(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





















































































































































exprInstances[expr_, pat_, opts___] :=
Module[{},
  
   {Cases[expr, pat, {0, Infinity}, 
      Heads -> (Heads /. {opts} /. Options[exprInstances])],
    Position[expr, pat, {0, Infinity}, 
      Heads -> (Heads /. {opts} /. Options[exprInstances])]}
]

Options[exprInstances] =
{
  Heads -> False
};











exprInstances[expr_, patternList_List, opts___] :=
Module[{retIndex, newPatsList},

  retIndex = returnIndex[patternList];
  newPatsList = 
    patternList //. {Times[x___,\[Section],y___] :> Times[x,y]};
  
  exprExtraction[expr, newPatsList, retIndex, opts]
]







exprExtraction[expr_, patsList_List, 
               retIndex_Integer:1, opts___] :=

Module[{vars, threadedPats, template, innerTempl,
        idExprs, idPos, buildTemplate, retTemplate,
        retExprs, retPos, theExprs, thePos},
  
  (* Unique list of variables *)
  
  vars = Table[Unique[x],{Length[patsList]-1}];
  
  (* Function to build up recursive templates *)
  
  buildTemplate[pats_List] :=
    Fold[(#1 /. {innerTempl -> #2})&, 
      pats//First, Drop[pats,1]] //. {Hold[x_] :> x};
      
  (* Construct a sub-template for each pattern given, *)
  (* except the last one                              *)
  
  threadedPats = 
  MapThread[
    Hold[Condition[Pattern[#2,#1],
                   MemberQ[#2, innerTempl, Infinity]]]&,
    {Drop[patsList,-1],vars}
  ];
  
  (* Append the last pattern which needs no recursive *)
  (* template                                         *)
  
  AppendTo[threadedPats, Last[patsList]];
  
  (* Construct the recursive template and ... *)
  (* search for matching expressions          *)
  
  template = buildTemplate[threadedPats];
  
  {idExprs, idPos} = 
  exprInstances[expr, template, opts];
  
  (* For the (sub-)expression to be returned we again *)
  (* have to search among the matching expressions    *)
  
  retTemplate =
    buildTemplate[Drop[threadedPats,retIndex-1]];
  
  {retExprs, retPos} = Transpose[
  Map[exprInstances[#, retTemplate, opts]&, idExprs]];
  
  (* As the Outer function does not cope with nested *)
  (* lists properly, we have to find a work around   *)
  (* by inserting a dummy LIST header, which will be *)
  (* replaced after applying the Outer function      *)
  
  (* Finally, return the matching sub-expressions *)
  (* together with their positions                *)
  
  Attributes[LIST] = {Flat};
  
  {theExprs, thePos} =
  {retExprs,
   Flatten[
     MapThread[Outer[LIST,#1,#2]&,
       {idPos /. {{x___Integer} :> {LIST[x]}},
        retPos /. {{x___Integer} :> LIST[x]}}
     ] /. {LIST -> List}, 1]
  };
  
  Transpose[Union[Flatten[
    MapThread[MapThread[List,{#1,#2}]&,{theExprs, thePos}],
    1]
  ]]
]







returnIndex[patList_List] :=
Module[{pos},

  If[(pos = Position[patList, \[Section]]) === {}, 
    1, pos//First//First]
]



























patternSelection[{},opts___] = {};

patternSelection[patternsAndRanks_List,opts___] :=

Module[{
        selectedIndex, 
        selectedPattern,
        selectionFunction =
           PatternSelectionFunction /. {opts}     
           /.Options[patternSelection]},
  
  selectedIndex = 
    selectionFunction[Map[#[[2]]&,patternsAndRanks]];
    
  selectedPattern =
    First[Part[patternsAndRanks,selectedIndex]];
    
  {selectedPattern,
  patternSelection[
    Part[patternsAndRanks,selectedIndex][[3]]]}
   // Flatten
];

Options[patternSelection] :=
{
  PatternSelectionFunction -> rouletteWheelSelectionAttributesOnly
}






rouletteWheelSelection[rules_List,
                       attributes_List] :=

Module[ {members, totalsum, partsum, index, randpos},

	members		=	Length[rules];
	totalsum	= 	Apply[Plus,attributes];
	partsum  	= 	attributes[[1]];
	index    	= 	1;
	
	randpos  	=	Random[Real,totalsum];
	
	While[partsum < randpos && index < members,
	
		index = index + 1;
		partsum = partsum + attributes[[index]];
		
	]; (* end while *)
	
	Print["Selected rule: ",rules[[index]]];
	index

] (* end module *)



rouletteWheelSelectionAttributesOnly[attributes_List] :=

Module[ {members, totalsum, partsum, index, randpos},

	members		=	Length[attributes];
	totalsum	= 	Apply[Plus,attributes];
	partsum  	= 	attributes[[1]];
	index    	= 	1;
	
	randpos  	=	Random[Real,{0,N[totalsum]}];
	
	While[partsum < randpos && index < members,
	
		index = index + 1;
		partsum = partsum + attributes[[index]];
		
	]; (* end while *)
	
	(** Print["Selected index: ",index]; **)
	index

] (* end module *)





rankBasedSelection[ranks_Integer] :=

Module[ {totalsum, partsum, partsumTable, index, randpos},

	totalsum	= 	Sum[i,{i,1,ranks}];
        Print["totalsum: ",totalsum];
	partsumTable 	= 	Table[i,{i,ranks,1,-1}];
        Print["partsumTable: ",partsumTable];
	partsum		=	partsumTable[[1]];
	index    	= 	1;
	
	randpos  	=	Random[Integer,{1,totalsum}];
	
	While[partsum < randpos && index < ranks,
	
		index = index + 1;
		partsum = partsum + partsumTable[[index]];
		
	]; (* end while *)
	
	(** Print["Selected index: ",index]; **)
	index

]; (* end module *)



rankBasedSelectionExp[ranks_Integer] :=

Module[ {totalsum, partsum, partsumTable, index, randpos},

	partsumTable 	= 	Table[N[Exp[-i]],{i,0,ranks-1,1}];
        Print["partsumTable: ",partsumTable];
	totalsum	= 	Sum[partsumTable[[i]],{i,1,ranks}];
        Print["totalsum: ",totalsum];

	partsum		=	partsumTable[[1]];
	index    	= 	1;
	
	randpos  	=	Random[Real,{0,totalsum}];
	Print["randpos: ",randpos];

	While[partsum < randpos && index < ranks,
	
		index = index + 1;
		partsum = partsum + partsumTable[[index]];
		
	]; (* end while *)
	
	(** Print["Selected index: ",index]; **)
	index

]; (* end module *)






exprToTerm = {(f_/; Not[AtomQ[f]])[x___] :> "EXPR"[f,x]};





TermPlot[expr_, opts___] := 
  Show[Graphics[TermPlot0[expr, 0, 0, 1,opts]], 
    PlotRange -> All,
    DefaultFont -> {"Courier-Bold",10}]


Options[TermPlot] =
{
  TreeWidth -> 1,
  TreeHeight -> 0.2,
  
  GridBranches -> False,
  
  ColorFunction -> GrayLevel,
  LineColor -> 0, 
  TextColor -> 0, TextFont -> {"Courier-Bold",10},
  LabelColor -> 0.9, LabelSize -> .05
};







TermPlot0[expr_, x_, y_, n_, opts___] :=
Block[{xl, xr, f$, c$, xi, gnew, gthis, dx, th, tw,
       colFun, lineCol, textCol, textFnt, labelCol, 
       lSize, gridBran},
		
  th = TreeHeight /. {opts} /. Options[TermPlot];
  tw = TreeWidth /. {opts} /. Options[TermPlot];
  
  colFun = ColorFunction /. {opts} /. Options[TermPlot];
  lineCol = LineColor /. {opts} /. Options[TermPlot];
  textCol = TextColor /. {opts} /. Options[TermPlot];
  textFnt = TextFont /. {opts} /. Options[TermPlot];
  labelCol = LabelColor /. {opts} /. Options[TermPlot];
  lSize  = LabelSize /. {opts} /. Options[TermPlot];
  gridBran = GridBranches /. {opts} /. Options[TermPlot];
  
  f$ = Head[expr];
  c$ = List @@ expr; 
  If[Length[c$]==1, 
    Return[
      Flatten[
        { colFun[lineCol], Line[{{x, y}, {x, y-th}}],
          colFun[labelCol], PointSize[lSize], Point[{x,y}],
          colFun[textCol], Text[FontForm[f$,textFnt],{x,y}],
          TermPlot0[First[c$], x, y-th, 1,opts] } ] ] ] ;
          
  xl = x - tw^(Abs[y]) 2/n ; 
  xr = x + tw^(Abs[y]) 2/n ;  
  dx = N[(xr - xl)/(Length[c$] - 1)] ;
                
  gnew = 
  Table[ 
    If[!AtomQ[c$[[i$+1]]],
      TermPlot0[c$[[i$+1]], xl + i$ dx, y-th, Length[c$],opts], 
      {GrayLevel[1], PointSize[lSize], Point[{xl + i$ dx,y-th}],
       colFun[textCol],
       Text[FontForm[c$[[i$+1]],textFnt],{xl + i$ dx,y-th}]
      } ],  
    {i$, 0, Length[c$]-1} ] ; 
  
  gthis = 
  If[gridBran,
    Table[
      xi = xl + i dx ; 
      {colFun[lineCol], Line[{{xi, y}, {xi, y-th}}]}, 
      {i, 0, Length[c$]-1}],
  
    Table[
      xi = xl + i dx ; 
      {colFun[lineCol], Line[{{x, y}, {xi, y-th}}]}, 
      {i, 0, Length[c$]-1}] 
  ];
  
  Flatten[{gthis, gnew,
           If[gridBran,
             {colFun[lineCol], Line[{{xl, y}, {xr, y}}]},{}],
           colFun[labelCol], 
           If[f$ === "EXPR", 
             {PointSize[lSize], Point[{x,y}],
              GrayLevel[0], PointSize[.5 lSize], Point[{x,y}]}, 
             {PointSize[lSize], Point[{x,y}], 
              colFun[textCol], Text[FontForm[f$,textFnt],{x,y}]}
           ]
          }]
]






TermPlot0[e_?AtomQ, x_, y_, n_,opts___] := 
Module[{colFun, textCol, textFnt},

  colFun = ColorFunction /. {opts} /. Options[TermPlot];
  textCol = TextColor /. {opts} /. Options[TermPlot];
  textFnt = TextFont /. {opts} /. Options[TermPlot];
  
  {GrayLevel[1], PointSize[.04], Point[{x,y}],
   colFun[textCol],
   Text[FontForm[e,textFnt],{x,y}]}
]



