(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   4507400,     292698]*)
(*NotebookOutlinePosition[   4515191,     292896]*)
(*  CellTagsIndexPosition[   4513949,     292865]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Evolving Ant Foraging Behavior  (Analysis)", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  July 1998 / February 2001 \
\[Copyright]\
\>", "Subsubtitle"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.230635 1.486233 0.019577 0.95651 [
[(Gen.59, Ind.1, Fit.45.)] .5 1 0 -1.5 Msboxa
[(5)] .22092 .11714 .84695 1 Msboxa
[(10)] .37284 .07856 .79165 1 Msboxa
[(15)] .5299 .0387 .73636 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Msboxa
P
[(5)] .71947 .07888 -1 .38093 Msboxa
[(10)] .79611 .14908 -1 .36667 Msboxa
[(15)] .86831 .21523 -1 .35344 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87582 .1216 -1 .36805 Msboxa
P
[(0)] .09642 .17323 1 -0.39101 Msboxa
[(10)] .07539 .34479 1 -0.36223 Msboxa
[(20)] .05204 .53529 1 -0.33012 Msboxa
[(30)] .02597 .74805 1 -0.29405 Msboxa
[(t)] -0.02569 .47223 1 -0.34405 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.59, Ind.1, Fit.45.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11528 .15603 m
.63741 .02391 L
s
P
p
.002 w
.23292 .12626 m
.23893 .13082 L
s
P
[(5)] .22092 .11714 .84695 1 Mshowa
p
.002 w
.38437 .08794 m
.39013 .09263 L
s
P
[(10)] .37284 .07856 .79165 1 Mshowa
p
.002 w
.54092 .04833 m
.54642 .05314 L
s
P
[(15)] .5299 .0387 .73636 1 Mshowa
p
.001 w
.26282 .1187 m
.26639 .12145 L
s
P
p
.001 w
.29291 .11108 m
.29645 .11385 L
s
P
p
.001 w
.32319 .10342 m
.32671 .1062 L
s
P
p
.001 w
.35368 .0957 m
.35717 .0985 L
s
P
p
.001 w
.41526 .08012 m
.41869 .08295 L
s
P
p
.001 w
.44636 .07225 m
.44976 .0751 L
s
P
p
.001 w
.47767 .06433 m
.48104 .06719 L
s
P
p
.001 w
.50919 .05636 m
.51252 .05923 L
s
P
p
.001 w
.20323 .13377 m
.20686 .1365 L
s
P
p
.001 w
.17372 .14124 m
.17738 .14395 L
s
P
p
.001 w
.14441 .14866 m
.14809 .15135 L
s
P
p
.001 w
.57286 .04024 m
.57613 .04315 L
s
P
p
.001 w
.60502 .03211 m
.60826 .03503 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Mshowa
P
P
p
p
.002 w
.63741 .02391 m
.8921 .25702 L
s
P
p
.002 w
.70211 .08313 m
.69343 .08526 L
s
P
[(5)] .71947 .07888 -1 .38093 Mshowa
p
.002 w
.77866 .1532 m
.76994 .15526 L
s
P
[(10)] .79611 .14908 -1 .36667 Mshowa
p
.002 w
.85079 .21921 m
.84203 .2212 L
s
P
[(15)] .86831 .21523 -1 .35344 Mshowa
p
.001 w
.7178 .09749 m
.71258 .09876 L
s
P
p
.001 w
.73329 .11167 m
.72807 .11293 L
s
P
p
.001 w
.7486 .12568 m
.74337 .12693 L
s
P
p
.001 w
.76372 .13952 m
.75849 .14076 L
s
P
p
.001 w
.79343 .16671 m
.78819 .16794 L
s
P
p
.001 w
.80802 .18007 m
.80278 .18129 L
s
P
p
.001 w
.82244 .19327 m
.8172 .19448 L
s
P
p
.001 w
.8367 .20631 m
.83145 .20752 L
s
P
p
.001 w
.68624 .0686 m
.68103 .06989 L
s
P
p
.001 w
.67016 .05389 m
.66496 .05519 L
s
P
p
.001 w
.65389 .039 m
.64869 .0403 L
s
P
p
.001 w
.86472 .23196 m
.85946 .23315 L
s
P
p
.001 w
.87849 .24456 m
.87322 .24574 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87582 .1216 -1 .36805 Mshowa
P
P
p
p
.002 w
.11528 .15603 m
.03716 .79936 L
s
P
p
.002 w
.11372 .16888 m
.12237 .1667 L
s
P
[(0)] .09642 .17323 1 -0.39101 Mshowa
p
.002 w
.09285 .34072 m
.10159 .33869 L
s
P
[(10)] .07539 .34479 1 -0.36223 Mshowa
p
.002 w
.06968 .53155 m
.0785 .52967 L
s
P
[(20)] .05204 .53529 1 -0.33012 Mshowa
p
.002 w
.0438 .74468 m
.05271 .74299 L
s
P
[(30)] .02597 .74805 1 -0.29405 Mshowa
p
.001 w
.10972 .20186 m
.11492 .20057 L
s
P
p
.001 w
.10563 .23552 m
.11084 .23425 L
s
P
p
.001 w
.10146 .26987 m
.10668 .26861 L
s
P
p
.001 w
.0972 .30493 m
.10243 .30369 L
s
P
p
.001 w
.08841 .37727 m
.09366 .37607 L
s
P
p
.001 w
.08388 .4146 m
.08914 .41342 L
s
P
p
.001 w
.07925 .45274 m
.08452 .45158 L
s
P
p
.001 w
.07452 .49171 m
.0798 .49057 L
s
P
p
.001 w
.06473 .57227 m
.07004 .57117 L
s
P
p
.001 w
.05968 .61391 m
.06499 .61283 L
s
P
p
.001 w
.0545 .6565 m
.05983 .65545 L
s
P
p
.001 w
.04921 .70008 m
.05455 .69905 L
s
P
p
.001 w
.03825 .79033 m
.04361 .78934 L
s
P
[(t)] -0.02569 .47223 1 -0.34405 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11372 .16888 m
.40485 .37783 L
s
P
p
.4 g
.002 w
.09285 .34072 m
.39976 .54298 L
s
P
p
.4 g
.002 w
.06968 .53155 m
.39417 .72452 L
s
P
p
.4 g
.002 w
.0438 .74468 m
.38799 .92503 L
s
P
p
.4 g
.002 w
.18866 .20901 m
.12672 .84468 L
s
P
p
.4 g
.002 w
.27571 .27188 m
.23195 .89793 L
s
P
p
.4 g
.002 w
.358 .33131 m
.33036 .94772 L
s
P
.002 w
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.38641 .97609 L
s
.38641 .97609 m
.40523 .36542 L
s
.40523 .36542 m
.11528 .15603 L
s
.63741 .02391 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.63741 .02391 m
.11528 .15603 L
s
p
.4 g
.51538 .34089 m
.5159 .95571 L
s
P
p
.4 g
.65679 .30941 m
.68292 .92943 L
s
P
p
.4 g
.80251 .27696 m
.85598 .9022 L
s
P
p
.4 g
.40485 .37783 m
.89352 .26968 L
s
P
p
.4 g
.39976 .54298 m
.91253 .43853 L
s
P
p
.4 g
.39417 .72452 m
.93354 .62513 L
s
P
p
.4 g
.38799 .92503 m
.95688 .8324 L
s
P
.40523 .36542 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.38641 .97609 L
s
.38641 .97609 m
.40523 .36542 L
s
p
.4 g
.23292 .12626 m
.51538 .34089 L
s
P
p
.4 g
.38437 .08794 m
.65679 .30941 L
s
P
p
.4 g
.54092 .04833 m
.80251 .27696 L
s
P
p
.4 g
.18866 .20901 m
.70211 .08313 L
s
P
p
.4 g
.27571 .27188 m
.77866 .1532 L
s
P
p
.4 g
.358 .33131 m
.85079 .21921 L
s
P
P
p
.002 w
.41076 .36919 m .41853 .3748 L .40485 .37783 L p
.4 g
F P
s
P
p
.002 w
.40485 .37783 m .39706 .37224 L .41076 .36919 L p
.4 g
F P
s
P
p
.002 w
.89352 .26968 m .40485 .37783 L .11372 .16888 L p
.9 g
F P
s
P
p
.002 w
.43224 .37177 m .41853 .3748 L p
.41076 .36919 L .4 g
F P
s
P
p
.002 w
.41076 .36919 m .39706 .37224 L .38922 .36661 L p
.4 g
F P
s
P
p
.002 w
.43828 .36308 m .446 .36872 L .43224 .37177 L p
.4 g
F P
s
P
p
.002 w
.41076 .36919 m .43828 .36308 L p
.43224 .37177 L .4 g
F P
s
P
p
.002 w
.38922 .36661 m .38134 .36095 L p
.41076 .36919 L .4 g
F P
s
P
p
.002 w
.38134 .36095 m .39509 .35788 L .41076 .36919 L p
.4 g
F P
s
P
p
.002 w
.4598 .36567 m .446 .36872 L p
.43828 .36308 L .4 g
F P
s
P
p
.002 w
.46597 .35693 m .47363 .36261 L .4598 .36567 L p
.4 g
F P
s
P
p
.002 w
.43828 .36308 m .46597 .35693 L p
.4598 .36567 L .4 g
F P
s
P
p
.002 w
.48751 .35954 m .47363 .36261 L p
.46597 .35693 L .4 g
F P
s
P
p
.002 w
.39509 .35788 m .38134 .36095 L .37341 .35527 L p
.4 g
F P
s
P
p
.002 w
.49382 .35074 m .50143 .35646 L .48751 .35954 L p
.4 g
F P
s
P
p
.002 w
.46597 .35693 m .49382 .35074 L p
.48751 .35954 L .4 g
F P
s
P
p
.002 w
.37341 .35527 m .36545 .34955 L p
.39509 .35788 L .4 g
F P
s
P
p
.002 w
.36545 .34955 m .37925 .34644 L .39509 .35788 L p
.4 g
F P
s
P
p
.002 w
.51539 .35337 m .50143 .35646 L p
.49382 .35074 L .4 g
F P
s
P
p
.002 w
.52184 .34452 m .5294 .35027 L .51539 .35337 L p
.4 g
F P
s
P
p
.002 w
.49382 .35074 m .52184 .34452 L p
.51539 .35337 L .4 g
F P
s
P
p
.002 w
.54344 .34716 m .5294 .35027 L p
.52184 .34452 L .4 g
F P
s
P
p
.002 w
.37925 .34644 m .36545 .34955 L .35744 .3438 L p
.4 g
F P
s
P
p
.002 w
.55003 .33826 m .55753 .34404 L .54344 .34716 L p
.4 g
F P
s
P
p
.002 w
.52184 .34452 m .55003 .33826 L p
.54344 .34716 L .4 g
F P
s
P
p
.002 w
.35744 .3438 m .34938 .33802 L p
.37925 .34644 L .4 g
F P
s
P
p
.002 w
.34938 .33802 m .36324 .33487 L .37925 .34644 L p
.4 g
F P
s
P
p
.002 w
.57166 .34091 m .55753 .34404 L p
.55003 .33826 L .4 g
F P
s
P
p
.002 w
.57838 .33196 m .58583 .33778 L .57166 .34091 L p
.4 g
F P
s
P
p
.002 w
.55003 .33826 m .57838 .33196 L p
.57166 .34091 L .4 g
F P
s
P
p
.002 w
.43489 .3339 m .40699 .34019 L .39108 .32856 L p
.8 g
F P
s
P
p
.002 w
.57838 .33196 m .55003 .33826 L .5349 .3266 L p
.4 g
F P
s
P
p
.002 w
.36324 .33487 m .34938 .33802 L .34128 .3322 L p
.4 g
F P
s
P
p
.002 w
.60004 .33463 m .58583 .33778 L p
.57838 .33196 L .4 g
F P
s
P
p
.002 w
.34128 .3322 m .33314 .32636 L p
.36324 .33487 L .4 g
F P
s
P
p
.002 w
.33314 .32636 m .34705 .32318 L .36324 .33487 L p
.4 g
F P
s
P
p
.002 w
.60691 .32563 m .6143 .33148 L .60004 .33463 L p
.4 g
F P
s
P
p
.002 w
.57838 .33196 m .60691 .32563 L p
.60004 .33463 L .4 g
F P
s
P
p
.002 w
.46295 .32758 m .43489 .3339 L .41909 .3222 L p
.8 g
F P
s
P
p
.002 w
.39108 .32856 m .41909 .3222 L .43489 .3339 L p
.8 g
F P
s
P
p
.002 w
.5349 .3266 m .56336 .32024 L .57838 .33196 L p
.4 g
F P
s
P
p
.002 w
.62859 .32831 m .6143 .33148 L p
.60691 .32563 L .4 g
F P
s
P
p
.002 w
.41909 .3222 m .39108 .32856 L .37499 .31679 L p
.8 g
F P
s
P
p
.002 w
.6356 .31925 m .64294 .32514 L .62859 .32831 L p
.4 g
F P
s
P
p
.002 w
.60691 .32563 m .6356 .31925 L p
.62859 .32831 L .4 g
F P
s
P
p
.002 w
.41909 .3222 m .44726 .3158 L .46295 .32758 L p
.8 g
F P
s
P
p
.002 w
.56336 .32024 m .5349 .3266 L .5196 .31482 L p
.4 g
F P
s
P
p
.002 w
.34705 .32318 m .33314 .32636 L .32495 .32048 L p
.4 g
F P
s
P
p
.002 w
.65732 .32195 m .64294 .32514 L p
.6356 .31925 L .4 g
F P
s
P
p
.002 w
.32495 .32048 m .31671 .31457 L p
.34705 .32318 L .4 g
F P
s
P
p
.002 w
.31671 .31457 m .33067 .31135 L .34705 .32318 L p
.4 g
F P
s
P
p
.002 w
.37499 .31679 m .40311 .31036 L .41909 .3222 L p
.8 g
F P
s
P
p
.002 w
.66448 .31284 m .67175 .31876 L .65732 .32195 L p
.4 g
F P
s
P
p
.002 w
.6356 .31925 m .66448 .31284 L p
.65732 .32195 L .4 g
F P
s
P
p
.002 w
.5196 .31482 m .49119 .32122 L .47561 .30937 L p
.8 g
F P
s
P
p
.002 w
.5196 .31482 m .54818 .30838 L .56336 .32024 L p
.4 g
F P
s
P
p
.002 w
.68622 .31556 m .67175 .31876 L p
.66448 .31284 L .4 g
F P
s
P
p
.002 w
.69352 .30639 m .70074 .31234 L .68622 .31556 L p
.4 g
F P
s
P
p
.002 w
.66448 .31284 m .69352 .30639 L p
.68622 .31556 L .4 g
F P
s
P
p
.002 w
.54818 .30838 m .5196 .31482 L .50413 .3029 L p
.8 g
F P
s
P
p
.002 w
.47561 .30937 m .50413 .3029 L .5196 .31482 L p
.8 g
F P
s
P
p
.002 w
.33067 .31135 m .31671 .31457 L .30843 .30863 L p
.4 g
F P
s
P
p
.002 w
.69352 .30639 m .66448 .31284 L .64981 .3009 L p
.8 g
F P
s
P
p
.002 w
.7153 .30912 m .70074 .31234 L p
.69352 .30639 L .4 g
F P
s
P
p
.002 w
.30843 .30863 m .3001 .30265 L p
.33067 .31135 L .4 g
F P
s
P
p
.002 w
.3001 .30265 m .31412 .2994 L .33067 .31135 L p
.4 g
F P
s
P
p
1 .019 0 r
.01 w
.64267 .31011 m
.64267 .31011 L
s
P
p
1 .038 0 r
.01 w
.62792 .29974 m
.64274 .31171 L
s
P
p
.002 w
.72275 .2999 m .7299 .30589 L .7153 .30912 L p
.4 g
F P
s
P
p
.002 w
.69352 .30639 m .72275 .2999 L p
.7153 .30912 L .4 g
F P
s
P
p
.002 w
.57693 .3019 m .54818 .30838 L .53282 .29639 L p
.8 g
F P
s
P
p
.002 w
.50413 .3029 m .53282 .29639 L .54818 .30838 L p
.8 g
F P
s
P
p
.002 w
.72275 .2999 m .69352 .30639 L .67897 .29437 L p
.8 g
F P
s
P
p
.002 w
.64981 .3009 m .67897 .29437 L .69352 .30639 L p
.8 g
F P
s
P
p
.002 w
.74455 .30265 m .7299 .30589 L p
.72275 .2999 L .4 g
F P
s
P
p
1 .151 0 r
.01 w
.55505 .31038 m
.57031 .32232 L
s
P
p
1 .17 0 r
.01 w
.57034 .32393 m
.57034 .32393 L
s
P
p
.002 w
.53282 .29639 m .50413 .3029 L .48849 .29084 L p
.4 g
F P
s
P
p
.002 w
.75215 .29337 m .75924 .2994 L .74455 .30265 L p
.4 g
F P
s
P
p
.002 w
.72275 .2999 m .75215 .29337 L p
.74455 .30265 L .4 g
F P
s
P
p
.002 w
.31412 .2994 m .3001 .30265 L .29172 .29664 L p
.4 g
F P
s
P
p
1 .189 0 r
.01 w
.57036 .32554 m
.57036 .32554 L
s
P
p
.002 w
.53282 .29639 m .56169 .28983 L .57693 .3019 L p
.8 g
F P
s
P
p
1 .208 0 r
.01 w
.57039 .32715 m
.57039 .32715 L
s
P
p
1 .226 0 r
.01 w
.57042 .32876 m
.57042 .32876 L
s
P
p
.002 w
.75215 .29337 m .72275 .2999 L .70832 .28781 L p
.8 g
F P
s
P
p
.002 w
.67897 .29437 m .70832 .28781 L .72275 .2999 L p
.8 g
F P
s
P
p
.002 w
.77398 .29613 m .75924 .2994 L p
.75215 .29337 L .4 g
F P
s
P
p
.002 w
.29172 .29664 m .2833 .29059 L p
.31412 .2994 L .4 g
F P
s
P
p
.002 w
.2833 .29059 m .29737 .2873 L .31412 .2994 L p
.4 g
F P
s
P
p
1 .245 0 r
.01 w
.55515 .31846 m
.57044 .33038 L
s
P
p
.002 w
.48849 .29084 m .51729 .28426 L .53282 .29639 L p
.4 g
F P
s
P
p
.002 w
.78173 .2868 m .78876 .29286 L .77398 .29613 L p
.4 g
F P
s
P
p
.002 w
.75215 .29337 m .78173 .2868 L p
.77398 .29613 L .4 g
F P
s
P
p
.002 w
.63497 .28882 m .60586 .29538 L .59074 .28324 L p
.8 g
F P
s
P
p
1 .057 0 r
.01 w
.61298 .28925 m
.62797 .30135 L
s
P
p
1 .113 0 r
.01 w
.55501 .30717 m
.58398 .30064 L
s
P
p
.002 w
.78173 .2868 m .75215 .29337 L .73784 .2812 L p
.8 g
F P
s
P
p
.002 w
.70832 .28781 m .73784 .2812 L .75215 .29337 L p
.8 g
F P
s
P
p
1 .132 0 r
.01 w
.55503 .30877 m
.55503 .30877 L
s
P
p
.002 w
.80359 .28958 m .78876 .29286 L p
.78173 .2868 L .4 g
F P
s
P
p
.002 w
.37061 .28629 m .34228 .29286 L .32564 .28069 L p
.8 g
F P
s
P
p
.002 w
.51729 .28426 m .48849 .29084 L .47266 .27865 L p
.4 g
F P
s
P
p
.002 w
.29737 .2873 m .2833 .29059 L .27483 .28451 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .81847 .28629 L .80359 .28958 L p
.4 g
F P
s
P
p
.002 w
.78173 .2868 m .8115 .28018 L p
.80359 .28958 L .4 g
F P
s
P
p
.002 w
.66426 .28222 m .63497 .28882 L .61997 .27661 L p
.8 g
F P
s
P
p
.002 w
.59074 .28324 m .61997 .27661 L .63497 .28882 L p
.8 g
F P
s
P
p
1 .094 0 r
.01 w
.58394 .29903 m
.61307 .29246 L
s
P
p
.002 w
.27483 .28451 m .26631 .2784 L p
.29737 .2873 L .4 g
F P
s
P
p
.002 w
.26631 .2784 m .28044 .27507 L .29737 .2873 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .78173 .2868 L .76755 .27456 L p
.8 g
F P
s
P
p
.002 w
.73784 .2812 m .76755 .27456 L .78173 .2868 L p
.8 g
F P
s
P
p
.002 w
.83338 .28299 m .81847 .28629 L p
.8115 .28018 L .4 g
F P
s
P
p
.002 w
.39912 .27967 m .37061 .28629 L .35408 .27405 L p
.8 g
F P
s
P
p
.002 w
.32564 .28069 m .35408 .27405 L .37061 .28629 L p
.8 g
F P
s
P
p
1 .264 0 r
.01 w
.55517 .32008 m
.55517 .32008 L
s
P
p
1 .283 0 r
.01 w
.55519 .3217 m
.58428 .31519 L
s
P
p
.002 w
.47266 .27865 m .50159 .27199 L .51729 .28426 L p
.4 g
F P
s
P
p
.002 w
.84144 .27353 m .84835 .27967 L .83338 .28299 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .84144 .27353 L p
.83338 .28299 L .4 g
F P
s
P
p
1 .075 0 r
.01 w
.61303 .29085 m
.61303 .29085 L
s
P
p
.002 w
.69372 .27558 m .66426 .28222 L .64937 .26993 L p
.8 g
F P
s
P
p
.002 w
.61997 .27661 m .64937 .26993 L .66426 .28222 L p
.8 g
F P
s
P
p
.002 w
.76755 .27456 m .79744 .26787 L .8115 .28018 L p
.8 g
F P
s
P
p
.002 w
.86336 .27635 m .84835 .27967 L p
.84144 .27353 L .4 g
F P
s
P
p
.002 w
.35408 .27405 m .3827 .26736 L .39912 .27967 L p
.8 g
F P
s
P
p
.002 w
.50159 .27199 m .47266 .27865 L .45666 .26632 L p
.4 g
F P
s
P
p
.002 w
.28044 .27507 m .26631 .2784 L .25775 .27225 L p
.4 g
F P
s
P
p
1 .302 0 r
.01 w
.58431 .31681 m
.58431 .31681 L
s
P
p
1 .321 0 r
.01 w
.56897 .30632 m
.58435 .31844 L
s
P
p
.002 w
.87158 .26684 m .87842 .27302 L .86336 .27635 L p
.4 g
F P
s
P
p
.002 w
.84144 .27353 m .87158 .26684 L p
.86336 .27635 L .4 g
F P
s
P
p
.002 w
.72337 .2689 m .69372 .27558 L .67896 .26322 L p
.8 g
F P
s
P
p
.002 w
.64937 .26993 m .67896 .26322 L .69372 .27558 L p
.8 g
F P
s
P
p
.002 w
.25775 .27225 m .24913 .26606 L p
.28044 .27507 L .4 g
F P
s
P
p
.002 w
.24913 .26606 m .26331 .2627 L .28044 .27507 L p
.4 g
F P
s
P
p
.002 w
.79744 .26787 m .76755 .27456 L .7532 .26218 L p
.8 g
F P
s
P
p
1 .377 0 r
.01 w
.56905 .31122 m
.58445 .32332 L
s
P
p
.002 w
.89352 .26968 m .87842 .27302 L p
.87158 .26684 L .4 g
F P
s
P
p
1 .396 0 r
.01 w
.58448 .32496 m
.58448 .32496 L
s
P
p
.002 w
.45666 .26632 m .4857 .25959 L .50159 .27199 L p
.4 g
F P
s
P
p
1 .415 0 r
.01 w
.58452 .32659 m
.61389 .32005 L
s
P
p
.002 w
.87158 .26684 m .88671 .26348 L .89352 .26968 L p
.4 g
F P
s
P
p
.002 w
.11372 .16888 m .63792 .03696 L .89352 .26968 L p
.9 g
F P
s
P
p
.002 w
.67896 .26322 m .70873 .25646 L .72337 .2689 L p
.8 g
F P
s
P
p
.002 w
.7532 .26218 m .78322 .25542 L .79744 .26787 L p
.8 g
F P
s
P
p
.002 w
.4115 .26062 m .3827 .26736 L .3661 .2549 L p
.8 g
F P
s
P
p
.002 w
.88671 .26348 m .87158 .26684 L p
.85778 .25437 L .4 g
F P
s
P
p
.002 w
.4857 .25959 m .45666 .26632 L .44048 .25385 L p
.4 g
F P
s
P
p
.002 w
.26331 .2627 m .24913 .26606 L .24046 .25985 L p
.4 g
F P
s
P
p
1 .434 0 r
.01 w
.61394 .32169 m
.6435 .31512 L
s
P
p
.002 w
.87987 .25724 m .88671 .26348 L p
.85778 .25437 L .4 g
F P
s
P
p
.002 w
.70873 .25646 m .67896 .26322 L .66403 .25071 L p
.8 g
F P
s
P
p
1 .34 0 r
.01 w
.56899 .30795 m
.56899 .30795 L
s
P
p
.002 w
.24046 .25985 m .23175 .25359 L p
.26331 .2627 L .4 g
F P
s
P
p
.002 w
.23175 .25359 m .24598 .25019 L .26331 .2627 L p
.4 g
F P
s
P
p
.002 w
.78322 .25542 m .7532 .26218 L .73869 .24966 L p
.8 g
F P
s
P
p
1 .358 0 r
.01 w
.56902 .30959 m
.56902 .30959 L
s
P
p
.002 w
.3661 .2549 m .39501 .24809 L .4115 .26062 L p
.8 g
F P
s
P
p
.002 w
.44048 .25385 m .46963 .24704 L .4857 .25959 L p
.4 g
F P
s
P
p
.002 w
.85778 .25437 m .87298 .25097 L .87987 .25724 L p
.4 g
F P
s
P
p
.002 w
.66403 .25071 m .69393 .24388 L .70873 .25646 L p
.8 g
F P
s
P
p
1 .453 0 r
.01 w
.64357 .31676 m
.64357 .31676 L
s
P
p
.002 w
.73869 .24966 m .76884 .24282 L .78322 .25542 L p
.8 g
F P
s
P
p
.002 w
.39501 .24809 m .3661 .2549 L .34931 .24229 L p
.8 g
F P
s
P
p
1 .472 0 r
.01 w
.62844 .30616 m
.64363 .3184 L
s
P
p
.002 w
.87298 .25097 m .85778 .25437 L p
.84382 .24176 L .4 g
F P
s
P
p
.002 w
.46963 .24704 m .44048 .25385 L .4241 .24124 L p
.4 g
F P
s
P
p
.002 w
.24598 .25019 m .23175 .25359 L .22298 .2473 L p
.4 g
F P
s
P
p
1 .528 0 r
.01 w
.6286 .31111 m
.64382 .32333 L
s
P
p
.002 w
.86605 .24467 m .87298 .25097 L p
.84382 .24176 L .4 g
F P
s
P
p
.002 w
.69393 .24388 m .66403 .25071 L .64893 .23806 L p
.8 g
F P
s
P
p
1 .547 0 r
.01 w
.64388 .32498 m
.64388 .32498 L
s
P
p
.002 w
.22298 .2473 m .21417 .24097 L p
.24598 .25019 L .4 g
F P
s
P
p
.002 w
.21417 .24097 m .22846 .23753 L .24598 .25019 L p
.4 g
F P
s
P
p
.002 w
.76884 .24282 m .73869 .24966 L .72401 .237 L p
.8 g
F P
s
P
p
1 .566 0 r
.01 w
.64394 .32663 m
.6738 .32003 L
s
P
p
.002 w
.34931 .24229 m .37833 .2354 L .39501 .24809 L p
.8 g
F P
s
P
p
.002 w
.4241 .24124 m .45338 .23434 L .46963 .24704 L p
.4 g
F P
s
P
p
.002 w
.64893 .23806 m .61909 .24493 L .60369 .23221 L p
.4 g
F P
s
P
p
.002 w
.84382 .24176 m .85909 .23832 L .86605 .24467 L p
.4 g
F P
s
P
p
.002 w
.64893 .23806 m .67895 .23114 L .69393 .24388 L p
.8 g
F P
s
P
p
.002 w
.79917 .23594 m .76884 .24282 L .75429 .23008 L p
.8 g
F P
s
P
p
.002 w
.72401 .237 m .75429 .23008 L .76884 .24282 L p
.8 g
F P
s
P
p
.002 w
.85909 .23832 m .84382 .24176 L p
.8297 .22901 L .4 g
F P
s
P
p
1 .585 0 r
.01 w
.67387 .32168 m
.70393 .31504 L
s
P
p
.002 w
.45338 .23434 m .4241 .24124 L .40754 .22847 L p
.4 g
F P
s
P
p
1 .491 0 r
.01 w
.62849 .30781 m
.62849 .30781 L
s
P
p
.002 w
.22846 .23753 m .21417 .24097 L .2053 .23461 L p
.4 g
F P
s
P
p
1 .509 0 r
.01 w
.62855 .30946 m
.62855 .30946 L
s
P
p
.002 w
.60369 .23221 m .57391 .23912 L .55821 .22633 L p
.8 g
F P
s
P
p
.002 w
.85208 .23194 m .85909 .23832 L p
.8297 .22901 L .4 g
F P
s
P
p
.002 w
.60369 .23221 m .63365 .22526 L .64893 .23806 L p
.4 g
F P
s
P
p
.002 w
.67895 .23114 m .64893 .23806 L .63365 .22526 L p
.8 g
F P
s
P
p
.002 w
.2053 .23461 m .19638 .22821 L p
.22846 .23753 L .4 g
F P
s
P
p
.002 w
.19638 .22821 m .21073 .22472 L .22846 .23753 L p
.4 g
F P
s
P
p
.002 w
.8297 .22901 m .79917 .23594 L .78475 .22311 L p
.8 g
F P
s
P
p
.002 w
.75429 .23008 m .78475 .22311 L .79917 .23594 L p
.8 g
F P
s
P
p
.002 w
.48284 .2274 m .45338 .23434 L .43693 .2215 L p
.4 g
F P
s
P
p
.002 w
.40754 .22847 m .43693 .2215 L .45338 .23434 L p
.4 g
F P
s
P
p
1 .604 0 r
.01 w
.70402 .3167 m
.70402 .3167 L
s
P
p
1 .623 0 r
.01 w
.68912 .306 m
.70411 .31836 L
s
P
p
.002 w
.63365 .22526 m .60369 .23221 L .5881 .21934 L p
.4 g
F P
s
P
p
.002 w
.55821 .22633 m .5881 .21934 L .60369 .23221 L p
.8 g
F P
s
P
p
.002 w
.8297 .22901 m .84503 .22553 L .85208 .23194 L p
.4 g
F P
s
P
p
.002 w
.70916 .22419 m .67895 .23114 L .6638 .21826 L p
.8 g
F P
s
P
p
.002 w
.63365 .22526 m .6638 .21826 L .67895 .23114 L p
.8 g
F P
s
P
p
.002 w
.84503 .22553 m .8297 .22901 L p
.81541 .2161 L .4 g
F P
s
P
p
.002 w
.78475 .22311 m .81541 .2161 L .8297 .22901 L p
.8 g
F P
s
P
p
.002 w
.43693 .2215 m .40754 .22847 L .39078 .21556 L p
.4 g
F P
s
P
p
.002 w
.21073 .22472 m .19638 .22821 L .18741 .22177 L p
.4 g
F P
s
P
p
.002 w
.43693 .2215 m .46651 .21448 L .48284 .2274 L p
.4 g
F P
s
P
p
.002 w
.83794 .21907 m .84503 .22553 L p
.81541 .2161 L .4 g
F P
s
P
p
.002 w
.5881 .21934 m .61819 .21231 L .63365 .22526 L p
.4 g
F P
s
P
p
.002 w
.18741 .22177 m .17839 .21529 L p
.21073 .22472 L .4 g
F P
s
P
p
.002 w
.17839 .21529 m .19279 .21177 L .21073 .22472 L p
.4 g
F P
s
P
p
.002 w
.73957 .21718 m .70916 .22419 L .69414 .21122 L p
.8 g
F P
s
P
p
.002 w
.6638 .21826 m .69414 .21122 L .70916 .22419 L p
.8 g
F P
s
P
p
.002 w
.81541 .2161 m .78475 .22311 L .77017 .21014 L p
.8 g
F P
s
P
p
.002 w
.46651 .21448 m .43693 .2215 L .42029 .20851 L p
.4 g
F P
s
P
p
.002 w
.39078 .21556 m .42029 .20851 L .43693 .2215 L p
.4 g
F P
s
P
p
.002 w
.61819 .21231 m .5881 .21934 L .57234 .20632 L p
.4 g
F P
s
P
p
.002 w
.81541 .2161 m .83081 .21258 L .83794 .21907 L p
.4 g
F P
s
P
p
1 .642 0 r
.01 w
.67403 .29515 m
.6892 .30766 L
s
P
p
.002 w
.77017 .21014 m .73957 .21718 L .72468 .20414 L p
.8 g
F P
s
P
p
.002 w
.69414 .21122 m .72468 .20414 L .73957 .21718 L p
.8 g
F P
s
P
p
.002 w
.34438 .20959 m .31513 .21664 L .29774 .20359 L p
.8 g
F P
s
P
p
.002 w
.83081 .21258 m .81541 .2161 L p
.80096 .20305 L .4 g
F P
s
P
p
.002 w
.77017 .21014 m .80096 .20305 L .81541 .2161 L p
.8 g
F P
s
P
p
.002 w
.19279 .21177 m .17839 .21529 L .16931 .20878 L p
.4 g
F P
s
P
p
.002 w
.42029 .20851 m .44999 .2014 L .46651 .21448 L p
.4 g
F P
s
P
p
.002 w
.82364 .20605 m .83081 .21258 L p
.80096 .20305 L .4 g
F P
s
P
p
.002 w
.57234 .20632 m .60255 .19921 L .61819 .21231 L p
.4 g
F P
s
P
p
.002 w
.16931 .20878 m .16018 .20222 L p
.19279 .21177 L .4 g
F P
s
P
p
.002 w
.16018 .20222 m .17464 .19866 L .19279 .21177 L p
.4 g
F P
s
P
p
1 .679 0 r
.01 w
.6438 .30528 m
.67418 .29849 L
s
P
p
.002 w
.80096 .20305 m .77017 .21014 L .75541 .19701 L p
.8 g
F P
s
P
p
.002 w
.72468 .20414 m .75541 .19701 L .77017 .21014 L p
.8 g
F P
s
P
p
.002 w
.29774 .20359 m .32711 .19646 L .34438 .20959 L p
.8 g
F P
s
P
p
1 .698 0 r
.01 w
.64386 .30695 m
.64386 .30695 L
s
P
p
1 .811 0 r
.01 w
.67474 .31024 m
.68998 .32271 L
s
P
p
1 .717 0 r
.01 w
.64393 .30862 m
.64393 .30862 L
s
P
p
1 .83 0 r
.01 w
.69007 .32439 m
.69007 .32439 L
s
P
p
.002 w
.52623 .20031 m .49628 .20742 L .47988 .19426 L p
.8 g
F P
s
P
p
1 .736 0 r
.01 w
.64399 .3103 m
.64399 .3103 L
s
P
p
1 .849 0 r
.01 w
.69016 .32607 m
.72074 .31934 L
s
P
p
.002 w
.60255 .19921 m .57234 .20632 L .55638 .19315 L p
.4 g
F P
s
P
p
.002 w
.80096 .20305 m .81643 .19948 L .82364 .20605 L p
.4 g
F P
s
P
p
1 .755 0 r
.01 w
.64405 .31197 m
.64405 .31197 L
s
P
p
1 .774 0 r
.01 w
.64412 .31365 m
.67458 .30687 L
s
P
p
1 .66 0 r
.01 w
.6741 .29682 m
.6741 .29682 L
s
P
p
.002 w
.32711 .19646 m .29774 .20359 L .28014 .19039 L p
.8 g
F P
s
P
p
0 1 .585 r
.01 w
.40634 .56212 m
.4232 .57314 L
s
P
p
.002 w
.81643 .19948 m .80096 .20305 L p
.78633 .18983 L .4 g
F P
s
P
p
.002 w
.75541 .19701 m .78633 .18983 L .80096 .20305 L p
.8 g
F P
s
P
p
.002 w
.40346 .19536 m .37383 .2025 L .35667 .18928 L p
.4 g
F P
s
P
p
0 1 .604 r
.01 w
.42316 .57495 m
.42316 .57495 L
s
P
p
.002 w
.17464 .19866 m .16018 .20222 L .151 .19563 L p
.4 g
F P
s
P
p
0 1 .623 r
.01 w
.42311 .57676 m
.42311 .57676 L
s
P
p
0 1 0 r
.01 w
.67992 .48022 m
.64938 .48645 L
s
P
p
.002 w
.47988 .19426 m .50997 .18706 L .52623 .20031 L p
.8 g
F P
s
P
p
0 1 .642 r
.01 w
.42307 .57857 m
.40619 .56756 L
s
P
p
0 1 .019 r
.01 w
.64944 .48822 m
.64944 .48822 L
s
P
p
.002 w
.80917 .19288 m .81643 .19948 L p
.78633 .18983 L .4 g
F P
s
P
p
.002 w
.63296 .19205 m .60255 .19921 L .58673 .18595 L p
.4 g
F P
s
P
p
.002 w
.55638 .19315 m .58673 .18595 L .60255 .19921 L p
.4 g
F P
s
P
p
.002 w
.151 .19563 m .14176 .189 L p
.17464 .19866 L .4 g
F P
s
P
p
.002 w
.14176 .189 m .15627 .1854 L .17464 .19866 L p
.4 g
F P
s
P
p
0 1 .038 r
.01 w
.64951 .48999 m
.64951 .48999 L
s
P
p
1 .868 0 r
.01 w
.72084 .32102 m
.75164 .31425 L
s
P
p
0 1 .434 r
.01 w
.46652 .53555 m
.48307 .54676 L
s
P
p
0 1 .057 r
.01 w
.64958 .49176 m
.68016 .48553 L
s
P
p
0 1 .453 r
.01 w
.48305 .54855 m
.48305 .54855 L
s
P
p
.057 1 0 r
.01 w
.71036 .46863 m
.67967 .47492 L
s
P
p
1 .792 0 r
.01 w
.67466 .30855 m
.67466 .30855 L
s
P
p
.002 w
.28014 .19039 m .30963 .18317 L .32711 .19646 L p
.8 g
F P
s
P
p
0 1 .472 r
.01 w
.48304 .55036 m
.48304 .55036 L
s
P
p
.038 1 0 r
.01 w
.67975 .47668 m
.67975 .47668 L
s
P
p
.002 w
.43328 .18817 m .40346 .19536 L .38643 .18206 L p
.4 g
F P
s
P
p
.002 w
.35667 .18928 m .38643 .18206 L .40346 .19536 L p
.4 g
F P
s
P
p
0 1 .491 r
.01 w
.48302 .55216 m
.46645 .54097 L
s
P
p
.019 1 0 r
.01 w
.67983 .47845 m
.67983 .47845 L
s
P
p
.002 w
.78633 .18983 m .80187 .18623 L .80917 .19288 L p
.4 g
F P
s
P
p
0 1 .547 r
.01 w
.43632 .55247 m
.40645 .5585 L
s
P
p
.002 w
.66356 .18484 m .63296 .19205 L .61726 .17871 L p
.4 g
F P
s
P
p
.002 w
.58673 .18595 m .61726 .17871 L .63296 .19205 L p
.4 g
F P
s
P
p
0 1 .679 r
.01 w
.40608 .5712 m
.3763 .57717 L
s
P
p
0 1 .566 r
.01 w
.4064 .56031 m
.4064 .56031 L
s
P
p
0 1 .698 r
.01 w
.37623 .57899 m
.37623 .57899 L
s
P
p
.075 1 0 r
.01 w
.74113 .46054 m
.71026 .46687 L
s
P
p
1 .887 0 r
.01 w
.75176 .31594 m
.75176 .31594 L
s
P
p
.002 w
.80187 .18623 m .78633 .18983 L p
.77153 .17647 L .4 g
F P
s
P
p
0 1 .717 r
.01 w
.37617 .58081 m
.37617 .58081 L
s
P
p
.002 w
.38643 .18206 m .35667 .18928 L .33931 .17591 L p
.4 g
F P
s
P
p
0 1 .075 r
.01 w
.68025 .4873 m
.68025 .4873 L
s
P
p
1 .906 0 r
.01 w
.73687 .30502 m
.75188 .31763 L
s
P
p
.002 w
.15627 .1854 m .14176 .189 L .13247 .18233 L p
.4 g
F P
s
P
p
0 1 .736 r
.01 w
.3761 .58263 m
.3761 .58263 L
s
P
p
.002 w
.38643 .18206 m .41637 .17478 L .43328 .18817 L p
.4 g
F P
s
P
p
0 1 .094 r
.01 w
.68033 .48908 m
.66489 .47748 L
s
P
p
0 1 .755 r
.01 w
.37603 .58445 m
.35877 .57342 L
s
P
p
0 1 .396 r
.01 w
.49671 .52582 m
.46657 .53195 L
s
P
p
.132 1 0 r
.01 w
.77181 .44887 m
.74079 .45525 L
s
P
p
0 1 .528 r
.01 w
.46641 .54459 m
.43636 .55066 L
s
P
p
.002 w
.79453 .17954 m .80187 .18623 L p
.77153 .17647 L .4 g
F P
s
P
p
0 1 .66 r
.01 w
.40614 .56938 m
.40614 .56938 L
s
P
p
0 1 .415 r
.01 w
.46654 .53375 m
.46654 .53375 L
s
P
p
.113 1 0 r
.01 w
.7409 .45701 m
.7409 .45701 L
s
P
p
.002 w
.13247 .18233 m .12312 .17563 L p
.15627 .1854 L .4 g
F P
s
P
p
.002 w
.12312 .17563 m .13769 .17197 L .15627 .1854 L p
.4 g
F P
s
P
p
.002 w
.69436 .17759 m .66356 .18484 L .648 .17141 L p
.4 g
F P
s
P
p
.002 w
.61726 .17871 m .648 .17141 L .66356 .18484 L p
.4 g
F P
s
P
p
.094 1 0 r
.01 w
.74102 .45877 m
.74102 .45877 L
s
P
p
0 1 .208 r
.01 w
.58792 .48917 m
.60386 .50073 L
s
P
p
.002 w
.41637 .17478 m .38643 .18206 L .36919 .16859 L p
.4 g
F P
s
P
p
.002 w
.33931 .17591 m .36919 .16859 L .38643 .18206 L p
.4 g
F P
s
P
p
0 1 .226 r
.01 w
.60391 .50252 m
.60391 .50252 L
s
P
p
0 1 .377 r
.01 w
.52703 .51784 m
.49671 .52402 L
s
P
p
.151 1 0 r
.01 w
.80289 .44068 m
.77168 .44711 L
s
P
p
0 1 .509 r
.01 w
.46643 .54278 m
.46643 .54278 L
s
P
p
0 1 .245 r
.01 w
.60395 .50431 m
.60395 .50431 L
s
P
p
.002 w
.57071 .17254 m .54024 .17982 L .52391 .16634 L p
.8 g
F P
s
P
p
.002 w
.77153 .17647 m .78714 .17282 L .79453 .17954 L p
.4 g
F P
s
P
p
0 1 .264 r
.01 w
.604 .5061 m
.58803 .49456 L
s
P
p
.226 1 0 r
.01 w
.78753 .42166 m
.80232 .43364 L
s
P
p
.002 w
.648 .17141 m .67893 .16407 L .69436 .17759 L p
.4 g
F P
s
P
p
0 1 .321 r
.01 w
.55748 .50622 m
.52701 .51244 L
s
P
p
.208 1 0 r
.01 w
.80246 .4354 m
.80246 .4354 L
s
P
p
.002 w
.78714 .17282 m .77153 .17647 L p
.75656 .16294 L .4 g
F P
s
P
p
0 1 .34 r
.01 w
.52702 .51424 m
.52702 .51424 L
s
P
p
.189 1 0 r
.01 w
.8026 .43716 m
.8026 .43716 L
s
P
p
.002 w
.13769 .17197 m .12312 .17563 L .11372 .16888 L p
.4 g
F P
s
P
p
.002 w
.44651 .16747 m .41637 .17478 L .39926 .16124 L p
.4 g
F P
s
P
p
.002 w
.36919 .16859 m .39926 .16124 L .41637 .17478 L p
.4 g
F P
s
P
p
0 1 .358 r
.01 w
.52703 .51604 m
.52703 .51604 L
s
P
p
.17 1 0 r
.01 w
.80275 .43892 m
.80275 .43892 L
s
P
p
1 .925 0 r
.01 w
.72178 .29395 m
.73698 .30671 L
s
P
p
0 1 .113 r
.01 w
.66496 .47926 m
.64933 .46753 L
s
P
p
0 1 .774 r
.01 w
.3587 .57525 m
.3587 .57525 L
s
P
p
.002 w
.77971 .16605 m .78714 .17282 L p
.75656 .16294 L .4 g
F P
s
P
p
.002 w
.52391 .16634 m .55451 .15896 L .57071 .17254 L p
.8 g
F P
s
P
p
.358 1 0 r
.01 w
.77166 .39721 m
.78658 .40936 L
s
P
p
1 .981 0 r
.01 w
.65997 .31287 m
.69093 .30599 L
s
P
p
.002 w
.12832 .1652 m .14296 .16152 L p
.13769 .17197 L .4 g
F P
s
P
p
.002 w
.16696 .16464 m .13769 .17197 L p
.14296 .16152 L .4 g
F P
s
P
p
.002 w
.11372 .16888 m .12832 .1652 L .13769 .17197 L p
.4 g
F P
s
P
p
0 1 .792 r
.01 w
.35862 .57708 m
.38861 .57106 L
s
P
p
.002 w
.67893 .16407 m .648 .17141 L .63225 .15782 L p
.4 g
F P
s
P
p
0 1 .17 r
.01 w
.61859 .47927 m
.58785 .48559 L
s
P
p
.34 1 0 r
.01 w
.78671 .41112 m
.78671 .41112 L
s
P
p
1 1 0 r
.01 w
.66005 .31457 m
.66005 .31457 L
s
P
p
0 1 .302 r
.01 w
.58811 .49816 m
.55746 .50442 L
s
P
p
0 1 .189 r
.01 w
.58788 .48738 m
.58788 .48738 L
s
P
p
.321 1 0 r
.01 w
.78685 .41287 m
.81825 .40631 L
s
P
p
.981 1 0 r
.01 w
.66012 .31627 m
.66012 .31627 L
s
P
p
.002 w
.32175 .16237 m .29195 .16972 L .27405 .15611 L p
.8 g
F P
s
P
p
.962 1 0 r
.01 w
.66019 .31798 m
.66019 .31798 L
s
P
p
.943 1 0 r
.01 w
.66027 .31969 m
.64456 .30697 L
s
P
p
.002 w
.47684 .1601 m .44651 .16747 L .42952 .15383 L p
.4 g
F P
s
P
p
.002 w
.39926 .16124 m .42952 .15383 L .44651 .16747 L p
.4 g
F P
s
P
p
.264 1 0 r
.01 w
.81871 .41158 m
.78726 .41814 L
s
P
p
1 .962 0 r
.01 w
.72199 .29736 m
.69085 .30428 L
s
P
p
.002 w
.75656 .16294 m .77223 .15925 L .77971 .16605 L p
.4 g
F P
s
P
p
.245 1 0 r
.01 w
.7874 .4199 m
.7874 .4199 L
s
P
p
0 1 .151 r
.01 w
.64946 .47111 m
.61854 .47748 L
s
P
p
.002 w
.15765 .15782 m .17238 .15411 L p
.16696 .16464 L .4 g
F P
s
P
p
.002 w
.19643 .15725 m .16696 .16464 L p
.17238 .15411 L .4 g
F P
s
P
p
.002 w
.14296 .16152 m .15765 .15782 L .16696 .16464 L p
.4 g
F P
s
P
p
0 1 .283 r
.01 w
.58807 .49636 m
.58807 .49636 L
s
P
p
.887 1 0 r
.01 w
.64476 .31211 m
.66049 .32482 L
s
P
p
.002 w
.63225 .15782 m .66331 .15039 L .67893 .16407 L p
.4 g
F P
s
P
p
0 1 .811 r
.01 w
.38855 .5729 m
.38855 .5729 L
s
P
p
.868 1 0 r
.01 w
.66056 .32654 m
.66056 .32654 L
s
P
p
.002 w
.77223 .15925 m .75656 .16294 L p
.7414 .14925 L .4 g
F P
s
P
p
.002 w
.35174 .15497 m .32175 .16237 L .30397 .14867 L p
.8 g
F P
s
P
p
.002 w
.27405 .15611 m .30397 .14867 L .32175 .16237 L p
.8 g
F P
s
P
p
0 1 .83 r
.01 w
.38849 .57474 m
.37111 .56352 L
s
P
p
.849 1 0 r
.01 w
.66064 .32825 m
.69174 .32139 L
s
P
p
.302 1 0 r
.01 w
.8184 .40806 m
.8184 .40806 L
s
P
p
.283 1 0 r
.01 w
.81856 .40982 m
.81856 .40982 L
s
P
p
.002 w
.50737 .15268 m .47684 .1601 L .45998 .14637 L p
.4 g
F P
s
P
p
.002 w
.42952 .15383 m .45998 .14637 L .47684 .1601 L p
.4 g
F P
s
P
p
.377 1 0 r
.01 w
.75645 .38314 m
.77153 .39545 L
s
P
p
1 .943 0 r
.01 w
.72189 .29565 m
.72189 .29565 L
s
P
p
.002 w
.76471 .1524 m .77223 .15925 L p
.7414 .14925 L .4 g
F P
s
P
p
0 1 .132 r
.01 w
.6494 .46932 m
.6494 .46932 L
s
P
p
.002 w
.66331 .15039 m .63225 .15782 L .61631 .14407 L p
.4 g
F P
s
P
p
.002 w
.18717 .15039 m .202 .14666 L p
.19643 .15725 L .4 g
F P
s
P
p
.002 w
.22608 .14982 m .19643 .15725 L p
.202 .14666 L .4 g
F P
s
P
p
.002 w
.17238 .15411 m .18717 .15039 L .19643 .15725 L p
.4 g
F P
s
P
p
.002 w
.30397 .14867 m .33409 .14118 L .35174 .15497 L p
.8 g
F P
s
P
p
.528 1 0 r
.01 w
.81869 .3556 m
.83344 .36811 L
s
P
p
.83 1 0 r
.01 w
.69183 .32311 m
.72315 .31621 L
s
P
p
.509 1 0 r
.01 w
.8336 .36985 m
.8336 .36985 L
s
P
p
.925 1 0 r
.01 w
.64463 .30868 m
.64463 .30868 L
s
P
p
.002 w
.45998 .14637 m .49064 .13887 L .50737 .15268 L p
.4 g
F P
s
P
p
.002 w
.7414 .14925 m .75715 .14551 L .76471 .1524 L p
.4 g
F P
s
P
p
.491 1 0 r
.01 w
.83376 .3716 m
.83376 .3716 L
s
P
p
.906 1 0 r
.01 w
.6447 .3104 m
.6447 .3104 L
s
P
p
.472 1 0 r
.01 w
.83392 .37335 m
.81915 .36086 L
s
P
p
.002 w
.61631 .14407 m .64751 .13655 L .66331 .15039 L p
.4 g
F P
s
P
p
.002 w
.21688 .14292 m .23181 .13916 L p
.22608 .14982 L .4 g
F P
s
P
p
.002 w
.25593 .14234 m .22608 .14982 L p
.23181 .13916 L .4 g
F P
s
P
p
.002 w
.202 .14666 m .21688 .14292 L .22608 .14982 L p
.4 g
F P
s
P
p
.002 w
.75715 .14551 m .7414 .14925 L p
.72606 .13539 L .4 g
F P
s
P
p
.415 1 0 r
.01 w
.7878 .3729 m
.7562 .37963 L
s
P
p
.002 w
.41233 .14003 m .38194 .14752 L .36441 .13365 L p
.8 g
F P
s
P
p
0 1 .849 r
.01 w
.37104 .56537 m
.35344 .55402 L
s
P
p
.396 1 0 r
.01 w
.75632 .38139 m
.75632 .38139 L
s
P
p
.002 w
.49064 .13887 m .45998 .14637 L .44292 .13248 L p
.4 g
F P
s
P
p
.002 w
.74954 .13858 m .75715 .14551 L p
.72606 .13539 L .4 g
F P
s
P
p
.002 w
.56904 .13771 m .5381 .14522 L .5215 .13132 L p
.8 g
F P
s
P
p
.811 1 0 r
.01 w
.72325 .31793 m
.72325 .31793 L
s
P
p
.002 w
.64751 .13655 m .61631 .14407 L .60017 .13015 L p
.4 g
F P
s
P
p
.585 1 0 r
.01 w
.80331 .3377 m
.81822 .35037 L
s
P
p
.792 1 0 r
.01 w
.72336 .31966 m
.70787 .3068 L
s
P
p
.566 1 0 r
.01 w
.81838 .35211 m
.81838 .35211 L
s
P
p
.002 w
.24679 .13539 m .26182 .13161 L p
.25593 .14234 L .4 g
F P
s
P
p
.002 w
.28598 .13481 m .25593 .14234 L p
.26182 .13161 L .4 g
F P
s
P
p
.002 w
.23181 .13916 m .24679 .13539 L .25593 .14234 L p
.4 g
F P
s
P
p
.434 1 0 r
.01 w
.81946 .36436 m
.78767 .37115 L
s
P
p
.547 1 0 r
.01 w
.81853 .35386 m
.81853 .35386 L
s
P
p
.736 1 0 r
.01 w
.70817 .31201 m
.72368 .32485 L
s
P
p
.002 w
.44292 .13248 m .41233 .14003 L .39492 .12606 L p
.8 g
F P
s
P
p
.002 w
.36441 .13365 m .39492 .12606 L .41233 .14003 L p
.8 g
F P
s
P
p
.717 1 0 r
.01 w
.72379 .32658 m
.72379 .32658 L
s
P
p
.002 w
.44292 .13248 m .47371 .12489 L .49064 .13887 L p
.4 g
F P
s
P
p
0 1 .887 r
.01 w
.35328 .55773 m
.32297 .56389 L
s
P
p
.002 w
.72606 .13539 m .74188 .13161 L .74954 .13858 L p
.4 g
F P
s
P
p
.698 1 0 r
.01 w
.72389 .32832 m
.75553 .32138 L
s
P
p
.002 w
.5215 .13132 m .55257 .12371 L .56904 .13771 L p
.8 g
F P
s
P
p
0 1 .906 r
.01 w
.32287 .56574 m
.32287 .56574 L
s
P
p
.002 w
.60017 .13015 m .63151 .12254 L .64751 .13655 L p
.4 g
F P
s
P
p
0 1 .925 r
.01 w
.32277 .5676 m
.32277 .5676 L
s
P
p
.453 1 0 r
.01 w
.8193 .36261 m
.8193 .36261 L
s
P
p
.002 w
.74188 .13161 m .72606 .13539 L p
.71054 .12136 L .4 g
F P
s
P
p
0 1 .943 r
.01 w
.32268 .56946 m
.32268 .56946 L
s
P
p
.002 w
.2769 .12781 m .29203 .12401 L p
.28598 .13481 L .4 g
F P
s
P
p
.002 w
.31622 .12723 m .28598 .13481 L p
.29203 .12401 L .4 g
F P
s
P
p
.002 w
.26182 .13161 m .2769 .12781 L .28598 .13481 L p
.4 g
F P
s
P
p
0 1 .962 r
.01 w
.32258 .57132 m
.30459 .55994 L
s
P
p
.002 w
.39492 .12606 m .42564 .11842 L .44292 .13248 L p
.8 g
F P
s
P
p
0 1 .868 r
.01 w
.35336 .55587 m
.35336 .55587 L
s
P
p
.002 w
.73417 .12459 m .74188 .13161 L p
.71054 .12136 L .4 g
F P
s
P
p
.002 w
.55257 .12371 m .5215 .13132 L .5047 .11724 L p
.8 g
F P
s
P
p
.604 1 0 r
.01 w
.78808 .32313 m
.80317 .33595 L
s
P
p
.002 w
.63151 .12254 m .60017 .13015 L .58384 .11606 L p
.4 g
F P
s
P
p
.679 1 0 r
.01 w
.75566 .32312 m
.78752 .31615 L
s
P
p
.774 1 0 r
.01 w
.70797 .30854 m
.70797 .30854 L
s
P
p
.755 1 0 r
.01 w
.70807 .31027 m
.70807 .31027 L
s
P
p
.002 w
.3072 .12019 m .32243 .11635 L p
.31622 .12723 L .4 g
F P
s
P
p
.002 w
.34666 .1196 m .31622 .12723 L p
.32243 .11635 L .4 g
F P
s
P
p
.002 w
.29203 .12401 m .3072 .12019 L .31622 .12723 L p
.4 g
F P
s
P
p
.002 w
.71054 .12136 m .72642 .11754 L .73417 .12459 L p
.4 g
F P
s
P
p
.002 w
.5047 .11724 m .5359 .10954 L .55257 .12371 L p
.8 g
F P
s
P
p
.002 w
.58384 .11606 m .61532 .10836 L .63151 .12254 L p
.4 g
F P
s
P
p
.002 w
.72642 .11754 m .71054 .12136 L p
.69482 .10717 L .4 g
F P
s
P
p
.66 1 0 r
.01 w
.78766 .31789 m
.78766 .31789 L
s
P
p
.002 w
.33771 .11251 m .35304 .10865 L p
.34666 .1196 L .4 g
F P
s
P
p
.002 w
.37731 .11192 m .34666 .1196 L p
.35304 .10865 L .4 g
F P
s
P
p
.002 w
.32243 .11635 m .33771 .11251 L .34666 .1196 L p
.4 g
F P
s
P
p
.642 1 0 r
.01 w
.7878 .31963 m
.7878 .31963 L
s
P
p
0 1 .981 r
.01 w
.30448 .56181 m
.30448 .56181 L
s
P
p
.002 w
.45656 .11073 m .42564 .11842 L .40816 .10419 L p
.4 g
F P
s
P
p
.623 1 0 r
.01 w
.78794 .32138 m
.78794 .32138 L
s
P
p
0 1 1 r
.01 w
.30437 .56368 m
.33491 .55746 L
s
P
p
.002 w
.71862 .11043 m .72642 .11754 L p
.69482 .10717 L .4 g
F P
s
P
p
.002 w
.5359 .10954 m .5047 .11724 L .48769 .10299 L p
.8 g
F P
s
P
p
.002 w
.61532 .10836 m .58384 .11606 L .56731 .1018 L p
.4 g
F P
s
P
p
.002 w
.36842 .10478 m .38385 .1009 L p
.37731 .11192 L .4 g
F P
s
P
p
.002 w
.40816 .10419 m .37731 .11192 L p
.38385 .1009 L .4 g
F P
s
P
p
.002 w
.35304 .10865 m .36842 .10478 L .37731 .11192 L p
.4 g
F P
s
P
p
.002 w
.40816 .10419 m .43921 .0964 L .45656 .11073 L p
.4 g
F P
s
P
p
.002 w
.69482 .10717 m .71078 .10329 L .71862 .11043 L p
.4 g
F P
s
P
p
.002 w
.48769 .10299 m .51903 .0952 L .5359 .10954 L p
.8 g
F P
s
P
p
0 .981 1 r
.01 w
.33482 .55934 m
.33482 .55934 L
s
P
p
.002 w
.64701 .1006 m .61532 .10836 L .59893 .094 L p
.4 g
F P
s
P
p
.002 w
.56731 .1018 m .59893 .094 L .61532 .10836 L p
.4 g
F P
s
P
p
0 .962 1 r
.01 w
.33473 .56121 m
.3166 .54964 L
s
P
p
.002 w
.71078 .10329 m .69482 .10717 L p
.67891 .09279 L .4 g
F P
s
P
p
.002 w
.39933 .097 m .41487 .09309 L p
.40816 .10419 L .4 g
F P
s
P
p
.002 w
.43921 .0964 m .40816 .10419 L p
.41487 .09309 L .4 g
F P
s
P
p
.002 w
.38385 .1009 m .39933 .097 L .40816 .10419 L p
.4 g
F P
s
P
p
0 .906 1 r
.01 w
.31629 .5553 m
.33445 .56685 L
s
P
p
.002 w
.70288 .0961 m .71078 .10329 L p
.67891 .09279 L .4 g
F P
s
P
p
0 .887 1 r
.01 w
.33436 .56874 m
.33436 .56874 L
s
P
p
0 .868 1 r
.01 w
.33427 .57063 m
.36511 .56439 L
s
P
p
.002 w
.67891 .09279 m .64701 .1006 L .63076 .08615 L p
.4 g
F P
s
P
p
.002 w
.59893 .094 m .63076 .08615 L .64701 .1006 L p
.4 g
F P
s
P
p
.002 w
.43045 .08917 m .44609 .08524 L p
.43921 .0964 L .4 g
F P
s
P
p
.002 w
.47047 .08857 m .43921 .0964 L p
.44609 .08524 L .4 g
F P
s
P
p
.002 w
.41487 .09309 m .43045 .08917 L .43921 .0964 L p
.4 g
F P
s
P
p
.002 w
.67891 .09279 m .69494 .08887 L .70288 .0961 L p
.4 g
F P
s
P
p
.002 w
.69494 .08887 m .67891 .09279 L p
.6628 .07824 L .4 g
F P
s
P
p
.002 w
.63076 .08615 m .6628 .07824 L .67891 .09279 L p
.4 g
F P
s
P
p
0 .849 1 r
.01 w
.36504 .56628 m
.3961 .56001 L
s
P
p
0 .943 1 r
.01 w
.31649 .55153 m
.31649 .55153 L
s
P
p
0 .925 1 r
.01 w
.31639 .55341 m
.31639 .55341 L
s
P
p
.002 w
.68694 .08159 m .69494 .08887 L p
.6628 .07824 L .4 g
F P
s
P
p
.002 w
.46178 .08129 m .47753 .07733 L p
.47047 .08857 L .4 g
F P
s
P
p
.002 w
.50194 .08068 m .47047 .08857 L p
.47753 .07733 L .4 g
F P
s
P
p
.002 w
.44609 .08524 m .46178 .08129 L .47047 .08857 L p
.4 g
F P
s
P
p
0 .83 1 r
.01 w
.39604 .56191 m
.39604 .56191 L
s
P
p
0 .811 1 r
.01 w
.39598 .5638 m
.37804 .55212 L
s
P
p
.002 w
.6628 .07824 m .6789 .07427 L .68694 .08159 L p
.4 g
F P
s
P
p
.002 w
.49332 .07335 m .50917 .06936 L p
.50194 .08068 L .4 g
F P
s
P
p
.002 w
.53363 .07274 m .50194 .08068 L p
.50917 .06936 L .4 g
F P
s
P
p
.002 w
.47753 .07733 m .49332 .07335 L .50194 .08068 L p
.4 g
F P
s
P
p
.002 w
.6789 .07427 m .6628 .07824 L p
.64649 .06351 L .4 g
F P
s
P
p
.002 w
.67081 .0669 m .6789 .07427 L p
.64649 .06351 L .4 g
F P
s
P
p
.002 w
.52508 .06536 m .54103 .06134 L p
.53363 .07274 L .4 g
F P
s
P
p
.002 w
.56553 .06474 m .53363 .07274 L p
.54103 .06134 L .4 g
F P
s
P
p
.002 w
.50917 .06936 m .52508 .06536 L .53363 .07274 L p
.4 g
F P
s
P
p
.002 w
.64649 .06351 m .66266 .05949 L .67081 .0669 L p
.4 g
F P
s
P
p
0 .792 1 r
.01 w
.37797 .55403 m
.35979 .54221 L
s
P
p
.002 w
.55705 .05731 m .57311 .05327 L p
.56553 .06474 L .4 g
F P
s
P
p
.002 w
.59764 .05669 m .56553 .06474 L p
.57311 .05327 L .4 g
F P
s
P
p
.002 w
.54103 .06134 m .55705 .05731 L .56553 .06474 L p
.4 g
F P
s
P
p
.002 w
.66266 .05949 m .64649 .06351 L p
.62997 .04859 L .4 g
F P
s
P
p
.002 w
.65447 .05202 m .66266 .05949 L p
.62997 .04859 L .4 g
F P
s
P
p
0 .755 1 r
.01 w
.35963 .54604 m
.32821 .55245 L
s
P
p
.002 w
.58923 .04921 m .60541 .04514 L p
.59764 .05669 L .4 g
F P
s
P
p
.002 w
.62997 .04859 m .59764 .05669 L p
.60541 .04514 L .4 g
F P
s
P
p
.002 w
.57311 .05327 m .58923 .04921 L .59764 .05669 L p
.4 g
F P
s
P
p
0 .736 1 r
.01 w
.32812 .55437 m
.32812 .55437 L
s
P
p
0 .717 1 r
.01 w
.32802 .55628 m
.32802 .55628 L
s
P
p
0 .698 1 r
.01 w
.32793 .5582 m
.35939 .5518 L
s
P
p
.002 w
.62997 .04859 m .64622 .04452 L .65447 .05202 L p
.4 g
F P
s
P
p
0 .774 1 r
.01 w
.35971 .54412 m
.35971 .54412 L
s
P
p
.002 w
.62164 .04106 m .63792 .03696 L p
.62997 .04859 L .4 g
F P
s
P
p
.002 w
.64622 .04452 m .62997 .04859 L p
.63792 .03696 L .4 g
F P
s
P
p
.002 w
.60541 .04514 m .62164 .04106 L .62997 .04859 L p
.4 g
F P
s
P
p
0 .679 1 r
.01 w
.35931 .55372 m
.35931 .55372 L
s
P
p
0 .66 1 r
.01 w
.35923 .55565 m
.34074 .54371 L
s
P
p
0 .642 1 r
.01 w
.34065 .54565 m
.32192 .53357 L
s
P
p
0 .604 1 r
.01 w
.32172 .53746 m
.28991 .54401 L
s
P
p
0 .585 1 r
.01 w
.28979 .54595 m
.28979 .54595 L
s
P
p
0 .566 1 r
.01 w
.28967 .5479 m
.28967 .5479 L
s
P
p
0 .547 1 r
.01 w
.28955 .54985 m
.32142 .5433 L
s
P
p
0 .623 1 r
.01 w
.32182 .53551 m
.32182 .53551 L
s
P
p
0 .528 1 r
.01 w
.32131 .54525 m
.32131 .54525 L
s
P
p
0 .509 1 r
.01 w
.32121 .54721 m
.30217 .53502 L
s
P
p
0 .491 1 r
.01 w
.30205 .53698 m
.28275 .52464 L
s
P
p
0 .453 1 r
.01 w
.2825 .52858 m
.25027 .53528 L
s
P
p
0 .434 1 r
.01 w
.25013 .53725 m
.25013 .53725 L
s
P
p
0 .415 1 r
.01 w
.24999 .53923 m
.24999 .53923 L
s
P
p
0 .396 1 r
.01 w
.24985 .5412 m
.28213 .53451 L
s
P
p
0 .472 1 r
.01 w
.28263 .52661 m
.28263 .52661 L
s
P
p
0 .377 1 r
.01 w
.282 .53649 m
.282 .53649 L
s
P
p
0 .358 1 r
.01 w
.28188 .53848 m
.26224 .52602 L
s
P
p
0 .34 1 r
.01 w
.2621 .52801 m
.2422 .51539 L
s
P
p
0 .302 1 r
.01 w
.2419 .51939 m
.20925 .52624 L
s
P
p
0 .283 1 r
.01 w
.20908 .52824 m
.20908 .52824 L
s
P
p
0 .264 1 r
.01 w
.20892 .53025 m
.20892 .53025 L
s
P
p
0 .245 1 r
.01 w
.20875 .53225 m
.24145 .52541 L
s
P
p
0 .321 1 r
.01 w
.24205 .51739 m
.24205 .51739 L
s
P
p
0 .226 1 r
.01 w
.2413 .52743 m
.2413 .52743 L
s
P
p
0 .208 1 r
.01 w
.24115 .52944 m
.22089 .5167 L
s
P
p
0 .094 1 r
.01 w
.25314 .52191 m
.27333 .53471 L
s
P
p
0 .189 1 r
.01 w
.22073 .51872 m
.22073 .51872 L
s
P
p
0 .075 1 r
.01 w
.27319 .53674 m
.27319 .53674 L
s
P
p
0 .17 1 r
.01 w
.22057 .52074 m
.22057 .52074 L
s
P
p
0 .057 1 r
.01 w
.27306 .53877 m
.30641 .53187 L
s
P
p
0 .151 1 r
.01 w
.2204 .52277 m
.2204 .52277 L
s
P
p
0 .132 1 r
.01 w
.22024 .5248 m
.25343 .51784 L
s
P
p
0 .038 1 r
.01 w
.3063 .53391 m
.33992 .52696 L
s
P
p
0 .113 1 r
.01 w
.25329 .51987 m
.25329 .51987 L
s
P
p
0 .019 1 r
.01 w
.33982 .52901 m
.33982 .52901 L
s
P
p
0 0 1 r
.01 w
.33972 .53106 m
.31978 .51811 L
s
P
p
1 0 .151 r
.01 w
.55803 .82342 m
.57639 .83433 L
s
P
p
1 0 .132 r
.01 w
.57642 .83655 m
.57642 .83655 L
s
P
p
1 0 .113 r
.01 w
.57646 .83878 m
.57646 .83878 L
s
P
p
1 0 .094 r
.01 w
.5765 .84101 m
.5581 .83013 L
s
P
p
.113 0 1 r
.01 w
.3533 .52342 m
.37315 .53643 L
s
P
p
.019 0 1 r
.01 w
.31967 .52016 m
.31967 .52016 L
s
P
p
1 0 .189 r
.01 w
.59293 .81298 m
.55797 .81896 L
s
P
p
.132 0 1 r
.01 w
.37307 .5385 m
.37307 .5385 L
s
P
p
1 0 .057 r
.01 w
.55816 .83462 m
.52332 .84052 L
s
P
p
.038 0 1 r
.01 w
.31957 .52222 m
.31957 .52222 L
s
P
p
1 0 .17 r
.01 w
.558 .82119 m
.558 .82119 L
s
P
p
.151 0 1 r
.01 w
.37299 .54057 m
.4073 .53355 L
s
P
p
1 0 .038 r
.01 w
.52332 .84276 m
.52332 .84276 L
s
P
p
.057 0 1 r
.01 w
.31946 .52429 m
.31946 .52429 L
s
P
p
1 0 .019 r
.01 w
.52333 .84501 m
.52333 .84501 L
s
P
p
.075 0 1 r
.01 w
.31935 .52635 m
.35348 .51928 L
s
P
p
1 0 .34 r
.01 w
.5205 .77876 m
.53926 .79006 L
s
P
p
1 0 .226 r
.01 w
.57444 .79734 m
.59284 .80851 L
s
P
p
1 0 .321 r
.01 w
.53928 .79228 m
.53928 .79228 L
s
P
p
1 0 .208 r
.01 w
.59289 .81074 m
.59289 .81074 L
s
P
p
1 0 .302 r
.01 w
.53929 .7945 m
.5743 .78841 L
s
P
p
1 0 .075 r
.01 w
.55813 .83237 m
.55813 .83237 L
s
P
p
.17 0 1 r
.01 w
.40724 .53563 m
.44181 .52856 L
s
P
p
.094 0 1 r
.01 w
.35339 .52135 m
.35339 .52135 L
s
P
p
1 0 .283 r
.01 w
.57433 .79064 m
.57433 .79064 L
s
P
p
1 0 .264 r
.01 w
.57437 .79287 m
.57437 .79287 L
s
P
p
1 0 .358 r
.01 w
.50148 .76507 m
.52049 .77654 L
s
P
p
1 0 .245 r
.01 w
.57441 .7951 m
.57441 .7951 L
s
P
p
.189 0 1 r
.01 w
.44177 .53065 m
.44177 .53065 L
s
P
p
.208 0 1 r
.01 w
.44173 .53273 m
.44173 .53273 L
s
P
p
.226 0 1 r
.01 w
.44169 .53482 m
.47659 .52772 L
s
P
p
1 0 .396 r
.01 w
.53674 .75433 m
.50149 .76061 L
s
P
p
.245 0 1 r
.01 w
.47657 .52981 m
.51175 .52265 L
s
P
p
1 0 .377 r
.01 w
.50149 .76284 m
.50149 .76284 L
s
P
p
1 0 .415 r
.01 w
.57223 .74576 m
.53673 .7521 L
s
P
p
1 0 .491 r
.01 w
.55324 .72498 m
.57209 .73684 L
s
P
p
.264 0 1 r
.01 w
.51175 .52475 m
.51175 .52475 L
s
P
p
1 0 .472 r
.01 w
.57212 .73907 m
.57212 .73907 L
s
P
p
.283 0 1 r
.01 w
.51174 .52686 m
.49246 .51352 L
s
P
p
1 0 .453 r
.01 w
.57216 .7413 m
.57216 .7413 L
s
P
p
1 0 .434 r
.01 w
.57219 .74352 m
.57219 .74352 L
s
P
p
1 0 .528 r
.01 w
.58901 .71402 m
.55319 .72052 L
s
P
p
1 0 .509 r
.01 w
.55321 .72275 m
.55321 .72275 L
s
P
p
.302 0 1 r
.01 w
.49244 .51563 m
.49244 .51563 L
s
P
p
1 0 .566 r
.01 w
.57002 .6974 m
.58892 .70956 L
s
P
p
.321 0 1 r
.01 w
.49243 .51774 m
.49243 .51774 L
s
P
p
1 0 .547 r
.01 w
.58896 .71179 m
.58896 .71179 L
s
P
p
.34 0 1 r
.01 w
.49242 .51986 m
.49242 .51986 L
s
P
p
.358 0 1 r
.01 w
.49241 .52198 m
.52815 .51469 L
s
P
p
1 0 .604 r
.01 w
.60614 .68627 m
.56996 .69294 L
s
P
p
.377 0 1 r
.01 w
.52816 .51682 m
.52816 .51682 L
s
P
p
1 0 .585 r
.01 w
.56999 .69517 m
.56999 .69517 L
s
P
p
.396 0 1 r
.01 w
.52817 .51895 m
.52817 .51895 L
s
P
p
.415 0 1 r
.01 w
.52818 .52108 m
.52818 .52108 L
s
P
p
.434 0 1 r
.01 w
.52819 .52321 m
.52819 .52321 L
s
P
p
1 0 .755 r
.01 w
.53132 .65019 m
.55064 .66277 L
s
P
p
.453 0 1 r
.01 w
.5282 .52535 m
.5282 .52535 L
s
P
p
1 0 .642 r
.01 w
.5871 .66935 m
.60603 .68181 L
s
P
p
1 0 .736 r
.01 w
.55066 .66499 m
.55066 .66499 L
s
P
p
.472 0 1 r
.01 w
.52821 .52749 m
.52821 .52749 L
s
P
p
1 0 .623 r
.01 w
.60609 .68404 m
.60609 .68404 L
s
P
p
1 0 .717 r
.01 w
.55068 .66721 m
.58692 .66043 L
s
P
p
.491 0 1 r
.01 w
.52822 .52963 m
.56438 .52231 L
s
P
p
1 0 .698 r
.01 w
.58697 .66265 m
.58697 .66265 L
s
P
p
.509 0 1 r
.01 w
.56441 .52446 m
.56441 .52446 L
s
P
p
1 0 .679 r
.01 w
.58701 .66489 m
.58701 .66489 L
s
P
p
.528 0 1 r
.01 w
.56444 .52661 m
.56444 .52661 L
s
P
p
1 0 .774 r
.01 w
.51172 .63519 m
.53131 .64796 L
s
P
p
1 0 .66 r
.01 w
.58706 .66712 m
.58706 .66712 L
s
P
p
.547 0 1 r
.01 w
.56447 .52876 m
.56447 .52876 L
s
P
p
.566 0 1 r
.01 w
.5645 .53091 m
.5645 .53091 L
s
P
p
.585 0 1 r
.01 w
.56453 .53307 m
.56453 .53307 L
s
P
p
.604 0 1 r
.01 w
.56456 .53523 m
.56456 .53523 L
s
P
p
.623 0 1 r
.01 w
.5646 .53739 m
.60119 .53005 L
s
P
p
1 0 .811 r
.01 w
.54822 .62372 m
.51172 .63073 L
s
P
p
1 0 .792 r
.01 w
.51172 .63296 m
.51172 .63296 L
s
P
p
.642 0 1 r
.01 w
.60124 .53222 m
.60124 .53222 L
s
P
p
.66 0 1 r
.01 w
.6013 .53439 m
.6013 .53439 L
s
P
p
.679 0 1 r
.01 w
.60135 .53656 m
.60135 .53656 L
s
P
p
.906 0 1 r
.01 w
.65812 .56903 m
.6211 .57626 L
s
P
p
1 0 .962 r
.01 w
.62155 .59172 m
.58466 .59887 L
s
P
p
.698 0 1 r
.01 w
.6014 .53874 m
.6014 .53874 L
s
P
p
.925 0 1 r
.01 w
.62116 .57846 m
.62116 .57846 L
s
P
p
1 0 .83 r
.01 w
.58496 .61443 m
.5482 .62149 L
s
P
p
1 0 .943 r
.01 w
.5847 .60109 m
.5847 .60109 L
s
P
p
.717 0 1 r
.01 w
.60146 .54092 m
.60146 .54092 L
s
P
p
.943 0 1 r
.01 w
.62123 .58067 m
.62123 .58067 L
s
P
p
.83 0 1 r
.01 w
.6389 .54669 m
.65777 .56023 L
s
P
p
1 0 .925 r
.01 w
.58475 .6033 m
.58475 .6033 L
s
P
p
.736 0 1 r
.01 w
.60151 .5431 m
.60151 .5431 L
s
P
p
.962 0 1 r
.01 w
.62129 .58287 m
.62129 .58287 L
s
P
p
.849 0 1 r
.01 w
.65786 .56243 m
.65786 .56243 L
s
P
p
1 0 .906 r
.01 w
.58479 .60552 m
.58479 .60552 L
s
P
p
.755 0 1 r
.01 w
.60156 .54529 m
.6386 .53791 L
s
P
p
.981 0 1 r
.01 w
.62136 .58508 m
.62136 .58508 L
s
P
p
.868 0 1 r
.01 w
.65795 .56462 m
.65795 .56462 L
s
P
p
1 0 .887 r
.01 w
.58483 .60775 m
.58483 .60775 L
s
P
p
1 0 1 r
.01 w
.62142 .58729 m
.62142 .58729 L
s
P
p
.887 0 1 r
.01 w
.65803 .56682 m
.65803 .56682 L
s
P
p
1 0 .868 r
.01 w
.58488 .60997 m
.58488 .60997 L
s
P
p
1 0 .981 r
.01 w
.62149 .5895 m
.62149 .5895 L
s
P
p
1 0 .849 r
.01 w
.58492 .6122 m
.58492 .6122 L
s
P
p
.774 0 1 r
.01 w
.63867 .5401 m
.63867 .5401 L
s
P
p
.792 0 1 r
.01 w
.63875 .5423 m
.63875 .5423 L
s
P
p
.811 0 1 r
.01 w
.63882 .54449 m
.63882 .54449 L
s
P
p
.002 w
.63741 .02391 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.63741 .02391 m
.11528 .15603 L
s
P
p
p
.002 w
.11528 .15603 m
.63741 .02391 L
s
P
p
.002 w
.23292 .12626 m
.23893 .13082 L
s
P
[(5)] .22092 .11714 .84695 1 Mshowa
p
.002 w
.38437 .08794 m
.39013 .09263 L
s
P
[(10)] .37284 .07856 .79165 1 Mshowa
p
.002 w
.54092 .04833 m
.54642 .05314 L
s
P
[(15)] .5299 .0387 .73636 1 Mshowa
p
.001 w
.26282 .1187 m
.26639 .12145 L
s
P
p
.001 w
.29291 .11108 m
.29645 .11385 L
s
P
p
.001 w
.32319 .10342 m
.32671 .1062 L
s
P
p
.001 w
.35368 .0957 m
.35717 .0985 L
s
P
p
.001 w
.41526 .08012 m
.41869 .08295 L
s
P
p
.001 w
.44636 .07225 m
.44976 .0751 L
s
P
p
.001 w
.47767 .06433 m
.48104 .06719 L
s
P
p
.001 w
.50919 .05636 m
.51252 .05923 L
s
P
p
.001 w
.20323 .13377 m
.20686 .1365 L
s
P
p
.001 w
.17372 .14124 m
.17738 .14395 L
s
P
p
.001 w
.14441 .14866 m
.14809 .15135 L
s
P
p
.001 w
.57286 .04024 m
.57613 .04315 L
s
P
p
.001 w
.60502 .03211 m
.60826 .03503 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{230, 230},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003V0000iPP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000>H0003V0000iP0007D00ol300?oJ00003T0
0ol300;o0`03o`800ol20003o`0002D000?o00001@000ol0001U0000>0001ol0003o0?l00P000ol0
o`020006o`00o`3o0P000ol0000U0003o`0000D000?o0000I@0003`000?o0?l00P000ol0o`020006
o`00o`3o0P000ol0000U0003o`0000800omX0000>@03o`8000Ko003o0?l20006o`00o`3o0P000ol0
000U0003o`00008000?o00005@04odl0000h0003o`0000@00_l20005o`00o`001_lW00;o1004oa00
1?l20003o`3o04h0000h0005o`000?l030000ol0o`0o00Co1P001?l00?m=0000>@03o`l000?o0000
>@04o`@000Co00001?l20003o`0004X0002400Go1P05o`03a?oF00CoB`0005<00ol400;o9004o`L0
1Ol3a003olCo00?o0P000ol000180000E0000ol000020004o`00oal01?l00`3oa00400Ko1<@00oo4
a002o`?400Co003oB@0005@000?o00000P001?l00?lK00Co1P07o`C41?l4eP03olC400;41?m80000
E0000ol000020004o`00oaL01?l20003o`0000801?l2a003olC400?o2]H01oo4a<Coa?l00P000ol0
000700?o>`0005@000?o00000P001?l00?lC00Co1`04o`G400Coa?oo3MH01?oFool2a0;o0P000ol0
00090003o`0003P0001C00;o1@02oa001?l40003o`0000Go0/@00oo4a003oa7F00Coe]KF0l@2o`04
0?ooo`T000?o0000>00006T01Ol500Go1L@01?o4oolDeP03omKF00;F1<@01Ol0003o00D00olk0000
I@04o`H01_l2a003olC400?o6=H01?oFe]H4o`;400Go0000o`040003o`0003/0000g00?o9`04o`03
0?l000<01ol3a0;o00?4ool07=H3o`?400Coa<C40_l2a004o`0000Co>P0003X000?o00008004o`H0
1?l6a0Co7=H6o`K400Koa<Coa?l20003o`0003h0000j0003o`0001`01?l30003ol@000Co0l@00oo4
a003oa_F1_l4a0;o1l@2o`;40_l20003o`0003d0000g00?o6`05o`D01Ol7a0;o3=H4o`_F0ol4a003
olC400C400?oa<@00ol4eP?41Oln0000=`000ol0000G00Co1P06o`;400?oa<@00ol3a003omKF00KF
1?l4IP03omKF00KF0_l8a004olC4a0Go2=H4a004o`00ocd0000g00Co4`03o`8000Co00001_l4a0;o
00?4ool01l@00ooFeP07eP03ofIV00AV00?oe]H01mH00oo4a006a0?o0]H00ooFeP09eP;o0/@01?l0
0?lO00Go00D0oooo0003o`<00_l;0000BP04o`D01ol3a0Co1MH00oo4a005a003omKF00OF00CoIVIV
0_l00fKoo`08eP03olC400?o0/@00ooFeP02eP03omKF00[F1<@01?l0oolN0003o`00008000Co003o
10001?l00?l<0000AP04o`8000?o00001Ol2a003olC400?o2mH00oo4a003o`cF0ol5IP03omKF00KF
0_l6a005omKFe_l03MH3a0;o0P02oa`000?o00000`03o`800_l30003o`0000X0001200Go1005o`G4
00Coa?oo3=H5oa3F00?oIVH01FH00ooFeP06eP03olC400G400Coe]Ko3]H2o`;400Go0000o`0K00Go
0`000ol0o`050003o`0000X0000n00Co1@06o`;400?oa<@00ol;ePGo16H00ooFeP04ePCo1mH00omV
IP02IP;o00=Vool01mH00oo4a002a0;o00C4omKo3mH4a0Go6P000ol0000300;o0`03o`040?ooo`/0
000j00Co0P000ol00007o`?40_l00lCoo`0;eP?o0fH00omVIP04IP03omKF00?o1<@00ooFeP05ePCo
1FH00ooFeP05ePCo1<@2oa3F0l@00oo4o`020003o`0000H00ol400;o20000ol0000=0003o`0000X0
000f00Co1@04o`G400?oa?l00_l>eP;o1fH01?mVIVH2o`03I_oo00S400?oe]H01]H00omVIP05IP03
omKF00KF00?oa<@01<@00ooFeP0?eP;o0/@2o`8000?o00001P000ol000020004o`00o`L01OlH0000
<`03o`<000?o0?l01?l2a003olC400?o5=H00omVIP06IP?o1MH00oo4a006a003omKF00KF00?oIVH0
0VH01?mVI_l8eP04olC4a0Go4MH3a0Go1`000ol000020004o`00ob@0000_00Co1006o`?40_l00lCo
o`0<ePGo1mH00omVIP03o`_F00?oa<@00ol3a003omKF00KF1?l=eP?o0/@00oo4a002oa3F1<@01?l0
0?l60003o`00008000Co003o900002/01?l400Oo0l@3o`cF1Ol5IP;o1]H2o`cF1Ol7a003omKF01OF
00Goa<C4o`04a003omKF00kF0_l2a004o`00o`D000?o00000P001?l00?lT00009`04o`040?l000Co
0l@00oo4a003o`gF0ol3IP03ofIV00IV00?oe]H03=H5o`G400?oa<@01L@00ooFeP0GeP03olC400?o
0l@00ooFeP0>ePC400Coa<Co0`02o`D00_lU00009@02o`@01Ol7a0;o3]H2o`MV00?oIVH00ol>eP?o
0l@00oo4a005a003olC400?o2]H3o`oF0ol6a003omKF00kF0l@2o`8000?o0000;P0002D000?o0?l0
1Ol2a003olC400?o5=H00omVIP05IP;o3=H5o`O400?oa<@00/@2o`03a?oo00[F0ol3IP03omKF00kF
00?oa<@01L@2o`oF0_l2a003o`0000;o;P0002D01Ol3a0;o00?4ool06=H00omVIP03o`[F1Ol5a003
olC400G41?l=eP;o1fH00ooFeP0=eP;o0/@3o`?400?oe]H03MH4a003o`3o00;o;@0001d00_l600;o
0l@3oakF0_l:eP?o0l@00oo4a005a003olC400?o4mH00omVIP06IP03omKF00cF1?l7a003omKF00gF
0l@2o`<000?o0000:P0001`000Co003o1@001?l0ool3a003omKF02KF0_l7a003olC400;40_l00lCo
o`0GeP03ofIV00?o3]H4o`;400?oa<@01/@00ooFeP0=eP;o0/@2o`8000?o0000:@0001`000Co003o
10000ol000020005olC4a?l0:MH00oo4a005a0Co1<@00ooFeP0FeP;o3=H5o`?400Goa<C4o`02a0?o
4mH4a0Go:P0001`000Co003o10000ol000030004olC4a0;o7=H5o`OF00?oa<@00ol3a003olC400C4
00?oe]H03MH3o`kF1Ol5a004olC4o`C40_lGeP?400?oa?l00P000ol0000W000070001?l00?l40003
o`0000@00_l3a003omKF01KF0ol5IP;o1]H2o`O400Coa<C40_l00lCoeP0:eP?o0fH00ooFeP08eP?o
0l@00oo4a005a0Co7=H3o`;40_l20003o`0002H0000M00;o1@000ol000060005olC4a?l06=H00omV
IP06IP03omKF00GF00?oa<@01L@3o`gF0_l7IP03omKF00GF0_l7a003olC400?o1=H00ooFeP0GeP?o
0VH01?o4a<@5obL0000T00;o20001?o4a<@2oaOF00?oIVH00ol3IP03omKF00GF00?oa<@00ol:eP?o
1]H00omVIP05IP03omKF00GF00?oa<@01/@2o`OF00?oe]H04]H5o`IV00Koa<Coa?l20003o`0000H0
0ol300?o5@0002@000?o00002002o`?400?oe]H05MH2o`MV00?oe]H01MH2o`[F0ol3a003omKF00CF
00?oIVH00ol:eP03olC400?o0l@00ooFeP05eP03omKF00cF1_l5IP03ofIV00AV0_l3a004o`00o`P0
00?o00001@000ol0000B000090000ol0000:0005olC4a?l06=H00omVIP05IP03omKF00_F1Ol7a003
omKF00CF0_l>eP;o1l@00ooFeP04eP03omKF00WF0ol3IP03ofIV00IV0ol5IP04olC4a0Go1P000ol0
00050003o`000180000T0003o`0000`00_l00lCoo`0GeP03ofIV00?o2mH4o`C400?oa<@01/@00ooF
eP0EeP;o1/@00ooFeP03eP03omKF00CF1Ol7IP03ofIV00?o0mH00omVIP05IP05olC4a?l00`000ol0
00030003o`0000800olE00008`000ol0000>0004olC4a0;o5]H2oa3F00?oa<@01<@00oo4a003o`?4
00?oe]H05=H5o`C400?oe]H00]H00ooFo`04o`EV0_l6IP;o1mH00omVIP02IP;o00=Vool00/@01Oo4
a<Co00@000?o00000P000ol0000E00008`000ol0000?0003olC400;400?oe]H09]H01?o4a<@2o`03
a?oo00O400?oe]H04=H3o`=V00?oa<@01<@00ooFeP03o`=V00?oIVH01VH3o`_F1_l5IP03olC400;o
0P000ol00002o`@01?lD00008`000ol0000?0004a03oo`;400?oe]H09]H3o`G400?oa<@01L@00ooF
eP0=eP;o1fH01?o4a<@2o`05a?ooI_l01FH00omVIP03o`gF0ol3IP03ofIV00IV1Ol20003o`0001d0
000S0003o`0000l000?40?l01<@00ooFeP0VeP03olC400G400?oa<@00olCeP03ofIV00EV0ol5a0;o
1VH2o`_F1Ol7IP03ofIV00?o0mH3a0Go7P0002<00_l?0005a0000?l01<@2oacF1Ol6eP03olC400;4
0_l00lCoo`0GeP03ofIV00?o0]H00oo4a005a0Co16H00ooFeP06eP?o1FH2o`IV0_l7eP?40_l20003
o`0001/0000S0003o`0000h000?400000`02o`?400?oe]H05MH4o`EV00?oe]H01=H4o`G400?oe]H0
5MH2o`KF00?oa<@00ol01=Koe_l6IP03omKF00KF00?oIVH01VH3o`gF0_l00lCoo`020003o`0001X0
000S0003o`0000h000?400001@001Oo4a<Co01SF00?oIVH01FH2o`KF00?oa<@01L@2oakF0_l4eP04
omKFo`=V0_l00fKoo`07eP03ofIV00?o0fH00ooFeP0=eP?41OlK00008`000ol0000>0003a00000H0
00Coa<C40_lGeP03ofIV00?o0fH00ooFeP04eP03olC400?o0l@00ooFeP0QeP04omKFeP?o1FH2o`KF
0_l7IP03omKF00gF0l@2o`8000?o00006000028000?o00003`000l@0000700;o0l@00ooFeP0EeP;o
1fH00ooFeP04eP;o1l@00ooFeP0PeP03omKF00;F00?oIVH01VH00ooFeP04eP03ofIV00IV00?oe]H0
3MH2o`;41?lI00008P000ol0000?0003a00000T000Goa<C4o`0HeP03ofIV00EV00?oe]H01MH00oo4
a005a003omKF01oF00?oe]H00mH00omVIP03o`=V00?oe]H01=H00omVIP03o`=V00?oe]H03MH4a003
o`3o01T0000R0003o`0000l000?400002`02o`03a?oo01OF00?oIVH00ol:ePCo1<@00ooFeP0NeP04
omKFePGo1fH00ooFeP04eP;o1fH00ooFeP0=eP?40olI00008P02oa0000?4000030001?o4a<@2oa?F
1Ol?eP03olC400C400?oe]H07MH4o`EV00?oIVH01FH00ooFeP05eP03ofIV00EV0_l;ePGo0]H00ol0
000G00008P000ol0000?0003a00000d000?oa<@00/@00ooFeP09ePOo1FH00ooFeP0=eP04olC4a0;o
00?4ool06]H4o`03I_mV00IV1?l;ePGo1FH01?oFe]H7o`?40ol00`3o000H00008P000ol0000?0003
a00000l00_l2a003omKF00GF0ol5IP03ofIV00EV00?oe]H03MH3o`G400?oe]H04]H5o`=V00CoIVKo
0VH3o`gF0ol2IP03ofIV00IV0ol3a0Co0/@00ol000030003o`0001H0000R0003o`0000l000?40000
40001Oo4a<Co00SF00?oIVH016H00omVIP03oa;F00?oa<@01L@2o`kF1?l5IP04ofIVo`=V0_l;ePGo
1VH00omVIP03o`O400?o00002P000ol0000F00008P000ol0000>0003a000018000Coa<C40_l7eP04
ofIVIP;o00=Vool05]H00oo4a003o`?400?oe]H01=H2o`OF00CoIQmO16H3o`[F1_l5IP03ofIV00AV
0_l4a0Co3`000ol0000F00008@000ol0000?0003a000018000?4ool00l@00ooFeP05eP?o7=H2o`O4
00?oe]H00ol2IP03omKF00?F0al00elO7`02o`?F00?oe]H00mH5o`AV0ml5IP?o1<@3o`030<@00180
00?o00005P00024000?o00003`000l@0000B0004a000o`?400?oe]H09MH2o`K40_l6IP09omIO7elO
GamO008O00=Oe]H00]H01?oFe_l4W`03ofIV00=V0ml00ioOo`02o`C400Coa<Co10000l@0000A0003
o`0001H0000Q00;o40000l@0000B0003a00000800_l00lCoo`0VePCo1FH00omVIP02IP037elO00@O
1=H47`?F00?oWil019l035ooI]nOgioOWmnOg`;41?l80003a000014000?o00005P00024000?o0000
3`000l@0000B0003a00000@000Coa<Co8]H3o`9V00?oIVH01FH00omOG`03G`037elO00OF00NOGelO
gmko00:O00?OWml01]l01mkOa<Cogil00]l<0003a000014000?o00005P00024000?o00003`000l@0
000A0003a00000D000Coa<C40_l;ePGo3]H2o`IV00?oIVH00ol2a08O0Ul00imOeP08eP04WenOG`;O
00?ogml01]l00ioOg`03gP05o`00gil00]l<0003a000010000?o00005P00024000?o00003`000l@0
000A0003a00000H00_l3a003omKF00GF0ol5IP04omKFePGo1mH00omVIP04IP;o1L@3G`03WenO009O
1mH4G`03gmko00OO00IOWeoNgmh3g`0609nOgioO1004gP<000?4000040000ol0000F00008@000ol0
000?0003a000014000?4000020001Oo4a<Co00OF00?oIVH01FH3o`EV00?oe]H01MH3o`GF00?oa<@0
0/@8G`03eUnO00IO0il03Mkog]oNWeoOg]oNgmh00]l00mkOgP03g`04g]oNg`ON0`000l@0000A0003
o`0001D0000Q0003o`0000l000?400004@000l@0000:00;o00?4ool01]H00omVIP03o`=V00?oIVH0
16H00ooFeP0=eP?o00C4GamO0Ql01YmOWenOG`:O00UOWenOa5nOGol03Mh00moNg`0;gP040=kAgP80
00?400004@000ol0000E00008@000ol0000?0003a000014000?400002`001Oo4a<Co00KF0_l7IP04
ofIVIP;o00=VomH03mH01?o4a<@3G`05a9mOWel00/@3o`;4013o09nOomkOg]oNg`3Og]nO0`001moN
gmkOgP000mh40006dMkAgP344`000ol0000E000080000ol0000?0003a000018000?4000030001?o4
a<@2o`KF0_l6IP?o5MH01_o4a?mO7`K400?o00001`001?oNg]h;00?N3@001=kAg/@C0003o`0001D0
000P0003olCo00l000?400004P000l@0000=00;o0l@00ooFeP05eP?o6MH5o`?41?l<0003ol@001d0
00?NdMh04`000ol0000E00004P03o`@00_l50003o`3400l000?400004P000l@0000?0005olC4a?l0
7MH5o`?40olB0003ol@001d000CAg]7N4P000ol0000E00004`000ol000020004o`00o`@000?o0000
0/@=0003a000018000?400003`001L@0ooo400;o6=H3o`;40ol2a003o`0001<000?oa0007`001=kA
g]h@0003o`0001D0000C0003o`00008000Co003o10000ol000020003a00000X000?400004P000l@0
000?0004a000o`?400?oe]H04=H5o`C400?o00006@000oo4000O0004a=kNdA0000?o00005@0001<0
00?o00000P001?l00?l40003o`0000<00/@:0003a000018000?400003`001L@0003o00?40_l;ePGo
0l@4o`030<@001/000?oa0007`001<CNg]4@0003o`0001D0000C0003o`00008000Co003o10000ol0
00050003a00000L000?400004P000l@0000?0003a00000800_l3a0;o0mH6o`?40ol70003a00001X0
00?oa0007`001M7NdMkA010000?o0000500001800_l500;o1@000ol0000600;41`000l@0000B0003
a00000l000?4000010000oo4a002a0?o0l@3o`;400?o000020000l@0000J0003o`3401`01]401=kA
dMh>0003o`0001@0000O0003o`0000T000?4000010000l@0000A0003a000010000?400001P02o`03
e/C400?400?o00003P000l@0000J0003o`3401P000[Ag]kAg]7NdL@01=h>0003o`0001@0000O00;o
2`02a0@000?400004@000l@0000@0003a00000L01OlC0003a00001X000?o0<@05@001=7NdMh4d@<0
00?400000m4>0003o`0001@0000O0003o`0000`000G40000a00C0003a000010000?400001`000ol0
000E0003a00001X000?o0<@04`001]kAg]7Nd@L000?400004@000ol0000D00007`000ol0000=00?4
50000l@0000?0003a00000P000?o00005@000l@0000J0003o`3401<000?Ag]402P000l@0000A0003
o`0001@0000O0003o`0000l000?400004P000l@0000?0003a00000P000?o00005@000l@0000J0003
o`3401@000?Ag]402@000l@0000A0003o`0001@0000O0003o`0000l00l@B0003a00000l000?40000
20000ol0000E0003a00001X000?o0<@05@03d@P000?400004@000ol0000D00007`000ol0000?0004
a000a14000?400003`000l@000080003o`0001D000?400006P000ol0a00F0003dMkA00L000?40000
4@000ol0000D00007`000ol0000?0004a00000;43`000l@0000?0003a00000P000?o00005@000l@0
000J0003o`3401H000CNdMkA1004d@03d000010000?o00004`0001h000?o000040000l@000030003
a00000`000?400003`000l@000080003o`0001D000?400006P000ol0a00H00WA00?@d@004@000ol0
000C00007P03oa0000?400001002a0`000?400003`000l@000080003o`0001D000?400006`000oo4
000H00GA00?@dM000]4B0003o`0001<0000N0003o`00010000?400001P000l@000090003a00000l0
00?4000020000ol0000E0003a00001/000?oa0006002d0;A00G@dM3Ad00C0003o`0001<0000N0003
o`00010000?400001`02a0T000?400003`000l@000080003o`0001D000?400006`000oo4000H00?A
00?@d@000P000l@0000A0003o`0001<0000N0003o`00010000?400002@000l@000060003a00000l0
00?4000020000ol0000E0003a00001/000?oa0006@001=3Ad=430003a000014000?o00004`0001h0
00?o00003`000l@0000;00;41@000l@0000@0003a00000P000?o00005@000l@0000K0003ol@001/0
00?@dM400P000l@0000A0003o`0001<0000N0003o`0000l000?400003@000l@000020003a0000100
00?4000020000ol0000E0003a00001/000?oa0007002d@8000?400003`02a003o`0001<0000N0003
o`0000l000?400003P02a08000?4000040000l@000080003o`0001D000?400006`000oo4000I0005
dM3Ad=400P000l@0000:00G40P000ol0000C00007@000ol0000@0003a000010000?40<@04P000l@0
00070003o`0001H000?400006`000oo4000E00WA0P000l@0000500G420000ol0000B00007@03oa00
00?400004@02a18000?400001`000ol0000F0003a00001/000?oa0004P03d005dM3Ad=401P000l@0
0005a0d000?o00004P0001d000?o000040000l@0000B00;44@000l@000070003o`0001H000?40000
6`000oo4000>00;A00?@dM401=4700G44P000ol0000B00007@000ol0000@0003a000018000C40<C4
3`000l@000070003o`0001H000?400006`000oo4000<0003d=7@00C@1`04a08000?400004P000ol0
000B00007@000ol0000@0003a000018000G40000a00>0003a00000L000?o00005P000l@0000K0003
ol@000P000WAd=7@dM3Ad=401005a0H000?400004P000ol0000B00000`03oaL000?o000040000l@0
000B0003a00000800/@<0003a00000L000?o00005P000l@0000G0007h=3@d?l0a00500C@00CAd=7@
0`05a0/000?400004P000ol0000B00000`001?l00?lF0003o`00010000?400004P000l@000040003
a00000T000?400001`000ol0000F0003a00001@01n001?o@a003d007dM3Ad=7@0005a10000?40000
4P000ol0000B00000`000ol0000G0003o`00010000?400004P000l@0000500;42@000l@000070003
o`0001H000?400003`002N3@h=3Pd>3@h0030003om3P00K@00<0a<@00/@E0003a000018000?o0000
4P0000<000?o00005P000ol0000@0003a00001<000?400001`000l@000060003a00000L000?o0000
5P000l@0000<00;@1n060004om3Pd0;P00C@a<C46P000l@0000A0003o`000180000200Co5P000ol0
000@0003a00001<000?400002002a0D000?4000020000ol0000F0003a00000`000CPd=3P2@000n3@
o`05d003h00001/000?400004P000ol0000A00000`000ol0000F00;o4@000l@0000C0003a00000X0
00?400000P000l@000080003o`0001H000?4000030000m3Pd00700?400G@h?oPd002h003d00001`0
00?400004P000ol0000A00000`000ol0000F0003o`00010000?400004P000l@0000<00;40P000l@0
00080003o`0001H000?400002P000n3@h003h0030<C400?40`02d003o`34024000?400004P000ol0
000A000070000ol0000@0003a000018000?400003P000l@0a00:0003o`0001H000?400001`07h004
d>3Pd0T000?o0<@08@000l@0000B0003o`000140000L0003o`00010000?400004P000l@0000?00;4
2P000ol0000F0003a00000800n001]3Pd>3@h0;400<0h=000^090003o`34024000?400004P000ol0
000A000070000ol0000@0003a000018000?400004002a0T000?o000040000d5<@@030003a03P00SP
1`000n3@00090003o`34024000?400004P000ol0000A000070000ol0000@0003a00000T000E<P800
P003C003P<@000X00d`40004a034a0L000?o00004004@@06CT5>@Di10^0H0003o`34024000?40000
4P000ol0000A00006`000ol0000A0003a00000T01h000db0C00;0007@Da<C45<@@02C003@@3400H0
00?o00004008@@03CT4000<00Th2@A<000?oa00080000l@0000B0003o`000140000K0003o`000140
00?400001P03P0]<00>008000X050008C45<@Da1C442C0800/@40003o`0000h000X8@Di1CT5>@D`0
0T401Di1CT5>009100=>00004@000oo4000P0003a000018000?o00004@0001/000?oa?l040000l@0
000700J014`01@20C81<00:00/002Tb0C81<@Da1C442C008@Da1C45<0<@30003o`0000801442C00@
045<@Da1C45<@D`8@Dc400M>00<0CT400`000d5>@@02CP/000?oa00080000l@0000C0003o`000100
000=00Co0`02o`D000Co0<C43`000l@0000700J000@0P8300h02C003P4a<00=<00N0C81<P4b0009<
00H0a011C442C00;045<@Da1C45<@D`00T401da1C45<@D`00d460005a01>@Dh01@000d5>CP05CP03
Cdh000X000?oa00080000l@0000C0003o`000100000>0003o`00008000Co003o10001Ol0003400h0
00?400001`000h1<P0060004P<20`0:000I<P4b0C<03C003P<2000?000<0a0000P0=@@08a011C45<
@@03h0P000?400001`001Ti1CT5>@@8000Q>C`00Cdi?CP9?0`000oo4000Q0003a000018000?o0000
400000l000Go0000o`020003o`00008000?o00000P02a0`000?4000040001L20`83000=<0l001830
`803`003P<2000?000L1`45<@Da1008000?oa000200420?P1`000l@0000700=>1@08CP03Cdh00080
00?oa0008@000l@0000B0003o`000100000@0004o`00o`8000?o00000P000ol0000400;42P000l@0
000C0003a00000<000G0P<20`004P0030<3000?000<1`0400P440003o`0000@02N0420D000?40000
3`001Dm>Cdi?00<00Tl01Dh00?o4028000?400004P000ol0000@00003@001?l00?l20004o`00o`@0
00?o00001P000l@000070003a00001<000?400000`002<20`8000L203L0010400?l300032>0800D8
10001>08h>050003a00001L000M>Cdi?0?o4028000?400004P000ol0000@00003P02o`@00_l40003
o`0000P00/@70003a000018000?400001`020@;000<1`<001l0200@10/002>08h0SP2>08200220H0
00?400006@03CP03ol@0024000?400004P000ol0000@00006P000ol0000:00;41@000l@0000B0003
a00000L01@401l01`07020400/020@04`041`0810PP00n08000C0003a00001X00Tl00oo4000Q0003
a000018000?o0000400001X000?o000030000l@000020003a000018000?400001`060@03`07000[0
0P401Ol820SP01@000?400006@001Di?C_o4028000?400004P000ol0000@00006P02o`h00/@20003
a000018000?400002P000`480@080@04`0480@H800CP2>084P000l@0000E00I?00A>o`348@000l@0
000C0003o`0000l0000J0003o`0000l00l@D0003a00000/00P43`0030<@100D12PP00n00000@0003
a00001<000M?CTi?CTm>008000?o0<@08@000l@0000C0003o`0000l0000J0003o`0001000/@D0003
a000014000?420P00`P01P482040o`<000<8h0P04P000l@0000C00=?1P000ol0a00Q0003a00001<0
00?o00003`0001X000?o000040001<@0a<@B0003a000014000K400000@P20@<000?o00005P000l@0
000C009?1`000ol0a00Q0003a00001<000?o00003`0001X000?o000040001<@00002a10000?40000
40000l@00003008810000ol0000F0003a000014000@oCdm?1`000ol0a00Q0003a00001<000?o0000
3`0001T000?o00004@000l@000030003a00000d000?4000040000l@000090003o`0001H000?40000
3@08C`L000?o0<@08P000l@0000B0003o`0000l0000I0003o`00014000?400001002a0d000?40000
40000l@000080003o`0001L000?400002`001cm??dloCcl02P000ol0a00R0003a000018000?o0000
3`0001T000?o00004@000l@0000600;42`000l@0000@0003a00000P000?o00005`000l@0000;0003
?dm?00h000?o0<@08P000l@0000B0003o`0000l0000I0003o`00014000?4000020000l@000080003
a000010000?4000020000ol0000G0003a00000/000<oC`003P000ol0a00R0003a000018000?o0000
3`0001T00_lB0003a00000T00/@80003a000010000?4000020000ol0000G0003a00000T013l?0003
o`34028000?400004`000ol0000>00006@000ol0000A0003a00000/00/@60003a000010000?40000
20000ol0000G0003a00000D000PoCcm??dloC`l000?o0<@08P000l@0000C0003o`0000h0000I0003
o`00014000?400003@000l@000020003a000014000?4000020000ol0000G0004a000009?1clB0003
o`34028000?400004003a003o`0000h0000I0003o`00014000?400003P02a08000?400004@000l@0
00080003o`0001L000E??dloC`02?`03Ccl001D000?o0<@08P000l@0000;00G40`000ol0000>0000
60000ol0000A0003a00001400l@C0003a00000P000?o00005@07Ca/000?oa0008@000l@0000600G4
20000ol0000>000060000ol0000A0003a00001<000?400004@000l@000080003o`0001D000=??cl0
7`000oo4000Q0004a00000G43@000ol0000>000060000ol0000A0003a00001<00l@A0003a00000P0
00?o00005@001DloCcm?01d000?oa0007`06a18000?o00003P0001P000?o00004@000l@0000C0003
a00000;43`000l@000080003o`0001L000A??dlo70000oo4000J00G40P000l@0000C0003o`0000h0
000H0003o`00014000?400004`000l@000020003a00000`000?4000020000ol0000G0005a01??dl0
6`000oo4000E00G420000l@0000B0003o`0000h0000H00;o4P000l@0000C0003a00000<00/@<0003
a00000P000?o00005`000l@0?`04?aT000?oa0003`06a0d000?400004`000ol0000=000060000ol0
000A0003a00001<000?400001@02a0X000?4000020000ol0000G0008a00004loCcl40003?dlo008o
3`000oo4000:00G44`000l@0000C0003o`0000d0000H0003o`00014000?400004`000l@000070003
a00000L000?4000020000ol0000G0003a00000<00Sl00dlo?`06?`l000?oa0001@05a1P000?40000
4`000ol0000=000060000ol0000A0003a00001<000?400002002a0L000?4000020000ol0000G0003
a00000@000M??dloCcl000<o3`000oo40005a1d000?400004`000ol0000=00005`000ol0000B0003
a00001<000?400002P02a0D000?4000020000ol0000G0003a00000@00cl40005;cl_?bl02P03a003
olC4028000?400004`000ol0000=00005`000ol0000A0003a00001@000?4000030000l@000020003
a00000P000?o00005`000l@0000=00@o1005a0<000?o0<@08P000l@0000C0003o`0000d0000G0003
o`00014000?400004`000l@0000>00;40P000l@000080003o`0001L000?400003`000blo?`03a0D0
1Ol00l@0000P0003a00001<000?o00003@0001L000?o00004@000l@0000C0003a00001000l@:0003
o`0001L000?400002`001l@_?blo;cl00`05o`D000?o000080000l@0000C0003o`0000d0000G0003
o`00014000?400004`000l@0000B0003a00000P000?o00005`000l@0000500?400Lo;cl_?blo00Ko
2P000lCoo`0P0003a00001<000?o00003@0001L00_lB0003a00001<000?400004@001<@0a<@80003
o`0001L000?400001L@30003;coo00Co40001<@00?lO0003a00001@000?o0000300001L000?o0000
4@000l@0000C0003a000014000C400000/@60003o`0001D01L@500Go0SlC0004a00000;o7@000l@0
000D0003o`0000`0000G0003o`00014000?400004`000l@0000A0003a00000<000?400000`000ol0
000?00K40P000l@0o`05o`D000<o;cl04P000l@000030003o`0001/000?400004`000ol0000<0000
5P000ol0000B0003a00001<000?400004@000l@0000400;40`000ol0000:00G41@05o``00Sl00bl0
000?0003a00000@00_lK0003a00001<000?o0000300001H000?o00004P000l@0000C0003a0000140
00?400001P02a0030?l000H01L@400Ko0`000l@0000800@_00<o;`0040000l@000060003o`0001P0
00?400004`000ol0000<00005P000ol0000B0003a00001<000?400004@000l@000080004a?l000G4
1005o`T000?4000010000cl_?`07?a4000?400001`02oaP000?400004`000ol0000<00005P000ol0
000B0003a00001<000?400004@000l@000090003olC400@01Ol>0003a00000@01BlF0003a00000T0
00?o00005@000l@0000C0003o`0000`0000F0003o`00014000?4000050000l@0000A0003a00000T0
1olC0003a00000@000D_?blo;`0F0003a00000X00_lE0003a00001<000?o0000300001H000?o0000
4@000l@0000D0003a000014000?400001@05oaT000?400001P04?aD000?4000030000ol0000B0003
a00001<000?o0000300001H000?o00004@000l@0000D0003a000014000?40?l01Ol40003o`0001L0
00?400002003;a@000?400003@02oa8000?4000050000ol0000;00001`03o`@00_l60003olCo0140
00?400004`000l@0000?00Go2P000ol0000G0003a00000H000Do;clo;`0D0003a00000l000?o0000
3`000l@0000D0003o`0000/0000:0004o`00o`8000?o00000P000ol00002a10000?400004`000l@0
000:00Go0`000l@000090003o`0001L000?400000`001cl_?blo;cl05@000l@0000@00;o3`000l@0
000D0003o`0000/0000:0004o`00o`8000?o00000P000ol0000200;43P000l@0000C0003a00000@0
1_l80003a00000P000?o000060002/@0;cl_?blo;clH0003a000018000?o000030000l@0000D0003
o`0000/0000800;o0`001?l00?l40003o`0000@00/@<0003a00001<000?40?l01?l>0003a00000P0
00?o00005P002Cl_?blo;cl_?`0K0003a00001<00_l<0003a00001@000?o00002`0000X000Co003o
0P000ol000020003o`0000H00/@:0003a00000l01_lC0003a00000P000?o000050001blo;cl_?bl0
7`000l@0000E0003o`0000T000?4000050000ol0000;00001`03o`@00_l50003o`0000P000?40000
1`000l@0000:00Go10000l@0000B0003a00000P000?o000050001Cl_;`34024000?400005P02o`X0
00?400004`000ol0000;00005@000ol0000900;41`000l@0000500Go2@000l@0000B0003a00000P0
00?o00005005;b4000?4000060000ol000070003a00001<000?o00002`0001D000?o00002`02a0@0
00?400001_l>0003a000018000?4000020000ol0000F0003?blo008_7`000l@0000I00;o1`000l@0
000C0003o`0000/0000E0003o`0000d00/@5oa@000?400004P000l@000080003o`0001P012lO0003
a00001X000?o000010000l@0000D0003o`0000X0000D0003o`0000X01_l3a1H000?400004P000l@0
00080003o`0001P000?402l00RlN0003a00001/000?o00000`000l@0000D0003o`0000X0000D00?o
1@05o`P00/@E0003a000018000?4000020000ol0000H0003a00000@_00<0;bl00bl00al0000C0003
a00001`00_l30003a00001@000?o00002P0001@000?o00001Ol=0004a034a1<000?400004P000l@0
00080003o`0001P000_400007blO;al_7`03;`037`00018000?400007P001?l00<@F0003o`0000X0
000D00?o4P001<@00002a14000?400004@000l@000090003o`0001P000C400001Bl300047blO;a<0
00?400007`02o`03a00001@000?o00002P0001H00_lA0003a00000<00/@?0003a000014000?40000
2@000ol0000H0003a00000/000<O;al04P000l@0000Q0003o`0001@000?o00002P0001P00_l?0003
a00000D00/@<0003a000018000?400002@000ol0000H0003a00000`000<_7al04@000l@0000Q0003
a?oo01@000?o00002P0001X00_l=0003a00000L000?400002@000l@0000B0003a00000T000?o0000
60000l@0000900037blO00<_4@000l@0000Q0004a000oa<000?o00002P0001`00_l;0003a00000P0
0/@90003a000018000?400002@000ol0000H0003a00000D000<O;bl01alA0003a000024000C40000
0_lA0003o`0000X0000N00;o2@000l@0000:00;41`000l@0000B0003a00000T000?o000060000l@0
0005008O0Rl00al0000D0003a000028000?400000P000ol0000?0003o`0000T0000P00;o1P000l@0
000=00;41@000l@0000B0003a00000T000?o000060000l@0000500D_5P000l@0000R0003a00000<0
0_l?0003o`0000T0000R00;o10000l@0000?00;40`000l@0000B0003a00000T000?o000060000l@0
000300@O00<_7bl00QlD0003a000028000?400001@000ol0000900?400?o00002@0002@00_l20003
a00001400/@00`34000C0003a00000T000?o000060002/@002lO;al_7bl27`03;al_01@000?40000
8P000l@0000600;o0`06a0<000?o00002@0002H00_l00l@0000C00;450000l@000090003o`0001P0
00?47al011l300@O00<_00004P000l@0000R0003a00000D00l@00oo4a0090003o`0000T0000X00;o
5@03a18000?400002@000ol0000H0004a1lO;`P000<_7`0050000l@0000R0003a03400G41002o`T0
00?o00002@0002X00_lC0003a00000;440000l@000090003o`0001P000?4000080000l@0000N00K4
30000ol000060003o`0000T0000/00;o4@000l@000020003a00000d000?400002@000ol0000H0003
a000020000?400005`07a0@000?400003002o`H000?o00002@0002h00_l?0003a00000<00/@=0003
a00000T000?o000060000l@0000P0003a00001401/@;0003a00000h000?o00000`000ol000090000
<002o`d000?400001@02a0/000?400002@000ol0000H0003a000020000?400002`06a14000?40000
3`02o`@000?o0000200003800_l:0003a00000P00/@90003a00000T000?o000060000l@0000P0003
a00000D01/@G0003a000014000Go0000o`0:0000=002o`P000?400002P02a0L000?400002@000ol0
000H0003a000020000?40<@01L@M0003a00001800_l00`3o00090000=P02o`H000?400003002a0D0
00?400002@000ol0000H0003a00001`01/@T0003a00001<00_l:0000>002o`@000?400003P02a0<0
00?400002@000ol0000H0003a00001H01/@50003a000028000?400004@04o`X0000j0005o`000<@0
4P02a0030<@000X000?o000060000l@0000@00K42`000l@0000R0003a00000/01_l>0000>`02o`03
0<@001<00/@;0003o`0001P000?400002P06a14000?400008P000l@0000400Oo500003d00_lE00?4
2@000ol0000H0003a00000@01/@G0003a000028000?4ool01?lK0000?`02oa8000G40000a0080003
o`0001P01l@M0003a00001d01_lQ0000@@02oa0000?400000P02a0D000?o00004`07a2<000?40000
5`06obL0001300;o3P000l@0000400;40`000ol0000=00K41P000l@0000Q0003a00001401_l]0000
A@02o``000?400001P02a0030?l000P01/@<0003a000024000?400002P07oc<0001700;o2P000l@0
00080003a?l000801/@B0003a000024000?400001006ocX0001900;o20000l@000090004olC4a1P0
00?400008@000lCoo`04od00001;00;o1P000l@000090003o`0001T000?400007006odH0001=00;o
10000l@000090003o`0001T000?400005P06od`0001?00;o0P000l@000090003o`0001T000?40000
3`07oe80001A00;o00?400002@000ol0000I0003a00000T01_mI0000D`02o`X000?o00006@000l@0
000300KoG`0005D00_l80003o`0001T01_mU0000E`02o`H000?o00004`06of/0001I00;o10000ol0
000<00OoL@0005/00_l20003o`0000H01_mh0000G@03o`801_mn0000G`03oh@0003V0000iP000>H0
003V0000iP000>H0003V0000iP0005`000?o00009`000ol0001M0000=`04o`<01?l0103oo`02o`80
0_l300?o0`03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go
0P03o`<00_l400?o0P03o`@00_l^0000=P001Ol0003o008000?o00000`001?l00?l300;o1P000ol0
00030003o`00008000?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o000010000ol0
00070003o`0000D000?o00000P001?l00?l200;o1@000ol000040004o`0000;o;P0003H000?o0?l0
0_l200Go00D0o`00o`0;0004o`0000?o40001Ol0003o008000Co003o0`000ol000060003o`0000h0
00?o00001@000ol000020003o`0000P01?l50003o`000340000f0003o`0000@000Oo0000o`3o0080
00?o00001P03o`<000Co003o40001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003
o`00008000?o000020000ol0o`0300?o=00003H000Go0000o`0300?o00<0ool00ol80003o`0000<0
00Co003o40000ol00005o`<01?l80003o`0000h000?o00001002o`<01?l80003o`3o00<000?o0000
=00003L01?lD00Co0`02o`l01Ol;0003o`0000D00_l?00Go2@000ol0000900;o0`04oc<0001f00;o
8@000ol000020003o`0004D0003V0000\
\>"],
  ImageRangeCache->{{{0, 229}, {229, 0}} -> {0.11492, -0.0286817, 0.00313225, 
  0.00486691}},
  CellTags->"AntTracker3D - Gen 59"],

Cell[TextData[ButtonBox["AntTracker Examples ...",
  ButtonData:>"AntTracker3D - Gen 0",
  ButtonStyle->"Hyperlink"]], "Text",
  TextAlignment->Center],

Cell[CellGroupData[{

Cell["Introduction", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "This notebook is the original version used to analyze the evolved ",
  StyleBox["AntTracker",
    FontSlant->"Italic"],
  "  programs."
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
The evolved programs are discussed under the following \
aspects:\
\>", "Text"],

Cell[TextData[{
  "\[Bullet] ",
  ButtonBox["Fitness graphs",
    ButtonData:>"Fitness chart 3D - Part 1",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "\[Bullet] ",
  ButtonBox["Behaviour",
    ButtonData:>"AntTracker3D - Gen 0",
    ButtonStyle->"Hyperlink"],
  " of the evolved programs"
}], "Text"],

Cell["\<\
\[Bullet] Evolution of the champ programs\
\>", "Text"],

Cell[TextData[{
  "A thorough description of this evolution example can be found in the book \
",
  StyleBox["Principia Evolvica",
    FontSlant->"Italic"],
  ", Chapter 10.5."
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Packages and Notebooks", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Basic directory", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "IEC-Evolvica.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[BoxData[
    \(SetDirectory[\[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
"\<Chapters\>", \[IndentingNewLine]"\<08-AdvancedGP\>", "\<AntTracker\>", \
"\<Packages\>"}]]\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["System Defaults", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Print a message whenever a new symbol is created:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Off[General::newsym]", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["On[General::stop]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["On::none: Message General::stop not found.", "Message",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Imported Packages and Notebooks", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["General packages", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Needs[\"Statistics`DescriptiveStatistics`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"LinearAlgebra`CrossProduct`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"DiscreteMath`Tree`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Graphics`\"];", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`Shapes`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Needs[\"Graphics`Graphics3D`\"];
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Special notebooks", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Get[ 
     \"AntTrackerInterpret-Wall.m\" 
   ]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics programs", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Fitness charts", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\

fitnessChart[fitnesses_List] :=
Module[{},
  (**
  BarChart[Reverse[Sort[fitnesses]],
    BarEdges -> True,
    BarLabels -> 
      Append[Table[\" \",{Length[fitnesses]-1}],
        Length[fitnesses]],
    BarSpacing -> Automatic,
    BarStyle -> (GrayLevel[0.0]&),
    BarOrientation -> Horizontal,
    DefaultFont -> {\"Helvetica\",12},
    PlotLabel -> \"Sorted Fitnesses Histogram\"
  ];
  **)
  
  ListPlot[Reverse[Sort[fitnesses]],
    PlotJoined -> True
  ];
  
]; (* end module *)\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  "\nfitnessChart3D[fitnesses_List,opts___] :=\nModule[{l,r,\n        \
theFitnesses,\n        maxLength,\n        gen =\n          DisplayGeneration \
/. {opts} /. Options[fitnessChart3D],\n        genIndices =\n          \
GenIndices /. {opts} /. Options[fitnessChart3D],\n        genAxisTicks\n      \
 },\n\n  ",
  StyleBox["(* First scale all lists to the same length ... *)",
    FontSlant->"Italic"],
  "\n  \n  theFitnesses = fitnesses;\n  \n  maxLength = \
Max[Map[Length[#]&,theFitnesses]];\n  \n  theFitnesses =\n    Map[\n      \
If[(r = maxLength - Length[#]) > 0,\n        Join[#,Table[-1.,{r}]],\n        \
#\n      ]&,\n      theFitnesses\n    ];\n  \n  ",
  StyleBox["(* Graphics generation and display ... *)",
    FontSlant->"Italic"],
  "\n  \n  l = Length[theFitnesses];\n  \n  If[gen === {},gen = l-1];\n  \
If[genIndices === {},\n    genIndices = Range[l];\n    genAxisTicks = \
MapIndexed[{First[#2],#1}&,genIndices],\n    If[NumberQ[First[genIndices]],\n \
     genAxisTicks = Transpose[{genIndices,genIndices}],\n      genAxisTicks = \
genIndices\n    ]\n  ];\n  \n  If[l > 1,\n    \n    \
ListShadowPlot3D[theFitnesses,\n      ViewPoint -> {1.3, -2.4, 0.7},\n      \
Ticks -> {Automatic,genAxisTicks,Automatic},\n      Color -> True,\n      \
SurfaceMesh -> True,\n      ShadowMesh -> False,\n      PlotLabel -> \n       \
FontForm[\n         \"Sorted Fitnesses History, Gen. \" <> ToString[gen],\n   \
      {\"Helvetica-Bold\",12}\n       ],\n      PlotRange -> \
{All,All,{-25,44}},\n      FaceGrids -> {{-1,0,0},{0,1,0}},\n      Boxed -> \
False,\n      Axes -> True,\n      AxesEdge -> {Automatic,{1,-1},Automatic},\n\
      AxesLabel -> {\"Indiv.\",\"Gen.\",\"Fit.\"},\n      DefaultFont -> \
{\"Helvetica\",12},\n      Background -> GrayLevel[0.8]\n    ],\n    \n    \
BarChart[First[theFitnesses],\n      BarEdges -> True,\n      BarLabels -> \n \
       Append[Table[\" \",{Length[First[theFitnesses]]-1}],\n        \
Length[First[theFitnesses]]],\n      BarSpacing -> Automatic,\n      BarStyle \
-> (GrayLevel[0.0]&),\n      BarOrientation -> Vertical,\n      DefaultFont \
-> {\"Helvetica\",12},\n      PlotLabel -> \n        FontForm[\n          \
\"Sorted Fitnesses Histogram, Gen. \" <> ToString[gen],\n          \
{\"Helvetica-Bold\",12}\n        ],\n      PlotRange -> All,\n      \
Background -> GrayLevel[0.8]\n    ]\n  ];\n  \n]; (* end module *)"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[fitnessChart3D] =
{
  DisplayGeneration -> {},
  GenIndices -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualization examples ...", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "$basicDirectory = \"~/",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "/Working/AntTracker.adv/Examples/\";\n$basicExperiment = \
\"AntTracker-07-1i\";"
}], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["getFitnesses[$basicDirectory,$basicExperiment,85]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{45, 26, 1, 45, 45, 7, 45, 24.07692307692308, 11, 6, \
6, 38, 3, 38, 9, 2, 
 
  45, 2.2, 8, 45, 12, 45, 26, 9, 6, 9, 6, 11, 24.07692307692308, 45, 45, 
 
  3, 38, 17, 2, 24.07692307692308, 19, 2, 22, 45, 19, 2.846153846153846, 
 
  1.923076923076923, 26, 1., 45, 9, 45, 27.4, 26}\
\>", "\<\
{45, 26, 1, 45, \
45, 7, 45, 24.07692307692308, 11, 6, 6, 38, 3, 38, 9, 2, 
 
  45, 2.2, 8, 45, 12, 45, 26, 9, 6, 9, 6, 11, 24.07692307692308, 45, 45, 
 
  3, 38, 17, 2, 24.07692307692308, 19, 2, 22, 45, 19, 2.846153846153846, 
 
  1.923076923076923, 26, 1., 45, 9, 45, 27.4, 26}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["champPos = Position[%,45]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{1}, {4}, {5}, {7}, {17}, {20}, {22}, {30}, {31}, \
{40}, {46}, {48}}\
\>", "\<\
{{1}, {4}, {5}, {7}, {17}, {20}, {22}, {30}, \
{31}, {40}, {46}, {48}}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
showAnt[$basicDirectory,$basicExperiment,5,1,
  Generation -> True]
\
\>", "Input",
  AspectRatioFixed->True],

Cell["Ant: 1", "Print",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.359276 1.73825 0.004203 0.971509 [
[(Gen.5, Ind.1, Fit.12.)] .5 1 0 -1.5 Msboxa
[(5)] .22208 .10062 .837 1 Msboxa
[(10)] .37129 .06817 .79276 1 Msboxa
[(15)] .52449 .03486 .74852 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Msboxa
P
[(5)] .7152 .06936 -1 .37828 Msboxa
[(10)] .7916 .12855 -1 .36695 Msboxa
[(15)] .86445 .18501 -1 .35627 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88608 .10179 -1 .36805 Msboxa
P
[(0)] .09796 .15325 1 -0.38573 Msboxa
[(10)] .08166 .2985 1 -0.36305 Msboxa
[(20)] .06397 .45624 1 -0.33834 Msboxa
[(30)] .04469 .62815 1 -0.31133 Msboxa
[(40)] .02361 .81623 1 -0.28167 Msboxa
[(t)] -0.03846 .47163 1 -0.33899 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.5, Ind.1, Fit.12.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11976 .13514 m
.63111 .02429 L
s
P
p
.002 w
.23603 .10993 m
.243 .11459 L
s
P
[(5)] .22208 .10062 .837 1 Mshowa
p
.002 w
.38479 .07768 m
.39154 .08244 L
s
P
[(10)] .37129 .06817 .79276 1 Mshowa
p
.002 w
.53751 .04458 m
.54402 .04944 L
s
P
[(15)] .52449 .03486 .74852 1 Mshowa
p
.001 w
.26547 .10355 m
.26963 .10636 L
s
P
p
.001 w
.29507 .09713 m
.2992 .09995 L
s
P
p
.001 w
.32482 .09069 m
.32892 .09352 L
s
P
p
.001 w
.35472 .0842 m
.3588 .08704 L
s
P
p
.001 w
.41501 .07113 m
.41903 .074 L
s
P
p
.001 w
.44539 .06455 m
.44939 .06743 L
s
P
p
.001 w
.47594 .05793 m
.4799 .06082 L
s
P
p
.001 w
.50664 .05127 m
.51058 .05417 L
s
P
p
.001 w
.20673 .11628 m
.21094 .11906 L
s
P
p
.001 w
.17759 .1226 m
.18183 .12537 L
s
P
p
.001 w
.1486 .12888 m
.15286 .13164 L
s
P
p
.001 w
.56854 .03785 m
.57242 .04078 L
s
P
p
.001 w
.59974 .03109 m
.60359 .03403 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Mshowa
P
P
p
p
.002 w
.63111 .02429 m
.88606 .22165 L
s
P
p
.002 w
.69488 .07366 m
.68472 .07581 L
s
P
[(5)] .7152 .06936 -1 .37828 Mshowa
p
.002 w
.7712 .13274 m
.761 .13483 L
s
P
[(10)] .7916 .12855 -1 .36695 Mshowa
p
.002 w
.84399 .18908 m
.83375 .19112 L
s
P
[(15)] .86445 .18501 -1 .35627 Mshowa
p
.001 w
.71044 .0857 m
.70434 .08698 L
s
P
p
.001 w
.72585 .09763 m
.71974 .0989 L
s
P
p
.001 w
.74111 .10944 m
.735 .11071 L
s
P
p
.001 w
.75623 .12115 m
.75011 .12241 L
s
P
p
.001 w
.78603 .14422 m
.77991 .14547 L
s
P
p
.001 w
.80072 .15559 m
.7946 .15683 L
s
P
p
.001 w
.81528 .16686 m
.80915 .16809 L
s
P
p
.001 w
.8297 .17802 m
.82356 .17925 L
s
P
p
.001 w
.67917 .0615 m
.67308 .06279 L
s
P
p
.001 w
.66331 .04921 m
.65722 .05052 L
s
P
p
.001 w
.64729 .03681 m
.6412 .03812 L
s
P
p
.001 w
.85814 .20004 m
.852 .20126 L
s
P
p
.001 w
.87216 .2109 m
.86602 .21211 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88608 .10179 -1 .36805 Mshowa
P
P
p
p
.002 w
.11976 .13514 m
.04346 .82258 L
s
P
p
.002 w
.11823 .14888 m
.12837 .1467 L
s
P
[(0)] .09796 .15325 1 -0.38573 Mshowa
p
.002 w
.10209 .29436 m
.1123 .29229 L
s
P
[(10)] .08166 .2985 1 -0.36305 Mshowa
p
.002 w
.08455 .45235 m
.09484 .4504 L
s
P
[(20)] .06397 .45624 1 -0.33834 Mshowa
p
.002 w
.06544 .62454 m
.07581 .62274 L
s
P
[(30)] .04469 .62815 1 -0.31133 Mshowa
p
.002 w
.04453 .81294 m
.05498 .81129 L
s
P
[(40)] .02361 .81623 1 -0.28167 Mshowa
p
.001 w
.11511 .17705 m
.1212 .17575 L
s
P
p
.001 w
.11193 .20567 m
.11803 .20438 L
s
P
p
.001 w
.1087 .23475 m
.11481 .23348 L
s
P
p
.001 w
.10542 .26431 m
.11154 .26305 L
s
P
p
.001 w
.0987 .32491 m
.10483 .32368 L
s
P
p
.001 w
.09525 .35597 m
.10139 .35475 L
s
P
p
.001 w
.09174 .38755 m
.0979 .38635 L
s
P
p
.001 w
.08818 .41967 m
.09434 .41849 L
s
P
p
.001 w
.08086 .48559 m
.08704 .48444 L
s
P
p
.001 w
.07711 .51942 m
.0833 .51828 L
s
P
p
.001 w
.07329 .55384 m
.07949 .55272 L
s
P
p
.001 w
.0694 .58888 m
.07561 .58777 L
s
P
p
.001 w
.06141 .66085 m
.06764 .65979 L
s
P
p
.001 w
.0573 .69783 m
.06355 .69678 L
s
P
p
.001 w
.05312 .73549 m
.05938 .73446 L
s
P
p
.001 w
.04886 .77385 m
.05513 .77284 L
s
P
[(t)] -0.03846 .47163 1 -0.33899 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11823 .14888 m
.40213 .32966 L
s
P
p
.4 g
.002 w
.10209 .29436 m
.39803 .47072 L
s
P
p
.4 g
.002 w
.08455 .45235 m
.39361 .62294 L
s
P
p
.4 g
.002 w
.06544 .62454 m
.38882 .7877 L
s
P
p
.4 g
.002 w
.04453 .81294 m
.38363 .9666 L
s
P
p
.4 g
.002 w
.19031 .18033 m
.12919 .8612 L
s
P
p
.4 g
.002 w
.27489 .23452 m
.23116 .90714 L
s
P
p
.4 g
.002 w
.35572 .2863 m
.32778 .95067 L
s
P
.002 w
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.38336 .97571 L
s
.38336 .97571 m
.40251 .31629 L
s
.40251 .31629 m
.11976 .13514 L
s
.63111 .02429 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.63111 .02429 m
.11976 .13514 L
s
p
.4 g
.51275 .29471 m
.51327 .95771 L
s
P
p
.4 g
.65354 .26716 m
.67985 .93462 L
s
P
p
.4 g
.7978 .23893 m
.85127 .91086 L
s
P
p
.4 g
.40213 .32966 m
.88748 .23523 L
s
P
p
.4 g
.39803 .47072 m
.90247 .37874 L
s
P
p
.4 g
.39361 .62294 m
.91871 .53411 L
s
P
p
.4 g
.38882 .7877 m
.93634 .70288 L
s
P
p
.4 g
.38363 .9666 m
.95556 .88687 L
s
P
.40251 .31629 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.38336 .97571 L
s
.38336 .97571 m
.40251 .31629 L
s
p
.4 g
.23603 .10993 m
.51275 .29471 L
s
P
p
.4 g
.38479 .07768 m
.65354 .26716 L
s
P
p
.4 g
.53751 .04458 m
.7978 .23893 L
s
P
p
.4 g
.19031 .18033 m
.69488 .07366 L
s
P
p
.4 g
.27489 .23452 m
.7712 .13274 L
s
P
p
.4 g
.35572 .2863 m
.84399 .18908 L
s
P
P
p
.002 w
.40812 .32205 m .41584 .32699 L .40213 .32966 L p
.4 g
F P
s
P
p
.002 w
.40213 .32966 m .39438 .32473 L .40812 .32205 L p
.4 g
F P
s
P
p
.002 w
.88748 .23523 m .40213 .32966 L .11823 .14888 L p
.9 g
F P
s
P
p
.002 w
.42959 .32431 m .41584 .32699 L p
.40812 .32205 L .4 g
F P
s
P
p
.002 w
.40812 .32205 m .39438 .32473 L .38661 .31977 L p
.4 g
F P
s
P
p
.002 w
.43569 .31667 m .44336 .32163 L .42959 .32431 L p
.4 g
F P
s
P
p
.002 w
.40812 .32205 m .43569 .31667 L p
.42959 .32431 L .4 g
F P
s
P
p
.002 w
.38661 .31977 m .3788 .3148 L p
.40812 .32205 L .4 g
F P
s
P
p
.002 w
.3788 .3148 m .39257 .3121 L .40812 .32205 L p
.4 g
F P
s
P
p
.002 w
.45718 .31895 m .44336 .32163 L p
.43569 .31667 L .4 g
F P
s
P
p
.002 w
.46339 .31126 m .47102 .31625 L .45718 .31895 L p
.4 g
F P
s
P
p
.002 w
.43569 .31667 m .46339 .31126 L p
.45718 .31895 L .4 g
F P
s
P
p
.002 w
.4849 .31355 m .47102 .31625 L p
.46339 .31126 L .4 g
F P
s
P
p
.002 w
.39257 .3121 m .3788 .3148 L .37095 .3098 L p
.4 g
F P
s
P
p
.002 w
.49122 .30583 m .49881 .31085 L .4849 .31355 L p
.4 g
F P
s
P
p
.002 w
.46339 .31126 m .49122 .30583 L p
.4849 .31355 L .4 g
F P
s
P
p
.002 w
.37095 .3098 m .36307 .30479 L p
.39257 .3121 L .4 g
F P
s
P
p
.002 w
.36307 .30479 m .37689 .30206 L .39257 .3121 L p
.4 g
F P
s
P
p
.002 w
.51276 .30813 m .49881 .31085 L p
.49122 .30583 L .4 g
F P
s
P
p
.002 w
.51919 .30038 m .52674 .30541 L .51276 .30813 L p
.4 g
F P
s
P
p
.002 w
.49122 .30583 m .51919 .30038 L p
.51276 .30813 L .4 g
F P
s
P
p
.002 w
.54075 .30269 m .52674 .30541 L p
.51919 .30038 L .4 g
F P
s
P
p
.002 w
.37689 .30206 m .36307 .30479 L .35515 .29975 L p
.4 g
F P
s
P
p
.002 w
.54729 .29489 m .55479 .29996 L .54075 .30269 L p
.4 g
F P
s
P
p
.002 w
.51919 .30038 m .54729 .29489 L p
.54075 .30269 L .4 g
F P
s
P
p
.002 w
.35515 .29975 m .3472 .29468 L p
.37689 .30206 L .4 g
F P
s
P
p
.002 w
.3472 .29468 m .36106 .29193 L .37689 .30206 L p
.4 g
F P
s
P
p
.002 w
.56887 .29722 m .55479 .29996 L p
.54729 .29489 L .4 g
F P
s
P
p
.002 w
.57553 .28938 m .58299 .29447 L .56887 .29722 L p
.4 g
F P
s
P
p
.002 w
.54729 .29489 m .57553 .28938 L p
.56887 .29722 L .4 g
F P
s
P
p
.002 w
.4325 .29108 m .40463 .29658 L .38889 .28641 L p
.8 g
F P
s
P
p
.002 w
.57553 .28938 m .54729 .29489 L .53218 .2847 L p
.4 g
F P
s
P
p
.002 w
.36106 .29193 m .3472 .29468 L .33921 .2896 L p
.4 g
F P
s
P
p
.002 w
.59714 .29172 m .58299 .29447 L p
.57553 .28938 L .4 g
F P
s
P
p
.002 w
.33921 .2896 m .33119 .28449 L p
.36106 .29193 L .4 g
F P
s
P
p
.002 w
.33119 .28449 m .3451 .28171 L .36106 .29193 L p
.4 g
F P
s
P
p
.002 w
.60391 .28385 m .61132 .28896 L .59714 .29172 L p
.4 g
F P
s
P
p
.002 w
.57553 .28938 m .60391 .28385 L p
.59714 .29172 L .4 g
F P
s
P
p
.002 w
.46051 .28555 m .4325 .29108 L .41685 .28085 L p
.8 g
F P
s
P
p
.002 w
.38889 .28641 m .41685 .28085 L .4325 .29108 L p
.8 g
F P
s
P
p
.002 w
.53218 .2847 m .56051 .27914 L .57553 .28938 L p
.4 g
F P
s
P
p
.002 w
.62554 .28619 m .61132 .28896 L p
.60391 .28385 L .4 g
F P
s
P
p
.002 w
.41685 .28085 m .38889 .28641 L .37301 .27614 L p
.8 g
F P
s
P
p
.002 w
.63242 .27828 m .63979 .28342 L .62554 .28619 L p
.4 g
F P
s
P
p
.002 w
.60391 .28385 m .63242 .27828 L p
.62554 .28619 L .4 g
F P
s
P
p
.002 w
.41685 .28085 m .44494 .27528 L .46051 .28555 L p
.8 g
F P
s
P
p
.002 w
.56051 .27914 m .53218 .2847 L .51693 .27442 L p
.4 g
F P
s
P
p
.002 w
.3451 .28171 m .33119 .28449 L .32313 .27936 L p
.4 g
F P
s
P
p
.002 w
.65408 .28064 m .63979 .28342 L p
.63242 .27828 L .4 g
F P
s
P
p
.002 w
.32313 .27936 m .31504 .2742 L p
.3451 .28171 L .4 g
F P
s
P
p
.002 w
.31504 .2742 m .32899 .2714 L .3451 .28171 L p
.4 g
F P
s
P
p
.002 w
.37301 .27614 m .40105 .27054 L .41685 .28085 L p
.8 g
F P
s
P
p
.002 w
.66107 .27269 m .6684 .27785 L .65408 .28064 L p
.4 g
F P
s
P
p
.002 w
.63242 .27828 m .66107 .27269 L p
.65408 .28064 L .4 g
F P
s
P
p
.002 w
.51693 .27442 m .48865 .28 L .47318 .26967 L p
.8 g
F P
s
P
p
.002 w
.51693 .27442 m .54535 .26881 L .56051 .27914 L p
.4 g
F P
s
P
p
.002 w
.68275 .27506 m .6684 .27785 L p
.66107 .27269 L .4 g
F P
s
P
p
.002 w
.68987 .26708 m .69714 .27226 L .68275 .27506 L p
.4 g
F P
s
P
p
.002 w
.66107 .27269 m .68987 .26708 L p
.68275 .27506 L .4 g
F P
s
P
p
.002 w
.54535 .26881 m .51693 .27442 L .50155 .26404 L p
.8 g
F P
s
P
p
.002 w
.47318 .26967 m .50155 .26404 L .51693 .27442 L p
.8 g
F P
s
P
p
.002 w
.32899 .2714 m .31504 .2742 L .30691 .26902 L p
.4 g
F P
s
P
p
.002 w
.68987 .26708 m .66107 .27269 L .64633 .2623 L p
.8 g
F P
s
P
p
.002 w
.71157 .26946 m .69714 .27226 L p
.68987 .26708 L .4 g
F P
s
P
p
.002 w
.30691 .26902 m .29874 .26382 L p
.32899 .2714 L .4 g
F P
s
P
p
.002 w
.29874 .26382 m .31273 .26099 L .32899 .2714 L p
.4 g
F P
s
P
p
.002 w
.7188 .26143 m .72603 .26664 L .71157 .26946 L p
.4 g
F P
s
P
p
.002 w
.68987 .26708 m .7188 .26143 L p
.71157 .26946 L .4 g
F P
s
P
p
.002 w
.57391 .26317 m .54535 .26881 L .53006 .25838 L p
.8 g
F P
s
P
p
.002 w
.50155 .26404 m .53006 .25838 L .54535 .26881 L p
.8 g
F P
s
P
p
.002 w
.7188 .26143 m .68987 .26708 L .67522 .25663 L p
.8 g
F P
s
P
p
.002 w
.64633 .2623 m .67522 .25663 L .68987 .26708 L p
.8 g
F P
s
P
p
1 .015 0 r
.01 w
.63935 .27032 m
.66812 .26469 L
s
P
p
.002 w
.74053 .26382 m .72603 .26664 L p
.7188 .26143 L .4 g
F P
s
P
p
.002 w
.53006 .25838 m .50155 .26404 L .48602 .25357 L p
.4 g
F P
s
P
p
.002 w
.74788 .25576 m .75506 .26099 L .74053 .26382 L p
.4 g
F P
s
P
p
.002 w
.7188 .26143 m .74788 .25576 L p
.74053 .26382 L .4 g
F P
s
P
p
.002 w
.31273 .26099 m .29874 .26382 L .29053 .2586 L p
.4 g
F P
s
P
p
.002 w
.53006 .25838 m .55871 .25269 L .57391 .26317 L p
.8 g
F P
s
P
p
.002 w
.74788 .25576 m .7188 .26143 L .70425 .25093 L p
.8 g
F P
s
P
p
.002 w
.67522 .25663 m .70425 .25093 L .7188 .26143 L p
.8 g
F P
s
P
p
1 .03 0 r
.01 w
.66818 .26606 m
.69711 .26041 L
s
P
p
.002 w
.76963 .25816 m .75506 .26099 L p
.74788 .25576 L .4 g
F P
s
P
p
.002 w
.29053 .2586 m .28229 .25335 L p
.31273 .26099 L .4 g
F P
s
P
p
.002 w
.28229 .25335 m .29632 .25049 L .31273 .26099 L p
.4 g
F P
s
P
p
.002 w
.48602 .25357 m .51463 .24785 L .53006 .25838 L p
.4 g
F P
s
P
p
.002 w
.7771 .25006 m .78423 .25532 L .76963 .25816 L p
.4 g
F P
s
P
p
.002 w
.74788 .25576 m .7771 .25006 L p
.76963 .25816 L .4 g
F P
s
P
p
.002 w
.63145 .25181 m .60261 .2575 L .5875 .24697 L p
.8 g
F P
s
P
p
1 .045 0 r
.01 w
.69718 .26179 m
.72625 .2561 L
s
P
p
.002 w
.7771 .25006 m .74788 .25576 L .73343 .24521 L p
.8 g
F P
s
P
p
.002 w
.70425 .25093 m .73343 .24521 L .74788 .25576 L p
.8 g
F P
s
P
p
.002 w
.79888 .25247 m .78423 .25532 L p
.7771 .25006 L .4 g
F P
s
P
p
.002 w
.36904 .24962 m .34081 .25532 L .3245 .24477 L p
.8 g
F P
s
P
p
.002 w
.51463 .24785 m .48602 .25357 L .47036 .243 L p
.4 g
F P
s
P
p
.002 w
.29632 .25049 m .28229 .25335 L .27401 .24807 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .81355 .24962 L .79888 .25247 L p
.4 g
F P
s
P
p
.002 w
.7771 .25006 m .80647 .24433 L p
.79888 .25247 L .4 g
F P
s
P
p
.002 w
.66044 .24609 m .63145 .25181 L .61644 .24123 L p
.8 g
F P
s
P
p
.002 w
.5875 .24697 m .61644 .24123 L .63145 .25181 L p
.8 g
F P
s
P
p
1 .06 0 r
.01 w
.72634 .25748 m
.72634 .25748 L
s
P
p
.002 w
.27401 .24807 m .26569 .24278 L p
.29632 .25049 L .4 g
F P
s
P
p
.002 w
.26569 .24278 m .27977 .2399 L .29632 .25049 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .7771 .25006 L .76275 .23946 L p
.8 g
F P
s
P
p
.002 w
.73343 .24521 m .76275 .23946 L .7771 .25006 L p
.8 g
F P
s
P
p
1 .076 0 r
.01 w
.71183 .2483 m
.72642 .25886 L
s
P
p
.002 w
.82826 .24675 m .81355 .24962 L p
.80647 .24433 L .4 g
F P
s
P
p
.002 w
.3974 .24388 m .36904 .24962 L .35281 .23901 L p
.8 g
F P
s
P
p
.002 w
.3245 .24477 m .35281 .23901 L .36904 .24962 L p
.8 g
F P
s
P
p
.002 w
.47036 .243 m .49905 .23723 L .51463 .24785 L p
.4 g
F P
s
P
p
.002 w
.83598 .23857 m .84301 .24388 L .82826 .24675 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .83598 .23857 L p
.82826 .24675 L .4 g
F P
s
P
p
.002 w
.68956 .24034 m .66044 .24609 L .64552 .23546 L p
.8 g
F P
s
P
p
.002 w
.61644 .24123 m .64552 .23546 L .66044 .24609 L p
.8 g
F P
s
P
p
.002 w
.76275 .23946 m .79221 .23367 L .80647 .24433 L p
.8 g
F P
s
P
p
.002 w
.8578 .24101 m .84301 .24388 L p
.83598 .23857 L .4 g
F P
s
P
p
.002 w
.35281 .23901 m .38126 .23323 L .3974 .24388 L p
.8 g
F P
s
P
p
.002 w
.49905 .23723 m .47036 .243 L .45455 .23233 L p
.4 g
F P
s
P
p
.002 w
.27977 .2399 m .26569 .24278 L .25734 .23746 L p
.4 g
F P
s
P
p
.002 w
.86564 .23278 m .87262 .23812 L .8578 .24101 L p
.4 g
F P
s
P
p
.002 w
.83598 .23857 m .86564 .23278 L p
.8578 .24101 L .4 g
F P
s
P
p
.002 w
.71884 .23456 m .68956 .24034 L .67474 .22965 L p
.8 g
F P
s
P
p
.002 w
.64552 .23546 m .67474 .22965 L .68956 .24034 L p
.8 g
F P
s
P
p
.002 w
.25734 .23746 m .24894 .23211 L p
.27977 .2399 L .4 g
F P
s
P
p
.002 w
.24894 .23211 m .26306 .22921 L .27977 .2399 L p
.4 g
F P
s
P
p
.002 w
.79221 .23367 m .76275 .23946 L .74825 .22876 L p
.8 g
F P
s
P
p
1 .091 0 r
.01 w
.69717 .23903 m
.7119 .24968 L
s
P
p
.002 w
.88748 .23523 m .87262 .23812 L p
.86564 .23278 L .4 g
F P
s
P
p
.002 w
.45455 .23233 m .48333 .22652 L .49905 .23723 L p
.4 g
F P
s
P
p
.002 w
.86564 .23278 m .88053 .22988 L .88748 .23523 L p
.4 g
F P
s
P
p
.002 w
.11823 .14888 m .6316 .03821 L .88748 .23523 L p
.9 g
F P
s
P
p
.002 w
.67474 .22965 m .70411 .22382 L .71884 .23456 L p
.8 g
F P
s
P
p
.002 w
.74825 .22876 m .77782 .22292 L .79221 .23367 L p
.8 g
F P
s
P
p
.002 w
.40985 .22741 m .38126 .23323 L .36497 .22247 L p
.8 g
F P
s
P
p
.002 w
.88053 .22988 m .86564 .23278 L p
.85158 .22202 L .4 g
F P
s
P
p
.002 w
.48333 .22652 m .45455 .23233 L .43859 .22157 L p
.4 g
F P
s
P
p
.002 w
.26306 .22921 m .24894 .23211 L .24051 .22674 L p
.4 g
F P
s
P
p
.002 w
.87354 .2245 m .88053 .22988 L p
.85158 .22202 L .4 g
F P
s
P
p
.002 w
.70411 .22382 m .67474 .22965 L .65979 .21887 L p
.8 g
F P
s
P
p
.002 w
.24051 .22674 m .23204 .22135 L p
.26306 .22921 L .4 g
F P
s
P
p
.002 w
.23204 .22135 m .2462 .21841 L .26306 .22921 L p
.4 g
F P
s
P
p
.002 w
.77782 .22292 m .74825 .22876 L .73363 .21796 L p
.8 g
F P
s
P
p
.002 w
.36497 .22247 m .39366 .21661 L .40985 .22741 L p
.8 g
F P
s
P
p
1 .106 0 r
.01 w
.68237 .22966 m
.69724 .24042 L
s
P
p
.002 w
.43859 .22157 m .46747 .2157 L .48333 .22652 L p
.4 g
F P
s
P
p
.002 w
.85158 .22202 m .86652 .21909 L .87354 .2245 L p
.4 g
F P
s
P
p
.002 w
.65979 .21887 m .68925 .21298 L .70411 .22382 L p
.8 g
F P
s
P
p
.002 w
.73363 .21796 m .7633 .21207 L .77782 .22292 L p
.8 g
F P
s
P
p
.002 w
.39366 .21661 m .36497 .22247 L .34853 .21162 L p
.8 g
F P
s
P
p
.002 w
.86652 .21909 m .85158 .22202 L p
.83739 .21116 L .4 g
F P
s
P
p
.002 w
.46747 .2157 m .43859 .22157 L .42249 .21071 L p
.4 g
F P
s
P
p
.002 w
.2462 .21841 m .23204 .22135 L .22352 .21593 L p
.4 g
F P
s
P
p
1 .136 0 r
.01 w
.65307 .23828 m
.6825 .23245 L
s
P
p
1 .151 0 r
.01 w
.65312 .23967 m
.65312 .23967 L
s
P
p
.002 w
.85947 .21366 m .86652 .21909 L p
.83739 .21116 L .4 g
F P
s
P
p
.002 w
.68925 .21298 m .65979 .21887 L .64469 .20798 L p
.8 g
F P
s
P
p
.002 w
.22352 .21593 m .21497 .21048 L p
.2462 .21841 L .4 g
F P
s
P
p
.002 w
.21497 .21048 m .22918 .20752 L .2462 .21841 L p
.4 g
F P
s
P
p
1 .166 0 r
.01 w
.65318 .24106 m
.65318 .24106 L
s
P
p
.002 w
.7633 .21207 m .73363 .21796 L .71887 .20707 L p
.8 g
F P
s
P
p
1 .181 0 r
.01 w
.65323 .24246 m
.6827 .23663 L
s
P
p
.002 w
.34853 .21162 m .37731 .2057 L .39366 .21661 L p
.8 g
F P
s
P
p
.002 w
.42249 .21071 m .45146 .20478 L .46747 .2157 L p
.4 g
F P
s
P
p
1 .121 0 r
.01 w
.68244 .23105 m
.68244 .23105 L
s
P
p
.002 w
.64469 .20798 m .61527 .21389 L .59993 .20295 L p
.4 g
F P
s
P
p
.002 w
.83739 .21116 m .85238 .20821 L .85947 .21366 L p
.4 g
F P
s
P
p
.002 w
.64469 .20798 m .67426 .20204 L .68925 .21298 L p
.8 g
F P
s
P
p
.002 w
.79311 .20615 m .7633 .21207 L .74864 .20112 L p
.8 g
F P
s
P
p
.002 w
.71887 .20707 m .74864 .20112 L .7633 .21207 L p
.8 g
F P
s
P
p
.002 w
.85238 .20821 m .83739 .21116 L p
.82307 .2002 L .4 g
F P
s
P
p
.002 w
.45146 .20478 m .42249 .21071 L .40623 .19975 L p
.4 g
F P
s
P
p
1 .196 0 r
.01 w
.68277 .23802 m
.68277 .23802 L
s
P
p
.002 w
.22918 .20752 m .21497 .21048 L .20638 .20501 L p
.4 g
F P
s
P
p
1 .212 0 r
.01 w
.66779 .22858 m
.68284 .23942 L
s
P
p
.002 w
.59993 .20295 m .57056 .20889 L .55499 .19791 L p
.8 g
F P
s
P
p
.002 w
.84526 .20273 m .85238 .20821 L p
.82307 .2002 L .4 g
F P
s
P
p
.002 w
.59993 .20295 m .62945 .19699 L .64469 .20798 L p
.4 g
F P
s
P
p
.002 w
.67426 .20204 m .64469 .20798 L .62945 .19699 L p
.8 g
F P
s
P
p
.002 w
.20638 .20501 m .19775 .19952 L p
.22918 .20752 L .4 g
F P
s
P
p
.002 w
.19775 .19952 m .21201 .19653 L .22918 .20752 L p
.4 g
F P
s
P
p
.002 w
.82307 .2002 m .79311 .20615 L .77855 .19515 L p
.8 g
F P
s
P
p
.002 w
.74864 .20112 m .77855 .19515 L .79311 .20615 L p
.8 g
F P
s
P
p
.002 w
.48058 .19883 m .45146 .20478 L .4353 .19376 L p
.4 g
F P
s
P
p
.002 w
.40623 .19975 m .4353 .19376 L .45146 .20478 L p
.4 g
F P
s
P
p
.002 w
.62945 .19699 m .59993 .20295 L .58445 .19192 L p
.4 g
F P
s
P
p
.002 w
.55499 .19791 m .58445 .19192 L .59993 .20295 L p
.8 g
F P
s
P
p
.002 w
.82307 .2002 m .83811 .19722 L .84526 .20273 L p
.4 g
F P
s
P
p
.002 w
.70397 .19607 m .67426 .20204 L .65912 .19099 L p
.8 g
F P
s
P
p
.002 w
.62945 .19699 m .65912 .19099 L .67426 .20204 L p
.8 g
F P
s
P
p
.002 w
.83811 .19722 m .82307 .2002 L p
.80862 .18914 L .4 g
F P
s
P
p
.002 w
.77855 .19515 m .80862 .18914 L .82307 .2002 L p
.8 g
F P
s
P
p
.002 w
.4353 .19376 m .40623 .19975 L .38983 .18868 L p
.4 g
F P
s
P
p
.002 w
.21201 .19653 m .19775 .19952 L .18908 .19399 L p
.4 g
F P
s
P
p
.002 w
.4353 .19376 m .46452 .18775 L .48058 .19883 L p
.4 g
F P
s
P
p
1 .227 0 r
.01 w
.65265 .21905 m
.66785 .22998 L
s
P
p
.002 w
.83093 .19169 m .83811 .19722 L p
.80862 .18914 L .4 g
F P
s
P
p
.002 w
.58445 .19192 m .61407 .1859 L .62945 .19699 L p
.4 g
F P
s
P
p
.002 w
.18908 .19399 m .18037 .18845 L p
.21201 .19653 L .4 g
F P
s
P
p
.002 w
.18037 .18845 m .19467 .18543 L .21201 .19653 L p
.4 g
F P
s
P
p
.002 w
.73384 .19007 m .70397 .19607 L .68893 .18497 L p
.8 g
F P
s
P
p
.002 w
.65912 .19099 m .68893 .18497 L .70397 .19607 L p
.8 g
F P
s
P
p
.002 w
.80862 .18914 m .77855 .19515 L .76386 .18404 L p
.8 g
F P
s
P
p
.002 w
.46452 .18775 m .4353 .19376 L .41899 .18264 L p
.4 g
F P
s
P
p
.002 w
.38983 .18868 m .41899 .18264 L .4353 .19376 L p
.4 g
F P
s
P
p
.002 w
.61407 .1859 m .58445 .19192 L .56883 .18078 L p
.4 g
F P
s
P
p
.002 w
.80862 .18914 m .82371 .18613 L .83093 .19169 L p
.4 g
F P
s
P
p
.002 w
.76386 .18404 m .73384 .19007 L .7189 .17891 L p
.8 g
F P
s
P
p
.002 w
.68893 .18497 m .7189 .17891 L .73384 .19007 L p
.8 g
F P
s
P
p
.002 w
.34416 .18357 m .3152 .18961 L .29829 .17844 L p
.8 g
F P
s
P
p
.002 w
.82371 .18613 m .80862 .18914 L p
.79403 .17798 L .4 g
F P
s
P
p
.002 w
.76386 .18404 m .79403 .17798 L .80862 .18914 L p
.8 g
F P
s
P
p
.002 w
.19467 .18543 m .18037 .18845 L .17162 .18287 L p
.4 g
F P
s
P
p
.002 w
.41899 .18264 m .4483 .17657 L .46452 .18775 L p
.4 g
F P
s
P
p
.002 w
.81646 .18055 m .82371 .18613 L p
.79403 .17798 L .4 g
F P
s
P
p
.002 w
.56883 .18078 m .59855 .1747 L .61407 .1859 L p
.4 g
F P
s
P
p
1 .242 0 r
.01 w
.65271 .22045 m
.65271 .22045 L
s
P
p
.002 w
.17162 .18287 m .16283 .17728 L p
.19467 .18543 L .4 g
F P
s
P
p
.002 w
.16283 .17728 m .17717 .17423 L .19467 .18543 L p
.4 g
F P
s
P
p
1 .257 0 r
.01 w
.65276 .22186 m
.68264 .21589 L
s
P
p
.002 w
.79403 .17798 m .76386 .18404 L .74903 .17282 L p
.8 g
F P
s
P
p
.002 w
.7189 .17891 m .74903 .17282 L .76386 .18404 L p
.8 g
F P
s
P
p
.002 w
.29829 .17844 m .32735 .17235 L .34416 .18357 L p
.8 g
F P
s
P
p
.002 w
.52339 .17564 m .49388 .18171 L .47776 .17047 L p
.8 g
F P
s
P
p
.002 w
.59855 .1747 m .56883 .18078 L .55306 .16953 L p
.4 g
F P
s
P
p
.002 w
.79403 .17798 m .80917 .17493 L .81646 .18055 L p
.4 g
F P
s
P
p
.002 w
.32735 .17235 m .29829 .17844 L .28123 .16718 L p
.8 g
F P
s
P
p
.002 w
.80917 .17493 m .79403 .17798 L p
.7793 .16671 L .4 g
F P
s
P
p
.002 w
.74903 .17282 m .7793 .16671 L .79403 .17798 L p
.8 g
F P
s
P
p
1 .272 0 r
.01 w
.68271 .2173 m
.68271 .2173 L
s
P
p
.002 w
.40253 .17142 m .37327 .17751 L .35655 .16623 L p
.4 g
F P
s
P
p
.002 w
.17717 .17423 m .16283 .17728 L .15399 .17165 L p
.4 g
F P
s
P
p
1 .287 0 r
.01 w
.66752 .20762 m
.68278 .21871 L
s
P
p
.002 w
.47776 .17047 m .50737 .16434 L .52339 .17564 L p
.8 g
F P
s
P
p
.002 w
.80185 .1693 m .80917 .17493 L p
.7793 .16671 L .4 g
F P
s
P
p
.002 w
.62841 .16859 m .59855 .1747 L .58287 .1634 L p
.4 g
F P
s
P
p
.002 w
.55306 .16953 m .58287 .1634 L .59855 .1747 L p
.4 g
F P
s
P
p
.002 w
.15399 .17165 m .14512 .166 L p
.17717 .17423 L .4 g
F P
s
P
p
.002 w
.14512 .166 m .15951 .16293 L .17717 .17423 L p
.4 g
F P
s
P
p
1 .332 0 r
.01 w
.6677 .21186 m
.68298 .22294 L
s
P
p
1 .348 0 r
.01 w
.68305 .22435 m
.68305 .22435 L
s
P
p
.002 w
.28123 .16718 m .31038 .16103 L .32735 .17235 L p
.8 g
F P
s
P
p
1 .363 0 r
.01 w
.68312 .22576 m
.71323 .21978 L
s
P
p
.002 w
.43193 .16529 m .40253 .17142 L .38591 .16008 L p
.4 g
F P
s
P
p
.002 w
.35655 .16623 m .38591 .16008 L .40253 .17142 L p
.4 g
F P
s
P
p
.002 w
.7793 .16671 m .7945 .16364 L .80185 .1693 L p
.4 g
F P
s
P
p
.002 w
.65843 .16245 m .62841 .16859 L .61284 .15723 L p
.4 g
F P
s
P
p
.002 w
.58287 .1634 m .61284 .15723 L .62841 .16859 L p
.4 g
F P
s
P
p
.002 w
.7945 .16364 m .7793 .16671 L p
.76443 .15533 L .4 g
F P
s
P
p
.002 w
.38591 .16008 m .35655 .16623 L .33968 .15485 L p
.4 g
F P
s
P
p
.002 w
.15951 .16293 m .14512 .166 L .1362 .16032 L p
.4 g
F P
s
P
p
.002 w
.38591 .16008 m .41541 .1539 L .43193 .16529 L p
.4 g
F P
s
P
p
1 .378 0 r
.01 w
.71331 .22119 m
.7436 .21518 L
s
P
p
1 .302 0 r
.01 w
.66758 .20903 m
.66758 .20903 L
s
P
p
1 .317 0 r
.01 w
.66764 .21045 m
.66764 .21045 L
s
P
p
.002 w
.78711 .15795 m .7945 .16364 L p
.76443 .15533 L .4 g
F P
s
P
p
.002 w
.1362 .16032 m .12724 .15461 L p
.15951 .16293 L .4 g
F P
s
P
p
.002 w
.12724 .15461 m .14167 .15151 L .15951 .16293 L p
.4 g
F P
s
P
p
.002 w
.68861 .15628 m .65843 .16245 L .64297 .15103 L p
.4 g
F P
s
P
p
.002 w
.61284 .15723 m .64297 .15103 L .65843 .16245 L p
.4 g
F P
s
P
p
.002 w
.41541 .1539 m .38591 .16008 L .36913 .14864 L p
.4 g
F P
s
P
p
.002 w
.33968 .15485 m .36913 .14864 L .38591 .16008 L p
.4 g
F P
s
P
p
.002 w
.56705 .15199 m .53714 .15818 L .52107 .14672 L p
.8 g
F P
s
P
p
1 .393 0 r
.01 w
.74369 .2166 m
.77414 .21055 L
s
P
p
.002 w
.76443 .15533 m .77968 .15223 L .78711 .15795 L p
.4 g
F P
s
P
p
.002 w
.64297 .15103 m .67324 .1448 L .68861 .15628 L p
.4 g
F P
s
P
p
.002 w
.77968 .15223 m .76443 .15533 L p
.74942 .14384 L .4 g
F P
s
P
p
.002 w
.14167 .15151 m .12724 .15461 L .11823 .14888 L p
.4 g
F P
s
P
p
.002 w
.44507 .14768 m .41541 .1539 L .39873 .1424 L p
.4 g
F P
s
P
p
.002 w
.36913 .14864 m .39873 .1424 L .41541 .1539 L p
.4 g
F P
s
P
p
.002 w
.77222 .14648 m .77968 .15223 L p
.74942 .14384 L .4 g
F P
s
P
p
.002 w
.52107 .14672 m .55108 .14047 L .56705 .15199 L p
.8 g
F P
s
P
p
.002 w
.13269 .14576 m .14719 .14264 L p
.14167 .15151 L .4 g
F P
s
P
p
.002 w
.17065 .14528 m .14167 .15151 L p
.14719 .14264 L .4 g
F P
s
P
p
.002 w
.11823 .14888 m .13269 .14576 L .14167 .15151 L p
.4 g
F P
s
P
p
.002 w
.67324 .1448 m .64297 .15103 L .62735 .13951 L p
.4 g
F P
s
P
p
1 .408 0 r
.01 w
.77424 .21197 m
.77424 .21197 L
s
P
p
1 .423 0 r
.01 w
.77435 .2134 m
.77435 .2134 L
s
P
p
.002 w
.32264 .14336 m .29325 .1496 L .27596 .13806 L p
.8 g
F P
s
P
p
1 .438 0 r
.01 w
.77445 .21482 m
.77445 .21482 L
s
P
p
1 .453 0 r
.01 w
.77456 .21624 m
.77456 .21624 L
s
P
p
.002 w
.47488 .14144 m .44507 .14768 L .42848 .13612 L p
.4 g
F P
s
P
p
.002 w
.39873 .1424 m .42848 .13612 L .44507 .14768 L p
.4 g
F P
s
P
p
1 .469 0 r
.01 w
.77466 .21767 m
.77466 .21767 L
s
P
p
.002 w
.74942 .14384 m .76473 .14071 L .77222 .14648 L p
.4 g
F P
s
P
p
1 .484 0 r
.01 w
.77477 .21909 m
.77477 .21909 L
s
P
p
.002 w
.16172 .13951 m .17629 .13637 L p
.17065 .14528 L .4 g
F P
s
P
p
.002 w
.19978 .13902 m .17065 .14528 L p
.17629 .13637 L .4 g
F P
s
P
p
.002 w
.14719 .14264 m .16172 .13951 L .17065 .14528 L p
.4 g
F P
s
P
p
1 .499 0 r
.01 w
.77487 .22052 m
.77487 .22052 L
s
P
p
.002 w
.62735 .13951 m .65773 .13322 L .67324 .1448 L p
.4 g
F P
s
P
p
1 .514 0 r
.01 w
.77498 .22195 m
.77498 .22195 L
s
P
p
.002 w
.76473 .14071 m .74942 .14384 L p
.73427 .13225 L .4 g
F P
s
P
p
.002 w
.35219 .13709 m .32264 .14336 L .30545 .13176 L p
.8 g
F P
s
P
p
.002 w
.27596 .13806 m .30545 .13176 L .32264 .14336 L p
.8 g
F P
s
P
p
1 .529 0 r
.01 w
.77508 .22338 m
.77508 .22338 L
s
P
p
1 .544 0 r
.01 w
.77519 .22481 m
.77519 .22481 L
s
P
p
.002 w
.50484 .13516 m .47488 .14144 L .45839 .12982 L p
.4 g
F P
s
P
p
.002 w
.42848 .13612 m .45839 .12982 L .47488 .14144 L p
.4 g
F P
s
P
p
1 .559 0 r
.01 w
.77529 .22624 m
.77529 .22624 L
s
P
p
.002 w
.7572 .13491 m .76473 .14071 L p
.73427 .13225 L .4 g
F P
s
P
p
1 .574 0 r
.01 w
.7754 .22767 m
.7754 .22767 L
s
P
p
.002 w
.65773 .13322 m .62735 .13951 L .61159 .12787 L p
.4 g
F P
s
P
p
1 .589 0 r
.01 w
.77551 .22911 m
.77551 .22911 L
s
P
p
.002 w
.19089 .13322 m .20554 .13006 L p
.19978 .13902 L .4 g
F P
s
P
p
.002 w
.22906 .13273 m .19978 .13902 L p
.20554 .13006 L .4 g
F P
s
P
p
.002 w
.17629 .13637 m .19089 .13322 L .19978 .13902 L p
.4 g
F P
s
P
p
1 .605 0 r
.01 w
.77561 .23054 m
.77561 .23054 L
s
P
p
1 .62 0 r
.01 w
.77572 .23198 m
.77572 .23198 L
s
P
p
.002 w
.30545 .13176 m .33509 .12543 L .35219 .13709 L p
.8 g
F P
s
P
p
1 .635 0 r
.01 w
.77582 .23342 m
.77582 .23342 L
s
P
p
1 .65 0 r
.01 w
.77593 .23486 m
.77593 .23486 L
s
P
p
.002 w
.45839 .12982 m .48846 .12348 L .50484 .13516 L p
.4 g
F P
s
P
p
.002 w
.73427 .13225 m .74963 .12909 L .7572 .13491 L p
.4 g
F P
s
P
p
1 .665 0 r
.01 w
.77603 .2363 m
.77603 .2363 L
s
P
p
1 .68 0 r
.01 w
.77614 .23774 m
.77614 .23774 L
s
P
p
.002 w
.61159 .12787 m .64207 .12152 L .65773 .13322 L p
.4 g
F P
s
P
p
.002 w
.22022 .12689 m .23494 .12372 L p
.22906 .13273 L .4 g
F P
s
P
p
.002 w
.2585 .12641 m .22906 .13273 L p
.23494 .12372 L .4 g
F P
s
P
p
.002 w
.20554 .13006 m .22022 .12689 L .22906 .13273 L p
.4 g
F P
s
P
p
1 .695 0 r
.01 w
.77625 .23918 m
.77625 .23918 L
s
P
p
.002 w
.74963 .12909 m .73427 .13225 L p
.71897 .12054 L .4 g
F P
s
P
p
1 .71 0 r
.01 w
.77635 .24062 m
.77635 .24062 L
s
P
p
.002 w
.41174 .12445 m .38189 .13079 L .36489 .11907 L p
.8 g
F P
s
P
p
1 .725 0 r
.01 w
.77646 .24207 m
.77646 .24207 L
s
P
p
.002 w
.48846 .12348 m .45839 .12982 L .44175 .11808 L p
.4 g
F P
s
P
p
1 .741 0 r
.01 w
.77657 .24351 m
.77657 .24351 L
s
P
p
.002 w
.74202 .12323 m .74963 .12909 L p
.71897 .12054 L .4 g
F P
s
P
p
.002 w
.56524 .1225 m .53496 .12884 L .51868 .1171 L p
.8 g
F P
s
P
p
1 .756 0 r
.01 w
.77667 .24496 m
.77667 .24496 L
s
P
p
.002 w
.64207 .12152 m .61159 .12787 L .59567 .11612 L p
.4 g
F P
s
P
p
1 .771 0 r
.01 w
.77678 .24641 m
.77678 .24641 L
s
P
p
1 .786 0 r
.01 w
.77689 .24785 m
.77689 .24785 L
s
P
p
.002 w
.2497 .12054 m .2645 .11735 L p
.2585 .12641 L .4 g
F P
s
P
p
.002 w
.28808 .12005 m .2585 .12641 L p
.2645 .11735 L .4 g
F P
s
P
p
.002 w
.23494 .12372 m .2497 .12054 L .2585 .12641 L p
.4 g
F P
s
P
p
1 .801 0 r
.01 w
.77699 .2493 m
.77699 .2493 L
s
P
p
1 .816 0 r
.01 w
.7771 .25076 m
.7771 .25076 L
s
P
p
.002 w
.44175 .11808 m .41174 .12445 L .39484 .11267 L p
.8 g
F P
s
P
p
.002 w
.36489 .11907 m .39484 .11267 L .41174 .12445 L p
.8 g
F P
s
P
p
1 .831 0 r
.01 w
.77721 .25221 m
.77721 .25221 L
s
P
p
.002 w
.44175 .11808 m .47192 .11168 L .48846 .12348 L p
.4 g
F P
s
P
p
.002 w
.71897 .12054 m .73438 .11735 L .74202 .12323 L p
.4 g
F P
s
P
p
1 .846 0 r
.01 w
.77731 .25366 m
.77731 .25366 L
s
P
p
.002 w
.51868 .1171 m .54906 .1107 L .56524 .1225 L p
.8 g
F P
s
P
p
1 .861 0 r
.01 w
.77742 .25512 m
.77742 .25512 L
s
P
p
.002 w
.59567 .11612 m .62626 .10971 L .64207 .12152 L p
.4 g
F P
s
P
p
1 .877 0 r
.01 w
.77753 .25657 m
.77753 .25657 L
s
P
p
.002 w
.73438 .11735 m .71897 .12054 L p
.70353 .10872 L .4 g
F P
s
P
p
.002 w
.27934 .11415 m .29421 .11094 L p
.28808 .12005 L .4 g
F P
s
P
p
.002 w
.31782 .11366 m .28808 .12005 L p
.29421 .11094 L .4 g
F P
s
P
p
.002 w
.2645 .11735 m .27934 .11415 L .28808 .12005 L p
.4 g
F P
s
P
p
1 .892 0 r
.01 w
.77763 .25803 m
.77763 .25803 L
s
P
p
1 .907 0 r
.01 w
.77774 .25949 m
.77774 .25949 L
s
P
p
.002 w
.39484 .11267 m .42495 .10624 L .44175 .11808 L p
.8 g
F P
s
P
p
1 .922 0 r
.01 w
.77785 .26095 m
.77785 .26095 L
s
P
p
.002 w
.72671 .11144 m .73438 .11735 L p
.70353 .10872 L .4 g
F P
s
P
p
.002 w
.54906 .1107 m .51868 .1171 L .50224 .10525 L p
.8 g
F P
s
P
p
1 .937 0 r
.01 w
.77796 .26241 m
.77796 .26241 L
s
P
p
.002 w
.62626 .10971 m .59567 .11612 L .5796 .10426 L p
.4 g
F P
s
P
p
1 .952 0 r
.01 w
.77806 .26387 m
.77806 .26387 L
s
P
p
1 .967 0 r
.01 w
.77817 .26533 m
.77817 .26533 L
s
P
p
1 .982 0 r
.01 w
.77828 .2668 m
.77828 .2668 L
s
P
p
.002 w
.30913 .10773 m .32408 .1045 L p
.31782 .11366 L .4 g
F P
s
P
p
.002 w
.34772 .10723 m .31782 .11366 L p
.32408 .1045 L .4 g
F P
s
P
p
.002 w
.29421 .11094 m .30913 .10773 L .31782 .11366 L p
.4 g
F P
s
P
p
1 .997 0 r
.01 w
.77839 .26826 m
.77839 .26826 L
s
P
p
.987 1 0 r
.01 w
.7785 .26973 m
.7785 .26973 L
s
P
p
.002 w
.70353 .10872 m .71899 .1055 L .72671 .11144 L p
.4 g
F P
s
P
p
.972 1 0 r
.01 w
.7786 .2712 m
.7786 .2712 L
s
P
p
.002 w
.50224 .10525 m .53273 .09878 L .54906 .1107 L p
.8 g
F P
s
P
p
.957 1 0 r
.01 w
.77871 .27267 m
.77871 .27267 L
s
P
p
.002 w
.5796 .10426 m .6103 .09778 L .62626 .10971 L p
.4 g
F P
s
P
p
.942 1 0 r
.01 w
.77882 .27414 m
.77882 .27414 L
s
P
p
.002 w
.71899 .1055 m .70353 .10872 L p
.68793 .09678 L .4 g
F P
s
P
p
.927 1 0 r
.01 w
.77893 .27561 m
.77893 .27561 L
s
P
p
.002 w
.33907 .10127 m .35411 .09803 L p
.34772 .10723 L .4 g
F P
s
P
p
.002 w
.37777 .10077 m .34772 .10723 L p
.35411 .09803 L .4 g
F P
s
P
p
.002 w
.32408 .1045 m .33907 .10127 L .34772 .10723 L p
.4 g
F P
s
P
p
.912 1 0 r
.01 w
.77904 .27708 m
.77904 .27708 L
s
P
p
.002 w
.45522 .09978 m .42495 .10624 L .40798 .09428 L p
.4 g
F P
s
P
p
.897 1 0 r
.01 w
.77915 .27855 m
.77915 .27855 L
s
P
p
.002 w
.71124 .09953 m .71899 .1055 L p
.68793 .09678 L .4 g
F P
s
P
p
.002 w
.53273 .09878 m .50224 .10525 L .48565 .09328 L p
.8 g
F P
s
P
p
.882 1 0 r
.01 w
.77925 .28003 m
.77925 .28003 L
s
P
p
.002 w
.6103 .09778 m .5796 .10426 L .56337 .09228 L p
.4 g
F P
s
P
p
.866 1 0 r
.01 w
.77936 .2815 m
.77936 .2815 L
s
P
p
.851 1 0 r
.01 w
.77947 .28298 m
.77947 .28298 L
s
P
p
.836 1 0 r
.01 w
.77958 .28446 m
.77958 .28446 L
s
P
p
.821 1 0 r
.01 w
.77969 .28594 m
.77969 .28594 L
s
P
p
.002 w
.36918 .09478 m .38429 .09152 L p
.37777 .10077 L .4 g
F P
s
P
p
.002 w
.40798 .09428 m .37777 .10077 L p
.38429 .09152 L .4 g
F P
s
P
p
.002 w
.35411 .09803 m .36918 .09478 L .37777 .10077 L p
.4 g
F P
s
P
p
.806 1 0 r
.01 w
.7798 .28742 m
.7798 .28742 L
s
P
p
.002 w
.40798 .09428 m .43836 .08775 L .45522 .09978 L p
.4 g
F P
s
P
p
.002 w
.68793 .09678 m .70345 .09353 L .71124 .09953 L p
.4 g
F P
s
P
p
.791 1 0 r
.01 w
.77991 .2889 m
.77991 .2889 L
s
P
p
.002 w
.48565 .09328 m .51623 .08675 L .53273 .09878 L p
.8 g
F P
s
P
p
.776 1 0 r
.01 w
.78002 .29038 m
.78002 .29038 L
s
P
p
.002 w
.64116 .09127 m .6103 .09778 L .59418 .08574 L p
.4 g
F P
s
P
p
.002 w
.56337 .09228 m .59418 .08574 L .6103 .09778 L p
.4 g
F P
s
P
p
.761 1 0 r
.01 w
.78013 .29187 m
.78013 .29187 L
s
P
p
.002 w
.70345 .09353 m .68793 .09678 L p
.67218 .08473 L .4 g
F P
s
P
p
.746 1 0 r
.01 w
.78024 .29335 m
.78024 .29335 L
s
P
p
.73 1 0 r
.01 w
.78034 .29484 m
.78034 .29484 L
s
P
p
.002 w
.39944 .08826 m .41463 .08498 L p
.40798 .09428 L .4 g
F P
s
P
p
.002 w
.43836 .08775 m .40798 .09428 L p
.41463 .08498 L .4 g
F P
s
P
p
.002 w
.38429 .09152 m .39944 .08826 L .40798 .09428 L p
.4 g
F P
s
P
p
.715 1 0 r
.01 w
.78045 .29633 m
.78045 .29633 L
s
P
p
.002 w
.69562 .0875 m .70345 .09353 L p
.67218 .08473 L .4 g
F P
s
P
p
.7 1 0 r
.01 w
.78056 .29782 m
.78056 .29782 L
s
P
p
.685 1 0 r
.01 w
.78067 .29931 m
.78067 .29931 L
s
P
p
.002 w
.67218 .08473 m .64116 .09127 L .62515 .07917 L p
.4 g
F P
s
P
p
.002 w
.59418 .08574 m .62515 .07917 L .64116 .09127 L p
.4 g
F P
s
P
p
.67 1 0 r
.01 w
.78078 .3008 m
.78078 .3008 L
s
P
p
.655 1 0 r
.01 w
.78089 .30229 m
.78089 .30229 L
s
P
p
.64 1 0 r
.01 w
.781 .30379 m
.781 .30379 L
s
P
p
.625 1 0 r
.01 w
.78111 .30528 m
.78111 .30528 L
s
P
p
.002 w
.42986 .0817 m .44513 .07841 L p
.43836 .08775 L .4 g
F P
s
P
p
.002 w
.46889 .08119 m .43836 .08775 L p
.44513 .07841 L .4 g
F P
s
P
p
.002 w
.41463 .08498 m .42986 .0817 L .43836 .08775 L p
.4 g
F P
s
P
p
.002 w
.67218 .08473 m .68776 .08145 L .69562 .0875 L p
.4 g
F P
s
P
p
.61 1 0 r
.01 w
.78122 .30678 m
.78122 .30678 L
s
P
p
.594 1 0 r
.01 w
.78133 .30828 m
.78133 .30828 L
s
P
p
.579 1 0 r
.01 w
.78144 .30978 m
.78144 .30978 L
s
P
p
.002 w
.68776 .08145 m .67218 .08473 L p
.65628 .07256 L .4 g
F P
s
P
p
.002 w
.62515 .07917 m .65628 .07256 L .67218 .08473 L p
.4 g
F P
s
P
p
.564 1 0 r
.01 w
.78155 .31128 m
.78155 .31128 L
s
P
p
.549 1 0 r
.01 w
.78167 .31278 m
.78167 .31278 L
s
P
p
.534 1 0 r
.01 w
.78178 .31428 m
.78178 .31428 L
s
P
p
.002 w
.67985 .07536 m .68776 .08145 L p
.65628 .07256 L .4 g
F P
s
P
p
.002 w
.46045 .07511 m .4758 .0718 L p
.46889 .08119 L .4 g
F P
s
P
p
.002 w
.49958 .0746 m .46889 .08119 L p
.4758 .0718 L .4 g
F P
s
P
p
.002 w
.44513 .07841 m .46045 .07511 L .46889 .08119 L p
.4 g
F P
s
P
p
.519 1 0 r
.01 w
.78189 .31578 m
.78189 .31578 L
s
P
p
.504 1 0 r
.01 w
.782 .31729 m
.782 .31729 L
s
P
p
.489 1 0 r
.01 w
.78211 .31879 m
.78211 .31879 L
s
P
p
.474 1 0 r
.01 w
.78222 .3203 m
.78222 .3203 L
s
P
p
.458 1 0 r
.01 w
.78233 .32181 m
.78233 .32181 L
s
P
p
.443 1 0 r
.01 w
.78244 .32332 m
.78244 .32332 L
s
P
p
.002 w
.65628 .07256 m .67191 .06924 L .67985 .07536 L p
.4 g
F P
s
P
p
.428 1 0 r
.01 w
.78255 .32483 m
.78255 .32483 L
s
P
p
.002 w
.49119 .06848 m .50663 .06515 L p
.49958 .0746 L .4 g
F P
s
P
p
.002 w
.53044 .06797 m .49958 .0746 L p
.50663 .06515 L .4 g
F P
s
P
p
.002 w
.4758 .0718 m .49119 .06848 L .49958 .0746 L p
.4 g
F P
s
P
p
.413 1 0 r
.01 w
.78266 .32634 m
.78266 .32634 L
s
P
p
.398 1 0 r
.01 w
.78278 .32786 m
.78278 .32786 L
s
P
p
.002 w
.67191 .06924 m .65628 .07256 L p
.64022 .06027 L .4 g
F P
s
P
p
.383 1 0 r
.01 w
.78289 .32937 m
.78289 .32937 L
s
P
p
.368 1 0 r
.01 w
.783 .33089 m
.783 .33089 L
s
P
p
.353 1 0 r
.01 w
.78311 .33241 m
.78311 .33241 L
s
P
p
.002 w
.66393 .0631 m .67191 .06924 L p
.64022 .06027 L .4 g
F P
s
P
p
.338 1 0 r
.01 w
.78322 .33392 m
.78322 .33392 L
s
P
p
.002 w
.5221 .06181 m .53762 .05847 L p
.53044 .06797 L .4 g
F P
s
P
p
.002 w
.56146 .0613 m .53044 .06797 L p
.53762 .05847 L .4 g
F P
s
P
p
.002 w
.50663 .06515 m .5221 .06181 L .53044 .06797 L p
.4 g
F P
s
P
p
.322 1 0 r
.01 w
.78333 .33544 m
.78333 .33544 L
s
P
p
.307 1 0 r
.01 w
.78345 .33697 m
.78345 .33697 L
s
P
p
.292 1 0 r
.01 w
.78356 .33849 m
.78356 .33849 L
s
P
p
.277 1 0 r
.01 w
.78367 .34001 m
.78367 .34001 L
s
P
p
.262 1 0 r
.01 w
.78378 .34154 m
.78378 .34154 L
s
P
p
.002 w
.64022 .06027 m .65591 .05692 L .66393 .0631 L p
.4 g
F P
s
P
p
.247 1 0 r
.01 w
.78389 .34306 m
.78389 .34306 L
s
P
p
.232 1 0 r
.01 w
.78401 .34459 m
.78401 .34459 L
s
P
p
.002 w
.55318 .05511 m .56878 .05175 L p
.56146 .0613 L .4 g
F P
s
P
p
.002 w
.59265 .0546 m .56146 .0613 L p
.56878 .05175 L .4 g
F P
s
P
p
.002 w
.53762 .05847 m .55318 .05511 L .56146 .0613 L p
.4 g
F P
s
P
p
.217 1 0 r
.01 w
.78412 .34612 m
.78412 .34612 L
s
P
p
.002 w
.65591 .05692 m .64022 .06027 L p
.624 .04786 L .4 g
F P
s
P
p
.202 1 0 r
.01 w
.78423 .34765 m
.78423 .34765 L
s
P
p
.186 1 0 r
.01 w
.78435 .34918 m
.78435 .34918 L
s
P
p
.171 1 0 r
.01 w
.78446 .35071 m
.78446 .35071 L
s
P
p
.002 w
.64785 .05071 m .65591 .05692 L p
.624 .04786 L .4 g
F P
s
P
p
.156 1 0 r
.01 w
.78457 .35224 m
.78457 .35224 L
s
P
p
.141 1 0 r
.01 w
.78468 .35378 m
.78468 .35378 L
s
P
p
.002 w
.58442 .04838 m .60011 .045 L p
.59265 .0546 L .4 g
F P
s
P
p
.002 w
.624 .04786 m .59265 .0546 L p
.60011 .045 L .4 g
F P
s
P
p
.002 w
.56878 .05175 m .58442 .04838 L .59265 .0546 L p
.4 g
F P
s
P
p
.126 1 0 r
.01 w
.7848 .35532 m
.7848 .35532 L
s
P
p
.111 1 0 r
.01 w
.78491 .35685 m
.78491 .35685 L
s
P
p
.096 1 0 r
.01 w
.78502 .35839 m
.78502 .35839 L
s
P
p
.081 1 0 r
.01 w
.78514 .35993 m
.78514 .35993 L
s
P
p
.002 w
.624 .04786 m .63974 .04448 L .64785 .05071 L p
.4 g
F P
s
P
p
.065 1 0 r
.01 w
.78525 .36147 m
.78525 .36147 L
s
P
p
.05 1 0 r
.01 w
.78536 .36301 m
.78536 .36301 L
s
P
p
.035 1 0 r
.01 w
.78548 .36456 m
.78548 .36456 L
s
P
p
.002 w
.61583 .04161 m .6316 .03821 L p
.624 .04786 L .4 g
F P
s
P
p
.002 w
.63974 .04448 m .624 .04786 L p
.6316 .03821 L .4 g
F P
s
P
p
.002 w
.60011 .045 m .61583 .04161 L .624 .04786 L p
.4 g
F P
s
P
p
.02 1 0 r
.01 w
.78559 .3661 m
.78559 .3661 L
s
P
p
.005 1 0 r
.01 w
.7857 .36765 m
.7857 .36765 L
s
P
p
0 1 .01 r
.01 w
.78582 .3692 m
.78582 .3692 L
s
P
p
0 1 .025 r
.01 w
.78593 .37075 m
.78593 .37075 L
s
P
p
0 1 .04 r
.01 w
.78605 .3723 m
.78605 .3723 L
s
P
p
0 1 .055 r
.01 w
.78616 .37385 m
.78616 .37385 L
s
P
p
0 1 .071 r
.01 w
.78628 .3754 m
.78628 .3754 L
s
P
p
0 1 .086 r
.01 w
.78639 .37695 m
.78639 .37695 L
s
P
p
0 1 .101 r
.01 w
.7865 .37851 m
.7865 .37851 L
s
P
p
0 1 .116 r
.01 w
.78662 .38007 m
.78662 .38007 L
s
P
p
0 1 .131 r
.01 w
.78673 .38162 m
.78673 .38162 L
s
P
p
0 1 .146 r
.01 w
.78685 .38318 m
.78685 .38318 L
s
P
p
0 1 .161 r
.01 w
.78696 .38474 m
.78696 .38474 L
s
P
p
0 1 .176 r
.01 w
.78708 .38631 m
.78708 .38631 L
s
P
p
0 1 .191 r
.01 w
.78719 .38787 m
.78719 .38787 L
s
P
p
0 1 .207 r
.01 w
.78731 .38943 m
.78731 .38943 L
s
P
p
0 1 .222 r
.01 w
.78742 .391 m
.78742 .391 L
s
P
p
0 1 .237 r
.01 w
.78754 .39256 m
.78754 .39256 L
s
P
p
0 1 .252 r
.01 w
.78765 .39413 m
.78765 .39413 L
s
P
p
0 1 .267 r
.01 w
.78777 .3957 m
.78777 .3957 L
s
P
p
0 1 .282 r
.01 w
.78789 .39727 m
.78789 .39727 L
s
P
p
0 1 .297 r
.01 w
.788 .39885 m
.788 .39885 L
s
P
p
0 1 .312 r
.01 w
.78812 .40042 m
.78812 .40042 L
s
P
p
0 1 .327 r
.01 w
.78823 .40199 m
.78823 .40199 L
s
P
p
0 1 .343 r
.01 w
.78835 .40357 m
.78835 .40357 L
s
P
p
0 1 .358 r
.01 w
.78847 .40515 m
.78847 .40515 L
s
P
p
0 1 .373 r
.01 w
.78858 .40673 m
.78858 .40673 L
s
P
p
0 1 .388 r
.01 w
.7887 .40831 m
.7887 .40831 L
s
P
p
0 1 .403 r
.01 w
.78881 .40989 m
.78881 .40989 L
s
P
p
0 1 .418 r
.01 w
.78893 .41147 m
.78893 .41147 L
s
P
p
0 1 .433 r
.01 w
.78905 .41305 m
.78905 .41305 L
s
P
p
0 1 .448 r
.01 w
.78916 .41464 m
.78916 .41464 L
s
P
p
0 1 .463 r
.01 w
.78928 .41623 m
.78928 .41623 L
s
P
p
0 1 .479 r
.01 w
.7894 .41781 m
.7894 .41781 L
s
P
p
0 1 .494 r
.01 w
.78952 .4194 m
.78952 .4194 L
s
P
p
0 1 .509 r
.01 w
.78963 .42099 m
.78963 .42099 L
s
P
p
0 1 .524 r
.01 w
.78975 .42259 m
.78975 .42259 L
s
P
p
0 1 .539 r
.01 w
.78987 .42418 m
.78987 .42418 L
s
P
p
0 1 .554 r
.01 w
.78998 .42577 m
.78998 .42577 L
s
P
p
0 1 .569 r
.01 w
.7901 .42737 m
.7901 .42737 L
s
P
p
0 1 .584 r
.01 w
.79022 .42897 m
.79022 .42897 L
s
P
p
0 1 .599 r
.01 w
.79034 .43056 m
.79034 .43056 L
s
P
p
0 1 .615 r
.01 w
.79045 .43216 m
.79045 .43216 L
s
P
p
0 1 .63 r
.01 w
.79057 .43377 m
.79057 .43377 L
s
P
p
0 1 .645 r
.01 w
.79069 .43537 m
.79069 .43537 L
s
P
p
0 1 .66 r
.01 w
.79081 .43697 m
.79081 .43697 L
s
P
p
0 1 .675 r
.01 w
.79093 .43858 m
.79093 .43858 L
s
P
p
0 1 .69 r
.01 w
.79105 .44018 m
.79105 .44018 L
s
P
p
0 1 .705 r
.01 w
.79116 .44179 m
.79116 .44179 L
s
P
p
0 1 .72 r
.01 w
.79128 .4434 m
.79128 .4434 L
s
P
p
0 1 .736 r
.01 w
.7914 .44501 m
.7914 .44501 L
s
P
p
0 1 .751 r
.01 w
.79152 .44663 m
.79152 .44663 L
s
P
p
0 1 .766 r
.01 w
.79164 .44824 m
.79164 .44824 L
s
P
p
0 1 .781 r
.01 w
.79176 .44985 m
.79176 .44985 L
s
P
p
0 1 .796 r
.01 w
.79188 .45147 m
.79188 .45147 L
s
P
p
0 1 .811 r
.01 w
.792 .45309 m
.792 .45309 L
s
P
p
0 1 .826 r
.01 w
.79211 .45471 m
.79211 .45471 L
s
P
p
0 1 .841 r
.01 w
.79223 .45633 m
.79223 .45633 L
s
P
p
0 1 .856 r
.01 w
.79235 .45795 m
.79235 .45795 L
s
P
p
0 1 .872 r
.01 w
.79247 .45957 m
.79247 .45957 L
s
P
p
0 1 .887 r
.01 w
.79259 .4612 m
.79259 .4612 L
s
P
p
0 1 .902 r
.01 w
.79271 .46282 m
.79271 .46282 L
s
P
p
0 1 .917 r
.01 w
.79283 .46445 m
.79283 .46445 L
s
P
p
0 1 .932 r
.01 w
.79295 .46608 m
.79295 .46608 L
s
P
p
0 1 .947 r
.01 w
.79307 .46771 m
.79307 .46771 L
s
P
p
0 1 .962 r
.01 w
.79319 .46934 m
.79319 .46934 L
s
P
p
0 1 .977 r
.01 w
.79331 .47097 m
.79331 .47097 L
s
P
p
0 1 .992 r
.01 w
.79343 .4726 m
.79343 .4726 L
s
P
p
0 .992 1 r
.01 w
.79355 .47424 m
.79355 .47424 L
s
P
p
0 .977 1 r
.01 w
.79367 .47588 m
.79367 .47588 L
s
P
p
0 .962 1 r
.01 w
.79379 .47752 m
.79379 .47752 L
s
P
p
0 .947 1 r
.01 w
.79391 .47916 m
.79391 .47916 L
s
P
p
0 .932 1 r
.01 w
.79404 .4808 m
.79404 .4808 L
s
P
p
0 .917 1 r
.01 w
.79416 .48244 m
.79416 .48244 L
s
P
p
0 .902 1 r
.01 w
.79428 .48408 m
.79428 .48408 L
s
P
p
0 .887 1 r
.01 w
.7944 .48573 m
.7944 .48573 L
s
P
p
0 .872 1 r
.01 w
.79452 .48737 m
.79452 .48737 L
s
P
p
0 .856 1 r
.01 w
.79464 .48902 m
.79464 .48902 L
s
P
p
0 .841 1 r
.01 w
.79476 .49067 m
.79476 .49067 L
s
P
p
0 .826 1 r
.01 w
.79488 .49232 m
.79488 .49232 L
s
P
p
0 .811 1 r
.01 w
.79501 .49397 m
.79501 .49397 L
s
P
p
0 .796 1 r
.01 w
.79513 .49563 m
.79513 .49563 L
s
P
p
0 .781 1 r
.01 w
.79525 .49728 m
.79525 .49728 L
s
P
p
0 .766 1 r
.01 w
.79537 .49894 m
.79537 .49894 L
s
P
p
0 .751 1 r
.01 w
.79549 .5006 m
.79549 .5006 L
s
P
p
0 .736 1 r
.01 w
.79562 .50226 m
.79562 .50226 L
s
P
p
0 .72 1 r
.01 w
.79574 .50392 m
.79574 .50392 L
s
P
p
0 .705 1 r
.01 w
.79586 .50558 m
.79586 .50558 L
s
P
p
0 .69 1 r
.01 w
.79598 .50724 m
.79598 .50724 L
s
P
p
0 .675 1 r
.01 w
.7961 .50891 m
.7961 .50891 L
s
P
p
0 .66 1 r
.01 w
.79623 .51058 m
.79623 .51058 L
s
P
p
0 .645 1 r
.01 w
.79635 .51224 m
.79635 .51224 L
s
P
p
0 .63 1 r
.01 w
.79647 .51391 m
.79647 .51391 L
s
P
p
0 .615 1 r
.01 w
.7966 .51558 m
.7966 .51558 L
s
P
p
0 .599 1 r
.01 w
.79672 .51726 m
.79672 .51726 L
s
P
p
0 .584 1 r
.01 w
.79684 .51893 m
.79684 .51893 L
s
P
p
0 .569 1 r
.01 w
.79697 .5206 m
.79697 .5206 L
s
P
p
0 .554 1 r
.01 w
.79709 .52228 m
.79709 .52228 L
s
P
p
0 .539 1 r
.01 w
.79721 .52396 m
.79721 .52396 L
s
P
p
0 .524 1 r
.01 w
.79734 .52564 m
.79734 .52564 L
s
P
p
0 .509 1 r
.01 w
.79746 .52732 m
.79746 .52732 L
s
P
p
0 .494 1 r
.01 w
.79758 .529 m
.79758 .529 L
s
P
p
0 .479 1 r
.01 w
.79771 .53068 m
.79771 .53068 L
s
P
p
0 .463 1 r
.01 w
.79783 .53237 m
.79783 .53237 L
s
P
p
0 .448 1 r
.01 w
.79796 .53406 m
.79796 .53406 L
s
P
p
0 .433 1 r
.01 w
.79808 .53574 m
.79808 .53574 L
s
P
p
0 .418 1 r
.01 w
.7982 .53743 m
.7982 .53743 L
s
P
p
0 .403 1 r
.01 w
.79833 .53913 m
.79833 .53913 L
s
P
p
0 .388 1 r
.01 w
.79845 .54082 m
.79845 .54082 L
s
P
p
0 .373 1 r
.01 w
.79858 .54251 m
.79858 .54251 L
s
P
p
0 .358 1 r
.01 w
.7987 .54421 m
.7987 .54421 L
s
P
p
0 .343 1 r
.01 w
.79883 .5459 m
.79883 .5459 L
s
P
p
0 .327 1 r
.01 w
.79895 .5476 m
.79895 .5476 L
s
P
p
0 .312 1 r
.01 w
.79908 .5493 m
.79908 .5493 L
s
P
p
0 .297 1 r
.01 w
.7992 .551 m
.7992 .551 L
s
P
p
0 .282 1 r
.01 w
.79933 .55271 m
.79933 .55271 L
s
P
p
0 .267 1 r
.01 w
.79945 .55441 m
.79945 .55441 L
s
P
p
0 .252 1 r
.01 w
.79958 .55612 m
.79958 .55612 L
s
P
p
0 .237 1 r
.01 w
.79971 .55782 m
.79971 .55782 L
s
P
p
0 .222 1 r
.01 w
.79983 .55953 m
.79983 .55953 L
s
P
p
0 .207 1 r
.01 w
.79996 .56124 m
.79996 .56124 L
s
P
p
0 .191 1 r
.01 w
.80008 .56295 m
.80008 .56295 L
s
P
p
0 .176 1 r
.01 w
.80021 .56467 m
.80021 .56467 L
s
P
p
0 .161 1 r
.01 w
.80034 .56638 m
.80034 .56638 L
s
P
p
0 .146 1 r
.01 w
.80046 .5681 m
.80046 .5681 L
s
P
p
0 .131 1 r
.01 w
.80059 .56981 m
.80059 .56981 L
s
P
p
0 .116 1 r
.01 w
.80072 .57153 m
.80072 .57153 L
s
P
p
0 .101 1 r
.01 w
.80084 .57325 m
.80084 .57325 L
s
P
p
0 .086 1 r
.01 w
.80097 .57498 m
.80097 .57498 L
s
P
p
0 .071 1 r
.01 w
.8011 .5767 m
.8011 .5767 L
s
P
p
0 .055 1 r
.01 w
.80122 .57843 m
.80122 .57843 L
s
P
p
0 .04 1 r
.01 w
.80135 .58015 m
.80135 .58015 L
s
P
p
0 .025 1 r
.01 w
.80148 .58188 m
.80148 .58188 L
s
P
p
0 .01 1 r
.01 w
.8016 .58361 m
.8016 .58361 L
s
P
p
.005 0 1 r
.01 w
.80173 .58534 m
.80173 .58534 L
s
P
p
.02 0 1 r
.01 w
.80186 .58707 m
.80186 .58707 L
s
P
p
.035 0 1 r
.01 w
.80199 .58881 m
.80199 .58881 L
s
P
p
.05 0 1 r
.01 w
.80211 .59054 m
.80211 .59054 L
s
P
p
.065 0 1 r
.01 w
.80224 .59228 m
.80224 .59228 L
s
P
p
.081 0 1 r
.01 w
.80237 .59402 m
.80237 .59402 L
s
P
p
.096 0 1 r
.01 w
.8025 .59576 m
.8025 .59576 L
s
P
p
.111 0 1 r
.01 w
.80263 .5975 m
.80263 .5975 L
s
P
p
.126 0 1 r
.01 w
.80276 .59924 m
.80276 .59924 L
s
P
p
.141 0 1 r
.01 w
.80288 .60099 m
.80288 .60099 L
s
P
p
.156 0 1 r
.01 w
.80301 .60274 m
.80301 .60274 L
s
P
p
.171 0 1 r
.01 w
.80314 .60448 m
.80314 .60448 L
s
P
p
.186 0 1 r
.01 w
.80327 .60623 m
.80327 .60623 L
s
P
p
.202 0 1 r
.01 w
.8034 .60798 m
.8034 .60798 L
s
P
p
.217 0 1 r
.01 w
.80353 .60974 m
.80353 .60974 L
s
P
p
.232 0 1 r
.01 w
.80366 .61149 m
.80366 .61149 L
s
P
p
.247 0 1 r
.01 w
.80379 .61325 m
.80379 .61325 L
s
P
p
.262 0 1 r
.01 w
.80392 .615 m
.80392 .615 L
s
P
p
.277 0 1 r
.01 w
.80405 .61676 m
.80405 .61676 L
s
P
p
.292 0 1 r
.01 w
.80417 .61852 m
.80417 .61852 L
s
P
p
.307 0 1 r
.01 w
.8043 .62028 m
.8043 .62028 L
s
P
p
.322 0 1 r
.01 w
.80443 .62205 m
.80443 .62205 L
s
P
p
.338 0 1 r
.01 w
.80456 .62381 m
.80456 .62381 L
s
P
p
.353 0 1 r
.01 w
.80469 .62558 m
.80469 .62558 L
s
P
p
.368 0 1 r
.01 w
.80482 .62735 m
.80482 .62735 L
s
P
p
.383 0 1 r
.01 w
.80495 .62912 m
.80495 .62912 L
s
P
p
.398 0 1 r
.01 w
.80509 .63089 m
.80509 .63089 L
s
P
p
.413 0 1 r
.01 w
.80522 .63266 m
.80522 .63266 L
s
P
p
.428 0 1 r
.01 w
.80535 .63443 m
.80535 .63443 L
s
P
p
.443 0 1 r
.01 w
.80548 .63621 m
.80548 .63621 L
s
P
p
.458 0 1 r
.01 w
.80561 .63799 m
.80561 .63799 L
s
P
p
.474 0 1 r
.01 w
.80574 .63977 m
.80574 .63977 L
s
P
p
.489 0 1 r
.01 w
.80587 .64155 m
.80587 .64155 L
s
P
p
.504 0 1 r
.01 w
.806 .64333 m
.806 .64333 L
s
P
p
.519 0 1 r
.01 w
.80613 .64511 m
.80613 .64511 L
s
P
p
.534 0 1 r
.01 w
.80626 .6469 m
.80626 .6469 L
s
P
p
.549 0 1 r
.01 w
.8064 .64868 m
.8064 .64868 L
s
P
p
.564 0 1 r
.01 w
.80653 .65047 m
.80653 .65047 L
s
P
p
.579 0 1 r
.01 w
.80666 .65226 m
.80666 .65226 L
s
P
p
.594 0 1 r
.01 w
.80679 .65405 m
.80679 .65405 L
s
P
p
.61 0 1 r
.01 w
.80692 .65585 m
.80692 .65585 L
s
P
p
.625 0 1 r
.01 w
.80705 .65764 m
.80705 .65764 L
s
P
p
.64 0 1 r
.01 w
.80719 .65944 m
.80719 .65944 L
s
P
p
.655 0 1 r
.01 w
.80732 .66124 m
.80732 .66124 L
s
P
p
.67 0 1 r
.01 w
.80745 .66304 m
.80745 .66304 L
s
P
p
.685 0 1 r
.01 w
.80758 .66484 m
.80758 .66484 L
s
P
p
.7 0 1 r
.01 w
.80772 .66664 m
.80772 .66664 L
s
P
p
.715 0 1 r
.01 w
.80785 .66844 m
.80785 .66844 L
s
P
p
.73 0 1 r
.01 w
.80798 .67025 m
.80798 .67025 L
s
P
p
.746 0 1 r
.01 w
.80812 .67206 m
.80812 .67206 L
s
P
p
.761 0 1 r
.01 w
.80825 .67387 m
.80825 .67387 L
s
P
p
.776 0 1 r
.01 w
.80838 .67568 m
.80838 .67568 L
s
P
p
.791 0 1 r
.01 w
.80852 .67749 m
.80852 .67749 L
s
P
p
.806 0 1 r
.01 w
.80865 .6793 m
.80865 .6793 L
s
P
p
.821 0 1 r
.01 w
.80878 .68112 m
.80878 .68112 L
s
P
p
.836 0 1 r
.01 w
.80892 .68294 m
.80892 .68294 L
s
P
p
.851 0 1 r
.01 w
.80905 .68476 m
.80905 .68476 L
s
P
p
.866 0 1 r
.01 w
.80919 .68658 m
.80919 .68658 L
s
P
p
.882 0 1 r
.01 w
.80932 .6884 m
.80932 .6884 L
s
P
p
.897 0 1 r
.01 w
.80945 .69022 m
.80945 .69022 L
s
P
p
.912 0 1 r
.01 w
.80959 .69205 m
.80959 .69205 L
s
P
p
.927 0 1 r
.01 w
.80972 .69388 m
.80972 .69388 L
s
P
p
.942 0 1 r
.01 w
.80986 .69571 m
.80986 .69571 L
s
P
p
.957 0 1 r
.01 w
.80999 .69754 m
.80999 .69754 L
s
P
p
.972 0 1 r
.01 w
.81013 .69937 m
.81013 .69937 L
s
P
p
.987 0 1 r
.01 w
.81026 .7012 m
.81026 .7012 L
s
P
p
1 0 .997 r
.01 w
.8104 .70304 m
.8104 .70304 L
s
P
p
1 0 .982 r
.01 w
.81053 .70487 m
.81053 .70487 L
s
P
p
1 0 .967 r
.01 w
.81067 .70671 m
.81067 .70671 L
s
P
p
1 0 .952 r
.01 w
.8108 .70855 m
.8108 .70855 L
s
P
p
1 0 .937 r
.01 w
.81094 .7104 m
.81094 .7104 L
s
P
p
1 0 .922 r
.01 w
.81107 .71224 m
.81107 .71224 L
s
P
p
1 0 .907 r
.01 w
.81121 .71408 m
.81121 .71408 L
s
P
p
1 0 .892 r
.01 w
.81135 .71593 m
.81135 .71593 L
s
P
p
1 0 .877 r
.01 w
.81148 .71778 m
.81148 .71778 L
s
P
p
1 0 .861 r
.01 w
.81162 .71963 m
.81162 .71963 L
s
P
p
1 0 .846 r
.01 w
.81176 .72148 m
.81176 .72148 L
s
P
p
1 0 .831 r
.01 w
.81189 .72334 m
.81189 .72334 L
s
P
p
1 0 .816 r
.01 w
.81203 .72519 m
.81203 .72519 L
s
P
p
1 0 .801 r
.01 w
.81216 .72705 m
.81216 .72705 L
s
P
p
1 0 .786 r
.01 w
.8123 .72891 m
.8123 .72891 L
s
P
p
1 0 .771 r
.01 w
.81244 .73077 m
.81244 .73077 L
s
P
p
1 0 .756 r
.01 w
.81258 .73263 m
.81258 .73263 L
s
P
p
1 0 .741 r
.01 w
.81271 .73449 m
.81271 .73449 L
s
P
p
1 0 .725 r
.01 w
.81285 .73636 m
.81285 .73636 L
s
P
p
1 0 .71 r
.01 w
.81299 .73823 m
.81299 .73823 L
s
P
p
1 0 .695 r
.01 w
.81313 .74009 m
.81313 .74009 L
s
P
p
1 0 .68 r
.01 w
.81326 .74197 m
.81326 .74197 L
s
P
p
1 0 .665 r
.01 w
.8134 .74384 m
.8134 .74384 L
s
P
p
1 0 .65 r
.01 w
.81354 .74571 m
.81354 .74571 L
s
P
p
1 0 .635 r
.01 w
.81368 .74759 m
.81368 .74759 L
s
P
p
1 0 .62 r
.01 w
.81382 .74946 m
.81382 .74946 L
s
P
p
1 0 .605 r
.01 w
.81395 .75134 m
.81395 .75134 L
s
P
p
1 0 .589 r
.01 w
.81409 .75322 m
.81409 .75322 L
s
P
p
1 0 .574 r
.01 w
.81423 .75511 m
.81423 .75511 L
s
P
p
1 0 .559 r
.01 w
.81437 .75699 m
.81437 .75699 L
s
P
p
1 0 .544 r
.01 w
.81451 .75888 m
.81451 .75888 L
s
P
p
1 0 .529 r
.01 w
.81465 .76076 m
.81465 .76076 L
s
P
p
1 0 .514 r
.01 w
.81479 .76265 m
.81479 .76265 L
s
P
p
1 0 .499 r
.01 w
.81493 .76455 m
.81493 .76455 L
s
P
p
1 0 .484 r
.01 w
.81506 .76644 m
.81506 .76644 L
s
P
p
1 0 .469 r
.01 w
.8152 .76833 m
.8152 .76833 L
s
P
p
1 0 .453 r
.01 w
.81534 .77023 m
.81534 .77023 L
s
P
p
1 0 .438 r
.01 w
.81548 .77213 m
.81548 .77213 L
s
P
p
1 0 .423 r
.01 w
.81562 .77403 m
.81562 .77403 L
s
P
p
1 0 .408 r
.01 w
.81576 .77593 m
.81576 .77593 L
s
P
p
1 0 .393 r
.01 w
.8159 .77783 m
.8159 .77783 L
s
P
p
1 0 .378 r
.01 w
.81604 .77974 m
.81604 .77974 L
s
P
p
1 0 .363 r
.01 w
.81618 .78164 m
.81618 .78164 L
s
P
p
1 0 .348 r
.01 w
.81632 .78355 m
.81632 .78355 L
s
P
p
1 0 .332 r
.01 w
.81647 .78546 m
.81647 .78546 L
s
P
p
1 0 .317 r
.01 w
.81661 .78737 m
.81661 .78737 L
s
P
p
1 0 .302 r
.01 w
.81675 .78929 m
.81675 .78929 L
s
P
p
1 0 .287 r
.01 w
.81689 .7912 m
.81689 .7912 L
s
P
p
1 0 .272 r
.01 w
.81703 .79312 m
.81703 .79312 L
s
P
p
1 0 .257 r
.01 w
.81717 .79504 m
.81717 .79504 L
s
P
p
1 0 .242 r
.01 w
.81731 .79696 m
.81731 .79696 L
s
P
p
1 0 .227 r
.01 w
.81745 .79888 m
.81745 .79888 L
s
P
p
1 0 .212 r
.01 w
.8176 .80081 m
.8176 .80081 L
s
P
p
1 0 .196 r
.01 w
.81774 .80273 m
.81774 .80273 L
s
P
p
1 0 .181 r
.01 w
.81788 .80466 m
.81788 .80466 L
s
P
p
1 0 .166 r
.01 w
.81802 .80659 m
.81802 .80659 L
s
P
p
1 0 .151 r
.01 w
.81816 .80852 m
.81816 .80852 L
s
P
p
1 0 .136 r
.01 w
.81831 .81046 m
.81831 .81046 L
s
P
p
1 0 .121 r
.01 w
.81845 .81239 m
.81845 .81239 L
s
P
p
1 0 .106 r
.01 w
.81859 .81433 m
.81859 .81433 L
s
P
p
1 0 .091 r
.01 w
.81873 .81627 m
.81873 .81627 L
s
P
p
1 0 .076 r
.01 w
.81888 .81821 m
.81888 .81821 L
s
P
p
1 0 .06 r
.01 w
.81902 .82015 m
.81902 .82015 L
s
P
p
1 0 .045 r
.01 w
.81916 .82209 m
.81916 .82209 L
s
P
p
1 0 .03 r
.01 w
.81931 .82404 m
.81931 .82404 L
s
P
p
1 0 .015 r
.01 w
.81945 .82599 m
.81945 .82599 L
s
P
p
.002 w
.63111 .02429 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.63111 .02429 m
.11976 .13514 L
s
P
p
p
.002 w
.11976 .13514 m
.63111 .02429 L
s
P
p
.002 w
.23603 .10993 m
.243 .11459 L
s
P
[(5)] .22208 .10062 .837 1 Mshowa
p
.002 w
.38479 .07768 m
.39154 .08244 L
s
P
[(10)] .37129 .06817 .79276 1 Mshowa
p
.002 w
.53751 .04458 m
.54402 .04944 L
s
P
[(15)] .52449 .03486 .74852 1 Mshowa
p
.001 w
.26547 .10355 m
.26963 .10636 L
s
P
p
.001 w
.29507 .09713 m
.2992 .09995 L
s
P
p
.001 w
.32482 .09069 m
.32892 .09352 L
s
P
p
.001 w
.35472 .0842 m
.3588 .08704 L
s
P
p
.001 w
.41501 .07113 m
.41903 .074 L
s
P
p
.001 w
.44539 .06455 m
.44939 .06743 L
s
P
p
.001 w
.47594 .05793 m
.4799 .06082 L
s
P
p
.001 w
.50664 .05127 m
.51058 .05417 L
s
P
p
.001 w
.20673 .11628 m
.21094 .11906 L
s
P
p
.001 w
.17759 .1226 m
.18183 .12537 L
s
P
p
.001 w
.1486 .12888 m
.15286 .13164 L
s
P
p
.001 w
.56854 .03785 m
.57242 .04078 L
s
P
p
.001 w
.59974 .03109 m
.60359 .03403 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004P0
0ol300;o0`03o`800ol20003o`000;X000170007o`000?l0o`020003o`3o008000Ko003o0?l20003
o`000;X0001;0003o`3o008000?o0?l00P001_l00?l0o`8000?o0000<@03o`<00on00000B003o`80
00Ko003o0?l20006o`00o`3o0P000ol0000b0003o`0000D000?o0000O@0004L000?o00001002o`80
00Go003o0006ocD000?o00001@000ol0001m0000A`001Ol0003o00`000?o0?l0=`000ol0000200?o
P00004P00ol?0003o`0003D000?o00000P000ol0000K00CoH@0009400_l400Co5@05o`8000?o0?l0
H0000:/01Ol70004o`00oel0002W00Co1@000ol000040003o`0000?oG@000:801_l=00Go0`000ol0
001J0000J003o`@00_l/00Go3P05o`:10ol40003o`0005T0001Y0003o`00008000Co003o9`04o`80
00?oP@001P09o`B10ol2P@03o`00008000?o0000F00006T000?o00000P001?l00?lR00Go1`001?n1
0004o`B100?oPH401?l01K_;^h7o00>10_l00`3oo`02oeP0001Y0003o`00008000Co003o7@05o`<0
00?o00001P04o`V10_l8^`03oh6100:10_l40003o`0000T00om90000J@000ol000020004o`00oaP0
1Ol=00Co0h400on1P@05o`0=^l^kbk_;^l^kbk_;o`03P@Go0`000ol0000;0003o`0004H0001X00;o
1@02oaD01?l50003o`0000H01?l8P@;o4K/01?nkool5P@03o`3o00?o2`000ol000160000P@06o`d0
1?l3P@03oh6100Co01W;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00J100?o00000P000ol0000500?o
B@0007`01Ol60003o`0000D01Ol4P@;o0X42oaVk00?o^k/00[/4P@03oh7o00@000?o000010000ol0
00190000AP03obl01?l200;o2P06o`B11?l08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
bk_;00Go0h400ol00002P@03o`0000<01?m80000B@000ol0000W00Go3008o`:11?lU^`Co18400on1
P@02P@?o0P02odl000190003o`0002801Ol40003oh4000H01?l8P@;o02?;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`07o`V100KoPH7oPOl40003o`0004`0001600?o8@05o`X00X45o`>1
00?oPH401?lQ^`Ko1X42o`V10_l3P@04o`0000;oC@0004H000?o00007005o`D000?o00001@04o`V1
0_l03/^kbk_;^l^kbk_;^l^k1_l03L^kbk_;^l^kbk_;^l/01?l3P@03oh6100N100?oPH401Ol01<^k
bk/4P@?o0P02ob`01Ol01@3oool000?o0`02o`d0001600Co5P05o`030?oo00/01?l4P@03oh6100Co
18400onk^`07^`Co1U/2o`Vk0_l8P@03oh6100J10ol:^`>100?oPOl010000ol0000Y0003o`000080
00Co003o10001?l00?l>0000G004o`h01_l4P@;o0X42o`V100cobk_;^l^kbk_;^ol9F`0<ok_;^l^k
bk_;^l_o28400on1P@04o`0?^onkbk_;^l^kbk_;^l^k00;o0h400ol000020003o`0002P000?o0000
0`03o`800_l30003o`0000`0001G00Go0`000ol0000600Oo1H44o`Jk00?oPH401h400onk^`08^`03
oe]K00MK0_l9^`03oh6100:10_l2P@;o1K/00onk^`0=^`B11_lY00Go0`000ol0o`050003o`0000`0
001B00Go3@04o`>100?oPH401?l03/^kbk_;^l^kbk_;^l_o0X44o`0?bk_;^l^kbk_;^l^kbk_o009K
1?l4F`0:ol^kbk_;^l^kb`Co1X42o`0D^l^kok_;^l^kbk_;^l^kbk_;^l/4P@;o0`02obL000?o0000
0`02o`<00ol0103oool=0000C@05o`D000?o00001P04o`R10_l@^`Co4k/2o`UK00?o^k/02;/00on1
P@07P@04ok^koa6k1_l40003o`0002@000?o00003@000ol0000<0000B@04o`030?oo00`01?l3P@03
oh6100Co013;^l^kbk_;^l^kbk_;^l^k1?l4F`;o00O;^l^kbk_;00Co00Vkbk_;^l^kbol02E/2o`0:
^l^kbk_;^l^ko`F10_l2P@?o01:kbk_;^l^kbk_;^l^kbk_;^l/5P@Ko9@05oaX0001400Go1`000ol0
000400Go1842o`:10_l>^`Ko2U/00onk^`04o`B100?o^k/01[/00omKF`04o`AK00?o^k/01k/5o`J1
00?o^k/04K/5P@;o0`02o`X00ol400;o;`0003l01Ol40003o`0000H000>1ool01?l4P@Co013;^l^k
bk_;^l^kbk_;^l^k1?l6F`;o2E/2o`V100Wo^l^kbk_;^l/00_l9F`0<ok_;^l^kbk_;^l_o2842o`0C
bk_;^l^kbk_;^l^kbk_;^l^kb`03P@Co10000ol000080003o`00008000Co003o;P0003/01Ol<00So
0X44oaRk0_l8F`03oe]K00Co1;/00on1P@07P@;o2;/00omKF`07F`03ok^k00Rk00?oPH401H401?n1
oolB^`;o18400ol0o`03o`T000?o00000P001?l00?l^0000=P05o`D000?o00001@04o`R10_l04<^k
bk_;^l^kbk_;^l^kbk/4o`0;bk_;^l^kbk_;^ol015/2o`9K0_l02[_;^l^kbk_;^ol2P@Co18402_o;
^l^kbk_;^ol2F`Co00nkbk_;^l^kbk_;^l^kbol00X45o`>101Co^l^kbk_;^l^kbk_;^l^kbk_;^`F1
0_l30003o`0000H000?o00000P001?l00?l^0000<@05o`030?l000/01?l3P@03oh6100Co4K/3o`AK
0_l9^`Co3[/4o`V100?o^k/01[/2oa>k0_l4P@03oh6100:100?o^k/04K/3P@04oh7oo`<00_l60003
o`00008000Co003o;P0002l00_l70003o`0000@01_l4P@03oh6100;o00o;^l^kbk_;^l^kbk_;^l/0
1_l9F`0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l4P@03oh6100N1023obk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`>100?oPH400h42o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l4P@;o0h400ol0
000200;o1@02obl0000_0003o`3o00T01Ol5P@Co4;/4o`IK00?oFe/01e/00onk^`0=^`Ko2H400on1
P@04ob:k00?oPH401?l4P@03ok^k016k1H42o`<000?o0000>@0002l000?o00000_l00`3oo`06o`:1
1?l06K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol025/00omKF`04o`0<^l^kbk_;^l^kbk_;1_l6P@;o
2842o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l04/^kbk_;^l^kbk_;^l^kbk_;^`?o28405?o;^l^kbk_;
^l^kbk_;^l^kbk_;0h401?n1ool300;o>@0002l000?o0?l00ol8P@;o7K/00omKF`02F`;o0U/2o`bk
1?l4P@;o28400on1P@03oa6k1?l4F`03ok^k016k00?oPH401h42oa:k0_l4P@03o`3o00?o>00002l0
0_l3P@03oh6100Co02:kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l03[_;^l^kbk_;
^l^kbk_;1?l:P@03oh6100:10_l2P@;o01;;^l^kbk_;^l^kbk_;^l^kbk/2o`UK01?obk_;^l^kbk_;
^l^kbk_;^l^k00;o0X44o`B101Co^l^kbk_;^l^kbk_;^l^kbk_;^`F10_l30003o`0003D0000V00;o
1`02o`B10_le^`?o1842o`V11?lJ^`03oe]K00MK00?o^k/03K/6o`V100?o^k/04K/3P@04oh7oo`<0
00?o0000=00002D000Co003o1@000ol00002o`B10_l0<K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l9P@03oh6100Co18407_nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`9K1?l03<^kbk_;^l^kbk_;^`Ko0X401On1PH7o00V101Co^l^kbk_;^l^kbk_;^l^k
bk_;^`;o18400ol0o`03oc@0000U0004o`00o`D000?o00000`05P@03ok^k02Bk1?l8^`03oh6100N1
0_l9P@03ok^k01Zk0_l<^`Co18401On1PH7o00B100?oPH401?lH^`F10_l30003o`000340000U0004
o`00o`D000?o000010000on1P@02P@;o023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co
15/02_nkbk_;^l^kbol2P@Co18400on1P@07P@0Bok_;^l^kbk_;^l^kbk_;^l^k1?l04<^kbk_;^l^k
bk_;^l^kbk/4o`V100GoPH7oP@02o`:10_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>1
00CoPOoo0`000ol0000`00009@001?l00?l50003o`0000D00_l4P@;o7;/2o`UK00?o^k/01[/2o`V1
00?oPH401?l@^`Co15/00onk^`09^`Co18400on1P@07P@Co8;/6o`>10_l00`3oo`02oc00000V00;o
1P000ol000070003oh6100>101ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`QK0_l02<^k
bk_;^l^k0_l8P@;o01;;^l^kbk_;^l^kbk_;^l^kbk/2o`UK00Wobk_;^l^kbk/00_l9P@03oh6100Co
023;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Ko1U/01?n1PH42o`@000?o00002@03o`<0
0olK0000;P03o`T000?oPH400X42oafk00?oFe/00ol4F`;o2;/00on1P@03o`bk1?l8^`03oe]K00MK
00?o^k/01k/00on1P@07P@;o2;/00onk^`0E^`Co15/00omKF`06F`05oh61oh400_l30003o`0000T0
00?o00001@000ol0000H0000;P000ol0000:00;o18407_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`;o2E/02Onkbk_;^l^kb`02o`0<^l^kbk_;^l^kbk_;0ol4P@;o00S;^l^kbk_;o`9K1?l03/^k
bk_;^l^kbk_;^l_o0X44o`B101co^l^kbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^k1?l9F`03oe]K009K
0_l2F`;o18400ol0o`02o`X000?o00001@000ol0000H0000;P000ol0000<0003oh6100:100?o^k/0
7;/00omKF`07F`03ok^k00nk1?l9P@03ok^k00Fk0_lB^`;o2H400onk^`04^`03ok^k00fk1?l4F`03
oe]K00MK1?l6F`03oh6100:100Co00000_l80003o`0000800olK0000;P000ol0000=0003oh6100:1
0_l07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`9K1?l04;_;^l^kbk_;^l^kbk_;^l/4o`B1
00?oPH401h42o`0K^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2842o`0>bk_;^onkbk_;^l^k
bk/6o`UK00?oFe/01?l01L^kbk_o00QK00GoPH7oP@02o`<000?o00001@000ol000020003o`0001/0
000]0003o`0000l00_l4P@;o7;/2oa:k0_l9P@03oh6100Co18400onk^`0H^`Ko1X401Onk^k_o00>k
1_l6F`03oe]K00MK0_l9^`03oe]K009K0_l2F`;o18401On1PH7o00D00_l400Co6P0002d000?o0000
4P05P@0col^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00V1
0_l9P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol4F`;o1h400oo;^`04o`AK00?oFe/01U/00omK
F`04o`0<bk_;^l^kbk_;^l^k1_l6F`03oh6100:100Co00000_lW0000;@000ol0000B0003POn100>1
0_l`^`03oh6100Co18400on1P@07P@03ok^k016k0_l9F`03oh6100:100?oPH400ol8F`03oe]K009K
0_l2F`;o3;/4o`AK00?oFe/01U/01On1POn100;o0`000ol0000T0000;@000ol0000B0004P@3oo`B1
037o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2H400on1
P@04o`0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`09F`Co1H42o`QK1?l03/^kbk_;^l^kbk_;^l^k
1?l9F`03oe]K009K0_l2F`;o1845obD0000]00?o4@000h4000020003oh6100:100?o^k/09;/4o`Nk
0ol7P@;o7K/00omKF`04o`Bk00?oPH401H400omKF`04o`AK00?o^k/02K/4o`AK00?oFe/01e/4o`Fk
1H42o`<000?o00008P0002d000?o00004@000h40000400;o0X42o`0Pbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/4o`AK00[o^l^kbk_;^l^k1?l5P@0Nol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0_l02[_;^l^kbk_;^ol4P@03oh7o00;o0e/3G`=K00Wobk_;^l^kbk/00_l9F`03oaLG008G
0_l03<^kbk_;^l^kbk_;^`>100?oPOl00_l200;o8P0002d000?o00004@000h4000060004oh61P@;o
7;/2o`UK00?o^k/02;/00on1P@05P@03ok^k02Jk1?l2^`04ok^ko`9K15l3F`;o2;/2o`AK00QO5elG
GaLA5`nk0_l4P@Ko8@0002d000?o00004@000h4000070003oh6100:101oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00UK0_l02/^kbk_;^l^kbol4P@03oh6100;o036kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l_o009K1El03amKFonkbk_;^l^k5elGG`075`0D
FaLGbk_;^l^kbk_;^l^kbk_;^l/5P@;o0`000ol0000N0000;@000ol0000A0003P@0000T00_l2P@;o
7;/00omKF`04o`AK00?o^k/01k/4o`F10_lZ^`09ok^kGamO7elO00AO0U/55`06GaMO5elG0Ul00aMO
F`04F`8G4k/3o`03POoo00Co7`0002`000?o00004P000h40000:0003oh6100:10_l06k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`UK00cobk_;^l^kbk_;^ol8P@0dol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kGaMO5eooF`UO00XGGaMO5k_;^l_o15/2o`0G4AOo^l^k
bk_;^l^kbk_;^l^kbk_;^l/01842o`030?l001h0000/0003o`00018000>100002`000on1P@03P@;o
6k/3o`MK00?o^k/02;/00on1P@02P@;o0X42obNk00?o^k/00[/00elOG`027`03GaLG00<G0e/00onk
^`07^`Co0U/24@03Fonk01>k1843oal0000/00?o4P000h40000>00;o0h42o`0J^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/6o`0?^l^kbk_;^l^kbk_;^l^k00Co1X42o`0Ybk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kboo;^l/00_l00amO7`02G`037elO00IK00cobk_;^l^kbk_;^ol3F`0I
Wa5KFonkbk_;^l^kbk_;^l^kbk_;^l^kb`06oal0000/0003o`00018000>100003`000on1P@03P@03
ok^k01>k1?l4F`03ok^k012k00?oPH401h42ob>k1?l015]OGel47`03GamO009K0_l2F`03ok^k00Rk
00?oFe/00Yl00omKF`02o`bk1?l5P@:k0_lN0000;0000ol0000B0003P@00010000?oPH400h42o`0>
bk_;^l^kbk_;^l^kbk/5o`UK01Co^l^kbk_;^l^kbk_;^l^kbk_;o`:11?l4P@0Ook_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`05o`9K00LOGalG7aLO00=O0al03aO;^l^kbk_;^l^kbk_;^`04o`:O
1E/2o`04^l^kb`Ko1H45o`030?l001h0000/0003o`00018000>100004P02o`B100?o^k/01k/4o`EK
00?oFe/01e/00onk^`0@^`;o2H400onk^`0E^`Ko15/02OmKFaMO5elGG`02o`8O00FkGalOG`09^`Co
0e/01?oOgil6F`Co1846o`P000?o0000700002`000?o00004@000h40000E0003oh6100:100cobk_;
^l^kbk_;^ol7F`03oe]K00Co01Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@;o017;^l^kbk_;^l^k
bk_;^l^kb`04o`IK0_l2F`06oe]K7aLO0_l03K_;^l^kbk_;5alG7el01_l8F`>O1?l9P@;o3@000ol0
000L0000;0000ol0000A0003P@0001D000>1oh400h42o`Vk00?oFe/00U/00omKF`02oabk00?oPH40
1?l4P@03ok^k012k00?oFe/01e/4o`fk0_l01ElOGamO00EK0_l7F`:O1X44oa8000?o0000700002`0
00?o00004@000h40000E0004P@3oo`B10_l02<^kbk_;^l^k1?l08/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/2o`V100Gobk_;^`06o`09bk_;^l^kbk_o009K1?l03k_;^l_obk_;^l^kbk_;
^`04o`=K00HG7elOGal5F`Co0h4019oOool3P@03o`0001@000?o0000700002/000?o00004P000h40
000E0003P@0000801H400onk^`0]^`;o2844o`IK0_l7^`;o2;/00onk^`03^`Go1E/57`03GamO00?o
28400ooOW`040003P@0001D000?o0000700002/000?o0?l04P000h40000E0003P@0000<000?oPH40
0X42o`0`^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o0X43o`AK
00?oFe/01e/04onkbk_;^l^kbk_;^l^kbk_;ol/01?l5F`0=7elOGamO7elOGomO7`05P@Co0`02g`@0
00>100005@000ol0000L0000:`02oa<000>100005@000h40000400;o18400onk^`0Y^`Ko25/00omK
F`04oa>k00?o^k/03Ql4P@Co0h400ol0000500;O1@000h40000D0003o`0001`0000[0003o`000180
00>1000050000h4000070003oh6100:101;o^l^kbk_;^l^kbk_;^l^kbk/4o`0Abk_;^l^kbk_;^l^k
bk_;^l/01?l6F`;o1e/2o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^aoo1al015lOGal8P@;o3P000mkO
00040003P@0001@000?o0000700002/000?o00004P000h40000D0003P@0000T00_l2P@;o2k/4o`AK
00?o^k/04;/00omKF`07F`Co1H400onk^`0C^`037olO008O1?l5P@Co4`000moN00040003P@0001@0
00?o0000700002/000?o00004P000h40000D0003P@0000X000?oPH400X42o`07^l^kbk_;^`02o`UK
00Gobk_;^`06o`09bk_;^l^kbk_o009K1?l01K_;^l_o00N101;obk_;^l^kbk_;^l^kbk_;^l/6o`B1
1?l2P@03o`0001D00]l50003P@0001D000?o00006`0002/000?o00004P000h40000D0003P@0000/0
00?oPH400h42o`Nk0_l8F`Co1U/2o`Nk0_l9^`03oh6100:100?oPH400_l<^`?o18400on1P@02P@;o
7@02gPD000>100005@000ol0000K0000:`000ol0000B0003P@0001@000>100003@02o`B100[obk_;
^l^kbk_o0U/3o`AK00?oFe/01e/04onkbk_;^l^kbk_;^l^kbk_;^l/01?l5P@;o00C;^l^k1_l4P@Go
0P000h40000M0003g]l000@000>100005@000ol0000K0000:`000ol0000A0003P@0001D000>10000
3`000on1P@02P@03ok^k00Jk0_l8F`03oe]K00Co5k/00on1P@06P@Co1845o`@000Go0000P@0O0003
gmh000@000>100005@000ol0000K0000:P001?l0oolA0003P@0001D000>100004@001?n1PH42o`08
^l^kbk_;^l/2o`MK0_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00:10ol9P@03o`0000L0
00Go0000P@0O00;N1@000h40000E0003o`0001/0000Z0003oh61018000>100005@000h40000B00;o
0h400onk^`07^`Co7[/6o`B11Ol=0005o`0008407`000moNgP040003P@0001D000?o00006`0001X0
0ol400;o1`000ol00002PA0000>100005@000h40000D000Yoh61POnkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/01_l4P@Go4`001Ol0002102000]h40003P@0001D000?o00006`0001/0
00?o00000P001?l00?l60003o`00008000>100003@000h40000E0003P@0001@000F1ooooP@02oank
0ol9P@03o`0001H000Go0000P@0P0003LMh000<000>100005@000ol0000K00006`000ol000020004
o`00o`H000?o00000`02P@d000>100005@000h40000D0004P@00o`>10ol05/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/6o`B11OlL0005o`0008408002gP@000>100005@000ol0000K00006`000ol000020004
o`00o`H000?o00001@02P@/000>100005@000h40000D0005P@000?l01H42o`jk1_l4P@Co00<0P@00
80001Ol0002102000]h40003P@0001D000?o00006`0001/000?o00000P001?l00?l60003o`0000L0
00>1000020000h40000E0003P@0001@000>100000`02o`B100_o^l^kbk_;^l^kb`03o`>10ol3P@03
o`0000<000>100007`001Ol0002102000W450003P@0001D000?o00006P0001X00_l500;o1`000ol0
000800:120000h40000E0003P@0001@000>100001@000on1P@02P@03ok^k00:k1Ol5P@;o2`000h40
000P0005o`0008407`000mia00040003P@0001D000?o00006P0002X00_l;00:11P000h40000E0003
P@0001@000>100001P000on1P@02P@Co0h44oa0000>1000080001Ol0002101l000=agP0010000h40
000E0003o`0001X0000Y00;o3P000h4000030003P@0001D000>1000050000h40000700;o0k/3o`:1
00?o00004P000h40000P0005o`0008407`02L@D000>100005@000ol0000J0000:@000ol0000>00:1
0`000h40000D0003P@0001@000>100002P03oaX000>1000080001Ol0002101l000?ML@0010000h40
000E0003o`0001X0000Y0003o`0001000h4G0003P@0001@000>100002P000ol0000J0003P@000200
00Go0000P@0O0003LID000@000>100005@000ol0000J0000:@000ol0000B00:15P000h40000D0003
P@0000X000?o00006P000h40000P0005o`0008407`000iEa00040003P@0001D000?o00006P0002T0
00?o00004P000h40P@0E0003P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0O0003
LID000@000>100005@000ol0000J0000:@000ol0000B0003P@0000:14`000h40000D0003P@0000X0
00?o00006P000h40000P0005o`0008407`000iGMU@040003P@0001D000?o00006P0002T000?o0000
4P000h40000200:14@000h40000D0003P@0000X000?o00006P000h40000P0005o`0008407`000mfE
g0040003P@0001H000?o00006@0002T000?o00004P000h4000040003P@0000h000>1000050000h40
000:0003o`0001X000>1000080001Ol0002102000YD40003P@0001H000?o00006@0002T00olB0003
P@0000D00X4>0003P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0P00:E10000h40
000F0003o`0001T0000X0003o`0001<000>100001`02P@`000>1000050000h40000:0003o`0001X0
00>1000080001Ol0002102000]`40003P@0001H000?o00006@0002P000?o00004`000h4000090003
P@0000T000>1000050000h40000:0003o`0001X000>1000080001Ol0002102000]`50003P@0001D0
00?o00006@0002P000?o00004`000h40000:00:12@000h40000D0003P@0000X000?o00006P000h40
000P0005o`0008408002g0D000>100005@000ol0000I0000:0000ol0000C0003P@0000`00X470003
P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0P0003g>`000@000>100005@000ol0
000I0000:0000ol0000B0003P@0000l000>1000010000h40000D0003P@0000X000?o00006P000h40
000P0005o`00084080000ncL00040003P@0001D000?o00006@0002P000?o00004P000h40000@00:1
10000h40000D0003P@0000X000?o00006P000h40000P0005o`00084080000ncL00040003P@0001<0
0X400on1000I0000:0000ol0000B0003P@0001800X420003P@0001@000>100002@000ol0000K0003
P@00020000Go0000P@0P0003k=`000@000>100003P05P@<000?o0000600002P00olB0003P@0001@0
0h4F0003P@0000T000?o00006`000h40000P0005o`0008408002g0D000>100002006P@P000?o0000
600002P000?o00004P000h40000E00:15P000h4000090003o`0001/000>1000080001Ol000210200
0^`50003P@0000801X4>0003o`0001P0000W0003o`0001<000>100005@001840PH4D0003P@0000T0
00?o00006`000h40000P0005o`00084080000ncL000400F150000ol0000H00009`000ol0000C0003
P@0001D000B100000X4B0003P@0000T000?o00006`000h40000P0005o`00084080000mc/g005PAP0
00?o0000600002L000?o00004`000h40000E0003P@0000<000>100003`000h4000090003o`0001/0
00>1000080001Ol0002101`01H42k0@000>100005P000ol0000H00009`000ol0000C0003P@0001D0
00>100001002P@l000>100002@000ol0000K0003P@00020000Go0000P@0F00J11@000nbg00030003
P@0001H000?o0000600002L000?o00004`000h40000E0003P@0000H00X4=0003P@0000T000?o0000
6`000h40000P0005o`0008404@05P@/00[L50003P@0001D000?o0000600002L000?o00004`000h40
000E0003P@0000P000>100002@000h40000:0003o`0001/000>1000080000ol000020003P@0000P0
1X4@0003]kH000@000>100005@000ol0000H00009`03oa8000>100005P000h40000900:12@000h40
000:0003o`0001/000>1000080000ol000020003P@0000801X4F00:f1@000h40000E0003o`0001P0
000W0003o`00018000>100005P000h40000;00:11`000h40000:0003o`0001/000>1000080000ol0
000200F17002]PD000>100005P000ol0000G00009`000ol0000B0003P@0001H000>100003@02P@D0
00>100002P000ol0000K0003P@0001l000>1oh40184P0003]kH000@000>100005P000ol0000G0000
9P000ol0000C0003P@0001H000>100003`000h4000020003P@0000X000?o00006`000h40000J00F1
00<0o`000`000h40000N00:f1@000h40000F0003o`0001L0000V0003o`0001<000>100005P000h40
000@00:10P000h40000:0003o`0001/000>100005006P@H000?o00000P000h40000N00:f1@000h40
000F0003o`0001L0000V0003o`0001<000>100005P000h40000B00>130000ol0000K0003P@0000h0
1X4=0005o`00084080000obf00040003P@0001H000?o00005`0002H000?o00004`000h40000F0003
P@0001@000>100002P000ol0000K0003P@0000T01H4C0005o`0008408002]PD000>100005P000ol0
000G00009P000ol0000C0003P@0001H000>100005003P@X000?o00006`000h40000300J160001Ol0
002102000[D50003P@0001H000?o00005`0002H000?o00004`000h40000F0003P@0001@000>10000
0X480003o`0001/01X4N0005o`00084080000kJeo0040003P@0001H000?o00005`0002H000CoPOoo
4P000h40000F0003P@0001@000>100000P000h4000050003o`0001H01X4S0005o`00084080000kD=
]@040003P@0001H000?o00005`0001H01?l300;o1`001?l0PH4B0003P@0001D000>100005@000h40
000300:11@000ol0000A00F11@000h40000Q0005o`0008408@000`fe00030003P@0001L000?o0000
5P0001L000?o00000P001?l00?l60005o`0008404@000h40000E0003P@0001D000>100001@02P@<0
00?o00002`06P@X000>100008@001Ol0002102400[D50003P@0001H000?o00005P0001P000Go0000
o`020003o`0000<000?o00000`02P@h000>100005P000h40000E0003P@0000L000B1003o1`06PA00
00>100008@001Ol0002102400[D50003P@0001H000?o00005P0001T000Co003o0P000ol000030003
o`0000D00X4<0003P@0001H000>100005@000h40000800:100?o00001H4F0003P@00024000Go0000
P@0Q0003]@d000@000>100005P000ol0000F00000P03oa4000Co003o0P001?l00?l50003o`0000L0
0X4:0003P@0001H000>100005@000h40000:0003oh6101/000>100008@001Ol0002102400Pd50003
P@0001H000?o00005P00008000Co003o4@02o`@00_l60003o`0000T00X480003P@0001H000>10000
5@000h40000:0003o`0001/000>100008@001Ol0002102400Pd50003P@0001H000?o00005P000080
00?o000080000ol0000;0003P@0000D000>100005P000h40000E0003P@0000X000?o00006`000h40
000Q0005o`0008408@000`g<00040003P@0001H000?o00005P00008000?o000080000ol0000<00:1
1@000h40000F0003P@0001D000>100002P000ol0000K0003P@00024000Go0000P@0Q0003c0d000@0
00>100005P000ol0000F000000<0ool00_lP00?o3P02P@<000>100005P000h40000E0003P@0000X0
00?o00006`000h40000Q0005o`0008408@000l`=00040003P@0001H000?o00005P00008000?o0000
80000ol0000@00:100<0P@005`000h40000E0003P@0000X000?o00006`000h40000Q0005o`000840
8@000l`=00040003P@0001H000?o00005P00008000?o000080000ol0000B00:160000h40000E0003
P@0000X000?o00006`000h40000Q0005o`0008408@023@D000>100005`000ol0000E00009@000ol0
000C00:15`000h40000D0003P@0000/000?o00006`000h40000Q0005o`0008408@000`g<00040003
P@0001L000?o00005@0002@000?o000050001840PH4E0003P@0001@000>100002`000ol0000K0003
P@00024000Go0000P@0Q008=00?<00000P000h40000G0003o`0001D0000T0003o`0001<000>10000
0P02PA<000>1000050000h40000;0003o`0001/000>100008@001Ol0002102400l`40003P@0001L0
00?o00005@0002@000?o00004`000h40000400:14@000h40000D0003P@0000/000?o00006`000h40
000Q0003o`00008000>100007`02c0D000>100005P000ol0000E000090000ol0000C0003P@0000H0
00>100003P000h40000D0003P@0000/000?o00006`000h40000Q0003o`00008000>100007`02c0D0
00>100005P000ol0000E000090000ol0000C0003P@0000L00X4=0003P@0001D000>100002P000ol0
000L0003P@00024000?o00000P000h40000O00;01@000h40000F0003o`0001D0000T00?o4`000h40
000900:12`000h40000E0003P@0000X000?o000070000h40000Q0003o`00008000>100007`02`0D0
00>100005P000ol0000E000090000ol0000C0003P@0000/00X490003P@0001D000>100002P000ol0
000L0003P@00024000?o00000P000h40000O0003`<H000@000>100005P000ol0000E000090000ol0
000C0003P@0000d00X470003P@0001D000>100002P000ol0000L0003P@00024000?o00000P000h40
000O0003`<H000@000>100005`000ol0000D000090000ol0000C0003P@0000l000>1000010000h40
000E0003P@0000X000?o000070000h40000Q0003o`00008000>100007`000lK000040003P@0001L0
00?o0000500002<000?o000050000h40000@00:110000h40000E0003P@0000X000?o000070000h40
000Q0003o`00008000>100007`02aPD000>100005003P@03o`0001@0000S0003o`0001@000>10000
4P02P@8000>100005@000h40000:0003o`0001`000>100008@000ol000020003P@0001l00/H50003
P@0000h01X430003o`0001@0000S0003o`0001@000>100005003PAL000>100002P000ol0000L0003
P@00024000?o00000P000h40000O0003S<H000@000>100002@05P@T000?o0000500002<000?o0000
4`000h40000G0003P@0001D000>100002P000ol0000L0003P@00024000?o00000P000h40000O00:<
1@000h40000300J13P000ol0000D00008`000ol0000C0003P@0001L00h4E0003P@0000X000?o0000
70000h40000Q0003o`00008000>100007`000ha<S00400J150000ol0000D00008`03oa<000>10000
5`000h400002PA<000>100002P000ol0000L0003P@00028000Go0000P@0Q00:<00=<PH400h4I0003
o`0001@0000S0003o`0001<000>100005`000h40000200:14@000h40000:0003o`0001`000>10000
8P001Ol0002101`01X42S0D000>100005P000ol0000D00008`000ol0000C0003P@0001L000>10000
1002P@l000>100002P000ol0000L0003P@00028000Go0000P@0G00F11P02C0D000>100005`000ol0
000C00008`000ol0000C0003P@0001L000>100001P000h40000<0003P@0000X000?o000070000h40
000R0005o`0008404@06P@/000><C00010000h40000G0003o`0001<0000R0003o`0001@000>10000
5`000h40000700:130000h40000:0003o`0001`000>100008P001Ol0002100/01X4A00:<1@000h40
000G0003o`0001<0000R0003o`0001@000>100005`000h40000900:12P000h40000:0003o`0001`0
00>100008P001Ol0002100D01X4G009<1@000h40000G0003o`0001<0000R0003o`0001@000>10000
5P000h40000<00:120000h40000:0003o`0001`000>100008P001?l00006PAd000=<S00010000h40
000G0003o`0001<0000R0003o`0001@000>100005P000h40000>00:11@000h40000;0003o`0001`0
00>100008@000h7oP@03PB8000><C00010000h40000G0003o`0001<0000R0003o`0001@000>10000
5P000h40000@0003P@00008000>100002`000ol0000L0003P@0001/01X400`3o00020003P@000200
0T`50003P@0001L000?o00004`0002800olC0003P@0001L000>100004@02P@8000>100002`000ol0
000L0003P@0001D01X470005o`0008408P000de<00040003P@0001L000?o00004`00028000?o0000
4`000h40000G0003P@0001<00h4=0003o`0001`000>100003`06P@d000Go0000P@0R0003C4d000@0
00>100005`000ol0000C00008P000ol0000C0003P@0001L000>100005@02P@`000?o000070000h40
000900J14`001Ol0002102800T`50003P@0001L000?o00004`00028000?o00004`000h40000G0003
P@0001D000>108402`000ol0000L0003P@0000@01H4I0005o`0008408P000de<00040003P@0001P0
00?o00004P00024000?o000050000h40000G0003P@0001D000>100000X490003o`0001`01h4N0003
o`00008000>100007`02C003C@0000<000>100005`000ol0000B00008@000ol0000D0003P@0001L0
00>100005@000h40000200:11`000ol0000G00J190000ol000020003P@0001l000==C4`01@000h40
000G0003o`000180000Q0003o`0001@000>100005`000h40000E0003P@0000@00X450003o`000140
1X450003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180000Q0003o`0001@0
00>100005`000h40000E0003P@0000H00X430003o`0000/01X4;0003P@00028000?o00000P000h40
000P0003C4d000@000>100005`000ol0000B00008@000ol0000D0003P@0001L000>100005@000h40
00080004P@00o`P01H4A0003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180
000Q0003o`0001@000>100005`000h40000E0003P@0000T00X400ol00006PAH000>100008P000ol0
00020003P@0002000Td50003P@0001L000?o00004P00024000CoPOoo4`000h40000G0003P@0001D0
00>100002`000on1P@0L0003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180
000A00?o1002o`L000Co08614`000h40000G0003P@0001D000>100002`000ol0000M0003P@000240
00?o00000P000h40000P0003ITd000@000>100005`000ol0000B000050001?l00?l20003o`0000@0
00Co00000X4@0003P@0001P000>100005@000h40000;0003o`0001d000>100008@000ol000020003
P@00020000==IP0010000h40000H0003o`000140000D0004o`00o`8000?o00000`000ol0000400:1
3P000h40000G0003P@0001H000>100002`000ol0000M0003P@00024000?o00000P000h40000P009V
1@000h40000H0003o`000140000B00;o0`001?l00?l50003o`0000H00X4<0003P@0001L000>10000
5P000h40000;0003o`0001d000>100008@000ol000020003P@00020000==CP0010000h40000H0003
o`000140000D0004o`00o`8000?o00000`000ol0000800:12P000h40000G0003P@0001H000>10000
2`000ol0000M0003P@00024000?o00000P000h40000P0003ITd000@000>1000060000ol0000A0000
4@03o`@00_l60003o`0000X00X480003P@0001L000>100005P000h40000:0003o`0001h000>10000
8@000ol000020003P@00020000=VCP0010000h40000H0003o`000140000P0003o`0000`00X460003
P@0001L000>100005P000h40000:0003o`0001h000>100008@000ol000020003P@0002000VH60003
P@0001L000?o00004@00020000?o00003P02P@@000>100005`000h40000F0003P@0000X000?o0000
7P000h40000Q0003o`00008000>100008003IPD000>100005`000ol0000A00008003oa000X420003
P@0001L000>100005P000h40000:0003o`0001h000>100008@000ol000020003P@00024000=VCP00
10000h40000G0003o`000140000P0003o`0001800h4I0003P@0001D000>100002`000ol0000N0003
P@00024000?o00000P000h40000Q0003@Th000@000>100005`000ol0000A000080000ol0000D00:1
60000h40000E0003P@0000/000?o00007P000h40000Q0003o`00008000>100008@000diV00040003
P@0001L000?o00004@0001l000?o00005@001840PH4F0003P@0001D000>100002`000ol0000N0003
P@00028000Go0000P@0S0003IT8000@000>1000060000ol0000@00007`000ol0000D0003P@000080
0X4D0003P@0001D000>100002`000ol0000N0003P@00028000Go0000P@0S00921@000h40000H0003
o`000100000O0003o`0001@000>100001002PA8000>100005@000h40000;0003o`0001h000>10000
8P001Ol0002102<00T850003P@0001P000?o0000400001l000?o000050000h40000600:140000h40
000E0003P@0000/000?o00007P000h40000R0005o`0008408`000d9?00040003P@0001P000?o0000
400001l000?o000050000h40000800:13P000h40000E0003P@0000/000?o00007P000h40000R0005
o`0008408`000dm200040003P@0001P000?o0000400001l000?o000050000h40000:00:130000h40
000E0003P@0000/000?o00007P000h40000R0005o`0008408`02@PD000>1000060000ol0000@0000
7`000ol0000D0003P@0000`00X4:0003P@0001D000>100002`000ol0000N0003P@00028000Go0000
P@0S0003@Tl000@000>1000060000ol0000@00007`03oa@000>100003P02P@L000>100005P000h40
000;0003o`0001h000>100008P001Ol0002102<000=?@P0010000h40000H0003o`000100000O0003
o`0001@000>100004002P@D000>100005P000h40000;0003o`0001h000>100008P000ol000020003
P@0002000Tl60003P@0001L000?o0000400001h000?o00005@000h40000B00:10`000h40000F0003
P@0000/000?o00007P000h40000R0003o`00008000>100008003C`D000>100005@03P@03o`0000l0
000N0003o`0001D000>100005002P@03084001L000>100002`000ol0000N0003P@00028000?o0000
0P000h40000P00=?1@000h40000>00N10`000ol0000?00007P000ol0000E0003P@0001H00X4H0003
P@0000/000?o00007P000h40000R0003o`00008000>100008@000cm?00040003P@0000P01X4:0003
o`0000l0000N0003o`0001@000>100006003PAH000>100002`000ol0000N0003P@00028000?o0000
0P000h40000Q0003Ccl000@000B100001h4@0003o`0000l0000N0003o`0001@000>1000060000h40
0002PA@000>100002`000ol0000N0003P@00028000?o00000P000h40000Q008o0P07PAL000?o0000
3`0001h000?o000050000h40000H0003P@0000800X4B0003P@0000/000?o00007P000h40000R0003
o`00008000>100007`02P@04Ccn1P@<000>1000060000ol0000?00007P000ol0000D0003P@0001P0
00>100001002PA0000>100002`000ol0000N0003P@0001l01Ol30003P@0001P01h42009?1@000h40
000H0003o`0000l0000N0003o`0001@000>1000060000h40000600:13P000h40000;0003o`0001h0
00>100006007o`D00_l00`21000C00J12@02?`D000>1000060000ol0000?00007P02oaD000>10000
60000h40000800:130000h40000;0003o`0001h000>100004P06o`h000?oP@003007P@l000=??`00
10000h40000H0003o`0000l0000M0003o`0001D000>1000060000h40000:00:12P000h40000;0003
o`0001h000>100002`07oaD00_l500N15P000cm?00040003P@0001P000?o00003`0001d000?o0000
5@000h40000H0003P@0000`00X480003P@0000/000?o00007P000h40000500Ko7002P@;o0h4M008o
1@000h40000I0003o`0000h0000M0003o`0001D000>1000060000h40000>00:11@000h40000<0003
o`0001h000>1ool01OlL00N10`02oah000<o80001@000h40000H0003o`0000h0000M0003o`0001D0
00>1000060000h40000@00:10`000h40000<0003o`0001T01_lM00J11P000h40000300;o700280H0
00>1000060000ol0000>00007@000ol0000E0003P@0001P000>100004P02P@03084000d000?o0000
4P07o`D000>100005007P@`000>100001@000ol0000I008P1P000h40000H0003o`0000h0000M0003
o`0001D000>1000060000h40000D00:13P000ol0000<00Ko30000h40000=00N14`000h40000600;o
6@028@03800000<000>1000060000ol0000>00007@000ol0000D0003P@0001P000>100005P03P@`0
00?o00001@07oa8000>100001`06PAX000>100002002oaP00R050003P@0001P000?o00003P0001d0
00?o000050000h40000H0003P@0001H000>100000X4:0003o`3o00Go6@000h400007PB0000>10000
2P02oaH00R050003P@0001P000?o00003P0001d000?o000050000h40000H0003P@0001H000>10000
0P02P@<01olL00J19`000h40000<0003o`0001<00R450003P@0001P000?o00003P0001`000?o0?l0
5@000h40000H0003P@0001H000B100001_l50003o`0001@01h430003P@0002L000>100003@02oa<0
0R450003P@0001P000?o00003P0001`00_lF0003P@0001P000>100005006o`D00X440003o`0000d0
1h4:0003P@0002L000>100003`02oa400R450003P@0001T000?o00003@0001`000?o00005@000h40
000H0003P@0000d01ol20003P@0000P00X400`3o000900J14@000h40000W0003P@0001400_l?008Q
1@000h40000I0003o`0000d0000L0003o`0001D000>1000060000h40000700Ko2@000h40000:0003
POl000801h4G0003P@0002L000>100004`02o`d00Rl50003P@0001T000?o00003@0001`000?o0000
5@000h40000H0003P@0000Oo3`000h40000;0004oh61PAh000>100009`000h40000E0003o`0000X0
0R450003P@0001T000?o00003@0001`000?o00005@000h40000E00Ko5P000h40000;0003o`0001l0
00>100009`000h40000F00;o2P000b4R00040003P@0001T000?o00003@0001`000?o00005@000h40
000>00Oo0`000h40000F0003P@0000/000?o00007`000h40000X0003P@0001L00_l80003;b8000D0
00>1000060000ol0000=000070000ol0000E0003P@0000P01_l:0003P@0001H000>100002`000ol0
000O0003P@0002P000>100006@02o`H000<Q8P001@000h40000H0003o`0000d0000L0003o`0001@0
00>100000P07oa0000>100005P000h40000;0003o`0001l000>10000:0000h40000K0003o`0000<0
0R860003P@0001P000?o00003@0001/000?o00005006oaL000>100005P000h40000;0003o`0001l0
00>10000:0000h40000L00;o0`028PH000>1000060000ol0000=00006`000ol0000=00Oo00<0P@00
6P000h40000F0003P@0000/000?o00007`000h40000X0003P@0001h00_l0100R8Ql50003P@0001T0
00?o0000300000`00ol300;o1`001?n1ool600Ko20000h40000I0003P@0001H000>100002`000ol0
000O0003P@0002P000>100008002o`037b8000@000>100006@000ol0000<00003@001Ol0003o0080
00?o000010000ol0P@07o`h000>100006@000h40000F0003P@0000/000?o00007`000h40000X0003
P@0002800_l50003P@0001T000?o0000300000/01?l20004o`00o`H00ol00`21P@0B0003P@0001P0
00>100005`000h40000;0003o`0001l000>10000:0000h40000R00037b;o00@000>100006@000ol0
000<00002`000ol0o`030004o`00o`P00_l200>13`000h40000H0003P@0001L000>100002`000ol0
000O0003P@0002P000>100008P027`030?oo008000>100006@000ol0000<00002`000ol0o`030004
o`00o`X00_l300:13@000h40000H0003P@0001H000>1000030000ol0000O0003P@0002P000>10000
8P027`<00_l00h40000I0003o`0000`0000<00;o1002o`d00ol200:12`000h40000H0003P@0001H0
00>1000030000ol0000O0003P@0002P000>10000:@02oaX000?o0000300002@00_l200:12@000h40
000H0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:@000h40o`0I0003o`0000`0
000V00;o0P02P@L000>1000060000h40000F0003P@0000`000?o00007`000h40000X0003P@0002T0
00>100000_lG0003o`0000`0000X00;o0P03P@<000>100006@000h40000F0003P@0000`000?o0000
7`000h40000X0003P@0002X000B100000_lE0003o`0000`0000Z00;o0`02P@03084001X000>10000
5P000h40000<0003o`0001l000>10000:0000h40000Z0003P@0000<00_lD0003o`0000/0000/00?o
0P02PA/000>100005P000h40000<0003o`0001l000>10000:0000h40000Z0003P@0000D00_lB0003
o`0000/0000_00;o00@0PH616@000h40000F0003P@0000`000?o00007`000h40000X0003P@0002X0
00>100001`000ol0000?0003o`0000/0000a00;o0P02PAL000>100005P000h40000<0003o`0001l0
00>10000:0000h40000Z0003P@0000P00_l?0003o`0000/0000b0003POoo00800h4D0003P@0001H0
00>1000030000ol0000O0003P@0002P000>10000:P000h40000:00;o3@000ol0000;0000=@02o`<0
0X4B0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:P000h40000<00;o2`000ol0
000;0000=`03o`800X4@0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:P000h40
000>0003o`0000P000?o00002`0003X00_l200:13P000h40000F0003P@0000`000?o00007`000h40
000X0003P@0002X000>100003`02o`P000?o00002`0003`00_l200:130000h40000F0003P@0000`0
00?o00007`000h40000X0003P@0002X000>100004@02o`H000?o00002`0003h00_l200>120000h40
000G0003P@0000`000?o00007`000h40000X0003P@0002X000>100004`02o`D000?o00002P000400
0_l300:11P000h40000G0003P@0000`000?o00007`000h40000X0003P@0002X000>100005@02o`<0
00?o00002P0004800ol200:110000h40000G0003P@0000`000?o00007`000h40000Y0003P@0002T0
00>100005P001H7oPH7o00`0001500;o0P02P@8000>100005`000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000h01h4200?o300004L00_l200>16@000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000L01h4700Go300004T00_l200>15`000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000N11`07oa40001;00;o00>100000X4E0003P@0000`000?o00007`000h40
000Y0003P@0002D0284700Oo600004d00ol200:14`000h40000<0003o`0001l000>10000:@000h40
000N00N11@000h400007oal0001@00;o0P02PA0000>1000030000ol0000P0003P@0002T000>10000
5`07P@L02?lV0000DP02o`800X4>0003P@0000`000?o000080000h40000Y0003P@0001001h4700Oo
;P0005@00_l200>12`000h40000<0003o`00020000>10000:@000h40000800R11`07ocD0001F00;o
0`02P@T000>1000030000ol0000P0003P@0002T000B100001h4800Oo?00005P00ol200:11`000h40
000<0003o`00020000>100009P07P@L02?m30000F`02o`800X450003P@0000`000?o000080000h40
000O00N10`0018400007od/0001M00;o0P02P@<000>1000030000ol0000P0003P@0001P01h4700Oo
DP0005l00_l200B13P000ol0000P0003P@000100284700OoF@0006400_l300:13@000ol0000P0003
P@0000T01h4800OoH00006<00ol01840PH4;0003o`00020000>100000P07P@L02?mW0000IP02o`80
0X490003o`0001h01h4700OoK`0006P00_l200:11`000ol0000F00R10P000h40000200OoMP0006X0
0_l200>110000ol0000?00N12007ogd0001/00;o0`02P@8000?o00002007P@L02?n40000KP03o`80
0X401?l00007P@L01on<0000L@02o`8000CoPH611`07oi<0001c00?o0`07oiX0001e00CoX@000?l0
6`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`0007D0
00?o00009`000ol0001h0000EP04o`<01?l0103oo`02o`800_l300?o10000ol0000800Go00@0ool0
0_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<00ol300Co0`02odT0001E0005
o`000?l00P000ol000030004o`00o`<00_l60003o`00008000?o00002@001Ol0003o008000Co003o
0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o10000ol0
00030003o`0000<00_m90000E@000ol0o`02o`801Ol01@3o003o00/000?o00003P001Ol0003o0080
00Co003o0`000ol000060003o`0000h000?o00001@000ol000020003o`0000T000?o000010000ol0
001=0000E@000ol000040007o`000?l0o`020003o`0000H00olA0005o`000?l00P001?l00?l30003
o`0000H000?o00003P03o`D000?o00000P000ol000090003o`0000D000?o0000C00005D000Go0000
o`0300?o00<0ool00ol80003o`00014000?o00001Ol300Co20000ol0000>0003o`0000@00_l300Co
2@000ol000020004o`00odh0001F00Co5004o`h01Ol;0003o`0000D00_l?00Go2@000ol0000800;o
1@02odl0002?00;o8@000ol000020003o`000600003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.171525, -0.0166478, \
0.00217245, 0.003887}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.5, Ind.1, Fit.12.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.5, Ind.1, Fit.12.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.44603 .5261 m .41861 .53422 L .40239 .51917 L p
.8 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.47374 .5179 m .44603 .5261 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.40239 .51917 m .42999 .5109 L .44603 .5261 L p
.8 g
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.42999 .5109 m .45788 .50253 L .47374 .5179 L p
.8 g
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .50173 .50961 L .48607 .49408 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.55862 .49278 m .53003 .50124 L .51456 .48554 L p
.8 g
F P
s
P
p
.002 w
.48607 .49408 m .51456 .48554 L .53003 .50124 L p
.8 g
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.58752 .48422 m .55862 .49278 L .54335 .47691 L p
.8 g
F P
s
P
p
.002 w
.51456 .48554 m .54335 .47691 L .55862 .49278 L p
.8 g
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .015 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .015 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.54335 .47691 m .57246 .46819 L .58752 .48422 L p
.8 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .03 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .03 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .06 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .045 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .76384 .4729 L .75043 .45663 L p
.8 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .06 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .045 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .7942 .46413 L .78102 .44769 L p
.8 g
F P
s
P
p
.002 w
.75043 .45663 m .78102 .44769 L .7942 .46413 L p
.8 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.73942 .45475 m .72426 .4592 L .71734 .45097 L p
1 .076 0 r
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.78102 .44769 m .81196 .43865 L .82489 .45527 L p
.8 g
F P
s
P
p
.002 w
.71734 .45097 m .73256 .44648 L .73942 .45475 L p
1 .076 0 r
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .091 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .091 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .166 0 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .151 0 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .136 0 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .166 0 r
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .151 0 r
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .136 0 r
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .196 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .181 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .121 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .106 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .196 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .181 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .121 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .106 0 r
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .212 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .212 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .242 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .227 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .242 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .227 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .348 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .332 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .272 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .257 0 r
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .348 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .332 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .272 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .257 0 r
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .363 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .363 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .317 0 r
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .302 0 r
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .287 0 r
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
1 .378 0 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .317 0 r
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .302 0 r
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .287 0 r
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
1 .378 0 r
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .015 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .03 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .045 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .06 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .076 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .091 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .106 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .121 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .136 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .151 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .166 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .181 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .196 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .212 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .227 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .242 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .257 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .272 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .287 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .302 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .317 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .332 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .348 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .363 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .378 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .393 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .408 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .423 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .438 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .453 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .469 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .484 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .499 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .514 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .529 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .544 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .559 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .574 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .589 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .605 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .62 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .635 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .65 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .665 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .68 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .695 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .71 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .725 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .741 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .756 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .771 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .786 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .801 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .816 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .831 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .846 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .861 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .877 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .892 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .907 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .922 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .937 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .952 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .967 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .982 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .997 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.987 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.972 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.957 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.942 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.927 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.912 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.897 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.882 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.866 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.851 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.836 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.821 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.806 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.791 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.776 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.761 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.746 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.73 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.715 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.7 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.685 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.67 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.655 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.64 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.625 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.61 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.594 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.579 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.564 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.549 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.534 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.519 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.504 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.489 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.474 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.458 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.443 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.428 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.413 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.398 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.383 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.368 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.353 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.338 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.322 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.307 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.292 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.277 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.262 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.247 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.232 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.217 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.202 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.186 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.171 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.156 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.141 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.126 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.111 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.096 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.081 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.065 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.05 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.035 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.02 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.005 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .01 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .025 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .04 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .055 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .071 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .086 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .101 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .116 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .131 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .146 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .161 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .176 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .191 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .207 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .222 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .237 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .252 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .267 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .282 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .297 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .312 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .327 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .343 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .358 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .373 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .388 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .403 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .418 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .433 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .448 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .463 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .479 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .494 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .509 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .524 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .539 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .554 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .569 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .584 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .599 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .615 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .63 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .645 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .66 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .675 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .69 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .705 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .72 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .736 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .751 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .766 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .781 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .796 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .811 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .826 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .841 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .856 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .872 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .887 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .902 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .917 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .932 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .947 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .962 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .977 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .992 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .992 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .977 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .962 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .947 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .932 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .917 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .902 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .887 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .872 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .856 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .841 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .826 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .811 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .796 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .781 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .766 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .751 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .736 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .72 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .705 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .69 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .675 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .66 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .645 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .63 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .615 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .599 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .584 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .569 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .554 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .539 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .524 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .509 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .494 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .479 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .463 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .448 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .433 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .418 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .403 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .388 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .373 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .358 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .343 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .327 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .312 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .297 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .282 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .267 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .252 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .237 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .222 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .207 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .191 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .176 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .161 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .146 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .131 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .116 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .101 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .086 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .071 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .055 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .04 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .025 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .01 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.005 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.02 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.035 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.05 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.065 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.081 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.096 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.111 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.126 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.141 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.156 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.171 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.186 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.202 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.217 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.232 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.247 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.262 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.277 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.292 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.307 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.322 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.338 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.353 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.368 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.383 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.398 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.413 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.428 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.443 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.458 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.474 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.489 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.504 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.519 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.534 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.549 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.564 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.579 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.594 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.61 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.625 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.64 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.655 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.67 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.685 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.7 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.715 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.73 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.746 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.761 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.776 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.791 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.806 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.821 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.836 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.851 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.866 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.882 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.897 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.912 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.927 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.942 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.957 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.972 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.987 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .997 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .982 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .967 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .952 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .937 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .922 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .907 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .892 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .877 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .861 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .846 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .831 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .816 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .801 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .786 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .771 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .756 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .741 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .725 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .71 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .695 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .68 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .665 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .65 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .635 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .62 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .605 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .589 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .574 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .559 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .544 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .529 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .514 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .499 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .484 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .469 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .453 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .438 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .423 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .408 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .393 0 r
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .015 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .03 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .045 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .06 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .076 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .091 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .106 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .121 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .136 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .151 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .166 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .181 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .196 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .212 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .227 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .242 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .257 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .272 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .287 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .302 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .317 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .332 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .348 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .363 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .378 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .393 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .408 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .423 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .438 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .453 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .469 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .484 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .499 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .514 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .529 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .544 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .559 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .574 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .589 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .605 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .62 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .635 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .65 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .665 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .68 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .695 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .71 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .725 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .741 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .756 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .771 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .786 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .801 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .816 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .831 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .846 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .861 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .877 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .892 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .907 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .922 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .937 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .952 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .967 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .982 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .997 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.987 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.972 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.957 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.942 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.927 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.912 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.897 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.882 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.866 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.851 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.836 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.821 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.806 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.791 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.776 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.761 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.746 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.73 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.715 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.7 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.685 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.67 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.655 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.64 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.625 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.61 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.594 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.579 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.564 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.549 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.534 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.519 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.504 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.489 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.474 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.458 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.443 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.428 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.413 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.398 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.383 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.368 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.353 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.338 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.322 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.307 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.292 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.277 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.262 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.247 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.232 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.217 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.202 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.186 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.171 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.156 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.141 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.126 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.111 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.096 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.081 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.065 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.05 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.035 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.02 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.005 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .01 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .025 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .04 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .055 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .071 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .086 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .101 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .116 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .131 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .146 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .161 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .176 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .191 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .207 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .222 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .237 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .252 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .267 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .282 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .297 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .312 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .327 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .343 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .358 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .373 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .388 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .403 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .418 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .433 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .448 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .463 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .479 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .494 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .509 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .524 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .539 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .554 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .569 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .584 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .599 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .615 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .63 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .645 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .66 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .675 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .69 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .705 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .72 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .736 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .751 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .766 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .781 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .796 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .811 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .826 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .841 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .856 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .872 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .887 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .902 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .917 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .932 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .947 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .962 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .977 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .992 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .992 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .977 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .962 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .947 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .932 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .917 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .902 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .887 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .872 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .856 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .841 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .826 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .811 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .796 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .781 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .766 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .751 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .736 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .72 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .705 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .69 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .675 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .66 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .645 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .63 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .615 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .599 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .584 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .569 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .554 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .539 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .524 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .509 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .494 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .479 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .463 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .448 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .433 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .418 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .403 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .388 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .373 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .358 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .343 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .327 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .312 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .297 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .282 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .267 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .252 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .237 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .222 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .207 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .191 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .176 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .161 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .146 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .131 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .116 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .101 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .086 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .071 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .055 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .04 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .025 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .01 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.005 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.02 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.035 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.05 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.065 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.081 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.096 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.111 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.126 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.141 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.156 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.171 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.186 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.202 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.217 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.232 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.247 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.262 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.277 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.292 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.307 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.322 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.338 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.353 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.368 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.383 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.398 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.413 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.428 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.443 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.458 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.474 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.489 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.504 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.519 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.534 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.549 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.564 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.579 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.594 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.61 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.625 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.64 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.655 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.67 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.685 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.7 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.715 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.73 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.746 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.761 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.776 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.791 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.806 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.821 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.836 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.851 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.866 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.882 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.897 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.912 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.927 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.942 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.957 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.972 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.987 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .997 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .982 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .967 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .952 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .937 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .922 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .907 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .892 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .877 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .861 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .846 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .831 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .816 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .801 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .786 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .771 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .756 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .741 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .725 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .71 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .695 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .68 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .665 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .65 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .635 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .62 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .605 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .589 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .574 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .559 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .544 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .529 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .514 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .499 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .484 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .469 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .453 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .438 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .423 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .408 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .393 0 r
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o<K/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0
000Z00007`000ol000090008ol^kbk_;^ol<P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol035/03onkbk_;^l^kbk_;^l^ko`0<P@03oh6100?o01Jkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0ol9F`0=ol^kbk_;^l^kbk_;^`02o`^100?oPH402X40=_nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10old^`;o0[/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0d^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00HGol^kbol8P@?o00V1ok_;
^l^kbol00P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omK
F`04F`?o0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42ocJk00Oo5elG
GaOo00:k00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol0
1X43o`B102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^k
bk_;^l^kbk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?
^l^kbk_;^l^kbk_;^l_o00J11?l2P@0aok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`06^l^kbk_o1QL01Oo;^on100?o2H402?nkbk_;^l_o0P000ol000020003
o`0000D00ol300?o6@0002D000?o00002@000onk^`03^`03oh6100?o28400onk^`0T^`;o2e/00onk
^`0O^`?o0X400onk^`0;^`03oe]K00=K0_lB^`03oh6100?o1h400onk^`0B^`?o5K/3o`03GaOo00Fk
00?oGol00_l3^`?o38400onk^`04^`04o`00o`D000?o00001@000ol000050003o`0001H0000V0003
o`0000T000Ko^l^kbk/2o`b102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
35/07_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1X404?o;^l^kbk_;^l^kbk_;oe/3o`0E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2h404Onkbk_;^l^kbk_;^l^kbk_;00?o0el09?o;^l^kbk_;
^l^kbk_;^l^kbk_;oaMO5elGGonkbk_;^onkb`Co0U/00on1P@0;P@08ol^kbk_;^ol20003o`000080
00?o00001@000ol000050003o`0001H0000W0003o`0000T000?o^k/01;/00on1P@0:P@03ok^k02Bk
00?oFe/02U/00onk^`0F^`Co2X400onk^`0;^`03ok^k01Nk00?oPH402X400onk^`0>^`07oelOGamO
o`0B^`09oaMO5elGGaOo00Bk0ol7F`03oh6100^100?o^k/01;/01?l00?l40003o`0000@000?o0000
0P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^kb`03o`:100?oPH402X40:Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b101;o^l^kbk_;^l^kbk_;^l^kbol3G`0<
oeoobk_;^l^kbk_;1?l02;_;^l^koelG0ol01<^kbk/2o`]K00?oPH401X43o`09POnkbk_;^l_o0080
00?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1P@0:P@03ok^k02Bk
00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k00jk0ol9^`?o0aL00onk
^`04^`;o1k/00omKF`0;F`03oh6100>10_l5P@03ok^k00Bk00Co003o0P000ol0o`0400;o1004oaP0
000[0003o`0000T000Oobk_;^l_o00J10ol3P@0Xok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`9K0ol05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z100?oPH402840:on1ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01X43o`:101oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00EO017obk_;^l^kbk_;^l^kbk_;o`0=F`03oh7o00;o28402?nkbk_;^l_o
0P000ol000020003o`0002<0000/0003o`0000T000?o^k/00k/00on1P@03o`N100?o^k/09;/2oaVk
00?oPH402H400on1P@04P@?o0h400onk^`0U^`03oh6100?o1X400onk^`0B^`?o1[/01olG5aOo5ol0
3k/00omKF`0;F`03oh6100V100?o^k/01;/01?l00?l50003o`000280000]0003o`0000T000Kobk_;
^l/2o`^104?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00^100?oPH400ol7P@0Vol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/4o`Z1017obk_;^l^kbk_;^l^kbk_;^`03o`0:5elGok_;^l^kb`?o01C;^l^kbk_;^l^k
bk_;^l^kbk_;o`IK1?l2F`03oh6100Z100Sobk_;^l^ko`8000?o00000`000ol0000Q0000;P000ol0
00090003ok^k00Bk00?oPH402H400onk^`0o^`03oh6100V10_l;P@03ok^k01jk1?l2F`03oh6100Z1
00?o^k/03K/02?lOGamO7eoo7;/00omKF`03o`MK00?oPH402X400onk^`04^`04o`00o`@000?o0000
8@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH402X407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@09ol^kbk_;^l^k00;o00W;^l^kbomO5el0
0_l071Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`]K00?oPH401H43o`0:POnkbk_;^l^ko`80
00?o00000P000ol0000P0000<0000ol0000900;o1K/00on1P@09P@;o@;/00on1P@03o`J100?oPH40
2X400onk^`0G^`;o2e/00on1P@08P@03oh7o00Bk0ol00eoo^`05^`?o6[/4o`9K00?oFe/02U/00on1
P@03P@;o1H400onk^`04^`04o`00o`<000?o0?l08@0003400_l;0007ok_;^l^ko`06P@?o0h40@Oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00;o2X400on1P@0:P@0Kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00?oPH401843o`:1
02[o^l^koamO7elOok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`MK00?oFe/02U/00on1
o`02o`R100So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH40
0ol7P@03ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X402onk^olOGamO
7eoo01Zk1?l;F`03oe]K00QK00?oFol038400onk^`04^`04o`00o`@000?o00007P0003@000?o0000
2@001_nkbk_;^`;o2h40@Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100?oPH400ol08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol<F`;o2X401OnkbomO00?o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0U/00omK
F`0:F`03oe]K00AK1?l00l^ko`0=P@07ok_;^l^ko`020003o`0000<000?o00007@0003D000?o0000
2@000onk^`03^`03oh6100Z100?o^k/0?K/00on1P@08P@04oh7oobFk00?oFe/015/3o`:k00?oPH40
2X401?nk^olI^`?o1U/00omKF`0:F`03oe]K00?o1k/00on1P@0;P@03ok^k00>k00Co003o10000ol0
000M0000=P000ol000090007ok_;^l^ko`0<P@0aol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04o`0<bk_;^l^kbk_;^l_o1X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`07^l^kbk_;o`0<P@08ok_;^l^kbk/3o`0?^l^kbk_;
^l^kbk_;^l^k00;o2U/00omKF`08F`0@oe_ook_;^l^kbk_;^l^ko`J11?l2P@08ol^kbk_;^ol20004
o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z10_l[^`?o15/00onk^`09^`03oh6100?o
1h400onk^`0T^`;o2[/00on1P@08P@03oh7o00>k0ol27`03ok^k00fk00?oFe/02U/00omKF`04F`?o
4;/00on1P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;
0_l;P@0dok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J1
0ol01k_;^l^kbol01El04Oo;^l^kbk_;^l^kbk_;^l_o00aK00?oFe/00ol05<^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l;P@07ol^kbk_;o`020003o`00008000?o00006`0003X000?o00002@000onk^`02^`03
oh6100?o28400onk^`0R^`;o35/00onk^`09^`03oh6100Z100?o^k/0<;/00on1P@03o`Zk00Oo7alO
oaoo00nk00?oFe/025/01?mKoolG^`03oh6100Z100?o^k/01;/01?l00?l40003o`0001X0000k0003
o`0000T000Gobk_;^`02o`b102Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
35/03Oo;^l^kbk_;^l^kbol03840<onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`0>^l^kbk_;^l^kbk_;^l/3o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol6F`?o
0U/06oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0<P@0:ok_;^l^kbol0o`D000?o00006@0003`0
00?o00002@000onk^`03^`03oh6100Z100?o^k/08k/00omKF`0:F`03ok^k00Vk00?oPH402X400onk
^`1F^`03oe]K00?o1U/00onk^`0G^`03oh6100R100?oPOl01K/01?l00?l40003o`0001T0000m0003
o`0000T000Kobk_;^l/2o`^102Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1U/3o`9K00ko^l^kbk_;^l^kbk_;o`J10ol3P@16ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co00o;^l^kbk_;^l^kbk_;^l/0
0_l:F`0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l00002oaX0
000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0S^`03oe]K00?o1U/00onk^`0:^`03
oh6100?o1h400onk^`0o^`?o00DOGamOo`0>^`03oe]K00UK00?o^k/05k/00on1P@03o`N100?o^k/0
1;/01?l00?l40003o`0001L0000o0003o`0000T000Sobk_;^l^ko`:10ol6P@0Vok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^kbk_;^l^kbk_;00;o2h40@onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1Ql04?o;^l^kbk_;^l^kbk_;^ol;F`0Jok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`^100Oobk_;
^l_o008000?o00000`000ol0000F0000@002o`X000?o^k/01;/2o`Z100?o^k/08k/00omKF`09F`03
ok^k00Zk00?oPH402X400onk^`0f^`Co1K/00olOo`02oa6k00?oFe/01e/00omKo`0H^`03oh6100Z1
00?o^k/01;/01?l00?l40003o`0001H000120003o`0000P00_l01[_;^l^ko`^102Oo^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02e/03_nkbk_;^l^kbk_;^l_o3840=Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o11l07?nkbk_;^onk
bk_;^l^kbk_;^l^kbk_;^l^kbol6F`?o0e/06_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o38402?nk
bk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/00k/00on1P@09P@03ok^k02>k
00?oFe/02E/00onk^`0:^`03oh6100B10ol2P@03ok^k03>k00?oGel015l00onk^`08^`;o3[/00omK
F`03o`MK00?o^k/05[/00on1P@08P@03oh7o00Fk00Co003o1@000ol0000D0000A0000ol000090007
ok_;^l^ko`0;P@;o02G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00IK0ol04<^k
bk_;^l^kbk_;^l^kbol2P@?o1X40>?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbolO0ol00l^ko`02o`04^l^kb`?o014Ool^kbk_;^l^kbk_;^l^kb`02o`]K
01Wo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J11?l2P@08ol^kbk_;^ol20004o`0000;o5P0004D0
00?o00002@000onk^`03^`03oh6100B10ol3P@03ok^k02:k00?oFe/00olC^`;o2X400onk^`0c^`03
ok^k00?o0U/02onk^k_o7elOGaoo00nk00?oFe/02U/00onk^`0E^`03oh6100?o1h400onk^`04^`04
o`00o`@000?o00004`0004H000?o00002@001onkbk_;^ol00X43o`N102Cobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2h40=Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1U/06oo;^l_o7aLO
5aoobk_;^l^kbk_;^l^kbk_;o`0<F`0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co2h402_o;^l^kbk_o
0?l300?o500004L000?o00002@000onk^`03^`;o2h400onk^`0M^`?o0e/00onk^`0E^`03oh6100V1
00?o^k/0;[/3o`YK00Co^k^k0olC^`03oe]K00AK0ol2F`03ok^k012k0ol2P@03oh6100^100?o^k/0
0k/00ol00003o`8000?o00004P0004P00_l:0008ok_;^l^kbol;P@0Lol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/06Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02h42o`0[^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`9K00?oFe/02E/06oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02F`?o1U/03oo;^l^kbk_;^l^kbk_;^`03o`J100?oPH402h401_o;^l^kb`;o
00<0o`000P000ol0000B0000BP000ol0000800;o1K/00on1P@09P@03ok^k01Bk1?l;F`03ok^k01Fk
00?oPH401843o`>100?o^k/09K/3o`IK00?oFe/02E/00onk^`05^`?o3K/4o`YK00?o^k/01k/4o`Z1
00?oPH401844o`Vk00?o0?l00`000ol0000B0000B`000ol000090007ol^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol3F`03oe]K00YK01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:1
0ol7P@0Sok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l:F`03oe]K00MK00KoFoo;
^l/3o`0=7elOol^kbk_;^l^kb`03o`9K00?oFe/02E/01onkbk_;^l/00ol2P@03oh6100Z100?oPH40
0ol02;_;^l^kbk_;0ol50004o`00oa@0001<0003o`0000T000?o^k/00k/00on1P@03o`J100?o^k/0
3;/3o`MK00?oFe/02U/00onk^`0E^`;o2h400onk^`0L^`?o0U/00omKF`0:F`04oe]KF`Go1[/02?mO
7elOGaoo1K/3o`IK00?oFe/02E/00onk^`03o`J100?oPH402X42o`Nk1?l90004o`00oa<0001=0003
o`0000T000Kobk_;^l/2o`Z100cobk_;^l^kbk_;^l/2o`]K00?oFe/015/3o`0Lbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`b101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol6F`03oe]K00YK
0ol03/^kbk_;^l^kbk_;^omO0ol01K_;^l^k00;o2U/00omKF`07F`04oe_oo`Z100?oPH401843o`08
bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk^`03^`03oh6100V100?o^k/02[/00omK
F`09F`03oe]K00?o7k/00on1P@0:P@03ok^k01Fk0_l:F`03oe]K00AK0olB^`03ok^k00Jk00?oFe/0
2U/01?mKFe/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;^l^kbol0
2h403_o;^l^kbk_;^l^kbk_o2e/2o`0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1X43o`:101[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`]K00?oFe/00ol06l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`03^l_o00aK0ol8P@03oh6100Z10_l01l^kbk_;^l/00olF00;o4`000540
00?o000020000onk^`03^`03oh6100V10_l;^`03oe]K00AK0olW^`03oh6100?o1X400onk^`0F^`03
oe]K00UK0_lK^`?o00<Ook/00[/00omKF`04F`?o0X400on1P@09P@03oh6100B10ol7^`Co6003oa<0
001B0003o`0000P00_l01K_;^l_o00J10ol3P@0=ok_;^l^kbk_;^l^ko`02F`?o02_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X402oo;^l^kbk_;^l^k00;o00g;^l^k
bk_;^l^kbk_o00IK0ol0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;oamO7elOol^kbol2F`?o
1X400on1P@09P@03oh6100?o00Nkbk_;^l^k00?o6@03oaH0001C0003o`0000T000?o^k/00[/00on1
P@03o`N100?o^k/02K/2objk00?oPH402X400onk^`04^`?o0U/00onk^`0:^`03oe]K00?o6K/3o`Fk
00?o7al00al00onko`03o`Z100?oPH401h401?n1ool6^`Co6004oaT0001D0003o`0000T000Go^l^k
b`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00b100?obk/00ol6F`0=ol^kbk_;^l^kbk_;^`02o`0Ibk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1P@09P@03oh6100B10ol01l^kbk_;^l/0
0olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V100?o^k/0>K/00on1P@08P@04oh7oo`YK
00?o^k/09K/00olO7`037`03ok^k00>k0ol6P@03oh6100V100?oPH400ol6^`Co6004ob00001F0003
o`0000T000Oo^l^kbk_o00^10_l0>l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol3F`03oe]K00UK023obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo7`05o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000
E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03oh6100?o1e/00omKF`09F`03ok^k01Vk
0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T000?o000020001onk
bk_;^ol00X43o`N103Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/01?l;F`03oe]K00AK0ol07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`HO
00Gobk_;^`03o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X000?o000020000onk
^`03^`;o2h400onk^`0`^`Go0e/00omKF`0:F`03oe]K00?o6K/3o`Fk00?o7ol00_l3^`?o2X400on1
P@07P@04oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h40<?o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o2E/00omKF`0:F`;o01Vkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06bk_;^l^k
0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/04[/4oaNk00?oFe/025/00omK
F`04F`?o0h400onk^`0G^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk1?lH00?o=P0005d0
00?o00002@001oo;^l^kbol01X43o`:100oobk_;^l^kbk_;^l^kbk/01Ol4F`0Iol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`0:F`03oe]K00?o1h407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ob<3o`03
bk_;00Co2X400on1P@04P@?o00Rkbk_;^l^kb`?o6004ocT0001N0003o`0000T000?o^k/00k/00on1
P@03o`J100?o^k/02K/2o`YK00?o^k/02;/2o`^k00?oFe/01U/01?mKool;P@03ok^k01Nk00Co^k^k
0ol2P@03oh6100Z100?oPH400ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o2X403Oo;^l^kbk_;
^l^kbol02e/01oo;^l^kbk/00ol2F`0=ol^kbk_;^l^kbk_;o`02F`Go00Bkbk_o38406_o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co@000064000?o0000
20000onk^`03^`03oh6100V100?o^k/02K/00omKF`09F`03ok^k00?o1U/00onk^`09^`;o2K/00on1
P@0:P@03ok^k01:k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P000Oobk_;^l_o00^1
0_l02k_;^l^kbk_;^l_o00]K0_l:F`0Hol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`:1013o^l^k
bk_;^l^kbk_;^l^k1Ol3P@03oh6100V100?oPH400ol01l^kbk_;^l/00olH00CoA`0006<000?o0000
2002o`Bk00?oPH401843o`>100?o^k/02;/00omKF`04F`?o0U/00omKF`09F`03ok^k01Bk00?oPH40
0ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T000Ko^l^kbol2P@?o
1h403?nkbk_;^l^kbk_;o`9K0ol6F`03oe]K00UK01Oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z1
00Oo^l^kbk_;00?o0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0001U0003o`0000T0
00?o^k/00[/2o`^100?o^k/02;/2o`YK00?oFe/015/3oaVk00?oPH402H400onk^`03o`J100?oPH40
2H400on1P@03o`Fk1?lG00CoDP0006H000?o00002@001onkbk_;^ol02h403Onkbk_;^l^kbk_;^ol0
2U/00omKF`03o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2h42o`Z100?oPH401h402?n1
ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k00?oPH402H400onk^`09^`03oe]K00QK0_lQ^`03
oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0001Y0003o`0000P000Oo^l^kbk_o00J1
0ol2P@0=ok_;^l^kbk_;^l^ko`02F`Go02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?oG@0006X000?o000020000onk^`03^`03
oh6100?o1X400onk^`09^`;o:[/4o`Z100?oPH401843o`Nk0olH00CoH00006/000?o00002002o`04
bk_;^`;o2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T000?o^k/00[/00on1
P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T000Kobk_;^ol;P@0Z
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03oh6100V100?oPH40
1Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03ok^k02>k0ol6P@03
oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL01?mb0000L@000ol0
00080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o6003ogH0001b0003
o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V100?oPH402H42o`06
^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o0X400on1P@08P@03
oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onkbk_;^l^kbk_;^l^k
b`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o00002@000onk^`02^`;o
2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007ok_;^l^ko`09P@07
ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P000?o000020000onk
^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003o`0000P000Oo^l^k
bk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol000080003ok^k00>k
00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P000Ko^l^kbk/2o`V1
00?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH4028400on1P@05o`Jk
0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?oW@0007h00_l:0003
ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh400ol01[_;^l^kb`Co
5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003o`0000P000Oobk_;
^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o00001`03oaL00onb0000
Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT000280003o`0000<000?o0000
3004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0o`0400Coa`0008`0
0_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0002?0003o`0002L000?o0000X@0007001?l300Co00@0ool0
0_l200;o0`03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go
0P03o`<00_l300?o0`04o`<00_mb0000K`001Ol0003o008000?o00000`001?l00?l300;o1P000ol0
00020003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003o`0000@000?o00001`000ol0
00050003o`00008000Co003o0P02o`@000?o00000`000ol0000300;oLP0006l000?o0?l00_l200Go
00D0o`00o`0;0003o`0000h000Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D0
00?o00000P000ol000090003o`0000@000?o0000MP0006l000?o000010001ol0003o0?l00P000ol0
000600?o4@001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003o`00008000?o0000
2@000ol000050003o`0007D0001_0005o`000?l00`03o`030?oo00?o20000ol0000A0003o`0000Go
0`04o`P000?o00003P000ol0000400;o0`04o`T000?o00000P001?l00?mg0000L004oa@01?l>00Go
2`000ol0000500;o3`05o`T000?o00002002o`D00_mh0000Z@02ob4000?o00000P000ol000290000
o`1N0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}}]
}, Open  ]],

Cell[OutputFormData["\<\
TableForm[{\"Gen: 5, Ant: 1\", 11, 
 
   AntTracker[seq[seq[advance], 
 
     ifSensor[dust][seq[seq[stop]], seq[advance]], 
 
     seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
 
      seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
 
         ifSensor[phero][seq[turnLeft], seq[stop]]], seq[turnRight]]], 
 
      seq[nop]]]]}]\
\>", "\<\
Gen: 5, Ant: 1

11

AntTracker[seq[seq[advance], ifSensor[dust][seq[seq[stop]], seq[advance]], 
 
   seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
 
    seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
 
       ifSensor[phero][seq[turnLeft], seq[stop]]], seq[turnRight]]], 
 
    seq[nop]]]]\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["(antProgram //. simplificationRules)", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
AntTracker[advance]\
\>", "\<\
AntTracker[advance]\
\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["(antProgram //. simplificationRules) //. antEncRules", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
AntTracker[seq[ifSensor[0][advance, 
 
    seq[advance, ifSensor[nop][10, turnLeft]]], 
 
   ifSensor[0][seq[seq[turnRight], 
 
     ifSensor[10][turnRight, ifSensor[0]]], advance]]]\
\>", \
"\<\
AntTracker[seq[ifSensor[0][advance, 
 
    seq[advance, ifSensor[nop][10, turnLeft]]], 
 
   ifSensor[0][seq[seq[turnRight], 
 
     ifSensor[10][turnRight, ifSensor[0]]], advance]]]\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell["\<\
Table[
  showAnt[$basicDirectory,$basicExperiment,17,i],
  {i,1,1}
]\
\>", "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Analyzation of evolved ",
  StyleBox["Ant Tracker",
    FontSlant->"Italic"],
  "  programs"
}], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Fitness graphics", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
allFitnesses =
  Table[ 
    getFitnesses[$basicDirectory,\"AntTracker-07-1i\",i],
    {i,0,85}
  ];\
\>", "Input",
  AspectRatioFixed->True],

Cell["allFitnessesSorted = Map[Reverse[Sort[#]]&,allFitnesses];", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["ListPlot3D[Map[Reverse[Sort[#]]&,allFitnesses]];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .82055 
MathPictureStart
%% SurfaceGraphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024936 0.99742 -0.039634 0.99742 [
[(10)] .15425 .21825 .99414 1 Msboxa
[(20)] .27421 .17106 .90904 1 Msboxa
[(30)] .40025 .12149 .82394 1 Msboxa
[(40)] .53284 .06937 .73884 1 Msboxa
[(50)] .6725 .0145 .65374 1 Msboxa
[(20)] .76117 .12793 -1 .36685 Msboxa
[(40)] .82776 .2299 -1 .34399 Msboxa
[(60)] .88789 .32199 -1 .32382 Msboxa
[(80)] .94248 .40558 -1 .30588 Msboxa
[(0)] .04785 .27682 1 -0.3906 Msboxa
[(10)] .04074 .32137 1 -0.38179 Msboxa
[(20)] .03341 .36729 1 -0.37268 Msboxa
[(30)] .02586 .41465 1 -0.36326 Msboxa
[(40)] .01806 .46352 1 -0.35351 Msboxa
[ 0 0 0 0 ]
[ 1 .82055 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.06024 .26735 m
.67932 .02494 L
s
P
p
.002 w
.16304 .2271 m
.16744 .23152 L
s
P
[(10)] .15425 .21825 .99414 1 Mshowa
p
.002 w
.2826 .18028 m
.28679 .18489 L
s
P
[(20)] .27421 .17106 .90904 1 Mshowa
p
.002 w
.40818 .13111 m
.41214 .13592 L
s
P
[(30)] .40025 .12149 .82394 1 Mshowa
p
.002 w
.54025 .07939 m
.54395 .08441 L
s
P
[(40)] .53284 .06937 .73884 1 Mshowa
p
.002 w
.67932 .02494 m
.68274 .03015 L
s
P
[(50)] .6725 .0145 .65374 1 Mshowa
p
.001 w
.18649 .21791 m
.18911 .22059 L
s
P
p
.001 w
.21017 .20864 m
.21276 .21134 L
s
P
p
.001 w
.23408 .19928 m
.23664 .202 L
s
P
p
.001 w
.25822 .18983 m
.26076 .19257 L
s
P
p
.001 w
.30722 .17064 m
.30971 .17343 L
s
P
p
.001 w
.33208 .16091 m
.33454 .16372 L
s
P
p
.001 w
.35719 .15107 m
.35963 .15391 L
s
P
p
.001 w
.38256 .14114 m
.38496 .144 L
s
P
p
.001 w
.43405 .12098 m
.4364 .12389 L
s
P
p
.001 w
.4602 .11074 m
.46252 .11367 L
s
P
p
.001 w
.48661 .1004 m
.48889 .10336 L
s
P
p
.001 w
.51329 .08995 m
.51554 .09293 L
s
P
p
.001 w
.56748 .06873 m
.56967 .07176 L
s
P
p
.001 w
.59501 .05795 m
.59716 .06101 L
s
P
p
.001 w
.62282 .04706 m
.62494 .05014 L
s
P
p
.001 w
.65092 .03606 m
.653 .03916 L
s
P
p
.001 w
.13982 .23619 m
.14248 .23882 L
s
P
p
.001 w
.11681 .2452 m
.11949 .24781 L
s
P
p
.001 w
.09402 .25412 m
.09673 .25671 L
s
P
p
.001 w
.07145 .26296 m
.07417 .26552 L
s
P
P
p
p
.002 w
.67932 .02494 m
.94594 .43277 L
s
P
p
.002 w
.74946 .13222 m
.74361 .13437 L
s
P
[(20)] .76117 .12793 -1 .36685 Mshowa
p
.002 w
.81597 .23395 m
.81007 .23598 L
s
P
[(40)] .82776 .2299 -1 .34399 Mshowa
p
.002 w
.87603 .32583 m
.8701 .32775 L
s
P
[(60)] .88789 .32199 -1 .32382 Mshowa
p
.002 w
.93055 .40923 m
.92459 .41105 L
s
P
[(80)] .94248 .40558 -1 .30588 Mshowa
p
.001 w
.69089 .04263 m
.68741 .04399 L
s
P
p
.001 w
.70602 .06578 m
.70253 .06711 L
s
P
p
.001 w
.72082 .08841 m
.71732 .08973 L
s
P
p
.001 w
.7353 .11055 m
.73179 .11186 L
s
P
p
.001 w
.76333 .15343 m
.75981 .1547 L
s
P
p
.001 w
.7769 .17419 m
.77338 .17545 L
s
P
p
.001 w
.79019 .19453 m
.78667 .19577 L
s
P
p
.001 w
.80321 .21444 m
.79968 .21567 L
s
P
p
.001 w
.82846 .25307 m
.82492 .25427 L
s
P
p
.001 w
.84071 .2718 m
.83717 .27299 L
s
P
p
.001 w
.85272 .29017 m
.84917 .29135 L
s
P
p
.001 w
.86449 .30817 m
.86094 .30934 L
s
P
p
.001 w
.88736 .34315 m
.88379 .34429 L
s
P
p
.001 w
.89846 .36014 m
.8949 .36127 L
s
P
p
.001 w
.90936 .37681 m
.90579 .37793 L
s
P
p
.001 w
.92006 .39317 m
.91648 .39428 L
s
P
p
.001 w
.94086 .42499 m
.93728 .42608 L
s
P
P
p
p
.002 w
.06024 .26735 m
.02494 .49015 L
s
P
p
.002 w
.05946 .27229 m
.06527 .27002 L
s
P
[(0)] .04785 .27682 1 -0.3906 Mshowa
p
.002 w
.05239 .31692 m
.05821 .3147 L
s
P
[(10)] .04074 .32137 1 -0.38179 Mshowa
p
.002 w
.0451 .36293 m
.05094 .36076 L
s
P
[(20)] .03341 .36729 1 -0.37268 Mshowa
p
.002 w
.03757 .41039 m
.04343 .40826 L
s
P
[(30)] .02586 .41465 1 -0.36326 Mshowa
p
.002 w
.02981 .45937 m
.03569 .45729 L
s
P
[(40)] .01806 .46352 1 -0.35351 Mshowa
p
.001 w
.05806 .28111 m
.06155 .27975 L
s
P
p
.001 w
.05666 .28998 m
.06014 .28863 L
s
P
p
.001 w
.05524 .2989 m
.05873 .29756 L
s
P
p
.001 w
.05382 .30788 m
.05731 .30654 L
s
P
p
.001 w
.05095 .32601 m
.05444 .32468 L
s
P
p
.001 w
.0495 .33515 m
.053 .33383 L
s
P
p
.001 w
.04804 .34436 m
.05154 .34304 L
s
P
p
.001 w
.04657 .35362 m
.05007 .3523 L
s
P
p
.001 w
.04361 .37231 m
.04712 .37101 L
s
P
p
.001 w
.04211 .38174 m
.04562 .38044 L
s
P
p
.001 w
.04061 .39123 m
.04412 .38994 L
s
P
p
.001 w
.0391 .40078 m
.04261 .3995 L
s
P
p
.001 w
.03604 .42006 m
.03956 .41879 L
s
P
p
.001 w
.0345 .4298 m
.03802 .42853 L
s
P
p
.001 w
.03295 .43959 m
.03647 .43833 L
s
P
p
.001 w
.03138 .44945 m
.03491 .4482 L
s
P
p
.001 w
.02823 .46935 m
.03176 .46811 L
s
P
p
.001 w
.02664 .4794 m
.03017 .47817 L
s
P
p
.001 w
.02504 .48951 m
.02857 .48828 L
s
P
P
0 0 m
1 0 L
1 .82055 L
0 .82055 L
closepath
clip
newpath
p
.002 w
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.40296 .79562 L
s
.40296 .79562 m
.41001 .59401 L
s
.41001 .59401 m
.06024 .26735 L
s
.67932 .02494 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.67932 .02494 m
.06024 .26735 L
s
.41001 .59401 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.40296 .79562 L
s
.40296 .79562 m
.41001 .59401 L
s
P
p
.646 .762 .934 r
.0015 w
.39952 .78759 .40314 .79053 .41365 .78777 .41004 .78482 Metetra
.646 .762 .934 r
.41004 .78482 .41365 .78777 .4242 .785 .42061 .78203 Metetra
.646 .762 .934 r
.42061 .78203 .4242 .785 .43479 .78221 .43121 .77924 Metetra
.646 .762 .934 r
.43121 .77924 .43479 .78221 .44543 .77942 .44187 .77643 Metetra
.646 .762 .934 r
.44187 .77643 .44543 .77942 .45611 .77661 .45256 .77361 Metetra
.646 .762 .934 r
.45256 .77361 .45611 .77661 .46683 .77379 .4633 .77078 Metetra
.646 .762 .934 r
.4633 .77078 .46683 .77379 .4776 .77096 .47409 .76794 Metetra
.646 .762 .934 r
.47409 .76794 .4776 .77096 .48841 .76812 .48492 .76508 Metetra
.646 .762 .934 r
.48492 .76508 .48841 .76812 .49927 .76527 .4958 .76222 Metetra
.646 .762 .934 r
.4958 .76222 .49927 .76527 .51018 .7624 .50672 .75934 Metetra
.646 .762 .934 r
.50672 .75934 .51018 .7624 .52113 .75952 .51769 .75645 Metetra
.646 .762 .934 r
.51769 .75645 .52113 .75952 .53205 .72483 .5287 .75354 Metetra
.514 .271 .484 r
.5287 .75354 .53205 .72483 .54299 .72189 .53974 .74604 Metetra
.392 .159 .437 r
.53974 .74604 .54299 .72189 .55397 .71893 .55071 .72798 Metetra
.18 0 .193 r
.55071 .72798 .55397 .71893 .56443 .66874 .5617 .71603 Metetra
.544 .316 .518 r
.5617 .71603 .56443 .66874 .57525 .65956 .57276 .7098 Metetra
.558 .328 .523 r
.57276 .7098 .57525 .65956 .5862 .65651 .58391 .7068 Metetra
.558 .328 .523 r
.58391 .7068 .5862 .65651 .59719 .65344 .5951 .70378 Metetra
.327 .144 .473 r
.5951 .70378 .59719 .65344 .60823 .65036 .60516 .65324 Metetra
.60516 .65324 .60823 .65036 .61907 .63883 .61611 .64396 Metetra
.369 0 .135 r
.61611 .64396 .61907 .63883 .63017 .63571 .62726 .64084 Metetra
.62726 .64084 .63017 .63571 .64132 .63258 .63816 .62924 Metetra
.655 .752 .921 r
.63816 .62924 .64132 .63258 .65216 .62034 .64938 .62608 Metetra
.394 .007 .182 r
.64938 .62608 .65216 .62034 .66281 .6041 .66064 .62292 Metetra
.524 .257 .452 r
.66064 .62292 .66281 .6041 .67402 .60091 .67193 .61939 Metetra
.427 .174 .427 r
.67193 .61939 .67402 .60091 .68485 .58903 .68285 .60739 Metetra
.526 .257 .45 r
.68285 .60739 .68485 .58903 .69498 .56429 .69422 .60417 Metetra
.491 .268 .504 r
.69422 .60417 .69498 .56429 .70598 .55675 .70491 .5878 Metetra
.547 .303 .498 r
.70491 .5878 .70598 .55675 .71725 .55347 .71633 .58453 Metetra
.324 .128 .453 r
.71633 .58453 .71725 .55347 .72803 .54164 .72588 .55093 Metetra
.371 .06 .302 r
.72588 .55093 .72803 .54164 .73937 .53832 .737 .54332 Metetra
.737 .54332 .73937 .53832 .75075 .53498 .74784 .53142 Metetra
.661 .745 .913 r
.74784 .53142 .75075 .53498 .76219 .53164 .75929 .52806 Metetra
.812 .786 .828 r
.75929 .52806 .76219 .53164 .77333 .52401 .77028 .51811 Metetra
.762 .686 .778 r
.77028 .51811 .77333 .52401 .78449 .51637 .7813 .5085 Metetra
.644 .585 .773 r
.7813 .5085 .78449 .51637 .79567 .50872 .79285 .50508 Metetra
.662 .744 .911 r
.79285 .50508 .79567 .50872 .80725 .5053 .80445 .50164 Metetra
.662 .744 .911 r
.80445 .50164 .80725 .5053 .81888 .50186 .81609 .49819 Metetra
.882 .793 .757 r
.81609 .49819 .81888 .50186 .83056 .49842 .82656 .48199 Metetra
.616 .481 .675 r
.82656 .48199 .83056 .49842 .84099 .48222 .83826 .4785 Metetra
.663 .743 .909 r
.83826 .4785 .84099 .48222 .85272 .47873 .85 .475 Metetra
.663 .743 .909 r
.85 .475 .85272 .47873 .86442 .47457 .8618 .47148 Metetra
.658 .782 .94 r
.8618 .47148 .86442 .47457 .87593 .46831 .87364 .46794 Metetra
.497 .901 .92 r
.87364 .46794 .87593 .46831 .8877 .46393 .88546 .46374 Metetra
.673 .975 .89 r
.88546 .46374 .8877 .46393 .89961 .46037 .89698 .45658 Metetra
.663 .742 .909 r
.89698 .45658 .89961 .46037 .91156 .45681 .90896 .45299 Metetra
.663 .742 .909 r
.90896 .45299 .91156 .45681 .92353 .45289 .92099 .44939 Metetra
.779 .802 .871 r
.92099 .44939 .92353 .45289 .93507 .44538 .93251 .44152 Metetra
.663 .742 .908 r
.93251 .44152 .93507 .44538 .94717 .44176 .94463 .43789 Metetra
.646 .762 .934 r
.39588 .78464 .39952 .78759 .41004 .78482 .40642 .78185 Metetra
.646 .762 .934 r
.40642 .78185 .41004 .78482 .42061 .78203 .417 .77906 Metetra
.646 .762 .934 r
.417 .77906 .42061 .78203 .43121 .77924 .42762 .77625 Metetra
.646 .762 .934 r
.42762 .77625 .43121 .77924 .44187 .77643 .43829 .77343 Metetra
.646 .762 .934 r
.43829 .77343 .44187 .77643 .45256 .77361 .449 .7706 Metetra
.646 .762 .934 r
.449 .7706 .45256 .77361 .4633 .77078 .45976 .76775 Metetra
.646 .762 .934 r
.45976 .76775 .4633 .77078 .47409 .76794 .47056 .7649 Metetra
.646 .762 .934 r
.47056 .7649 .47409 .76794 .48492 .76508 .48141 .76203 Metetra
.646 .762 .934 r
.48141 .76203 .48492 .76508 .4958 .76222 .49231 .75915 Metetra
.646 .762 .934 r
.49231 .75915 .4958 .76222 .50672 .75934 .50325 .75626 Metetra
.646 .762 .934 r
.50325 .75626 .50672 .75934 .51769 .75645 .51423 .75336 Metetra
.646 .762 .934 r
.51423 .75336 .51769 .75645 .5287 .75354 .52526 .75044 Metetra
.646 .762 .934 r
.52526 .75044 .5287 .75354 .53974 .74604 .53634 .74751 Metetra
.53634 .74751 .53974 .74604 .55071 .72798 .54747 .74457 Metetra
.461 .19 .415 r
.54747 .74457 .55071 .72798 .5617 .71603 .55859 .73701 Metetra
.356 .119 .41 r
.55859 .73701 .5617 .71603 .57276 .7098 .56959 .71886 Metetra
.182 0 .195 r
.56959 .71886 .57276 .7098 .58391 .7068 .58064 .70683 Metetra
.677 .968 .926 r
.58064 .70683 .58391 .7068 .5951 .70378 .5918 .70056 Metetra
.649 .759 .929 r
.5918 .70056 .5951 .70378 .60516 .65324 .60305 .69751 Metetra
.555 .322 .516 r
.60305 .69751 .60516 .65324 .61611 .64396 .61436 .69445 Metetra
.329 .146 .474 r
.61436 .69445 .61611 .64396 .62726 .64084 .62426 .64371 Metetra
.62426 .64371 .62726 .64084 .63816 .62924 .63528 .63436 Metetra
.366 0 .131 r
.63528 .63436 .63816 .62924 .64938 .62608 .64654 .6312 Metetra
.64654 .6312 .64938 .62608 .66064 .62292 .6575 .61953 Metetra
.655 .752 .921 r
.6575 .61953 .66064 .62292 .67193 .61939 .66883 .61633 Metetra
.652 .773 .937 r
.66883 .61633 .67193 .61939 .68285 .60739 .6802 .61312 Metetra
.391 .003 .178 r
.6802 .61312 .68285 .60739 .69422 .60417 .69163 .6099 Metetra
.69163 .6099 .69422 .60417 .70491 .5878 .70259 .59749 Metetra
.474 .152 .34 r
.70259 .59749 .70491 .5878 .71633 .58453 .71408 .59422 Metetra
.108 0 .21 r
.71408 .59422 .71633 .58453 .72588 .55093 .7248 .57776 Metetra
.541 .292 .486 r
.7248 .57776 .72588 .55093 .737 .54332 .73633 .57445 Metetra
.285 .099 .444 r
.73633 .57445 .737 .54332 .74784 .53142 .7455 .53641 Metetra
.7455 .53641 .74784 .53142 .75929 .52806 .75638 .52446 Metetra
.661 .745 .913 r
.75638 .52446 .75929 .52806 .77028 .51811 .7679 .52107 Metetra
.7679 .52107 .77028 .51811 .7813 .5085 .77894 .51108 Metetra
.165 0 0 r
.77894 .51108 .7813 .5085 .79285 .50508 .79053 .50765 Metetra
.79053 .50765 .79285 .50508 .80445 .50164 .80163 .49797 Metetra
.662 .744 .911 r
.80163 .49797 .80445 .50164 .81609 .49819 .81329 .49451 Metetra
.882 .793 .757 r
.81329 .49451 .81609 .49819 .82656 .48199 .82379 .47828 Metetra
.663 .743 .909 r
.82379 .47828 .82656 .48199 .83826 .4785 .83551 .47477 Metetra
.663 .743 .909 r
.83551 .47477 .83826 .4785 .85 .475 .84727 .47125 Metetra
.663 .743 .909 r
.84727 .47125 .85 .475 .8618 .47148 .85909 .46771 Metetra
.663 .743 .909 r
.85909 .46771 .8618 .47148 .87364 .46794 .87095 .46416 Metetra
.773 .781 .859 r
.87095 .46416 .87364 .46794 .88546 .46374 .88238 .45635 Metetra
.654 .604 .786 r
.88238 .45635 .88546 .46374 .89698 .45658 .8943 .45243 Metetra
.761 .761 .853 r
.8943 .45243 .89698 .45658 .90896 .45299 .90581 .44491 Metetra
.645 .585 .773 r
.90581 .44491 .90896 .45299 .92099 .44939 .91785 .44129 Metetra
.645 .585 .773 r
.91785 .44129 .92099 .44939 .93251 .44152 .92994 .43765 Metetra
.663 .742 .908 r
.92994 .43765 .93251 .44152 .94463 .43789 .94208 .434 Metetra
.646 .762 .934 r
.39223 .78167 .39588 .78464 .40642 .78185 .40278 .77888 Metetra
.646 .762 .934 r
.40278 .77888 .40642 .78185 .417 .77906 .41338 .77607 Metetra
.646 .762 .934 r
.41338 .77607 .417 .77906 .42762 .77625 .42402 .77325 Metetra
.646 .762 .934 r
.42402 .77325 .42762 .77625 .43829 .77343 .4347 .77042 Metetra
.646 .762 .934 r
.4347 .77042 .43829 .77343 .449 .7706 .44543 .76757 Metetra
.646 .762 .934 r
.44543 .76757 .449 .7706 .45976 .76775 .4562 .76472 Metetra
.646 .762 .934 r
.4562 .76472 .45976 .76775 .47056 .7649 .46702 .76185 Metetra
.646 .762 .934 r
.46702 .76185 .47056 .7649 .48141 .76203 .47789 .75897 Metetra
.646 .762 .934 r
.47789 .75897 .48141 .76203 .49231 .75915 .4888 .75608 Metetra
.646 .762 .934 r
.4888 .75608 .49231 .75915 .50325 .75626 .49976 .75317 Metetra
.646 .762 .934 r
.49976 .75317 .50325 .75626 .51423 .75336 .51076 .75025 Metetra
.646 .762 .934 r
.51076 .75025 .51423 .75336 .52526 .75044 .52181 .74733 Metetra
.646 .762 .934 r
.52181 .74733 .52526 .75044 .53634 .74751 .5329 .74438 Metetra
.646 .762 .934 r
.5329 .74438 .53634 .74751 .54747 .74457 .54405 .74143 Metetra
.646 .762 .934 r
.54405 .74143 .54747 .74457 .55859 .73701 .55524 .73846 Metetra
.55524 .73846 .55859 .73701 .56959 .71886 .56648 .73548 Metetra
.519 .241 .432 r
.56648 .73548 .56959 .71886 .58064 .70683 .57777 .73249 Metetra
.54 .286 .479 r
.57777 .73249 .58064 .70683 .5918 .70056 .5891 .72949 Metetra
.544 .295 .489 r
.5891 .72949 .5918 .70056 .60305 .69751 .60049 .72647 Metetra
.544 .295 .489 r
.60049 .72647 .60305 .69751 .61436 .69445 .61192 .72344 Metetra
.544 .295 .489 r
.61192 .72344 .61436 .69445 .62426 .64371 .6234 .72039 Metetra
.514 .301 .529 r
.6234 .72039 .62426 .64371 .63528 .63436 .63428 .69737 Metetra
.56 .334 .53 r
.63428 .69737 .63528 .63436 .64654 .6312 .64579 .69427 Metetra
.56 .334 .53 r
.64579 .69427 .64654 .6312 .6575 .61953 .65735 .69116 Metetra
.561 .338 .534 r
.65735 .69116 .6575 .61953 .66883 .61633 .66896 .68804 Metetra
.53 .314 .53 r
.66896 .68804 .66883 .61633 .6802 .61312 .68004 .67248 Metetra
.559 .332 .527 r
.68004 .67248 .6802 .61312 .69163 .6099 .69171 .66932 Metetra
.352 .172 .492 r
.69171 .66932 .69163 .6099 .70259 .59749 .70049 .61175 Metetra
.445 .166 .395 r
.70049 .61175 .70259 .59749 .71408 .59422 .7118 .60404 Metetra
.384 .073 .31 r
.7118 .60404 .71408 .59422 .7248 .57776 .72316 .59665 Metetra
.525 .257 .45 r
.72316 .59665 .7248 .57776 .73633 .57445 .7348 .59336 Metetra
.525 .257 .45 r
.7348 .59336 .73633 .57445 .7455 .53641 .74648 .59005 Metetra
.527 .305 .521 r
.74648 .59005 .7455 .53641 .75638 .52446 .75756 .57749 Metetra
.512 .294 .519 r
.75756 .57749 .75638 .52446 .7679 .52107 .7683 .56088 Metetra
.305 .127 .468 r
.7683 .56088 .7679 .52107 .77894 .51108 .77659 .51402 Metetra
.206 0 0 r
.77659 .51402 .77894 .51108 .79053 .50765 .78823 .51058 Metetra
.206 0 0 r
.78823 .51058 .79053 .50765 .80163 .49797 .79992 .50713 Metetra
.369 .058 .3 r
.79992 .50713 .80163 .49797 .81329 .49451 .81126 .49936 Metetra
.354 0 .12 r
.81126 .49936 .81329 .49451 .82379 .47828 .82303 .49588 Metetra
.246 .037 .385 r
.82303 .49588 .82379 .47828 .83551 .47477 .83274 .47102 Metetra
.663 .743 .909 r
.83274 .47102 .83551 .47477 .84727 .47125 .84453 .46749 Metetra
.663 .743 .909 r
.84453 .46749 .84727 .47125 .85909 .46771 .85637 .46393 Metetra
.663 .743 .909 r
.85637 .46393 .85909 .46771 .87095 .46416 .86826 .46037 Metetra
.663 .743 .909 r
.86826 .46037 .87095 .46416 .88238 .45635 .88019 .45678 Metetra
.256 .761 .736 r
.88019 .45678 .88238 .45635 .8943 .45243 .89218 .45318 Metetra
.238 .738 .667 r
.89218 .45318 .8943 .45243 .90581 .44491 .90415 .44891 Metetra
.112 0 0 r
.90415 .44891 .90581 .44491 .91785 .44129 .91574 .44135 Metetra
.645 .967 .847 r
.91574 .44135 .91785 .44129 .92994 .43765 .92735 .43377 Metetra
.663 .742 .908 r
.92735 .43377 .92994 .43765 .94208 .434 .93951 .4301 Metetra
.646 .762 .934 r
.38856 .7787 .39223 .78167 .40278 .77888 .39913 .77589 Metetra
.646 .762 .934 r
.39913 .77589 .40278 .77888 .41338 .77607 .40974 .77307 Metetra
.646 .762 .934 r
.40974 .77307 .41338 .77607 .42402 .77325 .42039 .77023 Metetra
.646 .762 .934 r
.42039 .77023 .42402 .77325 .4347 .77042 .43109 .76739 Metetra
.646 .762 .934 r
.43109 .76739 .4347 .77042 .44543 .76757 .44184 .76453 Metetra
.646 .762 .934 r
.44184 .76453 .44543 .76757 .4562 .76472 .45263 .76166 Metetra
.646 .762 .934 r
.45263 .76166 .4562 .76472 .46702 .76185 .46347 .75878 Metetra
.646 .762 .934 r
.46347 .75878 .46702 .76185 .47789 .75897 .47435 .75589 Metetra
.646 .762 .934 r
.47435 .75589 .47789 .75897 .4888 .75608 .48528 .75298 Metetra
.646 .762 .934 r
.48528 .75298 .4888 .75608 .49976 .75317 .49625 .75007 Metetra
.646 .762 .934 r
.49625 .75007 .49976 .75317 .51076 .75025 .50727 .74714 Metetra
.646 .762 .934 r
.50727 .74714 .51076 .75025 .52181 .74733 .51834 .74419 Metetra
.646 .762 .934 r
.51834 .74419 .52181 .74733 .5329 .74438 .52945 .74124 Metetra
.774 .787 .864 r
.52945 .74124 .5329 .74438 .54405 .74143 .54059 .73366 Metetra
.638 .585 .778 r
.54059 .73366 .54405 .74143 .55524 .73846 .55178 .73067 Metetra
.802 .659 .705 r
.55178 .73067 .55524 .73846 .56648 .73548 .56285 .71245 Metetra
.602 .449 .646 r
.56285 .71245 .56648 .73548 .57777 .73249 .57409 .70942 Metetra
.602 .449 .646 r
.57409 .70942 .57777 .73249 .5891 .72949 .58537 .70638 Metetra
.602 .449 .646 r
.58537 .70638 .5891 .72949 .60049 .72647 .59671 .70332 Metetra
.675 .499 .639 r
.59671 .70332 .60049 .72647 .61192 .72344 .60778 .6879 Metetra
.593 .421 .618 r
.60778 .6879 .61192 .72344 .6234 .72039 .61917 .68481 Metetra
.593 .421 .618 r
.61917 .68481 .6234 .72039 .63428 .69737 .63061 .6817 Metetra
.708 .545 .666 r
.63061 .6817 .63428 .69737 .64579 .69427 .64168 .66669 Metetra
.762 .55 .61 r
.64168 .66669 .64579 .69427 .65735 .69116 .65153 .62123 Metetra
.594 .402 .591 r
.65153 .62123 .65735 .69116 .66896 .68804 .66273 .61357 Metetra
.582 .392 .589 r
.66273 .61357 .66896 .68804 .68004 .67248 .67416 .61034 Metetra
.595 .405 .594 r
.67416 .61034 .68004 .67248 .69171 .66932 .68543 .60299 Metetra
.584 .395 .592 r
.68543 .60299 .69171 .66932 .70049 .61175 .69694 .59972 Metetra
.625 .518 .713 r
.69694 .59972 .70049 .61175 .7118 .60404 .7085 .59644 Metetra
.767 .652 .735 r
.7085 .59644 .7118 .60404 .72316 .59665 .71955 .58393 Metetra
.883 .656 .591 r
.71955 .58393 .72316 .59665 .7348 .59336 .72755 .52403 Metetra
.583 .394 .59 r
.72755 .52403 .7348 .59336 .74648 .59005 .73901 .52063 Metetra
.583 .394 .59 r
.73901 .52063 .74648 .59005 .75756 .57749 .75053 .51722 Metetra
.585 .398 .595 r
.75053 .51722 .75756 .57749 .7683 .56088 .76209 .5138 Metetra
.589 .407 .604 r
.76209 .5138 .7683 .56088 .77659 .51402 .77369 .51036 Metetra
.661 .745 .913 r
.77369 .51036 .77659 .51402 .78823 .51058 .78535 .50691 Metetra
.773 .78 .859 r
.78535 .50691 .78823 .51058 .79992 .50713 .79669 .49914 Metetra
.681 .604 .763 r
.79669 .49914 .79992 .50713 .81126 .49936 .80822 .49334 Metetra
.763 .688 .779 r
.80822 .49334 .81126 .49936 .82303 .49588 .81941 .48358 Metetra
.749 .588 .676 r
.81941 .48358 .82303 .49588 .83274 .47102 .8299 .4666 Metetra
.662 .708 .881 r
.8299 .4666 .83274 .47102 .84453 .46749 .84171 .46305 Metetra
.749 .74 .845 r
.84171 .46305 .84453 .46749 .85637 .46393 .85319 .45589 Metetra
.644 .585 .773 r
.85319 .45589 .85637 .46393 .86826 .46037 .86508 .4523 Metetra
.644 .585 .773 r
.86508 .4523 .86826 .46037 .88019 .45678 .87702 .44869 Metetra
.644 .585 .773 r
.87702 .44869 .88019 .45678 .89218 .45318 .88901 .44508 Metetra
.709 .618 .754 r
.88901 .44508 .89218 .45318 .90415 .44891 .90054 .43719 Metetra
.629 .524 .717 r
.90054 .43719 .90415 .44891 .91574 .44135 .91262 .43353 Metetra
.646 .592 .78 r
.91262 .43353 .91574 .44135 .92735 .43377 .92475 .42986 Metetra
.663 .742 .908 r
.92475 .42986 .92735 .43377 .93951 .4301 .93694 .42618 Metetra
.646 .762 .934 r
.38487 .77571 .38856 .7787 .39913 .77589 .39546 .77289 Metetra
.646 .762 .934 r
.39546 .77289 .39913 .77589 .40974 .77307 .40608 .77005 Metetra
.646 .762 .934 r
.40608 .77005 .40974 .77307 .42039 .77023 .41676 .76721 Metetra
.646 .762 .934 r
.41676 .76721 .42039 .77023 .43109 .76739 .42747 .76435 Metetra
.646 .762 .934 r
.42747 .76435 .43109 .76739 .44184 .76453 .43823 .76148 Metetra
.646 .762 .934 r
.43823 .76148 .44184 .76453 .45263 .76166 .44904 .7586 Metetra
.646 .762 .934 r
.44904 .7586 .45263 .76166 .46347 .75878 .45989 .7557 Metetra
.646 .762 .934 r
.45989 .7557 .46347 .75878 .47435 .75589 .47079 .7528 Metetra
.646 .762 .934 r
.47079 .7528 .47435 .75589 .48528 .75298 .48174 .74988 Metetra
.646 .762 .934 r
.48174 .74988 .48528 .75298 .49625 .75007 .49273 .74695 Metetra
.774 .785 .863 r
.49273 .74695 .49625 .75007 .50727 .74714 .50379 .7394 Metetra
.638 .585 .778 r
.50379 .7394 .50727 .74714 .51834 .74419 .51486 .73644 Metetra
.638 .585 .778 r
.51486 .73644 .51834 .74419 .52945 .74124 .52598 .73346 Metetra
.638 .585 .778 r
.52598 .73346 .52945 .74124 .54059 .73366 .53714 .73048 Metetra
.88 .778 .744 r
.53714 .73048 .54059 .73366 .55178 .73067 .54824 .71226 Metetra
.608 .468 .665 r
.54824 .71226 .55178 .73067 .56285 .71245 .55945 .70923 Metetra
.648 .76 .931 r
.55945 .70923 .56285 .71245 .57409 .70942 .57071 .70618 Metetra
.865 .784 .77 r
.57071 .70618 .57409 .70942 .58537 .70638 .5818 .69079 Metetra
.614 .485 .682 r
.5818 .69079 .58537 .70638 .59671 .70332 .59311 .68771 Metetra
.708 .545 .666 r
.59311 .68771 .59671 .70332 .60778 .6879 .60419 .67275 Metetra
.615 .489 .685 r
.60419 .67275 .60778 .6879 .61917 .68481 .61556 .66963 Metetra
.769 .585 .649 r
.61556 .66963 .61917 .68481 .63061 .6817 .62626 .64357 Metetra
.624 .44 .613 r
.62626 .64357 .63061 .6817 .64168 .66669 .63737 .6323 Metetra
.659 .469 .616 r
.63737 .6323 .64168 .66669 .65153 .62123 .64817 .61336 Metetra
.641 .585 .776 r
.64817 .61336 .65153 .62123 .66273 .61357 .65957 .61013 Metetra
.767 .782 .865 r
.65957 .61013 .66273 .61357 .67416 .61034 .67083 .60278 Metetra
.766 .651 .735 r
.67083 .60278 .67416 .61034 .68543 .60299 .68186 .59032 Metetra
.623 .511 .706 r
.68186 .59032 .68543 .60299 .69694 .59972 .69336 .58702 Metetra
.623 .511 .706 r
.69336 .58702 .69694 .59972 .7085 .59644 .70491 .58372 Metetra
.623 .511 .706 r
.70491 .58372 .7085 .59644 .71955 .58393 .7165 .5804 Metetra
.905 .785 .718 r
.7165 .5804 .71955 .58393 .72755 .52403 .72703 .55942 Metetra
.286 .104 .451 r
.72703 .55942 .72755 .52403 .73901 .52063 .73605 .517 Metetra
.661 .745 .913 r
.73605 .517 .73901 .52063 .75053 .51722 .74758 .51358 Metetra
.812 .786 .828 r
.74758 .51358 .75053 .51722 .76209 .5138 .75867 .50354 Metetra
.659 .557 .728 r
.75867 .50354 .76209 .5138 .77369 .51036 .77012 .49811 Metetra
.672 .544 .7 r
.77012 .49811 .77369 .51036 .78535 .50691 .78141 .49036 Metetra
.614 .48 .674 r
.78141 .49036 .78535 .50691 .79669 .49914 .79309 .48686 Metetra
.672 .544 .7 r
.79309 .48686 .79669 .49914 .80822 .49334 .80444 .47908 Metetra
.653 .517 .686 r
.80444 .47908 .80822 .49334 .81941 .48358 .81588 .47213 Metetra
.639 .533 .717 r
.81588 .47213 .81941 .48358 .8299 .4666 .8276 .46773 Metetra
.498 .879 .685 r
.8276 .46773 .8299 .4666 .84171 .46305 .83901 .45991 Metetra
.659 .782 .94 r
.83901 .45991 .84171 .46305 .85319 .45589 .85089 .45632 Metetra
.265 .768 .745 r
.85089 .45632 .85319 .45589 .86508 .4523 .86282 .45272 Metetra
.623 .956 .807 r
.86282 .45272 .86508 .4523 .87702 .44869 .87432 .44484 Metetra
.663 .742 .909 r
.87432 .44484 .87702 .44869 .88901 .44508 .88634 .44121 Metetra
.663 .742 .909 r
.88634 .44121 .88901 .44508 .90054 .43719 .8984 .43755 Metetra
.618 .953 .802 r
.8984 .43755 .90054 .43719 .91262 .43353 .90999 .42962 Metetra
.663 .742 .908 r
.90999 .42962 .91262 .43353 .92475 .42986 .92215 .42594 Metetra
.663 .742 .908 r
.92215 .42594 .92475 .42986 .93694 .42618 .93435 .42223 Metetra
.646 .762 .934 r
.38117 .7727 .38487 .77571 .39546 .77289 .39177 .76987 Metetra
.646 .762 .934 r
.39177 .76987 .39546 .77289 .40608 .77005 .40241 .76702 Metetra
.646 .762 .934 r
.40241 .76702 .40608 .77005 .41676 .76721 .4131 .76416 Metetra
.646 .762 .934 r
.4131 .76416 .41676 .76721 .42747 .76435 .42383 .76129 Metetra
.646 .762 .934 r
.42383 .76129 .42747 .76435 .43823 .76148 .43461 .75841 Metetra
.646 .762 .934 r
.43461 .75841 .43823 .76148 .44904 .7586 .44544 .75552 Metetra
.646 .762 .934 r
.44544 .75552 .44904 .7586 .45989 .7557 .45631 .75261 Metetra
.646 .762 .934 r
.45631 .75261 .45989 .7557 .47079 .7528 .46722 .74969 Metetra
.646 .762 .934 r
.46722 .74969 .47079 .7528 .48174 .74988 .47818 .74676 Metetra
.646 .762 .934 r
.47818 .74676 .48174 .74988 .49273 .74695 .48919 .74382 Metetra
.646 .762 .934 r
.48919 .74382 .49273 .74695 .50379 .7394 .50025 .74086 Metetra
.50025 .74086 .50379 .7394 .51486 .73644 .51135 .73789 Metetra
.51135 .73789 .51486 .73644 .52598 .73346 .5225 .73491 Metetra
.589 .939 .777 r
.5225 .73491 .52598 .73346 .53714 .73048 .53368 .72728 Metetra
.646 .762 .933 r
.53368 .72728 .53714 .73048 .54824 .71226 .54491 .72427 Metetra
.491 .184 .373 r
.54491 .72427 .54824 .71226 .55945 .70923 .55619 .72124 Metetra
.491 .184 .373 r
.55619 .72124 .55945 .70923 .57071 .70618 .56752 .71821 Metetra
.491 .184 .373 r
.56752 .71821 .57071 .70618 .5818 .69079 .57889 .71515 Metetra
.388 .153 .433 r
.57889 .71515 .5818 .69079 .59311 .68771 .59002 .69677 Metetra
.46 .125 .309 r
.59002 .69677 .59311 .68771 .60419 .67275 .60144 .69367 Metetra
.528 .262 .456 r
.60144 .69367 .60419 .67275 .61556 .66963 .61291 .69056 Metetra
.441 .188 .434 r
.61291 .69056 .61556 .66963 .62626 .64357 .62417 .67892 Metetra
.547 .304 .5 r
.62417 .67892 .62626 .64357 .63737 .6323 .63572 .67577 Metetra
.551 .316 .511 r
.63572 .67577 .63737 .6323 .64817 .61336 .64731 .67261 Metetra
.557 .329 .525 r
.64731 .67261 .64817 .61336 .65957 .61013 .65895 .66943 Metetra
.545 .319 .523 r
.65895 .66943 .65957 .61013 .67083 .60278 .67047 .66233 Metetra
.52 .299 .52 r
.67047 .66233 .67083 .60278 .68186 .59032 .68162 .64715 Metetra
.553 .324 .523 r
.68162 .64715 .68186 .59032 .69336 .58702 .6933 .64279 Metetra
.424 .223 .502 r
.6933 .64279 .69336 .58702 .70491 .58372 .70315 .60429 Metetra
.416 .17 .431 r
.70315 .60429 .70491 .58372 .7165 .5804 .71422 .59021 Metetra
.1 0 .203 r
.71422 .59021 .7165 .5804 .72703 .55942 .7251 .5735 Metetra
.503 .213 .405 r
.7251 .5735 .72703 .55942 .73605 .517 .73682 .57013 Metetra
.555 .325 .521 r
.73682 .57013 .73605 .517 .74758 .51358 .74858 .56675 Metetra
.378 .19 .495 r
.74858 .56675 .74758 .51358 .75867 .50354 .75717 .51941 Metetra
.076 0 .303 r
.75717 .51941 .75867 .50354 .77012 .49811 .76687 .49013 Metetra
.709 .618 .754 r
.76687 .49013 .77012 .49811 .78141 .49036 .77817 .48237 Metetra
.697 .612 .758 r
.77817 .48237 .78141 .49036 .79309 .48686 .78957 .47544 Metetra
.639 .533 .717 r
.78957 .47544 .79309 .48686 .80444 .47908 .80121 .47105 Metetra
.709 .618 .754 r
.80121 .47105 .80444 .47908 .81588 .47213 .81258 .46325 Metetra
.64 .567 .757 r
.81258 .46325 .81588 .47213 .8276 .46773 .82438 .45968 Metetra
.644 .585 .773 r
.82438 .45968 .8276 .46773 .83901 .45991 .83623 .45609 Metetra
.663 .743 .909 r
.83623 .45609 .83901 .45991 .85089 .45632 .84813 .45249 Metetra
.663 .743 .909 r
.84813 .45249 .85089 .45632 .86282 .45272 .86008 .44887 Metetra
.663 .743 .909 r
.86008 .44887 .86282 .45272 .87432 .44484 .87209 .44524 Metetra
.27 .772 .749 r
.87209 .44524 .87432 .44484 .88634 .44121 .88414 .44159 Metetra
.332 .811 .767 r
.88414 .44159 .88634 .44121 .8984 .43755 .89617 .43727 Metetra
.418 .863 .892 r
.89617 .43727 .8984 .43755 .90999 .42962 .90833 .43359 Metetra
.118 0 0 r
.90833 .43359 .90999 .42962 .92215 .42594 .92007 .42627 Metetra
.275 .775 .753 r
.92007 .42627 .92215 .42594 .93435 .42223 .93232 .42255 Metetra
.646 .762 .934 r
.37745 .76969 .38117 .7727 .39177 .76987 .38807 .76684 Metetra
.646 .762 .934 r
.38807 .76684 .39177 .76987 .40241 .76702 .39872 .76398 Metetra
.646 .762 .934 r
.39872 .76398 .40241 .76702 .4131 .76416 .40943 .76111 Metetra
.646 .762 .934 r
.40943 .76111 .4131 .76416 .42383 .76129 .42018 .75823 Metetra
.646 .762 .934 r
.42018 .75823 .42383 .76129 .43461 .75841 .43097 .75533 Metetra
.646 .762 .934 r
.43097 .75533 .43461 .75841 .44544 .75552 .44181 .75242 Metetra
.646 .762 .934 r
.44181 .75242 .44544 .75552 .45631 .75261 .4527 .7495 Metetra
.646 .762 .934 r
.4527 .7495 .45631 .75261 .46722 .74969 .46363 .74657 Metetra
.646 .762 .934 r
.46363 .74657 .46722 .74969 .47818 .74676 .47461 .74363 Metetra
.646 .762 .934 r
.47461 .74363 .47818 .74676 .48919 .74382 .48564 .74067 Metetra
.646 .762 .934 r
.48564 .74067 .48919 .74382 .50025 .74086 .49671 .7377 Metetra
.646 .762 .934 r
.49671 .7377 .50025 .74086 .51135 .73789 .50783 .73472 Metetra
.646 .762 .934 r
.50783 .73472 .51135 .73789 .5225 .73491 .519 .73172 Metetra
.646 .762 .934 r
.519 .73172 .5225 .73491 .53368 .72728 .53021 .72871 Metetra
.589 .939 .777 r
.53021 .72871 .53368 .72728 .54491 .72427 .54145 .72105 Metetra
.646 .762 .933 r
.54145 .72105 .54491 .72427 .55619 .72124 .55275 .71801 Metetra
.646 .762 .933 r
.55275 .71801 .55619 .72124 .56752 .71821 .5641 .71496 Metetra
.646 .762 .933 r
.5641 .71496 .56752 .71821 .57889 .71515 .57549 .71189 Metetra
.646 .762 .933 r
.57549 .71189 .57889 .71515 .59002 .69677 .58694 .70881 Metetra
.49 .182 .371 r
.58694 .70881 .59002 .69677 .60144 .69367 .59843 .70572 Metetra
.109 0 .226 r
.59843 .70572 .60144 .69367 .61291 .69056 .60958 .68724 Metetra
.648 .76 .931 r
.60958 .68724 .61291 .69056 .62417 .67892 .62112 .6841 Metetra
.358 0 .113 r
.62112 .6841 .62417 .67892 .63572 .67577 .63271 .68094 Metetra
.358 0 .113 r
.63271 .68094 .63572 .67577 .64731 .67261 .64435 .67778 Metetra
.64435 .67778 .64731 .67261 .65895 .66943 .6557 .66604 Metetra
.649 .759 .93 r
.6557 .66604 .65895 .66943 .67047 .66233 .66742 .66283 Metetra
.264 .77 .768 r
.66742 .66283 .67047 .66233 .68162 .64715 .67918 .65961 Metetra
.493 .189 .378 r
.67918 .65961 .68162 .64715 .6933 .64279 .69099 .65638 Metetra
.5 .203 .394 r
.69099 .65638 .6933 .64279 .70315 .60429 .70286 .65313 Metetra
.538 .308 .514 r
.70286 .65313 .70315 .60429 .71422 .59021 .71456 .64594 Metetra
.328 .151 .482 r
.71456 .64594 .71422 .59021 .7251 .5735 .72314 .5878 Metetra
.371 .102 .37 r
.72314 .5878 .7251 .5735 .73682 .57013 .73438 .57581 Metetra
.73438 .57581 .73682 .57013 .74858 .56675 .74556 .56314 Metetra
.656 .751 .92 r
.74556 .56314 .74858 .56675 .75717 .51941 .7574 .55973 Metetra
.548 .311 .507 r
.7574 .55973 .75717 .51941 .76687 .49013 .76929 .55631 Metetra
.557 .331 .528 r
.76929 .55631 .76687 .49013 .77817 .48237 .78123 .55287 Metetra
.463 .261 .52 r
.78123 .55287 .77817 .48237 .78957 .47544 .79025 .514 Metetra
.507 .277 .501 r
.79025 .514 .78957 .47544 .80121 .47105 .80139 .50176 Metetra
.541 .294 .491 r
.80139 .50176 .80121 .47105 .81258 .46325 .81331 .49822 Metetra
.383 .18 .477 r
.81331 .49822 .81258 .46325 .82438 .45968 .82264 .46704 Metetra
.246 0 .203 r
.82264 .46704 .82438 .45968 .83623 .45609 .83395 .45738 Metetra
.525 .883 .657 r
.83395 .45738 .83623 .45609 .84813 .45249 .84536 .44864 Metetra
.663 .743 .909 r
.84536 .44864 .84813 .45249 .86008 .44887 .85733 .445 Metetra
.683 .751 .903 r
.85733 .445 .86008 .44887 .87209 .44524 .86929 .4407 Metetra
.662 .708 .881 r
.86929 .4407 .87209 .44524 .88414 .44159 .88136 .43703 Metetra
.662 .708 .881 r
.88136 .43703 .88414 .44159 .89617 .43727 .89349 .43335 Metetra
.663 .743 .909 r
.89349 .43335 .89617 .43727 .90833 .43359 .90567 .42965 Metetra
.759 .778 .869 r
.90567 .42965 .90833 .43359 .92007 .42627 .91744 .42231 Metetra
.773 .783 .861 r
.91744 .42231 .92007 .42627 .93232 .42255 .92914 .4143 Metetra
.646 .762 .934 r
.37371 .76666 .37745 .76969 .38807 .76684 .38435 .7638 Metetra
.646 .762 .934 r
.38435 .7638 .38807 .76684 .39872 .76398 .39502 .76092 Metetra
.646 .762 .934 r
.39502 .76092 .39872 .76398 .40943 .76111 .40574 .75804 Metetra
.646 .762 .934 r
.40574 .75804 .40943 .76111 .42018 .75823 .41651 .75514 Metetra
.646 .762 .934 r
.41651 .75514 .42018 .75823 .43097 .75533 .42732 .75224 Metetra
.646 .762 .934 r
.42732 .75224 .43097 .75533 .44181 .75242 .43818 .74931 Metetra
.646 .762 .934 r
.43818 .74931 .44181 .75242 .4527 .7495 .44908 .74638 Metetra
.646 .762 .934 r
.44908 .74638 .4527 .7495 .46363 .74657 .46003 .74344 Metetra
.646 .762 .934 r
.46003 .74344 .46363 .74657 .47461 .74363 .47102 .74048 Metetra
.646 .762 .934 r
.47102 .74048 .47461 .74363 .48564 .74067 .48207 .73751 Metetra
.646 .762 .934 r
.48207 .73751 .48564 .74067 .49671 .7377 .49316 .73452 Metetra
.646 .762 .934 r
.49316 .73452 .49671 .7377 .50783 .73472 .5043 .73153 Metetra
.646 .762 .934 r
.5043 .73153 .50783 .73472 .519 .73172 .51548 .72852 Metetra
.774 .787 .864 r
.51548 .72852 .519 .73172 .53021 .72871 .52671 .72086 Metetra
.637 .585 .779 r
.52671 .72086 .53021 .72871 .54145 .72105 .53798 .71781 Metetra
.646 .762 .933 r
.53798 .71781 .54145 .72105 .55275 .71801 .54929 .71476 Metetra
.646 .762 .933 r
.54929 .71476 .55275 .71801 .5641 .71496 .56066 .71169 Metetra
.646 .762 .933 r
.56066 .71169 .5641 .71496 .57549 .71189 .57207 .70861 Metetra
.646 .762 .933 r
.57207 .70861 .57549 .71189 .58694 .70881 .58353 .70552 Metetra
.884 .783 .744 r
.58353 .70552 .58694 .70881 .59843 .70572 .59472 .68704 Metetra
.607 .467 .665 r
.59472 .68704 .59843 .70572 .60958 .68724 .60623 .68389 Metetra
.648 .76 .931 r
.60623 .68389 .60958 .68724 .62112 .6841 .61779 .68074 Metetra
.648 .76 .931 r
.61779 .68074 .62112 .6841 .63271 .68094 .6294 .67757 Metetra
.648 .76 .931 r
.6294 .67757 .63271 .68094 .64435 .67778 .64106 .67439 Metetra
.648 .76 .931 r
.64106 .67439 .64435 .67778 .6557 .66604 .65278 .6712 Metetra
.355 0 .109 r
.65278 .6712 .6557 .66604 .66742 .66283 .66454 .66799 Metetra
.355 0 .109 r
.66454 .66799 .66742 .66283 .67918 .65961 .67635 .66476 Metetra
.355 0 .109 r
.67635 .66476 .67918 .65961 .69099 .65638 .68822 .66153 Metetra
.201 0 .035 r
.68822 .66153 .69099 .65638 .70286 .65313 .69997 .65504 Metetra
.471 .848 .619 r
.69997 .65504 .70286 .65313 .71456 .64594 .71162 .64638 Metetra
.268 .773 .771 r
.71162 .64638 .71456 .64594 .72314 .5878 .72362 .64309 Metetra
.539 .312 .518 r
.72362 .64309 .72314 .5878 .73438 .57581 .73537 .63517 Metetra
.52 .299 .519 r
.73537 .63517 .73438 .57581 .74556 .56314 .74667 .62042 Metetra
.375 .188 .495 r
.74667 .62042 .74556 .56314 .7574 .55973 .75535 .56954 Metetra
.108 0 .21 r
.75535 .56954 .7574 .55973 .76929 .55631 .7663 .55265 Metetra
.656 .751 .92 r
.7663 .55265 .76929 .55631 .78123 .55287 .77826 .54919 Metetra
.656 .751 .92 r
.77826 .54919 .78123 .55287 .79025 .514 .79028 .54572 Metetra
.5 .262 .486 r
.79028 .54572 .79025 .514 .80139 .50176 .80171 .53501 Metetra
.363 .161 .467 r
.80171 .53501 .80139 .50176 .81331 .49822 .81123 .50321 Metetra
.81123 .50321 .81331 .49822 .82264 .46704 .82243 .49088 Metetra
.381 .158 .445 r
.82243 .49088 .82264 .46704 .83395 .45738 .83276 .4699 Metetra
.491 .191 .384 r
.83276 .4699 .83395 .45738 .84536 .44864 .84479 .46628 Metetra
.421 .167 .421 r
.84479 .46628 .84536 .44864 .85733 .445 .85595 .45401 Metetra
.247 0 .258 r
.85595 .45401 .85733 .445 .86929 .4407 .86709 .44174 Metetra
.496 .878 .683 r
.86709 .44174 .86929 .4407 .88136 .43703 .87872 .43377 Metetra
.659 .782 .939 r
.87872 .43377 .88136 .43703 .89349 .43335 .89087 .43007 Metetra
.859 .833 .82 r
.89087 .43007 .89349 .43335 .90567 .42965 .90202 .4178 Metetra
.628 .524 .717 r
.90202 .4178 .90567 .42965 .91744 .42231 .91424 .41406 Metetra
.644 .585 .773 r
.91424 .41406 .91744 .42231 .92914 .4143 .92652 .4103 Metetra
.646 .762 .934 r
.36996 .76361 .37371 .76666 .38435 .7638 .38061 .76074 Metetra
.646 .762 .934 r
.38061 .76074 .38435 .7638 .39502 .76092 .3913 .75785 Metetra
.646 .762 .934 r
.3913 .75785 .39502 .76092 .40574 .75804 .40204 .75496 Metetra
.646 .762 .934 r
.40204 .75496 .40574 .75804 .41651 .75514 .41282 .75205 Metetra
.646 .762 .934 r
.41282 .75205 .41651 .75514 .42732 .75224 .42365 .74913 Metetra
.646 .762 .934 r
.42365 .74913 .42732 .75224 .43818 .74931 .43452 .74619 Metetra
.773 .783 .861 r
.43452 .74619 .43818 .74931 .44908 .74638 .44555 .73864 Metetra
.637 .585 .779 r
.44555 .73864 .44908 .74638 .46003 .74344 .4565 .73567 Metetra
.637 .585 .779 r
.4565 .73567 .46003 .74344 .47102 .74048 .4675 .7327 Metetra
.637 .585 .779 r
.4675 .7327 .47102 .74048 .48207 .73751 .47854 .72971 Metetra
.637 .585 .779 r
.47854 .72971 .48207 .73751 .49316 .73452 .48964 .7267 Metetra
.637 .585 .779 r
.48964 .7267 .49316 .73452 .5043 .73153 .50078 .72369 Metetra
.637 .585 .779 r
.50078 .72369 .5043 .73153 .51548 .72852 .51196 .72066 Metetra
.637 .585 .779 r
.51196 .72066 .51548 .72852 .52671 .72086 .5232 .71762 Metetra
.646 .762 .933 r
.5232 .71762 .52671 .72086 .53798 .71781 .53449 .71456 Metetra
.646 .762 .933 r
.53449 .71456 .53798 .71781 .54929 .71476 .54582 .7115 Metetra
.882 .78 .744 r
.54582 .7115 .54929 .71476 .56066 .71169 .55705 .69308 Metetra
.607 .466 .665 r
.55705 .69308 .56066 .71169 .57207 .70861 .56843 .68996 Metetra
.607 .466 .665 r
.56843 .68996 .57207 .70861 .58353 .70552 .57986 .68683 Metetra
.607 .466 .665 r
.57986 .68683 .58353 .70552 .59472 .68704 .59134 .68369 Metetra
.648 .76 .931 r
.59134 .68369 .59472 .68704 .60623 .68389 .60287 .68054 Metetra
.648 .76 .931 r
.60287 .68054 .60623 .68389 .61779 .68074 .61445 .67737 Metetra
.744 .785 .886 r
.61445 .67737 .61779 .68074 .6294 .67757 .62598 .67097 Metetra
.736 .662 .777 r
.62598 .67097 .6294 .67757 .64106 .67439 .63747 .66242 Metetra
.763 .601 .677 r
.63747 .66242 .64106 .67439 .65278 .6712 .64856 .64329 Metetra
.763 .549 .608 r
.64856 .64329 .65278 .6712 .66454 .66799 .65849 .59737 Metetra
.621 .42 .589 r
.65849 .59737 .66454 .66799 .67635 .66476 .66928 .5762 Metetra
.578 .384 .582 r
.66928 .5762 .67635 .66476 .68822 .66153 .68085 .57285 Metetra
.647 .435 .582 r
.68085 .57285 .68822 .66153 .69997 .65504 .69041 .52995 Metetra
.599 .395 .576 r
.69041 .52995 .69997 .65504 .71162 .64638 .70097 .50925 Metetra
.575 .376 .574 r
.70097 .50925 .71162 .64638 .72362 .64309 .71248 .50579 Metetra
.581 .38 .574 r
.71248 .50579 .72362 .64309 .73537 .63517 .72377 .49802 Metetra
.577 .377 .574 r
.72377 .49802 .73537 .63517 .74667 .62042 .73527 .4931 Metetra
.585 .384 .575 r
.73527 .4931 .74667 .62042 .75535 .56954 .7464 .48244 Metetra
.579 .384 .582 r
.7464 .48244 .75535 .56954 .7663 .55265 .75806 .47891 Metetra
.58 .389 .586 r
.75806 .47891 .7663 .55265 .77826 .54919 .76977 .47537 Metetra
.584 .391 .586 r
.76977 .47537 .77826 .54919 .79028 .54572 .78139 .47016 Metetra
.604 .405 .585 r
.78139 .47016 .79028 .54572 .80171 .53501 .79223 .4554 Metetra
.579 .387 .584 r
.79223 .4554 .80171 .53501 .81123 .50321 .80404 .45179 Metetra
.585 .401 .598 r
.80404 .45179 .81123 .50321 .82243 .49088 .8159 .44817 Metetra
.588 .409 .606 r
.8159 .44817 .82243 .49088 .83276 .4699 .82782 .44454 Metetra
.6 .44 .637 r
.82782 .44454 .83276 .4699 .84479 .46628 .83978 .44089 Metetra
.6 .44 .637 r
.83978 .44089 .84479 .46628 .85595 .45401 .8518 .43722 Metetra
.619 .482 .673 r
.8518 .43722 .85595 .45401 .86709 .44174 .86379 .43288 Metetra
.64 .571 .761 r
.86379 .43288 .86709 .44174 .87872 .43377 .87591 .42918 Metetra
.819 .763 .8 r
.87591 .42918 .87872 .43377 .89087 .43007 .88715 .41756 Metetra
.625 .516 .709 r
.88715 .41756 .89087 .43007 .90202 .4178 .89934 .41382 Metetra
.663 .742 .908 r
.89934 .41382 .90202 .4178 .91424 .41406 .91159 .41006 Metetra
.663 .742 .908 r
.91159 .41006 .91424 .41406 .92652 .4103 .92388 .40629 Metetra
.646 .762 .934 r
.36619 .76055 .36996 .76361 .38061 .76074 .37686 .75767 Metetra
.646 .762 .934 r
.37686 .75767 .38061 .76074 .3913 .75785 .38756 .75477 Metetra
.646 .762 .934 r
.38756 .75477 .3913 .75785 .40204 .75496 .39832 .75186 Metetra
.646 .762 .934 r
.39832 .75186 .40204 .75496 .41282 .75205 .40911 .74894 Metetra
.646 .762 .934 r
.40911 .74894 .41282 .75205 .42365 .74913 .41996 .746 Metetra
.646 .762 .934 r
.41996 .746 .42365 .74913 .43452 .74619 .43085 .74306 Metetra
.646 .762 .934 r
.43085 .74306 .43452 .74619 .44555 .73864 .44179 .7401 Metetra
.44179 .7401 .44555 .73864 .4565 .73567 .45277 .73712 Metetra
.45277 .73712 .4565 .73567 .4675 .7327 .4638 .73414 Metetra
.4638 .73414 .4675 .7327 .47854 .72971 .47488 .73114 Metetra
.611 .95 .797 r
.47488 .73114 .47854 .72971 .48964 .7267 .48606 .72349 Metetra
.646 .762 .933 r
.48606 .72349 .48964 .7267 .50078 .72369 .49721 .72047 Metetra
.646 .762 .933 r
.49721 .72047 .50078 .72369 .51196 .72066 .50842 .71742 Metetra
.646 .762 .933 r
.50842 .71742 .51196 .72066 .5232 .71762 .51968 .71437 Metetra
.646 .762 .933 r
.51968 .71437 .5232 .71762 .53449 .71456 .53098 .7113 Metetra
.646 .762 .933 r
.53098 .7113 .53449 .71456 .54582 .7115 .54233 .70822 Metetra
.646 .762 .933 r
.54233 .70822 .54582 .7115 .55705 .69308 .55373 .70512 Metetra
.486 .176 .365 r
.55373 .70512 .55705 .69308 .56843 .68996 .56519 .70201 Metetra
.486 .176 .365 r
.56519 .70201 .56843 .68996 .57986 .68683 .57669 .69889 Metetra
.486 .176 .365 r
.57669 .69889 .57986 .68683 .59134 .68369 .58824 .69575 Metetra
.486 .176 .365 r
.58824 .69575 .59134 .68369 .60287 .68054 .59984 .6926 Metetra
.486 .176 .365 r
.59984 .6926 .60287 .68054 .61445 .67737 .6115 .68944 Metetra
.486 .176 .365 r
.6115 .68944 .61445 .67737 .62598 .67097 .6232 .68626 Metetra
.505 .215 .408 r
.6232 .68626 .62598 .67097 .63747 .66242 .63496 .68307 Metetra
.523 .254 .448 r
.63496 .68307 .63747 .66242 .64856 .64329 .64677 .67986 Metetra
.544 .301 .497 r
.64677 .67986 .64856 .64329 .65849 .59737 .65863 .67664 Metetra
.557 .333 .53 r
.65863 .67664 .65849 .59737 .66928 .5762 .67054 .67341 Metetra
.56 .338 .535 r
.67054 .67341 .66928 .5762 .68085 .57285 .68251 .67016 Metetra
.56 .338 .535 r
.68251 .67016 .68085 .57285 .69041 .52995 .69453 .66689 Metetra
.542 .329 .54 r
.69453 .66689 .69041 .52995 .70097 .50925 .70574 .64801 Metetra
.562 .345 .542 r
.70574 .64801 .70097 .50925 .71248 .50579 .71781 .64469 Metetra
.562 .345 .542 r
.71781 .64469 .71248 .50579 .72377 .49802 .72993 .64137 Metetra
.562 .345 .543 r
.72993 .64137 .72377 .49802 .73527 .4931 .74211 .63803 Metetra
.562 .345 .543 r
.74211 .63803 .73527 .4931 .7464 .48244 .75434 .63467 Metetra
.563 .346 .544 r
.75434 .63467 .7464 .48244 .75806 .47891 .76663 .6313 Metetra
.563 .346 .544 r
.76663 .6313 .75806 .47891 .76977 .47537 .77897 .62791 Metetra
.559 .343 .543 r
.77897 .62791 .76977 .47537 .78139 .47016 .79111 .62123 Metetra
.489 .291 .538 r
.79111 .62123 .78139 .47016 .79223 .4554 .79831 .5565 Metetra
.554 .334 .536 r
.79831 .5565 .79223 .4554 .80404 .45179 .81023 .54934 Metetra
.527 .314 .534 r
.81023 .54934 .80404 .45179 .8159 .44817 .82083 .52768 Metetra
.557 .333 .531 r
.82083 .52768 .8159 .44817 .82782 .44454 .83311 .52412 Metetra
.414 .228 .517 r
.83311 .52412 .82782 .44454 .83978 .44089 .8396 .46289 Metetra
.525 .262 .459 r
.8396 .46289 .83978 .44089 .8518 .43722 .85174 .45923 Metetra
.409 .173 .442 r
.85174 .45923 .8518 .43722 .86379 .43288 .86251 .44252 Metetra
.461 .135 .326 r
.86251 .44252 .86379 .43288 .87591 .42918 .87471 .43882 Metetra
.373 .064 .306 r
.87471 .43882 .87591 .42918 .88715 .41756 .88645 .43077 Metetra
.363 .095 .367 r
.88645 .43077 .88715 .41756 .89934 .41382 .89769 .4184 Metetra
.299 0 .071 r
.89769 .4184 .89934 .41382 .91159 .41006 .90991 .41397 Metetra
.284 0 .01 r
.90991 .41397 .91159 .41006 .92388 .40629 .92227 .41019 Metetra
.646 .762 .934 r
.36241 .75748 .36619 .76055 .37686 .75767 .37309 .75458 Metetra
.646 .762 .934 r
.37309 .75458 .37686 .75767 .38756 .75477 .38381 .75167 Metetra
.646 .762 .934 r
.38381 .75167 .38756 .75477 .39832 .75186 .39458 .74875 Metetra
.646 .762 .934 r
.39458 .74875 .39832 .75186 .40911 .74894 .40539 .74581 Metetra
.646 .762 .934 r
.40539 .74581 .40911 .74894 .41996 .746 .41625 .74287 Metetra
.646 .762 .934 r
.41625 .74287 .41996 .746 .43085 .74306 .42716 .73991 Metetra
.646 .762 .934 r
.42716 .73991 .43085 .74306 .44179 .7401 .43812 .73693 Metetra
.646 .762 .934 r
.43812 .73693 .44179 .7401 .45277 .73712 .44912 .73395 Metetra
.646 .762 .934 r
.44912 .73395 .45277 .73712 .4638 .73414 .46016 .73095 Metetra
.646 .762 .934 r
.46016 .73095 .4638 .73414 .47488 .73114 .47126 .72794 Metetra
.646 .762 .934 r
.47126 .72794 .47488 .73114 .48606 .72349 .4824 .72491 Metetra
.4824 .72491 .48606 .72349 .49721 .72047 .49359 .72187 Metetra
.608 .949 .794 r
.49359 .72187 .49721 .72047 .50842 .71742 .50486 .71417 Metetra
.646 .762 .933 r
.50486 .71417 .50842 .71742 .51968 .71437 .51613 .7111 Metetra
.646 .762 .933 r
.51613 .7111 .51968 .71437 .53098 .7113 .52746 .70802 Metetra
.646 .762 .933 r
.52746 .70802 .53098 .7113 .54233 .70822 .53883 .70492 Metetra
.646 .762 .933 r
.53883 .70492 .54233 .70822 .55373 .70512 .55025 .70181 Metetra
.646 .762 .933 r
.55025 .70181 .55373 .70512 .56519 .70201 .56172 .69869 Metetra
.646 .762 .933 r
.56172 .69869 .56519 .70201 .57669 .69889 .57324 .69555 Metetra
.646 .762 .933 r
.57324 .69555 .57669 .69889 .58824 .69575 .58481 .6924 Metetra
.646 .762 .933 r
.58481 .6924 .58824 .69575 .59984 .6926 .59643 .68923 Metetra
.646 .762 .933 r
.59643 .68923 .59984 .6926 .6115 .68944 .60811 .68605 Metetra
.646 .762 .933 r
.60811 .68605 .6115 .68944 .6232 .68626 .61983 .68286 Metetra
.646 .762 .933 r
.61983 .68286 .6232 .68626 .63496 .68307 .63161 .67965 Metetra
.646 .762 .933 r
.63161 .67965 .63496 .68307 .64677 .67986 .64344 .67643 Metetra
.646 .762 .933 r
.64344 .67643 .64677 .67986 .65863 .67664 .65532 .6732 Metetra
.646 .762 .933 r
.65532 .6732 .65863 .67664 .67054 .67341 .66725 .66995 Metetra
.646 .762 .933 r
.66725 .66995 .67054 .67341 .68251 .67016 .67924 .66668 Metetra
.646 .762 .933 r
.67924 .66668 .68251 .67016 .69453 .66689 .69128 .6634 Metetra
.894 .796 .744 r
.69128 .6634 .69453 .66689 .70574 .64801 .70253 .64448 Metetra
.648 .76 .931 r
.70253 .64448 .70574 .64801 .71781 .64469 .71462 .64115 Metetra
.648 .76 .931 r
.71462 .64115 .71781 .64469 .72993 .64137 .72677 .63781 Metetra
.648 .76 .931 r
.72677 .63781 .72993 .64137 .74211 .63803 .73897 .63445 Metetra
.648 .76 .931 r
.73897 .63445 .74211 .63803 .75434 .63467 .75122 .63108 Metetra
.648 .76 .931 r
.75122 .63108 .75434 .63467 .76663 .6313 .76353 .62769 Metetra
.648 .76 .931 r
.76353 .62769 .76663 .6313 .77897 .62791 .7759 .62429 Metetra
.648 .76 .931 r
.7759 .62429 .77897 .62791 .79111 .62123 .78832 .62087 Metetra
.663 .965 .924 r
.78832 .62087 .79111 .62123 .79831 .5565 .80052 .61415 Metetra
.482 .268 .511 r
.80052 .61415 .79831 .5565 .81023 .54934 .81112 .58901 Metetra
.158 .016 .425 r
.81112 .58901 .81023 .54934 .82083 .52768 .81791 .52389 Metetra
.975 .749 .534 r
.81791 .52389 .82083 .52768 .83311 .52412 .82464 .46265 Metetra
.581 .393 .591 r
.82464 .46265 .83311 .52412 .8396 .46289 .83676 .45899 Metetra
.661 .745 .913 r
.83676 .45899 .8396 .46289 .85174 .45923 .84892 .45532 Metetra
.887 .801 .758 r
.84892 .45532 .85174 .45923 .86251 .44252 .85973 .43858 Metetra
.662 .744 .911 r
.85973 .43858 .86251 .44252 .87471 .43882 .87195 .43486 Metetra
.773 .783 .861 r
.87195 .43486 .87471 .43882 .88645 .43077 .88372 .42679 Metetra
.844 .799 .807 r
.88372 .42679 .88645 .43077 .89769 .4184 .89498 .41439 Metetra
.683 .751 .903 r
.89498 .41439 .89769 .4184 .90991 .41397 .90722 .40995 Metetra
.759 .779 .869 r
.90722 .40995 .90991 .41397 .92227 .41019 .91913 .4025 Metetra
.646 .762 .934 r
.3586 .7544 .36241 .75748 .37309 .75458 .3693 .75149 Metetra
.646 .762 .934 r
.3693 .75149 .37309 .75458 .38381 .75167 .38004 .74856 Metetra
.646 .762 .934 r
.38004 .74856 .38381 .75167 .39458 .74875 .39082 .74563 Metetra
.646 .762 .934 r
.39082 .74563 .39458 .74875 .40539 .74581 .40166 .74268 Metetra
.646 .762 .934 r
.40166 .74268 .40539 .74581 .41625 .74287 .41253 .73972 Metetra
.646 .762 .934 r
.41253 .73972 .41625 .74287 .42716 .73991 .42346 .73674 Metetra
.646 .762 .934 r
.42346 .73674 .42716 .73991 .43812 .73693 .43443 .73375 Metetra
.646 .762 .934 r
.43443 .73375 .43812 .73693 .44912 .73395 .44545 .73076 Metetra
.646 .762 .934 r
.44545 .73076 .44912 .73395 .46016 .73095 .45651 .72774 Metetra
.774 .785 .862 r
.45651 .72774 .46016 .73095 .47126 .72794 .4677 .72007 Metetra
.637 .585 .779 r
.4677 .72007 .47126 .72794 .4824 .72491 .47885 .71703 Metetra
.637 .585 .779 r
.47885 .71703 .4824 .72491 .49359 .72187 .49004 .71397 Metetra
.637 .585 .779 r
.49004 .71397 .49359 .72187 .50486 .71417 .50128 .7109 Metetra
.646 .762 .933 r
.50128 .7109 .50486 .71417 .51613 .7111 .51258 .70782 Metetra
.646 .762 .933 r
.51258 .70782 .51613 .7111 .52746 .70802 .52392 .70472 Metetra
.646 .762 .933 r
.52392 .70472 .52746 .70802 .53883 .70492 .53531 .70161 Metetra
.646 .762 .933 r
.53531 .70161 .53883 .70492 .55025 .70181 .54675 .69849 Metetra
.646 .762 .933 r
.54675 .69849 .55025 .70181 .56172 .69869 .55824 .69535 Metetra
.646 .762 .933 r
.55824 .69535 .56172 .69869 .57324 .69555 .56978 .6922 Metetra
.646 .762 .933 r
.56978 .6922 .57324 .69555 .58481 .6924 .58137 .68903 Metetra
.646 .762 .933 r
.58137 .68903 .58481 .6924 .59643 .68923 .59301 .68585 Metetra
.646 .762 .933 r
.59301 .68585 .59643 .68923 .60811 .68605 .6047 .68266 Metetra
.646 .762 .933 r
.6047 .68266 .60811 .68605 .61983 .68286 .61645 .67945 Metetra
.646 .762 .933 r
.61645 .67945 .61983 .68286 .63161 .67965 .62824 .67623 Metetra
.646 .762 .933 r
.62824 .67623 .63161 .67965 .64344 .67643 .64009 .67299 Metetra
.646 .762 .933 r
.64009 .67299 .64344 .67643 .65532 .6732 .652 .66974 Metetra
.646 .762 .933 r
.652 .66974 .65532 .6732 .66725 .66995 .66395 .66647 Metetra
.892 .793 .744 r
.66395 .66647 .66725 .66995 .67924 .66668 .67524 .64758 Metetra
.606 .465 .664 r
.67524 .64758 .67924 .66668 .69128 .6634 .68725 .64427 Metetra
.606 .465 .664 r
.68725 .64427 .69128 .6634 .70253 .64448 .69931 .64094 Metetra
.648 .76 .931 r
.69931 .64094 .70253 .64448 .71462 .64115 .71142 .63759 Metetra
.648 .76 .931 r
.71142 .63759 .71462 .64115 .72677 .63781 .72359 .63424 Metetra
.648 .76 .931 r
.72359 .63424 .72677 .63781 .73897 .63445 .73581 .63086 Metetra
.933 .785 .673 r
.73581 .63086 .73897 .63445 .75122 .63108 .74639 .60262 Metetra
.82 .584 .582 r
.74639 .60262 .75122 .63108 .76353 .62769 .75355 .52887 Metetra
.633 .421 .578 r
.75355 .52887 .76353 .62769 .7759 .62429 .76287 .48997 Metetra
.59 .386 .573 r
.76287 .48997 .7759 .62429 .78832 .62087 .77375 .4733 Metetra
.573 .372 .571 r
.77375 .4733 .78832 .62087 .80052 .61415 .78568 .46969 Metetra
.589 .384 .571 r
.78568 .46969 .80052 .61415 .81112 .58901 .79651 .45307 Metetra
.573 .374 .572 r
.79651 .45307 .81112 .58901 .81791 .52389 .80849 .44941 Metetra
.579 .386 .585 r
.80849 .44941 .81791 .52389 .82464 .46265 .82052 .44574 Metetra
.649 .501 .668 r
.82052 .44574 .82464 .46265 .83676 .45899 .83217 .43773 Metetra
.604 .454 .651 r
.83217 .43773 .83676 .45899 .84892 .45532 .84429 .43402 Metetra
.646 .482 .646 r
.84429 .43402 .84892 .45532 .85973 .43858 .8558 .42413 Metetra
.643 .512 .688 r
.8558 .42413 .85973 .43858 .87195 .43486 .86772 .41792 Metetra
.618 .481 .673 r
.86772 .41792 .87195 .43486 .88372 .42679 .87988 .41349 Metetra
.661 .531 .695 r
.87988 .41349 .88372 .42679 .89498 .41439 .89174 .40606 Metetra
.709 .619 .755 r
.89174 .40606 .89498 .41439 .90722 .40995 .90354 .39796 Metetra
.627 .523 .717 r
.90354 .39796 .90722 .40995 .91913 .4025 .9159 .39413 Metetra
.646 .762 .934 r
.35478 .7513 .3586 .7544 .3693 .75149 .36549 .74837 Metetra
.646 .762 .934 r
.36549 .74837 .3693 .75149 .38004 .74856 .37625 .74544 Metetra
.646 .762 .934 r
.37625 .74544 .38004 .74856 .39082 .74563 .38705 .74249 Metetra
.646 .762 .934 r
.38705 .74249 .39082 .74563 .40166 .74268 .3979 .73952 Metetra
.646 .762 .934 r
.3979 .73952 .40166 .74268 .41253 .73972 .40879 .73655 Metetra
.646 .762 .934 r
.40879 .73655 .41253 .73972 .42346 .73674 .41974 .73356 Metetra
.646 .762 .934 r
.41974 .73356 .42346 .73674 .43443 .73375 .43072 .73056 Metetra
.646 .762 .934 r
.43072 .73056 .43443 .73375 .44545 .73076 .44176 .72755 Metetra
.646 .762 .934 r
.44176 .72755 .44545 .73076 .45651 .72774 .45284 .72452 Metetra
.774 .785 .862 r
.45284 .72452 .45651 .72774 .4677 .72007 .46405 .71683 Metetra
.646 .762 .933 r
.46405 .71683 .4677 .72007 .47885 .71703 .47522 .71378 Metetra
.646 .762 .933 r
.47522 .71378 .47885 .71703 .49004 .71397 .48643 .7107 Metetra
.646 .762 .933 r
.48643 .7107 .49004 .71397 .50128 .7109 .49769 .70762 Metetra
.646 .762 .933 r
.49769 .70762 .50128 .7109 .51258 .70782 .509 .70452 Metetra
.646 .762 .933 r
.509 .70452 .51258 .70782 .52392 .70472 .52036 .70141 Metetra
.646 .762 .933 r
.52036 .70141 .52392 .70472 .53531 .70161 .53177 .69828 Metetra
.646 .762 .933 r
.53177 .69828 .53531 .70161 .54675 .69849 .54323 .69515 Metetra
.646 .762 .933 r
.54323 .69515 .54675 .69849 .55824 .69535 .55474 .69199 Metetra
.646 .762 .933 r
.55474 .69199 .55824 .69535 .56978 .6922 .56629 .68883 Metetra
.646 .762 .933 r
.56629 .68883 .56978 .6922 .58137 .68903 .57791 .68564 Metetra
.646 .762 .933 r
.57791 .68564 .58137 .68903 .59301 .68585 .58957 .68245 Metetra
.646 .762 .933 r
.58957 .68245 .59301 .68585 .6047 .68266 .60128 .67924 Metetra
.646 .762 .933 r
.60128 .67924 .6047 .68266 .61645 .67945 .61305 .67602 Metetra
.646 .762 .933 r
.61305 .67602 .61645 .67945 .62824 .67623 .62486 .67278 Metetra
.646 .762 .933 r
.62486 .67278 .62824 .67623 .64009 .67299 .63673 .66953 Metetra
.646 .762 .933 r
.63673 .66953 .64009 .67299 .652 .66974 .64866 .66626 Metetra
.646 .762 .933 r
.64866 .66626 .652 .66974 .66395 .66647 .66063 .66298 Metetra
.892 .793 .744 r
.66063 .66298 .66395 .66647 .67524 .64758 .67196 .64405 Metetra
.648 .76 .931 r
.67196 .64405 .67524 .64758 .68725 .64427 .68399 .64072 Metetra
.648 .76 .931 r
.68399 .64072 .68725 .64427 .69931 .64094 .69607 .63738 Metetra
.648 .76 .931 r
.69607 .63738 .69931 .64094 .71142 .63759 .7082 .63402 Metetra
.648 .76 .931 r
.7082 .63402 .71142 .63759 .72359 .63424 .72039 .63064 Metetra
.648 .76 .931 r
.72039 .63064 .72359 .63424 .73581 .63086 .73263 .62725 Metetra
.933 .785 .673 r
.73263 .62725 .73581 .63086 .74639 .60262 .74325 .59896 Metetra
.65 .758 .928 r
.74325 .59896 .74639 .60262 .75355 .52887 .75551 .59551 Metetra
.346 .168 .491 r
.75551 .59551 .75355 .52887 .76287 .48997 .7632 .53055 Metetra
.469 .246 .491 r
.7632 .53055 .76287 .48997 .77375 .4733 .7741 .51147 Metetra
.509 .274 .494 r
.7741 .51147 .77375 .4733 .78568 .46969 .78564 .50102 Metetra
.51 .267 .482 r
.78564 .50102 .78568 .46969 .79651 .45307 .7974 .49297 Metetra
.292 .114 .459 r
.7974 .49297 .79651 .45307 .80849 .44941 .80559 .4455 Metetra
.662 .744 .911 r
.80559 .4455 .80849 .44941 .82052 .44574 .81764 .44181 Metetra
.885 .797 .757 r
.81764 .44181 .82052 .44574 .83217 .43773 .82847 .42516 Metetra
.624 .515 .709 r
.82847 .42516 .83217 .43773 .84429 .43402 .84057 .42143 Metetra
.624 .515 .709 r
.84057 .42143 .84429 .43402 .8558 .42413 .85273 .41768 Metetra
.653 .636 .82 r
.85273 .41768 .8558 .42413 .86772 .41792 .86494 .41391 Metetra
.773 .782 .86 r
.86494 .41391 .86772 .41792 .87988 .41349 .87671 .40582 Metetra
.653 .604 .787 r
.87671 .40582 .87988 .41349 .89174 .40606 .88897 .40168 Metetra
.761 .762 .853 r
.88897 .40168 .89174 .40606 .90354 .39796 .90083 .39389 Metetra
.663 .742 .908 r
.90083 .39389 .90354 .39796 .9159 .39413 .91322 .39004 Metetra
.646 .762 .934 r
.35095 .74819 .35478 .7513 .36549 .74837 .36167 .74525 Metetra
.646 .762 .934 r
.36167 .74525 .36549 .74837 .37625 .74544 .37245 .7423 Metetra
.646 .762 .934 r
.37245 .7423 .37625 .74544 .38705 .74249 .38326 .73933 Metetra
.646 .762 .934 r
.38326 .73933 .38705 .74249 .3979 .73952 .39413 .73636 Metetra
.646 .762 .934 r
.39413 .73636 .3979 .73952 .40879 .73655 .40504 .73337 Metetra
.773 .783 .861 r
.40504 .73337 .40879 .73655 .41974 .73356 .41614 .72574 Metetra
.636 .585 .78 r
.41614 .72574 .41974 .73356 .43072 .73056 .42714 .72272 Metetra
.636 .585 .78 r
.42714 .72272 .43072 .73056 .44176 .72755 .43817 .71968 Metetra
.636 .585 .78 r
.43817 .71968 .44176 .72755 .45284 .72452 .44926 .71664 Metetra
.636 .585 .78 r
.44926 .71664 .45284 .72452 .46405 .71683 .46039 .71358 Metetra
.646 .762 .933 r
.46039 .71358 .46405 .71683 .47522 .71378 .47157 .71051 Metetra
.646 .762 .933 r
.47157 .71051 .47522 .71378 .48643 .7107 .4828 .70742 Metetra
.646 .762 .933 r
.4828 .70742 .48643 .7107 .49769 .70762 .49408 .70432 Metetra
.646 .762 .933 r
.49408 .70432 .49769 .70762 .509 .70452 .50541 .70121 Metetra
.646 .762 .933 r
.50541 .70121 .509 .70452 .52036 .70141 .51679 .69808 Metetra
.646 .762 .933 r
.51679 .69808 .52036 .70141 .53177 .69828 .52821 .69494 Metetra
.646 .762 .933 r
.52821 .69494 .53177 .69828 .54323 .69515 .53969 .69179 Metetra
.646 .762 .933 r
.53969 .69179 .54323 .69515 .55474 .69199 .55122 .68862 Metetra
.646 .762 .933 r
.55122 .68862 .55474 .69199 .56629 .68883 .5628 .68544 Metetra
.646 .762 .933 r
.5628 .68544 .56629 .68883 .57791 .68564 .57443 .68224 Metetra
.646 .762 .933 r
.57443 .68224 .57791 .68564 .58957 .68245 .58611 .67903 Metetra
.646 .762 .933 r
.58611 .67903 .58957 .68245 .60128 .67924 .59784 .67581 Metetra
.646 .762 .933 r
.59784 .67581 .60128 .67924 .61305 .67602 .60963 .67257 Metetra
.646 .762 .933 r
.60963 .67257 .61305 .67602 .62486 .67278 .62147 .66932 Metetra
.646 .762 .933 r
.62147 .66932 .62486 .67278 .63673 .66953 .63336 .66605 Metetra
.646 .762 .933 r
.63336 .66605 .63673 .66953 .64866 .66626 .6453 .66277 Metetra
.646 .762 .933 r
.6453 .66277 .64866 .66626 .66063 .66298 .6573 .65947 Metetra
.844 .8 .808 r
.6573 .65947 .66063 .66298 .67196 .64405 .66893 .64668 Metetra
.66893 .64668 .67196 .64405 .68399 .64072 .68071 .63716 Metetra
.648 .76 .931 r
.68071 .63716 .68399 .64072 .69607 .63738 .69281 .6338 Metetra
.648 .76 .931 r
.69281 .6338 .69607 .63738 .7082 .63402 .70497 .63043 Metetra
.648 .76 .931 r
.70497 .63043 .7082 .63402 .72039 .63064 .71718 .62704 Metetra
.648 .76 .931 r
.71718 .62704 .72039 .63064 .73263 .62725 .72944 .62363 Metetra
.648 .76 .931 r
.72944 .62363 .73263 .62725 .74325 .59896 .74177 .62021 Metetra
.52 .249 .445 r
.74177 .62021 .74325 .59896 .75551 .59551 .75414 .61677 Metetra
.52 .249 .445 r
.75414 .61677 .75551 .59551 .7632 .53055 .76658 .61332 Metetra
.555 .329 .528 r
.76658 .61332 .7632 .53055 .7741 .51147 .77907 .60985 Metetra
.533 .315 .53 r
.77907 .60985 .7741 .51147 .78564 .50102 .79051 .5929 Metetra
.534 .315 .529 r
.79051 .5929 .78564 .50102 .7974 .49297 .80206 .57779 Metetra
.45 .252 .518 r
.80206 .57779 .7974 .49297 .80559 .4455 .81052 .52865 Metetra
.499 .288 .524 r
.81052 .52865 .80559 .4455 .81764 .44181 .82057 .49972 Metetra
.373 .187 .495 r
.82057 .49972 .81764 .44181 .82847 .42516 .82816 .4472 Metetra
.354 .127 .425 r
.82816 .4472 .82847 .42516 .84057 .42143 .83861 .42607 Metetra
.111 0 0 r
.83861 .42607 .84057 .42143 .85273 .41768 .85037 .41798 Metetra
.643 .965 .824 r
.85037 .41798 .85273 .41768 .86494 .41391 .86214 .40988 Metetra
.773 .782 .86 r
.86214 .40988 .86494 .41391 .87671 .40582 .87394 .40176 Metetra
.663 .742 .909 r
.87394 .40176 .87671 .40582 .88897 .40168 .88626 .39794 Metetra
.673 .765 .92 r
.88626 .39794 .88897 .40168 .90083 .39389 .8986 .39377 Metetra
.668 .975 .865 r
.8986 .39377 .90083 .39389 .91322 .39004 .91052 .38593 Metetra
.646 .762 .934 r
.34709 .74506 .35095 .74819 .36167 .74525 .35783 .74211 Metetra
.646 .762 .934 r
.35783 .74211 .36167 .74525 .37245 .7423 .36862 .73914 Metetra
.646 .762 .934 r
.36862 .73914 .37245 .7423 .38326 .73933 .37946 .73617 Metetra
.773 .782 .86 r
.37946 .73617 .38326 .73933 .39413 .73636 .39052 .72855 Metetra
.636 .585 .78 r
.39052 .72855 .39413 .73636 .40504 .73337 .40143 .72554 Metetra
.636 .585 .78 r
.40143 .72554 .40504 .73337 .41614 .72574 .41239 .72252 Metetra
.646 .762 .933 r
.41239 .72252 .41614 .72574 .42714 .72272 .4234 .71949 Metetra
.646 .762 .933 r
.4234 .71949 .42714 .72272 .43817 .71968 .43446 .71644 Metetra
.646 .762 .933 r
.43446 .71644 .43817 .71968 .44926 .71664 .44556 .71338 Metetra
.646 .762 .933 r
.44556 .71338 .44926 .71664 .46039 .71358 .45671 .71031 Metetra
.646 .762 .933 r
.45671 .71031 .46039 .71358 .47157 .71051 .46791 .70722 Metetra
.646 .762 .933 r
.46791 .70722 .47157 .71051 .4828 .70742 .47916 .70412 Metetra
.646 .762 .933 r
.47916 .70412 .4828 .70742 .49408 .70432 .49046 .70101 Metetra
.646 .762 .933 r
.49046 .70101 .49408 .70432 .50541 .70121 .5018 .69788 Metetra
.646 .762 .933 r
.5018 .69788 .50541 .70121 .51679 .69808 .5132 .69474 Metetra
.646 .762 .933 r
.5132 .69474 .51679 .69808 .52821 .69494 .52464 .69159 Metetra
.646 .762 .933 r
.52464 .69159 .52821 .69494 .53969 .69179 .53614 .68842 Metetra
.646 .762 .933 r
.53614 .68842 .53969 .69179 .55122 .68862 .54769 .68524 Metetra
.646 .762 .933 r
.54769 .68524 .55122 .68862 .5628 .68544 .55929 .68204 Metetra
.646 .762 .933 r
.55929 .68204 .5628 .68544 .57443 .68224 .57094 .67883 Metetra
.646 .762 .933 r
.57094 .67883 .57443 .68224 .58611 .67903 .58264 .6756 Metetra
.646 .762 .933 r
.58264 .6756 .58611 .67903 .59784 .67581 .59439 .67236 Metetra
.646 .762 .933 r
.59439 .67236 .59784 .67581 .60963 .67257 .6062 .66911 Metetra
.646 .762 .933 r
.6062 .66911 .60963 .67257 .62147 .66932 .61805 .66584 Metetra
.646 .762 .933 r
.61805 .66584 .62147 .66932 .63336 .66605 .62997 .66256 Metetra
.646 .762 .933 r
.62997 .66256 .63336 .66605 .6453 .66277 .64193 .65926 Metetra
.646 .762 .933 r
.64193 .65926 .6453 .66277 .6573 .65947 .65395 .65595 Metetra
.892 .793 .744 r
.65395 .65595 .6573 .65947 .66893 .64668 .66535 .63695 Metetra
.63 .556 .752 r
.66535 .63695 .66893 .64668 .68071 .63716 .67742 .63359 Metetra
.648 .76 .931 r
.67742 .63359 .68071 .63716 .69281 .6338 .68954 .63021 Metetra
.648 .76 .931 r
.68954 .63021 .69281 .6338 .70497 .63043 .70172 .62682 Metetra
.648 .76 .931 r
.70172 .62682 .70497 .63043 .71718 .62704 .71395 .62341 Metetra
.882 .801 .765 r
.71395 .62341 .71718 .62704 .72944 .62363 .72541 .60659 Metetra
.699 .535 .661 r
.72541 .60659 .72944 .62363 .74177 .62021 .73694 .5916 Metetra
.77 .55 .6 r
.73694 .5916 .74177 .62021 .75414 .61677 .74609 .54272 Metetra
.631 .424 .583 r
.74609 .54272 .75414 .61677 .76658 .61332 .75642 .51397 Metetra
.612 .405 .576 r
.75642 .51397 .76658 .61332 .77907 .60985 .76677 .48739 Metetra
.601 .393 .572 r
.76677 .48739 .77907 .60985 .79051 .5929 .77721 .46343 Metetra
.579 .377 .571 r
.77721 .46343 .79051 .5929 .80206 .57779 .78882 .45437 Metetra
.572 .373 .572 r
.78882 .45437 .80206 .57779 .81052 .52865 .80091 .45068 Metetra
.576 .383 .582 r
.80091 .45068 .81052 .52865 .82057 .49972 .81306 .44696 Metetra
.582 .396 .595 r
.81306 .44696 .82057 .49972 .82816 .4472 .82526 .44324 Metetra
.887 .799 .758 r
.82526 .44324 .82816 .4472 .83861 .42607 .83619 .4264 Metetra
.92 .977 .718 r
.83619 .4264 .83861 .42607 .85037 .41798 .84708 .40963 Metetra
.643 .585 .774 r
.84708 .40963 .85037 .41798 .86214 .40988 .85934 .40583 Metetra
.663 .743 .909 r
.85934 .40583 .86214 .40988 .87394 .40176 .87164 .40201 Metetra
.311 .801 .786 r
.87164 .40201 .87394 .40176 .88626 .39794 .88401 .39817 Metetra
.37 .837 .8 r
.88401 .39817 .88626 .39794 .8986 .39377 .89635 .39365 Metetra
.649 .969 .868 r
.89635 .39365 .8986 .39377 .91052 .38593 .90835 .38612 Metetra
.646 .762 .934 r
.34322 .74192 .34709 .74506 .35783 .74211 .35398 .73895 Metetra
.646 .762 .934 r
.35398 .73895 .35783 .74211 .36862 .73914 .36478 .73598 Metetra
.646 .762 .934 r
.36478 .73598 .36862 .73914 .37946 .73617 .37563 .73299 Metetra
.773 .782 .86 r
.37563 .73299 .37946 .73617 .39052 .72855 .38672 .72535 Metetra
.646 .762 .933 r
.38672 .72535 .39052 .72855 .40143 .72554 .39765 .72233 Metetra
.646 .762 .933 r
.39765 .72233 .40143 .72554 .41239 .72252 .40863 .71929 Metetra
.646 .762 .933 r
.40863 .71929 .41239 .72252 .4234 .71949 .41965 .71625 Metetra
.646 .762 .933 r
.41965 .71625 .4234 .71949 .43446 .71644 .43072 .71319 Metetra
.646 .762 .933 r
.43072 .71319 .43446 .71644 .44556 .71338 .44184 .71011 Metetra
.646 .762 .933 r
.44184 .71011 .44556 .71338 .45671 .71031 .45301 .70702 Metetra
.646 .762 .933 r
.45301 .70702 .45671 .71031 .46791 .70722 .46423 .70392 Metetra
.646 .762 .933 r
.46423 .70392 .46791 .70722 .47916 .70412 .4755 .70081 Metetra
.646 .762 .933 r
.4755 .70081 .47916 .70412 .49046 .70101 .48681 .69768 Metetra
.646 .762 .933 r
.48681 .69768 .49046 .70101 .5018 .69788 .49818 .69454 Metetra
.646 .762 .933 r
.49818 .69454 .5018 .69788 .5132 .69474 .50959 .69138 Metetra
.646 .762 .933 r
.50959 .69138 .5132 .69474 .52464 .69159 .52106 .68821 Metetra
.646 .762 .933 r
.52106 .68821 .52464 .69159 .53614 .68842 .53257 .68503 Metetra
.646 .762 .933 r
.53257 .68503 .53614 .68842 .54769 .68524 .54414 .68183 Metetra
.646 .762 .933 r
.54414 .68183 .54769 .68524 .55929 .68204 .55576 .67862 Metetra
.646 .762 .933 r
.55576 .67862 .55929 .68204 .57094 .67883 .56743 .6754 Metetra
.646 .762 .933 r
.56743 .6754 .57094 .67883 .58264 .6756 .57915 .67216 Metetra
.646 .762 .933 r
.57915 .67216 .58264 .6756 .59439 .67236 .59092 .6689 Metetra
.646 .762 .933 r
.59092 .6689 .59439 .67236 .6062 .66911 .60275 .66563 Metetra
.646 .762 .933 r
.60275 .66563 .6062 .66911 .61805 .66584 .61462 .66235 Metetra
.646 .762 .933 r
.61462 .66235 .61805 .66584 .62997 .66256 .62656 .65905 Metetra
.89 .791 .744 r
.62656 .65905 .62997 .66256 .64193 .65926 .638 .64008 Metetra
.604 .464 .663 r
.638 .64008 .64193 .65926 .65395 .65595 .64998 .63673 Metetra
.604 .464 .663 r
.64998 .63673 .65395 .65595 .66535 .63695 .66202 .63337 Metetra
.648 .76 .931 r
.66202 .63337 .66535 .63695 .67742 .63359 .67411 .62999 Metetra
.648 .76 .931 r
.67411 .62999 .67742 .63359 .68954 .63021 .68625 .6266 Metetra
.648 .76 .931 r
.68625 .6266 .68954 .63021 .70172 .62682 .69845 .62319 Metetra
.948 .768 .626 r
.69845 .62319 .70172 .62682 .71395 .62341 .70871 .58483 Metetra
.756 .531 .59 r
.70871 .58483 .71395 .62341 .72541 .60659 .71748 .52537 Metetra
.585 .388 .581 r
.71748 .52537 .72541 .60659 .73694 .5916 .7292 .51732 Metetra
.591 .394 .583 r
.7292 .51732 .73694 .5916 .74609 .54272 .74079 .50719 Metetra
.722 .508 .599 r
.74079 .50719 .74609 .54272 .75642 .51397 .7502 .46685 Metetra
.602 .413 .599 r
.7502 .46685 .75642 .51397 .76677 .48739 .76177 .45782 Metetra
.593 .426 .625 r
.76177 .45782 .76677 .48739 .77721 .46343 .77378 .45414 Metetra
.636 .564 .756 r
.77378 .45414 .77721 .46343 .78882 .45437 .78585 .45044 Metetra
.884 .796 .757 r
.78585 .45044 .78882 .45437 .80091 .45068 .79681 .43366 Metetra
.611 .476 .673 r
.79681 .43366 .80091 .45068 .81306 .44696 .80892 .42992 Metetra
.648 .5 .668 r
.80892 .42992 .81306 .44696 .82526 .44324 .82068 .42182 Metetra
.612 .459 .649 r
.82068 .42182 .82526 .44324 .83619 .4264 .83275 .41671 Metetra
.736 .612 .72 r
.83275 .41671 .83619 .4264 .84708 .40963 .84417 .40492 Metetra
.749 .742 .846 r
.84417 .40492 .84708 .40963 .85934 .40583 .85604 .39745 Metetra
.643 .585 .774 r
.85604 .39745 .85934 .40583 .87164 .40201 .86836 .39361 Metetra
.709 .619 .755 r
.86836 .39361 .87164 .40201 .88401 .39817 .88022 .38543 Metetra
.623 .515 .709 r
.88022 .38543 .88401 .39817 .89635 .39365 .89263 .38155 Metetra
.626 .523 .717 r
.89263 .38155 .89635 .39365 .90835 .38612 .90509 .37765 Metetra
.646 .762 .934 r
.33933 .73876 .34322 .74192 .35398 .73895 .3501 .73578 Metetra
.646 .762 .934 r
.3501 .73578 .35398 .73895 .36478 .73598 .36093 .73279 Metetra
.646 .762 .934 r
.36093 .73279 .36478 .73598 .37563 .73299 .37179 .72979 Metetra
.646 .762 .934 r
.37179 .72979 .37563 .73299 .38672 .72535 .38271 .72677 Metetra
.38271 .72677 .38672 .72535 .39765 .72233 .39367 .72374 Metetra
.646 .966 .826 r
.39367 .72374 .39765 .72233 .40863 .71929 .40484 .71605 Metetra
.646 .762 .933 r
.40484 .71605 .40863 .71929 .41965 .71625 .41588 .71299 Metetra
.646 .762 .933 r
.41588 .71299 .41965 .71625 .43072 .71319 .42697 .70991 Metetra
.646 .762 .933 r
.42697 .70991 .43072 .71319 .44184 .71011 .43811 .70682 Metetra
.646 .762 .933 r
.43811 .70682 .44184 .71011 .45301 .70702 .4493 .70372 Metetra
.646 .762 .933 r
.4493 .70372 .45301 .70702 .46423 .70392 .46053 .70061 Metetra
.646 .762 .933 r
.46053 .70061 .46423 .70392 .4755 .70081 .47182 .69748 Metetra
.646 .762 .933 r
.47182 .69748 .4755 .70081 .48681 .69768 .48315 .69434 Metetra
.646 .762 .933 r
.48315 .69434 .48681 .69768 .49818 .69454 .49453 .69118 Metetra
.646 .762 .933 r
.49453 .69118 .49818 .69454 .50959 .69138 .50597 .68801 Metetra
.646 .762 .933 r
.50597 .68801 .50959 .69138 .52106 .68821 .51745 .68483 Metetra
.646 .762 .933 r
.51745 .68483 .52106 .68821 .53257 .68503 .52899 .68163 Metetra
.646 .762 .933 r
.52899 .68163 .53257 .68503 .54414 .68183 .54057 .67841 Metetra
.646 .762 .933 r
.54057 .67841 .54414 .68183 .55576 .67862 .55221 .67519 Metetra
.646 .762 .933 r
.55221 .67519 .55576 .67862 .56743 .6754 .5639 .67195 Metetra
.646 .762 .933 r
.5639 .67195 .56743 .6754 .57915 .67216 .57564 .66869 Metetra
.646 .762 .933 r
.57564 .66869 .57915 .67216 .59092 .6689 .58743 .66542 Metetra
.646 .762 .933 r
.58743 .66542 .59092 .6689 .60275 .66563 .59928 .66214 Metetra
.646 .762 .933 r
.59928 .66214 .60275 .66563 .61462 .66235 .61118 .65884 Metetra
.889 .789 .744 r
.61118 .65884 .61462 .66235 .62656 .65905 .62266 .63987 Metetra
.604 .463 .663 r
.62266 .63987 .62656 .65905 .638 .64008 .63461 .63652 Metetra
.648 .76 .931 r
.63461 .63652 .638 .64008 .64998 .63673 .64661 .63315 Metetra
.648 .76 .931 r
.64661 .63315 .64998 .63673 .66202 .63337 .65867 .62977 Metetra
.648 .76 .931 r
.65867 .62977 .66202 .63337 .67411 .62999 .67078 .62638 Metetra
.648 .76 .931 r
.67078 .62638 .67411 .62999 .68625 .6266 .68295 .62297 Metetra
.648 .76 .931 r
.68295 .62297 .68625 .6266 .69845 .62319 .69517 .61955 Metetra
.948 .768 .626 r
.69517 .61955 .69845 .62319 .70871 .58483 .70548 .58112 Metetra
.947 .769 .629 r
.70548 .58112 .70871 .58483 .71748 .52537 .71568 .54422 Metetra
0 0 .271 r
.71568 .54422 .71748 .52537 .7292 .51732 .72564 .50696 Metetra
.763 .617 .697 r
.72564 .50696 .7292 .51732 .74079 .50719 .73685 .49101 Metetra
.776 .583 .639 r
.73685 .49101 .74079 .50719 .7502 .46685 .74715 .46296 Metetra
.792 .785 .846 r
.74715 .46296 .7502 .46685 .76177 .45782 .75874 .4539 Metetra
.661 .745 .913 r
.75874 .4539 .76177 .45782 .77378 .45414 .77077 .4502 Metetra
.883 .794 .757 r
.77077 .4502 .77378 .45414 .78585 .45044 .78177 .43342 Metetra
.648 .5 .668 r
.78177 .43342 .78585 .45044 .79681 .43366 .79347 .42534 Metetra
.76 .644 .733 r
.79347 .42534 .79681 .43366 .80892 .42992 .8048 .41294 Metetra
.611 .476 .673 r
.8048 .41294 .80892 .42992 .82068 .42182 .81694 .40915 Metetra
.623 .514 .709 r
.81694 .40915 .82068 .42182 .83275 .41671 .82913 .40534 Metetra
.628 .531 .725 r
.82913 .40534 .83275 .41671 .84417 .40492 .84138 .40152 Metetra
.66 .781 .938 r
.84138 .40152 .84417 .40492 .85604 .39745 .85368 .39768 Metetra
.38 .843 .809 r
.85368 .39768 .85604 .39745 .86836 .39361 .86596 .39315 Metetra
.697 .978 .905 r
.86596 .39315 .86836 .39361 .88022 .38543 .87794 .38562 Metetra
.324 .81 .798 r
.87794 .38562 .88022 .38543 .89263 .38155 .89039 .38172 Metetra
.646 .966 .826 r
.89039 .38172 .89263 .38155 .90509 .37765 .90235 .37349 Metetra
.646 .762 .934 r
.33542 .73559 .33933 .73876 .3501 .73578 .34621 .7326 Metetra
.646 .762 .934 r
.34621 .7326 .3501 .73578 .36093 .73279 .35705 .7296 Metetra
.646 .762 .934 r
.35705 .7296 .36093 .73279 .37179 .72979 .36794 .72658 Metetra
.646 .762 .934 r
.36794 .72658 .37179 .72979 .38271 .72677 .37887 .72355 Metetra
.773 .782 .86 r
.37887 .72355 .38271 .72677 .39367 .72374 .39003 .71585 Metetra
.636 .585 .78 r
.39003 .71585 .39367 .72374 .40484 .71605 .40104 .71279 Metetra
.646 .762 .933 r
.40104 .71279 .40484 .71605 .41588 .71299 .4121 .70972 Metetra
.646 .762 .933 r
.4121 .70972 .41588 .71299 .42697 .70991 .42321 .70663 Metetra
.646 .762 .933 r
.42321 .70663 .42697 .70991 .43811 .70682 .43436 .70352 Metetra
.646 .762 .933 r
.43436 .70352 .43811 .70682 .4493 .70372 .44557 .70041 Metetra
.646 .762 .933 r
.44557 .70041 .4493 .70372 .46053 .70061 .45682 .69728 Metetra
.646 .762 .933 r
.45682 .69728 .46053 .70061 .47182 .69748 .46812 .69413 Metetra
.646 .762 .933 r
.46812 .69413 .47182 .69748 .48315 .69434 .47947 .69098 Metetra
.646 .762 .933 r
.47947 .69098 .48315 .69434 .49453 .69118 .49088 .68781 Metetra
.646 .762 .933 r
.49088 .68781 .49453 .69118 .50597 .68801 .50233 .68462 Metetra
.646 .762 .933 r
.50233 .68462 .50597 .68801 .51745 .68483 .51383 .68142 Metetra
.646 .762 .933 r
.51383 .68142 .51745 .68483 .52899 .68163 .52538 .67821 Metetra
.646 .762 .933 r
.52538 .67821 .52899 .68163 .54057 .67841 .53699 .67498 Metetra
.646 .762 .933 r
.53699 .67498 .54057 .67841 .55221 .67519 .54865 .67174 Metetra
.84 .792 .805 r
.54865 .67174 .55221 .67519 .5639 .67195 .56025 .65904 Metetra
.639 .523 .706 r
.56025 .65904 .5639 .67195 .57564 .66869 .57195 .65395 Metetra
.657 .52 .686 r
.57195 .65395 .57564 .66869 .58743 .66542 .58365 .64631 Metetra
.603 .463 .663 r
.58365 .64631 .58743 .66542 .59928 .66214 .59546 .64299 Metetra
.603 .463 .663 r
.59546 .64299 .59928 .66214 .61118 .65884 .60732 .63965 Metetra
.603 .463 .663 r
.60732 .63965 .61118 .65884 .62266 .63987 .61924 .6363 Metetra
.925 .773 .673 r
.61924 .6363 .62266 .63987 .63461 .63652 .63036 .60699 Metetra
.756 .541 .605 r
.63036 .60699 .63461 .63652 .64661 .63315 .64075 .56152 Metetra
.649 .438 .583 r
.64075 .56152 .64661 .63315 .65867 .62977 .65123 .52452 Metetra
.583 .382 .574 r
.65123 .52452 .65867 .62977 .67078 .62638 .66268 .51416 Metetra
.624 .411 .573 r
.66268 .51416 .67078 .62638 .68295 .62297 .67278 .47552 Metetra
.573 .37 .567 r
.67278 .47552 .68295 .62297 .69517 .61955 .68434 .46924 Metetra
.569 .367 .567 r
.68434 .46924 .69517 .61955 .70548 .58112 .69607 .46562 Metetra
.587 .383 .572 r
.69607 .46562 .70548 .58112 .71568 .54422 .70724 .45166 Metetra
.573 .376 .576 r
.70724 .45166 .71568 .54422 .72564 .50696 .71903 .448 Metetra
.583 .393 .589 r
.71903 .448 .72564 .50696 .73685 .49101 .73076 .44265 Metetra
.591 .404 .597 r
.73076 .44265 .73685 .49101 .74715 .46296 .74247 .4363 Metetra
.595 .432 .631 r
.74247 .4363 .74715 .46296 .75874 .4539 .7544 .43258 Metetra
.633 .472 .647 r
.7544 .43258 .75874 .4539 .77077 .4502 .76604 .42453 Metetra
.623 .453 .632 r
.76604 .42453 .77077 .4502 .78177 .43342 .7777 .41647 Metetra
.61 .476 .673 r
.7777 .41647 .78177 .43342 .79347 .42534 .78976 .41269 Metetra
.623 .514 .709 r
.78976 .41269 .79347 .42534 .8048 .41294 .80186 .4089 Metetra
.663 .743 .909 r
.80186 .4089 .8048 .41294 .81694 .40915 .81403 .4051 Metetra
.663 .743 .909 r
.81403 .4051 .81694 .40915 .82913 .40534 .82624 .40127 Metetra
.663 .743 .909 r
.82624 .40127 .82913 .40534 .84138 .40152 .83851 .39743 Metetra
.663 .743 .909 r
.83851 .39743 .84138 .40152 .85368 .39768 .85083 .39357 Metetra
.773 .782 .86 r
.85083 .39357 .85368 .39768 .86596 .39315 .86273 .38537 Metetra
.646 .601 .789 r
.86273 .38537 .86596 .39315 .87794 .38562 .87514 .38147 Metetra
.682 .75 .903 r
.87514 .38147 .87794 .38562 .89039 .38172 .88754 .37694 Metetra
.751 .746 .848 r
.88754 .37694 .89039 .38172 .90235 .37349 .8996 .3693 Metetra
.646 .762 .934 r
.3315 .73241 .33542 .73559 .34621 .7326 .3423 .7294 Metetra
.646 .762 .934 r
.3423 .7294 .34621 .7326 .35705 .7296 .35316 .72638 Metetra
.646 .762 .934 r
.35316 .72638 .35705 .7296 .36794 .72658 .36406 .72335 Metetra
.646 .762 .934 r
.36406 .72335 .36794 .72658 .37887 .72355 .37501 .72031 Metetra
.646 .762 .934 r
.37501 .72031 .37887 .72355 .39003 .71585 .386 .71725 Metetra
.386 .71725 .39003 .71585 .40104 .71279 .39705 .71418 Metetra
.649 .967 .828 r
.39705 .71418 .40104 .71279 .4121 .70972 .4083 .70643 Metetra
.646 .762 .933 r
.4083 .70643 .4121 .70972 .42321 .70663 .41942 .70332 Metetra
.646 .762 .933 r
.41942 .70332 .42321 .70663 .43436 .70352 .4306 .70021 Metetra
.646 .762 .933 r
.4306 .70021 .43436 .70352 .44557 .70041 .44182 .69708 Metetra
.646 .762 .933 r
.44182 .69708 .44557 .70041 .45682 .69728 .45309 .69393 Metetra
.646 .762 .933 r
.45309 .69393 .45682 .69728 .46812 .69413 .46441 .69077 Metetra
.646 .762 .933 r
.46441 .69077 .46812 .69413 .47947 .69098 .47578 .6876 Metetra
.646 .762 .933 r
.47578 .6876 .47947 .69098 .49088 .68781 .4872 .68441 Metetra
.646 .762 .933 r
.4872 .68441 .49088 .68781 .50233 .68462 .49867 .68121 Metetra
.646 .762 .933 r
.49867 .68121 .50233 .68462 .51383 .68142 .51019 .678 Metetra
.646 .762 .933 r
.51019 .678 .51383 .68142 .52538 .67821 .52177 .67477 Metetra
.646 .762 .933 r
.52177 .67477 .52538 .67821 .53699 .67498 .53339 .67153 Metetra
.646 .762 .933 r
.53339 .67153 .53699 .67498 .54865 .67174 .54507 .66827 Metetra
.84 .792 .805 r
.54507 .66827 .54865 .67174 .56025 .65904 .5567 .65555 Metetra
.647 .761 .932 r
.5567 .65555 .56025 .65904 .57195 .65395 .56845 .65225 Metetra
.693 .889 .97 r
.56845 .65225 .57195 .65395 .58365 .64631 .58022 .64712 Metetra
.64 .966 .843 r
.58022 .64712 .58365 .64631 .59546 .64299 .59197 .63944 Metetra
.648 .76 .931 r
.59197 .63944 .59546 .64299 .60732 .63965 .60386 .63609 Metetra
.648 .76 .931 r
.60386 .63609 .60732 .63965 .61924 .6363 .61579 .63272 Metetra
.648 .76 .931 r
.61579 .63272 .61924 .6363 .63036 .60699 .62779 .62934 Metetra
.517 .247 .444 r
.62779 .62934 .63036 .60699 .64075 .56152 .63983 .62594 Metetra
.493 .273 .507 r
.63983 .62594 .64075 .56152 .65123 .52452 .65125 .60512 Metetra
.53 .307 .52 r
.65125 .60512 .65123 .52452 .66268 .51416 .66297 .59303 Metetra
.538 .312 .521 r
.66297 .59303 .66268 .51416 .67278 .47552 .67483 .58417 Metetra
.534 .315 .528 r
.67483 .58417 .67278 .47552 .68434 .46924 .68637 .56887 Metetra
.504 .291 .523 r
.68637 .56887 .68434 .46924 .69607 .46562 .69716 .54021 Metetra
.419 .221 .502 r
.69716 .54021 .69607 .46562 .70724 .45166 .70665 .49157 Metetra
.247 .071 .434 r
.70665 .49157 .70724 .45166 .71903 .448 .71582 .44242 Metetra
.783 .714 .787 r
.71582 .44242 .71903 .448 .73076 .44265 .72722 .43175 Metetra
.683 .567 .717 r
.72722 .43175 .73076 .44265 .74247 .4363 .7388 .42373 Metetra
.622 .514 .709 r
.7388 .42373 .74247 .4363 .7544 .43258 .75072 .41998 Metetra
.622 .514 .709 r
.75072 .41998 .7544 .43258 .76604 .42453 .76269 .41622 Metetra
.642 .585 .775 r
.76269 .41622 .76604 .42453 .7777 .41647 .77471 .41245 Metetra
.663 .743 .909 r
.77471 .41245 .7777 .41647 .78976 .41269 .78678 .40866 Metetra
.663 .743 .909 r
.78678 .40866 .78976 .41269 .80186 .4089 .79891 .40485 Metetra
.663 .743 .909 r
.79891 .40485 .80186 .4089 .81403 .4051 .8111 .40102 Metetra
.663 .743 .909 r
.8111 .40102 .81403 .4051 .82624 .40127 .82333 .39718 Metetra
.663 .743 .909 r
.82333 .39718 .82624 .40127 .83851 .39743 .83562 .39332 Metetra
.773 .781 .86 r
.83562 .39332 .83851 .39743 .85083 .39357 .84751 .38512 Metetra
.709 .619 .755 r
.84751 .38512 .85083 .39357 .86273 .38537 .85941 .3769 Metetra
.642 .585 .775 r
.85941 .3769 .86273 .38537 .87514 .38147 .87183 .37298 Metetra
.642 .585 .775 r
.87183 .37298 .87514 .38147 .88754 .37694 .88431 .36904 Metetra
.646 .6 .788 r
.88431 .36904 .88754 .37694 .8996 .3693 .89684 .36509 Metetra
.646 .762 .934 r
.32755 .72921 .3315 .73241 .3423 .7294 .33838 .72619 Metetra
.646 .762 .934 r
.33838 .72619 .3423 .7294 .35316 .72638 .34925 .72316 Metetra
.646 .762 .934 r
.34925 .72316 .35316 .72638 .36406 .72335 .36017 .72011 Metetra
.646 .762 .934 r
.36017 .72011 .36406 .72335 .37501 .72031 .37113 .71705 Metetra
.646 .762 .934 r
.37113 .71705 .37501 .72031 .386 .71725 .38214 .71398 Metetra
.646 .762 .934 r
.38214 .71398 .386 .71725 .39705 .71418 .3932 .7109 Metetra
.646 .762 .934 r
.3932 .7109 .39705 .71418 .4083 .70643 .40431 .7078 Metetra
.40431 .7078 .4083 .70643 .41942 .70332 .41547 .70469 Metetra
.646 .966 .826 r
.41547 .70469 .41942 .70332 .4306 .70021 .42681 .69687 Metetra
.646 .762 .933 r
.42681 .69687 .4306 .70021 .44182 .69708 .43805 .69373 Metetra
.646 .762 .933 r
.43805 .69373 .44182 .69708 .45309 .69393 .44934 .69057 Metetra
.646 .762 .933 r
.44934 .69057 .45309 .69393 .46441 .69077 .46068 .6874 Metetra
.646 .762 .933 r
.46068 .6874 .46441 .69077 .47578 .6876 .47207 .68421 Metetra
.646 .762 .933 r
.47207 .68421 .47578 .6876 .4872 .68441 .48351 .68101 Metetra
.646 .762 .933 r
.48351 .68101 .4872 .68441 .49867 .68121 .495 .67779 Metetra
.646 .762 .933 r
.495 .67779 .49867 .68121 .51019 .678 .50654 .67456 Metetra
.646 .762 .933 r
.50654 .67456 .51019 .678 .52177 .67477 .51813 .67132 Metetra
.646 .762 .933 r
.51813 .67132 .52177 .67477 .53339 .67153 .52977 .66806 Metetra
.646 .762 .933 r
.52977 .66806 .53339 .67153 .54507 .66827 .54147 .66479 Metetra
.646 .762 .933 r
.54147 .66479 .54507 .66827 .5567 .65555 .55322 .6615 Metetra
.357 0 .124 r
.55322 .6615 .5567 .65555 .56845 .65225 .56502 .6582 Metetra
.357 0 .124 r
.56502 .6582 .56845 .65225 .58022 .64712 .57687 .65488 Metetra
.41 .041 .224 r
.57687 .65488 .58022 .64712 .59197 .63944 .58878 .65155 Metetra
.256 0 .265 r
.58878 .65155 .59197 .63944 .60386 .63609 .60052 .63869 Metetra
.104 0 0 r
.60052 .63869 .60386 .63609 .61579 .63272 .6125 .63532 Metetra
.104 0 0 r
.6125 .63532 .61579 .63272 .62779 .62934 .62454 .63193 Metetra
.104 0 0 r
.62454 .63193 .62779 .62934 .63983 .62594 .63663 .62852 Metetra
.63663 .62852 .63983 .62594 .65125 .60512 .6487 .62327 Metetra
.452 .175 .402 r
.6487 .62327 .65125 .60512 .66297 .59303 .66071 .61544 Metetra
.516 .245 .442 r
.66071 .61544 .66297 .59303 .67483 .58417 .67294 .61198 Metetra
.525 .266 .464 r
.67294 .61198 .67483 .58417 .68637 .56887 .68523 .60851 Metetra
.443 .217 .474 r
.68523 .60851 .68637 .56887 .69716 .54021 .69664 .5875 Metetra
.541 .301 .501 r
.69664 .5875 .69716 .54021 .70665 .49157 .70897 .58397 Metetra
.551 .325 .525 r
.70897 .58397 .70665 .49157 .71582 .44242 .72136 .58042 Metetra
.555 .333 .534 r
.72136 .58042 .71582 .44242 .72722 .43175 .73381 .57686 Metetra
.459 .262 .525 r
.73381 .57686 .72722 .43175 .7388 .42373 .74151 .5037 Metetra
.433 .234 .508 r
.74151 .5037 .7388 .42373 .75072 .41998 .75053 .45523 Metetra
.429 .204 .469 r
.75053 .45523 .75072 .41998 .76269 .41622 .76132 .43391 Metetra
.395 .134 .395 r
.76132 .43391 .76269 .41622 .77471 .41245 .77275 .42141 Metetra
.048 0 .156 r
.77275 .42141 .77471 .41245 .78678 .40866 .7838 .4046 Metetra
.663 .743 .909 r
.7838 .4046 .78678 .40866 .79891 .40485 .79595 .40078 Metetra
.663 .743 .909 r
.79595 .40078 .79891 .40485 .8111 .40102 .80815 .39693 Metetra
.663 .743 .909 r
.80815 .39693 .8111 .40102 .82333 .39718 .82041 .39307 Metetra
.663 .743 .909 r
.82041 .39307 .82333 .39718 .83562 .39332 .83273 .3892 Metetra
.773 .781 .86 r
.83273 .3892 .83562 .39332 .84751 .38512 .84464 .38097 Metetra
.773 .781 .86 r
.84464 .38097 .84751 .38512 .85941 .3769 .85657 .37273 Metetra
.663 .742 .908 r
.85657 .37273 .85941 .3769 .87183 .37298 .86901 .36879 Metetra
.663 .742 .908 r
.86901 .36879 .87183 .37298 .88431 .36904 .88151 .36483 Metetra
.663 .742 .908 r
.88151 .36483 .88431 .36904 .89684 .36509 .89406 .36086 Metetra
.646 .762 .934 r
.32359 .726 .32755 .72921 .33838 .72619 .33443 .72296 Metetra
.646 .762 .934 r
.33443 .72296 .33838 .72619 .34925 .72316 .34532 .71992 Metetra
.646 .762 .934 r
.34532 .71992 .34925 .72316 .36017 .72011 .35625 .71686 Metetra
.646 .762 .934 r
.35625 .71686 .36017 .72011 .37113 .71705 .36724 .71378 Metetra
.646 .762 .934 r
.36724 .71378 .37113 .71705 .38214 .71398 .37827 .7107 Metetra
.646 .762 .934 r
.37827 .7107 .38214 .71398 .3932 .7109 .38934 .7076 Metetra
.646 .762 .934 r
.38934 .7076 .3932 .7109 .40431 .7078 .40047 .70449 Metetra
.646 .762 .934 r
.40047 .70449 .40431 .7078 .41547 .70469 .41164 .70136 Metetra
.774 .784 .862 r
.41164 .70136 .41547 .70469 .42681 .69687 .42301 .69353 Metetra
.646 .762 .933 r
.42301 .69353 .42681 .69687 .43805 .69373 .43427 .69037 Metetra
.646 .762 .933 r
.43427 .69037 .43805 .69373 .44934 .69057 .44557 .68719 Metetra
.646 .762 .933 r
.44557 .68719 .44934 .69057 .46068 .6874 .45693 .684 Metetra
.646 .762 .933 r
.45693 .684 .46068 .6874 .47207 .68421 .46834 .6808 Metetra
.646 .762 .933 r
.46834 .6808 .47207 .68421 .48351 .68101 .4798 .67759 Metetra
.646 .762 .933 r
.4798 .67759 .48351 .68101 .495 .67779 .4913 .67436 Metetra
.646 .762 .933 r
.4913 .67436 .495 .67779 .50654 .67456 .50286 .67111 Metetra
.646 .762 .933 r
.50286 .67111 .50654 .67456 .51813 .67132 .51448 .66785 Metetra
.646 .762 .933 r
.51448 .66785 .51813 .67132 .52977 .66806 .52614 .66458 Metetra
.646 .762 .933 r
.52614 .66458 .52977 .66806 .54147 .66479 .53786 .66129 Metetra
.646 .762 .933 r
.53786 .66129 .54147 .66479 .55322 .6615 .54962 .65799 Metetra
.646 .762 .933 r
.54962 .65799 .55322 .6615 .56502 .6582 .56145 .65467 Metetra
.646 .762 .933 r
.56145 .65467 .56502 .6582 .57687 .65488 .57332 .65133 Metetra
.646 .762 .933 r
.57332 .65133 .57687 .65488 .58878 .65155 .58525 .64799 Metetra
.646 .762 .933 r
.58525 .64799 .58878 .65155 .60052 .63869 .59723 .64462 Metetra
.354 0 .12 r
.59723 .64462 .60052 .63869 .6125 .63532 .60927 .64124 Metetra
.354 0 .12 r
.60927 .64124 .6125 .63532 .62454 .63193 .62136 .63785 Metetra
.354 0 .12 r
.62136 .63785 .62454 .63193 .63663 .62852 .63351 .63444 Metetra
.354 0 .12 r
.63351 .63444 .63663 .62852 .6487 .62327 .64571 .63102 Metetra
.408 .038 .221 r
.64571 .63102 .6487 .62327 .66071 .61544 .65797 .62757 Metetra
.265 0 .273 r
.65797 .62757 .66071 .61544 .67294 .61198 .66986 .61452 Metetra
.099 0 0 r
.66986 .61452 .67294 .61198 .68523 .60851 .68219 .61104 Metetra
.099 0 0 r
.68219 .61104 .68523 .60851 .69664 .5875 .69458 .60754 Metetra
.442 .175 .412 r
.69458 .60754 .69664 .5875 .70897 .58397 .70668 .59776 Metetra
.13 0 .259 r
.70668 .59776 .70897 .58397 .72136 .58042 .7181 .57663 Metetra
.65 .758 .929 r
.7181 .57663 .72136 .58042 .73381 .57686 .73057 .57306 Metetra
.65 .758 .929 r
.73057 .57306 .73381 .57686 .74151 .5037 .74309 .56946 Metetra
.508 .285 .51 r
.74309 .56946 .74151 .5037 .75053 .45523 .75473 .55274 Metetra
.463 .259 .517 r
.75473 .55274 .75053 .45523 .76132 .43391 .76406 .50611 Metetra
.512 .29 .514 r
.76406 .50611 .76132 .43391 .77275 .42141 .77542 .48867 Metetra
.467 .255 .507 r
.77542 .48867 .77275 .42141 .7838 .4046 .78561 .45778 Metetra
.477 .256 .499 r
.78561 .45778 .7838 .4046 .79595 .40078 .79645 .43613 Metetra
.268 .086 .438 r
.79645 .43613 .79595 .40078 .80815 .39693 .8052 .39283 Metetra
.663 .743 .909 r
.8052 .39283 .80815 .39693 .82041 .39307 .81748 .38895 Metetra
.663 .743 .909 r
.81748 .38895 .82041 .39307 .83273 .3892 .82981 .38505 Metetra
.663 .743 .909 r
.82981 .38505 .83273 .3892 .84464 .38097 .84221 .38114 Metetra
.337 .818 .809 r
.84221 .38114 .84464 .38097 .85657 .37273 .85465 .37721 Metetra
.289 0 .029 r
.85465 .37721 .85657 .37273 .86901 .36879 .86716 .37326 Metetra
.081 0 0 r
.86716 .37326 .86901 .36879 .88151 .36483 .8792 .36494 Metetra
.656 .971 .835 r
.8792 .36494 .88151 .36483 .89406 .36086 .89127 .35661 Metetra
.646 .762 .934 r
.31961 .72277 .32359 .726 .33443 .72296 .33047 .71972 Metetra
.646 .762 .934 r
.33047 .71972 .33443 .72296 .34532 .71992 .34137 .71666 Metetra
.646 .762 .934 r
.34137 .71666 .34532 .71992 .35625 .71686 .35232 .71359 Metetra
.646 .762 .934 r
.35232 .71359 .35625 .71686 .36724 .71378 .36332 .7105 Metetra
.646 .762 .934 r
.36332 .7105 .36724 .71378 .37827 .7107 .37437 .7074 Metetra
.646 .762 .934 r
.37437 .7074 .37827 .7107 .38934 .7076 .38546 .70429 Metetra
.646 .762 .934 r
.38546 .70429 .38934 .7076 .40047 .70449 .39661 .70116 Metetra
.646 .762 .934 r
.39661 .70116 .40047 .70449 .41164 .70136 .4078 .69802 Metetra
.646 .762 .934 r
.4078 .69802 .41164 .70136 .42301 .69353 .41904 .69486 Metetra
.649 .967 .828 r
.41904 .69486 .42301 .69353 .43427 .69037 .43046 .68699 Metetra
.646 .762 .933 r
.43046 .68699 .43427 .69037 .44557 .68719 .44179 .6838 Metetra
.646 .762 .933 r
.44179 .6838 .44557 .68719 .45693 .684 .45316 .6806 Metetra
.646 .762 .933 r
.45316 .6806 .45693 .684 .46834 .6808 .46459 .67738 Metetra
.646 .762 .933 r
.46459 .67738 .46834 .6808 .4798 .67759 .47607 .67415 Metetra
.646 .762 .933 r
.47607 .67415 .4798 .67759 .4913 .67436 .4876 .6709 Metetra
.646 .762 .933 r
.4876 .6709 .4913 .67436 .50286 .67111 .49917 .66764 Metetra
.646 .762 .933 r
.49917 .66764 .50286 .67111 .51448 .66785 .51081 .66437 Metetra
.646 .762 .933 r
.51081 .66437 .51448 .66785 .52614 .66458 .52249 .66108 Metetra
.646 .762 .933 r
.52249 .66108 .52614 .66458 .53786 .66129 .53422 .65777 Metetra
.646 .762 .933 r
.53422 .65777 .53786 .66129 .54962 .65799 .54601 .65445 Metetra
.646 .762 .933 r
.54601 .65445 .54962 .65799 .56145 .65467 .55785 .65112 Metetra
.646 .762 .933 r
.55785 .65112 .56145 .65467 .57332 .65133 .56975 .64777 Metetra
.646 .762 .933 r
.56975 .64777 .57332 .65133 .58525 .64799 .5817 .64441 Metetra
.646 .762 .933 r
.5817 .64441 .58525 .64799 .59723 .64462 .5937 .64103 Metetra
.646 .762 .933 r
.5937 .64103 .59723 .64462 .60927 .64124 .60576 .63763 Metetra
.843 .798 .807 r
.60576 .63763 .60927 .64124 .62136 .63785 .6176 .62466 Metetra
.617 .509 .709 r
.6176 .62466 .62136 .63785 .63351 .63444 .62973 .62122 Metetra
.712 .566 .688 r
.62973 .62122 .63351 .63444 .64571 .63102 .64158 .60824 Metetra
.686 .506 .637 r
.64158 .60824 .64571 .63102 .65797 .62757 .65322 .59056 Metetra
.584 .409 .611 r
.65322 .59056 .65797 .62757 .66986 .61452 .66543 .58704 Metetra
.591 .43 .631 r
.66543 .58704 .66986 .61452 .68219 .61104 .67769 .58351 Metetra
.591 .43 .631 r
.67769 .58351 .68219 .61104 .69458 .60754 .69001 .57997 Metetra
.591 .43 .631 r
.69001 .57997 .69458 .60754 .70668 .59776 .70239 .5764 Metetra
.599 .452 .654 r
.70239 .5764 .70668 .59776 .7181 .57663 .71482 .57283 Metetra
.963 .757 .578 r
.71482 .57283 .7181 .57663 .73057 .57306 .7243 .52152 Metetra
.641 .438 .592 r
.7243 .52152 .73057 .57306 .74309 .56946 .73528 .49738 Metetra
.637 .426 .58 r
.73528 .49738 .74309 .56946 .75473 .55274 .74558 .46506 Metetra
.589 .387 .576 r
.74558 .46506 .75473 .55274 .76406 .50611 .75718 .45237 Metetra
.592 .4 .591 r
.75718 .45237 .76406 .50611 .77542 .48867 .76911 .44413 Metetra
.598 .411 .599 r
.76911 .44413 .77542 .48867 .78561 .45778 .78106 .43588 Metetra
.748 .545 .621 r
.78106 .43588 .78561 .45778 .79645 .43613 .79111 .40563 Metetra
.655 .465 .616 r
.79111 .40563 .79645 .43613 .8052 .39283 .80222 .3887 Metetra
.663 .743 .909 r
.80222 .3887 .8052 .39283 .81748 .38895 .81453 .3848 Metetra
.663 .743 .909 r
.81453 .3848 .81748 .38895 .82981 .38505 .82689 .38089 Metetra
.663 .743 .909 r
.82689 .38089 .82981 .38505 .84221 .38114 .8393 .37695 Metetra
.843 .797 .807 r
.8393 .37695 .84221 .38114 .85465 .37721 .85083 .36432 Metetra
.622 .513 .709 r
.85083 .36432 .85465 .37721 .86716 .37326 .86332 .36035 Metetra
.622 .513 .709 r
.86332 .36035 .86716 .37326 .8792 .36494 .87587 .35636 Metetra
.642 .585 .775 r
.87587 .35636 .8792 .36494 .89127 .35661 .88847 .35234 Metetra
.646 .762 .934 r
.31562 .71952 .31961 .72277 .33047 .71972 .32649 .71646 Metetra
.646 .762 .934 r
.32649 .71646 .33047 .71972 .34137 .71666 .33741 .71339 Metetra
.646 .762 .934 r
.33741 .71339 .34137 .71666 .35232 .71359 .34838 .7103 Metetra
.646 .762 .934 r
.34838 .7103 .35232 .71359 .36332 .7105 .35939 .7072 Metetra
.646 .762 .934 r
.35939 .7072 .36332 .7105 .37437 .7074 .37046 .70409 Metetra
.646 .762 .934 r
.37046 .70409 .37437 .7074 .38546 .70429 .38157 .70096 Metetra
.646 .762 .934 r
.38157 .70096 .38546 .70429 .39661 .70116 .39273 .69781 Metetra
.646 .762 .934 r
.39273 .69781 .39661 .70116 .4078 .69802 .40394 .69466 Metetra
.646 .762 .934 r
.40394 .69466 .4078 .69802 .41904 .69486 .4152 .69149 Metetra
.646 .762 .934 r
.4152 .69149 .41904 .69486 .43046 .68699 .42651 .68831 Metetra
.649 .967 .828 r
.42651 .68831 .43046 .68699 .44179 .6838 .43799 .68039 Metetra
.646 .762 .933 r
.43799 .68039 .44179 .6838 .45316 .6806 .44938 .67717 Metetra
.646 .762 .933 r
.44938 .67717 .45316 .6806 .46459 .67738 .46083 .67394 Metetra
.646 .762 .933 r
.46083 .67394 .46459 .67738 .47607 .67415 .47232 .67069 Metetra
.646 .762 .933 r
.47232 .67069 .47607 .67415 .4876 .6709 .48387 .66743 Metetra
.646 .762 .933 r
.48387 .66743 .4876 .6709 .49917 .66764 .49547 .66416 Metetra
.646 .762 .933 r
.49547 .66416 .49917 .66764 .51081 .66437 .50712 .66087 Metetra
.646 .762 .933 r
.50712 .66087 .51081 .66437 .52249 .66108 .51882 .65756 Metetra
.646 .762 .933 r
.51882 .65756 .52249 .66108 .53422 .65777 .53058 .65424 Metetra
.646 .762 .933 r
.53058 .65424 .53422 .65777 .54601 .65445 .54238 .65091 Metetra
.646 .762 .933 r
.54238 .65091 .54601 .65445 .55785 .65112 .55425 .64755 Metetra
.646 .762 .933 r
.55425 .64755 .55785 .65112 .56975 .64777 .56616 .64419 Metetra
.646 .762 .933 r
.56616 .64419 .56975 .64777 .5817 .64441 .57813 .64081 Metetra
.935 .762 .644 r
.57813 .64081 .5817 .64441 .5937 .64103 .58949 .60424 Metetra
.584 .409 .61 r
.58949 .60424 .5937 .64103 .60576 .63763 .60144 .60078 Metetra
.584 .409 .61 r
.60144 .60078 .60576 .63763 .6176 .62466 .61345 .59732 Metetra
.591 .429 .631 r
.61345 .59732 .6176 .62466 .62973 .62122 .62552 .59383 Metetra
.591 .429 .631 r
.62552 .59383 .62973 .62122 .64158 .60824 .63764 .59033 Metetra
.605 .47 .671 r
.63764 .59033 .64158 .60824 .65322 .59056 .64981 .58682 Metetra
.65 .758 .929 r
.64981 .58682 .65322 .59056 .66543 .58704 .66204 .58329 Metetra
.957 .753 .587 r
.66204 .58329 .66543 .58704 .67769 .58351 .67211 .53219 Metetra
.642 .438 .592 r
.67211 .53219 .67769 .58351 .69001 .57997 .68324 .50816 Metetra
.576 .382 .581 r
.68324 .50816 .69001 .57997 .70239 .5764 .69529 .50299 Metetra
.572 .378 .58 r
.69529 .50299 .70239 .5764 .71482 .57283 .70747 .49931 Metetra
.659 .441 .578 r
.70747 .49931 .71482 .57283 .7243 .52152 .71719 .4552 Metetra
.629 .421 .582 r
.71719 .4552 .7243 .52152 .73528 .49738 .72786 .42941 Metetra
.606 .404 .582 r
.72786 .42941 .73528 .49738 .74558 .46506 .73903 .41253 Metetra
.592 .4 .591 r
.73903 .41253 .74558 .46506 .75718 .45237 .7508 .40437 Metetra
.595 .405 .595 r
.7508 .40437 .75718 .45237 .76911 .44413 .76259 .39619 Metetra
.579 .394 .595 r
.76259 .39619 .76911 .44413 .78106 .43588 .77475 .39233 Metetra
.581 .399 .6 r
.77475 .39233 .78106 .43588 .79111 .40563 .78697 .38845 Metetra
.609 .474 .672 r
.78697 .38845 .79111 .40563 .80222 .3887 .79924 .38455 Metetra
.773 .78 .859 r
.79924 .38455 .80222 .3887 .81453 .3848 .81115 .3763 Metetra
.642 .585 .775 r
.81115 .3763 .81453 .3848 .82689 .38089 .82352 .37236 Metetra
.709 .62 .755 r
.82352 .37236 .82689 .38089 .8393 .37695 .83549 .36407 Metetra
.622 .513 .709 r
.83549 .36407 .8393 .37695 .85083 .36432 .84795 .36009 Metetra
.663 .742 .908 r
.84795 .36009 .85083 .36432 .86332 .36035 .86046 .3561 Metetra
.663 .742 .908 r
.86046 .3561 .86332 .36035 .87587 .35636 .87303 .35209 Metetra
.663 .742 .908 r
.87303 .35209 .87587 .35636 .88847 .35234 .88565 .34805 Metetra
.646 .762 .934 r
.3116 .71627 .31562 .71952 .32649 .71646 .32249 .71319 Metetra
.646 .762 .934 r
.32249 .71319 .32649 .71646 .33741 .71339 .33342 .7101 Metetra
.646 .762 .934 r
.33342 .7101 .33741 .71339 .34838 .7103 .34441 .707 Metetra
.646 .762 .934 r
.34441 .707 .34838 .7103 .35939 .7072 .35544 .70388 Metetra
.646 .762 .934 r
.35544 .70388 .35939 .7072 .37046 .70409 .36652 .70076 Metetra
.646 .762 .934 r
.36652 .70076 .37046 .70409 .38157 .70096 .37765 .69761 Metetra
.646 .762 .934 r
.37765 .69761 .38157 .70096 .39273 .69781 .38883 .69446 Metetra
.646 .762 .934 r
.38883 .69446 .39273 .69781 .40394 .69466 .40006 .69128 Metetra
.646 .762 .934 r
.40006 .69128 .40394 .69466 .4152 .69149 .41134 .6881 Metetra
.646 .762 .934 r
.41134 .6881 .4152 .69149 .42651 .68831 .42266 .6849 Metetra
.774 .785 .863 r
.42266 .6849 .42651 .68831 .43799 .68039 .43417 .67696 Metetra
.646 .762 .933 r
.43417 .67696 .43799 .68039 .44938 .67717 .44558 .67373 Metetra
.646 .762 .933 r
.44558 .67373 .44938 .67717 .46083 .67394 .45704 .67048 Metetra
.646 .762 .933 r
.45704 .67048 .46083 .67394 .47232 .67069 .46856 .66722 Metetra
.646 .762 .933 r
.46856 .66722 .47232 .67069 .48387 .66743 .48012 .66395 Metetra
.646 .762 .933 r
.48012 .66395 .48387 .66743 .49547 .66416 .49174 .66065 Metetra
.646 .762 .933 r
.49174 .66065 .49547 .66416 .50712 .66087 .50341 .65735 Metetra
.646 .762 .933 r
.50341 .65735 .50712 .66087 .51882 .65756 .51513 .65403 Metetra
.646 .762 .933 r
.51513 .65403 .51882 .65756 .53058 .65424 .52691 .65069 Metetra
.646 .762 .933 r
.52691 .65069 .53058 .65424 .54238 .65091 .53874 .64734 Metetra
.841 .793 .805 r
.53874 .64734 .54238 .65091 .55425 .64755 .55054 .63445 Metetra
.772 .6 .666 r
.55054 .63445 .55425 .64755 .56616 .64419 .56222 .61215 Metetra
.611 .435 .618 r
.56222 .61215 .56616 .64419 .57813 .64081 .57404 .60401 Metetra
.583 .408 .61 r
.57404 .60401 .57813 .64081 .58949 .60424 .58596 .60056 Metetra
.65 .758 .929 r
.58596 .60056 .58949 .60424 .60144 .60078 .59793 .59709 Metetra
.65 .758 .929 r
.59793 .59709 .60144 .60078 .61345 .59732 .60997 .59361 Metetra
.955 .743 .577 r
.60997 .59361 .61345 .59732 .62552 .59383 .62037 .5345 Metetra
.61 .411 .587 r
.62037 .5345 .62552 .59383 .63764 .59033 .63188 .51881 Metetra
.572 .378 .58 r
.63188 .51881 .63764 .59033 .64981 .58682 .64382 .5152 Metetra
.572 .378 .58 r
.64382 .5152 .64981 .58682 .66204 .58329 .65581 .51157 Metetra
.576 .381 .58 r
.65581 .51157 .66204 .58329 .67211 .53219 .66778 .50642 Metetra
.712 .514 .62 r
.66778 .50642 .67211 .53219 .68324 .50816 .67876 .48021 Metetra
.591 .426 .628 r
.67876 .48021 .68324 .50816 .69529 .50299 .69082 .47651 Metetra
.708 .509 .618 r
.69082 .47651 .69529 .50299 .70747 .49931 .70165 .45053 Metetra
.661 .453 .591 r
.70165 .45053 .70747 .49931 .71719 .4552 .71211 .42044 Metetra
.626 .439 .61 r
.71211 .42044 .71719 .4552 .72786 .42941 .72357 .40795 Metetra
.632 .47 .646 r
.72357 .40795 .72786 .42941 .73903 .41253 .73531 .39979 Metetra
.621 .513 .709 r
.73531 .39979 .73903 .41253 .7508 .40437 .74739 .39594 Metetra
.641 .585 .775 r
.74739 .39594 .7508 .40437 .76259 .39619 .75952 .39208 Metetra
.663 .743 .909 r
.75952 .39208 .76259 .39619 .77475 .39233 .77171 .3882 Metetra
.773 .779 .858 r
.77171 .3882 .77475 .39233 .78697 .38845 .78357 .37996 Metetra
.641 .585 .775 r
.78357 .37996 .78697 .38845 .79924 .38455 .79585 .37604 Metetra
.641 .585 .775 r
.79585 .37604 .79924 .38455 .81115 .3763 .80818 .3721 Metetra
.663 .742 .909 r
.80818 .3721 .81115 .3763 .82352 .37236 .82057 .36815 Metetra
.663 .742 .909 r
.82057 .36815 .82352 .37236 .83549 .36407 .83301 .36417 Metetra
.671 .976 .847 r
.83301 .36417 .83549 .36407 .84795 .36009 .84505 .35584 Metetra
.663 .742 .908 r
.84505 .35584 .84795 .36009 .86046 .3561 .85758 .35183 Metetra
.663 .742 .908 r
.85758 .35183 .86046 .3561 .87303 .35209 .87017 .34779 Metetra
.663 .742 .908 r
.87017 .34779 .87303 .35209 .88565 .34805 .88282 .34374 Metetra
.646 .762 .934 r
.30756 .71299 .3116 .71627 .32249 .71319 .31847 .7099 Metetra
.646 .762 .934 r
.31847 .7099 .32249 .71319 .33342 .7101 .32942 .7068 Metetra
.646 .762 .934 r
.32942 .7068 .33342 .7101 .34441 .707 .34042 .70368 Metetra
.646 .762 .934 r
.34042 .70368 .34441 .707 .35544 .70388 .35147 .70055 Metetra
.773 .782 .86 r
.35147 .70055 .35544 .70388 .36652 .70076 .3628 .69272 Metetra
.634 .585 .781 r
.3628 .69272 .36652 .70076 .37765 .69761 .37393 .68955 Metetra
.634 .585 .781 r
.37393 .68955 .37765 .69761 .38883 .69446 .38511 .68637 Metetra
.634 .585 .781 r
.38511 .68637 .38883 .69446 .40006 .69128 .39634 .68318 Metetra
.634 .585 .781 r
.39634 .68318 .40006 .69128 .41134 .6881 .40762 .67998 Metetra
.634 .585 .781 r
.40762 .67998 .41134 .6881 .42266 .6849 .41895 .67676 Metetra
.634 .585 .781 r
.41895 .67676 .42266 .6849 .43417 .67696 .43033 .67352 Metetra
.646 .762 .933 r
.43033 .67352 .43417 .67696 .44558 .67373 .44176 .67027 Metetra
.646 .762 .933 r
.44176 .67027 .44558 .67373 .45704 .67048 .45324 .66701 Metetra
.646 .762 .933 r
.45324 .66701 .45704 .67048 .46856 .66722 .46478 .66373 Metetra
.774 .787 .864 r
.46478 .66373 .46856 .66722 .48012 .66395 .47643 .6557 Metetra
.709 .621 .757 r
.47643 .6557 .48012 .66395 .49174 .66065 .4881 .64766 Metetra
.616 .509 .709 r
.4881 .64766 .49174 .66065 .50341 .65735 .49976 .64432 Metetra
.771 .6 .667 r
.49976 .64432 .50341 .65735 .51513 .65403 .51153 .62213 Metetra
.611 .435 .618 r
.51153 .62213 .51513 .65403 .52691 .65069 .52323 .61406 Metetra
.582 .407 .61 r
.52323 .61406 .52691 .65069 .53874 .64734 .53496 .61066 Metetra
.582 .407 .61 r
.53496 .61066 .53874 .64734 .55054 .63445 .54674 .60723 Metetra
.645 .467 .628 r
.54674 .60723 .55054 .63445 .56222 .61215 .55848 .59444 Metetra
.604 .469 .671 r
.55848 .59444 .56222 .61215 .57404 .60401 .57033 .59097 Metetra
.861 .648 .613 r
.57033 .59097 .57404 .60401 .58596 .60056 .58141 .54139 Metetra
.574 .384 .586 r
.58141 .54139 .58596 .60056 .59793 .59709 .5932 .53784 Metetra
.588 .394 .587 r
.5932 .53784 .59793 .59709 .60997 .59361 .60493 .52972 Metetra
.594 .397 .584 r
.60493 .52972 .60997 .59361 .62037 .5345 .61658 .51858 Metetra
.625 .492 .68 r
.61658 .51858 .62037 .5345 .63188 .51881 .62844 .51346 Metetra
.799 .728 .785 r
.62844 .51346 .63188 .51881 .64382 .5152 .64009 .50169 Metetra
.697 .553 .687 r
.64009 .50169 .64382 .5152 .65581 .51157 .65174 .49018 Metetra
.647 .481 .646 r
.65174 .49018 .65581 .51157 .66778 .50642 .66345 .47998 Metetra
.592 .43 .632 r
.66345 .47998 .66778 .50642 .67876 .48021 .67547 .47627 Metetra
.84 .791 .805 r
.67547 .47627 .67876 .48021 .69082 .47651 .68708 .46361 Metetra
.885 .658 .59 r
.68708 .46361 .69082 .47651 .70165 .45053 .69621 .40719 Metetra
.58 .398 .599 r
.69621 .40719 .70165 .45053 .71211 .42044 .70815 .40338 Metetra
.608 .473 .672 r
.70815 .40338 .71211 .42044 .72357 .40795 .72014 .39955 Metetra
.641 .585 .776 r
.72014 .39955 .72357 .40795 .73531 .39979 .73219 .3957 Metetra
.663 .743 .909 r
.73219 .3957 .73531 .39979 .74739 .39594 .74429 .39183 Metetra
.663 .743 .909 r
.74429 .39183 .74739 .39594 .75952 .39208 .75644 .38795 Metetra
.663 .743 .909 r
.75644 .38795 .75952 .39208 .77171 .3882 .76865 .38405 Metetra
.663 .743 .909 r
.76865 .38405 .77171 .3882 .78357 .37996 .78091 .38013 Metetra
.68 .979 .854 r
.78091 .38013 .78357 .37996 .79585 .37604 .79284 .37185 Metetra
.663 .742 .909 r
.79284 .37185 .79585 .37604 .80818 .3721 .80519 .36789 Metetra
.663 .742 .909 r
.80519 .36789 .80818 .3721 .82057 .36815 .8176 .36392 Metetra
.773 .781 .859 r
.8176 .36392 .82057 .36815 .83301 .36417 .82963 .35558 Metetra
.641 .585 .775 r
.82963 .35558 .83301 .36417 .84505 .35584 .84213 .35157 Metetra
.663 .742 .908 r
.84213 .35157 .84505 .35584 .85758 .35183 .85469 .34753 Metetra
.663 .742 .908 r
.85469 .34753 .85758 .35183 .87017 .34779 .86731 .34348 Metetra
.663 .742 .908 r
.86731 .34348 .87017 .34779 .88282 .34374 .87998 .33941 Metetra
.646 .762 .934 r
.30351 .7097 .30756 .71299 .31847 .7099 .31443 .7066 Metetra
.646 .762 .934 r
.31443 .7066 .31847 .7099 .32942 .7068 .3254 .70348 Metetra
.646 .762 .934 r
.3254 .70348 .32942 .7068 .34042 .70368 .33642 .70035 Metetra
.773 .782 .86 r
.33642 .70035 .34042 .70368 .35147 .70055 .34773 .69251 Metetra
.634 .585 .781 r
.34773 .69251 .35147 .70055 .3628 .69272 .35883 .68935 Metetra
.646 .762 .933 r
.35883 .68935 .3628 .69272 .37393 .68955 .36998 .68617 Metetra
.646 .762 .933 r
.36998 .68617 .37393 .68955 .38511 .68637 .38118 .68298 Metetra
.646 .762 .933 r
.38118 .68298 .38511 .68637 .39634 .68318 .39243 .67977 Metetra
.646 .762 .933 r
.39243 .67977 .39634 .68318 .40762 .67998 .40373 .67655 Metetra
.646 .762 .933 r
.40373 .67655 .40762 .67998 .41895 .67676 .41508 .67332 Metetra
.646 .762 .933 r
.41508 .67332 .41895 .67676 .43033 .67352 .42647 .67007 Metetra
.646 .762 .933 r
.42647 .67007 .43033 .67352 .44176 .67027 .43792 .6668 Metetra
.774 .786 .863 r
.43792 .6668 .44176 .67027 .45324 .66701 .44953 .65879 Metetra
.634 .585 .781 r
.44953 .65879 .45324 .66701 .46478 .66373 .46107 .65549 Metetra
.634 .585 .781 r
.46107 .65549 .46478 .66373 .47643 .6557 .47265 .65218 Metetra
.647 .761 .933 r
.47265 .65218 .47643 .6557 .4881 .64766 .48429 .64885 Metetra
.646 .966 .826 r
.48429 .64885 .4881 .64766 .49976 .64432 .49603 .64076 Metetra
.896 .775 .72 r
.49603 .64076 .49976 .64432 .51153 .62213 .50785 .61853 Metetra
.774 .786 .863 r
.50785 .61853 .51153 .62213 .52323 .61406 .51957 .61044 Metetra
.65 .758 .929 r
.51957 .61044 .52323 .61406 .53496 .61066 .53132 .60701 Metetra
.839 .789 .804 r
.53132 .60701 .53496 .61066 .54674 .60723 .54306 .59421 Metetra
.67 .541 .7 r
.54306 .59421 .54674 .60723 .55848 .59444 .55484 .58608 Metetra
.893 .69 .622 r
.55484 .58608 .55848 .59444 .57033 .59097 .56615 .54116 Metetra
.576 .39 .593 r
.56615 .54116 .57033 .59097 .58141 .54139 .57791 .53761 Metetra
.655 .753 .922 r
.57791 .53761 .58141 .54139 .5932 .53784 .58972 .53404 Metetra
.773 .783 .861 r
.58972 .53404 .5932 .53784 .60493 .52972 .60147 .52591 Metetra
.821 .788 .822 r
.60147 .52591 .60493 .52972 .61658 .51858 .61315 .51473 Metetra
.899 .782 .723 r
.61315 .51473 .61658 .51858 .62844 .51346 .62452 .49361 Metetra
.682 .51 .647 r
.62452 .49361 .62844 .51346 .64009 .50169 .63603 .47896 Metetra
.628 .465 .641 r
.63603 .47896 .64009 .50169 .65174 .49018 .64778 .47081 Metetra
.641 .485 .655 r
.64778 .47081 .65174 .49018 .66345 .47998 .65953 .46231 Metetra
.753 .564 .639 r
.65953 .46231 .66345 .47998 .67547 .47627 .67049 .43683 Metetra
.581 .402 .604 r
.67049 .43683 .67547 .47627 .68708 .46361 .68244 .43306 Metetra
.588 .418 .62 r
.68244 .43306 .68708 .46361 .69621 .40719 .69446 .42927 Metetra
.185 0 .353 r
.69446 .42927 .69621 .40719 .70815 .40338 .70497 .3993 Metetra
.663 .743 .909 r
.70497 .3993 .70815 .40338 .72014 .39955 .71698 .39545 Metetra
.663 .743 .909 r
.71698 .39545 .72014 .39955 .73219 .3957 .72905 .39158 Metetra
.663 .743 .909 r
.72905 .39158 .73219 .3957 .74429 .39183 .74117 .3877 Metetra
.663 .743 .909 r
.74117 .3877 .74429 .39183 .75644 .38795 .75334 .3838 Metetra
.663 .743 .909 r
.75334 .3838 .75644 .38795 .76865 .38405 .76557 .37988 Metetra
.663 .743 .909 r
.76557 .37988 .76865 .38405 .78091 .38013 .77786 .37594 Metetra
.773 .779 .858 r
.77786 .37594 .78091 .38013 .79284 .37185 .78981 .36764 Metetra
.663 .742 .909 r
.78981 .36764 .79284 .37185 .80519 .36789 .80219 .36366 Metetra
.773 .78 .859 r
.80219 .36366 .80519 .36789 .8176 .36392 .81421 .35533 Metetra
.641 .585 .775 r
.81421 .35533 .8176 .36392 .82963 .35558 .82668 .35131 Metetra
.663 .742 .908 r
.82668 .35131 .82963 .35558 .84213 .35157 .8392 .34727 Metetra
.663 .742 .908 r
.8392 .34727 .84213 .35157 .85469 .34753 .85178 .34322 Metetra
.663 .742 .908 r
.85178 .34322 .85469 .34753 .86731 .34348 .86443 .33915 Metetra
.663 .742 .908 r
.86443 .33915 .86731 .34348 .87998 .33941 .87712 .33506 Metetra
.773 .78 .859 r
.29944 .7064 .30351 .7097 .31443 .7066 .31067 .6986 Metetra
.634 .585 .782 r
.31067 .6986 .31443 .7066 .3254 .70348 .32165 .69546 Metetra
.634 .585 .782 r
.32165 .69546 .3254 .70348 .33642 .70035 .33267 .69231 Metetra
.634 .585 .782 r
.33267 .69231 .33642 .70035 .34773 .69251 .34374 .68914 Metetra
.646 .762 .933 r
.34374 .68914 .34773 .69251 .35883 .68935 .35485 .68597 Metetra
.646 .762 .933 r
.35485 .68597 .35883 .68935 .36998 .68617 .36602 .68277 Metetra
.646 .762 .933 r
.36602 .68277 .36998 .68617 .38118 .68298 .37724 .67956 Metetra
.646 .762 .933 r
.37724 .67956 .38118 .68298 .39243 .67977 .3885 .67634 Metetra
.646 .762 .933 r
.3885 .67634 .39243 .67977 .40373 .67655 .39982 .67311 Metetra
.646 .762 .933 r
.39982 .67311 .40373 .67655 .41508 .67332 .41118 .66986 Metetra
.646 .762 .933 r
.41118 .66986 .41508 .67332 .42647 .67007 .4226 .66659 Metetra
.646 .762 .933 r
.4226 .66659 .42647 .67007 .43792 .6668 .43407 .66331 Metetra
.646 .762 .933 r
.43407 .66331 .43792 .6668 .44953 .65879 .44559 .66002 Metetra
.654 .97 .833 r
.44559 .66002 .44953 .65879 .46107 .65549 .45725 .65196 Metetra
.647 .761 .933 r
.45725 .65196 .46107 .65549 .47265 .65218 .46886 .64863 Metetra
.647 .761 .933 r
.46886 .64863 .47265 .65218 .48429 .64885 .48052 .64529 Metetra
.647 .761 .933 r
.48052 .64529 .48429 .64885 .49603 .64076 .49223 .64193 Metetra
.646 .966 .826 r
.49223 .64193 .49603 .64076 .50785 .61853 .50403 .63379 Metetra
.059 0 .21 r
.50403 .63379 .50785 .61853 .51957 .61044 .51587 .61149 Metetra
.203 .72 .685 r
.51587 .61149 .51957 .61044 .53132 .60701 .52766 .60805 Metetra
.651 .969 .83 r
.52766 .60805 .53132 .60701 .54306 .59421 .53948 .59989 Metetra
.53948 .59989 .54306 .59421 .55484 .58608 .55123 .58237 Metetra
.651 .757 .927 r
.55123 .58237 .55484 .58608 .56615 .54116 .56311 .57887 Metetra
.502 .256 .474 r
.56311 .57887 .56615 .54116 .57791 .53761 .57497 .57068 Metetra
.195 .004 .38 r
.57497 .57068 .57791 .53761 .58972 .53404 .58621 .53023 Metetra
.655 .753 .922 r
.58621 .53023 .58972 .53404 .60147 .52591 .5981 .52663 Metetra
.265 .768 .745 r
.5981 .52663 .60147 .52591 .61315 .51473 .61004 .52301 Metetra
0 0 .025 r
.61004 .52301 .61315 .51473 .62452 .49361 .62165 .50722 Metetra
.38 .082 .329 r
.62165 .50722 .62452 .49361 .63603 .47896 .63347 .49847 Metetra
.339 .084 .374 r
.63347 .49847 .63603 .47896 .64778 .47081 .64502 .48233 Metetra
0 0 .111 r
.64502 .48233 .64778 .47081 .65953 .46231 .65621 .45867 Metetra
.67 .77 .926 r
.65621 .45867 .65953 .46231 .67049 .43683 .66821 .45458 Metetra
.379 .111 .376 r
.66821 .45458 .67049 .43683 .68244 .43306 .67985 .44227 Metetra
.422 .074 .268 r
.67985 .44227 .68244 .43306 .69446 .42927 .69193 .43847 Metetra
0 0 .111 r
.69193 .43847 .69446 .42927 .70497 .3993 .7033 .42139 Metetra
.506 .232 .434 r
.7033 .42139 .70497 .3993 .71698 .39545 .71544 .41755 Metetra
.419 .162 .416 r
.71544 .41755 .71698 .39545 .72905 .39158 .72705 .40489 Metetra
.395 .097 .338 r
.72705 .40489 .72905 .39158 .74117 .3877 .73896 .39662 Metetra
.008 0 .12 r
.73896 .39662 .74117 .3877 .75334 .3838 .75023 .37962 Metetra
.663 .743 .909 r
.75023 .37962 .75334 .3838 .76557 .37988 .76249 .37569 Metetra
.663 .743 .909 r
.76249 .37569 .76557 .37988 .77786 .37594 .77479 .37173 Metetra
.663 .743 .909 r
.77479 .37173 .77786 .37594 .78981 .36764 .78715 .36776 Metetra
.363 .834 .83 r
.78715 .36776 .78981 .36764 .80219 .36366 .79957 .36377 Metetra
.68 .979 .854 r
.79957 .36377 .80219 .36366 .81421 .35533 .81163 .3554 Metetra
.367 .836 .833 r
.81163 .3554 .81421 .35533 .82668 .35131 .82414 .35137 Metetra
.367 .836 .833 r
.82414 .35137 .82668 .35131 .8392 .34727 .83671 .34731 Metetra
.367 .836 .833 r
.83671 .34731 .8392 .34727 .85178 .34322 .84934 .34325 Metetra
.674 .977 .849 r
.84934 .34325 .85178 .34322 .86443 .33915 .86153 .3348 Metetra
.663 .742 .908 r
.86153 .3348 .86443 .33915 .87712 .33506 .87425 .33069 Metetra
.634 .585 .782 r
.29567 .6984 .29944 .7064 .31067 .6986 .30661 .69526 Metetra
.646 .762 .933 r
.30661 .69526 .31067 .6986 .32165 .69546 .31759 .69211 Metetra
.646 .762 .933 r
.31759 .69211 .32165 .69546 .33267 .69231 .32863 .68894 Metetra
.646 .762 .933 r
.32863 .68894 .33267 .69231 .34374 .68914 .33972 .68576 Metetra
.646 .762 .933 r
.33972 .68576 .34374 .68914 .35485 .68597 .35085 .68257 Metetra
.646 .762 .933 r
.35085 .68257 .35485 .68597 .36602 .68277 .36204 .67936 Metetra
.646 .762 .933 r
.36204 .67936 .36602 .68277 .37724 .67956 .37327 .67614 Metetra
.646 .762 .933 r
.37327 .67614 .37724 .67956 .3885 .67634 .38455 .6729 Metetra
.646 .762 .933 r
.38455 .6729 .3885 .67634 .39982 .67311 .39589 .66965 Metetra
.646 .762 .933 r
.39589 .66965 .39982 .67311 .41118 .66986 .40727 .66638 Metetra
.646 .762 .933 r
.40727 .66638 .41118 .66986 .4226 .66659 .41871 .6631 Metetra
.774 .785 .863 r
.41871 .6631 .4226 .66659 .43407 .66331 .43033 .65506 Metetra
.634 .585 .782 r
.43033 .65506 .43407 .66331 .44559 .66002 .44185 .65175 Metetra
.634 .585 .782 r
.44185 .65175 .44559 .66002 .45725 .65196 .45342 .64842 Metetra
.647 .761 .933 r
.45342 .64842 .45725 .65196 .46886 .64863 .46505 .64507 Metetra
.647 .761 .933 r
.46505 .64507 .46886 .64863 .48052 .64529 .47673 .64171 Metetra
.647 .761 .933 r
.47673 .64171 .48052 .64529 .49223 .64193 .48846 .63833 Metetra
.774 .788 .864 r
.48846 .63833 .49223 .64193 .50403 .63379 .50028 .63018 Metetra
.897 .776 .72 r
.50028 .63018 .50403 .63379 .51587 .61149 .51217 .60783 Metetra
.897 .776 .72 r
.51217 .60783 .51587 .61149 .52766 .60805 .52397 .58563 Metetra
.595 .443 .646 r
.52397 .58563 .52766 .60805 .53948 .59989 .53576 .58215 Metetra
.603 .468 .67 r
.53576 .58215 .53948 .59989 .55123 .58237 .54761 .57864 Metetra
.651 .757 .927 r
.54761 .57864 .55123 .58237 .56311 .57887 .55951 .57512 Metetra
.942 .751 .615 r
.55951 .57512 .56311 .57887 .57497 .57068 .57085 .53 Metetra
.579 .399 .602 r
.57085 .53 .57497 .57068 .58621 .53023 .5827 .5264 Metetra
.655 .753 .922 r
.5827 .5264 .58621 .53023 .5981 .52663 .5946 .52278 Metetra
.655 .753 .922 r
.5946 .52278 .5981 .52663 .61004 .52301 .60656 .51915 Metetra
.867 .789 .772 r
.60656 .51915 .61004 .52301 .62165 .50722 .61821 .50333 Metetra
.945 .758 .619 r
.61821 .50333 .62165 .50722 .63347 .49847 .62896 .46217 Metetra
.675 .472 .603 r
.62896 .46217 .63347 .49847 .64502 .48233 .64006 .43635 Metetra
.61 .417 .595 r
.64006 .43635 .64502 .48233 .65621 .45867 .65159 .42382 Metetra
.605 .424 .61 r
.65159 .42382 .65621 .45867 .66821 .45458 .6633 .41566 Metetra
.581 .401 .604 r
.6633 .41566 .66821 .45458 .67985 .44227 .67525 .41183 Metetra
.587 .418 .619 r
.67525 .41183 .67985 .44227 .69193 .43847 .68725 .40799 Metetra
.587 .418 .619 r
.68725 .40799 .69193 .43847 .7033 .42139 .69931 .40414 Metetra
.71 .538 .653 r
.69931 .40414 .7033 .42139 .71544 .41755 .71062 .3872 Metetra
.587 .418 .62 r
.71062 .3872 .71544 .41755 .72705 .40489 .72273 .38329 Metetra
.598 .447 .648 r
.72273 .38329 .72705 .40489 .73896 .39662 .73489 .37937 Metetra
.607 .472 .672 r
.73489 .37937 .73896 .39662 .75023 .37962 .74711 .37543 Metetra
.663 .743 .909 r
.74711 .37543 .75023 .37962 .76249 .37569 .75938 .37148 Metetra
.663 .743 .909 r
.75938 .37148 .76249 .37569 .77479 .37173 .77171 .3675 Metetra
.663 .743 .909 r
.77171 .3675 .77479 .37173 .78715 .36776 .7841 .36351 Metetra
.663 .743 .909 r
.7841 .36351 .78715 .36776 .79957 .36377 .79654 .3595 Metetra
.663 .743 .909 r
.79654 .3595 .79957 .36377 .81163 .3554 .80904 .35547 Metetra
.367 .836 .833 r
.80904 .35547 .81163 .3554 .82414 .35137 .82159 .35142 Metetra
.678 .978 .852 r
.82159 .35142 .82414 .35137 .83671 .34731 .83375 .34298 Metetra
.663 .742 .909 r
.83375 .34298 .83671 .34731 .84934 .34325 .8464 .3389 Metetra
.663 .742 .909 r
.8464 .3389 .84934 .34325 .86153 .3348 .85911 .33479 Metetra
.674 .977 .849 r
.85911 .33479 .86153 .3348 .87425 .33069 .87137 .32629 Metetra
.646 .762 .933 r
.29156 .69506 .29567 .6984 .30661 .69526 .30252 .6919 Metetra
.646 .762 .933 r
.30252 .6919 .30661 .69526 .31759 .69211 .31352 .68874 Metetra
.646 .762 .933 r
.31352 .68874 .31759 .69211 .32863 .68894 .32458 .68556 Metetra
.646 .762 .933 r
.32458 .68556 .32863 .68894 .33972 .68576 .33568 .68236 Metetra
.646 .762 .933 r
.33568 .68236 .33972 .68576 .35085 .68257 .34683 .67915 Metetra
.646 .762 .933 r
.34683 .67915 .35085 .68257 .36204 .67936 .35803 .67593 Metetra
.646 .762 .933 r
.35803 .67593 .36204 .67936 .37327 .67614 .36929 .67269 Metetra
.773 .783 .861 r
.36929 .67269 .37327 .67614 .38455 .6729 .38079 .66471 Metetra
.634 .585 .782 r
.38079 .66471 .38455 .6729 .39589 .66965 .39213 .66144 Metetra
.634 .585 .782 r
.39213 .66144 .39589 .66965 .40727 .66638 .40351 .65815 Metetra
.634 .585 .782 r
.40351 .65815 .40727 .66638 .41871 .6631 .41495 .65485 Metetra
.634 .585 .782 r
.41495 .65485 .41871 .6631 .43033 .65506 .42644 .65153 Metetra
.647 .761 .933 r
.42644 .65153 .43033 .65506 .44185 .65175 .43798 .6482 Metetra
.647 .761 .933 r
.43798 .6482 .44185 .65175 .45342 .64842 .44957 .64486 Metetra
.647 .761 .933 r
.44957 .64486 .45342 .64842 .46505 .64507 .46122 .64149 Metetra
.908 .766 .692 r
.46122 .64149 .46505 .64507 .47673 .64171 .47328 .61447 Metetra
.588 .426 .629 r
.47328 .61447 .47673 .64171 .48846 .63833 .48495 .61104 Metetra
.588 .426 .629 r
.48495 .61104 .48846 .63833 .50028 .63018 .49667 .60761 Metetra
.594 .442 .645 r
.49667 .60761 .50028 .63018 .51217 .60783 .50844 .60416 Metetra
.875 .783 .757 r
.50844 .60416 .51217 .60783 .52397 .58563 .52029 .58659 Metetra
.664 .973 .841 r
.52029 .58659 .52397 .58563 .53576 .58215 .5321 .57841 Metetra
.651 .757 .927 r
.5321 .57841 .53576 .58215 .54761 .57864 .54397 .57489 Metetra
.934 .757 .64 r
.54397 .57489 .54761 .57864 .55951 .57512 .55555 .53708 Metetra
.614 .427 .606 r
.55555 .53708 .55951 .57512 .57085 .53 .56729 .52616 Metetra
.655 .753 .922 r
.56729 .52616 .57085 .53 .5827 .5264 .57916 .52255 Metetra
.655 .753 .922 r
.57916 .52255 .5827 .5264 .5946 .52278 .59109 .51891 Metetra
.655 .753 .922 r
.59109 .51891 .5946 .52278 .60656 .51915 .60307 .51526 Metetra
.655 .753 .922 r
.60307 .51526 .60656 .51915 .61821 .50333 .6151 .51159 Metetra
.401 .035 .224 r
.6151 .51159 .61821 .50333 .62896 .46217 .62719 .50791 Metetra
.531 .287 .489 r
.62719 .50791 .62896 .46217 .64006 .43635 .63933 .50421 Metetra
.539 .305 .507 r
.63933 .50421 .64006 .43635 .65159 .42382 .65153 .50049 Metetra
.541 .309 .512 r
.65153 .50049 .65159 .42382 .6633 .41566 .66379 .49676 Metetra
.512 .287 .51 r
.66379 .49676 .6633 .41566 .67525 .41183 .6755 .48075 Metetra
.324 .14 .47 r
.6755 .48075 .67525 .41183 .68725 .40799 .68468 .41706 Metetra
.416 .065 .259 r
.68468 .41706 .68725 .40799 .69931 .40414 .69681 .41319 Metetra
0 0 .101 r
.69681 .41319 .69931 .40414 .71062 .3872 .7082 .39612 Metetra
.414 .061 .255 r
.7082 .39612 .71062 .3872 .72273 .38329 .72039 .39221 Metetra
.414 .061 .255 r
.72039 .39221 .72273 .38329 .73489 .37937 .73263 .38828 Metetra
.414 .061 .255 r
.73263 .38828 .73489 .37937 .74711 .37543 .74492 .38434 Metetra
.414 .061 .255 r
.74492 .38434 .74711 .37543 .75938 .37148 .75727 .38037 Metetra
.008 0 .12 r
.75727 .38037 .75938 .37148 .77171 .3675 .76862 .36325 Metetra
.663 .743 .909 r
.76862 .36325 .77171 .3675 .7841 .36351 .78102 .35924 Metetra
.663 .743 .909 r
.78102 .35924 .7841 .36351 .79654 .3595 .79349 .35521 Metetra
.663 .743 .909 r
.79349 .35521 .79654 .3595 .80904 .35547 .80601 .35116 Metetra
.713 .762 .891 r
.80601 .35116 .80904 .35547 .82159 .35142 .81842 .34534 Metetra
.713 .689 .825 r
.81842 .34534 .82159 .35142 .83375 .34298 .83078 .33863 Metetra
.663 .742 .909 r
.83078 .33863 .83375 .34298 .8464 .3389 .84345 .33452 Metetra
.663 .742 .909 r
.84345 .33452 .8464 .3389 .85911 .33479 .85618 .3304 Metetra
.773 .783 .861 r
.85618 .3304 .85911 .33479 .87137 .32629 .86847 .32188 Metetra
.646 .762 .933 r
.28744 .6917 .29156 .69506 .30252 .6919 .29841 .68853 Metetra
.646 .762 .933 r
.29841 .68853 .30252 .6919 .31352 .68874 .30943 .68535 Metetra
.646 .762 .933 r
.30943 .68535 .31352 .68874 .32458 .68556 .32051 .68215 Metetra
.646 .762 .933 r
.32051 .68215 .32458 .68556 .33568 .68236 .33163 .67894 Metetra
.646 .762 .933 r
.33163 .67894 .33568 .68236 .34683 .67915 .34279 .67572 Metetra
.646 .762 .933 r
.34279 .67572 .34683 .67915 .35803 .67593 .35401 .67248 Metetra
.646 .762 .933 r
.35401 .67248 .35803 .67593 .36929 .67269 .36528 .66923 Metetra
.646 .762 .933 r
.36528 .66923 .36929 .67269 .38079 .66471 .3766 .66596 Metetra
.3766 .66596 .38079 .66471 .39213 .66144 .38797 .66268 Metetra
.38797 .66268 .39213 .66144 .40351 .65815 .39939 .65938 Metetra
.669 .975 .845 r
.39939 .65938 .40351 .65815 .41495 .65485 .41103 .65132 Metetra
.647 .761 .933 r
.41103 .65132 .41495 .65485 .42644 .65153 .42253 .64799 Metetra
.647 .761 .933 r
.42253 .64799 .42644 .65153 .43798 .6482 .43409 .64464 Metetra
.647 .761 .933 r
.43409 .64464 .43798 .6482 .44957 .64486 .44571 .64128 Metetra
.647 .761 .933 r
.44571 .64128 .44957 .64486 .46122 .64149 .45737 .6379 Metetra
.908 .766 .692 r
.45737 .6379 .46122 .64149 .47328 .61447 .46948 .61082 Metetra
.649 .759 .929 r
.46948 .61082 .47328 .61447 .48495 .61104 .48117 .60739 Metetra
.649 .759 .929 r
.48117 .60739 .48495 .61104 .49667 .60761 .49291 .60393 Metetra
.673 .766 .92 r
.49291 .60393 .49667 .60761 .50844 .60416 .50471 .59979 Metetra
.858 .762 .755 r
.50471 .59979 .50844 .60416 .52029 .58659 .51658 .58287 Metetra
.774 .785 .863 r
.51658 .58287 .52029 .58659 .5321 .57841 .52842 .57467 Metetra
.651 .757 .927 r
.52842 .57467 .5321 .57841 .54397 .57489 .54031 .57113 Metetra
.651 .757 .927 r
.54031 .57113 .54397 .57489 .55555 .53708 .55225 .56757 Metetra
.518 .257 .459 r
.55225 .56757 .55555 .53708 .56729 .52616 .56424 .564 Metetra
.271 .068 .411 r
.56424 .564 .56729 .52616 .57916 .52255 .57573 .52602 Metetra
.165 0 0 r
.57573 .52602 .57916 .52255 .59109 .51891 .5877 .52237 Metetra
.5877 .52237 .59109 .51891 .60307 .51526 .59956 .51136 Metetra
.655 .753 .922 r
.59956 .51136 .60307 .51526 .6151 .51159 .61161 .50767 Metetra
.655 .753 .922 r
.61161 .50767 .6151 .51159 .62719 .50791 .62372 .50397 Metetra
.655 .753 .922 r
.62372 .50397 .62719 .50791 .63933 .50421 .63589 .50025 Metetra
.655 .753 .922 r
.63589 .50025 .63933 .50421 .65153 .50049 .64811 .49652 Metetra
.655 .753 .922 r
.64811 .49652 .65153 .50049 .66379 .49676 .66038 .49276 Metetra
.655 .753 .922 r
.66038 .49276 .66379 .49676 .6755 .48075 .67272 .48899 Metetra
0 0 .041 r
.67272 .48899 .6755 .48075 .68468 .41706 .68448 .47293 Metetra
.535 .295 .498 r
.68448 .47293 .68468 .41706 .69681 .41319 .69687 .46911 Metetra
.484 .255 .491 r
.69687 .46911 .69681 .41319 .7082 .39612 .7085 .45133 Metetra
.379 .175 .473 r
.7085 .45133 .7082 .39612 .72039 .39221 .71858 .41013 Metetra
.374 .107 .374 r
.71858 .41013 .72039 .39221 .73263 .38828 .73033 .39732 Metetra
.414 .061 .255 r
.73033 .39732 .73263 .38828 .74492 .38434 .74271 .39336 Metetra
0 0 .054 r
.74271 .39336 .74492 .38434 .75727 .38037 .7538 .37174 Metetra
.64 .585 .777 r
.7538 .37174 .75727 .38037 .76862 .36325 .76621 .36774 Metetra
.76621 .36774 .76862 .36325 .78102 .35924 .77794 .35495 Metetra
.663 .743 .909 r
.77794 .35495 .78102 .35924 .79349 .35521 .79043 .3509 Metetra
.663 .743 .909 r
.79043 .3509 .79349 .35521 .80601 .35116 .80297 .34683 Metetra
.663 .743 .909 r
.80297 .34683 .80601 .35116 .81842 .34534 .81557 .34274 Metetra
.795 .886 .911 r
.81557 .34274 .81842 .34534 .83078 .33863 .82779 .33426 Metetra
.663 .742 .909 r
.82779 .33426 .83078 .33863 .84345 .33452 .84049 .33013 Metetra
.663 .742 .909 r
.84049 .33013 .84345 .33452 .85618 .3304 .85324 .32598 Metetra
.663 .742 .909 r
.85324 .32598 .85618 .3304 .86847 .32188 .86606 .32182 Metetra
.646 .762 .933 r
.2833 .68833 .28744 .6917 .29841 .68853 .29429 .68515 Metetra
.646 .762 .933 r
.29429 .68515 .29841 .68853 .30943 .68535 .30533 .68195 Metetra
.646 .762 .933 r
.30533 .68195 .30943 .68535 .32051 .68215 .31641 .67874 Metetra
.646 .762 .933 r
.31641 .67874 .32051 .68215 .33163 .67894 .32755 .67551 Metetra
.646 .762 .933 r
.32755 .67551 .33163 .67894 .34279 .67572 .33874 .67227 Metetra
.646 .762 .933 r
.33874 .67227 .34279 .67572 .35401 .67248 .34997 .66902 Metetra
.646 .762 .933 r
.34997 .66902 .35401 .67248 .36528 .66923 .36126 .66575 Metetra
.646 .762 .933 r
.36126 .66575 .36528 .66923 .3766 .66596 .3726 .66247 Metetra
.646 .762 .933 r
.3726 .66247 .3766 .66596 .38797 .66268 .38399 .65917 Metetra
.646 .762 .933 r
.38399 .65917 .38797 .66268 .39939 .65938 .39543 .65586 Metetra
.646 .762 .933 r
.39543 .65586 .39939 .65938 .41103 .65132 .40692 .65253 Metetra
.669 .975 .845 r
.40692 .65253 .41103 .65132 .42253 .64799 .41861 .64442 Metetra
.647 .761 .933 r
.41861 .64442 .42253 .64799 .43409 .64464 .43019 .64106 Metetra
.647 .761 .933 r
.43019 .64106 .43409 .64464 .44571 .64128 .44182 .63768 Metetra
.647 .761 .933 r
.44182 .63768 .44571 .64128 .45737 .6379 .45351 .63429 Metetra
.908 .766 .692 r
.45351 .63429 .45737 .6379 .46948 .61082 .46566 .60716 Metetra
.894 .773 .721 r
.46566 .60716 .46948 .61082 .48117 .60739 .47764 .58496 Metetra
.594 .442 .645 r
.47764 .58496 .48117 .60739 .49291 .60393 .48933 .58147 Metetra
.594 .442 .645 r
.48933 .58147 .49291 .60393 .50471 .59979 .50107 .57796 Metetra
.595 .445 .648 r
.50107 .57796 .50471 .59979 .51658 .58287 .51287 .57444 Metetra
.635 .585 .781 r
.51287 .57444 .51658 .58287 .52842 .57467 .52473 .5709 Metetra
.932 .756 .641 r
.52473 .5709 .52842 .57467 .54031 .57113 .53649 .53302 Metetra
.579 .401 .605 r
.53649 .53302 .54031 .57113 .55225 .56757 .54833 .52941 Metetra
.613 .426 .605 r
.54833 .52941 .55225 .56757 .56424 .564 .56013 .51844 Metetra
.575 .391 .595 r
.56013 .51844 .56424 .564 .57573 .52602 .57204 .51479 Metetra
.623 .533 .732 r
.57204 .51479 .57573 .52602 .5877 .52237 .58401 .51112 Metetra
.623 .533 .732 r
.58401 .51112 .5877 .52237 .59956 .51136 .59603 .50744 Metetra
.655 .753 .922 r
.59603 .50744 .59956 .51136 .61161 .50767 .60811 .50373 Metetra
.655 .753 .922 r
.60811 .50373 .61161 .50767 .62372 .50397 .62024 .50001 Metetra
.655 .753 .922 r
.62024 .50001 .62372 .50397 .63589 .50025 .63242 .49627 Metetra
.655 .753 .922 r
.63242 .49627 .63589 .50025 .64811 .49652 .64467 .49252 Metetra
.87 .793 .772 r
.64467 .49252 .64811 .49652 .66038 .49276 .65644 .47648 Metetra
.722 .552 .659 r
.65644 .47648 .66038 .49276 .67272 .48899 .66811 .45876 Metetra
.585 .417 .62 r
.66811 .45876 .67272 .48899 .68448 .47293 .68041 .45493 Metetra
.655 .5 .663 r
.68041 .45493 .68448 .47293 .69687 .46911 .69246 .44523 Metetra
.785 .565 .603 r
.69246 .44523 .69687 .46911 .7085 .45133 .70249 .401 Metetra
.574 .386 .59 r
.70249 .401 .7085 .45133 .71858 .41013 .71478 .39706 Metetra
.712 .566 .688 r
.71478 .39706 .71858 .41013 .73033 .39732 .72653 .38427 Metetra
.67 .541 .7 r
.72653 .38427 .73033 .39732 .74271 .39336 .73857 .37588 Metetra
.606 .471 .671 r
.73857 .37588 .74271 .39336 .7538 .37174 .75097 .37188 Metetra
.854 .997 .806 r
.75097 .37188 .7538 .37174 .76621 .36774 .76273 .35907 Metetra
.709 .62 .756 r
.76273 .35907 .76621 .36774 .77794 .35495 .77484 .35064 Metetra
.663 .743 .909 r
.77484 .35064 .77794 .35495 .79043 .3509 .78735 .34657 Metetra
.663 .743 .909 r
.78735 .34657 .79043 .3509 .80297 .34683 .79991 .34248 Metetra
.699 .757 .896 r
.79991 .34248 .80297 .34683 .81557 .34274 .81242 .33712 Metetra
.729 .713 .836 r
.81242 .33712 .81557 .34274 .82779 .33426 .82478 .32986 Metetra
.773 .782 .86 r
.82478 .32986 .82779 .33426 .84049 .33013 .83704 .32134 Metetra
.641 .585 .776 r
.83704 .32134 .84049 .33013 .85324 .32598 .84981 .31717 Metetra
.641 .585 .776 r
.84981 .31717 .85324 .32598 .86606 .32182 .86263 .31298 Metetra
.646 .762 .933 r
.27913 .68494 .2833 .68833 .29429 .68515 .29014 .68174 Metetra
.646 .762 .933 r
.29014 .68174 .29429 .68515 .30533 .68195 .3012 .67853 Metetra
.646 .762 .933 r
.3012 .67853 .30533 .68195 .31641 .67874 .3123 .6753 Metetra
.646 .762 .933 r
.3123 .6753 .31641 .67874 .32755 .67551 .32346 .67206 Metetra
.646 .762 .933 r
.32346 .67206 .32755 .67551 .33874 .67227 .33466 .66881 Metetra
.773 .782 .86 r
.33466 .66881 .33874 .67227 .34997 .66902 .34617 .66081 Metetra
.836 .671 .677 r
.34617 .66081 .34997 .66902 .36126 .66575 .35863 .63404 Metetra
.582 .411 .616 r
.35863 .63404 .36126 .66575 .3726 .66247 .3699 .6307 Metetra
.674 .48 .615 r
.3699 .6307 .3726 .66247 .38399 .65917 .38201 .60876 Metetra
.572 .385 .589 r
.38201 .60876 .38399 .65917 .39543 .65586 .39331 .60537 Metetra
.572 .385 .589 r
.39331 .60537 .39543 .65586 .40692 .65253 .40466 .60197 Metetra
.572 .385 .589 r
.40466 .60197 .40692 .65253 .41861 .64442 .41607 .59856 Metetra
.593 .404 .595 r
.41607 .59856 .41861 .64442 .43019 .64106 .42765 .59049 Metetra
.667 .457 .592 r
.42765 .59049 .43019 .64106 .44182 .63768 .43991 .55764 Metetra
.565 .367 .572 r
.43991 .55764 .44182 .63768 .45351 .63429 .45134 .55413 Metetra
.565 .367 .572 r
.45134 .55413 .45351 .63429 .46566 .60716 .46283 .55062 Metetra
.595 .399 .586 r
.46283 .55062 .46566 .60716 .47764 .58496 .47448 .53979 Metetra
.574 .39 .594 r
.47448 .53979 .47764 .58496 .48933 .58147 .48604 .53624 Metetra
.574 .39 .594 r
.48604 .53624 .48933 .58147 .50107 .57796 .49766 .53266 Metetra
.574 .39 .594 r
.49766 .53266 .50107 .57796 .51287 .57444 .50933 .52907 Metetra
.574 .39 .594 r
.50933 .52907 .51287 .57444 .52473 .5709 .52104 .52547 Metetra
.574 .39 .594 r
.52104 .52547 .52473 .5709 .53649 .53302 .53282 .52185 Metetra
.623 .533 .732 r
.53282 .52185 .53649 .53302 .54833 .52941 .54464 .51821 Metetra
.753 .605 .694 r
.54464 .51821 .54833 .52941 .56013 .51844 .5564 .50238 Metetra
.722 .552 .66 r
.5564 .50238 .56013 .51844 .57204 .51479 .56809 .48488 Metetra
.741 .528 .604 r
.56809 .48488 .57204 .51479 .58401 .51112 .57932 .44486 Metetra
.57 .375 .578 r
.57932 .44486 .58401 .51112 .59603 .50744 .59111 .44041 Metetra
.568 .373 .577 r
.59111 .44041 .59603 .50744 .60811 .50373 .60296 .43662 Metetra
.586 .387 .578 r
.60296 .43662 .60811 .50373 .62024 .50001 .61468 .42651 Metetra
.573 .375 .575 r
.61468 .42651 .62024 .50001 .63242 .49627 .62653 .42016 Metetra
.566 .369 .573 r
.62653 .42016 .63242 .49627 .64467 .49252 .63851 .41631 Metetra
.588 .385 .574 r
.63851 .41631 .64467 .49252 .65644 .47648 .65018 .40365 Metetra
.578 .379 .575 r
.65018 .40365 .65644 .47648 .66811 .45876 .66203 .39537 Metetra
.569 .376 .579 r
.66203 .39537 .66811 .45876 .68041 .45493 .67412 .39146 Metetra
.569 .376 .579 r
.67412 .39146 .68041 .45493 .69246 .44523 .68626 .38752 Metetra
.598 .399 .583 r
.68626 .38752 .69246 .44523 .70249 .401 .69795 .37482 Metetra
.618 .447 .628 r
.69795 .37482 .70249 .401 .71478 .39706 .7099 .36648 Metetra
.585 .415 .618 r
.7099 .36648 .71478 .39706 .72653 .38427 .72215 .36248 Metetra
.596 .445 .647 r
.72215 .36248 .72653 .38427 .73857 .37588 .73446 .35846 Metetra
.606 .471 .671 r
.73446 .35846 .73857 .37588 .75097 .37188 .74682 .35443 Metetra
.606 .471 .671 r
.74682 .35443 .75097 .37188 .76273 .35907 .75924 .35038 Metetra
.64 .585 .777 r
.75924 .35038 .76273 .35907 .77484 .35064 .77172 .34631 Metetra
.773 .78 .859 r
.77172 .34631 .77484 .35064 .78735 .34657 .78387 .33784 Metetra
.64 .585 .776 r
.78387 .33784 .78735 .34657 .79991 .34248 .79644 .33373 Metetra
.64 .585 .776 r
.79644 .33373 .79991 .34248 .81242 .33712 .80908 .3296 Metetra
.724 .655 .78 r
.80908 .3296 .81242 .33712 .82478 .32986 .82133 .32107 Metetra
.64 .585 .776 r
.82133 .32107 .82478 .32986 .83704 .32134 .83405 .3169 Metetra
.663 .742 .908 r
.83405 .3169 .83704 .32134 .84981 .31717 .84684 .31271 Metetra
.663 .742 .908 r
.84684 .31271 .84981 .31717 .86263 .31298 .85968 .3085 Metetra
.646 .762 .933 r
.27495 .68154 .27913 .68494 .29014 .68174 .28598 .67832 Metetra
.646 .762 .933 r
.28598 .67832 .29014 .68174 .3012 .67853 .29705 .6751 Metetra
.646 .762 .933 r
.29705 .6751 .3012 .67853 .3123 .6753 .30817 .67186 Metetra
.646 .762 .933 r
.30817 .67186 .3123 .6753 .32346 .67206 .31934 .6686 Metetra
.646 .762 .933 r
.31934 .6686 .32346 .67206 .33466 .66881 .33056 .66533 Metetra
.773 .782 .86 r
.33056 .66533 .33466 .66881 .34617 .66081 .3421 .65731 Metetra
.773 .782 .86 r
.3421 .65731 .34617 .66081 .35863 .63404 .35365 .64927 Metetra
0 0 .134 r
.35365 .64927 .35863 .63404 .3699 .6307 .36589 .62714 Metetra
.886 .764 .722 r
.36589 .62714 .3699 .6307 .38201 .60876 .37805 .60516 Metetra
.75 .777 .875 r
.37805 .60516 .38201 .60876 .39331 .60537 .38951 .59828 Metetra
.665 .626 .8 r
.38951 .59828 .39331 .60537 .40466 .60197 .40091 .59371 Metetra
.858 .678 .658 r
.40091 .59371 .40466 .60197 .41607 .59856 .41332 .5609 Metetra
.578 .399 .604 r
.41332 .5609 .41607 .59856 .42765 .59049 .42468 .55741 Metetra
.621 .437 .613 r
.42468 .55741 .42765 .59049 .43991 .55764 .43628 .54663 Metetra
.623 .533 .732 r
.43628 .54663 .43991 .55764 .45134 .55413 .44771 .54311 Metetra
.623 .533 .732 r
.44771 .54311 .45134 .55413 .46283 .55062 .45919 .53956 Metetra
.623 .533 .732 r
.45919 .53956 .46283 .55062 .47448 .53979 .47072 .53601 Metetra
.655 .753 .922 r
.47072 .53601 .47448 .53979 .48604 .53624 .4823 .53243 Metetra
.655 .753 .922 r
.4823 .53243 .48604 .53624 .49766 .53266 .49393 .52884 Metetra
.655 .753 .922 r
.49393 .52884 .49766 .53266 .50933 .52907 .50562 .52524 Metetra
.862 .781 .77 r
.50562 .52524 .50933 .52907 .52104 .52547 .51738 .50947 Metetra
.607 .479 .681 r
.51738 .50947 .52104 .52547 .53282 .52185 .52913 .50581 Metetra
.607 .479 .681 r
.52913 .50581 .53282 .52185 .54464 .51821 .54093 .50215 Metetra
.792 .596 .635 r
.54093 .50215 .54464 .51821 .5564 .50238 .55252 .46989 Metetra
.629 .444 .613 r
.55252 .46989 .5564 .50238 .56809 .48488 .5642 .45723 Metetra
.641 .46 .623 r
.5642 .45723 .56809 .48488 .57932 .44486 .57587 .44459 Metetra
.76 .98 .914 r
.57587 .44459 .57932 .44486 .59111 .44041 .58762 .43638 Metetra
.66 .746 .914 r
.58762 .43638 .59111 .44041 .60296 .43662 .59949 .43257 Metetra
.899 .779 .719 r
.59949 .43257 .60296 .43662 .61468 .42651 .61092 .41113 Metetra
.655 .513 .679 r
.61092 .41113 .61468 .42651 .62653 .42016 .62268 .40289 Metetra
.605 .47 .671 r
.62268 .40289 .62653 .42016 .63851 .41631 .63463 .39901 Metetra
.67 .512 .662 r
.63463 .39901 .63851 .41631 .65018 .40365 .64634 .38784 Metetra
.624 .491 .68 r
.64634 .38784 .65018 .40365 .66203 .39537 .6583 .38246 Metetra
.67 .542 .7 r
.6583 .38246 .66203 .39537 .67412 .39146 .67016 .37416 Metetra
.605 .47 .671 r
.67016 .37416 .67412 .39146 .68626 .38752 .68227 .3702 Metetra
.605 .47 .671 r
.68227 .3702 .68626 .38752 .69795 .37482 .69443 .36622 Metetra
.64 .585 .777 r
.69443 .36622 .69795 .37482 .7099 .36648 .70665 .36222 Metetra
.663 .743 .909 r
.70665 .36222 .7099 .36648 .72215 .36248 .71893 .35821 Metetra
.772 .778 .857 r
.71893 .35821 .72215 .36248 .73446 .35846 .73095 .34981 Metetra
.64 .585 .777 r
.73095 .34981 .73446 .35846 .74682 .35443 .74332 .34575 Metetra
.64 .585 .777 r
.74332 .34575 .74682 .35443 .75924 .35038 .75575 .34167 Metetra
.64 .585 .777 r
.75575 .34167 .75924 .35038 .77172 .34631 .76823 .33758 Metetra
.659 .595 .772 r
.76823 .33758 .77172 .34631 .78387 .33784 .78067 .33237 Metetra
.66 .69 .867 r
.78067 .33237 .78387 .33784 .79644 .33373 .79326 .32824 Metetra
.734 .721 .838 r
.79326 .32824 .79644 .33373 .80908 .3296 .8056 .32081 Metetra
.64 .585 .776 r
.8056 .32081 .80908 .3296 .82133 .32107 .8183 .31663 Metetra
.663 .742 .908 r
.8183 .31663 .82133 .32107 .83405 .3169 .83105 .31244 Metetra
.663 .742 .908 r
.83105 .31244 .83405 .3169 .84684 .31271 .84386 .30822 Metetra
.663 .742 .908 r
.84386 .30822 .84684 .31271 .85968 .3085 .85673 .30399 Metetra
.646 .762 .933 r
.27075 .67812 .27495 .68154 .28598 .67832 .28179 .67489 Metetra
.646 .762 .933 r
.28179 .67489 .28598 .67832 .29705 .6751 .29288 .67165 Metetra
.646 .762 .933 r
.29288 .67165 .29705 .6751 .30817 .67186 .30402 .66839 Metetra
.646 .762 .933 r
.30402 .66839 .30817 .67186 .31934 .6686 .31521 .66512 Metetra
.646 .762 .933 r
.31521 .66512 .31934 .6686 .33056 .66533 .32645 .66183 Metetra
.646 .762 .933 r
.32645 .66183 .33056 .66533 .3421 .65731 .33774 .65853 Metetra
.208 .724 .69 r
.33774 .65853 .3421 .65731 .35365 .64927 .34908 .65522 Metetra
.315 0 .065 r
.34908 .65522 .35365 .64927 .36589 .62714 .36047 .65188 Metetra
.504 .23 .432 r
.36047 .65188 .36589 .62714 .37805 .60516 .37191 .64854 Metetra
.526 .276 .479 r
.37191 .64854 .37805 .60516 .38951 .59828 .38341 .64518 Metetra
.528 .281 .484 r
.38341 .64518 .38951 .59828 .40091 .59371 .39496 .6418 Metetra
.528 .282 .485 r
.39496 .6418 .40091 .59371 .41332 .5609 .40655 .63841 Metetra
.537 .302 .506 r
.40655 .63841 .41332 .5609 .42468 .55741 .41821 .635 Metetra
.537 .302 .506 r
.41821 .635 .42468 .55741 .43628 .54663 .42991 .63158 Metetra
.538 .305 .509 r
.42991 .63158 .43628 .54663 .44771 .54311 .44167 .62814 Metetra
.538 .305 .509 r
.44167 .62814 .44771 .54311 .45919 .53956 .45349 .62469 Metetra
.526 .295 .507 r
.45349 .62469 .45919 .53956 .47072 .53601 .46544 .61641 Metetra
.538 .303 .507 r
.46544 .61641 .47072 .53601 .4823 .53243 .47734 .61292 Metetra
.538 .303 .507 r
.47734 .61292 .4823 .53243 .49393 .52884 .4893 .60941 Metetra
.538 .303 .507 r
.4893 .60941 .49393 .52884 .50562 .52524 .50132 .60588 Metetra
.525 .293 .505 r
.50132 .60588 .50562 .52524 .51738 .50947 .51341 .59753 Metetra
.491 .267 .502 r
.51341 .59753 .51738 .50947 .52913 .50581 .52551 .57481 Metetra
.456 .233 .487 r
.52551 .57481 .52913 .50581 .54093 .50215 .5375 .54755 Metetra
.526 .278 .482 r
.5375 .54755 .54093 .50215 .55252 .46989 .54956 .5439 Metetra
.504 .275 .499 r
.54956 .5439 .55252 .46989 .5642 .45723 .56154 .5292 Metetra
.513 .282 .5 r
.56154 .5292 .5642 .45723 .57587 .44459 .57355 .51782 Metetra
.504 .274 .499 r
.57355 .51782 .57587 .44459 .58762 .43638 .58549 .50294 Metetra
.511 .278 .497 r
.58549 .50294 .58762 .43638 .59949 .43257 .59748 .4918 Metetra
.532 .292 .496 r
.59748 .4918 .59949 .43257 .61092 .41113 .60968 .48802 Metetra
.537 .302 .506 r
.60968 .48802 .61092 .41113 .62268 .40289 .62193 .48423 Metetra
.538 .304 .508 r
.62193 .48423 .62268 .40289 .63463 .39901 .63424 .48042 Metetra
.507 .279 .504 r
.63424 .48042 .63463 .39901 .64634 .38784 .64612 .46428 Metetra
.537 .302 .506 r
.64612 .46428 .64634 .38784 .6583 .38246 .6585 .46042 Metetra
.537 .302 .507 r
.6585 .46042 .6583 .38246 .67016 .37416 .67093 .45655 Metetra
.538 .304 .509 r
.67093 .45655 .67016 .37416 .68227 .3702 .68342 .45265 Metetra
.538 .304 .509 r
.68342 .45265 .68227 .3702 .69443 .36622 .69596 .44874 Metetra
.476 .257 .501 r
.69596 .44874 .69443 .36622 .70665 .36222 .70711 .42035 Metetra
.516 .279 .494 r
.70711 .42035 .70665 .36222 .71893 .35821 .71938 .41183 Metetra
.53 .287 .492 r
.71938 .41183 .71893 .35821 .73095 .34981 .73198 .40783 Metetra
.449 .228 .485 r
.73198 .40783 .73095 .34981 .74332 .34575 .74301 .38123 Metetra
.374 .152 .443 r
.74301 .38123 .74332 .34575 .75575 .34167 .75392 .3549 Metetra
.455 .14 .34 r
.75392 .3549 .75575 .34167 .76823 .33758 .76651 .3508 Metetra
.201 0 .273 r
.76651 .3508 .76823 .33758 .78067 .33237 .77802 .33345 Metetra
.77802 .33345 .78067 .33237 .79326 .32824 .79066 .3293 Metetra
.535 .903 .715 r
.79066 .3293 .79326 .32824 .8056 .32081 .80294 .32074 Metetra
.395 .853 .856 r
.80294 .32074 .8056 .32081 .8183 .31663 .81568 .31655 Metetra
.691 .982 .862 r
.81568 .31655 .8183 .31663 .83105 .31244 .82803 .30795 Metetra
.663 .742 .908 r
.82803 .30795 .83105 .31244 .84386 .30822 .84086 .30372 Metetra
.663 .742 .908 r
.84086 .30372 .84386 .30822 .85673 .30399 .85376 .29947 Metetra
.646 .762 .933 r
.26653 .67468 .27075 .67812 .28179 .67489 .27759 .67144 Metetra
.646 .762 .933 r
.27759 .67144 .28179 .67489 .29288 .67165 .28869 .66818 Metetra
.646 .762 .933 r
.28869 .66818 .29288 .67165 .30402 .66839 .29985 .66491 Metetra
.646 .762 .933 r
.29985 .66491 .30402 .66839 .31521 .66512 .31106 .66162 Metetra
.646 .762 .933 r
.31106 .66162 .31521 .66512 .32645 .66183 .32231 .65832 Metetra
.646 .762 .933 r
.32231 .65832 .32645 .66183 .33774 .65853 .33362 .655 Metetra
.646 .762 .933 r
.33362 .655 .33774 .65853 .34908 .65522 .34498 .65167 Metetra
.646 .762 .933 r
.34498 .65167 .34908 .65522 .36047 .65188 .35639 .64832 Metetra
.646 .762 .933 r
.35639 .64832 .36047 .65188 .37191 .64854 .36785 .64496 Metetra
.646 .762 .933 r
.36785 .64496 .37191 .64854 .38341 .64518 .37936 .64158 Metetra
.774 .785 .862 r
.37936 .64158 .38341 .64518 .39496 .6418 .39112 .63341 Metetra
.888 .686 .624 r
.39112 .63341 .39496 .6418 .40655 .63841 .40441 .58406 Metetra
.573 .382 .585 r
.40441 .58406 .40655 .63841 .41821 .635 .41595 .57941 Metetra
.569 .378 .583 r
.41595 .57941 .41821 .635 .42991 .63158 .42749 .57591 Metetra
.569 .378 .583 r
.42749 .57591 .42991 .63158 .44167 .62814 .43909 .57239 Metetra
.607 .408 .586 r
.43909 .57239 .44167 .62814 .45349 .62469 .45099 .55742 Metetra
.616 .41 .579 r
.45099 .55742 .45349 .62469 .46544 .61641 .463 .5357 Metetra
.581 .379 .571 r
.463 .5357 .46544 .61641 .47734 .61292 .47476 .52477 Metetra
.562 .362 .567 r
.47476 .52477 .47734 .61292 .4893 .60941 .48643 .52115 Metetra
.562 .362 .567 r
.48643 .52115 .4893 .60941 .50132 .60588 .49816 .51751 Metetra
.562 .362 .567 r
.49816 .51751 .50132 .60588 .51341 .59753 .50994 .51385 Metetra
.563 .364 .569 r
.50994 .51385 .51341 .59753 .52551 .57481 .52177 .51018 Metetra
.566 .372 .577 r
.52177 .51018 .52551 .57481 .5375 .54755 .53366 .50648 Metetra
.627 .432 .599 r
.53366 .50648 .5375 .54755 .54956 .5439 .54551 .49056 Metetra
.57 .38 .585 r
.54551 .49056 .54956 .5439 .56154 .5292 .55746 .48682 Metetra
.574 .392 .597 r
.55746 .48682 .56154 .5292 .57355 .51782 .56946 .48307 Metetra
.628 .44 .608 r
.56946 .48307 .57355 .51782 .58549 .50294 .58134 .46956 Metetra
.632 .444 .61 r
.58134 .46956 .58549 .50294 .59748 .4918 .5932 .45577 Metetra
.615 .428 .606 r
.5932 .45577 .59748 .4918 .60968 .48802 .60509 .44453 Metetra
.581 .396 .595 r
.60509 .44453 .60968 .48802 .62193 .48423 .61716 .43906 Metetra
.573 .389 .593 r
.61716 .43906 .62193 .48423 .63424 .48042 .62933 .43518 Metetra
.655 .448 .591 r
.62933 .43518 .63424 .48042 .64612 .46428 .64069 .40887 Metetra
.569 .379 .583 r
.64069 .40887 .64612 .46428 .6585 .46042 .65288 .40494 Metetra
.569 .379 .583 r
.65288 .40494 .6585 .46042 .67093 .45655 .66512 .40099 Metetra
.599 .4 .583 r
.66512 .40099 .67093 .45655 .68342 .45265 .67697 .38812 Metetra
.567 .373 .577 r
.67697 .38812 .68342 .45265 .69596 .44874 .68929 .38412 Metetra
.584 .385 .577 r
.68929 .38412 .69596 .44874 .70711 .42035 .70132 .37419 Metetra
.585 .396 .592 r
.70132 .37419 .70711 .42035 .71938 .41183 .71354 .3672 Metetra
.592 .402 .593 r
.71354 .3672 .71938 .41183 .73198 .40783 .72569 .35872 Metetra
.588 .396 .589 r
.72569 .35872 .73198 .40783 .74301 .38123 .73787 .35022 Metetra
.59 .417 .616 r
.73787 .35022 .74301 .38123 .75392 .3549 .75031 .34501 Metetra
.735 .616 .725 r
.75031 .34501 .75392 .3549 .76651 .3508 .76228 .33319 Metetra
.645 .495 .665 r
.76228 .33319 .76651 .3508 .77802 .33345 .77451 .32465 Metetra
.64 .585 .777 r
.77451 .32465 .77802 .33345 .79066 .3293 .78715 .32047 Metetra
.64 .585 .777 r
.78715 .32047 .79066 .3293 .80294 .32074 .79986 .31628 Metetra
.663 .742 .909 r
.79986 .31628 .80294 .32074 .81568 .31655 .81262 .31207 Metetra
.773 .782 .86 r
.81262 .31207 .81568 .31655 .82803 .30795 .82499 .30345 Metetra
.663 .742 .908 r
.82499 .30345 .82803 .30795 .84086 .30372 .83785 .29919 Metetra
.663 .742 .908 r
.83785 .29919 .84086 .30372 .85376 .29947 .85077 .29492 Metetra
.646 .762 .933 r
.26229 .67123 .26653 .67468 .27759 .67144 .27336 .66797 Metetra
.646 .762 .933 r
.27336 .66797 .27759 .67144 .28869 .66818 .28449 .6647 Metetra
.646 .762 .933 r
.28449 .6647 .28869 .66818 .29985 .66491 .29566 .66141 Metetra
.646 .762 .933 r
.29566 .66141 .29985 .66491 .31106 .66162 .30688 .65811 Metetra
.646 .762 .933 r
.30688 .65811 .31106 .66162 .32231 .65832 .31816 .65479 Metetra
.646 .762 .933 r
.31816 .65479 .32231 .65832 .33362 .655 .32948 .65146 Metetra
.646 .762 .933 r
.32948 .65146 .33362 .655 .34498 .65167 .34086 .64811 Metetra
.646 .762 .933 r
.34086 .64811 .34498 .65167 .35639 .64832 .35229 .64474 Metetra
.929 .731 .615 r
.35229 .64474 .35639 .64832 .36785 .64496 .36628 .5896 Metetra
.568 .377 .583 r
.36628 .5896 .36785 .64496 .37936 .64158 .37763 .58615 Metetra
.568 .377 .583 r
.37763 .58615 .37936 .64158 .39112 .63341 .38904 .58268 Metetra
.57 .381 .587 r
.38904 .58268 .39112 .63341 .40441 .58406 .4005 .57919 Metetra
.652 .699 .881 r
.4005 .57919 .40441 .58406 .41595 .57941 .41201 .57569 Metetra
.853 .779 .779 r
.41201 .57569 .41595 .57941 .42749 .57591 .42393 .56074 Metetra
.784 .596 .646 r
.42393 .56074 .42749 .57591 .43909 .57239 .4362 .53174 Metetra
.574 .393 .598 r
.4362 .53174 .43909 .57239 .45099 .55742 .44773 .52815 Metetra
.583 .416 .62 r
.44773 .52815 .45099 .55742 .463 .5357 .45932 .52454 Metetra
.622 .533 .732 r
.45932 .52454 .463 .5357 .47476 .52477 .47096 .52091 Metetra
.655 .753 .922 r
.47096 .52091 .47476 .52477 .48643 .52115 .48265 .51727 Metetra
.655 .753 .922 r
.48265 .51727 .48643 .52115 .49816 .51751 .4944 .51361 Metetra
.655 .753 .922 r
.4944 .51361 .49816 .51751 .50994 .51385 .5062 .50994 Metetra
.804 .784 .834 r
.5062 .50994 .50994 .51385 .52177 .51018 .51806 .49977 Metetra
.703 .589 .725 r
.51806 .49977 .52177 .51018 .53366 .50648 .52993 .49032 Metetra
.606 .478 .681 r
.52993 .49032 .53366 .50648 .54551 .49056 .54185 .48658 Metetra
.656 .751 .92 r
.54185 .48658 .54551 .49056 .55746 .48682 .55382 .48283 Metetra
.905 .777 .709 r
.55382 .48283 .55746 .48682 .56946 .48307 .56558 .45934 Metetra
.591 .435 .639 r
.56558 .45934 .56946 .48307 .58134 .46956 .57758 .45553 Metetra
.663 .53 .691 r
.57758 .45553 .58134 .46956 .5932 .45577 .58954 .44717 Metetra
.686 .609 .765 r
.58954 .44717 .5932 .45577 .60509 .44453 .60156 .44043 Metetra
.707 .764 .897 r
.60156 .44043 .60509 .44453 .61716 .43906 .61365 .43493 Metetra
.919 .777 .687 r
.61365 .43493 .61716 .43906 .62933 .43518 .6251 .40862 Metetra
.587 .425 .628 r
.6251 .40862 .62933 .43518 .64069 .40887 .63725 .40468 Metetra
.66 .746 .914 r
.63725 .40468 .64069 .40887 .65288 .40494 .64946 .40073 Metetra
.66 .746 .914 r
.64946 .40073 .65288 .40494 .66512 .40099 .66173 .39677 Metetra
.862 .791 .78 r
.66173 .39677 .66512 .40099 .67697 .38812 .6735 .38164 Metetra
.818 .713 .749 r
.6735 .38164 .67697 .38812 .68929 .38412 .68524 .36656 Metetra
.604 .469 .67 r
.68524 .36656 .68929 .38412 .70132 .37419 .69758 .36252 Metetra
.68 .562 .715 r
.69758 .36252 .70132 .37419 .71354 .3672 .7097 .35404 Metetra
.669 .541 .699 r
.7097 .35404 .71354 .3672 .72569 .35872 .72185 .34555 Metetra
.747 .586 .676 r
.72185 .34555 .72569 .35872 .73787 .35022 .7334 .3283 Metetra
.595 .444 .646 r
.7334 .3283 .73787 .35022 .75031 .34501 .74587 .32416 Metetra
.597 .449 .651 r
.74587 .32416 .75031 .34501 .76228 .33319 .75841 .32 Metetra
.618 .511 .709 r
.75841 .32 .76228 .33319 .77451 .32465 .771 .31582 Metetra
.64 .585 .777 r
.771 .31582 .77451 .32465 .78715 .32047 .78364 .31163 Metetra
.64 .585 .777 r
.78364 .31163 .78715 .32047 .79986 .31628 .79635 .30741 Metetra
.64 .585 .777 r
.79635 .30741 .79986 .31628 .81262 .31207 .80911 .30317 Metetra
.64 .585 .777 r
.80911 .30317 .81262 .31207 .82499 .30345 .82194 .29892 Metetra
.663 .742 .908 r
.82194 .29892 .82499 .30345 .83785 .29919 .83482 .29464 Metetra
.663 .742 .908 r
.83482 .29464 .83785 .29919 .85077 .29492 .84777 .29035 Metetra
.646 .762 .933 r
.25803 .66776 .26229 .67123 .27336 .66797 .26912 .66449 Metetra
.646 .762 .933 r
.26912 .66449 .27336 .66797 .28449 .6647 .28026 .6612 Metetra
.646 .762 .933 r
.28026 .6612 .28449 .6647 .29566 .66141 .29145 .65789 Metetra
.646 .762 .933 r
.29145 .65789 .29566 .66141 .30688 .65811 .30269 .65457 Metetra
.646 .762 .933 r
.30269 .65457 .30688 .65811 .31816 .65479 .31398 .65124 Metetra
.925 .728 .619 r
.31398 .65124 .31816 .65479 .32948 .65146 .32843 .59625 Metetra
.567 .376 .582 r
.32843 .59625 .32948 .65146 .34086 .64811 .33965 .59282 Metetra
.567 .376 .582 r
.33965 .59282 .34086 .64811 .35229 .64474 .35092 .58938 Metetra
.567 .376 .582 r
.35092 .58938 .35229 .64474 .36628 .5896 .36224 .58592 Metetra
.651 .756 .926 r
.36224 .58592 .36628 .5896 .37763 .58615 .37362 .58245 Metetra
.651 .756 .926 r
.37362 .58245 .37763 .58615 .38904 .58268 .38504 .57896 Metetra
.651 .756 .926 r
.38504 .57896 .38904 .58268 .4005 .57919 .39652 .57546 Metetra
.651 .756 .926 r
.39652 .57546 .4005 .57919 .41201 .57569 .40805 .57194 Metetra
.651 .756 .926 r
.40805 .57194 .41201 .57569 .42393 .56074 .41963 .5684 Metetra
.365 0 .165 r
.41963 .5684 .42393 .56074 .4362 .53174 .43127 .56485 Metetra
.513 .252 .456 r
.43127 .56485 .4362 .53174 .44773 .52815 .44295 .56128 Metetra
.513 .252 .456 r
.44295 .56128 .44773 .52815 .45932 .52454 .45469 .5577 Metetra
.443 .192 .437 r
.45469 .5577 .45932 .52454 .47096 .52091 .46665 .54475 Metetra
.476 .201 .417 r
.46665 .54475 .47096 .52091 .48265 .51727 .4785 .53897 Metetra
.492 .209 .412 r
.4785 .53897 .48265 .51727 .4944 .51361 .49036 .53533 Metetra
.084 0 .267 r
.49036 .53533 .4944 .51361 .5062 .50994 .50244 .50601 Metetra
.655 .753 .922 r
.50244 .50601 .5062 .50994 .51806 .49977 .51432 .5023 Metetra
.019 0 0 r
.51432 .5023 .51806 .49977 .52993 .49032 .52624 .49857 Metetra
.38 .006 .196 r
.52624 .49857 .52993 .49032 .54185 .48658 .53823 .49483 Metetra
.38 .006 .196 r
.53823 .49483 .54185 .48658 .55382 .48283 .55026 .49107 Metetra
.38 .006 .196 r
.55026 .49107 .55382 .48283 .56558 .45934 .56235 .48729 Metetra
.505 .237 .441 r
.56235 .48729 .56558 .45934 .57758 .45553 .5745 .48349 Metetra
.396 .146 .414 r
.5745 .48349 .57758 .45553 .58954 .44717 .58646 .46738 Metetra
.487 .2 .403 r
.58646 .46738 .58954 .44717 .60156 .44043 .59867 .46354 Metetra
.495 .217 .42 r
.59867 .46354 .60156 .44043 .61365 .43493 .61094 .45968 Metetra
.499 .224 .428 r
.61094 .45968 .61365 .43493 .6251 .40862 .62327 .4558 Metetra
.524 .276 .481 r
.62327 .4558 .6251 .40862 .63725 .40468 .63565 .4519 Metetra
.479 .24 .474 r
.63565 .4519 .63725 .40468 .64946 .40073 .6477 .43816 Metetra
.427 .189 .449 r
.6477 .43816 .64946 .40073 .66173 .39677 .65951 .41959 Metetra
.225 .001 .349 r
.65951 .41959 .66173 .39677 .6735 .38164 .67089 .39334 Metetra
.429 .098 .301 r
.67089 .39334 .6735 .38164 .68524 .36656 .68329 .38898 Metetra
.449 .178 .409 r
.68329 .38898 .68524 .36656 .69758 .36252 .69552 .38045 Metetra
.478 .184 .387 r
.69552 .38045 .69758 .36252 .7097 .35404 .70803 .37639 Metetra
.227 .005 .354 r
.70803 .37639 .7097 .35404 .72185 .34555 .71915 .35001 Metetra
.71915 .35001 .72185 .34555 .7334 .3283 .73108 .33705 Metetra
.269 0 .186 r
.73108 .33705 .7334 .3283 .74587 .32416 .74331 .3285 Metetra
.225 0 0 r
.74331 .3285 .74587 .32416 .75841 .32 .7559 .32433 Metetra
.225 0 0 r
.7559 .32433 .75841 .32 .771 .31582 .76855 .32014 Metetra
.225 0 0 r
.76855 .32014 .771 .31582 .78364 .31163 .78127 .31593 Metetra
.78127 .31593 .78364 .31163 .79635 .30741 .79323 .3029 Metetra
.663 .742 .908 r
.79323 .3029 .79635 .30741 .80911 .30317 .80602 .29864 Metetra
.663 .742 .908 r
.80602 .29864 .80911 .30317 .82194 .29892 .81887 .29437 Metetra
.663 .742 .908 r
.81887 .29437 .82194 .29892 .83482 .29464 .83178 .29007 Metetra
.663 .742 .908 r
.83178 .29007 .83482 .29464 .84777 .29035 .84475 .28575 Metetra
.646 .762 .933 r
.25375 .66427 .25803 .66776 .26912 .66449 .26486 .66098 Metetra
.646 .762 .933 r
.26486 .66098 .26912 .66449 .28026 .6612 .27601 .65768 Metetra
.646 .762 .933 r
.27601 .65768 .28026 .6612 .29145 .65789 .28722 .65436 Metetra
.646 .762 .933 r
.28722 .65436 .29145 .65789 .30269 .65457 .29848 .65103 Metetra
.646 .762 .933 r
.29848 .65103 .30269 .65457 .31398 .65124 .30979 .64768 Metetra
.925 .728 .619 r
.30979 .64768 .31398 .65124 .32843 .59625 .32432 .5926 Metetra
.651 .756 .926 r
.32432 .5926 .32843 .59625 .33965 .59282 .33556 .58916 Metetra
.651 .756 .926 r
.33556 .58916 .33965 .59282 .35092 .58938 .34685 .5857 Metetra
.651 .756 .926 r
.34685 .5857 .35092 .58938 .36224 .58592 .35819 .58223 Metetra
.651 .756 .926 r
.35819 .58223 .36224 .58592 .37362 .58245 .36959 .57874 Metetra
.651 .756 .926 r
.36959 .57874 .37362 .58245 .38504 .57896 .38103 .57523 Metetra
.651 .756 .926 r
.38103 .57523 .38504 .57896 .39652 .57546 .39253 .57171 Metetra
.651 .756 .926 r
.39253 .57171 .39652 .57546 .40805 .57194 .40407 .56818 Metetra
.651 .756 .926 r
.40407 .56818 .40805 .57194 .41963 .5684 .41567 .56462 Metetra
.853 .78 .779 r
.41567 .56462 .41963 .5684 .43127 .56485 .42767 .54958 Metetra
.607 .485 .688 r
.42767 .54958 .43127 .56485 .44295 .56128 .43933 .54599 Metetra
.607 .485 .688 r
.43933 .54599 .44295 .56128 .45469 .5577 .45105 .54237 Metetra
.607 .485 .688 r
.45105 .54237 .45469 .5577 .46665 .54475 .46282 .53874 Metetra
.802 .71 .763 r
.46282 .53874 .46665 .54475 .4785 .53897 .4748 .52528 Metetra
.701 .556 .686 r
.4748 .52528 .4785 .53897 .49036 .53533 .48674 .51314 Metetra
.648 .479 .641 r
.48674 .51314 .49036 .53533 .50244 .50601 .49867 .50206 Metetra
.655 .753 .922 r
.49867 .50206 .50244 .50601 .51432 .5023 .51056 .49833 Metetra
.655 .753 .922 r
.51056 .49833 .51432 .5023 .52624 .49857 .52251 .49459 Metetra
.773 .782 .86 r
.52251 .49459 .52624 .49857 .53823 .49483 .5345 .48622 Metetra
.732 .632 .747 r
.5345 .48622 .53823 .49483 .55026 .49107 .54649 .476 Metetra
.623 .497 .689 r
.54649 .476 .55026 .49107 .56235 .48729 .55855 .47096 Metetra
.605 .478 .68 r
.55855 .47096 .56235 .48729 .5745 .48349 .57067 .46714 Metetra
.694 .534 .666 r
.57067 .46714 .5745 .48349 .58646 .46738 .58266 .45351 Metetra
.746 .581 .67 r
.58266 .45351 .58646 .46738 .59867 .46354 .59452 .43507 Metetra
.584 .418 .623 r
.59452 .43507 .59867 .46354 .61094 .45968 .60672 .43116 Metetra
.718 .512 .609 r
.60672 .43116 .61094 .45968 .62327 .4558 .61813 .40022 Metetra
.567 .376 .582 r
.61813 .40022 .62327 .4558 .63565 .4519 .63033 .39625 Metetra
.567 .376 .582 r
.63033 .39625 .63565 .4519 .6477 .43816 .64258 .39227 Metetra
.607 .411 .591 r
.64258 .39227 .6477 .43816 .65951 .41959 .6545 .37933 Metetra
.632 .434 .597 r
.6545 .37933 .65951 .41959 .67089 .39334 .6662 .362 Metetra
.581 .41 .615 r
.6662 .362 .67089 .39334 .68329 .38898 .67853 .35793 Metetra
.582 .411 .615 r
.67853 .35793 .68329 .38898 .69552 .38045 .69092 .35385 Metetra
.587 .424 .628 r
.69092 .35385 .69552 .38045 .70803 .37639 .70336 .34974 Metetra
.587 .424 .628 r
.70336 .34974 .70803 .37639 .71915 .35001 .71586 .34562 Metetra
.773 .78 .859 r
.71586 .34562 .71915 .35001 .73108 .33705 .72812 .33705 Metetra
.705 .985 .873 r
.72812 .33705 .73108 .33705 .74331 .3285 .74039 .32847 Metetra
.705 .985 .873 r
.74039 .32847 .74331 .3285 .7559 .32433 .75269 .31987 Metetra
.663 .743 .909 r
.75269 .31987 .7559 .32433 .76855 .32014 .76537 .31566 Metetra
.773 .781 .859 r
.76537 .31566 .76855 .32014 .78127 .31593 .77773 .30702 Metetra
.639 .585 .777 r
.77773 .30702 .78127 .31593 .79323 .3029 .7905 .30277 Metetra
.554 .932 .882 r
.7905 .30277 .79323 .3029 .80602 .29864 .80316 .2966 Metetra
.731 .917 .957 r
.80316 .2966 .80602 .29864 .81887 .29437 .81579 .28979 Metetra
.663 .742 .908 r
.81579 .28979 .81887 .29437 .83178 .29007 .82873 .28547 Metetra
.663 .742 .908 r
.82873 .28547 .83178 .29007 .84475 .28575 .84172 .28114 Metetra
.646 .762 .933 r
.24945 .66077 .25375 .66427 .26486 .66098 .26057 .65747 Metetra
.646 .762 .933 r
.26057 .65747 .26486 .66098 .27601 .65768 .27174 .65415 Metetra
.915 .734 .643 r
.27174 .65415 .27601 .65768 .28722 .65436 .28591 .61034 Metetra
.619 .424 .596 r
.28591 .61034 .28722 .65436 .29848 .65103 .29783 .59581 Metetra
.566 .375 .581 r
.29783 .59581 .29848 .65103 .30979 .64768 .30899 .59238 Metetra
.566 .375 .581 r
.30899 .59238 .30979 .64768 .32432 .5926 .3202 .58894 Metetra
.651 .756 .926 r
.3202 .58894 .32432 .5926 .33556 .58916 .33145 .58548 Metetra
.651 .756 .926 r
.33145 .58548 .33556 .58916 .34685 .5857 .34276 .582 Metetra
.651 .756 .926 r
.34276 .582 .34685 .5857 .35819 .58223 .35412 .57851 Metetra
.651 .756 .926 r
.35412 .57851 .35819 .58223 .36959 .57874 .36553 .57501 Metetra
.651 .756 .926 r
.36553 .57501 .36959 .57874 .38103 .57523 .377 .57149 Metetra
.651 .756 .926 r
.377 .57149 .38103 .57523 .39253 .57171 .38851 .56795 Metetra
.651 .756 .926 r
.38851 .56795 .39253 .57171 .40407 .56818 .40008 .56439 Metetra
.651 .756 .926 r
.40008 .56439 .40407 .56818 .41567 .56462 .4117 .56082 Metetra
.853 .78 .779 r
.4117 .56082 .41567 .56462 .42767 .54958 .42373 .54575 Metetra
.653 .755 .925 r
.42373 .54575 .42767 .54958 .43933 .54599 .43541 .54214 Metetra
.653 .755 .925 r
.43541 .54214 .43933 .54599 .45105 .54237 .44715 .53851 Metetra
.892 .772 .723 r
.44715 .53851 .45105 .54237 .46282 .53874 .45931 .51659 Metetra
.591 .44 .645 r
.45931 .51659 .46282 .53874 .4748 .52528 .47109 .5129 Metetra
.617 .517 .718 r
.47109 .5129 .4748 .52528 .48674 .51314 .48292 .5092 Metetra
.815 .784 .824 r
.48292 .5092 .48674 .51314 .49867 .50206 .49488 .49809 Metetra
.773 .781 .859 r
.49488 .49809 .49867 .50206 .51056 .49833 .50681 .48974 Metetra
.636 .585 .78 r
.50681 .48974 .51056 .49833 .52251 .49459 .51876 .48598 Metetra
.732 .632 .747 r
.51876 .48598 .52251 .49459 .5345 .48622 .53076 .47575 Metetra
.645 .558 .742 r
.53076 .47575 .5345 .48622 .54649 .476 .54278 .47072 Metetra
.82 .741 .777 r
.54278 .47072 .54649 .476 .55855 .47096 .55477 .45712 Metetra
.613 .501 .703 r
.55477 .45712 .55855 .47096 .57067 .46714 .56688 .45326 Metetra
.746 .581 .67 r
.56688 .45326 .57067 .46714 .58266 .45351 .57878 .43482 Metetra
.599 .46 .664 r
.57878 .43482 .58266 .45351 .59452 .43507 .59094 .43091 Metetra
.902 .782 .719 r
.59094 .43091 .59452 .43507 .60672 .43116 .60269 .40892 Metetra
.592 .441 .645 r
.60269 .40892 .60672 .43116 .61813 .40022 .61489 .40496 Metetra
.61489 .40496 .61813 .40022 .63033 .39625 .627 .39683 Metetra
.692 .982 .844 r
.627 .39683 .63033 .39625 .64258 .39227 .63911 .388 Metetra
.66 .746 .914 r
.63911 .388 .64258 .39227 .6545 .37933 .65144 .38397 Metetra
.234 0 0 r
.65144 .38397 .6545 .37933 .6662 .362 .66383 .37993 Metetra
.453 .16 .378 r
.66383 .37993 .6662 .362 .67853 .35793 .67619 .37407 Metetra
.357 .072 .337 r
.67619 .37407 .67853 .35793 .69092 .35385 .68829 .36282 Metetra
.244 0 .174 r
.68829 .36282 .69092 .35385 .70336 .34974 .70051 .35361 Metetra
.70051 .35361 .70336 .34974 .71586 .34562 .71255 .34122 Metetra
.662 .744 .911 r
.71255 .34122 .71586 .34562 .72812 .33705 .72514 .33705 Metetra
.399 .855 .859 r
.72514 .33705 .72812 .33705 .74039 .32847 .73778 .33287 Metetra
.73778 .33287 .74039 .32847 .75269 .31987 .7498 .3198 Metetra
.406 .859 .865 r
.7498 .3198 .75269 .31987 .76537 .31566 .76252 .31557 Metetra
.835 .999 .824 r
.76252 .31557 .76537 .31566 .77773 .30702 .77463 .30337 Metetra
.804 .832 .872 r
.77463 .30337 .77773 .30702 .7905 .30277 .78696 .29382 Metetra
.639 .585 .777 r
.78696 .29382 .7905 .30277 .80316 .2966 .7998 .28952 Metetra
.651 .637 .823 r
.7998 .28952 .80316 .2966 .81579 .28979 .8127 .2852 Metetra
.663 .742 .908 r
.8127 .2852 .81579 .28979 .82873 .28547 .82566 .28086 Metetra
.663 .742 .908 r
.82566 .28086 .82873 .28547 .84172 .28114 .83868 .2765 Metetra
.646 .762 .933 r
.24512 .65725 .24945 .66077 .26057 .65747 .25626 .65393 Metetra
.913 .733 .644 r
.25626 .65393 .26057 .65747 .27174 .65415 .27059 .61012 Metetra
.619 .423 .596 r
.27059 .61012 .27174 .65415 .28591 .61034 .28253 .59559 Metetra
.606 .487 .69 r
.28253 .59559 .28591 .61034 .29783 .59581 .29365 .59216 Metetra
.651 .756 .926 r
.29365 .59216 .29783 .59581 .30899 .59238 .30483 .58872 Metetra
.651 .756 .926 r
.30483 .58872 .30899 .59238 .3202 .58894 .31605 .58526 Metetra
.651 .756 .926 r
.31605 .58526 .3202 .58894 .33145 .58548 .32733 .58178 Metetra
.651 .756 .926 r
.32733 .58178 .33145 .58548 .34276 .582 .33866 .57829 Metetra
.651 .756 .926 r
.33866 .57829 .34276 .582 .35412 .57851 .35003 .57478 Metetra
.651 .756 .926 r
.35003 .57478 .35412 .57851 .36553 .57501 .36146 .57126 Metetra
.851 .776 .778 r
.36146 .57126 .36553 .57501 .377 .57149 .37348 .55628 Metetra
.606 .484 .688 r
.37348 .55628 .377 .57149 .38851 .56795 .38497 .55271 Metetra
.606 .484 .688 r
.38497 .55271 .38851 .56795 .40008 .56439 .39651 .54912 Metetra
.752 .576 .658 r
.39651 .54912 .40008 .56439 .4117 .56082 .40877 .52732 Metetra
.577 .403 .609 r
.40877 .52732 .4117 .56082 .42373 .54575 .42036 .52368 Metetra
.591 .44 .645 r
.42036 .52368 .42373 .54575 .43541 .54214 .43199 .52002 Metetra
.591 .44 .645 r
.43199 .52002 .43541 .54214 .44715 .53851 .44368 .51635 Metetra
.648 .479 .641 r
.44368 .51635 .44715 .53851 .45931 .51659 .45559 .5053 Metetra
.682 .567 .719 r
.45559 .5053 .45931 .51659 .47109 .5129 .46744 .49699 Metetra
.605 .479 .683 r
.46744 .49699 .47109 .5129 .48292 .5092 .47925 .49325 Metetra
.744 .567 .655 r
.47925 .49325 .48292 .5092 .49488 .49809 .49129 .47213 Metetra
.586 .424 .629 r
.49129 .47213 .49488 .49809 .50681 .48974 .50314 .46834 Metetra
.627 .467 .646 r
.50314 .46834 .50681 .48974 .51876 .48598 .51506 .46038 Metetra
.586 .426 .631 r
.51506 .46038 .51876 .48598 .53076 .47575 .527 .45655 Metetra
.631 .479 .657 r
.527 .45655 .53076 .47575 .54278 .47072 .53898 .44892 Metetra
.644 .477 .643 r
.53898 .44892 .54278 .47072 .55477 .45712 .55096 .43846 Metetra
.73 .546 .642 r
.55096 .43846 .55477 .45712 .56688 .45326 .5628 .41654 Metetra
.619 .429 .603 r
.5628 .41654 .56688 .45326 .57878 .43482 .57471 .40367 Metetra
.58 .409 .614 r
.57471 .40367 .57878 .43482 .59094 .43091 .58678 .39972 Metetra
.58 .409 .614 r
.58678 .39972 .59094 .43091 .60269 .40892 .59891 .39574 Metetra
.638 .522 .706 r
.59891 .39574 .60269 .40892 .61489 .40496 .61104 .38996 Metetra
.682 .534 .678 r
.61104 .38996 .61489 .40496 .627 .39683 .62304 .37882 Metetra
.601 .465 .667 r
.62304 .37882 .627 .39683 .63911 .388 .6353 .37478 Metetra
.616 .509 .709 r
.6353 .37478 .63911 .388 .65144 .38397 .64761 .37073 Metetra
.693 .555 .693 r
.64761 .37073 .65144 .38397 .66383 .37993 .65968 .3598 Metetra
.614 .463 .653 r
.65968 .3598 .66383 .37993 .67619 .37407 .67198 .35365 Metetra
.633 .474 .65 r
.67198 .35365 .67619 .37407 .68829 .36282 .68419 .34509 Metetra
.68 .517 .658 r
.68419 .34509 .68829 .36282 .70051 .35361 .69617 .3321 Metetra
.594 .444 .648 r
.69617 .3321 .70051 .35361 .71255 .34122 .70868 .32793 Metetra
.649 .529 .704 r
.70868 .32793 .71255 .34122 .72514 .33705 .72107 .32109 Metetra
.626 .494 .681 r
.72107 .32109 .72514 .33705 .73778 .33287 .73356 .31512 Metetra
.624 .481 .667 r
.73356 .31512 .73778 .33287 .7498 .3198 .74606 .30868 Metetra
.658 .559 .732 r
.74606 .30868 .7498 .3198 .76252 .31557 .7586 .30222 Metetra
.617 .51 .709 r
.7586 .30222 .76252 .31557 .77463 .30337 .77136 .29794 Metetra
.759 .739 .834 r
.77136 .29794 .77463 .30337 .78696 .29382 .7838 .28924 Metetra
.663 .742 .908 r
.7838 .28924 .78696 .29382 .7998 .28952 .79666 .28492 Metetra
.663 .742 .908 r
.79666 .28492 .7998 .28952 .8127 .2852 .80958 .28058 Metetra
.663 .742 .908 r
.80958 .28058 .8127 .2852 .82566 .28086 .82257 .27621 Metetra
.663 .742 .908 r
.82257 .27621 .82566 .28086 .83868 .2765 .83561 .27183 Metetra
.646 .762 .933 r
.24078 .65372 .24512 .65725 .25626 .65393 .25194 .65038 Metetra
.646 .762 .933 r
.25194 .65038 .25626 .65393 .27059 .61012 .26315 .64703 Metetra
0 0 .197 r
.26315 .64703 .27059 .61012 .28253 .59559 .27823 .5931 Metetra
.69 .831 .951 r
.27823 .5931 .28253 .59559 .29365 .59216 .28946 .58849 Metetra
.651 .756 .926 r
.28946 .58849 .29365 .59216 .30483 .58872 .30065 .58503 Metetra
.651 .756 .926 r
.30065 .58503 .30483 .58872 .31605 .58526 .31189 .58156 Metetra
.651 .756 .926 r
.31189 .58156 .31605 .58526 .32733 .58178 .32318 .57806 Metetra
.651 .756 .926 r
.32318 .57806 .32733 .58178 .33866 .57829 .33453 .57456 Metetra
.651 .756 .926 r
.33453 .57456 .33866 .57829 .35003 .57478 .34592 .57103 Metetra
.651 .756 .926 r
.34592 .57103 .35003 .57478 .36146 .57126 .35737 .56749 Metetra
.851 .776 .778 r
.35737 .56749 .36146 .57126 .37348 .55628 .36942 .55248 Metetra
.653 .755 .925 r
.36942 .55248 .37348 .55628 .38497 .55271 .38093 .54889 Metetra
.838 .779 .795 r
.38093 .54889 .38497 .55271 .39651 .54912 .3929 .53551 Metetra
.611 .501 .704 r
.3929 .53551 .39651 .54912 .40877 .52732 .40448 .53188 Metetra
.21 0 0 r
.40448 .53188 .40877 .52732 .42036 .52368 .41611 .52824 Metetra
.41611 .52824 .42036 .52368 .43199 .52002 .42805 .51612 Metetra
.654 .753 .923 r
.42805 .51612 .43199 .52002 .44368 .51635 .43977 .51243 Metetra
.654 .753 .923 r
.43977 .51243 .44368 .51635 .45559 .5053 .45153 .50872 Metetra
.111 0 0 r
.45153 .50872 .45559 .5053 .46744 .49699 .46335 .505 Metetra
.46335 .505 .46744 .49699 .47925 .49325 .47541 .48926 Metetra
.655 .752 .921 r
.47541 .48926 .47925 .49325 .49129 .47213 .48729 .48549 Metetra
.406 .086 .306 r
.48729 .48549 .49129 .47213 .50314 .46834 .49924 .47981 Metetra
.424 .084 .283 r
.49924 .47981 .50314 .46834 .51506 .46038 .51122 .476 Metetra
.46 .15 .352 r
.51122 .476 .51506 .46038 .527 .45655 .52326 .47217 Metetra
.329 .036 .307 r
.52326 .47217 .527 .45655 .53898 .44892 .53533 .46102 Metetra
.225 0 .216 r
.53533 .46102 .53898 .44892 .55096 .43846 .54739 .44889 Metetra
.411 .061 .259 r
.54739 .44889 .55096 .43846 .5628 .41654 .55954 .44499 Metetra
.467 .202 .429 r
.55954 .44499 .5628 .41654 .57471 .40367 .57168 .43689 Metetra
.508 .245 .451 r
.57168 .43689 .57471 .40367 .58678 .39972 .58392 .43296 Metetra
.482 .224 .446 r
.58392 .43296 .58678 .39972 .59891 .39574 .59613 .4252 Metetra
.48 .215 .435 r
.59613 .4252 .59891 .39574 .61104 .38996 .60839 .41823 Metetra
.289 .06 .383 r
.60839 .41823 .61104 .38996 .62304 .37882 .62009 .39244 Metetra
.263 0 .268 r
.62009 .39244 .62304 .37882 .6353 .37478 .63213 .37941 Metetra
.123 0 0 r
.63213 .37941 .6353 .37478 .64761 .37073 .64443 .37355 Metetra
.503 .833 .54 r
.64443 .37355 .64761 .37073 .65968 .3598 .65654 .36229 Metetra
.65 .913 .606 r
.65654 .36229 .65968 .3598 .67198 .35365 .66856 .34926 Metetra
.773 .779 .858 r
.66856 .34926 .67198 .35365 .68419 .34509 .6808 .34068 Metetra
.808 .786 .832 r
.6808 .34068 .68419 .34509 .69617 .3321 .69295 .33 Metetra
.729 .902 .956 r
.69295 .33 .69617 .3321 .70868 .32793 .70535 .32347 Metetra
.682 .75 .903 r
.70535 .32347 .70868 .32793 .72107 .32109 .7179 .31863 Metetra
.779 .892 .925 r
.7179 .31863 .72107 .32109 .73356 .31512 .73028 .31061 Metetra
.663 .743 .909 r
.73028 .31061 .73356 .31512 .74606 .30868 .74297 .30635 Metetra
.632 .865 .986 r
.74297 .30635 .74606 .30868 .7586 .30222 .75571 .30208 Metetra
.772 .996 .858 r
.75571 .30208 .7586 .30222 .77136 .29794 .76803 .2919 Metetra
.722 .703 .832 r
.76803 .2919 .77136 .29794 .7838 .28924 .78062 .28464 Metetra
.663 .742 .908 r
.78062 .28464 .7838 .28924 .79666 .28492 .79351 .2803 Metetra
.663 .742 .908 r
.79351 .2803 .79666 .28492 .80958 .28058 .80646 .27593 Metetra
.663 .742 .908 r
.80646 .27593 .80958 .28058 .82257 .27621 .81947 .27155 Metetra
.663 .742 .908 r
.81947 .27155 .82257 .27621 .83561 .27183 .83254 .26714 Metetra
.646 .762 .933 r
.23642 .65017 .24078 .65372 .25194 .65038 .24759 .64681 Metetra
.831 .775 .799 r
.24759 .64681 .25194 .65038 .26315 .64703 .25958 .63392 Metetra
.837 .637 .632 r
.25958 .63392 .26315 .64703 .27823 .5931 .27399 .58943 Metetra
.691 .765 .909 r
.27399 .58943 .27823 .5931 .28946 .58849 .28524 .58481 Metetra
.651 .756 .926 r
.28524 .58481 .28946 .58849 .30065 .58503 .29645 .58133 Metetra
.651 .756 .926 r
.29645 .58133 .30065 .58503 .31189 .58156 .30771 .57784 Metetra
.651 .756 .926 r
.30771 .57784 .31189 .58156 .32318 .57806 .31902 .57433 Metetra
.651 .756 .926 r
.31902 .57433 .32318 .57806 .33453 .57456 .33038 .57081 Metetra
.849 .774 .778 r
.33038 .57081 .33453 .57456 .34592 .57103 .34244 .55582 Metetra
.605 .484 .688 r
.34244 .55582 .34592 .57103 .35737 .56749 .35386 .55225 Metetra
.699 .544 .673 r
.35386 .55225 .35737 .56749 .36942 .55248 .36582 .53889 Metetra
.611 .5 .703 r
.36582 .53889 .36942 .55248 .38093 .54889 .37732 .53528 Metetra
.701 .556 .686 r
.37732 .53528 .38093 .54889 .3929 .53551 .38923 .52321 Metetra
.616 .517 .718 r
.38923 .52321 .3929 .53551 .40448 .53188 .4008 .51955 Metetra
.616 .517 .718 r
.4008 .51955 .40448 .53188 .41611 .52824 .41242 .51588 Metetra
.616 .517 .718 r
.41242 .51588 .41611 .52824 .42805 .51612 .4241 .51219 Metetra
.654 .753 .923 r
.4241 .51219 .42805 .51612 .43977 .51243 .43583 .50848 Metetra
.654 .753 .923 r
.43583 .50848 .43977 .51243 .45153 .50872 .44761 .50476 Metetra
.654 .753 .923 r
.44761 .50476 .45153 .50872 .46335 .505 .45945 .50102 Metetra
.654 .753 .923 r
.45945 .50102 .46335 .505 .47541 .48926 .47134 .49726 Metetra
.361 0 .166 r
.47134 .49726 .47541 .48926 .48729 .48549 .48329 .49348 Metetra
.361 0 .166 r
.48329 .49348 .48729 .48549 .49924 .47981 .49529 .48969 Metetra
.4 .042 .237 r
.49529 .48969 .49924 .47981 .51122 .476 .50735 .48588 Metetra
0 0 .041 r
.50735 .48588 .51122 .476 .52326 .47217 .51948 .46999 Metetra
.625 .856 .986 r
.51948 .46999 .52326 .47217 .53533 .46102 .53161 .46613 Metetra
.139 0 0 r
.53161 .46613 .53533 .46102 .54739 .44889 .54378 .46034 Metetra
.422 .081 .28 r
.54378 .46034 .54739 .44889 .55954 .44499 .55601 .45645 Metetra
.422 .081 .28 r
.55601 .45645 .55954 .44499 .57168 .43689 .56829 .45253 Metetra
.331 .038 .308 r
.56829 .45253 .57168 .43689 .58392 .43296 .5805 .44124 Metetra
.369 0 .182 r
.5805 .44124 .58392 .43296 .59613 .4252 .59288 .43728 Metetra
.231 0 .222 r
.59288 .43728 .59613 .4252 .60839 .41823 .60509 .42499 Metetra
.325 0 .107 r
.60509 .42499 .60839 .41823 .62009 .39244 .61754 .42098 Metetra
.466 .202 .428 r
.61754 .42098 .62009 .39244 .63213 .37941 .62991 .41274 Metetra
.507 .243 .45 r
.62991 .41274 .63213 .37941 .64443 .37355 .64247 .4087 Metetra
.509 .247 .454 r
.64247 .4087 .64443 .37355 .65654 .36229 .65508 .40463 Metetra
.48 .233 .462 r
.65508 .40463 .65654 .36229 .66856 .34926 .66743 .3937 Metetra
.452 .213 .46 r
.66743 .3937 .66856 .34926 .6808 .34068 .67948 .37676 Metetra
.192 .006 .384 r
.67948 .37676 .6808 .34068 .69295 .33 .68993 .33206 Metetra
.68993 .33206 .69295 .33 .70535 .32347 .70253 .32786 Metetra
.209 0 0 r
.70253 .32786 .70535 .32347 .7179 .31863 .71518 .32364 Metetra
.71518 .32364 .7179 .31863 .73028 .31061 .72698 .30608 Metetra
.663 .743 .909 r
.72698 .30608 .73028 .31061 .74297 .30635 .73969 .3018 Metetra
.841 .794 .806 r
.73969 .3018 .74297 .30635 .75571 .30208 .75178 .28868 Metetra
.617 .509 .709 r
.75178 .28868 .75571 .30208 .76803 .2919 .76457 .28436 Metetra
.648 .624 .812 r
.76457 .28436 .76803 .2919 .78062 .28464 .77743 .28002 Metetra
.663 .742 .908 r
.77743 .28002 .78062 .28464 .79351 .2803 .79034 .27565 Metetra
.663 .742 .908 r
.79034 .27565 .79351 .2803 .80646 .27593 .80331 .27127 Metetra
.663 .742 .908 r
.80331 .27127 .80646 .27593 .81947 .27155 .81635 .26686 Metetra
.663 .742 .908 r
.81635 .26686 .81947 .27155 .83254 .26714 .82944 .26243 Metetra
.646 .762 .933 r
.23203 .6466 .23642 .65017 .24759 .64681 .24322 .64323 Metetra
.831 .775 .799 r
.24322 .64323 .24759 .64681 .25958 .63392 .25525 .6303 Metetra
.902 .746 .678 r
.25525 .6303 .25958 .63392 .27399 .58943 .26873 .59857 Metetra
.192 0 .096 r
.26873 .59857 .27399 .58943 .28524 .58481 .2803 .59043 Metetra
.2803 .59043 .28524 .58481 .29645 .58133 .29223 .57761 Metetra
.651 .756 .926 r
.29223 .57761 .29645 .58133 .30771 .57784 .3035 .5741 Metetra
.651 .756 .926 r
.3035 .5741 .30771 .57784 .31902 .57433 .31483 .57058 Metetra
.651 .756 .926 r
.31483 .57058 .31902 .57433 .33038 .57081 .32621 .56704 Metetra
.651 .756 .926 r
.32621 .56704 .33038 .57081 .34244 .55582 .33764 .56348 Metetra
.348 0 .141 r
.33764 .56348 .34244 .55582 .35386 .55225 .34913 .5599 Metetra
.348 0 .141 r
.34913 .5599 .35386 .55225 .36582 .53889 .36066 .55631 Metetra
.467 .163 .366 r
.36066 .55631 .36582 .53889 .37732 .53528 .37225 .55271 Metetra
.467 .163 .366 r
.37225 .55271 .37732 .53528 .38923 .52321 .38389 .54908 Metetra
.494 .217 .422 r
.38389 .54908 .38923 .52321 .4008 .51955 .39559 .54544 Metetra
.365 .104 .379 r
.39559 .54544 .4008 .51955 .41242 .51588 .40776 .53024 Metetra
.448 .128 .329 r
.40776 .53024 .41242 .51588 .4241 .51219 .41952 .52656 Metetra
.221 0 .234 r
.41952 .52656 .4241 .51219 .43583 .50848 .43162 .51301 Metetra
.172 0 0 r
.43162 .51301 .43583 .50848 .44761 .50476 .44347 .50883 Metetra
.44347 .50883 .44761 .50476 .45945 .50102 .45553 .49702 Metetra
.654 .753 .923 r
.45553 .49702 .45945 .50102 .47134 .49726 .46744 .49324 Metetra
.654 .753 .923 r
.46744 .49324 .47134 .49726 .48329 .49348 .47941 .48945 Metetra
.654 .753 .923 r
.47941 .48945 .48329 .49348 .49529 .48969 .49144 .48564 Metetra
.654 .753 .923 r
.49144 .48564 .49529 .48969 .50735 .48588 .50352 .48181 Metetra
.654 .753 .923 r
.50352 .48181 .50735 .48588 .51948 .46999 .51565 .47796 Metetra
.358 0 .162 r
.51565 .47796 .51948 .46999 .53161 .46613 .52784 .47409 Metetra
.358 0 .162 r
.52784 .47409 .53161 .46613 .54378 .46034 .54009 .47021 Metetra
0 0 .05 r
.54009 .47021 .54378 .46034 .55601 .45645 .55229 .45419 Metetra
.711 .878 .959 r
.55229 .45419 .55601 .45645 .56829 .45253 .56458 .44834 Metetra
.655 .752 .921 r
.56458 .44834 .56829 .45253 .5805 .44124 .57695 .44439 Metetra
.085 0 0 r
.57695 .44439 .5805 .44124 .59288 .43728 .58937 .44042 Metetra
.085 0 0 r
.58937 .44042 .59288 .43728 .60509 .42499 .60186 .43643 Metetra
.42 .078 .277 r
.60186 .43643 .60509 .42499 .61754 .42098 .6144 .43242 Metetra
.238 0 .212 r
.6144 .43242 .61754 .42098 .62991 .41274 .62676 .42099 Metetra
.059 0 .053 r
.62676 .42099 .62991 .41274 .64247 .4087 .63907 .40859 Metetra
.422 .866 .886 r
.63907 .40859 .64247 .4087 .65508 .40463 .65173 .4045 Metetra
.684 .976 .902 r
.65173 .4045 .65508 .40463 .66743 .3937 .66427 .3967 Metetra
.038 0 0 r
.66427 .3967 .66743 .3937 .67948 .37676 .67701 .39204 Metetra
.454 .141 .344 r
.67701 .39204 .67948 .37676 .68993 .33206 .68983 .3879 Metetra
.421 .198 .467 r
.68983 .3879 .68993 .33206 .70253 .32786 .70128 .35942 Metetra
.472 .212 .438 r
.70128 .35942 .70253 .32786 .71518 .32364 .71382 .35065 Metetra
.495 .222 .428 r
.71382 .35065 .71518 .32364 .72698 .30608 .7267 .34642 Metetra
.463 .218 .456 r
.7267 .34642 .72698 .30608 .73969 .3018 .73898 .33307 Metetra
.283 .069 .401 r
.73898 .33307 .73969 .3018 .75178 .28868 .74988 .3018 Metetra
.358 .049 .297 r
.74988 .3018 .75178 .28868 .76457 .28436 .76241 .29302 Metetra
.252 0 .167 r
.76241 .29302 .76457 .28436 .77743 .28002 .77497 .28422 Metetra
.77497 .28422 .77743 .28002 .79034 .27565 .78755 .27541 Metetra
.709 .985 .876 r
.78755 .27541 .79034 .27565 .80331 .27127 .80015 .26658 Metetra
.663 .742 .908 r
.80015 .26658 .80331 .27127 .81635 .26686 .81321 .26215 Metetra
.663 .742 .908 r
.81321 .26215 .81635 .26686 .82944 .26243 .82634 .2577 Metetra
.646 .762 .933 r
.22762 .64301 .23203 .6466 .24322 .64323 .23883 .63962 Metetra
.646 .762 .933 r
.23883 .63962 .24322 .64323 .25525 .6303 .2501 .63622 Metetra
.2501 .63622 .25525 .6303 .26873 .59857 .26217 .62324 Metetra
0 0 .197 r
.26217 .62324 .26873 .59857 .2803 .59043 .27567 .5914 Metetra
.931 .929 .781 r
.27567 .5914 .2803 .59043 .29223 .57761 .28798 .57388 Metetra
.651 .756 .926 r
.28798 .57388 .29223 .57761 .3035 .5741 .29928 .57035 Metetra
.651 .756 .926 r
.29928 .57035 .3035 .5741 .31483 .57058 .31063 .56681 Metetra
.651 .756 .926 r
.31063 .56681 .31483 .57058 .32621 .56704 .32202 .56325 Metetra
.651 .756 .926 r
.32202 .56325 .32621 .56704 .33764 .56348 .33347 .55967 Metetra
.651 .756 .926 r
.33347 .55967 .33764 .56348 .34913 .5599 .34498 .55608 Metetra
.792 .78 .842 r
.34498 .55608 .34913 .5599 .36066 .55631 .35683 .54662 Metetra
.682 .588 .745 r
.35683 .54662 .36066 .55631 .37225 .55271 .36859 .53949 Metetra
.64 .523 .705 r
.36859 .53949 .37225 .55271 .38389 .54908 .38032 .53368 Metetra
.699 .543 .672 r
.38032 .53368 .38389 .54908 .39559 .54544 .3924 .52018 Metetra
.588 .427 .631 r
.3924 .52018 .39559 .54544 .40776 .53024 .40411 .51604 Metetra
.609 .495 .699 r
.40411 .51604 .40776 .53024 .41952 .52656 .41585 .51232 Metetra
.694 .548 .684 r
.41585 .51232 .41952 .52656 .43162 .51301 .42789 .50054 Metetra
.615 .516 .719 r
.42789 .50054 .43162 .51301 .44347 .50883 .43972 .49678 Metetra
.617 .522 .724 r
.43972 .49678 .44347 .50883 .45553 .49702 .45159 .493 Metetra
.654 .753 .923 r
.45159 .493 .45553 .49702 .46744 .49324 .46353 .4892 Metetra
.654 .753 .923 r
.46353 .4892 .46744 .49324 .47941 .48945 .47552 .48539 Metetra
.654 .753 .923 r
.47552 .48539 .47941 .48945 .49144 .48564 .48756 .48156 Metetra
.654 .753 .923 r
.48756 .48156 .49144 .48564 .50352 .48181 .49966 .47771 Metetra
.875 .784 .756 r
.49966 .47771 .50352 .48181 .51565 .47796 .51187 .45984 Metetra
.598 .463 .668 r
.51187 .45984 .51565 .47796 .52784 .47409 .52403 .45594 Metetra
.598 .463 .668 r
.52403 .45594 .52784 .47409 .54009 .47021 .53625 .45203 Metetra
.698 .528 .654 r
.53625 .45203 .54009 .47021 .55229 .45419 .54842 .43612 Metetra
.634 .487 .665 r
.54842 .43612 .55229 .45419 .56458 .44834 .56066 .42847 Metetra
.632 .477 .654 r
.56066 .42847 .56458 .44834 .57695 .44439 .57292 .42027 Metetra
.587 .431 .637 r
.57292 .42027 .57695 .44439 .58937 .44042 .58529 .41626 Metetra
.587 .431 .637 r
.58529 .41626 .58937 .44042 .60186 .43643 .59771 .41222 Metetra
.685 .498 .627 r
.59771 .41222 .60186 .43643 .6144 .43242 .60977 .39311 Metetra
.614 .421 .597 r
.60977 .39311 .6144 .43242 .62676 .42099 .62196 .37992 Metetra
.63 .43 .594 r
.62196 .37992 .62676 .42099 .63907 .40859 .63396 .36223 Metetra
.586 .394 .588 r
.63396 .36223 .63907 .40859 .65173 .4045 .64628 .35358 Metetra
.583 .388 .583 r
.64628 .35358 .65173 .4045 .66427 .3967 .65862 .34492 Metetra
.598 .398 .582 r
.65862 .34492 .66427 .3967 .67701 .39204 .67076 .33177 Metetra
.577 .378 .575 r
.67076 .33177 .67701 .39204 .68983 .3879 .68312 .32309 Metetra
.595 .389 .572 r
.68312 .32309 .68983 .3879 .70128 .35942 .69509 .3073 Metetra
.572 .379 .581 r
.69509 .3073 .70128 .35942 .71382 .35065 .70763 .30125 Metetra
.566 .377 .584 r
.70763 .30125 .71382 .35065 .7267 .34642 .72033 .29696 Metetra
.583 .389 .584 r
.72033 .29696 .7267 .34642 .73898 .33307 .73278 .28821 Metetra
.569 .382 .589 r
.73278 .28821 .73898 .33307 .74988 .3018 .74558 .28387 Metetra
.643 .493 .664 r
.74558 .28387 .74988 .3018 .76241 .29302 .75809 .27509 Metetra
.601 .466 .669 r
.75809 .27509 .76241 .29302 .77497 .28422 .77099 .2707 Metetra
.616 .509 .709 r
.77099 .2707 .77497 .28422 .78755 .27541 .78395 .26629 Metetra
.639 .585 .778 r
.78395 .26629 .78755 .27541 .80015 .26658 .79698 .26186 Metetra
.663 .742 .908 r
.79698 .26186 .80015 .26658 .81321 .26215 .81006 .25741 Metetra
.663 .742 .908 r
.81006 .25741 .81321 .26215 .82634 .2577 .82321 .25294 Metetra
.646 .762 .933 r
.2232 .63941 .22762 .64301 .23883 .63962 .23442 .636 Metetra
.646 .762 .933 r
.23442 .636 .23883 .63962 .2501 .63622 .2457 .63259 Metetra
.773 .781 .859 r
.2457 .63259 .2501 .63622 .26217 .62324 .25742 .62436 Metetra
.716 .986 .881 r
.25742 .62436 .26217 .62324 .27567 .5914 .26916 .61611 Metetra
0 0 .197 r
.26916 .61611 .27567 .5914 .28798 .57388 .28268 .58417 Metetra
.28268 .58417 .28798 .57388 .29928 .57035 .29503 .56658 Metetra
.651 .756 .926 r
.29503 .56658 .29928 .57035 .31063 .56681 .3064 .56302 Metetra
.651 .756 .926 r
.3064 .56302 .31063 .56681 .32202 .56325 .31781 .55944 Metetra
.651 .756 .926 r
.31781 .55944 .32202 .56325 .33347 .55967 .32928 .55585 Metetra
.651 .756 .926 r
.32928 .55585 .33347 .55967 .34498 .55608 .3408 .55224 Metetra
.851 .776 .778 r
.3408 .55224 .34498 .55608 .35683 .54662 .35299 .5371 Metetra
.628 .563 .763 r
.35299 .5371 .35683 .54662 .36859 .53949 .36458 .53344 Metetra
.648 .66 .848 r
.36458 .53344 .36859 .53949 .38032 .53368 .37622 .52977 Metetra
.839 .78 .795 r
.37622 .52977 .38032 .53368 .3924 .52018 .38833 .51624 Metetra
.669 .759 .918 r
.38833 .51624 .3924 .52018 .40411 .51604 .40006 .51208 Metetra
.653 .754 .924 r
.40006 .51208 .40411 .51604 .41585 .51232 .41182 .50835 Metetra
.653 .754 .924 r
.41182 .50835 .41585 .51232 .42789 .50054 .42364 .5046 Metetra
.156 0 0 r
.42364 .5046 .42789 .50054 .43972 .49678 .43551 .50083 Metetra
.504 .824 .515 r
.43551 .50083 .43972 .49678 .45159 .493 .44764 .48896 Metetra
.654 .753 .923 r
.44764 .48896 .45159 .493 .46353 .4892 .45959 .48514 Metetra
.654 .753 .923 r
.45959 .48514 .46353 .4892 .47552 .48539 .4716 .48131 Metetra
.654 .753 .923 r
.4716 .48131 .47552 .48539 .48756 .48156 .48367 .47746 Metetra
.654 .753 .923 r
.48367 .47746 .48756 .48156 .49966 .47771 .49579 .4736 Metetra
.654 .753 .923 r
.49579 .4736 .49966 .47771 .51187 .45984 .50797 .46971 Metetra
.50797 .46971 .51187 .45984 .52403 .45594 .52022 .45177 Metetra
.886 .783 .741 r
.52022 .45177 .52403 .45594 .53625 .45203 .53241 .43218 Metetra
.594 .452 .657 r
.53241 .43218 .53625 .45203 .54842 .43612 .54464 .42821 Metetra
.659 .617 .796 r
.54464 .42821 .54842 .43612 .56066 .42847 .55692 .4233 Metetra
.735 .733 .85 r
.55692 .4233 .56066 .42847 .57292 .42027 .56922 .416 Metetra
.796 .786 .843 r
.56922 .416 .57292 .42027 .58529 .41626 .5815 .40606 Metetra
.695 .593 .738 r
.5815 .40606 .58529 .41626 .59771 .41222 .59382 .39742 Metetra
.795 .604 .643 r
.59382 .39742 .59771 .41222 .60977 .39311 .60561 .36874 Metetra
.607 .443 .634 r
.60561 .36874 .60977 .39311 .62196 .37992 .61795 .36197 Metetra
.643 .492 .664 r
.61795 .36197 .62196 .37992 .63396 .36223 .63025 .35332 Metetra
.709 .621 .757 r
.63025 .35332 .63396 .36223 .64628 .35358 .64258 .34465 Metetra
.785 .656 .721 r
.64258 .34465 .64628 .35358 .65862 .34492 .65463 .32907 Metetra
.629 .496 .682 r
.65463 .32907 .65862 .34492 .67076 .33177 .66708 .32282 Metetra
.638 .585 .779 r
.66708 .32282 .67076 .33177 .68312 .32309 .67969 .31857 Metetra
.662 .744 .911 r
.67969 .31857 .68312 .32309 .69509 .3073 .69235 .3143 Metetra
.157 0 .055 r
.69235 .3143 .69509 .3073 .70763 .30125 .7048 .30556 Metetra
.7048 .30556 .70763 .30125 .72033 .29696 .71699 .29236 Metetra
.799 .786 .84 r
.71699 .29236 .72033 .29696 .73278 .28821 .72936 .28212 Metetra
.722 .703 .832 r
.72936 .28212 .73278 .28821 .74558 .28387 .74196 .27481 Metetra
.638 .585 .778 r
.74196 .27481 .74558 .28387 .75809 .27509 .75482 .27042 Metetra
.663 .742 .908 r
.75482 .27042 .75809 .27509 .77099 .2707 .76775 .26601 Metetra
.663 .742 .908 r
.76775 .26601 .77099 .2707 .78395 .26629 .78074 .26158 Metetra
.663 .742 .908 r
.78074 .26158 .78395 .26629 .79698 .26186 .79379 .25713 Metetra
.663 .742 .908 r
.79379 .25713 .79698 .26186 .81006 .25741 .8069 .25265 Metetra
.663 .742 .908 r
.8069 .25265 .81006 .25741 .82321 .25294 .82007 .24816 Metetra
.646 .762 .933 r
.21875 .63578 .2232 .63941 .23442 .636 .22999 .63237 Metetra
.646 .762 .933 r
.22999 .63237 .23442 .636 .2457 .63259 .24129 .62893 Metetra
.832 .776 .799 r
.24129 .62893 .2457 .63259 .25742 .62436 .25343 .61589 Metetra
.869 .68 .644 r
.25343 .61589 .25742 .62436 .26916 .61611 .26779 .57457 Metetra
.591 .402 .594 r
.26779 .57457 .26916 .61611 .28268 .58417 .27944 .56635 Metetra
.596 .461 .667 r
.27944 .56635 .28268 .58417 .29503 .56658 .29077 .56279 Metetra
.651 .756 .926 r
.29077 .56279 .29503 .56658 .3064 .56302 .30215 .55921 Metetra
.651 .756 .926 r
.30215 .55921 .3064 .56302 .31781 .55944 .31359 .55562 Metetra
.849 .774 .778 r
.31359 .55562 .31781 .55944 .32928 .55585 .32578 .54051 Metetra
.604 .482 .687 r
.32578 .54051 .32928 .55585 .3408 .55224 .33728 .53687 Metetra
.604 .482 .687 r
.33728 .53687 .3408 .55224 .35299 .5371 .34884 .53321 Metetra
.653 .755 .925 r
.34884 .53321 .35299 .5371 .36458 .53344 .36044 .52954 Metetra
.842 .778 .79 r
.36044 .52954 .36458 .53344 .37622 .52977 .37259 .51556 Metetra
.694 .548 .684 r
.37259 .51556 .37622 .52977 .38833 .51624 .38462 .5038 Metetra
.615 .516 .719 r
.38462 .5038 .38833 .51624 .40006 .51208 .39632 .50005 Metetra
.617 .522 .724 r
.39632 .50005 .40006 .51208 .41182 .50835 .40807 .49629 Metetra
.617 .522 .724 r
.40807 .49629 .41182 .50835 .42364 .5046 .41988 .49251 Metetra
.617 .522 .724 r
.41988 .49251 .42364 .5046 .43551 .50083 .43174 .48871 Metetra
.617 .522 .724 r
.43174 .48871 .43551 .50083 .44764 .48896 .44366 .4849 Metetra
.654 .753 .923 r
.44366 .4849 .44764 .48896 .45959 .48514 .45564 .48107 Metetra
.873 .78 .756 r
.45564 .48107 .45959 .48514 .4716 .48131 .46792 .46323 Metetra
.597 .462 .668 r
.46792 .46323 .4716 .48131 .48367 .47746 .47995 .45934 Metetra
.625 .48 .665 r
.47995 .45934 .48367 .47746 .49579 .4736 .49206 .45272 Metetra
.689 .511 .641 r
.49206 .45272 .49579 .4736 .50797 .46971 .50428 .43588 Metetra
.574 .399 .607 r
.50428 .43588 .50797 .46971 .52022 .45177 .51642 .43193 Metetra
.603 .457 .656 r
.51642 .43193 .52022 .45177 .53241 .43218 .52862 .42703 Metetra
.82 .752 .788 r
.52862 .42703 .53241 .43218 .54464 .42821 .54082 .41386 Metetra
.824 .623 .631 r
.54082 .41386 .54464 .42821 .55692 .4233 .55278 .3781 Metetra
.605 .408 .588 r
.55278 .3781 .55692 .4233 .56922 .416 .56486 .36508 Metetra
.564 .373 .581 r
.56486 .36508 .56922 .416 .5815 .40606 .57708 .36098 Metetra
.567 .38 .588 r
.57708 .36098 .5815 .40606 .59382 .39742 .58936 .35686 Metetra
.57 .387 .594 r
.58936 .35686 .59382 .39742 .60561 .36874 .6017 .35272 Metetra
.605 .48 .683 r
.6017 .35272 .60561 .36874 .61795 .36197 .61409 .34856 Metetra
.668 .54 .699 r
.61409 .34856 .61795 .36197 .63025 .35332 .62639 .3399 Metetra
.645 .526 .704 r
.62639 .3399 .63025 .35332 .64258 .34465 .63878 .33329 Metetra
.708 .584 .715 r
.63878 .33329 .64258 .34465 .65463 .32907 .65104 .32255 Metetra
.653 .656 .841 r
.65104 .32255 .65463 .32907 .66708 .32282 .66361 .3183 Metetra
.662 .744 .911 r
.66361 .3183 .66708 .32282 .67969 .31857 .67624 .31403 Metetra
.84 .792 .805 r
.67624 .31403 .67969 .31857 .69235 .3143 .68843 .30083 Metetra
.615 .508 .709 r
.68843 .30083 .69235 .3143 .7048 .30556 .70114 .29652 Metetra
.709 .621 .757 r
.70114 .29652 .7048 .30556 .71699 .29236 .71362 .28774 Metetra
.773 .779 .858 r
.71362 .28774 .71699 .29236 .72936 .28212 .72612 .27895 Metetra
.792 .86 .9 r
.72612 .27895 .72936 .28212 .74196 .27481 .73865 .27014 Metetra
.663 .742 .908 r
.73865 .27014 .74196 .27481 .75482 .27042 .75154 .26573 Metetra
.663 .742 .908 r
.75154 .26573 .75482 .27042 .76775 .26601 .76449 .26129 Metetra
.663 .742 .908 r
.76449 .26129 .76775 .26601 .78074 .26158 .7775 .25684 Metetra
.663 .742 .908 r
.7775 .25684 .78074 .26158 .79379 .25713 .79058 .25236 Metetra
.663 .742 .908 r
.79058 .25236 .79379 .25713 .8069 .25265 .80372 .24787 Metetra
.663 .742 .908 r
.80372 .24787 .8069 .25265 .82007 .24816 .81692 .24335 Metetra
.646 .762 .933 r
.21428 .63215 .21875 .63578 .22999 .63237 .22554 .62871 Metetra
.831 .775 .799 r
.22554 .62871 .22999 .63237 .24129 .62893 .23769 .61567 Metetra
.831 .634 .636 r
.23769 .61567 .24129 .62893 .25343 .61589 .2522 .57434 Metetra
.591 .402 .594 r
.2522 .57434 .25343 .61589 .26779 .57457 .26384 .56612 Metetra
.632 .585 .783 r
.26384 .56612 .26779 .57457 .27944 .56635 .27514 .56256 Metetra
.651 .756 .926 r
.27514 .56256 .27944 .56635 .29077 .56279 .28648 .55898 Metetra
.651 .756 .926 r
.28648 .55898 .29077 .56279 .30215 .55921 .29788 .55539 Metetra
.849 .773 .777 r
.29788 .55539 .30215 .55921 .31359 .55562 .3101 .54027 Metetra
.603 .482 .687 r
.3101 .54027 .31359 .55562 .32578 .54051 .32157 .53663 Metetra
.653 .755 .925 r
.32157 .53663 .32578 .54051 .33728 .53687 .33309 .53297 Metetra
.653 .755 .925 r
.33309 .53297 .33728 .53687 .34884 .53321 .34466 .5293 Metetra
.653 .755 .925 r
.34466 .5293 .34884 .53321 .36044 .52954 .35628 .52561 Metetra
.653 .755 .925 r
.35628 .52561 .36044 .52954 .37259 .51556 .36796 .5219 Metetra
.36796 .5219 .37259 .51556 .38462 .5038 .38014 .50831 Metetra
.507 .82 .501 r
.38014 .50831 .38462 .5038 .39632 .50005 .39224 .49605 Metetra
.654 .753 .923 r
.39224 .49605 .39632 .50005 .40807 .49629 .40402 .49227 Metetra
.654 .753 .923 r
.40402 .49227 .40807 .49629 .41988 .49251 .41585 .48847 Metetra
.654 .753 .923 r
.41585 .48847 .41988 .49251 .43174 .48871 .42773 .48465 Metetra
.815 .783 .823 r
.42773 .48465 .43174 .48871 .44366 .4849 .43987 .47338 Metetra
.703 .578 .713 r
.43987 .47338 .44366 .4849 .45564 .48107 .45198 .46298 Metetra
.625 .48 .665 r
.45198 .46298 .45564 .48107 .46792 .46323 .46403 .45637 Metetra
.646 .638 .828 r
.46403 .45637 .46792 .46323 .47995 .45934 .47607 .45247 Metetra
.779 .69 .766 r
.47607 .45247 .47995 .45934 .49206 .45272 .48827 .44028 Metetra
.676 .554 .709 r
.48827 .44028 .49206 .45272 .50428 .43588 .50043 .43167 Metetra
.846 .785 .793 r
.50043 .43167 .50428 .43588 .51642 .43193 .51262 .41761 Metetra
.766 .59 .66 r
.51262 .41761 .51642 .43193 .52862 .42703 .5248 .3954 Metetra
.638 .448 .61 r
.5248 .3954 .52862 .42703 .54082 .41386 .53691 .38048 Metetra
.59 .411 .607 r
.53691 .38048 .54082 .41386 .55278 .3781 .54907 .37377 Metetra
.836 .785 .802 r
.54907 .37377 .55278 .3781 .56486 .36508 .56118 .36071 Metetra
.661 .745 .913 r
.56118 .36071 .56486 .36508 .57708 .36098 .57342 .35659 Metetra
.661 .745 .913 r
.57342 .35659 .57708 .36098 .58936 .35686 .58572 .35245 Metetra
.742 .77 .876 r
.58572 .35245 .58936 .35686 .6017 .35272 .598 .34531 Metetra
.748 .67 .774 r
.598 .34531 .6017 .35272 .61409 .34856 .61023 .33517 Metetra
.614 .508 .709 r
.61023 .33517 .61409 .34856 .62639 .3399 .62267 .33096 Metetra
.709 .621 .757 r
.62267 .33096 .62639 .3399 .63878 .33329 .63499 .32227 Metetra
.626 .543 .741 r
.63499 .32227 .63878 .33329 .65104 .32255 .64753 .31802 Metetra
.662 .744 .911 r
.64753 .31802 .65104 .32255 .66361 .3183 .66012 .31375 Metetra
.881 .792 .757 r
.66012 .31375 .66361 .3183 .67624 .31403 .6721 .29612 Metetra
.629 .484 .666 r
.6721 .29612 .67624 .31403 .68843 .30083 .68459 .28885 Metetra
.622 .529 .728 r
.68459 .28885 .68843 .30083 .70114 .29652 .69729 .28451 Metetra
.696 .571 .711 r
.69729 .28451 .70114 .29652 .71362 .28774 .70968 .27425 Metetra
.615 .508 .709 r
.70968 .27425 .71362 .28774 .72612 .27895 .72247 .26985 Metetra
.638 .585 .778 r
.72247 .26985 .72612 .27895 .73865 .27014 .73532 .26544 Metetra
.663 .742 .908 r
.73532 .26544 .73865 .27014 .75154 .26573 .74824 .26101 Metetra
.663 .742 .908 r
.74824 .26101 .75154 .26573 .76449 .26129 .76122 .25655 Metetra
.663 .742 .908 r
.76122 .25655 .76449 .26129 .7775 .25684 .77425 .25208 Metetra
.663 .742 .908 r
.77425 .25208 .7775 .25684 .79058 .25236 .78735 .24758 Metetra
.663 .742 .908 r
.78735 .24758 .79058 .25236 .80372 .24787 .80052 .24306 Metetra
.663 .742 .908 r
.80052 .24306 .80372 .24787 .81692 .24335 .81375 .23852 Metetra
.831 .775 .799 r
.20979 .62849 .21428 .63215 .22554 .62871 .22195 .61545 Metetra
.83 .633 .637 r
.22195 .61545 .22554 .62871 .23769 .61567 .23661 .57411 Metetra
.566 .382 .591 r
.23661 .57411 .23769 .61567 .2522 .57434 .24784 .57057 Metetra
.651 .757 .927 r
.24784 .57057 .2522 .57434 .26384 .56612 .25911 .56701 Metetra
.734 .987 .893 r
.25911 .56701 .26384 .56612 .27514 .56256 .27081 .55875 Metetra
.651 .756 .926 r
.27081 .55875 .27514 .56256 .28648 .55898 .28218 .55516 Metetra
.651 .756 .926 r
.28218 .55516 .28648 .55898 .29788 .55539 .2936 .55154 Metetra
.651 .756 .926 r
.2936 .55154 .29788 .55539 .3101 .54027 .30507 .54791 Metetra
.30507 .54791 .3101 .54027 .32157 .53663 .31734 .53274 Metetra
.653 .755 .925 r
.31734 .53274 .32157 .53663 .33309 .53297 .32887 .52906 Metetra
.653 .755 .925 r
.32887 .52906 .33309 .53297 .34466 .5293 .34046 .52537 Metetra
.653 .755 .925 r
.34046 .52537 .34466 .5293 .35628 .52561 .3521 .52166 Metetra
.653 .755 .925 r
.3521 .52166 .35628 .52561 .36796 .5219 .3638 .51793 Metetra
.888 .768 .723 r
.3638 .51793 .36796 .5219 .38014 .50831 .37641 .49581 Metetra
.614 .515 .719 r
.37641 .49581 .38014 .50831 .39224 .49605 .38815 .49202 Metetra
.654 .753 .923 r
.38815 .49202 .39224 .49605 .40402 .49227 .39994 .48822 Metetra
.654 .753 .923 r
.39994 .48822 .40402 .49227 .41585 .48847 .41179 .48441 Metetra
.654 .753 .923 r
.41179 .48441 .41585 .48847 .42773 .48465 .42369 .48057 Metetra
.654 .753 .923 r
.42369 .48057 .42773 .48465 .43987 .47338 .43565 .47672 Metetra
.074 0 0 r
.43565 .47672 .43987 .47338 .45198 .46298 .44767 .47285 Metetra
.122 0 .093 r
.44767 .47285 .45198 .46298 .46403 .45637 .45989 .46149 Metetra
.225 0 0 r
.45989 .46149 .46403 .45637 .47607 .45247 .47199 .45758 Metetra
.47199 .45758 .47607 .45247 .48827 .44028 .48426 .44434 Metetra
.48426 .44434 .48827 .44028 .50043 .43167 .49647 .43729 Metetra
.49647 .43729 .50043 .43167 .51262 .41761 .50874 .42345 Metetra
.266 0 .014 r
.50874 .42345 .51262 .41761 .5248 .3954 .52098 .41943 Metetra
.234 0 .328 r
.52098 .41943 .5248 .3954 .53691 .38048 .53321 .39613 Metetra
.447 .132 .337 r
.53321 .39613 .53691 .38048 .54907 .37377 .54549 .39206 Metetra
.096 0 .24 r
.54549 .39206 .54907 .37377 .56118 .36071 .5576 .36795 Metetra
.236 0 .074 r
.5576 .36795 .56118 .36071 .57342 .35659 .56988 .36164 Metetra
.199 0 0 r
.56988 .36164 .57342 .35659 .58572 .35245 .58223 .35702 Metetra
.193 0 0 r
.58223 .35702 .58572 .35245 .598 .34531 .59465 .35284 Metetra
.332 0 .131 r
.59465 .35284 .598 .34531 .61023 .33517 .60713 .34865 Metetra
.364 .046 .286 r
.60713 .34865 .61023 .33517 .62267 .33096 .61955 .34097 Metetra
.231 0 .171 r
.61955 .34097 .62267 .33096 .63499 .32227 .63193 .33119 Metetra
.368 0 .193 r
.63193 .33119 .63499 .32227 .64753 .31802 .64454 .32693 Metetra
.368 0 .193 r
.64454 .32693 .64753 .31802 .66012 .31375 .65722 .32265 Metetra
.368 0 .193 r
.65722 .32265 .66012 .31375 .6721 .29612 .66995 .31835 Metetra
.429 .15 .386 r
.66995 .31835 .6721 .29612 .68459 .28885 .6825 .30952 Metetra
.42 .137 .375 r
.6825 .30952 .68459 .28885 .69729 .28451 .69508 .30068 Metetra
.131 0 .256 r
.69508 .30068 .69729 .28451 .70968 .27425 .70684 .27843 Metetra
.045 0 0 r
.70684 .27843 .70968 .27425 .72247 .26985 .71955 .2718 Metetra
.568 .891 .626 r
.71955 .2718 .72247 .26985 .73532 .26544 .73198 .26072 Metetra
.663 .742 .908 r
.73198 .26072 .73532 .26544 .74824 .26101 .74492 .25627 Metetra
.663 .742 .908 r
.74492 .25627 .74824 .26101 .76122 .25655 .75792 .25179 Metetra
.663 .742 .908 r
.75792 .25179 .76122 .25655 .77425 .25208 .77099 .24729 Metetra
.663 .742 .908 r
.77099 .24729 .77425 .25208 .78735 .24758 .78411 .24277 Metetra
.663 .742 .908 r
.78411 .24277 .78735 .24758 .80052 .24306 .7973 .23823 Metetra
.663 .742 .908 r
.7973 .23823 .80052 .24306 .81375 .23852 .81056 .23366 Metetra
.561 .369 .579 r
.20987 .57741 .20979 .62849 .22195 .61545 .22101 .57389 Metetra
.566 .381 .591 r
.22101 .57389 .22195 .61545 .23661 .57411 .23221 .57034 Metetra
.651 .757 .927 r
.23221 .57034 .23661 .57411 .24784 .57057 .24345 .56678 Metetra
.651 .757 .927 r
.24345 .56678 .24784 .57057 .25911 .56701 .25474 .56321 Metetra
.772 .776 .856 r
.25474 .56321 .25911 .56701 .27081 .55875 .26647 .55492 Metetra
.651 .756 .926 r
.26647 .55492 .27081 .55875 .28218 .55516 .27785 .55131 Metetra
.651 .756 .926 r
.27785 .55131 .28218 .55516 .2936 .55154 .28929 .54768 Metetra
.651 .756 .926 r
.28929 .54768 .2936 .55154 .30507 .54791 .30078 .54403 Metetra
.849 .774 .778 r
.30078 .54403 .30507 .54791 .31734 .53274 .31308 .52883 Metetra
.653 .755 .925 r
.31308 .52883 .31734 .53274 .32887 .52906 .32463 .52513 Metetra
.653 .755 .925 r
.32463 .52513 .32887 .52906 .34046 .52537 .33624 .52142 Metetra
.653 .755 .925 r
.33624 .52142 .34046 .52537 .3521 .52166 .3479 .51769 Metetra
.887 .767 .723 r
.3479 .51769 .3521 .52166 .3638 .51793 .36057 .49556 Metetra
.586 .435 .642 r
.36057 .49556 .3638 .51793 .37641 .49581 .37227 .49178 Metetra
.654 .753 .923 r
.37227 .49178 .37641 .49581 .38815 .49202 .38403 .48798 Metetra
.654 .753 .923 r
.38403 .48798 .38815 .49202 .39994 .48822 .39585 .48416 Metetra
.654 .753 .923 r
.39585 .48416 .39994 .48822 .41179 .48441 .40771 .48032 Metetra
.896 .769 .713 r
.40771 .48032 .41179 .48441 .42369 .48057 .42029 .45669 Metetra
.73 .53 .621 r
.42029 .45669 .42369 .48057 .43565 .47672 .43292 .42839 Metetra
.582 .388 .583 r
.43292 .42839 .43565 .47672 .44767 .47285 .4449 .41991 Metetra
.561 .368 .577 r
.4449 .41991 .44767 .47285 .45989 .46149 .45681 .41595 Metetra
.564 .377 .585 r
.45681 .41595 .45989 .46149 .47199 .45758 .46877 .41197 Metetra
.564 .377 .585 r
.46877 .41197 .47199 .45758 .48426 .44434 .48078 .40798 Metetra
.639 .442 .6 r
.48078 .40798 .48426 .44434 .49647 .43729 .49299 .39037 Metetra
.564 .375 .584 r
.49299 .39037 .49647 .43729 .50874 .42345 .50507 .38632 Metetra
.616 .424 .599 r
.50507 .38632 .50874 .42345 .52098 .41943 .51722 .37324 Metetra
.564 .376 .585 r
.51722 .37324 .52098 .41943 .53321 .39613 .52937 .36915 Metetra
.581 .416 .624 r
.52937 .36915 .53321 .39613 .54549 .39206 .54158 .36503 Metetra
.605 .434 .623 r
.54158 .36503 .54549 .39206 .5576 .36795 .55381 .35744 Metetra
.644 .56 .746 r
.55381 .35744 .5576 .36795 .56988 .36164 .5661 .35225 Metetra
.704 .61 .75 r
.5661 .35225 .56988 .36164 .58223 .35702 .57838 .34358 Metetra
.613 .507 .709 r
.57838 .34358 .58223 .35702 .59465 .35284 .59078 .33938 Metetra
.712 .565 .688 r
.59078 .33938 .59465 .35284 .60713 .34865 .60301 .32619 Metetra
.625 .46 .64 r
.60301 .32619 .60713 .34865 .61955 .34097 .61535 .31748 Metetra
.587 .431 .638 r
.61535 .31748 .61955 .34097 .63193 .33119 .62787 .3132 Metetra
.63 .484 .665 r
.62787 .3132 .63193 .33119 .64454 .32693 .64032 .30572 Metetra
.646 .48 .643 r
.64032 .30572 .64454 .32693 .65722 .32265 .65265 .29466 Metetra
.603 .43 .62 r
.65265 .29466 .65722 .32265 .66995 .31835 .66514 .2869 Metetra
.576 .404 .611 r
.66514 .2869 .66995 .31835 .6825 .30952 .67784 .28253 Metetra
.581 .417 .624 r
.67784 .28253 .6825 .30952 .69508 .30068 .6906 .27815 Metetra
.624 .46 .639 r
.6906 .27815 .69508 .30068 .70684 .27843 .70315 .2693 Metetra
.709 .622 .758 r
.70315 .2693 .70684 .27843 .71955 .2718 .71572 .26044 Metetra
.625 .54 .739 r
.71572 .26044 .71955 .2718 .73198 .26072 .72863 .25598 Metetra
.663 .742 .908 r
.72863 .25598 .73198 .26072 .74492 .25627 .74159 .2515 Metetra
.663 .742 .908 r
.74159 .2515 .74492 .25627 .75792 .25179 .75462 .247 Metetra
.663 .742 .908 r
.75462 .247 .75792 .25179 .77099 .24729 .76771 .24248 Metetra
.663 .742 .908 r
.76771 .24248 .77099 .24729 .78411 .24277 .78086 .23793 Metetra
.663 .742 .908 r
.78086 .23793 .78411 .24277 .7973 .23823 .79407 .23337 Metetra
.663 .742 .908 r
.79407 .23337 .7973 .23823 .81056 .23366 .80735 .22878 Metetra
.651 .757 .927 r
.20541 .57366 .20987 .57741 .22101 .57389 .21657 .57011 Metetra
.772 .775 .855 r
.21657 .57011 .22101 .57389 .23221 .57034 .22821 .56187 Metetra
.632 .585 .783 r
.22821 .56187 .23221 .57034 .24345 .56678 .23945 .55829 Metetra
.632 .585 .783 r
.23945 .55829 .24345 .56678 .25474 .56321 .25075 .55469 Metetra
.632 .585 .783 r
.25075 .55469 .25474 .56321 .26647 .55492 .2621 .55108 Metetra
.651 .756 .926 r
.2621 .55108 .26647 .55492 .27785 .55131 .2735 .54745 Metetra
.651 .756 .926 r
.2735 .54745 .27785 .55131 .28929 .54768 .28496 .5438 Metetra
.651 .756 .926 r
.28496 .5438 .28929 .54768 .30078 .54403 .29646 .54013 Metetra
.651 .756 .926 r
.29646 .54013 .30078 .54403 .31308 .52883 .30802 .53645 Metetra
.326 0 .111 r
.30802 .53645 .31308 .52883 .32463 .52513 .31964 .53275 Metetra
.326 0 .111 r
.31964 .53275 .32463 .52513 .33624 .52142 .3313 .52904 Metetra
.3313 .52904 .33624 .52142 .3479 .51769 .34368 .51371 Metetra
.653 .755 .925 r
.34368 .51371 .3479 .51769 .36057 .49556 .35542 .50994 Metetra
.434 .107 .311 r
.35542 .50994 .36057 .49556 .37227 .49178 .36721 .50616 Metetra
.434 .107 .311 r
.36721 .50616 .37227 .49178 .38403 .48798 .37905 .50236 Metetra
.434 .107 .311 r
.37905 .50236 .38403 .48798 .39585 .48416 .39095 .49854 Metetra
.434 .107 .311 r
.39095 .49854 .39585 .48416 .40771 .48032 .40291 .49471 Metetra
.195 0 .209 r
.40291 .49471 .40771 .48032 .42029 .45669 .41526 .48091 Metetra
.378 .105 .367 r
.41526 .48091 .42029 .45669 .43292 .42839 .42756 .46846 Metetra
.504 .242 .452 r
.42756 .46846 .43292 .42839 .4449 .41991 .43962 .46455 Metetra
.507 .25 .459 r
.43962 .46455 .4449 .41991 .45681 .41595 .45173 .46062 Metetra
.347 .118 .417 r
.45173 .46062 .45681 .41595 .46877 .41197 .46437 .43204 Metetra
.218 0 .288 r
.46437 .43204 .46877 .41197 .48078 .40798 .47674 .41283 Metetra
.47674 .41283 .48078 .40798 .49299 .39037 .48892 .40423 Metetra
.334 .017 .269 r
.48892 .40423 .49299 .39037 .50507 .38632 .50112 .39561 Metetra
.369 0 .195 r
.50112 .39561 .50507 .38632 .51722 .37324 .51332 .39154 Metetra
.458 .154 .361 r
.51332 .39154 .51722 .37324 .52937 .36915 .52559 .38744 Metetra
.458 .154 .361 r
.52559 .38744 .52937 .36915 .54158 .36503 .53791 .38333 Metetra
.458 .154 .361 r
.53791 .38333 .54158 .36503 .55381 .35744 .55029 .3792 Metetra
.472 .18 .388 r
.55029 .3792 .55381 .35744 .5661 .35225 .56273 .37505 Metetra
.363 .093 .363 r
.56273 .37505 .5661 .35225 .57838 .34358 .57507 .36138 Metetra
.395 .098 .339 r
.57507 .36138 .57838 .34358 .59078 .33938 .58749 .35297 Metetra
.23 0 .235 r
.58749 .35297 .59078 .33938 .60301 .32619 .59982 .33967 Metetra
.426 .096 .302 r
.59982 .33967 .60301 .32619 .61535 .31748 .6124 .33542 Metetra
.456 .151 .359 r
.6124 .33542 .61535 .31748 .62787 .3132 .62504 .33114 Metetra
.456 .151 .359 r
.62504 .33114 .62787 .3132 .64032 .30572 .63774 .32685 Metetra
.469 .176 .385 r
.63774 .32685 .64032 .30572 .65265 .29466 .6505 .32253 Metetra
.408 .147 .403 r
.6505 .32253 .65265 .29466 .66514 .2869 .6629 .30913 Metetra
.444 .16 .386 r
.6629 .30913 .66514 .2869 .67784 .28253 .6756 .30198 Metetra
.319 .049 .337 r
.6756 .30198 .67784 .28253 .6906 .27815 .68789 .28686 Metetra
.359 0 .182 r
.68789 .28686 .6906 .27815 .70315 .2693 .7008 .28244 Metetra
.423 .092 .298 r
.7008 .28244 .70315 .2693 .71572 .26044 .71377 .278 Metetra
.394 .1 .343 r
.71377 .278 .71572 .26044 .72863 .25598 .72649 .26904 Metetra
.244 0 .248 r
.72649 .26904 .72863 .25598 .74159 .2515 .7389 .25561 Metetra
.7389 .25561 .74159 .2515 .75462 .247 .75164 .24663 Metetra
.519 .915 .904 r
.75164 .24663 .75462 .247 .76771 .24248 .7647 .2412 Metetra
.741 .966 .936 r
.7647 .2412 .76771 .24248 .78086 .23793 .77758 .23307 Metetra
.663 .742 .908 r
.77758 .23307 .78086 .23793 .79407 .23337 .79083 .22849 Metetra
.663 .742 .908 r
.79083 .22849 .79407 .23337 .80735 .22878 .80413 .22387 Metetra
.772 .774 .855 r
.20093 .56989 .20541 .57366 .21657 .57011 .21256 .56164 Metetra
.632 .585 .784 r
.21256 .56164 .21657 .57011 .22821 .56187 .22377 .55806 Metetra
.651 .756 .926 r
.22377 .55806 .22821 .56187 .23945 .55829 .23503 .55446 Metetra
.651 .756 .926 r
.23503 .55446 .23945 .55829 .25075 .55469 .24635 .55085 Metetra
.651 .756 .926 r
.24635 .55085 .25075 .55469 .2621 .55108 .25771 .54721 Metetra
.651 .756 .926 r
.25771 .54721 .2621 .55108 .2735 .54745 .26913 .54356 Metetra
.651 .756 .926 r
.26913 .54356 .2735 .54745 .28496 .5438 .2806 .5399 Metetra
.651 .756 .926 r
.2806 .5399 .28496 .5438 .29646 .54013 .29213 .53622 Metetra
.651 .756 .926 r
.29213 .53622 .29646 .54013 .30802 .53645 .30371 .53252 Metetra
.651 .756 .926 r
.30371 .53252 .30802 .53645 .31964 .53275 .31534 .5288 Metetra
.651 .756 .926 r
.31534 .5288 .31964 .53275 .3313 .52904 .32703 .52506 Metetra
.651 .756 .926 r
.32703 .52506 .3313 .52904 .34368 .51371 .33877 .52131 Metetra
.322 0 .106 r
.33877 .52131 .34368 .51371 .35542 .50994 .35056 .51754 Metetra
.322 0 .106 r
.35056 .51754 .35542 .50994 .36721 .50616 .36241 .51376 Metetra
.322 0 .106 r
.36241 .51376 .36721 .50616 .37905 .50236 .37432 .50995 Metetra
.322 0 .106 r
.37432 .50995 .37905 .50236 .39095 .49854 .38628 .50613 Metetra
.322 0 .106 r
.38628 .50613 .39095 .49854 .40291 .49471 .3983 .50229 Metetra
.3983 .50229 .40291 .49471 .41526 .48091 .4108 .48674 Metetra
.252 0 0 r
.4108 .48674 .41526 .48091 .42756 .46846 .42289 .48285 Metetra
0 0 .081 r
.42289 .48285 .42756 .46846 .43962 .46455 .43556 .46037 Metetra
.654 .753 .923 r
.43556 .46037 .43962 .46455 .45173 .46062 .44769 .45642 Metetra
.654 .753 .923 r
.44769 .45642 .45173 .46062 .46437 .43204 .45988 .45245 Metetra
.45988 .45245 .46437 .43204 .47674 .41283 .47295 .3994 Metetra
.612 .506 .709 r
.47295 .3994 .47674 .41283 .48892 .40423 .48506 .39535 Metetra
.635 .585 .781 r
.48506 .39535 .48892 .40423 .50112 .39561 .49723 .39127 Metetra
.691 .759 .903 r
.49723 .39127 .50112 .39561 .51332 .39154 .50947 .38613 Metetra
.737 .727 .841 r
.50947 .38613 .51332 .39154 .52559 .38744 .52175 .3785 Metetra
.648 .592 .777 r
.52175 .3785 .52559 .38744 .53791 .38333 .53407 .37366 Metetra
.631 .569 .767 r
.53407 .37366 .53791 .38333 .55029 .3792 .54645 .3695 Metetra
.696 .603 .748 r
.54645 .3695 .55029 .3792 .56273 .37505 .55884 .36111 Metetra
.741 .58 .674 r
.55884 .36111 .56273 .37505 .57507 .36138 .57111 .34363 Metetra
.763 .57 .636 r
.57111 .34363 .57507 .36138 .58749 .35297 .58315 .31693 Metetra
.57 .391 .6 r
.58315 .31693 .58749 .35297 .59982 .33967 .5956 .31265 Metetra
.58 .416 .623 r
.5956 .31265 .59982 .33967 .6124 .33542 .6081 .30836 Metetra
.58 .416 .623 r
.6081 .30836 .6124 .33542 .62504 .33114 .62067 .30404 Metetra
.618 .442 .621 r
.62067 .30404 .62504 .33114 .63774 .32685 .63309 .29412 Metetra
.593 .413 .607 r
.63309 .29412 .63774 .32685 .6505 .32253 .64561 .28642 Metetra
.616 .424 .598 r
.64561 .28642 .6505 .32253 .6629 .30913 .65791 .27314 Metetra
.57 .391 .6 r
.65791 .27314 .6629 .30913 .6756 .30198 .67064 .26873 Metetra
.598 .415 .605 r
.67064 .26873 .6756 .30198 .68789 .28686 .68319 .25986 Metetra
.581 .416 .624 r
.68319 .25986 .68789 .28686 .7008 .28244 .69602 .2554 Metetra
.581 .416 .624 r
.69602 .2554 .7008 .28244 .71377 .278 .70891 .25092 Metetra
.581 .416 .624 r
.70891 .25092 .71377 .278 .72649 .26904 .72186 .24642 Metetra
.588 .436 .642 r
.72186 .24642 .72649 .26904 .7389 .25561 .73487 .24189 Metetra
.614 .507 .709 r
.73487 .24189 .7389 .25561 .75164 .24663 .74795 .23735 Metetra
.637 .585 .779 r
.74795 .23735 .75164 .24663 .7647 .2412 .76109 .23278 Metetra
.643 .608 .799 r
.76109 .23278 .7647 .2412 .77758 .23307 .77429 .22819 Metetra
.663 .742 .908 r
.77429 .22819 .77758 .23307 .79083 .22849 .78756 .22358 Metetra
.663 .742 .908 r
.78756 .22358 .79083 .22849 .80413 .22387 .80089 .21894 Metetra
.631 .585 .784 r
.1969 .56141 .20093 .56989 .21256 .56164 .20808 .55783 Metetra
.651 .756 .926 r
.20808 .55783 .21256 .56164 .22377 .55806 .21931 .55423 Metetra
.651 .756 .926 r
.21931 .55423 .22377 .55806 .23503 .55446 .23059 .55061 Metetra
.651 .756 .926 r
.23059 .55061 .23503 .55446 .24635 .55085 .24192 .54698 Metetra
.651 .756 .926 r
.24192 .54698 .24635 .55085 .25771 .54721 .2533 .54333 Metetra
.651 .756 .926 r
.2533 .54333 .25771 .54721 .26913 .54356 .26474 .53966 Metetra
.651 .756 .926 r
.26474 .53966 .26913 .54356 .2806 .5399 .27623 .53598 Metetra
.651 .756 .926 r
.27623 .53598 .2806 .5399 .29213 .53622 .28777 .53228 Metetra
.651 .756 .926 r
.28777 .53228 .29213 .53622 .30371 .53252 .29937 .52856 Metetra
.651 .756 .926 r
.29937 .52856 .30371 .53252 .31534 .5288 .31102 .52482 Metetra
.651 .756 .926 r
.31102 .52482 .31534 .5288 .32703 .52506 .32273 .52107 Metetra
.651 .756 .926 r
.32273 .52107 .32703 .52506 .33877 .52131 .33449 .5173 Metetra
.651 .756 .926 r
.33449 .5173 .33877 .52131 .35056 .51754 .3463 .51351 Metetra
.651 .756 .926 r
.3463 .51351 .35056 .51754 .36241 .51376 .35817 .50971 Metetra
.651 .756 .926 r
.35817 .50971 .36241 .51376 .37432 .50995 .3701 .50588 Metetra
.854 .781 .779 r
.3701 .50588 .37432 .50995 .38628 .50613 .38261 .49036 Metetra
.753 .576 .656 r
.38261 .49036 .38628 .50613 .3983 .50229 .39536 .46796 Metetra
.57 .394 .603 r
.39536 .46796 .3983 .50229 .4108 .48674 .40735 .46404 Metetra
.585 .433 .641 r
.40735 .46404 .4108 .48674 .42289 .48285 .41939 .46011 Metetra
.76 .554 .618 r
.41939 .46011 .42289 .48285 .43556 .46037 .43239 .4255 Metetra
.643 .446 .602 r
.43239 .4255 .43556 .46037 .44769 .45642 .44478 .40774 Metetra
.561 .37 .58 r
.44478 .40774 .44769 .45642 .45988 .45245 .45682 .40371 Metetra
.561 .37 .58 r
.45682 .40371 .45988 .45245 .47295 .3994 .46892 .39965 Metetra
.736 .987 .895 r
.46892 .39965 .47295 .3994 .48506 .39535 .48114 .39101 Metetra
.658 .748 .917 r
.48114 .39101 .48506 .39535 .49723 .39127 .49333 .38692 Metetra
.658 .748 .917 r
.49333 .38692 .49723 .39127 .50947 .38613 .50558 .3828 Metetra
.693 .815 .941 r
.50558 .3828 .50947 .38613 .52175 .3785 .51789 .37761 Metetra
.743 .959 .941 r
.51789 .37761 .52175 .3785 .53407 .37366 .53024 .36994 Metetra
.682 .792 .933 r
.53024 .36994 .53407 .37366 .54645 .3695 .54264 .36506 Metetra
.766 .778 .863 r
.54264 .36506 .54645 .3695 .55884 .36111 .55506 .35664 Metetra
.857 .788 .783 r
.55506 .35664 .55884 .36111 .57111 .34363 .5674 .34139 Metetra
.728 .892 .955 r
.5674 .34139 .57111 .34363 .58315 .31693 .57988 .33487 Metetra
.311 .028 .311 r
.57988 .33487 .58315 .31693 .5956 .31265 .59224 .32155 Metetra
.356 0 .178 r
.59224 .32155 .5956 .31265 .6081 .30836 .60482 .31724 Metetra
.60482 .31724 .6081 .30836 .62067 .30404 .61704 .29943 Metetra
.662 .744 .911 r
.61704 .29943 .62067 .30404 .63309 .29412 .62969 .29507 Metetra
.268 .765 .712 r
.62969 .29507 .63309 .29412 .64561 .28642 .6424 .29069 Metetra
.6424 .29069 .64561 .28642 .65791 .27314 .65477 .27734 Metetra
.156 0 0 r
.65477 .27734 .65791 .27314 .67064 .26873 .66757 .27291 Metetra
.622 .831 .433 r
.66757 .27291 .67064 .26873 .68319 .25986 .6797 .25512 Metetra
.663 .742 .908 r
.6797 .25512 .68319 .25986 .69602 .2554 .69256 .25063 Metetra
.663 .742 .908 r
.69256 .25063 .69602 .2554 .70891 .25092 .70547 .24613 Metetra
.663 .742 .908 r
.70547 .24613 .70891 .25092 .72186 .24642 .71845 .2416 Metetra
.663 .742 .908 r
.71845 .2416 .72186 .24642 .73487 .24189 .73149 .23706 Metetra
.663 .742 .908 r
.73149 .23706 .73487 .24189 .74795 .23735 .74459 .23249 Metetra
.663 .742 .908 r
.74459 .23249 .74795 .23735 .76109 .23278 .75776 .22789 Metetra
.663 .742 .908 r
.75776 .22789 .76109 .23278 .77429 .22819 .77099 .22328 Metetra
.663 .742 .908 r
.77099 .22328 .77429 .22819 .78756 .22358 .78428 .21864 Metetra
.663 .742 .908 r
.78428 .21864 .78756 .22358 .80089 .21894 .79764 .21398 Metetra
.651 .756 .926 r
.19238 .5576 .1969 .56141 .20808 .55783 .20358 .554 Metetra
.651 .756 .926 r
.20358 .554 .20808 .55783 .21931 .55423 .21482 .55038 Metetra
.651 .756 .926 r
.21482 .55038 .21931 .55423 .23059 .55061 .22612 .54675 Metetra
.651 .756 .926 r
.22612 .54675 .23059 .55061 .24192 .54698 .23747 .54309 Metetra
.651 .756 .926 r
.23747 .54309 .24192 .54698 .2533 .54333 .24887 .53943 Metetra
.651 .756 .926 r
.24887 .53943 .2533 .54333 .26474 .53966 .26033 .53574 Metetra
.651 .756 .926 r
.26033 .53574 .26474 .53966 .27623 .53598 .27184 .53204 Metetra
.651 .756 .926 r
.27184 .53204 .27623 .53598 .28777 .53228 .2834 .52832 Metetra
.651 .756 .926 r
.2834 .52832 .28777 .53228 .29937 .52856 .29501 .52458 Metetra
.651 .756 .926 r
.29501 .52458 .29937 .52856 .31102 .52482 .30668 .52083 Metetra
.651 .756 .926 r
.30668 .52083 .31102 .52482 .32273 .52107 .31841 .51706 Metetra
.651 .756 .926 r
.31841 .51706 .32273 .52107 .33449 .5173 .33019 .51327 Metetra
.651 .756 .926 r
.33019 .51327 .33449 .5173 .3463 .51351 .34202 .50946 Metetra
.651 .756 .926 r
.34202 .50946 .3463 .51351 .35817 .50971 .35391 .50564 Metetra
.917 .754 .665 r
.35391 .50564 .35817 .50971 .3701 .50588 .36737 .4716 Metetra
.569 .393 .603 r
.36737 .4716 .3701 .50588 .38261 .49036 .37926 .4677 Metetra
.584 .432 .641 r
.37926 .4677 .38261 .49036 .39536 .46796 .39121 .46379 Metetra
.913 .761 .679 r
.39121 .46379 .39536 .46796 .40735 .46404 .40422 .43383 Metetra
.574 .403 .613 r
.40422 .43383 .40735 .46404 .41939 .46011 .41618 .42985 Metetra
.574 .403 .613 r
.41618 .42985 .41939 .46011 .43239 .4255 .4282 .42585 Metetra
.736 .987 .895 r
.4282 .42585 .43239 .4255 .44478 .40774 .4404 .41722 Metetra
.4404 .41722 .44478 .40774 .45682 .40371 .45283 .39939 Metetra
.658 .749 .917 r
.45283 .39939 .45682 .40371 .46892 .39965 .46495 .39532 Metetra
.772 .777 .857 r
.46495 .39532 .46892 .39965 .48114 .39101 .47719 .38665 Metetra
.658 .748 .917 r
.47719 .38665 .48114 .39101 .49333 .38692 .4894 .38254 Metetra
.691 .759 .903 r
.4894 .38254 .49333 .38692 .50558 .3828 .50168 .37734 Metetra
.738 .727 .842 r
.50168 .37734 .50558 .3828 .51789 .37761 .51402 .36967 Metetra
.641 .612 .805 r
.51402 .36967 .51789 .37761 .53024 .36994 .52639 .36549 Metetra
.681 .755 .908 r
.52639 .36549 .53024 .36994 .54264 .36506 .53881 .36059 Metetra
.766 .778 .863 r
.53881 .36059 .54264 .36506 .55506 .35664 .55126 .35214 Metetra
.659 .747 .915 r
.55126 .35214 .55506 .35664 .5674 .34139 .56378 .3479 Metetra
.56378 .3479 .5674 .34139 .57988 .33487 .57614 .33032 Metetra
.66 .746 .914 r
.57614 .33032 .57988 .33487 .59224 .32155 .58873 .32602 Metetra
.169 0 0 r
.58873 .32602 .59224 .32155 .60482 .31724 .60138 .3217 Metetra
.169 0 0 r
.60138 .3217 .60482 .31724 .61704 .29943 .61409 .31736 Metetra
.451 .143 .352 r
.61409 .31736 .61704 .29943 .62969 .29507 .62686 .313 Metetra
.451 .143 .352 r
.62686 .313 .62969 .29507 .6424 .29069 .63969 .30862 Metetra
.451 .143 .352 r
.63969 .30862 .6424 .29069 .65477 .27734 .65259 .30422 Metetra
.241 .012 .352 r
.65259 .30422 .65477 .27734 .66757 .27291 .66446 .27714 Metetra
.156 0 0 r
.66446 .27714 .66757 .27291 .6797 .25512 .67737 .27268 Metetra
.15 0 .266 r
.67737 .27268 .6797 .25512 .69256 .25063 .68933 .25028 Metetra
.734 .987 .893 r
.68933 .25028 .69256 .25063 .70547 .24613 .70202 .24131 Metetra
.663 .742 .908 r
.70202 .24131 .70547 .24613 .71845 .2416 .71502 .23676 Metetra
.663 .742 .908 r
.71502 .23676 .71845 .2416 .73149 .23706 .72809 .23219 Metetra
.663 .742 .908 r
.72809 .23219 .73149 .23706 .74459 .23249 .74121 .2276 Metetra
.663 .742 .908 r
.74121 .2276 .74459 .23249 .75776 .22789 .75441 .22298 Metetra
.663 .742 .908 r
.75441 .22298 .75776 .22789 .77099 .22328 .76766 .21834 Metetra
.663 .742 .908 r
.76766 .21834 .77099 .22328 .78428 .21864 .78098 .21368 Metetra
.663 .742 .908 r
.78098 .21368 .78428 .21864 .79764 .21398 .79437 .209 Metetra
.651 .756 .926 r
.18784 .55377 .19238 .5576 .20358 .554 .19906 .55015 Metetra
.651 .756 .926 r
.19906 .55015 .20358 .554 .21482 .55038 .21032 .54651 Metetra
.651 .756 .926 r
.21032 .54651 .21482 .55038 .22612 .54675 .22163 .54286 Metetra
.651 .756 .926 r
.22163 .54286 .22612 .54675 .23747 .54309 .233 .53919 Metetra
.651 .756 .926 r
.233 .53919 .23747 .54309 .24887 .53943 .24442 .5355 Metetra
.651 .756 .926 r
.24442 .5355 .24887 .53943 .26033 .53574 .25589 .5318 Metetra
.651 .756 .926 r
.25589 .5318 .26033 .53574 .27184 .53204 .26742 .52808 Metetra
.651 .756 .926 r
.26742 .52808 .27184 .53204 .2834 .52832 .279 .52434 Metetra
.651 .756 .926 r
.279 .52434 .2834 .52832 .29501 .52458 .29063 .52059 Metetra
.651 .756 .926 r
.29063 .52059 .29501 .52458 .30668 .52083 .30232 .51681 Metetra
.651 .756 .926 r
.30232 .51681 .30668 .52083 .31841 .51706 .31407 .51302 Metetra
.913 .751 .667 r
.31407 .51302 .31841 .51706 .33019 .51327 .32775 .47909 Metetra
.569 .392 .602 r
.32775 .47909 .33019 .51327 .34202 .50946 .33949 .47523 Metetra
.694 .486 .602 r
.33949 .47523 .34202 .50946 .35391 .50564 .35272 .4454 Metetra
.554 .357 .568 r
.35272 .4454 .35391 .50564 .36737 .4716 .36448 .44147 Metetra
.573 .403 .612 r
.36448 .44147 .36737 .4716 .37926 .4677 .3763 .43753 Metetra
.677 .479 .61 r
.3763 .43753 .37926 .4677 .39121 .46379 .38897 .41524 Metetra
.58 .384 .58 r
.38897 .41524 .39121 .46379 .40422 .43383 .40101 .40669 Metetra
.577 .412 .621 r
.40101 .40669 .40422 .43383 .41618 .42985 .41291 .40267 Metetra
.577 .412 .621 r
.41291 .40267 .41618 .42985 .4282 .42585 .42486 .39862 Metetra
.577 .412 .621 r
.42486 .39862 .4282 .42585 .4404 .41722 .43687 .39456 Metetra
.623 .458 .638 r
.43687 .39456 .4404 .41722 .45283 .39939 .44904 .38593 Metetra
.621 .511 .708 r
.44904 .38593 .45283 .39939 .46495 .39532 .46116 .38112 Metetra
.608 .497 .701 r
.46116 .38112 .46495 .39532 .47719 .38665 .47331 .377 Metetra
.696 .603 .748 r
.47331 .377 .47719 .38665 .4894 .38254 .48558 .36865 Metetra
.741 .58 .674 r
.48558 .36865 .4894 .38254 .50168 .37734 .49795 .35123 Metetra
.579 .417 .626 r
.49795 .35123 .50168 .37734 .51402 .36967 .51021 .34703 Metetra
.585 .432 .64 r
.51021 .34703 .51402 .36967 .52639 .36549 .52252 .34282 Metetra
.585 .432 .64 r
.52252 .34282 .52639 .36549 .53881 .36059 .5349 .33858 Metetra
.587 .436 .644 r
.5349 .33858 .53881 .36059 .55126 .35214 .54733 .33432 Metetra
.597 .464 .67 r
.54733 .33432 .55126 .35214 .56378 .3479 .55982 .33004 Metetra
.681 .517 .658 r
.55982 .33004 .56378 .3479 .57614 .33032 .57223 .31669 Metetra
.712 .565 .687 r
.57223 .31669 .57614 .33032 .58873 .32602 .58462 .30335 Metetra
.623 .458 .638 r
.58462 .30335 .58873 .32602 .60138 .3217 .5971 .29451 Metetra
.578 .414 .622 r
.5971 .29451 .60138 .3217 .61409 .31736 .60974 .29013 Metetra
.578 .414 .622 r
.60974 .29013 .61409 .31736 .62686 .313 .62243 .28572 Metetra
.578 .414 .622 r
.62243 .28572 .62686 .313 .63969 .30862 .63519 .2813 Metetra
.663 .472 .615 r
.63519 .2813 .63969 .30862 .65259 .30422 .64744 .26343 Metetra
.565 .38 .59 r
.64744 .26343 .65259 .30422 .66446 .27714 .66026 .25895 Metetra
.641 .49 .663 r
.66026 .25895 .66446 .27714 .67737 .27268 .67291 .24999 Metetra
.623 .458 .638 r
.67291 .24999 .67737 .27268 .68933 .25028 .68559 .24102 Metetra
.637 .585 .779 r
.68559 .24102 .68933 .25028 .70202 .24131 .69855 .23647 Metetra
.663 .742 .908 r
.69855 .23647 .70202 .24131 .71502 .23676 .71158 .2319 Metetra
.663 .742 .908 r
.71158 .2319 .71502 .23676 .72809 .23219 .72467 .2273 Metetra
.663 .742 .908 r
.72467 .2273 .72809 .23219 .74121 .2276 .73782 .22269 Metetra
.663 .742 .908 r
.73782 .22269 .74121 .2276 .75441 .22298 .75104 .21805 Metetra
.663 .742 .908 r
.75104 .21805 .75441 .22298 .76766 .21834 .76432 .21338 Metetra
.663 .742 .908 r
.76432 .21338 .76766 .21834 .78098 .21368 .77767 .2087 Metetra
.663 .742 .908 r
.77767 .2087 .78098 .21368 .79437 .209 .79108 .20399 Metetra
.651 .756 .926 r
.18328 .54991 .18784 .55377 .19906 .55015 .19451 .54628 Metetra
.651 .756 .926 r
.19451 .54628 .19906 .55015 .21032 .54651 .20579 .54262 Metetra
.651 .756 .926 r
.20579 .54262 .21032 .54651 .22163 .54286 .21712 .53895 Metetra
.651 .756 .926 r
.21712 .53895 .22163 .54286 .233 .53919 .22851 .53527 Metetra
.651 .756 .926 r
.22851 .53527 .233 .53919 .24442 .5355 .23995 .53156 Metetra
.651 .756 .926 r
.23995 .53156 .24442 .5355 .25589 .5318 .25144 .52784 Metetra
.651 .756 .926 r
.25144 .52784 .25589 .5318 .26742 .52808 .26298 .5241 Metetra
.651 .756 .926 r
.26298 .5241 .26742 .52808 .279 .52434 .27458 .52035 Metetra
.651 .756 .926 r
.27458 .52035 .279 .52434 .29063 .52059 .28623 .51657 Metetra
.651 .756 .926 r
.28623 .51657 .29063 .52059 .30232 .51681 .29794 .51278 Metetra
.912 .75 .667 r
.29794 .51278 .30232 .51681 .31407 .51302 .31174 .47884 Metetra
.694 .486 .602 r
.31174 .47884 .31407 .51302 .32775 .47909 .32511 .44905 Metetra
.572 .402 .612 r
.32511 .44905 .32775 .47909 .33949 .47523 .33678 .44515 Metetra
.656 .463 .612 r
.33678 .44515 .33949 .47523 .35272 .4454 .34928 .42748 Metetra
.654 .499 .661 r
.34928 .42748 .35272 .4454 .36448 .44147 .36132 .41756 Metetra
.608 .443 .633 r
.36132 .41756 .36448 .44147 .3763 .43753 .37324 .41043 Metetra
.577 .412 .621 r
.37324 .41043 .3763 .43753 .38897 .41524 .38504 .40643 Metetra
.634 .585 .782 r
.38504 .40643 .38897 .41524 .40101 .40669 .3969 .40241 Metetra
.772 .774 .855 r
.3969 .40241 .40101 .40669 .41291 .40267 .40899 .39381 Metetra
.648 .592 .778 r
.40899 .39381 .41291 .40267 .42486 .39862 .42097 .38905 Metetra
.697 .603 .748 r
.42097 .38905 .42486 .39862 .43687 .39456 .4331 .38077 Metetra
.609 .501 .705 r
.4331 .38077 .43687 .39456 .44904 .38593 .44515 .37666 Metetra
.7 .611 .754 r
.44515 .37666 .44904 .38593 .46116 .38112 .45734 .36834 Metetra
.673 .549 .706 r
.45734 .36834 .46116 .38112 .47331 .377 .46957 .35966 Metetra
.644 .496 .667 r
.46957 .35966 .47331 .377 .48558 .36865 .48181 .35096 Metetra
.597 .463 .67 r
.48181 .35096 .48558 .36865 .49795 .35123 .49404 .34676 Metetra
.66 .746 .914 r
.49404 .34676 .49795 .35123 .51021 .34703 .50632 .34254 Metetra
.66 .746 .914 r
.50632 .34254 .51021 .34703 .52252 .34282 .51865 .3383 Metetra
.836 .785 .802 r
.51865 .3383 .52252 .34282 .5349 .33858 .53103 .32501 Metetra
.612 .506 .709 r
.53103 .32501 .5349 .33858 .54733 .33432 .54345 .32072 Metetra
.712 .565 .687 r
.54345 .32072 .54733 .33432 .55982 .33004 .55583 .30741 Metetra
.623 .458 .638 r
.55583 .30741 .55982 .33004 .57223 .31669 .56826 .29859 Metetra
.596 .461 .667 r
.56826 .29859 .57223 .31669 .58462 .30335 .5808 .29423 Metetra
.636 .585 .78 r
.5808 .29423 .58462 .30335 .5971 .29451 .5934 .28984 Metetra
.662 .744 .911 r
.5934 .28984 .5971 .29451 .60974 .29013 .60606 .28544 Metetra
.879 .79 .757 r
.60606 .28544 .60974 .29013 .62243 .28572 .61834 .2676 Metetra
.641 .49 .663 r
.61834 .2676 .62243 .28572 .63519 .2813 .6309 .25869 Metetra
.623 .458 .638 r
.6309 .25869 .63519 .2813 .64744 .26343 .64348 .24977 Metetra
.613 .507 .709 r
.64348 .24977 .64744 .26343 .66026 .25895 .65628 .24526 Metetra
.613 .507 .709 r
.65628 .24526 .66026 .25895 .67291 .24999 .66915 .24073 Metetra
.637 .585 .779 r
.66915 .24073 .67291 .24999 .68559 .24102 .68207 .23618 Metetra
.663 .742 .908 r
.68207 .23618 .68559 .24102 .69855 .23647 .69506 .2316 Metetra
.663 .742 .908 r
.69506 .2316 .69855 .23647 .71158 .2319 .70811 .22701 Metetra
.663 .742 .908 r
.70811 .22701 .71158 .2319 .72467 .2273 .72123 .22239 Metetra
.663 .742 .908 r
.72123 .22239 .72467 .2273 .73782 .22269 .73441 .21775 Metetra
.663 .742 .908 r
.73441 .21775 .73782 .22269 .75104 .21805 .74765 .21308 Metetra
.663 .742 .908 r
.74765 .21308 .75104 .21805 .76432 .21338 .76096 .2084 Metetra
.663 .742 .908 r
.76096 .2084 .76432 .21338 .77767 .2087 .77433 .20369 Metetra
.663 .742 .908 r
.77433 .20369 .77767 .2087 .79108 .20399 .78777 .19896 Metetra
.651 .756 .926 r
.1787 .54604 .18328 .54991 .19451 .54628 .18995 .54239 Metetra
.651 .756 .926 r
.18995 .54239 .19451 .54628 .20579 .54262 .20124 .53872 Metetra
.651 .756 .926 r
.20124 .53872 .20579 .54262 .21712 .53895 .21259 .53503 Metetra
.651 .756 .926 r
.21259 .53503 .21712 .53895 .22851 .53527 .22399 .53132 Metetra
.651 .756 .926 r
.22399 .53132 .22851 .53527 .23995 .53156 .23545 .5276 Metetra
.651 .756 .926 r
.23545 .5276 .23995 .53156 .25144 .52784 .24696 .52386 Metetra
.651 .756 .926 r
.24696 .52386 .25144 .52784 .26298 .5241 .25852 .5201 Metetra
.651 .756 .926 r
.25852 .5201 .26298 .5241 .27458 .52035 .27014 .51633 Metetra
.651 .756 .926 r
.27014 .51633 .27458 .52035 .28623 .51657 .28181 .51254 Metetra
.651 .756 .926 r
.28181 .51254 .28623 .51657 .29794 .51278 .29354 .50873 Metetra
.651 .756 .926 r
.29354 .50873 .29794 .51278 .31174 .47884 .30532 .5049 Metetra
.475 .188 .398 r
.30532 .5049 .31174 .47884 .32511 .44905 .31715 .50105 Metetra
.504 .248 .46 r
.31715 .50105 .32511 .44905 .33678 .44515 .32905 .49719 Metetra
.504 .248 .46 r
.32905 .49719 .33678 .44515 .34928 .42748 .341 .4933 Metetra
.51 .261 .472 r
.341 .4933 .34928 .42748 .36132 .41756 .353 .4894 Metetra
.478 .235 .468 r
.353 .4894 .36132 .41756 .37324 .41043 .36555 .47594 Metetra
.51 .26 .472 r
.36555 .47594 .37324 .41043 .38504 .40643 .37764 .47199 Metetra
.408 .175 .446 r
.37764 .47199 .38504 .40643 .3969 .40241 .39079 .44436 Metetra
.323 .088 .394 r
.39079 .44436 .3969 .40241 .40899 .39381 .40381 .41702 Metetra
.466 .174 .384 r
.40381 .41702 .40899 .39381 .42097 .38905 .41589 .41296 Metetra
.281 .017 .323 r
.41589 .41296 .42097 .38905 .4331 .38077 .42846 .39503 Metetra
.32 0 .254 r
.42846 .39503 .4331 .38077 .44515 .37666 .44073 .38632 Metetra
.2 0 .11 r
.44073 .38632 .44515 .37666 .45734 .36834 .45302 .3776 Metetra
.156 0 .079 r
.45302 .3776 .45734 .36834 .46957 .35966 .46534 .36816 Metetra
.184 0 .069 r
.46534 .36816 .46957 .35966 .48181 .35096 .47765 .36011 Metetra
.337 0 .163 r
.47765 .36011 .48181 .35096 .49404 .34676 .48996 .35555 Metetra
.186 0 .083 r
.48996 .35555 .49404 .34676 .50632 .34254 .50234 .34712 Metetra
.50234 .34712 .50632 .34254 .51865 .3383 .51475 .33831 Metetra
.439 .876 .889 r
.51475 .33831 .51865 .3383 .53103 .32501 .52719 .33403 Metetra
.347 0 .165 r
.52719 .33403 .53103 .32501 .54345 .32072 .53969 .32974 Metetra
.53969 .32974 .54345 .32072 .55583 .30741 .55214 .31439 Metetra
.177 0 .016 r
.55214 .31439 .55583 .30741 .56826 .29859 .56468 .30745 Metetra
.343 0 .161 r
.56468 .30745 .56826 .29859 .5808 .29423 .5773 .30308 Metetra
.007 0 .022 r
.5773 .30308 .5808 .29423 .5934 .28984 .58977 .28965 Metetra
.741 .987 .897 r
.58977 .28965 .5934 .28984 .60606 .28544 .60235 .28073 Metetra
.662 .744 .911 r
.60235 .28073 .60606 .28544 .61834 .2676 .6151 .27628 Metetra
.34 0 .157 r
.6151 .27628 .61834 .2676 .6309 .25869 .6279 .27181 Metetra
.21 0 .214 r
.6279 .27181 .6309 .25869 .64348 .24977 .64041 .25834 Metetra
.338 0 .154 r
.64041 .25834 .64348 .24977 .65628 .24526 .6533 .25382 Metetra
.192 0 .1 r
.6533 .25382 .65628 .24526 .66915 .24073 .66603 .2448 Metetra
.66603 .2448 .66915 .24073 .68207 .23618 .67878 .23576 Metetra
.738 .987 .896 r
.67878 .23576 .68207 .23618 .69506 .2316 .69156 .22671 Metetra
.663 .742 .908 r
.69156 .22671 .69506 .2316 .70811 .22701 .70463 .22209 Metetra
.663 .742 .908 r
.70463 .22209 .70811 .22701 .72123 .22239 .71777 .21745 Metetra
.663 .742 .908 r
.71777 .21745 .72123 .22239 .73441 .21775 .73098 .21278 Metetra
.663 .742 .908 r
.73098 .21278 .73441 .21775 .74765 .21308 .74425 .2081 Metetra
.663 .742 .908 r
.74425 .2081 .74765 .21308 .76096 .2084 .75758 .20339 Metetra
.663 .742 .908 r
.75758 .20339 .76096 .2084 .77433 .20369 .77098 .19865 Metetra
.663 .742 .908 r
.77098 .19865 .77433 .20369 .78777 .19896 .78445 .19389 Metetra
.651 .756 .926 r
.17409 .54215 .1787 .54604 .18995 .54239 .18536 .53848 Metetra
.651 .756 .926 r
.18536 .53848 .18995 .54239 .20124 .53872 .19667 .53479 Metetra
.651 .756 .926 r
.19667 .53479 .20124 .53872 .21259 .53503 .20804 .53108 Metetra
.651 .756 .926 r
.20804 .53108 .21259 .53503 .22399 .53132 .21946 .52736 Metetra
.651 .756 .926 r
.21946 .52736 .22399 .53132 .23545 .5276 .23093 .52362 Metetra
.651 .756 .926 r
.23093 .52362 .23545 .5276 .24696 .52386 .24246 .51986 Metetra
.651 .756 .926 r
.24246 .51986 .24696 .52386 .25852 .5201 .25404 .51609 Metetra
.651 .756 .926 r
.25404 .51609 .25852 .5201 .27014 .51633 .26567 .51229 Metetra
.651 .756 .926 r
.26567 .51229 .27014 .51633 .28181 .51254 .27736 .50848 Metetra
.651 .756 .926 r
.27736 .50848 .28181 .51254 .29354 .50873 .28911 .50465 Metetra
.651 .756 .926 r
.28911 .50465 .29354 .50873 .30532 .5049 .30091 .5008 Metetra
.651 .756 .926 r
.30091 .5008 .30532 .5049 .31715 .50105 .31277 .49694 Metetra
.651 .756 .926 r
.31277 .49694 .31715 .50105 .32905 .49719 .32468 .49305 Metetra
.651 .756 .926 r
.32468 .49305 .32905 .49719 .341 .4933 .33665 .48915 Metetra
.835 .782 .801 r
.33665 .48915 .341 .4933 .353 .4894 .34921 .47568 Metetra
.607 .502 .709 r
.34921 .47568 .353 .4894 .36555 .47594 .36126 .47173 Metetra
.652 .755 .925 r
.36126 .47173 .36555 .47594 .37764 .47199 .37336 .46776 Metetra
.652 .755 .925 r
.37336 .46776 .37764 .47199 .39079 .44436 .38553 .46377 Metetra
.451 .143 .352 r
.38553 .46377 .39079 .44436 .40381 .41702 .39775 .45977 Metetra
.467 .208 .437 r
.39775 .45977 .40381 .41702 .41589 .41296 .41021 .45096 Metetra
.423 .165 .416 r
.41021 .45096 .41589 .41296 .42846 .39503 .42284 .43739 Metetra
.436 .181 .428 r
.42284 .43739 .42846 .39503 .44073 .38632 .43545 .42384 Metetra
.491 .223 .434 r
.43545 .42384 .44073 .38632 .45302 .3776 .44782 .41972 Metetra
.328 .093 .397 r
.44782 .41972 .45302 .3776 .46534 .36816 .46073 .39211 Metetra
.208 0 .298 r
.46073 .39211 .46534 .36816 .47765 .36011 .47343 .36939 Metetra
.186 0 .093 r
.47343 .36939 .47765 .36011 .48996 .35555 .48587 .36057 Metetra
.185 0 0 r
.48587 .36057 .48996 .35555 .50234 .34712 .49828 .35633 Metetra
.348 0 .167 r
.49828 .35633 .50234 .34712 .51475 .33831 .51076 .35207 Metetra
.373 .042 .27 r
.51076 .35207 .51475 .33831 .52719 .33403 .5233 .34582 Metetra
.185 0 .162 r
.5233 .34582 .52719 .33403 .53969 .32974 .53586 .33393 Metetra
.128 0 0 r
.53586 .33393 .53969 .32974 .55214 .31439 .54847 .3296 Metetra
.426 .1 .308 r
.54847 .3296 .55214 .31439 .56468 .30745 .56115 .32525 Metetra
.378 .075 .32 r
.56115 .32525 .56468 .30745 .5773 .30308 .57382 .31664 Metetra
.316 0 .25 r
.57382 .31664 .5773 .30308 .58977 .28965 .58651 .30765 Metetra
.376 .075 .322 r
.58651 .30765 .58977 .28965 .60235 .28073 .59921 .29866 Metetra
.299 .013 .299 r
.59921 .29866 .60235 .28073 .6151 .27628 .61181 .28509 Metetra
.19 0 .098 r
.61181 .28509 .6151 .27628 .6279 .27181 .62454 .27607 Metetra
.14 0 0 r
.62454 .27607 .6279 .27181 .64041 .25834 .63747 .27156 Metetra
.21 0 .214 r
.63747 .27156 .64041 .25834 .6533 .25382 .65007 .25798 Metetra
.135 0 0 r
.65007 .25798 .6533 .25382 .66603 .2448 .66309 .25342 Metetra
.337 0 .152 r
.66309 .25342 .66603 .2448 .67878 .23576 .67617 .24884 Metetra
.214 0 .219 r
.67617 .24884 .67878 .23576 .69156 .22671 .6888 .23522 Metetra
.335 0 .15 r
.6888 .23522 .69156 .22671 .70463 .22209 .70197 .23059 Metetra
.298 0 .137 r
.70197 .23059 .70463 .22209 .71777 .21745 .71511 .2247 Metetra
.079 0 .013 r
.71511 .2247 .71777 .21745 .73098 .21278 .72798 .21411 Metetra
.34 .795 .661 r
.72798 .21411 .73098 .21278 .74425 .2081 .74117 .20756 Metetra
.732 .987 .892 r
.74117 .20756 .74425 .2081 .75758 .20339 .75419 .19835 Metetra
.663 .742 .908 r
.75419 .19835 .75758 .20339 .77098 .19865 .76762 .19359 Metetra
.663 .742 .908 r
.76762 .19359 .77098 .19865 .78445 .19389 .78111 .18881 Metetra
.651 .756 .926 r
.16946 .53824 .17409 .54215 .18536 .53848 .18074 .53455 Metetra
.651 .756 .926 r
.18074 .53455 .18536 .53848 .19667 .53479 .19208 .53085 Metetra
.651 .756 .926 r
.19208 .53085 .19667 .53479 .20804 .53108 .20346 .52712 Metetra
.651 .756 .926 r
.20346 .52712 .20804 .53108 .21946 .52736 .2149 .52338 Metetra
.651 .756 .926 r
.2149 .52338 .21946 .52736 .23093 .52362 .22639 .51962 Metetra
.651 .756 .926 r
.22639 .51962 .23093 .52362 .24246 .51986 .23793 .51584 Metetra
.831 .775 .799 r
.23793 .51584 .24246 .51986 .25404 .51609 .25035 .50258 Metetra
.607 .502 .709 r
.25035 .50258 .25404 .51609 .26567 .51229 .26197 .49875 Metetra
.607 .502 .709 r
.26197 .49875 .26567 .51229 .27736 .50848 .27365 .49491 Metetra
.793 .612 .656 r
.27365 .49491 .27736 .50848 .28911 .50465 .28716 .46755 Metetra
.563 .382 .594 r
.28716 .46755 .28911 .50465 .30091 .5008 .29886 .46364 Metetra
.563 .382 .594 r
.29886 .46364 .30091 .5008 .31277 .49694 .31062 .45972 Metetra
.563 .382 .594 r
.31062 .45972 .31277 .49694 .32468 .49305 .32243 .45578 Metetra
.669 .463 .597 r
.32243 .45578 .32468 .49305 .33665 .48915 .33563 .42999 Metetra
.557 .358 .567 r
.33563 .42999 .33665 .48915 .34921 .47568 .34755 .42456 Metetra
.575 .377 .576 r
.34755 .42456 .34921 .47568 .36126 .47173 .35969 .41592 Metetra
.554 .358 .569 r
.35969 .41592 .36126 .47173 .37336 .46776 .37164 .41163 Metetra
.604 .397 .573 r
.37164 .41163 .37336 .46776 .38553 .46377 .38425 .39401 Metetra
.564 .358 .561 r
.38425 .39401 .38553 .46377 .39775 .45977 .39643 .38533 Metetra
.548 .344 .556 r
.39643 .38533 .39775 .45977 .41021 .45096 .40846 .38121 Metetra
.555 .352 .56 r
.40846 .38121 .41021 .45096 .42284 .43739 .42062 .37511 Metetra
.578 .372 .566 r
.42062 .37511 .42284 .43739 .43545 .42384 .43298 .36341 Metetra
.583 .377 .568 r
.43298 .36341 .43545 .42384 .44782 .41972 .44538 .35048 Metetra
.591 .38 .563 r
.44538 .35048 .44782 .41972 .46073 .39211 .45786 .33271 Metetra
.552 .354 .566 r
.45786 .33271 .46073 .39211 .47343 .36939 .47006 .32845 Metetra
.585 .393 .588 r
.47006 .32845 .47343 .36939 .48587 .36057 .48237 .31968 Metetra
.606 .409 .588 r
.48237 .31968 .48587 .36057 .49828 .35633 .49475 .30642 Metetra
.556 .363 .575 r
.49475 .30642 .49828 .35633 .51076 .35207 .50706 .30209 Metetra
.556 .363 .575 r
.50706 .30209 .51076 .35207 .5233 .34582 .51943 .29775 Metetra
.557 .366 .577 r
.51943 .29775 .5233 .34582 .53586 .33393 .53186 .29338 Metetra
.562 .377 .588 r
.53186 .29338 .53586 .33393 .54847 .3296 .54434 .289 Metetra
.562 .377 .588 r
.54434 .289 .54847 .3296 .56115 .32525 .55689 .28459 Metetra
.571 .383 .588 r
.55689 .28459 .56115 .32525 .57382 .31664 .56947 .27843 Metetra
.602 .409 .592 r
.56947 .27843 .57382 .31664 .58651 .30765 .58199 .26674 Metetra
.568 .381 .588 r
.58199 .26674 .58651 .30765 .59921 .29866 .59465 .26104 Metetra
.582 .395 .594 r
.59465 .26104 .59921 .29866 .61181 .28509 .6073 .25329 Metetra
.57 .397 .607 r
.6073 .25329 .61181 .28509 .62454 .27607 .62009 .24876 Metetra
.596 .424 .62 r
.62009 .24876 .62454 .27607 .63747 .27156 .63285 .24158 Metetra
.585 .411 .612 r
.63285 .24158 .63747 .27156 .65007 .25798 .64568 .23517 Metetra
.594 .438 .639 r
.64568 .23517 .65007 .25798 .66309 .25342 .65858 .22946 Metetra
.609 .444 .633 r
.65858 .22946 .66309 .25342 .67617 .24884 .67143 .2215 Metetra
.577 .412 .621 r
.67143 .2215 .67617 .24884 .6888 .23522 .68449 .21685 Metetra
.596 .461 .667 r
.68449 .21685 .6888 .23522 .70197 .23059 .69762 .21218 Metetra
.596 .461 .667 r
.69762 .21218 .70197 .23059 .71511 .2247 .71081 .20749 Metetra
.6 .471 .677 r
.71081 .20749 .71511 .2247 .72798 .21411 .72407 .20278 Metetra
.625 .546 .746 r
.72407 .20278 .72798 .21411 .74117 .20756 .73739 .19804 Metetra
.636 .585 .78 r
.73739 .19804 .74117 .20756 .75419 .19835 .75078 .19328 Metetra
.663 .742 .908 r
.75078 .19328 .75419 .19835 .76762 .19359 .76423 .1885 Metetra
.663 .742 .908 r
.76423 .1885 .76762 .19359 .78111 .18881 .77775 .18369 Metetra
.651 .756 .926 r
.16481 .53432 .16946 .53824 .18074 .53455 .17611 .53061 Metetra
.651 .756 .926 r
.17611 .53061 .18074 .53455 .19208 .53085 .18746 .52688 Metetra
.651 .756 .926 r
.18746 .52688 .19208 .53085 .20346 .52712 .19886 .52314 Metetra
.651 .756 .926 r
.19886 .52314 .20346 .52712 .2149 .52338 .21032 .51938 Metetra
.651 .756 .926 r
.21032 .51938 .2149 .52338 .22639 .51962 .22183 .5156 Metetra
.651 .756 .926 r
.22183 .5156 .22639 .51962 .23793 .51584 .23339 .5118 Metetra
.831 .775 .799 r
.23339 .5118 .23793 .51584 .25035 .50258 .24584 .49851 Metetra
.652 .755 .925 r
.24584 .49851 .25035 .50258 .26197 .49875 .25748 .49467 Metetra
.864 .769 .755 r
.25748 .49467 .26197 .49875 .27365 .49491 .27032 .47666 Metetra
.652 .497 .661 r
.27032 .47666 .27365 .49491 .28716 .46755 .28248 .46673 Metetra
.747 .943 .947 r
.28248 .46673 .28716 .46755 .29886 .46364 .29446 .45947 Metetra
.654 .753 .922 r
.29446 .45947 .29886 .46364 .31062 .45972 .30624 .45553 Metetra
.654 .753 .922 r
.30624 .45553 .31062 .45972 .32243 .45578 .31807 .45157 Metetra
.772 .777 .857 r
.31807 .45157 .32243 .45578 .33563 .42999 .33025 .4429 Metetra
.33025 .4429 .33563 .42999 .34755 .42456 .34318 .42171 Metetra
.703 .838 .947 r
.34318 .42171 .34755 .42456 .35969 .41592 .35518 .41624 Metetra
.418 .865 .873 r
.35518 .41624 .35969 .41592 .37164 .41163 .36715 .41218 Metetra
.382 .846 .839 r
.36715 .41218 .37164 .41163 .38425 .39401 .37918 .4081 Metetra
.411 .075 .282 r
.37918 .4081 .38425 .39401 .39643 .38533 .39126 .404 Metetra
.443 .132 .342 r
.39126 .404 .39643 .38533 .40846 .38121 .4034 .39988 Metetra
.443 .132 .342 r
.4034 .39988 .40846 .38121 .42062 .37511 .4156 .39574 Metetra
.346 .055 .321 r
.4156 .39574 .42062 .37511 .43298 .36341 .42809 .38443 Metetra
.453 .151 .362 r
.42809 .38443 .43298 .36341 .44538 .35048 .44038 .38024 Metetra
.477 .197 .409 r
.44038 .38024 .44538 .35048 .45786 .33271 .45272 .37603 Metetra
.453 .196 .433 r
.45272 .37603 .45786 .33271 .47006 .32845 .46526 .36502 Metetra
.454 .189 .421 r
.46526 .36502 .47006 .32845 .48237 .31968 .47777 .35614 Metetra
.454 .189 .421 r
.47777 .35614 .48237 .31968 .49475 .30642 .4903 .34724 Metetra
.492 .226 .439 r
.4903 .34724 .49475 .30642 .50706 .30209 .50282 .34294 Metetra
.492 .226 .439 r
.50282 .34294 .50706 .30209 .51943 .29775 .51541 .33861 Metetra
.365 .123 .408 r
.51541 .33861 .51943 .29775 .53186 .29338 .52802 .31588 Metetra
.404 .116 .358 r
.52802 .31588 .53186 .29338 .54434 .289 .54062 .30693 Metetra
.368 .066 .314 r
.54062 .30693 .54434 .289 .55689 .28459 .55324 .29796 Metetra
.306 0 .239 r
.55324 .29796 .55689 .28459 .56947 .27843 .56589 .28898 Metetra
.368 .004 .208 r
.56589 .28898 .56947 .27843 .58199 .26674 .57864 .28452 Metetra
.397 .09 .323 r
.57864 .28452 .58199 .26674 .59465 .26104 .59139 .27724 Metetra
.4 .084 .309 r
.59139 .27724 .59465 .26104 .6073 .25329 .6042 .27098 Metetra
.434 .121 .334 r
.6042 .27098 .6073 .25329 .62009 .24876 .61711 .26621 Metetra
.371 .068 .314 r
.61711 .26621 .62009 .24876 .63285 .24158 .62993 .25736 Metetra
.349 .039 .291 r
.62993 .25736 .63285 .24158 .64568 .23517 .64277 .24825 Metetra
.402 .062 .27 r
.64277 .24825 .64568 .23517 .65858 .22946 .65584 .24365 Metetra
.413 .081 .29 r
.65584 .24365 .65858 .22946 .67143 .2215 .66897 .23902 Metetra
.437 .123 .334 r
.66897 .23902 .67143 .2215 .68449 .21685 .68216 .23437 Metetra
.437 .123 .334 r
.68216 .23437 .68449 .21685 .69762 .21218 .69542 .2297 Metetra
.437 .123 .334 r
.69542 .2297 .69762 .21218 .71081 .20749 .70875 .225 Metetra
.437 .123 .334 r
.70875 .225 .71081 .20749 .72407 .20278 .72214 .22028 Metetra
.437 .123 .334 r
.72214 .22028 .72407 .20278 .73739 .19804 .7356 .21554 Metetra
.304 .018 .304 r
.7356 .21554 .73739 .19804 .75078 .19328 .74841 .20169 Metetra
.74841 .20169 .75078 .19328 .76423 .1885 .76083 .18338 Metetra
.663 .742 .908 r
.76083 .18338 .76423 .1885 .77775 .18369 .77437 .17855 Metetra
.651 .756 .926 r
.16014 .53037 .16481 .53432 .17611 .53061 .17145 .52664 Metetra
.651 .756 .926 r
.17145 .52664 .17611 .53061 .18746 .52688 .18282 .5229 Metetra
.651 .756 .926 r
.18282 .5229 .18746 .52688 .19886 .52314 .19424 .51914 Metetra
.83 .773 .798 r
.19424 .51914 .19886 .52314 .21032 .51938 .20666 .5059 Metetra
.745 .585 .677 r
.20666 .5059 .21032 .51938 .22183 .5156 .21952 .48799 Metetra
.639 .456 .619 r
.21952 .48799 .22183 .5156 .23339 .5118 .23189 .47481 Metetra
.562 .381 .593 r
.23189 .47481 .23339 .5118 .24584 .49851 .24341 .47094 Metetra
.572 .406 .618 r
.24341 .47094 .24584 .49851 .25748 .49467 .25499 .46705 Metetra
.572 .406 .618 r
.25499 .46705 .25748 .49467 .27032 .47666 .26662 .46314 Metetra
.607 .502 .709 r
.26662 .46314 .27032 .47666 .28248 .46673 .2783 .45922 Metetra
.64 .621 .815 r
.2783 .45922 .28248 .46673 .29446 .45947 .29004 .45527 Metetra
.883 .765 .727 r
.29004 .45527 .29446 .45947 .30624 .45553 .30311 .43349 Metetra
.631 .466 .64 r
.30311 .43349 .30624 .45553 .31807 .45157 .31526 .42405 Metetra
.573 .407 .619 r
.31526 .42405 .31807 .45157 .33025 .4429 .32708 .42002 Metetra
.581 .427 .638 r
.32708 .42002 .33025 .4429 .34318 .42171 .33896 .41598 Metetra
.652 .686 .869 r
.33896 .41598 .34318 .42171 .35518 .41624 .35089 .41192 Metetra
.656 .751 .919 r
.35089 .41192 .35518 .41624 .36715 .41218 .36288 .40783 Metetra
.81 .779 .825 r
.36288 .40783 .36715 .41218 .37918 .4081 .37528 .3966 Metetra
.708 .585 .715 r
.37528 .3966 .37918 .4081 .39126 .404 .38766 .38572 Metetra
.592 .457 .666 r
.38766 .38572 .39126 .404 .4034 .39988 .39977 .38157 Metetra
.64 .488 .662 r
.39977 .38157 .4034 .39988 .4156 .39574 .4121 .37278 Metetra
.594 .437 .638 r
.4121 .37278 .4156 .39574 .42809 .38443 .42435 .36717 Metetra
.781 .585 .634 r
.42435 .36717 .42809 .38443 .44038 .38024 .43736 .33694 Metetra
.558 .37 .582 r
.43736 .33694 .44038 .38024 .45272 .37603 .44958 .33267 Metetra
.558 .37 .582 r
.44958 .33267 .45272 .37603 .46526 .36502 .46185 .32839 Metetra
.59 .402 .595 r
.46185 .32839 .46526 .36502 .47777 .35614 .47425 .31954 Metetra
.59 .402 .595 r
.47425 .31954 .47777 .35614 .4903 .34724 .48668 .31068 Metetra
.564 .383 .595 r
.48668 .31068 .4903 .34724 .50282 .34294 .49909 .30633 Metetra
.564 .383 .595 r
.49909 .30633 .50282 .34294 .51541 .33861 .51156 .30195 Metetra
.575 .391 .595 r
.51156 .30195 .51541 .33861 .52802 .31588 .52409 .29565 Metetra
.589 .445 .653 r
.52409 .29565 .52802 .31588 .54062 .30693 .53667 .29122 Metetra
.633 .502 .685 r
.53667 .29122 .54062 .30693 .55324 .29796 .54929 .28416 Metetra
.667 .538 .699 r
.54929 .28416 .55324 .29796 .56589 .28898 .56193 .27517 Metetra
.61 .505 .709 r
.56193 .27517 .56589 .28898 .57864 .28452 .57466 .27068 Metetra
.667 .538 .699 r
.57466 .27068 .57864 .28452 .59139 .27724 .58736 .26165 Metetra
.603 .484 .69 r
.58736 .26165 .59139 .27724 .6042 .27098 .6002 .25711 Metetra
.61 .505 .709 r
.6002 .25711 .6042 .27098 .61711 .26621 .6131 .25254 Metetra
.612 .508 .712 r
.6131 .25254 .61711 .26621 .62993 .25736 .62607 .24796 Metetra
.635 .585 .781 r
.62607 .24796 .62993 .25736 .64277 .24825 .63909 .24335 Metetra
.662 .744 .911 r
.63909 .24335 .64277 .24825 .65584 .24365 .65218 .23872 Metetra
.662 .744 .911 r
.65218 .23872 .65584 .24365 .66897 .23902 .66534 .23407 Metetra
.662 .744 .911 r
.66534 .23407 .66897 .23902 .68216 .23437 .67856 .2294 Metetra
.662 .744 .911 r
.67856 .2294 .68216 .23437 .69542 .2297 .69185 .2247 Metetra
.834 .795 .815 r
.69185 .2247 .69542 .2297 .70875 .225 .70467 .21163 Metetra
.725 .579 .691 r
.70467 .21163 .70875 .225 .72214 .22028 .71739 .19715 Metetra
.583 .43 .639 r
.71739 .19715 .72214 .22028 .7356 .21554 .73078 .19237 Metetra
.62 .454 .636 r
.73078 .19237 .7356 .21554 .74841 .20169 .7439 .18307 Metetra
.595 .46 .667 r
.7439 .18307 .74841 .20169 .76083 .18338 .75741 .17824 Metetra
.663 .742 .908 r
.75741 .17824 .76083 .18338 .77437 .17855 .77098 .17338 Metetra
.651 .756 .926 r
.15544 .5264 .16014 .53037 .17145 .52664 .16677 .52266 Metetra
.651 .756 .926 r
.16677 .52266 .17145 .52664 .18282 .5229 .17816 .51889 Metetra
.892 .75 .698 r
.17816 .51889 .18282 .5229 .19424 .51914 .19207 .49157 Metetra
.572 .405 .618 r
.19207 .49157 .19424 .51914 .20666 .5059 .20348 .48774 Metetra
.59 .455 .665 r
.20348 .48774 .20666 .5059 .21952 .48799 .21495 .4839 Metetra
.83 .772 .798 r
.21495 .4839 .21952 .48799 .23189 .47481 .22735 .47069 Metetra
.654 .753 .922 r
.22735 .47069 .23189 .47481 .24341 .47094 .23889 .4668 Metetra
.654 .753 .922 r
.23889 .4668 .24341 .47094 .25499 .46705 .25049 .46289 Metetra
.654 .753 .922 r
.25049 .46289 .25499 .46705 .26662 .46314 .26213 .45896 Metetra
.654 .753 .922 r
.26213 .45896 .26662 .46314 .2783 .45922 .27384 .45502 Metetra
.847 .773 .78 r
.27384 .45502 .2783 .45922 .29004 .45527 .28646 .43979 Metetra
.673 .527 .678 r
.28646 .43979 .29004 .45527 .30311 .43349 .29871 .42924 Metetra
.785 .775 .844 r
.29871 .42924 .30311 .43349 .31526 .42405 .31089 .41976 Metetra
.656 .751 .919 r
.31089 .41976 .31526 .42405 .32708 .42002 .32273 .41572 Metetra
.656 .751 .919 r
.32273 .41572 .32708 .42002 .33896 .41598 .33463 .41165 Metetra
.656 .751 .919 r
.33463 .41165 .33896 .41598 .35089 .41192 .34658 .40757 Metetra
.868 .774 .756 r
.34658 .40757 .35089 .41192 .36288 .40783 .35934 .38959 Metetra
.592 .457 .666 r
.35934 .38959 .36288 .40783 .37528 .3966 .37136 .38546 Metetra
.62 .541 .743 r
.37136 .38546 .37528 .3966 .38766 .38572 .38343 .3813 Metetra
.772 .776 .856 r
.38343 .3813 .38766 .38572 .39977 .38157 .39575 .37251 Metetra
.709 .622 .758 r
.39575 .37251 .39977 .38157 .4121 .37278 .4081 .36371 Metetra
.633 .585 .782 r
.4081 .36371 .4121 .37278 .42435 .36717 .42031 .35949 Metetra
.819 .692 .724 r
.42031 .35949 .42435 .36717 .43736 .33694 .43299 .34149 Metetra
.533 .829 .498 r
.43299 .34149 .43736 .33694 .44958 .33267 .4455 .32811 Metetra
.66 .746 .914 r
.4455 .32811 .44958 .33267 .46185 .32839 .45779 .3238 Metetra
.66 .746 .914 r
.45779 .3238 .46185 .32839 .47425 .31954 .47015 .31947 Metetra
.715 .979 .912 r
.47015 .31947 .47425 .31954 .48668 .31068 .48261 .31138 Metetra
.425 .868 .82 r
.48261 .31138 .48668 .31068 .49909 .30633 .49507 .3062 Metetra
.751 .985 .903 r
.49507 .3062 .49909 .30633 .51156 .30195 .50761 .29727 Metetra
.661 .745 .913 r
.50761 .29727 .51156 .30195 .52409 .29565 .52016 .29285 Metetra
.722 .864 .949 r
.52016 .29285 .52409 .29565 .53667 .29122 .53277 .28649 Metetra
.733 .768 .881 r
.53277 .28649 .53667 .29122 .54929 .28416 .54542 .2794 Metetra
.661 .745 .912 r
.54542 .2794 .54929 .28416 .56193 .27517 .55813 .27491 Metetra
.47 .889 .909 r
.55813 .27491 .56193 .27517 .57466 .27068 .57091 .2704 Metetra
.746 .986 .901 r
.57091 .2704 .57466 .27068 .58736 .26165 .58366 .26133 Metetra
.473 .891 .911 r
.58366 .26133 .58736 .26165 .6002 .25711 .59654 .25677 Metetra
.745 .986 .9 r
.59654 .25677 .6002 .25711 .6131 .25254 .60935 .24766 Metetra
.662 .744 .911 r
.60935 .24766 .6131 .25254 .62607 .24796 .62234 .24306 Metetra
.662 .744 .911 r
.62234 .24306 .62607 .24796 .63909 .24335 .63539 .23842 Metetra
.662 .744 .911 r
.63539 .23842 .63909 .24335 .65218 .23872 .64851 .23377 Metetra
.662 .744 .911 r
.64851 .23377 .65218 .23872 .66534 .23407 .66169 .22909 Metetra
.662 .744 .911 r
.66169 .22909 .66534 .23407 .67856 .2294 .67494 .22439 Metetra
.662 .744 .911 r
.67494 .22439 .67856 .2294 .69185 .2247 .68825 .21967 Metetra
.662 .744 .911 r
.68825 .21967 .69185 .2247 .70467 .21163 .70163 .21493 Metetra
.70163 .21493 .70467 .21163 .71739 .19715 .71477 .20561 Metetra
.322 0 .133 r
.71477 .20561 .71739 .19715 .73078 .19237 .72826 .20081 Metetra
.259 0 .113 r
.72826 .20081 .73078 .19237 .7439 .18307 .74165 .19385 Metetra
.314 0 .199 r
.74165 .19385 .7439 .18307 .75741 .17824 .75507 .1866 Metetra
.75507 .1866 .75741 .17824 .77098 .17338 .76757 .16818 Metetra
.651 .756 .926 r
.15072 .52241 .15544 .5264 .16677 .52266 .16207 .51865 Metetra
.651 .756 .926 r
.16207 .51865 .16677 .52266 .17816 .51889 .17347 .51487 Metetra
.892 .75 .698 r
.17347 .51487 .17816 .51889 .19207 .49157 .18744 .4875 Metetra
.654 .754 .923 r
.18744 .4875 .19207 .49157 .20348 .48774 .19887 .48365 Metetra
.654 .754 .923 r
.19887 .48365 .20348 .48774 .21495 .4839 .21035 .47979 Metetra
.83 .772 .798 r
.21035 .47979 .21495 .4839 .22735 .47069 .22279 .46655 Metetra
.654 .753 .922 r
.22279 .46655 .22735 .47069 .23889 .4668 .23435 .46264 Metetra
.654 .753 .922 r
.23435 .46264 .23889 .4668 .25049 .46289 .24596 .45871 Metetra
.654 .753 .922 r
.24596 .45871 .25049 .46289 .26213 .45896 .25763 .45477 Metetra
.654 .753 .922 r
.25763 .45477 .26213 .45896 .27384 .45502 .26935 .4508 Metetra
.654 .753 .922 r
.26935 .4508 .27384 .45502 .28646 .43979 .28113 .44682 Metetra
.262 0 .024 r
.28113 .44682 .28646 .43979 .29871 .42924 .29296 .44282 Metetra
.29296 .44282 .29871 .42924 .31089 .41976 .3065 .41546 Metetra
.656 .751 .919 r
.3065 .41546 .31089 .41976 .32273 .41572 .31836 .41139 Metetra
.656 .751 .919 r
.31836 .41139 .32273 .41572 .33463 .41165 .33028 .40731 Metetra
.867 .773 .756 r
.33028 .40731 .33463 .41165 .34658 .40757 .34308 .38933 Metetra
.591 .456 .665 r
.34308 .38933 .34658 .40757 .35934 .38959 .35505 .38519 Metetra
.657 .749 .918 r
.35505 .38519 .35934 .38959 .37136 .38546 .36709 .38103 Metetra
.772 .775 .856 r
.36709 .38103 .37136 .38546 .38343 .3813 .3794 .37224 Metetra
.672 .605 .771 r
.3794 .37224 .38343 .3813 .39575 .37251 .39163 .36588 Metetra
.703 .678 .823 r
.39163 .36588 .39575 .37251 .4081 .36371 .40391 .35921 Metetra
.658 .748 .917 r
.40391 .35921 .4081 .36371 .42031 .35949 .41614 .35497 Metetra
.772 .776 .856 r
.41614 .35497 .42031 .35949 .43299 .34149 .42857 .3461 Metetra
.533 .829 .498 r
.42857 .3461 .43299 .34149 .4455 .32811 .44115 .33264 Metetra
.44115 .33264 .4455 .32811 .45779 .3238 .45361 .32375 Metetra
.753 .985 .905 r
.45361 .32375 .45779 .3238 .47015 .31947 .46609 .31484 Metetra
.66 .746 .914 r
.46609 .31484 .47015 .31947 .48261 .31138 .47853 .31047 Metetra
.549 .906 .968 r
.47853 .31047 .48261 .31138 .49507 .3062 .49102 .30608 Metetra
.463 .886 .905 r
.49102 .30608 .49507 .3062 .50761 .29727 .50357 .30166 Metetra
.50357 .30166 .50761 .29727 .52016 .29285 .5162 .29267 Metetra
.641 .96 .92 r
.5162 .29267 .52016 .29285 .53277 .28649 .52885 .28579 Metetra
.663 .955 .947 r
.52885 .28579 .53277 .28649 .54542 .2794 .54155 .27917 Metetra
.47 .889 .909 r
.54155 .27917 .54542 .2794 .55813 .27491 .5543 .27466 Metetra
.47 .889 .909 r
.5543 .27466 .55813 .27491 .57091 .2704 .56713 .27013 Metetra
.47 .889 .909 r
.56713 .27013 .57091 .2704 .58366 .26133 .58001 .26557 Metetra
.58001 .26557 .58366 .26133 .59654 .25677 .59285 .25644 Metetra
.745 .986 .9 r
.59285 .25644 .59654 .25677 .60935 .24766 .60571 .24729 Metetra
.476 .892 .913 r
.60571 .24729 .60935 .24766 .62234 .24306 .61875 .24266 Metetra
.476 .892 .913 r
.61875 .24266 .62234 .24306 .63539 .23842 .63185 .23801 Metetra
.476 .892 .913 r
.63185 .23801 .63539 .23842 .64851 .23377 .64501 .23334 Metetra
.741 .987 .897 r
.64501 .23334 .64851 .23377 .66169 .22909 .65802 .22409 Metetra
.662 .744 .911 r
.65802 .22409 .66169 .22909 .67494 .22439 .6713 .21937 Metetra
.662 .744 .911 r
.6713 .21937 .67494 .22439 .68825 .21967 .68463 .21462 Metetra
.662 .744 .911 r
.68463 .21462 .68825 .21967 .70163 .21493 .69804 .20985 Metetra
.662 .744 .911 r
.69804 .20985 .70163 .21493 .71477 .20561 .71151 .20505 Metetra
.479 .893 .915 r
.71151 .20505 .71477 .20561 .72826 .20081 .72505 .20023 Metetra
.479 .893 .915 r
.72505 .20023 .72826 .20081 .74165 .19385 .73865 .19539 Metetra
.73865 .19539 .74165 .19385 .75507 .1866 .75233 .19052 Metetra
.819 .87 .429 r
.75233 .19052 .75507 .1866 .76757 .16818 .76414 .16296 Metetra
.89 .748 .699 r
.14597 .51841 .15072 .52241 .16207 .51865 .16006 .49108 Metetra
.57 .404 .617 r
.16006 .49108 .16207 .51865 .17347 .51487 .1714 .48725 Metetra
.57 .404 .617 r
.1714 .48725 .17347 .51487 .18744 .4875 .18279 .4834 Metetra
.654 .754 .923 r
.18279 .4834 .18744 .4875 .19887 .48365 .19424 .47954 Metetra
.654 .754 .923 r
.19424 .47954 .19887 .48365 .21035 .47979 .20574 .47566 Metetra
.654 .754 .923 r
.20574 .47566 .21035 .47979 .22279 .46655 .21729 .47176 Metetra
.599 .88 .565 r
.21729 .47176 .22279 .46655 .23435 .46264 .22979 .45846 Metetra
.654 .753 .922 r
.22979 .45846 .23435 .46264 .24596 .45871 .24142 .45451 Metetra
.654 .753 .922 r
.24142 .45451 .24596 .45871 .25763 .45477 .2531 .45055 Metetra
.654 .753 .922 r
.2531 .45055 .25763 .45477 .26935 .4508 .26484 .44656 Metetra
.654 .753 .922 r
.26484 .44656 .26935 .4508 .28113 .44682 .27664 .44256 Metetra
.9 .758 .696 r
.27664 .44256 .28113 .44682 .29296 .44282 .29027 .4152 Metetra
.571 .405 .617 r
.29027 .4152 .29296 .44282 .3065 .41546 .30209 .41113 Metetra
.866 .771 .756 r
.30209 .41113 .3065 .41546 .31836 .41139 .31492 .39318 Metetra
.591 .456 .665 r
.31492 .39318 .31836 .41139 .33028 .40731 .3268 .38906 Metetra
.591 .456 .665 r
.3268 .38906 .33028 .40731 .34308 .38933 .33875 .38492 Metetra
.657 .749 .918 r
.33875 .38492 .34308 .38933 .35505 .38519 .35074 .38077 Metetra
.833 .778 .8 r
.35074 .38077 .35505 .38519 .36709 .38103 .36329 .36738 Metetra
.619 .51 .707 r
.36329 .36738 .36709 .38103 .3794 .37224 .3754 .36236 Metetra
.681 .594 .752 r
.3754 .36236 .3794 .37224 .39163 .36588 .38768 .35489 Metetra
.621 .545 .747 r
.38768 .35489 .39163 .36588 .40391 .35921 .39986 .35064 Metetra
.647 .604 .792 r
.39986 .35064 .40391 .35921 .41614 .35497 .41211 .34582 Metetra
.633 .585 .783 r
.41211 .34582 .41614 .35497 .42857 .3461 .42441 .34153 Metetra
.734 .769 .881 r
.42441 .34153 .42857 .3461 .44115 .33264 .43684 .33451 Metetra
.43684 .33451 .44115 .33264 .45361 .32375 .44924 .33017 Metetra
.141 0 0 r
.44924 .33017 .45361 .32375 .46609 .31484 .46173 .32392 Metetra
.46173 .32392 .46609 .31484 .47853 .31047 .4744 .31036 Metetra
.752 .985 .904 r
.4744 .31036 .47853 .31047 .49102 .30608 .48699 .30138 Metetra
.66 .746 .914 r
.48699 .30138 .49102 .30608 .50357 .30166 .49957 .29694 Metetra
.677 .752 .908 r
.49957 .29694 .50357 .30166 .5162 .29267 .51221 .29195 Metetra
.754 .971 .926 r
.51221 .29195 .5162 .29267 .52885 .28579 .5249 .28343 Metetra
.632 .869 .987 r
.5249 .28343 .52885 .28579 .54155 .27917 .53764 .27893 Metetra
.748 .986 .902 r
.53764 .27893 .54155 .27917 .5543 .27466 .5504 .26983 Metetra
.661 .745 .913 r
.5504 .26983 .5543 .27466 .56713 .27013 .56325 .26528 Metetra
.773 .779 .858 r
.56325 .26528 .56713 .27013 .58001 .26557 .57608 .25615 Metetra
.709 .623 .759 r
.57608 .25615 .58001 .26557 .59285 .25644 .58893 .24699 Metetra
.634 .585 .781 r
.58893 .24699 .59285 .25644 .60571 .24729 .60192 .24236 Metetra
.773 .779 .858 r
.60192 .24236 .60571 .24729 .61875 .24266 .61484 .23317 Metetra
.634 .585 .781 r
.61484 .23317 .61875 .24266 .63185 .23801 .62794 .22849 Metetra
.634 .585 .781 r
.62794 .22849 .63185 .23801 .64501 .23334 .64111 .22379 Metetra
.634 .585 .781 r
.64111 .22379 .64501 .23334 .65802 .22409 .65434 .21906 Metetra
.662 .744 .911 r
.65434 .21906 .65802 .22409 .6713 .21937 .66764 .21431 Metetra
.662 .744 .911 r
.66764 .21431 .6713 .21937 .68463 .21462 .681 .20954 Metetra
.662 .744 .911 r
.681 .20954 .68463 .21462 .69804 .20985 .69443 .20474 Metetra
.662 .744 .911 r
.69443 .20474 .69804 .20985 .71151 .20505 .70793 .19992 Metetra
.662 .744 .911 r
.70793 .19992 .71151 .20505 .72505 .20023 .72149 .19508 Metetra
.844 .8 .808 r
.72149 .19508 .72505 .20023 .73865 .19539 .73445 .1811 Metetra
.712 .564 .686 r
.73445 .1811 .73865 .19539 .75233 .19052 .74739 .16715 Metetra
.619 .453 .635 r
.74739 .16715 .75233 .19052 .76414 .16296 .76069 .1577 Metetra
.89 .748 .699 r
.14121 .51438 .14597 .51841 .16006 .49108 .15535 .487 Metetra
.654 .754 .923 r
.15535 .487 .16006 .49108 .1714 .48725 .16671 .48316 Metetra
.654 .754 .923 r
.16671 .48316 .1714 .48725 .18279 .4834 .17812 .47929 Metetra
.654 .754 .923 r
.17812 .47929 .18279 .4834 .19424 .47954 .18958 .47541 Metetra
.654 .754 .923 r
.18958 .47541 .19424 .47954 .20574 .47566 .2011 .47151 Metetra
.654 .754 .923 r
.2011 .47151 .20574 .47566 .21729 .47176 .21267 .46759 Metetra
.83 .773 .798 r
.21267 .46759 .21729 .47176 .22979 .45846 .2252 .45426 Metetra
.654 .753 .922 r
.2252 .45426 .22979 .45846 .24142 .45451 .23685 .45029 Metetra
.654 .753 .922 r
.23685 .45029 .24142 .45451 .2531 .45055 .24855 .4463 Metetra
.864 .769 .755 r
.24855 .4463 .2531 .45055 .26484 .44656 .26151 .42827 Metetra
.59 .454 .665 r
.26151 .42827 .26484 .44656 .27664 .44256 .27327 .42423 Metetra
.678 .514 .656 r
.27327 .42423 .27664 .44256 .29027 .4152 .28581 .41087 Metetra
.772 .774 .855 r
.28581 .41087 .29027 .4152 .30209 .41113 .298 .40215 Metetra
.761 .645 .733 r
.298 .40215 .30209 .41113 .31492 .39318 .31053 .3888 Metetra
.657 .749 .918 r
.31053 .3888 .31492 .39318 .3268 .38906 .32243 .38466 Metetra
.657 .749 .918 r
.32243 .38466 .3268 .38906 .33875 .38492 .33439 .3805 Metetra
.832 .777 .8 r
.33439 .3805 .33875 .38492 .35074 .38077 .34695 .36711 Metetra
.607 .503 .709 r
.34695 .36711 .35074 .38077 .36329 .36738 .35899 .3629 Metetra
.658 .748 .917 r
.35899 .3629 .36329 .36738 .3754 .36236 .37109 .35867 Metetra
.686 .797 .934 r
.37109 .35867 .3754 .36236 .38768 .35489 .38328 .35361 Metetra
.751 .936 .947 r
.38328 .35361 .38768 .35489 .39986 .35064 .39563 .34609 Metetra
.659 .748 .916 r
.39563 .34609 .39986 .35064 .41211 .34582 .40788 .3418 Metetra
.677 .781 .928 r
.40788 .3418 .41211 .34582 .42441 .34153 .42022 .33694 Metetra
.659 .748 .916 r
.42022 .33694 .42441 .34153 .43684 .33451 .43259 .3326 Metetra
.706 .905 .966 r
.43259 .3326 .43684 .33451 .44924 .33017 .44507 .3264 Metetra
.688 .8 .935 r
.44507 .3264 .44924 .33017 .46173 .32392 .45758 .32115 Metetra
.887 .856 .806 r
.45758 .32115 .46173 .32392 .4744 .31036 .47032 .30567 Metetra
.772 .777 .857 r
.47032 .30567 .4744 .31036 .48699 .30138 .48294 .29666 Metetra
.66 .746 .914 r
.48294 .29666 .48699 .30138 .49957 .29694 .49554 .2922 Metetra
.772 .777 .857 r
.49554 .2922 .49957 .29694 .51221 .29195 .50822 .28314 Metetra
.77 .66 .741 r
.50822 .28314 .51221 .29195 .5249 .28343 .52093 .26953 Metetra
.618 .509 .708 r
.52093 .26953 .5249 .28343 .53764 .27893 .53366 .26434 Metetra
.606 .495 .701 r
.53366 .26434 .53764 .27893 .5504 .26983 .54644 .25978 Metetra
.748 .63 .73 r
.54644 .25978 .5504 .26983 .56325 .26528 .55918 .24678 Metetra
.592 .457 .666 r
.55918 .24678 .56325 .26528 .57608 .25615 .57206 .24216 Metetra
.609 .504 .709 r
.57206 .24216 .57608 .25615 .58893 .24699 .58499 .23753 Metetra
.634 .585 .781 r
.58499 .23753 .58893 .24699 .60192 .24236 .59799 .23287 Metetra
.634 .585 .781 r
.59799 .23287 .60192 .24236 .61484 .23317 .61105 .22819 Metetra
.662 .744 .911 r
.61105 .22819 .61484 .23317 .62794 .22849 .62418 .22349 Metetra
.662 .744 .911 r
.62418 .22349 .62794 .22849 .64111 .22379 .63737 .21876 Metetra
.662 .744 .911 r
.63737 .21876 .64111 .22379 .65434 .21906 .65063 .21401 Metetra
.662 .744 .911 r
.65063 .21401 .65434 .21906 .66764 .21431 .66395 .20923 Metetra
.81 .79 .834 r
.66395 .20923 .66764 .21431 .681 .20954 .67699 .19775 Metetra
.658 .561 .735 r
.67699 .19775 .681 .20954 .69443 .20474 .69027 .19052 Metetra
.712 .564 .686 r
.69027 .19052 .69443 .20474 .70793 .19992 .70318 .17663 Metetra
.581 .428 .638 r
.70318 .17663 .70793 .19992 .72149 .19508 .71668 .17174 Metetra
.619 .452 .635 r
.71668 .17174 .72149 .19508 .73445 .1811 .72992 .16232 Metetra
.593 .458 .666 r
.72992 .16232 .73445 .1811 .74739 .16715 .74354 .15739 Metetra
.635 .585 .781 r
.74354 .15739 .74739 .16715 .76069 .1577 .75722 .15242 Metetra
.569 .402 .616 r
.1393 .48676 .14121 .51438 .15535 .487 .15062 .48291 Metetra
.828 .769 .797 r
.15062 .48291 .15535 .487 .16671 .48316 .16307 .46969 Metetra
.605 .501 .709 r
.16307 .46969 .16671 .48316 .17812 .47929 .17447 .46579 Metetra
.605 .501 .709 r
.17447 .46579 .17812 .47929 .18958 .47541 .18592 .46188 Metetra
.746 .585 .677 r
.18592 .46188 .18958 .47541 .2011 .47151 .19888 .44398 Metetra
.638 .454 .618 r
.19888 .44398 .2011 .47151 .21267 .46759 .21133 .43076 Metetra
.559 .377 .591 r
.21133 .43076 .21267 .46759 .2252 .45426 .22286 .42677 Metetra
.606 .43 .618 r
.22286 .42677 .2252 .45426 .23685 .45029 .23488 .41814 Metetra
.624 .434 .605 r
.23488 .41814 .23685 .45029 .24855 .4463 .24733 .4049 Metetra
.555 .368 .582 r
.24733 .4049 .24855 .4463 .26151 .42827 .25898 .40084 Metetra
.57 .404 .617 r
.25898 .40084 .26151 .42827 .27327 .42423 .27068 .39676 Metetra
.57 .404 .617 r
.27068 .39676 .27327 .42423 .28581 .41087 .28243 .39265 Metetra
.59 .455 .665 r
.28243 .39265 .28581 .41087 .298 .40215 .29425 .38853 Metetra
.667 .538 .699 r
.29425 .38853 .298 .40215 .31053 .3888 .30644 .37979 Metetra
.709 .622 .758 r
.30644 .37979 .31053 .3888 .32243 .38466 .31866 .37103 Metetra
.607 .502 .709 r
.31866 .37103 .32243 .38466 .33439 .3805 .33061 .36684 Metetra
.607 .502 .709 r
.33061 .36684 .33439 .3805 .34695 .36711 .34261 .36263 Metetra
.684 .756 .906 r
.34261 .36263 .34695 .36711 .35899 .3629 .35471 .35759 Metetra
.735 .734 .85 r
.35471 .35759 .35899 .3629 .37109 .35867 .367 .35009 Metetra
.647 .604 .792 r
.367 .35009 .37109 .35867 .38328 .35361 .37918 .34527 Metetra
.674 .623 .79 r
.37918 .34527 .38328 .35361 .39563 .34609 .39148 .33914 Metetra
.668 .658 .831 r
.39148 .33914 .39563 .34609 .40788 .3418 .40378 .33395 Metetra
.642 .621 .814 r
.40378 .33395 .40788 .3418 .42022 .33694 .41611 .32961 Metetra
.645 .638 .829 r
.41611 .32961 .42022 .33694 .43259 .3326 .42849 .32525 Metetra
.693 .659 .812 r
.42849 .32525 .43259 .3326 .44507 .3264 .441 .31862 Metetra
.786 .684 .752 r
.441 .31862 .44507 .3264 .45758 .32115 .45372 .30473 Metetra
.629 .494 .679 r
.45372 .30473 .45758 .32115 .47032 .30567 .46628 .29768 Metetra
.669 .633 .804 r
.46628 .29768 .47032 .30567 .48294 .29666 .47887 .29191 Metetra
.66 .746 .914 r
.47887 .29191 .48294 .29666 .49554 .2922 .49149 .28743 Metetra
.772 .777 .857 r
.49149 .28743 .49554 .2922 .50822 .28314 .5042 .27835 Metetra
.66 .746 .913 r
.5042 .27835 .50822 .28314 .52093 .26953 .51693 .27382 Metetra
.102 0 0 r
.51693 .27382 .52093 .26953 .53366 .26434 .52972 .26926 Metetra
.52972 .26926 .53366 .26434 .54644 .25978 .54254 .26011 Metetra
.395 .853 .838 r
.54254 .26011 .54644 .25978 .55918 .24678 .55543 .25551 Metetra
.036 0 .005 r
.55543 .25551 .55918 .24678 .57206 .24216 .56828 .24359 Metetra
.686 .969 .762 r
.56828 .24359 .57206 .24216 .58499 .23753 .58114 .23257 Metetra
.662 .744 .911 r
.58114 .23257 .58499 .23753 .59799 .23287 .59416 .22789 Metetra
.662 .744 .911 r
.59416 .22789 .59799 .23287 .61105 .22819 .60725 .22318 Metetra
.662 .744 .911 r
.60725 .22318 .61105 .22819 .62418 .22349 .6204 .21845 Metetra
.662 .744 .911 r
.6204 .21845 .62418 .22349 .63737 .21876 .63362 .2137 Metetra
.662 .744 .911 r
.63362 .2137 .63737 .21876 .65063 .21401 .6469 .20893 Metetra
.662 .744 .911 r
.6469 .20893 .65063 .21401 .66395 .20923 .66025 .20413 Metetra
.662 .744 .911 r
.66025 .20413 .66395 .20923 .67699 .19775 .67367 .1993 Metetra
.67367 .1993 .67699 .19775 .69027 .19052 .68716 .19445 Metetra
.09 0 0 r
.68716 .19445 .69027 .19052 .70318 .17663 .70071 .18958 Metetra
.188 0 .194 r
.70071 .18958 .70318 .17663 .71668 .17174 .71372 .17557 Metetra
.085 0 0 r
.71372 .17557 .71668 .17174 .72992 .16232 .72736 .17064 Metetra
0 0 .014 r
.72736 .17064 .72992 .16232 .74354 .15739 .74037 .15662 Metetra
.5 .901 .928 r
.74037 .15662 .74354 .15739 .75722 .15242 .75411 .15163 Metetra
.654 .754 .923 r
.13452 .48266 .1393 .48676 .15062 .48291 .14586 .47879 Metetra
.771 .772 .853 r
.14586 .47879 .15062 .48291 .16307 .46969 .1578 .47022 Metetra
.766 .981 .911 r
.1578 .47022 .16307 .46969 .17447 .46579 .16976 .46163 Metetra
.891 .75 .698 r
.16976 .46163 .17447 .46579 .18592 .46188 .18378 .43448 Metetra
.569 .403 .616 r
.18378 .43448 .18592 .46188 .19888 .44398 .19522 .4305 Metetra
.667 .539 .699 r
.19522 .4305 .19888 .44398 .21133 .43076 .20719 .4219 Metetra
.631 .585 .784 r
.20719 .4219 .21133 .43076 .22286 .42677 .21873 .41788 Metetra
.631 .585 .784 r
.21873 .41788 .22286 .42677 .23488 .41814 .23031 .41384 Metetra
.829 .771 .798 r
.23031 .41384 .23488 .41814 .24733 .4049 .2428 .40058 Metetra
.657 .749 .918 r
.2428 .40058 .24733 .4049 .25898 .40084 .25447 .39649 Metetra
.657 .749 .918 r
.25447 .39649 .25898 .40084 .27068 .39676 .26618 .39239 Metetra
.657 .749 .918 r
.26618 .39239 .27068 .39676 .28243 .39265 .27796 .38827 Metetra
.657 .749 .918 r
.27796 .38827 .28243 .39265 .29425 .38853 .28979 .38412 Metetra
.771 .773 .854 r
.28979 .38412 .29425 .38853 .30644 .37979 .30201 .37535 Metetra
.658 .749 .917 r
.30201 .37535 .30644 .37979 .31866 .37103 .31394 .37117 Metetra
.763 .982 .91 r
.31394 .37117 .31866 .37103 .33061 .36684 .32622 .36236 Metetra
.658 .748 .917 r
.32622 .36236 .33061 .36684 .34261 .36263 .33825 .35812 Metetra
.772 .774 .855 r
.33825 .35812 .34261 .36263 .35471 .35759 .35059 .34927 Metetra
.638 .606 .801 r
.35059 .34927 .35471 .35759 .367 .35009 .36271 .345 Metetra
.657 .723 .897 r
.36271 .345 .367 .35009 .37918 .34527 .37489 .3407 Metetra
.734 .768 .88 r
.37489 .3407 .37918 .34527 .39148 .33914 .38725 .33368 Metetra
.656 .708 .886 r
.38725 .33368 .39148 .33914 .40378 .33395 .39954 .32933 Metetra
.659 .748 .916 r
.39954 .32933 .40378 .33395 .41611 .32961 .41188 .32497 Metetra
.844 .782 .791 r
.41188 .32497 .41611 .32961 .42849 .32525 .42463 .31043 Metetra
.616 .498 .696 r
.42463 .31043 .42849 .32525 .441 .31862 .43708 .3051 Metetra
.653 .534 .706 r
.43708 .3051 .441 .31862 .45372 .30473 .44964 .29739 Metetra
.646 .641 .83 r
.44964 .29739 .45372 .30473 .46628 .29768 .46217 .29293 Metetra
.794 .78 .84 r
.46217 .29293 .46628 .29768 .47887 .29191 .47485 .28257 Metetra
.709 .623 .759 r
.47485 .28257 .47887 .29191 .49149 .28743 .48753 .2735 Metetra
.608 .503 .709 r
.48753 .2735 .49149 .28743 .5042 .27835 .5002 .26896 Metetra
.709 .623 .759 r
.5002 .26896 .5042 .27835 .51693 .27382 .51295 .25985 Metetra
.624 .513 .707 r
.51295 .25985 .51693 .27382 .52972 .26926 .52572 .25412 Metetra
.624 .502 .693 r
.52572 .25412 .52972 .26926 .54254 .26011 .53854 .24792 Metetra
.617 .53 .733 r
.53854 .24792 .54254 .26011 .55543 .25551 .55142 .24329 Metetra
.645 .546 .728 r
.55142 .24329 .55543 .25551 .56828 .24359 .56435 .23681 Metetra
.745 .704 .813 r
.56435 .23681 .56828 .24359 .58114 .23257 .57727 .22759 Metetra
.662 .744 .911 r
.57727 .22759 .58114 .23257 .59416 .22789 .59032 .22288 Metetra
.662 .744 .911 r
.59032 .22288 .59416 .22789 .60725 .22318 .60343 .21815 Metetra
.662 .744 .911 r
.60343 .21815 .60725 .22318 .6204 .21845 .61661 .2134 Metetra
.662 .744 .911 r
.61661 .2134 .6204 .21845 .63362 .2137 .62985 .20862 Metetra
.662 .744 .911 r
.62985 .20862 .63362 .2137 .6469 .20893 .64316 .20382 Metetra
.662 .744 .911 r
.64316 .20382 .6469 .20893 .66025 .20413 .65654 .19899 Metetra
.662 .744 .911 r
.65654 .19899 .66025 .20413 .67367 .1993 .66998 .19414 Metetra
.662 .744 .911 r
.66998 .19414 .67367 .1993 .68716 .19445 .68349 .18927 Metetra
.662 .744 .911 r
.68349 .18927 .68716 .19445 .70071 .18958 .69707 .18437 Metetra
.724 .768 .887 r
.69707 .18437 .70071 .18958 .71372 .17557 .71057 .17716 Metetra
.71057 .17716 .71372 .17557 .72736 .17064 .7242 .17123 Metetra
.418 .86 .778 r
.7242 .17123 .72736 .17064 .74037 .15662 .73787 .16495 Metetra
.16 0 .065 r
.73787 .16495 .74037 .15662 .75411 .15163 .75134 .15538 Metetra
.903 .737 .665 r
.12973 .47854 .13452 .48266 .14586 .47879 .14506 .44212 Metetra
.557 .375 .589 r
.14506 .44212 .14586 .47879 .1578 .47022 .15636 .43818 Metetra
.595 .412 .603 r
.15636 .43818 .1578 .47022 .16976 .46163 .16824 .42962 Metetra
.562 .387 .601 r
.16824 .42962 .16976 .46163 .18378 .43448 .17963 .42564 Metetra
.759 .643 .733 r
.17963 .42564 .18378 .43448 .19522 .4305 .19206 .41246 Metetra
.639 .488 .661 r
.19206 .41246 .19522 .4305 .20719 .4219 .20401 .40385 Metetra
.589 .454 .665 r
.20401 .40385 .20719 .4219 .21873 .41788 .21551 .3998 Metetra
.589 .454 .665 r
.21551 .3998 .21873 .41788 .23031 .41384 .22707 .39573 Metetra
.589 .454 .665 r
.22707 .39573 .23031 .41384 .2428 .40058 .23868 .39164 Metetra
.76 .644 .733 r
.23868 .39164 .2428 .40058 .25447 .39649 .25116 .37838 Metetra
.59 .454 .665 r
.25116 .37838 .25447 .39649 .26618 .39239 .26285 .37425 Metetra
.62 .475 .663 r
.26285 .37425 .26618 .39239 .27796 .38827 .27481 .3674 Metetra
.582 .435 .647 r
.27481 .3674 .27796 .38827 .28979 .38412 .2866 .36322 Metetra
.643 .477 .644 r
.2866 .36322 .28979 .38412 .30201 .37535 .29893 .35258 Metetra
.62 .453 .635 r
.29893 .35258 .30201 .37535 .31394 .37117 .31113 .34381 Metetra
.596 .422 .617 r
.31113 .34381 .31394 .37117 .32622 .36236 .32326 .33632 Metetra
.583 .417 .622 r
.32326 .33632 .32622 .36236 .33825 .35812 .3353 .33075 Metetra
.605 .429 .617 r
.3353 .33075 .33825 .35812 .35059 .34927 .34758 .32192 Metetra
.605 .429 .617 r
.34758 .32192 .35059 .34927 .36271 .345 .35988 .31307 Metetra
.564 .388 .602 r
.35988 .31307 .36271 .345 .37489 .3407 .37198 .30873 Metetra
.585 .404 .603 r
.37198 .30873 .37489 .3407 .38725 .33368 .38427 .30135 Metetra
.574 .395 .601 r
.38427 .30135 .38725 .33368 .39954 .32933 .39653 .29545 Metetra
.569 .389 .597 r
.39653 .29545 .39954 .32933 .41188 .32497 .40882 .28991 Metetra
.56 .38 .594 r
.40882 .28991 .41188 .32497 .42463 .31043 .42112 .28548 Metetra
.588 .424 .627 r
.42112 .28548 .42463 .31043 .43708 .3051 .43353 .27944 Metetra
.623 .447 .623 r
.43353 .27944 .43708 .3051 .44964 .29739 .44612 .26864 Metetra
.569 .399 .612 r
.44612 .26864 .44964 .29739 .46217 .29293 .45857 .26413 Metetra
.569 .399 .612 r
.45857 .26413 .46217 .29293 .47485 .28257 .47107 .25961 Metetra
.579 .425 .637 r
.47107 .25961 .47485 .28257 .48753 .2735 .48364 .25506 Metetra
.591 .456 .665 r
.48364 .25506 .48753 .2735 .5002 .26896 .49628 .25048 Metetra
.591 .456 .665 r
.49628 .25048 .5002 .26896 .51295 .25985 .50897 .24589 Metetra
.608 .503 .709 r
.50897 .24589 .51295 .25985 .52572 .25412 .52172 .24127 Metetra
.614 .519 .724 r
.52172 .24127 .52572 .25412 .53854 .24792 .53454 .23663 Metetra
.622 .546 .748 r
.53454 .23663 .53854 .24792 .55142 .24329 .54742 .23197 Metetra
.622 .546 .748 r
.54742 .23197 .55142 .24329 .56435 .23681 .56037 .22729 Metetra
.634 .585 .782 r
.56037 .22729 .56435 .23681 .57727 .22759 .57338 .22258 Metetra
.662 .744 .911 r
.57338 .22258 .57727 .22759 .59032 .22288 .58645 .21784 Metetra
.662 .744 .911 r
.58645 .21784 .59032 .22288 .60343 .21815 .59959 .21309 Metetra
.662 .744 .911 r
.59959 .21309 .60343 .21815 .61661 .2134 .61279 .20831 Metetra
.746 .773 .874 r
.61279 .20831 .61661 .2134 .62985 .20862 .62594 .20026 Metetra
.69 .643 .797 r
.62594 .20026 .62985 .20862 .64316 .20382 .63916 .19299 Metetra
.737 .618 .726 r
.63916 .19299 .64316 .20382 .65654 .19899 .65218 .1802 Metetra
.591 .456 .665 r
.65218 .1802 .65654 .19899 .66998 .19414 .66558 .17531 Metetra
.637 .485 .66 r
.66558 .17531 .66998 .19414 .68349 .18927 .6788 .16588 Metetra
.58 .426 .637 r
.6788 .16588 .68349 .18927 .69707 .18437 .69232 .16094 Metetra
.618 .451 .634 r
.69232 .16094 .69707 .18437 .71057 .17716 .70561 .15146 Metetra
.575 .415 .626 r
.70561 .15146 .71057 .17716 .7242 .17123 .71924 .14647 Metetra
.577 .419 .631 r
.71924 .14647 .7242 .17123 .73787 .16495 .73294 .14145 Metetra
.58 .426 .637 r
.73294 .14145 .73787 .16495 .75134 .15538 .74671 .13641 Metetra
.586 .397 .592 r
.12905 .44187 .12973 .47854 .14506 .44212 .14088 .43333 Metetra
.759 .642 .732 r
.14088 .43333 .14506 .44212 .15636 .43818 .15329 .4202 Metetra
.589 .453 .664 r
.15329 .4202 .15636 .43818 .16824 .42962 .16461 .41621 Metetra
.667 .539 .699 r
.16461 .41621 .16824 .42962 .17963 .42564 .1765 .40763 Metetra
.589 .453 .664 r
.1765 .40763 .17963 .42564 .19206 .41246 .18792 .40359 Metetra
.631 .585 .784 r
.18792 .40359 .19206 .41246 .20401 .40385 .19938 .39954 Metetra
.658 .749 .917 r
.19938 .39954 .20401 .40385 .21551 .3998 .2109 .39547 Metetra
.771 .769 .852 r
.2109 .39547 .21551 .3998 .22707 .39573 .22293 .3868 Metetra
.709 .622 .758 r
.22293 .3868 .22707 .39573 .23868 .39164 .23498 .37812 Metetra
.644 .525 .703 r
.23498 .37812 .23868 .39164 .25116 .37838 .24687 .3713 Metetra
.645 .639 .829 r
.24687 .3713 .25116 .37838 .26285 .37425 .25857 .36713 Metetra
.645 .639 .829 r
.25857 .36713 .26285 .37425 .27481 .3674 .27032 .36295 Metetra
.799 .773 .828 r
.27032 .36295 .27481 .3674 .2866 .36322 .28264 .35231 Metetra
.62 .544 .747 r
.28264 .35231 .2866 .36322 .29893 .35258 .29448 .34809 Metetra
.852 .772 .773 r
.29448 .34809 .29893 .35258 .31113 .34381 .30723 .33216 Metetra
.617 .532 .736 r
.30723 .33216 .31113 .34381 .32326 .33632 .31913 .32788 Metetra
.675 .62 .785 r
.31913 .32788 .32326 .33632 .3353 .33075 .33123 .32164 Metetra
.633 .585 .783 r
.33123 .32164 .3353 .33075 .34758 .32192 .34324 .31732 Metetra
.771 .771 .853 r
.34324 .31732 .34758 .32192 .35988 .31307 .35557 .30845 Metetra
.661 .745 .913 r
.35557 .30845 .35988 .31307 .37198 .30873 .36768 .30408 Metetra
.771 .772 .853 r
.36768 .30408 .37198 .30873 .38427 .30135 .38007 .29517 Metetra
.682 .69 .85 r
.38007 .29517 .38427 .30135 .39653 .29545 .39233 .28963 Metetra
.697 .708 .857 r
.39233 .28963 .39653 .29545 .40882 .28991 .40466 .28361 Metetra
.774 .717 .799 r
.40466 .28361 .40882 .28991 .42112 .28548 .41721 .27284 Metetra
.613 .519 .724 r
.41721 .27284 .42112 .28548 .43353 .27944 .42956 .26835 Metetra
.622 .546 .748 r
.42956 .26835 .43353 .27944 .44612 .26864 .44197 .26384 Metetra
.662 .744 .911 r
.44197 .26384 .44612 .26864 .45857 .26413 .45444 .25931 Metetra
.662 .744 .911 r
.45444 .25931 .45857 .26413 .47107 .25961 .46697 .25476 Metetra
.662 .744 .911 r
.46697 .25476 .47107 .25961 .48364 .25506 .47957 .25019 Metetra
.662 .744 .911 r
.47957 .25019 .48364 .25506 .49628 .25048 .49222 .24559 Metetra
.662 .744 .911 r
.49222 .24559 .49628 .25048 .50897 .24589 .50494 .24098 Metetra
.662 .744 .911 r
.50494 .24098 .50897 .24589 .52172 .24127 .51771 .23633 Metetra
.662 .744 .911 r
.51771 .23633 .52172 .24127 .53454 .23663 .53056 .23167 Metetra
.662 .744 .911 r
.53056 .23167 .53454 .23663 .54742 .23197 .54346 .22698 Metetra
.662 .744 .911 r
.54346 .22698 .54742 .23197 .56037 .22729 .55643 .22227 Metetra
.662 .744 .911 r
.55643 .22227 .56037 .22729 .57338 .22258 .56946 .21754 Metetra
.662 .744 .911 r
.56946 .21754 .57338 .22258 .58645 .21784 .58256 .21278 Metetra
.662 .744 .911 r
.58256 .21278 .58645 .21784 .59959 .21309 .59572 .208 Metetra
.662 .744 .911 r
.59572 .208 .59959 .21309 .61279 .20831 .60895 .2032 Metetra
.662 .744 .911 r
.60895 .2032 .61279 .20831 .62594 .20026 .62225 .19837 Metetra
.691 .926 .969 r
.62225 .19837 .62594 .20026 .63916 .19299 .63554 .19176 Metetra
.754 .969 .929 r
.63554 .19176 .63916 .19299 .65218 .1802 .64879 .18294 Metetra
.64879 .18294 .65218 .1802 .66558 .17531 .66212 .17534 Metetra
.416 .865 .853 r
.66212 .17534 .66558 .17531 .6788 .16588 .67565 .17041 Metetra
.085 0 0 r
.67565 .17041 .6788 .16588 .69232 .16094 .6892 .16473 Metetra
.067 0 0 r
.6892 .16473 .69232 .16094 .70561 .15146 .70285 .15975 Metetra
.145 0 .048 r
.70285 .15975 .70561 .15146 .71924 .14647 .71627 .15019 Metetra
.71627 .15019 .71924 .14647 .73294 .14145 .72971 .14061 Metetra
.745 .986 .9 r
.72971 .14061 .73294 .14145 .74671 .13641 .74317 .13102 Metetra
.639 .488 .661 r
.12604 .42392 .12905 .44187 .14088 .43333 .13785 .41538 Metetra
.588 .453 .664 r
.13785 .41538 .14088 .43333 .15329 .4202 .14912 .41139 Metetra
.631 .585 .784 r
.14912 .41139 .15329 .4202 .16461 .41621 .16044 .40737 Metetra
.781 .651 .72 r
.16044 .40737 .16461 .41621 .1765 .40763 .17318 .39155 Metetra
.668 .518 .672 r
.17318 .39155 .1765 .40763 .18792 .40359 .18528 .38109 Metetra
.577 .423 .636 r
.18528 .38109 .18792 .40359 .19938 .39954 .1967 .377 Metetra
.672 .491 .633 r
.1967 .377 .19938 .39954 .2109 .39547 .20938 .36129 Metetra
.573 .389 .595 r
.20938 .36129 .2109 .39547 .22293 .3868 .22106 .35522 Metetra
.562 .386 .601 r
.22106 .35522 .22293 .3868 .23498 .37812 .23259 .35106 Metetra
.569 .402 .616 r
.23259 .35106 .23498 .37812 .24687 .3713 .24418 .34688 Metetra
.613 .442 .627 r
.24418 .34688 .24687 .3713 .25857 .36713 .25622 .33817 Metetra
.6 .421 .61 r
.25622 .33817 .25857 .36713 .27032 .36295 .26829 .32946 Metetra
.568 .387 .596 r
.26829 .32946 .27032 .36295 .28264 .35231 .2801 .32409 Metetra
.58 .407 .612 r
.2801 .32409 .28264 .35231 .29448 .34809 .29199 .31825 Metetra
.579 .403 .607 r
.29199 .31825 .29448 .34809 .30723 .33216 .30394 .31216 Metetra
.63 .471 .649 r
.30394 .31216 .30723 .33216 .31913 .32788 .31612 .30337 Metetra
.574 .414 .627 r
.31612 .30337 .31913 .32788 .33123 .32164 .32803 .29903 Metetra
.578 .424 .636 r
.32803 .29903 .33123 .32164 .34324 .31732 .34 .29467 Metetra
.578 .424 .636 r
.34 .29467 .34324 .31732 .35557 .30845 .35202 .29028 Metetra
.59 .455 .665 r
.35202 .29028 .35557 .30845 .36768 .30408 .3641 .28588 Metetra
.59 .455 .665 r
.3641 .28588 .36768 .30408 .38007 .29517 .37624 .28146 Metetra
.607 .503 .709 r
.37624 .28146 .38007 .29517 .39233 .28963 .38843 .27702 Metetra
.613 .519 .724 r
.38843 .27702 .39233 .28963 .40466 .28361 .40068 .27255 Metetra
.622 .546 .748 r
.40068 .27255 .40466 .28361 .41721 .27284 .413 .26806 Metetra
.662 .744 .911 r
.413 .26806 .41721 .27284 .42956 .26835 .42537 .26355 Metetra
.662 .744 .911 r
.42537 .26355 .42956 .26835 .44197 .26384 .4378 .25902 Metetra
.662 .744 .911 r
.4378 .25902 .44197 .26384 .45444 .25931 .4503 .25447 Metetra
.662 .744 .911 r
.4503 .25447 .45444 .25931 .46697 .25476 .46285 .24989 Metetra
.662 .744 .911 r
.46285 .24989 .46697 .25476 .47957 .25019 .47547 .2453 Metetra
.662 .744 .911 r
.47547 .2453 .47957 .25019 .49222 .24559 .48814 .24068 Metetra
.662 .744 .911 r
.48814 .24068 .49222 .24559 .50494 .24098 .50088 .23604 Metetra
.662 .744 .911 r
.50088 .23604 .50494 .24098 .51771 .23633 .51368 .23137 Metetra
.662 .744 .911 r
.51368 .23137 .51771 .23633 .53056 .23167 .52655 .22668 Metetra
.662 .744 .911 r
.52655 .22668 .53056 .23167 .54346 .22698 .53948 .22197 Metetra
.662 .744 .911 r
.53948 .22197 .54346 .22698 .55643 .22227 .55247 .21723 Metetra
.662 .744 .911 r
.55247 .21723 .55643 .22227 .56946 .21754 .56553 .21248 Metetra
.662 .744 .911 r
.56553 .21248 .56946 .21754 .58256 .21278 .57865 .20769 Metetra
.662 .744 .911 r
.57865 .20769 .58256 .21278 .59572 .208 .59184 .20289 Metetra
.662 .744 .911 r
.59184 .20289 .59572 .208 .60895 .2032 .60509 .19806 Metetra
.662 .744 .911 r
.60509 .19806 .60895 .2032 .62225 .19837 .61841 .1932 Metetra
.662 .744 .911 r
.61841 .1932 .62225 .19837 .63554 .19176 .6318 .18832 Metetra
.717 .853 .946 r
.6318 .18832 .63554 .19176 .64879 .18294 .64518 .18166 Metetra
.646 .942 .96 r
.64518 .18166 .64879 .18294 .66212 .17534 .65862 .17523 Metetra
.6 .951 .883 r
.65862 .17523 .66212 .17534 .67565 .17041 .67207 .16783 Metetra
.741 .91 .951 r
.67207 .16783 .67565 .17041 .6892 .16473 .68555 .16014 Metetra
.662 .778 .935 r
.68555 .16014 .6892 .16473 .70285 .15975 .69924 .15513 Metetra
.866 .83 .81 r
.69924 .15513 .70285 .15975 .71627 .15019 .71233 .14029 Metetra
.709 .624 .76 r
.71233 .14029 .71627 .15019 .72971 .14061 .72578 .13069 Metetra
.634 .585 .781 r
.72578 .13069 .72971 .14061 .74317 .13102 .73961 .12559 Metetra
.78 .65 .719 r
.12186 .41513 .12604 .42392 .13785 .41538 .13459 .39937 Metetra
.668 .518 .672 r
.13459 .39937 .13785 .41538 .14912 .41139 .14663 .38896 Metetra
.62 .453 .635 r
.14663 .38896 .14912 .41139 .16044 .40737 .15845 .38039 Metetra
.624 .443 .617 r
.15845 .38039 .16044 .40737 .17318 .39155 .17059 .36925 Metetra
.586 .43 .636 r
.17059 .36925 .17318 .39155 .18528 .38109 .18203 .36426 Metetra
.606 .472 .672 r
.18203 .36426 .18528 .38109 .1967 .377 .19354 .3591 Metetra
.639 .488 .661 r
.19354 .3591 .1967 .377 .20938 .36129 .20546 .35047 Metetra
.689 .58 .729 r
.20546 .35047 .20938 .36129 .22106 .35522 .2174 .34182 Metetra
.607 .502 .709 r
.2174 .34182 .22106 .35522 .23259 .35106 .22892 .33763 Metetra
.607 .502 .709 r
.22892 .33763 .23259 .35106 .24418 .34688 .24049 .33342 Metetra
.667 .539 .699 r
.24049 .33342 .24418 .34688 .25622 .33817 .25252 .32471 Metetra
.667 .539 .699 r
.25252 .32471 .25622 .33817 .26829 .32946 .26458 .31599 Metetra
.607 .502 .709 r
.26458 .31599 .26829 .32946 .2801 .32409 .27628 .31171 Metetra
.613 .519 .724 r
.27628 .31171 .2801 .32409 .29199 .31825 .28804 .30741 Metetra
.622 .546 .748 r
.28804 .30741 .29199 .31825 .30394 .31216 .29986 .30309 Metetra
.633 .585 .782 r
.29986 .30309 .30394 .31216 .31612 .30337 .31173 .29875 Metetra
.662 .744 .911 r
.31173 .29875 .31612 .30337 .32803 .29903 .32366 .29438 Metetra
.662 .744 .911 r
.32366 .29438 .32803 .29903 .34 .29467 .33564 .29 Metetra
.662 .744 .911 r
.33564 .29 .34 .29467 .35202 .29028 .34768 .2856 Metetra
.662 .744 .911 r
.34768 .2856 .35202 .29028 .3641 .28588 .35978 .28117 Metetra
.662 .744 .911 r
.35978 .28117 .3641 .28588 .37624 .28146 .37194 .27673 Metetra
.662 .744 .911 r
.37194 .27673 .37624 .28146 .38843 .27702 .38416 .27226 Metetra
.662 .744 .911 r
.38416 .27226 .38843 .27702 .40068 .27255 .39643 .26777 Metetra
.662 .744 .911 r
.39643 .26777 .40068 .27255 .413 .26806 .40876 .26326 Metetra
.662 .744 .911 r
.40876 .26326 .413 .26806 .42537 .26355 .42116 .25873 Metetra
.662 .744 .911 r
.42116 .25873 .42537 .26355 .4378 .25902 .43361 .25418 Metetra
.662 .744 .911 r
.43361 .25418 .4378 .25902 .4503 .25447 .44613 .2496 Metetra
.662 .744 .911 r
.44613 .2496 .4503 .25447 .46285 .24989 .45871 .245 Metetra
.662 .744 .911 r
.45871 .245 .46285 .24989 .47547 .2453 .47134 .24038 Metetra
.662 .744 .911 r
.47134 .24038 .47547 .2453 .48814 .24068 .48404 .23574 Metetra
.662 .744 .911 r
.48404 .23574 .48814 .24068 .50088 .23604 .49681 .23107 Metetra
.662 .744 .911 r
.49681 .23107 .50088 .23604 .51368 .23137 .50963 .22638 Metetra
.662 .744 .911 r
.50963 .22638 .51368 .23137 .52655 .22668 .52252 .22167 Metetra
.662 .744 .911 r
.52252 .22167 .52655 .22668 .53948 .22197 .53547 .21693 Metetra
.662 .744 .911 r
.53547 .21693 .53948 .22197 .55247 .21723 .54849 .21217 Metetra
.662 .744 .911 r
.54849 .21217 .55247 .21723 .56553 .21248 .56157 .20739 Metetra
.662 .744 .911 r
.56157 .20739 .56553 .21248 .57865 .20769 .57472 .20258 Metetra
.662 .744 .911 r
.57472 .20258 .57865 .20769 .59184 .20289 .58793 .19775 Metetra
.662 .744 .911 r
.58793 .19775 .59184 .20289 .60509 .19806 .60121 .19289 Metetra
.662 .744 .911 r
.60121 .19289 .60509 .19806 .61841 .1932 .61456 .18801 Metetra
.746 .773 .875 r
.61456 .18801 .61841 .1932 .6318 .18832 .62786 .17984 Metetra
.642 .62 .812 r
.62786 .17984 .6318 .18832 .64518 .18166 .64132 .17491 Metetra
.655 .679 .861 r
.64132 .17491 .64518 .18166 .65862 .17523 .65486 .16995 Metetra
.662 .744 .911 r
.65486 .16995 .65862 .17523 .67207 .16783 .66846 .16497 Metetra
.694 .884 .968 r
.66846 .16497 .67207 .16783 .68555 .16014 .68206 .15866 Metetra
.704 .955 .95 r
.68206 .15866 .68555 .16014 .69924 .15513 .69563 .15101 Metetra
.702 .82 .938 r
.69563 .15101 .69924 .15513 .71233 .14029 .70934 .14471 Metetra
.70934 .14471 .71233 .14029 .72578 .13069 .7225 .12979 Metetra
.747 .986 .901 r
.7225 .12979 .72578 .13069 .73961 .12559 .73603 .12014 Metetra
.576 .421 .635 r
.11946 .39274 .12186 .41513 .13459 .39937 .13065 .3887 Metetra
.689 .582 .73 r
.13065 .3887 .13459 .39937 .14663 .38896 .14246 .38013 Metetra
.632 .585 .783 r
.14246 .38013 .14663 .38896 .15845 .38039 .15374 .37605 Metetra
.66 .747 .914 r
.15374 .37605 .15845 .38039 .17059 .36925 .16508 .37195 Metetra
.593 .936 .755 r
.16508 .37195 .17059 .36925 .18203 .36426 .17698 .36333 Metetra
.732 .934 .955 r
.17698 .36333 .18203 .36426 .19354 .3591 .18869 .35661 Metetra
.781 .857 .907 r
.18869 .35661 .19354 .3591 .20546 .35047 .20057 .34859 Metetra
.746 .891 .945 r
.20057 .34859 .20546 .35047 .2174 .34182 .21235 .34184 Metetra
.779 .972 .917 r
.21235 .34184 .2174 .34182 .22892 .33763 .22435 .33315 Metetra
.661 .745 .912 r
.22435 .33315 .22892 .33763 .24049 .33342 .23594 .32891 Metetra
.77 .766 .85 r
.23594 .32891 .24049 .33342 .25252 .32471 .248 .32018 Metetra
.77 .766 .85 r
.248 .32018 .25252 .32471 .26458 .31599 .26008 .31143 Metetra
.662 .744 .911 r
.26008 .31143 .26458 .31599 .27628 .31171 .27181 .30713 Metetra
.662 .744 .911 r
.27181 .30713 .27628 .31171 .28804 .30741 .28358 .30281 Metetra
.662 .744 .911 r
.28358 .30281 .28804 .30741 .29986 .30309 .29542 .29847 Metetra
.662 .744 .911 r
.29542 .29847 .29986 .30309 .31173 .29875 .30731 .2941 Metetra
.662 .744 .911 r
.30731 .2941 .31173 .29875 .32366 .29438 .31926 .28972 Metetra
.662 .744 .911 r
.31926 .28972 .32366 .29438 .33564 .29 .33126 .28532 Metetra
.662 .744 .911 r
.33126 .28532 .33564 .29 .34768 .2856 .34332 .28089 Metetra
.662 .744 .911 r
.34332 .28089 .34768 .2856 .35978 .28117 .35544 .27644 Metetra
.662 .744 .911 r
.35544 .27644 .35978 .28117 .37194 .27673 .36762 .27197 Metetra
.662 .744 .911 r
.36762 .27197 .37194 .27673 .38416 .27226 .37986 .26748 Metetra
.662 .744 .911 r
.37986 .26748 .38416 .27226 .39643 .26777 .39215 .26297 Metetra
.662 .744 .911 r
.39215 .26297 .39643 .26777 .40876 .26326 .40451 .25844 Metetra
.662 .744 .911 r
.40451 .25844 .40876 .26326 .42116 .25873 .41693 .25388 Metetra
.662 .744 .911 r
.41693 .25388 .42116 .25873 .43361 .25418 .4294 .24931 Metetra
.662 .744 .911 r
.4294 .24931 .43361 .25418 .44613 .2496 .44194 .24471 Metetra
.662 .744 .911 r
.44194 .24471 .44613 .2496 .45871 .245 .45454 .24008 Metetra
.662 .744 .911 r
.45454 .24008 .45871 .245 .47134 .24038 .4672 .23544 Metetra
.662 .744 .911 r
.4672 .23544 .47134 .24038 .48404 .23574 .47992 .23077 Metetra
.662 .744 .911 r
.47992 .23077 .48404 .23574 .49681 .23107 .49271 .22608 Metetra
.662 .744 .911 r
.49271 .22608 .49681 .23107 .50963 .22638 .50556 .22136 Metetra
.662 .744 .911 r
.50556 .22136 .50963 .22638 .52252 .22167 .51847 .21662 Metetra
.662 .744 .911 r
.51847 .21662 .52252 .22167 .53547 .21693 .53145 .21186 Metetra
.662 .744 .911 r
.53145 .21186 .53547 .21693 .54849 .21217 .54449 .20708 Metetra
.746 .771 .873 r
.54449 .20708 .54849 .21217 .56157 .20739 .55756 .19902 Metetra
.642 .62 .812 r
.55756 .19902 .56157 .20739 .57472 .20258 .57072 .19418 Metetra
.642 .62 .812 r
.57072 .19418 .57472 .20258 .58793 .19775 .58394 .18932 Metetra
.642 .62 .812 r
.58394 .18932 .58793 .19775 .60121 .19289 .59723 .18444 Metetra
.669 .633 .805 r
.59723 .18444 .60121 .19289 .61456 .18801 .61055 .17822 Metetra
.765 .65 .735 r
.61055 .17822 .61456 .18801 .62786 .17984 .62364 .16419 Metetra
.602 .486 .694 r
.62364 .16419 .62786 .17984 .64132 .17491 .63709 .15923 Metetra
.602 .486 .694 r
.63709 .15923 .64132 .17491 .65486 .16995 .6506 .15423 Metetra
.602 .486 .694 r
.6506 .15423 .65486 .16995 .66846 .16497 .66417 .14922 Metetra
.655 .519 .685 r
.66417 .14922 .66846 .16497 .68206 .15866 .67757 .13964 Metetra
.59 .454 .665 r
.67757 .13964 .68206 .15866 .69563 .15101 .69127 .13456 Metetra
.651 .511 .68 r
.69127 .13456 .69563 .15101 .70934 .14471 .70474 .12493 Metetra
.588 .449 .66 r
.70474 .12493 .70934 .14471 .7225 .12979 .71855 .11981 Metetra
.634 .585 .782 r
.71855 .11981 .7225 .12979 .73603 .12014 .73243 .11465 Metetra
.659 .747 .915 r
.11467 .38844 .11946 .39274 .13065 .3887 .12588 .38438 Metetra
.77 .765 .848 r
.12588 .38438 .13065 .3887 .14246 .38013 .13772 .37579 Metetra
.66 .747 .914 r
.13772 .37579 .14246 .38013 .15374 .37605 .14901 .37169 Metetra
.77 .765 .849 r
.14901 .37169 .15374 .37605 .16508 .37195 .16091 .36306 Metetra
.632 .585 .783 r
.16091 .36306 .16508 .37195 .17698 .36333 .17229 .35892 Metetra
.66 .746 .914 r
.17229 .35892 .17698 .36333 .18869 .35661 .18374 .35476 Metetra
.629 .876 .988 r
.18374 .35476 .18869 .35661 .20057 .34859 .19523 .35058 Metetra
.508 .904 .779 r
.19523 .35058 .20057 .34859 .21235 .34184 .20705 .34379 Metetra
.765 .996 .828 r
.20705 .34379 .21235 .34184 .22435 .33315 .2193 .33313 Metetra
.5 .901 .928 r
.2193 .33313 .22435 .33315 .23594 .32891 .23093 .32888 Metetra
.607 .942 .941 r
.23093 .32888 .23594 .32891 .248 .32018 .24273 .32332 Metetra
.396 .813 .623 r
.24273 .32332 .248 .32018 .26008 .31143 .25475 .31582 Metetra
.25475 .31582 .26008 .31143 .27181 .30713 .26692 .30701 Metetra
.506 .903 .932 r
.26692 .30701 .27181 .30713 .28358 .30281 .27873 .30267 Metetra
.777 .974 .916 r
.27873 .30267 .28358 .30281 .29542 .29847 .29096 .29382 Metetra
.662 .744 .911 r
.29096 .29382 .29542 .29847 .30731 .2941 .30287 .28944 Metetra
.662 .744 .911 r
.30287 .28944 .30731 .2941 .31926 .28972 .31483 .28503 Metetra
.662 .744 .911 r
.31483 .28503 .31926 .28972 .33126 .28532 .32686 .2806 Metetra
.662 .744 .911 r
.32686 .2806 .33126 .28532 .34332 .28089 .33894 .27616 Metetra
.662 .744 .911 r
.33894 .27616 .34332 .28089 .35544 .27644 .35108 .27169 Metetra
.662 .744 .911 r
.35108 .27169 .35544 .27644 .36762 .27197 .36328 .26719 Metetra
.662 .744 .911 r
.36328 .26719 .36762 .27197 .37986 .26748 .37554 .26268 Metetra
.662 .744 .911 r
.37554 .26268 .37986 .26748 .39215 .26297 .38786 .25815 Metetra
.662 .744 .911 r
.38786 .25815 .39215 .26297 .40451 .25844 .40023 .25359 Metetra
.662 .744 .911 r
.40023 .25359 .40451 .25844 .41693 .25388 .41267 .24901 Metetra
.662 .744 .911 r
.41267 .24901 .41693 .25388 .4294 .24931 .42517 .24441 Metetra
.662 .744 .911 r
.42517 .24441 .4294 .24931 .44194 .24471 .43773 .23978 Metetra
.662 .744 .911 r
.43773 .23978 .44194 .24471 .45454 .24008 .45035 .23514 Metetra
.662 .744 .911 r
.45035 .23514 .45454 .24008 .4672 .23544 .46304 .23047 Metetra
.662 .744 .911 r
.46304 .23047 .4672 .23544 .47992 .23077 .47578 .22577 Metetra
.662 .744 .911 r
.47578 .22577 .47992 .23077 .49271 .22608 .48859 .22106 Metetra
.662 .744 .911 r
.48859 .22106 .49271 .22608 .50556 .22136 .50146 .21632 Metetra
.662 .744 .911 r
.50146 .21632 .50556 .22136 .51847 .21662 .5144 .21156 Metetra
.662 .744 .911 r
.5144 .21156 .51847 .21662 .53145 .21186 .5274 .20677 Metetra
.662 .744 .911 r
.5274 .20677 .53145 .21186 .54449 .20708 .54047 .20196 Metetra
.711 .761 .891 r
.54047 .20196 .54449 .20708 .55756 .19902 .55358 .19537 Metetra
.711 .835 .941 r
.55358 .19537 .55756 .19902 .57072 .19418 .56675 .18901 Metetra
.662 .744 .911 r
.56675 .18901 .57072 .19418 .58394 .18932 .58 .18412 Metetra
.662 .744 .911 r
.58 .18412 .58394 .18932 .59723 .18444 .59331 .17921 Metetra
.699 .757 .897 r
.59331 .17921 .59723 .18444 .61055 .17822 .60666 .17297 Metetra
.662 .743 .911 r
.60666 .17297 .61055 .17822 .62364 .16419 .6201 .16801 Metetra
.6201 .16801 .62364 .16419 .63709 .15923 .63344 .15846 Metetra
.515 .905 .936 r
.63344 .15846 .63709 .15923 .6506 .15423 .647 .15344 Metetra
.753 .985 .905 r
.647 .15344 .6506 .15423 .66417 .14922 .6604 .14385 Metetra
.663 .743 .909 r
.6604 .14385 .66417 .14922 .67757 .13964 .67408 .13878 Metetra
.517 .906 .938 r
.67408 .13878 .67757 .13964 .69127 .13456 .68782 .13368 Metetra
.873 .986 .829 r
.68782 .13368 .69127 .13456 .70474 .12493 .70106 .11948 Metetra
.663 .742 .908 r
.70106 .11948 .70474 .12493 .71855 .11981 .7149 .11432 Metetra
.663 .742 .908 r
.7149 .11432 .71855 .11981 .73243 .11465 .72881 .10914 Metetra
.659 .747 .915 r
.10986 .38412 .11467 .38844 .12588 .38438 .12109 .38004 Metetra
.659 .747 .915 r
.12109 .38004 .12588 .38438 .13772 .37579 .13237 .37595 Metetra
.782 .97 .918 r
.13237 .37595 .13772 .37579 .14901 .37169 .14426 .36731 Metetra
.66 .747 .914 r
.14426 .36731 .14901 .37169 .16091 .36306 .15563 .36317 Metetra
.494 .899 .925 r
.15563 .36317 .16091 .36306 .17229 .35892 .16705 .35901 Metetra
.781 .971 .918 r
.16705 .35901 .17229 .35892 .18374 .35476 .17905 .35031 Metetra
.66 .746 .914 r
.17905 .35031 .18374 .35476 .19523 .35058 .19056 .3461 Metetra
.66 .746 .914 r
.19056 .3461 .19523 .35058 .20705 .34379 .20213 .34188 Metetra
.63 .876 .987 r
.20213 .34188 .20705 .34379 .2193 .33313 .21375 .33764 Metetra
.058 0 0 r
.21375 .33764 .2193 .33313 .23093 .32888 .22542 .33338 Metetra
.22542 .33338 .23093 .32888 .24273 .32332 .23741 .3265 Metetra
.649 .948 .718 r
.23741 .3265 .24273 .32332 .25475 .31582 .24978 .31573 Metetra
.778 .973 .917 r
.24978 .31573 .25475 .31582 .26692 .30701 .26199 .30689 Metetra
.682 .963 .939 r
.26199 .30689 .26692 .30701 .27873 .30267 .27405 .30011 Metetra
.731 .865 .944 r
.27405 .30011 .27873 .30267 .29096 .29382 .28611 .29365 Metetra
.777 .974 .916 r
.28611 .29365 .29096 .29382 .30287 .28944 .2984 .28475 Metetra
.662 .744 .911 r
.2984 .28475 .30287 .28944 .31483 .28503 .31039 .28032 Metetra
.662 .744 .911 r
.31039 .28032 .31483 .28503 .32686 .2806 .32243 .27587 Metetra
.662 .744 .911 r
.32243 .27587 .32686 .2806 .33894 .27616 .33454 .2714 Metetra
.662 .744 .911 r
.33454 .2714 .33894 .27616 .35108 .27169 .3467 .26691 Metetra
.662 .744 .911 r
.3467 .26691 .35108 .27169 .36328 .26719 .35892 .26239 Metetra
.662 .744 .911 r
.35892 .26239 .36328 .26719 .37554 .26268 .3712 .25785 Metetra
.662 .744 .911 r
.3712 .25785 .37554 .26268 .38786 .25815 .38354 .2533 Metetra
.662 .744 .911 r
.38354 .2533 .38786 .25815 .40023 .25359 .39594 .24872 Metetra
.662 .744 .911 r
.39594 .24872 .40023 .25359 .41267 .24901 .4084 .24411 Metetra
.662 .744 .911 r
.4084 .24411 .41267 .24901 .42517 .24441 .42092 .23949 Metetra
.662 .744 .911 r
.42092 .23949 .42517 .24441 .43773 .23978 .4335 .23484 Metetra
.662 .744 .911 r
.4335 .23484 .43773 .23978 .45035 .23514 .44614 .23017 Metetra
.662 .744 .911 r
.44614 .23017 .45035 .23514 .46304 .23047 .45885 .22547 Metetra
.662 .744 .911 r
.45885 .22547 .46304 .23047 .47578 .22577 .47162 .22075 Metetra
.662 .744 .911 r
.47162 .22075 .47578 .22577 .48859 .22106 .48445 .21601 Metetra
.662 .744 .911 r
.48445 .21601 .48859 .22106 .50146 .21632 .49735 .21125 Metetra
.662 .744 .911 r
.49735 .21125 .50146 .21632 .5144 .21156 .51031 .20646 Metetra
.662 .744 .911 r
.51031 .20646 .5144 .21156 .5274 .20677 .52334 .20165 Metetra
.662 .744 .911 r
.52334 .20165 .5274 .20677 .54047 .20196 .53643 .19681 Metetra
.662 .744 .911 r
.53643 .19681 .54047 .20196 .55358 .19537 .54958 .19195 Metetra
.654 .832 .968 r
.54958 .19195 .55358 .19537 .56675 .18901 .56281 .18707 Metetra
.696 .924 .968 r
.56281 .18707 .56675 .18901 .58 .18412 .57606 .1804 Metetra
.711 .835 .941 r
.57606 .1804 .58 .18412 .59331 .17921 .58938 .17396 Metetra
.662 .744 .911 r
.58938 .17396 .59331 .17921 .60666 .17297 .60279 .16899 Metetra
.815 .846 .872 r
.60279 .16899 .60666 .17297 .6201 .16801 .61607 .15814 Metetra
.633 .585 .782 r
.61607 .15814 .6201 .16801 .63344 .15846 .62959 .15312 Metetra
.662 .743 .91 r
.62959 .15312 .63344 .15846 .647 .15344 .64317 .14808 Metetra
.842 .796 .806 r
.64317 .14808 .647 .15344 .6604 .14385 .6564 .13391 Metetra
.709 .624 .76 r
.6564 .13391 .6604 .14385 .67408 .13878 .66984 .12428 Metetra
.607 .502 .709 r
.66984 .12428 .67408 .13878 .68782 .13368 .68357 .11915 Metetra
.607 .502 .709 r
.68357 .11915 .68782 .13368 .70106 .11948 .69736 .11399 Metetra
.663 .742 .908 r
.69736 .11399 .70106 .11948 .7149 .11432 .71123 .10881 Metetra
.663 .742 .908 r
.71123 .10881 .7149 .11432 .72881 .10914 .72517 .1036 Metetra
.77 .764 .848 r
.10503 .37978 .10986 .38412 .12109 .38004 .11688 .37116 Metetra
.631 .585 .784 r
.11688 .37116 .12109 .38004 .13237 .37595 .12816 .36704 Metetra
.631 .585 .784 r
.12816 .36704 .13237 .37595 .14426 .36731 .13949 .3629 Metetra
.66 .747 .914 r
.13949 .3629 .14426 .36731 .15563 .36317 .15087 .35874 Metetra
.746 .763 .867 r
.15087 .35874 .15563 .36317 .16705 .35901 .1627 .35133 Metetra
.654 .627 .81 r
.1627 .35133 .16705 .35901 .17905 .35031 .17425 .34653 Metetra
.685 .786 .927 r
.17425 .34653 .17905 .35031 .19056 .3461 .18586 .34161 Metetra
.66 .746 .914 r
.18586 .34161 .19056 .3461 .20213 .34188 .19745 .33737 Metetra
.66 .746 .914 r
.19745 .33737 .20213 .34188 .21375 .33764 .20909 .3331 Metetra
.66 .746 .914 r
.20909 .3331 .21375 .33764 .22542 .33338 .22078 .32882 Metetra
.732 .763 .877 r
.22078 .32882 .22542 .33338 .23741 .3265 .23279 .32192 Metetra
.738 .764 .874 r
.23279 .32192 .23741 .3265 .24978 .31573 .24485 .31474 Metetra
.649 .926 .974 r
.24485 .31474 .24978 .31573 .26199 .30689 .25679 .30935 Metetra
.25679 .30935 .26199 .30689 .27405 .30011 .26869 .30498 Metetra
.26869 .30498 .27405 .30011 .28611 .29365 .28086 .29799 Metetra
.045 0 0 r
.28086 .29799 .28611 .29365 .2984 .28475 .29286 .29358 Metetra
.066 0 0 r
.29286 .29358 .2984 .28475 .31039 .28032 .30525 .28461 Metetra
.30525 .28461 .31039 .28032 .32243 .27587 .31767 .27562 Metetra
.512 .905 .935 r
.31767 .27562 .32243 .27587 .33454 .2714 .32981 .27113 Metetra
.512 .905 .935 r
.32981 .27113 .33454 .2714 .3467 .26691 .34201 .26662 Metetra
.512 .905 .935 r
.34201 .26662 .3467 .26691 .35892 .26239 .35427 .26208 Metetra
.512 .905 .935 r
.35427 .26208 .35892 .26239 .3712 .25785 .36659 .25753 Metetra
.512 .905 .935 r
.36659 .25753 .3712 .25785 .38354 .2533 .37897 .25295 Metetra
.641 .953 .94 r
.37897 .25295 .38354 .2533 .39594 .24872 .39149 .24653 Metetra
.724 .899 .958 r
.39149 .24653 .39594 .24872 .4084 .24411 .40407 .23984 Metetra
.684 .782 .925 r
.40407 .23984 .4084 .24411 .42092 .23949 .41664 .23454 Metetra
.662 .744 .911 r
.41664 .23454 .42092 .23949 .4335 .23484 .42924 .22987 Metetra
.662 .744 .911 r
.42924 .22987 .4335 .23484 .44614 .23017 .44191 .22517 Metetra
.662 .744 .911 r
.44191 .22517 .44614 .23017 .45885 .22547 .45464 .22045 Metetra
.662 .744 .911 r
.45464 .22045 .45885 .22547 .47162 .22075 .46743 .21571 Metetra
.662 .744 .911 r
.46743 .21571 .47162 .22075 .48445 .21601 .48029 .21094 Metetra
.662 .744 .911 r
.48029 .21094 .48445 .21601 .49735 .21125 .49321 .20615 Metetra
.662 .744 .911 r
.49321 .20615 .49735 .21125 .51031 .20646 .5062 .20134 Metetra
.662 .744 .911 r
.5062 .20134 .51031 .20646 .52334 .20165 .51925 .1965 Metetra
.662 .744 .911 r
.51925 .1965 .52334 .20165 .53643 .19681 .53236 .19164 Metetra
.662 .744 .911 r
.53236 .19164 .53643 .19681 .54958 .19195 .54554 .18675 Metetra
.662 .744 .911 r
.54554 .18675 .54958 .19195 .56281 .18707 .55879 .18184 Metetra
.662 .744 .911 r
.55879 .18184 .56281 .18707 .57606 .1804 .57211 .1769 Metetra
.655 .832 .968 r
.57211 .1769 .57606 .1804 .58938 .17396 .58549 .17194 Metetra
.696 .924 .968 r
.58549 .17194 .58938 .17396 .60279 .16899 .59889 .16519 Metetra
.711 .835 .941 r
.59889 .16519 .60279 .16899 .61607 .15814 .61236 .15867 Metetra
.724 .988 .821 r
.61236 .15867 .61607 .15814 .62959 .15312 .62572 .14775 Metetra
.662 .743 .91 r
.62572 .14775 .62959 .15312 .64317 .14808 .63933 .14268 Metetra
.662 .743 .91 r
.63933 .14268 .64317 .14808 .6564 .13391 .65301 .13759 Metetra
.65301 .13759 .6564 .13391 .66984 .12428 .6663 .12335 Metetra
.755 .984 .906 r
.6663 .12335 .66984 .12428 .68357 .11915 .67982 .11366 Metetra
.663 .742 .908 r
.67982 .11366 .68357 .11915 .69736 .11399 .69365 .10847 Metetra
.663 .742 .908 r
.69365 .10847 .69736 .11399 .71123 .10881 .70754 .10326 Metetra
.663 .742 .908 r
.70754 .10326 .71123 .10881 .72517 .1036 .72151 .09802 Metetra
.659 .747 .915 r
.10017 .37542 .10503 .37978 .11688 .37116 .11143 .3713 Metetra
.784 .968 .919 r
.11143 .3713 .11688 .37116 .12816 .36704 .12334 .36263 Metetra
.66 .747 .914 r
.12334 .36263 .12816 .36704 .13949 .3629 .13469 .35847 Metetra
.66 .747 .914 r
.13469 .35847 .13949 .3629 .15087 .35874 .14609 .35429 Metetra
.66 .747 .914 r
.14609 .35429 .15087 .35874 .1627 .35133 .15755 .35009 Metetra
.602 .899 .987 r
.15755 .35009 .1627 .35133 .17425 .34653 .16906 .34587 Metetra
.563 .909 .971 r
.16906 .34587 .17425 .34653 .18586 .34161 .18062 .34163 Metetra
.5 .901 .928 r
.18062 .34163 .18586 .34161 .19745 .33737 .19224 .33737 Metetra
.78 .972 .917 r
.19224 .33737 .19745 .33737 .20909 .3331 .2044 .32854 Metetra
.66 .746 .914 r
.2044 .32854 .20909 .3331 .22078 .32882 .21612 .32423 Metetra
.66 .746 .914 r
.21612 .32423 .22078 .32882 .23279 .32192 .22789 .31991 Metetra
.631 .875 .987 r
.22789 .31991 .23279 .32192 .24485 .31474 .23971 .31556 Metetra
.624 .96 .888 r
.23971 .31556 .24485 .31474 .25679 .30935 .25184 .30859 Metetra
.563 .909 .97 r
.25184 .30859 .25679 .30935 .26869 .30498 .26377 .3042 Metetra
.626 .93 .969 r
.26377 .3042 .26869 .30498 .28086 .29799 .27583 .29889 Metetra
.636 .965 .878 r
.27583 .29889 .28086 .29799 .29286 .29358 .28812 .29145 Metetra
.745 .893 .946 r
.28812 .29145 .29286 .29358 .30525 .28461 .3004 .28439 Metetra
.776 .975 .916 r
.3004 .28439 .30525 .28461 .31767 .27562 .31287 .27537 Metetra
.512 .905 .935 r
.31287 .27537 .31767 .27562 .32981 .27113 .32505 .27086 Metetra
.775 .976 .916 r
.32505 .27086 .32981 .27113 .34201 .26662 .33758 .26179 Metetra
.661 .744 .912 r
.33758 .26179 .34201 .26662 .35427 .26208 .34986 .25723 Metetra
.661 .744 .912 r
.34986 .25723 .35427 .26208 .36659 .25753 .3622 .25265 Metetra
.759 .77 .861 r
.3622 .25265 .36659 .25753 .37897 .25295 .3748 .24417 Metetra
.65 .608 .794 r
.3748 .24417 .37897 .25295 .39149 .24653 .38727 .23889 Metetra
.645 .636 .827 r
.38727 .23889 .39149 .24653 .40407 .23984 .39977 .23424 Metetra
.659 .715 .889 r
.39977 .23424 .40407 .23984 .41664 .23454 .41234 .22956 Metetra
.662 .744 .911 r
.41234 .22956 .41664 .23454 .42924 .22987 .42497 .22487 Metetra
.662 .744 .911 r
.42497 .22487 .42924 .22987 .44191 .22517 .43766 .22015 Metetra
.662 .744 .911 r
.43766 .22015 .44191 .22517 .45464 .22045 .45041 .2154 Metetra
.662 .744 .911 r
.45041 .2154 .45464 .22045 .46743 .21571 .46323 .21064 Metetra
.662 .744 .911 r
.46323 .21064 .46743 .21571 .48029 .21094 .47611 .20584 Metetra
.662 .744 .911 r
.47611 .20584 .48029 .21094 .49321 .20615 .48905 .20103 Metetra
.662 .744 .911 r
.48905 .20103 .49321 .20615 .5062 .20134 .50206 .19619 Metetra
.662 .744 .911 r
.50206 .19619 .5062 .20134 .51925 .1965 .51513 .19133 Metetra
.662 .744 .911 r
.51513 .19133 .51925 .1965 .53236 .19164 .52828 .18644 Metetra
.662 .744 .911 r
.52828 .18644 .53236 .19164 .54554 .18675 .54148 .18152 Metetra
.662 .744 .911 r
.54148 .18152 .54554 .18675 .55879 .18184 .55476 .17659 Metetra
.662 .744 .911 r
.55476 .17659 .55879 .18184 .57211 .1769 .5681 .17162 Metetra
.711 .762 .892 r
.5681 .17162 .57211 .1769 .58549 .17194 .58147 .16487 Metetra
.788 .723 .792 r
.58147 .16487 .58549 .17194 .59889 .16519 .59475 .15247 Metetra
.615 .528 .733 r
.59475 .15247 .59889 .16519 .61236 .15867 .60825 .14743 Metetra
.694 .594 .74 r
.60825 .14743 .61236 .15867 .62572 .14775 .62166 .1378 Metetra
.766 .651 .736 r
.62166 .1378 .62572 .14775 .63933 .14268 .63492 .12362 Metetra
.588 .453 .664 r
.63492 .12362 .63933 .14268 .65301 .13759 .64856 .11849 Metetra
.588 .453 .664 r
.64856 .11849 .65301 .13759 .6663 .12335 .66227 .11333 Metetra
.633 .585 .782 r
.66227 .11333 .6663 .12335 .67982 .11366 .67606 .10814 Metetra
.663 .742 .908 r
.67606 .10814 .67982 .11366 .69365 .10847 .68991 .10293 Metetra
.663 .742 .908 r
.68991 .10293 .69365 .10847 .70754 .10326 .70383 .09768 Metetra
.663 .742 .908 r
.70383 .09768 .70754 .10326 .72151 .09802 .71783 .09242 Metetra
.659 .747 .915 r
.09529 .37103 .10017 .37542 .11143 .3713 .10656 .36689 Metetra
.659 .747 .915 r
.10656 .36689 .11143 .3713 .12334 .36263 .11789 .36274 Metetra
.784 .968 .919 r
.11789 .36274 .12334 .36263 .13469 .35847 .12987 .35402 Metetra
.66 .747 .914 r
.12987 .35402 .13469 .35847 .14609 .35429 .14129 .34982 Metetra
.66 .747 .914 r
.14129 .34982 .14609 .35429 .15755 .35009 .15276 .3456 Metetra
.66 .747 .914 r
.15276 .3456 .15755 .35009 .16906 .34587 .16429 .34135 Metetra
.66 .747 .914 r
.16429 .34135 .16906 .34587 .18062 .34163 .17587 .33709 Metetra
.77 .767 .85 r
.17587 .33709 .18062 .34163 .19224 .33737 .18802 .32826 Metetra
.631 .585 .784 r
.18802 .32826 .19224 .33737 .2044 .32854 .1997 .32396 Metetra
.732 .762 .877 r
.1997 .32396 .2044 .32854 .21612 .32423 .2117 .31703 Metetra
.689 .658 .815 r
.2117 .31703 .21612 .32423 .22789 .31991 .22368 .31074 Metetra
.76 .644 .733 r
.22368 .31074 .22789 .31991 .23971 .31556 .23639 .29731 Metetra
.637 .485 .66 r
.23639 .29731 .23971 .31556 .25184 .30859 .24866 .28839 Metetra
.581 .436 .649 r
.24866 .28839 .25184 .30859 .26377 .3042 .26055 .28396 Metetra
.581 .436 .649 r
.26055 .28396 .26377 .3042 .27583 .29889 .2725 .27951 Metetra
.583 .443 .656 r
.2725 .27951 .27583 .29889 .28812 .29145 .28451 .27504 Metetra
.641 .5 .676 r
.28451 .27504 .28812 .29145 .3004 .28439 .29687 .26668 Metetra
.597 .462 .668 r
.29687 .26668 .3004 .28439 .31287 .27537 .30903 .26152 Metetra
.605 .501 .709 r
.30903 .26152 .31287 .27537 .32505 .27086 .32119 .25698 Metetra
.605 .501 .709 r
.32119 .25698 .32505 .27086 .33758 .26179 .33341 .25241 Metetra
.632 .585 .783 r
.33341 .25241 .33758 .26179 .34986 .25723 .34569 .24783 Metetra
.632 .585 .783 r
.34569 .24783 .34986 .25723 .3622 .25265 .35804 .24322 Metetra
.632 .585 .783 r
.35804 .24322 .3622 .25265 .3748 .24417 .37044 .23859 Metetra
.659 .715 .889 r
.37044 .23859 .3748 .24417 .38727 .23889 .3829 .23394 Metetra
.662 .744 .911 r
.3829 .23394 .38727 .23889 .39977 .23424 .39543 .22926 Metetra
.662 .744 .911 r
.39543 .22926 .39977 .23424 .41234 .22956 .40802 .22457 Metetra
.662 .744 .911 r
.40802 .22457 .41234 .22956 .42497 .22487 .42067 .21984 Metetra
.662 .744 .911 r
.42067 .21984 .42497 .22487 .43766 .22015 .43338 .2151 Metetra
.662 .744 .911 r
.43338 .2151 .43766 .22015 .45041 .2154 .44616 .21033 Metetra
.662 .744 .911 r
.44616 .21033 .45041 .2154 .46323 .21064 .459 .20554 Metetra
.662 .744 .911 r
.459 .20554 .46323 .21064 .47611 .20584 .4719 .20072 Metetra
.662 .744 .911 r
.4719 .20072 .47611 .20584 .48905 .20103 .48487 .19588 Metetra
.662 .744 .911 r
.48487 .19588 .48905 .20103 .50206 .19619 .4979 .19101 Metetra
.662 .744 .911 r
.4979 .19101 .50206 .19619 .51513 .19133 .511 .18612 Metetra
.662 .744 .911 r
.511 .18612 .51513 .19133 .52828 .18644 .52417 .18121 Metetra
.662 .744 .911 r
.52417 .18121 .52828 .18644 .54148 .18152 .5374 .17627 Metetra
.662 .744 .911 r
.5374 .17627 .54148 .18152 .55476 .17659 .5507 .1713 Metetra
.662 .744 .911 r
.5507 .1713 .55476 .17659 .5681 .17162 .56406 .16631 Metetra
.662 .744 .911 r
.56406 .16631 .5681 .17162 .58147 .16487 .5775 .1613 Metetra
.655 .831 .968 r
.5775 .1613 .58147 .16487 .59475 .15247 .591 .15626 Metetra
.023 0 0 r
.591 .15626 .59475 .15247 .60825 .14743 .60458 .15119 Metetra
.023 0 0 r
.60458 .15119 .60825 .14743 .62166 .1378 .61822 .1461 Metetra
.266 0 .06 r
.61822 .1461 .62166 .1378 .63492 .12362 .63193 .14098 Metetra
.397 .066 .283 r
.63193 .14098 .63492 .12362 .64856 .11849 .64572 .13583 Metetra
.37 .044 .276 r
.64572 .13583 .64856 .11849 .66227 .11333 .65949 .12889 Metetra
0 0 .124 r
.65949 .12889 .66227 .11333 .67606 .10814 .67227 .10259 Metetra
.663 .742 .908 r
.67227 .10259 .67606 .10814 .68991 .10293 .68615 .09735 Metetra
.663 .742 .908 r
.68615 .09735 .68991 .10293 .70383 .09768 .7001 .09208 Metetra
.663 .742 .908 r
.7001 .09208 .70383 .09768 .71783 .09242 .71413 .08678 Metetra
.77 .764 .848 r
.09038 .36663 .09529 .37103 .10656 .36689 .10231 .35794 Metetra
.631 .585 .784 r
.10231 .35794 .10656 .36689 .11789 .36274 .11364 .35375 Metetra
.631 .585 .784 r
.11364 .35375 .11789 .36274 .12987 .35402 .12502 .34955 Metetra
.66 .747 .914 r
.12502 .34955 .12987 .35402 .14129 .34982 .13645 .34533 Metetra
.66 .747 .914 r
.13645 .34533 .14129 .34982 .15276 .3456 .14795 .34108 Metetra
.77 .766 .849 r
.14795 .34108 .15276 .3456 .16429 .34135 .16004 .33228 Metetra
.819 .666 .693 r
.16004 .33228 .16429 .34135 .17587 .33709 .17376 .30994 Metetra
.564 .396 .612 r
.17376 .30994 .17587 .33709 .18802 .32826 .18533 .30562 Metetra
.617 .45 .633 r
.18533 .30562 .18802 .32826 .1997 .32396 .19746 .29679 Metetra
.564 .396 .612 r
.19746 .29679 .1997 .32396 .2117 .31703 .20912 .29242 Metetra
.569 .408 .623 r
.20912 .29242 .2117 .31703 .22368 .31074 .22085 .28802 Metetra
.573 .419 .633 r
.22085 .28802 .22368 .31074 .23639 .29731 .23263 .28361 Metetra
.605 .5 .709 r
.23263 .28361 .23639 .29731 .24866 .28839 .24446 .27918 Metetra
.632 .585 .783 r
.24446 .27918 .24866 .28839 .26055 .28396 .25636 .27472 Metetra
.632 .585 .783 r
.25636 .27472 .26055 .28396 .2725 .27951 .26831 .27025 Metetra
.632 .585 .783 r
.26831 .27025 .2725 .27951 .28451 .27504 .28032 .26575 Metetra
.632 .585 .783 r
.28032 .26575 .28451 .27504 .29687 .26668 .29238 .26123 Metetra
.659 .715 .889 r
.29238 .26123 .29687 .26668 .30903 .26152 .30451 .25669 Metetra
.662 .744 .911 r
.30451 .25669 .30903 .26152 .32119 .25698 .31669 .25212 Metetra
.662 .744 .911 r
.31669 .25212 .32119 .25698 .33341 .25241 .32894 .24753 Metetra
.662 .744 .911 r
.32894 .24753 .33341 .25241 .34569 .24783 .34124 .24293 Metetra
.662 .744 .911 r
.34124 .24293 .34569 .24783 .35804 .24322 .35361 .23829 Metetra
.662 .744 .911 r
.35361 .23829 .35804 .24322 .37044 .23859 .36603 .23364 Metetra
.662 .744 .911 r
.36603 .23364 .37044 .23859 .3829 .23394 .37852 .22896 Metetra
.662 .744 .911 r
.37852 .22896 .3829 .23394 .39543 .22926 .39106 .22426 Metetra
.662 .744 .911 r
.39106 .22426 .39543 .22926 .40802 .22457 .40367 .21954 Metetra
.662 .744 .911 r
.40367 .21954 .40802 .22457 .42067 .21984 .41635 .21479 Metetra
.662 .744 .911 r
.41635 .21479 .42067 .21984 .43338 .2151 .42908 .21002 Metetra
.662 .744 .911 r
.42908 .21002 .43338 .2151 .44616 .21033 .44188 .20523 Metetra
.662 .744 .911 r
.44188 .20523 .44616 .21033 .459 .20554 .45474 .20041 Metetra
.662 .744 .911 r
.45474 .20041 .459 .20554 .4719 .20072 .46767 .19557 Metetra
.662 .744 .911 r
.46767 .19557 .4719 .20072 .48487 .19588 .48066 .1907 Metetra
.662 .744 .911 r
.48066 .1907 .48487 .19588 .4979 .19101 .49372 .18581 Metetra
.662 .744 .911 r
.49372 .18581 .4979 .19101 .511 .18612 .50685 .18089 Metetra
.662 .744 .911 r
.50685 .18089 .511 .18612 .52417 .18121 .52004 .17595 Metetra
.662 .744 .911 r
.52004 .17595 .52417 .18121 .5374 .17627 .53329 .17098 Metetra
.662 .744 .911 r
.53329 .17098 .5374 .17627 .5507 .1713 .54662 .16599 Metetra
.662 .744 .911 r
.54662 .16599 .5507 .1713 .56406 .16631 .56001 .16098 Metetra
.662 .744 .911 r
.56001 .16098 .56406 .16631 .5775 .1613 .57347 .15593 Metetra
.711 .762 .892 r
.57347 .15593 .5775 .1613 .591 .15626 .58696 .1491 Metetra
.715 .697 .832 r
.58696 .1491 .591 .15626 .60458 .15119 .60048 .14118 Metetra
.709 .624 .761 r
.60048 .14118 .60458 .15119 .61822 .1461 .61398 .13147 Metetra
.605 .501 .709 r
.61398 .13147 .61822 .1461 .63193 .14098 .62767 .12632 Metetra
.605 .501 .709 r
.62767 .12632 .63193 .14098 .64572 .13583 .64144 .12114 Metetra
.752 .586 .671 r
.64144 .12114 .64572 .13583 .65949 .12889 .65462 .10225 Metetra
.568 .405 .62 r
.65462 .10225 .65949 .12889 .67227 .10259 .66846 .09701 Metetra
.663 .742 .908 r
.66846 .09701 .67227 .10259 .68615 .09735 .68237 .09174 Metetra
.663 .742 .908 r
.68237 .09174 .68615 .09735 .7001 .09208 .69635 .08644 Metetra
.663 .742 .908 r
.69635 .08644 .7001 .09208 .71413 .08678 .71041 .08111 Metetra
.709 .621 .757 r
.08611 .35767 .09038 .36663 .10231 .35794 .09804 .34896 Metetra
.631 .585 .784 r
.09804 .34896 .10231 .35794 .11364 .35375 .10937 .34475 Metetra
.793 .656 .711 r
.10937 .34475 .11364 .35375 .12502 .34955 .12257 .327 Metetra
.617 .45 .633 r
.12257 .327 .12502 .34955 .13645 .34533 .13455 .31826 Metetra
.563 .395 .612 r
.13455 .31826 .13645 .34533 .14795 .34108 .14598 .31397 Metetra
.602 .424 .614 r
.14598 .31397 .14795 .34108 .16004 .33228 .15801 .30519 Metetra
.563 .395 .612 r
.15801 .30519 .16004 .33228 .17376 .30994 .16953 .30086 Metetra
.632 .585 .784 r
.16953 .30086 .17376 .30994 .18533 .30562 .18111 .29651 Metetra
.632 .585 .784 r
.18111 .29651 .18533 .30562 .19746 .29679 .19274 .29213 Metetra
.662 .744 .911 r
.19274 .29213 .19746 .29679 .20912 .29242 .20443 .28774 Metetra
.662 .744 .911 r
.20443 .28774 .20912 .29242 .22085 .28802 .21617 .28333 Metetra
.662 .744 .911 r
.21617 .28333 .22085 .28802 .23263 .28361 .22797 .27889 Metetra
.662 .744 .911 r
.22797 .27889 .23263 .28361 .24446 .27918 .23983 .27444 Metetra
.662 .744 .911 r
.23983 .27444 .24446 .27918 .25636 .27472 .25174 .26996 Metetra
.662 .744 .911 r
.25174 .26996 .25636 .27472 .26831 .27025 .26371 .26546 Metetra
.662 .744 .911 r
.26371 .26546 .26831 .27025 .28032 .26575 .27574 .26094 Metetra
.662 .744 .911 r
.27574 .26094 .28032 .26575 .29238 .26123 .28782 .25639 Metetra
.662 .744 .911 r
.28782 .25639 .29238 .26123 .30451 .25669 .29997 .25183 Metetra
.662 .744 .911 r
.29997 .25183 .30451 .25669 .31669 .25212 .31217 .24724 Metetra
.662 .744 .911 r
.31217 .24724 .31669 .25212 .32894 .24753 .32444 .24263 Metetra
.662 .744 .911 r
.32444 .24263 .32894 .24753 .34124 .24293 .33676 .238 Metetra
.662 .744 .911 r
.33676 .238 .34124 .24293 .35361 .23829 .34915 .23334 Metetra
.662 .744 .911 r
.34915 .23334 .35361 .23829 .36603 .23364 .3616 .22866 Metetra
.662 .744 .911 r
.3616 .22866 .36603 .23364 .37852 .22896 .3741 .22396 Metetra
.662 .744 .911 r
.3741 .22396 .37852 .22896 .39106 .22426 .38667 .21923 Metetra
.662 .744 .911 r
.38667 .21923 .39106 .22426 .40367 .21954 .39931 .21449 Metetra
.662 .744 .911 r
.39931 .21449 .40367 .21954 .41635 .21479 .412 .20971 Metetra
.662 .744 .911 r
.412 .20971 .41635 .21479 .42908 .21002 .42476 .20492 Metetra
.662 .744 .911 r
.42476 .20492 .42908 .21002 .44188 .20523 .43758 .2001 Metetra
.662 .744 .911 r
.43758 .2001 .44188 .20523 .45474 .20041 .45047 .19525 Metetra
.662 .744 .911 r
.45047 .19525 .45474 .20041 .46767 .19557 .46342 .19039 Metetra
.662 .744 .911 r
.46342 .19039 .46767 .19557 .48066 .1907 .47644 .18549 Metetra
.662 .744 .911 r
.47644 .18549 .48066 .1907 .49372 .18581 .48952 .18057 Metetra
.662 .744 .911 r
.48952 .18057 .49372 .18581 .50685 .18089 .50267 .17563 Metetra
.662 .744 .911 r
.50267 .17563 .50685 .18089 .52004 .17595 .51588 .17066 Metetra
.662 .744 .911 r
.51588 .17066 .52004 .17595 .53329 .17098 .52917 .16567 Metetra
.772 .778 .858 r
.52917 .16567 .53329 .17098 .54662 .16599 .54249 .15607 Metetra
.765 .65 .735 r
.54249 .15607 .54662 .16599 .56001 .16098 .55578 .1419 Metetra
.635 .482 .658 r
.55578 .1419 .56001 .16098 .57347 .15593 .56912 .13227 Metetra
.614 .446 .631 r
.56912 .13227 .57347 .15593 .58696 .1491 .5825 .12263 Metetra
.567 .404 .62 r
.5825 .12263 .58696 .1491 .60048 .14118 .59601 .11749 Metetra
.573 .419 .633 r
.59601 .11749 .60048 .14118 .61398 .13147 .6096 .11233 Metetra
.587 .451 .663 r
.6096 .11233 .61398 .13147 .62767 .12632 .62325 .10714 Metetra
.587 .451 .663 r
.62325 .10714 .62767 .12632 .64144 .12114 .63697 .10192 Metetra
.587 .451 .663 r
.63697 .10192 .64144 .12114 .65462 .10225 .65077 .09667 Metetra
.663 .742 .908 r
.65077 .09667 .65462 .10225 .66846 .09701 .66463 .0914 Metetra
.663 .742 .908 r
.66463 .0914 .66846 .09701 .68237 .09174 .67857 .0861 Metetra
.663 .742 .908 r
.67857 .0861 .68237 .09174 .69635 .08644 .69258 .08077 Metetra
.663 .742 .908 r
.69258 .08077 .69635 .08644 .71041 .08111 .70667 .07542 Metetra
.769 .764 .848 r
.08116 .35321 .08611 .35767 .09804 .34896 .09312 .34448 Metetra
.66 .746 .914 r
.09312 .34448 .09804 .34896 .10937 .34475 .10447 .34025 Metetra
.855 .758 .754 r
.10447 .34025 .10937 .34475 .12257 .327 .11771 .32247 Metetra
.661 .745 .912 r
.11771 .32247 .12257 .327 .13455 .31826 .12912 .31818 Metetra
.787 .965 .919 r
.12912 .31818 .13455 .31826 .14598 .31397 .14116 .30939 Metetra
.769 .764 .848 r
.14116 .30939 .14598 .31397 .15801 .30519 .15322 .30058 Metetra
.662 .744 .911 r
.15322 .30058 .15801 .30519 .16953 .30086 .16476 .29623 Metetra
.662 .744 .911 r
.16476 .29623 .16953 .30086 .18111 .29651 .17635 .29185 Metetra
.662 .744 .911 r
.17635 .29185 .18111 .29651 .19274 .29213 .188 .28746 Metetra
.662 .744 .911 r
.188 .28746 .19274 .29213 .20443 .28774 .19971 .28304 Metetra
.662 .744 .911 r
.19971 .28304 .20443 .28774 .21617 .28333 .21147 .27861 Metetra
.662 .744 .911 r
.21147 .27861 .21617 .28333 .22797 .27889 .22329 .27415 Metetra
.662 .744 .911 r
.22329 .27415 .22797 .27889 .23983 .27444 .23516 .26967 Metetra
.662 .744 .911 r
.23516 .26967 .23983 .27444 .25174 .26996 .2471 .26517 Metetra
.662 .744 .911 r
.2471 .26517 .25174 .26996 .26371 .26546 .25909 .26064 Metetra
.662 .744 .911 r
.25909 .26064 .26371 .26546 .27574 .26094 .27113 .2561 Metetra
.662 .744 .911 r
.27113 .2561 .27574 .26094 .28782 .25639 .28324 .25153 Metetra
.662 .744 .911 r
.28324 .25153 .28782 .25639 .29997 .25183 .29541 .24694 Metetra
.662 .744 .911 r
.29541 .24694 .29997 .25183 .31217 .24724 .30763 .24233 Metetra
.662 .744 .911 r
.30763 .24233 .31217 .24724 .32444 .24263 .31992 .2377 Metetra
.662 .744 .911 r
.31992 .2377 .32444 .24263 .33676 .238 .33226 .23304 Metetra
.662 .744 .911 r
.33226 .23304 .33676 .238 .34915 .23334 .34467 .22836 Metetra
.662 .744 .911 r
.34467 .22836 .34915 .23334 .3616 .22866 .35714 .22366 Metetra
.662 .744 .911 r
.35714 .22366 .3616 .22866 .3741 .22396 .36967 .21893 Metetra
.662 .744 .911 r
.36967 .21893 .3741 .22396 .38667 .21923 .38226 .21418 Metetra
.662 .744 .911 r
.38226 .21418 .38667 .21923 .39931 .21449 .39492 .20941 Metetra
.662 .744 .911 r
.39492 .20941 .39931 .21449 .412 .20971 .40763 .20461 Metetra
.662 .744 .911 r
.40763 .20461 .412 .20971 .42476 .20492 .42041 .19979 Metetra
.662 .744 .911 r
.42041 .19979 .42476 .20492 .43758 .2001 .43326 .19494 Metetra
.662 .744 .911 r
.43326 .19494 .43758 .2001 .45047 .19525 .44617 .19007 Metetra
.662 .744 .911 r
.44617 .19007 .45047 .19525 .46342 .19039 .45915 .18518 Metetra
.662 .744 .911 r
.45915 .18518 .46342 .19039 .47644 .18549 .47219 .18026 Metetra
.662 .744 .911 r
.47219 .18026 .47644 .18549 .48952 .18057 .48529 .17531 Metetra
.746 .771 .873 r
.48529 .17531 .48952 .18057 .50267 .17563 .4985 .16707 Metetra
.668 .633 .806 r
.4985 .16707 .50267 .17563 .51588 .17066 .51173 .16077 Metetra
.806 .667 .711 r
.51173 .16077 .51588 .17066 .52917 .16567 .52501 .14209 Metetra
.614 .446 .631 r
.52501 .14209 .52917 .16567 .54249 .15607 .53827 .13251 Metetra
.573 .418 .633 r
.53827 .13251 .54249 .15607 .55578 .1419 .55161 .12742 Metetra
.605 .501 .709 r
.55161 .12742 .55578 .1419 .56912 .13227 .56501 .1223 Metetra
.632 .585 .783 r
.56501 .1223 .56912 .13227 .5825 .12263 .57848 .11716 Metetra
.663 .742 .908 r
.57848 .11716 .5825 .12263 .59601 .11749 .59202 .11199 Metetra
.663 .742 .908 r
.59202 .11199 .59601 .11749 .6096 .11233 .60564 .1068 Metetra
.663 .742 .908 r
.60564 .1068 .6096 .11233 .62325 .10714 .61932 .10158 Metetra
.663 .742 .908 r
.61932 .10158 .62325 .10714 .63697 .10192 .63307 .09633 Metetra
.663 .742 .908 r
.63307 .09633 .63697 .10192 .65077 .09667 .64689 .09106 Metetra
.663 .742 .908 r
.64689 .09106 .65077 .09667 .66463 .0914 .66079 .08576 Metetra
.663 .742 .908 r
.66079 .08576 .66463 .0914 .67857 .0861 .67475 .08043 Metetra
.663 .742 .908 r
.67475 .08043 .67857 .0861 .69258 .08077 .68879 .07507 Metetra
.663 .742 .908 r
.68879 .07507 .69258 .08077 .70667 .07542 .70291 .06968 Metetra
.66 .747 .914 r
.07619 .34874 .08116 .35321 .09312 .34448 .08751 .34451 Metetra
.515 .905 .936 r
.08751 .34451 .09312 .34448 .10447 .34025 .09889 .34026 Metetra
.787 .965 .919 r
.09889 .34026 .10447 .34025 .11771 .32247 .11096 .33145 Metetra
.11096 .33145 .11771 .32247 .12912 .31818 .12365 .31811 Metetra
.882 .934 .848 r
.12365 .31811 .12912 .31818 .14116 .30939 .13632 .30478 Metetra
.769 .764 .848 r
.13632 .30478 .14116 .30939 .15322 .30058 .14841 .29595 Metetra
.662 .744 .911 r
.14841 .29595 .15322 .30058 .16476 .29623 .15996 .29157 Metetra
.662 .744 .911 r
.15996 .29157 .16476 .29623 .17635 .29185 .17158 .28718 Metetra
.662 .744 .911 r
.17158 .28718 .17635 .29185 .188 .28746 .18324 .28276 Metetra
.662 .744 .911 r
.18324 .28276 .188 .28746 .19971 .28304 .19497 .27832 Metetra
.662 .744 .911 r
.19497 .27832 .19971 .28304 .21147 .27861 .20675 .27386 Metetra
.662 .744 .911 r
.20675 .27386 .21147 .27861 .22329 .27415 .21858 .26938 Metetra
.662 .744 .911 r
.21858 .26938 .22329 .27415 .23516 .26967 .23048 .26488 Metetra
.662 .744 .911 r
.23048 .26488 .23516 .26967 .2471 .26517 .24243 .26035 Metetra
.662 .744 .911 r
.24243 .26035 .2471 .26517 .25909 .26064 .25444 .25581 Metetra
.662 .744 .911 r
.25444 .25581 .25909 .26064 .27113 .2561 .26651 .25124 Metetra
.662 .744 .911 r
.26651 .25124 .27113 .2561 .28324 .25153 .27863 .24665 Metetra
.662 .744 .911 r
.27863 .24665 .28324 .25153 .29541 .24694 .29082 .24203 Metetra
.662 .744 .911 r
.29082 .24203 .29541 .24694 .30763 .24233 .30307 .2374 Metetra
.662 .744 .911 r
.30307 .2374 .30763 .24233 .31992 .2377 .31537 .23274 Metetra
.662 .744 .911 r
.31537 .23274 .31992 .2377 .33226 .23304 .32774 .22806 Metetra
.662 .744 .911 r
.32774 .22806 .33226 .23304 .34467 .22836 .34017 .22335 Metetra
.662 .744 .911 r
.34017 .22335 .34467 .22836 .35714 .22366 .35266 .21863 Metetra
.662 .744 .911 r
.35266 .21863 .35714 .22366 .36967 .21893 .36521 .21387 Metetra
.662 .744 .911 r
.36521 .21387 .36967 .21893 .38226 .21418 .37782 .2091 Metetra
.662 .744 .911 r
.37782 .2091 .38226 .21418 .39492 .20941 .3905 .2043 Metetra
.662 .744 .911 r
.3905 .2043 .39492 .20941 .40763 .20461 .40324 .19948 Metetra
.662 .744 .911 r
.40324 .19948 .40763 .20461 .42041 .19979 .41605 .19463 Metetra
.662 .744 .911 r
.41605 .19463 .42041 .19979 .43326 .19494 .42892 .18976 Metetra
.662 .744 .911 r
.42892 .18976 .43326 .19494 .44617 .19007 .44185 .18486 Metetra
.662 .744 .911 r
.44185 .18486 .44617 .19007 .45915 .18518 .45485 .17994 Metetra
.662 .744 .911 r
.45485 .17994 .45915 .18518 .47219 .18026 .46791 .17499 Metetra
.662 .744 .911 r
.46791 .17499 .47219 .18026 .48529 .17531 .48105 .17002 Metetra
.662 .744 .911 r
.48105 .17002 .48529 .17531 .4985 .16707 .49424 .16503 Metetra
.617 .896 .988 r
.49424 .16503 .4985 .16707 .51173 .16077 .50751 .16001 Metetra
.531 .91 .945 r
.50751 .16001 .51173 .16077 .52501 .14209 .52084 .15496 Metetra
.341 0 .192 r
.52084 .15496 .52501 .14209 .53827 .13251 .53425 .14988 Metetra
.386 .051 .27 r
.53425 .14988 .53827 .13251 .55161 .12742 .54772 .14479 Metetra
.386 .051 .27 r
.54772 .14479 .55161 .12742 .56501 .1223 .56126 .13966 Metetra
.386 .051 .27 r
.56126 .13966 .56501 .1223 .57848 .11716 .57487 .13451 Metetra
.218 0 .218 r
.57487 .13451 .57848 .11716 .59202 .11199 .58833 .12014 Metetra
.58833 .12014 .59202 .11199 .60564 .1068 .60178 .10579 Metetra
.541 .912 .95 r
.60178 .10579 .60564 .1068 .61932 .10158 .61551 .10054 Metetra
.764 .981 .91 r
.61551 .10054 .61932 .10158 .63307 .09633 .62914 .09072 Metetra
.663 .742 .908 r
.62914 .09072 .63307 .09633 .64689 .09106 .64299 .08542 Metetra
.663 .742 .908 r
.64299 .08542 .64689 .09106 .66079 .08576 .65692 .08008 Metetra
.663 .742 .908 r
.65692 .08008 .66079 .08576 .67475 .08043 .67091 .07472 Metetra
.663 .742 .908 r
.67091 .07472 .67475 .08043 .68879 .07507 .68498 .06934 Metetra
.663 .742 .908 r
.68498 .06934 .68879 .07507 .70291 .06968 .69912 .06392 Metetra
.886 .744 .7 r
.07119 .34424 .07619 .34874 .08751 .34451 .08585 .31743 Metetra
.561 .392 .61 r
.08585 .31743 .08751 .34451 .09889 .34026 .09717 .31314 Metetra
.601 .422 .613 r
.09717 .31314 .09889 .34026 .11096 .33145 .10917 .30436 Metetra
.561 .393 .61 r
.10917 .30436 .11096 .33145 .12365 .31811 .12058 .30002 Metetra
.584 .449 .663 r
.12058 .30002 .12365 .31811 .13632 .30478 .13205 .29567 Metetra
.631 .585 .784 r
.13205 .29567 .13632 .30478 .14841 .29595 .14357 .29129 Metetra
.662 .744 .911 r
.14357 .29129 .14841 .29595 .15996 .29157 .15514 .28689 Metetra
.662 .744 .911 r
.15514 .28689 .15996 .29157 .17158 .28718 .16677 .28247 Metetra
.662 .744 .911 r
.16677 .28247 .17158 .28718 .18324 .28276 .17846 .27803 Metetra
.662 .744 .911 r
.17846 .27803 .18324 .28276 .19497 .27832 .1902 .27357 Metetra
.662 .744 .911 r
.1902 .27357 .19497 .27832 .20675 .27386 .202 .26909 Metetra
.662 .744 .911 r
.202 .26909 .20675 .27386 .21858 .26938 .21385 .26459 Metetra
.662 .744 .911 r
.21385 .26459 .21858 .26938 .23048 .26488 .22577 .26006 Metetra
.662 .744 .911 r
.22577 .26006 .23048 .26488 .24243 .26035 .23774 .25551 Metetra
.662 .744 .911 r
.23774 .25551 .24243 .26035 .25444 .25581 .24977 .25094 Metetra
.662 .744 .911 r
.24977 .25094 .25444 .25581 .26651 .25124 .26185 .24635 Metetra
.662 .744 .911 r
.26185 .24635 .26651 .25124 .27863 .24665 .274 .24174 Metetra
.662 .744 .911 r
.274 .24174 .27863 .24665 .29082 .24203 .28621 .2371 Metetra
.662 .744 .911 r
.28621 .2371 .29082 .24203 .30307 .2374 .29848 .23244 Metetra
.662 .744 .911 r
.29848 .23244 .30307 .2374 .31537 .23274 .3108 .22776 Metetra
.662 .744 .911 r
.3108 .22776 .31537 .23274 .32774 .22806 .32319 .22305 Metetra
.662 .744 .911 r
.32319 .22305 .32774 .22806 .34017 .22335 .33564 .21832 Metetra
.662 .744 .911 r
.33564 .21832 .34017 .22335 .35266 .21863 .34815 .21357 Metetra
.662 .744 .911 r
.34815 .21357 .35266 .21863 .36521 .21387 .36073 .20879 Metetra
.662 .744 .911 r
.36073 .20879 .36521 .21387 .37782 .2091 .37336 .20399 Metetra
.662 .744 .911 r
.37336 .20399 .37782 .2091 .3905 .2043 .38606 .19917 Metetra
.662 .744 .911 r
.38606 .19917 .3905 .2043 .40324 .19948 .39883 .19432 Metetra
.662 .744 .911 r
.39883 .19432 .40324 .19948 .41605 .19463 .41165 .18944 Metetra
.662 .744 .911 r
.41165 .18944 .41605 .19463 .42892 .18976 .42455 .18455 Metetra
.662 .744 .911 r
.42455 .18455 .42892 .18976 .44185 .18486 .4375 .17962 Metetra
.662 .744 .911 r
.4375 .17962 .44185 .18486 .45485 .17994 .45053 .17468 Metetra
.662 .744 .911 r
.45053 .17468 .45485 .17994 .46791 .17499 .46362 .1697 Metetra
.662 .744 .911 r
.46362 .1697 .46791 .17499 .48105 .17002 .47677 .16471 Metetra
.662 .744 .911 r
.47677 .16471 .48105 .17002 .49424 .16503 .49 .15968 Metetra
.662 .744 .911 r
.49 .15968 .49424 .16503 .50751 .16001 .50329 .15463 Metetra
.662 .744 .911 r
.50329 .15463 .50751 .16001 .52084 .15496 .51665 .14956 Metetra
.662 .744 .911 r
.51665 .14956 .52084 .15496 .53425 .14988 .53008 .14446 Metetra
.662 .744 .911 r
.53008 .14446 .53425 .14988 .54772 .14479 .54357 .13933 Metetra
.662 .744 .911 r
.54357 .13933 .54772 .14479 .56126 .13966 .55714 .13417 Metetra
.746 .773 .874 r
.55714 .13417 .56126 .13966 .57487 .13451 .57072 .1257 Metetra
.838 .704 .715 r
.57072 .1257 .57487 .13451 .58833 .12014 .58408 .10545 Metetra
.604 .5 .709 r
.58408 .10545 .58833 .12014 .60178 .10579 .59777 .10021 Metetra
.663 .742 .909 r
.59777 .10021 .60178 .10579 .61551 .10054 .61153 .09493 Metetra
.663 .742 .909 r
.61153 .09493 .61551 .10054 .62914 .09072 .62536 .08963 Metetra
.764 .981 .91 r
.62536 .08963 .62914 .09072 .64299 .08542 .63907 .07974 Metetra
.663 .742 .908 r
.63907 .07974 .64299 .08542 .65692 .08008 .65302 .07438 Metetra
.663 .742 .908 r
.65302 .07438 .65692 .08008 .67091 .07472 .66705 .06899 Metetra
.663 .742 .908 r
.66705 .06899 .67091 .07472 .68498 .06934 .68115 .06357 Metetra
.663 .742 .908 r
.68115 .06357 .68498 .06934 .69912 .06392 .69532 .05813 Metetra
.6 .422 .612 r
.06961 .31716 .07119 .34424 .08585 .31743 .08156 .30839 Metetra
.631 .585 .784 r
.08156 .30839 .08585 .31743 .09717 .31314 .09288 .30408 Metetra
.631 .585 .784 r
.09288 .30408 .09717 .31314 .10917 .30436 .10425 .29974 Metetra
.662 .744 .911 r
.10425 .29974 .10917 .30436 .12058 .30002 .11568 .29538 Metetra
.662 .744 .911 r
.11568 .29538 .12058 .30002 .13205 .29567 .12716 .29101 Metetra
.662 .744 .911 r
.12716 .29101 .13205 .29567 .14357 .29129 .1387 .28661 Metetra
.662 .744 .911 r
.1387 .28661 .14357 .29129 .15514 .28689 .15029 .28219 Metetra
.662 .744 .911 r
.15029 .28219 .15514 .28689 .16677 .28247 .16194 .27775 Metetra
.662 .744 .911 r
.16194 .27775 .16677 .28247 .17846 .27803 .17365 .27329 Metetra
.662 .744 .911 r
.17365 .27329 .17846 .27803 .1902 .27357 .18541 .2688 Metetra
.662 .744 .911 r
.18541 .2688 .1902 .27357 .202 .26909 .19722 .2643 Metetra
.662 .744 .911 r
.19722 .2643 .202 .26909 .21385 .26459 .2091 .25977 Metetra
.662 .744 .911 r
.2091 .25977 .21385 .26459 .22577 .26006 .22103 .25522 Metetra
.662 .744 .911 r
.22103 .25522 .22577 .26006 .23774 .25551 .23302 .25065 Metetra
.662 .744 .911 r
.23302 .25065 .23774 .25551 .24977 .25094 .24507 .24606 Metetra
.662 .744 .911 r
.24507 .24606 .24977 .25094 .26185 .24635 .25718 .24144 Metetra
.662 .744 .911 r
.25718 .24144 .26185 .24635 .274 .24174 .26935 .2368 Metetra
.662 .744 .911 r
.26935 .2368 .274 .24174 .28621 .2371 .28157 .23214 Metetra
.662 .744 .911 r
.28157 .23214 .28621 .2371 .29848 .23244 .29386 .22746 Metetra
.662 .744 .911 r
.29386 .22746 .29848 .23244 .3108 .22776 .30621 .22275 Metetra
.662 .744 .911 r
.30621 .22275 .3108 .22776 .32319 .22305 .31862 .21802 Metetra
.662 .744 .911 r
.31862 .21802 .32319 .22305 .33564 .21832 .33109 .21326 Metetra
.662 .744 .911 r
.33109 .21326 .33564 .21832 .34815 .21357 .34362 .20848 Metetra
.662 .744 .911 r
.34362 .20848 .34815 .21357 .36073 .20879 .35622 .20368 Metetra
.662 .744 .911 r
.35622 .20368 .36073 .20879 .37336 .20399 .36888 .19886 Metetra
.662 .744 .911 r
.36888 .19886 .37336 .20399 .38606 .19917 .3816 .194 Metetra
.662 .744 .911 r
.3816 .194 .38606 .19917 .39883 .19432 .39439 .18913 Metetra
.662 .744 .911 r
.39439 .18913 .39883 .19432 .41165 .18944 .40724 .18423 Metetra
.662 .744 .911 r
.40724 .18423 .41165 .18944 .42455 .18455 .42016 .17931 Metetra
.662 .744 .911 r
.42016 .17931 .42455 .18455 .4375 .17962 .43314 .17436 Metetra
.662 .744 .911 r
.43314 .17436 .4375 .17962 .45053 .17468 .44618 .16938 Metetra
.662 .744 .911 r
.44618 .16938 .45053 .17468 .46362 .1697 .4593 .16438 Metetra
.662 .744 .911 r
.4593 .16438 .46362 .1697 .47677 .16471 .47248 .15936 Metetra
.662 .744 .911 r
.47248 .15936 .47677 .16471 .49 .15968 .48573 .15431 Metetra
.662 .744 .911 r
.48573 .15431 .49 .15968 .50329 .15463 .49904 .14923 Metetra
.662 .744 .911 r
.49904 .14923 .50329 .15463 .51665 .14956 .51243 .14413 Metetra
.662 .744 .911 r
.51243 .14413 .51665 .14956 .53008 .14446 .52588 .139 Metetra
.881 .792 .757 r
.52588 .139 .53008 .14446 .54357 .13933 .53933 .12009 Metetra
.633 .481 .657 r
.53933 .12009 .54357 .13933 .55714 .13417 .55281 .11034 Metetra
.571 .416 .632 r
.55281 .11034 .55714 .13417 .57072 .1257 .56638 .10512 Metetra
.627 .469 .648 r
.56638 .10512 .57072 .1257 .58408 .10545 .57993 .09532 Metetra
.632 .585 .783 r
.57993 .09532 .58408 .10545 .59777 .10021 .59362 .09004 Metetra
.632 .585 .783 r
.59362 .09004 .59777 .10021 .61153 .09493 .60739 .08473 Metetra
.632 .585 .783 r
.60739 .08473 .61153 .09493 .62536 .08963 .62122 .0794 Metetra
.632 .585 .783 r
.62122 .0794 .62536 .08963 .63907 .07974 .63513 .07403 Metetra
.663 .742 .908 r
.63513 .07403 .63907 .07974 .65302 .07438 .64911 .06864 Metetra
.663 .742 .908 r
.64911 .06864 .65302 .07438 .66705 .06899 .66316 .06322 Metetra
.663 .742 .908 r
.66316 .06322 .66705 .06899 .68115 .06357 .67729 .05778 Metetra
.663 .742 .908 r
.67729 .05778 .68115 .06357 .69532 .05813 .69149 .0523 Metetra
.631 .585 .784 r
.0653 .30812 .06961 .31716 .08156 .30839 .07659 .3038 Metetra
.662 .744 .911 r
.07659 .3038 .08156 .30839 .09288 .30408 .08792 .29946 Metetra
.662 .744 .911 r
.08792 .29946 .09288 .30408 .10425 .29974 .09931 .2951 Metetra
.662 .744 .911 r
.09931 .2951 .10425 .29974 .11568 .29538 .11076 .29073 Metetra
.662 .744 .911 r
.11076 .29073 .11568 .29538 .12716 .29101 .12226 .28633 Metetra
.662 .744 .911 r
.12226 .28633 .12716 .29101 .1387 .28661 .13381 .2819 Metetra
.662 .744 .911 r
.13381 .2819 .1387 .28661 .15029 .28219 .14542 .27746 Metetra
.662 .744 .911 r
.14542 .27746 .15029 .28219 .16194 .27775 .15709 .273 Metetra
.662 .744 .911 r
.15709 .273 .16194 .27775 .17365 .27329 .16881 .26851 Metetra
.662 .744 .911 r
.16881 .26851 .17365 .27329 .18541 .2688 .18059 .26401 Metetra
.662 .744 .911 r
.18059 .26401 .18541 .2688 .19722 .2643 .19243 .25948 Metetra
.662 .744 .911 r
.19243 .25948 .19722 .2643 .2091 .25977 .20432 .25493 Metetra
.662 .744 .911 r
.20432 .25493 .2091 .25977 .22103 .25522 .21627 .25036 Metetra
.662 .744 .911 r
.21627 .25036 .22103 .25522 .23302 .25065 .22828 .24576 Metetra
.662 .744 .911 r
.22828 .24576 .23302 .25065 .24507 .24606 .24035 .24114 Metetra
.662 .744 .911 r
.24035 .24114 .24507 .24606 .25718 .24144 .25248 .2365 Metetra
.662 .744 .911 r
.25248 .2365 .25718 .24144 .26935 .2368 .26467 .23184 Metetra
.662 .744 .911 r
.26467 .23184 .26935 .2368 .28157 .23214 .27691 .22715 Metetra
.662 .744 .911 r
.27691 .22715 .28157 .23214 .29386 .22746 .28922 .22244 Metetra
.662 .744 .911 r
.28922 .22244 .29386 .22746 .30621 .22275 .30159 .21771 Metetra
.662 .744 .911 r
.30159 .21771 .30621 .22275 .31862 .21802 .31402 .21296 Metetra
.662 .744 .911 r
.31402 .21296 .31862 .21802 .33109 .21326 .32652 .20818 Metetra
.662 .744 .911 r
.32652 .20818 .33109 .21326 .34362 .20848 .33907 .20337 Metetra
.662 .744 .911 r
.33907 .20337 .34362 .20848 .35622 .20368 .35169 .19854 Metetra
.662 .744 .911 r
.35169 .19854 .35622 .20368 .36888 .19886 .36437 .19369 Metetra
.662 .744 .911 r
.36437 .19369 .36888 .19886 .3816 .194 .37712 .18882 Metetra
.662 .744 .911 r
.37712 .18882 .3816 .194 .39439 .18913 .38993 .18391 Metetra
.845 .782 .79 r
.38993 .18391 .39439 .18913 .40724 .18423 .40323 .16882 Metetra
.693 .544 .68 r
.40323 .16882 .40724 .18423 .42016 .17931 .41643 .15584 Metetra
.57 .415 .632 r
.41643 .15584 .42016 .17931 .43314 .17436 .42936 .15085 Metetra
.57 .415 .632 r
.42936 .15085 .43314 .17436 .44618 .16938 .44235 .14583 Metetra
.57 .415 .632 r
.44235 .14583 .44618 .16938 .4593 .16438 .4554 .14079 Metetra
.57 .415 .632 r
.4554 .14079 .4593 .16438 .47248 .15936 .46852 .13573 Metetra
.57 .415 .632 r
.46852 .13573 .47248 .15936 .48573 .15431 .48171 .13064 Metetra
.612 .444 .63 r
.48171 .13064 .48573 .15431 .49904 .14923 .49501 .12098 Metetra
.56 .392 .61 r
.49501 .12098 .49904 .14923 .51243 .14413 .50831 .11584 Metetra
.56 .392 .61 r
.50831 .11584 .51243 .14413 .52588 .139 .52168 .11066 Metetra
.56 .392 .61 r
.52168 .11066 .52588 .139 .53933 .12009 .53512 .10546 Metetra
.603 .499 .709 r
.53512 .10546 .53933 .12009 .55281 .11034 .54863 .10023 Metetra
.632 .585 .784 r
.54863 .10023 .55281 .11034 .56638 .10512 .56221 .09498 Metetra
.632 .585 .784 r
.56221 .09498 .56638 .10512 .57993 .09532 .57586 .0897 Metetra
.663 .742 .908 r
.57586 .0897 .57993 .09532 .59362 .09004 .58958 .08439 Metetra
.663 .742 .908 r
.58958 .08439 .59362 .09004 .60739 .08473 .60337 .07905 Metetra
.663 .742 .908 r
.60337 .07905 .60739 .08473 .62122 .0794 .61723 .07369 Metetra
.663 .742 .908 r
.61723 .07369 .62122 .0794 .63513 .07403 .63117 .0683 Metetra
.663 .742 .908 r
.63117 .0683 .63513 .07403 .64911 .06864 .64517 .06287 Metetra
.663 .742 .908 r
.64517 .06287 .64911 .06864 .66316 .06322 .65926 .05743 Metetra
.663 .742 .908 r
.65926 .05743 .66316 .06322 .67729 .05778 .67341 .05195 Metetra
.663 .742 .908 r
.67341 .05195 .67729 .05778 .69149 .0523 .68765 .04644 Metetra
.662 .744 .911 r
.06028 .30352 .0653 .30812 .07659 .3038 .07158 .29918 Metetra
.662 .744 .911 r
.07158 .29918 .07659 .3038 .08792 .29946 .08294 .29482 Metetra
.662 .744 .911 r
.08294 .29482 .08792 .29946 .09931 .2951 .09435 .29044 Metetra
.662 .744 .911 r
.09435 .29044 .09931 .2951 .11076 .29073 .10581 .28604 Metetra
.662 .744 .911 r
.10581 .28604 .11076 .29073 .12226 .28633 .11733 .28162 Metetra
.662 .744 .911 r
.11733 .28162 .12226 .28633 .13381 .2819 .1289 .27718 Metetra
.662 .744 .911 r
.1289 .27718 .13381 .2819 .14542 .27746 .14053 .27271 Metetra
.662 .744 .911 r
.14053 .27271 .14542 .27746 .15709 .273 .15221 .26823 Metetra
.662 .744 .911 r
.15221 .26823 .15709 .273 .16881 .26851 .16395 .26372 Metetra
.662 .744 .911 r
.16395 .26372 .16881 .26851 .18059 .26401 .17575 .25919 Metetra
.662 .744 .911 r
.17575 .25919 .18059 .26401 .19243 .25948 .1876 .25463 Metetra
.837 .768 .786 r
.1876 .25463 .19243 .25948 .20432 .25493 .20064 .24001 Metetra
.679 .536 .684 r
.20064 .24001 .20432 .25493 .21627 .25036 .21326 .22897 Metetra
.59 .436 .64 r
.21326 .22897 .21627 .25036 .22828 .24576 .22538 .22285 Metetra
.57 .414 .631 r
.22538 .22285 .22828 .24576 .24035 .24114 .2374 .21819 Metetra
.57 .414 .631 r
.2374 .21819 .24035 .24114 .25248 .2365 .24948 .21351 Metetra
.57 .414 .631 r
.24948 .21351 .25248 .2365 .26467 .23184 .26161 .20881 Metetra
.57 .414 .631 r
.26161 .20881 .26467 .23184 .27691 .22715 .27381 .20408 Metetra
.614 .445 .631 r
.27381 .20408 .27691 .22715 .28922 .22244 .28644 .19485 Metetra
.56 .391 .609 r
.28644 .19485 .28922 .22244 .30159 .21771 .29873 .19008 Metetra
.56 .391 .609 r
.29873 .19008 .30159 .21771 .31402 .21296 .31109 .18528 Metetra
.56 .391 .609 r
.31109 .18528 .31402 .21296 .32652 .20818 .32351 .18045 Metetra
.56 .391 .609 r
.32351 .18045 .32652 .20818 .33907 .20337 .33599 .17561 Metetra
.56 .391 .609 r
.33599 .17561 .33907 .20337 .35169 .19854 .34854 .17073 Metetra
.56 .391 .609 r
.34854 .17073 .35169 .19854 .36437 .19369 .36114 .16584 Metetra
.56 .391 .609 r
.36114 .16584 .36437 .19369 .37712 .18882 .37381 .16092 Metetra
.56 .391 .609 r
.37381 .16092 .37712 .18882 .38993 .18391 .38655 .15597 Metetra
.56 .391 .609 r
.38655 .15597 .38993 .18391 .40323 .16882 .39934 .151 Metetra
.587 .458 .671 r
.39934 .151 .40323 .16882 .41643 .15584 .4122 .14601 Metetra
.631 .585 .784 r
.4122 .14601 .41643 .15584 .42936 .15085 .42513 .14099 Metetra
.631 .585 .784 r
.42513 .14099 .42936 .15085 .44235 .14583 .43812 .13594 Metetra
.631 .585 .784 r
.43812 .13594 .44235 .14583 .4554 .14079 .45118 .13087 Metetra
.631 .585 .784 r
.45118 .13087 .4554 .14079 .46852 .13573 .46431 .12578 Metetra
.631 .585 .784 r
.46431 .12578 .46852 .13573 .48171 .13064 .4775 .12065 Metetra
.631 .585 .784 r
.4775 .12065 .48171 .13064 .49501 .12098 .49076 .1155 Metetra
.663 .742 .908 r
.49076 .1155 .49501 .12098 .50831 .11584 .50408 .11033 Metetra
.663 .742 .908 r
.50408 .11033 .50831 .11584 .52168 .11066 .51748 .10513 Metetra
.663 .742 .908 r
.51748 .10513 .52168 .11066 .53512 .10546 .53094 .0999 Metetra
.663 .742 .908 r
.53094 .0999 .53512 .10546 .54863 .10023 .54448 .09464 Metetra
.663 .742 .908 r
.54448 .09464 .54863 .10023 .56221 .09498 .55808 .08936 Metetra
.663 .742 .908 r
.55808 .08936 .56221 .09498 .57586 .0897 .57176 .08405 Metetra
.663 .742 .908 r
.57176 .08405 .57586 .0897 .58958 .08439 .58551 .07871 Metetra
.663 .742 .908 r
.58551 .07871 .58958 .08439 .60337 .07905 .59932 .07334 Metetra
.663 .742 .908 r
.59932 .07334 .60337 .07905 .61723 .07369 .61322 .06795 Metetra
.663 .742 .908 r
.61322 .06795 .61723 .07369 .63117 .0683 .62718 .06253 Metetra
.663 .742 .908 r
.62718 .06253 .63117 .0683 .64517 .06287 .64122 .05707 Metetra
.663 .742 .908 r
.64122 .05707 .64517 .06287 .65926 .05743 .65533 .05159 Metetra
.663 .742 .908 r
.65533 .05159 .65926 .05743 .67341 .05195 .66952 .04608 Metetra
.663 .742 .908 r
.66952 .04608 .67341 .05195 .68765 .04644 .68378 .04055 Metetra
.662 .744 .911 r
.05524 .2989 .06028 .30352 .07158 .29918 .06656 .29454 Metetra
.662 .744 .911 r
.06656 .29454 .07158 .29918 .08294 .29482 .07793 .29016 Metetra
.662 .744 .911 r
.07793 .29016 .08294 .29482 .09435 .29044 .08935 .28576 Metetra
.662 .744 .911 r
.08935 .28576 .09435 .29044 .10581 .28604 .10083 .28134 Metetra
.662 .744 .911 r
.10083 .28134 .10581 .28604 .11733 .28162 .11237 .27689 Metetra
.662 .744 .911 r
.11237 .27689 .11733 .28162 .1289 .27718 .12396 .27242 Metetra
.662 .744 .911 r
.12396 .27242 .1289 .27718 .14053 .27271 .1356 .26794 Metetra
.662 .744 .911 r
.1356 .26794 .14053 .27271 .15221 .26823 .14731 .26343 Metetra
.662 .744 .911 r
.14731 .26343 .15221 .26823 .16395 .26372 .15907 .2589 Metetra
.662 .744 .911 r
.15907 .2589 .16395 .26372 .17575 .25919 .17088 .25434 Metetra
.662 .744 .911 r
.17088 .25434 .17575 .25919 .1876 .25463 .18276 .24977 Metetra
.837 .768 .786 r
.18276 .24977 .1876 .25463 .20064 .24001 .19583 .23511 Metetra
.799 .768 .825 r
.19583 .23511 .20064 .24001 .21326 .22897 .20848 .22404 Metetra
.707 .754 .889 r
.20848 .22404 .21326 .22897 .22538 .22285 .22063 .21789 Metetra
.663 .742 .909 r
.22063 .21789 .22538 .22285 .2374 .21819 .23266 .21321 Metetra
.663 .742 .909 r
.23266 .21321 .2374 .21819 .24948 .21351 .24476 .20851 Metetra
.663 .742 .909 r
.24476 .20851 .24948 .21351 .26161 .20881 .25692 .20378 Metetra
.663 .742 .909 r
.25692 .20378 .26161 .20881 .27381 .20408 .26913 .19903 Metetra
.663 .742 .909 r
.26913 .19903 .27381 .20408 .28644 .19485 .28141 .19425 Metetra
.786 .967 .919 r
.28141 .19425 .28644 .19485 .29873 .19008 .29411 .18497 Metetra
.663 .742 .908 r
.29411 .18497 .29873 .19008 .31109 .18528 .30649 .18014 Metetra
.663 .742 .908 r
.30649 .18014 .31109 .18528 .32351 .18045 .31893 .17529 Metetra
.663 .742 .908 r
.31893 .17529 .32351 .18045 .33599 .17561 .33143 .17042 Metetra
.663 .742 .908 r
.33143 .17042 .33599 .17561 .34854 .17073 .344 .16552 Metetra
.663 .742 .908 r
.344 .16552 .34854 .17073 .36114 .16584 .35663 .1606 Metetra
.663 .742 .908 r
.35663 .1606 .36114 .16584 .37381 .16092 .36932 .15566 Metetra
.663 .742 .908 r
.36932 .15566 .37381 .16092 .38655 .15597 .38208 .15068 Metetra
.663 .742 .908 r
.38208 .15068 .38655 .15597 .39934 .151 .3949 .14569 Metetra
.663 .742 .908 r
.3949 .14569 .39934 .151 .4122 .14601 .40778 .14067 Metetra
.663 .742 .908 r
.40778 .14067 .4122 .14601 .42513 .14099 .42073 .13562 Metetra
.663 .742 .908 r
.42073 .13562 .42513 .14099 .43812 .13594 .43375 .13055 Metetra
.663 .742 .908 r
.43375 .13055 .43812 .13594 .45118 .13087 .44683 .12545 Metetra
.663 .742 .908 r
.44683 .12545 .45118 .13087 .46431 .12578 .45998 .12032 Metetra
.663 .742 .908 r
.45998 .12032 .46431 .12578 .4775 .12065 .47319 .11517 Metetra
.663 .742 .908 r
.47319 .11517 .4775 .12065 .49076 .1155 .48648 .11 Metetra
.663 .742 .908 r
.48648 .11 .49076 .1155 .50408 .11033 .49983 .10479 Metetra
.663 .742 .908 r
.49983 .10479 .50408 .11033 .51748 .10513 .51325 .09956 Metetra
.663 .742 .908 r
.51325 .09956 .51748 .10513 .53094 .0999 .52674 .0943 Metetra
.663 .742 .908 r
.52674 .0943 .53094 .0999 .54448 .09464 .5403 .08902 Metetra
.663 .742 .908 r
.5403 .08902 .54448 .09464 .55808 .08936 .55394 .08371 Metetra
.663 .742 .908 r
.55394 .08371 .55808 .08936 .57176 .08405 .56764 .07837 Metetra
.663 .742 .908 r
.56764 .07837 .57176 .08405 .58551 .07871 .58141 .073 Metetra
.663 .742 .908 r
.58141 .073 .58551 .07871 .59932 .07334 .59526 .0676 Metetra
.663 .742 .908 r
.59526 .0676 .59932 .07334 .61322 .06795 .60918 .06218 Metetra
.663 .742 .908 r
.60918 .06218 .61322 .06795 .62718 .06253 .62317 .05672 Metetra
.663 .742 .908 r
.62317 .05672 .62718 .06253 .64122 .05707 .63724 .05124 Metetra
.663 .742 .908 r
.63724 .05124 .64122 .05707 .65533 .05159 .65138 .04573 Metetra
.663 .742 .908 r
.65138 .04573 .65533 .05159 .66952 .04608 .66559 .04019 Metetra
.663 .742 .908 r
.66559 .04019 .66952 .04608 .68378 .04055 .67989 .03462 Metetra
P
p
.002 w
.67932 .02494 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.67932 .02494 m
.06024 .26735 L
s
P
p
p
.002 w
.06024 .26735 m
.67932 .02494 L
s
P
p
.002 w
.16304 .2271 m
.16744 .23152 L
s
P
[(10)] .15425 .21825 .99414 1 Mshowa
p
.002 w
.2826 .18028 m
.28679 .18489 L
s
P
[(20)] .27421 .17106 .90904 1 Mshowa
p
.002 w
.40818 .13111 m
.41214 .13592 L
s
P
[(30)] .40025 .12149 .82394 1 Mshowa
p
.002 w
.54025 .07939 m
.54395 .08441 L
s
P
[(40)] .53284 .06937 .73884 1 Mshowa
p
.002 w
.67932 .02494 m
.68274 .03015 L
s
P
[(50)] .6725 .0145 .65374 1 Mshowa
p
.001 w
.18649 .21791 m
.18911 .22059 L
s
P
p
.001 w
.21017 .20864 m
.21276 .21134 L
s
P
p
.001 w
.23408 .19928 m
.23664 .202 L
s
P
p
.001 w
.25822 .18983 m
.26076 .19257 L
s
P
p
.001 w
.30722 .17064 m
.30971 .17343 L
s
P
p
.001 w
.33208 .16091 m
.33454 .16372 L
s
P
p
.001 w
.35719 .15107 m
.35963 .15391 L
s
P
p
.001 w
.38256 .14114 m
.38496 .144 L
s
P
p
.001 w
.43405 .12098 m
.4364 .12389 L
s
P
p
.001 w
.4602 .11074 m
.46252 .11367 L
s
P
p
.001 w
.48661 .1004 m
.48889 .10336 L
s
P
p
.001 w
.51329 .08995 m
.51554 .09293 L
s
P
p
.001 w
.56748 .06873 m
.56967 .07176 L
s
P
p
.001 w
.59501 .05795 m
.59716 .06101 L
s
P
p
.001 w
.62282 .04706 m
.62494 .05014 L
s
P
p
.001 w
.65092 .03606 m
.653 .03916 L
s
P
p
.001 w
.13982 .23619 m
.14248 .23882 L
s
P
p
.001 w
.11681 .2452 m
.11949 .24781 L
s
P
p
.001 w
.09402 .25412 m
.09673 .25671 L
s
P
p
.001 w
.07145 .26296 m
.07417 .26552 L
s
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{367, 301},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005_0001;@P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0L0000?l0L0000?l0L0000>h00ol400;o
N0000?4000Co003o0P000ol0001e0000l@001?l00?l20003o`0007D0003^00?o0`001?l00?mg0000
kP000ol000030004o`00ogL0003^00Co0`02ogP0003o0700003o0700003o0700003o0700003o0700
003i00;oM0000?H00ol00`3o001c0000m002o`@00_mc0000l@03o`H000?o0?l0LP000>h00ol800;o
00<0o`00L@000>`00_l20003o`0000<00ol01F_o003o0740003Y00?o2002o`04cV_>J`;o0P000ol0
001^0000i`02o`P00ol00g?oL`04o`04Joooog00003T00?o2002o`04Jli[cP;o00E[cV_oJ`02o`03
0?l006h0002m00?o0`02oad00_l20003o`0000<00ol00f_oJ`03o`04Jg?oL`?o00Eco`00o`1^0000
_P001Ol0003o008000?o00005`03o`P00_l01<i[cV/2o`05cV_>Jlh00_l016_>olh2o`030?l006d0
002l00Co0P001?l00?lG00;o2003o`03Lomc00?o00AcJom[0ol00f_oJ`03o`05Jg?o0?l0K@000;`0
00?o0?l00`001?l00?lD00?o2002o`04Jli[cP;o00E[cV_>J`02o`04cV_>J`;o00G>oli[cP02o`03
0?l006/0002l0003o`3o00<000Co003o4@03o`8000?o00000`03o`03Jom[00?o00A[of]c0ol00g?o
L`03o`03Lomc00Co00A[o`3oK0000;d00_l400;o4002o`T00_l01<i[cV/2o`04cV_>J`?o00A[cV_>
0_l016_>Jlh3o`04cV_>J`;o00<0o`00JP000=800ol800?o00=cog<00ol00g?oL`03o`04Lf_oJ`?o
00=[of/00ol016]cog<3o`04Loooof/0003@00?o2002o`04Jli[cP;o00A[cV_>0_l01F_>Jli[00;o
00C>Jli[0_l01Li[cV_>00;o00A[cV_>0_l00`3o001Y0000c@03o`8000?o00000`03o`03Jom[00?o
00=[of/00ol016]cog<3o`03Lomc00?o00AcJom[1Ol02F_ooom[Lol0o`1Y0000b`02o`P00ol01<i[
cV/2o`04cV_>J`;o00G>Jli[cP02o`04Jli[cP;o00E[cV_>J`02o`03cV_>00?o00G>Jli[cP03ofT0
003800?o1P04o`04Jg?oL`?o00=cog<00ol017=[of/3o`03EOm[00?o00A[Lomc0ol00g?oL`03o`04
Lf_oJ`?o00A[o`3oJ0000<D01?l500?o00I[of_>Jlh2o`04Jli[cP;o00E[cV_>J`02o`04ECME=`;o
00G>Jli[cP02o`04Jli[cP;o00E[c_o>J`02o`04cV_>J`;o00<0o`00IP000<<00_l30004o`0000;o
00EcJg=[L`04o`03Jom[00?o00A[Lomc0ol02^[ojUGZo`lUof/3o`03Jom[00?o00A[of]c0ol00g?o
L`03o`04Lol0ofL0003000?o1P03o`05c_o>Jlh00ol01<i[cV/2o`05cV_>Jlh00_l02cME=eGoECOo
oRCn00;o00C>Jli[0_l01<i[cV/4o`03cV_>00;o00Q[cV_>Jol0ofH0002n00;o1`02o`04Jg=[L`Co
00E[Lf_oJ`02o`04Lf_oJ`?o00MEoeGZENYE00;o00L?ooooLomc00?o00=cog<00ol00g=[o`04o`05
Jom[Lf/00ol00`3oo`1U0000^`04o`D00ol00f_oJ`03o`06JlkocV_>0ol01<i[cV/2o`08ECME=eGo
ECL5o`04Jli[cP;o00A[cV_>0_l01F_>Jli[00;o00C>Jli[1?l01/i[c_l0ofD0002i00;o10000ol0
0002o`04Lf]cJ`;o00EcJg=[L`04o`04EN[oL`?o00KZonYEjUD4o`06Looo9Om[0ol00f_oJ`03o`04
Jg?oL`?o00=cog<00ol01W=[of]cJ`?o00<0o`00H`000;H00ol600?o00?>olh00ol01<i[of/3o`06
=olgECME0_l01CME=eDg00Co00S>Jom[oohToP;o00C>Jli[0_l01Li[cV_>00;o00A[cV_>0_l01F_>
Jli[00Co00?>Jol00P000ol0001Q0000]002o`L00_l016]cJg<2o`05Jg=[Lf/00_l01nYEjUGoENX0
0_l01Y[oENYEjP;o00E[Lf]cJ`02o`083oooog=[of/2o`04EF7oJ`?o00=Rof/00ol016_oog<3o`05
LomcJg<00ol00`3o001R0000R`03o`@00_lM00?o00<0o`000`03o`04JlkocP;o00A[c_o>0ol01eGo
ECME=eD00_l01UInEWkoE@;o00AnEOo>0ol020ooof_>Jli[0_l046YnJWiZofYmJWeZoli[cV/3o`04
Jli[cPCo00=[c_l00P000ol0001P0000SP001?l00?l20003o`0001L00ol700;o00EcJg=[L`02o`04
Jg=[L`;o00UZHVYRonYEjUD00_l03UJJEYYFV_mZHVYRJ_mb0ol016]cog<3o`0=EOmEHEEQEOmQHV5R
H@02o`07Joooof_oJ`03o`05Jom[Lf/00ol20003o`0005l0002>0004o`00o`8000?o00005@02o`L0
0ol01<i[of/3o`03Jom[00?o00LZogiEOUEn00Co00inogiFOUInE_mnEGiEOP;o00G>Jli[cP02o`09
OVYnJ_mZOVYn00;o00IZOFYmoo82o`04cV_oJ`;o00C>Jli[1?l01/i[c_l0of40002<00;o0`001?l0
0?lD00?o1`02o`05Jg=[Lf/00_l017=[Lf/2o`0957hDO_mZHVYR00;o00XJFQYJoeJJEYYF0_l02FYR
JV;oLf_oJ`03o`0AHOmQEF5EoeEQEOlgj_mRHF800_l00n[oL`03o`03Lomc00?o00IcJom[Lf/3o`03
0?l005l0002>0004o`00o`8000?o00004002o`<000?o00000P02o`04JlkocP?o00?>olh00ol02H3o
P2Z0:X3oE@02o`0EEOn=OXenSOmFOUKo<OmnEGkoJli[00;o01MZOVYnogiZOVYnogkoEC9EogeZOOlg
E@02o`04Jom[cP;o00E[cV_>J`04o`06cV_oo`3oG`0008/00ol400;o4003o`P00_l016]cJg<2o`04
Jg=[L`;o00Yn57hDoaAn57hD0_l3ZP0;oaYJ6UXJoiYFV_l00[l01?mRog<3o`0LP?mEHEEQof5EHEEQ
of7ojSOZof9QonYEobGoJ`?o00AZH_mc0ol01G?oLf]c00?o00<0o`001`04o`<00_m>0000XP02o`P0
0ol00f_oJ`03o`03=om[00?o01hZobZ0:X0ZobZ0:X3oOUEnEGkoOXenSOmFO_lK<A/4o`0?FWiJO_mZ
OVYnJ_mZOVYn00;o00`bEC9EogeZoeGo9503o`0:OUEnEGkoJli[cPCo00<gEOl00P000ol000060003
o`00008000Co003oC@0009l01?l600?o00AcJg=[0_l01>YEjUD2o`0@57hDO_mn57hDO_mn57hDo`FZ
00WoFQYJ6_nJE_l00kl04_mQH_m:P4Z0oeEQEF5EoeEQE@;o00OZ=nXgj_mR00Ko00MRoomZHVYR00;o
00Y[ooooHOmEjUGZ0_l20003o`0000H000Go0000o`020003o`0004/0002L00?o0`000ol00004o`04
JlkocP?o01IEoeDgEOmZoh0ZP2Z0oh0ZP2[o:X0Z0_l02giEOUEnogj=OXen00;o018a6c7oOFYmoeYn
FWiJogiZOVX4o`08O_mE<UDbEC84o`0;OUEnEGkoOUEnob@00_l01fYnJWko=eD00_l01@7oo`3o00T0
00Co003o0P000ol0001;0000VP02o`H00ol01F]cog=[00?o00QEjUGZEOmEo`9n01;o57hDOQCo57hD
O_mn57ko:ol4ZP05oeXJFQX00_l3_`0?of5RHF;oBX1:P4[oHEEQ00;o00]RJV9ZH_lgjSOZ=`02o`0D
EOmZHVYRJ_mZH_oKocOoEF5EHED5o`05jUGo0?l01@001?l00?l20004o`00odd0002G00?o1P02o`05
cV_>Jlh00ol025DgocME=eDg0_l076YQJV7o:X0ZP?n0:X0ZobZ0o`OZoeEnEGkoOXd2o`0@FolK<OmQ
ogeZOOmJOUYnFPCo00aEoeEnEGiEoc9E<UD2o`0E<E0aoeEnEGkoO_lToeFZofYnJWiZ00;o00DgECME
=`03o`H00_l400;oCP0009D00_l20003o`0000800_l017=[of/3o`08EOmEjUGZonX3o`03F_mn00=n
00_oOQAn5?lDOQAn5002o`04:bH[o`FZ0_l016_>Jlh2o`9n00WoHV5RHOn0BX000_l036YRJV9ZofYR
JV;o=`Co00UE_UFnof9ZHVX00_l02m_o=ghgO_mQEF5E00;o00IEjUGZobD3oe/0002B00?o1@002?l0
ooo>Jli[0_l02EDgECOo=eDgE@02o`0DSGj=O_mZHFYQobZ0:X3oP2Z0:X02o`07jPOZ1omnE@03o`04
3e/?F`;o00YQJV7oOFYmJ_mn0_l0353oOUEnEGkoOUEnE@;o00YnooooD35@<OmE1_l04UFZEJYEogiZ
O_m@<OmE=ol13`;o00<0o`00F@0009000_l700?o00=cog<00ol01n[ojUGZENX01?l01a[o6UXJF_l0
17h02_mn57hDO_mn57h2o`049R/V:`Co00AcJoo>0ol5OP05of9QHV400_l02eFnEKkoHVYRJ_mZ00?o
00=QEOl00ol015FnEKh2o`0DL_ooof7oOSMn=gkoHEGo_UFnonX4o`04F_l0oeX0002=00?o1`02o`04
Jli[cP;o00TgECME=olgECL00_l057j=OXgoSGj=O_mZHFYQobZ0:X0Z1?l00lko1`03o`05c_o>Jlh0
0ol037iEO_mZHFYQogeZO@;o00XaD35@<OmEOUEn0_l00o[oo`02o`04Jom;F`Co00i[oomZO_mnJ_nZ
EJYEZP;o00A@<E0a0ol01GiEOUGo008000?o0000E`0008X00ol30004o`0000?o00A[Lomc0_l02EGo
ENYEjUGoE@02o`0=F_mJ6UXJoaYJ6UXJo`04OP04oaAn50;o00A[Lf]c0_l016]cJg<5o`FZ00?oOWh0
0gh03?mQoa_o_UFnEKkoHP?o00XaooooLf]coe/70_l047=[oolgoeEQEOmEocMn=gh3o`03EKko00;o
00R0oh1JP5Z0o`8000?o0000EP0008P00_l700?o00G>Jli[cP02o`09=eDgEOmE=eDg00;o01=nSGko
OXenSOn=OXenSOmQJV5Z00Co00=[of/00ol016_>olh2o`03FWiJ00;o00]nEGiEO_mZHFYQJP02o`08
<1/`oe0aD342o`0;EOooof_>Jom[od/00_l042Coc_nZEJYEogiZof[oZUD3o`0?9G_ooeYnFWkoOUEn
EGko008000?o0000EP0008D00ol600?o00E[Lf_oJ`03o`08HOmEjUGZonX3o`0AF_mJ6UXJoaYJ6U[o
FQYJ6_l00gh2o`04Lf]cJ`;o00EcJg=[L`02o`05O_m:P?l00S400onZZP02ZP03ogin009n0_l01Q_>
6lkoE@?o00PgEOonog=[L`?o00EKo`lU3`02o`0;OSMn=gkoHEGoEF400_l0137oF`L3o`0;BX1:P4[o
FX1JP?l00`000ol0001E0000GP04o`<00_lL00;o00<0o`000`03o`05c_o>Jlh00ol026YnJWiZoeDg
0ol04henSGkoOXenSOn=OXenogj=OXd01?l00lkocP03o`04cV_oJ`?o00AQJV5Z0_l02Koj_omEOUEn
E@04o`06FolK<1/`0_l01eGojUGooRD01?l01F_>ooon00?o00ajoeFZEJYEogiZofX2o`0C2olUNomn
P?mJOUYnF_mEOUEnE@03o`030?l005D0001O0003o`00008000Co003o6003o`@000So0?ooJg=[L`Co
00Qn5?mEHEEQE@?o01EJ6_lJFQYJoeXJFQ[o6UXJF_mJ6UX00_l016]cJg<2o`05Jg=[Lf/00_l00`Oo
OP03OP;o13400onZZP02ZP;o00ED3e@?E004o`05VWjJoeD01?l00eGoJ`03o`0>LoooJV9ZHV[o=ghg
OSL4o`0D3oooF`Oo6UXJF_n0BX1:oeZ0FX02o`04EOoooeH0001P0005o`000?l00P000ol0000D00;o
1`02o`04JlkocP;o00/ZobZ0:X3oJWiZOP02o`0COXenSOn=OXenogj=OXgoSGj=OP04o`04JlkocP;o
00A[c_o>0ol03a/C6omZHF[oFooj_oZonP04o`05JomDFe@00ol00c3oE@03E@?o00AE=eDg0ol03lgo
oeGoEGYENUGoZUFZE@02o`0J3oooolkoNomnP7j0O_mnFWiJoeEnEOlgECL2o`030?l005@0001Q0004
o`00o`8000?o00004@03o`L00_l016]cJg<2o`0POQAnoghDOQCoEF5EogkoFQYJ6_lJFQYJ6_lJFQYJ
oeX3o`05Lf]cJg<00_l016]cJg<3o`061c87<POo0Wh01?mKc_l4<@;o00AcJg=[1?l01eGo<F_oOYX0
0ol01@oojUGZ00Go00aZHVYRof9ZHV[o=gh2o`07c_ooooX?nP02o`0AO_lJFQYJoh1:P4[oFX3ojUD0
0_l01Gko003o05@0001N0004o`00o`8000Co003o4@02o`<000Co00000ol00f_oJ`03o`0O:_lZP2Z0
oh0ZP2[oO_n0<X3oSGj=ohenSGj=ohenS@03o`05Jli[of/00ol00f_oJ`04o`08EOlK4a/C6a<2o`04
FliKcPCo00?>olh00ol04/i[olko<2/`oeGo6omKRomE=`?o00ejEOmENUEjogYENUEj00;o00@?oomb
1Ol03WiZO_n0OX1nogiJOUYn0_l02UGoofYnJWko0?mD0000G`02o`@00_l?00?o1`02o`04Lf]cJ`;o
00hDOQAnoghDOQCo57hDOP;o00inEGiEoaYJ6U[oFQYJ6PCo00Ecog=[L`03o`03Lf]c00Go00T`6c0K
oc87<PL00_l015_>Flh2o`04Jg=[L`;o00E[Lf]cJ`02o`04<F/aJ`;o00HKo`n;3h/3o`0=HVYRJ_mZ
HVYRof9ZHP03o`05FonK1Y/00ol5OP0:oaYJ6U[oP4Z0BP;o00=nHOl01Gh2o`030?l00580001c00?o
2002o`04cV_oJ`;o01n0oh0ZP2[o:X0ZP?n0:X0Zoh0bP3:0ohenSGkoOXen00;o00A[cV_>1?l00f_>
o`03o`05JoooFol015D00olCo`02o`03Joo>00?o00=[of/00ol016_>olh3o`03Fol[00?o00L?oomK
Re^;00;o00^oogYENUEjogYENP04o`05cV_oo`l00ol03WkoO_mZOVYnoh1nP7j01?l02VYEJUGoOVYn
J_l29`03o`3o0580001a00;o00<0o`001@03o`03Lf]c00?o01dDOQCo57hDO_mn57hDoaAn57koEGiE
OUGo6UXJFP04o`03Jom[00?o00A[Lomc0_l036]cog?oJli[c_lK<0?o00AcJg=[0_l017=[Lf/2o`05
Lf]cJg<00_l015@?E0l2o`08Noooof]co`l3o`8a00KoHVYRJV84o`03EOmc00Ko00NZoeZ0oh3o00An
00Go6UXJFP03o`05O_mnHGh00_l4OP06o`8co`3oDP0006h00ol40003o`3o00?o00=[c_l00ol07bZ0
oh0ZP?n0:X0ZobZ0:X3oP2Z0oe_o<X0bP?n=OXd00_l01<i[cV/2o`05cV_>Jlh00_l016_>Jlh2o`04
3e/?F`Co00A[c_o>0ol01<i[of/2o`04cV_oJ`?o00=[oe@00ol02<kooli[cV_>0_l02V_o_oZon_mE
NUD2o`04D<i@cPGo00mnEGiEoeEnogkoJWiZOVX01?l047iZOV[oJUGoEC;oJWiZobL5oe40001/00;o
1`02o`04Jg?oL`;o021noghDOQCo57hDoaAn57hDoaAn57koO_l7:omnEGiEOP?o00AcJom[0_l017=[
of/3o`03Jom[00?o00=[olh00ol01F]cog=[00Co00=cJg<00ol017=[Lf/2o`04Lf]cJ`?o00O>oolK
<?m[00?o00=Dool01C44o`04c_oZE@Go00=nojX00jX01_mJP?n0o`An0_l00h3oOP05OP;o00AnEGko
0Wh01_lcof]co`8000?o0000CP0006T00ol700;o00A[cV_>0_l05bZ0:_lZP2Z0oh0ZP?n0:X0ZP?n0
:X0Z00;o00QK:e_o<X0bP0;o00C>Jli[0_l01<i[cV/2o`04cV_>J`;o00C>Jli[0_l01Li[cV_>00?o
00?>Jlh01?l016_>olh3o`03c_o>00?o00S>Jooo3a/?6`;o00YKE?ooEOoj_oZo0_l5E@;o01=boeEZ
EF[oOUEnEGkoO_mnofYn00?o015EOUGoOVYnJWkoEC9E<_mZOP02o`03cV_o00;o00<0o`00C`0006L0
0_l30004o`0000?o00=[of/00ol067koOQAnoghDOQCo57hDO_mn57hDoaAn50;o00D7:`L[1`04o`03
Lomc00?o00=cog<00ol017=[of/2o`04Lf_oJ`;o00AcJom[0ol00f_oJ`03o`05Jom[Lf/01?l00g=[
o`02o`03Jg=[00;o00<?oa/00ol027?o3ol`6c3o0S42o`06JolbcS;>1Ol01F5nHGko00FZ00GoP?n0
FP02o`07c_n0FX1Jo`04OP;o00IEOUEnogh5o`06Lf_oo`3oC`0006@00ol600?o00C>Jli[0_l05h0Z
P2[o:X0ZobZ0:X3oP2Z0:_lZP2Z000Co00E[ob]K:`03o`03Jli[00?o00A[cV_>0_l01F_>Jli[00;o
00C>Jli[0_l01<i[cV/2o`04cV_>J`;o00C>Jli[1?l00li[cP03o`08cV_>olko3e@3o`03Jli[00?o
1ED2o`06F`mK3omE1Ol03S;oEFYEJUGoEGiEO_mn1?l060ooogiEOUGoOVYnoe_oEC9E<_mZof[ocP?o
00G>o`00o`1>0000H@03o`T000GoJbGoJ`02o`0H5?lDOQAnoghDO_mn57hDO_mn57koOQAn0_l017=[
Lf/4o`03Lf_o00?o00EcJg?oL`02o`04Jg?oL`?o00=cog<00ol00g?oL`03o`03Lomc00?o00AcJom[
0_l017=[of/3o`05Jom[Lf/01_l00g=[o`03o`07</ko6c0K<002o`05cV_>Jlh00_l03C3o3olg<COo
OV5nHOl00jX4o`0;Lf_oogkoP5Z0F_l00Wh02OmK1omEOUEnE@05o`04Jg=[L`;o00<0o`00C@0005l0
0_l00`3o00080003o`lT00?o01J0:X3oP2Z0:_lZP2Z0oh0ZP2[o:X0Z1?l01<i[of/2o`04cV_oJ`;o
00K>Jom[cV/3o`03Jli[00?o00A[cV_>0_l016_>Jlh2o`04Jli[cP;o00E[cV_>J`02o`04cV_>J`;o
00C>Jli[1?l01Poo3a_oJ`;o00=EoeD015D02?mEoom[c_mK0ol03/koob_o<^Xbj_mZEFYE1?l01<i[
of/2o`09<UDbogiEOUEn00;o15/01?lbEC82o`06O_m[c_o>0_l01F_>o`3o04d0001L00?o10000ol0
000400Go01Qn5?lDOQCo57hDO_mn57hDoaAn57koOQ@2o`05Jg=[Lf/00_l017=[Lf/2o`04Lf]cJ`Co
00=cJol00ol017=[of/3o`04Jg?oL`;o00A[Lomc0_l016]cog<3o`03Lomc00?o00=cog<00ol027=[
olko<1/`0_l023;></kocS;>0ol016]cJg<2o`05Jg?oo`l00_l02CLa=c4gogiQOP02o`05Jg=[Lf/0
0ol02EEnEGkoP5Z0FP02o`05F`MK1e/01?l01V5Eog=[L`;o00A[Lf]c1?m<0000FP02o`/00ol06/ko
obZ0:X3oP2Z0oh0ZP2Z0oh0ZP?n0:X0Z0ol016_>olh3o`03c_o>00?o00?>olh00ol01<i[of/2o`05
cV_oJlh01?l00f_>J`03o`03Jli[00?o00A[cV_>0_l016_>Jlh2o`04Jli[cP;o00E[cV_>J`02o`06
3ooooeGo15D4o`04cV_oJ`?o00E[of_o<002o`082ooZ<^XbjS83o`04JlkocP?o0UD01_mE<UDbE@Co
00?>oe/00U/3o`06JWkoO_m[0ol00f_oJ`03o`04Jol0od`0000b00?o1002oa`01?l:00;o01][Lf_o
O_mn57hDoaAn5?lDOQAn5?lDOQCo57h00ol016]cJg<2o`04Jg=[L`;o00A[Lf]c0_l01F]cJg=[00;o
00AcJg=[0ol00f]cJ`04o`03Lf_o00?o00AcJom[0ol00f_oJ`03o`04Jg?oL`;o00A[Lomc0ol020oo
olhbcS;>1?l01G?oLf]c00?o00=cJg<01Ol02C1E<5Go<CLa=`02o`04Jg=[L`?o00An<Whb0_l00giE
OP02o`04Jg=[L`Go1Gh3o`03Lf]c00?o00AcJg=[0_l00`3o001:0000<`000ol000020004o`00oaT0
0_l40003o`0000D00_l06F_>olkoJV7o:X0ZP?n0:X0ZobZ0:X3oP2X01?l01Li[c_o>00;o00A[c_o>
0_l016_>olh2o`04JlkocP?o00?>olh00ol00lkocP03o`04cV_oJ`;o00G>Jom[cP04o`03Jlko00;o
00G>Jli[cP02o`04Jli[cP;o00IDFooo3ol4E@;o00A[cV_>1?l00f_>o`03o`0;JoooFol;SP^>oc80
0ol00f_oJ`04o`03FomE00=E1Ol00f_oJ`06o`09O_mZOVYnJ_l?00Co00A[c_o>0ol01<ko0?m;0000
<`000ol000020004o`00oaH00ol;00?o00=[Lf/00ol3OP0?oghDOQCo57hDO_mn57hD00?o00IcJom[
Lf/3o`03Jg=[00?o00A[Lf]c0_l016]cJg<2o`04Jg=[L`;o00A[Lf]c0_l01F]cJg=[00;o00AcJg=[
0ol00f]cJ`03o`05Jg=[of/00ol00f_oJ`03o`08JomDoli[cV/4o`04Jg?oL`;o00A[Lomc0_l036]c
og?oJli[c_mE<0?o00=cJg<00ol02W=[og]KNolbOS82o`04Lf]cJ`Go00EJ6UXJo`04OP?o00E[of]c
J`03o`03Jg=[00?o00<0o`00B@0003<000?o00000P001?l00?lD00;o2P04o`03cV_o00?o01AncOmQ
JV7o:X0ZP2[o:X0ZobZ0:P;o00C>Jli[1?l00li[o`03o`04cV_oJ`?o00=[of/00ol016_>olh2o`04
JlkocP;o00A[c_o>0ol00lkocP03o`03c_o>00?o00G>oli[cP03o`03cV_>00?o00C>Jli[0_l015/?
F`l2o`05cV_>Jlh00_l016_>Jlh2o`04Jli[cP;o00@?F`mK1?l00f_>o`03o`09Jlkoc_mK<5/`00Go
00=[of/00_l04/kojU[oEGiEO_mZOV[ocV_>J`Co00?>Jol00ol01/i[ool0odT0000c0003o`000080
00Co003o4@03o`8000?o00001@02o`04Lf_oJ`;o00<JoaX00aX00omnOP02OP09oaAn57koOQAn00Co
00=cog<00ol017=[of/2o`05Lf_oJg<01?l00f]co`03o`03Jg=[00?o00A[Lf]c0_l016]cJg<2o`04
Jg=[L`;o00A[Lf]c0_l016]cJg<4o`03Jg?o00?o00E[Lf_oJ`02o`04Lf_ocP;o00AcJom[0ol00f_o
J`03o`03Jom[00?o00=[olh00ol00f_oJ`03o`05Jom[Lf/01?l00e]ko`03o`03Lf_o00?o00acJolg
<SOoFQYJ6_l2OP;o00McooooLomc00?o00=cog<00ol017?o0?m90000<P02o`D00_l?00?o2`02o`04
cV_>J`;o01EncGkoO/encOmQJV5Zoh0ZP2[o:X000_l016_>Jlh2o`05Jli[cV/00_l01<i[cV/3o`03
Jli[00?o00=[cV/01?l01<i[of/3o`03Jom[00?o00=[of/00ol016_>olh2o`04JlkocP;o00A[c_o>
0_l01V_>oli[cP?o00?>Jlh00ol00li[cP03o`04cV_>J`;o00C>Jli[0_l01<i[cV/2o`04cV_>J`;o
00C>Jli[1?l00li[cP03o`03cV_>00Co00m[c_o>onYJjU[oEGiEOUD00_l01lkoof_>Jlh00_l016_>
Jlh2o`04Jli[cP;o00<0o`00A`0004P00_l<00;o00AcJom[0_l00a[o6P036P05oaXJ6_l017h01OlD
OQAn00?o00A[Lomc0_l016]cog<3o`03Lomc00?o00=cog<00ol00g?oL`03o`05Lf_oJg<01?l00f]c
o`03o`03Jg?o00;o00EcJg=[L`02o`04Jg=[L`;o00A[Lf]c0_l016]cJg<4o`03Jg?o00?o00=[Lol0
0ol016]cog<3o`03Lomc00?o00=cog<00ol017=[of/2o`04Lf_oJ`;o00AcJom[0ol00f_oJ`03o`05
Jom[of/01?l02C8g<SOoFQYJ6P04o`04Jg?oL`;o00A[Lomc0_l016]cog<2o`05Jg?o0?l0A`0004D0
1?l;00;o00?>Jlh00ol057k=O_mncGk=olencGkoJV5Zoh0Z1?l00li[o`02o`04Jli[cP;o00A[cV_>
0_l016_>Jlh2o`04Jli[cP;o00E[cV_>J`03o`03Jli[00?o00=[cV/00ol01F_>Jom[00?o00=[of/0
0ol00f_oJ`03o`03Jom[00?o00=[of/00ol00f_oJ`03o`05JlkocV/01?l00li[o`03o`03cV_o00;o
00E[cV_>J`02o`04cV_>J`;o00C>Jli[0_l01<i[cV/2o`04cV_>J`Go00PaJc7oF^YJjPKo00=[cV/0
0ol016_>Jlh2o`04Jli[cP;o00A[cV_>0ol900?o0`02ocH0001300;o10000ol0000500?o00<?ool0
0_l26P05oaXJ6_l011X00olJ6P026P03ogin00Co00=cJg<00ol01G=[Lomc00;o00A[Lomc0_l016]c
og<2o`04Jg?oL`;o00A[Lomc0ol00g?oL`03o`03Lomc00?o00Ecog=[L`03o`03Lf]c00?o00AcJg=[
0_l017=[Lf/2o`04Lf]cJ`;o00AcJg=[0_l01G=[Lf]c00?o00=cJg<00ol00g=[L`03o`05Lf]cog<0
0ol00g?oL`03o`03Lomc00?o00?Zog<00ol00g?oL`03o`0;Loooo`M[1f_o=c801Ol00g=[o`03o`04
Lf_oJ`?o00=[of/00ol00f_oJ`03o`04Jol0o`T000Go0000o`020003o`0003<0001000?o3@006OmD
FeCoP?o=O/enogk=O_mncGk=olencGh00ol01<i[of/3o`05Jom[cV/00ol00f_>J`03o`03Jli[00?o
00A[cV_>0_l016_>Jlh2o`04Jli[cP;o00A[cV_>0_l016_>Jlh4o`03Jlko00?o00E[cV_oJ`02o`04
cV_oJ`;o00C>Jom[0_l01<i[of/2o`04cV_oJ`?o00=[of/00ol00cOoJ`03o`05Jom[cV/00ol00f_>
J`03o`03Jli[00?o00@gECME0_l016_>Jlh2o`04Jli[cP;o00@aJc5[1Ol00lkocP03o`05c_o>Jlh0
0ol00li[cP03o`03cV_>00?o00?>Jlh00ol00`3o000500Co0P001?l00?le0000?P03o`h000Go<?l?
o`02FP03oaXJ008J00?o6QX00QX01OlJ6Q[o00<J0_l017=[Lf/2o`04Lf]cJ`Co00=cJol00ol00g=[
o`03o`04Lf_oJ`?o00A[Lomc0_l016]cog<2o`04Jg?oL`;o00A[Lomc0_l016]cog<2o`06Jg?oLf]c
0ol00g=[L`03o`03Lf]c00?o00AcJg=[0_l017=[Lf/2o`04Lf]cJ`;o00CZENYE0_l017=[Lf/4o`03
Lf_o00?o00=cJol00ol01NYEoeGZ00;o00<Uof/00ol00f_oJ`03o`04Jooo1`Go00=cJg<00_l016]c
Jg<4o`03Jg?o00?o00=[Lol00ol00f]co`03o`05Jg?o0?l01P000ol0o`030004o`00ocD0000k00?o
0`000ol0000:000Goc]K>on0OX3ocGk=O_mncGk=olencGh00ol01<i[of/2o`04cV_oJ`;o00C>Jom[
0_l01<i[of/2o`05cV_oJlh01?l00f_>J`03o`03Jli[00?o00A[cV_>0_l016_>Jlh2o`04Jli[cP;o
00A[cV_>1?l00f_>o`03o`03Jlko00?o00A[c_o>0ol00lkocP03o`03c_o>00?o00AEoeDg0_l00a_o
cP03o`04cV_oJ`;o00AE=om[0_l01eGoECME=eD00_l00bD?o`03o`03Jlko00;o00C>Jli[1Ol00f_o
J`03o`03Jom[00?o00=[of/00ol00f_oJ`03o`032om[00?o00E[of_>J`03o`030?l000@000?o0?l0
0`001?l00?le0000>003o`L000?o000020001?l`Fc02o`=J00?o6QX00aX01OlJ6Q[o008J0ol00g=[
L`03o`04Lf]cJ`;o00AcJg=[0_l017=[Lf/2o`04Lf]cJ`?o00=[Lf/01?l00g=[o`03o`04Lf_oJ`?o
00<[of/00ol00f_oJ`03o`03Jom[00?o00=[of/00ol016]cog<2o`05Jg?oLf/01?l00g=[o`03o`03
Lf_o00;o00EnEGiEOP02o`0:6c0K<?m[Lf]cJ`;o00CZENYE0_l02>YEjUGoENYE1Ol00f]cJ`03o`05
Jg=[of/01Ol00f]co`03o`03Jg?o00;o00AcJg=[0_l017=[Lf/2o`04<EDaE@;o00AcJg=[1?l00g=[
o`03o`D00_l400;o=P0003H00olC000Coc]K>oo:oh1nP7koO/encOo=OP04o`03Jlko00?o00A[c_o>
0ol00lkocP03o`03c_o>00?o00C>Jom[0_l01<i[of/2o`04cV_oJ`;o00G>6om[cP03o`04cQ_>6`?o
00=[c_l00_l01<i[cV/2o`04cV_>J`;o00G>Jli[cP02o`04Jli[cP?o00?>Jlh00ol00li[cP03o`07
EM[ofUGJE@02o`@K00Co9Oo>0ol015GoECL2o`08FomE=eDgocL4o`03c_o>00?o00G>oli[cP03o`04
J_ooJ`?o00=[cV/00ol01F_>Jom[00;o00?>olh00ol015GoE@/2o`033oo>00?o00?>olh00ol01<ko
0?m30000<`03o`<000?o00003`002?nooc3oOSOo15X00olJ6P026P?o00A[Lomc0_l01F]cog=[00Co
00=cJol00ol00g=[o`02o`05Jg=[Lf/00_l017=[Lf/2o`04Lf]cJ`;o00Ac:g<[0ol01IYEV_l[00;o
00=D9Ol00_l01F]cJom[00;o00AcJom[0_l017=[of/3o`03Jom[00?o00=[of/00ol00f_oJ`03o`0A
O_mnEGiEoeEnogko<1/`ooh00ol01EGZENYE00;o00S>FlkojUGZE@?o00A[Lf]c0_l016]cJg<4o`04
HV5RH@?o00?Zog<00ol01G?oLf]c00?o00=cJol00_l01EGZENYE00;o00<TmR@00_l016]cJg<2o`04
Jg=[L`;o00<0o`00@@0003400_lG000AolmKcoo:Z/ZZogj0O_mncGh00_l016_>Jlh2o`04Jli[cP?o
00?>Jlh00ol00li[cP03o`05cV_>olh00ol00lkocP03o`03c_o>00?o00=Eolh00ol01UGocY[>VP;o
00W>ooooc_o>Jlh00ol00li[cP03o`03cV_>00?o00C>Jli[0_l01<i[cV/2o`04cV_>J`;o015ENUEj
omYEfUGoEOmE<UGo6`03o`07EGko=eDgE@02o`05cU_>Flh01Ol00f_oJ`03o`03Jom[00?o00aQJV7o
OVYnocMEoeD2o`04Jli[cPCo00=[c_l00_l01eEZocME=eD00ol01Pooof_oJ`?o00=[of/00ol01F_o
003o0440000^00?o60001?noFkl2o`05=ghgO_l00eX4o`04Jg?oL`;o00A[Lomc0_l016]cog<2o`04
Jg?oL`;o00E[LomcJ`04o`03Lf_o00?o00=cJol00_l015GZENX2o`05<EDaEC401?l01`Koof]cJg<0
1?l00f]co`03o`03Jg?o00?o00A[Lomc0ol00g?oL`03o`03Lomc00?o00YRogYnNWijoeEn0ol017kJ
O]X3o`05HVYRJV801?l01EGoFliK00Go00=[Lol00_l017=[Lf/2o`03O_mn00An00KoHOooENX2o`03
9Om[00?o00=[of/00ol025[oOVYnJ_oZ0_l01W?ooom[L`Co00=[Lol00ol00f]co`02o`030?l00400
000/00;o0P000ol0000E000=olmKcoo?olZZbZ[oOP04o`03Jli[00?o00A[cV_>0_l016_>Jlh2o`04
Jli[cP;o00A[cV_>0ol00li[cP03o`03cV_>00?o00UE=olgECOo3ol015D3o`073oooJlkocP02o`04
JlkocP;o00A[c_o>0_l01F_>oli[00Co00?>Jol00ol00li[o`02o`09OUEnEGkoNUEj00Co0UD03?lb
EC;oEFYEogiEOP;o00EE=eDgE@04o`03Jli[00?o00DgECOoJ`02o`=Z00KoJV5ZHFX2o`03=f[o00;o
00P?oooocV_>J`;o00UnP7j0ofYEJUD01Ol00li[o`02o`03Jli[00?o00=[cV/00ol00f_>o`020003
o`0003h0000Y00?o6P02o`0:_e^ookmK_omn=`?o00=[Lf/01?l017=[of/3o`03Jom[00?o00=[of/0
0ol00f_oJ`03o`03Jom[00?o00=[of/00ol03UGoENYEj_oZolhKc_mE0_l020oooom[Lf]c0_l016]c
Jg<2o`04Jg=[L`;o00A[Lf]c0ol00g=[L`03o`03Lf]c00?o02AnHOmZHVYRJ_mnN_mJoiYnVWkoO][o
OV5nHOmZH_o:onYEjUD2o`039Omc00?o00InonYEjUD2o`07HOmnHGiQo`02OP?o0gh4o`04Jg?oL`?o
00=QoeX015X00omZo`02o`03Lomc00?o00=cog<00ol00g?oL`03o`04LomcJ`Co00<0o`00?P0002L0
0_lK00;o00W>Joo?olmKce/00ol01<i[of/2o`05cV_oJlh01?l00f_>o`03o`03Jlko00;o00C>Jli[
0_l01<i[cV/2o`04cV_>J`;o00UE=eDgocME=eD00_l010mK3e/5o`04cV_oJ`?o00=[of/00ol00f_o
J`03o`03Jom[00?o00=[of/00ol00f_oJ`03o`0BEOmEJUEZoeEnEGkoN_m^EFko15D3o`0=JUEZEOmn
oe0aD?lgE@02o`0;0@ooof5EHEGoECL00_l3JP04ofYZJPGo00YZ=fXgJ_o>oli[0ol02UEZEF[oOX1n
P7h2o`03Jli[00?o00A[cV_>0_l016_>Jlh2o`04Jli[cP?o00?>Jlh00olo00009004oaT00ol017=[
Lf/2o`04_e^oF`;o00AcJg=[0_l017=[Lf/3o`03Jg=[00?o00=[Lf/00ol01F]cJom[00;o00AcJom[
0_l017=[of/2o`07H_oZENYEjP04o`03JolK00Co00EcJom[L`04o`03Jg?o00?o00=[Lol00ol00f]c
o`02o`04Lf]cJ`;o00AcJg=[0_l03WiQOV7oHGiQO_mRJV9Z0_l025YnFWkoOYYn0_l01S7oOV5nH@;o
00K:ELYEoeD5o`07J_mZOVYnJP03o`04HV5RH@Co00EnojYEo`04OP03of]c00?o00UQH_mRHF9QH_l0
15X5o`04Lf_oJ`?o00=[of/00ol00f_oJ`03o`03Jom[00?o00A[o`3o?P0002400ol40003o`0001<0
0ol01F_>Jom[00;o00C>Joo?0_l01<i[of/2o`04cV_oJ`;o00C>Jom[0_l01<i[of/2o`05cV_oJlh0
1?l00f_>o`03o`03Jlko00;o00MEOUEnocME00?o00C>Jli[1?l01<i[cV/3o`03Jli[00?o00=[cV/0
0ol00f_>J`03o`05Jli[of/00_l01<i[of/2o`0=O_mZEFYEoeEZEF[oE@03o`08EOmEKUE^oeD2o`0>
jQCZ5?mEJ_mKoc5@<E04o`09ECiE?_mQEF5E00;o00<gofX00fX00omEJP02o`08OU1nD?lgJSL5o`0D
EFYEoeEZEFYEoh1nP7kocV_oJlh3o`03cV_>00?o00?>Jlh00ol00li[cP03o`04cV_>J`;o00<0o`00
?00001l00_lJ00?o00Ecog=[L`03o`03Lf]c00?o00=cJg<00ol00g=[L`03o`04Lf]cJ`;o00AcJg=[
0_l017=[Lf/3o`03Jg=[00?o00<[Lb/00ol01fYRof9ZHVX00ol01F]cJom[00Co00=cog<00ol00g?o
L`03o`03Lomc00?o00=cog<00ol01G?oLf]c00?o00=cJg<00ol03H1JP?mnHGiQO_mnHGh00_l02GiJ
OU[oFWiJOP03o`Da00SoHOmKc_o:E@?o00YRF_mnJWiZO_mn0_l0269nH_mRHF9Q0ol01f;oEJYEZ_l0
0Wh3o`0=HOooHV5RHOmQHV5Ro`03FP04of]cJ`?o00=[Lol00ol00f]co`03o`03Jg?o00?o00A[Lomc
0ol017?o0?lm00007004oaT00_l016_>Jlh4o`03Jlko00?o00=[c_l00ol00f_>o`03o`04JlkocP?o
00?>olh00ol00lkocP03o`03c_o>00?o00=Eolh00ol03f[oEGiEoeEnEOlToli[cP05o`03cV_o00;o
00A[cV_>0_l016_>Jlh2o`04Jli[cP;o00A[cV_>1?l00f_>o`03o`0>P6[oOUYnF_mEJUEZofX2o`09
D?lbEC9E<_m^00;o00QEH_lDjQCZ50;o00AKcU_>0_l02eGoEEIEE_lnECiE00?o00EZ=fXgo`03JP0:
ohIZQV[oOU1nD0Co01=ZEFYEoeEZEF[oJUEZEOn0O_o>00?o00?>olh00_l016_>olh2o`03Jom[00?o
00Dbof_>J`03o`03Jli[00?o00<0o`00>`0001/00_l30003o`0001@00_l016]cog<2o`04Jg?oL`;o
00A[Lomc0_l016]cog<2o`05Jg?oLf/01?l00g=[o`03o`03Lf_o00;o00A[Lf]c0_l015GZENX2o`0<
HEEQEOmRJV9Zof[o0RD5o`03Lf]c00?o00EcJg?oL`02o`04Jg?oL`;o00A[Lomc0_l016]cog<2o`04
OUGoL`;o011Rof9QHV7oP5Z0F_mQOV5n0_l02EG:EOmnFWiJOP02o`06HVYRJV;o0S43o`03FliK00?o
00/bO_mJHUYRofYnJP02o`09HOmnHWiRO_mQ00;o16800omEo`03o`07O_ooHF9QHP02o`09HF9Qof5R
HF9Q00Co00=[Lf/00ol016]cJg<2o`03Jg=[00;o00@aEC5E1?l00g=[o`03o`03Lf_o00;o?00001/0
0olF00Co00?>Jol00_l016_>Jlh2o`04Jli[cP;o00A[cV_>0_l016_>Jlh3o`03cV_>00?o00?>Jlh0
0ol01Li[c_o>00;o014gocME=om@ogiZOVYnogiEOP02o`039?oo00;o00A[c_o>0_l01F_>oli[00Co
00?>Jol00ol00li[o`02o`03Jli[00?o00CJEMYE0_l04H1ZP?n0JX1ZogiJOU[oEFYE00;o00TaD35@
<OmE<UD00_l01WkoHUERE@?o00?>Jol01Ol02UEnEOmEEUEFoch2o`09JXIZofXgJSMZ00Co00>6JXH0
0ol0151nD7h2o`0?H_mEJUGoEOmEJ_mZEFYE00;o00=E<UD00ol01<i[of/3o`03Jom[00;o00UEoeDb
EOl?olh00ol00lkocP03o`04c_l0oc/0000K0004o`00oa800ol00g=[L`03o`05Lf]cog<00_l016]c
og<2o`04Jg?oL`;o00A[Lomc0_l016]cog<2o`04Jg?oL`;o00E[LomcJ`03o`0AENYEj_oZoeFjof5E
HEEQofX01ol016]cJg<2o`04Jg=[L`?o00=cJg<00ol00g=[L`03o`03EGiE00?o01MjO_mnEGkoO_mR
HF;oHV5RHOn0FX1JP003o`07H_o:ELYEbP04o`0;OVYnofYRJ_lUof/00_l00g;oo`02o`09<WhbOS;o
HUYR00;o00YRof5RHF;oHWiR0ol00gkoo`02o`9R00CoZUFZ0_l01f9nof9QHV400_l01F9Qof5R00;o
00@aEC5E0_l00g=[L`03o`03Lf]c00?o00QZOVYnoeGo9@?o00A[Lf]c0_l016]cJg<4ocX0000K0005
o`000?l03`02o`04JlkocP;o00E[c_o>J`04o`03cV_o00?o00?>Jol00ol00li[o`02o`04Jli[cP;o
00A[cV_>0_l016_>Jlh3o`07ECOo=eDgE@02o`08D7i@ogiZOVX8o`03Jom[00?o00=[of/00ol00f_o
J`03o`03Jom[00?o00EjomYEfP02o`0HEGYEN_oJEOmZO_n0JX1ZofZ0JX3oFWiJ0_l01eEnEGkoD340
0ol03?[oEGiEO_mREOl?Z`Ko00QE?_mnEGiEOPCo00QZHV[oJXIZQPCo00=Z=ol00_l01HIZQVZ600Co
00iZHVYRoeEZEF[oJ_mZE@;o00MEJ_lbEOn;00Co00<bEOl00ol01heZoeEnEGh01?l01Li[c_o>00;o
00=[of/00ol016_o0?lj00004`02o`D000?o00000`000ol0000:00;o00A[Lf]c0_l016]cJg<3o`03
Lf]c00?o00=cJg<00ol00g=[L`03o`04Lf_oJ`?o00=[of/00ol00f_oJ`03o`06EOmEjUGZ1?l02gko
^UFjEOmEHOlU00Go00=[Lol00ol00f]co`03o`03Jg?o00;o00AcJg=[0_l03gYnNWkoOUGoFc7oOWYn
NP02o`=n00coHV5RHOmQHV5RoeX2o`06b_mRJV9Z0ol00f_o<@02<@05ogiZOVX01_l036_o<_mZOVYn
oghbOP;o00=Rof800f801?mQHV42o`03ZUGo00;o00@DOQCo16804?mRH_mROV9nof9QHV7oHF83o`0H
OVYnoeGo3oo>oeDaEOnjoghgOSOoJWiZ0_l01F_oJg=[00?o00=[Lol00_l00g=[L`03o`030?l003P0
000B0004o`00o`@00ol40003o`0000L00_l016_>olh2o`04JlkocP;o00=[of/00ol00f_oJ`03o`03
Jom[00?o00A[of_>1?l00f_>o`03o`03Jlko00;o00ME=eDgEOmE00?o00eZP6Z0oe1nD7koJ_lT00;o
00=[cV/00ol00f_>J`03o`03Jli[00?o00E[cV_oJ`02o`07EOmENUEjE@02o`07<2/`ogYENP02o`0>
JWiZO_n0JX1ZofZ0JX02o`0C<E0aoeEnEOmKolkon[oj_omnE@06o`0HJlkoEGko?UDnEOmEO_n6JXKo
HVYRJ_mZ0ol00gkoo`02o`0F=fXgJ_mZQVZ6ohEZofYRJV;oEFYEJPGo00AEJUEZ0_l05X_o6c0KoeGo
O^[oSFZ=JXgoO_m[cV/4o`03cV_o00;o00=[c_l00ol01V_>ool0ocP0000B0004o`00o`@000?o0000
1@000ol0000300?o00=[Lf/00ol00f]cJ`03o`03Jg?o00?o00=[Lol00_l017=[Lf/2o`04Lf]cJ`?o
00=[Lf/00ol00f]cJ`03o`07JV;ojUGZE@03o`0<FX3oHGiQO_njEKYE0_l01BGoJom[00;o00AcJom[
0_l00g?oL`03o`05LomcJg<00ol0269ZHV[oOWYn0_l01U/aFc7oOP;o00<Jogh00gh05OmRHF9Qof5R
HF;oELYEbUGoJ_mKcP02o`@a2?l03lkoJolbOS9nogiZO_mno`04HP03of9R009R0_l00b_oo`03o`07
H_mn57hDo`03HP0<of9RH_mROV9nH_mQ0ol00cOoNP02o`04O_oocP;o00C>6lhK0_l02KZZ^Z[o=ghg
OP02o`07Loooog?oL`03o`03Lomc00;o00A[Lomc0_l016_o0?lh00004P001?l00?l40003o`0000H0
00?o0?l00_l00li[o`03o`03cV_o00?o00?>Jol00_l00f_>J`03o`05Jli[of/00_l01<i[of/2o`04
cV_oJ`;o00C>Jom[0_l027koEGiEO_lg0_l03WkoOUEnofZ0JX1Zogi@1?l02<koooo>Jli[0_l00li[
cP02o`04Jli[cPCo00UnJ_mEOUEnogX00_l01Q_o:c0[<0;o015nP7koJWiZOV[oJX1ZofZ0JP02o`05
D35@<E000_l02e_>olko_oZoob/T00?o00AK3e/?0_l025EnEGiEoeDn1?l02FZ6JXKoHVYRJP05o`0G
JXEZQOlgJSMZofZ6J_mZQF[oJV9ZHVX00_l01giZO_mnjWh00_l01U_oobCo<0?o00Z6onYnjWkoJXeZ
1?l00f_>J`03o`03Jli[00?o00A[cV_>0_l00f_>J`02o`030?l003H0000B0004o`00o`@00_l600?o
00=[of/00_l017=[of/2o`04Lf_oJ`;o00AcJom[0_l01G=[of]c00Co00=[Lol00ol00f]co`03o`03
Jg?o00;o00R0BX3oHVYRJP;o00f0FX3oP5Z0F_mnHGiQ00?o00<`ool00_l016]cog<3o`03Lomc00;o
00A[Lomc0_l02f7oHEEQEOmRJV9Z00;o1<h4o`075?lJFQYJo`04OP0=of5RHF;oH_mK<?o:E@04o`09
c_o>Flko<Ol?00?o00<`olh00ol01SOoOS9n<PCo00EnHWiRo`03HP03of;o00Go00anogiROV9noaAn
5?l3HP03of9R009R00GoOV9nHP02o`06OSMnocMj1?l00e/`F`02o`AR00So^ZZjZ_lgOP?o00?>ool0
0_l00g=[o`03o`:Z00?oJol00_l00f_oJ`02o`05Lol00?l0=P0001<00_l50003o`0000801?l00f_>
o`03o`03Jlko00;o00C>Jli[0_l01<i[cV/2o`04cV_>J`?o00=[cV/00ol00f_>J`03o`03Jli[00?o
00V0J_mnFWiJogh00_l03WkoOUEnogiEOUGoP6Z00ol01h_oJlkocV/01?l00li[o`03o`03cV_o00;o
00UnJWkoOVYnJWh01?l01A_o6e@K00;o01=SP6>0ogj0OX3oOVYnJ_mZP6Z000;o00=KNe/00ol00lh?
cP02o`04cU_>F`;o00H[og?ocPl2o`07P:Z0Z_mEOP02o`0;JXIZofYRJV;oQVX00ol056YRoomZQF[o
JXEZQF[oJSMZofZ60_l096Z5JXGoHVYRoeEZof[ojWkoD37oFbAKof[oJXIZQ_oZO^YnjP?o00H`6om;
olh3o`06EOo>ELiE0_l00li[cP03o`03cV_o00Co=P0001T000?o00000ol00f]cJ`03o`03Jg=[00?o
00E[Lf_oJ`02o`04Lf_oJ`;o00CZEOm[0_l017=[of/2o`04Lf_oJ`;o00?Zog<00ol02V7oHF9Qoh1:
P4X2o`>Z00koP5Z0oh1JP5[oOV7oL`?o00=cJg<00ol00g=[L`03o`03Lf]c00?o01:0F_mQEF5EoeEQ
EF7ocUC>E<h3o`0<H_mn57hDoaYJ6U[o17h00omQHP03o`07Fooooa_oJ`03o`03JomK00?o00=[ool0
0_l02S3oogkoOSMn=gh3o`AR00GoOV9nHP03o`9R01?oH_mnogiROV;oHWiRO_lDOQCo009R0_l4HP0?
ogiRof5RHOlgog[obUG:00;o00EKof9Ro`05HP04ojZjZP;o00H?olko6lh2o`05EC5E<ED01?l00lko
o`02o`03Jg?o00;o00IcJooo0?le00006@03o`04cV_oJ`;o00C>Jom[0_l01Li[of_>00Co00=[c_l0
0_l015DgECL2o`03cV_>00?o00C>Jli[0_l00eDgE@02o`0LQVZ6J_mZP6[oOUYnF_mEOUEnogiEOUGo
EGiEOPCo00AD9?o>0_l016_>olh2o`03Jom[00?o00iJoeYnF_mnJWiZofYnJP;o00AE6eDK0_l04HEZ
QOmSP6>0ogj0OX3oOVYn00Co00C>V_oo15D2o`04cPo>3`;o00?>9Lh00_l05V_>oolgJSMZojZ0ZX3o
5?n6JXIZofX4o`04QVZ6JP;o0165J_mZQFZ5ohEZQF[oJSMZ=`02o`0=J_mZQFZ5of;oEFYEJP04o`03
D35@00Co00]ZHV[oJXIZQV[oOP03o`8U0_l02D/`oc3o<UDbE@02o`079?ooof_oJ`03o`03Jom[00;o
00G>Jol0o`0d00006@02o`03Jg?o00;o00AcJg=[0_l017=[Lf/3o`03Jg=[00?o00EQEOoZE@02o`03
cQ_o00;o00A[Lomc0ol05N[ojUGoO_mRHF9Qof5RHOn0BX1:o`05ZP08oeZ0F_mJP5X2o`04<?lU9@?o
00=[Lf/00ol00f]co`02o`0EP5Z0F_mJP5[oHEEQEOmEHOlKc_mD00;o00=Rof800V802omn57hDO_mJ
6U[o009n017oH_mEZUGoD?l`6c3ocU_oJ`02o`06Lf_oJom[0ol03V;oOV5nHOlgOSOoKWko1682o`04
HWiRo`=R0_l04WiRO_mnHWiRof9nHWko57hDOP;o00=Rof800f83o`04HV5RH@;o00AnoeG:0ol00f;o
HP02HP03of9R00=R1ol02F[oc_l?R`oo<@05o`03Lf]c00?o00=cJg<00ol017=[Lf/3oc@0000I0009
o`3oof_>Jom[00;o00C>Jom[0_l015Dgof/2o`06P?mZOVYn0_l025/6FomKoli[0ol01CME=eDg00;o
00mZO_n6JXIZofZ0JX3oFWh00_l02EEnEGiEoeEnE@04o`033ooo00?o00?>Jol00ol00eDgE@02o`0A
EGkoOUYnF_mJOUYnofYnJWh00_l00e_fF`02o`0BHFYQohEZQF[oP6>0Hon0OX1n0_l03fYEJ_nJogYn
N_mEoliKcP02o`03cPo>00Go019ZHVYRocMZ=f[oZX3o580DohH4o`06JV9ZH_n60_l056[oJXEZofZ5
JXGoQFZ5JXGo=fXg0_l01F[oJXEZ00;o00YRoeEZEOmZEFYE0_l018IZQVX2o`08HVYRohIZQVX4o`0:
JUEZEF[o<7/`N`Co00=[c_l00ol00c9E<P03o`04JlkocP?o00C>o`3o<`0001T000Ko003oJg<4o`03
Jg?o00;o00CZENYE0_l03c9n<_mEHEEQoa_>6olKcP03o`07HF;oENYEjP02o`=n00goHV5RHF;oHV5R
od[o008a00?oZZX00ZX00omJo`07o`04Lf_oJ`;o00IEonYEjUD2o`<J00goP5Z0F_mJP5Z0oeEQ00?o
00HKooooH_l3HP03of9R009R00Wo57hDO_mJ6UX00_l03V8bHS9Roe1ED5E@oliK0_l00`ooo`04o`9R
00?oHV800V801_mnHGiQOP?o00=nK_l00_l3HP05ogiROV800_l3OP0AogiROV;oHWiRof9nHWiRogh0
0ol04GiRO_mRof9QHV7oHOmZOVYn00?o16800omRo`02HP03of9R009R0_l02C;oOVYnJWkoR`03o`04
EOooL`;o00IEoeDaEC42o`03Jg=[00?o00=[Lf/00ol00`3o000a00006@02o`800_l00cME=`03o`05
=eGoECL00_l02V[oP4B0ofYnJWh2o`0=FomK1_mQohIZQV[oE@02o`0?Q_mnJWkoQVZ6JXKoP6Z000;o
00Oj<_[oOUEn00?o00<?ool01?l00f_>o`02o`0FEMYEf_lgEOmnogiEOUGoFWiJO_mnFPCo01K>Jooo
JWiZO_mQJV7oQFZ5J_n0Hh1S1?l01UGoEFYEJP;o00UnNWijO_mKob@01Ol03f[oJXIZofYRJV9ZofXg
JP02o`0>5?oooaB0ofZ6JXKoHVX2o`0B=fXgJ_mZQFZ5ohEZQF[oJXEZ0ol01V[oJV9ZHP?o00ARJV9Z
0ol05EEZoomZQ_n6JXIZofYRof;oQVZ6o`04E@04oeEZE@?o00=E<UD01?l02C9E<UGoEC;ocP04o`03
cV_o00?o00?>Jol00_lb00006@001ol0003ojUD00_l01V;ojUGZE@;o00eROV;o<WhbO_mQEOl100?o
00o>of9nof9QHV5Rof9QH_l00gh02OmRHF9QH_mRH@02o`@a00KoZZ[o9G<4o`03Jg=[00?o00YnN_mE
OUEnoeGo0YX00olJ6P026P0<oeZ0FX3oP?o>6om[0_l00f;oHP03HP05of9RH_l016805olDOQAnoghj
OS[oHS9Rob_oD5E@EOlU00Go16801OmRHV;o00ER00?oHOl01Ol01Gi^OVko00AR00GoH_mEo`04OP0:
ogiROV;oHWiROPCo00QROV9nof9nHP;o00Enof9QHP02o`04B`Ooo`AR00?oHV800f801OmRof;o00=R
00So<WhbO_mZOP;o00C>oc5E0_l03c5EoeDaEC7o<Oo>og?oL`03o`03Lomc00?o00Aco`3o<@0001P0
00?o00000`02o`06JV9ZH_lg0ol0465ZHF[oP4B0A?mnoj_o3b@2o`0GHFYQohIZQVZ6ohIZQ_mnJWiZ
ofZ6JXH00ol01c7o<_XbnS801Ol01ECo1_m[00;o00YEoeEjEOmEfUGJ0_l03GiFO_mnEGiEoeYnFWh0
0_l00oIKmP02o`0WJXEZofYnJWkoHFYQohEZQF[oP6>0HomnEGiEO_mZo`PaogijO_l700Co011nohIZ
QV[oJXIZQ_mRJV9Z1?l03AB05?lDP1B0ofZ6JXH00_l03c9EocMZ=f[oJXEZQOn5JP03o`0@JWkoHFYQ
J_mZH_mQJV7oHP;o0e/3o`0=JXIZQ_n6JXIZQ_mRJP02o`04QVZ6o`AE00OoEOoocU_>00;o00QE<UDb
EOmE<P?o00?>o`l00ol00f_>J`03o`03Jli[00?o00<0o`001`02o`@00_lP00006003o`<000KoOV9n
HWh2o`0<57koOV9nH_lbOS9n0_l00`7oJ`02o`0:H_mnHWkoHV5RH@;o00ARHF;o17h01?mQHV42o`05
E5EDEOl00S48o`0<cQ_oof9ZH_mjOWYn1?l00f7oVP03VP08oaXJ6_mJP5X2o`06cQ_oof;o0f800omR
HP02HP03of9R009R00ooHV9RoaAn5?l[ocYn>Wh00_l4:`06oeGo9Om[0_l2HP03of9R009R00?oHV80
0V800omRHP03o`0<>T[oOVinogi^OVko0f82o`05EGiEO_l017h00omROP05o`An00OoHWiRO_mR00;o
00=nHWh00_l00g?oB`03o`03H_mR00AR00?oHV800V801OmRHV;o009R00GoO_mn<P04o`03cU_o00;o
00EEoeDaE@04o`03Lf_o00?o00=cJol00ol00g=[o`03o`05<EGo0?l01`001?l00?l20004o`00oal0
000H0003o`0000<001CoHVYRJV;o:X0Zof5ZHF[oP4B0A0Go01R6JXKoHFYQohIZQ_lbohIZQV[oJWiZ
ofX2o`053ola6c401_l01U/UoomK1P;o00UEoeEnEGkoNUD00_l03V9ZHV[oOUInE_mEOUEn0ol08eGo
FomZOV[oJXEZofYnJWiZofYQJ_mZQFZ5of?o:e_oEGiE00;o00D8<@Pa2002o`031ooo00;o00enJWko
QVZ6J_mZQVZ600?o011RJ_mRB_lDP1Co580DP?mZ0ol02S9E<UDbofXgJSL4o`0=JUEZEOmnJWkoHFYQ
JP02o`03V_mQ00?o01M[ooooJlkoJV?oQVZ6J_mZQVZ6of9ZHP02o`03J_mZ00Co00=[c_l00_l01UDb
EC;o<P;o00=Eolh01?l00c;oJ`02o`04EC;oJ`;o00YEoeDbEC9Eo`3o1P001?l00?l20004o`00oal0
000900?o1002o`H000?o00000`001OmnHWiR00;o00in57koOV9nH_lbOS;oL`;o01Enof9QH_mnHWiR
of5RokooHV5RHOl00gh2o`C>0ol017=[ool3cP?o00[>oghbO_mRJV9Z0ol01f;oHV5RHOl019X01?lJ
6QX2o`03jUGZ00;o00EnHWiRo`03HP03of9R00=R00GoHV9Ro`04HP;o00D[1b_o>P02o`03E?l[00<[
0_l01RGooomRo`AR00GoHV9Ro`02HP?o0f803Om:>T[oOVinK_m^OVh00_l02GkoO_mEOUEno`03OP;o
00QRHOmQHV5Ro`An00?oOV800_l00i[oo`05o`05<EGoJol00f800omRHP02HP03of9R009R00CoHV9R
0_l00f;oOP02o`0:JoooogiZO_mE<@?o00<aEC400ol0135E<ED2o`04<EDaE@;o00PaEC7o<EDaE@?o
00<0o`001003o`<000Co003o7`0000X000?o00000P001?l00?l500;o10001OmRJV9Z00;o02HZP2[o
HFYQJ_n0A?m[ogiZO_n6JXKoHFYQJ_mZoa/bohIZQV[oJPCo00<?Fol00_l02<h?c_mK3olU0_l02e_o
ogiEOUEnogiE00;o0fX02_mRJV9ZH_mFOUH4o`0MEOmE=omnogiZOV[oJXEZofYnJWiZofYQJ_mZQFX0
0_l012]K:e/2o`04EOMEm`Co010>ooo>ofYnogiZOV[oJXIZ0ol04VZ6of9ZH_m:HT[o580DP?n050;o
00UZojXboeDbEC801?l03UEZEF[oJUEZEOmnJWiZ1_l02J[>ogkoEGiEOP02o`0CJV=ZHon6JXIZofZ6
JXKoHVYRJP02o`03EOoo00;o00EZoeEZE@04o`05<UGoEC800_l011_oEC82o`042omE<P;o00IKoeDb
EC85o`04c_l0o`D000?o00000`001?l00?lO00002P000ol000020004o`00o`D000?o00000`005?mn
HWko<_mn57koOV9nH_lboc;o17h04omRHF;oOV9nH_mQoc:o<_mQHV400_l015GZENX2o`06Jg=[of_o
0lh2o`0:cQ_o<_lbOS9n<P?o00aRof9QH_mRHF9QH_l2VP;o00Gj<OXanP02o`08HWkoOV9nH_l4HP03
of9R009R00CoHV9R1?l00f_o1`03o`05V_mD<E@00ol015Coog<2o`=R00?oHV800V84o`03H_mR009R
00goHV;o>TXjB_mnKWi^00?o00Unoomn=gkoEGh00ol3HP0:of5RHOmQHV5Ro`9n1Ol00jXgZP02o`09
EE1EoeDaof;o00AR00?oHV800V800omRHP02HP03of9R009R1?l03giQOV7oJWko^_mE<EDaE@02o`04
FliKcP;o00AE<EDa0_l01/iKcU_oE@?o00E[oe_>F`04o`D00ol300;o800000X000?o00000P001?l0
0?l40003o`0000@000ooHVYRo`So:X0ZP?mZHFX00_l04;mKofYnJWkoQVZ6J_mZHFX2o`07<Q/b6omZ
QP02o`09ECME=oo>o`o>00?o00=Kool00ol02E_oEGiEoeEnE@02o`04QFZ5o`=Z00KoHVYRJV83o`06
EOlaEC5E0_l057iZO_mnJWiZO_n5JXGoOVYnJ_mZ1?l00`o>o`02o`05cY[>V/h00ol00`o>o`04o`08
B_mnJWkoOVX3o`0CJXIZQ_n6JXKoHV[oHTYRB_lDP003o`09<UGoojXbZS:Z00;o00h?ohEZQF[oJUEZ
EOmEJPSo029njWkZogiFOUKoO_mRJ_mZHfYSohIZQV[oJXIZQ_mRJV9Z1?l03EEZEF[oEOmnjWkoEC80
1?l00a/`o`02o`04<0/`2`;o00C>FliK0ol01/i[oomKcP;o00D?ool0o`0/00002P000ol000020004
o`00o`@00_l6000=of;oD39@oaAn5?mROP02o`04<POoo`An00SoHV5RHOmROP;o00hb_c:o<_mQolhK
oeGZo`8U0ol00f]co`02o`03Lf]c00;o00XbOS9noghbogko0f804OmRHF;oHV5RHF;oOYYnV_la00;o
00aRogiRO_mnHWiRO_l3HP04of9RHP?o00?j:oX00ol01lhboeFJEIX00ol00e_oo`02o`A:00CoHV9R
0ol2HP03of9R009R00?oHV800V83o`04>TXjBP?o00=Zool00_l02EGo=ghgOSOoL`02o`AR00GoHF9Q
HP03o`9J00?obUD00_l02ZXgZSNZoe1ED5D2o`=R00?oHV800V800omRHP02HP03of9R009R00?oHV80
0V802?mQO_mnHGiQ0_l4^P?o0e@3o`0:<EGo<EDaoa_oF`?o00=[of/00_l00g?ocP04o`04Jol0ob`0
000900;o1@02o`D000?o00001@009_mZo`L81on0:X3oJ_lToe_o2omZOVYnohIZQV[oJ_mKoa/b6c8K
0_l01@IK1_lg00Co00?>olh00_l01<hTolh2o`0@O_mnEGiEoeGoJV;oQFZ5o`AZ00KoJV9ZH_l4E@;o
01=QJV7oOVYnogiZOVYnohEZQOmn00;o00=Kolh00ol00lkoE@03E@06oi[oolh?1?l01V;oHTYRBPGo
00inJWiZofZ6JXKoQVZ6JP;o00LjodYRB_ln00?o00UnJWiZojXbZS800ol02LkoQFZ5J_mZE@03o`0=
O_nSoe0aoeGojWkZOP02o`0[OUInof[oJV9ZofYSJV=ZofZ6J_mZQVZ6J_mZHV[oJSMZofYEoc;ojWkZ
OP02o`0?L_oooc;o<UDbEOl;oa/`00;o00?>Jlh00ol00li[o`03o`03cV_>00?o00<0o`00:P0001L0
00?o00001@02o`08<U0bD?lDOQ@2o`079Ol7<_lbo`04OP05of9QHV400_l01Q_>6ono<P?o00?>6lh0
1Ol00g=[o`03o`8U0ol026YRJ_lbOS9n0_l017iRO_l3HP09of9QHV7oHF9Q00;o01AnV_ooH_mROV;o
OV9nH_mROV9no`=R0_l3cP;o1LX00oo><P03o`06Loooolko0dX00om:BP03o`AR00GoHV9Ro`04HP04
of9RHP;o00DjB_m:>P03o`9J00WoHEEQEOlgOSL00_l0139n<_l4HP?o00@gOSMn0ol03UGo<V8bocNZ
oklaoeGo0V800omRHP02HP03of9R009R00GoHV9Ro`05HP08of9RogiQOV43o`03=c7o00>j00coj_oo
<EDaEC7o<ED3o`046lkoF`Co00=[Lol00_l00g?o6`04o`03Jg?o00;o:`0001L000?o00001@02o`06
20L81on01_l03Koo50/DogiZO_n6JXH00_l00e/6F`04o`033lko00Co00?>3lh00ol00`ooo`03o`09
EGkoOUEnEOmE00;o00]nof9ZH_n5JXEZo`03JP06ofYRokmK0_l04f5ZHOmQJV7oOVYnJ_mZOVYnohD0
0ol02PmK3ol`oc;></h4o`07o/koo`mK3`02o`03HTYR00?o011RB_mnJWiZofYnJWkoQVZ61?l09F8j
HS[oB_nSohenSGkoJWiZO_lboeCocS;>ohEZQF[oj_mZOVX00_l03F[ooeEnEGkoO_lb2c800_l06FYR
J_mZHVYRof=ZHf[oJXIZQ_n6JXIZofX00_l013MZ=fX2o`0?<^XbonYnoeGoFomE<UDb00Co00YKE?l`
od_oEOm[0ol00f_oJ`03o`03Jom[00?o00A[o`3o:P0001L00_l60005oe0bD3801Ol00f]cJ`02o`05
<S4b<Ol00gh4o`03Loo>00;o00A[Lomc1?l012EDog<2o`03Jg?o00?o00XgofYRJ_mZHVYR0_l3OP05
ogiRO_l016802OmQHV7oHOlK1`02o`0AOV9nH_mROV;oOV9nH_mROV800ol02g<[Loo>oc7j<Oo:00;o
00A[LolK0_l015GZolh3o`04B_ooo`A:00?oHV800V800omRHP02HP03of;o00;o00M:>_ljBSY:00;o
0UX00omJFP02FP05oeEQEF401?l01GhbOS;o00=R00SoOS7o=gkoOP;o00Inof8bHS82o`03_c6o00;o
16800omRHP02HP03of9R009R00?oHV800V800omRHP02HP;o00DaogiQOP02o`07=olg<COo^P02o`05
FliKoeD00_l01G?o3e@?00?o00AKoc7>0_l00g=[L`04o`03Jg?o00;o00=cJg<01OlY00005P000ol0
0007000:o`SoolkoF`Ko3`;o00QEo`/D2aCoOPCo00?>3ol00ol00lh?o`05o`03cPoo00?o00?>ool0
0_l02e[ZF_mnEGiEoeEn00;o00iZOVYnof9ZH_n5JXEZo`=Z0_l04[mKof[oJV5ZHOmQJV5ZofYnJPCo
00D;oc_>>`03o`04<5D`E@;o00<?cPl00ol013ME=eD2o`0D2oooodYRof9:HT[oOVYnJ_mZOVX3o`09
J_mR>V;oHSYR00;o00bSOZ?oSGj=O_mZOVX3o`0>FolbcS;><_mZonXbjS84o`06EGiEoeEn0_l07C7o
2c;oH_mRJV9ZofYRJV;oHfYSJ_mZQVZ6ohIZ00?o00<bJS800ol01f[ojS;o<^X00ol00e_>F`03o`03
cV_>00Co00Q[c_ooEA_o3`Go00?>Jol00_l00f_>o`03o`05Jlko0?l0:@0001H000?o00002002o`05
JolKcQ/00_l01nYEj_lb<C800ol00g=[L`03o`03Lf]c00?o00G>oolKE003o`03Lf]c00Go00UE=eDg
EOmRJV800ol00f7oOP03OP06ogiROV;o0f800omQo`03o`0A1omnO_mnHWiRof9nHWkoHWh00_l0135E
<ED4o`05EC7onS400_l00f_oo`02o`05EC7oENX01Ol00n[oBP02BP03odY:00=:00KoHV9Rof82o`AR
00Co>TXj1Ol4FP03oeYJ00=J0ol00f_o1`02o`05OS9n<Wh00ol00c5no`04o`05<WhbOS800_l01<YE
bUD2o`9R00?oHV800f801OmRHV;o00AR00?oHV800V84o`04EC5E<@;o00QnHWiRoc7o<@;o00<aool0
0_l016]cog<2o`03Jom[00?o00?>olh01?l00g?oL`03o`03Lomc00;o00E[of]cJ`03o`030?l002L0
000F00;o2`000omK1P02o`06<OmE=eDg0ol013MEolh2o`043lkocP;o00H?c_oo<ED2o`03c_l?00Ko
00UnonYJjU[ZoeD00ol04FYmJ_mZOVYnof9ZHV[oJXEZ00;o00?:ELX00_l066YnJ_mZHFYQJ_mZHF[o
J_mKoeD;EOlKo`EE0_l01G;ooeGo00EE1Ol04A_o<_mRBV;oHTYRBV;oJWiZ00;o00QRocMZ=f[oHP?o
00enXgjSoj=nXgkoOXen00;o00/?c_mKoc;o</hbcP08o`0=NU[oOUEnEGkoD35@<@02o`0IHVYRof9Z
HVYRof9ZH_mSJV=ZofZ6J_mnP002o`0<<V[oof[oJV5ZHOlb0_l025Dboe3oJli[0ol00f_>o`02o`03
F`mK00Go00?>Jol00_l00f_>J`03o`03Jlko00Co00K>oooo0?lW00005P000ol0000:0009olkobUG:
EOmE00?o00AEjUGZ0ol00g=[o`03o`07Looo6olKo`029@Co00ADo`oo0jX01?lgECL3o`07OQCoHF9Q
o`04OP06ogiROV;o0V82o`06EGiEoj[o0gh02_mnHWiRO_mnHWh2o`0<6lhKoeGocU_>oc5E1Ol01eEn
EGko<ED00ol02<iKokoo<^[o0dX00om:BP03BP05of9RH_l00V801?mRHV83o`03BQ[o00AJ00?oFUX0
0UX03omJoomKof_o1omE<EGo<P07o`0:H_lgQCN5oghbOP;o00IEbUGoH_l3HP03of9R00=R00GoHV9R
o`05HP08of;oFQ[oOS82o`=R00WoOV9nHWkoSWh00_l00kYE^P03o`03Lf_o00;o00=[Lol01Ol00eDa
o`02o`03<EGo00?o00=cJol00_l00f]co`03o`05EC7o0?l09`0001H000?o00002`001Om@<E0a00?o
00UE=olgECOo3b@00ol00lh?cP02o`03E5]D00Go00<?cPl01?l01WiEOUGoFP;o02YZoh0JP?mZOF[o
JWiZO_mRJV9Zof[oFomEb_nJO_mZOV[oJV5ZHF[oJV42o`04FoIKmP;o00@K1Q/60ol02EGooeGoELYE
bP04o`0JcPooc_l;ocLbof9:HT[oBV9:H_mZO_mRJV86o`0=OX1nogjSOZ?oXgjSOP02o`03cU_>00;o
00=Koc800c86o`0XJXIZQ_mJNUYjoeEnoeGoD37oJV;oHVYRof9ZHVYRof9ZHV[oJV=ZH`;o00EnP7ko
E@02o`0=OVYnJ_mZHFYQJ_mZE@02o`05<E0aolh00ol00lkocP04o`0>c_lbEC;oc_lbEOl?olh3o`03
c_o>00;o00IZoc9E<UD2o`030?l002D0000F00?o2`003omEbUGo6omEjUGZon[oJ`02o`04Jg?oL`;o
00=[oa/01?l01>YEof/4o`03S_nZ00BZ00koHV9RoaAn5?mQHV5Ro`=n00GoOV9nHP02o`=K0_l01:ZJ
Z_l4OP05of9nHWh00ol017=[oa/2o`043c_ocP;o00Uco`oo<S4boeD01Ol00g=[L`03o`07<OoZ<^Xb
o`03BP03odY:009:00CoH_oo0V82o`0:HEGo<OlJBQY:o`=J00CoFUYJ0_l01LiKc_o>00;o00EE<EDa
E@03o`9R00?oHV800V802olgQCN5ogkoZ[ZZ00;o0f800omRHP02HP03of9R009R00?oHV800V800omR
HP02HP;o00<JFQX00_l00f;oHP04HP08of9nH_mnSWh2o`03^UGo00;o00=[Lf/00ol036_ooliKc_la
oliKcP;o00OnooooJg=[00?o00UnJWiZoc5Eooh01?lU00005@02o`h000Wo<OmK1U_oECL01Ol00`o>
3`03o`033lko00Co00AE=eDg1?l07FYEJ_mnEGiEO_mZHV[oP1Z0ofYmJWgoOVYnof9Z00?o00=K<?l0
0_l03IYnVWkoJWiZO_mQJV400_l00lh?cP03o`03cU3>00?o00?>3ol00_l015IEEUD5o`036ooo00;o
018gEOlKoc8g<SOoBV9:odYRBV82o`086_mRoe3oO_l2<P0:ogj0OX3oXgjSOP?o00W>3_o>olkoP?l0
1C82o`0=JXIZofZ6JXIZogYJNP02o`0MEGiEO_mZHVYRof9ZHV[oJV9ZH_mRJV9ZofYSJV<00_l04gj0
oomZH_mnJWiZO_mQJV7oEFX00_l01E3ooli[00Co00?>Jol00_l01<iKcU/2o`03cU_>00Co00=EJUD0
0ol02EEZofYEJUGoE@03o`04c_l0obD0000600Co0`02o`H000?o00003P001OlKcQ_>00?o00AcoolU
1?l00nYEjP02o`08Jg?oc_oZENX3o`066_n>OXko1:X2o`=R00[o57hDO_mRHF;o0Wh4o`03VUGo00;o
0UX01onJZYZZV_l00gh01OmRool?00Co00=ZHVX00ol00fYRJP02o`04FWko<@Go00YD2eCoEOmEjUGZ
0_l01S;Z<^Xbo`=:00CoBTY:0_l01QXjoomE^P;o00TaEC5EodXJB_l00UX3o`=[0ol03<ko=c4goc5E
<OmJo`=R00?oHV800f84o`07O_njZ[ZZo`04HP03of9R009R00?oHV800V800omRHP02HP0>of9RH_lJ
oaYJof9nH_l5HP09of9nohino`4U00Go00AcJom[0ol00f_oF`03o`03JomK00?o011EogiZOV[oJWiZ
O_mnJWiZ0ol00g=[o`02o`030?l002<000070003o`00008000Co003o1@000ol0000?0009oe_oo`oo
3ol?00;o011EoeDgECOoc_l?o`IK1_lg0_l06WiEO_mZEFYEoeEnogkoJV9Zoh0JP1[oOFYm0ol05I[o
V/jJoh3oSGj=oiYnVWjJogiZOP02o`0C9?ooO_mnEGiEO_mnEGiEO_mZE@03o`0=EOoo=eGo6olaD37o
E@02o`0FEOlg<SLb=om:HT[oBV;oHQYR6_m@OP;o1C800on0OP04o`036eGo00?o00UEc_ooP>Z0j_l0
0S805_mJH_mZQVZ6ohIZQV[oJWiZO_mEOUD2o`0KJV9ZHV[oJV9ZofYRJV;oHVYRJ_mZHf[oO_mn00;o
00aRJV9ZofYnJWkoHFX3o`039Ooo00?o00?>Jlh01?l00f_>o`02o`03cV_>00?o017>oc5@ofYEJ_mK
ofYEJUGoE@02o`03Jooo00;o0UD2o`030?l0028000080005o`000?l00P000ol0000300;o4@000om[
L`05o`09jUGZEOmEj_lU00?o00C>6lhK0_l047ko6UXJohinSWkoZ_nZ<_l4HP07oghDO_mRH@02o`0:
VUFJEOmEoghgo`AJ00OoZYZZV_mn00Go00iZHVYRof9ZH_l7of9ZHPCo00QnF_oojS7Z<@;o00AEbUG:
0_l3FP07oc;Z<^Xbo`03BP0Ood[ooaXj6S[o^_laoeDaEC5Eod[oc_mE<EGoZbCo3`02o`0=EOla=c4g
oc7oFTYJo`04HP03of9R009R00_oHGiQO_njZ_lJo`05HP05of9RH_l016800omRHP02HP07of9RH_lJ
FP03o`05HWiRO_l016800omROP04o`03EOm[00Oo00IKooooJg<4o`0BJg?ooeFjEK[oJ_mK1omnJWiZ
1Ol02S5Eoc5Eolko0?lS00002@001?l00?l20003o`0000<000?o00004@02o`0;3lkoFomE=eDgocL0
0ol01@o>3ol600?o00]nJ_mnEGiEoeEZE@02o`0<OU1nofYRJV;o6X0J0ol01H1EoljJ00?o00b0JX3o
SGj=O_mnVWh3o`0AcPooD?mnEGiEoeEnoc5KoeD00ol00e_oE@02o`04m_lgE@;o01G>oe0aD?mEoeEn
EOlg<SLb=om:HTX00_l01F[oHQYR00?o00?ZP?l01C82o`086`HKoeGo3bD3o`08<UDboh3ZP>X3o`0<
HUYRF_n6JXKoQVZ60_l096YnJWiZogkoO_mZHVYRJ_mZHV[oJV9ZH_mRJV9ZofYSoh1nP0?o00YRJV9Z
ofYnJWiZ0_l01EEZoeDb00;o00?>Jol00_l01/koo`oocP;o00<bof/00ol01S;oD35@<@;o0e/00omZ
E@03o`07EOmE<UDbE@02o`06E5_oo`3o8P0000H000Co003o0P001?l00?l50003o`00018000WoJolK
cQ_oENX01?l011_oJg<3o`03Lomn009n00Oo6UXJF_mn00?o00FZ<ZXbo`04HP03oghD00;o00DbHS9R
<P02o`07EF7o=ghgo`04FP0EojZJoa_>og?obUGoJV9ZH_mRo`MK00Co00<7F`L00_l011_>6lh2o`0:
FliKoeG:okZZo`AJ00OojS;Z<_m:00?o0V800olJ>P03o`08<CLa=olaEC42o`04cU_>F`Go00ME<OmE
OUEn00Co0V801_mJBUY:o`=R00_oHV9Roc;oOV5nH@02o`04FQYJo`AR00GoHV9Ro`04HP03of9R009R
00GoHV;oFP03o`07H_mROV9no`05HP;o00=noo@00ol00f]co`04o`03D2Go00;o00=E<ED00_l01c5E
<EDaokX00ol00e/7F`05o`08<EDaoc5E<ED2o`04cQ_ooPCo8@0000L00_l400;o1@000ol0o`0D00;o
00<6Fol00ol01@o>oe/600?o00dgEOooOVYnJ_mnEGiE00;o01EnF_m@OU1nofYRJV;o6_m@oh1EP5D0
0_l03GiZO_n0JX1Zogj=OXd00_l00e_fF`02o`08D35@<OmEOUD5o`06Fooo<E/a0_l015_fFoH2o`05
FliKcU/00_l035EnEOmEOUEnoc8g<PCo00iSJV=Zof8Jof;oP>Z0jPCo00?=o`H01?l02A_oEFYEJUGo
E@04o`0a=fXgJ_mRFV9JohIZQ_n6JXKoj_mnJWiZoghcOS?oHVYRJ_mZHV[oJV9ZHV[oJV9ZHP05o`0A
HVYRJ_mZHV[oJWiZOV[oJUD01ol00f_oo`04o`0<EC;o<UGoFomE<UDb0ol00f_>o`03o`09c_oo<OmE
<UDb00Co00?>oe/00ol015Go0?lQ00005002oaL00_l01f]cJom[oa/00_l01eGojUGoO_l01Gh00omJ
6P02o`09FX1JojXbZS;o00AR0_l04/YEoc9R<_laof5EHOlgOSMno`=J0_l02Q_>oolboeG:ELX6o`07
Foooof_oF`02o`04Lf_o6`;o00EEO_mKcP03o`05^ZZjZ_l015X4o`=R00?oHV800V802?lJof9ZH_lg
1?l00e@?o`03o`09c_o>FomE<EDa00Co00=RO_l016801_mJBUY:o`=R017oHV;o<C;oOV5nHOlJFQYJ
o`04HP05of9RH_l01F800omRHP02HP;o0V800omRHP02HP05ogiRO_l01F800on>o`03o`03Jg?o00;o
00Ucolko<EDaEC400_l00e_>F`04o`03Lomc00?o00[>olko^UFjEOmE0ol00c/?>`04o`07EWiFO_l0
o`0P000050000ol0000G0003o`o>00?o00IKonYJjUX2o`0IJWkoOVYnJWkoEOm:oeYnF_m@OU1nofYR
JP02o`0BD35@<OmEooXbogiZOV[oJX1Z1?l02Poom_mnEGiEoc45o`03c_oo00;o00<?c_l00ol00`o>
o`02o`04EJYEZP?o01iEJ_mnEGiEO_mnEGkoH_mZHfYSof=ZHf[oH_mEHUD2o`033lh?00?o00<?cPl0
0_l011/`6c04o`05JUEZofX00_l05cMZ=f[oHUYRF_n6JXKoQV[o<^[oOVYn00;o01Qn<ghcof9ZHV[o
JV9ZH_mRJV9ZofYRJV82o`0GJV;oHVYRJ_mZHVYRogiZO_mEJ_o>olh00_l02V_oJoo>Flko<UD3o`03
Flko00;o00=[cV/00ol016_ocU/2o`04D35@<@?o0UD5o`06NUGoEEIE0ol00`3o000N000050000ol0
000H00;o00Y[Looo=eDgECOo0gh00omnOP03OP;o00an=omJP5[oZS:Z<_l2HP07oa_oELYEbP02o`@a
00KoEF5Eogh3o`04Lf]cJ`;o00En<WhbOP08o`04HGiQOP;o00AQOV5n0_l04f5noeEnEOnZogiQO_nj
Z[ZZ^_l00UX01?m:F_l4HP03of9R009R0_l00fYRJP02o`07Loooog?oL`03o`043omKcP?o0V801OmQ
HV5R00?o16801_mJBUY:o`AR0_l03S8a<_mnHOmnoaYJ6U[o16800omRHP02HP03of9R009R00?oHV80
0ol4HP0:of9RH_mnHWiRo`=R00CoO_m[0ol00f]co`02o`03cU_o00Co00<gOCL00_l00g=[o`03o`0;
Lf_ooliKoe_oEKX00_l015_o<ED2o`09EOmnJWiZoeIn00;o00@Uo`3o7`0001@00_lI000:olkooe[o
F^YJjP;o01mnJWkoOVYnJWkoBZY:oeYnFWkoOU1nof[oF`KoD35@00;o00Sj<_Xbn_mZOP?o00D?cPoo
3`02o`06J_mEOUEn0ol0=0ooof[oJUEZEF[oJUEZEF[oJUEZoeFZogkZofYEJ_mnEGiEO_mnof9:H_mZ
HfYSof=ZHfX2o`04HUGoF`;o00@?cPo>0_l01<eKcE/4o`08QVZ6J_mZEFX3o`0?<_mZ=f[oHUYRF_n6
JXIZ00;o00CZ<^Xb0_l05GiZoghcOS?oHVYRJ_mZHVYRof9ZHP04o`0DH_mZHVYRJ_mZHV[oJV9ZH_mn
JWh4o`03cV_o00;o00=[c_l00_l02VYnoomZ=fXgof/2o`04cV_oJ`;o00O>oe_oFliK00;o00C>FliK
0ol0235@ogYENUEj0ol01W?oool0oah0000D0003o`0001T000_oBX1:P?mE=olgo`03OP03ogin00=n
00go=ghgO_n0FX3o<ZXb00;o00@KcQ_>0ol00eGo<@04<@?o00EcJom[L`03o`04EF5EH@Go0S402Omn
HGkoOV5nH@02o`04OV5nH@;o00AnHGiQ0_l03JXgZ_mnHGiQojZjZ[X00ol015Y:F_l4HP03of9R009R
00KoJ_ooFol29@08og?ooeGZo`l2o`04OV9no`AR1?l01F;o_l[o00AR00GoBUY:o`04HP;o00hb<C8a
ogiROV;oFQYJo`ER00CoHV9R1_l015Y:F_l5HP0:of9RH_mnHWiRo`9R0ol01g?ooolaog<00_l00f;o
HP03HP;o00PgOOlDog=[L`?o00=cJol00_l00e_>o`02o`03cU_>00Co00QE^UFjofYnJPGo00=cool0
0olM000050000ol0000I000CoeYnFWkoj_nZB_mnJWiZofYnJP02o`0:BZY:Z_mnFWkoOPCo00<6Fol0
0_l01fYnJWko<_X01?l00`o>o`03o`05OF[oJWh00ol0:7iEooXbn_mZEF[oJUEZoe_oJUEZoe_oJUEZ
EOmnjWkZO_mEJUGoEGh3o`0>:_mRBV9:of=ZHomSJV<4o`04Fol?9@?o00@gECME0ol03fYRJV;oQVZ6
J_mZofYno`02<P0=ofXgJSOoFV9JH_mZQP02o`0G<^XbjS;oJWiZO_lcOS?oHVYRJV;oHVX00_l06QYn
of[oHTYRB_mRJV9ZofYRJ_mZHVYRogiZ1?l0139E<UD2o`0:HVYRogiZOV[oJP;o00=nJ_l00ol00f_>
o`02o`03cV_o00;o00=[c_l01?l01eDboe0aD3401Ol00e_oo`02o`05EUGo0?l02002o`@00_l=0000
4`03oaX000_oBX1:P4[o=ghgo`04OP0<oginoc7o=ghgO_n01?l00f]cJ`03o`08HEGoEF5EHED2o`03
Jg=[00?o00IRHOmQHV43o`05EF7o<_l00c42o`0COV5nHOmQo`L81omQo`L81omQOP02o`08=jXgZSOo
HGh4o`AR00KoFTYJB_l3HP07of9RH_m[L`05o`05OV[oENX00_l025Y:of9nHWko16802OmnO_mRoko:
o`04HP0>odYJBU[oH_mEoc4b<C82o`0:OV9nH_mJ6UXJo`AR00CoH_oo0UX02OmRH_mJBUY:o`04HP0;
of9RH_mnHWiRof800_l01FYnoeDa00;o00=Rof800V800omRHP02HP06oggooghD0_l01f_ooom[of/0
0_l00g?oL`03o`093olaEC5E<Onj00Co00i[oa_oEOmnEWiFO_l0o`H000Co003o0P001?l00?l<0000
4`000ol0000J000HoeYnFWiJodZZBZ[oJWiZof[o2c8;ojY:0ol01CME=ol?00;o00YZofYnJ_mZOVYn
0_l02LkooomRofYmJP05o`04JWiZOP;o023j<_[oFomZEFYEoeGo<U/boeGo<U/boeGo<5_ojWkZOP?o
01IR:V;oHRYR:_mRBV9:of=ZHomSJ_o>0_l025YRF_lnECiE0ol0469:H_mZHVYRohIZQ_lDJQ@2o`<b
00[oJSMZ=omJHUYR0_l05eGZoc;Z<_mnofYnJWko<ghcO_mZHVYR00?o01XJOQ[oOV[oHTYRB_mRJV9Z
ofYRJV;oHVYRJP;o00AZEFYE0_l03F9ZH_mRJV;oOVYnJWh00ol00gkoo`02o`03cV_>00?o00?>Jol0
0_l027?oFa]Koc9E1?l00f_>o`02o`09FolaD37oEEIE00;o00<0o`001@001?l00?l20004o`00o``0
000C0003o`0001X000GoBX1:P002o`05=ghgO_l00gh2o`04<Kla_`?o00IEonYEjUD2o`0?EF5EoeEQ
EOmEHEGo1e_o00A:00?oHF800_l01V5RHF;oH@;o00c>oc4ao`Lb1omQOV42o`0420L81`;o00@81`P7
0_l3J`03ojXg00?o00<jof800V800omRHP02HP06oeY:FT[o0f800omRHP02o`E:00CoJWiZ0_l02dCo
BUY:of9nHWko00=R00CoOWin0_l01<Zob_l4HP04odYJBP;o01AE=eGo<C;o<U3oOV9nH_mJ6UXJo`9R
1Ol2FP0:of9RH_mJBUY:o`AR00?oHV800V801OmROV9n00;o00=nJWh00_l01GiROV;o00AR00?oHV80
0V800omn5002o`03Jooo00?o00=[ool00_l02:YnZ_l?<0l`0ol00f_oF`03o`0=<EGooeFjEK[oEWko
cP04o`H00_l30004o`00o``0000C00?o6`003?mnF_lbodZZBZ[oJP?o00@;<P/b0_l01VYnJ_mE=`;o
01EnofYnJ_mZOVYnogko<E/aoh1RP6800ol01V[oJWeZO@;o00AKmU_f0_l01U/8F`SoE@Co00=K<_l0
0ol00e/bo`02o`04<5/`F`Co01hjHS[oHRYRof8ZHR[oHTYRB_mSJV?oHomJoeYRFV83o`0FEOmZ<V[o
HTYRB_mRJV;oQV[oJQAZ50;o0c807_mZ=fXgoeYRoe_ojUGZEOoZoeInofYnJWko<ghcOPCo01aRJV;o
6WkoJWiZO_m:HT[oHVYRJ_mZHVYRof9Z0ol067koEOmZofYRJV;oHVYRJ_mZOVYnogiZOP;o00?>Jol0
0ol01UEjojYEZP;o00`KooooEOo>oe_oFol2E@0=of?oD35@<OmEoe/?F`02o`030?l000<000Co003o
0P001?l00?l<00004`000ol0000K0009oh3o_c6ooghg00?o00eEj_no<KooO_mEHEEQ00;o0jX02OmE
HEEQof5EH@02o`031e/700;o00=:ool00_l03F5RHOmQHV5Roa_>6lh00_l010Lb1c83o`03Lf]c00?o
00=cJg<00ol017=[of/3o`=R00Go>SXjo`03HP03of9R009R00KoFTYJB_l3HP05of;oB_l014X4o`0A
OTAnA?m:FTYJogiROV;oH_l017h01_nob[o:o`AR00[oB_mK<?mE=eDg0_l0650bD?mnHWiRoeXJFQ[o
H_mnHWiRO_mJo`AR00GoBUY:o`04HP03of9R009R0ol019YFVUH2o`09HWkoOV9nHWko00=R00CoHV9R
0_l01GhDO_m[00;o015QofYnJWkoOZ[o=c7oEC5E<@02o`05FomKcU/00_l01WhbO_njE@?o00?>Jol0
1Ol500;o1002o`d0000400?o1002o`H000?o00006`02o`04<_XbnP?o01eZoeDgECOo<_mnEOmZOVYn
oeEnEGkoJWiZO_mnJP02o`03<E/a00Co00aRP6;oJWeZOOmmJWd2o`07FoooOF[oF`02o`033ol?00?o
00<?o`l00ol012_o3lh3o`0LH_mZA6Y4ocYR>_mR:V;oHRYR:_mRBV9:of=ZH`;o00MRF_mJHUYR00Co
00hbJS9Zof9:HT[oHVYRJP?o00EZ56XDo`04<P05ofXgJSL00_l01U/TFbCoE@?o01IFOUInofYnJWiZ
oghcohIZofYRJV9Z0ol04FYnJWkoBV9:of9ZHVYRof9Z00Co01JJOYYnofYRJ_mZHVYRJ_mZHV[oJWiZ
0_l00giZOP02o`09JX1ZP?mjEGYE00;o00HbjS;o<UD2o`06o_ooFliK0_l016=EHeD3o`03cU3o00Co
0UD3oaT000070004o`00o`8000?o00000P000ol0000L0005okla_c400_l01eEQEF7oENX00ol01ghb
O_mEHED00_l5ZP04of5EH@?o00=Ej_l00ol00gkoBP03BP0Dof5RHF;oHV7o=gkoHV5RHF;oJg<4o`03
Jg?o00;o00AEjUGZ1?l3>P03of9R009R00Go>SXjo`03HP03of9R009R00KoFTYJB_l3HP;o0TX00om:
BP02BPCo00inA7i4O_mJBU[oOV9nHP?o17h01onob[o:_ol00V82o`03Fc1K00Co0UX03_lbD39@<_mR
OV9noa[o16801OmROV9n00?o16801Om:FT[o00ER01KoH_mRogkoVUJJE_mnHWiRof9nHWko0f802?mR
HV;o<_lD1?l01cMQ=omnJWh00_l01CLa=oon00Go00>Zolh00_l023Oo<WhbO_l?1?l017kojSL2o`04
Fol0oaP000070004o`00o`8000?o00000P03oa`000conS;jogkoJWiZOVX2o`0COV[oEGiEO_mnoc;j
ogiEOUGoOP03o`03=eGo00?o01UnJWkoP6:0H_mZOFYmoggo<ZXbogeZOFYm00?o00<?cPl00ol01EEn
EOl[00Co01mZof8JH_mZA6Y4ocYR>_mR:V8ZobYR:_mRBV9:of=Z00;o00MJHU[oFV9J00?o00n6J_mZ
<VXbodYRB_mRJV800_l01C;oJQAZ00;o1C801?lgo`H4o`0AOZ?oXgjSoeInEWiFogiZOVX00ol06VZ6
JXKoHVYRJ_mZQ_mnJWkoBV9:H_mZHVYR0_l026[oJV;oVWjJ0_l05fYRJV;oHVYRJ_mZHV[oJWkobS;o
J_oj00;o00F0JX3oNP02o`06J_oZ<_lV0ol01:[>Z/h2o`0@XgZSof=EHomKoe[o<UDbE@;o00C>FliK
0_lH00001@02o`<000Co003o10000ol0000M0003oc7o00:Z00GoEF5EH@02o`08EF5EoghbOS82o`<a
00CoZZZZ0ol00nYEo`02o`08EOmnogiRO_l4BP05of5RHF800_l00cMn=`02o`04HV5RH@;o00=Kof/0
0_l02V7oP5Z0FX3o<Ol3HP05ocXj>_l016801Olj>S[o00AR00WoHV9RoeY:FTX01?l4BP04odY:BP;o
0f802Om4OTAnoeY:FP04o`0>=nXgj_mnod/7olZob[l2o`04FonZo`AJ00?oFUX00UX02Om@<U0bof9n
HP02o`03H_mR00=R00KoHWiRO_l2HP0:of9RH_m:FTYJo`AR00CoHV;o0gh03omFof;oOV9nH_mROV9n
o`03HP0?of9RoghboaCo<OmQof4g00;o0gh00olg<@02o`04NWkoZP?o00anocMn=gkoO_mKogX2o`03
OUIn00;o00C>FliK1?lG00001`001?l00?l20003o`00008000?o00007P004_mnEGkoJWiZoo[oJWiZ
O_mnE@;o00TbnS;jogiEogh01?l04UGoEOmZO_mnJWkoP6:0H_mZO@?o00@bZS:Z0_l01geZOF[oF`H0
0_l02FYnJ_mnEGiEOP02o`11HVYRJ_mR6V;oJTAZA?ljHS[oHRYR:_lZHR[oHTYRB_lbJ_mRFV9JoeYR
F_n6JXIZofXbJS;oBV9:ob_ojS;Z<^X00_l014/aBol2<P?o05/6oeEnogjSOZ?oXgjSO_mnEWiFogiZ
ofZ6J_mZQVZ6of9ZH_n6JXKoOVYnodYRBV;oJV9ZH_mRJ_mZHV[oO_mZO_mRJV;oHVYRJ_mZHV[oJWko
bS;oJ_oj<_n000;o00InofZ>JXh3o`03FUEJ00;o00UEJUEZoj=jXgX00_l035_oF_m[oc9Eoe_oF`Co
00A[o`3o5P0000@00ol400;o1@02oal000?oZZX00ZX00omQo`02<@05oeEQEF400ol00gko<@04<@;o
00InoooojUD3o`09OV9nogiROV;o00=:0ol03UEQoghgO_lbof9QH_mK0_l03I[oHF9Qoh1JP5[o>_l0
16801Olj>S[o00AR00Go>SXjo`04HP0=of9RH_mJBU[oA7i4o`04BP03odY:00;o16804?m4OTAnoeY:
F_l7>olgjSL2o`03B`M;00Co00T`n_ooZYZZV_l00eX00omJFP02FP07oe0bD3;oHP02o`=R00?oHV80
0V801?mRO_l4HP0:of9RH_m:FTYJo`=R00GoHV9Ro`03OP;o0f802_mROV;oHWiRO_l4HP;o00HbOS;o
5?l2<@;o00AEoeGo17h3o`0=OW[oV_lcOS=nocMn=`02o`07Foooo`Mk1`02o`03cV_o00;o00=cJol0
1?lF00004P000ol0000N0005ogiEOUD00_l01oXbnS;oOVX00_l021Z06_lbnS;j1?l00giEo`02o`0N
P1CoOVYnogiZOV[oHX1RofYnJWko<ZXboc;oOFYm0_l0;7iFO_mZOV[oOUEnof8Jof9ZHV[oHQYRofY4
JTCo>V8jof8ZHR[o:V8Zof9:0_l02fXbJ_mRFV9JH_mR00;o0126JXIZofXbJS;oBV;oFb]K1?l00eGo
<@02o`03J_mE009E01GoO_mnEGiEoj=nXgkoOZ=nogiFOUH00_l033;oJXIZofZ6JXKoHP;o02aZQVZ6
ogiZO_m:HTYRofYRJ_mZH_mRJV9ZofYnJWkoHVYRJ_mZHV[oJV9ZHP;o00HbbS;:oc83o`09D7koO_mZ
SVZ>00;o00mEoonJOY[oJUEZEOmjoe/01?l00f^;o`02o`04FoooJ`Co00K>oooo0?lE00004@000ol0
000O0004ojZZZP;o1C402OmQof;oOQAn5006o`0C<WhbO_m^OVinogiRO_mnHWiRo`02BP;o00eEHEEQ
oghgobHb9_mQ00;o00eFVUJJof5RHF;oFX3o008j00?oHV800V801Olj>S[o00AR00Go>SXjo`04HP06
of9RH_mJ0ol01DAnA7ko00A:00CoB_oo16802_m4OTAnoe[o1c/3o`0EHGiQOV7oHGiQO_ojojYEojZJ
ZY[o00AJ00?oFUX00UX00olbo`02o`03OV[o00=R00?oHV800V801?mRool4HP0:of9RH_m:FTYJo`=R
00CoHV;o17h00omRHP02HP0:of9nHWkoOV9no`AR0_l0139n<Wh2o`06HCOo^UFj0_l3OP;o00anoonJ
ZYZZoghcOS<2o`05Fooo:`l00ol00f]co`04o`03EC7o00;o00=[Lol00olD00004@000ol0000P000:
oeGoH_lbnS;j<P;o00IZH_lJP1X3o`07OFYmogiEOP02o`0OP1B05?mnJWiZofYnJ_mRP?l8ogiZOV[o
Z_l7<POoJP02o`0ZEWiFO_mZOVYnoeGo6V8Jof9ZHV[oHQYRofY4JTCo>V8jof8ZHR[o:V8Z0_l06Gko
ofXbJS;oFV9JH_mRof[oJXIZofXbJS800_l08eGoof9ZofYEJUEZofYEJUEZogi@O_mnEGiEoj=nXgko
OZ=n00Co00eZ<VXbofZ6J_mZQVZ600;o019ZofZ6JXKoOVYnodYRBV;oJV82o`06JV;oHVYR0_l04FYn
JWkoHVYRJ_mZHVYRof9Z00;o00k:</Xbb_n0JX1Zogi@OP;o00>>oc400_l02F[oOYYnV_mZE@03o`03
Fooo00?o00?>olh01?l023;oNUGo3oo>0_l016_o0?lD00004@02ob400_l3HP03oc4a00?o00=ROV80
1?l08aCoHF9QHV7oO_mnofinKWkoOV9nH_mROV;oB_lb1omQEF5E00;o00@b9S8V1?l035JJEY[oHF9Q
H_mJo`<j00?oHV800V801Olj>S[o00AR00Go>SXjo`04HP0>of9RH_mQogkoA7i4O_l4BP;o0V800omR
HP02HP03ogi400;o00/bO_mQHV7oHGiQOP02o`0?HGiQOV7oEJYEojZJZY[o00AJ1?l02F9QH_mnJWiZ
o`03HP03of9R009R00CoHV;o16800omRHP02HP05oeY:F_l00V82o`03H_oo00=n0_l4HP0Dof9nHWko
OV9nH_mRogkoOS9n<Wh2o`0:HCMQoeFjEK[oOP;o00UQOV7oVZZJZYX00_l00f_oo`03o`03nR_j00Co
00EFOUInEP02o`06o_ooof]c1?lD00004@000ol0000P0006of9ZHVYR0_l016:mof83o`036X0J00;o
00EZOFYmJP02o`0@Of[oP1B05?mnJWiZofYnJP;o00P8F`SoOVYnJP;o00@b1c870ol02POoOUInE_mn
JWh3o`0/6V8Jof9ZHV[oHQYR6_m4JTCo>V8jof8ZHR[o:V8Zof[o<_mZ<VXboeYRFV82o`07QV[oJXIZ
QP03o`03<UDb00;o00QZHVYRoeEZE@;o00AZEFYE0_l02gi@OU3oEGiEO_mn00Go02AZEFYEofXbJS;o
JXIZQ_n6JXKoQV[oJXIZQ_mnJWiZof9:HTX2o`0H<Wkoof[oJ_mnofYnJWiZofYRJ_mZHVYR0_l04VYR
olXbbS;o1omZP6[oOU1nD0Co00UZEFYEoiYnVWh01Ol00lkoo`05o`06<OmE<UDb1?l2E@?o00A[c_oo
5000014000?o000080000omRHP03HP03odYJ00?o00InH_mn57h2o`06HF9QHV7o0gh03_m^OVinogiR
OV;oHWiR0_l01PLb1c;oE@Co00<b9_l00ol02_X8oiYFVUKoHV42o`03O_lj008j00?oHV800V800olj
>P02>P05of9RH_l00cX00omRHP02HP0>of9Rof;o<Whbogi4O_l4BP;o0V800omRHP02HP;o01in<Wko
F_mQHV5RogiQo`P[ogiQof;oEJYEZ_nJZYX3o`0@OV7o=n[oHV5RogiZOVYno`=R00CoHV;o0f800omR
HP02HP03of9R009R00GoFTYJBP02o`8b0_l01aCoO_lJB_l016802?mnHWkoOV9n0_l04GiROV;o<Whb
obKoHCMQ=onj00Ko00YQOV5nojZJZ_l[1_l05G=[oonjEKYEogiFocOZonXgog;oL`02o`030?l001<0
000A0003o`00020000GoHVYRJP04o`0P_OmRJV;o6X3o1omZOFYmJ_mZOf[oP1B05?mnJWiZofX3o`03
F`QK00Co00<?c_l01?l03:YFoe07ogiFOUKoOP;o01mZO_lJHQ[oHVYRJ_mR6V8JodAZA?ljHS[oHRYR
:_lZ00;o00inogXbN_lbJS;oFV9JHP;o02>6J_mZQV[o:omE<_n0<_mZHVYRoeGoD0M@oeGoOS9noe1n
D005o`0GEC;oJ_lbEOmEJUEZoc9Z<V[oQVZ6ohH00_l04VZ6J_mZQVZ6J_mZOV[oHTYRBP;o02HbO_oo
J_mZoghcogiZOV[oJV9ZH_mRof;oHVYRJ_lbb_oj1o[oP0Co00=ZHVX00ol02FYEJUGoVWko1`04o`03
o_m[00;o00UEoc5@<E3o<_l015D2o`04:e_oo`@000?o00004@0001000olQ0004of9RHP?o015:FT[o
HWiRogko<PPbof9QHP02o`=n00WoKWi^O_mnHWh00ol00f]co`03o`03Jg?o00?o00m[o`LKogko2?X8
oiYFVUH00ol017hDO_l3>P03of9R009R00?o>SX00SX01OmRHV;o00<j00?oHV800V82o`0<H_mRoc9n
<_mnA7ko14X01OmRHV;o009R00Co<C4a0_l02EYnF_mQHV5RH@02o`03:`P[00;o00MREF9EojYE00?o
00EcocOZ=`02o`0>jSOZof9QHV7oJWiZO_l3HP;o00<Dof800f800omRHP02HP07of9RH_mJBP03o`<b
00?oOQ@00_l014XJB_l4HP05ogiROV800_l03GiRogiROV;o<Wko:bH00ol2HP03of9R009R0_l03Wko
OV5nojZJobKoLol>0ol01cOZ=n[oEKX01?l00nXgo`02o`03L_oo00H000?o00004@00010000?o0000
8@05o`0M9_nmH[goHVYRoa[oD0M@ogeZoc;oJWmZOolDP1@01?l00lkocP02o`043lkocP;o014?c_o>
oe/KFonZo`M@1e3oEP03o`0Oc_mnJWko6V8JH_mZHV[oHQYR6_m4JTCo>V8jof8ZHP02o`0?JWkooc9j
<W[o<VXboeYR00?o00UZQV[oJ_l[6b/00_l03H0bP3;oJV9ZHV[o1e000ol01GhbOS9n00?o01T63ooo
EC9E<_lbEC9EoeEZEF[o<VXbJ_n600?o00mRJV;oQVZ6ohIZQV[oJWh01?l02Gko<WhbO_mRJP02o`0H
<ghcogiZOV[oJV9ZH_mRJV;oHVYRJ_lb1?l035[oHVYRof9ZHV[oZP;o00AEJUEZ0_l00b_oo`03o`9E
00CoEEEE1?l00liKo`03o`04Jlkoo`P000?o00004@00010000?o00007`03o`=R00[o:om:FT[oHWiR
0_l02PPb23;oH_laEOl4OP04ogi^OP;o00=cJol00ol00g=[o`03o`03Lf_o00;o00<76`L00ol01?X8
nPP3o`09Lf_ooaAn57ko00@j00GoHV9Ro`04>P05of9RH_l00cX00omRo`02o`03HV5R00;o00Mn<Whb
ogi400Go00=:of800V83o`8a00go=omnFWiJO_mRHF9Q00?o00XgO_mEHUEREOmK1?l04cOZ=nXgocOZ
=n[oHV5RHOmZOVX00ol01f;o57hDO_l00f800omRHP02HPCo00G:^/Zjo`04<P09oghDoaY:6T[o00AR
00ooOV9nH_mROV;oOV9nHWh00_l01EY:FT[o00=R00?oHV800V801_mnO_mnH@?o00XVoooZ=olgjSOZ
0ol0135Eolh2o`03Jom[00?o2P000ol0000A00004003oa`00ol2000>of9ZoklVokeR_OmRJV82o`04
1e07D0;o00hbJS;oJWmZOolDP1Co<@;o00?>3lh00ol00lh?cP03o`03cPoo00?o0UD00om@o`02o`03
3ol?00;o01aZofYnJWko6V8JH_mZHV[oHQYR6_m4JTCo>V8j0_l01PPaogiZOP;o00@bNS9j0ol027?>
olkoH_mZ0ol07<iEoomZP?n0<X0bP?mRJV;oSOn=JXeZoc9n<Wh2o`08EGiEO_mE<UD2o`09<UDbEC;o
JUEZ00Co011RJV9ZofYRJV;oQVZ6ohIZ0ol07FYQoe1nD7ko<WhbofYRJ_mn<ghcogiZOV[oJV9Z00;o
00URJV9ZofYRJV800_l03f9JHU[oHVYRJ_mZHV[oZP04o`05Jlko1ol015D00omEo`03o`03ELYE00;o
00=[c_l00_l=0003o`000140000@0003o`0001T00ol5000=of9Ro`P[odYJB_mROP02o`04<PPb20;o
00HaEC5E<Ol3OP06ogi^o`MK0_l01W?oof_oJ`?o00=[of/00_l01V;o</hbcP?o00=[Lol00_l3HP06
oaAn57ko13X01OmRHV;o00@j00KoHV9RocX3o`05>klkof800ol01C9n<Whb00;o00=bJol00_l00d[o
o`02o`03VZ[o00;o02`gOSMnoeYnFWkoHV7o=gkoOSMn=omREF;oZ_ljOSYnonXgogiEonXgjSOoH@?o
0V800omRHP02HP07oaAn57koHP05o`0;H_mROV9nok[:^_l00S802omn57hDoaY:6T[o00ER00koH_mR
of9nHWkoHWiROP;o00EJBUY:o`04HP04of9RHP;o00ERoomcJ`04o`03=n[o00Co00=KcU/01ol@0003
o`000140000200?o0`02o`H000?o00005P03o`P0017oHV[o_bKo_F:mof;o6bCo1`02o`0@O_mZ<VXb
J_moJWoo5?laF`Co00<?c_l00ol00`o>o`02o`06EGiEO_mE0_l00`ooo`02o`0LQV[oJXIZofYnJWko
6V8JH_mZHV[oHQYR6_m4JPCo00@a23480ol027jSogXbNS9j1Ol01dYRofZ0JX000_l076Ynoh1ZP6[o
<X0bP?mRoheZSOn=JXeZoc9noiX2o`0=EGiEO_mEogdbOOmE<P04o`0?O_mRJV;oHVYRJ_mZHVYR00;o
00EZofYRJP02o`0;HFYQJ_mnD7ko<Wh00_l03VYRJ_mn<ghcogiZOVYn0_l07fYRof9ZHV[oJV9Zof[o
HUYRF_mRJV9ZofYRof9ZHVX02Ol01li[oomKcU/01?lD0003o`00014000030005o`000?l00P000ol0
00030003o`0001<00ol;000:of;o:`P[odYJBP;o00<?9Ol00_l02VYRJV;oEC5E<Ol3OP;o00H7Fooo
Lf/3o`03Jg=[00?o00QRHOmRJV9ZHPCo0V801OmRHV;o00=R00Ko57hDO_l4>P05of9RH_l013X5o`9J
00Ko_oooH_l3FP05oc9n<Wh00_l3HP0Fod[o=ghgOSOoHEEQocMn=gkoFWiJOP?o00Un=ghgocMn=gh0
0_l02:[o1c_oOSYn0_l017iEOUD4o`05HWiRO_l00f800omRHP02HP06oaAn57ko0V801?mRHV82o`09
HWiRO_njb[[:00;o00AZoaAn0_l01QY:6TXJo`AR01KoHV9Rof9nHWkoHWiRof;oFTYJBU[o0f801?mR
H_l4HPCo00A[Lomc0ol00g?ocP03oaL000?o00004@0000030?oo00;o0P001?l00?l400?o4P02o`h0
00[oH_lV_bKo_F:m1?l03UEnogiEOUGo<VXbJ_mo1?l015_oo`l2o`04cPoo3`;o02YZofYmJWgoOUEn
oe1nofZ6J_mZQV[oJXIZofYnJWko6V8JH_mZHV[oHQX3o`0D9OnSOZ=nXon5JXGoXgjSO_lbNS82o`03
HVYR00?o00B0JX1Z0_l037iZO_n0JX1Zoc:0<P;o00XboheZSF[oJXeZ1?l00a=;4`04o`0/N_lbOC9m
odAZofYnJWkoHVYRof9ZHV[oJV9ZofYRJV;oH_lbof5ZHFYQoe03o`0gOS;oJV;oHolcOS=nofYnJWko
HVYRJ_mZHV[oJV9ZofYSoeYRFV;oJV9ZofYRof9ZHV[oc_o>J`03o`03Jli[00Co6P000ol0000@0000
00@0o`3o0`001?l00?l40003o`0000l00ol@00;o01H8:`P[odYJolhKofYRJ_mZHVYRoeDa1?l00g9[
o`02o`06F`Ooof]c0ol0365RHOmQHV5RofYRo`:j0_l3HP05of9RH_l00f801_lDOQAno`@j00?oH_l0
1?l00g9[o`02o`EJ00GoHV9Ro`04FP06oghbogko0V82o`0A=olgOSOo1omQEF5EoghgOSL01?l01`P7
2?lgOSL01ol00`Lk1`02o`09OXinS_mnEGko00=n00KoHWiRO_l3HP03of9R00=R00?oO_l01F82o`08
OUGoHWiROV84o`0>JWiZoaAnogkoBQY:6_l3HP;o16802?mnHWkoHWko0f801_m:FTYJo`=R00CoHV;o
1685o`03Looo00Go70000ol0000@000000@0o`3o0`001?l00?l40003o`0000`00olC00;o00Vo9[lV
okgomU/00_l027iEOUGoEGiE0ol00lico`03o`07c_mK<OlaF`02o`0AEh3oJWeZofYmJWgoO_m@OU00
0_l05FZ6J_mZQV[oJXIZofYnJWko6V8JHP02o`05OUEnobD00_l01fZ5oj=nXgh00_l03HEZQOnSOZ=n
oc9joc800ol04GkZO^[oJ_mK<U_oJWiZofZ000?o00Qcoc9K<U_oJPKo00AmEOm;0_l02AGoEGYEN_lb
O@02o`0DJTAZA?mnJWkoHVYRJ_mZHVYRof82o`04JV9ZHP;o0c801omZHFYQoa/00_l04C9n<_mZH_mS
oc=n<gkoJWiZ00;o029RJV9ZofYRJ_mZH_mSJV?oFV9JH_mZHVYRof;oHVYRJ_o>1?l016_>oolO0003
o`000100000200;o1002o`D00_l:00?o5P001_l[22/8:`;o00W>6omK1omRJV801?l00f_oJ`02o`0:
LV_oJomK1ol7F`;o00hDOQCoHF9Qof5RHF9Qo`>j00?o<_l00f801OmRHV;o00AR00GoOQAno`03>P;o
00ARJV9Z0ol3HP07oeYJF_oZo`04HP06oeYJF_mn1?l01V_o=jXgZP;o00H720L8oeD5o`08LV_oo`P7
20L3o`08FQ[ooc8g<SL2o`0;OQYn6_n>OXinoeD00_l4OP05ogiRO_l016800omRHP02HP;o00=:of80
0f802OmEOUEnogiROP04o`0?OVYnJ_lDO_mnodXJBQ[o00=R0_l4HP08ogiRO_mRO_l3HP06odYJBU[o
16801?mRool3HP;o00=[Lol00olQ0003o`000100000?0003o`0000H00olJ0003oklV00Co00MKoe/a
FomE00Co00=cc_l00ol00g?>o`03o`0f<OlaFomZoh1GP?mZOF[oJWeZOF[oOU1noc;oJXIZofZ6JXKo
QVZ6ogiZO_lJH_mKoeEnEOmR0_l04hEZQOnSOZ?oO_n5JXEZogjSOZ<00_l02<koJg_oO^Yn0_l015/b
Fc83o`05Llicog<00_l01<icoc83o`0EV_n0ocOZoeEmocOo5EDEEOmjEGYE00;o019ZofY4JTCoOVYn
J_mZHV[oJV83o`06BV;oJV9Z0_l4<P03ofYQ00;o021nEOmn<Whbof[oJV?o<ghcO_mZO_m^of9ZHV[o
JV9ZHP?o00mSJV?oFV9JH_mZHVYRof800_l01VYRooo>J`?o8`000ol0000@00003`000ol0000300?o
7P02o`03LV_o00;o00=K1ol00ol00f]bJ`03o`03Jg9[00?o00=[LV/00_l00`MKo`02OP0=oaAn5?mQ
HV5Rof9QHP02o`:j00Co<C;o16801OmRHV;o00=R00goOQAnoc[oF`MKof[o008j0_l4HP06oe[o=n[o
16800omJFP03o`06Jom[<F/a0ol0179[o`L2o`05L_mbJg800ol00g9[LP03o`04L_nJEP;o0c400olg
o`02<@09oghJOQ[oSWj>00;o0Wh00omnOP02OP06ogiROV;o0V84o`03B_m:009:00coHV;o1omEOUEn
ogh2o`0CFQYJogiZOV[o5?lDO_m:6TXJo`02HP04oeYGo`=R00GoOV9nHP03o`=R00KoBUY:F_l4HP04
of;oo`9R00Co=ooo0`000ol0000P0003o`000100000>0004o`0000?o8P03o`03JWeZ00;o00EccW?o
L`02o`04JWgoL`;o00C>Lomc0_l0;6[oFomZOf[oP5N0ofYmJWgoOF[oFomnD?oZ<_mZQVZ6ohIZQ_n6
JXKoOVYn0_l015/7F`L2o`0CHQ[o>on5JXEZogko<WkoQFZ5JP03o`03c_oo00;o00=kJol00_l00lic
cP03o`03cW?o00Co00=cool00ol01G?ooonJ00?o00@gjSOZ0_l02COZ=n[oEAEE5@03o`0>HVYRJ_mZ
A6Y4ogiZOVX3o`0?J_mRBV;oHTYRof[oFc;o00@b1?l08EEnEGko<Whbof[oJV?o<ghcO_mZO_m^O_mZ
HV[oJV9ZHP03o`0?HfYSoeYRFV;oJV9ZH_mR00;o00EZH_lgo`050003o`0001l000?o0000400000h0
1?lU0006of5RHF9Q0_l00f]bo`02o`09HF9QHV7oLV]b00?o00EEHEEQo`04OP0?oaAn57koHV5Rof;o
1c8700;o00@b<C;o16801OmRHV;o00=R00?oOQ@00_l015/7F`L3o`8j00?o6ol01682o`05jSOZ=ol0
0f84o`03Jg;o00?o00=nNWh00ol00f]bo`02o`03LV]b00?o00=bJg800ol01a[ooooZEOl00S42o`03
Fola00<a00?o6Wh00ol00f;oOP04OP07oginO_mnHP03o`=R00GoBUY:o`03BP;o10L00omnE@02o`0<
6_ooFQYJ6_mZOVYn0_l021AnodXJBQY:0_l015MJEol3HP08ogiROV;oH_l3HP06odYJBU[o1682o`04
[omRHP;o1`000ol0000O0003o`0000l0000>00;o9`002?mZOFYmoe070_l027eZofYmJWeZ1?l05GeZ
ofYnJWkoOfYoJ_n0Eh1GogeZO@02o`04F`QK20;o010bjS;oJXIZQ_n6JXKoQVZ60ol012_>oe/2o`0H
NS;oH_l8>`SoJXEZoc9n<WhbofZ5og?>1?l02UIEoeEFEOm@olh2o`04LlkocP;o00=cog<01?l02Gko
olko=eDgE@02o`06cU_>FooZ1_l03F5ZHOmRJV9ZH_m4JT@00ol03E[oHVYRJ_mRBV;oHTX00_l01E/b
Fc9K00Co00eEof[oEGiEO_lbOS9n00;o00QZHf[oOS=n<`;o01anKWkoJV9ZofYRJV;oHomSJV?oFV9J
HU[oHVYR0_l01@SoJV;o00P000?o00007`000ol0000?000040000ol0000T000Lof5RHF;o<PSoHF9Q
of5RHF;o<_mRHF9QoeEQE@;o17h02?lDOQAnof9Q0_l010Lb1c82o`05<C8a<_l016801_mRHV;oHPCo
00<>Jol00_l02f9ZHV[o>_no6koo00=R00[o=nXgjSOoH_mb0_l02gkoOWYnN_mjO_me00?o00=[LV/0
0ol00f]bo`02o`03O^Yn00;o00MKcU_oENYE00;o00C>FliK0ol00gkoHP02HP03of9R009R00?oOWh0
0Wh00omnOP02o`04BUY:o`AR00CoBUY:0ol00g=[o`021`?o01YcoaYJogkoFQYJ6_mZOVYnoghDOQCo
6TXJBP;o00AGFUOo16801?mRO_l2HP03of9R009R00KoFTYJB_l4HP03ojoo009R00?o00001`000ol0
000N0003o`0000l0000A0003o`0002<000OoJWeZo`M@00;o00QZOF[oJWeZO@?o01=mJWeZofYnoe[o
OfYoJ_n0Eh1G00?o00@Uc_mK0_l03GkojS;Z<_mZQVZ6ohH01?l00lh[cP03o`07JXGoNS9j<P02o`07
>`Pk2?mZQ@02o`07<WhbOS;oJP02o`09EUEFEOmEEUEF00Co00=EEUD00ol00lico`02o`0<EOlg<SLb
oe_>FliK0ol01<h?olh2o`03NUEj00;o01b6JXKoHFYQJ_mZHVYRodCoB_mJHU[oHVYRJ_mR0ol00lh?
cP04o`033ooo00;o03enEOmZ<_mnEGko<WhbO_mSJV=ZoghcOS?oKWi^O_mZHVYRof;oHfYSof=ZHf[o
HUYRF_mRJV9Zo`Pcof;o00X000?o00007@000ol0000?00004P000ol0000R0007of5RHOl8<P02o`09
HF9Qof5RHOl800;o00YRHF9QH_mQoc7o17h01?lDOQ@2o`03Jg9[00?o00UZHV[o<C8a<_l00f83o`04
3V_oJ`?o00<Kof800V801OmRJV9Z00;o00hK_a^oof;o6`OojSOZ=`;o00YnogijOW[oNWij0_l01Gko
OWYn00?o011[ooooOXinonYnj_m[oe_>0ol00g=[L`04o`06OXinoe[o0f800omRHP02HP03ogin009n
0_l01dYJodYJB_l00f83o`03Jg?o00?o00=[Lol00_l049ZZV_lJofYnJ_lJFQYJogh3o`0?OQAn5?lJ
BQY:oeYGFUOo00AR00?oH_l00f800omRHP02HP06oeY:FT[o16801_n_2?mRo`X000?o00007@000ol0
000?00004`02ob<000ooOOm@1ol7ofYmJ_mZOFX00_l01e3oOFYmJWd00_l03C9JogmZOf[oP5Oo<E/0
0ol02eEnogiEOUGo<^Xb00Co00@[ob_>1?l03348<On5JXGoNS9j<P;o00@k23/80_l01PMK1omn<P?o
00UEEUGoEEIEoeD00_l01VYEJ_mFE@Go00c>oomENUEjoc;oJc03o`033ooo00?o01nZjZ[Zog[oOQ[o
QVZ6of5ZHF[oJV9ZH_m:HT[oFV9J00Co00?>olh00_l00`oo3`03o`07EC;oOZYnZP02o`07<VXbogiE
OP03o`0;JXKoHfYSJ_mn<gh00_l02FinKWkoJV9ZHP03o`0HHfYSof=ZHf[oHUYRF_mRJV9Zo`Pcof;o
2`000ol0000L0003o`0000l0000E0003o`00020001koH_lb2?l8of5RHF;oH_lboc;oHV5RHF;o<EDa
EOl3OP0BoaCo1e/7of9ZHV[oJV9ZH_lb1?l00f/>o`03o`08Jooo_a^o6ol3HP04of9ZHP;o00Bo6klK
0_l00a/76`04o`09O_mnNWijogYn00?o00IEogiZOVX4o`0:Jooooc;oOXinSP;o0V/00onZVP02o`09
LomkFolgECME00;o0eX01OmRHV;o00AR00?oOWh00Wh01_mJBU[oBP?o00=[Lf/00ol00f]co`03o`08
EGiEO_nJZYX2o`04OVYnJPCo00=Rof800V802Omn57hDoaY:6P02o`05FUMJEol016800omRo`04HP0:
of9RH_mJBUY:o`=R0_l01Jl8of;o00`000?o00006`000ol0000?00005P000ol0000O00;o00`7D?m@
1e3oOFYmogd2o`071e07ofYmJP02o`08FS9J<_mZOfX2o`0=<E/aoc7oOUEnEOmEOP03o`03:lh[00?o
00D[onjokP02o`082348<On5JXD4o`03c_l800?o00?>oe/00_l02UGoJUEZEOmEEUD3o`08c_lbEOmZ
EFX2o`0<c_oooeDbEC9EogYE0_l03f/`ojYnZ_l?oc1K<5_ojP03o`0DOQYn6_n6JXKoHFYQJ_mZHV[o
HTX4o`03c_oo00?o00?>ool00ol01c/7oeDbEC801?l0=f;oJS9Z<_mZHVYRohIZQ_mSJV=Zoghcogko
KWi^O_mZHVYRoaCoHfYSJ_mZHf[oHUYRF_mRJV800_l01@Pcof;o00d000?o00006P000ol0000?0000
5`000ol0000N00;o00X8<_lb23;oHV5R0_l040So2388of5Roe_o<EDaEOl2OP;o00/7F`Oo1e_oJV9Z
HP03o`043V_oJ`;o00P>Jom[of/8J`;o00Jo6klKof84o`033V_o00?o00<>Jol00_l02?[oEOmnJWiZ
1?l02F_oJomEOUGoOP02o`0;L_ooojZJoc9n<Wh00ol01f[oJonZVZX01?l00e]ko`03o`03BU[o00AJ
00?oHV800V801OmRHV;o009n1?l00jYnZP02o`03Jg=[00Co00X8oolaFc5KogiE0_l4HP06ogiZOV[o
16805OmRHV;oOQAn5?lJB_mR5?mGFUMJo`03HP03of;o00AR00[oHV9RoeY:FT[o0f801?l8[`P2o`h0
00?o00006`000ol0000>00006002oah000coD0Oo1e07D?mmJWd3o`0>D0M@1omZoe/aFolbFS83o`0;
cR_o<OlaFc7oOUD01?l00b_>o`02o`03cR_>00?o00>ok_l00ol00`Pao`03o`03cR_o00?o00?>:ol0
1?l02>X7oc9E<_mE1?l00g?>o`02o`05<UDbEC801?l027?oZWjZoc9E0ol02eFZEJ[oZWjZO_o>00Co
01LjH_mRBV;oOQYn6_n6JXIZofYQJV7oHP02o`AE0_l00lkoo`02o`032?mA00;o00Dk1c/7>`03o`0:
J_mZHVYRofXbJP;o02mZHVYRohIZQV[oJV=ZHolcogiZogi^OVkoHVYRoaCoHfYSJ_mZHf[oHUYRF_mR
JP02o`03<`Pc00;o3`000ol0000J0003o`0000h0000J0003o`0001`000Wo2?l8<PPbof800ol01S;o
<PPb20;o00IK1e/7oeD4o`03J`ko00?o00=K1ol00ol00f/>o`03o`03Jooo00?o00=[3_l00_l00`i[
3P03o`033V/>00?o00<>Jol00ol02`Sjool8n_mEOUEn00;o00=[3ol00ol01fYRogiEOUD00_l02G;o
oonZVZZJZP02o`06HGkoJWiZ0_l019ZZVZX2o`0;>T[o>TXjoeY:F_l015X00omRHP02HP03of9R009R
0_l01JYnogjZ00Go00=cod/00ol2=`03oc5K00?o0f800omRHP02HP04ogiZOP;o16800omRHP02HP05
oaAn57h00_l02AAR5?mGFUMJo`02HP04of9Ro`AR00coHV9RoeY:FTYJof82o`052:l8[ol040000ol0
000I0003o`0000h0000K0003o`0001`00_l00`M@o`03o`03c_oo00;o00=@1ol00ol00c5Ko`03o`03
:lh[00?o00<[cR/00ol00b_>o`03o`03:lko00;o00G>:lkocP02o`04:lkocP;o00<[ob/00ol00b_o
:`04o`031e3o00?o00T7oc9E<UDboe/00_l02X1noeEREOlbEC84o`9Z00OoOZYnZWko00=Z00WoEJ[o
EOnZOZX00_l06F9:H_mR>V;oHTYRB_lJOQYnofZ6J_mZHFX00_l3E@06oeGoolh?0ol020SoogZSNZ=j
0_l07hIZofZ6J_mZHVYRofXbof[oJV9ZH_n6JXIZofYSJV<00_l07FYnJ_mnKWi^of9ZofXDof=ZHf[o
JV=ZHomJHUYR00;o00MJoc<8<`So010000?o00006@000ol0000>000070000ol0000M00;o00<>Jol0
0_l00f/>J`03o`03J`i[00?o00E[3V_oJ`02o`033_l>00?o00<>o`h00_l016/>o`h2o`05J`ko3V/0
1?l00`i[o`02o`03J`ko00?o00=[3_l00ol00f_oo`02o`03LV_o00;o00L7oeEnEOl700;o00XJFQ[o
HVYRJ_mE0_l02WkoOV5nojZJZYX2o`04OV5nH@;o00InEGkoZYX2o`0=BSY:ocY:>_mJBUY:o`04FP05
of9RH_l00V801_mRogjZOPKo00=cJol00ol5=`05of9RH_l00f800omRHP03HP06of[o56;o0f800omR
HP02HP0@oaAn57koHQAR5?mGFUMJo`9R00CoHV;o16800omRHP02HP05odYJBUX00_l01d[o2:l8[ol0
4@000ol0000H0003o`0000h0000M0003o`0001`000So:ooocR_o:`;o00C>:ol[0_l01Lh[ob_>00?o
00?>:ol00ol00lh[o`03o`03cR_o00?o00?>:ol00ol00lh[o`03o`03c_oo00;o00<[cR/00ol00b_>
o`02o`03cRG>00?o01C>oe/aoeDboe_o<_mnP7j0of9EHP;o0fX02omZJV[oOZYno`Oo00AZ00SoEC9E
<_mnZP;o01YRBV;oHSYRof9:HT[o6WhJO_mZQV[oJ_mZHPKo00C>3ol?0_l026_oJV;oXgZS0_l0?fZ6
J_mZQVZ6of9ZHV[o<_mZO_mRJV9ZofZ6J_mZHfYSogiZOV[oOVinK_mRJ_mZ5?mSJV=ZofYSJV?oFV9J
HP02o`04F_lc20?o4P000ol0000G0003o`0000h0000N00;o7@02o`03J`ko00?o00=[3_l00_l00`i[
3P04o`03Jooo00;o00<>Jol00ol00`i[3P03o`033V/>00?o00<>Jol00ol00`i[o`02o`05J`i[of/0
0_l020i[of_oJom[0ol05F_oJol7:`OoEOl7oeEnoaYJ6U[oJP04o`0YOV5nogiQO_nZVZ[o2?mnHGiQ
oeEnEGkoZ_m:odXjB_ljBS[oFTYJB_l015X01?mRHV82o`=R1?l00g=[L`04o`03JomR009R00Ko=cOo
H_l3HP03of9R009R00?oHV800V82o`04HQARo`AR01CoHV9RoaAn57koHQAR5?mGFUMJo`9R00GoHV9R
o`03HP03of9R009R00SoBUY:F_mJBP?o5P000ol0000F0003o`0000h0000P0003o`0001`00_l00b_>
:`03o`03:lko00?o00<[c_l00_l00lh[cP03o`05cR_>olh00_l00b_o:`03o`03:ol[00;o00C>:ol[
0_l01Lh[ob_>00?o00?>:lh00ol00lkoo`02o`039Lko00?o00<aFol00_l02U_o<Whbogj0OX02o`04
JV9Zo`=Z00?oJVX00VX01onZoe07D?l00VX0:Ol[oc9E<_mnof;oHTYRof8jH_mRBV9:oaYn6WkoJXIZ
ofYRJV;oOVYn00Co01]Kc_ooJV9ZH_nSN_mZofZ6J_mZQVZ6of9ZHVX00_l0<giZO_mRJV9ZofZ6J_mZ
HfYSogiZOV[oOVinK_mRoaAZ56[oJV=ZHomSJV?oFV9JH_mRFP02oaL000?o00005P000ol0000>0000
8@000ol0000L0007of_oo`ko3P02o`04J`ko3P;o00A[3_l>0_l01F/>o`i[00?o00=[3_l00ol00f/>
o`03o`03J`ko00;o00<>J`h01?l00f_oo`07o`03Jg;o00?o00=[LV/00ol0:lYEoomEOUEnoaYJ6U[o
HV5RHOmnHGiQof5nHOnJooX8n_mQoc47ogiEOUD00_l03d[oBSY:ocY:>_mJBUY:o`04FP05of9RH_l0
16801?mRHV83o`05FlkoH_l01F82o`9R00GoHV9Ro`04HP03of9R009R00Ko568DH_l4HP08of9RH_lD
OQ@2o`0;HQAR5?mGFUMJof800_l3HP03of9R009R00goHV9RodYJBU[oFT[o01T000?o00005P000ol0
000=00008P000ol0000L0003olh[00Co00?>:ol00ol00lh[o`02o`03:lh[00Co00?>ool00_l00b_>
o`03o`03:lko00?o00<[c_l00ol00b_>o`02o`03Fooo00;o00<UcRD00ol015Ejolh3o`03EOo>00;o
00YooghbOS9noh1n0_l01F9ZHV[o00AZ00CoJVYZ0_l010M@1e02o`06:oL[oc9E0ol05dYRof9:H_mR
>V;oHTYRB_lJOQYnofZ600;o04IZHV[oJWiZO_l?olkoHV[oJV9ZHV[oJQAZofZ6JXKoQVZ6of9ZHV[o
JWiZO_mRJV9ZofZ6J_mZHf[o2?mZOVYnofinK_mR0_l05FXDJ_mZHfYSof=ZHomJHUYRof9Jo`0J0003
o`0001D000?o00003@0002<00_lM00;o00<>Jol00ol00`i[o`03o`033V_o00?o00<>Jol00_l00f/>
J`03o`03J`i[00?o00A[3_l>0_l016/>o`h2o`03Jol700;o00B5=om[0_l02hGoQCN5=omEOUEn00;o
01UZOV[oEGiEOUGoF_oZof9QHV5Rof5nHOmQ00Co00<8n_l00_l01347<@L4o`0C>TXjB_m:>T[o>TXj
oeY:FTYJo`03FP05of;oH_l00f801_mRHV;oL`?o0f800omRHP03HP03of9R009R00GoHV9Ro`03HP03
of9R009R00Ko568DH_l4HP03of9R009R013oOQCo<_lDHQARoeYGF_mR0_l3HP03of9R009R00coHV9R
odYJB_m:F_lL0003o`0001@000?o00003@0002D000?o00007002o`03cR_>00?o00C>:ol[0_l01<h[
ob/2o`04cR_o:`;o00?>olh00ol01<kocR/4o`03cR_o00?o02g>oe_oNUEjEG[oNUEjogYENUGo<UDb
oe[oOeEooghbOS9noh3oO_mRJV9ZH_l00VX3o`03cRG>00?o00AEF_og0ol06TYRB_m:HTYRof9:H_mR
>V;oHTYRBV;oOQYn0_l02WiZofYRJ_mZOVX2o`0lHV[oJV9ZofYRJV9ZofXDJQCoQVZ6ohIZQ_mRJV9Z
ofYnJWkoHVYRJ_mZQVZ6of=Zo`SoJWiZO_m^OVin0ol056XDJ_mZHfYSof=ZHomJHU[oFV;o70000ol0
000D0003o`0000d0000V0003o`0001`000So3_ooJom[3PCo00=[3_l00ol00f/>o`02o`033V_o00?o
00<>Jol00ol00`i[o`03o`033V_o00;o00L7oon5=hDg00;o01R5=hGoQCN5oa_oO_lb<OmZOVYnogiE
OUD2o`08=n[oHV5RHF83o`03Jom[00?o00MRof9JHU[o009R01Wo>TXjocY:>T[oBSY:ocY:>T[oBUY:
F_mJ00?o00IROV9nof82o`=R00GoHV9Ro`03HP03of9R00=R00?oHV800V801OmRHV;o00=R00CoHV9R
0_l01AAR56;o00AR00?oHV800V803omn5?lboaAR56;oFUMJE`03o`=R00?oHV800V800omRHP02HP07
oeY:odYJo`0M0003o`0001<000?o00003@0002L000?o000070000ol[cP04o`03:lko00?o00<[c_l0
0ol00b_oo`02o`03cR_o00?o00?>:lh00ol00lh[o`03o`03cR_o00?o00mjEG[oFomjEGYEoeGo_e/0
0_l02eYEFUGoEGmEoc9n00Co00/bOS;oJV9ZH_lUcP03o`0SEEYEF_mJEEYEofYSodYRB_m:HTYRof9:
H_mR>V8jodYRBV800_l02F5ZofYnJWkoHP02o`0@JWiZofYRJ_mZHV[oJV9ZHP;o04IZ56XDohIZQ_n6
JXKoHVYRoc?oOVYnJ_mZHV[oJXIZQ_mSJ_l8ofYnJWkoKWi^O_mnofXDJ_mZHfYSof=ZHf[oHU[oFV;o
7P000ol0000B0003o`0000d0000X00;o7@02o`03J`i[00?o00=[3V/00ol00f/>o`02o`033V/>00?o
00D>J`ko3P02o`03Jom[00;o00@>Jom[0_l03Pko6`Oo=ol76`Oo=hDg0_l02a_ooe_o<C8a<_mn00So
00[Z=nXgof5RHOlK0_l0369JoeYRFV;oHUYRo`=R01So>TXjocY:>T[oBSY:ocY:>T[oBUY:F_l4HP06
ogiRO_mR0_l2HP;o0f800omRHP02HP04of9RHP;o16801OmRHV;o00AR00_oHV;o2?mR568Do`03HP03
of9R009R01;oO_l8<_lDHQARoeYGFUOo6_l3HP03of9R009R00?oHV800V801omJB_m:F_l07P000ol0
000B0003o`0000d0000Z0003o`0001/000So:ooocR_o:`;o00?>olh00_l012_>olh2o`05:lkocR/0
0ol00b_>o`03o`03:lko00?o00D[okmK_`02o`06FkmK_omE0ol02;ooNe]kFomE1?l00bGoo`02o`0I
EE[oOS9n<_mZH_l7FomEFUEJoeYEFUGoE@02o`0IHfYSodYRB_m:HTYRof9:H_mR>V8jodYRBP02o`08
JV5ZHOmnJWh2o`0422KoOP;o00aZHV[oJV9ZH_mRJV82o`16JQAZ5?n6JXKoQVZ6J_mZH_lcogiZOV[o
JV9ZofZ6JXKoHon_2?mZOVYnofinKWkoO_mZ56XDof=ZHomSJV=Zof9JoeYRoal000?o00004P000ol0
000<0000:`000ol0000K00;o00=[3_l00_l00`i[o`03o`033V_o00?o00<>Jol00ol00nYEo`02o`03
J`ko00?o00=[3_l00_l00a/7o`02o`041a/76`?o00P>Jooo<5/`F`?o00=Eo`L00_l06eYRof9JH_oZ
=nXgof7o6`Oo1omRFV;oHUYRFP02o`03H_mR009R01Ko>TXjocY:>T[oBSY:ocY:>T[oBUY:0_l4HP04
ogiROP;o00@b_omR0_l3HP03of9R009R00CoHV9R0_l4HP05of9RH_l016802omRH_l8of8DHQCo00=R
00?oHV800V804_mno`PboaAR56;oFUMJEolJo`AR00GoHV9Ro`04HP07oe[oodYJo`0P0003o`000140
00?o0000300002`000?o00007002o`03:ooo00;o00?>:ol00ol00lh[o`03o`08ECOo=eGoFlh3o`03
:lko00?o00<[c_l00_l01Lh[c_mK00;o00<[ob/00_l01<h[og/2o`0C<Whboe^ooeYEF_mJEEYEoc9n
<P02o`0<1e_oF`OoFUEJoeYE0ol09VXDof=ZHom:HT[oBV9:H_mRBV9:ocYR>_m:H_l8ofYQJV7oOVYn
0_l00`PVo`03o`0<JV9ZofYRJV;oHVYR0_l0@FXDJQCoQVZ6ohIZQV[oJV;o<omnJWiZofYRJ_mZQVZ6
of?o[`SoJWiZO_m^OVko<gkoJQAZ5?mSJV=ZofYSJ_mR00;o00=Jo`008@000ol0000@0003o`0000`0
000]00;o7@02o`03jUGZ00?o00?ZEOl00ol01nYEoeGZENX00_l01U_>obGo3P;o00A[3_l>0_l01F/>
o`i[00?o00=[3_l00ol00f/>o`02o`07FV;oEOl76`02o`0:HUYRof9JHU[o=`Co00T7o`LK1omRFV80
1Ol3HP0Lof9RH_ljBS[o>TXjB_m:>TXjodXjB_m:F_noo`AR00SoOV9noklb_`Co0f800omRHP02HP06
of9Roc?o16801OmRHV;o00AR00_oH_lb2?mR568Do`04HP0Fof9RH_mno`Pb2?mR568DoeOo6UXJo`AR
00?oHV800V801_mRHV;oFP;o00=:o`008@000ol0000@0003o`0000`0000_0003o`0001X001?o=eDg
ooKo=eGoFomE=eDgEOmE00Co00?>obD01?l00lh[o`03o`03cR_o00?o00?>ool00_l00b_>o`04o`04
EEYEFP;o00aK_onooeYEFUGoEEX3o`03:lh[00;o00EK1e/7F`03o`0QJV7o5?lDJQCoHfYSodYRB_m:
HTYRB_m:HT[o>V8jod[o00<800KoHFYQogh3o`039PPV00;o034bofYRJ_mZHVYRof9Zo`SoJQAZ5?n6
JXKoQVZ6J_mZo`PcogiZOV[oJV9ZH_n6JXIZ00;o01j_2:ooOVYnJ_mnoghcO_mZ56XDof=ZHf[oJV=Z
of82o`03F_l0028000?o00003`000ol0000<0000<0000ol0000J0006on[ocQ_>0_l01Q_>6omEjPCo
00=[3V/01?l00nYEjP03o`04EF5EH@;o00<>ool00_l00f/>J`03o`08Jol76`OoHUX2o`0:1a_o6`LK
oeYRFP?o00@>Jom[0_l01@ko6`LK00?o00@bof;o0V801OmRHV;o00=R01Wo>TXjocY:>TXjocY:>_m:
>T[oB_lK_a_o009R1?l01Gko_c:o00;o00<8of800V800omRHP02HP07of9Roc>oo`03HP05of9RH_l0
16802omRoc88of8DHQCo00AR00?oHV800V802_lb2388of8DHQ@3o`056UXJF_l00f800omRHP02HP06
of9RH_mJ0_l00d[o000S0003o`0000h000?o00003000034000?o00006P001?ofFoH2o`04FoIKmP?o
00D[cR_o:`03o`0=H_lgECOoH_mnJWiZOP03o`05:lh[ob/00_l02<koc_mK_e^o0ol02R_o_onoFkmK
oeD4o`03:lko00;o00?>:ol01Ol00c:J<P02o`0M56XDoaAZ5?mSJV?oBV9:H_mRBV9:odYRB_ljHSX0
0_l420?o00Bo2;l80_l00bH89P02o`0><_mZHVYRof9ZH_mRJ_l2200YoaAZ5?n6JXKoQVZ6J_mZo`Pc
ogiZOV[oJV9ZH_n6JXIZo`R_2:ooOVX00ol053;oOS=n<olDJQCoHfYSJ_mZHfYS0ol00e[o000S0003
o`0000h000?o00003000038000?o00006@002?lKool>JolK0_l01F;o3V/>00?o01D>ogiRO_oZogiR
of5EHEGo3V_oJ`h00ol00`i[o`03o`036`Oo00;o00=[3_l00ol00`LKo`03o`03J`ko00?o00=[ool0
0_l01`ko6`LKoc800ol4HP05of9RH_l016804Om:>T[oBSY:>_ljBS[oBSY:00;o00>o6ol00ol02@PK
21/8oc:o<P03o`032;oo00=R00GoHV9Ro`02HP04oc>oo`=R00?oHV800V804?mRHV;oH_lb23;o568D
H_l3HP04of9RHP;o00<b23801?l02V;o<Wko6UXJF_l3HP03of9R009R00?oHV800V801OmRod[o02D0
00?o00003@000ol0000<0000<`02oaX00_l00b_>o`02o`04JXIZQP?o01B6JXKoHVYRJV;oHVYRogiZ
O_l[cPCo00<[ool00_l00lh[o`03o`03c_oo00;o00<[c_l00ol00b_oo`03o`03:lko00;o00?>:lh0
0_l00`MK1`03o`0QQV[oJQAZ5?lDJQCoHfYSJ_mRBV;oHTYRB_m:HT[o>V8j00Co00O>oooo2;l800?o
00D89_mRo`03<P0;of9ZH_mRJV;oH_l00`P03_lDJQAZofZ6J_mZQVZ60_l030Pc2?mZOVYnof9ZHPCo
00=Zo`P00_l082_ooomRoeXboghcOS?o56XDof=ZHf[oJV=ZHomSoe[o9P000ol0000=0003o`0000/0
000e0003o`0001T00_l2BP03of9R009R00?oHV800f803omROV9nH_mROV9noeGo0@02o`03Jooo00;o
00<>J`h00ol00`i[o`02o`03J`i[00?o00=[3_l00_l01@i[3_l>00;o00=[of/00ol00n[o1`02o`03
H_mR009R00?oHV800V800omRHP02HP0Gof9RH_m:>T[oBSY:>_ljBS[oBSY:oe/00ol00f/>o`03o`04
J`ko<P;o00IRokl8_ol3HP0;of9RH_mRoklc_ol016801OmRHV;o00AR00co2388<_lDHQARof83o`08
OV5nHGkoJ`h5o`09OS9noaYJ6U[o00AR00GoHV9Ro`04HP03of9R00;o9`000ol0000<0003o`0000/0
000f0003o`0001P000SoHTYRofZ6JP;o00B6JXIZ0_l0169ZHVX2o`04HVYRJP;o00<8ool00_l01Lh[
c_o>00;o00<[ob/00_l01<h[ob/2o`03c_o>00;o00D[c_o>:`03o`03:lko00?o00=bc_l00_l0:fZ6
J_mZQV[oJQAZ5?lDJQAZofYSJ_mRBV;oHTYRB_m:HT[o>V;oFol?olh00_l01HeZolh[00?o00@b2?oo
0c802OmRJV;oHVYRJP02o`<801Ko56XDJ_mZQV[oJXIZQ_lc23<8ofYn1?l027iEoeEZEFYE0ol00f9Z
HP02o`0J<UXboghcOS?o56XDJ_mZHf[oJV=ZHomSJ_lX0003o`0000`000?o00002`0003L000?o0000
5`001Om:BT[o00=R0_l4HP;o00AROV9n0_l01V9nHWko0@;o00E[3_l>J`03o`03J`ko00?o00=[3_l0
0_l00`i[o`03o`033V_o00?o00<>ool00_l4HP;o0V801OmRHV;o00=R00?oHV800V800omRHP02HP0D
of9RH_m:>T[oBSY:>_ljBS[oBSX2o`09o_oooghgOSMn00;o00Da<S4b<@02o`04_`Roo`=R00?oHV80
0V82o`04_c>oo`AR00GoHV9Ro`02HP?o00<8<_l01?l03QYJoeXJF_mnHGiQof;o1682o`09OS9n<_mJ
6U[o00AR00?oHV800V801?mRH_l3HP03o`0002L000?o00002`000ol0000;0000>002oaL000SoHTYR
ofZ6JP;o00B6JXIZ0_l0169ZHVX2o`04HVYRJP?o00?>:ol00ol00lkoo`02o`03:lko00?o00<[ool0
0_l00lh[o`03o`03c_oo00;o0366J_mZQVZ6J_mZHV[oJXIZofZ6J_mZ56XDoaAZ56[oJV=Zof9:H_mR
BV9:odYRB_lj00Co00QZ=on=JXeZS@;o00D8<PPb2002o`<b00WoHVYRof9ZHVX00_l32008oaAZ56[o
JXH4o`03cR_o00;o01MEO_mnEGiEoeEnEGkoJUEZoc;oJV9ZHP02o`0J<UXbF_lcOS?o56XDJ_mZHfYS
of?oHfYSJ_lZ0003o`0000X000?o00002`0003X000?o000050001Om:BT[o009R00?oV_l00f803?nJ
of9nH_oZof9nHP;o00D?oooo3P04o`03J`ko00?o00=[ool00_l00`i[3P03o`=R0_l2HP05of9RH_l0
1F801OmRHV;o00=R00GoHV9Ro`04HP03of9R009R01?oHV9RodXjB_m:>TXjocY:>_m:00?o01InHGko
OSMn=omnoc4b<C8ao`Ro2;oo0f800omRHP02HP06oc>o<koo1683o`03S_l>00?o01IQoaYJ6_lJFQYJ
oeXJFQ[oHGko<V;o16802olbOS9n<_mJ6U[o00AR00?oHV800V800omRo`04HP03o`0002P000?o0000
2P000ol0000;0000>`000ol0000C000Iof9:H_mZQ_mjohIZQ_mFof9ZH_l8of9ZHP03o`076oooob_>
:`03o`03BV9:00;o00G>:lkocP02o`0CQ_n6JXIZofZ6J_mZQV[oJXIZQP02o`0VJV9ZofZ6J_mZQV[o
JQAZ5?lDJQAZofYSJ_mRBV;oHTYRB_m:HTX5o`0>=fXgoheZSOmnEGko<PP3o`@b00[oHVYRof9ZHV[o
10P00olDJP03o`05JUEZEOl016X0;OmnEGiEoeEnEOmEOUEnof[o<UXbofYRJV;oFS9J<U[o<ghcoaAZ
56[oJV=ZH`03o`05HfYSJ_l0:`000ol000090003o`0000/0000l0003o`00018000GoBTY:o`02HP03
oi[o00=R00koV_mROV;oj_mROV;ocP;o00AJH_m[0_l01T[oBUY:FP;o00<>Jol00_l3HP03of9R009R
00GoHV9Ro`03HP03of9R009R0_l3HP05of9RH_l00f800omRHP03HP05of9RH_l00f803Om:>T[oBSY:
>_ljBSX00_l03[ooogiQOV7o=omn<Whb0ol027j>o`Ro2;oo0f800omRHP03o`03<koo00Co01]J6_n>
OXinof9QHV7o6UXJF_mJ6U[oFQYJ6UX00_l0168bH_l4HP0;oc9n<WhboeXJF_l016800omRHP02HP03
od[o00=R00?o0000:`000ol000080003o`0000/0000m00;o4P00:omRBV;oJ_noN[ooJ_noE[ooJ_no
2?mRJ_oFoeDbEC9Eof9:H_mRBV9:oe000_l02VZ6ohIZQ_n6JXH2o`0<JXIZofZ6J_mZQVZ60_l09FYR
J_mZQV[oJXIZofXDJQAZofXDJ_mZHf[oHTYRof9:HT[oBV800_l020SoDOlgJSMZ0ol02UEnEGkoEFYE
J_l4<P03of;o00Co00<[ool00_l02giEoeEnEGkoJUEZ00;o16X03_mnEGiEoeEnEGkoOUEn0ol01c9J
<U[oHVX00_l06UXbFS9Joc=n<olDJQAZofYSJV?oB_mSJV?o;P000ol000080003o`0000X0000o0003
o`0000l001ooBTY:of;o<YXbof;o<YXbogko<^[oHWkoe_mJHUYR00;o00]:FT[oBUY:oc:oo`03HP05
of9RH_l00f82o`=R00GoHV9Ro`03HP03o`So00=R00GoHV9Ro`03HP03of9R00=R00GoHV9Ro`03HP0E
odXjB_m:>TXjoc[o1ol7ob/8of5n00Co00=n<Wh00_l027j>OXinokl80ol00`i[3P03o`0RHF;oFQYJ
oeXJFQ[oSWkoO_mRHF9QoaYJ6U[oFQYJ6_lJFP;o01H[of8bHS;oH_mEO_mn<WhboeXJFQ[o0f802?mR
HV;oFT[o0V800ol0000]0003o`0000P000?o00002P00040000?o00003P006OmRBV;oJ_noN[ooJ_no
E[ooJ_no2?mRoo<00_l075DbEOmZof9:H_mRBV;o253oQVZ6ohIZQ_n6JXH2o`0`JXIZofZ6J_mZQV[o
_omZHV[oJXIZofZ6JXKo56XDJ_mZ56[oJV=Zof9:H_mRBV9:0_l065_oFol7D@OoJ_l?oe/KogkoVWko
JUEZE@?o00=Zob/00ol00f[oJP02JP0@oeEnEGkoOUEnEOmEogjZo`AZ03;oEGiEoeEnEGkoO_l8o`So
<UXbF_mRof8boc9J<U[o<ghcO_mZ56XDof?oBV9:H_mZoc0000?o00001`000ol0000:0000@@000ol0
000=0004odY:BP;o00BJ<YXb0_l019XbVS82o`05jS;Zof800_l04GiRof;oHWkoBUY:odYJB_lb00;o
0f801OmRHV;o00=R0_l3HP05of9RH_l00f800ol8o`03HP03of9R009R00GoHV9Ro`04HP05of9RH_l0
0f802?m:>T[oBSY:1Ol01Koo22/800;o00Gno`M;1`02o`07VUJJohinSP02o`0GHV5RHOmQHV5Rof9Q
HV7o6UXJoaYJ6UX00_l04AAn5?mQHV5RoeXJFQ[o6UXJ00Co00No:omR<V8b00;o00inEGkoOS9n<_mJ
6UXJo`AR00[oH_m:FTYJof;o<@000ol000060003o`0000X0001200;o3@001?mRBV82o`04N[mj_`;o
00AF_eJo0_l00`Ro2003o`03OVYn00;o00eZ56[oHTYRof9:H_l800;o03R6JXKoQVZ6ohIZo`SoJXIZ
ofZ6J_mZQV[o_omZHV[oJXIZQ_n6JXKo56XDJ_mZ56[oJV=Zof9:HPGo00MZOVYnoe4700Go00=K6ol0
0_l02YYnVWkoJUGoH_l4JP03ofYZ009Z00?oJVX00VX03omnEGkoOUEnEOmnZWjZo`04JP07oeEnEGko
OP04o`0M2?l82?lbFS9Jof8bHS;o<UXbFS;oOS=nofXDJQ@00ol014YRBV82oc<000?o00001@000ol0
000:0000A0000ol0000:0004odY:BP;o00BJ<YXb0_l019XbVS82o`03jS;Z00?o019ROV;oHWiRO_m:
FT[oBU[o_c82o`=R00GoHV9Ro`02HP03oc;o00=R00?oHV800V801_mRoc88o`AR00GoHV9Ro`03HP03
of9R009R00GoHV9Ro`03HP03od[o00;o00PJF_mnHGiQOPGo00=[ool00_l0265RoeJJEYYF0_l2OP0U
of9QHV7oHF9QH_mRHF9QoaYJ6_lJFQYJoghDOQCoHF9QH_mJ6P04o`9:0_l06Koo_b_oHS9R<_mEOUEn
oghbOS9noaYJ6_l00V83o`9R00CoFTYJ0_lc0003o`0000D000?o00002P0004D000?o00002@005OmR
BV;o_gZoN[oo_eJoE[oo_`Ro2002o`17JWiZO_lDJQAZof9:H_mRB_m@oe3oQVZ6ohIZQ_n6J_l8ofZ6
J_mZQVZ6ohKoD;m@of9ZH_n6JXKoQVZ6oaAZ56[oJQAZofX01?l03X3oP7j0ogiZOV[o1omK0ol2JP0?
ofYZJ_nJOYYnV_mRJV;o00=Z0_l4JP03ofYZ009Z00SoOUEnogiEOP;o00EnZWjZo`04JP?o00HbJ_mR
BV82o`0F2?l82?lbFS;o1olbHS9RoeXbFS;oOPGo00QnofYRJ_mRBP;o=@000ol000040003o`0000X0
00160003o`0000P001CoBTY:oc:J<YXboc:J<YXboc;Z<P?o01EnHWiRof9nHWkoBUY:odYJokoo_ol0
0f801OmRHV;o009R00?o<_l016802omRHV;oH_lb23;o00=R00GoHV9Ro`03HP03of9R009R00?oHV80
0ol03`SoFQYJoeXJF_mnHGko:`03o`0@O_mRHF;oHV5RoeJJEYYFo`=n02;oHV5Roa_oHV5Rof9QHV7o
6UXJF_mJoghaoaAn5?mQHV5R0_l014ARA?l3BP0:ob^ookl[_olbo`8k00SoOUEnEOlbOPGo00HJBQY:
6_l3HP03oe[o03P000?o000010000ol000090000A`000ol000070003of9:00;o00BoN[mj0_l01;mF
_eH2o`09_`SookooJWiZ00;o048DJQAZof9:H_mRB_m@oe3oQVZ6ohIZQ_n6oe08D?n6JXKoQVZ6ohKo
D;m@of9ZH_n6JXKoQVZ6oaAZ56[oJ_l7o`L2o`0BP7j0oh1nP?mnJWkoDOmRJV;o0fX02OmZJV[oVWjJ
OP02o`04HVYRo`=Z00?o2?l00fX00omZJP03JP04oeEnE@;o00SZ<^[oZWjZo`=Z00SoJ_mZ<V[oHPGo
10P02OmJobH7oc9R<P05o`0=<S<b<olEOQEnofYRJP02ocT000?o000010000ol000090000B002o`L0
017oB_l7FonJ<_l7oc:J<_l7F`02o`079OooogiROP02o`0@HWiRO_m:FT[oB_lboc:oo`=R00_oHV9R
of;o_c:oo`03HP04of9RHP;o00D8<PPbo`03HP05of9RH_l00f800omRHP02HP?o00>ZojX00_l03EXJ
F_mJ6UXJof7o2?l017h03omRHF;oHV5RoeJJE_oZo`03OP0Bof9QoklKof9QHV7oHF9QH_mJ0ol037ha
OS7o57hDO_mRo`9R00?oA6800ol00f/>J`02o`04:kl[_`;o13/4o`0?1e/7oa@b53;oBQY:6_mR00Co
>P000ol000030003o`0000T0001:0003o`0000@00_l03S5K<Omjoc5K<OmFoc5K1?l01Y[oofYnJP;o
02DDJQAZof9:H_mRo`So253oQVZ6ohIZQ_n6oe08D?n6JXKoQVZ600;o01>oD;m@of9ZH_n6JXKoQVZ6
oaAZ00?o01URoom@oe3oP7j0oh1nP7koJ_l7ofYRJV;o00=Z00?oJVX00VX03OmnV_lgof9ZHV[oJ_l0
0PP00omZJP02JP03ofYZ009Z0_l035Enoc;Z<^[oZWjZOP;o00=ZHVX00ol00lkocP03o`04c_l820?o
00<V1bH00ol03W?oo`Pb23;o<c8coaEn1_lm0003o`00008000?o00002@0004/000?o00000`001Ol7
F`MK00;o00@7F`MK0_l020MKoe_o:onJ0_l05GiRo`SoHWiRO_m:FT[oB_lboc:oo`03HP0;of9RH_mR
oklb_ol00f801?mRHV82o`052388<_l00f801OmRHV;o009R1?l2BP;o00h8o`So2?mJ6UXJoaYJ6P;o
00<[ool017h03omRHF;oHV5RHOnJoc7Zo`04OP0>of7o_a_oHV5RHOmQHV42o`0;OVYnoghaOS5nogh0
0ol2HP?o00<>Jol00_l00f/>J`04o`033_oo00?o00`>oooo1ol7F`MKoc85o`04Jooood0000Go0000
o`0;0000C0000ol000020003oe_o00;o00C>oe/a1?l00e_oF`03o`0P_i[oofYnoa_o56XDJ_mRBV;o
H_l8o`Q@ohIZQ_n6JXH2o`0J2508D?n6JXKoQVZ6oe2oD;m@of9ZH_n6JXH3o`06H_m:HTYR0ol030Oo
1e07ogj0O_mnP0?o00QAoomZHVYRo`AZ00koJVYZogko<SLbofYRJP;o0`P00omZJP02JP0>ofYZoe_o
OUEnEOoZ<^X8o`03Looo00;o00?>ool00ol00lkoo`02o`03Llko00?o00Qcoooo<PPb20?o00?>Lol0
0om30005o`000?l02`0004d00_l300;o00<>Jol00ol00`i[o`02o`0FFooo1olboe3oOV;o2?mROV9n
odYJBP;o00Jooklb_ol3HP04of9RHP;o00Db_c:oo`03HP03of9R00;o00Hb2388<_l3HP03of;o00;o
00An57ko0dX2o`0@Z_nZojX8Z_lJFQ[o6_o>F`;o00<aj_l017h02?mQHV7oHF9Q0_l01NXajS7o00=n
0_l04Q^o6omRHF9Qof7oF`MKofYnJPOo00<>Jol00ol00`koo`02o`03J`i[00?o00=[3_l00ol00f/>
o`02o`043V_oF`?o00=[of/00_m80004o`00o`/0001?0003o`0000800_l00lico`03o`03c_oo00;o
01@aoonookooJ_no6kooJQAZof9:HP;o00e@oe08D?n6JXKoQVZ600;o01@8D0Q@ohIZQ_n6o`ooD;m@
_e3oHPCo00IZH_mRJV84o`03c_l700;o00Q@1e07ogj0OP;o00d?ool7oc8gof9ZHV[o00=Z00koJVYZ
oc8g<SLbofYRJP;o10P01?mZJVX2o`AK00?oEOl01?l00lico`03o`03JXeZ00;o00@bEOo>0ol00lko
cP02o`03Lomc00?o00Acog?>0ol00liccP03od/000?o0?l02`00050000?o00000`02o`033V_o00;o
01Q[3_l7o`Oo<_m@ogkoD0Q@ogiRO_m:FTX2o`06_ono<[oo0f801?mRHV82o`05<[lb_ol00f82o`06
cU_>o`Pb1?l2HP06of9nH_mn1?l00`i[o`02o`082?l8ZPRZoaX3o`03c_m@00;o00CZ<N[o17h01omQ
HV7oHF800_l01S7Z<NXao`=n00So_a^o6kooH@Co00<7Fol01?l013Mnof/2o`0;=olgOSMn=omnEGh0
0_l00f/>J`03o`03J`ko00;o00<>J`h01?l00f_oo`03odh000Co003o2P00054000?o00000P003_mc
ooo>Lomcoc7o<E/a0_l03kooJ_no6kooJQAZof9:HP03o`0D2508D?n6JXKoQVZ6oe08D0Q@ohH3o`03
3e_o00Co00QZQ_n6JXKoHPCo00?>Lol00ol00lkoo`02o`03D0Oo00?o00=cool00ol02e3o=c8gof9Z
HV[o00=Z00?oJ_l00U/01olg<SLbofX01?l220Co00=cc_l00ol04HeZofZ=JXeZofZ=J_mZSFZ=00;o
00=E<_l01Ol00lkoo`02o`03Looo00?o00=cool00_mD0003o`3o00X0001B00;o0`02o`03J`ko00;o
00T7o`MK1e_o25000_l050Q@253oOV9nodYJB_lboc:o<[oo0f800omRo`02o`04_c:o<P?o00<>Jol0
0_l3HP05of9RH_l00V83o`033V_o00?o00<>ool00_l00f/>J`03o`03J`ko00;o00<>Jol00ol01C7Z
<N[o00An00CoHF9Q0_l01PM;1ooZ<@Co00=[3_l00ol00f_oo`03o`05O_mn=gh00_l043Mn=ghgocMn
=gkoOSMnob/3o`03J`ko00?o00=n=gh00_l00`i[o`04oeP00_l:0000E0000ol0000200;o00=cool0
0_l00e/ao`02o`0?6koooa^o6kooJQAZof9:00;o00T8o`Q@253oQVX00ol01Licc_l800;o00=cog<0
0_l03WYnohIZQ_n6JXKoQ_l[1?l00lico`02o`04LlkocP?o00?>olh00_l017?>olh2o`0>OUGo<SLb
=omRJV9ZofX4o`9K1?l00g?>o`03o`03Llko00;o013>oon=JXgoSFZ=oe3oSFZ=0_l02VZ=JXgoSF[o
1oh5o`07SF[oJXeZS@06oeX00ol:0000E@000ol0000200;o00<>Jol00ol01@koD0Q@00;o00P8D0Q@
ogiROP?o00P>oono<[lb_`?o00E[of/>J`03o`03J`ko00;o00E^=fhgo`03HP04of9RHPCo00@>Jom[
0_l010ko3V/4o`033V_o00;o00=[3V/01?l02VYnJ_lajS7Z<Ol2OP?o00=[3V/00ol016/>o`h2o`04
J`ko3P;o02a[of_oO_mn=ghgocOo22_oOSOo2?lgOSMnogko:`P[ob_oOSMn=olgOSOo20;oF@04o`d0
001F0003o`0000<00_l00liccP02o`0<6klK_ono6klK_omZ0ol00lico`03o`03253o00;o00=cc_l0
1?l00lkoo`02o`0=OV[oNWijO_n6JXKoQP05o`03Llko00;o00?>Lol00ol00eDgE@03o`03c_oo00Co
00a@<OmEOUEnocLb=c83o`03c_o>00?o00C>olic0ol00g?>L`03o`03Llko00;o00MZSOn=JXeZ00;o
00i@1e3oSF[o1e3oSFZ=JP;o00?n1ol00ol028eZSF[oJXeZ0_mG00Co4@0005L00_l40003o`i[00?o
00<8D?l00ol00`Q@o`03o`03Jooo00;o00<>Jol00ol00`koo`02o`03J`ko00?o0]X02omQHV7oKSM^
=omR00Co00<>ooh01?l00eGZo`02o`06jUGoENYE1Ol00eGZE@02o`0;bUG:EOmnJWkojS400ol00`i[
o`03o`033V_o00?o00<>ool00ol00`koo`02o`0:O_mn=ghgocMn=`;o00@[22/80_l01R/8:omn=`?o
0148:ooo2?l8ocMn=gkoO_l[o`1D00?o5@0005T000?o00000P02o`03c_oo00;o00=cc_l00ol00g?o
o`02o`03cW?o00?o00?>ool00_l00g?>o`04o`0=Fonof[ooJWiZogYnNP03o`04cW?oL`?o00hgEOmE
=ol?ocME=eGoE@;o00lgEOmE=eGoFolaD35@ogh01Ol00g?oo`02o`03cW?o00?o00?>ool00_l00g?>
o`04o`0<ZUFZEOn=JXeZofZ=0_l010M@1e02o`031e0700Co00Acc_l70_l02OkooPOoJXeZS@02o`03
1ol005001?lH0000FP000ol0000200;o00=[3_l00ol00f_oo`02o`033V_o00?o00<>Jol00_l00f/>
J`03o`04JomKcP;o1=X01?mQHV44o`04Jom[3P?o00KZonYEjUD2o`06cU_>onYE1?l03>YEjUGoEOmK
cU_oE@Co00<>Jol00ol00`koo`03o`033_oo00;o00=[ool01?l03GiZO_lgOSMnoghgOSL00ol00`ko
2003o`033_l800;o00E[3_l>J`03o`0;1ooo22/8ocMn=gh00om>00Co700005/000?o00000`02o`03
Llko00;o00?>Llh00ol01<icog<2o`04cW?oL`;o00o>olkoFlkoc_oJ_mZoofX01?l00g?>o`03o`07
=eDgECOo=`03o`033e/?00Go00H?F`oo=eD3o`03F`oo00?o00?>Lol00ol00lkoo`02o`03Llic00?o
00=cc_l00_l01<koFe/2o`0;EGmEOomEZUFZofX00ol00lico`03o`03cW?o00;o00=ccW<01?l03<ko
ool7o`On1okoS@?o00?no`00B@04ob00001L00;o0`002?l>oom[3_l>0_l016_oJ`h4o`03J`ko00;o
00<>Jol00ol01lkocU_>omX01?l00f/>o`03o`07ENYEj_oZE@04o`033_oo00?o00H>oooocU/5o`03
J`ko00;o00<>Jol00ol00`i[o`02o`04J`ko3P?o00<>o`h00_l046_oJol7Bom;1omZOV[oOSL4o`03
Jooo00;o00<>Jol00ol00`koo`03o`033_oo00;o00M[oooo:`P[00Co00@>ooooA`04ob@0001N0004
o`0000;o00?>Lol00_l00g?>o`03o`03Llko00?o00=cool00_l00lico`02o`03cU_o00?o00=cc_l0
1?l01U_>FomE=`Co00?>ool00_l00g?>L`03o`03Llko00;o00G>LlkocP02o`03Lomc00;o00C>Lomc
0_l01<kocW<4o`03cW?o00;o00=cc_l00ol00e_oF`02F`03ogoo00Co00=cool00_l00lkoo`03o`03
c_oo00;o00=cool00ol00g?oo`02o`03c_oo00?o00?>Lol01?m500?o:00005l000?o00000P02o`03
3_oo00;o00=[3_l00ol00f_oo`02o`033V_o00?o00<>ool00_l00f/>o`03o`08Jooooe_>Flh3o`03
3V_o00;o00E[3V_oJ`02o`033_l>00;o00E[3_l>J`03o`03J`ko00?o00=[3_l00_l00`i[o`03o`03
3V_o00?o00<>ool00_l00f/>o`02o`03B`Oo00?o00<>Jol00ol00`koo`02o`03J`ko00?o00=[ool0
0_l00`i[3P03o`033V_o00;o00E[3V_oJ`04od@01?l[0000H0000ol0000200;o00=cc_l00ol00g?o
o`02o`03cW?o00?o00?>ool00_l00g?>L`03o`03Llko00;o00G>LlkoF`02o`03Lomc00;o00G>Lomc
cP03o`03cW?o00?o00?>Lol00ol00lkoo`02o`03Llko00?o00=cool00_l00lico`03o`03c_oo00;o
00=cc_l00ol00g?oo`02o`03cW?o00?o00?>Lol00_l00g?>o`03o`03Llko00;o00C>Lomc0ol00g?o
L`02o`05c_o>Llh00ol00fYRo`1100Co;`00064000?o00000`02o`03Jooo00;o00<>J`h00ol00`i[
o`02o`05J`i[of/00_l00`ko3P02o`05J`ko3V/00ol00f/>o`03o`03J`ko00?o00=[ool00_l00nYE
jP03o`033_oo00;o00=[3_l00ol00f_oo`02o`033_oo00?o00<>ool00_l00f_oo`03o`03J`ko00;o
00<>Jol00ol010i[of/2o`033_l>00;o00A[3_l>0_l016_oJ`h4o`03J`ko00;o00<>Jol01?l01F;o
HV;o03h01?lc0000HP02o`@00_l01Licc_o>00;o00=cog<00_l01Licog?>00?o00?>Lol00ol00lic
o`03o`03c_oo00;o00=cc_l00ol00g?oo`02o`05ECOo=eD00_l01@oooomc00Go00=cool00_l00lko
o`02o`03Llic00?o00=cc_l00_l01Licc_o>00;o00=cog<00_l01Licog?>00?o00?>Lol00_l00g?>
L`03o`03Llko00?o00=cc_l00ol00g?oo`02o`09<V[oHVYRof;o03/01?lg0000I0000ol000020003
o`i[00?o00=[3_l00ol00f/>o`03o`03Jooo00;o00<>Jol00ol00`koo`02o`03J`ko00?o00=[ool0
0_l01nYEoeGZENX00_l00e_>o`04o`033V/>00?o00<>Jol00_l01F/>Jom[00;o00<>o`h00_l01F/>
o`i[00?o00=[3_l00_l00`i[3P04o`03Jooo00;o00<>ool00ol00`koo`02o`03Jooo00?o00=[ool0
0_l03GkoOS9n<_mROV;oH_l0=`04oc/0001U0003o`0000800_l00lkoo`02o`03Llko00?o00=cool0
0_l00lico`03o`03c_oo00;o00=cool00ol00g?oo`02o`09ECOo=eDgEOmE00Co00P?ooo>LlkocP;o
00=cog<00_l01Licog?>00?o00?>Lol00_l00g?>L`04o`03c_oo00;o00=cool00ol00g?oo`02o`03
c_oo00;o00=cc_l00ol00g?oo`02o`03cW?o00Co00en<Whboc9Z<V[oHVYR00;o=@03ocl0001V0003
o`0000800_l00f/>o`03o`03Jooo00;o00<>Jol00ol00`koo`02o`03Jooo00;o00<>J`h00ol02NYE
oeGZEN[ojP04o`03J`ko00;o00A@o`i[0ol00f/>o`02o`033V/>00Co00=[ool00_l00`koo`03o`03
3_oo00;o00=[ool00_l00`i[o`03o`033_oo00;o00=[3_l00ol00f_oo`02o`033_oo00Co00mROV9n
ogiEOUGo<Whbof800olb00Co@P0006L00_l400;o00=cool00_l00lico`03o`03c_oo00;o00<gEOl0
0_l01EDgEOo>00;o00PgocME=eGoE@Co00=cc_l01?l00`ono`03o`03c_oo00;o00=cool00ol00g?o
o`02o`03c_oo00;o00=cc_l00ol00g?oo`02o`03cW?o00?o00?>ool00_l00g?oo`03o`03Llko00;o
00?>Lol00_l04HeZoomQof5ZHF[o<WhbO_mZ00Co<@04odH0001Y0003o`0000800_l00`i[3P03o`03
3V_o00;o00aEj_oZEOmKoeGZENX2o`06ENYEj_oZ1?l00f/>o`03o`03Jooo00Co00<>ool00_l00f_o
o`02o`033V_o00?o00<>ool00_l00f/>o`03o`03Jooo00;o00<>ool00ol00`i[o`02o`03J`ko00;o
00D>J`ko3P02o`03Jom[00?o00mn=gkoHWiRof9nHWkoOUD01?la00CoBP0006X000?o00000P001oo>
oolgog<00_l01UGoECME=`;o00EKcU_oE@02o`04c_lgE@Co00=cc_l00ol00g?>o`02o`04c_oocP?o
00=cool00_l00lico`03o`03c_oo00;o00=cc_l00ol00g?oo`02o`03cW?o00;o00EccW?oL`02o`03
c_o>00;o00Ecog?>L`03o`03Llko00;o00D7D?n=JP02o`09HFYQJ_mZHFYQ00;o<@04odh0001[0003
o`00008000CoENYE0_l01^YEjUGoE@Co00?>Fol00_l00e_>F`03o`03J`i[00?o00A[3_l>0_l01V_o
JomKcPGo00<>Jol00ol00`koo`02o`03J`ko00?o00=[3_l00_l010i[of/2o`053V_oJ`h00ol00`i[
o`02o`03J`ko00Co00<>ool01?l04R/8:omn=olbogiRO_mnHWiRobl00omB0000K002o`8000Wo=ooo
FomE=eD00ol00liccP03o`04cW?ocP;o00C>Lomc0_l01<kocW<3o`03Llko00?o00K>ooo>Llh3o`03
cW?o00;o00Acc_o>0_l017?>olh2o`04LomccP?o00?>Llh01?l00g?oo`02o`03c_oo00;o00=cc_l0
1?l00fZ=JP02o`04D0M@1`;o00]@O_mZHF[oJV5Zo`0/00CoE@0006h000So003ocU_>F`?o00A[3_l>
0_l016_oJ`h4o`03J`ko00;o00<>Jol00ol00`koo`02o`03J`ko00;o00<>o`h00_l00f_oJ`02o`04
3_l>J`Co00<>Jol00_l00f/>o`03o`03Jooo00?o00=[ool00_l00`koo`02o`03J`ko00Co00DgOSOo
=`04o`03:`So00;o00`b^S;oOV9nogiRO_lX00CoF@0006l000Ko003ocU/3o`03cW?o00;o00=cc_l0
0ol00g?>o`03o`03Looo00;o00?>ool00_l00g?>o`04o`03cW?o00;o00=cc_l00_l00lico`03o`03
cW?o00?o00?>ool00_l00g?oo`02o`03cW?o00?o00?>ool00_l00g?oo`04o`051e07ofX01?l00g?>
o`03o`0>EOm@OU1nofYQJ_mZHOlU00CoG@00070000?o00000_l00f_oo`02o`033_oo00;o00=[3_l0
0ol00f_oo`02o`033_oo00;o00=[3_l01?l00e3no`03o`033_oo00;o00=[ool00_l00`i[o`03o`03
3_oo00;o00=[ool00_l00`i[o`03o`033_oo00;o00=[ool00_l00`i[o`02o`03:`So00?o00=[3_l0
1Ol047iQO_nj<[XbogiRO_mnH_lQ00CoH@0007400_l0103oolh4o`03Llko00?o00=cool00_l00lic
o`02o`03Llko00?o00=cool01?l00lkoo`02o`03Looo00;o00?>Lol00ol00lkoo`02o`03Looo00;o
00?>Lol00ol00eDgo`02o`03Looo00;o00?>Lol00ol00lico`02o`04LlkocP;o00Acc_o>0_l03EEZ
EOm@OU1nofYQJV400_lO00?oI@0007<000Ko0?ooJ`h4o`03Jooo00;o00<>Jol00ol00`koo`02o`03
Jooo00Co00?ZEOl00_l00f_oo`02o`033V_o00?o00<>ool00_l00eGZo`02o`033V_o00?o00GZEOmE
jP05o`033V/>00?o00@>Jom[0_l010ko3V/4o`033V_o00;o00mnogiQOV7o<[XbogiROV800_lK00Co
J00007@000?o00000_l00g?oo`02o`03cW?o00?o00?>ool00_l00g?>o`02o`07cW?oc_lgE@05o`03
cW?o00?o00?>ool00_l023MEoeDgo`mK0ol01eDgocME=eD00ol01Licc_o>00;o00@gog?>0ol00lic
o`03o`03cW?o00Co011EJUEZofYEJ_mnD7i@of5Z0_lH00CoK00007D000?o00000_l00`i[o`03o`03
3V_o00;o00A[3_l>0_l026/>o`kocU_>0ol00`i[o`03o`033_oo00;o00MEj_oZENYE00;o00_>FomK
oeGZEN[ojP03o`043_l>J`?o00=EjUD00ol00eGZo`02o`033_oo00Co015nHGkoOV5nHOmQOV7o<[Xb
^P03oaH01?m`0000MP001?l00002o`04cW?oL`;o00C>olic1?l00lico`02o`03cU_o00Ko00=E=ol0
0_l02CMEoeDgECOo=`04o`07FomK3e_oE@05o`03cW?o00?o00AE=olg0_l00e_oE@06o`0ED?n=ogoo
EFYEJ_mZEF[oJUEZogi@00?o5004og@0001g00;o00@0of/>1?l00f/>o`02o`033V_o00?o00<>ool0
1Ol03^YEoeGZolkojUGZEOmE1?l00`i[o`02o`03Flko00Go00=cool00_l01NYEoeGZ00?o00?>Flh0
1?l01F_o:`P[00;o00d7<POoHGiQof5nHOmQ00Go4`04ogP0001i0006o`3oog?>1?l00g?oo`02o`03
c_oo00;o00Ycolkoc_lgECME0_l01LiKc_lg00Co00?>Lol00ol00lkoo`02o`03Looo00Co00IE=olg
ECL3o`04LlkoF`?o00HUoooo1e03o`0:OoMomomZEF[oJPCo5@03og`0001j0003o`0000;o00=[ool0
0_l00`koo`02o`03J`ko00;o00O>oliKc_oZ00?o00?>Fol00ol00`i[o`03o`033_oo00;o00=[ool0
1?l01nYEoeGZENX00ol010ko3V/3o`06JooooeDa0ol02C5Eoc87<POoH@04oaD01?mo0000N`000ol0
0002o`03c_oo00;o00=cc_l00ol01W?oooo>F`Co00=cc_l00_l00lico`03o`03c_oo00;o00=cc_l0
1?l02EDgocME=eGoE@03o`03cW?o00?o017>ooooEOmE<_l?oc9E<UGom`04oaD01?n30000O002o`05
0?ooJ`h01?l00f_oo`02o`033_oo00;o00=[3_l00ol00f_oo`02o`033V_o00;o00A[3_l>0ol02NYE
oeGZEN[ojP04o`03Jooo00;o00<>ool00ol0135E<ED2o`05cU_>oc401?lE00CoQ`0007h000?o0000
0_l00g?oo`02o`03c_oo00;o00=cc_l00ol00g?>o`02o`04cW?oL`;o00C>olic0ol02<ko=eDgEOmE
1?l00g?oo`02o`03c_oo00?o00IE<UDboc83o`033e_o00Co5004oh/0001o0003o`0000;o00<>Jol0
0_l00f/>J`03o`04J`ko3P;o00A[of/>0ol00`i[o`03o`073_o>FlkojP04o`03Jooo00;o00<>ool0
0_l01f_oFliKoeD01?l00`koo`02o`04Jooooa800on?0000P0001?l00002o`04cW?oL`;o00C>olic
0ol00g?>o`03o`03Llko00;o00?>Lol00_l00liKo`03o`03Looo00;o00?>ool00_l00g?>o`02o`03
F`oo00?o00?>ool00_l00g?oo`03oa001?nB0000P@02o`040?m[3P?o00<>Jol00ol00`koo`02o`03
J`ko00?o00=[ool00_l00`koo`02o`03Jooo00;o00<>Jol00_l00f/>o`03o`03Jooo00;o00<>ool0
0_l00f_oo`02o`033_oo00h01?nF0000P`001Ol0oomc00Co00?>Lol00_l00g?>o`03o`03Looo00;o
00?>ool00_l00g?oo`02o`03cW?o00?o00?>ool00_l00g?oo`02o`03c_oo00;o00=cool00_l00lic
o`02o``01?nJ0000Q0001_l0ool>J`Co00<>ool00_l00f_oo`02o`033_oo00;o00=[3_l00_l00`i[
o`03o`033_oo00;o00=[ool00_l00`koo`02o`03Jooo00;o00<>Jol01?l:00CoWP0008D000?o0000
0_l00lkoo`02o`03Looo00;o00?>ool00_l00g?>o`03o`03Looo00;o00?>ool00_l00g?oo`02o`03
c_oo00;o00=cc_l00_l00liccP03o`04cW?oo`L01?nR0000QP02o`040?ooJ`Co00<>Jol00_l00f/>
o`03o`03Jooo00;o00<>ool00_l00f_oo`02o`033_oo00;o00=[3_l00ol016/>o`h2o`04Jom[3P?o
1003ojH000280006o`3oolic1?l00lkoo`02o`03Looo00;o00?>ool00_l00g?oo`02o`03cW?o00;o
00=ccW<00ol01G?>olic00?o00=cc_l00ol300CoZ@0008T000?o00000_l00`koo`02o`03Jooo00;o
00<>ool00_l00f/>o`02o`033V_o00?o00@>Jom[0_l010ko3V/4o`033_oo00;o0`04ojd0002:0003
o`0000;o00=cc_l00_l00lico`02o`03Llko00?o00=cool00_l01Licog?>00?o00?>Lol00ol00lko
o`02o`<01?na0000R`001?l00002o`03Jooo00;o00<>ool00_l00f_oo`02o`053V_oJ`h01?l00f_o
o`02o`033_oo00;o0`04okD0002<00;o0P02o`03c_oo00;o00=cc_l00_l01Licog?>00Co00=cool0
0_l00lkoo`02o`@00oni0000SP000ol00002o`04J`ko3P;o00A[of/>1?l00f/>o`02o`033V_o00;o
1004ok`0002?0005o`3ocW<01?l00lico`02o`03Llko00?o00=cool00_l300Co`000090000Ko0?oo
3V/4o`033_oo00;o00=[ool00_l300Coa00009400_l0103oolh4o`03Looo00;o0`04olP0002C0005
o`3oof/01?l400?oc00009@000Co0?oo1004oll0002E00;o00<0ool00_oC0000UP02omL0003o0700
003o0700003o0700003o0700003o0700003o0700003o0700003o07000000\
\>"],
  ImageRangeCache->{{{0, 366}, {300, 0}} -> {-0.0413401, 0.026403, 0.0027867, \
0.0027867}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
fitnessChart3D[Take[allFitnessesSorted,40],
  GenIndices -> {10,20,30,40}
];\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.068667 0.026717 1.068667 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 39)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .07579 .18311 -0.06628 1 Msboxa
[(20)] .29254 .12405 -0.03525 1 Msboxa
[(40)] .54186 .05614 .00111 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(10)] .78558 .10795 -1 .2444 Msboxa
[(20)] .84786 .17982 -1 .22195 Msboxa
[(30)] .90123 .24142 -1 .20328 Msboxa
[(40)] .94747 .29479 -1 .1875 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-20)] .05664 .24611 1 -0.25735 Msboxa
[(0)] .04388 .43446 1 -0.19718 Msboxa
[(20)] .03044 .63328 1 -0.13312 Msboxa
[(40)] .0163 .84345 1 -0.06478 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 39)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.0749 .19643 m
.07446 .2031 L
s
P
[(0)] .07579 .18311 -0.06628 1 Mshowa
p
.002 w
.29207 .1374 m
.29183 .14408 L
s
P
[(20)] .29254 .12405 -0.03525 1 Mshowa
p
.002 w
.54188 .0695 m
.54188 .07618 L
s
P
[(40)] .54186 .05614 .00111 1 Mshowa
p
.001 w
.11604 .18525 m
.11579 .18925 L
s
P
p
.001 w
.15827 .17377 m
.15805 .17777 L
s
P
p
.001 w
.20166 .16198 m
.20146 .16598 L
s
P
p
.001 w
.24624 .14986 m
.24607 .15386 L
s
P
p
.001 w
.3392 .12459 m
.33908 .1286 L
s
P
p
.001 w
.38768 .11141 m
.38759 .11542 L
s
P
p
.001 w
.43758 .09785 m
.43752 .10186 L
s
P
p
.001 w
.48895 .08388 m
.48893 .08789 L
s
P
p
.001 w
.59641 .05467 m
.59645 .05868 L
s
P
p
.001 w
.65264 .03939 m
.65271 .0434 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.7726 .11112 m
.76611 .11271 L
s
P
[(10)] .78558 .10795 -1 .2444 Mshowa
p
.002 w
.83482 .18272 m
.8283 .18417 L
s
P
[(20)] .84786 .17982 -1 .22195 Mshowa
p
.002 w
.88814 .24408 m
.88159 .24541 L
s
P
[(30)] .90123 .24142 -1 .20328 Mshowa
p
.002 w
.93434 .29725 m
.92778 .29848 L
s
P
[(40)] .94747 .29479 -1 .1875 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06958 .24278 m
.07604 .24112 L
s
P
[(-20)] .05664 .24611 1 -0.25735 Mshowa
p
.002 w
.05698 .43188 m
.06353 .43059 L
s
P
[(0)] .04388 .43446 1 -0.19718 Mshowa
p
.002 w
.04368 .63151 m
.05031 .63063 L
s
P
[(20)] .03044 .63328 1 -0.13312 Mshowa
p
.002 w
.02963 .84259 m
.03629 .84216 L
s
P
[(40)] .0163 .84345 1 -0.06478 Mshowa
p
.001 w
.06711 .2798 m
.071 .27884 L
s
P
p
.001 w
.06462 .31721 m
.06852 .3163 L
s
P
p
.001 w
.0621 .35502 m
.06601 .35416 L
s
P
p
.001 w
.05955 .39324 m
.06348 .39242 L
s
P
p
.001 w
.05438 .47094 m
.05832 .47021 L
s
P
p
.001 w
.05175 .51042 m
.0557 .50974 L
s
P
p
.001 w
.04909 .55034 m
.05305 .54971 L
s
P
p
.001 w
.0464 .5907 m
.05037 .59012 L
s
P
p
.001 w
.04094 .67278 m
.04491 .67231 L
s
P
p
.001 w
.03816 .71452 m
.04214 .71409 L
s
P
p
.001 w
.03534 .75672 m
.03934 .75635 L
s
P
p
.001 w
.0325 .79941 m
.0365 .7991 L
s
P
p
.001 w
.07202 .20615 m
.07589 .20511 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06958 .24278 m
.429 .43263 L
s
P
p
.4 g
.002 w
.05698 .43188 m
.42684 .57972 L
s
P
p
.4 g
.002 w
.04368 .63151 m
.42459 .73297 L
s
P
p
.4 g
.002 w
.02963 .84259 m
.42224 .89279 L
s
P
p
.4 g
.002 w
.07234 .1969 m
.02639 .88623 L
s
P
p
.4 g
.002 w
.17852 .25632 m
.14586 .89812 L
s
P
p
.4 g
.002 w
.27073 .30792 m
.24826 .90831 L
s
P
p
.4 g
.002 w
.35157 .35315 m
.33703 .91714 L
s
P
p
.4 g
.002 w
.423 .39313 m
.4147 .92487 L
s
P
p
.4 g
.002 w
.43147 .39642 m
.42384 .9255 L
s
P
p
.4 g
.002 w
.61322 .36259 m
.61941 .91897 L
s
P
p
.4 g
.002 w
.8151 .32502 m
.83844 .91166 L
s
P
p
.4 g
.002 w
.429 .43263 m
.94085 .34267 L
s
P
p
.4 g
.002 w
.42684 .57972 m
.95046 .5099 L
s
P
p
.4 g
.002 w
.42459 .73297 m
.96053 .68523 L
s
P
p
.4 g
.002 w
.42224 .89279 m
.97111 .86925 L
s
P
P
p
.42642 .42001 m .44195 .42208 L .43318 .42364 L 1 0 0 r
F
P
p
.43523 .41843 m .45077 .42051 L .44195 .42208 L 1 0 .07 r
F
P
p
.42642 .42001 m .43523 .41843 L .44195 .42208 L 1 0 0 r
F
P
p
.44408 .41684 m .45963 .41893 L .45077 .42051 L 1 0 .488 r
F
P
p
.43523 .41843 m .44408 .41684 L .45077 .42051 L 1 0 .07 r
F
P
p
.41958 .41633 m .43523 .41843 L .42642 .42001 L 1 0 .07 r
F
P
p
.45298 .41524 m .46854 .41734 L .45963 .41893 L .849 0 1 r
F
P
p
.44408 .41684 m .45298 .41524 L .45963 .41893 L 1 0 .488 r
F
P
p
.42842 .41473 m .44408 .41684 L .43523 .41843 L 1 0 .488 r
F
P
p
.41958 .41633 m .42842 .41473 L .43523 .41843 L 1 0 .07 r
F
P
p
.46192 .41363 m .47749 .41575 L .46854 .41734 L .5 0 1 r
F
P
p
.45298 .41524 m .46192 .41363 L .46854 .41734 L .849 0 1 r
F
P
p
.43731 .41312 m .45298 .41524 L .44408 .41684 L .884 0 1 r
F
P
p
.42842 .41473 m .43731 .41312 L .44408 .41684 L 1 0 .488 r
F
P
p
.41266 .4126 m .42842 .41473 L .41958 .41633 L 1 0 .767 r
F
P
p
.47091 .41202 m .48649 .41415 L .47749 .41575 L .465 0 1 r
F
P
p
.46192 .41363 m .47091 .41202 L .47749 .41575 L .5 0 1 r
F
P
p
.44624 .4115 m .46192 .41363 L .45298 .41524 L .57 0 1 r
F
P
p
.43731 .41312 m .44624 .4115 L .45298 .41524 L .884 0 1 r
F
P
p
.42154 .41098 m .43731 .41312 L .42842 .41473 L .884 0 1 r
F
P
p
.41266 .4126 m .42154 .41098 L .42842 .41473 L 1 0 .767 r
F
P
p
.47994 .4104 m .49553 .41254 L .48649 .41415 L .465 0 1 r
F
P
p
.47091 .41202 m .47994 .4104 L .48649 .41415 L .465 0 1 r
F
P
p
.45522 .40988 m .47091 .41202 L .46192 .41363 L .5 0 1 r
F
P
p
.44624 .4115 m .45522 .40988 L .46192 .41363 L .57 0 1 r
F
P
p
.43046 .40936 m .44624 .4115 L .43731 .41312 L .605 0 1 r
F
P
p
.42154 .41098 m .43046 .40936 L .43731 .41312 L .884 0 1 r
F
P
p
.40566 .40883 m .42154 .41098 L .41266 .4126 L .605 0 1 r
F
P
p
.48902 .40877 m .50462 .41092 L .49553 .41254 L .379 0 1 r
F
P
p
.47994 .4104 m .48902 .40877 L .49553 .41254 L .465 0 1 r
F
P
p
.46424 .40824 m .47994 .4104 L .47091 .41202 L .465 0 1 r
F
P
p
.45522 .40988 m .46424 .40824 L .47091 .41202 L .5 0 1 r
F
P
p
.43943 .40772 m .45522 .40988 L .44624 .4115 L .605 0 1 r
F
P
p
.43046 .40936 m .43943 .40772 L .44624 .4115 L .605 0 1 r
F
P
p
.41457 .4072 m .43046 .40936 L .42154 .41098 L .57 0 1 r
F
P
p
.40566 .40883 m .41457 .4072 L .42154 .41098 L .605 0 1 r
F
P
p
.49815 .40713 m .51376 .40929 L .50462 .41092 L .208 0 1 r
F
P
p
.48902 .40877 m .49815 .40713 L .50462 .41092 L .379 0 1 r
F
P
p
.47332 .4066 m .48902 .40877 L .47994 .4104 L .465 0 1 r
F
P
p
.46424 .40824 m .47332 .4066 L .47994 .4104 L .465 0 1 r
F
P
p
.44844 .40608 m .46424 .40824 L .45522 .40988 L .535 0 1 r
F
P
p
.43943 .40772 m .44844 .40608 L .45522 .40988 L .605 0 1 r
F
P
p
.42353 .40555 m .43943 .40772 L .43046 .40936 L .535 0 1 r
F
P
p
.41457 .4072 m .42353 .40555 L .43046 .40936 L .57 0 1 r
F
P
p
.50732 .40548 m .52294 .40765 L .51376 .40929 L .122 0 1 r
F
P
p
.49815 .40713 m .50732 .40548 L .51376 .40929 L .208 0 1 r
F
P
p
.39857 .40502 m .41457 .4072 L .40566 .40883 L .57 0 1 r
F
P
p
.48243 .40495 m .49815 .40713 L .48902 .40877 L .379 0 1 r
F
P
p
.47332 .4066 m .48243 .40495 L .48902 .40877 L .465 0 1 r
F
P
p
.4575 .40442 m .47332 .4066 L .46424 .40824 L .465 0 1 r
F
P
p
.44844 .40608 m .4575 .40442 L .46424 .40824 L .535 0 1 r
F
P
p
.43253 .40389 m .44844 .40608 L .43943 .40772 L .535 0 1 r
F
P
p
.42353 .40555 m .43253 .40389 L .43943 .40772 L .535 0 1 r
F
P
p
.51655 .40382 m .53217 .40601 L .52294 .40765 L .122 0 1 r
F
P
p
.50732 .40548 m .51655 .40382 L .52294 .40765 L .122 0 1 r
F
P
p
.40751 .40336 m .42353 .40555 L .41457 .4072 L .5 0 1 r
F
P
p
.39857 .40502 m .40751 .40336 L .41457 .4072 L .57 0 1 r
F
P
p
.4916 .40329 m .50732 .40548 L .49815 .40713 L .208 0 1 r
F
P
p
.48243 .40495 m .4916 .40329 L .49815 .40713 L .379 0 1 r
F
P
p
.46661 .40276 m .48243 .40495 L .47332 .4066 L .465 0 1 r
F
P
p
.4575 .40442 m .46661 .40276 L .47332 .4066 L .465 0 1 r
F
P
p
.44158 .40223 m .4575 .40442 L .44844 .40608 L .5 0 1 r
F
P
p
.43253 .40389 m .44158 .40223 L .44844 .40608 L .535 0 1 r
F
P
p
.52582 .40216 m .54145 .40435 L .53217 .40601 L .122 0 1 r
F
P
p
.51655 .40382 m .52582 .40216 L .53217 .40601 L .122 0 1 r
F
P
p
.41651 .4017 m .43253 .40389 L .42353 .40555 L .465 0 1 r
F
P
p
.40751 .40336 m .41651 .4017 L .42353 .40555 L .5 0 1 r
F
P
p
.50081 .40163 m .51655 .40382 L .50732 .40548 L .122 0 1 r
F
P
p
.4916 .40329 m .50081 .40163 L .50732 .40548 L .208 0 1 r
F
P
p
.39139 .40116 m .40751 .40336 L .39857 .40502 L .5 0 1 r
F
P
p
.47577 .40109 m .4916 .40329 L .48243 .40495 L .465 0 1 r
F
P
p
.46661 .40276 m .47577 .40109 L .48243 .40495 L .465 0 1 r
F
P
p
.45068 .40056 m .46661 .40276 L .4575 .40442 L .465 0 1 r
F
P
p
.44158 .40223 m .45068 .40056 L .4575 .40442 L .5 0 1 r
F
P
p
.53514 .40049 m .55078 .40269 L .54145 .40435 L .045 0 1 r
F
P
p
.52582 .40216 m .53514 .40049 L .54145 .40435 L .122 0 1 r
F
P
p
.42555 .40002 m .44158 .40223 L .43253 .40389 L .465 0 1 r
F
P
p
.41651 .4017 m .42555 .40002 L .43253 .40389 L .465 0 1 r
F
P
p
.51008 .39995 m .52582 .40216 L .51655 .40382 L .122 0 1 r
F
P
p
.50081 .40163 m .51008 .39995 L .51655 .40382 L .122 0 1 r
F
P
p
.40037 .39948 m .41651 .4017 L .40751 .40336 L .465 0 1 r
F
P
p
.39139 .40116 m .40037 .39948 L .40751 .40336 L .5 0 1 r
F
P
p
.48497 .39941 m .50081 .40163 L .4916 .40329 L .293 0 1 r
F
P
p
.47577 .40109 m .48497 .39941 L .4916 .40329 L .465 0 1 r
F
P
p
.45982 .39887 m .47577 .40109 L .46661 .40276 L .465 0 1 r
F
P
p
.45068 .40056 m .45982 .39887 L .46661 .40276 L .465 0 1 r
F
P
p
.54451 .3988 m .56016 .40102 L .55078 .40269 L 0 .166 1 r
F
P
p
.53514 .40049 m .54451 .3988 L .55078 .40269 L .045 0 1 r
F
P
p
.43464 .39834 m .45068 .40056 L .44158 .40223 L .465 0 1 r
F
P
p
.42555 .40002 m .43464 .39834 L .44158 .40223 L .465 0 1 r
F
P
p
.51939 .39827 m .53514 .40049 L .52582 .40216 L .122 0 1 r
F
P
p
.51008 .39995 m .51939 .39827 L .52582 .40216 L .122 0 1 r
F
P
p
.4094 .39779 m .42555 .40002 L .41651 .4017 L .465 0 1 r
F
P
p
.40037 .39948 m .4094 .39779 L .41651 .4017 L .465 0 1 r
F
P
p
.49422 .39772 m .51008 .39995 L .50081 .40163 L .122 0 1 r
F
P
p
.48497 .39941 m .49422 .39772 L .50081 .40163 L .293 0 1 r
F
P
p
.38413 .39725 m .40037 .39948 L .39139 .40116 L .465 0 1 r
F
P
p
.46902 .39718 m .48497 .39941 L .47577 .40109 L .465 0 1 r
F
P
p
.45982 .39887 m .46902 .39718 L .47577 .40109 L .465 0 1 r
F
P
p
.55393 .39711 m .56959 .39934 L .56016 .40102 L 0 .364 1 r
F
P
p
.54451 .3988 m .55393 .39711 L .56016 .40102 L 0 .166 1 r
F
P
p
.44377 .39664 m .45982 .39887 L .45068 .40056 L .465 0 1 r
F
P
p
.43464 .39834 m .44377 .39664 L .45068 .40056 L .465 0 1 r
F
P
p
.52875 .39657 m .54451 .3988 L .53514 .40049 L .122 0 1 r
F
P
p
.51939 .39827 m .52875 .39657 L .53514 .40049 L .122 0 1 r
F
P
p
.41848 .3961 m .43464 .39834 L .42555 .40002 L .465 0 1 r
F
P
p
.4094 .39779 m .41848 .3961 L .42555 .40002 L .465 0 1 r
F
P
p
.50353 .39603 m .51939 .39827 L .51008 .39995 L .122 0 1 r
F
P
p
.49422 .39772 m .50353 .39603 L .51008 .39995 L .122 0 1 r
F
P
p
.39315 .39555 m .4094 .39779 L .40037 .39948 L .465 0 1 r
F
P
p
.38413 .39725 m .39315 .39555 L .40037 .39948 L .465 0 1 r
F
P
p
.47826 .39548 m .49422 .39772 L .48497 .39941 L .379 0 1 r
F
P
p
.46902 .39718 m .47826 .39548 L .48497 .39941 L .465 0 1 r
F
P
p
.56339 .39541 m .57906 .39765 L .56959 .39934 L 0 .428 1 r
F
P
p
.55393 .39711 m .56339 .39541 L .56959 .39934 L 0 .364 1 r
F
P
p
.45296 .39494 m .46902 .39718 L .45982 .39887 L .465 0 1 r
F
P
p
.44377 .39664 m .45296 .39494 L .45982 .39887 L .465 0 1 r
F
P
p
.53816 .39487 m .55393 .39711 L .54451 .3988 L 0 .089 1 r
F
P
p
.52875 .39657 m .53816 .39487 L .54451 .3988 L .122 0 1 r
F
P
p
.42761 .39439 m .44377 .39664 L .43464 .39834 L .465 0 1 r
F
P
p
.41848 .3961 m .42761 .39439 L .43464 .39834 L .465 0 1 r
F
P
p
.51288 .39432 m .52875 .39657 L .51939 .39827 L .122 0 1 r
F
P
p
.50353 .39603 m .51288 .39432 L .51939 .39827 L .122 0 1 r
F
P
p
.40221 .39385 m .41848 .3961 L .4094 .39779 L .465 0 1 r
F
P
p
.39315 .39555 m .40221 .39385 L .4094 .39779 L .465 0 1 r
F
P
p
.48755 .39378 m .50353 .39603 L .49422 .39772 L .293 0 1 r
F
P
p
.47826 .39548 m .48755 .39378 L .49422 .39772 L .379 0 1 r
F
P
p
.57291 .3937 m .58859 .39596 L .57906 .39765 L 0 .428 1 r
F
P
p
.56339 .39541 m .57291 .3937 L .57906 .39765 L 0 .428 1 r
F
P
p
.37678 .3933 m .39315 .39555 L .38413 .39725 L .465 0 1 r
F
P
p
.46219 .39323 m .47826 .39548 L .46902 .39718 L .465 0 1 r
F
P
p
.45296 .39494 m .46219 .39323 L .46902 .39718 L .465 0 1 r
F
P
p
.54762 .39316 m .56339 .39541 L .55393 .39711 L 0 .364 1 r
F
P
p
.53816 .39487 m .54762 .39316 L .55393 .39711 L 0 .089 1 r
F
P
p
.43678 .39268 m .45296 .39494 L .44377 .39664 L .465 0 1 r
F
P
p
.42761 .39439 m .43678 .39268 L .44377 .39664 L .465 0 1 r
F
P
p
.52228 .39261 m .53816 .39487 L .52875 .39657 L 0 .016 1 r
F
P
p
.51288 .39432 m .52228 .39261 L .52875 .39657 L .122 0 1 r
F
P
p
.41133 .39213 m .42761 .39439 L .41848 .3961 L .465 0 1 r
F
P
p
.40221 .39385 m .41133 .39213 L .41848 .3961 L .465 0 1 r
F
P
p
.49689 .39206 m .51288 .39432 L .50353 .39603 L .293 0 1 r
F
P
p
.48755 .39378 m .49689 .39206 L .50353 .39603 L .293 0 1 r
F
P
p
.58248 .39199 m .59817 .39425 L .58859 .39596 L 0 .428 1 r
F
P
p
.57291 .3937 m .58248 .39199 L .58859 .39596 L 0 .428 1 r
F
P
p
.38583 .39158 m .40221 .39385 L .39315 .39555 L .465 0 1 r
F
P
p
.37678 .3933 m .38583 .39158 L .39315 .39555 L .465 0 1 r
F
P
p
.47147 .39151 m .48755 .39378 L .47826 .39548 L .465 0 1 r
F
P
p
.46219 .39323 m .47147 .39151 L .47826 .39548 L .465 0 1 r
F
P
p
.55713 .39144 m .57291 .3937 L .56339 .39541 L 0 .428 1 r
F
P
p
.54762 .39316 m .55713 .39144 L .56339 .39541 L 0 .364 1 r
F
P
p
.446 .39096 m .46219 .39323 L .45296 .39494 L .465 0 1 r
F
P
p
.43678 .39268 m .446 .39096 L .45296 .39494 L .465 0 1 r
F
P
p
.53173 .39088 m .54762 .39316 L .53816 .39487 L 0 .291 1 r
F
P
p
.52228 .39261 m .53173 .39088 L .53816 .39487 L 0 .016 1 r
F
P
p
.42049 .3904 m .43678 .39268 L .42761 .39439 L .465 0 1 r
F
P
p
.41133 .39213 m .42049 .3904 L .42761 .39439 L .465 0 1 r
F
P
p
.50629 .39033 m .52228 .39261 L .51288 .39432 L .208 0 1 r
F
P
p
.49689 .39206 m .50629 .39033 L .51288 .39432 L .293 0 1 r
F
P
p
.5921 .39026 m .60779 .39254 L .59817 .39425 L 0 .484 1 r
F
P
p
.58248 .39199 m .5921 .39026 L .59817 .39425 L 0 .428 1 r
F
P
p
.39493 .38985 m .41133 .39213 L .40221 .39385 L .465 0 1 r
F
P
p
.38583 .39158 m .39493 .38985 L .40221 .39385 L .465 0 1 r
F
P
p
.4808 .38978 m .49689 .39206 L .48755 .39378 L .465 0 1 r
F
P
p
.47147 .39151 m .4808 .38978 L .48755 .39378 L .465 0 1 r
F
P
p
.56669 .38971 m .58248 .39199 L .57291 .3937 L 0 .428 1 r
F
P
p
.55713 .39144 m .56669 .38971 L .57291 .3937 L 0 .428 1 r
F
P
p
.36933 .38929 m .38583 .39158 L .37678 .3933 L .465 0 1 r
F
P
p
.45527 .38922 m .47147 .39151 L .46219 .39323 L .465 0 1 r
F
P
p
.446 .39096 m .45527 .38922 L .46219 .39323 L .465 0 1 r
F
P
p
.54123 .38915 m .55713 .39144 L .54762 .39316 L 0 .428 1 r
F
P
p
.53173 .39088 m .54123 .38915 L .54762 .39316 L 0 .291 1 r
F
P
p
.4297 .38867 m .446 .39096 L .43678 .39268 L .465 0 1 r
F
P
p
.42049 .3904 m .4297 .38867 L .43678 .39268 L .465 0 1 r
F
P
p
.51573 .38859 m .53173 .39088 L .52228 .39261 L 0 .016 1 r
F
P
p
.50629 .39033 m .51573 .38859 L .52228 .39261 L .208 0 1 r
F
P
p
.60177 .38852 m .61747 .39081 L .60779 .39254 L 0 .589 1 r
F
P
p
.5921 .39026 m .60177 .38852 L .60779 .39254 L 0 .484 1 r
F
P
p
.40408 .38811 m .42049 .3904 L .41133 .39213 L .465 0 1 r
F
P
p
.39493 .38985 m .40408 .38811 L .41133 .39213 L .465 0 1 r
F
P
p
.49018 .38804 m .50629 .39033 L .49689 .39206 L .465 0 1 r
F
P
p
.4808 .38978 m .49018 .38804 L .49689 .39206 L .465 0 1 r
F
P
p
.5763 .38797 m .5921 .39026 L .58248 .39199 L 0 .428 1 r
F
P
p
.56669 .38971 m .5763 .38797 L .58248 .39199 L 0 .428 1 r
F
P
p
.37842 .38755 m .39493 .38985 L .38583 .39158 L .465 0 1 r
F
P
p
.36933 .38929 m .37842 .38755 L .38583 .39158 L .465 0 1 r
F
P
p
.46459 .38748 m .4808 .38978 L .47147 .39151 L .465 0 1 r
F
P
p
.45527 .38922 m .46459 .38748 L .47147 .39151 L .465 0 1 r
F
P
p
.55078 .38741 m .56669 .38971 L .55713 .39144 L 0 .428 1 r
F
P
p
.54123 .38915 m .55078 .38741 L .55713 .39144 L 0 .428 1 r
F
P
p
.43896 .38692 m .45527 .38922 L .446 .39096 L .465 0 1 r
F
P
p
.4297 .38867 m .43896 .38692 L .446 .39096 L .465 0 1 r
F
P
p
.52522 .38685 m .54123 .38915 L .53173 .39088 L 0 .153 1 r
F
P
p
.51573 .38859 m .52522 .38685 L .53173 .39088 L 0 .016 1 r
F
P
p
.6115 .38678 m .6272 .38908 L .61747 .39081 L 0 .764 1 r
F
P
p
.60177 .38852 m .6115 .38678 L .61747 .39081 L 0 .589 1 r
F
P
p
.41328 .38636 m .4297 .38867 L .42049 .3904 L .465 0 1 r
F
P
p
.40408 .38811 m .41328 .38636 L .42049 .3904 L .465 0 1 r
F
P
p
.49961 .38629 m .51573 .38859 L .50629 .39033 L .379 0 1 r
F
P
p
.49018 .38804 m .49961 .38629 L .50629 .39033 L .465 0 1 r
F
P
p
.58596 .38622 m .60177 .38852 L .5921 .39026 L 0 .484 1 r
F
P
p
.5763 .38797 m .58596 .38622 L .5921 .39026 L 0 .428 1 r
F
P
p
.38756 .3858 m .40408 .38811 L .39493 .38985 L .465 0 1 r
F
P
p
.37842 .38755 m .38756 .3858 L .39493 .38985 L .465 0 1 r
F
P
p
.47396 .38573 m .49018 .38804 L .4808 .38978 L .465 0 1 r
F
P
p
.46459 .38748 m .47396 .38573 L .4808 .38978 L .465 0 1 r
F
P
p
.56038 .38566 m .5763 .38797 L .56669 .38971 L 0 .428 1 r
F
P
p
.55078 .38741 m .56038 .38566 L .56669 .38971 L 0 .428 1 r
F
P
p
.3618 .38524 m .37842 .38755 L .36933 .38929 L .465 0 1 r
F
P
p
.44827 .38517 m .46459 .38748 L .45527 .38922 L .465 0 1 r
F
P
p
.43896 .38692 m .44827 .38517 L .45527 .38922 L .465 0 1 r
F
P
p
.53476 .38509 m .55078 .38741 L .54123 .38915 L 0 .153 1 r
F
P
p
.52522 .38685 m .53476 .38509 L .54123 .38915 L 0 .153 1 r
F
P
p
.62127 .38502 m .63699 .38734 L .6272 .38908 L 0 .889 1 r
F
P
p
.6115 .38678 m .62127 .38502 L .6272 .38908 L 0 .764 1 r
F
P
p
.42253 .38461 m .43896 .38692 L .4297 .38867 L .465 0 1 r
F
P
p
.41328 .38636 m .42253 .38461 L .4297 .38867 L .465 0 1 r
F
P
p
.50909 .38453 m .52522 .38685 L .51573 .38859 L .293 0 1 r
F
P
p
.49961 .38629 m .50909 .38453 L .51573 .38859 L .379 0 1 r
F
P
p
.59568 .38446 m .6115 .38678 L .60177 .38852 L 0 .589 1 r
F
P
p
.58596 .38622 m .59568 .38446 L .60177 .38852 L 0 .484 1 r
F
P
p
.39675 .38404 m .41328 .38636 L .40408 .38811 L .465 0 1 r
F
P
p
.38756 .3858 m .39675 .38404 L .40408 .38811 L .465 0 1 r
F
P
p
.48338 .38397 m .49961 .38629 L .49018 .38804 L .465 0 1 r
F
P
p
.47396 .38573 m .48338 .38397 L .49018 .38804 L .465 0 1 r
F
P
p
.57004 .3839 m .58596 .38622 L .5763 .38797 L 0 .577 1 r
F
P
p
.56038 .38566 m .57004 .3839 L .5763 .38797 L 0 .428 1 r
F
P
p
.37093 .38348 m .38756 .3858 L .37842 .38755 L .465 0 1 r
F
P
p
.3618 .38524 m .37093 .38348 L .37842 .38755 L .465 0 1 r
F
P
p
.45763 .3834 m .47396 .38573 L .46459 .38748 L .465 0 1 r
F
P
p
.44827 .38517 m .45763 .3834 L .46459 .38748 L .465 0 1 r
F
P
p
.54435 .38333 m .56038 .38566 L .55078 .38741 L 0 .153 1 r
F
P
p
.53476 .38509 m .54435 .38333 L .55078 .38741 L 0 .153 1 r
F
P
p
.6311 .38326 m .64682 .38558 L .63699 .38734 L 0 .972 1 r
F
P
p
.62127 .38502 m .6311 .38326 L .63699 .38734 L 0 .889 1 r
F
P
p
.43183 .38284 m .44827 .38517 L .43896 .38692 L .465 0 1 r
F
P
p
.42253 .38461 m .43183 .38284 L .43896 .38692 L .465 0 1 r
F
P
p
.51863 .38277 m .53476 .38509 L .52522 .38685 L .293 0 1 r
F
P
p
.50909 .38453 m .51863 .38277 L .52522 .38685 L .293 0 1 r
F
P
p
.60544 .38269 m .62127 .38502 L .6115 .38678 L 0 .714 1 r
F
P
p
.59568 .38446 m .60544 .38269 L .6115 .38678 L 0 .589 1 r
F
P
p
.40599 .38227 m .42253 .38461 L .41328 .38636 L .465 0 1 r
F
P
p
.39675 .38404 m .40599 .38227 L .41328 .38636 L .465 0 1 r
F
P
p
.49286 .3822 m .50909 .38453 L .49961 .38629 L .465 0 1 r
F
P
p
.48338 .38397 m .49286 .3822 L .49961 .38629 L .465 0 1 r
F
P
p
.57974 .38212 m .59568 .38446 L .58596 .38622 L 0 .912 1 r
F
P
p
.57004 .3839 m .57974 .38212 L .58596 .38622 L 0 .577 1 r
F
P
p
.3801 .3817 m .39675 .38404 L .38756 .3858 L .465 0 1 r
F
P
p
.37093 .38348 m .3801 .3817 L .38756 .3858 L .465 0 1 r
F
P
p
.46704 .38163 m .48338 .38397 L .47396 .38573 L .465 0 1 r
F
P
p
.45763 .3834 m .46704 .38163 L .47396 .38573 L .465 0 1 r
F
P
p
.554 .38156 m .57004 .3839 L .56038 .38566 L 0 .153 1 r
F
P
p
.54435 .38333 m .554 .38156 L .56038 .38566 L 0 .153 1 r
F
P
p
.64098 .38148 m .65671 .38382 L .64682 .38558 L 0 1 .812 r
F
P
p
.6311 .38326 m .64098 .38148 L .64682 .38558 L 0 .972 1 r
F
P
p
.35417 .38114 m .37093 .38348 L .3618 .38524 L .465 0 1 r
F
P
p
.44118 .38106 m .45763 .3834 L .44827 .38517 L .465 0 1 r
F
P
p
.43183 .38284 m .44118 .38106 L .44827 .38517 L .465 0 1 r
F
P
p
.52821 .38099 m .54435 .38333 L .53476 .38509 L .293 0 1 r
F
P
p
.51863 .38277 m .52821 .38099 L .53476 .38509 L .293 0 1 r
F
P
p
.61526 .38091 m .6311 .38326 L .62127 .38502 L 0 .791 1 r
F
P
p
.60544 .38269 m .61526 .38091 L .62127 .38502 L 0 .714 1 r
F
P
p
.41528 .38049 m .43183 .38284 L .42253 .38461 L .465 0 1 r
F
P
p
.40599 .38227 m .41528 .38049 L .42253 .38461 L .465 0 1 r
F
P
p
.50238 .38042 m .51863 .38277 L .50909 .38453 L .465 0 1 r
F
P
p
.49286 .3822 m .50238 .38042 L .50909 .38453 L .465 0 1 r
F
P
p
.5895 .38034 m .60544 .38269 L .59568 .38446 L 0 1 .867 r
F
P
p
.57974 .38212 m .5895 .38034 L .59568 .38446 L 0 .912 1 r
F
P
p
.38933 .37992 m .40599 .38227 L .39675 .38404 L .465 0 1 r
F
P
p
.3801 .3817 m .38933 .37992 L .39675 .38404 L .465 0 1 r
F
P
p
.4765 .37985 m .49286 .3822 L .48338 .38397 L .465 0 1 r
F
P
p
.46704 .38163 m .4765 .37985 L .48338 .38397 L .465 0 1 r
F
P
p
.5637 .37977 m .57974 .38212 L .57004 .3839 L 0 .376 1 r
F
P
p
.554 .38156 m .5637 .37977 L .57004 .3839 L 0 .153 1 r
F
P
p
.65091 .3797 m .66665 .38205 L .65671 .38382 L 0 1 .602 r
F
P
p
.64098 .38148 m .65091 .3797 L .65671 .38382 L 0 1 .812 r
F
P
p
.36333 .37935 m .3801 .3817 L .37093 .38348 L .465 0 1 r
F
P
p
.35417 .38114 m .36333 .37935 L .37093 .38348 L .465 0 1 r
F
P
p
.45058 .37928 m .46704 .38163 L .45763 .3834 L .465 0 1 r
F
P
p
.44118 .38106 m .45058 .37928 L .45763 .3834 L .465 0 1 r
F
P
p
.53785 .3792 m .554 .38156 L .54435 .38333 L .293 0 1 r
F
P
p
.52821 .38099 m .53785 .3792 L .54435 .38333 L .293 0 1 r
F
P
p
.62514 .37913 m .64098 .38148 L .6311 .38326 L 0 .923 1 r
F
P
p
.61526 .38091 m .62514 .37913 L .6311 .38326 L 0 .791 1 r
F
P
p
.42461 .3787 m .44118 .38106 L .43183 .38284 L .465 0 1 r
F
P
p
.41528 .38049 m .42461 .3787 L .43183 .38284 L .465 0 1 r
F
P
p
.51195 .37863 m .52821 .38099 L .51863 .38277 L .465 0 1 r
F
P
p
.50238 .38042 m .51195 .37863 L .51863 .38277 L .465 0 1 r
F
P
p
.59931 .37856 m .61526 .38091 L .60544 .38269 L 0 1 .777 r
F
P
p
.5895 .38034 m .59931 .37856 L .60544 .38269 L 0 1 .867 r
F
P
p
.3986 .37813 m .41528 .38049 L .40599 .38227 L .465 0 1 r
F
P
p
.38933 .37992 m .3986 .37813 L .40599 .38227 L .465 0 1 r
F
P
p
.48602 .37806 m .50238 .38042 L .49286 .3822 L .465 0 1 r
F
P
p
.4765 .37985 m .48602 .37806 L .49286 .3822 L .465 0 1 r
F
P
p
.57345 .37798 m .5895 .38034 L .57974 .38212 L 0 .848 1 r
F
P
p
.5637 .37977 m .57345 .37798 L .57974 .38212 L 0 .376 1 r
F
P
p
.6609 .37791 m .67665 .38027 L .66665 .38205 L 0 1 .379 r
F
P
p
.65091 .3797 m .6609 .37791 L .66665 .38205 L 0 1 .602 r
F
P
p
.37255 .37756 m .38933 .37992 L .3801 .3817 L .465 0 1 r
F
P
p
.36333 .37935 m .37255 .37756 L .3801 .3817 L .465 0 1 r
F
P
p
.46003 .37748 m .4765 .37985 L .46704 .38163 L .465 0 1 r
F
P
p
.45058 .37928 m .46003 .37748 L .46704 .38163 L .465 0 1 r
F
P
p
.54754 .37741 m .5637 .37977 L .554 .38156 L .293 0 1 r
F
P
p
.53785 .3792 m .54754 .37741 L .554 .38156 L .293 0 1 r
F
P
p
.63506 .37733 m .65091 .3797 L .64098 .38148 L 0 1 .886 r
F
P
p
.62514 .37913 m .63506 .37733 L .64098 .38148 L 0 .923 1 r
F
P
p
.34644 .37698 m .36333 .37935 L .35417 .38114 L .465 0 1 r
F
P
p
.434 .3769 m .45058 .37928 L .44118 .38106 L .465 0 1 r
F
P
p
.42461 .3787 m .434 .3769 L .44118 .38106 L .465 0 1 r
F
P
p
.52158 .37683 m .53785 .3792 L .52821 .38099 L .465 0 1 r
F
P
p
.51195 .37863 m .52158 .37683 L .52821 .38099 L .465 0 1 r
F
P
p
.60918 .37676 m .62514 .37913 L .61526 .38091 L 0 1 .721 r
F
P
p
.59931 .37856 m .60918 .37676 L .61526 .38091 L 0 1 .777 r
F
P
p
.40793 .37633 m .42461 .3787 L .41528 .38049 L .465 0 1 r
F
P
p
.3986 .37813 m .40793 .37633 L .41528 .38049 L .465 0 1 r
F
P
p
.002 w
.47419 .83138 m .46465 .84015 L .4577 .83063 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46465 .84015 m .45454 .90682 L .44815 .83943 L p
.849 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44815 .83943 m .4577 .83063 L .46465 .84015 L p
.849 0 1 r
F P
0 0 0 r
s
P
p
.49558 .37625 m .51195 .37863 L .50238 .38042 L .465 0 1 r
F
P
p
.48602 .37806 m .49558 .37625 L .50238 .38042 L .465 0 1 r
F
P
p
.58325 .37618 m .59931 .37856 L .5895 .38034 L 0 1 .867 r
F
P
p
.57345 .37798 m .58325 .37618 L .5895 .38034 L 0 .848 1 r
F
P
p
.67094 .3761 m .68669 .37848 L .67665 .38027 L 0 1 .079 r
F
P
p
.6609 .37791 m .67094 .3761 L .67665 .38027 L 0 1 .379 r
F
P
p
.38181 .37575 m .3986 .37813 L .38933 .37992 L .465 0 1 r
F
P
p
.37255 .37756 m .38181 .37575 L .38933 .37992 L .465 0 1 r
F
P
p
.46953 .37568 m .48602 .37806 L .4765 .37985 L .465 0 1 r
F
P
p
.46003 .37748 m .46953 .37568 L .4765 .37985 L .465 0 1 r
F
P
p
.55728 .3756 m .57345 .37798 L .5637 .37977 L .134 0 1 r
F
P
p
.54754 .37741 m .55728 .3756 L .5637 .37977 L .293 0 1 r
F
P
p
.64504 .37553 m .6609 .37791 L .65091 .3797 L 0 1 .677 r
F
P
p
.63506 .37733 m .64504 .37553 L .65091 .3797 L 0 1 .886 r
F
P
p
.002 w
.4837 .83081 m .47419 .83138 L .4672 .83005 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4577 .83063 m .4672 .83005 L .47419 .83138 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.35564 .37517 m .37255 .37756 L .36333 .37935 L .465 0 1 r
F
P
p
.34644 .37698 m .35564 .37517 L .36333 .37935 L .465 0 1 r
F
P
p
.44344 .3751 m .46003 .37748 L .45058 .37928 L .465 0 1 r
F
P
p
.434 .3769 m .44344 .3751 L .45058 .37928 L .465 0 1 r
F
P
p
.53126 .37502 m .54754 .37741 L .53785 .3792 L .379 0 1 r
F
P
p
.52158 .37683 m .53126 .37502 L .53785 .3792 L .465 0 1 r
F
P
p
.6191 .37495 m .63506 .37733 L .62514 .37913 L 0 1 .651 r
F
P
p
.60918 .37676 m .6191 .37495 L .62514 .37913 L 0 1 .721 r
F
P
p
.4173 .37452 m .434 .3769 L .42461 .3787 L .465 0 1 r
F
P
p
.40793 .37633 m .4173 .37452 L .42461 .3787 L .465 0 1 r
F
P
p
.5052 .37444 m .52158 .37683 L .51195 .37863 L .465 0 1 r
F
P
p
.49558 .37625 m .5052 .37444 L .51195 .37863 L .465 0 1 r
F
P
p
.59311 .37437 m .60918 .37676 L .59931 .37856 L 0 1 .833 r
F
P
p
.58325 .37618 m .59311 .37437 L .59931 .37856 L 0 1 .867 r
F
P
p
.68104 .37429 m .6968 .37668 L .68669 .37848 L .34 1 0 r
F
P
p
.67094 .3761 m .68104 .37429 L .68669 .37848 L 0 1 .079 r
F
P
p
.39112 .37394 m .40793 .37633 L .3986 .37813 L .465 0 1 r
F
P
p
.38181 .37575 m .39112 .37394 L .3986 .37813 L .465 0 1 r
F
P
p
.002 w
.4379 .90634 m .44815 .83943 L .45454 .90682 L p
1 0 .488 r
F P
0 0 0 r
s
P
p
.002 w
.4577 .83063 m .44815 .83943 L .44098 .83816 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44815 .83943 m .4379 .90634 L .43154 .83871 L p
.884 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43154 .83871 m .44098 .83816 L .44815 .83943 L p
.884 0 1 r
F P
0 0 0 r
s
P
p
.47909 .37386 m .49558 .37625 L .48602 .37806 L .242 0 1 r
F
P
p
.46953 .37568 m .47909 .37386 L .48602 .37806 L .465 0 1 r
F
P
p
.56707 .37378 m .58325 .37618 L .57345 .37798 L 0 .089 1 r
F
P
p
.55728 .3756 m .56707 .37378 L .57345 .37798 L .134 0 1 r
F
P
p
.65508 .37371 m .67094 .3761 L .6609 .37791 L 0 1 .386 r
F
P
p
.64504 .37553 m .65508 .37371 L .6609 .37791 L 0 1 .677 r
F
P
p
.002 w
.49326 .83024 m .4837 .83081 L .47675 .82948 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4672 .83005 m .47675 .82948 L .4837 .83081 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.36489 .37335 m .38181 .37575 L .37255 .37756 L .465 0 1 r
F
P
p
.35564 .37517 m .36489 .37335 L .37255 .37756 L .465 0 1 r
F
P
p
.45293 .37328 m .46953 .37568 L .46003 .37748 L .465 0 1 r
F
P
p
.44344 .3751 m .45293 .37328 L .46003 .37748 L .465 0 1 r
F
P
p
.54099 .3732 m .55728 .3756 L .54754 .37741 L .156 0 1 r
F
P
p
.53126 .37502 m .54099 .3732 L .54754 .37741 L .379 0 1 r
F
P
p
.62907 .37313 m .64504 .37553 L .63506 .37733 L 0 1 .453 r
F
P
p
.6191 .37495 m .62907 .37313 L .63506 .37733 L 0 1 .651 r
F
P
p
.002 w
.4672 .83005 m .4577 .83063 L .45049 .8376 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44098 .83816 m .45049 .8376 L .4577 .83063 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.33862 .37277 m .35564 .37517 L .34644 .37698 L .465 0 1 r
F
P
p
.42673 .37269 m .44344 .3751 L .434 .3769 L .465 0 1 r
F
P
p
.4173 .37452 m .42673 .37269 L .434 .3769 L .465 0 1 r
F
P
p
.002 w
.45454 .90682 m .44489 .92386 L .4379 .90634 L p
1 0 .488 r
F P
0 0 0 r
s
P
p
.002 w
.42823 .92343 m .4379 .90634 L .44489 .92386 L closepath p
1 0 .07 r
F P
0 0 0 r
s
P
p
.51487 .37262 m .53126 .37502 L .52158 .37683 L .242 0 1 r
F
P
p
.5052 .37444 m .51487 .37262 L .52158 .37683 L .465 0 1 r
F
P
p
.60302 .37254 m .6191 .37495 L .60918 .37676 L 0 1 .648 r
F
P
p
.59311 .37437 m .60302 .37254 L .60918 .37676 L 0 1 .833 r
F
P
p
.69119 .37247 m .70696 .37487 L .6968 .37668 L .744 1 0 r
F
P
p
.68104 .37429 m .69119 .37247 L .6968 .37668 L .34 1 0 r
F
P
p
.40049 .37211 m .4173 .37452 L .40793 .37633 L .465 0 1 r
F
P
p
.39112 .37394 m .40049 .37211 L .40793 .37633 L .465 0 1 r
F
P
p
.48869 .37203 m .5052 .37444 L .49558 .37625 L .019 0 1 r
F
P
p
.47909 .37386 m .48869 .37203 L .49558 .37625 L .242 0 1 r
F
P
p
.57692 .37196 m .59311 .37437 L .58325 .37618 L 0 .291 1 r
F
P
p
.56707 .37378 m .57692 .37196 L .58325 .37618 L 0 .089 1 r
F
P
p
.66517 .37188 m .68104 .37429 L .67094 .3761 L 0 1 .016 r
F
P
p
.65508 .37371 m .66517 .37188 L .67094 .3761 L 0 1 .386 r
F
P
p
.002 w
.50288 .82966 m .49326 .83024 L .48636 .8289 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47675 .82948 m .48636 .8289 L .49326 .83024 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.37419 .37153 m .39112 .37394 L .38181 .37575 L .465 0 1 r
F
P
p
.36489 .37335 m .37419 .37153 L .38181 .37575 L .465 0 1 r
F
P
p
.002 w
.42115 .90585 m .43154 .83871 L .4379 .90634 L p
1 0 .488 r
F P
0 0 0 r
s
P
p
.002 w
.44098 .83816 m .43154 .83871 L .42424 .83742 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43154 .83871 m .42115 .90585 L .4148 .83798 L p
.884 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4148 .83798 m .42424 .83742 L .43154 .83871 L p
.884 0 1 r
F P
0 0 0 r
s
P
p
.46248 .37145 m .47909 .37386 L .46953 .37568 L .242 0 1 r
F
P
p
.45293 .37328 m .46248 .37145 L .46953 .37568 L .465 0 1 r
F
P
p
.55078 .37137 m .56707 .37378 L .55728 .3756 L 0 .067 1 r
F
P
p
.54099 .3732 m .55078 .37137 L .55728 .3756 L .156 0 1 r
F
P
p
.6391 .3713 m .65508 .37371 L .64504 .37553 L 0 1 .251 r
F
P
p
.62907 .37313 m .6391 .3713 L .64504 .37553 L 0 1 .453 r
F
P
p
.002 w
.47675 .82948 m .4672 .83005 L .46012 .82871 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45049 .8376 m .46012 .82871 L .4672 .83005 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.34786 .37094 m .36489 .37335 L .35564 .37517 L .465 0 1 r
F
P
p
.33862 .37277 m .34786 .37094 L .35564 .37517 L .465 0 1 r
F
P
p
.002 w
.42115 .90585 m .41145 .92301 L .40541 .83853 L p
1 0 .767 r
F P
0 0 0 r
s
P
p
.002 w
.40541 .83853 m .4148 .83798 L .42115 .90585 L p
1 0 .767 r
F P
0 0 0 r
s
P
p
.002 w
.4148 .83798 m .40541 .83853 L .39794 .83725 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.43621 .37086 m .45293 .37328 L .44344 .3751 L .465 0 1 r
F
P
p
.42673 .37269 m .43621 .37086 L .44344 .3751 L .465 0 1 r
F
P
p
.52459 .37079 m .54099 .3732 L .53126 .37502 L 0 .067 1 r
F
P
p
.51487 .37262 m .52459 .37079 L .53126 .37502 L .242 0 1 r
F
P
p
.61298 .37071 m .62907 .37313 L .6191 .37495 L 0 1 .348 r
F
P
p
.60302 .37254 m .61298 .37071 L .6191 .37495 L 0 1 .648 r
F
P
p
.7014 .37064 m .71717 .37305 L .70696 .37487 L .884 1 0 r
F
P
p
.69119 .37247 m .7014 .37064 L .70696 .37487 L .744 1 0 r
F
P
p
.4099 .37028 m .42673 .37269 L .4173 .37452 L .465 0 1 r
F
P
p
.40049 .37211 m .4099 .37028 L .4173 .37452 L .465 0 1 r
F
P
p
.002 w
.4379 .90634 m .42823 .92343 L .42115 .90585 L p
1 0 .488 r
F P
0 0 0 r
s
P
p
.002 w
.41145 .92301 m .42115 .90585 L .42823 .92343 L closepath p
1 0 .07 r
F P
0 0 0 r
s
P
p
.49835 .3702 m .51487 .37262 L .5052 .37444 L 0 .177 1 r
F
P
p
.48869 .37203 m .49835 .3702 L .5052 .37444 L .019 0 1 r
F
P
p
.58682 .37012 m .60302 .37254 L .59311 .37437 L 0 .428 1 r
F
P
p
.57692 .37196 m .58682 .37012 L .59311 .37437 L 0 .291 1 r
F
P
p
.67531 .37005 m .69119 .37247 L .68104 .37429 L .235 1 0 r
F
P
p
.66517 .37188 m .67531 .37005 L .68104 .37429 L 0 1 .016 r
F
P
p
.002 w
.51261 .80869 m .50288 .82966 L .49612 .80785 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48636 .8289 m .49612 .80785 L .50288 .82966 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5223 .80805 m .51261 .80869 L .50581 .80721 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49612 .80785 m .50581 .80721 L .51261 .80869 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.38355 .36969 m .40049 .37211 L .39112 .37394 L .465 0 1 r
F
P
p
.37419 .37153 m .38355 .36969 L .39112 .37394 L .465 0 1 r
F
P
p
.002 w
.45049 .8376 m .44098 .83816 L .43373 .83687 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42424 .83742 m .43373 .83687 L .44098 .83816 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.47207 .36961 m .48869 .37203 L .47909 .37386 L 0 .4 1 r
F
P
p
.46248 .37145 m .47207 .36961 L .47909 .37386 L .242 0 1 r
F
P
p
.56062 .36953 m .57692 .37196 L .56707 .37378 L 0 .153 1 r
F
P
p
.55078 .37137 m .56062 .36953 L .56707 .37378 L 0 .067 1 r
F
P
p
.64918 .36946 m .66517 .37188 L .65508 .37371 L 0 1 .107 r
F
P
p
.6391 .3713 m .64918 .36946 L .65508 .37371 L 0 1 .251 r
F
P
p
.002 w
.48636 .8289 m .47675 .82948 L .46972 .82813 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46012 .82871 m .46972 .82813 L .47675 .82948 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35714 .3691 m .37419 .37153 L .36489 .37335 L .465 0 1 r
F
P
p
.34786 .37094 m .35714 .3691 L .36489 .37335 L .465 0 1 r
F
P
p
.002 w
.42424 .83742 m .4148 .83798 L .40737 .83669 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39794 .83725 m .40737 .83669 L .4148 .83798 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.44574 .36902 m .46248 .37145 L .45293 .37328 L .465 0 1 r
F
P
p
.43621 .37086 m .44574 .36902 L .45293 .37328 L .465 0 1 r
F
P
p
.53436 .36895 m .55078 .37137 L .54099 .3732 L 0 .291 1 r
F
P
p
.52459 .37079 m .53436 .36895 L .54099 .3732 L 0 .067 1 r
F
P
p
.623 .36887 m .6391 .3713 L .62907 .37313 L 0 1 .093 r
F
P
p
.61298 .37071 m .623 .36887 L .62907 .37313 L 0 1 .348 r
F
P
p
.71166 .36879 m .72744 .37122 L .71717 .37305 L .884 1 0 r
F
P
p
.7014 .37064 m .71166 .36879 L .71717 .37305 L .884 1 0 r
F
P
p
.33069 .36851 m .34786 .37094 L .33862 .37277 L .465 0 1 r
F
P
p
.41937 .36843 m .43621 .37086 L .42673 .37269 L .465 0 1 r
F
P
p
.4099 .37028 m .41937 .36843 L .42673 .37269 L .465 0 1 r
F
P
p
.50806 .36835 m .52459 .37079 L .51487 .37262 L 0 .595 1 r
F
P
p
.49835 .3702 m .50806 .36835 L .51487 .37262 L 0 .177 1 r
F
P
p
.59678 .36828 m .61298 .37071 L .60302 .37254 L 0 .613 1 r
F
P
p
.58682 .37012 m .59678 .36828 L .60302 .37254 L 0 .428 1 r
F
P
p
.68552 .3682 m .7014 .37064 L .69119 .37247 L .479 1 0 r
F
P
p
.67531 .37005 m .68552 .3682 L .69119 .37247 L .235 1 0 r
F
P
p
.002 w
.53205 .80742 m .5223 .80805 L .51555 .80657 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50581 .80721 m .51555 .80657 L .5223 .80805 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.39295 .36784 m .4099 .37028 L .40049 .37211 L .465 0 1 r
F
P
p
.38355 .36969 m .39295 .36784 L .40049 .37211 L .465 0 1 r
F
P
p
.002 w
.46012 .82871 m .45049 .8376 L .44327 .8363 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43373 .83687 m .44327 .8363 L .45049 .8376 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.48172 .36776 m .49835 .3702 L .48869 .37203 L 0 .819 1 r
F
P
p
.47207 .36961 m .48172 .36776 L .48869 .37203 L 0 .4 1 r
F
P
p
.57051 .36769 m .58682 .37012 L .57692 .37196 L 0 .521 1 r
F
P
p
.56062 .36953 m .57051 .36769 L .57692 .37196 L 0 .153 1 r
F
P
p
.65932 .36761 m .67531 .37005 L .66517 .37188 L .109 1 0 r
F
P
p
.64918 .36946 m .65932 .36761 L .66517 .37188 L 0 1 .107 r
F
P
p
.002 w
.49612 .80785 m .48636 .8289 L .47936 .82754 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46972 .82813 m .47936 .82754 L .48636 .8289 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50581 .80721 m .49612 .80785 L .48907 .82695 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47936 .82754 m .48907 .82695 L .49612 .80785 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.36648 .36725 m .38355 .36969 L .37419 .37153 L .465 0 1 r
F
P
p
.35714 .3691 m .36648 .36725 L .37419 .37153 L .465 0 1 r
F
P
p
.002 w
.43373 .83687 m .42424 .83742 L .41697 .82776 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40737 .83669 m .41697 .82776 L .42424 .83742 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.45533 .36717 m .47207 .36961 L .46248 .37145 L .242 0 1 r
F
P
p
.44574 .36902 m .45533 .36717 L .46248 .37145 L .465 0 1 r
F
P
p
.54419 .36709 m .56062 .36953 L .55078 .37137 L 0 .623 1 r
F
P
p
.53436 .36895 m .54419 .36709 L .55078 .37137 L 0 .291 1 r
F
P
p
.63308 .36702 m .64918 .36946 L .6391 .3713 L .081 1 0 r
F
P
p
.623 .36887 m .63308 .36702 L .6391 .3713 L 0 1 .093 r
F
P
p
.72199 .36694 m .73777 .36938 L .72744 .37122 L .907 1 0 r
F
P
p
.71166 .36879 m .72199 .36694 L .72744 .37122 L .884 1 0 r
F
P
p
.002 w
.46972 .82813 m .46012 .82871 L .45295 .82736 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44327 .8363 m .45295 .82736 L .46012 .82871 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.33997 .36665 m .35714 .3691 L .34786 .37094 L .465 0 1 r
F
P
p
.33069 .36851 m .33997 .36665 L .34786 .37094 L .465 0 1 r
F
P
p
.002 w
.40737 .83669 m .39794 .83725 L .39038 .83594 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.42889 .36658 m .44574 .36902 L .43621 .37086 L .465 0 1 r
F
P
p
.41937 .36843 m .42889 .36658 L .43621 .37086 L .465 0 1 r
F
P
p
.51783 .3665 m .53436 .36895 L .52459 .37079 L 0 .819 1 r
F
P
p
.50806 .36835 m .51783 .3665 L .52459 .37079 L 0 .595 1 r
F
P
p
.60679 .36642 m .623 .36887 L .61298 .37071 L 0 1 .718 r
F
P
p
.59678 .36828 m .60679 .36642 L .61298 .37071 L 0 .613 1 r
F
P
p
.69577 .36634 m .71166 .36879 L .7014 .37064 L .72 1 0 r
F
P
p
.68552 .3682 m .69577 .36634 L .7014 .37064 L .479 1 0 r
F
P
p
.002 w
.54186 .80677 m .53205 .80742 L .52534 .80592 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51555 .80657 m .52534 .80592 L .53205 .80742 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.4024 .36598 m .41937 .36843 L .4099 .37028 L .395 0 1 r
F
P
p
.39295 .36784 m .4024 .36598 L .4099 .37028 L .465 0 1 r
F
P
p
.49142 .3659 m .50806 .36835 L .49835 .3702 L 0 1 .881 r
F
P
p
.48172 .36776 m .49142 .3659 L .49835 .3702 L 0 .819 1 r
F
P
p
.58046 .36583 m .59678 .36828 L .58682 .37012 L 0 .993 1 r
F
P
p
.57051 .36769 m .58046 .36583 L .58682 .37012 L 0 .521 1 r
F
P
p
.66952 .36575 m .68552 .3682 L .67531 .37005 L .256 1 0 r
F
P
p
.65932 .36761 m .66952 .36575 L .67531 .37005 L .109 1 0 r
F
P
p
.002 w
.51555 .80657 m .50581 .80721 L .49892 .80571 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48907 .82695 m .49892 .80571 L .50581 .80721 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.37587 .36539 m .39295 .36784 L .38355 .36969 L .465 0 1 r
F
P
p
.36648 .36725 m .37587 .36539 L .38355 .36969 L .465 0 1 r
F
P
p
.002 w
.44327 .8363 m .43373 .83687 L .42649 .82717 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41697 .82776 m .42649 .82717 L .43373 .83687 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.46497 .36531 m .48172 .36776 L .47207 .36961 L 0 .177 1 r
F
P
p
.45533 .36717 m .46497 .36531 L .47207 .36961 L .242 0 1 r
F
P
p
.55408 .36523 m .57051 .36769 L .56062 .36953 L 0 .819 1 r
F
P
p
.54419 .36709 m .55408 .36523 L .56062 .36953 L 0 .623 1 r
F
P
p
.64321 .36515 m .65932 .36761 L .64918 .36946 L .186 1 0 r
F
P
p
.63308 .36702 m .64321 .36515 L .64918 .36946 L .081 1 0 r
F
P
p
.73236 .36508 m .74815 .36753 L .73777 .36938 L .977 1 0 r
F
P
p
.72199 .36694 m .73236 .36508 L .73777 .36938 L .907 1 0 r
F
P
p
.002 w
.47936 .82754 m .46972 .82813 L .46259 .82677 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45295 .82736 m .46259 .82677 L .46972 .82813 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.34929 .36479 m .36648 .36725 L .35714 .3691 L .465 0 1 r
F
P
p
.33997 .36665 m .34929 .36479 L .35714 .3691 L .465 0 1 r
F
P
p
.002 w
.41697 .82776 m .40737 .83669 L .39999 .82698 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39038 .83594 m .39999 .82698 L .40737 .83669 L p
.57 0 1 r
F P
0 0 0 r
s
P
p
.43846 .36471 m .45533 .36717 L .44574 .36902 L .465 0 1 r
F
P
p
.42889 .36658 m .43846 .36471 L .44574 .36902 L .465 0 1 r
F
P
p
.52765 .36463 m .54419 .36709 L .53436 .36895 L 0 .958 1 r
F
P
p
.51783 .3665 m .52765 .36463 L .53436 .36895 L 0 .819 1 r
F
P
p
.61686 .36456 m .63308 .36702 L .623 .36887 L 0 1 .198 r
F
P
p
.60679 .36642 m .61686 .36456 L .623 .36887 L 0 1 .718 r
F
P
p
.70609 .36448 m .72199 .36694 L .71166 .36879 L .741 1 0 r
F
P
p
.69577 .36634 m .70609 .36448 L .71166 .36879 L .72 1 0 r
F
P
p
.32267 .36419 m .33997 .36665 L .33069 .36851 L .465 0 1 r
F
P
p
.002 w
.55167 .78776 m .54186 .80677 L .53519 .80527 L p
.045 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52534 .80592 m .53519 .80527 L .54186 .80677 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.41191 .36411 m .42889 .36658 L .41937 .36843 L .326 0 1 r
F
P
p
.4024 .36598 m .41191 .36411 L .41937 .36843 L .395 0 1 r
F
P
p
.50118 .36403 m .51783 .3665 L .50806 .36835 L 0 1 .536 r
F
P
p
.49142 .3659 m .50118 .36403 L .50806 .36835 L 0 1 .881 r
F
P
p
.59046 .36396 m .60679 .36642 L .59678 .36828 L 0 1 .902 r
F
P
p
.58046 .36583 m .59046 .36396 L .59678 .36828 L 0 .993 1 r
F
P
p
.002 w
.56151 .77264 m .55167 .78776 L .54509 .80462 L p
0 .166 1 r
F P
0 0 0 r
s
P
p
.002 w
.53519 .80527 m .54509 .80462 L .55167 .78776 L p
.045 0 1 r
F P
0 0 0 r
s
P
p
.67977 .36388 m .69577 .36634 L .68552 .3682 L .437 1 0 r
F
P
p
.66952 .36575 m .67977 .36388 L .68552 .3682 L .256 1 0 r
F
P
p
.002 w
.42649 .82717 m .41697 .82776 L .4095 .82639 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39999 .82698 m .4095 .82639 L .41697 .82776 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52534 .80592 m .51555 .80657 L .5087 .80506 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49892 .80571 m .5087 .80506 L .51555 .80657 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.38532 .36351 m .4024 .36598 L .39295 .36784 L .465 0 1 r
F
P
p
.37587 .36539 m .38532 .36351 L .39295 .36784 L .465 0 1 r
F
P
p
.002 w
.45295 .82736 m .44327 .8363 L .43607 .82658 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42649 .82717 m .43607 .82658 L .44327 .8363 L p
.535 0 1 r
F P
0 0 0 r
s
P
p
.47466 .36344 m .49142 .3659 L .48172 .36776 L 0 .372 1 r
F
P
p
.46497 .36531 m .47466 .36344 L .48172 .36776 L 0 .177 1 r
F
P
p
.002 w
.57143 .7719 m .56151 .77264 L .555 .78622 L p
0 .364 1 r
F P
0 0 0 r
s
P
p
.002 w
.555 .78622 m .56151 .77264 L p
.54627 .80231 L 0 .166 1 r
F P
0 0 0 r
s
P
p
.002 w
.555 .78622 m .54832 .76917 L p
.56374 .7701 L 0 .364 1 r
F P
0 0 0 r
s
P
p
.002 w
.56492 .77017 m .555 .78622 L p
.56374 .7701 L 0 .364 1 r
F P
0 0 0 r
s
P
p
.002 w
.54509 .80462 m .555 .78622 L p
.54627 .80231 L 0 .166 1 r
F P
0 0 0 r
s
P
p
.56402 .36336 m .58046 .36583 L .57051 .36769 L 0 1 .951 r
F
P
p
.55408 .36523 m .56402 .36336 L .57051 .36769 L 0 .819 1 r
F
P
p
.6534 .36328 m .66952 .36575 L .65932 .36761 L .256 1 0 r
F
P
p
.64321 .36515 m .6534 .36328 L .65932 .36761 L .186 1 0 r
F
P
p
.7428 .3632 m .75859 .36567 L .74815 .36753 L 1 .942 0 r
F
P
p
.73236 .36508 m .7428 .3632 L .74815 .36753 L .977 1 0 r
F
P
p
.002 w
.48907 .82695 m .47936 .82754 L .47228 .82617 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46259 .82677 m .47228 .82617 L .47936 .82754 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35867 .36291 m .37587 .36539 L .36648 .36725 L .395 0 1 r
F
P
p
.34929 .36479 m .35867 .36291 L .36648 .36725 L .465 0 1 r
F
P
p
.44809 .36284 m .46497 .36531 L .45533 .36717 L .465 0 1 r
F
P
p
.43846 .36471 m .44809 .36284 L .45533 .36717 L .465 0 1 r
F
P
p
.53752 .36276 m .55408 .36523 L .54419 .36709 L 0 1 .672 r
F
P
p
.52765 .36463 m .53752 .36276 L .54419 .36709 L 0 .958 1 r
F
P
p
.62698 .36268 m .64321 .36515 L .63308 .36702 L 0 1 .128 r
F
P
p
.61686 .36456 m .62698 .36268 L .63308 .36702 L 0 1 .198 r
F
P
p
.71646 .3626 m .73236 .36508 L .72199 .36694 L .767 1 0 r
F
P
p
.70609 .36448 m .71646 .3626 L .72199 .36694 L .741 1 0 r
F
P
p
.002 w
.46259 .82677 m .45295 .82736 L .44569 .82598 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43607 .82658 m .44569 .82598 L .45295 .82736 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.33198 .36231 m .34929 .36479 L .33997 .36665 L .465 0 1 r
F
P
p
.32267 .36419 m .33198 .36231 L .33997 .36665 L .465 0 1 r
F
P
p
.002 w
.39999 .82698 m .39038 .83594 L .38288 .8262 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.42147 .36223 m .43846 .36471 L .42889 .36658 L .326 0 1 r
F
P
p
.41191 .36411 m .42147 .36223 L .42889 .36658 L .326 0 1 r
F
P
p
.51099 .36216 m .52765 .36463 L .51783 .3665 L 0 1 .466 r
F
P
p
.50118 .36403 m .51099 .36216 L .51783 .3665 L 0 1 .536 r
F
P
p
.60052 .36208 m .61686 .36456 L .60679 .36642 L 0 1 .533 r
F
P
p
.59046 .36396 m .60052 .36208 L .60679 .36642 L 0 1 .902 r
F
P
p
.69007 .362 m .70609 .36448 L .69577 .36634 L .642 1 0 r
F
P
p
.67977 .36388 m .69007 .362 L .69577 .36634 L .437 1 0 r
F
P
p
.002 w
.43607 .82658 m .42649 .82717 L .41906 .82579 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4095 .82639 m .41906 .82579 L .42649 .82717 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.53519 .80527 m .52534 .80592 L .51854 .80441 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5087 .80506 m .51854 .80441 L .52534 .80592 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.39481 .36163 m .41191 .36411 L .4024 .36598 L .326 0 1 r
F
P
p
.38532 .36351 m .39481 .36163 L .4024 .36598 L .465 0 1 r
F
P
p
.4844 .36155 m .50118 .36403 L .49142 .3659 L 0 .477 1 r
F
P
p
.47466 .36344 m .4844 .36155 L .49142 .3659 L 0 .372 1 r
F
P
p
.002 w
.58141 .77116 m .57143 .7719 L .56492 .77017 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.555 .78622 m .56492 .77017 L .57143 .7719 L p
0 .364 1 r
F P
0 0 0 r
s
P
p
.57401 .36147 m .59046 .36396 L .58046 .36583 L 0 1 .581 r
F
P
p
.56402 .36336 m .57401 .36147 L .58046 .36583 L 0 1 .951 r
F
P
p
.66364 .3614 m .67977 .36388 L .66952 .36575 L .256 1 0 r
F
P
p
.6534 .36328 m .66364 .3614 L .66952 .36575 L .256 1 0 r
F
P
p
.75329 .36132 m .76909 .3638 L .75859 .36567 L 1 .853 0 r
F
P
p
.7428 .3632 m .75329 .36132 L .75859 .36567 L 1 .942 0 r
F
P
p
.002 w
.4095 .82639 m .39999 .82698 L .39238 .8256 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38288 .8262 m .39238 .8256 L .39999 .82698 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49892 .80571 m .48907 .82695 L .48203 .82557 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47228 .82617 m .48203 .82557 L .48907 .82695 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5087 .80506 m .49892 .80571 L .49194 .8042 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48203 .82557 m .49194 .8042 L .49892 .80571 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.3681 .36103 m .38532 .36351 L .37587 .36539 L .221 0 1 r
F
P
p
.35867 .36291 m .3681 .36103 L .37587 .36539 L .395 0 1 r
F
P
p
.45777 .36095 m .47466 .36344 L .46497 .36531 L .465 0 1 r
F
P
p
.44809 .36284 m .45777 .36095 L .46497 .36531 L .465 0 1 r
F
P
p
.54745 .36087 m .56402 .36336 L .55408 .36523 L 0 1 .442 r
F
P
p
.53752 .36276 m .54745 .36087 L .55408 .36523 L 0 1 .672 r
F
P
p
.63716 .36079 m .6534 .36328 L .64321 .36515 L 0 1 .085 r
F
P
p
.62698 .36268 m .63716 .36079 L .64321 .36515 L 0 1 .128 r
F
P
p
.72689 .36071 m .7428 .3632 L .73236 .36508 L .837 1 0 r
F
P
p
.71646 .3626 m .72689 .36071 L .73236 .36508 L .767 1 0 r
F
P
p
.002 w
.47228 .82617 m .46259 .82677 L .45537 .82538 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44569 .82598 m .45537 .82538 L .46259 .82677 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.34134 .36042 m .35867 .36291 L .34929 .36479 L .291 0 1 r
F
P
p
.33198 .36231 m .34134 .36042 L .34929 .36479 L .465 0 1 r
F
P
p
.43109 .36034 m .44809 .36284 L .43846 .36471 L .151 0 1 r
F
P
p
.42147 .36223 m .43109 .36034 L .43846 .36471 L .326 0 1 r
F
P
p
.52085 .36027 m .53752 .36276 L .52765 .36463 L 0 1 .302 r
F
P
p
.51099 .36216 m .52085 .36027 L .52765 .36463 L 0 1 .466 r
F
P
p
.61063 .36019 m .62698 .36268 L .61686 .36456 L 0 1 .128 r
F
P
p
.60052 .36208 m .61063 .36019 L .61686 .36456 L 0 1 .533 r
F
P
p
.70044 .36011 m .71646 .3626 L .70609 .36448 L .706 1 0 r
F
P
p
.69007 .362 m .70044 .36011 L .70609 .36448 L .642 1 0 r
F
P
p
.002 w
.44569 .82598 m .43607 .82658 L .42867 .82519 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41906 .82579 m .42867 .82519 L .43607 .82658 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31454 .35982 m .33198 .36231 L .32267 .36419 L .465 0 1 r
F
P
p
.002 w
.54509 .80462 m .53519 .80527 L .52843 .80375 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51854 .80441 m .52843 .80375 L .53519 .80527 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.40436 .35974 m .42147 .36223 L .41191 .36411 L .186 0 1 r
F
P
p
.39481 .36163 m .40436 .35974 L .41191 .36411 L .326 0 1 r
F
P
p
.4942 .35966 m .51099 .36216 L .50118 .36403 L 0 .627 1 r
F
P
p
.4844 .36155 m .4942 .35966 L .50118 .36403 L 0 .477 1 r
F
P
p
.002 w
.59144 .77041 m .58141 .77116 L .57495 .76941 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.56492 .77017 m .57495 .76941 L .58141 .77116 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.58406 .35958 m .60052 .36208 L .59046 .36396 L 0 1 .337 r
F
P
p
.57401 .36147 m .58406 .35958 L .59046 .36396 L 0 1 .581 r
F
P
p
.67394 .3595 m .69007 .362 L .67977 .36388 L .283 1 0 r
F
P
p
.66364 .3614 m .67394 .3595 L .67977 .36388 L .256 1 0 r
F
P
p
.76384 .35942 m .77965 .36192 L .76909 .3638 L 1 .749 0 r
F
P
p
.75329 .36132 m .76384 .35942 L .76909 .3638 L 1 .853 0 r
F
P
p
.002 w
.41906 .82579 m .4095 .82639 L .40192 .825 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39238 .8256 m .40192 .825 L .4095 .82639 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51854 .80441 m .5087 .80506 L .50177 .80354 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49194 .8042 m .50177 .80354 L .5087 .80506 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.37758 .35913 m .39481 .36163 L .38532 .36351 L .047 0 1 r
F
P
p
.3681 .36103 m .37758 .35913 L .38532 .36351 L .221 0 1 r
F
P
p
.4675 .35905 m .4844 .36155 L .47466 .36344 L .465 0 1 r
F
P
p
.45777 .36095 m .4675 .35905 L .47466 .36344 L .465 0 1 r
F
P
p
.55744 .35897 m .57401 .36147 L .56402 .36336 L 0 1 .442 r
F
P
p
.54745 .36087 m .55744 .35897 L .56402 .36336 L 0 1 .442 r
F
P
p
.6474 .35889 m .66364 .3614 L .6534 .36328 L 0 1 .05 r
F
P
p
.63716 .36079 m .6474 .35889 L .6534 .36328 L 0 1 .085 r
F
P
p
.73738 .35882 m .75329 .36132 L .7428 .3632 L .911 1 0 r
F
P
p
.72689 .36071 m .73738 .35882 L .7428 .3632 L .837 1 0 r
F
P
p
.002 w
.39238 .8256 m .38288 .8262 L .37513 .82481 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48203 .82557 m .47228 .82617 L .46511 .82478 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45537 .82538 m .46511 .82478 L .47228 .82617 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35076 .35852 m .3681 .36103 L .35867 .36291 L .047 0 1 r
F
P
p
.34134 .36042 m .35076 .35852 L .35867 .36291 L .291 0 1 r
F
P
p
.44075 .35844 m .45777 .36095 L .44809 .36284 L 0 .023 1 r
F
P
p
.43109 .36034 m .44075 .35844 L .44809 .36284 L .151 0 1 r
F
P
p
.53077 .35837 m .54745 .36087 L .53752 .36276 L 0 1 .128 r
F
P
p
.52085 .36027 m .53077 .35837 L .53752 .36276 L 0 1 .302 r
F
P
p
.62081 .35829 m .63716 .36079 L .62698 .36268 L 0 1 .093 r
F
P
p
.61063 .36019 m .62081 .35829 L .62698 .36268 L 0 1 .128 r
F
P
p
.71086 .35821 m .72689 .36071 L .71646 .3626 L .744 1 0 r
F
P
p
.70044 .36011 m .71086 .35821 L .71646 .3626 L .706 1 0 r
F
P
p
.002 w
.45537 .82538 m .44569 .82598 L .43834 .82459 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42867 .82519 m .43834 .82459 L .44569 .82598 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.32389 .35791 m .34134 .36042 L .33198 .36231 L .465 0 1 r
F
P
p
.31454 .35982 m .32389 .35791 L .33198 .36231 L .465 0 1 r
F
P
p
.002 w
.555 .78622 m .54509 .80462 L .53838 .80308 L p
0 .089 1 r
F P
0 0 0 r
s
P
p
.002 w
.52843 .80375 m .53838 .80308 L .54509 .80462 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.41396 .35783 m .43109 .36034 L .42147 .36223 L .081 0 1 r
F
P
p
.40436 .35974 m .41396 .35783 L .42147 .36223 L .186 0 1 r
F
P
p
.50405 .35776 m .52085 .36027 L .51099 .36216 L 0 .767 1 r
F
P
p
.4942 .35966 m .50405 .35776 L .51099 .36216 L 0 .627 1 r
F
P
p
.002 w
.60153 .76965 m .59144 .77041 L .58503 .76865 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.57495 .76941 m .58503 .76865 L .59144 .77041 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.59417 .35768 m .61063 .36019 L .60052 .36208 L 0 1 .233 r
F
P
p
.58406 .35958 m .59417 .35768 L .60052 .36208 L 0 1 .337 r
F
P
p
.6843 .3576 m .70044 .36011 L .69007 .362 L .318 1 0 r
F
P
p
.67394 .3595 m .6843 .3576 L .69007 .362 L .283 1 0 r
F
P
p
.002 w
.53838 .80308 m .54832 .76917 L .555 .78622 L p
0 .089 1 r
F P
0 0 0 r
s
P
p
.77445 .35752 m .79026 .36003 L .77965 .36192 L 1 .698 0 r
F
P
p
.76384 .35942 m .77445 .35752 L .77965 .36192 L 1 .749 0 r
F
P
p
.002 w
.42867 .82519 m .41906 .82579 L .41152 .8244 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40192 .825 m .41152 .8244 L .41906 .82579 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52843 .80375 m .51854 .80441 L .51165 .80287 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50177 .80354 m .51165 .80287 L .51854 .80441 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.38712 .35722 m .40436 .35974 L .39481 .36163 L 0 .093 1 r
F
P
p
.37758 .35913 m .38712 .35722 L .39481 .36163 L .047 0 1 r
F
P
p
.47729 .35715 m .4942 .35966 L .4844 .36155 L .465 0 1 r
F
P
p
.4675 .35905 m .47729 .35715 L .4844 .36155 L .465 0 1 r
F
P
p
.002 w
.57495 .76941 m .56492 .77017 L .55833 .76841 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.54832 .76917 m .55833 .76841 L .56492 .77017 L p
0 .364 1 r
F P
0 0 0 r
s
P
p
.56748 .35707 m .58406 .35958 L .57401 .36147 L 0 1 .407 r
F
P
p
.55744 .35897 m .56748 .35707 L .57401 .36147 L 0 1 .442 r
F
P
p
.65769 .35699 m .67394 .3595 L .66364 .3614 L 0 1 .018 r
F
P
p
.6474 .35889 m .65769 .35699 L .66364 .3614 L 0 1 .05 r
F
P
p
.74792 .35691 m .76384 .35942 L .75329 .36132 L 1 .985 0 r
F
P
p
.73738 .35882 m .74792 .35691 L .75329 .36132 L .911 1 0 r
F
P
p
.002 w
.40192 .825 m .39238 .8256 L .38466 .8242 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37513 .82481 m .38466 .8242 L .39238 .8256 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49194 .8042 m .48203 .82557 L .47489 .82418 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46511 .82478 m .47489 .82418 L .48203 .82557 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50177 .80354 m .49194 .8042 L .48474 .82357 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47489 .82418 m .48474 .82357 L .49194 .8042 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.36023 .35661 m .37758 .35913 L .3681 .36103 L 0 .128 1 r
F
P
p
.35076 .35852 m .36023 .35661 L .3681 .36103 L .047 0 1 r
F
P
p
.45048 .35653 m .4675 .35905 L .45777 .36095 L 0 .023 1 r
F
P
p
.44075 .35844 m .45048 .35653 L .45777 .36095 L 0 .023 1 r
F
P
p
.54074 .35645 m .55744 .35897 L .54745 .36087 L 0 1 .058 r
F
P
p
.53077 .35837 m .54074 .35645 L .54745 .36087 L 0 1 .128 r
F
P
p
.63103 .35637 m .6474 .35889 L .63716 .36079 L 0 1 .085 r
F
P
p
.62081 .35829 m .63103 .35637 L .63716 .36079 L 0 1 .093 r
F
P
p
.72134 .3563 m .73738 .35882 L .72689 .36071 L .814 1 0 r
F
P
p
.71086 .35821 m .72134 .3563 L .72689 .36071 L .744 1 0 r
F
P
p
.002 w
.46511 .82478 m .45537 .82538 L .44806 .82398 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43834 .82459 m .44806 .82398 L .45537 .82538 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33329 .356 m .35076 .35852 L .34134 .36042 L .116 0 1 r
F
P
p
.32389 .35791 m .33329 .356 L .34134 .36042 L .465 0 1 r
F
P
p
.42362 .35592 m .44075 .35844 L .43109 .36034 L 0 .243 1 r
F
P
p
.41396 .35783 m .42362 .35592 L .43109 .36034 L .081 0 1 r
F
P
p
.51396 .35584 m .53077 .35837 L .52085 .36027 L 0 .86 1 r
F
P
p
.50405 .35776 m .51396 .35584 L .52085 .36027 L 0 .767 1 r
F
P
p
.002 w
.61168 .7689 m .60153 .76965 L .59517 .76789 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.58503 .76865 m .59517 .76789 L .60153 .76965 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.60433 .35576 m .62081 .35829 L .61063 .36019 L 0 1 .163 r
F
P
p
.59417 .35768 m .60433 .35576 L .61063 .36019 L 0 1 .233 r
F
P
p
.69472 .35568 m .71086 .35821 L .70044 .36011 L .433 1 0 r
F
P
p
.6843 .3576 m .69472 .35568 L .70044 .36011 L .318 1 0 r
F
P
p
.78513 .3556 m .80094 .35813 L .79026 .36003 L 1 .593 0 r
F
P
p
.77445 .35752 m .78513 .3556 L .79026 .36003 L 1 .698 0 r
F
P
p
.002 w
.43834 .82459 m .42867 .82519 L .42118 .82379 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41152 .8244 m .42118 .82379 L .42867 .82519 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.3063 .35539 m .32389 .35791 L .31454 .35982 L .291 0 1 r
F
P
p
.002 w
.53838 .80308 m .52843 .80375 L .52159 .8022 L p
0 .016 1 r
F P
0 0 0 r
s
P
p
.002 w
.51165 .80287 m .52159 .8022 L .52843 .80375 L p
.122 0 1 r
F P
0 0 0 r
s
P
p
.39671 .35531 m .41396 .35783 L .40436 .35974 L 0 .163 1 r
F
P
p
.38712 .35722 m .39671 .35531 L .40436 .35974 L 0 .093 1 r
F
P
p
.48713 .35523 m .50405 .35776 L .4942 .35966 L .395 0 1 r
F
P
p
.47729 .35715 m .48713 .35523 L .4942 .35966 L .465 0 1 r
F
P
p
.002 w
.58503 .76865 m .57495 .76941 L .56841 .76765 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.55833 .76841 m .56841 .76765 L .57495 .76941 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.57758 .35515 m .59417 .35768 L .58406 .35958 L 0 1 .233 r
F
P
p
.56748 .35707 m .57758 .35515 L .58406 .35958 L 0 1 .407 r
F
P
p
.66804 .35507 m .6843 .3576 L .67394 .3595 L 0 1 .013 r
F
P
p
.65769 .35699 m .66804 .35507 L .67394 .3595 L 0 1 .018 r
F
P
p
.75853 .35499 m .77445 .35752 L .76384 .35942 L 1 .907 0 r
F
P
p
.74792 .35691 m .75853 .35499 L .76384 .35942 L 1 .985 0 r
F
P
p
.002 w
.41152 .8244 m .40192 .825 L .39425 .82359 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38466 .8242 m .39425 .82359 L .40192 .825 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51165 .80287 m .50177 .80354 L .49463 .82296 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48474 .82357 m .49463 .82296 L .50177 .80354 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.36975 .35469 m .38712 .35722 L .37758 .35913 L 0 .372 1 r
F
P
p
.36023 .35661 m .36975 .35469 L .37758 .35913 L 0 .128 1 r
F
P
p
.46025 .35461 m .47729 .35715 L .4675 .35905 L 0 .023 1 r
F
P
p
.45048 .35653 m .46025 .35461 L .4675 .35905 L 0 .023 1 r
F
P
p
.002 w
.55833 .76841 m .54832 .76917 L .5416 .7674 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.54832 .76917 m .53838 .80308 L .53159 .76817 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.002 w
.53159 .76817 m .5416 .7674 L .54832 .76917 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.55078 .35453 m .56748 .35707 L .55744 .35897 L 0 1 .018 r
F
P
p
.54074 .35645 m .55078 .35453 L .55744 .35897 L 0 1 .058 r
F
P
p
.64132 .35445 m .65769 .35699 L .6474 .35889 L 0 1 .042 r
F
P
p
.63103 .35637 m .64132 .35445 L .6474 .35889 L 0 1 .085 r
F
P
p
.73188 .35437 m .74792 .35691 L .73738 .35882 L .945 1 0 r
F
P
p
.72134 .3563 m .73188 .35437 L .73738 .35882 L .814 1 0 r
F
P
p
.002 w
.38466 .8242 m .37513 .82481 L .36727 .8234 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47489 .82418 m .46511 .82478 L .45784 .82337 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44806 .82398 m .45784 .82337 L .46511 .82478 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.34275 .35408 m .36023 .35661 L .35076 .35852 L 0 .233 1 r
F
P
p
.33329 .356 m .34275 .35408 L .35076 .35852 L .116 0 1 r
F
P
p
.43333 .354 m .45048 .35653 L .44075 .35844 L 0 .487 1 r
F
P
p
.42362 .35592 m .43333 .354 L .44075 .35844 L 0 .243 1 r
F
P
p
.52393 .35392 m .54074 .35645 L .53077 .35837 L 0 1 .965 r
F
P
p
.51396 .35584 m .52393 .35392 L .53077 .35837 L 0 .86 1 r
F
P
p
.002 w
.62188 .76814 m .61168 .7689 L .60523 .7536 L p
0 .589 1 r
F P
0 0 0 r
s
P
p
.002 w
.59517 .76789 m .60523 .7536 L .61168 .7689 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.61455 .35384 m .63103 .35637 L .62081 .35829 L 0 1 .093 r
F
P
p
.60433 .35576 m .61455 .35384 L .62081 .35829 L 0 1 .163 r
F
P
p
.70519 .35376 m .72134 .3563 L .71086 .35821 L .572 1 0 r
F
P
p
.69472 .35568 m .70519 .35376 L .71086 .35821 L .433 1 0 r
F
P
p
.79586 .35368 m .81167 .35622 L .80094 .35813 L 1 .395 0 r
F
P
p
.78513 .3556 m .79586 .35368 L .80094 .35813 L 1 .593 0 r
F
P
p
.002 w
.44806 .82398 m .43834 .82459 L .43089 .82318 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42118 .82379 m .43089 .82318 L .43834 .82459 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31569 .35346 m .33329 .356 L .32389 .35791 L .116 0 1 r
F
P
p
.3063 .35539 m .31569 .35346 L .32389 .35791 L .291 0 1 r
F
P
p
.002 w
.52159 .8022 m .53159 .76817 L .53838 .80308 L p
0 .016 1 r
F P
0 0 0 r
s
P
p
.40635 .35338 m .42362 .35592 L .41396 .35783 L 0 .267 1 r
F
P
p
.39671 .35531 m .40635 .35338 L .41396 .35783 L 0 .163 1 r
F
P
p
.49703 .3533 m .51396 .35584 L .50405 .35776 L .256 0 1 r
F
P
p
.48713 .35523 m .49703 .3533 L .50405 .35776 L .395 0 1 r
F
P
p
.002 w
.59517 .76789 m .58503 .76865 L .57853 .76688 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.56841 .76765 m .57853 .76688 L .58503 .76865 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.58773 .35322 m .60433 .35576 L .59417 .35768 L 0 1 .088 r
F
P
p
.57758 .35515 m .58773 .35322 L .59417 .35768 L 0 1 .233 r
F
P
p
.67845 .35314 m .69472 .35568 L .6843 .3576 L .02 1 0 r
F
P
p
.66804 .35507 m .67845 .35314 L .6843 .3576 L 0 1 .013 r
F
P
p
.76919 .35306 m .78513 .3556 L .77445 .35752 L 1 .907 0 r
F
P
p
.75853 .35499 m .76919 .35306 L .77445 .35752 L 1 .907 0 r
F
P
p
.002 w
.42118 .82379 m .41152 .8244 L .40389 .82298 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39425 .82359 m .40389 .82298 L .41152 .8244 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52159 .8022 m .51165 .80287 L .50459 .82234 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49463 .82296 m .50459 .82234 L .51165 .80287 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.37933 .35276 m .39671 .35531 L .38712 .35722 L 0 .512 1 r
F
P
p
.36975 .35469 m .37933 .35276 L .38712 .35722 L 0 .372 1 r
F
P
p
.47008 .35268 m .48713 .35523 L .47729 .35715 L 0 .187 1 r
F
P
p
.46025 .35461 m .47008 .35268 L .47729 .35715 L 0 .023 1 r
F
P
p
.002 w
.56841 .76765 m .55833 .76841 L .55166 .76663 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.5416 .7674 m .55166 .76663 L .55833 .76841 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.56086 .3526 m .57758 .35515 L .56748 .35707 L .02 1 0 r
F
P
p
.55078 .35453 m .56086 .3526 L .56748 .35707 L 0 1 .018 r
F
P
p
.65166 .35252 m .66804 .35507 L .65769 .35699 L .025 1 0 r
F
P
p
.64132 .35445 m .65166 .35252 L .65769 .35699 L 0 1 .042 r
F
P
p
.74248 .35244 m .75853 .35499 L .74792 .35691 L 1 .95 0 r
F
P
p
.73188 .35437 m .74248 .35244 L .74792 .35691 L .945 1 0 r
F
P
p
.002 w
.64209 .74114 m .63181 .74198 L .62555 .73506 L p
0 .889 1 r
F P
0 0 0 r
s
P
p
.002 w
.63181 .74198 m .62188 .76814 L .61533 .74087 L p
0 .764 1 r
F P
0 0 0 r
s
P
p
.002 w
.61533 .74087 m .62555 .73506 L .63181 .74198 L p
0 .764 1 r
F P
0 0 0 r
s
P
p
.002 w
.39425 .82359 m .38466 .8242 L .37685 .82279 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36727 .8234 m .37685 .82279 L .38466 .8242 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48474 .82357 m .47489 .82418 L .46767 .82276 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45784 .82337 m .46767 .82276 L .47489 .82418 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35225 .35214 m .36975 .35469 L .36023 .35661 L 0 .233 1 r
F
P
p
.34275 .35408 m .35225 .35214 L .36023 .35661 L 0 .233 1 r
F
P
p
.44309 .35206 m .46025 .35461 L .45048 .35653 L 0 .512 1 r
F
P
p
.43333 .354 m .44309 .35206 L .45048 .35653 L 0 .487 1 r
F
P
p
.002 w
.5416 .7674 m .53159 .76817 L .52469 .79996 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.53159 .76817 m .52159 .8022 L .51465 .80064 L p
0 .016 1 r
F P
0 0 0 r
s
P
p
.002 w
.51465 .80064 m .52469 .79996 L .53159 .76817 L p
0 .016 1 r
F P
0 0 0 r
s
P
p
.53395 .35198 m .55078 .35453 L .54074 .35645 L 0 1 .581 r
F
P
p
.52393 .35392 m .53395 .35198 L .54074 .35645 L 0 1 .965 r
F
P
p
.002 w
.60523 .7536 m .61533 .74087 L .62188 .76814 L p
0 .589 1 r
F P
0 0 0 r
s
P
p
.62483 .3519 m .64132 .35445 L .63103 .35637 L 0 1 .085 r
F
P
p
.61455 .35384 m .62483 .3519 L .63103 .35637 L 0 1 .093 r
F
P
p
.71573 .35182 m .73188 .35437 L .72134 .3563 L .744 1 0 r
F
P
p
.70519 .35376 m .71573 .35182 L .72134 .3563 L .572 1 0 r
F
P
p
.80665 .35174 m .82247 .35429 L .81167 .35622 L 1 .302 0 r
F
P
p
.79586 .35368 m .80665 .35174 L .81167 .35622 L 1 .395 0 r
F
P
p
.002 w
.45784 .82337 m .44806 .82398 L .44065 .82256 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43089 .82318 m .44065 .82256 L .44806 .82398 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.32513 .35152 m .34275 .35408 L .33329 .356 L 0 .058 1 r
F
P
p
.31569 .35346 m .32513 .35152 L .33329 .356 L .116 0 1 r
F
P
p
.41605 .35144 m .43333 .354 L .42362 .35592 L 0 .417 1 r
F
P
p
.40635 .35338 m .41605 .35144 L .42362 .35592 L 0 .267 1 r
F
P
p
.50698 .35136 m .52393 .35392 L .51396 .35584 L .186 0 1 r
F
P
p
.49703 .3533 m .50698 .35136 L .51396 .35584 L .256 0 1 r
F
P
p
.002 w
.60523 .7536 m .59517 .76789 L .58872 .7661 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.57853 .76688 m .58872 .7661 L .59517 .76789 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.59794 .35128 m .61455 .35384 L .60433 .35576 L 0 1 .047 r
F
P
p
.58773 .35322 m .59794 .35128 L .60433 .35576 L 0 1 .088 r
F
P
p
.68892 .3512 m .70519 .35376 L .69472 .35568 L .226 1 0 r
F
P
p
.67845 .35314 m .68892 .3512 L .69472 .35568 L .02 1 0 r
F
P
p
.77992 .35112 m .79586 .35368 L .78513 .3556 L 1 .802 0 r
F
P
p
.76919 .35306 m .77992 .35112 L .78513 .3556 L 1 .907 0 r
F
P
p
.002 w
.43089 .82318 m .42118 .82379 L .41359 .82237 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40389 .82298 m .41359 .82237 L .42118 .82379 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.29796 .3509 m .31569 .35346 L .3063 .35539 L .116 0 1 r
F
P
p
.002 w
.50459 .82234 m .51465 .80064 L .52159 .8022 L p
.208 0 1 r
F P
0 0 0 r
s
P
p
.38896 .35082 m .40635 .35338 L .39671 .35531 L 0 .512 1 r
F
P
p
.37933 .35276 m .38896 .35082 L .39671 .35531 L 0 .512 1 r
F
P
p
.47997 .35074 m .49703 .3533 L .48713 .35523 L 0 .431 1 r
F
P
p
.47008 .35268 m .47997 .35074 L .48713 .35523 L 0 .187 1 r
F
P
p
.002 w
.58872 .7661 m .59896 .76533 L .60523 .7536 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.58195 .72799 m .59184 .6821 L .59896 .76533 L p
0 .912 1 r
F P
0 0 0 r
s
P
p
.002 w
.59896 .76533 m .58872 .7661 L .58195 .72799 L p
0 .912 1 r
F P
0 0 0 r
s
P
p
.002 w
.58195 .72799 m .58872 .7661 L p
.57352 .76517 L 0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.57195 .76508 m .58195 .72799 L p
.57352 .76517 L 0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.58195 .72799 m .57756 .76301 L p
.59003 .69236 L 0 .848 1 r
F P
0 0 0 r
s
P
p
.002 w
.59184 .6821 m .58195 .72799 L p
.59003 .69236 L 0 .848 1 r
F P
0 0 0 r
s
P
p
.002 w
.57853 .76688 m .56898 .7676 L p
.57118 .76643 L 0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.58872 .7661 m .57853 .76688 L .57195 .76508 L p
0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.57195 .76508 m .57853 .76688 L p
.57051 .76639 L 0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.56178 .76586 m .57195 .76508 L p
.57051 .76639 L 0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.57195 .76508 m .56542 .7972 L p
.57341 .76375 L 0 .376 1 r
F P
0 0 0 r
s
P
p
.002 w
.58195 .72799 m .57195 .76508 L p
.57341 .76375 L 0 .376 1 r
F P
0 0 0 r
s
P
p
.002 w
.57756 .76301 m .57565 .77823 L p
.57828 .76263 L 0 .848 1 r
F P
0 0 0 r
s
P
p
.57828 .76263 m .59184 .6821 L .57756 .76301 L 0 .848 1 r
F
P
p
.002 w
.56841 .76765 m .56178 .76586 L p
.57118 .76643 L 0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.56898 .7676 m .56841 .76765 L p
.57118 .76643 L 0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.55166 .76663 m .56178 .76586 L .56841 .76765 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.57101 .35066 m .58773 .35322 L .57758 .35515 L .087 1 0 r
F
P
p
.56086 .3526 m .57101 .35066 L .57758 .35515 L .02 1 0 r
F
P
p
.002 w
.61533 .74087 m .60523 .7536 L .59896 .76533 L p
0 .589 1 r
F P
0 0 0 r
s
P
p
.66206 .35058 m .67845 .35314 L .66804 .35507 L .063 1 0 r
F
P
p
.65166 .35252 m .66206 .35058 L .66804 .35507 L .025 1 0 r
F
P
p
.75314 .35049 m .76919 .35306 L .75853 .35499 L 1 .882 0 r
F
P
p
.74248 .35244 m .75314 .35049 L .75853 .35499 L 1 .95 0 r
F
P
p
.002 w
.65235 .73533 m .64209 .74114 L .63587 .7342 L p
0 .972 1 r
F P
0 0 0 r
s
P
p
.002 w
.63587 .7342 m .64209 .74114 L p
.63232 .73755 L 0 .889 1 r
F P
0 0 0 r
s
P
p
.002 w
.63587 .7342 m .64603 .71817 L .65235 .73533 L p
0 .972 1 r
F P
0 0 0 r
s
P
p
.002 w
.63587 .7342 m .62986 .74925 L p
.63945 .73081 L 0 .923 1 r
F P
0 0 0 r
s
P
p
.002 w
.64603 .71817 m .63587 .7342 L p
.63945 .73081 L 0 .923 1 r
F P
0 0 0 r
s
P
p
.002 w
.62555 .73506 m .63587 .7342 L p
.63232 .73755 L 0 .889 1 r
F P
0 0 0 r
s
P
p
.002 w
.40389 .82298 m .39425 .82359 L .38648 .82217 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37685 .82279 m .38648 .82217 L .39425 .82359 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49463 .82296 m .48474 .82357 L .47755 .82214 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46767 .82276 m .47755 .82214 L .48474 .82357 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.36181 .35019 m .37933 .35276 L .36975 .35469 L 0 .372 1 r
F
P
p
.35225 .35214 m .36181 .35019 L .36975 .35469 L 0 .233 1 r
F
P
p
.45291 .35011 m .47008 .35268 L .46025 .35461 L 0 .512 1 r
F
P
p
.44309 .35206 m .45291 .35011 L .46025 .35461 L 0 .512 1 r
F
P
p
.002 w
.55166 .76663 m .5416 .7674 L .53479 .79928 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.52469 .79996 m .53479 .79928 L .5416 .7674 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.54402 .35003 m .56086 .3526 L .55078 .35453 L 0 1 .367 r
F
P
p
.53395 .35198 m .54402 .35003 L .55078 .35453 L 0 1 .581 r
F
P
p
.63516 .34995 m .65166 .35252 L .64132 .35445 L 0 1 .042 r
F
P
p
.62483 .3519 m .63516 .34995 L .64132 .35445 L 0 1 .085 r
F
P
p
.72632 .34987 m .74248 .35244 L .73188 .35437 L .919 1 0 r
F
P
p
.71573 .35182 m .72632 .34987 L .73188 .35437 L .744 1 0 r
F
P
p
.8175 .34979 m .83333 .35236 L .82247 .35429 L 1 .221 0 r
F
P
p
.80665 .35174 m .8175 .34979 L .82247 .35429 L 1 .302 0 r
F
P
p
.002 w
.62555 .73506 m .61533 .74087 L .60926 .76455 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.59896 .76533 m .60926 .76455 L .61533 .74087 L p
0 .589 1 r
F P
0 0 0 r
s
P
p
.002 w
.37685 .82279 m .36727 .8234 L .35932 .82197 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46767 .82276 m .45784 .82337 L .45047 .82195 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44065 .82256 m .45047 .82195 L .45784 .82337 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33463 .34957 m .35225 .35214 L .34275 .35408 L 0 .233 1 r
F
P
p
.32513 .35152 m .33463 .34957 L .34275 .35408 L 0 .058 1 r
F
P
p
.4258 .34949 m .44309 .35206 L .43333 .354 L 0 .487 1 r
F
P
p
.41605 .35144 m .4258 .34949 L .43333 .354 L 0 .417 1 r
F
P
p
.51699 .34941 m .53395 .35198 L .52393 .35392 L .012 0 1 r
F
P
p
.50698 .35136 m .51699 .34941 L .52393 .35392 L .186 0 1 r
F
P
p
.60821 .34933 m .62483 .3519 L .61455 .35384 L .02 1 0 r
F
P
p
.59794 .35128 m .60821 .34933 L .61455 .35384 L 0 1 .047 r
F
P
p
.69945 .34925 m .71573 .35182 L .70519 .35376 L .607 1 0 r
F
P
p
.68892 .3512 m .69945 .34925 L .70519 .35376 L .226 1 0 r
F
P
p
.79071 .34917 m .80665 .35174 L .79586 .35368 L 1 .64 0 r
F
P
p
.77992 .35112 m .79071 .34917 L .79586 .35368 L 1 .802 0 r
F
P
p
.002 w
.67275 .70993 m .66233 .71086 L .65631 .7087 L p
0 1 .602 r
F P
0 0 0 r
s
P
p
.002 w
.66233 .71086 m .65235 .73533 L .64603 .71817 L p
0 1 .812 r
F P
0 0 0 r
s
P
p
.002 w
.65631 .7087 m .66233 .71086 L p
.65188 .71555 L 0 1 .812 r
F P
0 0 0 r
s
P
p
.002 w
.66644 .68915 m .67275 .70993 L p
.66109 .70906 L 0 1 .602 r
F P
0 0 0 r
s
P
p
.002 w
.65631 .7087 m .66644 .68915 L p
.66109 .70906 L 0 1 .602 r
F P
0 0 0 r
s
P
p
.002 w
.66644 .68915 m .65631 .7087 L p
.66076 .7018 L 0 1 .677 r
F P
0 0 0 r
s
P
p
.002 w
.66072 .70555 m .66644 .68915 L p
.65346 .71808 L 0 1 .677 r
F P
0 0 0 r
s
P
p
.002 w
.65048 .7247 m .66072 .70555 L p
.65346 .71808 L 0 1 .677 r
F P
0 0 0 r
s
P
p
.002 w
.66644 .68915 m .66072 .70555 L p
.67181 .66918 L 0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.67629 .65446 m .66644 .68915 L p
.67181 .66918 L 0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.65631 .7087 m .65182 .72102 L p
.66076 .7018 L 0 1 .677 r
F P
0 0 0 r
s
P
p
.002 w
.65182 .72102 m .65048 .7247 L p
.65346 .71808 L 0 1 .677 r
F P
0 0 0 r
s
P
p
.65346 .71808 m .66076 .7018 L .65182 .72102 L 0 1 .677 r
F
P
p
.002 w
.68319 .70731 m .67275 .70993 L .66834 .69541 L p
0 1 .379 r
F P
0 0 0 r
s
P
p
.002 w
.66834 .69541 m .66644 .68915 L p
.66958 .69255 L 0 1 .379 r
F P
0 0 0 r
s
P
p
.66958 .69255 m .68319 .70731 L .66834 .69541 L 0 1 .379 r
F
P
p
.002 w
.69336 .68946 m .68319 .70731 L .67748 .66353 L p
0 1 .079 r
F P
0 0 0 r
s
P
p
.002 w
.67748 .66353 m .67629 .65446 L p
.67871 .65942 L 0 1 .079 r
F P
0 0 0 r
s
P
p
.67871 .65942 m .69336 .68946 L .67748 .66353 L 0 1 .079 r
F
P
p
.002 w
.67629 .65446 m .68638 .63314 L .69336 .68946 L p
0 1 .079 r
F P
0 0 0 r
s
P
p
.002 w
.66644 .68915 m .67629 .65446 L .68319 .70731 L p
0 1 .379 r
F P
0 0 0 r
s
P
p
.002 w
.6817 .66458 m .68618 .6345 L p
.67789 .67338 L 0 1 .016 r
F P
0 0 0 r
s
P
p
.002 w
.68618 .6345 m .68638 .63314 L p
.6859 .63545 L 0 1 .016 r
F P
0 0 0 r
s
P
p
.67789 .67338 m .68618 .6345 L .6859 .63545 L 0 1 .016 r
F
P
p
.002 w
.68122 .66776 m .6817 .66458 L p
.67994 .67132 L 0 1 .016 r
F P
0 0 0 r
s
P
p
.6713 .70459 m .6817 .66458 L .67789 .67338 L 0 1 .016 r
F
P
p
.002 w
.68638 .63314 m .67629 .65446 L .67319 .68563 L p
0 1 .016 r
F P
0 0 0 r
s
P
p
.002 w
.67319 .68563 m .6713 .70459 L p
.676 .68233 L 0 1 .016 r
F P
0 0 0 r
s
P
p
.676 .68233 m .68638 .63314 L .67319 .68563 L 0 1 .016 r
F
P
p
.002 w
.70258 .62976 m .69336 .68946 L .68638 .63314 L p
.34 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69681 .62706 m .70258 .62976 L p
.68996 .6324 L .34 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68638 .63314 m .69681 .62706 L p
.68996 .6324 L .34 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71272 .61195 m .70258 .62976 L .69681 .62706 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69681 .62706 m .69187 .66669 L p
.70371 .62169 L .479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69681 .62706 m .70701 .60913 L .71272 .61195 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70701 .60913 m .69681 .62706 L p
.70371 .62169 L .479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69681 .62706 m .68638 .63314 L .68122 .66776 L p
.235 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68122 .66776 m .69187 .66669 L .69681 .62706 L p
.235 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68505 .62155 m .69149 .66417 L p
.67569 .62586 L .256 1 0 r
F P
0 0 0 r
s
P
p
.67441 .62275 m .69149 .66417 L .69107 .66467 L .256 1 0 r
F
P
p
.002 w
.68122 .66776 m .67441 .62275 L p
.68648 .65311 L .256 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66072 .70555 m .6713 .70459 L .67629 .65446 L p
0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.66383 .62394 m .67441 .62275 L .68122 .66776 L p
.109 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70173 .6281 m .69187 .66669 L .68505 .62155 L p
.437 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68505 .62155 m .6956 .61381 L .70173 .6281 L p
.437 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68505 .62155 m .67989 .66164 L p
.69449 .61719 L .283 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6956 .61381 m .68505 .62155 L p
.69449 .61719 L .283 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67441 .62275 m .68505 .62155 L p
.67569 .62586 L .256 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69149 .66417 m .69187 .66669 L p
.69107 .66467 L .256 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69187 .66669 m .68122 .66776 L p
.68648 .65311 L .256 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6713 .70459 m .68122 .66776 L p
.67994 .67132 L 0 1 .016 r
F P
0 0 0 r
s
P
p
.002 w
.66072 .70555 m .66067 .70509 L p
.66801 .69297 L 0 1 .107 r
F P
0 0 0 r
s
P
p
.002 w
.66067 .70509 m .65359 .64199 L p
.6678 .69224 L 0 1 .107 r
F P
0 0 0 r
s
P
p
.6678 .69224 m .66801 .69297 L .66067 .70509 L 0 1 .107 r
F
P
p
.002 w
.6713 .70459 m .66072 .70555 L p
.66801 .69297 L 0 1 .107 r
F P
0 0 0 r
s
P
p
.002 w
.64603 .71817 m .65631 .7087 L p
.65188 .71555 L 0 1 .812 r
F P
0 0 0 r
s
P
p
.002 w
.44065 .82256 m .43089 .82318 L .42334 .82175 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41359 .82237 m .42334 .82175 L .43089 .82318 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.30739 .34895 m .32513 .35152 L .31569 .35346 L 0 .233 1 r
F
P
p
.29796 .3509 m .30739 .34895 L .31569 .35346 L .116 0 1 r
F
P
p
.39864 .34886 m .41605 .35144 L .40635 .35338 L 0 .512 1 r
F
P
p
.38896 .35082 m .39864 .34886 L .40635 .35338 L 0 .512 1 r
F
P
p
.48991 .34878 m .50698 .35136 L .49703 .3533 L 0 .547 1 r
F
P
p
.47997 .35074 m .48991 .34878 L .49703 .3533 L 0 .431 1 r
F
P
p
.58121 .3487 m .59794 .35128 L .58773 .35322 L .159 1 0 r
F
P
p
.57101 .35066 m .58121 .3487 L .58773 .35322 L .087 1 0 r
F
P
p
.67253 .34862 m .68892 .3512 L .67845 .35314 L .132 1 0 r
F
P
p
.66206 .35058 m .67253 .34862 L .67845 .35314 L .063 1 0 r
F
P
p
.76386 .34854 m .77992 .35112 L .76919 .35306 L 1 .804 0 r
F
P
p
.75314 .35049 m .76386 .34854 L .76919 .35306 L 1 .882 0 r
F
P
p
.002 w
.41359 .82237 m .40389 .82298 L .39616 .82155 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38648 .82217 m .39616 .82155 L .40389 .82298 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50459 .82234 m .49463 .82296 L .4875 .82152 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47755 .82214 m .4875 .82152 L .49463 .82296 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63587 .7342 m .62555 .73506 L .61946 .75008 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.61946 .75008 m .62555 .73506 L p
.61134 .76078 L 0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.61946 .75008 m .61229 .67164 L p
.62762 .73934 L 0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.61946 .75008 m .62986 .74925 L .63587 .7342 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.62986 .74925 m .61946 .75008 L p
.62762 .73934 L 0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.60926 .76455 m .61946 .75008 L p
.61134 .76078 L 0 .714 1 r
F P
0 0 0 r
s
P
p
.37143 .34824 m .38896 .35082 L .37933 .35276 L 0 .512 1 r
F
P
p
.36181 .35019 m .37143 .34824 L .37933 .35276 L 0 .372 1 r
F
P
p
.46278 .34816 m .47997 .35074 L .47008 .35268 L 0 .71 1 r
F
P
p
.45291 .35011 m .46278 .34816 L .47008 .35268 L 0 .512 1 r
F
P
p
.002 w
.72329 .61074 m .71272 .61195 L .70701 .60913 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56178 .76586 m .55166 .76663 L .54494 .79859 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.53479 .79928 m .54494 .79859 L .55166 .76663 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.55416 .34807 m .57101 .35066 L .56086 .3526 L 0 1 .225 r
F
P
p
.54402 .35003 m .55416 .34807 L .56086 .3526 L 0 1 .367 r
F
P
p
.64555 .34799 m .66206 .35058 L .65166 .35252 L .02 1 0 r
F
P
p
.63516 .34995 m .64555 .34799 L .65166 .35252 L 0 1 .042 r
F
P
p
.73697 .34791 m .75314 .35049 L .74248 .35244 L .953 1 0 r
F
P
p
.72632 .34987 m .73697 .34791 L .74248 .35244 L .919 1 0 r
F
P
p
.82841 .34783 m .84424 .35041 L .83333 .35236 L 1 .105 0 r
F
P
p
.8175 .34979 m .82841 .34783 L .83333 .35236 L 1 .221 0 r
F
P
p
.002 w
.60926 .76455 m .59896 .76533 L .59184 .6821 L p
0 1 .867 r
F P
0 0 0 r
s
P
p
.002 w
.59184 .6821 m .602 .67268 L .60926 .76455 L p
0 1 .867 r
F P
0 0 0 r
s
P
p
.002 w
.602 .67268 m .59184 .6821 L .58591 .76166 L p
0 1 .867 r
F P
0 0 0 r
s
P
p
.002 w
.57565 .77823 m .58591 .76166 L .59184 .6821 L p
0 .848 1 r
F P
0 0 0 r
s
P
p
.002 w
.38648 .82217 m .37685 .82279 L .36893 .82135 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35932 .82197 m .36893 .82135 L .37685 .82279 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47755 .82214 m .46767 .82276 L .46035 .82133 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45047 .82195 m .46035 .82133 L .46767 .82276 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.34417 .34761 m .36181 .35019 L .35225 .35214 L 0 .233 1 r
F
P
p
.33463 .34957 m .34417 .34761 L .35225 .35214 L 0 .233 1 r
F
P
p
.43561 .34753 m .45291 .35011 L .44309 .35206 L 0 .645 1 r
F
P
p
.4258 .34949 m .43561 .34753 L .44309 .35206 L 0 .487 1 r
F
P
p
.52706 .34745 m .54402 .35003 L .53395 .35198 L 0 .337 1 r
F
P
p
.51699 .34941 m .52706 .34745 L .53395 .35198 L .012 0 1 r
F
P
p
.61854 .34737 m .63516 .34995 L .62483 .3519 L .162 1 0 r
F
P
p
.60821 .34933 m .61854 .34737 L .62483 .3519 L .02 1 0 r
F
P
p
.71003 .34728 m .72632 .34987 L .71573 .35182 L .884 1 0 r
F
P
p
.69945 .34925 m .71003 .34728 L .71573 .35182 L .607 1 0 r
F
P
p
.80155 .3472 m .8175 .34979 L .80665 .35174 L 1 .547 0 r
F
P
p
.79071 .34917 m .80155 .3472 L .80665 .35174 L 1 .64 0 r
F
P
p
.002 w
.45047 .82195 m .44065 .82256 L .43315 .82113 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42334 .82175 m .43315 .82113 L .44065 .82256 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31687 .34698 m .33463 .34957 L .32513 .35152 L 0 .233 1 r
F
P
p
.30739 .34895 m .31687 .34698 L .32513 .35152 L 0 .233 1 r
F
P
p
.40838 .3469 m .4258 .34949 L .41605 .35144 L 0 .512 1 r
F
P
p
.39864 .34886 m .40838 .3469 L .41605 .35144 L 0 .512 1 r
F
P
p
.49991 .34682 m .51699 .34941 L .50698 .35136 L 0 .583 1 r
F
P
p
.48991 .34878 m .49991 .34682 L .50698 .35136 L 0 .547 1 r
F
P
p
.59147 .34674 m .60821 .34933 L .59794 .35128 L .232 1 0 r
F
P
p
.58121 .3487 m .59147 .34674 L .59794 .35128 L .159 1 0 r
F
P
p
.68305 .34665 m .69945 .34925 L .68892 .3512 L .383 1 0 r
F
P
p
.67253 .34862 m .68305 .34665 L .68892 .3512 L .132 1 0 r
F
P
p
.002 w
.61946 .75008 m .60926 .76455 L .602 .67268 L p
0 1 .777 r
F P
0 0 0 r
s
P
p
.002 w
.602 .67268 m .61229 .67164 L .61946 .75008 L p
0 1 .777 r
F P
0 0 0 r
s
P
p
.002 w
.61229 .67164 m .602 .67268 L .59631 .76086 L p
0 1 .833 r
F P
0 0 0 r
s
P
p
.002 w
.58591 .76166 m .59631 .76086 L .602 .67268 L p
0 1 .867 r
F P
0 0 0 r
s
P
p
.77464 .34657 m .79071 .34917 L .77992 .35112 L 1 .725 0 r
F
P
p
.76386 .34854 m .77464 .34657 L .77992 .35112 L 1 .804 0 r
F
P
p
.002 w
.42334 .82175 m .41359 .82237 L .4059 .82093 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39616 .82155 m .4059 .82093 L .41359 .82237 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.28951 .34635 m .30739 .34895 L .29796 .3509 L 0 .058 1 r
F
P
p
.002 w
.51465 .80064 m .50459 .82234 L .4975 .8209 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4875 .82152 m .4975 .8209 L .50459 .82234 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52469 .79996 m .51465 .80064 L .50755 .82027 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4975 .8209 m .50755 .82027 L .51465 .80064 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.3811 .34627 m .39864 .34886 L .38896 .35082 L 0 .512 1 r
F
P
p
.37143 .34824 m .3811 .34627 L .38896 .35082 L 0 .512 1 r
F
P
p
.47272 .34619 m .48991 .34878 L .47997 .35074 L 0 1 .952 r
F
P
p
.46278 .34816 m .47272 .34619 L .47997 .35074 L 0 .71 1 r
F
P
p
.002 w
.73392 .60952 m .72329 .61074 L .71764 .60791 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70701 .60913 m .71764 .60791 L .72329 .61074 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57195 .76508 m .56178 .76586 L .55515 .7979 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.54494 .79859 m .55515 .7979 L .56178 .76586 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.56435 .34611 m .58121 .3487 L .57101 .35066 L 0 1 .053 r
F
P
p
.55416 .34807 m .56435 .34611 L .57101 .35066 L 0 1 .225 r
F
P
p
.65601 .34602 m .67253 .34862 L .66206 .35058 L .057 1 0 r
F
P
p
.64555 .34799 m .65601 .34602 L .66206 .35058 L .02 1 0 r
F
P
p
.74769 .34594 m .76386 .34854 L .75314 .35049 L .978 1 0 r
F
P
p
.73697 .34791 m .74769 .34594 L .75314 .35049 L .953 1 0 r
F
P
p
.83939 .34586 m .85522 .34846 L .84424 .35041 L 1 .035 0 r
F
P
p
.82841 .34783 m .83939 .34586 L .84424 .35041 L 1 .105 0 r
F
P
p
.002 w
.39616 .82155 m .38648 .82217 L .3786 .82073 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36893 .82135 m .3786 .82073 L .38648 .82217 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65631 .7087 m .64603 .71817 L .64008 .73129 L p
0 1 .886 r
F P
0 0 0 r
s
P
p
.002 w
.64008 .73129 m .64603 .71817 L p
.63201 .74513 L 0 .923 1 r
F P
0 0 0 r
s
P
p
.002 w
.64008 .73129 m .63302 .66954 L p
.64818 .71742 L 0 1 .453 r
F P
0 0 0 r
s
P
p
.002 w
.64008 .73129 m .65048 .7247 L .65631 .7087 L p
0 1 .886 r
F P
0 0 0 r
s
P
p
.002 w
.65048 .7247 m .64008 .73129 L p
.64818 .71742 L 0 1 .453 r
F P
0 0 0 r
s
P
p
.002 w
.62986 .74925 m .64008 .73129 L p
.63201 .74513 L 0 .923 1 r
F P
0 0 0 r
s
P
p
.002 w
.4875 .82152 m .47755 .82214 L .47028 .8207 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46035 .82133 m .47028 .8207 L .47755 .82214 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35377 .34564 m .37143 .34824 L .36181 .35019 L 0 .302 1 r
F
P
p
.34417 .34761 m .35377 .34564 L .36181 .35019 L 0 .233 1 r
F
P
p
.44547 .34556 m .46278 .34816 L .45291 .35011 L 0 .819 1 r
F
P
p
.43561 .34753 m .44547 .34556 L .45291 .35011 L 0 .645 1 r
F
P
p
.002 w
.56542 .7972 m .57565 .77823 L .58195 .72799 L p
0 .376 1 r
F P
0 0 0 r
s
P
p
.53718 .34547 m .55416 .34807 L .54402 .35003 L 0 .547 1 r
F
P
p
.52706 .34745 m .53718 .34547 L .54402 .35003 L 0 .337 1 r
F
P
p
.62892 .34539 m .64555 .34799 L .63516 .34995 L .299 1 0 r
F
P
p
.61854 .34737 m .62892 .34539 L .63516 .34995 L .162 1 0 r
F
P
p
.72068 .34531 m .73697 .34791 L .72632 .34987 L .953 1 0 r
F
P
p
.71003 .34728 m .72068 .34531 L .72632 .34987 L .884 1 0 r
F
P
p
.81246 .34523 m .82841 .34783 L .8175 .34979 L 1 .326 0 r
F
P
p
.80155 .3472 m .81246 .34523 L .8175 .34979 L 1 .547 0 r
F
P
p
.002 w
.36893 .82135 m .35932 .82197 L .35125 .82053 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46035 .82133 m .45047 .82195 L .44301 .8205 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43315 .82113 m .44301 .8205 L .45047 .82195 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.3264 .34501 m .34417 .34761 L .33463 .34957 L 0 .233 1 r
F
P
p
.31687 .34698 m .3264 .34501 L .33463 .34957 L 0 .233 1 r
F
P
p
.41817 .34492 m .43561 .34753 L .4258 .34949 L 0 .596 1 r
F
P
p
.40838 .3469 m .41817 .34492 L .4258 .34949 L 0 .512 1 r
F
P
p
.50997 .34484 m .52706 .34745 L .51699 .34941 L 0 .688 1 r
F
P
p
.49991 .34682 m .50997 .34484 L .51699 .34941 L 0 .583 1 r
F
P
p
.60179 .34476 m .61854 .34737 L .60821 .34933 L .334 1 0 r
F
P
p
.59147 .34674 m .60179 .34476 L .60821 .34933 L .232 1 0 r
F
P
p
.69363 .34468 m .71003 .34728 L .69945 .34925 L .762 1 0 r
F
P
p
.68305 .34665 m .69363 .34468 L .69945 .34925 L .383 1 0 r
F
P
p
.002 w
.61229 .67164 m .62263 .67059 L .62986 .74925 L p
0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.62263 .67059 m .61229 .67164 L .60677 .76005 L p
0 1 .648 r
F P
0 0 0 r
s
P
p
.002 w
.59631 .76086 m .60677 .76005 L .61229 .67164 L p
0 1 .833 r
F P
0 0 0 r
s
P
p
.78549 .34459 m .80155 .3472 L .79071 .34917 L 1 .663 0 r
F
P
p
.77464 .34657 m .78549 .34459 L .79071 .34917 L 1 .725 0 r
F
P
p
.002 w
.43315 .82113 m .42334 .82175 L .41569 .8203 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4059 .82093 m .41569 .8203 L .42334 .82175 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.29897 .34437 m .31687 .34698 L .30739 .34895 L 0 .302 1 r
F
P
p
.28951 .34635 m .29897 .34437 L .30739 .34895 L 0 .058 1 r
F
P
p
.002 w
.53479 .79928 m .52469 .79996 L .51767 .81964 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50755 .82027 m .51767 .81964 L .52469 .79996 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.39083 .34429 m .40838 .3469 L .39864 .34886 L 0 .512 1 r
F
P
p
.3811 .34627 m .39083 .34429 L .39864 .34886 L 0 .512 1 r
F
P
p
.4827 .34421 m .49991 .34682 L .48991 .34878 L 0 1 .767 r
F
P
p
.47272 .34619 m .4827 .34421 L .48991 .34878 L 0 1 .952 r
F
P
p
.002 w
.74461 .6083 m .73392 .60952 L .72832 .60667 L p
.907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72832 .60667 m .73392 .60952 L p
.72172 .60831 L .884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73891 .59982 m .74461 .6083 L p
.73105 .60694 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72832 .60667 m .73891 .59982 L p
.73105 .60694 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75536 .60707 m .74461 .6083 L .73891 .59982 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73891 .59982 m .74938 .58733 L .75536 .60707 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73891 .59982 m .73391 .61952 L p
.74682 .59266 L .837 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74938 .58733 m .73891 .59982 L p
.74682 .59266 L .837 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72832 .60667 m .72309 .62073 L p
.73498 .60502 L .767 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73891 .59982 m .72832 .60667 L p
.73498 .60502 L .767 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71764 .60791 m .72832 .60667 L p
.72172 .60831 L .884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55515 .7979 m .56542 .7972 L .57195 .76508 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.5746 .34413 m .59147 .34674 L .58121 .3487 L .049 1 0 r
F
P
p
.56435 .34611 m .5746 .34413 L .58121 .3487 L 0 1 .053 r
F
P
p
.66652 .34404 m .68305 .34665 L .67253 .34862 L .132 1 0 r
F
P
p
.65601 .34602 m .66652 .34404 L .67253 .34862 L .057 1 0 r
F
P
p
.75846 .34396 m .77464 .34657 L .76386 .34854 L 1 .944 0 r
F
P
p
.74769 .34594 m .75846 .34396 L .76386 .34854 L .978 1 0 r
F
P
p
.85043 .34388 m .86626 .34649 L .85522 .34846 L 1 0 0 r
F
P
p
.83939 .34586 m .85043 .34388 L .85522 .34846 L 1 .035 0 r
F
P
p
.002 w
.4059 .82093 m .39616 .82155 L .38833 .8201 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3786 .82073 m .38833 .8201 L .39616 .82155 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4975 .8209 m .4875 .82152 L .48027 .82007 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47028 .8207 m .48027 .82007 L .4875 .82152 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.36343 .34365 m .3811 .34627 L .37143 .34824 L 0 .442 1 r
F
P
p
.35377 .34564 m .36343 .34365 L .37143 .34824 L 0 .302 1 r
F
P
p
.45539 .34357 m .47272 .34619 L .46278 .34816 L 0 .895 1 r
F
P
p
.44547 .34556 m .45539 .34357 L .46278 .34816 L 0 .819 1 r
F
P
p
.002 w
.70173 .6281 m .70701 .60913 L p
.69947 .6378 L .479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69187 .66669 m .70173 .6281 L p
.69947 .6378 L .479 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70173 .6281 m .6956 .61381 L p
.704 .61833 L .642 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71764 .60791 m .70701 .60913 L .70173 .6281 L p
.72 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71234 .62283 m .71764 .60791 L p
.70341 .62597 L .72 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70173 .6281 m .71234 .62283 L p
.70341 .62597 L .72 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72832 .60667 m .71764 .60791 L .71234 .62283 L p
.741 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72309 .62073 m .72832 .60667 L p
.71275 .62241 L .741 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71234 .62283 m .72309 .62073 L p
.71275 .62241 L .741 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72309 .62073 m .73391 .61952 L .73891 .59982 L p
.767 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72309 .62073 m .7169 .60085 L p
.73348 .61904 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73391 .61952 m .72309 .62073 L p
.73348 .61904 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71234 .62283 m .70631 .61062 L p
.72132 .61967 L .706 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72309 .62073 m .71234 .62283 L p
.72132 .61967 L .706 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71234 .62283 m .70173 .6281 L p
.704 .61833 L .642 1 0 r
F P
0 0 0 r
s
P
p
.54737 .34349 m .56435 .34611 L .55416 .34807 L 0 .756 1 r
F
P
p
.53718 .34547 m .54737 .34349 L .55416 .34807 L 0 .547 1 r
F
P
p
.63937 .34341 m .65601 .34602 L .64555 .34799 L .326 1 0 r
F
P
p
.62892 .34539 m .63937 .34341 L .64555 .34799 L .299 1 0 r
F
P
p
.73139 .34333 m .74769 .34594 L .73697 .34791 L .953 1 0 r
F
P
p
.72068 .34531 m .73139 .34333 L .73697 .34791 L .953 1 0 r
F
P
p
.82343 .34324 m .83939 .34586 L .82841 .34783 L 1 .122 0 r
F
P
p
.81246 .34523 m .82343 .34324 L .82841 .34783 L 1 .326 0 r
F
P
p
.002 w
.3786 .82073 m .36893 .82135 L .36091 .8199 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35125 .82053 m .36091 .8199 L .36893 .82135 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47028 .8207 m .46035 .82133 L .45293 .81987 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44301 .8205 m .45293 .81987 L .46035 .82133 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33599 .34302 m .35377 .34564 L .34417 .34761 L 0 .233 1 r
F
P
p
.3264 .34501 m .33599 .34302 L .34417 .34761 L 0 .233 1 r
F
P
p
.42802 .34294 m .44547 .34556 L .43561 .34753 L 0 .863 1 r
F
P
p
.41817 .34492 m .42802 .34294 L .43561 .34753 L 0 .596 1 r
F
P
p
.52008 .34285 m .53718 .34547 L .52706 .34745 L 0 .826 1 r
F
P
p
.50997 .34484 m .52008 .34285 L .52706 .34745 L 0 .688 1 r
F
P
p
.61216 .34277 m .62892 .34539 L .61854 .34737 L .503 1 0 r
F
P
p
.60179 .34476 m .61216 .34277 L .61854 .34737 L .334 1 0 r
F
P
p
.70427 .34269 m .72068 .34531 L .71003 .34728 L 1 .977 0 r
F
P
p
.69363 .34468 m .70427 .34269 L .71003 .34728 L .762 1 0 r
F
P
p
.002 w
.64008 .73129 m .62986 .74925 L .62263 .67059 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.002 w
.62263 .67059 m .63302 .66954 L p
.62697 .68572 L 0 1 .651 r
F P
0 0 0 r
s
P
p
.002 w
.63302 .66954 m .64008 .73129 L p
.62697 .68572 L 0 1 .651 r
F P
0 0 0 r
s
P
p
.002 w
.63302 .66954 m .62263 .67059 L .61678 .71348 L p
0 1 .348 r
F P
0 0 0 r
s
P
p
.002 w
.63302 .66954 m .62694 .68414 L p
.6391 .6533 L 0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.64311 .64312 m .63302 .66954 L p
.6391 .6533 L 0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.63302 .66954 m .64311 .64312 L .65048 .7247 L p
0 1 .453 r
F P
0 0 0 r
s
P
p
.002 w
.62694 .68414 m .63302 .66954 L p
.62276 .6973 L 0 1 .348 r
F P
0 0 0 r
s
P
p
.002 w
.61678 .71348 m .62694 .68414 L p
.62276 .6973 L 0 1 .348 r
F P
0 0 0 r
s
P
p
.002 w
.62694 .68414 m .62516 .67884 L p
.62906 .67747 L 0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.62965 .67726 m .63736 .67454 L .64311 .64312 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.63736 .67454 m .62694 .68414 L p
.62906 .67747 L 0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.61864 .69982 m .62263 .67059 L p
.61585 .7088 L 0 1 .648 r
F P
0 0 0 r
s
P
p
.002 w
.62516 .67884 m .62035 .66457 L p
.62816 .66915 L 0 1 .198 r
F P
0 0 0 r
s
P
p
.62816 .66915 m .63736 .67454 L .62516 .67884 L 0 1 .198 r
F
P
p
.002 w
.60677 .76005 m .61678 .71348 L .61864 .69982 L p
0 1 .648 r
F P
0 0 0 r
s
P
p
.60677 .76005 m .61864 .69982 L .61585 .7088 L 0 1 .648 r
F
P
p
.79639 .34261 m .81246 .34523 L .80155 .3472 L 1 .593 0 r
F
P
p
.78549 .34459 m .79639 .34261 L .80155 .3472 L 1 .663 0 r
F
P
p
.002 w
.44301 .8205 m .43315 .82113 L .42554 .81967 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41569 .8203 m .42554 .81967 L .43315 .82113 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.30849 .34238 m .3264 .34501 L .31687 .34698 L 0 .372 1 r
F
P
p
.29897 .34437 m .30849 .34238 L .31687 .34698 L 0 .302 1 r
F
P
p
.002 w
.54494 .79859 m .53479 .79928 L .52784 .81901 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51767 .81964 m .52784 .81901 L .53479 .79928 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.40061 .3423 m .41817 .34492 L .40838 .3469 L 0 .512 1 r
F
P
p
.39083 .34429 m .40061 .3423 L .40838 .3469 L 0 .512 1 r
F
P
p
.49275 .34222 m .50997 .34484 L .49991 .34682 L 0 1 .719 r
F
P
p
.4827 .34421 m .49275 .34222 L .49991 .34682 L 0 1 .767 r
F
P
p
.58491 .34213 m .60179 .34476 L .59147 .34674 L .191 1 0 r
F
P
p
.5746 .34413 m .58491 .34213 L .59147 .34674 L .049 1 0 r
F
P
p
.67709 .34205 m .69363 .34468 L .68305 .34665 L .281 1 0 r
F
P
p
.66652 .34404 m .67709 .34205 L .68305 .34665 L .132 1 0 r
F
P
p
.7693 .34197 m .78549 .34459 L .77464 .34657 L 1 .794 0 r
F
P
p
.75846 .34396 m .7693 .34197 L .77464 .34657 L 1 .944 0 r
F
P
p
.86153 .34189 m .87737 .34451 L .86626 .34649 L 1 0 0 r
F
P
p
.85043 .34388 m .86153 .34189 L .86626 .34649 L 1 0 0 r
F
P
p
.002 w
.41569 .8203 m .4059 .82093 L .39811 .81947 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38833 .8201 m .39811 .81947 L .4059 .82093 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.28094 .34174 m .29897 .34437 L .28951 .34635 L 0 .233 1 r
F
P
p
.002 w
.50755 .82027 m .4975 .8209 L .49031 .81944 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48027 .82007 m .49031 .81944 L .4975 .8209 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.37314 .34166 m .39083 .34429 L .3811 .34627 L 0 .512 1 r
F
P
p
.36343 .34365 m .37314 .34166 L .3811 .34627 L 0 .442 1 r
F
P
p
.46536 .34158 m .4827 .34421 L .47272 .34619 L 0 1 .941 r
F
P
p
.45539 .34357 m .46536 .34158 L .47272 .34619 L 0 .895 1 r
F
P
p
.55761 .34149 m .5746 .34413 L .56435 .34611 L 0 1 .965 r
F
P
p
.54737 .34349 m .55761 .34149 L .56435 .34611 L 0 .756 1 r
F
P
p
.64987 .34141 m .66652 .34404 L .65601 .34602 L .331 1 0 r
F
P
p
.63937 .34341 m .64987 .34141 L .65601 .34602 L .326 1 0 r
F
P
p
.74216 .34133 m .75846 .34396 L .74769 .34594 L .997 1 0 r
F
P
p
.73139 .34333 m .74216 .34133 L .74769 .34594 L .953 1 0 r
F
P
p
.83447 .34125 m .85043 .34388 L .83939 .34586 L 1 .052 0 r
F
P
p
.82343 .34324 m .83447 .34125 L .83939 .34586 L 1 .122 0 r
F
P
p
.002 w
.38833 .8201 m .3786 .82073 L .37062 .81927 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36091 .8199 m .37062 .81927 L .3786 .82073 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48027 .82007 m .47028 .8207 L .46291 .81924 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45293 .81987 m .46291 .81924 L .47028 .8207 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66072 .70555 m .65048 .7247 L .64311 .64312 L p
0 1 .251 r
F P
0 0 0 r
s
P
p
.002 w
.65359 .64199 m .66072 .70555 L p
.64598 .65332 L 0 1 .251 r
F P
0 0 0 r
s
P
p
.002 w
.65359 .64199 m .66383 .62394 L .6713 .70459 L p
0 1 .107 r
F P
0 0 0 r
s
P
p
.002 w
.65359 .64199 m .64781 .66492 L p
.66123 .63061 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66383 .62394 m .65359 .64199 L p
.66123 .63061 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64311 .64312 m .65359 .64199 L p
.64598 .65332 L 0 1 .251 r
F P
0 0 0 r
s
P
p
.002 w
.65359 .64199 m .64311 .64312 L .63736 .67454 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.34563 .34102 m .36343 .34365 L .35377 .34564 L 0 .233 1 r
F
P
p
.33599 .34302 m .34563 .34102 L .35377 .34564 L 0 .233 1 r
F
P
p
.43793 .34094 m .45539 .34357 L .44547 .34556 L 0 1 .873 r
F
P
p
.42802 .34294 m .43793 .34094 L .44547 .34556 L 0 .863 1 r
F
P
p
.53025 .34085 m .54737 .34349 L .53718 .34547 L 0 .895 1 r
F
P
p
.52008 .34285 m .53025 .34085 L .53718 .34547 L 0 .826 1 r
F
P
p
.6226 .34077 m .63937 .34341 L .62892 .34539 L .605 1 0 r
F
P
p
.61216 .34277 m .6226 .34077 L .62892 .34539 L .503 1 0 r
F
P
p
.71497 .34069 m .73139 .34333 L .72068 .34531 L 1 .907 0 r
F
P
p
.70427 .34269 m .71497 .34069 L .72068 .34531 L 1 .977 0 r
F
P
p
.80736 .34061 m .82343 .34324 L .81246 .34523 L 1 .384 0 r
F
P
p
.79639 .34261 m .80736 .34061 L .81246 .34523 L 1 .593 0 r
F
P
p
.002 w
.36091 .8199 m .35125 .82053 L .34308 .81906 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45293 .81987 m .44301 .8205 L .43545 .81904 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42554 .81967 m .43545 .81904 L .44301 .8205 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31806 .34038 m .33599 .34302 L .3264 .34501 L 0 .372 1 r
F
P
p
.30849 .34238 m .31806 .34038 L .3264 .34501 L 0 .372 1 r
F
P
p
.002 w
.55515 .7979 m .54494 .79859 L .53807 .81837 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52784 .81901 m .53807 .81837 L .54494 .79859 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.41044 .3403 m .42802 .34294 L .41817 .34492 L 0 .596 1 r
F
P
p
.40061 .3423 m .41044 .3403 L .41817 .34492 L 0 .512 1 r
F
P
p
.50285 .34021 m .52008 .34285 L .50997 .34484 L 0 1 .614 r
F
P
p
.49275 .34222 m .50285 .34021 L .50997 .34484 L 0 1 .719 r
F
P
p
.002 w
.76591 .59742 m .75536 .60707 L .74938 .58733 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.59528 .34013 m .61216 .34277 L .60179 .34476 L .331 1 0 r
F
P
p
.58491 .34213 m .59528 .34013 L .60179 .34476 L .191 1 0 r
F
P
p
.68773 .34005 m .70427 .34269 L .69363 .34468 L .485 1 0 r
F
P
p
.67709 .34205 m .68773 .34005 L .69363 .34468 L .281 1 0 r
F
P
p
.7802 .33996 m .79639 .34261 L .78549 .34459 L 1 .676 0 r
F
P
p
.7693 .34197 m .7802 .33996 L .78549 .34459 L 1 .794 0 r
F
P
p
.87269 .33988 m .88854 .34252 L .87737 .34451 L 1 0 0 r
F
P
p
.86153 .34189 m .87269 .33988 L .87737 .34451 L 1 0 0 r
F
P
p
.002 w
.42554 .81967 m .41569 .8203 L .40794 .81883 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39811 .81947 m .40794 .81883 L .41569 .8203 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.29045 .33974 m .30849 .34238 L .29897 .34437 L 0 .337 1 r
F
P
p
.28094 .34174 m .29045 .33974 L .29897 .34437 L 0 .233 1 r
F
P
p
.002 w
.51767 .81964 m .50755 .82027 L .50041 .81881 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49031 .81944 m .50041 .81881 L .50755 .82027 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.38291 .33965 m .40061 .3423 L .39083 .34429 L 0 .512 1 r
F
P
p
.37314 .34166 m .38291 .33965 L .39083 .34429 L 0 .512 1 r
F
P
p
.4754 .33957 m .49275 .34222 L .4827 .34421 L 0 1 .801 r
F
P
p
.46536 .34158 m .4754 .33957 L .4827 .34421 L 0 1 .941 r
F
P
p
.56791 .33949 m .58491 .34213 L .5746 .34413 L 0 1 .826 r
F
P
p
.55761 .34149 m .56791 .33949 L .5746 .34413 L 0 1 .965 r
F
P
p
.66044 .3394 m .67709 .34205 L .66652 .34404 L .369 1 0 r
F
P
p
.64987 .34141 m .66044 .3394 L .66652 .34404 L .331 1 0 r
F
P
p
.75299 .33932 m .7693 .34197 L .75846 .34396 L 1 .933 0 r
F
P
p
.74216 .34133 m .75299 .33932 L .75846 .34396 L .997 1 0 r
F
P
p
.84556 .33924 m .86153 .34189 L .85043 .34388 L 1 0 0 r
F
P
p
.83447 .34125 m .84556 .33924 L .85043 .34388 L 1 .052 0 r
F
P
p
.002 w
.39811 .81947 m .38833 .8201 L .38039 .81863 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37062 .81927 m .38039 .81863 L .38833 .8201 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49031 .81944 m .48027 .82007 L .47294 .8186 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46291 .81924 m .47294 .8186 L .48027 .82007 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64781 .66492 m .65359 .64199 L p
.64144 .66635 L .081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64781 .66492 m .65844 .66383 L .66383 .62394 L p
.186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64781 .66492 m .64153 .66239 L p
.65423 .66347 L 0 1 .085 r
F P
0 0 0 r
s
P
p
.002 w
.65844 .66383 m .64781 .66492 L p
.65423 .66347 L 0 1 .085 r
F P
0 0 0 r
s
P
p
.002 w
.63736 .67454 m .64781 .66492 L p
.64144 .66635 L .081 1 0 r
F P
0 0 0 r
s
P
p
.35532 .33901 m .37314 .34166 L .36343 .34365 L 0 .372 1 r
F
P
p
.34563 .34102 m .35532 .33901 L .36343 .34365 L 0 .233 1 r
F
P
p
.002 w
.77663 .59162 m .76591 .59742 L .76023 .58603 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.76023 .58603 m .76591 .59742 L p
.75255 .58926 L 1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.76023 .58603 m .77086 .57628 L .77663 .59162 L p
1 .853 0 r
F P
0 0 0 r
s
P
p
.002 w
.76023 .58603 m .75556 .61049 L p
.76796 .58277 L 1 .985 0 r
F P
0 0 0 r
s
P
p
.002 w
.77086 .57628 m .76023 .58603 L p
.76796 .58277 L 1 .985 0 r
F P
0 0 0 r
s
P
p
.002 w
.74938 .58733 m .76023 .58603 L p
.75255 .58926 L 1 .942 0 r
F P
0 0 0 r
s
P
p
.44789 .33893 m .46536 .34158 L .45539 .34357 L 0 1 .791 r
F
P
p
.43793 .34094 m .44789 .33893 L .45539 .34357 L 0 1 .873 r
F
P
p
.54048 .33884 m .55761 .34149 L .54737 .34349 L 0 1 .985 r
F
P
p
.53025 .34085 m .54048 .33884 L .54737 .34349 L 0 .895 1 r
F
P
p
.6331 .33876 m .64987 .34141 L .63937 .34341 L .605 1 0 r
F
P
p
.6226 .34077 m .6331 .33876 L .63937 .34341 L .605 1 0 r
F
P
p
.72573 .33868 m .74216 .34133 L .73139 .34333 L 1 .802 0 r
F
P
p
.71497 .34069 m .72573 .33868 L .73139 .34333 L 1 .907 0 r
F
P
p
.002 w
.68122 .66776 m .6713 .70459 L .66383 .62394 L p
.109 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67441 .62275 m .66383 .62394 L .65844 .66383 L p
.256 1 0 r
F P
0 0 0 r
s
P
p
.81839 .33859 m .83447 .34125 L .82343 .34324 L 1 .157 0 r
F
P
p
.80736 .34061 m .81839 .33859 L .82343 .34324 L 1 .384 0 r
F
P
p
.002 w
.37062 .81927 m .36091 .8199 L .35278 .81842 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34308 .81906 m .35278 .81842 L .36091 .8199 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46291 .81924 m .45293 .81987 L .44541 .8184 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43545 .81904 m .44541 .8184 L .45293 .81987 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.32769 .33837 m .34563 .34102 L .33599 .34302 L 0 .477 1 r
F
P
p
.31806 .34038 m .32769 .33837 L .33599 .34302 L 0 .372 1 r
F
P
p
.002 w
.56542 .7972 m .55515 .7979 L .54836 .81773 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.53807 .81837 m .54836 .81773 L .55515 .7979 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.42034 .33828 m .43793 .34094 L .42802 .34294 L 0 .729 1 r
F
P
p
.41044 .3403 m .42034 .33828 L .42802 .34294 L 0 .596 1 r
F
P
p
.51301 .3382 m .53025 .34085 L .52008 .34285 L 0 1 .477 r
F
P
p
.50285 .34021 m .51301 .3382 L .52008 .34285 L 0 1 .614 r
F
P
p
.60571 .33812 m .6226 .34077 L .61216 .34277 L .398 1 0 r
F
P
p
.59528 .34013 m .60571 .33812 L .61216 .34277 L .331 1 0 r
F
P
p
.69842 .33803 m .71497 .34069 L .70427 .34269 L .674 1 0 r
F
P
p
.68773 .34005 m .69842 .33803 L .70427 .34269 L .485 1 0 r
F
P
p
.79116 .33795 m .80736 .34061 L .79639 .34261 L 1 .572 0 r
F
P
p
.7802 .33996 m .79116 .33795 L .79639 .34261 L 1 .676 0 r
F
P
p
.88392 .33786 m .89977 .34052 L .88854 .34252 L 1 0 0 r
F
P
p
.87269 .33988 m .88392 .33786 L .88854 .34252 L 1 0 0 r
F
P
p
.002 w
.43545 .81904 m .42554 .81967 L .41784 .81819 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40794 .81883 m .41784 .81819 L .42554 .81967 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.3 .33772 m .31806 .34038 L .30849 .34238 L 0 .477 1 r
F
P
p
.29045 .33974 m .3 .33772 L .30849 .34238 L 0 .337 1 r
F
P
p
.002 w
.52784 .81901 m .51767 .81964 L .51057 .81817 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50041 .81881 m .51057 .81817 L .51767 .81964 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.39273 .33764 m .41044 .3403 L .40061 .3423 L 0 .512 1 r
F
P
p
.38291 .33965 m .39273 .33764 L .40061 .3423 L 0 .512 1 r
F
P
p
.48549 .33755 m .50285 .34021 L .49275 .34222 L 0 1 .791 r
F
P
p
.4754 .33957 m .48549 .33755 L .49275 .34222 L 0 1 .801 r
F
P
p
.57826 .33747 m .59528 .34013 L .58491 .34213 L 0 1 .576 r
F
P
p
.56791 .33949 m .57826 .33747 L .58491 .34213 L 0 1 .826 r
F
P
p
.002 w
.78712 .57803 m .77663 .59162 L .77086 .57628 L p
1 .749 0 r
F P
0 0 0 r
s
P
p
.67106 .33739 m .68773 .34005 L .67709 .34205 L .401 1 0 r
F
P
p
.66044 .3394 m .67106 .33739 L .67709 .34205 L .369 1 0 r
F
P
p
.76388 .3373 m .7802 .33996 L .7693 .34197 L 1 .767 0 r
F
P
p
.75299 .33932 m .76388 .3373 L .7693 .34197 L 1 .933 0 r
F
P
p
.85673 .33722 m .87269 .33988 L .86153 .34189 L 1 0 0 r
F
P
p
.84556 .33924 m .85673 .33722 L .86153 .34189 L 1 0 0 r
F
P
p
.002 w
.40794 .81883 m .39811 .81947 L .39021 .81799 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38039 .81863 m .39021 .81799 L .39811 .81947 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.76023 .58603 m .74938 .58733 L .74481 .6183 L p
.911 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73391 .61952 m .74481 .6183 L .74938 .58733 L p
.837 1 0 r
F P
0 0 0 r
s
P
p
.27226 .33707 m .29045 .33974 L .28094 .34174 L 0 .477 1 r
F
P
p
.002 w
.50041 .81881 m .49031 .81944 L .48303 .81796 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .8186 m .48303 .81796 L .49031 .81944 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.36508 .33699 m .38291 .33965 L .37314 .34166 L 0 .512 1 r
F
P
p
.35532 .33901 m .36508 .33699 L .37314 .34166 L 0 .372 1 r
F
P
p
.45791 .33691 m .4754 .33957 L .46536 .34158 L 0 1 .791 r
F
P
p
.44789 .33893 m .45791 .33691 L .46536 .34158 L 0 1 .791 r
F
P
p
.55077 .33682 m .56791 .33949 L .55761 .34149 L 0 1 .773 r
F
P
p
.54048 .33884 m .55077 .33682 L .55761 .34149 L 0 1 .985 r
F
P
p
.64365 .33674 m .66044 .3394 L .64987 .34141 L .674 1 0 r
F
P
p
.6331 .33876 m .64365 .33674 L .64987 .34141 L .605 1 0 r
F
P
p
.73656 .33665 m .75299 .33932 L .74216 .34133 L 1 .654 0 r
F
P
p
.72573 .33868 m .73656 .33665 L .74216 .34133 L 1 .802 0 r
F
P
p
.002 w
.68505 .62155 m .67441 .62275 L .66913 .66274 L p
.256 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65844 .66383 m .66913 .66274 L .67441 .62275 L p
.256 1 0 r
F P
0 0 0 r
s
P
p
.82948 .33657 m .84556 .33924 L .83447 .34125 L 1 .052 0 r
F
P
p
.81839 .33859 m .82948 .33657 L .83447 .34125 L 1 .157 0 r
F
P
p
.002 w
.79808 .5767 m .78712 .57803 L .78182 .57494 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77086 .57628 m .78182 .57494 L .78712 .57803 L p
1 .749 0 r
F P
0 0 0 r
s
P
p
.002 w
.38039 .81863 m .37062 .81927 L .36253 .81778 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35278 .81842 m .36253 .81778 L .37062 .81927 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .8186 m .46291 .81924 L .45543 .81776 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44541 .8184 m .45543 .81776 L .46291 .81924 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33737 .33634 m .35532 .33901 L .34563 .34102 L 0 .651 1 r
F
P
p
.32769 .33837 m .33737 .33634 L .34563 .34102 L 0 .477 1 r
F
P
p
.002 w
.57565 .77823 m .56542 .7972 L .55871 .81709 L p
.134 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.54836 .81773 m .55871 .81709 L .56542 .7972 L p
.293 0 1 r
F P
0 0 0 r
s
P
p
.43029 .33626 m .44789 .33893 L .43793 .34094 L 0 .994 1 r
F
P
p
.42034 .33828 m .43029 .33626 L .43793 .34094 L 0 .729 1 r
F
P
p
.52323 .33617 m .54048 .33884 L .53025 .34085 L 0 1 .442 r
F
P
p
.51301 .3382 m .52323 .33617 L .53025 .34085 L 0 1 .477 r
F
P
p
.61619 .33609 m .6331 .33876 L .6226 .34077 L .433 1 0 r
F
P
p
.60571 .33812 m .61619 .33609 L .6226 .34077 L .398 1 0 r
F
P
p
.70918 .33601 m .72573 .33868 L .71497 .34069 L .744 1 0 r
F
P
p
.69842 .33803 m .70918 .33601 L .71497 .34069 L .674 1 0 r
F
P
p
.002 w
.58591 .76166 m .57565 .77823 L .56901 .79486 L p
0 .089 1 r
F P
0 0 0 r
s
P
p
.002 w
.56901 .79486 m .57565 .77823 L p
.56364 .80577 L .134 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56901 .79486 m .56206 .75872 L p
.57442 .7839 L 0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.56901 .79486 m .57945 .79415 L .58591 .76166 L p
0 .089 1 r
F P
0 0 0 r
s
P
p
.002 w
.57945 .79415 m .56901 .79486 L p
.57442 .7839 L 0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.55871 .81709 m .56901 .79486 L p
.56364 .80577 L .134 0 1 r
F P
0 0 0 r
s
P
p
.80219 .33592 m .81839 .33859 L .80736 .34061 L 1 .453 0 r
F
P
p
.79116 .33795 m .80219 .33592 L .80736 .34061 L 1 .572 0 r
F
P
p
.002 w
.35278 .81842 m .34308 .81906 L .3348 .81758 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.89521 .33584 m .91107 .33851 L .89977 .34052 L 1 0 0 r
F
P
p
.88392 .33786 m .89521 .33584 L .89977 .34052 L 1 0 0 r
F
P
p
.002 w
.44541 .8184 m .43545 .81904 L .42779 .81755 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41784 .81819 m .42779 .81755 L .43545 .81904 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.30961 .33569 m .32769 .33837 L .31806 .34038 L 0 .686 1 r
F
P
p
.3 .33772 m .30961 .33569 L .31806 .34038 L 0 .477 1 r
F
P
p
.002 w
.53807 .81837 m .52784 .81901 L .52079 .81752 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51057 .81817 m .52079 .81752 L .52784 .81901 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.40261 .33561 m .42034 .33828 L .41044 .3403 L 0 .512 1 r
F
P
p
.39273 .33764 m .40261 .33561 L .41044 .3403 L 0 .512 1 r
F
P
p
.49564 .33552 m .51301 .3382 L .50285 .34021 L 0 1 .737 r
F
P
p
.48549 .33755 m .49564 .33552 L .50285 .34021 L 0 1 .791 r
F
P
p
.002 w
.59631 .76086 m .58591 .76166 L .57945 .79415 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.58868 .33544 m .60571 .33812 L .59528 .34013 L 0 1 .192 r
F
P
p
.57826 .33747 m .58868 .33544 L .59528 .34013 L 0 1 .576 r
F
P
p
.68175 .33535 m .69842 .33803 L .68773 .34005 L .572 1 0 r
F
P
p
.67106 .33739 m .68175 .33535 L .68773 .34005 L .401 1 0 r
F
P
p
.77484 .33527 m .79116 .33795 L .7802 .33996 L 1 .606 0 r
F
P
p
.76388 .3373 m .77484 .33527 L .7802 .33996 L 1 .767 0 r
F
P
p
.86795 .33519 m .88392 .33786 L .87269 .33988 L 1 0 0 r
F
P
p
.85673 .33722 m .86795 .33519 L .87269 .33988 L 1 0 0 r
F
P
p
.002 w
.70631 .61062 m .71234 .62283 L p
.69724 .61469 L .642 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70631 .61062 m .7169 .60085 L .72309 .62073 L p
.706 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70631 .61062 m .70159 .65942 L p
.71542 .60651 L .433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7169 .60085 m .70631 .61062 L p
.71542 .60651 L .433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6956 .61381 m .70631 .61062 L p
.69724 .61469 L .642 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41784 .81819 m .40794 .81883 L .40009 .81735 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39021 .81799 m .40009 .81735 L .40794 .81883 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.74481 .6183 m .75556 .61049 L .76023 .58603 L p
.911 1 0 r
F P
0 0 0 r
s
P
p
.2818 .33504 m .3 .33772 L .29045 .33974 L 0 .756 1 r
F
P
p
.27226 .33707 m .2818 .33504 L .29045 .33974 L 0 .477 1 r
F
P
p
.002 w
.51057 .81817 m .50041 .81881 L .49318 .81732 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48303 .81796 m .49318 .81732 L .50041 .81881 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.37489 .33496 m .39273 .33764 L .38291 .33965 L 0 .512 1 r
F
P
p
.36508 .33699 m .37489 .33496 L .38291 .33965 L 0 .512 1 r
F
P
p
.46799 .33487 m .48549 .33755 L .4754 .33957 L 0 1 .791 r
F
P
p
.45791 .33691 m .46799 .33487 L .4754 .33957 L 0 1 .791 r
F
P
p
.56112 .33479 m .57826 .33747 L .56791 .33949 L 0 1 .579 r
F
P
p
.55077 .33682 m .56112 .33479 L .56791 .33949 L 0 1 .773 r
F
P
p
.65427 .3347 m .67106 .33739 L .66044 .3394 L .744 1 0 r
F
P
p
.64365 .33674 m .65427 .3347 L .66044 .3394 L .674 1 0 r
F
P
p
.74744 .33462 m .76388 .3373 L .75299 .33932 L 1 .584 0 r
F
P
p
.73656 .33665 m .74744 .33462 L .75299 .33932 L 1 .654 0 r
F
P
p
.002 w
.66913 .66274 m .67989 .66164 L .68505 .62155 L p
.256 1 0 r
F P
0 0 0 r
s
P
p
.84064 .33453 m .85673 .33722 L .84556 .33924 L 1 0 0 r
F
P
p
.82948 .33657 m .84064 .33453 L .84556 .33924 L 1 .052 0 r
F
P
p
.002 w
.80911 .57537 m .79808 .5767 L .79284 .57359 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.79284 .57359 m .79808 .5767 L p
.78997 .57582 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.79284 .57359 m .80298 .54682 L .80911 .57537 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.79284 .57359 m .78841 .59613 L p
.79574 .57134 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.80298 .54682 m .79284 .57359 L p
.79574 .57134 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.78182 .57494 m .79284 .57359 L p
.78997 .57582 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39021 .81799 m .38039 .81863 L .37234 .81714 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36253 .81778 m .37234 .81714 L .38039 .81863 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48303 .81796 m .47294 .8186 L .46551 .81711 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45543 .81776 m .46551 .81711 L .47294 .8186 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62694 .68414 m .61678 .71348 L .61078 .75734 L p
0 1 .718 r
F P
0 0 0 r
s
P
p
.002 w
.61678 .71348 m .60677 .76005 L .60021 .75816 L p
0 .613 1 r
F P
0 0 0 r
s
P
p
.002 w
.60021 .75816 m .61078 .75734 L .61678 .71348 L p
0 .613 1 r
F P
0 0 0 r
s
P
p
.002 w
.61078 .75734 m .62035 .66457 L .62694 .68414 L p
0 1 .718 r
F P
0 0 0 r
s
P
p
.34711 .33431 m .36508 .33699 L .35532 .33901 L 0 .791 1 r
F
P
p
.33737 .33634 m .34711 .33431 L .35532 .33901 L 0 .651 1 r
F
P
p
.4403 .33422 m .45791 .33691 L .44789 .33893 L 0 1 .791 r
F
P
p
.43029 .33626 m .4403 .33422 L .44789 .33893 L 0 .994 1 r
F
P
p
.53351 .33414 m .55077 .33682 L .54048 .33884 L 0 1 .427 r
F
P
p
.52323 .33617 m .53351 .33414 L .54048 .33884 L 0 1 .442 r
F
P
p
.62674 .33405 m .64365 .33674 L .6331 .33876 L .5 1 0 r
F
P
p
.61619 .33609 m .62674 .33405 L .6331 .33876 L .433 1 0 r
F
P
p
.72 .33397 m .73656 .33665 L .72573 .33868 L .849 1 0 r
F
P
p
.70918 .33601 m .72 .33397 L .72573 .33868 L .744 1 0 r
F
P
p
.81327 .33388 m .82948 .33657 L .81839 .33859 L 1 .384 0 r
F
P
p
.80219 .33592 m .81327 .33388 L .81839 .33859 L 1 .453 0 r
F
P
p
.002 w
.78182 .57494 m .77086 .57628 L .76624 .59871 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.76624 .59871 m .77086 .57628 L p
.75819 .60463 L 1 .985 0 r
F P
0 0 0 r
s
P
p
.002 w
.76624 .59871 m .77729 .59742 L .78182 .57494 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.76624 .59871 m .75992 .57 L p
.77434 .59276 L 1 .882 0 r
F P
0 0 0 r
s
P
p
.002 w
.77729 .59742 m .76624 .59871 L p
.77434 .59276 L 1 .882 0 r
F P
0 0 0 r
s
P
p
.002 w
.75556 .61049 m .76624 .59871 L p
.75819 .60463 L 1 .985 0 r
F P
0 0 0 r
s
P
p
.002 w
.36253 .81778 m .35278 .81842 L .34454 .81693 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3348 .81758 m .34454 .81693 L .35278 .81842 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.90657 .3338 m .92243 .33649 L .91107 .33851 L 1 0 0 r
F
P
p
.89521 .33584 m .90657 .3338 L .91107 .33851 L 1 0 0 r
F
P
p
.002 w
.45543 .81776 m .44541 .8184 L .4378 .81691 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42779 .81755 m .4378 .81691 L .44541 .8184 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31928 .33365 m .33737 .33634 L .32769 .33837 L 0 .965 1 r
F
P
p
.30961 .33569 m .31928 .33365 L .32769 .33837 L 0 .686 1 r
F
P
p
.002 w
.54836 .81773 m .53807 .81837 L .53107 .81688 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52079 .81752 m .53107 .81688 L .53807 .81837 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.41255 .33357 m .43029 .33626 L .42034 .33828 L 0 .686 1 r
F
P
p
.40261 .33561 m .41255 .33357 L .42034 .33828 L 0 .512 1 r
F
P
p
.50584 .33348 m .52323 .33617 L .51301 .3382 L 0 1 .632 r
F
P
p
.49564 .33552 m .50584 .33348 L .51301 .3382 L 0 1 .737 r
F
P
p
.002 w
.60677 .76005 m .59631 .76086 L .5897 .75898 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.002 w
.57945 .79415 m .5897 .75898 L .59631 .76086 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.59916 .3334 m .61619 .33609 L .60571 .33812 L .014 1 0 r
F
P
p
.58868 .33544 m .59916 .3334 L .60571 .33812 L 0 1 .192 r
F
P
p
.6925 .33331 m .70918 .33601 L .69842 .33803 L .814 1 0 r
F
P
p
.68175 .33535 m .6925 .33331 L .69842 .33803 L .572 1 0 r
F
P
p
.78586 .33323 m .80219 .33592 L .79116 .33795 L 1 .467 0 r
F
P
p
.77484 .33527 m .78586 .33323 L .79116 .33795 L 1 .606 0 r
F
P
p
.002 w
.70631 .61062 m .6956 .61381 L .69071 .66054 L p
.318 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67989 .66164 m .69071 .66054 L .6956 .61381 L p
.283 1 0 r
F P
0 0 0 r
s
P
p
.87924 .33314 m .89521 .33584 L .88392 .33786 L 1 0 0 r
F
P
p
.86795 .33519 m .87924 .33314 L .88392 .33786 L 1 0 0 r
F
P
p
.002 w
.64781 .66492 m .63736 .67454 L .63091 .66348 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.62035 .66457 m .63091 .66348 L .63736 .67454 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.42779 .81755 m .41784 .81819 L .41003 .8167 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40009 .81735 m .41003 .8167 L .41784 .81819 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.2914 .333 m .30961 .33569 L .3 .33772 L 0 .86 1 r
F
P
p
.2818 .33504 m .2914 .333 L .3 .33772 L 0 .756 1 r
F
P
p
.002 w
.52079 .81752 m .51057 .81817 L .50339 .81667 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49318 .81732 m .50339 .81667 L .51057 .81817 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.38475 .33291 m .40261 .33561 L .39273 .33764 L 0 .616 1 r
F
P
p
.37489 .33496 m .38475 .33291 L .39273 .33764 L 0 .512 1 r
F
P
p
.47813 .33283 m .49564 .33552 L .48549 .33755 L 0 1 .686 r
F
P
p
.46799 .33487 m .47813 .33283 L .48549 .33755 L 0 1 .791 r
F
P
p
.57153 .33274 m .58868 .33544 L .57826 .33747 L 0 1 .233 r
F
P
p
.56112 .33479 m .57153 .33274 L .57826 .33747 L 0 1 .579 r
F
P
p
.66495 .33266 m .68175 .33535 L .67106 .33739 L .814 1 0 r
F
P
p
.65427 .3347 m .66495 .33266 L .67106 .33739 L .744 1 0 r
F
P
p
.75839 .33257 m .77484 .33527 L .76388 .3373 L 1 .419 0 r
F
P
p
.74744 .33462 m .75839 .33257 L .76388 .3373 L 1 .584 0 r
F
P
p
.85186 .33249 m .86795 .33519 L .85673 .33722 L 1 0 0 r
F
P
p
.84064 .33453 m .85186 .33249 L .85673 .33722 L 1 0 0 r
F
P
p
.002 w
.81953 .55712 m .80911 .57537 L .80298 .54682 L p
1 .395 0 r
F P
0 0 0 r
s
P
p
.002 w
.40009 .81735 m .39021 .81799 L .38221 .81649 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37234 .81714 m .38221 .81649 L .39021 .81799 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.26347 .33234 m .2818 .33504 L .27226 .33707 L 0 1 1 r
F
P
p
.002 w
.49318 .81732 m .48303 .81796 L .47565 .81646 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46551 .81711 m .47565 .81646 L .48303 .81796 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.3569 .33226 m .37489 .33496 L .36508 .33699 L 0 .895 1 r
F
P
p
.34711 .33431 m .3569 .33226 L .36508 .33699 L 0 .791 1 r
F
P
p
.45036 .33217 m .46799 .33487 L .45791 .33691 L 0 1 .791 r
F
P
p
.4403 .33422 m .45036 .33217 L .45791 .33691 L 0 1 .791 r
F
P
p
.54385 .33209 m .56112 .33479 L .55077 .33682 L 0 1 .301 r
F
P
p
.53351 .33414 m .54385 .33209 L .55077 .33682 L 0 1 .427 r
F
P
p
.002 w
.83066 .55572 m .81953 .55712 L .81387 .53975 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.80298 .54682 m .81387 .53975 L .81953 .55712 L p
1 .395 0 r
F P
0 0 0 r
s
P
p
.63735 .332 m .65427 .3347 L .64365 .33674 L .605 1 0 r
F
P
p
.62674 .33405 m .63735 .332 L .64365 .33674 L .5 1 0 r
F
P
p
.73088 .33192 m .74744 .33462 L .73656 .33665 L .953 1 0 r
F
P
p
.72 .33397 m .73088 .33192 L .73656 .33665 L .849 1 0 r
F
P
p
.002 w
.63091 .66348 m .64153 .66239 L .64781 .66492 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.82443 .33183 m .84064 .33453 L .82948 .33657 L 1 .314 0 r
F
P
p
.81327 .33388 m .82443 .33183 L .82948 .33657 L 1 .384 0 r
F
P
p
.002 w
.79284 .57359 m .78182 .57494 L .77729 .59742 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.37234 .81714 m .36253 .81778 L .35434 .81628 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34454 .81693 m .35434 .81628 L .36253 .81778 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.90657 .3338 m .918 .33175 L .92243 .33649 L 1 0 0 r
F
P
p
.002 w
.46551 .81711 m .45543 .81776 L .44786 .81626 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4378 .81691 m .44786 .81626 L .45543 .81776 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.329 .3316 m .34711 .33431 L .33737 .33634 L 0 1 .826 r
F
P
p
.31928 .33365 m .329 .3316 L .33737 .33634 L 0 .965 1 r
F
P
p
.002 w
.55871 .81709 m .54836 .81773 L .54139 .79464 L p
.156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.53107 .81688 m .54139 .79464 L .54836 .81773 L p
.379 0 1 r
F P
0 0 0 r
s
P
p
.42255 .33151 m .4403 .33422 L .43029 .33626 L 0 1 .965 r
F
P
p
.41255 .33357 m .42255 .33151 L .43029 .33626 L 0 .686 1 r
F
P
p
.51611 .33143 m .53351 .33414 L .52323 .33617 L 0 1 .581 r
F
P
p
.50584 .33348 m .51611 .33143 L .52323 .33617 L 0 1 .632 r
F
P
p
.002 w
.5897 .75898 m .60021 .75816 L .60677 .76005 L p
0 .428 1 r
F P
0 0 0 r
s
P
p
.6097 .33134 m .62674 .33405 L .61619 .33609 L .084 1 0 r
F
P
p
.59916 .3334 m .6097 .33134 L .61619 .33609 L .014 1 0 r
F
P
p
.002 w
.69071 .66054 m .70159 .65942 L .70631 .61062 L p
.318 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52406 .75927 m .51365 .81602 L .5068 .70962 L p
0 .595 1 r
F P
0 0 0 r
s
P
p
.002 w
.5068 .70962 m .51704 .70866 L .52406 .75927 L p
0 .595 1 r
F P
0 0 0 r
s
P
p
.002 w
.49639 .75901 m .5068 .70962 L .51365 .81602 L p
0 .177 1 r
F P
0 0 0 r
s
P
p
.002 w
.51704 .70866 m .5068 .70962 L .4997 .68146 L p
0 1 .536 r
F P
0 0 0 r
s
P
p
.002 w
.5068 .70962 m .49639 .75901 L .48935 .70835 L p
0 1 .881 r
F P
0 0 0 r
s
P
p
.002 w
.48935 .70835 m .4997 .68146 L .5068 .70962 L p
0 1 .881 r
F P
0 0 0 r
s
P
p
.70331 .33126 m .72 .33397 L .70918 .33601 L .919 1 0 r
F
P
p
.6925 .33331 m .70331 .33126 L .70918 .33601 L .814 1 0 r
F
P
p
.002 w
.62035 .66457 m .61078 .75734 L .60341 .67174 L p
0 1 .533 r
F P
0 0 0 r
s
P
p
.002 w
.63091 .66348 m .62035 .66457 L .61398 .67067 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.60341 .67174 m .61398 .67067 L .62035 .66457 L p
0 1 .533 r
F P
0 0 0 r
s
P
p
.79694 .33117 m .81327 .33388 L .80219 .33592 L 1 .349 0 r
F
P
p
.78586 .33323 m .79694 .33117 L .80219 .33592 L 1 .467 0 r
F
P
p
.002 w
.74481 .6183 m .73391 .61952 L .72776 .59958 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72776 .59958 m .73391 .61952 L p
.72116 .60553 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72776 .59958 m .73821 .58123 L .74481 .6183 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72776 .59958 m .72288 .63109 L p
.73441 .5936 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73821 .58123 m .72776 .59958 L p
.73441 .5936 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7169 .60085 m .72776 .59958 L p
.72116 .60553 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34454 .81693 m .3348 .81758 L .32641 .81607 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.8906 .33109 m .90657 .3338 L .89521 .33584 L 1 0 0 r
F
P
p
.87924 .33314 m .8906 .33109 L .89521 .33584 L 1 0 0 r
F
P
p
.002 w
.4378 .81691 m .42779 .81755 L .42002 .81605 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41003 .8167 m .42002 .81605 L .42779 .81755 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.30105 .33094 m .31928 .33365 L .30961 .33569 L 0 1 .895 r
F
P
p
.2914 .333 m .30105 .33094 L .30961 .33569 L 0 .86 1 r
F
P
p
.002 w
.53107 .81688 m .52079 .81752 L .51365 .81602 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50339 .81667 m .51365 .81602 L .52079 .81752 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.39468 .33086 m .41255 .33357 L .40261 .33561 L 0 .721 1 r
F
P
p
.38475 .33291 m .39468 .33086 L .40261 .33561 L 0 .616 1 r
F
P
p
.002 w
.50339 .81667 m .49318 .81732 L .48621 .75983 L p
.019 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48621 .75983 m .49639 .75901 L .50339 .81667 L p
.019 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47565 .81646 m .48621 .75983 L .49318 .81732 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49639 .75901 m .48621 .75983 L .48039 .71792 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.48169 .71653 m .49639 .75901 L .48039 .71792 L 0 .819 1 r
F
P
p
.002 w
.48621 .75983 m .47565 .81646 L .46866 .75875 L p
0 .4 1 r
F P
0 0 0 r
s
P
p
.002 w
.46866 .75875 m .47919 .70931 L .48621 .75983 L p
0 .4 1 r
F P
0 0 0 r
s
P
p
.002 w
.47919 .70931 m .48935 .70835 L .49639 .75901 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.48935 .70835 m .48123 .81206 L p
.49706 .70013 L 0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.4997 .68146 m .48935 .70835 L p
.49706 .70013 L 0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.48039 .71792 m .47919 .70931 L p
.48169 .71653 L 0 .819 1 r
F P
0 0 0 r
s
P
p
.48833 .33077 m .50584 .33348 L .49564 .33552 L 0 1 .528 r
F
P
p
.47813 .33283 m .48833 .33077 L .49564 .33552 L 0 1 .686 r
F
P
p
.582 .33069 m .59916 .3334 L .58868 .33544 L .186 1 0 r
F
P
p
.57153 .33274 m .582 .33069 L .58868 .33544 L 0 1 .233 r
F
P
p
.002 w
.45799 .8156 m .46866 .75875 L .47565 .81646 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48935 .70835 m .47919 .70931 L .47088 .81273 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.47919 .70931 m .46866 .75875 L .46059 .8134 L p
0 .177 1 r
F P
0 0 0 r
s
P
p
.002 w
.46059 .8134 m .47088 .81273 L .47919 .70931 L p
0 .177 1 r
F P
0 0 0 r
s
P
p
.67569 .3306 m .6925 .33331 L .68175 .33535 L .988 1 0 r
F
P
p
.66495 .33266 m .67569 .3306 L .68175 .33535 L .814 1 0 r
F
P
p
.76941 .33051 m .78586 .33323 L .77484 .33527 L 1 .279 0 r
F
P
p
.75839 .33257 m .76941 .33051 L .77484 .33527 L 1 .419 0 r
F
P
p
.86315 .33043 m .87924 .33314 L .86795 .33519 L 1 0 0 r
F
P
p
.85186 .33249 m .86315 .33043 L .86795 .33519 L 1 0 0 r
F
P
p
.002 w
.41003 .8167 m .40009 .81735 L .39213 .81584 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38221 .81649 m .39213 .81584 L .40009 .81735 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.27305 .33028 m .2914 .333 L .2818 .33504 L 0 1 .651 r
F
P
p
.26347 .33234 m .27305 .33028 L .2818 .33504 L 0 1 1 r
F
P
p
.36676 .3302 m .38475 .33291 L .37489 .33496 L 0 1 1 r
F
P
p
.3569 .33226 m .36676 .3302 L .37489 .33496 L 0 .895 1 r
F
P
p
.002 w
.81387 .53975 m .80298 .54682 L .7996 .59482 L p
1 .64 0 r
F P
0 0 0 r
s
P
p
.002 w
.78841 .59613 m .7996 .59482 L .80298 .54682 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.46049 .33011 m .47813 .33283 L .46799 .33487 L 0 1 .686 r
F
P
p
.45036 .33217 m .46049 .33011 L .46799 .33487 L 0 1 .791 r
F
P
p
.002 w
.72776 .59958 m .7169 .60085 L .7121 .64027 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7121 .64027 m .7169 .60085 L p
.70357 .65184 L .433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7121 .64027 m .72288 .63109 L .72776 .59958 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7121 .64027 m .70558 .61215 L p
.72066 .62867 L .607 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72288 .63109 m .7121 .64027 L p
.72066 .62867 L .607 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70159 .65942 m .7121 .64027 L p
.70357 .65184 L .433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56901 .79486 m .55871 .81709 L .55168 .75953 L p
0 .067 1 r
F P
0 0 0 r
s
P
p
.002 w
.55168 .75953 m .56206 .75872 L .56901 .79486 L p
0 .067 1 r
F P
0 0 0 r
s
P
p
.002 w
.54139 .79464 m .55168 .75953 L .55871 .81709 L p
.156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56206 .75872 m .55168 .75953 L .54474 .75764 L p
0 .623 1 r
F P
0 0 0 r
s
P
p
.002 w
.55168 .75953 m .54139 .79464 L .53437 .75846 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.002 w
.53437 .75846 m .54474 .75764 L .55168 .75953 L p
0 .291 1 r
F P
0 0 0 r
s
P
p
.55424 .33003 m .57153 .33274 L .56112 .33479 L 0 1 .123 r
F
P
p
.54385 .33209 m .55424 .33003 L .56112 .33479 L 0 1 .301 r
F
P
p
.002 w
.84149 .54585 m .83066 .55572 L .82503 .5383 L p
1 .221 0 r
F P
0 0 0 r
s
P
p
.002 w
.82503 .5383 m .83066 .55572 L p
.8168 .54253 L 1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.82503 .5383 m .83579 .52552 L .84149 .54585 L p
1 .221 0 r
F P
0 0 0 r
s
P
p
.002 w
.82503 .5383 m .82149 .57491 L p
.83333 .53403 L 1 .326 0 r
F P
0 0 0 r
s
P
p
.002 w
.83579 .52552 m .82503 .5383 L p
.83333 .53403 L 1 .326 0 r
F P
0 0 0 r
s
P
p
.002 w
.81387 .53975 m .82503 .5383 L p
.8168 .54253 L 1 .302 0 r
F P
0 0 0 r
s
P
p
.64802 .32994 m .66495 .33266 L .65427 .3347 L .674 1 0 r
F
P
p
.63735 .332 m .64802 .32994 L .65427 .3347 L .605 1 0 r
F
P
p
.74182 .32985 m .75839 .33257 L .74744 .33462 L .953 1 0 r
F
P
p
.73088 .33192 m .74182 .32985 L .74744 .33462 L .953 1 0 r
F
P
p
.002 w
.66913 .66274 m .65844 .66383 L .65219 .6593 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.64153 .66239 m .65219 .6593 L .65844 .66383 L p
0 1 .085 r
F P
0 0 0 r
s
P
p
.83564 .32977 m .85186 .33249 L .84064 .33453 L 1 .209 0 r
F
P
p
.82443 .33183 m .83564 .32977 L .84064 .33453 L 1 .314 0 r
F
P
p
.002 w
.77729 .59742 m .78841 .59613 L .79284 .57359 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.61078 .75734 m .60021 .75816 L .5929 .67281 L p
0 1 .902 r
F P
0 0 0 r
s
P
p
.002 w
.5929 .67281 m .60341 .67174 L .61078 .75734 L p
0 1 .902 r
F P
0 0 0 r
s
P
p
.002 w
.58263 .69967 m .5929 .67281 L .60021 .75816 L p
0 .993 1 r
F P
0 0 0 r
s
P
p
.002 w
.60341 .67174 m .5929 .67281 L .58642 .69637 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.002 w
.58263 .69967 m .5725 .7579 L .56546 .70704 L p
0 1 .951 r
F P
0 0 0 r
s
P
p
.002 w
.56546 .70704 m .57594 .70606 L .58263 .69967 L p
0 1 .951 r
F P
0 0 0 r
s
P
p
.002 w
.5929 .67281 m .58263 .69967 L .57594 .70606 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.60021 .75816 m .5897 .75898 L .58263 .69967 L p
0 .993 1 r
F P
0 0 0 r
s
P
p
.002 w
.5725 .7579 m .58263 .69967 L .5897 .75898 L p
0 .521 1 r
F P
0 0 0 r
s
P
p
.002 w
.57594 .70606 m .58642 .69637 L .5929 .67281 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.38221 .81649 m .37234 .81714 L .36419 .81563 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35434 .81628 m .36419 .81563 L .37234 .81714 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47565 .81646 m .46551 .81711 L .45799 .8156 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44786 .81626 m .45799 .8156 L .46551 .81711 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33878 .32954 m .3569 .33226 L .34711 .33431 L 0 1 .721 r
F
P
p
.329 .3316 m .33878 .32954 L .34711 .33431 L 0 1 .826 r
F
P
p
.4326 .32945 m .45036 .33217 L .4403 .33422 L 0 1 .686 r
F
P
p
.42255 .33151 m .4326 .32945 L .4403 .33422 L 0 1 .965 r
F
P
p
.002 w
.54139 .79464 m .53107 .81688 L .52406 .75927 L p
0 .067 1 r
F P
0 0 0 r
s
P
p
.002 w
.52406 .75927 m .53437 .75846 L .54139 .79464 L p
0 .067 1 r
F P
0 0 0 r
s
P
p
.002 w
.51365 .81602 m .52406 .75927 L .53107 .81688 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.53437 .75846 m .52406 .75927 L .51704 .70866 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.52644 .32936 m .54385 .33209 L .53351 .33414 L 0 1 .547 r
F
P
p
.51611 .33143 m .52644 .32936 L .53351 .33414 L 0 1 .581 r
F
P
p
.6203 .32928 m .63735 .332 L .62674 .33405 L .151 1 0 r
F
P
p
.6097 .33134 m .6203 .32928 L .62674 .33405 L .084 1 0 r
F
P
p
.002 w
.51704 .70866 m .52733 .7077 L .53437 .75846 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.52733 .7077 m .51704 .70866 L .50998 .66914 L p
0 1 .466 r
F P
0 0 0 r
s
P
p
.002 w
.4997 .68146 m .50998 .66914 L .51704 .70866 L p
0 1 .536 r
F P
0 0 0 r
s
P
p
.71418 .32919 m .73088 .33192 L .72 .33397 L .953 1 0 r
F
P
p
.70331 .33126 m .71418 .32919 L .72 .33397 L .919 1 0 r
F
P
p
.002 w
.64153 .66239 m .63091 .66348 L .6245 .66093 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.61398 .67067 m .6245 .66093 L .63091 .66348 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.80809 .32911 m .82443 .33183 L .81327 .33388 L 1 .349 0 r
F
P
p
.79694 .33117 m .80809 .32911 L .81327 .33388 L 1 .349 0 r
F
P
p
.002 w
.75556 .61049 m .74481 .6183 L .73821 .58123 L p
.945 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35434 .81628 m .34454 .81693 L .33619 .81542 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32641 .81607 m .33619 .81542 L .34454 .81693 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.90202 .32902 m .918 .33175 L .90657 .3338 L 1 0 0 r
F
P
p
.8906 .33109 m .90202 .32902 L .90657 .3338 L 1 0 0 r
F
P
p
.002 w
.51365 .81602 m .50339 .81667 L .49639 .75901 L p
0 .177 1 r
F P
0 0 0 r
s
P
p
.002 w
.50998 .66914 m .4997 .68146 L .49165 .81138 L p
0 .627 1 r
F P
0 0 0 r
s
P
p
.002 w
.48123 .81206 m .49165 .81138 L .4997 .68146 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.44786 .81626 m .4378 .81691 L .43008 .81539 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42002 .81605 m .43008 .81539 L .4378 .81691 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.31076 .32887 m .329 .3316 L .31928 .33365 L 0 1 .651 r
F
P
p
.30105 .33094 m .31076 .32887 L .31928 .33365 L 0 1 .895 r
F
P
p
.40466 .32879 m .42255 .33151 L .41255 .33357 L 0 .965 1 r
F
P
p
.39468 .33086 m .40466 .32879 L .41255 .33357 L 0 .721 1 r
F
P
p
.002 w
.85236 .53594 m .84149 .54585 L .83579 .52552 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.49858 .3287 m .51611 .33143 L .50584 .33348 L 0 1 .423 r
F
P
p
.48833 .33077 m .49858 .3287 L .50584 .33348 L 0 1 .528 r
F
P
p
.002 w
.82503 .5383 m .81387 .53975 L .81052 .58488 L p
1 .547 0 r
F P
0 0 0 r
s
P
p
.002 w
.7996 .59482 m .81052 .58488 L .81387 .53975 L p
1 .64 0 r
F P
0 0 0 r
s
P
p
.002 w
.5897 .75898 m .57945 .79415 L .5725 .7579 L p
0 .521 1 r
F P
0 0 0 r
s
P
p
.59253 .32862 m .6097 .33134 L .59916 .3334 L .395 1 0 r
F
P
p
.582 .33069 m .59253 .32862 L .59916 .3334 L .186 1 0 r
F
P
p
.002 w
.47088 .81273 m .48123 .81206 L .48935 .70835 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.6865 .32853 m .70331 .33126 L .6925 .33331 L 1 .837 0 r
F
P
p
.67569 .3306 m .6865 .32853 L .6925 .33331 L .988 1 0 r
F
P
p
.78049 .32844 m .79694 .33117 L .78586 .33323 L 1 .14 0 r
F
P
p
.76941 .33051 m .78049 .32844 L .78586 .33323 L 1 .279 0 r
F
P
p
.002 w
.55503 .70801 m .54474 .75764 L .53767 .67213 L p
0 1 .672 r
F P
0 0 0 r
s
P
p
.002 w
.53767 .67213 m .54801 .66243 L .55503 .70801 L p
0 1 .672 r
F P
0 0 0 r
s
P
p
.002 w
.52733 .7077 m .53767 .67213 L .54474 .75764 L p
0 .958 1 r
F P
0 0 0 r
s
P
p
.002 w
.54801 .66243 m .53767 .67213 L .53062 .66098 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.53767 .67213 m .52733 .7077 L .52028 .66208 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.52028 .66208 m .53062 .66098 L .53767 .67213 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.8745 .32836 m .8906 .33109 L .87924 .33314 L 1 0 0 r
F
P
p
.86315 .33043 m .8745 .32836 L .87924 .33314 L 1 0 0 r
F
P
p
.002 w
.42002 .81605 m .41003 .8167 L .40211 .81518 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39213 .81584 m .40211 .81518 L .41003 .8167 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.28268 .32821 m .30105 .33094 L .2914 .333 L 0 1 .547 r
F
P
p
.27305 .33028 m .28268 .32821 L .2914 .333 L 0 1 .651 r
F
P
p
.37667 .32812 m .39468 .33086 L .38475 .33291 L 0 1 .826 r
F
P
p
.36676 .3302 m .37667 .32812 L .38475 .33291 L 0 1 1 r
F
P
p
.002 w
.46866 .75875 m .45799 .8156 L .45036 .81407 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45036 .81407 m .46059 .8134 L .46866 .75875 L p
.242 0 1 r
F P
0 0 0 r
s
P
p
.47067 .32804 m .48833 .33077 L .47813 .33283 L 0 1 .477 r
F
P
p
.46049 .33011 m .47067 .32804 L .47813 .33283 L 0 1 .686 r
F
P
p
.002 w
.50998 .66914 m .52028 .66208 L .52733 .7077 L p
0 1 .466 r
F P
0 0 0 r
s
P
p
.002 w
.52028 .66208 m .50998 .66914 L .50212 .8107 L p
0 .767 1 r
F P
0 0 0 r
s
P
p
.002 w
.49165 .81138 m .50212 .8107 L .50998 .66914 L p
0 .627 1 r
F P
0 0 0 r
s
P
p
.002 w
.56206 .75872 m .5725 .7579 L .57945 .79415 L p
0 .153 1 r
F P
0 0 0 r
s
P
p
.002 w
.5725 .7579 m .56206 .75872 L .55503 .70801 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.54474 .75764 m .55503 .70801 L .56206 .75872 L p
0 .623 1 r
F P
0 0 0 r
s
P
p
.5647 .32795 m .582 .33069 L .57153 .33274 L .049 1 0 r
F
P
p
.55424 .33003 m .5647 .32795 L .57153 .33274 L 0 1 .123 r
F
P
p
.65876 .32787 m .67569 .3306 L .66495 .33266 L .829 1 0 r
F
P
p
.64802 .32994 m .65876 .32787 L .66495 .33266 L .674 1 0 r
F
P
p
.002 w
.55503 .70801 m .56546 .70704 L .5725 .7579 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.56546 .70704 m .55503 .70801 L .54801 .66243 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.75283 .32778 m .76941 .33051 L .75839 .33257 L 1 .977 0 r
F
P
p
.74182 .32985 m .75283 .32778 L .75839 .33257 L .953 1 0 r
F
P
p
.002 w
.67989 .66164 m .66913 .66274 L .66282 .65153 L p
0 1 .018 r
F P
0 0 0 r
s
P
p
.002 w
.65219 .6593 m .66282 .65153 L .66913 .66274 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.84693 .32769 m .86315 .33043 L .85186 .33249 L 1 .105 0 r
F
P
p
.83564 .32977 m .84693 .32769 L .85186 .33249 L 1 .209 0 r
F
P
p
.002 w
.61398 .67067 m .60341 .67174 L .5968 .66924 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.58642 .69637 m .5968 .66924 L .60341 .67174 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.002 w
.76624 .59871 m .75556 .61049 L .74891 .57137 L p
1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.73821 .58123 m .74891 .57137 L .75556 .61049 L p
.945 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39213 .81584 m .38221 .81649 L .3741 .81497 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36419 .81563 m .3741 .81497 L .38221 .81649 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.74891 .57137 m .73821 .58123 L .73344 .61255 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73344 .61255 m .73821 .58123 L p
.72569 .62195 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73344 .61255 m .74451 .61129 L .74891 .57137 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73344 .61255 m .7265 .56635 L p
.74123 .60311 L .953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74451 .61129 m .73344 .61255 L p
.74123 .60311 L .953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72288 .63109 m .73344 .61255 L p
.72569 .62195 L .744 1 0 r
F P
0 0 0 r
s
P
p
.25455 .32755 m .27305 .33028 L .26347 .33234 L 0 1 .512 r
F
P
p
.002 w
.86327 .526 m .85236 .53594 L .84706 .52402 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.83579 .52552 m .84706 .52402 L .85236 .53594 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.34862 .32746 m .36676 .3302 L .3569 .33226 L 0 1 .686 r
F
P
p
.33878 .32954 m .34862 .32746 L .3569 .33226 L 0 1 .721 r
F
P
p
.44271 .32737 m .46049 .33011 L .45036 .33217 L 0 1 .581 r
F
P
p
.4326 .32945 m .44271 .32737 L .45036 .33217 L 0 1 .686 r
F
P
p
.002 w
.54474 .75764 m .53437 .75846 L .52733 .7077 L p
0 .958 1 r
F P
0 0 0 r
s
P
p
.53683 .32729 m .55424 .33003 L .54385 .33209 L 0 1 .447 r
F
P
p
.52644 .32936 m .53683 .32729 L .54385 .33209 L 0 1 .547 r
F
P
p
.63096 .3272 m .64802 .32994 L .63735 .332 L .201 1 0 r
F
P
p
.6203 .32928 m .63096 .3272 L .63735 .332 L .151 1 0 r
F
P
p
.002 w
.54801 .66243 m .55843 .66133 L .56546 .70704 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.002 w
.55843 .66133 m .54801 .66243 L .54102 .65987 L p
0 1 .058 r
F P
0 0 0 r
s
P
p
.002 w
.54102 .65987 m .54801 .66243 L p
.53221 .66111 L 0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.54102 .65987 m .55146 .65007 L .55843 .66133 L p
0 1 .058 r
F P
0 0 0 r
s
P
p
.002 w
.54102 .65987 m .53393 .74556 L p
.54989 .65862 L 0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.55146 .65007 m .54102 .65987 L p
.54989 .65862 L 0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.53062 .66098 m .54102 .65987 L p
.53221 .66111 L 0 1 .128 r
F P
0 0 0 r
s
P
p
.72512 .32711 m .74182 .32985 L .73088 .33192 L .953 1 0 r
F
P
p
.71418 .32919 m .72512 .32711 L .73088 .33192 L .953 1 0 r
F
P
p
.002 w
.65219 .6593 m .64153 .66239 L .63517 .65983 L p
0 1 .085 r
F P
0 0 0 r
s
P
p
.002 w
.6245 .66093 m .63517 .65983 L .64153 .66239 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.8193 .32703 m .83564 .32977 L .82443 .33183 L 1 .314 0 r
F
P
p
.80809 .32911 m .8193 .32703 L .82443 .33183 L 1 .349 0 r
F
P
p
.002 w
.36419 .81563 m .35434 .81628 L .34603 .81476 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33619 .81542 m .34603 .81476 L .35434 .81628 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.90202 .32902 m .91351 .32694 L .918 .33175 L 1 0 0 r
F
P
p
.002 w
.45799 .8156 m .44786 .81626 L .44019 .81473 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43008 .81539 m .44019 .81473 L .44786 .81626 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.32052 .32679 m .33878 .32954 L .329 .3316 L 0 1 .512 r
F
P
p
.31076 .32887 m .32052 .32679 L .329 .3316 L 0 1 .651 r
F
P
p
.4147 .32671 m .4326 .32945 L .42255 .33151 L 0 1 .756 r
F
P
p
.40466 .32879 m .4147 .32671 L .42255 .33151 L 0 .965 1 r
F
P
p
.5089 .32662 m .52644 .32936 L .51611 .33143 L 0 1 .337 r
F
P
p
.49858 .3287 m .5089 .32662 L .51611 .33143 L 0 1 .423 r
F
P
p
.002 w
.75992 .57 m .76624 .59871 L p
.75034 .57361 L 1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .56251 m .77729 .59742 L p
.76129 .57215 L 1 .882 0 r
F P
0 0 0 r
s
P
p
.002 w
.75992 .57 m .7708 .56251 L p
.76129 .57215 L 1 .882 0 r
F P
0 0 0 r
s
P
p
.002 w
.78841 .59613 m .77729 .59742 L .7708 .56251 L p
1 .804 0 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .56251 m .78149 .54814 L .78841 .59613 L p
1 .804 0 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .56251 m .76685 .60875 L p
.78035 .55284 L 1 .944 0 r
F P
0 0 0 r
s
P
p
.002 w
.78149 .54814 m .7708 .56251 L p
.78035 .55284 L 1 .944 0 r
F P
0 0 0 r
s
P
p
.002 w
.75992 .57 m .75565 .61002 L p
.76957 .56637 L .978 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .56251 m .75992 .57 L p
.76957 .56637 L .978 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74891 .57137 m .75992 .57 L p
.75034 .57361 L 1 .95 0 r
F P
0 0 0 r
s
P
p
.002 w
.81052 .58488 m .82149 .57491 L .82503 .5383 L p
1 .547 0 r
F P
0 0 0 r
s
P
p
.60312 .32653 m .6203 .32928 L .6097 .33134 L .535 1 0 r
F
P
p
.59253 .32862 m .60312 .32653 L .6097 .33134 L .395 1 0 r
F
P
p
.002 w
.53062 .66098 m .52028 .66208 L .51271 .79199 L p
0 .86 1 r
F P
0 0 0 r
s
P
p
.002 w
.51271 .79199 m .52028 .66208 L p
.5043 .79284 L 0 .767 1 r
F P
0 0 0 r
s
P
p
.002 w
.51271 .79199 m .52329 .79125 L .53062 .66098 L p
0 .86 1 r
F P
0 0 0 r
s
P
p
.002 w
.51271 .79199 m .50529 .79026 L p
.52118 .79113 L .186 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52329 .79125 m .51271 .79199 L p
.52118 .79113 L .186 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50212 .8107 m .51271 .79199 L p
.5043 .79284 L 0 .767 1 r
F P
0 0 0 r
s
P
p
.69736 .32645 m .71418 .32919 L .70331 .33126 L 1 .733 0 r
F
P
p
.6865 .32853 m .69736 .32645 L .70331 .33126 L 1 .837 0 r
F
P
p
.79163 .32636 m .80809 .32911 L .79694 .33117 L 1 0 0 r
F
P
p
.78049 .32844 m .79163 .32636 L .79694 .33117 L 1 .14 0 r
F
P
p
.002 w
.75992 .57 m .74891 .57137 L .74451 .61129 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.87461 .5245 m .86327 .526 L .8584 .52251 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84706 .52402 m .8584 .52251 L .86327 .526 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.33619 .81542 m .32641 .81607 L .31791 .81455 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.88592 .32627 m .90202 .32902 L .8906 .33109 L 1 0 0 r
F
P
p
.8745 .32836 m .88592 .32627 L .8906 .33109 L 1 0 0 r
F
P
p
.002 w
.43008 .81539 m .42002 .81605 L .41215 .81452 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40211 .81518 m .41215 .81452 L .42002 .81605 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.29237 .32613 m .31076 .32887 L .30105 .33094 L 0 1 .477 r
F
P
p
.28268 .32821 m .29237 .32613 L .30105 .33094 L 0 1 .547 r
F
P
p
.38663 .32604 m .40466 .32879 L .39468 .33086 L 0 1 .721 r
F
P
p
.37667 .32812 m .38663 .32604 L .39468 .33086 L 0 1 .826 r
F
P
p
.48092 .32595 m .49858 .3287 L .48833 .33077 L 0 1 .372 r
F
P
p
.47067 .32804 m .48092 .32595 L .48833 .33077 L 0 1 .477 r
F
P
p
.57522 .32587 m .59253 .32862 L .582 .33069 L .205 1 0 r
F
P
p
.5647 .32795 m .57522 .32587 L .582 .33069 L .049 1 0 r
F
P
p
.66955 .32578 m .6865 .32853 L .67569 .3306 L 1 .962 0 r
F
P
p
.65876 .32787 m .66955 .32578 L .67569 .3306 L .829 1 0 r
F
P
p
.002 w
.57594 .70606 m .56546 .70704 L .55843 .66133 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.7639 .32569 m .78049 .32844 L .76941 .33051 L 1 .733 0 r
F
P
p
.75283 .32778 m .7639 .32569 L .76941 .33051 L 1 .977 0 r
F
P
p
.002 w
.69071 .66054 m .67989 .66164 L .67359 .64906 L p
0 1 .013 r
F P
0 0 0 r
s
P
p
.002 w
.66282 .65153 m .67359 .64906 L .67989 .66164 L p
0 1 .018 r
F P
0 0 0 r
s
P
p
.002 w
.83143 .53911 m .83579 .52552 L p
.82923 .54818 L 1 .326 0 r
F P
0 0 0 r
s
P
p
.002 w
.82149 .57491 m .83143 .53911 L p
.82923 .54818 L 1 .326 0 r
F P
0 0 0 r
s
P
p
.002 w
.83143 .53911 m .82596 .52707 L p
.83366 .52997 L 1 .157 0 r
F P
0 0 0 r
s
P
p
.002 w
.84706 .52402 m .83579 .52552 L .83143 .53911 L p
1 .122 0 r
F P
0 0 0 r
s
P
p
.002 w
.83143 .53911 m .84262 .53334 L .84706 .52402 L p
1 .122 0 r
F P
0 0 0 r
s
P
p
.002 w
.84262 .53334 m .83143 .53911 L p
.83366 .52997 L 1 .157 0 r
F P
0 0 0 r
s
P
p
.85828 .32561 m .8745 .32836 L .86315 .33043 L 1 .063 0 r
F
P
p
.84693 .32769 m .85828 .32561 L .86315 .33043 L 1 .105 0 r
F
P
p
.002 w
.6245 .66093 m .61398 .67067 L .60741 .66816 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.002 w
.5968 .66924 m .60741 .66816 L .61398 .67067 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.40211 .81518 m .39213 .81584 L .38406 .81431 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3741 .81497 m .38406 .81431 L .39213 .81584 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.26417 .32546 m .28268 .32821 L .27305 .33028 L 0 1 .372 r
F
P
p
.25455 .32755 m .26417 .32546 L .27305 .33028 L 0 1 .512 r
F
P
p
.35852 .32537 m .37667 .32812 L .36676 .3302 L 0 1 .512 r
F
P
p
.34862 .32746 m .35852 .32537 L .36676 .3302 L 0 1 .686 r
F
P
p
.45288 .32528 m .47067 .32804 L .46049 .33011 L 0 1 .477 r
F
P
p
.44271 .32737 m .45288 .32528 L .46049 .33011 L 0 1 .581 r
F
P
p
.54727 .3252 m .5647 .32795 L .55424 .33003 L 0 1 .184 r
F
P
p
.53683 .32729 m .54727 .3252 L .55424 .33003 L 0 1 .447 r
F
P
p
.002 w
.66282 .65153 m .65219 .6593 L .64591 .65871 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.63517 .65983 m .64591 .65871 L .65219 .6593 L p
0 1 .085 r
F P
0 0 0 r
s
P
p
.64169 .32511 m .65876 .32787 L .64802 .32994 L .273 1 0 r
F
P
p
.63096 .3272 m .64169 .32511 L .64802 .32994 L .201 1 0 r
F
P
p
.002 w
.55843 .66133 m .5689 .66023 L .57594 .70606 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.002 w
.5689 .66023 m .55843 .66133 L .55146 .65007 L p
0 1 .018 r
F P
0 0 0 r
s
P
p
.73612 .32502 m .75283 .32778 L .74182 .32985 L .953 1 0 r
F
P
p
.72512 .32711 m .73612 .32502 L .74182 .32985 L .953 1 0 r
F
P
p
.83058 .32494 m .84693 .32769 L .83564 .32977 L 1 .209 0 r
F
P
p
.8193 .32703 m .83058 .32494 L .83564 .32977 L 1 .314 0 r
F
P
p
.002 w
.3741 .81497 m .36419 .81563 L .35592 .8141 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34603 .81476 m .35592 .8141 L .36419 .81563 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44019 .81473 m .45036 .81407 L .45799 .8156 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.33034 .3247 m .34862 .32746 L .33878 .32954 L 0 1 .442 r
F
P
p
.32052 .32679 m .33034 .3247 L .33878 .32954 L 0 1 .512 r
F
P
p
.4248 .32461 m .44271 .32737 L .4326 .32945 L 0 1 .547 r
F
P
p
.4147 .32671 m .4248 .32461 L .4326 .32945 L 0 1 .756 r
F
P
p
.51927 .32453 m .53683 .32729 L .52644 .32936 L 0 1 .233 r
F
P
p
.5089 .32662 m .51927 .32453 L .52644 .32936 L 0 1 .337 r
F
P
p
.61377 .32444 m .63096 .3272 L .6203 .32928 L .605 1 0 r
F
P
p
.60312 .32653 m .61377 .32444 L .6203 .32928 L .535 1 0 r
F
P
p
.002 w
.54102 .65987 m .53062 .66098 L .52329 .79125 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.70829 .32435 m .72512 .32711 L .71418 .32919 L 1 .698 0 r
F
P
p
.69736 .32645 m .70829 .32435 L .71418 .32919 L 1 .733 0 r
F
P
p
.002 w
.63517 .65983 m .6245 .66093 L .618 .65835 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.60741 .66816 m .618 .65835 L .6245 .66093 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.80284 .32427 m .8193 .32703 L .80809 .32911 L 1 0 0 r
F
P
p
.79163 .32636 m .80284 .32427 L .80809 .32911 L 1 0 0 r
F
P
p
.002 w
.74451 .61129 m .75565 .61002 L .75992 .57 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.88602 .52299 m .87461 .5245 L .86981 .52099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8584 .52251 m .86981 .52099 L .87461 .5245 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34603 .81476 m .33619 .81542 L .32773 .81389 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31791 .81455 m .32773 .81389 L .33619 .81542 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.89741 .32418 m .91351 .32694 L .90202 .32902 L 1 0 0 r
F
P
p
.88592 .32627 m .89741 .32418 L .90202 .32902 L 1 0 0 r
F
P
p
.002 w
.44019 .81473 m .43008 .81539 L .42225 .81386 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41215 .81452 m .42225 .81386 L .43008 .81539 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.30212 .32403 m .32052 .32679 L .31076 .32887 L 0 1 .372 r
F
P
p
.29237 .32613 m .30212 .32403 L .31076 .32887 L 0 1 .477 r
F
P
p
.39666 .32394 m .4147 .32671 L .40466 .32879 L 0 1 .651 r
F
P
p
.38663 .32604 m .39666 .32394 L .40466 .32879 L 0 1 .721 r
F
P
p
.49122 .32386 m .5089 .32662 L .49858 .3287 L 0 1 .337 r
F
P
p
.48092 .32595 m .49122 .32386 L .49858 .3287 L 0 1 .372 r
F
P
p
.5858 .32377 m .60312 .32653 L .59253 .32862 L .326 1 0 r
F
P
p
.57522 .32587 m .5858 .32377 L .59253 .32862 L .205 1 0 r
F
P
p
.002 w
.67359 .64906 m .66282 .65153 L .65668 .65558 L p
.025 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64591 .65871 m .65668 .65558 L .66282 .65153 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.68041 .32368 m .69736 .32645 L .6865 .32853 L 1 .907 0 r
F
P
p
.66955 .32578 m .68041 .32368 L .6865 .32853 L 1 .962 0 r
F
P
p
.002 w
.58642 .69637 m .57594 .70606 L .5689 .66023 L p
0 1 .407 r
F P
0 0 0 r
s
P
p
.77504 .32359 m .79163 .32636 L .78049 .32844 L 1 .453 0 r
F
P
p
.7639 .32569 m .77504 .32359 L .78049 .32844 L 1 .733 0 r
F
P
p
.002 w
.70159 .65942 m .69071 .66054 L .68445 .64791 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67359 .64906 m .68445 .64791 L .69071 .66054 L p
0 1 .013 r
F P
0 0 0 r
s
P
p
.002 w
.8584 .52251 m .84706 .52402 L .84262 .53334 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.86969 .32351 m .88592 .32627 L .8745 .32836 L 1 .028 0 r
F
P
p
.85828 .32561 m .86969 .32351 L .8745 .32836 L 1 .063 0 r
F
P
p
.002 w
.41215 .81452 m .40211 .81518 L .39409 .81365 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38406 .81431 m .39409 .81365 L .40211 .81518 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.27384 .32336 m .29237 .32613 L .28268 .32821 L 0 1 .302 r
F
P
p
.26417 .32546 m .27384 .32336 L .28268 .32821 L 0 1 .372 r
F
P
p
.36847 .32327 m .38663 .32604 L .37667 .32812 L 0 1 .372 r
F
P
p
.35852 .32537 m .36847 .32327 L .37667 .32812 L 0 1 .512 r
F
P
p
.46311 .32318 m .48092 .32595 L .47067 .32804 L 0 1 .372 r
F
P
p
.45288 .32528 m .46311 .32318 L .47067 .32804 L 0 1 .477 r
F
P
p
.55778 .3231 m .57522 .32587 L .5647 .32795 L .014 1 0 r
F
P
p
.54727 .3252 m .55778 .3231 L .5647 .32795 L 0 1 .184 r
F
P
p
.65248 .32301 m .66955 .32578 L .65876 .32787 L .416 1 0 r
F
P
p
.64169 .32511 m .65248 .32301 L .65876 .32787 L .273 1 0 r
F
P
p
.002 w
.5689 .66023 m .57943 .65911 L .58642 .69637 L p
0 1 .407 r
F P
0 0 0 r
s
P
p
.002 w
.57943 .65911 m .5689 .66023 L .56197 .64759 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56197 .64759 m .5689 .66023 L p
.55313 .65104 L 0 1 .018 r
F P
0 0 0 r
s
P
p
.002 w
.56197 .64759 m .5725 .63839 L .57943 .65911 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56197 .64759 m .55514 .69913 L p
.57086 .64411 L 0 1 .225 r
F P
0 0 0 r
s
P
p
.002 w
.5725 .63839 m .56197 .64759 L p
.57086 .64411 L 0 1 .225 r
F P
0 0 0 r
s
P
p
.002 w
.55146 .65007 m .56197 .64759 L p
.55313 .65104 L 0 1 .018 r
F P
0 0 0 r
s
P
p
.74719 .32292 m .7639 .32569 L .75283 .32778 L 1 .942 0 r
F
P
p
.73612 .32502 m .74719 .32292 L .75283 .32778 L .953 1 0 r
F
P
p
.84193 .32283 m .85828 .32561 L .84693 .32769 L 1 .105 0 r
F
P
p
.83058 .32494 m .84193 .32283 L .84693 .32769 L 1 .209 0 r
F
P
p
.002 w
.60741 .66816 m .5968 .66924 L .58996 .64929 L p
0 1 .088 r
F P
0 0 0 r
s
P
p
.002 w
.5968 .66924 m .58642 .69637 L .57943 .65911 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.57943 .65911 m .58996 .64929 L .5968 .66924 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.75565 .61002 m .76685 .60875 L .7708 .56251 L p
.978 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38406 .81431 m .3741 .81497 L .36588 .81343 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35592 .8141 m .36588 .81343 L .3741 .81497 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.24552 .32268 m .26417 .32546 L .25455 .32755 L 0 1 .177 r
F
P
p
.34022 .3226 m .35852 .32537 L .34862 .32746 L 0 1 .442 r
F
P
p
.33034 .3247 m .34022 .3226 L .34862 .32746 L 0 1 .442 r
F
P
p
.43496 .32251 m .45288 .32528 L .44271 .32737 L 0 1 .372 r
F
P
p
.4248 .32461 m .43496 .32251 L .44271 .32737 L 0 1 .547 r
F
P
p
.52971 .32242 m .54727 .3252 L .53683 .32729 L 0 1 .152 r
F
P
p
.51927 .32453 m .52971 .32242 L .53683 .32729 L 0 1 .233 r
F
P
p
.002 w
.7996 .59482 m .78841 .59613 L .78225 .5534 L p
1 .725 0 r
F P
0 0 0 r
s
P
p
.78317 .55247 m .7996 .59482 L .78225 .5534 L 1 .725 0 r
F
P
p
.002 w
.78149 .54814 m .79242 .54011 L .7996 .59482 L p
1 .725 0 r
F P
0 0 0 r
s
P
p
.002 w
.78884 .58868 m .78902 .58624 L p
.77958 .60082 L 1 .794 0 r
F P
0 0 0 r
s
P
p
.002 w
.78902 .58624 m .79218 .5434 L p
.78086 .59496 L 1 .794 0 r
F P
0 0 0 r
s
P
p
.77958 .60082 m .78902 .58624 L .78086 .59496 L 1 .794 0 r
F
P
p
.002 w
.79218 .5434 m .79242 .54011 L p
.7916 .54398 L 1 .794 0 r
F P
0 0 0 r
s
P
p
.77812 .60747 m .79218 .5434 L .7916 .54398 L 1 .794 0 r
F
P
p
.002 w
.78225 .5534 m .78149 .54814 L p
.78317 .55247 L 1 .725 0 r
F P
0 0 0 r
s
P
p
.002 w
.79242 .54011 m .78149 .54814 L .77812 .60747 L p
1 .794 0 r
F P
0 0 0 r
s
P
p
.002 w
.81052 .58488 m .7996 .59482 L .79242 .54011 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.79242 .54011 m .80365 .53864 L .81052 .58488 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.80365 .53864 m .79242 .54011 L .78884 .58868 L p
1 .676 0 r
F P
0 0 0 r
s
P
p
.002 w
.78884 .58868 m .80002 .58195 L .80365 .53864 L p
1 .676 0 r
F P
0 0 0 r
s
P
p
.002 w
.79262 .52303 m .79919 .57536 L p
.78339 .53056 L 1 .606 0 r
F P
0 0 0 r
s
P
p
.002 w
.82149 .57491 m .81052 .58488 L .80365 .53864 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.81494 .53716 m .82149 .57491 L p
.80588 .54317 L 1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.80365 .53864 m .81494 .53716 L p
.80588 .54317 L 1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.83143 .53911 m .82149 .57491 L .81494 .53716 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.81494 .53716 m .82596 .52707 L .83143 .53911 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.81494 .53716 m .81067 .55975 L p
.82406 .53112 L 1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .52707 m .81494 .53716 L p
.82406 .53112 L 1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.81494 .53716 m .80365 .53864 L .80002 .58195 L p
1 .572 0 r
F P
0 0 0 r
s
P
p
.002 w
.81067 .55975 m .81494 .53716 L p
.80348 .57159 L 1 .572 0 r
F P
0 0 0 r
s
P
p
.002 w
.80002 .58195 m .81067 .55975 L p
.80348 .57159 L 1 .572 0 r
F P
0 0 0 r
s
P
p
.002 w
.81067 .55975 m .82213 .55831 L .82596 .52707 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.81067 .55975 m .8037 .51281 L p
.81789 .54785 L 1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.82213 .55831 m .81067 .55975 L p
.81789 .54785 L 1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.81067 .55975 m .80002 .58195 L .79262 .52303 L p
1 .467 0 r
F P
0 0 0 r
s
P
p
.002 w
.79262 .52303 m .8037 .51281 L .81067 .55975 L p
1 .467 0 r
F P
0 0 0 r
s
P
p
.002 w
.79262 .52303 m .78775 .53692 L p
.80201 .51537 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.8037 .51281 m .79262 .52303 L p
.80201 .51537 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.78128 .52457 m .79262 .52303 L p
.78339 .53056 L 1 .606 0 r
F P
0 0 0 r
s
P
p
.002 w
.79919 .57536 m .80002 .58195 L p
.79821 .57641 L 1 .606 0 r
F P
0 0 0 r
s
P
p
.78128 .52457 m .79919 .57536 L .79821 .57641 L 1 .606 0 r
F
P
p
.002 w
.78884 .58868 m .78128 .52457 L p
.79821 .57641 L 1 .606 0 r
F P
0 0 0 r
s
P
p
.002 w
.80002 .58195 m .78884 .58868 L p
.79821 .57641 L 1 .606 0 r
F P
0 0 0 r
s
P
p
.002 w
.77812 .60747 m .78884 .58868 L p
.77958 .60082 L 1 .794 0 r
F P
0 0 0 r
s
P
p
.62449 .32233 m .64169 .32511 L .63096 .3272 L .62 1 0 r
F
P
p
.61377 .32444 m .62449 .32233 L .63096 .3272 L .605 1 0 r
F
P
p
.002 w
.52329 .79125 m .53393 .74556 L .54102 .65987 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.71929 .32225 m .73612 .32502 L .72512 .32711 L 1 .593 0 r
F
P
p
.70829 .32435 m .71929 .32225 L .72512 .32711 L 1 .698 0 r
F
P
p
.002 w
.64591 .65871 m .63517 .65983 L .62873 .65723 L p
0 1 .085 r
F P
0 0 0 r
s
P
p
.002 w
.618 .65835 m .62873 .65723 L .63517 .65983 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.81411 .32216 m .83058 .32494 L .8193 .32703 L 1 0 0 r
F
P
p
.80284 .32427 m .81411 .32216 L .8193 .32703 L 1 0 0 r
F
P
p
.002 w
.89749 .52147 m .88602 .52299 L .88128 .51946 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86981 .52099 m .88128 .51946 L .88602 .52299 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35592 .8141 m .34603 .81476 L .33761 .81322 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32773 .81389 m .33761 .81322 L .34603 .81476 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.89741 .32418 m .90896 .32207 L .91351 .32694 L 1 0 0 r
F
P
p
.002 w
.45036 .81407 m .44019 .81473 L .43241 .81319 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42225 .81386 m .43241 .81319 L .44019 .81473 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.76685 .60875 m .77812 .60747 L .78149 .54814 L p
1 .944 0 r
F P
0 0 0 r
s
P
p
.31193 .32192 m .33034 .3247 L .32052 .32679 L 0 1 .267 r
F
P
p
.30212 .32403 m .31193 .32192 L .32052 .32679 L 0 1 .372 r
F
P
p
.40674 .32183 m .4248 .32461 L .4147 .32671 L 0 1 .547 r
F
P
p
.39666 .32394 m .40674 .32183 L .4147 .32671 L 0 1 .651 r
F
P
p
.002 w
.68445 .64791 m .67359 .64906 L .66742 .64773 L p
.063 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65668 .65558 m .66742 .64773 L .67359 .64906 L p
.025 1 0 r
F P
0 0 0 r
s
P
p
.50158 .32175 m .51927 .32453 L .5089 .32662 L 0 1 .251 r
F
P
p
.49122 .32386 m .50158 .32175 L .5089 .32662 L 0 1 .337 r
F
P
p
.59645 .32166 m .61377 .32444 L .60312 .32653 L .5 1 0 r
F
P
p
.5858 .32377 m .59645 .32166 L .60312 .32653 L .326 1 0 r
F
P
p
.69133 .32157 m .70829 .32435 L .69736 .32645 L 1 .837 0 r
F
P
p
.68041 .32368 m .69133 .32157 L .69736 .32645 L 1 .907 0 r
F
P
p
.78624 .32148 m .80284 .32427 L .79163 .32636 L 1 .209 0 r
F
P
p
.77504 .32359 m .78624 .32148 L .79163 .32636 L 1 .453 0 r
F
P
p
.002 w
.7121 .64027 m .70159 .65942 L .69519 .63872 L p
.226 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68445 .64791 m .69519 .63872 L .70159 .65942 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.86981 .52099 m .8584 .52251 L .85347 .51897 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84262 .53334 m .85347 .51897 L .8584 .52251 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.32773 .81389 m .31791 .81455 L .30929 .813 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.88118 .3214 m .89741 .32418 L .88592 .32627 L 1 0 0 r
F
P
p
.86969 .32351 m .88118 .3214 L .88592 .32627 L 1 .028 0 r
F
P
p
.002 w
.42225 .81386 m .41215 .81452 L .40448 .79518 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39409 .81365 m .40448 .79518 L .41215 .81452 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.28358 .32125 m .30212 .32403 L .29237 .32613 L 0 1 .177 r
F
P
p
.27384 .32336 m .28358 .32125 L .29237 .32613 L 0 1 .302 r
F
P
p
.37848 .32116 m .39666 .32394 L .38663 .32604 L 0 1 .372 r
F
P
p
.36847 .32327 m .37848 .32116 L .38663 .32604 L 0 1 .372 r
F
P
p
.002 w
.69519 .63872 m .70558 .61215 L .7121 .64027 L p
.226 1 0 r
F P
0 0 0 r
s
P
p
.47341 .32107 m .49122 .32386 L .48092 .32595 L 0 1 .302 r
F
P
p
.46311 .32318 m .47341 .32107 L .48092 .32595 L 0 1 .372 r
F
P
p
.002 w
.56197 .64759 m .55146 .65007 L .54451 .70015 L p
0 1 .367 r
F P
0 0 0 r
s
P
p
.002 w
.53393 .74556 m .54451 .70015 L .55146 .65007 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.56835 .32098 m .5858 .32377 L .57522 .32587 L .065 1 0 r
F
P
p
.55778 .3231 m .56835 .32098 L .57522 .32587 L .014 1 0 r
F
P
p
.66333 .32089 m .68041 .32368 L .66955 .32578 L .52 1 0 r
F
P
p
.65248 .32301 m .66333 .32089 L .66955 .32578 L .416 1 0 r
F
P
p
.002 w
.58996 .64929 m .57943 .65911 L .5725 .63839 L p
.087 1 0 r
F P
0 0 0 r
s
P
p
.75832 .32081 m .77504 .32359 L .7639 .32569 L 1 .663 0 r
F
P
p
.74719 .32292 m .75832 .32081 L .7639 .32569 L 1 .942 0 r
F
P
p
.002 w
.73344 .61255 m .72288 .63109 L .7155 .56774 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7155 .56774 m .7265 .56635 L .73344 .61255 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70558 .61215 m .7155 .56774 L .72288 .63109 L p
.607 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7265 .56635 m .7155 .56774 L .71064 .60793 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.7155 .56774 m .70558 .61215 L .69968 .61357 L p
.762 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69968 .61357 m .71064 .60793 L .7155 .56774 L p
.762 1 0 r
F P
0 0 0 r
s
P
p
.85334 .32072 m .86969 .32351 L .85828 .32561 L 1 .063 0 r
F
P
p
.84193 .32283 m .85334 .32072 L .85828 .32561 L 1 .105 0 r
F
P
p
.002 w
.618 .65835 m .60741 .66816 L .60059 .6468 L p
0 1 .047 r
F P
0 0 0 r
s
P
p
.002 w
.58996 .64929 m .60059 .6468 L .60741 .66816 L p
0 1 .088 r
F P
0 0 0 r
s
P
p
.002 w
.39409 .81365 m .38406 .81431 L .37589 .81276 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36588 .81343 m .37589 .81276 L .38406 .81431 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.25517 .32057 m .27384 .32336 L .26417 .32546 L 0 1 .003 r
F
P
p
.24552 .32268 m .25517 .32057 L .26417 .32546 L 0 1 .177 r
F
P
p
.35016 .32048 m .36847 .32327 L .35852 .32537 L 0 1 .372 r
F
P
p
.34022 .3226 m .35016 .32048 L .35852 .32537 L 0 1 .442 r
F
P
p
.44517 .32039 m .46311 .32318 L .45288 .32528 L 0 1 .372 r
F
P
p
.43496 .32251 m .44517 .32039 L .45288 .32528 L 0 1 .372 r
F
P
p
.54021 .3203 m .55778 .3231 L .54727 .3252 L .162 1 0 r
F
P
p
.52971 .32242 m .54021 .3203 L .54727 .3252 L 0 1 .152 r
F
P
p
.63527 .32022 m .65248 .32301 L .64169 .32511 L .692 1 0 r
F
P
p
.62449 .32233 m .63527 .32022 L .64169 .32511 L .62 1 0 r
F
P
p
.73035 .32013 m .74719 .32292 L .73612 .32502 L 1 .453 0 r
F
P
p
.71929 .32225 m .73035 .32013 L .73612 .32502 L 1 .593 0 r
F
P
p
.002 w
.65668 .65558 m .64591 .65871 L .63949 .65408 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.62873 .65723 m .63949 .65408 L .64591 .65871 L p
0 1 .085 r
F P
0 0 0 r
s
P
p
.82545 .32004 m .84193 .32283 L .83058 .32494 L 1 0 0 r
F
P
p
.81411 .32216 m .82545 .32004 L .83058 .32494 L 1 0 0 r
F
P
p
.002 w
.90904 .51995 m .89749 .52147 L .89282 .51792 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88128 .51946 m .89282 .51792 L .89749 .52147 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36588 .81343 m .35592 .8141 L .34755 .81255 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33761 .81322 m .34755 .81255 L .35592 .8141 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46059 .8134 m .45036 .81407 L .44263 .81252 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43241 .81319 m .44263 .81252 L .45036 .81407 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.32179 .3198 m .34022 .3226 L .33034 .3247 L 0 1 .233 r
F
P
p
.31193 .32192 m .32179 .3198 L .33034 .3247 L 0 1 .267 r
F
P
p
.41689 .31971 m .43496 .32251 L .4248 .32461 L 0 1 .407 r
F
P
p
.40674 .32183 m .41689 .31971 L .4248 .32461 L 0 1 .547 r
F
P
p
.002 w
.69519 .63872 m .68445 .64791 L .67831 .64522 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66742 .64773 m .67831 .64522 L .68445 .64791 L p
.063 1 0 r
F P
0 0 0 r
s
P
p
.51201 .31962 m .52971 .32242 L .51927 .32453 L 0 1 .146 r
F
P
p
.50158 .32175 m .51201 .31962 L .51927 .32453 L 0 1 .251 r
F
P
p
.002 w
.60059 .6468 m .58996 .64929 L .58312 .63721 L p
.159 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58312 .63721 m .58996 .64929 L p
.57568 .64038 L .087 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59374 .62795 m .60059 .6468 L p
.58339 .63736 L .159 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58312 .63721 m .59374 .62795 L p
.58339 .63736 L .159 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6113 .64564 m .60059 .6468 L .59374 .62795 L p
.232 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59374 .62795 m .60439 .61799 L .6113 .64564 L p
.232 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59374 .62795 m .58712 .65155 L p
.60412 .61851 L .191 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60439 .61799 m .59374 .62795 L p
.60412 .61851 L .191 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58312 .63721 m .57641 .66154 L p
.59061 .63401 L .049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59374 .62795 m .58312 .63721 L p
.59061 .63401 L .049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5725 .63839 m .58312 .63721 L p
.57568 .64038 L .087 1 0 r
F P
0 0 0 r
s
P
p
.60715 .31954 m .62449 .32233 L .61377 .32444 L .605 1 0 r
F
P
p
.59645 .32166 m .60715 .31954 L .61377 .32444 L .5 1 0 r
F
P
p
.70232 .31945 m .71929 .32225 L .70829 .32435 L 1 .733 0 r
F
P
p
.69133 .32157 m .70232 .31945 L .70829 .32435 L 1 .837 0 r
F
P
p
.002 w
.62873 .65723 m .618 .65835 L .6113 .64564 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60059 .6468 m .6113 .64564 L .618 .65835 L p
0 1 .047 r
F P
0 0 0 r
s
P
p
.79751 .31936 m .81411 .32216 L .80284 .32427 L 1 .035 0 r
F
P
p
.78624 .32148 m .79751 .31936 L .80284 .32427 L 1 .209 0 r
F
P
p
.002 w
.88128 .51946 m .86981 .52099 L .86494 .51743 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85347 .51897 m .86494 .51743 L .86981 .52099 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33761 .81322 m .32773 .81389 L .31915 .81233 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30929 .813 m .31915 .81233 L .32773 .81389 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.89273 .31927 m .90896 .32207 L .89741 .32418 L 1 0 0 r
F
P
p
.88118 .3214 m .89273 .31927 L .89741 .32418 L 1 0 0 r
F
P
p
.002 w
.43241 .81319 m .42225 .81386 L .4146 .79445 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40448 .79518 m .4146 .79445 L .42225 .81386 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.29337 .31912 m .31193 .32192 L .30212 .32403 L 0 1 .003 r
F
P
p
.28358 .32125 m .29337 .31912 L .30212 .32403 L 0 1 .177 r
F
P
p
.002 w
.54451 .70015 m .55514 .69913 L .56197 .64759 L p
0 1 .367 r
F P
0 0 0 r
s
P
p
.38855 .31903 m .40674 .32183 L .39666 .32394 L 0 1 .372 r
F
P
p
.37848 .32116 m .38855 .31903 L .39666 .32394 L 0 1 .372 r
F
P
p
.48376 .31894 m .50158 .32175 L .49122 .32386 L 0 1 .192 r
F
P
p
.47341 .32107 m .48376 .31894 L .49122 .32386 L 0 1 .302 r
F
P
p
.57899 .31886 m .59645 .32166 L .5858 .32377 L .186 1 0 r
F
P
p
.56835 .32098 m .57899 .31886 L .5858 .32377 L .065 1 0 r
F
P
p
.67424 .31877 m .69133 .32157 L .68041 .32368 L .572 1 0 r
F
P
p
.66333 .32089 m .67424 .31877 L .68041 .32368 L .52 1 0 r
F
P
p
.76952 .31868 m .78624 .32148 L .77504 .32359 L 1 .453 0 r
F
P
p
.75832 .32081 m .76952 .31868 L .77504 .32359 L 1 .663 0 r
F
P
p
.002 w
.7265 .56635 m .73756 .56496 L .74451 .61129 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73756 .56496 m .7265 .56635 L .72131 .58917 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.71064 .60793 m .72131 .58917 L .7265 .56635 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.70558 .61215 m .69519 .63872 L .68912 .63597 L p
.383 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68912 .63597 m .69968 .61357 L .70558 .61215 L p
.383 1 0 r
F P
0 0 0 r
s
P
p
.86482 .31859 m .88118 .3214 L .86969 .32351 L 1 .028 0 r
F
P
p
.85334 .32072 m .86482 .31859 L .86969 .32351 L 1 .063 0 r
F
P
p
.002 w
.40448 .79518 m .39409 .81365 L .38596 .81209 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37589 .81276 m .38596 .81209 L .39409 .81365 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.26489 .31844 m .28358 .32125 L .27384 .32336 L .081 1 0 r
F
P
p
.25517 .32057 m .26489 .31844 L .27384 .32336 L 0 1 .003 r
F
P
p
.36016 .31835 m .37848 .32116 L .36847 .32327 L 0 1 .233 r
F
P
p
.35016 .32048 m .36016 .31835 L .36847 .32327 L 0 1 .372 r
F
P
p
.002 w
.67831 .64522 m .68912 .63597 L .69519 .63872 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.45545 .31826 m .47341 .32107 L .46311 .32318 L 0 1 .302 r
F
P
p
.44517 .32039 m .45545 .31826 L .46311 .32318 L 0 1 .372 r
F
P
p
.55077 .31817 m .56835 .32098 L .55778 .3231 L .535 1 0 r
F
P
p
.54021 .3203 m .55077 .31817 L .55778 .3231 L .162 1 0 r
F
P
p
.002 w
.66742 .64773 m .65668 .65558 L .65024 .64619 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63949 .65408 m .65024 .64619 L .65668 .65558 L p
0 1 .042 r
F P
0 0 0 r
s
P
p
.002 w
.4146 .79445 m .40448 .79518 L .39641 .79349 L p
.186 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38596 .81209 m .39641 .79349 L .40448 .79518 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.64611 .31808 m .66333 .32089 L .65248 .32301 L .75 1 0 r
F
P
p
.63527 .32022 m .64611 .31808 L .65248 .32301 L .692 1 0 r
F
P
p
.74147 .318 m .75832 .32081 L .74719 .32292 L 1 .279 0 r
F
P
p
.73035 .32013 m .74147 .318 L .74719 .32292 L 1 .453 0 r
F
P
p
.83686 .31791 m .85334 .32072 L .84193 .32283 L 1 0 0 r
F
P
p
.82545 .32004 m .83686 .31791 L .84193 .32283 L 1 0 0 r
F
P
p
.002 w
.92065 .51841 m .90904 .51995 L .90443 .51637 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89282 .51792 m .90443 .51637 L .90904 .51995 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.37589 .81276 m .36588 .81343 L .35796 .79399 L p
.221 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34755 .81255 m .35796 .79399 L .36588 .81343 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.23635 .31776 m .25517 .32057 L .24552 .32268 L .137 1 0 r
F
P
p
.002 w
.47088 .81273 m .46059 .8134 L .4529 .81184 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44263 .81252 m .4529 .81184 L .46059 .8134 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58312 .63721 m .5725 .63839 L .56573 .6715 L p
0 1 .053 r
F P
0 0 0 r
s
P
p
.002 w
.55514 .69913 m .56573 .6715 L .5725 .63839 L p
0 1 .225 r
F P
0 0 0 r
s
P
p
.33171 .31767 m .35016 .32048 L .34022 .3226 L 0 1 .198 r
F
P
p
.32179 .3198 m .33171 .31767 L .34022 .3226 L 0 1 .233 r
F
P
p
.42709 .31758 m .44517 .32039 L .43496 .32251 L 0 1 .267 r
F
P
p
.41689 .31971 m .42709 .31758 L .43496 .32251 L 0 1 .407 r
F
P
p
.5225 .31749 m .54021 .3203 L .52971 .32242 L 0 1 .093 r
F
P
p
.51201 .31962 m .5225 .31749 L .52971 .32242 L 0 1 .146 r
F
P
p
.61792 .3174 m .63527 .32022 L .62449 .32233 L .605 1 0 r
F
P
p
.60715 .31954 m .61792 .3174 L .62449 .32233 L .605 1 0 r
F
P
p
.002 w
.85347 .51897 m .84262 .53334 L .83701 .51693 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.82596 .52707 m .83701 .51693 L .84262 .53334 L p
1 .157 0 r
F P
0 0 0 r
s
P
p
.71338 .31731 m .73035 .32013 L .71929 .32225 L 1 .593 0 r
F
P
p
.70232 .31945 m .71338 .31731 L .71929 .32225 L 1 .733 0 r
F
P
p
.002 w
.63949 .65408 m .62873 .65723 L .62197 .6364 L p
.162 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6113 .64564 m .62197 .6364 L .62873 .65723 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.80885 .31722 m .82545 .32004 L .81411 .32216 L 1 0 0 r
F
P
p
.79751 .31936 m .80885 .31722 L .81411 .32216 L 1 .035 0 r
F
P
p
.002 w
.75565 .61002 m .74451 .61129 L .73756 .56496 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.89282 .51792 m .88128 .51946 L .87648 .51588 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86494 .51743 m .87648 .51588 L .88128 .51946 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34755 .81255 m .33761 .81322 L .32907 .81166 L p
.291 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31915 .81233 m .32907 .81166 L .33761 .81322 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.89273 .31927 m .90435 .31714 L .90896 .32207 L 1 0 0 r
F
P
p
.002 w
.44263 .81252 m .43241 .81319 L .42478 .79373 L p
.151 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4146 .79445 m .42478 .79373 L .43241 .81319 L p
.326 0 1 r
F P
0 0 0 r
s
P
p
.30321 .31698 m .32179 .3198 L .31193 .32192 L .047 1 0 r
F
P
p
.29337 .31912 m .30321 .31698 L .31193 .32192 L 0 1 .003 r
F
P
p
.39868 .31689 m .41689 .31971 L .40674 .32183 L 0 1 .372 r
F
P
p
.38855 .31903 m .39868 .31689 L .40674 .32183 L 0 1 .372 r
F
P
p
.49417 .31681 m .51201 .31962 L .50158 .32175 L 0 1 .109 r
F
P
p
.48376 .31894 m .49417 .31681 L .50158 .32175 L 0 1 .192 r
F
P
p
.58969 .31672 m .60715 .31954 L .59645 .32166 L .326 1 0 r
F
P
p
.57899 .31886 m .58969 .31672 L .59645 .32166 L .186 1 0 r
F
P
p
.002 w
.67831 .64522 m .66742 .64773 L .66115 .64502 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65024 .64619 m .66115 .64502 L .66742 .64773 L p
.02 1 0 r
F P
0 0 0 r
s
P
p
.68522 .31663 m .70232 .31945 L .69133 .32157 L .709 1 0 r
F
P
p
.67424 .31877 m .68522 .31663 L .69133 .32157 L .572 1 0 r
F
P
p
.78078 .31654 m .79751 .31936 L .78624 .32148 L 1 .244 0 r
F
P
p
.76952 .31868 m .78078 .31654 L .78624 .32148 L 1 .453 0 r
F
P
p
.002 w
.73756 .56496 m .74869 .56355 L .75565 .61002 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74869 .56355 m .73756 .56496 L .73247 .58782 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.72131 .58917 m .73247 .58782 L .73756 .56496 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.86494 .51743 m .85347 .51897 L .84847 .51538 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83701 .51693 m .84847 .51538 L .85347 .51897 L p
1 .052 0 r
F P
0 0 0 r
s
P
p
.002 w
.31915 .81233 m .30929 .813 L .30055 .81144 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.87637 .31645 m .89273 .31927 L .88118 .3214 L 1 0 0 r
F
P
p
.86482 .31859 m .87637 .31645 L .88118 .3214 L 1 .028 0 r
F
P
p
.27466 .3163 m .29337 .31912 L .28358 .32125 L .261 1 0 r
F
P
p
.26489 .31844 m .27466 .3163 L .28358 .32125 L .081 1 0 r
F
P
p
.37021 .31621 m .38855 .31903 L .37848 .32116 L 0 1 .163 r
F
P
p
.36016 .31835 m .37021 .31621 L .37848 .32116 L 0 1 .233 r
F
P
p
.46579 .31612 m .48376 .31894 L .47341 .32107 L 0 1 .163 r
F
P
p
.45545 .31826 m .46579 .31612 L .47341 .32107 L 0 1 .302 r
F
P
p
.56139 .31603 m .57899 .31886 L .56835 .32098 L .605 1 0 r
F
P
p
.55077 .31817 m .56139 .31603 L .56835 .32098 L .535 1 0 r
F
P
p
.002 w
.4529 .81184 m .44263 .81252 L .43561 .74848 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.43561 .74848 m .44585 .74762 L .4529 .81184 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.42478 .79373 m .43561 .74848 L .44263 .81252 L p
.151 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43561 .74848 m .42478 .79373 L .41723 .76515 L p
0 .243 1 r
F P
0 0 0 r
s
P
p
.002 w
.41723 .76515 m .42764 .75284 L .43561 .74848 L p
0 .243 1 r
F P
0 0 0 r
s
P
p
.002 w
.44585 .74762 m .43561 .74848 L .42764 .75284 L p
0 .487 1 r
F P
0 0 0 r
s
P
p
.002 w
.42478 .79373 m .4146 .79445 L .40658 .79276 L p
.081 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39641 .79349 m .40658 .79276 L .4146 .79445 L p
.186 0 1 r
F P
0 0 0 r
s
P
p
.65702 .31594 m .67424 .31877 L .66333 .32089 L .75 1 0 r
F
P
p
.64611 .31808 m .65702 .31594 L .66333 .32089 L .75 1 0 r
F
P
p
.75267 .31585 m .76952 .31868 L .75832 .32081 L 1 .14 0 r
F
P
p
.74147 .318 m .75267 .31585 L .75832 .32081 L 1 .279 0 r
F
P
p
.84834 .31576 m .86482 .31859 L .85334 .32072 L 1 0 0 r
F
P
p
.83686 .31791 m .84834 .31576 L .85334 .32072 L 1 0 0 r
F
P
p
.002 w
.93233 .51687 m .92065 .51841 L .91611 .51482 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90443 .51637 m .91611 .51482 L .92065 .51841 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38596 .81209 m .37589 .81276 L .36858 .76652 L p
.047 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35796 .79399 m .36858 .76652 L .37589 .81276 L p
.221 0 1 r
F P
0 0 0 r
s
P
p
.24605 .31561 m .26489 .31844 L .25517 .32057 L .311 1 0 r
F
P
p
.23635 .31776 m .24605 .31561 L .25517 .32057 L .137 1 0 r
F
P
p
.002 w
.48123 .81206 m .47088 .81273 L .46324 .81116 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4529 .81184 m .46324 .81116 L .47088 .81273 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56573 .6715 m .57641 .66154 L .58312 .63721 L p
0 1 .053 r
F P
0 0 0 r
s
P
p
.34169 .31552 m .36016 .31835 L .35016 .32048 L 0 1 .128 r
F
P
p
.33171 .31767 m .34169 .31552 L .35016 .32048 L 0 1 .198 r
F
P
p
.002 w
.62197 .6364 m .6113 .64564 L .60439 .61799 L p
.334 1 0 r
F P
0 0 0 r
s
P
p
.43736 .31543 m .45545 .31826 L .44517 .32039 L 0 1 .233 r
F
P
p
.42709 .31758 m .43736 .31543 L .44517 .32039 L 0 1 .267 r
F
P
p
.53305 .31534 m .55077 .31817 L .54021 .3203 L .047 1 0 r
F
P
p
.5225 .31749 m .53305 .31534 L .54021 .3203 L 0 1 .093 r
F
P
p
.002 w
.65024 .64619 m .63949 .65408 L .63245 .60967 L p
.299 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62197 .6364 m .63245 .60967 L .63949 .65408 L p
.162 1 0 r
F P
0 0 0 r
s
P
p
.62876 .31525 m .64611 .31808 L .63527 .32022 L .744 1 0 r
F
P
p
.61792 .3174 m .62876 .31525 L .63527 .32022 L .605 1 0 r
F
P
p
.72449 .31516 m .74147 .318 L .73035 .32013 L 1 .453 0 r
F
P
p
.71338 .31731 m .72449 .31516 L .73035 .32013 L 1 .593 0 r
F
P
p
.82025 .31508 m .83686 .31791 L .82545 .32004 L 1 0 0 r
F
P
p
.80885 .31722 m .82025 .31508 L .82545 .32004 L 1 0 0 r
F
P
p
.002 w
.76685 .60875 m .75565 .61002 L .74869 .56355 L p
.997 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36858 .76652 m .37901 .74793 L .38596 .81209 L p
.047 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37901 .74793 m .36858 .76652 L .36024 .76463 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.36858 .76652 m .35796 .79399 L .35019 .76545 L p
0 .128 1 r
F P
0 0 0 r
s
P
p
.002 w
.35019 .76545 m .36024 .76463 L .36858 .76652 L p
0 .128 1 r
F P
0 0 0 r
s
P
p
.002 w
.90443 .51637 m .89282 .51792 L .88808 .51432 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87648 .51588 m .88808 .51432 L .89282 .51792 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35796 .79399 m .34755 .81255 L .34021 .76626 L p
.047 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32907 .81166 m .34021 .76626 L .34755 .81255 L p
.291 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.83701 .51693 m .82596 .52707 L .82213 .55831 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.31312 .31483 m .33171 .31767 L .32179 .3198 L .136 1 0 r
F
P
p
.30321 .31698 m .31312 .31483 L .32179 .3198 L .047 1 0 r
F
P
p
.40887 .31474 m .42709 .31758 L .41689 .31971 L 0 1 .302 r
F
P
p
.39868 .31689 m .40887 .31474 L .41689 .31971 L 0 1 .372 r
F
P
p
.002 w
.68912 .63597 m .67831 .64522 L .6721 .64249 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66115 .64502 m .6721 .64249 L .67831 .64522 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.50465 .31465 m .5225 .31749 L .51201 .31962 L 0 1 .05 r
F
P
p
.49417 .31681 m .50465 .31465 L .51201 .31962 L 0 1 .109 r
F
P
p
.002 w
.39641 .79349 m .38596 .81209 L .37901 .74793 L p
0 .093 1 r
F P
0 0 0 r
s
P
p
.002 w
.37901 .74793 m .3891 .74707 L .39641 .79349 L p
0 .093 1 r
F P
0 0 0 r
s
P
p
.002 w
.3891 .74707 m .37901 .74793 L .37073 .74591 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.36024 .76463 m .37073 .74591 L .37901 .74793 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.34021 .76626 m .35019 .76545 L .35796 .79399 L p
.047 0 1 r
F P
0 0 0 r
s
P
p
.60045 .31456 m .61792 .3174 L .60715 .31954 L .395 1 0 r
F
P
p
.58969 .31672 m .60045 .31456 L .60715 .31954 L .326 1 0 r
F
P
p
.69627 .31448 m .71338 .31731 L .70232 .31945 L .884 1 0 r
F
P
p
.68522 .31663 m .69627 .31448 L .70232 .31945 L .709 1 0 r
F
P
p
.002 w
.63245 .60967 m .6433 .60839 L .65024 .64619 L p
.299 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6433 .60839 m .63245 .60967 L .62592 .6067 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63245 .60967 m .62197 .6364 L .61508 .60799 L p
.503 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61508 .60799 m .62592 .6067 L .63245 .60967 L p
.503 1 0 r
F P
0 0 0 r
s
P
p
.79212 .31439 m .80885 .31722 L .79751 .31936 L 1 .035 0 r
F
P
p
.78078 .31654 m .79212 .31439 L .79751 .31936 L 1 .244 0 r
F
P
p
.002 w
.74869 .56355 m .75954 .55131 L .76685 .60875 L p
.997 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75954 .55131 m .74869 .56355 L .74295 .56026 L p
1 .654 0 r
F P
0 0 0 r
s
P
p
.002 w
.73247 .58782 m .74295 .56026 L .74869 .56355 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.35019 .76545 m .34021 .76626 L .33166 .76436 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.34021 .76626 m .32907 .81166 L .32042 .81007 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32042 .81007 m .33166 .76436 L .34021 .76626 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.87648 .51588 m .86494 .51743 L .86001 .51382 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84847 .51538 m .86001 .51382 L .86494 .51743 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.32907 .81166 m .31915 .81233 L .31045 .81076 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30055 .81144 m .31045 .81076 L .31915 .81233 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.88799 .3143 m .90435 .31714 L .89273 .31927 L 1 0 0 r
F
P
p
.87637 .31645 m .88799 .3143 L .89273 .31927 L 1 0 0 r
F
P
p
.002 w
.57641 .66154 m .58712 .65155 L .59374 .62795 L p
.049 1 0 r
F P
0 0 0 r
s
P
p
.28449 .31414 m .30321 .31698 L .29337 .31912 L .463 1 0 r
F
P
p
.27466 .3163 m .28449 .31414 L .29337 .31912 L .261 1 0 r
F
P
p
.002 w
.60439 .61799 m .61508 .60799 L .62197 .6364 L p
.334 1 0 r
F P
0 0 0 r
s
P
p
.38033 .31405 m .39868 .31689 L .38855 .31903 L 0 1 .142 r
F
P
p
.37021 .31621 m .38033 .31405 L .38855 .31903 L 0 1 .163 r
F
P
p
.47619 .31396 m .49417 .31681 L .48376 .31894 L 0 1 .087 r
F
P
p
.46579 .31612 m .47619 .31396 L .48376 .31894 L 0 1 .163 r
F
P
p
.57208 .31387 m .58969 .31672 L .57899 .31886 L .64 1 0 r
F
P
p
.56139 .31603 m .57208 .31387 L .57899 .31886 L .605 1 0 r
F
P
p
.002 w
.66115 .64502 m .65024 .64619 L .6433 .60839 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46324 .81116 m .4529 .81184 L .44585 .74762 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.44585 .74762 m .45616 .74675 L .46324 .81116 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.45616 .74675 m .44585 .74762 L .43802 .7456 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.42764 .75284 m .43802 .7456 L .44585 .74762 L p
0 .487 1 r
F P
0 0 0 r
s
P
p
.002 w
.40658 .79276 m .41723 .76515 L .42478 .79373 L p
.081 0 1 r
F P
0 0 0 r
s
P
p
.66799 .31378 m .68522 .31663 L .67424 .31877 L .795 1 0 r
F
P
p
.65702 .31594 m .66799 .31378 L .67424 .31877 L .75 1 0 r
F
P
p
.76392 .3137 m .78078 .31654 L .76952 .31868 L 1 .105 0 r
F
P
p
.75267 .31585 m .76392 .3137 L .76952 .31868 L 1 .14 0 r
F
P
p
.002 w
.84847 .51538 m .83701 .51693 L .83367 .55687 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.82213 .55831 m .83367 .55687 L .83701 .51693 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.85988 .31361 m .87637 .31645 L .86482 .31859 L 1 0 0 r
F
P
p
.84834 .31576 m .85988 .31361 L .86482 .31859 L 1 0 0 r
F
P
p
.002 w
.91611 .51482 m .92785 .51325 L .93233 .51687 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.25581 .31345 m .27466 .3163 L .26489 .31844 L .43 1 0 r
F
P
p
.24605 .31561 m .25581 .31345 L .26489 .31844 L .311 1 0 r
F
P
p
.002 w
.49165 .81138 m .48123 .81206 L .47364 .81048 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46324 .81116 m .47364 .81048 L .48123 .81206 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.35173 .31336 m .37021 .31621 L .36016 .31835 L 0 1 .003 r
F
P
p
.34169 .31552 m .35173 .31336 L .36016 .31835 L 0 1 .128 r
F
P
p
.002 w
.77812 .60747 m .76685 .60875 L .75954 .55131 L p
1 .933 0 r
F P
0 0 0 r
s
P
p
.002 w
.77057 .54337 m .77812 .60747 L p
.7618 .55814 L 1 .933 0 r
F P
0 0 0 r
s
P
p
.002 w
.78884 .58868 m .77812 .60747 L .77057 .54337 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.77057 .54337 m .78128 .52457 L .78884 .58868 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.77057 .54337 m .76552 .55739 L p
.77937 .52854 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.78128 .52457 m .77057 .54337 L p
.77937 .52854 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.75954 .55131 m .77057 .54337 L p
.7618 .55814 L 1 .933 0 r
F P
0 0 0 r
s
P
p
.002 w
.77057 .54337 m .75954 .55131 L .7542 .55883 L p
1 .584 0 r
F P
0 0 0 r
s
P
p
.002 w
.74295 .56026 m .7542 .55883 L .75954 .55131 L p
1 .654 0 r
F P
0 0 0 r
s
P
p
.002 w
.69968 .61357 m .68912 .63597 L .68297 .63317 L p
.281 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6721 .64249 m .68297 .63317 L .68912 .63597 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.44768 .31327 m .46579 .31612 L .45545 .31826 L 0 1 .163 r
F
P
p
.43736 .31543 m .44768 .31327 L .45545 .31826 L 0 1 .233 r
F
P
p
.002 w
.71064 .60793 m .69968 .61357 L .69406 .63195 L p
.485 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68297 .63317 m .69406 .63195 L .69968 .61357 L p
.281 1 0 r
F P
0 0 0 r
s
P
p
.54366 .31318 m .56139 .31603 L .55077 .31817 L .326 1 0 r
F
P
p
.53305 .31534 m .54366 .31318 L .55077 .31817 L .047 1 0 r
F
P
p
.002 w
.40658 .79276 m .39641 .79349 L .3891 .74707 L p
0 .163 1 r
F P
0 0 0 r
s
P
p
.63966 .31309 m .65702 .31594 L .64611 .31808 L .919 1 0 r
F
P
p
.62876 .31525 m .63966 .31309 L .64611 .31808 L .744 1 0 r
F
P
p
.73568 .313 m .75267 .31585 L .74147 .318 L 1 .314 0 r
F
P
p
.72449 .31516 m .73568 .313 L .74147 .318 L 1 .453 0 r
F
P
p
.83173 .31291 m .84834 .31576 L .83686 .31791 L 1 0 0 r
F
P
p
.82025 .31508 m .83173 .31291 L .83686 .31791 L 1 0 0 r
F
P
p
.002 w
.61508 .60799 m .60439 .61799 L .59786 .64016 L p
.331 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58712 .65155 m .59786 .64016 L .60439 .61799 L p
.191 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.91611 .51482 m .90443 .51637 L .89976 .51275 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88808 .51432 m .89976 .51275 L .90443 .51637 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.22707 .31276 m .24605 .31561 L .23635 .31776 L .326 1 0 r
F
P
p
.32308 .31267 m .34169 .31552 L .33171 .31767 L .276 1 0 r
F
P
p
.31312 .31483 m .32308 .31267 L .33171 .31767 L .136 1 0 r
F
P
p
.41912 .31258 m .43736 .31543 L .42709 .31758 L 0 1 .198 r
F
P
p
.40887 .31474 m .41912 .31258 L .42709 .31758 L 0 1 .302 r
F
P
p
.51518 .31249 m .53305 .31534 L .5225 .31749 L 0 1 .027 r
F
P
p
.50465 .31465 m .51518 .31249 L .5225 .31749 L 0 1 .05 r
F
P
p
.002 w
.3891 .74707 m .39926 .74619 L .40658 .79276 L p
0 .163 1 r
F P
0 0 0 r
s
P
p
.002 w
.39926 .74619 m .3891 .74707 L .38087 .74503 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.37073 .74591 m .38087 .74503 L .3891 .74707 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.61127 .3124 m .62876 .31525 L .61792 .3174 L .395 1 0 r
F
P
p
.60045 .31456 m .61127 .3124 L .61792 .3174 L .395 1 0 r
F
P
p
.70738 .31231 m .72449 .31516 L .71338 .31731 L 1 .977 0 r
F
P
p
.69627 .31448 m .70738 .31231 L .71338 .31731 L .884 1 0 r
F
P
p
.002 w
.6433 .60839 m .65421 .60711 L .66115 .64502 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65421 .60711 m .6433 .60839 L .63682 .6054 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62592 .6067 m .63682 .6054 L .6433 .60839 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.80351 .31222 m .82025 .31508 L .80885 .31722 L 1 0 0 r
F
P
p
.79212 .31439 m .80351 .31222 L .80885 .31722 L 1 .035 0 r
F
P
p
.002 w
.36024 .76463 m .35019 .76545 L .34169 .76354 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.33166 .76436 m .34169 .76354 L .35019 .76545 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.88808 .51432 m .87648 .51588 L .87161 .51225 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86001 .51382 m .87161 .51225 L .87648 .51588 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31045 .81076 m .32042 .81007 L .32907 .81166 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.88799 .3143 m .89967 .31213 L .90435 .31714 L 1 0 0 r
F
P
p
.29438 .31198 m .31312 .31483 L .30321 .31698 L .527 1 0 r
F
P
p
.28449 .31414 m .29438 .31198 L .30321 .31698 L .463 1 0 r
F
P
p
.3905 .31189 m .40887 .31474 L .39868 .31689 L 0 1 .122 r
F
P
p
.38033 .31405 m .3905 .31189 L .39868 .31689 L 0 1 .142 r
F
P
p
.48665 .3118 m .50465 .31465 L .49417 .31681 L 0 1 .05 r
F
P
p
.47619 .31396 m .48665 .3118 L .49417 .31681 L 0 1 .087 r
F
P
p
.002 w
.7542 .55883 m .76552 .55739 L .77057 .54337 L p
1 .584 0 r
F P
0 0 0 r
s
P
p
.58283 .31171 m .60045 .31456 L .58969 .31672 L .738 1 0 r
F
P
p
.57208 .31387 m .58283 .31171 L .58969 .31672 L .64 1 0 r
F
P
p
.002 w
.6721 .64249 m .66115 .64502 L .65421 .60711 L p
.331 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47364 .81048 m .46324 .81116 L .45616 .74675 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.45616 .74675 m .46652 .74588 L .47364 .81048 L p
0 .023 1 r
F P
0 0 0 r
s
P
p
.002 w
.46652 .74588 m .45616 .74675 L .44838 .74472 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.43802 .7456 m .44838 .74472 L .45616 .74675 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.67903 .31162 m .69627 .31448 L .68522 .31663 L .932 1 0 r
F
P
p
.66799 .31378 m .67903 .31162 L .68522 .31663 L .795 1 0 r
F
P
p
.002 w
.62592 .6067 m .61508 .60799 L .60867 .63146 L p
.398 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59786 .64016 m .60867 .63146 L .61508 .60799 L p
.331 1 0 r
F P
0 0 0 r
s
P
p
.77525 .31153 m .79212 .31439 L .78078 .31654 L 1 .035 0 r
F
P
p
.76392 .3137 m .77525 .31153 L .78078 .31654 L 1 .105 0 r
F
P
p
.002 w
.72131 .58917 m .71064 .60793 L .70462 .60494 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69406 .63195 m .70462 .60494 L .71064 .60793 L p
.485 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.86001 .51382 m .84847 .51538 L .8449 .54664 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.83367 .55687 m .8449 .54664 L .84847 .51538 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.31045 .81076 m .30055 .81144 L .29169 .80985 L p
.291 0 1 r
F P
0 0 0 r
s
P
p
.8715 .31144 m .88799 .3143 L .87637 .31645 L 1 0 0 r
F
P
p
.85988 .31361 m .8715 .31144 L .87637 .31645 L 1 0 0 r
F
P
p
.002 w
.49473 .79101 m .48411 .80979 L .47727 .70323 L p
0 .431 1 r
F P
0 0 0 r
s
P
p
.002 w
.47727 .70323 m .48772 .6995 L .49473 .79101 L p
0 .431 1 r
F P
0 0 0 r
s
P
p
.002 w
.46652 .74588 m .47727 .70323 L .48411 .80979 L p
0 .187 1 r
F P
0 0 0 r
s
P
p
.002 w
.47727 .70323 m .46652 .74588 L .45879 .74383 L p
0 .71 1 r
F P
0 0 0 r
s
P
p
.002 w
.48772 .6995 m .47727 .70323 L .46934 .73394 L p
0 1 .952 r
F P
0 0 0 r
s
P
p
.002 w
.45879 .74383 m .46934 .73394 L .47727 .70323 L p
0 .71 1 r
F P
0 0 0 r
s
P
p
.002 w
.42764 .75284 m .41723 .76515 L .40947 .74532 L p
0 .417 1 r
F P
0 0 0 r
s
P
p
.002 w
.41723 .76515 m .40658 .79276 L .39926 .74619 L p
0 .267 1 r
F P
0 0 0 r
s
P
p
.002 w
.39926 .74619 m .40947 .74532 L .41723 .76515 L p
0 .267 1 r
F P
0 0 0 r
s
P
p
.002 w
.79262 .52303 m .78128 .52457 L .77633 .53842 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.76552 .55739 m .77633 .53842 L .78128 .52457 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.26562 .31128 m .28449 .31414 L .27466 .3163 L .52 1 0 r
F
P
p
.25581 .31345 m .26562 .31128 L .27466 .3163 L .43 1 0 r
F
P
p
.002 w
.50212 .8107 m .49165 .81138 L .48411 .80979 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47364 .81048 m .48411 .80979 L .49165 .81138 L p
.465 0 1 r
F P
0 0 0 r
s
P
p
.36183 .31119 m .38033 .31405 L .37021 .31621 L .088 1 0 r
F
P
p
.35173 .31336 m .36183 .31119 L .37021 .31621 L 0 1 .003 r
F
P
p
.45807 .3111 m .47619 .31396 L .46579 .31612 L 0 1 .087 r
F
P
p
.44768 .31327 m .45807 .3111 L .46579 .31612 L 0 1 .163 r
F
P
p
.002 w
.73247 .58782 m .72131 .58917 L .7158 .60363 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70462 .60494 m .7158 .60363 L .72131 .58917 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.55433 .31101 m .57208 .31387 L .56139 .31603 L .5 1 0 r
F
P
p
.54366 .31318 m .55433 .31101 L .56139 .31603 L .326 1 0 r
F
P
p
.65062 .31092 m .66799 .31378 L .65702 .31594 L .988 1 0 r
F
P
p
.63966 .31309 m .65062 .31092 L .65702 .31594 L .919 1 0 r
F
P
p
.002 w
.55514 .69913 m .54451 .70015 L .53736 .78799 L p
0 .547 1 r
F P
0 0 0 r
s
P
p
.002 w
.54451 .70015 m .53393 .74556 L .527 .78645 L p
0 .337 1 r
F P
0 0 0 r
s
P
p
.52737 .785 m .54451 .70015 L .527 .78645 L 0 .337 1 r
F
P
p
.002 w
.52661 .78875 m .53736 .78799 L .54451 .70015 L p
0 .337 1 r
F P
0 0 0 r
s
P
p
.002 w
.54076 .64964 m .54464 .71692 L p
.53067 .6535 L 0 .895 1 r
F P
0 0 0 r
s
P
p
.53008 .65081 m .54464 .71692 L .54133 .72996 L 0 .895 1 r
F
P
p
.002 w
.53736 .78799 m .54817 .77808 L .55514 .69913 L p
0 .547 1 r
F P
0 0 0 r
s
P
p
.002 w
.54817 .77808 m .53736 .78799 L .53008 .65081 L p
0 .895 1 r
F P
0 0 0 r
s
P
p
.002 w
.58712 .65155 m .57641 .66154 L .56981 .7399 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.56981 .7399 m .57641 .66154 L p
.56052 .75042 L 0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.55898 .759 m .56981 .7399 L p
.56052 .75042 L 0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.56981 .7399 m .58076 .73899 L .58712 .65155 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.56981 .7399 m .56908 .72928 L p
.57491 .73413 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.002 w
.58076 .73899 m .56981 .7399 L p
.57491 .73413 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.002 w
.56573 .6715 m .55514 .69913 L .54951 .76288 L p
0 .756 1 r
F P
0 0 0 r
s
P
p
.55057 .76105 m .56573 .6715 L .54951 .76288 L 0 .756 1 r
F
P
p
.54934 .77098 m .56573 .6715 L .54869 .77219 L 0 .756 1 r
F
P
p
.002 w
.57641 .66154 m .56573 .6715 L .55898 .759 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.54817 .77808 m .55898 .759 L .56573 .6715 L p
0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.57299 .6104 m .58076 .73899 L p
.56311 .63397 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.002 w
.56224 .62876 m .57299 .6104 L p
.56311 .63397 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.002 w
.59786 .64016 m .58712 .65155 L .58076 .73899 L p
0 1 .576 r
F P
0 0 0 r
s
P
p
.002 w
.59143 .69259 m .59786 .64016 L p
.58167 .73374 L 0 1 .576 r
F P
0 0 0 r
s
P
p
.002 w
.58076 .73899 m .59143 .69259 L p
.58167 .73374 L 0 1 .576 r
F P
0 0 0 r
s
P
p
.002 w
.60867 .63146 m .59786 .64016 L .59143 .69259 L p
0 1 .192 r
F P
0 0 0 r
s
P
p
.002 w
.59143 .69259 m .5837 .58248 L p
.60115 .65161 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .65544 m .60867 .63146 L p
.59516 .67936 L 0 1 .192 r
F P
0 0 0 r
s
P
p
.002 w
.59143 .69259 m .60212 .65544 L p
.59516 .67936 L 0 1 .192 r
F P
0 0 0 r
s
P
p
.002 w
.60867 .63146 m .61959 .62955 L .62592 .6067 L p
.398 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61959 .62955 m .60867 .63146 L .60212 .65544 L p
.014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .65544 m .59505 .58546 L p
.60908 .63147 L .395 1 0 r
F P
0 0 0 r
s
P
p
.59563 .58465 m .60908 .63147 L .59505 .58546 L .395 1 0 r
F
P
p
.002 w
.59461 .5811 m .59505 .58546 L p
.58936 .58397 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59505 .58546 m .60212 .65544 L p
.58659 .59395 L .186 1 0 r
F P
0 0 0 r
s
P
p
.5837 .58248 m .59505 .58546 L .58659 .59395 L .186 1 0 r
F
P
p
.002 w
.59505 .58546 m .59461 .5811 L p
.59563 .58465 L .395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57299 .6104 m .57835 .59644 L p
.59143 .69259 L 0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.57835 .59644 m .5837 .58248 L .58406 .58769 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.58406 .58769 m .59143 .69259 L p
.57835 .59644 L 0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.61305 .64527 m .61959 .62955 L p
.6037 .65308 L .014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .65544 m .61305 .64527 L p
.6037 .65308 L .014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63682 .6054 m .62592 .6067 L .61959 .62955 L p
.433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61959 .62955 m .63048 .6201 L .63682 .6054 L p
.433 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63048 .6201 m .61959 .62955 L .61305 .64527 L p
.084 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61305 .64527 m .62413 .64407 L .63048 .6201 L p
.084 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61305 .64527 m .6055 .57083 L p
.62244 .63742 L .535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62413 .64407 m .61305 .64527 L p
.62244 .63742 L .535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59461 .5811 m .6055 .57083 L .61305 .64527 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59461 .5811 m .58825 .65906 L p
.60456 .57565 L .326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6055 .57083 m .59461 .5811 L p
.60456 .57565 L .326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5837 .58248 m .59461 .5811 L p
.58936 .58397 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6055 .57083 m .61633 .55166 L .62413 .64407 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6055 .57083 m .60514 .57533 L p
.6154 .55696 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60514 .57533 m .59933 .64874 L p
.61369 .56676 L .5 1 0 r
F P
0 0 0 r
s
P
p
.61369 .56676 m .6154 .55696 L .60514 .57533 L .5 1 0 r
F
P
p
.002 w
.61633 .55166 m .6055 .57083 L p
.6154 .55696 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61305 .64527 m .60212 .65544 L p
.60908 .63147 L .395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60212 .65544 m .59143 .69259 L p
.60115 .65161 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59143 .69259 m .58076 .73899 L .57299 .6104 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.57299 .6104 m .57233 .61663 L p
.57987 .594 L .049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5837 .58248 m .57299 .6104 L p
.57987 .594 L .049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56908 .72928 m .56265 .63484 L p
.57688 .7159 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.56311 .63397 m .57688 .7159 L .56265 .63484 L 0 1 .579 r
F
P
p
.002 w
.57233 .61663 m .56689 .66808 L p
.57992 .60236 L .049 1 0 r
F P
0 0 0 r
s
P
p
.56768 .66684 m .57992 .60236 L .56689 .66808 L .049 1 0 r
F
P
p
.57992 .60236 m .5837 .58248 L .57233 .61663 L .049 1 0 r
F
P
p
.002 w
.59461 .5811 m .5837 .58248 L .57724 .67355 L p
.205 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5662 .67467 m .57724 .67355 L .5837 .58248 L p
.049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58825 .65906 m .59461 .5811 L p
.57773 .67091 L .205 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57724 .67355 m .58825 .65906 L p
.57773 .67091 L .205 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58825 .65906 m .59933 .64874 L .6055 .57083 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58825 .65906 m .58072 .59258 L p
.59881 .64716 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59933 .64874 m .58825 .65906 L p
.59881 .64716 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56967 .59395 m .58072 .59258 L .58589 .63817 L p
.065 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58589 .63817 m .58825 .65906 L p
.58341 .64208 L .065 1 0 r
F P
0 0 0 r
s
P
p
.56967 .59395 m .58589 .63817 L .58341 .64208 L .065 1 0 r
F
P
p
.002 w
.56689 .66808 m .5662 .67467 L p
.56768 .66684 L .049 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56265 .63484 m .56224 .62876 L p
.56311 .63397 L 0 1 .579 r
F P
0 0 0 r
s
P
p
.57688 .7159 m .58076 .73899 L .56908 .72928 L 0 1 .579 r
F
P
p
.002 w
.54951 .76288 m .54869 .77219 L p
.55057 .76105 L 0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.54869 .77219 m .54817 .77808 L p
.54934 .77098 L 0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.55149 .64464 m .55863 .75362 L p
.54194 .65652 L 0 1 .985 r
F P
0 0 0 r
s
P
p
.5417 .65531 m .55863 .75362 L .55821 .7544 L 0 1 .985 r
F
P
p
.54076 .64964 m .54173 .65528 L .5417 .65531 L 0 1 .985 r
F
P
p
.54173 .65528 m .55863 .75362 L .5417 .65531 L 0 1 .985 r
F
P
p
.002 w
.55898 .759 m .54817 .77808 L .54113 .65615 L p
0 1 .985 r
F P
0 0 0 r
s
P
p
.002 w
.54113 .65615 m .54076 .64964 L p
.5417 .65531 L 0 1 .985 r
F P
0 0 0 r
s
P
p
.5417 .65531 m .55898 .759 L .54113 .65615 L 0 1 .985 r
F
P
p
.002 w
.56981 .7399 m .55898 .759 L .55149 .64464 L p
0 1 .773 r
F P
0 0 0 r
s
P
p
.002 w
.56224 .62876 m .56981 .7399 L p
.55177 .64609 L 0 1 .773 r
F P
0 0 0 r
s
P
p
.002 w
.55149 .64464 m .56224 .62876 L p
.55177 .64609 L 0 1 .773 r
F P
0 0 0 r
s
P
p
.002 w
.56224 .62876 m .55522 .67579 L p
.57272 .61139 L 0 1 .123 r
F P
0 0 0 r
s
P
p
.002 w
.57299 .6104 m .56224 .62876 L p
.57272 .61139 L 0 1 .123 r
F P
0 0 0 r
s
P
p
.002 w
.55522 .67579 m .56177 .63191 L p
.54725 .68098 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.54433 .69085 m .56177 .63191 L .5611 .63268 L 0 1 .301 r
F
P
p
.002 w
.55149 .64464 m .54433 .69085 L p
.5611 .63268 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.54076 .64964 m .55149 .64464 L p
.54194 .65652 L 0 1 .985 r
F P
0 0 0 r
s
P
p
.002 w
.54076 .64964 m .53347 .69191 L p
.5511 .64567 L 0 1 .427 r
F P
0 0 0 r
s
P
p
.002 w
.53347 .69191 m .54433 .69085 L .55149 .64464 L p
0 1 .427 r
F P
0 0 0 r
s
P
p
.002 w
.55522 .67579 m .5662 .67467 L .57299 .6104 L p
0 1 .123 r
F P
0 0 0 r
s
P
p
.002 w
.55522 .67579 m .54787 .64797 L p
.56333 .6705 L 0 1 .184 r
F P
0 0 0 r
s
P
p
.002 w
.5662 .67467 m .55522 .67579 L p
.56333 .6705 L 0 1 .184 r
F P
0 0 0 r
s
P
p
.002 w
.54433 .69085 m .55522 .67579 L p
.54725 .68098 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.56177 .63191 m .56224 .62876 L p
.5611 .63268 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.56224 .62876 m .55149 .64464 L p
.5611 .63268 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.55863 .75362 m .55898 .759 L p
.55821 .7544 L 0 1 .985 r
F P
0 0 0 r
s
P
p
.002 w
.55149 .64464 m .54076 .64964 L p
.5511 .64567 L 0 1 .427 r
F P
0 0 0 r
s
P
p
.002 w
.53008 .65081 m .54076 .64964 L p
.53067 .6535 L 0 .895 1 r
F P
0 0 0 r
s
P
p
.002 w
.54464 .71692 m .54817 .77808 L p
.54133 .72996 L 0 .895 1 r
F P
0 0 0 r
s
P
p
.002 w
.527 .78645 m .52661 .78875 L p
.52737 .785 L 0 .337 1 r
F P
0 0 0 r
s
P
p
.74693 .31083 m .76392 .3137 L .75267 .31585 L 1 .209 0 r
F
P
p
.73568 .313 m .74693 .31083 L .75267 .31585 L 1 .314 0 r
F
P
p
.84327 .31074 m .85988 .31361 L .84834 .31576 L 1 0 0 r
F
P
p
.83173 .31291 m .84327 .31074 L .84834 .31576 L 1 0 0 r
F
P
p
.002 w
.92785 .51325 m .91611 .51482 L .9115 .51117 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89976 .51275 m .9115 .51117 L .91611 .51482 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.2368 .31058 m .25581 .31345 L .24605 .31561 L .395 1 0 r
F
P
p
.22707 .31276 m .2368 .31058 L .24605 .31561 L .326 1 0 r
F
P
p
.33311 .31049 m .35173 .31336 L .34169 .31552 L .36 1 0 r
F
P
p
.32308 .31267 m .33311 .31049 L .34169 .31552 L .276 1 0 r
F
P
p
.42943 .3104 m .44768 .31327 L .43736 .31543 L 0 1 .128 r
F
P
p
.41912 .31258 m .42943 .3104 L .43736 .31543 L 0 1 .198 r
F
P
p
.002 w
.43802 .7456 m .42764 .75284 L .41975 .74443 L p
0 .487 1 r
F P
0 0 0 r
s
P
p
.002 w
.40947 .74532 m .41975 .74443 L .42764 .75284 L p
0 .417 1 r
F P
0 0 0 r
s
P
p
.52578 .31031 m .54366 .31318 L .53305 .31534 L .012 1 0 r
F
P
p
.51518 .31249 m .52578 .31031 L .53305 .31534 L 0 1 .027 r
F
P
p
.002 w
.40947 .74532 m .39926 .74619 L .39107 .74415 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.38087 .74503 m .39107 .74415 L .39926 .74619 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.62216 .31022 m .63966 .31309 L .62876 .31525 L .55 1 0 r
F
P
p
.61127 .3124 m .62216 .31022 L .62876 .31525 L .395 1 0 r
F
P
p
.71856 .31013 m .73568 .313 L .72449 .31516 L 1 .872 0 r
F
P
p
.70738 .31231 m .71856 .31013 L .72449 .31516 L 1 .977 0 r
F
P
p
.002 w
.65421 .60711 m .66519 .60582 L .6721 .64249 L p
.331 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66519 .60582 m .65421 .60711 L .64779 .6041 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63682 .6054 m .64779 .6041 L p
.64843 .60654 L .605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64779 .6041 m .63682 .6054 L .63048 .6201 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64779 .6041 m .6414 .60993 L p
.64714 .60163 L .605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65852 .58517 m .64779 .6041 L p
.64714 .60163 L .605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64779 .6041 m .65421 .60711 L p
.64843 .60654 L .605 1 0 r
F P
0 0 0 r
s
P
p
.81498 .31004 m .83173 .31291 L .82025 .31508 L 1 0 0 r
F
P
p
.80351 .31222 m .81498 .31004 L .82025 .31508 L 1 0 0 r
F
P
p
.002 w
.37073 .74591 m .36024 .76463 L .35177 .76271 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.34169 .76354 m .35177 .76271 L .36024 .76463 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.89976 .51275 m .88808 .51432 L .88328 .51067 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87161 .51225 m .88328 .51067 L .88808 .51432 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.30432 .3098 m .32308 .31267 L .31312 .31483 L .659 1 0 r
F
P
p
.29438 .31198 m .30432 .3098 L .31312 .31483 L .527 1 0 r
F
P
p
.40074 .30971 m .41912 .31258 L .40887 .31474 L 0 1 .038 r
F
P
p
.3905 .31189 m .40074 .30971 L .40887 .31474 L 0 1 .122 r
F
P
p
.002 w
.68297 .63317 m .6721 .64249 L .66519 .60582 L p
.369 1 0 r
F P
0 0 0 r
s
P
p
.49718 .30961 m .51518 .31249 L .50465 .31465 L .005 1 0 r
F
P
p
.48665 .3118 m .49718 .30961 L .50465 .31465 L 0 1 .05 r
F
P
p
.002 w
.38087 .74503 m .37073 .74591 L .36233 .74387 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.35177 .76271 m .36233 .74387 L .37073 .74591 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.59364 .30952 m .61127 .3124 L .60045 .31456 L .808 1 0 r
F
P
p
.58283 .31171 m .59364 .30952 L .60045 .31456 L .738 1 0 r
F
P
p
.002 w
.50529 .79026 m .49473 .79101 L .48772 .6995 L p
0 .547 1 r
F P
0 0 0 r
s
P
p
.002 w
.48772 .6995 m .49825 .6896 L .50529 .79026 L p
0 .547 1 r
F P
0 0 0 r
s
P
p
.002 w
.49825 .6896 m .48772 .6995 L .48011 .69988 L p
0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.46934 .73394 m .48011 .69988 L .48772 .6995 L p
0 1 .952 r
F P
0 0 0 r
s
P
p
.002 w
.48411 .80979 m .47364 .81048 L .46652 .74588 L p
0 .187 1 r
F P
0 0 0 r
s
P
p
.002 w
.44838 .74472 m .45879 .74383 L .46652 .74588 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.69013 .30943 m .70738 .31231 L .69627 .31448 L 1 .932 0 r
F
P
p
.67903 .31162 m .69013 .30943 L .69627 .31448 L .932 1 0 r
F
P
p
.78664 .30934 m .80351 .31222 L .79212 .31439 L 1 0 0 r
F
P
p
.77525 .31153 m .78664 .30934 L .79212 .31439 L 1 .035 0 r
F
P
p
.002 w
.7542 .55883 m .74295 .56026 L .73836 .601 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74295 .56026 m .73247 .58782 L .72705 .60232 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72705 .60232 m .73836 .601 L .74295 .56026 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34169 .76354 m .33166 .76436 L .32299 .76245 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.33166 .76436 m .32042 .81007 L .31298 .76328 L p
0 .058 1 r
F P
0 0 0 r
s
P
p
.002 w
.31298 .76328 m .32299 .76245 L .33166 .76436 L p
0 .058 1 r
F P
0 0 0 r
s
P
p
.002 w
.87161 .51225 m .86001 .51382 L .85578 .52761 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.85578 .52761 m .86001 .51382 L p
.84794 .54003 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.85578 .52761 m .84993 .50645 L p
.86365 .51514 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.86707 .51731 m .87161 .51225 L p
.86032 .5232 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.85578 .52761 m .86707 .51731 L p
.86032 .5232 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.88328 .51067 m .87161 .51225 L .86707 .51731 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.86707 .51731 m .86167 .50483 L p
.87388 .51137 L 1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.86707 .51731 m .87875 .51397 L .88328 .51067 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.87875 .51397 m .86707 .51731 L p
.87388 .51137 L 1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.86707 .51731 m .85578 .52761 L p
.86365 .51514 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.8449 .54664 m .85578 .52761 L p
.84794 .54003 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.32042 .81007 m .31045 .81076 L .30303 .7641 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29169 .80985 m .30303 .7641 L .31045 .81076 L p
.291 0 1 r
F P
0 0 0 r
s
P
p
.88318 .30925 m .89967 .31213 L .88799 .3143 L 1 0 0 r
F
P
p
.8715 .31144 m .88318 .30925 L .88799 .3143 L 1 0 0 r
F
P
p
.002 w
.77633 .53842 m .78775 .53692 L .79262 .52303 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.27549 .3091 m .29438 .31198 L .28449 .31414 L .617 1 0 r
F
P
p
.26562 .31128 m .27549 .3091 L .28449 .31414 L .52 1 0 r
F
P
p
.002 w
.51271 .79199 m .50212 .8107 L .49473 .79101 L p
.256 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48411 .80979 m .49473 .79101 L .50212 .8107 L p
.395 0 1 r
F P
0 0 0 r
s
P
p
.37199 .30901 m .3905 .31189 L .38033 .31405 L .108 1 0 r
F
P
p
.36183 .31119 m .37199 .30901 L .38033 .31405 L .088 1 0 r
F
P
p
.46852 .30891 m .48665 .3118 L .47619 .31396 L 0 1 .056 r
F
P
p
.45807 .3111 m .46852 .30891 L .47619 .31396 L 0 1 .087 r
F
P
p
.002 w
.7158 .60363 m .72705 .60232 L .73247 .58782 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.56507 .30882 m .58283 .31171 L .57208 .31387 L .57 1 0 r
F
P
p
.55433 .31101 m .56507 .30882 L .57208 .31387 L .5 1 0 r
F
P
p
.002 w
.44838 .74472 m .43802 .7456 L .43009 .74355 L p
0 .645 1 r
F P
0 0 0 r
s
P
p
.002 w
.41975 .74443 m .43009 .74355 L .43802 .7456 L p
0 .487 1 r
F P
0 0 0 r
s
P
p
.66165 .30873 m .67903 .31162 L .66799 .31378 L 1 .928 0 r
F
P
p
.65062 .31092 m .66165 .30873 L .66799 .31378 L .988 1 0 r
F
P
p
.002 w
.53393 .74556 m .52329 .79125 L .51592 .78951 L p
.012 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51592 .78951 m .52661 .78875 L .53393 .74556 L p
.012 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49473 .79101 m .50529 .79026 L .51271 .79199 L p
.256 0 1 r
F P
0 0 0 r
s
P
p
.75825 .30864 m .77525 .31153 L .76392 .3137 L 1 .174 0 r
F
P
p
.74693 .31083 m .75825 .30864 L .76392 .3137 L 1 .209 0 r
F
P
p
.002 w
.30303 .7641 m .31298 .76328 L .32042 .81007 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31298 .76328 m .30303 .7641 L .29415 .76218 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.30303 .7641 m .29169 .80985 L .28271 .80824 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28271 .80824 m .29415 .76218 L .30303 .7641 L p
.116 0 1 r
F P
0 0 0 r
s
P
p
.85487 .30855 m .8715 .31144 L .85988 .31361 L 1 0 0 r
F
P
p
.84327 .31074 m .85487 .30855 L .85988 .31361 L 1 0 0 r
F
P
p
.002 w
.9115 .51117 m .92332 .50958 L .92785 .51325 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.2466 .3084 m .26562 .31128 L .25581 .31345 L .465 1 0 r
F
P
p
.2368 .31058 m .2466 .3084 L .25581 .31345 L .395 1 0 r
F
P
p
.34319 .3083 m .36183 .31119 L .35173 .31336 L .416 1 0 r
F
P
p
.33311 .31049 m .34319 .3083 L .35173 .31336 L .36 1 0 r
F
P
p
.002 w
.69406 .63195 m .68297 .63317 L .67623 .60452 L p
.401 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66519 .60582 m .67623 .60452 L .68297 .63317 L p
.369 1 0 r
F P
0 0 0 r
s
P
p
.43981 .30821 m .45807 .3111 L .44768 .31327 L 0 1 .093 r
F
P
p
.42943 .3104 m .43981 .30821 L .44768 .31327 L 0 1 .128 r
F
P
p
.002 w
.51592 .78951 m .50529 .79026 L .49825 .6896 L p
0 .583 1 r
F P
0 0 0 r
s
P
p
.002 w
.49825 .6896 m .50879 .68808 L p
.50163 .70874 L 0 .583 1 r
F P
0 0 0 r
s
P
p
.002 w
.50879 .68808 m .49825 .6896 L .49067 .6961 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.002 w
.49067 .6961 m .50127 .69506 L .50879 .68808 L p
0 1 .719 r
F P
0 0 0 r
s
P
p
.002 w
.50879 .68808 m .50127 .69506 L p
.51596 .66738 L 0 1 .614 r
F P
0 0 0 r
s
P
p
.002 w
.51944 .66082 m .50879 .68808 L p
.51596 .66738 L 0 1 .614 r
F P
0 0 0 r
s
P
p
.002 w
.50879 .68808 m .51592 .78951 L p
.50163 .70874 L 0 .583 1 r
F P
0 0 0 r
s
P
p
.002 w
.49067 .6961 m .49825 .6896 L p
.4844 .69745 L 0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.49067 .6961 m .48303 .69368 L p
.49699 .69474 L 0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.50127 .69506 m .49067 .6961 L p
.49699 .69474 L 0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.48011 .69988 m .49067 .6961 L p
.4844 .69745 L 0 1 .767 r
F P
0 0 0 r
s
P
p
.53645 .30812 m .55433 .31101 L .54366 .31318 L .137 1 0 r
F
P
p
.52578 .31031 m .53645 .30812 L .54366 .31318 L .012 1 0 r
F
P
p
.002 w
.41975 .74443 m .40947 .74532 L .40133 .74326 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.39107 .74415 m .40133 .74326 L .40947 .74532 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.63311 .30803 m .65062 .31092 L .63966 .31309 L .739 1 0 r
F
P
p
.62216 .31022 m .63311 .30803 L .63966 .31309 L .55 1 0 r
F
P
p
.7298 .30794 m .74693 .31083 L .73568 .313 L 1 .767 0 r
F
P
p
.71856 .31013 m .7298 .30794 L .73568 .313 L 1 .872 0 r
F
P
p
.002 w
.67623 .60452 m .66519 .60582 L .65852 .58517 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64779 .6041 m .65852 .58517 L .66519 .60582 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8037 .51281 m .81515 .51124 L .82213 .55831 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.81515 .51124 m .8037 .51281 L .79829 .50914 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78775 .53692 m .79829 .50914 L .8037 .51281 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.82652 .30785 m .84327 .31074 L .83173 .31291 L 1 0 0 r
F
P
p
.81498 .31004 m .82652 .30785 L .83173 .31291 L 1 0 0 r
F
P
p
.002 w
.9115 .51117 m .89976 .51275 L .89502 .50908 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88328 .51067 m .89502 .50908 L .89976 .51275 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.21765 .30769 m .2368 .31058 L .22707 .31276 L .326 1 0 r
F
P
p
.31433 .3076 m .33311 .31049 L .32308 .31267 L .834 1 0 r
F
P
p
.30432 .3098 m .31433 .3076 L .32308 .31267 L .659 1 0 r
F
P
p
.41104 .30751 m .42943 .3104 L .41912 .31258 L .081 1 0 r
F
P
p
.40074 .30971 m .41104 .30751 L .41912 .31258 L 0 1 .038 r
F
P
p
.50777 .30742 m .52578 .31031 L .51518 .31249 L .034 1 0 r
F
P
p
.49718 .30961 m .50777 .30742 L .51518 .31249 L .005 1 0 r
F
P
p
.002 w
.39107 .74415 m .38087 .74503 L .37252 .74298 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.36233 .74387 m .37252 .74298 L .38087 .74503 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.60452 .30733 m .62216 .31022 L .61127 .3124 L .849 1 0 r
F
P
p
.59364 .30952 m .60452 .30733 L .61127 .3124 L .808 1 0 r
F
P
p
.7013 .30724 m .71856 .31013 L .70738 .31231 L 1 .793 0 r
F
P
p
.69013 .30943 m .7013 .30724 L .70738 .31231 L 1 .932 0 r
F
P
p
.7981 .30715 m .81498 .31004 L .80351 .31222 L 1 0 0 r
F
P
p
.78664 .30934 m .7981 .30715 L .80351 .31222 L 1 0 0 r
F
P
p
.002 w
.76552 .55739 m .7542 .55883 L .74975 .59967 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73836 .601 m .74975 .59967 L .7542 .55883 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35177 .76271 m .34169 .76354 L .33306 .76161 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.32299 .76245 m .33306 .76161 L .34169 .76354 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.88318 .30925 m .89493 .30706 L .89967 .31213 L 1 0 0 r
F
P
p
.28542 .3069 m .30432 .3098 L .29438 .31198 L .686 1 0 r
F
P
p
.27549 .3091 m .28542 .3069 L .29438 .31198 L .617 1 0 r
F
P
p
.38221 .30681 m .40074 .30971 L .3905 .31189 L .178 1 0 r
F
P
p
.37199 .30901 m .38221 .30681 L .3905 .31189 L .108 1 0 r
F
P
p
.47903 .30672 m .49718 .30961 L .48665 .3118 L 0 1 .021 r
F
P
p
.46852 .30891 m .47903 .30672 L .48665 .3118 L 0 1 .056 r
F
P
p
.57588 .30662 m .59364 .30952 L .58283 .31171 L .633 1 0 r
F
P
p
.56507 .30882 m .57588 .30662 L .58283 .31171 L .57 1 0 r
F
P
p
.002 w
.45879 .74383 m .44838 .74472 L .44092 .70833 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.43009 .74355 m .44092 .70833 L .44838 .74472 L p
0 .645 1 r
F P
0 0 0 r
s
P
p
.67275 .30653 m .69013 .30943 L .67903 .31162 L 1 .824 0 r
F
P
p
.66165 .30873 m .67275 .30653 L .67903 .31162 L 1 .928 0 r
F
P
p
.002 w
.50529 .79026 m .51592 .78951 L .52329 .79125 L p
.186 0 1 r
F P
0 0 0 r
s
P
p
.76964 .30644 m .78664 .30934 L .77525 .31153 L 1 .105 0 r
F
P
p
.75825 .30864 m .76964 .30644 L .77525 .31153 L 1 .174 0 r
F
P
p
.002 w
.7158 .60363 m .70462 .60494 L .69812 .58424 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70462 .60494 m .69406 .63195 L .68734 .60321 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68734 .60321 m .69812 .58424 L .70462 .60494 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53736 .78799 m .52661 .78875 L .51944 .66082 L p
0 .826 1 r
F P
0 0 0 r
s
P
p
.002 w
.51944 .66082 m .53008 .65081 L .53736 .78799 L p
0 .826 1 r
F P
0 0 0 r
s
P
p
.002 w
.50879 .68808 m .51944 .66082 L .52661 .78875 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.53008 .65081 m .51944 .66082 L .51194 .69402 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.52661 .78875 m .51592 .78951 L .50879 .68808 L p
0 .688 1 r
F P
0 0 0 r
s
P
p
.002 w
.50127 .69506 m .51194 .69402 L .51944 .66082 L p
0 1 .614 r
F P
0 0 0 r
s
P
p
.002 w
.32299 .76245 m .31298 .76328 L .30414 .76134 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.29415 .76218 m .30414 .76134 L .31298 .76328 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.86655 .30635 m .88318 .30925 L .8715 .31144 L 1 0 0 r
F
P
p
.85487 .30855 m .86655 .30635 L .8715 .31144 L 1 0 0 r
F
P
p
.002 w
.83367 .55687 m .82213 .55831 L .81515 .51124 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.25645 .30619 m .27549 .3091 L .26562 .31128 L .5 1 0 r
F
P
p
.2466 .3084 m .25645 .30619 L .26562 .31128 L .465 1 0 r
F
P
p
.35334 .3061 m .37199 .30901 L .36183 .31119 L .471 1 0 r
F
P
p
.34319 .3083 m .35334 .3061 L .36183 .31119 L .416 1 0 r
F
P
p
.002 w
.67623 .60452 m .68734 .60321 L .69406 .63195 L p
.401 1 0 r
F P
0 0 0 r
s
P
p
.45024 .30601 m .46852 .30891 L .45807 .3111 L 0 1 .052 r
F
P
p
.43981 .30821 m .45024 .30601 L .45807 .3111 L 0 1 .093 r
F
P
p
.54718 .30592 m .56507 .30882 L .55433 .31101 L .262 1 0 r
F
P
p
.53645 .30812 m .54718 .30592 L .55433 .31101 L .137 1 0 r
F
P
p
.002 w
.43009 .74355 m .41975 .74443 L .41165 .74237 L p
0 .596 1 r
F P
0 0 0 r
s
P
p
.002 w
.40133 .74326 m .41165 .74237 L .41975 .74443 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.64413 .30583 m .66165 .30873 L .65062 .31092 L .829 1 0 r
F
P
p
.63311 .30803 m .64413 .30583 L .65062 .31092 L .739 1 0 r
F
P
p
.74112 .30574 m .75825 .30864 L .74693 .31083 L 1 .628 0 r
F
P
p
.7298 .30794 m .74112 .30574 L .74693 .31083 L 1 .767 0 r
F
P
p
.002 w
.68734 .60321 m .67623 .60452 L .66959 .5838 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66959 .5838 m .67623 .60452 L p
.66359 .5907 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66959 .5838 m .68038 .56479 L .68734 .60321 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66959 .5838 m .66368 .60732 L p
.67564 .57685 L .829 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68038 .56479 m .66959 .5838 L p
.67564 .57685 L .829 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65852 .58517 m .66959 .5838 L p
.66359 .5907 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81515 .51124 m .82668 .50965 L .83367 .55687 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.82668 .50965 m .81515 .51124 L .80981 .50754 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79829 .50914 m .80981 .50754 L .81515 .51124 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.83812 .30564 m .85487 .30855 L .84327 .31074 L 1 0 0 r
F
P
p
.82652 .30785 m .83812 .30564 L .84327 .31074 L 1 0 0 r
F
P
p
.002 w
.92332 .50958 m .9115 .51117 L .90684 .50748 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89502 .50908 m .90684 .50748 L .9115 .51117 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.22743 .30549 m .2466 .3084 L .2368 .31058 L .36 1 0 r
F
P
p
.21765 .30769 m .22743 .30549 L .2368 .31058 L .326 1 0 r
F
P
p
.3244 .3054 m .34319 .3083 L .33311 .31049 L .884 1 0 r
F
P
p
.31433 .3076 m .3244 .3054 L .33311 .31049 L .834 1 0 r
F
P
p
.4214 .3053 m .43981 .30821 L .42943 .3104 L .176 1 0 r
F
P
p
.41104 .30751 m .4214 .3053 L .42943 .3104 L .081 1 0 r
F
P
p
.51842 .30521 m .53645 .30812 L .52578 .31031 L .042 1 0 r
F
P
p
.50777 .30742 m .51842 .30521 L .52578 .31031 L .034 1 0 r
F
P
p
.002 w
.40133 .74326 m .39107 .74415 L .38276 .74208 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.37252 .74298 m .38276 .74208 L .39107 .74415 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.61547 .30512 m .63311 .30803 L .62216 .31022 L .898 1 0 r
F
P
p
.60452 .30733 m .61547 .30512 L .62216 .31022 L .849 1 0 r
F
P
p
.002 w
.54076 .64964 m .53008 .65081 L .52267 .69297 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.002 w
.51194 .69402 m .52267 .69297 L .53008 .65081 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.71254 .30503 m .7298 .30794 L .71856 .31013 L 1 .663 0 r
F
P
p
.7013 .30724 m .71254 .30503 L .71856 .31013 L 1 .793 0 r
F
P
p
.002 w
.63048 .6201 m .6414 .60993 L .64779 .6041 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.80963 .30494 m .82652 .30785 L .81498 .31004 L 1 0 0 r
F
P
p
.7981 .30715 m .80963 .30494 L .81498 .31004 L 1 0 0 r
F
P
p
.002 w
.77633 .53842 m .76552 .55739 L .7612 .59833 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.74975 .59967 m .7612 .59833 L .76552 .55739 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36233 .74387 m .35177 .76271 L .34319 .76077 L p
0 .302 1 r
F P
0 0 0 r
s
P
p
.002 w
.33306 .76161 m .34319 .76077 L .35177 .76271 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.89502 .50908 m .88328 .51067 L .87875 .51397 L p
1 .028 0 r
F P
0 0 0 r
s
P
p
.002 w
.44092 .70833 m .45145 .6968 L .45879 .74383 L p
0 .819 1 r
F P
0 0 0 r
s
P
p
.002 w
.45145 .6968 m .44092 .70833 L .43296 .706 L p
0 1 .873 r
F P
0 0 0 r
s
P
p
.002 w
.44092 .70833 m .43009 .74355 L .42237 .7197 L p
0 .863 1 r
F P
0 0 0 r
s
P
p
.002 w
.42237 .7197 m .43296 .706 L .44092 .70833 L p
0 .863 1 r
F P
0 0 0 r
s
P
p
.29541 .30469 m .31433 .3076 L .30432 .3098 L .779 1 0 r
F
P
p
.28542 .3069 m .29541 .30469 L .30432 .3098 L .686 1 0 r
F
P
p
.3925 .3046 m .41104 .30751 L .40074 .30971 L .276 1 0 r
F
P
p
.38221 .30681 m .3925 .3046 L .40074 .30971 L .178 1 0 r
F
P
p
.002 w
.66959 .5838 m .65852 .58517 L .65251 .60863 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6414 .60993 m .65251 .60863 L .65852 .58517 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.48961 .3045 m .50777 .30742 L .49718 .30961 L .028 1 0 r
F
P
p
.47903 .30672 m .48961 .3045 L .49718 .30961 L 0 1 .021 r
F
P
p
.002 w
.78775 .53692 m .77633 .53842 L .77273 .59699 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.7612 .59833 m .77273 .59699 L .77633 .53842 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.37252 .74298 m .36233 .74387 L .35338 .75992 L p
0 .442 1 r
F P
0 0 0 r
s
P
p
.002 w
.34319 .76077 m .35338 .75992 L .36233 .74387 L p
0 .302 1 r
F P
0 0 0 r
s
P
p
.58675 .30441 m .60452 .30733 L .59364 .30952 L .668 1 0 r
F
P
p
.57588 .30662 m .58675 .30441 L .59364 .30952 L .633 1 0 r
F
P
p
.002 w
.46934 .73394 m .45879 .74383 L .45145 .6968 L p
0 .895 1 r
F P
0 0 0 r
s
P
p
.68391 .30432 m .7013 .30724 L .69013 .30943 L 1 .736 0 r
F
P
p
.67275 .30653 m .68391 .30432 L .69013 .30943 L 1 .824 0 r
F
P
p
.78109 .30423 m .7981 .30715 L .78664 .30934 L 1 .035 0 r
F
P
p
.76964 .30644 m .78109 .30423 L .78664 .30934 L 1 .105 0 r
F
P
p
.002 w
.72705 .60232 m .7158 .60363 L .70891 .56524 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69812 .58424 m .70891 .56524 L .7158 .60363 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33306 .76161 m .32299 .76245 L .3142 .7605 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.30414 .76134 m .3142 .7605 L .32299 .76245 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.8783 .30414 m .89493 .30706 L .88318 .30925 L 1 0 0 r
F
P
p
.86655 .30635 m .8783 .30414 L .88318 .30925 L 1 0 0 r
F
P
p
.002 w
.8449 .54664 m .83367 .55687 L .82668 .50965 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.49067 .6961 m .48011 .69988 L .47244 .69473 L p
0 1 .801 r
F P
0 0 0 r
s
P
p
.002 w
.48011 .69988 m .46934 .73394 L .46191 .69577 L p
0 1 .941 r
F P
0 0 0 r
s
P
p
.002 w
.46191 .69577 m .47244 .69473 L .48011 .69988 L p
0 1 .941 r
F P
0 0 0 r
s
P
p
.26636 .30398 m .28542 .3069 L .27549 .3091 L .57 1 0 r
F
P
p
.25645 .30619 m .26636 .30398 L .27549 .3091 L .5 1 0 r
F
P
p
.36354 .30389 m .38221 .30681 L .37199 .30901 L .541 1 0 r
F
P
p
.35334 .3061 m .36354 .30389 L .37199 .30901 L .471 1 0 r
F
P
p
.46074 .3038 m .47903 .30672 L .46852 .30891 L .014 1 0 r
F
P
p
.45024 .30601 m .46074 .3038 L .46852 .30891 L 0 1 .052 r
F
P
p
.55797 .3037 m .57588 .30662 L .56507 .30882 L .346 1 0 r
F
P
p
.54718 .30592 m .55797 .3037 L .56507 .30882 L .262 1 0 r
F
P
p
.002 w
.45145 .6968 m .46191 .69577 L .46934 .73394 L p
0 .895 1 r
F P
0 0 0 r
s
P
p
.002 w
.46191 .69577 m .45145 .6968 L .44355 .69439 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.43296 .706 m .44355 .69439 L .45145 .6968 L p
0 1 .873 r
F P
0 0 0 r
s
P
p
.002 w
.41165 .74237 m .42237 .7197 L .43009 .74355 L p
0 .596 1 r
F P
0 0 0 r
s
P
p
.65522 .30361 m .67275 .30653 L .66165 .30873 L .953 1 0 r
F
P
p
.64413 .30583 m .65522 .30361 L .66165 .30873 L .829 1 0 r
F
P
p
.7525 .30352 m .76964 .30644 L .75825 .30864 L 1 .523 0 r
F
P
p
.74112 .30574 m .7525 .30352 L .75825 .30864 L 1 .628 0 r
F
P
p
.002 w
.69812 .58424 m .68734 .60321 L .68038 .56479 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30414 .76134 m .29415 .76218 L .28515 .76023 L p
0 .302 1 r
F P
0 0 0 r
s
P
p
.002 w
.29415 .76218 m .28271 .80824 L .27517 .76107 L p
0 .058 1 r
F P
0 0 0 r
s
P
p
.002 w
.27517 .76107 m .28515 .76023 L .29415 .76218 L p
0 .058 1 r
F P
0 0 0 r
s
P
p
.002 w
.82668 .50965 m .83827 .50805 L .8449 .54664 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.83827 .50805 m .82668 .50965 L .8214 .50593 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80981 .50754 m .8214 .50593 L .82668 .50965 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8498 .30343 m .86655 .30635 L .85487 .30855 L 1 0 0 r
F
P
p
.83812 .30564 m .8498 .30343 L .85487 .30855 L 1 0 0 r
F
P
p
.002 w
.90684 .50748 m .91872 .50587 L .92332 .50958 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.23726 .30327 m .25645 .30619 L .2466 .3084 L .43 1 0 r
F
P
p
.22743 .30549 m .23726 .30327 L .2466 .3084 L .36 1 0 r
F
P
p
.33453 .30318 m .35334 .3061 L .34319 .3083 L .884 1 0 r
F
P
p
.3244 .3054 m .33453 .30318 L .34319 .3083 L .884 1 0 r
F
P
p
.43182 .30308 m .45024 .30601 L .43981 .30821 L .246 1 0 r
F
P
p
.4214 .3053 m .43182 .30308 L .43981 .30821 L .176 1 0 r
F
P
p
.002 w
.70891 .56524 m .69812 .58424 L .69137 .55454 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.68038 .56479 m .69137 .55454 L .69812 .58424 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.52914 .30299 m .54718 .30592 L .53645 .30812 L .067 1 0 r
F
P
p
.51842 .30521 m .52914 .30299 L .53645 .30812 L .042 1 0 r
F
P
p
.002 w
.41165 .74237 m .40133 .74326 L .39307 .74118 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.38276 .74208 m .39307 .74118 L .40133 .74326 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.62648 .3029 m .64413 .30583 L .63311 .30803 L .928 1 0 r
F
P
p
.61547 .30512 m .62648 .3029 L .63311 .30803 L .898 1 0 r
F
P
p
.002 w
.52267 .69297 m .53347 .69191 L .54076 .64964 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.72384 .30281 m .74112 .30574 L .7298 .30794 L 1 .607 0 r
F
P
p
.71254 .30503 m .72384 .30281 L .7298 .30794 L 1 .663 0 r
F
P
p
.002 w
.85578 .52761 m .8449 .54664 L .83827 .50805 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.80981 .50754 m .79829 .50914 L .79439 .54957 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.7828 .55106 m .78775 .53692 L p
.78029 .56677 L 1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.77273 .59699 m .7828 .55106 L p
.78029 .56677 L 1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.7828 .55106 m .77627 .52094 L p
.78533 .53526 L 1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.79829 .50914 m .78775 .53692 L .7828 .55106 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.7828 .55106 m .79439 .54957 L .79829 .50914 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.79439 .54957 m .7828 .55106 L p
.78533 .53526 L 1 .453 0 r
F P
0 0 0 r
s
P
p
.82123 .30272 m .83812 .30564 L .82652 .30785 L 1 0 0 r
F
P
p
.80963 .30494 m .82123 .30272 L .82652 .30785 L 1 0 0 r
F
P
p
.002 w
.90684 .50748 m .89502 .50908 L .89022 .50535 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87875 .51397 m .89022 .50535 L .89502 .50908 L p
1 .028 0 r
F P
0 0 0 r
s
P
p
.002 w
.70891 .56524 m .71994 .55501 L .72705 .60232 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71994 .55501 m .70891 .56524 L .7026 .55307 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.69137 .55454 m .7026 .55307 L .70891 .56524 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.2081 .30256 m .22743 .30549 L .21765 .30769 L .36 1 0 r
F
P
p
.30546 .30246 m .3244 .3054 L .31433 .3076 L .899 1 0 r
F
P
p
.29541 .30469 m .30546 .30246 L .31433 .3076 L .779 1 0 r
F
P
p
.40284 .30237 m .4214 .3053 L .41104 .30751 L .45 1 0 r
F
P
p
.3925 .3046 m .40284 .30237 L .41104 .30751 L .276 1 0 r
F
P
p
.002 w
.83827 .50805 m .84993 .50645 L .85578 .52761 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.65251 .60863 m .66368 .60732 L .66959 .5838 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.50025 .30228 m .51842 .30521 L .50777 .30742 L .073 1 0 r
F
P
p
.48961 .3045 m .50025 .30228 L .50777 .30742 L .028 1 0 r
F
P
p
.002 w
.38276 .74208 m .37252 .74298 L .36405 .74089 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.35338 .75992 m .36405 .74089 L .37252 .74298 L p
0 .442 1 r
F P
0 0 0 r
s
P
p
.59768 .30219 m .61547 .30512 L .60452 .30733 L .709 1 0 r
F
P
p
.58675 .30441 m .59768 .30219 L .60452 .30733 L .668 1 0 r
F
P
p
.002 w
.47244 .69473 m .48303 .69368 L .49067 .6961 L p
0 1 .801 r
F P
0 0 0 r
s
P
p
.69514 .30209 m .71254 .30503 L .7013 .30724 L 1 .667 0 r
F
P
p
.68391 .30432 m .69514 .30209 L .7013 .30724 L 1 .736 0 r
F
P
p
.79262 .302 m .80963 .30494 L .7981 .30715 L 1 0 0 r
F
P
p
.78109 .30423 m .79262 .302 L .7981 .30715 L 1 .035 0 r
F
P
p
.002 w
.73836 .601 m .72705 .60232 L .71994 .55501 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34319 .76077 m .33306 .76161 L .32431 .75965 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.3142 .7605 m .32431 .75965 L .33306 .76161 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.69137 .55454 m .68038 .56479 L .6745 .58429 L p
1 .962 0 r
F P
0 0 0 r
s
P
p
.002 w
.66368 .60732 m .6745 .58429 L .68038 .56479 L p
.829 1 0 r
F P
0 0 0 r
s
P
p
.8783 .30414 m .89012 .30191 L .89493 .30706 L 1 0 0 r
F
P
p
.27634 .30175 m .29541 .30469 L .28542 .3069 L .625 1 0 r
F
P
p
.26636 .30398 m .27634 .30175 L .28542 .3069 L .57 1 0 r
F
P
p
.37381 .30166 m .3925 .3046 L .38221 .30681 L .634 1 0 r
F
P
p
.36354 .30389 m .37381 .30166 L .38221 .30681 L .541 1 0 r
F
P
p
.47131 .30157 m .48961 .3045 L .47903 .30672 L .042 1 0 r
F
P
p
.46074 .3038 m .47131 .30157 L .47903 .30672 L .014 1 0 r
F
P
p
.56883 .30147 m .58675 .30441 L .57588 .30662 L .465 1 0 r
F
P
p
.55797 .3037 m .56883 .30147 L .57588 .30662 L .346 1 0 r
F
P
p
.002 w
.47244 .69473 m .46191 .69577 L .45406 .69335 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.44355 .69439 m .45406 .69335 L .46191 .69577 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.66637 .30138 m .68391 .30432 L .67275 .30653 L 1 .977 0 r
F
P
p
.65522 .30361 m .66637 .30138 L .67275 .30653 L .953 1 0 r
F
P
p
.76395 .30129 m .78109 .30423 L .76964 .30644 L 1 .453 0 r
F
P
p
.7525 .30352 m .76395 .30129 L .76964 .30644 L 1 .523 0 r
F
P
p
.002 w
.71994 .55501 m .73124 .55354 L .73836 .601 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73124 .55354 m .71994 .55501 L .7139 .5516 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.7026 .55307 m .7139 .5516 L .71994 .55501 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.3142 .7605 m .30414 .76134 L .29576 .74121 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.28515 .76023 m .29576 .74121 L .30414 .76134 L p
0 .302 1 r
F P
0 0 0 r
s
P
p
.002 w
.84993 .50645 m .83827 .50805 L .83306 .50431 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8214 .50593 m .83306 .50431 L .83827 .50805 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.86154 .3012 m .8783 .30414 L .86655 .30635 L 1 0 0 r
F
P
p
.8498 .30343 m .86154 .3012 L .86655 .30635 L 1 0 0 r
F
P
p
.24715 .30104 m .26636 .30398 L .25645 .30619 L .5 1 0 r
F
P
p
.23726 .30327 m .24715 .30104 L .25645 .30619 L .43 1 0 r
F
P
p
.002 w
.84993 .50645 m .86167 .50483 L .86707 .51731 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.34472 .30094 m .36354 .30389 L .35334 .3061 L .953 1 0 r
F
P
p
.33453 .30318 m .34472 .30094 L .35334 .3061 L .884 1 0 r
F
P
p
.44231 .30085 m .46074 .3038 L .45024 .30601 L .326 1 0 r
F
P
p
.43182 .30308 m .44231 .30085 L .45024 .30601 L .246 1 0 r
F
P
p
.53992 .30076 m .55797 .3037 L .54718 .30592 L .102 1 0 r
F
P
p
.52914 .30299 m .53992 .30076 L .54718 .30592 L .067 1 0 r
F
P
p
.002 w
.42237 .7197 m .41165 .74237 L .40344 .74027 L p
0 .596 1 r
F P
0 0 0 r
s
P
p
.002 w
.39307 .74118 m .40344 .74027 L .41165 .74237 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.63756 .30066 m .65522 .30361 L .64413 .30583 L .983 1 0 r
F
P
p
.62648 .3029 m .63756 .30066 L .64413 .30583 L .928 1 0 r
F
P
p
.002 w
.43296 .706 m .42237 .7197 L .41388 .73936 L p
0 .729 1 r
F P
0 0 0 r
s
P
p
.002 w
.40344 .74027 m .41388 .73936 L .42237 .7197 L p
0 .596 1 r
F P
0 0 0 r
s
P
p
.73522 .30057 m .7525 .30352 L .74112 .30574 L 1 .503 0 r
F
P
p
.72384 .30281 m .73522 .30057 L .74112 .30574 L 1 .607 0 r
F
P
p
.002 w
.7026 .55307 m .69137 .55454 L .68567 .5778 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.6745 .58429 m .68567 .5778 L .69137 .55454 L p
1 .962 0 r
F P
0 0 0 r
s
P
p
.002 w
.28515 .76023 m .27517 .76107 L .266 .75911 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.80473 .51261 m .80981 .50754 L p
.80368 .52425 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.79439 .54957 m .80473 .51261 L p
.80368 .52425 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.80473 .51261 m .7989 .49999 L p
.80578 .50086 L 1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.8214 .50593 m .80981 .50754 L .80473 .51261 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.81605 .50216 m .80473 .51261 L p
.80578 .50086 L 1 .035 0 r
F P
0 0 0 r
s
P
p
.8329 .30048 m .8498 .30343 L .83812 .30564 L 1 0 0 r
F
P
p
.82123 .30272 m .8329 .30048 L .83812 .30564 L 1 0 0 r
F
P
p
.002 w
.91872 .50587 m .90684 .50748 L .9021 .50373 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89022 .50535 m .9021 .50373 L .90684 .50748 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.21792 .30032 m .23726 .30327 L .22743 .30549 L .395 1 0 r
F
P
p
.2081 .30256 m .21792 .30032 L .22743 .30549 L .36 1 0 r
F
P
p
.002 w
.65251 .60863 m .6414 .60993 L .63528 .64286 L p
.201 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63528 .64286 m .64644 .63776 L .65251 .60863 L p
.201 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6274 .55017 m .63854 .54868 L .64545 .62658 L p
.62 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64545 .62658 m .64644 .63776 L p
.64422 .62755 L .62 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6414 .60993 m .63048 .6201 L .62435 .64324 L p
.151 1 0 r
F P
0 0 0 r
s
P
p
.62468 .64298 m .6414 .60993 L .62435 .64324 L .151 1 0 r
F
P
p
.002 w
.62413 .64407 m .63528 .64286 L .6414 .60993 L p
.151 1 0 r
F P
0 0 0 r
s
P
p
.6274 .55017 m .64545 .62658 L .64422 .62755 L .62 1 0 r
F
P
p
.002 w
.62435 .64324 m .62413 .64407 L p
.62468 .64298 L .151 1 0 r
F P
0 0 0 r
s
P
p
.31557 .30023 m .33453 .30318 L .3244 .3054 L .988 1 0 r
F
P
p
.30546 .30246 m .31557 .30023 L .3244 .3054 L .899 1 0 r
F
P
p
.41325 .30013 m .43182 .30308 L .4214 .3053 L .6 1 0 r
F
P
p
.40284 .30237 m .41325 .30013 L .4214 .3053 L .45 1 0 r
F
P
p
.51095 .30004 m .52914 .30299 L .51842 .30521 L .083 1 0 r
F
P
p
.50025 .30228 m .51095 .30004 L .51842 .30521 L .073 1 0 r
F
P
p
.002 w
.39307 .74118 m .38276 .74208 L .37434 .73998 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.36405 .74089 m .37434 .73998 L .38276 .74208 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.60868 .29995 m .62648 .3029 L .61547 .30512 L .779 1 0 r
F
P
p
.59768 .30219 m .60868 .29995 L .61547 .30512 L .709 1 0 r
F
P
p
.002 w
.51194 .69402 m .50127 .69506 L .49368 .69263 L p
0 1 .737 r
F P
0 0 0 r
s
P
p
.002 w
.48303 .69368 m .49368 .69263 L .50127 .69506 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.70644 .29985 m .72384 .30281 L .71254 .30503 L 1 .626 0 r
F
P
p
.69514 .30209 m .70644 .29985 L .71254 .30503 L 1 .667 0 r
F
P
p
.80421 .29976 m .82123 .30272 L .80963 .30494 L 1 0 0 r
F
P
p
.79262 .302 m .80421 .29976 L .80963 .30494 L 1 0 0 r
F
P
p
.002 w
.74975 .59967 m .73836 .601 L .73124 .55354 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35338 .75992 m .34319 .76077 L .33449 .7588 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.32431 .75965 m .33449 .7588 L .34319 .76077 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.44355 .69439 m .43296 .706 L .42437 .73844 L p
0 .994 1 r
F P
0 0 0 r
s
P
p
.002 w
.41388 .73936 m .42437 .73844 L .43296 .706 L p
0 .729 1 r
F P
0 0 0 r
s
P
p
.28637 .29951 m .30546 .30246 L .29541 .30469 L .674 1 0 r
F
P
p
.27634 .30175 m .28637 .29951 L .29541 .30469 L .625 1 0 r
F
P
p
.38414 .29942 m .40284 .30237 L .3925 .3046 L .704 1 0 r
F
P
p
.37381 .30166 m .38414 .29942 L .3925 .3046 L .634 1 0 r
F
P
p
.48193 .29932 m .50025 .30228 L .48961 .3045 L .081 1 0 r
F
P
p
.47131 .30157 m .48193 .29932 L .48961 .3045 L .042 1 0 r
F
P
p
.57975 .29923 m .59768 .30219 L .58675 .30441 L .57 1 0 r
F
P
p
.56883 .30147 m .57975 .29923 L .58675 .30441 L .465 1 0 r
F
P
p
.002 w
.48303 .69368 m .47244 .69473 L .46464 .69229 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.45406 .69335 m .46464 .69229 L .47244 .69473 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.6776 .29914 m .69514 .30209 L .68391 .30432 L 1 .92 0 r
F
P
p
.66637 .30138 m .6776 .29914 L .68391 .30432 L 1 .977 0 r
F
P
p
.77547 .29904 m .79262 .302 L .78109 .30423 L 1 .314 0 r
F
P
p
.76395 .30129 m .77547 .29904 L .78109 .30423 L 1 .453 0 r
F
P
p
.002 w
.73124 .55354 m .74262 .55207 L .74975 .59967 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74262 .55207 m .73124 .55354 L .72526 .55011 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.7139 .5516 m .72526 .55011 L .73124 .55354 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32431 .75965 m .3142 .7605 L .30584 .74031 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.29576 .74121 m .30584 .74031 L .3142 .7605 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.86167 .50483 m .84993 .50645 L .84479 .50269 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83306 .50431 m .84479 .50269 L .84993 .50645 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89022 .50535 m .87875 .51397 L .87347 .50321 L p
1 .028 0 r
F P
0 0 0 r
s
P
p
.002 w
.86167 .50483 m .87347 .50321 L .87875 .51397 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.87336 .29895 m .89012 .30191 L .8783 .30414 L 1 0 0 r
F
P
p
.86154 .3012 m .87336 .29895 L .8783 .30414 L 1 0 0 r
F
P
p
.25711 .29879 m .27634 .30175 L .26636 .30398 L .535 1 0 r
F
P
p
.24715 .30104 m .25711 .29879 L .26636 .30398 L .5 1 0 r
F
P
p
.35497 .2987 m .37381 .30166 L .36354 .30389 L 1 .907 0 r
F
P
p
.34472 .30094 m .35497 .2987 L .36354 .30389 L .953 1 0 r
F
P
p
.45286 .2986 m .47131 .30157 L .46074 .3038 L .43 1 0 r
F
P
p
.44231 .30085 m .45286 .2986 L .46074 .3038 L .326 1 0 r
F
P
p
.55077 .29851 m .56883 .30147 L .55797 .3037 L .136 1 0 r
F
P
p
.53992 .30076 m .55077 .29851 L .55797 .3037 L .102 1 0 r
F
P
p
.002 w
.45406 .69335 m .44355 .69439 L .43554 .69195 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.42437 .73844 m .43554 .69195 L .44355 .69439 L p
0 .994 1 r
F P
0 0 0 r
s
P
p
.6487 .29842 m .66637 .30138 L .65522 .30361 L 1 .942 0 r
F
P
p
.63756 .30066 m .6487 .29842 L .65522 .30361 L .983 1 0 r
F
P
p
.74666 .29832 m .76395 .30129 L .7525 .30352 L 1 .41 0 r
F
P
p
.73522 .30057 m .74666 .29832 L .7525 .30352 L 1 .503 0 r
F
P
p
.002 w
.7139 .5516 m .7026 .55307 L .69701 .57639 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.68567 .5778 m .69701 .57639 L .7026 .55307 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.29576 .74121 m .28515 .76023 L .27602 .75825 L p
0 .337 1 r
F P
0 0 0 r
s
P
p
.002 w
.266 .75911 m .27602 .75825 L .28515 .76023 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.83306 .50431 m .8214 .50593 L .81605 .50216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80473 .51261 m .81605 .50216 L .8214 .50593 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.84465 .29823 m .86154 .3012 L .8498 .30343 L 1 0 0 r
F
P
p
.8329 .30048 m .84465 .29823 L .8498 .30343 L 1 0 0 r
F
P
p
.002 w
.9021 .50373 m .91405 .50209 L .91872 .50587 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.22779 .29807 m .24715 .30104 L .23726 .30327 L .43 1 0 r
F
P
p
.21792 .30032 m .22779 .29807 L .23726 .30327 L .395 1 0 r
F
P
p
.32574 .29798 m .34472 .30094 L .33453 .30318 L 1 .977 0 r
F
P
p
.31557 .30023 m .32574 .29798 L .33453 .30318 L .988 1 0 r
F
P
p
.42372 .29788 m .44231 .30085 L .43182 .30308 L .65 1 0 r
F
P
p
.41325 .30013 m .42372 .29788 L .43182 .30308 L .6 1 0 r
F
P
p
.002 w
.27602 .75825 m .2864 .74823 L .29576 .74121 L p
0 .337 1 r
F P
0 0 0 r
s
P
p
.002 w
.30584 .74031 m .29576 .74121 L .2864 .74823 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.52172 .29779 m .53992 .30076 L .52914 .30299 L .088 1 0 r
F
P
p
.51095 .30004 m .52172 .29779 L .52914 .30299 L .083 1 0 r
F
P
p
.002 w
.40344 .74027 m .39307 .74118 L .3847 .73906 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.37434 .73998 m .3847 .73906 L .39307 .74118 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.61975 .2977 m .63756 .30066 L .62648 .3029 L .847 1 0 r
F
P
p
.60868 .29995 m .61975 .2977 L .62648 .3029 L .779 1 0 r
F
P
p
.002 w
.52267 .69297 m .51194 .69402 L .50446 .67765 L p
0 1 .632 r
F P
0 0 0 r
s
P
p
.002 w
.49368 .69263 m .50446 .67765 L .51194 .69402 L p
0 1 .737 r
F P
0 0 0 r
s
P
p
.7178 .2976 m .73522 .30057 L .72384 .30281 L 1 .571 0 r
F
P
p
.70644 .29985 m .7178 .2976 L .72384 .30281 L 1 .626 0 r
F
P
p
.81588 .29751 m .8329 .30048 L .82123 .30272 L 1 0 0 r
F
P
p
.80421 .29976 m .81588 .29751 L .82123 .30272 L 1 0 0 r
F
P
p
.002 w
.7612 .59833 m .74975 .59967 L .74262 .55207 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36405 .74089 m .35338 .75992 L .34472 .75794 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.33449 .7588 m .34472 .75794 L .35338 .75992 L p
0 .233 1 r
F P
0 0 0 r
s
P
p
.002 w
.9021 .50373 m .89022 .50535 L .88535 .50157 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87347 .50321 m .88535 .50157 L .89022 .50535 L p
1 .028 0 r
F P
0 0 0 r
s
P
p
.19842 .29735 m .21792 .30032 L .2081 .30256 L .36 1 0 r
F
P
p
.29646 .29725 m .31557 .30023 L .30546 .30246 L .744 1 0 r
F
P
p
.28637 .29951 m .29646 .29725 L .30546 .30246 L .674 1 0 r
F
P
p
.39453 .29716 m .41325 .30013 L .40284 .30237 L .82 1 0 r
F
P
p
.38414 .29942 m .39453 .29716 L .40284 .30237 L .704 1 0 r
F
P
p
.49262 .29707 m .51095 .30004 L .50025 .30228 L .122 1 0 r
F
P
p
.48193 .29932 m .49262 .29707 L .50025 .30228 L .081 1 0 r
F
P
p
.002 w
.37434 .73998 m .36405 .74089 L .35546 .73877 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.34472 .75794 m .35546 .73877 L .36405 .74089 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.59074 .29697 m .60868 .29995 L .59768 .30219 L .605 1 0 r
F
P
p
.57975 .29923 m .59074 .29697 L .59768 .30219 L .57 1 0 r
F
P
p
.002 w
.49368 .69263 m .48303 .69368 L .47528 .69123 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.002 w
.46464 .69229 m .47528 .69123 L .48303 .69368 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.68889 .29688 m .70644 .29985 L .69514 .30209 L 1 .851 0 r
F
P
p
.6776 .29914 m .68889 .29688 L .69514 .30209 L 1 .92 0 r
F
P
p
.78705 .29678 m .80421 .29976 L .79262 .302 L 1 .209 0 r
F
P
p
.77547 .29904 m .78705 .29678 L .79262 .302 L 1 .314 0 r
F
P
p
.002 w
.74262 .55207 m .75406 .55059 L .7612 .59833 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75406 .55059 m .74262 .55207 L .73596 .52201 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.72526 .55011 m .73596 .52201 L .74262 .55207 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.33449 .7588 m .32431 .75965 L .31597 .73939 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.30584 .74031 m .31597 .73939 L .32431 .75965 L p
0 .372 1 r
F P
0 0 0 r
s
P
p
.002 w
.87347 .50321 m .86167 .50483 L .85659 .50105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84479 .50269 m .85659 .50105 L .86167 .50483 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.87336 .29895 m .88525 .29669 L .89012 .30191 L 1 0 0 r
F
P
p
.002 w
.66368 .60732 m .65251 .60863 L .64644 .63776 L p
.273 1 0 r
F P
0 0 0 r
s
P
p
.26712 .29653 m .28637 .29951 L .27634 .30175 L .57 1 0 r
F
P
p
.25711 .29879 m .26712 .29653 L .27634 .30175 L .535 1 0 r
F
P
p
.36528 .29644 m .38414 .29942 L .37381 .30166 L 1 .828 0 r
F
P
p
.35497 .2987 m .36528 .29644 L .37381 .30166 L 1 .907 0 r
F
P
p
.46347 .29634 m .48193 .29932 L .47131 .30157 L .465 1 0 r
F
P
p
.45286 .2986 m .46347 .29634 L .47131 .30157 L .43 1 0 r
F
P
p
.56168 .29625 m .57975 .29923 L .56883 .30147 L .311 1 0 r
F
P
p
.55077 .29851 m .56168 .29625 L .56883 .30147 L .136 1 0 r
F
P
p
.002 w
.46464 .69229 m .45406 .69335 L .4461 .69089 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.002 w
.43554 .69195 m .4461 .69089 L .45406 .69335 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.65991 .29615 m .6776 .29914 L .66637 .30138 L 1 .907 0 r
F
P
p
.6487 .29842 m .65991 .29615 L .66637 .30138 L 1 .942 0 r
F
P
p
.002 w
.63528 .64286 m .62413 .64407 L .61633 .55166 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61633 .55166 m .6274 .55017 L .63528 .64286 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6274 .55017 m .61633 .55166 L .61045 .63839 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61045 .63839 m .61633 .55166 L p
.60029 .64326 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61045 .63839 m .62172 .63715 L .6274 .55017 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61045 .63839 m .60286 .5717 L p
.62066 .63349 L .395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62172 .63715 m .61045 .63839 L p
.62066 .63349 L .395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59933 .64874 m .61045 .63839 L p
.60029 .64326 L .5 1 0 r
F P
0 0 0 r
s
P
p
.75817 .29606 m .77547 .29904 L .76395 .30129 L 1 .375 0 r
F
P
p
.74666 .29832 m .75817 .29606 L .76395 .30129 L 1 .41 0 r
F
P
p
.002 w
.69701 .57639 m .70798 .55706 L .7139 .5516 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.72526 .55011 m .7139 .5516 L .70798 .55706 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.84479 .50269 m .83306 .50431 L .82778 .50052 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81605 .50216 m .82778 .50052 L .83306 .50431 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.85646 .29597 m .87336 .29895 L .86154 .3012 L 1 0 0 r
F
P
p
.84465 .29823 m .85646 .29597 L .86154 .3012 L 1 0 0 r
F
P
p
.23773 .29581 m .25711 .29879 L .24715 .30104 L .465 1 0 r
F
P
p
.22779 .29807 m .23773 .29581 L .24715 .30104 L .43 1 0 r
F
P
p
.33598 .29571 m .35497 .2987 L .34472 .30094 L 1 .907 0 r
F
P
p
.32574 .29798 m .33598 .29571 L .34472 .30094 L 1 .977 0 r
F
P
p
.43426 .29562 m .45286 .2986 L .44231 .30085 L .709 1 0 r
F
P
p
.42372 .29788 m .43426 .29562 L .44231 .30085 L .65 1 0 r
F
P
p
.002 w
.31597 .73939 m .30584 .74031 L .29682 .73818 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.2864 .74823 m .29682 .73818 L .30584 .74031 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.53256 .29552 m .55077 .29851 L .53992 .30076 L .119 1 0 r
F
P
p
.52172 .29779 m .53256 .29552 L .53992 .30076 L .088 1 0 r
F
P
p
.002 w
.41388 .73936 m .40344 .74027 L .39512 .73814 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.3847 .73906 m .39512 .73814 L .40344 .74027 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.63089 .29543 m .6487 .29842 L .63756 .30066 L .917 1 0 r
F
P
p
.61975 .2977 m .63089 .29543 L .63756 .30066 L .847 1 0 r
F
P
p
.002 w
.53347 .69191 m .52267 .69297 L .51526 .66333 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.50446 .67765 m .51526 .66333 L .52267 .69297 L p
0 1 .632 r
F P
0 0 0 r
s
P
p
.72924 .29533 m .74666 .29832 L .73522 .30057 L 1 .468 0 r
F
P
p
.7178 .2976 m .72924 .29533 L .73522 .30057 L 1 .571 0 r
F
P
p
.002 w
.27602 .75825 m .266 .75911 L .2567 .75711 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.82761 .29524 m .84465 .29823 L .8329 .30048 L 1 0 0 r
F
P
p
.81588 .29751 m .82761 .29524 L .8329 .30048 L 1 0 0 r
F
P
p
.002 w
.7828 .55106 m .77273 .59699 L .76473 .52251 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.76473 .52251 m .77627 .52094 L .7828 .55106 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.77273 .59699 m .7612 .59833 L .75406 .55059 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.91405 .50209 m .9021 .50373 L .8973 .49993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88535 .50157 m .8973 .49993 L .9021 .50373 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.20827 .29508 m .22779 .29807 L .21792 .30032 L .43 1 0 r
F
P
p
.19842 .29735 m .20827 .29508 L .21792 .30032 L .36 1 0 r
F
P
p
.30662 .29498 m .32574 .29798 L .31557 .30023 L .869 1 0 r
F
P
p
.29646 .29725 m .30662 .29498 L .31557 .30023 L .744 1 0 r
F
P
p
.002 w
.75406 .55059 m .76473 .52251 L .77273 .59699 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.77627 .52094 m .76473 .52251 L .7584 .50111 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.76473 .52251 m .75406 .55059 L .74716 .51158 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.74716 .51158 m .7584 .50111 L .76473 .52251 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.40499 .29489 m .42372 .29788 L .41325 .30013 L .958 1 0 r
F
P
p
.39453 .29716 m .40499 .29489 L .41325 .30013 L .82 1 0 r
F
P
p
.50338 .2948 m .52172 .29779 L .51095 .30004 L .129 1 0 r
F
P
p
.49262 .29707 m .50338 .2948 L .51095 .30004 L .122 1 0 r
F
P
p
.002 w
.3847 .73906 m .37434 .73998 L .3658 .73785 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.002 w
.35546 .73877 m .3658 .73785 L .37434 .73998 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.6018 .2947 m .61975 .2977 L .60868 .29995 L .644 1 0 r
F
P
p
.59074 .29697 m .6018 .2947 L .60868 .29995 L .605 1 0 r
F
P
p
.002 w
.50446 .67765 m .49368 .69263 L .48616 .66296 L p
0 1 .528 r
F P
0 0 0 r
s
P
p
.002 w
.47528 .69123 m .48616 .66296 L .49368 .69263 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.70025 .29461 m .7178 .2976 L .70644 .29985 L 1 .835 0 r
F
P
p
.68889 .29688 m .70025 .29461 L .70644 .29985 L 1 .851 0 r
F
P
p
.79871 .29451 m .81588 .29751 L .80421 .29976 L 1 .2 0 r
F
P
p
.78705 .29678 m .79871 .29451 L .80421 .29976 L 1 .209 0 r
F
P
p
.002 w
.73596 .52201 m .74716 .51158 L .75406 .55059 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.34472 .75794 m .33449 .7588 L .32693 .71116 L p
0 .651 1 r
F P
0 0 0 r
s
P
p
.002 w
.31597 .73939 m .32693 .71116 L .33449 .7588 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.88535 .50157 m .87347 .50321 L .86847 .4994 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85659 .50105 m .86847 .4994 L .87347 .50321 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6745 .58429 m .66368 .60732 L .65748 .62159 L p
.416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65748 .62159 m .66368 .60732 L p
.64893 .63336 L .273 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65748 .62159 m .6688 .6203 L .6745 .58429 L p
.416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65748 .62159 m .64974 .54718 L p
.66606 .60977 L .75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6688 .6203 m .65748 .62159 L p
.66606 .60977 L .75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64644 .63776 m .65748 .62159 L p
.64893 .63336 L .273 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68567 .5778 m .6745 .58429 L .6688 .6203 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.80473 .51261 m .79439 .54957 L .78756 .51049 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.78756 .51049 m .7989 .49999 L .80473 .51261 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.2772 .29426 m .29646 .29725 L .28637 .29951 L .605 1 0 r
F
P
p
.26712 .29653 m .2772 .29426 L .28637 .29951 L .57 1 0 r
F
P
p
.002 w
.74716 .51158 m .73596 .52201 L .7307 .54512 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.73596 .52201 m .72526 .55011 L .7192 .54663 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.7192 .54663 m .7307 .54512 L .73596 .52201 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.37566 .29416 m .39453 .29716 L .38414 .29942 L 1 .808 0 r
F
P
p
.36528 .29644 m .37566 .29416 L .38414 .29942 L 1 .828 0 r
F
P
p
.002 w
.2864 .74823 m .27602 .75825 L .26904 .69238 L p
0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.26904 .69238 m .27908 .69132 L .2864 .74823 L p
0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.2567 .75711 m .26904 .69238 L .27602 .75825 L p
0 .477 1 r
F P
0 0 0 r
s
P
p
.002 w
.27908 .69132 m .26904 .69238 L .26008 .68081 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.002 w
.26904 .69238 m .2567 .75711 L .24972 .69098 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.24972 .69098 m .26008 .68081 L .26904 .69238 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.47415 .29407 m .49262 .29707 L .48193 .29932 L .509 1 0 r
F
P
p
.46347 .29634 m .47415 .29407 L .48193 .29932 L .465 1 0 r
F
P
p
.57266 .29397 m .59074 .29697 L .57975 .29923 L .535 1 0 r
F
P
p
.56168 .29625 m .57266 .29397 L .57975 .29923 L .311 1 0 r
F
P
p
.002 w
.47528 .69123 m .46464 .69229 L .45673 .68982 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.002 w
.4461 .69089 m .45673 .68982 L .46464 .69229 L p
0 1 .791 r
F P
0 0 0 r
s
P
p
.6712 .29388 m .68889 .29688 L .6776 .29914 L 1 .837 0 r
F
P
p
.65991 .29615 m .6712 .29388 L .6776 .29914 L 1 .907 0 r
F
P
p
.002 w
.64644 .63776 m .63528 .64286 L .6274 .55017 L p
.62 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63854 .54868 m .6274 .55017 L .62172 .63715 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.76976 .29378 m .78705 .29678 L .77547 .29904 L 1 .279 0 r
F
P
p
.75817 .29606 m .76976 .29378 L .77547 .29904 L 1 .375 0 r
F
P
p
.002 w
.70798 .55706 m .7192 .54663 L .72526 .55011 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.51526 .66333 m .50446 .67765 L .4969 .66181 L p
0 1 .423 r
F P
0 0 0 r
s
P
p
.002 w
.48616 .66296 m .4969 .66181 L .50446 .67765 L p
0 1 .528 r
F P
0 0 0 r
s
P
p
.002 w
.32693 .71116 m .33764 .692 L .34472 .75794 L p
0 .651 1 r
F P
0 0 0 r
s
P
p
.002 w
.33764 .692 m .32693 .71116 L .31857 .69059 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.32693 .71116 m .31597 .73939 L .30839 .69166 L p
0 .965 1 r
F P
0 0 0 r
s
P
p
.002 w
.30839 .69166 m .31857 .69059 L .32693 .71116 L p
0 .965 1 r
F P
0 0 0 r
s
P
p
.002 w
.85659 .50105 m .84479 .50269 L .83957 .49887 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82778 .50052 m .83957 .49887 L .84479 .50269 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.86834 .29369 m .88525 .29669 L .87336 .29895 L 1 0 0 r
F
P
p
.85646 .29597 m .86834 .29369 L .87336 .29895 L 1 0 0 r
F
P
p
.24772 .29353 m .26712 .29653 L .25711 .29879 L .49 1 0 r
F
P
p
.23773 .29581 m .24772 .29353 L .25711 .29879 L .465 1 0 r
F
P
p
.34628 .29343 m .36528 .29644 L .35497 .2987 L 1 .767 0 r
F
P
p
.33598 .29571 m .34628 .29343 L .35497 .2987 L 1 .907 0 r
F
P
p
.44486 .29334 m .46347 .29634 L .45286 .2986 L .814 1 0 r
F
P
p
.43426 .29562 m .44486 .29334 L .45286 .2986 L .709 1 0 r
F
P
p
.002 w
.35546 .73877 m .34472 .75794 L .33764 .692 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.33764 .692 m .3479 .69093 L .35546 .73877 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.3479 .69093 m .33764 .692 L .32907 .68042 L p
0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.31857 .69059 m .32907 .68042 L .33764 .692 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.29682 .73818 m .30839 .69166 L .31597 .73939 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.54346 .29324 m .56168 .29625 L .55077 .29851 L .228 1 0 r
F
P
p
.53256 .29552 m .54346 .29324 L .55077 .29851 L .119 1 0 r
F
P
p
.002 w
.4461 .69089 m .43554 .69195 L .42742 .68948 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.002 w
.43554 .69195 m .42437 .73844 L .41687 .69055 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.41687 .69055 m .42742 .68948 L .43554 .69195 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.42437 .73844 m .41388 .73936 L .4056 .73722 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.39512 .73814 m .4056 .73722 L .41388 .73936 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.64209 .29315 m .65991 .29615 L .6487 .29842 L .953 1 0 r
F
P
p
.63089 .29543 m .64209 .29315 L .6487 .29842 L .917 1 0 r
F
P
p
.002 w
.54433 .69085 m .53347 .69191 L .52607 .66218 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.002 w
.51526 .66333 m .52607 .66218 L .53347 .69191 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.74074 .29305 m .75817 .29606 L .74666 .29832 L 1 .41 0 r
F
P
p
.72924 .29533 m .74074 .29305 L .74666 .29832 L 1 .468 0 r
F
P
p
.002 w
.82778 .50052 m .81605 .50216 L .81062 .49834 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7989 .49999 m .81062 .49834 L .81605 .50216 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.83942 .29296 m .85646 .29597 L .84465 .29823 L 1 0 0 r
F
P
p
.82761 .29524 m .83942 .29296 L .84465 .29823 L 1 0 0 r
F
P
p
.002 w
.77627 .52094 m .78756 .51049 L .79439 .54957 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.7584 .50111 m .74716 .51158 L .74227 .54359 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.7307 .54512 m .74227 .54359 L .74716 .51158 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.8973 .49993 m .90932 .49827 L .91405 .50209 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52607 .66218 m .51526 .66333 L .5077 .66065 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.002 w
.4969 .66181 m .5077 .66065 L .51526 .66333 L p
0 1 .423 r
F P
0 0 0 r
s
P
p
.21819 .2928 m .23773 .29581 L .22779 .29807 L .465 1 0 r
F
P
p
.20827 .29508 m .21819 .2928 L .22779 .29807 L .43 1 0 r
F
P
p
.31684 .2927 m .33598 .29571 L .32574 .29798 L .953 1 0 r
F
P
p
.30662 .29498 m .31684 .2927 L .32574 .29798 L .869 1 0 r
F
P
p
.002 w
.78756 .51049 m .77627 .52094 L .76998 .49947 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.7584 .50111 m .76998 .49947 L .77627 .52094 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.41551 .29261 m .43426 .29562 L .42372 .29788 L 1 .992 0 r
F
P
p
.40499 .29489 m .41551 .29261 L .42372 .29788 L .958 1 0 r
F
P
p
.002 w
.69701 .57639 m .68567 .5778 L .6802 .61901 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6688 .6203 m .6802 .61901 L .68567 .5778 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31857 .69059 m .30839 .69166 L .29964 .68007 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.002 w
.30839 .69166 m .29682 .73818 L .28949 .68117 L p
0 1 .895 r
F P
0 0 0 r
s
P
p
.002 w
.28949 .68117 m .29964 .68007 L .30839 .69166 L p
0 1 .895 r
F P
0 0 0 r
s
P
p
.5142 .29251 m .53256 .29552 L .52172 .29779 L .206 1 0 r
F
P
p
.50338 .2948 m .5142 .29251 L .52172 .29779 L .129 1 0 r
F
P
p
.002 w
.39512 .73814 m .3847 .73906 L .37621 .73692 L p
0 .616 1 r
F P
0 0 0 r
s
P
p
.002 w
.3658 .73785 m .37621 .73692 L .3847 .73906 L p
0 .512 1 r
F P
0 0 0 r
s
P
p
.61293 .29242 m .63089 .29543 L .61975 .2977 L .732 1 0 r
F
P
p
.6018 .2947 m .61293 .29242 L .61975 .2977 L .644 1 0 r
F
P
p
.71167 .29232 m .72924 .29533 L .7178 .2976 L 1 .8 0 r
F
P
p
.70025 .29461 m .71167 .29232 L .7178 .2976 L 1 .835 0 r
F
P
p
.81045 .29223 m .82761 .29524 L .81588 .29751 L 1 .144 0 r
F
P
p
.79871 .29451 m .81045 .29223 L .81588 .29751 L 1 .2 0 r
F
P
p
.002 w
.8973 .49993 m .88535 .50157 L .88041 .49774 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86847 .4994 m .88041 .49774 L .88535 .50157 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.4969 .66181 m .48616 .66296 L .47839 .66028 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.48616 .66296 m .47528 .69123 L .46767 .66144 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.46767 .66144 m .47839 .66028 L .48616 .66296 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.1886 .29206 m .20827 .29508 L .19842 .29735 L .326 1 0 r
F
P
p
.28734 .29197 m .30662 .29498 L .29646 .29725 L .625 1 0 r
F
P
p
.2772 .29426 m .28734 .29197 L .29646 .29725 L .605 1 0 r
F
P
p
.3861 .29187 m .40499 .29489 L .39453 .29716 L 1 .781 0 r
F
P
p
.37566 .29416 m .3861 .29187 L .39453 .29716 L 1 .808 0 r
F
P
p
.002 w
.29682 .73818 m .2864 .74823 L .27908 .69132 L p
0 .86 1 r
F P
0 0 0 r
s
P
p
.002 w
.27908 .69132 m .28949 .68117 L .29682 .73818 L p
0 .86 1 r
F P
0 0 0 r
s
P
p
.002 w
.28949 .68117 m .27908 .69132 L .27081 .66153 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.002 w
.26008 .68081 m .27081 .66153 L .27908 .69132 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.48489 .29178 m .50338 .2948 L .49262 .29707 L .564 1 0 r
F
P
p
.47415 .29407 m .48489 .29178 L .49262 .29707 L .509 1 0 r
F
P
p
.002 w
.3658 .73785 m .35546 .73877 L .3479 .69093 L p
0 .895 1 r
F P
0 0 0 r
s
P
p
.58371 .29168 m .6018 .2947 L .59074 .29697 L .605 1 0 r
F
P
p
.57266 .29397 m .58371 .29168 L .59074 .29697 L .535 1 0 r
F
P
p
.002 w
.45673 .68982 m .46767 .66144 L .47528 .69123 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.68255 .29159 m .70025 .29461 L .68889 .29688 L 1 .767 0 r
F
P
p
.6712 .29388 m .68255 .29159 L .68889 .29688 L 1 .837 0 r
F
P
p
.002 w
.65748 .62159 m .64644 .63776 L .63854 .54868 L p
.692 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63854 .54868 m .64974 .54718 L .65748 .62159 L p
.692 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64974 .54718 m .63854 .54868 L .63305 .63589 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62172 .63715 m .63305 .63589 L .63854 .54868 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76998 .49947 m .7584 .50111 L .75337 .52408 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.74227 .54359 m .75337 .52408 L .7584 .50111 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.78141 .29149 m .79871 .29451 L .78705 .29678 L 1 .209 0 r
F
P
p
.76976 .29378 m .78141 .29149 L .78705 .29678 L 1 .279 0 r
F
P
p
.002 w
.86847 .4994 m .85659 .50105 L .85144 .49721 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83957 .49887 m .85144 .49721 L .85659 .50105 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.86834 .29369 m .8803 .2914 L .88525 .29669 L 1 0 0 r
F
P
p
.002 w
.7989 .49999 m .78756 .51049 L .78162 .49781 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.76998 .49947 m .78162 .49781 L .78756 .51049 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.25778 .29124 m .2772 .29426 L .26712 .29653 L .554 1 0 r
F
P
p
.24772 .29353 m .25778 .29124 L .26712 .29653 L .49 1 0 r
F
P
p
.35664 .29114 m .37566 .29416 L .36528 .29644 L 1 .698 0 r
F
P
p
.34628 .29343 m .35664 .29114 L .36528 .29644 L 1 .767 0 r
F
P
p
.002 w
.26008 .68081 m .24972 .69098 L .24134 .66116 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.45552 .29104 m .47415 .29407 L .46347 .29634 L .884 1 0 r
F
P
p
.44486 .29334 m .45552 .29104 L .46347 .29634 L .814 1 0 r
F
P
p
.002 w
.3479 .69093 m .35844 .68077 L .3658 .73785 L p
0 .895 1 r
F P
0 0 0 r
s
P
p
.002 w
.35844 .68077 m .3479 .69093 L .33937 .67931 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.002 w
.32907 .68042 m .33937 .67931 L .3479 .69093 L p
0 1 .721 r
F P
0 0 0 r
s
P
p
.55443 .29095 m .57266 .29397 L .56168 .29625 L .411 1 0 r
F
P
p
.54346 .29324 m .55443 .29095 L .56168 .29625 L .228 1 0 r
F
P
p
.002 w
.45673 .68982 m .4461 .69089 L .43838 .66107 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.002 w
.42742 .68948 m .43838 .66107 L .4461 .69089 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.002 w
.4056 .73722 m .41687 .69055 L .42437 .73844 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.65336 .29085 m .6712 .29388 L .65991 .29615 L .953 1 0 r
F
P
p
.64209 .29315 m .65336 .29085 L .65991 .29615 L .953 1 0 r
F
P
p
.002 w
.55522 .67579 m .54433 .69085 L .53694 .65195 L p
0 1 .447 r
F P
0 0 0 r
s
P
p
.002 w
.52607 .66218 m .53694 .65195 L .54433 .69085 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.75232 .29076 m .76976 .29378 L .75817 .29606 L 1 .375 0 r
F
P
p
.74074 .29305 m .75232 .29076 L .75817 .29606 L 1 .41 0 r
F
P
p
.002 w
.83957 .49887 m .82778 .50052 L .82242 .49667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81062 .49834 m .82242 .49667 L .82778 .50052 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8513 .29066 m .86834 .29369 L .85646 .29597 L 1 0 0 r
F
P
p
.83942 .29296 m .8513 .29066 L .85646 .29597 L 1 0 0 r
F
P
p
.002 w
.53694 .65195 m .52607 .66218 L .51858 .65038 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .66065 m .51858 .65038 L .52607 .66218 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.22817 .2905 m .24772 .29353 L .23773 .29581 L .465 1 0 r
F
P
p
.21819 .2928 m .22817 .2905 L .23773 .29581 L .465 1 0 r
F
P
p
.002 w
.29964 .68007 m .28949 .68117 L .28092 .66037 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.27081 .66153 m .28092 .66037 L .28949 .68117 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.32712 .2904 m .34628 .29343 L .33598 .29571 L .998 1 0 r
F
P
p
.31684 .2927 m .32712 .2904 L .33598 .29571 L .953 1 0 r
F
P
p
.42609 .29031 m .44486 .29334 L .43426 .29562 L 1 .977 0 r
F
P
p
.41551 .29261 m .42609 .29031 L .43426 .29562 L 1 .992 0 r
F
P
p
.002 w
.70798 .55706 m .69701 .57639 L .69221 .605 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.69335 .60339 m .70798 .55706 L .69221 .605 L .709 1 0 r
F
P
p
.002 w
.7192 .54663 m .70798 .55706 L .7028 .59885 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69149 .6093 m .7028 .59885 L .70798 .55706 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7028 .59885 m .71416 .58836 L .7192 .54663 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70632 .519 m .71277 .57603 L p
.69565 .5254 L 1 .932 0 r
F P
0 0 0 r
s
P
p
.69486 .52306 m .71277 .57603 L .71118 .57827 L 1 .932 0 r
F
P
p
.002 w
.71416 .58836 m .7028 .59885 L .69486 .52306 L p
1 .932 0 r
F P
0 0 0 r
s
P
p
.002 w
.7307 .54512 m .7192 .54663 L .71416 .58836 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.72532 .56873 m .7307 .54512 L p
.71583 .58399 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.71416 .58836 m .72532 .56873 L p
.71583 .58399 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.74227 .54359 m .7307 .54512 L .72532 .56873 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.72532 .56873 m .71775 .51082 L p
.73485 .55342 L 1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.73675 .55816 m .74227 .54359 L p
.72746 .56557 L 1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.72532 .56873 m .73675 .55816 L p
.72746 .56557 L 1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.75337 .52408 m .74227 .54359 L .73675 .55816 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.73675 .55816 m .74849 .55665 L .75337 .52408 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.73675 .55816 m .7294 .50918 L p
.7461 .55071 L 1 .607 0 r
F P
0 0 0 r
s
P
p
.002 w
.74849 .55665 m .73675 .55816 L p
.7461 .55071 L 1 .607 0 r
F P
0 0 0 r
s
P
p
.002 w
.73675 .55816 m .72532 .56873 L p
.73485 .55342 L 1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.72532 .56873 m .71416 .58836 L .70632 .519 L p
1 .793 0 r
F P
0 0 0 r
s
P
p
.002 w
.70632 .519 m .71775 .51082 L .72532 .56873 L p
1 .793 0 r
F P
0 0 0 r
s
P
p
.002 w
.70632 .519 m .70098 .5577 L p
.71714 .51253 L 1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.71775 .51082 m .70632 .519 L p
.71714 .51253 L 1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.69486 .52306 m .70632 .519 L p
.69565 .5254 L 1 .932 0 r
F P
0 0 0 r
s
P
p
.002 w
.71277 .57603 m .71416 .58836 L p
.71118 .57827 L 1 .932 0 r
F P
0 0 0 r
s
P
p
.002 w
.69221 .605 m .69149 .6093 L p
.69335 .60339 L .709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6802 .61901 m .69149 .6093 L .69701 .57639 L p
.572 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32907 .68042 m .31857 .69059 L .31041 .66075 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.002 w
.29964 .68007 m .31041 .66075 L .31857 .69059 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.52509 .29021 m .54346 .29324 L .53256 .29552 L .307 1 0 r
F
P
p
.5142 .29251 m .52509 .29021 L .53256 .29552 L .206 1 0 r
F
P
p
.002 w
.42742 .68948 m .41687 .69055 L .40858 .68805 L p
0 1 .756 r
F P
0 0 0 r
s
P
p
.002 w
.41687 .69055 m .4056 .73722 L .39771 .70743 L p
0 .965 1 r
F P
0 0 0 r
s
P
p
.002 w
.39771 .70743 m .40858 .68805 L .41687 .69055 L p
0 .965 1 r
F P
0 0 0 r
s
P
p
.002 w
.4056 .73722 m .39512 .73814 L .38722 .70845 L p
0 .721 1 r
F P
0 0 0 r
s
P
p
.002 w
.37621 .73692 m .38722 .70845 L .39512 .73814 L p
0 .616 1 r
F P
0 0 0 r
s
P
p
.62412 .29012 m .64209 .29315 L .63089 .29543 L .798 1 0 r
F
P
p
.61293 .29242 m .62412 .29012 L .63089 .29543 L .732 1 0 r
F
P
p
.002 w
.57724 .67355 m .5662 .67467 L .55869 .59531 L p
.014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55869 .59531 m .56967 .59395 L .57724 .67355 L p
.014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54787 .64797 m .55869 .59531 L .5662 .67467 L p
0 1 .184 r
F P
0 0 0 r
s
P
p
.002 w
.55869 .59531 m .54787 .64797 L .54048 .63884 L p
.162 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54048 .63884 m .55145 .61025 L .55869 .59531 L p
.162 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56967 .59395 m .55869 .59531 L .55145 .61025 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.72317 .29002 m .74074 .29305 L .72924 .29533 L 1 .733 0 r
F
P
p
.71167 .29232 m .72317 .29002 L .72924 .29533 L 1 .8 0 r
F
P
p
.002 w
.81062 .49834 m .7989 .49999 L .79333 .49614 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78162 .49781 m .79333 .49614 L .7989 .49999 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.82225 .28993 m .83942 .29296 L .82761 .29524 L 1 .084 0 r
F
P
p
.81045 .29223 m .82225 .28993 L .82761 .29524 L 1 .144 0 r
F
P
p
.002 w
.53694 .65195 m .54787 .64797 L .55522 .67579 L p
0 1 .447 r
F P
0 0 0 r
s
P
p
.002 w
.90932 .49827 m .8973 .49993 L .89243 .49607 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88041 .49774 m .89243 .49607 L .8973 .49993 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.5077 .66065 m .4969 .66181 L .48917 .65911 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.002 w
.47839 .66028 m .48917 .65911 L .4969 .66181 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.19849 .28976 m .21819 .2928 L .20827 .29508 L .36 1 0 r
F
P
p
.1886 .29206 m .19849 .28976 L .20827 .29508 L .326 1 0 r
F
P
p
.002 w
.27081 .66153 m .26008 .68081 L .25172 .65091 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.24134 .66116 m .25172 .65091 L .26008 .68081 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.29754 .28967 m .31684 .2927 L .30662 .29498 L .694 1 0 r
F
P
p
.28734 .29197 m .29754 .28967 L .30662 .29498 L .625 1 0 r
F
P
p
.002 w
.37621 .73692 m .3658 .73785 L .35844 .68077 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.35844 .68077 m .36923 .66149 L .37621 .73692 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.36923 .66149 m .35844 .68077 L .34973 .6782 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.002 w
.33937 .67931 m .34973 .6782 L .35844 .68077 L p
0 1 .686 r
F P
0 0 0 r
s
P
p
.39661 .28957 m .41551 .29261 L .40499 .29489 L 1 .733 0 r
F
P
p
.3861 .29187 m .39661 .28957 L .40499 .29489 L 1 .781 0 r
F
P
p
.4957 .28948 m .5142 .29251 L .50338 .2948 L .585 1 0 r
F
P
p
.48489 .29178 m .4957 .28948 L .50338 .2948 L .564 1 0 r
F
P
p
.59482 .28938 m .61293 .29242 L .6018 .2947 L .644 1 0 r
F
P
p
.58371 .29168 m .59482 .28938 L .6018 .2947 L .605 1 0 r
F
P
p
.69397 .28928 m .71167 .29232 L .70025 .29461 L 1 .733 0 r
F
P
p
.68255 .29159 m .69397 .28928 L .70025 .29461 L 1 .767 0 r
F
P
p
.002 w
.64974 .54718 m .66102 .54567 L .6688 .6203 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66102 .54567 m .64974 .54718 L .64392 .59797 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64392 .59797 m .64974 .54718 L p
.63714 .6142 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64392 .59797 m .65519 .58746 L .66102 .54567 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64392 .59797 m .6367 .56349 L p
.65072 .58167 L .739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65519 .58746 m .64392 .59797 L p
.65072 .58167 L .739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63305 .63589 m .64392 .59797 L p
.63714 .6142 L .744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28092 .66037 m .27081 .66153 L .2618 .64971 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.25172 .65091 m .2618 .64971 L .27081 .66153 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.78162 .49781 m .76998 .49947 L .76505 .52248 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.75337 .52408 m .76505 .52248 L .76998 .49947 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.79314 .28919 m .81045 .29223 L .79871 .29451 L 1 .2 0 r
F
P
p
.78141 .29149 m .79314 .28919 L .79871 .29451 L 1 .209 0 r
F
P
p
.002 w
.38722 .70845 m .37621 .73692 L .36923 .66149 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.36923 .66149 m .37964 .66032 L .38722 .70845 L p
0 1 .826 r
F P
0 0 0 r
s
P
p
.002 w
.37964 .66032 m .36923 .66149 L .36058 .65878 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.34973 .6782 m .36058 .65878 L .36923 .66149 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.002 w
.54787 .64797 m .53694 .65195 L .5295 .64007 L p
0 1 .152 r
F P
0 0 0 r
s
P
p
.002 w
.51858 .65038 m .5295 .64007 L .53694 .65195 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.88041 .49774 m .86847 .4994 L .86339 .49554 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85144 .49721 m .86339 .49554 L .86847 .4994 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47839 .66028 m .46767 .66144 L .45973 .65873 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.46767 .66144 m .45673 .68982 L .44902 .6599 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.44902 .6599 m .45973 .65873 L .46767 .66144 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.2679 .28893 m .28734 .29197 L .2772 .29426 L .599 1 0 r
F
P
p
.25778 .29124 m .2679 .28893 L .2772 .29426 L .554 1 0 r
F
P
p
.002 w
.33937 .67931 m .32907 .68042 L .32093 .65048 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.002 w
.31041 .66075 m .32093 .65048 L .32907 .68042 L p
0 1 .512 r
F P
0 0 0 r
s
P
p
.36706 .28883 m .3861 .29187 L .37566 .29416 L 1 .698 0 r
F
P
p
.35664 .29114 m .36706 .28883 L .37566 .29416 L 1 .698 0 r
F
P
p
.46625 .28874 m .48489 .29178 L .47415 .29407 L .942 1 0 r
F
P
p
.45552 .29104 m .46625 .28874 L .47415 .29407 L .884 1 0 r
F
P
p
.56546 .28864 m .58371 .29168 L .57266 .29397 L .56 1 0 r
F
P
p
.55443 .29095 m .56546 .28864 L .57266 .29397 L .411 1 0 r
F
P
p
.002 w
.43838 .66107 m .44902 .6599 L .45673 .68982 L p
0 1 .581 r
F P
0 0 0 r
s
P
p
.6647 .28855 m .68255 .29159 L .6712 .29388 L .988 1 0 r
F
P
p
.65336 .29085 m .6647 .28855 L .6712 .29388 L .953 1 0 r
F
P
p
.002 w
.25172 .65091 m .24134 .66116 L .23215 .64933 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.76397 .28845 m .78141 .29149 L .76976 .29378 L 1 .349 0 r
F
P
p
.75232 .29076 m .76397 .28845 L .76976 .29378 L 1 .375 0 r
F
P
p
.002 w
.85144 .49721 m .83957 .49887 L .83428 .495 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82242 .49667 m .83428 .495 L .83957 .49887 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.86326 .28835 m .8803 .2914 L .86834 .29369 L 1 0 0 r
F
P
p
.8513 .29066 m .86326 .28835 L .86834 .29369 L 1 0 0 r
F
P
p
.002 w
.44902 .6599 m .43838 .66107 L .43023 .65836 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.43838 .66107 m .42742 .68948 L .41932 .6778 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.002 w
.41932 .6778 m .43023 .65836 L .43838 .66107 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.2382 .28819 m .25778 .29124 L .24772 .29353 L .49 1 0 r
F
P
p
.22817 .2905 m .2382 .28819 L .24772 .29353 L .465 1 0 r
F
P
p
.002 w
.31041 .66075 m .29964 .68007 L .2914 .6501 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.28092 .66037 m .2914 .6501 L .29964 .68007 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.33746 .28809 m .35664 .29114 L .34628 .29343 L 1 .897 0 r
F
P
p
.32712 .2904 m .33746 .28809 L .34628 .29343 L .998 1 0 r
F
P
p
.43674 .288 m .45552 .29104 L .44486 .29334 L 1 .942 0 r
F
P
p
.42609 .29031 m .43674 .288 L .44486 .29334 L 1 .977 0 r
F
P
p
.53605 .2879 m .55443 .29095 L .54346 .29324 L .428 1 0 r
F
P
p
.52509 .29021 m .53605 .2879 L .54346 .29324 L .307 1 0 r
F
P
p
.002 w
.40858 .68805 m .41932 .6778 L .42742 .68948 L p
0 1 .756 r
F P
0 0 0 r
s
P
p
.002 w
.38722 .70845 m .39771 .70743 L .4056 .73722 L p
0 .721 1 r
F P
0 0 0 r
s
P
p
.63538 .2878 m .65336 .29085 L .64209 .29315 L .849 1 0 r
F
P
p
.62412 .29012 m .63538 .2878 L .64209 .29315 L .798 1 0 r
F
P
p
.002 w
.58825 .65906 m .57724 .67355 L .56967 .59395 L p
.065 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58072 .59258 m .56967 .59395 L .56245 .59076 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55145 .61025 m .56245 .59076 L .56967 .59395 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.73474 .28771 m .75232 .29076 L .74074 .29305 L 1 .698 0 r
F
P
p
.72317 .29002 m .73474 .28771 L .74074 .29305 L 1 .733 0 r
F
P
p
.002 w
.32093 .65048 m .31041 .66075 L .30162 .64889 L p
0 1 .267 r
F P
0 0 0 r
s
P
p
.002 w
.2914 .6501 m .30162 .64889 L .31041 .66075 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.82242 .49667 m .81062 .49834 L .80512 .49446 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79333 .49614 m .80512 .49446 L .81062 .49834 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.83413 .28761 m .8513 .29066 L .83942 .29296 L 1 .035 0 r
F
P
p
.82225 .28993 m .83413 .28761 L .83942 .29296 L 1 .084 0 r
F
P
p
.002 w
.39771 .70743 m .38722 .70845 L .37964 .66032 L p
0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.89243 .49607 m .90453 .49439 L .90932 .49827 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51858 .65038 m .5077 .66065 L .50007 .64879 L p
0 1 .251 r
F P
0 0 0 r
s
P
p
.002 w
.48917 .65911 m .50007 .64879 L .5077 .66065 L p
0 1 .337 r
F P
0 0 0 r
s
P
p
.20845 .28745 m .22817 .2905 L .21819 .2928 L .43 1 0 r
F
P
p
.19849 .28976 m .20845 .28745 L .21819 .2928 L .36 1 0 r
F
P
p
.3078 .28735 m .32712 .2904 L .31684 .2927 L .744 1 0 r
F
P
p
.29754 .28967 m .3078 .28735 L .31684 .2927 L .694 1 0 r
F
P
p
.40718 .28726 m .42609 .29031 L .41551 .29261 L 1 .698 0 r
F
P
p
.39661 .28957 m .40718 .28726 L .41551 .29261 L 1 .733 0 r
F
P
p
.50658 .28716 m .52509 .29021 L .5142 .29251 L .671 1 0 r
F
P
p
.4957 .28948 m .50658 .28716 L .5142 .29251 L .585 1 0 r
F
P
p
.002 w
.2618 .64971 m .25172 .65091 L .24315 .62454 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.002 w
.23215 .64933 m .24315 .62454 L .25172 .65091 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.002 w
.5295 .64007 m .54048 .63884 L .54787 .64797 L p
0 1 .152 r
F P
0 0 0 r
s
P
p
.60601 .28706 m .62412 .29012 L .61293 .29242 L .783 1 0 r
F
P
p
.59482 .28938 m .60601 .28706 L .61293 .29242 L .644 1 0 r
F
P
p
.70546 .28697 m .72317 .29002 L .71167 .29232 L 1 .698 0 r
F
P
p
.69397 .28928 m .70546 .28697 L .71167 .29232 L 1 .733 0 r
F
P
p
.002 w
.6802 .61901 m .6688 .6203 L .66213 .5563 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66213 .5563 m .66127 .54807 L p
.66324 .55546 L .75 1 0 r
F P
0 0 0 r
s
P
p
.66324 .55546 m .6802 .61901 L .66213 .5563 L .75 1 0 r
F
P
p
.66161 .54795 m .6802 .61901 L .66127 .54807 L .75 1 0 r
F
P
p
.002 w
.66102 .54567 m .67236 .54414 L .6802 .61901 L p
.75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69149 .6093 m .6802 .61901 L .67321 .55227 L p
.795 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67321 .55227 m .67236 .54414 L p
.67431 .5508 L .795 1 0 r
F P
0 0 0 r
s
P
p
.67431 .5508 m .69149 .6093 L .67321 .55227 L .795 1 0 r
F
P
p
.002 w
.6837 .53915 m .69149 .6093 L p
.67431 .5508 L .795 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67236 .54414 m .6837 .53915 L p
.67431 .5508 L .795 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7028 .59885 m .69149 .6093 L .6837 .53915 L p
.932 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6837 .53915 m .69486 .52306 L .7028 .59885 L p
.932 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6837 .53915 m .67785 .56632 L p
.69313 .52746 L 1 .824 0 r
F P
0 0 0 r
s
P
p
.69313 .52746 m .69464 .52361 L .6837 .53915 L 1 .824 0 r
F
P
p
.002 w
.69486 .52306 m .69238 .52664 L p
.69464 .52361 L 1 .824 0 r
F P
0 0 0 r
s
P
p
.002 w
.69238 .52664 m .6837 .53915 L p
.69464 .52361 L 1 .824 0 r
F P
0 0 0 r
s
P
p
.002 w
.67785 .56632 m .6835 .54007 L p
.66926 .57092 L 1 .928 0 r
F P
0 0 0 r
s
P
p
.6665 .57691 m .6835 .54007 L .68317 .54032 L 1 .928 0 r
F
P
p
.002 w
.67236 .54414 m .6665 .57691 L p
.68317 .54032 L 1 .928 0 r
F P
0 0 0 r
s
P
p
.002 w
.66127 .54807 m .66102 .54567 L p
.66161 .54795 L .75 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67236 .54414 m .66102 .54567 L .65519 .58746 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65519 .58746 m .6665 .57691 L .67236 .54414 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67785 .56632 m .68945 .56484 L .69486 .52306 L p
1 .824 0 r
F P
0 0 0 r
s
P
p
.002 w
.67785 .56632 m .67094 .54452 L p
.68655 .56166 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.68945 .56484 m .67785 .56632 L p
.68655 .56166 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.6665 .57691 m .67785 .56632 L p
.66926 .57092 L 1 .928 0 r
F P
0 0 0 r
s
P
p
.002 w
.6835 .54007 m .6837 .53915 L p
.68317 .54032 L 1 .928 0 r
F P
0 0 0 r
s
P
p
.002 w
.6837 .53915 m .67236 .54414 L p
.68317 .54032 L 1 .928 0 r
F P
0 0 0 r
s
P
p
.002 w
.2914 .6501 m .28092 .66037 L .27195 .64851 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.002 w
.2618 .64971 m .27195 .64851 L .28092 .66037 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.79333 .49614 m .78162 .49781 L .7765 .51187 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.76505 .52248 m .7765 .51187 L .78162 .49781 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.80494 .28687 m .82225 .28993 L .81045 .29223 L 1 .144 0 r
F
P
p
.79314 .28919 m .80494 .28687 L .81045 .29223 L 1 .2 0 r
F
P
p
.002 w
.37964 .66032 m .39012 .65916 L .39771 .70743 L p
0 1 .721 r
F P
0 0 0 r
s
P
p
.002 w
.39012 .65916 m .37964 .66032 L .37105 .6576 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.36058 .65878 m .37105 .6576 L .37964 .66032 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.89243 .49607 m .88041 .49774 L .8754 .49385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86339 .49554 m .8754 .49385 L .88041 .49774 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.48917 .65911 m .47839 .66028 L .4705 .65755 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.45973 .65873 m .4705 .65755 L .47839 .66028 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.17864 .28671 m .19849 .28976 L .1886 .29206 L .36 1 0 r
F
P
p
.27808 .28661 m .29754 .28967 L .28734 .29197 L .605 1 0 r
F
P
p
.2679 .28893 m .27808 .28661 L .28734 .29197 L .599 1 0 r
F
P
p
.002 w
.34973 .6782 m .33937 .67931 L .33124 .64928 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.002 w
.32093 .65048 m .33124 .64928 L .33937 .67931 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.37755 .28651 m .39661 .28957 L .3861 .29187 L 1 .698 0 r
F
P
p
.36706 .28883 m .37755 .28651 L .3861 .29187 L 1 .698 0 r
F
P
p
.47705 .28642 m .4957 .28948 L .48489 .29178 L 1 .98 0 r
F
P
p
.46625 .28874 m .47705 .28642 L .48489 .29178 L .942 1 0 r
F
P
p
.57657 .28632 m .59482 .28938 L .58371 .29168 L .605 1 0 r
F
P
p
.56546 .28864 m .57657 .28632 L .58371 .29168 L .56 1 0 r
F
P
p
.002 w
.33124 .64928 m .32093 .65048 L .31191 .64768 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.30162 .64889 m .31191 .64768 L .32093 .65048 L p
0 1 .267 r
F P
0 0 0 r
s
P
p
.67612 .28622 m .69397 .28928 L .68255 .29159 L 1 .942 0 r
F
P
p
.6647 .28855 m .67612 .28622 L .68255 .29159 L .988 1 0 r
F
P
p
.77569 .28613 m .79314 .28919 L .78141 .29149 L 1 .349 0 r
F
P
p
.76397 .28845 m .77569 .28613 L .78141 .29149 L 1 .349 0 r
F
P
p
.002 w
.5295 .64007 m .51858 .65038 L .51099 .64328 L p
0 1 .146 r
F P
0 0 0 r
s
P
p
.002 w
.50007 .64879 m .51099 .64328 L .51858 .65038 L p
0 1 .251 r
F P
0 0 0 r
s
P
p
.002 w
.86339 .49554 m .85144 .49721 L .84622 .49331 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83428 .495 m .84622 .49331 L .85144 .49721 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.86326 .28835 m .87529 .28603 L .8803 .2914 L 1 0 0 r
F
P
p
.002 w
.45973 .65873 m .44902 .6599 L .44092 .65717 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.43023 .65836 m .44092 .65717 L .44902 .6599 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.2483 .28586 m .2679 .28893 L .25778 .29124 L .52 1 0 r
F
P
p
.2382 .28819 m .2483 .28586 L .25778 .29124 L .49 1 0 r
F
P
p
.34787 .28577 m .36706 .28883 L .35664 .29114 L 1 .802 0 r
F
P
p
.33746 .28809 m .34787 .28577 L .35664 .29114 L 1 .897 0 r
F
P
p
.44746 .28567 m .46625 .28874 L .45552 .29104 L 1 .907 0 r
F
P
p
.43674 .288 m .44746 .28567 L .45552 .29104 L 1 .942 0 r
F
P
p
.54707 .28557 m .56546 .28864 L .55443 .29095 L .545 1 0 r
F
P
p
.53605 .2879 m .54707 .28557 L .55443 .29095 L .428 1 0 r
F
P
p
.002 w
.30162 .64889 m .2914 .6501 L .28296 .62367 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.002 w
.27195 .64851 m .28296 .62367 L .2914 .6501 L p
0 1 .177 r
F P
0 0 0 r
s
P
p
.64672 .28548 m .6647 .28855 L .65336 .29085 L .884 1 0 r
F
P
p
.63538 .2878 m .64672 .28548 L .65336 .29085 L .849 1 0 r
F
P
p
.002 w
.58072 .59258 m .59177 .58216 L .59933 .64874 L p
.186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59177 .58216 m .58072 .59258 L .57356 .58937 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56245 .59076 m .57356 .58937 L .58072 .59258 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.74638 .28538 m .76397 .28845 L .75232 .29076 L 1 .698 0 r
F
P
p
.73474 .28771 m .74638 .28538 L .75232 .29076 L 1 .698 0 r
F
P
p
.002 w
.83428 .495 m .82242 .49667 L .81698 .49277 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80512 .49446 m .81698 .49277 L .82242 .49667 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.84608 .28528 m .86326 .28835 L .8513 .29066 L 1 0 0 r
F
P
p
.83413 .28761 m .84608 .28528 L .8513 .29066 L 1 .035 0 r
F
P
p
.002 w
.40858 .68805 m .39771 .70743 L .39012 .65916 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.21847 .28512 m .2382 .28819 L .22817 .2905 L .465 1 0 r
F
P
p
.20845 .28745 m .21847 .28512 L .22817 .2905 L .43 1 0 r
F
P
p
.31813 .28502 m .33746 .28809 L .32712 .2904 L .774 1 0 r
F
P
p
.3078 .28735 m .31813 .28502 L .32712 .2904 L .744 1 0 r
F
P
p
.41781 .28492 m .43674 .288 L .42609 .29031 L 1 .698 0 r
F
P
p
.40718 .28726 m .41781 .28492 L .42609 .29031 L 1 .698 0 r
F
P
p
.51752 .28483 m .53605 .2879 L .52509 .29021 L .767 1 0 r
F
P
p
.50658 .28716 m .51752 .28483 L .52509 .29021 L .671 1 0 r
F
P
p
.002 w
.27195 .64851 m .2618 .64971 L .25373 .61042 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24315 .62454 m .25373 .61042 L .2618 .64971 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.002 w
.41932 .6778 m .40858 .68805 L .40067 .65798 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.002 w
.39012 .65916 m .40067 .65798 L .40858 .68805 L p
0 1 .651 r
F P
0 0 0 r
s
P
p
.61726 .28473 m .63538 .2878 L .62412 .29012 L .889 1 0 r
F
P
p
.60601 .28706 m .61726 .28473 L .62412 .29012 L .783 1 0 r
F
P
p
.002 w
.54048 .63884 m .5295 .64007 L .52196 .6372 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.51099 .64328 m .52196 .6372 L .5295 .64007 L p
0 1 .146 r
F P
0 0 0 r
s
P
p
.71702 .28463 m .73474 .28771 L .72317 .29002 L 1 .698 0 r
F
P
p
.70546 .28697 m .71702 .28463 L .72317 .29002 L 1 .698 0 r
F
P
p
.002 w
.80512 .49446 m .79333 .49614 L .788 .50122 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.7765 .51187 m .788 .50122 L .79333 .49614 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.81681 .28454 m .83413 .28761 L .82225 .28993 L 1 .084 0 r
F
P
p
.80494 .28687 m .81681 .28454 L .82225 .28993 L 1 .144 0 r
F
P
p
.002 w
.40067 .65798 m .39012 .65916 L .38158 .65642 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.37105 .6576 m .38158 .65642 L .39012 .65916 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.90453 .49439 m .89243 .49607 L .88749 .49216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8754 .49385 m .88749 .49216 L .89243 .49607 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.50007 .64879 m .48917 .65911 L .48147 .63805 L p
0 1 .192 r
F P
0 0 0 r
s
P
p
.002 w
.4705 .65755 m .48147 .63805 L .48917 .65911 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.18857 .28437 m .20845 .28745 L .19849 .28976 L .395 1 0 r
F
P
p
.17864 .28671 m .18857 .28437 L .19849 .28976 L .36 1 0 r
F
P
p
.28833 .28427 m .3078 .28735 L .29754 .28967 L .605 1 0 r
F
P
p
.27808 .28661 m .28833 .28427 L .29754 .28967 L .605 1 0 r
F
P
p
.002 w
.36058 .65878 m .34973 .6782 L .34161 .64807 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.33124 .64928 m .34161 .64807 L .34973 .6782 L p
0 1 .442 r
F P
0 0 0 r
s
P
p
.38811 .28418 m .40718 .28726 L .39661 .28957 L 1 .698 0 r
F
P
p
.37755 .28651 m .38811 .28418 L .39661 .28957 L 1 .698 0 r
F
P
p
.002 w
.25373 .61042 m .24315 .62454 L .23407 .60866 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24315 .62454 m .23215 .64933 L .22401 .61 L p
.137 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22401 .61 m .23407 .60866 L .24315 .62454 L p
.137 1 0 r
F P
0 0 0 r
s
P
p
.48791 .28408 m .50658 .28716 L .4957 .28948 L 1 .938 0 r
F
P
p
.47705 .28642 m .48791 .28408 L .4957 .28948 L 1 .98 0 r
F
P
p
.002 w
.61045 .63839 m .59933 .64874 L .59177 .58216 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59177 .58216 m .60286 .5717 L .61045 .63839 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57356 .58937 m .58473 .58797 L .59177 .58216 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60286 .5717 m .59177 .58216 L .58473 .58797 L p
.738 1 0 r
F P
0 0 0 r
s
P
p
.58774 .28398 m .60601 .28706 L .59482 .28938 L .674 1 0 r
F
P
p
.57657 .28632 m .58774 .28398 L .59482 .28938 L .605 1 0 r
F
P
p
.002 w
.34161 .64807 m .33124 .64928 L .32227 .64647 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.31191 .64768 m .32227 .64647 L .33124 .64928 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.6876 .28389 m .70546 .28697 L .69397 .28928 L 1 .837 0 r
F
P
p
.67612 .28622 m .6876 .28389 L .69397 .28928 L 1 .942 0 r
F
P
p
.78748 .28379 m .80494 .28687 L .79314 .28919 L 1 .349 0 r
F
P
p
.77569 .28613 m .78748 .28379 L .79314 .28919 L 1 .349 0 r
F
P
p
.002 w
.37105 .6576 m .36058 .65878 L .35205 .64686 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.34161 .64807 m .35205 .64686 L .36058 .65878 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.8754 .49385 m .86339 .49554 L .85823 .49162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84622 .49331 m .85823 .49162 L .86339 .49554 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.4705 .65755 m .45973 .65873 L .45168 .65599 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.44092 .65717 m .45168 .65599 L .45973 .65873 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.25847 .28352 m .27808 .28661 L .2679 .28893 L .53 1 0 r
F
P
p
.2483 .28586 m .25847 .28352 L .2679 .28893 L .52 1 0 r
F
P
p
.35834 .28343 m .37755 .28651 L .36706 .28883 L 1 .767 0 r
F
P
p
.34787 .28577 m .35834 .28343 L .36706 .28883 L 1 .802 0 r
F
P
p
.002 w
.43023 .65836 m .41932 .6778 L .41128 .6568 L p
0 1 .407 r
F P
0 0 0 r
s
P
p
.002 w
.40067 .65798 m .41128 .6568 L .41932 .6778 L p
0 1 .547 r
F P
0 0 0 r
s
P
p
.45824 .28333 m .47705 .28642 L .46625 .28874 L 1 .872 0 r
F
P
p
.44746 .28567 m .45824 .28333 L .46625 .28874 L 1 .907 0 r
F
P
p
.002 w
.76505 .52248 m .75337 .52408 L .74849 .55665 L p
1 .628 0 r
F P
0 0 0 r
s
P
p
.55817 .28323 m .57657 .28632 L .56546 .28864 L .62 1 0 r
F
P
p
.54707 .28557 m .55817 .28323 L .56546 .28864 L .545 1 0 r
F
P
p
.002 w
.31191 .64768 m .30162 .64889 L .29363 .60952 L p
.047 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28296 .62367 m .29363 .60952 L .30162 .64889 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.65812 .28314 m .67612 .28622 L .6647 .28855 L .919 1 0 r
F
P
p
.64672 .28548 m .65812 .28314 L .6647 .28855 L .884 1 0 r
F
P
p
.002 w
.25373 .61042 m .26421 .6 L .27195 .64851 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26421 .6 m .25373 .61042 L .24455 .5982 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23407 .60866 m .24455 .5982 L .25373 .61042 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.7581 .28304 m .77569 .28613 L .76397 .28845 L 1 .698 0 r
F
P
p
.74638 .28538 m .7581 .28304 L .76397 .28845 L 1 .698 0 r
F
P
p
.002 w
.51099 .64328 m .50007 .64879 L .49236 .63518 L p
0 1 .109 r
F P
0 0 0 r
s
P
p
.002 w
.48147 .63805 m .49236 .63518 L .50007 .64879 L p
0 1 .192 r
F P
0 0 0 r
s
P
p
.002 w
.84622 .49331 m .83428 .495 L .82891 .49107 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81698 .49277 m .82891 .49107 L .83428 .495 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8581 .28294 m .87529 .28603 L .86326 .28835 L 1 0 0 r
F
P
p
.84608 .28528 m .8581 .28294 L .86326 .28835 L 1 0 0 r
F
P
p
.002 w
.44092 .65717 m .43023 .65836 L .42209 .64642 L p
0 1 .267 r
F P
0 0 0 r
s
P
p
.002 w
.41128 .6568 m .42209 .64642 L .43023 .65836 L p
0 1 .407 r
F P
0 0 0 r
s
P
p
.002 w
.55145 .61025 m .54048 .63884 L .53299 .63594 L p
.047 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56245 .59076 m .55145 .61025 L .54407 .62549 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53299 .63594 m .54407 .62549 L .55145 .61025 L p
.047 1 0 r
F P
0 0 0 r
s
P
p
.22855 .28277 m .2483 .28586 L .2382 .28819 L .465 1 0 r
F
P
p
.21847 .28512 m .22855 .28277 L .2382 .28819 L .465 1 0 r
F
P
p
.32852 .28268 m .34787 .28577 L .33746 .28809 L .879 1 0 r
F
P
p
.31813 .28502 m .32852 .28268 L .33746 .28809 L .774 1 0 r
F
P
p
.002 w
.60286 .5717 m .61409 .57025 L .62172 .63715 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61409 .57025 m .60286 .5717 L .59591 .57904 L p
.808 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58473 .58797 m .59591 .57904 L p
.59649 .57742 L .738 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59591 .57904 m .58473 .58797 L .57752 .58469 L p
.633 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59591 .57904 m .58882 .58326 L p
.59533 .58068 L .668 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6072 .57598 m .59591 .57904 L p
.59533 .58068 L .668 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59591 .57904 m .60286 .5717 L p
.59649 .57742 L .738 1 0 r
F P
0 0 0 r
s
P
p
.42851 .28258 m .44746 .28567 L .43674 .288 L 1 .698 0 r
F
P
p
.41781 .28492 m .42851 .28258 L .43674 .288 L 1 .698 0 r
F
P
p
.002 w
.29363 .60952 m .28296 .62367 L .27491 .58435 L p
.463 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28296 .62367 m .27195 .64851 L .26421 .6 L p
.261 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26421 .6 m .27491 .58435 L .28296 .62367 L p
.261 1 0 r
F P
0 0 0 r
s
P
p
.52853 .28248 m .54707 .28557 L .53605 .2879 L .86 1 0 r
F
P
p
.51752 .28483 m .52853 .28248 L .53605 .2879 L .767 1 0 r
F
P
p
.62858 .28238 m .64672 .28548 L .63538 .2878 L .929 1 0 r
F
P
p
.61726 .28473 m .62858 .28238 L .63538 .2878 L .889 1 0 r
F
P
p
.002 w
.23407 .60866 m .22401 .61 L .21424 .60689 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57356 .58937 m .56245 .59076 L .55517 .60581 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54407 .62549 m .55517 .60581 L p
.55568 .60355 L .326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55517 .60581 m .54407 .62549 L .53654 .62247 L p
.137 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55517 .60581 m .54774 .6157 L p
.55466 .6081 L .262 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55517 .60581 m .56633 .59527 L .57356 .58937 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56633 .59527 m .55517 .60581 L p
.55466 .6081 L .262 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55517 .60581 m .56245 .59076 L p
.55568 .60355 L .326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52196 .6372 m .53299 .63594 L .54048 .63884 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.72865 .28229 m .74638 .28538 L .73474 .28771 L 1 .698 0 r
F
P
p
.71702 .28463 m .72865 .28229 L .73474 .28771 L 1 .698 0 r
F
P
p
.002 w
.81698 .49277 m .80512 .49446 L .79954 .49053 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.788 .50122 m .79954 .49053 L .80512 .49446 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.82875 .28219 m .84608 .28528 L .83413 .28761 L 1 .035 0 r
F
P
p
.81681 .28454 m .82875 .28219 L .83413 .28761 L 1 .084 0 r
F
P
p
.002 w
.41128 .6568 m .40067 .65798 L .39217 .65522 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.38158 .65642 m .39217 .65522 L .40067 .65798 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.88749 .49216 m .89966 .49046 L .90453 .49439 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.19857 .28202 m .21847 .28512 L .20845 .28745 L .43 1 0 r
F
P
p
.18857 .28437 m .19857 .28202 L .20845 .28745 L .395 1 0 r
F
P
p
.29863 .28192 m .31813 .28502 L .3078 .28735 L .605 1 0 r
F
P
p
.28833 .28427 m .29863 .28192 L .3078 .28735 L .605 1 0 r
F
P
p
.39872 .28183 m .41781 .28492 L .40718 .28726 L 1 .698 0 r
F
P
p
.38811 .28418 m .39872 .28183 L .40718 .28726 L 1 .698 0 r
F
P
p
.002 w
.70632 .519 m .69486 .52306 L .68945 .56484 L p
1 .736 0 r
F P
0 0 0 r
s
P
p
.49884 .28173 m .51752 .28483 L .50658 .28716 L 1 .869 0 r
F
P
p
.48791 .28408 m .49884 .28173 L .50658 .28716 L 1 .938 0 r
F
P
p
.002 w
.27491 .58435 m .26421 .6 L .25473 .59682 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24455 .5982 m .25473 .59682 L .26421 .6 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.59898 .28163 m .61726 .28473 L .60601 .28706 L .814 1 0 r
F
P
p
.58774 .28398 m .59898 .28163 L .60601 .28706 L .674 1 0 r
F
P
p
.002 w
.35205 .64686 m .34161 .64807 L .33294 .63605 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.32227 .64647 m .33294 .63605 L .34161 .64807 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.69915 .28153 m .71702 .28463 L .70546 .28697 L 1 .767 0 r
F
P
p
.6876 .28389 m .69915 .28153 L .70546 .28697 L 1 .837 0 r
F
P
p
.002 w
.29363 .60952 m .30391 .60818 L .31191 .64768 L p
.047 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30391 .60818 m .29363 .60952 L .28521 .58114 L p
.527 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28521 .58114 m .29363 .60952 L p
.27509 .58458 L .463 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27491 .58435 m .28521 .58114 L p
.27509 .58458 L .463 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28521 .58114 m .27491 .58435 L .26497 .59544 L p
.617 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28521 .58114 m .29558 .57761 L .30391 .60818 L p
.527 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26497 .59544 m .27559 .58486 L .28521 .58114 L p
.617 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28521 .58114 m .27559 .58486 L p
.2954 .57767 L .686 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29558 .57761 m .28521 .58114 L p
.2954 .57767 L .686 1 0 r
F P
0 0 0 r
s
P
p
.79935 .28144 m .81681 .28454 L .80494 .28687 L 1 .349 0 r
F
P
p
.78748 .28379 m .79935 .28144 L .80494 .28687 L 1 .349 0 r
F
P
p
.002 w
.38158 .65642 m .37105 .6576 L .36297 .62729 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.002 w
.35205 .64686 m .36297 .62729 L .37105 .6576 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.88749 .49216 m .8754 .49385 L .87032 .48991 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85823 .49162 m .87032 .48991 L .8754 .49385 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.48147 .63805 m .4705 .65755 L .46268 .6364 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.002 w
.45168 .65599 m .46268 .6364 L .4705 .65755 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.16853 .28127 m .18857 .28437 L .17864 .28671 L .465 1 0 r
F
P
p
.26869 .28117 m .28833 .28427 L .27808 .28661 L .535 1 0 r
F
P
p
.25847 .28352 m .26869 .28117 L .27808 .28661 L .53 1 0 r
F
P
p
.002 w
.52196 .6372 m .51099 .64328 L .50333 .62744 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.49236 .63518 m .50333 .62744 L .51099 .64328 L p
0 1 .109 r
F P
0 0 0 r
s
P
p
.36888 .28107 m .38811 .28418 L .37755 .28651 L 1 .733 0 r
F
P
p
.35834 .28343 m .36888 .28107 L .37755 .28651 L 1 .767 0 r
F
P
p
.46909 .28098 m .48791 .28408 L .47705 .28642 L 1 .828 0 r
F
P
p
.45824 .28333 m .46909 .28098 L .47705 .28642 L 1 .872 0 r
F
P
p
.002 w
.7765 .51187 m .76505 .52248 L .75973 .5369 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.75973 .5369 m .76505 .52248 L p
.75266 .54805 L 1 .628 0 r
F P
0 0 0 r
s
P
p
.002 w
.75973 .5369 m .75265 .49677 L p
.76685 .52568 L 1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.75973 .5369 m .77159 .53532 L .7765 .51187 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.77159 .53532 m .75973 .5369 L p
.76685 .52568 L 1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.74849 .55665 m .75973 .5369 L p
.75266 .54805 L 1 .628 0 r
F P
0 0 0 r
s
P
p
.56933 .28088 m .58774 .28398 L .57657 .28632 L .709 1 0 r
F
P
p
.55817 .28323 m .56933 .28088 L .57657 .28632 L .62 1 0 r
F
P
p
.002 w
.32227 .64647 m .31191 .64768 L .30391 .60818 L p
.136 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25473 .59682 m .26497 .59544 L .27491 .58435 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49236 .63518 m .48147 .63805 L .47354 .63514 L p
0 1 .087 r
F P
0 0 0 r
s
P
p
.002 w
.46268 .6364 m .47354 .63514 L .48147 .63805 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.66959 .28078 m .6876 .28389 L .67612 .28622 L 1 .977 0 r
F
P
p
.65812 .28314 m .66959 .28078 L .67612 .28622 L .919 1 0 r
F
P
p
.76988 .28068 m .78748 .28379 L .77569 .28613 L 1 .698 0 r
F
P
p
.7581 .28304 m .76988 .28068 L .77569 .28613 L 1 .698 0 r
F
P
p
.002 w
.85823 .49162 m .84622 .49331 L .84092 .48936 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82891 .49107 m .84092 .48936 L .84622 .49331 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.8581 .28294 m .8702 .28058 L .87529 .28603 L 1 0 0 r
F
P
p
.002 w
.45168 .65599 m .44092 .65717 L .43295 .636 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.42209 .64642 m .43295 .636 L .44092 .65717 L p
0 1 .267 r
F P
0 0 0 r
s
P
p
.23869 .28042 m .25847 .28352 L .2483 .28586 L .465 1 0 r
F
P
p
.22855 .28277 m .23869 .28042 L .2483 .28586 L .465 1 0 r
F
P
p
.33897 .28032 m .35834 .28343 L .34787 .28577 L 1 .977 0 r
F
P
p
.32852 .28268 m .33897 .28032 L .34787 .28577 L .879 1 0 r
F
P
p
.002 w
.63305 .63589 m .62172 .63715 L .61409 .57025 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61409 .57025 m .62538 .56879 L .63305 .63589 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .56879 m .61409 .57025 L .6072 .57598 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59591 .57904 m .6072 .57598 L .61409 .57025 L p
.808 1 0 r
F P
0 0 0 r
s
P
p
.43928 .28022 m .45824 .28333 L .44746 .28567 L 1 .698 0 r
F
P
p
.42851 .28258 m .43928 .28022 L .44746 .28567 L 1 .698 0 r
F
P
p
.53961 .28012 m .55817 .28323 L .54707 .28557 L .934 1 0 r
F
P
p
.52853 .28248 m .53961 .28012 L .54707 .28557 L .86 1 0 r
F
P
p
.63997 .28002 m .65812 .28314 L .64672 .28548 L 1 .972 0 r
F
P
p
.62858 .28238 m .63997 .28002 L .64672 .28548 L .929 1 0 r
F
P
p
.002 w
.24455 .5982 m .23407 .60866 L .22435 .60554 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21424 .60689 m .22435 .60554 L .23407 .60866 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58473 .58797 m .57356 .58937 L .56633 .59527 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.74036 .27993 m .7581 .28304 L .74638 .28538 L 1 .698 0 r
F
P
p
.72865 .28229 m .74036 .27993 L .74638 .28538 L 1 .698 0 r
F
P
p
.002 w
.82891 .49107 m .81698 .49277 L .81147 .48881 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79954 .49053 m .81147 .48881 L .81698 .49277 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.84077 .27983 m .8581 .28294 L .84608 .28528 L 1 0 0 r
F
P
p
.82875 .28219 m .84077 .27983 L .84608 .28528 L 1 .035 0 r
F
P
p
.002 w
.42209 .64642 m .41128 .6568 L .40283 .65402 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.002 w
.39217 .65522 m .40283 .65402 L .41128 .6568 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.70098 .5577 m .70632 .519 L p
.68999 .56337 L 1 .736 0 r
F P
0 0 0 r
s
P
p
.002 w
.71262 .55264 m .71775 .51082 L p
.70175 .55555 L 1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.70098 .5577 m .71262 .55264 L p
.70175 .55555 L 1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.7294 .50918 m .73675 .55816 L p
.71881 .51346 L 1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.71775 .51082 m .7294 .50918 L p
.71881 .51346 L 1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.7294 .50918 m .74098 .50219 L .74849 .55665 L p
1 .607 0 r
F P
0 0 0 r
s
P
p
.002 w
.7294 .50918 m .7244 .55062 L p
.74006 .50487 L 1 .571 0 r
F P
0 0 0 r
s
P
p
.002 w
.74098 .50219 m .7294 .50918 L p
.74006 .50487 L 1 .571 0 r
F P
0 0 0 r
s
P
p
.002 w
.7294 .50918 m .71775 .51082 L .71262 .55264 L p
1 .626 0 r
F P
0 0 0 r
s
P
p
.002 w
.71262 .55264 m .7244 .55062 L .7294 .50918 L p
1 .626 0 r
F P
0 0 0 r
s
P
p
.002 w
.71262 .55264 m .70582 .5306 L p
.72356 .54971 L 1 .835 0 r
F P
0 0 0 r
s
P
p
.002 w
.7244 .55062 m .71262 .55264 L p
.72356 .54971 L 1 .835 0 r
F P
0 0 0 r
s
P
p
.002 w
.70098 .5577 m .69406 .53221 L p
.71203 .55199 L 1 .851 0 r
F P
0 0 0 r
s
P
p
.002 w
.71262 .55264 m .70098 .5577 L p
.71203 .55199 L 1 .851 0 r
F P
0 0 0 r
s
P
p
.002 w
.68945 .56484 m .70098 .5577 L p
.68999 .56337 L 1 .736 0 r
F P
0 0 0 r
s
P
p
.20863 .27966 m .22855 .28277 L .21847 .28512 L .465 1 0 r
F
P
p
.19857 .28202 m .20863 .27966 L .21847 .28512 L .43 1 0 r
F
P
p
.30901 .27956 m .32852 .28268 L .31813 .28502 L .645 1 0 r
F
P
p
.29863 .28192 m .30901 .27956 L .31813 .28502 L .605 1 0 r
F
P
p
.002 w
.788 .50122 m .7765 .51187 L .77159 .53532 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.40941 .27946 m .42851 .28258 L .41781 .28492 L 1 .698 0 r
F
P
p
.39872 .28183 m .40941 .27946 L .41781 .28492 L 1 .698 0 r
F
P
p
.50984 .27936 m .52853 .28248 L .51752 .28483 L 1 .808 0 r
F
P
p
.49884 .28173 m .50984 .27936 L .51752 .28483 L 1 .869 0 r
F
P
p
.6103 .27927 m .62858 .28238 L .61726 .28473 L .889 1 0 r
F
P
p
.59898 .28163 m .6103 .27927 L .61726 .28473 L .814 1 0 r
F
P
p
.002 w
.36297 .62729 m .35205 .64686 L .34364 .62559 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.002 w
.33294 .63605 m .34364 .62559 L .35205 .64686 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.33294 .63605 m .32227 .64647 L .31497 .58339 L p
.276 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31497 .58339 m .32546 .57807 L .33294 .63605 L p
.276 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30391 .60818 m .31497 .58339 L .32227 .64647 L p
.136 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32546 .57807 m .31497 .58339 L .30623 .56703 L p
.834 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31497 .58339 m .30391 .60818 L .29558 .57761 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29558 .57761 m .30623 .56703 L .31497 .58339 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53299 .63594 m .52196 .6372 L .51433 .62615 L p
0 1 .027 r
F P
0 0 0 r
s
P
p
.002 w
.50333 .62744 m .51433 .62615 L .52196 .6372 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.71078 .27917 m .72865 .28229 L .71702 .28463 L 1 .767 0 r
F
P
p
.69915 .28153 m .71078 .27917 L .71702 .28463 L 1 .767 0 r
F
P
p
.81129 .27907 m .82875 .28219 L .81681 .28454 L 1 .349 0 r
F
P
p
.79935 .28144 m .81129 .27907 L .81681 .28454 L 1 .349 0 r
F
P
p
.002 w
.39217 .65522 m .38158 .65642 L .37351 .626 L p
0 1 .142 r
F P
0 0 0 r
s
P
p
.002 w
.36297 .62729 m .37351 .626 L .38158 .65642 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.002 w
.89966 .49046 m .88749 .49216 L .88248 .48819 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87032 .48991 m .88248 .48819 L .88749 .49216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.17851 .2789 m .19857 .28202 L .18857 .28437 L .535 1 0 r
F
P
p
.16853 .28127 m .17851 .2789 L .18857 .28437 L .465 1 0 r
F
P
p
.27898 .2788 m .29863 .28192 L .28833 .28427 L .57 1 0 r
F
P
p
.26869 .28117 m .27898 .2788 L .28833 .28427 L .535 1 0 r
F
P
p
.002 w
.37351 .626 m .36297 .62729 L .3543 .61888 L p
.088 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34364 .62559 m .3543 .61888 L .36297 .62729 L p
0 1 .003 r
F P
0 0 0 r
s
P
p
.37948 .2787 m .39872 .28183 L .38811 .28418 L 1 .698 0 r
F
P
p
.36888 .28107 m .37948 .2787 L .38811 .28418 L 1 .733 0 r
F
P
p
.002 w
.50333 .62744 m .49236 .63518 L .48448 .63387 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.002 w
.47354 .63514 m .48448 .63387 L .49236 .63518 L p
0 1 .087 r
F P
0 0 0 r
s
P
p
.48001 .27861 m .49884 .28173 L .48791 .28408 L 1 .808 0 r
F
P
p
.46909 .28098 m .48001 .27861 L .48791 .28408 L 1 .828 0 r
F
P
p
.002 w
.25473 .59682 m .24455 .5982 L .23489 .595 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22435 .60554 m .23489 .595 L .24455 .5982 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.58056 .27851 m .59898 .28163 L .58774 .28398 L .779 1 0 r
F
P
p
.56933 .28088 m .58056 .27851 L .58774 .28398 L .709 1 0 r
F
P
p
.68114 .27841 m .69915 .28153 L .6876 .28389 L 1 .872 0 r
F
P
p
.66959 .28078 m .68114 .27841 L .6876 .28389 L 1 .977 0 r
F
P
p
.002 w
.43295 .636 m .42209 .64642 L .41371 .64356 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.40283 .65402 m .41371 .64356 L .42209 .64642 L p
0 1 .302 r
F P
0 0 0 r
s
P
p
.78174 .27831 m .79935 .28144 L .78748 .28379 L 1 .633 0 r
F
P
p
.76988 .28068 m .78174 .27831 L .78748 .28379 L 1 .698 0 r
F
P
p
.002 w
.87032 .48991 m .85823 .49162 L .853 .48764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84092 .48936 m .853 .48764 L .85823 .49162 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64392 .59797 m .63305 .63589 L .62538 .56879 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62538 .56879 m .6367 .56349 L .64392 .59797 L p
.55 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46268 .6364 m .45168 .65599 L .44373 .63474 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.002 w
.43295 .636 m .44373 .63474 L .45168 .65599 L p
0 1 .233 r
F P
0 0 0 r
s
P
p
.002 w
.79954 .49053 m .788 .50122 L .78351 .53374 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.77159 .53532 m .78351 .53374 L .788 .50122 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.2489 .27804 m .26869 .28117 L .25847 .28352 L .465 1 0 r
F
P
p
.23869 .28042 m .2489 .27804 L .25847 .28352 L .465 1 0 r
F
P
p
.34949 .27794 m .36888 .28107 L .35834 .28343 L 1 .888 0 r
F
P
p
.33897 .28032 m .34949 .27794 L .35834 .28343 L 1 .977 0 r
F
P
p
.002 w
.6367 .56349 m .62538 .56879 L .61847 .56537 L p
.898 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6072 .57598 m .61847 .56537 L .62538 .56879 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.45011 .27785 m .46909 .28098 L .45824 .28333 L 1 .698 0 r
F
P
p
.43928 .28022 m .45011 .27785 L .45824 .28333 L 1 .698 0 r
F
P
p
.55076 .27775 m .56933 .28088 L .55817 .28323 L .978 1 0 r
F
P
p
.53961 .28012 m .55076 .27775 L .55817 .28323 L .934 1 0 r
F
P
p
.002 w
.47354 .63514 m .46268 .6364 L .45458 .63347 L p
0 1 .087 r
F P
0 0 0 r
s
P
p
.002 w
.44373 .63474 m .45458 .63347 L .46268 .6364 L p
0 1 .163 r
F P
0 0 0 r
s
P
p
.65144 .27765 m .66959 .28078 L .65812 .28314 L 1 .872 0 r
F
P
p
.63997 .28002 m .65144 .27765 L .65812 .28314 L 1 .972 0 r
F
P
p
.002 w
.56633 .59527 m .57752 .58469 L .58473 .58797 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.75214 .27755 m .76988 .28068 L .7581 .28304 L 1 .698 0 r
F
P
p
.74036 .27993 m .75214 .27755 L .7581 .28304 L 1 .698 0 r
F
P
p
.002 w
.84092 .48936 m .82891 .49107 L .82347 .48709 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81147 .48881 m .82347 .48709 L .82891 .49107 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.85287 .27745 m .8702 .28058 L .8581 .28294 L 1 0 0 r
F
P
p
.84077 .27983 m .85287 .27745 L .8581 .28294 L 1 0 0 r
F
P
p
.21875 .27728 m .23869 .28042 L .22855 .28277 L .465 1 0 r
F
P
p
.20863 .27966 m .21875 .27728 L .22855 .28277 L .465 1 0 r
F
P
p
.002 w
.34364 .62559 m .33294 .63605 L .32546 .57807 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32546 .57807 m .33591 .57663 L .34364 .62559 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33591 .57663 m .32546 .57807 L .31692 .55642 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30623 .56703 m .31692 .55642 L .32546 .57807 L p
.834 1 0 r
F P
0 0 0 r
s
P
p
.31944 .27718 m .33897 .28032 L .32852 .28268 L .756 1 0 r
F
P
p
.30901 .27956 m .31944 .27718 L .32852 .28268 L .645 1 0 r
F
P
p
.42016 .27708 m .43928 .28022 L .42851 .28258 L 1 .698 0 r
F
P
p
.40941 .27946 m .42016 .27708 L .42851 .28258 L 1 .698 0 r
F
P
p
.52091 .27698 m .53961 .28012 L .52853 .28248 L 1 .747 0 r
F
P
p
.50984 .27936 m .52091 .27698 L .52853 .28248 L 1 .808 0 r
F
P
p
.002 w
.44373 .63474 m .43295 .636 L .42449 .64232 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.41371 .64356 m .42449 .64232 L .43295 .636 L p
0 1 .198 r
F P
0 0 0 r
s
P
p
.002 w
.51433 .62615 m .50333 .62744 L .49549 .63097 L p
.005 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48448 .63387 m .49549 .63097 L .50333 .62744 L p
0 1 .05 r
F P
0 0 0 r
s
P
p
.62168 .27689 m .63997 .28002 L .62858 .28238 L .929 1 0 r
F
P
p
.6103 .27927 m .62168 .27689 L .62858 .28238 L .889 1 0 r
F
P
p
.002 w
.22435 .60554 m .21424 .60689 L .20434 .60375 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54407 .62549 m .53299 .63594 L .52541 .62377 L p
.012 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51433 .62615 m .52541 .62377 L .53299 .63594 L p
0 1 .027 r
F P
0 0 0 r
s
P
p
.72248 .27679 m .74036 .27993 L .72865 .28229 L 1 .767 0 r
F
P
p
.71078 .27917 m .72248 .27679 L .72865 .28229 L 1 .767 0 r
F
P
p
.002 w
.6665 .57691 m .65519 .58746 L .64813 .562 L p
.829 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6367 .56349 m .64813 .562 L .65519 .58746 L p
.739 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81147 .48881 m .79954 .49053 L .79486 .51383 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.79486 .51383 m .79954 .49053 L p
.78755 .52285 L 1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.79486 .51383 m .8069 .51217 L .81147 .48881 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.79486 .51383 m .78813 .48249 L p
.80221 .50475 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.8069 .51217 m .79486 .51383 L p
.80221 .50475 L 1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.78351 .53374 m .79486 .51383 L p
.78755 .52285 L 1 .314 0 r
F P
0 0 0 r
s
P
p
.8233 .27669 m .84077 .27983 L .82875 .28219 L 1 .279 0 r
F
P
p
.81129 .27907 m .8233 .27669 L .82875 .28219 L 1 .349 0 r
F
P
p
.002 w
.40283 .65402 m .39217 .65522 L .38423 .6193 L p
0 1 .122 r
F P
0 0 0 r
s
P
p
.002 w
.37351 .626 m .38423 .6193 L .39217 .65522 L p
0 1 .142 r
F P
0 0 0 r
s
P
p
.002 w
.88248 .48819 m .89472 .48646 L .89966 .49046 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.18854 .27652 m .20863 .27966 L .19857 .28202 L .64 1 0 r
F
P
p
.17851 .2789 m .18854 .27652 L .19857 .28202 L .535 1 0 r
F
P
p
.002 w
.30623 .56703 m .29558 .57761 L .28613 .57818 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27559 .58486 m .28613 .57818 L .29558 .57761 L p
.686 1 0 r
F P
0 0 0 r
s
P
p
.28933 .27642 m .30901 .27956 L .29863 .28192 L .605 1 0 r
F
P
p
.27898 .2788 m .28933 .27642 L .29863 .28192 L .57 1 0 r
F
P
p
.002 w
.38423 .6193 m .37351 .626 L .36488 .61756 L p
.108 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3543 .61888 m .36488 .61756 L .37351 .626 L p
.088 1 0 r
F P
0 0 0 r
s
P
p
.39015 .27632 m .40941 .27946 L .39872 .28183 L 1 .698 0 r
F
P
p
.37948 .2787 m .39015 .27632 L .39872 .28183 L 1 .698 0 r
F
P
p
.49099 .27622 m .50984 .27936 L .49884 .28173 L 1 .747 0 r
F
P
p
.48001 .27861 m .49099 .27622 L .49884 .28173 L 1 .808 0 r
F
P
p
.002 w
.26497 .59544 m .25473 .59682 L .24511 .5936 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23489 .595 m .24511 .5936 L .25473 .59682 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.59186 .27612 m .6103 .27927 L .59898 .28163 L .849 1 0 r
F
P
p
.58056 .27851 m .59186 .27612 L .59898 .28163 L .779 1 0 r
F
P
p
.002 w
.57752 .58469 m .58882 .58326 L .59591 .57904 L p
.633 1 0 r
F P
0 0 0 r
s
P
p
.69276 .27602 m .71078 .27917 L .69915 .28153 L 1 .802 0 r
F
P
p
.68114 .27841 m .69276 .27602 L .69915 .28153 L 1 .872 0 r
F
P
p
.002 w
.64813 .562 m .6367 .56349 L .6299 .56388 L p
.928 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6299 .56388 m .6367 .56349 L p
.62617 .56458 L .898 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .55851 m .64813 .562 L p
.63265 .5636 L .928 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6299 .56388 m .64134 .55851 L p
.63265 .5636 L .928 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65954 .5552 m .64813 .562 L .64134 .55851 L p
.983 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .55851 m .65282 .55166 L .65954 .5552 L p
.983 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .55851 m .63457 .56324 L p
.65009 .55339 L .917 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65282 .55166 m .64134 .55851 L p
.65009 .55339 L .917 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61847 .56537 m .6299 .56388 L p
.62617 .56458 L .898 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6299 .56388 m .61847 .56537 L .61165 .58037 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62306 .56964 m .6299 .56388 L p
.62627 .56716 L .779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61165 .58037 m .62306 .56964 L p
.62627 .56716 L .779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58882 .58326 m .6002 .58182 L .6072 .57598 L p
.668 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61847 .56537 m .6072 .57598 L .6002 .58182 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6002 .58182 m .61165 .58037 L .61847 .56537 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62306 .56964 m .61165 .58037 L .60451 .57698 L p
.644 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62306 .56964 m .61608 .5744 L p
.6198 .57216 L .732 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63457 .56324 m .62306 .56964 L p
.6198 .57216 L .732 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6299 .56388 m .62306 .56964 L p
.63367 .56318 L .847 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64134 .55851 m .6299 .56388 L p
.63367 .56318 L .847 1 0 r
F P
0 0 0 r
s
P
p
.79368 .27592 m .81129 .27907 L .79935 .28144 L 1 .494 0 r
F
P
p
.78174 .27831 m .79368 .27592 L .79935 .28144 L 1 .633 0 r
F
P
p
.002 w
.88248 .48819 m .87032 .48991 L .86516 .48591 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.853 .48764 m .86516 .48591 L .87032 .48991 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.15828 .27575 m .17851 .2789 L .16853 .28127 L .535 1 0 r
F
P
p
.25917 .27565 m .27898 .2788 L .26869 .28117 L .5 1 0 r
F
P
p
.2489 .27804 m .25917 .27565 L .26869 .28117 L .465 1 0 r
F
P
p
.002 w
.3543 .61888 m .34364 .62559 L .33591 .57663 L p
.416 1 0 r
F P
0 0 0 r
s
P
p
.36008 .27556 m .37948 .2787 L .36888 .28107 L 1 .818 0 r
F
P
p
.34949 .27794 m .36008 .27556 L .36888 .28107 L 1 .888 0 r
F
P
p
.46102 .27546 m .48001 .27861 L .46909 .28098 L 1 .698 0 r
F
P
p
.45011 .27785 m .46102 .27546 L .46909 .28098 L 1 .698 0 r
F
P
p
.002 w
.52541 .62377 m .53654 .62247 L .54407 .62549 L p
.012 1 0 r
F P
0 0 0 r
s
P
p
.56198 .27536 m .58056 .27851 L .56933 .28088 L 1 .942 0 r
F
P
p
.55076 .27775 m .56198 .27536 L .56933 .28088 L .978 1 0 r
F
P
p
.002 w
.67785 .56632 m .6665 .57691 L .65954 .5552 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64813 .562 m .65954 .5552 L .6665 .57691 L p
.829 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48448 .63387 m .47354 .63514 L .46552 .63056 L p
0 1 .056 r
F P
0 0 0 r
s
P
p
.002 w
.45458 .63347 m .46552 .63056 L .47354 .63514 L p
0 1 .087 r
F P
0 0 0 r
s
P
p
.66297 .27526 m .68114 .27841 L .66959 .28078 L 1 .802 0 r
F
P
p
.65144 .27765 m .66297 .27526 L .66959 .28078 L 1 .872 0 r
F
P
p
.76399 .27516 m .78174 .27831 L .76988 .28068 L 1 .698 0 r
F
P
p
.75214 .27755 m .76399 .27516 L .76988 .28068 L 1 .698 0 r
F
P
p
.002 w
.853 .48764 m .84092 .48936 L .83555 .48535 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82347 .48709 m .83555 .48535 L .84092 .48936 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31692 .55642 m .30623 .56703 L .2968 .56884 L p
.899 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28613 .57818 m .2968 .56884 L .30623 .56703 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.85287 .27745 m .86504 .27506 L .8702 .28058 L 1 0 0 r
F
P
p
.002 w
.53654 .62247 m .54774 .6157 L p
.54434 .6155 L .137 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54774 .6157 m .53654 .62247 L .52891 .61941 L p
.067 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54774 .6157 m .54017 .61807 L p
.55119 .6159 L .102 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55902 .61436 m .54774 .6157 L p
.55119 .6159 L .102 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54774 .6157 m .55517 .60581 L p
.54434 .6155 L .137 1 0 r
F P
0 0 0 r
s
P
p
.22894 .27489 m .2489 .27804 L .23869 .28042 L .5 1 0 r
F
P
p
.21875 .27728 m .22894 .27489 L .23869 .28042 L .465 1 0 r
F
P
p
.002 w
.33591 .57663 m .34642 .57518 L .3543 .61888 L p
.416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34642 .57518 m .33591 .57663 L .32738 .55491 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31692 .55642 m .32738 .55491 L .33591 .57663 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.32995 .27479 m .34949 .27794 L .33897 .28032 L .871 1 0 r
F
P
p
.31944 .27718 m .32995 .27479 L .33897 .28032 L .756 1 0 r
F
P
p
.43098 .27469 m .45011 .27785 L .43928 .28022 L 1 .698 0 r
F
P
p
.42016 .27708 m .43098 .27469 L .43928 .28022 L 1 .698 0 r
F
P
p
.53204 .27459 m .55076 .27775 L .53961 .28012 L 1 .698 0 r
F
P
p
.52091 .27698 m .53204 .27459 L .53961 .28012 L 1 .747 0 r
F
P
p
.002 w
.45458 .63347 m .44373 .63474 L .43547 .63178 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.42449 .64232 m .43547 .63178 L .44373 .63474 L p
0 1 .128 r
F P
0 0 0 r
s
P
p
.002 w
.38423 .6193 m .3949 .61799 L .40283 .65402 L p
0 1 .122 r
F P
0 0 0 r
s
P
p
.002 w
.3949 .61799 m .38423 .6193 L .37553 .61624 L p
.178 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36488 .61756 m .37553 .61624 L .38423 .6193 L p
.108 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52541 .62377 m .51433 .62615 L .50658 .62314 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49549 .63097 m .50658 .62314 L .51433 .62615 L p
.005 1 0 r
F P
0 0 0 r
s
P
p
.63313 .27449 m .65144 .27765 L .63997 .28002 L 1 .972 0 r
F
P
p
.62168 .27689 m .63313 .27449 L .63997 .28002 L .929 1 0 r
F
P
p
.002 w
.23489 .595 m .22435 .60554 L .21448 .60238 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20434 .60375 m .21448 .60238 L .22435 .60554 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.73425 .27439 m .75214 .27755 L .74036 .27993 L 1 .733 0 r
F
P
p
.72248 .27679 m .73425 .27439 L .74036 .27993 L 1 .767 0 r
F
P
p
.002 w
.82347 .48709 m .81147 .48881 L .8069 .51217 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.83539 .27429 m .85287 .27745 L .84077 .27983 L 1 .105 0 r
F
P
p
.8233 .27669 m .83539 .27429 L .84077 .27983 L 1 .279 0 r
F
P
p
.002 w
.41371 .64356 m .40283 .65402 L .3949 .61799 L p
0 1 .038 r
F P
0 0 0 r
s
P
p
.19865 .27412 m .21875 .27728 L .20863 .27966 L .779 1 0 r
F
P
p
.18854 .27652 m .19865 .27412 L .20863 .27966 L .64 1 0 r
F
P
p
.29975 .27402 m .31944 .27718 L .30901 .27956 L .625 1 0 r
F
P
p
.28933 .27642 m .29975 .27402 L .30901 .27956 L .605 1 0 r
F
P
p
.002 w
.75973 .5369 m .74849 .55665 L .74098 .50219 L p
1 .503 0 r
F P
0 0 0 r
s
P
p
.40089 .27392 m .42016 .27708 L .40941 .27946 L 1 .698 0 r
F
P
p
.39015 .27632 m .40089 .27392 L .40941 .27946 L 1 .698 0 r
F
P
p
.002 w
.65954 .5552 m .67094 .54452 L .67785 .56632 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.50205 .27382 m .52091 .27698 L .50984 .27936 L 1 .698 0 r
F
P
p
.49099 .27622 m .50205 .27382 L .50984 .27936 L 1 .747 0 r
F
P
p
.002 w
.74098 .50219 m .75265 .49677 L .75973 .5369 L p
1 .503 0 r
F P
0 0 0 r
s
P
p
.002 w
.75265 .49677 m .74098 .50219 L .73603 .54032 L p
1 .468 0 r
F P
0 0 0 r
s
P
p
.002 w
.7244 .55062 m .73603 .54032 L .74098 .50219 L p
1 .571 0 r
F P
0 0 0 r
s
P
p
.002 w
.27559 .58486 m .26497 .59544 L .25574 .58298 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24511 .5936 m .25574 .58298 L .26497 .59544 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36488 .61756 m .3543 .61888 L .34642 .57518 L p
.471 1 0 r
F P
0 0 0 r
s
P
p
.60323 .27372 m .62168 .27689 L .6103 .27927 L .892 1 0 r
F
P
p
.59186 .27612 m .60323 .27372 L .6103 .27927 L .849 1 0 r
F
P
p
.002 w
.30743 .56209 m .31692 .55642 L p
.30689 .56261 L .899 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2968 .56884 m .30743 .56209 L p
.30689 .56261 L .899 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32738 .55491 m .31692 .55642 L .30743 .56209 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30743 .56209 m .31823 .55136 L .32738 .55491 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30743 .56209 m .29765 .57184 L p
.30798 .56156 L .869 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31823 .55136 m .30743 .56209 L p
.30798 .56156 L .869 1 0 r
F P
0 0 0 r
s
P
p
.70445 .27362 m .72248 .27679 L .71078 .27917 L 1 .767 0 r
F
P
p
.69276 .27602 m .70445 .27362 L .71078 .27917 L 1 .802 0 r
F
P
p
.80568 .27352 m .8233 .27669 L .81129 .27907 L 1 .419 0 r
F
P
p
.79368 .27592 m .80568 .27352 L .81129 .27907 L 1 .494 0 r
F
P
p
.002 w
.57752 .58469 m .56633 .59527 L .55902 .61436 L p
.346 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54774 .6157 m .55902 .61436 L .56633 .59527 L p
.262 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.89472 .48646 m .88248 .48819 L .8774 .48417 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86516 .48591 m .8774 .48417 L .88248 .48819 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.16829 .27335 m .18854 .27652 L .17851 .2789 L .605 1 0 r
F
P
p
.15828 .27575 m .16829 .27335 L .17851 .2789 L .535 1 0 r
F
P
p
.2695 .27325 m .28933 .27642 L .27898 .2788 L .57 1 0 r
F
P
p
.25917 .27565 m .2695 .27325 L .27898 .2788 L .5 1 0 r
F
P
p
.37073 .27315 m .39015 .27632 L .37948 .2787 L 1 .733 0 r
F
P
p
.36008 .27556 m .37073 .27315 L .37948 .2787 L 1 .818 0 r
F
P
p
.47199 .27305 m .49099 .27622 L .48001 .27861 L 1 .698 0 r
F
P
p
.46102 .27546 m .47199 .27305 L .48001 .27861 L 1 .698 0 r
F
P
p
.002 w
.24511 .5936 m .23489 .595 L .22469 .601 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21448 .60238 m .22469 .601 L .23489 .595 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.57327 .27295 m .59186 .27612 L .58056 .27851 L 1 .907 0 r
F
P
p
.56198 .27536 m .57327 .27295 L .58056 .27851 L 1 .942 0 r
F
P
p
.002 w
.49549 .63097 m .48448 .63387 L .47655 .62272 L p
0 1 .021 r
F P
0 0 0 r
s
P
p
.002 w
.46552 .63056 m .47655 .62272 L .48448 .63387 L p
0 1 .056 r
F P
0 0 0 r
s
P
p
.67458 .27285 m .69276 .27602 L .68114 .27841 L 1 .767 0 r
F
P
p
.66297 .27526 m .67458 .27285 L .68114 .27841 L 1 .802 0 r
F
P
p
.002 w
.42449 .64232 m .41371 .64356 L .40586 .60363 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3949 .61799 m .40586 .60363 L .41371 .64356 L p
0 1 .038 r
F P
0 0 0 r
s
P
p
.77592 .27275 m .79368 .27592 L .78174 .27831 L 1 .633 0 r
F
P
p
.76399 .27516 m .77592 .27275 L .78174 .27831 L 1 .698 0 r
F
P
p
.002 w
.86516 .48591 m .853 .48764 L .8477 .48361 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83555 .48535 m .8477 .48361 L .853 .48764 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.23919 .27248 m .25917 .27565 L .2489 .27804 L .674 1 0 r
F
P
p
.22894 .27489 m .23919 .27248 L .2489 .27804 L .5 1 0 r
F
P
p
.002 w
.34642 .57518 m .35722 .56454 L .36488 .61756 L p
.471 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35722 .56454 m .34642 .57518 L .33792 .55338 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32738 .55491 m .33792 .55338 L .34642 .57518 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.34051 .27238 m .36008 .27556 L .34949 .27794 L .932 1 0 r
F
P
p
.32995 .27479 m .34051 .27238 L .34949 .27794 L .871 1 0 r
F
P
p
.002 w
.28613 .57818 m .27559 .58486 L .26608 .58154 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25574 .58298 m .26608 .58154 L .27559 .58486 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.44187 .27228 m .46102 .27546 L .45011 .27785 L 1 .698 0 r
F
P
p
.43098 .27469 m .44187 .27228 L .45011 .27785 L 1 .698 0 r
F
P
p
.002 w
.53654 .62247 m .52541 .62377 L .51771 .62182 L p
.042 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50658 .62314 m .51771 .62182 L .52541 .62377 L p
.034 1 0 r
F P
0 0 0 r
s
P
p
.54325 .27218 m .56198 .27536 L .55076 .27775 L 1 .698 0 r
F
P
p
.53204 .27459 m .54325 .27218 L .55076 .27775 L 1 .698 0 r
F
P
p
.002 w
.46552 .63056 m .45458 .63347 L .44637 .6305 L p
0 1 .052 r
F P
0 0 0 r
s
P
p
.002 w
.43547 .63178 m .44637 .6305 L .45458 .63347 L p
0 1 .093 r
F P
0 0 0 r
s
P
p
.002 w
.40586 .60363 m .3949 .61799 L .38651 .60182 L p
.276 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37553 .61624 m .38651 .60182 L .3949 .61799 L p
.178 1 0 r
F P
0 0 0 r
s
P
p
.64466 .27208 m .66297 .27526 L .65144 .27765 L 1 .851 0 r
F
P
p
.63313 .27449 m .64466 .27208 L .65144 .27765 L 1 .972 0 r
F
P
p
.002 w
.58882 .58326 m .57752 .58469 L .57034 .60918 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55902 .61436 m .57034 .60918 L .57752 .58469 L p
.346 1 0 r
F P
0 0 0 r
s
P
p
.74609 .27198 m .76399 .27516 L .75214 .27755 L 1 .698 0 r
F
P
p
.73425 .27439 m .74609 .27198 L .75214 .27755 L 1 .733 0 r
F
P
p
.002 w
.83555 .48535 m .82347 .48709 L .81893 .508 L p
1 .144 0 r
F P
0 0 0 r
s
P
p
.002 w
.8069 .51217 m .81893 .508 L .82347 .48709 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.84756 .27188 m .86504 .27506 L .85287 .27745 L 1 0 0 r
F
P
p
.83539 .27429 m .84756 .27188 L .85287 .27745 L 1 .105 0 r
F
P
p
.002 w
.76444 .49279 m .77159 .53532 L p
.7537 .49891 L 1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.78351 .53374 m .77159 .53532 L .76444 .49279 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .49279 m .77614 .48424 L .78351 .53374 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .49279 m .75968 .52788 L p
.77523 .48664 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.77614 .48424 m .76444 .49279 L p
.77523 .48664 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.75265 .49677 m .76444 .49279 L p
.7537 .49891 L 1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .49279 m .75265 .49677 L .74769 .52951 L p
1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.74769 .52951 m .75265 .49677 L p
.73938 .53154 L 1 .468 0 r
F P
0 0 0 r
s
P
p
.002 w
.74769 .52951 m .75968 .52788 L .76444 .49279 L p
1 .41 0 r
F P
0 0 0 r
s
P
p
.002 w
.74769 .52951 m .74154 .52573 L p
.75606 .52745 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75968 .52788 m .74769 .52951 L p
.75606 .52745 L 1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.73603 .54032 m .74769 .52951 L p
.73938 .53154 L 1 .468 0 r
F P
0 0 0 r
s
P
p
.20881 .27171 m .22894 .27489 L .21875 .27728 L .814 1 0 r
F
P
p
.19865 .27412 m .20881 .27171 L .21875 .27728 L .779 1 0 r
F
P
p
.002 w
.67094 .54452 m .65954 .5552 L .65282 .55166 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.31024 .27161 m .32995 .27479 L .31944 .27718 L .666 1 0 r
F
P
p
.29975 .27402 m .31024 .27161 L .31944 .27718 L .625 1 0 r
F
P
p
.41169 .27151 m .43098 .27469 L .42016 .27708 L 1 .698 0 r
F
P
p
.40089 .27392 m .41169 .27151 L .42016 .27708 L 1 .698 0 r
F
P
p
.002 w
.70098 .5577 m .68945 .56484 L .68256 .54297 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.67094 .54452 m .68256 .54297 L p
.67557 .54961 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.68256 .54297 m .67094 .54452 L .66445 .55012 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.66445 .55012 m .67616 .54856 L .68256 .54297 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.68256 .54297 m .67616 .54856 L p
.68961 .53628 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.69406 .53221 m .68256 .54297 L p
.68961 .53628 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.68256 .54297 m .68945 .56484 L p
.67557 .54961 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.51317 .27141 m .53204 .27459 L .52091 .27698 L 1 .698 0 r
F
P
p
.50205 .27382 m .51317 .27141 L .52091 .27698 L 1 .698 0 r
F
P
p
.002 w
.37553 .61624 m .36488 .61756 L .35722 .56454 L p
.541 1 0 r
F P
0 0 0 r
s
P
p
.61468 .27131 m .63313 .27449 L .62168 .27689 L .948 1 0 r
F
P
p
.60323 .27372 m .61468 .27131 L .62168 .27689 L .892 1 0 r
F
P
p
.002 w
.21448 .60238 m .20434 .60375 L .19429 .60056 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33792 .55338 m .32738 .55491 L .31823 .55136 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.71621 .27121 m .73425 .27439 L .72248 .27679 L 1 .767 0 r
F
P
p
.70445 .27362 m .71621 .27121 L .72248 .27679 L 1 .767 0 r
F
P
p
.81777 .27111 m .83539 .27429 L .8233 .27669 L 1 .314 0 r
F
P
p
.80568 .27352 m .81777 .27111 L .8233 .27669 L 1 .419 0 r
F
P
p
.002 w
.40586 .60363 m .41678 .59304 L .42449 .64232 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41678 .59304 m .40586 .60363 L .39727 .60044 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38651 .60182 m .39727 .60044 L .40586 .60363 L p
.276 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8774 .48417 m .88971 .48241 L .89472 .48646 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35722 .56454 m .36806 .55387 L .37553 .61624 L p
.541 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36806 .55387 m .35722 .56454 L .34875 .54266 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.33792 .55338 m .34875 .54266 L .35722 .56454 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.17837 .27093 m .19865 .27412 L .18854 .27652 L .814 1 0 r
F
P
p
.16829 .27335 m .17837 .27093 L .18854 .27652 L .605 1 0 r
F
P
p
.2799 .27083 m .29975 .27402 L .28933 .27642 L .625 1 0 r
F
P
p
.2695 .27325 m .2799 .27083 L .28933 .27642 L .57 1 0 r
F
P
p
.38145 .27073 m .40089 .27392 L .39015 .27632 L 1 .698 0 r
F
P
p
.37073 .27315 m .38145 .27073 L .39015 .27632 L 1 .733 0 r
F
P
p
.002 w
.50658 .62314 m .49549 .63097 L .48761 .62031 L p
.028 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47655 .62272 m .48761 .62031 L .49549 .63097 L p
0 1 .021 r
F P
0 0 0 r
s
P
p
.48303 .27063 m .50205 .27382 L .49099 .27622 L 1 .698 0 r
F
P
p
.47199 .27305 m .48303 .27063 L .49099 .27622 L 1 .698 0 r
F
P
p
.002 w
.25574 .58298 m .24511 .5936 L .23535 .59033 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22469 .601 m .23535 .59033 L .24511 .5936 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.58463 .27053 m .60323 .27372 L .59186 .27612 L 1 .872 0 r
F
P
p
.57327 .27295 m .58463 .27053 L .59186 .27612 L 1 .907 0 r
F
P
p
.002 w
.26608 .58154 m .27648 .58009 L .28613 .57818 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2968 .56884 m .28613 .57818 L .27648 .58009 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.68626 .27043 m .70445 .27362 L .69276 .27602 L 1 .733 0 r
F
P
p
.67458 .27285 m .68626 .27043 L .69276 .27602 L 1 .767 0 r
F
P
p
.002 w
.43547 .63178 m .42449 .64232 L .41678 .59304 L p
.176 1 0 r
F P
0 0 0 r
s
P
p
.78792 .27033 m .80568 .27352 L .79368 .27592 L 1 .459 0 r
F
P
p
.77592 .27275 m .78792 .27033 L .79368 .27592 L 1 .633 0 r
F
P
p
.002 w
.8774 .48417 m .86516 .48591 L .85993 .48185 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8477 .48361 m .85993 .48185 L .86516 .48591 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65282 .55166 m .66445 .55012 L .67094 .54452 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.14788 .27016 m .16829 .27335 L .15828 .27575 L .5 1 0 r
F
P
p
.2495 .27006 m .2695 .27325 L .25917 .27565 L .849 1 0 r
F
P
p
.23919 .27248 m .2495 .27006 L .25917 .27565 L .674 1 0 r
F
P
p
.35115 .26996 m .37073 .27315 L .36008 .27556 L .987 1 0 r
F
P
p
.34051 .27238 m .35115 .26996 L .36008 .27556 L .932 1 0 r
F
P
p
.002 w
.47655 .62272 m .46552 .63056 L .45744 .61989 L p
.014 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44637 .6305 m .45744 .61989 L .46552 .63056 L p
0 1 .052 r
F P
0 0 0 r
s
P
p
.45283 .26986 m .47199 .27305 L .46102 .27546 L 1 .698 0 r
F
P
p
.44187 .27228 m .45283 .26986 L .46102 .27546 L 1 .698 0 r
F
P
p
.002 w
.51771 .62182 m .52891 .61941 L .53654 .62247 L p
.042 1 0 r
F P
0 0 0 r
s
P
p
.55453 .26975 m .57327 .27295 L .56198 .27536 L 1 .698 0 r
F
P
p
.54325 .27218 m .55453 .26975 L .56198 .27536 L 1 .698 0 r
F
P
p
.002 w
.68256 .54297 m .69406 .53221 L .70098 .5577 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.65626 .26965 m .67458 .27285 L .66297 .27526 L 1 .747 0 r
F
P
p
.64466 .27208 m .65626 .26965 L .66297 .27526 L 1 .851 0 r
F
P
p
.002 w
.41678 .59304 m .42772 .58503 L .43547 .63178 L p
.176 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42772 .58503 m .41678 .59304 L .40852 .57521 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39727 .60044 m .40852 .57521 L .41678 .59304 L p
.45 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57034 .60918 m .58163 .58919 L .58882 .58326 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6002 .58182 m .58882 .58326 L .58163 .58919 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38651 .60182 m .37553 .61624 L .36806 .55387 L p
.634 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.36806 .55387 m .37879 .55004 L .38651 .60182 L p
.634 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37879 .55004 m .36806 .55387 L .35962 .5319 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.34875 .54266 m .35962 .5319 L .36806 .55387 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.75802 .26955 m .77592 .27275 L .76399 .27516 L 1 .698 0 r
F
P
p
.74609 .27198 m .75802 .26955 L .76399 .27516 L 1 .698 0 r
F
P
p
.002 w
.8477 .48361 m .83555 .48535 L .83062 .49422 L p
1 .084 0 r
F P
0 0 0 r
s
P
p
.002 w
.83062 .49422 m .83555 .48535 L p
.82298 .50248 L 1 .144 0 r
F P
0 0 0 r
s
P
p
.002 w
.83062 .49422 m .82456 .47716 L p
.83832 .48591 L 1 .084 0 r
F P
0 0 0 r
s
P
p
.002 w
.83062 .49422 m .84271 .4887 L .8477 .48361 L p
1 .084 0 r
F P
0 0 0 r
s
P
p
.002 w
.84271 .4887 m .83062 .49422 L p
.83832 .48591 L 1 .084 0 r
F P
0 0 0 r
s
P
p
.002 w
.81893 .508 m .83062 .49422 L p
.82298 .50248 L 1 .144 0 r
F P
0 0 0 r
s
P
p
.84756 .27188 m .8598 .26945 L .86504 .27506 L 1 0 0 r
F
P
p
.21904 .26928 m .23919 .27248 L .22894 .27489 L .884 1 0 r
F
P
p
.20881 .27171 m .21904 .26928 L .22894 .27489 L .814 1 0 r
F
P
p
.32079 .26918 m .34051 .27238 L .32995 .27479 L .716 1 0 r
F
P
p
.31024 .27161 m .32079 .26918 L .32995 .27479 L .666 1 0 r
F
P
p
.002 w
.26608 .58154 m .25574 .58298 L .24567 .58891 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23535 .59033 m .24567 .58891 L .25574 .58298 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.42256 .26908 m .44187 .27228 L .43098 .27469 L 1 .698 0 r
F
P
p
.41169 .27151 m .42256 .26908 L .43098 .27469 L 1 .698 0 r
F
P
p
.52436 .26898 m .54325 .27218 L .53204 .27459 L 1 .698 0 r
F
P
p
.51317 .27141 m .52436 .26898 L .53204 .27459 L 1 .698 0 r
F
P
p
.002 w
.44637 .6305 m .43547 .63178 L .42772 .58503 L p
.246 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51771 .62182 m .50658 .62314 L .49874 .61525 L p
.073 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48761 .62031 m .49874 .61525 L .50658 .62314 L p
.028 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30743 .56209 m .2968 .56884 L .28695 .57863 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27648 .58009 m .28695 .57863 L .2968 .56884 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.62619 .26888 m .64466 .27208 L .63313 .27449 L .995 1 0 r
F
P
p
.61468 .27131 m .62619 .26888 L .63313 .27449 L .948 1 0 r
F
P
p
.002 w
.22469 .601 m .21448 .60238 L .20489 .58988 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19429 .60056 m .20489 .58988 L .21448 .60238 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34875 .54266 m .33792 .55338 L .32881 .54981 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.31823 .55136 m .32881 .54981 L p
.32809 .55237 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.28695 .57863 m .29765 .57184 L .30743 .56209 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29765 .57184 m .30866 .55704 L .31823 .55136 L p
.869 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32881 .54981 m .31823 .55136 L .30866 .55704 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30866 .55704 m .3193 .5555 L .32881 .54981 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32881 .54981 m .3193 .5555 L p
.32954 .54722 L .998 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33971 .539 m .32881 .54981 L p
.32954 .54722 L .998 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32881 .54981 m .33792 .55338 L p
.32809 .55237 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.72805 .26877 m .74609 .27198 L .73425 .27439 L 1 .733 0 r
F
P
p
.71621 .27121 m .72805 .26877 L .73425 .27439 L 1 .767 0 r
F
P
p
.82993 .26867 m .84756 .27188 L .83539 .27429 L 1 .105 0 r
F
P
p
.81777 .27111 m .82993 .26867 L .83539 .27429 L 1 .314 0 r
F
P
p
.002 w
.79486 .51383 m .78351 .53374 L .77614 .48424 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.18852 .2685 m .20881 .27171 L .19865 .27412 L 1 .942 0 r
F
P
p
.17837 .27093 m .18852 .2685 L .19865 .27412 L .814 1 0 r
F
P
p
.29036 .2684 m .31024 .27161 L .29975 .27402 L .659 1 0 r
F
P
p
.2799 .27083 m .29036 .2684 L .29975 .27402 L .625 1 0 r
F
P
p
.39224 .2683 m .41169 .27151 L .40089 .27392 L 1 .698 0 r
F
P
p
.38145 .27073 m .39224 .2683 L .40089 .27392 L 1 .698 0 r
F
P
p
.49414 .2682 m .51317 .27141 L .50205 .27382 L 1 .698 0 r
F
P
p
.48303 .27063 m .49414 .2682 L .50205 .27382 L 1 .698 0 r
F
P
p
.002 w
.77614 .48424 m .78813 .48249 L .79486 .51383 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.48761 .62031 m .47655 .62272 L .46847 .61856 L p
.042 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45744 .61989 m .46847 .61856 L .47655 .62272 L p
.014 1 0 r
F P
0 0 0 r
s
P
p
.59607 .2681 m .61468 .27131 L .60323 .27372 L 1 .828 0 r
F
P
p
.58463 .27053 m .59607 .2681 L .60323 .27372 L 1 .872 0 r
F
P
p
.69802 .26799 m .71621 .27121 L .70445 .27362 L 1 .698 0 r
F
P
p
.68626 .27043 m .69802 .26799 L .70445 .27362 L 1 .733 0 r
F
P
p
.002 w
.52891 .61941 m .54017 .61807 L .54774 .6157 L p
.067 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78813 .48249 m .77614 .48424 L .77175 .52625 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.75968 .52788 m .77175 .52625 L .77614 .48424 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.63457 .56324 m .64134 .55851 L p
.62562 .56808 L .847 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63457 .56324 m .64614 .55734 L .65282 .55166 L p
.917 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63457 .56324 m .62763 .56465 L p
.64357 .55836 L .798 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64614 .55734 m .63457 .56324 L p
.64357 .55836 L .798 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62306 .56964 m .63457 .56324 L p
.62562 .56808 L .847 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42772 .58503 m .43864 .58096 L .44637 .6305 L p
.246 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43864 .58096 m .42772 .58503 L .41938 .57374 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40852 .57521 m .41938 .57374 L .42772 .58503 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.8 .26789 m .81777 .27111 L .80568 .27352 L 1 .349 0 r
F
P
p
.78792 .27033 m .8 .26789 L .80568 .27352 L 1 .459 0 r
F
P
p
.002 w
.39727 .60044 m .38651 .60182 L .37879 .55004 L p
.704 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.88971 .48241 m .8774 .48417 L .87224 .48008 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85993 .48185 m .87224 .48008 L .8774 .48417 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.15793 .26772 m .17837 .27093 L .16829 .27335 L .535 1 0 r
F
P
p
.14788 .27016 m .15793 .26772 L .16829 .27335 L .5 1 0 r
F
P
p
.25988 .26762 m .2799 .27083 L .2695 .27325 L .919 1 0 r
F
P
p
.2495 .27006 m .25988 .26762 L .2695 .27325 L .849 1 0 r
F
P
p
.002 w
.69406 .53221 m .70582 .5306 L .71262 .55264 L p
1 .851 0 r
F P
0 0 0 r
s
P
p
.36185 .26752 m .38145 .27073 L .37073 .27315 L 1 .942 0 r
F
P
p
.35115 .26996 m .36185 .26752 L .37073 .27315 L .987 1 0 r
F
P
p
.46385 .26742 m .48303 .27063 L .47199 .27305 L 1 .698 0 r
F
P
p
.45283 .26986 m .46385 .26742 L .47199 .27305 L 1 .698 0 r
F
P
p
.002 w
.37879 .55004 m .3896 .54527 L .39727 .60044 L p
.704 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3896 .54527 m .37879 .55004 L .37033 .53029 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.002 w
.35962 .5319 m .37033 .53029 L .37879 .55004 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.35962 .5319 m .34875 .54266 L .33971 .539 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.32881 .54981 m .33971 .539 L .34875 .54266 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.56588 .26731 m .58463 .27053 L .57327 .27295 L 1 .698 0 r
F
P
p
.55453 .26975 m .56588 .26731 L .57327 .27295 L 1 .698 0 r
F
P
p
.66793 .26721 m .68626 .27043 L .67458 .27285 L 1 .698 0 r
F
P
p
.65626 .26965 m .66793 .26721 L .67458 .27285 L 1 .747 0 r
F
P
p
.002 w
.61165 .58037 m .6002 .58182 L .593 .57845 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58163 .58919 m .593 .57845 L .6002 .58182 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.77001 .26711 m .78792 .27033 L .77592 .27275 L 1 .698 0 r
F
P
p
.75802 .26955 m .77001 .26711 L .77592 .27275 L 1 .698 0 r
F
P
p
.002 w
.85993 .48185 m .8477 .48361 L .84271 .4887 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.22933 .26684 m .2495 .27006 L .23919 .27248 L 1 .907 0 r
F
P
p
.21904 .26928 m .22933 .26684 L .23919 .27248 L .884 1 0 r
F
P
p
.3314 .26673 m .35115 .26996 L .34051 .27238 L .744 1 0 r
F
P
p
.32079 .26918 m .3314 .26673 L .34051 .27238 L .716 1 0 r
F
P
p
.002 w
.27648 .58009 m .26608 .58154 L .25607 .58747 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24567 .58891 m .25607 .58747 L .26608 .58154 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.4335 .26663 m .45283 .26986 L .44187 .27228 L 1 .698 0 r
F
P
p
.42256 .26908 m .4335 .26663 L .44187 .27228 L 1 .698 0 r
F
P
p
.53563 .26653 m .55453 .26975 L .54325 .27218 L 1 .698 0 r
F
P
p
.52436 .26898 m .53563 .26653 L .54325 .27218 L 1 .698 0 r
F
P
p
.002 w
.45744 .61989 m .44637 .6305 L .43864 .58096 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52891 .61941 m .51771 .62182 L .50992 .61215 L p
.083 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49874 .61525 m .50992 .61215 L .51771 .62182 L p
.073 1 0 r
F P
0 0 0 r
s
P
p
.63778 .26643 m .65626 .26965 L .64466 .27208 L 1 .935 0 r
F
P
p
.62619 .26888 m .63778 .26643 L .64466 .27208 L .995 1 0 r
F
P
p
.002 w
.23535 .59033 m .22469 .601 L .21514 .58845 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20489 .58988 m .21514 .58845 L .22469 .601 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.73996 .26633 m .75802 .26955 L .74609 .27198 L 1 .698 0 r
F
P
p
.72805 .26877 m .73996 .26633 L .74609 .27198 L 1 .733 0 r
F
P
p
.002 w
.67616 .54856 m .68774 .53772 L .69406 .53221 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.70582 .5306 m .69406 .53221 L .68774 .53772 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.84217 .26623 m .8598 .26945 L .84756 .27188 L 1 0 0 r
F
P
p
.82993 .26867 m .84217 .26623 L .84756 .27188 L 1 .105 0 r
F
P
p
.19872 .26605 m .21904 .26928 L .20881 .27171 L 1 .872 0 r
F
P
p
.18852 .2685 m .19872 .26605 L .20881 .27171 L 1 .942 0 r
F
P
p
.002 w
.66445 .55012 m .65282 .55166 L .64614 .55734 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.3009 .26595 m .32079 .26918 L .31024 .27161 L .744 1 0 r
F
P
p
.29036 .2684 m .3009 .26595 L .31024 .27161 L .659 1 0 r
F
P
p
.40309 .26585 m .42256 .26908 L .41169 .27151 L 1 .698 0 r
F
P
p
.39224 .2683 m .40309 .26585 L .41169 .27151 L 1 .698 0 r
F
P
p
.002 w
.37033 .53029 m .35962 .5319 L .35064 .52815 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33971 .539 m .35064 .52815 L .35962 .5319 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.49874 .61525 m .48761 .62031 L .47957 .61722 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46847 .61856 m .47957 .61722 L .48761 .62031 L p
.042 1 0 r
F P
0 0 0 r
s
P
p
.50532 .26575 m .52436 .26898 L .51317 .27141 L 1 .698 0 r
F
P
p
.49414 .2682 m .50532 .26575 L .51317 .27141 L 1 .698 0 r
F
P
p
.002 w
.81893 .508 m .8069 .51217 L .8002 .48072 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.002 w
.78813 .48249 m .8002 .48072 L .8069 .51217 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.43864 .58096 m .44971 .57024 L .45744 .61989 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44971 .57024 m .43864 .58096 L .43038 .56827 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41938 .57374 m .43038 .56827 L .43864 .58096 L p
.65 1 0 r
F P
0 0 0 r
s
P
p
.60757 .26565 m .62619 .26888 L .61468 .27131 L 1 .808 0 r
F
P
p
.59607 .2681 m .60757 .26565 L .61468 .27131 L 1 .828 0 r
F
P
p
.002 w
.20489 .58988 m .19429 .60056 L .18409 .59732 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.70985 .26554 m .72805 .26877 L .71621 .27121 L 1 .698 0 r
F
P
p
.69802 .26799 m .70985 .26554 L .71621 .27121 L 1 .698 0 r
F
P
p
.002 w
.41938 .57374 m .40852 .57521 L .40048 .54002 L p
.958 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40852 .57521 m .39727 .60044 L .3896 .54527 L p
.82 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3896 .54527 m .40048 .54002 L .40852 .57521 L p
.82 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57034 .60918 m .55902 .61436 L .5515 .61298 L p
.136 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54017 .61807 m .5515 .61298 L .55902 .61436 L p
.102 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8002 .48072 m .78813 .48249 L .78389 .52461 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.77175 .52625 m .78389 .52461 L .78813 .48249 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.81216 .26544 m .82993 .26867 L .81777 .27111 L 1 .298 0 r
F
P
p
.8 .26789 m .81216 .26544 L .81777 .27111 L 1 .349 0 r
F
P
p
.002 w
.87224 .48008 m .88463 .4783 L .88971 .48241 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.16805 .26527 m .18852 .2685 L .17837 .27093 L .674 1 0 r
F
P
p
.15793 .26772 m .16805 .26527 L .17837 .27093 L .535 1 0 r
F
P
p
.002 w
.40048 .54002 m .3896 .54527 L .38111 .52867 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.002 w
.37033 .53029 m .38111 .52867 L .3896 .54527 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.002 w
.73603 .54032 m .7244 .55062 L .71765 .52899 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.002 w
.70582 .5306 m .71765 .52899 L .7244 .55062 L p
1 .835 0 r
F P
0 0 0 r
s
P
p
.27032 .26516 m .29036 .2684 L .2799 .27083 L .973 1 0 r
F
P
p
.25988 .26762 m .27032 .26516 L .2799 .27083 L .919 1 0 r
F
P
p
.37262 .26506 m .39224 .2683 L .38145 .27073 L 1 .872 0 r
F
P
p
.36185 .26752 m .37262 .26506 L .38145 .27073 L 1 .942 0 r
F
P
p
.002 w
.46847 .61856 m .45744 .61989 L .44971 .57024 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.47495 .26496 m .49414 .2682 L .48303 .27063 L 1 .698 0 r
F
P
p
.46385 .26742 m .47495 .26496 L .48303 .27063 L 1 .698 0 r
F
P
p
.002 w
.24567 .58891 m .23535 .59033 L .22544 .58701 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21514 .58845 m .22544 .58701 L .23535 .59033 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.5773 .26486 m .59607 .2681 L .58463 .27053 L 1 .698 0 r
F
P
p
.56588 .26731 m .5773 .26486 L .58463 .27053 L 1 .698 0 r
F
P
p
.67968 .26476 m .69802 .26799 L .68626 .27043 L 1 .698 0 r
F
P
p
.66793 .26721 m .67968 .26476 L .68626 .27043 L 1 .698 0 r
F
P
p
.002 w
.593 .57845 m .60451 .57698 L .61165 .58037 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.78208 .26465 m .8 .26789 L .78792 .27033 L 1 .663 0 r
F
P
p
.77001 .26711 m .78208 .26465 L .78792 .27033 L 1 .698 0 r
F
P
p
.002 w
.87224 .48008 m .85993 .48185 L .85462 .47773 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84271 .4887 m .85462 .47773 L .85993 .48185 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.13732 .26448 m .15793 .26772 L .14788 .27016 L .64 1 0 r
F
P
p
.23969 .26438 m .25988 .26762 L .2495 .27006 L 1 .767 0 r
F
P
p
.22933 .26684 m .23969 .26438 L .2495 .27006 L 1 .907 0 r
F
P
p
.34209 .26428 m .36185 .26752 L .35115 .26996 L .771 1 0 r
F
P
p
.3314 .26673 m .34209 .26428 L .35115 .26996 L .744 1 0 r
F
P
p
.002 w
.28695 .57863 m .27648 .58009 L .26687 .57669 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25607 .58747 m .26687 .57669 L .27648 .58009 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44971 .57024 m .46082 .55949 L .46847 .61856 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46082 .55949 m .44971 .57024 L .44138 .56677 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43038 .56827 m .44138 .56677 L .44971 .57024 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.44451 .26417 m .46385 .26742 L .45283 .26986 L 1 .698 0 r
F
P
p
.4335 .26663 m .44451 .26417 L .45283 .26986 L 1 .698 0 r
F
P
p
.002 w
.21514 .58845 m .20489 .58988 L .19432 .5959 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18409 .59732 m .19432 .5959 L .20489 .58988 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54017 .61807 m .52891 .61941 L .52116 .61079 L p
.088 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50992 .61215 m .52116 .61079 L .52891 .61941 L p
.083 1 0 r
F P
0 0 0 r
s
P
p
.54697 .26407 m .56588 .26731 L .55453 .26975 L 1 .698 0 r
F
P
p
.53563 .26653 m .54697 .26407 L .55453 .26975 L 1 .698 0 r
F
P
p
.64944 .26397 m .66793 .26721 L .65626 .26965 L 1 .781 0 r
F
P
p
.63778 .26643 m .64944 .26397 L .65626 .26965 L 1 .935 0 r
F
P
p
.75195 .26387 m .77001 .26711 L .75802 .26955 L 1 .698 0 r
F
P
p
.73996 .26633 m .75195 .26387 L .75802 .26955 L 1 .698 0 r
F
P
p
.002 w
.71765 .52899 m .70582 .5306 L .69958 .53612 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.68774 .53772 m .69958 .53612 L .70582 .5306 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.84217 .26623 m .85448 .26376 L .8598 .26945 L 1 0 0 r
F
P
p
.002 w
.50992 .61215 m .49874 .61525 L .49077 .61035 L p
.122 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47957 .61722 m .49077 .61035 L .49874 .61525 L p
.081 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74769 .52951 m .73603 .54032 L .72955 .52736 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.71765 .52899 m .72955 .52736 L .73603 .54032 L p
1 .8 0 r
F P
0 0 0 r
s
P
p
.209 .26359 m .22933 .26684 L .21904 .26928 L 1 .767 0 r
F
P
p
.19872 .26605 m .209 .26359 L .21904 .26928 L 1 .872 0 r
F
P
p
.002 w
.67616 .54856 m .66445 .55012 L .65785 .5558 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64614 .55734 m .65785 .5558 L .66445 .55012 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.83062 .49422 m .81893 .508 L .81234 .47895 L p
1 .144 0 r
F P
0 0 0 r
s
P
p
.002 w
.8002 .48072 m .81234 .47895 L .81893 .508 L p
1 .2 0 r
F P
0 0 0 r
s
P
p
.31149 .26349 m .3314 .26673 L .32079 .26918 L .869 1 0 r
F
P
p
.3009 .26595 m .31149 .26349 L .32079 .26918 L .744 1 0 r
F
P
p
.002 w
.58163 .58919 m .57034 .60918 L .5629 .60986 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5515 .61298 m .5629 .60986 L .57034 .60918 L p
.136 1 0 r
F P
0 0 0 r
s
P
p
.41402 .26338 m .4335 .26663 L .42256 .26908 L 1 .698 0 r
F
P
p
.40309 .26585 m .41402 .26338 L .42256 .26908 L 1 .698 0 r
F
P
p
.002 w
.38111 .52867 m .37033 .53029 L .3614 .52652 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35064 .52815 m .3614 .52652 L .37033 .53029 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.51657 .26328 m .53563 .26653 L .52436 .26898 L 1 .698 0 r
F
P
p
.50532 .26575 m .51657 .26328 L .52436 .26898 L 1 .698 0 r
F
P
p
.002 w
.60451 .57698 m .61608 .5744 L .62306 .56964 L p
.644 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40048 .54002 m .41151 .52919 L .41938 .57374 L p
.958 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41151 .52919 m .40048 .54002 L .39195 .52704 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.38111 .52867 m .39195 .52704 L .40048 .54002 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.61915 .26318 m .63778 .26643 L .62619 .26888 L 1 .795 0 r
F
P
p
.60757 .26565 m .61915 .26318 L .62619 .26888 L 1 .808 0 r
F
P
p
.72176 .26308 m .73996 .26633 L .72805 .26877 L 1 .698 0 r
F
P
p
.70985 .26554 m .72176 .26308 L .72805 .26877 L 1 .698 0 r
F
P
p
.002 w
.43038 .56827 m .41938 .57374 L .41151 .52919 L p
1 .992 0 r
F P
0 0 0 r
s
P
p
.002 w
.81234 .47895 m .8002 .48072 L .79611 .52295 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.78389 .52461 m .79611 .52295 L .8002 .48072 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.82439 .26297 m .84217 .26623 L .82993 .26867 L 1 .228 0 r
F
P
p
.81216 .26544 m .82439 .26297 L .82993 .26867 L 1 .298 0 r
F
P
p
.002 w
.593 .57845 m .58163 .58919 L .57425 .58585 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5629 .60986 m .57425 .58585 L .58163 .58919 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.17824 .2628 m .19872 .26605 L .18852 .2685 L .884 1 0 r
F
P
p
.16805 .26527 m .17824 .2628 L .18852 .2685 L .674 1 0 r
F
P
p
.002 w
.47957 .61722 m .46847 .61856 L .46082 .55949 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46082 .55949 m .47189 .55796 L .47957 .61722 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47189 .55796 m .46082 .55949 L .45255 .55593 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44138 .56677 m .45255 .55593 L .46082 .55949 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.28084 .2627 m .3009 .26595 L .29036 .2684 L 1 .992 0 r
F
P
p
.27032 .26516 m .28084 .2627 L .29036 .2684 L .973 1 0 r
F
P
p
.38346 .26259 m .40309 .26585 L .39224 .2683 L 1 .802 0 r
F
P
p
.37262 .26506 m .38346 .26259 L .39224 .2683 L 1 .872 0 r
F
P
p
.48611 .26249 m .50532 .26575 L .49414 .2682 L 1 .698 0 r
F
P
p
.47495 .26496 m .48611 .26249 L .49414 .2682 L 1 .698 0 r
F
P
p
.002 w
.25607 .58747 m .24567 .58891 L .23581 .58557 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22544 .58701 m .23581 .58557 L .24567 .58891 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.58879 .26239 m .60757 .26565 L .59607 .2681 L 1 .698 0 r
F
P
p
.5773 .26486 m .58879 .26239 L .59607 .2681 L 1 .698 0 r
F
P
p
.002 w
.81234 .47895 m .82456 .47716 L .83062 .49422 L p
1 .144 0 r
F P
0 0 0 r
s
P
p
.6915 .26228 m .70985 .26554 L .69802 .26799 L 1 .698 0 r
F
P
p
.67968 .26476 m .6915 .26228 L .69802 .26799 L 1 .698 0 r
F
P
p
.79423 .26218 m .81216 .26544 L .8 .26789 L 1 .628 0 r
F
P
p
.78208 .26465 m .79423 .26218 L .8 .26789 L 1 .663 0 r
F
P
p
.002 w
.72955 .52736 m .74154 .52573 L .74769 .52951 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.88463 .4783 m .87224 .48008 L .867 .47594 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.85462 .47773 m .867 .47594 L .87224 .48008 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.14742 .26201 m .16805 .26527 L .15793 .26772 L .814 1 0 r
F
P
p
.13732 .26448 m .14742 .26201 L .15793 .26772 L .64 1 0 r
F
P
p
.25012 .2619 m .27032 .26516 L .25988 .26762 L 1 .733 0 r
F
P
p
.23969 .26438 m .25012 .2619 L .25988 .26762 L 1 .767 0 r
F
P
p
.35284 .2618 m .37262 .26506 L .36185 .26752 L .821 1 0 r
F
P
p
.34209 .26428 m .35284 .2618 L .36185 .26752 L .771 1 0 r
F
P
p
.002 w
.29765 .57184 m .28695 .57863 L .27738 .57521 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26687 .57669 m .27738 .57521 L .28695 .57863 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.4556 .2617 m .47495 .26496 L .46385 .26742 L 1 .698 0 r
F
P
p
.44451 .26417 m .4556 .2617 L .46385 .26742 L 1 .698 0 r
F
P
p
.002 w
.41151 .52919 m .42244 .52756 L .43038 .56827 L p
1 .992 0 r
F P
0 0 0 r
s
P
p
.002 w
.42244 .52756 m .41151 .52919 L .40286 .52541 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39195 .52704 m .40286 .52541 L .41151 .52919 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.22544 .58701 m .21514 .58845 L .20504 .5851 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19432 .5959 m .20504 .5851 L .21514 .58845 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5515 .61298 m .54017 .61807 L .53248 .60942 L p
.119 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52116 .61079 m .53248 .60942 L .54017 .61807 L p
.088 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35064 .52815 m .33971 .539 L .33008 .55128 L p
1 .897 0 r
F P
0 0 0 r
s
P
p
.002 w
.3193 .5555 m .33008 .55128 L .33971 .539 L p
.998 1 0 r
F P
0 0 0 r
s
P
p
.55838 .26159 m .5773 .26486 L .56588 .26731 L 1 .698 0 r
F
P
p
.54697 .26407 m .55838 .26159 L .56588 .26731 L 1 .698 0 r
F
P
p
.66118 .26149 m .67968 .26476 L .66793 .26721 L 1 .698 0 r
F
P
p
.64944 .26397 m .66118 .26149 L .66793 .26721 L 1 .781 0 r
F
P
p
.002 w
.60451 .57698 m .593 .57845 L .5857 .57503 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57425 .58585 m .5857 .57503 L .593 .57845 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52116 .61079 m .50992 .61215 L .502 .60898 L p
.129 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49077 .61035 m .502 .60898 L .50992 .61215 L p
.122 1 0 r
F P
0 0 0 r
s
P
p
.76402 .26139 m .78208 .26465 L .77001 .26711 L 1 .698 0 r
F
P
p
.75195 .26387 m .76402 .26139 L .77001 .26711 L 1 .698 0 r
F
P
p
.002 w
.72955 .52736 m .71765 .52899 L .71127 .5252 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69958 .53612 m .71127 .5252 L .71765 .52899 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.62763 .56465 m .6203 .54231 L p
.63443 .55775 L .889 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62763 .56465 m .63457 .56324 L p
.62088 .5715 L .732 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62763 .56465 m .63935 .56313 L .64614 .55734 L p
.798 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63935 .56313 m .62763 .56465 L p
.63443 .55775 L .889 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61608 .5744 m .62763 .56465 L p
.62088 .5715 L .732 1 0 r
F P
0 0 0 r
s
P
p
.21933 .26111 m .23969 .26438 L .22933 .26684 L 1 .698 0 r
F
P
p
.209 .26359 m .21933 .26111 L .22933 .26684 L 1 .767 0 r
F
P
p
.002 w
.65785 .5558 m .66964 .55425 L .67616 .54856 L p
.953 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68774 .53772 m .67616 .54856 L .66964 .55425 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.32216 .26101 m .34209 .26428 L .3314 .26673 L .924 1 0 r
F
P
p
.31149 .26349 m .32216 .26101 L .3314 .26673 L .869 1 0 r
F
P
p
.002 w
.44138 .56677 m .43038 .56827 L .42244 .52756 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.42501 .2609 m .44451 .26417 L .4335 .26663 L 1 .698 0 r
F
P
p
.41402 .26338 m .42501 .2609 L .4335 .26663 L 1 .698 0 r
F
P
p
.002 w
.39195 .52704 m .38111 .52867 L .37223 .52488 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3614 .52652 m .37223 .52488 L .38111 .52867 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52789 .2608 m .54697 .26407 L .53563 .26653 L 1 .698 0 r
F
P
p
.51657 .26328 m .52789 .2608 L .53563 .26653 L 1 .698 0 r
F
P
p
.6308 .2607 m .64944 .26397 L .63778 .26643 L 1 .781 0 r
F
P
p
.61915 .26318 m .6308 .2607 L .63778 .26643 L 1 .795 0 r
F
P
p
.73374 .26059 m .75195 .26387 L .73996 .26633 L 1 .698 0 r
F
P
p
.72176 .26308 m .73374 .26059 L .73996 .26633 L 1 .698 0 r
F
P
p
.002 w
.82456 .47716 m .81234 .47895 L .80841 .52129 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.79611 .52295 m .80841 .52129 L .81234 .47895 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.8367 .26049 m .85448 .26376 L .84217 .26623 L 1 .105 0 r
F
P
p
.82439 .26297 m .8367 .26049 L .84217 .26623 L 1 .228 0 r
F
P
p
.18849 .26031 m .209 .26359 L .19872 .26605 L 1 .942 0 r
F
P
p
.17824 .2628 m .18849 .26031 L .19872 .26605 L .884 1 0 r
F
P
p
.002 w
.85462 .47773 m .84271 .4887 L .83686 .47536 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.82456 .47716 m .83686 .47536 L .84271 .4887 L p
1 .084 0 r
F P
0 0 0 r
s
P
p
.002 w
.49077 .61035 m .47957 .61722 L .47189 .55796 L p
.509 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47189 .55796 m .48307 .55022 L .49077 .61035 L p
.509 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48307 .55022 m .47189 .55796 L .46368 .55438 L p
.942 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45255 .55593 m .46368 .55438 L .47189 .55796 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.29142 .26021 m .31149 .26349 L .3009 .26595 L 1 .907 0 r
F
P
p
.28084 .2627 m .29142 .26021 L .3009 .26595 L 1 .992 0 r
F
P
p
.39437 .26011 m .41402 .26338 L .40309 .26585 L 1 .767 0 r
F
P
p
.38346 .26259 m .39437 .26011 L .40309 .26585 L 1 .802 0 r
F
P
p
.002 w
.3614 .52652 m .35064 .52815 L .34104 .54302 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.33008 .55128 m .34104 .54302 L .35064 .52815 L p
1 .897 0 r
F P
0 0 0 r
s
P
p
.49735 .26 m .51657 .26328 L .50532 .26575 L 1 .698 0 r
F
P
p
.48611 .26249 m .49735 .26 L .50532 .26575 L 1 .698 0 r
F
P
p
.002 w
.26687 .57669 m .25607 .58747 L .24652 .57741 L p
.554 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23581 .58557 m .24652 .57741 L .25607 .58747 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.60036 .2599 m .61915 .26318 L .60757 .26565 L 1 .698 0 r
F
P
p
.58879 .26239 m .60036 .2599 L .60757 .26565 L 1 .698 0 r
F
P
p
.002 w
.19432 .5959 m .18409 .59732 L .17374 .59403 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27738 .57521 m .28796 .57372 L .29765 .57184 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30866 .55704 m .29765 .57184 L .28796 .57372 L p
.694 1 0 r
F P
0 0 0 r
s
P
p
.7034 .2598 m .72176 .26308 L .70985 .26554 L 1 .698 0 r
F
P
p
.6915 .26228 m .7034 .2598 L .70985 .26554 L 1 .698 0 r
F
P
p
.80646 .25969 m .82439 .26297 L .81216 .26544 L 1 .611 0 r
F
P
p
.79423 .26218 m .80646 .25969 L .81216 .26544 L 1 .628 0 r
F
P
p
.002 w
.77175 .52625 m .75968 .52788 L .75359 .52408 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74154 .52573 m .75359 .52408 L .75968 .52788 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.867 .47594 m .87947 .47413 L .88463 .4783 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69958 .53612 m .68774 .53772 L .6815 .55269 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.66964 .55425 m .6815 .55269 L .68774 .53772 L p
.988 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5629 .60986 m .5515 .61298 L .54387 .60344 L p
.228 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53248 .60942 m .54387 .60344 L .5515 .61298 L p
.119 1 0 r
F P
0 0 0 r
s
P
p
.15758 .25952 m .17824 .2628 L .16805 .26527 L .884 1 0 r
F
P
p
.14742 .26201 m .15758 .25952 L .16805 .26527 L .814 1 0 r
F
P
p
.26061 .25941 m .28084 .2627 L .27032 .26516 L 1 .698 0 r
F
P
p
.25012 .2619 m .26061 .25941 L .27032 .26516 L 1 .733 0 r
F
P
p
.36366 .25931 m .38346 .26259 L .37262 .26506 L .899 1 0 r
F
P
p
.35284 .2618 m .36366 .25931 L .37262 .26506 L .821 1 0 r
F
P
p
.002 w
.65785 .5558 m .64614 .55734 L .63935 .56313 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.46675 .25921 m .48611 .26249 L .47495 .26496 L 1 .698 0 r
F
P
p
.4556 .2617 m .46675 .25921 L .47495 .26496 L 1 .698 0 r
F
P
p
.002 w
.42244 .52756 m .43344 .52593 L .44138 .56677 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.43344 .52593 m .42244 .52756 L .41385 .52376 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40286 .52541 m .41385 .52376 L .42244 .52756 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23581 .58557 m .22544 .58701 L .21539 .58365 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20504 .5851 m .21539 .58365 L .22544 .58701 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.56986 .2591 m .58879 .26239 L .5773 .26486 L 1 .698 0 r
F
P
p
.55838 .26159 m .56986 .2591 L .5773 .26486 L 1 .698 0 r
F
P
p
.67299 .259 m .6915 .26228 L .67968 .26476 L 1 .698 0 r
F
P
p
.66118 .26149 m .67299 .259 L .67968 .26476 L 1 .698 0 r
F
P
p
.002 w
.61608 .5744 m .60451 .57698 L .59727 .57354 L p
.644 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5857 .57503 m .59727 .57354 L .60451 .57698 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53248 .60942 m .52116 .61079 L .5133 .6076 L p
.206 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.502 .60898 m .5133 .6076 L .52116 .61079 L p
.129 1 0 r
F P
0 0 0 r
s
P
p
.77616 .25889 m .79423 .26218 L .78208 .26465 L 1 .698 0 r
F
P
p
.76402 .26139 m .77616 .25889 L .78208 .26465 L 1 .698 0 r
F
P
p
.002 w
.74154 .52573 m .72955 .52736 L .72324 .52355 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.71127 .5252 m .72324 .52355 L .72955 .52736 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.867 .47594 m .85462 .47773 L .84924 .47355 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83686 .47536 m .84924 .47355 L .85462 .47773 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.3193 .5555 m .30866 .55704 L .29861 .57223 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.28796 .57372 m .29861 .57223 L .30866 .55704 L p
.694 1 0 r
F P
0 0 0 r
s
P
p
.12661 .25872 m .14742 .26201 L .13732 .26448 L 1 .977 0 r
F
P
p
.22974 .25861 m .25012 .2619 L .23969 .26438 L 1 .698 0 r
F
P
p
.21933 .26111 m .22974 .25861 L .23969 .26438 L 1 .698 0 r
F
P
p
.3329 .25851 m .35284 .2618 L .34209 .26428 L .93 1 0 r
F
P
p
.32216 .26101 m .3329 .25851 L .34209 .26428 L .924 1 0 r
F
P
p
.002 w
.27738 .57521 m .26687 .57669 L .25706 .57469 L p
.599 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25706 .57469 m .26687 .57669 L p
.24715 .57739 L .554 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25706 .57469 m .26768 .57174 L .27738 .57521 L p
.599 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25706 .57469 m .24684 .57922 L p
.26704 .57197 L .53 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26768 .57174 m .25706 .57469 L p
.26704 .57197 L .53 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24652 .57741 m .25706 .57469 L p
.24715 .57739 L .554 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45255 .55593 m .44138 .56677 L .43344 .52593 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.502 .60898 m .49077 .61035 L .48307 .55022 L p
.564 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48307 .55022 m .49429 .54555 L .502 .60898 L p
.564 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49429 .54555 m .48307 .55022 L .47495 .54346 L p
1 .98 0 r
F P
0 0 0 r
s
P
p
.002 w
.46368 .55438 m .47495 .54346 L .48307 .55022 L p
.942 1 0 r
F P
0 0 0 r
s
P
p
.43608 .25841 m .4556 .2617 L .44451 .26417 L 1 .698 0 r
F
P
p
.42501 .2609 m .43608 .25841 L .44451 .26417 L 1 .698 0 r
F
P
p
.002 w
.40286 .52541 m .39195 .52704 L .38313 .52323 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37223 .52488 m .38313 .52323 L .39195 .52704 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53929 .2583 m .55838 .26159 L .54697 .26407 L 1 .698 0 r
F
P
p
.52789 .2608 m .53929 .2583 L .54697 .26407 L 1 .698 0 r
F
P
p
.64253 .2582 m .66118 .26149 L .64944 .26397 L 1 .733 0 r
F
P
p
.6308 .2607 m .64253 .2582 L .64944 .26397 L 1 .781 0 r
F
P
p
.7458 .25809 m .76402 .26139 L .75195 .26387 L 1 .646 0 r
F
P
p
.73374 .26059 m .7458 .25809 L .75195 .26387 L 1 .698 0 r
F
P
p
.002 w
.83686 .47536 m .82456 .47716 L .82079 .51961 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.80841 .52129 m .82079 .51961 L .82456 .47716 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.8367 .26049 m .84909 .25799 L .85448 .26376 L 1 .105 0 r
F
P
p
.19881 .25781 m .21933 .26111 L .209 .26359 L 1 .767 0 r
F
P
p
.18849 .26031 m .19881 .25781 L .209 .26359 L 1 .942 0 r
F
P
p
.30206 .25771 m .32216 .26101 L .31149 .26349 L 1 .802 0 r
F
P
p
.29142 .26021 m .30206 .25771 L .31149 .26349 L 1 .907 0 r
F
P
p
.40535 .2576 m .42501 .2609 L .41402 .26338 L 1 .767 0 r
F
P
p
.39437 .26011 m .40535 .2576 L .41402 .26338 L 1 .767 0 r
F
P
p
.002 w
.34104 .54302 m .35211 .53205 L .3614 .52652 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.37223 .52488 m .3614 .52652 L .35211 .53205 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.50866 .2575 m .52789 .2608 L .51657 .26328 L 1 .698 0 r
F
P
p
.49735 .26 m .50866 .2575 L .51657 .26328 L 1 .698 0 r
F
P
p
.612 .2574 m .6308 .2607 L .61915 .26318 L 1 .698 0 r
F
P
p
.60036 .2599 m .612 .2574 L .61915 .26318 L 1 .698 0 r
F
P
p
.002 w
.20504 .5851 m .19432 .5959 L .18401 .5926 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17374 .59403 m .18401 .5926 L .19432 .5959 L p
.326 1 0 r
F P
0 0 0 r
s
P
p
.71537 .25729 m .73374 .26059 L .72176 .26308 L 1 .698 0 r
F
P
p
.7034 .2598 m .71537 .25729 L .72176 .26308 L 1 .698 0 r
F
P
p
.002 w
.57425 .58585 m .5629 .60986 L .55526 .58259 L p
.411 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54387 .60344 m .55526 .58259 L .5629 .60986 L p
.228 1 0 r
F P
0 0 0 r
s
P
p
.81877 .25719 m .8367 .26049 L .82439 .26297 L 1 .577 0 r
F
P
p
.80646 .25969 m .81877 .25719 L .82439 .26297 L 1 .611 0 r
F
P
p
.002 w
.78389 .52461 m .77175 .52625 L .76573 .52242 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75359 .52408 m .76573 .52242 L .77175 .52625 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5857 .57503 m .57425 .58585 L .56674 .57575 L p
.56 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55526 .58259 m .56674 .57575 L .57425 .58585 L p
.411 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71127 .5252 m .69958 .53612 L .69323 .54173 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.6815 .55269 m .69323 .54173 L .69958 .53612 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.16781 .25701 m .18849 .26031 L .17824 .2628 L 1 .977 0 r
F
P
p
.15758 .25952 m .16781 .25701 L .17824 .2628 L .884 1 0 r
F
P
p
.002 w
.46368 .55438 m .45255 .55593 L .44451 .52429 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.43344 .52593 m .44451 .52429 L .45255 .55593 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.27117 .25691 m .29142 .26021 L .28084 .2627 L 1 .698 0 r
F
P
p
.26061 .25941 m .27117 .25691 L .28084 .2627 L 1 .698 0 r
F
P
p
.37456 .2568 m .39437 .26011 L .38346 .26259 L 1 .977 0 r
F
P
p
.36366 .25931 m .37456 .2568 L .38346 .26259 L .899 1 0 r
F
P
p
.002 w
.66964 .55425 m .65785 .5558 L .65099 .55219 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63935 .56313 m .65099 .55219 L .65785 .5558 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.47797 .2567 m .49735 .26 L .48611 .26249 L 1 .698 0 r
F
P
p
.46675 .25921 m .47797 .2567 L .48611 .26249 L 1 .698 0 r
F
P
p
.002 w
.44451 .52429 m .43344 .52593 L .4249 .5221 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41385 .52376 m .4249 .5221 L .43344 .52593 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24652 .57741 m .23581 .58557 L .22581 .58218 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21539 .58365 m .22581 .58218 L .23581 .58557 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.58141 .25659 m .60036 .2599 L .58879 .26239 L 1 .698 0 r
F
P
p
.56986 .2591 m .58141 .25659 L .58879 .26239 L 1 .698 0 r
F
P
p
.002 w
.62763 .56465 m .61608 .5744 L .60882 .56264 L p
.783 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59727 .57354 m .60882 .56264 L .61608 .5744 L p
.644 1 0 r
F P
0 0 0 r
s
P
p
.68488 .25649 m .7034 .2598 L .6915 .26228 L 1 .698 0 r
F
P
p
.67299 .259 m .68488 .25649 L .6915 .26228 L 1 .698 0 r
F
P
p
.002 w
.54387 .60344 m .53248 .60942 L .52471 .58535 L p
.307 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5133 .6076 m .52471 .58535 L .53248 .60942 L p
.206 1 0 r
F P
0 0 0 r
s
P
p
.78838 .25638 m .80646 .25969 L .79423 .26218 L 1 .698 0 r
F
P
p
.77616 .25889 m .78838 .25638 L .79423 .26218 L 1 .698 0 r
F
P
p
.002 w
.75359 .52408 m .74154 .52573 L .73529 .52189 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72324 .52355 m .73529 .52189 L .74154 .52573 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.87947 .47413 m .867 .47594 L .86169 .47173 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84924 .47355 m .86169 .47173 L .867 .47594 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.33008 .55128 m .3193 .5555 L .30933 .57072 L p
.774 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29861 .57223 m .30933 .57072 L .3193 .5555 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5133 .6076 m .502 .60898 L .49429 .54555 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49429 .54555 m .50557 .54164 L .5133 .6076 L p
.585 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50557 .54164 m .49429 .54555 L .48622 .53952 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.47495 .54346 m .48622 .53952 L .49429 .54555 L p
1 .98 0 r
F P
0 0 0 r
s
P
p
.13675 .25621 m .15758 .25952 L .14742 .26201 L 1 .767 0 r
F
P
p
.12661 .25872 m .13675 .25621 L .14742 .26201 L 1 .977 0 r
F
P
p
.24021 .2561 m .26061 .25941 L .25012 .2619 L 1 .698 0 r
F
P
p
.22974 .25861 m .24021 .2561 L .25012 .2619 L 1 .698 0 r
F
P
p
.3437 .256 m .36366 .25931 L .35284 .2618 L .96 1 0 r
F
P
p
.3329 .25851 m .3437 .256 L .35284 .2618 L .93 1 0 r
F
P
p
.002 w
.28796 .57372 m .27738 .57521 L .26768 .57174 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.44722 .25589 m .46675 .25921 L .4556 .2617 L 1 .698 0 r
F
P
p
.43608 .25841 m .44722 .25589 L .4556 .2617 L 1 .698 0 r
F
P
p
.002 w
.41385 .52376 m .40286 .52541 L .39409 .52157 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38313 .52323 m .39409 .52157 L .40286 .52541 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21539 .58365 m .20504 .5851 L .19436 .59115 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18401 .5926 m .19436 .59115 L .20504 .5851 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.55076 .25579 m .56986 .2591 L .55838 .26159 L 1 .698 0 r
F
P
p
.53929 .2583 m .55076 .25579 L .55838 .26159 L 1 .698 0 r
F
P
p
.65433 .25568 m .67299 .259 L .66118 .26149 L 1 .698 0 r
F
P
p
.64253 .2582 m .65433 .25568 L .66118 .26149 L 1 .733 0 r
F
P
p
.002 w
.59727 .57354 m .5857 .57503 L .57829 .57156 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56674 .57575 m .57829 .57156 L .5857 .57503 L p
.56 1 0 r
F P
0 0 0 r
s
P
p
.75793 .25558 m .77616 .25889 L .76402 .26139 L 1 .577 0 r
F
P
p
.7458 .25809 m .75793 .25558 L .76402 .26139 L 1 .646 0 r
F
P
p
.002 w
.70501 .53073 m .71127 .5252 L p
.70228 .53344 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.69323 .54173 m .70501 .53073 L p
.70228 .53344 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.70501 .53073 m .69843 .52689 L p
.70777 .52799 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.72324 .52355 m .71127 .5252 L .70501 .53073 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.70501 .53073 m .71707 .52908 L .72324 .52355 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.71707 .52908 m .70501 .53073 L p
.70777 .52799 L 1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.84924 .47355 m .83686 .47536 L .83324 .51793 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.82079 .51961 m .83324 .51793 L .83686 .47536 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.20919 .2553 m .22974 .25861 L .21933 .26111 L 1 .698 0 r
F
P
p
.19881 .25781 m .20919 .2553 L .21933 .26111 L 1 .767 0 r
F
P
p
.31278 .25519 m .3329 .25851 L .32216 .26101 L 1 .767 0 r
F
P
p
.30206 .25771 m .31278 .25519 L .32216 .26101 L 1 .802 0 r
F
P
p
.4164 .25509 m .43608 .25841 L .42501 .2609 L 1 .767 0 r
F
P
p
.40535 .2576 m .4164 .25509 L .42501 .2609 L 1 .767 0 r
F
P
p
.002 w
.38313 .52323 m .37223 .52488 L .363 .53041 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.35211 .53205 m .363 .53041 L .37223 .52488 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.52004 .25498 m .53929 .2583 L .52789 .2608 L 1 .698 0 r
F
P
p
.50866 .2575 m .52004 .25498 L .52789 .2608 L 1 .698 0 r
F
P
p
.002 w
.60882 .56264 m .6203 .54231 L .62763 .56465 L p
.783 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25706 .57469 m .24652 .57741 L .23629 .5807 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22581 .58218 m .23629 .5807 L .24652 .57741 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.62372 .25488 m .64253 .2582 L .6308 .2607 L 1 .698 0 r
F
P
p
.612 .2574 m .62372 .25488 L .6308 .2607 L 1 .698 0 r
F
P
p
.72742 .25477 m .7458 .25809 L .73374 .26059 L 1 .698 0 r
F
P
p
.71537 .25729 m .72742 .25477 L .73374 .26059 L 1 .698 0 r
F
P
p
.83115 .25467 m .84909 .25799 L .8367 .26049 L 1 .279 0 r
F
P
p
.81877 .25719 m .83115 .25467 L .8367 .26049 L 1 .577 0 r
F
P
p
.002 w
.79611 .52295 m .78389 .52461 L .77794 .52076 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.76573 .52242 m .77794 .52076 L .78389 .52461 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.1781 .25449 m .19881 .25781 L .18849 .26031 L 1 .837 0 r
F
P
p
.16781 .25701 m .1781 .25449 L .18849 .26031 L 1 .977 0 r
F
P
p
.002 w
.47495 .54346 m .46368 .55438 L .45565 .52263 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.44451 .52429 m .45565 .52263 L .46368 .55438 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.55526 .58259 m .54387 .60344 L .53612 .582 L p
.428 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52471 .58535 m .53612 .582 L .54387 .60344 L p
.307 1 0 r
F P
0 0 0 r
s
P
p
.2818 .25438 m .30206 .25771 L .29142 .26021 L 1 .698 0 r
F
P
p
.27117 .25691 m .2818 .25438 L .29142 .26021 L 1 .698 0 r
F
P
p
.38552 .25428 m .40535 .2576 L .39437 .26011 L 1 .907 0 r
F
P
p
.37456 .2568 m .38552 .25428 L .39437 .26011 L 1 .977 0 r
F
P
p
.002 w
.6815 .55269 m .66964 .55425 L .66284 .55062 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65099 .55219 m .66284 .55062 L .66964 .55425 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.48927 .25417 m .50866 .2575 L .49735 .26 L 1 .698 0 r
F
P
p
.47797 .2567 m .48927 .25417 L .49735 .26 L 1 .698 0 r
F
P
p
.002 w
.45565 .52263 m .44451 .52429 L .43603 .52043 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4249 .5221 m .43603 .52043 L .44451 .52429 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.59304 .25407 m .612 .2574 L .60036 .2599 L 1 .698 0 r
F
P
p
.58141 .25659 m .59304 .25407 L .60036 .2599 L 1 .698 0 r
F
P
p
.002 w
.18401 .5926 m .17374 .59403 L .16324 .59069 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34104 .54302 m .33008 .55128 L .32027 .56379 L p
.879 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30933 .57072 m .32027 .56379 L .33008 .55128 L p
.774 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52471 .58535 m .5133 .6076 L .50557 .54164 L p
.671 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50557 .54164 m .51691 .54004 L .52471 .58535 L p
.671 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51691 .54004 m .50557 .54164 L .49756 .53462 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.002 w
.48622 .53952 m .49756 .53462 L .50557 .54164 L p
1 .938 0 r
F P
0 0 0 r
s
P
p
.002 w
.56674 .57575 m .55526 .58259 L .5476 .57377 L p
.545 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53612 .582 m .5476 .57377 L .55526 .58259 L p
.428 1 0 r
F P
0 0 0 r
s
P
p
.69685 .25396 m .71537 .25729 L .7034 .2598 L 1 .698 0 r
F
P
p
.68488 .25649 m .69685 .25396 L .7034 .2598 L 1 .698 0 r
F
P
p
.80068 .25386 m .81877 .25719 L .80646 .25969 L 1 .628 0 r
F
P
p
.78838 .25638 m .80068 .25386 L .80646 .25969 L 1 .698 0 r
F
P
p
.002 w
.76573 .52242 m .75359 .52408 L .74742 .52022 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.73529 .52189 m .74742 .52022 L .75359 .52408 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.86169 .47173 m .87423 .4699 L .87947 .47413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.14695 .25368 m .16781 .25701 L .15758 .25952 L 1 .733 0 r
F
P
p
.13675 .25621 m .14695 .25368 L .15758 .25952 L 1 .767 0 r
F
P
p
.25075 .25357 m .27117 .25691 L .26061 .25941 L 1 .698 0 r
F
P
p
.24021 .2561 m .25075 .25357 L .26061 .25941 L 1 .698 0 r
F
P
p
.35457 .25347 m .37456 .2568 L .36366 .25931 L 1 .967 0 r
F
P
p
.3437 .256 m .35457 .25347 L .36366 .25931 L .96 1 0 r
F
P
p
.002 w
.29861 .57223 m .28796 .57372 L .2783 .57023 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26768 .57174 m .2783 .57023 L .28796 .57372 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.45842 .25336 m .47797 .2567 L .46675 .25921 L 1 .698 0 r
F
P
p
.44722 .25589 m .45842 .25336 L .46675 .25921 L 1 .698 0 r
F
P
p
.002 w
.4249 .5221 m .41385 .52376 L .40513 .51989 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39409 .52157 m .40513 .51989 L .41385 .52376 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.22581 .58218 m .21539 .58365 L .20519 .58023 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19436 .59115 m .20519 .58023 L .21539 .58365 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.5623 .25326 m .58141 .25659 L .56986 .2591 L 1 .698 0 r
F
P
p
.55076 .25579 m .5623 .25326 L .56986 .2591 L 1 .698 0 r
F
P
p
.66621 .25315 m .68488 .25649 L .67299 .259 L 1 .698 0 r
F
P
p
.65433 .25568 m .66621 .25315 L .67299 .259 L 1 .698 0 r
F
P
p
.002 w
.60882 .56264 m .59727 .57354 L .58992 .57004 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57829 .57156 m .58992 .57004 L .59727 .57354 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.77015 .25305 m .78838 .25638 L .77616 .25889 L 1 .488 0 r
F
P
p
.75793 .25558 m .77015 .25305 L .77616 .25889 L 1 .577 0 r
F
P
p
.002 w
.73529 .52189 m .72324 .52355 L .71707 .52908 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.86169 .47173 m .84924 .47355 L .84497 .49739 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.83324 .51793 m .84497 .49739 L .84924 .47355 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.48622 .53952 m .47495 .54346 L .46686 .52096 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.45565 .52263 m .46686 .52096 L .47495 .54346 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.11574 .25287 m .13675 .25621 L .12661 .25872 L 1 .733 0 r
F
P
p
.002 w
.53612 .582 m .52471 .58535 L .51691 .54004 L p
.767 1 0 r
F P
0 0 0 r
s
P
p
.21964 .25276 m .24021 .2561 L .22974 .25861 L 1 .698 0 r
F
P
p
.20919 .2553 m .21964 .25276 L .22974 .25861 L 1 .698 0 r
F
P
p
.32356 .25266 m .3437 .256 L .3329 .25851 L 1 .767 0 r
F
P
p
.31278 .25519 m .32356 .25266 L .3329 .25851 L 1 .767 0 r
F
P
p
.42752 .25255 m .44722 .25589 L .43608 .25841 L 1 .767 0 r
F
P
p
.4164 .25509 m .42752 .25255 L .43608 .25841 L 1 .767 0 r
F
P
p
.002 w
.39409 .52157 m .38313 .52323 L .37417 .51936 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.363 .53041 m .37417 .51936 L .38313 .52323 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.23629 .5807 m .24684 .57922 L .25706 .57469 L p
.52 1 0 r
F P
0 0 0 r
s
P
p
.5315 .25245 m .55076 .25579 L .53929 .2583 L 1 .698 0 r
F
P
p
.52004 .25498 m .5315 .25245 L .53929 .2583 L 1 .698 0 r
F
P
p
.002 w
.65099 .55219 m .63935 .56313 L .63203 .53936 L p
.929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6203 .54231 m .63203 .53936 L .63935 .56313 L p
.889 1 0 r
F P
0 0 0 r
s
P
p
.63551 .25234 m .65433 .25568 L .64253 .2582 L 1 .698 0 r
F
P
p
.62372 .25488 m .63551 .25234 L .64253 .2582 L 1 .698 0 r
F
P
p
.002 w
.35211 .53205 m .34104 .54302 L .3315 .54873 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.32027 .56379 m .3315 .54873 L .34104 .54302 L p
.879 1 0 r
F P
0 0 0 r
s
P
p
.73955 .25224 m .75793 .25558 L .7458 .25809 L 1 .646 0 r
F
P
p
.72742 .25477 m .73955 .25224 L .7458 .25809 L 1 .698 0 r
F
P
p
.83115 .25467 m .84361 .25213 L .84909 .25799 L 1 .279 0 r
F
P
p
.002 w
.80841 .52129 m .79611 .52295 L .79024 .51908 L p
1 .633 0 r
F P
0 0 0 r
s
P
p
.002 w
.77794 .52076 m .79024 .51908 L .79611 .52295 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57829 .57156 m .56674 .57575 L .55915 .57226 L p
.62 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5476 .57377 m .55915 .57226 L .56674 .57575 L p
.545 1 0 r
F P
0 0 0 r
s
P
p
.18846 .25195 m .20919 .2553 L .19881 .25781 L 1 .733 0 r
F
P
p
.1781 .25449 m .18846 .25195 L .19881 .25781 L 1 .837 0 r
F
P
p
.29249 .25184 m .31278 .25519 L .30206 .25771 L 1 .698 0 r
F
P
p
.2818 .25438 m .29249 .25184 L .30206 .25771 L 1 .698 0 r
F
P
p
.39655 .25174 m .4164 .25509 L .40535 .2576 L 1 .872 0 r
F
P
p
.38552 .25428 m .39655 .25174 L .40535 .2576 L 1 .907 0 r
F
P
p
.002 w
.69323 .54173 m .6815 .55269 L .67458 .53961 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.66284 .55062 m .67458 .53961 L .6815 .55269 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.50063 .25163 m .52004 .25498 L .50866 .2575 L 1 .698 0 r
F
P
p
.48927 .25417 m .50063 .25163 L .50866 .2575 L 1 .698 0 r
F
P
p
.002 w
.46686 .52096 m .45565 .52263 L .44722 .51875 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43603 .52043 m .44722 .51875 L .45565 .52263 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.6203 .54231 m .60882 .56264 L .60154 .55905 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58992 .57004 m .60154 .55905 L .60882 .56264 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.60475 .25153 m .62372 .25488 L .612 .2574 L 1 .698 0 r
F
P
p
.59304 .25407 m .60475 .25153 L .612 .2574 L 1 .698 0 r
F
P
p
.002 w
.19436 .59115 m .18401 .5926 L .17402 .57975 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16324 .59069 m .17402 .57975 L .18401 .5926 L p
.36 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51691 .54004 m .52833 .53514 L .53612 .582 L p
.767 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52833 .53514 m .51691 .54004 L .509 .51982 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.002 w
.49756 .53462 m .509 .51982 L .51691 .54004 L p
1 .869 0 r
F P
0 0 0 r
s
P
p
.70889 .25142 m .72742 .25477 L .71537 .25729 L 1 .698 0 r
F
P
p
.69685 .25396 m .70889 .25142 L .71537 .25729 L 1 .698 0 r
F
P
p
.81306 .25132 m .83115 .25467 L .81877 .25719 L 1 .488 0 r
F
P
p
.80068 .25386 m .81306 .25132 L .81877 .25719 L 1 .628 0 r
F
P
p
.002 w
.77794 .52076 m .76573 .52242 L .75963 .51854 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74742 .52022 m .75963 .51854 L .76573 .52242 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.15722 .25114 m .1781 .25449 L .16781 .25701 L 1 .698 0 r
F
P
p
.14695 .25368 m .15722 .25114 L .16781 .25701 L 1 .733 0 r
F
P
p
.002 w
.63203 .53936 m .6203 .54231 L .61331 .55749 L p
.889 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60154 .55905 m .61331 .55749 L .6203 .54231 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.26135 .25103 m .2818 .25438 L .27117 .25691 L 1 .698 0 r
F
P
p
.25075 .25357 m .26135 .25103 L .27117 .25691 L 1 .698 0 r
F
P
p
.36552 .25092 m .38552 .25428 L .37456 .2568 L 1 .877 0 r
F
P
p
.35457 .25347 m .36552 .25092 L .37456 .2568 L 1 .967 0 r
F
P
p
.002 w
.30933 .57072 m .29861 .57223 L .289 .56871 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2783 .57023 m .289 .56871 L .29861 .57223 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66284 .55062 m .65099 .55219 L .64386 .53775 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.63203 .53936 m .64386 .53775 L p
.64054 .54512 L .929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64386 .53775 m .63203 .53936 L .62516 .55592 L p
.929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63695 .54481 m .64386 .53775 L p
.63018 .55104 L .929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62516 .55592 m .63695 .54481 L p
.63018 .55104 L .929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64386 .53775 m .63695 .54481 L p
.6472 .5303 L 1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.64386 .53775 m .65099 .55219 L p
.64054 .54512 L .929 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65546 .51861 m .64386 .53775 L p
.6472 .5303 L 1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.64386 .53775 m .65546 .51861 L .66284 .55062 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.63695 .54481 m .64893 .54319 L .65546 .51861 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.63695 .54481 m .62956 .52573 L p
.64376 .53853 L .995 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64893 .54319 m .63695 .54481 L p
.64376 .53853 L .995 1 0 r
F P
0 0 0 r
s
P
p
.4697 .25082 m .48927 .25417 L .47797 .2567 L 1 .698 0 r
F
P
p
.45842 .25336 m .4697 .25082 L .47797 .2567 L 1 .698 0 r
F
P
p
.002 w
.43603 .52043 m .4249 .5221 L .41624 .51821 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40513 .51989 m .41624 .51821 L .4249 .5221 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23629 .5807 m .22581 .58218 L .21565 .57874 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20519 .58023 m .21565 .57874 L .22581 .58218 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3315 .54873 m .34265 .53767 L .35211 .53205 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.363 .53041 m .35211 .53205 L .34265 .53767 L p
1 .888 0 r
F P
0 0 0 r
s
P
p
.57392 .25071 m .59304 .25407 L .58141 .25659 L 1 .698 0 r
F
P
p
.5623 .25326 m .57392 .25071 L .58141 .25659 L 1 .698 0 r
F
P
p
.002 w
.49756 .53462 m .48622 .53952 L .47814 .51929 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.002 w
.46686 .52096 m .47814 .51929 L .48622 .53952 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.67817 .25061 m .69685 .25396 L .68488 .25649 L 1 .698 0 r
F
P
p
.66621 .25315 m .67817 .25061 L .68488 .25649 L 1 .698 0 r
F
P
p
.78244 .2505 m .80068 .25386 L .78838 .25638 L 1 .419 0 r
F
P
p
.77015 .25305 m .78244 .2505 L .78838 .25638 L 1 .488 0 r
F
P
p
.002 w
.74742 .52022 m .73529 .52189 L .7292 .52743 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.71707 .52908 m .7292 .52743 L .73529 .52189 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.5476 .57377 m .53612 .582 L .52833 .53514 L p
.86 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.87423 .4699 m .86169 .47173 L .8563 .46746 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.84497 .49739 m .8563 .46746 L .86169 .47173 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.12592 .25032 m .14695 .25368 L .13675 .25621 L 1 .698 0 r
F
P
p
.11574 .25287 m .12592 .25032 L .13675 .25621 L 1 .733 0 r
F
P
p
.23015 .25021 m .25075 .25357 L .24021 .2561 L 1 .698 0 r
F
P
p
.21964 .25276 m .23015 .25021 L .24021 .2561 L 1 .698 0 r
F
P
p
.002 w
.70501 .53073 m .69323 .54173 L .68638 .52856 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.67458 .53961 m .68638 .52856 L .69323 .54173 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.33442 .25011 m .35457 .25347 L .3437 .256 L 1 .767 0 r
F
P
p
.32356 .25266 m .33442 .25011 L .3437 .256 L 1 .767 0 r
F
P
p
.002 w
.2783 .57023 m .26768 .57174 L .25746 .57772 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24684 .57922 m .25746 .57772 L .26768 .57174 L p
.53 1 0 r
F P
0 0 0 r
s
P
p
.43871 .25 m .45842 .25336 L .44722 .25589 L 1 .767 0 r
F
P
p
.42752 .25255 m .43871 .25 L .44722 .25589 L 1 .767 0 r
F
P
p
.002 w
.40513 .51989 m .39409 .52157 L .38519 .51767 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37417 .51936 m .38519 .51767 L .39409 .52157 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.54303 .2499 m .5623 .25326 L .55076 .25579 L 1 .698 0 r
F
P
p
.5315 .25245 m .54303 .2499 L .55076 .25579 L 1 .698 0 r
F
P
p
.64738 .24979 m .66621 .25315 L .65433 .25568 L 1 .698 0 r
F
P
p
.63551 .25234 m .64738 .24979 L .65433 .25568 L 1 .698 0 r
F
P
p
.002 w
.58992 .57004 m .57829 .57156 L .57071 .55856 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55915 .57226 m .57071 .55856 L .57829 .57156 L p
.62 1 0 r
F P
0 0 0 r
s
P
p
.75176 .24968 m .77015 .25305 L .75793 .25558 L 1 .577 0 r
F
P
p
.73955 .25224 m .75176 .24968 L .75793 .25558 L 1 .646 0 r
F
P
p
.002 w
.82079 .51961 m .80841 .52129 L .80197 .50007 L p
1 .494 0 r
F P
0 0 0 r
s
P
p
.002 w
.80197 .50007 m .80841 .52129 L p
.79168 .51925 L 1 .633 0 r
F P
0 0 0 r
s
P
p
.002 w
.80197 .50007 m .81361 .47807 L .82079 .51961 L p
1 .494 0 r
F P
0 0 0 r
s
P
p
.002 w
.80197 .50007 m .79672 .51343 L p
.81228 .48083 L 1 .459 0 r
F P
0 0 0 r
s
P
p
.002 w
.81361 .47807 m .80197 .50007 L p
.81228 .48083 L 1 .459 0 r
F P
0 0 0 r
s
P
p
.002 w
.79024 .51908 m .80197 .50007 L p
.79168 .51925 L 1 .633 0 r
F P
0 0 0 r
s
P
p
.19889 .2494 m .21964 .25276 L .20919 .2553 L 1 .698 0 r
F
P
p
.18846 .25195 m .19889 .2494 L .20919 .2553 L 1 .733 0 r
F
P
p
.30326 .24929 m .32356 .25266 L .31278 .25519 L 1 .698 0 r
F
P
p
.29249 .25184 m .30326 .24929 L .31278 .25519 L 1 .698 0 r
F
P
p
.002 w
.52833 .53514 m .5398 .52036 L .5476 .57377 L p
.86 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5398 .52036 m .52833 .53514 L .52045 .51814 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.002 w
.509 .51982 m .52045 .51814 L .52833 .53514 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.40765 .24918 m .42752 .25255 L .4164 .25509 L 1 .837 0 r
F
P
p
.39655 .25174 m .40765 .24918 L .4164 .25509 L 1 .872 0 r
F
P
p
.51208 .24908 m .5315 .25245 L .52004 .25498 L 1 .698 0 r
F
P
p
.50063 .25163 m .51208 .24908 L .52004 .25498 L 1 .698 0 r
F
P
p
.002 w
.47814 .51929 m .46686 .52096 L .45849 .51706 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44722 .51875 m .45849 .51706 L .46686 .52096 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.61653 .24897 m .63551 .25234 L .62372 .25488 L 1 .698 0 r
F
P
p
.60475 .25153 m .61653 .24897 L .62372 .25488 L 1 .698 0 r
F
P
p
.002 w
.20519 .58023 m .19436 .59115 L .18439 .57826 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17402 .57975 m .18439 .57826 L .19436 .59115 L p
.395 1 0 r
F P
0 0 0 r
s
P
p
.72101 .24886 m .73955 .25224 L .72742 .25477 L 1 .698 0 r
F
P
p
.70889 .25142 m .72101 .24886 L .72742 .25477 L 1 .698 0 r
F
P
p
.82552 .24876 m .84361 .25213 L .83115 .25467 L 1 .209 0 r
F
P
p
.81306 .25132 m .82552 .24876 L .83115 .25467 L 1 .488 0 r
F
P
p
.002 w
.79024 .51908 m .77794 .52076 L .77191 .51685 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75963 .51854 m .77191 .51685 L .77794 .52076 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61331 .55749 m .62516 .55592 L .63203 .53936 L p
.889 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55915 .57226 m .5476 .57377 L .5398 .52036 L p
.934 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68638 .52856 m .69843 .52689 L .70501 .53073 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.16756 .24858 m .18846 .25195 L .1781 .25449 L 1 .698 0 r
F
P
p
.15722 .25114 m .16756 .24858 L .1781 .25449 L 1 .698 0 r
F
P
p
.27203 .24847 m .29249 .25184 L .2818 .25438 L 1 .698 0 r
F
P
p
.26135 .25103 m .27203 .24847 L .2818 .25438 L 1 .698 0 r
F
P
p
.002 w
.509 .51982 m .49756 .53462 L .4895 .5176 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.002 w
.47814 .51929 m .4895 .5176 L .49756 .53462 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.37653 .24836 m .39655 .25174 L .38552 .25428 L 1 .837 0 r
F
P
p
.36552 .25092 m .37653 .24836 L .38552 .25428 L 1 .877 0 r
F
P
p
.002 w
.32027 .56379 m .30933 .57072 L .29977 .56718 L p
.645 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.289 .56871 m .29977 .56718 L .30933 .57072 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67458 .53961 m .66284 .55062 L .65546 .51861 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.48106 .24826 m .50063 .25163 L .48927 .25417 L 1 .698 0 r
F
P
p
.4697 .25082 m .48106 .24826 L .48927 .25417 L 1 .698 0 r
F
P
p
.002 w
.44722 .51875 m .43603 .52043 L .42742 .51651 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41624 .51821 m .42742 .51651 L .43603 .52043 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24684 .57922 m .23629 .5807 L .22618 .57724 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21565 .57874 m .22618 .57724 L .23629 .5807 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.37417 .51936 m .363 .53041 L .35373 .53094 L p
1 .818 0 r
F P
0 0 0 r
s
P
p
.002 w
.34265 .53767 m .35373 .53094 L .363 .53041 L p
1 .888 0 r
F P
0 0 0 r
s
P
p
.58561 .24815 m .60475 .25153 L .59304 .25407 L 1 .698 0 r
F
P
p
.57392 .25071 m .58561 .24815 L .59304 .25407 L 1 .698 0 r
F
P
p
.002 w
.5398 .52036 m .55133 .51868 L .55915 .57226 L p
.934 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55133 .51868 m .5398 .52036 L .53197 .51644 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52045 .51814 m .53197 .51644 L .5398 .52036 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.002 w
.17402 .57975 m .16324 .59069 L .15307 .57778 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.6902 .24804 m .70889 .25142 L .69685 .25396 L 1 .673 0 r
F
P
p
.67817 .25061 m .6902 .24804 L .69685 .25396 L 1 .698 0 r
F
P
p
.79481 .24794 m .81306 .25132 L .80068 .25386 L 1 .314 0 r
F
P
p
.78244 .2505 m .79481 .24794 L .80068 .25386 L 1 .419 0 r
F
P
p
.002 w
.75963 .51854 m .74742 .52022 L .74142 .52576 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.7292 .52743 m .74142 .52576 L .74742 .52022 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.8563 .46746 m .86891 .4656 L .87423 .4699 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.13616 .24775 m .15722 .25114 L .14695 .25368 L 1 .698 0 r
F
P
p
.12592 .25032 m .13616 .24775 L .14695 .25368 L 1 .698 0 r
F
P
p
.24074 .24765 m .26135 .25103 L .25075 .25357 L 1 .698 0 r
F
P
p
.23015 .25021 m .24074 .24765 L .25075 .25357 L 1 .698 0 r
F
P
p
.34534 .24754 m .36552 .25092 L .35457 .25347 L 1 .738 0 r
F
P
p
.33442 .25011 m .34534 .24754 L .35457 .25347 L 1 .767 0 r
F
P
p
.002 w
.289 .56871 m .2783 .57023 L .26815 .57622 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25746 .57772 m .26815 .57622 L .2783 .57023 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.44997 .24743 m .4697 .25082 L .45842 .25336 L 1 .753 0 r
F
P
p
.43871 .25 m .44997 .24743 L .45842 .25336 L 1 .767 0 r
F
P
p
.002 w
.41624 .51821 m .40513 .51989 L .39628 .51597 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38519 .51767 m .39628 .51597 L .40513 .51989 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21565 .57874 m .20519 .58023 L .19483 .57676 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18439 .57826 m .19483 .57676 L .20519 .58023 L p
.43 1 0 r
F P
0 0 0 r
s
P
p
.55464 .24733 m .57392 .25071 L .5623 .25326 L 1 .698 0 r
F
P
p
.54303 .2499 m .55464 .24733 L .5623 .25326 L 1 .698 0 r
F
P
p
.002 w
.52045 .51814 m .509 .51982 L .50093 .5159 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4895 .5176 m .50093 .5159 L .509 .51982 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.65932 .24722 m .67817 .25061 L .66621 .25315 L 1 .698 0 r
F
P
p
.64738 .24979 m .65932 .24722 L .66621 .25315 L 1 .698 0 r
F
P
p
.002 w
.60154 .55905 m .58992 .57004 L .58233 .54751 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57071 .55856 m .58233 .54751 L .58992 .57004 L p
.709 1 0 r
F P
0 0 0 r
s
P
p
.76404 .24711 m .78244 .2505 L .77015 .25305 L 1 .488 0 r
F
P
p
.75176 .24968 m .76404 .24711 L .77015 .25305 L 1 .577 0 r
F
P
p
.002 w
.83324 .51793 m .82079 .51961 L .81361 .47807 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.1047 .24693 m .12592 .25032 L .11574 .25287 L 1 .698 0 r
F
P
p
.20938 .24682 m .23015 .25021 L .21964 .25276 L 1 .698 0 r
F
P
p
.19889 .2494 m .20938 .24682 L .21964 .25276 L 1 .698 0 r
F
P
p
.002 w
.68638 .52856 m .67458 .53961 L .66741 .51692 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.65546 .51861 m .66741 .51692 L .67458 .53961 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.31409 .24672 m .33442 .25011 L .32356 .25266 L 1 .698 0 r
F
P
p
.30326 .24929 m .31409 .24672 L .32356 .25266 L 1 .698 0 r
F
P
p
.41883 .24661 m .43871 .25 L .42752 .25255 L 1 .837 0 r
F
P
p
.40765 .24918 m .41883 .24661 L .42752 .25255 L 1 .837 0 r
F
P
p
.002 w
.38519 .51767 m .37417 .51936 L .36485 .5249 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.36485 .5249 m .37417 .51936 L p
.36091 .52687 L 1 .818 0 r
F P
0 0 0 r
s
P
p
.002 w
.36485 .5249 m .37615 .51371 L .38519 .51767 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.36485 .5249 m .35514 .54012 L p
.36883 .52291 L 1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.37615 .51371 m .36485 .5249 L p
.36883 .52291 L 1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.35373 .53094 m .36485 .5249 L p
.36091 .52687 L 1 .818 0 r
F P
0 0 0 r
s
P
p
.002 w
.18439 .57826 m .17402 .57975 L .1639 .56675 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15307 .57778 m .1639 .56675 L .17402 .57975 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.52359 .2465 m .54303 .2499 L .5315 .25245 L 1 .698 0 r
F
P
p
.51208 .24908 m .52359 .2465 L .5315 .25245 L 1 .698 0 r
F
P
p
.002 w
.4895 .5176 m .47814 .51929 L .46983 .51535 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45849 .51706 m .46983 .51535 L .47814 .51929 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62839 .2464 m .64738 .24979 L .63551 .25234 L 1 .698 0 r
F
P
p
.61653 .24897 m .62839 .2464 L .63551 .25234 L 1 .698 0 r
F
P
p
.002 w
.3315 .54873 m .32027 .56379 L .31077 .5602 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29977 .56718 m .31077 .5602 L .32027 .56379 L p
.645 1 0 r
F P
0 0 0 r
s
P
p
.73321 .24629 m .75176 .24968 L .73955 .25224 L 1 .698 0 r
F
P
p
.72101 .24886 m .73321 .24629 L .73955 .25224 L 1 .698 0 r
F
P
p
.82552 .24876 m .83806 .24618 L .84361 .25213 L 1 .209 0 r
F
P
p
.002 w
.80197 .50007 m .79024 .51908 L .78428 .51514 L p
1 .633 0 r
F P
0 0 0 r
s
P
p
.002 w
.77191 .51685 m .78428 .51514 L .79024 .51908 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57071 .55856 m .55915 .57226 L .55133 .51868 L p
.978 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7292 .52743 m .71707 .52908 L .71032 .51576 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.69843 .52689 m .71032 .51576 L .71707 .52908 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.17796 .246 m .19889 .2494 L .18846 .25195 L 1 .698 0 r
F
P
p
.16756 .24858 m .17796 .246 L .18846 .25195 L 1 .698 0 r
F
P
p
.28277 .24589 m .30326 .24929 L .29249 .25184 L 1 .698 0 r
F
P
p
.27203 .24847 m .28277 .24589 L .29249 .25184 L 1 .698 0 r
F
P
p
.38762 .24578 m .40765 .24918 L .39655 .25174 L 1 .802 0 r
F
P
p
.37653 .24836 m .38762 .24578 L .39655 .25174 L 1 .837 0 r
F
P
p
.49249 .24568 m .51208 .24908 L .50063 .25163 L 1 .698 0 r
F
P
p
.48106 .24826 m .49249 .24568 L .50063 .25163 L 1 .698 0 r
F
P
p
.002 w
.45849 .51706 m .44722 .51875 L .43867 .51481 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42742 .51651 m .43867 .51481 L .44722 .51875 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25746 .57772 m .24684 .57922 L .23678 .57573 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22618 .57724 m .23678 .57573 L .24684 .57922 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61331 .55749 m .60154 .55905 L .59408 .54591 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58233 .54751 m .59408 .54591 L .60154 .55905 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.59738 .24557 m .61653 .24897 L .60475 .25153 L 1 .698 0 r
F
P
p
.58561 .24815 m .59738 .24557 L .60475 .25153 L 1 .698 0 r
F
P
p
.002 w
.55133 .51868 m .56294 .51699 L .57071 .55856 L p
.978 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56294 .51699 m .55133 .51868 L .54356 .51474 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53197 .51644 m .54356 .51474 L .55133 .51868 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.78428 .51514 m .79672 .51343 L .80197 .50007 L p
1 .633 0 r
F P
0 0 0 r
s
P
p
.70231 .24546 m .72101 .24886 L .70889 .25142 L 1 .629 0 r
F
P
p
.6902 .24804 m .70231 .24546 L .70889 .25142 L 1 .673 0 r
F
P
p
.002 w
.66741 .51692 m .65546 .51861 L .64893 .54319 L p
1 .851 0 r
F P
0 0 0 r
s
P
p
.80726 .24536 m .82552 .24876 L .81306 .25132 L 1 .14 0 r
F
P
p
.79481 .24794 m .80726 .24536 L .81306 .25132 L 1 .314 0 r
F
P
p
.002 w
.77191 .51685 m .75963 .51854 L .75343 .5146 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74142 .52576 m .75343 .5146 L .75963 .51854 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.34265 .53767 m .3315 .54873 L .32185 .55263 L p
.871 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31077 .5602 m .32185 .55263 L .3315 .54873 L p
.756 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69843 .52689 m .68638 .52856 L .67943 .51521 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.66741 .51692 m .67943 .51521 L .68638 .52856 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.14647 .24517 m .16756 .24858 L .15722 .25114 L 1 .698 0 r
F
P
p
.13616 .24775 m .14647 .24517 L .15722 .25114 L 1 .698 0 r
F
P
p
.002 w
.82607 .47624 m .83324 .51793 L p
.81606 .48305 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.84497 .49739 m .83324 .51793 L .82607 .47624 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.82607 .47624 m .83822 .46501 L .84497 .49739 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.82607 .47624 m .82148 .50043 L p
.83614 .4694 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.83822 .46501 m .82607 .47624 L p
.83614 .4694 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.81361 .47807 m .82607 .47624 L p
.81606 .48305 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.82607 .47624 m .81361 .47807 L .80889 .50219 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.79672 .51343 m .80889 .50219 L .81361 .47807 L p
1 .459 0 r
F P
0 0 0 r
s
P
p
.25139 .24507 m .27203 .24847 L .26135 .25103 L 1 .698 0 r
F
P
p
.24074 .24765 m .25139 .24507 L .26135 .25103 L 1 .698 0 r
F
P
p
.35634 .24496 m .37653 .24836 L .36552 .25092 L 1 .703 0 r
F
P
p
.34534 .24754 m .35634 .24496 L .36552 .25092 L 1 .738 0 r
F
P
p
.002 w
.29977 .56718 m .289 .56871 L .27925 .56515 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26815 .57622 m .27925 .56515 L .289 .56871 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.46131 .24485 m .48106 .24826 L .4697 .25082 L 1 .724 0 r
F
P
p
.44997 .24743 m .46131 .24485 L .4697 .25082 L 1 .753 0 r
F
P
p
.002 w
.42742 .51651 m .41624 .51821 L .40744 .51426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39628 .51597 m .40744 .51426 L .41624 .51821 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.22618 .57724 m .21565 .57874 L .20534 .57525 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19483 .57676 m .20534 .57525 L .21565 .57874 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58233 .54751 m .57071 .55856 L .56294 .51699 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.56632 .24474 m .58561 .24815 L .57392 .25071 L 1 .698 0 r
F
P
p
.55464 .24733 m .56632 .24474 L .57392 .25071 L 1 .698 0 r
F
P
p
.002 w
.53197 .51644 m .52045 .51814 L .51244 .51419 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50093 .5159 m .51244 .51419 L .52045 .51814 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67135 .24464 m .6902 .24804 L .67817 .25061 L 1 .698 0 r
F
P
p
.65932 .24722 m .67135 .24464 L .67817 .25061 L 1 .698 0 r
F
P
p
.77641 .24453 m .79481 .24794 L .78244 .2505 L 1 .349 0 r
F
P
p
.76404 .24711 m .77641 .24453 L .78244 .2505 L 1 .488 0 r
F
P
p
.002 w
.86891 .4656 m .8563 .46746 L .85083 .46313 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8563 .46746 m .84497 .49739 L .83822 .46501 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.83822 .46501 m .85083 .46313 L .8563 .46746 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.11492 .24434 m .13616 .24775 L .12592 .25032 L 1 .698 0 r
F
P
p
.1047 .24693 m .11492 .24434 L .12592 .25032 L 1 .698 0 r
F
P
p
.21994 .24424 m .24074 .24765 L .23015 .25021 L 1 .698 0 r
F
P
p
.20938 .24682 m .21994 .24424 L .23015 .25021 L 1 .698 0 r
F
P
p
.325 .24413 m .34534 .24754 L .33442 .25011 L 1 .698 0 r
F
P
p
.31409 .24672 m .325 .24413 L .33442 .25011 L 1 .698 0 r
F
P
p
.43008 .24402 m .44997 .24743 L .43871 .25 L 1 .807 0 r
F
P
p
.41883 .24661 m .43008 .24402 L .43871 .25 L 1 .837 0 r
F
P
p
.002 w
.39628 .51597 m .38519 .51767 L .37615 .51371 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19483 .57676 m .18439 .57826 L .17431 .56521 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1639 .56675 m .17431 .56521 L .18439 .57826 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.53518 .24391 m .55464 .24733 L .54303 .2499 L 1 .698 0 r
F
P
p
.52359 .2465 m .53518 .24391 L .54303 .2499 L 1 .698 0 r
F
P
p
.002 w
.50093 .5159 m .4895 .5176 L .48125 .51364 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46983 .51535 m .48125 .51364 L .4895 .5176 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.64032 .24381 m .65932 .24722 L .64738 .24979 L 1 .698 0 r
F
P
p
.62839 .2464 m .64032 .24381 L .64738 .24979 L 1 .698 0 r
F
P
p
.002 w
.35373 .53094 m .34265 .53767 L .33287 .54885 L p
.932 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32185 .55263 m .33287 .54885 L .34265 .53767 L p
.871 1 0 r
F P
0 0 0 r
s
P
p
.74549 .2437 m .76404 .24711 L .75176 .24968 L 1 .698 0 r
F
P
p
.73321 .24629 m .74549 .2437 L .75176 .24968 L 1 .698 0 r
F
P
p
.002 w
.74142 .52576 m .7292 .52743 L .72252 .51405 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.71032 .51576 m .72252 .51405 L .7292 .52743 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.18843 .24341 m .20938 .24682 L .19889 .2494 L 1 .698 0 r
F
P
p
.17796 .246 m .18843 .24341 L .19889 .2494 L 1 .698 0 r
F
P
p
.29359 .2433 m .31409 .24672 L .30326 .24929 L 1 .698 0 r
F
P
p
.28277 .24589 m .29359 .2433 L .30326 .24929 L 1 .698 0 r
F
P
p
.002 w
.59408 .54591 m .58233 .54751 L .57462 .51528 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.56294 .51699 m .57462 .51528 L .58233 .54751 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.39877 .24319 m .41883 .24661 L .40765 .24918 L 1 .767 0 r
F
P
p
.38762 .24578 m .39877 .24319 L .40765 .24918 L 1 .802 0 r
F
P
p
.002 w
.1639 .56675 m .15307 .57778 L .14227 .57428 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.50399 .24308 m .52359 .2465 L .51208 .24908 L 1 .698 0 r
F
P
p
.49249 .24568 m .50399 .24308 L .51208 .24908 L 1 .698 0 r
F
P
p
.002 w
.46983 .51535 m .45849 .51706 L .45 .51309 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43867 .51481 m .45 .51309 L .45849 .51706 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26815 .57622 m .25746 .57772 L .24745 .57422 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23678 .57573 m .24745 .57422 L .25746 .57772 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62516 .55592 m .61331 .55749 L .6058 .53478 L p
.892 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59408 .54591 m .6058 .53478 L .61331 .55749 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.60923 .24297 m .62839 .2464 L .61653 .24897 L 1 .698 0 r
F
P
p
.59738 .24557 m .60923 .24297 L .61653 .24897 L 1 .698 0 r
F
P
p
.002 w
.57462 .51528 m .56294 .51699 L .55523 .51302 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54356 .51474 m .55523 .51302 L .56294 .51699 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.7145 .24287 m .73321 .24629 L .72101 .24886 L 1 .549 0 r
F
P
p
.70231 .24546 m .7145 .24287 L .72101 .24886 L 1 .629 0 r
F
P
p
.002 w
.66073 .52627 m .66741 .51692 L p
.65079 .54054 L 1 .851 0 r
F P
0 0 0 r
s
P
p
.002 w
.64893 .54319 m .66073 .52627 L p
.65079 .54054 L 1 .851 0 r
F P
0 0 0 r
s
P
p
.002 w
.66073 .52627 m .65363 .5185 L p
.6707 .51194 L 1 .781 0 r
F P
0 0 0 r
s
P
p
.002 w
.67943 .51521 m .66741 .51692 L .66073 .52627 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.002 w
.67259 .51122 m .66073 .52627 L p
.6707 .51194 L 1 .781 0 r
F P
0 0 0 r
s
P
p
.8198 .24276 m .83806 .24618 L .82552 .24876 L 1 .035 0 r
F
P
p
.80726 .24536 m .8198 .24276 L .82552 .24876 L 1 .14 0 r
F
P
p
.002 w
.78428 .51514 m .77191 .51685 L .76579 .51288 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75343 .5146 m .76579 .51288 L .77191 .51685 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.71032 .51576 m .69843 .52689 L .69154 .5135 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.67943 .51521 m .69154 .5135 L .69843 .52689 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.15685 .24257 m .17796 .246 L .16756 .24858 L 1 .698 0 r
F
P
p
.14647 .24517 m .15685 .24257 L .16756 .24858 L 1 .698 0 r
F
P
p
.002 w
.80889 .50219 m .82148 .50043 L .82607 .47624 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.26212 .24247 m .28277 .24589 L .27203 .24847 L 1 .698 0 r
F
P
p
.25139 .24507 m .26212 .24247 L .27203 .24847 L 1 .698 0 r
F
P
p
.36741 .24236 m .38762 .24578 L .37653 .24836 L 1 .698 0 r
F
P
p
.35634 .24496 m .36741 .24236 L .37653 .24836 L 1 .703 0 r
F
P
p
.002 w
.31077 .5602 m .29977 .56718 L .29006 .56359 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27925 .56515 m .29006 .56359 L .29977 .56718 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.47273 .24225 m .49249 .24568 L .48106 .24826 L 1 .703 0 r
F
P
p
.46131 .24485 m .47273 .24225 L .48106 .24826 L 1 .724 0 r
F
P
p
.002 w
.43867 .51481 m .42742 .51651 L .41868 .51254 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40744 .51426 m .41868 .51254 L .42742 .51651 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23678 .57573 m .22618 .57724 L .21592 .57373 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20534 .57525 m .21592 .57373 L .22618 .57724 L p
.465 1 0 r
F P
0 0 0 r
s
P
p
.57807 .24214 m .59738 .24557 L .58561 .24815 L 1 .698 0 r
F
P
p
.56632 .24474 m .57807 .24214 L .58561 .24815 L 1 .698 0 r
F
P
p
.002 w
.54356 .51474 m .53197 .51644 L .52402 .51247 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51244 .51419 m .52402 .51247 L .53197 .51644 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68345 .24203 m .70231 .24546 L .6902 .24804 L 1 .673 0 r
F
P
p
.67135 .24464 m .68345 .24203 L .6902 .24804 L 1 .698 0 r
F
P
p
.78885 .24193 m .80726 .24536 L .79481 .24794 L 1 .244 0 r
F
P
p
.77641 .24453 m .78885 .24193 L .79481 .24794 L 1 .349 0 r
F
P
p
.002 w
.85083 .46313 m .86352 .46124 L .86891 .4656 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.12521 .24174 m .14647 .24517 L .13616 .24775 L 1 .698 0 r
F
P
p
.11492 .24434 m .12521 .24174 L .13616 .24775 L 1 .698 0 r
F
P
p
.002 w
.36485 .5249 m .35373 .53094 L .3439 .54724 L p
.987 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33287 .54885 m .3439 .54724 L .35373 .53094 L p
.932 1 0 r
F P
0 0 0 r
s
P
p
.23058 .24163 m .25139 .24507 L .24074 .24765 L 1 .698 0 r
F
P
p
.21994 .24424 m .23058 .24163 L .24074 .24765 L 1 .698 0 r
F
P
p
.002 w
.17431 .56521 m .1639 .56675 L .15316 .56316 L p
.605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.14227 .57428 m .15316 .56316 L .1639 .56675 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.33597 .24152 m .35634 .24496 L .34534 .24754 L 1 .698 0 r
F
P
p
.325 .24413 m .33597 .24152 L .34534 .24754 L 1 .698 0 r
F
P
p
.4414 .24141 m .46131 .24485 L .44997 .24743 L 1 .758 0 r
F
P
p
.43008 .24402 m .4414 .24141 L .44997 .24743 L 1 .807 0 r
F
P
p
.002 w
.40744 .51426 m .39628 .51597 L .38729 .51199 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37615 .51371 m .38729 .51199 L .39628 .51597 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20534 .57525 m .19483 .57676 L .18615 .53505 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17431 .56521 m .18615 .53505 L .19483 .57676 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.54685 .24131 m .56632 .24474 L .55464 .24733 L 1 .698 0 r
F
P
p
.53518 .24391 m .54685 .24131 L .55464 .24733 L 1 .698 0 r
F
P
p
.002 w
.51244 .51419 m .50093 .5159 L .49274 .51192 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48125 .51364 m .49274 .51192 L .50093 .5159 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.65233 .2412 m .67135 .24464 L .65932 .24722 L 1 .698 0 r
F
P
p
.64032 .24381 m .65233 .2412 L .65932 .24722 L 1 .698 0 r
F
P
p
.75784 .24109 m .77641 .24453 L .76404 .24711 L 1 .698 0 r
F
P
p
.74549 .2437 m .75784 .24109 L .76404 .24711 L 1 .698 0 r
F
P
p
.002 w
.72252 .51405 m .71032 .51576 L .70372 .51177 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69154 .5135 m .70372 .51177 L .71032 .51576 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.85083 .46313 m .83822 .46501 L .83397 .49416 L p
1 .228 0 r
F P
0 0 0 r
s
P
p
.002 w
.82148 .50043 m .83397 .49416 L .83822 .46501 L p
1 .298 0 r
F P
0 0 0 r
s
P
p
.0935 .2409 m .11492 .24434 L .1047 .24693 L 1 .698 0 r
F
P
p
.002 w
.75343 .5146 m .74142 .52576 L .73479 .51233 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.72252 .51405 m .73479 .51233 L .74142 .52576 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.19897 .2408 m .21994 .24424 L .20938 .24682 L 1 .698 0 r
F
P
p
.18843 .24341 m .19897 .2408 L .20938 .24682 L 1 .698 0 r
F
P
p
.30447 .24069 m .325 .24413 L .31409 .24672 L 1 .698 0 r
F
P
p
.29359 .2433 m .30447 .24069 L .31409 .24672 L 1 .698 0 r
F
P
p
.002 w
.6058 .53478 m .59408 .54591 L .58638 .51357 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.57462 .51528 m .58638 .51357 L .59408 .54591 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.41 .24058 m .43008 .24402 L .41883 .24661 L 1 .767 0 r
F
P
p
.39877 .24319 m .41 .24058 L .41883 .24661 L 1 .767 0 r
F
P
p
.51556 .24047 m .53518 .24391 L .52359 .2465 L 1 .698 0 r
F
P
p
.50399 .24308 m .51556 .24047 L .52359 .2465 L 1 .698 0 r
F
P
p
.002 w
.48125 .51364 m .46983 .51535 L .4614 .51136 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45 .51309 m .4614 .51136 L .46983 .51535 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27925 .56515 m .26815 .57622 L .25855 .56309 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24745 .57422 m .25855 .56309 L .26815 .57622 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63695 .54481 m .62516 .55592 L .61765 .53075 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6058 .53478 m .61765 .53075 L .62516 .55592 L p
.892 1 0 r
F P
0 0 0 r
s
P
p
.62115 .24036 m .64032 .24381 L .62839 .2464 L 1 .698 0 r
F
P
p
.60923 .24297 m .62115 .24036 L .62839 .2464 L 1 .698 0 r
F
P
p
.002 w
.58638 .51357 m .57462 .51528 L .56698 .51129 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55523 .51302 m .56698 .51129 L .57462 .51528 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29006 .56359 m .30095 .56203 L .31077 .5602 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32185 .55263 m .31077 .5602 L .30095 .56203 L p
.666 1 0 r
F P
0 0 0 r
s
P
p
.72677 .24025 m .74549 .2437 L .73321 .24629 L 1 .488 0 r
F
P
p
.7145 .24287 m .72677 .24025 L .73321 .24629 L 1 .549 0 r
F
P
p
.002 w
.69154 .5135 m .67943 .51521 L .67259 .51122 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.66073 .52627 m .67259 .51122 L .67943 .51521 L p
1 .747 0 r
F P
0 0 0 r
s
P
p
.8198 .24276 m .83242 .24014 L .83806 .24618 L 1 .035 0 r
F
P
p
.002 w
.79672 .51343 m .78428 .51514 L .77823 .51115 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.76579 .51288 m .77823 .51115 L .78428 .51514 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.1673 .23996 m .18843 .24341 L .17796 .246 L 1 .698 0 r
F
P
p
.15685 .24257 m .1673 .23996 L .17796 .246 L 1 .698 0 r
F
P
p
.27291 .23985 m .29359 .2433 L .28277 .24589 L 1 .698 0 r
F
P
p
.26212 .24247 m .27291 .23985 L .28277 .24589 L 1 .698 0 r
F
P
p
.37855 .23974 m .39877 .24319 L .38762 .24578 L 1 .698 0 r
F
P
p
.36741 .24236 m .37855 .23974 L .38762 .24578 L 1 .698 0 r
F
P
p
.48421 .23963 m .50399 .24308 L .49249 .24568 L 1 .698 0 r
F
P
p
.47273 .24225 m .48421 .23963 L .49249 .24568 L 1 .703 0 r
F
P
p
.002 w
.45 .51309 m .43867 .51481 L .42999 .51081 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41868 .51254 m .42999 .51081 L .43867 .51481 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24745 .57422 m .23678 .57573 L .22697 .56259 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.21592 .57373 m .22697 .56259 L .23678 .57573 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.18615 .53505 m .19709 .52389 L .20534 .57525 L p
.779 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.19709 .52389 m .18615 .53505 L .17555 .53121 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.18615 .53505 m .17431 .56521 L .16361 .56159 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16361 .56159 m .17555 .53121 L .18615 .53505 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3439 .54724 m .35514 .54012 L .36485 .5249 L p
.987 1 0 r
F P
0 0 0 r
s
P
p
.58991 .23952 m .60923 .24297 L .59738 .24557 L 1 .698 0 r
F
P
p
.57807 .24214 m .58991 .23952 L .59738 .24557 L 1 .698 0 r
F
P
p
.002 w
.55523 .51302 m .54356 .51474 L .53568 .51074 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52402 .51247 m .53568 .51074 L .54356 .51474 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69563 .23941 m .7145 .24287 L .70231 .24546 L 1 .616 0 r
F
P
p
.68345 .24203 m .69563 .23941 L .70231 .24546 L 1 .673 0 r
F
P
p
.80138 .23931 m .8198 .24276 L .80726 .24536 L 1 .14 0 r
F
P
p
.78885 .24193 m .80138 .23931 L .80726 .24536 L 1 .244 0 r
F
P
p
.002 w
.76579 .51288 m .75343 .5146 L .74714 .51059 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.73479 .51233 m .74714 .51059 L .75343 .5146 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.13556 .23912 m .15685 .24257 L .14647 .24517 L 1 .698 0 r
F
P
p
.12521 .24174 m .13556 .23912 L .14647 .24517 L 1 .698 0 r
F
P
p
.002 w
.61765 .53075 m .6058 .53478 L .59822 .51184 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.002 w
.58638 .51357 m .59822 .51184 L .6058 .53478 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.24128 .23901 m .26212 .24247 L .25139 .24507 L 1 .698 0 r
F
P
p
.23058 .24163 m .24128 .23901 L .25139 .24507 L 1 .698 0 r
F
P
p
.002 w
.15316 .56316 m .16361 .56159 L p
.16904 .5647 L .605 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15316 .56316 m .14227 .57428 L .1313 .57072 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16361 .56159 m .15316 .56316 L .14173 .56917 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.14173 .56917 m .15223 .56761 L .16361 .56159 L p
.535 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16361 .56159 m .15223 .56761 L p
.1581 .55844 L .674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.17555 .53121 m .16361 .56159 L p
.1581 .55844 L .674 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.16361 .56159 m .17431 .56521 L p
.16904 .5647 L .605 1 0 r
F P
0 0 0 r
s
P
p
.34702 .2389 m .36741 .24236 L .35634 .24496 L 1 .698 0 r
F
P
p
.33597 .24152 m .34702 .2389 L .35634 .24496 L 1 .698 0 r
F
P
p
.002 w
.29006 .56359 m .27925 .56515 L .26934 .56153 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25855 .56309 m .26934 .56153 L .27925 .56515 L p
.57 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61765 .53075 m .62956 .52573 L .63695 .54481 L p
.948 1 0 r
F P
0 0 0 r
s
P
p
.45279 .23879 m .47273 .24225 L .46131 .24485 L 1 .724 0 r
F
P
p
.4414 .24141 m .45279 .23879 L .46131 .24485 L 1 .758 0 r
F
P
p
.002 w
.41868 .51254 m .40744 .51426 L .39851 .51025 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38729 .51199 m .39851 .51025 L .40744 .51426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21592 .57373 m .20534 .57525 L .19709 .52389 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.5586 .23868 m .57807 .24214 L .56632 .24474 L 1 .698 0 r
F
P
p
.54685 .24131 m .5586 .23868 L .56632 .24474 L 1 .698 0 r
F
P
p
.002 w
.52402 .51247 m .51244 .51419 L .50431 .51018 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49274 .51192 m .50431 .51018 L .51244 .51419 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66443 .23857 m .68345 .24203 L .67135 .24464 L 1 .698 0 r
F
P
p
.65233 .2412 m .66443 .23857 L .67135 .24464 L 1 .698 0 r
F
P
p
.77028 .23846 m .78885 .24193 L .77641 .24453 L 1 .61 0 r
F
P
p
.75784 .24109 m .77028 .23846 L .77641 .24453 L 1 .698 0 r
F
P
p
.002 w
.73479 .51233 m .72252 .51405 L .71598 .51004 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.70372 .51177 m .71598 .51004 L .72252 .51405 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.86352 .46124 m .85083 .46313 L .8465 .48729 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.83397 .49416 m .8465 .48729 L .85083 .46313 L p
1 .228 0 r
F P
0 0 0 r
s
P
p
.002 w
.33287 .54885 m .32185 .55263 L .31191 .56045 L p
.716 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.30095 .56203 m .31191 .56045 L .32185 .55263 L p
.666 1 0 r
F P
0 0 0 r
s
P
p
.10376 .23828 m .12521 .24174 L .11492 .24434 L 1 .698 0 r
F
P
p
.0935 .2409 m .10376 .23828 L .11492 .24434 L 1 .698 0 r
F
P
p
.20958 .23817 m .23058 .24163 L .21994 .24424 L 1 .698 0 r
F
P
p
.19897 .2408 m .20958 .23817 L .21994 .24424 L 1 .698 0 r
F
P
p
.31543 .23806 m .33597 .24152 L .325 .24413 L 1 .698 0 r
F
P
p
.30447 .24069 m .31543 .23806 L .325 .24413 L 1 .698 0 r
F
P
p
.002 w
.19709 .52389 m .20765 .5222 L .21592 .57373 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20765 .5222 m .19709 .52389 L .18609 .52953 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.17555 .53121 m .18609 .52953 L .19709 .52389 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.42131 .23795 m .4414 .24141 L .43008 .24402 L 1 .738 0 r
F
P
p
.41 .24058 m .42131 .23795 L .43008 .24402 L 1 .767 0 r
F
P
p
.002 w
.38729 .51199 m .37615 .51371 L .36631 .53847 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.35514 .54012 m .36631 .53847 L .37615 .51371 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.52722 .23784 m .54685 .24131 L .53518 .24391 L 1 .698 0 r
F
P
p
.51556 .24047 m .52722 .23784 L .53518 .24391 L 1 .698 0 r
F
P
p
.002 w
.49274 .51192 m .48125 .51364 L .47287 .50962 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4614 .51136 m .47287 .50962 L .48125 .51364 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.63315 .23773 m .65233 .2412 L .64032 .24381 L 1 .698 0 r
F
P
p
.62115 .24036 m .63315 .23773 L .64032 .24381 L 1 .698 0 r
F
P
p
.002 w
.59822 .51184 m .58638 .51357 L .5788 .50955 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56698 .51129 m .5788 .50955 L .58638 .51357 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73912 .23762 m .75784 .24109 L .74549 .2437 L 1 .453 0 r
F
P
p
.72677 .24025 m .73912 .23762 L .74549 .2437 L 1 .488 0 r
F
P
p
.002 w
.70372 .51177 m .69154 .5135 L .68476 .50948 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.67259 .51122 m .68476 .50948 L .69154 .5135 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.80889 .50219 m .79672 .51343 L .79075 .50941 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.77823 .51115 m .79075 .50941 L .79672 .51343 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.17782 .23732 m .19897 .2408 L .18843 .24341 L 1 .698 0 r
F
P
p
.1673 .23996 m .17782 .23732 L .18843 .24341 L 1 .698 0 r
F
P
p
.28377 .23722 m .30447 .24069 L .29359 .2433 L 1 .698 0 r
F
P
p
.27291 .23985 m .28377 .23722 L .29359 .2433 L 1 .698 0 r
F
P
p
.38976 .23711 m .41 .24058 L .39877 .24319 L 1 .698 0 r
F
P
p
.37855 .23974 m .38976 .23711 L .39877 .24319 L 1 .698 0 r
F
P
p
.49577 .237 m .51556 .24047 L .50399 .24308 L 1 .698 0 r
F
P
p
.48421 .23963 m .49577 .237 L .50399 .24308 L 1 .698 0 r
F
P
p
.002 w
.4614 .51136 m .45 .51309 L .44137 .50906 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42999 .51081 m .44137 .50906 L .45 .51309 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25855 .56309 m .24745 .57422 L .23923 .52274 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.22697 .56259 m .23923 .52274 L .24745 .57422 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.60182 .23689 m .62115 .24036 L .60923 .24297 L 1 .698 0 r
F
P
p
.58991 .23952 m .60182 .23689 L .60923 .24297 L 1 .698 0 r
F
P
p
.002 w
.56698 .51129 m .55523 .51302 L .54741 .50899 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53568 .51074 m .54741 .50899 L .55523 .51302 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70789 .23678 m .72677 .24025 L .7145 .24287 L 1 .492 0 r
F
P
p
.69563 .23941 m .70789 .23678 L .7145 .24287 L 1 .616 0 r
F
P
p
.002 w
.62956 .52573 m .61765 .53075 L .61013 .51011 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.002 w
.59822 .51184 m .61013 .51011 L .61765 .53075 L p
1 .828 0 r
F P
0 0 0 r
s
P
p
.81399 .23667 m .83242 .24014 L .8198 .24276 L 1 .07 0 r
F
P
p
.80138 .23931 m .81399 .23667 L .8198 .24276 L 1 .14 0 r
F
P
p
.002 w
.77823 .51115 m .76579 .51288 L .75957 .50885 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74714 .51059 m .75957 .50885 L .76579 .51288 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.14599 .23648 m .1673 .23996 L .15685 .24257 L 1 .698 0 r
F
P
p
.13556 .23912 m .14599 .23648 L .15685 .24257 L 1 .698 0 r
F
P
p
.25205 .23637 m .27291 .23985 L .26212 .24247 L 1 .698 0 r
F
P
p
.24128 .23901 m .25205 .23637 L .26212 .24247 L 1 .698 0 r
F
P
p
.35814 .23626 m .37855 .23974 L .36741 .24236 L 1 .698 0 r
F
P
p
.34702 .2389 m .35814 .23626 L .36741 .24236 L 1 .698 0 r
F
P
p
.002 w
.30095 .56203 m .29006 .56359 L .2804 .55444 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26934 .56153 m .2804 .55444 L .29006 .56359 L p
.625 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66073 .52627 m .64893 .54319 L .64159 .52404 L p
1 .935 0 r
F P
0 0 0 r
s
P
p
.002 w
.62956 .52573 m .64159 .52404 L .64893 .54319 L p
.995 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23923 .52274 m .24995 .52104 L .25855 .56309 L p
.849 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24995 .52104 m .23923 .52274 L .22939 .50921 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.23923 .52274 m .22697 .56259 L .2187 .51095 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.2187 .51095 m .22939 .50921 L .23923 .52274 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.46427 .23615 m .48421 .23963 L .47273 .24225 L 1 .703 0 r
F
P
p
.45279 .23879 m .46427 .23615 L .47273 .24225 L 1 .724 0 r
F
P
p
.002 w
.42999 .51081 m .41868 .51254 L .40981 .50851 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39851 .51025 m .40981 .50851 L .41868 .51254 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.22697 .56259 m .21592 .57373 L .20765 .5222 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.57042 .23604 m .58991 .23952 L .57807 .24214 L 1 .698 0 r
F
P
p
.5586 .23868 m .57042 .23604 L .57807 .24214 L 1 .698 0 r
F
P
p
.002 w
.53568 .51074 m .52402 .51247 L .51595 .50843 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50431 .51018 m .51595 .50843 L .52402 .51247 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3231 .55335 m .33287 .54885 L p
.31439 .55908 L .716 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31191 .56045 m .3231 .55335 L p
.31439 .55908 L .716 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3231 .55335 m .31441 .51643 L p
.33187 .54758 L .924 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3439 .54724 m .33287 .54885 L .3231 .55335 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3231 .55335 m .3342 .55174 L .3439 .54724 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3342 .55174 m .3231 .55335 L p
.33187 .54758 L .924 1 0 r
F P
0 0 0 r
s
P
p
.6766 .23593 m .69563 .23941 L .68345 .24203 L 1 .698 0 r
F
P
p
.66443 .23857 m .6766 .23593 L .68345 .24203 L 1 .698 0 r
F
P
p
.002 w
.82148 .50043 m .80889 .50219 L .80335 .50765 L p
1 .628 0 r
F P
0 0 0 r
s
P
p
.002 w
.79075 .50941 m .80335 .50765 L .80889 .50219 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.78281 .23582 m .80138 .23931 L .78885 .24193 L 1 .516 0 r
F
P
p
.77028 .23846 m .78281 .23582 L .78885 .24193 L 1 .61 0 r
F
P
p
.002 w
.74714 .51059 m .73479 .51233 L .72832 .50829 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.71598 .51004 m .72832 .50829 L .73479 .51233 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.8465 .48729 m .85804 .45681 L .86352 .46124 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.11409 .23563 m .13556 .23912 L .12521 .24174 L 1 .698 0 r
F
P
p
.10376 .23828 m .11409 .23563 L .12521 .24174 L 1 .698 0 r
F
P
p
.22026 .23552 m .24128 .23901 L .23058 .24163 L 1 .698 0 r
F
P
p
.20958 .23817 m .22026 .23552 L .23058 .24163 L 1 .698 0 r
F
P
p
.002 w
.1313 .57072 m .14173 .56917 L .15316 .56316 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.32646 .23541 m .34702 .2389 L .33597 .24152 L 1 .698 0 r
F
P
p
.31543 .23806 m .32646 .23541 L .33597 .24152 L 1 .698 0 r
F
P
p
.002 w
.26934 .56153 m .25855 .56309 L .24995 .52104 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.20765 .5222 m .2187 .51095 L .22697 .56259 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2187 .51095 m .20765 .5222 L .19716 .51823 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.18609 .52953 m .19716 .51823 L .20765 .5222 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.43269 .2353 m .45279 .23879 L .4414 .24141 L 1 .703 0 r
F
P
p
.42131 .23795 m .43269 .2353 L .4414 .24141 L 1 .738 0 r
F
P
p
.002 w
.39851 .51025 m .38729 .51199 L .37776 .52716 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.36631 .53847 m .37776 .52716 L .38729 .51199 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.002 w
.64159 .52404 m .65363 .5185 L .66073 .52627 L p
1 .935 0 r
F P
0 0 0 r
s
P
p
.53895 .23519 m .5586 .23868 L .54685 .24131 L 1 .698 0 r
F
P
p
.52722 .23784 m .53895 .23519 L .54685 .24131 L 1 .698 0 r
F
P
p
.002 w
.50431 .51018 m .49274 .51192 L .48442 .50787 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47287 .50962 m .48442 .50787 L .49274 .51192 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.64524 .23508 m .66443 .23857 L .65233 .2412 L 1 .698 0 r
F
P
p
.63315 .23773 m .64524 .23508 L .65233 .2412 L 1 .698 0 r
F
P
p
.002 w
.61013 .51011 m .59822 .51184 L .5907 .5078 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5788 .50955 m .5907 .5078 L .59822 .51184 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75155 .23497 m .77028 .23846 L .75784 .24109 L 1 .419 0 r
F
P
p
.73912 .23762 m .75155 .23497 L .75784 .24109 L 1 .453 0 r
F
P
p
.002 w
.71598 .51004 m .70372 .51177 L .69701 .50773 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.68476 .50948 m .69701 .50773 L .70372 .51177 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.1884 .23467 m .20958 .23817 L .19897 .2408 L 1 .698 0 r
F
P
p
.17782 .23732 m .1884 .23467 L .19897 .2408 L 1 .698 0 r
F
P
p
.29471 .23456 m .31543 .23806 L .30447 .24069 L 1 .698 0 r
F
P
p
.28377 .23722 m .29471 .23456 L .30447 .24069 L 1 .698 0 r
F
P
p
.40105 .23445 m .42131 .23795 L .41 .24058 L 1 .698 0 r
F
P
p
.38976 .23711 m .40105 .23445 L .41 .24058 L 1 .698 0 r
F
P
p
.002 w
.64159 .52404 m .62956 .52573 L .62212 .50836 L p
1 .795 0 r
F P
0 0 0 r
s
P
p
.002 w
.61013 .51011 m .62212 .50836 L .62956 .52573 L p
1 .808 0 r
F P
0 0 0 r
s
P
p
.50741 .23434 m .52722 .23784 L .51556 .24047 L 1 .698 0 r
F
P
p
.49577 .237 m .50741 .23434 L .51556 .24047 L 1 .698 0 r
F
P
p
.002 w
.47287 .50962 m .4614 .51136 L .45283 .50731 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44137 .50906 m .45283 .50731 L .4614 .51136 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.61381 .23423 m .63315 .23773 L .62115 .24036 L 1 .673 0 r
F
P
p
.60182 .23689 m .61381 .23423 L .62115 .24036 L 1 .698 0 r
F
P
p
.002 w
.5788 .50955 m .56698 .51129 L .55922 .50724 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54741 .50899 m .55922 .50724 L .56698 .51129 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72023 .23412 m .73912 .23762 L .72677 .24025 L 1 .381 0 r
F
P
p
.70789 .23678 m .72023 .23412 L .72677 .24025 L 1 .492 0 r
F
P
p
.002 w
.68476 .50948 m .67259 .51122 L .66564 .50716 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.65363 .5185 m .66564 .50716 L .67259 .51122 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.81399 .23667 m .82669 .23401 L .83242 .24014 L 1 .07 0 r
F
P
p
.002 w
.79075 .50941 m .77823 .51115 L .77208 .50709 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75957 .50885 m .77208 .50709 L .77823 .51115 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.15648 .23382 m .17782 .23732 L .1673 .23996 L 1 .698 0 r
F
P
p
.14599 .23648 m .15648 .23382 L .1673 .23996 L 1 .698 0 r
F
P
p
.26289 .23371 m .28377 .23722 L .27291 .23985 L 1 .698 0 r
F
P
p
.25205 .23637 m .26289 .23371 L .27291 .23985 L 1 .698 0 r
F
P
p
.002 w
.22939 .50921 m .2187 .51095 L .20827 .50689 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19716 .51823 m .20827 .50689 L .2187 .51095 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.36934 .2336 m .38976 .23711 L .37855 .23974 L 1 .698 0 r
F
P
p
.35814 .23626 m .36934 .2336 L .37855 .23974 L 1 .698 0 r
F
P
p
.002 w
.31191 .56045 m .30095 .56203 L .29147 .5487 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2804 .55444 m .29147 .5487 L .30095 .56203 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.24995 .52104 m .2611 .50977 L .26934 .56153 L p
.919 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.2611 .50977 m .24995 .52104 L .24014 .50746 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.22939 .50921 m .24014 .50746 L .24995 .52104 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.47581 .23349 m .49577 .237 L .48421 .23963 L 1 .698 0 r
F
P
p
.46427 .23615 m .47581 .23349 L .48421 .23963 L 1 .703 0 r
F
P
p
.002 w
.44137 .50906 m .42999 .51081 L .42117 .50675 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40981 .50851 m .42117 .50675 L .42999 .51081 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.18609 .52953 m .17555 .53121 L .1633 .55631 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15223 .56761 m .1633 .55631 L .17555 .53121 L p
.674 1 0 r
F P
0 0 0 r
s
P
p
.58232 .23338 m .60182 .23689 L .58991 .23952 L 1 .698 0 r
F
P
p
.57042 .23604 m .58232 .23338 L .58991 .23952 L 1 .698 0 r
F
P
p
.002 w
.54741 .50899 m .53568 .51074 L .52767 .50667 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51595 .50843 m .52767 .50667 L .53568 .51074 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35514 .54012 m .3439 .54724 L .3342 .55174 L p
.771 1 0 r
F P
0 0 0 r
s
P
p
.68885 .23327 m .70789 .23678 L .69563 .23941 L 1 .684 0 r
F
P
p
.6766 .23593 m .68885 .23327 L .69563 .23941 L 1 .698 0 r
F
P
p
.002 w
.83397 .49416 m .82148 .50043 L .81604 .50589 L p
1 .611 0 r
F P
0 0 0 r
s
P
p
.002 w
.80335 .50765 m .81604 .50589 L .82148 .50043 L p
1 .628 0 r
F P
0 0 0 r
s
P
p
.79541 .23316 m .81399 .23667 L .80138 .23931 L 1 .429 0 r
F
P
p
.78281 .23582 m .79541 .23316 L .80138 .23931 L 1 .516 0 r
F
P
p
.002 w
.75957 .50885 m .74714 .51059 L .74075 .50653 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72832 .50829 m .74075 .50653 L .74714 .51059 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.12449 .23297 m .14599 .23648 L .13556 .23912 L 1 .698 0 r
F
P
p
.11409 .23563 m .12449 .23297 L .13556 .23912 L 1 .698 0 r
F
P
p
.23101 .23286 m .25205 .23637 L .24128 .23901 L 1 .698 0 r
F
P
p
.22026 .23552 m .23101 .23286 L .24128 .23901 L 1 .698 0 r
F
P
p
.33756 .23275 m .35814 .23626 L .34702 .2389 L 1 .698 0 r
F
P
p
.32646 .23541 m .33756 .23275 L .34702 .2389 L 1 .698 0 r
F
P
p
.002 w
.2804 .55444 m .26934 .56153 L .2611 .50977 L p
.973 1 0 r
F P
0 0 0 r
s
P
p
.44414 .23264 m .46427 .23615 L .45279 .23879 L 1 .698 0 r
F
P
p
.43269 .2353 m .44414 .23264 L .45279 .23879 L 1 .703 0 r
F
P
p
.002 w
.37776 .52716 m .38926 .51581 L .39851 .51025 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.40981 .50851 m .39851 .51025 L .38926 .51581 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.55076 .23253 m .57042 .23604 L .5586 .23868 L 1 .698 0 r
F
P
p
.53895 .23519 m .55076 .23253 L .5586 .23868 L 1 .698 0 r
F
P
p
.002 w
.51595 .50843 m .50431 .51018 L .49605 .50611 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48442 .50787 m .49605 .50611 L .50431 .51018 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6574 .23242 m .6766 .23593 L .66443 .23857 L 1 .698 0 r
F
P
p
.64524 .23508 m .6574 .23242 L .66443 .23857 L 1 .698 0 r
F
P
p
.002 w
.62212 .50836 m .61013 .51011 L .60269 .50604 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5907 .5078 m .60269 .50604 L .61013 .51011 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.76407 .23231 m .78281 .23582 L .77028 .23846 L 1 .366 0 r
F
P
p
.75155 .23497 m .76407 .23231 L .77028 .23846 L 1 .419 0 r
F
P
p
.002 w
.72832 .50829 m .71598 .51004 L .70935 .50596 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69701 .50773 m .70935 .50596 L .71598 .51004 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.19906 .23201 m .22026 .23552 L .20958 .23817 L 1 .698 0 r
F
P
p
.1884 .23467 m .19906 .23201 L .20958 .23817 L 1 .698 0 r
F
P
p
.30572 .2319 m .32646 .23541 L .31543 .23806 L 1 .698 0 r
F
P
p
.29471 .23456 m .30572 .2319 L .31543 .23806 L 1 .698 0 r
F
P
p
.002 w
.2611 .50977 m .27195 .50802 L .2804 .55444 L p
.973 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.27195 .50802 m .2611 .50977 L .25097 .50569 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24014 .50746 m .25097 .50569 L .2611 .50977 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.41241 .23178 m .43269 .2353 L .42131 .23795 L 1 .698 0 r
F
P
p
.40105 .23445 m .41241 .23178 L .42131 .23795 L 1 .698 0 r
F
P
p
.002 w
.65363 .5185 m .64159 .52404 L .63419 .5066 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.002 w
.62212 .50836 m .63419 .5066 L .64159 .52404 L p
1 .795 0 r
F P
0 0 0 r
s
P
p
.51913 .23167 m .53895 .23519 L .52722 .23784 L 1 .698 0 r
F
P
p
.50741 .23434 m .51913 .23167 L .52722 .23784 L 1 .698 0 r
F
P
p
.002 w
.48442 .50787 m .47287 .50962 L .46437 .50554 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45283 .50731 m .46437 .50554 L .47287 .50962 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62588 .23156 m .64524 .23508 L .63315 .23773 L 1 .648 0 r
F
P
p
.61381 .23423 m .62588 .23156 L .63315 .23773 L 1 .673 0 r
F
P
p
.002 w
.5907 .5078 m .5788 .50955 L .57111 .50547 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55922 .50724 m .57111 .50547 L .5788 .50955 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73266 .23145 m .75155 .23497 L .73912 .23762 L 1 .325 0 r
F
P
p
.72023 .23412 m .73266 .23145 L .73912 .23762 L 1 .381 0 r
F
P
p
.002 w
.69701 .50773 m .68476 .50948 L .67788 .5054 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.66564 .50716 m .67788 .5054 L .68476 .50948 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.80335 .50765 m .79075 .50941 L .78468 .50532 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77208 .50709 m .78468 .50532 L .79075 .50941 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36631 .53847 m .35514 .54012 L .34541 .5482 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3342 .55174 m .34541 .5482 L .35514 .54012 L p
.771 1 0 r
F P
0 0 0 r
s
P
p
.16704 .23115 m .1884 .23467 L .17782 .23732 L 1 .698 0 r
F
P
p
.15648 .23382 m .16704 .23115 L .17782 .23732 L 1 .698 0 r
F
P
p
.002 w
.8465 .48729 m .83397 .49416 L .82881 .50411 L p
1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.81604 .50589 m .82881 .50411 L .83397 .49416 L p
1 .611 0 r
F P
0 0 0 r
s
P
p
.27381 .23104 m .29471 .23456 L .28377 .23722 L 1 .698 0 r
F
P
p
.26289 .23371 m .27381 .23104 L .28377 .23722 L 1 .698 0 r
F
P
p
.002 w
.24014 .50746 m .22939 .50921 L .219 .50512 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20827 .50689 m .219 .50512 L .22939 .50921 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.38061 .23093 m .40105 .23445 L .38976 .23711 L 1 .698 0 r
F
P
p
.36934 .2336 m .38061 .23093 L .38976 .23711 L 1 .698 0 r
F
P
p
.002 w
.14173 .56917 m .1313 .57072 L .12016 .56711 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.3231 .55335 m .31191 .56045 L .30308 .52777 L p
.869 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.29147 .5487 m .30308 .52777 L .31191 .56045 L p
.744 1 0 r
F P
0 0 0 r
s
P
p
.48744 .23082 m .50741 .23434 L .49577 .237 L 1 .698 0 r
F
P
p
.47581 .23349 m .48744 .23082 L .49577 .237 L 1 .698 0 r
F
P
p
.002 w
.45283 .50731 m .44137 .50906 L .43262 .50498 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42117 .50675 m .43262 .50498 L .44137 .50906 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19716 .51823 m .18609 .52953 L .1749 .53527 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.002 w
.1633 .55631 m .1749 .53527 L .18609 .52953 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.59429 .23071 m .61381 .23423 L .60182 .23689 L 1 .698 0 r
F
P
p
.58232 .23338 m .59429 .23071 L .60182 .23689 L 1 .698 0 r
F
P
p
.002 w
.55922 .50724 m .54741 .50899 L .53947 .5049 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52767 .50667 m .53947 .5049 L .54741 .50899 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29147 .5487 m .2804 .55444 L .27195 .50802 L p
1 .992 0 r
F P
0 0 0 r
s
P
p
.70118 .23059 m .72023 .23412 L .70789 .23678 L 1 .627 0 r
F
P
p
.68885 .23327 m .70118 .23059 L .70789 .23678 L 1 .684 0 r
F
P
p
.8081 .23048 m .82669 .23401 L .81399 .23667 L 1 .314 0 r
F
P
p
.79541 .23316 m .8081 .23048 L .81399 .23667 L 1 .429 0 r
F
P
p
.002 w
.77208 .50709 m .75957 .50885 L .75326 .50476 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.002 w
.74075 .50653 m .75326 .50476 L .75957 .50885 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.13495 .23029 m .15648 .23382 L .14599 .23648 L 1 .698 0 r
F
P
p
.12449 .23297 m .13495 .23029 L .14599 .23648 L 1 .698 0 r
F
P
p
.24183 .23018 m .26289 .23371 L .25205 .23637 L 1 .698 0 r
F
P
p
.23101 .23286 m .24183 .23018 L .25205 .23637 L 1 .698 0 r
F
P
p
.34874 .23007 m .36934 .2336 L .35814 .23626 L 1 .698 0 r
F
P
p
.33756 .23275 m .34874 .23007 L .35814 .23626 L 1 .698 0 r
F
P
p
.45568 .22996 m .47581 .23349 L .46427 .23615 L 1 .698 0 r
F
P
p
.44414 .23264 m .45568 .22996 L .46427 .23615 L 1 .698 0 r
F
P
p
.002 w
.42117 .50675 m .40981 .50851 L .40062 .51406 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.38926 .51581 m .40062 .51406 L .40981 .50851 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.56264 .22985 m .58232 .23338 L .57042 .23604 L 1 .698 0 r
F
P
p
.55076 .23253 m .56264 .22985 L .57042 .23604 L 1 .698 0 r
F
P
p
.002 w
.52767 .50667 m .51595 .50843 L .50776 .50434 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49605 .50611 m .50776 .50434 L .51595 .50843 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66964 .22974 m .68885 .23327 L .6766 .23593 L 1 .698 0 r
F
P
p
.6574 .23242 m .66964 .22974 L .6766 .23593 L 1 .698 0 r
F
P
p
.002 w
.63419 .5066 m .62212 .50836 L .61475 .50426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.60269 .50604 m .61475 .50426 L .62212 .50836 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.77666 .22962 m .79541 .23316 L .78281 .23582 L 1 .306 0 r
F
P
p
.76407 .23231 m .77666 .22962 L .78281 .23582 L 1 .366 0 r
F
P
p
.002 w
.74075 .50653 m .72832 .50829 L .72176 .50419 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.70935 .50596 m .72176 .50419 L .72832 .50829 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.85804 .45681 m .8465 .48729 L .84167 .50233 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.82881 .50411 m .84167 .50233 L .8465 .48729 L p
1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.84167 .50233 m .85248 .45232 L .85804 .45681 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.66564 .50716 m .65363 .5185 L .64635 .50483 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.63419 .5066 m .64635 .50483 L .65363 .5185 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.20978 .22932 m .23101 .23286 L .22026 .23552 L 1 .698 0 r
F
P
p
.19906 .23201 m .20978 .22932 L .22026 .23552 L 1 .698 0 r
F
P
p
.3168 .22921 m .33756 .23275 L .32646 .23541 L 1 .698 0 r
F
P
p
.30572 .2319 m .3168 .22921 L .32646 .23541 L 1 .698 0 r
F
P
p
.002 w
.27195 .50802 m .28287 .50626 L .29147 .5487 L p
1 .992 0 r
F P
0 0 0 r
s
P
p
.002 w
.28287 .50626 m .27195 .50802 L .26187 .50391 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25097 .50569 m .26187 .50391 L .27195 .50802 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20827 .50689 m .19716 .51823 L .1865 .51421 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.1749 .53527 m .1865 .51421 L .19716 .51823 L p
1 .942 0 r
F P
0 0 0 r
s
P
p
.42385 .2291 m .44414 .23264 L .43269 .2353 L 1 .698 0 r
F
P
p
.41241 .23178 m .42385 .2291 L .43269 .2353 L 1 .698 0 r
F
P
p
.53092 .22899 m .55076 .23253 L .53895 .23519 L 1 .698 0 r
F
P
p
.51913 .23167 m .53092 .22899 L .53895 .23519 L 1 .698 0 r
F
P
p
.002 w
.49605 .50611 m .48442 .50787 L .47598 .50377 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46437 .50554 m .47598 .50377 L .48442 .50787 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.63803 .22887 m .6574 .23242 L .64524 .23508 L 1 .648 0 r
F
P
p
.62588 .23156 m .63803 .22887 L .64524 .23508 L 1 .648 0 r
F
P
p
.002 w
.60269 .50604 m .5907 .5078 L .58308 .50369 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57111 .50547 m .58308 .50369 L .5907 .5078 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.30308 .52777 m .31441 .51643 L .3231 .55335 L p
.869 1 0 r
F P
0 0 0 r
s
P
p
.74516 .22876 m .76407 .23231 L .75155 .23497 L 1 .285 0 r
F
P
p
.73266 .23145 m .74516 .22876 L .75155 .23497 L 1 .325 0 r
F
P
p
.002 w
.70935 .50596 m .69701 .50773 L .69021 .50362 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.67788 .5054 m .69021 .50362 L .69701 .50773 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.81604 .50589 m .80335 .50765 L .79736 .50354 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.78468 .50532 m .79736 .50354 L .80335 .50765 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37776 .52716 m .36631 .53847 L .35681 .54015 L p
.899 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34541 .5482 m .35681 .54015 L .36631 .53847 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.17767 .22846 m .19906 .23201 L .1884 .23467 L 1 .698 0 r
F
P
p
.16704 .23115 m .17767 .22846 L .1884 .23467 L 1 .698 0 r
F
P
p
.002 w
.30308 .52777 m .29147 .5487 L .28287 .50626 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.2848 .22835 m .30572 .2319 L .29471 .23456 L 1 .698 0 r
F
P
p
.27381 .23104 m .2848 .22835 L .29471 .23456 L 1 .698 0 r
F
P
p
.002 w
.25097 .50569 m .24014 .50746 L .22981 .50334 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.219 .50512 m .22981 .50334 L .24014 .50746 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.39195 .22824 m .41241 .23178 L .40105 .23445 L 1 .698 0 r
F
P
p
.38061 .23093 m .39195 .22824 L .40105 .23445 L 1 .698 0 r
F
P
p
.002 w
.15223 .56761 m .14173 .56917 L .13331 .51713 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.12016 .56711 m .13331 .51713 L .14173 .56917 L p
.64 1 0 r
F P
0 0 0 r
s
P
p
.49914 .22812 m .51913 .23167 L .50741 .23434 L 1 .698 0 r
F
P
p
.48744 .23082 m .49914 .22812 L .50741 .23434 L 1 .698 0 r
F
P
p
.002 w
.46437 .50554 m .45283 .50731 L .44413 .50319 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43262 .50498 m .44413 .50319 L .45283 .50731 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60635 .22801 m .62588 .23156 L .61381 .23423 L 1 .659 0 r
F
P
p
.59429 .23071 m .60635 .22801 L .61381 .23423 L 1 .698 0 r
F
P
p
.002 w
.57111 .50547 m .55922 .50724 L .55134 .50312 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53947 .5049 m .55134 .50312 L .55922 .50724 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.31441 .51643 m .30308 .52777 L .29387 .50448 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.28287 .50626 m .29387 .50448 L .30308 .52777 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.7136 .2279 m .73266 .23145 L .72023 .23412 L 1 .551 0 r
F
P
p
.70118 .23059 m .7136 .2279 L .72023 .23412 L 1 .627 0 r
F
P
p
.002 w
.67788 .5054 m .66564 .50716 L .65858 .50305 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.64635 .50483 m .65858 .50305 L .66564 .50716 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.8081 .23048 m .82087 .22779 L .82669 .23401 L 1 .314 0 r
F
P
p
.002 w
.78468 .50532 m .77208 .50709 L .76539 .48879 L p
1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.75326 .50476 m .76539 .48879 L .77208 .50709 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.14549 .2276 m .16704 .23115 L .15648 .23382 L 1 .698 0 r
F
P
p
.13495 .23029 m .14549 .2276 L .15648 .23382 L 1 .698 0 r
F
P
p
.25272 .22748 m .27381 .23104 L .26289 .23371 L 1 .698 0 r
F
P
p
.24183 .23018 m .25272 .22748 L .26289 .23371 L 1 .698 0 r
F
P
p
.002 w
.219 .50512 m .20827 .50689 L .19768 .50277 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1865 .51421 m .19768 .50277 L .20827 .50689 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.13331 .51713 m .1438 .5154 L .15223 .56761 L p
.814 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.1438 .5154 m .13331 .51713 L .12269 .50342 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.13331 .51713 m .12016 .56711 L .11168 .51484 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.11168 .51484 m .12269 .50342 L .13331 .51713 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.35999 .22737 m .38061 .23093 L .36934 .2336 L 1 .698 0 r
F
P
p
.34874 .23007 m .35999 .22737 L .36934 .2336 L 1 .698 0 r
F
P
p
.46728 .22726 m .48744 .23082 L .47581 .23349 L 1 .698 0 r
F
P
p
.45568 .22996 m .46728 .22726 L .47581 .23349 L 1 .698 0 r
F
P
p
.002 w
.43262 .50498 m .42117 .50675 L .41206 .51231 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.40062 .51406 m .41206 .51231 L .42117 .50675 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.57461 .22715 m .59429 .23071 L .58232 .23338 L 1 .698 0 r
F
P
p
.56264 .22985 m .57461 .22715 L .58232 .23338 L 1 .698 0 r
F
P
p
.002 w
.53947 .5049 m .52767 .50667 L .51954 .50255 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50776 .50434 m .51954 .50255 L .52767 .50667 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68196 .22703 m .70118 .23059 L .68885 .23327 L 1 .673 0 r
F
P
p
.66964 .22974 m .68196 .22703 L .68885 .23327 L 1 .698 0 r
F
P
p
.002 w
.64635 .50483 m .63419 .5066 L .62689 .50247 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61475 .50426 m .62689 .50247 L .63419 .5066 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38926 .51581 m .37776 .52716 L .36825 .53291 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.35681 .54015 m .36825 .53291 L .37776 .52716 L p
.899 1 0 r
F P
0 0 0 r
s
P
p
.78935 .22692 m .8081 .23048 L .79541 .23316 L 1 .289 0 r
F
P
p
.77666 .22962 m .78935 .22692 L .79541 .23316 L 1 .306 0 r
F
P
p
.002 w
.75326 .50476 m .74075 .50653 L .73426 .5024 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72176 .50419 m .73426 .5024 L .74075 .50653 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.22058 .22662 m .24183 .23018 L .23101 .23286 L 1 .698 0 r
F
P
p
.20978 .22932 m .22058 .22662 L .23101 .23286 L 1 .698 0 r
F
P
p
.32796 .22651 m .34874 .23007 L .33756 .23275 L 1 .698 0 r
F
P
p
.3168 .22921 m .32796 .22651 L .33756 .23275 L 1 .698 0 r
F
P
p
.002 w
.29387 .50448 m .28287 .50626 L .27284 .50212 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26187 .50391 m .27284 .50212 L .28287 .50626 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.43536 .22639 m .45568 .22996 L .44414 .23264 L 1 .698 0 r
F
P
p
.42385 .2291 m .43536 .22639 L .44414 .23264 L 1 .698 0 r
F
P
p
.002 w
.31441 .51643 m .32552 .51469 L .3342 .55174 L p
.924 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32552 .51469 m .31441 .51643 L .30493 .5027 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.29387 .50448 m .30493 .5027 L .31441 .51643 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.5428 .22628 m .56264 .22985 L .55076 .23253 L 1 .698 0 r
F
P
p
.53092 .22899 m .5428 .22628 L .55076 .23253 L 1 .698 0 r
F
P
p
.002 w
.50776 .50434 m .49605 .50611 L .48767 .50198 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47598 .50377 m .48767 .50198 L .49605 .50611 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.65026 .22617 m .66964 .22974 L .6574 .23242 L 1 .648 0 r
F
P
p
.63803 .22887 m .65026 .22617 L .6574 .23242 L 1 .648 0 r
F
P
p
.002 w
.61475 .50426 m .60269 .50604 L .59513 .5019 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58308 .50369 m .59513 .5019 L .60269 .50604 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34541 .5482 m .3342 .55174 L .32552 .51469 L p
.93 1 0 r
F P
0 0 0 r
s
P
p
.75775 .22606 m .77666 .22962 L .76407 .23231 L 1 .244 0 r
F
P
p
.74516 .22876 m .75775 .22606 L .76407 .23231 L 1 .285 0 r
F
P
p
.002 w
.72176 .50419 m .70935 .50596 L .70261 .50183 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69021 .50362 m .70261 .50183 L .70935 .50596 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.82881 .50411 m .81604 .50589 L .81013 .50175 L p
1 .628 0 r
F P
0 0 0 r
s
P
p
.002 w
.79736 .50354 m .81013 .50175 L .81604 .50589 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.18837 .22575 m .20978 .22932 L .19906 .23201 L 1 .698 0 r
F
P
p
.17767 .22846 m .18837 .22575 L .19906 .23201 L 1 .698 0 r
F
P
p
.29586 .22564 m .3168 .22921 L .30572 .2319 L 1 .698 0 r
F
P
p
.2848 .22835 m .29586 .22564 L .30572 .2319 L 1 .698 0 r
F
P
p
.002 w
.26187 .50391 m .25097 .50569 L .24069 .50155 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.22981 .50334 m .24069 .50155 L .25097 .50569 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.40337 .22552 m .42385 .2291 L .41241 .23178 L 1 .698 0 r
F
P
p
.39195 .22824 m .40337 .22552 L .41241 .23178 L 1 .698 0 r
F
P
p
.002 w
.1633 .55631 m .15223 .56761 L .1438 .5154 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.51092 .22541 m .53092 .22899 L .51913 .23167 L 1 .698 0 r
F
P
p
.49914 .22812 m .51092 .22541 L .51913 .23167 L 1 .698 0 r
F
P
p
.002 w
.47598 .50377 m .46437 .50554 L .45573 .5014 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44413 .50319 m .45573 .5014 L .46437 .50554 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37983 .52146 m .38926 .51581 L p
.37353 .52861 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.36825 .53291 m .37983 .52146 L p
.37353 .52861 L 1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.37983 .52146 m .37089 .49785 L p
.38618 .51426 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.40062 .51406 m .38926 .51581 L .37983 .52146 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.37983 .52146 m .39126 .51972 L .40062 .51406 L p
1 .907 0 r
F P
0 0 0 r
s
P
p
.002 w
.39126 .51972 m .37983 .52146 L p
.38618 .51426 L 1 .837 0 r
F P
0 0 0 r
s
P
p
.61849 .2253 m .63803 .22887 L .62588 .23156 L 1 .61 0 r
F
P
p
.60635 .22801 m .61849 .2253 L .62588 .23156 L 1 .659 0 r
F
P
p
.002 w
.58308 .50369 m .57111 .50547 L .5633 .50133 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55134 .50312 m .5633 .50133 L .57111 .50547 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72609 .22519 m .74516 .22876 L .73266 .23145 L 1 .501 0 r
F
P
p
.7136 .2279 m .72609 .22519 L .73266 .23145 L 1 .551 0 r
F
P
p
.002 w
.69021 .50362 m .67788 .5054 L .67089 .50125 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.65858 .50305 m .67089 .50125 L .67788 .5054 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.79736 .50354 m .78468 .50532 L .77787 .48184 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.77787 .48184 m .78468 .50532 L p
.77059 .49324 L 1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.77787 .48184 m .7899 .46067 L .79736 .50354 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.77787 .48184 m .77226 .49697 L p
.7852 .47036 L 1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.7899 .46067 m .77787 .48184 L p
.7852 .47036 L 1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.76539 .48879 m .77787 .48184 L p
.77059 .49324 L 1 .577 0 r
F P
0 0 0 r
s
P
p
.15609 .22488 m .17767 .22846 L .16704 .23115 L 1 .698 0 r
F
P
p
.14549 .2276 m .15609 .22488 L .16704 .23115 L 1 .698 0 r
F
P
p
.26369 .22477 m .2848 .22835 L .27381 .23104 L 1 .698 0 r
F
P
p
.25272 .22748 m .26369 .22477 L .27381 .23104 L 1 .698 0 r
F
P
p
.002 w
.22981 .50334 m .219 .50512 L .20846 .50097 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19768 .50277 m .20846 .50097 L .219 .50512 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1438 .5154 m .15486 .50399 L .1633 .55631 L p
.884 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.15486 .50399 m .1438 .5154 L .13321 .50162 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.12269 .50342 m .13321 .50162 L .1438 .5154 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.37131 .22465 m .39195 .22824 L .38061 .23093 L 1 .698 0 r
F
P
p
.35999 .22737 m .37131 .22465 L .38061 .23093 L 1 .698 0 r
F
P
p
.47897 .22454 m .49914 .22812 L .48744 .23082 L 1 .698 0 r
F
P
p
.46728 .22726 m .47897 .22454 L .48744 .23082 L 1 .698 0 r
F
P
p
.002 w
.44413 .50319 m .43262 .50498 L .42358 .51054 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.41206 .51231 m .42358 .51054 L .43262 .50498 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.58665 .22443 m .60635 .22801 L .59429 .23071 L 1 .698 0 r
F
P
p
.57461 .22715 m .58665 .22443 L .59429 .23071 L 1 .698 0 r
F
P
p
.002 w
.55134 .50312 m .53947 .5049 L .5314 .50075 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51954 .50255 m .5314 .50075 L .53947 .5049 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69437 .22432 m .7136 .2279 L .70118 .23059 L 1 .634 0 r
F
P
p
.68196 .22703 m .69437 .22432 L .70118 .23059 L 1 .673 0 r
F
P
p
.002 w
.65858 .50305 m .64635 .50483 L .63911 .50068 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.62689 .50247 m .63911 .50068 L .64635 .50483 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.80211 .2242 m .82087 .22779 L .8081 .23048 L 1 .244 0 r
F
P
p
.78935 .22692 m .80211 .2242 L .8081 .23048 L 1 .289 0 r
F
P
p
.002 w
.76539 .48879 m .75326 .50476 L .74684 .5006 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.002 w
.73426 .5024 m .74684 .5006 L .75326 .50476 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.23145 .2239 m .25272 .22748 L .24183 .23018 L 1 .698 0 r
F
P
p
.22058 .22662 m .23145 .2239 L .24183 .23018 L 1 .698 0 r
F
P
p
.002 w
.1749 .53527 m .1633 .55631 L .15486 .50399 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.002 w
.12269 .50342 m .11168 .51484 L .10087 .50105 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.33919 .22378 m .35999 .22737 L .34874 .23007 L 1 .698 0 r
F
P
p
.32796 .22651 m .33919 .22378 L .34874 .23007 L 1 .698 0 r
F
P
p
.002 w
.30493 .5027 m .29387 .50448 L .28389 .50032 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27284 .50212 m .28389 .50032 L .29387 .50448 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44695 .22367 m .46728 .22726 L .45568 .22996 L 1 .698 0 r
F
P
p
.43536 .22639 m .44695 .22367 L .45568 .22996 L 1 .698 0 r
F
P
p
.002 w
.35681 .54015 m .34541 .5482 L .33669 .51294 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32552 .51469 m .33669 .51294 L .34541 .5482 L p
.93 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.33669 .51294 m .32552 .51469 L .31608 .5009 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.30493 .5027 m .31608 .5009 L .32552 .51469 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.55475 .22356 m .57461 .22715 L .56264 .22985 L 1 .698 0 r
F
P
p
.5428 .22628 m .55475 .22356 L .56264 .22985 L 1 .698 0 r
F
P
p
.002 w
.51954 .50255 m .50776 .50434 L .49944 .50017 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48767 .50198 m .49944 .50017 L .50776 .50434 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66257 .22344 m .68196 .22703 L .66964 .22974 L 1 .638 0 r
F
P
p
.65026 .22617 m .66257 .22344 L .66964 .22974 L 1 .648 0 r
F
P
p
.002 w
.62689 .50247 m .61475 .50426 L .60725 .5001 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59513 .5019 m .60725 .5001 L .61475 .50426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1865 .51421 m .1749 .53527 L .16548 .5022 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.15486 .50399 m .16548 .5022 L .1749 .53527 L p
1 .977 0 r
F P
0 0 0 r
s
P
p
.77043 .22333 m .78935 .22692 L .77666 .22962 L 1 .174 0 r
F
P
p
.75775 .22606 m .77043 .22333 L .77666 .22962 L 1 .244 0 r
F
P
p
.002 w
.73426 .5024 m .72176 .50419 L .7151 .50002 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.70261 .50183 m .7151 .50002 L .72176 .50419 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.85248 .45232 m .84167 .50233 L .8343 .45936 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.8343 .45936 m .84683 .44775 L .85248 .45232 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.84167 .50233 m .82881 .50411 L .82221 .48057 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.81013 .50175 m .82221 .48057 L .82881 .50411 L p
1 .628 0 r
F P
0 0 0 r
s
P
p
.002 w
.77787 .48184 m .76539 .48879 L .75951 .49879 L p
1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.74684 .5006 m .75951 .49879 L .76539 .48879 L p
1 .646 0 r
F P
0 0 0 r
s
P
p
.19915 .22302 m .22058 .22662 L .20978 .22932 L 1 .698 0 r
F
P
p
.18837 .22575 m .19915 .22302 L .20978 .22932 L 1 .698 0 r
F
P
p
.002 w
.16548 .5022 m .15486 .50399 L .1438 .49982 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.13321 .50162 m .1438 .49982 L .15486 .50399 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.30699 .22291 m .32796 .22651 L .3168 .22921 L 1 .698 0 r
F
P
p
.29586 .22564 m .30699 .22291 L .3168 .22921 L 1 .698 0 r
F
P
p
.002 w
.27284 .50212 m .26187 .50391 L .25164 .49975 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24069 .50155 m .25164 .49975 L .26187 .50391 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19768 .50277 m .1865 .51421 L .17616 .5004 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.002 w
.16548 .5022 m .17616 .5004 L .1865 .51421 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.41487 .2228 m .43536 .22639 L .42385 .2291 L 1 .698 0 r
F
P
p
.40337 .22552 m .41487 .2228 L .42385 .2291 L 1 .698 0 r
F
P
p
.52277 .22268 m .5428 .22628 L .53092 .22899 L 1 .698 0 r
F
P
p
.51092 .22541 m .52277 .22268 L .53092 .22899 L 1 .698 0 r
F
P
p
.002 w
.48767 .50198 m .47598 .50377 L .4674 .4996 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45573 .5014 m .4674 .4996 L .47598 .50377 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41206 .51231 m .40062 .51406 L .39126 .51972 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.63071 .22257 m .65026 .22617 L .63803 .22887 L 1 .598 0 r
F
P
p
.61849 .2253 m .63071 .22257 L .63803 .22887 L 1 .61 0 r
F
P
p
.002 w
.59513 .5019 m .58308 .50369 L .57533 .49952 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5633 .50133 m .57533 .49952 L .58308 .50369 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73868 .22246 m .75775 .22606 L .74516 .22876 L 1 .456 0 r
F
P
p
.72609 .22519 m .73868 .22246 L .74516 .22876 L 1 .501 0 r
F
P
p
.002 w
.70261 .50183 m .69021 .50362 L .68329 .49945 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.67089 .50125 m .68329 .49945 L .69021 .50362 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.81013 .50175 m .79736 .50354 L .7899 .46067 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.16677 .22215 m .18837 .22575 L .17767 .22846 L 1 .698 0 r
F
P
p
.15609 .22488 m .16677 .22215 L .17767 .22846 L 1 .698 0 r
F
P
p
.002 w
.13321 .50162 m .12269 .50342 L .11136 .49924 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.10087 .50105 m .11136 .49924 L .12269 .50342 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.27473 .22203 m .29586 .22564 L .2848 .22835 L 1 .698 0 r
F
P
p
.26369 .22477 m .27473 .22203 L .2848 .22835 L 1 .698 0 r
F
P
p
.002 w
.24069 .50155 m .22981 .50334 L .21931 .49917 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20846 .50097 m .21931 .49917 L .22981 .50334 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.38271 .22192 m .40337 .22552 L .39195 .22824 L 1 .698 0 r
F
P
p
.37131 .22465 m .38271 .22192 L .39195 .22824 L 1 .698 0 r
F
P
p
.49073 .22181 m .51092 .22541 L .49914 .22812 L 1 .698 0 r
F
P
p
.47897 .22454 m .49073 .22181 L .49914 .22812 L 1 .698 0 r
F
P
p
.002 w
.45573 .5014 m .44413 .50319 L .43517 .50876 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.42358 .51054 m .43517 .50876 L .44413 .50319 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.59878 .22169 m .61849 .2253 L .60635 .22801 L 1 .684 0 r
F
P
p
.58665 .22443 m .59878 .22169 L .60635 .22801 L 1 .698 0 r
F
P
p
.002 w
.5633 .50133 m .55134 .50312 L .54334 .49894 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5314 .50075 m .54334 .49894 L .55134 .50312 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36825 .53291 m .35681 .54015 L .34794 .51118 L p
1 .967 0 r
F P
0 0 0 r
s
P
p
.002 w
.33669 .51294 m .34794 .51118 L .35681 .54015 L p
.96 1 0 r
F P
0 0 0 r
s
P
p
.70686 .22158 m .72609 .22519 L .7136 .2279 L 1 .61 0 r
F
P
p
.69437 .22432 m .70686 .22158 L .7136 .2279 L 1 .634 0 r
F
P
p
.002 w
.67089 .50125 m .65858 .50305 L .65141 .49887 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.63911 .50068 m .65141 .49887 L .65858 .50305 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.80211 .2242 m .81496 .22147 L .82087 .22779 L 1 .244 0 r
F
P
p
.24239 .22116 m .26369 .22477 L .25272 .22748 L 1 .698 0 r
F
P
p
.23145 .2239 m .24239 .22116 L .25272 .22748 L 1 .698 0 r
F
P
p
.002 w
.20846 .50097 m .19768 .50277 L .18692 .49859 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.17616 .5004 m .18692 .49859 L .19768 .50277 L p
1 .733 0 r
F P
0 0 0 r
s
P
p
.35049 .22104 m .37131 .22465 L .35999 .22737 L 1 .698 0 r
F
P
p
.33919 .22378 m .35049 .22104 L .35999 .22737 L 1 .698 0 r
F
P
p
.002 w
.31608 .5009 m .30493 .5027 L .29501 .49851 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.28389 .50032 m .29501 .49851 L .30493 .5027 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.45862 .22093 m .47897 .22454 L .46728 .22726 L 1 .698 0 r
F
P
p
.44695 .22367 m .45862 .22093 L .46728 .22726 L 1 .698 0 r
F
P
p
.002 w
.75951 .49879 m .77226 .49697 L .77787 .48184 L p
1 .577 0 r
F P
0 0 0 r
s
P
p
.002 w
.34794 .51118 m .33669 .51294 L .32729 .49909 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.31608 .5009 m .32729 .49909 L .33669 .51294 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.56678 .22081 m .58665 .22443 L .57461 .22715 L 1 .698 0 r
F
P
p
.55475 .22356 m .56678 .22081 L .57461 .22715 L 1 .698 0 r
F
P
p
.002 w
.5314 .50075 m .51954 .50255 L .51128 .49836 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49944 .50017 m .51128 .49836 L .51954 .50255 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67497 .2207 m .69437 .22432 L .68196 .22703 L 1 .533 0 r
F
P
p
.66257 .22344 m .67497 .2207 L .68196 .22703 L 1 .638 0 r
F
P
p
.002 w
.63911 .50068 m .62689 .50247 L .61946 .49828 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.60725 .5001 m .61946 .49828 L .62689 .50247 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.78319 .22059 m .80211 .2242 L .78935 .22692 L 1 .105 0 r
F
P
p
.77043 .22333 m .78319 .22059 L .78935 .22692 L 1 .174 0 r
F
P
p
.002 w
.74684 .5006 m .73426 .5024 L .72768 .49821 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.7151 .50002 m .72768 .49821 L .73426 .5024 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.82221 .48057 m .8343 .45936 L .84167 .50233 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.80268 .45874 m .81013 .50175 L p
.79279 .46654 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.82221 .48057 m .81013 .50175 L .80268 .45874 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.80268 .45874 m .81515 .44712 L .82221 .48057 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.80268 .45874 m .79731 .47368 L p
.81262 .45088 L 1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.81515 .44712 m .80268 .45874 L p
.81262 .45088 L 1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.7899 .46067 m .80268 .45874 L p
.79279 .46654 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.80268 .45874 m .7899 .46067 L .7851 .49513 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.77226 .49697 m .7851 .49513 L .7899 .46067 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.20999 .22028 m .23145 .2239 L .22058 .22662 L 1 .698 0 r
F
P
p
.19915 .22302 m .20999 .22028 L .22058 .22662 L 1 .698 0 r
F
P
p
.002 w
.17616 .5004 m .16548 .5022 L .15446 .498 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1438 .49982 m .15446 .498 L .16548 .5022 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.3182 .22016 m .33919 .22378 L .32796 .22651 L 1 .698 0 r
F
P
p
.30699 .22291 m .3182 .22016 L .32796 .22651 L 1 .698 0 r
F
P
p
.002 w
.28389 .50032 m .27284 .50212 L .26266 .49793 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25164 .49975 m .26266 .49793 L .27284 .50212 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.42644 .22005 m .44695 .22367 L .43536 .22639 L 1 .698 0 r
F
P
p
.41487 .2228 m .42644 .22005 L .43536 .22639 L 1 .698 0 r
F
P
p
.53471 .21993 m .55475 .22356 L .5428 .22628 L 1 .698 0 r
F
P
p
.52277 .22268 m .53471 .21993 L .5428 .22628 L 1 .698 0 r
F
P
p
.002 w
.49944 .50017 m .48767 .50198 L .47916 .49778 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4674 .4996 m .47916 .49778 L .48767 .50198 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42358 .51054 m .41206 .51231 L .40295 .50819 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.39126 .51972 m .40295 .50819 L .41206 .51231 L p
1 .872 0 r
F P
0 0 0 r
s
P
p
.64301 .21982 m .66257 .22344 L .65026 .22617 L 1 .598 0 r
F
P
p
.63071 .22257 m .64301 .21982 L .65026 .22617 L 1 .598 0 r
F
P
p
.002 w
.60725 .5001 m .59513 .5019 L .58745 .4977 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57533 .49952 m .58745 .4977 L .59513 .5019 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75134 .21971 m .77043 .22333 L .75775 .22606 L 1 .43 0 r
F
P
p
.73868 .22246 m .75134 .21971 L .75775 .22606 L 1 .456 0 r
F
P
p
.002 w
.7151 .50002 m .70261 .50183 L .69577 .49763 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.68329 .49945 m .69577 .49763 L .70261 .50183 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37983 .52146 m .36825 .53291 L .35947 .50106 L p
1 .877 0 r
F P
0 0 0 r
s
P
p
.002 w
.34794 .51118 m .35947 .50106 L .36825 .53291 L p
1 .967 0 r
F P
0 0 0 r
s
P
p
.17752 .2194 m .19915 .22302 L .18837 .22575 L 1 .698 0 r
F
P
p
.16677 .22215 m .17752 .2194 L .18837 .22575 L 1 .698 0 r
F
P
p
.002 w
.1438 .49982 m .13321 .50162 L .12193 .49742 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.11136 .49924 m .12193 .49742 L .13321 .50162 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.28584 .21928 m .30699 .22291 L .29586 .22564 L 1 .698 0 r
F
P
p
.27473 .22203 m .28584 .21928 L .29586 .22564 L 1 .698 0 r
F
P
p
.002 w
.25164 .49975 m .24069 .50155 L .23024 .49735 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21931 .49917 m .23024 .49735 L .24069 .50155 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.39419 .21917 m .41487 .2228 L .40337 .22552 L 1 .698 0 r
F
P
p
.38271 .22192 m .39419 .21917 L .40337 .22552 L 1 .698 0 r
F
P
p
.50257 .21905 m .52277 .22268 L .51092 .22541 L 1 .698 0 r
F
P
p
.49073 .22181 m .50257 .21905 L .51092 .22541 L 1 .698 0 r
F
P
p
.002 w
.4674 .4996 m .45573 .5014 L .44684 .50697 L p
1 .753 0 r
F P
0 0 0 r
s
P
p
.002 w
.43517 .50876 m .44684 .50697 L .45573 .5014 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.8343 .45936 m .82221 .48057 L .81515 .44712 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.61099 .21894 m .63071 .22257 L .61849 .2253 L 1 .659 0 r
F
P
p
.59878 .22169 m .61099 .21894 L .61849 .2253 L 1 .684 0 r
F
P
p
.002 w
.57533 .49952 m .5633 .50133 L .55536 .49712 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54334 .49894 m .55536 .49712 L .5633 .50133 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71943 .21882 m .73868 .22246 L .72609 .22519 L 1 .579 0 r
F
P
p
.70686 .22158 m .71943 .21882 L .72609 .22519 L 1 .61 0 r
F
P
p
.002 w
.68329 .49945 m .67089 .50125 L .6638 .49704 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.65141 .49887 m .6638 .49704 L .67089 .50125 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.11136 .49924 m .10087 .50105 L .08932 .49684 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.84683 .44775 m .8343 .45936 L .82808 .44512 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.81515 .44712 m .82808 .44512 L .8343 .45936 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.25341 .2184 m .27473 .22203 L .26369 .22477 L 1 .698 0 r
F
P
p
.24239 .22116 m .25341 .2184 L .26369 .22477 L 1 .698 0 r
F
P
p
.002 w
.21931 .49917 m .20846 .50097 L .19775 .49676 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.18692 .49859 m .19775 .49676 L .20846 .50097 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.36187 .21828 m .38271 .22192 L .37131 .22465 L 1 .698 0 r
F
P
p
.35049 .22104 m .36187 .21828 L .37131 .22465 L 1 .698 0 r
F
P
p
.002 w
.32729 .49909 m .31608 .5009 L .30621 .49669 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29501 .49851 m .30621 .49669 L .31608 .5009 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.47037 .21817 m .49073 .22181 L .47897 .22454 L 1 .698 0 r
F
P
p
.45862 .22093 m .47037 .21817 L .47897 .22454 L 1 .698 0 r
F
P
p
.002 w
.35947 .50106 m .34794 .51118 L .33858 .49727 L p
1 .738 0 r
F P
0 0 0 r
s
P
p
.002 w
.32729 .49909 m .33858 .49727 L .34794 .51118 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.57889 .21805 m .59878 .22169 L .58665 .22443 L 1 .698 0 r
F
P
p
.56678 .22081 m .57889 .21805 L .58665 .22443 L 1 .698 0 r
F
P
p
.002 w
.54334 .49894 m .5314 .50075 L .52321 .49653 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51128 .49836 m .52321 .49653 L .5314 .50075 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68745 .21794 m .70686 .22158 L .69437 .22432 L 1 .439 0 r
F
P
p
.67497 .2207 m .68745 .21794 L .69437 .22432 L 1 .533 0 r
F
P
p
.002 w
.65141 .49887 m .63911 .50068 L .63176 .49646 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61946 .49828 m .63176 .49646 L .63911 .50068 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35947 .50106 m .37089 .49785 L .37983 .52146 L p
1 .877 0 r
F P
0 0 0 r
s
P
p
.79603 .21782 m .81496 .22147 L .80211 .2242 L 1 .035 0 r
F
P
p
.78319 .22059 m .79603 .21782 L .80211 .2242 L 1 .105 0 r
F
P
p
.002 w
.75951 .49879 m .74684 .5006 L .74033 .49638 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72768 .49821 m .74033 .49638 L .74684 .5006 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.7851 .49513 m .79731 .47368 L .80268 .45874 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.22091 .21751 m .24239 .22116 L .23145 .2239 L 1 .62 0 r
F
P
p
.20999 .22028 m .22091 .21751 L .23145 .2239 L 1 .698 0 r
F
P
p
.002 w
.18692 .49859 m .17616 .5004 L .16519 .49618 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.15446 .498 m .16519 .49618 L .17616 .5004 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.32949 .2174 m .35049 .22104 L .33919 .22378 L 1 .698 0 r
F
P
p
.3182 .22016 m .32949 .2174 L .33919 .22378 L 1 .698 0 r
F
P
p
.002 w
.29501 .49851 m .28389 .50032 L .27376 .4961 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26266 .49793 m .27376 .4961 L .28389 .50032 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.43809 .21728 m .45862 .22093 L .44695 .22367 L 1 .698 0 r
F
P
p
.42644 .22005 m .43809 .21728 L .44695 .22367 L 1 .698 0 r
F
P
p
.54673 .21717 m .56678 .22081 L .55475 .22356 L 1 .698 0 r
F
P
p
.53471 .21993 m .54673 .21717 L .55475 .22356 L 1 .698 0 r
F
P
p
.002 w
.51128 .49836 m .49944 .50017 L .49099 .49595 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47916 .49778 m .49099 .49595 L .49944 .50017 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43517 .50876 m .42358 .51054 L .41453 .50639 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.002 w
.40295 .50819 m .41453 .50639 L .42358 .51054 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.6554 .21705 m .67497 .2207 L .66257 .22344 L 1 .578 0 r
F
P
p
.64301 .21982 m .6554 .21705 L .66257 .22344 L 1 .598 0 r
F
P
p
.002 w
.61946 .49828 m .60725 .5001 L .59965 .49587 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58745 .4977 m .59965 .49587 L .60725 .5001 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.76409 .21694 m .78319 .22059 L .77043 .22333 L 1 .319 0 r
F
P
p
.75134 .21971 m .76409 .21694 L .77043 .22333 L 1 .43 0 r
F
P
p
.002 w
.72768 .49821 m .7151 .50002 L .70817 .48881 L p
1 .629 0 r
F P
0 0 0 r
s
P
p
.002 w
.69577 .49763 m .70817 .48881 L .7151 .50002 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.82808 .44512 m .84109 .44311 L .84683 .44775 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.18834 .21663 m .20999 .22028 L .19915 .22302 L 1 .698 0 r
F
P
p
.17752 .2194 m .18834 .21663 L .19915 .22302 L 1 .698 0 r
F
P
p
.002 w
.15446 .498 m .1438 .49982 L .13256 .49559 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.12193 .49742 m .13256 .49559 L .1438 .49982 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.29703 .21651 m .3182 .22016 L .30699 .22291 L 1 .698 0 r
F
P
p
.28584 .21928 m .29703 .21651 L .30699 .22291 L 1 .698 0 r
F
P
p
.002 w
.26266 .49793 m .25164 .49975 L .24124 .49551 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23024 .49735 m .24124 .49551 L .25164 .49975 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.40575 .2164 m .42644 .22005 L .41487 .2228 L 1 .698 0 r
F
P
p
.39419 .21917 m .40575 .2164 L .41487 .2228 L 1 .698 0 r
F
P
p
.5145 .21628 m .53471 .21993 L .52277 .22268 L 1 .698 0 r
F
P
p
.50257 .21905 m .5145 .21628 L .52277 .22268 L 1 .698 0 r
F
P
p
.002 w
.44684 .50697 m .45863 .50124 L .4674 .4996 L p
1 .753 0 r
F P
0 0 0 r
s
P
p
.002 w
.47916 .49778 m .4674 .4996 L .45863 .50124 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.37089 .49785 m .35947 .50106 L .34995 .49544 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.002 w
.33858 .49727 m .34995 .49544 L .35947 .50106 L p
1 .738 0 r
F P
0 0 0 r
s
P
p
.62328 .21617 m .64301 .21982 L .63071 .22257 L 1 .634 0 r
F
P
p
.61099 .21894 m .62328 .21617 L .63071 .22257 L 1 .659 0 r
F
P
p
.002 w
.58745 .4977 m .57533 .49952 L .56747 .49528 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55536 .49712 m .56747 .49528 L .57533 .49952 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73209 .21605 m .75134 .21971 L .73868 .22246 L 1 .53 0 r
F
P
p
.71943 .21882 m .73209 .21605 L .73868 .22246 L 1 .579 0 r
F
P
p
.002 w
.69577 .49763 m .68329 .49945 L .67627 .49521 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.6638 .49704 m .67627 .49521 L .68329 .49945 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.82808 .44512 m .81515 .44712 L .81028 .47176 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.79731 .47368 m .81028 .47176 L .81515 .44712 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.12193 .49742 m .11136 .49924 L .09986 .495 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.08932 .49684 m .09986 .495 L .11136 .49924 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.2645 .21562 m .28584 .21928 L .27473 .22203 L 1 .698 0 r
F
P
p
.25341 .2184 m .2645 .21562 L .27473 .22203 L 1 .698 0 r
F
P
p
.002 w
.23024 .49735 m .21931 .49917 L .20865 .49492 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19775 .49676 m .20865 .49492 L .21931 .49917 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.37333 .21551 m .39419 .21917 L .38271 .22192 L 1 .698 0 r
F
P
p
.36187 .21828 m .37333 .21551 L .38271 .22192 L 1 .698 0 r
F
P
p
.002 w
.33858 .49727 m .32729 .49909 L .31748 .49485 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.30621 .49669 m .31748 .49485 L .32729 .49909 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.4822 .21539 m .50257 .21905 L .49073 .22181 L 1 .698 0 r
F
P
p
.47037 .21817 m .4822 .21539 L .49073 .22181 L 1 .698 0 r
F
P
p
.59109 .21527 m .61099 .21894 L .59878 .22169 L 1 .698 0 r
F
P
p
.57889 .21805 m .59109 .21527 L .59878 .22169 L 1 .698 0 r
F
P
p
.002 w
.55536 .49712 m .54334 .49894 L .53522 .49469 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52321 .49653 m .53522 .49469 L .54334 .49894 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70001 .21516 m .71943 .21882 L .70686 .22158 L 1 .439 0 r
F
P
p
.68745 .21794 m .70001 .21516 L .70686 .22158 L 1 .439 0 r
F
P
p
.002 w
.6638 .49704 m .65141 .49887 L .64413 .49462 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.63176 .49646 m .64413 .49462 L .65141 .49887 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40295 .50819 m .39126 .51972 L .38236 .49602 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.002 w
.37089 .49785 m .38236 .49602 L .39126 .51972 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.79603 .21782 m .80896 .21504 L .81496 .22147 L 1 .035 0 r
F
P
p
.002 w
.77226 .49697 m .75951 .49879 L .75308 .49454 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74033 .49638 m .75308 .49454 L .75951 .49879 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.2319 .21473 m .25341 .2184 L .24239 .22116 L 1 .492 0 r
F
P
p
.22091 .21751 m .2319 .21473 L .24239 .22116 L 1 .62 0 r
F
P
p
.002 w
.19775 .49676 m .18692 .49859 L .17599 .49433 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.16519 .49618 m .17599 .49433 L .18692 .49859 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.34085 .21461 m .36187 .21828 L .35049 .22104 L 1 .698 0 r
F
P
p
.32949 .2174 m .34085 .21461 L .35049 .22104 L 1 .698 0 r
F
P
p
.002 w
.30621 .49669 m .29501 .49851 L .28493 .49426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27376 .4961 m .28493 .49426 L .29501 .49851 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44982 .2145 m .47037 .21817 L .45862 .22093 L 1 .698 0 r
F
P
p
.43809 .21728 m .44982 .2145 L .45862 .22093 L 1 .698 0 r
F
P
p
.55883 .21438 m .57889 .21805 L .56678 .22081 L 1 .698 0 r
F
P
p
.54673 .21717 m .55883 .21438 L .56678 .22081 L 1 .698 0 r
F
P
p
.002 w
.52321 .49653 m .51128 .49836 L .5029 .4941 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49099 .49595 m .5029 .4941 L .51128 .49836 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44684 .50697 m .43517 .50876 L .42618 .50459 L p
1 .807 0 r
F P
0 0 0 r
s
P
p
.002 w
.41453 .50639 m .42618 .50459 L .43517 .50876 L p
1 .837 0 r
F P
0 0 0 r
s
P
p
.66787 .21427 m .68745 .21794 L .67497 .2207 L 1 .488 0 r
F
P
p
.6554 .21705 m .66787 .21427 L .67497 .2207 L 1 .578 0 r
F
P
p
.002 w
.63176 .49646 m .61946 .49828 L .61193 .49403 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59965 .49587 m .61193 .49403 L .61946 .49828 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.77693 .21415 m .79603 .21782 L .78319 .22059 L 1 .14 0 r
F
P
p
.76409 .21694 m .77693 .21415 L .78319 .22059 L 1 .319 0 r
F
P
p
.002 w
.74033 .49638 m .72768 .49821 L .72067 .4817 L p
1 .549 0 r
F P
0 0 0 r
s
P
p
.002 w
.70817 .48881 m .72067 .4817 L p
.7153 .49225 L 1 .629 0 r
F P
0 0 0 r
s
P
p
.002 w
.70817 .48881 m .69577 .49763 L .68882 .49336 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.68882 .49336 m .70146 .4915 L .70817 .48881 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.72067 .4817 m .70817 .48881 L .70459 .49025 L p
1 .616 0 r
F P
0 0 0 r
s
P
p
.002 w
.70459 .49025 m .70146 .4915 L p
.70825 .48804 L 1 .616 0 r
F P
0 0 0 r
s
P
p
.70825 .48804 m .72067 .4817 L .70459 .49025 L 1 .616 0 r
F
P
p
.002 w
.70146 .4915 m .71409 .48583 L .72067 .4817 L p
1 .616 0 r
F P
0 0 0 r
s
P
p
.002 w
.72067 .4817 m .71409 .48583 L p
.72608 .47108 L 1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.73291 .46268 m .72067 .4817 L p
.72608 .47108 L 1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.72067 .4817 m .73291 .46268 L .74033 .49638 L p
1 .549 0 r
F P
0 0 0 r
s
P
p
.71619 .48325 m .72667 .47536 L .71856 .48033 L 1 .492 0 r
F
P
p
.002 w
.71985 .48104 m .72667 .47536 L p
.71619 .48325 L 1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.75308 .49454 m .74033 .49638 L .73291 .46268 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.72667 .47536 m .73291 .46268 L p
.71856 .48033 L 1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.71409 .48583 m .71985 .48104 L p
.71619 .48325 L 1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.72667 .47536 m .71409 .48583 L .70728 .48523 L p
1 .627 0 r
F P
0 0 0 r
s
P
p
.002 w
.72667 .47536 m .72008 .47948 L p
.73485 .47036 L 1 .551 0 r
F P
0 0 0 r
s
P
p
.002 w
.74567 .46071 m .75308 .49454 L p
.73682 .46886 L 1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.73291 .46268 m .74567 .46071 L p
.73682 .46886 L 1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.76591 .49269 m .75308 .49454 L .74567 .46071 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.74567 .46071 m .75822 .44893 L .76591 .49269 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.74567 .46071 m .73938 .46756 L p
.75459 .45252 L 1 .325 0 r
F P
0 0 0 r
s
P
p
.002 w
.75822 .44893 m .74567 .46071 L p
.75459 .45252 L 1 .325 0 r
F P
0 0 0 r
s
P
p
.002 w
.73938 .46756 m .72667 .47536 L p
.73485 .47036 L 1 .551 0 r
F P
0 0 0 r
s
P
p
.002 w
.72067 .4817 m .72768 .49821 L p
.7153 .49225 L 1 .629 0 r
F P
0 0 0 r
s
P
p
.19924 .21384 m .22091 .21751 L .20999 .22028 L 1 .698 0 r
F
P
p
.18834 .21663 m .19924 .21384 L .20999 .22028 L 1 .698 0 r
F
P
p
.002 w
.16519 .49618 m .15446 .498 L .14327 .49374 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.13256 .49559 m .14327 .49374 L .15446 .498 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.30829 .21372 m .32949 .2174 L .3182 .22016 L 1 .698 0 r
F
P
p
.29703 .21651 m .30829 .21372 L .3182 .22016 L 1 .698 0 r
F
P
p
.002 w
.27376 .4961 m .26266 .49793 L .25232 .49367 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24124 .49551 m .25232 .49367 L .26266 .49793 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.41738 .21361 m .43809 .21728 L .42644 .22005 L 1 .698 0 r
F
P
p
.40575 .2164 m .41738 .21361 L .42644 .22005 L 1 .698 0 r
F
P
p
.002 w
.38236 .49602 m .37089 .49785 L .3614 .49359 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34995 .49544 m .3614 .49359 L .37089 .49785 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.5265 .21349 m .54673 .21717 L .53471 .21993 L 1 .698 0 r
F
P
p
.5145 .21628 m .5265 .21349 L .53471 .21993 L 1 .698 0 r
F
P
p
.002 w
.49099 .49595 m .47916 .49778 L .4705 .49492 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.002 w
.45863 .50124 m .4705 .49492 L .47916 .49778 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.41453 .50639 m .40295 .50819 L .3939 .49418 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.38236 .49602 m .3939 .49418 L .40295 .50819 L p
1 .802 0 r
F P
0 0 0 r
s
P
p
.63565 .21337 m .6554 .21705 L .64301 .21982 L 1 .61 0 r
F
P
p
.62328 .21617 m .63565 .21337 L .64301 .21982 L 1 .634 0 r
F
P
p
.002 w
.59965 .49587 m .58745 .4977 L .57965 .49344 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56747 .49528 m .57965 .49344 L .58745 .4977 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.74483 .21326 m .76409 .21694 L .75134 .21971 L 1 .479 0 r
F
P
p
.73209 .21605 m .74483 .21326 L .75134 .21971 L 1 .53 0 r
F
P
p
.002 w
.67627 .49521 m .68882 .49336 L .69577 .49763 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.81028 .47176 m .82256 .45021 L .82808 .44512 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.84109 .44311 m .82808 .44512 L .82256 .45021 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.13256 .49559 m .12193 .49742 L .11047 .49315 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.09986 .495 m .11047 .49315 L .12193 .49742 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.27567 .21283 m .29703 .21651 L .28584 .21928 L 1 .698 0 r
F
P
p
.2645 .21562 m .27567 .21283 L .28584 .21928 L 1 .698 0 r
F
P
p
.002 w
.24124 .49551 m .23024 .49735 L .21963 .49307 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20865 .49492 m .21963 .49307 L .23024 .49735 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.38487 .21271 m .40575 .2164 L .39419 .21917 L 1 .698 0 r
F
P
p
.37333 .21551 m .38487 .21271 L .39419 .21917 L 1 .698 0 r
F
P
p
.002 w
.34995 .49544 m .33858 .49727 L .32882 .493 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.31748 .49485 m .32882 .493 L .33858 .49727 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.4941 .21259 m .5145 .21628 L .50257 .21905 L 1 .698 0 r
F
P
p
.4822 .21539 m .4941 .21259 L .50257 .21905 L 1 .698 0 r
F
P
p
.60337 .21248 m .62328 .21617 L .61099 .21894 L 1 .698 0 r
F
P
p
.59109 .21527 m .60337 .21248 L .61099 .21894 L 1 .698 0 r
F
P
p
.002 w
.56747 .49528 m .55536 .49712 L .5473 .49284 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53522 .49469 m .5473 .49284 L .55536 .49712 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71266 .21236 m .73209 .21605 L .71943 .21882 L 1 .439 0 r
F
P
p
.70001 .21516 m .71266 .21236 L .71943 .21882 L 1 .439 0 r
F
P
p
.002 w
.67627 .49521 m .6638 .49704 L .65659 .49277 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.64413 .49462 m .65659 .49277 L .6638 .49704 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.7851 .49513 m .77226 .49697 L .76591 .49269 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75308 .49454 m .76591 .49269 L .77226 .49697 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.09986 .495 m .08932 .49684 L .07759 .49256 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.24297 .21193 m .2645 .21562 L .25341 .2184 L 1 .43 0 r
F
P
p
.2319 .21473 m .24297 .21193 L .25341 .2184 L 1 .492 0 r
F
P
p
.002 w
.20865 .49492 m .19775 .49676 L .18687 .49248 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.17599 .49433 m .18687 .49248 L .19775 .49676 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.35229 .21181 m .37333 .21551 L .36187 .21828 L 1 .698 0 r
F
P
p
.34085 .21461 m .35229 .21181 L .36187 .21828 L 1 .698 0 r
F
P
p
.002 w
.31748 .49485 m .30621 .49669 L .29618 .4924 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.28493 .49426 m .29618 .4924 L .30621 .49669 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.46163 .2117 m .4822 .21539 L .47037 .21817 L 1 .698 0 r
F
P
p
.44982 .2145 m .46163 .2117 L .47037 .21817 L 1 .698 0 r
F
P
p
.57101 .21158 m .59109 .21527 L .57889 .21805 L 1 .698 0 r
F
P
p
.55883 .21438 m .57101 .21158 L .57889 .21805 L 1 .698 0 r
F
P
p
.002 w
.53522 .49469 m .52321 .49653 L .51489 .49225 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5029 .4941 m .51489 .49225 L .52321 .49653 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45863 .50124 m .44684 .50697 L .43803 .49433 L p
1 .758 0 r
F P
0 0 0 r
s
P
p
.002 w
.42618 .50459 m .43803 .49433 L .44684 .50697 L p
1 .807 0 r
F P
0 0 0 r
s
P
p
.68042 .21146 m .70001 .21516 L .68745 .21794 L 1 .384 0 r
F
P
p
.66787 .21427 m .68042 .21146 L .68745 .21794 L 1 .488 0 r
F
P
p
.002 w
.64413 .49462 m .63176 .49646 L .62429 .49217 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.61193 .49403 m .62429 .49217 L .63176 .49646 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.78986 .21135 m .80896 .21504 L .79603 .21782 L 1 .035 0 r
F
P
p
.77693 .21415 m .78986 .21135 L .79603 .21782 L 1 .14 0 r
F
P
p
.2102 .21103 m .2319 .21473 L .22091 .21751 L 1 .542 0 r
F
P
p
.19924 .21384 m .2102 .21103 L .22091 .21751 L 1 .698 0 r
F
P
p
.002 w
.17599 .49433 m .16519 .49618 L .15404 .49189 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.14327 .49374 m .15404 .49189 L .16519 .49618 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.31963 .21091 m .34085 .21461 L .32949 .2174 L 1 .698 0 r
F
P
p
.30829 .21372 m .31963 .21091 L .32949 .2174 L 1 .698 0 r
F
P
p
.002 w
.28493 .49426 m .27376 .4961 L .26347 .49181 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25232 .49367 m .26347 .49181 L .27376 .4961 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.42909 .2108 m .44982 .2145 L .43809 .21728 L 1 .698 0 r
F
P
p
.41738 .21361 m .42909 .2108 L .43809 .21728 L 1 .698 0 r
F
P
p
.002 w
.3939 .49418 m .38236 .49602 L .37292 .49173 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3614 .49359 m .37292 .49173 L .38236 .49602 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53859 .21068 m .55883 .21438 L .54673 .21717 L 1 .698 0 r
F
P
p
.5265 .21349 m .53859 .21068 L .54673 .21717 L 1 .698 0 r
F
P
p
.002 w
.5029 .4941 m .49099 .49595 L .4824 .49165 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4705 .49492 m .4824 .49165 L .49099 .49595 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.002 w
.42618 .50459 m .41453 .50639 L .40552 .49233 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.002 w
.3939 .49418 m .40552 .49233 L .41453 .50639 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.64811 .21056 m .66787 .21427 L .6554 .21705 L 1 .588 0 r
F
P
p
.63565 .21337 m .64811 .21056 L .6554 .21705 L 1 .61 0 r
F
P
p
.002 w
.61193 .49403 m .59965 .49587 L .59192 .49158 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57965 .49344 m .59192 .49158 L .59965 .49587 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75766 .21045 m .77693 .21415 L .76409 .21694 L 1 .375 0 r
F
P
p
.74483 .21326 m .75766 .21045 L .76409 .21694 L 1 .479 0 r
F
P
p
.002 w
.82256 .45021 m .83567 .4482 L .84109 .44311 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.14327 .49374 m .13256 .49559 L .12114 .49129 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.11047 .49315 m .12114 .49129 L .13256 .49559 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.28691 .21001 m .30829 .21372 L .29703 .21651 L 1 .698 0 r
F
P
p
.27567 .21283 m .28691 .21001 L .29703 .21651 L 1 .698 0 r
F
P
p
.002 w
.25232 .49367 m .24124 .49551 L .23068 .49121 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21963 .49307 m .23068 .49121 L .24124 .49551 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.39648 .20989 m .41738 .21361 L .40575 .2164 L 1 .698 0 r
F
P
p
.38487 .21271 m .39648 .20989 L .40575 .2164 L 1 .698 0 r
F
P
p
.002 w
.3614 .49359 m .34995 .49544 L .34025 .49113 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32882 .493 m .34025 .49113 L .34995 .49544 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.50609 .20978 m .5265 .21349 L .5145 .21628 L 1 .698 0 r
F
P
p
.4941 .21259 m .50609 .20978 L .5145 .21628 L 1 .698 0 r
F
P
p
.61573 .20966 m .63565 .21337 L .62328 .21617 L 1 .684 0 r
F
P
p
.60337 .21248 m .61573 .20966 L .62328 .21617 L 1 .698 0 r
F
P
p
.002 w
.57965 .49344 m .56747 .49528 L .55947 .49098 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5473 .49284 m .55947 .49098 L .56747 .49528 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72539 .20954 m .74483 .21326 L .73209 .21605 L 1 .394 0 r
F
P
p
.71266 .21236 m .72539 .20954 L .73209 .21605 L 1 .439 0 r
F
P
p
.002 w
.68882 .49336 m .67627 .49521 L .66913 .4909 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.65659 .49277 m .66913 .4909 L .67627 .49521 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.79731 .47368 m .7851 .49513 L .77882 .49083 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.76591 .49269 m .77882 .49083 L .7851 .49513 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.11047 .49315 m .09986 .495 L .08817 .49069 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.07759 .49256 m .08817 .49069 L .09986 .495 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.25411 .20911 m .27567 .21283 L .2645 .21562 L 1 .419 0 r
F
P
p
.24297 .21193 m .25411 .20911 L .2645 .21562 L 1 .43 0 r
F
P
p
.002 w
.21963 .49307 m .20865 .49492 L .19782 .49061 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.18687 .49248 m .19782 .49061 L .20865 .49492 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4705 .49492 m .45863 .50124 L .44985 .49106 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.002 w
.43803 .49433 m .44985 .49106 L .45863 .50124 L p
1 .758 0 r
F P
0 0 0 r
s
P
p
.3638 .20899 m .38487 .21271 L .37333 .21551 L 1 .698 0 r
F
P
p
.35229 .21181 m .3638 .20899 L .37333 .21551 L 1 .698 0 r
F
P
p
.002 w
.32882 .493 m .31748 .49485 L .30751 .49054 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29618 .4924 m .30751 .49054 L .31748 .49485 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.47352 .20887 m .4941 .21259 L .4822 .21539 L 1 .698 0 r
F
P
p
.46163 .2117 m .47352 .20887 L .4822 .21539 L 1 .698 0 r
F
P
p
.002 w
.81028 .47176 m .79731 .47368 L .79165 .484 L p
1 .516 0 r
F P
0 0 0 r
s
P
p
.002 w
.79165 .484 m .79731 .47368 L p
.77967 .49004 L 1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.79165 .484 m .80466 .47997 L .81028 .47176 L p
1 .516 0 r
F P
0 0 0 r
s
P
p
.002 w
.79165 .484 m .78381 .43503 L p
.80371 .47793 L 1 .306 0 r
F P
0 0 0 r
s
P
p
.002 w
.80466 .47997 m .79165 .484 L p
.80371 .47793 L 1 .306 0 r
F P
0 0 0 r
s
P
p
.002 w
.77882 .49083 m .79165 .484 L p
.77967 .49004 L 1 .61 0 r
F P
0 0 0 r
s
P
p
.58327 .20876 m .60337 .21248 L .59109 .21527 L 1 .698 0 r
F
P
p
.57101 .21158 m .58327 .20876 L .59109 .21527 L 1 .698 0 r
F
P
p
.002 w
.5473 .49284 m .53522 .49469 L .52696 .49038 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51489 .49225 m .52696 .49038 L .53522 .49469 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69306 .20864 m .71266 .21236 L .70001 .21516 L 1 .349 0 r
F
P
p
.68042 .21146 m .69306 .20864 L .70001 .21516 L 1 .384 0 r
F
P
p
.002 w
.65659 .49277 m .64413 .49462 L .63674 .4903 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.62429 .49217 m .63674 .4903 L .64413 .49462 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.78986 .21135 m .80287 .20852 L .80896 .21504 L 1 .035 0 r
F
P
p
.22125 .2082 m .24297 .21193 L .2319 .21473 L 1 .286 0 r
F
P
p
.2102 .21103 m .22125 .2082 L .2319 .21473 L 1 .542 0 r
F
P
p
.002 w
.18687 .49248 m .17599 .49433 L .1649 .49002 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.15404 .49189 m .1649 .49002 L .17599 .49433 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74567 .46071 m .73291 .46268 L .72667 .47536 L p
1 .381 0 r
F P
0 0 0 r
s
P
p
.33105 .20808 m .35229 .21181 L .34085 .21461 L 1 .698 0 r
F
P
p
.31963 .21091 m .33105 .20808 L .34085 .21461 L 1 .698 0 r
F
P
p
.002 w
.29618 .4924 m .28493 .49426 L .27469 .48994 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26347 .49181 m .27469 .48994 L .28493 .49426 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44089 .20797 m .46163 .2117 L .44982 .2145 L 1 .698 0 r
F
P
p
.42909 .2108 m .44089 .20797 L .44982 .2145 L 1 .698 0 r
F
P
p
.002 w
.40552 .49233 m .3939 .49418 L .38452 .48986 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37292 .49173 m .38452 .48986 L .3939 .49418 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55075 .20785 m .57101 .21158 L .55883 .21438 L 1 .698 0 r
F
P
p
.53859 .21068 m .55075 .20785 L .55883 .21438 L 1 .698 0 r
F
P
p
.002 w
.51489 .49225 m .5029 .4941 L .49438 .48978 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4824 .49165 m .49438 .48978 L .5029 .4941 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43803 .49433 m .42618 .50459 L .41722 .49046 L p
1 .738 0 r
F P
0 0 0 r
s
P
p
.002 w
.40552 .49233 m .41722 .49046 L .42618 .50459 L p
1 .767 0 r
F P
0 0 0 r
s
P
p
.66065 .20773 m .68042 .21146 L .66787 .21427 L 1 .533 0 r
F
P
p
.64811 .21056 m .66065 .20773 L .66787 .21427 L 1 .588 0 r
F
P
p
.002 w
.62429 .49217 m .61193 .49403 L .60427 .4897 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59192 .49158 m .60427 .4897 L .61193 .49403 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.77058 .20761 m .78986 .21135 L .77693 .21415 L 1 .18 0 r
F
P
p
.75766 .21045 m .77058 .20761 L .77693 .21415 L 1 .375 0 r
F
P
p
.002 w
.15404 .49189 m .14327 .49374 L .1319 .48942 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.12114 .49129 m .1319 .48942 L .14327 .49374 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.29823 .20718 m .31963 .21091 L .30829 .21372 L 1 .698 0 r
F
P
p
.28691 .21001 m .29823 .20718 L .30829 .21372 L 1 .698 0 r
F
P
p
.002 w
.26347 .49181 m .25232 .49367 L .24181 .48934 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23068 .49121 m .24181 .48934 L .25232 .49367 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.40818 .20706 m .42909 .2108 L .41738 .21361 L 1 .698 0 r
F
P
p
.39648 .20989 m .40818 .20706 L .41738 .21361 L 1 .698 0 r
F
P
p
.002 w
.37292 .49173 m .3614 .49359 L .35175 .48926 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34025 .49113 m .35175 .48926 L .3614 .49359 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.51816 .20694 m .53859 .21068 L .5265 .21349 L 1 .698 0 r
F
P
p
.50609 .20978 m .51816 .20694 L .5265 .21349 L 1 .698 0 r
F
P
p
.62817 .20682 m .64811 .21056 L .63565 .21337 L 1 .659 0 r
F
P
p
.61573 .20966 m .62817 .20682 L .63565 .21337 L 1 .684 0 r
F
P
p
.002 w
.59192 .49158 m .57965 .49344 L .57173 .4891 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55947 .49098 m .57173 .4891 L .57965 .49344 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4824 .49165 m .4705 .49492 L .46172 .48918 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.002 w
.44985 .49106 m .46172 .48918 L .4705 .49492 L p
1 .724 0 r
F P
0 0 0 r
s
P
p
.73821 .20671 m .75766 .21045 L .74483 .21326 L 1 .329 0 r
F
P
p
.72539 .20954 m .73821 .20671 L .74483 .21326 L 1 .394 0 r
F
P
p
.002 w
.70146 .4915 m .68882 .49336 L .68176 .48903 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.66913 .4909 m .68176 .48903 L .68882 .49336 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.12114 .49129 m .11047 .49315 L .09882 .48881 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.08817 .49069 m .09882 .48881 L .11047 .49315 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.26533 .20627 m .28691 .21001 L .27567 .21283 L 1 .419 0 r
F
P
p
.25411 .20911 m .26533 .20627 L .27567 .21283 L 1 .419 0 r
F
P
p
.002 w
.23068 .49121 m .21963 .49307 L .20885 .48874 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.19782 .49061 m .20885 .48874 L .21963 .49307 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.3754 .20615 m .39648 .20989 L .38487 .21271 L 1 .698 0 r
F
P
p
.3638 .20899 m .3754 .20615 L .38487 .21271 L 1 .698 0 r
F
P
p
.002 w
.34025 .49113 m .32882 .493 L .31891 .48866 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.30751 .49054 m .31891 .48866 L .32882 .493 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.4855 .20603 m .50609 .20978 L .4941 .21259 L 1 .698 0 r
F
P
p
.47352 .20887 m .4855 .20603 L .4941 .21259 L 1 .698 0 r
F
P
p
.002 w
.82256 .45021 m .81028 .47176 L .80466 .47997 L p
1 .429 0 r
F P
0 0 0 r
s
P
p
.59562 .20591 m .61573 .20966 L .60337 .21248 L 1 .698 0 r
F
P
p
.58327 .20876 m .59562 .20591 L .60337 .21248 L 1 .698 0 r
F
P
p
.002 w
.55947 .49098 m .5473 .49284 L .53912 .4885 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52696 .49038 m .53912 .4885 L .5473 .49284 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44985 .49106 m .43803 .49433 L .429 .48858 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.002 w
.41722 .49046 m .429 .48858 L .43803 .49433 L p
1 .738 0 r
F P
0 0 0 r
s
P
p
.70578 .2058 m .72539 .20954 L .71266 .21236 L 1 .314 0 r
F
P
p
.69306 .20864 m .70578 .2058 L .71266 .21236 L 1 .349 0 r
F
P
p
.002 w
.66913 .4909 m .65659 .49277 L .64927 .48842 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.63674 .4903 m .64927 .48842 L .65659 .49277 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77882 .49083 m .76591 .49269 L .75822 .44893 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.83567 .4482 m .82256 .45021 L .81772 .47521 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.80466 .47997 m .81772 .47521 L .82256 .45021 L p
1 .429 0 r
F P
0 0 0 r
s
P
p
.23237 .20536 m .25411 .20911 L .24297 .21193 L 1 .163 0 r
F
P
p
.22125 .2082 m .23237 .20536 L .24297 .21193 L 1 .286 0 r
F
P
p
.002 w
.19782 .49061 m .18687 .49248 L .17582 .48813 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1649 .49002 m .17582 .48813 L .18687 .49248 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72667 .47536 m .73938 .46756 L .74567 .46071 L p
1 .381 0 r
F P
0 0 0 r
s
P
p
.34255 .20524 m .3638 .20899 L .35229 .21181 L 1 .698 0 r
F
P
p
.33105 .20808 m .34255 .20524 L .35229 .21181 L 1 .698 0 r
F
P
p
.002 w
.30751 .49054 m .29618 .4924 L .286 .48805 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27469 .48994 m .286 .48805 L .29618 .4924 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.45276 .20512 m .47352 .20887 L .46163 .2117 L 1 .698 0 r
F
P
p
.44089 .20797 m .45276 .20512 L .46163 .2117 L 1 .698 0 r
F
P
p
.002 w
.41722 .49046 m .40552 .49233 L .3962 .48798 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38452 .48986 m .3962 .48798 L .40552 .49233 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.563 .205 m .58327 .20876 L .57101 .21158 L 1 .698 0 r
F
P
p
.55075 .20785 m .563 .205 L .57101 .21158 L 1 .698 0 r
F
P
p
.002 w
.52696 .49038 m .51489 .49225 L .50644 .4879 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49438 .48978 m .50644 .4879 L .51489 .49225 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67328 .20488 m .69306 .20864 L .68042 .21146 L 1 .453 0 r
F
P
p
.66065 .20773 m .67328 .20488 L .68042 .21146 L 1 .533 0 r
F
P
p
.002 w
.63674 .4903 m .62429 .49217 L .6167 .48782 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.60427 .4897 m .6167 .48782 L .62429 .49217 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.78358 .20476 m .80287 .20852 L .78986 .21135 L 1 .035 0 r
F
P
p
.77058 .20761 m .78358 .20476 L .78986 .21135 L 1 .18 0 r
F
P
p
.002 w
.1649 .49002 m .15404 .49189 L .14272 .48753 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1319 .48942 m .14272 .48753 L .15404 .49189 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.30962 .20432 m .33105 .20808 L .31963 .21091 L 1 .698 0 r
F
P
p
.29823 .20718 m .30962 .20432 L .31963 .21091 L 1 .698 0 r
F
P
p
.002 w
.27469 .48994 m .26347 .49181 L .25301 .48745 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24181 .48934 m .25301 .48745 L .26347 .49181 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.41995 .20421 m .44089 .20797 L .42909 .2108 L 1 .698 0 r
F
P
p
.40818 .20706 m .41995 .20421 L .42909 .2108 L 1 .698 0 r
F
P
p
.002 w
.38452 .48986 m .37292 .49173 L .36333 .48737 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35175 .48926 m .36333 .48737 L .37292 .49173 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53031 .20409 m .55075 .20785 L .53859 .21068 L 1 .698 0 r
F
P
p
.51816 .20694 m .53031 .20409 L .53859 .21068 L 1 .698 0 r
F
P
p
.002 w
.49438 .48978 m .4824 .49165 L .47368 .48729 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46172 .48918 m .47368 .48729 L .4824 .49165 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.6407 .20397 m .66065 .20773 L .64811 .21056 L 1 .634 0 r
F
P
p
.62817 .20682 m .6407 .20397 L .64811 .21056 L 1 .659 0 r
F
P
p
.002 w
.60427 .4897 m .59192 .49158 L .58407 .48721 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57173 .4891 m .58407 .48721 L .59192 .49158 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75112 .20385 m .77058 .20761 L .75766 .21045 L 1 .265 0 r
F
P
p
.73821 .20671 m .75112 .20385 L .75766 .21045 L 1 .329 0 r
F
P
p
.002 w
.71409 .48583 m .70146 .4915 L .69448 .48714 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.68176 .48903 m .69448 .48714 L .70146 .4915 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77114 .44691 m .77882 .49083 L p
.76116 .45491 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.79165 .484 m .77882 .49083 L .77114 .44691 L p
1 .366 0 r
F P
0 0 0 r
s
P
p
.002 w
.77114 .44691 m .78381 .43503 L .79165 .484 L p
1 .366 0 r
F P
0 0 0 r
s
P
p
.002 w
.77114 .44691 m .76533 .46203 L p
.78119 .43886 L 1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.78381 .43503 m .77114 .44691 L p
.78119 .43886 L 1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.75822 .44893 m .77114 .44691 L p
.76116 .45491 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.77114 .44691 m .75822 .44893 L .75234 .46559 L p
1 .285 0 r
F P
0 0 0 r
s
P
p
.002 w
.73938 .46756 m .75234 .46559 L .75822 .44893 L p
1 .325 0 r
F P
0 0 0 r
s
P
p
.002 w
.1319 .48942 m .12114 .49129 L .10955 .48692 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.09882 .48881 m .10955 .48692 L .12114 .49129 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.27663 .20341 m .29823 .20718 L .28691 .21001 L 1 .419 0 r
F
P
p
.26533 .20627 m .27663 .20341 L .28691 .21001 L 1 .419 0 r
F
P
p
.002 w
.24181 .48934 m .23068 .49121 L .21995 .48684 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20885 .48874 m .21995 .48684 L .23068 .49121 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.38707 .20329 m .40818 .20706 L .39648 .20989 L 1 .698 0 r
F
P
p
.3754 .20615 m .38707 .20329 L .39648 .20989 L 1 .698 0 r
F
P
p
.002 w
.35175 .48926 m .34025 .49113 L .33039 .48677 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.31891 .48866 m .33039 .48677 L .34025 .49113 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.49755 .20317 m .51816 .20694 L .50609 .20978 L 1 .698 0 r
F
P
p
.4855 .20603 m .49755 .20317 L .50609 .20978 L 1 .698 0 r
F
P
p
.002 w
.46172 .48918 m .44985 .49106 L .44086 .48669 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.429 .48858 m .44086 .48669 L .44985 .49106 L p
1 .703 0 r
F P
0 0 0 r
s
P
p
.60806 .20305 m .62817 .20682 L .61573 .20966 L 1 .698 0 r
F
P
p
.59562 .20591 m .60806 .20305 L .61573 .20966 L 1 .698 0 r
F
P
p
.002 w
.57173 .4891 m .55947 .49098 L .55136 .48661 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53912 .4885 m .55136 .48661 L .55947 .49098 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71859 .20293 m .73821 .20671 L .72539 .20954 L 1 .244 0 r
F
P
p
.70578 .2058 m .71859 .20293 L .72539 .20954 L 1 .314 0 r
F
P
p
.002 w
.68176 .48903 m .66913 .4909 L .66189 .48653 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.64927 .48842 m .66189 .48653 L .66913 .4909 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.81772 .47521 m .83056 .46331 L .83567 .4482 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.24356 .20249 m .26533 .20627 L .25411 .20911 L 1 .14 0 r
F
P
p
.23237 .20536 m .24356 .20249 L .25411 .20911 L 1 .163 0 r
F
P
p
.002 w
.20885 .48874 m .19782 .49061 L .18682 .48624 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.17582 .48813 m .18682 .48624 L .19782 .49061 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.35412 .20237 m .3754 .20615 L .3638 .20899 L 1 .698 0 r
F
P
p
.34255 .20524 m .35412 .20237 L .3638 .20899 L 1 .698 0 r
F
P
p
.002 w
.31891 .48866 m .30751 .49054 L .29738 .48616 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.286 .48805 m .29738 .48616 L .30751 .49054 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.46471 .20225 m .4855 .20603 L .47352 .20887 L 1 .698 0 r
F
P
p
.45276 .20512 m .46471 .20225 L .47352 .20887 L 1 .698 0 r
F
P
p
.002 w
.429 .48858 m .41722 .49046 L .40796 .48608 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3962 .48798 m .40796 .48608 L .41722 .49046 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57534 .20213 m .59562 .20591 L .58327 .20876 L 1 .698 0 r
F
P
p
.563 .205 m .57534 .20213 L .58327 .20876 L 1 .698 0 r
F
P
p
.002 w
.53912 .4885 m .52696 .49038 L .51858 .486 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50644 .4879 m .51858 .486 L .52696 .49038 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68599 .20201 m .70578 .2058 L .69306 .20864 L 1 .419 0 r
F
P
p
.67328 .20488 m .68599 .20201 L .69306 .20864 L 1 .453 0 r
F
P
p
.002 w
.64927 .48842 m .63674 .4903 L .62913 .47882 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.6167 .48782 m .62913 .47882 L .63674 .4903 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.78358 .20476 m .79668 .20189 L .80287 .20852 L 1 .035 0 r
F
P
p
.002 w
.17582 .48813 m .1649 .49002 L .15362 .48563 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.14272 .48753 m .15362 .48563 L .1649 .49002 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.3211 .20145 m .34255 .20524 L .33105 .20808 L 1 .698 0 r
F
P
p
.30962 .20432 m .3211 .20145 L .33105 .20808 L 1 .698 0 r
F
P
p
.002 w
.286 .48805 m .27469 .48994 L .26429 .48555 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25301 .48745 m .26429 .48555 L .27469 .48994 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69448 .48714 m .70728 .48523 L .71409 .48583 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.43181 .20133 m .45276 .20512 L .44089 .20797 L 1 .698 0 r
F
P
p
.41995 .20421 m .43181 .20133 L .44089 .20797 L 1 .698 0 r
F
P
p
.002 w
.3962 .48798 m .38452 .48986 L .37499 .48547 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36333 .48737 m .37499 .48547 L .38452 .48986 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.54255 .20121 m .563 .205 L .55075 .20785 L 1 .698 0 r
F
P
p
.53031 .20409 m .54255 .20121 L .55075 .20785 L 1 .698 0 r
F
P
p
.002 w
.50644 .4879 m .49438 .48978 L .48572 .48539 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47368 .48729 m .48572 .48539 L .49438 .48978 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.65332 .20109 m .67328 .20488 L .66065 .20773 L 1 .565 0 r
F
P
p
.6407 .20397 m .65332 .20109 L .66065 .20773 L 1 .634 0 r
F
P
p
.002 w
.6167 .48782 m .60427 .4897 L .59649 .48531 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58407 .48721 m .59649 .48531 L .60427 .4897 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.76412 .20097 m .78358 .20476 L .77058 .20761 L 1 .145 0 r
F
P
p
.75112 .20385 m .76412 .20097 L .77058 .20761 L 1 .265 0 r
F
P
p
.002 w
.76533 .46203 m .77114 .44691 L p
.75383 .4641 L 1 .285 0 r
F P
0 0 0 r
s
P
p
.002 w
.76533 .46203 m .77846 .46003 L .78381 .43503 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.76533 .46203 m .75881 .45895 L p
.77692 .45995 L 1 .43 0 r
F P
0 0 0 r
s
P
p
.002 w
.77846 .46003 m .76533 .46203 L p
.77692 .45995 L 1 .43 0 r
F P
0 0 0 r
s
P
p
.002 w
.75234 .46559 m .76533 .46203 L p
.75383 .4641 L 1 .285 0 r
F P
0 0 0 r
s
P
p
.002 w
.14272 .48753 m .1319 .48942 L .12035 .48502 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.10955 .48692 m .12035 .48502 L .1319 .48942 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.288 .20053 m .30962 .20432 L .29823 .20718 L 1 .419 0 r
F
P
p
.27663 .20341 m .288 .20053 L .29823 .20718 L 1 .419 0 r
F
P
p
.002 w
.25301 .48745 m .24181 .48934 L .23113 .48494 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.21995 .48684 m .23113 .48494 L .24181 .48934 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.39883 .20041 m .41995 .20421 L .40818 .20706 L 1 .698 0 r
F
P
p
.38707 .20329 m .39883 .20041 L .40818 .20706 L 1 .698 0 r
F
P
p
.002 w
.36333 .48737 m .35175 .48926 L .34195 .48486 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33039 .48677 m .34195 .48486 L .35175 .48926 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.50969 .20029 m .53031 .20409 L .51816 .20694 L 1 .698 0 r
F
P
p
.49755 .20317 m .50969 .20029 L .51816 .20694 L 1 .698 0 r
F
P
p
.002 w
.47368 .48729 m .46172 .48918 L .4528 .48478 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44086 .48669 m .4528 .48478 L .46172 .48918 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62057 .20017 m .6407 .20397 L .62817 .20682 L 1 .684 0 r
F
P
p
.60806 .20305 m .62057 .20017 L .62817 .20682 L 1 .698 0 r
F
P
p
.002 w
.58407 .48721 m .57173 .4891 L .56368 .4847 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55136 .48661 m .56368 .4847 L .57173 .4891 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73149 .20005 m .75112 .20385 L .73821 .20671 L 1 .209 0 r
F
P
p
.71859 .20293 m .73149 .20005 L .73821 .20671 L 1 .244 0 r
F
P
p
.002 w
.69448 .48714 m .68176 .48903 L .67459 .48462 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.66189 .48653 m .67459 .48462 L .68176 .48903 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.25483 .1996 m .27663 .20341 L .26533 .20627 L 1 .14 0 r
F
P
p
.24356 .20249 m .25483 .1996 L .26533 .20627 L 1 .14 0 r
F
P
p
.002 w
.21995 .48684 m .20885 .48874 L .1979 .48433 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.18682 .48624 m .1979 .48433 L .20885 .48874 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72008 .47948 m .72667 .47536 L p
.70814 .4848 L 1 .627 0 r
F P
0 0 0 r
s
P
p
.002 w
.72008 .47948 m .73296 .47424 L .73938 .46756 L p
1 .551 0 r
F P
0 0 0 r
s
P
p
.002 w
.72008 .47948 m .71306 .47164 L p
.73209 .47412 L 1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.73296 .47424 m .72008 .47948 L p
.73209 .47412 L 1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.70728 .48523 m .72008 .47948 L p
.70814 .4848 L 1 .627 0 r
F P
0 0 0 r
s
P
p
.36578 .19948 m .38707 .20329 L .3754 .20615 L 1 .698 0 r
F
P
p
.35412 .20237 m .36578 .19948 L .3754 .20615 L 1 .698 0 r
F
P
p
.002 w
.33039 .48677 m .31891 .48866 L .30884 .48425 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29738 .48616 m .30884 .48425 L .31891 .48866 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.47675 .19936 m .49755 .20317 L .4855 .20603 L 1 .698 0 r
F
P
p
.46471 .20225 m .47675 .19936 L .4855 .20603 L 1 .698 0 r
F
P
p
.002 w
.44086 .48669 m .429 .48858 L .4198 .48417 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40796 .48608 m .4198 .48417 L .429 .48858 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.58776 .19924 m .60806 .20305 L .59562 .20591 L 1 .698 0 r
F
P
p
.57534 .20213 m .58776 .19924 L .59562 .20591 L 1 .698 0 r
F
P
p
.002 w
.55136 .48661 m .53912 .4885 L .5308 .48409 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51858 .486 m .5308 .48409 L .53912 .4885 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69879 .19912 m .71859 .20293 L .70578 .2058 L 1 .314 0 r
F
P
p
.68599 .20201 m .69879 .19912 L .70578 .2058 L 1 .419 0 r
F
P
p
.002 w
.66189 .48653 m .64927 .48842 L .64172 .47689 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.62913 .47882 m .64172 .47689 L .64927 .48842 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.78381 .43503 m .79689 .43295 L .80466 .47997 L p
1 .306 0 r
F P
0 0 0 r
s
P
p
.002 w
.79689 .43295 m .78381 .43503 L .77846 .46003 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.18682 .48624 m .17582 .48813 L .1646 .48372 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.15362 .48563 m .1646 .48372 L .17582 .48813 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.33265 .19856 m .35412 .20237 L .34255 .20524 L 1 .698 0 r
F
P
p
.3211 .20145 m .33265 .19856 L .34255 .20524 L 1 .698 0 r
F
P
p
.002 w
.29738 .48616 m .286 .48805 L .27565 .48364 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26429 .48555 m .27565 .48364 L .286 .48805 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44374 .19844 m .46471 .20225 L .45276 .20512 L 1 .698 0 r
F
P
p
.43181 .20133 m .44374 .19844 L .45276 .20512 L 1 .698 0 r
F
P
p
.002 w
.40796 .48608 m .3962 .48798 L .38673 .48356 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37499 .48547 m .38673 .48356 L .3962 .48798 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55487 .19832 m .57534 .20213 L .563 .205 L 1 .698 0 r
F
P
p
.54255 .20121 m .55487 .19832 L .563 .205 L 1 .698 0 r
F
P
p
.002 w
.51858 .486 m .50644 .4879 L .49785 .48348 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48572 .48539 m .49785 .48348 L .50644 .4879 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66602 .1982 m .68599 .20201 L .67328 .20488 L 1 .463 0 r
F
P
p
.65332 .20109 m .66602 .1982 L .67328 .20488 L 1 .565 0 r
F
P
p
.002 w
.62913 .47882 m .6167 .48782 L .609 .4834 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.59649 .48531 m .609 .4834 L .6167 .48782 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.77721 .19808 m .79668 .20189 L .78358 .20476 L 1 .035 0 r
F
P
p
.76412 .20097 m .77721 .19808 L .78358 .20476 L 1 .145 0 r
F
P
p
.002 w
.81772 .47521 m .80466 .47997 L .79689 .43295 L p
1 .289 0 r
F P
0 0 0 r
s
P
p
.002 w
.15362 .48563 m .14272 .48753 L .13122 .4831 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.12035 .48502 m .13122 .4831 L .14272 .48753 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.29945 .19763 m .3211 .20145 L .30962 .20432 L 1 .384 0 r
F
P
p
.288 .20053 m .29945 .19763 L .30962 .20432 L 1 .419 0 r
F
P
p
.002 w
.26429 .48555 m .25301 .48745 L .24239 .48302 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23113 .48494 m .24239 .48302 L .25301 .48745 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.41066 .19751 m .43181 .20133 L .41995 .20421 L 1 .698 0 r
F
P
p
.39883 .20041 m .41066 .19751 L .41995 .20421 L 1 .698 0 r
F
P
p
.002 w
.37499 .48547 m .36333 .48737 L .35359 .48294 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34195 .48486 m .35359 .48294 L .36333 .48737 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52191 .19739 m .54255 .20121 L .53031 .20409 L 1 .698 0 r
F
P
p
.50969 .20029 m .52191 .19739 L .53031 .20409 L 1 .698 0 r
F
P
p
.002 w
.48572 .48539 m .47368 .48729 L .46482 .48286 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4528 .48478 m .46482 .48286 L .47368 .48729 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75234 .46559 m .73938 .46756 L .73296 .47424 L p
1 .501 0 r
F P
0 0 0 r
s
P
p
.63318 .19727 m .65332 .20109 L .6407 .20397 L 1 .601 0 r
F
P
p
.62057 .20017 m .63318 .19727 L .6407 .20397 L 1 .684 0 r
F
P
p
.002 w
.59649 .48531 m .58407 .48721 L .57609 .48278 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56368 .4847 m .57609 .48278 L .58407 .48721 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.74448 .19715 m .76412 .20097 L .75112 .20385 L 1 .105 0 r
F
P
p
.73149 .20005 m .74448 .19715 L .75112 .20385 L 1 .209 0 r
F
P
p
.002 w
.70728 .48523 m .69448 .48714 L .68739 .4827 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.67459 .48462 m .68739 .4827 L .69448 .48714 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.26618 .1967 m .288 .20053 L .27663 .20341 L 1 .14 0 r
F
P
p
.25483 .1996 m .26618 .1967 L .27663 .20341 L 1 .14 0 r
F
P
p
.002 w
.23113 .48494 m .21995 .48684 L .20905 .48241 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1979 .48433 m .20905 .48241 L .21995 .48684 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.37751 .19658 m .39883 .20041 L .38707 .20329 L 1 .698 0 r
F
P
p
.36578 .19948 m .37751 .19658 L .38707 .20329 L 1 .698 0 r
F
P
p
.002 w
.34195 .48486 m .33039 .48677 L .32037 .48233 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.30884 .48425 m .32037 .48233 L .33039 .48677 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.48887 .19646 m .50969 .20029 L .49755 .20317 L 1 .698 0 r
F
P
p
.47675 .19936 m .48887 .19646 L .49755 .20317 L 1 .698 0 r
F
P
p
.002 w
.4528 .48478 m .44086 .48669 L .43173 .48225 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4198 .48417 m .43173 .48225 L .44086 .48669 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60026 .19634 m .62057 .20017 L .60806 .20305 L 1 .698 0 r
F
P
p
.58776 .19924 m .60026 .19634 L .60806 .20305 L 1 .698 0 r
F
P
p
.002 w
.56368 .4847 m .55136 .48661 L .54311 .48217 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5308 .48409 m .54311 .48217 L .55136 .48661 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71168 .19622 m .73149 .20005 L .71859 .20293 L 1 .174 0 r
F
P
p
.69879 .19912 m .71168 .19622 L .71859 .20293 L 1 .314 0 r
F
P
p
.002 w
.67459 .48462 m .66189 .48653 L .6544 .47494 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.64172 .47689 m .6544 .47494 L .66189 .48653 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.64172 .47689 m .62913 .47882 L .62154 .47762 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.609 .4834 m .62154 .47762 L .62913 .47882 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.79689 .43295 m .81007 .43086 L .81772 .47521 L p
1 .289 0 r
F P
0 0 0 r
s
P
p
.002 w
.81007 .43086 m .79689 .43295 L .79133 .44801 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.77846 .46003 m .79133 .44801 L .79689 .43295 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.1979 .48433 m .18682 .48624 L .17565 .48179 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.1646 .48372 m .17565 .48179 L .18682 .48624 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.34429 .19565 m .36578 .19948 L .35412 .20237 L 1 .698 0 r
F
P
p
.33265 .19856 m .34429 .19565 L .35412 .20237 L 1 .698 0 r
F
P
p
.002 w
.30884 .48425 m .29738 .48616 L .28708 .48171 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27565 .48364 m .28708 .48171 L .29738 .48616 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.45576 .19552 m .47675 .19936 L .46471 .20225 L 1 .698 0 r
F
P
p
.44374 .19844 m .45576 .19552 L .46471 .20225 L 1 .698 0 r
F
P
p
.002 w
.4198 .48417 m .40796 .48608 L .39855 .48163 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38673 .48356 m .39855 .48163 L .40796 .48608 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.56727 .1954 m .58776 .19924 L .57534 .20213 L 1 .698 0 r
F
P
p
.55487 .19832 m .56727 .1954 L .57534 .20213 L 1 .698 0 r
F
P
p
.002 w
.5308 .48409 m .51858 .486 L .51006 .48155 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49785 .48348 m .51006 .48155 L .51858 .486 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67881 .19528 m .69879 .19912 L .68599 .20201 L 1 .419 0 r
F
P
p
.66602 .1982 m .67881 .19528 L .68599 .20201 L 1 .463 0 r
F
P
p
.002 w
.83056 .46331 m .81772 .47521 L .81007 .43086 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.77721 .19808 m .79039 .19516 L .79668 .20189 L 1 .035 0 r
F
P
p
.002 w
.1646 .48372 m .15362 .48563 L .14217 .48117 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.13122 .4831 m .14217 .48117 L .15362 .48563 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.31099 .19471 m .33265 .19856 L .3211 .20145 L 1 .349 0 r
F
P
p
.29945 .19763 m .31099 .19471 L .3211 .20145 L 1 .384 0 r
F
P
p
.002 w
.27565 .48364 m .26429 .48555 L .25372 .48109 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24239 .48302 m .25372 .48109 L .26429 .48555 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.42258 .19459 m .44374 .19844 L .43181 .20133 L 1 .698 0 r
F
P
p
.41066 .19751 m .42258 .19459 L .43181 .20133 L 1 .698 0 r
F
P
p
.002 w
.38673 .48356 m .37499 .48547 L .36531 .48101 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35359 .48294 m .36531 .48101 L .37499 .48547 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53421 .19447 m .55487 .19832 L .54255 .20121 L 1 .698 0 r
F
P
p
.52191 .19739 m .53421 .19447 L .54255 .20121 L 1 .698 0 r
F
P
p
.002 w
.49785 .48348 m .48572 .48539 L .47693 .48093 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46482 .48286 m .47693 .48093 L .48572 .48539 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.76533 .46203 m .75234 .46559 L .74586 .4669 L p
1 .456 0 r
F P
0 0 0 r
s
P
p
.002 w
.73296 .47424 m .74586 .4669 L .75234 .46559 L p
1 .501 0 r
F P
0 0 0 r
s
P
p
.64587 .19435 m .66602 .1982 L .65332 .20109 L 1 .52 0 r
F
P
p
.63318 .19727 m .64587 .19435 L .65332 .20109 L 1 .601 0 r
F
P
p
.002 w
.609 .4834 m .59649 .48531 L .58858 .48085 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57609 .48278 m .58858 .48085 L .59649 .48531 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75756 .19423 m .77721 .19808 L .76412 .20097 L 1 0 0 r
F
P
p
.74448 .19715 m .75756 .19423 L .76412 .20097 L 1 .105 0 r
F
P
p
.002 w
.72008 .47948 m .70728 .48523 L .7001 .47361 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.002 w
.68739 .4827 m .7001 .47361 L .70728 .48523 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.27761 .19377 m .29945 .19763 L .288 .20053 L 1 .14 0 r
F
P
p
.26618 .1967 m .27761 .19377 L .288 .20053 L 1 .14 0 r
F
P
p
.002 w
.24239 .48302 m .23113 .48494 L .22028 .48047 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.20905 .48241 m .22028 .48047 L .23113 .48494 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.38933 .19365 m .41066 .19751 L .39883 .20041 L 1 .698 0 r
F
P
p
.37751 .19658 m .38933 .19365 L .39883 .20041 L 1 .698 0 r
F
P
p
.002 w
.35359 .48294 m .34195 .48486 L .33199 .48039 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32037 .48233 m .33199 .48039 L .34195 .48486 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.50107 .19353 m .52191 .19739 L .50969 .20029 L 1 .698 0 r
F
P
p
.48887 .19646 m .50107 .19353 L .50969 .20029 L 1 .698 0 r
F
P
p
.002 w
.46482 .48286 m .4528 .48478 L .44373 .48031 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43173 .48225 m .44373 .48031 L .4528 .48478 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.81007 .43086 m .82333 .42875 L .83056 .46331 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.61285 .19341 m .63318 .19727 L .62057 .20017 L 1 .684 0 r
F
P
p
.60026 .19634 m .61285 .19341 L .62057 .20017 L 1 .698 0 r
F
P
p
.002 w
.57609 .48278 m .56368 .4847 L .5555 .48023 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54311 .48217 m .5555 .48023 L .56368 .4847 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72466 .19329 m .74448 .19715 L .73149 .20005 L 1 .14 0 r
F
P
p
.71168 .19622 m .72466 .19329 L .73149 .20005 L 1 .174 0 r
F
P
p
.002 w
.68739 .4827 m .67459 .48462 L .66717 .47298 L p
1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.6544 .47494 m .66717 .47298 L .67459 .48462 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.6544 .47494 m .64172 .47689 L .63417 .47235 L p
1 .598 0 r
F P
0 0 0 r
s
P
p
.002 w
.62154 .47762 m .63417 .47235 L .64172 .47689 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.79133 .44801 m .80424 .43593 L .81007 .43086 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.82333 .42875 m .81007 .43086 L .80424 .43593 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.20905 .48241 m .1979 .48433 L .18677 .47985 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.17565 .48179 m .18677 .47985 L .1979 .48433 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.356 .19271 m .37751 .19658 L .36578 .19948 L 1 .698 0 r
F
P
p
.34429 .19565 m .356 .19271 L .36578 .19948 L 1 .698 0 r
F
P
p
.002 w
.32037 .48233 m .30884 .48425 L .2986 .47977 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.28708 .48171 m .2986 .47977 L .30884 .48425 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.46787 .19259 m .48887 .19646 L .47675 .19936 L 1 .698 0 r
F
P
p
.45576 .19552 m .46787 .19259 L .47675 .19936 L 1 .698 0 r
F
P
p
.002 w
.43173 .48225 m .4198 .48417 L .41046 .47969 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39855 .48163 m .41046 .47969 L .4198 .48417 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57976 .19247 m .60026 .19634 L .58776 .19924 L 1 .698 0 r
F
P
p
.56727 .1954 m .57976 .19247 L .58776 .19924 L 1 .698 0 r
F
P
p
.002 w
.54311 .48217 m .5308 .48409 L .52235 .47961 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51006 .48155 m .52235 .47961 L .5308 .48409 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69169 .19235 m .71168 .19622 L .69879 .19912 L 1 .349 0 r
F
P
p
.67881 .19528 m .69169 .19235 L .69879 .19912 L 1 .419 0 r
F
P
p
.002 w
.17565 .48179 m .1646 .48372 L .15319 .47923 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.14217 .48117 m .15319 .47923 L .1646 .48372 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.3226 .19177 m .34429 .19565 L .33265 .19856 L 1 .349 0 r
F
P
p
.31099 .19471 m .3226 .19177 L .33265 .19856 L 1 .349 0 r
F
P
p
.002 w
.28708 .48171 m .27565 .48364 L .26513 .47915 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25372 .48109 m .26513 .47915 L .27565 .48364 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.7001 .47361 m .71306 .47164 L .72008 .47948 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.43458 .19165 m .45576 .19552 L .44374 .19844 L 1 .698 0 r
F
P
p
.42258 .19459 m .43458 .19165 L .44374 .19844 L 1 .698 0 r
F
P
p
.002 w
.39855 .48163 m .38673 .48356 L .37711 .47906 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36531 .48101 m .37711 .47906 L .38673 .48356 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74586 .4669 m .75881 .45895 L .76533 .46203 L p
1 .456 0 r
F P
0 0 0 r
s
P
p
.5466 .19153 m .56727 .1954 L .55487 .19832 L 1 .698 0 r
F
P
p
.53421 .19447 m .5466 .19153 L .55487 .19832 L 1 .698 0 r
F
P
p
.002 w
.51006 .48155 m .49785 .48348 L .48912 .47898 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47693 .48093 m .48912 .47898 L .49785 .48348 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.65865 .1914 m .67881 .19528 L .66602 .1982 L 1 .429 0 r
F
P
p
.64587 .19435 m .65865 .1914 L .66602 .1982 L 1 .52 0 r
F
P
p
.002 w
.62154 .47762 m .609 .4834 L .60116 .4789 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.58858 .48085 m .60116 .4789 L .609 .4834 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.77073 .19128 m .79039 .19516 L .77721 .19808 L 1 0 0 r
F
P
p
.75756 .19423 m .77073 .19128 L .77721 .19808 L 1 0 0 r
F
P
p
.28912 .19083 m .31099 .19471 L .29945 .19763 L 1 .105 0 r
F
P
p
.27761 .19377 m .28912 .19083 L .29945 .19763 L 1 .14 0 r
F
P
p
.002 w
.25372 .48109 m .24239 .48302 L .23159 .47852 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.22028 .48047 m .23159 .47852 L .24239 .48302 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.40123 .19071 m .42258 .19459 L .41066 .19751 L 1 .698 0 r
F
P
p
.38933 .19365 m .40123 .19071 L .41066 .19751 L 1 .698 0 r
F
P
p
.002 w
.36531 .48101 m .35359 .48294 L .34369 .47844 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33199 .48039 m .34369 .47844 L .35359 .48294 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.51336 .19058 m .53421 .19447 L .52191 .19739 L 1 .698 0 r
F
P
p
.50107 .19353 m .51336 .19058 L .52191 .19739 L 1 .698 0 r
F
P
p
.002 w
.47693 .48093 m .46482 .48286 L .45582 .47836 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44373 .48031 m .45582 .47836 L .46482 .48286 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62553 .19046 m .64587 .19435 L .63318 .19727 L 1 .614 0 r
F
P
p
.61285 .19341 m .62553 .19046 L .63318 .19727 L 1 .684 0 r
F
P
p
.002 w
.58858 .48085 m .57609 .48278 L .56798 .47828 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5555 .48023 m .56798 .47828 L .57609 .48278 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73774 .19034 m .75756 .19423 L .74448 .19715 L 1 .07 0 r
F
P
p
.72466 .19329 m .73774 .19034 L .74448 .19715 L 1 .14 0 r
F
P
p
.002 w
.7001 .47361 m .68739 .4827 L .67997 .46813 L p
1 .533 0 r
F P
0 0 0 r
s
P
p
.002 w
.66717 .47298 m .67997 .46813 L .68739 .4827 L p
1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.66717 .47298 m .6544 .47494 L .64693 .47037 L p
1 .598 0 r
F P
0 0 0 r
s
P
p
.002 w
.63417 .47235 m .64693 .47037 L .6544 .47494 L p
1 .598 0 r
F P
0 0 0 r
s
P
p
.002 w
.80424 .43593 m .81722 .42381 L .82333 .42875 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.22028 .48047 m .20905 .48241 L .19798 .4779 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.18677 .47985 m .19798 .4779 L .20905 .48241 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.36779 .18976 m .38933 .19365 L .37751 .19658 L 1 .698 0 r
F
P
p
.356 .19271 m .36779 .18976 L .37751 .19658 L 1 .698 0 r
F
P
p
.002 w
.33199 .48039 m .32037 .48233 L .3102 .47781 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.2986 .47977 m .3102 .47781 L .32037 .48233 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.48005 .18964 m .50107 .19353 L .48887 .19646 L 1 .698 0 r
F
P
p
.46787 .19259 m .48005 .18964 L .48887 .19646 L 1 .698 0 r
F
P
p
.002 w
.44373 .48031 m .43173 .48225 L .42245 .47773 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41046 .47969 m .42245 .47773 L .43173 .48225 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.59234 .18951 m .61285 .19341 L .60026 .19634 L 1 .698 0 r
F
P
p
.57976 .19247 m .59234 .18951 L .60026 .19634 L 1 .698 0 r
F
P
p
.002 w
.5555 .48023 m .54311 .48217 L .53473 .47765 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52235 .47961 m .53473 .47765 L .54311 .48217 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70466 .18939 m .72466 .19329 L .71168 .19622 L 1 .174 0 r
F
P
p
.69169 .19235 m .70466 .18939 L .71168 .19622 L 1 .349 0 r
F
P
p
.002 w
.74586 .4669 m .73296 .47424 L .72611 .46966 L p
1 .579 0 r
F P
0 0 0 r
s
P
p
.002 w
.71306 .47164 m .72611 .46966 L .73296 .47424 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.18677 .47985 m .17565 .48179 L .16429 .47727 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.15319 .47923 m .16429 .47727 L .17565 .48179 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.63417 .47235 m .62154 .47762 L .61383 .47694 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.60116 .4789 m .61383 .47694 L .62154 .47762 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.33429 .18881 m .356 .19271 L .34429 .19565 L 1 .349 0 r
F
P
p
.3226 .19177 m .33429 .18881 L .34429 .19565 L 1 .349 0 r
F
P
p
.002 w
.2986 .47977 m .28708 .48171 L .27663 .47719 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.26513 .47915 m .27663 .47719 L .28708 .48171 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44667 .18869 m .46787 .19259 L .45576 .19552 L 1 .698 0 r
F
P
p
.43458 .19165 m .44667 .18869 L .45576 .19552 L 1 .698 0 r
F
P
p
.002 w
.41046 .47969 m .39855 .48163 L .389 .47711 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37711 .47906 m .389 .47711 L .39855 .48163 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.79133 .44801 m .77846 .46003 L .77203 .45692 L p
1 .319 0 r
F P
0 0 0 r
s
P
p
.002 w
.75881 .45895 m .77203 .45692 L .77846 .46003 L p
1 .43 0 r
F P
0 0 0 r
s
P
p
.55908 .18857 m .57976 .19247 L .56727 .1954 L 1 .698 0 r
F
P
p
.5466 .19153 m .55908 .18857 L .56727 .1954 L 1 .698 0 r
F
P
p
.002 w
.52235 .47961 m .51006 .48155 L .5014 .47702 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48912 .47898 m .5014 .47702 L .51006 .48155 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67152 .18844 m .69169 .19235 L .67881 .19528 L 1 .279 0 r
F
P
p
.65865 .1914 m .67152 .18844 L .67881 .19528 L 1 .429 0 r
F
P
p
.77073 .19128 m .78399 .18832 L .79039 .19516 L 1 0 0 r
F
P
p
.002 w
.71306 .47164 m .7001 .47361 L .69247 .44603 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.002 w
.67997 .46813 m .69247 .44603 L .7001 .47361 L p
1 .533 0 r
F P
0 0 0 r
s
P
p
.30071 .18786 m .3226 .19177 L .31099 .19471 L 1 .035 0 r
F
P
p
.28912 .19083 m .30071 .18786 L .31099 .19471 L 1 .105 0 r
F
P
p
.002 w
.26513 .47915 m .25372 .48109 L .24298 .47656 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23159 .47852 m .24298 .47656 L .25372 .48109 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.41321 .18774 m .43458 .19165 L .42258 .19459 L 1 .698 0 r
F
P
p
.40123 .19071 m .41321 .18774 L .42258 .19459 L 1 .698 0 r
F
P
p
.002 w
.37711 .47906 m .36531 .48101 L .35547 .47648 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34369 .47844 m .35547 .47648 L .36531 .48101 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52574 .18761 m .5466 .19153 L .53421 .19447 L 1 .673 0 r
F
P
p
.51336 .19058 m .52574 .18761 L .53421 .19447 L 1 .698 0 r
F
P
p
.002 w
.48912 .47898 m .47693 .48093 L .46799 .4764 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45582 .47836 m .46799 .4764 L .47693 .48093 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6383 .18749 m .65865 .1914 L .64587 .19435 L 1 .558 0 r
F
P
p
.62553 .19046 m .6383 .18749 L .64587 .19435 L 1 .614 0 r
F
P
p
.002 w
.60116 .4789 m .58858 .48085 L .58055 .47631 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56798 .47828 m .58055 .47631 L .58858 .48085 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.7509 .18737 m .77073 .19128 L .75756 .19423 L 1 0 0 r
F
P
p
.73774 .19034 m .7509 .18737 L .75756 .19423 L 1 .07 0 r
F
P
p
.002 w
.67997 .46813 m .66717 .47298 L .65978 .46838 L p
1 .578 0 r
F P
0 0 0 r
s
P
p
.002 w
.64693 .47037 m .65978 .46838 L .66717 .47298 L p
1 .598 0 r
F P
0 0 0 r
s
P
p
.002 w
.23159 .47852 m .22028 .48047 L .20926 .47593 L p
1 .62 0 r
F P
0 0 0 r
s
P
p
.002 w
.19798 .4779 m .20926 .47593 L .22028 .48047 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.80424 .43593 m .79133 .44801 L .78458 .43315 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.77203 .45692 m .78458 .43315 L .79133 .44801 L p
1 .319 0 r
F P
0 0 0 r
s
P
p
.002 w
.75881 .45895 m .74586 .4669 L .73925 .46766 L p
1 .53 0 r
F P
0 0 0 r
s
P
p
.002 w
.72611 .46966 m .73925 .46766 L .74586 .4669 L p
1 .579 0 r
F P
0 0 0 r
s
P
p
.37967 .18679 m .40123 .19071 L .38933 .19365 L 1 .698 0 r
F
P
p
.36779 .18976 m .37967 .18679 L .38933 .19365 L 1 .698 0 r
F
P
p
.002 w
.34369 .47844 m .33199 .48039 L .32187 .47585 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3102 .47781 m .32187 .47585 L .33199 .48039 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.49232 .18666 m .51336 .19058 L .50107 .19353 L 1 .698 0 r
F
P
p
.48005 .18964 m .49232 .18666 L .50107 .19353 L 1 .698 0 r
F
P
p
.002 w
.45582 .47836 m .44373 .48031 L .43452 .47577 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42245 .47773 m .43452 .47577 L .44373 .48031 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60501 .18654 m .62553 .19046 L .61285 .19341 L 1 .698 0 r
F
P
p
.59234 .18951 m .60501 .18654 L .61285 .19341 L 1 .698 0 r
F
P
p
.002 w
.56798 .47828 m .5555 .48023 L .54719 .47568 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53473 .47765 m .54719 .47568 L .5555 .48023 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71773 .18641 m .73774 .19034 L .72466 .19329 L 1 .035 0 r
F
P
p
.70466 .18939 m .71773 .18641 L .72466 .19329 L 1 .174 0 r
F
P
p
.002 w
.64693 .47037 m .63417 .47235 L .62659 .47497 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.002 w
.61383 .47694 m .62659 .47497 L .63417 .47235 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.19798 .4779 m .18677 .47985 L .17547 .4753 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.16429 .47727 m .17547 .4753 L .18677 .47985 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.34606 .18583 m .36779 .18976 L .356 .19271 L 1 .349 0 r
F
P
p
.33429 .18881 m .34606 .18583 L .356 .19271 L 1 .349 0 r
F
P
p
.002 w
.3102 .47781 m .2986 .47977 L .2882 .47522 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27663 .47719 m .2882 .47522 L .2986 .47977 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.45884 .18571 m .48005 .18964 L .46787 .19259 L 1 .698 0 r
F
P
p
.44667 .18869 m .45884 .18571 L .46787 .19259 L 1 .698 0 r
F
P
p
.002 w
.42245 .47773 m .41046 .47969 L .40096 .47513 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.389 .47711 m .40096 .47513 L .41046 .47969 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57164 .18558 m .59234 .18951 L .57976 .19247 L 1 .663 0 r
F
P
p
.55908 .18857 m .57164 .18558 L .57976 .19247 L 1 .698 0 r
F
P
p
.002 w
.53473 .47765 m .52235 .47961 L .51376 .47505 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5014 .47702 m .51376 .47505 L .52235 .47961 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68448 .18546 m .70466 .18939 L .69169 .19235 L 1 .209 0 r
F
P
p
.67152 .18844 m .68448 .18546 L .69169 .19235 L 1 .279 0 r
F
P
p
.002 w
.72611 .46966 m .71306 .47164 L .70547 .44396 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.002 w
.69247 .44603 m .70547 .44396 L .71306 .47164 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.002 w
.81722 .42381 m .80424 .43593 L .79757 .42096 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.78458 .43315 m .79757 .42096 L .80424 .43593 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.31238 .18487 m .33429 .18881 L .3226 .19177 L 1 0 0 r
F
P
p
.30071 .18786 m .31238 .18487 L .3226 .19177 L 1 .035 0 r
F
P
p
.002 w
.27663 .47719 m .26513 .47915 L .25445 .47458 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24298 .47656 m .25445 .47458 L .26513 .47915 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.42527 .18475 m .44667 .18869 L .43458 .19165 L 1 .698 0 r
F
P
p
.41321 .18774 m .42527 .18475 L .43458 .19165 L 1 .698 0 r
F
P
p
.002 w
.389 .47711 m .37711 .47906 L .36733 .4745 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35547 .47648 m .36733 .4745 L .37711 .47906 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.5382 .18463 m .55908 .18857 L .5466 .19153 L 1 .638 0 r
F
P
p
.52574 .18761 m .5382 .18463 L .5466 .19153 L 1 .673 0 r
F
P
p
.002 w
.5014 .47702 m .48912 .47898 L .48025 .47442 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46799 .4764 m .48025 .47442 L .48912 .47898 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69247 .44603 m .67997 .46813 L .67266 .46348 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.65978 .46838 m .67266 .46348 L .67997 .46813 L p
1 .578 0 r
F P
0 0 0 r
s
P
p
.002 w
.77203 .45692 m .75881 .45895 L .75239 .46275 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.002 w
.73925 .46766 m .75239 .46275 L .75881 .45895 L p
1 .53 0 r
F P
0 0 0 r
s
P
p
.65116 .1845 m .67152 .18844 L .65865 .1914 L 1 .523 0 r
F
P
p
.6383 .18749 m .65116 .1845 L .65865 .1914 L 1 .558 0 r
F
P
p
.002 w
.61383 .47694 m .60116 .4789 L .5932 .47434 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58055 .47631 m .5932 .47434 L .60116 .4789 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.76415 .18438 m .78399 .18832 L .77073 .19128 L 1 0 0 r
F
P
p
.7509 .18737 m .76415 .18438 L .77073 .19128 L 1 0 0 r
F
P
p
.002 w
.70547 .44396 m .69247 .44603 L .68568 .46145 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.67266 .46348 m .68568 .46145 L .69247 .44603 L p
1 .488 0 r
F P
0 0 0 r
s
P
p
.002 w
.24298 .47656 m .23159 .47852 L .22161 .45138 L p
1 .492 0 r
F P
0 0 0 r
s
P
p
.002 w
.20926 .47593 m .22161 .45138 L .23159 .47852 L p
1 .62 0 r
F P
0 0 0 r
s
P
p
.39163 .18379 m .41321 .18774 L .40123 .19071 L 1 .698 0 r
F
P
p
.37967 .18679 m .39163 .18379 L .40123 .19071 L 1 .698 0 r
F
P
p
.002 w
.35547 .47648 m .34369 .47844 L .33363 .47387 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32187 .47585 m .33363 .47387 L .34369 .47844 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.50468 .18367 m .52574 .18761 L .51336 .19058 L 1 .698 0 r
F
P
p
.49232 .18666 m .50468 .18367 L .51336 .19058 L 1 .698 0 r
F
P
p
.002 w
.46799 .4764 m .45582 .47836 L .44667 .47378 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43452 .47577 m .44667 .47378 L .45582 .47836 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.61776 .18354 m .6383 .18749 L .62553 .19046 L 1 .684 0 r
F
P
p
.60501 .18654 m .61776 .18354 L .62553 .19046 L 1 .698 0 r
F
P
p
.002 w
.58055 .47631 m .56798 .47828 L .55974 .4737 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54719 .47568 m .55974 .4737 L .56798 .47828 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73088 .18342 m .7509 .18737 L .73774 .19034 L 1 0 0 r
F
P
p
.71773 .18641 m .73088 .18342 L .73774 .19034 L 1 .035 0 r
F
P
p
.002 w
.65978 .46838 m .64693 .47037 L .63938 .46908 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.62659 .47497 m .63938 .46908 L .64693 .47037 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.002 w
.79757 .42096 m .811 .41879 L .81722 .42381 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.20926 .47593 m .19798 .4779 L .18672 .47331 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.17547 .4753 m .18672 .47331 L .19798 .4779 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.35792 .18283 m .37967 .18679 L .36779 .18976 L 1 .349 0 r
F
P
p
.34606 .18583 m .35792 .18283 L .36779 .18976 L 1 .349 0 r
F
P
p
.002 w
.32187 .47585 m .3102 .47781 L .29985 .47323 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.2882 .47522 m .29985 .47323 L .3102 .47781 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.47109 .1827 m .49232 .18666 L .48005 .18964 L 1 .698 0 r
F
P
p
.45884 .18571 m .47109 .1827 L .48005 .18964 L 1 .698 0 r
F
P
p
.002 w
.43452 .47577 m .42245 .47773 L .41301 .47315 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40096 .47513 m .41301 .47315 L .42245 .47773 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.58429 .18258 m .60501 .18654 L .59234 .18951 L 1 .558 0 r
F
P
p
.57164 .18558 m .58429 .18258 L .59234 .18951 L 1 .663 0 r
F
P
p
.002 w
.54719 .47568 m .53473 .47765 L .52621 .47306 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51376 .47505 m .52621 .47306 L .53473 .47765 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69753 .18245 m .71773 .18641 L .70466 .18939 L 1 .14 0 r
F
P
p
.68448 .18546 m .69753 .18245 L .70466 .18939 L 1 .209 0 r
F
P
p
.002 w
.73925 .46766 m .72611 .46966 L .71855 .44187 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.002 w
.70547 .44396 m .71855 .44187 L .72611 .46966 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.32413 .18187 m .34606 .18583 L .33429 .18881 L 1 0 0 r
F
P
p
.31238 .18487 m .32413 .18187 L .33429 .18881 L 1 0 0 r
F
P
p
.002 w
.2882 .47522 m .27663 .47719 L .266 .47259 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.25445 .47458 m .266 .47259 L .27663 .47719 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.43742 .18174 m .45884 .18571 L .44667 .18869 L 1 .698 0 r
F
P
p
.42527 .18475 m .43742 .18174 L .44667 .18869 L 1 .698 0 r
F
P
p
.002 w
.40096 .47513 m .389 .47711 L .37928 .47251 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36733 .4745 m .37928 .47251 L .389 .47711 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55075 .18162 m .57164 .18558 L .55908 .18857 L 1 .523 0 r
F
P
p
.5382 .18463 m .55075 .18162 L .55908 .18857 L 1 .638 0 r
F
P
p
.002 w
.51376 .47505 m .5014 .47702 L .4926 .47243 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48025 .47442 m .4926 .47243 L .5014 .47702 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.78458 .43315 m .77203 .45692 L .76552 .45491 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.75239 .46275 m .76552 .45491 L .77203 .45692 L p
1 .479 0 r
F P
0 0 0 r
s
P
p
.66411 .18149 m .68448 .18546 L .67152 .18844 L 1 .419 0 r
F
P
p
.65116 .1845 m .66411 .18149 L .67152 .18844 L 1 .523 0 r
F
P
p
.002 w
.62659 .47497 m .61383 .47694 L .60595 .47234 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.5932 .47434 m .60595 .47234 L .61383 .47694 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.76415 .18438 m .7775 .18137 L .78399 .18832 L 1 0 0 r
F
P
p
.002 w
.79757 .42096 m .78458 .43315 L .78193 .44095 L p
1 .18 0 r
F P
0 0 0 r
s
P
p
.78893 .43439 m .79757 .42096 L .78193 .44095 L 1 .18 0 r
F
P
p
.002 w
.78193 .44095 m .77883 .45009 L p
.78893 .43439 L 1 .18 0 r
F P
0 0 0 r
s
P
p
.002 w
.77883 .45009 m .79153 .42603 L .79757 .42096 L p
1 .18 0 r
F P
0 0 0 r
s
P
p
.002 w
.811 .41879 m .79757 .42096 L .79153 .42603 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.79153 .42603 m .80469 .41369 L .80809 .41643 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.80809 .41643 m .811 .41879 L p
.80201 .42213 L 1 .035 0 r
F P
0 0 0 r
s
P
p
.79153 .42603 m .80809 .41643 L .80201 .42213 L 1 .035 0 r
F
P
p
.002 w
.76552 .45491 m .77883 .45009 L .78458 .43315 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.69856 .44923 m .70547 .44396 L p
.69561 .45267 L 1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.68568 .46145 m .69856 .44923 L p
.69561 .45267 L 1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.69856 .44923 m .69129 .44436 L p
.70154 .44575 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.71855 .44187 m .70547 .44396 L .69856 .44923 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.69856 .44923 m .71174 .44714 L .71855 .44187 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.71174 .44714 m .69856 .44923 L p
.70154 .44575 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.25445 .47458 m .24298 .47656 L .23362 .43482 L p
1 .43 0 r
F P
0 0 0 r
s
P
p
.002 w
.22161 .45138 m .23362 .43482 L .24298 .47656 L p
1 .492 0 r
F P
0 0 0 r
s
P
p
.40368 .18077 m .42527 .18475 L .41321 .18774 L 1 .698 0 r
F
P
p
.39163 .18379 m .40368 .18077 L .41321 .18774 L 1 .698 0 r
F
P
p
.002 w
.36733 .4745 m .35547 .47648 L .34547 .47187 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33363 .47387 m .34547 .47187 L .35547 .47648 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.51713 .18065 m .5382 .18463 L .52574 .18761 L 1 .673 0 r
F
P
p
.50468 .18367 m .51713 .18065 L .52574 .18761 L 1 .698 0 r
F
P
p
.002 w
.48025 .47442 m .46799 .4764 L .45891 .47179 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44667 .47378 m .45891 .47179 L .46799 .4764 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.63061 .18052 m .65116 .1845 L .6383 .18749 L 1 .649 0 r
F
P
p
.61776 .18354 m .63061 .18052 L .6383 .18749 L 1 .684 0 r
F
P
p
.002 w
.5932 .47434 m .58055 .47631 L .57239 .4717 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55974 .4737 m .57239 .4717 L .58055 .47631 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.74412 .1804 m .76415 .18438 L .7509 .18737 L 1 0 0 r
F
P
p
.73088 .18342 m .74412 .1804 L .7509 .18737 L 1 0 0 r
F
P
p
.002 w
.67266 .46348 m .65978 .46838 L .65226 .46371 L p
1 .588 0 r
F P
0 0 0 r
s
P
p
.002 w
.63938 .46908 m .65226 .46371 L .65978 .46838 L p
1 .61 0 r
F P
0 0 0 r
s
P
p
.002 w
.22161 .45138 m .20926 .47593 L .19806 .47131 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.002 w
.18672 .47331 m .19806 .47131 L .20926 .47593 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.36986 .17981 m .39163 .18379 L .37967 .18679 L 1 .349 0 r
F
P
p
.35792 .18283 m .36986 .17981 L .37967 .18679 L 1 .349 0 r
F
P
p
.002 w
.33363 .47387 m .32187 .47585 L .31159 .47123 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.29985 .47323 m .31159 .47123 L .32187 .47585 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.48343 .17968 m .50468 .18367 L .49232 .18666 L 1 .698 0 r
F
P
p
.47109 .1827 m .48343 .17968 L .49232 .18666 L 1 .698 0 r
F
P
p
.002 w
.44667 .47378 m .43452 .47577 L .42515 .47115 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41301 .47315 m .42515 .47115 L .43452 .47577 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23362 .43482 m .22161 .45138 L .2105 .44657 L p
1 .286 0 r
F P
0 0 0 r
s
P
p
.002 w
.19806 .47131 m .2105 .44657 L .22161 .45138 L p
1 .542 0 r
F P
0 0 0 r
s
P
p
.59704 .17956 m .61776 .18354 L .60501 .18654 L 1 .453 0 r
F
P
p
.58429 .18258 m .59704 .17956 L .60501 .18654 L 1 .558 0 r
F
P
p
.002 w
.55974 .4737 m .54719 .47568 L .53875 .47106 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52621 .47306 m .53875 .47106 L .54719 .47568 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71067 .17943 m .73088 .18342 L .71773 .18641 L 1 .035 0 r
F
P
p
.69753 .18245 m .71067 .17943 L .71773 .18641 L 1 .14 0 r
F
P
p
.002 w
.75239 .46275 m .73925 .46766 L .73173 .43976 L p
1 .394 0 r
F P
0 0 0 r
s
P
p
.002 w
.71855 .44187 m .73173 .43976 L .73925 .46766 L p
1 .439 0 r
F P
0 0 0 r
s
P
p
.33597 .17884 m .35792 .18283 L .34606 .18583 L 1 0 0 r
F
P
p
.32413 .18187 m .33597 .17884 L .34606 .18583 L 1 0 0 r
F
P
p
.002 w
.29985 .47323 m .2882 .47522 L .27763 .47059 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.266 .47259 m .27763 .47059 L .2882 .47522 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.44966 .17871 m .47109 .1827 L .45884 .18571 L 1 .698 0 r
F
P
p
.43742 .18174 m .44966 .17871 L .45884 .18571 L 1 .698 0 r
F
P
p
.002 w
.41301 .47315 m .40096 .47513 L .39131 .47051 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37928 .47251 m .39131 .47051 L .40096 .47513 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.56339 .17858 m .58429 .18258 L .57164 .18558 L 1 .349 0 r
F
P
p
.55075 .18162 m .56339 .17858 L .57164 .18558 L 1 .523 0 r
F
P
p
.002 w
.52621 .47306 m .51376 .47505 L .50503 .47042 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4926 .47243 m .50503 .47042 L .51376 .47505 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67715 .17846 m .69753 .18245 L .68448 .18546 L 1 .349 0 r
F
P
p
.66411 .18149 m .67715 .17846 L .68448 .18546 L 1 .419 0 r
F
P
p
.002 w
.63938 .46908 m .62659 .47497 L .61878 .47034 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.60595 .47234 m .61878 .47034 L .62659 .47497 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.23362 .43482 m .24523 .42932 L .25445 .47458 L p
1 .43 0 r
F P
0 0 0 r
s
P
p
.002 w
.24523 .42932 m .23362 .43482 L .2226 .42986 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.2105 .44657 m .2226 .42986 L .23362 .43482 L p
1 .286 0 r
F P
0 0 0 r
s
P
p
.002 w
.73173 .43976 m .71855 .44187 L .71174 .44714 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.266 .47259 m .25445 .47458 L .24523 .42932 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.41581 .17774 m .43742 .18174 L .42527 .18475 L 1 .62 0 r
F
P
p
.40368 .18077 m .41581 .17774 L .42527 .18475 L 1 .698 0 r
F
P
p
.002 w
.37928 .47251 m .36733 .4745 L .3574 .46986 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34547 .47187 m .3574 .46986 L .36733 .4745 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52966 .17761 m .55075 .18162 L .5382 .18463 L 1 .638 0 r
F
P
p
.51713 .18065 m .52966 .17761 L .5382 .18463 L 1 .673 0 r
F
P
p
.002 w
.4926 .47243 m .48025 .47442 L .47124 .46978 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45891 .47179 m .47124 .46978 L .48025 .47442 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.68568 .46145 m .67266 .46348 L .66527 .46167 L p
1 .533 0 r
F P
0 0 0 r
s
P
p
.002 w
.65226 .46371 m .66527 .46167 L .67266 .46348 L p
1 .588 0 r
F P
0 0 0 r
s
P
p
.64354 .17749 m .66411 .18149 L .65116 .1845 L 1 .593 0 r
F
P
p
.63061 .18052 m .64354 .17749 L .65116 .1845 L 1 .649 0 r
F
P
p
.002 w
.60595 .47234 m .5932 .47434 L .58512 .46969 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57239 .4717 m .58512 .46969 L .5932 .47434 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75746 .17736 m .7775 .18137 L .76415 .18438 L 1 0 0 r
F
P
p
.74412 .1804 m .75746 .17736 L .76415 .18438 L 1 0 0 r
F
P
p
.38189 .17676 m .40368 .18077 L .39163 .18379 L 1 .349 0 r
F
P
p
.36986 .17981 m .38189 .17676 L .39163 .18379 L 1 .349 0 r
F
P
p
.002 w
.34547 .47187 m .33363 .47387 L .32341 .46922 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.31159 .47123 m .32341 .46922 L .33363 .47387 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.49586 .17664 m .51713 .18065 L .50468 .18367 L 1 .698 0 r
F
P
p
.48343 .17968 m .49586 .17664 L .50468 .18367 L 1 .698 0 r
F
P
p
.002 w
.45891 .47179 m .44667 .47378 L .43737 .46913 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42515 .47115 m .43737 .46913 L .44667 .47378 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60987 .17651 m .63061 .18052 L .61776 .18354 L 1 .37 0 r
F
P
p
.59704 .17956 m .60987 .17651 L .61776 .18354 L 1 .453 0 r
F
P
p
.002 w
.57239 .4717 m .55974 .4737 L .55137 .46905 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53875 .47106 m .55137 .46905 L .55974 .4737 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.76552 .45491 m .75239 .46275 L .7447 .4275 L p
1 .329 0 r
F P
0 0 0 r
s
P
p
.002 w
.73173 .43976 m .7447 .4275 L .75239 .46275 L p
1 .394 0 r
F P
0 0 0 r
s
P
p
.72391 .17638 m .74412 .1804 L .73088 .18342 L 1 0 0 r
F
P
p
.71067 .17943 m .72391 .17638 L .73088 .18342 L 1 .035 0 r
F
P
p
.002 w
.65226 .46371 m .63938 .46908 L .63171 .46832 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.61878 .47034 m .63171 .46832 L .63938 .46908 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.34788 .17579 m .36986 .17981 L .35792 .18283 L 1 0 0 r
F
P
p
.33597 .17884 m .34788 .17579 L .35792 .18283 L 1 0 0 r
F
P
p
.002 w
.31159 .47123 m .29985 .47323 L .28934 .46857 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.27763 .47059 m .28934 .46857 L .29985 .47323 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.24523 .42932 m .25677 .42717 L .266 .47259 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.25677 .42717 m .24523 .42932 L .23427 .4243 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.2226 .42986 m .23427 .4243 L .24523 .42932 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.46198 .17566 m .48343 .17968 L .47109 .1827 L 1 .698 0 r
F
P
p
.44966 .17871 m .46198 .17566 L .47109 .1827 L 1 .698 0 r
F
P
p
.002 w
.42515 .47115 m .41301 .47315 L .40343 .46849 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39131 .47051 m .40343 .46849 L .41301 .47315 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57611 .17553 m .59704 .17956 L .58429 .18258 L 1 .209 0 r
F
P
p
.56339 .17858 m .57611 .17553 L .58429 .18258 L 1 .349 0 r
F
P
p
.002 w
.53875 .47106 m .52621 .47306 L .51755 .4684 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50503 .47042 m .51755 .4684 L .52621 .47306 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69028 .1754 m .71067 .17943 L .69753 .18245 L 1 .335 0 r
F
P
p
.67715 .17846 m .69028 .1754 L .69753 .18245 L 1 .349 0 r
F
P
p
.002 w
.7447 .4275 m .73173 .43976 L .72475 .43482 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.71174 .44714 m .72475 .43482 L .73173 .43976 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.27763 .47059 m .266 .47259 L .25677 .42717 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.42803 .17468 m .44966 .17871 L .43742 .18174 L 1 .48 0 r
F
P
p
.41581 .17774 m .42803 .17468 L .43742 .18174 L 1 .62 0 r
F
P
p
.002 w
.39131 .47051 m .37928 .47251 L .36941 .46784 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3574 .46986 m .36941 .46784 L .37928 .47251 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.54228 .17455 m .56339 .17858 L .55075 .18162 L 1 .523 0 r
F
P
p
.52966 .17761 m .54228 .17455 L .55075 .18162 L 1 .638 0 r
F
P
p
.002 w
.50503 .47042 m .4926 .47243 L .48365 .46775 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47124 .46978 m .48365 .46775 L .4926 .47243 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.69856 .44923 m .68568 .46145 L .67812 .44647 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.66527 .46167 m .67812 .44647 L .68568 .46145 L p
1 .533 0 r
F P
0 0 0 r
s
P
p
.65657 .17442 m .67715 .17846 L .66411 .18149 L 1 .558 0 r
F
P
p
.64354 .17749 m .65657 .17442 L .66411 .18149 L 1 .593 0 r
F
P
p
.002 w
.61878 .47034 m .60595 .47234 L .59794 .46767 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58512 .46969 m .59794 .46767 L .60595 .47234 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75746 .17736 m .77089 .1743 L .7775 .18137 L 1 0 0 r
F
P
p
.002 w
.77883 .45009 m .76552 .45491 L .75805 .42534 L p
1 .265 0 r
F P
0 0 0 r
s
P
p
.002 w
.7447 .4275 m .75805 .42534 L p
.74941 .4337 L 1 .329 0 r
F P
0 0 0 r
s
P
p
.002 w
.75805 .42534 m .7447 .4275 L .73811 .43267 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.73811 .43267 m .75156 .4305 L .75805 .42534 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.75805 .42534 m .75156 .4305 L p
.76675 .41691 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.77115 .41298 m .75805 .42534 L p
.76675 .41691 L 1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.75805 .42534 m .76552 .45491 L p
.74941 .4337 L 1 .329 0 r
F P
0 0 0 r
s
P
p
.394 .1737 m .41581 .17774 L .40368 .18077 L 1 .349 0 r
F
P
p
.38189 .17676 m .394 .1737 L .40368 .18077 L 1 .349 0 r
F
P
p
.002 w
.3574 .46986 m .34547 .47187 L .33531 .46719 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32341 .46922 m .33531 .46719 L .34547 .47187 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.50838 .17357 m .52966 .17761 L .51713 .18065 L 1 .698 0 r
F
P
p
.49586 .17664 m .50838 .17357 L .51713 .18065 L 1 .698 0 r
F
P
p
.002 w
.47124 .46978 m .45891 .47179 L .44968 .4671 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43737 .46913 m .44968 .4671 L .45891 .47179 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62279 .17344 m .64354 .17749 L .63061 .18052 L 1 .301 0 r
F
P
p
.60987 .17651 m .62279 .17344 L .63061 .18052 L 1 .37 0 r
F
P
p
.002 w
.58512 .46969 m .57239 .4717 L .56409 .46702 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55137 .46905 m .56409 .46702 L .57239 .4717 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73724 .17331 m .75746 .17736 L .74412 .1804 L 1 0 0 r
F
P
p
.72391 .17638 m .73724 .17331 L .74412 .1804 L 1 0 0 r
F
P
p
.002 w
.66527 .46167 m .65226 .46371 L .64472 .46628 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.002 w
.63171 .46832 m .64472 .46628 L .65226 .46371 L p
1 .659 0 r
F P
0 0 0 r
s
P
p
.002 w
.72475 .43482 m .73811 .43267 L .7447 .4275 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.35989 .17271 m .38189 .17676 L .36986 .17981 L 1 0 0 r
F
P
p
.34788 .17579 m .35989 .17271 L .36986 .17981 L 1 0 0 r
F
P
p
.002 w
.32341 .46922 m .31159 .47123 L .30113 .46654 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.28934 .46857 m .30113 .46654 L .31159 .47123 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.67812 .44647 m .69129 .44436 L .69856 .44923 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.25677 .42717 m .2684 .425 L .27763 .47059 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.2684 .425 m .25677 .42717 L .24587 .42211 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.23427 .4243 m .24587 .42211 L .25677 .42717 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.47439 .17259 m .49586 .17664 L .48343 .17968 L 1 .698 0 r
F
P
p
.46198 .17566 m .47439 .17259 L .48343 .17968 L 1 .698 0 r
F
P
p
.002 w
.43737 .46913 m .42515 .47115 L .41563 .46645 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40343 .46849 m .41563 .46645 L .42515 .47115 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.58893 .17246 m .60987 .17651 L .59704 .17956 L 1 .105 0 r
F
P
p
.57611 .17553 m .58893 .17246 L .59704 .17956 L 1 .209 0 r
F
P
p
.002 w
.55137 .46905 m .53875 .47106 L .53016 .46637 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51755 .4684 m .53016 .46637 L .53875 .47106 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.7035 .17233 m .72391 .17638 L .71067 .17943 L 1 .161 0 r
F
P
p
.69028 .1754 m .7035 .17233 L .71067 .17943 L 1 .335 0 r
F
P
p
.002 w
.28934 .46857 m .27763 .47059 L .2684 .425 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.44033 .1716 m .46198 .17566 L .44966 .17871 L 1 .419 0 r
F
P
p
.42803 .17468 m .44033 .1716 L .44966 .17871 L 1 .48 0 r
F
P
p
.002 w
.40343 .46849 m .39131 .47051 L .3815 .4658 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36941 .46784 m .3815 .4658 L .39131 .47051 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55499 .17147 m .57611 .17553 L .56339 .17858 L 1 .384 0 r
F
P
p
.54228 .17455 m .55499 .17147 L .56339 .17858 L 1 .523 0 r
F
P
p
.002 w
.51755 .4684 m .50503 .47042 L .49616 .46572 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48365 .46775 m .49616 .46572 L .50503 .47042 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.79153 .42603 m .77883 .45009 L .77115 .41298 L p
1 .145 0 r
F P
0 0 0 r
s
P
p
.002 w
.75805 .42534 m .77115 .41298 L .77883 .45009 L p
1 .265 0 r
F P
0 0 0 r
s
P
p
.66969 .17134 m .69028 .1754 L .67715 .17846 L 1 .558 0 r
F
P
p
.65657 .17442 m .66969 .17134 L .67715 .17846 L 1 .558 0 r
F
P
p
.002 w
.63171 .46832 m .61878 .47034 L .61085 .46563 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59794 .46767 m .61085 .46563 L .61878 .47034 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.80469 .41369 m .79153 .42603 L .78466 .41074 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.77115 .41298 m .78466 .41074 L .79153 .42603 L p
1 .145 0 r
F P
0 0 0 r
s
P
p
.40619 .17061 m .42803 .17468 L .41581 .17774 L 1 .271 0 r
F
P
p
.394 .1737 m .40619 .17061 L .41581 .17774 L 1 .349 0 r
F
P
p
.002 w
.36941 .46784 m .3574 .46986 L .3473 .46515 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33531 .46719 m .3473 .46515 L .3574 .46986 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52098 .17048 m .54228 .17455 L .52966 .17761 L 1 .698 0 r
F
P
p
.50838 .17357 m .52098 .17048 L .52966 .17761 L 1 .698 0 r
F
P
p
.002 w
.48365 .46775 m .47124 .46978 L .46208 .46506 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44968 .4671 m .46208 .46506 L .47124 .46978 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6358 .17035 m .65657 .17442 L .64354 .17749 L 1 .244 0 r
F
P
p
.62279 .17344 m .6358 .17035 L .64354 .17749 L 1 .301 0 r
F
P
p
.002 w
.59794 .46767 m .58512 .46969 L .57689 .46498 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56409 .46702 m .57689 .46498 L .58512 .46969 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75066 .17022 m .77089 .1743 L .75746 .17736 L 1 0 0 r
F
P
p
.73724 .17331 m .75066 .17022 L .75746 .17736 L 1 0 0 r
F
P
p
.002 w
.67812 .44647 m .66527 .46167 L .65777 .46027 L p
1 .565 0 r
F P
0 0 0 r
s
P
p
.002 w
.64472 .46628 m .65777 .46027 L .66527 .46167 L p
1 .634 0 r
F P
0 0 0 r
s
P
p
.37198 .16962 m .394 .1737 L .38189 .17676 L 1 0 0 r
F
P
p
.35989 .17271 m .37198 .16962 L .38189 .17676 L 1 0 0 r
F
P
p
.002 w
.33531 .46719 m .32341 .46922 L .31301 .46449 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.30113 .46654 m .31301 .46449 L .32341 .46922 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72475 .43482 m .71174 .44714 L .70456 .44223 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.69129 .44436 m .70456 .44223 L .71174 .44714 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.2684 .425 m .28011 .42281 L .28934 .46857 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.28011 .42281 m .2684 .425 L .25755 .41991 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.24587 .42211 m .25755 .41991 L .2684 .425 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.48689 .16949 m .50838 .17357 L .49586 .17664 L 1 .698 0 r
F
P
p
.47439 .17259 m .48689 .16949 L .49586 .17664 L 1 .698 0 r
F
P
p
.002 w
.44968 .4671 m .43737 .46913 L .42792 .4644 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41563 .46645 m .42792 .4644 L .43737 .46913 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60184 .16936 m .62279 .17344 L .60987 .17651 L 1 .035 0 r
F
P
p
.58893 .17246 m .60184 .16936 L .60987 .17651 L 1 .105 0 r
F
P
p
.002 w
.56409 .46702 m .55137 .46905 L .54286 .46432 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53016 .46637 m .54286 .46432 L .55137 .46905 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.71682 .16923 m .73724 .17331 L .72391 .17638 L 1 0 0 r
F
P
p
.7035 .17233 m .71682 .16923 L .72391 .17638 L 1 .161 0 r
F
P
p
.002 w
.78466 .41074 m .79827 .4085 L .80469 .41369 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.30113 .46654 m .28934 .46857 L .28011 .42281 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.69129 .44436 m .67812 .44647 L .6709 .45479 L p
1 .463 0 r
F P
0 0 0 r
s
P
p
.002 w
.65777 .46027 m .6709 .45479 L .67812 .44647 L p
1 .565 0 r
F P
0 0 0 r
s
P
p
.45272 .1685 m .47439 .17259 L .46198 .17566 L 1 .419 0 r
F
P
p
.44033 .1716 m .45272 .1685 L .46198 .17566 L 1 .419 0 r
F
P
p
.002 w
.41563 .46645 m .40343 .46849 L .39368 .46375 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3815 .4658 m .39368 .46375 L .40343 .46849 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.5678 .16837 m .58893 .17246 L .57611 .17553 L 1 .349 0 r
F
P
p
.55499 .17147 m .5678 .16837 L .57611 .17553 L 1 .384 0 r
F
P
p
.002 w
.53016 .46637 m .51755 .4684 L .50875 .46366 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49616 .46572 m .50875 .46366 L .51755 .4684 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68291 .16824 m .7035 .17233 L .69028 .1754 L 1 .44 0 r
F
P
p
.66969 .17134 m .68291 .16824 L .69028 .1754 L 1 .558 0 r
F
P
p
.002 w
.64472 .46628 m .63171 .46832 L .62385 .46358 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.61085 .46563 m .62385 .46358 L .63171 .46832 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.78466 .41074 m .77115 .41298 L .76444 .40778 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75156 .4305 m .76444 .40778 L .77115 .41298 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.73811 .43267 m .72475 .43482 L .7174 .41954 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.70456 .44223 m .7174 .41954 L .72475 .43482 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.41848 .1675 m .44033 .1716 L .42803 .17468 L 1 .131 0 r
F
P
p
.40619 .17061 m .41848 .1675 L .42803 .17468 L 1 .271 0 r
F
P
p
.002 w
.3815 .4658 m .36941 .46784 L .35937 .46309 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3473 .46515 m .35937 .46309 L .36941 .46784 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53368 .16737 m .55499 .17147 L .54228 .17455 L 1 .698 0 r
F
P
p
.52098 .17048 m .53368 .16737 L .54228 .17455 L 1 .698 0 r
F
P
p
.002 w
.49616 .46572 m .48365 .46775 L .47456 .463 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46208 .46506 m .47456 .463 L .48365 .46775 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.64891 .16724 m .66969 .17134 L .65657 .17442 L 1 .209 0 r
F
P
p
.6358 .17035 m .64891 .16724 L .65657 .17442 L 1 .244 0 r
F
P
p
.002 w
.61085 .46563 m .59794 .46767 L .58979 .46292 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.57689 .46498 m .58979 .46292 L .59794 .46767 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.75066 .17022 m .76418 .16711 L .77089 .1743 L 1 0 0 r
F
P
p
.38415 .1665 m .40619 .17061 L .394 .1737 L 1 0 0 r
F
P
p
.37198 .16962 m .38415 .1665 L .394 .1737 L 1 0 0 r
F
P
p
.002 w
.3473 .46515 m .33531 .46719 L .32498 .46243 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.31301 .46449 m .32498 .46243 L .33531 .46719 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.28011 .42281 m .2919 .42061 L .30113 .46654 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.2919 .42061 m .28011 .42281 L .26932 .41769 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.25755 .41991 m .26932 .41769 L .28011 .42281 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.49948 .16637 m .52098 .17048 L .50838 .17357 L 1 .698 0 r
F
P
p
.48689 .16949 m .49948 .16637 L .50838 .17357 L 1 .698 0 r
F
P
p
.002 w
.46208 .46506 m .44968 .4671 L .4403 .46234 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42792 .4644 m .4403 .46234 L .44968 .4671 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.61484 .16624 m .6358 .17035 L .62279 .17344 L 1 0 0 r
F
P
p
.60184 .16936 m .61484 .16624 L .62279 .17344 L 1 .035 0 r
F
P
p
.002 w
.57689 .46498 m .56409 .46702 L .55565 .46226 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54286 .46432 m .55565 .46226 L .56409 .46702 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73024 .16611 m .75066 .17022 L .73724 .17331 L 1 0 0 r
F
P
p
.71682 .16923 m .73024 .16611 L .73724 .17331 L 1 0 0 r
F
P
p
.002 w
.31301 .46449 m .30113 .46654 L .2919 .42061 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.70456 .44223 m .69129 .44436 L .68391 .4394 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.6709 .45479 m .68391 .4394 L .69129 .44436 L p
1 .463 0 r
F P
0 0 0 r
s
P
p
.4652 .16537 m .48689 .16949 L .47439 .17259 L 1 .419 0 r
F
P
p
.45272 .1685 m .4652 .16537 L .47439 .17259 L 1 .419 0 r
F
P
p
.002 w
.42792 .4644 m .41563 .46645 L .40595 .46168 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39368 .46375 m .40595 .46168 L .41563 .46645 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.58069 .16524 m .60184 .16936 L .58893 .17246 L 1 .349 0 r
F
P
p
.5678 .16837 m .58069 .16524 L .58893 .17246 L 1 .349 0 r
F
P
p
.002 w
.54286 .46432 m .53016 .46637 L .52143 .46159 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50875 .46366 m .52143 .46159 L .53016 .46637 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69621 .16511 m .71682 .16923 L .7035 .17233 L 1 .161 0 r
F
P
p
.68291 .16824 m .69621 .16511 L .7035 .17233 L 1 .44 0 r
F
P
p
.002 w
.65777 .46027 m .64472 .46628 L .63689 .45753 L p
1 .601 0 r
F P
0 0 0 r
s
P
p
.002 w
.62385 .46358 m .63689 .45753 L .64472 .46628 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.79827 .4085 m .78466 .41074 L .77805 .40551 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .40778 m .77805 .40551 L .78466 .41074 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75156 .4305 m .73811 .43267 L .73054 .40705 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.7174 .41954 m .73054 .40705 L .73811 .43267 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.43085 .16437 m .45272 .1685 L .44033 .1716 L 1 .07 0 r
F
P
p
.41848 .1675 m .43085 .16437 L .44033 .1716 L 1 .131 0 r
F
P
p
.002 w
.39368 .46375 m .3815 .4658 L .37153 .46102 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.35937 .46309 m .37153 .46102 L .3815 .4658 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.54646 .16424 m .5678 .16837 L .55499 .17147 L 1 .698 0 r
F
P
p
.53368 .16737 m .54646 .16424 L .55499 .17147 L 1 .698 0 r
F
P
p
.002 w
.50875 .46366 m .49616 .46572 L .48714 .46093 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47456 .463 m .48714 .46093 L .49616 .46572 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66211 .16411 m .68291 .16824 L .66969 .17134 L 1 .209 0 r
F
P
p
.64891 .16724 m .66211 .16411 L .66969 .17134 L 1 .209 0 r
F
P
p
.002 w
.62385 .46358 m .61085 .46563 L .60278 .46084 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58979 .46292 m .60278 .46084 L .61085 .46563 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.39641 .16336 m .41848 .1675 L .40619 .17061 L 1 0 0 r
F
P
p
.38415 .1665 m .39641 .16336 L .40619 .17061 L 1 0 0 r
F
P
p
.002 w
.35937 .46309 m .3473 .46515 L .33703 .46035 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.32498 .46243 m .33703 .46035 L .3473 .46515 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.2919 .42061 m .30411 .40815 L .31301 .46449 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.30411 .40815 m .2919 .42061 L .28117 .41545 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.26932 .41769 m .28117 .41545 L .2919 .42061 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.51216 .16323 m .53368 .16737 L .52098 .17048 L 1 .698 0 r
F
P
p
.49948 .16637 m .51216 .16323 L .52098 .17048 L 1 .698 0 r
F
P
p
.002 w
.47456 .463 m .46208 .46506 L .45276 .46027 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4403 .46234 m .45276 .46027 L .46208 .46506 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62793 .1631 m .64891 .16724 L .6358 .17035 L 1 0 0 r
F
P
p
.61484 .16624 m .62793 .1631 L .6358 .17035 L 1 0 0 r
F
P
p
.002 w
.58979 .46292 m .57689 .46498 L .56853 .46018 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.55565 .46226 m .56853 .46018 L .57689 .46498 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.74375 .16297 m .76418 .16711 L .75066 .17022 L 1 0 0 r
F
P
p
.73024 .16611 m .74375 .16297 L .75066 .17022 L 1 0 0 r
F
P
p
.002 w
.6709 .45479 m .65777 .46027 L .64981 .43871 L p
1 .52 0 r
F P
0 0 0 r
s
P
p
.002 w
.63689 .45753 m .64981 .43871 L .65777 .46027 L p
1 .601 0 r
F P
0 0 0 r
s
P
p
.002 w
.32498 .46243 m .31301 .46449 L .30411 .40815 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.7174 .41954 m .70456 .44223 L .69726 .43724 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.68391 .4394 m .69726 .43724 L .70456 .44223 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.47777 .16222 m .49948 .16637 L .48689 .16949 L 1 .419 0 r
F
P
p
.4652 .16537 m .47777 .16222 L .48689 .16949 L 1 .419 0 r
F
P
p
.002 w
.4403 .46234 m .42792 .4644 L .41831 .4596 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40595 .46168 m .41831 .4596 L .42792 .4644 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.59368 .16209 m .61484 .16624 L .60184 .16936 L 1 .349 0 r
F
P
p
.58069 .16524 m .59368 .16209 L .60184 .16936 L 1 .349 0 r
F
P
p
.002 w
.55565 .46226 m .54286 .46432 L .53421 .45951 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52143 .46159 m .53421 .45951 L .54286 .46432 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70962 .16196 m .73024 .16611 L .71682 .16923 L 1 0 0 r
F
P
p
.69621 .16511 m .70962 .16196 L .71682 .16923 L 1 .161 0 r
F
P
p
.002 w
.77805 .40551 m .79175 .40322 L .79827 .4085 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73054 .40705 m .7174 .41954 L .71407 .42726 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.72067 .42099 m .73054 .40705 L .71407 .42726 L 1 .174 0 r
F
P
p
.002 w
.73054 .40705 m .74404 .40478 L .75156 .4305 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.71407 .42726 m .71071 .43506 L p
.72067 .42099 L 1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.71071 .43506 m .72371 .4121 L .73054 .40705 L p
1 .174 0 r
F P
0 0 0 r
s
P
p
.002 w
.74404 .40478 m .73054 .40705 L .72371 .4121 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.72371 .4121 m .73702 .39944 L .74054 .40212 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.74054 .40212 m .74404 .40478 L p
.7339 .40843 L 1 .035 0 r
F P
0 0 0 r
s
P
p
.72371 .4121 m .74054 .40212 L .7339 .40843 L 1 .035 0 r
F
P
p
.002 w
.69726 .43724 m .71071 .43506 L .7174 .41954 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .40778 m .75156 .4305 L .74404 .40478 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.30411 .40815 m .31605 .40588 L .32498 .46243 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.31605 .40588 m .30411 .40815 L .29311 .41319 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.28117 .41545 m .29311 .41319 L .30411 .40815 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.44331 .16121 m .4652 .16537 L .45272 .1685 L 1 .07 0 r
F
P
p
.43085 .16437 m .44331 .16121 L .45272 .1685 L 1 .07 0 r
F
P
p
.002 w
.40595 .46168 m .39368 .46375 L .38378 .45893 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.37153 .46102 m .38378 .45893 L .39368 .46375 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55934 .16108 m .58069 .16524 L .5678 .16837 L 1 .698 0 r
F
P
p
.54646 .16424 m .55934 .16108 L .5678 .16837 L 1 .698 0 r
F
P
p
.002 w
.52143 .46159 m .50875 .46366 L .4998 .45884 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48714 .46093 m .4998 .45884 L .50875 .46366 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.67541 .16095 m .69621 .16511 L .68291 .16824 L 1 .105 0 r
F
P
p
.66211 .16411 m .67541 .16095 L .68291 .16824 L 1 .209 0 r
F
P
p
.002 w
.63689 .45753 m .62385 .46358 L .61586 .45876 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.60278 .46084 m .61586 .45876 L .62385 .46358 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77805 .40551 m .76444 .40778 L .75763 .40249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74404 .40478 m .75763 .40249 L .76444 .40778 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.40876 .1602 m .43085 .16437 L .41848 .1675 L 1 0 0 r
F
P
p
.39641 .16336 m .40876 .1602 L .41848 .1675 L 1 0 0 r
F
P
p
.002 w
.37153 .46102 m .35937 .46309 L .34916 .45826 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.33703 .46035 m .34916 .45826 L .35937 .46309 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.52493 .16007 m .54646 .16424 L .53368 .16737 L 1 .698 0 r
F
P
p
.51216 .16323 m .52493 .16007 L .53368 .16737 L 1 .698 0 r
F
P
p
.002 w
.48714 .46093 m .47456 .463 L .46532 .45817 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45276 .46027 m .46532 .45817 L .47456 .463 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.64112 .15994 m .66211 .16411 L .64891 .16724 L 1 0 0 r
F
P
p
.62793 .1631 m .64112 .15994 L .64891 .16724 L 1 0 0 r
F
P
p
.002 w
.60278 .46084 m .58979 .46292 L .58151 .45809 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56853 .46018 m .58151 .45809 L .58979 .46292 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.74375 .16297 m .75736 .15981 L .76418 .16711 L 1 0 0 r
F
P
p
.002 w
.68391 .4394 m .6709 .45479 L .66305 .43655 L p
1 .429 0 r
F P
0 0 0 r
s
P
p
.002 w
.66305 .43655 m .6709 .45479 L p
.65474 .44247 L 1 .52 0 r
F P
0 0 0 r
s
P
p
.002 w
.67619 .42399 m .68391 .4394 L p
.66724 .43712 L 1 .429 0 r
F P
0 0 0 r
s
P
p
.002 w
.66305 .43655 m .67619 .42399 L p
.66724 .43712 L 1 .429 0 r
F P
0 0 0 r
s
P
p
.002 w
.69726 .43724 m .68391 .4394 L .67619 .42399 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.67619 .42399 m .68916 .40102 L .69726 .43724 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.67619 .42399 m .66915 .45025 L p
.68519 .41077 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.68916 .40102 m .67619 .42399 L p
.68519 .41077 L 1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.66305 .43655 m .65568 .4524 L p
.67144 .43057 L 1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.67619 .42399 m .66305 .43655 L p
.67144 .43057 L 1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.64981 .43871 m .66305 .43655 L p
.65474 .44247 L 1 .52 0 r
F P
0 0 0 r
s
P
p
.002 w
.33703 .46035 m .32498 .46243 L .31605 .40588 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.49043 .15905 m .51216 .16323 L .49948 .16637 L 1 .419 0 r
F
P
p
.47777 .16222 m .49043 .15905 L .49948 .16637 L 1 .419 0 r
F
P
p
.002 w
.45276 .46027 m .4403 .46234 L .43076 .4575 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.41831 .4596 m .43076 .4575 L .4403 .46234 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.60676 .15892 m .62793 .1631 L .61484 .16624 L 1 .279 0 r
F
P
p
.59368 .16209 m .60676 .15892 L .61484 .16624 L 1 .349 0 r
F
P
p
.002 w
.56853 .46018 m .55565 .46226 L .54707 .45741 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53421 .45951 m .54707 .45741 L .55565 .46226 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.72312 .15879 m .74375 .16297 L .73024 .16611 L 1 0 0 r
F
P
p
.70962 .16196 m .72312 .15879 L .73024 .16611 L 1 0 0 r
F
P
p
.002 w
.64981 .43871 m .63689 .45753 L .62904 .45665 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.61586 .45876 m .62904 .45665 L .63689 .45753 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.31605 .40588 m .32808 .4036 L .33703 .46035 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.32808 .4036 m .31605 .40588 L .30546 .40057 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.29311 .41319 m .30546 .40057 L .31605 .40588 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.45586 .15804 m .47777 .16222 L .4652 .16537 L 1 .07 0 r
F
P
p
.44331 .16121 m .45586 .15804 L .4652 .16537 L 1 .07 0 r
F
P
p
.002 w
.41831 .4596 m .40595 .46168 L .39611 .45683 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38378 .45893 m .39611 .45683 L .40595 .46168 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57231 .1579 m .59368 .16209 L .58069 .16524 L 1 .698 0 r
F
P
p
.55934 .16108 m .57231 .1579 L .58069 .16524 L 1 .698 0 r
F
P
p
.002 w
.53421 .45951 m .52143 .46159 L .51256 .45674 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4998 .45884 m .51256 .45674 L .52143 .46159 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6888 .15777 m .70962 .16196 L .69621 .16511 L 1 0 0 r
F
P
p
.67541 .16095 m .6888 .15777 L .69621 .16511 L 1 .105 0 r
F
P
p
.002 w
.79175 .40322 m .77805 .40551 L .77132 .40018 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75763 .40249 m .77132 .40018 L .77805 .40551 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66305 .43655 m .64981 .43871 L .64231 .45453 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.62904 .45665 m .64231 .45453 L .64981 .43871 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.4212 .15702 m .44331 .16121 L .43085 .16437 L 1 0 0 r
F
P
p
.40876 .1602 m .4212 .15702 L .43085 .16437 L 1 0 0 r
F
P
p
.002 w
.38378 .45893 m .37153 .46102 L .36139 .45615 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.34916 .45826 m .36139 .45615 L .37153 .46102 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.53779 .15688 m .55934 .16108 L .54646 .16424 L 1 .698 0 r
F
P
p
.52493 .16007 m .53779 .15688 L .54646 .16424 L 1 .698 0 r
F
P
p
.002 w
.4998 .45884 m .48714 .46093 L .47797 .45607 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46532 .45817 m .47797 .45607 L .48714 .46093 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.65441 .15675 m .67541 .16095 L .66211 .16411 L 1 0 0 r
F
P
p
.64112 .15994 m .65441 .15675 L .66211 .16411 L 1 0 0 r
F
P
p
.002 w
.61586 .45876 m .60278 .46084 L .59458 .45598 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.58151 .45809 m .59458 .45598 L .60278 .46084 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75763 .40249 m .74404 .40478 L .73702 .39944 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34916 .45826 m .33703 .46035 L .32808 .4036 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.50318 .15586 m .52493 .16007 L .51216 .16323 L 1 .384 0 r
F
P
p
.49043 .15905 m .50318 .15586 L .51216 .16323 L 1 .419 0 r
F
P
p
.002 w
.46532 .45817 m .45276 .46027 L .44329 .45539 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43076 .4575 m .44329 .45539 L .45276 .46027 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.61993 .15573 m .64112 .15994 L .62793 .1631 L 1 .14 0 r
F
P
p
.60676 .15892 m .61993 .15573 L .62793 .1631 L 1 .279 0 r
F
P
p
.002 w
.58151 .45809 m .56853 .46018 L .56003 .4553 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54707 .45741 m .56003 .4553 L .56853 .46018 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73672 .1556 m .75736 .15981 L .74375 .16297 L 1 0 0 r
F
P
p
.72312 .15879 m .73672 .1556 L .74375 .16297 L 1 0 0 r
F
P
p
.002 w
.32808 .4036 m .3402 .4013 L .34916 .45826 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.3402 .4013 m .32808 .4036 L .31756 .39824 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.30546 .40057 m .31756 .39824 L .32808 .4036 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71071 .43506 m .69726 .43724 L .68916 .40102 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.4685 .15484 m .49043 .15905 L .47777 .16222 L 1 .07 0 r
F
P
p
.45586 .15804 m .4685 .15484 L .47777 .16222 L 1 .07 0 r
F
P
p
.002 w
.43076 .4575 m .41831 .4596 L .40854 .45471 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.39611 .45683 m .40854 .45471 L .41831 .4596 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.58538 .1547 m .60676 .15892 L .59368 .16209 L 1 .673 0 r
F
P
p
.57231 .1579 m .58538 .1547 L .59368 .16209 L 1 .698 0 r
F
P
p
.002 w
.54707 .45741 m .53421 .45951 L .52541 .45462 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.51256 .45674 m .52541 .45462 L .53421 .45951 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70229 .15457 m .72312 .15879 L .70962 .16196 L 1 0 0 r
F
P
p
.6888 .15777 m .70229 .15457 L .70962 .16196 L 1 0 0 r
F
P
p
.002 w
.77132 .40018 m .78511 .39786 L .79175 .40322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64231 .45453 m .65568 .4524 L .66305 .43655 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.43373 .15381 m .45586 .15804 L .44331 .16121 L 1 0 0 r
F
P
p
.4212 .15702 m .43373 .15381 L .44331 .16121 L 1 0 0 r
F
P
p
.002 w
.39611 .45683 m .38378 .45893 L .3737 .45403 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.36139 .45615 m .3737 .45403 L .38378 .45893 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.55074 .15368 m .57231 .1579 L .55934 .16108 L 1 .593 0 r
F
P
p
.53779 .15688 m .55074 .15368 L .55934 .16108 L 1 .698 0 r
F
P
p
.002 w
.51256 .45674 m .4998 .45884 L .4907 .45394 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47797 .45607 m .4907 .45394 L .4998 .45884 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66779 .15354 m .6888 .15777 L .67541 .16095 L 1 0 0 r
F
P
p
.65441 .15675 m .66779 .15354 L .67541 .16095 L 1 0 0 r
F
P
p
.002 w
.62904 .45665 m .61586 .45876 L .60774 .45385 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.59458 .45598 m .60774 .45385 L .61586 .45876 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.77132 .40018 m .75763 .40249 L .7507 .39711 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73702 .39944 m .7507 .39711 L .75763 .40249 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36139 .45615 m .34916 .45826 L .3402 .4013 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.51603 .15265 m .53779 .15688 L .52493 .16007 L 1 .349 0 r
F
P
p
.50318 .15586 m .51603 .15265 L .52493 .16007 L 1 .384 0 r
F
P
p
.002 w
.47797 .45607 m .46532 .45817 L .45592 .45326 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44329 .45539 m .45592 .45326 L .46532 .45817 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6332 .15251 m .65441 .15675 L .64112 .15994 L 1 .07 0 r
F
P
p
.61993 .15573 m .6332 .15251 L .64112 .15994 L 1 .14 0 r
F
P
p
.002 w
.59458 .45598 m .58151 .45809 L .57309 .45317 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.56003 .4553 m .57309 .45317 L .58151 .45809 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.73672 .1556 m .75042 .15238 L .75736 .15981 L 1 0 0 r
F
P
p
.002 w
.65568 .4524 m .66915 .45025 L .67619 .42399 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.3402 .4013 m .35241 .39899 L .36139 .45615 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.35241 .39899 m .3402 .4013 L .32974 .39591 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.31756 .39824 m .32974 .39591 L .3402 .4013 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72371 .4121 m .71071 .43506 L .70263 .3987 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.68916 .40102 m .70263 .3987 L .71071 .43506 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.48123 .15161 m .50318 .15586 L .49043 .15905 L 1 .07 0 r
F
P
p
.4685 .15484 m .48123 .15161 L .49043 .15905 L 1 .07 0 r
F
P
p
.002 w
.44329 .45539 m .43076 .4575 L .42105 .45258 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.40854 .45471 m .42105 .45258 L .43076 .4575 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.59854 .15148 m .61993 .15573 L .60676 .15892 L 1 .463 0 r
F
P
p
.58538 .1547 m .59854 .15148 L .60676 .15892 L 1 .673 0 r
F
P
p
.002 w
.56003 .4553 m .54707 .45741 L .53835 .445 L p
1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.52541 .45462 m .53835 .445 L .54707 .45741 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.70263 .3987 m .68916 .40102 L .68272 .44809 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.66915 .45025 m .68272 .44809 L .68916 .40102 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.71588 .15134 m .73672 .1556 L .72312 .15879 L 1 0 0 r
F
P
p
.70229 .15457 m .71588 .15134 L .72312 .15879 L 1 0 0 r
F
P
p
.002 w
.73702 .39944 m .72371 .4121 L .71621 .39636 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.70263 .3987 m .71621 .39636 L .72371 .4121 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.44636 .15058 m .4685 .15484 L .45586 .15804 L 1 0 0 r
F
P
p
.43373 .15381 m .44636 .15058 L .45586 .15804 L 1 0 0 r
F
P
p
.002 w
.40854 .45471 m .39611 .45683 L .38611 .45189 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.3737 .45403 m .38611 .45189 L .39611 .45683 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.56379 .15044 m .58538 .1547 L .57231 .1579 L 1 .453 0 r
F
P
p
.55074 .15368 m .56379 .15044 L .57231 .1579 L 1 .593 0 r
F
P
p
.002 w
.52541 .45462 m .51256 .45674 L .50353 .4518 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4907 .45394 m .50353 .4518 L .51256 .45674 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68127 .15031 m .70229 .15457 L .6888 .15777 L 1 0 0 r
F
P
p
.66779 .15354 m .68127 .15031 L .6888 .15777 L 1 0 0 r
F
P
p
.002 w
.64231 .45453 m .62904 .45665 L .621 .45172 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.60774 .45385 m .621 .45172 L .62904 .45665 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.78511 .39786 m .77132 .40018 L .76448 .39477 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7507 .39711 m .76448 .39477 L .77132 .40018 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3737 .45403 m .36139 .45615 L .35241 .39899 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.52897 .14941 m .55074 .15368 L .53779 .15688 L 1 .349 0 r
F
P
p
.51603 .15265 m .52897 .14941 L .53779 .15688 L 1 .349 0 r
F
P
p
.002 w
.4907 .45394 m .47797 .45607 L .46864 .45112 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45592 .45326 m .46864 .45112 L .47797 .45607 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.64657 .14927 m .66779 .15354 L .65441 .15675 L 1 .035 0 r
F
P
p
.6332 .15251 m .64657 .14927 L .65441 .15675 L 1 .07 0 r
F
P
p
.002 w
.60774 .45385 m .59458 .45598 L .58616 .44052 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.57309 .45317 m .58616 .44052 L .59458 .45598 L p
1 .663 0 r
F P
0 0 0 r
s
P
p
.002 w
.7507 .39711 m .73702 .39944 L .72988 .39401 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71621 .39636 m .72988 .39401 L .73702 .39944 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.35241 .39899 m .3647 .39666 L .3737 .45403 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.3647 .39666 m .35241 .39899 L .34201 .39355 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.32974 .39591 m .34201 .39355 L .35241 .39899 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49406 .14837 m .51603 .15265 L .50318 .15586 L 1 .035 0 r
F
P
p
.48123 .15161 m .49406 .14837 L .50318 .15586 L 1 .07 0 r
F
P
p
.002 w
.45592 .45326 m .44329 .45539 L .43366 .45043 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.42105 .45258 m .43366 .45043 L .44329 .45539 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6118 .14823 m .6332 .15251 L .61993 .15573 L 1 .209 0 r
F
P
p
.59854 .15148 m .6118 .14823 L .61993 .15573 L 1 .463 0 r
F
P
p
.002 w
.57309 .45317 m .56003 .4553 L .55136 .43982 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.53835 .445 m .55136 .43982 L p
.55085 .45094 L 1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.53835 .445 m .52541 .45462 L .51646 .44965 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.51646 .44965 m .52948 .44748 L .53835 .445 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.55136 .43982 m .53835 .445 L .52948 .44748 L p
1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.52948 .44748 m .5426 .4453 L .55136 .43982 L p
1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.55136 .43982 m .5426 .4453 L p
.55188 .42858 L 1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.56434 .40614 m .55136 .43982 L p
.55188 .42858 L 1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.55136 .43982 m .56003 .4553 L p
.55085 .45094 L 1 .638 0 r
F P
0 0 0 r
s
P
p
.002 w
.71621 .39636 m .70263 .3987 L .69638 .44591 L p
1 .335 0 r
F P
0 0 0 r
s
P
p
.002 w
.68272 .44809 m .69638 .44591 L .70263 .3987 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.72957 .1481 m .75042 .15238 L .73672 .1556 L 1 0 0 r
F
P
p
.71588 .15134 m .72957 .1481 L .73672 .1556 L 1 0 0 r
F
P
p
.45907 .14732 m .48123 .15161 L .4685 .15484 L 1 0 0 r
F
P
p
.44636 .15058 m .45907 .14732 L .4685 .15484 L 1 0 0 r
F
P
p
.002 w
.42105 .45258 m .40854 .45471 L .3986 .44974 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.38611 .45189 m .3986 .44974 L .40854 .45471 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.57694 .14719 m .59854 .15148 L .58538 .1547 L 1 .394 0 r
F
P
p
.56379 .15044 m .57694 .14719 L .58538 .1547 L 1 .453 0 r
F
P
p
.002 w
.50353 .4518 m .51646 .44965 L .52541 .45462 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.69484 .14705 m .71588 .15134 L .70229 .15457 L 1 0 0 r
F
P
p
.68127 .15031 m .69484 .14705 L .70229 .15457 L 1 0 0 r
F
P
p
.002 w
.65568 .4524 m .64231 .45453 L .6343 .44551 L p
1 .649 0 r
F P
0 0 0 r
s
P
p
.002 w
.621 .45172 m .6343 .44551 L .64231 .45453 L p
1 .684 0 r
F P
0 0 0 r
s
P
p
.002 w
.76448 .39477 m .77836 .3924 L .78511 .39786 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38611 .45189 m .3737 .45403 L .3647 .39666 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.542 .14614 m .56379 .15044 L .55074 .15368 L 1 .244 0 r
F
P
p
.52897 .14941 m .542 .14614 L .55074 .15368 L 1 .349 0 r
F
P
p
.002 w
.50353 .4518 m .4907 .45394 L .48145 .44896 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46864 .45112 m .48145 .44896 L .4907 .45394 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.66004 .14601 m .68127 .15031 L .66779 .15354 L 1 0 0 r
F
P
p
.64657 .14927 m .66004 .14601 L .66779 .15354 L 1 .035 0 r
F
P
p
.002 w
.621 .45172 m .60774 .45385 L .59919 .41733 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.58616 .44052 m .59919 .41733 L .60774 .45385 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.76448 .39477 m .7507 .39711 L .74365 .39164 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72988 .39401 m .74365 .39164 L .7507 .39711 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.3647 .39666 m .37709 .39431 L .38611 .45189 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.37709 .39431 m .3647 .39666 L .35437 .39118 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.34201 .39355 m .35437 .39118 L .3647 .39666 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.50698 .1451 m .52897 .14941 L .51603 .15265 L 1 0 0 r
F
P
p
.49406 .14837 m .50698 .1451 L .51603 .15265 L 1 .035 0 r
F
P
p
.002 w
.46864 .45112 m .45592 .45326 L .44636 .44827 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43366 .45043 m .44636 .44827 L .45592 .45326 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.62515 .14496 m .64657 .14927 L .6332 .15251 L 1 .14 0 r
F
P
p
.6118 .14823 m .62515 .14496 L .6332 .15251 L 1 .209 0 r
F
P
p
.002 w
.58616 .44052 m .57309 .45317 L .56434 .40614 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.55136 .43982 m .56434 .40614 L .57309 .45317 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.72988 .39401 m .71621 .39636 L .71005 .43962 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.002 w
.69638 .44591 m .71005 .43962 L .71621 .39636 L p
1 .335 0 r
F P
0 0 0 r
s
P
p
.72957 .1481 m .74336 .14482 L .75042 .15238 L 1 0 0 r
F
P
p
.47188 .14405 m .49406 .14837 L .48123 .15161 L 1 0 0 r
F
P
p
.45907 .14732 m .47188 .14405 L .48123 .15161 L 1 0 0 r
F
P
p
.002 w
.43366 .45043 m .42105 .45258 L .41119 .44757 L p
1 .62 0 r
F P
0 0 0 r
s
P
p
.002 w
.3986 .44974 m .41119 .44757 L .42105 .45258 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.59018 .14391 m .6118 .14823 L .59854 .15148 L 1 .219 0 r
F
P
p
.57694 .14719 m .59018 .14391 L .59854 .15148 L 1 .394 0 r
F
P
p
.70852 .14377 m .72957 .1481 L .71588 .15134 L 1 0 0 r
F
P
p
.69484 .14705 m .70852 .14377 L .71588 .15134 L 1 0 0 r
F
P
p
.002 w
.66915 .45025 m .65568 .4524 L .64764 .43682 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.6343 .44551 m .64764 .43682 L .65568 .4524 L p
1 .649 0 r
F P
0 0 0 r
s
P
p
.002 w
.3986 .44974 m .38611 .45189 L .37709 .39431 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.59919 .41733 m .58616 .44052 L .57743 .39336 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.56434 .40614 m .57743 .39336 L .58616 .44052 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.55513 .14286 m .57694 .14719 L .56379 .15044 L 1 .105 0 r
F
P
p
.542 .14614 m .55513 .14286 L .56379 .15044 L 1 .244 0 r
F
P
p
.002 w
.51646 .44965 m .50353 .4518 L .49436 .44678 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48145 .44896 m .49436 .44678 L .50353 .4518 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6736 .14272 m .69484 .14705 L .68127 .15031 L 1 0 0 r
F
P
p
.66004 .14601 m .6736 .14272 L .68127 .15031 L 1 0 0 r
F
P
p
.002 w
.6343 .44551 m .621 .45172 L .61236 .40457 L p
1 .37 0 r
F P
0 0 0 r
s
P
p
.002 w
.59919 .41733 m .61236 .40457 L .621 .45172 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.57743 .39336 m .56434 .40614 L .55581 .44309 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.5426 .4453 m .55581 .44309 L .56434 .40614 L p
1 .523 0 r
F P
0 0 0 r
s
P
p
.002 w
.77836 .3924 m .76448 .39477 L .75752 .38926 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74365 .39164 m .75752 .38926 L .76448 .39477 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61236 .40457 m .59919 .41733 L .59066 .39098 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.57743 .39336 m .59066 .39098 L .59919 .41733 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.37709 .39431 m .38956 .39194 L .3986 .44974 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.38956 .39194 m .37709 .39431 L .36682 .38879 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.35437 .39118 m .36682 .38879 L .37709 .39431 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.52 .1418 m .542 .14614 L .52897 .14941 L 1 0 0 r
F
P
p
.50698 .1451 m .52 .1418 L .52897 .14941 L 1 0 0 r
F
P
p
.002 w
.48145 .44896 m .46864 .45112 L .45915 .44609 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.44636 .44827 m .45915 .44609 L .46864 .45112 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.6386 .14166 m .66004 .14601 L .64657 .14927 L 1 .105 0 r
F
P
p
.62515 .14496 m .6386 .14166 L .64657 .14927 L 1 .14 0 r
F
P
p
.002 w
.74365 .39164 m .72988 .39401 L .72262 .38849 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71005 .43962 m .72262 .38849 L .72988 .39401 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.48478 .14074 m .50698 .1451 L .49406 .14837 L 1 0 0 r
F
P
p
.47188 .14405 m .48478 .14074 L .49406 .14837 L 1 0 0 r
F
P
p
.002 w
.44636 .44827 m .43366 .45043 L .42423 .42178 L p
1 .48 0 r
F P
0 0 0 r
s
P
p
.002 w
.41119 .44757 m .42423 .42178 L .43366 .45043 L p
1 .62 0 r
F P
0 0 0 r
s
P
p
.002 w
.59066 .39098 m .57743 .39336 L .56912 .44088 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.55581 .44309 m .56912 .44088 L .57743 .39336 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.60352 .14061 m .62515 .14496 L .6118 .14823 L 1 .07 0 r
F
P
p
.59018 .14391 m .60352 .14061 L .6118 .14823 L 1 .219 0 r
F
P
p
.7223 .14047 m .74336 .14482 L .72957 .1481 L 1 0 0 r
F
P
p
.70852 .14377 m .7223 .14047 L .72957 .1481 L 1 0 0 r
F
P
p
.002 w
.68272 .44809 m .66915 .45025 L .66099 .42403 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.64764 .43682 m .66099 .42403 L .66915 .45025 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.61236 .40457 m .62559 .39174 L .6343 .44551 L p
1 .37 0 r
F P
0 0 0 r
s
P
p
.002 w
.62559 .39174 m .61236 .40457 L .60398 .38859 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.59066 .39098 m .60398 .38859 L .61236 .40457 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.64764 .43682 m .6343 .44551 L .62559 .39174 L p
1 .301 0 r
F P
0 0 0 r
s
P
p
.002 w
.41119 .44757 m .3986 .44974 L .38956 .39194 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.56836 .13954 m .59018 .14391 L .57694 .14719 L 1 .07 0 r
F
P
p
.55513 .14286 m .56836 .13954 L .57694 .14719 L 1 .105 0 r
F
P
p
.002 w
.52948 .44748 m .51646 .44965 L .50736 .44459 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.49436 .44678 m .50736 .44459 L .51646 .44965 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.68727 .13941 m .70852 .14377 L .69484 .14705 L 1 0 0 r
F
P
p
.6736 .14272 m .68727 .13941 L .69484 .14705 L 1 0 0 r
F
P
p
.002 w
.75752 .38926 m .7715 .38686 L .77836 .3924 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.38956 .39194 m .40213 .38956 L .41119 .44757 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.40213 .38956 m .38956 .39194 L .37937 .38638 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.36682 .38879 m .37937 .38638 L .38956 .39194 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.53311 .13848 m .55513 .14286 L .542 .14614 L 1 0 0 r
F
P
p
.52 .1418 m .53311 .13848 L .542 .14614 L 1 0 0 r
F
P
p
.002 w
.49436 .44678 m .48145 .44896 L .47204 .44389 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45915 .44609 m .47204 .44389 L .48145 .44896 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.62559 .39174 m .63902 .38936 L .64764 .43682 L p
1 .301 0 r
F P
0 0 0 r
s
P
p
.002 w
.63902 .38936 m .62559 .39174 L .61741 .38618 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60398 .38859 m .61741 .38618 L .62559 .39174 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.65215 .13834 m .6736 .14272 L .66004 .14601 L 1 .035 0 r
F
P
p
.6386 .14166 m .65215 .13834 L .66004 .14601 L 1 .105 0 r
F
P
p
.002 w
.75752 .38926 m .74365 .39164 L .73648 .38608 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72262 .38849 m .73648 .38608 L .74365 .39164 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.49778 .13742 m .52 .1418 L .50698 .1451 L 1 0 0 r
F
P
p
.48478 .14074 m .49778 .13742 L .50698 .1451 L 1 0 0 r
F
P
p
.002 w
.45915 .44609 m .44636 .44827 L .43721 .40083 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.42423 .42178 m .43721 .40083 L .44636 .44827 L p
1 .48 0 r
F P
0 0 0 r
s
P
p
.002 w
.66099 .42403 m .64764 .43682 L .63902 .38936 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.60398 .38859 m .59066 .39098 L .58253 .43864 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.56912 .44088 m .58253 .43864 L .59066 .39098 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.61696 .13728 m .6386 .14166 L .62515 .14496 L 1 .07 0 r
F
P
p
.60352 .14061 m .61696 .13728 L .62515 .14496 L 1 .07 0 r
F
P
p
.7223 .14047 m .73618 .13714 L .74336 .14482 L 1 0 0 r
F
P
p
.002 w
.69638 .44591 m .68272 .44809 L .6746 .42176 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.66099 .42403 m .6746 .42176 L .68272 .44809 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.002 w
.42423 .42178 m .41119 .44757 L .40213 .38956 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.58168 .13621 m .60352 .14061 L .59018 .14391 L 1 .035 0 r
F
P
p
.56836 .13954 m .58168 .13621 L .59018 .14391 L 1 .07 0 r
F
P
p
.002 w
.5426 .4453 m .52948 .44748 L .52046 .44239 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50736 .44459 m .52046 .44239 L .52948 .44748 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.70103 .13607 m .7223 .14047 L .70852 .14377 L 1 0 0 r
F
P
p
.68727 .13941 m .70103 .13607 L .70852 .14377 L 1 0 0 r
F
P
p
.002 w
.43721 .40083 m .42423 .42178 L .41479 .38716 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.40213 .38956 m .41479 .38716 L .42423 .42178 L p
1 .271 0 r
F P
0 0 0 r
s
P
p
.002 w
.6746 .42176 m .66099 .42403 L .65256 .38696 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.63902 .38936 m .65256 .38696 L .66099 .42403 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.41479 .38716 m .40213 .38956 L .392 .38396 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.37937 .38638 m .392 .38396 L .40213 .38956 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.54632 .13514 m .56836 .13954 L .55513 .14286 L 1 0 0 r
F
P
p
.53311 .13848 m .54632 .13514 L .55513 .14286 L 1 0 0 r
F
P
p
.002 w
.50736 .44459 m .49436 .44678 L .48502 .44168 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47204 .44389 m .48502 .44168 L .49436 .44678 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.43721 .40083 m .45 .39847 L .45915 .44609 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.45 .39847 m .43721 .40083 L .42754 .38474 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.41479 .38716 m .42754 .38474 L .43721 .40083 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.65256 .38696 m .63902 .38936 L .63093 .38376 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61741 .38618 m .63093 .38376 L .63902 .38936 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66581 .135 m .68727 .13941 L .6736 .14272 L 1 0 0 r
F
P
p
.65215 .13834 m .66581 .135 L .6736 .14272 L 1 .035 0 r
F
P
p
.002 w
.7715 .38686 m .75752 .38926 L .75045 .38366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73648 .38608 m .75045 .38366 L .75752 .38926 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.51087 .13406 m .53311 .13848 L .52 .1418 L 1 0 0 r
F
P
p
.49778 .13742 m .51087 .13406 L .52 .1418 L 1 0 0 r
F
P
p
.002 w
.47204 .44389 m .45915 .44609 L .45 .39847 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.61741 .38618 m .60398 .38859 L .59604 .43639 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.58253 .43864 m .59604 .43639 L .60398 .38859 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.6305 .13392 m .65215 .13834 L .6386 .14166 L 1 .07 0 r
F
P
p
.61696 .13728 m .6305 .13392 L .6386 .14166 L 1 .07 0 r
F
P
p
.002 w
.73648 .38608 m .72262 .38849 L .71523 .38288 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72262 .38849 m .71005 .43962 L .70138 .38531 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.002 w
.70138 .38531 m .71523 .38288 L .72262 .38849 L p
1 .161 0 r
F P
0 0 0 r
s
P
p
.002 w
.71005 .43962 m .69638 .44591 L .68831 .41947 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.002 w
.6746 .42176 m .68831 .41947 L .69638 .44591 L p
1 .558 0 r
F P
0 0 0 r
s
P
p
.5951 .13285 m .61696 .13728 L .60352 .14061 L 1 0 0 r
F
P
p
.58168 .13621 m .5951 .13285 L .60352 .14061 L 1 .035 0 r
F
P
p
.002 w
.55581 .44309 m .5426 .4453 L .53365 .44016 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52046 .44239 m .53365 .44016 L .5426 .4453 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.7149 .13271 m .73618 .13714 L .7223 .14047 L 1 0 0 r
F
P
p
.70103 .13607 m .7149 .13271 L .7223 .14047 L 1 0 0 r
F
P
p
.002 w
.68831 .41947 m .6746 .42176 L .6662 .38453 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.65256 .38696 m .6662 .38453 L .6746 .42176 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.42754 .38474 m .41479 .38716 L .40473 .38152 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.392 .38396 m .40473 .38152 L .41479 .38716 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.55962 .13177 m .58168 .13621 L .56836 .13954 L 1 0 0 r
F
P
p
.54632 .13514 m .55962 .13177 L .56836 .13954 L 1 0 0 r
F
P
p
.002 w
.52046 .44239 m .50736 .44459 L .4981 .43945 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48502 .44168 m .4981 .43945 L .50736 .44459 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.45 .39847 m .46289 .39609 L .47204 .44389 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.46289 .39609 m .45 .39847 L .44039 .3823 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.42754 .38474 m .44039 .3823 L .45 .39847 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.6662 .38453 m .65256 .38696 L .64455 .38131 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63093 .38376 m .64455 .38131 L .65256 .38696 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67956 .13163 m .70103 .13607 L .68727 .13941 L 1 0 0 r
F
P
p
.66581 .135 m .67956 .13163 L .68727 .13941 L 1 0 0 r
F
P
p
.002 w
.75045 .38366 m .76452 .38121 L .7715 .38686 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68831 .41947 m .70138 .38531 L .71005 .43962 L p
1 .44 0 r
F P
0 0 0 r
s
P
p
.52406 .13069 m .54632 .13514 L .53311 .13848 L 1 0 0 r
F
P
p
.51087 .13406 m .52406 .13069 L .53311 .13848 L 1 0 0 r
F
P
p
.002 w
.48502 .44168 m .47204 .44389 L .46289 .39609 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.63093 .38376 m .61741 .38618 L .60965 .43412 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.002 w
.59604 .43639 m .60965 .43412 L .61741 .38618 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.64413 .13055 m .66581 .135 L .65215 .13834 L 1 .035 0 r
F
P
p
.6305 .13392 m .64413 .13055 L .65215 .13834 L 1 .07 0 r
F
P
p
.002 w
.75045 .38366 m .73648 .38608 L .72919 .38043 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71523 .38288 m .72919 .38043 L .73648 .38608 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60862 .12946 m .6305 .13392 L .61696 .13728 L 1 0 0 r
F
P
p
.5951 .13285 m .60862 .12946 L .61696 .13728 L 1 0 0 r
F
P
p
.002 w
.56912 .44088 m .55581 .44309 L .54695 .43792 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.53365 .44016 m .54695 .43792 L .55581 .44309 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.71523 .38288 m .70138 .38531 L .69378 .37964 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70138 .38531 m .68831 .41947 L .67994 .3821 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.67994 .3821 m .69378 .37964 L .70138 .38531 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.7149 .13271 m .72887 .12932 L .73618 .13714 L 1 0 0 r
F
P
p
.002 w
.6662 .38453 m .67994 .3821 L .68831 .41947 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.44039 .3823 m .42754 .38474 L .41756 .37906 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.40473 .38152 m .41756 .37906 L .42754 .38474 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57303 .12837 m .5951 .13285 L .58168 .13621 L 1 0 0 r
F
P
p
.55962 .13177 m .57303 .12837 L .58168 .13621 L 1 0 0 r
F
P
p
.002 w
.53365 .44016 m .52046 .44239 L .51128 .4372 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.4981 .43945 m .51128 .4372 L .52046 .44239 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.46289 .39609 m .47587 .3937 L .48502 .44168 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.47587 .3937 m .46289 .39609 L .45333 .37984 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.44039 .3823 m .45333 .37984 L .46289 .39609 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.67994 .3821 m .6662 .38453 L .65828 .37885 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64455 .38131 m .65828 .37885 L .6662 .38453 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69342 .12823 m .7149 .13271 L .70103 .13607 L 1 0 0 r
F
P
p
.67956 .13163 m .69342 .12823 L .70103 .13607 L 1 0 0 r
F
P
p
.53735 .12729 m .55962 .13177 L .54632 .13514 L 1 0 0 r
F
P
p
.52406 .13069 m .53735 .12729 L .54632 .13514 L 1 0 0 r
F
P
p
.002 w
.4981 .43945 m .48502 .44168 L .47587 .3937 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.64455 .38131 m .63093 .38376 L .6231 .41023 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.60965 .43412 m .6231 .41023 L .63093 .38376 L p
1 .279 0 r
F P
0 0 0 r
s
P
p
.65788 .12714 m .67956 .13163 L .66581 .135 L 1 0 0 r
F
P
p
.64413 .13055 m .65788 .12714 L .66581 .135 L 1 .035 0 r
F
P
p
.002 w
.76452 .38121 m .75045 .38366 L .74325 .37796 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72919 .38043 m .74325 .37796 L .75045 .38366 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62225 .12605 m .64413 .13055 L .6305 .13392 L 1 0 0 r
F
P
p
.60862 .12946 m .62225 .12605 L .6305 .13392 L 1 0 0 r
F
P
p
.002 w
.58253 .43864 m .56912 .44088 L .56034 .43567 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.54695 .43792 m .56034 .43567 L .56912 .44088 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.72919 .38043 m .71523 .38288 L .70772 .37716 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69378 .37964 m .70772 .37716 L .71523 .38288 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45333 .37984 m .44039 .3823 L .43048 .37658 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.41756 .37906 m .43048 .37658 L .44039 .3823 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.58654 .12496 m .60862 .12946 L .5951 .13285 L 1 0 0 r
F
P
p
.57303 .12837 m .58654 .12496 L .5951 .13285 L 1 0 0 r
F
P
p
.002 w
.54695 .43792 m .53365 .44016 L .52455 .43494 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.51128 .4372 m .52455 .43494 L .53365 .44016 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.47587 .3937 m .48895 .39128 L .4981 .43945 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.48895 .39128 m .47587 .3937 L .46637 .37737 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.45333 .37984 m .46637 .37737 L .47587 .3937 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.69378 .37964 m .67994 .3821 L .67211 .37637 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65828 .37885 m .67211 .37637 L .67994 .3821 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70738 .12481 m .72887 .12932 L .7149 .13271 L 1 0 0 r
F
P
p
.69342 .12823 m .70738 .12481 L .7149 .13271 L 1 0 0 r
F
P
p
.55074 .12386 m .57303 .12837 L .55962 .13177 L 1 0 0 r
F
P
p
.53735 .12729 m .55074 .12386 L .55962 .13177 L 1 0 0 r
F
P
p
.002 w
.51128 .4372 m .4981 .43945 L .48895 .39128 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.63656 .3863 m .64455 .38131 L p
.63745 .39089 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.6231 .41023 m .63656 .3863 L p
.63745 .39089 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.63656 .3863 m .62826 .38054 L p
.63567 .38164 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.65828 .37885 m .64455 .38131 L .63656 .3863 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.63656 .3863 m .6504 .38383 L .65828 .37885 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.6504 .38383 m .63656 .3863 L p
.63567 .38164 L 1 .14 0 r
F P
0 0 0 r
s
P
p
.67172 .12372 m .69342 .12823 L .67956 .13163 L 1 0 0 r
F
P
p
.65788 .12714 m .67172 .12372 L .67956 .13163 L 1 0 0 r
F
P
p
.002 w
.74325 .37796 m .75742 .37547 L .76452 .38121 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.63598 .12261 m .65788 .12714 L .64413 .13055 L 1 0 0 r
F
P
p
.62225 .12605 m .63598 .12261 L .64413 .13055 L 1 0 0 r
F
P
p
.002 w
.59604 .43639 m .58253 .43864 L .57383 .43339 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.56034 .43567 m .57383 .43339 L .58253 .43864 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.74325 .37796 m .72919 .38043 L .72177 .37467 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70772 .37716 m .72177 .37467 L .72919 .38043 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.46637 .37737 m .45333 .37984 L .4435 .37408 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.43048 .37658 m .4435 .37408 L .45333 .37984 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.60015 .12151 m .62225 .12605 L .60862 .12946 L 1 0 0 r
F
P
p
.58654 .12496 m .60015 .12151 L .60862 .12946 L 1 0 0 r
F
P
p
.002 w
.56034 .43567 m .54695 .43792 L .53793 .43266 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.52455 .43494 m .53793 .43266 L .54695 .43792 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.48895 .39128 m .50213 .38885 L .51128 .4372 L p
1 .419 0 r
F P
0 0 0 r
s
P
p
.002 w
.50213 .38885 m .48895 .39128 L .47951 .37488 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.46637 .37737 m .47951 .37488 L .48895 .39128 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.70772 .37716 m .69378 .37964 L .68604 .37387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67211 .37637 m .68604 .37387 L .69378 .37964 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.70738 .12481 m .72144 .12137 L .72887 .12932 L 1 0 0 r
F
P
p
.56423 .1204 m .58654 .12496 L .57303 .12837 L 1 0 0 r
F
P
p
.55074 .12386 m .56423 .1204 L .57303 .12837 L 1 0 0 r
F
P
p
.002 w
.52455 .43494 m .51128 .4372 L .50213 .38885 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.67211 .37637 m .65828 .37885 L .6504 .38383 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.68567 .12026 m .70738 .12481 L .69342 .12823 L 1 0 0 r
F
P
p
.67172 .12372 m .68567 .12026 L .69342 .12823 L 1 0 0 r
F
P
p
.6498 .11915 m .67172 .12372 L .65788 .12714 L 1 0 0 r
F
P
p
.63598 .12261 m .6498 .11915 L .65788 .12714 L 1 0 0 r
F
P
p
.002 w
.60965 .43412 m .59604 .43639 L .58743 .4311 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.57383 .43339 m .58743 .4311 L .59604 .43639 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.75742 .37547 m .74325 .37796 L .73593 .37216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72177 .37467 m .73593 .37216 L .74325 .37796 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.47951 .37488 m .46637 .37737 L .45662 .37156 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.4435 .37408 m .45662 .37156 L .46637 .37737 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61386 .11804 m .63598 .12261 L .62225 .12605 L 1 0 0 r
F
P
p
.60015 .12151 m .61386 .11804 L .62225 .12605 L 1 0 0 r
F
P
p
.002 w
.57383 .43339 m .56034 .43567 L .5514 .43037 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.53793 .43266 m .5514 .43037 L .56034 .43567 L p
1 .698 0 r
F P
0 0 0 r
s
P
p
.002 w
.50213 .38885 m .51544 .37568 L .52455 .43494 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.51544 .37568 m .50213 .38885 L .49275 .37237 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.47951 .37488 m .49275 .37237 L .50213 .38885 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.72177 .37467 m .70772 .37716 L .70008 .37135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68604 .37387 m .70008 .37135 L .70772 .37716 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.57782 .11693 m .60015 .12151 L .58654 .12496 L 1 0 0 r
F
P
p
.56423 .1204 m .57782 .11693 L .58654 .12496 L 1 0 0 r
F
P
p
.002 w
.53793 .43266 m .52455 .43494 L .51544 .37568 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.68604 .37387 m .67211 .37637 L .66414 .37054 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6504 .38383 m .66414 .37054 L .67211 .37637 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.69972 .11678 m .72144 .12137 L .70738 .12481 L 1 0 0 r
F
P
p
.68567 .12026 m .69972 .11678 L .70738 .12481 L 1 0 0 r
F
P
p
.002 w
.51544 .37568 m .52879 .37317 L .53793 .43266 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.52879 .37317 m .51544 .37568 L .50609 .36984 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49275 .37237 m .50609 .36984 L .51544 .37568 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.66374 .11566 m .68567 .12026 L .67172 .12372 L 1 0 0 r
F
P
p
.6498 .11915 m .66374 .11566 L .67172 .12372 L 1 0 0 r
F
P
p
.002 w
.6231 .41023 m .60965 .43412 L .60105 .42103 L p
1 .463 0 r
F P
0 0 0 r
s
P
p
.002 w
.58743 .4311 m .60105 .42103 L .60965 .43412 L p
1 .673 0 r
F P
0 0 0 r
s
P
p
.002 w
.73593 .37216 m .75019 .36963 L .75742 .37547 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63656 .3863 m .6231 .41023 L .61444 .38304 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.002 w
.60105 .42103 m .61444 .38304 L .6231 .41023 L p
1 .463 0 r
F P
0 0 0 r
s
P
p
.002 w
.49275 .37237 m .47951 .37488 L .46984 .36902 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.45662 .37156 m .46984 .36902 L .47951 .37488 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.62767 .11454 m .6498 .11915 L .63598 .12261 L 1 0 0 r
F
P
p
.61386 .11804 m .62767 .11454 L .63598 .12261 L 1 0 0 r
F
P
p
.002 w
.58743 .4311 m .57383 .43339 L .56484 .39551 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.5514 .43037 m .56484 .39551 L .57383 .43339 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.73593 .37216 m .72177 .37467 L .71422 .36881 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70008 .37135 m .71422 .36881 L .72177 .37467 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61444 .38304 m .62826 .38054 L .63656 .3863 L p
1 .209 0 r
F P
0 0 0 r
s
P
p
.59152 .11342 m .61386 .11804 L .60015 .12151 L 1 0 0 r
F
P
p
.57782 .11693 m .59152 .11342 L .60015 .12151 L 1 0 0 r
F
P
p
.002 w
.5514 .43037 m .53793 .43266 L .52879 .37317 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.70008 .37135 m .68604 .37387 L .67817 .368 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66414 .37054 m .67817 .368 L .68604 .37387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.69972 .11678 m .71388 .11327 L .72144 .12137 L 1 0 0 r
F
P
p
.002 w
.52879 .37317 m .54225 .37065 L .5514 .43037 L p
1 .349 0 r
F P
0 0 0 r
s
P
p
.002 w
.54225 .37065 m .52879 .37317 L .51953 .36729 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.50609 .36984 m .51953 .36729 L .52879 .37317 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67778 .11215 m .69972 .11678 L .68567 .12026 L 1 0 0 r
F
P
p
.66374 .11566 m .67778 .11215 L .68567 .12026 L 1 0 0 r
F
P
p
.002 w
.50609 .36984 m .49275 .37237 L .48315 .36647 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.46984 .36902 m .48315 .36647 L .49275 .37237 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64159 .11102 m .66374 .11566 L .6498 .11915 L 1 0 0 r
F
P
p
.62767 .11454 m .64159 .11102 L .6498 .11915 L 1 0 0 r
F
P
p
.002 w
.60105 .42103 m .58743 .4311 L .5784 .38224 L p
1 .394 0 r
F P
0 0 0 r
s
P
p
.002 w
.56484 .39551 m .5784 .38224 L .58743 .4311 L p
1 .453 0 r
F P
0 0 0 r
s
P
p
.002 w
.75019 .36963 m .73593 .37216 L .72847 .36626 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71422 .36881 m .72847 .36626 L .73593 .37216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66414 .37054 m .6504 .38383 L .64219 .37803 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.62826 .38054 m .64219 .37803 L .6504 .38383 L p
1 .14 0 r
F P
0 0 0 r
s
P
p
.002 w
.5784 .38224 m .56484 .39551 L .55581 .3681 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.56484 .39551 m .5514 .43037 L .54225 .37065 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.002 w
.54225 .37065 m .55581 .3681 L .56484 .39551 L p
1 .244 0 r
F P
0 0 0 r
s
P
p
.60532 .10989 m .62767 .11454 L .61386 .11804 L 1 0 0 r
F
P
p
.59152 .11342 m .60532 .10989 L .61386 .11804 L 1 0 0 r
F
P
p
.002 w
.71422 .36881 m .70008 .37135 L .6923 .36544 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67817 .368 m .6923 .36544 L .70008 .37135 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62826 .38054 m .61444 .38304 L .60579 .36636 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.61444 .38304 m .60105 .42103 L .5921 .37974 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.5921 .37974 m .60579 .36636 L .61444 .38304 L p
1 .219 0 r
F P
0 0 0 r
s
P
p
.002 w
.55581 .3681 m .54225 .37065 L .53307 .36472 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51953 .36729 m .53307 .36472 L .54225 .37065 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67817 .368 m .66414 .37054 L .65622 .3755 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.64219 .37803 m .65622 .3755 L .66414 .37054 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.69193 .10861 m .71388 .11327 L .69972 .11678 L 1 0 0 r
F
P
p
.67778 .11215 m .69193 .10861 L .69972 .11678 L 1 0 0 r
F
P
p
.002 w
.5784 .38224 m .5921 .37974 L .60105 .42103 L p
1 .394 0 r
F P
0 0 0 r
s
P
p
.002 w
.5921 .37974 m .5784 .38224 L .56948 .36554 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.55581 .3681 m .56948 .36554 L .5784 .38224 L p
1 .105 0 r
F P
0 0 0 r
s
P
p
.002 w
.51953 .36729 m .50609 .36984 L .49657 .36389 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.48315 .36647 m .49657 .36389 L .50609 .36984 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.65562 .10747 m .67778 .11215 L .66374 .11566 L 1 0 0 r
F
P
p
.64159 .11102 m .65562 .10747 L .66374 .11566 L 1 0 0 r
F
P
p
.002 w
.72847 .36626 m .74283 .36368 L .75019 .36963 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.61922 .10633 m .64159 .11102 L .62767 .11454 L 1 0 0 r
F
P
p
.60532 .10989 m .61922 .10633 L .62767 .11454 L 1 0 0 r
F
P
p
.002 w
.72847 .36626 m .71422 .36881 L .70654 .36285 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6923 .36544 m .70654 .36285 L .71422 .36881 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64219 .37803 m .62826 .38054 L .61968 .36379 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.60579 .36636 m .61968 .36379 L .62826 .38054 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.56948 .36554 m .55581 .3681 L .54671 .36213 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53307 .36472 m .54671 .36213 L .55581 .3681 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6923 .36544 m .67817 .368 L .67015 .36202 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65622 .3755 m .67015 .36202 L .67817 .368 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.69193 .10861 m .70618 .10504 L .71388 .11327 L 1 0 0 r
F
P
p
.002 w
.60579 .36636 m .5921 .37974 L .58324 .36296 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.56948 .36554 m .58324 .36296 L .5921 .37974 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.53307 .36472 m .51953 .36729 L .51009 .3613 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49657 .36389 m .51009 .3613 L .51953 .36729 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66975 .10389 m .69193 .10861 L .67778 .11215 L 1 0 0 r
F
P
p
.65562 .10747 m .66975 .10389 L .67778 .11215 L 1 0 0 r
F
P
p
.002 w
.61968 .36379 m .60579 .36636 L .59712 .36036 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58324 .36296 m .59712 .36036 L .60579 .36636 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.63323 .10274 m .65562 .10747 L .64159 .11102 L 1 0 0 r
F
P
p
.61922 .10633 m .63323 .10274 L .64159 .11102 L 1 0 0 r
F
P
p
.002 w
.74283 .36368 m .72847 .36626 L .72089 .36025 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70654 .36285 m .72089 .36025 L .72847 .36626 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65622 .3755 m .64219 .37803 L .63368 .36119 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.61968 .36379 m .63368 .36119 L .64219 .37803 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.58324 .36296 m .56948 .36554 L .56046 .35952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54671 .36213 m .56046 .35952 L .56948 .36554 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70654 .36285 m .6923 .36544 L .68438 .35941 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67015 .36202 m .68438 .35941 L .6923 .36544 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.54671 .36213 m .53307 .36472 L .52372 .35869 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.51009 .3613 m .52372 .35869 L .53307 .36472 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.684 .10028 m .70618 .10504 L .69193 .10861 L 1 0 0 r
F
P
p
.66975 .10389 m .684 .10028 L .69193 .10861 L 1 0 0 r
F
P
p
.002 w
.63368 .36119 m .61968 .36379 L .6111 .35774 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59712 .36036 m .6111 .35774 L .61968 .36379 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.64735 .09913 m .66975 .10389 L .65562 .10747 L 1 0 0 r
F
P
p
.63323 .10274 m .64735 .09913 L .65562 .10747 L 1 0 0 r
F
P
p
.002 w
.72089 .36025 m .73535 .35763 L .74283 .36368 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67015 .36202 m .65622 .3755 L .64778 .35858 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.002 w
.63368 .36119 m .64778 .35858 L .65622 .3755 L p
1 .07 0 r
F P
0 0 0 r
s
P
p
.002 w
.59712 .36036 m .58324 .36296 L .57432 .35689 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56046 .35952 m .57432 .35689 L .58324 .36296 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72089 .36025 m .70654 .36285 L .69872 .35679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68438 .35941 m .69872 .35679 L .70654 .36285 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56046 .35952 m .54671 .36213 L .53745 .35605 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.52372 .35869 m .53745 .35605 L .54671 .36213 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68438 .35941 m .67015 .36202 L .662 .35594 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64778 .35858 m .662 .35594 L .67015 .36202 L p
1 .035 0 r
F P
0 0 0 r
s
P
p
.684 .10028 m .69835 .09665 L .70618 .10504 L 1 0 0 r
F
P
p
.002 w
.64778 .35858 m .63368 .36119 L .62519 .35509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6111 .35774 m .62519 .35509 L .63368 .36119 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.66158 .09548 m .684 .10028 L .66975 .10389 L 1 0 0 r
F
P
p
.64735 .09913 m .66158 .09548 L .66975 .10389 L 1 0 0 r
F
P
p
.002 w
.6111 .35774 m .59712 .36036 L .58828 .35425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57432 .35689 m .58828 .35425 L .59712 .36036 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73535 .35763 m .72089 .36025 L .71316 .35414 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69872 .35679 m .71316 .35414 L .72089 .36025 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57432 .35689 m .56046 .35952 L .55129 .3534 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.53745 .35605 m .55129 .3534 L .56046 .35952 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69872 .35679 m .68438 .35941 L .67632 .35329 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.662 .35594 m .67632 .35329 L .68438 .35941 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.662 .35594 m .64778 .35858 L .63938 .35243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62519 .35509 m .63938 .35243 L .64778 .35858 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67592 .09181 m .69835 .09665 L .684 .10028 L 1 0 0 r
F
P
p
.66158 .09548 m .67592 .09181 L .684 .10028 L 1 0 0 r
F
P
p
.002 w
.62519 .35509 m .6111 .35774 L .60236 .35158 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58828 .35425 m .60236 .35158 L .6111 .35774 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71316 .35414 m .72772 .35147 L .73535 .35763 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58828 .35425 m .57432 .35689 L .56524 .35072 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.55129 .3534 m .56524 .35072 L .57432 .35689 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71316 .35414 m .69872 .35679 L .69075 .35061 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67632 .35329 m .69075 .35061 L .69872 .35679 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67632 .35329 m .662 .35594 L .65369 .34975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63938 .35243 m .65369 .34975 L .662 .35594 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.67592 .09181 m .69037 .08811 L .69835 .09665 L 1 0 0 r
F
P
p
.002 w
.63938 .35243 m .62519 .35509 L .61654 .34889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60236 .35158 m .61654 .34889 L .62519 .35509 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60236 .35158 m .58828 .35425 L .57929 .34802 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.56524 .35072 m .57929 .34802 L .58828 .35425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72772 .35147 m .71316 .35414 L .7053 .34791 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69075 .35061 m .7053 .34791 L .71316 .35414 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69075 .35061 m .67632 .35329 L .66811 .34704 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65369 .34975 m .66811 .34704 L .67632 .35329 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65369 .34975 m .63938 .35243 L .63083 .34618 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61654 .34889 m .63083 .34618 L .63938 .35243 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61654 .34889 m .60236 .35158 L .59345 .3453 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57929 .34802 m .59345 .3453 L .60236 .35158 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7053 .34791 m .71996 .34519 L .72772 .35147 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7053 .34791 m .69075 .35061 L .68265 .34432 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66811 .34704 m .68265 .34432 L .69075 .35061 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66811 .34704 m .65369 .34975 L .64524 .34344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63083 .34618 m .64524 .34344 L .65369 .34975 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63083 .34618 m .61654 .34889 L .60773 .34257 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59345 .3453 m .60773 .34257 L .61654 .34889 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71996 .34519 m .7053 .34791 L .69729 .34157 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68265 .34432 m .69729 .34157 L .7053 .34791 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68265 .34432 m .66811 .34704 L .65975 .34069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64524 .34344 m .65975 .34069 L .66811 .34704 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64524 .34344 m .63083 .34618 L .62212 .3398 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60773 .34257 m .62212 .3398 L .63083 .34618 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69729 .34157 m .71206 .3388 L .71996 .34519 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69729 .34157 m .68265 .34432 L .67439 .33791 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65975 .34069 m .67439 .33791 L .68265 .34432 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65975 .34069 m .64524 .34344 L .63662 .33702 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62212 .3398 m .63662 .33702 L .64524 .34344 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71206 .3388 m .69729 .34157 L .68914 .33512 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67439 .33791 m .68914 .33512 L .69729 .34157 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67439 .33791 m .65975 .34069 L .65124 .33422 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63662 .33702 m .65124 .33422 L .65975 .34069 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68914 .33512 m .70401 .33229 L .71206 .3388 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68914 .33512 m .67439 .33791 L .66598 .33139 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65124 .33422 m .66598 .33139 L .67439 .33791 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70401 .33229 m .68914 .33512 L .68083 .32854 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66598 .33139 m .68083 .32854 L .68914 .33512 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68083 .32854 m .69581 .32567 L .70401 .33229 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.0749 .19643 m
.07446 .2031 L
s
P
[(0)] .07579 .18311 -0.06628 1 Mshowa
p
.002 w
.29207 .1374 m
.29183 .14408 L
s
P
[(20)] .29254 .12405 -0.03525 1 Mshowa
p
.002 w
.54188 .0695 m
.54188 .07618 L
s
P
[(40)] .54186 .05614 .00111 1 Mshowa
p
.001 w
.11604 .18525 m
.11579 .18925 L
s
P
p
.001 w
.15827 .17377 m
.15805 .17777 L
s
P
p
.001 w
.20166 .16198 m
.20146 .16598 L
s
P
p
.001 w
.24624 .14986 m
.24607 .15386 L
s
P
p
.001 w
.3392 .12459 m
.33908 .1286 L
s
P
p
.001 w
.38768 .11141 m
.38759 .11542 L
s
P
p
.001 w
.43758 .09785 m
.43752 .10186 L
s
P
p
.001 w
.48895 .08388 m
.48893 .08789 L
s
P
p
.001 w
.59641 .05467 m
.59645 .05868 L
s
P
p
.001 w
.65264 .03939 m
.65271 .0434 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 268},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J000130P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?mK6U/10000oe/JF`40003oFaYK
0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000oe/JF`40001UF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0VU/10000IE/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o09eK
0@0006EK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0WE/10000IE/00omKo`03F`04oe]Ko`AK
00?oFol00e/00omKo`2MF`40001UF`03oe_o00=K00CoFe_o15/00omKo`03F`03oe_o025K00CoFe]K
1?mdF`40001UF`04oe_oo`9K00CoFe_o0e/2o`05FomKFol00e/00omKF`0NF`04oe]Ko`AK00?oFe/0
7U/3oe1K0@0006EK00CoFomK0_l4F`?o00AKoe_o0U/01OmKFe_o01aK1_l00e_oF`03F`03oe]K01YK
1?l2F`03oe]K04iK0@0006EK00?oFe/02e/00omKF`0SF`05oe]KFol00U/00omKF`02F`03oe]K01MK
0ol7F`03oe]K04eK0@0006EK00?oFe/02e/00omKo`0TF`04oe]Ko`9K00?oFe/00U/00omKF`0CF`Co
2e/00omKF`1<F`40002KF`03oe_o009K00?oFe/00U/00omKF`0?F`Co00=Koe/03E/00omKF`1;F`40
002KF`03oe_o009K00?oFe/00U/00omKF`0<F`?o5E/00omKF`1:F`40002LF`;o0U/00omKF`02F`03
oe]K00QK1?lIF`03oe]K04UK0@0009eK00CoFe]K1?l7F`Co7U/00omKF`18F`40002YF`?o0U/00omK
F`0MF`03oe]K04QK0@000:EK1?lVF`03oe]K04MK0@000:5K1?l[F`03oe]K04IK0@0009iK0ol`F`03
oe]K04EK0@0009YK1?l2F`03oe]K02mK00?oFe/0A5/10000UU/4o`IK00?oFe/0<5/00omKF`13F`40
002CF`?o?U/00omKF`12F`40002?F`Go@5/00omKF`12F`40002;F`CoAU/00omKF`11F`40001KF`Ko
0U/4ob5K0oleF`LS3e/00omKF`08F`03oe]K009K1?l_F`40001KF`03oe]K00AK00?oFe/00U/00omK
F`0JF`Co=E/;8`mK00?oFe/01e/01OmKFe_o00AK00?oFe/0;5/10000G5/00omKF`03F`03oe]K009K
00?oFe/05U/4o`9K00?oFe/0<5/@8`mK00?oFe/01U/01OmKFe_o00AK00?oFe/0;5/10000GE/2o`=K
00?oFe/00U/00omKF`0CF`?o=U/D8`mK00?oFe/01E/01OmKFe_o00AK00?oFe/0;5/10000Ge/01?mK
Fol4F`03oe]K00mK1?leFaPS45/00omKF`04F`05oe]KFol015/00omKF`0/F`40001PF`03oe_o00AK
00?oFe/02e/5ocEK72<>F`;o1U/01OmKFe_o00AK00?oFe/0;5/10000Fe/00omKF`02F`03oe_o00AK
00?oFe/025/3ocIK8B<?F`04oe]KF`?o0e/00omKF`02F`03oe]K02aK0@0005]K00?oFe/00U/00omK
o`04F`03oe]K00AK1?lfFbDS3e/00omKF`02F`05oe]KFol015/00omKF`0/F`40001LF`Co0e/4o`=K
1?lfFbXS3e/01OmKFe_o00AK1?l_F`40001WF`?o0e/00omKF`0^FahS0QlA8`mK00?oFe/0>5/10000
He/4oc=K7R<01amO7elOGal04B<?F`03oe]K03MK0@0005mK1?ldFaDS0al68`067elOGamO1AlA8`mK
00?oFe/0=U/10000G5/3o`9K00?oFe/0<5/E8`07GamO7elOG`028`087elOGamO7el37`04GamO7a4S
3U/00omKF`0fF`40001HF`Co1E/00omKF`0/Fa8S00IO7emO7el27`0<GalO7elOGamO7elO15l011mO
7el27a<S3U/00omKF`0eF`40001DF`Co<U/<8`037elO00HS00<GGel015l27`<G00IO5amO7el27`=O
1al00elO8`0D8`iK00?oFe/0=5/10000:5/4obEK0ol00e_oF`0`F``S00<OGal011l28`055elGGaL0
0Ul00alA4@024@035a4G00<G00EO7aLA5`047`9O00<OGal011lE8`iK00?oFe/0<e/100009e/00omK
F`02F`03oe]K01iK1?lcF`PS00`OGamO7elOGamO7el45`07GaMO5eoOW`054@8G00>Ogil00il011LA
5a42G`<O00EO7elOG`0G8`mK00?oFe/06e/4o`03FomK00Co0U/01OmKFe_o00=K0Ol1F`40000WF`03
oe]K009K00?oFe/06U/4oc=K2B<02AmO7elOGamO7`075`05GaMO5el01Yl24@VO00IO5elOGal4G`03
7elS00PS00<OGb<03b<?F`03oe]K01UK00?oFe/00U/3o`AK00?oFol00e/00omKF`03F`40000WF`03
oe]K009K00?oFe/05e/3o`03FomK035K2B<04QmO7elOGamO7a4G4ALA5a4G4@<G01OOWmnOgioOWmnO
gioOWmnOgelGGaMO5`02G``S0el47`8S00=O7b<032<>F`03oe]K00AK1_l2F`Co1e/00omKF`04F`;o
1U/01OmKFe_o00EK0@0002MK00?oFe/00U/00omKF`0CF`Co<E/<8`9O00LOGamO7elO00PG5Il025lG
GaMO5elG0Ql:8`PO00=O4AL015l=8`eK00?oFe/015/00omKF`04F`03oe]K009K00?oFe/015/00omK
F`04F`Oo00=Koe/00U/00omKF`03F`40000WF`03oe]K009K00?oFe/03e/4oc9K2B<01QMO7elOG`@O
01iO5a4G4ALA5a4GgioOWmnOgioOWmnOgioOWmnOgil35`06GaMO5elG0al00elOG`028`03GamO00UO
00/A5a4A5a4GGamO7`0=8`eK00?oFe/015/00omKF`03F`03oe]K009K00?oFe/015/01?mKFe/5o`AK
00?oFol00e/00omKF`03F`40000WF`03oe]K009K00?oFe/035/3o`03FomK031K2B<02QMO5elGGamO
4Il54@DG4Il24@@G00IO5elGGaL27`03GamO00<O0QL6G`0:7a4A5a4G4ALA5`8A00<GGel015l=8`eK
00?oFe/015/2o`=K00?oFe/00U/00omKF`04F`03oe]K00EK00?oFe/00U/01?mKool2F`03oe]K00=K
0@0002MK00?oFe/00U/00omKF`08F`Co<5/<8`0?5elGGaMO5eoOWmlAWa6O008G01BOgioOWmnOgioO
WmnOgioOWmnOg`JO1A400aMO5`04G`8O0QL02ElGGaMO7ilAW`044@035a4A008G00=O5el01El00amO
7`0=8`eK0_l6F`04oe]Ko`AK00?oFe/015/00omKF`04F`03oe_o00?o0U/01?mKool6F`40000XF`Co
1e/4oc5K2B<02elGGaMO5elGGaMO00RO00<AWil069l44@HG00UOWilG4ALA5a400aL3W`044IlAW`8A
1aL00elO7`04G`@O32<<F`03oe_o00MK00?oFol015/00omKF`05F`03oe]K009K00?oFe/045/10000
<5/3o`9K00?oFe/0;E/00elOG`068`0^GaMO5elGGaNOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOg`RO0Q400ioOW`04W`075a7OWmnOg`05W`8A00<G4A4011400aMOG`04G`8O00LG7elO
GamO00/S3U/00omKo`04F`03oe_o00AK00?oFe/01U/4oa=K0@0002aK1?l_F`=O00@OGamO0al28`08
GaMO5elGGaL^W`8A4il0216O4IlG4ALA0QL01Q4G7elOG`8O00<GGel00el27`=O00@OGamO1b<>F`;o
15/00omKo`04F`03oe]K01eK0@0002YK0_l`F`TO0aL0BUlGGaMO5elGWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO1Il84@@G0Ul02A4G
5elGGaLO5`057`04GalO7`PS3E/00omKo`03o`=K1?lPF`40000ZF`03oe]K02aK2El35`05GaMO5el0
CYl44@<G00DA5a4G4@055`UO0al00elOG`028`9O11l=F`03oe]K02UK0@0002UK0_lYF`037elO00PO
00DA5a4G4@035`1=gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWml01Il34@03Wa4A00<A0aL02Q4G4ALOGamO5al6G`<O
00=O7al00Ql015lOGal=F`03oe]K02QK0@0002YK00>1Fe/095/00elOG`05G`/GEil34@035a4A008G
00<A5a400aL6G`037aLG00IO00HOGemO5el47`eK00?oFe/09e/10000:U/00h5KF`0QF`<A1El35`1K
4ALA5a4GgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOg`05W`PA00<G4AL011L02elGGamO4AMO5elG009O
0aL02UlGGelOGamO7el>F`03oe]K02IK0@0002YK00>1Fe/075/6W`055a4G7el00a400aLA5`025e^O
0a400ilAW`084@0:GaMO5elA5a4G4@<G00<A5a400a425`IO0al>F`03oe]K02EK0@0002YK00>1Fe/0
6E/02YoOWmnOgioOWml2W`1W4IlG4IoOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO4IlA
W`064@045a4G5`8A0QL01a4G4ALA5a400QL01A4G4ALA00@G15l47`04GamO7`eK00?oFe/095/10000
:U/00h5KF`0CFa:O00<AWil0H9l00a6O4@0;4@055a4G4AL00Q401IlAWa6O008A0QL00a4G4@025`03
4AMO00=O00@OGamO0Ql00elOF`0;F`03oe]K02AK0@0002UK00>1Fe/04U/0LYoOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOg`>O1a401YlAWa6O4@>O00PG4InO
4IlAW`8A00HG4ALA5a425`IO00<G7aL00al6G`aK00?oFe/01U/4o`=K1?lBF`40000YF`03PE]K00aK
OIl02Q6OWa6O4IlAWa49W`HA00@G4ALG0Ul00amO7`02G`037aLG00AO00@OGa4G15l<F`03oe]K00AK
00?oFe/00U/00omKo`04F`03oe]K00mK0@0002UK00>1Fe/02U/0O9oOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWml5W`0?4IlAWa6OgioOWmnO
gioO00FO00<A5a4011L5G`084ALAGaMO7el24@@G00<OGel03E/00omKF`03F`03oe]K009K00?oFol0
15/00omKF`0?F`40000YF`03POmK00AKDIl01]nOWmnOg`FO00?OWml0>il54@07GaLA5a4G4@035`:O
00<AWa4011L01a4GGamO7el03E/00omKF`07F`03oe_o00AK00?oFe/03e/1000065/6o`9K1?l5F`:1
1U/0CMnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioO00NO00?OWil02Il0<mnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOg`05W`<A00HG4A4A5a435`06gioOWmnO0Q400aMOG`03G`@O
00AO7elO2e/2o`EK0ol2F`03oe]K009K00?oFe/03e/1000065/00omKF`04F`03oe]K009K00?oFe/0
0U/0185KPH45FcjO00?OWml01il4g`04WmnOg`BO1=l01ioOWioOWml0>9l44@035a6O00ZO0Q400aMO
5`02G`037emO00AO0al=F`03oe]K00EK00?oFol015/00omKF`0?F`40000IF`03oe]K00=K00?oFe/0
0U/00omKF`02F`04PE]KF`:11E/0=YoOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioO
WmnOgioOWmnOgioOWmnOg`NO00?OWml00Yl01MnOgioO00>O00OOWmnOgioO00bO03GOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOg`05W`0:4IoOWmnOgioOW`8A
00DG4ALG4@025`07Ga4G7elOG`027`034EmO009O35/01?mKFol4F`03oe_o00AK00?oFe/03e/10000
55/3o`=K0_l3F`03oe]K009K00?oFe/00U/00h5KF`03F`:11E/00mnOg`02W`06gioOgioO2Il00mnO
W`0LW`06gioOWmnO2=l01YoOgioOW`;O19l01mnOgioOWml0BYl00a6O4@074@8G0Yl74@8O00=O7el0
2e/00omKo`04F`03oe_o00AK00?oFe/03e/1000075/01?mKFol4F`03oe]K009K00>1Fe/01E/2P@AK
00?OWml00]l3W`03gioN00GO00BOgmoO19l05]nOgioOWmnOgioOWmnOgioOWmnO4Ml8W`07g]oNgmkO
W`07g`034MnO00VO053OWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgilAW`8A00`G4A4GgioOWmnO4Il24@035a4G009O
0Ql<F`03oe_o00?o0e/4oa9K0@0001eK00?oFol015/00omKF`02F`03PE]K00MK00>1Fe/015/00moN
L@05gP03gmkO00;O00WNgmnOgioOWml01Il01]nOgmnOg`FO1=l019oOgml3gP07gmkOg]oNg`04gP03
gmkO00GO00BOgioO=9l2g`04WmnOW`;O69l00a6OW`07W`@A00>O4Il00Q401QmOGamO7`aK00?oFe/0
6e/1000065/00omKF`02F`03oe_o00AK00?oFe/00U/00h5KF`08F`:11U/3gP04LMoNL@GN0ml019oO
Wml2W`05gilAga400il01mnOg]oNgmh00]l6gP?O00?Ngmh00mh00moNgP03g`03WmnO00>O03;OWmnO
gioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOgioOW`;O29l5g`0NWmnOgioO
WmnOgioOWmnOgioOWmnOgioOWmnOgioO1Il02Q6O5elOGamO7el37`8S35/00omKF`0JF`40000HF`03
oe]K009K00?oFol015/00omKF`02F`03PE]K00YK0X45F`04gW7NL@ON00>Ogil00]l029oNg]oNgmjO
1]h00moNg`02g`03LMia00ON00OOg]oOg]oN00GO00>Ogml0=Il01=nOWil2g`03g]oO00?O00>Ogil0
0Yl00mnOg`04W`03gioO00JO0]l00ioOW`0<W`055a4GGaL01El00amO7`048`aK00?oFe/06E/10000
6E/4o`=K1?l5F`03PE]K00aK0X45F`04gW7NL@CN00=agml00]l02MkOgg7Og]oNL@05gP03LMia00oN
00KOg]oNgmh3g`0O4IoOWmnOgioOWmnOgioOWmnOgioOWmnOgioOWmnOg`03W`0@gioOWmnOgioOWmnO
gioOW`;O00/Aga7OWmoNgmkOgP05g`06WmnOgioO29l00mnOW`07W`0?gioOWmnOgioOWmnO4IlA00<G
00HA5a4G7el67`<S35/00omKF`0HF`40000XF`03oh5K00mK0X46F`?N00=ag]h00]h02G7NgW7NLMia
gP03L@04gW7NL@;N00=agW401G42gP06LMkNgmkO0]h3g`08WmnO4IlAWmlIW`CO00BOginO0]l00ioO
W`02W`03gmkO00CO00JOgioOg]l4gP07gmkOgmkOgP04g`03WmnO00CO0Yl00mnOg`03g`05WmnOgil0
0]l:W`LA0aL01elOGamO7el01B<;F`03oe]K01QK0@0002UK00>1Fe/045/2P@EK01cNLMiagW7MLMia
gW7NLMiagW7NLMiagW7NLMia2]h01G7Ng]oN00GO19l05MnOgioOWmnOgioOWmnOgioOWmnOg`02W`04
ga7O4@:O1]l4W`?O00?Ngmh00]l00miagP06gP0ALMmagmkOg]oNgmkOWmnOgmh01Ml00ioOW`09W`0G
gioOWmnOgioOWmnOgilAGaMO5elGGaL00Ul00amO7`068`aK00?oFe/025/01?mKFe/4o`MK0@0002QK
00>1Fe/04e/2P@AK00GNLMeag@07L@04gW7NL@;N00=ag]h01]h0377NLMiagW7NgmkOgP;O00?Ngil0
1=l00ioOW`0@W`05gioOWml00Yl00mnOW`03g`03WmnO00:O0]h00moNg`02gP9a1=h01W7NLMkOL@ON
0]l01MkOg]kO00;N00GOg]oOgP03g`03WmnO00:O00?OWil04Il01UlGGaMO5`AO00<OGal00al78`aK
00?oFe/01e/01?mKFol4F`03oe]K00AK0@0002QK00>1Fe/05E/2P@9K00V1Fe]agG7MLMd00W402Mia
gW7NLMiagP03L@03gmkN00ON00?Og]h00mh6g`:O01;OWmnOgioOWmnOgioOWmnOgil6g`034MoN00GO
0]h00g7NL@06gP06UG5agW7N0g401=magg44gP05LMiag]l00]h02=oNg]kOg]oN1ml2W`0GgioOWmnO
gioOWmnOgioOWaMO5elGGaL01Ul37`07GamO7elOG`088`]K00?oFe/00U/6o`03FomK00=K00?oFe/0
15/10000:5/00h5KF`0GF`>115/01=fEgMd3L@06gW7NLMia0]h00g7NL@02gP04LMiagP9a00?NLMh0
0mh00moNg`02g`04WmnOg`JO1=l00ioOg`08g`03g]oN00;N00COg]oO1=h2L@03gW7L00;L0iD00g6E
U@04U@=a1Mh00g7NgP04gP0<gmkOgmkOg]oNgmkO1Il01=nOgml3W`?O00>Oga4021L011mO7el77`AO
00<O8b<02b<;F`;o0U/01OmKFe_o009K00?oFe/00U/00omKF`04F`40000XF`03PE]K01QK0X46F`0B
LMeaLMiagW7NLMiagW7NLMia2]h8g`094MnOga7O4MlA00:O0]h01]magg7OgP;O00?NLMh00mh01]oN
LMiagP=a00FEg77LL@02U@OL00SMUG6Eg9EaU@9a1]h02G7NgmoNgmkOgP05g`0>4MlAgioOWmnOgioO
4Il54@035a4G00<G00=O5el00Ul00amOG`04Ga<S2U/00omKo`03F`04oe]Ko`9K00?oFe/00U/00omK
F`04F`40000XF`03PE]K01QK00B1Fh611E/01MeagG7M00Ia00GNLMiagP03L@03gW7N00?N0]l00mkO
g`03g`08g]oOg]oNgil3gP05LMkOg]l00]h01G7NLMia00;N00MaUIGMUMea00?L00FEg9FEg003U@03
g9FE00ZE00KLLMgNLMh3L@04gW7OgP;O0mh00moNg`04g`03g]oO00?O00>Ogil019l34@045a6O4@LG
00<A5a400el27aLS35/01omKFe_oFol00U/00omKF`02F`03oe]K00AK0@0002QK00>1Fe/065/0185K
Fe/2P@EK00OMLMeagG7M009a00KNLMiagW44gP06gmkOg]oN0]l01mkOg]oNgmh00]l01G7NLMia00;N
19D01W6ELG6Eg0BE00CMUG7M1]`01iGLg=bEg9D00m`029GLUMbEg9GL0iD3g@WN1Ml00mkOgP03g`03
g]oO00?O00DAgmnOg`08W`074InO4IlAW`034@035alO008O00=O7b<05b<?F`03oe_o009K00?oFe/0
0U/00omKF`04F`40000XF`03PE]K01QK00>1Fe/00e/2P@IK00CMUG7M0g400miaL@03gP03LMia00CN
00?Og]h01=h00mmag@05L@JE00?Lk=`01=`01YGLUMc/g0;/00SLk=c/g>cLk0?L00?/g=`00m`00iGL
U@05g004UMgMgPEa00?Ngmh01=l2gP03gmkN00?N00?Og]h00ml02IoOWioNgioOW`04g`>O0]l019oO
4A427`AO0QlL8`mK0_l2F`03oe]K009K00?oFe/015/10000:5/00h7oF`0HF`03PE]K00EK0X45F`04
gG7Mg@9a00BEgW7N1742gP03LMia00?N00REg9EaUG7Mk0OL00>Eg=`00m`01NcLk>cL00C/00SLk>c/
g>cLk0?L00?/g>`01m`00ncLk003g006LMeagMia1]h02]oNg]kMLMeagG43gP03gmkO00CO00VOg]kO
g]nOgmh01Ml01IlG7elO00=O1Ql01UlO8b=O7aTS3U/01?mKFe/4o`MK0@0002QK00>1Fe/065/00h5K
F`07F`:115/01MfEg9GL00Aa00OLUMcMUG7N00?L00FEg9GLk006g005k=cLk=`01N`6]`06k;Ngg>cL
0^`00mc/k005k007g>cLg>cLk002g0?/00OLk=bEg9GM00?N00Aag]ia0YD05=fEgIEagW7NLMiag]oN
gmkOg]oN0]l3L@06gmkOg]nO11401aLAGelOGal00el01alA5a5O7el00al@8`8O1R<MF`40000XF`03
PE]K01QK00>1Fe/02E/2P@AK00GLUKOL]`03g007UNcLg;OL]`03g003UNcL00G/00Ff]kK/]`03k009
]nbgk;O/]nbg00>f0[L03Mc/]nbgk;O/g>bgk=`01>`01=c/k>`3g004]mc/g0>E00=ag]`01M`00iGL
g@02L@KN00Eag]oNg`02gPEa0]h0117OWml2W`03gilA00<A0aL2G`03ginO00:O0aL4G`037elO00TS
1Al00elOG`078aaK0@0002QK00>1Fe/065/00h5KF`0;F`:11E/00nbg]`04]`C/0kH2]`03g>bg00>g
00Ff]kJe]P07]`0=]_bfo;Kl][Nf]KJg]P02]`Ff0kL01>bg]kL8k004g>c/]P:g00?/]n`00m`4U@04
gIGML@CN00=ag]h00YD4g@9a00?Nool01_l00ioOW`02W`8A00SNgmkOg]nOg`:O00GOWaLA5`027`LS
00=O7al00Ql01UlOGelOG`@O1b<KF`40000XF`03PE]K01QK00>1Fe/03E/2P@EK00Nf]nbgo;Kl00:f
0[L01;D=]_`2]P08]kFe]Obe]_`2]P>d0kD02?c<c0g<3Lbe0Pd01[Kl]_bg]P:g00>fo;H01;L02;Jg
][Jg]^bg1[H2]`05g>cLk=`019D01mbEgG7NLM`01iD00g6EgP03o`<S00?o8b<00R<00onOgP0>g`04
WemOG`8O0R<025lGGaMO7elO15l57``S6U/10000:5/00h5KF`0HF`03PE]K00mK0X45F`:d00Bfo<`=
0l`3]@03]Pd=008=00>e3O`00`d01<`=c;@2aP05c<3<`<`00`d3c003]@ff00Ne00Rf]KFe][Ff]`;l
1kH00kNf]`04k006g;Jfg>cL0YD5g0:E00?Lool01_l38`04ob<S8`;o0b<01?oOg]l3gP05gmkOg]l0
0Q435`0>GalA5a4G4AMO5elGGaL2G`8O4b<IF`40000XF`03PE]K01QK00>1Fe/04E/00h5KF`02F`03
PLK600;60/`00`g6aP02aP03c0d=00C600_0c<b<a/36`<K0aP03`008a/36`0g<3L`33@Ze00?l]KD0
1;D02;Jg]kNf]kJg0Pd01KJe][Fg00:e00Bf]kJg0^`2g004LOooo`<S00?o8b<00R<2o`8S0_l28`03
ob<S008S0_l00mkOgP05W`035a6O00BO00DAWa4A5`024@DG00<OGal00QlB8aYK0@0002MK00>1Fe/0
6E/00h5KF`0BF`:10U/01X5K`<2<C0><0/05aP;000F<C8a<S00>aP;000C<3Lc<0`d5]@033KFe00>e
00Gl]_bfo002]P;<00<=c0d00`d3]@8=00>e3KH01ol38`04ob<S8`;o0b<00olS8`028`;o00<Sool0
12<00onOg`02g`03g]oO00?O00>Ogil00ml2W`075a4A4AMO5`04G`037elO00/S2E/4PA=K0@0002MK
00>1Fe/06E/00h5KF`0DF`>10e/2S0A<00><aX`02X`00db<`002aP0:`<K0a/36`<K0aP?00`d01;G0
3L033@0<]@fe3Obe][G6`0g<0Pd00l0=3@03`0?<00<=g?l00ol28`03ob<S008S0_l28`;o0R<00olS
8`028`;o0b<01?lS8b<2o`<S00?ogml02]l7W`<A0el00amO7`027`03GalS00@S2E/5PAMK0@0002MK
00>1Fe/06E/00h5KF`0FF`:115/048a<C4f<C8a<S4b<C8a<S4`2S0o61L000lc0`003aP083Lbe3L36
`<H4`004c4a<C0><00?6]kL01?l38`04ob<S8`;o0b<00olS8`028`;o00<Sool012<2o`8S0_l28`03
ob<S008S00Kog]oNgmh2g`03WmoO00?O00bOga6O4IlG4AMO7el27`03GalO00UK1X4LF`40000WF`03
POmK01UK00>1Fe/05U/0185KPH45F`05CDb<C4d014`7S00?aXc6S<K0a/36`4b<C<K000K600?0a/00
14`3aP03CFI=00==00=<CD`01ol48`;o0R<2o`<S00Co8b<S0_l38`04ob<S8`;o0b<00olS8`028`;o
00<Sool00b<00ooNg`04g`06WmlAga7O19l0214GGelOGamO25/6PB9K0@0002MK00>1Fe/06E/00h5K
F`0FF`04PE]KF`:11E/00de<C@03IP06CDa=S4a=0T`01ha<aTe<S4`018`2C006CDb<C8c01d`6IP05
CFI<c0d00ol38`03ob<S008S0_l38`04ob<S8`;o0R<2o`<S0_l28`;o0Ql00olS8`028`;o0b<01?lS
8b<2o`8S0_l5g`04WmnOg`>O0Q425`9K00>1Fe/015/5PBQK0@0002MK00>1Fe/06E/00h5KF`0EF`03
PE]K00AK0X45F`05ITeVCFH014d01daVCDa=C4d00T`00lI=C@02C@03C4e<00==00e<CDa<CFI=ITeV
CFI=00Oo12<00olS8`02o`<S00?o8b<00R<2o`03Gaoo00@S0_l02Qoo7elOoamO7el2o`<S00?o8b<0
0R<2o`8S00?o8b<00R<00ooOg`03g`BO00?OFe/01E/7PBeK0@0002MK00>1Fe/06E/00h5KF`0EF`03
PE]K00IK0X45F`YV0Td00daVIP03IP04CFI=IPA=26H6o`<S00Co8b<S0_l38`03ob<S008S00?o8b<0
0_l00amOo`047`;o00]O7olOGaoo7elOo`027`03oalO00;o0R<2o`@S0_l00b?oo`038`04omnOW`UK
1H4cF`40000WF`03PE]K01UK00>1Fe/05E/00h5KF`08F`:11E/076I=ITeVCFI=ITeVCFI=ITeVCFI=
ITeVCFI=ITd4o`8S00?o8b<00R<00olS8`02o`<S00Co8b<S0_l2G`0;oalOoamO7eooGal00_l045lO
Gaoo7eooGamOoeooGal28`03ob<S008S0_l28`05ob<Sob<00_l28`03oe]K00=K1X44F`03PE]K035K
0@0002MK00>1Fe/06E/00h5KF`0EF`03PE]K00YK0X45FaAV1_l38`04ob<S8`;o00=O7ol011l2o`8S
0_l075oo7elOoelOGolOGaoo7olOGomO7eooGaoo7el3o`<O0_l00b?oo`038`04ob<S8`;o0b<01OlS
8b?o00B12e/00h5KF`0`F`40000WF`03PE]K01QK00>1Fe/05U/00h5KF`0<F`03PE]K00=K00m=ITeV
CFI=ITeVCFI=ITd01?l28`03ob<S008S00?o8b<00_l04UooGamO7olOGolGGaMO5elGo`AO00Ko7aoo
Gal3o`06GamOoamO1ol01AooGamO008S00Co8b<S0_l28`;o0b<2o`8S0_l28`03oe]K00aK00>1Fe/0
<5/100009e/00h5KF`0HF`03PE]K01IK00>1Fe/03E/2P@=K00>1IVH01VH6o`@S0_l092?ooelOoamO
oelOGomO7eoo7olGoaMO5olGGolOGamOoamO7`;o0QL01OmO7elO00;o0al3o`03GolO008S0_l28`;o
00=O7ol012<2o`8S00?o8b<00R<2o`038ooo00aK00>1Fe/0<5/100009e/00h5KF`0HF`03PE]K01IK
00>1Fe/03e/2P@04Fh5KF`Ko0b<01?lS8b<2o`0C7olOGomO7elOoamOoelOGomO7`02o`<G00MO5eoo
GaOo00AO00ko7aooGaMO5omO7elOo`EO0_l28`;o1El00olO7`027`;o00@OGamO0_l00b?oo`038`04
ob<S8`;o2U/00h5KF`0`F`40000WF`03PE]K01QK00>1Fe/05U/00h5KF`0AF`04POooo`8S00?o8b<0
0R<00olS8`02o`03GomO009O00go7eooGamOoelOoamO00Co0QL03elGGaMO5olGGaOoGamO7`02o`03
5olG008G00GoGamO7`02o`@O00?oGol011l02_lO7aoo7elOGol5G`;o0b<2o`8S0_l38`03oe]K00MK
00>1Fe/0<5/100009U/00on1F`0IF`03PE]K01IK00>1Fe/02e/7o`<S0_l032?ooelGGaMO7elOo`@O
00Ko7eooGal6o`064ALA5a7o0aL02?lGGaOo5eoo15l03_lG5aOoGaMOoamOoaOo0el00olOG`02G`05
oemOGol00el00olO7`02o`07GamO7eooG`02o`8S00Co8b<S0_l28`03oe]K00MK00>1Fe/0<5/10000
9e/00h5KF`0HF`03PE]K01IK00>1Fe/01U/5o`<S00Co8b<S0_l041MO5elGGaMOoelGoamO7ol4G`Go
21L06?lG5omO5eooGaMOoelGoelOGaoo4ALAo`<G00Oo7eoo5a7o008O00OoGomO7eoo008O00[o7alO
oelOoa7o0el01?mOGal3o`038ooo00<S0_l00b?oo`07F`03PE]K031K0@0002IK00>1Fe/06E/00h5K
F`0FF`03PE]K00IK00?oGol00b<00olS8`02o`0C5elGGomO5olGGaOo5eooGamOo`047`0B5a4G4ALA
oa4GoaLA5olG4AOo0QL02?lGGaOo5eoo0el2o`<G013oGaMOoamOoaLAoeoo7eoo0el01?mOGol3G`0>
oalOoaOo7elOoamOoel3o`8S0_l28`04ob<S8`;o1E/00h5KF`0`F`40000VF`03PE]K01UK00>1Fe/0
5U/00h5KF`05F`04oalO7`;o01UO5elGGaMOoelGGaMO5elGGomO5eooGaoo00=O0_l25`04oaLGo`XG
01Co5elGoaMOoelGoelOGolAoaLAo`<G00Wo7olA5a7o7ol00el01?lOGol37`09oalOoeoo5a7o00=O
00?oGol00Ql01UooGamO7`?o00<Sool00b<00omKF`02F`03PE]K031K0@0002IK00>1Fe/06E/00h5K
F`0FF`03PE]K00AK00?oGal00Ul06aMO5olGGomO5elGGaOo5eooGaMOoelGoamOo`027`0DoaOo4AOo
5a4GoaLAoa4G4OlA5ol35`07oelGoaMOo`02G`04oa4Ao`<G00[o5eoo7olA5a4G0_l011mO7ol2G`05
oemOGol00Ul03?lOoa4GoamO7olOG`<O00Go7elOG`02o`<S0_l00elOo`04F`03PE]K031K0@0002IK
00>1Fe/06E/00h5KF`0FF`03PE_o00Co020OGomO5olGGomO5olGGaOo5eooGaOo5elGoaMOoelOo`9O
00?o4A400aL01?lG5ol25`05oaLG5ol00QL03_lGGaOo5eooGaOoGaoo0Q401OlG4AOo00<G0_l0114G
4AL2o`=O00Co7eoo0al01?lO7al2o`0:5a4GoeooGomOo`=O00Ko7eoo7el2o`03GolO00<O0_l2F`03
PE]K031K0@0002IK00>1Fe/06E/00h5KF`0BF`Ko11l08OlG5olGGomO5olGGaOo5eooGaOo5eooGaMO
oelGoamO7`02o`<G017o5a7o4AOo5a7o4ALAoa4Go`035`0:oelGoaMO5omOo`8A01Co5aLGoaMO5olG
4ALAoaOo7elOo`=O00KoGemOoel2o`0<5a4G4OmOoelO5aoo0Ql01OmO7olO00;o0al01_mO7olOG`;o
00>1Fe/0<5/100009U/00h5KF`0IF`03PE]K00aK1_l3G`04oemOG`;o02<GGaMOoelGGaMO5olGGomO
5olGGomO5olGGaOo5eooGamOo`044@04oaLGo`8G00Go5aLGo`025`0>oaLGoaMO5olGGaOo5el2o`<A
00Go5a4Go`025`;o00@G4AOo0QL02?mOGeoo7elO1_l021Oo4ALA5omO0_l3G`0:oemOoaooGomOo`=O
00?o7ol01Al00omKF`0`F`40000VF`03PE]K01UK00>1Fe/02e/01OmO7eoo00<O00?o7al00_l01A4G
4AOo00<G01koGaOo5eooGaOo5eooGaMOoelGoaMOoelGoamO7ol45`0AoaLAoa4GoaLA5olG4OlA5ol0
11L01_lGGomO5`;o11401?lG5aL2o`0=WolG4AOoGaOo7elOo`03G`0>oaLA5a4G4OlG4ALAoel2o`04
7aLOo`<O0ol015lOGol37`08oaoo7eooGolbF`40000MF`Co1E/2PAYK00>1Fe/02U/00omOG`03G`;o
1aL09_lG5olGGaOo5eooGaOo5eooGaMOoelGoaMOoelGoaMOoelOoa7o0a401?lG5ol25`05oaLG5ol0
0aL03?lG5omO5eooGaOo5`;o1A400olAo`02o`>O00Co4Ooo0QL00omOG`02G`0Aoeoooa4G4ALA5a7o
5a4Goel00_l4G`04oeooo`9O00@OGaoo0el00olGG`02o`<O00?oFe/0;e/1000075/00omKF`02F`03
oe]K009K00>1Fh400X4GF`03PE]K00YK00?oGel00_l03QLA5a7o4AOo5a7o4ALA0aL07omO5olGGomO
5olGGaOo5eooGaOo5eooGaMOoeoo4Ol00aL04olG4OlA5a7o4AOo5a4GoaLAoaL01ol01MnOgioo008A
0_l019oOWml2o`0;WolGoelGGomO7el00_l24@0?oa4G4OlA5olA5a4GoelO00Ko0el01OmO7eoo008O
00OoGalOoelO009O00?oFe/0;e/1000075/00omKF`02F`03oe]K009K00>1Fe/00U/2PAEK00>1Fe/0
2E/02?mO7elA5a7o0QL01?lG5ol35`0PoaLGoelGoaMOoelGoaMOoelGGomO5olGGomO5eooGaL2o`04
Wa6Oo`<A00Co5aOo0QL01_lG5aOo5`Ko19l2o`03Wooo00>O00CoWinO0ol01a4G4OlA5ol00aL00omO
G`02o`<A00_o5a4GoaLAoaLA5`02o`05GomOGol00aL02?mOGeooGaoo0Ul02_mOGolOGolOGolaF`40
000LF`03oe]K009K00?oFe/00U/00h5KF`04F`>14U/00h5KF`08F`04oemOG`;o11L0314GoaLAoa4G
oaLAo`8G01[oGaOo5eooGaOo5elGoaMOoelGoaMO5olGG`;o00BO4Ioo0aL01OlA5olG00Oo00NOgooO
WmnO00;o00[OWonOgioOomnO0_l021MOoa4G4AOo0aL00olGG`03o`03WolA008A00So4ALA5olG4@Co
00XOoamO4AMO5eoo0el01OlOGolO00;o00<Ooel00Ul01_mOGeooF`?o;5/1000075/00omKF`02F`03
oe]K009K00>1Fe/01e/2PA1K00>1Fe/01e/3o`08GolA4OlA5ol25`04oaLGo`8G01oo5aOoGaOo5eoo
GaOo5elGoaMOoelGGomO5olGGomO00;o00DAWa6Oo`024@Ko0il01?nOWil2o`03Wooo00BO0_l01Ioo
oa7o00@G00koGooo5a4G4OlA5a7o5`;o00DAWa6Oo`034@03oa7o00Go00TGoaOo4ALA5ol00aL02?mO
GeooGamO0_l02UoooelOGaooGal3o`8O00?oFe/0:E/1000075/00omKF`02F`03oe]K009K00>1Fe/0
2E/2P@iK00>1Fe/01e/02?lA4OlG4AOo0QL03OlA5olG4OlA5olG4Ol00QL04omO5eooGaOo5eooGaMO
oelGoaL01_l01ioOWolAWa400_l02]nOoioOWmoogil2o`03gioO00;o00ROgoooWonOo`BO00Co4A4A
0_l2W`07oaLA5a7o5`03o`:O00Go4IlAo`024@Co1AL2o`0;5a4GoaLA5olGGol015l02OmOoomOoamO
o`03G`0:oemOoaooGomOobYK0@0001aK00?oFe/00U/00omKF`02F`03PE]K00]K0h4;F`03PE]K00IK
00Go4ALAo`034@07oa4G4OlGo`025`04oaLGo`8G00ooGaMOoelGoaMOoelGoaL01ol2W`04oinOW`;o
0Yl2o`>O0_l00iooo`04W`;o00>Oool00il01OnOWioo00>O00?o4A401_l4W`Ko0Yl01?nOWil9o`0@
4OlG4OmO4AOo5a4GoaLAo`8G00CoGemO1?l00eooo`02G`09oamO7omO7omO00;o0Ql2obUK0@0001aK
00?oFe/00U/01OmKFe^1015K0X49F`03PE]K00IK00[o4A7oWaLA5a7o0QL03OlGoaLAoa4GoaLA5ol0
0QL02?lGGomO5olG0ol01mnOgooOWml00_l02YooomnOgiooWml2o`07WmnOgooOW`02o`06giooWmnO
0_l01mnOoooOWml00_l01iooomnOgil00_l02]oooioOomnOgil2o`04goooo`@A0_l05Q7o5a7o5olA
oaLAoa4G4OlA5olGGaL3o`8G0ol01AOo7eoo00=O00CoGemO0_l3G`03oeoo02QK0@0001eK1?l4F`03
PE]K015K0h45F`03PE]K00IK00Oo5a4Goioo00<A00Ko5a7o5ol35`04oaLGo`8G00Go5eooG`06o`BO
00?oWil00_l4W`03oinO00;o0Yl01?nOWil2o`>O00CoWinO0_l00iooo`04W`03oinO00;o0Yl00onO
W`02W`;o0Yl01?nOWil2o`03Wooo00BO0_l2W`03oa7o00<A01Go4ALA5olG4OlA5olG4AOo5a4GoaL0
0_l24@;o00DGoaLGo`02G`08oamO7omO7el2o`<O00?oGol00_lVF`40000UF`03PE]K01AK0X43F`03
PE]K00IK00_o4A7o4IlAoaLAo`025`0;oaLAoa4GoaLAoa401_l01ioOWmoogil00_l01mnOgiooWml0
0_l01YoOomnOg`;o00ZOoooOWmnOoioO0_l00ioOW`02o`0:giooomnOoioOW`;o00OOoonOgioO00;o
00JOoooOWml2o`07WooogioOo`03W`0Goa6Ooa7o4ALAoa4G4OlG4AOo5a4GoaL01?l03AOo5aLA5omO
5olOGol015l00omOo`02o`9O00OoGelOob?o02EK0@0002EK00>1oe/05U/4P@IK1?l01Q7o4IlAo`8A
00So5a4GoaOo5`Ko19l00onOW`02o`>O0_l00iooo`03W`04oinOW`;o00>Oool019l00onOW`02o`>O
0_l00iooo`03W`04oinOW`;o00>Oool00il2o`03Wooo00BO0_l00iooo`02W`04oinOW`;o0Yl3o`05
Wa6O4Ol00Q402OlAoa4G4AOo5`07o`084OlGoa4G4Ol25`04oaLGo`=O00CoGamO0_l00eooo`027`04
oaoo7`;o00<Soe/08e/100009E/00h5KF`0IF`:11Ol03ioOWmooWa6O4OlG4AOo5`05o`07WmnOgooO
W`02o`06gioOWonO0_l02]nOgooOWmoogil2o`03gioO00;o00NOgoooWmnO00;o00gOoonOgooOWmnO
oioO00;o00>Ogil00_l01]oooioOW`;o00[OWooogiooWmnO0_l01]oooioOW`;o00<Aoa400Q43o`03
4OnO00:O00?o5a400ol00ilAo`034@05oa4G4Ol00aL03?lA5omO5eooGaooG`?o00POoa4GoeooG`8O
00@SoolS0_lRF`40000UF`03PE]K01EK1_l3W`;o00>Oool00il01?nO4Il5o`>O0_l00iooo`04W`03
oinO00;o0Yl01OnOWioo00:O0_l3W`;o00>Oool019l00onOW`02o`:O00CoWinO0_l00iooo`04W`;o
00>Oool00il2o`03Wooo00>O00CoWinO0_l00iooo`03W`;o00ROoonOoilAW`;o00JOoilAWol34@05
oaOoWol01142o`035a7o008A00Go4ALAo`025`06oaLG5omO0ol3G`;o0Q401_lOoamO7`8S0ol00b?o
F`0PF`40000UF`03PE]K00mK1_l04]nOgiooWmoogioOomnOgooOW`;o00?OWml00_l02YooomnOgioo
Wml2o`06WmoogioO0_l02IooomnOgiooW`02o`07gioOWonOg`02o`06WmoogioO0_l02YooomnOgioo
Wml2o`03WmnO00;o00WOoonOgooOWml00_l01ioOoonOgil00_l01]oooioOW`;o00lAoioo4IooWa6O
oilAWol00Yl2o`>O00GoWonOo`034@05oaLA5ol00QL01_lA5a7o5`?o00`A5omO7eoo5a4Goel2o`03
7ooo008S00Go8b<So`0PF`40000UF`03PE]K00YK1Ol4W`03oinO00;o0il00onOW`02o`03Wooo00BO
00CoWioo19l00onOW`02o`:O00CoWinO0_l00iooo`04W`03oinO00;o0il2o`03Wooo00>O0_l019oo
oil2o`BO00?oWil00_l3W`;o00>Oool00il2o`04WoooW`;o0il2o`:O0_l3W`;o00>Oool00il02_nO
Wioo4IooWa47o`>O0_l00iooo`02o`044ALAo`<A00Go5a4Go`025`;o00>Oool00QL01OmOGeoo00<A
00Oo7oooGolS00;o00<Sool00R<00omKF`0MF`40000UF`03PE]K00EK1Ol06YoOWmoogiooWmnOgooO
WonOgooOWmnOoioO0_l01YoOWmoog`;o00VOgioOomnOoil00_l01mnOgiooWml00_l00ioOW`02o`06
goooWmnO0_l03MoooioOWonOgiooWml00_l00ioOW`02o`06goooWmnO0_l02MoooioOomnOg`02o`0:
WooogioOWonOg`;o00>Ogil00_l01]oooioOo`>O1Ol00mnOg`02o`06WooogioO0_l24@03Wa7o008A
00Go5a4Go`035`0DoaOooa7o4OlA5omO7olAoa4Goel2o`048ooo8`;o00<Sool00R<2oaeK0@0002EK
00>1Fe/00e/2o`>O0_l00iooo`04W`04oiooo`>O00KoWinOoil2o`BO00?oWil00_l3W`;o00>Oool0
0Yl01?nOWil2o`03Wooo00>O0_l00iooo`04W`04oinOo`>O00GoWinOo`02W`;o00JOomnOgil2o`06
WooOWmnO0_l2W`04oinOW`;o00>Oool00il2o`03Wooo00BO0_l00iooo`03W`;o00BOoonO0_l3W`;o
00>Oool00il2o`07WoooWonOo`034@06oaLA5olA1ol2W`05oa4A4Ol00QL2o`8A00Co4A4A0ol28`;o
00@SoolS0_l38`03oe]K01YK0@0002EK00>1Fe/01U/02?oOWmnOoioO0_l02IoOWmoogooOW`02o`03
gioO00;o00VOoooOWmnOoil00_l02MnOgiooWmoog`02o`0?WmnOgooOWonOgioOomnO00;o00KOWonO
gil2o`05goooWol00Yl01onOWioogil00_l3W`03oioo00>O0_l01YooomnOg`;o00JOoooOWml2o`07
WooogioOW`02o`09goooWmoogioO00;o00JOoooOWml2o`06WooogioO0_l00iooW`02W`03oilA00Ko
00>Ogil00_l02moooa7o5a4GoaLA00;o00JO4OlA5a44o`<S0_l012?oob<2o`8S00?oFe/06E/10000
9E/00h5KF`09F`06omnOgioo0Yl2o`03Wmoo00>O00WoWiooWmnOgol00Yl2o`>O0_l00iooo`02W`04
oinOW`;o00>Oool00il2o`0<WooogooOWooOWmnO0_l01MnOWioo00?O00WogiooWmooWol00]l00onO
g`02o`03ginO00;o00BOoonO0_l3W`;o00>Oool00il2o`03Wooo00>O0ol019oooil2o`>O0_l00ioo
o`03W`;o00>Oool00il2o`04WoooW`;o0il2o`07WooooilAo`034@03oa7o00Go11400olAo`03o`03
8ooo008S0_l012?oob<2o`8S00?oFe/065/100009E/00h5KF`09F`04oioOW`;o0il01?oOWml2o`09
gooOWooOWmoo00>O00gogiooWmnOgooOWonO00;o00KOWmnOoil2o`05WonOWol00il03onOWooOoioo
WmnOgioOo`02W`03oinO00Go19l3o`09giooWmnOoioO00;o00JOoooOWml2o`06WooogioO0_l01Yoo
omnOg`;o00BOoooO0_l00ioOW`02o`06goooWmnO0_l01]oooioOW`;o00COoonO0_l00mnOg`02o`06
WonO4IlA1Ol00mnOg`02o`05Wooooil00_l00aoo8`02o`088ooo7omO7el2o`8S0_l00b?oF`0HF`40
000TF`03oh5K00]K00?oWol00]l01onOgioogol00ml03OnOWioogonOgiooWml00_l02IooomooWmnO
g`02o`03Wooo00;O00>Ooml00]l02OnOgooOWonOg`02o`;O00GoWmnOo`02W`04omoOg`;o0il2o`03
Wooo00;o0il2o`05WoooWol019l01?nOWol4W`04oiooo`>O0_l00iooo`02W`04oinOW`;o00jOoooO
oioOoioOWooOW`;o00>Oool00il2o`04WoooW`;o0il2o`03Wooo00>O0_l00iooo`02o`<A00Co5aLG
0ol021ooGaooGamO0_l27`;o0R<2o`048oooF`F14E/100009E/00h5KF`0;F`03omoO00;O00?oWil0
0_l00mkog`02g`09oioOWonOoioo00>O00Go4MlAo`02W`07oioOomkOgP03g`04omlAo`>O00?oWol0
1Ol03=nOgioOomnOoioOo`:O00?oWml01?l00mnOg`02o`06WooogioO0_l019oooml2o`03WmnO00;o
00GOoonOg`02o`06WooogioO0_l019oooml2o`05gonOWol00il02ooOWonOoioOFonO00;o00WOoonO
gooOWml00_l01IooomnO00?o00FOoooOW`02o`0;golAWolG4OlA5a400_l2G`06oalO7olO0_l011oo
ob<2o`<S0_l00b?oF`0EF`40000TF`03PE]K00aK00?ogml00ml2o`04g]oNo`?O00OoWinOomnO00?o
00jOoooOWmnOoioogooNo`;O00OogmooWmoo00CO00Cog]oN1=l02OoOgmoogioOo`02W`;o00COWinO
0_l00iooo`03W`;o00>Oool00il2o`04WoooW`;o0il2o`03WonO00:O0_l02iooomnOgioogioo00>O
00Cogmoo0]l00ooOW`04o`0<gooOgonOgonOgioO0_l02]oogioogiooWml2o`03Wooo00>O00Ko4A4A
oa47o`<O00?o7ol00_l00b?o8`028`;o00<Sool00R<2o`038omK01AK0@0002AK00>1Fe/035/00ooO
g`03g`07ommaomkOo`02g`04oioOo`;O00coWmnOomkOomlAga43o`06g]oogmko0ml01?lAgol2W`0A
omkOomoNomkOg_nOgooOWml01_l02=oogioOWonO0_l00mnOg`02o`05Wooo4Ol00Yl00onOW`02W`;o
00>Ooil00il00ooNg`05g`0;oa7OomnOgooO4Ol00Yl01_nOWooOo`;O00CoWooo0il02?nOWonOoioo
0il00onOW`02o`05WmnOgil00_l01MoooioO00;o00^OooooGaOo7elOo`02G`?o00<Sool00R<2o`04
8ooo8`;o6U/1000095/00h5KF`0=F`03omoO00;O00Oog]kog]oo00;O01?oWooOWooOWmoNgmkOoioO
Wmoo00;N00COg]oo0]l04OoOgooOWooOomkog]oNgmko00;O00Sogmoogioog`:O0_l019oooil2o`>O
00WoWooogonOgol00il01_oOgooOW`;o0ml01ooOWooNgol00]l02onOgiooWmooWmoo00:O00?ogml0
1Ol029oOWmooWmoo0]l00ooOW`02o`?O00?ogol01_l00iooo`02W`;o00jOooooGolOGaMO5elGo`9O
00Go7aoo7`02o`038ooo02=K0@0002AK00>1Fe/03E/01?oOgml2o`06gg7Og]oo0ml4o`0GWmiagg7o
g]ooga7O4OoNomkOg_oNgol00]l01OlAga7o00CO00_NomkOomoNoioOW`02o`09gooogooOWmnO00;o
1]l02a7O4OnOgioo4Moo00:O00?oWol00]l01_nOWonOo`;O00?Noml00]l03?oOgooO4OnOgooO4@?o
00GOomoOo`04g`04oioOo`>O0_l01IoOoonO00;o00JOoioOWml2o`07Wooo5olGG`03o`0=GolGoelG
oaMOoelOo`02G`;o:5/1000000=Koe/015/01?mKFe/2o`03FomK01AK00>1Fe/03E/01OoOgmoo00CN
00?ogol00ml2o`05g_oOg_l00]h01ooNgonOgil00_l2gP04gmkOo`;O00SogmoogioOo`?N00KogooO
g_l2g`03omoO00?o00WOoioOWooOWol00ml03OoOgonOgioOWooOWol00Yl00ooOg`02o`>O00?ogml0
0_l2gP04omoNo`;O00[ogiooWmooWmnO0_l01]oog]oNo`;O00?ogil00_l00ioOo`02g`;o00OOWonO
gioo00?O00CoWmoo0aL00olGo`04o`0<5omOoaOo5eooGaOo0Ul01?lOoolYF`4000000e_oF`04F`05
oe]KFol065/00h5KF`0=F`0<omoOgooNog7Oomoo0ml06ooOg_oOg_oOLMoogmko4Moog_oOomoNomkO
o`02g`03oa7O00;o0ml02On1gooOomoNg`04o`0;4OnOomnOoioogol00]l04?oOgmoogolAgooOWolA
ga42o`;O00OogmooWooN00CO00?Ngol00]l03_oOgooO4OnOgooOg]oo0ml02ooOgooOoiooWmnO00;o
0]l3o`05WonOgol00Yl01ooOoolA5a400_l3W`07oaLGoeoo5`02o`0:5olGGomO7omOobYK0@000003
FomK00AK00GoFe]Ko`0HF`03PE]K00iK00Kogmoog_l2gP03omoo00;O00Sog]oNomoNg`?N00kogmko
gioog_oNomkOo`;O00CogmoO0_l00moNo`02gP06omoNomko0]l4o`:O00GogmooW`02o`;O00GogmoO
o`02g`09omoogioogioO00Co00COWmnO1?l00moNo`03gP03gmko00;O00OogiooWmnO00;o0mh01]oN
omoNo`;O0_l01IoOoioO00;o0ml2o`:O00CoWioo0]l2o`03WolG008G0_l3W`04oa4G4@;o00PGoaMO
oelGo`=O0_lZF`4000000e_oF`04F`05oe]KFol065/00h5KF`0>F`03omoo00;N00KoLMoogol2g`03
omkO00;o00cOg]ooLMoogmko4Ol2gP0:omoNomkog]oNo`;O0_l2gP09omoOomiKomoN00;o00OO4Moo
ga7o00:O0_l01W7Og]oNo`;O00Cogmoo0]l02?oOomnOomoo0ml2o`ON00OogmoOomoo00;O00KogmoO
oa42o`07gmkOomoNo`03g`;o00GOomnOg`02o`0>g_oOgooOomnOoioOoil2o`<A00?o5ol00]l01OnO
Wioo008G00ko4AOoGaOo5eooGamOob]K0@000003Fooo00Go0e/00omKF`0FF`03POmK00iK00Kogoma
g_l2gP03omoN00;o00WOg]koLOoNgol00]h01_oOg_oOo`;N00Kog]kogol3g`08omooomkOg_l3gP;o
00WOoooogooOWol00Yl3o`?N00GogmoOo`02g`09omoOomnOoioO00;o00?Ngmh00_l01G7NLMko00;N
00GogmkOo`02gP03omko00?O00?oWol00_l00mkogP02gP06omoNomoN0_l00moNo`02g`;o00?Ngmh0
0_l00mnOo`03W`04oiooo`:O00?oWa400ol00mnOo`03W`Co00`A5olGGaOo5eooGol/F`4000000e_o
F`04F`05oe]KFol065/00h5KF`0>F`03omoo00;N00KoLMoogmh3o`0@LOoNg_oNgomagooOg_lAo`;N
00Sogmkog]oog`?o00?Nomh00]h00ooOg`06o`;O00Co4MlA0_l4gP07og7OomoNo`02g`04omoOo`;O
00Cogooo0]l00omagP03gP03LMko00;N00Gog]kNo`02g`03omoo00?O0_l03=kogmkOomkOg_oNg`;o
00CNomkO0ol01MoNoooO00;o00FOgiooW`04o`>O00?o4A400_l3g`0AoinOWolAWolA5a7o5eooGaL0
0_l]F`4000000e_oF`04F`03oe]K00?o5e/00h5KF`0>F`06omooLMko0mh03OoNomkog_oNLOoNgol0
0]h01OoOg]oo00?N00Kog]kNomh2o`03g_oN00;N00CogmkO0_l04mkOomkOomkOomnOog7NLOoOg_l0
0]h01?oOgol2g`06omoOgonO0_l01=kOg_l2gP07og5aog7No`03gP04omkOo`;N00?og_l00ml02?oO
g]oog]oN1ol00mmag`02o`;N0_l01=oNgol2g`03oioo00;o00FOomoOo`02W`Co00GOomnOo`03W`09
oa4Aoa4G4OmO00Go;U/1000000=Koe/025/00omKF`0FF`03PE]K00mK00?og]h00]h01OoOLOoN00?o
00maomkNomkOog7OomoNgol00mh01?oOg]l3o`?N00?og]h01_l01mkogmkOg_l00]l2o`05g_oNg_l0
0mh01_oOomoNo`?O00?ogml00_l01G7OLOoN00=a00Sog]koLMiao`;N00Cog]ko0]l01?oOg_l2g`08
omkNg_oNgol2gP07omkOg]oogP02o`06gooOg]oo0]l00ooOg`02o`05g_nOgol00Yl00onOo`02g`04
omoOo`;O00_oWiooWonOoa4G4@03o`035omK02mK0@000003Fooo00Go0e/00omKF`0FF`03PE]K00mK
00KogW7NLOl2gP;o00_NLMkoLMiaomkOo`03gP04omkoo`CN00Cog_oo17401OoNooma00;o0mh02_oN
gooOg_oOg_l2gP0:omiag]oNgooNo`?O00Gogmoog`02o`;N00GoLMiao`02gP03og5a009a00?NLOl0
0]h01?oNgol3gP0<omoogooNomkOomko0]h2o`04g]oNg`;o00CNomoo0mh00ooNg`04o`06g]oogioo
0]l3o`09gmkog]oogioo00:O00gogolAoa4G4OlAoeoo031K0@0002AK00>1Fe/04E/2o`03g_oo00;o
00KNoomag_l3gP06omoNomma0_l00g7No`03gP;o00=ag_l00]h00ooNgP02o`?N0_l02=kog]oogmko
0]l01=iag_l3gP0;omkNomoogmkOoml00ol3gP06og7NLMko0g401ooNg_oNLOl00]h01?oNg_l3g`07
omkoomiao`02gP?o00WNomiaomoogol00]h01moNomoNgol00]l02_oNg_oOg_nOgol2W`03omoO00GO
00Cogmoo0Yl02?nOoilAoaOo0a400omKF`0_F`40000SF`03PE]K01EK00Sog_oNomiao`;N00SoLMko
gmkogP;o00CNLMko0]h2o`06gW7Nog7o0g42o`0=g_oNg_oNomkOg_oNg`03o`?N00OoLMkog]oo00;N
00?ogol00_l01]kog]oNo`=a00?oLOl00mh01omaLOoNLOl00]h01_oNgmkogPCo00CNLMia0_l0177N
LOl4gP03omoN00;N00Gog]oNo`03gP?o0]l01_oNgooOW`;o00gOomoNomkOomoogioo00:O00?ogol0
0Q43o`<A00?oPE/0;e/100008e/00h5KF`0HF`07omiag_oNL@08o`03gW7N00;o00IaoooNLMh2o`03
LOoN00;o00CNoooo0mh00ooNg`07o`06LOmagW7o0]h01_oNg_oOL@;o013Nomiag_oNomgoLMiagW7o
0W401ooNg_oNLOl00mh00ooNgP02o`05g_oNLMh00_l01G7Oomia00;o01CNoooNog7oLMiaomkOomkO
g_oNo`;N00KogmkoWml4o`;O00Cogmoo0]l01OoOoioo00:O00?oWa400_l01Yoo4OmKPC1K0@0002=K
00>1Fe/065/01OmagW7N00;o00=aog400g42o`03LMia00;o00GNomiao`03gP03og5a00;o0mh02OoN
g]kog_mag@05L@03gW7N00;N00OoLMkog]oo00;N00GoLMiao`02gP;o00?MUOl017401Mkog]ko009a
00CogW7o0mh01?oOool3L@;o0W400ooNo`02gP03og5a00;o00Eaog5ao`03gP04omoNo`;N00Cog]oo
0]l01_oNgmkoW`Co00_Og_oNgooOg_nOg`02o`04Wmoo4@;o0Yl2o`9K00>1Fe/0;U/100008e/00h5K
F`0IF`0Kog7ogG7ogG7oLMkogW7NomiagW7oLMiaog7o00?N00KoLMiag_l4gP06oiGogG7o0W401oma
g_oNLOl00]h02?oNg_oOog7o0]h3o`;M00UagG5agW7oLOl00W401ooNg_oNLOl00mh2o`06UOmagW7o
1742o`0CLOoNg]goLMgogG7oLMiaomkOgP03o`;N00[og]kogmkOomnO0ol2g`04omoOo`;O00?ogml0
0_l2W`;o00>Ooil00_l3F`03PE]K02iK0@0002=K00>1oe/06U/02_magG7Mog7oLOl4L@03og5a009a
00Gog_oogP02o`9a00CoLMko0mh02_oNg]kogOoMLOl2L@04omiao`;N00OoLMkog]oN00;o00gNomko
g9EaUOoMUMgo009a00?og_l00]h01omaLOoNLOl00mh01_maLG7oL@;o17402?maog6EgIGo1W401_oN
g_oOgP;o00GNomkOo`02g`06omkOg_nO0_l03Moogmkog]oogmkoWml00_l01IoOoioO00;o1E/00h5K
F`0^F`40000SF`03PE]K01YK00J1Fe_ogG43o`0BgW7NLMgogW7Nomiaog7NLOoN0ol01W7Nomiao`;N
0_l01YGogG7Mo`=a00GNomiao`03gP03omkN00;o0W404?nEUOnEgOmagG7ogW7oLOl2L@07omkNomia
o`02gP0:oiGoUG7og_mao`9a00SoUG7ogYGog@9a00WMLOmagOoNLMh00ol2gP04omkNo`?N00?og]l0
0ol01=oNgol2g`06omoOomoo0]l2o`:O00CoWooo1U/00h5KF`0^F`40000SF`03PE]K01YK00>1Fe/0
0e/01ooMog7MLOl00W400omao`02L@06gW7NLOoN0_l01IGMog7o00;N00?og]h00_l2g@04og7Mo`9a
00?oLOl00]h05_magW7ogmkoLMiag9GLog6ELOnEgOl2L@03omko00?N00_oLG7oLMkog_nEo`02L@05
og7oUOl00W401?maomh2U@04oiGMo`9a00CoLG7o0mh02OoNomoNomkOo`03g`04omoNo`;N00Wogmko
g]oogmh01_l00mooo`02o`QK00>1Fe/0;U/100008e/00h5KF`0JF`03PE]K00EK00GoLMeag@05o`0L
LMgoog7NLMkoLIEaomkogW7og_nEoiEaog7Mo`9a00Kog_oNLOl3gPGo00=aool00iD03?oMUOoMLOoN
LOmao`=a00Kog]koLMh2o`:E023oUG6EoiEaog7oLOoNombEg=eaomeaog7Momiag_oOo`;N00Cog]ko
0mh02?oNoooOLOoN2Ol2g`03omnO00;o2U/00h5KF`0^F`40000SF`03PE]K01YK00>1Fe/025/01OnE
gIGM00;o00Maog5aog7o00:E00OMUMgoLMko00;N0_l029GLomgoLMgo0W400omao`03gP04omiao`CM
00goUOnEg9GoUG7oUMgo00=a00?oLOl00]h01_maLOmagP;o0iD01?maool3U@;o00AaoiGo0iD00ooM
o`02L@04og5ao`?N00Wog]kog_oNgol00ml2o`03LOoo00?o00WOg_oOg_oNgol00]l00onOg`02o`YK
00>1Fe/0;U/100008e/00h5KF`0JF`03PE]K00YK0_l04W7MLOmaUG6EombEog6ELOoNL@Co00WLUMco
LOmagOl00W404_oNLOmag_oNoiGoLIGog9GLo`:E00kogIGogG7ogW7NomkoL@So19D2o`05g?nELID0
1?l05Mcog9GLog7ogG7oLMgogW7og]oNo`02gP04omkNo`;N00_og]koLOoNomoNo`02g`03omoo00Oo
2e/00h5KF`0^F`40000SF`03PE]K01YK00>1Fe/03E/00ooLo`04L@0GUMbEomfEgOmag]bEg9GLUMco
gOmagOl00g400ooNo`02gP;o01CLUOoMomcoUMcog9GoUG7oUMfEo`9a00OoLOoog9Go00>E0_l00iGo
U@02U@03oiFE00;o00>Eom`00_l00iGoo`02U@03omgo009a00CoLG7o0]h03OoNg]kog]oogmkogol0
0W402?oNLG7NomoN1OlCF`03PE]K02iK0@0002=K00>1Fe/06U/00h5KF`0=F`06ombEoiEa0_l01mbE
g?nELID00ol03MbEombEg?maog7MLOl00W46o`BE00Oog>cLUMco00:E00WogIGogG7Mog401?l019GL
UM`2o`03UMco00;L00?og=`00_l019Goool3g00AomcLoiGLog7ogG7oLMgogW400_l00moNo`02gP03
omkN00?o0]h00omaL@02gP05omoNog400_lDF`03PE]K02iK0@0002=K00>1Fe/06E/00h5KF`0?F`06
oiGLog7o0]`01YGLoiGMU@;o00oLUMbEg9GLomgoLMeaog400_l3U@03oiFE00;o1M`02ooLombEoiEa
UOoM00?o0]`00onEg002o`;L00CoUMbE1Ol00iGog002o`08]ooLg?nEg?l2U@03omgo009a00GoLG7o
gP03o`;N1ol2L@;o00Iag]iagW44oaIK00>1Fe/0;U/100008e/00h5KF`0IF`03PE]K00mK00GoUMbE
o`02g008oiGLoiEaUOl2g00<oiGLoiGLog6Eomea0_l2g005omcLg?l00]`02NcLomc/g?oLo`03U@03
oiGM00;o0]`02ooLg=cog?nEg9GL00;o0m`2o`?L00GoUOoLo`02g003oiGL00;o00[Log7Mog7Momea
1?l00moNo`02g@04og7Mo`9a0_l2L@04omkNgP;o65/00h5KF`0^F`40000BF`Ko0U/4o`EK00>1Fe/0
6E/00h5KF`0?F`05oiGLUOl00]`02?nEg?nEgIGo0]`01ooLUOnEg?l00]d01?oMool4g0;o0n`01Oo/
g>co00;L00Sog?oLUMcoL@;o00CLk=c/0_l01mc/omcog?l00]`01Ncog=co00?L0_l019Go]ol2g003
oiGL00;o00FEomfEo`02L@03og5a00;o00?Nomh00_l2g@06og5aLOma0ol01IGoLMia00;o65/00h5K
F`0^F`40000BF`03oe]K00AK00?oFe/00U/01?mKFe/3PAYK00>1Fe/03e/00onEg002o`;L00SoUMco
UG7o]`;L00WoUMcoUMcoLID00_l00ncLo`03g004k=c/o`;L00_og>cok=cog9GoU@03o`03]mbg00;o
00?Lk?l00m`5o`?L00cok=cog?oLoiGog?l2g00?omcLoiGLog7Mog7Momea00;o00EaoooMo`02g@03
og7M00Co00Aaog7o0]h2oaUK00>1Fe/0;U/100004e/00omKF`03F`03oe]K009K00GoFe]KP@02F`B1
5U/00h5KF`0?F`0OoiGLoncog?nEg?nEgOo/omcog9GoUMbEomgog>cLo`02g0;o1N`01?oLk?l3g007
oiGoomc/g002o`?/0_l03>coomc/g?o/g?o/g0Oo00GLUOngo`02g009oiGooiGMUOnE00So00GNoonE
o`03g@;o00?LUOl00_l3U@;o6e/00h5KF`0^F`40000DF`;o0e/00omKF`02F`05oe]KFh401U/4PA9K
00>1Fe/045/2o`03g;Oo00;L00?og9D00_l00mbgo`02g008ombEombEoiD2o`05k=cog?l00^`03?o/
g?oLomc/oncLk0?o00o/g>c/omc/g>cok=c/g?l00^`01_o/g?oLo`?L0_l01kOoUOngg?l00]`02OoL
oonELIGog@02o`03g]co00;N0_l01YGogG7og@;o00ZEg?oLUOnELIGo75/00h5KF`0^F`40000FF`04
oe]Ko`AK00GoFe]KP@0:F`>13e/00h5KF`0@F`;o0^`01_oLg?oLU@;o0n`02?oLoiGLombE0_l2g003
omc/00;o00?/g?l00^`01_o/omc/o`;L1?l01^cLk>cLo`;/00?ok?l00^`00oo/o`02g004omcoo`;/
00?ok?l00n`2o`03k;Oo00;L00CoUMco0iD2o`03LOoo00Ko00=aool00ol029GLUOnEomco0iD00omK
F`0JF`03PE]K02iK0@0001MK00?oFol015/01OmKFe^100eK184;F`03PE]K011K00Go]mbgg006o`04
]mbgg0Wo1>`3o`?/00Wok=cog?oLk=`00_l05=c/oooLk=cok?o/omc/omcok=co0n`01Oo/k>co00?/
00?ok=`00_l00kOLo`02g003omcL00;o00CLgOma0_l00iGLo`03U@?o00CLUMbE0_l2g007oiGLoiEa
o`0MF`03PE]K02iK0@00019K00?oFe/00U/00omKo`04F`05oe]KFh404E/4P@MK00>1Fe/045/00oo/
k002k006okNgonco0n`2o`:g00Cok=c/0_l03;Jg][Oo]ooLk=c/o`;/00Cok?o/0ol03>co]kOog>co
g?o/o`;/00?ok?l00^`00ooLg002o`08g>coomc/g>`2o`05]oo/]ol00]`01_nEg9GoU@?o00OLomcL
oiGL00;o0]`00ooLo`02g004omcLo`?L0_lNF`03PE]K02iK0@00019K00?oFe/00U/00omKo`04F`05
oe]KFh405E/4P@=K00>1Fe/04E/07ooLokKok;O/oncog?ngonbgk?o/okNf]ong]_ngk?l00^`8o`04
k;O/o`>g00?ok=`01?l02NcLk=cog>cLk002o`;/0_l2k003onco00:f00Jg]_ngg?l3g003omcL00;o
00>Eool00]`00ooLo`02o`08g?oLk=cog?l2g006omcLombE0_lNF`03PE]K02iK0@0001=K1?l3F`Co
15/00h5KF`0GF`B155/01?ng]ol4]`?o0kH03_ng]kOo]ong][Oo]kKo0[L2o`>g0_l01kOoo?ng]_l0
1;L2o`>g00Co]ooo0kL2o`03k?o/00;/00?ok>`00^`02ong]_nf]oo/]nco00;L00Cog9Go0YD2o`09
g>coomc/g?oL00?o00GLk=cog007oamK00>1Fe/0;U/100008U/00h5KF`0JF`F145/02ong][Oo]nbg
okKo00>g01;o]nbgokNfokNfokJgonbgokL3]@06o;Glo;Ko0kH02_ng]kOo]_ng]_l3]`03okNg00:g
0_l01KKo]kJg00;o00>g][H00[H01onf]ooL]ol00]`01_oLoooLU@;o00SLoncok=cog0;o00G/g?oo
g002o`04g?nEL@;o85/00h5KF`0^F`40000RF`03PE]K01YK00>1Fe/00U/3P@eK00Go]kNgo`02]`;o
00>g]_l00[H00ong]`02o`:g00Wo][Oo]kKo]ol00[L03One3Onfo?ol]_nf]ol00[L01?nfool2]P05
okJf]_l01;H01Ong][Oo00:g0kH02ong][Oo]kKog>co00;L0_l00mc/o`04o`0?k?oLk=cog>cog>co
g>co00:E1OlQF`03PE]K02eK0@00029K00>1oe/06U/00h5KF`05F`B12U/02onf]ongokKlokKo00:g
017o]onfo?nfokNfokJgonco]P02o`:e00Oo]Oco]_co00:f00?o]ol00[H02_olokJgokOo]_l2]`;o
00Fg][Oo]P02o`04][Nfo`:f00So][Oog;Oog0;o0n`2o`05k?o/okL00_l2k0?o0^`02OoLk?nEg?oL
k002ob5K00>1Fe/0;E/100008U/00h5KF`0JF`03PE]K00UK1846F`04okNg]`;o00Gl]_nfo`03]P;o
00?l]_l00[L01_ng]_nf]`;o01Jgoone3KFfo;Ko]_nf]kKo][Oo]KKo0[H01OnfokGo00:f00Oo]_nf
]kKo00:f00Wo][Ko][Oo]kH01Ol01KKok=c/00;o00G/okNf]`02o`;L00Wo]_oLk?oLk?l00YD00oo/
g002ob5K00>1Fe/0;E/100008U/00h5KF`0JF`03PE]K00eK1842F`09okJg]_ol]_co00:f1?l01_bf
o?nf]`Wo00>dokD00[D01_ol]Oolo`:f0_l2]P0JokKlokJgokOo]_ngokKlokJg]_ol]_ng]_l2]P0:
okJgokFfokNfo`?/0_l01Nco]kJg00;o00G/okNgo`02k005omc/oiD00_l00mc/o`0RF`03PE]K02eK
0@00029K00>1Fe/06U/00h5KF`0AF`:100?o]kL00_l01kKl]_nf]ol00[D01Onfo;Ko00:g0_l01[Ko
][Ffo`>d00Wo3KGoo;Ko]_`00_l02;JeokOo]KKo0kH04?nf]OnfokFfokJgooco]_l2]P04okJg]PCo
00ReokJfoncLk0;o00NeokNfokKl00;o00Zg]_oLk?oLk?nE0_l00ncLo`0RF`03PE]K01QK1h4>F`40
000QF`03PE]K01]K00>1Fe/055/2o`:d00Co]_bf0ol01kD=]Onfo;H00_l2]@06ooco]_l=0k@05One
]Ool]Ool]_ol]Obeoobfo;Ko]`02o`03o;Kl00;o00>fo;H00_l2]@07okKlokJgo`02]PCo00FfokNf
o`03k00;o`feokNfokFfokH00kL01_o/omc/g0?o00?Lk?l08U/00h5KF`0=F`^15E/100008E/00h5K
F`0KF`03PE]K01AK00?o];@00[@4o`03c?ne00>e1?l01;D=]@d3o`033Lco00:d00[o3KGoo;Ko]_co
0Pd01?ne3KD2o`03]Ooo00>e00So]_nf]KJeo`?l00?o]_l01ol01@gookGo00:f00Gok=c/o`02]@0A
okNfokKl]_co][Ook=cok=`00ol00ncLo`0RF`03PE]K009K2h4PF`40000QF`03PE]K01]K00>1Fe/0
55/00ond]002]003olc<008=00Wo]@fe3Ol=c?l01;D2c0<=00Co];Co0[D02_ol]Oolo`g<3Ol33@04
o`goo`>e0_l00kGo]@02]@;o00Zeooneolco3L3o0Pd02Ol=okFfokNfo`03k0;o00ZeokNfokFfFkKo
0[L01_o/k?o/g0?o00?Loe/06e/<PB]K0@00025K00>1Fe/06U/00h5KF`0EF`03okBd00:d00Coc0go
0/`01One]KGo00<=00?o3KD00_l01@go3L`=00:d00Oo3KD=okKl00;o0`d03one3KGo3Ol=c0g<o`fe
3@03o`03a/3o00;000Coc<co0/`01_o<3Ol=o`:e00Oo][Kok=c/00;o01FeokNfokKoFoco][Ook=co
k=co]n`00_lAF`^11e/00h5KF`0]F`40000QF`03PE]K01YK00>1Fe/05E/00ond]002]004olc<o`8=
00?o3KD00_l02Pg<3Oneolcoc?l33@03okCo00>e00?o]O`00_l010g<ool23@04o`d=]@;o0Pd01_ne
3KGo]@?000[o`<Ko3Lco3L3o0Pd02Ol=okFfokNfo`02k00=o`go]Ong]_neoobfo`02]`03onc/00Co
00Bgk?oo1U/;PA9K00>1Fe/0;E/100008E/00h5KF`0JF`03PE]K01EK00Co];Bd0_l00l`=c002c006
okFeolco0Pd01Ol=ol3o00<=00S<3Ondo`fe3@Co0`d2o`04]@go3@;o00k0o`g<3One3Ol=`<K0o`;0
00Coc<co0/`01oo<3Ol=okD00ol05kKok=co3OneokNfokKo]_co][Ook=co00:f00Co]ooo1h4MF`03
PE]K02eK0@00025K00>1Fe/06U/00h5KF`0FF`06okBdolKo0/`03ol=o`feo`goc0g<ol3<o`02c006
o`d=okCo0kD3c004ol`=c0;o0Pd01ol=3Ol=`?l00Pd01_l=o`g6o`;000[o`<Ko3Lco3L3o0Pd01?l=
okD3o`0A][Ook?l=okGo]onf]OolPOl00[L00oo/o`05obIK00>1Fe/0;E/100008E/00h7oF`0JF`03
PE]K01IK00_o];Co`?l=c?o<o`02]@03olco00<=00Coc<3o0Pd02?o<3Ondo`fe0_l00`g<o`023@07
olco]@goc002o`0>`<coc0go]Onea_o6`<H3`003olco00;<00Koc0go3Ol3]@08okJfomco3Ol2]@;o
00Sl]_nfo?nf]`;o00>eoe/0:E/00h5KF`0]F`40000QF`03PE]K01YK00>1Fe/05U/01_nd]?o6o`;<
00[o3Ol=ol`=ol`=0_l00l3<o`02c004o`d=o`:d00Go]Oo0o`02c005o`goc0d00_l23@;o00<=`?l0
0Pd01_l=ooo6o`C000S6`?o<o`g0o`8=00Wo3One][Go][L00_l23@03okD=00;o00Rf]Ool]_co]`?o
:e/00h5KF`0]F`40000QF`03PE]K01YK00>1Fe/05U/03Ond]?o0o`g<olco]Ol00/`00ol=3@02o`03
c<3o008=00Coc0go0[@2o`08`<coc0go3Ol2c0?o00[<ooo0c?o<3One0_l01/Koa/36o`;000?oc?l0
0/`01_o<3Ol=o`>e00?o][H00_l23@03okFe00;o00_l]_nfo;Ko]oneo`0[F`03PE]K02eK0@00025K
00>1Fe/06U/00h5KF`0FF`03okCo00;600Coc<co0Pd2o`05c0goc?l00/H01/3<`?o<o`<=00Co]?oo
0/002?o<c?l=ol`=0_l01`goc<co`?l00`d3o`;60l002Oo6`?o<o`g0o`023@09o`go]KJeokJg00;o
0Pd00one3@03o`05]Ool]_`00ol00kGoF`0ZF`03PE]K02eK0@00025K00>1Fe/06U/00h5KF`0FF`03
okCo00;000Co3Lco0/`2o`?<0_l2`004ol3<o`8=00Go3Lco]002o`07`<coc0g<o`03c0;o01?<olc0
olcoc0g<ohcoa/3o`<Ko00;000?oc?l00/`01_o<3Ol=o`>e00?o][H00_l23@03okFe00?o00Nfo?ol
]_l=00;o;5/00h5KF`0]F`40000QF`03PE]K01YK00>1Fe/05U/00ondo`02aP0;olc<c?l=o`g<3L`0
0_l2aP04olc0o`;<00?o3@d00ol4`007olcoo`g<3@02o`093Oo<c?o03Ol=00;o00G6olK6o`02`009
olK0olco3L3o008=00Wo3@go][Go]KL00_l23@03okD=00;o00Zfooco]_co3Lco;5/00h5KF`0]F`40
000QF`03PE]K01YK00>1Fe/05U/00ondo`02`007o`g<3Oo<o`04c008ol30`?o0c?l23@Co0lH2o`03
`?oo00?600_oc?o0ol3<`?o<`002o`0:c?n<olK0ol36o`;000?oc?l00/`01?o<3Ol23@03okFe00Go
0`d02Oneooneoocoo003obiK00>1Fe/0;E/100008E/00h5KF`0JF`03PE]K01MK0_l2aP04olc<c0;o
0/H01?o6S?l3aP04olc0o`;<00CoS?o60_l02LKool36`?o0o`04`004olc<c0Ko00=<a_l00/H03?o0
`?o6`?o<o`g0o`8=00_o3@go][Go3Oo0o`033@07o`gookKoo002oc5K00>1Fe/0;E/1000085/00h5K
F`0KF`03PE]K01MK00?o`<000/000oo<3@02o`04S?o6o`;600_o`<3o`<co3Oo6o`02aP03olK600;6
00Koa_ooC?l2aP05ol30`?l00lH2o`0;a_o6S?o6`?o0a_l00/000oo<o`02c004ol`=o`8=00?o]Ol0
0_l3aP06o`d=okGo0[D4oc5K00>1Fe/0;E/1000085/00h5KF`0KF`03PE]K01MK00?oa/H00/H03?o<
oom<S?n<a_o6o`?600Ko`?ooS?l2aP0?S?n<aTc6C8coC8a<ol3600;o00?6C4`01D`01?m<a_l2aP0<
ol30olK0olco3L3o0`d01ol=ool=`?l00l002ol=3Ol=okFfolco039K00>1Fe/0;E/1000085/00h7o
F`0KF`03PE]K01MK00?o`<000/02o`05S?n<S?l00/H00oo6o`03`006olcoolKo0/H03Oo6oon<C?n<
oha<S?l00/H00on<o`07C00:olJ<olK0ol36o`;000?oc?l00l`01Ol=c?l=00;o00?0c?l00lH00ol=
3@03o`05]Ooo3Ol0<U/00h5KF`0]F`40000PF`03PE]K01]K00>1Fe/05e/01H5Kooo600?o00J<C8a<
olH<o`0AS?n<odcoC<KoS?m<S4co`?l00X`01_m<C?m<o`9<00OoC<I<olKo00;000[oa/3oc0go`0go
0Pd00ol=o`04o`?01ol00l3oo`0cF`03PE]K02eK0@00021K00>1Fe/06e/00h5KF`0FF`03PE]K00=K
00OoS4b<C?n<00;o00F<C8coS002o`03C8a<00Co00O6odgoS4co00:<00OoC8a<oha<00;o0T`00om<
o`02C00:olJ<a_o0ol36o`;000Coc<co0/`01_l=c?l=o`><00Soa/K6ohco3@;o0/02oc=K00>1Fe/0
;E/1000085/00h5KF`0KF`03PE]K01IK00>1Fe/00e/00om<C002C005odgoCOl014`02_m<oon<oha<
S?l3C00:olKoS4coS4b<o`:<00?oCOl01d`01_o6C?o6o`?000Wo`<Ko3Oo03Ol00Pd2o`05C?m<S?l0
0l001?n<ool2aP?o=E/00h5KF`0/F`40000PF`03PE]K01]K00>1Fe/05U/00h5KF`03F`0Noha<S4co
COm=odb<C8coC?m=C?n<C8coC4e<odco0X`00om<S002o`05S4coCOl014`03Om<C?n<a_o0a_o6`?l0
0/000oo<o`02c003o`g<00;o00><C8`00X`01_o6odco`0;o0U/00h5KF`0dF`03PE]K02aK0@00021K
00>1Fe/06e/00h5KF`0FF`03PE]K00AK00GoC4coC002o`03COm<009<00CoCDco0T`01On<C8co00=<
00ooaTcoC?n<C?m=ohcoCOl00T`00om<o`02C004olI<o`;600co`<3o`<Ko3Oo03Ol23@;o00U<S?n<
C?o0oh`01U/00h5KF`0dF`03PE]K02aK0@00021K00>1Fe/06e/00h5KF`0FF`03PE]K00AK00koC8co
C?m<CDcoS4coC@;o00E=C4goC002o`0BC4e<odb<ohcoC?m=C?m<odgo0T`00om<o`02C00:ohc6ol36
olK0o`;000?oc?l00/`00ol=o`02o`08S4coohcoa_l7F`03PE]K03AK00>1Fe/0;5/1000085/00h5K
F`0JF`03PE]K01MK00>1Fe/015/02_m<C?m<odgoC?l2C005odgoCOl00T`01Om<odgo009<00KoaTco
C8`2o`07C4goS?m=o`02C003odco009<00CoaTco0/H02oo0`?o0a_l=ol0=00?o00Y<odb<oha<ol3o
25/00h5KF`0cF`03PE]K02aK0@00021K00>1Fe/06U/00h5KF`0GF`03PE]K00AK01koC?m=C?m<odco
S4coCOm=oda=odcoCOm=C?m<S?l2S0;o00A=C?oo0Td01_m<C?m<o`9<00[oS<Ko`<Koa/3o0/06o`08
C?m=oha<oh`2o`03a_mK00MK00>1Fe/0<e/00h5KF`0/F`40000PF`03PE]K01YK00>1Fe/05e/00h5K
F`04F`05odcoCOl00Td01om<odcoC?l00Td02?m<C4coC4go0T`01Oo6C?m<00;o00Q=C4e<oda=o`9<
00?oC?l00T`01?o6C?l2aPSo00m=odb<ode<COn<C?m<S?l02E/00h5KF`0cF`03PE]K02aK0@00021K
00>1Fe/06U/00h5KF`0GF`03PE]K00AK01goC?m=ode<odcoS?m<oda=oda=C?m<COm=C?m<S002o`==
0_l01DgoCDgo009<00?oC?l00T`02on<a_o0a_m<CDa=00;o00I<COn<C?l3C@03odb<00Co2E/00h5K
F`0cF`03PE]K02aK0@0001mK00?oPE/06e/00h5KF`0GF`03PE]K00EK0_l02dgoCDgoC?m<odco009=
00SoC4a<oda=o`=<00GoC?m=o`05C@05oda=C?l00T`00om<o`02C007odcoa_m=o`02C@?o0Td02om<
S?m=C4goS4co00aK00>1Fe/0<e/00h5KF`0/F`40000OF`03PE]K01]K00>1Fe/05e/00h5KF`05F`09
oda=ode<COm=00;o00m<oda=C?m=ofKoCDcoC4d00_l014goCOl4C@05ode=COl00T`00om<o`02C00:
olKoodeVodgoS0;o00I<COn<ofH3C@03odco00eK00>1Fe/0<e/00h5KF`0/F`40000OF`03PE]K01]K
00>1Fe/05e/00h5KF`05F`?o14d01Om=odgo00A=0_l01VI=ode<o`9<0_l014goI_l2C@07ode=ode<
o`02C003odco009<00[oC?ooITgoCOm<0_l2C@0:odcoCOm<COn<o`eK00>1Fe/0<e/00h5KF`0/F`40
000OF`03PE]K01]K00>1Fe/05e/00h5KF`07F`05oda=C4d01Ol02Te<CDcoITeVodd6o`04COm=o`9=
00GoCDgoC@0<o`05ITeVCOl00X`01?m=C4d2o`03CFKo009=0_l>F`03PE]K03=K00>1Fe/0;5/10000
7e/00h5KF`0KF`03PE]K01MK00>1Fe/02e/2o`03ITeV00;o00E=odeVC@02o`05I_mVCFH00_l01Dgo
CFI=00Oo00==ITd00_l00fKoC@02o`A=1_l3C@;o0dd01?m=ool>F`03PE]K03=K00>1Fe/0;5/10000
7e/00h5KF`0KF`03PE]K01MK00>1Fe/04U/01?mVool3IP04ofKoo`=V00CoI_oo0fH01_mVoomVo`=V
0_l00fKoIP02IP;o00=<ofH00VH2o`08I_m=ofI=ITd3o`mK00>1Fe/0<e/00h5KF`0/F`40000OF`03
PE]K01]K00>1Fe/05e/00h5KF`0CF`03PE]K009K00WoI_ooCFI=odd00_l01FKoITeV00;o00M=odeV
COm=00;o00EVCFKoIP02o`04COoooaaK00>1Fe/0<e/00h5KF`0/F`40000OF`03PE]K01]K00>1Fe/0
5e/00h5KF`0CF`03PE]K00IK00CoIVIV0_l00fKoIP02IP04ofKoo`=V00KoI_ooI_l3IP?o00AVCOoo
75/00h5KF`0cF`03PE]K02aK0@0001mK00>1Fe/06e/00h5KF`0GF`03PE]K01=K00>1Fe/02E/01om=
oom>CDh00_l01fKoIVKoC_l00VH2o`06ITeVofKo0dd00omKF`0KF`03PE]K03=K00>1Fe/0;5/10000
7e/00h5KF`0KF`03PE]K01MK00>1Fe/04e/00h5KF`0:F`0<ofI=odkoCFKoCOm=0_l01fI=odkoC_l0
9E/00h5KF`0cF`03PE]K02aK0@00019K00CoFe]K1?l5F`03PE]K01]K00>1Fe/05e/00h5KF`0CF`03
PE]K00aK00KoC_m>ITh4o`04ITiVo`=200?oFe/095/00h5KF`0cF`03PE]K02aK0@00019K00CoFe_o
15/00omKF`02F`F16E/00h5KF`0GF`03PE]K01=K00>1Fe/03U/00cm?o`03@P0:od92@_m?@Tm2obIK
00>1Fe/0<e/00h5KF`0/F`40000>F`Ko00=Koe/00e/00omKF`02F`03PE]K009K1h4BF`03PE]K01MK
00>1Fe/04e/00h5KF`0>F`8o00WoCTm>odi?C_l014800omKF`0TF`03PE]K03=K00>1Fe/0;5/10000
3U/01OmKFe_o009K00?oFe/00U/00omKF`02F`03PE]K00UK284:F`03PE]K01MK00>1Fe/04U/00h5K
F`0?F`03odoo00=200[o@T92odm2Cd;o9U/00h5KF`0cF`03PE]K02aK0@0000mK00CoFe_o0U/00omK
F`02F`03oe]K009K00>1Fe/04E/8P@9K00>1Fe/05e/00h5KF`0BF`03PE]K00mK00_o?om>CdkoCTm>
o`03@P03oe]K02EK00>1Fe/0<e/00h5KF`0/F`40000@F`03oe_o009K00?oFe/00U/00omKF`02F`03
PE]K01UK1h4EF`03PE]K019K00>1Fe/03e/03om??om2ob3o@_lPod9?o`0WF`03PE]K03=K00>1Fe/0
;5/1000045/00omKo`02F`03oe]K009K00GoFe]KP@0MF`03PE]K00=K284<F`03PE]K01=K00>1Fe/0
3e/03?lo?om?ob7oColQo`9200?oFe/09E/00h5KF`0cF`03PE]K02aK0@00015K0_l2F`03oe]K009K
00GoFe]KP@0MF`03PE]K00]K2844F`03PE]K01=K00>1Fe/03e/03om??om2ob3o@_lPod9?o`0WF`03
PE]K03AK00>1Fe/0:e/100004U/01?mKFe/4o`AK00>1Fe/06e/00h5KF`0CF`N14e/00h5KF`0?F`0<
ocloodoo8Om?ob7o0T800omKF`0UF`03PE]K03AK00>1Fe/04e/<P@aK0@0001iK00>1Fe/06e/00h5K
F`0GF`03PE]K00R12e/00h5KF`0?F`0>odlood;o8?m2ob3o@_lXF`03PE]K03=K5h4HF`40000NF`03
PE]K01]K00>1Fe/05e/00h5KF`08F`N115/00h5KF`0?F`0>ocloodoo8Om?ob7o@_lXF`03PE]K01aK
5h400e^1F`0/F`40000NF`03PE]K01]K00>1Fe/05e/00h5KF`0?F`R13e/03Olood;o8?m2ob3o@_l0
:5/00h5KF`05FaN165/00h5KF`0[F`40000NF`03PE]K01]K00>1Fe/05e/00h5KF`0CF`04PE]KF`R1
1e/03Oloodoo8Om?ob7o@_l06E/GPBmK00>1Fe/0:e/10000?5/00h5KF`0GF`03PE]K01=K00>1Fe/0
2E/7P@0=ocoo@_lPod;o8?m2o`02FaN13e/00h5KF`0dF`03PE]K02]K0@0003aK00>1Fe/05e/00h5K
F`0CF`03PE]K011K00_o?coo824Pob0Q8002o`:19U/00h5KF`0dF`03PE]K02]K0@0003aK00>1Fe/0
5e/00h5KF`0CF`03PE]K011K00Co?doo0b001OlP823o02UK00>1Fe/0=5/00h5KF`0[F`40001FF`03
PE]K01=K00>1Fe/045/03?lo?olP8B3o824PobUK00>1Fe/0=5/00h5KF`0[F`40001FF`03PE]K01=K
00>1Fe/045/01?loCol38005ob0P8?l0:E/00h5KF`0dF`03PE]K02]K0@0005IK00>1Fe/04e/00h5K
F`0@F`0<ocloob0Q8?lP8B3o:E/00h5KF`0dF`03PE]K02]K0@0006aK00>1Fe/045/01?loool28005
oaoo8?l0:U/00h5KF`1RF`40001/F`03PE]K011K0_l02B8OoolR7olQo`0ZF`03PE]K069K0@0007mK
2Ol00b3oF`2>F`400020F`03PE^100AK0_n@F`40003oFaYK0@000?mK6U/10000oe/JF`40003oFaYK
0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000oe/JF`40003oFaYK0@000;iK0_mIF`40
002oF`;o0e/00omKF`1BF`400030F`;o0e/00omKF`1AF`40000hF`Go0e/3o`9K0_l4F`?o00=Kool0
0_l3F`Go1E/2o`EK0_l2F`Go0U/2o`9K1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K0_l00e_oo`02F`Co
0e/3o`9K0ol2F`;o1E/3o`9K0_l7F`Co00=Koe/01?l2F`;o0U/2o`9K0_l5F`Co0e/3obIK0@0003MK
0_l3F`;o00AKoomK0_l00e_oo`04F`;o00=Kool00U/2o`03Fooo009K0_l5F`;o1E/2o`9K0_l00e_o
o`02F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`Co0U/2o`03Fooo009K0_l5F`;o0e/2o`04
FoooF`;o0U/2o`9K0_l2F`;o00AKoomK0_l5F`?o0U/2o`IK0_l2F`Go0U/2o`03Fooo009K0_l2F`;o
15/2o`9K0_l00e_oo`02F`03oe]K02=K0@0003MK0_l3F`Co0e/4o`AK0_l00e_oo`05F`;o0U/2o`EK
0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`08F`?o15/5o`QK0ol5F`;o0e/2o`03Fooo00AK0ol2F`;o
00=Kool00e/4o`AK0_l00e_oo`08F`;o15/4o`EK0_l2F`;o25/2o`9K0_l5F`;o95/10000>e/5o`=K
1?l4F`;o00=Kool01?l00e_oo`02F`;o1E/2o`EK0_l2F`;o00=Kool00U/2o`03Fooo00Co0U/4o`=K
1?l00e_oo`04o`9K1?l6F`;o0e/2o`03Fooo009K1?l3F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o
15/8o`03Fooo009K0_l<F`;o0U/5obAK0@0003QK1Ol00e_oo`03F`Co15/2o`03Fooo009K0_l00e_o
o`02F`;o1E/5o`9K0_l2F`;o00=Kool00U/2o`03Fooo009K0_l015_oool4F`?o0e/2o`9K0_l015_o
ool8F`;o0e/2o`04FoooF`?o1E/2o`03Fooo00=K1?l4F`;o00=Kool025/2o`9K1_l2F`;o00=Kool0
0U/2o`YK0ol2F`;o0U/2obAK0@0003MK0ol5F`;o00AKoomK0ol3F`;o00=Kool00U/2o`03Fooo009K
0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`Co0U/2o`03
Fooo009K0_l5F`Oo00AKoomK0_l2F`;o0U/2o`9K0_l015_ooe/3o`=K0_l00e_oo`08F`;o1U/2o`9K
0_l00e_oo`02F`;o35/2o`03Fooo009K0_lTF`40000gF`;o0e/2o`9K0ol2F`?o0U/4o`03Fooo00;o
0e/5o`EK0_l5F`;o00=Kool01ol3F`Co0e/4o`=K1?l2F`Co0e/4o`IK0_l3F`;o00=Kool00U/4o`9K
1?l2F`?o0U/3o`9K0_l3F`;o1e/2o`AK0_l00e_oo`02o`9K1Ol9F`;o0U/2o`03Fooo009K0_lTF`40
000gF`;o0e/2o`eK0_l<F`;o1E/2o`UK0_l^F`;o0e/2o`aK0_lLF`;o0U/2oaIK0_l2F`;o00=Kool0
0U/00omKF`0SF`40000hF`Go3U/2o`aK0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK
1?lHF`Co0e/4obEK0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000\
\>"],
  ImageRangeCache->{{{0, 281}, {267, 0}} -> {-0.0880742, -0.0502163, \
0.00370667, 0.00370667}},
  CellTags->"Fitness chart 3D - Part 1"]
}, Open  ]],

Cell[TextData[Cell[BoxData[
    FormBox[
      ButtonBox[\(Part\ 2\),
        ButtonData:>"Fitness chart 3D - Part 2",
        ButtonStyle->"Hyperlink"], TraditionalForm]]]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "This fitness chart is continued in the ",
  ButtonBox["following plot",
    ButtonData:>"Fitness chart 3D - Part 2",
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell["\<\
fitnessChart3D[Take[allFitnessesSorted,{40,85}],
  GenIndices -> {{1,40},{10,50},{20,60},{30,70},{40,80}},
  DisplayGeneration -> 85
];\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95229 
MathPictureStart
%% Graphics3D
/Helvetica findfont 12  scalefont  setfont
% Background color
.8 g
MFill
% Scaling calculations
-3.75585e-05 1.068667 0.026717 1.068667 [
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 85)] .5 .95229 0 -1.5 Msboxa
P
[(0)] .07579 .18311 -0.06628 1 Msboxa
[(20)] .29254 .12405 -0.03525 1 Msboxa
[(40)] .54186 .05614 .00111 1 Msboxa
[(Indiv.)] .35928 .03957 -0.02584 1 Msboxa
[(40)] .71991 .03217 -1 .26888 Msboxa
[(50)] .7774 .09851 -1 .24741 Msboxa
[(60)] .83301 .16268 -1 .22724 Msboxa
[(70)] .88153 .21868 -1 .21011 Msboxa
[(80)] .92423 .26796 -1 .19539 Msboxa
[(Gen.)] .91594 .16872 -1 .22094 Msboxa
[(-20)] .05664 .24611 1 -0.25735 Msboxa
[(0)] .04388 .43446 1 -0.19718 Msboxa
[(20)] .03044 .63328 1 -0.13312 Msboxa
[(40)] .0163 .84345 1 -0.06478 Msboxa
[(Fit.)] -0.0283 .53856 1 -0.16726 Msboxa
[ 0 0 0 0 ]
[ 1 .95229 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
/Helvetica-Bold findfont 12 scalefont setfont
[(Sorted Fitnesses History, Gen. 85)] .5 .95229 0 -1.5 Mshowa
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.0749 .19643 m
.07446 .2031 L
s
P
[(0)] .07579 .18311 -0.06628 1 Mshowa
p
.002 w
.29207 .1374 m
.29183 .14408 L
s
P
[(20)] .29254 .12405 -0.03525 1 Mshowa
p
.002 w
.54188 .0695 m
.54188 .07618 L
s
P
[(40)] .54186 .05614 .00111 1 Mshowa
p
.001 w
.11604 .18525 m
.11579 .18925 L
s
P
p
.001 w
.15827 .17377 m
.15805 .17777 L
s
P
p
.001 w
.20166 .16198 m
.20146 .16598 L
s
P
p
.001 w
.24624 .14986 m
.24607 .15386 L
s
P
p
.001 w
.3392 .12459 m
.33908 .1286 L
s
P
p
.001 w
.38768 .11141 m
.38759 .11542 L
s
P
p
.001 w
.43758 .09785 m
.43752 .10186 L
s
P
p
.001 w
.48895 .08388 m
.48893 .08789 L
s
P
p
.001 w
.59641 .05467 m
.59645 .05868 L
s
P
p
.001 w
.65264 .03939 m
.65271 .0434 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
p
.002 w
.69926 .02672 m
.93852 .30206 L
s
P
p
.002 w
.70701 .03564 m
.70056 .03737 L
s
P
[(40)] .71991 .03217 -1 .26888 Mshowa
p
.002 w
.76443 .10172 m
.75795 .10332 L
s
P
[(50)] .7774 .09851 -1 .24741 Mshowa
p
.002 w
.81998 .16564 m
.81347 .16712 L
s
P
[(60)] .83301 .16268 -1 .22724 Mshowa
p
.002 w
.86845 .22142 m
.86192 .2228 L
s
P
[(70)] .88153 .21868 -1 .21011 Mshowa
p
.002 w
.91112 .27052 m
.90456 .2718 L
s
P
[(80)] .92423 .26796 -1 .19539 Mshowa
[(Gen.)] .91594 .16872 -1 .22094 Mshowa
P
p
p
.002 w
.07262 .19706 m
.02672 .88626 L
s
P
p
.002 w
.06958 .24278 m
.07604 .24112 L
s
P
[(-20)] .05664 .24611 1 -0.25735 Mshowa
p
.002 w
.05698 .43188 m
.06353 .43059 L
s
P
[(0)] .04388 .43446 1 -0.19718 Mshowa
p
.002 w
.04368 .63151 m
.05031 .63063 L
s
P
[(20)] .03044 .63328 1 -0.13312 Mshowa
p
.002 w
.02963 .84259 m
.03629 .84216 L
s
P
[(40)] .0163 .84345 1 -0.06478 Mshowa
p
.001 w
.06711 .2798 m
.071 .27884 L
s
P
p
.001 w
.06462 .31721 m
.06852 .3163 L
s
P
p
.001 w
.0621 .35502 m
.06601 .35416 L
s
P
p
.001 w
.05955 .39324 m
.06348 .39242 L
s
P
p
.001 w
.05438 .47094 m
.05832 .47021 L
s
P
p
.001 w
.05175 .51042 m
.0557 .50974 L
s
P
p
.001 w
.04909 .55034 m
.05305 .54971 L
s
P
p
.001 w
.0464 .5907 m
.05037 .59012 L
s
P
p
.001 w
.04094 .67278 m
.04491 .67231 L
s
P
p
.001 w
.03816 .71452 m
.04214 .71409 L
s
P
p
.001 w
.03534 .75672 m
.03934 .75635 L
s
P
p
.001 w
.0325 .79941 m
.0365 .7991 L
s
P
p
.001 w
.07202 .20615 m
.07589 .20511 L
s
P
[(Fit.)] -0.0283 .53856 1 -0.16726 Mshowa
P
0 0 m
1 0 L
1 .95229 L
0 .95229 L
closepath
clip
newpath
p
p
.4 g
.002 w
.06958 .24278 m
.429 .43263 L
s
P
p
.4 g
.002 w
.05698 .43188 m
.42684 .57972 L
s
P
p
.4 g
.002 w
.04368 .63151 m
.42459 .73297 L
s
P
p
.4 g
.002 w
.02963 .84259 m
.42224 .89279 L
s
P
p
.4 g
.002 w
.07386 .19775 m
.02812 .8864 L
s
P
p
.4 g
.002 w
.16657 .24963 m
.1325 .89679 L
s
P
p
.4 g
.002 w
.24854 .2955 m
.22373 .90587 L
s
P
p
.4 g
.002 w
.32152 .33634 m
.30415 .91387 L
s
P
p
.4 g
.002 w
.38693 .37294 m
.37556 .92098 L
s
P
p
.4 g
.002 w
.43147 .39642 m
.42384 .9255 L
s
P
p
.4 g
.002 w
.61322 .36259 m
.61941 .91897 L
s
P
p
.4 g
.002 w
.8151 .32502 m
.83844 .91166 L
s
P
p
.4 g
.002 w
.429 .43263 m
.94085 .34267 L
s
P
p
.4 g
.002 w
.42684 .57972 m
.95046 .5099 L
s
P
p
.4 g
.002 w
.42459 .73297 m
.96053 .68523 L
s
P
p
.4 g
.002 w
.42224 .89279 m
.97111 .86925 L
s
P
P
p
.42738 .41685 m .442 .41844 L .43323 .42002 L 1 0 0 r
F
P
p
.43618 .41526 m .45081 .41687 L .442 .41844 L 1 0 0 r
F
P
p
.42738 .41685 m .43618 .41526 L .442 .41844 L 1 0 0 r
F
P
p
.44502 .41367 m .45967 .41528 L .45081 .41687 L 1 0 0 r
F
P
p
.43618 .41526 m .44502 .41367 L .45081 .41687 L 1 0 0 r
F
P
p
.42147 .41365 m .43618 .41526 L .42738 .41685 L 1 0 0 r
F
P
p
.45391 .41206 m .46857 .41368 L .45967 .41528 L 1 0 0 r
F
P
p
.44502 .41367 m .45391 .41206 L .45967 .41528 L 1 0 0 r
F
P
p
.4303 .41205 m .44502 .41367 L .43618 .41526 L 1 0 0 r
F
P
p
.42147 .41365 m .4303 .41205 L .43618 .41526 L 1 0 0 r
F
P
p
.46284 .41045 m .47752 .41208 L .46857 .41368 L 1 0 0 r
F
P
p
.45391 .41206 m .46284 .41045 L .46857 .41368 L 1 0 0 r
F
P
p
.43917 .41044 m .45391 .41206 L .44502 .41367 L 1 0 0 r
F
P
p
.4303 .41205 m .43917 .41044 L .44502 .41367 L 1 0 0 r
F
P
p
.4155 .41042 m .4303 .41205 L .42147 .41365 L 1 0 0 r
F
P
p
.47182 .40883 m .48651 .41047 L .47752 .41208 L 1 0 0 r
F
P
p
.46284 .41045 m .47182 .40883 L .47752 .41208 L 1 0 0 r
F
P
p
.44809 .40882 m .46284 .41045 L .45391 .41206 L 1 0 0 r
F
P
p
.43917 .41044 m .44809 .40882 L .45391 .41206 L 1 0 0 r
F
P
p
.42436 .4088 m .43917 .41044 L .4303 .41205 L 1 0 0 r
F
P
p
.4155 .41042 m .42436 .4088 L .4303 .41205 L 1 0 0 r
F
P
p
.48084 .4072 m .49555 .40885 L .48651 .41047 L 1 0 0 r
F
P
p
.47182 .40883 m .48084 .4072 L .48651 .41047 L 1 0 0 r
F
P
p
.45705 .40719 m .47182 .40883 L .46284 .41045 L 1 0 0 r
F
P
p
.44809 .40882 m .45705 .40719 L .46284 .41045 L 1 0 0 r
F
P
p
.43326 .40717 m .44809 .40882 L .43917 .41044 L 1 0 0 r
F
P
p
.42436 .4088 m .43326 .40717 L .43917 .41044 L 1 0 0 r
F
P
p
.40947 .40715 m .42436 .4088 L .4155 .41042 L 1 0 0 r
F
P
p
.48992 .40557 m .50463 .40722 L .49555 .40885 L 1 0 0 r
F
P
p
.48084 .4072 m .48992 .40557 L .49555 .40885 L 1 0 0 r
F
P
p
.46606 .40555 m .48084 .4072 L .47182 .40883 L 1 0 0 r
F
P
p
.45705 .40719 m .46606 .40555 L .47182 .40883 L 1 0 0 r
F
P
p
.44221 .40553 m .45705 .40719 L .44809 .40882 L 1 0 0 r
F
P
p
.43326 .40717 m .44221 .40553 L .44809 .40882 L 1 0 0 r
F
P
p
.41836 .40552 m .43326 .40717 L .42436 .4088 L 1 0 0 r
F
P
p
.40947 .40715 m .41836 .40552 L .42436 .4088 L 1 0 0 r
F
P
p
.49903 .40392 m .51377 .40559 L .50463 .40722 L 1 0 0 r
F
P
p
.48992 .40557 m .49903 .40392 L .50463 .40722 L 1 0 0 r
F
P
p
.47512 .40391 m .48992 .40557 L .48084 .4072 L 1 0 0 r
F
P
p
.46606 .40555 m .47512 .40391 L .48084 .4072 L 1 0 0 r
F
P
p
.45121 .40389 m .46606 .40555 L .45705 .40719 L 1 0 0 r
F
P
p
.44221 .40553 m .45121 .40389 L .45705 .40719 L 1 0 0 r
F
P
p
.42729 .40387 m .44221 .40553 L .43326 .40717 L 1 0 0 r
F
P
p
.41836 .40552 m .42729 .40387 L .43326 .40717 L 1 0 0 r
F
P
p
.40337 .40386 m .41836 .40552 L .40947 .40715 L 1 0 0 r
F
P
p
.5082 .40227 m .52295 .40394 L .51377 .40559 L 1 0 0 r
F
P
p
.49903 .40392 m .5082 .40227 L .51377 .40559 L 1 0 0 r
F
P
p
.48422 .40225 m .49903 .40392 L .48992 .40557 L 1 0 0 r
F
P
p
.47512 .40391 m .48422 .40225 L .48992 .40557 L 1 0 0 r
F
P
p
.46025 .40224 m .47512 .40391 L .46606 .40555 L 1 0 0 r
F
P
p
.45121 .40389 m .46025 .40224 L .46606 .40555 L 1 0 0 r
F
P
p
.43627 .40222 m .45121 .40389 L .44221 .40553 L 1 0 0 r
F
P
p
.42729 .40387 m .43627 .40222 L .44221 .40553 L 1 0 0 r
F
P
p
.41229 .4022 m .42729 .40387 L .41836 .40552 L 1 0 0 r
F
P
p
.40337 .40386 m .41229 .4022 L .41836 .40552 L 1 0 0 r
F
P
p
.51741 .40061 m .53217 .40229 L .52295 .40394 L 1 0 0 r
F
P
p
.5082 .40227 m .51741 .40061 L .52295 .40394 L 1 0 0 r
F
P
p
.49338 .40059 m .5082 .40227 L .49903 .40392 L 1 0 0 r
F
P
p
.48422 .40225 m .49338 .40059 L .49903 .40392 L 1 0 0 r
F
P
p
.46934 .40057 m .48422 .40225 L .47512 .40391 L 1 0 0 r
F
P
p
.46025 .40224 m .46934 .40057 L .47512 .40391 L 1 0 0 r
F
P
p
.4453 .40056 m .46025 .40224 L .45121 .40389 L 1 0 0 r
F
P
p
.43627 .40222 m .4453 .40056 L .45121 .40389 L 1 0 0 r
F
P
p
.42125 .40054 m .43627 .40222 L .42729 .40387 L 1 0 0 r
F
P
p
.41229 .4022 m .42125 .40054 L .42729 .40387 L 1 0 0 r
F
P
p
.39721 .40052 m .41229 .4022 L .40337 .40386 L 1 0 0 r
F
P
p
.52667 .39894 m .54145 .40062 L .53217 .40229 L 1 0 0 r
F
P
p
.51741 .40061 m .52667 .39894 L .53217 .40229 L 1 0 0 r
F
P
p
.50257 .39892 m .51741 .40061 L .5082 .40227 L 1 0 0 r
F
P
p
.49338 .40059 m .50257 .39892 L .5082 .40227 L 1 0 0 r
F
P
p
.47847 .3989 m .49338 .40059 L .48422 .40225 L 1 0 0 r
F
P
p
.46934 .40057 m .47847 .3989 L .48422 .40225 L 1 0 0 r
F
P
p
.45437 .39889 m .46934 .40057 L .46025 .40224 L 1 0 0 r
F
P
p
.4453 .40056 m .45437 .39889 L .46025 .40224 L 1 0 0 r
F
P
p
.43027 .39887 m .4453 .40056 L .43627 .40222 L 1 0 0 r
F
P
p
.42125 .40054 m .43027 .39887 L .43627 .40222 L 1 0 0 r
F
P
p
.40616 .39885 m .42125 .40054 L .41229 .4022 L 1 0 0 r
F
P
p
.39721 .40052 m .40616 .39885 L .41229 .4022 L 1 0 0 r
F
P
p
.53598 .39726 m .55077 .39895 L .54145 .40062 L 1 0 .034 r
F
P
p
.52667 .39894 m .53598 .39726 L .54145 .40062 L 1 0 0 r
F
P
p
.51182 .39724 m .52667 .39894 L .51741 .40061 L 1 0 0 r
F
P
p
.50257 .39892 m .51182 .39724 L .51741 .40061 L 1 0 0 r
F
P
p
.48766 .39722 m .50257 .39892 L .49338 .40059 L 1 0 0 r
F
P
p
.47847 .3989 m .48766 .39722 L .49338 .40059 L 1 0 0 r
F
P
p
.46349 .39721 m .47847 .3989 L .46934 .40057 L 1 0 0 r
F
P
p
.45437 .39889 m .46349 .39721 L .46934 .40057 L 1 0 0 r
F
P
p
.43932 .39719 m .45437 .39889 L .4453 .40056 L 1 0 0 r
F
P
p
.43027 .39887 m .43932 .39719 L .4453 .40056 L 1 0 0 r
F
P
p
.41516 .39717 m .43027 .39887 L .42125 .40054 L 1 0 0 r
F
P
p
.40616 .39885 m .41516 .39717 L .42125 .40054 L 1 0 0 r
F
P
p
.39099 .39715 m .40616 .39885 L .39721 .40052 L 1 0 0 r
F
P
p
.54534 .39557 m .56015 .39727 L .55077 .39895 L 1 0 .181 r
F
P
p
.53598 .39726 m .54534 .39557 L .55077 .39895 L 1 0 .034 r
F
P
p
.52112 .39555 m .53598 .39726 L .52667 .39894 L 1 0 0 r
F
P
p
.51182 .39724 m .52112 .39555 L .52667 .39894 L 1 0 0 r
F
P
p
.49689 .39553 m .51182 .39724 L .50257 .39892 L 1 0 0 r
F
P
p
.48766 .39722 m .49689 .39553 L .50257 .39892 L 1 0 0 r
F
P
p
.47266 .39552 m .48766 .39722 L .47847 .3989 L 1 0 0 r
F
P
p
.46349 .39721 m .47266 .39552 L .47847 .3989 L 1 0 0 r
F
P
p
.44843 .3955 m .46349 .39721 L .45437 .39889 L 1 0 0 r
F
P
p
.43932 .39719 m .44843 .3955 L .45437 .39889 L 1 0 0 r
F
P
p
.4242 .39548 m .43932 .39719 L .43027 .39887 L 1 0 0 r
F
P
p
.41516 .39717 m .4242 .39548 L .43027 .39887 L 1 0 0 r
F
P
p
.39997 .39546 m .41516 .39717 L .40616 .39885 L 1 0 0 r
F
P
p
.39099 .39715 m .39997 .39546 L .40616 .39885 L 1 0 0 r
F
P
p
.55475 .39387 m .56957 .39559 L .56015 .39727 L 1 0 .395 r
F
P
p
.54534 .39557 m .55475 .39387 L .56015 .39727 L 1 0 .181 r
F
P
p
.53046 .39385 m .54534 .39557 L .53598 .39726 L 1 0 0 r
F
P
p
.52112 .39555 m .53046 .39385 L .53598 .39726 L 1 0 0 r
F
P
p
.50617 .39384 m .52112 .39555 L .51182 .39724 L 1 0 0 r
F
P
p
.49689 .39553 m .50617 .39384 L .51182 .39724 L 1 0 0 r
F
P
p
.48188 .39382 m .49689 .39553 L .48766 .39722 L 1 0 0 r
F
P
p
.47266 .39552 m .48188 .39382 L .48766 .39722 L 1 0 0 r
F
P
p
.45758 .3938 m .47266 .39552 L .46349 .39721 L 1 0 0 r
F
P
p
.44843 .3955 m .45758 .3938 L .46349 .39721 L 1 0 0 r
F
P
p
.43329 .39378 m .44843 .3955 L .43932 .39719 L 1 0 0 r
F
P
p
.4242 .39548 m .43329 .39378 L .43932 .39719 L 1 0 0 r
F
P
p
.40899 .39377 m .4242 .39548 L .41516 .39717 L 1 0 0 r
F
P
p
.39997 .39546 m .40899 .39377 L .41516 .39717 L 1 0 0 r
F
P
p
.3847 .39375 m .39997 .39546 L .39099 .39715 L 1 0 0 r
F
P
p
.56421 .39217 m .57904 .39389 L .56957 .39559 L 1 0 .634 r
F
P
p
.55475 .39387 m .56421 .39217 L .56957 .39559 L 1 0 .395 r
F
P
p
.53986 .39215 m .55475 .39387 L .54534 .39557 L 1 0 0 r
F
P
p
.53046 .39385 m .53986 .39215 L .54534 .39557 L 1 0 0 r
F
P
p
.5155 .39213 m .53046 .39385 L .52112 .39555 L 1 0 0 r
F
P
p
.50617 .39384 m .5155 .39213 L .52112 .39555 L 1 0 0 r
F
P
p
.49114 .39211 m .50617 .39384 L .49689 .39553 L 1 0 0 r
F
P
p
.48188 .39382 m .49114 .39211 L .49689 .39553 L 1 0 0 r
F
P
p
.46679 .3921 m .48188 .39382 L .47266 .39552 L 1 0 0 r
F
P
p
.45758 .3938 m .46679 .3921 L .47266 .39552 L 1 0 0 r
F
P
p
.44243 .39208 m .45758 .3938 L .44843 .3955 L 1 0 0 r
F
P
p
.43329 .39378 m .44243 .39208 L .44843 .3955 L 1 0 0 r
F
P
p
.41807 .39206 m .43329 .39378 L .4242 .39548 L 1 0 0 r
F
P
p
.40899 .39377 m .41807 .39206 L .4242 .39548 L 1 0 0 r
F
P
p
.39371 .39204 m .40899 .39377 L .39997 .39546 L 1 0 0 r
F
P
p
.3847 .39375 m .39371 .39204 L .39997 .39546 L 1 0 0 r
F
P
p
.57372 .39045 m .58856 .39218 L .57904 .39389 L 1 0 .838 r
F
P
p
.56421 .39217 m .57372 .39045 L .57904 .39389 L 1 0 .634 r
F
P
p
.5493 .39043 m .56421 .39217 L .55475 .39387 L 1 0 .034 r
F
P
p
.53986 .39215 m .5493 .39043 L .55475 .39387 L 1 0 0 r
F
P
p
.52488 .39041 m .53986 .39215 L .53046 .39385 L 1 0 0 r
F
P
p
.5155 .39213 m .52488 .39041 L .53046 .39385 L 1 0 0 r
F
P
p
.50046 .3904 m .5155 .39213 L .50617 .39384 L 1 0 .034 r
F
P
p
.49114 .39211 m .50046 .3904 L .50617 .39384 L 1 0 0 r
F
P
p
.47604 .39038 m .49114 .39211 L .48188 .39382 L 1 0 0 r
F
P
p
.46679 .3921 m .47604 .39038 L .48188 .39382 L 1 0 0 r
F
P
p
.45162 .39036 m .46679 .3921 L .45758 .3938 L 1 0 0 r
F
P
p
.44243 .39208 m .45162 .39036 L .45758 .3938 L 1 0 0 r
F
P
p
.42719 .39034 m .44243 .39208 L .43329 .39378 L 1 0 0 r
F
P
p
.41807 .39206 m .42719 .39034 L .43329 .39378 L 1 0 0 r
F
P
p
.40277 .39033 m .41807 .39206 L .40899 .39377 L 1 0 0 r
F
P
p
.39371 .39204 m .40277 .39033 L .40899 .39377 L 1 0 0 r
F
P
p
.37834 .39031 m .39371 .39204 L .3847 .39375 L 1 0 0 r
F
P
p
.58327 .38873 m .59813 .39047 L .58856 .39218 L 1 0 .93 r
F
P
p
.57372 .39045 m .58327 .38873 L .58856 .39218 L 1 0 .838 r
F
P
p
.55879 .38871 m .57372 .39045 L .56421 .39217 L 1 0 .181 r
F
P
p
.5493 .39043 m .55879 .38871 L .56421 .39217 L 1 0 .034 r
F
P
p
.53431 .38869 m .5493 .39043 L .53986 .39215 L 1 0 .034 r
F
P
p
.52488 .39041 m .53431 .38869 L .53986 .39215 L 1 0 0 r
F
P
p
.50982 .38867 m .52488 .39041 L .5155 .39213 L 1 0 .068 r
F
P
p
.50046 .3904 m .50982 .38867 L .5155 .39213 L 1 0 .034 r
F
P
p
.48534 .38865 m .50046 .3904 L .49114 .39211 L 1 0 0 r
F
P
p
.47604 .39038 m .48534 .38865 L .49114 .39211 L 1 0 0 r
F
P
p
.46085 .38864 m .47604 .39038 L .46679 .3921 L 1 0 0 r
F
P
p
.45162 .39036 m .46085 .38864 L .46679 .3921 L 1 0 0 r
F
P
p
.43636 .38862 m .45162 .39036 L .44243 .39208 L 1 0 0 r
F
P
p
.42719 .39034 m .43636 .38862 L .44243 .39208 L 1 0 0 r
F
P
p
.41187 .3886 m .42719 .39034 L .41807 .39206 L 1 0 0 r
F
P
p
.40277 .39033 m .41187 .3886 L .41807 .39206 L 1 0 0 r
F
P
p
.38738 .38858 m .40277 .39033 L .39371 .39204 L 1 0 0 r
F
P
p
.37834 .39031 m .38738 .38858 L .39371 .39204 L 1 0 0 r
F
P
p
.59288 .38699 m .60776 .38874 L .59813 .39047 L .684 0 1 r
F
P
p
.58327 .38873 m .59288 .38699 L .59813 .39047 L 1 0 .93 r
F
P
p
.56834 .38697 m .58327 .38873 L .57372 .39045 L 1 0 .361 r
F
P
p
.55879 .38871 m .56834 .38697 L .57372 .39045 L 1 0 .181 r
F
P
p
.54379 .38696 m .55879 .38871 L .5493 .39043 L 1 0 .068 r
F
P
p
.53431 .38869 m .54379 .38696 L .5493 .39043 L 1 0 .034 r
F
P
p
.51924 .38694 m .53431 .38869 L .52488 .39041 L 1 0 .068 r
F
P
p
.50982 .38867 m .51924 .38694 L .52488 .39041 L 1 0 .068 r
F
P
p
.49469 .38692 m .50982 .38867 L .50046 .3904 L 1 0 .034 r
F
P
p
.48534 .38865 m .49469 .38692 L .50046 .3904 L 1 0 0 r
F
P
p
.47014 .3869 m .48534 .38865 L .47604 .39038 L 1 0 0 r
F
P
p
.46085 .38864 m .47014 .3869 L .47604 .39038 L 1 0 0 r
F
P
p
.44558 .38689 m .46085 .38864 L .45162 .39036 L 1 0 0 r
F
P
p
.43636 .38862 m .44558 .38689 L .45162 .39036 L 1 0 0 r
F
P
p
.42103 .38687 m .43636 .38862 L .42719 .39034 L 1 0 0 r
F
P
p
.41187 .3886 m .42103 .38687 L .42719 .39034 L 1 0 0 r
F
P
p
.39647 .38685 m .41187 .3886 L .40277 .39033 L 1 0 0 r
F
P
p
.38738 .38858 m .39647 .38685 L .40277 .39033 L 1 0 0 r
F
P
p
.37191 .38683 m .38738 .38858 L .37834 .39031 L 1 0 0 r
F
P
p
.60254 .38525 m .61743 .38701 L .60776 .38874 L .275 0 1 r
F
P
p
.59288 .38699 m .60254 .38525 L .60776 .38874 L .684 0 1 r
F
P
p
.57793 .38523 m .59288 .38699 L .58327 .38873 L 1 0 .453 r
F
P
p
.56834 .38697 m .57793 .38523 L .58327 .38873 L 1 0 .361 r
F
P
p
.55332 .38521 m .56834 .38697 L .55879 .38871 L 1 0 .181 r
F
P
p
.54379 .38696 m .55332 .38521 L .55879 .38871 L 1 0 .068 r
F
P
p
.5287 .3852 m .54379 .38696 L .53431 .38869 L 1 0 .102 r
F
P
p
.51924 .38694 m .5287 .3852 L .53431 .38869 L 1 0 .068 r
F
P
p
.50409 .38518 m .51924 .38694 L .50982 .38867 L 1 0 .068 r
F
P
p
.49469 .38692 m .50409 .38518 L .50982 .38867 L 1 0 .034 r
F
P
p
.47947 .38516 m .49469 .38692 L .48534 .38865 L 1 0 0 r
F
P
p
.47014 .3869 m .47947 .38516 L .48534 .38865 L 1 0 0 r
F
P
p
.45485 .38514 m .47014 .3869 L .46085 .38864 L 1 0 0 r
F
P
p
.44558 .38689 m .45485 .38514 L .46085 .38864 L 1 0 0 r
F
P
p
.43023 .38512 m .44558 .38689 L .43636 .38862 L 1 0 0 r
F
P
p
.42103 .38687 m .43023 .38512 L .43636 .38862 L 1 0 0 r
F
P
p
.40561 .38511 m .42103 .38687 L .41187 .3886 L 1 0 0 r
F
P
p
.39647 .38685 m .40561 .38511 L .41187 .3886 L 1 0 0 r
F
P
p
.38099 .38509 m .39647 .38685 L .38738 .38858 L 1 0 0 r
F
P
p
.37191 .38683 m .38099 .38509 L .38738 .38858 L 1 0 0 r
F
P
p
.61226 .3835 m .62715 .38527 L .61743 .38701 L 0 .134 1 r
F
P
p
.60254 .38525 m .61226 .3835 L .61743 .38701 L .275 0 1 r
F
P
p
.58758 .38348 m .60254 .38525 L .59288 .38699 L 1 0 .477 r
F
P
p
.57793 .38523 m .58758 .38348 L .59288 .38699 L 1 0 .453 r
F
P
p
.5629 .38346 m .57793 .38523 L .56834 .38697 L 1 0 .294 r
F
P
p
.55332 .38521 m .5629 .38346 L .56834 .38697 L 1 0 .181 r
F
P
p
.53822 .38344 m .55332 .38521 L .54379 .38696 L 1 0 .249 r
F
P
p
.5287 .3852 m .53822 .38344 L .54379 .38696 L 1 0 .102 r
F
P
p
.51354 .38343 m .5287 .3852 L .51924 .38694 L 1 0 .068 r
F
P
p
.50409 .38518 m .51354 .38343 L .51924 .38694 L 1 0 .068 r
F
P
p
.48885 .38341 m .50409 .38518 L .49469 .38692 L 1 0 0 r
F
P
p
.47947 .38516 m .48885 .38341 L .49469 .38692 L 1 0 0 r
F
P
p
.46417 .38339 m .47947 .38516 L .47014 .3869 L 1 0 0 r
F
P
p
.45485 .38514 m .46417 .38339 L .47014 .3869 L 1 0 0 r
F
P
p
.43948 .38337 m .45485 .38514 L .44558 .38689 L 1 0 .034 r
F
P
p
.43023 .38512 m .43948 .38337 L .44558 .38689 L 1 0 0 r
F
P
p
.4148 .38335 m .43023 .38512 L .42103 .38687 L 1 0 0 r
F
P
p
.40561 .38511 m .4148 .38335 L .42103 .38687 L 1 0 0 r
F
P
p
.39011 .38334 m .40561 .38511 L .39647 .38685 L 1 0 0 r
F
P
p
.38099 .38509 m .39011 .38334 L .39647 .38685 L 1 0 0 r
F
P
p
.36542 .38332 m .38099 .38509 L .37191 .38683 L 1 0 0 r
F
P
p
.62202 .38174 m .63693 .38352 L .62715 .38527 L 0 .609 1 r
F
P
p
.61226 .3835 m .62202 .38174 L .62715 .38527 L 0 .134 1 r
F
P
p
.59728 .38172 m .61226 .3835 L .60254 .38525 L 1 0 .477 r
F
P
p
.58758 .38348 m .59728 .38172 L .60254 .38525 L 1 0 .477 r
F
P
p
.57253 .3817 m .58758 .38348 L .57793 .38523 L 1 0 .294 r
F
P
p
.5629 .38346 m .57253 .3817 L .57793 .38523 L 1 0 .294 r
F
P
p
.54778 .38168 m .5629 .38346 L .55332 .38521 L 1 0 .475 r
F
P
p
.53822 .38344 m .54778 .38168 L .55332 .38521 L 1 0 .249 r
F
P
p
.52304 .38166 m .53822 .38344 L .5287 .3852 L 1 0 .102 r
F
P
p
.51354 .38343 m .52304 .38166 L .5287 .3852 L 1 0 .068 r
F
P
p
.49829 .38165 m .51354 .38343 L .50409 .38518 L 1 0 0 r
F
P
p
.48885 .38341 m .49829 .38165 L .50409 .38518 L 1 0 0 r
F
P
p
.47354 .38163 m .48885 .38341 L .47947 .38516 L 1 0 0 r
F
P
p
.46417 .38339 m .47354 .38163 L .47947 .38516 L 1 0 0 r
F
P
p
.44879 .38161 m .46417 .38339 L .45485 .38514 L 1 0 .068 r
F
P
p
.43948 .38337 m .44879 .38161 L .45485 .38514 L 1 0 .034 r
F
P
p
.42403 .38159 m .43948 .38337 L .43023 .38512 L 1 0 0 r
F
P
p
.4148 .38335 m .42403 .38159 L .43023 .38512 L 1 0 0 r
F
P
p
.39928 .38157 m .4148 .38335 L .40561 .38511 L 1 0 0 r
F
P
p
.39011 .38334 m .39928 .38157 L .40561 .38511 L 1 0 0 r
F
P
p
.37452 .38155 m .39011 .38334 L .38099 .38509 L 1 0 0 r
F
P
p
.36542 .38332 m .37452 .38155 L .38099 .38509 L 1 0 0 r
F
P
p
.63184 .37997 m .64676 .38175 L .63693 .38352 L 0 .722 1 r
F
P
p
.62202 .38174 m .63184 .37997 L .63693 .38352 L 0 .609 1 r
F
P
p
.60703 .37995 m .62202 .38174 L .61226 .3835 L 1 0 .839 r
F
P
p
.59728 .38172 m .60703 .37995 L .61226 .3835 L 1 0 .477 r
F
P
p
.58221 .37993 m .59728 .38172 L .58758 .38348 L 1 0 .294 r
F
P
p
.57253 .3817 m .58221 .37993 L .58758 .38348 L 1 0 .294 r
F
P
p
.5574 .37991 m .57253 .3817 L .5629 .38346 L 1 0 .587 r
F
P
p
.54778 .38168 m .5574 .37991 L .5629 .38346 L 1 0 .475 r
F
P
p
.53259 .37989 m .54778 .38168 L .53822 .38344 L 1 0 .249 r
F
P
p
.52304 .38166 m .53259 .37989 L .53822 .38344 L 1 0 .102 r
F
P
p
.50777 .37987 m .52304 .38166 L .51354 .38343 L 1 0 0 r
F
P
p
.49829 .38165 m .50777 .37987 L .51354 .38343 L 1 0 0 r
F
P
p
.48296 .37986 m .49829 .38165 L .48885 .38341 L 1 0 0 r
F
P
p
.47354 .38163 m .48296 .37986 L .48885 .38341 L 1 0 0 r
F
P
p
.45814 .37984 m .47354 .38163 L .46417 .38339 L 1 0 .068 r
F
P
p
.44879 .38161 m .45814 .37984 L .46417 .38339 L 1 0 .068 r
F
P
p
.43332 .37982 m .44879 .38161 L .43948 .38337 L 1 0 .034 r
F
P
p
.42403 .38159 m .43332 .37982 L .43948 .38337 L 1 0 0 r
F
P
p
.4085 .3798 m .42403 .38159 L .4148 .38335 L 1 0 0 r
F
P
p
.39928 .38157 m .4085 .3798 L .4148 .38335 L 1 0 0 r
F
P
p
.38368 .37978 m .39928 .38157 L .39011 .38334 L 1 0 0 r
F
P
p
.37452 .38155 m .38368 .37978 L .39011 .38334 L 1 0 0 r
F
P
p
.35885 .37976 m .37452 .38155 L .36542 .38332 L 1 0 0 r
F
P
p
.6417 .37818 m .65664 .37998 L .64676 .38175 L 0 .788 1 r
F
P
p
.63184 .37997 m .6417 .37818 L .64676 .38175 L 0 .722 1 r
F
P
p
.61683 .37817 m .63184 .37997 L .62202 .38174 L .605 0 1 r
F
P
p
.60703 .37995 m .61683 .37817 L .62202 .38174 L 1 0 .839 r
F
P
p
.59195 .37815 m .60703 .37995 L .59728 .38172 L 1 0 .385 r
F
P
p
.58221 .37993 m .59195 .37815 L .59728 .38172 L 1 0 .294 r
F
P
p
.56707 .37813 m .58221 .37993 L .57253 .3817 L 1 0 .679 r
F
P
p
.5574 .37991 m .56707 .37813 L .57253 .3817 L 1 0 .587 r
F
P
p
.54219 .37811 m .5574 .37991 L .54778 .38168 L 1 0 .362 r
F
P
p
.53259 .37989 m .54219 .37811 L .54778 .38168 L 1 0 .249 r
F
P
p
.51731 .37809 m .53259 .37989 L .52304 .38166 L 1 0 .034 r
F
P
p
.50777 .37987 m .51731 .37809 L .52304 .38166 L 1 0 0 r
F
P
p
.49243 .37807 m .50777 .37987 L .49829 .38165 L 1 0 0 r
F
P
p
.48296 .37986 m .49243 .37807 L .49829 .38165 L 1 0 0 r
F
P
p
.46754 .37806 m .48296 .37986 L .47354 .38163 L 1 0 .068 r
F
P
p
.45814 .37984 m .46754 .37806 L .47354 .38163 L 1 0 .068 r
F
P
p
.44266 .37804 m .45814 .37984 L .44879 .38161 L 1 0 .068 r
F
P
p
.43332 .37982 m .44266 .37804 L .44879 .38161 L 1 0 .034 r
F
P
p
.41777 .37802 m .43332 .37982 L .42403 .38159 L 1 0 0 r
F
P
p
.4085 .3798 m .41777 .37802 L .42403 .38159 L 1 0 0 r
F
P
p
.39288 .378 m .4085 .3798 L .39928 .38157 L 1 0 0 r
F
P
p
.38368 .37978 m .39288 .378 L .39928 .38157 L 1 0 0 r
F
P
p
.36799 .37798 m .38368 .37978 L .37452 .38155 L 1 0 0 r
F
P
p
.35885 .37976 m .36799 .37798 L .37452 .38155 L 1 0 0 r
F
P
p
.65163 .37639 m .66658 .3782 L .65664 .37998 L 0 .856 1 r
F
P
p
.6417 .37818 m .65163 .37639 L .65664 .37998 L 0 .788 1 r
F
P
p
.62668 .37638 m .6417 .37818 L .63184 .37997 L .411 0 1 r
F
P
p
.61683 .37817 m .62668 .37638 L .63184 .37997 L .605 0 1 r
F
P
p
.60174 .37636 m .61683 .37817 L .60703 .37995 L 1 0 .477 r
F
P
p
.59195 .37815 m .60174 .37636 L .60703 .37995 L 1 0 .385 r
F
P
p
.57679 .37634 m .59195 .37815 L .58221 .37993 L 1 0 .771 r
F
P
p
.56707 .37813 m .57679 .37634 L .58221 .37993 L 1 0 .679 r
F
P
p
.55185 .37632 m .56707 .37813 L .5574 .37991 L 1 0 .362 r
F
P
p
.54219 .37811 m .55185 .37632 L .5574 .37991 L 1 0 .362 r
F
P
p
.5269 .3763 m .54219 .37811 L .53259 .37989 L 1 0 .102 r
F
P
p
.51731 .37809 m .5269 .3763 L .53259 .37989 L 1 0 .034 r
F
P
p
.50195 .37628 m .51731 .37809 L .50777 .37987 L 1 0 0 r
F
P
p
.49243 .37807 m .50195 .37628 L .50777 .37987 L 1 0 0 r
F
P
p
.477 .37627 m .49243 .37807 L .48296 .37986 L 1 0 .068 r
F
P
p
.46754 .37806 m .477 .37627 L .48296 .37986 L 1 0 .068 r
F
P
p
.45204 .37625 m .46754 .37806 L .45814 .37984 L 1 0 .068 r
F
P
p
.44266 .37804 m .45204 .37625 L .45814 .37984 L 1 0 .068 r
F
P
p
.42709 .37623 m .44266 .37804 L .43332 .37982 L 1 0 0 r
F
P
p
.41777 .37802 m .42709 .37623 L .43332 .37982 L 1 0 0 r
F
P
p
.40213 .37621 m .41777 .37802 L .4085 .3798 L 1 0 0 r
F
P
p
.39288 .378 m .40213 .37621 L .4085 .3798 L 1 0 0 r
F
P
p
.37718 .37619 m .39288 .378 L .38368 .37978 L 1 0 0 r
F
P
p
.36799 .37798 m .37718 .37619 L .38368 .37978 L 1 0 0 r
F
P
p
.35222 .37617 m .36799 .37798 L .35885 .37976 L 1 0 0 r
F
P
p
.6616 .37459 m .67657 .37641 L .66658 .3782 L 0 .927 1 r
F
P
p
.65163 .37639 m .6616 .37459 L .66658 .3782 L 0 .856 1 r
F
P
p
.63659 .37458 m .65163 .37639 L .6417 .37818 L .345 0 1 r
F
P
p
.62668 .37638 m .63659 .37458 L .6417 .37818 L .411 0 1 r
F
P
p
.61158 .37456 m .62668 .37638 L .61683 .37817 L 1 0 .624 r
F
P
p
.60174 .37636 m .61158 .37456 L .61683 .37817 L 1 0 .477 r
F
P
p
.58657 .37454 m .60174 .37636 L .59195 .37815 L 1 0 .951 r
F
P
p
.57679 .37634 m .58657 .37454 L .59195 .37815 L 1 0 .771 r
F
P
p
.56155 .37452 m .57679 .37634 L .56707 .37813 L 1 0 .454 r
F
P
p
.55185 .37632 m .56155 .37452 L .56707 .37813 L 1 0 .362 r
F
P
p
.53654 .3745 m .55185 .37632 L .54219 .37811 L 1 0 .136 r
F
P
p
.5269 .3763 m .53654 .3745 L .54219 .37811 L 1 0 .102 r
F
P
p
.51152 .37448 m .5269 .3763 L .51731 .37809 L 1 0 .034 r
F
P
p
.50195 .37628 m .51152 .37448 L .51731 .37809 L 1 0 0 r
F
P
p
.4865 .37447 m .50195 .37628 L .49243 .37807 L 1 0 .068 r
F
P
p
.477 .37627 m .4865 .37447 L .49243 .37807 L 1 0 .068 r
F
P
p
.46148 .37445 m .477 .37627 L .46754 .37806 L 1 0 .068 r
F
P
p
.45204 .37625 m .46148 .37445 L .46754 .37806 L 1 0 .068 r
F
P
p
.43646 .37443 m .45204 .37625 L .44266 .37804 L 1 0 0 r
F
P
p
.42709 .37623 m .43646 .37443 L .44266 .37804 L 1 0 0 r
F
P
p
.41144 .37441 m .42709 .37623 L .41777 .37802 L 1 0 0 r
F
P
p
.40213 .37621 m .41144 .37441 L .41777 .37802 L 1 0 0 r
F
P
p
.38641 .37439 m .40213 .37621 L .39288 .378 L 1 0 0 r
F
P
p
.37718 .37619 m .38641 .37439 L .39288 .378 L 1 0 0 r
F
P
p
.36139 .37437 m .37718 .37619 L .36799 .37798 L 1 0 0 r
F
P
p
.35222 .37617 m .36139 .37437 L .36799 .37798 L 1 0 0 r
F
P
p
.67163 .37279 m .68661 .37461 L .67657 .37641 L 0 .995 1 r
F
P
p
.6616 .37459 m .67163 .37279 L .67657 .37641 L 0 .927 1 r
F
P
p
.64655 .37277 m .6616 .37459 L .65163 .37639 L .28 0 1 r
F
P
p
.63659 .37458 m .64655 .37277 L .65163 .37639 L .345 0 1 r
F
P
p
.62148 .37275 m .63659 .37458 L .62668 .37638 L 1 0 .86 r
F
P
p
.61158 .37456 m .62148 .37275 L .62668 .37638 L 1 0 .624 r
F
P
p
.59639 .37273 m .61158 .37456 L .60174 .37636 L .868 0 1 r
F
P
p
.58657 .37454 m .59639 .37273 L .60174 .37636 L 1 0 .951 r
F
P
p
.57131 .37271 m .58657 .37454 L .57679 .37634 L 1 0 .658 r
F
P
p
.56155 .37452 m .57131 .37271 L .57679 .37634 L 1 0 .454 r
F
P
p
.54623 .37269 m .56155 .37452 L .55185 .37632 L 1 0 .136 r
F
P
p
.53654 .3745 m .54623 .37269 L .55185 .37632 L 1 0 .136 r
F
P
p
.52114 .37267 m .53654 .3745 L .5269 .3763 L 1 0 .102 r
F
P
p
.51152 .37448 m .52114 .37267 L .5269 .3763 L 1 0 .034 r
F
P
p
.49606 .37265 m .51152 .37448 L .50195 .37628 L 1 0 .068 r
F
P
p
.4865 .37447 m .49606 .37265 L .50195 .37628 L 1 0 .068 r
F
P
p
.47097 .37264 m .4865 .37447 L .477 .37627 L 1 0 .102 r
F
P
p
.46148 .37445 m .47097 .37264 L .477 .37627 L 1 0 .068 r
F
P
p
.44588 .37262 m .46148 .37445 L .45204 .37625 L 1 0 0 r
F
P
p
.43646 .37443 m .44588 .37262 L .45204 .37625 L 1 0 0 r
F
P
p
.42079 .3726 m .43646 .37443 L .42709 .37623 L 1 0 0 r
F
P
p
.41144 .37441 m .42079 .3726 L .42709 .37623 L 1 0 0 r
F
P
p
.3957 .37258 m .41144 .37441 L .40213 .37621 L 1 0 0 r
F
P
p
.38641 .37439 m .3957 .37258 L .40213 .37621 L 1 0 0 r
F
P
p
.3706 .37256 m .38641 .37439 L .37718 .37619 L 1 0 0 r
F
P
p
.36139 .37437 m .3706 .37256 L .37718 .37619 L 1 0 0 r
F
P
p
.34551 .37254 m .36139 .37437 L .35222 .37617 L 1 0 0 r
F
P
p
.68172 .37097 m .69671 .3728 L .68661 .37461 L 0 1 .832 r
F
P
p
.67163 .37279 m .68172 .37097 L .68661 .37461 L 0 .995 1 r
F
P
p
.65657 .37095 m .67163 .37279 L .6616 .37459 L .188 0 1 r
F
P
p
.64655 .37277 m .65657 .37095 L .6616 .37459 L .28 0 1 r
F
P
p
.63142 .37093 m .64655 .37277 L .63659 .37458 L .731 0 1 r
F
P
p
.62148 .37275 m .63142 .37093 L .63659 .37458 L 1 0 .86 r
F
P
p
.60628 .37091 m .62148 .37275 L .61158 .37456 L .695 0 1 r
F
P
p
.59639 .37273 m .60628 .37091 L .61158 .37456 L .868 0 1 r
F
P
p
.58112 .37089 m .59639 .37273 L .58657 .37454 L 1 0 .86 r
F
P
p
.57131 .37271 m .58112 .37089 L .58657 .37454 L 1 0 .658 r
F
P
p
.55597 .37087 m .57131 .37271 L .56155 .37452 L 1 0 .136 r
F
P
p
.54623 .37269 m .55597 .37087 L .56155 .37452 L 1 0 .136 r
F
P
p
.53082 .37085 m .54623 .37269 L .53654 .3745 L 1 0 .136 r
F
P
p
.52114 .37267 m .53082 .37085 L .53654 .3745 L 1 0 .102 r
F
P
p
.50567 .37083 m .52114 .37267 L .51152 .37448 L 1 0 .102 r
F
P
p
.49606 .37265 m .50567 .37083 L .51152 .37448 L 1 0 .068 r
F
P
p
.48051 .37082 m .49606 .37265 L .4865 .37447 L 1 0 .136 r
F
P
p
.47097 .37264 m .48051 .37082 L .4865 .37447 L 1 0 .102 r
F
P
p
.45535 .3708 m .47097 .37264 L .46148 .37445 L 1 0 0 r
F
P
p
.44588 .37262 m .45535 .3708 L .46148 .37445 L 1 0 0 r
F
P
p
.43019 .37078 m .44588 .37262 L .43646 .37443 L 1 0 0 r
F
P
p
.42079 .3726 m .43019 .37078 L .43646 .37443 L 1 0 0 r
F
P
p
.40503 .37076 m .42079 .3726 L .41144 .37441 L 1 0 0 r
F
P
p
.3957 .37258 m .40503 .37076 L .41144 .37441 L 1 0 0 r
F
P
p
.37987 .37074 m .3957 .37258 L .38641 .37439 L 1 0 0 r
F
P
p
.3706 .37256 m .37987 .37074 L .38641 .37439 L 1 0 0 r
F
P
p
.35471 .37072 m .3706 .37256 L .36139 .37437 L 1 0 0 r
F
P
p
.34551 .37254 m .35471 .37072 L .36139 .37437 L 1 0 0 r
F
P
p
.69186 .36914 m .70686 .37098 L .69671 .3728 L 0 1 .659 r
F
P
p
.68172 .37097 m .69186 .36914 L .69671 .3728 L 0 1 .832 r
F
P
p
.66664 .36912 m .68172 .37097 L .67163 .37279 L .096 0 1 r
F
P
p
.65657 .37095 m .66664 .36912 L .67163 .37279 L .188 0 1 r
F
P
p
.64143 .3691 m .65657 .37095 L .64655 .37277 L .377 0 1 r
F
P
p
.63142 .37093 m .64143 .3691 L .64655 .37277 L .731 0 1 r
F
P
p
.61621 .36908 m .63142 .37093 L .62148 .37275 L .373 0 1 r
F
P
p
.60628 .37091 m .61621 .36908 L .62148 .37275 L .695 0 1 r
F
P
p
.59099 .36906 m .60628 .37091 L .59639 .37273 L 1 0 .948 r
F
P
p
.58112 .37089 m .59099 .36906 L .59639 .37273 L 1 0 .86 r
F
P
p
.56577 .36904 m .58112 .37089 L .57131 .37271 L 1 0 .249 r
F
P
p
.55597 .37087 m .56577 .36904 L .57131 .37271 L 1 0 .136 r
F
P
p
.54055 .36902 m .55597 .37087 L .54623 .37269 L 1 0 .136 r
F
P
p
.53082 .37085 m .54055 .36902 L .54623 .37269 L 1 0 .136 r
F
P
p
.51533 .369 m .53082 .37085 L .52114 .37267 L 1 0 .136 r
F
P
p
.50567 .37083 m .51533 .369 L .52114 .37267 L 1 0 .102 r
F
P
p
.4901 .36899 m .50567 .37083 L .49606 .37265 L 1 0 .136 r
F
P
p
.48051 .37082 m .4901 .36899 L .49606 .37265 L 1 0 .136 r
F
P
p
.46488 .36897 m .48051 .37082 L .47097 .37264 L 1 0 .034 r
F
P
p
.45535 .3708 m .46488 .36897 L .47097 .37264 L 1 0 0 r
F
P
p
.43965 .36895 m .45535 .3708 L .44588 .37262 L 1 0 0 r
F
P
p
.43019 .37078 m .43965 .36895 L .44588 .37262 L 1 0 0 r
F
P
p
.41442 .36893 m .43019 .37078 L .42079 .3726 L 1 0 0 r
F
P
p
.40503 .37076 m .41442 .36893 L .42079 .3726 L 1 0 0 r
F
P
p
.38919 .36891 m .40503 .37076 L .3957 .37258 L 1 0 0 r
F
P
p
.37987 .37074 m .38919 .36891 L .3957 .37258 L 1 0 0 r
F
P
p
.36396 .36889 m .37987 .37074 L .3706 .37256 L 1 0 0 r
F
P
p
.35471 .37072 m .36396 .36889 L .3706 .37256 L 1 0 0 r
F
P
p
.33873 .36887 m .35471 .37072 L .34551 .37254 L 1 0 0 r
F
P
p
.70205 .3673 m .71707 .36916 L .70686 .37098 L 0 1 .318 r
F
P
p
.69186 .36914 m .70205 .3673 L .70686 .37098 L 0 1 .659 r
F
P
p
.67677 .36728 m .69186 .36914 L .68172 .37097 L 0 .384 1 r
F
P
p
.66664 .36912 m .67677 .36728 L .68172 .37097 L .096 0 1 r
F
P
p
.65149 .36726 m .66664 .36912 L .65657 .37095 L .251 0 1 r
F
P
p
.64143 .3691 m .65149 .36726 L .65657 .37095 L .377 0 1 r
F
P
p
.6262 .36724 m .64143 .3691 L .63142 .37093 L 0 .218 1 r
F
P
p
.61621 .36908 m .6262 .36724 L .63142 .37093 L .373 0 1 r
F
P
p
.60091 .36722 m .61621 .36908 L .60628 .37091 L .816 0 1 r
F
P
p
.59099 .36906 m .60091 .36722 L .60628 .37091 L 1 0 .948 r
F
P
p
.57562 .3672 m .59099 .36906 L .58112 .37089 L 1 0 .362 r
F
P
p
.56577 .36904 m .57562 .3672 L .58112 .37089 L 1 0 .249 r
F
P
p
.55033 .36718 m .56577 .36904 L .55597 .37087 L 1 0 .136 r
F
P
p
.54055 .36902 m .55033 .36718 L .55597 .37087 L 1 0 .136 r
F
P
p
.52504 .36716 m .54055 .36902 L .53082 .37085 L 1 0 .136 r
F
P
p
.51533 .369 m .52504 .36716 L .53082 .37085 L 1 0 .136 r
F
P
p
.49975 .36715 m .51533 .369 L .50567 .37083 L 1 0 .136 r
F
P
p
.4901 .36899 m .49975 .36715 L .50567 .37083 L 1 0 .136 r
F
P
p
.47445 .36713 m .4901 .36899 L .48051 .37082 L 1 0 .068 r
F
P
p
.46488 .36897 m .47445 .36713 L .48051 .37082 L 1 0 .034 r
F
P
p
.44916 .36711 m .46488 .36897 L .45535 .3708 L 1 0 .034 r
F
P
p
.43965 .36895 m .44916 .36711 L .45535 .3708 L 1 0 0 r
F
P
p
.42386 .36709 m .43965 .36895 L .43019 .37078 L 1 0 0 r
F
P
p
.41442 .36893 m .42386 .36709 L .43019 .37078 L 1 0 0 r
F
P
p
.39856 .36707 m .41442 .36893 L .40503 .37076 L 1 0 .034 r
F
P
p
.38919 .36891 m .39856 .36707 L .40503 .37076 L 1 0 0 r
F
P
p
.37326 .36705 m .38919 .36891 L .37987 .37074 L 1 0 .034 r
F
P
p
.36396 .36889 m .37326 .36705 L .37987 .37074 L 1 0 0 r
F
P
p
.34796 .36703 m .36396 .36889 L .35471 .37072 L 1 0 0 r
F
P
p
.33873 .36887 m .34796 .36703 L .35471 .37072 L 1 0 0 r
F
P
p
.71231 .36545 m .72734 .36732 L .71707 .36916 L .057 1 0 r
F
P
p
.70205 .3673 m .71231 .36545 L .71707 .36916 L 0 1 .318 r
F
P
p
.68695 .36543 m .70205 .3673 L .69186 .36914 L 0 .898 1 r
F
P
p
.67677 .36728 m .68695 .36543 L .69186 .36914 L 0 .384 1 r
F
P
p
.6616 .36541 m .67677 .36728 L .66664 .36912 L .128 0 1 r
F
P
p
.65149 .36726 m .6616 .36541 L .66664 .36912 L .251 0 1 r
F
P
p
.63624 .36539 m .65149 .36726 L .64143 .3691 L 0 .693 1 r
F
P
p
.6262 .36724 m .63624 .36539 L .64143 .3691 L 0 .218 1 r
F
P
p
.61089 .36537 m .6262 .36724 L .61621 .36908 L .519 0 1 r
F
P
p
.60091 .36722 m .61089 .36537 L .61621 .36908 L .816 0 1 r
F
P
p
.58553 .36535 m .60091 .36722 L .59099 .36906 L 1 0 .475 r
F
P
p
.57562 .3672 m .58553 .36535 L .59099 .36906 L 1 0 .362 r
F
P
p
.56017 .36533 m .57562 .3672 L .56577 .36904 L 1 0 .136 r
F
P
p
.55033 .36718 m .56017 .36533 L .56577 .36904 L 1 0 .136 r
F
P
p
.53481 .36531 m .55033 .36718 L .54055 .36902 L 1 0 .249 r
F
P
p
.52504 .36716 m .53481 .36531 L .54055 .36902 L 1 0 .136 r
F
P
p
.50945 .3653 m .52504 .36716 L .51533 .369 L 1 0 .136 r
F
P
p
.49975 .36715 m .50945 .3653 L .51533 .369 L 1 0 .136 r
F
P
p
.48408 .36528 m .49975 .36715 L .4901 .36899 L 1 0 .102 r
F
P
p
.47445 .36713 m .48408 .36528 L .4901 .36899 L 1 0 .068 r
F
P
p
.45872 .36526 m .47445 .36713 L .46488 .36897 L 1 0 .068 r
F
P
p
.44916 .36711 m .45872 .36526 L .46488 .36897 L 1 0 .034 r
F
P
p
.43335 .36524 m .44916 .36711 L .43965 .36895 L 1 0 0 r
F
P
p
.42386 .36709 m .43335 .36524 L .43965 .36895 L 1 0 0 r
F
P
p
.40798 .36522 m .42386 .36709 L .41442 .36893 L 1 0 .068 r
F
P
p
.39856 .36707 m .40798 .36522 L .41442 .36893 L 1 0 .034 r
F
P
p
.38261 .3652 m .39856 .36707 L .38919 .36891 L 1 0 .068 r
F
P
p
.37326 .36705 m .38261 .3652 L .38919 .36891 L 1 0 .034 r
F
P
p
.35724 .36518 m .37326 .36705 L .36396 .36889 L 1 0 0 r
F
P
p
.34796 .36703 m .35724 .36518 L .36396 .36889 L 1 0 0 r
F
P
p
.33187 .36516 m .34796 .36703 L .33873 .36887 L 1 0 0 r
F
P
p
.72261 .36359 m .73766 .36547 L .72734 .36732 L .432 1 0 r
F
P
p
.71231 .36545 m .72261 .36359 L .72734 .36732 L .057 1 0 r
F
P
p
.69719 .36357 m .71231 .36545 L .70205 .3673 L 0 1 .934 r
F
P
p
.68695 .36543 m .69719 .36357 L .70205 .3673 L 0 .898 1 r
F
P
p
.67177 .36355 m .68695 .36543 L .67677 .36728 L 0 .313 1 r
F
P
p
.6616 .36541 m .67177 .36355 L .67677 .36728 L .128 0 1 r
F
P
p
.64634 .36353 m .6616 .36541 L .65149 .36726 L 0 .759 1 r
F
P
p
.63624 .36539 m .64634 .36353 L .65149 .36726 L 0 .693 1 r
F
P
p
.62092 .36351 m .63624 .36539 L .6262 .36724 L .337 0 1 r
F
P
p
.61089 .36537 m .62092 .36351 L .6262 .36724 L .519 0 1 r
F
P
p
.59549 .36349 m .61089 .36537 L .60091 .36722 L 1 0 .65 r
F
P
p
.58553 .36535 m .59549 .36349 L .60091 .36722 L 1 0 .475 r
F
P
p
.57006 .36347 m .58553 .36535 L .57562 .3672 L 1 0 .249 r
F
P
p
.56017 .36533 m .57006 .36347 L .57562 .3672 L 1 0 .136 r
F
P
p
.54463 .36345 m .56017 .36533 L .55033 .36718 L 1 0 .362 r
F
P
p
.53481 .36531 m .54463 .36345 L .55033 .36718 L 1 0 .249 r
F
P
p
.5192 .36343 m .53481 .36531 L .52504 .36716 L 1 0 .136 r
F
P
p
.50945 .3653 m .5192 .36343 L .52504 .36716 L 1 0 .136 r
F
P
p
.49376 .36342 m .50945 .3653 L .49975 .36715 L 1 0 .136 r
F
P
p
.48408 .36528 m .49376 .36342 L .49975 .36715 L 1 0 .102 r
F
P
p
.46833 .3634 m .48408 .36528 L .47445 .36713 L 1 0 .068 r
F
P
p
.45872 .36526 m .46833 .3634 L .47445 .36713 L 1 0 .068 r
F
P
p
.44289 .36338 m .45872 .36526 L .44916 .36711 L 1 0 .068 r
F
P
p
.43335 .36524 m .44289 .36338 L .44916 .36711 L 1 0 0 r
F
P
p
.41746 .36336 m .43335 .36524 L .42386 .36709 L 1 0 .068 r
F
P
p
.40798 .36522 m .41746 .36336 L .42386 .36709 L 1 0 .068 r
F
P
p
.39202 .36334 m .40798 .36522 L .39856 .36707 L 1 0 .102 r
F
P
p
.38261 .3652 m .39202 .36334 L .39856 .36707 L 1 0 .068 r
F
P
p
.36658 .36332 m .38261 .3652 L .37326 .36705 L 1 0 .068 r
F
P
p
.35724 .36518 m .36658 .36332 L .37326 .36705 L 1 0 0 r
F
P
p
.34113 .3633 m .35724 .36518 L .34796 .36703 L 1 0 0 r
F
P
p
.33187 .36516 m .34113 .3633 L .34796 .36703 L 1 0 0 r
F
P
p
.73298 .36172 m .74803 .36361 L .73766 .36547 L .841 1 0 r
F
P
p
.72261 .36359 m .73298 .36172 L .73766 .36547 L .432 1 0 r
F
P
p
.70749 .3617 m .72261 .36359 L .71231 .36545 L 0 1 .801 r
F
P
p
.69719 .36357 m .70749 .3617 L .71231 .36545 L 0 1 .934 r
F
P
p
.68199 .36168 m .69719 .36357 L .68695 .36543 L 0 .756 1 r
F
P
p
.67177 .36355 m .68199 .36168 L .68695 .36543 L 0 .313 1 r
F
P
p
.6565 .36166 m .67177 .36355 L .6616 .36541 L 0 .892 1 r
F
P
p
.64634 .36353 m .6565 .36166 L .6616 .36541 L 0 .759 1 r
F
P
p
.631 .36164 m .64634 .36353 L .63624 .36539 L .217 0 1 r
F
P
p
.62092 .36351 m .631 .36164 L .63624 .36539 L .337 0 1 r
F
P
p
.6055 .36162 m .62092 .36351 L .61089 .36537 L 1 0 .713 r
F
P
p
.59549 .36349 m .6055 .36162 L .61089 .36537 L 1 0 .65 r
F
P
p
.58001 .3616 m .59549 .36349 L .58553 .36535 L 1 0 .475 r
F
P
p
.57006 .36347 m .58001 .3616 L .58553 .36535 L 1 0 .249 r
F
P
p
.5545 .36158 m .57006 .36347 L .56017 .36533 L 1 0 .362 r
F
P
p
.54463 .36345 m .5545 .36158 L .56017 .36533 L 1 0 .362 r
F
P
p
.529 .36156 m .54463 .36345 L .53481 .36531 L 1 0 .249 r
F
P
p
.5192 .36343 m .529 .36156 L .53481 .36531 L 1 0 .136 r
F
P
p
.5035 .36154 m .5192 .36343 L .50945 .3653 L 1 0 .136 r
F
P
p
.49376 .36342 m .5035 .36154 L .50945 .3653 L 1 0 .136 r
F
P
p
.47799 .36153 m .49376 .36342 L .48408 .36528 L 1 0 .102 r
F
P
p
.46833 .3634 m .47799 .36153 L .48408 .36528 L 1 0 .068 r
F
P
p
.45249 .36151 m .46833 .3634 L .45872 .36526 L 1 0 .136 r
F
P
p
.44289 .36338 m .45249 .36151 L .45872 .36526 L 1 0 .068 r
F
P
p
.42698 .36149 m .44289 .36338 L .43335 .36524 L 1 0 .068 r
F
P
p
.41746 .36336 m .42698 .36149 L .43335 .36524 L 1 0 .068 r
F
P
p
.40147 .36147 m .41746 .36336 L .40798 .36522 L 1 0 .136 r
F
P
p
.39202 .36334 m .40147 .36147 L .40798 .36522 L 1 0 .102 r
F
P
p
.37596 .36145 m .39202 .36334 L .38261 .3652 L 1 0 .136 r
F
P
p
.36658 .36332 m .37596 .36145 L .38261 .3652 L 1 0 .068 r
F
P
p
.35045 .36143 m .36658 .36332 L .35724 .36518 L 1 0 0 r
F
P
p
.34113 .3633 m .35045 .36143 L .35724 .36518 L 1 0 0 r
F
P
p
.32494 .36141 m .34113 .3633 L .33187 .36516 L 1 0 0 r
F
P
p
.7434 .35984 m .75847 .36174 L .74803 .36361 L .962 1 0 r
F
P
p
.73298 .36172 m .7434 .35984 L .74803 .36361 L .841 1 0 r
F
P
p
.71784 .35982 m .73298 .36172 L .72261 .36359 L 0 1 .528 r
F
P
p
.70749 .3617 m .71784 .35982 L .72261 .36359 L 0 1 .801 r
F
P
p
.69227 .3598 m .70749 .3617 L .69719 .36357 L 0 .892 1 r
F
P
p
.68199 .36168 m .69227 .3598 L .69719 .36357 L 0 .756 1 r
F
P
p
.66671 .35978 m .68199 .36168 L .67177 .36355 L 0 .995 1 r
F
P
p
.6565 .36166 m .66671 .35978 L .67177 .36355 L 0 .892 1 r
F
P
p
.64114 .35976 m .6565 .36166 L .64634 .36353 L .156 0 1 r
F
P
p
.631 .36164 m .64114 .35976 L .64634 .36353 L .217 0 1 r
F
P
p
.61558 .35974 m .631 .36164 L .62092 .36351 L 1 0 .713 r
F
P
p
.6055 .36162 m .61558 .35974 L .62092 .36351 L 1 0 .713 r
F
P
p
.59001 .35972 m .6055 .36162 L .59549 .36349 L 1 0 .587 r
F
P
p
.58001 .3616 m .59001 .35972 L .59549 .36349 L 1 0 .475 r
F
P
p
.56444 .3597 m .58001 .3616 L .57006 .36347 L 1 0 .475 r
F
P
p
.5545 .36158 m .56444 .3597 L .57006 .36347 L 1 0 .362 r
F
P
p
.53886 .35968 m .5545 .36158 L .54463 .36345 L 1 0 .362 r
F
P
p
.529 .36156 m .53886 .35968 L .54463 .36345 L 1 0 .249 r
F
P
p
.51329 .35966 m .529 .36156 L .5192 .36343 L 1 0 .136 r
F
P
p
.5035 .36154 m .51329 .35966 L .5192 .36343 L 1 0 .136 r
F
P
p
.48771 .35964 m .5035 .36154 L .49376 .36342 L 1 0 .136 r
F
P
p
.47799 .36153 m .48771 .35964 L .49376 .36342 L 1 0 .102 r
F
P
p
.46214 .35962 m .47799 .36153 L .46833 .3634 L 1 0 .136 r
F
P
p
.45249 .36151 m .46214 .35962 L .46833 .3634 L 1 0 .136 r
F
P
p
.43656 .35961 m .45249 .36151 L .44289 .36338 L 1 0 .102 r
F
P
p
.42698 .36149 m .43656 .35961 L .44289 .36338 L 1 0 .068 r
F
P
p
.41098 .35959 m .42698 .36149 L .41746 .36336 L 1 0 .136 r
F
P
p
.40147 .36147 m .41098 .35959 L .41746 .36336 L 1 0 .136 r
F
P
p
.3854 .35957 m .40147 .36147 L .39202 .36334 L 1 0 .136 r
F
P
p
.37596 .36145 m .3854 .35957 L .39202 .36334 L 1 0 .136 r
F
P
p
.35982 .35955 m .37596 .36145 L .36658 .36332 L 1 0 .034 r
F
P
p
.35045 .36143 m .35982 .35955 L .36658 .36332 L 1 0 0 r
F
P
p
.33423 .35953 m .35045 .36143 L .34113 .3633 L 1 0 0 r
F
P
p
.32494 .36141 m .33423 .35953 L .34113 .3633 L 1 0 0 r
F
P
p
.75388 .35795 m .76896 .35986 L .75847 .36174 L 1 .884 0 r
F
P
p
.7434 .35984 m .75388 .35795 L .75847 .36174 L .962 1 0 r
F
P
p
.72825 .35793 m .7434 .35984 L .73298 .36172 L 0 1 .116 r
F
P
p
.71784 .35982 m .72825 .35793 L .73298 .36172 L 0 1 .528 r
F
P
p
.70261 .35791 m .71784 .35982 L .70749 .3617 L 0 1 .562 r
F
P
p
.69227 .3598 m .70261 .35791 L .70749 .3617 L 0 .892 1 r
F
P
p
.67698 .35789 m .69227 .3598 L .68199 .36168 L 0 .995 1 r
F
P
p
.66671 .35978 m .67698 .35789 L .68199 .36168 L 0 .995 1 r
F
P
p
.65134 .35787 m .66671 .35978 L .6565 .36166 L 0 .063 1 r
F
P
p
.64114 .35976 m .65134 .35787 L .6565 .36166 L .156 0 1 r
F
P
p
.6257 .35785 m .64114 .35976 L .631 .36164 L 1 0 .776 r
F
P
p
.61558 .35974 m .6257 .35785 L .631 .36164 L 1 0 .713 r
F
P
p
.60006 .35783 m .61558 .35974 L .6055 .36162 L 1 0 .587 r
F
P
p
.59001 .35972 m .60006 .35783 L .6055 .36162 L 1 0 .587 r
F
P
p
.57442 .35781 m .59001 .35972 L .58001 .3616 L 1 0 .587 r
F
P
p
.56444 .3597 m .57442 .35781 L .58001 .3616 L 1 0 .475 r
F
P
p
.54878 .35779 m .56444 .3597 L .5545 .36158 L 1 0 .362 r
F
P
p
.53886 .35968 m .54878 .35779 L .5545 .36158 L 1 0 .362 r
F
P
p
.52313 .35777 m .53886 .35968 L .529 .36156 L 1 0 .136 r
F
P
p
.51329 .35966 m .52313 .35777 L .529 .36156 L 1 0 .136 r
F
P
p
.49749 .35775 m .51329 .35966 L .5035 .36154 L 1 0 .136 r
F
P
p
.48771 .35964 m .49749 .35775 L .5035 .36154 L 1 0 .136 r
F
P
p
.47184 .35773 m .48771 .35964 L .47799 .36153 L 1 0 .136 r
F
P
p
.46214 .35962 m .47184 .35773 L .47799 .36153 L 1 0 .136 r
F
P
p
.44619 .35771 m .46214 .35962 L .45249 .36151 L 1 0 .136 r
F
P
p
.43656 .35961 m .44619 .35771 L .45249 .36151 L 1 0 .102 r
F
P
p
.42054 .35769 m .43656 .35961 L .42698 .36149 L 1 0 .136 r
F
P
p
.41098 .35959 m .42054 .35769 L .42698 .36149 L 1 0 .136 r
F
P
p
.39489 .35767 m .41098 .35959 L .40147 .36147 L 1 0 .136 r
F
P
p
.3854 .35957 m .39489 .35767 L .40147 .36147 L 1 0 .136 r
F
P
p
.36924 .35766 m .3854 .35957 L .37596 .36145 L 1 0 .068 r
F
P
p
.35982 .35955 m .36924 .35766 L .37596 .36145 L 1 0 .034 r
F
P
p
.34358 .35764 m .35982 .35955 L .35045 .36143 L 1 0 0 r
F
P
p
.33423 .35953 m .34358 .35764 L .35045 .36143 L 1 0 0 r
F
P
p
.31792 .35762 m .33423 .35953 L .32494 .36141 L 1 0 0 r
F
P
p
.76442 .35605 m .77951 .35797 L .76896 .35986 L 1 .781 0 r
F
P
p
.75388 .35795 m .76442 .35605 L .76896 .35986 L 1 .884 0 r
F
P
p
.73872 .35603 m .75388 .35795 L .7434 .35984 L .125 1 0 r
F
P
p
.72825 .35793 m .73872 .35603 L .7434 .35984 L 0 1 .116 r
F
P
p
.71301 .35601 m .72825 .35793 L .71784 .35982 L 0 1 .119 r
F
P
p
.70261 .35791 m .71301 .35601 L .71784 .35982 L 0 1 .562 r
F
P
p
.6873 .35599 m .70261 .35791 L .69227 .3598 L 0 1 .934 r
F
P
p
.67698 .35789 m .6873 .35599 L .69227 .3598 L 0 .995 1 r
F
P
p
.66159 .35597 m .67698 .35789 L .66671 .35978 L 0 .231 1 r
F
P
p
.65134 .35787 m .66159 .35597 L .66671 .35978 L 0 .063 1 r
F
P
p
.63589 .35595 m .65134 .35787 L .64114 .35976 L 1 0 .868 r
F
P
p
.6257 .35785 m .63589 .35595 L .64114 .35976 L 1 0 .776 r
F
P
p
.61017 .35593 m .6257 .35785 L .61558 .35974 L 1 0 .587 r
F
P
p
.60006 .35783 m .61017 .35593 L .61558 .35974 L 1 0 .587 r
F
P
p
.58446 .35591 m .60006 .35783 L .59001 .35972 L 1 0 .587 r
F
P
p
.57442 .35781 m .58446 .35591 L .59001 .35972 L 1 0 .587 r
F
P
p
.55875 .35589 m .57442 .35781 L .56444 .3597 L 1 0 .362 r
F
P
p
.54878 .35779 m .55875 .35589 L .56444 .3597 L 1 0 .362 r
F
P
p
.53303 .35587 m .54878 .35779 L .53886 .35968 L 1 0 .136 r
F
P
p
.52313 .35777 m .53303 .35587 L .53886 .35968 L 1 0 .136 r
F
P
p
.50731 .35585 m .52313 .35777 L .51329 .35966 L 1 0 .136 r
F
P
p
.49749 .35775 m .50731 .35585 L .51329 .35966 L 1 0 .136 r
F
P
p
.4816 .35583 m .49749 .35775 L .48771 .35964 L 1 0 .136 r
F
P
p
.47184 .35773 m .4816 .35583 L .48771 .35964 L 1 0 .136 r
F
P
p
.45588 .35581 m .47184 .35773 L .46214 .35962 L 1 0 .136 r
F
P
p
.44619 .35771 m .45588 .35581 L .46214 .35962 L 1 0 .136 r
F
P
p
.43015 .35579 m .44619 .35771 L .43656 .35961 L 1 0 .136 r
F
P
p
.42054 .35769 m .43015 .35579 L .43656 .35961 L 1 0 .136 r
F
P
p
.40443 .35577 m .42054 .35769 L .41098 .35959 L 1 0 .136 r
F
P
p
.39489 .35767 m .40443 .35577 L .41098 .35959 L 1 0 .136 r
F
P
p
.37871 .35575 m .39489 .35767 L .3854 .35957 L 1 0 .102 r
F
P
p
.36924 .35766 m .37871 .35575 L .3854 .35957 L 1 0 .068 r
F
P
p
.35298 .35573 m .36924 .35766 L .35982 .35955 L 1 0 0 r
F
P
p
.34358 .35764 m .35298 .35573 L .35982 .35955 L 1 0 0 r
F
P
p
.32725 .35571 m .34358 .35764 L .33423 .35953 L 1 0 0 r
F
P
p
.31792 .35762 m .32725 .35571 L .33423 .35953 L 1 0 0 r
F
P
p
.77502 .35413 m .79012 .35607 L .77951 .35797 L 1 .732 0 r
F
P
p
.76442 .35605 m .77502 .35413 L .77951 .35797 L 1 .781 0 r
F
P
p
.74924 .35411 m .76442 .35605 L .75388 .35795 L .621 1 0 r
F
P
p
.73872 .35603 m .74924 .35411 L .75388 .35795 L .125 1 0 r
F
P
p
.72346 .35409 m .73872 .35603 L .72825 .35793 L 0 1 .048 r
F
P
p
.71301 .35601 m .72346 .35409 L .72825 .35793 L 0 1 .119 r
F
P
p
.69769 .35407 m .71301 .35601 L .70261 .35791 L 0 1 .284 r
F
P
p
.6873 .35599 m .69769 .35407 L .70261 .35791 L 0 1 .934 r
F
P
p
.67191 .35406 m .6873 .35599 L .67698 .35789 L 0 .504 1 r
F
P
p
.66159 .35597 m .67191 .35406 L .67698 .35789 L 0 .231 1 r
F
P
p
.64613 .35404 m .66159 .35597 L .65134 .35787 L 1 0 .985 r
F
P
p
.63589 .35595 m .64613 .35404 L .65134 .35787 L 1 0 .868 r
F
P
p
.62034 .35402 m .63589 .35595 L .6257 .35785 L 1 0 .65 r
F
P
p
.61017 .35593 m .62034 .35402 L .6257 .35785 L 1 0 .587 r
F
P
p
.59456 .354 m .61017 .35593 L .60006 .35783 L 1 0 .611 r
F
P
p
.58446 .35591 m .59456 .354 L .60006 .35783 L 1 0 .587 r
F
P
p
.56877 .35398 m .58446 .35591 L .57442 .35781 L 1 0 .362 r
F
P
p
.55875 .35589 m .56877 .35398 L .57442 .35781 L 1 0 .362 r
F
P
p
.54299 .35396 m .55875 .35589 L .54878 .35779 L 1 0 .136 r
F
P
p
.53303 .35587 m .54299 .35396 L .54878 .35779 L 1 0 .136 r
F
P
p
.5172 .35394 m .53303 .35587 L .52313 .35777 L 1 0 .136 r
F
P
p
.50731 .35585 m .5172 .35394 L .52313 .35777 L 1 0 .136 r
F
P
p
.49141 .35392 m .50731 .35585 L .49749 .35775 L 1 0 .136 r
F
P
p
.4816 .35583 m .49141 .35392 L .49749 .35775 L 1 0 .136 r
F
P
p
.46562 .3539 m .4816 .35583 L .47184 .35773 L 1 0 .136 r
F
P
p
.45588 .35581 m .46562 .3539 L .47184 .35773 L 1 0 .136 r
F
P
p
.43982 .35388 m .45588 .35581 L .44619 .35771 L 1 0 .136 r
F
P
p
.43015 .35579 m .43982 .35388 L .44619 .35771 L 1 0 .136 r
F
P
p
.41403 .35386 m .43015 .35579 L .42054 .35769 L 1 0 .136 r
F
P
p
.40443 .35577 m .41403 .35386 L .42054 .35769 L 1 0 .136 r
F
P
p
.38823 .35384 m .40443 .35577 L .39489 .35767 L 1 0 .136 r
F
P
p
.37871 .35575 m .38823 .35384 L .39489 .35767 L 1 0 .102 r
F
P
p
.36243 .35382 m .37871 .35575 L .36924 .35766 L 1 0 .034 r
F
P
p
.35298 .35573 m .36243 .35382 L .36924 .35766 L 1 0 0 r
F
P
p
.33664 .3538 m .35298 .35573 L .34358 .35764 L 1 0 0 r
F
P
p
.32725 .35571 m .33664 .3538 L .34358 .35764 L 1 0 0 r
F
P
p
.31084 .35378 m .32725 .35571 L .31792 .35762 L 1 0 0 r
F
P
p
.78567 .35221 m .80079 .35415 L .79012 .35607 L 1 .682 0 r
F
P
p
.77502 .35413 m .78567 .35221 L .79012 .35607 L 1 .732 0 r
F
P
p
.75983 .35219 m .77502 .35413 L .76442 .35605 L 1 .986 0 r
F
P
p
.74924 .35411 m .75983 .35219 L .76442 .35605 L .621 1 0 r
F
P
p
.73398 .35217 m .74924 .35411 L .73872 .35603 L .125 1 0 r
F
P
p
.72346 .35409 m .73398 .35217 L .73872 .35603 L 0 1 .048 r
F
P
p
.70813 .35215 m .72346 .35409 L .71301 .35601 L .602 1 0 r
F
P
p
.69769 .35407 m .70813 .35215 L .71301 .35601 L 0 1 .284 r
F
P
p
.68228 .35213 m .69769 .35407 L .6873 .35599 L 0 .85 1 r
F
P
p
.67191 .35406 m .68228 .35213 L .6873 .35599 L 0 .504 1 r
F
P
p
.65642 .35211 m .67191 .35406 L .66159 .35597 L .917 0 1 r
F
P
p
.64613 .35404 m .65642 .35211 L .66159 .35597 L 1 0 .985 r
F
P
p
.63057 .35209 m .64613 .35404 L .63589 .35595 L 1 0 .713 r
F
P
p
.62034 .35402 m .63057 .35209 L .63589 .35595 L 1 0 .65 r
F
P
p
.60471 .35207 m .62034 .35402 L .61017 .35593 L 1 0 .674 r
F
P
p
.59456 .354 m .60471 .35207 L .61017 .35593 L 1 0 .611 r
F
P
p
.57885 .35205 m .59456 .354 L .58446 .35591 L 1 0 .362 r
F
P
p
.56877 .35398 m .57885 .35205 L .58446 .35591 L 1 0 .362 r
F
P
p
.553 .35203 m .56877 .35398 L .55875 .35589 L 1 0 .136 r
F
P
p
.54299 .35396 m .553 .35203 L .55875 .35589 L 1 0 .136 r
F
P
p
.52713 .35201 m .54299 .35396 L .53303 .35587 L 1 0 .136 r
F
P
p
.5172 .35394 m .52713 .35201 L .53303 .35587 L 1 0 .136 r
F
P
p
.50127 .35199 m .5172 .35394 L .50731 .35585 L 1 0 .136 r
F
P
p
.49141 .35392 m .50127 .35199 L .50731 .35585 L 1 0 .136 r
F
P
p
.47541 .35197 m .49141 .35392 L .4816 .35583 L 1 0 .136 r
F
P
p
.46562 .3539 m .47541 .35197 L .4816 .35583 L 1 0 .136 r
F
P
p
.44954 .35195 m .46562 .3539 L .45588 .35581 L 1 0 .136 r
F
P
p
.43982 .35388 m .44954 .35195 L .45588 .35581 L 1 0 .136 r
F
P
p
.42368 .35193 m .43982 .35388 L .43015 .35579 L 1 0 .136 r
F
P
p
.41403 .35386 m .42368 .35193 L .43015 .35579 L 1 0 .136 r
F
P
p
.39781 .35191 m .41403 .35386 L .40443 .35577 L 1 0 .136 r
F
P
p
.38823 .35384 m .39781 .35191 L .40443 .35577 L 1 0 .136 r
F
P
p
.37194 .35189 m .38823 .35384 L .37871 .35575 L 1 0 .102 r
F
P
p
.36243 .35382 m .37194 .35189 L .37871 .35575 L 1 0 .034 r
F
P
p
.34607 .35188 m .36243 .35382 L .35298 .35573 L 1 0 0 r
F
P
p
.33664 .3538 m .34607 .35188 L .35298 .35573 L 1 0 0 r
F
P
p
.3202 .35186 m .33664 .3538 L .32725 .35571 L 1 0 0 r
F
P
p
.31084 .35378 m .3202 .35186 L .32725 .35571 L 1 0 0 r
F
P
p
.79639 .35028 m .81152 .35223 L .80079 .35415 L 1 .477 0 r
F
P
p
.78567 .35221 m .79639 .35028 L .80079 .35415 L 1 .682 0 r
F
P
p
.77047 .35026 m .78567 .35221 L .77502 .35413 L 1 .936 0 r
F
P
p
.75983 .35219 m .77047 .35026 L .77502 .35413 L 1 .986 0 r
F
P
p
.74455 .35024 m .75983 .35219 L .74924 .35411 L .568 1 0 r
F
P
p
.73398 .35217 m .74455 .35024 L .74924 .35411 L .125 1 0 r
F
P
p
.71863 .35022 m .73398 .35217 L .72346 .35409 L .909 1 0 r
F
P
p
.70813 .35215 m .71863 .35022 L .72346 .35409 L .602 1 0 r
F
P
p
.6927 .3502 m .70813 .35215 L .69769 .35407 L 0 1 .83 r
F
P
p
.68228 .35213 m .6927 .3502 L .69769 .35407 L 0 .85 1 r
F
P
p
.66678 .35018 m .68228 .35213 L .67191 .35406 L .645 0 1 r
F
P
p
.65642 .35211 m .66678 .35018 L .67191 .35406 L .917 0 1 r
F
P
p
.64085 .35016 m .65642 .35211 L .64613 .35404 L 1 0 .713 r
F
P
p
.63057 .35209 m .64085 .35016 L .64613 .35404 L 1 0 .713 r
F
P
p
.61492 .35014 m .63057 .35209 L .62034 .35402 L 1 0 .831 r
F
P
p
.60471 .35207 m .61492 .35014 L .62034 .35402 L 1 0 .674 r
F
P
p
.58899 .35012 m .60471 .35207 L .59456 .354 L 1 0 .385 r
F
P
p
.57885 .35205 m .58899 .35012 L .59456 .354 L 1 0 .362 r
F
P
p
.56306 .3501 m .57885 .35205 L .56877 .35398 L 1 0 .136 r
F
P
p
.553 .35203 m .56306 .3501 L .56877 .35398 L 1 0 .136 r
F
P
p
.53713 .35008 m .553 .35203 L .54299 .35396 L 1 0 .136 r
F
P
p
.52713 .35201 m .53713 .35008 L .54299 .35396 L 1 0 .136 r
F
P
p
.51119 .35006 m .52713 .35201 L .5172 .35394 L 1 0 .136 r
F
P
p
.50127 .35199 m .51119 .35006 L .5172 .35394 L 1 0 .136 r
F
P
p
.48526 .35004 m .50127 .35199 L .49141 .35392 L 1 0 .136 r
F
P
p
.47541 .35197 m .48526 .35004 L .49141 .35392 L 1 0 .136 r
F
P
p
.45932 .35002 m .47541 .35197 L .46562 .3539 L 1 0 .136 r
F
P
p
.44954 .35195 m .45932 .35002 L .46562 .3539 L 1 0 .136 r
F
P
p
.43338 .35 m .44954 .35195 L .43982 .35388 L 1 0 .136 r
F
P
p
.42368 .35193 m .43338 .35 L .43982 .35388 L 1 0 .136 r
F
P
p
.40744 .34998 m .42368 .35193 L .41403 .35386 L 1 0 .136 r
F
P
p
.39781 .35191 m .40744 .34998 L .41403 .35386 L 1 0 .136 r
F
P
p
.3815 .34996 m .39781 .35191 L .38823 .35384 L 1 0 .136 r
F
P
p
.37194 .35189 m .3815 .34996 L .38823 .35384 L 1 0 .102 r
F
P
p
.35556 .34994 m .37194 .35189 L .36243 .35382 L 1 0 .034 r
F
P
p
.34607 .35188 m .35556 .34994 L .36243 .35382 L 1 0 0 r
F
P
p
.32961 .34992 m .34607 .35188 L .33664 .3538 L 1 0 0 r
F
P
p
.3202 .35186 m .32961 .34992 L .33664 .3538 L 1 0 0 r
F
P
p
.30367 .3499 m .3202 .35186 L .31084 .35378 L 1 0 0 r
F
P
p
.002 w
.62182 .76308 m .61175 .77563 L .60714 .86504 L p
.275 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61175 .77563 m .6024 .86654 L .59682 .86554 L p
.684 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59682 .86554 m .60714 .86504 L .61175 .77563 L p
.684 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56194 .89147 m .55761 .91939 L .55879 .91928 L p
1 0 .395 r
F P
0 0 0 r
s
P
p
.002 w
.57194 .8741 m .56194 .89147 L p
.55879 .91928 L 1 0 .395 r
F P
0 0 0 r
s
P
p
.002 w
.56194 .89147 m .55198 .92025 L .54985 .91965 L p
1 0 .181 r
F P
0 0 0 r
s
P
p
.002 w
.54985 .91965 m .55761 .91939 L .56194 .89147 L p
1 0 .181 r
F P
0 0 0 r
s
P
p
.002 w
.63207 .7623 m .62182 .76308 L .61752 .86454 L p
0 .134 1 r
F P
0 0 0 r
s
P
p
.002 w
.60714 .86504 m .61752 .86454 L .62182 .76308 L p
.275 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58201 .86751 m .57194 .8741 L .56642 .91888 L p
1 0 .634 r
F P
0 0 0 r
s
P
p
.002 w
.55879 .91928 m .56642 .91888 L .57194 .8741 L p
1 0 .395 r
F P
0 0 0 r
s
P
p
.80717 .34833 m .82231 .3503 L .81152 .35223 L 1 .273 0 r
F
P
p
.79639 .35028 m .80717 .34833 L .81152 .35223 L 1 .477 0 r
F
P
p
.78117 .34831 m .79639 .35028 L .78567 .35221 L 1 .852 0 r
F
P
p
.77047 .35026 m .78117 .34831 L .78567 .35221 L 1 .936 0 r
F
P
p
.75518 .34829 m .77047 .35026 L .75983 .35219 L .909 1 0 r
F
P
p
.74455 .35024 m .75518 .34829 L .75983 .35219 L .568 1 0 r
F
P
p
.72919 .34827 m .74455 .35024 L .73398 .35217 L .962 1 0 r
F
P
p
.71863 .35022 m .72919 .34827 L .73398 .35217 L .909 1 0 r
F
P
p
.70319 .34825 m .71863 .35022 L .70813 .35215 L 0 1 .284 r
F
P
p
.6927 .3502 m .70319 .34825 L .70813 .35215 L 0 1 .83 r
F
P
p
.67719 .34823 m .6927 .3502 L .68228 .35213 L .27 0 1 r
F
P
p
.66678 .35018 m .67719 .34823 L .68228 .35213 L .645 0 1 r
F
P
p
.65119 .34821 m .66678 .35018 L .65642 .35211 L 1 0 .713 r
F
P
p
.64085 .35016 m .65119 .34821 L .65642 .35211 L 1 0 .713 r
F
P
p
.62519 .34819 m .64085 .35016 L .63057 .35209 L .731 0 1 r
F
P
p
.61492 .35014 m .62519 .34819 L .63057 .35209 L 1 0 .831 r
F
P
p
.59919 .34817 m .61492 .35014 L .60471 .35207 L 1 0 .448 r
F
P
p
.58899 .35012 m .59919 .34817 L .60471 .35207 L 1 0 .385 r
F
P
p
.57318 .34815 m .58899 .35012 L .57885 .35205 L 1 0 .136 r
F
P
p
.56306 .3501 m .57318 .34815 L .57885 .35205 L 1 0 .136 r
F
P
p
.54718 .34813 m .56306 .3501 L .553 .35203 L 1 0 .136 r
F
P
p
.53713 .35008 m .54718 .34813 L .553 .35203 L 1 0 .136 r
F
P
p
.52117 .34811 m .53713 .35008 L .52713 .35201 L 1 0 .136 r
F
P
p
.51119 .35006 m .52117 .34811 L .52713 .35201 L 1 0 .136 r
F
P
p
.49516 .34809 m .51119 .35006 L .50127 .35199 L 1 0 .136 r
F
P
p
.48526 .35004 m .49516 .34809 L .50127 .35199 L 1 0 .136 r
F
P
p
.46915 .34807 m .48526 .35004 L .47541 .35197 L 1 0 .136 r
F
P
p
.45932 .35002 m .46915 .34807 L .47541 .35197 L 1 0 .136 r
F
P
p
.44314 .34805 m .45932 .35002 L .44954 .35195 L 1 0 .136 r
F
P
p
.43338 .35 m .44314 .34805 L .44954 .35195 L 1 0 .136 r
F
P
p
.41713 .34803 m .43338 .35 L .42368 .35193 L 1 0 .136 r
F
P
p
.40744 .34998 m .41713 .34803 L .42368 .35193 L 1 0 .136 r
F
P
p
.39111 .34801 m .40744 .34998 L .39781 .35191 L 1 0 .136 r
F
P
p
.3815 .34996 m .39111 .34801 L .39781 .35191 L 1 0 .136 r
F
P
p
.3651 .34799 m .3815 .34996 L .37194 .35189 L 1 0 .068 r
F
P
p
.35556 .34994 m .3651 .34799 L .37194 .35189 L 1 0 .034 r
F
P
p
.33908 .34797 m .35556 .34994 L .34607 .35188 L 1 0 0 r
F
P
p
.32961 .34992 m .33908 .34797 L .34607 .35188 L 1 0 0 r
F
P
p
.31306 .34795 m .32961 .34992 L .3202 .35186 L 1 0 0 r
F
P
p
.30367 .3499 m .31306 .34795 L .3202 .35186 L 1 0 0 r
F
P
p
.002 w
.59218 .86703 m .58201 .86751 L .57648 .88978 L p
1 0 .838 r
F P
0 0 0 r
s
P
p
.002 w
.56642 .91888 m .57648 .88978 L .58201 .86751 L p
1 0 .634 r
F P
0 0 0 r
s
P
p
.002 w
.61752 .86454 m .62684 .77263 L .63207 .7623 L p
0 .134 1 r
F P
0 0 0 r
s
P
p
.002 w
.64215 .74526 m .63207 .7623 L .62684 .77263 L p
0 .609 1 r
F P
0 0 0 r
s
P
p
.818 .34638 m .83316 .34835 L .82231 .3503 L 1 .273 0 r
F
P
p
.80717 .34833 m .818 .34638 L .82231 .3503 L 1 .273 0 r
F
P
p
.79194 .34636 m .80717 .34833 L .79639 .35028 L 1 .716 0 r
F
P
p
.78117 .34831 m .79194 .34636 L .79639 .35028 L 1 .852 0 r
F
P
p
.76587 .34634 m .78117 .34831 L .77047 .35026 L .943 1 0 r
F
P
p
.75518 .34829 m .76587 .34634 L .77047 .35026 L .909 1 0 r
F
P
p
.7398 .34632 m .75518 .34829 L .74455 .35024 L 1 .97 0 r
F
P
p
.72919 .34827 m .7398 .34632 L .74455 .35024 L .962 1 0 r
F
P
p
.71373 .3463 m .72919 .34827 L .71863 .35022 L .023 1 0 r
F
P
p
.70319 .34825 m .71373 .3463 L .71863 .35022 L 0 1 .284 r
F
P
p
.68766 .34628 m .70319 .34825 L .6927 .3502 L 0 .352 1 r
F
P
p
.67719 .34823 m .68766 .34628 L .6927 .3502 L .27 0 1 r
F
P
p
.66159 .34626 m .67719 .34823 L .66678 .35018 L 1 0 .737 r
F
P
p
.65119 .34821 m .66159 .34626 L .66678 .35018 L 1 0 .713 r
F
P
p
.63552 .34624 m .65119 .34821 L .64085 .35016 L .274 0 1 r
F
P
p
.62519 .34819 m .63552 .34624 L .64085 .35016 L .731 0 1 r
F
P
p
.60944 .34622 m .62519 .34819 L .61492 .35014 L 1 0 .605 r
F
P
p
.59919 .34817 m .60944 .34622 L .61492 .35014 L 1 0 .448 r
F
P
p
.58336 .3462 m .59919 .34817 L .58899 .35012 L 1 0 .136 r
F
P
p
.57318 .34815 m .58336 .3462 L .58899 .35012 L 1 0 .136 r
F
P
p
.002 w
.65249 .74443 m .64215 .74526 L .63704 .75992 L p
0 .722 1 r
F P
0 0 0 r
s
P
p
.002 w
.62684 .77263 m .63704 .75992 L .64215 .74526 L p
0 .609 1 r
F P
0 0 0 r
s
P
p
.55729 .34618 m .57318 .34815 L .56306 .3501 L 1 0 .136 r
F
P
p
.54718 .34813 m .55729 .34618 L .56306 .3501 L 1 0 .136 r
F
P
p
.5312 .34616 m .54718 .34813 L .53713 .35008 L 1 0 .136 r
F
P
p
.52117 .34811 m .5312 .34616 L .53713 .35008 L 1 0 .136 r
F
P
p
.50512 .34614 m .52117 .34811 L .51119 .35006 L 1 0 .136 r
F
P
p
.49516 .34809 m .50512 .34614 L .51119 .35006 L 1 0 .136 r
F
P
p
.47904 .34612 m .49516 .34809 L .48526 .35004 L 1 0 .136 r
F
P
p
.46915 .34807 m .47904 .34612 L .48526 .35004 L 1 0 .136 r
F
P
p
.45296 .3461 m .46915 .34807 L .45932 .35002 L 1 0 .136 r
F
P
p
.44314 .34805 m .45296 .3461 L .45932 .35002 L 1 0 .136 r
F
P
p
.42687 .34608 m .44314 .34805 L .43338 .35 L 1 0 .136 r
F
P
p
.41713 .34803 m .42687 .34608 L .43338 .35 L 1 0 .136 r
F
P
p
.40078 .34606 m .41713 .34803 L .40744 .34998 L 1 0 .136 r
F
P
p
.39111 .34801 m .40078 .34606 L .40744 .34998 L 1 0 .136 r
F
P
p
.37469 .34604 m .39111 .34801 L .3815 .34996 L 1 0 .102 r
F
P
p
.3651 .34799 m .37469 .34604 L .3815 .34996 L 1 0 .068 r
F
P
p
.3486 .34602 m .3651 .34799 L .35556 .34994 L 1 0 0 r
F
P
p
.33908 .34797 m .3486 .34602 L .35556 .34994 L 1 0 0 r
F
P
p
.32251 .346 m .33908 .34797 L .32961 .34992 L 1 0 0 r
F
P
p
.31306 .34795 m .32251 .346 L .32961 .34992 L 1 0 0 r
F
P
p
.29641 .34598 m .31306 .34795 L .30367 .3499 L 1 0 0 r
F
P
p
.002 w
.57648 .88978 m .5866 .87221 L .59218 .86703 L p
1 0 .838 r
F P
0 0 0 r
s
P
p
.002 w
.6024 .86654 m .59218 .86703 L .5866 .87221 L p
1 0 .93 r
F P
0 0 0 r
s
P
p
.8289 .34441 m .84407 .3464 L .83316 .34835 L 1 .273 0 r
F
P
p
.818 .34638 m .8289 .34441 L .83316 .34835 L 1 .273 0 r
F
P
p
.80276 .34439 m .818 .34638 L .80717 .34833 L 1 .443 0 r
F
P
p
.79194 .34636 m .80276 .34439 L .80717 .34833 L 1 .716 0 r
F
P
p
.77662 .34437 m .79194 .34636 L .78117 .34831 L 1 .97 0 r
F
P
p
.76587 .34634 m .77662 .34437 L .78117 .34831 L .943 1 0 r
F
P
p
.75048 .34435 m .76587 .34634 L .75518 .34829 L 1 .92 0 r
F
P
p
.7398 .34632 m .75048 .34435 L .75518 .34829 L 1 .97 0 r
F
P
p
.72434 .34433 m .7398 .34632 L .72919 .34827 L .416 1 0 r
F
P
p
.71373 .3463 m .72434 .34433 L .72919 .34827 L .023 1 0 r
F
P
p
.6982 .34431 m .71373 .3463 L .70319 .34825 L 0 .929 1 r
F
P
p
.68766 .34628 m .6982 .34431 L .70319 .34825 L 0 .352 1 r
F
P
p
.67205 .34429 m .68766 .34628 L .67719 .34823 L 1 0 .829 r
F
P
p
.66159 .34626 m .67205 .34429 L .67719 .34823 L 1 0 .737 r
F
P
p
.6459 .34427 m .66159 .34626 L .65119 .34821 L .138 0 1 r
F
P
p
.63552 .34624 m .6459 .34427 L .65119 .34821 L .274 0 1 r
F
P
p
.61975 .34425 m .63552 .34624 L .62519 .34819 L .957 0 1 r
F
P
p
.60944 .34622 m .61975 .34425 L .62519 .34819 L 1 0 .605 r
F
P
p
.5936 .34423 m .60944 .34622 L .59919 .34817 L 1 0 .136 r
F
P
p
.58336 .3462 m .5936 .34423 L .59919 .34817 L 1 0 .136 r
F
P
p
.002 w
.6629 .74359 m .65249 .74443 L .64746 .75913 L p
0 .788 1 r
F P
0 0 0 r
s
P
p
.002 w
.63704 .75992 m .64746 .75913 L .65249 .74443 L p
0 .722 1 r
F P
0 0 0 r
s
P
p
.56745 .34421 m .58336 .3462 L .57318 .34815 L 1 0 .136 r
F
P
p
.55729 .34618 m .56745 .34421 L .57318 .34815 L 1 0 .136 r
F
P
p
.5413 .34419 m .55729 .34618 L .54718 .34813 L 1 0 .136 r
F
P
p
.5312 .34616 m .5413 .34419 L .54718 .34813 L 1 0 .136 r
F
P
p
.51514 .34417 m .5312 .34616 L .52117 .34811 L 1 0 .136 r
F
P
p
.50512 .34614 m .51514 .34417 L .52117 .34811 L 1 0 .136 r
F
P
p
.48898 .34415 m .50512 .34614 L .49516 .34809 L 1 0 .136 r
F
P
p
.47904 .34612 m .48898 .34415 L .49516 .34809 L 1 0 .136 r
F
P
p
.46282 .34413 m .47904 .34612 L .46915 .34807 L 1 0 .136 r
F
P
p
.45296 .3461 m .46282 .34413 L .46915 .34807 L 1 0 .136 r
F
P
p
.43666 .34411 m .45296 .3461 L .44314 .34805 L 1 0 .136 r
F
P
p
.42687 .34608 m .43666 .34411 L .44314 .34805 L 1 0 .136 r
F
P
p
.4105 .34409 m .42687 .34608 L .41713 .34803 L 1 0 .136 r
F
P
p
.40078 .34606 m .4105 .34409 L .41713 .34803 L 1 0 .136 r
F
P
p
.38434 .34407 m .40078 .34606 L .39111 .34801 L 1 0 .136 r
F
P
p
.37469 .34604 m .38434 .34407 L .39111 .34801 L 1 0 .102 r
F
P
p
.35818 .34405 m .37469 .34604 L .3651 .34799 L 1 0 0 r
F
P
p
.3486 .34602 m .35818 .34405 L .3651 .34799 L 1 0 0 r
F
P
p
.33201 .34403 m .3486 .34602 L .33908 .34797 L 1 0 0 r
F
P
p
.32251 .346 m .33201 .34403 L .33908 .34797 L 1 0 0 r
F
P
p
.30584 .34401 m .32251 .346 L .31306 .34795 L 1 0 0 r
F
P
p
.29641 .34598 m .30584 .34401 L .31306 .34795 L 1 0 0 r
F
P
p
.002 w
.5866 .87221 m .59682 .86554 L .6024 .86654 L p
1 0 .93 r
F P
0 0 0 r
s
P
p
.83986 .34243 m .85504 .34443 L .84407 .3464 L 1 .273 0 r
F
P
p
.8289 .34441 m .83986 .34243 L .84407 .3464 L 1 .273 0 r
F
P
p
.81365 .34241 m .8289 .34441 L .818 .34638 L 1 .273 0 r
F
P
p
.80276 .34439 m .81365 .34241 L .818 .34638 L 1 .443 0 r
F
P
p
.78744 .34239 m .80276 .34439 L .79194 .34636 L 1 .868 0 r
F
P
p
.77662 .34437 m .78744 .34239 L .79194 .34636 L 1 .97 0 r
F
P
p
.76122 .34237 m .77662 .34437 L .76587 .34634 L 1 .852 0 r
F
P
p
.75048 .34435 m .76122 .34237 L .76587 .34634 L 1 .92 0 r
F
P
p
.73501 .34235 m .75048 .34435 L .7398 .34632 L 1 .97 0 r
F
P
p
.72434 .34433 m .73501 .34235 L .7398 .34632 L .416 1 0 r
F
P
p
.70879 .34233 m .72434 .34433 L .71373 .3463 L 0 1 .934 r
F
P
p
.6982 .34431 m .70879 .34233 L .71373 .3463 L 0 .929 1 r
F
P
p
.68257 .34231 m .6982 .34431 L .68766 .34628 L .694 0 1 r
F
P
p
.67205 .34429 m .68257 .34231 L .68766 .34628 L 1 0 .829 r
F
P
p
.65634 .34229 m .67205 .34429 L .66159 .34626 L 0 .192 1 r
F
P
p
.6459 .34427 m .65634 .34229 L .66159 .34626 L .138 0 1 r
F
P
p
.63012 .34227 m .6459 .34427 L .63552 .34624 L .5 0 1 r
F
P
p
.61975 .34425 m .63012 .34227 L .63552 .34624 L .957 0 1 r
F
P
p
.6039 .34225 m .61975 .34425 L .60944 .34622 L 1 0 .136 r
F
P
p
.5936 .34423 m .6039 .34225 L .60944 .34622 L 1 0 .136 r
F
P
p
.002 w
.67335 .7421 m .6629 .74359 L .65766 .74189 L p
0 .856 1 r
F P
0 0 0 r
s
P
p
.002 w
.64746 .75913 m .65766 .74189 L .6629 .74359 L p
0 .788 1 r
F P
0 0 0 r
s
P
p
.57767 .34223 m .5936 .34423 L .58336 .3462 L 1 0 .136 r
F
P
p
.56745 .34421 m .57767 .34223 L .58336 .3462 L 1 0 .136 r
F
P
p
.55144 .34221 m .56745 .34421 L .55729 .34618 L 1 0 .136 r
F
P
p
.5413 .34419 m .55144 .34221 L .55729 .34618 L 1 0 .136 r
F
P
p
.52521 .34219 m .5413 .34419 L .5312 .34616 L 1 0 .136 r
F
P
p
.51514 .34417 m .52521 .34219 L .5312 .34616 L 1 0 .136 r
F
P
p
.49898 .34217 m .51514 .34417 L .50512 .34614 L 1 0 .136 r
F
P
p
.48898 .34415 m .49898 .34217 L .50512 .34614 L 1 0 .136 r
F
P
p
.47275 .34215 m .48898 .34415 L .47904 .34612 L 1 0 .136 r
F
P
p
.46282 .34413 m .47275 .34215 L .47904 .34612 L 1 0 .136 r
F
P
p
.44652 .34213 m .46282 .34413 L .45296 .3461 L 1 0 .136 r
F
P
p
.43666 .34411 m .44652 .34213 L .45296 .3461 L 1 0 .136 r
F
P
p
.42028 .34211 m .43666 .34411 L .42687 .34608 L 1 0 .136 r
F
P
p
.4105 .34409 m .42028 .34211 L .42687 .34608 L 1 0 .136 r
F
P
p
.39404 .34209 m .4105 .34409 L .40078 .34606 L 1 0 .136 r
F
P
p
.38434 .34407 m .39404 .34209 L .40078 .34606 L 1 0 .136 r
F
P
p
.36781 .34207 m .38434 .34407 L .37469 .34604 L 1 0 .034 r
F
P
p
.35818 .34405 m .36781 .34207 L .37469 .34604 L 1 0 0 r
F
P
p
.34157 .34205 m .35818 .34405 L .3486 .34602 L 1 0 0 r
F
P
p
.33201 .34403 m .34157 .34205 L .3486 .34602 L 1 0 0 r
F
P
p
.31532 .34203 m .33201 .34403 L .32251 .346 L 1 0 0 r
F
P
p
.30584 .34401 m .31532 .34203 L .32251 .346 L 1 0 0 r
F
P
p
.28908 .34201 m .30584 .34401 L .29641 .34598 L 1 0 0 r
F
P
p
.002 w
.62684 .77263 m .62339 .91609 L .62392 .91607 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63704 .75992 m .62684 .77263 L p
.62392 .91607 L .605 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62684 .77263 m .61752 .86454 L p
.61343 .91643 L 1 0 .839 r
F P
0 0 0 r
s
P
p
.002 w
.61343 .91643 m .62339 .91609 L .62684 .77263 L p
1 0 .839 r
F P
0 0 0 r
s
P
p
.002 w
.57648 .88978 m .57222 .918 L .57343 .91789 L p
1 0 .361 r
F P
0 0 0 r
s
P
p
.002 w
.5866 .87221 m .57648 .88978 L p
.57343 .91789 L 1 0 .361 r
F P
0 0 0 r
s
P
p
.002 w
.57648 .88978 m .56642 .91888 L .56434 .91826 L p
1 0 .181 r
F P
0 0 0 r
s
P
p
.002 w
.56434 .91826 m .57222 .918 L .57648 .88978 L p
1 0 .181 r
F P
0 0 0 r
s
P
p
.002 w
.64746 .75913 m .63704 .75992 L .63331 .88627 L p
.411 0 1 r
F P
0 0 0 r
s
P
p
.62741 .89051 m .63704 .75992 L .62598 .89153 L .605 0 1 r
F
P
p
.002 w
.62553 .91596 m .63331 .88627 L .63704 .75992 L p
.605 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63331 .88627 m .64395 .88583 L .64746 .75913 L p
.411 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63331 .88627 m .62747 .86146 L p
.64068 .88099 L 1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.64395 .88583 m .63331 .88627 L p
.64068 .88099 L 1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.62392 .91607 m .62553 .91596 L p
.62741 .89051 L .605 0 1 r
F P
0 0 0 r
s
P
p
.62741 .89051 m .62598 .89153 L .62392 .91607 L .605 0 1 r
F
P
p
.002 w
.5866 .87221 m .58211 .91759 L .58349 .91753 L p
1 0 .453 r
F P
0 0 0 r
s
P
p
.002 w
.59682 .86554 m .5866 .87221 L p
.58349 .91753 L 1 0 .453 r
F P
0 0 0 r
s
P
p
.002 w
.57343 .91789 m .58211 .91759 L .5866 .87221 L p
1 0 .361 r
F P
0 0 0 r
s
P
p
.85089 .34045 m .86608 .34246 L .85504 .34443 L 1 .233 0 r
F
P
p
.83986 .34243 m .85089 .34045 L .85504 .34443 L 1 .273 0 r
F
P
p
.8246 .34043 m .83986 .34243 L .8289 .34441 L 1 .273 0 r
F
P
p
.81365 .34241 m .8246 .34043 L .8289 .34441 L 1 .273 0 r
F
P
p
.79831 .34041 m .81365 .34241 L .80276 .34439 L 1 .54 0 r
F
P
p
.78744 .34239 m .79831 .34041 L .80276 .34439 L 1 .868 0 r
F
P
p
.77202 .34038 m .78744 .34239 L .77662 .34437 L 1 .766 0 r
F
P
p
.76122 .34237 m .77202 .34038 L .77662 .34437 L 1 .852 0 r
F
P
p
.74573 .34036 m .76122 .34237 L .75048 .34435 L 1 .682 0 r
F
P
p
.73501 .34235 m .74573 .34036 L .75048 .34435 L 1 .97 0 r
F
P
p
.71944 .34034 m .73501 .34235 L .72434 .34433 L 0 1 .523 r
F
P
p
.70879 .34233 m .71944 .34034 L .72434 .34433 L 0 1 .934 r
F
P
p
.69314 .34032 m .70879 .34233 L .6982 .34431 L .186 0 1 r
F
P
p
.68257 .34231 m .69314 .34032 L .6982 .34431 L .694 0 1 r
F
P
p
.002 w
.68353 .72424 m .67335 .7421 L .66816 .74104 L p
0 .927 1 r
F P
0 0 0 r
s
P
p
.002 w
.65766 .74189 m .66816 .74104 L .67335 .7421 L p
0 .856 1 r
F P
0 0 0 r
s
P
p
.66685 .3403 m .68257 .34231 L .67205 .34429 L 0 .698 1 r
F
P
p
.65634 .34229 m .66685 .3403 L .67205 .34429 L 0 .192 1 r
F
P
p
.64055 .34028 m .65634 .34229 L .6459 .34427 L .364 0 1 r
F
P
p
.63012 .34227 m .64055 .34028 L .6459 .34427 L .5 0 1 r
F
P
p
.61425 .34026 m .63012 .34227 L .61975 .34425 L 1 0 .136 r
F
P
p
.6039 .34225 m .61425 .34026 L .61975 .34425 L 1 0 .136 r
F
P
p
.58795 .34024 m .6039 .34225 L .5936 .34423 L 1 0 .136 r
F
P
p
.57767 .34223 m .58795 .34024 L .5936 .34423 L 1 0 .136 r
F
P
p
.56165 .34022 m .57767 .34223 L .56745 .34421 L 1 0 .136 r
F
P
p
.55144 .34221 m .56165 .34022 L .56745 .34421 L 1 0 .136 r
F
P
p
.53534 .3402 m .55144 .34221 L .5413 .34419 L 1 0 .136 r
F
P
p
.52521 .34219 m .53534 .3402 L .5413 .34419 L 1 0 .136 r
F
P
p
.50904 .34018 m .52521 .34219 L .51514 .34417 L 1 0 .136 r
F
P
p
.49898 .34217 m .50904 .34018 L .51514 .34417 L 1 0 .136 r
F
P
p
.48273 .34016 m .49898 .34217 L .48898 .34415 L 1 0 .136 r
F
P
p
.47275 .34215 m .48273 .34016 L .48898 .34415 L 1 0 .136 r
F
P
p
.45642 .34014 m .47275 .34215 L .46282 .34413 L 1 0 .136 r
F
P
p
.44652 .34213 m .45642 .34014 L .46282 .34413 L 1 0 .136 r
F
P
p
.43011 .34012 m .44652 .34213 L .43666 .34411 L 1 0 .136 r
F
P
p
.42028 .34211 m .43011 .34012 L .43666 .34411 L 1 0 .136 r
F
P
p
.4038 .3401 m .42028 .34211 L .4105 .34409 L 1 0 .136 r
F
P
p
.39404 .34209 m .4038 .3401 L .4105 .34409 L 1 0 .136 r
F
P
p
.37749 .34008 m .39404 .34209 L .38434 .34407 L 1 0 .068 r
F
P
p
.36781 .34207 m .37749 .34008 L .38434 .34407 L 1 0 .034 r
F
P
p
.35118 .34006 m .36781 .34207 L .35818 .34405 L 1 0 0 r
F
P
p
.34157 .34205 m .35118 .34006 L .35818 .34405 L 1 0 0 r
F
P
p
.32486 .34004 m .34157 .34205 L .33201 .34403 L 1 0 0 r
F
P
p
.31532 .34203 m .32486 .34004 L .33201 .34403 L 1 0 0 r
F
P
p
.29854 .34002 m .31532 .34203 L .30584 .34401 L 1 0 0 r
F
P
p
.28908 .34201 m .29854 .34002 L .30584 .34401 L 1 0 0 r
F
P
p
.002 w
.73437 .62626 m .72393 .63581 L .72052 .69297 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71476 .69595 m .70412 .69693 L .69965 .7206 L p
0 1 .659 r
F P
0 0 0 r
s
P
p
.002 w
.69965 .7206 m .71038 .71968 L .71476 .69595 L p
0 1 .659 r
F P
0 0 0 r
s
P
p
.002 w
.72393 .63581 m .71476 .69595 L .71038 .71968 L p
0 1 .318 r
F P
0 0 0 r
s
P
p
.002 w
.71038 .71968 m .72052 .69297 L .72393 .63581 L p
0 1 .318 r
F P
0 0 0 r
s
P
p
.002 w
.69408 .72334 m .68353 .72424 L .67873 .74019 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.002 w
.66816 .74104 m .67873 .74019 L .68353 .72424 L p
0 .927 1 r
F P
0 0 0 r
s
P
p
.002 w
.59682 .86554 m .59239 .91723 L .59387 .91718 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.60714 .86504 m .59682 .86554 L p
.59387 .91718 L 1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.58349 .91753 m .59239 .91723 L .59682 .86554 L p
1 0 .453 r
F P
0 0 0 r
s
P
p
.74133 .62899 m .74461 .6083 L .73362 .6425 L .432 1 0 r
F
P
p
.002 w
.73362 .6425 m .73133 .69197 L p
.74133 .62899 L .432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73133 .69197 m .74028 .62269 L .74461 .6083 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75536 .60707 m .74461 .6083 L .74028 .62269 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74028 .62269 m .75061 .60457 L .75418 .60645 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75418 .60645 m .75536 .60707 L p
.75161 .61096 L .841 1 0 r
F P
0 0 0 r
s
P
p
.74028 .62269 m .75418 .60645 L .75161 .61096 L .841 1 0 r
F
P
p
.002 w
.74461 .6083 m .73437 .62626 L .73362 .6425 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72052 .69297 m .73133 .69197 L .73437 .62626 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65766 .74189 m .64746 .75913 L .64395 .88583 L p
.345 0 1 r
F P
0 0 0 r
s
P
p
.86197 .33845 m .87717 .34047 L .86608 .34246 L 1 .163 0 r
F
P
p
.85089 .34045 m .86197 .33845 L .86608 .34246 L 1 .233 0 r
F
P
p
.83561 .33843 m .85089 .34045 L .83986 .34243 L 1 .273 0 r
F
P
p
.8246 .34043 m .83561 .33843 L .83986 .34243 L 1 .273 0 r
F
P
p
.80925 .3384 m .8246 .34043 L .81365 .34241 L 1 .262 0 r
F
P
p
.79831 .34041 m .80925 .3384 L .81365 .34241 L 1 .54 0 r
F
P
p
.78288 .33838 m .79831 .34041 L .78744 .34239 L 1 .636 0 r
F
P
p
.77202 .34038 m .78288 .33838 L .78744 .34239 L 1 .766 0 r
F
P
p
.75652 .33836 m .77202 .34038 L .76122 .34237 L 1 .586 0 r
F
P
p
.74573 .34036 m .75652 .33836 L .76122 .34237 L 1 .682 0 r
F
P
p
.73015 .33834 m .74573 .34036 L .73501 .34235 L .023 1 0 r
F
P
p
.71944 .34034 m .73015 .33834 L .73501 .34235 L 0 1 .523 r
F
P
p
.002 w
.70412 .69693 m .69408 .72334 L .68936 .73933 L p
0 1 .832 r
F P
0 0 0 r
s
P
p
.002 w
.68936 .73933 m .69965 .7206 L .70412 .69693 L p
0 1 .832 r
F P
0 0 0 r
s
P
p
.70378 .33832 m .71944 .34034 L .70879 .34233 L 0 .068 1 r
F
P
p
.69314 .34032 m .70378 .33832 L .70879 .34233 L .186 0 1 r
F
P
p
.67741 .3383 m .69314 .34032 L .68257 .34231 L 0 .874 1 r
F
P
p
.66685 .3403 m .67741 .3383 L .68257 .34231 L 0 .698 1 r
F
P
p
.65104 .33828 m .66685 .3403 L .65634 .34229 L .057 0 1 r
F
P
p
.64055 .34028 m .65104 .33828 L .65634 .34229 L .364 0 1 r
F
P
p
.62466 .33826 m .64055 .34028 L .63012 .34227 L 1 0 .136 r
F
P
p
.61425 .34026 m .62466 .33826 L .63012 .34227 L 1 0 .136 r
F
P
p
.59829 .33824 m .61425 .34026 L .6039 .34225 L 1 0 .136 r
F
P
p
.58795 .34024 m .59829 .33824 L .6039 .34225 L 1 0 .136 r
F
P
p
.002 w
.66816 .74104 m .65766 .74189 L .65465 .88537 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64395 .88583 m .65465 .88537 L .65766 .74189 L p
.345 0 1 r
F P
0 0 0 r
s
P
p
.57191 .33822 m .58795 .34024 L .57767 .34223 L 1 0 .136 r
F
P
p
.56165 .34022 m .57191 .33822 L .57767 .34223 L 1 0 .136 r
F
P
p
.54553 .3382 m .56165 .34022 L .55144 .34221 L 1 0 .136 r
F
P
p
.53534 .3402 m .54553 .3382 L .55144 .34221 L 1 0 .136 r
F
P
p
.51915 .33818 m .53534 .3402 L .52521 .34219 L 1 0 .136 r
F
P
p
.50904 .34018 m .51915 .33818 L .52521 .34219 L 1 0 .136 r
F
P
p
.49277 .33816 m .50904 .34018 L .49898 .34217 L 1 0 .136 r
F
P
p
.48273 .34016 m .49277 .33816 L .49898 .34217 L 1 0 .136 r
F
P
p
.46639 .33814 m .48273 .34016 L .47275 .34215 L 1 0 .136 r
F
P
p
.45642 .34014 m .46639 .33814 L .47275 .34215 L 1 0 .136 r
F
P
p
.44 .33812 m .45642 .34014 L .44652 .34213 L 1 0 .136 r
F
P
p
.43011 .34012 m .44 .33812 L .44652 .34213 L 1 0 .136 r
F
P
p
.41362 .3381 m .43011 .34012 L .42028 .34211 L 1 0 .136 r
F
P
p
.4038 .3401 m .41362 .3381 L .42028 .34211 L 1 0 .136 r
F
P
p
.38723 .33808 m .4038 .3401 L .39404 .34209 L 1 0 .102 r
F
P
p
.37749 .34008 m .38723 .33808 L .39404 .34209 L 1 0 .068 r
F
P
p
.36084 .33805 m .37749 .34008 L .36781 .34207 L 1 0 0 r
F
P
p
.35118 .34006 m .36084 .33805 L .36781 .34207 L 1 0 0 r
F
P
p
.33445 .33803 m .35118 .34006 L .34157 .34205 L 1 0 0 r
F
P
p
.32486 .34004 m .33445 .33803 L .34157 .34205 L 1 0 0 r
F
P
p
.30806 .33801 m .32486 .34004 L .31532 .34203 L 1 0 0 r
F
P
p
.29854 .34002 m .30806 .33801 L .31532 .34203 L 1 0 0 r
F
P
p
.28166 .33799 m .29854 .34002 L .28908 .34201 L 1 0 0 r
F
P
p
.002 w
.67873 .74019 m .68936 .73933 L .69408 .72334 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.002 w
.60714 .86504 m .60282 .91687 L .60431 .91682 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.61752 .86454 m .60714 .86504 L p
.60431 .91682 L 1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.59387 .91718 m .60282 .91687 L .60714 .86504 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.87312 .33643 m .88833 .33847 L .87717 .34047 L 1 .1 0 r
F
P
p
.86197 .33845 m .87312 .33643 L .87717 .34047 L 1 .163 0 r
F
P
p
.84669 .33641 m .86197 .33845 L .85089 .34045 L 1 .239 0 r
F
P
p
.83561 .33843 m .84669 .33641 L .85089 .34045 L 1 .273 0 r
F
P
p
.82025 .33639 m .83561 .33843 L .8246 .34043 L 1 .233 0 r
F
P
p
.80925 .3384 m .82025 .33639 L .8246 .34043 L 1 .262 0 r
F
P
p
.79381 .33637 m .80925 .3384 L .79831 .34041 L 1 .445 0 r
F
P
p
.78288 .33838 m .79381 .33637 L .79831 .34041 L 1 .636 0 r
F
P
p
.76737 .33635 m .78288 .33838 L .77202 .34038 L 1 .518 0 r
F
P
p
.75652 .33836 m .76737 .33635 L .77202 .34038 L 1 .586 0 r
F
P
p
.002 w
.76577 .5929 m .75536 .60707 L .75061 .60457 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.74092 .33633 m .75652 .33836 L .74573 .34036 L .261 1 0 r
F
P
p
.73015 .33834 m .74092 .33633 L .74573 .34036 L .023 1 0 r
F
P
p
.71448 .33631 m .73015 .33834 L .71944 .34034 L 0 .577 1 r
F
P
p
.70378 .33832 m .71448 .33631 L .71944 .34034 L 0 .068 1 r
F
P
p
.68803 .33629 m .70378 .33832 L .69314 .34032 L 0 .942 1 r
F
P
p
.67741 .3383 m .68803 .33629 L .69314 .34032 L 0 .874 1 r
F
P
p
.66159 .33627 m .67741 .3383 L .66685 .3403 L 0 .499 1 r
F
P
p
.65104 .33828 m .66159 .33627 L .66685 .3403 L .057 0 1 r
F
P
p
.63514 .33625 m .65104 .33828 L .64055 .34028 L 1 0 .136 r
F
P
p
.62466 .33826 m .63514 .33625 L .64055 .34028 L 1 0 .136 r
F
P
p
.60869 .33623 m .62466 .33826 L .61425 .34026 L 1 0 .136 r
F
P
p
.59829 .33824 m .60869 .33623 L .61425 .34026 L 1 0 .136 r
F
P
p
.002 w
.67873 .74019 m .66816 .74104 L .66542 .88492 L p
.188 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65465 .88537 m .66542 .88492 L .66816 .74104 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.58223 .33621 m .59829 .33824 L .58795 .34024 L 1 0 .136 r
F
P
p
.57191 .33822 m .58223 .33621 L .58795 .34024 L 1 0 .136 r
F
P
p
.55578 .33619 m .57191 .33822 L .56165 .34022 L 1 0 .136 r
F
P
p
.54553 .3382 m .55578 .33619 L .56165 .34022 L 1 0 .136 r
F
P
p
.52933 .33617 m .54553 .3382 L .53534 .3402 L 1 0 .136 r
F
P
p
.51915 .33818 m .52933 .33617 L .53534 .3402 L 1 0 .136 r
F
P
p
.50287 .33614 m .51915 .33818 L .50904 .34018 L 1 0 .136 r
F
P
p
.49277 .33816 m .50287 .33614 L .50904 .34018 L 1 0 .136 r
F
P
p
.47641 .33612 m .49277 .33816 L .48273 .34016 L 1 0 .136 r
F
P
p
.46639 .33814 m .47641 .33612 L .48273 .34016 L 1 0 .136 r
F
P
p
.44995 .3361 m .46639 .33814 L .45642 .34014 L 1 0 .136 r
F
P
p
.44 .33812 m .44995 .3361 L .45642 .34014 L 1 0 .136 r
F
P
p
.42349 .33608 m .44 .33812 L .43011 .34012 L 1 0 .136 r
F
P
p
.41362 .3381 m .42349 .33608 L .43011 .34012 L 1 0 .136 r
F
P
p
.39703 .33606 m .41362 .3381 L .4038 .3401 L 1 0 .136 r
F
P
p
.38723 .33808 m .39703 .33606 L .4038 .3401 L 1 0 .102 r
F
P
p
.37056 .33604 m .38723 .33808 L .37749 .34008 L 1 0 0 r
F
P
p
.36084 .33805 m .37056 .33604 L .37749 .34008 L 1 0 0 r
F
P
p
.34409 .33602 m .36084 .33805 L .35118 .34006 L 1 0 0 r
F
P
p
.33445 .33803 m .34409 .33602 L .35118 .34006 L 1 0 0 r
F
P
p
.31763 .336 m .33445 .33803 L .32486 .34004 L 1 0 0 r
F
P
p
.30806 .33801 m .31763 .336 L .32486 .34004 L 1 0 0 r
F
P
p
.29116 .33598 m .30806 .33801 L .29854 .34002 L 1 0 0 r
F
P
p
.28166 .33799 m .29116 .33598 L .29854 .34002 L 1 0 0 r
F
P
p
.002 w
.77622 .57935 m .76577 .5929 L .76148 .60332 L p
1 .884 0 r
F P
0 0 0 r
s
P
p
.002 w
.75061 .60457 m .76148 .60332 L .76577 .5929 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61752 .86454 m .61331 .91651 L .61343 .91643 L p
1 0 .839 r
F P
0 0 0 r
s
P
p
.002 w
.60431 .91682 m .61331 .91651 L .61752 .86454 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.78712 .57803 m .77622 .57935 L .77198 .58903 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.002 w
.76148 .60332 m .77198 .58903 L .77622 .57935 L p
1 .884 0 r
F P
0 0 0 r
s
P
p
.88434 .33441 m .89956 .33646 L .88833 .33847 L 1 .068 0 r
F
P
p
.87312 .33643 m .88434 .33441 L .88833 .33847 L 1 .1 0 r
F
P
p
.85783 .33439 m .87312 .33643 L .86197 .33845 L 1 .202 0 r
F
P
p
.84669 .33641 m .85783 .33439 L .86197 .33845 L 1 .239 0 r
F
P
p
.83131 .33437 m .84669 .33641 L .83561 .33843 L 1 .205 0 r
F
P
p
.82025 .33639 m .83131 .33437 L .83561 .33843 L 1 .233 0 r
F
P
p
.8048 .33435 m .82025 .33639 L .80925 .3384 L 1 .296 0 r
F
P
p
.79381 .33637 m .8048 .33435 L .80925 .3384 L 1 .445 0 r
F
P
p
.77828 .33433 m .79381 .33637 L .78288 .33838 L 1 .416 0 r
F
P
p
.76737 .33635 m .77828 .33433 L .78288 .33838 L 1 .518 0 r
F
P
p
.75176 .33431 m .76737 .33635 L .75652 .33836 L .595 1 0 r
F
P
p
.74092 .33633 m .75176 .33431 L .75652 .33836 L .261 1 0 r
F
P
p
.72524 .33429 m .74092 .33633 L .73015 .33834 L 0 1 .966 r
F
P
p
.71448 .33631 m .72524 .33429 L .73015 .33834 L 0 .577 1 r
F
P
p
.69872 .33427 m .71448 .33631 L .70378 .33832 L 0 1 .895 r
F
P
p
.68803 .33629 m .69872 .33427 L .70378 .33832 L 0 .942 1 r
F
P
p
.6722 .33424 m .68803 .33629 L .67741 .3383 L 0 .748 1 r
F
P
p
.66159 .33627 m .6722 .33424 L .67741 .3383 L 0 .499 1 r
F
P
p
.64567 .33422 m .66159 .33627 L .65104 .33828 L 1 0 .136 r
F
P
p
.63514 .33625 m .64567 .33422 L .65104 .33828 L 1 0 .136 r
F
P
p
.61914 .3342 m .63514 .33625 L .62466 .33826 L 1 0 .136 r
F
P
p
.60869 .33623 m .61914 .3342 L .62466 .33826 L 1 0 .136 r
F
P
p
.002 w
.68936 .73933 m .67873 .74019 L .6758 .86042 L p
.096 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6758 .86042 m .67873 .74019 L p
.66665 .87149 L .188 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6758 .86042 m .68665 .85989 L .68936 .73933 L p
.096 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6758 .86042 m .6684 .7447 L p
.68498 .8493 L .128 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68665 .85989 m .6758 .86042 L p
.68498 .8493 L .128 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66542 .88492 m .6758 .86042 L p
.66665 .87149 L .188 0 1 r
F P
0 0 0 r
s
P
p
.59262 .33418 m .60869 .33623 L .59829 .33824 L 1 0 .136 r
F
P
p
.58223 .33621 m .59262 .33418 L .59829 .33824 L 1 0 .136 r
F
P
p
.56609 .33416 m .58223 .33621 L .57191 .33822 L 1 0 .136 r
F
P
p
.55578 .33619 m .56609 .33416 L .57191 .33822 L 1 0 .136 r
F
P
p
.53956 .33414 m .55578 .33619 L .54553 .3382 L 1 0 .136 r
F
P
p
.52933 .33617 m .53956 .33414 L .54553 .3382 L 1 0 .136 r
F
P
p
.51302 .33412 m .52933 .33617 L .51915 .33818 L 1 0 .136 r
F
P
p
.50287 .33614 m .51302 .33412 L .51915 .33818 L 1 0 .136 r
F
P
p
.48649 .3341 m .50287 .33614 L .49277 .33816 L 1 0 .136 r
F
P
p
.47641 .33612 m .48649 .3341 L .49277 .33816 L 1 0 .136 r
F
P
p
.45995 .33408 m .47641 .33612 L .46639 .33814 L 1 0 .136 r
F
P
p
.44995 .3361 m .45995 .33408 L .46639 .33814 L 1 0 .136 r
F
P
p
.43342 .33406 m .44995 .3361 L .44 .33812 L 1 0 .136 r
F
P
p
.42349 .33608 m .43342 .33406 L .44 .33812 L 1 0 .136 r
F
P
p
.40688 .33404 m .42349 .33608 L .41362 .3381 L 1 0 .136 r
F
P
p
.39703 .33606 m .40688 .33404 L .41362 .3381 L 1 0 .136 r
F
P
p
.38034 .33402 m .39703 .33606 L .38723 .33808 L 1 0 .068 r
F
P
p
.37056 .33604 m .38034 .33402 L .38723 .33808 L 1 0 0 r
F
P
p
.35379 .33399 m .37056 .33604 L .36084 .33805 L 1 0 0 r
F
P
p
.34409 .33602 m .35379 .33399 L .36084 .33805 L 1 0 0 r
F
P
p
.32725 .33397 m .34409 .33602 L .33445 .33803 L 1 0 0 r
F
P
p
.31763 .336 m .32725 .33397 L .33445 .33803 L 1 0 0 r
F
P
p
.30071 .33395 m .31763 .336 L .30806 .33801 L 1 0 0 r
F
P
p
.29116 .33598 m .30071 .33395 L .30806 .33801 L 1 0 0 r
F
P
p
.27416 .33393 m .29116 .33598 L .28166 .33799 L 1 0 0 r
F
P
p
.002 w
.57745 .9174 m .56953 .91767 L .56493 .88804 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.55474 .91748 m .56493 .88804 L .56953 .91767 L closepath p
1 0 .181 r
F P
0 0 0 r
s
P
p
.002 w
.56493 .88804 m .57525 .8876 L p
.57745 .9174 L 1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.57525 .8876 m .56493 .88804 L .55905 .88715 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.56493 .88804 m .55474 .91748 L .54874 .8876 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.54874 .8876 m .55905 .88715 L .56493 .88804 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.79808 .5767 m .78712 .57803 L .78295 .58772 L p
1 .732 0 r
F P
0 0 0 r
s
P
p
.002 w
.77198 .58903 m .78295 .58772 L .78712 .57803 L p
1 .781 0 r
F P
0 0 0 r
s
P
p
.002 w
.75061 .60457 m .74028 .62269 L .73851 .73315 L p
0 1 .116 r
F P
0 0 0 r
s
P
p
.002 w
.73005 .60076 m .74095 .59949 L .74279 .62562 L p
0 1 .048 r
F P
0 0 0 r
s
P
p
.002 w
.72752 .73404 m .73851 .73315 L .74028 .62269 L p
0 1 .528 r
F P
0 0 0 r
s
P
p
.002 w
.73851 .73315 m .74904 .71403 L .75061 .60457 L p
0 1 .116 r
F P
0 0 0 r
s
P
p
.002 w
.74279 .62562 m .74904 .71403 L p
.73884 .65321 L 0 1 .048 r
F P
0 0 0 r
s
P
p
.002 w
.74028 .62269 m .73133 .69197 L .72796 .72916 L p
0 1 .528 r
F P
0 0 0 r
s
P
p
.72855 .72502 m .74028 .62269 L .72796 .72916 L 0 1 .528 r
F
P
p
.73005 .60076 m .74279 .62562 L .73884 .65321 L 0 1 .048 r
F
P
p
.002 w
.72796 .72916 m .72752 .73404 L p
.72855 .72502 L 0 1 .528 r
F P
0 0 0 r
s
P
p
.89562 .33238 m .91085 .33443 L .89956 .33646 L 1 .034 0 r
F
P
p
.88434 .33441 m .89562 .33238 L .89956 .33646 L 1 .068 0 r
F
P
p
.86903 .33236 m .88434 .33441 L .87312 .33643 L 1 .163 0 r
F
P
p
.85783 .33439 m .86903 .33236 L .87312 .33643 L 1 .202 0 r
F
P
p
.84244 .33233 m .85783 .33439 L .84669 .33641 L 1 .205 0 r
F
P
p
.83131 .33437 m .84244 .33233 L .84669 .33641 L 1 .205 0 r
F
P
p
.81585 .33231 m .83131 .33437 L .82025 .33639 L 1 .233 0 r
F
P
p
.8048 .33435 m .81585 .33231 L .82025 .33639 L 1 .296 0 r
F
P
p
.78925 .33229 m .8048 .33435 L .79381 .33637 L 1 .348 0 r
F
P
p
.77828 .33433 m .78925 .33229 L .79381 .33637 L 1 .416 0 r
F
P
p
.76266 .33227 m .77828 .33433 L .76737 .33635 L .97 1 0 r
F
P
p
.75176 .33431 m .76266 .33227 L .76737 .33635 L .595 1 0 r
F
P
p
.002 w
.76148 .60332 m .75061 .60457 L .74904 .71403 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.73606 .33225 m .75176 .33431 L .74092 .33633 L 0 1 .864 r
F
P
p
.72524 .33429 m .73606 .33225 L .74092 .33633 L 0 1 .966 r
F
P
p
.70946 .33223 m .72524 .33429 L .71448 .33631 L 0 1 .389 r
F
P
p
.69872 .33427 m .70946 .33223 L .71448 .33631 L 0 1 .895 r
F
P
p
.68287 .33221 m .69872 .33427 L .68803 .33629 L 0 .782 1 r
F
P
p
.6722 .33424 m .68287 .33221 L .68803 .33629 L 0 .748 1 r
F
P
p
.65626 .33219 m .6722 .33424 L .66159 .33627 L 1 0 .362 r
F
P
p
.64567 .33422 m .65626 .33219 L .66159 .33627 L 1 0 .136 r
F
P
p
.62966 .33217 m .64567 .33422 L .63514 .33625 L 1 0 .249 r
F
P
p
.61914 .3342 m .62966 .33217 L .63514 .33625 L 1 0 .136 r
F
P
p
.002 w
.68936 .73933 m .68665 .85989 L p
.69859 .73198 L 0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.69965 .7206 m .6901 .73799 L p
.69859 .73198 L 0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.6901 .73799 m .68936 .73933 L p
.69859 .73198 L 0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.69529 .75341 m .69965 .7206 L p
.69517 .76867 L 0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.68665 .85989 m .69529 .75341 L p
.69517 .76867 L 0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.69529 .75341 m .68976 .73493 L p
.69542 .73805 L 0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.70592 .74385 m .70954 .72424 L p
.69563 .75271 L 0 .898 1 r
F P
0 0 0 r
s
P
p
.002 w
.69529 .75341 m .70592 .74385 L p
.69563 .75271 L 0 .898 1 r
F P
0 0 0 r
s
P
p
.69529 .75341 m .70954 .72424 L .70778 .72548 L 0 .898 1 r
F
P
p
.002 w
.71038 .71968 m .69965 .7206 L .69529 .75341 L p
0 .898 1 r
F P
0 0 0 r
s
P
p
.002 w
.72052 .69297 m .71038 .71968 L .70592 .74385 L p
0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.7166 .73493 m .72052 .69297 L p
.7076 .73799 L 0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.70592 .74385 m .7166 .73493 L p
.7076 .73799 L 0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.73133 .69197 m .72052 .69297 L .7166 .73493 L p
0 1 .801 r
F P
0 0 0 r
s
P
p
.002 w
.7166 .73493 m .72752 .73404 L .73133 .69197 L p
0 1 .801 r
F P
0 0 0 r
s
P
p
.002 w
.7166 .73493 m .71109 .71498 L p
.72564 .73186 L 0 1 .562 r
F P
0 0 0 r
s
P
p
.002 w
.72752 .73404 m .7166 .73493 L p
.72564 .73186 L 0 1 .562 r
F P
0 0 0 r
s
P
p
.002 w
.70592 .74385 m .70061 .73403 L p
.71629 .73492 L 0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.7166 .73493 m .70592 .74385 L p
.71629 .73492 L 0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.70592 .74385 m .69529 .75341 L p
.69542 .73805 L 0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.70954 .72424 m .71038 .71968 L p
.70778 .72548 L 0 .898 1 r
F P
0 0 0 r
s
P
p
.60306 .33215 m .61914 .3342 L .60869 .33623 L 1 0 .136 r
F
P
p
.59262 .33418 m .60306 .33215 L .60869 .33623 L 1 0 .136 r
F
P
p
.57645 .33213 m .59262 .33418 L .58223 .33621 L 1 0 .136 r
F
P
p
.56609 .33416 m .57645 .33213 L .58223 .33621 L 1 0 .136 r
F
P
p
.002 w
.53851 .91712 m .54874 .8876 L .55474 .91748 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.54985 .3321 m .56609 .33416 L .55578 .33619 L 1 0 .136 r
F
P
p
.53956 .33414 m .54985 .3321 L .55578 .33619 L 1 0 .136 r
F
P
p
.52324 .33208 m .53956 .33414 L .52933 .33617 L 1 0 .136 r
F
P
p
.51302 .33412 m .52324 .33208 L .52933 .33617 L 1 0 .136 r
F
P
p
.49663 .33206 m .51302 .33412 L .50287 .33614 L 1 0 .136 r
F
P
p
.48649 .3341 m .49663 .33206 L .50287 .33614 L 1 0 .136 r
F
P
p
.47001 .33204 m .48649 .3341 L .47641 .33612 L 1 0 .136 r
F
P
p
.45995 .33408 m .47001 .33204 L .47641 .33612 L 1 0 .136 r
F
P
p
.4434 .33202 m .45995 .33408 L .44995 .3361 L 1 0 .136 r
F
P
p
.43342 .33406 m .4434 .33202 L .44995 .3361 L 1 0 .136 r
F
P
p
.41679 .332 m .43342 .33406 L .42349 .33608 L 1 0 .136 r
F
P
p
.40688 .33404 m .41679 .332 L .42349 .33608 L 1 0 .136 r
F
P
p
.39017 .33198 m .40688 .33404 L .39703 .33606 L 1 0 .136 r
F
P
p
.38034 .33402 m .39017 .33198 L .39703 .33606 L 1 0 .068 r
F
P
p
.36355 .33196 m .38034 .33402 L .37056 .33604 L 1 0 0 r
F
P
p
.35379 .33399 m .36355 .33196 L .37056 .33604 L 1 0 0 r
F
P
p
.33693 .33194 m .35379 .33399 L .34409 .33602 L 1 0 0 r
F
P
p
.32725 .33397 m .33693 .33194 L .34409 .33602 L 1 0 0 r
F
P
p
.31031 .33192 m .32725 .33397 L .31763 .336 L 1 0 0 r
F
P
p
.30071 .33395 m .31031 .33192 L .31763 .336 L 1 0 0 r
F
P
p
.28369 .33189 m .30071 .33395 L .29116 .33598 L 1 0 0 r
F
P
p
.27416 .33393 m .28369 .33189 L .29116 .33598 L 1 0 0 r
F
P
p
.002 w
.57525 .8876 m .57986 .91731 L .57745 .9174 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.58783 .91704 m .57986 .91731 L .57525 .8876 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.57525 .8876 m .58563 .88716 L p
.58783 .91704 L 1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.58563 .88716 m .57525 .8876 L .56941 .88671 L p
1 0 .679 r
F P
0 0 0 r
s
P
p
.002 w
.56941 .88671 m .57525 .8876 L p
.56633 .88736 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.56941 .88671 m .5797 .86249 L .58563 .88716 L p
1 0 .679 r
F P
0 0 0 r
s
P
p
.002 w
.56941 .88671 m .56363 .91531 L p
.57253 .88606 L 1 0 .454 r
F P
0 0 0 r
s
P
p
.002 w
.5797 .86249 m .56941 .88671 L p
.57253 .88606 L 1 0 .454 r
F P
0 0 0 r
s
P
p
.002 w
.55905 .88715 m .56941 .88671 L p
.56633 .88736 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.55905 .88715 m .54874 .8876 L .54279 .91604 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.54874 .8876 m .53851 .91712 L .53246 .9164 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.002 w
.53246 .9164 m .54279 .91604 L .54874 .8876 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.002 w
.80911 .57537 m .79808 .5767 L .79354 .57401 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.78295 .58772 m .79354 .57401 L .79808 .5767 L p
1 .732 0 r
F P
0 0 0 r
s
P
p
.90696 .33033 m .9222 .3324 L .91085 .33443 L 1 0 0 r
F
P
p
.89562 .33238 m .90696 .33033 L .91085 .33443 L 1 .034 0 r
F
P
p
.8803 .33031 m .89562 .33238 L .88434 .33441 L 1 .094 0 r
F
P
p
.86903 .33236 m .8803 .33031 L .88434 .33441 L 1 .163 0 r
F
P
p
.85363 .33029 m .86903 .33236 L .85783 .33439 L 1 .205 0 r
F
P
p
.84244 .33233 m .85363 .33029 L .85783 .33439 L 1 .205 0 r
F
P
p
.82696 .33027 m .84244 .33233 L .83131 .33437 L 1 .205 0 r
F
P
p
.81585 .33231 m .82696 .33027 L .83131 .33437 L 1 .233 0 r
F
P
p
.80029 .33025 m .81585 .33231 L .8048 .33435 L 1 .307 0 r
F
P
p
.78925 .33229 m .80029 .33025 L .8048 .33435 L 1 .348 0 r
F
P
p
.77362 .33022 m .78925 .33229 L .77828 .33433 L 1 .92 0 r
F
P
p
.76266 .33227 m .77362 .33022 L .77828 .33433 L .97 1 0 r
F
P
p
.002 w
.77198 .58903 m .76148 .60332 L .75933 .68686 L p
.621 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74904 .71403 m .75933 .68686 L .76148 .60332 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.74695 .3302 m .76266 .33227 L .75176 .33431 L 0 1 .591 r
F
P
p
.73606 .33225 m .74695 .3302 L .75176 .33431 L 0 1 .864 r
F
P
p
.72027 .33018 m .73606 .33225 L .72524 .33429 L .125 1 0 r
F
P
p
.70946 .33223 m .72027 .33018 L .72524 .33429 L 0 1 .389 r
F
P
p
.6936 .33016 m .70946 .33223 L .69872 .33427 L 0 .828 1 r
F
P
p
.68287 .33221 m .6936 .33016 L .69872 .33427 L 0 .782 1 r
F
P
p
.66692 .33014 m .68287 .33221 L .6722 .33424 L 1 0 .587 r
F
P
p
.65626 .33219 m .66692 .33014 L .6722 .33424 L 1 0 .362 r
F
P
p
.64024 .33012 m .65626 .33219 L .64567 .33422 L 1 0 .362 r
F
P
p
.62966 .33217 m .64024 .33012 L .64567 .33422 L 1 0 .249 r
F
P
p
.61356 .3301 m .62966 .33217 L .61914 .3342 L 1 0 .136 r
F
P
p
.60306 .33215 m .61356 .3301 L .61914 .3342 L 1 0 .136 r
F
P
p
.58688 .33008 m .60306 .33215 L .59262 .33418 L 1 0 .136 r
F
P
p
.57645 .33213 m .58688 .33008 L .59262 .33418 L 1 0 .136 r
F
P
p
.56019 .33006 m .57645 .33213 L .56609 .33416 L 1 0 .136 r
F
P
p
.54985 .3321 m .56019 .33006 L .56609 .33416 L 1 0 .136 r
F
P
p
.53351 .33004 m .54985 .3321 L .53956 .33414 L 1 0 .136 r
F
P
p
.52324 .33208 m .53351 .33004 L .53956 .33414 L 1 0 .136 r
F
P
p
.50682 .33001 m .52324 .33208 L .51302 .33412 L 1 0 .136 r
F
P
p
.49663 .33206 m .50682 .33001 L .51302 .33412 L 1 0 .136 r
F
P
p
.48013 .32999 m .49663 .33206 L .48649 .3341 L 1 0 .136 r
F
P
p
.47001 .33204 m .48013 .32999 L .48649 .3341 L 1 0 .136 r
F
P
p
.45344 .32997 m .47001 .33204 L .45995 .33408 L 1 0 .136 r
F
P
p
.4434 .33202 m .45344 .32997 L .45995 .33408 L 1 0 .136 r
F
P
p
.42675 .32995 m .4434 .33202 L .43342 .33406 L 1 0 .136 r
F
P
p
.41679 .332 m .42675 .32995 L .43342 .33406 L 1 0 .136 r
F
P
p
.40006 .32993 m .41679 .332 L .40688 .33404 L 1 0 .136 r
F
P
p
.39017 .33198 m .40006 .32993 L .40688 .33404 L 1 0 .136 r
F
P
p
.37336 .32991 m .39017 .33198 L .38034 .33402 L 1 0 .034 r
F
P
p
.36355 .33196 m .37336 .32991 L .38034 .33402 L 1 0 0 r
F
P
p
.34667 .32989 m .36355 .33196 L .35379 .33399 L 1 0 0 r
F
P
p
.33693 .33194 m .34667 .32989 L .35379 .33399 L 1 0 0 r
F
P
p
.31997 .32987 m .33693 .33194 L .32725 .33397 L 1 0 0 r
F
P
p
.31031 .33192 m .31997 .32987 L .32725 .33397 L 1 0 0 r
F
P
p
.29327 .32985 m .31031 .33192 L .30071 .33395 L 1 0 0 r
F
P
p
.28369 .33189 m .29327 .32985 L .30071 .33395 L 1 0 0 r
F
P
p
.26657 .32982 m .28369 .33189 L .27416 .33393 L 1 0 0 r
F
P
p
.002 w
.58563 .88716 m .59024 .91696 L .58783 .91704 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.7677 .5995 m .77198 .58903 L p
.77032 .60189 L .621 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75933 .68686 m .7677 .5995 L p
.77032 .60189 L .621 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7677 .5995 m .76293 .59691 L p
.76505 .59709 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78295 .58772 m .77198 .58903 L .7677 .5995 L p
1 .986 0 r
F P
0 0 0 r
s
P
p
.002 w
.7677 .5995 m .77874 .59822 L .78295 .58772 L p
1 .986 0 r
F P
0 0 0 r
s
P
p
.002 w
.77874 .59822 m .7677 .5995 L p
.76505 .59709 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59826 .91668 m .59024 .91696 L .58563 .88716 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.83032 .54728 m .8192 .5487 L .81478 .54583 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.8192 .5487 m .80911 .57537 L .80462 .57266 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.80462 .57266 m .81478 .54583 L .8192 .5487 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.58563 .88716 m .59607 .88672 L p
.59826 .91668 L 1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.59607 .88672 m .58563 .88716 L .5797 .86249 L p
1 0 .771 r
F P
0 0 0 r
s
P
p
.002 w
.56941 .88671 m .55905 .88715 L .55318 .91567 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.54279 .91604 m .55318 .91567 L .55905 .88715 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.80462 .57266 m .80911 .57537 L p
.80289 .57483 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.80462 .57266 m .8007 .58704 L p
.80636 .57047 L 1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.81478 .54583 m .80462 .57266 L p
.80636 .57047 L 1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.79354 .57401 m .80462 .57266 L p
.80289 .57483 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.66542 .88492 m .65465 .88537 L .64725 .75505 L p
.377 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64725 .75505 m .65773 .74556 L .66542 .88492 L p
.377 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63781 .83792 m .64725 .75505 L .65465 .88537 L p
.731 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65773 .74556 m .64725 .75505 L .64169 .74469 L p
0 .693 1 r
F P
0 0 0 r
s
P
p
.002 w
.64725 .75505 m .63781 .83792 L .63149 .77625 L p
0 .218 1 r
F P
0 0 0 r
s
P
p
.002 w
.63149 .77625 m .64169 .74469 L .64725 .75505 L p
0 .218 1 r
F P
0 0 0 r
s
P
p
.90696 .33033 m .91837 .32827 L .9222 .3324 L 1 0 0 r
F
P
p
.89163 .32825 m .90696 .33033 L .89562 .33238 L 1 .031 0 r
F
P
p
.8803 .33031 m .89163 .32825 L .89562 .33238 L 1 .094 0 r
F
P
p
.86488 .32823 m .8803 .33031 L .86903 .33236 L 1 .165 0 r
F
P
p
.85363 .33029 m .86488 .32823 L .86903 .33236 L 1 .205 0 r
F
P
p
.83814 .32821 m .85363 .33029 L .84244 .33233 L 1 .17 0 r
F
P
p
.82696 .33027 m .83814 .32821 L .84244 .33233 L 1 .205 0 r
F
P
p
.81139 .32819 m .82696 .33027 L .81585 .33231 L 1 .273 0 r
F
P
p
.80029 .33025 m .81139 .32819 L .81585 .33231 L 1 .307 0 r
F
P
p
.78464 .32817 m .80029 .33025 L .78925 .33229 L 1 .669 0 r
F
P
p
.77362 .33022 m .78464 .32817 L .78925 .33229 L 1 .92 0 r
F
P
p
.7579 .32814 m .77362 .33022 L .76266 .33227 L 0 1 .195 r
F
P
p
.74695 .3302 m .7579 .32814 L .76266 .33227 L 0 1 .591 r
F
P
p
.73114 .32812 m .74695 .3302 L .73606 .33225 L .227 1 0 r
F
P
p
.72027 .33018 m .73114 .32812 L .73606 .33225 L .125 1 0 r
F
P
p
.002 w
.73851 .73315 m .72752 .73404 L .71921 .60203 L p
0 1 .119 r
F P
0 0 0 r
s
P
p
.002 w
.71921 .60203 m .73005 .60076 L .73851 .73315 L p
0 1 .119 r
F P
0 0 0 r
s
P
p
.002 w
.71109 .71498 m .71921 .60203 L .72752 .73404 L p
0 1 .562 r
F P
0 0 0 r
s
P
p
.002 w
.73005 .60076 m .71921 .60203 L .7161 .67707 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71921 .60203 m .71109 .71498 L .70596 .71306 L p
0 1 .284 r
F P
0 0 0 r
s
P
p
.002 w
.70596 .71306 m .7161 .67707 L .71921 .60203 L p
0 1 .284 r
F P
0 0 0 r
s
P
p
.70439 .3281 m .72027 .33018 L .70946 .33223 L 0 .896 1 r
F
P
p
.6936 .33016 m .70439 .3281 L .70946 .33223 L 0 .828 1 r
F
P
p
.67764 .32808 m .6936 .33016 L .68287 .33221 L 1 0 .587 r
F
P
p
.66692 .33014 m .67764 .32808 L .68287 .33221 L 1 0 .587 r
F
P
p
.65088 .32806 m .66692 .33014 L .65626 .33219 L 1 0 .475 r
F
P
p
.64024 .33012 m .65088 .32806 L .65626 .33219 L 1 0 .362 r
F
P
p
.62412 .32804 m .64024 .33012 L .62966 .33217 L 1 0 .362 r
F
P
p
.61356 .3301 m .62412 .32804 L .62966 .33217 L 1 0 .136 r
F
P
p
.59736 .32802 m .61356 .3301 L .60306 .33215 L 1 0 .136 r
F
P
p
.58688 .33008 m .59736 .32802 L .60306 .33215 L 1 0 .136 r
F
P
p
.5706 .328 m .58688 .33008 L .57645 .33213 L 1 0 .136 r
F
P
p
.56019 .33006 m .5706 .328 L .57645 .33213 L 1 0 .136 r
F
P
p
.54384 .32798 m .56019 .33006 L .54985 .3321 L 1 0 .136 r
F
P
p
.53351 .33004 m .54384 .32798 L .54985 .3321 L 1 0 .136 r
F
P
p
.51708 .32795 m .53351 .33004 L .52324 .33208 L 1 0 .136 r
F
P
p
.50682 .33001 m .51708 .32795 L .52324 .33208 L 1 0 .136 r
F
P
p
.49031 .32793 m .50682 .33001 L .49663 .33206 L 1 0 .136 r
F
P
p
.48013 .32999 m .49031 .32793 L .49663 .33206 L 1 0 .136 r
F
P
p
.46354 .32791 m .48013 .32999 L .47001 .33204 L 1 0 .136 r
F
P
p
.45344 .32997 m .46354 .32791 L .47001 .33204 L 1 0 .136 r
F
P
p
.43678 .32789 m .45344 .32997 L .4434 .33202 L 1 0 .136 r
F
P
p
.42675 .32995 m .43678 .32789 L .4434 .33202 L 1 0 .136 r
F
P
p
.41 .32787 m .42675 .32995 L .41679 .332 L 1 0 .136 r
F
P
p
.40006 .32993 m .41 .32787 L .41679 .332 L 1 0 .136 r
F
P
p
.38323 .32785 m .40006 .32993 L .39017 .33198 L 1 0 .102 r
F
P
p
.37336 .32991 m .38323 .32785 L .39017 .33198 L 1 0 .034 r
F
P
p
.35646 .32783 m .37336 .32991 L .36355 .33196 L 1 0 0 r
F
P
p
.34667 .32989 m .35646 .32783 L .36355 .33196 L 1 0 0 r
F
P
p
.32968 .32781 m .34667 .32989 L .33693 .33194 L 1 0 0 r
F
P
p
.31997 .32987 m .32968 .32781 L .33693 .33194 L 1 0 0 r
F
P
p
.30291 .32778 m .31997 .32987 L .31031 .33192 L 1 0 0 r
F
P
p
.29327 .32985 m .30291 .32778 L .31031 .33192 L 1 0 0 r
F
P
p
.27613 .32776 m .29327 .32985 L .28369 .33189 L 1 0 0 r
F
P
p
.26657 .32982 m .27613 .32776 L .28369 .33189 L 1 0 0 r
F
P
p
.002 w
.59607 .88672 m .60069 .9166 L .59826 .91668 L p
1 0 .294 r
F P
0 0 0 r
s
P
p
.002 w
.79354 .57401 m .78295 .58772 L .77874 .59822 L p
1 .936 0 r
F P
0 0 0 r
s
P
p
.002 w
.6758 .86042 m .66542 .88492 L .65773 .74556 L p
.251 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65773 .74556 m .6684 .7447 L .6758 .86042 L p
.251 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6684 .7447 m .65773 .74556 L .65235 .74383 L p
0 .759 1 r
F P
0 0 0 r
s
P
p
.002 w
.65235 .74383 m .65773 .74556 L p
.6427 .74475 L 0 .693 1 r
F P
0 0 0 r
s
P
p
.002 w
.66293 .73492 m .6684 .7447 L p
.65351 .7439 L 0 .759 1 r
F P
0 0 0 r
s
P
p
.002 w
.65235 .74383 m .66293 .73492 L p
.65351 .7439 L 0 .759 1 r
F P
0 0 0 r
s
P
p
.002 w
.6684 .7447 m .67898 .73581 L .68665 .85989 L p
.128 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.67898 .73581 m .6684 .7447 L .66293 .73492 L p
0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.66293 .73492 m .67336 .71592 L .67898 .73581 L p
0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.66293 .73492 m .65958 .85718 L p
.67238 .7259 L 0 .063 1 r
F P
0 0 0 r
s
P
p
.002 w
.67336 .71592 m .66293 .73492 L p
.67238 .7259 L 0 .063 1 r
F P
0 0 0 r
s
P
p
.002 w
.65235 .74383 m .64876 .86538 L p
.66206 .74292 L .156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66293 .73492 m .65235 .74383 L p
.66206 .74292 L .156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64169 .74469 m .65235 .74383 L p
.6427 .74475 L 0 .693 1 r
F P
0 0 0 r
s
P
p
.002 w
.60876 .91633 m .60069 .9166 L .59607 .88672 L p
1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.84149 .54585 m .83032 .54728 L .82594 .5444 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.81478 .54583 m .82594 .5444 L .83032 .54728 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.62076 .916 m .61171 .91631 L .60635 .86249 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.60635 .86249 m .61688 .86198 L p
.62076 .916 L 1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.60635 .86249 m .61171 .91631 L .60876 .91633 L p
1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.59607 .88672 m .60635 .86249 L p
.60876 .91633 L 1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.61688 .86198 m .60635 .86249 L .60425 .85392 L p
.868 0 1 r
F P
0 0 0 r
s
P
p
.60688 .84768 m .61688 .86198 L .60425 .85392 L .868 0 1 r
F
P
p
.002 w
.61101 .83792 m .6211 .79275 L .62747 .86146 L p
.695 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60046 .83851 m .61101 .83792 L .61688 .86198 L p
.868 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62747 .86146 m .61688 .86198 L .61109 .83827 L p
.695 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61109 .83827 m .61101 .83792 L p
.61119 .83819 L .695 0 1 r
F P
0 0 0 r
s
P
p
.61119 .83819 m .62747 .86146 L .61109 .83827 L .695 0 1 r
F
P
p
.002 w
.63781 .83792 m .62747 .86146 L .62171 .79933 L p
.373 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62171 .79933 m .6211 .79275 L p
.62262 .79686 L .373 0 1 r
F P
0 0 0 r
s
P
p
.62262 .79686 m .63781 .83792 L .62171 .79933 L .373 0 1 r
F
P
p
.002 w
.63149 .77625 m .63781 .83792 L p
.62262 .79686 L .373 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6211 .79275 m .63149 .77625 L p
.62262 .79686 L .373 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63149 .77625 m .62915 .8238 L p
.63972 .75714 L .337 0 1 r
F P
0 0 0 r
s
P
p
.63972 .75714 m .64153 .74569 L .63149 .77625 L .337 0 1 r
F
P
p
.002 w
.64169 .74469 m .64023 .74922 L p
.64153 .74569 L .337 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64023 .74922 m .63149 .77625 L p
.64153 .74569 L .337 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61688 .86198 m .62747 .86146 L .63331 .88627 L p
1 0 .624 r
F P
0 0 0 r
s
P
p
.002 w
.62747 .86146 m .63781 .83792 L .64395 .88583 L p
1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.62915 .8238 m .62705 .86641 L p
.6325 .82112 L .337 0 1 r
F P
0 0 0 r
s
P
p
.6325 .82112 m .64169 .74469 L .62915 .8238 L .337 0 1 r
F
P
p
.002 w
.61101 .83792 m .60576 .88399 L p
.61515 .8281 L .816 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6211 .79275 m .61101 .83792 L p
.61515 .8281 L .816 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60425 .85392 m .60046 .83851 L p
.60688 .84768 L .868 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60635 .86249 m .59607 .88672 L .59015 .86197 L p
1 0 .951 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .86197 m .60046 .83851 L .60635 .86249 L p
1 0 .951 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .86197 m .59607 .88672 L p
.58503 .87038 L 1 0 .771 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .86197 m .58451 .88491 L p
.5953 .85352 L 1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.60046 .83851 m .59015 .86197 L p
.5953 .85352 L 1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.5797 .86249 m .59015 .86197 L p
.58503 .87038 L 1 0 .771 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .86197 m .5797 .86249 L .57414 .91494 L p
1 0 .658 r
F P
0 0 0 r
s
P
p
.002 w
.56363 .91531 m .57414 .91494 L .5797 .86249 L p
1 0 .454 r
F P
0 0 0 r
s
P
p
.002 w
.55318 .91567 m .56363 .91531 L .56941 .88671 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.80462 .57266 m .79354 .57401 L .78984 .59693 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.77874 .59822 m .78984 .59693 L .79354 .57401 L p
1 .936 0 r
F P
0 0 0 r
s
P
p
.90303 .32618 m .91837 .32827 L .90696 .33033 L 1 0 0 r
F
P
p
.89163 .32825 m .90303 .32618 L .90696 .33033 L 1 .031 0 r
F
P
p
.87621 .32616 m .89163 .32825 L .8803 .33031 L 1 .094 0 r
F
P
p
.86488 .32823 m .87621 .32616 L .8803 .33031 L 1 .165 0 r
F
P
p
.84938 .32614 m .86488 .32823 L .85363 .33029 L 1 .136 0 r
F
P
p
.83814 .32821 m .84938 .32614 L .85363 .33029 L 1 .17 0 r
F
P
p
.82256 .32612 m .83814 .32821 L .82696 .33027 L 1 .273 0 r
F
P
p
.81139 .32819 m .82256 .32612 L .82696 .33027 L 1 .273 0 r
F
P
p
.79573 .3261 m .81139 .32819 L .80029 .33025 L 1 .403 0 r
F
P
p
.78464 .32817 m .79573 .3261 L .80029 .33025 L 1 .669 0 r
F
P
p
.76891 .32607 m .78464 .32817 L .77362 .33022 L .146 1 0 r
F
P
p
.7579 .32814 m .76891 .32607 L .77362 .33022 L 0 1 .195 r
F
P
p
.74208 .32605 m .7579 .32814 L .74695 .3302 L .24 1 0 r
F
P
p
.73114 .32812 m .74208 .32605 L .74695 .3302 L .227 1 0 r
F
P
p
.002 w
.74904 .71403 m .73851 .73315 L .73005 .60076 L p
0 1 .048 r
F P
0 0 0 r
s
P
p
.002 w
.74095 .59949 m .73005 .60076 L .72508 .59819 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7161 .67707 m .72508 .59819 L .73005 .60076 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.71525 .32603 m .73114 .32812 L .72027 .33018 L 0 .953 1 r
F
P
p
.70439 .3281 m .71525 .32603 L .72027 .33018 L 0 .896 1 r
F
P
p
.68842 .32601 m .70439 .3281 L .6936 .33016 L 1 0 .587 r
F
P
p
.67764 .32808 m .68842 .32601 L .6936 .33016 L 1 0 .587 r
F
P
p
.66158 .32599 m .67764 .32808 L .66692 .33014 L 1 0 .587 r
F
P
p
.65088 .32806 m .66158 .32599 L .66692 .33014 L 1 0 .475 r
F
P
p
.63475 .32597 m .65088 .32806 L .64024 .33012 L 1 0 .587 r
F
P
p
.62412 .32804 m .63475 .32597 L .64024 .33012 L 1 0 .362 r
F
P
p
.60791 .32595 m .62412 .32804 L .61356 .3301 L 1 0 .136 r
F
P
p
.59736 .32802 m .60791 .32595 L .61356 .3301 L 1 0 .136 r
F
P
p
.58107 .32592 m .59736 .32802 L .58688 .33008 L 1 0 .136 r
F
P
p
.5706 .328 m .58107 .32592 L .58688 .33008 L 1 0 .136 r
F
P
p
.55423 .3259 m .5706 .328 L .56019 .33006 L 1 0 .136 r
F
P
p
.54384 .32798 m .55423 .3259 L .56019 .33006 L 1 0 .136 r
F
P
p
.52739 .32588 m .54384 .32798 L .53351 .33004 L 1 0 .136 r
F
P
p
.51708 .32795 m .52739 .32588 L .53351 .33004 L 1 0 .136 r
F
P
p
.50055 .32586 m .51708 .32795 L .50682 .33001 L 1 0 .136 r
F
P
p
.49031 .32793 m .50055 .32586 L .50682 .33001 L 1 0 .136 r
F
P
p
.4737 .32584 m .49031 .32793 L .48013 .32999 L 1 0 .136 r
F
P
p
.46354 .32791 m .4737 .32584 L .48013 .32999 L 1 0 .136 r
F
P
p
.44686 .32582 m .46354 .32791 L .45344 .32997 L 1 0 .136 r
F
P
p
.43678 .32789 m .44686 .32582 L .45344 .32997 L 1 0 .136 r
F
P
p
.42001 .3258 m .43678 .32789 L .42675 .32995 L 1 0 .136 r
F
P
p
.41 .32787 m .42001 .3258 L .42675 .32995 L 1 0 .136 r
F
P
p
.39316 .32578 m .41 .32787 L .40006 .32993 L 1 0 .136 r
F
P
p
.38323 .32785 m .39316 .32578 L .40006 .32993 L 1 0 .102 r
F
P
p
.36631 .32575 m .38323 .32785 L .37336 .32991 L 1 0 0 r
F
P
p
.35646 .32783 m .36631 .32575 L .37336 .32991 L 1 0 0 r
F
P
p
.33946 .32573 m .35646 .32783 L .34667 .32989 L 1 0 0 r
F
P
p
.32968 .32781 m .33946 .32573 L .34667 .32989 L 1 0 0 r
F
P
p
.3126 .32571 m .32968 .32781 L .31997 .32987 L 1 0 .034 r
F
P
p
.30291 .32778 m .3126 .32571 L .31997 .32987 L 1 0 0 r
F
P
p
.28575 .32569 m .30291 .32778 L .29327 .32985 L 1 0 0 r
F
P
p
.27613 .32776 m .28575 .32569 L .29327 .32985 L 1 0 0 r
F
P
p
.25889 .32567 m .27613 .32776 L .26657 .32982 L 1 0 .034 r
F
P
p
.002 w
.65465 .88537 m .64395 .88583 L .63781 .83792 L p
.731 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65235 .74383 m .64169 .74469 L .63787 .8659 L p
.217 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62705 .86641 m .63787 .8659 L .64169 .74469 L p
.337 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.85273 .54441 m .84149 .54585 L .83717 .54295 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.82594 .5444 m .83717 .54295 L .84149 .54585 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.82594 .5444 m .81478 .54583 L .81192 .58571 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.8007 .58704 m .81192 .58571 L .81478 .54583 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.62227 .91594 m .61688 .86198 L p
.63331 .88627 L 1 0 .624 r
F P
0 0 0 r
s
P
p
.002 w
.61688 .86198 m .62227 .91594 L .62076 .916 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.63149 .77625 m .6211 .79275 L .6163 .86693 L p
.519 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60576 .88399 m .6163 .86693 L .6211 .79275 L p
.816 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61101 .83792 m .60046 .83851 L .5951 .88445 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.002 w
.58451 .88491 m .5951 .88445 L .60046 .83851 L p
1 0 .86 r
F P
0 0 0 r
s
P
p
.002 w
.57414 .91494 m .58451 .88491 L .59015 .86197 L p
1 0 .658 r
F P
0 0 0 r
s
P
p
.002 w
.63331 .88627 m .62553 .91596 L .62227 .91594 L p
1 0 .624 r
F P
0 0 0 r
s
P
p
.002 w
.8007 .58704 m .80462 .57266 L p
.79404 .59004 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.8007 .58704 m .79593 .57972 L p
.80741 .58402 L 1 .868 0 r
F P
0 0 0 r
s
P
p
.002 w
.81192 .58571 m .8007 .58704 L p
.80741 .58402 L 1 .868 0 r
F P
0 0 0 r
s
P
p
.002 w
.78984 .59693 m .8007 .58704 L p
.79404 .59004 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.69529 .75341 m .68665 .85989 L .67898 .73581 L p
0 .313 1 r
F P
0 0 0 r
s
P
p
.002 w
.67898 .73581 m .68976 .73493 L .69529 .75341 L p
0 .313 1 r
F P
0 0 0 r
s
P
p
.002 w
.6163 .86693 m .62705 .86641 L .63149 .77625 L p
.519 0 1 r
F P
0 0 0 r
s
P
p
.90303 .32618 m .91449 .3241 L .91837 .32827 L 1 0 0 r
F
P
p
.88759 .32408 m .90303 .32618 L .89163 .32825 L 1 .031 0 r
F
P
p
.87621 .32616 m .88759 .32408 L .89163 .32825 L 1 .094 0 r
F
P
p
.86069 .32405 m .87621 .32616 L .86488 .32823 L 1 .102 0 r
F
P
p
.84938 .32614 m .86069 .32405 L .86488 .32823 L 1 .136 0 r
F
P
p
.83379 .32403 m .84938 .32614 L .83814 .32821 L 1 .239 0 r
F
P
p
.82256 .32612 m .83379 .32403 L .83814 .32821 L 1 .273 0 r
F
P
p
.80689 .32401 m .82256 .32612 L .81139 .32819 L 1 .314 0 r
F
P
p
.79573 .3261 m .80689 .32401 L .81139 .32819 L 1 .403 0 r
F
P
p
.77998 .32399 m .79573 .3261 L .78464 .32817 L .649 1 0 r
F
P
p
.76891 .32607 m .77998 .32399 L .78464 .32817 L .146 1 0 r
F
P
p
.002 w
.7677 .5995 m .75933 .68686 L .75191 .59821 L p
.568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75191 .59821 m .76293 .59691 L .7677 .5995 L p
.568 1 0 r
F P
0 0 0 r
s
P
p
.75308 .32397 m .76891 .32607 L .7579 .32814 L .398 1 0 r
F
P
p
.74208 .32605 m .75308 .32397 L .7579 .32814 L .24 1 0 r
F
P
p
.002 w
.75933 .68686 m .74904 .71403 L .74095 .59949 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74095 .59949 m .75191 .59821 L .75933 .68686 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75191 .59821 m .74095 .59949 L .73603 .5969 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73603 .5969 m .74095 .59949 L p
.72676 .59833 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73603 .5969 m .74666 .58239 L .75191 .59821 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.73943 .6548 m .74535 .59546 L .73466 .67589 L .416 1 0 r
F
P
p
.002 w
.76293 .59691 m .75191 .59821 L .74666 .58239 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.74666 .58239 m .75759 .57709 L .76293 .59691 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.73603 .5969 m .73466 .67589 L p
.74535 .59546 L .416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74666 .58239 m .73603 .5969 L p
.74535 .59546 L .416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73466 .67589 m .73411 .70817 L p
.73943 .6548 L .416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73411 .70817 m .74285 .61901 L .74666 .58239 L p
.416 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75759 .57709 m .74666 .58239 L .74285 .61901 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.74285 .61901 m .75247 .56572 L .7572 .57622 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.7572 .57622 m .75759 .57709 L p
.75594 .58178 L 1 .97 0 r
F P
0 0 0 r
s
P
p
.74285 .61901 m .7572 .57622 L .75594 .58178 L 1 .97 0 r
F
P
p
.002 w
.72508 .59819 m .73603 .5969 L p
.72676 .59833 L .909 1 0 r
F P
0 0 0 r
s
P
p
.72617 .32395 m .74208 .32605 L .73114 .32812 L 0 .953 1 r
F
P
p
.71525 .32603 m .72617 .32395 L .73114 .32812 L 0 .953 1 r
F
P
p
.69926 .32393 m .71525 .32603 L .70439 .3281 L 1 0 .587 r
F
P
p
.68842 .32601 m .69926 .32393 L .70439 .3281 L 1 0 .587 r
F
P
p
.67235 .3239 m .68842 .32601 L .67764 .32808 L 1 0 .587 r
F
P
p
.66158 .32599 m .67235 .3239 L .67764 .32808 L 1 0 .587 r
F
P
p
.64543 .32388 m .66158 .32599 L .65088 .32806 L 1 0 .587 r
F
P
p
.63475 .32597 m .64543 .32388 L .65088 .32806 L 1 0 .587 r
F
P
p
.61852 .32386 m .63475 .32597 L .62412 .32804 L 1 0 .317 r
F
P
p
.60791 .32595 m .61852 .32386 L .62412 .32804 L 1 0 .136 r
F
P
p
.002 w
.68976 .73493 m .67898 .73581 L .67336 .71592 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.5916 .32384 m .60791 .32595 L .59736 .32802 L 1 0 .136 r
F
P
p
.58107 .32592 m .5916 .32384 L .59736 .32802 L 1 0 .136 r
F
P
p
.56468 .32382 m .58107 .32592 L .5706 .328 L 1 0 .136 r
F
P
p
.55423 .3259 m .56468 .32382 L .5706 .328 L 1 0 .136 r
F
P
p
.53777 .3238 m .55423 .3259 L .54384 .32798 L 1 0 .136 r
F
P
p
.52739 .32588 m .53777 .3238 L .54384 .32798 L 1 0 .136 r
F
P
p
.51084 .32378 m .52739 .32588 L .51708 .32795 L 1 0 .205 r
F
P
p
.50055 .32586 m .51084 .32378 L .51708 .32795 L 1 0 .136 r
F
P
p
.48392 .32375 m .50055 .32586 L .49031 .32793 L 1 0 .136 r
F
P
p
.4737 .32584 m .48392 .32375 L .49031 .32793 L 1 0 .136 r
F
P
p
.457 .32373 m .4737 .32584 L .46354 .32791 L 1 0 .136 r
F
P
p
.44686 .32582 m .457 .32373 L .46354 .32791 L 1 0 .136 r
F
P
p
.43007 .32371 m .44686 .32582 L .43678 .32789 L 1 0 .136 r
F
P
p
.42001 .3258 m .43007 .32371 L .43678 .32789 L 1 0 .136 r
F
P
p
.40314 .32369 m .42001 .3258 L .41 .32787 L 1 0 .136 r
F
P
p
.39316 .32578 m .40314 .32369 L .41 .32787 L 1 0 .136 r
F
P
p
.37622 .32367 m .39316 .32578 L .38323 .32785 L 1 0 .034 r
F
P
p
.36631 .32575 m .37622 .32367 L .38323 .32785 L 1 0 0 r
F
P
p
.34928 .32365 m .36631 .32575 L .35646 .32783 L 1 0 0 r
F
P
p
.33946 .32573 m .34928 .32365 L .35646 .32783 L 1 0 0 r
F
P
p
.32235 .32363 m .33946 .32573 L .32968 .32781 L 1 0 .068 r
F
P
p
.3126 .32571 m .32235 .32363 L .32968 .32781 L 1 0 .034 r
F
P
p
.29542 .3236 m .3126 .32571 L .30291 .32778 L 1 0 .034 r
F
P
p
.28575 .32569 m .29542 .3236 L .30291 .32778 L 1 0 0 r
F
P
p
.26848 .32358 m .28575 .32569 L .27613 .32776 L 1 0 .068 r
F
P
p
.25889 .32567 m .26848 .32358 L .27613 .32776 L 1 0 .034 r
F
P
p
.002 w
.68976 .73493 m .70061 .73403 L .70592 .74385 L p
0 .756 1 r
F P
0 0 0 r
s
P
p
.002 w
.63787 .8659 m .64876 .86538 L .65235 .74383 L p
.217 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.86404 .54297 m .85273 .54441 L .84846 .5415 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83717 .54295 m .84846 .5415 L .85273 .54441 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83717 .54295 m .82594 .5444 L .82151 .54148 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.81192 .58571 m .82151 .54148 L .82594 .5444 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.5951 .88445 m .60576 .88399 L .61101 .83792 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.89905 .32198 m .91449 .3241 L .90303 .32618 L 1 0 0 r
F
P
p
.88759 .32408 m .89905 .32198 L .90303 .32618 L 1 .031 0 r
F
P
p
.87207 .32196 m .88759 .32408 L .87621 .32616 L 1 .034 0 r
F
P
p
.86069 .32405 m .87207 .32196 L .87621 .32616 L 1 .102 0 r
F
P
p
.84509 .32194 m .86069 .32405 L .84938 .32614 L 1 .205 0 r
F
P
p
.83379 .32403 m .84509 .32194 L .84938 .32614 L 1 .239 0 r
F
P
p
.81811 .32192 m .83379 .32403 L .82256 .32612 L 1 .273 0 r
F
P
p
.80689 .32401 m .81811 .32192 L .82256 .32612 L 1 .314 0 r
F
P
p
.79112 .3219 m .80689 .32401 L .79573 .3261 L 1 .88 0 r
F
P
p
.77998 .32399 m .79112 .3219 L .79573 .3261 L .649 1 0 r
F
P
p
.002 w
.78984 .59693 m .77874 .59822 L .77403 .59562 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76293 .59691 m .77403 .59562 L .77874 .59822 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.76414 .32187 m .77998 .32399 L .76891 .32607 L .76 1 0 r
F
P
p
.75308 .32397 m .76414 .32187 L .76891 .32607 L .398 1 0 r
F
P
p
.73715 .32185 m .75308 .32397 L .74208 .32605 L 0 .99 1 r
F
P
p
.72617 .32395 m .73715 .32185 L .74208 .32605 L 0 .953 1 r
F
P
p
.002 w
.73603 .5969 m .72508 .59819 L .72293 .70915 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70061 .73403 m .71109 .71498 L .7166 .73493 L p
0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.71109 .71498 m .70061 .73403 L .69503 .71401 L p
0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.70596 .71306 m .71109 .71498 L p
.70422 .71457 L 0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.70596 .71306 m .70137 .73767 L p
.70772 .71153 L 0 1 .83 r
F P
0 0 0 r
s
P
p
.002 w
.7161 .67707 m .70596 .71306 L p
.70772 .71153 L 0 1 .83 r
F P
0 0 0 r
s
P
p
.002 w
.69503 .71401 m .70596 .71306 L p
.70422 .71457 L 0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.70137 .73767 m .71182 .71013 L .7161 .67707 L p
0 1 .83 r
F P
0 0 0 r
s
P
p
.002 w
.72508 .59819 m .7161 .67707 L .71182 .71013 L p
0 1 .284 r
F P
0 0 0 r
s
P
p
.002 w
.71182 .71013 m .72293 .70915 L .72508 .59819 L p
0 1 .284 r
F P
0 0 0 r
s
P
p
.71016 .32183 m .72617 .32395 L .71525 .32603 L 1 0 .587 r
F
P
p
.69926 .32393 m .71016 .32183 L .71525 .32603 L 1 0 .587 r
F
P
p
.68317 .32181 m .69926 .32393 L .68842 .32601 L 1 0 .587 r
F
P
p
.67235 .3239 m .68317 .32181 L .68842 .32601 L 1 0 .587 r
F
P
p
.65618 .32179 m .67235 .3239 L .66158 .32599 L 1 0 .587 r
F
P
p
.64543 .32388 m .65618 .32179 L .66158 .32599 L 1 0 .587 r
F
P
p
.62919 .32177 m .64543 .32388 L .63475 .32597 L 1 0 .543 r
F
P
p
.61852 .32386 m .62919 .32177 L .63475 .32597 L 1 0 .317 r
F
P
p
.002 w
.70061 .73403 m .68976 .73493 L .68416 .71497 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.002 w
.67336 .71592 m .68416 .71497 L .68976 .73493 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.60219 .32174 m .61852 .32386 L .60791 .32595 L 1 0 .136 r
F
P
p
.5916 .32384 m .60219 .32174 L .60791 .32595 L 1 0 .136 r
F
P
p
.002 w
.64876 .86538 m .65958 .85718 L .66293 .73492 L p
.156 0 1 r
F P
0 0 0 r
s
P
p
.5752 .32172 m .5916 .32384 L .58107 .32592 L 1 0 .136 r
F
P
p
.56468 .32382 m .5752 .32172 L .58107 .32592 L 1 0 .136 r
F
P
p
.5482 .3217 m .56468 .32382 L .55423 .3259 L 1 0 .136 r
F
P
p
.53777 .3238 m .5482 .3217 L .55423 .3259 L 1 0 .136 r
F
P
p
.5212 .32168 m .53777 .3238 L .52739 .32588 L 1 0 .286 r
F
P
p
.51084 .32378 m .5212 .32168 L .52739 .32588 L 1 0 .205 r
F
P
p
.4942 .32166 m .51084 .32378 L .50055 .32586 L 1 0 .136 r
F
P
p
.48392 .32375 m .4942 .32166 L .50055 .32586 L 1 0 .136 r
F
P
p
.4672 .32164 m .48392 .32375 L .4737 .32584 L 1 0 .136 r
F
P
p
.457 .32373 m .4672 .32164 L .4737 .32584 L 1 0 .136 r
F
P
p
.44019 .32162 m .457 .32373 L .44686 .32582 L 1 0 .136 r
F
P
p
.43007 .32371 m .44019 .32162 L .44686 .32582 L 1 0 .136 r
F
P
p
.41319 .32159 m .43007 .32371 L .42001 .3258 L 1 0 .136 r
F
P
p
.40314 .32369 m .41319 .32159 L .42001 .3258 L 1 0 .136 r
F
P
p
.38618 .32157 m .40314 .32369 L .39316 .32578 L 1 0 .102 r
F
P
p
.37622 .32367 m .38618 .32157 L .39316 .32578 L 1 0 .034 r
F
P
p
.35917 .32155 m .37622 .32367 L .36631 .32575 L 1 0 0 r
F
P
p
.34928 .32365 m .35917 .32155 L .36631 .32575 L 1 0 0 r
F
P
p
.33216 .32153 m .34928 .32365 L .33946 .32573 L 1 0 .068 r
F
P
p
.32235 .32363 m .33216 .32153 L .33946 .32573 L 1 0 .068 r
F
P
p
.30515 .32151 m .32235 .32363 L .3126 .32571 L 1 0 .102 r
F
P
p
.29542 .3236 m .30515 .32151 L .3126 .32571 L 1 0 .034 r
F
P
p
.27813 .32149 m .29542 .3236 L .28575 .32569 L 1 0 .068 r
F
P
p
.26848 .32358 m .27813 .32149 L .28575 .32569 L 1 0 .068 r
F
P
p
.25112 .32146 m .26848 .32358 L .25889 .32567 L 1 0 .102 r
F
P
p
.002 w
.68416 .71497 m .67336 .71592 L .67016 .83309 L p
0 .231 1 r
F P
0 0 0 r
s
P
p
.002 w
.65958 .85718 m .67016 .83309 L .67336 .71592 L p
0 .063 1 r
F P
0 0 0 r
s
P
p
.002 w
.87535 .5402 m .86404 .54297 L .85982 .54004 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.84846 .5415 m .85982 .54004 L .86404 .54297 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.84846 .5415 m .83717 .54295 L .83279 .54002 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.82151 .54148 m .83279 .54002 L .83717 .54295 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.89905 .32198 m .91057 .31987 L .91449 .3241 L 1 0 0 r
F
P
p
.88351 .31985 m .89905 .32198 L .88759 .32408 L 1 0 0 r
F
P
p
.87207 .32196 m .88351 .31985 L .88759 .32408 L 1 .034 0 r
F
P
p
.85645 .31983 m .87207 .32196 L .86069 .32405 L 1 .199 0 r
F
P
p
.84509 .32194 m .85645 .31983 L .86069 .32405 L 1 .205 0 r
F
P
p
.82939 .31981 m .84509 .32194 L .83379 .32403 L 1 .267 0 r
F
P
p
.81811 .32192 m .82939 .31981 L .83379 .32403 L 1 .273 0 r
F
P
p
.80233 .31979 m .81811 .32192 L .80689 .32401 L 1 .655 0 r
F
P
p
.79112 .3219 m .80233 .31979 L .80689 .32401 L 1 .88 0 r
F
P
p
.002 w
.8007 .58704 m .78984 .59693 L .78489 .5857 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.77403 .59562 m .78489 .5857 L .78984 .59693 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.77526 .31977 m .79112 .3219 L .77998 .32399 L 1 .955 0 r
F
P
p
.76414 .32187 m .77526 .31977 L .77998 .32399 L .76 1 0 r
F
P
p
.002 w
.77403 .59562 m .76293 .59691 L .75759 .57709 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.7482 .31974 m .76414 .32187 L .75308 .32397 L 0 1 .435 r
F
P
p
.73715 .32185 m .7482 .31974 L .75308 .32397 L 0 .99 1 r
F
P
p
.002 w
.72293 .70915 m .73411 .70817 L .73603 .5969 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.72113 .31972 m .73715 .32185 L .72617 .32395 L 1 0 .587 r
F
P
p
.71016 .32183 m .72113 .31972 L .72617 .32395 L 1 0 .587 r
F
P
p
.69406 .3197 m .71016 .32183 L .69926 .32393 L 1 0 .768 r
F
P
p
.68317 .32181 m .69406 .3197 L .69926 .32393 L 1 0 .587 r
F
P
p
.66699 .31968 m .68317 .32181 L .67235 .3239 L 1 0 .587 r
F
P
p
.65618 .32179 m .66699 .31968 L .67235 .3239 L 1 0 .587 r
F
P
p
.63992 .31966 m .65618 .32179 L .64543 .32388 L 1 0 .587 r
F
P
p
.62919 .32177 m .63992 .31966 L .64543 .32388 L 1 0 .543 r
F
P
p
.002 w
.68416 .71497 m .69503 .71401 L .70061 .73403 L p
0 .995 1 r
F P
0 0 0 r
s
P
p
.61285 .31964 m .62919 .32177 L .61852 .32386 L 1 0 .317 r
F
P
p
.60219 .32174 m .61285 .31964 L .61852 .32386 L 1 0 .136 r
F
P
p
.58577 .31961 m .60219 .32174 L .5916 .32384 L 1 0 .249 r
F
P
p
.5752 .32172 m .58577 .31961 L .5916 .32384 L 1 0 .136 r
F
P
p
.5587 .31959 m .5752 .32172 L .56468 .32382 L 1 0 .136 r
F
P
p
.5482 .3217 m .5587 .31959 L .56468 .32382 L 1 0 .136 r
F
P
p
.53162 .31957 m .5482 .3217 L .53777 .3238 L 1 0 .33 r
F
P
p
.5212 .32168 m .53162 .31957 L .53777 .3238 L 1 0 .286 r
F
P
p
.50454 .31955 m .5212 .32168 L .51084 .32378 L 1 0 .273 r
F
P
p
.4942 .32166 m .50454 .31955 L .51084 .32378 L 1 0 .136 r
F
P
p
.47746 .31953 m .4942 .32166 L .48392 .32375 L 1 0 .136 r
F
P
p
.4672 .32164 m .47746 .31953 L .48392 .32375 L 1 0 .136 r
F
P
p
.45037 .31951 m .4672 .32164 L .457 .32373 L 1 0 .136 r
F
P
p
.44019 .32162 m .45037 .31951 L .457 .32373 L 1 0 .136 r
F
P
p
.42329 .31948 m .44019 .32162 L .43007 .32371 L 1 0 .136 r
F
P
p
.41319 .32159 m .42329 .31948 L .43007 .32371 L 1 0 .136 r
F
P
p
.3962 .31946 m .41319 .32159 L .40314 .32369 L 1 0 .136 r
F
P
p
.38618 .32157 m .3962 .31946 L .40314 .32369 L 1 0 .102 r
F
P
p
.36912 .31944 m .38618 .32157 L .37622 .32367 L 1 0 0 r
F
P
p
.35917 .32155 m .36912 .31944 L .37622 .32367 L 1 0 0 r
F
P
p
.34203 .31942 m .35917 .32155 L .34928 .32365 L 1 0 .068 r
F
P
p
.33216 .32153 m .34203 .31942 L .34928 .32365 L 1 0 .068 r
F
P
p
.31493 .3194 m .33216 .32153 L .32235 .32363 L 1 0 .136 r
F
P
p
.30515 .32151 m .31493 .3194 L .32235 .32363 L 1 0 .102 r
F
P
p
.28784 .31938 m .30515 .32151 L .29542 .3236 L 1 0 .102 r
F
P
p
.27813 .32149 m .28784 .31938 L .29542 .3236 L 1 0 .068 r
F
P
p
.26075 .31935 m .27813 .32149 L .26848 .32358 L 1 0 .136 r
F
P
p
.25112 .32146 m .26075 .31935 L .26848 .32358 L 1 0 .102 r
F
P
p
.002 w
.69503 .71401 m .68416 .71497 L .68115 .83024 L p
0 .504 1 r
F P
0 0 0 r
s
P
p
.002 w
.67016 .83309 m .68115 .83024 L .68416 .71497 L p
0 .231 1 r
F P
0 0 0 r
s
P
p
.002 w
.88643 .53151 m .87535 .5402 L .87085 .53 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.85982 .54004 m .87085 .53 L .87535 .5402 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.85982 .54004 m .84846 .5415 L .84414 .53855 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83279 .54002 m .84414 .53855 L .84846 .5415 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83279 .54002 m .82151 .54148 L .81698 .53722 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.82151 .54148 m .81192 .58571 L .80672 .56575 L p
1 .54 0 r
F P
0 0 0 r
s
P
p
.002 w
.80672 .56575 m .81698 .53722 L .82151 .54148 L p
1 .54 0 r
F P
0 0 0 r
s
P
p
.002 w
.78489 .5857 m .79593 .57972 L .8007 .58704 L p
1 .97 0 r
F P
0 0 0 r
s
P
p
.002 w
.5951 .88445 m .58451 .88491 L .5788 .91382 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.58451 .88491 m .57414 .91494 L .56819 .9142 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.002 w
.56819 .9142 m .5788 .91382 L .58451 .88491 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.89502 .31773 m .91057 .31987 L .89905 .32198 L 1 0 0 r
F
P
p
.88351 .31985 m .89502 .31773 L .89905 .32198 L 1 0 0 r
F
P
p
.86788 .31771 m .88351 .31985 L .87207 .32196 L 1 .16 0 r
F
P
p
.85645 .31983 m .86788 .31771 L .87207 .32196 L 1 .199 0 r
F
P
p
.84074 .31769 m .85645 .31983 L .84509 .32194 L 1 .262 0 r
F
P
p
.82939 .31981 m .84074 .31769 L .84509 .32194 L 1 .267 0 r
F
P
p
.8136 .31767 m .82939 .31981 L .81811 .32192 L 1 .545 0 r
F
P
p
.80233 .31979 m .8136 .31767 L .81811 .32192 L 1 .655 0 r
F
P
p
.78646 .31765 m .80233 .31979 L .79112 .3219 L 1 .75 0 r
F
P
p
.77526 .31977 m .78646 .31765 L .79112 .3219 L 1 .955 0 r
F
P
p
.002 w
.78489 .5857 m .77403 .59562 L .76843 .56713 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.75759 .57709 m .76843 .56713 L .77403 .59562 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.75931 .31762 m .77526 .31977 L .76414 .32187 L .132 1 0 r
F
P
p
.7482 .31974 m .75931 .31762 L .76414 .32187 L 0 1 .435 r
F
P
p
.73217 .3176 m .7482 .31974 L .73715 .32185 L 1 0 .611 r
F
P
p
.72113 .31972 m .73217 .3176 L .73715 .32185 L 1 0 .587 r
F
P
p
.70502 .31758 m .72113 .31972 L .71016 .32183 L .527 0 1 r
F
P
p
.69406 .3197 m .70502 .31758 L .71016 .32183 L 1 0 .768 r
F
P
p
.67787 .31756 m .69406 .3197 L .68317 .32181 L 1 0 .587 r
F
P
p
.66699 .31968 m .67787 .31756 L .68317 .32181 L 1 0 .587 r
F
P
p
.65072 .31754 m .66699 .31968 L .65618 .32179 L 1 0 .587 r
F
P
p
.63992 .31966 m .65072 .31754 L .65618 .32179 L 1 0 .587 r
F
P
p
.62357 .31752 m .63992 .31966 L .62919 .32177 L 1 0 .543 r
F
P
p
.61285 .31964 m .62357 .31752 L .62919 .32177 L 1 0 .317 r
F
P
p
.59641 .31749 m .61285 .31964 L .60219 .32174 L 1 0 .362 r
F
P
p
.58577 .31961 m .59641 .31749 L .60219 .32174 L 1 0 .249 r
F
P
p
.56926 .31747 m .58577 .31961 L .5752 .32172 L 1 0 .249 r
F
P
p
.5587 .31959 m .56926 .31747 L .5752 .32172 L 1 0 .136 r
F
P
p
.5421 .31745 m .5587 .31959 L .5482 .3217 L 1 0 .362 r
F
P
p
.53162 .31957 m .5421 .31745 L .5482 .3217 L 1 0 .33 r
F
P
p
.51494 .31743 m .53162 .31957 L .5212 .32168 L 1 0 .422 r
F
P
p
.50454 .31955 m .51494 .31743 L .5212 .32168 L 1 0 .273 r
F
P
p
.48778 .31741 m .50454 .31955 L .4942 .32166 L 1 0 .136 r
F
P
p
.47746 .31953 m .48778 .31741 L .4942 .32166 L 1 0 .136 r
F
P
p
.46062 .31738 m .47746 .31953 L .4672 .32164 L 1 0 .136 r
F
P
p
.45037 .31951 m .46062 .31738 L .4672 .32164 L 1 0 .136 r
F
P
p
.43345 .31736 m .45037 .31951 L .44019 .32162 L 1 0 .136 r
F
P
p
.42329 .31948 m .43345 .31736 L .44019 .32162 L 1 0 .136 r
F
P
p
.40629 .31734 m .42329 .31948 L .41319 .32159 L 1 0 .136 r
F
P
p
.3962 .31946 m .40629 .31734 L .41319 .32159 L 1 0 .136 r
F
P
p
.37912 .31732 m .3962 .31946 L .38618 .32157 L 1 0 .068 r
F
P
p
.36912 .31944 m .37912 .31732 L .38618 .32157 L 1 0 0 r
F
P
p
.002 w
.89792 .53002 m .88643 .53151 L .8823 .52784 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8823 .52784 m .88643 .53151 L p
.87745 .53064 L 1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.8823 .52784 m .89345 .5184 L .89792 .53002 L p
1 .1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8823 .52784 m .87858 .53409 L p
.88718 .52501 L 1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.89345 .5184 m .8823 .52784 L p
.88718 .52501 L 1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.87085 .53 m .8823 .52784 L p
.87745 .53064 L 1 .163 0 r
F P
0 0 0 r
s
P
p
.35195 .3173 m .36912 .31944 L .35917 .32155 L 1 0 .068 r
F
P
p
.34203 .31942 m .35195 .3173 L .35917 .32155 L 1 0 .068 r
F
P
p
.32478 .31728 m .34203 .31942 L .33216 .32153 L 1 0 .136 r
F
P
p
.31493 .3194 m .32478 .31728 L .33216 .32153 L 1 0 .136 r
F
P
p
.29761 .31725 m .31493 .3194 L .30515 .32151 L 1 0 .136 r
F
P
p
.28784 .31938 m .29761 .31725 L .30515 .32151 L 1 0 .102 r
F
P
p
.27043 .31723 m .28784 .31938 L .27813 .32149 L 1 0 .136 r
F
P
p
.26075 .31935 m .27043 .31723 L .27813 .32149 L 1 0 .136 r
F
P
p
.24326 .31721 m .26075 .31935 L .25112 .32146 L 1 0 .136 r
F
P
p
.002 w
.76843 .56713 m .75759 .57709 L .75247 .56572 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.70596 .71306 m .69503 .71401 L .69079 .75988 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.68115 .83024 m .69079 .75988 L .69503 .71401 L p
0 .504 1 r
F P
0 0 0 r
s
P
p
.002 w
.87085 .53 m .85982 .54004 L .85555 .53707 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.84414 .53855 m .85555 .53707 L .85982 .54004 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.84414 .53855 m .83279 .54002 L .82831 .53573 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.81698 .53722 m .82831 .53573 L .83279 .54002 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.79593 .57972 m .80672 .56575 L .81192 .58571 L p
1 .868 0 r
F P
0 0 0 r
s
P
p
.002 w
.79593 .57972 m .78489 .5857 L .77959 .56574 L p
1 .766 0 r
F P
0 0 0 r
s
P
p
.002 w
.76843 .56713 m .77959 .56574 L .78489 .5857 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.60576 .88399 m .5951 .88445 L .58948 .91345 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.5788 .91382 m .58948 .91345 L .5951 .88445 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.77959 .56574 m .76843 .56713 L .76335 .5557 L p
1 .586 0 r
F P
0 0 0 r
s
P
p
.002 w
.75247 .56572 m .76335 .5557 L .76843 .56713 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.89502 .31773 m .9066 .3156 L .91057 .31987 L 1 0 0 r
F
P
p
.87938 .31558 m .89502 .31773 L .88351 .31985 L 1 .097 0 r
F
P
p
.86788 .31771 m .87938 .31558 L .88351 .31985 L 1 .16 0 r
F
P
p
.85216 .31556 m .86788 .31771 L .85645 .31983 L 1 .257 0 r
F
P
p
.84074 .31769 m .85216 .31556 L .85645 .31983 L 1 .262 0 r
F
P
p
.82494 .31554 m .84074 .31769 L .82939 .31981 L 1 .404 0 r
F
P
p
.8136 .31767 m .82494 .31554 L .82939 .31981 L 1 .545 0 r
F
P
p
.79772 .31551 m .8136 .31767 L .80233 .31979 L 1 .614 0 r
F
P
p
.78646 .31765 m .79772 .31551 L .80233 .31979 L 1 .75 0 r
F
P
p
.77049 .31549 m .78646 .31765 L .77526 .31977 L .295 1 0 r
F
P
p
.75931 .31762 m .77049 .31549 L .77526 .31977 L .132 1 0 r
F
P
p
.74327 .31547 m .75931 .31762 L .7482 .31974 L .892 0 1 r
F
P
p
.73217 .3176 m .74327 .31547 L .7482 .31974 L 1 0 .611 r
F
P
p
.71604 .31545 m .73217 .3176 L .72113 .31972 L 0 .271 1 r
F
P
p
.70502 .31758 m .71604 .31545 L .72113 .31972 L .527 0 1 r
F
P
p
.68881 .31543 m .70502 .31758 L .69406 .3197 L 1 0 .948 r
F
P
p
.67787 .31756 m .68881 .31543 L .69406 .3197 L 1 0 .587 r
F
P
p
.66158 .3154 m .67787 .31756 L .66699 .31968 L 1 0 .587 r
F
P
p
.65072 .31754 m .66158 .3154 L .66699 .31968 L 1 0 .587 r
F
P
p
.63435 .31538 m .65072 .31754 L .63992 .31966 L 1 0 .587 r
F
P
p
.62357 .31752 m .63435 .31538 L .63992 .31966 L 1 0 .543 r
F
P
p
.60711 .31536 m .62357 .31752 L .61285 .31964 L 1 0 .475 r
F
P
p
.59641 .31749 m .60711 .31536 L .61285 .31964 L 1 0 .362 r
F
P
p
.57988 .31534 m .59641 .31749 L .58577 .31961 L 1 0 .475 r
F
P
p
.56926 .31747 m .57988 .31534 L .58577 .31961 L 1 0 .249 r
F
P
p
.55264 .31532 m .56926 .31747 L .5587 .31959 L 1 0 .362 r
F
P
p
.5421 .31745 m .55264 .31532 L .5587 .31959 L 1 0 .362 r
F
P
p
.5254 .31529 m .5421 .31745 L .53162 .31957 L 1 0 .48 r
F
P
p
.51494 .31743 m .5254 .31529 L .53162 .31957 L 1 0 .422 r
F
P
p
.49816 .31527 m .51494 .31743 L .50454 .31955 L 1 0 .205 r
F
P
p
.48778 .31741 m .49816 .31527 L .50454 .31955 L 1 0 .136 r
F
P
p
.47092 .31525 m .48778 .31741 L .47746 .31953 L 1 0 .136 r
F
P
p
.46062 .31738 m .47092 .31525 L .47746 .31953 L 1 0 .136 r
F
P
p
.44367 .31523 m .46062 .31738 L .45037 .31951 L 1 0 .136 r
F
P
p
.43345 .31736 m .44367 .31523 L .45037 .31951 L 1 0 .136 r
F
P
p
.41643 .31521 m .43345 .31736 L .42329 .31948 L 1 0 .136 r
F
P
p
.40629 .31734 m .41643 .31521 L .42329 .31948 L 1 0 .136 r
F
P
p
.38918 .31518 m .40629 .31734 L .3962 .31946 L 1 0 .136 r
F
P
p
.37912 .31732 m .38918 .31518 L .3962 .31946 L 1 0 .068 r
F
P
p
.002 w
.90948 .52851 m .89792 .53002 L .89345 .5184 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.36193 .31516 m .37912 .31732 L .36912 .31944 L 1 0 .068 r
F
P
p
.35195 .3173 m .36193 .31516 L .36912 .31944 L 1 0 .068 r
F
P
p
.002 w
.8823 .52784 m .87085 .53 L .86703 .53558 L p
1 .202 0 r
F P
0 0 0 r
s
P
p
.002 w
.85555 .53707 m .86703 .53558 L .87085 .53 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.33468 .31514 m .35195 .3173 L .34203 .31942 L 1 0 .136 r
F
P
p
.32478 .31728 m .33468 .31514 L .34203 .31942 L 1 0 .136 r
F
P
p
.30743 .31512 m .32478 .31728 L .31493 .3194 L 1 0 .136 r
F
P
p
.29761 .31725 m .30743 .31512 L .31493 .3194 L 1 0 .136 r
F
P
p
.28017 .3151 m .29761 .31725 L .28784 .31938 L 1 0 .136 r
F
P
p
.27043 .31723 m .28017 .3151 L .28784 .31938 L 1 0 .136 r
F
P
p
.25292 .31507 m .27043 .31723 L .26075 .31935 L 1 0 .136 r
F
P
p
.24326 .31721 m .25292 .31507 L .26075 .31935 L 1 0 .136 r
F
P
p
.002 w
.69079 .75988 m .70137 .73767 L .70596 .71306 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.80672 .56575 m .79593 .57972 L .79052 .55571 L p
1 .636 0 r
F P
0 0 0 r
s
P
p
.002 w
.77959 .56574 m .79052 .55571 L .79593 .57972 L p
1 .766 0 r
F P
0 0 0 r
s
P
p
.002 w
.81698 .53722 m .80672 .56575 L .80155 .54737 L p
1 .445 0 r
F P
0 0 0 r
s
P
p
.002 w
.82831 .53573 m .81698 .53722 L .81283 .54418 L p
1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.80155 .54737 m .81283 .54418 L .81698 .53722 L p
1 .445 0 r
F P
0 0 0 r
s
P
p
.002 w
.85555 .53707 m .84414 .53855 L .8394 .52696 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.82831 .53573 m .8394 .52696 L .84414 .53855 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.6163 .86693 m .60576 .88399 L .59997 .88306 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.002 w
.58948 .91345 m .59997 .88306 L .60576 .88399 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.79052 .55571 m .80155 .54737 L .80672 .56575 L p
1 .636 0 r
F P
0 0 0 r
s
P
p
.002 w
.79052 .55571 m .77959 .56574 L .77432 .54736 L p
1 .518 0 r
F P
0 0 0 r
s
P
p
.002 w
.76335 .5557 m .77432 .54736 L .77959 .56574 L p
1 .586 0 r
F P
0 0 0 r
s
P
p
.002 w
.76335 .5557 m .75247 .56572 L .75167 .70415 L p
.261 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75247 .56572 m .74285 .61901 L .74031 .70516 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74031 .70516 m .75167 .70415 L .75247 .56572 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.89094 .31343 m .9066 .3156 L .89502 .31773 L 1 .068 0 r
F
P
p
.87938 .31558 m .89094 .31343 L .89502 .31773 L 1 .097 0 r
F
P
p
.86364 .31341 m .87938 .31558 L .86788 .31771 L 1 .252 0 r
F
P
p
.85216 .31556 m .86364 .31341 L .86788 .31771 L 1 .257 0 r
F
P
p
.83634 .31339 m .85216 .31556 L .84074 .31769 L 1 .296 0 r
F
P
p
.82494 .31554 m .83634 .31339 L .84074 .31769 L 1 .404 0 r
F
P
p
.80904 .31337 m .82494 .31554 L .8136 .31767 L 1 .545 0 r
F
P
p
.79772 .31551 m .80904 .31337 L .8136 .31767 L 1 .614 0 r
F
P
p
.002 w
.62705 .86641 m .6163 .86693 L .61073 .88259 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.59997 .88306 m .61073 .88259 L .6163 .86693 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.78174 .31335 m .79772 .31551 L .78646 .31765 L .432 1 0 r
F
P
p
.77049 .31549 m .78174 .31335 L .78646 .31765 L .295 1 0 r
F
P
p
.75443 .31332 m .77049 .31549 L .75931 .31762 L .234 0 1 r
F
P
p
.74327 .31547 m .75443 .31332 L .75931 .31762 L .892 0 1 r
F
P
p
.72712 .3133 m .74327 .31547 L .73217 .3176 L 0 .646 1 r
F
P
p
.71604 .31545 m .72712 .3133 L .73217 .3176 L 0 .271 1 r
F
P
p
.69981 .31328 m .71604 .31545 L .70502 .31758 L .166 0 1 r
F
P
p
.68881 .31543 m .69981 .31328 L .70502 .31758 L 1 0 .948 r
F
P
p
.6725 .31326 m .68881 .31543 L .67787 .31756 L 1 0 .587 r
F
P
p
.66158 .3154 m .6725 .31326 L .67787 .31756 L 1 0 .587 r
F
P
p
.64519 .31324 m .66158 .3154 L .65072 .31754 L 1 0 .587 r
F
P
p
.63435 .31538 m .64519 .31324 L .65072 .31754 L 1 0 .587 r
F
P
p
.61787 .31321 m .63435 .31538 L .62357 .31752 L 1 0 .587 r
F
P
p
.60711 .31536 m .61787 .31321 L .62357 .31752 L 1 0 .475 r
F
P
p
.59056 .31319 m .60711 .31536 L .59641 .31749 L 1 0 .587 r
F
P
p
.57988 .31534 m .59056 .31319 L .59641 .31749 L 1 0 .475 r
F
P
p
.56324 .31317 m .57988 .31534 L .56926 .31747 L 1 0 .475 r
F
P
p
.55264 .31532 m .56324 .31317 L .56926 .31747 L 1 0 .362 r
F
P
p
.53592 .31315 m .55264 .31532 L .5421 .31745 L 1 0 .556 r
F
P
p
.5254 .31529 m .53592 .31315 L .5421 .31745 L 1 0 .48 r
F
P
p
.5086 .31313 m .5254 .31529 L .51494 .31743 L 1 0 .273 r
F
P
p
.49816 .31527 m .5086 .31313 L .51494 .31743 L 1 0 .205 r
F
P
p
.48128 .3131 m .49816 .31527 L .48778 .31741 L 1 0 .136 r
F
P
p
.47092 .31525 m .48128 .3131 L .48778 .31741 L 1 0 .136 r
F
P
p
.45395 .31308 m .47092 .31525 L .46062 .31738 L 1 0 .136 r
F
P
p
.44367 .31523 m .45395 .31308 L .46062 .31738 L 1 0 .136 r
F
P
p
.002 w
.86703 .53558 m .87858 .53409 L .8823 .52784 L p
1 .202 0 r
F P
0 0 0 r
s
P
p
.42663 .31306 m .44367 .31523 L .43345 .31736 L 1 0 .136 r
F
P
p
.41643 .31521 m .42663 .31306 L .43345 .31736 L 1 0 .136 r
F
P
p
.3993 .31304 m .41643 .31521 L .40629 .31734 L 1 0 .136 r
F
P
p
.38918 .31518 m .3993 .31304 L .40629 .31734 L 1 0 .136 r
F
P
p
.002 w
.92065 .51841 m .90948 .52851 L .90505 .51685 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.89345 .5184 m .90505 .51685 L .90948 .52851 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.37197 .31301 m .38918 .31518 L .37912 .31732 L 1 0 .102 r
F
P
p
.36193 .31516 m .37197 .31301 L .37912 .31732 L 1 0 .068 r
F
P
p
.34464 .31299 m .36193 .31516 L .35195 .3173 L 1 0 .136 r
F
P
p
.33468 .31514 m .34464 .31299 L .35195 .3173 L 1 0 .136 r
F
P
p
.31731 .31297 m .33468 .31514 L .32478 .31728 L 1 0 .136 r
F
P
p
.30743 .31512 m .31731 .31297 L .32478 .31728 L 1 0 .136 r
F
P
p
.28997 .31295 m .30743 .31512 L .29761 .31725 L 1 0 .136 r
F
P
p
.28017 .3151 m .28997 .31295 L .29761 .31725 L 1 0 .136 r
F
P
p
.26264 .31293 m .28017 .3151 L .27043 .31723 L 1 0 .136 r
F
P
p
.25292 .31507 m .26264 .31293 L .27043 .31723 L 1 0 .136 r
F
P
p
.2353 .3129 m .25292 .31507 L .24326 .31721 L 1 0 .136 r
F
P
p
.002 w
.80155 .54737 m .79052 .55571 L .78552 .54417 L p
1 .416 0 r
F P
0 0 0 r
s
P
p
.002 w
.78552 .54417 m .79052 .55571 L p
.77565 .54804 L 1 .518 0 r
F P
0 0 0 r
s
P
p
.002 w
.78552 .54417 m .79653 .53404 L .80155 .54737 L p
1 .416 0 r
F P
0 0 0 r
s
P
p
.002 w
.78552 .54417 m .78315 .6114 L p
.79545 .54028 L 1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.79653 .53404 m .78552 .54417 L p
.79545 .54028 L 1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.77432 .54736 m .78552 .54417 L p
.77565 .54804 L 1 .518 0 r
F P
0 0 0 r
s
P
p
.002 w
.77432 .54736 m .76335 .5557 L .76311 .70313 L p
.595 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75167 .70415 m .76311 .70313 L .76335 .5557 L p
.261 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.8394 .52696 m .82831 .53573 L .82388 .53406 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.81283 .54418 m .82388 .53406 L .82831 .53573 L p
1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.86703 .53558 m .85555 .53707 L .85086 .52544 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.8394 .52696 m .85086 .52544 L .85555 .53707 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.93233 .51687 m .92065 .51841 L .91672 .5153 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90505 .51685 m .91672 .5153 L .92065 .51841 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.90505 .51685 m .89345 .5184 L .89014 .53125 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.87858 .53409 m .89014 .53125 L .89345 .5184 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.89094 .31343 m .90258 .31128 L .9066 .3156 L 1 .068 0 r
F
P
p
.8752 .31125 m .89094 .31343 L .87938 .31558 L 1 .194 0 r
F
P
p
.86364 .31341 m .8752 .31125 L .87938 .31558 L 1 .252 0 r
F
P
p
.84782 .31123 m .86364 .31341 L .85216 .31556 L 1 .262 0 r
F
P
p
.83634 .31339 m .84782 .31123 L .85216 .31556 L 1 .296 0 r
F
P
p
.82043 .31121 m .83634 .31339 L .82494 .31554 L 1 .404 0 r
F
P
p
.80904 .31337 m .82043 .31121 L .82494 .31554 L 1 .545 0 r
F
P
p
.002 w
.63787 .8659 m .62705 .86641 L .62156 .88212 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.61073 .88259 m .62156 .88212 L .62705 .86641 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.79305 .31119 m .80904 .31337 L .79772 .31551 L .875 1 0 r
F
P
p
.78174 .31335 m .79305 .31119 L .79772 .31551 L .432 1 0 r
F
P
p
.76566 .31117 m .78174 .31335 L .77049 .31549 L 0 .543 1 r
F
P
p
.75443 .31332 m .76566 .31117 L .77049 .31549 L .234 0 1 r
F
P
p
.73827 .31114 m .75443 .31332 L .74327 .31547 L 0 .772 1 r
F
P
p
.72712 .3133 m .73827 .31114 L .74327 .31547 L 0 .646 1 r
F
P
p
.71088 .31112 m .72712 .3133 L .71604 .31545 L 0 1 .911 r
F
P
p
.69981 .31328 m .71088 .31112 L .71604 .31545 L .166 0 1 r
F
P
p
.68349 .3111 m .69981 .31328 L .68881 .31543 L 1 0 .768 r
F
P
p
.6725 .31326 m .68349 .3111 L .68881 .31543 L 1 0 .587 r
F
P
p
.6561 .31108 m .6725 .31326 L .66158 .3154 L 1 0 .587 r
F
P
p
.64519 .31324 m .6561 .31108 L .66158 .3154 L 1 0 .587 r
F
P
p
.6287 .31105 m .64519 .31324 L .63435 .31538 L 1 0 .587 r
F
P
p
.61787 .31321 m .6287 .31105 L .63435 .31538 L 1 0 .587 r
F
P
p
.60131 .31103 m .61787 .31321 L .60711 .31536 L 1 0 .587 r
F
P
p
.59056 .31319 m .60131 .31103 L .60711 .31536 L 1 0 .587 r
F
P
p
.002 w
.81283 .54418 m .80155 .54737 L .79653 .53404 L p
1 .348 0 r
F P
0 0 0 r
s
P
p
.57391 .31101 m .59056 .31319 L .57988 .31534 L 1 0 .776 r
F
P
p
.56324 .31317 m .57391 .31101 L .57988 .31534 L 1 0 .475 r
F
P
p
.002 w
.78552 .54417 m .77432 .54736 L .77229 .6304 L p
.97 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76311 .70313 m .77229 .6304 L .77432 .54736 L p
.595 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56217 .91344 m .55157 .91382 L .54539 .88305 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.53485 .91344 m .54539 .88305 L .55157 .91382 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.54651 .31099 m .56324 .31317 L .55264 .31532 L 1 0 .587 r
F
P
p
.53592 .31315 m .54651 .31099 L .55264 .31532 L 1 0 .556 r
F
P
p
.51911 .31097 m .53592 .31315 L .5254 .31529 L 1 0 .286 r
F
P
p
.5086 .31313 m .51911 .31097 L .5254 .31529 L 1 0 .273 r
F
P
p
.4917 .31094 m .5086 .31313 L .49816 .31527 L 1 0 .136 r
F
P
p
.48128 .3131 m .4917 .31094 L .49816 .31527 L 1 0 .136 r
F
P
p
.4643 .31092 m .48128 .3131 L .47092 .31525 L 1 0 .136 r
F
P
p
.45395 .31308 m .4643 .31092 L .47092 .31525 L 1 0 .136 r
F
P
p
.43689 .3109 m .45395 .31308 L .44367 .31523 L 1 0 .136 r
F
P
p
.42663 .31306 m .43689 .3109 L .44367 .31523 L 1 0 .136 r
F
P
p
.40948 .31088 m .42663 .31306 L .41643 .31521 L 1 0 .136 r
F
P
p
.3993 .31304 m .40948 .31088 L .41643 .31521 L 1 0 .136 r
F
P
p
.38207 .31085 m .3993 .31304 L .38918 .31518 L 1 0 .136 r
F
P
p
.37197 .31301 m .38207 .31085 L .38918 .31518 L 1 0 .102 r
F
P
p
.35466 .31083 m .37197 .31301 L .36193 .31516 L 1 0 .136 r
F
P
p
.34464 .31299 m .35466 .31083 L .36193 .31516 L 1 0 .136 r
F
P
p
.32725 .31081 m .34464 .31299 L .33468 .31514 L 1 0 .136 r
F
P
p
.31731 .31297 m .32725 .31081 L .33468 .31514 L 1 0 .136 r
F
P
p
.002 w
.85086 .52544 m .8394 .52696 L .83534 .53255 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.82388 .53406 m .83534 .53255 L .8394 .52696 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.29983 .31079 m .31731 .31297 L .30743 .31512 L 1 0 .136 r
F
P
p
.28997 .31295 m .29983 .31079 L .30743 .31512 L 1 0 .136 r
F
P
p
.27242 .31077 m .28997 .31295 L .28017 .3151 L 1 0 .136 r
F
P
p
.26264 .31293 m .27242 .31077 L .28017 .3151 L 1 0 .136 r
F
P
p
.245 .31074 m .26264 .31293 L .25292 .31507 L 1 0 .136 r
F
P
p
.2353 .3129 m .245 .31074 L .25292 .31507 L 1 0 .136 r
F
P
p
.002 w
.74285 .61901 m .73411 .70817 L .72901 .70616 L p
0 1 .523 r
F P
0 0 0 r
s
P
p
.002 w
.72901 .70616 m .74031 .70516 L .74285 .61901 L p
0 1 .523 r
F P
0 0 0 r
s
P
p
.002 w
.87858 .53409 m .86703 .53558 L .86238 .52391 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.85086 .52544 m .86238 .52391 L .86703 .53558 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.61073 .88259 m .59997 .88306 L .59411 .88211 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.59997 .88306 m .58948 .91345 L .58336 .88258 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.58336 .88258 m .59411 .88211 L .59997 .88306 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.91672 .5153 m .92845 .51374 L .93233 .51687 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.91672 .5153 m .90505 .51685 L .90142 .52172 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.89014 .53125 m .90142 .52172 L .90505 .51685 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.54539 .88305 m .55599 .88258 L .56217 .91344 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.55599 .88258 m .54539 .88305 L .53922 .9123 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.54539 .88305 m .53485 .91344 L .52859 .91268 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.002 w
.52859 .91268 m .53922 .9123 L .54539 .88305 L p
1 0 .249 r
F P
0 0 0 r
s
P
p
.88682 .30908 m .90258 .31128 L .89094 .31343 L 1 .102 0 r
F
P
p
.8752 .31125 m .88682 .30908 L .89094 .31343 L 1 .194 0 r
F
P
p
.85936 .30906 m .8752 .31125 L .86364 .31341 L 1 .194 0 r
F
P
p
.84782 .31123 m .85936 .30906 L .86364 .31341 L 1 .262 0 r
F
P
p
.83189 .30904 m .84782 .31123 L .83634 .31339 L 1 .296 0 r
F
P
p
.82043 .31121 m .83189 .30904 L .83634 .31339 L 1 .404 0 r
F
P
p
.002 w
.82388 .53406 m .81283 .54418 L .80791 .53253 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.79653 .53404 m .80791 .53253 L .81283 .54418 L p
1 .348 0 r
F P
0 0 0 r
s
P
p
.002 w
.64876 .86538 m .63787 .8659 L .63245 .88165 L p
1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.62156 .88212 m .63245 .88165 L .63787 .8659 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.80443 .30902 m .82043 .31121 L .80904 .31337 L 1 .682 0 r
F
P
p
.79305 .31119 m .80443 .30902 L .80904 .31337 L .875 1 0 r
F
P
p
.002 w
.77229 .6304 m .78315 .6114 L .78552 .54417 L p
.97 1 0 r
F P
0 0 0 r
s
P
p
.77696 .30899 m .79305 .31119 L .78174 .31335 L 0 1 .42 r
F
P
p
.76566 .31117 m .77696 .30899 L .78174 .31335 L 0 .543 1 r
F
P
p
.74949 .30897 m .76566 .31117 L .75443 .31332 L 0 1 .945 r
F
P
p
.73827 .31114 m .74949 .30897 L .75443 .31332 L 0 .772 1 r
F
P
p
.72202 .30895 m .73827 .31114 L .72712 .3133 L .038 1 0 r
F
P
p
.71088 .31112 m .72202 .30895 L .72712 .3133 L 0 1 .911 r
F
P
p
.69454 .30893 m .71088 .31112 L .69981 .31328 L 1 0 .948 r
F
P
p
.68349 .3111 m .69454 .30893 L .69981 .31328 L 1 0 .768 r
F
P
p
.002 w
.71182 .71013 m .70137 .73767 L .70116 .74649 L p
0 .352 1 r
F P
0 0 0 r
s
P
p
.002 w
.70116 .74649 m .69866 .85384 L p
.70975 .73274 L 0 .352 1 r
F P
0 0 0 r
s
P
p
.70975 .73274 m .71182 .71013 L .70116 .74649 L 0 .352 1 r
F
P
p
.002 w
.69866 .85384 m .70745 .74391 L .71182 .71013 L p
0 .352 1 r
F P
0 0 0 r
s
P
p
.002 w
.70745 .74391 m .71824 .72574 L .72165 .71368 L p
0 .929 1 r
F P
0 0 0 r
s
P
p
.002 w
.72165 .71368 m .72293 .70915 L p
.71908 .71779 L 0 .929 1 r
F P
0 0 0 r
s
P
p
.70745 .74391 m .72165 .71368 L .71908 .71779 L 0 .929 1 r
F
P
p
.002 w
.70137 .73767 m .69079 .75988 L .68756 .86219 L p
.27 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68115 .83024 m .67016 .83309 L .66523 .86326 L p
.917 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66523 .86326 m .67636 .86273 L .68115 .83024 L p
.917 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.69079 .75988 m .68115 .83024 L .67636 .86273 L p
.645 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.67636 .86273 m .68756 .86219 L .69079 .75988 L p
.645 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68756 .86219 m .69866 .85384 L .70137 .73767 L p
.27 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.69866 .85384 m .68756 .86219 L .68251 .87145 L p
1 0 .829 r
F P
0 0 0 r
s
P
p
.68291 .87115 m .69866 .85384 L .68251 .87145 L 1 0 .829 r
F
P
p
.002 w
.69342 .86055 m .69866 .85384 L p
.68291 .87115 L 1 0 .829 r
F P
0 0 0 r
s
P
p
.002 w
.68231 .87181 m .69342 .86055 L p
.68291 .87115 L 1 0 .829 r
F P
0 0 0 r
s
P
p
.002 w
.70745 .74391 m .69866 .85384 L .69342 .86055 L p
.694 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.69342 .86055 m .70481 .86 L .70745 .74391 L p
.694 0 1 r
F P
0 0 0 r
s
P
p
.69837 .78274 m .70397 .84992 L .69342 .86055 L 0 .874 1 r
F
P
p
.70397 .84992 m .70442 .85529 L .69342 .86055 L 0 .874 1 r
F
P
p
.002 w
.69342 .86055 m .68268 .59455 L p
.69837 .78274 L 0 .874 1 r
F P
0 0 0 r
s
P
p
.002 w
.70481 .86 m .69756 .86035 L p
.70442 .85529 L 0 .874 1 r
F P
0 0 0 r
s
P
p
.002 w
.69756 .86035 m .69342 .86055 L p
.70442 .85529 L 0 .874 1 r
F P
0 0 0 r
s
P
p
.002 w
.68251 .87145 m .68231 .87181 L p
.68291 .87115 L 1 0 .829 r
F P
0 0 0 r
s
P
p
.68285 .59446 m .70481 .86 L .68268 .59455 L 0 .874 1 r
F
P
p
.002 w
.68251 .59028 m .69353 .58894 L .70481 .86 L p
0 .874 1 r
F P
0 0 0 r
s
P
p
.002 w
.71824 .72574 m .70745 .74391 L .705 .85189 L p
.186 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.705 .85189 m .70481 .86 L p
.70571 .85098 L .186 0 1 r
F P
0 0 0 r
s
P
p
.70571 .85098 m .71824 .72574 L .705 .85189 L .186 0 1 r
F
P
p
.002 w
.72293 .70915 m .71182 .71013 L .70745 .74391 L p
0 .929 1 r
F P
0 0 0 r
s
P
p
.002 w
.73411 .70817 m .72293 .70915 L .71824 .72574 L p
0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.71824 .72574 m .72901 .70616 L .73411 .70817 L p
0 1 .934 r
F P
0 0 0 r
s
P
p
.002 w
.72901 .70616 m .71824 .72574 L .71605 .85021 L p
0 .068 1 r
F P
0 0 0 r
s
P
p
.002 w
.70481 .86 m .71605 .85021 L .71824 .72574 L p
.186 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.71605 .85021 m .72698 .82671 L .72901 .70616 L p
0 .068 1 r
F P
0 0 0 r
s
P
p
.002 w
.71547 .57457 m .72686 .82416 L p
.70488 .58403 L 0 1 .895 r
F P
0 0 0 r
s
P
p
.70441 .57886 m .72686 .82416 L .72676 .82429 L 0 1 .895 r
F
P
p
.002 w
.72698 .82671 m .71605 .85021 L .70441 .57886 L p
0 1 .895 r
F P
0 0 0 r
s
P
p
.002 w
.74031 .70516 m .72901 .70616 L .72698 .82671 L p
0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.73594 .73029 m .72698 .82671 L .71547 .57457 L p
0 1 .389 r
F P
0 0 0 r
s
P
p
.002 w
.71547 .57457 m .72629 .55859 L .73594 .73029 L p
0 1 .389 r
F P
0 0 0 r
s
P
p
.002 w
.71547 .57457 m .71754 .87417 L p
.72611 .56507 L 0 .896 1 r
F P
0 0 0 r
s
P
p
.002 w
.72629 .55859 m .71547 .57457 L p
.72611 .56507 L 0 .896 1 r
F P
0 0 0 r
s
P
p
.002 w
.70441 .57886 m .71547 .57457 L p
.70488 .58403 L 0 1 .895 r
F P
0 0 0 r
s
P
p
.002 w
.72686 .82416 m .72698 .82671 L p
.72676 .82429 L 0 1 .895 r
F P
0 0 0 r
s
P
p
.002 w
.71605 .85021 m .70481 .86 L .69353 .58894 L p
0 .942 1 r
F P
0 0 0 r
s
P
p
.002 w
.69353 .58894 m .70441 .57886 L .71605 .85021 L p
0 .942 1 r
F P
0 0 0 r
s
P
p
.002 w
.69353 .58894 m .69428 .87521 L p
.70425 .58341 L 0 .782 1 r
F P
0 0 0 r
s
P
p
.002 w
.70441 .57886 m .69353 .58894 L p
.70425 .58341 L 0 .782 1 r
F P
0 0 0 r
s
P
p
.002 w
.68268 .59455 m .68251 .59028 L p
.68285 .59446 L 0 .874 1 r
F P
0 0 0 r
s
P
p
.002 w
.67221 .62647 m .68251 .59028 L .69342 .86055 L p
0 .698 1 r
F P
0 0 0 r
s
P
p
.002 w
.68756 .86219 m .67636 .86273 L .67116 .87874 L p
1 0 .737 r
F P
0 0 0 r
s
P
p
.002 w
.67116 .87874 m .68231 .87181 L .68756 .86219 L p
1 0 .737 r
F P
0 0 0 r
s
P
p
.002 w
.69342 .86055 m .68231 .87181 L .67221 .62647 L p
0 .698 1 r
F P
0 0 0 r
s
P
p
.002 w
.69353 .58894 m .68251 .59028 L .68276 .87572 L p
0 .748 1 r
F P
0 0 0 r
s
P
p
.002 w
.66264 .70714 m .67221 .62647 L .68231 .87181 L p
0 .192 1 r
F P
0 0 0 r
s
P
p
.002 w
.65958 .85718 m .64876 .86538 L .64317 .86432 L p
1 0 .868 r
F P
0 0 0 r
s
P
p
.002 w
.64317 .86432 m .65417 .8638 L .65958 .85718 L p
1 0 .868 r
F P
0 0 0 r
s
P
p
.002 w
.67016 .83309 m .65958 .85718 L .65417 .8638 L p
1 0 .985 r
F P
0 0 0 r
s
P
p
.002 w
.65417 .8638 m .66523 .86326 L .67016 .83309 L p
1 0 .985 r
F P
0 0 0 r
s
P
p
.002 w
.67636 .86273 m .66523 .86326 L .65996 .87923 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.65996 .87923 m .67116 .87874 L .67636 .86273 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.68231 .87181 m .67116 .87874 L .66264 .70714 L p
0 .192 1 r
F P
0 0 0 r
s
P
p
.002 w
.68251 .59028 m .67221 .62647 L .67187 .90752 L p
0 .499 1 r
F P
0 0 0 r
s
P
p
.002 w
.68276 .87572 m .68251 .59028 L p
.67292 .87628 L 0 .499 1 r
F P
0 0 0 r
s
P
p
.002 w
.68276 .87572 m .69428 .87521 L .69353 .58894 L p
0 .748 1 r
F P
0 0 0 r
s
P
p
.002 w
.68276 .87572 m .67714 .87469 L p
.69267 .87516 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.69428 .87521 m .68276 .87572 L p
.69267 .87516 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67187 .90752 m .68276 .87572 L p
.67292 .87628 L 0 .499 1 r
F P
0 0 0 r
s
P
p
.66707 .30891 m .68349 .3111 L .6725 .31326 L 1 0 .684 r
F
P
p
.6561 .31108 m .66707 .30891 L .6725 .31326 L 1 0 .587 r
F
P
p
.63959 .30888 m .6561 .31108 L .64519 .31324 L 1 0 .587 r
F
P
p
.6287 .31105 m .63959 .30888 L .64519 .31324 L 1 0 .587 r
F
P
p
.61212 .30886 m .6287 .31105 L .61787 .31321 L 1 0 .587 r
F
P
p
.60131 .31103 m .61212 .30886 L .61787 .31321 L 1 0 .587 r
F
P
p
.002 w
.57283 .91307 m .58336 .88258 L .58948 .91345 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.58464 .30884 m .60131 .31103 L .59056 .31319 L .723 0 1 r
F
P
p
.57391 .31101 m .58464 .30884 L .59056 .31319 L 1 0 .776 r
F
P
p
.002 w
.57283 .91307 m .56217 .91344 L .55599 .88258 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.55716 .30882 m .57391 .31101 L .56324 .31317 L 1 0 .587 r
F
P
p
.54651 .31099 m .55716 .30882 L .56324 .31317 L 1 0 .587 r
F
P
p
.52967 .30879 m .54651 .31099 L .53592 .31315 L 1 0 .33 r
F
P
p
.51911 .31097 m .52967 .30879 L .53592 .31315 L 1 0 .286 r
F
P
p
.50219 .30877 m .51911 .31097 L .5086 .31313 L 1 0 .136 r
F
P
p
.4917 .31094 m .50219 .30877 L .5086 .31313 L 1 0 .136 r
F
P
p
.4747 .30875 m .4917 .31094 L .48128 .3131 L 1 0 .136 r
F
P
p
.4643 .31092 m .4747 .30875 L .48128 .3131 L 1 0 .136 r
F
P
p
.44721 .30873 m .4643 .31092 L .45395 .31308 L 1 0 .136 r
F
P
p
.43689 .3109 m .44721 .30873 L .45395 .31308 L 1 0 .136 r
F
P
p
.41972 .3087 m .43689 .3109 L .42663 .31306 L 1 0 .136 r
F
P
p
.40948 .31088 m .41972 .3087 L .42663 .31306 L 1 0 .136 r
F
P
p
.39223 .30868 m .40948 .31088 L .3993 .31304 L 1 0 .136 r
F
P
p
.38207 .31085 m .39223 .30868 L .3993 .31304 L 1 0 .136 r
F
P
p
.36474 .30866 m .38207 .31085 L .37197 .31301 L 1 0 .136 r
F
P
p
.35466 .31083 m .36474 .30866 L .37197 .31301 L 1 0 .136 r
F
P
p
.33725 .30864 m .35466 .31083 L .34464 .31299 L 1 0 .136 r
F
P
p
.32725 .31081 m .33725 .30864 L .34464 .31299 L 1 0 .136 r
F
P
p
.002 w
.86238 .52391 m .85086 .52544 L .84687 .53103 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.83534 .53255 m .84687 .53103 L .85086 .52544 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.30975 .30861 m .32725 .31081 L .31731 .31297 L 1 0 .136 r
F
P
p
.29983 .31079 m .30975 .30861 L .31731 .31297 L 1 0 .136 r
F
P
p
.28225 .30859 m .29983 .31079 L .28997 .31295 L 1 0 .136 r
F
P
p
.27242 .31077 m .28225 .30859 L .28997 .31295 L 1 0 .136 r
F
P
p
.25475 .30857 m .27242 .31077 L .26264 .31293 L 1 0 .136 r
F
P
p
.245 .31074 m .25475 .30857 L .26264 .31293 L 1 0 .136 r
F
P
p
.22725 .30855 m .245 .31074 L .2353 .3129 L 1 0 .136 r
F
P
p
.002 w
.89014 .53125 m .87858 .53409 L .87397 .52237 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.002 w
.86238 .52391 m .87397 .52237 L .87858 .53409 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.83534 .53255 m .82388 .53406 L .81935 .53102 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.80791 .53253 m .81935 .53102 L .82388 .53406 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.80791 .53253 m .79653 .53404 L .79464 .6101 L p
1 .669 0 r
F P
0 0 0 r
s
P
p
.002 w
.78315 .6114 m .79464 .6101 L .79653 .53404 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.66523 .86326 m .65417 .8638 L .64882 .87972 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.64882 .87972 m .65996 .87923 L .66523 .86326 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.67116 .87874 m .65996 .87923 L .65345 .74549 L p
.138 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65345 .74549 m .65164 .70814 L p
.65512 .73854 L .138 0 1 r
F P
0 0 0 r
s
P
p
.65512 .73854 m .67116 .87874 L .65345 .74549 L .138 0 1 r
F
P
p
.002 w
.65164 .70814 m .66264 .70714 L .67116 .87874 L p
.138 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66264 .70714 m .66044 .90793 L p
.67015 .67577 L .057 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.67221 .62647 m .66264 .70714 L p
.67015 .67577 L .057 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66044 .90793 m .67187 .90752 L .67221 .62647 L p
.057 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62156 .88212 m .61073 .88259 L .60492 .88164 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.59411 .88211 m .60492 .88164 L .61073 .88259 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.59411 .88211 m .58336 .88258 L .57738 .88164 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.58336 .88258 m .57283 .91307 L .56665 .88211 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.56665 .88211 m .57738 .88164 L .58336 .88258 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.92845 .51374 m .91672 .5153 L .91274 .51215 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90142 .52172 m .91274 .51215 L .91672 .5153 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.55599 .88258 m .56665 .88211 L .57283 .91307 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.56665 .88211 m .55599 .88258 L .54991 .91191 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.53922 .9123 m .54991 .91191 L .55599 .88258 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.88682 .30908 m .89851 .3069 L .90258 .31128 L 1 .102 0 r
F
P
p
.87097 .30688 m .88682 .30908 L .8752 .31125 L 1 .097 0 r
F
P
p
.85936 .30906 m .87097 .30688 L .8752 .31125 L 1 .194 0 r
F
P
p
.84342 .30686 m .85936 .30906 L .84782 .31123 L 1 .199 0 r
F
P
p
.83189 .30904 m .84342 .30686 L .84782 .31123 L 1 .296 0 r
F
P
p
.002 w
.63245 .88165 m .64317 .86432 L .64876 .86538 L p
1 0 .776 r
F P
0 0 0 r
s
P
p
.81587 .30683 m .83189 .30904 L .82043 .31121 L 1 .574 0 r
F
P
p
.80443 .30902 m .81587 .30683 L .82043 .31121 L 1 .682 0 r
F
P
p
.78832 .30681 m .80443 .30902 L .79305 .31119 L .466 1 0 r
F
P
p
.77696 .30899 m .78832 .30681 L .79305 .31119 L 0 1 .42 r
F
P
p
.76077 .30679 m .77696 .30899 L .76566 .31117 L 0 1 .23 r
F
P
p
.74949 .30897 m .76077 .30679 L .76566 .31117 L 0 1 .945 r
F
P
p
.73322 .30677 m .74949 .30897 L .73827 .31114 L .311 1 0 r
F
P
p
.72202 .30895 m .73322 .30677 L .73827 .31114 L .038 1 0 r
F
P
p
.70566 .30674 m .72202 .30895 L .71088 .31112 L .595 0 1 r
F
P
p
.69454 .30893 m .70566 .30674 L .71088 .31112 L 1 0 .948 r
F
P
p
.67811 .30672 m .69454 .30893 L .68349 .3111 L 1 0 .864 r
F
P
p
.66707 .30891 m .67811 .30672 L .68349 .3111 L 1 0 .684 r
F
P
p
.65055 .3067 m .66707 .30891 L .6561 .31108 L 1 0 .841 r
F
P
p
.63959 .30888 m .65055 .3067 L .6561 .31108 L 1 0 .587 r
F
P
p
.62299 .30668 m .63959 .30888 L .6287 .31105 L 1 0 .587 r
F
P
p
.61212 .30886 m .62299 .30668 L .6287 .31105 L 1 0 .587 r
F
P
p
.59543 .30665 m .61212 .30886 L .60131 .31103 L .156 0 1 r
F
P
p
.58464 .30884 m .59543 .30665 L .60131 .31103 L .723 0 1 r
F
P
p
.56787 .30663 m .58464 .30884 L .57391 .31101 L 1 0 .776 r
F
P
p
.55716 .30882 m .56787 .30663 L .57391 .31101 L 1 0 .587 r
F
P
p
.5403 .30661 m .55716 .30882 L .54651 .31099 L 1 0 .43 r
F
P
p
.52967 .30879 m .5403 .30661 L .54651 .31099 L 1 0 .33 r
F
P
p
.51274 .30659 m .52967 .30879 L .51911 .31097 L 1 0 .136 r
F
P
p
.50219 .30877 m .51274 .30659 L .51911 .31097 L 1 0 .136 r
F
P
p
.48517 .30656 m .50219 .30877 L .4917 .31094 L 1 0 .136 r
F
P
p
.4747 .30875 m .48517 .30656 L .4917 .31094 L 1 0 .136 r
F
P
p
.4576 .30654 m .4747 .30875 L .4643 .31092 L 1 0 .136 r
F
P
p
.44721 .30873 m .4576 .30654 L .4643 .31092 L 1 0 .136 r
F
P
p
.43003 .30652 m .44721 .30873 L .43689 .3109 L 1 0 .136 r
F
P
p
.41972 .3087 m .43003 .30652 L .43689 .3109 L 1 0 .136 r
F
P
p
.40245 .3065 m .41972 .3087 L .40948 .31088 L 1 0 .136 r
F
P
p
.39223 .30868 m .40245 .3065 L .40948 .31088 L 1 0 .136 r
F
P
p
.37488 .30647 m .39223 .30868 L .38207 .31085 L 1 0 .136 r
F
P
p
.36474 .30866 m .37488 .30647 L .38207 .31085 L 1 0 .136 r
F
P
p
.3473 .30645 m .36474 .30866 L .35466 .31083 L 1 0 .136 r
F
P
p
.33725 .30864 m .3473 .30645 L .35466 .31083 L 1 0 .136 r
F
P
p
.002 w
.87397 .52237 m .86238 .52391 L .85807 .5208 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.84687 .53103 m .85807 .5208 L .86238 .52391 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.31973 .30643 m .33725 .30864 L .32725 .31081 L 1 0 .136 r
F
P
p
.30975 .30861 m .31973 .30643 L .32725 .31081 L 1 0 .136 r
F
P
p
.29215 .30641 m .30975 .30861 L .29983 .31079 L 1 0 .136 r
F
P
p
.28225 .30859 m .29215 .30641 L .29983 .31079 L 1 0 .136 r
F
P
p
.26456 .30638 m .28225 .30859 L .27242 .31077 L 1 0 .136 r
F
P
p
.25475 .30857 m .26456 .30638 L .27242 .31077 L 1 0 .136 r
F
P
p
.23698 .30636 m .25475 .30857 L .245 .31074 L 1 0 .136 r
F
P
p
.22725 .30855 m .23698 .30636 L .245 .31074 L 1 0 .136 r
F
P
p
.002 w
.90142 .52172 m .89014 .53125 L .88521 .51213 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.87397 .52237 m .88521 .51213 L .89014 .53125 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.002 w
.84687 .53103 m .83534 .53255 L .83086 .52949 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.81935 .53102 m .83086 .52949 L .83534 .53255 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.79464 .6101 m .80411 .55235 L .80791 .53253 L p
1 .669 0 r
F P
0 0 0 r
s
P
p
.002 w
.81935 .53102 m .80791 .53253 L .80411 .55235 L p
1 .403 0 r
F P
0 0 0 r
s
P
p
.002 w
.71547 .57457 m .70441 .57886 L .70588 .87469 L p
0 .828 1 r
F P
0 0 0 r
s
P
p
.002 w
.69428 .87521 m .70588 .87469 L .70441 .57886 L p
0 .782 1 r
F P
0 0 0 r
s
P
p
.002 w
.65417 .8638 m .64317 .86432 L .63774 .8802 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.63774 .8802 m .64882 .87972 L .65417 .8638 L p
1 0 .713 r
F P
0 0 0 r
s
P
p
.002 w
.63138 .83057 m .64121 .74478 L .64882 .87972 L p
.731 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64317 .86432 m .63245 .88165 L .62674 .88068 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.002 w
.62674 .88068 m .63774 .8802 L .64317 .86432 L p
1 0 .65 r
F P
0 0 0 r
s
P
p
.002 w
.63774 .8802 m .62674 .88068 L .62417 .87298 L p
1 0 .831 r
F P
0 0 0 r
s
P
p
.002 w
.62417 .87298 m .62076 .86272 L p
.62585 .86797 L 1 0 .831 r
F P
0 0 0 r
s
P
p
.62585 .86797 m .63774 .8802 L .62417 .87298 L 1 0 .831 r
F
P
p
.002 w
.64882 .87972 m .63774 .8802 L .63138 .83057 L p
.731 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63138 .83057 m .63774 .8802 L p
.62585 .86797 L 1 0 .831 r
F P
0 0 0 r
s
P
p
.002 w
.62076 .86272 m .63138 .83057 L p
.62585 .86797 L 1 0 .831 r
F P
0 0 0 r
s
P
p
.002 w
.63138 .83057 m .62981 .8562 L p
.63481 .80736 L .957 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64121 .74478 m .63138 .83057 L p
.63481 .80736 L .957 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62981 .8562 m .62844 .87862 L p
.63088 .85302 L .957 0 1 r
F P
0 0 0 r
s
P
p
.63088 .85302 m .64121 .74478 L .62981 .8562 L .957 0 1 r
F
P
p
.002 w
.63245 .88165 m .62156 .88212 L .61909 .88171 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.62035 .8813 m .63245 .88165 L .61909 .88171 L 1 0 .587 r
F
P
p
.002 w
.61579 .88116 m .62674 .88068 L .63245 .88165 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.62844 .87862 m .62657 .90915 L p
.62932 .87833 L .957 0 1 r
F P
0 0 0 r
s
P
p
.62932 .87833 m .64121 .74478 L .62844 .87862 L .957 0 1 r
F
P
p
.002 w
.61909 .88171 m .61579 .88116 L p
.62035 .8813 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.60492 .88164 m .61579 .88116 L .62156 .88212 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.60492 .88164 m .59411 .88211 L .58818 .88116 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.57738 .88164 m .58818 .88116 L .59411 .88211 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.91274 .51215 m .92453 .51057 L .92845 .51374 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.57738 .88164 m .56665 .88211 L .56066 .91152 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.54991 .91191 m .56066 .91152 L .56665 .88211 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.88265 .30468 m .89851 .3069 L .88682 .30908 L 1 .034 0 r
F
P
p
.87097 .30688 m .88265 .30468 L .88682 .30908 L 1 .097 0 r
F
P
p
.85502 .30466 m .87097 .30688 L .85936 .30906 L 1 .068 0 r
F
P
p
.84342 .30686 m .85502 .30466 L .85936 .30906 L 1 .199 0 r
F
P
p
.82739 .30464 m .84342 .30686 L .83189 .30904 L 1 .467 0 r
F
P
p
.81587 .30683 m .82739 .30464 L .83189 .30904 L 1 .574 0 r
F
P
p
.79976 .30461 m .81587 .30683 L .80443 .30902 L .909 1 0 r
F
P
p
.78832 .30681 m .79976 .30461 L .80443 .30902 L .466 1 0 r
F
P
p
.77212 .30459 m .78832 .30681 L .77696 .30899 L .67 1 0 r
F
P
p
.76077 .30679 m .77212 .30459 L .77696 .30899 L 0 1 .23 r
F
P
p
.74449 .30457 m .76077 .30679 L .74949 .30897 L .5 1 0 r
F
P
p
.73322 .30677 m .74449 .30457 L .74949 .30897 L .311 1 0 r
F
P
p
.71685 .30455 m .73322 .30677 L .72202 .30895 L .02 0 1 r
F
P
p
.70566 .30674 m .71685 .30455 L .72202 .30895 L .595 0 1 r
F
P
p
.68921 .30452 m .70566 .30674 L .69454 .30893 L .717 0 1 r
F
P
p
.67811 .30672 m .68921 .30452 L .69454 .30893 L 1 0 .864 r
F
P
p
.66157 .3045 m .67811 .30672 L .66707 .30891 L .391 0 1 r
F
P
p
.65055 .3067 m .66157 .3045 L .66707 .30891 L 1 0 .841 r
F
P
p
.63393 .30448 m .65055 .3067 L .63959 .30888 L 1 0 .587 r
F
P
p
.62299 .30668 m .63393 .30448 L .63959 .30888 L 1 0 .587 r
F
P
p
.60629 .30446 m .62299 .30668 L .61212 .30886 L 0 .15 1 r
F
P
p
.59543 .30665 m .60629 .30446 L .61212 .30886 L .156 0 1 r
F
P
p
.57864 .30443 m .59543 .30665 L .58464 .30884 L .723 0 1 r
F
P
p
.56787 .30663 m .57864 .30443 L .58464 .30884 L 1 0 .776 r
F
P
p
.551 .30441 m .56787 .30663 L .55716 .30882 L 1 0 .498 r
F
P
p
.5403 .30661 m .551 .30441 L .55716 .30882 L 1 0 .43 r
F
P
p
.52335 .30439 m .5403 .30661 L .52967 .30879 L 1 0 .136 r
F
P
p
.51274 .30659 m .52335 .30439 L .52967 .30879 L 1 0 .136 r
F
P
p
.4957 .30437 m .51274 .30659 L .50219 .30877 L 1 0 .136 r
F
P
p
.48517 .30656 m .4957 .30437 L .50219 .30877 L 1 0 .136 r
F
P
p
.46805 .30434 m .48517 .30656 L .4747 .30875 L 1 0 .136 r
F
P
p
.4576 .30654 m .46805 .30434 L .4747 .30875 L 1 0 .136 r
F
P
p
.002 w
.91274 .51215 m .90142 .52172 L .89693 .51055 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.88521 .51213 m .89693 .51055 L .90142 .52172 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.44039 .30432 m .4576 .30654 L .44721 .30873 L 1 0 .136 r
F
P
p
.43003 .30652 m .44039 .30432 L .44721 .30873 L 1 0 .136 r
F
P
p
.41274 .3043 m .43003 .30652 L .41972 .3087 L 1 0 .17 r
F
P
p
.40245 .3065 m .41274 .3043 L .41972 .3087 L 1 0 .136 r
F
P
p
.38508 .30427 m .40245 .3065 L .39223 .30868 L 1 0 .17 r
F
P
p
.37488 .30647 m .38508 .30427 L .39223 .30868 L 1 0 .136 r
F
P
p
.35742 .30425 m .37488 .30647 L .36474 .30866 L 1 0 .136 r
F
P
p
.3473 .30645 m .35742 .30425 L .36474 .30866 L 1 0 .136 r
F
P
p
.002 w
.88521 .51213 m .87397 .52237 L .86972 .51925 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.85807 .5208 m .86972 .51925 L .87397 .52237 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.32976 .30423 m .3473 .30645 L .33725 .30864 L 1 0 .136 r
F
P
p
.31973 .30643 m .32976 .30423 L .33725 .30864 L 1 0 .136 r
F
P
p
.3021 .30421 m .31973 .30643 L .30975 .30861 L 1 0 .136 r
F
P
p
.29215 .30641 m .3021 .30421 L .30975 .30861 L 1 0 .136 r
F
P
p
.27444 .30418 m .29215 .30641 L .28225 .30859 L 1 0 .136 r
F
P
p
.26456 .30638 m .27444 .30418 L .28225 .30859 L 1 0 .136 r
F
P
p
.24677 .30416 m .26456 .30638 L .25475 .30857 L 1 0 .136 r
F
P
p
.23698 .30636 m .24677 .30416 L .25475 .30857 L 1 0 .136 r
F
P
p
.2191 .30414 m .23698 .30636 L .22725 .30855 L 1 0 .136 r
F
P
p
.002 w
.64121 .74478 m .65164 .70814 L .65996 .87923 L p
.274 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65996 .87923 m .64882 .87972 L .64121 .74478 L p
.274 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66264 .70714 m .65164 .70814 L .64908 .90834 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65164 .70814 m .64121 .74478 L .63779 .90875 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63779 .90875 m .64908 .90834 L .65164 .70814 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.70588 .87469 m .71754 .87417 L .71547 .57457 L p
0 .828 1 r
F P
0 0 0 r
s
P
p
.002 w
.85807 .5208 m .84687 .53103 L .84244 .52796 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.83086 .52949 m .84244 .52796 L .84687 .53103 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83086 .52949 m .81935 .53102 L .81517 .53845 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.80411 .55235 m .81517 .53845 L .81935 .53102 L p
1 .403 0 r
F P
0 0 0 r
s
P
p
.002 w
.61579 .88116 m .60492 .88164 L .59904 .88068 L p
1 0 .611 r
F P
0 0 0 r
s
P
p
.002 w
.59904 .88068 m .60492 .88164 L p
.59108 .88124 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.6099 .87383 m .61579 .88116 L p
.60054 .88072 L 1 0 .611 r
F P
0 0 0 r
s
P
p
.002 w
.59904 .88068 m .6099 .87383 L p
.60054 .88072 L 1 0 .611 r
F P
0 0 0 r
s
P
p
.002 w
.62674 .88068 m .61579 .88116 L .6099 .87383 L p
1 0 .674 r
F P
0 0 0 r
s
P
p
.002 w
.62076 .86272 m .62674 .88068 L p
.61406 .87553 L 1 0 .674 r
F P
0 0 0 r
s
P
p
.002 w
.6099 .87383 m .62076 .86272 L p
.61406 .87553 L 1 0 .674 r
F P
0 0 0 r
s
P
p
.002 w
.62076 .86272 m .61542 .90955 L p
.62748 .84985 L 1 0 .605 r
F P
0 0 0 r
s
P
p
.002 w
.63138 .83057 m .62076 .86272 L p
.62748 .84985 L 1 0 .605 r
F P
0 0 0 r
s
P
p
.002 w
.6099 .87383 m .60434 .90995 L p
.6193 .86691 L 1 0 .448 r
F P
0 0 0 r
s
P
p
.002 w
.62076 .86272 m .6099 .87383 L p
.6193 .86691 L 1 0 .448 r
F P
0 0 0 r
s
P
p
.002 w
.59904 .88068 m .59332 .91035 L p
.60705 .88011 L 1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.6099 .87383 m .59904 .88068 L p
.60705 .88011 L 1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.58818 .88116 m .59904 .88068 L p
.59108 .88124 L 1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.58818 .88116 m .57738 .88164 L .57148 .91113 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.56066 .91152 m .57148 .91113 L .57738 .88164 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.92453 .51057 m .91274 .51215 L .90871 .50896 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89693 .51055 m .90871 .50896 L .91274 .51215 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.89693 .51055 m .88521 .51213 L .88144 .51768 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.86972 .51925 m .88144 .51768 L .88521 .51213 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.73594 .73029 m .74031 .70516 L p
.73038 .79567 L 0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.72698 .82671 m .73594 .73029 L p
.73038 .79567 L 0 .577 1 r
F P
0 0 0 r
s
P
p
.002 w
.73594 .73029 m .72629 .55859 L p
.74144 .66553 L .125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74564 .70468 m .74031 .70516 L .73594 .73029 L p
0 1 .966 r
F P
0 0 0 r
s
P
p
.002 w
.75167 .70415 m .74564 .70468 L p
.73594 .73029 L 0 1 .966 r
F P
0 0 0 r
s
P
p
.002 w
.74662 .70209 m .73594 .73029 L p
.74144 .66553 L .125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72629 .55859 m .73753 .55715 L .74662 .70209 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73753 .55715 m .72629 .55859 L .72928 .87365 L p
0 .953 1 r
F P
0 0 0 r
s
P
p
.002 w
.71754 .87417 m .72928 .87365 L .72629 .55859 L p
0 .896 1 r
F P
0 0 0 r
s
P
p
.002 w
.62657 .90915 m .63779 .90875 L .64121 .74478 L p
.957 0 1 r
F P
0 0 0 r
s
P
p
.88265 .30468 m .89439 .30247 L .89851 .3069 L 1 .034 0 r
F
P
p
.86668 .30245 m .88265 .30468 L .87097 .30688 L 1 0 0 r
F
P
p
.85502 .30466 m .86668 .30245 L .87097 .30688 L 1 .068 0 r
F
P
p
.83897 .30243 m .85502 .30466 L .84342 .30686 L 1 .37 0 r
F
P
p
.82739 .30464 m .83897 .30243 L .84342 .30686 L 1 .467 0 r
F
P
p
.81126 .3024 m .82739 .30464 L .81587 .30683 L 1 .886 0 r
F
P
p
.79976 .30461 m .81126 .3024 L .81587 .30683 L .909 1 0 r
F
P
p
.78354 .30238 m .79976 .30461 L .78832 .30681 L 1 .852 0 r
F
P
p
.77212 .30459 m .78354 .30238 L .78832 .30681 L .67 1 0 r
F
P
p
.75582 .30236 m .77212 .30459 L .76077 .30679 L .977 1 0 r
F
P
p
.74449 .30457 m .75582 .30236 L .76077 .30679 L .5 1 0 r
F
P
p
.72811 .30234 m .74449 .30457 L .73322 .30677 L 0 .247 1 r
F
P
p
.71685 .30455 m .72811 .30234 L .73322 .30677 L .02 0 1 r
F
P
p
.70038 .30231 m .71685 .30455 L .70566 .30674 L .192 0 1 r
F
P
p
.68921 .30452 m .70038 .30231 L .70566 .30674 L .717 0 1 r
F
P
p
.67266 .30229 m .68921 .30452 L .67811 .30672 L 0 .241 1 r
F
P
p
.66157 .3045 m .67266 .30229 L .67811 .30672 L .391 0 1 r
F
P
p
.64494 .30227 m .66157 .3045 L .65055 .3067 L .905 0 1 r
F
P
p
.63393 .30448 m .64494 .30227 L .65055 .3067 L 1 0 .587 r
F
P
p
.61721 .30224 m .63393 .30448 L .62299 .30668 L 0 .476 1 r
F
P
p
.60629 .30446 m .61721 .30224 L .62299 .30668 L 0 .15 1 r
F
P
p
.58948 .30222 m .60629 .30446 L .59543 .30665 L .031 0 1 r
F
P
p
.57864 .30443 m .58948 .30222 L .59543 .30665 L .723 0 1 r
F
P
p
.56175 .3022 m .57864 .30443 L .56787 .30663 L 1 0 .498 r
F
P
p
.551 .30441 m .56175 .3022 L .56787 .30663 L 1 0 .498 r
F
P
p
.53402 .30218 m .551 .30441 L .5403 .30661 L 1 0 .205 r
F
P
p
.52335 .30439 m .53402 .30218 L .5403 .30661 L 1 0 .136 r
F
P
p
.50629 .30215 m .52335 .30439 L .51274 .30659 L 1 0 .136 r
F
P
p
.4957 .30437 m .50629 .30215 L .51274 .30659 L 1 0 .136 r
F
P
p
.47856 .30213 m .4957 .30437 L .48517 .30656 L 1 0 .136 r
F
P
p
.46805 .30434 m .47856 .30213 L .48517 .30656 L 1 0 .136 r
F
P
p
.45082 .30211 m .46805 .30434 L .4576 .30654 L 1 0 .136 r
F
P
p
.44039 .30432 m .45082 .30211 L .4576 .30654 L 1 0 .136 r
F
P
p
.42308 .30208 m .44039 .30432 L .43003 .30652 L 1 0 .239 r
F
P
p
.41274 .3043 m .42308 .30208 L .43003 .30652 L 1 0 .17 r
F
P
p
.39534 .30206 m .41274 .3043 L .40245 .3065 L 1 0 .205 r
F
P
p
.38508 .30427 m .39534 .30206 L .40245 .3065 L 1 0 .17 r
F
P
p
.3676 .30204 m .38508 .30427 L .37488 .30647 L 1 0 .136 r
F
P
p
.35742 .30425 m .3676 .30204 L .37488 .30647 L 1 0 .136 r
F
P
p
.33986 .30202 m .35742 .30425 L .3473 .30645 L 1 0 .136 r
F
P
p
.32976 .30423 m .33986 .30202 L .3473 .30645 L 1 0 .136 r
F
P
p
.002 w
.86972 .51925 m .85807 .5208 L .85409 .52642 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.84244 .52796 m .85409 .52642 L .85807 .5208 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.31211 .30199 m .32976 .30423 L .31973 .30643 L 1 0 .17 r
F
P
p
.3021 .30421 m .31211 .30199 L .31973 .30643 L 1 0 .136 r
F
P
p
.28437 .30197 m .3021 .30421 L .29215 .30641 L 1 0 .136 r
F
P
p
.27444 .30418 m .28437 .30197 L .29215 .30641 L 1 0 .136 r
F
P
p
.25662 .30195 m .27444 .30418 L .26456 .30638 L 1 0 .136 r
F
P
p
.24677 .30416 m .25662 .30195 L .26456 .30638 L 1 0 .136 r
F
P
p
.22887 .30193 m .24677 .30416 L .23698 .30636 L 1 0 .136 r
F
P
p
.2191 .30414 m .22887 .30193 L .23698 .30636 L 1 0 .136 r
F
P
p
.002 w
.64908 .90834 m .66044 .90793 L .66264 .70714 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.84244 .52796 m .83086 .52949 L .82633 .5264 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.81517 .53845 m .82633 .5264 L .83086 .52949 L p
1 .314 0 r
F P
0 0 0 r
s
P
p
.002 w
.59904 .88068 m .58818 .88116 L .58237 .91074 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.57148 .91113 m .58237 .91074 L .58818 .88116 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.90871 .50896 m .92057 .50736 L .92453 .51057 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90871 .50896 m .89693 .51055 L .89279 .50734 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88144 .51768 m .89279 .50734 L .89693 .51055 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.75811 .70106 m .74662 .70209 L .73771 .55999 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73771 .55999 m .7376 .55824 L p
.73784 .55995 L .227 1 0 r
F P
0 0 0 r
s
P
p
.73784 .55995 m .75811 .70106 L .73771 .55999 L .227 1 0 r
F
P
p
.73768 .55822 m .75811 .70106 L .7376 .55824 L .227 1 0 r
F
P
p
.002 w
.73753 .55715 m .74884 .5557 L .75811 .70106 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77229 .6304 m .76311 .70313 L .75811 .70106 L p
0 1 .591 r
F P
0 0 0 r
s
P
p
.002 w
.75811 .70106 m .76967 .70003 L .77229 .6304 L p
0 1 .591 r
F P
0 0 0 r
s
P
p
.002 w
.76967 .70003 m .75811 .70106 L .75426 .64069 L p
.24 1 0 r
F P
0 0 0 r
s
P
p
.75779 .61979 m .76967 .70003 L .75426 .64069 L .24 1 0 r
F
P
p
.7497 .56168 m .76967 .70003 L .74924 .56205 L .24 1 0 r
F
P
p
.002 w
.76011 .55085 m .76967 .70003 L p
.7497 .56168 L .24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74884 .5557 m .76011 .55085 L p
.7497 .56168 L .24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78315 .6114 m .77229 .6304 L .76967 .70003 L p
0 1 .195 r
F P
0 0 0 r
s
P
p
.002 w
.76967 .70003 m .78081 .68426 L .78315 .6114 L p
0 1 .195 r
F P
0 0 0 r
s
P
p
.002 w
.76011 .55085 m .7708 .52637 L .78081 .68426 L p
.398 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78081 .68426 m .76967 .70003 L .76011 .55085 L p
.398 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76011 .55085 m .76014 .55314 L p
.76172 .54918 L 0 1 .435 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .52637 m .76011 .55085 L p
.76172 .54918 L 0 1 .435 r
F P
0 0 0 r
s
P
p
.002 w
.76474 .86539 m .77277 .73934 L .77094 .54191 L p
0 1 .435 r
F P
0 0 0 r
s
P
p
.002 w
.77094 .54191 m .7708 .52637 L p
.77047 .54469 L 0 1 .435 r
F P
0 0 0 r
s
P
p
.76474 .86539 m .77094 .54191 L .77047 .54469 L 0 1 .435 r
F
P
p
.002 w
.75426 .64069 m .74924 .56205 L p
.75779 .61979 L .24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74924 .56205 m .74884 .5557 L p
.7497 .56168 L .24 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76311 .70313 m .75167 .70415 L .74662 .70209 L p
0 1 .864 r
F P
0 0 0 r
s
P
p
.002 w
.74662 .70209 m .75811 .70106 L .76311 .70313 L p
0 1 .864 r
F P
0 0 0 r
s
P
p
.002 w
.76014 .55314 m .76474 .86539 L p
.77047 .54469 L 0 1 .435 r
F P
0 0 0 r
s
P
p
.77047 .54469 m .7708 .52637 L .76014 .55314 L 0 1 .435 r
F
P
p
.002 w
.75298 .8726 m .76474 .86539 L .76014 .55314 L p
0 .99 1 r
F P
0 0 0 r
s
P
p
.002 w
.76014 .55314 m .76011 .55085 L p
.76006 .55317 L 0 .99 1 r
F P
0 0 0 r
s
P
p
.75298 .8726 m .76014 .55314 L .76006 .55317 L 0 .99 1 r
F
P
p
.002 w
.73594 .73029 m .74662 .70209 L .75167 .70415 L p
0 1 .966 r
F P
0 0 0 r
s
P
p
.002 w
.74884 .5557 m .75298 .8726 L p
.76006 .55317 L 0 .99 1 r
F P
0 0 0 r
s
P
p
.002 w
.76011 .55085 m .74884 .5557 L p
.76006 .55317 L 0 .99 1 r
F P
0 0 0 r
s
P
p
.002 w
.7376 .55824 m .73753 .55715 L p
.73768 .55822 L .227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74884 .5557 m .73753 .55715 L .7411 .87313 L p
0 .953 1 r
F P
0 0 0 r
s
P
p
.002 w
.72928 .87365 m .7411 .87313 L .73753 .55715 L p
0 .953 1 r
F P
0 0 0 r
s
P
p
.87842 .30023 m .89439 .30247 L .88265 .30468 L 1 0 0 r
F
P
p
.86668 .30245 m .87842 .30023 L .88265 .30468 L 1 0 0 r
F
P
p
.85063 .3002 m .86668 .30245 L .85502 .30466 L 1 .205 0 r
F
P
p
.83897 .30243 m .85063 .3002 L .85502 .30466 L 1 .37 0 r
F
P
p
.82283 .30018 m .83897 .30243 L .82739 .30464 L 1 .682 0 r
F
P
p
.81126 .3024 m .82283 .30018 L .82739 .30464 L 1 .886 0 r
F
P
p
.79503 .30016 m .81126 .3024 L .79976 .30461 L 1 .818 0 r
F
P
p
.78354 .30238 m .79503 .30016 L .79976 .30461 L 1 .852 0 r
F
P
p
.76723 .30013 m .78354 .30238 L .77212 .30459 L 1 .682 0 r
F
P
p
.75582 .30236 m .76723 .30013 L .77212 .30459 L .977 1 0 r
F
P
p
.73943 .30011 m .75582 .30236 L .74449 .30457 L 0 .514 1 r
F
P
p
.72811 .30234 m .73943 .30011 L .74449 .30457 L 0 .247 1 r
F
P
p
.71162 .30009 m .72811 .30234 L .71685 .30455 L 0 .174 1 r
F
P
p
.70038 .30231 m .71162 .30009 L .71685 .30455 L .192 0 1 r
F
P
p
.68382 .30007 m .70038 .30231 L .68921 .30452 L 0 .744 1 r
F
P
p
.67266 .30229 m .68382 .30007 L .68921 .30452 L 0 .241 1 r
F
P
p
.65601 .30004 m .67266 .30229 L .66157 .3045 L 0 .267 1 r
F
P
p
.64494 .30227 m .65601 .30004 L .66157 .3045 L .905 0 1 r
F
P
p
.6282 .30002 m .64494 .30227 L .63393 .30448 L 0 .769 1 r
F
P
p
.61721 .30224 m .6282 .30002 L .63393 .30448 L 0 .476 1 r
F
P
p
.60039 .3 m .61721 .30224 L .60629 .30446 L 0 .465 1 r
F
P
p
.58948 .30222 m .60039 .3 L .60629 .30446 L .031 0 1 r
F
P
p
.57258 .29997 m .58948 .30222 L .57864 .30443 L 1 0 .498 r
F
P
p
.56175 .3022 m .57258 .29997 L .57864 .30443 L 1 0 .498 r
F
P
p
.54476 .29995 m .56175 .3022 L .551 .30441 L 1 0 .273 r
F
P
p
.53402 .30218 m .54476 .29995 L .551 .30441 L 1 0 .205 r
F
P
p
.51695 .29993 m .53402 .30218 L .52335 .30439 L 1 0 .136 r
F
P
p
.50629 .30215 m .51695 .29993 L .52335 .30439 L 1 0 .136 r
F
P
p
.48913 .29991 m .50629 .30215 L .4957 .30437 L 1 0 .136 r
F
P
p
.47856 .30213 m .48913 .29991 L .4957 .30437 L 1 0 .136 r
F
P
p
.46131 .29988 m .47856 .30213 L .46805 .30434 L 1 0 .136 r
F
P
p
.45082 .30211 m .46131 .29988 L .46805 .30434 L 1 0 .136 r
F
P
p
.43349 .29986 m .45082 .30211 L .44039 .30432 L 1 0 .273 r
F
P
p
.42308 .30208 m .43349 .29986 L .44039 .30432 L 1 0 .239 r
F
P
p
.40567 .29984 m .42308 .30208 L .41274 .3043 L 1 0 .239 r
F
P
p
.39534 .30206 m .40567 .29984 L .41274 .3043 L 1 0 .205 r
F
P
p
.37784 .29981 m .39534 .30206 L .38508 .30427 L 1 0 .17 r
F
P
p
.3676 .30204 m .37784 .29981 L .38508 .30427 L 1 0 .136 r
F
P
p
.35001 .29979 m .3676 .30204 L .35742 .30425 L 1 0 .136 r
F
P
p
.33986 .30202 m .35001 .29979 L .35742 .30425 L 1 0 .136 r
F
P
p
.002 w
.88144 .51768 m .86972 .51925 L .86581 .52487 L p
1 .199 0 r
F P
0 0 0 r
s
P
p
.002 w
.85409 .52642 m .86581 .52487 L .86972 .51925 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.32219 .29977 m .33986 .30202 L .32976 .30423 L 1 0 .205 r
F
P
p
.31211 .30199 m .32219 .29977 L .32976 .30423 L 1 0 .17 r
F
P
p
.29436 .29974 m .31211 .30199 L .3021 .30421 L 1 0 .136 r
F
P
p
.28437 .30197 m .29436 .29974 L .3021 .30421 L 1 0 .136 r
F
P
p
.26652 .29972 m .28437 .30197 L .27444 .30418 L 1 0 .136 r
F
P
p
.25662 .30195 m .26652 .29972 L .27444 .30418 L 1 0 .136 r
F
P
p
.23869 .2997 m .25662 .30195 L .24677 .30416 L 1 0 .136 r
F
P
p
.22887 .30193 m .23869 .2997 L .24677 .30416 L 1 0 .136 r
F
P
p
.21086 .29968 m .22887 .30193 L .2191 .30414 L 1 0 .136 r
F
P
p
.002 w
.85409 .52642 m .84244 .52796 L .83797 .52485 L p
1 .267 0 r
F P
0 0 0 r
s
P
p
.002 w
.83797 .52485 m .84244 .52796 L p
.82712 .52648 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.83797 .52485 m .84962 .52193 L .85409 .52642 L p
1 .267 0 r
F P
0 0 0 r
s
P
p
.002 w
.83797 .52485 m .83453 .54832 L p
.84889 .52321 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.84962 .52193 m .83797 .52485 L p
.84889 .52321 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.82633 .5264 m .83797 .52485 L p
.82712 .52648 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.81517 .53845 m .80411 .55235 L .80147 .60616 L p
1 .88 0 r
F P
0 0 0 r
s
P
p
.002 w
.79464 .6101 m .78315 .6114 L .78081 .68426 L p
.146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78227 .52482 m .79381 .52326 L .79841 .57302 L p
1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.80411 .55235 m .79464 .6101 L .79124 .62259 L p
.649 1 0 r
F P
0 0 0 r
s
P
p
.79206 .61689 m .80411 .55235 L .79124 .62259 L .649 1 0 r
F
P
p
.002 w
.79124 .62259 m .79047 .62539 L p
.79206 .61689 L .649 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79047 .62539 m .79464 .6101 L p
.78433 .66537 L .146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78081 .68426 m .79047 .62539 L p
.78433 .66537 L .146 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79047 .62539 m .78227 .52482 L p
.7966 .58552 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.79733 .58865 m .80147 .60616 L .80411 .55235 L p
.649 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.80147 .60616 m .79047 .62539 L p
.7966 .58552 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.79841 .57302 m .80147 .60616 L p
.7966 .58552 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.78227 .52482 m .79841 .57302 L .7966 .58552 L 1 .955 0 r
F
P
p
.002 w
.58237 .91074 m .59332 .91035 L .59904 .88068 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.92057 .50736 m .90871 .50896 L .90463 .50573 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.89279 .50734 m .90463 .50573 L .90871 .50896 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7411 .87313 m .75298 .8726 L .74884 .5557 L p
0 .953 1 r
F P
0 0 0 r
s
P
p
.87842 .30023 m .89023 .29799 L .89439 .30247 L 1 0 0 r
F
P
p
.86235 .29797 m .87842 .30023 L .86668 .30245 L 1 .131 0 r
F
P
p
.85063 .3002 m .86235 .29797 L .86668 .30245 L 1 .205 0 r
F
P
p
.83447 .29794 m .85063 .3002 L .83897 .30243 L 1 .614 0 r
F
P
p
.82283 .30018 m .83447 .29794 L .83897 .30243 L 1 .682 0 r
F
P
p
.80659 .29792 m .82283 .30018 L .81126 .3024 L 1 .667 0 r
F
P
p
.79503 .30016 m .80659 .29792 L .81126 .3024 L 1 .818 0 r
F
P
p
.7787 .2979 m .79503 .30016 L .78354 .30238 L 1 .545 0 r
F
P
p
.76723 .30013 m .7787 .2979 L .78354 .30238 L 1 .682 0 r
F
P
p
.75082 .29787 m .76723 .30013 L .75582 .30236 L 0 1 .692 r
F
P
p
.73943 .30011 m .75082 .29787 L .75582 .30236 L 0 .514 1 r
F
P
p
.72293 .29785 m .73943 .30011 L .72811 .30234 L 0 .604 1 r
F
P
p
.71162 .30009 m .72293 .29785 L .72811 .30234 L 0 .174 1 r
F
P
p
.69504 .29783 m .71162 .30009 L .70038 .30231 L 0 1 .398 r
F
P
p
.68382 .30007 m .69504 .29783 L .70038 .30231 L 0 .744 1 r
F
P
p
.66715 .2978 m .68382 .30007 L .67266 .30229 L 0 1 .78 r
F
P
p
.65601 .30004 m .66715 .2978 L .67266 .30229 L 0 .267 1 r
F
P
p
.63926 .29778 m .65601 .30004 L .64494 .30227 L 0 1 .956 r
F
P
p
.6282 .30002 m .63926 .29778 L .64494 .30227 L 0 .769 1 r
F
P
p
.61136 .29776 m .6282 .30002 L .61721 .30224 L 0 .892 1 r
F
P
p
.60039 .3 m .61136 .29776 L .61721 .30224 L 0 .465 1 r
F
P
p
.002 w
.82633 .5264 m .81517 .53845 L .8118 .56906 L p
1 .655 0 r
F P
0 0 0 r
s
P
p
.002 w
.8118 .56906 m .81517 .53845 L p
.80579 .58482 L 1 .88 0 r
F P
0 0 0 r
s
P
p
.002 w
.8118 .56906 m .8235 .56763 L .82633 .5264 L p
1 .655 0 r
F P
0 0 0 r
s
P
p
.002 w
.8118 .56906 m .80542 .52169 L p
.81784 .55324 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.8235 .56763 m .8118 .56906 L p
.81784 .55324 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.80147 .60616 m .8118 .56906 L p
.80579 .58482 L 1 .88 0 r
F P
0 0 0 r
s
P
p
.58347 .29774 m .60039 .3 L .58948 .30222 L 1 0 .637 r
F
P
p
.57258 .29997 m .58347 .29774 L .58948 .30222 L 1 0 .498 r
F
P
p
.55557 .29771 m .57258 .29997 L .56175 .3022 L 1 0 .273 r
F
P
p
.54476 .29995 m .55557 .29771 L .56175 .3022 L 1 0 .273 r
F
P
p
.52767 .29769 m .54476 .29995 L .53402 .30218 L 1 0 .136 r
F
P
p
.51695 .29993 m .52767 .29769 L .53402 .30218 L 1 0 .136 r
F
P
p
.49977 .29767 m .51695 .29993 L .50629 .30215 L 1 0 .136 r
F
P
p
.48913 .29991 m .49977 .29767 L .50629 .30215 L 1 0 .136 r
F
P
p
.47186 .29764 m .48913 .29991 L .47856 .30213 L 1 0 .136 r
F
P
p
.46131 .29988 m .47186 .29764 L .47856 .30213 L 1 0 .136 r
F
P
p
.44396 .29762 m .46131 .29988 L .45082 .30211 L 1 0 .409 r
F
P
p
.43349 .29986 m .44396 .29762 L .45082 .30211 L 1 0 .273 r
F
P
p
.41605 .2976 m .43349 .29986 L .42308 .30208 L 1 0 .307 r
F
P
p
.40567 .29984 m .41605 .2976 L .42308 .30208 L 1 0 .239 r
F
P
p
.38814 .29757 m .40567 .29984 L .39534 .30206 L 1 0 .239 r
F
P
p
.37784 .29981 m .38814 .29757 L .39534 .30206 L 1 0 .17 r
F
P
p
.36023 .29755 m .37784 .29981 L .3676 .30204 L 1 0 .17 r
F
P
p
.35001 .29979 m .36023 .29755 L .3676 .30204 L 1 0 .136 r
F
P
p
.002 w
.89279 .50734 m .88144 .51768 L .87754 .52195 L p
1 .16 0 r
F P
0 0 0 r
s
P
p
.002 w
.87754 .52195 m .88144 .51768 L p
.86823 .52376 L 1 .199 0 r
F P
0 0 0 r
s
P
p
.002 w
.87754 .52195 m .8894 .52038 L .89279 .50734 L p
1 .16 0 r
F P
0 0 0 r
s
P
p
.002 w
.87754 .52195 m .87324 .51877 L p
.88692 .52013 L 1 .252 0 r
F P
0 0 0 r
s
P
p
.002 w
.8894 .52038 m .87754 .52195 L p
.88692 .52013 L 1 .252 0 r
F P
0 0 0 r
s
P
p
.002 w
.86581 .52487 m .87754 .52195 L p
.86823 .52376 L 1 .199 0 r
F P
0 0 0 r
s
P
p
.33232 .29753 m .35001 .29979 L .33986 .30202 L 1 0 .205 r
F
P
p
.32219 .29977 m .33232 .29753 L .33986 .30202 L 1 0 .205 r
F
P
p
.30441 .29751 m .32219 .29977 L .31211 .30199 L 1 0 .17 r
F
P
p
.29436 .29974 m .30441 .29751 L .31211 .30199 L 1 0 .136 r
F
P
p
.27649 .29748 m .29436 .29974 L .28437 .30197 L 1 0 .136 r
F
P
p
.26652 .29972 m .27649 .29748 L .28437 .30197 L 1 0 .136 r
F
P
p
.24857 .29746 m .26652 .29972 L .25662 .30195 L 1 0 .136 r
F
P
p
.23869 .2997 m .24857 .29746 L .25662 .30195 L 1 0 .136 r
F
P
p
.22066 .29744 m .23869 .2997 L .22887 .30193 L 1 0 .136 r
F
P
p
.21086 .29968 m .22066 .29744 L .22887 .30193 L 1 0 .136 r
F
P
p
.002 w
.59332 .91035 m .60434 .90995 L .6099 .87383 L p
1 0 .385 r
F P
0 0 0 r
s
P
p
.002 w
.86581 .52487 m .85409 .52642 L .84962 .52193 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.83797 .52485 m .82633 .5264 L .8235 .56763 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.79047 .62539 m .78081 .68426 L .7708 .52637 L p
.76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7708 .52637 m .78227 .52482 L .79047 .62539 L p
.76 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78227 .52482 m .7708 .52637 L .77277 .73934 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61542 .90955 m .62657 .90915 L .63138 .83057 L p
1 0 .605 r
F P
0 0 0 r
s
P
p
.002 w
.90463 .50573 m .91655 .50411 L .92057 .50736 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.90463 .50573 m .89279 .50734 L .8894 .52038 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.87415 .29572 m .89023 .29799 L .87842 .30023 L 1 .126 0 r
F
P
p
.86235 .29797 m .87415 .29572 L .87842 .30023 L 1 .131 0 r
F
P
p
.84618 .29569 m .86235 .29797 L .85063 .3002 L 1 .409 0 r
F
P
p
.83447 .29794 m .84618 .29569 L .85063 .3002 L 1 .614 0 r
F
P
p
.81821 .29567 m .83447 .29794 L .82283 .30018 L 1 .497 0 r
F
P
p
.80659 .29792 m .81821 .29567 L .82283 .30018 L 1 .667 0 r
F
P
p
.002 w
.60434 .90995 m .61542 .90955 L .62076 .86272 L p
1 0 .448 r
F P
0 0 0 r
s
P
p
.79025 .29565 m .80659 .29792 L .79503 .30016 L 1 .409 0 r
F
P
p
.7787 .2979 m .79025 .29565 L .79503 .30016 L 1 .545 0 r
F
P
p
.76228 .29562 m .7787 .2979 L .76723 .30013 L .174 1 0 r
F
P
p
.75082 .29787 m .76228 .29562 L .76723 .30013 L 0 1 .692 r
F
P
p
.7343 .2956 m .75082 .29787 L .73943 .30011 L 0 .983 1 r
F
P
p
.72293 .29785 m .7343 .2956 L .73943 .30011 L 0 .604 1 r
F
P
p
.70633 .29558 m .72293 .29785 L .71162 .30009 L .293 1 0 r
F
P
p
.69504 .29783 m .70633 .29558 L .71162 .30009 L 0 1 .398 r
F
P
p
.67836 .29555 m .69504 .29783 L .68382 .30007 L 0 1 .347 r
F
P
p
.66715 .2978 m .67836 .29555 L .68382 .30007 L 0 1 .78 r
F
P
p
.65038 .29553 m .66715 .2978 L .65601 .30004 L 0 1 .374 r
F
P
p
.63926 .29778 m .65038 .29553 L .65601 .30004 L 0 1 .956 r
F
P
p
.6224 .29551 m .63926 .29778 L .6282 .30002 L 0 1 .688 r
F
P
p
.61136 .29776 m .6224 .29551 L .6282 .30002 L 0 .892 1 r
F
P
p
.59442 .29548 m .61136 .29776 L .60039 .3 L 1 0 .871 r
F
P
p
.58347 .29774 m .59442 .29548 L .60039 .3 L 1 0 .637 r
F
P
p
.56644 .29546 m .58347 .29774 L .57258 .29997 L 1 0 .273 r
F
P
p
.55557 .29771 m .56644 .29546 L .57258 .29997 L 1 0 .273 r
F
P
p
.53845 .29544 m .55557 .29771 L .54476 .29995 L 1 0 .136 r
F
P
p
.52767 .29769 m .53845 .29544 L .54476 .29995 L 1 0 .136 r
F
P
p
.51047 .29541 m .52767 .29769 L .51695 .29993 L 1 0 .136 r
F
P
p
.49977 .29767 m .51047 .29541 L .51695 .29993 L 1 0 .136 r
F
P
p
.48248 .29539 m .49977 .29767 L .48913 .29991 L 1 0 .205 r
F
P
p
.47186 .29764 m .48248 .29539 L .48913 .29991 L 1 0 .136 r
F
P
p
.45449 .29537 m .47186 .29764 L .46131 .29988 L 1 0 .58 r
F
P
p
.44396 .29762 m .45449 .29537 L .46131 .29988 L 1 0 .409 r
F
P
p
.4265 .29534 m .44396 .29762 L .43349 .29986 L 1 0 .375 r
F
P
p
.41605 .2976 m .4265 .29534 L .43349 .29986 L 1 0 .307 r
F
P
p
.39851 .29532 m .41605 .2976 L .40567 .29984 L 1 0 .273 r
F
P
p
.38814 .29757 m .39851 .29532 L .40567 .29984 L 1 0 .239 r
F
P
p
.37051 .2953 m .38814 .29757 L .37784 .29981 L 1 0 .205 r
F
P
p
.36023 .29755 m .37051 .2953 L .37784 .29981 L 1 0 .17 r
F
P
p
.34252 .29528 m .36023 .29755 L .35001 .29979 L 1 0 .205 r
F
P
p
.33232 .29753 m .34252 .29528 L .35001 .29979 L 1 0 .205 r
F
P
p
.31452 .29525 m .33232 .29753 L .32219 .29977 L 1 0 .205 r
F
P
p
.30441 .29751 m .31452 .29525 L .32219 .29977 L 1 0 .17 r
F
P
p
.28652 .29523 m .30441 .29751 L .29436 .29974 L 1 0 .136 r
F
P
p
.27649 .29748 m .28652 .29523 L .29436 .29974 L 1 0 .136 r
F
P
p
.25852 .29521 m .27649 .29748 L .26652 .29972 L 1 0 .136 r
F
P
p
.24857 .29746 m .25852 .29521 L .26652 .29972 L 1 0 .136 r
F
P
p
.23051 .29518 m .24857 .29746 L .23869 .2997 L 1 0 .136 r
F
P
p
.22066 .29744 m .23051 .29518 L .23869 .2997 L 1 0 .136 r
F
P
p
.20251 .29516 m .22066 .29744 L .21086 .29968 L 1 0 .136 r
F
P
p
.002 w
.87754 .52195 m .86581 .52487 L .86139 .52036 L p
1 .257 0 r
F P
0 0 0 r
s
P
p
.002 w
.84962 .52193 m .86139 .52036 L .86581 .52487 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.8235 .56763 m .83453 .54832 L .83797 .52485 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.79381 .52326 m .78227 .52482 L .78441 .7309 L p
.295 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77277 .73934 m .78441 .7309 L .78227 .52482 L p
.132 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.91655 .50411 m .90463 .50573 L .90096 .5113 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.90096 .5113 m .90463 .50573 L p
.8964 .51364 L 1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.90096 .5113 m .89678 .50804 L p
.90555 .50893 L 1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.90096 .5113 m .91295 .50968 L .91655 .50411 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.91295 .50968 m .90096 .5113 L p
.90555 .50893 L 1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.8894 .52038 m .90096 .5113 L p
.8964 .51364 L 1 .097 0 r
F P
0 0 0 r
s
P
p
.87415 .29572 m .88601 .29345 L .89023 .29799 L 1 .126 0 r
F
P
p
.85796 .29343 m .87415 .29572 L .86235 .29797 L 1 .262 0 r
F
P
p
.84618 .29569 m .85796 .29343 L .86235 .29797 L 1 .409 0 r
F
P
p
.82991 .2934 m .84618 .29569 L .83447 .29794 L 1 .438 0 r
F
P
p
.81821 .29567 m .82991 .2934 L .83447 .29794 L 1 .497 0 r
F
P
p
.80186 .29338 m .81821 .29567 L .80659 .29792 L 1 .36 0 r
F
P
p
.79025 .29565 m .80186 .29338 L .80659 .29792 L 1 .409 0 r
F
P
p
.7738 .29336 m .79025 .29565 L .7787 .2979 L .841 1 0 r
F
P
p
.76228 .29562 m .7738 .29336 L .7787 .2979 L .174 1 0 r
F
P
p
.74575 .29333 m .76228 .29562 L .75082 .29787 L 0 1 .556 r
F
P
p
.7343 .2956 m .74575 .29333 L .75082 .29787 L 0 .983 1 r
F
P
p
.71769 .29331 m .7343 .2956 L .72293 .29785 L .668 1 0 r
F
P
p
.70633 .29558 m .71769 .29331 L .72293 .29785 L .293 1 0 r
F
P
p
.68963 .29329 m .70633 .29558 L .69504 .29783 L .269 1 0 r
F
P
p
.67836 .29555 m .68963 .29329 L .69504 .29783 L 0 1 .347 r
F
P
p
.66157 .29326 m .67836 .29555 L .66715 .2978 L .209 1 0 r
F
P
p
.65038 .29553 m .66157 .29326 L .66715 .2978 L 0 1 .374 r
F
P
p
.63351 .29324 m .65038 .29553 L .63926 .29778 L 0 1 .394 r
F
P
p
.6224 .29551 m .63351 .29324 L .63926 .29778 L 0 1 .688 r
F
P
p
.60544 .29322 m .6224 .29551 L .61136 .29776 L .996 0 1 r
F
P
p
.59442 .29548 m .60544 .29322 L .61136 .29776 L 1 0 .871 r
F
P
p
.57737 .2932 m .59442 .29548 L .58347 .29774 L 1 0 .286 r
F
P
p
.56644 .29546 m .57737 .2932 L .58347 .29774 L 1 0 .273 r
F
P
p
.5493 .29317 m .56644 .29546 L .55557 .29771 L 1 0 .205 r
F
P
p
.53845 .29544 m .5493 .29317 L .55557 .29771 L 1 0 .136 r
F
P
p
.52123 .29315 m .53845 .29544 L .52767 .29769 L 1 0 .375 r
F
P
p
.51047 .29541 m .52123 .29315 L .52767 .29769 L 1 0 .136 r
F
P
p
.49316 .29313 m .51047 .29541 L .49977 .29767 L 1 0 .409 r
F
P
p
.48248 .29539 m .49316 .29313 L .49977 .29767 L 1 0 .205 r
F
P
p
.46509 .2931 m .48248 .29539 L .47186 .29764 L 1 0 .614 r
F
P
p
.45449 .29537 m .46509 .2931 L .47186 .29764 L 1 0 .58 r
F
P
p
.43701 .29308 m .45449 .29537 L .44396 .29762 L 1 0 .682 r
F
P
p
.4265 .29534 m .43701 .29308 L .44396 .29762 L 1 0 .375 r
F
P
p
.40893 .29306 m .4265 .29534 L .41605 .2976 L 1 0 .273 r
F
P
p
.39851 .29532 m .40893 .29306 L .41605 .2976 L 1 0 .273 r
F
P
p
.38086 .29303 m .39851 .29532 L .38814 .29757 L 1 0 .239 r
F
P
p
.37051 .2953 m .38086 .29303 L .38814 .29757 L 1 0 .205 r
F
P
p
.35277 .29301 m .37051 .2953 L .36023 .29755 L 1 0 .239 r
F
P
p
.34252 .29528 m .35277 .29301 L .36023 .29755 L 1 0 .205 r
F
P
p
.32469 .29299 m .34252 .29528 L .33232 .29753 L 1 0 .205 r
F
P
p
.31452 .29525 m .32469 .29299 L .33232 .29753 L 1 0 .205 r
F
P
p
.29661 .29296 m .31452 .29525 L .30441 .29751 L 1 0 .136 r
F
P
p
.28652 .29523 m .29661 .29296 L .30441 .29751 L 1 0 .136 r
F
P
p
.26852 .29294 m .28652 .29523 L .27649 .29748 L 1 0 .17 r
F
P
p
.25852 .29521 m .26852 .29294 L .27649 .29748 L 1 0 .136 r
F
P
p
.24043 .29292 m .25852 .29521 L .24857 .29746 L 1 0 .136 r
F
P
p
.23051 .29518 m .24043 .29292 L .24857 .29746 L 1 0 .136 r
F
P
p
.21234 .29289 m .23051 .29518 L .22066 .29744 L 1 0 .136 r
F
P
p
.20251 .29516 m .21234 .29289 L .22066 .29744 L 1 0 .136 r
F
P
p
.002 w
.86139 .52036 m .87324 .51877 L .87754 .52195 L p
1 .257 0 r
F P
0 0 0 r
s
P
p
.002 w
.86139 .52036 m .84962 .52193 L .84558 .529 L p
1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.84558 .529 m .84962 .52193 L p
.83912 .54031 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.84558 .529 m .84062 .51554 L p
.85208 .51763 L 1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.85704 .51853 m .84558 .529 L p
.85208 .51763 L 1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.83453 .54832 m .84558 .529 L p
.83912 .54031 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.8118 .56906 m .80147 .60616 L .79381 .52326 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.79381 .52326 m .80542 .52169 L .8118 .56906 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.80542 .52169 m .79381 .52326 L .79505 .69257 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79505 .69257 m .79381 .52326 L p
.78609 .69384 L .295 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79505 .69257 m .80701 .69148 L .80542 .52169 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79505 .69257 m .7901 .69037 L p
.80408 .69129 L 0 1 .42 r
F P
0 0 0 r
s
P
p
.002 w
.80701 .69148 m .79505 .69257 L p
.80408 .69129 L 0 1 .42 r
F P
0 0 0 r
s
P
p
.002 w
.78441 .7309 m .79505 .69257 L p
.78609 .69384 L .295 1 0 r
F P
0 0 0 r
s
P
p
.86982 .29115 m .88601 .29345 L .87415 .29572 L 1 .223 0 r
F
P
p
.85796 .29343 m .86982 .29115 L .87415 .29572 L 1 .262 0 r
F
P
p
.84168 .29113 m .85796 .29343 L .84618 .29569 L 1 .302 0 r
F
P
p
.82991 .2934 m .84168 .29113 L .84618 .29569 L 1 .438 0 r
F
P
p
.81354 .2911 m .82991 .2934 L .81821 .29567 L 1 .292 0 r
F
P
p
.80186 .29338 m .81354 .2911 L .81821 .29567 L 1 .36 0 r
F
P
p
.7854 .29108 m .80186 .29338 L .79025 .29565 L 1 .545 0 r
F
P
p
.7738 .29336 m .7854 .29108 L .79025 .29565 L .841 1 0 r
F
P
p
.75726 .29106 m .7738 .29336 L .76228 .29562 L 0 1 .031 r
F
P
p
.74575 .29333 m .75726 .29106 L .76228 .29562 L 0 1 .556 r
F
P
p
.72912 .29103 m .74575 .29333 L .7343 .2956 L .867 1 0 r
F
P
p
.71769 .29331 m .72912 .29103 L .7343 .2956 L .668 1 0 r
F
P
p
.70097 .29101 m .71769 .29331 L .70633 .29558 L .825 1 0 r
F
P
p
.68963 .29329 m .70097 .29101 L .70633 .29558 L .269 1 0 r
F
P
p
.67283 .29099 m .68963 .29329 L .67836 .29555 L .571 1 0 r
F
P
p
.66157 .29326 m .67283 .29099 L .67836 .29555 L .209 1 0 r
F
P
p
.64468 .29096 m .66157 .29326 L .65038 .29553 L .214 1 0 r
F
P
p
.63351 .29324 m .64468 .29096 L .65038 .29553 L 0 1 .394 r
F
P
p
.61653 .29094 m .63351 .29324 L .6224 .29551 L .87 0 1 r
F
P
p
.60544 .29322 m .61653 .29094 L .6224 .29551 L .996 0 1 r
F
P
p
.58838 .29092 m .60544 .29322 L .59442 .29548 L 1 0 .33 r
F
P
p
.57737 .2932 m .58838 .29092 L .59442 .29548 L 1 0 .286 r
F
P
p
.56022 .29089 m .57737 .2932 L .56644 .29546 L 1 0 .273 r
F
P
p
.5493 .29317 m .56022 .29089 L .56644 .29546 L 1 0 .205 r
F
P
p
.53207 .29087 m .5493 .29317 L .53845 .29544 L 1 0 .614 r
F
P
p
.52123 .29315 m .53207 .29087 L .53845 .29544 L 1 0 .375 r
F
P
p
.50391 .29085 m .52123 .29315 L .51047 .29541 L 1 0 .58 r
F
P
p
.49316 .29313 m .50391 .29085 L .51047 .29541 L 1 0 .409 r
F
P
p
.47575 .29082 m .49316 .29313 L .48248 .29539 L 1 0 .682 r
F
P
p
.46509 .2931 m .47575 .29082 L .48248 .29539 L 1 0 .614 r
F
P
p
.44759 .2908 m .46509 .2931 L .45449 .29537 L .977 0 1 r
F
P
p
.43701 .29308 m .44759 .2908 L .45449 .29537 L 1 0 .682 r
F
P
p
.41943 .29077 m .43701 .29308 L .4265 .29534 L 1 0 .307 r
F
P
p
.40893 .29306 m .41943 .29077 L .4265 .29534 L 1 0 .273 r
F
P
p
.39126 .29075 m .40893 .29306 L .39851 .29532 L 1 0 .273 r
F
P
p
.38086 .29303 m .39126 .29075 L .39851 .29532 L 1 0 .239 r
F
P
p
.3631 .29073 m .38086 .29303 L .37051 .2953 L 1 0 .273 r
F
P
p
.35277 .29301 m .3631 .29073 L .37051 .2953 L 1 0 .239 r
F
P
p
.33493 .2907 m .35277 .29301 L .34252 .29528 L 1 0 .239 r
F
P
p
.32469 .29299 m .33493 .2907 L .34252 .29528 L 1 0 .205 r
F
P
p
.30676 .29068 m .32469 .29299 L .31452 .29525 L 1 0 .136 r
F
P
p
.29661 .29296 m .30676 .29068 L .31452 .29525 L 1 0 .136 r
F
P
p
.27859 .29066 m .29661 .29296 L .28652 .29523 L 1 0 .375 r
F
P
p
.26852 .29294 m .27859 .29066 L .28652 .29523 L 1 0 .17 r
F
P
p
.25041 .29063 m .26852 .29294 L .25852 .29521 L 1 0 .136 r
F
P
p
.24043 .29292 m .25041 .29063 L .25852 .29521 L 1 0 .136 r
F
P
p
.22224 .29061 m .24043 .29292 L .23051 .29518 L 1 0 .136 r
F
P
p
.21234 .29289 m .22224 .29061 L .23051 .29518 L 1 0 .136 r
F
P
p
.19406 .29059 m .21234 .29289 L .20251 .29516 L 1 0 .136 r
F
P
p
.002 w
.90096 .5113 m .8894 .52038 L .88516 .51718 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.002 w
.87324 .51877 m .88516 .51718 L .8894 .52038 L p
1 .252 0 r
F P
0 0 0 r
s
P
p
.002 w
.87324 .51877 m .86139 .52036 L .85704 .51853 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.84558 .529 m .85704 .51853 L .86139 .52036 L p
1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.80542 .52169 m .8171 .52011 L .8235 .56763 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.8171 .52011 m .80542 .52169 L .80701 .69148 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.86982 .29115 m .88174 .28886 L .88601 .29345 L 1 .223 0 r
F
P
p
.85352 .28883 m .86982 .29115 L .85796 .29343 L 1 .165 0 r
F
P
p
.84168 .29113 m .85352 .28883 L .85796 .29343 L 1 .302 0 r
F
P
p
.8253 .28881 m .84168 .29113 L .82991 .2934 L 1 .233 0 r
F
P
p
.81354 .2911 m .8253 .28881 L .82991 .2934 L 1 .292 0 r
F
P
p
.79707 .28879 m .81354 .2911 L .80186 .29338 L 1 .375 0 r
F
P
p
.7854 .29108 m .79707 .28879 L .80186 .29338 L 1 .545 0 r
F
P
p
.76885 .28876 m .7854 .29108 L .7738 .29336 L .534 1 0 r
F
P
p
.75726 .29106 m .76885 .28876 L .7738 .29336 L 0 1 .031 r
F
P
p
.74062 .28874 m .75726 .29106 L .74575 .29333 L 1 .989 0 r
F
P
p
.72912 .29103 m .74062 .28874 L .74575 .29333 L .867 1 0 r
F
P
p
.71239 .28872 m .72912 .29103 L .71769 .29331 L .909 1 0 r
F
P
p
.70097 .29101 m .71239 .28872 L .71769 .29331 L .825 1 0 r
F
P
p
.68415 .28869 m .70097 .29101 L .68963 .29329 L .888 1 0 r
F
P
p
.67283 .29099 m .68415 .28869 L .68963 .29329 L .571 1 0 r
F
P
p
.65592 .28867 m .67283 .29099 L .66157 .29326 L .99 1 0 r
F
P
p
.64468 .29096 m .65592 .28867 L .66157 .29326 L .214 1 0 r
F
P
p
.62768 .28865 m .64468 .29096 L .63351 .29324 L .471 0 1 r
F
P
p
.61653 .29094 m .62768 .28865 L .63351 .29324 L .87 0 1 r
F
P
p
.59945 .28862 m .61653 .29094 L .60544 .29322 L 1 0 .43 r
F
P
p
.58838 .29092 m .59945 .28862 L .60544 .29322 L 1 0 .33 r
F
P
p
.57121 .2886 m .58838 .29092 L .57737 .2932 L 1 0 .341 r
F
P
p
.56022 .29089 m .57121 .2886 L .57737 .2932 L 1 0 .273 r
F
P
p
.54296 .28858 m .56022 .29089 L .5493 .29317 L 1 0 .682 r
F
P
p
.53207 .29087 m .54296 .28858 L .5493 .29317 L 1 0 .614 r
F
P
p
.51472 .28855 m .53207 .29087 L .52123 .29315 L 1 0 .852 r
F
P
p
.50391 .29085 m .51472 .28855 L .52123 .29315 L 1 0 .58 r
F
P
p
.48648 .28853 m .50391 .29085 L .49316 .29313 L 1 0 .955 r
F
P
p
.47575 .29082 m .48648 .28853 L .49316 .29313 L 1 0 .682 r
F
P
p
.45823 .2885 m .47575 .29082 L .46509 .2931 L .909 0 1 r
F
P
p
.44759 .2908 m .45823 .2885 L .46509 .2931 L .977 0 1 r
F
P
p
.42998 .28848 m .44759 .2908 L .43701 .29308 L 1 0 .511 r
F
P
p
.41943 .29077 m .42998 .28848 L .43701 .29308 L 1 0 .307 r
F
P
p
.40173 .28846 m .41943 .29077 L .40893 .29306 L 1 0 .273 r
F
P
p
.39126 .29075 m .40173 .28846 L .40893 .29306 L 1 0 .273 r
F
P
p
.37348 .28843 m .39126 .29075 L .38086 .29303 L 1 0 .273 r
F
P
p
.3631 .29073 m .37348 .28843 L .38086 .29303 L 1 0 .273 r
F
P
p
.002 w
.88516 .51718 m .89678 .50804 L .90096 .5113 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.34522 .28841 m .3631 .29073 L .35277 .29301 L 1 0 .273 r
F
P
p
.33493 .2907 m .34522 .28841 L .35277 .29301 L 1 0 .239 r
F
P
p
.31697 .28839 m .33493 .2907 L .32469 .29299 L 1 0 .136 r
F
P
p
.30676 .29068 m .31697 .28839 L .32469 .29299 L 1 0 .136 r
F
P
p
.28871 .28836 m .30676 .29068 L .29661 .29296 L 1 0 .545 r
F
P
p
.27859 .29066 m .28871 .28836 L .29661 .29296 L 1 0 .375 r
F
P
p
.26045 .28834 m .27859 .29066 L .26852 .29294 L 1 0 .205 r
F
P
p
.25041 .29063 m .26045 .28834 L .26852 .29294 L 1 0 .136 r
F
P
p
.23219 .28832 m .25041 .29063 L .24043 .29292 L 1 0 .136 r
F
P
p
.22224 .29061 m .23219 .28832 L .24043 .29292 L 1 0 .136 r
F
P
p
.20393 .28829 m .22224 .29061 L .21234 .29289 L 1 0 .136 r
F
P
p
.19406 .29059 m .20393 .28829 L .21234 .29289 L 1 0 .136 r
F
P
p
.002 w
.88516 .51718 m .87324 .51877 L .86895 .51693 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.002 w
.85704 .51853 m .86895 .51693 L .87324 .51877 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.83453 .54832 m .8235 .56763 L .8171 .52011 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.82885 .51852 m .83453 .54832 L p
.81739 .52058 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.84558 .529 m .83453 .54832 L .82885 .51852 L p
1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.82885 .51852 m .84062 .51554 L .84558 .529 L p
1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.82885 .51852 m .82637 .56935 L p
.84038 .51644 L 1 .574 0 r
F P
0 0 0 r
s
P
p
.002 w
.84062 .51554 m .82885 .51852 L p
.84038 .51644 L 1 .574 0 r
F P
0 0 0 r
s
P
p
.002 w
.8171 .52011 m .82885 .51852 L p
.81739 .52058 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.82885 .51852 m .8171 .52011 L .81447 .5708 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.81447 .5708 m .8171 .52011 L p
.81397 .57324 L .875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81447 .5708 m .80968 .56787 L p
.81496 .56834 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.81447 .5708 m .82637 .56935 L .82885 .51852 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.82637 .56935 m .81447 .5708 L p
.81496 .56834 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.80701 .69148 m .81447 .5708 L p
.81397 .57324 L .875 1 0 r
F P
0 0 0 r
s
P
p
.86544 .28653 m .88174 .28886 L .86982 .29115 L 1 .097 0 r
F
P
p
.85352 .28883 m .86544 .28653 L .86982 .29115 L 1 .165 0 r
F
P
p
.83713 .2865 m .85352 .28883 L .84168 .29113 L 1 .163 0 r
F
P
p
.8253 .28881 m .83713 .2865 L .84168 .29113 L 1 .233 0 r
F
P
p
.80882 .28648 m .8253 .28881 L .81354 .2911 L 1 .307 0 r
F
P
p
.79707 .28879 m .80882 .28648 L .81354 .2911 L 1 .375 0 r
F
P
p
.7805 .28646 m .79707 .28879 L .7854 .29108 L 1 .852 0 r
F
P
p
.76885 .28876 m .7805 .28646 L .7854 .29108 L .534 1 0 r
F
P
p
.75219 .28643 m .76885 .28876 L .75726 .29106 L 1 .886 0 r
F
P
p
.74062 .28874 m .75219 .28643 L .75726 .29106 L 1 .989 0 r
F
P
p
.72387 .28641 m .74062 .28874 L .72912 .29103 L 1 .989 0 r
F
P
p
.71239 .28872 m .72387 .28641 L .72912 .29103 L .909 1 0 r
F
P
p
.69555 .28639 m .71239 .28872 L .70097 .29101 L 1 .86 0 r
F
P
p
.68415 .28869 m .69555 .28639 L .70097 .29101 L .888 1 0 r
F
P
p
.66723 .28636 m .68415 .28869 L .67283 .29099 L 1 .587 0 r
F
P
p
.65592 .28867 m .66723 .28636 L .67283 .29099 L .99 1 0 r
F
P
p
.63891 .28634 m .65592 .28867 L .64468 .29096 L 0 .182 1 r
F
P
p
.62768 .28865 m .63891 .28634 L .64468 .29096 L .471 0 1 r
F
P
p
.61058 .28631 m .62768 .28865 L .61653 .29094 L 1 0 .498 r
F
P
p
.59945 .28862 m .61058 .28631 L .61653 .29094 L 1 0 .43 r
F
P
p
.58226 .28629 m .59945 .28862 L .58838 .29092 L 1 0 .511 r
F
P
p
.57121 .2886 m .58226 .28629 L .58838 .29092 L 1 0 .341 r
F
P
p
.55393 .28627 m .57121 .2886 L .56022 .29089 L 1 0 .75 r
F
P
p
.54296 .28858 m .55393 .28627 L .56022 .29089 L 1 0 .682 r
F
P
p
.5256 .28624 m .54296 .28858 L .53207 .29087 L .909 0 1 r
F
P
p
.51472 .28855 m .5256 .28624 L .53207 .29087 L 1 0 .852 r
F
P
p
.49727 .28622 m .51472 .28855 L .50391 .29085 L .807 0 1 r
F
P
p
.48648 .28853 m .49727 .28622 L .50391 .29085 L 1 0 .955 r
F
P
p
.46894 .2862 m .48648 .28853 L .47575 .29082 L .841 0 1 r
F
P
p
.45823 .2885 m .46894 .2862 L .47575 .29082 L .909 0 1 r
F
P
p
.4406 .28617 m .45823 .2885 L .44759 .2908 L 1 0 .852 r
F
P
p
.42998 .28848 m .4406 .28617 L .44759 .2908 L 1 0 .511 r
F
P
p
.41226 .28615 m .42998 .28848 L .41943 .29077 L 1 0 .273 r
F
P
p
.40173 .28846 m .41226 .28615 L .41943 .29077 L 1 0 .273 r
F
P
p
.38393 .28612 m .40173 .28846 L .39126 .29075 L 1 0 .273 r
F
P
p
.37348 .28843 m .38393 .28612 L .39126 .29075 L 1 0 .273 r
F
P
p
.002 w
.89678 .50804 m .90837 .4975 L .91295 .50968 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.35559 .2861 m .37348 .28843 L .3631 .29073 L 1 0 .273 r
F
P
p
.34522 .28841 m .35559 .2861 L .3631 .29073 L 1 0 .273 r
F
P
p
.32724 .28608 m .34522 .28841 L .33493 .2907 L 1 0 .17 r
F
P
p
.31697 .28839 m .32724 .28608 L .33493 .2907 L 1 0 .136 r
F
P
p
.2989 .28605 m .31697 .28839 L .30676 .29068 L 1 0 .682 r
F
P
p
.28871 .28836 m .2989 .28605 L .30676 .29068 L 1 0 .545 r
F
P
p
.27055 .28603 m .28871 .28836 L .27859 .29066 L 1 0 .477 r
F
P
p
.26045 .28834 m .27055 .28603 L .27859 .29066 L 1 0 .205 r
F
P
p
.24221 .28601 m .26045 .28834 L .25041 .29063 L 1 0 .136 r
F
P
p
.23219 .28832 m .24221 .28601 L .25041 .29063 L 1 0 .136 r
F
P
p
.21386 .28598 m .23219 .28832 L .22224 .29061 L 1 0 .136 r
F
P
p
.20393 .28829 m .21386 .28598 L .22224 .29061 L 1 0 .136 r
F
P
p
.18551 .28596 m .20393 .28829 L .19406 .29059 L 1 0 .136 r
F
P
p
.002 w
.89678 .50804 m .88516 .51718 L .88008 .49748 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.86895 .51693 m .88008 .49748 L .88516 .51718 L p
1 .194 0 r
F P
0 0 0 r
s
P
p
.002 w
.86895 .51693 m .85704 .51853 L .85251 .51393 L p
1 .199 0 r
F P
0 0 0 r
s
P
p
.002 w
.85251 .51393 m .85704 .51853 L p
.84651 .51662 L 1 .296 0 r
F P
0 0 0 r
s
P
p
.002 w
.85251 .51393 m .86373 .49579 L .86895 .51693 L p
1 .199 0 r
F P
0 0 0 r
s
P
p
.002 w
.85251 .51393 m .84922 .53912 L p
.85856 .51122 L 1 .37 0 r
F P
0 0 0 r
s
P
p
.002 w
.86373 .49579 m .85251 .51393 L p
.85856 .51122 L 1 .37 0 r
F P
0 0 0 r
s
P
p
.002 w
.84062 .51554 m .85251 .51393 L p
.84651 .51662 L 1 .296 0 r
F P
0 0 0 r
s
P
p
.86544 .28653 m .87742 .28421 L .88174 .28886 L 1 .097 0 r
F
P
p
.84903 .28418 m .86544 .28653 L .85352 .28883 L 1 .066 0 r
F
P
p
.83713 .2865 m .84903 .28418 L .85352 .28883 L 1 .163 0 r
F
P
p
.82063 .28416 m .83713 .2865 L .8253 .28881 L 1 .205 0 r
F
P
p
.80882 .28648 m .82063 .28416 L .8253 .28881 L 1 .307 0 r
F
P
p
.79223 .28414 m .80882 .28648 L .79707 .28879 L 1 .477 0 r
F
P
p
.7805 .28646 m .79223 .28414 L .79707 .28879 L 1 .852 0 r
F
P
p
.76383 .28411 m .7805 .28646 L .76885 .28876 L 1 .852 0 r
F
P
p
.75219 .28643 m .76383 .28411 L .76885 .28876 L 1 .886 0 r
F
P
p
.73542 .28409 m .75219 .28643 L .74062 .28874 L 1 .75 0 r
F
P
p
.72387 .28641 m .73542 .28409 L .74062 .28874 L 1 .989 0 r
F
P
p
.70702 .28406 m .72387 .28641 L .71239 .28872 L 1 .784 0 r
F
P
p
.69555 .28639 m .70702 .28406 L .71239 .28872 L 1 .86 0 r
F
P
p
.67861 .28404 m .69555 .28639 L .68415 .28869 L 1 .464 0 r
F
P
p
.66723 .28636 m .67861 .28404 L .68415 .28869 L 1 .587 0 r
F
P
p
.6502 .28402 m .66723 .28636 L .65592 .28867 L 0 .877 1 r
F
P
p
.63891 .28634 m .6502 .28402 L .65592 .28867 L 0 .182 1 r
F
P
p
.62179 .28399 m .63891 .28634 L .62768 .28865 L 1 0 .624 r
F
P
p
.61058 .28631 m .62179 .28399 L .62768 .28865 L 1 0 .498 r
F
P
p
.59338 .28397 m .61058 .28631 L .59945 .28862 L 1 0 .682 r
F
P
p
.58226 .28629 m .59338 .28397 L .59945 .28862 L 1 0 .511 r
F
P
p
.56496 .28395 m .58226 .28629 L .57121 .2886 L 1 0 .818 r
F
P
p
.55393 .28627 m .56496 .28395 L .57121 .2886 L 1 0 .75 r
F
P
p
.53655 .28392 m .55393 .28627 L .54296 .28858 L .909 0 1 r
F
P
p
.5256 .28624 m .53655 .28392 L .54296 .28858 L .909 0 1 r
F
P
p
.50813 .2839 m .5256 .28624 L .51472 .28855 L .432 0 1 r
F
P
p
.49727 .28622 m .50813 .2839 L .51472 .28855 L .807 0 1 r
F
P
p
.47971 .28387 m .49727 .28622 L .48648 .28853 L .67 0 1 r
F
P
p
.46894 .2862 m .47971 .28387 L .48648 .28853 L .841 0 1 r
F
P
p
.45129 .28385 m .46894 .2862 L .45823 .2885 L .977 0 1 r
F
P
p
.4406 .28617 m .45129 .28385 L .45823 .2885 L 1 0 .852 r
F
P
p
.42286 .28383 m .4406 .28617 L .42998 .28848 L 1 0 .341 r
F
P
p
.41226 .28615 m .42286 .28383 L .42998 .28848 L 1 0 .273 r
F
P
p
.39444 .2838 m .41226 .28615 L .40173 .28846 L 1 0 .443 r
F
P
p
.38393 .28612 m .39444 .2838 L .40173 .28846 L 1 0 .273 r
F
P
p
.36601 .28378 m .38393 .28612 L .37348 .28843 L 1 0 .273 r
F
P
p
.35559 .2861 m .36601 .28378 L .37348 .28843 L 1 0 .273 r
F
P
p
.002 w
.90837 .4975 m .89678 .50804 L .8921 .49581 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.88008 .49748 m .8921 .49581 L .89678 .50804 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.33758 .28375 m .35559 .2861 L .34522 .28841 L 1 0 .239 r
F
P
p
.32724 .28608 m .33758 .28375 L .34522 .28841 L 1 0 .17 r
F
P
p
.30915 .28373 m .32724 .28608 L .31697 .28839 L 1 0 .818 r
F
P
p
.2989 .28605 m .30915 .28373 L .31697 .28839 L 1 0 .682 r
F
P
p
.28072 .28371 m .2989 .28605 L .28871 .28836 L 1 0 .818 r
F
P
p
.27055 .28603 m .28072 .28371 L .28871 .28836 L 1 0 .477 r
F
P
p
.25228 .28368 m .27055 .28603 L .26045 .28834 L 1 0 .17 r
F
P
p
.24221 .28601 m .25228 .28368 L .26045 .28834 L 1 0 .136 r
F
P
p
.22385 .28366 m .24221 .28601 L .23219 .28832 L 1 0 .136 r
F
P
p
.21386 .28598 m .22385 .28366 L .23219 .28832 L 1 0 .136 r
F
P
p
.19541 .28363 m .21386 .28598 L .20393 .28829 L 1 0 .136 r
F
P
p
.18551 .28596 m .19541 .28363 L .20393 .28829 L 1 0 .136 r
F
P
p
.002 w
.85251 .51393 m .84062 .51554 L .83722 .54068 L p
1 .467 0 r
F P
0 0 0 r
s
P
p
.002 w
.83722 .54068 m .84062 .51554 L p
.83335 .54297 L 1 .574 0 r
F P
0 0 0 r
s
P
p
.002 w
.83722 .54068 m .84922 .53912 L .85251 .51393 L p
1 .467 0 r
F P
0 0 0 r
s
P
p
.002 w
.83722 .54068 m .83256 .53755 L p
.84111 .53836 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.84922 .53912 m .83722 .54068 L p
.84111 .53836 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.82637 .56935 m .83722 .54068 L p
.83335 .54297 L 1 .574 0 r
F P
0 0 0 r
s
P
p
.002 w
.88008 .49748 m .86895 .51693 L .86373 .49579 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.8921 .49581 m .9042 .49413 L .90837 .4975 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.8921 .49581 m .88008 .49748 L .87574 .49411 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.86373 .49579 m .87574 .49411 L .88008 .49748 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.861 .28185 m .87742 .28421 L .86544 .28653 L 1 0 0 r
F
P
p
.84903 .28418 m .861 .28185 L .86544 .28653 L 1 .066 0 r
F
P
p
.83252 .28183 m .84903 .28418 L .83713 .2865 L 1 .134 0 r
F
P
p
.82063 .28416 m .83252 .28183 L .83713 .2865 L 1 .205 0 r
F
P
p
.80403 .2818 m .82063 .28416 L .80882 .28648 L 1 .307 0 r
F
P
p
.79223 .28414 m .80403 .2818 L .80882 .28648 L 1 .477 0 r
F
P
p
.77554 .28178 m .79223 .28414 L .7805 .28646 L 1 .705 0 r
F
P
p
.76383 .28411 m .77554 .28178 L .7805 .28646 L 1 .852 0 r
F
P
p
.74705 .28175 m .76383 .28411 L .75219 .28643 L 1 .545 0 r
F
P
p
.73542 .28409 m .74705 .28175 L .75219 .28643 L 1 .75 0 r
F
P
p
.71855 .28173 m .73542 .28409 L .72387 .28641 L 1 .614 0 r
F
P
p
.70702 .28406 m .71855 .28173 L .72387 .28641 L 1 .784 0 r
F
P
p
.69006 .28171 m .70702 .28406 L .69555 .28639 L 1 .409 0 r
F
P
p
.67861 .28404 m .69006 .28171 L .69555 .28639 L 1 .464 0 r
F
P
p
.66156 .28168 m .67861 .28404 L .66723 .28636 L 0 1 .714 r
F
P
p
.6502 .28402 m .66156 .28168 L .66723 .28636 L 0 .877 1 r
F
P
p
.63307 .28166 m .6502 .28402 L .63891 .28634 L 1 0 .795 r
F
P
p
.62179 .28399 m .63307 .28166 L .63891 .28634 L 1 0 .624 r
F
P
p
.60457 .28163 m .62179 .28399 L .61058 .28631 L 1 0 .75 r
F
P
p
.59338 .28397 m .60457 .28163 L .61058 .28631 L 1 0 .682 r
F
P
p
.57606 .28161 m .59338 .28397 L .58226 .28629 L 1 0 .989 r
F
P
p
.56496 .28395 m .57606 .28161 L .58226 .28629 L 1 0 .818 r
F
P
p
.54756 .28158 m .56496 .28395 L .55393 .28627 L .5 0 1 r
F
P
p
.53655 .28392 m .54756 .28158 L .55393 .28627 L .909 0 1 r
F
P
p
.51905 .28156 m .53655 .28392 L .5256 .28624 L .091 0 1 r
F
P
p
.50813 .2839 m .51905 .28156 L .5256 .28624 L .432 0 1 r
F
P
p
.49055 .28154 m .50813 .2839 L .49727 .28622 L .261 0 1 r
F
P
p
.47971 .28387 m .49055 .28154 L .49727 .28622 L .67 0 1 r
F
P
p
.46204 .28151 m .47971 .28387 L .46894 .2862 L .875 0 1 r
F
P
p
.45129 .28385 m .46204 .28151 L .46894 .2862 L .977 0 1 r
F
P
p
.43353 .28149 m .45129 .28385 L .4406 .28617 L 1 0 .682 r
F
P
p
.42286 .28383 m .43353 .28149 L .4406 .28617 L 1 0 .341 r
F
P
p
.40501 .28146 m .42286 .28383 L .41226 .28615 L 1 0 .614 r
F
P
p
.39444 .2838 m .40501 .28146 L .41226 .28615 L 1 0 .443 r
F
P
p
.3765 .28144 m .39444 .2838 L .38393 .28612 L 1 0 .273 r
F
P
p
.36601 .28378 m .3765 .28144 L .38393 .28612 L 1 0 .273 r
F
P
p
.34798 .28142 m .36601 .28378 L .35559 .2861 L 1 0 .273 r
F
P
p
.33758 .28375 m .34798 .28142 L .35559 .2861 L 1 0 .239 r
F
P
p
.31947 .28139 m .33758 .28375 L .32724 .28608 L 1 0 .818 r
F
P
p
.30915 .28373 m .31947 .28139 L .32724 .28608 L 1 0 .818 r
F
P
p
.29095 .28137 m .30915 .28373 L .2989 .28605 L .773 0 1 r
F
P
p
.28072 .28371 m .29095 .28137 L .2989 .28605 L 1 0 .818 r
F
P
p
.26242 .28134 m .28072 .28371 L .27055 .28603 L 1 0 .239 r
F
P
p
.25228 .28368 m .26242 .28134 L .27055 .28603 L 1 0 .17 r
F
P
p
.2339 .28132 m .25228 .28368 L .24221 .28601 L 1 0 .136 r
F
P
p
.22385 .28366 m .2339 .28132 L .24221 .28601 L 1 0 .136 r
F
P
p
.20537 .2813 m .22385 .28366 L .21386 .28598 L 1 0 .136 r
F
P
p
.19541 .28363 m .20537 .2813 L .21386 .28598 L 1 0 .136 r
F
P
p
.17685 .28127 m .19541 .28363 L .18551 .28596 L 1 0 .136 r
F
P
p
.002 w
.9042 .49413 m .8921 .49581 L .88782 .49242 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87574 .49411 m .88782 .49242 L .8921 .49581 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.87574 .49411 m .86373 .49579 L .86089 .52849 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.84922 .53912 m .86089 .52849 L .86373 .49579 L p
1 .37 0 r
F P
0 0 0 r
s
P
p
.861 .28185 m .87305 .2795 L .87742 .28421 L 1 0 0 r
F
P
p
.84448 .27948 m .861 .28185 L .84903 .28418 L 1 .097 0 r
F
P
p
.83252 .28183 m .84448 .27948 L .84903 .28418 L 1 .134 0 r
F
P
p
.8159 .27945 m .83252 .28183 L .82063 .28416 L 1 .239 0 r
F
P
p
.80403 .2818 m .8159 .27945 L .82063 .28416 L 1 .307 0 r
F
P
p
.78732 .27943 m .80403 .2818 L .79223 .28414 L 1 .427 0 r
F
P
p
.77554 .28178 m .78732 .27943 L .79223 .28414 L 1 .705 0 r
F
P
p
.75874 .2794 m .77554 .28178 L .76383 .28411 L 1 .443 0 r
F
P
p
.74705 .28175 m .75874 .2794 L .76383 .28411 L 1 .545 0 r
F
P
p
.002 w
.76474 .86539 m .75298 .8726 L .74799 .87158 L p
1 0 .611 r
F P
0 0 0 r
s
P
p
.002 w
.74799 .87158 m .74771 .87152 L p
.74861 .8712 L 1 0 .611 r
F P
0 0 0 r
s
P
p
.74861 .8712 m .76474 .86539 L .74799 .87158 L 1 0 .611 r
F
P
p
.002 w
.74771 .87152 m .75973 .87099 L .76474 .86539 L p
1 0 .611 r
F P
0 0 0 r
s
P
p
.002 w
.77277 .73934 m .76474 .86539 L .75984 .87086 L p
.892 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.75984 .87086 m .75973 .87099 L p
.75994 .86891 L .892 0 1 r
F P
0 0 0 r
s
P
p
.75994 .86891 m .77277 .73934 L .75984 .87086 L .892 0 1 r
F
P
p
.002 w
.75973 .87099 m .77162 .8637 L .77168 .85704 L p
.892 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77168 .85704 m .77277 .73934 L p
.76043 .86394 L .892 0 1 r
F P
0 0 0 r
s
P
p
.75973 .87099 m .77168 .85704 L .76043 .86394 L .892 0 1 r
F
P
p
.002 w
.75749 .57077 m .76593 .7458 L p
.74805 .5914 L 0 .772 1 r
F P
0 0 0 r
s
P
p
.002 w
.78441 .7309 m .77277 .73934 L .77162 .8637 L p
.234 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77162 .8637 m .78232 .81852 L .78441 .7309 L p
.234 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.75749 .57077 m .76834 .54219 L .78232 .81852 L p
0 1 .945 r
F P
0 0 0 r
s
P
p
.002 w
.78232 .81852 m .77162 .8637 L .75749 .57077 L p
0 1 .945 r
F P
0 0 0 r
s
P
p
.002 w
.75749 .57077 m .75455 .6414 L p
.76737 .54916 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76834 .54219 m .75749 .57077 L p
.76737 .54916 L .5 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74583 .57222 m .75749 .57077 L p
.74805 .5914 L 0 .772 1 r
F P
0 0 0 r
s
P
p
.002 w
.76593 .7458 m .77162 .8637 L p
.76425 .78038 L 0 .772 1 r
F P
0 0 0 r
s
P
p
.74583 .57222 m .76593 .7458 L .76425 .78038 L 0 .772 1 r
F
P
p
.002 w
.77162 .8637 m .75973 .87099 L .74583 .57222 L p
0 .772 1 r
F P
0 0 0 r
s
P
p
.002 w
.73499 .60075 m .74583 .57222 L .75973 .87099 L p
0 .646 1 r
F P
0 0 0 r
s
P
p
.002 w
.75749 .57077 m .74583 .57222 L .74311 .65693 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75973 .87099 m .74771 .87152 L .73514 .60393 L p
0 .646 1 r
F P
0 0 0 r
s
P
p
.002 w
.73514 .60393 m .73499 .60075 L p
.73525 .60365 L 0 .646 1 r
F P
0 0 0 r
s
P
p
.73525 .60365 m .75973 .87099 L .73514 .60393 L 0 .646 1 r
F
P
p
.002 w
.72531 .67514 m .73499 .60075 L .74771 .87152 L p
0 .271 1 r
F P
0 0 0 r
s
P
p
.002 w
.73218 .69035 m .74311 .65693 L .74562 .57876 L p
.038 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.74562 .57876 m .74583 .57222 L p
.74487 .58057 L .038 1 0 r
F P
0 0 0 r
s
P
p
.73218 .69035 m .74562 .57876 L .74487 .58057 L .038 1 0 r
F
P
p
.002 w
.74583 .57222 m .73499 .60075 L .73218 .69035 L p
.038 1 0 r
F P
0 0 0 r
s
P
p
.73016 .27938 m .74705 .28175 L .73542 .28409 L 1 .443 0 r
F
P
p
.71855 .28173 m .73016 .27938 L .73542 .28409 L 1 .614 0 r
F
P
p
.70158 .27935 m .71855 .28173 L .70702 .28406 L 1 .375 0 r
F
P
p
.69006 .28171 m .70158 .27935 L .70702 .28406 L 1 .409 0 r
F
P
p
.673 .27933 m .69006 .28171 L .67861 .28404 L 0 1 .114 r
F
P
p
.66156 .28168 m .673 .27933 L .67861 .28404 L 0 1 .714 r
F
P
p
.64441 .27931 m .66156 .28168 L .6502 .28402 L 1 0 .965 r
F
P
p
.63307 .28166 m .64441 .27931 L .6502 .28402 L 1 0 .795 r
F
P
p
.61582 .27928 m .63307 .28166 L .62179 .28399 L 1 0 .75 r
F
P
p
.60457 .28163 m .61582 .27928 L .62179 .28399 L 1 0 .75 r
F
P
p
.58723 .27926 m .60457 .28163 L .59338 .28397 L .909 0 1 r
F
P
p
.57606 .28161 m .58723 .27926 L .59338 .28397 L 1 0 .989 r
F
P
p
.55864 .27923 m .57606 .28161 L .56496 .28395 L 0 0 1 r
F
P
p
.54756 .28158 m .55864 .27923 L .56496 .28395 L .5 0 1 r
F
P
p
.53005 .27921 m .54756 .28158 L .53655 .28392 L .057 0 1 r
F
P
p
.51905 .28156 m .53005 .27921 L .53655 .28392 L .091 0 1 r
F
P
p
.50145 .27919 m .51905 .28156 L .50813 .2839 L 0 .386 1 r
F
P
p
.49055 .28154 m .50145 .27919 L .50813 .2839 L .261 0 1 r
F
P
p
.47286 .27916 m .49055 .28154 L .47971 .28387 L .636 0 1 r
F
P
p
.46204 .28151 m .47286 .27916 L .47971 .28387 L .875 0 1 r
F
P
p
.44426 .27914 m .46204 .28151 L .45129 .28385 L .909 0 1 r
F
P
p
.43353 .28149 m .44426 .27914 L .45129 .28385 L 1 0 .682 r
F
P
p
.41566 .27911 m .43353 .28149 L .42286 .28383 L 1 0 .648 r
F
P
p
.40501 .28146 m .41566 .27911 L .42286 .28383 L 1 0 .614 r
F
P
p
.38705 .27909 m .40501 .28146 L .39444 .2838 L 1 0 .614 r
F
P
p
.3765 .28144 m .38705 .27909 L .39444 .2838 L 1 0 .273 r
F
P
p
.35845 .27906 m .3765 .28144 L .36601 .28378 L 1 0 .273 r
F
P
p
.34798 .28142 m .35845 .27906 L .36601 .28378 L 1 0 .273 r
F
P
p
.32984 .27904 m .34798 .28142 L .33758 .28375 L 1 0 .852 r
F
P
p
.31947 .28139 m .32984 .27904 L .33758 .28375 L 1 0 .818 r
F
P
p
.30124 .27902 m .31947 .28139 L .30915 .28373 L .474 0 1 r
F
P
p
.29095 .28137 m .30124 .27902 L .30915 .28373 L .773 0 1 r
F
P
p
.27263 .27899 m .29095 .28137 L .28072 .28371 L 1 0 .409 r
F
P
p
.26242 .28134 m .27263 .27899 L .28072 .28371 L 1 0 .239 r
F
P
p
.24401 .27897 m .26242 .28134 L .25228 .28368 L 1 0 .136 r
F
P
p
.2339 .28132 m .24401 .27897 L .25228 .28368 L 1 0 .136 r
F
P
p
.2154 .27894 m .2339 .28132 L .22385 .28366 L 1 0 .136 r
F
P
p
.20537 .2813 m .2154 .27894 L .22385 .28366 L 1 0 .136 r
F
P
p
.18679 .27892 m .20537 .2813 L .19541 .28363 L 1 0 .136 r
F
P
p
.17685 .28127 m .18679 .27892 L .19541 .28363 L 1 0 .136 r
F
P
p
.002 w
.74771 .87152 m .73576 .87206 L .72712 .70923 L p
0 .271 1 r
F P
0 0 0 r
s
P
p
.002 w
.72712 .70923 m .72531 .67514 L p
.728 .69871 L 0 .271 1 r
F P
0 0 0 r
s
P
p
.728 .69871 m .74771 .87152 L .72712 .70923 L 0 .271 1 r
F
P
p
.002 w
.7172 .82061 m .72531 .67514 L .73576 .87206 L p
.527 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.7236 .8185 m .73218 .69035 L .73427 .62378 L p
0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.73427 .62378 m .73499 .60075 L p
.73298 .63922 L 0 1 .911 r
F P
0 0 0 r
s
P
p
.7236 .8185 m .73427 .62378 L .73298 .63922 L 0 1 .911 r
F
P
p
.002 w
.73499 .60075 m .72531 .67514 L .7236 .8185 L p
0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.88782 .49242 m .89998 .49072 L .9042 .49413 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.88782 .49242 m .87574 .49411 L .87218 .50875 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.87218 .50875 m .87574 .49411 L p
.86805 .51192 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.8843 .50569 m .88782 .49242 L p
.87339 .50749 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.87218 .50875 m .8843 .50569 L p
.87339 .50749 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.89998 .49072 m .88782 .49242 L .8843 .50569 L p
1 .126 0 r
F P
0 0 0 r
s
P
p
.002 w
.8843 .50569 m .89655 .50402 L .89998 .49072 L p
1 .126 0 r
F P
0 0 0 r
s
P
p
.002 w
.8843 .50569 m .8799 .50232 L p
.89527 .50389 L 1 .223 0 r
F P
0 0 0 r
s
P
p
.002 w
.89655 .50402 m .8843 .50569 L p
.89527 .50389 L 1 .223 0 r
F P
0 0 0 r
s
P
p
.002 w
.87218 .50875 m .86773 .5054 L p
.87636 .50555 L 1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.8843 .50569 m .87218 .50875 L p
.87636 .50555 L 1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.86089 .52849 m .87218 .50875 L p
.86805 .51192 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.79505 .69257 m .78441 .7309 L .78232 .81852 L p
0 .543 1 r
F P
0 0 0 r
s
P
p
.002 w
.7901 .69037 m .78232 .81852 L .76834 .54219 L p
0 1 .23 r
F P
0 0 0 r
s
P
p
.002 w
.76834 .54219 m .7801 .54064 L .7901 .69037 L p
0 1 .23 r
F P
0 0 0 r
s
P
p
.002 w
.7801 .54064 m .76834 .54219 L .76617 .63084 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.75455 .6414 m .76617 .63084 L .76834 .54219 L p
.5 1 0 r
F P
0 0 0 r
s
P
p
.85651 .27711 m .87305 .2795 L .861 .28185 L 1 .031 0 r
F
P
p
.84448 .27948 m .85651 .27711 L .861 .28185 L 1 .097 0 r
F
P
p
.82785 .27709 m .84448 .27948 L .83252 .28183 L 1 .205 0 r
F
P
p
.8159 .27945 m .82785 .27709 L .83252 .28183 L 1 .239 0 r
F
P
p
.002 w
.81447 .5708 m .80701 .69148 L .79779 .56933 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79779 .56933 m .80968 .56787 L .81447 .5708 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.79918 .27706 m .8159 .27945 L .80403 .2818 L 1 .233 0 r
F
P
p
.78732 .27943 m .79918 .27706 L .80403 .2818 L 1 .427 0 r
F
P
p
.77051 .27704 m .78732 .27943 L .77554 .28178 L 1 .399 0 r
F
P
p
.75874 .2794 m .77051 .27704 L .77554 .28178 L 1 .443 0 r
F
P
p
.002 w
.74311 .65693 m .75455 .6414 L .75749 .57077 L p
.311 1 0 r
F P
0 0 0 r
s
P
p
.74184 .27701 m .75874 .2794 L .74705 .28175 L 1 .341 0 r
F
P
p
.73016 .27938 m .74184 .27701 L .74705 .28175 L 1 .443 0 r
F
P
p
.71317 .27699 m .73016 .27938 L .71855 .28173 L 1 .307 0 r
F
P
p
.70158 .27935 m .71317 .27699 L .71855 .28173 L 1 .375 0 r
F
P
p
.6845 .27697 m .70158 .27935 L .69006 .28171 L .773 1 0 r
F
P
p
.673 .27933 m .6845 .27697 L .69006 .28171 L 0 1 .114 r
F
P
p
.65583 .27694 m .673 .27933 L .66156 .28168 L .909 0 1 r
F
P
p
.64441 .27931 m .65583 .27694 L .66156 .28168 L 1 0 .965 r
F
P
p
.62715 .27692 m .64441 .27931 L .63307 .28166 L 1 0 .795 r
F
P
p
.61582 .27928 m .62715 .27692 L .63307 .28166 L 1 0 .75 r
F
P
p
.59847 .27689 m .61582 .27928 L .60457 .28163 L .561 0 1 r
F
P
p
.58723 .27926 m .59847 .27689 L .60457 .28163 L .909 0 1 r
F
P
p
.56979 .27687 m .58723 .27926 L .57606 .28161 L 0 .091 1 r
F
P
p
.55864 .27923 m .56979 .27687 L .57606 .28161 L 0 0 1 r
F
P
p
.54111 .27684 m .55864 .27923 L .54756 .28158 L 0 .443 1 r
F
P
p
.53005 .27921 m .54111 .27684 L .54756 .28158 L .057 0 1 r
F
P
p
.51243 .27682 m .53005 .27921 L .51905 .28156 L 0 .727 1 r
F
P
p
.50145 .27919 m .51243 .27682 L .51905 .28156 L 0 .386 1 r
F
P
p
.48374 .2768 m .50145 .27919 L .49055 .28154 L .193 0 1 r
F
P
p
.47286 .27916 m .48374 .2768 L .49055 .28154 L .636 0 1 r
F
P
p
.45505 .27677 m .47286 .27916 L .46204 .28151 L .739 0 1 r
F
P
p
.44426 .27914 m .45505 .27677 L .46204 .28151 L .909 0 1 r
F
P
p
.42636 .27675 m .44426 .27914 L .43353 .28149 L 1 0 .818 r
F
P
p
.41566 .27911 m .42636 .27675 L .43353 .28149 L 1 0 .648 r
F
P
p
.39767 .27672 m .41566 .27911 L .40501 .28146 L 1 0 .955 r
F
P
p
.38705 .27909 m .39767 .27672 L .40501 .28146 L 1 0 .614 r
F
P
p
.36898 .2767 m .38705 .27909 L .3765 .28144 L 1 0 .273 r
F
P
p
.35845 .27906 m .36898 .2767 L .3765 .28144 L 1 0 .273 r
F
P
p
.34029 .27667 m .35845 .27906 L .34798 .28142 L 1 0 .92 r
F
P
p
.32984 .27904 m .34029 .27667 L .34798 .28142 L 1 0 .852 r
F
P
p
.31159 .27665 m .32984 .27904 L .31947 .28139 L .44 0 1 r
F
P
p
.30124 .27902 m .31159 .27665 L .31947 .28139 L .474 0 1 r
F
P
p
.28289 .27663 m .30124 .27902 L .29095 .28137 L 1 0 .682 r
F
P
p
.27263 .27899 m .28289 .27663 L .29095 .28137 L 1 0 .409 r
F
P
p
.25419 .2766 m .27263 .27899 L .26242 .28134 L 1 0 .136 r
F
P
p
.24401 .27897 m .25419 .2766 L .26242 .28134 L 1 0 .136 r
F
P
p
.22549 .27658 m .24401 .27897 L .2339 .28132 L 1 0 .136 r
F
P
p
.2154 .27894 m .22549 .27658 L .2339 .28132 L 1 0 .136 r
F
P
p
.19679 .27655 m .2154 .27894 L .20537 .2813 L 1 0 .136 r
F
P
p
.18679 .27892 m .19679 .27655 L .20537 .2813 L 1 0 .136 r
F
P
p
.16808 .27653 m .18679 .27892 L .17685 .28127 L 1 0 .136 r
F
P
p
.002 w
.68276 .87572 m .67187 .90752 L .66618 .90668 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.66618 .90668 m .67714 .87469 L .68276 .87572 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.83722 .54068 m .82637 .56935 L .82165 .56639 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.82165 .56639 m .83256 .53755 L .83722 .54068 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.79779 .56933 m .7901 .69037 L .7801 .54064 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7801 .54064 m .79193 .53909 L .79779 .56933 L p
.67 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79193 .53909 m .7801 .54064 L .77509 .53751 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.76617 .63084 m .77509 .53751 L .7801 .54064 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.85651 .27711 m .86862 .27473 L .87305 .2795 L 1 .031 0 r
F
P
p
.83987 .27471 m .85651 .27711 L .84448 .27948 L 1 .197 0 r
F
P
p
.82785 .27709 m .83987 .27471 L .84448 .27948 L 1 .205 0 r
F
P
p
.002 w
.80968 .56787 m .82165 .56639 L .82637 .56935 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.81111 .27468 m .82785 .27709 L .8159 .27945 L 1 .205 0 r
F
P
p
.79918 .27706 m .81111 .27468 L .8159 .27945 L 1 .233 0 r
F
P
p
.002 w
.7901 .69037 m .79779 .56933 L .80701 .69148 L p
0 1 .42 r
F P
0 0 0 r
s
P
p
.002 w
.80968 .56787 m .79779 .56933 L .79193 .53909 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.78236 .27466 m .79918 .27706 L .78732 .27943 L 1 .325 0 r
F
P
p
.77051 .27704 m .78236 .27466 L .78732 .27943 L 1 .399 0 r
F
P
p
.7536 .27464 m .77051 .27704 L .75874 .2794 L 1 .273 0 r
F
P
p
.74184 .27701 m .7536 .27464 L .75874 .2794 L 1 .341 0 r
F
P
p
.72484 .27461 m .74184 .27701 L .73016 .27938 L 1 .273 0 r
F
P
p
.71317 .27699 m .72484 .27461 L .73016 .27938 L 1 .307 0 r
F
P
p
.69608 .27459 m .71317 .27699 L .70158 .27935 L 1 .75 0 r
F
P
p
.6845 .27697 m .69608 .27459 L .70158 .27935 L .773 1 0 r
F
P
p
.66731 .27456 m .6845 .27697 L .673 .27933 L .398 0 1 r
F
P
p
.65583 .27694 m .66731 .27456 L .673 .27933 L .909 0 1 r
F
P
p
.63855 .27454 m .65583 .27694 L .64441 .27931 L 1 0 .965 r
F
P
p
.62715 .27692 m .63855 .27454 L .64441 .27931 L 1 0 .795 r
F
P
p
.60978 .27451 m .62715 .27692 L .61582 .27928 L .061 0 1 r
F
P
p
.59847 .27689 m .60978 .27451 L .61582 .27928 L .561 0 1 r
F
P
p
.58101 .27449 m .59847 .27689 L .58723 .27926 L 0 .091 1 r
F
P
p
.56979 .27687 m .58101 .27449 L .58723 .27926 L 0 .091 1 r
F
P
p
.55224 .27446 m .56979 .27687 L .55864 .27923 L 0 1 .989 r
F
P
p
.54111 .27684 m .55224 .27446 L .55864 .27923 L 0 .443 1 r
F
P
p
.52347 .27444 m .54111 .27684 L .53005 .27921 L 0 .795 1 r
F
P
p
.51243 .27682 m .52347 .27444 L .53005 .27921 L 0 .727 1 r
F
P
p
.49469 .27441 m .51243 .27682 L .50145 .27919 L 0 .148 1 r
F
P
p
.48374 .2768 m .49469 .27441 L .50145 .27919 L .193 0 1 r
F
P
p
.46592 .27439 m .48374 .2768 L .47286 .27916 L .602 0 1 r
F
P
p
.45505 .27677 m .46592 .27439 L .47286 .27916 L .739 0 1 r
F
P
p
.43714 .27437 m .45505 .27677 L .44426 .27914 L .807 0 1 r
F
P
p
.42636 .27675 m .43714 .27437 L .44426 .27914 L 1 0 .818 r
F
P
p
.40836 .27434 m .42636 .27675 L .41566 .27911 L 1 0 .955 r
F
P
p
.39767 .27672 m .40836 .27434 L .41566 .27911 L 1 0 .955 r
F
P
p
.37958 .27432 m .39767 .27672 L .38705 .27909 L 1 0 .614 r
F
P
p
.36898 .2767 m .37958 .27432 L .38705 .27909 L 1 0 .273 r
F
P
p
.35079 .27429 m .36898 .2767 L .35845 .27906 L .827 0 1 r
F
P
p
.34029 .27667 m .35079 .27429 L .35845 .27906 L 1 0 .92 r
F
P
p
.32201 .27427 m .34029 .27667 L .32984 .27904 L .214 0 1 r
F
P
p
.31159 .27665 m .32201 .27427 L .32984 .27904 L .44 0 1 r
F
P
p
.29322 .27424 m .31159 .27665 L .30124 .27902 L 1 0 .844 r
F
P
p
.28289 .27663 m .29322 .27424 L .30124 .27902 L 1 0 .682 r
F
P
p
.26443 .27422 m .28289 .27663 L .27263 .27899 L 1 0 .136 r
F
P
p
.25419 .2766 m .26443 .27422 L .27263 .27899 L 1 0 .136 r
F
P
p
.23564 .27419 m .25419 .2766 L .24401 .27897 L 1 0 .136 r
F
P
p
.22549 .27658 m .23564 .27419 L .24401 .27897 L 1 0 .136 r
F
P
p
.20685 .27417 m .22549 .27658 L .2154 .27894 L 1 0 .136 r
F
P
p
.19679 .27655 m .20685 .27417 L .2154 .27894 L 1 0 .136 r
F
P
p
.17805 .27415 m .19679 .27655 L .18679 .27892 L 1 0 .136 r
F
P
p
.16808 .27653 m .17805 .27415 L .18679 .27892 L 1 0 .136 r
F
P
p
.002 w
.72531 .67514 m .7172 .82061 L .71169 .81921 L p
.166 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.71169 .81921 m .7236 .8185 L .72531 .67514 L p
.166 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.70588 .87469 m .69428 .87521 L .68872 .87417 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67714 .87469 m .68872 .87417 L .69428 .87521 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.86089 .52849 m .84922 .53912 L .84463 .53597 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.83256 .53755 m .84463 .53597 L .84922 .53912 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.79193 .53909 m .80349 .52845 L .80968 .56787 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.80349 .52845 m .79424 .53697 L p
.79525 .53219 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.78698 .53594 m .79794 .50704 L .80349 .52845 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.79497 .55884 m .79557 .54837 L p
.79318 .57414 L .841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79557 .54837 m .79696 .52415 L p
.79483 .55236 L .841 1 0 r
F P
0 0 0 r
s
P
p
.79318 .57414 m .79557 .54837 L .79483 .55236 L .841 1 0 r
F
P
p
.002 w
.81545 .52685 m .80349 .52845 L .79794 .50704 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.79794 .50704 m .80993 .50537 L .81545 .52685 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.80993 .50537 m .79794 .50704 L .79497 .55884 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.80113 .52627 m .80574 .52033 L p
.79727 .53933 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.78903 .62799 m .79696 .52415 L .79653 .52617 L .841 1 0 r
F
P
p
.78642 .66342 m .78934 .62488 L .78903 .62799 L .841 1 0 r
F
P
p
.78934 .62488 m .79696 .52415 L .78903 .62799 L .841 1 0 r
F
P
p
.002 w
.79696 .52415 m .79794 .50704 L p
.79653 .52617 L .841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79193 .53909 m .78698 .53594 L p
.79525 .53219 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.79424 .53697 m .79193 .53909 L p
.79525 .53219 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.78698 .53594 m .79193 .53909 L p
.77807 .53779 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.77509 .53751 m .78698 .53594 L p
.77807 .53779 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.78698 .53594 m .78642 .66342 L p
.79595 .53408 L .841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.79794 .50704 m .78698 .53594 L p
.79595 .53408 L .841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78698 .53594 m .77509 .53751 L .77597 .71778 L p
.174 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77597 .71778 m .78642 .66342 L .78698 .53594 L p
.174 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.78995 .55576 m .78357 .51531 L p
.79918 .52505 L 1 .705 0 r
F P
0 0 0 r
s
P
p
.002 w
.80113 .52627 m .79833 .53364 L p
.79918 .52505 L 1 .705 0 r
F P
0 0 0 r
s
P
p
.002 w
.79833 .53364 m .78995 .55576 L p
.79918 .52505 L 1 .705 0 r
F P
0 0 0 r
s
P
p
.002 w
.78995 .55576 m .79833 .53364 L p
.79727 .53933 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.79833 .53364 m .80113 .52627 L p
.79727 .53933 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.79497 .55884 m .78995 .55576 L p
.79727 .53933 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.80574 .52033 m .79497 .55884 L p
.79727 .53933 L 1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.78642 .66342 m .79497 .55884 L p
.79318 .57414 L .841 1 0 r
F P
0 0 0 r
s
P
p
.85196 .27231 m .86862 .27473 L .85651 .27711 L 1 .128 0 r
F
P
p
.83987 .27471 m .85196 .27231 L .85651 .27711 L 1 .197 0 r
F
P
p
.82312 .27229 m .83987 .27471 L .82785 .27709 L 1 .17 0 r
F
P
p
.81111 .27468 m .82312 .27229 L .82785 .27709 L 1 .205 0 r
F
P
p
.002 w
.82165 .56639 m .80968 .56787 L .80349 .52845 L p
1 .818 0 r
F P
0 0 0 r
s
P
p
.79427 .27227 m .81111 .27468 L .79918 .27706 L 1 .233 0 r
F
P
p
.78236 .27466 m .79427 .27227 L .79918 .27706 L 1 .325 0 r
F
P
p
.76543 .27224 m .78236 .27466 L .77051 .27704 L 1 .273 0 r
F
P
p
.7536 .27464 m .76543 .27224 L .77051 .27704 L 1 .273 0 r
F
P
p
.73658 .27222 m .7536 .27464 L .74184 .27701 L 1 .273 0 r
F
P
p
.72484 .27461 m .73658 .27222 L .74184 .27701 L 1 .273 0 r
F
P
p
.70773 .27219 m .72484 .27461 L .71317 .27699 L 1 .545 0 r
F
P
p
.69608 .27459 m .70773 .27219 L .71317 .27699 L 1 .75 0 r
F
P
p
.67887 .27217 m .69608 .27459 L .6845 .27697 L 0 .549 1 r
F
P
p
.66731 .27456 m .67887 .27217 L .6845 .27697 L .398 0 1 r
F
P
p
.002 w
.66618 .90668 m .6547 .9071 L .64841 .87468 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.63742 .90668 m .64841 .87468 L .6547 .9071 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.65002 .27214 m .66731 .27456 L .65583 .27694 L .561 0 1 r
F
P
p
.63855 .27454 m .65002 .27214 L .65583 .27694 L 1 0 .965 r
F
P
p
.62116 .27212 m .63855 .27454 L .62715 .27692 L 0 .102 1 r
F
P
p
.60978 .27451 m .62116 .27212 L .62715 .27692 L .061 0 1 r
F
P
p
.5923 .27209 m .60978 .27451 L .59847 .27689 L 0 .45 1 r
F
P
p
.58101 .27449 m .5923 .27209 L .59847 .27689 L 0 .091 1 r
F
P
p
.56344 .27207 m .58101 .27449 L .56979 .27687 L 0 1 .825 r
F
P
p
.55224 .27446 m .56344 .27207 L .56979 .27687 L 0 1 .989 r
F
P
p
.53458 .27204 m .55224 .27446 L .54111 .27684 L 0 .977 1 r
F
P
p
.52347 .27444 m .53458 .27204 L .54111 .27684 L 0 .795 1 r
F
P
p
.50572 .27202 m .52347 .27444 L .51243 .27682 L 0 .455 1 r
F
P
p
.49469 .27441 m .50572 .27202 L .51243 .27682 L 0 .148 1 r
F
P
p
.47685 .27199 m .49469 .27441 L .48374 .2768 L .5 0 1 r
F
P
p
.46592 .27439 m .47685 .27199 L .48374 .2768 L .602 0 1 r
F
P
p
.44798 .27197 m .46592 .27439 L .45505 .27677 L .534 0 1 r
F
P
p
.43714 .27437 m .44798 .27197 L .45505 .27677 L .807 0 1 r
F
P
p
.41911 .27195 m .43714 .27437 L .42636 .27675 L 1 0 .959 r
F
P
p
.40836 .27434 m .41911 .27195 L .42636 .27675 L 1 0 .955 r
F
P
p
.39024 .27192 m .40836 .27434 L .39767 .27672 L .909 0 1 r
F
P
p
.37958 .27432 m .39024 .27192 L .39767 .27672 L 1 0 .614 r
F
P
p
.36137 .2719 m .37958 .27432 L .36898 .2767 L .609 0 1 r
F
P
p
.35079 .27429 m .36137 .2719 L .36898 .2767 L .827 0 1 r
F
P
p
.33249 .27187 m .35079 .27429 L .34029 .27667 L 0 .039 1 r
F
P
p
.32201 .27427 m .33249 .27187 L .34029 .27667 L .214 0 1 r
F
P
p
.30362 .27185 m .32201 .27427 L .31159 .27665 L 1 0 .878 r
F
P
p
.29322 .27424 m .30362 .27185 L .31159 .27665 L 1 0 .844 r
F
P
p
.27474 .27182 m .29322 .27424 L .28289 .27663 L 1 0 .136 r
F
P
p
.26443 .27422 m .27474 .27182 L .28289 .27663 L 1 0 .136 r
F
P
p
.24586 .2718 m .26443 .27422 L .25419 .2766 L 1 0 .136 r
F
P
p
.23564 .27419 m .24586 .2718 L .25419 .2766 L 1 0 .136 r
F
P
p
.21697 .27177 m .23564 .27419 L .22549 .27658 L 1 0 .136 r
F
P
p
.20685 .27417 m .21697 .27177 L .22549 .27658 L 1 0 .136 r
F
P
p
.18809 .27175 m .20685 .27417 L .19679 .27655 L 1 0 .136 r
F
P
p
.17805 .27415 m .18809 .27175 L .19679 .27655 L 1 0 .136 r
F
P
p
.1592 .27172 m .17805 .27415 L .16808 .27653 L 1 0 .136 r
F
P
p
.002 w
.87218 .50875 m .86089 .52849 L .85637 .52526 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.84463 .53597 m .85637 .52526 L .86089 .52849 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.80349 .52845 m .81545 .52685 L .82165 .56639 L p
1 .818 0 r
F P
0 0 0 r
s
P
p
.002 w
.85637 .52526 m .86773 .5054 L .87218 .50875 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.71754 .87417 m .70588 .87469 L .70037 .87365 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68872 .87417 m .70037 .87365 L .70588 .87469 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68872 .87417 m .67714 .87469 L .67146 .87364 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67714 .87469 m .66618 .90668 L .6599 .87416 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .87416 m .67146 .87364 L .67714 .87469 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.64841 .87468 m .6599 .87416 L .66618 .90668 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .87416 m .64841 .87468 L .64254 .87364 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64841 .87468 m .63742 .90668 L .63147 .90583 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.63147 .90583 m .64254 .87364 L .64841 .87468 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.84463 .53597 m .83256 .53755 L .82696 .51224 L p
1 .497 0 r
F P
0 0 0 r
s
P
p
.002 w
.83256 .53755 m .82165 .56639 L .81545 .52685 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.81545 .52685 m .82696 .51224 L .83256 .53755 L p
1 .667 0 r
F P
0 0 0 r
s
P
p
.002 w
.77509 .53751 m .76617 .63084 L .76643 .71987 L p
0 1 .692 r
F P
0 0 0 r
s
P
p
.002 w
.76643 .71987 m .76656 .76293 L p
.76849 .71185 L 0 1 .692 r
F P
0 0 0 r
s
P
p
.76849 .71185 m .77509 .53751 L .76643 .71987 L 0 1 .692 r
F
P
p
.76856 .7531 m .77509 .53751 L .76656 .76293 L 0 1 .692 r
F
P
p
.002 w
.77597 .71778 m .77509 .53751 L p
.76763 .78394 L 0 1 .692 r
F P
0 0 0 r
s
P
p
.002 w
.76671 .81417 m .77597 .71778 L p
.76763 .78394 L 0 1 .692 r
F P
0 0 0 r
s
P
p
.002 w
.77597 .71778 m .76576 .55883 L p
.78422 .65229 L 0 1 .031 r
F P
0 0 0 r
s
P
p
.002 w
.78642 .66342 m .77597 .71778 L p
.78422 .65229 L 0 1 .031 r
F P
0 0 0 r
s
P
p
.002 w
.76576 .55883 m .77781 .5573 L .78511 .64726 L p
0 1 .031 r
F P
0 0 0 r
s
P
p
.002 w
.78511 .64726 m .78642 .66342 L p
.78404 .65139 L 0 1 .031 r
F P
0 0 0 r
s
P
p
.76576 .55883 m .78511 .64726 L .78404 .65139 L 0 1 .031 r
F
P
p
.002 w
.76617 .63084 m .75455 .6414 L .75514 .83905 L p
0 .514 1 r
F P
0 0 0 r
s
P
p
.002 w
.75514 .83905 m .76671 .81417 L .76617 .63084 L p
0 .514 1 r
F P
0 0 0 r
s
P
p
.002 w
.75378 .56035 m .76576 .55883 L .77592 .71701 L p
0 1 .556 r
F P
0 0 0 r
s
P
p
.002 w
.77592 .71701 m .77597 .71778 L p
.77588 .71718 L 0 1 .556 r
F P
0 0 0 r
s
P
p
.75378 .56035 m .77592 .71701 L .77588 .71718 L 0 1 .556 r
F
P
p
.002 w
.76656 .76293 m .76671 .81417 L p
.76856 .7531 L 0 1 .692 r
F P
0 0 0 r
s
P
p
.85196 .27231 m .86413 .26991 L .86862 .27473 L 1 .128 0 r
F
P
p
.8352 .26988 m .85196 .27231 L .83987 .27471 L 1 .131 0 r
F
P
p
.82312 .27229 m .8352 .26988 L .83987 .27471 L 1 .17 0 r
F
P
p
.80626 .26986 m .82312 .27229 L .81111 .27468 L 1 .199 0 r
F
P
p
.79427 .27227 m .80626 .26986 L .81111 .27468 L 1 .233 0 r
F
P
p
.77733 .26983 m .79427 .27227 L .78236 .27466 L 1 .273 0 r
F
P
p
.76543 .27224 m .77733 .26983 L .78236 .27466 L 1 .273 0 r
F
P
p
.74839 .26981 m .76543 .27224 L .7536 .27464 L 1 .273 0 r
F
P
p
.73658 .27222 m .74839 .26981 L .7536 .27464 L 1 .273 0 r
F
P
p
.71945 .26978 m .73658 .27222 L .72484 .27461 L 1 .375 0 r
F
P
p
.70773 .27219 m .71945 .26978 L .72484 .27461 L 1 .545 0 r
F
P
p
.6905 .26976 m .70773 .27219 L .69608 .27459 L 0 1 .565 r
F
P
p
.67887 .27217 m .6905 .26976 L .69608 .27459 L 0 .549 1 r
F
P
p
.66156 .26973 m .67887 .27217 L .66731 .27456 L .061 0 1 r
F
P
p
.65002 .27214 m .66156 .26973 L .66731 .27456 L .561 0 1 r
F
P
p
.63261 .26971 m .65002 .27214 L .63855 .27454 L 0 .114 1 r
F
P
p
.62116 .27212 m .63261 .26971 L .63855 .27454 L 0 .102 1 r
F
P
p
.60366 .26968 m .62116 .27212 L .60978 .27451 L 0 1 .868 r
F
P
p
.5923 .27209 m .60366 .26968 L .60978 .27451 L 0 .45 1 r
F
P
p
.57471 .26966 m .5923 .27209 L .58101 .27449 L 0 1 .704 r
F
P
p
.56344 .27207 m .57471 .26966 L .58101 .27449 L 0 1 .825 r
F
P
p
.54576 .26963 m .56344 .27207 L .55224 .27446 L 0 1 .765 r
F
P
p
.53458 .27204 m .54576 .26963 L .55224 .27446 L 0 .977 1 r
F
P
p
.51681 .26961 m .53458 .27204 L .52347 .27444 L 0 .761 1 r
F
P
p
.50572 .27202 m .51681 .26961 L .52347 .27444 L 0 .455 1 r
F
P
p
.48785 .26958 m .50572 .27202 L .49469 .27441 L .159 0 1 r
F
P
p
.47685 .27199 m .48785 .26958 L .49469 .27441 L .5 0 1 r
F
P
p
.45889 .26956 m .47685 .27199 L .46592 .27439 L .5 0 1 r
F
P
p
.44798 .27197 m .45889 .26956 L .46592 .27439 L .534 0 1 r
F
P
p
.42993 .26953 m .44798 .27197 L .43714 .27437 L .836 0 1 r
F
P
p
.41911 .27195 m .42993 .26953 L .43714 .27437 L 1 0 .959 r
F
P
p
.40097 .26951 m .41911 .27195 L .40836 .27434 L .773 0 1 r
F
P
p
.39024 .27192 m .40097 .26951 L .40836 .27434 L .909 0 1 r
F
P
p
.37201 .26948 m .39024 .27192 L .37958 .27432 L .439 0 1 r
F
P
p
.36137 .2719 m .37201 .26948 L .37958 .27432 L .609 0 1 r
F
P
p
.34304 .26946 m .36137 .2719 L .35079 .27429 L 0 .345 1 r
F
P
p
.33249 .27187 m .34304 .26946 L .35079 .27429 L 0 .039 1 r
F
P
p
.31407 .26943 m .33249 .27187 L .32201 .27427 L .895 0 1 r
F
P
p
.30362 .27185 m .31407 .26943 L .32201 .27427 L 1 0 .878 r
F
P
p
.28511 .26941 m .30362 .27185 L .29322 .27424 L 1 0 .136 r
F
P
p
.27474 .27182 m .28511 .26941 L .29322 .27424 L 1 0 .136 r
F
P
p
.25613 .26939 m .27474 .27182 L .26443 .27422 L 1 0 .136 r
F
P
p
.24586 .2718 m .25613 .26939 L .26443 .27422 L 1 0 .136 r
F
P
p
.002 w
.78232 .81852 m .7901 .69037 L .79505 .69257 L p
0 .543 1 r
F P
0 0 0 r
s
P
p
.22716 .26936 m .24586 .2718 L .23564 .27419 L 1 0 .511 r
F
P
p
.21697 .27177 m .22716 .26936 L .23564 .27419 L 1 0 .136 r
F
P
p
.19819 .26934 m .21697 .27177 L .20685 .27417 L 1 0 .136 r
F
P
p
.18809 .27175 m .19819 .26934 L .20685 .27417 L 1 0 .136 r
F
P
p
.16921 .26931 m .18809 .27175 L .17805 .27415 L 1 0 .136 r
F
P
p
.1592 .27172 m .16921 .26931 L .17805 .27415 L 1 0 .136 r
F
P
p
.002 w
.82696 .51224 m .81545 .52685 L .80993 .50537 L p
1 .36 0 r
F P
0 0 0 r
s
P
p
.002 w
.86773 .5054 m .8799 .50232 L .8843 .50569 L p
1 .262 0 r
F P
0 0 0 r
s
P
p
.002 w
.72928 .87365 m .71754 .87417 L .71209 .87312 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.70037 .87365 m .71209 .87312 L .71754 .87417 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.70037 .87365 m .68872 .87417 L .68309 .87312 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67146 .87364 m .68309 .87312 L .68872 .87417 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67146 .87364 m .6599 .87416 L .65408 .87311 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64254 .87364 m .65408 .87311 L .6599 .87416 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.85637 .52526 m .84463 .53597 L .83883 .50538 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.82696 .51224 m .83883 .50538 L .84463 .53597 L p
1 .497 0 r
F P
0 0 0 r
s
P
p
.002 w
.83883 .50538 m .82696 .51224 L .82199 .50369 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.80993 .50537 m .82199 .50369 L .82696 .51224 L p
1 .36 0 r
F P
0 0 0 r
s
P
p
.84736 .26746 m .86413 .26991 L .85196 .27231 L 1 .097 0 r
F
P
p
.8352 .26988 m .84736 .26746 L .85196 .27231 L 1 .131 0 r
F
P
p
.81833 .26743 m .8352 .26988 L .82312 .27229 L 1 .131 0 r
F
P
p
.80626 .26986 m .81833 .26743 L .82312 .27229 L 1 .199 0 r
F
P
p
.7893 .26741 m .80626 .26986 L .79427 .27227 L 1 .273 0 r
F
P
p
.77733 .26983 m .7893 .26741 L .79427 .27227 L 1 .273 0 r
F
P
p
.76027 .26738 m .77733 .26983 L .76543 .27224 L 1 .273 0 r
F
P
p
.74839 .26981 m .76027 .26738 L .76543 .27224 L 1 .273 0 r
F
P
p
.73124 .26736 m .74839 .26981 L .73658 .27222 L 1 .273 0 r
F
P
p
.71945 .26978 m .73124 .26736 L .73658 .27222 L 1 .375 0 r
F
P
p
.70221 .26733 m .71945 .26978 L .70773 .27219 L .057 1 0 r
F
P
p
.6905 .26976 m .70221 .26733 L .70773 .27219 L 0 1 .565 r
F
P
p
.67317 .26731 m .6905 .26976 L .67887 .27217 L 0 .401 1 r
F
P
p
.66156 .26973 m .67317 .26731 L .67887 .27217 L .061 0 1 r
F
P
p
.64414 .26728 m .66156 .26973 L .65002 .27214 L 0 .768 1 r
F
P
p
.63261 .26971 m .64414 .26728 L .65002 .27214 L 0 .114 1 r
F
P
p
.002 w
.65383 .86765 m .64191 .86821 L .63381 .62654 L p
0 .769 1 r
F P
0 0 0 r
s
P
p
.002 w
.63381 .62654 m .63208 .57511 L p
.63549 .621 L 0 .769 1 r
F P
0 0 0 r
s
P
p
.63549 .621 m .65383 .86765 L .63381 .62654 L 0 .769 1 r
F
P
p
.63245 .57461 m .65383 .86765 L .63208 .57511 L 0 .769 1 r
F
P
p
.002 w
.63174 .56481 m .64314 .55766 L .65383 .86765 L p
0 .769 1 r
F P
0 0 0 r
s
P
p
.002 w
.66455 .79387 m .65383 .86765 L .64314 .55766 L p
0 1 .956 r
F P
0 0 0 r
s
P
p
.002 w
.6568 .60705 m .66455 .79387 L p
.6514 .64881 L 0 1 .956 r
F P
0 0 0 r
s
P
p
.002 w
.68004 .67756 m .67045 .79546 L .666 .79426 L p
0 .267 1 r
F P
0 0 0 r
s
P
p
.002 w
.666 .79426 m .66455 .79387 L p
.66712 .77462 L 0 .267 1 r
F P
0 0 0 r
s
P
p
.66712 .77462 m .68004 .67756 L .666 .79426 L 0 .267 1 r
F
P
p
.002 w
.65468 .55615 m .6659 .53269 L .67283 .67465 L p
0 1 .374 r
F P
0 0 0 r
s
P
p
.002 w
.66455 .79387 m .67518 .72289 L .68004 .67756 L p
0 .267 1 r
F P
0 0 0 r
s
P
p
.002 w
.67283 .67465 m .67518 .72289 L p
.67169 .69452 L 0 1 .374 r
F P
0 0 0 r
s
P
p
.65468 .55615 m .67283 .67465 L .67169 .69452 L 0 1 .374 r
F
P
p
.002 w
.67518 .72289 m .66455 .79387 L .65468 .55615 L p
0 1 .374 r
F P
0 0 0 r
s
P
p
.002 w
.65142 .71978 m .66171 .62288 L .66562 .53875 L p
.214 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66562 .53875 m .6659 .53269 L p
.66516 .54236 L .214 1 0 r
F P
0 0 0 r
s
P
p
.65142 .71978 m .66562 .53875 L .66516 .54236 L .214 1 0 r
F
P
p
.002 w
.65468 .55615 m .6568 .60705 L p
.64424 .56988 L 0 1 .956 r
F P
0 0 0 r
s
P
p
.64424 .56988 m .6568 .60705 L .6514 .64881 L 0 1 .956 r
F
P
p
.002 w
.64314 .55766 m .65468 .55615 L p
.64424 .56988 L 0 1 .956 r
F P
0 0 0 r
s
P
p
.002 w
.65468 .55615 m .65142 .71978 L p
.66516 .54236 L .214 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6659 .53269 m .65468 .55615 L p
.66516 .54236 L .214 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64029 .7739 m .65142 .71978 L .65464 .55813 L p
0 1 .394 r
F P
0 0 0 r
s
P
p
.002 w
.65464 .55813 m .65468 .55615 L p
.65453 .55851 L 0 1 .394 r
F P
0 0 0 r
s
P
p
.64029 .7739 m .65464 .55813 L .65453 .55851 L 0 1 .394 r
F
P
p
.002 w
.62119 .64008 m .63174 .56481 L .64191 .86821 L p
0 .476 1 r
F P
0 0 0 r
s
P
p
.002 w
.64191 .86821 m .63007 .86876 L .62119 .64008 L p
0 .476 1 r
F P
0 0 0 r
s
P
p
.002 w
.62872 .79962 m .64029 .7739 L .6431 .56001 L p
0 1 .688 r
F P
0 0 0 r
s
P
p
.002 w
.6431 .56001 m .64314 .55766 L p
.64299 .56017 L 0 1 .688 r
F P
0 0 0 r
s
P
p
.62872 .79962 m .6431 .56001 L .64299 .56017 L 0 1 .688 r
F
P
p
.002 w
.63208 .57511 m .63174 .56481 L p
.63245 .57461 L 0 .769 1 r
F P
0 0 0 r
s
P
p
.002 w
.64314 .55766 m .63174 .56481 L .62872 .79962 L p
0 1 .688 r
F P
0 0 0 r
s
P
p
.002 w
.63007 .86876 m .61831 .86932 L .61121 .68928 L p
0 .15 1 r
F P
0 0 0 r
s
P
p
.002 w
.61121 .68928 m .60988 .65566 L p
.61252 .68355 L 0 .15 1 r
F P
0 0 0 r
s
P
p
.61252 .68355 m .63007 .86876 L .61121 .68928 L 0 .15 1 r
F
P
p
.002 w
.62119 .64008 m .63007 .86876 L p
.61252 .68355 L 0 .15 1 r
F P
0 0 0 r
s
P
p
.002 w
.60988 .65566 m .62119 .64008 L p
.61252 .68355 L 0 .15 1 r
F P
0 0 0 r
s
P
p
.002 w
.62119 .64008 m .62104 .64645 L p
.62317 .63016 L 0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.63174 .56481 m .62119 .64008 L p
.62317 .63016 L 0 .892 1 r
F P
0 0 0 r
s
P
p
.002 w
.62104 .64645 m .61699 .81171 L p
.62891 .61214 L 0 .892 1 r
F P
0 0 0 r
s
P
p
.62891 .61214 m .63174 .56481 L .62104 .64645 L 0 .892 1 r
F
P
p
.002 w
.61699 .81171 m .62872 .79962 L .63174 .56481 L p
0 .892 1 r
F P
0 0 0 r
s
P
p
.6151 .26726 m .63261 .26971 L .62116 .27212 L 0 1 .534 r
F
P
p
.60366 .26968 m .6151 .26726 L .62116 .27212 L 0 1 .868 r
F
P
p
.58605 .26723 m .60366 .26968 L .5923 .27209 L 0 1 .584 r
F
P
p
.57471 .26966 m .58605 .26723 L .5923 .27209 L 0 1 .704 r
F
P
p
.55701 .26721 m .57471 .26966 L .56344 .27207 L 0 1 .477 r
F
P
p
.54576 .26963 m .55701 .26721 L .56344 .27207 L 0 1 .765 r
F
P
p
.52797 .26718 m .54576 .26963 L .53458 .27204 L 0 .852 1 r
F
P
p
.51681 .26961 m .52797 .26718 L .53458 .27204 L 0 .761 1 r
F
P
p
.49892 .26716 m .51681 .26961 L .50572 .27202 L 0 .455 1 r
F
P
p
.48785 .26958 m .49892 .26716 L .50572 .27202 L .159 0 1 r
F
P
p
.46987 .26713 m .48785 .26958 L .47685 .27199 L .248 0 1 r
F
P
p
.45889 .26956 m .46987 .26713 L .47685 .27199 L .5 0 1 r
F
P
p
.44082 .26711 m .45889 .26956 L .44798 .27197 L .568 0 1 r
F
P
p
.42993 .26953 m .44082 .26711 L .44798 .27197 L .836 0 1 r
F
P
p
.41177 .26708 m .42993 .26953 L .41911 .27195 L .768 0 1 r
F
P
p
.40097 .26951 m .41177 .26708 L .41911 .27195 L .773 0 1 r
F
P
p
.38271 .26706 m .40097 .26951 L .39024 .27192 L .077 0 1 r
F
P
p
.37201 .26948 m .38271 .26706 L .39024 .27192 L .439 0 1 r
F
P
p
.35366 .26703 m .37201 .26948 L .36137 .2719 L 0 .618 1 r
F
P
p
.34304 .26946 m .35366 .26703 L .36137 .2719 L 0 .345 1 r
F
P
p
.3246 .26701 m .34304 .26946 L .33249 .27187 L .677 0 1 r
F
P
p
.31407 .26943 m .3246 .26701 L .33249 .27187 L .895 0 1 r
F
P
p
.29554 .26698 m .31407 .26943 L .30362 .27185 L 1 0 .17 r
F
P
p
.28511 .26941 m .29554 .26698 L .30362 .27185 L 1 0 .136 r
F
P
p
.26648 .26696 m .28511 .26941 L .27474 .27182 L 1 0 .511 r
F
P
p
.25613 .26939 m .26648 .26696 L .27474 .27182 L 1 0 .136 r
F
P
p
.23741 .26693 m .25613 .26939 L .24586 .2718 L 1 0 .886 r
F
P
p
.22716 .26936 m .23741 .26693 L .24586 .2718 L 1 0 .511 r
F
P
p
.20835 .26691 m .22716 .26936 L .21697 .27177 L 1 0 .136 r
F
P
p
.19819 .26934 m .20835 .26691 L .21697 .27177 L 1 0 .136 r
F
P
p
.17928 .26688 m .19819 .26934 L .18809 .27175 L 1 0 .43 r
F
P
p
.16921 .26931 m .17928 .26688 L .18809 .27175 L 1 0 .136 r
F
P
p
.15021 .26686 m .16921 .26931 L .1592 .27172 L 1 0 .136 r
F
P
p
.002 w
.86773 .5054 m .85637 .52526 L .85092 .5023 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.83883 .50538 m .85092 .5023 L .85637 .52526 L p
1 .438 0 r
F P
0 0 0 r
s
P
p
.002 w
.8799 .50232 m .89184 .49289 L .89655 .50402 L p
1 .223 0 r
F P
0 0 0 r
s
P
p
.002 w
.8799 .50232 m .86773 .5054 L .8628 .49287 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.002 w
.85092 .5023 m .8628 .49287 L .86773 .5054 L p
1 .302 0 r
F P
0 0 0 r
s
P
p
.002 w
.85092 .5023 m .83883 .50538 L .83413 .50199 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.82199 .50369 m .83413 .50199 L .83883 .50538 L p
1 .292 0 r
F P
0 0 0 r
s
P
p
.002 w
.80574 .52033 m .80993 .50537 L p
.80622 .51863 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.79497 .55884 m .80574 .52033 L p
.80622 .51863 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.80574 .52033 m .80113 .52627 L p
.80525 .52205 L 1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.81753 .50946 m .80574 .52033 L p
.80525 .52205 L 1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.82199 .50369 m .80993 .50537 L .80574 .52033 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.7411 .87313 m .72928 .87365 L .72389 .87259 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.71209 .87312 m .72389 .87259 L .72928 .87365 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.71209 .87312 m .70037 .87365 L .69479 .87259 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68309 .87312 m .69479 .87259 L .70037 .87365 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68309 .87312 m .67146 .87364 L .6657 .87258 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.65408 .87311 m .6657 .87258 L .67146 .87364 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64254 .87364 m .63147 .90583 L .62545 .90498 L p
1 0 .317 r
F P
0 0 0 r
s
P
p
.002 w
.65408 .87311 m .64254 .87364 L .63677 .88518 L p
1 0 .543 r
F P
0 0 0 r
s
P
p
.002 w
.63677 .88518 m .64254 .87364 L p
.62905 .89838 L 1 0 .317 r
F P
0 0 0 r
s
P
p
.002 w
.63677 .88518 m .63058 .8715 L p
.64452 .87193 L 1 0 .543 r
F P
0 0 0 r
s
P
p
.002 w
.64819 .87204 m .63677 .88518 L p
.64452 .87193 L 1 0 .543 r
F P
0 0 0 r
s
P
p
.002 w
.62545 .90498 m .63677 .88518 L p
.62905 .89838 L 1 0 .317 r
F P
0 0 0 r
s
P
p
.002 w
.65468 .55615 m .64314 .55766 L .64029 .7739 L p
0 1 .394 r
F P
0 0 0 r
s
P
p
.002 w
.75455 .6414 m .74311 .65693 L .74368 .86766 L p
0 .247 1 r
F P
0 0 0 r
s
P
p
.002 w
.73576 .87206 m .72389 .87259 L .72232 .86042 L p
.527 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.72232 .86042 m .7172 .82061 L p
.72346 .83796 L .527 0 1 r
F P
0 0 0 r
s
P
p
.72346 .83796 m .73576 .87206 L .72232 .86042 L .527 0 1 r
F
P
p
.002 w
.70657 .87205 m .7172 .82061 L .72389 .87259 L p
1 0 .768 r
F P
0 0 0 r
s
P
p
.002 w
.7172 .82061 m .70657 .87205 L .70098 .87098 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.002 w
.70098 .87098 m .71169 .81921 L .7172 .82061 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.002 w
.7236 .8185 m .71169 .81921 L .70729 .86933 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.002 w
.70729 .86933 m .71934 .86878 L .7236 .8185 L p
1 0 .948 r
F P
0 0 0 r
s
P
p
.002 w
.7236 .8185 m .71934 .86878 L p
.72792 .74959 L .595 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.73218 .69035 m .72702 .76746 L p
.72792 .74959 L .595 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.72702 .76746 m .7236 .8185 L p
.72792 .74959 L .595 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.74311 .65693 m .73218 .69035 L .73147 .86822 L p
.02 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.73147 .86822 m .74368 .86766 L .74311 .65693 L p
.02 0 1 r
F P
0 0 0 r
s
P
p
.84736 .26746 m .85959 .26502 L .86413 .26991 L 1 .097 0 r
F
P
p
.83047 .26499 m .84736 .26746 L .8352 .26988 L 1 .068 0 r
F
P
p
.81833 .26743 m .83047 .26499 L .8352 .26988 L 1 .131 0 r
F
P
p
.80136 .26497 m .81833 .26743 L .80626 .26986 L 1 .233 0 r
F
P
p
.7893 .26741 m .80136 .26497 L .80626 .26986 L 1 .273 0 r
F
P
p
.77223 .26494 m .7893 .26741 L .77733 .26983 L 1 .273 0 r
F
P
p
.76027 .26738 m .77223 .26494 L .77733 .26983 L 1 .273 0 r
F
P
p
.74311 .26492 m .76027 .26738 L .74839 .26981 L 1 .273 0 r
F
P
p
.73124 .26736 m .74311 .26492 L .74839 .26981 L 1 .273 0 r
F
P
p
.71399 .26489 m .73124 .26736 L .71945 .26978 L .534 1 0 r
F
P
p
.70221 .26733 m .71399 .26489 L .71945 .26978 L .057 1 0 r
F
P
p
.68486 .26487 m .70221 .26733 L .6905 .26976 L 0 1 .906 r
F
P
p
.67317 .26731 m .68486 .26487 L .6905 .26976 L 0 .401 1 r
F
P
p
.65573 .26484 m .67317 .26731 L .66156 .26973 L 0 1 .255 r
F
P
p
.64414 .26728 m .65573 .26484 L .66156 .26973 L 0 .768 1 r
F
P
p
.6266 .26482 m .64414 .26728 L .63261 .26971 L 0 1 .352 r
F
P
p
.6151 .26726 m .6266 .26482 L .63261 .26971 L 0 1 .534 r
F
P
p
.59747 .26479 m .6151 .26726 L .60366 .26968 L 0 1 .352 r
F
P
p
.58605 .26723 m .59747 .26479 L .60366 .26968 L 0 1 .584 r
F
P
p
.56833 .26477 m .58605 .26723 L .57471 .26966 L 0 1 .238 r
F
P
p
.55701 .26721 m .56833 .26477 L .57471 .26966 L 0 1 .477 r
F
P
p
.5392 .26474 m .55701 .26721 L .54576 .26963 L 0 1 .868 r
F
P
p
.52797 .26718 m .5392 .26474 L .54576 .26963 L 0 .852 1 r
F
P
p
.51006 .26472 m .52797 .26718 L .51681 .26961 L 0 .727 1 r
F
P
p
.49892 .26716 m .51006 .26472 L .51681 .26961 L 0 .455 1 r
F
P
p
.48092 .26469 m .49892 .26716 L .48785 .26958 L 0 .366 1 r
F
P
p
.46987 .26713 m .48092 .26469 L .48785 .26958 L .248 0 1 r
F
P
p
.45178 .26467 m .46987 .26713 L .45889 .26956 L .5 0 1 r
F
P
p
.44082 .26711 m .45178 .26467 L .45889 .26956 L .568 0 1 r
F
P
p
.42263 .26464 m .44082 .26711 L .42993 .26953 L .666 0 1 r
F
P
p
.41177 .26708 m .42263 .26464 L .42993 .26953 L .768 0 1 r
F
P
p
.39349 .26462 m .41177 .26708 L .40097 .26951 L 0 .114 1 r
F
P
p
.38271 .26706 m .39349 .26462 L .40097 .26951 L .077 0 1 r
F
P
p
.36434 .26459 m .38271 .26706 L .37201 .26948 L 0 .618 1 r
F
P
p
.35366 .26703 m .36434 .26459 L .37201 .26948 L 0 .618 1 r
F
P
p
.33519 .26457 m .35366 .26703 L .34304 .26946 L .623 0 1 r
F
P
p
.3246 .26701 m .33519 .26457 L .34304 .26946 L .677 0 1 r
F
P
p
.30604 .26454 m .3246 .26701 L .31407 .26943 L 1 0 .537 r
F
P
p
.29554 .26698 m .30604 .26454 L .31407 .26943 L 1 0 .17 r
F
P
p
.27689 .26452 m .29554 .26698 L .28511 .26941 L 1 0 .886 r
F
P
p
.26648 .26696 m .27689 .26452 L .28511 .26941 L 1 0 .511 r
F
P
p
.24773 .26449 m .26648 .26696 L .25613 .26939 L 1 0 .886 r
F
P
p
.23741 .26693 m .24773 .26449 L .25613 .26939 L 1 0 .886 r
F
P
p
.21857 .26447 m .23741 .26693 L .22716 .26936 L 1 0 .886 r
F
P
p
.20835 .26691 m .21857 .26447 L .22716 .26936 L 1 0 .136 r
F
P
p
.18942 .26444 m .20835 .26691 L .19819 .26934 L 1 0 .805 r
F
P
p
.17928 .26688 m .18942 .26444 L .19819 .26934 L 1 0 .43 r
F
P
p
.002 w
.75514 .83905 m .75513 .83375 L p
.74376 .86585 L 0 .247 1 r
F P
0 0 0 r
s
P
p
.002 w
.75513 .83375 m .75455 .6414 L p
.74433 .85413 L 0 .247 1 r
F P
0 0 0 r
s
P
p
.74376 .86585 m .75513 .83375 L .74433 .85413 L 0 .247 1 r
F
P
p
.002 w
.7422 .57321 m .75378 .56035 L .76661 .81208 L p
0 .983 1 r
F P
0 0 0 r
s
P
p
.002 w
.76661 .81208 m .76671 .81417 L p
.76652 .81225 L 0 .983 1 r
F P
0 0 0 r
s
P
p
.7422 .57321 m .76661 .81208 L .76652 .81225 L 0 .983 1 r
F
P
p
.002 w
.75514 .83905 m .7422 .57321 L p
.76652 .81225 L 0 .983 1 r
F P
0 0 0 r
s
P
p
.002 w
.76671 .81417 m .75514 .83905 L p
.76652 .81225 L 0 .983 1 r
F P
0 0 0 r
s
P
p
.002 w
.74368 .86766 m .75514 .83905 L p
.74376 .86585 L 0 .247 1 r
F P
0 0 0 r
s
P
p
.002 w
.71934 .86878 m .73147 .86822 L .73218 .69035 L p
.595 0 1 r
F P
0 0 0 r
s
P
p
.16025 .26442 m .17928 .26688 L .16921 .26931 L 1 0 .43 r
F
P
p
.15021 .26686 m .16025 .26442 L .16921 .26931 L 1 0 .136 r
F
P
p
.002 w
.89184 .49289 m .8799 .50232 L .87466 .482 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.8628 .49287 m .87466 .482 L .8799 .50232 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.002 w
.8628 .49287 m .85092 .5023 L .84595 .49112 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.002 w
.83413 .50199 m .84595 .49112 L .85092 .5023 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.83413 .50199 m .82199 .50369 L .81753 .50946 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.80574 .52033 m .81753 .50946 L .82199 .50369 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.75298 .8726 m .7411 .87313 L .73576 .87206 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.72389 .87259 m .73576 .87206 L .7411 .87313 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.72389 .87259 m .71209 .87312 L .70657 .87205 L p
1 0 .768 r
F P
0 0 0 r
s
P
p
.002 w
.69479 .87259 m .70657 .87205 L .71209 .87312 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.69479 .87259 m .68309 .87312 L .67738 .87205 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.6657 .87258 m .67738 .87205 L .68309 .87312 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.6657 .87258 m .65408 .87311 L .64819 .87204 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63677 .88518 m .64819 .87204 L .65408 .87311 L p
1 0 .543 r
F P
0 0 0 r
s
P
p
.002 w
.70048 .81634 m .68902 .84098 L .68004 .67756 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.68004 .67756 m .69162 .66698 L .70048 .81634 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.67045 .79546 m .68004 .67756 L .68902 .84098 L p
.391 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.69162 .66698 m .68004 .67756 L .67518 .72289 L p
0 1 .78 r
F P
0 0 0 r
s
P
p
.002 w
.68563 .65077 m .67518 .72289 L .6659 .53269 L p
.209 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6659 .53269 m .67756 .53108 L .68563 .65077 L p
.209 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67756 .53108 m .6659 .53269 L .66171 .62288 L p
.99 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59908 .7269 m .60988 .65566 L .61831 .86932 L p
.156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61831 .86932 m .60662 .86986 L .59908 .7269 L p
.156 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62119 .64008 m .60988 .65566 L .60537 .83057 L p
0 .465 1 r
F P
0 0 0 r
s
P
p
.002 w
.58826 .81537 m .59908 .7269 L .60662 .86986 L p
.723 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60662 .86986 m .59501 .87041 L .58826 .81537 L p
.723 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58826 .81537 m .59501 .87041 L p
.58148 .86999 L 1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.58826 .81537 m .5822 .86819 L p
.59499 .76109 L .723 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59908 .7269 m .58826 .81537 L p
.59499 .76109 L .723 0 1 r
F P
0 0 0 r
s
P
p
.57724 .86986 m .58826 .81537 L .58148 .86999 L 1 0 .776 r
F
P
p
.002 w
.57705 .86986 m .5784 .8633 L p
.57724 .86986 L 1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.5784 .8633 m .58826 .81537 L p
.57724 .86986 L 1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.60988 .65566 m .59908 .7269 L .59818 .75153 L p
.031 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59564 .82065 m .59392 .86763 L p
.59708 .82571 L .031 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59392 .86763 m .60537 .83057 L .60988 .65566 L p
.031 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5822 .86819 m .59392 .86763 L .59908 .7269 L p
.723 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.61285 .87096 m .60129 .8715 L .59501 .87041 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.60129 .8715 m .59004 .90411 L .58347 .87095 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.58347 .87095 m .59501 .87041 L .60129 .8715 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.59501 .87041 m .60662 .86986 L .61285 .87096 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.59501 .87041 m .58347 .87095 L .57705 .86986 L p
1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.57216 .90367 m .58347 .87095 L .59004 .90411 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.002 w
.58347 .87095 m .57216 .90367 L .56553 .8704 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.56553 .8704 m .57705 .86986 L .58347 .87095 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.59392 .86763 m .5822 .86819 L .57573 .88008 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.57573 .88008 m .58753 .87955 L .59392 .86763 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.60537 .83057 m .59392 .86763 L .58753 .87955 L p
1 0 .637 r
F P
0 0 0 r
s
P
p
.002 w
.58753 .87955 m .59938 .87516 L .60315 .84712 L p
1 0 .637 r
F P
0 0 0 r
s
P
p
.002 w
.60315 .84712 m .60537 .83057 L p
.60148 .84125 L 1 0 .637 r
F P
0 0 0 r
s
P
p
.58753 .87955 m .60315 .84712 L .60148 .84125 L 1 0 .637 r
F
P
p
.002 w
.59818 .75153 m .59564 .82065 L p
.60598 .7074 L .031 0 1 r
F P
0 0 0 r
s
P
p
.59708 .82571 m .60598 .7074 L .59564 .82065 L .031 0 1 r
F
P
p
.60598 .7074 m .60988 .65566 L .59818 .75153 L .031 0 1 r
F
P
p
.84269 .26254 m .85959 .26502 L .84736 .26746 L 1 .034 0 r
F
P
p
.83047 .26499 m .84269 .26254 L .84736 .26746 L 1 .068 0 r
F
P
p
.81348 .26251 m .83047 .26499 L .81833 .26743 L 1 .165 0 r
F
P
p
.80136 .26497 m .81348 .26251 L .81833 .26743 L 1 .233 0 r
F
P
p
.78427 .26249 m .80136 .26497 L .7893 .26741 L 1 .239 0 r
F
P
p
.77223 .26494 m .78427 .26249 L .7893 .26741 L 1 .273 0 r
F
P
p
.75506 .26246 m .77223 .26494 L .76027 .26738 L 1 .273 0 r
F
P
p
.74311 .26492 m .75506 .26246 L .76027 .26738 L 1 .273 0 r
F
P
p
.72584 .26244 m .74311 .26492 L .73124 .26736 L .977 1 0 r
F
P
p
.71399 .26489 m .72584 .26244 L .73124 .26736 L .534 1 0 r
F
P
p
.69662 .26241 m .71399 .26489 L .70221 .26733 L 0 1 .386 r
F
P
p
.68486 .26487 m .69662 .26241 L .70221 .26733 L 0 1 .906 r
F
P
p
.6674 .26239 m .68486 .26487 L .67317 .26731 L .386 1 0 r
F
P
p
.65573 .26484 m .6674 .26239 L .67317 .26731 L 0 1 .255 r
F
P
p
.63818 .26236 m .65573 .26484 L .64414 .26728 L .33 1 0 r
F
P
p
.6266 .26482 m .63818 .26236 L .64414 .26728 L 0 1 .352 r
F
P
p
.60895 .26234 m .6266 .26482 L .6151 .26726 L 0 1 .114 r
F
P
p
.59747 .26479 m .60895 .26234 L .6151 .26726 L 0 1 .352 r
F
P
p
.57973 .26231 m .59747 .26479 L .58605 .26723 L 0 1 .058 r
F
P
p
.56833 .26477 m .57973 .26231 L .58605 .26723 L 0 1 .238 r
F
P
p
.5505 .26229 m .56833 .26477 L .55701 .26721 L 0 1 .523 r
F
P
p
.5392 .26474 m .5505 .26229 L .55701 .26721 L 0 1 .868 r
F
P
p
.002 w
.53805 .90496 m .52682 .90539 L .52016 .88516 L p
1 0 .286 r
F P
0 0 0 r
s
P
p
.002 w
.50891 .90496 m .52016 .88516 L .52682 .90539 L closepath p
1 0 .205 r
F P
0 0 0 r
s
P
p
.52127 .26226 m .5392 .26474 L .52797 .26718 L 0 .727 1 r
F
P
p
.51006 .26472 m .52127 .26226 L .52797 .26718 L 0 .727 1 r
F
P
p
.49204 .26223 m .51006 .26472 L .49892 .26716 L 0 .727 1 r
F
P
p
.48092 .26469 m .49204 .26223 L .49892 .26716 L 0 .366 1 r
F
P
p
.4628 .26221 m .48092 .26469 L .46987 .26713 L .248 0 1 r
F
P
p
.45178 .26467 m .4628 .26221 L .46987 .26713 L .5 0 1 r
F
P
p
.43357 .26218 m .45178 .26467 L .44082 .26711 L .534 0 1 r
F
P
p
.42263 .26464 m .43357 .26218 L .44082 .26711 L .666 0 1 r
F
P
p
.40433 .26216 m .42263 .26464 L .41177 .26708 L 0 .114 1 r
F
P
p
.39349 .26462 m .40433 .26216 L .41177 .26708 L 0 .114 1 r
F
P
p
.37509 .26213 m .39349 .26462 L .38271 .26706 L 0 .673 1 r
F
P
p
.36434 .26459 m .37509 .26213 L .38271 .26706 L 0 .618 1 r
F
P
p
.34585 .26211 m .36434 .26459 L .35366 .26703 L .568 0 1 r
F
P
p
.33519 .26457 m .34585 .26211 L .35366 .26703 L .623 0 1 r
F
P
p
.002 w
.87466 .482 m .88701 .48023 L .89184 .49289 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.31661 .26208 m .33519 .26457 L .3246 .26701 L 1 0 .878 r
F
P
p
.30604 .26454 m .31661 .26208 L .3246 .26701 L 1 0 .537 r
F
P
p
.002 w
.87466 .482 m .8628 .49287 L .8582 .48868 L p
1 .066 0 r
F P
0 0 0 r
s
P
p
.002 w
.84595 .49112 m .8582 .48868 L .8628 .49287 L p
1 .163 0 r
F P
0 0 0 r
s
P
p
.28736336 206 m .30604 .26454 L .29554 .26698 L 1 0 .92 r
F
P
p
.27689 .26452 m .28736336 206 L .29554 .26698 L 1 0 .886 r
F
P
p
.25811 .26203 m .27689 .26452 L .26648 .26696 L .739 0 1 r
F
P
p
.24773 .26449 m .25811 .26203 L .26648 .26696 L 1 0 .886 r
F
P
p
.22887 .26201 m .24773 .26449 L .23741 .26693 L .364 0 1 r
F
P
p
.21857 .26447 m .22887 .26201 L .23741 .26693 L 1 0 .886 r
F
P
p
.19961 .26198 m .21857 .26447 L .20835 .26691 L 1 0 .886 r
F
P
p
.18942 .26444 m .19961 .26198 L .20835 .26691 L 1 0 .805 r
F
P
p
.17036 .26196 m .18942 .26444 L .17928 .26688 L .902 0 1 r
F
P
p
.16025 .26442 m .17036 .26196 L .17928 .26688 L 1 0 .43 r
F
P
p
.14111 .26193 m .16025 .26442 L .15021 .26686 L 1 0 .136 r
F
P
p
.002 w
.60537 .83057 m .61699 .81171 L .62119 .64008 L p
0 .465 1 r
F P
0 0 0 r
s
P
p
.002 w
.7315 .61745 m .7422 .57321 L .75514 .83905 L p
0 .604 1 r
F P
0 0 0 r
s
P
p
.002 w
.75378 .56035 m .7422 .57321 L .73654 .55881 L p
.867 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7422 .57321 m .7315 .61745 L .72466 .56033 L p
.668 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72466 .56033 m .73654 .55881 L .7422 .57321 L p
.668 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7315 .61745 m .72087 .66699 L .71312 .5732 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71312 .5732 m .72466 .56033 L .7315 .61745 L p
.293 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70314 .65202 m .71312 .5732 L .72087 .66699 L p
0 1 .398 r
F P
0 0 0 r
s
P
p
.002 w
.72466 .56033 m .71312 .5732 L .7076 .57022 L p
.825 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71312 .5732 m .70314 .65202 L .69693 .6234 L p
.269 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69693 .6234 m .7076 .57022 L .71312 .5732 L p
.269 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.84595 .49112 m .83413 .50199 L .82938 .49856 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.81753 .50946 m .82938 .49856 L .83413 .50199 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.73576 .87206 m .74771 .87152 L .75298 .8726 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.70657 .87205 m .69479 .87259 L .68915 .87151 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67738 .87205 m .68915 .87151 L .69479 .87259 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67738 .87205 m .6657 .87258 L .65986 .87151 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64819 .87204 m .65986 .87151 L .6657 .87258 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.88701 .48023 m .87466 .482 L .87015 .47843 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.8582 .48868 m .87015 .47843 L .87466 .482 L p
1 .066 0 r
F P
0 0 0 r
s
P
p
.002 w
.69693 .6234 m .68563 .65077 L .67756 .53108 L p
.571 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67756 .53108 m .68922 .52593 L .69693 .6234 L p
.571 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68922 .52593 m .67756 .53108 L .67173 .52428 L p
1 .587 0 r
F P
0 0 0 r
s
P
p
.002 w
.66171 .62288 m .67173 .52428 L .67756 .53108 L p
.99 1 0 r
F P
0 0 0 r
s
P
p
.84269 .26254 m .85499 .26007 L .85959 .26502 L 1 .034 0 r
F
P
p
.82569 .26004 m .84269 .26254 L .83047 .26499 L 1 .131 0 r
F
P
p
.81348 .26251 m .82569 .26004 L .83047 .26499 L 1 .165 0 r
F
P
p
.79638 .26002 m .81348 .26251 L .80136 .26497 L 1 .136 0 r
F
P
p
.78427 .26249 m .79638 .26002 L .80136 .26497 L 1 .239 0 r
F
P
p
.76708 .25999 m .78427 .26249 L .77223 .26494 L 1 .273 0 r
F
P
p
.75506 .26246 m .76708 .25999 L .77223 .26494 L 1 .273 0 r
F
P
p
.002 w
.77597 .71778 m .76671 .81417 L .75378 .56035 L p
0 1 .556 r
F P
0 0 0 r
s
P
p
.002 w
.76576 .55883 m .75378 .56035 L .74851 .55728 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.73654 .55881 m .74851 .55728 L .75378 .56035 L p
.867 1 0 r
F P
0 0 0 r
s
P
p
.73777 .25997 m .75506 .26246 L .74311 .26492 L 1 .58 0 r
F
P
p
.72584 .26244 m .73777 .25997 L .74311 .26492 L .977 1 0 r
F
P
p
.002 w
.73654 .55881 m .72466 .56033 L .7192 .55726 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7076 .57022 m .7192 .55726 L .72466 .56033 L p
.825 1 0 r
F P
0 0 0 r
s
P
p
.70846 .25994 m .72584 .26244 L .71399 .26489 L 0 1 .011 r
F
P
p
.69662 .26241 m .70846 .25994 L .71399 .26489 L 0 1 .386 r
F
P
p
.67914 .25991 m .69662 .26241 L .68486 .26487 L .807 1 0 r
F
P
p
.6674 .26239 m .67914 .25991 L .68486 .26487 L .386 1 0 r
F
P
p
.64983 .25989 m .6674 .26239 L .65573 .26484 L 1 .92 0 r
F
P
p
.63818 .26236 m .64983 .25989 L .65573 .26484 L .33 1 0 r
F
P
p
.002 w
.63677 .88518 m .62545 .90498 L .61936 .90411 L p
1 0 .317 r
F P
0 0 0 r
s
P
p
.62051 .25986 m .63818 .26236 L .6266 .26482 L .534 1 0 r
F
P
p
.60895 .26234 m .62051 .25986 L .6266 .26482 L 0 1 .114 r
F
P
p
.59119 .25984 m .60895 .26234 L .59747 .26479 L .196 1 0 r
F
P
p
.57973 .26231 m .59119 .25984 L .59747 .26479 L 0 1 .058 r
F
P
p
.56187 .25981 m .57973 .26231 L .56833 .26477 L 0 1 .273 r
F
P
p
.5505 .26229 m .56187 .25981 L .56833 .26477 L 0 1 .523 r
F
P
p
.002 w
.54935 .90453 m .53805 .90496 L .53141 .88095 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.52016 .88516 m .53141 .88095 L p
.52307 .88839 L 1 0 .286 r
F P
0 0 0 r
s
P
p
.002 w
.53141 .88095 m .52016 .88516 L .51622 .88458 L p
1 0 .422 r
F P
0 0 0 r
s
P
p
.002 w
.51622 .88458 m .51338 .88417 L p
.52091 .88282 L 1 0 .422 r
F P
0 0 0 r
s
P
p
.52091 .88282 m .53141 .88095 L .51622 .88458 L 1 0 .422 r
F
P
p
.002 w
.51338 .88417 m .52468 .88367 L .53141 .88095 L p
1 0 .422 r
F P
0 0 0 r
s
P
p
.002 w
.53141 .88095 m .52468 .88367 L p
.53979 .87346 L 1 0 .48 r
F P
0 0 0 r
s
P
p
.002 w
.54271 .87149 m .53141 .88095 L p
.53979 .87346 L 1 0 .48 r
F P
0 0 0 r
s
P
p
.002 w
.53141 .88095 m .53805 .90496 L p
.52307 .88839 L 1 0 .286 r
F P
0 0 0 r
s
P
p
.002 w
.53141 .88095 m .54271 .87149 L .54935 .90453 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.52468 .88367 m .53605 .87941 L .53884 .87609 L p
1 0 .48 r
F P
0 0 0 r
s
P
p
.002 w
.53884 .87609 m .54271 .87149 L p
.53222 .87858 L 1 0 .48 r
F P
0 0 0 r
s
P
p
.52468 .88367 m .53884 .87609 L .53222 .87858 L 1 0 .48 r
F
P
p
.53255 .25979 m .5505 .26229 L .5392 .26474 L 0 .909 1 r
F
P
p
.52127 .26226 m .53255 .25979 L .5392 .26474 L 0 .727 1 r
F
P
p
.002 w
.52016 .88516 m .50891 .90496 L .50207 .90409 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.50323 .25976 m .52127 .26226 L .51006 .26472 L 0 .727 1 r
F
P
p
.49204 .26223 m .50323 .25976 L .51006 .26472 L 0 .727 1 r
F
P
p
.4739 .25974 m .49204 .26223 L .48092 .26469 L 0 .059 1 r
F
P
p
.4628 .26221 m .4739 .25974 L .48092 .26469 L .248 0 1 r
F
P
p
.44457 .25971 m .4628 .26221 L .45178 .26467 L .248 0 1 r
F
P
p
.43357 .26218 m .44457 .25971 L .45178 .26467 L .534 0 1 r
F
P
p
.41524 .25969 m .43357 .26218 L .42263 .26464 L 0 .114 1 r
F
P
p
.40433 .26216 m .41524 .25969 L .42263 .26464 L 0 .114 1 r
F
P
p
.38591 .25966 m .40433 .26216 L .39349 .26462 L 0 .727 1 r
F
P
p
.37509 .26213 m .38591 .25966 L .39349 .26462 L 0 .673 1 r
F
P
p
.35658 .25963 m .37509 .26213 L .36434 .26459 L .568 0 1 r
F
P
p
.34585 .26211 m .35658 .25963 L .36434 .26459 L .568 0 1 r
F
P
p
.32724 .25961 m .34585 .26211 L .33519 .26457 L 1 0 .886 r
F
P
p
.31661 .26208 m .32724 .25961 L .33519 .26457 L 1 0 .878 r
F
P
p
.2979 .25958 m .31661 .26208 L .30604 .26454 L .713 0 1 r
F
P
p
.28736336 206 m .2979 .25958 L .30604 .26454 L 1 0 .92 r
F
P
p
.002 w
.8582 .48868 m .84595 .49112 L .84126 .48761 L p
1 .134 0 r
F P
0 0 0 r
s
P
p
.002 w
.82938 .49856 m .84126 .48761 L .84595 .49112 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.26856 .25956 m .28736336 206 L .27689 .26452 L .364 0 1 r
F
P
p
.25811 .26203 m .26856 .25956 L .27689 .26452 L .739 0 1 r
F
P
p
.23922 .25953 m .25811 .26203 L .24773 .26449 L .364 0 1 r
F
P
p
.22887 .26201 m .23922 .25953 L .24773 .26449 L .364 0 1 r
F
P
p
.20988 .25951 m .22887 .26201 L .21857 .26447 L .739 0 1 r
F
P
p
.19961 .26198 m .20988 .25951 L .21857 .26447 L 1 0 .886 r
F
P
p
.18053 .25948 m .19961 .26198 L .18942 .26444 L .445 0 1 r
F
P
p
.17036 .26196 m .18053 .25948 L .18942 .26444 L .902 0 1 r
F
P
p
.15119 .25946 m .17036 .26196 L .16025 .26442 L 1 0 .43 r
F
P
p
.14111 .26193 m .15119 .25946 L .16025 .26442 L 1 0 .136 r
F
P
p
.002 w
.61936 .90411 m .63058 .8715 L .63677 .88518 L p
1 0 .317 r
F P
0 0 0 r
s
P
p
.002 w
.50207 .90409 m .51338 .88417 L .52016 .88516 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.75514 .83905 m .74368 .86766 L .7315 .61745 L p
0 .604 1 r
F P
0 0 0 r
s
P
p
.002 w
.72087 .66699 m .7315 .61745 L .74368 .86766 L p
0 .174 1 r
F P
0 0 0 r
s
P
p
.002 w
.7076 .57022 m .69693 .6234 L .68922 .52593 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68922 .52593 m .70088 .51861 L .7076 .57022 L p
.888 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70088 .51861 m .68922 .52593 L .68321 .50769 L p
1 .464 0 r
F P
0 0 0 r
s
P
p
.002 w
.67173 .52428 m .68321 .50769 L .68922 .52593 L p
1 .587 0 r
F P
0 0 0 r
s
P
p
.002 w
.68915 .87151 m .70098 .87098 L .70657 .87205 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68915 .87151 m .67738 .87205 L .67161 .87097 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.65986 .87151 m .67161 .87097 L .67738 .87205 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.65986 .87151 m .64819 .87204 L .64223 .87096 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63058 .8715 m .64223 .87096 L .64819 .87204 L p
1 0 .543 r
F P
0 0 0 r
s
P
p
.002 w
.87015 .47843 m .88257 .47664 L .88701 .48023 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.83797 .25756 m .85499 .26007 L .84269 .26254 L 1 .063 0 r
F
P
p
.82569 .26004 m .83797 .25756 L .84269 .26254 L 1 .131 0 r
F
P
p
.002 w
.82938 .49856 m .81753 .50946 L .81229 .49682 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.80113 .52627 m .81229 .49682 L .81753 .50946 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.80857 .25753 m .82569 .26004 L .81348 .26251 L 1 .068 0 r
F
P
p
.79638 .26002 m .80857 .25753 L .81348 .26251 L 1 .136 0 r
F
P
p
.002 w
.79497 .55884 m .78642 .66342 L .77781 .5573 L p
.534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.77781 .5573 m .78995 .55576 L .79497 .55884 L p
.534 1 0 r
F P
0 0 0 r
s
P
p
.77917 .2575 m .79638 .26002 L .78427 .26249 L 1 .205 0 r
F
P
p
.76708 .25999 m .77917 .2575 L .78427 .26249 L 1 .273 0 r
F
P
p
.002 w
.77781 .5573 m .76576 .55883 L .75968 .52788 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.74851 .55728 m .75968 .52788 L .76576 .55883 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.74977 .25748 m .76708 .25999 L .75506 .26246 L 1 .273 0 r
F
P
p
.73777 .25997 m .74977 .25748 L .75506 .26246 L 1 .58 0 r
F
P
p
.002 w
.74851 .55728 m .73654 .55881 L .73114 .55572 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.7192 .55726 m .73114 .55572 L .73654 .55881 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.72037 .25745 m .73777 .25997 L .72584 .26244 L .568 1 0 r
F
P
p
.70846 .25994 m .72037 .25745 L .72584 .26244 L 0 1 .011 r
F
P
p
.69096 .25743 m .70846 .25994 L .69662 .26241 L .977 1 0 r
F
P
p
.67914 .25991 m .69096 .25743 L .69662 .26241 L .807 1 0 r
F
P
p
.66155 .2574 m .67914 .25991 L .6674 .26239 L 1 .545 0 r
F
P
p
.64983 .25989 m .66155 .2574 L .6674 .26239 L 1 .92 0 r
F
P
p
.63214 .25738 m .64983 .25989 L .63818 .26236 L 1 .682 0 r
F
P
p
.62051 .25986 m .63214 .25738 L .63818 .26236 L .534 1 0 r
F
P
p
.002 w
.61936 .90411 m .6078 .90454 L .60129 .8715 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.59004 .90411 m .60129 .8715 L .6078 .90454 L closepath p
1 0 .249 r
F P
0 0 0 r
s
P
p
.60273 .25735 m .62051 .25986 L .60895 .26234 L .432 1 0 r
F
P
p
.59119 .25984 m .60273 .25735 L .60895 .26234 L .196 1 0 r
F
P
p
.57332 .25733 m .59119 .25984 L .57973 .26231 L .044 1 0 r
F
P
p
.56187 .25981 m .57332 .25733 L .57973 .26231 L 0 1 .273 r
F
P
p
.002 w
.56072 .9041 m .54935 .90453 L .54271 .87149 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.5439 .2573 m .56187 .25981 L .5505 .26229 L 0 1 .587 r
F
P
p
.53255 .25979 m .5439 .2573 L .5505 .26229 L 0 .909 1 r
F
P
p
.51449 .25727 m .53255 .25979 L .52127 .26226 L 0 .727 1 r
F
P
p
.50323 .25976 m .51449 .25727 L .52127 .26226 L 0 .727 1 r
F
P
p
.48507 .25725 m .50323 .25976 L .49204 .26223 L 0 .366 1 r
F
P
p
.4739 .25974 m .48507 .25725 L .49204 .26223 L 0 .059 1 r
F
P
p
.45565 .25722 m .4739 .25974 L .4628 .26221 L 0 .005 1 r
F
P
p
.44457 .25971 m .45565 .25722 L .4628 .26221 L .248 0 1 r
F
P
p
.42622 .2572 m .44457 .25971 L .43357 .26218 L 0 .114 1 r
F
P
p
.41524 .25969 m .42622 .2572 L .43357 .26218 L 0 .114 1 r
F
P
p
.3968 .25717 m .41524 .25969 L .40433 .26216 L 0 .727 1 r
F
P
p
.38591 .25966 m .3968 .25717 L .40433 .26216 L 0 .727 1 r
F
P
p
.002 w
.87015 .47843 m .8582 .48868 L .8536 .48585 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.8536 .48585 m .8582 .48868 L p
.84257 .4877 L 1 .134 0 r
F P
0 0 0 r
s
P
p
.002 w
.8536 .48585 m .84932 .49158 L p
.86471 .48399 L 1 .197 0 r
F P
0 0 0 r
s
P
p
.002 w
.86599 .48336 m .8536 .48585 L p
.86471 .48399 L 1 .197 0 r
F P
0 0 0 r
s
P
p
.002 w
.84126 .48761 m .8536 .48585 L p
.84257 .4877 L 1 .134 0 r
F P
0 0 0 r
s
P
p
.36737 .25715 m .38591 .25966 L .37509 .26213 L .534 0 1 r
F
P
p
.35658 .25963 m .36737 .25715 L .37509 .26213 L .568 0 1 r
F
P
p
.33794 .25712 m .35658 .25963 L .34585 .26211 L 1 0 .886 r
F
P
p
.32724 .25961 m .33794 .25712 L .34585 .26211 L 1 0 .886 r
F
P
p
.30851 .25709 m .32724 .25961 L .31661 .26208 L .372 0 1 r
F
P
p
.2979 .25958 m .30851 .25709 L .31661 .26208 L .713 0 1 r
F
P
p
.27908 .25707 m .2979 .25958 L .28736336 206 L .364 0 1 r
F
P
p
.26856 .25956 m .27908 .25707 L .28736336 206 L .364 0 1 r
F
P
p
.24964 .25704 m .26856 .25956 L .25811 .26203 L .364 0 1 r
F
P
p
.23922 .25953 m .24964 .25704 L .25811 .26203 L .364 0 1 r
F
P
p
.22021 .25702 m .23922 .25953 L .22887 .26201 L .364 0 1 r
F
P
p
.20988 .25951 m .22021 .25702 L .22887 .26201 L .739 0 1 r
F
P
p
.19077 .25699 m .20988 .25951 L .19961 .26198 L .364 0 1 r
F
P
p
.18053 .25948 m .19077 .25699 L .19961 .26198 L .445 0 1 r
F
P
p
.16133 .25697 m .18053 .25948 L .17036 .26196 L .829 0 1 r
F
P
p
.15119 .25946 m .16133 .25697 L .17036 .26196 L 1 0 .43 r
F
P
p
.13189 .25694 m .15119 .25946 L .14111 .26193 L 1 0 .136 r
F
P
p
.002 w
.74368 .86766 m .73147 .86822 L .72087 .66699 L p
0 .174 1 r
F P
0 0 0 r
s
P
p
.002 w
.71026 .72085 m .72087 .66699 L .73147 .86822 L p
.192 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.72087 .66699 m .71026 .72085 L .70314 .65202 L p
0 1 .398 r
F P
0 0 0 r
s
P
p
.002 w
.7192 .55726 m .7076 .57022 L .70088 .51861 L p
1 .86 0 r
F P
0 0 0 r
s
P
p
.002 w
.70088 .51861 m .71275 .51695 L .7192 .55726 L p
1 .86 0 r
F P
0 0 0 r
s
P
p
.002 w
.71275 .51695 m .70088 .51861 L .69483 .49675 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.68321 .50769 m .69483 .49675 L .70088 .51861 L p
1 .464 0 r
F P
0 0 0 r
s
P
p
.002 w
.71026 .72085 m .70048 .81634 L .69162 .66698 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.002 w
.69162 .66698 m .70314 .65202 L .71026 .72085 L p
0 .744 1 r
F P
0 0 0 r
s
P
p
.002 w
.70314 .65202 m .69162 .66698 L .68563 .65077 L p
0 1 .347 r
F P
0 0 0 r
s
P
p
.002 w
.67518 .72289 m .68563 .65077 L .69162 .66698 L p
0 1 .78 r
F P
0 0 0 r
s
P
p
.002 w
.71169 .81921 m .70098 .87098 L .69532 .86988 L p
1 0 .768 r
F P
0 0 0 r
s
P
p
.002 w
.69532 .86988 m .70729 .86933 L .71169 .81921 L p
1 0 .768 r
F P
0 0 0 r
s
P
p
.002 w
.84126 .48761 m .82938 .49856 L .82456 .49508 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.81229 .49682 m .82456 .49508 L .82938 .49856 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.68902 .84098 m .67763 .86933 L .67045 .79546 L p
.391 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65983 .86877 m .67045 .79546 L .67763 .86933 L p
1 0 .841 r
F P
0 0 0 r
s
P
p
.002 w
.68321 .50769 m .67173 .52428 L .67142 .82497 L p
0 1 .714 r
F P
0 0 0 r
s
P
p
.002 w
.67173 .52428 m .66171 .62288 L .65915 .82568 L p
0 .877 1 r
F P
0 0 0 r
s
P
p
.002 w
.67045 .79546 m .65983 .86877 L .65383 .86765 L p
.905 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65383 .86765 m .66455 .79387 L .67045 .79546 L p
.905 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65915 .82568 m .67142 .82497 L .67173 .52428 L p
0 .877 1 r
F P
0 0 0 r
s
P
p
.002 w
.70098 .87098 m .68915 .87151 L .68343 .87043 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67161 .87097 m .68343 .87043 L .68915 .87151 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.67161 .87097 m .65986 .87151 L .65396 .87042 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64223 .87096 m .65396 .87042 L .65986 .87151 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64223 .87096 m .63058 .8715 L .62448 .87042 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63058 .8715 m .61936 .90411 L .61285 .87096 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.61285 .87096 m .62448 .87042 L .63058 .8715 L p
1 0 .475 r
F P
0 0 0 r
s
P
p
.002 w
.60129 .8715 m .61285 .87096 L .61936 .90411 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.54271 .87149 m .55408 .87095 L .56072 .9041 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.55408 .87095 m .54271 .87149 L .53605 .87941 L p
1 0 .556 r
F P
0 0 0 r
s
P
p
.002 w
.88257 .47664 m .87015 .47843 L .86599 .48336 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.8536 .48585 m .86599 .48336 L .87015 .47843 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.75968 .52788 m .77175 .52625 L .77781 .5573 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.77175 .52625 m .75968 .52788 L .75413 .5153 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.75968 .52788 m .74851 .55728 L .74236 .52623 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.74236 .52623 m .75413 .5153 L .75968 .52788 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.68563 .65077 m .69693 .6234 L .70314 .65202 L p
0 1 .347 r
F P
0 0 0 r
s
P
p
.83797 .25756 m .85033 .25505 L .85499 .26007 L 1 .063 0 r
F
P
p
.82084 .25503 m .83797 .25756 L .82569 .26004 L 1 .063 0 r
F
P
p
.80857 .25753 m .82084 .25503 L .82569 .26004 L 1 .068 0 r
F
P
p
.79135 .255 m .80857 .25753 L .79638 .26002 L 1 .068 0 r
F
P
p
.77917 .2575 m .79135 .255 L .79638 .26002 L 1 .205 0 r
F
P
p
.002 w
.78995 .55576 m .77781 .5573 L .77175 .52625 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.76185 .25498 m .77917 .2575 L .76708 .25999 L 1 .273 0 r
F
P
p
.74977 .25748 m .76185 .25498 L .76708 .25999 L 1 .273 0 r
F
P
p
.002 w
.73114 .55572 m .74236 .52623 L .74851 .55728 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.73235 .25495 m .74977 .25748 L .73777 .25997 L 1 .682 0 r
F
P
p
.72037 .25745 m .73235 .25495 L .73777 .25997 L .568 1 0 r
F
P
p
.002 w
.73114 .55572 m .7192 .55726 L .71275 .51695 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.70285 .25492 m .72037 .25745 L .70846 .25994 L 1 .92 0 r
F
P
p
.69096 .25743 m .70285 .25492 L .70846 .25994 L .977 1 0 r
F
P
p
.002 w
.69483 .49675 m .68321 .50769 L .68377 .82425 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.67142 .82497 m .68377 .82425 L .68321 .50769 L p
0 1 .714 r
F P
0 0 0 r
s
P
p
.67335 .2549 m .69096 .25743 L .67914 .25991 L 1 .375 0 r
F
P
p
.66155 .2574 m .67335 .2549 L .67914 .25991 L 1 .545 0 r
F
P
p
.64385 .25487 m .66155 .2574 L .64983 .25989 L 1 .409 0 r
F
P
p
.63214 .25738 m .64385 .25487 L .64983 .25989 L 1 .682 0 r
F
P
p
.61435 .25485 m .63214 .25738 L .62051 .25986 L .909 1 0 r
F
P
p
.60273 .25735 m .61435 .25485 L .62051 .25986 L .432 1 0 r
F
P
p
.58484 .25482 m .60273 .25735 L .59119 .25984 L .403 1 0 r
F
P
p
.57332 .25733 m .58484 .25482 L .59119 .25984 L .044 1 0 r
F
P
p
.002 w
.57216 .90367 m .56072 .9041 L .55408 .87095 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.55533 .2548 m .57332 .25733 L .56187 .25981 L 0 1 0 r
F
P
p
.5439 .2573 m .55533 .2548 L .56187 .25981 L 0 1 .587 r
F
P
p
.52582 .25477 m .5439 .2573 L .53255 .25979 L 0 .818 1 r
F
P
p
.51449 .25727 m .52582 .25477 L .53255 .25979 L 0 .727 1 r
F
P
p
.002 w
.51338 .88417 m .50207 .90409 L .49515 .90321 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.49631 .25474 m .51449 .25727 L .50323 .25976 L 0 .618 1 r
F
P
p
.48507 .25725 m .49631 .25474 L .50323 .25976 L 0 .366 1 r
F
P
p
.46679 .25472 m .48507 .25725 L .4739 .25974 L 0 .059 1 r
F
P
p
.45565 .25722 m .46679 .25472 L .4739 .25974 L 0 .005 1 r
F
P
p
.43727 .25469 m .45565 .25722 L .44457 .25971 L 0 .366 1 r
F
P
p
.42622 .2572 m .43727 .25469 L .44457 .25971 L 0 .114 1 r
F
P
p
.40775 .25467 m .42622 .2572 L .41524 .25969 L 0 .727 1 r
F
P
p
.3968 .25717 m .40775 .25467 L .41524 .25969 L 0 .727 1 r
F
P
p
.37823 .25464 m .3968 .25717 L .38591 .25966 L .5 0 1 r
F
P
p
.36737 .25715 m .37823 .25464 L .38591 .25966 L .534 0 1 r
F
P
p
.34871 .25462 m .36737 .25715 L .35658 .25963 L 1 0 .97 r
F
P
p
.33794 .25712 m .34871 .25462 L .35658 .25963 L 1 0 .886 r
F
P
p
.31919 .25459 m .33794 .25712 L .32724 .25961 L .28 0 1 r
F
P
p
.30851 .25709 m .31919 .25459 L .32724 .25961 L .372 0 1 r
F
P
p
.28966 .25456 m .30851 .25709 L .2979 .25958 L .364 0 1 r
F
P
p
.27908 .25707 m .28966 .25456 L .2979 .25958 L .364 0 1 r
F
P
p
.002 w
.8536 .48585 m .84126 .48761 L .8369 .49333 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.82456 .49508 m .8369 .49333 L .84126 .48761 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.26013 .25454 m .27908 .25707 L .26856 .25956 L .364 0 1 r
F
P
p
.24964 .25704 m .26013 .25454 L .26856 .25956 L .364 0 1 r
F
P
p
.2306 .25451 m .24964 .25704 L .23922 .25953 L .364 0 1 r
F
P
p
.22021 .25702 m .2306 .25451 L .23922 .25953 L .364 0 1 r
F
P
p
.20107 .25449 m .22021 .25702 L .20988 .25951 L .364 0 1 r
F
P
p
.19077 .25699 m .20107 .25449 L .20988 .25951 L .364 0 1 r
F
P
p
.17154 .25446 m .19077 .25699 L .18053 .25948 L .372 0 1 r
F
P
p
.16133 .25697 m .17154 .25446 L .18053 .25948 L .829 0 1 r
F
P
p
.142 .25443 m .16133 .25697 L .15119 .25946 L 1 0 .205 r
F
P
p
.13189 .25694 m .142 .25443 L .15119 .25946 L 1 0 .136 r
F
P
p
.002 w
.52468 .88367 m .51338 .88417 L .50645 .90277 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.49515 .90321 m .50645 .90277 L .51338 .88417 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.71275 .51695 m .72444 .50601 L .73114 .55572 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.72444 .50601 m .71275 .51695 L .70672 .49501 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.69483 .49675 m .70672 .49501 L .71275 .51695 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.82456 .49508 m .81229 .49682 L .8073 .49189 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.81229 .49682 m .80113 .52627 L .79567 .51077 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.79567 .51077 m .8073 .49189 L .81229 .49682 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.002 w
.70672 .49501 m .69483 .49675 L .69301 .67416 L p
.773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68377 .82425 m .69301 .67416 L .69483 .49675 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.73147 .86822 m .71934 .86878 L .71026 .72085 L p
.192 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.70048 .81634 m .71026 .72085 L .71934 .86878 L p
.717 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68343 .87043 m .69532 .86988 L .70098 .87098 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.68343 .87043 m .67161 .87097 L .66576 .86988 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.65396 .87042 m .66576 .86988 L .67161 .87097 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.65396 .87042 m .64223 .87096 L .63619 .86987 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.62448 .87042 m .63619 .86987 L .64223 .87096 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.62448 .87042 m .61285 .87096 L .60662 .86986 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.55408 .87095 m .56553 .8704 L .57216 .90367 L p
1 0 .362 r
F P
0 0 0 r
s
P
p
.002 w
.56553 .8704 m .55408 .87095 L .54748 .86985 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.53605 .87941 m .54748 .86985 L .55408 .87095 L p
1 0 .556 r
F P
0 0 0 r
s
P
p
.002 w
.86599 .48336 m .87808 .47301 L .88257 .47664 L p
1 .031 0 r
F P
0 0 0 r
s
P
p
.002 w
.78357 .51531 m .79567 .51077 L .80113 .52627 L p
1 .705 0 r
F P
0 0 0 r
s
P
p
.002 w
.77175 .52625 m .78357 .51531 L .78995 .55576 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.78357 .51531 m .77175 .52625 L .76565 .49505 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.75413 .5153 m .76565 .49505 L .77175 .52625 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.75413 .5153 m .74236 .52623 L .73619 .49503 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.74236 .52623 m .73114 .55572 L .72444 .50601 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.72444 .50601 m .73619 .49503 L .74236 .52623 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.83319 .25251 m .85033 .25505 L .83797 .25756 L 1 .029 0 r
F
P
p
.82084 .25503 m .83319 .25251 L .83797 .25756 L 1 .063 0 r
F
P
p
.8036 .25248 m .82084 .25503 L .80857 .25753 L 1 0 0 r
F
P
p
.79135 .255 m .8036 .25248 L .80857 .25753 L 1 .068 0 r
F
P
p
.77401 .25246 m .79135 .255 L .77917 .2575 L 1 .239 0 r
F
P
p
.76185 .25498 m .77401 .25246 L .77917 .2575 L 1 .273 0 r
F
P
p
.74442 .25243 m .76185 .25498 L .74977 .25748 L 1 .273 0 r
F
P
p
.73235 .25495 m .74442 .25243 L .74977 .25748 L 1 .682 0 r
F
P
p
.002 w
.73619 .49503 m .72444 .50601 L .71869 .49326 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.70672 .49501 m .71869 .49326 L .72444 .50601 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.71482 .25241 m .73235 .25495 L .72037 .25745 L 1 .682 0 r
F
P
p
.70285 .25492 m .71482 .25241 L .72037 .25745 L 1 .92 0 r
F
P
p
.68523 .25238 m .70285 .25492 L .69096 .25743 L 1 .307 0 r
F
P
p
.67335 .2549 m .68523 .25238 L .69096 .25743 L 1 .375 0 r
F
P
p
.65563 .25235 m .67335 .2549 L .66155 .2574 L 1 .307 0 r
F
P
p
.64385 .25487 m .65563 .25235 L .66155 .2574 L 1 .409 0 r
F
P
p
.62603 .25233 m .64385 .25487 L .63214 .25738 L 1 .477 0 r
F
P
p
.61435 .25485 m .62603 .25233 L .63214 .25738 L .909 1 0 r
F
P
p
.59643 .2523 m .61435 .25485 L .60273 .25735 L .639 1 0 r
F
P
p
.58484 .25482 m .59643 .2523 L .60273 .25735 L .403 1 0 r
F
P
p
.56683 .25228 m .58484 .25482 L .57332 .25733 L .485 1 0 r
F
P
p
.55533 .2548 m .56683 .25228 L .57332 .25733 L 0 1 0 r
F
P
p
.53722 .25225 m .55533 .2548 L .5439 .2573 L 0 1 .807 r
F
P
p
.52582 .25477 m .53722 .25225 L .5439 .2573 L 0 .818 1 r
F
P
p
.50762 .25222 m .52582 .25477 L .51449 .25727 L 0 .673 1 r
F
P
p
.49631 .25474 m .50762 .25222 L .51449 .25727 L 0 .618 1 r
F
P
p
.47801 .2522 m .49631 .25474 L .48507 .25725 L 0 .366 1 r
F
P
p
.46679 .25472 m .47801 .2522 L .48507 .25725 L 0 .059 1 r
F
P
p
.4484 .25217 m .46679 .25472 L .45565 .25722 L 0 .618 1 r
F
P
p
.43727 .25469 m .4484 .25217 L .45565 .25722 L 0 .366 1 r
F
P
p
.41878 .25215 m .43727 .25469 L .42622 .2572 L 0 .818 1 r
F
P
p
.40775 .25467 m .41878 .25215 L .42622 .2572 L 0 .727 1 r
F
P
p
.38917 .25212 m .40775 .25467 L .3968 .25717 L .5 0 1 r
F
P
p
.37823 .25464 m .38917 .25212 L .3968 .25717 L .5 0 1 r
F
P
p
.35955 .25209 m .37823 .25464 L .36737 .25715 L .777 0 1 r
F
P
p
.34871 .25462 m .35955 .25209 L .36737 .25715 L 1 0 .97 r
F
P
p
.32993 .25207 m .34871 .25462 L .33794 .25712 L .007 0 1 r
F
P
p
.31919 .25459 m .32993 .25207 L .33794 .25712 L .28 0 1 r
F
P
p
.30031 .25204 m .31919 .25459 L .30851 .25709 L .364 0 1 r
F
P
p
.28966 .25456 m .30031 .25204 L .30851 .25709 L .364 0 1 r
F
P
p
.002 w
.8369 .49333 m .84932 .49158 L .8536 .48585 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.27069 .25202 m .28966 .25456 L .27908 .25707 L .364 0 1 r
F
P
p
.26013 .25454 m .27069 .25202 L .27908 .25707 L .364 0 1 r
F
P
p
.24106 .25199 m .26013 .25454 L .24964 .25704 L .364 0 1 r
F
P
p
.2306 .25451 m .24106 .25199 L .24964 .25704 L .364 0 1 r
F
P
p
.21144 .25196 m .2306 .25451 L .22021 .25702 L .364 0 1 r
F
P
p
.20107 .25449 m .21144 .25196 L .22021 .25702 L .364 0 1 r
F
P
p
.18181 .25194 m .20107 .25449 L .19077 .25699 L .364 0 1 r
F
P
p
.17154 .25446 m .18181 .25194 L .19077 .25699 L .372 0 1 r
F
P
p
.15218 .25191 m .17154 .25446 L .16133 .25697 L 1 0 .938 r
F
P
p
.142 .25443 m .15218 .25191 L .16133 .25697 L 1 0 .205 r
F
P
p
.12255 .25189 m .142 .25443 L .13189 .25694 L 1 0 .136 r
F
P
p
.002 w
.53605 .87941 m .52468 .88367 L .51783 .90233 L p
1 0 .286 r
F P
0 0 0 r
s
P
p
.002 w
.50645 .90277 m .51783 .90233 L .52468 .88367 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.79567 .51077 m .78357 .51531 L .7778 .4933 L p
1 .399 0 r
F P
0 0 0 r
s
P
p
.002 w
.76565 .49505 m .7778 .4933 L .78357 .51531 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.76565 .49505 m .75413 .5153 L .74825 .49328 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.73619 .49503 m .74825 .49328 L .75413 .5153 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.58826 .81537 m .57705 .86986 L .57055 .86875 L p
1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.57055 .86875 m .5822 .86819 L .58826 .81537 L p
1 0 .776 r
F P
0 0 0 r
s
P
p
.002 w
.8369 .49333 m .82456 .49508 L .81931 .48225 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.8073 .49189 m .81931 .48225 L .82456 .49508 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.7778 .4933 m .76565 .49505 L .76038 .49152 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.74825 .49328 m .76038 .49152 L .76565 .49505 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.74825 .49328 m .73619 .49503 L .73074 .4915 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71869 .49326 m .73074 .4915 L .73619 .49503 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.71869 .49326 m .70672 .49501 L .70304 .57632 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.69301 .67416 m .70304 .57632 L .70672 .49501 L p
.773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69532 .86988 m .68343 .87043 L .67763 .86933 L p
1 0 .684 r
F P
0 0 0 r
s
P
p
.002 w
.66576 .86988 m .67763 .86933 L .68343 .87043 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.66576 .86988 m .65396 .87042 L .64797 .86932 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63619 .86987 m .64797 .86932 L .65396 .87042 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63619 .86987 m .62448 .87042 L .61831 .86932 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.60662 .86986 m .61831 .86932 L .62448 .87042 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.57705 .86986 m .56553 .8704 L .55897 .8693 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.54748 .86985 m .55897 .8693 L .56553 .8704 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.83319 .25251 m .84561 .24997 L .85033 .25505 L 1 .029 0 r
F
P
p
.81593 .24995 m .83319 .25251 L .82084 .25503 L 1 0 0 r
F
P
p
.8036 .25248 m .81593 .24995 L .82084 .25503 L 1 0 0 r
F
P
p
.78625 .24992 m .8036 .25248 L .79135 .255 L 1 .17 0 r
F
P
p
.77401 .25246 m .78625 .24992 L .79135 .255 L 1 .239 0 r
F
P
p
.75656 .2499 m .77401 .25246 L .76185 .25498 L 1 .273 0 r
F
P
p
.74442 .25243 m .75656 .2499 L .76185 .25498 L 1 .273 0 r
F
P
p
.72687 .24987 m .74442 .25243 L .73235 .25495 L 1 .375 0 r
F
P
p
.71482 .25241 m .72687 .24987 L .73235 .25495 L 1 .682 0 r
F
P
p
.69718 .24984 m .71482 .25241 L .70285 .25492 L 1 .273 0 r
F
P
p
.68523 .25238 m .69718 .24984 L .70285 .25492 L 1 .307 0 r
F
P
p
.66749 .24982 m .68523 .25238 L .67335 .2549 L 1 .273 0 r
F
P
p
.65563 .25235 m .66749 .24982 L .67335 .2549 L 1 .307 0 r
F
P
p
.63779 .24979 m .65563 .25235 L .64385 .25487 L 1 .273 0 r
F
P
p
.62603 .25233 m .63779 .24979 L .64385 .25487 L 1 .477 0 r
F
P
p
.6081 .24977 m .62603 .25233 L .61435 .25485 L .705 1 0 r
F
P
p
.59643 .2523 m .6081 .24977 L .61435 .25485 L .639 1 0 r
F
P
p
.5784 .24974 m .59643 .2523 L .58484 .25482 L .741 1 0 r
F
P
p
.56683 .25228 m .5784 .24974 L .58484 .25482 L .485 1 0 r
F
P
p
.5487 .24971 m .56683 .25228 L .55533 .2548 L 0 1 .352 r
F
P
p
.53722 .25225 m .5487 .24971 L .55533 .2548 L 0 1 .807 r
F
P
p
.519 .24969 m .53722 .25225 L .52582 .25477 L 0 .727 1 r
F
P
p
.50762 .25222 m .519 .24969 L .52582 .25477 L 0 .673 1 r
F
P
p
.48929 .24966 m .50762 .25222 L .49631 .25474 L 0 .618 1 r
F
P
p
.47801 .2522 m .48929 .24966 L .49631 .25474 L 0 .366 1 r
F
P
p
.45959 .24964 m .47801 .2522 L .46679 .25472 L 0 .764 1 r
F
P
p
.4484 .25217 m .45959 .24964 L .46679 .25472 L 0 .618 1 r
F
P
p
.42988 .24961 m .4484 .25217 L .43727 .25469 L 0 .909 1 r
F
P
p
.41878 .25215 m .42988 .24961 L .43727 .25469 L 0 .818 1 r
F
P
p
.002 w
.54748 .86985 m .53605 .87941 L .52928 .90188 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.51783 .90233 m .52928 .90188 L .53605 .87941 L p
1 0 .286 r
F P
0 0 0 r
s
P
p
.40017 .24958 m .41878 .25215 L .40775 .25467 L .5 0 1 r
F
P
p
.38917 .25212 m .40017 .24958 L .40775 .25467 L .5 0 1 r
F
P
p
.002 w
.87808 .47301 m .86599 .48336 L .86176 .48837 L p
1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.84932 .49158 m .86176 .48837 L .86599 .48336 L p
1 .197 0 r
F P
0 0 0 r
s
P
p
.37046 .24956 m .38917 .25212 L .37823 .25464 L .555 0 1 r
F
P
p
.35955 .25209 m .37046 .24956 L .37823 .25464 L .777 0 1 r
F
P
p
.34075 .24953 m .35955 .25209 L .34871 .25462 L 0 .266 1 r
F
P
p
.32993 .25207 m .34075 .24953 L .34871 .25462 L .007 0 1 r
F
P
p
.31103 .2495 m .32993 .25207 L .31919 .25459 L .28 0 1 r
F
P
p
.30031 .25204 m .31103 .2495 L .31919 .25459 L .364 0 1 r
F
P
p
.28131 .24948 m .30031 .25204 L .28966 .25456 L .364 0 1 r
F
P
p
.27069 .25202 m .28131 .24948 L .28966 .25456 L .364 0 1 r
F
P
p
.25159 .24945 m .27069 .25202 L .26013 .25454 L .364 0 1 r
F
P
p
.24106 .25199 m .25159 .24945 L .26013 .25454 L .364 0 1 r
F
P
p
.22187 .24943 m .24106 .25199 L .2306 .25451 L .364 0 1 r
F
P
p
.21144 .25196 m .22187 .24943 L .2306 .25451 L .364 0 1 r
F
P
p
.19215 .2494 m .21144 .25196 L .20107 .25449 L .364 0 1 r
F
P
p
.18181 .25194 m .19215 .2494 L .20107 .25449 L .364 0 1 r
F
P
p
.16242 .24937 m .18181 .25194 L .17154 .25446 L .381 0 1 r
F
P
p
.15218 .25191 m .16242 .24937 L .17154 .25446 L 1 0 .938 r
F
P
p
.13269 .24935 m .15218 .25191 L .142 .25443 L 1 0 .273 r
F
P
p
.12255 .25189 m .13269 .24935 L .142 .25443 L 1 0 .136 r
F
P
p
.002 w
.8073 .49189 m .79567 .51077 L .79003 .49154 L p
1 .325 0 r
F P
0 0 0 r
s
P
p
.002 w
.7778 .4933 m .79003 .49154 L .79567 .51077 L p
1 .399 0 r
F P
0 0 0 r
s
P
p
.002 w
.81931 .48225 m .8073 .49189 L .80234 .48977 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.79003 .49154 m .80234 .48977 L .8073 .49189 L p
1 .325 0 r
F P
0 0 0 r
s
P
p
.002 w
.84932 .49158 m .8369 .49333 L .8317 .48046 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.8317 .48046 m .8369 .49333 L p
.8255 .48615 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.8317 .48046 m .84377 .46931 L .84932 .49158 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.8317 .48046 m .82715 .48475 L p
.83795 .47472 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.84377 .46931 m .8317 .48046 L p
.83795 .47472 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.81931 .48225 m .8317 .48046 L p
.8255 .48615 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.79003 .49154 m .7778 .4933 L .7726 .48975 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76038 .49152 m .7726 .48975 L .7778 .4933 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76038 .49152 m .74825 .49328 L .74286 .48973 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.73074 .4915 m .74286 .48973 L .74825 .49328 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.73074 .4915 m .71869 .49326 L .71427 .53674 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.70304 .57632 m .71427 .53674 L .71869 .49326 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.70729 .86933 m .69532 .86988 L .68902 .84098 L p
1 0 .864 r
F P
0 0 0 r
s
P
p
.002 w
.67763 .86933 m .68902 .84098 L .69532 .86988 L p
1 0 .684 r
F P
0 0 0 r
s
P
p
.002 w
.67763 .86933 m .66576 .86988 L .65983 .86877 L p
1 0 .841 r
F P
0 0 0 r
s
P
p
.002 w
.64797 .86932 m .65983 .86877 L .66576 .86988 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.64797 .86932 m .63619 .86987 L .63007 .86876 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.61831 .86932 m .63007 .86876 L .63619 .86987 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.55897 .8693 m .57055 .86875 L .57705 .86986 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.55897 .8693 m .54748 .86985 L .54081 .90143 L p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.52928 .90188 m .54081 .90143 L .54748 .86985 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.86176 .48837 m .87396 .47867 L .87808 .47301 L p
1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.66171 .62288 m .65142 .71978 L .64695 .8264 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.002 w
.64695 .8264 m .65915 .82568 L .66171 .62288 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.82834 .2474 m .84561 .24997 L .83319 .25251 L 1 0 0 r
F
P
p
.81593 .24995 m .82834 .2474 L .83319 .25251 L 1 0 0 r
F
P
p
.79856 .24737 m .81593 .24995 L .8036 .25248 L 1 .136 0 r
F
P
p
.78625 .24992 m .79856 .24737 L .8036 .25248 L 1 .17 0 r
F
P
p
.76878 .24734 m .78625 .24992 L .77401 .25246 L 1 .273 0 r
F
P
p
.75656 .2499 m .76878 .24734 L .77401 .25246 L 1 .273 0 r
F
P
p
.739 .24732 m .75656 .2499 L .74442 .25243 L 1 .239 0 r
F
P
p
.72687 .24987 m .739 .24732 L .74442 .25243 L 1 .375 0 r
F
P
p
.70921 .24729 m .72687 .24987 L .71482 .25241 L 1 .239 0 r
F
P
p
.69718 .24984 m .70921 .24729 L .71482 .25241 L 1 .273 0 r
F
P
p
.67942 .24727 m .69718 .24984 L .68523 .25238 L 1 .273 0 r
F
P
p
.66749 .24982 m .67942 .24727 L .68523 .25238 L 1 .273 0 r
F
P
p
.64963 .24724 m .66749 .24982 L .65563 .25235 L 1 .273 0 r
F
P
p
.63779 .24979 m .64963 .24724 L .65563 .25235 L 1 .273 0 r
F
P
p
.61984 .24721 m .63779 .24979 L .62603 .25233 L 1 .989 0 r
F
P
p
.6081 .24977 m .61984 .24721 L .62603 .25233 L .705 1 0 r
F
P
p
.59005 .24719 m .6081 .24977 L .59643 .2523 L .844 1 0 r
F
P
p
.5784 .24974 m .59005 .24719 L .59643 .2523 L .741 1 0 r
F
P
p
.56025 .24716 m .5784 .24974 L .56683 .25228 L 0 1 .114 r
F
P
p
.5487 .24971 m .56025 .24716 L .56683 .25228 L 0 1 .352 r
F
P
p
.53046 .24713 m .5487 .24971 L .53722 .25225 L 0 .727 1 r
F
P
p
.519 .24969 m .53046 .24713 L .53722 .25225 L 0 .727 1 r
F
P
p
.50066 .24711 m .519 .24969 L .50762 .25222 L 0 .673 1 r
F
P
p
.48929 .24966 m .50066 .24711 L .50762 .25222 L 0 .618 1 r
F
P
p
.47085 .24708 m .48929 .24966 L .47801 .2522 L 0 1 .987 r
F
P
p
.45959 .24964 m .47085 .24708 L .47801 .2522 L 0 .764 1 r
F
P
p
.44105 .24706 m .45959 .24964 L .4484 .25217 L 0 .909 1 r
F
P
p
.42988 .24961 m .44105 .24706 L .4484 .25217 L 0 .909 1 r
F
P
p
.41125 .24703 m .42988 .24961 L .41878 .25215 L .375 0 1 r
F
P
p
.40017 .24958 m .41125 .24703 L .41878 .25215 L .5 0 1 r
F
P
p
.38144 .247 m .40017 .24958 L .38917 .25212 L .5 0 1 r
F
P
p
.37046 .24956 m .38144 .247 L .38917 .25212 L .555 0 1 r
F
P
p
.35163 .24698 m .37046 .24956 L .35955 .25209 L 0 .484 1 r
F
P
p
.34075 .24953 m .35163 .24698 L .35955 .25209 L 0 .266 1 r
F
P
p
.32182 .24695 m .34075 .24953 L .32993 .25207 L .007 0 1 r
F
P
p
.31103 .2495 m .32182 .24695 L .32993 .25207 L .28 0 1 r
F
P
p
.292 .24692 m .31103 .2495 L .30031 .25204 L .364 0 1 r
F
P
p
.28131 .24948 m .292 .24692 L .30031 .25204 L .364 0 1 r
F
P
p
.26219 .2469 m .28131 .24948 L .27069 .25202 L .364 0 1 r
F
P
p
.25159 .24945 m .26219 .2469 L .27069 .25202 L .364 0 1 r
F
P
p
.002 w
.8317 .48046 m .81931 .48225 L .81473 .48799 L p
1 .199 0 r
F P
0 0 0 r
s
P
p
.002 w
.80234 .48977 m .81473 .48799 L .81931 .48225 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.23237 .24687 m .25159 .24945 L .24106 .25199 L .364 0 1 r
F
P
p
.22187 .24943 m .23237 .24687 L .24106 .25199 L .364 0 1 r
F
P
p
.20255 .24685 m .22187 .24943 L .21144 .25196 L .364 0 1 r
F
P
p
.19215 .2494 m .20255 .24685 L .21144 .25196 L .364 0 1 r
F
P
p
.17273 .24682 m .19215 .2494 L .18181 .25194 L .364 0 1 r
F
P
p
.16242 .24937 m .17273 .24682 L .18181 .25194 L .381 0 1 r
F
P
p
.14291 .24679 m .16242 .24937 L .15218 .25191 L 1 0 .912 r
F
P
p
.13269 .24935 m .14291 .24679 L .15218 .25191 L 1 0 .273 r
F
P
p
.11308 .24677 m .13269 .24935 L .12255 .25189 L 1 0 .136 r
F
P
p
.002 w
.68902 .84098 m .70048 .81634 L .70729 .86933 L p
1 0 .864 r
F P
0 0 0 r
s
P
p
.002 w
.86176 .48837 m .84932 .49158 L .84377 .46931 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.71934 .86878 m .70729 .86933 L .70048 .81634 L p
.717 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.80234 .48977 m .79003 .49154 L .7849 .48797 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7726 .48975 m .7849 .48797 L .79003 .49154 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7726 .48975 m .76038 .49152 L .75506 .48795 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.74286 .48973 m .75506 .48795 L .76038 .49152 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.73529 .60758 m .73677 .52197 L p
.72616 .64663 L .534 1 0 r
F P
0 0 0 r
s
P
p
.72434 .66803 m .73677 .52197 L .735 .51947 L .534 1 0 r
F
P
p
.002 w
.74286 .48973 m .73074 .4915 L .7274 .50871 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.72915 .51118 m .74286 .48973 L .7274 .50871 L 1 .375 0 r
F
P
p
.002 w
.75506 .48795 m .74286 .48973 L .7374 .48614 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7274 .50871 m .72596 .51616 L p
.72915 .51118 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.72596 .51616 m .7374 .48614 L .74286 .48973 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.7374 .48614 m .74966 .48434 L .75506 .48795 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.74966 .48434 m .7374 .48614 L .73529 .60758 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7374 .48614 m .72596 .51616 L .72434 .66803 L p
.534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73529 .60758 m .7467 .56707 L .74966 .48434 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73529 .60758 m .72856 .56548 L p
.7448 .5669 L .568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7467 .56707 m .73529 .60758 L p
.7448 .5669 L .568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.72434 .66803 m .73529 .60758 L p
.72616 .64663 L .534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73677 .52197 m .7374 .48614 L p
.735 .51947 L .534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71427 .53674 m .72596 .51616 L .73074 .4915 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.65983 .86877 m .64797 .86932 L .64191 .86821 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.63007 .86876 m .64191 .86821 L .64797 .86932 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.57055 .86875 m .55897 .8693 L .55236 .88112 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.54081 .90143 m .55236 .88112 L .55897 .8693 L p
1 0 .43 r
F P
0 0 0 r
s
P
p
.82834 .2474 m .84083 .24483 L .84561 .24997 L 1 0 0 r
F
P
p
.81096 .2448 m .82834 .2474 L .81593 .24995 L 1 .102 0 r
F
P
p
.79856 .24737 m .81096 .2448 L .81593 .24995 L 1 .136 0 r
F
P
p
.78108 .24478 m .79856 .24737 L .78625 .24992 L 1 .205 0 r
F
P
p
.76878 .24734 m .78108 .24478 L .78625 .24992 L 1 .273 0 r
F
P
p
.7512 .24475 m .76878 .24734 L .75656 .2499 L 1 .205 0 r
F
P
p
.739 .24732 m .7512 .24475 L .75656 .2499 L 1 .239 0 r
F
P
p
.72132 .24472 m .739 .24732 L .72687 .24987 L 1 .205 0 r
F
P
p
.70921 .24729 m .72132 .24472 L .72687 .24987 L 1 .239 0 r
F
P
p
.69143 .2447 m .70921 .24729 L .69718 .24984 L 1 .273 0 r
F
P
p
.67942 .24727 m .69143 .2447 L .69718 .24984 L 1 .273 0 r
F
P
p
.66155 .24467 m .67942 .24727 L .66749 .24982 L 1 .273 0 r
F
P
p
.64963 .24724 m .66155 .24467 L .66749 .24982 L 1 .273 0 r
F
P
p
.63166 .24464 m .64963 .24724 L .63779 .24979 L 1 .682 0 r
F
P
p
.61984 .24721 m .63166 .24464 L .63779 .24979 L 1 .989 0 r
F
P
p
.60177 .24462 m .61984 .24721 L .6081 .24977 L .909 1 0 r
F
P
p
.59005 .24719 m .60177 .24462 L .6081 .24977 L .844 1 0 r
F
P
p
.57188 .24459 m .59005 .24719 L .5784 .24974 L 0 1 .011 r
F
P
p
.56025 .24716 m .57188 .24459 L .5784 .24974 L 0 1 .114 r
F
P
p
.54199 .24456 m .56025 .24716 L .5487 .24971 L 0 .727 1 r
F
P
p
.53046 .24713 m .54199 .24456 L .5487 .24971 L 0 .727 1 r
F
P
p
.51209 .24454 m .53046 .24713 L .519 .24969 L 0 .727 1 r
F
P
p
.50066 .24711 m .51209 .24454 L .519 .24969 L 0 .673 1 r
F
P
p
.48219 .24451 m .50066 .24711 L .48929 .24966 L 0 1 .606 r
F
P
p
.47085 .24708 m .48219 .24451 L .48929 .24966 L 0 1 .987 r
F
P
p
.45229 .24449 m .47085 .24708 L .45959 .24964 L 0 1 .784 r
F
P
p
.44105 .24706 m .45229 .24449 L .45959 .24964 L 0 .909 1 r
F
P
p
.42239 .24446 m .44105 .24706 L .42988 .24961 L .114 0 1 r
F
P
p
.41125 .24703 m .42239 .24446 L .42988 .24961 L .375 0 1 r
F
P
p
.39249 .24443 m .41125 .24703 L .40017 .24958 L .5 0 1 r
F
P
p
.38144 .247 m .39249 .24443 L .40017 .24958 L .5 0 1 r
F
P
p
.36258 .24441 m .38144 .247 L .37046 .24956 L 0 .673 1 r
F
P
p
.35163 .24698 m .36258 .24441 L .37046 .24956 L 0 .484 1 r
F
P
p
.33268 .24438 m .35163 .24698 L .34075 .24953 L 0 .182 1 r
F
P
p
.32182 .24695 m .33268 .24438 L .34075 .24953 L .007 0 1 r
F
P
p
.30277 .24435 m .32182 .24695 L .31103 .2495 L .364 0 1 r
F
P
p
.292 .24692 m .30277 .24435 L .31103 .2495 L .364 0 1 r
F
P
p
.27285 .24433 m .292 .24692 L .28131 .24948 L .364 0 1 r
F
P
p
.26219 .2469 m .27285 .24433 L .28131 .24948 L .364 0 1 r
F
P
p
.002 w
.81473 .48799 m .82715 .48475 L .8317 .48046 L p
1 .199 0 r
F P
0 0 0 r
s
P
p
.24294 .2443 m .26219 .2469 L .25159 .24945 L .364 0 1 r
F
P
p
.23237 .24687 m .24294 .2443 L .25159 .24945 L .364 0 1 r
F
P
p
.21303 .24427 m .23237 .24687 L .22187 .24943 L .364 0 1 r
F
P
p
.20255 .24685 m .21303 .24427 L .22187 .24943 L .364 0 1 r
F
P
p
.18311 .24425 m .20255 .24685 L .19215 .2494 L .364 0 1 r
F
P
p
.17273 .24682 m .18311 .24425 L .19215 .2494 L .364 0 1 r
F
P
p
.15319 .24422 m .17273 .24682 L .16242 .24937 L .543 0 1 r
F
P
p
.14291 .24679 m .15319 .24422 L .16242 .24937 L 1 0 .912 r
F
P
p
.12327 .24419 m .14291 .24679 L .13269 .24935 L 1 0 .205 r
F
P
p
.11308 .24677 m .12327 .24419 L .13269 .24935 L 1 0 .136 r
F
P
p
.002 w
.87396 .47867 m .86176 .48837 L .8563 .46746 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.002 w
.84377 .46931 m .8563 .46746 L .86176 .48837 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.81473 .48799 m .80234 .48977 L .79727 .48618 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7849 .48797 m .79727 .48618 L .80234 .48977 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7849 .48797 m .7726 .48975 L .76733 .48616 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.75506 .48795 m .76733 .48616 L .7726 .48975 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.64191 .86821 m .65383 .86765 L .65983 .86877 L p
1 0 .587 r
F P
0 0 0 r
s
P
p
.002 w
.5822 .86819 m .57055 .86875 L .56401 .8806 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.55236 .88112 m .56401 .8806 L .57055 .86875 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.8563 .46746 m .84377 .46931 L .83936 .47498 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.83936 .47498 m .84377 .46931 L p
.83479 .47765 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.83936 .47498 m .83449 .47126 L p
.84398 .47227 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.83936 .47498 m .85198 .47313 L .8563 .46746 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.85198 .47313 m .83936 .47498 L p
.84398 .47227 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.002 w
.82715 .48475 m .83936 .47498 L p
.83479 .47765 L 1 .131 0 r
F P
0 0 0 r
s
P
p
.82343 .24222 m .84083 .24483 L .82834 .2474 L 1 .034 0 r
F
P
p
.81096 .2448 m .82343 .24222 L .82834 .2474 L 1 .102 0 r
F
P
p
.79346 .24219 m .81096 .2448 L .79856 .24737 L 1 .136 0 r
F
P
p
.78108 .24478 m .79346 .24219 L .79856 .24737 L 1 .205 0 r
F
P
p
.76348 .24216 m .78108 .24478 L .76878 .24734 L 1 .17 0 r
F
P
p
.7512 .24475 m .76348 .24216 L .76878 .24734 L 1 .205 0 r
F
P
p
.7335 .24214 m .7512 .24475 L .739 .24732 L 1 .17 0 r
F
P
p
.72132 .24472 m .7335 .24214 L .739 .24732 L 1 .205 0 r
F
P
p
.70352 .24211 m .72132 .24472 L .70921 .24729 L 1 .239 0 r
F
P
p
.69143 .2447 m .70352 .24211 L .70921 .24729 L 1 .273 0 r
F
P
p
.67354 .24209 m .69143 .2447 L .67942 .24727 L 1 .273 0 r
F
P
p
.66155 .24467 m .67354 .24209 L .67942 .24727 L 1 .273 0 r
F
P
p
.64356 .24206 m .66155 .24467 L .64963 .24724 L 1 .614 0 r
F
P
p
.63166 .24464 m .64356 .24206 L .64963 .24724 L 1 .682 0 r
F
P
p
.61357 .24203 m .63166 .24464 L .61984 .24721 L 1 .989 0 r
F
P
p
.60177 .24462 m .61357 .24203 L .61984 .24721 L .909 1 0 r
F
P
p
.58358 .24201 m .60177 .24462 L .59005 .24719 L .114 1 0 r
F
P
p
.57188 .24459 m .58358 .24201 L .59005 .24719 L 0 1 .011 r
F
P
p
.55359 .24198 m .57188 .24459 L .56025 .24716 L 0 .727 1 r
F
P
p
.54199 .24456 m .55359 .24198 L .56025 .24716 L 0 .727 1 r
F
P
p
.5236 .24195 m .54199 .24456 L .53046 .24713 L 0 .727 1 r
F
P
p
.51209 .24454 m .5236 .24195 L .53046 .24713 L 0 .727 1 r
F
P
p
.49361 .24193 m .51209 .24454 L .50066 .24711 L 0 1 .323 r
F
P
p
.48219 .24451 m .49361 .24193 L .50066 .24711 L 0 1 .606 r
F
P
p
.46361 .2419 m .48219 .24451 L .47085 .24708 L 0 1 .305 r
F
P
p
.45229 .24449 m .46361 .2419 L .47085 .24708 L 0 1 .784 r
F
P
p
.43361 .24187 m .45229 .24449 L .44105 .24706 L 0 .193 1 r
F
P
p
.42239 .24446 m .43361 .24187 L .44105 .24706 L .114 0 1 r
F
P
p
.40361 .24185 m .42239 .24446 L .41125 .24703 L .466 0 1 r
F
P
p
.39249 .24443 m .40361 .24185 L .41125 .24703 L .5 0 1 r
F
P
p
.37361 .24182 m .39249 .24443 L .38144 .247 L 0 .727 1 r
F
P
p
.36258 .24441 m .37361 .24182 L .38144 .247 L 0 .673 1 r
F
P
p
.3436 .24179 m .36258 .24441 L .35163 .24698 L 0 .182 1 r
F
P
p
.33268 .24438 m .3436 .24179 L .35163 .24698 L 0 .182 1 r
F
P
p
.3136 .24177 m .33268 .24438 L .32182 .24695 L .28 0 1 r
F
P
p
.30277 .24435 m .3136 .24177 L .32182 .24695 L .364 0 1 r
F
P
p
.002 w
.8563 .46746 m .86891 .4656 L .87396 .47867 L p
1 .097 0 r
F P
0 0 0 r
s
P
p
.28359 .24174 m .30277 .24435 L .292 .24692 L .364 0 1 r
F
P
p
.27285 .24433 m .28359 .24174 L .292 .24692 L .364 0 1 r
F
P
p
.25358 .24171 m .27285 .24433 L .26219 .2469 L .28 0 1 r
F
P
p
.24294 .2443 m .25358 .24171 L .26219 .2469 L .364 0 1 r
F
P
p
.22357 .24169 m .24294 .2443 L .23237 .24687 L .364 0 1 r
F
P
p
.21303 .24427 m .22357 .24169 L .23237 .24687 L .364 0 1 r
F
P
p
.19355 .24166 m .21303 .24427 L .20255 .24685 L .364 0 1 r
F
P
p
.18311 .24425 m .19355 .24166 L .20255 .24685 L .364 0 1 r
F
P
p
.16354 .24163 m .18311 .24425 L .17273 .24682 L .432 0 1 r
F
P
p
.15319 .24422 m .16354 .24163 L .17273 .24682 L .543 0 1 r
F
P
p
.13352 .24161 m .15319 .24422 L .14291 .24679 L 1 0 .545 r
F
P
p
.12327 .24419 m .13352 .24161 L .14291 .24679 L 1 0 .205 r
F
P
p
.1035 .24158 m .12327 .24419 L .11308 .24677 L 1 0 .136 r
F
P
p
.002 w
.82715 .48475 m .81473 .48799 L .80973 .48437 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.79727 .48618 m .80973 .48437 L .81473 .48799 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.79727 .48618 m .7849 .48797 L .77969 .48435 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76733 .48616 m .77969 .48435 L .7849 .48797 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76733 .48616 m .75506 .48795 L .74966 .48434 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.56401 .8806 m .57573 .88008 L .5822 .86819 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.86891 .4656 m .8563 .46746 L .85198 .47313 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.62917 .87631 m .64143 .87576 L .64466 .84688 L p
1 0 .624 r
F P
0 0 0 r
s
P
p
.002 w
.63534 .86419 m .64695 .8264 L .65142 .71978 L p
.471 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63967 .7852 m .63534 .86419 L p
.64155 .8084 L .471 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62324 .86477 m .63534 .86419 L .64029 .7739 L p
.87 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.63534 .86419 m .62324 .86477 L .617 .87686 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.617 .87686 m .62917 .87631 L .63534 .86419 L p
1 0 .498 r
F P
0 0 0 r
s
P
p
.002 w
.64695 .8264 m .63534 .86419 L .62917 .87631 L p
1 0 .624 r
F P
0 0 0 r
s
P
p
.002 w
.64466 .84688 m .64695 .8264 L p
.64374 .83543 L 1 0 .624 r
F P
0 0 0 r
s
P
p
.62917 .87631 m .64466 .84688 L .64374 .83543 L 1 0 .624 r
F
P
p
.002 w
.65142 .71978 m .64029 .7739 L .63967 .7852 L p
.471 0 1 r
F P
0 0 0 r
s
P
p
.64155 .8084 m .65142 .71978 L .63967 .7852 L .471 0 1 r
F
P
p
.82343 .24222 m .83599 .23962 L .84083 .24483 L 1 .034 0 r
F
P
p
.80592 .23959 m .82343 .24222 L .81096 .2448 L 1 .102 0 r
F
P
p
.79346 .24219 m .80592 .23959 L .81096 .2448 L 1 .136 0 r
F
P
p
.77584 .23956 m .79346 .24219 L .78108 .24478 L 1 .068 0 r
F
P
p
.76348 .24216 m .77584 .23956 L .78108 .24478 L 1 .17 0 r
F
P
p
.74577 .23954 m .76348 .24216 L .7512 .24475 L 1 .136 0 r
F
P
p
.7335 .24214 m .74577 .23954 L .7512 .24475 L 1 .17 0 r
F
P
p
.71569 .23951 m .7335 .24214 L .72132 .24472 L 1 .17 0 r
F
P
p
.70352 .24211 m .71569 .23951 L .72132 .24472 L 1 .239 0 r
F
P
p
.68561 .23948 m .70352 .24211 L .69143 .2447 L 1 .273 0 r
F
P
p
.67354 .24209 m .68561 .23948 L .69143 .2447 L 1 .273 0 r
F
P
p
.65553 .23946 m .67354 .24209 L .66155 .24467 L 1 .511 0 r
F
P
p
.64356 .24206 m .65553 .23946 L .66155 .24467 L 1 .614 0 r
F
P
p
.62545 .23943 m .64356 .24206 L .63166 .24464 L 1 .784 0 r
F
P
p
.61357 .24203 m .62545 .23943 L .63166 .24464 L 1 .989 0 r
F
P
p
.59536 .2394 m .61357 .24203 L .60177 .24462 L .659 1 0 r
F
P
p
.58358 .24201 m .59536 .2394 L .60177 .24462 L .114 1 0 r
F
P
p
.56527 .23938 m .58358 .24201 L .57188 .24459 L 0 .727 1 r
F
P
p
.55359 .24198 m .56527 .23938 L .57188 .24459 L 0 .727 1 r
F
P
p
.002 w
.55236 .88112 m .54081 .90143 L .534 .90052 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.53518 .23935 m .55359 .24198 L .54199 .24456 L 0 .727 1 r
F
P
p
.5236 .24195 m .53518 .23935 L .54199 .24456 L 0 .727 1 r
F
P
p
.50509 .23932 m .5236 .24195 L .51209 .24454 L 0 1 .318 r
F
P
p
.49361 .24193 m .50509 .23932 L .51209 .24454 L 0 1 .323 r
F
P
p
.475 .2393 m .49361 .24193 L .48219 .24451 L .212 1 0 r
F
P
p
.46361 .2419 m .475 .2393 L .48219 .24451 L 0 1 .305 r
F
P
p
.4449 .23927 m .46361 .2419 L .45229 .24449 L 0 .58 1 r
F
P
p
.43361 .24187 m .4449 .23927 L .45229 .24449 L 0 .193 1 r
F
P
p
.002 w
.43243 .90096 m .42122 .90141 L .41378 .89052 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.40243 .90095 m .41378 .89052 L .42122 .90141 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.41481 .23924 m .43361 .24187 L .42239 .24446 L .295 0 1 r
F
P
p
.40361 .24185 m .41481 .23924 L .42239 .24446 L .466 0 1 r
F
P
p
.002 w
.40243 .90095 m .39131 .90141 L .38372 .89052 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.37243 .90095 m .38372 .89052 L .39131 .90141 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.38471 .23922 m .40361 .24185 L .39249 .24443 L 0 .727 1 r
F
P
p
.37361 .24182 m .38471 .23922 L .39249 .24443 L 0 .727 1 r
F
P
p
.3546 .23919 m .37361 .24182 L .36258 .24441 L 0 .25 1 r
F
P
p
.3436 .24179 m .3546 .23919 L .36258 .24441 L 0 .182 1 r
F
P
p
.3245 .23916 m .3436 .24179 L .33268 .24438 L .196 0 1 r
F
P
p
.3136 .24177 m .3245 .23916 L .33268 .24438 L .28 0 1 r
F
P
p
.29439 .23913 m .3136 .24177 L .30277 .24435 L .364 0 1 r
F
P
p
.28359 .24174 m .29439 .23913 L .30277 .24435 L .364 0 1 r
F
P
p
.26429 .23911 m .28359 .24174 L .27285 .24433 L .196 0 1 r
F
P
p
.25358 .24171 m .26429 .23911 L .27285 .24433 L .28 0 1 r
F
P
p
.23418 .23908 m .25358 .24171 L .24294 .2443 L .364 0 1 r
F
P
p
.22357 .24169 m .23418 .23908 L .24294 .2443 L .364 0 1 r
F
P
p
.20407 .23905 m .22357 .24169 L .21303 .24427 L .364 0 1 r
F
P
p
.19355 .24166 m .20407 .23905 L .21303 .24427 L .364 0 1 r
F
P
p
.17395 .23903 m .19355 .24166 L .18311 .24425 L .364 0 1 r
F
P
p
.16354 .24163 m .17395 .23903 L .18311 .24425 L .432 0 1 r
F
P
p
.14384 .239 m .16354 .24163 L .15319 .24422 L .943 0 1 r
F
P
p
.13352 .24161 m .14384 .239 L .15319 .24422 L 1 0 .545 r
F
P
p
.11372 .23897 m .13352 .24161 L .12327 .24419 L 1 0 .136 r
F
P
p
.1035 .24158 m .11372 .23897 L .12327 .24419 L 1 0 .136 r
F
P
p
.002 w
.61699 .81171 m .60537 .83057 L .59938 .87516 L p
1 0 .871 r
F P
0 0 0 r
s
P
p
.002 w
.56401 .8806 m .55236 .88112 L .54566 .90006 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.534 .90052 m .54566 .90006 L .55236 .88112 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.62872 .79962 m .61699 .81171 L .61123 .86535 L p
.996 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59938 .87516 m .61123 .86535 L .61699 .81171 L p
1 0 .871 r
F P
0 0 0 r
s
P
p
.002 w
.83936 .47498 m .82715 .48475 L .82189 .47311 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.002 w
.80973 .48437 m .82189 .47311 L .82715 .48475 L p
1 .233 0 r
F P
0 0 0 r
s
P
p
.002 w
.80973 .48437 m .79727 .48618 L .79213 .48254 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.77969 .48435 m .79213 .48254 L .79727 .48618 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.77969 .48435 m .76733 .48616 L .762 .48252 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.74966 .48434 m .762 .48252 L .76733 .48616 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.72596 .51616 m .71427 .53674 L .71256 .69905 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71427 .53674 m .70304 .57632 L .70217 .79301 L p
0 1 .565 r
F P
0 0 0 r
s
P
p
.002 w
.71256 .69905 m .7127 .68622 L p
.70445 .74489 L 0 1 .565 r
F P
0 0 0 r
s
P
p
.002 w
.7127 .68622 m .71427 .53674 L p
.70589 .71435 L 0 1 .565 r
F P
0 0 0 r
s
P
p
.70445 .74489 m .7127 .68622 L .70589 .71435 L 0 1 .565 r
F
P
p
.002 w
.71256 .69905 m .72434 .66803 L .72596 .51616 L p
.057 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70418 .58804 m .71635 .57678 L .72241 .64608 L p
0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.72241 .64608 m .72434 .66803 L p
.72064 .65339 L 0 1 .386 r
F P
0 0 0 r
s
P
p
.70418 .58804 m .72241 .64608 L .72064 .65339 L 0 1 .386 r
F
P
p
.002 w
.71256 .69905 m .70418 .58804 L p
.72064 .65339 L 0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.72434 .66803 m .71256 .69905 L p
.72064 .65339 L 0 1 .386 r
F P
0 0 0 r
s
P
p
.002 w
.70217 .79301 m .71256 .69905 L p
.70445 .74489 L 0 1 .565 r
F P
0 0 0 r
s
P
p
.002 w
.85198 .47313 m .86424 .46183 L .86891 .4656 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.81846 .23697 m .83599 .23962 L .82343 .24222 L 1 .034 0 r
F
P
p
.80592 .23959 m .81846 .23697 L .82343 .24222 L 1 .102 0 r
F
P
p
.78829 .23694 m .80592 .23959 L .79346 .24219 L 1 0 0 r
F
P
p
.77584 .23956 m .78829 .23694 L .79346 .24219 L 1 .068 0 r
F
P
p
.75811 .23692 m .77584 .23956 L .76348 .24216 L 1 .102 0 r
F
P
p
.74577 .23954 m .75811 .23692 L .76348 .24216 L 1 .136 0 r
F
P
p
.72794 .23689 m .74577 .23954 L .7335 .24214 L 1 .136 0 r
F
P
p
.71569 .23951 m .72794 .23689 L .7335 .24214 L 1 .17 0 r
F
P
p
.69776 .23686 m .71569 .23951 L .70352 .24211 L 1 .273 0 r
F
P
p
.68561 .23948 m .69776 .23686 L .70352 .24211 L 1 .273 0 r
F
P
p
.002 w
.64029 .7739 m .62872 .79962 L .62324 .86477 L p
.87 0 1 r
F P
0 0 0 r
s
P
p
.66758 .23684 m .68561 .23948 L .67354 .24209 L 1 .375 0 r
F
P
p
.65553 .23946 m .66758 .23684 L .67354 .24209 L 1 .511 0 r
F
P
p
.6374 .23681 m .65553 .23946 L .64356 .24206 L 1 .614 0 r
F
P
p
.62545 .23943 m .6374 .23681 L .64356 .24206 L 1 .784 0 r
F
P
p
.002 w
.61123 .86535 m .62324 .86477 L .62872 .79962 L p
.996 0 1 r
F P
0 0 0 r
s
P
p
.60722 .23678 m .62545 .23943 L .61357 .24203 L 1 .886 0 r
F
P
p
.59536 .2394 m .60722 .23678 L .61357 .24203 L .659 1 0 r
F
P
p
.57703 .23676 m .59536 .2394 L .58358 .24201 L 0 .818 1 r
F
P
p
.56527 .23938 m .57703 .23676 L .58358 .24201 L 0 .727 1 r
F
P
p
.54684 .23673 m .56527 .23938 L .55359 .24198 L 0 .727 1 r
F
P
p
.53518 .23935 m .54684 .23673 L .55359 .24198 L 0 .727 1 r
F
P
p
.51665 .2367 m .53518 .23935 L .5236 .24195 L 0 1 .269 r
F
P
p
.50509 .23932 m .51665 .2367 L .5236 .24195 L 0 1 .318 r
F
P
p
.48646 .23667 m .50509 .23932 L .49361 .24193 L .597 1 0 r
F
P
p
.475 .2393 m .48646 .23667 L .49361 .24193 L .212 1 0 r
F
P
p
.45627 .23665 m .475 .2393 L .46361 .2419 L 0 .944 1 r
F
P
p
.4449 .23927 m .45627 .23665 L .46361 .2419 L 0 .58 1 r
F
P
p
.002 w
.44372 .9005 m .43243 .90096 L .42517 .88005 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.41378 .89052 m .42517 .88005 L .43243 .90096 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.42607 .23662 m .4449 .23927 L .43361 .24187 L 0 .011 1 r
F
P
p
.41481 .23924 m .42607 .23662 L .43361 .24187 L .295 0 1 r
F
P
p
.002 w
.41378 .89052 m .40243 .90095 L .39487 .89003 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.38372 .89052 m .39487 .89003 L .40243 .90095 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.39588 .23659 m .41481 .23924 L .40361 .24185 L 0 .727 1 r
F
P
p
.38471 .23922 m .39588 .23659 L .40361 .24185 L 0 .727 1 r
F
P
p
.002 w
.38372 .89052 m .37243 .90095 L .36449 .90003 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.36568 .23657 m .38471 .23922 L .37361 .24182 L 0 .334 1 r
F
P
p
.3546 .23919 m .36568 .23657 L .37361 .24182 L 0 .25 1 r
F
P
p
.33547 .23654 m .3546 .23919 L .3436 .24179 L .196 0 1 r
F
P
p
.3245 .23916 m .33547 .23654 L .3436 .24179 L .196 0 1 r
F
P
p
.002 w
.32332 .90048 m .31242 .90094 L .30439 .89001 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.29321 .90048 m .30439 .89001 L .31242 .90094 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.30527 .23651 m .3245 .23916 L .3136 .24177 L .196 0 1 r
F
P
p
.29439 .23913 m .30527 .23651 L .3136 .24177 L .364 0 1 r
F
P
p
.27506 .23649 m .29439 .23913 L .28359 .24174 L .196 0 1 r
F
P
p
.26429 .23911 m .27506 .23649 L .28359 .24174 L .196 0 1 r
F
P
p
.002 w
.82189 .47311 m .83449 .47126 L .83936 .47498 L p
1 .165 0 r
F P
0 0 0 r
s
P
p
.24486 .23646 m .26429 .23911 L .25358 .24171 L .196 0 1 r
F
P
p
.23418 .23908 m .24486 .23646 L .25358 .24171 L .364 0 1 r
F
P
p
.21465 .23643 m .23418 .23908 L .22357 .24169 L .28 0 1 r
F
P
p
.20407 .23905 m .21465 .23643 L .22357 .24169 L .364 0 1 r
F
P
p
.18443 .23641 m .20407 .23905 L .19355 .24166 L .364 0 1 r
F
P
p
.17395 .23903 m .18443 .23641 L .19355 .24166 L .364 0 1 r
F
P
p
.15422 .23638 m .17395 .23903 L .16354 .24163 L .534 0 1 r
F
P
p
.14384 .239 m .15422 .23638 L .16354 .24163 L .943 0 1 r
F
P
p
.12401 .23635 m .14384 .239 L .13352 .24161 L 1 0 .239 r
F
P
p
.11372 .23897 m .12401 .23635 L .13352 .24161 L 1 0 .136 r
F
P
p
.002 w
.70304 .57632 m .69301 .67416 L .69109 .7757 L p
0 .549 1 r
F P
0 0 0 r
s
P
p
.69332 .7626 m .70304 .57632 L .69109 .7757 L 0 .549 1 r
F
P
p
.002 w
.69022 .82205 m .70217 .79301 L .70304 .57632 L p
0 .549 1 r
F P
0 0 0 r
s
P
p
.002 w
.69226 .609 m .70418 .58804 L .70997 .6647 L p
0 1 .906 r
F P
0 0 0 r
s
P
p
.002 w
.70997 .6647 m .71256 .69905 L p
.70775 .67772 L 0 1 .906 r
F P
0 0 0 r
s
P
p
.69226 .609 m .70997 .6647 L .70775 .67772 L 0 1 .906 r
F
P
p
.002 w
.69109 .7757 m .69022 .82205 L p
.69332 .7626 L 0 .549 1 r
F P
0 0 0 r
s
P
p
.09379 .23632 m .11372 .23897 L .1035 .24158 L 1 0 .136 r
F
P
p
.002 w
.57573 .88008 m .56401 .8806 L .55739 .8996 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.54566 .90006 m .55739 .8996 L .56401 .8806 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.82189 .47311 m .80973 .48437 L .8043 .47124 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.79213 .48254 m .8043 .47124 L .80973 .48437 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.79213 .48254 m .77969 .48435 L .77442 .48069 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.762 .48252 m .77442 .48069 L .77969 .48435 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.762 .48252 m .74966 .48434 L .7467 .56707 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.42517 .88005 m .41378 .89052 L .4061 .88953 L p
1 0 .307 r
F P
0 0 0 r
s
P
p
.002 w
.39487 .89003 m .4061 .88953 L .41378 .89052 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.39487 .89003 m .38372 .89052 L .37563 .89957 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.36449 .90003 m .37563 .89957 L .38372 .89052 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.81846 .23697 m .83108 .23434 L .83599 .23962 L 1 .034 0 r
F
P
p
.80081 .23431 m .81846 .23697 L .80592 .23959 L 1 0 0 r
F
P
p
.78829 .23694 m .80081 .23431 L .80592 .23959 L 1 0 0 r
F
P
p
.77054 .23428 m .78829 .23694 L .77584 .23956 L 1 .034 0 r
F
P
p
.75811 .23692 m .77054 .23428 L .77584 .23956 L 1 .102 0 r
F
P
p
.74027 .23425 m .75811 .23692 L .74577 .23954 L 1 .136 0 r
F
P
p
.72794 .23689 m .74027 .23425 L .74577 .23954 L 1 .136 0 r
F
P
p
.70999 .23423 m .72794 .23689 L .71569 .23951 L 1 .205 0 r
F
P
p
.69776 .23686 m .70999 .23423 L .71569 .23951 L 1 .273 0 r
F
P
p
.67971 .2342 m .69776 .23686 L .68561 .23948 L 1 .273 0 r
F
P
p
.66758 .23684 m .67971 .2342 L .68561 .23948 L 1 .375 0 r
F
P
p
.64943 .23417 m .66758 .23684 L .65553 .23946 L 1 .511 0 r
F
P
p
.6374 .23681 m .64943 .23417 L .65553 .23946 L 1 .614 0 r
F
P
p
.61915 .23415 m .6374 .23681 L .62545 .23943 L 1 .682 0 r
F
P
p
.60722 .23678 m .61915 .23415 L .62545 .23943 L 1 .886 0 r
F
P
p
.58887 .23412 m .60722 .23678 L .59536 .2394 L 0 1 .545 r
F
P
p
.57703 .23676 m .58887 .23412 L .59536 .2394 L 0 .818 1 r
F
P
p
.55858 .23409 m .57703 .23676 L .56527 .23938 L 0 .818 1 r
F
P
p
.54684 .23673 m .55858 .23409 L .56527 .23938 L 0 .727 1 r
F
P
p
.52829 .23406 m .54684 .23673 L .53518 .23935 L 0 1 .201 r
F
P
p
.51665 .2367 m .52829 .23406 L .53518 .23935 L 0 1 .269 r
F
P
p
.498 .23404 m .51665 .2367 L .50509 .23932 L .636 1 0 r
F
P
p
.48646 .23667 m .498 .23404 L .50509 .23932 L .597 1 0 r
F
P
p
.46771 .23401 m .48646 .23667 L .475 .2393 L 0 1 .783 r
F
P
p
.45627 .23665 m .46771 .23401 L .475 .2393 L 0 .944 1 r
F
P
p
.002 w
.45508 .90004 m .44372 .9005 L .43648 .87952 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.42517 .88005 m .43648 .87952 L .44372 .9005 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.43741 .23398 m .45627 .23665 L .4449 .23927 L 0 .273 1 r
F
P
p
.42607 .23662 m .43741 .23398 L .4449 .23927 L 0 .011 1 r
F
P
p
.40712 .23396 m .42607 .23662 L .41481 .23924 L 0 .775 1 r
F
P
p
.39588 .23659 m .40712 .23396 L .41481 .23924 L 0 .727 1 r
F
P
p
.37682 .23393 m .39588 .23659 L .38471 .23922 L 0 .35 1 r
F
P
p
.36568 .23657 m .37682 .23393 L .38471 .23922 L 0 .334 1 r
F
P
p
.34652 .2339 m .36568 .23657 L .3546 .23919 L .128 0 1 r
F
P
p
.33547 .23654 m .34652 .2339 L .3546 .23919 L .196 0 1 r
F
P
p
.002 w
.33429 .90003 m .32332 .90048 L .31532 .88952 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.30439 .89001 m .31532 .88952 L .32332 .90048 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.31622 .23387 m .33547 .23654 L .3245 .23916 L .028 0 1 r
F
P
p
.30527 .23651 m .31622 .23387 L .3245 .23916 L .196 0 1 r
F
P
p
.002 w
.30439 .89001 m .29321 .90048 L .28472 .89955 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.28591 .23385 m .30527 .23651 L .29439 .23913 L .062 0 1 r
F
P
p
.27506 .23649 m .28591 .23385 L .29439 .23913 L .196 0 1 r
F
P
p
.002 w
.86424 .46183 m .85198 .47313 L .84711 .46803 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.83449 .47126 m .84711 .46803 L .85198 .47313 L p
1 .131 0 r
F P
0 0 0 r
s
P
p
.25561 .23382 m .27506 .23649 L .26429 .23911 L .028 0 1 r
F
P
p
.24486 .23646 m .25561 .23382 L .26429 .23911 L .196 0 1 r
F
P
p
.002 w
.83449 .47126 m .82189 .47311 L .81651 .45989 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.8043 .47124 m .81651 .45989 L .82189 .47311 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.2253 .23379 m .24486 .23646 L .23418 .23908 L .196 0 1 r
F
P
p
.21465 .23643 m .2253 .23379 L .23418 .23908 L .28 0 1 r
F
P
p
.19499 .23377 m .21465 .23643 L .20407 .23905 L .364 0 1 r
F
P
p
.18443 .23641 m .19499 .23377 L .20407 .23905 L .364 0 1 r
F
P
p
.16467 .23374 m .18443 .23641 L .17395 .23903 L .364 0 1 r
F
P
p
.15422 .23638 m .16467 .23374 L .17395 .23903 L .534 0 1 r
F
P
p
.13436 .23371 m .15422 .23638 L .14384 .239 L 1 0 .58 r
F
P
p
.12401 .23635 m .13436 .23371 L .14384 .239 L 1 0 .239 r
F
P
p
.10404 .23368 m .12401 .23635 L .11372 .23897 L 1 0 .136 r
F
P
p
.09379 .23632 m .10404 .23368 L .11372 .23897 L 1 0 .136 r
F
P
p
.002 w
.58753 .87955 m .57573 .88008 L .5692 .89913 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.55739 .8996 m .5692 .89913 L .57573 .88008 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.43648 .87952 m .42517 .88005 L .4174 .88903 L p
1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.4061 .88953 m .4174 .88903 L .42517 .88005 L p
1 0 .307 r
F P
0 0 0 r
s
P
p
.002 w
.8043 .47124 m .79213 .48254 L .78693 .47885 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.77442 .48069 m .78693 .47885 L .79213 .48254 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.77442 .48069 m .762 .48252 L .75659 .47883 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7467 .56707 m .75659 .47883 L .762 .48252 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.46652 .89958 m .45508 .90004 L .44832 .83907 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.002 w
.44832 .83907 m .45982 .82846 L .46652 .89958 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.002 w
.43648 .87952 m .44832 .83907 L .45508 .90004 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.45982 .82846 m .44832 .83907 L .44084 .83774 L p
.977 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44832 .83907 m .43648 .87952 L .42891 .87845 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.42891 .87845 m .44084 .83774 L .44832 .83907 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.4061 .88953 m .39487 .89003 L .38704 .88903 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.37563 .89957 m .38704 .88903 L .39487 .89003 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.31532 .88952 m .30439 .89001 L .29564 .89909 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.28472 .89955 m .29564 .89909 L .30439 .89001 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.002 w
.84711 .46803 m .85951 .458 L .86424 .46183 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.81342 .23166 m .83108 .23434 L .81846 .23697 L 1 0 0 r
F
P
p
.80081 .23431 m .81342 .23166 L .81846 .23697 L 1 0 0 r
F
P
p
.78305 .23163 m .80081 .23431 L .78829 .23694 L 1 0 0 r
F
P
p
.77054 .23428 m .78305 .23163 L .78829 .23694 L 1 .034 0 r
F
P
p
.75267 .2316 m .77054 .23428 L .75811 .23692 L 1 .102 0 r
F
P
p
.74027 .23425 m .75267 .2316 L .75811 .23692 L 1 .136 0 r
F
P
p
.7223 .23157 m .74027 .23425 L .72794 .23689 L 1 .136 0 r
F
P
p
.70999 .23423 m .7223 .23157 L .72794 .23689 L 1 .205 0 r
F
P
p
.69192 .23155 m .70999 .23423 L .69776 .23686 L 1 .273 0 r
F
P
p
.67971 .2342 m .69192 .23155 L .69776 .23686 L 1 .273 0 r
F
P
p
.66154 .23152 m .67971 .2342 L .66758 .23684 L 1 .375 0 r
F
P
p
.64943 .23417 m .66154 .23152 L .66758 .23684 L 1 .511 0 r
F
P
p
.63116 .23149 m .64943 .23417 L .6374 .23681 L 1 .477 0 r
F
P
p
.61915 .23415 m .63116 .23149 L .6374 .23681 L 1 .682 0 r
F
P
p
.60078 .23146 m .61915 .23415 L .60722 .23678 L 0 1 0 r
F
P
p
.58887 .23412 m .60078 .23146 L .60722 .23678 L 0 1 .545 r
F
P
p
.57039 .23144 m .58887 .23412 L .57703 .23676 L 0 1 .987 r
F
P
p
.55858 .23409 m .57039 .23144 L .57703 .23676 L 0 .818 1 r
F
P
p
.54001 .23141 m .55858 .23409 L .54684 .23673 L 0 1 .182 r
F
P
p
.52829 .23406 m .54001 .23141 L .54684 .23673 L 0 1 .201 r
F
P
p
.50962 .23138 m .52829 .23406 L .51665 .2367 L .821 1 0 r
F
P
p
.498 .23404 m .50962 .23138 L .51665 .2367 L .636 1 0 r
F
P
p
.47922 .23135 m .498 .23404 L .48646 .23667 L 0 1 .543 r
F
P
p
.46771 .23401 m .47922 .23135 L .48646 .23667 L 0 1 .783 r
F
P
p
.44883 .23133 m .46771 .23401 L .45627 .23665 L 0 .444 1 r
F
P
p
.43741 .23398 m .44883 .23133 L .45627 .23665 L 0 .273 1 r
F
P
p
.41844 .2313 m .43741 .23398 L .42607 .23662 L 0 .866 1 r
F
P
p
.40712 .23396 m .41844 .2313 L .42607 .23662 L 0 .775 1 r
F
P
p
.38804 .23127 m .40712 .23396 L .39588 .23659 L 0 .538 1 r
F
P
p
.37682 .23393 m .38804 .23127 L .39588 .23659 L 0 .35 1 r
F
P
p
.002 w
.37563 .89957 m .36449 .90003 L .35668 .88902 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.34533 .89956 m .35668 .88902 L .36449 .90003 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.35764 .23125 m .37682 .23393 L .36568 .23657 L 0 .028 1 r
F
P
p
.34652 .2339 m .35764 .23125 L .36568 .23657 L .128 0 1 r
F
P
p
.002 w
.34533 .89956 m .33429 .90003 L .32632 .88902 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.31532 .88952 m .32632 .88902 L .33429 .90003 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.32724 .23122 m .34652 .2339 L .33547 .23654 L .028 0 1 r
F
P
p
.31622 .23387 m .32724 .23122 L .33547 .23654 L .028 0 1 r
F
P
p
.29683 .23119 m .31622 .23387 L .30527 .23651 L 0 .157 1 r
F
P
p
.28591 .23385 m .29683 .23119 L .30527 .23651 L .062 0 1 r
F
P
p
.26643 .23116 m .28591 .23385 L .27506 .23649 L 0 .044 1 r
F
P
p
.25561 .23382 m .26643 .23116 L .27506 .23649 L .028 0 1 r
F
P
p
.002 w
.84711 .46803 m .83449 .47126 L .82916 .45798 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.002 w
.81651 .45989 m .82916 .45798 L .83449 .47126 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.23602 .23114 m .25561 .23382 L .24486 .23646 L .04 0 1 r
F
P
p
.2253 .23379 m .23602 .23114 L .24486 .23646 L .196 0 1 r
F
P
p
.002 w
.81651 .45989 m .8043 .47124 L .79916 .46747 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.78693 .47885 m .79916 .46747 L .8043 .47124 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.20561 .23111 m .2253 .23379 L .21465 .23643 L .28 0 1 r
F
P
p
.19499 .23377 m .20561 .23111 L .21465 .23643 L .364 0 1 r
F
P
p
.1752 .23108 m .19499 .23377 L .18443 .23641 L .364 0 1 r
F
P
p
.16467 .23374 m .1752 .23108 L .18443 .23641 L .364 0 1 r
F
P
p
.14478 .23105 m .16467 .23374 L .15422 .23638 L .875 0 1 r
F
P
p
.13436 .23371 m .14478 .23105 L .15422 .23638 L 1 0 .58 r
F
P
p
.11437 .23103 m .13436 .23371 L .12401 .23635 L 1 0 .239 r
F
P
p
.10404 .23368 m .11437 .23103 L .12401 .23635 L 1 0 .136 r
F
P
p
.002 w
.59938 .87516 m .58753 .87955 L .58108 .89866 L p
1 0 .286 r
F P
0 0 0 r
s
P
p
.002 w
.5692 .89913 m .58108 .89866 L .58753 .87955 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.47803 .89912 m .46652 .89958 L .45982 .82846 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.45982 .82846 m .47127 .82777 L .47803 .89912 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.47127 .82777 m .45982 .82846 L .4524 .82706 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44084 .83774 m .4524 .82706 L .45982 .82846 L p
.977 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4174 .88903 m .42891 .87845 L p
.43173 .88189 L 1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.42891 .87845 m .4174 .88903 L .4116 .88828 L p
1 0 .307 r
F P
0 0 0 r
s
P
p
.002 w
.4116 .88828 m .40966 .88802 L p
.41449 .88562 L 1 0 .307 r
F P
0 0 0 r
s
P
p
.41449 .88562 m .42891 .87845 L .4116 .88828 L 1 0 .307 r
F
P
p
.002 w
.40966 .88802 m .42108 .88752 L .42891 .87845 L p
1 0 .307 r
F P
0 0 0 r
s
P
p
.002 w
.42891 .87845 m .42108 .88752 L p
.42606 .87498 L 1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.44084 .83774 m .42891 .87845 L p
.42606 .87498 L 1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.42891 .87845 m .43648 .87952 L p
.43173 .88189 L 1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.42108 .88752 m .43272 .87683 L .43477 .86697 L p
1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.43477 .86697 m .44084 .83774 L p
.42606 .87498 L 1 0 .511 r
F P
0 0 0 r
s
P
p
.42108 .88752 m .43477 .86697 L .42606 .87498 L 1 0 .511 r
F
P
p
.002 w
.53672 .82566 m .52493 .82637 L .51813 .70571 L p
.091 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.51813 .70571 m .52979 .70461 L .53672 .82566 L p
.091 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50618 .80558 m .51813 .70571 L .52493 .82637 L p
.432 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52979 .70461 m .51813 .70571 L .5111 .70349 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.51813 .70571 m .50618 .80558 L .49946 .7046 L p
0 .386 1 r
F P
0 0 0 r
s
P
p
.002 w
.49946 .7046 m .5111 .70349 L .51813 .70571 L p
0 .386 1 r
F P
0 0 0 r
s
P
p
.002 w
.78693 .47885 m .77442 .48069 L .76908 .47698 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.75659 .47883 m .76908 .47698 L .77442 .48069 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.4174 .88903 m .4061 .88953 L .39831 .88853 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.38704 .88903 m .39831 .88853 L .4061 .88953 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.32632 .88902 m .31532 .88952 L .30663 .89862 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.29564 .89909 m .30663 .89862 L .31532 .88952 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.82916 .45798 m .81651 .45989 L .81145 .45604 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79916 .46747 m .81145 .45604 L .81651 .45989 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.81342 .23166 m .82611 .22898 L .83108 .23434 L 1 0 0 r
F
P
p
.79564 .22896 m .81342 .23166 L .80081 .23431 L 1 0 0 r
F
P
p
.78305 .23163 m .79564 .22896 L .80081 .23431 L 1 0 0 r
F
P
p
.76516 .22893 m .78305 .23163 L .77054 .23428 L 1 .034 0 r
F
P
p
.75267 .2316 m .76516 .22893 L .77054 .23428 L 1 .102 0 r
F
P
p
.73469 .2289 m .75267 .2316 L .74027 .23425 L 1 .102 0 r
F
P
p
.7223 .23157 m .73469 .2289 L .74027 .23425 L 1 .136 0 r
F
P
p
.70421 .22887 m .7223 .23157 L .70999 .23423 L 1 .239 0 r
F
P
p
.69192 .23155 m .70421 .22887 L .70999 .23423 L 1 .273 0 r
F
P
p
.67373 .22885 m .69192 .23155 L .67971 .2342 L 1 .273 0 r
F
P
p
.66154 .23152 m .67373 .22885 L .67971 .2342 L 1 .375 0 r
F
P
p
.64325 .22882 m .66154 .23152 L .64943 .23417 L 1 .477 0 r
F
P
p
.63116 .23149 m .64325 .22882 L .64943 .23417 L 1 .477 0 r
F
P
p
.61277 .22879 m .63116 .23149 L .61915 .23415 L .206 1 0 r
F
P
p
.60078 .23146 m .61277 .22879 L .61915 .23415 L 0 1 0 r
F
P
p
.58228 .22876 m .60078 .23146 L .58887 .23412 L 0 1 .792 r
F
P
p
.57039 .23144 m .58228 .22876 L .58887 .23412 L 0 1 .987 r
F
P
p
.5518 .22874 m .57039 .23144 L .55858 .23409 L 0 1 .023 r
F
P
p
.54001 .23141 m .5518 .22874 L .55858 .23409 L 0 1 .182 r
F
P
p
.52131 .22871 m .54001 .23141 L .52829 .23406 L 1 .94 0 r
F
P
p
.50962 .23138 m .52131 .22871 L .52829 .23406 L .821 1 0 r
F
P
p
.002 w
.50842 .89912 m .49681 .89959 L .48974 .87847 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.47803 .89912 m .48974 .87847 L .49681 .89959 L closepath p
1 0 .205 r
F P
0 0 0 r
s
P
p
.49082 .22868 m .50962 .23138 L .498 .23404 L 0 1 .373 r
F
P
p
.47922 .23135 m .49082 .22868 L .498 .23404 L 0 1 .543 r
F
P
p
.002 w
.61123 .86535 m .59938 .87516 L .59305 .89819 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.58108 .89866 m .59305 .89819 L .59938 .87516 L p
1 0 .286 r
F P
0 0 0 r
s
P
p
.46032 .22865 m .47922 .23135 L .46771 .23401 L 0 .58 1 r
F
P
p
.44883 .23133 m .46032 .22865 L .46771 .23401 L 0 .444 1 r
F
P
p
.42983 .22863 m .44883 .23133 L .43741 .23398 L 0 1 1 r
F
P
p
.41844 .2313 m .42983 .22863 L .43741 .23398 L 0 .866 1 r
F
P
p
.002 w
.85951 .458 m .84711 .46803 L .84189 .45606 L p
1 .029 0 r
F P
0 0 0 r
s
P
p
.002 w
.82916 .45798 m .84189 .45606 L .84711 .46803 L p
1 .063 0 r
F P
0 0 0 r
s
P
p
.39933 .2286 m .41844 .2313 L .40712 .23396 L 0 .775 1 r
F
P
p
.38804 .23127 m .39933 .2286 L .40712 .23396 L 0 .538 1 r
F
P
p
.002 w
.38704 .88903 m .37563 .89957 L .36785 .88852 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.35668 .88902 m .36785 .88852 L .37563 .89957 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.36883 .22857 m .38804 .23127 L .37682 .23393 L 0 .178 1 r
F
P
p
.35764 .23125 m .36883 .22857 L .37682 .23393 L 0 .028 1 r
F
P
p
.002 w
.35668 .88902 m .34533 .89956 L .33739 .88852 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.32632 .88902 m .33739 .88852 L .34533 .89956 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.33833 .22854 m .35764 .23125 L .34652 .2339 L 0 .106 1 r
F
P
p
.32724 .23122 m .33833 .22854 L .34652 .2339 L .028 0 1 r
F
P
p
.30782 .22852 m .32724 .23122 L .31622 .23387 L 0 .241 1 r
F
P
p
.29683 .23119 m .30782 .22852 L .31622 .23387 L 0 .157 1 r
F
P
p
.27732 .22849 m .29683 .23119 L .28591 .23385 L 0 .25 1 r
F
P
p
.26643 .23116 m .27732 .22849 L .28591 .23385 L 0 .044 1 r
F
P
p
.24681 .22846 m .26643 .23116 L .25561 .23382 L 0 .116 1 r
F
P
p
.23602 .23114 m .24681 .22846 L .25561 .23382 L .04 0 1 r
F
P
p
.2163 .22843 m .23602 .23114 L .2253 .23379 L .196 0 1 r
F
P
p
.20561 .23111 m .2163 .22843 L .2253 .23379 L .28 0 1 r
F
P
p
.18579 .22841 m .20561 .23111 L .19499 .23377 L .364 0 1 r
F
P
p
.1752 .23108 m .18579 .22841 L .19499 .23377 L .364 0 1 r
F
P
p
.15527 .22838 m .1752 .23108 L .16467 .23374 L .466 0 1 r
F
P
p
.14478 .23105 m .15527 .22838 L .16467 .23374 L .875 0 1 r
F
P
p
.12476 .22835 m .14478 .23105 L .13436 .23371 L 1 0 .648 r
F
P
p
.11437 .23103 m .12476 .22835 L .13436 .23371 L 1 0 .239 r
F
P
p
.002 w
.69301 .67416 m .68377 .82425 L .67772 .82279 L p
.398 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.67772 .82279 m .69022 .82205 L .69301 .67416 L p
.398 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5506 .89866 m .53881 .89913 L .5319 .82778 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.5319 .82778 m .54363 .82708 L .5506 .89866 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.52011 .89865 m .5319 .82778 L .53881 .89913 L closepath p
1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.54363 .82708 m .5319 .82778 L .52493 .82637 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5319 .82778 m .52011 .89865 L .51322 .82707 L p
1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.51322 .82707 m .52493 .82637 L .5319 .82778 L p
1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.48974 .87847 m .47803 .89912 L .47127 .82777 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.47127 .82777 m .48281 .82707 L .48974 .87847 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.48281 .82707 m .47127 .82777 L .46391 .82635 L p
.841 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4524 .82706 m .46391 .82635 L p
.465 .82753 L .909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4524 .82706 m .44084 .83774 L .43272 .87683 L p
1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.44476 .83571 m .4524 .82706 L p
.44849 .83693 L 1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.43272 .87683 m .44476 .83571 L p
.44849 .83693 L 1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.44476 .83571 m .43713 .83433 L p
.44098 .83447 L .909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46391 .82635 m .4524 .82706 L .44476 .83571 L p
.977 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44476 .83571 m .45634 .83503 L .46391 .82635 L p
.977 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45634 .83503 m .44476 .83571 L p
.44098 .83447 L .909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46391 .82635 m .45634 .83503 L p
.46281 .82516 L .875 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47565 .80557 m .46391 .82635 L p
.46281 .82516 L .875 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46391 .82635 m .47127 .82777 L p
.465 .82753 L .909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59135 .82423 m .5793 .82495 L .57182 .67737 L p
0 .091 1 r
F P
0 0 0 r
s
P
p
.002 w
.57182 .67737 m .58369 .67617 L .59135 .82423 L p
0 .091 1 r
F P
0 0 0 r
s
P
p
.002 w
.56012 .70462 m .57182 .67737 L .5793 .82495 L p
0 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58369 .67617 m .57182 .67737 L .5651 .67168 L p
0 1 .825 r
F P
0 0 0 r
s
P
p
.002 w
.57182 .67737 m .56012 .70462 L .55327 .67616 L p
0 1 .989 r
F P
0 0 0 r
s
P
p
.002 w
.55327 .67616 m .5651 .67168 L .57182 .67737 L p
0 1 .989 r
F P
0 0 0 r
s
P
p
.002 w
.70418 .58804 m .69226 .609 L .68411 .49966 L p
.807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68411 .49966 m .69613 .48832 L .70418 .58804 L p
.807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67249 .53007 m .68411 .49966 L .69226 .609 L p
.386 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69613 .48832 m .68411 .49966 L .67777 .47692 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.68411 .49966 m .67249 .53007 L .66576 .4883 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.66576 .4883 m .67777 .47692 L .68411 .49966 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.5793 .82495 m .56733 .82566 L .56012 .70462 L p
0 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.54859 .82494 m .56012 .70462 L .56733 .82566 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.56012 .70462 m .54859 .82494 L .54152 .69368 L p
0 .443 1 r
F P
0 0 0 r
s
P
p
.002 w
.54152 .69368 m .55327 .67616 L .56012 .70462 L p
0 .443 1 r
F P
0 0 0 r
s
P
p
.002 w
.54859 .82494 m .53672 .82566 L .52979 .70461 L p
.057 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52979 .70461 m .54152 .69368 L .54859 .82494 L p
.057 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.54152 .69368 m .52979 .70461 L .52281 .70238 L p
0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.5111 .70349 m .52281 .70238 L .52979 .70461 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.48735 .79476 m .49946 .7046 L .50618 .80558 L p
.261 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.5111 .70349 m .49946 .7046 L .49177 .79228 L p
0 .148 1 r
F P
0 0 0 r
s
P
p
.002 w
.49946 .7046 m .48735 .79476 L .48002 .79311 L p
.193 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48002 .79311 m .49177 .79228 L .49946 .7046 L p
.193 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.79916 .46747 m .78693 .47885 L .78165 .47511 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.76908 .47698 m .78165 .47511 L .78693 .47885 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76908 .47698 m .75659 .47883 L .75111 .4751 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.75659 .47883 m .7467 .56707 L .73946 .50571 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.73946 .50571 m .75111 .4751 L .75659 .47883 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.69226 .609 m .68121 .67256 L .67249 .53007 L p
.386 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6612 .57983 m .67249 .53007 L .68121 .67256 L p
0 1 .255 r
F P
0 0 0 r
s
P
p
.002 w
.67249 .53007 m .6612 .57983 L .65395 .50919 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.65395 .50919 m .66576 .4883 L .67249 .53007 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.65395 .50919 m .64272 .56859 L .63524 .47876 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.63524 .47876 m .64733 .4769 L .65395 .50919 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.62466 .59627 m .63524 .47876 L .64272 .56859 L p
.534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63524 .47876 m .62466 .59627 L .61755 .53462 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64733 .4769 m .63524 .47876 L .62972 .53293 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.61755 .53462 m .62972 .53293 L .63524 .47876 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52011 .89865 m .50842 .89912 L .50154 .83775 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.002 w
.50154 .83775 m .51322 .82707 L .52011 .89865 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.002 w
.48974 .87847 m .50154 .83775 L .50842 .89912 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.51322 .82707 m .50154 .83775 L .49453 .80635 L p
.807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50154 .83775 m .48974 .87847 L .48281 .82707 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.48281 .82707 m .49453 .80635 L .50154 .83775 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.39831 .88853 m .40966 .88802 L .4174 .88903 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.39831 .88853 m .38704 .88903 L .3791 .88802 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.36785 .88852 m .3791 .88802 L .38704 .88903 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.62324 .86477 m .61123 .86535 L .6051 .89772 L p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.59305 .89819 m .6051 .89772 L .61123 .86535 L p
1 0 .33 r
F P
0 0 0 r
s
P
p
.002 w
.36785 .88852 m .35668 .88902 L .34854 .88801 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.33739 .88852 m .34854 .88801 L .35668 .88902 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.33739 .88852 m .32632 .88902 L .31769 .89815 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.30663 .89862 m .31769 .89815 L .32632 .88902 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.84189 .45606 m .85471 .45412 L .85951 .458 L p
1 .029 0 r
F P
0 0 0 r
s
P
p
.002 w
.84189 .45606 m .82916 .45798 L .82416 .4541 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.81145 .45604 m .82416 .4541 L .82916 .45798 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.64272 .56859 m .65395 .50919 L .6612 .57983 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.66576 .4883 m .65395 .50919 L .64733 .4769 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.80831 .22627 m .82611 .22898 L .81342 .23166 L 1 0 0 r
F
P
p
.79564 .22896 m .80831 .22627 L .81342 .23166 L 1 0 0 r
F
P
p
.77774 .22624 m .79564 .22896 L .78305 .23163 L 1 0 0 r
F
P
p
.76516 .22893 m .77774 .22624 L .78305 .23163 L 1 .034 0 r
F
P
p
.74716 .22621 m .76516 .22893 L .75267 .2316 L 1 .034 0 r
F
P
p
.73469 .2289 m .74716 .22621 L .75267 .2316 L 1 .102 0 r
F
P
p
.71659 .22619 m .73469 .2289 L .7223 .23157 L 1 .205 0 r
F
P
p
.70421 .22887 m .71659 .22619 L .7223 .23157 L 1 .239 0 r
F
P
p
.002 w
.71635 .57678 m .70418 .58804 L .69613 .48832 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.69613 .48832 m .70821 .47694 L .71635 .57678 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.70821 .47694 m .69613 .48832 L .69004 .47506 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.67777 .47692 m .69004 .47506 L .69613 .48832 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.68601 .22616 m .70421 .22887 L .69192 .23155 L 1 .273 0 r
F
P
p
.67373 .22885 m .68601 .22616 L .69192 .23155 L 1 .273 0 r
F
P
p
.002 w
.67777 .47692 m .66576 .4883 L .6595 .47504 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.64733 .4769 m .6595 .47504 L .66576 .4883 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.65542 .22613 m .67373 .22885 L .66154 .23152 L 1 .477 0 r
F
P
p
.64325 .22882 m .65542 .22613 L .66154 .23152 L 1 .477 0 r
F
P
p
.62484 .2261 m .64325 .22882 L .63116 .23149 L .695 1 0 r
F
P
p
.61277 .22879 m .62484 .2261 L .63116 .23149 L .206 1 0 r
F
P
p
.59425 .22607 m .61277 .22879 L .60078 .23146 L 0 1 .657 r
F
P
p
.58228 .22876 m .59425 .22607 L .60078 .23146 L 0 1 .792 r
F
P
p
.002 w
.58108 .89866 m .5692 .89913 L .56239 .87794 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.5506 .89866 m .56239 .87794 L .5692 .89913 L closepath p
1 0 .205 r
F P
0 0 0 r
s
P
p
.56367 .22605 m .58228 .22876 L .57039 .23144 L .274 1 0 r
F
P
p
.5518 .22874 m .56367 .22605 L .57039 .23144 L 0 1 .023 r
F
P
p
.002 w
.55327 .67616 m .54152 .69368 L .54034 .69329 L p
0 .977 1 r
F P
0 0 0 r
s
P
p
.54309 .68445 m .55327 .67616 L .54034 .69329 L 0 .977 1 r
F
P
p
.002 w
.5346 .69137 m .54152 .69368 L p
.52773 .70009 L 0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.52281 .70238 m .53309 .69277 L p
.52773 .70009 L 0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.53309 .69277 m .5346 .69137 L p
.52773 .70009 L 0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.5651 .67168 m .55327 .67616 L .54642 .67373 L p
0 1 .765 r
F P
0 0 0 r
s
P
p
.002 w
.5346 .69137 m .54642 .67373 L .55327 .67616 L p
0 .977 1 r
F P
0 0 0 r
s
P
p
.002 w
.54642 .67373 m .5582 .63433 L .5651 .67168 L p
0 1 .765 r
F P
0 0 0 r
s
P
p
.002 w
.55144 .67003 m .55203 .66693 L p
.54981 .67241 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.55203 .66693 m .5582 .63433 L p
.5463 .67475 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.5395 .69783 m .55203 .66693 L .5463 .67475 L 0 1 .868 r
F
P
p
.002 w
.54642 .67373 m .54352 .68382 L p
.54978 .66293 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.54352 .68382 m .5395 .69783 L p
.54487 .67959 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.54487 .67959 m .54978 .66293 L .54352 .68382 L 0 1 .868 r
F
P
p
.002 w
.57692 .65276 m .5651 .67168 L .5582 .63433 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.5582 .63433 m .57001 .60894 L .57692 .65276 L p
0 1 .477 r
F P
0 0 0 r
s
P
p
.002 w
.57001 .60894 m .5582 .63433 L .55144 .67003 L p
0 1 .523 r
F P
0 0 0 r
s
P
p
.002 w
.55144 .67003 m .56344 .65758 L .57001 .60894 L p
0 1 .523 r
F P
0 0 0 r
s
P
p
.002 w
.55144 .67003 m .54828 .66889 L p
.55806 .6604 L 0 1 .587 r
F P
0 0 0 r
s
P
p
.002 w
.5582 .63433 m .54642 .67373 L p
.54978 .66293 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.54828 .66889 m .54447 .66751 L p
.54957 .66484 L 0 1 .587 r
F P
0 0 0 r
s
P
p
.54957 .66484 m .55806 .6604 L .54828 .66889 L 0 1 .587 r
F
P
p
.002 w
.56344 .65758 m .55144 .67003 L p
.55806 .6604 L 0 1 .587 r
F P
0 0 0 r
s
P
p
.002 w
.5395 .69783 m .55144 .67003 L p
.54981 .67241 L 0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.54034 .69329 m .5346 .69137 L p
.54309 .68445 L 0 .977 1 r
F P
0 0 0 r
s
P
p
.53308 .22602 m .5518 .22874 L .54001 .23141 L 1 .886 0 r
F
P
p
.52131 .22871 m .53308 .22602 L .54001 .23141 L 1 .94 0 r
F
P
p
.50248 .22599 m .52131 .22871 L .50962 .23138 L 0 1 .182 r
F
P
p
.49082 .22868 m .50248 .22599 L .50962 .23138 L 0 1 .373 r
F
P
p
.47189 .22596 m .49082 .22868 L .47922 .23135 L 0 .791 1 r
F
P
p
.46032 .22865 m .47189 .22596 L .47922 .23135 L 0 .58 1 r
F
P
p
.44129 .22594 m .46032 .22865 L .44883 .23133 L 0 1 .909 r
F
P
p
.42983 .22863 m .44129 .22594 L .44883 .23133 L 0 1 1 r
F
P
p
.4107 .22591 m .42983 .22863 L .41844 .2313 L 0 .866 1 r
F
P
p
.39933 .2286 m .4107 .22591 L .41844 .2313 L 0 .775 1 r
F
P
p
.3801 .22588 m .39933 .2286 L .38804 .23127 L 0 .484 1 r
F
P
p
.36883 .22857 m .3801 .22588 L .38804 .23127 L 0 .178 1 r
F
P
p
.34949 .22585 m .36883 .22857 L .35764 .23125 L 0 .312 1 r
F
P
p
.33833 .22854 m .34949 .22585 L .35764 .23125 L 0 .106 1 r
F
P
p
.31889 .22583 m .33833 .22854 L .32724 .23122 L 0 .241 1 r
F
P
p
.30782 .22852 m .31889 .22583 L .32724 .23122 L 0 .241 1 r
F
P
p
.28828 .2258 m .30782 .22852 L .29683 .23119 L 0 .384 1 r
F
P
p
.27732 .22849 m .28828 .2258 L .29683 .23119 L 0 .25 1 r
F
P
p
.002 w
.27612 .89862 m .26523 .89908 L .25684 .888 L p
1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.24561 .89861 m .25684 .888 L .26523 .89908 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.25767 .22577 m .27732 .22849 L .26643 .23116 L 0 .25 1 r
F
P
p
.24681 .22846 m .25767 .22577 L .26643 .23116 L 0 .116 1 r
F
P
p
.22706 .22574 m .24681 .22846 L .23602 .23114 L .124 0 1 r
F
P
p
.2163 .22843 m .22706 .22574 L .23602 .23114 L .196 0 1 r
F
P
p
.002 w
.81145 .45604 m .79916 .46747 L .7943 .47324 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.78165 .47511 m .7943 .47324 L .79916 .46747 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.19645 .22571 m .2163 .22843 L .20561 .23111 L .364 0 1 r
F
P
p
.18579 .22841 m .19645 .22571 L .20561 .23111 L .364 0 1 r
F
P
p
.16583 .22569 m .18579 .22841 L .1752 .23108 L .364 0 1 r
F
P
p
.15527 .22838 m .16583 .22569 L .1752 .23108 L .466 0 1 r
F
P
p
.13522 .22566 m .15527 .22838 L .14478 .23105 L .807 0 1 r
F
P
p
.12476 .22835 m .13522 .22566 L .14478 .23105 L 1 0 .648 r
F
P
p
.002 w
.56239 .87794 m .5506 .89866 L .54363 .82708 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.54363 .82708 m .55544 .82637 L .56239 .87794 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.55544 .82637 m .54363 .82708 L .53672 .82566 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52493 .82637 m .53672 .82566 L .54363 .82708 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52493 .82637 m .51322 .82707 L .50618 .80558 L p
.432 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49453 .80635 m .50618 .80558 L .51322 .82707 L p
.807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.49453 .80635 m .48281 .82707 L .47565 .80557 L p
.67 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46391 .82635 m .47565 .80557 L .48281 .82707 L p
.841 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60348 .8235 m .59135 .82423 L .58369 .67617 L p
0 .091 1 r
F P
0 0 0 r
s
P
p
.002 w
.58369 .67617 m .59564 .67497 L .60348 .8235 L p
0 .091 1 r
F P
0 0 0 r
s
P
p
.002 w
.59564 .67497 m .58369 .67617 L .57692 .65276 L p
0 1 .704 r
F P
0 0 0 r
s
P
p
.002 w
.5651 .67168 m .57692 .65276 L .58369 .67617 L p
0 1 .825 r
F P
0 0 0 r
s
P
p
.002 w
.52281 .70238 m .5111 .70349 L .50364 .78132 L p
0 .455 1 r
F P
0 0 0 r
s
P
p
.002 w
.49177 .79228 m .50364 .78132 L .5111 .70349 L p
0 .148 1 r
F P
0 0 0 r
s
P
p
.002 w
.50618 .80558 m .49453 .80635 L .48735 .79476 L p
.261 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47565 .80557 m .48735 .79476 L .49453 .80635 L p
.67 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.78165 .47511 m .76908 .47698 L .76367 .47322 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.75111 .4751 m .76367 .47322 L .76908 .47698 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.72856 .56548 m .71635 .57678 L .70821 .47694 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.70821 .47694 m .72058 .47508 L .72856 .56548 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.72058 .47508 m .70821 .47694 L .70239 .47318 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69004 .47506 m .70239 .47318 L .70821 .47694 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.69004 .47506 m .67777 .47692 L .67175 .47316 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.6595 .47504 m .67175 .47316 L .67777 .47692 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.68121 .67256 m .66971 .71809 L .6612 .57983 L p
0 1 .255 r
F P
0 0 0 r
s
P
p
.002 w
.65044 .66925 m .6612 .57983 L .66971 .71809 L p
0 .768 1 r
F P
0 0 0 r
s
P
p
.002 w
.6612 .57983 m .65044 .66925 L .64272 .56859 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6595 .47504 m .64733 .4769 L .6411 .47314 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.62972 .53293 m .6411 .47314 L .64733 .4769 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.40966 .88802 m .39831 .88853 L .39042 .88751 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.3791 .88802 m .39042 .88751 L .39831 .88853 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.617 .87686 m .62324 .86477 L p
.60949 .88974 L 1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.617 .87686 m .61001 .82495 L p
.62455 .86392 L 1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.62917 .87631 m .617 .87686 L p
.62455 .86392 L 1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.6051 .89772 m .617 .87686 L p
.60949 .88974 L 1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.3791 .88802 m .36785 .88852 L .35976 .88751 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.34854 .88801 m .35976 .88751 L .36785 .88852 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.34854 .88801 m .33739 .88852 L .3291 .8875 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.31769 .89815 m .3291 .8875 L .33739 .88852 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.28708 .89814 m .27612 .89862 L .26953 .83703 L p
1 0 .545 r
F P
0 0 0 r
s
P
p
.002 w
.26953 .83703 m .28045 .83635 L .28708 .89814 L p
1 0 .545 r
F P
0 0 0 r
s
P
p
.002 w
.25684 .888 m .26953 .83703 L .27612 .89862 L p
1 0 .375 r
F P
0 0 0 r
s
P
p
.002 w
.26953 .83703 m .25684 .888 L .24798 .88697 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.28045 .83635 m .26953 .83703 L .25931 .87625 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.24798 .88697 m .25931 .87625 L .26953 .83703 L p
1 0 .477 r
F P
0 0 0 r
s
P
p
.002 w
.85471 .45412 m .84189 .45606 L .83696 .45216 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82416 .4541 m .83696 .45216 L .84189 .45606 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.82416 .4541 m .81145 .45604 L .80704 .47135 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.7943 .47324 m .80704 .47135 L .81145 .45604 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.80831 .22627 m .82107 .22356 L .82611 .22898 L 1 0 0 r
F
P
p
.7904 .22353 m .80831 .22627 L .79564 .22896 L 1 0 0 r
F
P
p
.77774 .22624 m .7904 .22353 L .79564 .22896 L 1 0 0 r
F
P
p
.75972 .22351 m .77774 .22624 L .76516 .22893 L 1 0 0 r
F
P
p
.74716 .22621 m .75972 .22351 L .76516 .22893 L 1 .034 0 r
F
P
p
.72904 .22348 m .74716 .22621 L .73469 .2289 L 1 .136 0 r
F
P
p
.71659 .22619 m .72904 .22348 L .73469 .2289 L 1 .205 0 r
F
P
p
.69836 .22345 m .71659 .22619 L .70421 .22887 L 1 .273 0 r
F
P
p
.68601 .22616 m .69836 .22345 L .70421 .22887 L 1 .273 0 r
F
P
p
.66768 .22342 m .68601 .22616 L .67373 .22885 L 1 .477 0 r
F
P
p
.65542 .22613 m .66768 .22342 L .67373 .22885 L 1 .477 0 r
F
P
p
.63699 .22339 m .65542 .22613 L .64325 .22882 L 1 .955 0 r
F
P
p
.62484 .2261 m .63699 .22339 L .64325 .22882 L .695 1 0 r
F
P
p
.6063 .22337 m .62484 .2261 L .61277 .22879 L 0 1 .203 r
F
P
p
.59425 .22607 m .6063 .22337 L .61277 .22879 L 0 1 .657 r
F
P
p
.002 w
.59305 .89819 m .58108 .89866 L .5743 .8774 L p
1 0 .341 r
F P
0 0 0 r
s
P
p
.002 w
.56239 .87794 m .5743 .8774 L .58108 .89866 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.57561 .22334 m .59425 .22607 L .58228 .22876 L .412 1 0 r
F
P
p
.56367 .22605 m .57561 .22334 L .58228 .22876 L .274 1 0 r
F
P
p
.54492 .22331 m .56367 .22605 L .5518 .22874 L 1 .761 0 r
F
P
p
.53308 .22602 m .54492 .22331 L .5518 .22874 L 1 .886 0 r
F
P
p
.51423 .22328 m .53308 .22602 L .52131 .22871 L 0 1 .011 r
F
P
p
.50248 .22599 m .51423 .22328 L .52131 .22871 L 0 1 .182 r
F
P
p
.48353 .22326 m .50248 .22599 L .49082 .22868 L 0 1 .925 r
F
P
p
.47189 .22596 m .48353 .22326 L .49082 .22868 L 0 .791 1 r
F
P
p
.45284 .22323 m .47189 .22596 L .46032 .22865 L 0 1 .761 r
F
P
p
.44129 .22594 m .45284 .22323 L .46032 .22865 L 0 1 .909 r
F
P
p
.42214 .2232 m .44129 .22594 L .42983 .22863 L 0 .909 1 r
F
P
p
.4107 .22591 m .42214 .2232 L .42983 .22863 L 0 .866 1 r
F
P
p
.39144 .22317 m .4107 .22591 L .39933 .2286 L 0 .727 1 r
F
P
p
.3801 .22588 m .39144 .22317 L .39933 .2286 L 0 .484 1 r
F
P
p
.36073 .22314 m .3801 .22588 L .36883 .22857 L 0 .447 1 r
F
P
p
.34949 .22585 m .36073 .22314 L .36883 .22857 L 0 .312 1 r
F
P
p
.33003 .22312 m .34949 .22585 L .33833 .22854 L 0 .429 1 r
F
P
p
.31889 .22583 m .33003 .22312 L .33833 .22854 L 0 .241 1 r
F
P
p
.29932 .22309 m .31889 .22583 L .30782 .22852 L 0 .447 1 r
F
P
p
.28828 .2258 m .29932 .22309 L .30782 .22852 L 0 .384 1 r
F
P
p
.002 w
.30922 .89719 m .29811 .89767 L .29273 .79553 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.29273 .79553 m .30375 .79471 L .30922 .89719 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.28045 .83635 m .29273 .79553 L .29811 .89767 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.30375 .79471 m .29273 .79553 L .28413 .79389 L p
.474 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29273 .79553 m .28045 .83635 L .27174 .83498 L p
.773 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27174 .83498 m .28413 .79389 L .29273 .79553 L p
.773 0 1 r
F P
0 0 0 r
s
P
p
.26861 .22306 m .28828 .2258 L .27732 .22849 L 0 .384 1 r
F
P
p
.25767 .22577 m .26861 .22306 L .27732 .22849 L 0 .25 1 r
F
P
p
.002 w
.25684 .888 m .24561 .89861 L .23669 .89766 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.2379 .22303 m .25767 .22577 L .24681 .22846 L .052 0 1 r
F
P
p
.22706 .22574 m .2379 .22303 L .24681 .22846 L .124 0 1 r
F
P
p
.20718 .223 m .22706 .22574 L .2163 .22843 L .364 0 1 r
F
P
p
.19645 .22571 m .20718 .223 L .2163 .22843 L .364 0 1 r
F
P
p
.17647 .22298 m .19645 .22571 L .18579 .22841 L .364 0 1 r
F
P
p
.16583 .22569 m .17647 .22298 L .18579 .22841 L .364 0 1 r
F
P
p
.14575 .22295 m .16583 .22569 L .15527 .22838 L .466 0 1 r
F
P
p
.13522 .22566 m .14575 .22295 L .15527 .22838 L .807 0 1 r
F
P
p
.002 w
.65915 .82568 m .64695 .8264 L .64143 .87576 L p
1 0 .795 r
F P
0 0 0 r
s
P
p
.002 w
.63127 .61874 m .64272 .56859 L .65044 .66925 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.002 w
.64272 .56859 m .63127 .61874 L .62466 .59627 L p
.534 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63824 .67048 m .62616 .67498 L .61917 .62014 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.61917 .62014 m .63127 .61874 L .63824 .67048 L p
0 1 .534 r
F P
0 0 0 r
s
P
p
.002 w
.60763 .67047 m .61917 .62014 L .62616 .67498 L p
0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.63127 .61874 m .61917 .62014 L .61274 .61733 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.61917 .62014 m .60763 .67047 L .60066 .61873 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.002 w
.60066 .61873 m .61274 .61733 L .61917 .62014 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.002 w
.5743 .8774 m .56239 .87794 L .55544 .82637 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.55544 .82637 m .56733 .82566 L .5743 .8774 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.56733 .82566 m .55544 .82637 L .54859 .82494 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.53672 .82566 m .54859 .82494 L .55544 .82637 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6467 .82278 m .63439 .82351 L .62616 .67498 L p
0 .102 1 r
F P
0 0 0 r
s
P
p
.002 w
.62616 .67498 m .63824 .67048 L .6467 .82278 L p
0 .102 1 r
F P
0 0 0 r
s
P
p
.002 w
.61458 .72022 m .62616 .67498 L .63439 .82351 L p
.061 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.62616 .67498 m .61458 .72022 L .60763 .67047 L p
0 1 .868 r
F P
0 0 0 r
s
P
p
.002 w
.61458 .72022 m .60348 .8235 L .59564 .67497 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.59564 .67497 m .60763 .67047 L .61458 .72022 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.60763 .67047 m .59564 .67497 L .58877 .63434 L p
0 1 .584 r
F P
0 0 0 r
s
P
p
.002 w
.57692 .65276 m .58877 .63434 L .59564 .67497 L p
0 1 .704 r
F P
0 0 0 r
s
P
p
.002 w
.5346 .69137 m .52281 .70238 L .51573 .70011 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.50364 .78132 m .51573 .70011 L .52281 .70238 L p
0 .455 1 r
F P
0 0 0 r
s
P
p
.002 w
.48735 .79476 m .47565 .80557 L .46808 .8242 L p
.636 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45634 .83503 m .46808 .8242 L .47565 .80557 L p
.875 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58877 .63434 m .57692 .65276 L .57001 .60894 L p
0 1 .238 r
F P
0 0 0 r
s
P
p
.002 w
.7943 .47324 m .78165 .47511 L .7763 .47133 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76367 .47322 m .7763 .47133 L .78165 .47511 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.76367 .47322 m .75111 .4751 L .74556 .47131 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.75111 .4751 m .73946 .50571 L .73303 .4732 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.73303 .4732 m .74556 .47131 L .75111 .4751 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.73946 .50571 m .72856 .56548 L .72058 .47508 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.72058 .47508 m .73303 .4732 L .73946 .50571 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.73303 .4732 m .72058 .47508 L .71482 .47129 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.70239 .47318 m .71482 .47129 L .72058 .47508 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.70239 .47318 m .69004 .47506 L .68408 .47127 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67175 .47316 m .68408 .47127 L .69004 .47506 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67175 .47316 m .6595 .47504 L .65333 .47125 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.6411 .47314 m .65333 .47125 L .6595 .47504 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.42108 .88752 m .40966 .88802 L .40182 .887 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.39042 .88751 m .40182 .887 L .40966 .88802 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.39042 .88751 m .3791 .88802 L .37106 .887 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.35976 .88751 m .37106 .887 L .3791 .88802 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.35976 .88751 m .34854 .88801 L .34029 .88699 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.3291 .8875 m .34029 .88699 L .34854 .88801 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.29811 .89767 m .28708 .89814 L .28045 .83635 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.25931 .87625 m .27174 .83498 L .28045 .83635 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.23669 .89766 m .24798 .88697 L .25684 .888 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.83696 .45216 m .84985 .45019 L .85471 .45412 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.83696 .45216 m .82416 .4541 L .81986 .46945 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.80704 .47135 m .81986 .46945 L .82416 .4541 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.72856 .56548 m .73946 .50571 L .7467 .56707 L p
.568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.71256 .69905 m .70217 .79301 L .69226 .609 L p
0 1 .906 r
F P
0 0 0 r
s
P
p
.002 w
.68121 .67256 m .69226 .609 L .70217 .79301 L p
0 .401 1 r
F P
0 0 0 r
s
P
p
.002 w
.58877 .63434 m .60066 .61873 L .60763 .67047 L p
0 1 .584 r
F P
0 0 0 r
s
P
p
.002 w
.60066 .61873 m .58877 .63434 L .58191 .59773 L p
0 1 .058 r
F P
0 0 0 r
s
P
p
.002 w
.58191 .59773 m .58877 .63434 L p
.57021 .60922 L 0 1 .238 r
F P
0 0 0 r
s
P
p
.002 w
.58191 .59773 m .59384 .58572 L .60066 .61873 L p
0 1 .058 r
F P
0 0 0 r
s
P
p
.002 w
.58191 .59773 m .57539 .62886 L p
.59364 .5862 L .044 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59384 .58572 m .58191 .59773 L p
.59364 .5862 L .044 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57001 .60894 m .58191 .59773 L p
.57021 .60922 L 0 1 .238 r
F P
0 0 0 r
s
P
p
.002 w
.58191 .59773 m .57001 .60894 L .56344 .65758 L p
0 1 .273 r
F P
0 0 0 r
s
P
p
.80314 .22081 m .82107 .22356 L .80831 .22627 L 1 0 0 r
F
P
p
.7904 .22353 m .80314 .22081 L .80831 .22627 L 1 0 0 r
F
P
p
.77236 .22078 m .7904 .22353 L .77774 .22624 L 1 0 0 r
F
P
p
.75972 .22351 m .77236 .22078 L .77774 .22624 L 1 0 0 r
F
P
p
.74158 .22075 m .75972 .22351 L .74716 .22621 L 1 .068 0 r
F
P
p
.72904 .22348 m .74158 .22075 L .74716 .22621 L 1 .136 0 r
F
P
p
.71079 .22072 m .72904 .22348 L .71659 .22619 L 1 .273 0 r
F
P
p
.69836 .22345 m .71079 .22072 L .71659 .22619 L 1 .273 0 r
F
P
p
.68001 .2207 m .69836 .22345 L .68601 .22616 L 1 .375 0 r
F
P
p
.66768 .22342 m .68001 .2207 L .68601 .22616 L 1 .477 0 r
F
P
p
.64922 .22067 m .66768 .22342 L .65542 .22613 L 1 .886 0 r
F
P
p
.63699 .22339 m .64922 .22067 L .65542 .22613 L 1 .955 0 r
F
P
p
.61843 .22064 m .63699 .22339 L .62484 .2261 L .49 1 0 r
F
P
p
.6063 .22337 m .61843 .22064 L .62484 .2261 L 0 1 .203 r
F
P
p
.002 w
.62466 .59627 m .61274 .61733 L .60546 .53629 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60546 .53629 m .61755 .53462 L .62466 .59627 L p
.432 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59384 .58572 m .60546 .53629 L .61274 .61733 L p
.196 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61755 .53462 m .60546 .53629 L .59936 .58113 L p
.639 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60546 .53629 m .59384 .58572 L .58941 .58418 L p
.403 1 0 r
F P
0 0 0 r
s
P
p
.59056 .57478 m .60546 .53629 L .58941 .58418 L .403 1 0 r
F
P
p
.002 w
.58941 .58418 m .58721 .58342 L p
.59056 .57478 L .403 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58721 .58342 m .59936 .58113 L .60546 .53629 L p
.403 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61138 .56061 m .61755 .53462 L p
.60259 .57287 L .639 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59936 .58113 m .61138 .56061 L p
.60259 .57287 L .639 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62972 .53293 m .61755 .53462 L .61138 .56061 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61138 .56061 m .62366 .55899 L .62972 .53293 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61138 .56061 m .60422 .49842 L p
.62023 .54828 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62366 .55899 m .61138 .56061 L p
.62023 .54828 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60422 .49842 m .61138 .56061 L p
.59759 .51748 L .844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59207 .50023 m .59985 .49907 L p
.59759 .51748 L .844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59985 .49907 m .60422 .49842 L p
.59759 .51748 L .844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.6051 .89772 m .59305 .89819 L .58615 .85659 L p
1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.5743 .8774 m .58615 .85659 L .59305 .89819 L p
1 0 .341 r
F P
0 0 0 r
s
P
p
.58764 .22061 m .6063 .22337 L .59425 .22607 L .456 1 0 r
F
P
p
.57561 .22334 m .58764 .22061 L .59425 .22607 L .412 1 0 r
F
P
p
.55685 .22058 m .57561 .22334 L .56367 .22605 L 1 .591 0 r
F
P
p
.54492 .22331 m .55685 .22058 L .56367 .22605 L 1 .761 0 r
F
P
p
.002 w
.51573 .70011 m .52758 .69898 L .5346 .69137 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.54642 .67373 m .5346 .69137 L .52758 .69898 L p
0 .852 1 r
F P
0 0 0 r
s
P
p
.52605 .22056 m .54492 .22331 L .53308 .22602 L .023 1 0 r
F
P
p
.51423 .22328 m .52605 .22056 L .53308 .22602 L 0 1 .011 r
F
P
p
.49526 .22053 m .51423 .22328 L .50248 .22599 L 0 1 .74 r
F
P
p
.48353 .22326 m .49526 .22053 L .50248 .22599 L 0 1 .925 r
F
P
p
.002 w
.46808 .8242 m .48002 .79311 L .48735 .79476 L p
.636 0 1 r
F P
0 0 0 r
s
P
p
.46446 .2205 m .48353 .22326 L .47189 .22596 L 0 1 .541 r
F
P
p
.45284 .22323 m .46446 .2205 L .47189 .22596 L 0 1 .761 r
F
P
p
.43366 .22047 m .45284 .22323 L .44129 .22594 L 0 .909 1 r
F
P
p
.42214 .2232 m .43366 .22047 L .44129 .22594 L 0 .909 1 r
F
P
p
.40285 .22044 m .42214 .2232 L .4107 .22591 L 0 .727 1 r
F
P
p
.39144 .22317 m .40285 .22044 L .4107 .22591 L 0 .727 1 r
F
P
p
.37205 .22042 m .39144 .22317 L .3801 .22588 L 0 .618 1 r
F
P
p
.36073 .22314 m .37205 .22042 L .3801 .22588 L 0 .447 1 r
F
P
p
.34124 .22039 m .36073 .22314 L .34949 .22585 L 0 .652 1 r
F
P
p
.33003 .22312 m .34124 .22039 L .34949 .22585 L 0 .429 1 r
F
P
p
.002 w
.3291 .8875 m .31769 .89815 L .30922 .89719 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.31043 .22036 m .33003 .22312 L .31889 .22583 L 0 .509 1 r
F
P
p
.29932 .22309 m .31043 .22036 L .31889 .22583 L 0 .447 1 r
F
P
p
.002 w
.30922 .89719 m .3204 .89671 L .3291 .8875 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.002 w
.3204 .89671 m .30922 .89719 L .30375 .79471 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.30375 .79471 m .31483 .79389 L .3204 .89671 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.326 .79307 m .31483 .79389 L .30663 .78213 L p
.214 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30663 .78213 m .31483 .79389 L p
.30201 .78835 L .44 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29543 .78551 m .30663 .78213 L p
.30201 .78835 L .44 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30663 .78213 m .31967 .71706 L .326 .79307 L p
.214 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30663 .78213 m .30637 .78446 L p
.3069 .78176 L .895 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31967 .71706 m .30663 .78213 L p
.3069 .78176 L .895 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31483 .79389 m .30375 .79471 L .29979 .79034 L p
.44 0 1 r
F P
0 0 0 r
s
P
p
.30201 .78835 m .31483 .79389 L .29979 .79034 L .44 0 1 r
F
P
p
.002 w
.30637 .78446 m .29444 .89374 L p
.31058 .78069 L .895 0 1 r
F P
0 0 0 r
s
P
p
.31058 .78069 m .31967 .71706 L .30637 .78446 L .895 0 1 r
F
P
p
.002 w
.29979 .79034 m .29543 .78551 L p
.30201 .78835 L .44 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28413 .79389 m .29543 .78551 L .30375 .79471 L p
.474 0 1 r
F P
0 0 0 r
s
P
p
.27962 .22033 m .29932 .22309 L .28828 .2258 L 0 .384 1 r
F
P
p
.26861 .22306 m .27962 .22033 L .28828 .2258 L 0 .384 1 r
F
P
p
.002 w
.63439 .82351 m .62216 .82423 L .61458 .72022 L p
.061 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.60348 .8235 m .61458 .72022 L .62216 .82423 L p
.561 0 1 r
F P
0 0 0 r
s
P
p
.2488 .2203 m .26861 .22306 L .25767 .22577 L 0 .01 1 r
F
P
p
.2379 .22303 m .2488 .2203 L .25767 .22577 L .052 0 1 r
F
P
p
.21799 .22028 m .2379 .22303 L .22706 .22574 L .321 0 1 r
F
P
p
.20718 .223 m .21799 .22028 L .22706 .22574 L .364 0 1 r
F
P
p
.18717 .22025 m .20718 .223 L .19645 .22571 L .364 0 1 r
F
P
p
.17647 .22298 m .18717 .22025 L .19645 .22571 L .364 0 1 r
F
P
p
.15635 .22022 m .17647 .22298 L .16583 .22569 L .364 0 1 r
F
P
p
.14575 .22295 m .15635 .22022 L .16583 .22569 L .466 0 1 r
F
P
p
.002 w
.67142 .82497 m .65915 .82568 L .65356 .86181 L p
1 0 .965 r
F P
0 0 0 r
s
P
p
.002 w
.64143 .87576 m .65356 .86181 L .65915 .82568 L p
1 0 .795 r
F P
0 0 0 r
s
P
p
.002 w
.6591 .82204 m .6467 .82278 L .63824 .67048 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.63824 .67048 m .65044 .66925 L .6591 .82204 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.65044 .66925 m .63824 .67048 L .63127 .61874 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.002 w
.61274 .61733 m .62466 .59627 L .63127 .61874 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.617 .87686 m .6051 .89772 L .59794 .82567 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.59794 .82567 m .61001 .82495 L .617 .87686 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.58615 .85659 m .59794 .82567 L .6051 .89772 L p
1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.61001 .82495 m .59794 .82567 L .59135 .82423 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59794 .82567 m .58615 .85659 L .5793 .82495 L p
1 0 .989 r
F P
0 0 0 r
s
P
p
.002 w
.5793 .82495 m .59135 .82423 L .59794 .82567 L p
1 0 .989 r
F P
0 0 0 r
s
P
p
.002 w
.61274 .61733 m .60066 .61873 L .59384 .58572 L p
.196 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58615 .85659 m .5743 .8774 L .56733 .82566 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.56733 .82566 m .5793 .82495 L .58615 .85659 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.52758 .69898 m .5395 .69783 L .54642 .67373 L p
0 .852 1 r
F P
0 0 0 r
s
P
p
.002 w
.56344 .65758 m .57539 .62886 L .58191 .59773 L p
0 1 .273 r
F P
0 0 0 r
s
P
p
.002 w
.80704 .47135 m .7943 .47324 L .78902 .46943 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.7763 .47133 m .78902 .46943 L .7943 .47324 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7763 .47133 m .76367 .47322 L .75788 .45976 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.74556 .47131 m .75788 .45976 L .76367 .47322 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.74556 .47131 m .73303 .4732 L .72708 .45974 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.71482 .47129 m .72708 .45974 L .73303 .4732 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.73529 .60758 m .72434 .66803 L .71635 .57678 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.002 w
.71635 .57678 m .72856 .56548 L .73529 .60758 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.002 w
.71482 .47129 m .70239 .47318 L .69649 .46937 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68408 .47127 m .69649 .46937 L .70239 .47318 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68408 .47127 m .67175 .47316 L .66564 .46935 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.65333 .47125 m .66564 .46935 L .67175 .47316 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.65333 .47125 m .6411 .47314 L .63561 .52778 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.62878 .49475 m .6322 .51129 L p
.62432 .50393 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.61646 .49659 m .6322 .51129 L .63082 .51998 L 1 .989 0 r
F
P
p
.002 w
.6411 .47314 m .62972 .53293 L .62671 .54589 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.62671 .54589 m .62366 .55899 L p
.62807 .53728 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.62807 .53728 m .6411 .47314 L .62671 .54589 L 1 .989 0 r
F
P
p
.002 w
.63561 .52778 m .6411 .47314 L p
.62807 .53728 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.62366 .55899 m .63561 .52778 L p
.62807 .53728 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.63561 .52778 m .648 .52604 L .65333 .47125 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.63561 .52778 m .62878 .49475 L p
.6432 .51822 L 1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.648 .52604 m .63561 .52778 L p
.6432 .51822 L 1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.63561 .52778 m .62366 .55899 L .61646 .49659 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.62878 .49475 m .64075 .46352 L .648 .52604 L p
1 .784 0 r
F P
0 0 0 r
s
P
p
.002 w
.62878 .49475 m .62264 .52073 L p
.63476 .48244 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.64075 .46352 m .62878 .49475 L p
.63476 .48244 L 1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.61646 .49659 m .62878 .49475 L p
.62432 .50393 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.6322 .51129 m .63561 .52778 L p
.63082 .51998 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.44476 .83571 m .43272 .87683 L .42499 .87572 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.42499 .87572 m .43713 .83433 L .44476 .83571 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.43272 .87683 m .42108 .88752 L .41329 .88649 L p
1 0 .341 r
F P
0 0 0 r
s
P
p
.002 w
.40182 .887 m .41329 .88649 L .42108 .88752 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.40182 .887 m .39042 .88751 L .38243 .88648 L p
1 0 .443 r
F P
0 0 0 r
s
P
p
.002 w
.37106 .887 m .38243 .88648 L .39042 .88751 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.37106 .887 m .35976 .88751 L .35156 .88648 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.34029 .88699 m .35156 .88648 L .35976 .88751 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.34029 .88699 m .3291 .8875 L .3204 .89671 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.84985 .45019 m .83696 .45216 L .83237 .45785 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.81986 .46945 m .83237 .45785 L .83696 .45216 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.80314 .22081 m .81596 .21807 L .82107 .22356 L 1 0 0 r
F
P
p
.78508 .21804 m .80314 .22081 L .7904 .22353 L 1 0 0 r
F
P
p
.77236 .22078 m .78508 .21804 L .7904 .22353 L 1 0 0 r
F
P
p
.7542 .21801 m .77236 .22078 L .75972 .22351 L 1 .068 0 r
F
P
p
.74158 .22075 m .7542 .21801 L .75972 .22351 L 1 .068 0 r
F
P
p
.72331 .21798 m .74158 .22075 L .72904 .22348 L 1 .239 0 r
F
P
p
.71079 .22072 m .72331 .21798 L .72904 .22348 L 1 .273 0 r
F
P
p
.69243 .21795 m .71079 .22072 L .69836 .22345 L 1 .273 0 r
F
P
p
.68001 .2207 m .69243 .21795 L .69836 .22345 L 1 .375 0 r
F
P
p
.002 w
.57539 .62886 m .58721 .58342 L .59384 .58572 L p
.044 1 0 r
F P
0 0 0 r
s
P
p
.66154 .21792 m .68001 .2207 L .66768 .22342 L 1 .75 0 r
F
P
p
.64922 .22067 m .66154 .21792 L .66768 .22342 L 1 .886 0 r
F
P
p
.63065 .2179 m .64922 .22067 L .63699 .22339 L .909 1 0 r
F
P
p
.61843 .22064 m .63065 .2179 L .63699 .22339 L .49 1 0 r
F
P
p
.59975 .21787 m .61843 .22064 L .6063 .22337 L .875 1 0 r
F
P
p
.58764 .22061 m .59975 .21787 L .6063 .22337 L .456 1 0 r
F
P
p
.56886 .21784 m .58764 .22061 L .57561 .22334 L 1 .511 0 r
F
P
p
.55685 .22058 m .56886 .21784 L .57561 .22334 L 1 .591 0 r
F
P
p
.53796 .21781 m .55685 .22058 L .54492 .22331 L .17 1 0 r
F
P
p
.52605 .22056 m .53796 .21781 L .54492 .22331 L .023 1 0 r
F
P
p
.50706 .21778 m .52605 .22056 L .51423 .22328 L 0 1 .671 r
F
P
p
.49526 .22053 m .50706 .21778 L .51423 .22328 L 0 1 .74 r
F
P
p
.47616 .21776 m .49526 .22053 L .48353 .22326 L 0 1 .359 r
F
P
p
.46446 .2205 m .47616 .21776 L .48353 .22326 L 0 1 .541 r
F
P
p
.44525 .21773 m .46446 .2205 L .45284 .22323 L 0 1 .943 r
F
P
p
.43366 .22047 m .44525 .21773 L .45284 .22323 L 0 .909 1 r
F
P
p
.41435 .2177 m .43366 .22047 L .42214 .2232 L 0 .761 1 r
F
P
p
.40285 .22044 m .41435 .2177 L .42214 .2232 L 0 .727 1 r
F
P
p
.38344 .21767 m .40285 .22044 L .39144 .22317 L 0 .761 1 r
F
P
p
.37205 .22042 m .38344 .21767 L .39144 .22317 L 0 .618 1 r
F
P
p
.35253 .21764 m .37205 .22042 L .36073 .22314 L 0 .686 1 r
F
P
p
.34124 .22039 m .35253 .21764 L .36073 .22314 L 0 .652 1 r
F
P
p
.32161 .21761 m .34124 .22039 L .33003 .22312 L 0 .564 1 r
F
P
p
.31043 .22036 m .32161 .21761 L .33003 .22312 L 0 .509 1 r
F
P
p
.002 w
.33193 .88595 m .3204 .89671 L .31483 .79389 L p
1 0 .852 r
F P
0 0 0 r
s
P
p
.002 w
.31483 .79389 m .326 .79307 L .33193 .88595 L p
1 0 .852 r
F P
0 0 0 r
s
P
p
.2907 .21759 m .31043 .22036 L .29932 .22309 L 0 .447 1 r
F
P
p
.27962 .22033 m .2907 .21759 L .29932 .22309 L 0 .384 1 r
F
P
p
.002 w
.29543 .78551 m .28413 .79389 L .27188 .89474 L p
1 0 .844 r
F P
0 0 0 r
s
P
p
.002 w
.28413 .79389 m .27174 .83498 L .26071 .89523 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.002 w
.26071 .89523 m .27188 .89474 L .28413 .79389 L p
1 0 .682 r
F P
0 0 0 r
s
P
p
.25978 .21756 m .27962 .22033 L .26861 .22306 L 0 .073 1 r
F
P
p
.2488 .2203 m .25978 .21756 L .26861 .22306 L 0 .01 1 r
F
P
p
.002 w
.24798 .88697 m .23669 .89766 L .22765 .8967 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.002 w
.36611 .88438 m .35464 .88491 L .35038 .71707 L p
.609 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35038 .71707 m .36166 .71599 L .36611 .88438 L p
.609 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3375 .78214 m .35038 .71707 L .35464 .88491 L p
.827 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36166 .71599 m .35038 .71707 L .34252 .69891 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.35038 .71707 m .3375 .78214 L .33085 .71598 L p
0 .345 1 r
F P
0 0 0 r
s
P
p
.002 w
.33085 .71598 m .34252 .69891 L .35038 .71707 L p
0 .345 1 r
F P
0 0 0 r
s
P
p
.22886 .21753 m .2488 .2203 L .2379 .22303 L .253 0 1 r
F
P
p
.21799 .22028 m .22886 .21753 L .2379 .22303 L .321 0 1 r
F
P
p
.002 w
.3375 .78214 m .326 .79307 L .31967 .71706 L p
0 .039 1 r
F P
0 0 0 r
s
P
p
.002 w
.33085 .71598 m .3375 .78214 L p
.32079 .72114 L 0 .039 1 r
F P
0 0 0 r
s
P
p
.002 w
.34325 .88543 m .33193 .88595 L .326 .79307 L p
1 0 .92 r
F P
0 0 0 r
s
P
p
.002 w
.326 .79307 m .3375 .78214 L .34325 .88543 L p
1 0 .92 r
F P
0 0 0 r
s
P
p
.002 w
.33085 .71598 m .31732 .89273 L p
.34097 .71078 L .623 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34252 .69891 m .33085 .71598 L p
.34097 .71078 L .623 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31967 .71706 m .33085 .71598 L p
.32079 .72114 L 0 .039 1 r
F P
0 0 0 r
s
P
p
.002 w
.33085 .71598 m .31967 .71706 L .30584 .89324 L p
.677 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29444 .89374 m .30584 .89324 L .31967 .71706 L p
.895 0 1 r
F P
0 0 0 r
s
P
p
.19794 .2175 m .21799 .22028 L .20718 .223 L .364 0 1 r
F
P
p
.18717 .22025 m .19794 .2175 L .20718 .223 L .364 0 1 r
F
P
p
.16702 .21747 m .18717 .22025 L .17647 .22298 L .364 0 1 r
F
P
p
.15635 .22022 m .16702 .21747 L .17647 .22298 L .364 0 1 r
F
P
p
.002 w
.68377 .82425 m .67142 .82497 L .6653 .82352 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.65356 .86181 m .6653 .82352 L .67142 .82497 L p
1 0 .965 r
F P
0 0 0 r
s
P
p
.002 w
.66971 .71809 m .6591 .82204 L .65044 .66925 L p
0 .768 1 r
F P
0 0 0 r
s
P
p
.002 w
.61001 .82495 m .62216 .82423 L .62917 .87631 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.62216 .82423 m .61001 .82495 L .60348 .8235 L p
.561 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.59135 .82423 m .60348 .8235 L .61001 .82495 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41329 .88649 m .42499 .87572 L .43272 .87683 L p
1 0 .341 r
F P
0 0 0 r
s
P
p
.002 w
.70217 .79301 m .69022 .82205 L .68121 .67256 L p
0 .401 1 r
F P
0 0 0 r
s
P
p
.002 w
.66971 .71809 m .68121 .67256 L .69022 .82205 L p
.061 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52758 .69898 m .51573 .70011 L .50856 .69782 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.51573 .70011 m .50364 .78132 L .49674 .69896 L p
0 .455 1 r
F P
0 0 0 r
s
P
p
.002 w
.49674 .69896 m .50856 .69782 L .51573 .70011 L p
0 .455 1 r
F P
0 0 0 r
s
P
p
.002 w
.81986 .46945 m .80704 .47135 L .80111 .44818 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.78902 .46943 m .80111 .44818 L .80704 .47135 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.78902 .46943 m .7763 .47133 L .77057 .45781 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.75788 .45976 m .77057 .45781 L .7763 .47133 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.75788 .45976 m .74556 .47131 L .73966 .45779 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.72708 .45974 m .73966 .45779 L .74556 .47131 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.72708 .45974 m .71482 .47129 L .70899 .46745 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.69649 .46937 m .70899 .46745 L .71482 .47129 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69649 .46937 m .68408 .47127 L .67804 .46743 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.66564 .46935 m .67804 .46743 L .68408 .47127 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.66564 .46935 m .65333 .47125 L .648 .52604 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.46808 .8242 m .45634 .83503 L .44922 .7931 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43713 .83433 m .44922 .7931 L .45634 .83503 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41329 .88649 m .40182 .887 L .39481 .83501 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.38243 .88648 m .39481 .83501 L .40182 .887 L p
1 0 .443 r
F P
0 0 0 r
s
P
p
.002 w
.39481 .83501 m .40626 .83432 L .41329 .88649 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.40626 .83432 m .39481 .83501 L .38682 .83362 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.39481 .83501 m .38243 .88648 L .37432 .88544 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.37432 .88544 m .38682 .83362 L .39481 .83501 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.38243 .88648 m .37106 .887 L .3629 .88596 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.35156 .88648 m .3629 .88596 L .37106 .887 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.35156 .88648 m .34029 .88699 L .33193 .88595 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.3204 .89671 m .33193 .88595 L .34029 .88699 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.25931 .87625 m .24798 .88697 L .2386 .89621 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.2386 .89621 m .24962 .89572 L .25931 .87625 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.27174 .83498 m .25931 .87625 L .24962 .89572 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.24962 .89572 m .26071 .89523 L .27174 .83498 L p
1 0 .409 r
F P
0 0 0 r
s
P
p
.002 w
.22765 .8967 m .2386 .89621 L .24798 .88697 L p
1 0 .17 r
F P
0 0 0 r
s
P
p
.002 w
.83237 .45785 m .84493 .44621 L .84985 .45019 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.30663 .78213 m .29543 .78551 L .28312 .89424 L p
1 0 .878 r
F P
0 0 0 r
s
P
p
.002 w
.27188 .89474 m .28312 .89424 L .29543 .78551 L p
1 0 .844 r
F P
0 0 0 r
s
P
p
.79789 .21528 m .81596 .21807 L .80314 .22081 L 1 0 0 r
F
P
p
.78508 .21804 m .79789 .21528 L .80314 .22081 L 1 0 0 r
F
P
p
.76691 .21525 m .78508 .21804 L .77236 .22078 L 1 .068 0 r
F
P
p
.7542 .21801 m .76691 .21525 L .77236 .22078 L 1 .068 0 r
F
P
p
.73592 .21522 m .7542 .21801 L .74158 .22075 L 1 .205 0 r
F
P
p
.72331 .21798 m .73592 .21522 L .74158 .22075 L 1 .239 0 r
F
P
p
.70493 .21519 m .72331 .21798 L .71079 .22072 L 1 .273 0 r
F
P
p
.69243 .21795 m .70493 .21519 L .71079 .22072 L 1 .273 0 r
F
P
p
.67393 .21516 m .69243 .21795 L .68001 .2207 L 1 .511 0 r
F
P
p
.66154 .21792 m .67393 .21516 L .68001 .2207 L 1 .75 0 r
F
P
p
.64294 .21513 m .66154 .21792 L .64922 .22067 L 1 .92 0 r
F
P
p
.63065 .2179 m .64294 .21513 L .64922 .22067 L .909 1 0 r
F
P
p
.61194 .21511 m .63065 .2179 L .61843 .22064 L 1 .716 0 r
F
P
p
.59975 .21787 m .61194 .21511 L .61843 .22064 L .875 1 0 r
F
P
p
.58094 .21508 m .59975 .21787 L .58764 .22061 L 1 .477 0 r
F
P
p
.56886 .21784 m .58094 .21508 L .58764 .22061 L 1 .511 0 r
F
P
p
.002 w
.58721 .58342 m .57539 .62886 L .56813 .53289 L p
.485 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56813 .53289 m .58006 .51173 L .58721 .58342 L p
.485 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55632 .5834 m .56813 .53289 L .57539 .62886 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57539 .62886 m .56344 .65758 L .55632 .5834 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54447 .66751 m .55632 .5834 L .56344 .65758 L p
0 1 .587 r
F P
0 0 0 r
s
P
p
.002 w
.58006 .51173 m .56813 .53289 L .5619 .68957 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.5395 .69783 m .53244 .6955 L p
.54539 .67814 L 0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.55144 .67003 m .54582 .68311 L p
.54539 .67814 L 0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.54582 .68311 m .5395 .69783 L p
.54539 .67814 L 0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.53244 .6955 m .54447 .66751 L .55144 .67003 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.54447 .66751 m .53244 .6955 L .52529 .69315 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.52529 .69315 m .53741 .69196 L .54447 .66751 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.54447 .66751 m .53741 .69196 L p
.54353 .65679 L 0 1 .807 r
F P
0 0 0 r
s
P
p
.002 w
.55632 .5834 m .54447 .66751 L p
.54353 .65679 L 0 1 .807 r
F P
0 0 0 r
s
P
p
.002 w
.56813 .53289 m .55632 .5834 L .54961 .69077 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.002 w
.54961 .69077 m .5619 .68957 L .56813 .53289 L p
0 1 .352 r
F P
0 0 0 r
s
P
p
.54994 .21505 m .56886 .21784 L .55685 .22058 L .33 1 0 r
F
P
p
.53796 .21781 m .54994 .21505 L .55685 .22058 L .17 1 0 r
F
P
p
.51894 .21502 m .53796 .21781 L .52605 .22056 L 0 1 .659 r
F
P
p
.50706 .21778 m .51894 .21502 L .52605 .22056 L 0 1 .671 r
F
P
p
.48793 .21499 m .50706 .21778 L .49526 .22053 L 0 1 .172 r
F
P
p
.47616 .21776 m .48793 .21499 L .49526 .22053 L 0 1 .359 r
F
P
p
.002 w
.49177 .79228 m .48002 .79311 L .47259 .79144 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48002 .79311 m .46808 .8242 L .46087 .79227 L p
.602 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46087 .79227 m .47259 .79144 L .48002 .79311 L p
.602 0 1 r
F P
0 0 0 r
s
P
p
.45692 .21496 m .47616 .21776 L .46446 .2205 L 0 1 .795 r
F
P
p
.44525 .21773 m .45692 .21496 L .46446 .2205 L 0 1 .943 r
F
P
p
.002 w
.44922 .7931 m .46087 .79227 L .46808 .8242 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44922 .7931 m .43713 .83433 L .4294 .83293 L p
.807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44146 .80159 m .44922 .7931 L p
.44265 .8063 L .807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4294 .83293 m .44146 .80159 L p
.44265 .8063 L .807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44146 .80159 m .43371 .79996 L p
.44025 .79683 L .568 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.46087 .79227 m .44922 .7931 L .44146 .80159 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45328 .79059 m .44146 .80159 L p
.44025 .79683 L .568 0 1 r
F P
0 0 0 r
s
P
p
.42592 .21494 m .44525 .21773 L .43366 .22047 L 0 .843 1 r
F
P
p
.41435 .2177 m .42592 .21494 L .43366 .22047 L 0 .761 1 r
F
P
p
.3949 .21491 m .41435 .2177 L .40285 .22044 L 0 .795 1 r
F
P
p
.38344 .21767 m .3949 .21491 L .40285 .22044 L 0 .761 1 r
F
P
p
.36389 .21488 m .38344 .21767 L .37205 .22042 L 0 .87 1 r
F
P
p
.35253 .21764 m .36389 .21488 L .37205 .22042 L 0 .686 1 r
F
P
p
.33287 .21485 m .35253 .21764 L .34124 .22039 L 0 .652 1 r
F
P
p
.32161 .21761 m .33287 .21485 L .34124 .22039 L 0 .564 1 r
F
P
p
.002 w
.69022 .82205 m .67772 .82279 L .66971 .71809 L p
.061 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6591 .82204 m .66971 .71809 L .67772 .82279 L p
.561 0 1 r
F P
0 0 0 r
s
P
p
.30185 .21482 m .32161 .21761 L .31043 .22036 L 0 .509 1 r
F
P
p
.2907 .21759 m .30185 .21482 L .31043 .22036 L 0 .447 1 r
F
P
p
.27083 .21479 m .2907 .21759 L .27962 .22033 L 0 .157 1 r
F
P
p
.25978 .21756 m .27083 .21479 L .27962 .22033 L 0 .073 1 r
F
P
p
.002 w
.37872 .83222 m .36611 .88438 L .36166 .71599 L p
.439 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36166 .71599 m .37302 .7149 L .37872 .83222 L p
.439 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37302 .7149 m .36166 .71599 L .35382 .69776 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.34252 .69891 m .35382 .69776 L .36166 .71599 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.23981 .21476 m .25978 .21756 L .2488 .2203 L .212 0 1 r
F
P
p
.22886 .21753 m .23981 .21476 L .2488 .2203 L .253 0 1 r
F
P
p
.002 w
.30584 .89324 m .31732 .89273 L .33085 .71598 L p
.677 0 1 r
F P
0 0 0 r
s
P
p
.20879 .21474 m .22886 .21753 L .21799 .22028 L .237 0 1 r
F
P
p
.19794 .2175 m .20879 .21474 L .21799 .22028 L .364 0 1 r
F
P
p
.17776 .21471 m .19794 .2175 L .18717 .22025 L .28 0 1 r
F
P
p
.16702 .21747 m .17776 .21471 L .18717 .22025 L .364 0 1 r
F
P
p
.002 w
.77057 .45781 m .75788 .45976 L .75233 .45583 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.73966 .45779 m .75233 .45583 L .75788 .45976 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.73966 .45779 m .72708 .45974 L .72157 .46552 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.70899 .46745 m .72157 .46552 L .72708 .45974 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.6653 .82352 m .67772 .82279 L .68377 .82425 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64143 .87576 m .62917 .87631 L .62216 .82423 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.62216 .82423 m .63439 .82351 L .64143 .87576 L p
1 0 .75 r
F P
0 0 0 r
s
P
p
.002 w
.59936 .58113 m .58721 .58342 L .58138 .52501 L p
.741 1 0 r
F P
0 0 0 r
s
P
p
.58327 .52327 m .59936 .58113 L .58138 .52501 L .741 1 0 r
F
P
p
.002 w
.58006 .51173 m .59207 .50023 L .59936 .58113 L p
.741 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61138 .56061 m .59936 .58113 L .59207 .50023 L p
.844 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58673 .68714 m .59903 .65847 L .60404 .50406 L p
.114 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60404 .50406 m .60422 .49842 L p
.60367 .5044 L .114 1 0 r
F P
0 0 0 r
s
P
p
.58673 .68714 m .60404 .50406 L .60367 .5044 L .114 1 0 r
F
P
p
.002 w
.58138 .52501 m .58006 .51173 L p
.58327 .52327 L .741 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59207 .50023 m .58006 .51173 L .57427 .68836 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.002 w
.5619 .68957 m .57427 .68836 L .58006 .51173 L p
0 1 .114 r
F P
0 0 0 r
s
P
p
.002 w
.5395 .69783 m .52758 .69898 L .52046 .69667 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.50856 .69782 m .52046 .69667 L .52758 .69898 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.4844 .7906 m .49674 .69896 L .50364 .78132 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50856 .69782 m .49674 .69896 L .48941 .69665 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.49674 .69896 m .4844 .7906 L .47749 .71384 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.47749 .71384 m .48941 .69665 L .49674 .69896 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.35464 .88491 m .34325 .88543 L .3375 .78214 L p
.827 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35382 .69776 m .34252 .69891 L .32888 .89222 L p
.568 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31732 .89273 m .32888 .89222 L .34252 .69891 L p
.623 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.83237 .45785 m .81986 .46945 L .81396 .44619 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.80111 .44818 m .81396 .44619 L .81986 .46945 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.80111 .44818 m .78902 .46943 L .783 .44617 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.77057 .45781 m .783 .44617 L .78902 .46943 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.70899 .46745 m .69649 .46937 L .69052 .4655 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67804 .46743 m .69052 .4655 L .69649 .46937 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67804 .46743 m .66564 .46935 L .66014 .50459 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.66014 .50459 m .66564 .46935 L p
.64998 .51968 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.66014 .50459 m .67248 .49292 L .67804 .46743 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.66014 .50459 m .65319 .46157 L p
.67033 .48943 L 1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.67248 .49292 m .66014 .50459 L p
.67033 .48943 L 1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.648 .52604 m .66014 .50459 L p
.64998 .51968 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.43713 .83433 m .42499 .87572 L .41779 .83363 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.41779 .83363 m .4294 .83293 L .43713 .83433 L p
1 0 .818 r
F P
0 0 0 r
s
P
p
.002 w
.42499 .87572 m .41329 .88649 L .40626 .83432 L p
1 0 .648 r
F P
0 0 0 r
s
P
p
.002 w
.40626 .83432 m .41779 .83363 L .42499 .87572 L p
1 0 .648 r
F P
0 0 0 r
s
P
p
.002 w
.41779 .83363 m .40626 .83432 L .39832 .83293 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.38682 .83362 m .39832 .83293 L .40626 .83432 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.3629 .88596 m .37432 .88544 L .38243 .88648 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.3629 .88596 m .35156 .88648 L .34325 .88543 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.33193 .88595 m .34325 .88543 L .35156 .88648 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.28312 .89424 m .29444 .89374 L .30663 .78213 L p
1 0 .878 r
F P
0 0 0 r
s
P
p
.002 w
.81396 .44619 m .80111 .44818 L .79584 .44417 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.783 .44617 m .79584 .44417 L .80111 .44818 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.60422 .49842 m .59207 .50023 L .58673 .68714 L p
.114 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57427 .68836 m .58673 .68714 L .59207 .50023 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.79789 .21528 m .81079 .2125 L .81596 .21807 L 1 0 0 r
F
P
p
.7797 .21247 m .79789 .21528 L .78508 .21804 L 1 .034 0 r
F
P
p
.76691 .21525 m .7797 .21247 L .78508 .21804 L 1 .068 0 r
F
P
p
.7486 .21244 m .76691 .21525 L .7542 .21801 L 1 .17 0 r
F
P
p
.73592 .21522 m .7486 .21244 L .7542 .21801 L 1 .205 0 r
F
P
p
.71751 .21241 m .73592 .21522 L .72331 .21798 L 1 .273 0 r
F
P
p
.70493 .21519 m .71751 .21241 L .72331 .21798 L 1 .273 0 r
F
P
p
.68641 .21238 m .70493 .21519 L .69243 .21795 L 1 .341 0 r
F
P
p
.67393 .21516 m .68641 .21238 L .69243 .21795 L 1 .511 0 r
F
P
p
.65531 .21235 m .67393 .21516 L .66154 .21792 L 1 .75 0 r
F
P
p
.64294 .21513 m .65531 .21235 L .66154 .21792 L 1 .92 0 r
F
P
p
.62421 .21232 m .64294 .21513 L .63065 .2179 L 1 .614 0 r
F
P
p
.61194 .21511 m .62421 .21232 L .63065 .2179 L 1 .716 0 r
F
P
p
.59311 .2123 m .61194 .21511 L .59975 .21787 L 1 .409 0 r
F
P
p
.58094 .21508 m .59311 .2123 L .59975 .21787 L 1 .477 0 r
F
P
p
.56201 .21227 m .58094 .21508 L .56886 .21784 L .375 1 0 r
F
P
p
.54994 .21505 m .56201 .21227 L .56886 .21784 L .33 1 0 r
F
P
p
.002 w
.53741 .69196 m .54961 .69077 L .55632 .5834 L p
0 1 .807 r
F P
0 0 0 r
s
P
p
.5309 .21224 m .54994 .21505 L .53796 .21781 L 0 1 .398 r
F
P
p
.51894 .21502 m .5309 .21224 L .53796 .21781 L 0 1 .659 r
F
P
p
.49979 .21221 m .51894 .21502 L .50706 .21778 L 0 1 .07 r
F
P
p
.48793 .21499 m .49979 .21221 L .50706 .21778 L 0 1 .172 r
F
P
p
.002 w
.50364 .78132 m .49177 .79228 L .4844 .7906 L p
.159 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.47259 .79144 m .4844 .7906 L .49177 .79228 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.46868 .21218 m .48793 .21499 L .47616 .21776 L 0 1 .67 r
F
P
p
.45692 .21496 m .46868 .21218 L .47616 .21776 L 0 1 .795 r
F
P
p
.002 w
.47259 .79144 m .46087 .79227 L .45328 .79059 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.44146 .80159 m .45328 .79059 L .46087 .79227 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.43756 .21215 m .45692 .21496 L .44525 .21773 L 0 .9 1 r
F
P
p
.42592 .21494 m .43756 .21215 L .44525 .21773 L 0 .843 1 r
F
P
p
.40645 .21212 m .42592 .21494 L .41435 .2177 L 0 .877 1 r
F
P
p
.3949 .21491 m .40645 .21212 L .41435 .2177 L 0 .795 1 r
F
P
p
.37533 .2121 m .3949 .21491 L .38344 .21767 L 0 1 .911 r
F
P
p
.36389 .21488 m .37533 .2121 L .38344 .21767 L 0 .87 1 r
F
P
p
.34421 .21207 m .36389 .21488 L .35253 .21764 L 0 .775 1 r
F
P
p
.33287 .21485 m .34421 .21207 L .35253 .21764 L 0 .652 1 r
F
P
p
.31309 .21204 m .33287 .21485 L .32161 .21761 L 0 .509 1 r
F
P
p
.30185 .21482 m .31309 .21204 L .32161 .21761 L 0 .509 1 r
F
P
p
.28196 .21201 m .30185 .21482 L .2907 .21759 L 0 .241 1 r
F
P
p
.27083 .21479 m .28196 .21201 L .2907 .21759 L 0 .157 1 r
F
P
p
.002 w
.39105 .79057 m .37872 .83222 L .37302 .7149 L p
.077 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37302 .7149 m .38477 .69777 L .39105 .79057 L p
.077 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38477 .69777 m .37302 .7149 L .3652 .69661 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.35382 .69776 m .3652 .69661 L .37302 .7149 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.25083 .21198 m .27083 .21479 L .25978 .21756 L .124 0 1 r
F
P
p
.23981 .21476 m .25083 .21198 L .25978 .21756 L .212 0 1 r
F
P
p
.002 w
.84493 .44621 m .83237 .45785 L .8269 .44419 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.81396 .44619 m .8269 .44419 L .83237 .45785 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.21971 .21195 m .23981 .21476 L .22886 .21753 L .085 0 1 r
F
P
p
.20879 .21474 m .21971 .21195 L .22886 .21753 L .237 0 1 r
F
P
p
.18857 .21192 m .20879 .21474 L .19794 .2175 L .196 0 1 r
F
P
p
.17776 .21471 m .18857 .21192 L .19794 .2175 L .28 0 1 r
F
P
p
.002 w
.783 .44617 m .77057 .45781 L .76508 .45386 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.75233 .45583 m .76508 .45386 L .77057 .45781 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.75233 .45583 m .73966 .45779 L .73396 .45384 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.72157 .46552 m .73396 .45384 L .73966 .45779 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.67772 .82279 m .6653 .82352 L .6591 .82204 L p
.561 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.6653 .82352 m .65356 .86181 L .6467 .82278 L p
1 0 .965 r
F P
0 0 0 r
s
P
p
.002 w
.6467 .82278 m .6591 .82204 L .6653 .82352 L p
1 0 .965 r
F P
0 0 0 r
s
P
p
.002 w
.65356 .86181 m .64143 .87576 L .63439 .82351 L p
1 0 .795 r
F P
0 0 0 r
s
P
p
.002 w
.63439 .82351 m .6467 .82278 L .65356 .86181 L p
1 0 .795 r
F P
0 0 0 r
s
P
p
.002 w
.52046 .69667 m .53244 .6955 L .5395 .69783 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.52046 .69667 m .50856 .69782 L .50129 .69549 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.48941 .69665 m .50129 .69549 L .50856 .69782 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.40262 .78973 m .39105 .79057 L .38477 .69777 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.38477 .69777 m .39626 .69662 L .40262 .78973 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.39626 .69662 m .38477 .69777 L .37666 .69544 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.3652 .69661 m .37666 .69544 L .38477 .69777 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.3652 .69661 m .35382 .69776 L .34051 .8917 L p
.568 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32888 .89222 m .34051 .8917 L .35382 .69776 L p
.568 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.72157 .46552 m .70899 .46745 L .70308 .46356 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69052 .4655 m .70308 .46356 L .70899 .46745 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69052 .4655 m .67804 .46743 L .67248 .49292 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.4294 .83293 m .41779 .83363 L .4099 .83222 L p
1 0 .959 r
F P
0 0 0 r
s
P
p
.002 w
.39832 .83293 m .4099 .83222 L .41779 .83363 L p
1 0 .955 r
F P
0 0 0 r
s
P
p
.002 w
.39832 .83293 m .38682 .83362 L .37872 .83222 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38682 .83362 m .37432 .88544 L .36611 .88438 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.36611 .88438 m .37872 .83222 L .38682 .83362 L p
1 0 .614 r
F P
0 0 0 r
s
P
p
.002 w
.37432 .88544 m .3629 .88596 L .35464 .88491 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.34325 .88543 m .35464 .88491 L .3629 .88596 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.8269 .44419 m .83993 .44218 L .84493 .44621 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.8269 .44419 m .81396 .44619 L .80876 .44215 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79584 .44417 m .80876 .44215 L .81396 .44619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79584 .44417 m .783 .44617 L .77792 .45188 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.76508 .45386 m .77792 .45188 L .783 .44617 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.60422 .49842 m .61646 .49659 L .62366 .55899 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61646 .49659 m .60422 .49842 L .59903 .65847 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.79258 .20967 m .81079 .2125 L .79789 .21528 L 1 0 0 r
F
P
p
.7797 .21247 m .79258 .20967 L .79789 .21528 L 1 .034 0 r
F
P
p
.76138 .20964 m .7797 .21247 L .76691 .21525 L 1 .136 0 r
F
P
p
.7486 .21244 m .76138 .20964 L .76691 .21525 L 1 .17 0 r
F
P
p
.73018 .20961 m .7486 .21244 L .73592 .21522 L 1 .259 0 r
F
P
p
.71751 .21241 m .73018 .20961 L .73592 .21522 L 1 .273 0 r
F
P
p
.69898 .20958 m .71751 .21241 L .70493 .21519 L 1 .273 0 r
F
P
p
.68641 .21238 m .69898 .20958 L .70493 .21519 L 1 .341 0 r
F
P
p
.66777 .20955 m .68641 .21238 L .67393 .21516 L 1 .545 0 r
F
P
p
.65531 .21235 m .66777 .20955 L .67393 .21516 L 1 .75 0 r
F
P
p
.63657 .20952 m .65531 .21235 L .64294 .21513 L 1 .511 0 r
F
P
p
.62421 .21232 m .63657 .20952 L .64294 .21513 L 1 .614 0 r
F
P
p
.60536 .2095 m .62421 .21232 L .61194 .21511 L 1 .307 0 r
F
P
p
.59311 .2123 m .60536 .2095 L .61194 .21511 L 1 .409 0 r
F
P
p
.57415 .20947 m .59311 .2123 L .58094 .21508 L .409 1 0 r
F
P
p
.56201 .21227 m .57415 .20947 L .58094 .21508 L .375 1 0 r
F
P
p
.54294 .20944 m .56201 .21227 L .54994 .21505 L 0 1 .136 r
F
P
p
.5309 .21224 m .54294 .20944 L .54994 .21505 L 0 1 .398 r
F
P
p
.51172 .20941 m .5309 .21224 L .51894 .21502 L .125 1 0 r
F
P
p
.49979 .21221 m .51172 .20941 L .51894 .21502 L 0 1 .07 r
F
P
p
.48051 .20938 m .49979 .21221 L .48793 .21499 L 0 1 .524 r
F
P
p
.46868 .21218 m .48051 .20938 L .48793 .21499 L 0 1 .67 r
F
P
p
.002 w
.4844 .7906 m .47259 .79144 L .46506 .78975 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45328 .79059 m .46506 .78975 L .47259 .79144 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.44929 .20935 m .46868 .21218 L .45692 .21496 L 0 .909 1 r
F
P
p
.43756 .21215 m .44929 .20935 L .45692 .21496 L 0 .9 1 r
F
P
p
.41807 .20932 m .43756 .21215 L .42592 .21494 L 0 1 .984 r
F
P
p
.40645 .21212 m .41807 .20932 L .42592 .21494 L 0 .877 1 r
F
P
p
.38685 .20929 m .40645 .21212 L .3949 .21491 L 0 1 .846 r
F
P
p
.37533 .2121 m .38685 .20929 L .3949 .21491 L 0 1 .911 r
F
P
p
.002 w
.46506 .78975 m .47749 .71384 L .4844 .7906 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.48941 .69665 m .47749 .71384 L .46935 .78716 L p
0 .059 1 r
F P
0 0 0 r
s
P
p
.002 w
.47749 .71384 m .46506 .78975 L .45743 .78803 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45743 .78803 m .46935 .78716 L .47749 .71384 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.35562 .20926 m .37533 .2121 L .36389 .21488 L 0 .993 1 r
F
P
p
.34421 .21207 m .35562 .20926 L .36389 .21488 L 0 .775 1 r
F
P
p
.32439 .20924 m .34421 .21207 L .33287 .21485 L 0 .509 1 r
F
P
p
.31309 .21204 m .32439 .20924 L .33287 .21485 L 0 .509 1 r
F
P
p
.29316 .20921 m .31309 .21204 L .30185 .21482 L 0 .312 1 r
F
P
p
.28196 .21201 m .29316 .20921 L .30185 .21482 L 0 .241 1 r
F
P
p
.26193 .20918 m .28196 .21201 L .27083 .21479 L 0 .035 1 r
F
P
p
.25083 .21198 m .26193 .20918 L .27083 .21479 L .124 0 1 r
F
P
p
.2307 .20915 m .25083 .21198 L .23981 .21476 L .044 0 1 r
F
P
p
.21971 .21195 m .2307 .20915 L .23981 .21476 L .085 0 1 r
F
P
p
.19946 .20912 m .21971 .21195 L .20879 .21474 L .112 0 1 r
F
P
p
.18857 .21192 m .19946 .20912 L .20879 .21474 L .196 0 1 r
F
P
p
.002 w
.76508 .45386 m .75233 .45583 L .7467 .45186 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.73396 .45384 m .7467 .45186 L .75233 .45583 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.53244 .6955 m .52046 .69667 L .51325 .69432 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.50129 .69549 m .51325 .69432 L .52046 .69667 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.50129 .69549 m .48941 .69665 L .48134 .78629 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.46935 .78716 m .48134 .78629 L .48941 .69665 L p
0 .059 1 r
F P
0 0 0 r
s
P
p
.002 w
.44146 .80159 m .4294 .83293 L .42158 .83005 L p
.836 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42158 .83005 m .43371 .79996 L .44146 .80159 L p
.836 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41427 .78888 m .40262 .78973 L .39626 .69662 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.39626 .69662 m .40782 .69546 L .41427 .78888 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.40782 .69546 m .39626 .69662 L .3882 .69428 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.37666 .69544 m .3882 .69428 L .39626 .69662 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.37666 .69544 m .3652 .69661 L .35223 .89118 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34051 .8917 m .35223 .89118 L .3652 .69661 L p
.568 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.73396 .45384 m .72157 .46552 L .71572 .46161 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.70308 .46356 m .71572 .46161 L .72157 .46552 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.70308 .46356 m .69052 .4655 L .68446 .46159 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67248 .49292 m .68446 .46159 L .69052 .4655 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.4099 .83222 m .42158 .83005 L .4294 .83293 L p
1 0 .959 r
F P
0 0 0 r
s
P
p
.002 w
.4099 .83222 m .39832 .83293 L .39105 .79057 L p
.773 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37872 .83222 m .39105 .79057 L .39832 .83293 L p
.909 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35464 .88491 m .36611 .88438 L .37432 .88544 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.83993 .44218 m .8269 .44419 L .82177 .44013 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80876 .44215 m .82177 .44013 L .8269 .44419 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80876 .44215 m .79584 .44417 L .79049 .44011 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77792 .45188 m .79049 .44011 L .79584 .44417 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.59903 .65847 m .6102 .5225 L .61646 .49659 L p
.659 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62878 .49475 m .61646 .49659 L .6102 .5225 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.79258 .20967 m .80554 .20685 L .81079 .2125 L 1 0 0 r
F
P
p
.77424 .20682 m .79258 .20967 L .7797 .21247 L 1 .102 0 r
F
P
p
.76138 .20964 m .77424 .20682 L .7797 .21247 L 1 .136 0 r
F
P
p
.74293 .20679 m .76138 .20964 L .7486 .21244 L 1 .191 0 r
F
P
p
.73018 .20961 m .74293 .20679 L .7486 .21244 L 1 .259 0 r
F
P
p
.71163 .20676 m .73018 .20961 L .71751 .21241 L 1 .273 0 r
F
P
p
.69898 .20958 m .71163 .20676 L .71751 .21241 L 1 .273 0 r
F
P
p
.68032 .20673 m .69898 .20958 L .68641 .21238 L 1 .375 0 r
F
P
p
.66777 .20955 m .68032 .20673 L .68641 .21238 L 1 .545 0 r
F
P
p
.64901 .20671 m .66777 .20955 L .65531 .21235 L 1 .477 0 r
F
P
p
.63657 .20952 m .64901 .20671 L .65531 .21235 L 1 .511 0 r
F
P
p
.61769 .20668 m .63657 .20952 L .62421 .21232 L 1 .273 0 r
F
P
p
.60536 .2095 m .61769 .20668 L .62421 .21232 L 1 .307 0 r
F
P
p
.58638 .20665 m .60536 .2095 L .59311 .2123 L .409 1 0 r
F
P
p
.57415 .20947 m .58638 .20665 L .59311 .2123 L .409 1 0 r
F
P
p
.55506 .20662 m .57415 .20947 L .56201 .21227 L 0 1 .136 r
F
P
p
.54294 .20944 m .55506 .20662 L .56201 .21227 L 0 1 .136 r
F
P
p
.52374 .20659 m .54294 .20944 L .5309 .21224 L .466 1 0 r
F
P
p
.51172 .20941 m .52374 .20659 L .5309 .21224 L .125 1 0 r
F
P
p
.49242 .20656 m .51172 .20941 L .49979 .21221 L 0 1 .49 r
F
P
p
.48051 .20938 m .49242 .20656 L .49979 .21221 L 0 1 .524 r
F
P
p
.4611 .20653 m .48051 .20938 L .46868 .21218 L 0 1 .927 r
F
P
p
.44929 .20935 m .4611 .20653 L .46868 .21218 L 0 .909 1 r
F
P
p
.002 w
.46506 .78975 m .45328 .79059 L .4456 .78888 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43371 .79996 m .4456 .78888 L .45328 .79059 L p
.568 0 1 r
F P
0 0 0 r
s
P
p
.42977 .2065 m .44929 .20935 L .43756 .21215 L 0 1 .845 r
F
P
p
.41807 .20932 m .42977 .2065 L .43756 .21215 L 0 1 .984 r
F
P
p
.39844 .20647 m .41807 .20932 L .40645 .21212 L 0 1 .767 r
F
P
p
.38685 .20929 m .39844 .20647 L .40645 .21212 L 0 1 .846 r
F
P
p
.002 w
.39105 .79057 m .40262 .78973 L .4099 .83222 L p
.773 0 1 r
F P
0 0 0 r
s
P
p
.36711 .20644 m .38685 .20929 L .37533 .2121 L 0 1 .863 r
F
P
p
.35562 .20926 m .36711 .20644 L .37533 .2121 L 0 .993 1 r
F
P
p
.33578 .20641 m .35562 .20926 L .34421 .21207 L 0 .598 1 r
F
P
p
.32439 .20924 m .33578 .20641 L .34421 .21207 L 0 .509 1 r
F
P
p
.30444 .20639 m .32439 .20924 L .31309 .21204 L 0 .388 1 r
F
P
p
.29316 .20921 m .30444 .20639 L .31309 .21204 L 0 .312 1 r
F
P
p
.27311 .20636 m .29316 .20921 L .28196 .21201 L 0 .122 1 r
F
P
p
.26193 .20918 m .27311 .20636 L .28196 .21201 L 0 .035 1 r
F
P
p
.24177 .20633 m .26193 .20918 L .25083 .21198 L 0 .116 1 r
F
P
p
.2307 .20915 m .24177 .20633 L .25083 .21198 L .044 0 1 r
F
P
p
.21042 .2063 m .2307 .20915 L .21971 .21195 L .028 0 1 r
F
P
p
.19946 .20912 m .21042 .2063 L .21971 .21195 L .112 0 1 r
F
P
p
.002 w
.77792 .45188 m .76508 .45386 L .75952 .44986 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.7467 .45186 m .75952 .44986 L .76508 .45386 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.7467 .45186 m .73396 .45384 L .72819 .44984 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.71572 .46161 m .72819 .44984 L .73396 .45384 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.51325 .69432 m .52529 .69315 L .53244 .6955 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.49383 .70937 m .50129 .69549 L p
.49533 .7226 L 0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.48134 .78629 m .49383 .70937 L p
.49533 .7226 L 0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.49383 .70937 m .48645 .69074 L p
.49232 .69603 L 0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.51325 .69432 m .50129 .69549 L .49383 .70937 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.49383 .70937 m .50587 .70824 L .51325 .69432 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.50587 .70824 m .49383 .70937 L p
.49232 .69603 L 0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.426 .78802 m .41427 .78888 L .40782 .69546 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.40782 .69546 m .41947 .69429 L .426 .78802 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.41947 .69429 m .40782 .69546 L .39982 .6931 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.3882 .69428 m .39982 .6931 L .40782 .69546 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.3882 .69428 m .37666 .69544 L .36427 .88 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36427 .88 m .37666 .69544 L p
.35294 .88549 L .534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36427 .88 m .37614 .87944 L .3882 .69428 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36427 .88 m .35973 .70704 L p
.37566 .87448 L .555 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37614 .87944 m .36427 .88 L p
.37566 .87448 L .555 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.35223 .89118 m .36427 .88 L p
.35294 .88549 L .534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.71572 .46161 m .70308 .46356 L .69708 .45962 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68446 .46159 m .69708 .45962 L .70308 .46356 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.66014 .50459 m .648 .52604 L .64075 .46352 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.64075 .46352 m .65319 .46157 L .66014 .50459 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.65319 .46157 m .64075 .46352 L .63474 .48914 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.62264 .52073 m .63474 .48914 L .64075 .46352 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.42158 .83005 m .4099 .83222 L .40262 .78973 L p
.768 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.82177 .44013 m .83487 .43808 L .83993 .44218 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.23134 .89373 m .22023 .89423 L .21568 .77948 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.21568 .77948 m .22668 .77859 L .23134 .89373 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.19978 .89373 m .21568 .77948 L .22023 .89423 L closepath p
1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.22668 .77859 m .21568 .77948 L .20635 .77769 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21568 .77948 m .19978 .89373 L .19023 .89271 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.19023 .89271 m .20635 .77769 L .21568 .77948 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.82177 .44013 m .80876 .44215 L .80349 .43806 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79049 .44011 m .80349 .43806 L .80876 .44215 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6102 .5225 m .62264 .52073 L .62878 .49475 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.78719 .20398 m .80554 .20685 L .79258 .20967 L 1 .034 0 r
F
P
p
.77424 .20682 m .78719 .20398 L .79258 .20967 L 1 .102 0 r
F
P
p
.75578 .20395 m .77424 .20682 L .76138 .20964 L 1 .136 0 r
F
P
p
.74293 .20679 m .75578 .20395 L .76138 .20964 L 1 .191 0 r
F
P
p
.72436 .20393 m .74293 .20679 L .73018 .20961 L 1 .259 0 r
F
P
p
.71163 .20676 m .72436 .20393 L .73018 .20961 L 1 .273 0 r
F
P
p
.69295 .2039 m .71163 .20676 L .69898 .20958 L 1 .273 0 r
F
P
p
.68032 .20673 m .69295 .2039 L .69898 .20958 L 1 .375 0 r
F
P
p
.66153 .20387 m .68032 .20673 L .66777 .20955 L 1 .409 0 r
F
P
p
.64901 .20671 m .66153 .20387 L .66777 .20955 L 1 .477 0 r
F
P
p
.63011 .20384 m .64901 .20671 L .63657 .20952 L 1 .239 0 r
F
P
p
.61769 .20668 m .63011 .20384 L .63657 .20952 L 1 .273 0 r
F
P
p
.59869 .20381 m .61769 .20668 L .60536 .2095 L .591 1 0 r
F
P
p
.58638 .20665 m .59869 .20381 L .60536 .2095 L .409 1 0 r
F
P
p
.56727 .20378 m .58638 .20665 L .57415 .20947 L 0 1 .068 r
F
P
p
.55506 .20662 m .56727 .20378 L .57415 .20947 L 0 1 .136 r
F
P
p
.53584 .20375 m .55506 .20662 L .54294 .20944 L .636 1 0 r
F
P
p
.52374 .20659 m .53584 .20375 L .54294 .20944 L .466 1 0 r
F
P
p
.50441 .20372 m .52374 .20659 L .51172 .20941 L 0 1 .307 r
F
P
p
.49242 .20656 m .50441 .20372 L .51172 .20941 L 0 1 .49 r
F
P
p
.47298 .20369 m .49242 .20656 L .48051 .20938 L 0 1 .655 r
F
P
p
.4611 .20653 m .47298 .20369 L .48051 .20938 L 0 1 .927 r
F
P
p
.002 w
.4456 .78888 m .45743 .78803 L .46506 .78975 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.44155 .20366 m .4611 .20653 L .44929 .20935 L 0 1 .764 r
F
P
p
.42977 .2065 m .44155 .20366 L .44929 .20935 L 0 1 .845 r
F
P
p
.41012 .20363 m .42977 .2065 L .41807 .20932 L 0 1 .682 r
F
P
p
.39844 .20647 m .41012 .20363 L .41807 .20932 L 0 1 .767 r
F
P
p
.002 w
.40262 .78973 m .41427 .78888 L .42158 .83005 L p
.768 0 1 r
F P
0 0 0 r
s
P
p
.37868 .2036 m .39844 .20647 L .38685 .20929 L 0 1 .818 r
F
P
p
.36711 .20644 m .37868 .2036 L .38685 .20929 L 0 1 .863 r
F
P
p
.34724 .20357 m .36711 .20644 L .35562 .20926 L 0 .686 1 r
F
P
p
.33578 .20641 m .34724 .20357 L .35562 .20926 L 0 .598 1 r
F
P
p
.3158 .20355 m .33578 .20641 L .32439 .20924 L 0 .45 1 r
F
P
p
.30444 .20639 m .3158 .20355 L .32439 .20924 L 0 .388 1 r
F
P
p
.28435 .20352 m .30444 .20639 L .29316 .20921 L 0 .253 1 r
F
P
p
.27311 .20636 m .28435 .20352 L .29316 .20921 L 0 .122 1 r
F
P
p
.25291 .20349 m .27311 .20636 L .26193 .20918 L 0 .266 1 r
F
P
p
.24177 .20633 m .25291 .20349 L .26193 .20918 L 0 .116 1 r
F
P
p
.22146 .20346 m .24177 .20633 L .2307 .20915 L 0 .047 1 r
F
P
p
.21042 .2063 m .22146 .20346 L .2307 .20915 L .028 0 1 r
F
P
p
.002 w
.79049 .44011 m .77792 .45188 L .7721 .43804 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.75952 .44986 m .7721 .43804 L .77792 .45188 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.75952 .44986 m .7467 .45186 L .74099 .44783 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.74099 .44783 m .7467 .45186 L p
.73746 .45085 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.74099 .44783 m .75358 .43596 L .75952 .44986 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.74099 .44783 m .73548 .45363 L p
.74456 .44477 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.75358 .43596 m .74099 .44783 L p
.74456 .44477 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.72819 .44984 m .74099 .44783 L p
.73746 .45085 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.52529 .69315 m .51325 .69432 L .50587 .70824 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.4456 .78888 m .43371 .79996 L .426 .78802 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43371 .79996 m .42158 .83005 L .41427 .78888 L p
.666 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41427 .78888 m .426 .78802 L .43371 .79996 L p
.666 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43781 .78715 m .426 .78802 L .41947 .69429 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.41947 .69429 m .43119 .69311 L .43781 .78715 L p
0 .114 1 r
F P
0 0 0 r
s
P
p
.002 w
.43119 .69311 m .41947 .69429 L .41151 .69191 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.41151 .69191 m .41947 .69429 L p
.40236 .69325 L 0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.41151 .69191 m .42369 .66363 L .43119 .69311 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.41151 .69191 m .40201 .84743 L p
.42073 .69056 L .375 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40201 .84743 m .40046 .87281 L p
.40346 .84582 L .375 0 1 r
F P
0 0 0 r
s
P
p
.40346 .84582 m .42073 .69056 L .40201 .84743 L .375 0 1 r
F
P
p
.40076 .87242 m .42073 .69056 L .40046 .87281 L .375 0 1 r
F
P
p
.002 w
.42369 .66363 m .41151 .69191 L p
.42073 .69056 L .375 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39982 .6931 m .41151 .69191 L p
.40236 .69325 L 0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.41151 .69191 m .39982 .6931 L .38809 .87887 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.45055 .71049 m .43781 .78715 L .43119 .69311 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.43119 .69311 m .44299 .69192 L .45055 .71049 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.44299 .69192 m .43119 .69311 L .42369 .66363 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.42369 .66363 m .4355 .66234 L .44299 .69192 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.4355 .66234 m .42369 .66363 L .41241 .86695 L p
.114 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40012 .8783 m .41241 .86695 L .42369 .66363 L p
.375 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38809 .87887 m .40012 .8783 L .41151 .69191 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.426 .78802 m .43781 .78715 L .4456 .78888 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42744 .78858 m .4355 .66234 L p
.42008 .799 L .114 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43781 .78715 m .45055 .71049 L .45743 .78803 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.4624 .70936 m .45055 .71049 L .44299 .69192 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.44299 .69192 m .45487 .69073 L .4624 .70936 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.45487 .69073 m .44299 .69192 L .43907 .67642 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.44174 .67148 m .45487 .69073 L .43907 .67642 L 0 .909 1 r
F
P
p
.002 w
.4474 .66104 m .46003 .59557 L .46708 .66236 L p
0 1 .784 r
F P
0 0 0 r
s
P
p
.002 w
.46708 .66236 m .45487 .69073 L .4474 .66104 L p
0 1 .784 r
F P
0 0 0 r
s
P
p
.002 w
.4355 .66234 m .4474 .66104 L .45487 .69073 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.4474 .66104 m .43928 .75573 L p
.4531 .65053 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.44019 .75286 m .4531 .65053 L .43928 .75573 L 0 .58 1 r
F
P
p
.002 w
.46003 .59557 m .4474 .66104 L p
.4531 .65053 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.47446 .69194 m .4624 .70936 L .45487 .69073 L p
0 .764 1 r
F P
0 0 0 r
s
P
p
.002 w
.45487 .69073 m .46708 .66236 L .47446 .69194 L p
0 .764 1 r
F P
0 0 0 r
s
P
p
.002 w
.46935 .78716 m .45743 .78803 L .45055 .71049 L p
0 .005 1 r
F P
0 0 0 r
s
P
p
.002 w
.45055 .71049 m .4624 .70936 L .46935 .78716 L p
0 .005 1 r
F P
0 0 0 r
s
P
p
.002 w
.47931 .63014 m .46708 .66236 L .46003 .59557 L p
0 1 .305 r
F P
0 0 0 r
s
P
p
.002 w
.46003 .59557 m .47215 .57395 L .47931 .63014 L p
0 1 .305 r
F P
0 0 0 r
s
P
p
.002 w
.47215 .57395 m .46003 .59557 L .45032 .76847 L p
0 .944 1 r
F P
0 0 0 r
s
P
p
.002 w
.43811 .76942 m .45032 .76847 L .46003 .59557 L p
0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.48134 .78629 m .46935 .78716 L .4624 .70936 L p
0 .059 1 r
F P
0 0 0 r
s
P
p
.002 w
.4624 .70936 m .47446 .69194 L .48134 .78629 L p
0 .059 1 r
F P
0 0 0 r
s
P
p
.002 w
.48645 .69074 m .47446 .69194 L .46708 .66236 L p
0 1 .987 r
F P
0 0 0 r
s
P
p
.002 w
.46708 .66236 m .47931 .63014 L .48645 .69074 L p
0 1 .987 r
F P
0 0 0 r
s
P
p
.002 w
.46353 .73031 m .47215 .57395 L p
.45381 .73738 L 0 .944 1 r
F P
0 0 0 r
s
P
p
.002 w
.49182 .54724 m .47931 .63014 L .47215 .57395 L p
.212 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47215 .57395 m .4843 .5523 L .49182 .54724 L p
.212 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4843 .5523 m .47215 .57395 L .46285 .74256 L p
0 1 .783 r
F P
0 0 0 r
s
P
p
.002 w
.47931 .63014 m .49182 .54724 L .49852 .68954 L p
0 1 .606 r
F P
0 0 0 r
s
P
p
.002 w
.49383 .70937 m .48134 .78629 L .47446 .69194 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.47446 .69194 m .48645 .69074 L .49383 .70937 L p
0 .366 1 r
F P
0 0 0 r
s
P
p
.002 w
.49852 .68954 m .48645 .69074 L .47931 .63014 L p
0 1 .606 r
F P
0 0 0 r
s
P
p
.002 w
.46285 .74256 m .47533 .72409 L .4843 .5523 L p
0 1 .783 r
F P
0 0 0 r
s
P
p
.002 w
.45581 .65303 m .46807 .65167 L .47511 .72189 L p
0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.47511 .72189 m .47533 .72409 L p
.47479 .72212 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.45581 .65303 m .47511 .72189 L .47479 .72212 L 0 .58 1 r
F
P
p
.002 w
.46285 .74256 m .46353 .73031 L p
.45093 .76296 L 0 .944 1 r
F P
0 0 0 r
s
P
p
.45093 .76296 m .46353 .73031 L .45381 .73738 L 0 .944 1 r
F
P
p
.002 w
.45032 .76847 m .46285 .74256 L p
.45093 .76296 L 0 .944 1 r
F P
0 0 0 r
s
P
p
.002 w
.46285 .74256 m .45581 .65303 L p
.47479 .72212 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.47533 .72409 m .46285 .74256 L p
.47479 .72212 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.43907 .67642 m .4355 .66234 L p
.44174 .67148 L 0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.4474 .66104 m .4355 .66234 L .42522 .82338 L p
0 .193 1 r
F P
0 0 0 r
s
P
p
.002 w
.43811 .76942 m .4474 .66104 L p
.43 .7884 L 0 .193 1 r
F P
0 0 0 r
s
P
p
.002 w
.42522 .82338 m .43811 .76942 L p
.43 .7884 L 0 .193 1 r
F P
0 0 0 r
s
P
p
.002 w
.43928 .75573 m .43811 .76942 L p
.44019 .75286 L 0 .58 1 r
F P
0 0 0 r
s
P
p
.002 w
.43811 .76942 m .43117 .68336 L p
.44625 .75038 L 0 .273 1 r
F P
0 0 0 r
s
P
p
.44625 .75038 m .44823 .75917 L .43811 .76942 L 0 .273 1 r
F
P
p
.002 w
.44364 .65439 m .45581 .65303 L .45902 .69381 L p
0 .444 1 r
F P
0 0 0 r
s
P
p
.002 w
.45902 .69381 m .46285 .74256 L p
.45498 .70646 L 0 .444 1 r
F P
0 0 0 r
s
P
p
.44364 .65439 m .45902 .69381 L .45498 .70646 L 0 .444 1 r
F
P
p
.002 w
.45032 .76847 m .44115 .76918 L p
.44823 .75917 L 0 .273 1 r
F P
0 0 0 r
s
P
p
.002 w
.44115 .76918 m .43811 .76942 L p
.44823 .75917 L 0 .273 1 r
F P
0 0 0 r
s
P
p
.002 w
.42522 .82338 m .42744 .78858 L p
.41327 .85933 L .114 0 1 r
F P
0 0 0 r
s
P
p
.41327 .85933 m .42744 .78858 L .42008 .799 L .114 0 1 r
F
P
p
.002 w
.41241 .86695 m .42202 .83426 L p
.41327 .85933 L .114 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42202 .83426 m .42522 .82338 L p
.41327 .85933 L .114 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.43117 .68336 m .44364 .65439 L .44955 .75538 L p
0 .273 1 r
F P
0 0 0 r
s
P
p
.002 w
.44955 .75538 m .45032 .76847 L p
.44823 .75917 L 0 .273 1 r
F P
0 0 0 r
s
P
p
.43117 .68336 m .44955 .75538 L .44823 .75917 L 0 .273 1 r
F
P
p
.002 w
.40715 .68584 m .41912 .6846 L .42515 .82187 L p
.295 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.42515 .82187 m .42522 .82338 L p
.42504 .822 L .295 0 1 r
F P
0 0 0 r
s
P
p
.40715 .68584 m .42515 .82187 L .42504 .822 L .295 0 1 r
F
P
p
.002 w
.39982 .6931 m .3882 .69428 L .37614 .87944 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37614 .87944 m .38809 .87887 L .39982 .6931 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39527 .68706 m .40715 .68584 L .41216 .85819 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41216 .85819 m .41241 .86695 L p
.41164 .85884 L .466 0 1 r
F P
0 0 0 r
s
P
p
.39527 .68706 m .41216 .85819 L .41164 .85884 L .466 0 1 r
F
P
p
.002 w
.40046 .87281 m .40012 .8783 L p
.40076 .87242 L .375 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.72819 .44984 m .71572 .46161 L .7098 .45764 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.69708 .45962 m .7098 .45764 L .71572 .46161 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69708 .45962 m .68446 .46159 L .67831 .45762 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68446 .46159 m .67248 .49292 L .66571 .4596 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.66571 .4596 m .67831 .45762 L .68446 .46159 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.65319 .46157 m .66571 .4596 L .67248 .49292 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.66571 .4596 m .65319 .46157 L .6473 .48725 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.63474 .48914 m .6473 .48725 L .65319 .46157 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.27418 .89323 m .26289 .89374 L .25798 .7786 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.25798 .7786 m .26916 .77771 L .27418 .89323 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.24252 .89323 m .25798 .7786 L .26289 .89374 L closepath p
1 0 .511 r
F P
0 0 0 r
s
P
p
.002 w
.26916 .77771 m .25798 .7786 L .24891 .7768 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25798 .7786 m .24252 .89323 L .23776 .7777 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23776 .7777 m .24891 .7768 L .25798 .7786 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24252 .89323 m .23134 .89373 L .22668 .77859 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.22668 .77859 m .23776 .7777 L .24252 .89323 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.23776 .7777 m .22668 .77859 L .2174 .77679 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20635 .77769 m .2174 .77679 L .22668 .77859 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.83487 .43808 m .82177 .44013 L .81657 .43601 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80349 .43806 m .81657 .43601 L .82177 .44013 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.80349 .43806 m .79049 .44011 L .78507 .43599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7721 .43804 m .78507 .43599 L .79049 .44011 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.49223 .55584 m .49182 .54724 L p
.49288 .55516 L 0 1 .323 r
F P
0 0 0 r
s
P
p
.002 w
.49182 .54724 m .50382 .54403 L .51068 .68833 L p
0 1 .323 r
F P
0 0 0 r
s
P
p
.002 w
.50382 .54403 m .49182 .54724 L .4843 .5523 L p
.597 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4843 .5523 m .4964 .54061 L .50373 .54399 L p
.597 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50373 .54399 m .50382 .54403 L p
.50361 .54411 L .597 1 0 r
F P
0 0 0 r
s
P
p
.4843 .5523 m .50373 .54399 L .50361 .54411 L .597 1 0 r
F
P
p
.002 w
.51068 .68833 m .49852 .68954 L .49223 .55584 L p
0 1 .323 r
F P
0 0 0 r
s
P
p
.49288 .55516 m .51068 .68833 L .49223 .55584 L 0 1 .323 r
F
P
p
.78719 .20398 m .80022 .20113 L .80554 .20685 L 1 .034 0 r
F
P
p
.76871 .2011 m .78719 .20398 L .77424 .20682 L 1 .136 0 r
F
P
p
.75578 .20395 m .76871 .2011 L .77424 .20682 L 1 .136 0 r
F
P
p
.73719 .20107 m .75578 .20395 L .74293 .20679 L 1 .191 0 r
F
P
p
.72436 .20393 m .73719 .20107 L .74293 .20679 L 1 .259 0 r
F
P
p
.70566 .20104 m .72436 .20393 L .71163 .20676 L 1 .273 0 r
F
P
p
.69295 .2039 m .70566 .20104 L .71163 .20676 L 1 .273 0 r
F
P
p
.67414 .20101 m .69295 .2039 L .68032 .20673 L 1 .307 0 r
F
P
p
.66153 .20387 m .67414 .20101 L .68032 .20673 L 1 .409 0 r
F
P
p
.64261 .20098 m .66153 .20387 L .64901 .20671 L 1 .205 0 r
F
P
p
.63011 .20384 m .64261 .20098 L .64901 .20671 L 1 .239 0 r
F
P
p
.61109 .20095 m .63011 .20384 L .61769 .20668 L .807 1 0 r
F
P
p
.59869 .20381 m .61109 .20095 L .61769 .20668 L .591 1 0 r
F
P
p
.57956 .20092 m .59869 .20381 L .58638 .20665 L 0 1 0 r
F
P
p
.56727 .20378 m .57956 .20092 L .58638 .20665 L 0 1 .068 r
F
P
p
.54802 .20089 m .56727 .20378 L .55506 .20662 L .636 1 0 r
F
P
p
.53584 .20375 m .54802 .20089 L .55506 .20662 L .636 1 0 r
F
P
p
.51649 .20086 m .53584 .20375 L .52374 .20659 L 0 1 .136 r
F
P
p
.50441 .20372 m .51649 .20086 L .52374 .20659 L 0 1 .307 r
F
P
p
.48495 .20083 m .50441 .20372 L .49242 .20656 L 0 1 .545 r
F
P
p
.47298 .20369 m .48495 .20083 L .49242 .20656 L 0 1 .655 r
F
P
p
.45341 .2008 m .47298 .20369 L .4611 .20653 L 0 1 .582 r
F
P
p
.44155 .20366 m .45341 .2008 L .4611 .20653 L 0 1 .764 r
F
P
p
.002 w
.45743 .78803 m .4456 .78888 L .43781 .78715 L p
.248 0 1 r
F P
0 0 0 r
s
P
p
.42187 .20077 m .44155 .20366 L .42977 .2065 L 0 1 .522 r
F
P
p
.41012 .20363 m .42187 .20077 L .42977 .2065 L 0 1 .682 r
F
P
p
.39033 .20074 m .41012 .20363 L .39844 .20647 L 0 1 .787 r
F
P
p
.37868 .2036 m .39033 .20074 L .39844 .20647 L 0 1 .818 r
F
P
p
.35878 .20071 m .37868 .2036 L .36711 .20644 L 0 .7 1 r
F
P
p
.34724 .20357 m .35878 .20071 L .36711 .20644 L 0 .686 1 r
F
P
p
.32723 .20069 m .34724 .20357 L .33578 .20641 L 0 .509 1 r
F
P
p
.3158 .20355 m .32723 .20069 L .33578 .20641 L 0 .45 1 r
F
P
p
.29568 .20066 m .3158 .20355 L .30444 .20639 L 0 .388 1 r
F
P
p
.28435 .20352 m .29568 .20066 L .30444 .20639 L 0 .253 1 r
F
P
p
.26413 .20063 m .28435 .20352 L .27311 .20636 L 0 .273 1 r
F
P
p
.25291 .20349 m .26413 .20063 L .27311 .20636 L 0 .266 1 r
F
P
p
.23257 .2006 m .25291 .20349 L .24177 .20633 L 0 .253 1 r
F
P
p
.22146 .20346 m .23257 .2006 L .24177 .20633 L 0 .047 1 r
F
P
p
.002 w
.7721 .43804 m .75952 .44986 L .75358 .43596 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.74099 .44783 m .72819 .44984 L .72259 .45564 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.7098 .45764 m .72259 .45564 L .72819 .44984 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.53741 .69196 m .52529 .69315 L .51803 .69076 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.50587 .70824 m .51803 .69076 L .52529 .69315 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.7098 .45764 m .69708 .45962 L .69101 .45562 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67831 .45762 m .69101 .45562 L .69708 .45962 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.67831 .45762 m .66571 .4596 L .65993 .48535 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.6473 .48725 m .65993 .48535 L .66571 .4596 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.17919 .89322 m .16822 .89372 L .16287 .80318 L p
1 0 .805 r
F P
0 0 0 r
s
P
p
.002 w
.16287 .80318 m .17495 .77768 L .17919 .89322 L p
1 0 .805 r
F P
0 0 0 r
s
P
p
.002 w
.14752 .89321 m .16287 .80318 L .16822 .89372 L closepath p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.17495 .77768 m .16287 .80318 L .15437 .77677 L p
.445 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.16287 .80318 m .14752 .89321 L .14225 .80236 L p
.902 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14225 .80236 m .15437 .77677 L .16287 .80318 L p
.902 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.2859 .88221 m .27418 .89323 L .26916 .77771 L p
1 0 .92 r
F P
0 0 0 r
s
P
p
.002 w
.26916 .77771 m .28042 .77681 L .2859 .88221 L p
1 0 .92 r
F P
0 0 0 r
s
P
p
.002 w
.28042 .77681 m .26916 .77771 L .26014 .7759 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24891 .7768 m .26014 .7759 L .26916 .77771 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24891 .7768 m .23776 .7777 L .22852 .77589 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.2174 .77679 m .22852 .77589 L .23776 .7777 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81657 .43601 m .82974 .43394 L .83487 .43808 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.2174 .77679 m .20635 .77769 L .1969 .77588 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20635 .77769 m .19023 .89271 L .18588 .77678 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18588 .77678 m .1969 .77588 L .20635 .77769 L p
.739 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81657 .43601 m .80349 .43806 L .79814 .43391 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78507 .43599 m .79814 .43391 L .80349 .43806 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19023 .89271 m .17919 .89322 L .17495 .77768 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.17495 .77768 m .18588 .77678 L .19023 .89271 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.18588 .77678 m .17495 .77768 L .16527 .77587 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15437 .77677 m .16527 .77587 L .17495 .77768 L p
.445 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.78507 .43599 m .7721 .43804 L .76653 .43389 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75358 .43596 m .76653 .43389 L .7721 .43804 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.31732 .89273 m .30584 .89324 L .30048 .78028 L p
1 0 .878 r
F P
0 0 0 r
s
P
p
.002 w
.30048 .78028 m .31193 .77682 L .31732 .89273 L p
1 0 .878 r
F P
0 0 0 r
s
P
p
.002 w
.2859 .88221 m .30048 .78028 L .30584 .89324 L p
1 0 .537 r
F P
0 0 0 r
s
P
p
.002 w
.31193 .77682 m .30048 .78028 L .29176 .77591 L p
.372 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30048 .78028 m .2859 .88221 L .28042 .77681 L p
.713 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28042 .77681 m .29176 .77591 L .30048 .78028 L p
.713 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.52292 .68711 m .51068 .68833 L .50382 .54403 L p
0 1 .318 r
F P
0 0 0 r
s
P
p
.002 w
.50382 .54403 m .51588 .54233 L .52292 .68711 L p
0 1 .318 r
F P
0 0 0 r
s
P
p
.002 w
.51588 .54233 m .50382 .54403 L .4964 .54061 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.78172 .19822 m .80022 .20113 L .78719 .20398 L 1 .068 0 r
F
P
p
.76871 .2011 m .78172 .19822 L .78719 .20398 L 1 .136 0 r
F
P
p
.7501 .19819 m .76871 .2011 L .75578 .20395 L 1 .136 0 r
F
P
p
.73719 .20107 m .7501 .19819 L .75578 .20395 L 1 .191 0 r
F
P
p
.71847 .19816 m .73719 .20107 L .72436 .20393 L 1 .263 0 r
F
P
p
.70566 .20104 m .71847 .19816 L .72436 .20393 L 1 .273 0 r
F
P
p
.68684 .19813 m .70566 .20104 L .69295 .2039 L 1 .239 0 r
F
P
p
.67414 .20101 m .68684 .19813 L .69295 .2039 L 1 .307 0 r
F
P
p
.6552 .1981 m .67414 .20101 L .66153 .20387 L 1 .205 0 r
F
P
p
.64261 .20098 m .6552 .1981 L .66153 .20387 L 1 .205 0 r
F
P
p
.62357 .19807 m .64261 .20098 L .63011 .20384 L .875 1 0 r
F
P
p
.61109 .20095 m .62357 .19807 L .63011 .20384 L .807 1 0 r
F
P
p
.002 w
.62264 .52073 m .6102 .5225 L .60482 .65446 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59903 .65847 m .58673 .68714 L .58117 .68516 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.58117 .68516 m .57978 .68467 L p
.58365 .6794 L 0 .818 1 r
F P
0 0 0 r
s
P
p
.58365 .6794 m .59903 .65847 L .58117 .68516 L 0 .818 1 r
F
P
p
.002 w
.57978 .68467 m .59238 .68342 L .59903 .65847 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.6102 .5225 m .59903 .65847 L .5955 .67171 L p
0 1 .545 r
F P
0 0 0 r
s
P
p
.002 w
.5955 .67171 m .59238 .68342 L p
.59493 .66039 L 0 1 .545 r
F P
0 0 0 r
s
P
p
.59493 .66039 m .6102 .5225 L .5955 .67171 L 0 1 .545 r
F
P
p
.002 w
.60482 .65446 m .60592 .62753 L p
.59847 .65827 L 0 1 .545 r
F P
0 0 0 r
s
P
p
.002 w
.59238 .68342 m .60482 .65446 L p
.59847 .65827 L 0 1 .545 r
F P
0 0 0 r
s
P
p
.002 w
.60592 .62753 m .6102 .5225 L p
.59602 .65057 L 0 1 .545 r
F P
0 0 0 r
s
P
p
.59238 .68342 m .60592 .62753 L .59602 .65057 L 0 1 .545 r
F
P
p
.002 w
.60482 .65446 m .61755 .6531 L .62264 .52073 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60482 .65446 m .59765 .62009 L p
.61476 .64848 L 0 1 .657 r
F P
0 0 0 r
s
P
p
.002 w
.61755 .6531 m .60482 .65446 L p
.61476 .64848 L 0 1 .657 r
F P
0 0 0 r
s
P
p
.002 w
.59765 .62009 m .60482 .65446 L p
.59371 .63603 L 0 1 .792 r
F P
0 0 0 r
s
P
p
.002 w
.58499 .62156 m .59294 .62064 L p
.59371 .63603 L 0 1 .792 r
F P
0 0 0 r
s
P
p
.002 w
.59294 .62064 m .59765 .62009 L p
.59371 .63603 L 0 1 .792 r
F P
0 0 0 r
s
P
p
.59193 .19804 m .61109 .20095 L .59869 .20381 L .227 1 0 r
F
P
p
.57956 .20092 m .59193 .19804 L .59869 .20381 L 0 1 0 r
F
P
p
.56029 .19801 m .57956 .20092 L .56727 .20378 L .79 1 0 r
F
P
p
.54802 .20089 m .56029 .19801 L .56727 .20378 L .636 1 0 r
F
P
p
.52864 .19798 m .54802 .20089 L .53584 .20375 L 0 1 .064 r
F
P
p
.51649 .20086 m .52864 .19798 L .53584 .20375 L 0 1 .136 r
F
P
p
.497 .19795 m .51649 .20086 L .50441 .20372 L 0 1 .341 r
F
P
p
.48495 .20083 m .497 .19795 L .50441 .20372 L 0 1 .545 r
F
P
p
.46535 .19792 m .48495 .20083 L .47298 .20369 L 0 1 .291 r
F
P
p
.45341 .2008 m .46535 .19792 L .47298 .20369 L 0 1 .582 r
F
P
p
.4337 .19789 m .45341 .2008 L .44155 .20366 L 0 1 .264 r
F
P
p
.42187 .20077 m .4337 .19789 L .44155 .20366 L 0 1 .522 r
F
P
p
.40205 .19787 m .42187 .20077 L .41012 .20363 L 0 1 .704 r
F
P
p
.39033 .20074 m .40205 .19787 L .41012 .20363 L 0 1 .787 r
F
P
p
.3704 .19784 m .39033 .20074 L .37868 .2036 L 0 .714 1 r
F
P
p
.35878 .20071 m .3704 .19784 L .37868 .2036 L 0 .7 1 r
F
P
p
.33874 .19781 m .35878 .20071 L .34724 .20357 L 0 .509 1 r
F
P
p
.32723 .20069 m .33874 .19781 L .34724 .20357 L 0 .509 1 r
F
P
p
.30708 .19778 m .32723 .20069 L .3158 .20355 L 0 .45 1 r
F
P
p
.29568 .20066 m .30708 .19778 L .3158 .20355 L 0 .388 1 r
F
P
p
.27542 .19775 m .29568 .20066 L .28435 .20352 L 0 .332 1 r
F
P
p
.26413 .20063 m .27542 .19775 L .28435 .20352 L 0 .273 1 r
F
P
p
.24376 .19772 m .26413 .20063 L .25291 .20349 L 0 .388 1 r
F
P
p
.23257 .2006 m .24376 .19772 L .25291 .20349 L 0 .253 1 r
F
P
p
.002 w
.72259 .45564 m .73548 .45363 L .74099 .44783 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.54961 .69077 m .53741 .69196 L .53021 .68955 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.51803 .69076 m .53021 .68955 L .53741 .69196 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.72259 .45564 m .7098 .45764 L .70379 .45361 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69101 .45562 m .70379 .45361 L .7098 .45764 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69101 .45562 m .67831 .45762 L .67266 .48344 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.65993 .48535 m .67266 .48344 L .67831 .45762 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.32888 .89222 m .31732 .89273 L .31193 .77682 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.31193 .77682 m .32337 .77591 L .32888 .89222 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.32337 .77591 m .31193 .77682 L .30317 .775 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29176 .77591 m .30317 .775 L .31193 .77682 L p
.372 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29176 .77591 m .28042 .77681 L .27144 .77499 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26014 .7759 m .27144 .77499 L .28042 .77681 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12668 .8927 m .14225 .80236 L .14752 .89321 L closepath p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.15437 .77677 m .14225 .80236 L .1275 .89115 L p
.829 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14225 .80236 m .12668 .8927 L .11655 .89167 L p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.11655 .89167 m .1275 .89115 L .14225 .80236 L p
1 0 .43 r
F P
0 0 0 r
s
P
p
.002 w
.26014 .7759 m .24891 .7768 L .23972 .77498 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22852 .77589 m .23972 .77498 L .24891 .7768 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22852 .77589 m .2174 .77679 L .20799 .77497 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1969 .77588 m .20799 .77497 L .2174 .77679 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.82974 .43394 m .81657 .43601 L .81129 .43183 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79814 .43391 m .81129 .43183 L .81657 .43601 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.1969 .77588 m .18588 .77678 L .17625 .77496 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.16527 .77587 m .17625 .77496 L .18588 .77678 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.79814 .43391 m .78507 .43599 L .77958 .43181 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76653 .43389 m .77958 .43181 L .78507 .43599 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.16527 .77587 m .15437 .77677 L .14438 .77754 L p
.372 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1275 .89115 m .14438 .77754 L .15437 .77677 L p
.829 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.76653 .43389 m .75358 .43596 L .74816 .44168 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .45363 m .74816 .44168 L .75358 .43596 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.6473 .48725 m .63474 .48914 L .62997 .62011 L p
.695 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63474 .48914 m .62264 .52073 L .61755 .6531 L p
.206 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61755 .6531 m .62997 .62011 L .63474 .48914 L p
.206 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53524 .68589 m .52292 .68711 L .51588 .54233 L p
0 1 .269 r
F P
0 0 0 r
s
P
p
.002 w
.51588 .54233 m .52804 .52637 L .53524 .68589 L p
0 1 .269 r
F P
0 0 0 r
s
P
p
.002 w
.52804 .52637 m .51588 .54233 L .50853 .53889 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50853 .53889 m .51588 .54233 L p
.50074 .54099 L .636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50853 .53889 m .50041 .67959 L p
.51637 .53677 L 0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.50853 .53889 m .52081 .49712 L .52804 .52637 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52081 .49712 m .50853 .53889 L p
.51637 .53677 L 0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.4964 .54061 m .50853 .53889 L p
.50074 .54099 L .636 1 0 r
F P
0 0 0 r
s
P
p
.78172 .19822 m .79483 .19532 L .80022 .20113 L 1 .068 0 r
F
P
p
.7631 .19529 m .78172 .19822 L .76871 .2011 L 1 .136 0 r
F
P
p
.7501 .19819 m .7631 .19529 L .76871 .2011 L 1 .136 0 r
F
P
p
.73136 .19526 m .7501 .19819 L .73719 .20107 L 1 .195 0 r
F
P
p
.71847 .19816 m .73136 .19526 L .73719 .20107 L 1 .263 0 r
F
P
p
.69962 .19523 m .71847 .19816 L .70566 .20104 L 1 .205 0 r
F
P
p
.68684 .19813 m .69962 .19523 L .70566 .20104 L 1 .239 0 r
F
P
p
.66788 .1952 m .68684 .19813 L .67414 .20101 L 1 .205 0 r
F
P
p
.6552 .1981 m .66788 .1952 L .67414 .20101 L 1 .205 0 r
F
P
p
.63613 .19518 m .6552 .1981 L .64261 .20098 L 1 .92 0 r
F
P
p
.62357 .19807 m .63613 .19518 L .64261 .20098 L .875 1 0 r
F
P
p
.60439 .19515 m .62357 .19807 L .61109 .20095 L .511 1 0 r
F
P
p
.59193 .19804 m .60439 .19515 L .61109 .20095 L .227 1 0 r
F
P
p
.57264 .19512 m .59193 .19804 L .57956 .20092 L 1 .972 0 r
F
P
p
.56029 .19801 m .57264 .19512 L .57956 .20092 L .79 1 0 r
F
P
p
.54089 .19509 m .56029 .19801 L .54802 .20089 L .118 1 0 r
F
P
p
.52864 .19798 m .54089 .19509 L .54802 .20089 L 0 1 .064 r
F
P
p
.50913 .19506 m .52864 .19798 L .51649 .20086 L 0 1 .136 r
F
P
p
.497 .19795 m .50913 .19506 L .51649 .20086 L 0 1 .341 r
F
P
p
.47738 .19503 m .497 .19795 L .48495 .20083 L 0 1 .045 r
F
P
p
.46535 .19792 m .47738 .19503 L .48495 .20083 L 0 1 .291 r
F
P
p
.44562 .195 m .46535 .19792 L .45341 .2008 L .05 1 0 r
F
P
p
.4337 .19789 m .44562 .195 L .45341 .2008 L 0 1 .264 r
F
P
p
.41386 .19497 m .4337 .19789 L .42187 .20077 L 0 1 .511 r
F
P
p
.40205 .19787 m .41386 .19497 L .42187 .20077 L 0 1 .704 r
F
P
p
.002 w
.51803 .69076 m .50587 .70824 L .49852 .68954 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.48645 .69074 m .49852 .68954 L .50587 .70824 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.3821 .19494 m .40205 .19787 L .39033 .20074 L 0 .803 1 r
F
P
p
.3704 .19784 m .3821 .19494 L .39033 .20074 L 0 .714 1 r
F
P
p
.35033 .19491 m .3704 .19784 L .35878 .20071 L 0 .509 1 r
F
P
p
.33874 .19781 m .35033 .19491 L .35878 .20071 L 0 .509 1 r
F
P
p
.31857 .19488 m .33874 .19781 L .32723 .20069 L 0 .509 1 r
F
P
p
.30708 .19778 m .31857 .19488 L .32723 .20069 L 0 .45 1 r
F
P
p
.002 w
.30584 .89324 m .29444 .89374 L .2859 .88221 L p
1 0 .537 r
F P
0 0 0 r
s
P
p
.002 w
.27418 .89323 m .2859 .88221 L .29444 .89374 L closepath p
1 0 .17 r
F P
0 0 0 r
s
P
p
.2868 .19485 m .30708 .19778 L .29568 .20066 L 0 .391 1 r
F
P
p
.27542 .19775 m .2868 .19485 L .29568 .20066 L 0 .332 1 r
F
P
p
.25503 .19482 m .27542 .19775 L .26413 .20063 L 0 .391 1 r
F
P
p
.24376 .19772 m .25503 .19482 L .26413 .20063 L 0 .388 1 r
F
P
p
.002 w
.4964 .54061 m .4843 .5523 L .47533 .72409 L p
0 1 .543 r
F P
0 0 0 r
s
P
p
.002 w
.54765 .68465 m .53524 .68589 L .52804 .52637 L p
0 1 .201 r
F P
0 0 0 r
s
P
p
.002 w
.52804 .52637 m .54024 .5189 L .54765 .68465 L p
0 1 .201 r
F P
0 0 0 r
s
P
p
.002 w
.54024 .5189 m .52804 .52637 L .52081 .49712 L p
1 .94 0 r
F P
0 0 0 r
s
P
p
.002 w
.5619 .68957 m .54961 .69077 L .54248 .68835 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.53021 .68955 m .54248 .68835 L .54961 .69077 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.53021 .68955 m .51803 .69076 L .51068 .68833 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.49852 .68954 m .51068 .68833 L .51803 .69076 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.34713 .7486 m .33489 .77501 L .32852 .69068 L p
0 .266 1 r
F P
0 0 0 r
s
P
p
.002 w
.32852 .69068 m .34005 .68948 L .34713 .7486 L p
0 .266 1 r
F P
0 0 0 r
s
P
p
.002 w
.31541 .74859 m .32852 .69068 L .33489 .77501 L p
.007 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33489 .77501 m .32337 .77591 L .31541 .74859 L p
.007 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31541 .74859 m .32337 .77591 L p
.31096 .77535 L .28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30317 .775 m .31541 .74859 L p
.31096 .77535 L .28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31541 .74859 m .30317 .775 L .29429 .77315 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29429 .77315 m .30583 .77222 L .31541 .74859 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.31541 .74859 m .30583 .77222 L p
.31987 .72176 L .007 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32852 .69068 m .31541 .74859 L p
.31987 .72176 L .007 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34005 .68948 m .32852 .69068 L .31745 .77128 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.002 w
.30583 .77222 m .31745 .77128 L .32852 .69068 L p
.007 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.73548 .45363 m .72259 .45564 L .71665 .45159 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.70379 .45361 m .71665 .45159 L .72259 .45564 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.70379 .45361 m .69101 .45562 L .68547 .48151 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.67266 .48344 m .68547 .48151 L .69101 .45562 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.34051 .8917 m .32888 .89222 L .32337 .77591 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.32337 .77591 m .33489 .77501 L .34051 .8917 L p
1 0 .886 r
F P
0 0 0 r
s
P
p
.002 w
.30317 .775 m .29176 .77591 L .28283 .77407 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27144 .77499 m .28283 .77407 L .29176 .77591 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27144 .77499 m .26014 .7759 L .25099 .77406 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23972 .77498 m .25099 .77406 L .26014 .7759 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23972 .77498 m .22852 .77589 L .21915 .77405 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20799 .77497 m .21915 .77405 L .22852 .77589 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81129 .43183 m .82454 .42973 L .82974 .43394 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.20799 .77497 m .1969 .77588 L .18731 .77404 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17625 .77496 m .18731 .77404 L .1969 .77588 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81129 .43183 m .79814 .43391 L .79272 .42971 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77958 .43181 m .79272 .42971 L .79814 .43391 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.17625 .77496 m .16527 .77587 L .15547 .77403 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14438 .77754 m .15547 .77403 L .16527 .77587 L p
.372 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77958 .43181 m .76653 .43389 L .76121 .43962 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.74816 .44168 m .76121 .43962 L .76653 .43389 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.65993 .48535 m .6473 .48725 L .64157 .53372 L p
1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.64157 .53372 m .6473 .48725 L p
.63826 .55653 L .695 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64157 .53372 m .63469 .50982 L p
.6449 .5108 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.65403 .51168 m .65993 .48535 L p
.64686 .51979 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.64157 .53372 m .65403 .51168 L p
.64686 .51979 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.67266 .48344 m .65993 .48535 L .65403 .51168 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.65403 .51168 m .66688 .50984 L .67266 .48344 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.65403 .51168 m .6472 .48767 L p
.66126 .50351 L 1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.66688 .50984 m .65403 .51168 L p
.66126 .50351 L 1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.65403 .51168 m .64157 .53372 L p
.6449 .5108 L .909 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62997 .62011 m .64157 .53372 L p
.63826 .55653 L .695 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50853 .53889 m .4964 .54061 L .48789 .69764 L p
0 1 .373 r
F P
0 0 0 r
s
P
p
.002 w
.48789 .69764 m .4964 .54061 L p
.47609 .71747 L 0 1 .543 r
F P
0 0 0 r
s
P
p
.002 w
.50041 .67959 m .50853 .53889 L p
.48938 .68614 L 0 1 .373 r
F P
0 0 0 r
s
P
p
.002 w
.48789 .69764 m .50041 .67959 L p
.48938 .68614 L 0 1 .373 r
F P
0 0 0 r
s
P
p
.002 w
.50041 .67959 m .51292 .67831 L .52081 .49712 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.50041 .67959 m .49311 .60371 L p
.51151 .673 L 0 1 .74 r
F P
0 0 0 r
s
P
p
.002 w
.51292 .67831 m .50041 .67959 L p
.51151 .673 L 0 1 .74 r
F P
0 0 0 r
s
P
p
.002 w
.48789 .69764 m .48058 .62805 L p
.49971 .67777 L 0 1 .925 r
F P
0 0 0 r
s
P
p
.002 w
.50041 .67959 m .48789 .69764 L p
.49971 .67777 L 0 1 .925 r
F P
0 0 0 r
s
P
p
.002 w
.47533 .72409 m .48789 .69764 L p
.47609 .71747 L 0 1 .543 r
F P
0 0 0 r
s
P
p
.77618 .19238 m .79483 .19532 L .78172 .19822 L 1 .102 0 r
F
P
p
.7631 .19529 m .77618 .19238 L .78172 .19822 L 1 .136 0 r
F
P
p
.74434 .19235 m .7631 .19529 L .7501 .19819 L 1 .102 0 r
F
P
p
.73136 .19526 m .74434 .19235 L .7501 .19819 L 1 .195 0 r
F
P
p
.71249 .19232 m .73136 .19526 L .71847 .19816 L 1 .195 0 r
F
P
p
.69962 .19523 m .71249 .19232 L .71847 .19816 L 1 .205 0 r
F
P
p
.68064 .19229 m .69962 .19523 L .68684 .19813 L 1 .162 0 r
F
P
p
.66788 .1952 m .68064 .19229 L .68684 .19813 L 1 .205 0 r
F
P
p
.64878 .19226 m .66788 .1952 L .6552 .1981 L 1 .58 0 r
F
P
p
.63613 .19518 m .64878 .19226 L .6552 .1981 L 1 .92 0 r
F
P
p
.61693 .19223 m .63613 .19518 L .62357 .19807 L .602 1 0 r
F
P
p
.60439 .19515 m .61693 .19223 L .62357 .19807 L .511 1 0 r
F
P
p
.58507 .1922 m .60439 .19515 L .59193 .19804 L 1 .841 0 r
F
P
p
.57264 .19512 m .58507 .1922 L .59193 .19804 L 1 .972 0 r
F
P
p
.55321 .19217 m .57264 .19512 L .56029 .19801 L .48 1 0 r
F
P
p
.54089 .19509 m .55321 .19217 L .56029 .19801 L .118 1 0 r
F
P
p
.002 w
.56015 .68341 m .54765 .68465 L .54024 .5189 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.54024 .5189 m .55252 .5171 L .56015 .68341 L p
0 1 .182 r
F P
0 0 0 r
s
P
p
.002 w
.55252 .5171 m .54024 .5189 L .53303 .48527 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.52081 .49712 m .53303 .48527 L .54024 .5189 L p
1 .94 0 r
F P
0 0 0 r
s
P
p
.52135 .19214 m .54089 .19509 L .52864 .19798 L 0 1 .064 r
F
P
p
.50913 .19506 m .52135 .19214 L .52864 .19798 L 0 1 .136 r
F
P
p
.48948 .19211 m .50913 .19506 L .497 .19795 L .295 1 0 r
F
P
p
.47738 .19503 m .48948 .19211 L .497 .19795 L 0 1 .045 r
F
P
p
.45762 .19208 m .47738 .19503 L .46535 .19792 L .227 1 0 r
F
P
p
.44562 .195 m .45762 .19208 L .46535 .19792 L .05 1 0 r
F
P
p
.42575 .19205 m .44562 .195 L .4337 .19789 L 0 1 .264 r
F
P
p
.41386 .19497 m .42575 .19205 L .4337 .19789 L 0 1 .511 r
F
P
p
.39388 .19202 m .41386 .19497 L .40205 .19787 L 0 .946 1 r
F
P
p
.3821 .19494 m .39388 .19202 L .40205 .19787 L 0 .803 1 r
F
P
p
.362 .19199 m .3821 .19494 L .3704 .19784 L 0 .509 1 r
F
P
p
.35033 .19491 m .362 .19199 L .3704 .19784 L 0 .509 1 r
F
P
p
.33013 .19196 m .35033 .19491 L .33874 .19781 L 0 .509 1 r
F
P
p
.31857 .19488 m .33013 .19196 L .33874 .19781 L 0 .509 1 r
F
P
p
.29825 .19193 m .31857 .19488 L .30708 .19778 L 0 .45 1 r
F
P
p
.2868 .19485 m .29825 .19193 L .30708 .19778 L 0 .391 1 r
F
P
p
.26637 .1919 m .2868 .19485 L .27542 .19775 L 0 .391 1 r
F
P
p
.25503 .19482 m .26637 .1919 L .27542 .19775 L 0 .391 1 r
F
P
p
.002 w
.35973 .70704 m .37175 .68949 L .37614 .87944 L p
.555 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.34713 .7486 m .35973 .70704 L .36427 .88 L p
.777 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37175 .68949 m .35973 .70704 L .35166 .68827 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.35973 .70704 m .34713 .7486 L .34005 .68948 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.34005 .68948 m .35166 .68827 L .35973 .70704 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.53303 .48527 m .52081 .49712 L .51292 .67831 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.002 w
.57427 .68836 m .5619 .68957 L .55482 .68713 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.54248 .68835 m .55482 .68713 L .5619 .68957 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.54248 .68835 m .53021 .68955 L .52292 .68711 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.51068 .68833 m .52292 .68711 L .53021 .68955 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.38809 .87887 m .37614 .87944 L .37175 .68949 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.37175 .68949 m .38347 .68828 L .38809 .87887 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38347 .68828 m .37175 .68949 L .36335 .68705 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.35166 .68827 m .36335 .68705 L .37175 .68949 L p
0 .673 1 r
F P
0 0 0 r
s
P
p
.002 w
.35166 .68827 m .34005 .68948 L .32916 .77034 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.002 w
.31745 .77128 m .32916 .77034 L .34005 .68948 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.002 w
.74816 .44168 m .73548 .45363 L .72961 .44955 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.71665 .45159 m .72961 .44955 L .73548 .45363 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71665 .45159 m .70379 .45361 L .69769 .44953 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68547 .48151 m .69769 .44953 L .70379 .45361 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.35223 .89118 m .34051 .8917 L .33489 .77501 L p
1 0 .97 r
F P
0 0 0 r
s
P
p
.002 w
.33489 .77501 m .34713 .7486 L .35223 .89118 L p
1 0 .97 r
F P
0 0 0 r
s
P
p
.002 w
.28283 .77407 m .29429 .77315 L .30317 .775 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.36427 .88 m .35223 .89118 L .34713 .7486 L p
.777 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28283 .77407 m .27144 .77499 L .26234 .77314 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25099 .77406 m .26234 .77314 L .27144 .77499 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25099 .77406 m .23972 .77498 L .23039 .77313 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21915 .77405 m .23039 .77313 L .23972 .77498 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21915 .77405 m .20799 .77497 L .19844 .77312 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18731 .77404 m .19844 .77312 L .20799 .77497 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.82454 .42973 m .81129 .43183 L .80594 .4276 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.79272 .42971 m .80594 .4276 L .81129 .43183 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.18731 .77404 m .17625 .77496 L .16649 .77311 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15547 .77403 m .16649 .77311 L .17625 .77496 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.79272 .42971 m .77958 .43181 L .77435 .43753 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.76121 .43962 m .77435 .43753 L .77958 .43181 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.54532 .48336 m .55252 .5171 L p
.5344 .48751 L 1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.57258 .65444 m .56015 .68341 L .55252 .5171 L p
0 1 .023 r
F P
0 0 0 r
s
P
p
.002 w
.55252 .5171 m .5648 .49527 L .57258 .65444 L p
0 1 .023 r
F P
0 0 0 r
s
P
p
.002 w
.5648 .49527 m .55252 .5171 L .54532 .48336 L p
1 .761 0 r
F P
0 0 0 r
s
P
p
.002 w
.54532 .48336 m .55764 .46476 L .5648 .49527 L p
1 .761 0 r
F P
0 0 0 r
s
P
p
.002 w
.54532 .48336 m .53884 .65828 L p
.55631 .47917 L .17 1 0 r
F P
0 0 0 r
s
P
p
.53987 .65761 m .55631 .47917 L .53884 .65828 L .17 1 0 r
F
P
p
.002 w
.52551 .67702 m .5382 .67572 L .54532 .48336 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58499 .62156 m .57258 .65444 L .5648 .49527 L p
.274 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5648 .49527 m .57716 .48338 L .58499 .62156 L p
.274 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57716 .48338 m .5648 .49527 L .55764 .46476 L p
1 .591 0 r
F P
0 0 0 r
s
P
p
.002 w
.57006 .45943 m .57716 .48338 L p
.55826 .46535 L 1 .591 0 r
F P
0 0 0 r
s
P
p
.002 w
.55764 .46476 m .57006 .45943 L p
.55826 .46535 L 1 .591 0 r
F P
0 0 0 r
s
P
p
.002 w
.59765 .62009 m .58499 .62156 L .57716 .48338 L p
.412 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57716 .48338 m .58964 .48145 L .59765 .62009 L p
.412 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58964 .48145 m .57716 .48338 L .57006 .45943 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.57006 .45943 m .5825 .44739 L .58964 .48145 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.57006 .45943 m .56373 .64472 L p
.58192 .45347 L .375 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5825 .44739 m .57006 .45943 L p
.58192 .45347 L .375 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57006 .45943 m .55764 .46476 L .55091 .64613 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55091 .64613 m .55764 .46476 L p
.53987 .65761 L .17 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5382 .67572 m .55091 .64613 L p
.53987 .65761 L .17 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55091 .64613 m .56373 .64472 L .57006 .45943 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55091 .64613 m .54333 .52466 L p
.56201 .6346 L 0 1 .136 r
F P
0 0 0 r
s
P
p
.56201 .6346 m .5633 .64219 L .55091 .64613 L 0 1 .136 r
F
P
p
.002 w
.56373 .64472 m .55859 .64529 L p
.5633 .64219 L 0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.55859 .64529 m .55091 .64613 L p
.5633 .64219 L 0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.53884 .65828 m .5382 .67572 L p
.53987 .65761 L .17 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55764 .46476 m .54532 .48336 L p
.55631 .47917 L .17 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53303 .48527 m .54532 .48336 L p
.5344 .48751 L 1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.54532 .48336 m .53303 .48527 L .52551 .67702 L p
.023 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51292 .67831 m .52551 .67702 L .53303 .48527 L p
0 1 .011 r
F P
0 0 0 r
s
P
p
.002 w
.15547 .77403 m .14438 .77754 L .1344 .77571 L p
.381 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14438 .77754 m .1275 .89115 L .11844 .86872 L p
1 0 .938 r
F P
0 0 0 r
s
P
p
.002 w
.11844 .86872 m .1344 .77571 L .14438 .77754 L p
1 0 .938 r
F P
0 0 0 r
s
P
p
.77618 .19238 m .78936 .18944 L .79483 .19532 L 1 .102 0 r
F
P
p
.75741 .18941 m .77618 .19238 L .7631 .19529 L 1 .068 0 r
F
P
p
.74434 .19235 m .75741 .18941 L .7631 .19529 L 1 .102 0 r
F
P
p
.72545 .18938 m .74434 .19235 L .73136 .19526 L 1 .127 0 r
F
P
p
.71249 .19232 m .72545 .18938 L .73136 .19526 L 1 .195 0 r
F
P
p
.69349 .18935 m .71249 .19232 L .69962 .19523 L 1 .119 0 r
F
P
p
.68064 .19229 m .69349 .18935 L .69962 .19523 L 1 .162 0 r
F
P
p
.66153 .18932 m .68064 .19229 L .66788 .1952 L 1 .409 0 r
F
P
p
.64878 .19226 m .66153 .18932 L .66788 .1952 L 1 .58 0 r
F
P
p
.62956 .18929 m .64878 .19226 L .63613 .19518 L .841 1 0 r
F
P
p
.61693 .19223 m .62956 .18929 L .63613 .19518 L .602 1 0 r
F
P
p
.59759 .18926 m .61693 .19223 L .60439 .19515 L 1 .739 0 r
F
P
p
.58507 .1922 m .59759 .18926 L .60439 .19515 L 1 .841 0 r
F
P
p
.56562 .18923 m .58507 .1922 L .57264 .19512 L .821 1 0 r
F
P
p
.55321 .19217 m .56562 .18923 L .57264 .19512 L .48 1 0 r
F
P
p
.53365 .1892 m .55321 .19217 L .54089 .19509 L .186 1 0 r
F
P
p
.52135 .19214 m .53365 .1892 L .54089 .19509 L 0 1 .064 r
F
P
p
.50168 .18917 m .52135 .19214 L .50913 .19506 L .531 1 0 r
F
P
p
.48948 .19211 m .50168 .18917 L .50913 .19506 L .295 1 0 r
F
P
p
.4697 .18914 m .48948 .19211 L .47738 .19503 L .364 1 0 r
F
P
p
.45762 .19208 m .4697 .18914 L .47738 .19503 L .227 1 0 r
F
P
p
.43772 .18911 m .45762 .19208 L .44562 .195 L 0 1 .028 r
F
P
p
.42575 .19205 m .43772 .18911 L .44562 .195 L 0 1 .264 r
F
P
p
.40574 .18908 m .42575 .19205 L .41386 .19497 L 0 1 .925 r
F
P
p
.39388 .19202 m .40574 .18908 L .41386 .19497 L 0 .946 1 r
F
P
p
.37376 .18905 m .39388 .19202 L .3821 .19494 L 0 .598 1 r
F
P
p
.362 .19199 m .37376 .18905 L .3821 .19494 L 0 .509 1 r
F
P
p
.34177 .18902 m .362 .19199 L .35033 .19491 L 0 .509 1 r
F
P
p
.33013 .19196 m .34177 .18902 L .35033 .19491 L 0 .509 1 r
F
P
p
.30978 .18899 m .33013 .19196 L .31857 .19488 L 0 .509 1 r
F
P
p
.29825 .19193 m .30978 .18899 L .31857 .19488 L 0 .45 1 r
F
P
p
.27779 .18896 m .29825 .19193 L .2868 .19485 L 0 .391 1 r
F
P
p
.26637 .1919 m .27779 .18896 L .2868 .19485 L 0 .391 1 r
F
P
p
.002 w
.76121 .43962 m .74816 .44168 L .74266 .4475 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.72961 .44955 m .74266 .4475 L .74816 .44168 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.58673 .68714 m .57427 .68836 L .56726 .6859 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.55482 .68713 m .56726 .6859 L .57427 .68836 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.55482 .68713 m .54248 .68835 L .53524 .68589 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.52292 .68711 m .53524 .68589 L .54248 .68835 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.40012 .8783 m .38809 .87887 L .38347 .68828 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.38347 .68828 m .39527 .68706 L .40012 .8783 L p
.5 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.39527 .68706 m .38347 .68828 L .37513 .68583 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.36335 .68705 m .37513 .68583 L .38347 .68828 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.36335 .68705 m .35166 .68827 L .34094 .76939 L p
0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.32916 .77034 m .34094 .76939 L .35166 .68827 L p
0 .182 1 r
F P
0 0 0 r
s
P
p
.002 w
.72961 .44955 m .71665 .45159 L .71063 .44748 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69769 .44953 m .71063 .44748 L .71665 .45159 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.29429 .77315 m .28283 .77407 L .27377 .77221 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26234 .77314 m .27377 .77221 L .28283 .77407 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26234 .77314 m .25099 .77406 L .24171 .7722 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23039 .77313 m .24171 .7722 L .25099 .77406 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23039 .77313 m .21915 .77405 L .20965 .77219 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19844 .77312 m .20965 .77219 L .21915 .77405 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.80594 .4276 m .81926 .42547 L .82454 .42973 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.19844 .77312 m .18731 .77404 L .17759 .77218 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.16649 .77311 m .17759 .77218 L .18731 .77404 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.80594 .4276 m .79272 .42971 L .78757 .43544 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.77435 .43753 m .78757 .43544 L .79272 .42971 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.16649 .77311 m .15547 .77403 L .14552 .77217 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1344 .77571 m .14552 .77217 L .15547 .77403 L p
.381 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68547 .48151 m .67266 .48344 L .66688 .50984 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.77057 .18645 m .78936 .18944 L .77618 .19238 L 1 .068 0 r
F
P
p
.75741 .18941 m .77057 .18645 L .77618 .19238 L 1 .068 0 r
F
P
p
.7385 .18642 m .75741 .18941 L .74434 .19235 L 1 .034 0 r
F
P
p
.72545 .18938 m .7385 .18642 L .74434 .19235 L 1 .127 0 r
F
P
p
.70643 .18639 m .72545 .18938 L .71249 .19232 L 1 .094 0 r
F
P
p
.69349 .18935 m .70643 .18639 L .71249 .19232 L 1 .119 0 r
F
P
p
.67435 .18636 m .69349 .18935 L .68064 .19229 L 1 .298 0 r
F
P
p
.66153 .18932 m .67435 .18636 L .68064 .19229 L 1 .409 0 r
F
P
p
.64228 .18633 m .66153 .18932 L .64878 .19226 L 1 .776 0 r
F
P
p
.62956 .18929 m .64228 .18633 L .64878 .19226 L .841 1 0 r
F
P
p
.6102 .1863 m .62956 .18929 L .61693 .19223 L 1 .614 0 r
F
P
p
.59759 .18926 m .6102 .1863 L .61693 .19223 L 1 .739 0 r
F
P
p
.57812 .18627 m .59759 .18926 L .58507 .1922 L .943 1 0 r
F
P
p
.56562 .18923 m .57812 .18627 L .58507 .1922 L .821 1 0 r
F
P
p
.54604 .18624 m .56562 .18923 L .55321 .19217 L .634 1 0 r
F
P
p
.53365 .1892 m .54604 .18624 L .55321 .19217 L .186 1 0 r
F
P
p
.51395 .18621 m .53365 .1892 L .52135 .19214 L .6 1 0 r
F
P
p
.50168 .18917 m .51395 .18621 L .52135 .19214 L .531 1 0 r
F
P
p
.48186 .18618 m .50168 .18917 L .48948 .19211 L .514 1 0 r
F
P
p
.4697 .18914 m .48186 .18618 L .48948 .19211 L .364 1 0 r
F
P
p
.44977 .18615 m .4697 .18914 L .45762 .19208 L .071 1 0 r
F
P
p
.43772 .18911 m .44977 .18615 L .45762 .19208 L 0 1 .028 r
F
P
p
.41768 .18612 m .43772 .18911 L .42575 .19205 L 0 1 .849 r
F
P
p
.40574 .18908 m .41768 .18612 L .42575 .19205 L 0 1 .925 r
F
P
p
.38559 .18609 m .40574 .18908 L .39388 .19202 L 0 .686 1 r
F
P
p
.37376 .18905 m .38559 .18609 L .39388 .19202 L 0 .598 1 r
F
P
p
.35349 .18606 m .37376 .18905 L .362 .19199 L 0 .509 1 r
F
P
p
.34177 .18902 m .35349 .18606 L .362 .19199 L 0 .509 1 r
F
P
p
.32139 .18603 m .34177 .18902 L .33013 .19196 L 0 .509 1 r
F
P
p
.30978 .18899 m .32139 .18603 L .33013 .19196 L 0 .509 1 r
F
P
p
.28929 .186 m .30978 .18899 L .29825 .19193 L 0 .45 1 r
F
P
p
.27779 .18896 m .28929 .186 L .29825 .19193 L 0 .391 1 r
F
P
p
.002 w
.77435 .43753 m .76121 .43962 L .75579 .44543 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.74266 .4475 m .75579 .44543 L .76121 .43962 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.56726 .6859 m .57978 .68467 L .58673 .68714 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.56726 .6859 m .55482 .68713 L .54765 .68465 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.53524 .68589 m .54765 .68465 L .55482 .68713 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.41241 .86695 m .40012 .8783 L .39527 .68706 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.40715 .68584 m .39527 .68706 L .38698 .68459 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.37513 .68583 m .38698 .68459 L .39527 .68706 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.37513 .68583 m .36335 .68705 L .35332 .74729 L p
0 .334 1 r
F P
0 0 0 r
s
P
p
.002 w
.35332 .74729 m .36335 .68705 L p
.3453 .75337 L 0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.36535 .74138 m .37513 .68583 L p
.35458 .74376 L 0 .334 1 r
F P
0 0 0 r
s
P
p
.002 w
.35332 .74729 m .36535 .74138 L p
.35458 .74376 L 0 .334 1 r
F P
0 0 0 r
s
P
p
.002 w
.38698 .68459 m .37513 .68583 L .36535 .74138 L p
0 .35 1 r
F P
0 0 0 r
s
P
p
.002 w
.36535 .74138 m .37735 .74032 L .38698 .68459 L p
0 .35 1 r
F P
0 0 0 r
s
P
p
.002 w
.36535 .74138 m .35723 .71688 L p
.3762 .73899 L 0 .178 1 r
F P
0 0 0 r
s
P
p
.002 w
.37735 .74032 m .36535 .74138 L p
.3762 .73899 L 0 .178 1 r
F P
0 0 0 r
s
P
p
.002 w
.35332 .74729 m .34473 .74031 L p
.3614 .74118 L 0 .028 1 r
F P
0 0 0 r
s
P
p
.002 w
.36535 .74138 m .35332 .74729 L p
.3614 .74118 L 0 .028 1 r
F P
0 0 0 r
s
P
p
.002 w
.34094 .76939 m .35332 .74729 L p
.3453 .75337 L 0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.74266 .4475 m .72961 .44955 L .72366 .44541 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71063 .44748 m .72366 .44541 L .72961 .44955 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71063 .44748 m .69769 .44953 L .69196 .46552 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.69769 .44953 m .68547 .48151 L .679 .46752 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.679 .46752 m .69196 .46552 L .69769 .44953 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.30583 .77222 m .29429 .77315 L .28529 .77127 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27377 .77221 m .28529 .77127 L .29429 .77315 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27377 .77221 m .26234 .77314 L .25311 .77126 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24171 .7722 m .25311 .77126 L .26234 .77314 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24171 .7722 m .23039 .77313 L .22094 .77125 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20965 .77219 m .22094 .77125 L .23039 .77313 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20965 .77219 m .19844 .77312 L .18877 .77124 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17759 .77218 m .18877 .77124 L .19844 .77312 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81926 .42547 m .80594 .4276 L .80052 .4233 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.78757 .43544 m .80052 .4233 L .80594 .4276 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.17759 .77218 m .16649 .77311 L .15659 .77123 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14552 .77217 m .15659 .77123 L .16649 .77311 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.66688 .50984 m .679 .46752 L .68547 .48151 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.61026 .60531 m .59765 .62009 L .58964 .48145 L p
.456 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58964 .48145 m .60222 .47951 L .61026 .60531 L p
.456 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60222 .47951 m .58964 .48145 L .5825 .44739 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.1344 .77571 m .11844 .86872 L .10811 .86751 L p
1 0 .912 r
F P
0 0 0 r
s
P
p
.002 w
.10811 .86751 m .12268 .80285 L .1344 .77571 L p
1 0 .912 r
F P
0 0 0 r
s
P
p
.002 w
.14552 .77217 m .1344 .77571 L .12268 .80285 L p
.543 0 1 r
F P
0 0 0 r
s
P
p
.77057 .18645 m .78382 .18348 L .78936 .18944 L 1 .068 0 r
F
P
p
.75164 .18344 m .77057 .18645 L .75741 .18941 L 1 0 0 r
F
P
p
.7385 .18642 m .75164 .18344 L .75741 .18941 L 1 .034 0 r
F
P
p
.71946 .18341 m .7385 .18642 L .72545 .18938 L 1 .034 0 r
F
P
p
.70643 .18639 m .71946 .18341 L .72545 .18938 L 1 .094 0 r
F
P
p
.68727 .18338 m .70643 .18639 L .69349 .18935 L 1 .188 0 r
F
P
p
.67435 .18636 m .68727 .18338 L .69349 .18935 L 1 .298 0 r
F
P
p
.65508 .18335 m .67435 .18636 L .66153 .18932 L 1 .537 0 r
F
P
p
.64228 .18633 m .65508 .18335 L .66153 .18932 L 1 .776 0 r
F
P
p
.6229 .18332 m .64228 .18633 L .62956 .18929 L 1 .409 0 r
F
P
p
.6102 .1863 m .6229 .18332 L .62956 .18929 L 1 .614 0 r
F
P
p
.5907 .18329 m .6102 .1863 L .59759 .18926 L 1 .989 0 r
F
P
p
.57812 .18627 m .5907 .18329 L .59759 .18926 L .943 1 0 r
F
P
p
.55851 .18326 m .57812 .18627 L .56562 .18923 L .906 1 0 r
F
P
p
.54604 .18624 m .55851 .18326 L .56562 .18923 L .634 1 0 r
F
P
p
.52631 .18323 m .54604 .18624 L .53365 .1892 L .705 1 0 r
F
P
p
.51395 .18621 m .52631 .18323 L .53365 .1892 L .6 1 0 r
F
P
p
.49411 .1832 m .51395 .18621 L .50168 .18917 L .613 1 0 r
F
P
p
.48186 .18618 m .49411 .1832 L .50168 .18917 L .514 1 0 r
F
P
p
.46191 .18317 m .48186 .18618 L .4697 .18914 L .1 1 0 r
F
P
p
.44977 .18615 m .46191 .18317 L .4697 .18914 L .071 1 0 r
F
P
p
.42971 .18314 m .44977 .18615 L .43772 .18911 L 0 1 .818 r
F
P
p
.41768 .18612 m .42971 .18314 L .43772 .18911 L 0 1 .849 r
F
P
p
.3975 .18311 m .41768 .18612 L .40574 .18908 L 0 .7 1 r
F
P
p
.38559 .18609 m .3975 .18311 L .40574 .18908 L 0 .686 1 r
F
P
p
.3653 .18308 m .38559 .18609 L .37376 .18905 L 0 .612 1 r
F
P
p
.35349 .18606 m .3653 .18308 L .37376 .18905 L 0 .509 1 r
F
P
p
.33309 .18305 m .35349 .18606 L .34177 .18902 L 0 .509 1 r
F
P
p
.32139 .18603 m .33309 .18305 L .34177 .18902 L 0 .509 1 r
F
P
p
.30087 .18302 m .32139 .18603 L .30978 .18899 L 0 .509 1 r
F
P
p
.28929 .186 m .30087 .18302 L .30978 .18899 L 0 .45 1 r
F
P
p
.002 w
.78757 .43544 m .77435 .43753 L .76869 .4333 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.75579 .44543 m .76869 .4333 L .77435 .43753 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.57978 .68467 m .56726 .6859 L .56015 .68341 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.54765 .68465 m .56015 .68341 L .56726 .6859 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.42522 .82338 m .41241 .86695 L .40715 .68584 L p
.295 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.41912 .6846 m .40715 .68584 L .39892 .68335 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.38698 .68459 m .39892 .68335 L .40715 .68584 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.75579 .44543 m .74266 .4475 L .73677 .44333 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.72366 .44541 m .73677 .44333 L .74266 .4475 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.72366 .44541 m .71063 .44748 L .70452 .44331 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69196 .46552 m .70452 .44331 L .71063 .44748 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.5825 .44739 m .59508 .44533 L .60222 .47951 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.59508 .44533 m .5825 .44739 L .57664 .6433 L p
.409 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56373 .64472 m .57664 .6433 L .5825 .44739 L p
.375 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31745 .77128 m .30583 .77222 L .29688 .77033 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28529 .77127 m .29688 .77033 L .30583 .77222 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28529 .77127 m .27377 .77221 L .26459 .77032 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25311 .77126 m .26459 .77032 L .27377 .77221 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25311 .77126 m .24171 .7722 L .23231 .77031 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22094 .77125 m .23231 .77031 L .24171 .7722 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22094 .77125 m .20965 .77219 L .20002 .7703 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18877 .77124 m .20002 .7703 L .20965 .77219 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.80052 .4233 m .81391 .42114 L .81926 .42547 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.18877 .77124 m .17759 .77218 L .16773 .77029 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15659 .77123 m .16773 .77029 L .17759 .77218 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15659 .77123 m .14552 .77217 L .13432 .7914 L p
.432 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12268 .80285 m .13432 .7914 L .14552 .77217 L p
.543 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.64157 .53372 m .62997 .62011 L .62195 .51166 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62195 .51166 m .63469 .50982 L .64157 .53372 L p
.49 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62195 .51166 m .61026 .60531 L .60222 .47951 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60222 .47951 m .61465 .45743 L .62195 .51166 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61465 .45743 m .60222 .47951 L .59508 .44533 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.76487 .18045 m .78382 .18348 L .77057 .18645 L 1 0 0 r
F
P
p
.75164 .18344 m .76487 .18045 L .77057 .18645 L 1 0 0 r
F
P
p
.73258 .18041 m .75164 .18344 L .7385 .18642 L 1 0 0 r
F
P
p
.71946 .18341 m .73258 .18041 L .7385 .18642 L 1 .034 0 r
F
P
p
.70028 .18038 m .71946 .18341 L .70643 .18639 L 1 .128 0 r
F
P
p
.68727 .18338 m .70028 .18038 L .70643 .18639 L 1 .188 0 r
F
P
p
.66798 .18035 m .68727 .18338 L .67435 .18636 L 1 .341 0 r
F
P
p
.65508 .18335 m .66798 .18035 L .67435 .18636 L 1 .537 0 r
F
P
p
.002 w
.63469 .50982 m .6472 .48767 L .65403 .51168 L p
.909 1 0 r
F P
0 0 0 r
s
P
p
.63568 .18032 m .65508 .18335 L .64228 .18633 L 1 .264 0 r
F
P
p
.6229 .18332 m .63568 .18032 L .64228 .18633 L 1 .409 0 r
F
P
p
.002 w
.61026 .60531 m .62195 .51166 L .62997 .62011 L p
0 1 .203 r
F P
0 0 0 r
s
P
p
.002 w
.63469 .50982 m .62195 .51166 L .61465 .45743 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.61465 .45743 m .62723 .44535 L .63469 .50982 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.62723 .44535 m .61465 .45743 L .60775 .44325 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.59508 .44533 m .60775 .44325 L .61465 .45743 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.60338 .18029 m .6229 .18332 L .6102 .1863 L 1 .75 0 r
F
P
p
.5907 .18329 m .60338 .18029 L .6102 .1863 L 1 .989 0 r
F
P
p
.57107 .18026 m .5907 .18329 L .57812 .18627 L .943 1 0 r
F
P
p
.55851 .18326 m .57107 .18026 L .57812 .18627 L .906 1 0 r
F
P
p
.53876 .18023 m .55851 .18326 L .54604 .18624 L .875 1 0 r
F
P
p
.52631 .18323 m .53876 .18023 L .54604 .18624 L .705 1 0 r
F
P
p
.50645 .1802 m .52631 .18323 L .51395 .18621 L .736 1 0 r
F
P
p
.49411 .1832 m .50645 .1802 L .51395 .18621 L .613 1 0 r
F
P
p
.47414 .18017 m .49411 .1832 L .48186 .18618 L .164 1 0 r
F
P
p
.46191 .18317 m .47414 .18017 L .48186 .18618 L .1 1 0 r
F
P
p
.44182 .18014 m .46191 .18317 L .44977 .18615 L 0 1 .733 r
F
P
p
.42971 .18314 m .44182 .18014 L .44977 .18615 L 0 1 .818 r
F
P
p
.4095 .18011 m .42971 .18314 L .41768 .18612 L 0 .803 1 r
F
P
p
.3975 .18311 m .4095 .18011 L .41768 .18612 L 0 .7 1 r
F
P
p
.37718 .18007 m .3975 .18311 L .38559 .18609 L 0 .714 1 r
F
P
p
.3653 .18308 m .37718 .18007 L .38559 .18609 L 0 .612 1 r
F
P
p
.34486 .18004 m .3653 .18308 L .35349 .18606 L 0 .509 1 r
F
P
p
.33309 .18305 m .34486 .18004 L .35349 .18606 L 0 .509 1 r
F
P
p
.31253 .18001 m .33309 .18305 L .32139 .18603 L 0 .612 1 r
F
P
p
.30087 .18302 m .31253 .18001 L .32139 .18603 L 0 .509 1 r
F
P
p
.002 w
.80052 .4233 m .78757 .43544 L .78199 .43118 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.76869 .4333 m .78199 .43118 L .78757 .43544 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.10629 .89062 m .11844 .86872 L .1275 .89115 L closepath p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.679 .46752 m .66688 .50984 L .6599 .4756 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.69196 .46552 m .679 .46752 L .67285 .47362 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .4756 m .67285 .47362 L .679 .46752 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.59238 .68342 m .57978 .68467 L .57258 .65444 L p
0 1 .987 r
F P
0 0 0 r
s
P
p
.002 w
.56015 .68341 m .57258 .65444 L .57978 .68467 L p
0 .818 1 r
F P
0 0 0 r
s
P
p
.002 w
.43811 .76942 m .42522 .82338 L .41912 .6846 L p
0 .011 1 r
F P
0 0 0 r
s
P
p
.002 w
.41912 .6846 m .43117 .68336 L .43811 .76942 L p
0 .011 1 r
F P
0 0 0 r
s
P
p
.002 w
.43117 .68336 m .41912 .6846 L .41118 .66739 L p
0 .866 1 r
F P
0 0 0 r
s
P
p
.002 w
.39892 .68335 m .41118 .66739 L .41912 .6846 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.39892 .68335 m .38698 .68459 L .37735 .74032 L p
0 .538 1 r
F P
0 0 0 r
s
P
p
.002 w
.76869 .4333 m .75579 .44543 L .74986 .4372 L p
1 .191 0 r
F P
0 0 0 r
s
P
p
.002 w
.73677 .44333 m .74986 .4372 L .75579 .44543 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.73677 .44333 m .72366 .44541 L .71762 .44122 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.70452 .44331 m .71762 .44122 L .72366 .44541 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.6472 .48767 m .63469 .50982 L .62723 .44535 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.62723 .44535 m .64001 .44327 L .6472 .48767 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.64001 .44327 m .62723 .44535 L .62051 .44115 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.60775 .44325 m .62051 .44115 L .62723 .44535 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.60482 .65446 m .59238 .68342 L .58499 .62156 L p
0 1 .792 r
F P
0 0 0 r
s
P
p
.002 w
.60775 .44325 m .59508 .44533 L .58964 .64186 L p
.409 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57258 .65444 m .58499 .62156 L .59238 .68342 L p
0 1 .987 r
F P
0 0 0 r
s
P
p
.002 w
.57664 .6433 m .58964 .64186 L .59508 .44533 L p
.409 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.32916 .77034 m .31745 .77128 L .30933 .74346 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29688 .77033 m .30933 .74346 L .31745 .77128 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.29688 .77033 m .28529 .77127 L .27615 .76937 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26459 .77032 m .27615 .76937 L .28529 .77127 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26459 .77032 m .25311 .77126 L .24476 .74344 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23231 .77031 m .24476 .74344 L .25311 .77126 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.23231 .77031 m .22094 .77125 L .21136 .76935 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20002 .7703 m .21136 .76935 L .22094 .77125 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20002 .7703 m .18877 .77124 L .17895 .76934 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.16773 .77029 m .17895 .76934 L .18877 .77124 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.81391 .42114 m .80052 .4233 L .79539 .42903 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.78199 .43118 m .79539 .42903 L .80052 .4233 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.16773 .77029 m .15659 .77123 L .14655 .76933 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13432 .7914 m .14655 .76933 L .15659 .77123 L p
.432 0 1 r
F P
0 0 0 r
s
P
p
.76487 .18045 m .7782 .17743 L .78382 .18348 L 1 0 0 r
F
P
p
.74579 .17739 m .76487 .18045 L .75164 .18344 L 1 0 0 r
F
P
p
.73258 .18041 m .74579 .17739 L .75164 .18344 L 1 0 0 r
F
P
p
.71338 .17736 m .73258 .18041 L .71946 .18341 L 1 .068 0 r
F
P
p
.70028 .18038 m .71338 .17736 L .71946 .18341 L 1 .128 0 r
F
P
p
.68097 .17733 m .70028 .18038 L .68727 .18338 L 1 .205 0 r
F
P
p
.66798 .18035 m .68097 .17733 L .68727 .18338 L 1 .341 0 r
F
P
p
.002 w
.6472 .48767 m .6599 .4756 L .66688 .50984 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.64855 .1773 m .66798 .18035 L .65508 .18335 L 1 .196 0 r
F
P
p
.63568 .18032 m .64855 .1773 L .65508 .18335 L 1 .264 0 r
F
P
p
.61614 .17727 m .63568 .18032 L .6229 .18332 L 1 .375 0 r
F
P
p
.60338 .18029 m .61614 .17727 L .6229 .18332 L 1 .75 0 r
F
P
p
.58372 .17724 m .60338 .18029 L .5907 .18329 L .977 1 0 r
F
P
p
.57107 .18026 m .58372 .17724 L .5907 .18329 L .943 1 0 r
F
P
p
.5513 .17721 m .57107 .18026 L .55851 .18326 L .991 1 0 r
F
P
p
.53876 .18023 m .5513 .17721 L .55851 .18326 L .875 1 0 r
F
P
p
.51887 .17718 m .53876 .18023 L .52631 .18323 L .773 1 0 r
F
P
p
.50645 .1802 m .51887 .17718 L .52631 .18323 L .736 1 0 r
F
P
p
.48645 .17715 m .50645 .1802 L .49411 .1832 L .418 1 0 r
F
P
p
.47414 .18017 m .48645 .17715 L .49411 .1832 L .164 1 0 r
F
P
p
.45402 .17711 m .47414 .18017 L .46191 .18317 L 0 1 .65 r
F
P
p
.44182 .18014 m .45402 .17711 L .46191 .18317 L 0 1 .733 r
F
P
p
.42159 .17708 m .44182 .18014 L .42971 .18314 L 0 .906 1 r
F
P
p
.4095 .18011 m .42159 .17708 L .42971 .18314 L 0 .803 1 r
F
P
p
.38915 .17705 m .4095 .18011 L .3975 .18311 L 0 .714 1 r
F
P
p
.37718 .18007 m .38915 .17705 L .3975 .18311 L 0 .714 1 r
F
P
p
.35672 .17702 m .37718 .18007 L .3653 .18308 L 0 .612 1 r
F
P
p
.34486 .18004 m .35672 .17702 L .3653 .18308 L 0 .509 1 r
F
P
p
.32428 .17699 m .34486 .18004 L .33309 .18305 L 0 .714 1 r
F
P
p
.31253 .18001 m .32428 .17699 L .33309 .18305 L 0 .612 1 r
F
P
p
.002 w
.78199 .43118 m .76869 .4333 L .76296 .42901 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.74986 .4372 m .76296 .42901 L .76869 .4333 L p
1 .191 0 r
F P
0 0 0 r
s
P
p
.002 w
.11844 .86872 m .10629 .89062 L .09588 .88956 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.6599 .4756 m .6472 .48767 L .64001 .44327 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.09588 .88956 m .10811 .86751 L .11844 .86872 L p
1 0 .273 r
F P
0 0 0 r
s
P
p
.002 w
.70452 .44331 m .69196 .46552 L .68546 .45131 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.67285 .47362 m .68546 .45131 L .69196 .46552 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.46285 .74256 m .45032 .76847 L .44364 .65439 L p
0 .444 1 r
F P
0 0 0 r
s
P
p
.002 w
.45581 .65303 m .44364 .65439 L .43561 .65165 L p
0 1 .909 r
F P
0 0 0 r
s
P
p
.002 w
.44364 .65439 m .43117 .68336 L .42346 .65302 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.42346 .65302 m .43561 .65165 L .44364 .65439 L p
0 1 1 r
F P
0 0 0 r
s
P
p
.002 w
.41118 .66739 m .42346 .65302 L .43117 .68336 L p
0 .866 1 r
F P
0 0 0 r
s
P
p
.002 w
.41118 .66739 m .39892 .68335 L .39056 .68082 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.37735 .74032 m .39056 .68082 L .39892 .68335 L p
0 .538 1 r
F P
0 0 0 r
s
P
p
.002 w
.74986 .4372 m .73677 .44333 L .73081 .43911 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.71762 .44122 m .73081 .43911 L .73677 .44333 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71762 .44122 m .70452 .44331 L .69833 .43909 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.68546 .45131 m .69833 .43909 L .70452 .44331 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.64001 .44327 m .65288 .44117 L .6599 .4756 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.65288 .44117 m .64001 .44327 L .63336 .43904 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.63336 .43904 m .64001 .44327 L p
.62191 .4413 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.63336 .43904 m .64614 .42677 L .65288 .44117 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.63336 .43904 m .62835 .56983 L p
.6449 .43676 L .875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64614 .42677 m .63336 .43904 L p
.6449 .43676 L .875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62051 .44115 m .63336 .43904 L p
.62191 .4413 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.59765 .62009 m .61026 .60531 L .61755 .6531 L p
0 1 .657 r
F P
0 0 0 r
s
P
p
.002 w
.62051 .44115 m .60775 .44325 L .60274 .64042 L p
.591 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58964 .64186 m .60274 .64042 L .60775 .44325 L p
.409 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.34094 .76939 m .32916 .77034 L .32105 .74242 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30933 .74346 m .32105 .74242 L .32916 .77034 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30933 .74346 m .29688 .77033 L .28779 .76842 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27615 .76937 m .28779 .76842 L .29688 .77033 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.27615 .76937 m .26459 .77032 L .25625 .7424 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24476 .74344 m .25625 .7424 L .26459 .77032 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32105 .74242 m .30933 .74346 L .30033 .74136 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28779 .76842 m .30033 .74136 L .30933 .74346 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24476 .74344 m .23231 .77031 L .22277 .7684 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21136 .76935 m .22277 .7684 L .23231 .77031 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21136 .76935 m .20002 .7703 L .19025 .76839 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17895 .76934 m .19025 .76839 L .20002 .7703 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25625 .7424 m .24476 .74344 L .23531 .74134 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22277 .7684 m .23531 .74134 L .24476 .74344 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.79539 .42903 m .80849 .41676 L .81391 .42114 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.17895 .76934 m .16773 .77029 L .15774 .76838 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14655 .76933 m .15774 .76838 L .16773 .77029 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.67285 .47362 m .6599 .4756 L .65288 .44117 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.42346 .65302 m .41118 .66739 L .40264 .67955 L p
0 .866 1 r
F P
0 0 0 r
s
P
p
.002 w
.39056 .68082 m .40264 .67955 L .41118 .66739 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.13432 .7914 m .12268 .80285 L .10875 .86565 L p
.943 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.10811 .86751 m .09588 .88956 L .08886 .88884 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.08886 .88884 m .08532 .88848 L p
.09295 .88146 L 1 0 .205 r
F P
0 0 0 r
s
P
p
.09295 .88146 m .10811 .86751 L .08886 .88884 L 1 0 .205 r
F
P
p
.002 w
.08532 .88848 m .09639 .88794 L .10811 .86751 L p
1 0 .205 r
F P
0 0 0 r
s
P
p
.002 w
.12268 .80285 m .10811 .86751 L .09639 .88794 L p
1 0 .545 r
F P
0 0 0 r
s
P
p
.002 w
.09639 .88794 m .10875 .86565 L .11344 .8445 L p
1 0 .545 r
F P
0 0 0 r
s
P
p
.002 w
.11344 .8445 m .12268 .80285 L p
.10524 .85929 L 1 0 .545 r
F P
0 0 0 r
s
P
p
.09639 .88794 m .11344 .8445 L .10524 .85929 L 1 0 .545 r
F
P
p
.7591 .17435 m .7782 .17743 L .76487 .18045 L 1 0 0 r
F
P
p
.74579 .17739 m .7591 .17435 L .76487 .18045 L 1 0 0 r
F
P
p
.72657 .17432 m .74579 .17739 L .73258 .18041 L 1 .034 0 r
F
P
p
.71338 .17736 m .72657 .17432 L .73258 .18041 L 1 .068 0 r
F
P
p
.69405 .17429 m .71338 .17736 L .70028 .18038 L 1 .17 0 r
F
P
p
.68097 .17733 m .69405 .17429 L .70028 .18038 L 1 .205 0 r
F
P
p
.66152 .17426 m .68097 .17733 L .66798 .18035 L 1 .102 0 r
F
P
p
.64855 .1773 m .66152 .17426 L .66798 .18035 L 1 .196 0 r
F
P
p
.62899 .17423 m .64855 .1773 L .63568 .18032 L 1 .17 0 r
F
P
p
.61614 .17727 m .62899 .17423 L .63568 .18032 L 1 .375 0 r
F
P
p
.59645 .1742 m .61614 .17727 L .60338 .18029 L 1 .852 0 r
F
P
p
.58372 .17724 m .59645 .1742 L .60338 .18029 L .977 1 0 r
F
P
p
.56392 .17416 m .58372 .17724 L .57107 .18026 L 1 .941 0 r
F
P
p
.5513 .17721 m .56392 .17416 L .57107 .18026 L .991 1 0 r
F
P
p
.53138 .17413 m .5513 .17721 L .53876 .18023 L .825 1 0 r
F
P
p
.51887 .17718 m .53138 .17413 L .53876 .18023 L .773 1 0 r
F
P
p
.49884 .1741 m .51887 .17718 L .50645 .1802 L .705 1 0 r
F
P
p
.48645 .17715 m .49884 .1741 L .50645 .1802 L .418 1 0 r
F
P
p
.4663 .17407 m .48645 .17715 L .47414 .18017 L 0 1 .538 r
F
P
p
.45402 .17711 m .4663 .17407 L .47414 .18017 L 0 1 .65 r
F
P
p
.43375 .17404 m .45402 .17711 L .44182 .18014 L 0 .974 1 r
F
P
p
.42159 .17708 m .43375 .17404 L .44182 .18014 L 0 .906 1 r
F
P
p
.40121 .17401 m .42159 .17708 L .4095 .18011 L 0 .891 1 r
F
P
p
.38915 .17705 m .40121 .17401 L .4095 .18011 L 0 .714 1 r
F
P
p
.36866 .17398 m .38915 .17705 L .37718 .18007 L 0 .817 1 r
F
P
p
.35672 .17702 m .36866 .17398 L .37718 .18007 L 0 .612 1 r
F
P
p
.33611 .17395 m .35672 .17702 L .34486 .18004 L 0 .734 1 r
F
P
p
.32428 .17699 m .33611 .17395 L .34486 .18004 L 0 .714 1 r
F
P
p
.002 w
.62997 .62011 m .61755 .6531 L .61026 .60531 L p
0 1 .203 r
F P
0 0 0 r
s
P
p
.002 w
.79539 .42903 m .78199 .43118 L .77634 .42686 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.76296 .42901 m .77634 .42686 L .78199 .43118 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.46807 .65167 m .45581 .65303 L .44784 .65028 L p
0 1 .761 r
F P
0 0 0 r
s
P
p
.002 w
.43561 .65165 m .44784 .65028 L p
.44813 .65251 L 0 1 .909 r
F P
0 0 0 r
s
P
p
.002 w
.44784 .65028 m .43561 .65165 L .42705 .67698 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.42705 .67698 m .43939 .67568 L .44784 .65028 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.44784 .65028 m .43939 .67568 L p
.44754 .64803 L 0 1 .943 r
F P
0 0 0 r
s
P
p
.002 w
.46061 .6037 m .44784 .65028 L p
.44754 .64803 L 0 1 .943 r
F P
0 0 0 r
s
P
p
.002 w
.44784 .65028 m .45581 .65303 L p
.44813 .65251 L 0 1 .909 r
F P
0 0 0 r
s
P
p
.002 w
.43561 .65165 m .42346 .65302 L .4148 .67827 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.40264 .67955 m .4148 .67827 L .42346 .65302 L p
0 .866 1 r
F P
0 0 0 r
s
P
p
.002 w
.76296 .42901 m .74986 .4372 L .74409 .43698 L p
1 .191 0 r
F P
0 0 0 r
s
P
p
.002 w
.73081 .43911 m .74409 .43698 L .74986 .4372 L p
1 .259 0 r
F P
0 0 0 r
s
P
p
.002 w
.13432 .7914 m .12347 .80031 L p
.13506 .78476 L .534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.10875 .86565 m .12347 .80031 L .13432 .7914 L p
.943 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12347 .80031 m .13637 .7674 L .14655 .76933 L p
.534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13637 .7674 m .12347 .80031 L .11649 .83179 L p
.875 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.11649 .83179 m .1094 .86376 L p
.12299 .81519 L .875 0 1 r
F P
0 0 0 r
s
P
p
.12299 .81519 m .13637 .7674 L .11649 .83179 L .875 0 1 r
F
P
p
.002 w
.1094 .86376 m .12428 .79773 L .13036 .78248 L p
.875 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13036 .78248 m .13637 .7674 L p
.13193 .78324 L .875 0 1 r
F P
0 0 0 r
s
P
p
.1094 .86376 m .13036 .78248 L .13193 .78324 L .875 0 1 r
F
P
p
.002 w
.15774 .76838 m .14655 .76933 L .13637 .7674 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13637 .7674 m .1476 .76644 L .15774 .76838 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1476 .76644 m .13637 .7674 L .12428 .79773 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12428 .79773 m .13731 .76447 L .14247 .76545 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14247 .76545 m .1476 .76644 L p
.13598 .78202 L .466 0 1 r
F P
0 0 0 r
s
P
p
.12428 .79773 m .14247 .76545 L .13598 .78202 L .466 0 1 r
F
P
p
.002 w
.14655 .76933 m .13737 .78589 L p
.13506 .78476 L .534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13737 .78589 m .13432 .7914 L p
.13506 .78476 L .534 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.73081 .43911 m .71762 .44122 L .71149 .43696 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.69833 .43909 m .71149 .43696 L .71762 .44122 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.65288 .44117 m .66584 .43906 L .67285 .47362 L p
1 .477 0 r
F P
0 0 0 r
s
P
p
.002 w
.66584 .43906 m .65288 .44117 L .64614 .42677 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.63336 .43904 m .62051 .44115 L .61531 .5821 L p
.807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61531 .5821 m .61538 .58 L p
.6056 .60838 L .591 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61538 .58 m .62051 .44115 L p
.60604 .60348 L .591 1 0 r
F P
0 0 0 r
s
P
p
.6056 .60838 m .61538 .58 L .60604 .60348 L .591 1 0 r
F
P
p
.002 w
.62835 .56983 m .63336 .43904 L p
.61611 .57573 L .807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.61531 .5821 m .62835 .56983 L p
.61611 .57573 L .807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62835 .56983 m .64161 .56813 L .64614 .42677 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62835 .56983 m .62026 .47171 L p
.64068 .5639 L .602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64161 .56813 m .62835 .56983 L p
.64068 .5639 L .602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60727 .48065 m .62026 .47171 L .62682 .55126 L p
.511 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62682 .55126 m .62835 .56983 L p
.62503 .55577 L .511 1 0 r
F P
0 0 0 r
s
P
p
.60727 .48065 m .62682 .55126 L .62503 .55577 L .511 1 0 r
F
P
p
.002 w
.61531 .5821 m .60727 .48065 L p
.62503 .55577 L .511 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.62835 .56983 m .61531 .5821 L p
.62503 .55577 L .511 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60274 .64042 m .61531 .5821 L p
.6056 .60838 L .591 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.35332 .74729 m .34094 .76939 L .33284 .74137 L p
.128 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.32105 .74242 m .33284 .74137 L .34094 .76939 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28779 .76842 m .27615 .76937 L .26782 .74135 L p
.062 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.25625 .7424 m .26782 .74135 L .27615 .76937 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.33284 .74137 m .32105 .74242 L .3121 .7403 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.30033 .74136 m .3121 .7403 L .32105 .74242 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22277 .7684 m .21136 .76935 L .20279 .74133 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19025 .76839 m .20279 .74133 L .21136 .76935 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.26782 .74135 m .25625 .7424 L .24685 .74028 L p
0 .044 1 r
F P
0 0 0 r
s
P
p
.002 w
.23531 .74134 m .24685 .74028 L .25625 .7424 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19025 .76839 m .17895 .76934 L .169 .76741 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15774 .76838 m .169 .76741 L .17895 .76934 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.68546 .45131 m .67285 .47362 L .66584 .43906 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.33284 .74137 m .34473 .74031 L .35332 .74729 L p
.128 0 1 r
F P
0 0 0 r
s
P
p
.7591 .17435 m .7725 .17129 L .7782 .17743 L 1 0 0 r
F
P
p
.73986 .17126 m .7591 .17435 L .74579 .17739 L 1 0 0 r
F
P
p
.72657 .17432 m .73986 .17126 L .74579 .17739 L 1 .034 0 r
F
P
p
.70722 .17123 m .72657 .17432 L .71338 .17736 L 1 .136 0 r
F
P
p
.69405 .17429 m .70722 .17123 L .71338 .17736 L 1 .17 0 r
F
P
p
.002 w
.69833 .43909 m .68546 .45131 L .6789 .43694 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.66584 .43906 m .6789 .43694 L .68546 .45131 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.67458 .17119 m .69405 .17429 L .68097 .17733 L 1 .068 0 r
F
P
p
.66152 .17426 m .67458 .17119 L .68097 .17733 L 1 .102 0 r
F
P
p
.64193 .17116 m .66152 .17426 L .64855 .1773 L 1 .136 0 r
F
P
p
.62899 .17423 m .64193 .17116 L .64855 .1773 L 1 .17 0 r
F
P
p
.60928 .17113 m .62899 .17423 L .61614 .17727 L 1 .58 0 r
F
P
p
.59645 .1742 m .60928 .17113 L .61614 .17727 L 1 .852 0 r
F
P
p
.57663 .1711 m .59645 .1742 L .58372 .17724 L 1 .847 0 r
F
P
p
.56392 .17416 m .57663 .1711 L .58372 .17724 L 1 .941 0 r
F
P
p
.54398 .17107 m .56392 .17416 L .5513 .17721 L .907 1 0 r
F
P
p
.53138 .17413 m .54398 .17107 L .5513 .17721 L .825 1 0 r
F
P
p
.51133 .17104 m .53138 .17413 L .51887 .17718 L .786 1 0 r
F
P
p
.49884 .1741 m .51133 .17104 L .51887 .17718 L .705 1 0 r
F
P
p
.47867 .17101 m .49884 .1741 L .48645 .17715 L 0 1 .291 r
F
P
p
.4663 .17407 m .47867 .17101 L .48645 .17715 L 0 1 .538 r
F
P
p
.44601 .17097 m .4663 .17407 L .45402 .17711 L 0 1 .972 r
F
P
p
.43375 .17404 m .44601 .17097 L .45402 .17711 L 0 .974 1 r
F
P
p
.41335 .17094 m .43375 .17404 L .42159 .17708 L 0 1 .891 r
F
P
p
.40121 .17401 m .41335 .17094 L .42159 .17708 L 0 .891 1 r
F
P
p
.38068 .17091 m .40121 .17401 L .38915 .17705 L 0 1 .965 r
F
P
p
.36866 .17398 m .38068 .17091 L .38915 .17705 L 0 .817 1 r
F
P
p
.34802 .17088 m .36866 .17398 L .35672 .17702 L 0 .85 1 r
F
P
p
.33611 .17395 m .34802 .17088 L .35672 .17702 L 0 .734 1 r
F
P
p
.002 w
.80849 .41676 m .79539 .42903 L .78981 .42468 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.77634 .42686 m .78981 .42468 L .79539 .42903 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.30033 .74136 m .28779 .76842 L .28089 .69878 L p
0 .157 1 r
F P
0 0 0 r
s
P
p
.002 w
.28089 .69878 m .29257 .69757 L .30033 .74136 L p
0 .157 1 r
F P
0 0 0 r
s
P
p
.002 w
.26782 .74135 m .28089 .69878 L .28779 .76842 L p
.062 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.28089 .69878 m .26782 .74135 L .25929 .71684 L p
0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.29257 .69757 m .28089 .69878 L .27097 .71569 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.25929 .71684 m .27097 .71569 L .28089 .69878 L p
0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.77634 .42686 m .76296 .42901 L .75715 .42466 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.74409 .43698 m .75715 .42466 L .76296 .42901 L p
1 .191 0 r
F P
0 0 0 r
s
P
p
.002 w
.48789 .69764 m .47533 .72409 L .46807 .65167 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.46807 .65167 m .48058 .62805 L .48789 .69764 L p
0 .791 1 r
F P
0 0 0 r
s
P
p
.002 w
.48058 .62805 m .46807 .65167 L .46061 .6037 L p
0 1 .541 r
F P
0 0 0 r
s
P
p
.002 w
.44784 .65028 m .46061 .6037 L .46807 .65167 L p
0 1 .761 r
F P
0 0 0 r
s
P
p
.002 w
.4148 .67827 m .42705 .67698 L .43561 .65165 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.40264 .67955 m .39056 .68082 L .38209 .67825 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.39056 .68082 m .37735 .74032 L .36967 .69638 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.36967 .69638 m .38209 .67825 L .39056 .68082 L p
0 .484 1 r
F P
0 0 0 r
s
P
p
.002 w
.48058 .62805 m .49311 .60371 L .50041 .67959 L p
0 1 .925 r
F P
0 0 0 r
s
P
p
.002 w
.49311 .60371 m .48058 .62805 L .47294 .60216 L p
0 1 .359 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .60216 m .48058 .62805 L p
.46257 .60609 L 0 1 .541 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .60216 m .48543 .59018 L .49311 .60371 L p
0 1 .359 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .60216 m .46432 .67306 L p
.48339 .59819 L 0 1 .67 r
F P
0 0 0 r
s
P
p
.002 w
.48543 .59018 m .47294 .60216 L p
.48339 .59819 L 0 1 .67 r
F P
0 0 0 r
s
P
p
.002 w
.46061 .6037 m .47294 .60216 L p
.46257 .60609 L 0 1 .541 r
F P
0 0 0 r
s
P
p
.002 w
.74409 .43698 m .73081 .43911 L .72475 .43482 L p
1 .263 0 r
F P
0 0 0 r
s
P
p
.002 w
.71149 .43696 m .72475 .43482 L .73081 .43911 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.71149 .43696 m .69833 .43909 L .69204 .4348 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.6789 .43694 m .69204 .4348 L .69833 .43909 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.6789 .43694 m .66584 .43906 L .65915 .42459 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.64614 .42677 m .65915 .42459 L .66584 .43906 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.49311 .60371 m .50562 .58515 L .51292 .67831 L p
0 1 .74 r
F P
0 0 0 r
s
P
p
.002 w
.50562 .58515 m .49311 .60371 L .48543 .59018 L p
0 1 .172 r
F P
0 0 0 r
s
P
p
.002 w
.47294 .60216 m .46061 .6037 L .45181 .67437 L p
0 1 .795 r
F P
0 0 0 r
s
P
p
.002 w
.43939 .67568 m .45181 .67437 L .46061 .6037 L p
0 1 .943 r
F P
0 0 0 r
s
P
p
.002 w
.34473 .74031 m .35723 .71688 L .36535 .74138 L p
0 .028 1 r
F P
0 0 0 r
s
P
p
.002 w
.34473 .74031 m .33284 .74137 L .32395 .73924 L p
0 .106 1 r
F P
0 0 0 r
s
P
p
.002 w
.3121 .7403 m .32395 .73924 L .33284 .74137 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.3121 .7403 m .30033 .74136 L .29257 .69757 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.23531 .74134 m .22277 .7684 L .21422 .74027 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21422 .74027 m .22277 .7684 L p
.20879 .74945 L .196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21422 .74027 m .22665 .71683 L .23531 .74134 L p
.04 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21422 .74027 m .20328 .76449 L p
.21969 .73102 L .124 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.22665 .71683 m .21422 .74027 L p
.21969 .73102 L .124 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20279 .74133 m .21422 .74027 L p
.20879 .74945 L .196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24685 .74028 m .25929 .71684 L .26782 .74135 L p
0 .044 1 r
F P
0 0 0 r
s
P
p
.002 w
.20279 .74133 m .19025 .76839 L .18035 .76645 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.169 .76741 m .18035 .76645 L .19025 .76839 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24685 .74028 m .23531 .74134 L .22665 .71683 L p
0 .116 1 r
F P
0 0 0 r
s
P
p
.002 w
.78981 .42468 m .80299 .41231 L .80849 .41676 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.169 .76741 m .15774 .76838 L .1476 .76644 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21422 .74027 m .20279 .74133 L .19177 .76547 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18035 .76645 m .19177 .76547 L .20279 .74133 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.75324 .16817 m .7725 .17129 L .7591 .17435 L 1 0 0 r
F
P
p
.73986 .17126 m .75324 .16817 L .7591 .17435 L 1 0 0 r
F
P
p
.72048 .16814 m .73986 .17126 L .72657 .17432 L 1 .068 0 r
F
P
p
.70722 .17123 m .72048 .16814 L .72657 .17432 L 1 .136 0 r
F
P
p
.68772 .16811 m .70722 .17123 L .69405 .17429 L 1 .068 0 r
F
P
p
.67458 .17119 m .68772 .16811 L .69405 .17429 L 1 .068 0 r
F
P
p
.002 w
.52551 .67702 m .51292 .67831 L .50562 .58515 L p
0 1 .671 r
F P
0 0 0 r
s
P
p
.002 w
.50562 .58515 m .51813 .5798 L .52551 .67702 L p
0 1 .671 r
F P
0 0 0 r
s
P
p
.002 w
.51813 .5798 m .50562 .58515 L .50358 .58429 L p
0 1 .07 r
F P
0 0 0 r
s
P
p
.50651 .58101 m .51813 .5798 L .50358 .58429 L 0 1 .07 r
F
P
p
.002 w
.53072 .57817 m .51813 .5798 L .51053 .57651 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49795 .5819 m .51053 .57651 L .51813 .5798 L p
0 1 .07 r
F P
0 0 0 r
s
P
p
.002 w
.51053 .57651 m .52326 .52282 L .53072 .57817 L p
.125 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51053 .57651 m .50253 .64038 L p
.5146 .57195 L 0 1 .307 r
F P
0 0 0 r
s
P
p
.002 w
.52326 .52282 m .51053 .57651 L p
.5146 .57195 L 0 1 .307 r
F P
0 0 0 r
s
P
p
.002 w
.50358 .58429 m .49795 .5819 L p
.50651 .58101 L 0 1 .07 r
F P
0 0 0 r
s
P
p
.002 w
.48543 .59018 m .49795 .5819 L .50562 .58515 L p
0 1 .172 r
F P
0 0 0 r
s
P
p
.65496 .16808 m .67458 .17119 L .66152 .17426 L 1 .136 0 r
F
P
p
.64193 .17116 m .65496 .16808 L .66152 .17426 L 1 .136 0 r
F
P
p
.6222 .16805 m .64193 .17116 L .62899 .17423 L 1 .409 0 r
F
P
p
.60928 .17113 m .6222 .16805 L .62899 .17423 L 1 .58 0 r
F
P
p
.58944 .16801 m .60928 .17113 L .59645 .1742 L 1 .745 0 r
F
P
p
.57663 .1711 m .58944 .16801 L .59645 .1742 L 1 .847 0 r
F
P
p
.55667 .16798 m .57663 .1711 L .56392 .17416 L 1 .975 0 r
F
P
p
.54398 .17107 m .55667 .16798 L .56392 .17416 L .907 1 0 r
F
P
p
.5239 .16795 m .54398 .17107 L .53138 .17413 L .907 1 0 r
F
P
p
.51133 .17104 m .5239 .16795 L .53138 .17413 L .786 1 0 r
F
P
p
.49112 .16792 m .51133 .17104 L .49884 .1741 L 0 1 .028 r
F
P
p
.47867 .17101 m .49112 .16792 L .49884 .1741 L 0 1 .291 r
F
P
p
.45835 .16789 m .47867 .17101 L .4663 .17407 L 0 1 .911 r
F
P
p
.44601 .17097 m .45835 .16789 L .4663 .17407 L 0 1 .972 r
F
P
p
.42557 .16786 m .44601 .17097 L .43375 .17404 L 0 1 .818 r
F
P
p
.41335 .17094 m .42557 .16786 L .43375 .17404 L 0 1 .891 r
F
P
p
.39279 .16782 m .41335 .17094 L .40121 .17401 L 0 1 .761 r
F
P
p
.38068 .17091 m .39279 .16782 L .40121 .17401 L 0 1 .965 r
F
P
p
.36001 .16779 m .38068 .17091 L .36866 .17398 L 0 1 .952 r
F
P
p
.34802 .17088 m .36001 .16779 L .36866 .17398 L 0 .85 1 r
F
P
p
.002 w
.29257 .69757 m .30433 .69636 L .3121 .7403 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.30433 .69636 m .29257 .69757 L .28272 .71453 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.27097 .71569 m .28272 .71453 L .29257 .69757 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.78981 .42468 m .77634 .42686 L .7706 .42247 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.75715 .42466 m .7706 .42247 L .77634 .42686 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.65915 .42459 m .64614 .42677 L .64161 .56813 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.4148 .67827 m .40264 .67955 L .39422 .67697 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.38209 .67825 m .39422 .67697 L .40264 .67955 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.75715 .42466 m .74409 .43698 L .73803 .42975 L p
1 .195 0 r
F P
0 0 0 r
s
P
p
.002 w
.72475 .43482 m .73803 .42975 L .74409 .43698 L p
1 .263 0 r
F P
0 0 0 r
s
P
p
.002 w
.72475 .43482 m .71149 .43696 L .70504 .42243 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.69204 .4348 m .70504 .42243 L .71149 .43696 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.69204 .4348 m .6789 .43694 L .67226 .42241 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.65915 .42459 m .67226 .42241 L .6789 .43694 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.45181 .67437 m .46432 .67306 L .47294 .60216 L p
0 1 .795 r
F P
0 0 0 r
s
P
p
.002 w
.35723 .71688 m .36967 .69638 L .37735 .74032 L p
0 .178 1 r
F P
0 0 0 r
s
P
p
.002 w
.35723 .71688 m .34473 .74031 L .337 .69637 L p
0 .312 1 r
F P
0 0 0 r
s
P
p
.002 w
.32395 .73924 m .337 .69637 L .34473 .74031 L p
0 .106 1 r
F P
0 0 0 r
s
P
p
.002 w
.32395 .73924 m .3121 .7403 L .30433 .69636 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.25929 .71684 m .24685 .74028 L .2382 .71568 L p
0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.2382 .71568 m .24685 .74028 L p
.23099 .72187 L 0 .116 1 r
F P
0 0 0 r
s
P
p
.002 w
.2382 .71568 m .25058 .69511 L .25929 .71684 L p
0 .25 1 r
F P
0 0 0 r
s
P
p
.002 w
.2382 .71568 m .22654 .7625 L p
.24547 .70944 L 0 .01 1 r
F P
0 0 0 r
s
P
p
.002 w
.25058 .69511 m .2382 .71568 L p
.24547 .70944 L 0 .01 1 r
F P
0 0 0 r
s
P
p
.002 w
.22665 .71683 m .2382 .71568 L p
.23099 .72187 L 0 .116 1 r
F P
0 0 0 r
s
P
p
.002 w
.18035 .76645 m .169 .76741 L .15891 .76546 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1476 .76644 m .15891 .76546 L .169 .76741 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19177 .76547 m .20328 .76449 L .21422 .74027 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.54333 .52466 m .55601 .52283 L .56373 .64472 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.53072 .57817 m .54333 .52466 L .55091 .64613 L p
0 1 .398 r
F P
0 0 0 r
s
P
p
.002 w
.55601 .52283 m .54333 .52466 L .53591 .52097 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54333 .52466 m .53072 .57817 L .52326 .52282 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52326 .52282 m .53591 .52097 L .54333 .52466 L p
.466 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5382 .67572 m .52551 .67702 L .51813 .5798 L p
0 1 .659 r
F P
0 0 0 r
s
P
p
.002 w
.51813 .5798 m .53072 .57817 L .5382 .67572 L p
0 1 .659 r
F P
0 0 0 r
s
P
p
.002 w
.36967 .69638 m .35723 .71688 L .34896 .69514 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.337 .69637 m .34896 .69514 L .35723 .71688 L p
0 .312 1 r
F P
0 0 0 r
s
P
p
.002 w
.27097 .71569 m .25929 .71684 L .25058 .69511 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.2382 .71568 m .22665 .71683 L .21487 .7635 L p
.052 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20328 .76449 m .21487 .7635 L .22665 .71683 L p
.124 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12347 .80031 m .10875 .86565 L .09753 .87533 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.002 w
.09753 .87533 m .1094 .86376 L .12347 .80031 L p
1 0 .58 r
F P
0 0 0 r
s
P
p
.75324 .16817 m .76671 .16507 L .7725 .17129 L 1 0 0 r
F
P
p
.73384 .16503 m .75324 .16817 L .73986 .17126 L 1 0 0 r
F
P
p
.72048 .16814 m .73384 .16503 L .73986 .17126 L 1 .068 0 r
F
P
p
.70097 .165 m .72048 .16814 L .70722 .17123 L 1 .068 0 r
F
P
p
.68772 .16811 m .70097 .165 L .70722 .17123 L 1 .068 0 r
F
P
p
.66809 .16497 m .68772 .16811 L .67458 .17119 L 1 .136 0 r
F
P
p
.65496 .16808 m .66809 .16497 L .67458 .17119 L 1 .136 0 r
F
P
p
.63521 .16494 m .65496 .16808 L .64193 .17116 L 1 .307 0 r
F
P
p
.6222 .16805 m .63521 .16494 L .64193 .17116 L 1 .409 0 r
F
P
p
.60233 .16491 m .6222 .16805 L .60928 .17113 L 1 .648 0 r
F
P
p
.58944 .16801 m .60233 .16491 L .60928 .17113 L 1 .745 0 r
F
P
p
.56945 .16487 m .58944 .16801 L .57663 .1711 L 1 .779 0 r
F
P
p
.55667 .16798 m .56945 .16487 L .57663 .1711 L 1 .975 0 r
F
P
p
.53656 .16484 m .55667 .16798 L .54398 .17107 L 1 .902 0 r
F
P
p
.5239 .16795 m .53656 .16484 L .54398 .17107 L .907 1 0 r
F
P
p
.50367 .16481 m .5239 .16795 L .51133 .17104 L .085 1 0 r
F
P
p
.49112 .16792 m .50367 .16481 L .51133 .17104 L 0 1 .028 r
F
P
p
.47078 .16478 m .49112 .16792 L .47867 .17101 L 0 1 .849 r
F
P
p
.45835 .16789 m .47078 .16478 L .47867 .17101 L 0 1 .911 r
F
P
p
.43789 .16475 m .45835 .16789 L .44601 .17097 L 0 1 .787 r
F
P
p
.42557 .16786 m .43789 .16475 L .44601 .17097 L 0 1 .818 r
F
P
p
.40499 .16471 m .42557 .16786 L .41335 .17094 L 0 1 .639 r
F
P
p
.39279 .16782 m .40499 .16471 L .41335 .17094 L 0 1 .761 r
F
P
p
.37209 .16468 m .39279 .16782 L .38068 .17091 L 0 1 .727 r
F
P
p
.36001 .16779 m .37209 .16468 L .38068 .17091 L 0 1 .952 r
F
P
p
.002 w
.38209 .67825 m .36967 .69638 L .361 .69391 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.34896 .69514 m .361 .69391 L .36967 .69638 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.34896 .69514 m .337 .69637 L .32857 .67694 L p
0 .652 1 r
F P
0 0 0 r
s
P
p
.002 w
.337 .69637 m .32395 .73924 L .31617 .69513 L p
0 .429 1 r
F P
0 0 0 r
s
P
p
.002 w
.31617 .69513 m .32857 .67694 L .337 .69637 L p
0 .429 1 r
F P
0 0 0 r
s
P
p
.002 w
.30433 .69636 m .31617 .69513 L .32395 .73924 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.31617 .69513 m .30433 .69636 L .29519 .69389 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.28272 .71453 m .29519 .69389 L .30433 .69636 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.80299 .41231 m .78981 .42468 L .78414 .42027 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.7706 .42247 m .78414 .42027 L .78981 .42468 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.7706 .42247 m .75715 .42466 L .75125 .42025 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.73803 .42975 m .75125 .42025 L .75715 .42466 L p
1 .195 0 r
F P
0 0 0 r
s
P
p
.002 w
.67226 .42241 m .65915 .42459 L .65409 .5135 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.64161 .56813 m .65409 .5135 L .65915 .42459 L p
1 .92 0 r
F P
0 0 0 r
s
P
p
.002 w
.49795 .5819 m .48543 .59018 L .47715 .64325 L p
0 1 .524 r
F P
0 0 0 r
s
P
p
.002 w
.47715 .64325 m .48543 .59018 L p
.46994 .651 L 0 1 .67 r
F P
0 0 0 r
s
P
p
.002 w
.47715 .64325 m .48979 .64182 L .49795 .5819 L p
0 1 .524 r
F P
0 0 0 r
s
P
p
.002 w
.47715 .64325 m .46932 .61758 L p
.48441 .63544 L 0 1 .655 r
F P
0 0 0 r
s
P
p
.002 w
.48979 .64182 m .47715 .64325 L p
.48441 .63544 L 0 1 .655 r
F P
0 0 0 r
s
P
p
.002 w
.46432 .67306 m .47715 .64325 L p
.46994 .651 L 0 1 .67 r
F P
0 0 0 r
s
P
p
.002 w
.42705 .67698 m .4148 .67827 L .40644 .67567 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.39422 .67697 m .40644 .67567 L .4148 .67827 L p
0 .727 1 r
F P
0 0 0 r
s
P
p
.002 w
.39422 .67697 m .38209 .67825 L .3735 .67565 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.361 .69391 m .3735 .67565 L .38209 .67825 L p
0 .618 1 r
F P
0 0 0 r
s
P
p
.002 w
.73803 .42975 m .72475 .43482 L .71835 .42023 L p
1 .195 0 r
F P
0 0 0 r
s
P
p
.002 w
.70504 .42243 m .71835 .42023 L .72475 .43482 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.70504 .42243 m .69204 .4348 L .68545 .4202 L p
1 .162 0 r
F P
0 0 0 r
s
P
p
.002 w
.68545 .4202 m .69204 .4348 L p
.6732 .423 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.68545 .4202 m .69869 .41542 L .70504 .42243 L p
1 .162 0 r
F P
0 0 0 r
s
P
p
.002 w
.68545 .4202 m .67983 .45717 L p
.6978 .41739 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.69869 .41542 m .68545 .4202 L p
.6978 .41739 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.67226 .42241 m .68545 .4202 L p
.6732 .423 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.19177 .76547 m .18035 .76645 L .1703 .76448 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.15891 .76546 m .1703 .76448 L .18035 .76645 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.78414 .42027 m .79779 .41805 L .80299 .41231 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.15891 .76546 m .1476 .76644 L .13731 .76447 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.57664 .6433 m .56373 .64472 L .55601 .52283 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.55601 .52283 m .56877 .52099 L .57664 .6433 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.56877 .52099 m .55601 .52283 L .54865 .51912 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53591 .52097 m .54865 .51912 L .55601 .52283 L p
.636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55091 .64613 m .5382 .67572 L .53072 .57817 L p
0 1 .398 r
F P
0 0 0 r
s
P
p
.002 w
.53591 .52097 m .52326 .52282 L .51536 .63892 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.50253 .64038 m .51536 .63892 L .52326 .52282 L p
0 1 .307 r
F P
0 0 0 r
s
P
p
.002 w
.28272 .71453 m .27097 .71569 L .26228 .69388 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.25058 .69511 m .26228 .69388 L .27097 .71569 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.002 w
.21487 .7635 m .22654 .7625 L .2382 .71568 L p
.052 0 1 r
F P
0 0 0 r
s
P
p
.7473 .1619 m .76671 .16507 L .75324 .16817 L 1 0 0 r
F
P
p
.73384 .16503 m .7473 .1619 L .75324 .16817 L 1 0 0 r
F
P
p
.7143 .16187 m .73384 .16503 L .72048 .16814 L 1 .034 0 r
F
P
p
.70097 .165 m .7143 .16187 L .72048 .16814 L 1 .068 0 r
F
P
p
.68131 .16184 m .70097 .165 L .68772 .16811 L 1 .068 0 r
F
P
p
.66809 .16497 m .68131 .16184 L .68772 .16811 L 1 .136 0 r
F
P
p
.002 w
.51053 .57651 m .49795 .5819 L .48979 .64182 L p
0 1 .49 r
F P
0 0 0 r
s
P
p
.64831 .16181 m .66809 .16497 L .65496 .16808 L 1 .273 0 r
F
P
p
.63521 .16494 m .64831 .16181 L .65496 .16808 L 1 .307 0 r
F
P
p
.61532 .16178 m .63521 .16494 L .6222 .16805 L 1 .58 0 r
F
P
p
.60233 .16491 m .61532 .16178 L .6222 .16805 L 1 .648 0 r
F
P
p
.58232 .16174 m .60233 .16491 L .58944 .16801 L 1 .609 0 r
F
P
p
.56945 .16487 m .58232 .16174 L .58944 .16801 L 1 .779 0 r
F
P
p
.54931 .16171 m .56945 .16487 L .55667 .16798 L 1 .75 0 r
F
P
p
.53656 .16484 m .54931 .16171 L .55667 .16798 L 1 .902 0 r
F
P
p
.51631 .16168 m .53656 .16484 L .5239 .16795 L .153 1 0 r
F
P
p
.50367 .16481 m .51631 .16168 L .5239 .16795 L .085 1 0 r
F
P
p
.4833 .16165 m .50367 .16481 L .49112 .16792 L 0 1 .764 r
F
P
p
.47078 .16478 m .4833 .16165 L .49112 .16792 L 0 1 .849 r
F
P
p
.45029 .16161 m .47078 .16478 L .45835 .16789 L 0 1 .787 r
F
P
p
.43789 .16475 m .45029 .16161 L .45835 .16789 L 0 1 .787 r
F
P
p
.41727 .16158 m .43789 .16475 L .42557 .16786 L 0 1 .549 r
F
P
p
.40499 .16471 m .41727 .16158 L .42557 .16786 L 0 1 .639 r
F
P
p
.38426 .16155 m .40499 .16471 L .39279 .16782 L 0 1 .536 r
F
P
p
.37209 .16468 m .38426 .16155 L .39279 .16782 L 0 1 .727 r
F
P
p
.002 w
.361 .69391 m .34896 .69514 L .34083 .66504 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.32857 .67694 m .34083 .66504 L .34896 .69514 L p
0 .652 1 r
F P
0 0 0 r
s
P
p
.002 w
.32857 .67694 m .31617 .69513 L .30708 .69265 L p
0 .564 1 r
F P
0 0 0 r
s
P
p
.002 w
.29519 .69389 m .30708 .69265 L .31617 .69513 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.78414 .42027 m .7706 .42247 L .76444 .40778 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.75125 .42025 m .76444 .40778 L .7706 .42247 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.26228 .69388 m .25058 .69511 L .2383 .76149 L p
0 .073 1 r
F P
0 0 0 r
s
P
p
.002 w
.22654 .7625 m .2383 .76149 L .25058 .69511 L p
0 .01 1 r
F P
0 0 0 r
s
P
p
.002 w
.10875 .86565 m .09639 .88794 L .08572 .88684 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.71835 .42023 m .70504 .42243 L .69869 .41542 L p
1 .119 0 r
F P
0 0 0 r
s
P
p
.002 w
.68545 .4202 m .67226 .42241 L .66649 .45927 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.66649 .45927 m .67226 .42241 L p
.66303 .46869 L 1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.66649 .45927 m .6596 .44199 L p
.66997 .44977 L 1 .537 0 r
F P
0 0 0 r
s
P
p
.002 w
.66649 .45927 m .67983 .45717 L .68545 .4202 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.67983 .45717 m .66649 .45927 L p
.66997 .44977 L 1 .537 0 r
F P
0 0 0 r
s
P
p
.002 w
.65409 .5135 m .66649 .45927 L p
.66303 .46869 L 1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.08572 .88684 m .09753 .87533 L .10875 .86565 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.75125 .42025 m .73803 .42975 L .73176 .41801 L p
1 .127 0 r
F P
0 0 0 r
s
P
p
.002 w
.71835 .42023 m .73176 .41801 L .73803 .42975 L p
1 .195 0 r
F P
0 0 0 r
s
P
p
.002 w
.43939 .67568 m .42705 .67698 L .41892 .66373 L p
0 .843 1 r
F P
0 0 0 r
s
P
p
.002 w
.40644 .67567 m .41892 .66373 L .42705 .67698 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.40644 .67567 m .39422 .67697 L .3859 .66371 L p
0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.3735 .67565 m .3859 .66371 L .39422 .67697 L p
0 .761 1 r
F P
0 0 0 r
s
P
p
.002 w
.34083 .66504 m .32857 .67694 L .31906 .6914 L p
0 .652 1 r
F P
0 0 0 r
s
P
p
.002 w
.30708 .69265 m .31906 .6914 L .32857 .67694 L p
0 .564 1 r
F P
0 0 0 r
s
P
p
.002 w
.20328 .76449 m .19177 .76547 L .18177 .76349 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1703 .76448 m .18177 .76349 L .19177 .76547 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1703 .76448 m .15891 .76546 L .14867 .76348 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13731 .76447 m .14867 .76348 L .15891 .76546 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.58964 .64186 m .57664 .6433 L .56877 .52099 L p
0 1 .068 r
F P
0 0 0 r
s
P
p
.002 w
.56877 .52099 m .5815 .49839 L .58964 .64186 L p
0 1 .068 r
F P
0 0 0 r
s
P
p
.002 w
.5815 .49839 m .56877 .52099 L .56643 .51979 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.56897 .51019 m .5815 .49839 L .56643 .51979 L .79 1 0 r
F
P
p
.002 w
.56148 .51724 m .56877 .52099 L p
.55695 .51989 L .636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54865 .51912 m .56148 .51724 L p
.55695 .51989 L .636 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59441 .49645 m .5815 .49839 L .57426 .48928 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.56148 .51724 m .57426 .48928 L .5815 .49839 L p
.79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57426 .48928 m .58704 .46132 L .59441 .49645 L p
1 .972 0 r
F P
0 0 0 r
s
P
p
.002 w
.58704 .46132 m .57426 .48928 L .5693 .51269 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5693 .51269 m .56713 .5229 L p
.5707 .51188 L .821 1 0 r
F P
0 0 0 r
s
P
p
.5707 .51188 m .58704 .46132 L .5693 .51269 L .821 1 0 r
F
P
p
.002 w
.56713 .5229 m .56719 .52263 L p
.56133 .54613 L .48 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56719 .52263 m .57328 .49393 L p
.56155 .54518 L .48 1 0 r
F P
0 0 0 r
s
P
p
.56133 .54613 m .56719 .52263 L .56155 .54518 L .48 1 0 r
F
P
p
.002 w
.55946 .45497 m .57252 .45284 L .57633 .48609 L p
.906 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60274 .64042 m .58964 .64186 L .5815 .49839 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5815 .49839 m .59441 .49645 L .60274 .64042 L p
0 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56713 .5229 m .58023 .5202 L .58704 .46132 L p
.821 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57633 .48609 m .58023 .5202 L p
.57327 .49833 L .906 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57328 .49393 m .57426 .48928 L p
.57275 .49593 L .48 1 0 r
F P
0 0 0 r
s
P
p
.55426 .57703 m .57328 .49393 L .57275 .49593 L .48 1 0 r
F
P
p
.002 w
.56643 .51979 m .56148 .51724 L p
.56897 .51019 L .79 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57426 .48928 m .56148 .51724 L .55426 .57703 L p
.48 1 0 r
F P
0 0 0 r
s
P
p
.55946 .45497 m .57633 .48609 L .57327 .49833 L .906 1 0 r
F
P
p
.002 w
.56713 .5229 m .55946 .45497 L p
.57327 .49833 L .906 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58023 .5202 m .56713 .5229 L p
.57327 .49833 L .906 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55426 .57703 m .56713 .5229 L p
.56133 .54613 L .48 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54865 .51912 m .53591 .52097 L .52829 .63746 L p
0 1 .064 r
F P
0 0 0 r
s
P
p
.002 w
.51536 .63892 m .52829 .63746 L .53591 .52097 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.48979 .64182 m .50253 .64038 L .51053 .57651 L p
0 1 .49 r
F P
0 0 0 r
s
P
p
.002 w
.29519 .69389 m .28272 .71453 L .27405 .69263 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.26228 .69388 m .27405 .69263 L .28272 .71453 L p
0 .384 1 r
F P
0 0 0 r
s
P
p
.7473 .1619 m .76085 .15875 L .76671 .16507 L 1 0 0 r
F
P
p
.72774 .15872 m .7473 .1619 L .73384 .16503 L 1 0 0 r
F
P
p
.7143 .16187 m .72774 .15872 L .73384 .16503 L 1 .034 0 r
F
P
p
.69463 .15869 m .7143 .16187 L .70097 .165 L 1 0 0 r
F
P
p
.68131 .16184 m .69463 .15869 L .70097 .165 L 1 .068 0 r
F
P
p
.66151 .15865 m .68131 .16184 L .66809 .16497 L 1 .239 0 r
F
P
p
.64831 .16181 m .66151 .15865 L .66809 .16497 L 1 .273 0 r
F
P
p
.6284 .15862 m .64831 .16181 L .63521 .16494 L 1 .443 0 r
F
P
p
.61532 .16178 m .6284 .15862 L .63521 .16494 L 1 .58 0 r
F
P
p
.59528 .15859 m .61532 .16178 L .60233 .16491 L 1 .525 0 r
F
P
p
.58232 .16174 m .59528 .15859 L .60233 .16491 L 1 .609 0 r
F
P
p
.56216 .15856 m .58232 .16174 L .56945 .16487 L 1 .564 0 r
F
P
p
.54931 .16171 m .56216 .15856 L .56945 .16487 L 1 .75 0 r
F
P
p
.52903 .15853 m .54931 .16171 L .53656 .16484 L .327 1 0 r
F
P
p
.51631 .16168 m .52903 .15853 L .53656 .16484 L .153 1 0 r
F
P
p
.49591 .15849 m .51631 .16168 L .50367 .16481 L 0 1 .617 r
F
P
p
.4833 .16165 m .49591 .15849 L .50367 .16481 L 0 1 .764 r
F
P
p
.46278 .15846 m .4833 .16165 L .47078 .16478 L 0 1 .675 r
F
P
p
.45029 .16161 m .46278 .15846 L .47078 .16478 L 0 1 .787 r
F
P
p
.42965 .15843 m .45029 .16161 L .43789 .16475 L 0 1 .45 r
F
P
p
.41727 .16158 m .42965 .15843 L .43789 .16475 L 0 1 .549 r
F
P
p
.39651 .1584 m .41727 .16158 L .40499 .16471 L 0 1 .223 r
F
P
p
.38426 .16155 m .39651 .1584 L .40499 .16471 L 0 1 .536 r
F
P
p
.002 w
.34083 .66504 m .35288 .6637 L .361 .69391 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.35288 .6637 m .34083 .66504 L .33113 .69014 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.31906 .6914 m .33113 .69014 L .34083 .66504 L p
0 .652 1 r
F P
0 0 0 r
s
P
p
.002 w
.3735 .67565 m .361 .69391 L .35288 .6637 L p
0 .87 1 r
F P
0 0 0 r
s
P
p
.002 w
.30708 .69265 m .29519 .69389 L .28591 .69138 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.27405 .69263 m .28591 .69138 L .29519 .69389 L p
0 .447 1 r
F P
0 0 0 r
s
P
p
.002 w
.79779 .41805 m .78414 .42027 L .77805 .40551 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .40778 m .77805 .40551 L .78414 .42027 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.27405 .69263 m .26228 .69388 L .25015 .76048 L p
0 .157 1 r
F P
0 0 0 r
s
P
p
.002 w
.2383 .76149 m .25015 .76048 L .26228 .69388 L p
0 .073 1 r
F P
0 0 0 r
s
P
p
.002 w
.76444 .40778 m .75125 .42025 L .74496 .40548 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.73176 .41801 m .74496 .40548 L .75125 .42025 L p
1 .127 0 r
F P
0 0 0 r
s
P
p
.002 w
.73176 .41801 m .71835 .42023 L .71207 .41317 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.71207 .41317 m .71835 .42023 L p
.70526 .41702 L 1 .119 0 r
F P
0 0 0 r
s
P
p
.002 w
.71207 .41317 m .72534 .40317 L .73176 .41801 L p
1 .094 0 r
F P
0 0 0 r
s
P
p
.002 w
.71207 .41317 m .70607 .42159 L p
.71894 .40929 L 1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.72534 .40317 m .71207 .41317 L p
.71894 .40929 L 1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.69869 .41542 m .71207 .41317 L p
.70526 .41702 L 1 .119 0 r
F P
0 0 0 r
s
P
p
.002 w
.45181 .67437 m .43939 .67568 L .4315 .64749 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.41892 .66373 m .4315 .64749 L .43939 .67568 L p
0 .843 1 r
F P
0 0 0 r
s
P
p
.002 w
.41892 .66373 m .40644 .67567 L .39816 .66236 L p
0 .877 1 r
F P
0 0 0 r
s
P
p
.002 w
.3859 .66371 m .39816 .66236 L .40644 .67567 L p
0 .795 1 r
F P
0 0 0 r
s
P
p
.002 w
.3859 .66371 m .3735 .67565 L .36595 .62208 L p
0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.35288 .6637 m .36595 .62208 L .3735 .67565 L p
0 .87 1 r
F P
0 0 0 r
s
P
p
.002 w
.37811 .62058 m .3859 .66371 L p
.36819 .62677 L 0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.39816 .66236 m .3859 .66371 L .37811 .62058 L p
0 1 .846 r
F P
0 0 0 r
s
P
p
.002 w
.37811 .62058 m .39056 .60938 L .39816 .66236 L p
0 1 .846 r
F P
0 0 0 r
s
P
p
.002 w
.37811 .62058 m .36858 .65378 L p
.3881 .61435 L 0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.39056 .60938 m .37811 .62058 L p
.3881 .61435 L 0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.36595 .62208 m .37811 .62058 L p
.36819 .62677 L 0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.37811 .62058 m .36595 .62208 L .3562 .6596 L p
0 1 .863 r
F P
0 0 0 r
s
P
p
.002 w
.36595 .62208 m .35288 .6637 L .344 .66097 L p
0 .993 1 r
F P
0 0 0 r
s
P
p
.002 w
.344 .66097 m .3562 .6596 L .36595 .62208 L p
0 .993 1 r
F P
0 0 0 r
s
P
p
.002 w
.21487 .7635 m .20328 .76449 L .19333 .76249 L p
.321 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18177 .76349 m .19333 .76249 L .20328 .76449 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18177 .76349 m .1703 .76448 L .1601 .76248 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14867 .76348 m .1601 .76248 L .1703 .76448 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14867 .76348 m .13731 .76447 L .12688 .76247 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13731 .76447 m .12428 .79773 L .11556 .76346 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.11556 .76346 m .12688 .76247 L .13731 .76447 L p
.466 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77805 .40551 m .76444 .40778 L .75854 .4032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74496 .40548 m .75854 .4032 L .76444 .40778 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.56148 .51724 m .54865 .51912 L .54128 .61297 L p
.118 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52829 .63746 m .54128 .61297 L .54865 .51912 L p
0 1 .064 r
F P
0 0 0 r
s
P
p
.002 w
.12428 .79773 m .1094 .86376 L .10371 .77522 L p
.807 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.10371 .77522 m .11556 .76346 L .12428 .79773 L p
.807 0 1 r
F P
0 0 0 r
s
P
p
.74127 .15554 m .76085 .15875 L .7473 .1619 L 1 0 0 r
F
P
p
.72774 .15872 m .74127 .15554 L .7473 .1619 L 1 0 0 r
F
P
p
.70804 .15551 m .72774 .15872 L .7143 .16187 L 1 0 0 r
F
P
p
.69463 .15869 m .70804 .15551 L .7143 .16187 L 1 0 0 r
F
P
p
.6748 .15548 m .69463 .15869 L .68131 .16184 L 1 .136 0 r
F
P
p
.66151 .15865 m .6748 .15548 L .68131 .16184 L 1 .239 0 r
F
P
p
.64157 .15545 m .66151 .15865 L .64831 .16181 L 1 .341 0 r
F
P
p
.6284 .15862 m .64157 .15545 L .64831 .16181 L 1 .443 0 r
F
P
p
.60833 .15541 m .6284 .15862 L .61532 .16178 L 1 .491 0 r
F
P
p
.59528 .15859 m .60833 .15541 L .61532 .16178 L 1 .525 0 r
F
P
p
.002 w
.61531 .5821 m .60274 .64042 L .59441 .49645 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59441 .49645 m .60727 .48065 L .61531 .5821 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60727 .48065 m .59441 .49645 L .58704 .46132 L p
1 .841 0 r
F P
0 0 0 r
s
P
p
.57509 .15538 m .59528 .15859 L .58232 .16174 L 1 .427 0 r
F
P
p
.56216 .15856 m .57509 .15538 L .58232 .16174 L 1 .564 0 r
F
P
p
.54185 .15535 m .56216 .15856 L .54931 .16171 L .575 1 0 r
F
P
p
.52903 .15853 m .54185 .15535 L .54931 .16171 L .327 1 0 r
F
P
p
.5086 .15532 m .52903 .15853 L .51631 .16168 L 0 1 .556 r
F
P
p
.49591 .15849 m .5086 .15532 L .51631 .16168 L 0 1 .617 r
F
P
p
.47536 .15528 m .49591 .15849 L .4833 .16165 L 0 1 .441 r
F
P
p
.46278 .15846 m .47536 .15528 L .4833 .16165 L 0 1 .675 r
F
P
p
.44211 .15525 m .46278 .15846 L .45029 .16161 L 0 1 .372 r
F
P
p
.42965 .15843 m .44211 .15525 L .45029 .16161 L 0 1 .45 r
F
P
p
.002 w
.4315 .64749 m .41892 .66373 L .41076 .64606 L p
0 1 .984 r
F P
0 0 0 r
s
P
p
.002 w
.39816 .66236 m .41076 .64606 L .41892 .66373 L p
0 .877 1 r
F P
0 0 0 r
s
P
p
.40885 .15522 m .42965 .15843 L .41727 .16158 L .115 1 0 r
F
P
p
.39651 .1584 m .40885 .15522 L .41727 .16158 L 0 1 .223 r
F
P
p
.002 w
.69259 .42382 m .69869 .41542 L p
.69065 .43321 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.67983 .45717 m .69259 .42382 L p
.69065 .43321 L 1 .298 0 r
F P
0 0 0 r
s
P
p
.002 w
.69259 .42382 m .68588 .4089 L p
.69455 .41434 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.71207 .41317 m .69869 .41542 L .69259 .42382 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.69259 .42382 m .70607 .42159 L .71207 .41317 L p
1 .188 0 r
F P
0 0 0 r
s
P
p
.002 w
.70607 .42159 m .69259 .42382 L p
.69455 .41434 L 1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.33113 .69014 m .344 .66097 L .35288 .6637 L p
0 .775 1 r
F P
0 0 0 r
s
P
p
.002 w
.31906 .6914 m .30708 .69265 L .29786 .69013 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.28591 .69138 m .29786 .69013 L .30708 .69265 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.77805 .40551 m .79175 .40322 L .79779 .41805 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.28591 .69138 m .27405 .69263 L .26305 .73264 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.26305 .73264 m .27405 .69263 L p
.25705 .74089 L 0 .157 1 r
F P
0 0 0 r
s
P
p
.002 w
.26305 .73264 m .27503 .73152 L .28591 .69138 L p
0 .241 1 r
F P
0 0 0 r
s
P
p
.002 w
.26305 .73264 m .25429 .70634 L p
.2691 .72432 L 0 .122 1 r
F P
0 0 0 r
s
P
p
.002 w
.27503 .73152 m .26305 .73264 L p
.2691 .72432 L 0 .122 1 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .76048 m .26305 .73264 L p
.25705 .74089 L 0 .157 1 r
F P
0 0 0 r
s
P
p
.002 w
.08742 .86311 m .10371 .77522 L .1094 .86376 L p
1 0 .648 r
F P
0 0 0 r
s
P
p
.002 w
.09753 .87533 m .08572 .88684 L .0749 .88573 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.74496 .40548 m .73176 .41801 L .72534 .40317 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.46432 .67306 m .45181 .67437 L .44398 .64324 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.4315 .64749 m .44398 .64324 L .45181 .67437 L p
0 .9 1 r
F P
0 0 0 r
s
P
p
.002 w
.62026 .47171 m .60727 .48065 L .60006 .45923 L p
1 .739 0 r
F P
0 0 0 r
s
P
p
.002 w
.60006 .45923 m .60727 .48065 L p
.58969 .46384 L 1 .841 0 r
F P
0 0 0 r
s
P
p
.002 w
.60006 .45923 m .61306 .44672 L .62026 .47171 L p
1 .739 0 r
F P
0 0 0 r
s
P
p
.002 w
.60006 .45923 m .59335 .50767 L p
.61051 .45459 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.61306 .44672 m .60006 .45923 L p
.61051 .45459 L 1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.58704 .46132 m .60006 .45923 L p
.58969 .46384 L 1 .841 0 r
F P
0 0 0 r
s
P
p
.002 w
.44398 .64324 m .4315 .64749 L .42321 .64179 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.41076 .64606 m .42321 .64179 L .4315 .64749 L p
0 1 .984 r
F P
0 0 0 r
s
P
p
.002 w
.3562 .6596 m .36858 .65378 L .37811 .62058 L p
0 1 .863 r
F P
0 0 0 r
s
P
p
.002 w
.22654 .7625 m .21487 .7635 L .20556 .74793 L p
.253 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19333 .76249 m .20556 .74793 L .21487 .7635 L p
.321 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19333 .76249 m .18177 .76349 L .17162 .76147 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1601 .76248 m .17162 .76147 L .18177 .76349 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.1601 .76248 m .14867 .76348 L .13828 .76146 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.12688 .76247 m .13828 .76146 L .14867 .76348 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.79175 .40322 m .77805 .40551 L .77222 .4009 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75854 .4032 m .77222 .4009 L .77805 .40551 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.1094 .86376 m .09753 .87533 L .08742 .86311 L p
1 0 .648 r
F P
0 0 0 r
s
P
p
.002 w
.0749 .88573 m .08742 .86311 L .09753 .87533 L p
1 0 .239 r
F P
0 0 0 r
s
P
p
.002 w
.75854 .4032 m .74496 .40548 L .7389 .40087 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72534 .40317 m .7389 .40087 L .74496 .40548 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.60006 .45923 m .58704 .46132 L .58023 .5202 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54128 .61297 m .55426 .57703 L .56148 .51724 L p
.118 1 0 r
F P
0 0 0 r
s
P
p
.74127 .15554 m .7549 .15235 L .76085 .15875 L 1 0 0 r
F
P
p
.72155 .15231 m .74127 .15554 L .72774 .15872 L 1 0 0 r
F
P
p
.70804 .15551 m .72155 .15231 L .72774 .15872 L 1 0 0 r
F
P
p
.68819 .15228 m .70804 .15551 L .69463 .15869 L 1 .054 0 r
F
P
p
.6748 .15548 m .68819 .15228 L .69463 .15869 L 1 .136 0 r
F
P
p
.65484 .15225 m .6748 .15548 L .66151 .15865 L 1 .245 0 r
F
P
p
.64157 .15545 m .65484 .15225 L .66151 .15865 L 1 .341 0 r
F
P
p
.62148 .15222 m .64157 .15545 L .6284 .15862 L 1 .392 0 r
F
P
p
.60833 .15541 m .62148 .15222 L .6284 .15862 L 1 .491 0 r
F
P
p
.58812 .15218 m .60833 .15541 L .59528 .15859 L 1 .384 0 r
F
P
p
.57509 .15538 m .58812 .15218 L .59528 .15859 L 1 .427 0 r
F
P
p
.55476 .15215 m .57509 .15538 L .56216 .15856 L 1 .939 0 r
F
P
p
.54185 .15535 m .55476 .15215 L .56216 .15856 L .575 1 0 r
F
P
p
.52139 .15212 m .54185 .15535 L .52903 .15853 L 0 1 .478 r
F
P
p
.5086 .15532 m .52139 .15212 L .52903 .15853 L 0 1 .556 r
F
P
p
.48803 .15208 m .5086 .15532 L .49591 .15849 L 0 1 .155 r
F
P
p
.47536 .15528 m .48803 .15208 L .49591 .15849 L 0 1 .441 r
F
P
p
.45466 .15205 m .47536 .15528 L .46278 .15846 L 0 1 .041 r
F
P
p
.44211 .15525 m .45466 .15205 L .46278 .15846 L 0 1 .372 r
F
P
p
.42129 .15202 m .44211 .15525 L .42965 .15843 L .252 1 0 r
F
P
p
.40885 .15522 m .42129 .15202 L .42965 .15843 L .115 1 0 r
F
P
p
.002 w
.41076 .64606 m .39816 .66236 L .39056 .60938 L p
0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.33113 .69014 m .31906 .6914 L .30989 .68886 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.29786 .69013 m .30989 .68886 L .31906 .6914 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.29786 .69013 m .28591 .69138 L .27503 .73152 L p
0 .312 1 r
F P
0 0 0 r
s
P
p
.002 w
.40288 .60783 m .41076 .64606 L p
.39254 .61299 L 0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.42321 .64179 m .41076 .64606 L .40288 .60783 L p
0 1 .682 r
F P
0 0 0 r
s
P
p
.002 w
.41544 .59742 m .42321 .64179 L p
.40445 .61046 L 0 1 .682 r
F P
0 0 0 r
s
P
p
.002 w
.40288 .60783 m .41544 .59742 L p
.40445 .61046 L 0 1 .682 r
F P
0 0 0 r
s
P
p
.002 w
.43602 .61757 m .42321 .64179 L .41824 .61339 L p
0 1 .522 r
F P
0 0 0 r
s
P
p
.002 w
.41824 .61339 m .41544 .59742 L p
.4213 .60316 L 0 1 .522 r
F P
0 0 0 r
s
P
p
.4213 .60316 m .43602 .61757 L .41824 .61339 L 0 1 .522 r
F
P
p
.002 w
.44857 .61603 m .43602 .61757 L .42815 .58033 L p
0 1 .264 r
F P
0 0 0 r
s
P
p
.002 w
.42815 .58033 m .43602 .61757 L p
.4213 .60316 L 0 1 .522 r
F P
0 0 0 r
s
P
p
.002 w
.41544 .59742 m .42815 .58033 L p
.4213 .60316 L 0 1 .522 r
F P
0 0 0 r
s
P
p
.002 w
.42815 .58033 m .44125 .53629 L .44857 .61603 L p
0 1 .264 r
F P
0 0 0 r
s
P
p
.002 w
.42815 .58033 m .41918 .61134 L p
.43503 .55743 L 0 1 .264 r
F P
0 0 0 r
s
P
p
.43503 .55743 m .43836 .54613 L .42815 .58033 L 0 1 .264 r
F
P
p
.002 w
.44125 .53629 m .43292 .56429 L p
.43836 .54613 L 0 1 .264 r
F P
0 0 0 r
s
P
p
.002 w
.43292 .56429 m .42815 .58033 L p
.43836 .54613 L 0 1 .264 r
F P
0 0 0 r
s
P
p
.002 w
.41544 .59742 m .40626 .63232 L p
.42648 .58432 L 0 1 .511 r
F P
0 0 0 r
s
P
p
.002 w
.42815 .58033 m .41544 .59742 L p
.42648 .58432 L 0 1 .511 r
F P
0 0 0 r
s
P
p
.002 w
.40288 .60783 m .39341 .65096 L p
.41329 .60263 L 0 1 .704 r
F P
0 0 0 r
s
P
p
.002 w
.41544 .59742 m .40288 .60783 L p
.41329 .60263 L 0 1 .704 r
F P
0 0 0 r
s
P
p
.002 w
.39056 .60938 m .40288 .60783 L p
.39254 .61299 L 0 1 .767 r
F P
0 0 0 r
s
P
p
.002 w
.40288 .60783 m .39056 .60938 L .38095 .65238 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.002 w
.36858 .65378 m .38095 .65238 L .39056 .60938 L p
0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.62026 .47171 m .63327 .45925 L .64161 .56813 L p
.602 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63327 .45925 m .62026 .47171 L .61306 .44672 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.47715 .64325 m .46432 .67306 L .45651 .64181 L p
0 1 .927 r
F P
0 0 0 r
s
P
p
.002 w
.45651 .64181 m .46932 .61758 L .47715 .64325 L p
0 1 .927 r
F P
0 0 0 r
s
P
p
.002 w
.44398 .64324 m .45651 .64181 L .46432 .67306 L p
0 .909 1 r
F P
0 0 0 r
s
P
p
.002 w
.45651 .64181 m .44398 .64324 L .43602 .61757 L p
0 1 .764 r
F P
0 0 0 r
s
P
p
.002 w
.42321 .64179 m .43602 .61757 L .44398 .64324 L p
0 1 .845 r
F P
0 0 0 r
s
P
p
.002 w
.2383 .76149 m .22654 .7625 L .21761 .73874 L p
.212 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20556 .74793 m .21761 .73874 L .22654 .7625 L p
.253 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20556 .74793 m .19333 .76249 L .18322 .76046 L p
.237 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17162 .76147 m .18322 .76046 L .19333 .76249 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17162 .76147 m .1601 .76248 L .14976 .76045 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.13828 .76146 m .14976 .76045 L .1601 .76248 L p
.364 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.77222 .4009 m .786 .39858 L .79175 .40322 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.77222 .4009 m .75854 .4032 L .75256 .39855 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7389 .40087 m .75256 .39855 L .75854 .4032 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.7389 .40087 m .72534 .40317 L .71938 .40892 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.71938 .40892 m .72534 .40317 L p
.71574 .41235 L 1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.71938 .40892 m .71305 .40428 L p
.72306 .40545 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.71938 .40892 m .73304 .40662 L .7389 .40087 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.73304 .40662 m .71938 .40892 L p
.72306 .40545 L 1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.70607 .42159 m .71938 .40892 L p
.71574 .41235 L 1 .128 0 r
F P
0 0 0 r
s
P
p
.002 w
.66649 .45927 m .65409 .5135 L .64634 .44675 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.64634 .44675 m .6596 .44199 L .66649 .45927 L p
1 .776 0 r
F P
0 0 0 r
s
P
p
.002 w
.65409 .5135 m .64161 .56813 L .63327 .45925 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.63327 .45925 m .64634 .44675 L .65409 .5135 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.64634 .44675 m .63327 .45925 L .62611 .43416 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.61306 .44672 m .62611 .43416 L p
.61981 .45091 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.62611 .43416 m .63327 .45925 L p
.61981 .45091 L 1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.62611 .43416 m .61306 .44672 L .60663 .50572 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.62611 .43416 m .61937 .45072 L p
.63245 .41732 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.63891 .4008 m .62611 .43416 L p
.63245 .41732 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.59335 .50767 m .60006 .45923 L p
.58206 .5146 L .943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59335 .50767 m .60663 .50572 L .61306 .44672 L p
1 .989 0 r
F P
0 0 0 r
s
P
p
.002 w
.59335 .50767 m .58567 .4507 L p
.60472 .5007 L .977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60663 .50572 m .59335 .50767 L p
.60472 .5007 L .977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58023 .5202 m .59335 .50767 L p
.58206 .5146 L .943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52829 .63746 m .51536 .63892 L .50797 .51532 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.50797 .51532 m .52075 .51343 L .52829 .63746 L p
0 1 .136 r
F P
0 0 0 r
s
P
p
.002 w
.49494 .58037 m .50797 .51532 L .51536 .63892 L p
0 1 .341 r
F P
0 0 0 r
s
P
p
.002 w
.50797 .51532 m .49494 .58037 L .48727 .53448 L p
.295 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52075 .51343 m .50797 .51532 L .50006 .53264 L p
.531 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48727 .53448 m .50006 .53264 L .50797 .51532 L p
.295 1 0 r
F P
0 0 0 r
s
P
p
.73515 .14909 m .7549 .15235 L .74127 .15554 L 1 0 0 r
F
P
p
.72155 .15231 m .73515 .14909 L .74127 .15554 L 1 0 0 r
F
P
p
.70168 .14906 m .72155 .15231 L .70804 .15551 L 1 .019 0 r
F
P
p
.68819 .15228 m .70168 .14906 L .70804 .15551 L 1 .054 0 r
F
P
p
.6682 .14903 m .68819 .15228 L .6748 .15548 L 1 .109 0 r
F
P
p
.65484 .15225 m .6682 .14903 L .6748 .15548 L 1 .245 0 r
F
P
p
.63473 .14899 m .65484 .15225 L .64157 .15545 L 1 .29 0 r
F
P
p
.62148 .15222 m .63473 .14899 L .64157 .15545 L 1 .392 0 r
F
P
p
.60125 .14896 m .62148 .15222 L .60833 .15541 L 1 .316 0 r
F
P
p
.58812 .15218 m .60125 .14896 L .60833 .15541 L 1 .384 0 r
F
P
p
.56776 .14893 m .58812 .15218 L .57509 .15538 L 1 .564 0 r
F
P
p
.55476 .15215 m .56776 .14893 L .57509 .15538 L 1 .939 0 r
F
P
p
.53428 .14889 m .55476 .15215 L .54185 .15535 L 0 1 .301 r
F
P
p
.52139 .15212 m .53428 .14889 L .54185 .15535 L 0 1 .478 r
F
P
p
.50079 .14886 m .52139 .15212 L .5086 .15532 L .043 1 0 r
F
P
p
.48803 .15208 m .50079 .14886 L .5086 .15532 L 0 1 .155 r
F
P
p
.4673 .14883 m .48803 .15208 L .47536 .15528 L .344 1 0 r
F
P
p
.45466 .15205 m .4673 .14883 L .47536 .15528 L 0 1 .041 r
F
P
p
.43381 .14879 m .45466 .15205 L .44211 .15525 L .33 1 0 r
F
P
p
.42129 .15202 m .43381 .14879 L .44211 .15525 L .252 1 0 r
F
P
p
.002 w
.3562 .6596 m .344 .66097 L .33422 .6863 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.344 .66097 m .33113 .69014 L .32202 .68758 L p
0 .598 1 r
F P
0 0 0 r
s
P
p
.002 w
.32202 .68758 m .33422 .6863 L .344 .66097 L p
0 .598 1 r
F P
0 0 0 r
s
P
p
.002 w
.30989 .68886 m .32202 .68758 L .33113 .69014 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.28785 .70739 m .29786 .69013 L p
.28319 .71673 L 0 .312 1 r
F P
0 0 0 r
s
P
p
.002 w
.27503 .73152 m .28785 .70739 L p
.28319 .71673 L 0 .312 1 r
F P
0 0 0 r
s
P
p
.002 w
.28785 .70739 m .27902 .68497 L p
.29255 .69798 L 0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.30989 .68886 m .29786 .69013 L .28785 .70739 L p
0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.28785 .70739 m .3 .70513 L .30989 .68886 L p
0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.3 .70513 m .28785 .70739 L p
.29255 .69798 L 0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.38095 .65238 m .39341 .65096 L .40288 .60783 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.002 w
.21761 .73874 m .20556 .74793 L .19613 .73261 L p
.085 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18322 .76046 m .19613 .73261 L .20556 .74793 L p
.237 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.50253 .64038 m .48979 .64182 L .48224 .58203 L p
0 1 .545 r
F P
0 0 0 r
s
P
p
.002 w
.48224 .58203 m .49494 .58037 L .50253 .64038 L p
0 1 .545 r
F P
0 0 0 r
s
P
p
.002 w
.46932 .61758 m .48224 .58203 L .48979 .64182 L p
0 1 .655 r
F P
0 0 0 r
s
P
p
.002 w
.49494 .58037 m .48224 .58203 L .47423 .57868 L p
0 1 .045 r
F P
0 0 0 r
s
P
p
.002 w
.48224 .58203 m .46932 .61758 L .46155 .58035 L p
0 1 .291 r
F P
0 0 0 r
s
P
p
.002 w
.46155 .58035 m .47423 .57868 L .48224 .58203 L p
0 1 .291 r
F P
0 0 0 r
s
P
p
.002 w
.46932 .61758 m .45651 .64181 L .44857 .61603 L p
0 1 .582 r
F P
0 0 0 r
s
P
p
.002 w
.43602 .61757 m .44857 .61603 L .45651 .64181 L p
0 1 .764 r
F P
0 0 0 r
s
P
p
.002 w
.6596 .44199 m .64634 .44675 L .63891 .4008 L p
1 .264 0 r
F P
0 0 0 r
s
P
p
.002 w
.62611 .43416 m .63891 .4008 L .64634 .44675 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.44857 .61603 m .46155 .58035 L .46932 .61758 L p
0 1 .582 r
F P
0 0 0 r
s
P
p
.002 w
.69259 .42382 m .67983 .45717 L .67264 .42157 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.67264 .42157 m .68588 .4089 L .69259 .42382 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.46155 .58035 m .44857 .61603 L .44125 .53629 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44125 .53629 m .45406 .51339 L .46155 .58035 L p
.05 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45406 .51339 m .44125 .53629 L .43185 .60976 L p
0 1 .028 r
F P
0 0 0 r
s
P
p
.002 w
.41918 .61134 m .43185 .60976 L .44125 .53629 L p
0 1 .264 r
F P
0 0 0 r
s
P
p
.002 w
.25015 .76048 m .2383 .76149 L .22959 .73263 L p
.124 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.21761 .73874 m .22959 .73263 L .2383 .76149 L p
.212 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.18322 .76046 m .17162 .76147 L .16266 .7326 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.14976 .76045 m .16266 .7326 L .17162 .76147 L p
.28 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.786 .39858 m .77222 .4009 L .76632 .39622 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75256 .39855 m .76632 .39622 L .77222 .4009 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75256 .39855 m .7389 .40087 L .73304 .40662 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.6596 .44199 m .67264 .42157 L .67983 .45717 L p
1 .537 0 r
F P
0 0 0 r
s
P
p
.002 w
.63891 .4008 m .65221 .39848 L .6596 .44199 L p
1 .264 0 r
F P
0 0 0 r
s
P
p
.002 w
.65221 .39848 m .63891 .4008 L .63246 .42749 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.61937 .45072 m .62611 .43416 L p
.61838 .46255 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.60663 .50572 m .61937 .45072 L p
.61838 .46255 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.61937 .45072 m .61227 .44636 L p
.62038 .43878 L 1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.63246 .42749 m .63891 .4008 L p
.62593 .43396 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.61937 .45072 m .63246 .42749 L p
.62593 .43396 L 1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.64573 .41472 m .65221 .39848 L p
.64237 .41293 L 1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.63246 .42749 m .64573 .41472 L p
.64237 .41293 L 1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.64573 .41472 m .63246 .42749 L p
.63904 .42097 L 1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.62558 .43354 m .63895 .42067 L .64573 .41472 L p
1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.64573 .41472 m .63895 .42067 L p
.64912 .41654 L 1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.67264 .42157 m .6596 .44199 L .65221 .39848 L p
1 .196 0 r
F P
0 0 0 r
s
P
p
.002 w
.65924 .41242 m .64573 .41472 L p
.64912 .41654 L 1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.63246 .42749 m .62558 .43354 L p
.63904 .42097 L 1 .409 0 r
F P
0 0 0 r
s
P
p
.002 w
.63246 .42749 m .61937 .45072 L p
.62038 .43878 L 1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.54128 .61297 m .52829 .63746 L .52075 .51343 L p
0 1 .064 r
F P
0 0 0 r
s
P
p
.002 w
.52075 .51343 m .53362 .51151 L .54128 .61297 L p
0 1 .064 r
F P
0 0 0 r
s
P
p
.002 w
.53362 .51151 m .52075 .51343 L .51297 .52098 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50006 .53264 m .51297 .52098 L .52075 .51343 L p
.531 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.39341 .65096 m .40626 .63232 L .41544 .59742 L p
0 1 .704 r
F P
0 0 0 r
s
P
p
.002 w
.47423 .57868 m .46155 .58035 L .45406 .51339 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45406 .51339 m .46669 .51147 L .47423 .57868 L p
.227 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46669 .51147 m .45406 .51339 L .44474 .59825 L p
.071 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.43185 .60976 m .44474 .59825 L .45406 .51339 L p
0 1 .028 r
F P
0 0 0 r
s
P
p
.002 w
.22959 .73263 m .21761 .73874 L .20786 .73149 L p
.044 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.19613 .73261 m .20786 .73149 L .21761 .73874 L p
.085 0 1 r
F P
0 0 0 r
s
P
p
.73515 .14909 m .74886 .14585 L .7549 .15235 L 1 0 0 r
F
P
p
.71526 .14581 m .73515 .14909 L .72155 .15231 L 1 0 0 r
F
P
p
.70168 .14906 m .71526 .14581 L .72155 .15231 L 1 .019 0 r
F
P
p
.68167 .14578 m .70168 .14906 L .68819 .15228 L 1 .054 0 r
F
P
p
.6682 .14903 m .68167 .14578 L .68819 .15228 L 1 .109 0 r
F
P
p
.64807 .14575 m .6682 .14903 L .65484 .15225 L 1 .211 0 r
F
P
p
.63473 .14899 m .64807 .14575 L .65484 .15225 L 1 .29 0 r
F
P
p
.61447 .14571 m .63473 .14899 L .62148 .15222 L 1 .256 0 r
F
P
p
.60125 .14896 m .61447 .14571 L .62148 .15222 L 1 .316 0 r
F
P
p
.58086 .14568 m .60125 .14896 L .58812 .15218 L 1 .541 0 r
F
P
p
.56776 .14893 m .58086 .14568 L .58812 .15218 L 1 .564 0 r
F
P
p
.54725 .14565 m .56776 .14893 L .55476 .15215 L .106 1 0 r
F
P
p
.53428 .14889 m .54725 .14565 L .55476 .15215 L 0 1 .301 r
F
P
p
.51365 .14561 m .53428 .14889 L .52139 .15212 L .139 1 0 r
F
P
p
.50079 .14886 m .51365 .14561 L .52139 .15212 L .043 1 0 r
F
P
p
.48003 .14558 m .50079 .14886 L .48803 .15208 L .568 1 0 r
F
P
p
.4673 .14883 m .48003 .14558 L .48803 .15208 L .344 1 0 r
F
P
p
.44642 .14555 m .4673 .14883 L .45466 .15205 L .548 1 0 r
F
P
p
.43381 .14879 m .44642 .14555 L .45466 .15205 L .33 1 0 r
F
P
p
.002 w
.36858 .65378 m .3562 .6596 L .34652 .685 L p
0 .7 1 r
F P
0 0 0 r
s
P
p
.002 w
.33422 .6863 m .34652 .685 L .3562 .6596 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.32202 .68758 m .30989 .68886 L .3 .70513 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.51536 .63892 m .50253 .64038 L .49494 .58037 L p
0 1 .341 r
F P
0 0 0 r
s
P
p
.002 w
.47423 .57868 m .48727 .53448 L .49494 .58037 L p
0 1 .045 r
F P
0 0 0 r
s
P
p
.002 w
.40626 .63232 m .41918 .61134 L .42815 .58033 L p
0 1 .511 r
F P
0 0 0 r
s
P
p
.002 w
.71938 .40892 m .70607 .42159 L .69942 .4066 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.68588 .4089 m .69942 .4066 L .70607 .42159 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.68588 .4089 m .67264 .42157 L .6656 .39615 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.65221 .39848 m .6656 .39615 L .67264 .42157 L p
1 .196 0 r
F P
0 0 0 r
s
P
p
.002 w
.50006 .53264 m .48727 .53448 L .47941 .50955 L p
.514 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48727 .53448 m .47423 .57868 L .46669 .51147 L p
.364 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47941 .50955 m .48727 .53448 L p
.46753 .51241 L .364 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49225 .50337 m .50006 .53264 L p
.48171 .51212 L .514 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47941 .50955 m .49225 .50337 L p
.48171 .51212 L .514 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51297 .52098 m .50006 .53264 L .49225 .50337 L p
.613 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49225 .50337 m .50522 .48442 L .51297 .52098 L p
.613 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49225 .50337 m .48368 .57707 L p
.50287 .49456 L .418 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50522 .48442 m .49225 .50337 L p
.50287 .49456 L .418 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47941 .50955 m .47061 .5859 L p
.49139 .50667 L .164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49225 .50337 m .47941 .50955 L p
.49139 .50667 L .164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46669 .51147 m .47941 .50955 L p
.46753 .51241 L .364 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26305 .73264 m .25015 .76048 L .24234 .70858 L p
0 .035 1 r
F P
0 0 0 r
s
P
p
.002 w
.22959 .73263 m .24234 .70858 L .25015 .76048 L p
.124 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24234 .70858 m .25429 .70634 L .26305 .73264 L p
0 .035 1 r
F P
0 0 0 r
s
P
p
.002 w
.19613 .73261 m .18322 .76046 L .17427 .73148 L p
.112 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.16266 .7326 m .17427 .73148 L .18322 .76046 L p
.196 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.24234 .70858 m .22959 .73263 L .21968 .73036 L p
0 .116 1 r
F P
0 0 0 r
s
P
p
.002 w
.20786 .73149 m .21968 .73036 L .22959 .73263 L p
.044 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.20786 .73149 m .19613 .73261 L .18597 .73035 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.17427 .73148 m .18597 .73035 L .19613 .73261 L p
.112 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.76632 .39622 m .78017 .39387 L .786 .39858 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76632 .39622 m .75256 .39855 L .74648 .39384 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73304 .40662 m .74648 .39384 L .75256 .39855 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.6656 .39615 m .65221 .39848 L .64573 .41472 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.54655 .4885 m .55946 .45497 L .56713 .5229 L p
.634 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56713 .5229 m .55426 .57703 L .54655 .4885 L p
.634 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57252 .45284 m .55946 .45497 L .5521 .50371 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54655 .4885 m .55426 .57703 L p
.53549 .51744 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53362 .51151 m .54655 .4885 L p
.53549 .51744 L .186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54655 .4885 m .53362 .51151 L .52594 .50763 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52594 .50763 m .53897 .50568 L .54655 .4885 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54655 .4885 m .53897 .50568 L p
.55762 .45954 L .875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55946 .45497 m .54655 .4885 L p
.55762 .45954 L .875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53897 .50568 m .5521 .50371 L .55946 .45497 L p
.875 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55426 .57703 m .54128 .61297 L .53362 .51151 L p
.186 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51297 .52098 m .52594 .50763 L .53362 .51151 L p
.6 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47941 .50955 m .46669 .51147 L .45759 .59661 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44474 .59825 m .45759 .59661 L .46669 .51147 L p
.071 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25429 .70634 m .24234 .70858 L .23252 .70614 L p
0 .266 1 r
F P
0 0 0 r
s
P
p
.002 w
.21968 .73036 m .23252 .70614 L .24234 .70858 L p
0 .116 1 r
F P
0 0 0 r
s
P
p
.002 w
.38095 .65238 m .36858 .65378 L .35891 .68369 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.34652 .685 m .35891 .68369 L .36858 .65378 L p
0 .7 1 r
F P
0 0 0 r
s
P
p
.72895 .14255 m .74886 .14585 L .73515 .14909 L 1 0 0 r
F
P
p
.71526 .14581 m .72895 .14255 L .73515 .14909 L 1 0 0 r
F
P
p
.69523 .14251 m .71526 .14581 L .70168 .14906 L 1 .019 0 r
F
P
p
.68167 .14578 m .69523 .14251 L .70168 .14906 L 1 .054 0 r
F
P
p
.66151 .14248 m .68167 .14578 L .6682 .14903 L 1 .075 0 r
F
P
p
.64807 .14575 m .66151 .14248 L .6682 .14903 L 1 .211 0 r
F
P
p
.62778 .14245 m .64807 .14575 L .63473 .14899 L 1 .222 0 r
F
P
p
.61447 .14571 m .62778 .14245 L .63473 .14899 L 1 .256 0 r
F
P
p
.59406 .14241 m .61447 .14571 L .60125 .14896 L 1 .404 0 r
F
P
p
.58086 .14568 m .59406 .14241 L .60125 .14896 L 1 .541 0 r
F
P
p
.56033 .14238 m .58086 .14568 L .56776 .14893 L .593 1 0 r
F
P
p
.54725 .14565 m .56033 .14238 L .56776 .14893 L .106 1 0 r
F
P
p
.5266 .14234 m .54725 .14565 L .53428 .14889 L .272 1 0 r
F
P
p
.51365 .14561 m .5266 .14234 L .53428 .14889 L .139 1 0 r
F
P
p
.49286 .14231 m .51365 .14561 L .50079 .14886 L .773 1 0 r
F
P
p
.48003 .14558 m .49286 .14231 L .50079 .14886 L .568 1 0 r
F
P
p
.45913 .14228 m .48003 .14558 L .4673 .14883 L .753 1 0 r
F
P
p
.44642 .14555 m .45913 .14228 L .4673 .14883 L .548 1 0 r
F
P
p
.002 w
.33422 .6863 m .32202 .68758 L .31277 .68499 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.3 .70513 m .31277 .68499 L .32202 .68758 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.69942 .4066 m .71305 .40428 L .71938 .40892 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.69942 .4066 m .68588 .4089 L .6791 .39379 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.6656 .39615 m .6791 .39379 L .68588 .4089 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.28785 .70739 m .27503 .73152 L .26628 .70512 L p
0 .253 1 r
F P
0 0 0 r
s
P
p
.002 w
.25429 .70634 m .26628 .70512 L .27503 .73152 L p
0 .122 1 r
F P
0 0 0 r
s
P
p
.002 w
.21968 .73036 m .20786 .73149 L .19775 .72922 L p
0 .047 1 r
F P
0 0 0 r
s
P
p
.002 w
.18597 .73035 m .19775 .72922 L .20786 .73149 L p
.028 0 1 r
F P
0 0 0 r
s
P
p
.002 w
.78017 .39387 m .76632 .39622 L .76032 .39147 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74648 .39384 m .76032 .39147 L .76632 .39622 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6791 .39379 m .6656 .39615 L .65924 .41242 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.64573 .41472 m .65924 .41242 L .6656 .39615 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.59335 .50767 m .58023 .5202 L .57252 .45284 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57252 .45284 m .58567 .4507 L .59335 .50767 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58567 .4507 m .57252 .45284 L .56531 .49744 L p
1 .941 0 r
F P
0 0 0 r
s
P
p
.002 w
.5521 .50371 m .56531 .49744 L .57252 .45284 L p
.991 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45759 .59661 m .47061 .5859 L .47941 .50955 L p
.1 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26628 .70512 m .25429 .70634 L .24452 .70388 L p
0 .273 1 r
F P
0 0 0 r
s
P
p
.002 w
.23252 .70614 m .24452 .70388 L .25429 .70634 L p
0 .266 1 r
F P
0 0 0 r
s
P
p
.002 w
.26628 .70512 m .27902 .68497 L .28785 .70739 L p
0 .253 1 r
F P
0 0 0 r
s
P
p
.002 w
.39341 .65096 m .38095 .65238 L .37139 .68238 L p
0 .803 1 r
F P
0 0 0 r
s
P
p
.002 w
.35891 .68369 m .37139 .68238 L .38095 .65238 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.72895 .14255 m .74273 .13925 L .74886 .14585 L 1 0 0 r
F
P
p
.70889 .13922 m .72895 .14255 L .71526 .14581 L 1 0 0 r
F
P
p
.69523 .14251 m .70889 .13922 L .71526 .14581 L 1 .019 0 r
F
P
p
.67504 .13919 m .69523 .14251 L .68167 .14578 L 1 0 0 r
F
P
p
.66151 .14248 m .67504 .13919 L .68167 .14578 L 1 .075 0 r
F
P
p
.6412 .13915 m .66151 .14248 L .64807 .14575 L 1 .159 0 r
F
P
p
.62778 .14245 m .6412 .13915 L .64807 .14575 L 1 .222 0 r
F
P
p
.60735 .13912 m .62778 .14245 L .61447 .14571 L 1 .273 0 r
F
P
p
.59406 .14241 m .60735 .13912 L .61447 .14571 L 1 .404 0 r
F
P
p
.57349 .13908 m .59406 .14241 L .58086 .14568 L .807 1 0 r
F
P
p
.56033 .14238 m .57349 .13908 L .58086 .14568 L .593 1 0 r
F
P
p
.53964 .13905 m .56033 .14238 L .54725 .14565 L .378 1 0 r
F
P
p
.5266 .14234 m .53964 .13905 L .54725 .14565 L .272 1 0 r
F
P
p
.50578 .13902 m .5266 .14234 L .51365 .14561 L .962 1 0 r
F
P
p
.49286 .14231 m .50578 .13902 L .51365 .14561 L .773 1 0 r
F
P
p
.47192 .13898 m .49286 .14231 L .48003 .14558 L .841 1 0 r
F
P
p
.45913 .14228 m .47192 .13898 L .48003 .14558 L .753 1 0 r
F
P
p
.002 w
.34652 .685 m .33422 .6863 L .32504 .68368 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.31277 .68499 m .32504 .68368 L .33422 .6863 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.74648 .39384 m .73304 .40662 L .72679 .40194 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.71305 .40428 m .72679 .40194 L .73304 .40662 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.71305 .40428 m .69942 .4066 L .69269 .39142 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.6791 .39379 m .69269 .39142 L .69942 .4066 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.52594 .50763 m .51297 .52098 L .50522 .48442 L p
.736 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47061 .5859 m .48368 .57707 L .49225 .50337 L p
.164 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.23252 .70614 m .21968 .73036 L .21068 .70386 L p
0 .253 1 r
F P
0 0 0 r
s
P
p
.002 w
.19775 .72922 m .21068 .70386 L .21968 .73036 L p
0 .047 1 r
F P
0 0 0 r
s
P
p
.002 w
.76032 .39147 m .77426 .38909 L .78017 .39387 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.76032 .39147 m .74648 .39384 L .74032 .38906 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72679 .40194 m .74032 .38906 L .74648 .39384 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.69269 .39142 m .6791 .39379 L .67284 .4101 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.65924 .41242 m .67284 .4101 L .6791 .39379 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.61937 .45072 m .60663 .50572 L .59892 .44853 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.59892 .44853 m .61227 .44636 L .61937 .45072 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.58567 .4507 m .59892 .44853 L .60663 .50572 L p
.977 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59892 .44853 m .58567 .4507 L .57852 .47828 L p
1 .847 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .47828 m .58567 .4507 L p
.56676 .4941 L 1 .941 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .47828 m .5918 .46395 L .59892 .44853 L p
1 .847 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .47828 m .57086 .44191 L p
.59032 .46239 L 1 .779 0 r
F P
0 0 0 r
s
P
p
.002 w
.5918 .46395 m .57852 .47828 L p
.59032 .46239 L 1 .779 0 r
F P
0 0 0 r
s
P
p
.002 w
.56531 .49744 m .57852 .47828 L p
.56676 .4941 L 1 .941 0 r
F P
0 0 0 r
s
P
p
.002 w
.53897 .50568 m .52594 .50763 L .51819 .48238 L p
.773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.50522 .48442 m .51819 .48238 L .52594 .50763 L p
.736 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.31277 .68499 m .3 .70513 L .29116 .68367 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.27902 .68497 m .29116 .68367 L .3 .70513 L p
0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.27902 .68497 m .26628 .70512 L .25657 .70264 L p
0 .332 1 r
F P
0 0 0 r
s
P
p
.002 w
.24452 .70388 m .25657 .70264 L .26628 .70512 L p
0 .273 1 r
F P
0 0 0 r
s
P
p
.002 w
.24452 .70388 m .23252 .70614 L .2234 .68364 L p
0 .388 1 r
F P
0 0 0 r
s
P
p
.002 w
.21068 .70386 m .2234 .68364 L .23252 .70614 L p
0 .253 1 r
F P
0 0 0 r
s
P
p
.002 w
.40626 .63232 m .39341 .65096 L .38454 .65257 L p
0 .946 1 r
F P
0 0 0 r
s
P
p
.002 w
.37139 .68238 m .38454 .65257 L .39341 .65096 L p
0 .803 1 r
F P
0 0 0 r
s
P
p
.72265 .1359 m .74273 .13925 L .72895 .14255 L 1 0 0 r
F
P
p
.70889 .13922 m .72265 .1359 L .72895 .14255 L 1 0 0 r
F
P
p
.68868 .13587 m .70889 .13922 L .69523 .14251 L 1 0 0 r
F
P
p
.67504 .13919 m .68868 .13587 L .69523 .14251 L 1 0 0 r
F
P
p
.65471 .13583 m .67504 .13919 L .66151 .14248 L 1 .057 0 r
F
P
p
.6412 .13915 m .65471 .13583 L .66151 .14248 L 1 .159 0 r
F
P
p
.002 w
.61227 .44636 m .62558 .43354 L .63246 .42749 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.62073 .1358 m .6412 .13915 L .62778 .14245 L 1 .205 0 r
F
P
p
.60735 .13912 m .62073 .1358 L .62778 .14245 L 1 .273 0 r
F
P
p
.58676 .13577 m .60735 .13912 L .59406 .14241 L .943 1 0 r
F
P
p
.57349 .13908 m .58676 .13577 L .59406 .14241 L .807 1 0 r
F
P
p
.55278 .13573 m .57349 .13908 L .56033 .14238 L .681 1 0 r
F
P
p
.53964 .13905 m .55278 .13573 L .56033 .14238 L .378 1 0 r
F
P
p
.5188 .1357 m .53964 .13905 L .5266 .14234 L 1 .834 0 r
F
P
p
.50578 .13902 m .5188 .1357 L .5266 .14234 L .962 1 0 r
F
P
p
.002 w
.51819 .48238 m .50522 .48442 L .49705 .52319 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48368 .57707 m .49705 .52319 L .50522 .48442 L p
.418 1 0 r
F P
0 0 0 r
s
P
p
.48482 .13566 m .50578 .13902 L .49286 .14231 L .962 1 0 r
F
P
p
.47192 .13898 m .48482 .13566 L .49286 .14231 L .841 1 0 r
F
P
p
.002 w
.35891 .68369 m .34652 .685 L .33739 .68237 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.32504 .68368 m .33739 .68237 L .34652 .685 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.32504 .68368 m .31277 .68499 L .30339 .68235 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.29116 .68367 m .30339 .68235 L .31277 .68499 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.29116 .68367 m .27902 .68497 L .26871 .70139 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.25657 .70264 m .26871 .70139 L .27902 .68497 L p
0 .332 1 r
F P
0 0 0 r
s
P
p
.002 w
.72679 .40194 m .71305 .40428 L .70638 .38904 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.69269 .39142 m .70638 .38904 L .71305 .40428 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.41918 .61134 m .40626 .63232 L .39716 .65113 L p
0 1 .925 r
F P
0 0 0 r
s
P
p
.002 w
.38454 .65257 m .39716 .65113 L .40626 .63232 L p
0 .946 1 r
F P
0 0 0 r
s
P
p
.002 w
.43185 .60976 m .41918 .61134 L .40995 .64516 L p
0 1 .849 r
F P
0 0 0 r
s
P
p
.002 w
.39716 .65113 m .40995 .64516 L .41918 .61134 L p
0 1 .925 r
F P
0 0 0 r
s
P
p
.002 w
.77426 .38909 m .76032 .39147 L .75424 .38666 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74032 .38906 m .75424 .38666 L .76032 .39147 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70638 .38904 m .69269 .39142 L .68655 .40777 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.67284 .4101 m .68655 .40777 L .69269 .39142 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.61227 .44636 m .59892 .44853 L .5918 .46395 L p
1 .745 0 r
F P
0 0 0 r
s
P
p
.002 w
.5521 .50371 m .53897 .50568 L .53125 .48033 L p
.825 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53125 .48033 m .53897 .50568 L p
.52442 .48936 L .773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53125 .48033 m .54439 .46184 L .5521 .50371 L p
.825 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53125 .48033 m .52341 .49336 L p
.53814 .47122 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54439 .46184 m .53125 .48033 L p
.53814 .47122 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51819 .48238 m .53125 .48033 L p
.52442 .48936 L .773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.25657 .70264 m .24452 .70388 L .23538 .68233 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.2234 .68364 m .23538 .68233 L .24452 .70388 L p
0 .388 1 r
F P
0 0 0 r
s
P
p
.72265 .1359 m .73651 .13256 L .74273 .13925 L 1 0 0 r
F
P
p
.70242 .13253 m .72265 .1359 L .70889 .13922 L 1 0 0 r
F
P
p
.68868 .13587 m .70242 .13253 L .70889 .13922 L 1 0 0 r
F
P
p
.66832 .13249 m .68868 .13587 L .67504 .13919 L 1 0 0 r
F
P
p
.65471 .13583 m .66832 .13249 L .67504 .13919 L 1 .057 0 r
F
P
p
.63422 .13246 m .65471 .13583 L .6412 .13915 L 1 .091 0 r
F
P
p
.62073 .1358 m .63422 .13246 L .6412 .13915 L 1 .205 0 r
F
P
p
.60012 .13242 m .62073 .1358 L .60735 .13912 L 1 .886 0 r
F
P
p
.58676 .13577 m .60012 .13242 L .60735 .13912 L .943 1 0 r
F
P
p
.56602 .13239 m .58676 .13577 L .57349 .13908 L .998 1 0 r
F
P
p
.55278 .13573 m .56602 .13239 L .57349 .13908 L .681 1 0 r
F
P
p
.53191 .13235 m .55278 .13573 L .53964 .13905 L 1 .716 0 r
F
P
p
.5188 .1357 m .53191 .13235 L .53964 .13905 L 1 .834 0 r
F
P
p
.002 w
.53125 .48033 m .51819 .48238 L .51023 .49969 L p
.786 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49705 .52319 m .51023 .49969 L .51819 .48238 L p
.705 1 0 r
F P
0 0 0 r
s
P
p
.4978 .13232 m .5188 .1357 L .50578 .13902 L 1 .849 0 r
F
P
p
.48482 .13566 m .4978 .13232 L .50578 .13902 L .962 1 0 r
F
P
p
.002 w
.37139 .68238 m .35891 .68369 L .34984 .68104 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.33739 .68237 m .34984 .68104 L .35891 .68369 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.33739 .68237 m .32504 .68368 L .31571 .68103 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.30339 .68235 m .31571 .68103 L .32504 .68368 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.30339 .68235 m .29116 .68367 L .28093 .70013 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.26871 .70139 m .28093 .70013 L .29116 .68367 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.74032 .38906 m .72679 .40194 L .72017 .38663 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.70638 .38904 m .72017 .38663 L .72679 .40194 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.44474 .59825 m .43185 .60976 L .42275 .64369 L p
0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.40995 .64516 m .42275 .64369 L .43185 .60976 L p
0 1 .849 r
F P
0 0 0 r
s
P
p
.002 w
.67284 .4101 m .65924 .41242 L .65238 .40775 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.63895 .42067 m .65238 .40775 L .65924 .41242 L p
1 .307 0 r
F P
0 0 0 r
s
P
p
.002 w
.75424 .38666 m .76826 .38423 L .77426 .38909 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.75424 .38666 m .74032 .38906 L .73407 .38421 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72017 .38663 m .73407 .38421 L .74032 .38906 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.72017 .38663 m .70638 .38904 L .69987 .38418 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68655 .40777 m .69987 .38418 L .70638 .38904 L p
1 .068 0 r
F P
0 0 0 r
s
P
p
.002 w
.62558 .43354 m .61227 .44636 L .60506 .44193 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.5918 .46395 m .60506 .44193 L .61227 .44636 L p
1 .745 0 r
F P
0 0 0 r
s
P
p
.002 w
.56531 .49744 m .5521 .50371 L .54439 .46184 L p
.907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.26871 .70139 m .25657 .70264 L .24745 .681 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.23538 .68233 m .24745 .681 L .25657 .70264 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.71626 .12916 m .73651 .13256 L .72265 .1359 L 1 0 0 r
F
P
p
.70242 .13253 m .71626 .12916 L .72265 .1359 L 1 0 0 r
F
P
p
.68203 .12913 m .70242 .13253 L .68868 .13587 L 1 0 0 r
F
P
p
.66832 .13249 m .68203 .12913 L .68868 .13587 L 1 0 0 r
F
P
p
.64781 .12909 m .66832 .13249 L .65471 .13583 L 1 .023 0 r
F
P
p
.63422 .13246 m .64781 .12909 L .65471 .13583 L 1 .091 0 r
F
P
p
.61358 .12906 m .63422 .13246 L .62073 .1358 L 1 .545 0 r
F
P
p
.60012 .13242 m .61358 .12906 L .62073 .1358 L 1 .886 0 r
F
P
p
.57935 .12902 m .60012 .13242 L .58676 .13577 L 1 .955 0 r
F
P
p
.56602 .13239 m .57935 .12902 L .58676 .13577 L .998 1 0 r
F
P
p
.54512 .12899 m .56602 .13239 L .55278 .13573 L 1 .593 0 r
F
P
p
.53191 .13235 m .54512 .12899 L .55278 .13573 L 1 .716 0 r
F
P
p
.002 w
.51023 .49969 m .52341 .49336 L .53125 .48033 L p
.786 1 0 r
F P
0 0 0 r
s
P
p
.51089 .12895 m .53191 .13235 L .5188 .1357 L 1 .697 0 r
F
P
p
.4978 .13232 m .51089 .12895 L .5188 .1357 L 1 .849 0 r
F
P
p
.002 w
.39716 .65113 m .38454 .65257 L .37501 .67836 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.38454 .65257 m .37139 .68238 L .36238 .67971 L p
0 .598 1 r
F P
0 0 0 r
s
P
p
.002 w
.36238 .67971 m .37501 .67836 L .38454 .65257 L p
0 .598 1 r
F P
0 0 0 r
s
P
p
.002 w
.34984 .68104 m .36238 .67971 L .37139 .68238 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.34984 .68104 m .33739 .68237 L .32812 .67969 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.31571 .68103 m .32812 .67969 L .33739 .68237 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.31571 .68103 m .30339 .68235 L .29387 .67968 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.28093 .70013 m .29387 .67968 L .30339 .68235 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.45759 .59661 m .44474 .59825 L .43564 .64221 L p
0 1 .733 r
F P
0 0 0 r
s
P
p
.002 w
.42275 .64369 m .43564 .64221 L .44474 .59825 L p
0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.60506 .44193 m .61858 .4397 L .62558 .43354 L p
1 .648 0 r
F P
0 0 0 r
s
P
p
.002 w
.63895 .42067 m .62558 .43354 L .61858 .4397 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.002 w
.54439 .46184 m .5576 .45477 L .56531 .49744 L p
.907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5576 .45477 m .54439 .46184 L .53666 .47405 L p
1 .902 0 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .47405 m .54439 .46184 L p
.52433 .49197 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .47405 m .54994 .45038 L .5576 .45477 L p
1 .902 0 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .47405 m .52871 .58306 L p
.54903 .45606 L .327 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54994 .45038 m .53666 .47405 L p
.54903 .45606 L .327 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52341 .49336 m .53666 .47405 L p
.52433 .49197 L .907 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.68655 .40777 m .67284 .4101 L .66607 .40539 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.65238 .40775 m .66607 .40539 L p
.66263 .40893 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.65238 .40775 m .63895 .42067 L .6322 .43746 L p
1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.64559 .4137 m .65238 .40775 L p
.64121 .42419 L 1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.6322 .43746 m .64559 .4137 L p
.64121 .42419 L 1 .443 0 r
F P
0 0 0 r
s
P
p
.002 w
.64559 .4137 m .63828 .39281 L p
.65001 .40312 L 1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.6548 .40733 m .65238 .40775 L .64559 .4137 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.66607 .40539 m .6548 .40733 L p
.64559 .4137 L 1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.64559 .4137 m .65937 .41135 L .66607 .40539 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.65937 .41135 m .64559 .4137 L p
.65001 .40312 L 1 .29 0 r
F P
0 0 0 r
s
P
p
.002 w
.66607 .40539 m .65937 .41135 L p
.66954 .40182 L 1 .245 0 r
F P
0 0 0 r
s
P
p
.002 w
.67964 .39235 m .66607 .40539 L p
.66954 .40182 L 1 .245 0 r
F P
0 0 0 r
s
P
p
.002 w
.66607 .40539 m .67284 .4101 L p
.66263 .40893 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.57852 .47828 m .56531 .49744 L .5576 .45477 L p
1 .975 0 r
F P
0 0 0 r
s
P
p
.002 w
.76826 .38423 m .75424 .38666 L .74806 .38177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73407 .38421 m .74806 .38177 L .75424 .38666 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73407 .38421 m .72017 .38663 L .71374 .38174 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69987 .38418 m .71374 .38174 L .72017 .38663 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.28093 .70013 m .26871 .70139 L .25961 .67967 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.24745 .681 m .25961 .67967 L .26871 .70139 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.71626 .12916 m .7302 .12577 L .73651 .13256 L 1 0 0 r
F
P
p
.69585 .12573 m .71626 .12916 L .70242 .13253 L 1 0 0 r
F
P
p
.68203 .12913 m .69585 .12573 L .70242 .13253 L 1 0 0 r
F
P
p
.6615 .1257 m .68203 .12913 L .66832 .13249 L 1 0 0 r
F
P
p
.64781 .12909 m .6615 .1257 L .66832 .13249 L 1 .023 0 r
F
P
p
.002 w
.61858 .4397 m .6322 .43746 L .63895 .42067 L p
1 .58 0 r
F P
0 0 0 r
s
P
p
.62714 .12566 m .64781 .12909 L .63422 .13246 L 1 .239 0 r
F
P
p
.61358 .12906 m .62714 .12566 L .63422 .13246 L 1 .545 0 r
F
P
p
.59279 .12563 m .61358 .12906 L .60012 .13242 L 1 .852 0 r
F
P
p
.57935 .12902 m .59279 .12563 L .60012 .13242 L 1 .955 0 r
F
P
p
.002 w
.5576 .45477 m .57086 .44191 L .57852 .47828 L p
1 .975 0 r
F P
0 0 0 r
s
P
p
.55843 .12559 m .57935 .12902 L .56602 .13239 L 1 .457 0 r
F
P
p
.54512 .12899 m .55843 .12559 L .56602 .13239 L 1 .593 0 r
F
P
p
.52407 .12556 m .54512 .12899 L .53191 .13235 L 1 .682 0 r
F
P
p
.51089 .12895 m .52407 .12556 L .53191 .13235 L 1 .697 0 r
F
P
p
.002 w
.40995 .64516 m .39716 .65113 L .38774 .67701 L p
0 .7 1 r
F P
0 0 0 r
s
P
p
.002 w
.37501 .67836 m .38774 .67701 L .39716 .65113 L p
0 .686 1 r
F P
0 0 0 r
s
P
p
.002 w
.36238 .67971 m .34984 .68104 L .34063 .67835 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.32812 .67969 m .34063 .67835 L .34984 .68104 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.32812 .67969 m .31571 .68103 L .30625 .67834 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.29387 .67968 m .30625 .67834 L .31571 .68103 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.47061 .5859 m .45759 .59661 L .44884 .62314 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.43564 .64221 m .44884 .62314 L .45759 .59661 L p
0 1 .733 r
F P
0 0 0 r
s
P
p
.002 w
.57086 .44191 m .5576 .45477 L .54994 .45038 L p
1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.60506 .44193 m .5918 .46395 L .5841 .41833 L p
1 .609 0 r
F P
0 0 0 r
s
P
p
.002 w
.57086 .44191 m .5841 .41833 L .5918 .46395 L p
1 .779 0 r
F P
0 0 0 r
s
P
p
.002 w
.69987 .38418 m .68655 .40777 L .67964 .39235 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.66607 .40539 m .67964 .39235 L .68655 .40777 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.51023 .49969 m .49705 .52319 L .48843 .59837 L p
0 1 .028 r
F P
0 0 0 r
s
P
p
.002 w
.48368 .57707 m .47061 .5859 L .46189 .62157 L p
0 1 .538 r
F P
0 0 0 r
s
P
p
.002 w
.46189 .62157 m .47521 .60003 L .48368 .57707 L p
0 1 .538 r
F P
0 0 0 r
s
P
p
.002 w
.49705 .52319 m .48368 .57707 L .47521 .60003 L p
0 1 .291 r
F P
0 0 0 r
s
P
p
.002 w
.47521 .60003 m .48843 .59837 L .49705 .52319 L p
0 1 .291 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .38177 m .76217 .37931 L .76826 .38423 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.74806 .38177 m .73407 .38421 L .72772 .37928 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71374 .38174 m .72772 .37928 L .73407 .38421 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71374 .38174 m .69987 .38418 L .6935 .38993 L p
1 .054 0 r
F P
0 0 0 r
s
P
p
.002 w
.67964 .39235 m .6935 .38993 L .69987 .38418 L p
1 .136 0 r
F P
0 0 0 r
s
P
p
.002 w
.61858 .4397 m .60506 .44193 L .59755 .41601 L p
1 .525 0 r
F P
0 0 0 r
s
P
p
.002 w
.5841 .41833 m .59755 .41601 L .60506 .44193 L p
1 .609 0 r
F P
0 0 0 r
s
P
p
.002 w
.5841 .41833 m .57086 .44191 L .56328 .43741 L p
1 .564 0 r
F P
0 0 0 r
s
P
p
.002 w
.56328 .43741 m .57086 .44191 L p
.55098 .44996 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.56328 .43741 m .57665 .41933 L .5841 .41833 L p
1 .564 0 r
F P
0 0 0 r
s
P
p
.002 w
.56328 .43741 m .55589 .53158 L p
.57564 .42481 L 1 .939 0 r
F P
0 0 0 r
s
P
p
.002 w
.57665 .41933 m .56328 .43741 L p
.57564 .42481 L 1 .939 0 r
F P
0 0 0 r
s
P
p
.002 w
.54994 .45038 m .56328 .43741 L p
.55098 .44996 L 1 .75 0 r
F P
0 0 0 r
s
P
p
.002 w
.44884 .62314 m .46189 .62157 L .47061 .5859 L p
0 1 .65 r
F P
0 0 0 r
s
P
p
.002 w
.52341 .49336 m .51023 .49969 L .5018 .58652 L p
.085 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48843 .59837 m .5018 .58652 L .51023 .49969 L p
0 1 .028 r
F P
0 0 0 r
s
P
p
.002 w
.29387 .67968 m .28093 .70013 L .27186 .67832 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.25961 .67967 m .27186 .67832 L .28093 .70013 L p
0 .391 1 r
F P
0 0 0 r
s
P
p
.002 w
.42275 .64369 m .40995 .64516 L .40056 .67564 L p
0 .803 1 r
F P
0 0 0 r
s
P
p
.002 w
.38774 .67701 m .40056 .67564 L .40995 .64516 L p
0 .7 1 r
F P
0 0 0 r
s
P
p
.70977 .12232 m .7302 .12577 L .71626 .12916 L 1 0 0 r
F
P
p
.69585 .12573 m .70977 .12232 L .71626 .12916 L 1 0 0 r
F
P
p
.67529 .12228 m .69585 .12573 L .68203 .12913 L 1 0 0 r
F
P
p
.6615 .1257 m .67529 .12228 L .68203 .12913 L 1 0 0 r
F
P
p
.64081 .12225 m .6615 .1257 L .64781 .12909 L 1 .17 0 r
F
P
p
.62714 .12566 m .64081 .12225 L .64781 .12909 L 1 .239 0 r
F
P
p
.60632 .12221 m .62714 .12566 L .61358 .12906 L 1 .545 0 r
F
P
p
.59279 .12563 m .60632 .12221 L .61358 .12906 L 1 .852 0 r
F
P
p
.002 w
.59755 .41601 m .5841 .41833 L .57665 .41933 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.57184 .12218 m .59279 .12563 L .57935 .12902 L 1 .341 0 r
F
P
p
.55843 .12559 m .57184 .12218 L .57935 .12902 L 1 .457 0 r
F
P
p
.53735 .12214 m .55843 .12559 L .54512 .12899 L 1 .614 0 r
F
P
p
.52407 .12556 m .53735 .12214 L .54512 .12899 L 1 .682 0 r
F
P
p
.002 w
.37501 .67836 m .36238 .67971 L .35323 .67699 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.002 w
.34063 .67835 m .35323 .67699 L .36238 .67971 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.34063 .67835 m .32812 .67969 L .31872 .67698 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.30625 .67834 m .31872 .67698 L .32812 .67969 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.30625 .67834 m .29387 .67968 L .2842 .67697 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.27186 .67832 m .2842 .67697 L .29387 .67968 L p
0 .45 1 r
F P
0 0 0 r
s
P
p
.002 w
.53666 .47405 m .52341 .49336 L .5152 .5848 L p
.153 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5018 .58652 m .5152 .5848 L .52341 .49336 L p
.085 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.76217 .37931 m .74806 .38177 L .7418 .37681 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72772 .37928 m .7418 .37681 L .74806 .38177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6935 .38993 m .70736 .3829 L .71374 .38174 L p
1 .054 0 r
F P
0 0 0 r
s
P
p
.002 w
.72772 .37928 m .71374 .38174 L .70736 .3829 L p
1 .019 0 r
F P
0 0 0 r
s
P
p
.002 w
.6322 .43746 m .61858 .4397 L .61104 .40725 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.59755 .41601 m .61104 .40725 L .61858 .4397 L p
1 .525 0 r
F P
0 0 0 r
s
P
p
.002 w
.40056 .67564 m .41395 .64527 L .42275 .64369 L p
0 .803 1 r
F P
0 0 0 r
s
P
p
.002 w
.43564 .64221 m .42275 .64369 L .41395 .64527 L p
0 .906 1 r
F P
0 0 0 r
s
P
p
.70977 .12232 m .72379 .11887 L .7302 .12577 L 1 0 0 r
F
P
p
.68918 .11884 m .70977 .12232 L .69585 .12573 L 1 0 0 r
F
P
p
.67529 .12228 m .68918 .11884 L .69585 .12573 L 1 0 0 r
F
P
p
.65457 .1188 m .67529 .12228 L .6615 .1257 L 1 .102 0 r
F
P
p
.64081 .12225 m .65457 .1188 L .6615 .1257 L 1 .17 0 r
F
P
p
.61996 .11877 m .64081 .12225 L .62714 .12566 L 1 .273 0 r
F
P
p
.60632 .12221 m .61996 .11877 L .62714 .12566 L 1 .545 0 r
F
P
p
.002 w
.61104 .40725 m .59755 .41601 L .59015 .4113 L p
1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.57665 .41933 m .59015 .4113 L .59755 .41601 L p
1 .427 0 r
F P
0 0 0 r
s
P
p
.58535 .11873 m .60632 .12221 L .59279 .12563 L 1 .193 0 r
F
P
p
.57184 .12218 m .58535 .11873 L .59279 .12563 L 1 .341 0 r
F
P
p
.55073 .1187 m .57184 .12218 L .55843 .12559 L 1 .511 0 r
F
P
p
.53735 .12214 m .55073 .1187 L .55843 .12559 L 1 .614 0 r
F
P
p
.002 w
.5152 .5848 m .52871 .58306 L .53666 .47405 L p
.153 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38774 .67701 m .37501 .67836 L .36668 .64218 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.35323 .67699 m .36668 .64218 L .37501 .67836 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.002 w
.35323 .67699 m .34063 .67835 L .33128 .67562 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.31872 .67698 m .33128 .67562 L .34063 .67835 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.31872 .67698 m .30625 .67834 L .29664 .6756 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.002 w
.2842 .67697 m .29664 .6756 L .30625 .67834 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.6935 .38993 m .67964 .39235 L .67288 .38961 L p
1 .109 0 r
F P
0 0 0 r
s
P
p
.002 w
.65937 .41135 m .67288 .38961 L .67964 .39235 L p
1 .245 0 r
F P
0 0 0 r
s
P
p
.002 w
.56328 .43741 m .54994 .45038 L .5423 .56467 L p
.575 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52871 .58306 m .5423 .56467 L .54994 .45038 L p
.327 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.7418 .37681 m .75598 .37431 L .76217 .37931 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61104 .40725 m .62463 .40059 L .6322 .43746 L p
1 .491 0 r
F P
0 0 0 r
s
P
p
.002 w
.62463 .40059 m .61104 .40725 L .60376 .40739 L p
1 .316 0 r
F P
0 0 0 r
s
P
p
.002 w
.60376 .40739 m .61104 .40725 L p
.59638 .41009 L 1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.60376 .40739 m .61738 .39573 L .62463 .40059 L p
1 .316 0 r
F P
0 0 0 r
s
P
p
.002 w
.60376 .40739 m .59652 .42592 L p
.61121 .40466 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.61738 .39573 m .60376 .40739 L p
.61121 .40466 L 1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .4113 m .60376 .40739 L p
.59638 .41009 L 1 .384 0 r
F P
0 0 0 r
s
P
p
.002 w
.7418 .37681 m .72772 .37928 L .72127 .37428 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70736 .3829 m .72127 .37428 L .72772 .37928 L p
1 .019 0 r
F P
0 0 0 r
s
P
p
.002 w
.64559 .4137 m .6322 .43746 L .62463 .40059 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.002 w
.5423 .56467 m .55589 .53158 L .56328 .43741 L p
.575 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44884 .62314 m .43564 .64221 L .42698 .6392 L p
0 .974 1 r
F P
0 0 0 r
s
P
p
.002 w
.41395 .64527 m .42698 .6392 L .43564 .64221 L p
0 .906 1 r
F P
0 0 0 r
s
P
p
.002 w
.36668 .64218 m .37942 .64069 L .38774 .67701 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.37942 .64069 m .36668 .64218 L .3567 .67286 L p
0 .817 1 r
F P
0 0 0 r
s
P
p
.002 w
.36668 .64218 m .35323 .67699 L .34394 .67424 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.002 w
.34394 .67424 m .3567 .67286 L .36668 .64218 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.70318 .11537 m .72379 .11887 L .70977 .12232 L 1 0 0 r
F
P
p
.68918 .11884 m .70318 .11537 L .70977 .12232 L 1 0 0 r
F
P
p
.66844 .11533 m .68918 .11884 L .67529 .12228 L 1 .034 0 r
F
P
p
.65457 .1188 m .66844 .11533 L .67529 .12228 L 1 .102 0 r
F
P
p
.002 w
.62463 .40059 m .63828 .39281 L .64559 .4137 L p
1 .392 0 r
F P
0 0 0 r
s
P
p
.6337 .1153 m .65457 .1188 L .64081 .12225 L 1 .17 0 r
F
P
p
.61996 .11877 m .6337 .1153 L .64081 .12225 L 1 .273 0 r
F
P
p
.59895 .11526 m .61996 .11877 L .60632 .12221 L 1 .091 0 r
F
P
p
.58535 .11873 m .59895 .11526 L .60632 .12221 L 1 .193 0 r
F
P
p
.56421 .11523 m .58535 .11873 L .57184 .12218 L 1 .375 0 r
F
P
p
.55073 .1187 m .56421 .11523 L .57184 .12218 L 1 .511 0 r
F
P
p
.002 w
.40056 .67564 m .38774 .67701 L .37942 .64069 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.33128 .67562 m .34394 .67424 L .35323 .67699 L p
0 .509 1 r
F P
0 0 0 r
s
P
p
.002 w
.33128 .67562 m .31872 .67698 L .31019 .64066 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.29664 .6756 m .31019 .64066 L .31872 .67698 L p
0 .612 1 r
F P
0 0 0 r
s
P
p
.002 w
.70736 .3829 m .6935 .38993 L .68656 .37426 L p
1 .054 0 r
F P
0 0 0 r
s
P
p
.002 w
.67288 .38961 m .68656 .37426 L .6935 .38993 L p
1 .109 0 r
F P
0 0 0 r
s
P
p
.002 w
.55589 .53158 m .56913 .43056 L .57665 .41933 L p
1 .939 0 r
F P
0 0 0 r
s
P
p
.002 w
.59015 .4113 m .57665 .41933 L .56913 .43056 L p
1 .564 0 r
F P
0 0 0 r
s
P
p
.002 w
.46189 .62157 m .44884 .62314 L .44004 .63768 L p
0 1 .972 r
F P
0 0 0 r
s
P
p
.002 w
.42698 .6392 m .44004 .63768 L .44884 .62314 L p
0 .974 1 r
F P
0 0 0 r
s
P
p
.002 w
.63828 .39281 m .62463 .40059 L .61738 .39573 L p
1 .256 0 r
F P
0 0 0 r
s
P
p
.002 w
.75598 .37431 m .7418 .37681 L .73543 .37177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72127 .37428 m .73543 .37177 L .7418 .37681 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.37942 .64069 m .39225 .63918 L .40056 .67564 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.002 w
.39225 .63918 m .37942 .64069 L .3703 .63765 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.3567 .67286 m .3703 .63765 L .37942 .64069 L p
0 .817 1 r
F P
0 0 0 r
s
P
p
.002 w
.31019 .64066 m .32276 .63915 L .33128 .67562 L p
0 .714 1 r
F P
0 0 0 r
s
P
p
.70318 .11537 m .71729 .11187 L .72379 .11887 L 1 0 0 r
F
P
p
.68242 .11184 m .70318 .11537 L .68918 .11884 L 1 0 0 r
F
P
p
.66844 .11533 m .68242 .11184 L .68918 .11884 L 1 .034 0 r
F
P
p
.002 w
.67288 .38961 m .65937 .41135 L .65202 .38498 L p
1 .211 0 r
F P
0 0 0 r
s
P
p
.002 w
.63828 .39281 m .65202 .38498 L .65937 .41135 L p
1 .29 0 r
F P
0 0 0 r
s
P
p
.64754 .1118 m .66844 .11533 L .65457 .1188 L 1 .102 0 r
F
P
p
.6337 .1153 m .64754 .1118 L .65457 .1188 L 1 .17 0 r
F
P
p
.61267 .11177 m .6337 .1153 L .61996 .11877 L 1 .034 0 r
F
P
p
.59895 .11526 m .61267 .11177 L .61996 .11877 L 1 .091 0 r
F
P
p
.002 w
.72127 .37428 m .70736 .3829 L .70059 .37174 L p
1 .019 0 r
F P
0 0 0 r
s
P
p
.002 w
.68656 .37426 m .70059 .37174 L .70736 .3829 L p
1 .054 0 r
F P
0 0 0 r
s
P
p
.002 w
.60376 .40739 m .59015 .4113 L .58277 .42825 L p
1 .541 0 r
F P
0 0 0 r
s
P
p
.002 w
.56913 .43056 m .58277 .42825 L .59015 .4113 L p
1 .564 0 r
F P
0 0 0 r
s
P
p
.57779 .11173 m .59895 .11526 L .58535 .11873 L 1 .193 0 r
F
P
p
.56421 .11523 m .57779 .11173 L .58535 .11873 L 1 .375 0 r
F
P
p
.002 w
.42698 .6392 m .41395 .64527 L .40568 .60885 L p
0 1 .891 r
F P
0 0 0 r
s
P
p
.002 w
.41395 .64527 m .40056 .67564 L .39225 .63918 L p
0 .891 1 r
F P
0 0 0 r
s
P
p
.002 w
.39225 .63918 m .40568 .60885 L .41395 .64527 L p
0 .891 1 r
F P
0 0 0 r
s
P
p
.002 w
.34394 .67424 m .33128 .67562 L .32276 .63915 L p
0 .734 1 r
F P
0 0 0 r
s
P
p
.002 w
.47521 .60003 m .46189 .62157 L .4532 .63615 L p
0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.44004 .63768 m .4532 .63615 L .46189 .62157 L p
0 1 .972 r
F P
0 0 0 r
s
P
p
.002 w
.68656 .37426 m .67288 .38961 L .66595 .3825 L p
1 .075 0 r
F P
0 0 0 r
s
P
p
.002 w
.65202 .38498 m .66595 .3825 L .67288 .38961 L p
1 .211 0 r
F P
0 0 0 r
s
P
p
.002 w
.65202 .38498 m .63828 .39281 L .63119 .39329 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.61738 .39573 m .63119 .39329 L .63828 .39281 L p
1 .256 0 r
F P
0 0 0 r
s
P
p
.002 w
.48843 .59837 m .47521 .60003 L .46645 .63461 L p
0 1 .849 r
F P
0 0 0 r
s
P
p
.002 w
.4532 .63615 m .46645 .63461 L .47521 .60003 L p
0 1 .911 r
F P
0 0 0 r
s
P
p
.002 w
.73543 .37177 m .7497 .36923 L .75598 .37431 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.73543 .37177 m .72127 .37428 L .71473 .36921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70059 .37174 m .71473 .36921 L .72127 .37428 L p
1 .019 0 r
F P
0 0 0 r
s
P
p
.002 w
.70059 .37174 m .68656 .37426 L .67975 .36918 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66595 .3825 m .67975 .36918 L .68656 .37426 L p
1 .075 0 r
F P
0 0 0 r
s
P
p
.002 w
.40568 .60885 m .41879 .59833 L .42698 .6392 L p
0 1 .891 r
F P
0 0 0 r
s
P
p
.002 w
.41879 .59833 m .40568 .60885 L .39689 .59664 L p
0 1 .639 r
F P
0 0 0 r
s
P
p
.002 w
.40568 .60885 m .39225 .63918 L .38397 .59832 L p
0 1 .761 r
F P
0 0 0 r
s
P
p
.002 w
.38397 .59832 m .39689 .59664 L .40568 .60885 L p
0 1 .761 r
F P
0 0 0 r
s
P
p
.002 w
.44004 .63768 m .42698 .6392 L .41879 .59833 L p
0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.3703 .63765 m .38397 .59832 L .39225 .63918 L p
0 1 .965 r
F P
0 0 0 r
s
P
p
.002 w
.32276 .63915 m .3356 .63106 L .34394 .67424 L p
0 .734 1 r
F P
0 0 0 r
s
P
p
.002 w
.59652 .42592 m .58953 .49909 L p
.60229 .43166 L .943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59652 .42592 m .60376 .40739 L p
.59082 .42025 L 1 .541 0 r
F P
0 0 0 r
s
P
p
.002 w
.59652 .42592 m .61002 .39081 L .61738 .39573 L p
1 .404 0 r
F P
0 0 0 r
s
P
p
.002 w
.61002 .39081 m .59652 .42592 L p
.60229 .43166 L .943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58277 .42825 m .59652 .42592 L p
.59082 .42025 L 1 .541 0 r
F P
0 0 0 r
s
P
p
.6965 .10832 m .71729 .11187 L .70318 .11537 L 1 0 0 r
F
P
p
.68242 .11184 m .6965 .10832 L .70318 .11537 L 1 0 0 r
F
P
p
.66149 .10828 m .68242 .11184 L .66844 .11533 L 1 .034 0 r
F
P
p
.64754 .1118 m .66149 .10828 L .66844 .11533 L 1 .102 0 r
F
P
p
.62648 .10824 m .64754 .1118 L .6337 .1153 L 1 0 0 r
F
P
p
.61267 .11177 m .62648 .10824 L .6337 .1153 L 1 .034 0 r
F
P
p
.59147 .10821 m .61267 .11177 L .59895 .11526 L 1 .057 0 r
F
P
p
.57779 .11173 m .59147 .10821 L .59895 .11526 L 1 .193 0 r
F
P
p
.002 w
.3567 .67286 m .34394 .67424 L .3356 .63106 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.66595 .3825 m .65202 .38498 L .64511 .39083 L p
1 .159 0 r
F P
0 0 0 r
s
P
p
.002 w
.63119 .39329 m .64511 .39083 L .65202 .38498 L p
1 .222 0 r
F P
0 0 0 r
s
P
p
.002 w
.5018 .58652 m .48843 .59837 L .47981 .63306 L p
0 1 .764 r
F P
0 0 0 r
s
P
p
.002 w
.46645 .63461 m .47981 .63306 L .48843 .59837 L p
0 1 .849 r
F P
0 0 0 r
s
P
p
.002 w
.41879 .59833 m .43199 .58649 L .44004 .63768 L p
0 1 .818 r
F P
0 0 0 r
s
P
p
.002 w
.43199 .58649 m .41879 .59833 L .40996 .59272 L p
0 1 .549 r
F P
0 0 0 r
s
P
p
.002 w
.39689 .59664 m .40996 .59272 L .41879 .59833 L p
0 1 .639 r
F P
0 0 0 r
s
P
p
.002 w
.39689 .59664 m .38397 .59832 L .37488 .5927 L p
0 1 .536 r
F P
0 0 0 r
s
P
p
.002 w
.38397 .59832 m .3703 .63765 L .36194 .59662 L p
0 1 .727 r
F P
0 0 0 r
s
P
p
.002 w
.36194 .59662 m .37488 .5927 L .38397 .59832 L p
0 1 .727 r
F P
0 0 0 r
s
P
p
.002 w
.3703 .63765 m .3567 .67286 L .34914 .5983 L p
0 1 .952 r
F P
0 0 0 r
s
P
p
.002 w
.34914 .5983 m .36194 .59662 L .3703 .63765 L p
0 1 .952 r
F P
0 0 0 r
s
P
p
.002 w
.3356 .63106 m .34914 .5983 L .3567 .67286 L p
0 .85 1 r
F P
0 0 0 r
s
P
p
.002 w
.63119 .39329 m .61738 .39573 L .61002 .39081 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.7497 .36923 m .73543 .37177 L .72897 .36665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71473 .36921 m .72897 .36665 L .73543 .37177 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71473 .36921 m .70059 .37174 L .69386 .36663 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67975 .36918 m .69386 .36663 L .70059 .37174 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58277 .42825 m .56913 .43056 L .56196 .57416 L p
.593 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5152 .5848 m .5018 .58652 L .49337 .61354 L p
0 1 .617 r
F P
0 0 0 r
s
P
p
.002 w
.50698 .59157 m .5152 .5848 L p
.49669 .60917 L 0 1 .617 r
F P
0 0 0 r
s
P
p
.002 w
.49337 .61354 m .50698 .59157 L p
.49669 .60917 L 0 1 .617 r
F P
0 0 0 r
s
P
p
.002 w
.50698 .59157 m .49915 .48522 L p
.51731 .5739 L .043 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51943 .58425 m .5152 .5848 L .50698 .59157 L p
0 1 .556 r
F P
0 0 0 r
s
P
p
.002 w
.52871 .58306 m .51943 .58425 L p
.50698 .59157 L 0 1 .556 r
F P
0 0 0 r
s
P
p
.002 w
.50698 .59157 m .52057 .58985 L .52871 .58306 L p
0 1 .556 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .58985 m .50698 .59157 L p
.51731 .5739 L .043 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5423 .56467 m .52871 .58306 L .52107 .58943 L p
0 1 .478 r
F P
0 0 0 r
s
P
p
.002 w
.52107 .58943 m .52057 .58985 L p
.52176 .58848 L 0 1 .478 r
F P
0 0 0 r
s
P
p
.52176 .58848 m .5423 .56467 L .52107 .58943 L 0 1 .478 r
F
P
p
.002 w
.53428 .57905 m .5423 .56467 L p
.52176 .58848 L 0 1 .478 r
F P
0 0 0 r
s
P
p
.002 w
.52057 .58985 m .53428 .57905 L p
.52176 .58848 L 0 1 .478 r
F P
0 0 0 r
s
P
p
.002 w
.55589 .53158 m .5423 .56467 L .53434 .57893 L p
0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.53434 .57893 m .53428 .57905 L p
.53443 .57872 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.53443 .57872 m .55589 .53158 L .53434 .57893 L 0 1 .301 r
F
P
p
.002 w
.54807 .57596 m .55589 .53158 L p
.53443 .57872 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.53428 .57905 m .54807 .57596 L p
.53443 .57872 L 0 1 .301 r
F P
0 0 0 r
s
P
p
.002 w
.55355 .42115 m .56721 .39016 L .56843 .40786 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56913 .43056 m .55589 .53158 L .54811 .5757 L p
.106 1 0 r
F P
0 0 0 r
s
P
p
.54815 .57536 m .56913 .43056 L .54811 .5757 L .106 1 0 r
F
P
p
.002 w
.54811 .5757 m .54807 .57596 L p
.54815 .57536 L .106 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54807 .57596 m .56196 .57416 L .56913 .43056 L p
.106 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57587 .50955 m .58277 .42825 L p
.56704 .53853 L .593 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.59652 .42592 m .58277 .42825 L .57562 .51241 L p
.807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58953 .49909 m .59652 .42592 L p
.5768 .50753 L .807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57562 .51241 m .58953 .49909 L p
.5768 .50753 L .807 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58953 .49909 m .60362 .49698 L .61002 .39081 L p
.943 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58953 .49909 m .58102 .38326 L p
.60235 .49059 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.60362 .49698 m .58953 .49909 L p
.60235 .49059 L 1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.56721 .39016 m .58102 .38326 L .5875 .47135 L p
.998 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.5875 .47135 m .58953 .49909 L p
.58532 .47851 L .998 1 0 r
F P
0 0 0 r
s
P
p
.56721 .39016 m .5875 .47135 L .58532 .47851 L .998 1 0 r
F
P
p
.002 w
.57562 .51241 m .57587 .50955 L p
.56594 .54629 L .593 1 0 r
F P
0 0 0 r
s
P
p
.56594 .54629 m .57587 .50955 L .56704 .53853 L .593 1 0 r
F
P
p
.002 w
.56196 .57416 m .57562 .51241 L p
.56594 .54629 L .593 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.57562 .51241 m .56721 .39016 L p
.58532 .47851 L .998 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58953 .49909 m .57562 .51241 L p
.58532 .47851 L .998 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.56843 .40786 m .57562 .51241 L p
.56239 .45771 L .681 1 0 r
F P
0 0 0 r
s
P
p
.55355 .42115 m .56843 .40786 L .56239 .45771 L .681 1 0 r
F
P
p
.002 w
.54807 .57596 m .54647 .54835 L p
.55052 .5551 L .378 1 0 r
F P
0 0 0 r
s
P
p
.55052 .5551 m .56142 .57326 L .54807 .57596 L .378 1 0 r
F
P
p
.002 w
.56196 .57416 m .54807 .57596 L p
.56142 .57326 L .378 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.54647 .54835 m .53987 .43451 L p
.55462 .52778 L .378 1 0 r
F P
0 0 0 r
s
P
p
.55462 .52778 m .56196 .57416 L .54647 .54835 L .378 1 0 r
F
P
p
.53682 .57261 m .54112 .57389 L .53428 .57905 L .272 1 0 r
F
P
p
.002 w
.54807 .57596 m .53428 .57905 L p
.54112 .57389 L .272 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53428 .57905 m .53379 .5717 L p
.53682 .57261 L .272 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53379 .5717 m .52624 .45882 L p
.54449 .55677 L .272 1 0 r
F P
0 0 0 r
s
P
p
.54449 .55677 m .54807 .57596 L .53379 .5717 L .272 1 0 r
F
P
p
.002 w
.4232 .58301 m .40996 .59272 L .40277 .48937 L p
.115 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.40277 .48937 m .41614 .46537 L .4232 .58301 L p
.115 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.38831 .56863 m .40277 .48937 L .40996 .59272 L p
0 1 .223 r
F P
0 0 0 r
s
P
p
.002 w
.4532 .63615 m .44004 .63768 L .43199 .58649 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.6965 .10832 m .71068 .10477 L .71729 .11187 L 1 0 0 r
F
P
p
.67555 .10473 m .6965 .10832 L .68242 .11184 L 1 0 0 r
F
P
p
.66149 .10828 m .67555 .10473 L .68242 .11184 L 1 .034 0 r
F
P
p
.64041 .10469 m .66149 .10828 L .64754 .1118 L 1 0 0 r
F
P
p
.62648 .10824 m .64041 .10469 L .64754 .1118 L 1 0 0 r
F
P
p
.60526 .10466 m .62648 .10824 L .61267 .11177 L 1 0 0 r
F
P
p
.59147 .10821 m .60526 .10466 L .61267 .11177 L 1 .057 0 r
F
P
p
.002 w
.4366 .56685 m .4232 .58301 L .41614 .46537 L p
.252 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.41614 .46537 m .42922 .46319 L .4366 .56685 L p
.252 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47981 .63306 m .49337 .61354 L .5018 .58652 L p
0 1 .764 r
F P
0 0 0 r
s
P
p
.002 w
.43199 .58649 m .44513 .58476 L .4532 .63615 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.002 w
.44513 .58476 m .43199 .58649 L .4232 .58301 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.40996 .59272 m .4232 .58301 L .43199 .58649 L p
0 1 .549 r
F P
0 0 0 r
s
P
p
.002 w
.67975 .36918 m .66595 .3825 L .65888 .37384 L p
1 .057 0 r
F P
0 0 0 r
s
P
p
.002 w
.64511 .39083 m .65888 .37384 L .66595 .3825 L p
1 .159 0 r
F P
0 0 0 r
s
P
p
.002 w
.40996 .59272 m .39689 .59664 L .38831 .56863 L p
0 1 .223 r
F P
0 0 0 r
s
P
p
.002 w
.37488 .5927 m .38831 .56863 L .39689 .59664 L p
0 1 .536 r
F P
0 0 0 r
s
P
p
.002 w
.64511 .39083 m .63119 .39329 L .62391 .38833 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.62391 .38833 m .63119 .39329 L p
.61427 .3913 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.62391 .38833 m .63759 .364 L .64511 .39083 L p
1 .205 0 r
F P
0 0 0 r
s
P
p
.002 w
.62391 .38833 m .61755 .47226 L p
.63364 .38532 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.63759 .364 m .62391 .38833 L p
.63364 .38532 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.61002 .39081 m .62391 .38833 L p
.61427 .3913 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.72897 .36665 m .74333 .36408 L .7497 .36923 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72897 .36665 m .71473 .36921 L .70808 .36405 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69386 .36663 m .70808 .36405 L .71473 .36921 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69386 .36663 m .67975 .36918 L .67284 .36403 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65888 .37384 m .67284 .36403 L .67975 .36918 L p
1 .057 0 r
F P
0 0 0 r
s
P
p
.002 w
.46645 .63461 m .4532 .63615 L .44513 .58476 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.68971 .10115 m .71068 .10477 L .6965 .10832 L 1 0 0 r
F
P
p
.67555 .10473 m .68971 .10115 L .6965 .10832 L 1 0 0 r
F
P
p
.65443 .10112 m .67555 .10473 L .66149 .10828 L 1 0 0 r
F
P
p
.64041 .10469 m .65443 .10112 L .66149 .10828 L 1 0 0 r
F
P
p
.61916 .10108 m .64041 .10469 L .62648 .10824 L 1 0 0 r
F
P
p
.60526 .10466 m .61916 .10108 L .62648 .10824 L 1 0 0 r
F
P
p
.002 w
.45001 .55383 m .4366 .56685 L .42922 .46319 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.42922 .46319 m .44239 .46099 L .45001 .55383 L p
.33 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44513 .58476 m .45837 .58303 L .46645 .63461 L p
0 1 .787 r
F P
0 0 0 r
s
P
p
.002 w
.45837 .58303 m .44513 .58476 L .4366 .56685 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.4232 .58301 m .4366 .56685 L .44513 .58476 L p
0 1 .45 r
F P
0 0 0 r
s
P
p
.002 w
.65888 .37384 m .64511 .39083 L .63759 .364 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.002 w
.62391 .38833 m .61002 .39081 L .60362 .49698 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.74333 .36408 m .72897 .36665 L .72241 .36146 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .36405 m .72241 .36146 L .72897 .36665 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70808 .36405 m .69386 .36663 L .68703 .36143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67284 .36403 m .68703 .36143 L .69386 .36663 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.49915 .48522 m .51267 .47205 L .52057 .58985 L p
.043 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.48555 .52043 m .49915 .48522 L .50698 .59157 L p
0 1 .155 r
F P
0 0 0 r
s
P
p
.002 w
.51267 .47205 m .49915 .48522 L .49089 .46985 L p
.773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49915 .48522 m .48555 .52043 L .47737 .48307 L p
.568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47737 .48307 m .49089 .46985 L .49915 .48522 L p
.568 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49337 .61354 m .47981 .63306 L .47203 .54457 L p
0 1 .441 r
F P
0 0 0 r
s
P
p
.002 w
.47203 .54457 m .48555 .52043 L .49337 .61354 L p
0 1 .441 r
F P
0 0 0 r
s
P
p
.002 w
.45837 .58303 m .47203 .54457 L .47981 .63306 L p
0 1 .675 r
F P
0 0 0 r
s
P
p
.002 w
.48555 .52043 m .47203 .54457 L .46396 .49169 L p
.344 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.47203 .54457 m .45837 .58303 L .45001 .55383 L p
0 1 .041 r
F P
0 0 0 r
s
P
p
.002 w
.45001 .55383 m .46396 .49169 L .47203 .54457 L p
0 1 .041 r
F P
0 0 0 r
s
P
p
.002 w
.47981 .63306 m .46645 .63461 L .45837 .58303 L p
0 1 .675 r
F P
0 0 0 r
s
P
p
.68971 .10115 m .70398 .09755 L .71068 .10477 L 1 0 0 r
F
P
p
.66857 .09751 m .68971 .10115 L .67555 .10473 L 1 0 0 r
F
P
p
.65443 .10112 m .66857 .09751 L .67555 .10473 L 1 0 0 r
F
P
p
.63316 .09748 m .65443 .10112 L .64041 .10469 L 1 0 0 r
F
P
p
.61916 .10108 m .63316 .09748 L .64041 .10469 L 1 0 0 r
F
P
p
.002 w
.50698 .59157 m .49337 .61354 L .48555 .52043 L p
0 1 .155 r
F P
0 0 0 r
s
P
p
.002 w
.46396 .49169 m .47737 .48307 L .48555 .52043 L p
.344 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46396 .49169 m .45001 .55383 L .44239 .46099 L p
.548 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.44239 .46099 m .45567 .45877 L .46396 .49169 L p
.548 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.67284 .36403 m .65888 .37384 L .65165 .36141 L p
1 .023 0 r
F P
0 0 0 r
s
P
p
.002 w
.63759 .364 m .65165 .36141 L .65888 .37384 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.002 w
.47737 .48307 m .46396 .49169 L .45567 .45877 L p
.753 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.4366 .56685 m .45001 .55383 L .45837 .58303 L p
0 1 .372 r
F P
0 0 0 r
s
P
p
.002 w
.53428 .57905 m .52057 .58985 L .51267 .47205 L p
.139 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.51267 .47205 m .52624 .45882 L .53428 .57905 L p
.139 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.52624 .45882 m .51267 .47205 L .50447 .45656 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .46985 m .50447 .45656 L .51267 .47205 L p
.773 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.60362 .49698 m .61755 .47226 L .62391 .38833 L p
1 .886 0 r
F P
0 0 0 r
s
P
p
.002 w
.72241 .36146 m .73685 .35885 L .74333 .36408 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.72241 .36146 m .70808 .36405 L .70134 .35882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68703 .36143 m .70134 .35882 L .70808 .36405 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68703 .36143 m .67284 .36403 L .66582 .35879 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65165 .36141 m .66582 .35879 L .67284 .36403 L p
1 .023 0 r
F P
0 0 0 r
s
P
p
.002 w
.65165 .36141 m .63759 .364 L .6309 .40286 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.6309 .40286 m .63759 .364 L p
.62599 .42664 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.6309 .40286 m .62303 .3645 L p
.63583 .37895 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.6309 .40286 m .64496 .38927 L .65165 .36141 L p
1 .239 0 r
F P
0 0 0 r
s
P
p
.002 w
.64496 .38927 m .6309 .40286 L p
.63583 .37895 L 1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.61755 .47226 m .6309 .40286 L p
.62599 .42664 L 1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.49089 .46985 m .47737 .48307 L .46904 .45654 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.45567 .45877 m .46904 .45654 L .47737 .48307 L p
.753 1 0 r
F P
0 0 0 r
s
P
p
.68281 .09388 m .70398 .09755 L .68971 .10115 L 1 0 0 r
F
P
p
.66857 .09751 m .68281 .09388 L .68971 .10115 L 1 0 0 r
F
P
p
.64727 .09384 m .66857 .09751 L .65443 .10112 L 1 0 0 r
F
P
p
.63316 .09748 m .64727 .09384 L .65443 .10112 L 1 0 0 r
F
P
p
.002 w
.52624 .45882 m .53987 .43451 L .54807 .57596 L p
.272 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53987 .43451 m .52624 .45882 L .51814 .42614 L p
1 .834 0 r
F P
0 0 0 r
s
P
p
.002 w
.50447 .45656 m .51814 .42614 L .52624 .45882 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53987 .43451 m .55355 .42115 L .56196 .57416 L p
.378 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.55355 .42115 m .53987 .43451 L .53181 .41874 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.002 w
.51814 .42614 m .53181 .41874 L .53987 .43451 L p
1 .834 0 r
F P
0 0 0 r
s
P
p
.002 w
.50447 .45656 m .49089 .46985 L .4826 .4432 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.46904 .45654 m .4826 .4432 L .49089 .46985 L p
.841 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.73685 .35885 m .72241 .36146 L .71575 .35619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70134 .35882 m .71575 .35619 L .72241 .36146 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.58102 .38326 m .56721 .39016 L .55944 .41392 L p
1 .457 0 r
F P
0 0 0 r
s
P
p
.002 w
.56721 .39016 m .55355 .42115 L .54557 .41634 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.54557 .41634 m .55944 .41392 L .56721 .39016 L p
1 .593 0 r
F P
0 0 0 r
s
P
p
.002 w
.70134 .35882 m .68703 .36143 L .6801 .35616 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66582 .35879 m .6801 .35616 L .68703 .36143 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66582 .35879 m .65165 .36141 L .64496 .38927 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.57562 .51241 m .56196 .57416 L .55355 .42115 L p
.681 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.53181 .41874 m .54557 .41634 L .55355 .42115 L p
1 .716 0 r
F P
0 0 0 r
s
P
p
.68281 .09388 m .69717 .09022 L .70398 .09755 L 1 0 0 r
F
P
p
.66148 .09018 m .68281 .09388 L .66857 .09751 L 1 0 0 r
F
P
p
.64727 .09384 m .66148 .09018 L .66857 .09751 L 1 0 0 r
F
P
p
.002 w
.53181 .41874 m .51814 .42614 L .50991 .41632 L p
1 .697 0 r
F P
0 0 0 r
s
P
p
.002 w
.51814 .42614 m .50447 .45656 L .4962 .43491 L p
1 .849 0 r
F P
0 0 0 r
s
P
p
.002 w
.4962 .43491 m .50991 .41632 L .51814 .42614 L p
1 .849 0 r
F P
0 0 0 r
s
P
p
.002 w
.4826 .4432 m .4962 .43491 L .50447 .45656 L p
.962 1 0 r
F P
0 0 0 r
s
P
p
.002 w
.58102 .38326 m .59496 .38072 L .60362 .49698 L p
1 .955 0 r
F P
0 0 0 r
s
P
p
.002 w
.59496 .38072 m .58102 .38326 L .57336 .40033 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.55944 .41392 m .57336 .40033 L .58102 .38326 L p
1 .457 0 r
F P
0 0 0 r
s
P
p
.002 w
.71575 .35619 m .73028 .35353 L .73685 .35885 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.71575 .35619 m .70134 .35882 L .69449 .3535 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6801 .35616 m .69449 .3535 L .70134 .35882 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6801 .35616 m .66582 .35879 L .65908 .37561 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.64496 .38927 m .65908 .37561 L .66582 .35879 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.54557 .41634 m .53181 .41874 L .52364 .4139 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.002 w
.50991 .41632 m .52364 .4139 L .53181 .41874 L p
1 .697 0 r
F P
0 0 0 r
s
P
p
.67581 .0865 m .69717 .09022 L .68281 .09388 L 1 0 0 r
F
P
p
.66148 .09018 m .67581 .0865 L .68281 .09388 L 1 0 0 r
F
P
p
.002 w
.61755 .47226 m .60362 .49698 L .59496 .38072 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.59496 .38072 m .6089 .36712 L .61755 .47226 L p
1 .852 0 r
F P
0 0 0 r
s
P
p
.002 w
.6089 .36712 m .59496 .38072 L .58726 .37556 L p
1 .193 0 r
F P
0 0 0 r
s
P
p
.002 w
.57336 .40033 m .58726 .37556 L .59496 .38072 L p
1 .341 0 r
F P
0 0 0 r
s
P
p
.002 w
.73028 .35353 m .71575 .35619 L .70899 .35083 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69449 .3535 m .70899 .35083 L .71575 .35619 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65908 .37561 m .67327 .36189 L .6801 .35616 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.69449 .3535 m .6801 .35616 L .67327 .36189 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.55944 .41392 m .54557 .41634 L .53748 .41146 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.52364 .4139 m .53748 .41146 L .54557 .41634 L p
1 .682 0 r
F P
0 0 0 r
s
P
p
.67581 .0865 m .69025 .08278 L .69717 .09022 L 1 0 0 r
F
P
p
.002 w
.6309 .40286 m .61755 .47226 L .6089 .36712 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.6089 .36712 m .62303 .3645 L .6309 .40286 L p
1 .545 0 r
F P
0 0 0 r
s
P
p
.002 w
.62303 .3645 m .6089 .36712 L .60125 .35814 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.002 w
.58726 .37556 m .60125 .35814 L .6089 .36712 L p
1 .193 0 r
F P
0 0 0 r
s
P
p
.002 w
.70899 .35083 m .7236 .34813 L .73028 .35353 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70899 .35083 m .69449 .3535 L .68753 .34811 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67327 .36189 m .68753 .34811 L .69449 .3535 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.57336 .40033 m .55944 .41392 L .55137 .38665 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.53748 .41146 m .55137 .38665 L .55944 .41392 L p
1 .614 0 r
F P
0 0 0 r
s
P
p
.002 w
.65908 .37561 m .64496 .38927 L .63712 .35077 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.62303 .3645 m .63712 .35077 L .64496 .38927 L p
1 .273 0 r
F P
0 0 0 r
s
P
p
.002 w
.63712 .35077 m .62303 .3645 L .61537 .34805 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.60125 .35814 m .61537 .34805 L .62303 .3645 L p
1 .091 0 r
F P
0 0 0 r
s
P
p
.002 w
.58726 .37556 m .57336 .40033 L .56538 .38409 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.55137 .38665 m .56538 .38409 L .57336 .40033 L p
1 .511 0 r
F P
0 0 0 r
s
P
p
.002 w
.67327 .36189 m .65908 .37561 L .65145 .34808 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.63712 .35077 m .65145 .34808 L .65908 .37561 L p
1 .17 0 r
F P
0 0 0 r
s
P
p
.002 w
.60125 .35814 m .58726 .37556 L .57943 .37032 L p
1 .193 0 r
F P
0 0 0 r
s
P
p
.002 w
.56538 .38409 m .57943 .37032 L .58726 .37556 L p
1 .375 0 r
F P
0 0 0 r
s
P
p
.002 w
.7236 .34813 m .70899 .35083 L .70212 .34539 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68753 .34811 m .70212 .34539 L .70899 .35083 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65145 .34808 m .63712 .35077 L .62968 .34533 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.61537 .34805 m .62968 .34533 L .63712 .35077 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.61537 .34805 m .60125 .35814 L .59355 .35647 L p
1 .057 0 r
F P
0 0 0 r
s
P
p
.002 w
.57943 .37032 m .59355 .35647 L .60125 .35814 L p
1 .193 0 r
F P
0 0 0 r
s
P
p
.002 w
.68753 .34811 m .67327 .36189 L .6659 .34536 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.65145 .34808 m .6659 .34536 L .67327 .36189 L p
1 .102 0 r
F P
0 0 0 r
s
P
p
.002 w
.70212 .34539 m .71682 .34265 L .7236 .34813 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70212 .34539 m .68753 .34811 L .68046 .34262 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6659 .34536 m .68046 .34262 L .68753 .34811 L p
1 .034 0 r
F P
0 0 0 r
s
P
p
.002 w
.6659 .34536 m .65145 .34808 L .6441 .34259 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62968 .34533 m .6441 .34259 L .65145 .34808 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62968 .34533 m .61537 .34805 L .60773 .34257 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.59355 .35647 m .60773 .34257 L .61537 .34805 L p
1 .057 0 r
F P
0 0 0 r
s
P
p
.002 w
.71682 .34265 m .70212 .34539 L .69513 .33986 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68046 .34262 m .69513 .33986 L .70212 .34539 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68046 .34262 m .6659 .34536 L .65863 .33983 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6441 .34259 m .65863 .33983 L .6659 .34536 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.6441 .34259 m .62968 .34533 L .62212 .3398 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.60773 .34257 m .62212 .3398 L .62968 .34533 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69513 .33986 m .70993 .33708 L .71682 .34265 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.69513 .33986 m .68046 .34262 L .67328 .33705 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65863 .33983 m .67328 .33705 L .68046 .34262 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65863 .33983 m .6441 .34259 L .63662 .33702 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.62212 .3398 m .63662 .33702 L .6441 .34259 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70993 .33708 m .69513 .33986 L .68804 .33425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67328 .33705 m .68804 .33425 L .69513 .33986 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.67328 .33705 m .65863 .33983 L .65124 .33422 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.63662 .33702 m .65124 .33422 L .65863 .33983 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68804 .33425 m .70292 .33142 L .70993 .33708 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68804 .33425 m .67328 .33705 L .66598 .33139 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.65124 .33422 m .66598 .33139 L .67328 .33705 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.70292 .33142 m .68804 .33425 L .68083 .32854 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.66598 .33139 m .68083 .32854 L .68804 .33425 L p
1 0 0 r
F P
0 0 0 r
s
P
p
.002 w
.68083 .32854 m .69581 .32567 L .70292 .33142 L p
1 0 0 r
F P
0 0 0 r
s
P
p
P
p
p
.002 w
.07262 .19706 m
.69926 .02672 L
s
P
p
.002 w
.0749 .19643 m
.07446 .2031 L
s
P
[(0)] .07579 .18311 -0.06628 1 Mshowa
p
.002 w
.29207 .1374 m
.29183 .14408 L
s
P
[(20)] .29254 .12405 -0.03525 1 Mshowa
p
.002 w
.54188 .0695 m
.54188 .07618 L
s
P
[(40)] .54186 .05614 .00111 1 Mshowa
p
.001 w
.11604 .18525 m
.11579 .18925 L
s
P
p
.001 w
.15827 .17377 m
.15805 .17777 L
s
P
p
.001 w
.20166 .16198 m
.20146 .16598 L
s
P
p
.001 w
.24624 .14986 m
.24607 .15386 L
s
P
p
.001 w
.3392 .12459 m
.33908 .1286 L
s
P
p
.001 w
.38768 .11141 m
.38759 .11542 L
s
P
p
.001 w
.43758 .09785 m
.43752 .10186 L
s
P
p
.001 w
.48895 .08388 m
.48893 .08789 L
s
P
p
.001 w
.59641 .05467 m
.59645 .05868 L
s
P
p
.001 w
.65264 .03939 m
.65271 .0434 L
s
P
[(Indiv.)] .35928 .03957 -0.02584 1 Mshowa
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 268},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J000130P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?mK6U/10000oe/JF`40003oFaYK
0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000oe/JF`40001UF`03oe_o00=K00CoFe]K
0ol015_oFol4F`05oe]KFol0VU/10000IE/00omKo`03F`04oe]Ko`=K0_l00e_oF`02F`03oe_o09eK
0@0006EK00?oFol00e/01?mKFol4F`03oe_o00=K00?oFol0WE/10000IE/00omKo`03F`04oe]Ko`AK
00?oFol00e/00omKo`1EF`04oe]KF`Co@5/10000IE/00omKo`03F`04oe]Ko`AK00?oFol00e/00omK
o`0QF`04oe]KF`Co;5/01?mKFol4F`03oe]K03eK0@0006EK00CoFooo0U/01?mKFol3F`;o00EKoe]K
o`03F`03oe]K01iK00CoFe_o15/00omKF`0NF`?o15/6o`03FomK00=K00?oFe/0?E/10000IE/01?mK
oe/2o`AK0ol015_oFol2F`05oe]KFol075/6o`03FomK00=K00?oFe/06U/4o`9K00?oFe/00U/01OmK
Fe_o009K00?oFe/00U/00omKF`0mF`40001UF`03oe]K00]K00?oFe/08e/01OmKFe_o009K00?oFe/0
0U/00omKF`0GF`?o1e/2o`=K00CoFe_o0U/00omKF`02F`03oe]K03eK0@0006EK00?oFe/02e/00omK
o`0TF`04oe]Ko`9K00?oFe/00U/00omKF`0CF`Co2E/00omKo`04F`03oe_o009K00?oFe/00U/00omK
F`0mF`40002KF`03oe_o009K00?oFe/00U/00omKF`0?F`Co00=Koe/03E/01omKFe_oFol00U/00omK
F`02F`03oe]K03eK0@0009]K00?oFol00U/00omKF`02F`03oe]K00aK0olEF`04oe]KF`;o0U/00omK
F`02F`03oe]K03eK0@0009aK0_l2F`03oe]K009K00?oFe/025/4oaUK00GoFe]Ko`03F`Co@5/10000
WE/01?mKFe/4o`MK1?lNF`03oe]K04QK0@000:UK0ol2F`03oe]K01eK00?oFe/0B5/10000YE/4obIK
00?oFe/0Ae/10000XE/4ob]K00?oFe/0AU/10000WU/3oc1K00?oFe/0AE/10000VU/4o`9K00?oFe/0
;e/00omKF`14F`40002FF`Co1U/00omKF`0`F`03oe]K04=K0@0009=K0olnF`03oe]K049K0@0008mK
1Ol`F`8S3U/00omKF`06F`Co0e/4oc5K0@0008]K1?laF`LS3U/00omKF`04F`03oe]K009K00?oFol0
15/00omKF`0^F`40001KF`Ko0U/4ob5K0olbF`/S3U/00omKF`08F`03oe_o00AK00?oFe/0;U/10000
Fe/00omKF`04F`03oe]K009K00?oFe/06U/4oc5K42<>F`03oe]K00MK00?oFol015/00omKF`0^F`40
001LF`03oe]K00=K00?oFe/00U/00omKF`0FF`Co0U/00omKF`0]Fa@S3E/2o`=K00?oFe/00U/00omK
o`04F`03oe]K02iK0@0005eK0_l3F`03oe]K009K00?oFe/04e/3oc9K6B<>F`03oe]K00Go0U/00omK
F`02F`03oe]K02iK0@0005mK00CoFe_o15/00omKF`0?F`Co<U/27`lS00<OGal022<?F`03oe_o00IK
00?oFe/00U/00omKF`0^F`40001PF`03oe_o00AK00?oFe/02e/5oc5K0al015lOGal28`<O1R<00elO
G`047`PS3U/01?mKFol5F`03oe]K009K00?oFe/0;U/10000Fe/00omKF`02F`03oe_o00AK00?oFe/0
25/3obmK00HA5a4GGaL5G`065alG7aLO0Ul27`03GamO00DO00AO7elO2B<=F`03oe_o00Co0U/4oc5K
0@0005]K00?oFe/00U/00omKo`04F`03oe]K00AK1?l_F`03Wa4G00HG0Ul47`09GalA5a5O7elO00EO
00@OGamO0Ql;8`eK00?oFe/0>U/10000G5/4o`=K1?l3F`Co<5/2W`DA1AL00elGG`02G`;O1A4025lO
GelOGamO0Ql@8`eK00?oFe/0>E/10000Ie/3o`=K00?oFe/0:U/8W`@A00@G4ALA0Ul2g`BO00PA5a4G
GamO7`=O0QlA8`iK00?oFe/0>5/10000He/4oc1K00NOgmnOgioO00BO11425`?O00>Ogil00ml00ioO
4@034@9O00<G7aL011lA8`iK00?oFe/0=e/10000Ge/4oc5K0ml9W`03gioO008A0mh6g`08g]oNWmnO
4AL47`03GamO00<O00=O7b<042<=F`03oe]K03IK0@0005aK0ol2F`03oe]K02UK0mh01MoNgmkO00;N
0]l01]kOg]nOU@9a00CMLMea2=h2g`8G00DOGamO7`03G`8O00=O7el00al00elS8`058`8O22<=F`03
oe]K03IK0@0005QK1?l5F`03oe]K02IK0mh00moNg`02gP=a00COg]oN0]l00mbEg@04g@08LIFEUMia
gW42g`034ALG00<G00POGelOGamO7`=O0al00elOG`028`037elO00@O22<=F`03oe]K03EK0@0005AK
1?l_F`06UMgNLMia0]h2g@KN00[Og9FEg9GLUG7/0]`019GLUM`2gPHA0QL2G`075elGGaMO7`06G`04
7elOG`PO2B<=F`03oe]K00IK1?l3F`Co8e/10000:5/4obEK0ol00e_oF`0]F`03LIEa00?M0]h2g004
LMeag@9a0n`01]bEg9GLU@:f1>`2U@06gilA5a4G0Q425`IO00LOGaLOGamO00@O0Ul01amO7amO7el0
11l98`eK00?oFe/015/00omKF`02F`03oe_o00AK00?oFe/085/100009e/00omKF`02F`03oe]K01iK
1?l/F`0Bg>cLg=gLgIEa]kK/]nbgg>cL0]d03;Jg]]c/g>cLUKJg]P>g00G/g=iagP03g`8A1aL2G`03
4ALA00<G0Ul00aMO5`04G`037elO00LO2b<=F`03oe]K00=K00?oFe/00U/00omKo`04F`03oe]K00UK
1?l00e_oF`04o`9K00GoFe]Ko`03F`7o0E/100009e/00omKF`02F`03oe]K01YK1?l]F`07][Nfg>cL
k002U@06]kJg][Nf0[L2]@07o;Gl]KNf]@02o00C]_bfo;NfUMbEgIGMgW6OgaLA5`024@035ilA00DG
114011LA5a43G`8O00=O7el00Ul00amO8`068`8O22<=F`03oe]K009K00?oFe/00U/00omKo`04F`03
oe]K00QK00?oFe/00U/3o`AK00?oFol00e/00omKF`03F`40000WF`03oe]K009K00?oFe/05e/3o`03
FomK02]K00Vf]KNf]kJgk=`00_`4]P03]kJe00Fe00?l][D00[D00obeo002]P?L19D0177Mgml4W`8A
00?OWa401Q401IlG4ALA008G00LAGamO7elO009O0al00elOG`028`077elOGamO7`088`aK0_l3F`;o
0e/00omKo`04F`03oe]K00MK00?oFe/015/2o`IK00GoFe]Ko`05F`40000WF`03oe]K009K00?oFe/0
4e/4obiK00>e3KD00o`01[Jgo;Gl]@>f00>g][D02kD010fe]O`3g0FE00KLg]oNWml2W`GO00ZOgilA
WmlAWa6O0Q425`IO00<OGel015l021mO7elOGamO0al00elS8`068`eK00KoFe]Koe/3o`9K00?oFe/0
0U/00omKF`07F`03oe]K00AK1ol00e_oF`02F`03oe]K00=K0@0002MK00?oFe/00U/00omKF`0?F`Co
;5/02/`=3L`=c0fe3L053@07][G<3KD=]@023@06]L`=]@fe0`d2]PG/00KLg]kOg]l2gP0:gmkOg]oN
gmkOW`?O00>Ogil00il0116O5a445`037elO00TO00MO7elOGamO00<O00=O7el022<=F`04oe]Ko`IK
00?oFe/00U/00omKF`07F`04oe]KF`Go15/00omKo`03F`03oe]K00=K0@0002MK00?oFe/00U/00omK
F`0<F`?o00=Koe/0:U/01/`=c0g<3@;<00S0c<c0c<3<]@8=00G<3L`=c002]@033L`=00D=00Rfo;Jg
][OLk09a00?Og]l00]h00moNg`05gP?O00BOgioO0il2g`BO0Q425`IO0Ql00elOG`027`03GalO00IO
00<OGal011l88`aK00CoFe_o0e/00omKo`04F`03oe]K00MK00?oFe/01E/00omKF`02F`04oe_oo`9K
00?oFe/00e/100009e/00omKF`02F`03oe]K00QK1?l]F`03`<c<00C<00T=`<K0c<3<3L002<`00`g<
c0043@08c0gl]KKl]_`2]P03g9Ea00=a0]h01MoNgmkO00;N00?Og]l03ml2W`05GaMO5al00Ul00amO
G`02G`8O00=O5el00el02QmO7elOGamO7el:8`eK00?oFe/00ol3F`Co2U/00omKF`04F`03oe_o00?o
0U/01?mKool6F`40000XF`Co1e/4obiK0lH01Lc0c<`=00K600G0c<3<`002c0033L`=00C<10d01<be
]KD3o003]_bE00>E00KLUG5agW42gP03gmkN00;O00GNgmkOgP03g`04g]oOgPOO00>Ogil011L00elO
G`037`035a4G00=O1Ql015lO7el37`/S3E/00omKF`0DF`03oe]K009K00?oFe/045/10000<5/3o`9K
00?oFe/09e/4aP0E`<K6`<K0a/36`<K0a/36`<K0a/3<00;000G<3L`=c0023@Je00X=g>cLUMbEg9GM
1G42gP03LMkN00GN00>Eg=h00mh3g`03g]oO00CO00>Oga400a425`07gmjOgioO4@035`05GamO7el0
0Ql00elO7`037`07GamO7elOG`028`077elOGamO7`0<F`03oe]K01AK1?lCF`40000/F`Co;5/02hc6
S<J<aXc6`<K001361<02c0053Lbe3KD00Pd00kG/g004g004UMbEU@Aa0]h2L@CN00Aag]c/19D00mia
L@05gP03gmjO00:O00KOWmnO4G45gP04gilA4@@G1El011mO7el37`03GamO00<O00MO7amO7elO009O
00<OFe/02e/00omKF`0ZF`40000ZF`;o:e/00hc6aP05aP:<1<H00l36`002aP0>`<K0a/36`<K0a/36
`<H2`0?<10d01[Ff]kKLk0;L017/g9GLLIEagG7Lk=cMUMeagP06g00?UMcLgMcNLMkOg]nOgioO00:O
00COLG5a0mh01moNgioO5a400aL4G`037elO00MO00<OGel00Ul47`03GalO00@O35/00omKF`0ZF`40
000ZF`03oe]K02MK00V<C8c6S<J<aT`01X`01/J<a/36`0_60/`010g<3L`23@:e1;H4]`06g>cLk9GL
0[H01=c/g>`2g003][O/00S/00?Lk=`00YD00g7Og`05g`03g9FE00>E0]h01=oNgmh2g`03WalO00HO
0Ul011mO7el27`05GamO7el01Al8G`047elOG`aK00?oFe/0:E/10000:E/2obIK0d`4S006aTb<C8a<
1X`01lJ<a/36`<H00/002LK0a/0=c0g<3@03c0033KD=00>e00Cl]KKl1;H02=c/o;Gl][Nf0^`3o0>f
00Bgk=c/1]`7gP03g>cL00?L00>ELMh01Mh00moNG`07G`<G00<OGal00el02AmO7elOGamO5`04G`TO
00=O7el035/00omKF`06F`03oe]K00AK1?lGF`40000ZF`03PE]K01iK00==C4d014`00ha<C002C003
S4b<00=<00><C8`00T`3S006aXc6S<K00/H4`0;<0`d00kD=]@02]@083KFeo;Gl]KH33@0>]@fe]O`=
c;D=]@gl][L4]P;/0YD00miagP02L@03g^c/00G/00?LLG4017401miaGelOGal00Ul00alG5`044@8G
00<A5aL00aL01amO7elOGal00Ul00amO7`037`MO1Al<F`03oe]K00EK00?oFe/00e/00omKF`02F`03
oe]K01AK0@0002YK00>1Fe/075/3C@0CC4e<CDa=C4e<CDb<C4e<S4b<C004S00;C8a<aXc0a/36`<H0
0/000l`=3@033@04]@d=3@Fe00Kl3L`=]@d3]@<=00K03L0=]O`5]P09]ncLLMaag=ia00:g1]`00g7M
L@05L@8G00HOGamO7el24@045a4G4@8G00>O4A400a403aMO5elOGamO7elOGaMO5`02G`037elO00HO
00=O8b<00R<<F`03oe]K00EK00?oFe/00U/00omKF`02F`03oe]K01AK0@0002YK00>1Fe/06E/00da=
C004C09=00A<CDa=1T`014e<CD`4S004C8b<S0S600K<`<c<3L`23@03c0g<00>e00<=]@d00`d01<`=
3@d3c0053L`=3L`00[D3o0:g0n`00mc/g002U@?l0kL2k0?M1G434@<G0Ul01]nO4IlAW`8G00NOgioO
WaLA00<G15l01QmO7elOG`8O00AO7alO1El00amO7`037`@S35/00omKF`04F`03oe]K009K00?oFe/0
0U/00omKF`0DF`40000ZF`03PE]K01=K00I=ITeVCFH3C@05ITeVCFH02Td3C005S4b<C8`00lH01l36
`<36`<H01<001/c0c0g<3@;<00<=`<001/`00`g<c004c0083L0=]@fe3KD2]P0?k;O/]mbg]KKl]Obe
o;KL00FE00?MUA400Q400aLA5`025`05LMkOg]l00Yl02]iag]oNgioOWml4W`0;5a4GGamO7elOGal0
1Ul021mO7elOGamO2R<<F`;o1E/01OmKFe_o00AK00?oFe/055/10000:U/00h5KF`0AF`=V4Td014a=
C4d5C0:<00C6S<J<0/H00l36`004aP;000C6`<K00l`01L36`<c000;<0Pd01<`=c0d2c00B3L`=c0g<
3KD=o;Ff]kJgk;D=0[D01?beo?`6g005UMcOWml00a425`=a00CNLMoN0m`01=iag]h4g`05WmnOWml0
0Q445`067elOGamO0Ql5G`047elOG`hS2U/2o`IK00GoFe]Ko`04F`03oe]K01AK0@0002UK00>1Fe/0
35/00clP?`03@P0BCFI=ITeVCFI=ITeVCFI=ITeV0Td01da=C4e<S4`018`2aP:<1<H00l36S005S0;6
0d`01Xa<a/1<S0C600?<3L`01Pd02/2d]0fe3KJea/04c007]@fgk;OL]`03g0;O00BOgioO0Yl01=bE
LID3L@:e00Cl]_bf0^`2U@03g]oN00;O00>O5aL01AL01amO7elOGal01el47`03GamO008S00<OGb<0
2b<;F`03oe]K00AK00CoFe_o15/00omKF`0DF`40000YF`03PE]K00YK00L_8Rlo83m200A?0fH:C@03
C4e<009<00==C4`00d`00ha<C004C003S4c600B<00A<S4b<14`018a<S8`3C003aXc600;000G6`<K<
3@06c0>d00>e`<H01<023@03][Nf00Bg00K/g]kNgil2g`03WkO/00?L0]d33@>e0_`3g0>E0]h74@<G
00MO7elOGamO008O00AO7alO0Ul00amO7`027`03GamO00<O32<;F`03oe]K00AK00?oFol015/00omK
F`0DF`40000YF`03PE]K00EK00dO8QlR7b8Q8R4R8B0Q00920VH02TeVCFI=ITeVCFH:C@08C4e=CDa=
C8`3C@A<00R<CDe<CDa=C0==00E<CDa=C002S004aXc6S0;000H=c0g<3L`23@=<00B<C<K00Pd01;Gl
]O`2]PKN00?Og^`01>`01kOL3Lc03L000`d00l0=]P03]P;L1Il25`<A00dG4AMO5elOGamO7elO00EO
31l00elOG`0:8`037e]K00YK1ol2F`Co5e/10000:E/00h7oF`05F`077b8O8QlR7`028P09;b8PCd9?
@TeV00e=00A<CDa<0dd;C0A=2d`01De<C8a<00:<00O6S0g<3L`=00;<00<=C4d01D`3`003c0g<00:e
0iD01Miag]ia00?/01CLk=cL3L`=c0g<`<`=c0g<`<bf]`;N00?OWml00Yl01]nOga6O4@LG00POGamO
7elOG`8O2Ul00amO7`037`03GalS00@S00=O7al00Ql<F`03oe]K021K0@0001QK1_l2F`Co1E/2P@QK
00DO8QlR7`028P@P01Y?@VIVCFI=ITeVCFI=ITeVCFI=ITeVCFI=IPM=00UVCFI=ITeVCFH01Dd01/I<
aTc6C0:<0/`02`g<3L`=CDi=ITeV009=00=<CH`00X`02<K0o;GLk=c/0YD00obfk004k00Ec0g<3L`=
c0g<3L`=c0g<3MbEg9GL00?N1]l2W`DA00TGGamO7elOGal01Ul01QmOGelOG`<O00IO7elOGal3G`LO
00EO7elOG`0;F`03oe]K01mK0@0001QK00?oFe/015/00omKF`02F`03oe]K009K00B1Fh611e/0128O
8Ql38P098B1??dm>CDiV01I=00=<CDd03Dd3C005S<J<aX`00l03c0033Di>00A>0VH01DeVCDa=009<
00?<3L`00kD2k0<=0kH2k0;<00h=c0g<3L`=c0g<3L`=k0CL0YD3gP03gmkO00CO19l03A5O7elOGamO
7elOGal00Ul011mO7el37`=O11l3G`037elO008O1El011mO7al38`]K00?oFe/07U/100006E/00omK
F`03F`03oe]K009K00?oFe/00U/0185KFe/2P@MK00PR7b8O8R4R8@A?0dd08FI=ITeVCFI=ITeVCFI=
ITeVCFI=ITeVCFI=ITeVCFI=IP05C@=<00B<C8a<0/H00d9VIP03IP06CDi=CTe>0dd01/0=`0g03@?0
1<`23@03S<K000;01<`03@g<3L`=c;G/]nbgg>`00W44gP03gmkN00CN0]l25`0C7elOGamO7elOGamO
7elOGamO7`02G`04WaMO5`=O00LOGamO7elO009O00@OGamO0Ql88`037e]K00UK00?oFe/07U/10000
55/3o`=K0_l3F`03oe]K009K00?oFe/00U/00h5KF`03F`:125/011lR;bl38P03?dlo02E=00A<CDa=
0d`00ha<C`02C`=200=VCDh01Th01@g<3Lc000;<0lH02<3<`0g<C8a<0lH01<c0c<03c0053Lc0c<00
0[D00nbgg002g005LMiagmh00W401=iag]l2gP03gmhA008A00@OGaLG15l011lG5aL4G`037mnO00>O
0QL3W`06GamO7elO0Ul01QmOGelOG`DS00=O7el00al;F`03oe]K00IK1?l3F`Co35/1000075/01?mK
Fol4F`03oe]K009K00>1Fe/01E/2P@QK00@O8R8R0b43@P03CTe=00==01mVCFI2IT9VCFI=ITeVCFI=
ITeVCFI=ITeV@VI2CTe>009=00M??dloCcm?00IV00i>c0g<3L`=c0e<S4b<C0:<0dd6C004S<J<aP;0
00G<3L`=c0023@06`0fg][Nf0m`01^bEg9GLL@:E00MagW7Ngmia00BO0QL00ioO4@034@035eoN00GO
00>Og=`01=h2W`084AmO7elOGal4G`037elO008O00=O7el01al;F`03oe]K00AK00?oFe/00U/00omK
o`04F`03oe]K00UK0@0001eK00?oFol015/00omKF`02F`03PE]K00MK00>1Fe/01U/0228O8QlP8B0Q
0d82IP9?00LoCcm2CTlo00E=00HoCcm2CT82C@0??dm??dloCR0QCcm??dlo009>00M=ITeVCLc000G<
00Q<S4b<C8a<S09>00EVCFI<C@02CP06C4e<CDb<0/H02L`=c0g<3L`=c0023@04c0ff]P>g00O/g>bE
g>cL00>E0W400ncLgP02gP:O0md01mnOga4GLMd01Ml00nbgk003g09a0]l34@067elOGamO11l00elO
G`02G`037emO00EO0al;F`03oe]K00=K00?oFe/00U/00omKo`04F`03oe]K00UK0@0001QK00?oFe/0
0U/00omKo`04F`03oe]K009K00>1Fe/025/2P@MK00DO8QlR7`038@04@R4Q8@<o01Q?7b8O8Sm?ITdo
Ccm??dmV824P?dloCcl38P068B0oCfI>1FH6`0;<00U<CDb<C8a<CT8014h4IP03CTe>00A=00F<aX`=
c003aP03c0g<00D=00Be3KJf0[L3k0;L00Fg][O/]`02k008][Nf]nbggID2c0?/0W43aP033KD=00:g
00FEg=iagP02g`0<GamO7elOGamO7elO0el00amOG`02G`037elO008O00=O7el00al;F`03oe]K009K
00?oFe/00U/00omKo`04F`03oe]K00UK0@0001QK00?oFe/00U/00omKo`04F`03oe]K009K00>1Fe/0
2U/2P@MK01<O8QlR7b8O8R4R7b8O8QlR7b8O00<Q00hoCalR7b8O8R4R7b8O8P8O00<RCcl00d8044i2
C4b<aXc6c4iVCFI=ITd7@P07CTm?@Tm2C@02IP03CDi>009>00==CTh014d01l36`<`=c0d00/`23@07
o;Gl]KJe3@06]P0Da[D=]@ff]db<C8a<3LaVCDa=C4d3aP07]kJg]YGL4@045`0@GamO7elOGamO7elO
GamO7`9O11l7G`047elOG`YK0_l4F`Co0U/00omKF`02F`03oe]K00UK0@0001UK1?l3F`Co1E/00h5K
F`0<F`:11e/0;X4R7b8O8QlR7b8O8QlR7b8O8R4R7b8O8QlR7b8O8QlR7b8oCcm??dm2CDa=S4`3S092
0fH00di=8002800:Cd92ITloCcm??`A20fH02Di=IVI>CDi<C@03C0;61L`33@04o;D=3@Be00SlC<K6
`<H=]@I<00B<Ccm?0fH2C003CFK000;00[H2W`<A011O5elOGamO7elOGamO7elO2Ul00amO7`027`=O
00<OGal02e/01?mKFol4F`03oe_o00AK00?oFe/02E/10000:5/00on1F`0?F`:11E/07H5KFb8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O00<Q13l01fI>ITeVCD`00cl014loCdl6;`05?b0o83l014l01B0o
83lP00I200=>@VH00fH3C0:<00C6S0g<0`d01Da=C<36008=0m8014b<C8`3@P07CFI=C4e??`07C`=2
00U=I^cLgmkOWml00aL3G`047elA5`AO00<O5a400aL2G`054AMO7el00al00elO7`047`03GalO008O
2U/01?mKFol4F`03oe_o00AK00?oFe/02E/10000:E/00h5KF`0@F`:10e/00h5KF`02F`0B8QlR7b8O
8QlR7b8O8QlR7b8O0b800b4R8@028@0<Cb12IT9VCB1?84lP0Tl03B8Q8R4R8B8Q8R4R8B801b0013lP
;b43?`04@Tm2C`=200Y>ITi2CDa=C<IV0Td00da=C002C005@Te>CDh00]85C`03@Tlo00Ho0R04?`0:
Cl`=][Ff]N`G4@@G00=O5il01A400aNO4@034@035a7O00BO0aL015lOGal4G`LO12<:F`03oe_o00AK
00?oFol015/00omKF`09F`40000XF`03PE]K01=K0X400e^1F`04F`0A7b8O8QlR7b8O8QlR7b8O8Ql0
0R800alR;`048003?b1200@o00PP?b0R7b8_8Pd_00@Q83lP1Rl4?`E?00=2Cdh00Th02De<@T9VCFI=
C005@P9>00E??clP?`02C`<Q0Sl00dlo800280<o00U?aXc6c0g<]_`00Q400aLA5`025`:O00GOWmlA
W`02g`07WmnO5a6Og`03W`04ginOW`<A1El37`AO00<OGal00R<00amOF`09F`03oe_o00?o0e/4o`aK
0@0002QK00>1Fe/05E/2P@IK018R7b8O8QlR7b8O8QlR7b8O8Ql48P8Q00<_8B000R008clR7b8O8QlR
8B8Q8R4R8B8Q8R4R8B8Q8R4R8B8Q8R4R8B0Q00=?00A2Cd9?0T83?`07Ccm2@R0Q8004C`<P13l02R8Q
8R4_8B0Q;b838@098252@Ti=CTc600:E0ml00aLAgP02gP03gmkO00;O00?Ngmh02Ml029oLk=cNLMkO
0a4015lGGal6G`037emO008O00=O7al00Ql00emKF`08F`03oe]K01EK0@0002QK00>1Fe/05E/0185K
PH46F`0B8QlR7b8O8QlR7b8O8QlR7b8O0R802QlR8AlR7b8O8Ql68P06;b8R8RlR0Rl48P03;b8_00H_
1243?`9?0b0013lP?cl28P<Q0R000b8O8@028@05?b0O8Ql00R86;`068Bl_?dlo14l3]P:g0YD3]`>E
00Aa]nbg0md01=iagG45gP8=00>f]kH00m`4gP0>5a4GGaMO5amO4ALA5a42G`045amO7`9O0Ql;F`03
oe]K01AK0@0002QK00>1Fe/05E/01H5KFe^100QK01LO8QlR7b8O8QlR7b8O8QlR7b8O8QlR7`0=8P03
7b8R00LR00`Q8R4R8B8Q8R4R8B858@0681lR7b8O0b8051lR7b8O8QlR7b8O8QlR8B8Q8R4R0R45?`0G
Cl0=c0g<]KK<]@fe3KO/C;Gl]Oc/]l`01;L01g6Ea/3<`<`00Pd01L2f]KJe00>E00COgQ4A11L01enO
Wa4G4AL00a435`077elO7elOG`0;F`03oe]K01=K0@0002QK00>1Fe/05E/00h5KF`02F`:125/05QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b827`048QlR7`@R00@O8QlR0Ql28P8O00@R7b8_0b801RlR8B4_8P<_
0R405AlR7b8O8QlR7b8O8QlR7b8O8QlR7`028PD_1b02C005a/36c0d00/001@g<3KD=009200=<S4`0
0[D01Db<3L`=00:g0T`3S0;000=<S<H00/H2]P;O0il00aLAW`02W`054InOWml01Il00a4G5`037`9O
1B<;F`03oe]K019K0@0002QK00>1Fe/05E/00h5KF`04F`:125/05alR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O00<R00lO8QlR7b8O8QlR7b8O8Ql01B800alR8P038P0L7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8P@Q01dP8B0oCcmV@VI<CDa=C8a<aR0Q824P8DloCcm=IP02S0=?00AV@Te=0fH2C0:<00FELG7N
L@02g`03g>cN00;N0]l01g7NgmkOWml00a4011LAGaL2G`037elO008S0Ql00elOG`0OF`40000XF`03
PE]K01EK00>1Fe/01U/2P@QK04`O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8BlQ0Rl00b4P80048004?dloC`=>0Td<808o
0R06?`04Ccm??`9V0[D03]bEg74=c0fe3KGL`<K00[L01G7Ng]oN00:O00HG4ALG7el37`03GalO00<O
00IO7alOGalNF`40000XF`03POmK01EK00>1Fe/025/2P@QK01hO8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b827`048QlR7`8R01/O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8Ql00b80124R8B838@04
824P8@<_00HP8B0o824280058B0Q8B000R403b0Q824P8B0Q824P8B0Q8002?`9?00==C4d00Pd02Ha<
c<3<3La2C`03C@;000NEgG7NLMkO00DA0aL4G`037emO00EO0Ql00elOG`0MF`40000XF`03PE]K01EK
00>1Fe/02U/2P@MK00Z17b8O8QlR7b8O1B802AlR7b8O8QlR7`028P067b8O8QlR0b<07B8O7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O008R0Rl38@8P0Rl58@8R00HQ8R4P8B858@05824Q82403R003Sm?
?dmVCFJ<C20o83lP0T801KKLUMbE009a00cOWmnOga6O4ALA5a435`087elO7elOGal2G`057elO7el0
0R<LF`40000XF`03PE]K01EK00>1Fe/035/2P@EK00B1FalR0al01B8O8QlR00<O00<R7b800al01R8O
8QlR7`LS0al08b8O7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8R4R828Q008R00l_8RlO8QlR7b8Q
8QlR8B800Rl01AlR8BlQ00DP00dQ824P8B0Q824P8B0Q00<o00EV824P8@03808=0kL01iGLg]kOWml0
0il01=nOWil24@06GamO7elO1Ul00amO7`078a]K0@0002QK00>1Fe/05E/00h5KF`0>F`:10e/00h5K
F`028P067b8R7b8O0b<00b8O8P028P8O00<R7b802R<00b8O8P028P0M7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8Ql00R80624_8QlR7b8O8QlR7b8O8QlR7b8O8QlR7`8R00<Q8R002208o`DP00W<3L`=
c0gMUMd00W401=oNg9D3gP04gilG5`AO00DOGalOG`037`9O00<OGal00Ql015lO7al48aYK0@0002QK
00>1Fe/05E/00h5KF`0@F`:100=KPE/00e/00alS8`0:8`037b<S00`S11l28P0i7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O00<_00DQ82l_8003o`<S
00?o8b<00R<00ol=3@033@07LMaaUG6EL@02]P?/00BEgioO0Yl25`077elOGamO7`02G`037elO008O
0el00amO7`027`03GamO00@S6E/10000:5/00h5KF`0EF`03PE]K019K0X45Fa/S00@O8R8O0R80>AlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7`08o`<S
0_l28`;o0b<01?nek;L2U@05]@fe3KD00[H00g7Ng`02g`03WmlG008G0el01AmOGamO00/O1El47`8S
6U/10000:5/00h5KF`0EF`03PE]K01=K0X46Fa/S00<R7b800Ql0=B8O8QlR7b8O8QlR7b8O8QlR7b8O
8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR00?o0b<00olS8`028`;o0R<00olS8`028`;o
0R<02?m<a/363IGL0YD01G7NgQ4G00@A00PG4IlA5a5O7`MO00<OGel015l57b1K0@0002MK00>1Fe/0
5U/00h5KF`0CF`04PE^1P@IK5R<01B8O7b8O008R03<O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b8O8Ql00ol38`;o0R<2o`<S0ol00b?oo`048`;o00<Sool00kL2g0;O
0Yl24@:O00?OWml00Q42W`0<4ALAGamO7elOGamO0Ql015lOGel>F`B14e/100009e/00h5KF`0FF`03
PE]K01=K00B1Fe]K0X46Fa@S00<O8Ql00R80=AlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7b;o00<O0_l00elOo`048`;o00LOoamO7elO00;o0R<01_lS8olSo`=a
00KOWmnOgil5g`04WmoOg`:O00/A5a5O7elOGamO7`0?F`F15e/100009e/00h5KF`0FF`03PE]K019K
00>1Fe/015/2P@IK3R<01B8O8R8O008R03/O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O8QlR7b8O8QlR7b8O8QlR7olOGamOo`047`;o0Ul01OmO7eoo00<O00?o7ol00b<2o`<S00?og]l0
0ml2L@07gmkOg]nOg`02W`09gilA4AmO7elO00iK1X4LF`40000WF`03POmK01IK00>1Fe/04U/00h5K
F`06F`:11U/=8`@O034R7alR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR
7b8O00D_00[o7aoo5alGoelO0_l015lOGol37`07oelOoamO7`02o`<S0_l28`04omcLL@CN1]l3W`8G
0U/00h5KF`09F`J18U/100009e/00h5KF`0FF`03PE]K019K00>1Fe/025/2P@IK32<01B8O7b8O008R
02PO8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR7b8O8QlR1b43800<oaooGamO7olOoeoo
15l01_lOGolOo`<O0R<2o`<S00Co8b<S0_l3U@05LIoOgil00]l00imKF`05F`03PE]K00AK1H4XF`40
000WF`03PE]K01IK00>1Fe/04U/00h5KF`0:F`:115/00h4S8`098`<O0R802QlR7b8O8QlR7b827`04
8QlR7`8R00DO8QlR7`028P0?7b8R7b8O8QlR7b8O8R4R00H_00<P8B000R000omOG`02o`0=5alG7omO
7eoo7elOo`037`04oalS8`;o0b<2o`8S0_l38`05omoNgil03E/7PBeK0@0002MK00>1Fe/05U/00h5K
F`0BF`03PE]K00aK0X42F`03PE]K009K2B<27`038QlO00@R0Ql01B8O8QlR00<S00<R7al00R800alR
7`048P0=7b8O8QlR7b8O8B8Q8P048@068QlR8R7o0Ql00olO7`02o`075a5O7elOo`03G`06oamOoaoo
0b<2o`<S00Co8b<S0_l38`03oe]K00YK1H4cF`40000WF`03PE]K01IK00>1Fe/04U/00h5KF`0>F`>1
1E/98`8O1B<00alS8`098`8O0R<37`8R00@O8QlR0Ql0428O7b8O8QlR7b8O8QlR8B83o`05GomOGml0
11402OmO7eoo7elOG`02o`<O0_l38`;o0R<2o`<S0_l28`03oe]K00=K1X44F`03PE]K035K0@0002MK
00>1Fe/05E/00h5KF`0CF`03PE]K011K0X46FadS00<R7b800b827`038QlR00<R00hO8R8R7b8O8QlR
7b4Po`<G00?o7ol00Yl02OlA5a4GoelOo`04G`07oamOoelOG`02o`037olO00<O0_l48`;o00<Sool0
0h4;F`03PE]K031K0@0002MK00>1Fe/05E/00h5KF`0CF`03PE]K011K00>1Fh401e/F8`0=7b8O8QlR
7b8O8QlR7`058`DO0R800al_;`02;`068OmO5elG0_l3g`03oa4A008A00Oo7eoo7elO00;o00DOoelO
G`02o`<O00?o7ol00al2o`8S00Ko8b?o8ol=F`03PE]K031K0@0002MK00>1Fe/05E/00h5KF`0CF`03
PE]K011K00>1Fe/00X47Fa8S00XR7b8R7b8O8QlR2b<00alR8P028P048B8Q80?o11L00omOW`03W`0<
oa4G4AOoGamOoeoo0Ul02_mO7eoo7omO7el2o`8O12<2o`038ooo00<S00?oFe/02U/00h5KF`0`F`40
000WF`03PE]K01EK00>1Fe/04e/00h5KF`0@F`03PE]K009K0X46Fa<S0al=8`0:7b8O8QlR7b8O8@;o
00PA5olGGaOo5`GO00?o4A400Q401?lOGal2o`0:7emOGomOoelOG`?o00@O8b<S0_l00elOo`028`04
ob?oo`8S00?oFe/02E/00h5KF`0`F`40000WF`03PE]K01EK00>1Fe/04e/00h5KF`0@F`03PE]K00AK
0X46FalS00LR7b8R7b8O00<S00<R7ol011L01?lG5ol2g`0@oinOWolA5a4GoelOGomOo`@O00Go7elO
G`02o`06Gaoooeoo11l2o`<S0ol00b?oF`09F`03PE]K031K0@0002IK00?oPE/05U/00h5KF`0CF`03
PE]K011K00>1Fe/01U/2P@EK7b<00alS8`078`08oa7o4ALAoel2o`03Wmoo00?O00?o4A400a400omO
o`03G`07oemOGomOo`037`0=oamOoelOGomO7olOG`02o`<S0_l00b?oo`08F`03PE]K031K0@0002MK
00>1Fe/05E/00h5KF`0CF`03PE]K011K00>1Fe/025/2P@AK00>18b<092<012;o4Ol45`03omoo00;O
00?oWil00Yl01OlG4ALA00Co00=O7ol00Ql04olOGaooGolOGamOoelOoaoo7el00Ql2o`8S00Ko8b?o
8ol7F`03PE]K031K0@0002IK00>1Fe/05U/00h5KF`0CF`03PE]K011K00>1Fe/02U/2P@9K00B1Fe]K
8R<00e_o4@024@0:oaLA5ooOoioOW`CO00?o4A400Q400olGo`03G`03oeoo00AO00Ko7ooo7el6o`04
7olOG`<S0_l00b?oo`038`03oe]K00AK00>1Fe/0<5/100009U/00h5KF`0FF`03PE]K01=K00>1Fe/0
45/00h5KF`0<F`>11E/K8`IK00GoWa6Oo`025`03omoO00CO013oWinOoaLA5a7oGolOGamO0_l01ElO
GamO00Go0Ul01OmOoeoo008O0_l37`?o00DSoomOo`06F`03PE]K031K0@0002IK00>1Fe/05U/00h5K
F`0CF`03PE]K00mK00>1Fe/03e/2P@EK5R<7F`?o11401?lGool3g`04WmnOo`?O00?o4A400Q401OlG
5omO00?o00DOGooo7`02o`9O00GoGamO7`03o`077eoooamO7`02o`0:GamOoelOGomKo`=K00>1Fe/0
<5/100009U/00h5KF`0FF`03PE]K01=K00>1Fe/03e/00h5KF`0?F`03PE^100IK3B<9F`Go19l2o`05
Wa7og_l00ml01?oOgol3W`08oaLA5olGGaL2o`07GolO7omO7`02o`@O01[oGeooGaoo7olOGolOoelO
oelOGomO7omOo`=K00>1Fe/0<5/100009U/00h5KF`0FF`03PE]K01=K00>1Fe/03e/00h5KF`0?F`03
PE]K00:11E/78`iK00KogioOWml2o`:O00?o4Ol00]h02?oOgmoogioo0ml01OlA4A7o00<G00Co7eoo
0el2o`035eoo00=O00Co7olO0_l01aooGamO7ol00al00olOG`06o`057oooFh40<U/100009U/00h5K
F`0FF`03PE]K01=K00>1Fe/03e/00h5KF`0?F`03PE]K009K0X44F`03PE]K00]K1H401?nOoil2o`07
WonOgioOo`03gP05omoOgol00]l04?nOWioo5a4GoaMOoamO7ol37`03oemO009O1Ol27`07oalOoelO
G`02o`047eooG`;o0Ul01OmOoaoo008O00?oPE/0<E/100009U/00h5KF`0FF`03PE]K01=K00>1Fe/0
3e/00h5KF`0?F`03PE]K00AK0X42F`03PE]K00EK1X44F`0:oioOWonOgioOo`:O0_l3gP08omoOgooO
Wol3g`05oa4A4Ol00QL2o`037eoo00=O00OoGaMO5omO00;o0el01omOGeoo7ol00Ul2o`<O0ol02Aoo
7olOGolSo`0bF`40000MF`Co1E/2PAMK00>1Fe/04e/00h5KF`0?F`03PE]K00mK00>1Fe/01U/3P@9K
1H4:F`05oinOWol019l01OoOog7o00?N00GogmoOo`02g`08oinOWolG4AL3o`055omO7ol00Ql2o`=O
00KoGomO7ol37`03oaoo00;o0Ql00olO7`02o`=O0_l00eoo7`028`;o00<Sool0<5/1000075/00omK
F`02F`03oe]K009K00>1Fh400X4DF`03PE]K01=K00>1Fe/03e/00h5KF`0?F`03PE]K00QK0h4=F`;o
00?OWml00_l02IoOWmnOomeao`03gP08omoOgooNWol3g`05oa4AoaL00_l01AOo7elO00;o00HA5olG
Gol4G`03oemO00?o00EO7omOo`04G`;o0al2o`038ooo008S0ol00b?oF`0^F`40000LF`03oe]K009K
00?oFe/00U/00h5KF`02F`:14U/00h5KF`0CF`03PE]K00mK00>1Fe/03e/00h5KF`08F`03PE]K00]K
0_l00mooW`02W`03omoo00BO00AagG7o1=h01?oOgol2g`07oinOWolG4@03o`8G00CoGamO0_l00a4G
o`02G`03oemO00;o00IOoomO7el2o`047oooo`8O00?oGel00_l27`;o00<Sool00b<2o`038omK02eK
0@0001aK00?oFe/00U/00omKF`02F`03PE]K00AK0h4?F`03PE]K01=K00>1Fe/03e/00h5KF`0?F`03
PE]K00QK00>1Fe/02U/04ooOg]oNoioOomoogioOog7MLOl01=h02?oOgooOWmoo0]l00olA4@02o`<G
00?o7ol00_l02QLA5olGoaoo5el2o`067oooGamO0_l03AMOoeoo7eooGamOoel00_l00b?oo`038`;o
00<Sool0;5/1000075/00omKF`02F`03oe]K009K00>1Fe/01e/2P@eK00>1Fe/04e/00h5KF`0?F`03
PE]K00mK00>1Fe/025/00h5KF`0:F`03omoO00;O00?oWol00]l02OnOWooMLMeao`04gP04omoOo`?O
00KoWioo5a42o`<G0_l00ioOo`024@035omO00;o0aL01OmOoomO00;o00<OGal00_l02AoooomO7olO
o`027`05Gaooob<00_l00eoo7`037`03oe]K02UK0@0001aK00?oFe/00U/00omKF`02F`03PE]K00UK
0X4;F`03PE]K019K00>1Fe/045/00h5KF`0?F`03PE]K00QK00>1Fe/02E/2o`0BgmkOg_nOomkOomnO
og7ogG7o1=h02?oOgmooWmoo0ml2o`044OlG5`;o00COWmnO0_l02aOo5olGGaOo5elO00;o00IOoomO
oal2o`037olO00<O0_l01AmO7eoo008O00[o7aooGaoo7eoo:U/1000075/00omKF`02F`03oe]K009K
00>1Fe/02e/3P@MK00>1Fe/04e/00h5KF`0@F`03PE]K00mK00>1Fe/025/00h5KF`08F`04omkNo`CO
0_l3g`;o0]d01?oMLOl4gP04omoOg`;o00?Ooil00Yl2o`0>Wa7oomkogioOWolA5a42o`<G00KoGomO
7el2o`037ooo009O0_l02UoooaooGomO7el2o`9O00Co7elO0_l27`03ob?o02UK0@0001aK00?oFe/0
0U/01OmKFe^1015K0X45F`03PE]K01=K00>1Fe/045/00h5KF`0?F`03PE]K00QK00>1Fe/00U/6o`07
g]oNomkOgP02o`0<gmkOg_maUG7ogG7o1=h01?oOgml2o`03gooO00;O0_l24@09omoNomnOgioO00Co
00HAoeooGal2o`06GomOGamO0_l00amO7`02o`0:7omO7olOGomOo`8O00Co7alO0_l01QooGamOobQK
0@0001eK1?l4F`03PE]K015K0h42F`03PE]K01=K00>1Fe/045/00h5KF`0?F`03PE]K00IK1ol01]ko
gmkOo`?N00Kogmoog_l3g`03omgM00;M00GogG7Mo`03gP05omoOgol00]l01?nOWil2o`03WooN00;N
00OogioOWmoo008G00Ko4OlGoaL2o`04GolOo`9O00LOoemOoeoo008O00OoGemOoaoo008O00GoGeoo
G`02o`03GamO00;o00@OGooo9U/100009E/00h5KF`0DF`>15E/00h5KF`0@F`03PE]K00iK00>1Fe/0
1E/2o`09UG7MUMgNLMko00CN00CogmkO0_l04=oNgooNombELIEaomeagOl3gP08omoOgonOgol3g`?o
00gNomoNgonOgioOoaOo00<A00Co5elO0_l015ooGol3G`;o0Ul01omOGeoo7el00_l3G`03oalO00;o
00@OGolO0_l27`04oelOobEK0@0002EK00>1oe/05U/3PA=K00>1Fe/045/00h5KF`0>F`03PE]K00EK
00AaUG6E0md02OoNg]kog]oNo`03gP0:omkOg]oNoiGLo`?M00GogG7Mo`03gP05omoOgol00]l01?nO
Wil2o`03LMko00?N00KoWmnOoa42o`045a7o5`;o00UO7eoo7elOoal00_l01UlOGaoo7`Go11l4o`03
7eoo00;o00AOoeoo0al00omKF`0SF`40000UF`03PE]K01IK00>1Fe/00X4AF`03PE]K011K00>1Fe/0
3U/00h5KF`04F`0=oiEaUG7oUMgoLMiao`03gP03omoN00;o017NgmkOombEg?maUG6EgG7Mo`03gP08
omoOgonOgol3g`0<omkNg_oOg]ooWmnO0ol00ioo4@03o`05Gooo7el00_l01UoooelGG`;o00IOoomO
7el2o`047oooo`@O0_l025lOoolOoaoo0al2ob=K0@0002EK00>1Fe/05U/00h5KF`02F`>13U/00h5K
F`0@F`03PE]K00iK00>1Fe/015/2o`04UG6Eo`;M00Wog]kNomkOg]l00_l2L@09omoNoiGLUMco00CM
00CoLMgo0mh02?oOgmoogmko0il01OoNLMko00?N00WoWmnOoioOoml00_l4G`;o19l00olG5`025`?o
00`OoomO7eoo7olOGol2G`;o0Ul01?mOGol2G`07oelOGolOo`0RF`40000UF`03PE]K01IK00>1Fe/0
1E/2P@aK00>1Fe/045/00h5KF`0>F`03PE]K00=K00kogOmaUG7oUMgoLMiao`?N0_l3gP04omooU@;L
00^Eg?maUG6Eog7Mo`03gP0=omoOgonOgioogomao`02gP08omoNgonOgol3W`0<oioo5olOGooOWmoo
0Yl02?lGGaOoWolG0_l01UoooamOo`=O00?o7ol00Ul2o`047elOo`8O00?o7al00ol00b?oF`0PF`40
000UF`03PE]K01IK00>1Fe/01e/2P@YK00>1Fe/045/00h5KF`0>F`03PE]K00=K00OoUOnELIGo00;M
00?og]h00]h3o`03gOma00=a00SoUMbEoiGLo`CM00CoLMgo0mh01OoOgmoo00?O00SoWooNog7No`?N
00?oWml00_l019oOoml25`08oeoogioOWol3W`08oaLGoioo4Al2o`06Gooo7elO0_l01Aoo7elO00;o
0el01?mOGel4o`03Gaoo025K0@0002EK00>1Fe/05U/00h5KF`09F`>11e/00h5KF`0@F`03PE]K00iK
00>1Fe/00U/04?oLgOmaUG7oUMfEomiag_l3g@03omkN00;N013og9GLoiGLUOnELIGoLMgo1=h01ooO
gonOgil00_l2L@0:omkNg_oNgonOg`;o00JOoinOGaL2o`;O00CoWmoo0il02OmO5onOoaOo7`02o`03
GamO00;o00<Oool00el01_mOGomO7`Ko00=Ooal00Ql4oaeK0@0002EK00>1Fe/05U/00h5KF`0<F`:1
1E/00h5KF`0@F`03PE]K00iK00>1Fe/00U/02?nEUOnELIGo0md02_oNg]kogG7MLOl2L@;o00REg9Go
UMbEo`?M00CoLMgo1=h01?oOgol3g`;o0mh0177NLOl2gP03oioO00;o00JOoioo5ol4g`04omnOo`>O
00?o5ol00Yl00olAG`02o`05Gooo5ol00el01?mO7el7o`=O00KoGemOoal2o`04GolSoaaK0@0002EK
00>1Fe/05U/00h5KF`0>F`>10U/00h5KF`0@F`03PE]K00iK00>1Fe/00U/04?oLgMcoUG7oUMfEomia
g_l4g@03omkN00;o00oLUMcoUMbEoiEaUOmagOl01=h00ooOg`06o`=a0mh03OoNgonOomooWonO4Ol0
0]h3g`04oioOo`>O00?oGol00Yl01olGGolG4Ol00QL01OmOGolG00;o00IO7eooGol2G`;o00EOoamO
7`02o`077omOoelOo`0KF`40000UF`03PE]K01IK00>1Fe/04E/3PA9K00>1Fe/03U/0185KFe/2o`>E
00CoLIGo0md02_oNg]kogG7MLOl2L@;o00REg9GLUMbEo`?M00CoLMgo1=h00ooOg`02o`;O0_l3gP04
omiao`?N0_l01iooWolA5ol00]l02?oOgooOWmoo0il2o`04WolAG`;o00<A5ol00aL2o`034AOo00=O
00OoGolOGaoo00=O00OoGoooGamO00;o00<Oool06e/100009E/00h5KF`0FF`03PE]K01=K0h4@F`03
PE]K00iK00B1Fe]K0_l04=cMg?nELOnEgIGogW7og?l3g@0Domkog?oLUMbEombEoiEaUOoNgOl4gP04
omoog`Go0g401ooNg_oNgmh00_l00mnOo`024@;o0]h02?oOgmnOgioo0il03?nOWolAoa7o5a4Go`8G
0_l25`;o00=Ooel00Ul2o`054OlOGal00_l00elOG`02o`037ooo008O0olHF`40000TF`03oh5K01MK
00>1Fe/04e/00h5KF`02P@iK00>1Fe/03U/0185KFe/2o`>E00CoLIGo0md05_oNg_oLog7MLOmaonco
UMbEg?oLUOl3g@04omkMo`CN0_l00moNo`04U@07omkNomiao`03gPGo00@G4Ooo0]l02?oOgmooWmoo
0il03OnOWolAoa7o4ALAoaL00_l00aLAo`024@09oaOooa4G4AOo00=O0ol011ooGal2o`04GamOo`8S
00?oFh40184AF`40000UF`03PE]K01IK00>1Fe/04e/00h5KF`02F`>12e/00h5KF`0>F`04PE]KF`;o
013LgMcoUG7oUMfEomiaomco1=d2o`0Ag?ooUMbEombEoiEaUOoNgOl01=h2o`08goooUG6ELOl2L@07
omkNomkOgP02o`03gioo008A0_l2gP08omoOgooOWol3W`04oinOo`@A00?o4AL00_l01Ioo5aOo008G
00eO5olA5olG4OlOGolG00;o00UOoaooGomO7el00_l28`03oe]K01AK0@0002AK00>1Fe/05e/00h5K
F`0CF`03PE]K00EK0X49F`03PE]K00iK00N1Fe]Komco00:E00GoLIEao`02g@0;omkNomcoLMeagOl0
0n`02?oLUMcog9Go0md01?magOl4gP?o00?LoiD00iD01ooNg_oNLOl00mh02OoOWmoo5ooMo`06g`04
oioOo`:O0_l2W`07oa4G4AOo5`02o`0:gioOoa7o4OmOo`<A00Co4ALA0_l00aOoo`037`04oaoo7`;o
0al2o`038omK01AK0@0002AK00>1Fe/05e/00h5KF`0CF`03PE]K00MK0h46F`03PE]K00iK01J1Fe_o
k=cogMcoUG6EomfEomiaomco1=d04oo/g>coUMbEombEoiEaUOmagOl01=h2o`;L00KoUG6ELOl2L@0<
omkNomkOg_nOgioO0_l00g7ogP02gP07omoOomnOo`02W`;o0Yl2o`<A0_l01=ooWil3o`8G0_l029oo
4AOo5a4G0_l011Oo5el2o`03GolO00?o00=O7ol06E/1000095/00h5KF`0GF`03PE]K01=K00>1Fe/0
2U/2P@AK00>1Fe/03U/01h5KFoo/g?l00YD01OmaUG7o00;M00?og_l00]`01_magG7Mo`?/00Sog9GL
ombEo`?M00CoLMgo0mh00ooLo`02g003oiFE00:E00Oog]kogW7o00;N0_l01=nOgil2o`03gOoO00;O
00OogmooWmoo00:O00SoLOnOoioo4@;o0Yl01?oOWml5o`:O00Oo4A4AoaLA00;o00@Goooo0el3o`04
7eoooaYK0@0002AK00>1Fe/05e/00h5KF`0CF`03PE]K00aK0X42F`03PE]K00iK01J1Fe_ok=cogMco
UG6EomfEomkok=co0md2o`0Bk=c/oiGLUOoLUOnELIGoLMgo0mh00oo/o`02g006oiEaUG7o0W403OoN
g_oNgooMomnOgol00g401?oNg_l2g`04omnOo`:O00Kog_nOoil2o`03WmoO00;O00CoWinO0_l00moo
W`02W`06oaLAoa7o0Q401_mOGeoo7`;o00<Oool00_lKF`4000000e_oF`04F`04oe]KF`;o00=Koe/0
55/00h5KF`0GF`03PE]K01=K00>1Fe/03U/3PA1K00N1Fe_ok=co00:E00GoLIEao`03g@;o0m`01OoM
okOo00?/00Sog9GLombEo`?M00CoLG7o0mh00ooLo`02g003oiFE00:E00Oog]kNog7o00;N00_ogOnO
giooLMeao`02g`07omoOoioOo`02W`0:og7oWonOomnOo`>O00?oWml00_l00ilAo`03W`03oa4A00;o
00HAWalOoal3ob9K0@000003FomK00AK00GoFe]Ko`0HF`03PE]K01IK00>1Fe/055/00h5KF`0@F`>1
3U/04H5KFoo/g?oMg?nELIGogIGM00;o01_/g>cogOnfoncLk?nEg9Gog9GoUG6Eog7oLOl00]h00oo/
g003g005og6ELOl00g403?oNomkOomgogioOo`=a00Cog]ko0]l01_oOWonOo`;N00?oWol00_l01=nO
gol2g`03oinO00;o00@Aga7o0Yl=ob=K0@000003FomK00AK00GoFe]Ko`0HF`03PE]K01IK00>1Fe/0
55/00h5KF`0@F`03PE]K00>12e/01h5Komc/g?l00YD01OmaUG7o00?M0_l3g0;o00>f]ol00n`02?oL
UMcog9Go0md02_maUG7og_o/g>`3g005oiFEUOl00mh00omao`02gP05omgoWml00_l0177MLOl2g`09
omoOoioOoioo009a00WoWooogonOgol00Yl01?nOool2W`034Ioo00:O00?ogol00ol01Uoo7elOobAK
0@000003FomK00AK00GoFe]Ko`0HF`03PE]K01IK00>1Fe/055/00h5KF`0@F`03PE]K00=K0X49F`0d
PE_og>cLomgLoiEaUOoMUMgog>cLk?nf]kKok=c/oiGLUOoLUOnELIEaomeaomkog>cLo`;L00GoLIEa
o`03L@03omkN00?o00CMomnO0_l3L@04omkNo`;O00CogioO0_l2gP?o0]l01?nOgol2g`09oiooomoo
ga7o00:O00?ogol00_l00eooF`0XF`4000000e_oo`05o`=K00?oFe/05U/00h7oF`0FF`03PE]K01AK
00>1Fe/045/00h5KF`05F`>11U/01h5Komc/g?l00YD01OmaUG7o00?M00?og=`00]`01_ng][Nfo`;/
00Wog9GLombEg?l00md02_oMLOoNoncLk?l2g005oiFEUOl00mh00omagP03o`04gOnOg`;o00AagG7o
0]l01ooOgonOgil00_l2L@?o0]l01?nOgol3W`0<oiooWolAWonOoioO;U/1000000=Koe/015/01OmK
Fe_o01QK00>1Fe/05U/00h5KF`0CF`03PE]K015K00>1Fe/025/2P@AK0121FooLk=cogMcoUG6EomfE
0_l00mc/g002o`0F][Nf]ooLk?nEg9Gog9GLog6ELOoML@?o00CLk=co0]`01OmaUG7o00=a00?og]h0
0ol01=gogil2o`=a00Cog]ko0]l01?oOWml2o`?N0_l3g`04omnOo`;O0_l2g`08omlAoiooWol^F`40
00000e_oF`04F`03oe]K00?o5e/00h5KF`0FF`03PE]K01=K00>1Fe/045/00h5KF`0;F`>100QKPE_o
g>cLo`>E00SoUG7ogOngo`?L0_l01KNf]kKo00;/00Wog9GLombEg?l00md00ooML@02o`;/00?Lk?l0
0]`01OnEUIGo00?N00?oLMh00_l2g@09oiook?magG7o00;O00SogmoOomnOo`Aa00?ogml00]l8o`:O
00Co4IlA0ol_F`4000000e_oF`08F`03oe]K01IK00>1Fe/05U/00h5KF`0CF`03PE]K011K00>1Fe/0
3U/2P@0<oncLk=cogMcMog6E0_l01[O/omc/g0;o01Jf]kJgomc/oiGLUMcoUMcoLIEaomgL0_l01Mco
k=co00;L00KoLIEaUOl2L@03omkN00;o00NEgOoOonco00=a00Cog]ko0ml01?nOgol4gP0=omoookKo
g>cogW7No`03g`06oa7Oomoo;e/1000000=Kool01Ol3F`03oe]K01IK00>1Fe/05U/00h5KF`0CF`03
PE]K011K00>1Fe/03e/01h7ok=c/g?l00iD01?nELOl4]`0:omcoo?ng][Nfo`;/00Wog9GoUOnEg?l0
0md00ooML@02o`05k?oLk?l00]`00onEU@02U@06omkNog7N0_l3g@;o00K/og7MLOl2g`08omoOgooO
Wol4L@?o00>f]ol00]`01?oNg]h2o`:O00KoWooogol_F`40000TF`03PE]K01IK00>1Fe/04e/00h5K
F`0@F`03PE]K00mK02j1oncLk=c/omcMog6Eonbgk;Ook?nfo?ng][Oog>cLombEg?nEg?maUG7ogG7o
0]`01?o/g?l2g006og6ELIGo0W45o`03UMfE00;o0^`01?maLOl3gP05omoOoil00_l4gP0<o`go]kKo
g>cogW7N1_l00moNo`0`F`40000SF`03PE]K01MK00>1Fe/04e/00h5KF`0@F`03PE]K00mK00R1oncL
k=c/o`:E00GoUOngo`03]`0:omcoo;Go][Nfo`?/00SoUMbEoiGLo`?M00CogOoo0^`01?oLk?l2g003
oiFE00:E00Sog_mag_oNo`?M0_l01^cLomeao`?O00?ogml00_l00mcoL@03L@06o`go][Oo0]`01?oN
g]h2o`04gW7No`9K00>1Fe/0;U/100008e/00h5KF`0GF`03PE]K01=K00>1Fe/045/00h5KF`0?F`;o
00S/g>cLk?oLg@;o01Zg][Ook;O/oobfo?ng][Oog>cLombEg?nEg0?o00EaoooLo`02g004oncLo`;L
00GoLIEaU@03o`09LMkog_nEgIGo00?/00CoLG7o0mh01?oOgol2g005omkNg_l00Pd02_ng]_oLk?oN
LMh2o`04LMiao`9K00>1Fe/0;U/100008e/00h5KF`0GF`03PE]K01=K00>1Fe/045/00h5KF`0?F`08
okOog>cLk?l2U@06okNf]kKo0[L2o`08]ObeokJg]_l3k009oiGLUOnEonco00>E00?ok?l00^`01?oL
k?l2g003oiFE00:E00Kog?maomh2o`?M00Sog>cLomeao`?O00?ogol01=`01?maLOl23@04okJgo`;L
00Cog]kN0_l01=iag_l2F`03PE]K02iK0@0002=K00>1Fe/05e/00h5KF`0CF`03PE]K011K00>1Fe/0
3U/02onf]ooLk=c/omco00:f0_l05KNfooneoobfo?ng][Oog>cLombEg002o`;L00CoUMco0]`01ooL
g?o/g?l00]`02omaUG6EoncoLOma00;o00BEgIGo0n`01OmaLG7o00;N0_l00kOog002g004omkNo`8=
00[o]kKog>cogW7N0_l0177NLOl2F`03PE]K02iK0@0002=K00>1oe/05e/00h5KF`0CF`03PE]K011K
00>1Fe/03U/02?nf]ooLk=c/0_l00kNfo`07]@09okGl]Onf]kKo00?/00?oUOl00ol01]c/g?nEo`;/
00Ook>cog>co00;L00?oUID00YD01_oLog7ogP;o0md02OoLk=cogG7Mo`02g`04okO/o`?L00CoLOoo
0Pd01?nf]ol2g0;o00SNomkogW7No`9K00>1Fe/0;U/100008e/00h5KF`0GF`03PE]K01=K00>1Fe/0
45/00h5KF`0<F`;o00Jg][Nfon`4o`04]_l=o`>e00oo]KGoo;KlokNf]kKok=`00ol2g007omcLg?oL
o`02g007omcLoncLo`02g005og6ELOl00^`01?maog42o`04UMfEo`?/00GoLG5ao`02gP04okNgo`?L
00Cog_oo0Pd01_ng]_oLk0;o00QaomkoLMiao`9K00>1Fe/0;U/100008e/00h5KF`0GF`03PE]K01=K
00>1Fe/045/00h5KF`06F`Ko0o`2o`03]_oo00Bf00Co]KGo0kD03One]KGoo;Go][Nf]ol00^`00oo/
o`02k004omc/g0;o00C/gNco0^`01?oLk?l2g005oiFEUOl00m`3o`03k?oM00;M00[og>cLomeagOoO
0_l00kO/o`03g004og7oo`8=00Co][Oo0]`2o`08g_oNomiag_l2F`03PE]K02iK0@0002=K00>1Fe/0
5e/00h5KF`0CF`03PE]K011K00>1Fe/01U/03_l=]@go]KJe]_nf]KKo0o`01_l=]@feo`Je00ko]_co
]kJg]_o/okO/o`;L00Cog=cL0_l01=bEg?l2g004oncLo`;L00GoLIEao`03k0?o00BgoiGM0_l3k004
og5aL@;o00D=okNgo`04g0?o0Pd01_ng][Ook0;o00QaomkoLMiao`9K00>1Fe/0;U/100008e/00h5K
F`0GF`03PE]K01=K00>1Fe/045/00h5KF`05F`;o00Be3KGo1?`02_neo;GlokKo]Ol3]@05okFe]Ol0
0[D02?ol]Onf]kJg0_l01;K/k?l2k004omc/g0;o00C/gNco0^`01?oLk?l2g005oiFEUOl00m`3o`04
k?oMg@;o00OLk=cogG7M00;o00JeokO/]ol3g003ol3o008=0_l00kNfo`02g008omkookOoLOl3F`03
PE]K02iK0@0002=K00>1Fe/05e/00h5KF`0CF`03PE]K011K00>1Fe/01E/2o`073KD=]Onf]@02o`0=
][Ff]KKo]@go]@feo`03]@0;okFeokKlokNf]kH00_l01>bgk?l3g003omcL00;o0m`02?oLg?o/g>co
0]`00onEo`04k007omko]onEg@02o`?/00SoLG5aokD=o`>g00Oog=cLol3o00<=00So][Ook=coL@;o
00Bfomko0e/00h5KF`0^F`40000SF`03PE]K01MK00>1Fe/04e/00h5KF`0@F`03PE]K00EK0_l01KD=
]@go00;l00So]Ool]Obeo`>e00Co]KGo0kD02one]Ool]Oco]kJg00;o0n`01oo/k>cok=`00_l3k008
onc/omc/g?l2g003oiGo00CL00Gog_o/o`02g@;o00SLk=cogG7Mo`>e00Cok;Oo0m`00oo0o`033@04
okNfo`;L00Sog_oo]omao`=K00>1Fe/0;U/100008e/00h5KF`0FF`03PE]K01AK00>1Fe/045/00h5K
F`04F`0@o`go3KD=]Onf]Ol=okFf]@;o00Ne3KGo3KGo00>e00_o]KGo]_bfokJg]P02o`04k;O/o`?L
00[og=co]ooLgMco0]`01?oLk?l2g003oiGo00C/0_l01NbgoiGM00;o0n`02OmaLG7o]@feo`02]`07
omcLg?o0o`033@08okJgoncLog42o`04]_oNo`=K00>1Fe/0;U/100008e/00h5KF`0FF`03PE]K01AK
00>1Fe/045/00h5KF`04F`0Colc<o`fe3Oolo`feoobeo?l=o`02]@04okFeo`>e00go]KGoo;GlokNf
okKo00?/00Ook>c/onco00:g00Gok=g/o`02k004oncLo`;L0_l00ocog002g0;o00ngk;OogOo<oncL
omeagOl00kD01?o/]ol2g005ol30`?l00Pd01?ng]_l2g008omkookOoLOl3F`03PE]K02iK0@0002=K
00>1Fe/05U/00h5KF`0DF`03PE]K011K00>1Fe/015/02_l=c?ne3KGo]_l23@0=okFfol`=o`feo`fe
o`03]@0:okFe]Ool]_nfo`:f00Gok;O/o`03g003omco00:g00Gog=gLo`02g004omc/o`;L0_l00kKo
k002k0;o00S/]ncogOo<o`;/00?oLG400_l01;D=]Ol2]`08omcLolc0c?l23@08okJgoncLog42o`04
]_oNo`=K00>1Fe/0;U/100004U/6o`9K1?l5F`03PE]K01IK00>1Fe/055/00h5KF`0@F`03PE]K00=K
00Woc<c<o`fe3KD00_l02@feoobeol`=o`02]@05okFe]Ol00kD01_ne]Oneo0;o00FfokJgo`02k004
onc/k0;o0kL01Oo/k>co00;/00Cok=co0]`2o`0:o?oLg?nfokO/]`;o00P=c?o/g?oML@;o0kD01?o/
]ol2g005ol30`?l00Pd01?ng]_l2g008omkookOoLOl3F`03PE]K02iK0@00019K00?oFe/015/00omK
F`02F`04oe]KF`>15e/00h5KF`0DF`03PE]K011K00>1Fe/00U/2o`09c0g<okD=]@go00@=0_l02`g<
3Ol=]@go]@go00>e00Go]KGoo002o`;l00Oo][Ko]nco00?L0_l3]`05omcLg?l00]`01?oLk?l2g0;o
00Zfonc/okKok;O/0_l2c004onc/o`9a0_l01;D=]Ol2]`08omcLolc0c?l23@08okJgoncLog42o`04
]_oNo`=K00>1Fe/0;U/100004e/00omKF`03F`03oe]K009K00GoFe]KP@02F`B14e/00h5KF`0DF`03
PE]K011K00F1Fe]Ko`05c00:o`fe3KGo]@fe3@;o00@=c0go0kD00oneo`0:o`07]_bfokJgo`02k003
onco00?o0kL01Oo/k=go00;/00Cok=co0]`01?olo?l2g006okKo]nbg0_l020g<oncLomea0ol2]@04
onbgo`;L00Go`<30o`023@04okNfo`;L00Sog_oo]omao`=K00>1Fe/0;U/1000055/2o`=K00?oFe/0
0U/01OmKFe^100IK184?F`03PE]K01AK00>1Fe/045/4o`0=c0goc0g<okD=]@go3@02o`093Oo<3L`=
c?ne00Co00>eokD00ol01Pfe3KGoo0[o00?l]_l00kL01OoLg9Go00;L00?og?l01?l02obfonco]kKo
k;O/00;o0/`01_o/k>coL@;o00Be3KGo0[L02?oLooo<`<co0Pd01_o0]oo/g0;o00KNokKog_l3F`03
PE]K02iK0@0001IK00CoFe_o15/01OmKFe^100YK0h4<F`03PE]K01AK00>1Fe/045/01`g<3L`=c?l0
0l`04?l=]@goc<3<3Lcoc0g<3L`2o`053One3KD00_l01`g<o`fe3KD00_l01`fe3Ongo?l00_`01?ol
o?l3]`Wo00D=okFeo`03o0;o00Jg]_ngk;L2o`063Lcok=c/0_l2aP08okFeonbgom`2o`?000Oo3@go
]kKo00;L0_l01]ko]omao`=K00>1Fe/0;U/100005e/00omKo`04F`05oe]KFh403E/4P@QK00>1Fe/0
55/00h5KF`0?F`;o0/`03oo<3Lco3Lco]@feol0=o`02c00:ol`=c0g<ol`=]@;o00X=`0g03Ol=]@fe
0_l00`fe3@02o`08]_neo?ol]_l3]`04okOLo`;L0_l23@07okFeoobfo002o`06]kJgokO/0_l2c004
onc/k0;o0/H01Ol=]@go00:g0ol01<c0c?l23@06okJgoncL0_l01]ko]_oNo`=K00>1Fe/0;U/10000
4U/00omKF`02F`03oe_o00AK00GoFe]KP@0AF`B115/00h5KF`0DF`03PE]K00mK00Woc<`=c0g<3Ol0
0/`04?l=]Oo0c0g<3L`=o`g<3Ol53@0Dc0goc0g<o`fe3Ol=o`fe3Oneo?l2o004ooclo`:g0_l00nbg
o`02g005o`d=3Ol00kD02oolooneokJgonbg00;o00H=c?o/g>`2o`;600Oo]KFeokO/00?o0l001ol=
3Ong]_l00]`2o`06g_ngog7o0e/00h5KF`0^F`40000BF`03oe]K009K00?oFol015/01OmKFe^101EK
1H4EF`03PE]K00mK00Coc<3o0/`03?l=c?l=c0go3Ol=o`;<00_oc<co3L`=olbe3@02o`<=01Wo`0go
3KD=olco3Ol=okFfokGl]Onfo?ng00;o00>gg?l00]`01Ol=3@go00>e0ol02@feokJgokO/o`03c004
onc/k0;o0/H01Ol=]@go00:g0ol01<c0c?l23@06okJgoncL0_l01]ko]_oNo`=K00>1Fe/0;U/10000
4e/4o`=K1?l4F`03PE]K01MK184BF`03PE]K00mK00[o`<co3Lcoc0go0l`04_neolco3Lcoc0go3Lco
3Ol=o`;<00[o3Lco3L`=okGo0Pd02Ol=]@go]Nbeo`02o005ooclokL00_l00nbgo`02g0@=00Co]KFe
0ol040feokJgonbgol`=c?o/g>`2o`;600So]KFeokO/o`:<00Co`<3o0Pd01?ng]_l3g007omko]oma
o`03F`03PE]K02iK0@00029K00>1Fe/05e/0185KFe/4P@iK00>1Fe/03e/01?o<`?l2c007o`g<o`g<
3@02o`;000Coc<co0/`02ol=c?o<3Ol=c0go008=00Co`0g00_l4c00=okD=]Ong]Ool]Onfo002o`06
k?ngg?oL0_l33@05okFeokH00_l02@feokJgokO/o`03c005onc/k?l00lH01Ol=]@go00:g00OoaTco
`<co008=00Oo][Ook=c/00;o00Bg][Oo15/00h5KF`0^F`40000RF`03PE]K01MK00>1Fe/01E/3P@]K
00>1Fe/03U/03?o<`<co3Lcoc0g<o`;<0_l03L3<o`g<ol`=o`go3L`00_l3c007o`g<o`g<3@02o`@=
00So]KNeoobeo`;l00?oo?`00_l02Mcok;Oog?o0o`023@0>okFeokKo]@feokJgon`2o`08c0g<oncL
k?l3aP08okFe]Ongk?l2S004ol30o`8=00Co]kKo0m`2o`>g00?oFe/00e/00h5KF`0]F`40000RF`03
POmK01MK00>1Fe/025/4P@MK00>1Fe/03U/01_o0c<3<o`;<00Goc0goc002o`05`<c0c?l00/`00oo<
c002o`093Oo<c?o<3Lco008=00Ko3Oooa_l3c00=okD=]Onf]Ool]Onfo002o`04k?ngg0;o00?03Ol0
0`d2o`08]ooo]@feokH3o`03C?o<00;<00Gok>c/o`03aP05o`go3Ol00[L01oo6C?o0c?l00Pd01onf
ooo/g>`00_l01;Nf]ol5F`03PE]K02eK0@00029K00>1Fe/05e/00h5KF`0<F`B10e/00h5KF`09F`Go
00G0c<3<`009o`07`<c0c<3oc007o`043L`=c0Wo0/003Ol=3@go]@feoobgoo`01Ol2g003onbg00;o
00?<`?l00`d3o`05`?ne3KD00_l03Ha<S4coc0g<oncLk?l00lH01one]KGo]ol00h`01?o0`?l23@04
okNfo`;L00?ok?l00kL00omKF`03F`03PE]K02eK0@00029K00>1Fe/05e/00h5KF`0@F`B10U/9o`03
a/3600;o00O6`?ooa/3600;o00[0ooo6`<K0ol3<1?l00l`=c002o`033Ooo008=0_l02Hcoa/36ol36
o`03c004okD=]@Ko00?/g?l00n`00ongg002o`04`0g0o`8=0_l01l36okD=]Ol00d`00ha<o`03c005
onc/k?l00lH03_l=]@go]om<aTco`<co0Pd03Onf]kKog?o/okNf]ol01E/00h5KF`0]F`40000RF`03
PE]K01MK00>1Fe/04E/5o`0?a_o6S?n<a_o6`<K0ol3600;o0lH2o`03a_oo00C60_l03LKo`<co`?o6
o`g<3L`01?l01ha<ooo6`?l00/002?l=3@go]@go0^`01Oo/k?oL00Wo00C0c<3<1Ol04lK0okD=]Om<
S4b<C?o<3Lcok=`00_l3aP07okFe]Ongo`03S004ol30o`8=00Wo]kJgomcok?l00kL00omKF`03F`03
PE]K01QK1h4>F`40000QF`03PE]K01QK00>1Fe/04E/01?n<a_l3aP04olK6o`;600ooa/3o`<K0a/3o
`<Ko`<H00ol00`g<3@02o`?000Soa/Ko`?mVo`9=0d`02om<S4co`<Ko`<Ko00?<00?o]Ol02?l00`g<
3@02o`06c?oo3L`=0_l02/coC<Ko`<Ko]@d2o`9<00CoS4co1<`01?o/ool3aP04o`fe3@?o00M<aTco
`<co008=00go][Nfomcok?ng][Oo00EK00>1Fe/03E/;PAEK0@00025K00>1Fe/065/00h5KF`0@F`0I
ohcoS<KoaXcoS<KoaXco`?o0a_o6`?o0aP02o`07a_o0c<3oc004o`07c?o0`?o0aP02IP03ode<00=<
00SoS4b<olK0o`;000Co3@d=0_l00l3oc003c0;o00<=c0d00_l04lcoool=om;oC8a<S4coa/3o]@d0
0_l034b<oha<ol`=c0gog0;o0lH01?ne]KL3o`><00Co`<3o0`d01onf]ooLon`00_l2]`03oe]K00=K
00>1Fe/00U/;PB1K0@00025K00>1Fe/065/00h5KF`0?F`07ohb<olJ<o`02aP04olK6o`;600?oa_l0
0X`01_o0ol36o`C61Ol01L36`<Ko00?600Ko`?m=I_l2C@0>oda<odb<C?o0a_o0a_l3c005ol30`?l0
0l`01?l=c0d3o`0C`<K0o`god_o6C?m<a_o0a_ne3@02o`9<00GoS4b<o`03c004oncoo`?600Co3KD=
0ol01dc6C?o0c?l00`d00ong]P02o`05g>cooe/0384[F`40000QF`03PE]K01MK00>1Fe/03e/03On<
C8coS<KoaXc6olH01_l03HcoolKoC8co`<K0a_l00X`01oo0a/36`?l00l000oo0o`02IP04ode<o`9<
00SoS4b<olK0o`;000Co3@d=0_l00l3<o`02c0;o00[<ooooC?o6`<K00_l02m;oC8coS4coa/3600;o
00a=odb<C8a<S?l=c0d2o`03CDco00;600Co]KFe0ol3S004ol30o`<=00?o][L00_l01Mc/oon100MK
00>1Fe/0;E/100008E/00h5KF`0GF`03PE]K00iK00?oS8`00h`00on<o`06o`F<00?oS?l00_l2S003
olK600;600SoC8a<ol36`0;o0lH01_o0odeVo`9=00koC4coC8a<ol36ol36o`;<00?oS?l00/001Oo<
ooo600?o0T`01_o0a/36o`;B00[oaTcoC<Ko`<K00_l00dcoC002C004S4b<o`?<0_l2C007olK6a_ne
3@02o`08COo6C?o0c?l33@03okNe00;o00?Lk?l02E/00h5KF`0]F`40000QF`03PE]K01MK00>1Fe/0
3U/01_m<S4b<C0;o00=<S4`00_l01hcoC8a<S4`00_l02Ha<odb<ol36`002o`><00Koa/3oa_l3`003
odko009V00CoCDco0d`01om<S?o6`?l00l000ol=o`02aPCo00k6olI<CDa=C?o6`<K0o`;B00[oC8co
S4coa/360_l034goC8a<S4b<o`g<3@;o00==C?l00lH00one]@02o`05C?n<S?l00l001_l=3Onf]`;o
00?Lk?l02E/00h5KF`0]F`40000QF`03PE]K01MK00>1Fe/03E/00om<o`04S00:ohcoS4coC8a<o`B<
00?oS?l00X`01?n<S?l2aP0DodcoS4co`?n<C8coa_o0COm=I_l2C@0>oda<C?n<C?o0a_o0a/02o`03
aXc600;o0lH00oo6C@04C006ol36`<Ko0]802_o6C?m<a_o0a/02o`03C?m<009<00CoC8co0l`2o`9<
00Soa/K6okD=o`9=00SoaTco`<c0o`8=00?o]kH00_l00mc/o`09F`03PE]K02eK0@00025K00>1oe/0
5e/00h5KF`0=F`0:ohcoS4b<odb<o`=<00SoS4coS4b<o`:<00coC8coS4coa/3oC?l3S00;olJ<aXco
`?o6C_l00VH01?m=C?l3C007odb<olK0o`03`0;o0lH2o`0@a/3o`<I<CDa=C?o6`<K0o`?B01coS4b<
C8co`<KoC4e<oha<odb<o`g<3Om<CDco0lH01?ne]Ol2C004ohb<o`?000_o3@go][Ook=c/o`09F`03
PE]K02eK0@00025K00>1Fe/05e/00h5KF`0<F`05oda<C?l00X`03?m<oon<C8coS4b<o`:<00CoC8co
0X`01_n<S?o6o`9<01;oS4b<odb<C8coa_m>COm=I_l2C@0>oda<C?n<C?o0a/3oa/02o`03aXc600;o
0/H01_o6ode<o`9<00Ko`<K0a_l3dP0:odc6C<I<olK0o`=<00OoC4coC8co00?<00GoC4a<o`03aP04
okD=o`9=00SoaTco`<c0o`8=00?o]kH00_l00mc/o`09F`03PE]K02eK0@00025K00>1Fe/05e/00h5K
F`0<F`0<odb<C?m<ohcoCDco0d`01Om<S?m<00;o0X`03?m<S?n<C?o6oha<o`:<00WoC?n<aXco`?l0
0Th02?mVI_m=C4go0T`02?m<S?o6`<Ko0/02o`;601?oa_o6`?o0oda=ode<olK0a/3o00?B01coS4co
C8co`<KoC4e<oha<odb<o`g<3Om<CDco0lH01?ne]Ol2C004ohb<o`?000Ko3@go][L2o`03g>co00UK
00>1Fe/0;E/100008E/00h5KF`0GF`03PE]K00YK0_l4C00@ohcoS?m=C?m<S4coC8coS0;o00=<S?l0
0X`01_n<S?o6o`9<01;oS4coS?n<C8coa_m>COm=I_l3C@0=oda<oha<ol36`?o6`002o`05aXcoS?l0
0/H01_o6ode<o`=<00?oa/000_l3dP0:odc6olI<olK0o`=<00OoC4coC8co00?<00GoC4a<o`03aP04
okGoo`9=00SoaTco`<c0o`8=00?o]kH00_l00mcoF`09F`03PE]K02eK0@00025K00>1Fe/05e/00h5K
F`02F`So14`00om<S003o`04C4e<o`A<1?l00dgoS002S006oha<odb<0_l00ha<S002o`=<0_l018c6
ool2CP08ofIVode<COl2C00<odb<olK0a_o0odco0/H3o`0>a/3o`?m<COm=C4go`<H2o`?B01coS4co
C8co`<KoC4e<oha<odb<o`g<3Om<CDco0lH01?neool2C004ohb<o`?000Ko3@go][L2o`03g?mK00UK
00>1Fe/0;E/100008E/00h5KF`0GF`03PE]K009K0dd03Om<CDa=C?m<CDcoC?l00Td024a=C?m<S4b<
0_l3C005odb<C?l00X`01?n<S?l4C0;o00M<S4coC<I<00;o00I>COm=I_l3C@0:oda<oha<ol36`0;o
0T`00oo6S003o`;60ol00de<o`03C003olK000;o0m802_m<a_o6C?o6`?l3C007oda<odb<o`03c005
oda<C?l00lH01?neool2C@08olI<ol3<`?l23@03okNf00;o00?Loe/02E/00h5KF`0]F`40000QF`03
PE]K01MK00F1Fe]Ko`04C009ode<COm<oda=00;o0T`01Om<CDco00=<00OoC?m=C4go00><1ol01Db<
C8co00E<1Ol2CP08ofIVode<COl2C007odb<olK0aP02o`03S4co00;60ol03/K0oom=ode<CDa=ol36
0_l3dP0Loha<odb<ol36oda=C?n<C?m<S?l=c0goC4e<o`?600Co]Ooo0T`01?n<S?l3`006o`d=okJg
0_l00mcoF`09F`03PE]K02eK0@00025K00>1Fe/05e/01h5KFe_oCOl00Td02Om=C4goCOm=o`05C@09
ode<odb<C?m=00A<00KoC8a<odd2o`0:COooCOm<CDcoC0;o0VH02_m=C_m>COm=I_l3C@0:oda<oha<
S?o6`0;o0T`00oo6S002o`0:COooa_m=oda=o`9<00?oa/000_l3dP0:odc6olI<olK0o`=<00OoC4co
C8co00?<00GoC4a<o`03aP04okGoo`9=00SoaTc6olc0o`8=00?o]kH00_l00mcoF`09F`03PE]K02eK
0@00021K00>1Fe/065/01h5KFom=C?l00d`02_m<ode<COm=C4d3C004ode<o`9<00SoC4coCDa=o`:<
00CoC4co1D`02om<CDa=od;oITgo009>00CoCTko0VH01Om=C4go009<00OoC8a<ol3600;o00><C?l0
0/H00om=C@02o`0<a_m=ode<oda=ol360_l3dP0Loha<odb<ol3oCOm=C?n<C?m<S4coc?m=ode<o`?6
00Co]Ooo0T`01On<S8co00;000[o3@go]_l=omco2U/00h5KF`0]F`40000PF`03PE]K01QK00B1Fe_o
0dd01_m=COm<o`==00GoCDe=o`02C@04ode<C@?o0dd01om<C?m<S?l00Td01?m=COl3C@07ode<COmV
o`02IP0:ode>odi=odeVo`==00coC4a<odb<olKoC?l2C006olKooda=0_l01lKoCOm<COl00T`00oo6
`002o`?B00_oC<KoaTcoa_mVo`02C00<oda<C?n<C?o<ofKo0d`01Oo6a_ne00;o0Td02?o6C<Koc<3o
0Pd01ongokGog?l02U/00h5KF`0]F`40000PF`03POmK01QK00R1Fe_oCDa=o`9<00_oC?m=C?m=oda=
o`02C004ode<C@;o00Q<oda<oda=C0;o0T`00om=o`02C007oda<ode<o`02@P04ofI=o`9>00_oCTko
CVKoCDa=o`03C00<oha<ol3oC?n<C?o60_l2C@;o00c6odgoCDcoC4go`<H2o`?B01goS4coC8co`?m=
ode<oha<S?n<C?o<odgoCDa=o`02aP04okGoo`9<00GoS8b<o`02`00:o`d=okKo3OoLo`YK00>1Fe/0
;E/1000085/00h5KF`0HF`03POoo00A=00?oCDd00ol00dgoC@02C@04ode=o`9=00CoC?oo0Td01?m=
COl3C0;o00E=ode=o`02C@0:ode=ode<od9Vo`9V00[oCDkoCTgoCFKo0dd01om<C4coC8`00_l2C005
oda<olH00_l00da=o`02o`06ITgoC4go0T`00oo6`002o`?B00_oC<KoaTcoa_mVo`02C00<oda<C?n<
C?o<ofKo0d`04Oo6a_neofKoCOo6C<Koc<3o008=00Oo]oneomco00YK00>1Fe/0;E/1000085/00h5K
F`0AF`So14d00om=C002o`==00?oCDd00dd7o`05COm<C?l00T`01?m<CD`2o`05C?m<COl00T`01Om<
C?m=00;o0T801?mVCOl2CP04odi>o`9V00GoCDa=o`03C003oha<00;o0T`01On<C?o600;o0Td3o`0;
ITgoCDcoC4go`<H00_l3dP0Moha<odb<ol3oCOm=C?n<C8coS4coc?m=ode<COl00lH2o`04C_m<o`><
00Co`<3o0Pd01onfo`gog?l02U/00h5KF`0]F`40000PF`03PE]K011K0_l01FI=ITeV00Co00Y=oomV
CFI=odeV0_l2C@03ode=00?o00==odd00Td01?m=COl2C@03odco00;o00==odd00Td01?m=COl2C@?o
00=2I_l00VH02_m=C_m>COm=I_l3C@04oda<C0Go0T`01?m<C4`3o`03C4go00;o00IVCOm<COl2C006
olKoCDko0]802om<a_o6C?o6ofKo009<00coC4a<oha<olcoI_l3C004olK6aP;o00]VodgoaTc6olc0
o`023@07okOo]OoLo`0;F`03PE]K02aK0@00021K00>1Fe/03e/01?m2@_l3IP03ofIV00;o14d01?m=
ool4C@03ode<00;o0dd01Om=C4e<00So0dd01Om=C4e<00Oo00Q?od92ofI=o`9>00CoCTko0VH01Om=
C4go00=<0_l014e<COl2C003odb<00?o0Td03_n<ofI=ode<oda=ol3o0Th08?oBd_n<C?m<S?o0odgo
CDcoS4b<oha<olcoCOm=C4go0lH01?mVC_l2C004ohb<o`;000[o3@go]_l=omco2e/00h5KF`0/F`40
000PF`03PE]K00iK02ko@T92odeVCOm=I_mVCOm=ITeVofI=odeVCFKoITgoCFI=I_mVCOm=ITeVofI=
0_l016I=I_l4C@Co00HoCom2I_l2IP0:ode>odi=odeVo`==00CoC4a<0_l3C@04oda<o`9<0ol02da=
olKoITgoC4go009<00Koa_m=C_l2dP0;odc6olI<olKoI_l00T`03?m<C4coS4coc?mVo`=<00Soa/K6
od9Vo`9=00OoC<Koc<3o00<=0_l01;Gog?l;F`03PE]K02aK0@00021K00>1Fe/03U/01Om2@T;o00=V
00KoI_m=odd4IP;o00Hoodi2CT82o`==0_l01Tgoodi2CP;o00U=oom?odiVCVH00_l01cm??dloCcl0
0dl01om2@_mVCOl00Th01?m>C_l3IP04oda=o`=<00KoC4e<COl2C003odb<00;o0dd03_n<ofI=ode<
oda=ol3o0Th08?oBd_n<C?m<S?o0odgoCDcoS4b<oha<olcoCOm=C4go0lH01?mVC_l2C004ohb<o`;0
00Co3@d=0_l010gog?l;F`03PE]K02aK0@00021K00>1Fe/03U/00om2@P02@P03ofKo009V0_l00d;o
C@03C@0`?dloofI2IT;oCcoo?dloCom2IT9Vocm??dloofI2IT;oCcm??dloCcm??doo@VKo0VH02om=
C_m>COm=ITgo009=00?oC4`00_l4C@04oda<o`9<0_l00de<o`03o`06ITgoC4go0T`01_o6ode>o`;B
00_oC<KoaTcoa_mVo`02C00<oda<C?n<C?o<ofKo0d`02?o6a/Ko@VKo0Td01om<a_o<`?l00`d2o`04
]OoLo`]K00>1Fe/0;5/1000085/00h5KF`0>F`03od92009200OoI_m=odoo009201_oIVKo?dloodi2
CT;oCcoo?dloCom2CT9>ocl00Tl043m?odiVCVKoCcm??dloCcl3C`08od92ofI=I_l2CP04odi>o`9V
00CoC4go0T`>o`04COm=C0;o00]VCOm=C?m<COo0o`02CP0Pom;Boha<odb<ol3oCOm=C?n<C8coS4co
c?m=ode<COl3aP04ofI>o`9<00CoS8co0/001?l=3@d2o`043KGoo`]K00>1Fe/0;5/1000085/00h5K
F`0=F`;o14801?mVool2C`04od9?o`9=037o?dloofI2IT;oCcoo?dloCom2IT9Vocm??dloofI2IT;o
Ccm??dloCcm??doo@VKo00=V00[oCTgoCDkoITgo0dd01Om<ofKo009V0_l00dgoC@03C@;o00==C4d0
0_l01VI=oda=o`9<00Koa_m=C_l3dP06olI<odc60_l00fKoC002C00;oda<oha<olcoI_l00d`02?o6
a/Ko@VKo0Td01om<a_o<`?l00`d2o`03]@go00aK00>1Fe/0;5/1000085/00h5KF`0=F`;o1D801_mV
CcooC`9202?oI_m??dloodi2CT;oCcoo?dloCom2CT9>ocm?ocm?odiVCP02o`09Ccoo?dooCcoo009?
00So@T92odeVo`9>00CoCTko0VH01_m<CDcoC0;o00IVCOmVC_l3IP?o00m=C4e<odeVCOm=C?m<CD`0
0_l2CP0:om;Bd_m<S?n<C0;o01A=ode<COm<S?n<C?o<odgoCDa=o`?600CoITko0T`01?n<S?l2`009
o`d=3One3KGo00aK00>1Fe/0;5/100007e/00on1F`0>F`03ob3o00A200GoCdm?o`02@P0?Cd;oocoo
CcooIT9Vocm?00;o00Poocm?od9V@P;o00ToCom??omV@VH00_l044loocm?odloocm?od9V@_l2IP06
odi=ode>0_l00dgoC@02C@Co00IVoom2I_l3IP0@ofKoC4e<COm=ITeVode<o`9<0_l00de>o`03dP07
olI<odc6o`03IP04oda<o`9<00GoS4b<o`03IP04oda<o`;60_l00d9Vo`02C@08odc6olc0c?l23@05
o`fe3Ol035/00h5KF`0/F`40000OF`03PE]K00iK00?o?ol014801_m2CcooC`=200goCdooCcooCT9>
ocm?00;o00Poocm?od9>@P;o00ToColoCom>ITh00_l02Dloocm?odloo`02C`08od92@_m=I_l2CP04
odi>o`9V00CoC4e<0ol01doo@_m2C_l00VH04omVITkoC4e<odeVCFKoC4goCD`00_l2CP0Wom;Bd_m<
S?n<C?mVCFKoC4goC8a<odb<ofI=I_m<CDcoa_m>ITko009<00CoS8co0l002?l=3One3KGo35/00h5K
F`0/F`40000OF`03PE]K00iK00?o8?l01482o`9?00KoCd9?@_l2?`0:odloofI2I_loC`;o00Poocm?
od9V@P;o00ToCom??omV@VH00_l044loocm?odloocm?od9V@_l2IP0:odi=ode>ofI=o`==0_l00dm2
o`02o`03@VKo009V00GoCT9>@P04o`08CFI=I_m=C?l2C0;o00==C_l00m801oo6C?m<a_l00fH01?m<
C?l3C004odb<o`=V00_oC4a<olKoIT9Vo`02C@08odc6olc0c?l23@;o00>e3Ol035/00h5KF`0/F`40
000OF`03PE]K00eK00Co83oo0d801_m?odloo`A200?oCdl00Tl023ooCT9>ocm?0_l04cm??doo@Ti2
ob7oColoCom>ITh00_l02Dloocm?odloo`02C`08od92@_m=I_l2CP04odi>o`9V00CoC4e<0_l00d9?
F`02o`03@Ti200;o00=VCTh00Th03om2@_m=ITeVoda=ode<o`03CP0Pom;Bd_m<S?n<C?mVCFKoC4go
C8a<odb<ofI=I_m<CD`3o`04CVI>o`9<00CoS8co0l000ol=3@02o`033KGo00aK00>1Fe/0;5/10000
7e/00h5KF`0=F`04oclPo`=200_o@Tm?od9?@Tm2o`03?`09CcooIT9Vocm?00;o01<oCcm?od9V@_lP
odooCcooIT9V00;o011??oloCom??oloCom2IT;o0VH02_m>COm=C_mVCOl3C@;o00=?od800_l00d9V
@P02o`04@_m2CP;o0d802?mVCFKoCDco0T`01Om>CDko00?B00OoaTcoC<Ko00=V00CoC4co0d`01?m<
S?l3IP04oda<C0?o00AV@VKo0Td02?m<a_o<`<co0Pd2o`03]@go00aK00>1Fe/0;5/100007e/00h5K
F`0=F`04ob0oo`=20_l00cm?o`05@P03odm?009?00Poodi2C_loC`;o01<oCcm?od9>@_lQodoo?doo
CVI>00;o00U??oloCom??ol00Tl02?m2@T;oCFKo0Th01?m>C_l2IP07oda=C?m?@P02o`9200?oCT80
0_l014ooC_l2C`0>od92ofI=I_m<COm=C?l3CP0Pom;Bd_m<S?n<C?mVCFKoC4goC8a<odb<ofI=I_m<
CD`3o`04CVI>o`9<00CoS8co0l000ol=3@02o`033KGo00aK00>1Fe/0;5/100007e/00h5KF`0=F`04
oclPo`=20_l2C`;o00=?@Tl00_l3?`09CcooIT9Vocm?00;o02DoCcm?od9V@_lPodooCcooIT;o8?m?
?oloCom??oloCcooIT;o009V00[oCTgoCDkoITgo0dd02om2od;oCd;oIT;o009200Ko@_loCol2@P08
ofI=I_m=C?l2C005odi=C_l00m800oo6o`04o`9V5_l016I2I_l2C@0?odc6olc0c?l=o`go]@go00aK
00>1Fe/0;5/100007e/00h5KF`0=F`04ob0oo`9200Go@_loC`02o`=20_l3C`0CocooCT;oCcoo8Olo
Com?od9>o`028@0Dodoo?dooCVKo8?m??oloCom??ol3C`07od92odeVo`02CP04odi>o`9V00WoC4e<
odoo@_l00T802?m>odm2Cd;o0dl01?m2@T8Co`9?0_l01d;oodloCcl014l01_m?CdooC`;o00A=I_n<
0_l014iVC_l2C005ohb<S?l00/002?l=o`go3KGo35/00h5KF`0/F`40000OF`03PE]K00eK00Co?b3o
0T800om?o`02C`08ob7o@Too8Ol2?`0`ocooIT;oCcoo8OloCom?od9Vob4PodooCcm?od;o8?m??olo
Com??oloCcooIT;o0VH02_m>COm=C_mVCOl2C@;o00I2oom2Cd82o`8P0cl01Om??doo00920_l4C`03
ob0P00Do00E?84lPo`03C`03oclo00<o00Co?coo0cl02_m??dooCom=ITd2o`9?00Co@VKo0Td01om<
aTco`<`00_l01L`=okGo00eK00>1Fe/0;5/100007e/00h5KF`0<F`05oclP?ol00T802?loocm?ob7o
0T800olPo`02C`0CocooCT;oCcoo8OloCom?od9>o`028@0Eodoo?dloofKo8?m??oloCom??doo009?
00Oo@T;oCFKo009>00CoCTko0VH01Om<COm?00?o0d801Olo83oo008o00?oCdl00Tl2o`038?lo00<o
00?o?b000Sl02?loColo83oo0Tl2o`8o00Oo?dooCcoo00=?00CoCdoo0Tl013ooCFH2o`8o00OoITiV
odco00><00?o`<000_l01L`=o`go00eK00>1Fe/0;5/100004U/01?mKFe/4o`EK00>1Fe/035/01OlP
?b3o00920_l2C`;o00LQod9?ob7o008o033o?doo@_m??olQ8?m?odloofKo8B3oCcoo?doo@_lP8Olo
Com??oloCom??omV@_l2IP0:odi=ode>ofI=o`9=00[o84lPocoo8B3o0R003?lo?om??dloob4Po`A?
00Ko823o?ol2?`05ob1?8?l00Tl2o`8o00?o?cl013l03Olo?om??oloCcooITd00_l2C`05od9V@_l0
0Td01_o6C?o0c0;o00G<3Oneo`0=F`03PE]K02aK0@00019K00CoFe_o15/00omKF`02F`F12U/01Olo
83lP00;o00Q?odloob0Qo`9200?o8?l00Tl02OloCom2odloo`028@08odooCcooC_l28@0Eodloodlo
ofKo827o?dooCcoo?doo009?00Oo@T;oCFKo009>00CoCTko0VH02_m<ob0o83oo?ol28004ob0oo`<o
00GoCdm?o`028004oclo?`;o00<o8?l00cl01Tloob0oo`9?0_l4?`06Ccoo?doo0Tl01Om?Com?008o
00CoCFKo0cl01OmVCVKo009<00CoS8co0/02o`04c0goo`iK00>1Fe/0;5/100003U/6o`03FomK00=K
00?oFe/00U/00h5KF`02F`N10e/01OlP?b0o00;o00Doodm?o`028@06od9?ob7o0Sl06oloCom2odlo
ob4PodooCcooI_lQ8?m??oloC`02o`0C8B0Qocm?odloocm?odloofI2o`02IP0;odi=ode>ofI=odd0
0_l0121?ocl2o`038B0Q00<P00co?coo?dloob4P8Ol2C`;o0R001?lo?ol2?`04odlPC`;o00<Q8?l0
0Sl01?lo?ol2?`04oclo?`;o00M?odloofI=00A?00Go@VI2o`02C@0:olI<ol3oc?o<3@;o3U/00h5K
F`0/F`40000>F`05oe]KFol00U/00omKF`02F`03oe]K009K00>1Fe/02E/3P@05oclP?b000_l03Doo
Ccoo827o@_lQ8?l00Tl02OloCom2odloo`028@08odooCcooC_l28@06odloodlo0_l03B4P8OloCom?
?oloCol00Tl01om2@_m=I_l00Th01?m>C_l2IP08odcooclPocl2o`<P00Co?b3o0Sl00om?C`02o`<P
00?o?cl00_l00clPo`02?`07odloob0o8002o`8Q00[o?cooCcoo?doo0dl2o`06@_lo?om=0_l3?`05
ofI>I_l00T`02_n<S?o0ol3oc0d2o`iK00>1Fe/0;5/100003e/01?mKFol2F`03oe]K009K00?oFe/0
0U/00h5KF`0;F`06oclP?b0o0_l01CooCdoo008Q00?o@_l00R401_lo?oloC`;o00/oColP8B3oCom?
?`02o`09824Podloocm?00;o01<Q827o?dooCcoo?dooCcooIT;o009V00WoCTgoCDkoITd00_l01R3o
84oo?`;o00@Q827o0R001_lo?oloC`;o00@Q827o0Tl2o`8P00Co?coo0Sl01?m?84l2o`038B3o008o
00Co?coo0Sl01?lo?cl2o`09Com??omVocoo009?00Go@VI2o`02C@03olI<00;o00G0c?o<3@02o`iK
00>1Fe/0;5/1000045/00omKo`02F`03oe]K009K00?oFe/00U/00h5KF`0;F`0Eob0o83lPocm?odlo
ob0Qod;o8B3o009?00?o?dl00_l00cm?o`038@05odooCcl00_l38@06odloodlo0_l03B4P8OloCom?
?oloCol00Tl01om2@_m=I_l00Th01?m>C_l2IP;o00Doocoo?`02o`088OlP8?lo8?l2?`06odm?ob7o
0R000olo?`02o`03?b3o008o00SoCcoo83lPo`<Q00[o?cooCcoo?doo0dl01?m2@_l2?`;o0Sl02?lo
?cooCVKo0T`00on<S002o`06c<3oc0go3e/00h5KF`0/F`40000@F`03oe_o009K00?oFe/00U/01OmK
Fe^100iK00Wo?b0o83ooCol00Tl01olQ8B7o@_l00R401_lo?oloC`;o00/oColP8B3oCom??`02o`09
824Podloocm?00;o01<Q827o?dooCcoo?dooCcooIT;o009V00WoCTgoCDkoITd00_l01R3o8?loo`8Q
00Co827o0R001_lo?oloo`8Q00Co827o0Tl2o`8P00Co?coo0Sl02Om?84oo824Po`02?`04ocloo`8o
00[o?clood;o?dlo0_l2?`08odm?ComV@_l2C@03olI<00;o00C0c?o<0_l?F`03PE]K02aK0@00015K
0_l2F`03oe]K009K00GoFe]KP@0>F`;o00<o83l01?l033m?ob4P8Om2ob4Po`9?00?o?dl00_l00cm?
o`038@05odooCcl00_l38@06odloodlo0_l03B4P8OloCom??oloCol00Tl01om2@_m=I_l00Th01?m>
C_l2IP04ob0o80;o00Doob4Qo`028004oclPo`8o00?oCol00R401_lP8?loo`8Q00_o83oo?om??olP
?`02o`<Q00co?cooCcm?odloodl4o`<o0_l3?`08ocloodiVod`6o`04c<3ooa9K00>1Fe/0:e/10000
4U/01?mKFe/4o`AK00>1Fe/02e/02_lQ8_loob;o8_l2C`07ob4Q8Om2o`028@06oclo?om?0_l02cm?
ob0Q8?m??olo00;o00TP8B0Qocoo?dl00_l04b4P8OloCom??oloCom??omV@_l00VH02?m>COm=C_mV
0_l013lP?ol2?`07ob4Qob0Qo`028004oclo?`;o0R402OlP8Om?ob4_o`028004ocloo`8o0_l01RlQ
824Po`<o00Co?coo0Sl4o`038Ooo00?o13l8o`03I_oo00Ko4e/00h5KF`0CF`b135/100007U/00h5K
F`0;F`07ob8_8_lRo`02;`08ocm?ob4P8B02o`048B0Qo`9?00OoCooo?doo00<Q00GoCcoo?`02o`@Q
01Co?om??olP8B0Qocm?odloocm?o`9?00Oo@T;oCFKo009>00?oCTh00_l01B3o83lP00?o0b401olP
8?lo8?l00cl01OlQ8B7o008P00?o?ol00R401?lP?ol2?`03ocm?00;o0Rl01?lQ8Ol3?`05ocm?odl0
0_l01B3ooolP00;o0b02o`038?oo008P1Ol280;o00<Poe/04e/GPAQK0@0001iK00>1Fe/02U/03_lR
8B;o8_lR8OlRodoo1242o`<Q00Go?cooC`02o`0;?doo824Podloocl00_l07B0Q827o?oloColP8B0Q
ocm?odloocm?odloofI200_o0R001_lPob4_o`<Q00Co827o0R001Olo?coo00<Q00Wo827oColQ;ol0
0R000olo?`04o`078BlQob4Po`03?`Go0R02o`8_00Oo824Poboo00iK5h400e^1F`0/F`40000NF`03
PE]K00YK00Wo;b;o8Roo;ol00R83o`0:8B0Q8?lP8B0Qo`9?00KoCom??ol48@06odloocoo1B405?lo
odloob0Q827o?dooCcoo?doo0Tl04?m2ofKo?oloob4P8B3o83l2o`8_1B402?lP823o83oo0Sl01OlQ
8B7o00<P0_l28@04ob0oo`8o00Co;boo0bl01OlQ8B7o008o00Wo8OlQob3o8Ol00R401?lP8Ol28@n1
65/00h5KF`0[F`40000NF`03PE]K00UK1ol00b4Ro`028P;o1B400olQ8@028@0^ocloodooCcoo8B0Q
8?m??oloob4P8B0Qocoo?olRob4P8OloCom??oloCom??`Wo00@P8B0Q1ol00b8Q8@028@05ob0Q8?l0
0R001Oloob;o00<Q00?o8B000_l00b4_o`02800@ocoo8_lQ8_l_8OlQ827o?`;o00PQoblQoboo8@8_
00Ko827o;olWF`03PE]K02]K0@0002eK2ol02b0Q824Pob0Q827o009?00KoCom??ol48@06odloocoo
1B404_looolO8Qoo827o?dooCcoo?`Oo00H_ool_8Rl2o`03;ooo00<_00?o;ol00Rl01OlQ8B7o008P
00?o83l00_l28P05ob4Q8Ol00R001olQ8B7o83l00_l28P04obl_o`<_00?o8B400_l04R7o8OlQ8_lQ
ob;o8OlP8OlQobMK00>1Fe/0:e/10000=e/eo`068_lRob;o0b802_lRob8Q8_lR8B82o`068B8Qob7o
0b401?lQ8?l280;o0R803?lQ8B7o8B3o;b4_o`8P0_l28P0:ob4RoblQ;olP8@;o00H_ob7o;b42o`03
8R7o008_0_l00booF`0WF`03PE]K02]K0@0003UK00>1Fe/055/00h7oo`0Fo`8R00?o8_l01Ol28P;o
00<R7ol00R802OlRob8OoblRo`02;`05ob4Qob009Ol28@05ob7o8B800_l00b4Ro`028@;o00<Qoe/0
9e/00h5KF`0[F`40001@F`03PE]K00iK3?l5Fa[o25/?o`8_00?o;ol00ol01b7o8B8Q8_l00Rl02olQ
ool_ob8Q8_l_00;o00<_oe/09e/00h5KF`0[F`40001@F`03PE]K015K00>1Fe/03e/00h5KF`09F`03
PE]K015K4Ol00b7o8@0HobUK00>1Fe/0:e/10000I5/00h5KF`0?F`03PE]K00UK00>1Fe/06E/01R;o
;boo;aco:e/00h5KF`0[F`40001TF`03PE]K00mK00>1Fe/02E/00h5KF`0HFa3o0R401OlQ;olP00;o
He/10000MU/00h5KF`09F`03PE]K01UK6?mSF`40001fF`03PE]K00UK00>1Fe/07U/00omKF`1cF`40
0022F`03PE]K09AK0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000oe/JF`40003oFaYK
0@000?mK6U/10000oe/JF`40003oFaYK0@000?mK6U/10000_U/2oeUK0@000;mK0_l3F`03oe]K059K
0@000<1K0_l3F`03oe]K055K0@0003QK1Ol3F`?o0U/2o`AK0ol00e_oo`02o`=K1Ol5F`;o1E/2o`9K
1Ol2F`;o0U/4o`=K1?l3F`Co0U/4o`=K1?l6F`;o0e/2o`03Fooo009K1?l3F`?o0U/3o`9K0_l5F`?o
0U/2o`MK1?l00e_oF`04o`9K0_l2F`;o0U/2o`EK1?l3F`Co9E/10000=e/2o`=K0_l015_ooe/2o`03
Fooo00AK0_l00e_oo`02F`;o00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`02F`;o
00=Kool00U/2o`03Fooo009K1?l2F`;o00=Kool00U/2o`EK0_l3F`;o00AKoomK0_l2F`;o0U/2o`9K
0_l015_ooe/2o`EK0ol2F`;o1U/2o`9K1Ol2F`;o00=Kool00U/2o`9K0_l4F`;o0U/2o`03Fooo009K
0_lTF`40000gF`;o0e/4o`=K1?l4F`;o00=Kool01E/2o`9K0_l5F`;o1E/2o`9K0_l00e_oo`02F`;o
00=Kool025/3o`AK1Ol8F`?o1E/2o`=K0_l00e_oo`04F`?o0U/2o`03Fooo00=K1?l4F`;o00=Kool0
25/2o`AK1?l5F`;o0U/2o`QK0_l2F`;o00=Kool00U/2obAK0@0003]K1Ol3F`Co15/2o`03Fooo00Co
00=Kool00U/2o`EK0_l5F`;o0U/2o`03Fooo009K0_l00e_oo`04o`9K1?l3F`Co00=Kool01?l2F`Co
1U/2o`=K0_l00e_oo`02F`Co0e/2o`03Fooo00=K1?l4F`;o00=Kool025/2o`AK2?l00e_oo`02F`;o
25/2o`9K0_l5F`;o95/10000>5/5o`03Fooo00=K1?l4F`;o00=Kool00U/2o`03Fooo009K0_l5F`Go
0U/2o`9K0_l00e_oo`02F`;o00=Kool00U/2o`04Foooo`AK0ol3F`;o0U/2o`04Foooo`QK0_l3F`;o
00AKoomK0ol5F`;o00=Kool00e/4o`AK0_l00e_oo`08F`;o0U/6o`9K0_l00e_oo`02F`;o2E/4o`=K
00?oFe/00_lTF`40000gF`?o1E/2o`04FoooF`?o0e/2o`03Fooo009K0_l00e_oo`02F`;o1E/2o`EK
0_l2F`;o00=Kool00U/2o`03Fooo009K0_l00e_oo`02F`;o00=Kool00U/4o`9K0_l00e_oo`02F`;o
1E/7o`04FoooF`;o0U/2o`9K0_l2F`;o00AKoomK0ol3F`;o00=Kool025/2o`IK0_l2F`;o00=Kool0
0U/2o`QK0_l2F`;o0U/4obEK0@0003MK0_l3F`;o0U/3o`9K0ol2F`Co00=Kool00_l3F`Go1E/2o`EK
0_l00e_oo`07o`=K1?l3F`Co0e/4o`9K1?l3F`Co1U/2o`=K0_l00e_oo`02F`Co0U/4o`9K0ol2F`?o
0U/2o`=K0_l7F`;o15/2o`03Fooo00;o0U/5o`UK0_l2F`;o0U/00omKF`0VF`40000gF`;o0e/2o`eK
0_l<F`;o1E/2o`UK0_l^F`;o0e/2o`aK0_lLF`;o0U/2oaIK0_l2F`;o0U/00omKF`0VF`40000hF`Go
3U/2o`aK0_l5F`Ko00=Kool00U/2obiK0_l3F`;o00=Kool02E/2oaeK1?lHF`Co0e/5obAK0@000?mK
6U/10000oe/JF`40003oFaYK0@000?mK6U/10000\
\>"],
  ImageRangeCache->{{{0, 281}, {267, 0}} -> {-0.0880742, -0.0502163, \
0.00370667, 0.00370667}},
  CellTags->"Fitness chart 3D - Part 2"]
}, Open  ]],

Cell[TextData[Cell[BoxData[
    FormBox[
      ButtonBox[\(Part\ 1\),
        ButtonData:>"Fitness chart 3D - Part 1",
        ButtonStyle->"Hyperlink"], TraditionalForm]]]], "Text",
  TextAlignment->Center,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["A few further investigations ...", "Subsection"],

Cell["\<\
Needs[\"Graphics`FilledPlot`\"]

Needs[\"Graphics`Legend`\"]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
bestFits = Map[Reverse[Sort[#]] // First&,allFitnesses];
meanFits = Map[Reverse[Sort[#]] // Mean&,allFitnesses];
minFits  = Map[Reverse[Sort[#]] // Min&,allFitnesses];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["bestFits", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{6, 6, 6, 6, 7, 12, 12, 12, 12, 13, 13, 13, 13, 13, \
13, 13, 17, 18, 21, 
 
  28, 28, 28, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 34, 34, 
 
  34, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 
 
  44, 44, 44, 44, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 
 
  45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45}\
\>", "\<\
{6, 6, 6, 6, \
7, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 17, 18, 21, 
 
  28, 28, 28, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 34, 34, 
 
  34, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 
 
  44, 44, 44, 44, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 
 
  45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
newChampPositions =
Position[Map[#[[2]]-#[[1]]&,Partition[bestFits,2,1]],x_/;x > 0]+1\
\>", \
"Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{5}, {6}, {10}, {17}, {18}, {19}, {20}, {23}, {36}, \
{39}, {60}}\
\>", "\<\
{{5}, {6}, {10}, {17}, {18}, {19}, {20}, {23}, {36}, \
{39}, {60}}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["PrependTo[newChampPositions,{1}]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{1}, {5}, {6}, {10}, {17}, {18}, {19}, {20}, {23}, \
{36}, {39}, {60}}\
\>", "\<\
{{1}, {5}, {6}, {10}, {17}, {18}, {19}, {20}, \
{23}, {36}, {39}, {60}}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["newChampFits = Map[Take[bestFits,#]&,newChampPositions]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{{6}, {7}, {12}, {13}, {17}, {18}, {21}, {28}, {33}, \
{34}, {44}, {45}}\
\>", "\<\
{{6}, {7}, {12}, {13}, {17}, {18}, {21}, {28}, \
{33}, {34}, {44}, {45}}\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["BarChart[newChampFits // Flatten];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.032787 0.081967 0.014715 0.01308 [
[(1)] .04918 .01472 0 2 Msboxa
[(2)] .13115 .01472 0 2 Msboxa
[(3)] .21311 .01472 0 2 Msboxa
[(4)] .29508 .01472 0 2 Msboxa
[(5)] .37705 .01472 0 2 Msboxa
[(6)] .45902 .01472 0 2 Msboxa
[(7)] .54098 .01472 0 2 Msboxa
[(8)] .62295 .01472 0 2 Msboxa
[(9)] .70492 .01472 0 2 Msboxa
[(10)] .78689 .01472 0 2 Msboxa
[(11)] .86885 .01472 0 2 Msboxa
[(12)] .95082 .01472 0 2 Msboxa
[(0)] -0.0125 .01472 1 0 Msboxa
[(10)] -0.0125 .14552 1 0 Msboxa
[(20)] -0.0125 .27632 1 0 Msboxa
[(30)] -0.0125 .40712 1 0 Msboxa
[(40)] -0.0125 .53792 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.04918 .01472 m
.04918 .02097 L
s
P
[(1)] .04918 .01472 0 2 Mshowa
p
.002 w
.13115 .01472 m
.13115 .02097 L
s
P
[(2)] .13115 .01472 0 2 Mshowa
p
.002 w
.21311 .01472 m
.21311 .02097 L
s
P
[(3)] .21311 .01472 0 2 Mshowa
p
.002 w
.29508 .01472 m
.29508 .02097 L
s
P
[(4)] .29508 .01472 0 2 Mshowa
p
.002 w
.37705 .01472 m
.37705 .02097 L
s
P
[(5)] .37705 .01472 0 2 Mshowa
p
.002 w
.45902 .01472 m
.45902 .02097 L
s
P
[(6)] .45902 .01472 0 2 Mshowa
p
.002 w
.54098 .01472 m
.54098 .02097 L
s
P
[(7)] .54098 .01472 0 2 Mshowa
p
.002 w
.62295 .01472 m
.62295 .02097 L
s
P
[(8)] .62295 .01472 0 2 Mshowa
p
.002 w
.70492 .01472 m
.70492 .02097 L
s
P
[(9)] .70492 .01472 0 2 Mshowa
p
.002 w
.78689 .01472 m
.78689 .02097 L
s
P
[(10)] .78689 .01472 0 2 Mshowa
p
.002 w
.86885 .01472 m
.86885 .02097 L
s
P
[(11)] .86885 .01472 0 2 Mshowa
p
.002 w
.95082 .01472 m
.95082 .02097 L
s
P
[(12)] .95082 .01472 0 2 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
0 .01472 m
.00625 .01472 L
s
P
[(0)] -0.0125 .01472 1 0 Mshowa
p
.002 w
0 .14552 m
.00625 .14552 L
s
P
[(10)] -0.0125 .14552 1 0 Mshowa
p
.002 w
0 .27632 m
.00625 .27632 L
s
P
[(20)] -0.0125 .27632 1 0 Mshowa
p
.002 w
0 .40712 m
.00625 .40712 L
s
P
[(30)] -0.0125 .40712 1 0 Mshowa
p
.002 w
0 .53792 m
.00625 .53792 L
s
P
[(40)] -0.0125 .53792 1 0 Mshowa
p
.001 w
0 .04088 m
.00375 .04088 L
s
P
p
.001 w
0 .06704 m
.00375 .06704 L
s
P
p
.001 w
0 .0932 m
.00375 .0932 L
s
P
p
.001 w
0 .11936 m
.00375 .11936 L
s
P
p
.001 w
0 .17168 m
.00375 .17168 L
s
P
p
.001 w
0 .19784 m
.00375 .19784 L
s
P
p
.001 w
0 .224 m
.00375 .224 L
s
P
p
.001 w
0 .25016 m
.00375 .25016 L
s
P
p
.001 w
0 .30248 m
.00375 .30248 L
s
P
p
.001 w
0 .32864 m
.00375 .32864 L
s
P
p
.001 w
0 .3548 m
.00375 .3548 L
s
P
p
.001 w
0 .38096 m
.00375 .38096 L
s
P
p
.001 w
0 .43328 m
.00375 .43328 L
s
P
p
.001 w
0 .45944 m
.00375 .45944 L
s
P
p
.001 w
0 .4856 m
.00375 .4856 L
s
P
p
.001 w
0 .51176 m
.00375 .51176 L
s
P
p
.001 w
0 .56408 m
.00375 .56408 L
s
P
p
.001 w
0 .59024 m
.00375 .59024 L
s
P
p
.001 w
0 .6164 m
.00375 .6164 L
s
P
p
.002 w
0 0 m
0 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
p
1 0 0 r
.01639 .01472 m
.01639 .0932 L
.08197 .0932 L
.08197 .01472 L
F
P
p
.004 w
.01639 .01472 m
.01639 .0932 L
.08197 .0932 L
.08197 .01472 L
.01639 .01472 L
s
P
P
p
p
1 0 0 r
.09836 .01472 m
.09836 .10628 L
.16393 .10628 L
.16393 .01472 L
F
P
p
.004 w
.09836 .01472 m
.09836 .10628 L
.16393 .10628 L
.16393 .01472 L
.09836 .01472 L
s
P
P
p
p
1 0 0 r
.18033 .01472 m
.18033 .17168 L
.2459 .17168 L
.2459 .01472 L
F
P
p
.004 w
.18033 .01472 m
.18033 .17168 L
.2459 .17168 L
.2459 .01472 L
.18033 .01472 L
s
P
P
p
p
1 0 0 r
.2623 .01472 m
.2623 .18476 L
.32787 .18476 L
.32787 .01472 L
F
P
p
.004 w
.2623 .01472 m
.2623 .18476 L
.32787 .18476 L
.32787 .01472 L
.2623 .01472 L
s
P
P
p
p
1 0 0 r
.34426 .01472 m
.34426 .23708 L
.40984 .23708 L
.40984 .01472 L
F
P
p
.004 w
.34426 .01472 m
.34426 .23708 L
.40984 .23708 L
.40984 .01472 L
.34426 .01472 L
s
P
P
p
p
1 0 0 r
.42623 .01472 m
.42623 .25016 L
.4918 .25016 L
.4918 .01472 L
F
P
p
.004 w
.42623 .01472 m
.42623 .25016 L
.4918 .25016 L
.4918 .01472 L
.42623 .01472 L
s
P
P
p
p
1 0 0 r
.5082 .01472 m
.5082 .2894 L
.57377 .2894 L
.57377 .01472 L
F
P
p
.004 w
.5082 .01472 m
.5082 .2894 L
.57377 .2894 L
.57377 .01472 L
.5082 .01472 L
s
P
P
p
p
1 0 0 r
.59016 .01472 m
.59016 .38096 L
.65574 .38096 L
.65574 .01472 L
F
P
p
.004 w
.59016 .01472 m
.59016 .38096 L
.65574 .38096 L
.65574 .01472 L
.59016 .01472 L
s
P
P
p
p
1 0 0 r
.67213 .01472 m
.67213 .44636 L
.7377 .44636 L
.7377 .01472 L
F
P
p
.004 w
.67213 .01472 m
.67213 .44636 L
.7377 .44636 L
.7377 .01472 L
.67213 .01472 L
s
P
P
p
p
1 0 0 r
.7541 .01472 m
.7541 .45944 L
.81967 .45944 L
.81967 .01472 L
F
P
p
.004 w
.7541 .01472 m
.7541 .45944 L
.81967 .45944 L
.81967 .01472 L
.7541 .01472 L
s
P
P
p
p
1 0 0 r
.83607 .01472 m
.83607 .59024 L
.90164 .59024 L
.90164 .01472 L
F
P
p
.004 w
.83607 .01472 m
.83607 .59024 L
.90164 .59024 L
.90164 .01472 L
.83607 .01472 L
s
P
P
p
p
1 0 0 r
.91803 .01472 m
.91803 .60332 L
.98361 .60332 L
.98361 .01472 L
F
P
p
.004 w
.91803 .01472 m
.91803 .60332 L
.98361 .60332 L
.98361 .01472 L
.91803 .01472 L
s
P
P
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`0001`00olB00Co
4@03oa@00olA00?o5002oa<000?o00004`02oa800ol@00?o1002o``00ol300?o3003o`<01?l<0000
7@000ol0000B0003o`0001@000?o00004P000ol0000C0003o`00010000Co003o4P000ol0000B0004
o`00oa@000?o00003P000ol000020004o`00o``000?o00000`000ol0000<0003o`0000<000?o0000
300001d000?o00004`000ol0000C0003o`0001001?lD0003o`00010000Co003o4`000ol0000A0004
o`00oa800ol@0003o`00008000Co003o30000ol000030003o`0000`000?o000010000ol0000;0000
7@000ol0000D0003o`0001000_lC0003o`3o01800olC00?o50000ol0000B00;o4P001?l00?l@0003
o`00008000Co003o30000ol000030003o`0000`000?o00001@000ol0000:00007@000ol0000A0004
o`00oa@000?o000040000ol0o`0B0003o`0001<000?o00005@000ol0000@0004o`00oa4000Co003o
40000ol000020004o`00o``000?o00000`000ol0000<0003o`00008000Co003o300001`00_lD00;o
4P03oa@00_lB00Co4`03oa401?lC00;o4`02oa000_l500;o3002o`@00_l=00;o1@02o`d0003o01/0
003o01/0003o01/0000A0003o`000?l01`0000X00_l50003o`000?l01`0000T000Co003o10000ol0
003o00L000090004o`00o`@0ool7o`<000090004o`00o`@000Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0000T0
00Co003o10001Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`05
o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S
00Go0000o`0A8`05o`000?l042<00ol0000500002P02o`D000Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@000140
00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o010S
00?o00000P000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@00014000Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000
o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS
8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@0001400_l20003ob<S00hS00Go0000o`0A8`05o`000?l042<01Ol0003o014S00Go0000
o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@001Ol0003o010S00Go0000o`0A8`05
o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol000050000
4@001Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000
o`0A8`05o`000?l042<00ol0000500004@001Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`000080
00?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@001Ol0003o010S
00Go0000o`0A8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l0
42<00ol0000500004@001Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o014S00Go0000
o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@001Ol0003o010S00Go0000o`0A8`05
o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol000050000
4@02o`8000?o8b<03R<01Ol0003o014S00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A0005o`000?l042<01Ol0003o014S00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0005o`000?l0
42<01Ol0003o014S00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`000080
00?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000
o`0@8`03o`0000D0000A0005o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05
o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0005o`000?l042<01Ol0003o014S
00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0
000A0005o`000?l042<01Ol0003o014S00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A0005o`000?l042<01Ol0003o014S00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A00;o0P0Bo`<0
00?o8b<03b<01Ol0003o010S00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS
8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@00014000?o00005P000olS8`0?8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`05
o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S
00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0000F0003ob<S00lS00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0001H0
4ol30003ob<S00hS00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05
o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o0000
1@00014000?o0000;0000olS8`0>8`05o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`000080
00?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000
o`0@8`03o`0000D0000A0003o`0002`000?o8b<03R<01Ol0003o014S00Go0000o`0@8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000
o`0A8`05o`000?l042<00ol0000500004@000ol0000/0003ob<S00hS00Go0000o`0A8`05o`000?l0
42<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0001400_l]0003ob<S00hS00Go0000o`0A8`05
o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000;0000olS8`0>8`05
o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0002`0
00?o8b<03R<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol000050000
4@000ol0000/0003ob<S00hS00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS
8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@00014000?o0000;0000olS8`0>8`05o`000?l04B<01Ol0003o010S00Go0000o`0@8`03
o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S
00Go0000o`0@8`03o`0000D0000300?o1002o`D000?o0000;0000olS8`0>8`05o`000?l04B<01Ol0
003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05
o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D000040003o`00008000Co003o10000ol0
000/0003ob<S00hS00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05
o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o0000
1@0000@000?o00000P001?l00?l400;o;@000olS8`0>8`05o`000?l04B<01Ol0003o010S00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D000040003o`00008000Co003o10000ol0000/0003ob<S00hS
00Go0000o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol0
00020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0000@000?o0000
0P001?l00?l40003o`0002`000?o8b<03R<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol0
00020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05
o`000?l042<00ol0000500000`02o`D00_l50003o`0002`000?o8b<03R<01Ol0003o014S00Go0000
o`0@8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0000/0003ob<S00hS00Go0000
o`0A8`05o`000?l042<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000;0000olS
8`0>8`05o`000?l04B<01Ol0003o010S00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S
00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003
o`0002`000?o8b<03R<01Ol0003o014S00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@02obd04_l30003ob<S00lS00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol000110003ob<S00lS00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol000110003ob<S00lS00Go0000o`0@8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol0001101?o0`000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol000050000
4@000ol0001G0003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0005L0
00?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0001400_mH0003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A0003o`0005L000?o8b<03R<01Ol0003o010S00?o0000
0P000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00?o00001@00014000?o0000E`000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol0001G0003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S
00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003
o`0005L000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000E`000olS
8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0001G0003ob<S00hS00Go0000
o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A00;oF0000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l0
42<00ol0000500004@000ol0001G0003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0
000A0003o`0005L000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<00ol0
00020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000
E`000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<0
3R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0001G01;o0`000olS
8`0>8`03o`00008000?o8b<03R<01Ol0003o010S00?o00000P000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A0003o`0006`000?o8b<03R<00ol000020003ob<S00hS
00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol0001/0003ob<S00hS00?o00000P000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0001400_m]01;o10000olS
8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@00014000?o0000PP000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000
o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000PP000olS8`0>8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@000140
00?o0000PP000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@00014000?o0000PP000olS8`0>8`05o`000?l042<00ol000020003
ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0000<01?l300;o1@000ol0
00220003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05
o`000?l042<00ol00005000010000ol000020004o`00o`@000?o0000PP000olS8`0>8`05o`000?l0
42<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0000D0
00Go0000o`020003o`0000800_n30003ob<S00hS00Go0000o`0@8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500001P001?l00?l20003o`00008000?o0000
PP000olS8`0>8`05o`000?l042<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00?o00001@0000<000Co003o0P001?l00?l40003o`00088000?o8b<03R<01Ol0003o010S
00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000400;o
1002o`D000?o0000PP0Bo`<000?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0009L0
00?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o0000
1@0001400_nH0003ob<S00hS00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000
o`0@8`03o`0000D0000A0003o`0009L000?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<0
3R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS
00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003
o`0009L000?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000
o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS00?o00000P000olS8`0>8`05
o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A00;oV0000olS8`0>8`03o`000080
00?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003
ob<S00hS00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0
000A0003o`0009L000?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00?o00001@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<03R<01Ol0003o010S
00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS00?o00000P000olS
8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0009L000?o8b<0
3R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@000140
0_nH0003ob<S00hS00?o00000P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03
o`0000D0000A0003o`0009L000?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<03R<01Ol0
003o010S00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS00?o0000
0P000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A0003o`0009L0
00?o8b<03R<00ol000020003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o0000
1@00014000?o0000U`000olS8`0>8`03o`00008000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05
o`000?l042<00ol0000500004@000ol0002G0003ob<S00hS00?o00000P000olS8`0>8`05o`000?l0
42<01Ol0003o014S00Go0000o`0@8`03o`0000D0000A00;oV00Bo`@000?o8b<03R<01Ol0003o010S
00Go0000o`0A8`05o`000?l042<00ol0000500004@000ol0002]0003ob<S00hS00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000[@000olS8`0>8`05o`000?l042<01Ol0
003o014S00Go0000o`0@8`03o`0000D0000A0003o`000:d000?o8b<03R<01Ol0003o010S00Go0000
o`0A8`05o`000?l042<00ol0000500004@000ol0002]0003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@0000<00ol400;o1@000ol0002]0003ob<S00hS00Go0000o`0@8`05
o`000?l04B<01Ol0003o010S00?o00001@0000H000Co003o0P000ol000020003o`000:d000?o8b<0
3R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0000500001P001?l00?l20003o`000080
0_n^0003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S00?o00001@0000@00_l30004
o`00o`@000?o0000[@000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03o`0000D0
00060004o`00o`8000?o00000P000ol0002]0003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00?o00001@0000<00ol400;o1@000ol0002]0003ob<S00hS00Go0000o`0@8`05o`000?l0
4B<01Ol0003o010S00?o00001@00014000?o0000[@000olS8`0>8`05o`000?l042<01Ol0003o014S
00Go0000o`0@8`03o`0000D0000A0003o`000:d000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05
o`000?l042<00ol0000500004@000ol0002]0003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0
003o010S00?o00001@0001400_n^0003ob<S00hS00Go0000o`0@8`05o`000?l04B<01Ol0003o010S
00?o00001@00014000?o0000[@000olS8`0>8`05o`000?l042<01Ol0003o014S00Go0000o`0@8`03
o`0000D0000A0003o`000:d000?o8b<03R<01Ol0003o010S00Go0000o`0A8`05o`000?l042<00ol0
000500004@000ol0002]01;o0`000olS8`0>8`05o`000?l04B<01Ol0003o010S00?o00001@000140
00?o0000`P000olS8`0>8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000`P000olS
8`0>8`05o`000?l04B<01Ol0003o010S00?o00001@00014000?o0000`P000olS8`0>8`05o`000?l0
4B<01Ol0003o010S00?o00001@0001400_o301;o0`000olS8`0?8`05o`000?l042<00ol000050000
4@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A0003o`000=L000?o8b<03b<01Ol0
003o010S00?o00001@00014000?o0000e`000olS8`0?8`05o`000?l042<00ol0000500004@000ol0
003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A0003o`000=L000?o8b<03b<01Ol0003o010S
00?o00001@00014000?o0000e`000olS8`0?8`05o`000?l042<00ol0000500004@02omP000?o8b<0
3b<01Ol0003o010S00?o00001@00014000?o0000e`000olS8`0?8`05o`000?l042<00ol000050000
4@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A0003o`000=L000?o8b<03b<01Ol0
003o010S00?o00001@00014000?o0000e`000olS8`0?8`05o`000?l042<00ol0000500004@000ol0
003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A00;of0000olS8`0?8`05o`000?l042<00ol0
000500004@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A0003o`000=L000?o8b<0
3b<01Ol0003o010S00?o00001@00014000?o0000e`000olS8`0?8`05o`000?l042<00ol000050000
4@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000400?o0`02o`D000?o0000e`000olS
8`0?8`05o`000?l042<00ol0000500001@001Ol0003o008000?o00000P000ol0003G0003ob<S00lS
00Go0000o`0@8`03o`0000D0000300Co0P001?l00?l400;of0000olS8`0?8`05o`000?l042<00ol0
000500000`000ol0o`030004o`00o`@000?o0000e`000olS8`0?8`05o`000?l042<00ol000050000
0`000ol0o`030004o`00o`@000?o0000e`000olS8`0?8`05o`000?l042<00ol0000500001002o`@0
0_l50003o`000=L000?o8b<03b<01Ol0003o010S00?o00001@00014000?o0000e`000olS8`0?8`05
o`000?l042<00ol0000500004@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A0003
o`000=L000?o8b<03b<01Ol0003o010S00?o00001@0001400_oH0003ob<S00lS00Go0000o`0@8`03
o`0000D0000A0003o`000=L000?o8b<03b<01Ol0003o010S00?o00001@00014000?o0000e`000olS
8`0?8`05o`000?l042<00ol0000500004@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0
000A0003o`000=L000?o8b<03b<01Ol0003o010S00?o00001@00014000?o0000e`000olS8`0?8`05
o`000?l042<00ol0000500004@000ol0003G0003ob<S00lS00Go0000o`0@8`03o`0000D0000A00;o
f00Co`<000?o8b<03R<00ol0000500004@000ol0003]0003ob<S00hS00?o00001@00014000?o0000
k@000olS8`0>8`03o`0000D0000A0003o`000>d04_l700004@000ol0003o00L0000A0003o`000?l0
1`00014000?o0000o`0700004@02ool020000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-0.406188, -4.38607, 0.0466625, \
0.292415}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
ShowLegend[
  ListFilledPlot[
    bestFits,
    meanFits,
    minFits,
    Fills -> {GrayLevel[0.4],GrayLevel[0.8]},
    AxesLabel -> {\"Gen.\",\"Fit.\"},
    DisplayFunction -> Identity
  ],
  {{{GrayLevel[0.4],\"Best\"},
    {GrayLevel[0.8],\"Mean\"},
    {GrayLevel[1.0],\"Worst\"}},
   LegendPosition -> {1.1, -0.4},
   LegendSize -> {0.5,0.8}},
  DisplayFunction -> $DisplayFunction
];\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .46644 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.383199 0.359389 0.23322 0.359389 [
[ 0 0 0 0 ]
[ 1 .46644 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
% Start of sub-graphic
p
0.02381 0.011106 0.742588 0.455335 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 0.618034 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
% Start of sub-graphic
p
0 0 1 0.618034 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.011074 0.014715 0.01308 [
[(20)] .24529 .01472 0 2 Msboxa
[(40)] .46678 .01472 0 2 Msboxa
[(60)] .68826 .01472 0 2 Msboxa
[(80)] .90975 .01472 0 2 Msboxa
[(Gen.)] 1.025 .01472 -1 0 Msboxa
[(10)] .01131 .14552 1 0 Msboxa
[(20)] .01131 .27632 1 0 Msboxa
[(30)] .01131 .40712 1 0 Msboxa
[(40)] .01131 .53792 1 0 Msboxa
[(Fit.)] .02381 .61803 0 -4 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
.002 w
.24529 .01472 m
.24529 .02097 L
s
P
[(20)] .24529 .01472 0 2 Mshowa
p
.002 w
.46678 .01472 m
.46678 .02097 L
s
P
[(40)] .46678 .01472 0 2 Mshowa
p
.002 w
.68826 .01472 m
.68826 .02097 L
s
P
[(60)] .68826 .01472 0 2 Mshowa
p
.002 w
.90975 .01472 m
.90975 .02097 L
s
P
[(80)] .90975 .01472 0 2 Mshowa
p
.001 w
.06811 .01472 m
.06811 .01847 L
s
P
p
.001 w
.1124 .01472 m
.1124 .01847 L
s
P
p
.001 w
.1567 .01472 m
.1567 .01847 L
s
P
p
.001 w
.201 .01472 m
.201 .01847 L
s
P
p
.001 w
.28959 .01472 m
.28959 .01847 L
s
P
p
.001 w
.33389 .01472 m
.33389 .01847 L
s
P
p
.001 w
.37818 .01472 m
.37818 .01847 L
s
P
p
.001 w
.42248 .01472 m
.42248 .01847 L
s
P
p
.001 w
.51107 .01472 m
.51107 .01847 L
s
P
p
.001 w
.55537 .01472 m
.55537 .01847 L
s
P
p
.001 w
.59967 .01472 m
.59967 .01847 L
s
P
p
.001 w
.64396 .01472 m
.64396 .01847 L
s
P
p
.001 w
.73256 .01472 m
.73256 .01847 L
s
P
p
.001 w
.77685 .01472 m
.77685 .01847 L
s
P
p
.001 w
.82115 .01472 m
.82115 .01847 L
s
P
p
.001 w
.86545 .01472 m
.86545 .01847 L
s
P
p
.001 w
.95404 .01472 m
.95404 .01847 L
s
P
p
.001 w
.99834 .01472 m
.99834 .01847 L
s
P
[(Gen.)] 1.025 .01472 -1 0 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .14552 m
.03006 .14552 L
s
P
[(10)] .01131 .14552 1 0 Mshowa
p
.002 w
.02381 .27632 m
.03006 .27632 L
s
P
[(20)] .01131 .27632 1 0 Mshowa
p
.002 w
.02381 .40712 m
.03006 .40712 L
s
P
[(30)] .01131 .40712 1 0 Mshowa
p
.002 w
.02381 .53792 m
.03006 .53792 L
s
P
[(40)] .01131 .53792 1 0 Mshowa
p
.001 w
.02381 .04088 m
.02756 .04088 L
s
P
p
.001 w
.02381 .06704 m
.02756 .06704 L
s
P
p
.001 w
.02381 .0932 m
.02756 .0932 L
s
P
p
.001 w
.02381 .11936 m
.02756 .11936 L
s
P
p
.001 w
.02381 .17168 m
.02756 .17168 L
s
P
p
.001 w
.02381 .19784 m
.02756 .19784 L
s
P
p
.001 w
.02381 .224 m
.02756 .224 L
s
P
p
.001 w
.02381 .25016 m
.02756 .25016 L
s
P
p
.001 w
.02381 .30248 m
.02756 .30248 L
s
P
p
.001 w
.02381 .32864 m
.02756 .32864 L
s
P
p
.001 w
.02381 .3548 m
.02756 .3548 L
s
P
p
.001 w
.02381 .38096 m
.02756 .38096 L
s
P
p
.001 w
.02381 .43328 m
.02756 .43328 L
s
P
p
.001 w
.02381 .45944 m
.02756 .45944 L
s
P
p
.001 w
.02381 .4856 m
.02756 .4856 L
s
P
p
.001 w
.02381 .51176 m
.02756 .51176 L
s
P
p
.001 w
.02381 .56408 m
.02756 .56408 L
s
P
p
.001 w
.02381 .59024 m
.02756 .59024 L
s
P
p
.001 w
.02381 .6164 m
.02756 .6164 L
s
P
[(Fit.)] .02381 .61803 0 -4 Mshowa
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
p
.4 g
.03488 .0932 m
.04596 .0932 L
.05703 .0932 L
.06811 .0932 L
.07918 .10628 L
.09025 .17168 L
.10133 .17168 L
.1124 .17168 L
.12348 .17168 L
.13455 .18476 L
.14563 .18476 L
.1567 .18476 L
.16777 .18476 L
.17885 .18476 L
.18992 .18476 L
.201 .18476 L
.21207 .23708 L
.22315 .25016 L
.23422 .2894 L
.24529 .38096 L
.25637 .38096 L
.26744 .38096 L
.27852 .44636 L
.28959 .44636 L
.30066 .44636 L
.31174 .44636 L
.32281 .44636 L
.33389 .44636 L
.34496 .44636 L
.35604 .44636 L
.36711 .44636 L
.37818 .44636 L
.38926 .44636 L
.40033 .44636 L
.41141 .44636 L
.42248 .45944 L
.43355 .45944 L
.44463 .45944 L
.4557 .59024 L
.46678 .59024 L
.47785 .59024 L
.48893 .59024 L
.5 .59024 L
.51107 .59024 L
.52215 .59024 L
.53322 .59024 L
.5443 .59024 L
.55537 .59024 L
.56645 .59024 L
.57752 .59024 L
.58859 .59024 L
.59967 .59024 L
.61074 .59024 L
.62182 .59024 L
.63289 .59024 L
.64396 .59024 L
.65504 .59024 L
.66611 .59024 L
.67719 .59024 L
.68826 .60332 L
.69934 .60332 L
.71041 .60332 L
.72148 .60332 L
.73256 .60332 L
.74363 .60332 L
.75471 .60332 L
.76578 .60332 L
.77685 .60332 L
.78793 .60332 L
.799 .60332 L
.81008 .60332 L
.82115 .60332 L
.83223 .60332 L
.8433 .60332 L
.85437 .60332 L
.86545 .60332 L
.87652 .60332 L
.8876 .60332 L
.89867 .60332 L
.90975 .60332 L
.92082 .60332 L
.93189 .60332 L
.94297 .60332 L
.95404 .60332 L
.96512 .60332 L
.97619 .60332 L
.97619 .29322 L
.96512 .32297 L
.95404 .34145 L
.94297 .39685 L
.93189 .35311 L
.92082 .34289 L
.90975 .38522 L
.89867 .41765 L
.8876 .43944 L
.87652 .34992 L
.86545 .48464 L
.85437 .48763 L
.8433 .43667 L
.83223 .44908 L
.82115 .48376 L
.81008 .44432 L
.799 .42117 L
.78793 .41928 L
.77685 .35828 L
.76578 .39098 L
.75471 .43686 L
.74363 .4691 L
.73256 .44011 L
.72148 .3993 L
.71041 .37023 L
.69934 .34224 L
.68826 .33222 L
.67719 .35216 L
.66611 .33265 L
.65504 .35337 L
.64396 .3739 L
.63289 .35423 L
.62182 .26746 L
.61074 .25154 L
.59967 .39375 L
.58859 .3065 L
.57752 .28311 L
.56645 .3153 L
.55537 .2905 L
.5443 .28309 L
.53322 .25089 L
.52215 .27361 L
.51107 .29296 L
.5 .32653 L
.48893 .28542 L
.47785 .28468 L
.46678 .25924 L
.4557 .24719 L
.44463 .26482 L
.43355 .22525 L
.42248 .26948 L
.41141 .25435 L
.40033 .24842 L
.38926 .2531 L
.37818 .21741 L
.36711 .19966 L
.35604 .24344 L
.34496 .2767 L
.33389 .19712 L
.32281 .24381 L
.31174 .20768 L
.30066 .20936 L
.28959 .21667 L
.27852 .20981 L
.26744 .20053 L
.25637 .18848 L
.24529 .18406 L
.23422 .1396 L
.22315 .13556 L
.21207 .11228 L
.201 .10335 L
.18992 .0969 L
.17885 .1012 L
.16777 .10342 L
.1567 .10901 L
.14563 .109 L
.13455 .10763 L
.12348 .09623 L
.1124 .08325 L
.10133 .08019 L
.09025 .08979 L
.07918 .08438 L
.06811 .07881 L
.05703 .06671 L
.04596 .04587 L
.03488 .04613 L
F
P
p
p
.004 w
.03488 .0932 m
.04596 .0932 L
.05703 .0932 L
.06811 .0932 L
.07918 .10628 L
.09025 .17168 L
.10133 .17168 L
.1124 .17168 L
.12348 .17168 L
.13455 .18476 L
.14563 .18476 L
.1567 .18476 L
.16777 .18476 L
.17885 .18476 L
.18992 .18476 L
.201 .18476 L
.21207 .23708 L
.22315 .25016 L
.23422 .2894 L
.24529 .38096 L
.25637 .38096 L
.26744 .38096 L
.27852 .44636 L
.28959 .44636 L
.30066 .44636 L
.31174 .44636 L
.32281 .44636 L
.33389 .44636 L
.34496 .44636 L
.35604 .44636 L
.36711 .44636 L
.37818 .44636 L
.38926 .44636 L
.40033 .44636 L
.41141 .44636 L
.42248 .45944 L
.43355 .45944 L
.44463 .45944 L
.4557 .59024 L
.46678 .59024 L
.47785 .59024 L
.48893 .59024 L
.5 .59024 L
.51107 .59024 L
.52215 .59024 L
.53322 .59024 L
.5443 .59024 L
.55537 .59024 L
.56645 .59024 L
.57752 .59024 L
Mistroke
.58859 .59024 L
.59967 .59024 L
.61074 .59024 L
.62182 .59024 L
.63289 .59024 L
.64396 .59024 L
.65504 .59024 L
.66611 .59024 L
.67719 .59024 L
.68826 .60332 L
.69934 .60332 L
.71041 .60332 L
.72148 .60332 L
.73256 .60332 L
.74363 .60332 L
.75471 .60332 L
.76578 .60332 L
.77685 .60332 L
.78793 .60332 L
.799 .60332 L
.81008 .60332 L
.82115 .60332 L
.83223 .60332 L
.8433 .60332 L
.85437 .60332 L
.86545 .60332 L
.87652 .60332 L
.8876 .60332 L
.89867 .60332 L
.90975 .60332 L
.92082 .60332 L
.93189 .60332 L
.94297 .60332 L
.95404 .60332 L
.96512 .60332 L
.97619 .60332 L
Mfstroke
P
p
.004 w
.03488 .04613 m
.04596 .04587 L
.05703 .06671 L
.06811 .07881 L
.07918 .08438 L
.09025 .08979 L
.10133 .08019 L
.1124 .08325 L
.12348 .09623 L
.13455 .10763 L
.14563 .109 L
.1567 .10901 L
.16777 .10342 L
.17885 .1012 L
.18992 .0969 L
.201 .10335 L
.21207 .11228 L
.22315 .13556 L
.23422 .1396 L
.24529 .18406 L
.25637 .18848 L
.26744 .20053 L
.27852 .20981 L
.28959 .21667 L
.30066 .20936 L
.31174 .20768 L
.32281 .24381 L
.33389 .19712 L
.34496 .2767 L
.35604 .24344 L
.36711 .19966 L
.37818 .21741 L
.38926 .2531 L
.40033 .24842 L
.41141 .25435 L
.42248 .26948 L
.43355 .22525 L
.44463 .26482 L
.4557 .24719 L
.46678 .25924 L
.47785 .28468 L
.48893 .28542 L
.5 .32653 L
.51107 .29296 L
.52215 .27361 L
.53322 .25089 L
.5443 .28309 L
.55537 .2905 L
.56645 .3153 L
.57752 .28311 L
Mistroke
.58859 .3065 L
.59967 .39375 L
.61074 .25154 L
.62182 .26746 L
.63289 .35423 L
.64396 .3739 L
.65504 .35337 L
.66611 .33265 L
.67719 .35216 L
.68826 .33222 L
.69934 .34224 L
.71041 .37023 L
.72148 .3993 L
.73256 .44011 L
.74363 .4691 L
.75471 .43686 L
.76578 .39098 L
.77685 .35828 L
.78793 .41928 L
.799 .42117 L
.81008 .44432 L
.82115 .48376 L
.83223 .44908 L
.8433 .43667 L
.85437 .48763 L
.86545 .48464 L
.87652 .34992 L
.8876 .43944 L
.89867 .41765 L
.90975 .38522 L
.92082 .34289 L
.93189 .35311 L
.94297 .39685 L
.95404 .34145 L
.96512 .32297 L
.97619 .29322 L
Mfstroke
P
P
P
p
p
.8 g
.03488 .04613 m
.04596 .04587 L
.05703 .06671 L
.06811 .07881 L
.07918 .08438 L
.09025 .08979 L
.10133 .08019 L
.1124 .08325 L
.12348 .09623 L
.13455 .10763 L
.14563 .109 L
.1567 .10901 L
.16777 .10342 L
.17885 .1012 L
.18992 .0969 L
.201 .10335 L
.21207 .11228 L
.22315 .13556 L
.23422 .1396 L
.24529 .18406 L
.25637 .18848 L
.26744 .20053 L
.27852 .20981 L
.28959 .21667 L
.30066 .20936 L
.31174 .20768 L
.32281 .24381 L
.33389 .19712 L
.34496 .2767 L
.35604 .24344 L
.36711 .19966 L
.37818 .21741 L
.38926 .2531 L
.40033 .24842 L
.41141 .25435 L
.42248 .26948 L
.43355 .22525 L
.44463 .26482 L
.4557 .24719 L
.46678 .25924 L
.47785 .28468 L
.48893 .28542 L
.5 .32653 L
.51107 .29296 L
.52215 .27361 L
.53322 .25089 L
.5443 .28309 L
.55537 .2905 L
.56645 .3153 L
.57752 .28311 L
.58859 .3065 L
.59967 .39375 L
.61074 .25154 L
.62182 .26746 L
.63289 .35423 L
.64396 .3739 L
.65504 .35337 L
.66611 .33265 L
.67719 .35216 L
.68826 .33222 L
.69934 .34224 L
.71041 .37023 L
.72148 .3993 L
.73256 .44011 L
.74363 .4691 L
.75471 .43686 L
.76578 .39098 L
.77685 .35828 L
.78793 .41928 L
.799 .42117 L
.81008 .44432 L
.82115 .48376 L
.83223 .44908 L
.8433 .43667 L
.85437 .48763 L
.86545 .48464 L
.87652 .34992 L
.8876 .43944 L
.89867 .41765 L
.90975 .38522 L
.92082 .34289 L
.93189 .35311 L
.94297 .39685 L
.95404 .34145 L
.96512 .32297 L
.97619 .29322 L
.97619 .0278 L
.96512 .0278 L
.95404 .0278 L
.94297 .0278 L
.93189 .0278 L
.92082 .0278 L
.90975 .04088 L
.89867 .0278 L
.8876 .0278 L
.87652 .0278 L
.86545 .05194 L
.85437 .04088 L
.8433 .0278 L
.83223 .0278 L
.82115 .0278 L
.81008 .04088 L
.799 .0278 L
.78793 .0278 L
.77685 .0278 L
.76578 .0278 L
.75471 .0278 L
.74363 .0278 L
.73256 .0278 L
.72148 .0278 L
.71041 .0278 L
.69934 .0278 L
.68826 .0278 L
.67719 .0278 L
.66611 .0278 L
.65504 .0278 L
.64396 .04088 L
.63289 .0278 L
.62182 .0278 L
.61074 .0278 L
.59967 .0278 L
.58859 .0278 L
.57752 .0278 L
.56645 .0278 L
.55537 .0278 L
.5443 .0278 L
.53322 .0278 L
.52215 .0278 L
.51107 .0278 L
.5 .0278 L
.48893 .0278 L
.47785 .0278 L
.46678 .0278 L
.4557 .0278 L
.44463 .0278 L
.43355 .0278 L
.42248 .0278 L
.41141 .0278 L
.40033 .0278 L
.38926 .0278 L
.37818 .0278 L
.36711 .0278 L
.35604 .0278 L
.34496 .0278 L
.33389 .0278 L
.32281 .0278 L
.31174 .0278 L
.30066 .0278 L
.28959 .0278 L
.27852 .0278 L
.26744 .0278 L
.25637 .04088 L
.24529 .06704 L
.23422 .0278 L
.22315 .0278 L
.21207 .0278 L
.201 .0278 L
.18992 .0278 L
.17885 .0278 L
.16777 .0278 L
.1567 .0278 L
.14563 .0278 L
.13455 .0278 L
.12348 .0278 L
.1124 .0278 L
.10133 .0278 L
.09025 .0278 L
.07918 .0278 L
.06811 .0278 L
.05703 .0278 L
.04596 .0278 L
.03488 .0278 L
F
P
p
p
.004 w
.03488 .04613 m
.04596 .04587 L
.05703 .06671 L
.06811 .07881 L
.07918 .08438 L
.09025 .08979 L
.10133 .08019 L
.1124 .08325 L
.12348 .09623 L
.13455 .10763 L
.14563 .109 L
.1567 .10901 L
.16777 .10342 L
.17885 .1012 L
.18992 .0969 L
.201 .10335 L
.21207 .11228 L
.22315 .13556 L
.23422 .1396 L
.24529 .18406 L
.25637 .18848 L
.26744 .20053 L
.27852 .20981 L
.28959 .21667 L
.30066 .20936 L
.31174 .20768 L
.32281 .24381 L
.33389 .19712 L
.34496 .2767 L
.35604 .24344 L
.36711 .19966 L
.37818 .21741 L
.38926 .2531 L
.40033 .24842 L
.41141 .25435 L
.42248 .26948 L
.43355 .22525 L
.44463 .26482 L
.4557 .24719 L
.46678 .25924 L
.47785 .28468 L
.48893 .28542 L
.5 .32653 L
.51107 .29296 L
.52215 .27361 L
.53322 .25089 L
.5443 .28309 L
.55537 .2905 L
.56645 .3153 L
.57752 .28311 L
Mistroke
.58859 .3065 L
.59967 .39375 L
.61074 .25154 L
.62182 .26746 L
.63289 .35423 L
.64396 .3739 L
.65504 .35337 L
.66611 .33265 L
.67719 .35216 L
.68826 .33222 L
.69934 .34224 L
.71041 .37023 L
.72148 .3993 L
.73256 .44011 L
.74363 .4691 L
.75471 .43686 L
.76578 .39098 L
.77685 .35828 L
.78793 .41928 L
.799 .42117 L
.81008 .44432 L
.82115 .48376 L
.83223 .44908 L
.8433 .43667 L
.85437 .48763 L
.86545 .48464 L
.87652 .34992 L
.8876 .43944 L
.89867 .41765 L
.90975 .38522 L
.92082 .34289 L
.93189 .35311 L
.94297 .39685 L
.95404 .34145 L
.96512 .32297 L
.97619 .29322 L
Mfstroke
P
p
.004 w
.03488 .0278 m
.04596 .0278 L
.05703 .0278 L
.06811 .0278 L
.07918 .0278 L
.09025 .0278 L
.10133 .0278 L
.1124 .0278 L
.12348 .0278 L
.13455 .0278 L
.14563 .0278 L
.1567 .0278 L
.16777 .0278 L
.17885 .0278 L
.18992 .0278 L
.201 .0278 L
.21207 .0278 L
.22315 .0278 L
.23422 .0278 L
.24529 .06704 L
.25637 .04088 L
.26744 .0278 L
.27852 .0278 L
.28959 .0278 L
.30066 .0278 L
.31174 .0278 L
.32281 .0278 L
.33389 .0278 L
.34496 .0278 L
.35604 .0278 L
.36711 .0278 L
.37818 .0278 L
.38926 .0278 L
.40033 .0278 L
.41141 .0278 L
.42248 .0278 L
.43355 .0278 L
.44463 .0278 L
.4557 .0278 L
.46678 .0278 L
.47785 .0278 L
.48893 .0278 L
.5 .0278 L
.51107 .0278 L
.52215 .0278 L
.53322 .0278 L
.5443 .0278 L
.55537 .0278 L
.56645 .0278 L
.57752 .0278 L
Mistroke
.58859 .0278 L
.59967 .0278 L
.61074 .0278 L
.62182 .0278 L
.63289 .0278 L
.64396 .04088 L
.65504 .0278 L
.66611 .0278 L
.67719 .0278 L
.68826 .0278 L
.69934 .0278 L
.71041 .0278 L
.72148 .0278 L
.73256 .0278 L
.74363 .0278 L
.75471 .0278 L
.76578 .0278 L
.77685 .0278 L
.78793 .0278 L
.799 .0278 L
.81008 .04088 L
.82115 .0278 L
.83223 .0278 L
.8433 .0278 L
.85437 .04088 L
.86545 .05194 L
.87652 .0278 L
.8876 .0278 L
.89867 .0278 L
.90975 .04088 L
.92082 .0278 L
.93189 .0278 L
.94297 .0278 L
.95404 .0278 L
.96512 .0278 L
.97619 .0278 L
Mfstroke
P
P
P
P
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0 0 1 0.618034 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.011074 0.014715 0.01308 [
[(20)] .24529 .01472 0 2 Msboxa
[(40)] .46678 .01472 0 2 Msboxa
[(60)] .68826 .01472 0 2 Msboxa
[(80)] .90975 .01472 0 2 Msboxa
[(Gen.)] 1.025 .01472 -1 0 Msboxa
[(10)] .01131 .14552 1 0 Msboxa
[(20)] .01131 .27632 1 0 Msboxa
[(30)] .01131 .40712 1 0 Msboxa
[(40)] .01131 .53792 1 0 Msboxa
[(Fit.)] .02381 .61803 0 -4 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
.002 w
.24529 .01472 m
.24529 .02097 L
s
P
[(20)] .24529 .01472 0 2 Mshowa
p
.002 w
.46678 .01472 m
.46678 .02097 L
s
P
[(40)] .46678 .01472 0 2 Mshowa
p
.002 w
.68826 .01472 m
.68826 .02097 L
s
P
[(60)] .68826 .01472 0 2 Mshowa
p
.002 w
.90975 .01472 m
.90975 .02097 L
s
P
[(80)] .90975 .01472 0 2 Mshowa
p
.001 w
.06811 .01472 m
.06811 .01847 L
s
P
p
.001 w
.1124 .01472 m
.1124 .01847 L
s
P
p
.001 w
.1567 .01472 m
.1567 .01847 L
s
P
p
.001 w
.201 .01472 m
.201 .01847 L
s
P
p
.001 w
.28959 .01472 m
.28959 .01847 L
s
P
p
.001 w
.33389 .01472 m
.33389 .01847 L
s
P
p
.001 w
.37818 .01472 m
.37818 .01847 L
s
P
p
.001 w
.42248 .01472 m
.42248 .01847 L
s
P
p
.001 w
.51107 .01472 m
.51107 .01847 L
s
P
p
.001 w
.55537 .01472 m
.55537 .01847 L
s
P
p
.001 w
.59967 .01472 m
.59967 .01847 L
s
P
p
.001 w
.64396 .01472 m
.64396 .01847 L
s
P
p
.001 w
.73256 .01472 m
.73256 .01847 L
s
P
p
.001 w
.77685 .01472 m
.77685 .01847 L
s
P
p
.001 w
.82115 .01472 m
.82115 .01847 L
s
P
p
.001 w
.86545 .01472 m
.86545 .01847 L
s
P
p
.001 w
.95404 .01472 m
.95404 .01847 L
s
P
p
.001 w
.99834 .01472 m
.99834 .01847 L
s
P
[(Gen.)] 1.025 .01472 -1 0 Mshowa
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .14552 m
.03006 .14552 L
s
P
[(10)] .01131 .14552 1 0 Mshowa
p
.002 w
.02381 .27632 m
.03006 .27632 L
s
P
[(20)] .01131 .27632 1 0 Mshowa
p
.002 w
.02381 .40712 m
.03006 .40712 L
s
P
[(30)] .01131 .40712 1 0 Mshowa
p
.002 w
.02381 .53792 m
.03006 .53792 L
s
P
[(40)] .01131 .53792 1 0 Mshowa
p
.001 w
.02381 .04088 m
.02756 .04088 L
s
P
p
.001 w
.02381 .06704 m
.02756 .06704 L
s
P
p
.001 w
.02381 .0932 m
.02756 .0932 L
s
P
p
.001 w
.02381 .11936 m
.02756 .11936 L
s
P
p
.001 w
.02381 .17168 m
.02756 .17168 L
s
P
p
.001 w
.02381 .19784 m
.02756 .19784 L
s
P
p
.001 w
.02381 .224 m
.02756 .224 L
s
P
p
.001 w
.02381 .25016 m
.02756 .25016 L
s
P
p
.001 w
.02381 .30248 m
.02756 .30248 L
s
P
p
.001 w
.02381 .32864 m
.02756 .32864 L
s
P
p
.001 w
.02381 .3548 m
.02756 .3548 L
s
P
p
.001 w
.02381 .38096 m
.02756 .38096 L
s
P
p
.001 w
.02381 .43328 m
.02756 .43328 L
s
P
p
.001 w
.02381 .45944 m
.02756 .45944 L
s
P
p
.001 w
.02381 .4856 m
.02756 .4856 L
s
P
p
.001 w
.02381 .51176 m
.02756 .51176 L
s
P
p
.001 w
.02381 .56408 m
.02756 .56408 L
s
P
p
.001 w
.02381 .59024 m
.02756 .59024 L
s
P
p
.001 w
.02381 .6164 m
.02756 .6164 L
s
P
[(Fit.)] .02381 .61803 0 -4 Mshowa
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
P
MathSubEnd
P
% End of sub-graphic
P
MathSubEnd
P
% End of sub-graphic
p
p
.7965 .0715 m
.7965 .35901 L
.97619 .35901 L
.97619 .0715 L
F
1 g
.77853 .08946 m
.77853 .37698 L
.95822 .37698 L
.95822 .08946 L
F
0 g
.001 w
.77853 .08946 m
.95822 .08946 L
.95822 .37698 L
.77853 .37698 L
.77853 .08946 L
s
% Start of sub-graphic
p
0.778527 0.089465 0.958221 0.376976 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.029762 0.297619 0.043478 0.434783 [
[ 0 0 0 0 ]
[ 1 1.6 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 1.6 L
0 1.6 L
closepath
clip
newpath
p
p
p
p
1 g
.05357 .07826 m
.05357 .51304 L
.35119 .51304 L
.35119 .07826 L
F
P
[(Worst)] .38988 .29565 -1 0 Mshowa
P
p
p
.8 g
.05357 .58261 m
.05357 1.01739 L
.35119 1.01739 L
.35119 .58261 L
F
P
[(Mean)] .38988 .8 -1 0 Mshowa
P
p
p
.4 g
.05357 1.08696 m
.05357 1.52174 L
.35119 1.52174 L
.35119 1.08696 L
F
P
[(Best)] .38988 1.30435 -1 0 Mshowa
P
P
p
P
P
MathSubEnd
P
% End of sub-graphic
P
P
P
0 0 m
1 0 L
1 .46644 L
0 .46644 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{339, 158},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005C0000WPP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0E0000?l0E0000?l0E0000?l0E0000?l0
E0000?l0E0000?l0E00004D01?l300;o8003o`<00_lP00;o1002ob000_l400;oS@0004H000?o0000
0P001?l00?lP0005o`000?l00P000ol0000L0004o`00o`8000Co003o7P001?l00?l20004o`00oh`0
00170005o`000?l00P000ol0000L00Co0P001?l00?lN0004o`00o`8000Co003o7P001?l00?l20004
o`00oh`000180004o`00o`8000?o000070000ol0o`030004o`00oah00ol30004o`00oal00_l30004
o`00oh`000150004o`00o`8000Co003o7P000ol0o`030004o`00oah000?o00000`001?l00?lN0004
o`00o`8000Co003oS00004H00_l400;o8002o`@00_lP00?o0`02ob000_l400;oS@000?l0E0000?l0
E0000?l0E0000?l0E000024000?o0000]004o`<01?l0103oo`02o`800_mV00008@000ol0002c0005
o`000?l00P000ol000030004o`00o`<00_mV00007@2go`<000?o0?l00_l200Go00D0o`00o`1[0000
8@000ol000050003o`0000H000?o00001@000ol000050003o`0000D000?o00001@000ol000050003
o`0000D000?o00001@000ol000050003o`0000D000?o00001@000ol000050003o`0000D000?o0000
1@000ol000050003o`0000D000?o00001@000ol000050003o`0000D000?o00001@000ol000050003
o`00008000?o000010001ol0003o0?l00P000ol0001Y00008@000ol0002c0005o`000?l00`03o`03
0?oo00?oJ`00024000?o0?l09Ol504?o0`0Ko`<01Ol500Go0`0;o`T01?mg00008@000ol0F`0TF`03
o`00008000?oFe/0@E/00ol0o`0KF`03o`3o00EK00?o00000P000omKF`02F`03o`3o00YKQ@000240
0_lUF`05o`000?l0AE/00omKF`0KF`03oe]K00EK00Co003o1U/00omKF`09FhD0000Q0003o`3o00;o
8e/01?l00?m/F`03o`3o019KQ@00024000Go0861o`0SF`03o`3o06iK00?oFe/04E/n03go2P000240
00?o08400X400omKF`0PF`03o`3o089K?P0mo`X0000Q0003o`2100:100?oFe/08E/2oh9K?P0mo`X0
000Q00;o18400omKF`0PF`03oe]K085K?P0mo`X0000Q0003o`2100B100?oFe/0Xe/n03go2P000240
00?o08401H42o`AK0onLFcP0@ol:00008@000ol0P@07P@;o00=Koh400X400omKF`2IFcP000?o0000
>P06o`X0000Q0003o`2100V100?oPH400h400omKF`2HFcP000?o0000>P06o`X0000Q00Wo2X400omK
F`08F`?oS5/h0003o`0003X01_l:00008@000ol000060003oh6100R100?oFe/00e/4o`>100?oFe/0
RE/h0003o`0003X01_l:00008@000ol000070003oh6100R11Ol8P@03oe]K08QK>0000ol0000j00Ko
2P00024000?o00001`000on1P@0FP@03oe]K08MK>0000ol0000j00Ko2P0002400_l80003oh6101J1
00?oFe/0Qe/h0003o`0003X01_l:00008@000ol000070003oh6101N100?oFe/0QU/h0003o`0003X0
1_l:00008@000ol000080003oh6101J100?oFe/0QU/h0003o`0003X01_l:00005003o`@00_l40003
o`0000P000?oPH405h42ohIK>0000ol0000j00Ko2P0001D000?o00000P001?l00?l30003o`0000P0
00?oPH406H400omKF`23FcP000?o0000>P06o`X0000E0003o`00008000Co003o0`03o`P000?oPH40
6H400omKF`23FcP000?o0000>P06o`X0000E0003o`00008000Co003o0`000ol000080003oh6101V1
00?oFe/0Pe/h0003o`0003X01_l:00005@000ol000020004o`00o`<000?o000020000on1P@0JP@03
oe]K089K>0000ol0000j00Ko2P0001@00_l500;o10000ol000090003oh6101V100?oFe/0PU/h0003
o`0003X01_l:00008@000ol000090003oh6101V100?oFe/0PU/h0003o`0001H000Co003o0`03o`80
1?l200Co0`03o`P01_l:00008@02o`X02?lDP@03oe]K089K>0000ol0000F0004o`00o`8000Go0000
o`020003o`0000D000Go0000o`020003o`0000D01_l:00008@000ol0000A0003oh6101:100?oFe/0
PE/h0003o`0001H01?l20005o`000?l00P000ol0000200Co0`000ol0000800Ko2P00024000?o0000
4P0=o`N10_n2FcP000?o00005P001?l0ool20005o`000?l00P02o`<000?o000010000ol0000800Ko
2P00024000?o00007P000on1P@07P@03oe]K07mK>0000ol0000F0004o`00o`<00ol200;o00@0ool0
1?l200Co2006o`X0000Q0003o`0001h000?oPH4028400omKF`0:F`03oe]K075K>0000ol0000E00;o
0P02oa@000?o00002006o`X0000Q00;o80000on1P@08P@03oe]K00UK00?oFe/00e/00omKF`1[FcP0
00?o0000;`000ol0000800Ko2P00024000?o00007`000on1P@09P@03oe]K00=K0_l3F`03oe]K00=K
00?oFe/0Je/h0003o`0003X01_l:00008@000ol0000O0003oh6100Z10_l01E_ooh7o009K0_l5F`;o
K5/h0003o`0003X01_l:00008@000ol0000O0003oh6100b100GoPH61o`02F`;o15/01?n1POm[FcP0
00?o0000>P06o`X0000Q00;o80000on1P@0AP@05oe_oPOl00e/01?n1POm[FcP000?o0000>P06o`X0
000Q0003o`00020000?oPH4048401OmKoh7o00=K00CoPH7o2E/00omKF`1OFcP000?o0000>P06o`X0
000Q0003o`00020000?oPH4048401OmKoh7o00=K00GoPH61o`08F`03oe]K05mK>0000ol0000j00Ko
2P00024000?o000080000on1P@0AP@04oh61o`9K00?oPH400X400omKF`06F`03oe]K05mK>0000ol0
000j00Ko2P00024000?o00008@000on1P@0@P@04oh61o`9K00?oPH400X400omKF`05F`03oh7o061K
>0000ol0000j00Ko2P0002400_lS0003oh6101:100CoFe_o1H44o`=K00?oPOl00U/00omKF`0;F`03
oe]K00]K00?oFe/0?e/h0003o`0003X01_l:00008@000ol0000R0003oh6101:100?oFol01X401On1
PH7o009K00?oPOl00U/2o`aK00?oFe/02e/00omKF`0oFcP000?o0000>P06o`X0000Q0003o`000280
00?oPH404h42o`Z100CoFe_o0X42o`:100?oFe/025/00on1o`0<F`;o@5/h0003o`0003X01_l:0000
5004o`<00_l40003o`0002<000?oPH404X42o`^10_l3P@05oh61POl02U/00on1o`0<F`03oh7o03mK
>0000ol0000j00Ko2P0001D000?o00000P001?l00?l30003o`0002<000?oPH404X400on1P@0;P@03
oh6100J100?oFe/01U/01?n1POl<F`03oh7o03mK>0000ol0000j00Ko2P0001H000Go0000o`020004
o`0000?o8`000on1P@0BP@03oh6101B100?oFe/01U/01On1PH7o00]K00?oPOl0?e/h0003o`00019K
:006o`X0000G0004o`00o`8000Go0000o`0V0003oh6102V10ol4F`03oh6100:10_l4F`03oe]K00=K
00?oPOl0?e/h0003o`00019K:006o`X0000D0004o`00o`8000Co003o0`000ol0000T0003oh6102^1
00?oFe/00U/00on1P@04P@05oe]KFol015/01?n1POloFcP000?o00004U/X00Ko2P0001D00_l400;o
10000ol0000T0003oh6102^100GoFe]Ko`07P@06oe]Koh7o0e/01On1PH7o03iK00?o0000=@000ol0
000BFbP01_l:00008@000ol0000T0003oh6102b100CoFe_o28401OmKoh7o00=K00GoPH61o`0nF`03
o`0003D000?o00004U/X00Ko2P0002400_lU0003oh6102b100?oFol02H400omKo`02P@04oe]Ko`>1
00?oFe/0>e/00ol0000f0003o`00019K:006o`X0000Q0003o`0002@000?oPH40;8400omKo`09P@;o
0h401?mKFol3P@03oe]K03]K00?o0000=P000ol0000BFbP01_l:00008@000ol0000U0003oh6102^1
00?oFol02X401On1PH7o009K00GoPH61o`0mF`03o`0003H000?o00004U/X00Ko2P00024000?o0000
9@000on1P@0/P@03oh6100f100CoFe_o0h400omKF`0jF`03oh4003L000?o00004U/X00Ko2P000240
0_lV0003oh6102b100?oPH403H401?mKFol3P@03oe]K03YK00?oP@00=`000ol0000BFbP01_l:0000
8@000ol0000U0003oh6103f100?oFol00h400omKF`04F`05oe]KFol0<5/00on1P@0h0003o`00019K
10001Ol0003o00801?l00`3oo`03o`040?oo00;o3@06o`X0000Q0003o`0002D000?oPH40?H400omK
o`04P@03oe]K00=K00CoFe]K0_l_F`03oh6103P000?o00004U/40007o`000?l0o`050004o`00o`80
00Co003o3P06o`X0000Q0003o`0002D000?oPH40?H400omKo`04P@03oe]K009K00GoPOmKo`02P@03
oe]K02EK00?oFe/00e/01?n1PH4h0003o`00019K10001_l0o`3o00Go00<0ool00_l20004o`00o`h0
1_l:00008@000ol0000U0003oh6103f100?oFol018400omKF`02F`05oh7oFol00X400omKF`0MF`03
oe]K00EK0_l4F`04oh61PCP000?o00004U/40007o`3o0?l0o`030003o`00008000Co003o0P000ol0
000<00Ko2P0002400_lV0003oh6103f100?oFol018401OmKFe_o00>100?oPH400X400omKF`0LF`03
oe]K00EK00?oPOl00e/01?n1PH4h0003o`00019K1002o`030?oo00800ol300?o00<0ool00ol>00Ko
2P00024000?o00009@000on1P@0mP@;o1H401OmKFe_o00R100?oFe/02U/00omKF`0?F`03oe]K00AK
00CoPH7o0U/00on1P@02PCP000?o00004U/300;o0`02oah01_l:00008@000ol0000V0003oh6103b1
0_l6P@03oe_o00V100?oFe/02U/00omKF`0?F`03oe]K00AK00CoPH7o0U/00on1P@02PCP000?o0000
4U/X00Ko2P00024000?o00009P000on1P@0lP@;o1X400omKo`0:P@03oe]K00QK0_lAF`03oe]K00AK
00OoPH61oe_o00B1>0000ol0000BFbP01_l:00008@000ol0000V0003oh6103f100?oPH401H400on1
P@09P@03oe]K00QK0_lAF`;o1E/01on1PH7oFol0184h0003o`00019K:006o`X0000Q00;o9`05oc^1
00?oPH404X400omKF`07F`03oh7o011K0_l4F`03oh6100:100?oFol0184h0003o`00019K:006o`X0
000Q0003o`0002X000?oPH40>H400on1P@0BP@03oe]K00IK00CoPH7o3e/00on1o`04F`03oh6100:1
0_l5PCP000?o00004U/X00Ko2P00024000?o0000:P000on1P@0iP@03oh6101:100?oFe/01U/01?n1
POl?F`03oh7o00AK00?oPH400h400on1P@03PCP000?o00004U/X00Ko2P0001@00ol400;o10000ol0
000Z0003oh6104n100?oFe/01E/01?n1POl?F`03oh7o00=K00?oPH4018400on1P@03PCP000?o0000
4U/X00Ko2P0001L000Co003o0P001Ol0003o02d000?oPH40CX400omKF`05F`04oh61o`mK00?oPOl0
0e/00on1P@0:PCP000?o00004U/X00Ko2P0001L000Co003o0P001?l00003ob/000?oPH40CX400omK
F`04F`03oh6100:100?oFe/035/00on1o`03F`03oh6100Z1>0000ol0000BFbP01_l:00005@02o`<0
00Co003o0`000ol0000[0003oh6104n100?oFe/00e/00on1P@02P@03oe]K00aK00?oPOl00U/00on1
P@0;PCP000?o00004U/X00Ko2P0001L000Co003o0P001Ol0003o02d000?oPH40Ch400omKF`03F`03
oh6100:10ol<F`06oh61oe_o3H4h0003o`0003X01_l:00005003o`@00_l40003o`0002/000?oPH40
Ch400omKF`03F`03oh6100B100?oFe/02U/00on1P@02o`j1>0000ol0000j00Ko2P0002400_l/0003
oh6104n100?oFe/00U/00on1P@06P@03oe]K00UK00?oPH400_l>PCP000?o0000>P06o`X0000Q0003
o`0002`000?oPH40Ch401OmKFe_o00R100?oFe/015/00omKF`02F`04oh61o`n1>0000ol0000j00Ko
2P00024000?o0000;0000on1P@1?P@05oe]KFol02H400omKF`02F`;o15/00on1P@0@PCP000?o0000
4X4X00Ko2P00024000?o0000;00IocV100CoFe_o2X401omKFe_oPOl015/00on1P@0@PCP000?o0000
4X4X00Ko2P00024000?o0000A@000on1P@0gP@03oe_o00Z100GoFe]Ko`02P@05oe]KFol04X4h0003
o`0001:1:006o`X0000Q00;oA`05ocB100?oFol02h400omKo`03P@04oe]Koa>1>0000ol0000BPBP0
1_l:00008@000ol0001:0003oh6103:10_l<P@03oe_o00>100CoFe_o4h4h0003o`0001:1:006o`X0
000Q0003o`0004X000?oPH40<h400on1P@0:P@03oe_o00>100CoFe_o4h4h0003o`0001:1:006o`X0
000Q0003o`0004X000?oPH40@H400on1P@02P@04oe]Koa>1>0000ol0000BPBP01_l:00008@000ol0
001:0003oh61046100?oPH400h400omKo`0CPCP000?o00004X4X00Ko2P0002400_m;0003oh6104N1
0olCPCP000?o00004X4X00Ko2P00024000?o0000BP000on1P@1MPCP000?o00004X4X00Ko2P000240
00?o0000B`000on1P@1LPCP000?o00004X4X00Ko2P00024000?o0000B`000on1P@1LPCP000?o0000
4X4300Co1004o`030?oo00;o0`03o`h01_l:00008@000ol0001;0003oh6105b1>0000ol0000BP@@0
00Co003o0P000ol000060005o`000?l00P000ol0000;00Ko2P0002400_m<0003oh6105b1>0000ol0
000BP@@000Co003o0P05o`030?oo00;o0`000ol0000>00Ko2P00024000?o0000B`000on1P@1LPCP0
00?o00004X4400?o0`001ol0003o0?l01P000ol0000>00Ko2P0001D00ol300;o10000ol0001;0003
oh6105b1>0000ol0000BP@@000Co003o0`03o`801?l200Co3P06o`X0000F0005o`000?l00P001Ol0
003o04d000?oPH40G84h0003o`0001:10`04oa0000?o00003P06o`X0000D00Co0P001?l00?l300?o
B`000on1P@1LPCP000?o00004X4G0003o`0000h01_l:000050000ol0o`030004o`00o`<000?o0000
B`000on1P@1LPCP000?o00004X4X00Ko2P0001@000?o0?l00`001?l00?l30003o`0004/000?oPH40
G84h0003o`0001:1:006o`X0000E00;o1002o`@000?o0000B`000on1P@1LPCP000?o00004X4X00Ko
2P00024000?o0000B`000on1P@1LPCP000?o00004X4X00Ko2P0002400_m=0003oh6105^1>0000ol0
000BPBP01_l:00008@000ol0001<0003oh6105^1>0000ol0000BPBP01_l:00008@000ol0001<0003
oh6105^1>0000ol0000BPBP01_l:00008@000ol0001<0003oh6105^1>0000ol0000BPBP000?o0000
3@00024000?o0000C0000on1P@1KPCP000?o00004X4X0003o`0000d0000Q00;oC@0YocF1>0000ol0
000j0003o`0000d0000Q0003o`0007D000?oPH40<X4h0003o`0003X000?o00003@00024000?o0000
MP0eocL000?o0000>P000ol0000=00008@000ol0003R03ko3`00024000?o0000o`0`00008@02ool0
<@000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0
E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E0000?l0E00001D00ol400Go0P03o`<0
0_oo02T0000F0003o`0000D000?o00000P001?l00?l200;oo`0Y00005P000ol000050003o`000080
00?o0000o`0^00005P03o`D000?o00000P000ol0003o02h0000F0003o`0000@00_l300Coo`0^0000
5@05o`T000?o0000o`0^00007P000ol000020003o`000?l0;P000?l0E0000?l0E0000?l0E0000?l0
E0000001\
\>"],
  ImageRangeCache->{{{0, 338}, {157, 0}} -> {-1.07208, -0.648941, 0.00826677, \
0.00826677}, {{8.6875, 250.625}, {153.25, 3.6875}} -> {-0.0359134, \
-0.0252112, 0.00413334, 0.00668788}, {{8.6875, 250.625}, {153.188, 3.6875}} -> \
{-16.8835, -7.92431, 0.497538, 0.421234}, {{262.75, 323.188}, {126.875, \
30.0625}} -> {-14.7077, -1.2486, 0.0555952, 0.0380562}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Ant Tracker",
    FontSlant->"Italic"],
  " behaviours"
}], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Visualization function", "Subsubsection"],

Cell[CellGroupData[{

Cell["\<\
$RecursionLimit = 1000;
Map[
  showAnt[$basicDirectory,$basicExperiment,#//First,1,
    Generation -> (#//First),
    Fitness -> N[bestFits[[#//First]],2]]&,
    newChampPositions-1
];
\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1
Ant: 1\
\>", "Print",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 0", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.365638 1.750763 0.003587 0.97211 [
[(Gen.0, Ind.1, Fit.6.)] .5 1 0 -1.5 Msboxa
[(5)] .22214 .09993 .8366 1 Msboxa
[(10)] .37123 .06774 .7928 1 Msboxa
[(15)] .52425 .0347 .74901 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28793 .02348 .79718 1 Msboxa
P
[(5)] .71504 .06896 -1 .37818 Msboxa
[(10)] .79141 .12769 -1 .36696 Msboxa
[(15)] .86428 .18373 -1 .35638 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88662 .10096 -1 .36805 Msboxa
P
[(0)] .09805 .15241 1 -0.38552 Msboxa
[(10)] .08193 .29655 1 -0.36308 Msboxa
[(20)] .06446 .45294 1 -0.33866 Msboxa
[(30)] .04543 .62322 1 -0.31199 Msboxa
[(40)] .02465 .80932 1 -0.28273 Msboxa
[(t)] -0.03909 .47162 1 -0.33879 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.0, Ind.1, Fit.6.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11999 .13426 m
.63084 .0243 L
s
P
p
.002 w
.23618 .10925 m
.24321 .11391 L
s
P
[(5)] .22214 .09993 .8366 1 Mshowa
p
.002 w
.38482 .07726 m
.39162 .08202 L
s
P
[(10)] .37123 .06774 .7928 1 Mshowa
p
.002 w
.53737 .04442 m
.54393 .04929 L
s
P
[(15)] .52425 .0347 .74901 1 Mshowa
p
.001 w
.26561 .10292 m
.26979 .10573 L
s
P
p
.001 w
.29518 .09655 m
.29934 .09937 L
s
P
p
.001 w
.32491 .09015 m
.32904 .09299 L
s
P
p
.001 w
.35479 .08372 m
.35889 .08657 L
s
P
p
.001 w
.41501 .07076 m
.41906 .07363 L
s
P
p
.001 w
.44536 .06423 m
.44939 .06711 L
s
P
p
.001 w
.47587 .05766 m
.47987 .06055 L
s
P
p
.001 w
.50654 .05106 m
.5105 .05396 L
s
P
p
.001 w
.20691 .11555 m
.21115 .11834 L
s
P
p
.001 w
.17779 .12182 m
.18206 .12459 L
s
P
p
.001 w
.14882 .12806 m
.15311 .13082 L
s
P
p
.001 w
.56836 .03775 m
.57227 .04068 L
s
P
p
.001 w
.59952 .03104 m
.60339 .03399 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28793 .02348 .79718 1 Mshowa
P
P
p
p
.002 w
.63084 .0243 m
.88577 .22015 L
s
P
p
.002 w
.69457 .07326 m
.68433 .07541 L
s
P
[(5)] .71504 .06896 -1 .37818 Mshowa
p
.002 w
.77087 .13188 m
.76059 .13397 L
s
P
[(10)] .79141 .12769 -1 .36696 Mshowa
p
.002 w
.84367 .18781 m
.83336 .18985 L
s
P
[(15)] .86428 .18373 -1 .35638 Mshowa
p
.001 w
.71012 .08521 m
.70397 .08649 L
s
P
p
.001 w
.72552 .09704 m
.71937 .09832 L
s
P
p
.001 w
.74078 .10877 m
.73463 .11003 L
s
P
p
.001 w
.75589 .12038 m
.74974 .12164 L
s
P
p
.001 w
.7857 .14327 m
.77953 .14452 L
s
P
p
.001 w
.80039 .15456 m
.79422 .15581 L
s
P
p
.001 w
.81495 .16575 m
.80878 .16698 L
s
P
p
.001 w
.82938 .17683 m
.8232 .17806 L
s
P
p
.001 w
.67887 .0612 m
.67273 .0625 L
s
P
p
.001 w
.66301 .04902 m
.65688 .05032 L
s
P
p
.001 w
.64701 .03672 m
.64088 .03803 L
s
P
p
.001 w
.85783 .19869 m
.85164 .19991 L
s
P
p
.001 w
.87186 .20947 m
.86567 .21068 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88662 .10096 -1 .36805 Mshowa
P
P
p
p
.002 w
.11999 .13426 m
.04377 .82359 L
s
P
p
.002 w
.11847 .14804 m
.12868 .14586 L
s
P
[(0)] .09805 .15241 1 -0.38552 Mshowa
p
.002 w
.1025 .2924 m
.11279 .29033 L
s
P
[(10)] .08193 .29655 1 -0.36308 Mshowa
p
.002 w
.08518 .44904 m
.09555 .4471 L
s
P
[(20)] .06446 .45294 1 -0.33866 Mshowa
p
.002 w
.06633 .6196 m
.07677 .61779 L
s
P
[(30)] .04543 .62322 1 -0.31199 Mshowa
p
.002 w
.04571 .80601 m
.05624 .80436 L
s
P
[(40)] .02465 .80932 1 -0.28273 Mshowa
p
.001 w
.11538 .176 m
.12151 .1747 L
s
P
p
.001 w
.11223 .20441 m
.11838 .20312 L
s
P
p
.001 w
.10904 .23327 m
.1152 .232 L
s
P
p
.001 w
.1058 .2626 m
.11196 .26134 L
s
P
p
.001 w
.09915 .3227 m
.10533 .32147 L
s
P
p
.001 w
.09575 .3535 m
.10194 .35229 L
s
P
p
.001 w
.09229 .38482 m
.09849 .38362 L
s
P
p
.001 w
.08877 .41666 m
.09497 .41547 L
s
P
p
.001 w
.08154 .48198 m
.08777 .48083 L
s
P
p
.001 w
.07784 .5155 m
.08407 .51436 L
s
P
p
.001 w
.07407 .54959 m
.08031 .54847 L
s
P
p
.001 w
.07023 .58429 m
.07649 .58318 L
s
P
p
.001 w
.06235 .65555 m
.06863 .65448 L
s
P
p
.001 w
.0583 .69214 m
.06459 .69109 L
s
P
p
.001 w
.05418 .72941 m
.06048 .72837 L
s
P
p
.001 w
.04999 .76736 m
.0563 .76634 L
s
P
[(t)] -0.03909 .47162 1 -0.33879 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11847 .14804 m
.40203 .32759 L
s
P
p
.4 g
.002 w
.1025 .2924 m
.39797 .46762 L
s
P
p
.4 g
.002 w
.08518 .44904 m
.3936 .61861 L
s
P
p
.4 g
.002 w
.06633 .6196 m
.38887 .7819 L
s
P
p
.4 g
.002 w
.04571 .80601 m
.38374 .95906 L
s
P
p
.4 g
.002 w
.19042 .17913 m
.12934 .86193 L
s
P
p
.4 g
.002 w
.27489 .23294 m
.23116 .90755 L
s
P
p
.4 g
.002 w
.35565 .28438 m
.3277 .95081 L
s
P
.002 w
.11999 .13426 m
.04377 .82359 L
s
.04377 .82359 m
.38326 .9757 L
s
.38326 .9757 m
.40242 .31418 L
s
.40242 .31418 m
.11999 .13426 L
s
.63084 .0243 m
.88577 .22015 L
s
.88577 .22015 m
.95623 .89675 L
s
.95623 .89675 m
.65581 .72845 L
s
.65581 .72845 m
.63084 .0243 L
s
.11999 .13426 m
.04377 .82359 L
s
.04377 .82359 m
.65581 .72845 L
s
.65581 .72845 m
.63084 .0243 L
s
.63084 .0243 m
.11999 .13426 L
s
p
.4 g
.51264 .29274 m
.51316 .9578 L
s
P
p
.4 g
.65339 .26536 m
.6797 .93485 L
s
P
p
.4 g
.79757 .23731 m
.85104 .91125 L
s
P
p
.4 g
.40203 .32759 m
.88719 .23377 L
s
P
p
.4 g
.39797 .46762 m
.90202 .3762 L
s
P
p
.4 g
.3936 .61861 m
.91807 .53027 L
s
P
p
.4 g
.38887 .7819 m
.93548 .69749 L
s
P
p
.4 g
.38374 .95906 m
.95445 .87961 L
s
P
.40242 .31418 m
.88577 .22015 L
s
.88577 .22015 m
.95623 .89675 L
s
.95623 .89675 m
.38326 .9757 L
s
.38326 .9757 m
.40242 .31418 L
s
p
.4 g
.23618 .10925 m
.51264 .29274 L
s
P
p
.4 g
.38482 .07726 m
.65339 .26536 L
s
P
p
.4 g
.53737 .04442 m
.79757 .23731 L
s
P
p
.4 g
.19042 .17913 m
.69457 .07326 L
s
P
p
.4 g
.27489 .23294 m
.77087 .13188 L
s
P
p
.4 g
.35565 .28438 m
.84367 .18781 L
s
P
P
p
.002 w
.40803 .32002 m .41574 .32494 L .40203 .32759 L p
.4 g
F P
s
P
p
.002 w
.40203 .32759 m .39429 .32269 L .40803 .32002 L p
.4 g
F P
s
P
p
.002 w
.88719 .23377 m .40203 .32759 L .11847 .14804 L p
.9 g
F P
s
P
p
.002 w
.42949 .32228 m .41574 .32494 L p
.40803 .32002 L .4 g
F P
s
P
p
.002 w
.40803 .32002 m .39429 .32269 L .38652 .31777 L p
.4 g
F P
s
P
p
.002 w
.43559 .31468 m .44327 .31961 L .42949 .32228 L p
.4 g
F P
s
P
p
.002 w
.40803 .32002 m .43559 .31468 L p
.42949 .32228 L .4 g
F P
s
P
p
.002 w
.38652 .31777 m .37871 .31282 L p
.40803 .32002 L .4 g
F P
s
P
p
.002 w
.37871 .31282 m .39249 .31014 L .40803 .32002 L p
.4 g
F P
s
P
p
.002 w
.45708 .31694 m .44327 .31961 L p
.43559 .31468 L .4 g
F P
s
P
p
.002 w
.46329 .30931 m .47092 .31427 L .45708 .31694 L p
.4 g
F P
s
P
p
.002 w
.43559 .31468 m .46329 .30931 L p
.45708 .31694 L .4 g
F P
s
P
p
.002 w
.4848 .31158 m .47092 .31427 L p
.46329 .30931 L .4 g
F P
s
P
p
.002 w
.39249 .31014 m .37871 .31282 L .37087 .30786 L p
.4 g
F P
s
P
p
.002 w
.49112 .30391 m .49871 .30889 L .4848 .31158 L p
.4 g
F P
s
P
p
.002 w
.46329 .30931 m .49112 .30391 L p
.4848 .31158 L .4 g
F P
s
P
p
.002 w
.37087 .30786 m .36299 .30287 L p
.39249 .31014 L .4 g
F P
s
P
p
.002 w
.36299 .30287 m .37681 .30016 L .39249 .31014 L p
.4 g
F P
s
P
p
.002 w
.51265 .3062 m .49871 .30889 L p
.49112 .30391 L .4 g
F P
s
P
p
.002 w
.51908 .29849 m .52663 .30349 L .51265 .3062 L p
.4 g
F P
s
P
p
.002 w
.49112 .30391 m .51908 .29849 L p
.51265 .3062 L .4 g
F P
s
P
p
.002 w
.54064 .30079 m .52663 .30349 L p
.51908 .29849 L .4 g
F P
s
P
p
.002 w
.37681 .30016 m .36299 .30287 L .35508 .29786 L p
.4 g
F P
s
P
p
.002 w
.54717 .29304 m .55468 .29807 L .54064 .30079 L p
.4 g
F P
s
P
p
.002 w
.51908 .29849 m .54717 .29304 L p
.54064 .30079 L .4 g
F P
s
P
p
.002 w
.35508 .29786 m .34714 .29283 L p
.37681 .30016 L .4 g
F P
s
P
p
.002 w
.34714 .29283 m .361 .2901 L .37681 .30016 L p
.4 g
F P
s
P
p
.002 w
.56876 .29535 m .55468 .29807 L p
.54717 .29304 L .4 g
F P
s
P
p
.002 w
.57541 .28757 m .58287 .29262 L .56876 .29535 L p
.4 g
F P
s
P
p
.002 w
.54717 .29304 m .57541 .28757 L p
.56876 .29535 L .4 g
F P
s
P
p
.002 w
.43241 .28925 m .40455 .29472 L .38882 .28461 L p
.8 g
F P
s
P
p
.002 w
.57541 .28757 m .54717 .29304 L .53207 .28291 L p
.4 g
F P
s
P
p
.002 w
.361 .2901 m .34714 .29283 L .33915 .28778 L p
.4 g
F P
s
P
p
.002 w
.59701 .28988 m .58287 .29262 L p
.57541 .28757 L .4 g
F P
s
P
p
.002 w
.33915 .28778 m .33114 .2827 L p
.361 .2901 L .4 g
F P
s
P
p
.002 w
.33114 .2827 m .34504 .27994 L .361 .2901 L p
.4 g
F P
s
P
p
.002 w
.60377 .28206 m .61119 .28714 L .59701 .28988 L p
.4 g
F P
s
P
p
.002 w
.57541 .28757 m .60377 .28206 L p
.59701 .28988 L .4 g
F P
s
P
p
.002 w
.46041 .28376 m .43241 .28925 L .41677 .27909 L p
.8 g
F P
s
P
p
.002 w
.38882 .28461 m .41677 .27909 L .43241 .28925 L p
.8 g
F P
s
P
p
.002 w
.53207 .28291 m .56039 .27739 L .57541 .28757 L p
.4 g
F P
s
P
p
.002 w
.6254 .28439 m .61119 .28714 L p
.60377 .28206 L .4 g
F P
s
P
p
.002 w
.41677 .27909 m .38882 .28461 L .37295 .2744 L p
.8 g
F P
s
P
p
.002 w
.63228 .27654 m .63965 .28164 L .6254 .28439 L p
.4 g
F P
s
P
p
.002 w
.60377 .28206 m .63228 .27654 L p
.6254 .28439 L .4 g
F P
s
P
p
.002 w
.41677 .27909 m .44486 .27355 L .46041 .28376 L p
.8 g
F P
s
P
p
.002 w
.56039 .27739 m .53207 .28291 L .51682 .27269 L p
.4 g
F P
s
P
p
.002 w
.34504 .27994 m .33114 .2827 L .32309 .2776 L p
.4 g
F P
s
P
p
.002 w
.65393 .27888 m .63965 .28164 L p
.63228 .27654 L .4 g
F P
s
P
p
.002 w
.32309 .2776 m .315 .27248 L p
.34504 .27994 L .4 g
F P
s
P
p
.002 w
.315 .27248 m .32894 .2697 L .34504 .27994 L p
.4 g
F P
s
P
p
.002 w
.37295 .2744 m .40099 .26884 L .41677 .27909 L p
.8 g
F P
s
P
p
.002 w
.66092 .27098 m .66824 .27611 L .65393 .27888 L p
.4 g
F P
s
P
p
.002 w
.63228 .27654 m .66092 .27098 L p
.65393 .27888 L .4 g
F P
s
P
p
.002 w
.51682 .27269 m .48855 .27824 L .47308 .26798 L p
.8 g
F P
s
P
p
.002 w
.51682 .27269 m .54523 .26712 L .56039 .27739 L p
.4 g
F P
s
P
p
.002 w
.68259 .27334 m .66824 .27611 L p
.66092 .27098 L .4 g
F P
s
P
p
.002 w
.6897 .2654 m .69697 .27055 L .68259 .27334 L p
.4 g
F P
s
P
p
.002 w
.66092 .27098 m .6897 .2654 L p
.68259 .27334 L .4 g
F P
s
P
p
.002 w
.54523 .26712 m .51682 .27269 L .50145 .26239 L p
.8 g
F P
s
P
p
.002 w
.47308 .26798 m .50145 .26239 L .51682 .27269 L p
.8 g
F P
s
P
p
.002 w
.32894 .2697 m .315 .27248 L .30687 .26734 L p
.4 g
F P
s
P
p
.002 w
.6897 .2654 m .66092 .27098 L .64617 .26066 L p
.8 g
F P
s
P
p
.002 w
.71139 .26777 m .69697 .27055 L p
.6897 .2654 L .4 g
F P
s
P
p
.002 w
.30687 .26734 m .29871 .26217 L p
.32894 .2697 L .4 g
F P
s
P
p
.002 w
.29871 .26217 m .3127 .25936 L .32894 .2697 L p
.4 g
F P
s
P
p
.002 w
.71862 .25979 m .72585 .26497 L .71139 .26777 L p
.4 g
F P
s
P
p
.002 w
.6897 .2654 m .71862 .25979 L p
.71139 .26777 L .4 g
F P
s
P
p
.002 w
.57378 .26152 m .54523 .26712 L .52995 .25676 L p
.8 g
F P
s
P
p
.002 w
.50145 .26239 m .52995 .25676 L .54523 .26712 L p
.8 g
F P
s
P
p
.002 w
.71862 .25979 m .6897 .2654 L .67505 .25503 L p
.8 g
F P
s
P
p
.002 w
.64617 .26066 m .67505 .25503 L .6897 .2654 L p
.8 g
F P
s
P
p
1 .015 0 r
.01 w
.6392 .26862 m
.66796 .26303 L
s
P
p
.002 w
.74034 .26217 m .72585 .26497 L p
.71862 .25979 L .4 g
F P
s
P
p
.002 w
.52995 .25676 m .50145 .26239 L .48593 .25198 L p
.4 g
F P
s
P
p
.002 w
.3127 .25936 m .29871 .26217 L .29051 .25698 L p
.4 g
F P
s
P
p
.002 w
.74768 .25416 m .75486 .25936 L .74034 .26217 L p
.4 g
F P
s
P
p
.002 w
.71862 .25979 m .74768 .25416 L p
.74034 .26217 L .4 g
F P
s
P
p
.002 w
.52995 .25676 m .55858 .25111 L .57378 .26152 L p
.8 g
F P
s
P
p
.002 w
.74768 .25416 m .71862 .25979 L .70406 .24937 L p
.8 g
F P
s
P
p
.002 w
.67505 .25503 m .70406 .24937 L .71862 .25979 L p
.8 g
F P
s
P
p
1 .03 0 r
.01 w
.66802 .2644 m
.69693 .25878 L
s
P
p
.002 w
.29051 .25698 m .28228 .25177 L p
.3127 .25936 L .4 g
F P
s
P
p
.002 w
.28228 .25177 m .29631 .24893 L .3127 .25936 L p
.4 g
F P
s
P
p
.002 w
.76942 .25655 m .75486 .25936 L p
.74768 .25416 L .4 g
F P
s
P
p
.002 w
.48593 .25198 m .51452 .24631 L .52995 .25676 L p
.4 g
F P
s
P
p
.002 w
.77688 .24849 m .78402 .25372 L .76942 .25655 L p
.4 g
F P
s
P
p
.002 w
.74768 .25416 m .77688 .24849 L p
.76942 .25655 L .4 g
F P
s
P
p
.002 w
.6313 .25024 m .60247 .25589 L .58736 .24543 L p
.8 g
F P
s
P
p
1 .045 0 r
.01 w
.697 .26015 m
.72606 .2545 L
s
P
p
.002 w
.77688 .24849 m .74768 .25416 L .73322 .24368 L p
.8 g
F P
s
P
p
.002 w
.70406 .24937 m .73322 .24368 L .74768 .25416 L p
.8 g
F P
s
P
p
.002 w
.79865 .25089 m .78402 .25372 L p
.77688 .24849 L .4 g
F P
s
P
p
.002 w
.36899 .24806 m .34078 .25372 L .32448 .24324 L p
.8 g
F P
s
P
p
.002 w
.51452 .24631 m .48593 .25198 L .47027 .24149 L p
.4 g
F P
s
P
p
.002 w
.29631 .24893 m .28228 .25177 L .27401 .24653 L p
.4 g
F P
s
P
p
.002 w
.80623 .2428 m .81331 .24806 L .79865 .25089 L p
.4 g
F P
s
P
p
.002 w
.77688 .24849 m .80623 .2428 L p
.79865 .25089 L .4 g
F P
s
P
p
.002 w
.66026 .24456 m .6313 .25024 L .61628 .23973 L p
.8 g
F P
s
P
p
.002 w
.58736 .24543 m .61628 .23973 L .6313 .25024 L p
.8 g
F P
s
P
p
1 .06 0 r
.01 w
.72614 .25587 m
.75535 .2502 L
s
P
p
.002 w
.27401 .24653 m .2657 .24127 L p
.29631 .24893 L .4 g
F P
s
P
p
.002 w
.2657 .24127 m .27977 .23841 L .29631 .24893 L p
.4 g
F P
s
P
p
.002 w
.80623 .2428 m .77688 .24849 L .76252 .23797 L p
.8 g
F P
s
P
p
.002 w
.73322 .24368 m .76252 .23797 L .77688 .24849 L p
.8 g
F P
s
P
p
.002 w
.39734 .24236 m .36899 .24806 L .35278 .23753 L p
.8 g
F P
s
P
p
.002 w
.32448 .24324 m .35278 .23753 L .36899 .24806 L p
.8 g
F P
s
P
p
.002 w
.82802 .24521 m .81331 .24806 L p
.80623 .2428 L .4 g
F P
s
P
p
.002 w
.47027 .24149 m .49895 .23576 L .51452 .24631 L p
.4 g
F P
s
P
p
.002 w
.83572 .23708 m .84275 .24236 L .82802 .24521 L p
.4 g
F P
s
P
p
.002 w
.80623 .2428 m .83572 .23708 L p
.82802 .24521 L .4 g
F P
s
P
p
.002 w
.68937 .23885 m .66026 .24456 L .64535 .23399 L p
.8 g
F P
s
P
p
.002 w
.61628 .23973 m .64535 .23399 L .66026 .24456 L p
.8 g
F P
s
P
p
.002 w
.76252 .23797 m .79196 .23222 L .80623 .2428 L p
.8 g
F P
s
P
p
1 .075 0 r
.01 w
.75544 .25157 m
.78481 .24587 L
s
P
p
.002 w
.35278 .23753 m .38122 .23178 L .39734 .24236 L p
.8 g
F P
s
P
p
.002 w
.85753 .23951 m .84275 .24236 L p
.83572 .23708 L .4 g
F P
s
P
p
.002 w
.49895 .23576 m .47027 .24149 L .45447 .23089 L p
.4 g
F P
s
P
p
.002 w
.27977 .23841 m .2657 .24127 L .25735 .23598 L p
.4 g
F P
s
P
p
.002 w
.86535 .23134 m .87234 .23664 L .85753 .23951 L p
.4 g
F P
s
P
p
.002 w
.83572 .23708 m .86535 .23134 L p
.85753 .23951 L .4 g
F P
s
P
p
.002 w
.71863 .23311 m .68937 .23885 L .67455 .22823 L p
.8 g
F P
s
P
p
.002 w
.64535 .23399 m .67455 .22823 L .68937 .23885 L p
.8 g
F P
s
P
p
.002 w
.25735 .23598 m .24897 .23067 L p
.27977 .23841 L .4 g
F P
s
P
p
.002 w
.24897 .23067 m .26309 .22779 L .27977 .23841 L p
.4 g
F P
s
P
p
.002 w
.79196 .23222 m .76252 .23797 L .74802 .22734 L p
.8 g
F P
s
P
p
.002 w
.88719 .23377 m .87234 .23664 L p
.86535 .23134 L .4 g
F P
s
P
p
1 .09 0 r
.01 w
.78492 .24725 m
.81444 .24152 L
s
P
p
.002 w
.45447 .23089 m .48324 .22512 L .49895 .23576 L p
.4 g
F P
s
P
p
.002 w
.86535 .23134 m .88023 .22845 L .88719 .23377 L p
.4 g
F P
s
P
p
.002 w
.11847 .14804 m .63134 .03826 L .88719 .23377 L p
.9 g
F P
s
P
p
.002 w
.67455 .22823 m .7039 .22244 L .71863 .23311 L p
.8 g
F P
s
P
p
.002 w
.74802 .22734 m .77757 .22155 L .79196 .23222 L p
.8 g
F P
s
P
p
.002 w
.4098 .22601 m .38122 .23178 L .36495 .2211 L p
.8 g
F P
s
P
p
.002 w
.88023 .22845 m .86535 .23134 L p
.85129 .22065 L .4 g
F P
s
P
p
.002 w
.48324 .22512 m .45447 .23089 L .43852 .22021 L p
.4 g
F P
s
P
p
.002 w
.26309 .22779 m .24897 .23067 L .24055 .22534 L p
.4 g
F P
s
P
p
1 .105 0 r
.01 w
.81456 .2429 m
.84424 .23715 L
s
P
p
.002 w
.87323 .22311 m .88023 .22845 L p
.85129 .22065 L .4 g
F P
s
P
p
.002 w
.7039 .22244 m .67455 .22823 L .65959 .21752 L p
.8 g
F P
s
P
p
.002 w
.24055 .22534 m .23208 .21998 L p
.26309 .22779 L .4 g
F P
s
P
p
.002 w
.23208 .21998 m .24625 .21707 L .26309 .22779 L p
.4 g
F P
s
P
p
.002 w
.77757 .22155 m .74802 .22734 L .7334 .21662 L p
.8 g
F P
s
P
p
.002 w
.36495 .2211 m .39362 .21527 L .4098 .22601 L p
.8 g
F P
s
P
p
.002 w
.43852 .22021 m .46739 .21438 L .48324 .22512 L p
.4 g
F P
s
P
p
.002 w
.85129 .22065 m .86621 .21774 L .87323 .22311 L p
.4 g
F P
s
P
p
1 .12 0 r
.01 w
.84436 .23852 m
.84436 .23852 L
s
P
p
.002 w
.65959 .21752 m .68904 .21168 L .7039 .22244 L p
.8 g
F P
s
P
p
1 .135 0 r
.01 w
.84449 .2399 m
.84449 .2399 L
s
P
p
.002 w
.7334 .21662 m .76304 .21077 L .77757 .22155 L p
.8 g
F P
s
P
p
.002 w
.39362 .21527 m .36495 .2211 L .34852 .21032 L p
.8 g
F P
s
P
p
1 .15 0 r
.01 w
.84462 .24128 m
.84462 .24128 L
s
P
p
.002 w
.86621 .21774 m .85129 .22065 L p
.83709 .20987 L .4 g
F P
s
P
p
.002 w
.46739 .21438 m .43852 .22021 L .42243 .20942 L p
.4 g
F P
s
P
p
.002 w
.24625 .21707 m .23208 .21998 L .22358 .2146 L p
.4 g
F P
s
P
p
1 .165 0 r
.01 w
.84475 .24266 m
.84475 .24266 L
s
P
p
1 .18 0 r
.01 w
.84487 .24405 m
.84487 .24405 L
s
P
p
1 .195 0 r
.01 w
.845 .24543 m
.845 .24543 L
s
P
p
.002 w
.85915 .21235 m .86621 .21774 L p
.83709 .20987 L .4 g
F P
s
P
p
.002 w
.68904 .21168 m .65959 .21752 L .6445 .20671 L p
.8 g
F P
s
P
p
1 .209 0 r
.01 w
.84513 .24681 m
.84513 .24681 L
s
P
p
.002 w
.22358 .2146 m .21505 .20919 L p
.24625 .21707 L .4 g
F P
s
P
p
.002 w
.21505 .20919 m .22925 .20626 L .24625 .21707 L p
.4 g
F P
s
P
p
.002 w
.76304 .21077 m .7334 .21662 L .71864 .2058 L p
.8 g
F P
s
P
p
1 .224 0 r
.01 w
.84526 .2482 m
.84526 .2482 L
s
P
p
1 .239 0 r
.01 w
.84538 .24959 m
.84538 .24959 L
s
P
p
.002 w
.34852 .21032 m .37729 .20444 L .39362 .21527 L p
.8 g
F P
s
P
p
1 .254 0 r
.01 w
.84551 .25097 m
.84551 .25097 L
s
P
p
.002 w
.42243 .20942 m .45139 .20354 L .46739 .21438 L p
.4 g
F P
s
P
p
1 .269 0 r
.01 w
.84564 .25236 m
.84564 .25236 L
s
P
p
1 .284 0 r
.01 w
.84577 .25375 m
.84577 .25375 L
s
P
p
.002 w
.6445 .20671 m .6151 .21258 L .59977 .20172 L p
.4 g
F P
s
P
p
.002 w
.83709 .20987 m .85207 .20693 L .85915 .21235 L p
.4 g
F P
s
P
p
1 .299 0 r
.01 w
.8459 .25514 m
.8459 .25514 L
s
P
p
.002 w
.6445 .20671 m .67405 .20081 L .68904 .21168 L p
.8 g
F P
s
P
p
1 .314 0 r
.01 w
.84602 .25654 m
.84602 .25654 L
s
P
p
.002 w
.79283 .2049 m .76304 .21077 L .74838 .1999 L p
.8 g
F P
s
P
p
.002 w
.71864 .2058 m .74838 .1999 L .76304 .21077 L p
.8 g
F P
s
P
p
1 .329 0 r
.01 w
.84615 .25793 m
.84615 .25793 L
s
P
p
.002 w
.85207 .20693 m .83709 .20987 L p
.82277 .19899 L .4 g
F P
s
P
p
.002 w
.45139 .20354 m .42243 .20942 L .40619 .19853 L p
.4 g
F P
s
P
p
.002 w
.22925 .20626 m .21505 .20919 L .20647 .20376 L p
.4 g
F P
s
P
p
1 .344 0 r
.01 w
.84628 .25932 m
.84628 .25932 L
s
P
p
1 .359 0 r
.01 w
.84641 .26072 m
.84641 .26072 L
s
P
p
.002 w
.59977 .20172 m .57042 .20761 L .55485 .19671 L p
.8 g
F P
s
P
p
1 .374 0 r
.01 w
.84654 .26211 m
.84654 .26211 L
s
P
p
.002 w
.84494 .20149 m .85207 .20693 L p
.82277 .19899 L .4 g
F P
s
P
p
.002 w
.59977 .20172 m .62927 .1958 L .6445 .20671 L p
.4 g
F P
s
P
p
.002 w
.67405 .20081 m .6445 .20671 L .62927 .1958 L p
.8 g
F P
s
P
p
1 .389 0 r
.01 w
.84667 .26351 m
.84667 .26351 L
s
P
p
.002 w
.20647 .20376 m .19785 .19831 L p
.22925 .20626 L .4 g
F P
s
P
p
.002 w
.19785 .19831 m .2121 .19534 L .22925 .20626 L p
.4 g
F P
s
P
p
1 .404 0 r
.01 w
.8468 .26491 m
.8468 .26491 L
s
P
p
.002 w
.82277 .19899 m .79283 .2049 L .77827 .19397 L p
.8 g
F P
s
P
p
.002 w
.74838 .1999 m .77827 .19397 L .79283 .2049 L p
.8 g
F P
s
P
p
1 .419 0 r
.01 w
.84693 .26631 m
.84693 .26631 L
s
P
p
1 .434 0 r
.01 w
.84705 .26771 m
.84705 .26771 L
s
P
p
.002 w
.4805 .19762 m .45139 .20354 L .43525 .1926 L p
.4 g
F P
s
P
p
.002 w
.40619 .19853 m .43525 .1926 L .45139 .20354 L p
.4 g
F P
s
P
p
1 .449 0 r
.01 w
.84718 .26911 m
.84718 .26911 L
s
P
p
1 .464 0 r
.01 w
.84731 .27051 m
.84731 .27051 L
s
P
p
.002 w
.62927 .1958 m .59977 .20172 L .5843 .19076 L p
.4 g
F P
s
P
p
.002 w
.55485 .19671 m .5843 .19076 L .59977 .20172 L p
.8 g
F P
s
P
p
.002 w
.82277 .19899 m .83779 .19603 L .84494 .20149 L p
.4 g
F P
s
P
p
1 .479 0 r
.01 w
.84744 .27192 m
.84744 .27192 L
s
P
p
.002 w
.70374 .19488 m .67405 .20081 L .65891 .18984 L p
.8 g
F P
s
P
p
.002 w
.62927 .1958 m .65891 .18984 L .67405 .20081 L p
.8 g
F P
s
P
p
1 .494 0 r
.01 w
.84757 .27332 m
.84757 .27332 L
s
P
p
1 .509 0 r
.01 w
.8477 .27473 m
.8477 .27473 L
s
P
p
.002 w
.83779 .19603 m .82277 .19899 L p
.80831 .18801 L .4 g
F P
s
P
p
.002 w
.77827 .19397 m .80831 .18801 L .82277 .19899 L p
.8 g
F P
s
P
p
.002 w
.43525 .1926 m .40619 .19853 L .38981 .18755 L p
.4 g
F P
s
P
p
.002 w
.2121 .19534 m .19785 .19831 L .18919 .19282 L p
.4 g
F P
s
P
p
1 .524 0 r
.01 w
.84783 .27613 m
.84783 .27613 L
s
P
p
.002 w
.43525 .1926 m .46444 .18663 L .4805 .19762 L p
.4 g
F P
s
P
p
1 .539 0 r
.01 w
.84796 .27754 m
.84796 .27754 L
s
P
p
1 .554 0 r
.01 w
.84809 .27895 m
.84809 .27895 L
s
P
p
.002 w
.8306 .19053 m .83779 .19603 L p
.80831 .18801 L .4 g
F P
s
P
p
.002 w
.5843 .19076 m .61389 .18479 L .62927 .1958 L p
.4 g
F P
s
P
p
1 .569 0 r
.01 w
.84822 .28036 m
.84822 .28036 L
s
P
p
.002 w
.18919 .19282 m .18049 .18732 L p
.2121 .19534 L .4 g
F P
s
P
p
.002 w
.18049 .18732 m .19479 .18432 L .2121 .19534 L p
.4 g
F P
s
P
p
.002 w
.73358 .18893 m .70374 .19488 L .6887 .18386 L p
.8 g
F P
s
P
p
.002 w
.65891 .18984 m .6887 .18386 L .70374 .19488 L p
.8 g
F P
s
P
p
1 .584 0 r
.01 w
.84835 .28177 m
.84835 .28177 L
s
P
p
.002 w
.80831 .18801 m .77827 .19397 L .76357 .18294 L p
.8 g
F P
s
P
p
1 .599 0 r
.01 w
.84848 .28319 m
.84848 .28319 L
s
P
p
1 .613 0 r
.01 w
.84861 .2846 m
.84861 .2846 L
s
P
p
.002 w
.46444 .18663 m .43525 .1926 L .41895 .18155 L p
.4 g
F P
s
P
p
.002 w
.38981 .18755 m .41895 .18155 L .43525 .1926 L p
.4 g
F P
s
P
p
1 .628 0 r
.01 w
.84874 .28601 m
.84874 .28601 L
s
P
p
1 .643 0 r
.01 w
.84887 .28743 m
.84887 .28743 L
s
P
p
.002 w
.61389 .18479 m .5843 .19076 L .56868 .1797 L p
.4 g
F P
s
P
p
.002 w
.80831 .18801 m .82338 .18502 L .8306 .19053 L p
.4 g
F P
s
P
p
1 .658 0 r
.01 w
.849 .28885 m
.849 .28885 L
s
P
p
1 .673 0 r
.01 w
.84913 .29026 m
.84913 .29026 L
s
P
p
.002 w
.76357 .18294 m .73358 .18893 L .71864 .17785 L p
.8 g
F P
s
P
p
.002 w
.6887 .18386 m .71864 .17785 L .73358 .18893 L p
.8 g
F P
s
P
p
.002 w
.34417 .18248 m .31523 .18847 L .29834 .17739 L p
.8 g
F P
s
P
p
1 .688 0 r
.01 w
.84927 .29168 m
.84927 .29168 L
s
P
p
.002 w
.82338 .18502 m .80831 .18801 L p
.79371 .17692 L .4 g
F P
s
P
p
.002 w
.76357 .18294 m .79371 .17692 L .80831 .18801 L p
.8 g
F P
s
P
p
.002 w
.19479 .18432 m .18049 .18732 L .17176 .18179 L p
.4 g
F P
s
P
p
1 .703 0 r
.01 w
.8494 .2931 m
.8494 .2931 L
s
P
p
.002 w
.41895 .18155 m .44824 .17553 L .46444 .18663 L p
.4 g
F P
s
P
p
1 .718 0 r
.01 w
.84953 .29452 m
.84953 .29452 L
s
P
p
1 .733 0 r
.01 w
.84966 .29595 m
.84966 .29595 L
s
P
p
.002 w
.81613 .17947 m .82338 .18502 L p
.79371 .17692 L .4 g
F P
s
P
p
.002 w
.56868 .1797 m .59837 .17367 L .61389 .18479 L p
.4 g
F P
s
P
p
1 .748 0 r
.01 w
.84979 .29737 m
.84979 .29737 L
s
P
p
.002 w
.17176 .18179 m .16298 .17623 L p
.19479 .18432 L .4 g
F P
s
P
p
.002 w
.16298 .17623 m .17732 .17321 L .19479 .18432 L p
.4 g
F P
s
P
p
1 .763 0 r
.01 w
.84992 .29879 m
.84992 .29879 L
s
P
p
.002 w
.79371 .17692 m .76357 .18294 L .74874 .17181 L p
.8 g
F P
s
P
p
.002 w
.71864 .17785 m .74874 .17181 L .76357 .18294 L p
.8 g
F P
s
P
p
1 .778 0 r
.01 w
.85005 .30022 m
.85005 .30022 L
s
P
p
.002 w
.29834 .17739 m .32738 .17134 L .34417 .18248 L p
.8 g
F P
s
P
p
1 .793 0 r
.01 w
.85018 .30164 m
.85018 .30164 L
s
P
p
1 .808 0 r
.01 w
.85032 .30307 m
.85032 .30307 L
s
P
p
.002 w
.52328 .1746 m .49379 .18063 L .47768 .16948 L p
.8 g
F P
s
P
p
1 .823 0 r
.01 w
.85045 .3045 m
.85045 .3045 L
s
P
p
.002 w
.59837 .17367 m .56868 .1797 L .55292 .16854 L p
.4 g
F P
s
P
p
.002 w
.79371 .17692 m .80884 .1739 L .81613 .17947 L p
.4 g
F P
s
P
p
1 .838 0 r
.01 w
.85058 .30593 m
.85058 .30593 L
s
P
p
1 .853 0 r
.01 w
.85071 .30736 m
.85071 .30736 L
s
P
p
.002 w
.32738 .17134 m .29834 .17739 L .2813 .1662 L p
.8 g
F P
s
P
p
1 .868 0 r
.01 w
.85084 .30879 m
.85084 .30879 L
s
P
p
.002 w
.80884 .1739 m .79371 .17692 L p
.77898 .16574 L .4 g
F P
s
P
p
.002 w
.74874 .17181 m .77898 .16574 L .79371 .17692 L p
.8 g
F P
s
P
p
.002 w
.4025 .17041 m .37326 .17646 L .35657 .16527 L p
.4 g
F P
s
P
p
.002 w
.17732 .17321 m .16298 .17623 L .15416 .17064 L p
.4 g
F P
s
P
p
1 .883 0 r
.01 w
.85098 .31023 m
.85098 .31023 L
s
P
p
1 .898 0 r
.01 w
.85111 .31166 m
.85111 .31166 L
s
P
p
.002 w
.47768 .16948 m .50727 .16339 L .52328 .1746 L p
.8 g
F P
s
P
p
1 .913 0 r
.01 w
.85124 .3131 m
.85124 .3131 L
s
P
p
.002 w
.80152 .16831 m .80884 .1739 L p
.77898 .16574 L .4 g
F P
s
P
p
.002 w
.62822 .16761 m .59837 .17367 L .58271 .16245 L p
.4 g
F P
s
P
p
.002 w
.55292 .16854 m .58271 .16245 L .59837 .17367 L p
.4 g
F P
s
P
p
1 .928 0 r
.01 w
.85137 .31453 m
.85137 .31453 L
s
P
p
.002 w
.15416 .17064 m .1453 .16503 L p
.17732 .17321 L .4 g
F P
s
P
p
.002 w
.1453 .16503 m .15968 .16198 L .17732 .17321 L p
.4 g
F P
s
P
p
1 .943 0 r
.01 w
.8515 .31597 m
.8515 .31597 L
s
P
p
1 .958 0 r
.01 w
.85164 .31741 m
.85164 .31741 L
s
P
p
.002 w
.2813 .1662 m .31044 .1601 L .32738 .17134 L p
.8 g
F P
s
P
p
1 .973 0 r
.01 w
.85177 .31885 m
.85177 .31885 L
s
P
p
.002 w
.43189 .16433 m .4025 .17041 L .3859 .15916 L p
.4 g
F P
s
P
p
.002 w
.35657 .16527 m .3859 .15916 L .4025 .17041 L p
.4 g
F P
s
P
p
1 .988 0 r
.01 w
.8519 .32029 m
.8519 .32029 L
s
P
p
.998 1 0 r
.01 w
.85204 .32173 m
.85204 .32173 L
s
P
p
.002 w
.77898 .16574 m .79416 .16269 L .80152 .16831 L p
.4 g
F P
s
P
p
.983 1 0 r
.01 w
.85217 .32318 m
.85217 .32318 L
s
P
p
.002 w
.65821 .16151 m .62822 .16761 L .61265 .15633 L p
.4 g
F P
s
P
p
.002 w
.58271 .16245 m .61265 .15633 L .62822 .16761 L p
.4 g
F P
s
P
p
.968 1 0 r
.01 w
.8523 .32462 m
.8523 .32462 L
s
P
p
.953 1 0 r
.01 w
.85244 .32607 m
.85244 .32607 L
s
P
p
.002 w
.79416 .16269 m .77898 .16574 L p
.76412 .15444 L .4 g
F P
s
P
p
.002 w
.3859 .15916 m .35657 .16527 L .33972 .15397 L p
.4 g
F P
s
P
p
.938 1 0 r
.01 w
.85257 .32751 m
.85257 .32751 L
s
P
p
.002 w
.15968 .16198 m .1453 .16503 L .1364 .1594 L p
.4 g
F P
s
P
p
.002 w
.3859 .15916 m .41538 .15302 L .43189 .16433 L p
.4 g
F P
s
P
p
.923 1 0 r
.01 w
.8527 .32896 m
.8527 .32896 L
s
P
p
.908 1 0 r
.01 w
.85284 .33041 m
.85284 .33041 L
s
P
p
.002 w
.78677 .15704 m .79416 .16269 L p
.76412 .15444 L .4 g
F P
s
P
p
.893 1 0 r
.01 w
.85297 .33186 m
.85297 .33186 L
s
P
p
.002 w
.1364 .1594 m .12745 .15373 L p
.15968 .16198 L .4 g
F P
s
P
p
.002 w
.12745 .15373 m .14188 .15065 L .15968 .16198 L p
.4 g
F P
s
P
p
.002 w
.68835 .15539 m .65821 .16151 L .64275 .15018 L p
.4 g
F P
s
P
p
.002 w
.61265 .15633 m .64275 .15018 L .65821 .16151 L p
.4 g
F P
s
P
p
.878 1 0 r
.01 w
.8531 .33331 m
.8531 .33331 L
s
P
p
.863 1 0 r
.01 w
.85324 .33476 m
.85324 .33476 L
s
P
p
.848 1 0 r
.01 w
.85337 .33622 m
.85337 .33622 L
s
P
p
.002 w
.41538 .15302 m .3859 .15916 L .36914 .14781 L p
.4 g
F P
s
P
p
.002 w
.33972 .15397 m .36914 .14781 L .3859 .15916 L p
.4 g
F P
s
P
p
.833 1 0 r
.01 w
.85351 .33767 m
.85351 .33767 L
s
P
p
.818 1 0 r
.01 w
.85364 .33913 m
.85364 .33913 L
s
P
p
.002 w
.5669 .15113 m .53701 .15728 L .52095 .1459 L p
.8 g
F P
s
P
p
.002 w
.76412 .15444 m .77935 .15137 L .78677 .15704 L p
.4 g
F P
s
P
p
.803 1 0 r
.01 w
.85377 .34058 m
.85377 .34058 L
s
P
p
.788 1 0 r
.01 w
.85391 .34204 m
.85391 .34204 L
s
P
p
.002 w
.64275 .15018 m .673 .144 L .68835 .15539 L p
.4 g
F P
s
P
p
.773 1 0 r
.01 w
.85404 .3435 m
.85404 .3435 L
s
P
p
.002 w
.77935 .15137 m .76412 .15444 L p
.74911 .14304 L .4 g
F P
s
P
p
.758 1 0 r
.01 w
.85418 .34496 m
.85418 .34496 L
s
P
p
.002 w
.14188 .15065 m .12745 .15373 L .11847 .14804 L p
.4 g
F P
s
P
p
.002 w
.44502 .14685 m .41538 .15302 L .39872 .14161 L p
.4 g
F P
s
P
p
.002 w
.36914 .14781 m .39872 .14161 L .41538 .15302 L p
.4 g
F P
s
P
p
.743 1 0 r
.01 w
.85431 .34642 m
.85431 .34642 L
s
P
p
.728 1 0 r
.01 w
.85445 .34788 m
.85445 .34788 L
s
P
p
.002 w
.77189 .14566 m .77935 .15137 L p
.74911 .14304 L .4 g
F P
s
P
p
.002 w
.52095 .1459 m .55094 .1397 L .5669 .15113 L p
.8 g
F P
s
P
p
.713 1 0 r
.01 w
.85458 .34935 m
.85458 .34935 L
s
P
p
.002 w
.13292 .14495 m .1474 .14185 L p
.14188 .15065 L .4 g
F P
s
P
p
.002 w
.17084 .14447 m .14188 .15065 L p
.1474 .14185 L .4 g
F P
s
P
p
.002 w
.11847 .14804 m .13292 .14495 L .14188 .15065 L p
.4 g
F P
s
P
p
.002 w
.673 .144 m .64275 .15018 L .62714 .13874 L p
.4 g
F P
s
P
p
.698 1 0 r
.01 w
.85472 .35081 m
.85472 .35081 L
s
P
p
.683 1 0 r
.01 w
.85485 .35228 m
.85485 .35228 L
s
P
p
.002 w
.3227 .14257 m .29333 .14876 L .27606 .1373 L p
.8 g
F P
s
P
p
.668 1 0 r
.01 w
.85499 .35374 m
.85499 .35374 L
s
P
p
.653 1 0 r
.01 w
.85512 .35521 m
.85512 .35521 L
s
P
p
.002 w
.4748 .14065 m .44502 .14685 L .42845 .13538 L p
.4 g
F P
s
P
p
.002 w
.39872 .14161 m .42845 .13538 L .44502 .14685 L p
.4 g
F P
s
P
p
.638 1 0 r
.01 w
.85526 .35668 m
.85526 .35668 L
s
P
p
.002 w
.74911 .14304 m .76439 .13994 L .77189 .14566 L p
.4 g
F P
s
P
p
.623 1 0 r
.01 w
.85539 .35815 m
.85539 .35815 L
s
P
p
.002 w
.16193 .13874 m .17649 .13562 L p
.17084 .14447 L .4 g
F P
s
P
p
.002 w
.19996 .13826 m .17084 .14447 L p
.17649 .13562 L .4 g
F P
s
P
p
.002 w
.1474 .14185 m .16193 .13874 L .17084 .14447 L p
.4 g
F P
s
P
p
.608 1 0 r
.01 w
.85553 .35962 m
.85553 .35962 L
s
P
p
.002 w
.62714 .13874 m .65749 .1325 L .673 .144 L p
.4 g
F P
s
P
p
.594 1 0 r
.01 w
.85567 .3611 m
.85567 .3611 L
s
P
p
.002 w
.76439 .13994 m .74911 .14304 L p
.73396 .13154 L .4 g
F P
s
P
p
.002 w
.35223 .13634 m .3227 .14257 L .30553 .13105 L p
.8 g
F P
s
P
p
.002 w
.27606 .1373 m .30553 .13105 L .3227 .14257 L p
.8 g
F P
s
P
p
.579 1 0 r
.01 w
.8558 .36257 m
.8558 .36257 L
s
P
p
.564 1 0 r
.01 w
.85594 .36405 m
.85594 .36405 L
s
P
p
.002 w
.50474 .13442 m .4748 .14065 L .45834 .12912 L p
.4 g
F P
s
P
p
.002 w
.42845 .13538 m .45834 .12912 L .4748 .14065 L p
.4 g
F P
s
P
p
.549 1 0 r
.01 w
.85607 .36552 m
.85607 .36552 L
s
P
p
.002 w
.75686 .13418 m .76439 .13994 L p
.73396 .13154 L .4 g
F P
s
P
p
.534 1 0 r
.01 w
.85621 .367 m
.85621 .367 L
s
P
p
.002 w
.65749 .1325 m .62714 .13874 L .61138 .12719 L p
.4 g
F P
s
P
p
.519 1 0 r
.01 w
.85635 .36848 m
.85635 .36848 L
s
P
p
.002 w
.19108 .1325 m .20572 .12937 L p
.19996 .13826 L .4 g
F P
s
P
p
.002 w
.22922 .13202 m .19996 .13826 L p
.20572 .12937 L .4 g
F P
s
P
p
.002 w
.17649 .13562 m .19108 .1325 L .19996 .13826 L p
.4 g
F P
s
P
p
.504 1 0 r
.01 w
.85648 .36996 m
.85648 .36996 L
s
P
p
.489 1 0 r
.01 w
.85662 .37144 m
.85662 .37144 L
s
P
p
.002 w
.30553 .13105 m .33515 .12477 L .35223 .13634 L p
.8 g
F P
s
P
p
.474 1 0 r
.01 w
.85676 .37292 m
.85676 .37292 L
s
P
p
.459 1 0 r
.01 w
.85689 .37441 m
.85689 .37441 L
s
P
p
.002 w
.45834 .12912 m .48837 .12283 L .50474 .13442 L p
.4 g
F P
s
P
p
.002 w
.73396 .13154 m .7493 .1284 L .75686 .13418 L p
.4 g
F P
s
P
p
.444 1 0 r
.01 w
.85703 .37589 m
.85703 .37589 L
s
P
p
.429 1 0 r
.01 w
.85717 .37738 m
.85717 .37738 L
s
P
p
.002 w
.61138 .12719 m .64184 .12089 L .65749 .1325 L p
.4 g
F P
s
P
p
.002 w
.22039 .12623 m .2351 .12308 L p
.22922 .13202 L .4 g
F P
s
P
p
.002 w
.25863 .12574 m .22922 .13202 L p
.2351 .12308 L .4 g
F P
s
P
p
.002 w
.20572 .12937 m .22039 .12623 L .22922 .13202 L p
.4 g
F P
s
P
p
.414 1 0 r
.01 w
.8573 .37886 m
.8573 .37886 L
s
P
p
.002 w
.7493 .1284 m .73396 .13154 L p
.71866 .11992 L .4 g
F P
s
P
p
.399 1 0 r
.01 w
.85744 .38035 m
.85744 .38035 L
s
P
p
.002 w
.41173 .1238 m .3819 .13009 L .36492 .11846 L p
.8 g
F P
s
P
p
.384 1 0 r
.01 w
.85758 .38184 m
.85758 .38184 L
s
P
p
.002 w
.48837 .12283 m .45834 .12912 L .44171 .11749 L p
.4 g
F P
s
P
p
.369 1 0 r
.01 w
.85772 .38333 m
.85772 .38333 L
s
P
p
.002 w
.74169 .12259 m .7493 .1284 L p
.71866 .11992 L .4 g
F P
s
P
p
.002 w
.56508 .12186 m .53483 .12816 L .51857 .11651 L p
.8 g
F P
s
P
p
.354 1 0 r
.01 w
.85785 .38482 m
.85785 .38482 L
s
P
p
.002 w
.64184 .12089 m .61138 .12719 L .59548 .11553 L p
.4 g
F P
s
P
p
.339 1 0 r
.01 w
.85799 .38631 m
.85799 .38631 L
s
P
p
.324 1 0 r
.01 w
.85813 .38781 m
.85813 .38781 L
s
P
p
.002 w
.24985 .11992 m .26464 .11675 L p
.25863 .12574 L .4 g
F P
s
P
p
.002 w
.28819 .11943 m .25863 .12574 L p
.26464 .11675 L .4 g
F P
s
P
p
.002 w
.2351 .12308 m .24985 .11992 L .25863 .12574 L p
.4 g
F P
s
P
p
.309 1 0 r
.01 w
.85827 .3893 m
.85827 .3893 L
s
P
p
.294 1 0 r
.01 w
.8584 .3908 m
.8584 .3908 L
s
P
p
.002 w
.44171 .11749 m .41173 .1238 L .39485 .11211 L p
.8 g
F P
s
P
p
.002 w
.36492 .11846 m .39485 .11211 L .41173 .1238 L p
.8 g
F P
s
P
p
.279 1 0 r
.01 w
.85854 .3923 m
.85854 .3923 L
s
P
p
.002 w
.44171 .11749 m .47185 .11113 L .48837 .12283 L p
.4 g
F P
s
P
p
.002 w
.71866 .11992 m .73405 .11675 L .74169 .12259 L p
.4 g
F P
s
P
p
.264 1 0 r
.01 w
.85868 .3938 m
.85868 .3938 L
s
P
p
.002 w
.51857 .11651 m .54891 .11015 L .56508 .12186 L p
.8 g
F P
s
P
p
.249 1 0 r
.01 w
.85882 .39529 m
.85882 .39529 L
s
P
p
.002 w
.59548 .11553 m .62604 .10917 L .64184 .12089 L p
.4 g
F P
s
P
p
.234 1 0 r
.01 w
.85896 .3968 m
.85896 .3968 L
s
P
p
.002 w
.73405 .11675 m .71866 .11992 L p
.70322 .10819 L .4 g
F P
s
P
p
.002 w
.27946 .11358 m .29433 .1104 L p
.28819 .11943 L .4 g
F P
s
P
p
.002 w
.31791 .11309 m .28819 .11943 L p
.29433 .1104 L .4 g
F P
s
P
p
.002 w
.26464 .11675 m .27946 .11358 L .28819 .11943 L p
.4 g
F P
s
P
p
.219 1 0 r
.01 w
.8591 .3983 m
.8591 .3983 L
s
P
p
.204 1 0 r
.01 w
.85923 .3998 m
.85923 .3998 L
s
P
p
.002 w
.39485 .11211 m .42493 .10573 L .44171 .11749 L p
.8 g
F P
s
P
p
.19 1 0 r
.01 w
.85937 .40131 m
.85937 .40131 L
s
P
p
.002 w
.72638 .11089 m .73405 .11675 L p
.70322 .10819 L .4 g
F P
s
P
p
.002 w
.54891 .11015 m .51857 .11651 L .50215 .10475 L p
.8 g
F P
s
P
p
.175 1 0 r
.01 w
.85951 .40281 m
.85951 .40281 L
s
P
p
.002 w
.62604 .10917 m .59548 .11553 L .57942 .10376 L p
.4 g
F P
s
P
p
.16 1 0 r
.01 w
.85965 .40432 m
.85965 .40432 L
s
P
p
.145 1 0 r
.01 w
.85979 .40583 m
.85979 .40583 L
s
P
p
.13 1 0 r
.01 w
.85993 .40734 m
.85993 .40734 L
s
P
p
.002 w
.30923 .10721 m .32417 .10401 L p
.31791 .11309 L .4 g
F P
s
P
p
.002 w
.34778 .10672 m .31791 .11309 L p
.32417 .10401 L .4 g
F P
s
P
p
.002 w
.29433 .1104 m .30923 .10721 L .31791 .11309 L p
.4 g
F P
s
P
p
.115 1 0 r
.01 w
.86007 .40885 m
.86007 .40885 L
s
P
p
.1 1 0 r
.01 w
.86021 .41036 m
.86021 .41036 L
s
P
p
.002 w
.70322 .10819 m .71867 .105 L .72638 .11089 L p
.4 g
F P
s
P
p
.085 1 0 r
.01 w
.86035 .41187 m
.86035 .41187 L
s
P
p
.002 w
.50215 .10475 m .5326 .09833 L .54891 .11015 L p
.8 g
F P
s
P
p
.07 1 0 r
.01 w
.86049 .41339 m
.86049 .41339 L
s
P
p
.002 w
.57942 .10376 m .61008 .09734 L .62604 .10917 L p
.4 g
F P
s
P
p
.055 1 0 r
.01 w
.86063 .4149 m
.86063 .4149 L
s
P
p
.002 w
.71867 .105 m .70322 .10819 L p
.68763 .09635 L .4 g
F P
s
P
p
.04 1 0 r
.01 w
.86077 .41642 m
.86077 .41642 L
s
P
p
.002 w
.33915 .1008 m .35417 .09759 L p
.34778 .10672 L .4 g
F P
s
P
p
.002 w
.37781 .10031 m .34778 .10672 L p
.35417 .09759 L .4 g
F P
s
P
p
.002 w
.32417 .10401 m .33915 .1008 L .34778 .10672 L p
.4 g
F P
s
P
p
.025 1 0 r
.01 w
.86091 .41794 m
.86091 .41794 L
s
P
p
.002 w
.45517 .09932 m .42493 .10573 L .40799 .09387 L p
.4 g
F P
s
P
p
.01 1 0 r
.01 w
.86105 .41945 m
.86105 .41945 L
s
P
p
.002 w
.71092 .09907 m .71867 .105 L p
.68763 .09635 L .4 g
F P
s
P
p
.002 w
.5326 .09833 m .50215 .10475 L .48557 .09288 L p
.8 g
F P
s
P
p
0 1 .005 r
.01 w
.86119 .42097 m
.86119 .42097 L
s
P
p
.002 w
.61008 .09734 m .57942 .10376 L .56321 .09188 L p
.4 g
F P
s
P
p
0 1 .02 r
.01 w
.86133 .4225 m
.86133 .4225 L
s
P
p
0 1 .035 r
.01 w
.86147 .42402 m
.86147 .42402 L
s
P
p
0 1 .05 r
.01 w
.86161 .42554 m
.86161 .42554 L
s
P
p
0 1 .065 r
.01 w
.86175 .42707 m
.86175 .42707 L
s
P
p
.002 w
.36922 .09437 m .38432 .09113 L p
.37781 .10031 L .4 g
F P
s
P
p
.002 w
.40799 .09387 m .37781 .10031 L p
.38432 .09113 L .4 g
F P
s
P
p
.002 w
.35417 .09759 m .36922 .09437 L .37781 .10031 L p
.4 g
F P
s
P
p
0 1 .08 r
.01 w
.86189 .42859 m
.86189 .42859 L
s
P
p
.002 w
.40799 .09387 m .43833 .0874 L .45517 .09932 L p
.4 g
F P
s
P
p
.002 w
.68763 .09635 m .70313 .09312 L .71092 .09907 L p
.4 g
F P
s
P
p
0 1 .095 r
.01 w
.86203 .43012 m
.86203 .43012 L
s
P
p
.002 w
.48557 .09288 m .51612 .0864 L .5326 .09833 L p
.8 g
F P
s
P
p
0 1 .11 r
.01 w
.86217 .43165 m
.86217 .43165 L
s
P
p
.002 w
.64091 .09089 m .61008 .09734 L .59398 .0854 L p
.4 g
F P
s
P
p
.002 w
.56321 .09188 m .59398 .0854 L .61008 .09734 L p
.4 g
F P
s
P
p
0 1 .125 r
.01 w
.86231 .43318 m
.86231 .43318 L
s
P
p
.002 w
.70313 .09312 m .68763 .09635 L p
.67189 .0844 L .4 g
F P
s
P
p
0 1 .14 r
.01 w
.86245 .43471 m
.86245 .43471 L
s
P
p
0 1 .155 r
.01 w
.86259 .43624 m
.86259 .43624 L
s
P
p
.002 w
.39946 .08789 m .41463 .08465 L p
.40799 .09387 L .4 g
F P
s
P
p
.002 w
.43833 .0874 m .40799 .09387 L p
.41463 .08465 L .4 g
F P
s
P
p
.002 w
.38432 .09113 m .39946 .08789 L .40799 .09387 L p
.4 g
F P
s
P
p
0 1 .17 r
.01 w
.86274 .43778 m
.86274 .43778 L
s
P
p
.002 w
.69531 .08715 m .70313 .09312 L p
.67189 .0844 L .4 g
F P
s
P
p
0 1 .185 r
.01 w
.86288 .43931 m
.86288 .43931 L
s
P
p
0 1 .2 r
.01 w
.86302 .44085 m
.86302 .44085 L
s
P
p
.002 w
.67189 .0844 m .64091 .09089 L .62491 .07888 L p
.4 g
F P
s
P
p
.002 w
.59398 .0854 m .62491 .07888 L .64091 .09089 L p
.4 g
F P
s
P
p
0 1 .214 r
.01 w
.86316 .44239 m
.86316 .44239 L
s
P
p
0 1 .229 r
.01 w
.8633 .44392 m
.8633 .44392 L
s
P
p
0 1 .244 r
.01 w
.86344 .44546 m
.86344 .44546 L
s
P
p
0 1 .259 r
.01 w
.86359 .44701 m
.86359 .44701 L
s
P
p
.002 w
.42985 .08139 m .4451 .07812 L p
.43833 .0874 L .4 g
F P
s
P
p
.002 w
.46883 .08089 m .43833 .0874 L p
.4451 .07812 L .4 g
F P
s
P
p
.002 w
.41463 .08465 m .42985 .08139 L .43833 .0874 L p
.4 g
F P
s
P
p
.002 w
.67189 .0844 m .68745 .08114 L .69531 .08715 L p
.4 g
F P
s
P
p
0 1 .274 r
.01 w
.86373 .44855 m
.86373 .44855 L
s
P
p
0 1 .289 r
.01 w
.86387 .45009 m
.86387 .45009 L
s
P
p
0 1 .304 r
.01 w
.86401 .45164 m
.86401 .45164 L
s
P
p
.002 w
.68745 .08114 m .67189 .0844 L p
.656 .07233 L .4 g
F P
s
P
p
.002 w
.62491 .07888 m .656 .07233 L .67189 .0844 L p
.4 g
F P
s
P
p
0 1 .319 r
.01 w
.86416 .45318 m
.86416 .45318 L
s
P
p
0 1 .334 r
.01 w
.8643 .45473 m
.8643 .45473 L
s
P
p
0 1 .349 r
.01 w
.86444 .45628 m
.86444 .45628 L
s
P
p
.002 w
.67955 .0751 m .68745 .08114 L p
.656 .07233 L .4 g
F P
s
P
p
.002 w
.4604 .07485 m .47573 .07157 L p
.46883 .08089 L .4 g
F P
s
P
p
.002 w
.49949 .07435 m .46883 .08089 L p
.47573 .07157 L .4 g
F P
s
P
p
.002 w
.4451 .07812 m .4604 .07485 L .46883 .08089 L p
.4 g
F P
s
P
p
0 1 .364 r
.01 w
.86458 .45783 m
.86458 .45783 L
s
P
p
0 1 .379 r
.01 w
.86473 .45938 m
.86473 .45938 L
s
P
p
0 1 .394 r
.01 w
.86487 .46093 m
.86487 .46093 L
s
P
p
0 1 .409 r
.01 w
.86501 .46248 m
.86501 .46248 L
s
P
p
0 1 .424 r
.01 w
.86516 .46404 m
.86516 .46404 L
s
P
p
0 1 .439 r
.01 w
.8653 .46559 m
.8653 .46559 L
s
P
p
.002 w
.656 .07233 m .67161 .06904 L .67955 .0751 L p
.4 g
F P
s
P
p
0 1 .454 r
.01 w
.86544 .46715 m
.86544 .46715 L
s
P
p
.002 w
.49111 .06828 m .50653 .06498 L p
.49949 .07435 L .4 g
F P
s
P
p
.002 w
.53031 .06777 m .49949 .07435 L p
.50653 .06498 L .4 g
F P
s
P
p
.002 w
.47573 .07157 m .49111 .06828 L .49949 .07435 L p
.4 g
F P
s
P
p
0 1 .469 r
.01 w
.86559 .46871 m
.86559 .46871 L
s
P
p
0 1 .484 r
.01 w
.86573 .47027 m
.86573 .47027 L
s
P
p
.002 w
.67161 .06904 m .656 .07233 L p
.63996 .06014 L .4 g
F P
s
P
p
0 1 .499 r
.01 w
.86588 .47183 m
.86588 .47183 L
s
P
p
0 1 .514 r
.01 w
.86602 .47339 m
.86602 .47339 L
s
P
p
0 1 .529 r
.01 w
.86616 .47496 m
.86616 .47496 L
s
P
p
.002 w
.66363 .06294 m .67161 .06904 L p
.63996 .06014 L .4 g
F P
s
P
p
0 1 .544 r
.01 w
.86631 .47652 m
.86631 .47652 L
s
P
p
.002 w
.52198 .06167 m .53748 .05835 L p
.53031 .06777 L .4 g
F P
s
P
p
.002 w
.56129 .06116 m .53031 .06777 L p
.53748 .05835 L .4 g
F P
s
P
p
.002 w
.50653 .06498 m .52198 .06167 L .53031 .06777 L p
.4 g
F P
s
P
p
0 1 .559 r
.01 w
.86645 .47809 m
.86645 .47809 L
s
P
p
0 1 .574 r
.01 w
.8666 .47966 m
.8666 .47966 L
s
P
p
0 1 .589 r
.01 w
.86674 .48122 m
.86674 .48122 L
s
P
p
0 1 .603 r
.01 w
.86689 .48279 m
.86689 .48279 L
s
P
p
0 1 .618 r
.01 w
.86703 .48437 m
.86703 .48437 L
s
P
p
.002 w
.63996 .06014 m .65562 .05682 L .66363 .06294 L p
.4 g
F P
s
P
p
0 1 .633 r
.01 w
.86718 .48594 m
.86718 .48594 L
s
P
p
0 1 .648 r
.01 w
.86732 .48751 m
.86732 .48751 L
s
P
p
.002 w
.55302 .05502 m .5686 .05169 L p
.56129 .06116 L .4 g
F P
s
P
p
.002 w
.59244 .05451 m .56129 .06116 L p
.5686 .05169 L .4 g
F P
s
P
p
.002 w
.53748 .05835 m .55302 .05502 L .56129 .06116 L p
.4 g
F P
s
P
p
0 1 .663 r
.01 w
.86747 .48909 m
.86747 .48909 L
s
P
p
.002 w
.65562 .05682 m .63996 .06014 L p
.62375 .04783 L .4 g
F P
s
P
p
0 1 .678 r
.01 w
.86761 .49066 m
.86761 .49066 L
s
P
p
0 1 .693 r
.01 w
.86776 .49224 m
.86776 .49224 L
s
P
p
0 1 .708 r
.01 w
.8679 .49382 m
.8679 .49382 L
s
P
p
.002 w
.64756 .05066 m .65562 .05682 L p
.62375 .04783 L .4 g
F P
s
P
p
0 1 .723 r
.01 w
.86805 .4954 m
.86805 .4954 L
s
P
p
0 1 .738 r
.01 w
.86819 .49698 m
.86819 .49698 L
s
P
p
.002 w
.58422 .04834 m .59988 .04499 L p
.59244 .05451 L .4 g
F P
s
P
p
.002 w
.62375 .04783 m .59244 .05451 L p
.59988 .04499 L .4 g
F P
s
P
p
.002 w
.5686 .05169 m .58422 .04834 L .59244 .05451 L p
.4 g
F P
s
P
p
0 1 .753 r
.01 w
.86834 .49856 m
.86834 .49856 L
s
P
p
0 1 .768 r
.01 w
.86849 .50015 m
.86849 .50015 L
s
P
p
0 1 .783 r
.01 w
.86863 .50173 m
.86863 .50173 L
s
P
p
0 1 .798 r
.01 w
.86878 .50332 m
.86878 .50332 L
s
P
p
.002 w
.62375 .04783 m .63947 .04447 L .64756 .05066 L p
.4 g
F P
s
P
p
0 1 .813 r
.01 w
.86893 .50491 m
.86893 .50491 L
s
P
p
0 1 .828 r
.01 w
.86907 .5065 m
.86907 .5065 L
s
P
p
0 1 .843 r
.01 w
.86922 .50809 m
.86922 .50809 L
s
P
p
.002 w
.61559 .04163 m .63134 .03826 L p
.62375 .04783 L .4 g
F P
s
P
p
.002 w
.63947 .04447 m .62375 .04783 L p
.63134 .03826 L .4 g
F P
s
P
p
.002 w
.59988 .04499 m .61559 .04163 L .62375 .04783 L p
.4 g
F P
s
P
p
0 1 .858 r
.01 w
.86937 .50968 m
.86937 .50968 L
s
P
p
0 1 .873 r
.01 w
.86951 .51127 m
.86951 .51127 L
s
P
p
0 1 .888 r
.01 w
.86966 .51287 m
.86966 .51287 L
s
P
p
0 1 .903 r
.01 w
.86981 .51446 m
.86981 .51446 L
s
P
p
0 1 .918 r
.01 w
.86995 .51606 m
.86995 .51606 L
s
P
p
0 1 .933 r
.01 w
.8701 .51766 m
.8701 .51766 L
s
P
p
0 1 .948 r
.01 w
.87025 .51926 m
.87025 .51926 L
s
P
p
0 1 .963 r
.01 w
.8704 .52086 m
.8704 .52086 L
s
P
p
0 1 .978 r
.01 w
.87054 .52246 m
.87054 .52246 L
s
P
p
0 1 .993 r
.01 w
.87069 .52406 m
.87069 .52406 L
s
P
p
0 .993 1 r
.01 w
.87084 .52567 m
.87084 .52567 L
s
P
p
0 .978 1 r
.01 w
.87099 .52728 m
.87099 .52728 L
s
P
p
0 .963 1 r
.01 w
.87114 .52888 m
.87114 .52888 L
s
P
p
0 .948 1 r
.01 w
.87128 .53049 m
.87128 .53049 L
s
P
p
0 .933 1 r
.01 w
.87143 .5321 m
.87143 .5321 L
s
P
p
0 .918 1 r
.01 w
.87158 .53371 m
.87158 .53371 L
s
P
p
0 .903 1 r
.01 w
.87173 .53533 m
.87173 .53533 L
s
P
p
0 .888 1 r
.01 w
.87188 .53694 m
.87188 .53694 L
s
P
p
0 .873 1 r
.01 w
.87203 .53856 m
.87203 .53856 L
s
P
p
0 .858 1 r
.01 w
.87218 .54017 m
.87218 .54017 L
s
P
p
0 .843 1 r
.01 w
.87233 .54179 m
.87233 .54179 L
s
P
p
0 .828 1 r
.01 w
.87248 .54341 m
.87248 .54341 L
s
P
p
0 .813 1 r
.01 w
.87263 .54503 m
.87263 .54503 L
s
P
p
0 .798 1 r
.01 w
.87277 .54665 m
.87277 .54665 L
s
P
p
0 .783 1 r
.01 w
.87292 .54828 m
.87292 .54828 L
s
P
p
0 .768 1 r
.01 w
.87307 .5499 m
.87307 .5499 L
s
P
p
0 .753 1 r
.01 w
.87322 .55153 m
.87322 .55153 L
s
P
p
0 .738 1 r
.01 w
.87337 .55315 m
.87337 .55315 L
s
P
p
0 .723 1 r
.01 w
.87352 .55478 m
.87352 .55478 L
s
P
p
0 .708 1 r
.01 w
.87367 .55641 m
.87367 .55641 L
s
P
p
0 .693 1 r
.01 w
.87383 .55804 m
.87383 .55804 L
s
P
p
0 .678 1 r
.01 w
.87398 .55968 m
.87398 .55968 L
s
P
p
0 .663 1 r
.01 w
.87413 .56131 m
.87413 .56131 L
s
P
p
0 .648 1 r
.01 w
.87428 .56295 m
.87428 .56295 L
s
P
p
0 .633 1 r
.01 w
.87443 .56458 m
.87443 .56458 L
s
P
p
0 .618 1 r
.01 w
.87458 .56622 m
.87458 .56622 L
s
P
p
0 .603 1 r
.01 w
.87473 .56786 m
.87473 .56786 L
s
P
p
0 .589 1 r
.01 w
.87488 .5695 m
.87488 .5695 L
s
P
p
0 .574 1 r
.01 w
.87503 .57115 m
.87503 .57115 L
s
P
p
0 .559 1 r
.01 w
.87518 .57279 m
.87518 .57279 L
s
P
p
0 .544 1 r
.01 w
.87534 .57443 m
.87534 .57443 L
s
P
p
0 .529 1 r
.01 w
.87549 .57608 m
.87549 .57608 L
s
P
p
0 .514 1 r
.01 w
.87564 .57773 m
.87564 .57773 L
s
P
p
0 .499 1 r
.01 w
.87579 .57938 m
.87579 .57938 L
s
P
p
0 .484 1 r
.01 w
.87594 .58103 m
.87594 .58103 L
s
P
p
0 .469 1 r
.01 w
.8761 .58268 m
.8761 .58268 L
s
P
p
0 .454 1 r
.01 w
.87625 .58433 m
.87625 .58433 L
s
P
p
0 .439 1 r
.01 w
.8764 .58599 m
.8764 .58599 L
s
P
p
0 .424 1 r
.01 w
.87655 .58764 m
.87655 .58764 L
s
P
p
0 .409 1 r
.01 w
.87671 .5893 m
.87671 .5893 L
s
P
p
0 .394 1 r
.01 w
.87686 .59096 m
.87686 .59096 L
s
P
p
0 .379 1 r
.01 w
.87701 .59262 m
.87701 .59262 L
s
P
p
0 .364 1 r
.01 w
.87717 .59428 m
.87717 .59428 L
s
P
p
0 .349 1 r
.01 w
.87732 .59595 m
.87732 .59595 L
s
P
p
0 .334 1 r
.01 w
.87747 .59761 m
.87747 .59761 L
s
P
p
0 .319 1 r
.01 w
.87763 .59928 m
.87763 .59928 L
s
P
p
0 .304 1 r
.01 w
.87778 .60094 m
.87778 .60094 L
s
P
p
0 .289 1 r
.01 w
.87793 .60261 m
.87793 .60261 L
s
P
p
0 .274 1 r
.01 w
.87809 .60428 m
.87809 .60428 L
s
P
p
0 .259 1 r
.01 w
.87824 .60595 m
.87824 .60595 L
s
P
p
0 .244 1 r
.01 w
.8784 .60762 m
.8784 .60762 L
s
P
p
0 .229 1 r
.01 w
.87855 .6093 m
.87855 .6093 L
s
P
p
0 .214 1 r
.01 w
.87871 .61097 m
.87871 .61097 L
s
P
p
0 .2 1 r
.01 w
.87886 .61265 m
.87886 .61265 L
s
P
p
0 .185 1 r
.01 w
.87901 .61433 m
.87901 .61433 L
s
P
p
0 .17 1 r
.01 w
.87917 .61601 m
.87917 .61601 L
s
P
p
0 .155 1 r
.01 w
.87932 .61769 m
.87932 .61769 L
s
P
p
0 .14 1 r
.01 w
.87948 .61937 m
.87948 .61937 L
s
P
p
0 .125 1 r
.01 w
.87964 .62106 m
.87964 .62106 L
s
P
p
0 .11 1 r
.01 w
.87979 .62274 m
.87979 .62274 L
s
P
p
0 .095 1 r
.01 w
.87995 .62443 m
.87995 .62443 L
s
P
p
0 .08 1 r
.01 w
.8801 .62612 m
.8801 .62612 L
s
P
p
0 .065 1 r
.01 w
.88026 .62781 m
.88026 .62781 L
s
P
p
0 .05 1 r
.01 w
.88041 .6295 m
.88041 .6295 L
s
P
p
0 .035 1 r
.01 w
.88057 .63119 m
.88057 .63119 L
s
P
p
0 .02 1 r
.01 w
.88073 .63288 m
.88073 .63288 L
s
P
p
0 .005 1 r
.01 w
.88088 .63458 m
.88088 .63458 L
s
P
p
.01 0 1 r
.01 w
.88104 .63628 m
.88104 .63628 L
s
P
p
.025 0 1 r
.01 w
.8812 .63797 m
.8812 .63797 L
s
P
p
.04 0 1 r
.01 w
.88135 .63967 m
.88135 .63967 L
s
P
p
.055 0 1 r
.01 w
.88151 .64138 m
.88151 .64138 L
s
P
p
.07 0 1 r
.01 w
.88167 .64308 m
.88167 .64308 L
s
P
p
.085 0 1 r
.01 w
.88182 .64478 m
.88182 .64478 L
s
P
p
.1 0 1 r
.01 w
.88198 .64649 m
.88198 .64649 L
s
P
p
.115 0 1 r
.01 w
.88214 .64819 m
.88214 .64819 L
s
P
p
.13 0 1 r
.01 w
.88229 .6499 m
.88229 .6499 L
s
P
p
.145 0 1 r
.01 w
.88245 .65161 m
.88245 .65161 L
s
P
p
.16 0 1 r
.01 w
.88261 .65332 m
.88261 .65332 L
s
P
p
.175 0 1 r
.01 w
.88277 .65504 m
.88277 .65504 L
s
P
p
.19 0 1 r
.01 w
.88293 .65675 m
.88293 .65675 L
s
P
p
.204 0 1 r
.01 w
.88308 .65847 m
.88308 .65847 L
s
P
p
.219 0 1 r
.01 w
.88324 .66018 m
.88324 .66018 L
s
P
p
.234 0 1 r
.01 w
.8834 .6619 m
.8834 .6619 L
s
P
p
.249 0 1 r
.01 w
.88356 .66362 m
.88356 .66362 L
s
P
p
.264 0 1 r
.01 w
.88372 .66534 m
.88372 .66534 L
s
P
p
.279 0 1 r
.01 w
.88388 .66707 m
.88388 .66707 L
s
P
p
.294 0 1 r
.01 w
.88404 .66879 m
.88404 .66879 L
s
P
p
.309 0 1 r
.01 w
.8842 .67052 m
.8842 .67052 L
s
P
p
.324 0 1 r
.01 w
.88435 .67224 m
.88435 .67224 L
s
P
p
.339 0 1 r
.01 w
.88451 .67397 m
.88451 .67397 L
s
P
p
.354 0 1 r
.01 w
.88467 .6757 m
.88467 .6757 L
s
P
p
.369 0 1 r
.01 w
.88483 .67743 m
.88483 .67743 L
s
P
p
.384 0 1 r
.01 w
.88499 .67917 m
.88499 .67917 L
s
P
p
.399 0 1 r
.01 w
.88515 .6809 m
.88515 .6809 L
s
P
p
.414 0 1 r
.01 w
.88531 .68264 m
.88531 .68264 L
s
P
p
.429 0 1 r
.01 w
.88547 .68437 m
.88547 .68437 L
s
P
p
.444 0 1 r
.01 w
.88563 .68611 m
.88563 .68611 L
s
P
p
.459 0 1 r
.01 w
.88579 .68785 m
.88579 .68785 L
s
P
p
.474 0 1 r
.01 w
.88595 .6896 m
.88595 .6896 L
s
P
p
.489 0 1 r
.01 w
.88612 .69134 m
.88612 .69134 L
s
P
p
.504 0 1 r
.01 w
.88628 .69308 m
.88628 .69308 L
s
P
p
.519 0 1 r
.01 w
.88644 .69483 m
.88644 .69483 L
s
P
p
.534 0 1 r
.01 w
.8866 .69658 m
.8866 .69658 L
s
P
p
.549 0 1 r
.01 w
.88676 .69833 m
.88676 .69833 L
s
P
p
.564 0 1 r
.01 w
.88692 .70008 m
.88692 .70008 L
s
P
p
.579 0 1 r
.01 w
.88708 .70183 m
.88708 .70183 L
s
P
p
.594 0 1 r
.01 w
.88724 .70359 m
.88724 .70359 L
s
P
p
.608 0 1 r
.01 w
.88741 .70534 m
.88741 .70534 L
s
P
p
.623 0 1 r
.01 w
.88757 .7071 m
.88757 .7071 L
s
P
p
.638 0 1 r
.01 w
.88773 .70886 m
.88773 .70886 L
s
P
p
.653 0 1 r
.01 w
.88789 .71062 m
.88789 .71062 L
s
P
p
.668 0 1 r
.01 w
.88806 .71238 m
.88806 .71238 L
s
P
p
.683 0 1 r
.01 w
.88822 .71414 m
.88822 .71414 L
s
P
p
.698 0 1 r
.01 w
.88838 .71591 m
.88838 .71591 L
s
P
p
.713 0 1 r
.01 w
.88854 .71767 m
.88854 .71767 L
s
P
p
.728 0 1 r
.01 w
.88871 .71944 m
.88871 .71944 L
s
P
p
.743 0 1 r
.01 w
.88887 .72121 m
.88887 .72121 L
s
P
p
.758 0 1 r
.01 w
.88903 .72298 m
.88903 .72298 L
s
P
p
.773 0 1 r
.01 w
.8892 .72475 m
.8892 .72475 L
s
P
p
.788 0 1 r
.01 w
.88936 .72652 m
.88936 .72652 L
s
P
p
.803 0 1 r
.01 w
.88952 .7283 m
.88952 .7283 L
s
P
p
.818 0 1 r
.01 w
.88969 .73008 m
.88969 .73008 L
s
P
p
.833 0 1 r
.01 w
.88985 .73185 m
.88985 .73185 L
s
P
p
.848 0 1 r
.01 w
.89002 .73363 m
.89002 .73363 L
s
P
p
.863 0 1 r
.01 w
.89018 .73542 m
.89018 .73542 L
s
P
p
.878 0 1 r
.01 w
.89034 .7372 m
.89034 .7372 L
s
P
p
.893 0 1 r
.01 w
.89051 .73898 m
.89051 .73898 L
s
P
p
.908 0 1 r
.01 w
.89067 .74077 m
.89067 .74077 L
s
P
p
.923 0 1 r
.01 w
.89084 .74256 m
.89084 .74256 L
s
P
p
.938 0 1 r
.01 w
.891 .74435 m
.891 .74435 L
s
P
p
.953 0 1 r
.01 w
.89117 .74614 m
.89117 .74614 L
s
P
p
.968 0 1 r
.01 w
.89133 .74793 m
.89133 .74793 L
s
P
p
.983 0 1 r
.01 w
.8915 .74972 m
.8915 .74972 L
s
P
p
.998 0 1 r
.01 w
.89166 .75152 m
.89166 .75152 L
s
P
p
1 0 .988 r
.01 w
.89183 .75331 m
.89183 .75331 L
s
P
p
1 0 .973 r
.01 w
.892 .75511 m
.892 .75511 L
s
P
p
1 0 .958 r
.01 w
.89216 .75691 m
.89216 .75691 L
s
P
p
1 0 .943 r
.01 w
.89233 .75871 m
.89233 .75871 L
s
P
p
1 0 .928 r
.01 w
.89249 .76052 m
.89249 .76052 L
s
P
p
1 0 .913 r
.01 w
.89266 .76232 m
.89266 .76232 L
s
P
p
1 0 .898 r
.01 w
.89283 .76413 m
.89283 .76413 L
s
P
p
1 0 .883 r
.01 w
.89299 .76594 m
.89299 .76594 L
s
P
p
1 0 .868 r
.01 w
.89316 .76774 m
.89316 .76774 L
s
P
p
1 0 .853 r
.01 w
.89333 .76956 m
.89333 .76956 L
s
P
p
1 0 .838 r
.01 w
.89349 .77137 m
.89349 .77137 L
s
P
p
1 0 .823 r
.01 w
.89366 .77318 m
.89366 .77318 L
s
P
p
1 0 .808 r
.01 w
.89383 .775 m
.89383 .775 L
s
P
p
1 0 .793 r
.01 w
.894 .77682 m
.894 .77682 L
s
P
p
1 0 .778 r
.01 w
.89416 .77863 m
.89416 .77863 L
s
P
p
1 0 .763 r
.01 w
.89433 .78045 m
.89433 .78045 L
s
P
p
1 0 .748 r
.01 w
.8945 .78228 m
.8945 .78228 L
s
P
p
1 0 .733 r
.01 w
.89467 .7841 m
.89467 .7841 L
s
P
p
1 0 .718 r
.01 w
.89484 .78593 m
.89484 .78593 L
s
P
p
1 0 .703 r
.01 w
.89501 .78775 m
.89501 .78775 L
s
P
p
1 0 .688 r
.01 w
.89517 .78958 m
.89517 .78958 L
s
P
p
1 0 .673 r
.01 w
.89534 .79141 m
.89534 .79141 L
s
P
p
1 0 .658 r
.01 w
.89551 .79324 m
.89551 .79324 L
s
P
p
1 0 .643 r
.01 w
.89568 .79508 m
.89568 .79508 L
s
P
p
1 0 .628 r
.01 w
.89585 .79691 m
.89585 .79691 L
s
P
p
1 0 .613 r
.01 w
.89602 .79875 m
.89602 .79875 L
s
P
p
1 0 .599 r
.01 w
.89619 .80058 m
.89619 .80058 L
s
P
p
1 0 .584 r
.01 w
.89636 .80242 m
.89636 .80242 L
s
P
p
1 0 .569 r
.01 w
.89653 .80427 m
.89653 .80427 L
s
P
p
1 0 .554 r
.01 w
.8967 .80611 m
.8967 .80611 L
s
P
p
1 0 .539 r
.01 w
.89687 .80795 m
.89687 .80795 L
s
P
p
1 0 .524 r
.01 w
.89704 .8098 m
.89704 .8098 L
s
P
p
1 0 .509 r
.01 w
.89721 .81165 m
.89721 .81165 L
s
P
p
1 0 .494 r
.01 w
.89738 .8135 m
.89738 .8135 L
s
P
p
1 0 .479 r
.01 w
.89755 .81535 m
.89755 .81535 L
s
P
p
1 0 .464 r
.01 w
.89772 .8172 m
.89772 .8172 L
s
P
p
1 0 .449 r
.01 w
.89789 .81905 m
.89789 .81905 L
s
P
p
1 0 .434 r
.01 w
.89806 .82091 m
.89806 .82091 L
s
P
p
1 0 .419 r
.01 w
.89823 .82277 m
.89823 .82277 L
s
P
p
1 0 .404 r
.01 w
.89841 .82463 m
.89841 .82463 L
s
P
p
1 0 .389 r
.01 w
.89858 .82649 m
.89858 .82649 L
s
P
p
1 0 .374 r
.01 w
.89875 .82835 m
.89875 .82835 L
s
P
p
1 0 .359 r
.01 w
.89892 .83021 m
.89892 .83021 L
s
P
p
1 0 .344 r
.01 w
.89909 .83208 m
.89909 .83208 L
s
P
p
1 0 .329 r
.01 w
.89926 .83395 m
.89926 .83395 L
s
P
p
1 0 .314 r
.01 w
.89944 .83582 m
.89944 .83582 L
s
P
p
1 0 .299 r
.01 w
.89961 .83769 m
.89961 .83769 L
s
P
p
1 0 .284 r
.01 w
.89978 .83956 m
.89978 .83956 L
s
P
p
1 0 .269 r
.01 w
.89995 .84143 m
.89995 .84143 L
s
P
p
1 0 .254 r
.01 w
.90013 .84331 m
.90013 .84331 L
s
P
p
1 0 .239 r
.01 w
.9003 .84519 m
.9003 .84519 L
s
P
p
1 0 .224 r
.01 w
.90047 .84707 m
.90047 .84707 L
s
P
p
1 0 .209 r
.01 w
.90065 .84895 m
.90065 .84895 L
s
P
p
1 0 .195 r
.01 w
.90082 .85083 m
.90082 .85083 L
s
P
p
1 0 .18 r
.01 w
.90099 .85271 m
.90099 .85271 L
s
P
p
1 0 .165 r
.01 w
.90117 .8546 m
.90117 .8546 L
s
P
p
1 0 .15 r
.01 w
.90134 .85649 m
.90134 .85649 L
s
P
p
1 0 .135 r
.01 w
.90152 .85837 m
.90152 .85837 L
s
P
p
1 0 .12 r
.01 w
.90169 .86027 m
.90169 .86027 L
s
P
p
1 0 .105 r
.01 w
.90187 .86216 m
.90187 .86216 L
s
P
p
1 0 .09 r
.01 w
.90204 .86405 m
.90204 .86405 L
s
P
p
1 0 .075 r
.01 w
.90222 .86595 m
.90222 .86595 L
s
P
p
1 0 .06 r
.01 w
.90239 .86785 m
.90239 .86785 L
s
P
p
1 0 .045 r
.01 w
.90257 .86974 m
.90257 .86974 L
s
P
p
1 0 .03 r
.01 w
.90274 .87165 m
.90274 .87165 L
s
P
p
1 0 .015 r
.01 w
.90292 .87355 m
.90292 .87355 L
s
P
p
.002 w
.63084 .0243 m
.88577 .22015 L
s
.88577 .22015 m
.95623 .89675 L
s
.95623 .89675 m
.65581 .72845 L
s
.65581 .72845 m
.63084 .0243 L
s
.11999 .13426 m
.04377 .82359 L
s
.04377 .82359 m
.65581 .72845 L
s
.65581 .72845 m
.63084 .0243 L
s
.63084 .0243 m
.11999 .13426 L
s
P
p
p
.002 w
.11999 .13426 m
.63084 .0243 L
s
P
p
.002 w
.23618 .10925 m
.24321 .11391 L
s
P
[(5)] .22214 .09993 .8366 1 Mshowa
p
.002 w
.38482 .07726 m
.39162 .08202 L
s
P
[(10)] .37123 .06774 .7928 1 Mshowa
p
.002 w
.53737 .04442 m
.54393 .04929 L
s
P
[(15)] .52425 .0347 .74901 1 Mshowa
p
.001 w
.26561 .10292 m
.26979 .10573 L
s
P
p
.001 w
.29518 .09655 m
.29934 .09937 L
s
P
p
.001 w
.32491 .09015 m
.32904 .09299 L
s
P
p
.001 w
.35479 .08372 m
.35889 .08657 L
s
P
p
.001 w
.41501 .07076 m
.41906 .07363 L
s
P
p
.001 w
.44536 .06423 m
.44939 .06711 L
s
P
p
.001 w
.47587 .05766 m
.47987 .06055 L
s
P
p
.001 w
.50654 .05106 m
.5105 .05396 L
s
P
p
.001 w
.20691 .11555 m
.21115 .11834 L
s
P
p
.001 w
.17779 .12182 m
.18206 .12459 L
s
P
p
.001 w
.14882 .12806 m
.15311 .13082 L
s
P
p
.001 w
.56836 .03775 m
.57227 .04068 L
s
P
p
.001 w
.59952 .03104 m
.60339 .03399 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28793 .02348 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004P0
0ol300;o0`03o`800ol20003o`000;X000170007o`000?l0o`020003o`3o008000Ko003o0?l20003
o`000;X0001;0003o`3o008000?o0?l00P001_l00?l0o`8000?o0000<@03o`<00on00000B003o`80
00Ko003o0?l20006o`00o`3o0P000ol0000b0003o`0000D000?o0000O@0004L000?o00001002o`80
00Go003o0006ocD000?o00001@000ol0001m0000A`001Ol0003o00`000?o0?l0=`000ol0000200?o
P00004P00ol?0003o`0003D000?o00000P000ol0000K00CoH@0009400_l400Co5@05o`8000?o0?l0
H0000:/01Ol70004o`00oel0002W00Co1@000ol000040004o`0000;oG@000:801Ol>00Oo00<0o`00
F`0006P00ol400;o;005o`D000?o00001P05o`:100?obol010000ol0001I0000J@000ol000020004
o`00obL01?l00`3oo`0;00Ko1846o`@000?o0000F00006T000?o00000P001?l00?lR00Go1`001?l0
0009o`:11?l01K_;^h7o00>10_l00`3oo`02oeP0001Y0003o`00008000Co003o7@05o`<000?o0000
1P04o`V10_l8^`03oh6100:10_l40003o`0000T00om90000J@000ol000020004o`00oaT01?l=00Co
0h400on1P@05o`0=^l^kbk_;^l^kbk_;o`03P@Co10000ol0000;0003o`0004H0001X00;o1@02oaD0
1Ol40003o`0000H01?l8P@;o4K/01?nkool4P@;o00<0ool00_l;0003o`0004H0002100Ko3@04o`>1
00?oPH401?l06L^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l/01X400ol000020003o`0000D00om90000
O@04o`H000?o00001@05o`B10_l2P@;o6K/00onk^`02^`B100?oPOl010000ol000040003o`0004T0
001600?o;`05o`030?oo00X01_l4P@Co02?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^k
b`05o`>100?o00000X400ol0000300CoB00004T000?o00009`05o``02?l2P@Co9K/4o`B100?oPH40
0X43o`800_m?0000B@000ol0000S00Co0`000ol0P@0700Co2842o`0Sbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/01ol9P@06oh61oh7o10000ol0001<0000AP03ob401Ol80005o`21P@00
1?l3P@03oh6100Co8K/6o`J100?oPH402842o`>100Co00000_m=0000AP000ol0000M00Co1@000ol0
000600Co2842o`0>bk_;^l^kbk_;^l^kbk/6o`0=bk_;^l^kbk_;^l^kb`04o`>100?oPH401h400on1
P@05o`04bk_;^`B10ol200;o;005o`050?ooo`000ol300;o3@0004H01?lG00Oo2`05o`>100?oPH40
1?l4P@03ok^k00Nk1?l6F`;o2K/2o`R100?oPH401X43o`Zk0h400on1o`040003o`0002T000?o0000
0P001?l00?l40004o`00o`h0001L00Go3@06o`B10_l2P@;o2H403?o;^l^kbk_;^l^ko`UK00co^l^k
bk_;^l^kbol8P@03oh6100Co00nkok_;^l^kbk_;^l^kbk/00_l3P@04o`0000;o:P000ol0000300?o
0P02o`<000?o0000300005P01?l30003o`0000H02?l4P@Co1[/00on1P@07P@03ok^k00Rk00?oFe/0
1e/2o`Vk00?oPH400X42o`:10_l5^`03ok^k00fk1843o`8000?o00009`05o`<000?o0?l01@000ol0
000<0000D`05o``01?l3P@03oh6100Co00k;^l^kbk_;^l^kbk_;o`:11?l03l^kbk_;^l^kbk_;^l^k
o`02F`Co15/02_o;^l^kbk_;^l/4o`J10_l05;_;^onkbk_;^l^kbk_;^l^kbk_;1842o`<00_lW0003
o`0000<00_l300?o00@0oooo3@0004h01Ol40003o`0000H01?l8P@;o3[/6oa>k0_l9F`03ok^k00Rk
00?oPH401h401?nk^olA^`Ko10000ol0000T0003o`0000d000?o0000300004X01_l<00Co0h400on1
P@04o`0<bk_;^l^kbk_;^l^k1_l6F`;o00O;^l^kbk_;00Co00Vkbk_;^l^kbol02E/2o`0:^l^kbk_;
^l^ko`F10_l2P@?o01:kbk_;^l^kbk_;^l^kbk_;^l/5P@Ko9@05oaX0001500Go1P000ol0000400Go
1842o`:10_l<^`Co15/00omKF`07F`03ok^k00Co18400onk^`06^`03oe]K00Co15/00onk^`07^`Go
1X400onk^`0A^`F10_l300;o2P03o`@00_l_0000@005o`<000?o00001P000h7oo`04o`B11?l04<^k
bk_;^l^kbk_;^l^kbk/2o`UK00?oFe/01e/2o`V100Wo^l^kbk_;^l/00_l9F`0;ok_;^l^kbk_;^l/0
0_l7P@;o01?;^l^kbk_;^l^kbk_;^l^kbk_;00>11?l40003o`0000P000?o00000P001?l00?l^0000
?004o``02?l2P@Co6;/2o`QK00?oFe/01?l4^`03oh6100N10_l8^`03oe]K00MK00?o^k/02K/00on1
P@02P@?o00>1ool04[/2o`B100?o0?l00ol90003o`00008000Co003o;P0003L01Ol40003o`0000D0
1?l8P@;o00o;^l^kbk_;^l^kbk_;^l/01_l02[_;^l^kbk_;^ol4F`;o0U/2o`0:^l^kbk_;^l^ko`:1
1?l4P@0:ol^kbk_;^l^ko`9K1?l03k_;^l^kbk_;^l^kbk_;^`04o`:101SoPH61ok_;^l^kbk_;^l^k
bk_;^l^kbk/5P@;o0`000ol000060003o`00008000Co003o;P0003801ol;00Co18400on1P@03o`fk
1_l6F`03ok^k00Nk1?l>^`Co2H400onk^`06^`;o5;/00on1P@02P@03oh6100:100?o^k/04K/3P@04
oh7oo`<00_l60003o`00008000Co003o;P0003000_l=00Ko1842o`:10_l03;_;^l^kbk_;^l^kb`Co
0e/00omKF`07F`0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l4P@;o28408?o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_o0h400on1P@03P@;o01;;^l^kbk_;^l^kbk_;^l^kbk/2o`B100?oPH40
0X400ol0000200;o1@02obl0000`0003o`3o00P01_l4P@Co4;/2o`QK00?oFe/01e/00onk^`0=^`Ko
2X400on1P@03ob:k00?oPH401?l4P@03ok^k016k1H42o`<000?o0000>@00030000?o00002_l2P@Co
01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00QK00?oFe/01?l03;_;^l^kbk_;^l^kb`Ko1X42o`V1
0_l03/^kbk_;^l^kbk_;^l^k1_l04/^kbk_;^l^kbk_;^l^kbk_;^`?o28405?o;^l^kbk_;^l^kbk_;
^l^kbk_;0h401?n1ool300;o>@0003001Ol8P@;o7K/00omKF`02F`;o0U/2o`fk0ol4P@;o28400on1
P@04o`jk1?l6F`03ok^k016k00?oPH401h42oa:k0_l4P@03o`3o00?o>00002l00_l3P@03oh6100Co
02:kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l03k_;^l^kbk_;^l^kbk_;^`04o`V1
00?oPH400X42o`:10_l05L^kbk_;^l^kbk_;^l^kbk_;^l^ko`08F`0Col^kbk_;^l^kbk_;^l^kbk_;
^`02o`:11?l4P@0Dok_;^l^kbk_;^l^kbk_;^l^kbk/5P@;o0`000ol0000e00009P02o`L000Co0?oo
0X42ocFk1?l4P@03oh6100N11?lK^`03oe]K009K0_l2F`03ok^k00fk1_l9P@03ok^k016k0h401?n1
ool30003o`0003@0000U0004o`00o`H000?o00000_l3P@;o036kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2H400on1P@04o`B101ko^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/4o`0>bk_;^l^kbk_;^l^kbk/6o`:100GoPH61o`09P@0Dok_;^l^kbk_;^l^k
bk_;^l^kbk/2o`B100?o0?l00old00009@001?l00?l60003o`00008000?oPH400X400onk^`0T^`Co
2;/00on1P@07P@;o2H400onk^`0X^`Co18401On1PH7o00B100?oPH401?lH^`F10_l30003o`000340
000U0004o`00o`H000?o00000`03o`:10_l08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1?l4F`0:ok_;^l^kbk_;o`:11?l4P@03oh6100N101;o^l^kbk_;^l^kbk_;^l^kbk/4o`0>bk_;^l^k
bk_;^l^kbk/6o`V100GoPH7oP@02o`:10_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>1
00CoPOoo0`000ol0000`00009@001?l00?l60003o`0000D00_l3P@;o7;/2o`UK00?o^k/01[/2o`V1
00?oPH401?l@^`Co15/00onk^`07^`Co1X400on1P@07P@Co8;/6o`B100?o0?l00ol`00009P02o`L0
00?o00001`000on1P@02P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l8F`;o00S;^l^k
bk_;^`;o2842o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l9F`0<ol^kbk_;^l^kbk_o28400on1P@04o`0P
bk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/6o`IK00?oPH400X400ol000020003o`0000T0
0ol300?o6`0002h00ol900?o0X42oafk00?oFe/00ol4F`;o2;/00on1P@03o`bk1?l8^`;o25/00onk
^`08^`03oh6100:10_l2P@;o2;/00onk^`0E^`Co15/00omKF`06F`05oh61oh400_l30003o`0000T0
00?o00001@000ol0000H0000;`000ol0000:0003oh6100:101kobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/2o`UK00Wo^l^kbk_;^l/00_l03;_;^l^kbk_;^l^kb`?o1842o`09bk_;^l^kbk_o009K
0ol03/^kbk_;^l^kbk_;^l^k1?l6P@0Jok_;^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk/6o`UK00?oFe/0
0U/2o`9K0_l4P@03o`3o00;o2P000ol000050003o`0001P0000_0003o`0000/000?oPH400X400onk
^`0L^`03oe]K00MK00?o^k/03K/6o`V100?o^k/01[/2oa>k00?oPH401X400onk^`04^`03ok^k00Vk
1_l6F`03oe]K00MK1?l6F`03oh6100:100Co00000_l80003o`0000800olK0000;P000ol0000>00;o
0X42o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o0U/4o`0>^l^kbk_;^l^kbk_;^l/4o`J1
00?oPH401h42o`0M^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01842o`:10_l03<^kbk_o^l^k
bk_;^`Co15/00omKF`06F`03oe]K00Co00G;^l^ko`08F`05oh61oh400_l30003o`0000D000?o0000
0P000ol0000K0000;P000ol0000?00;o0h42oabk0_lD^`03oh6100J100?oPH401?l4P@03ok^k01Rk
1_l6P@05ok^k^ol00k/4o`UK00?oFe/00U/2o`9K0_l9^`03oe]K009K0_l2F`;o18401On1PH7o00D0
0_l400Co6P0002h000?o00004@000on1P@02P@0dol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`B10_l2P@;o2H405onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o
15/2o`N100?obk/01?l4F`03oe]K00MK1?l03/^kbk_;^l^kbk_;^l^k1_l6F`03oh6100:100Co0000
0_lW0000;P000ol0000A0004P@3oo`:10_la^`Co1X400on1P@07P@03ok^k016k0_l9F`03oh6100:1
00?oPH400ol8F`03oe]K00Co4;/4o`AK00?oFe/01e/3o`03POoo00800_lV0000;P000ol0000A0004
P@00o`B10ol0<;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o
1h400on1P@04o`0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`09F`Co1H400omKF`07F`;o00k;^l^k
bk_;^l^kbk_;^`Ko2E/00omKF`04o`03bk_;00B10ol20003o`0002<0000^00;o4@000h4000020003
oh6100B10_lQ^`Ko2K/00on1P@02P@03oh6100;o7K/00omKF`04o`Bk00?oPH401H400omKF`04o`AK
00?o^k/01k/4o`IK00?oFe/01e/2o`Rk1842o`<000?o00008P0002h000?o000040000h40000400?o
18407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co1U/02_nkbk_;^l^kbk/4o`F10_l07;_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0:^l^kbk_;^l^ko`B100?oPOl00_l9F`0<ol^kbk_;
^l^kbk_o25/00omKF`04o`0=bk_;^l^kbk_;^l^kb`07o`800_lR0000;P000ol0000@0003P@0000H0
00?oPH400h400onk^`0K^`03oe]K00IK00?o^k/02;/00on1P@06P@03ok^k02Fk1?l2^`03ok^k00;o
25/2o`Vk00?oFe/00U/2o`9K0_lC^`B10ol20003o`0001l0000^0003o`00010000>100001`000on1
P@03P@;o01fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`04F`;o0U/2o`0:bk_;^l^kbk_;o`B1
0_l2P@;o033;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk/4o`IK
00[o^l^kbk_;^l^k1?l6F`;o01;;^l^kbk_;^l^kbk_;^l^kbk/3P@03oh7o00<000?o00007P0002d0
00?o00004@000h40000900;o18400onk^`0J^`Co1U/00onk^`07^`Co1X42obVk00?o^k/01;/00omK
F`06F`03ok^k00Rk00?oFe/01e/00onk^`0@^`;o0h45oal0000]0003o`00014000>100002P02o`B1
01ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`MK00cobk_;^l^kbk_;^ol9P@;o033;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbol4F`;o0U/2o`0:bk_;^l^k
bk_;o`9K1?l3F`0Dol^kbk_;^l^kbk_;^l^kbk_;^l/4P@;o00<0o`007P0002d000?o00004@000h40
000<00;o0h42oafk00?oFe/00U/01?mKFol:^`03oh6100Co18400onk^`0T^`03ok^k00Bk1_l6F`03
ok^k00Nk0_l8F`03ok^k016k0h401?n1oolO0000;@02oa8000>100003P02o`>10_l06[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;1_l03k_;^l^kbk_;^l^kbk_;^`02o`V102[obk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l/3o`AK00?oFe/01U/03?o;^l^kbk_;^l^ko`QK0_l04[_;
^l^kbk_;^l^kbk_;^l^kb`;o00Bkbk_o7`0002d000?o00004@000h40000?00;o18400onk^`0C^`Co
15/00onk^`0@^`03oh6100N10_lQ^`Ko25/00omKF`02F`;o0U/00onk^`08^`03oe]K00?o15/00onk
^`09^`Co0X43o`:k0_lN0000;@000ol0000A0003P@00014000?oPH400X42o`0>bk_;^l^kbk_;^l^k
bk/5o`UK01Co^l^kbk_;^l^kbk_;^l^kbk_;o`:11?l4P@0Kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00Ko0U/01OmKFe_o00QK1?l03<^kbk_;^l^kbk_;^`Ko25/01_nkbk_;o`DO00=O7h400X44o`80
00?o00007@0002d000?o00004@000h40000B00;o18400onk^`07^`Co1E/3o`MK00?o^k/04;/2o`V1
00?o^k/04k/4o`AK00GoFe]Ko`04F`03oe]K00?o3;/6o`EK00?oFe/01E/03QmO7amO7elOGamO7elG
0_l80003o`0001`0000]0003o`00010000>100005@000on1P@02P@0<ol^kbk_;^l^kbk_o2E/4o`0I
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`09P@;o017;^l^kbk_;^l^kbk_;^l^kb`02o`UK00GoFe_o
F`02o`9K0_l02k_;^l^kbk_;^l^k00Co15/00omKF`04F`0;GamO7aLO5alG7aL01Al01X7oo`0OG`X0
00?o0000700002`000?o00004@000h40000F00?o0X42o`Vk00?oFe/01?lO^`03oh6100Co18400onk
^`05^`Co1k/00omKF`07F`Co3;/5o`UK00lOGamO7elOGamO7elOGal01Ol60003Gal000T000?o0000
700002`000?o00004@000h40000F0004P@3oo`>10ol01k_;^l^kbk/00_l09<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2H400oo;^`04o`AK00Wo^l^kbk_;^ol00U/4o`0<^l^kboo;
^l^kbk_;1_l5F`04oelOG`LO00IO7elOGh47o`/000<OG`002@000ol0000L0000;0000ol0000A0003
P@0001H000F10000o`05P@;o;K/3o`N10_l9F`03ok^k00Fk0_l8^`04ok^k^`Co0e/00olO7`097`06
GamO7elO1?l2P@?o10000h4000090003GaL000T000?o0000700002`00_lB0003P@0001D000>10000
0`03o`B102kobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1_l5F`03
oe]K00MK01?o^l^kbk_;^l^kbk_;^l^kboo;00;o00=K7al00al035lOGamO7elOGamOo`<O0h44o`X0
00>100002@025`X000?o0000700002`000?o00004@000h40000E0003P@0000D000?oPH400h400onk
^`0V^`Co15/00omKF`05F`03oe]K00Co4k/00olO7`0:7`04oalO7`B11_l@0003P@0000P000<G4@00
2@000ol0000L0000;0000ol0000A0003P@0001D000>100001P000on1P@03P@;o00jkbk_;^l^kbk_;
^l^kb`Go017;^l^kbk_;^l^kbk_;^l^kb`02o`UK00?oFe/00U/00omKF`02o`0Hbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^aoo1Al01E/OGaoo00:11?l3P@;o5@000h40000800034AL000T000?o0000700002`0
00?o00004@000h40000E0003P@0000P00_l4P@03ok^k00Nk1?l5F`03ok^k00Fk1?l7^`;o25/4o`F1
0_lD^`037olO00Ko1845oaX000>1000020025`X000?o0000700002`000?o00004@000h40000E0003
P@0000T00_l4P@0<ok_;^l^kbk_;^l_o1e/00oo;^`04o`AK00Wo^l^kbk_;^l/01?l01k_;^l^kbol0
2842o`0>bk_;^l^kbk_;^l^kbk/7o`B11_lO0003P@0000P000<G4@002P000ol0000K0000;0000ol0
000A0003P@0001D000>100002`000on1P@02P@;o2K/00omKF`02F`03oe]K00;o2E/00onk^`0@^`03
oh6100?o18400onk^`05^`Ko0h44o`>10_lT0003P@0000P00a4:0003o`0001/0000[0003o`000180
00>100005@000h40000<00;o18402_o;^l^kbk_;^l/4o`EK0_l8F`0Cok_;^l^kbk_;^l^kbk_;^l^k
b`02o`R100?obk/01?l8P@Co0`000h40000T0003P@0000T000>O4@002@000ol0000K0000:`000ol0
000A0003P@0001H000>100003P000on1P@02P@03ok^k00Rk00?oFe/01U/4oaVk0_l7P@;o1X45o`@0
00Go0000P@0V0003P@0000T00Yl:0003o`0001/0000[0004oh7ooa0000>100005P000h40000@00?o
00f1oonkbk_;^l^kbk_o009K0ol07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01_l3P@Co
0h400ol000070005o`0008409P000h4000090003Wml000T000?o00006`0001/00ol400;o1`000ol0
P@0A0003P@0001H000>100004@02o`>10ol7^`;o7[/4o`R11?l>0005o`0008409P000h4000090003
Wml000T000?o00006`0001`000?o00000P001?l00?l60003o`0000:13`000h40000F0003P@0001<0
00?oPH400h42o`0Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/5o`F11_lC0005o`000840
9P000h40000900:O2P000ol0000K000070000ol000020004o`00o`H000?o00000P02P@d000>10000
5P000h40000C0004POooo`B100?o^k/05k/6o`B11olH0005o`0008409P000h40000900:O2P000ol0
000K000070000ol000020004o`00o`H000?o000010000h40000:0003P@0001H000>100004`000h40
0002o`B101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/01?l9P@?o7@001Ol0002102H000>100002@02g`X0
00?o00006`0001`000?o00000P001?l00?l60003o`0000D00X4:0003P@0001H000>100004`001840
0002o`B10_l=^`Go1H45o`8000>100007P001Ol0002102H000>100002@000ioO00090003o`0001/0
000K00;o1@02o`L000?o00001`02P@P000>100005P000h40000C0003P@0000<00_l4P@07ok_;^l^k
b`06o`B11_l70003P@0001h000Go0000P@0W0003P@0000P00]l;0003o`0001X0000Z0003o`0000X0
00>100001@000h40000E0003P@0001@000>100001@000on1P@02P@03ok^k00?o0h43o`>10_l<0003
P@0001h000?o00000P000h40000T0003P@0000P00]l;0003o`0001X0000Z00?o2`02P@D000>10000
5@000h40000D0003P@0000H00ol2P@;o1H44oa4000>100007`001Ol0002102H000>100002003g`X0
00?o00006P0002X000?o00003@02P@<000>100005@000h40000D0003P@0000P000Co^k^k1OlF0003
P@0001l000Go0000P@0V0003P@0000T000?OgP002@000ol0000J0000:P000ol0000?0004P@00PAL0
00>1000050000h40000900?o6`000h40000O0005o`0008409P000h4000090003g]l000T000?o0000
6P0002X000?o00004002PAP000>1000050000h4000090003o`0001/000>100007`001Ol0002102H0
00>100002@02gPX000?o00006P0002X000?o00004@03PAH000>100004`000h40000:0003o`0001/0
00>100007`001Ol0002102H000>100002@000g7O00090003o`0001X0000Z0003o`00014000B10021
5@000h40000C0003P@0000X000?o00006`000h40000O0005o`0008409P000h40000900;O2P000ol0
000J0000:P000ol0000A0004P@0000:14`000h40000C0003P@0000X000?o00006`000h40000O0005
o`0008409P000h40000900;N2P000ol0000J0000:P000ol0000A0003P@0000<00X4A0003P@0001<0
00>100002P000ol0000K0003P@0001l000Go0000P@0V0003P@0000T00]h;0003o`0001T0000Y00?o
4P000h4000050003P@0000h000>100004`000h40000:0003o`0001/000>100007`001Ol0002102H0
00>100002@02gP/000?o00006@0002T000?o00004P000h40000600:13P000h40000C0003P@0000X0
00?o00006`000h40000O0005o`0008409P000h4000090003gW4000X000?o00006@0002T000?o0000
4P000h40000800:130000h40000C0003P@0000X000?o00006`000h40000O0005o`0008409P000h40
000900;N2`000ol0000I0000:@000ol0000B0003P@0000X000>100002@000h40000C0003P@0000X0
00?o00006`000h40000O0005o`0008409`000h4000080003LMkN00X000?o00006@0002T000?o0000
4P000h40000;00:12@000h40000C0003P@0000X000?o00006`000h40000O0005o`0008409`000h40
0009009a2P000ol0000I0000:@000ol0000B0003P@0000d00X470003P@0001<000>100002P000ol0
000K0003P@0001l000Go0000P@0W0003P@0000T000?NL@002@000ol0000I0000:@000ol0000A0003
P@00010000>100000`000h40000D0003P@0000X000?o00006`000h40000O0005o`0008409`000h40
0009009a2002P@03oh4001T0000Y0003o`00014000>100004@02P@<000>1000050000h40000:0003
o`0001/000>100007`001Ol0002102L000>100002@02L@<01H420003o`0001T0000X00?o4P000h40
000C00:100<0P@005@000h4000090003o`0001`000>100007`001Ol0002102L000>100002@000mea
P@02P@P000?o0000600002P000?o00004P000h40000E00:15P000h4000090003o`0001`000>10000
7`001Ol0002102L000>100000`06P@03UMd000X000?o0000600002P000?o00004P000h40000F00:1
5@000h4000090003o`0001`000>100007`001Ol0002102L01X460003UMd000X000?o0000600002P0
00?o00004P000h40000F0004P@21PA<000>100002@000ol0000L0003P@0001l000Go0000P@0S00F1
2`000g6E000:0003o`0001P0000X0003o`00018000>100005P001H400021018000>100002@000ol0
000L0003P@0001l000Go0000P@0M00J110000h40000900:E2`000ol0000H0000:0000ol0000B0003
P@0001H000>100000P02PA0000>100002@000ol0000L0003P@0001l000Go0000P@0H00F12P000h40
000900:E00?L000020000ol0000H0000:0000ol0000B0003P@0001H000>100001002P@h000>10000
2@000ol0000L0003P@0001l000Go0000P@0B00J13`000h40000900>E2P000ol0000H0000:0000ol0
000B0003P@0001H000>100001P000h40000;0003P@0000T000?o000070000h40000O0005o`000840
3@05PAH000>100002@02U@X000?o0000600002P000?o00004P000h40000F0003P@0000L00X4;0003
P@0000T000?o000070000h40000O0003o`00008000>100001@05PA/000>100002@000iGL00090003
o`0001P0000W00?o4P000h40000G0003P@0000T00X490003P@0000T000?o000070000h40000O0003
o`00008000>108401H4P0003P@0000T00]`:0003o`0001P0000W0003o`00018000>100005`000h40
000;0003P@0000H000>100002@000ol0000L0003P@0001l000?o0840184V0003P@0000T00]`;0003
o`0001L0000W0003o`00018000>100005`000h40000<00:11P000h4000090003o`0001`000>10000
7003P@03oh40008000>100009@000h4000090003g>`000X000?o00005`0002L000?o00004P000h40
000G0003P@0000h00X440003P@0000T000?o000070000h40000F00J10`000ol000020003P@0002D0
00>100002@02g0/000?o00005`0002L000?o00004P000h40000F0003P@00014000B1002130000ol0
000L0003P@0001401H490003o`00008000>100009@000h4000090003k=`000X000?o00005`0002L0
00?o00004P000h40000F0003P@0001800h4<0003o`0001`000>100003005P@h000?o00000P000h40
000U0003P@0000T000?/g0002P000ol0000G00009`000ol0000B0003P@0001H000>100005002P@/0
00?o000070000h40000600J150001Ol0002102L000>100002@02g0/000?o00005`0002L000?o0000
4P000h40000F0003P@0001@000>108402P000ol0000L0004P@0000F16P001Ol0002102L000>10000
2@000mc/g00:0003o`0001L0000W00?o4P000h40000F0003P@0001@000>100000X480003o`0001X0
1X4O0005o`0008409`000h40000900;L00?/000020000ol0000G00005P04o`<00_l70003oh4001<0
00>100005P000h40000D0003P@0000800X460003o`0001D01H420003P@00020000Go0000P@0W0003
P@0000X000?/g0002@000ol0000G00005`000ol000020004o`00o`H000Co08614P000h40000F0003
P@0001@000>1000010000h4000030003o`0001001H470003P@00020000Go0000P@0W0003P@0000X0
00>gk0002P000ol0000F000060001Ol0003o008000?o000010001?l00002PA0000>100005P000h40
000D0003P@0000D00X430003o`0000X01X4<0003P@00020000Go0000P@0X0003P@0000T000>gk000
2P000ol0000F00006@001?l00?l20003o`0000@000?o00000`000h40000<0003P@0001L000>10000
50000h40000700:100<0o`001P05PA8000>1000080001Ol0002102P000>100002@02]`/000?o0000
5P0001H000Co003o0P001?l00?l60003o`0000@00X4<0003P@0001L000>1000050000h4000090004
POl000F15`000h40000P0005o`000840:0000h40000900:g2`000ol0000F00000P03oa800_l400;o
1`000ol0000600:12P000h40000G0003P@0001@000>100002P000on1P@0L0003P@00020000Go0000
P@0X0003P@0000T00[H;0003o`0001H000020004o`00ob0000?o00002002P@P000>100005`000h40
000D0003P@0000X000?o000070000h40000P0005o`000840:0000h4000090003][L000X000?o0000
5P00008000?o00008@000ol0000:00:11P000h40000G0003P@0001@000>100002P000ol0000L0003
P@00020000Go0000P@0X0003P@0000T000>g]P002P000ol0000F00000P000ol0000P00?o3@000h40
00030003P@0001L000>1000050000h40000:0003o`0001`000>1000080001Ol0002102P000>10000
2@02]P/000?o00005P0000030?oo00;o80000ol0000>00:10`000h40000G0003P@0001@000>10000
2P000ol0000L0003P@00020000Go0000P@0X0003P@0000T00kH:0003o`0001H000020003o`000200
00?o00004002P@03084001L000>100005@000h40000:0003o`0001`000>1000080001Ol0002102P0
00>100002@02]P03o00000P000?o00005P00008000?o000080000ol0000B00:160000h40000E0003
P@0000X000?o000070000h40000P0005o`000840:0000h40000:0003]_`000X000?o00005@0002D0
00?o00004`03PAH000>100005@000h40000:0003o`0001`000>1000080001Ol0002102P000>10000
2P02]@/000?o00005@0002D000?o00004`000h400002PA@000>100005@000h40000:0003o`0001`0
00>1000080001Ol0002102P000>100002P02]@/000?o00005@0002D000?o00004P000h4000030003
P@00014000>100005@000h40000:0003o`0001`000>1000080001Ol0002102P000>100002P000`fe
000:0003o`0001D0000U0003o`00018000>100001002PA4000>100005@000h40000:0003o`0001`0
00>1000080000ol000020003P@0002H000>100002@000`fe000:0003o`0001D0000U0003o`000180
00>100001P02P@l000>100005@000h40000:0003o`0001`000>1000080000ol000020003P@0002H0
00>100002@000kD=000:0003o`0001D0000T00?o4`000h40000800:13@000h40000E0003P@0000T0
00?o00007@000h40000P0003o`00008000>100009P000h40000900:e2`000ol0000E000090000ol0
000C0003P@0000X00X4;0003P@0001D000>100002@000ol0000M0003P@00020000?o00000P000h40
000V0003P@0000T00Pd;0003o`0001D0000T0003o`0001<000>100003002P@T000>100005@000h40
00090003o`0001d000>1000080000ol000020003P@0002H000>100002@023@/000?o00005@0002@0
00?o00004`000h40000>0003P@0000H000>1000050000h40000:0003o`0001d000>1000080000ol0
00020003P@0002H000>100002@033@/000?o0000500002@000?o00004`000h40000?00:11P000h40
000D0003P@0000X000?o00007@000h40000P0003o`00008000>100009P000h40000:0003c0d000L0
0h400ol0000D000090000ol0000C0003P@0001400X440003P@0001@000>100002P000ol0000M0003
P@00020000?o00000P000h40000V0003P@0000X00Pd200J10`000ol0000D000090000ol0000C0003
P@0001<00X420003P@0001@000>100002P000ol0000M0003P@00020000?o00000P000h40000V0003
P@0000T000>13L`00X490003o`0001@0000T0003o`0001<000>100005@03PAH000>100002P000ol0
000M0003P@00020000?o00000P000h40000V0003P@0000<01X400`0=`00;0003o`0001@0000T0003
o`00018000>100005`02PAH000>100002P000ol0000M0003P@00020000?o00000P000h40000V00J1
1`023@/000?o0000500002<00olC0003P@0001L000B1086150000h40000:0003o`0001d000>10000
80000ol000020003P@0002001h4<00;<2`000ol0000D00008`000ol0000C0003P@0001L000B10000
0X4B0003P@0000X000?o00007@000h40000P0003o`00008000>100006P06P@H000>100002P000`g<
000:0003o`0001@0000S0003o`0001<000>100005`000h40000300:140000h40000:0003o`0001d0
00>100008@001Ol0002101L01H4=0003P@0000T000?<3@002P000ol0000D00008`000ol0000C0003
P@0001L000>100001@02P@h000>100002P000ol0000M0003P@00024000Go0000P@0A00J14P000h40
000900;<30000ol0000C00008`000ol0000C0003P@0001L000>100001`02P@`000>100002P000ol0
000M0003P@00024000Go0000P@0;00J160000h40000900;030000ol0000C00008`000ol0000C0003
P@0001L000>100002@000h4000090003P@0000X000?o00007@000h40000Q0005o`0008401@06PAh0
00>100002@03`0/000?o00004`0002<000?o00004`000h40000G0003P@0000X00X490003P@0000X0
00?o00007@000h40000Q0004o`0000J190000h40000:0003a/0000X000?o00004`0002<000?o0000
4`000h40000G0003P@0000`00X470003P@0000X000?o00007@000h40000P0003POn100>1:@000h40
000:0003a/0000X000?o00004`0002<000?o00004`000h40000G0003P@0000h00X450003P@0000X0
00?o00007@000h40000J00J100<0o`000P000h40000W0003P@0000X00/H;0003o`0001<0000R00?o
50000h40000G0003P@0001000X430003P@0000X000?o00007@000h40000D00J11`001Ol0002102T0
00>100002P000l36000:0003o`0001<0000R0003o`0001<000>1000060000h40000B00:100<0P@00
2`000ol0000M0003P@0000h01X4=0005o`000840:@000h40000:0003`<H000X000?o00004`000280
00?o00004`000h40000H0003P@0001@00X4<0003o`0001d000>100002006PA<000Go0000P@0Y0003
P@0000X000><aP002P000ol0000C00008P000ol0000C0003P@0001P000>100005@02P@/000?o0000
7@000h40000300F16@001Ol0002102T000>100002P000lJ<000:0003o`0001<0000R0003o`0001<0
00>1000060000h40000E0004P@21P@T000?o00007@06PAh000Go0000P@0Y0003P@0000X00X`<0003
o`000180000R0003o`0001<000>100005`000h40000F0004P@0000:11`000ol0000G00N18`000ol0
00020003P@0002L000>100002@02S0`000?o00004P00028000?o00004`000h40000G0003P@0001H0
00>100000`02P@D000?o00004@06P@H000>100008@000ol000020003P@0002L000>100002@000db<
C00;0003o`000180000R0003o`0001<000>100005`000h40000F0003P@0000D000>100000P000ol0
000;00J130000h40000Q0003o`00008000>100009`000h4000090003aXa<00/000?o00004P000240
00?o000050000h40000G0003P@0001H000>100001P02P@8000?o00001P05PA8000>100008@000ol0
00020003P@0002L000>100002P000lJ<000:0003o`000180000Q0004o`3ooa<000>100005`000h40
000F0003P@0000P00X400ol00006PAL000>100008@000ol000020003P@0002L000>100002P000db<
000:0003o`000180000A00?o1002o`L000?oP@0050000h40000G0003P@0001D000>100002`000on1
P@0M0003P@00024000?o00000P000h40000W0003P@0000X000=<S0002P000ol0000B000050001?l0
0?l20003o`0000@000Co08614`000h40000G0003P@0001D000>100002`000ol0000M0003P@000240
00?o00000P000h40000W0003P@0000X000=<S0002P000ol0000B000050001?l00?l20003o`0000@0
00Co00000X4A0003P@0001L000>100005@000h40000;0003o`0001d000>100008@000ol000020003
P@0002L000>100002P000ha<000:0003o`000180000B00;o0`001?l00?l60003o`0000<00X4>0003
P@0001P000>100005@000h40000;0003o`0001d000>100008@000ol000020003P@0002L000>10000
2P02C0`000?o00004@0001@000Co003o0P000ol000040003o`0000D00X4<0003P@0001P000>10000
5@000h40000;0003o`0001d000>100008@000ol000020003P@0002L000>100002P02C0`000?o0000
4@0001400ol400;o1`000ol0000700:12P000h40000H0003P@0001D000>100002`000ol0000M0003
P@00024000?o00000P000h40000W0003P@0000X00T`<0003o`000140000Q0003o`0000T00X480003
P@0001P000>100005@000h40000;0003o`0001d000>100008@000ol000020003P@0002L000>10000
2P000de<000;0003o`000140000P0003o`0000`00X460003P@0001P000>100005@000h40000:0003
o`0001h000>100008@000ol000020003P@0002L000>100002P000da=000;0003o`000140000P0003
o`0000h00X440003P@0001P000>100005@000h40000:0003o`0001h000>100008@000ol000020003
P@0002P000>100002@000da=C@0;0003o`000140000P00?o4002P@8000>1000060000h40000E0003
P@0000X000?o00007P000h40000Q0003o`00008000>10000:0000h40000:0003C4d000X000?o0000
4@00020000?o00004P03PAT000>100005P000h40000:0003o`0001h000>100008@000ol000020003
P@0002P000>100002P000da=000:0003o`000140000P0003o`0001@00X4H0003P@0001H000>10000
2P000ol0000N0003P@00024000?o00000P000h40000X0003P@0000X00Td;0003o`000140000P0003
o`0001@000B108615P000h40000F0003P@0000X000?o00007P000h40000Q0003o`00008000>10000
:0000h40000:0003CD`000X000?o00004@00020000?o0000500018400002PA@000>100005P000h40
000:0003o`0001h000>100008@000ol000020003P@0002P000>100002P000da=000;0003o`000100
000P0003o`0001<000>100001002PA8000>100005P000h40000:0003o`0001h000>100008P001Ol0
002102X000>100002P02C@`000?o00004000020000?o00004`000h40000600:140000h40000F0003
P@0000X000?o00007P000h40000R0005o`000840:P000h40000:009=30000ol0000@00007`000ol0
000D0003P@0000P00X4>0003P@0001H000>100002P000ol0000N0003P@00028000Go0000P@0Z0003
P@0000X000==CP002`000ol0000@00007`000ol0000D0003P@0000X00X4<0003P@0001H000>10000
2P000ol0000N0003P@00028000Go0000P@0Z0003P@0000X00Td<0003o`000100000O0003o`0001@0
00>100003002P@X000>100005P000h40000:0003o`0001h000>100008P001Ol0002102X000>10000
2P000fI>IP0;0003o`000100000O00?o50000h40000>00:120000h40000F0003P@0000X000?o0000
7P000h40000R0005o`000840:P000h40000:009V00=>00002@000ol0000@00007`000ol0000D0003
P@0001000X460003P@0001H000>100002P000ol0000N0003P@00028000Go0000P@0Z0003P@0000/0
00=>C@001`03P@03o`000100000O0003o`0001@000>100004P02P@@000>100005P000h40000:0003
o`0001h000>100008P000ol000020003P@0002P000>100002P0016I=0006P@<000?o0000400001l0
00?o000050000h40000D00:10P000h40000F0003P@0000X000?o00007P000h40000R0003o`000080
00>10000:0000h40000700>100A>IX612P000ol0000?00007`000ol0000D0003P@0001H00h4H0003
P@0000X000?o00007P000h40000R0003o`00008000>10000:00018400006P@<00Th<0003o`0000l0
000N0003o`0001D000>100006002PAL000>100002P000ol0000N0003P@00028000?o00000P000h40
000V00J12@02CP`000?o00003`0001h000?o000050000h40000H0003P@0000:150000h40000;0003
o`0001h000>100008P000ol000020003P@0002001X420003P@0000X000=2IP002`000ol0000?0000
7P000ol0000D0003P@0001P000>100000P02PA8000>100002`000ol0000N0003P@00028000?o0000
0P000h40000I00N120000h40000:0003@Th000/000?o00003`0001h000?o000050000h40000H0003
P@0000@00X4@0003P@0000/000?o00007P000h40000R0003o`00008000>100004`06P@l000>10000
2P000d9V000;0003o`0000l0000N0003o`0001@000>1000060000h40000600:13P000h40000;0003
o`0001h000>100008P000ol000020003P@0000d01X4E0003P@0000X00T8<0003o`0000l0000N00?o
50000h40000H0003P@0000P00X4<0003P@0000/000?o00007P000h40000O00Go0`000h40000700J1
6`000h40000:00=22`000ol0000?00007P000ol0000D0003P@0001P000>100002P02P@X000>10000
2`000ol0000N0003P@0001P01ol500;o00@0P@001h4Q0003P@0000X000=2Cd802`000ol0000?0000
7P000ol0000D0003P@0001P000>100003002P@P000>100002`000ol0000N0003P@0001801_l<00:1
0_l2PBP000>100002`000d9?000:0003o`0000l0000N0003o`0001@000>1000060000h40000>00:1
1P000h40000;0003o`0001h000>100002`07o``01X430003POl002P000>100002`000d9?000;0003
o`0000h0000M0003o`0001D000>1000060000h40000@00:110000h40000;0003o`0001h000>10000
1@06o``01h490004P@3oobP000>100002P000d9?000;0003o`0000h0000M0003o`0001D000>10000
60000h40000B00:10P000h40000;0003o`0001h000>1ool01Ol<00J1400018400002obH000>10000
2P02C``000?o00003P0001d000?o00005@000h40000H0003P@0001@00h4=0003o`0001T01_l=00J1
5P000h40000300;o90000h40000:0003?dl000/000?o00003P0001d000?o00005@000h40000H0003
P@0001H00X4<0003o`0001801ol50003P@0000D01X4L0003P@0000D00_lR0003P@0000X000=??`00
2`000ol0000>00007@000ol0000D0003P@0001T000>100005P001840PH4:0003o`0000`01_l<00R1
8P000h4000070003o`0001l000>100002P000cm?000;0003o`0000h0000M0003o`0001@000>10000
6@000h40000F0004P@0000:120000ol0000500Oo3@06PBT000>100002002oal000>100002P000cm?
000;0003o`0000h0000M00?o50000h40000I0003P@0001H000>100000`02P@H000?o0?l01Ol>00J1
1@000h40000W0003P@0000X00_lM0003P@0000X00Tl<0003o`0000h0000M0003o`0001@000>10000
60000h40000G0003P@0000D000>1ool01Ol>00J12`000h40000W0003P@0000`00_lK0003P@0000X0
0cl;0003o`0000h0000M0003o`0001@000>1000060000h40000G0003P@0000Ko00<0PH400P000ol0
000600N14@000h40000W0003P@0000h00_lI0003P@0000/00Sl<0003o`0000d0000L0003o`0001D0
00>1000060000h40000D00Ko2@000h7o000200J160000h40000W0003P@0001000_lG0003P@0000/0
00<oC`002`000ol0000=000070000ol0000E0003P@0001P000>100003@07o`<000>100002P001?n1
PH4N0003P@0002L000>100004P000ol0000D0003P@0000/000<oC`002`000ol0000=000070000ol0
000E0003P@0001P000>100001`06o`X000>100002P000ol0000O0003P@0002L000>100004`02oa@0
00>100002`02?``000?o00003@0001`000?o00005@000h40000H0003P@0000Oo40000h40000:0003
o`0001l000>100009`000h40000E00;o4P000h40000;008o30000ol0000=000070000ol0000E0003
P@0001D01_lG0003P@0000X000?o00007`000h40000X0003P@0001H00_lA0003P@0000X000<o8000
2`000ol0000=000070000ol0000E0003P@0000h01ol30003P@0001L000>100002P000ol0000O0003
P@0002P000>100006002o`l000>100002P0280`000?o00003@0001`000?o000050000h40000900Ko
2P000h40000G0003P@0000X000?o00007`000h40000X0003P@0001X000?o000030000h40000:0003
8B0000/000?o00003@0000`00ol300;o20001?n1oolC0003P@0000801ol@0003P@0001L000>10000
2P000ol0000O0003P@0002P000>100006`02o``000>100002P0280`000?o00003@0000d000Go0000
o`020003o`0000D000Co08614P06oaL000>100005P000h40000;0003o`0001l000>10000:0000h40
000M00;o2P000h40000:008Q3@000ol0000<00002`04o`8000Co003o1P000ol0000200:12@07o`03
084001X000>100005P000h40000;0003o`0001l000>10000:0000h40000O00;o20000h40000:0003
824Q00`000?o0000300000/000?o0?l00`001?l00?l60003o`0000@00h46o`P000>100006@000h40
000F0003P@0000/000?o00007`000h40000X0003P@0002400_l60003P@0000/000<Q80002`000ol0
000<00002`000ol0o`030004o`00o`H000?o00001ol2P@`000>100006@000h40000F0003P@0000/0
00?o00007`000h40000X0003P@0002<00_l40003P@0000/000<P8@002`000ol0000<00003002o`@0
0_l700?o2@02P@X000>100006@000h40000F0003P@0000/000?o00007`000h40000X0003P@0002D0
00Go0000P@0=00038Bl000/000?o0000300001d00_l:00:120000h40000H0003P@0001L000>10000
2`000ol0000O0003P@0002P000>100009P02o`03084000`000<Q;`002`000ol0000<00007`03o`T0
0X460003P@0001P000>100005`000h40000;0003o`0001l000>10000:0000h40000X00;o3@02;``0
00?o0000300002800_l900:110000h40000H0003P@0001L000>100002`000ol0000O0003P@0002P0
00>10000:@000h7oo`0;00038B8000/000?o0000300002@00_l900>100<0P@006@000h40000G0003
P@0000/000?o00007`000h40000X0003P@0002T000>100000_l9008_30000ol0000<00009P02o`X0
0X4J0003P@0001L000>100002`000ol0000O0003P@0002P000>10000:P001H40003o00P000<Q8P00
2`000ol0000<0000:003o`L000B1086160000h40000G0003P@0000/000?o00007`000h40000X0003
P@0002X000>100000P02o`H00R8=0003o`0000/0000[00;o1@0018400002PAH000>100005`000h40
000;0003o`0001l000>10000:0000h40000Z0003P@0000@00_l4008R3@000ol0000;0000;@02o`<0
00>100000`02PA@000>100005`000h40000;0003o`0001l000>10000:0000h40000Z0003P@0000H0
0_l2008R00<O00002P000ol0000;0000;`02o`03084000H00X4B0003P@0001L000>100002`000ol0
000O0003P@0002P000>10000:P000h40000800;o00<07bl030000ol0000;0000<@03o`P00h4?0003
P@0001L000>100002`000ol0000O0003P@0002P000>10000:P000h40000:00;o00<R00002P000ol0
000;0000=002o`T00X4=0003P@0001L000>100002`000ol0000O0003P@0002P000>10000:P000h40
000;00037ol000/000?o00002`0003H00_l900:12`000h40000G0003P@0000/000?o00007`000h40
000X0003P@0002X000>100002`027`;o2P000ol0000;0000>002o`T00X490003P@0001L000>10000
2`000ol0000O0003P@0002P000>10000:P000h40000;008O0P02o`P000?o00002`0003X00ol800:1
1`000h40000G0003P@0000/000?o00007`000h40000X0003P@0002X000>100002`027`@00_l60003
o`0000/0000m00;o2003P@@000>100005`000h40000;0003o`0001l000>10000:0000h40000Z0003
P@0001<00_l5P@03o`0000X0000o00;o2@02P@03084001T000>100002`000ol0000O0003P@0002P0
00>10000:P000h40000>00N100?o00000P000ol0000:0000@@02o`T00X4J0003P@0000/000?o0000
7`000h40000Y0003P@0002T000>100001`07P@P00_l20003o`0000X0001300?o1`03PAP000>10000
2`000ol0000O0003P@0002T000>10000:P000h40P@06PA400ol<0000AP02o`D000>100000X4F0003
P@0000/000?o00007`000h40000Y0003P@0002D01h4F00Go300004P00_l30003P@0000800X4D0003
P@0000/000?o00007`000h40000Y0003P@0001d028450003P@0000h01olA0000BP02o`03084000D0
0h4@0003P@0000`000?o00007`000h40000Y0003P@0001H01h4=0003P@0000L01olH0000C003o`P0
0X4>0003P@0000`000?o00007`000h40000Y0003P@0000l01h4D0003P@0000Oo7`0004l00_l800:1
30000h40000;0003o`00020000>10000:@000h40000800N15P08obH0001A00;o2002P@X000>10000
2`000ol0000P0003P@0002T000B100001h4F00Oo;P0005<00_l800:120000h40000;0003o`000200
00>100009@08PAH01ole0000E@03o`L00X460003P@0000/000?o000080000h40000N00N110000h40
000@00Oo?00005P00_l700>10`000h40000;0003o`00020000>100005`07P@/000>100002008od<0
001J00;o2002P@03084000`000?o000080000h40000@00N14P0018400007od/0001L00;o2002P@d0
00?o000080000h40000900N15P07oe80001N00?o1P03P@/000?o000080000h40000200N15P07oeT0
001Q00;o10000h400002P@T000?o00007@08PAH01omP0000H`02o`8000>100000P02P@L000?o0000
5P07P@<000>100004008ofL0001U00;o00>100001003P@@000?o00003`07P@X000>100002@07ofl0
001W00?o1`02P@8000?o00002007PA4000>100000P07ogH0001Z00;o1`02P@04o`0000N15P07ogd0
001/00;o1`001?n1PH4E00SoQ00006h00_l50003o`0000l01on<0000L003o`8000?o00002007oi<0
001c00?o0`07oiX0001e00CoX@000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000?l06`0007P000?o00009`000ol0001e0000F@04o`<01?l0103oo`02o`80
0_l400;o10000ol0000800Go00@0ool00_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o
0`02o`@00_l400;oC00005P000Go0000o`020003o`0000<000Co003o0`02o`<000Co003o10000ol0
00090005o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L000?o00001@000ol0
00020004o`00o`800_l30004o`00o`<00_m<0000F0000ol0o`02o`801Ol01@3o003o00P000Co003o
40001Ol0003o008000Co003o0`000ol000060003o`0000h000?o00001@000ol000020003o`0000P0
00Co003oD@0005P000?o000010001ol0003o0?l00P000ol000060004o`00oa0000Go0000o`020004
o`00o`<000?o00001P000ol0000>00?o1@000ol000020003o`0000P00omB0000F0001Ol0003o00<0
0ol00`3oo`03o`P000Co003o40000ol00005o`<01?l80003o`0000h000?o00001002o`<01?l80003
o`000580001I00Co5@02o`l01Ol;0003o`0000D00_l?00Go2@000ol0000900?oD@0009800_lQ0003
o`00008000?o0000G@000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.173565, -0.0165829, \
0.00215823, 0.00388695}},
  CellTags->"AntTracker3D - Gen 0"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Last",
          ButtonData:>"AntTracker3D - Gen 59",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Movie",
          ButtonData:>{
            FrontEnd`FileName[ {
              ParentDirectory[ 
                ParentDirectory[ ]], "Movies", "AntTracker-Movies Folder"}, 
              "AntTracker-7i-Gen00.nb", CharacterEncoding -> 
              "MacintoshRoman"], None},
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[advance]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.0, Ind.1, Fit.6.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.0, Ind.1, Fit.6.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.44603 .5261 m .41861 .53422 L .40239 .51917 L p
.8 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.47374 .5179 m .44603 .5261 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.40239 .51917 m .42999 .5109 L .44603 .5261 L p
.8 g
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.42999 .5109 m .45788 .50253 L .47374 .5179 L p
.8 g
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .50173 .50961 L .48607 .49408 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.55862 .49278 m .53003 .50124 L .51456 .48554 L p
.8 g
F P
s
P
p
.002 w
.48607 .49408 m .51456 .48554 L .53003 .50124 L p
.8 g
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.58752 .48422 m .55862 .49278 L .54335 .47691 L p
.8 g
F P
s
P
p
.002 w
.51456 .48554 m .54335 .47691 L .55862 .49278 L p
.8 g
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .015 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .015 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.54335 .47691 m .57246 .46819 L .58752 .48422 L p
.8 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .03 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .03 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .045 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .045 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .06 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .06 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .075 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .075 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.73675 .44005 m .70625 .44907 L .69207 .43233 L p
.8 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .09 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .09 0 r
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.69207 .43233 m .72279 .42312 L .73675 .44005 L p
.8 g
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .015 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .03 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .045 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .06 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .075 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .09 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .105 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .12 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .135 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .15 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .165 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .18 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .195 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .209 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .224 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .239 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .254 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .269 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .284 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .299 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .314 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .329 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .344 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .359 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .374 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .389 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .404 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .419 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .434 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .449 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .464 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .479 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .494 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .509 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .524 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .539 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .554 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .569 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .584 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .599 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .613 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .628 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .643 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .658 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .673 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .688 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .703 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .718 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .733 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .748 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .763 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .778 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .793 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .808 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .823 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .838 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .853 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .868 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .883 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .898 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .913 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .928 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .943 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .958 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .973 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 0 .988 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.998 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.983 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.968 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.953 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.938 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.923 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.908 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.893 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.878 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.863 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.848 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.833 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.818 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.803 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.788 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.773 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.758 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.743 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.728 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.713 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.698 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.683 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.668 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.653 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.638 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.623 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.608 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.594 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.579 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.564 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.549 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.534 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.519 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.504 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.489 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.474 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.459 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.444 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.429 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.414 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.399 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.384 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.369 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.354 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.339 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.324 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.309 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.294 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.279 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.264 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.249 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.234 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.219 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.204 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.19 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.175 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.16 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.145 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.13 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.115 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.1 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.085 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.07 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.055 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.04 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.025 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.01 0 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .005 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .02 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .035 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .05 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .065 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .08 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .095 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .11 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .125 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .14 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .155 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .17 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .185 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .2 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .214 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .229 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .244 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .259 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .274 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .289 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .304 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .319 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .334 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .349 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .364 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .379 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .394 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .409 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .424 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .439 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .454 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .469 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .484 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .499 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .514 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .529 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .544 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .559 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .574 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .589 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .603 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .618 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .633 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .648 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .663 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .678 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .693 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .708 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .723 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .738 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .753 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .768 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .783 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .798 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .813 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .828 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .843 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .858 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .873 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .888 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .903 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .918 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .933 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .948 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .963 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .978 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 .993 1 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .993 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .978 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .963 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .948 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .933 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .918 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .903 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .888 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .873 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .858 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .843 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .828 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .813 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .798 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .783 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .768 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .753 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .738 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .723 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .708 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .693 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .678 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .663 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .648 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .633 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .618 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .603 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .589 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .574 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .559 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .544 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .529 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .514 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .499 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .484 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .469 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .454 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .439 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .424 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .409 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .394 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .379 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .364 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .349 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .334 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .319 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .304 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .289 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .274 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .259 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .244 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .229 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .214 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .2 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .185 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .17 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .155 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .14 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .125 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .11 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .095 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .08 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .065 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .05 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .035 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .02 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
0 1 .005 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.01 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.025 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.04 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.055 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.07 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.085 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.1 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.115 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.13 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.145 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.16 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.175 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.19 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.204 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.219 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.234 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.249 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.264 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.279 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.294 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.309 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.324 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.339 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.354 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.369 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.384 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.399 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.414 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.429 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.444 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.459 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.474 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.489 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.504 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.519 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.534 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.549 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.564 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.579 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.594 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.608 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.623 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.638 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.653 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.668 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.683 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.698 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.713 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.728 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.743 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.758 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.773 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.788 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.803 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.818 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.833 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.848 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.863 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.878 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.893 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.908 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.923 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.938 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.953 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.968 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.983 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
.998 1 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .988 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .973 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .958 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .943 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .928 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .913 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .898 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .883 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .868 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .853 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .838 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .823 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .808 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .793 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .778 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .763 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .748 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .733 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .718 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .703 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .688 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .673 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .658 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .643 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .628 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .613 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .599 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .584 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .569 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .554 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .539 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .524 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .509 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .494 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .479 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .464 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .449 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .434 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .419 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .404 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .389 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .374 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .359 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .344 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .329 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .314 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .299 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .284 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .269 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .254 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .239 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .224 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .209 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .195 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .18 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .165 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .15 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .135 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .12 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .105 0 r
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .015 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .03 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .045 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .06 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .075 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .09 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .105 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .12 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .135 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .15 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .165 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .18 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .195 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .209 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .224 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .239 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .254 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .269 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .284 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .299 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .314 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .329 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .344 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .359 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .374 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .389 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .404 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .419 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .434 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .449 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .464 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .479 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .494 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .509 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .524 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .539 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .554 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .569 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .584 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .599 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .613 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .628 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .643 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .658 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .673 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .688 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .703 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .718 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .733 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .748 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .763 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .778 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .793 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .808 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .823 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .838 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .853 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .868 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .883 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .898 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .913 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .928 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .943 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .958 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .973 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 0 .988 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.998 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.983 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.968 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.953 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.938 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.923 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.908 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.893 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.878 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.863 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.848 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.833 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.818 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.803 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.788 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.773 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.758 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.743 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.728 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.713 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.698 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.683 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.668 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.653 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.638 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.623 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.608 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.594 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.579 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.564 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.549 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.534 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.519 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.504 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.489 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.474 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.459 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.444 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.429 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.414 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.399 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.384 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.369 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.354 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.339 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.324 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.309 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.294 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.279 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.264 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.249 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.234 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.219 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.204 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.19 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.175 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.16 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.145 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.13 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.115 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.1 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.085 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.07 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.055 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.04 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.025 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.01 0 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .005 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .02 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .035 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .05 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .065 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .08 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .095 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .11 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .125 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .14 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .155 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .17 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .185 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .2 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .214 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .229 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .244 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .259 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .274 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .289 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .304 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .319 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .334 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .349 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .364 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .379 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .394 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .409 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .424 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .439 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .454 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .469 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .484 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .499 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .514 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .529 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .544 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .559 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .574 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .589 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .603 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .618 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .633 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .648 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .663 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .678 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .693 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .708 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .723 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .738 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .753 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .768 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .783 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .798 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .813 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .828 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .843 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .858 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .873 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .888 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .903 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .918 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .933 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .948 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .963 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .978 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 .993 1 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .993 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .978 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .963 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .948 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .933 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .918 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .903 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .888 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .873 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .858 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .843 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .828 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .813 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .798 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .783 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .768 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .753 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .738 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .723 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .708 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .693 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .678 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .663 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .648 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .633 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .618 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .603 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .589 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .574 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .559 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .544 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .529 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .514 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .499 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .484 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .469 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .454 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .439 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .424 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .409 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .394 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .379 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .364 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .349 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .334 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .319 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .304 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .289 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .274 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .259 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .244 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .229 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .214 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .2 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .185 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .17 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .155 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .14 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .125 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .11 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .095 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .08 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .065 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .05 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .035 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .02 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
0 1 .005 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.01 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.025 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.04 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.055 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.07 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.085 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.1 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.115 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.13 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.145 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.16 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.175 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.19 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.204 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.219 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.234 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.249 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.264 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.279 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.294 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.309 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.324 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.339 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.354 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.369 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.384 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.399 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.414 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.429 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.444 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.459 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.474 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.489 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.504 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.519 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.534 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.549 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.564 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.579 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.594 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.608 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.623 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.638 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.653 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.668 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.683 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.698 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.713 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.728 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.743 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.758 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.773 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.788 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.803 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.818 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.833 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.848 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.863 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.878 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.893 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.908 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.923 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.938 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.953 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.968 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.983 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
.998 1 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .988 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .973 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .958 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .943 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .928 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .913 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .898 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .883 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .868 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .853 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .838 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .823 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .808 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .793 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .778 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .763 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .748 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .733 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .718 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .703 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .688 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .673 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .658 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .643 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .628 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .613 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .599 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .584 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .569 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .554 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .539 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .524 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .509 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .494 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .479 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .464 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .449 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .434 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .419 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .404 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .389 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .374 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .359 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .344 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .329 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .314 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .299 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .284 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .269 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .254 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .239 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .224 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .209 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .195 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .18 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .165 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .15 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .135 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .12 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .105 0 r
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o;k/3o`b100?o^k/01;/01?l00?l50003o`0002X0
000O0003o`0000T000Sobk_;^l^ko`b102Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^kbk_o00b100?oPH400ol05[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/3o`UK00gobk_;^l^kbk_;^l^k00;o2h400on1P@0:P@0_ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10ol^^`?o1e/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0]^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2e/00on1P@06P@?o00V1ok_;^l^kbol0
0P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omKF`04F`?o
0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42obbk1?l2F`03oe]K00YK
00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^kbk_;^l^k
bk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?^l^kbk_;
^l^kbk_;^l_o00J11?l2P@0[ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`MK00?oFe/02U/00on1o`02o`V100So^l^kbk_;o`8000?o00000P000ol0000500?o0`03oaT0
000U0003o`0000T000?o^k/00k/00on1P@03o`R100?o^k/09;/2o`]K00?o^k/07k/3o`:100?o^k/0
2k/00omKF`03F`;o4[/00on1P@03o`N100?o^k/08k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk
00Co003o1@000ol000050003o`0000D000?o00005P0002H000?o00002@001_nkbk_;^`;o3840:?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol6P@0@ol^kbk_;^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0_l;P@0Rok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0U/00omKF`0:F`03oe]K00AK
1?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol000050003o`0000D000?o00005P0002L0
00?o00002@000onk^`04^`03oh6100Z100?o^k/09;/00omKF`0:F`03ok^k01Jk1?l:P@03ok^k00^k
00?o^k/05k/00on1P@0:P@03ok^k01^k0ol6F`03oe]K00YK00?oFe/00ol7F`03oh6100^100?o^k/0
1;/01?l00?l40003o`0000@000?o00000P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`:100?oPH402X40:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b1
01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o2U/00omKF`08F`04oe_oo`]K00?oPH401X43o`09
POnkbk_;^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1
P@0:P@03ok^k02Bk00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k01>k
0ol00e_oF`0;F`03oe]K00AK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003
o`3o00@00_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2X400on1
P@08P@0[oh7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol5F`03oe]K00YK00?oFe/00ol01k_;^l^kbol03E/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000S0000;0000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k02Bk0_lI^`03oh6100V100?oPH401843o`>100?o^k/09K/00on1P@03o`J100?o^k/03;/3o`UK
00?oFe/025/01?mKool:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D000?o00008P0002d0
00?o00002@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N102Kobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X402oo;^l^kbk_;^l^k00?o35/00omKF`04F`Co013;^l^k
bk_;^l^kbk_;^l_o1U/4o`9K00?oPH402X402?o;^l^kbk_o0P000ol000030003o`000240000^0003
o`0000T000?o^k/01;/00on1P@09P@03ok^k03nk00?oPH402H42o`^100?o^k/07[/4o`9K00?oPH40
2X400onk^`04^`?o0U/00omKF`0;F`03oe]K00?o5;/00omKF`03o`MK00?oPH402X400onk^`04^`04
o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH40
2X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@03ol^k00?o1U/00omK
F`0;F`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l;F`03oh6100F10ol02X7o^l^kbk_;^ol20003
o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42od2k00?oPH400ol6P@03oh6100Z1
00?o^k/05k/2o`]K00?oPH4028401?n1ool:F`03oe]K00IK0olE^`Co0U/00omKF`0:F`03oh6100>1
0_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@11ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol035/00on1P@04P@?o0X400omK
F`0:F`03oe]K00=K0_l05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`MK00?oFe/02U/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X400omKF`0:F`03oe_o00;o
4k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol000090006
ok_;^l^k0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038400on1P@03o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`aK0_l:P@03oe]K00QK01KoFoo;^l^kbk_;^l^kbk_;^l^kbk_;0ol2F`03oe]K00YK00?oFe/0
15/4o`03bk_o00f100Oo^l^kbk_o008000?o00000`000ol0000M0000=@000ol000090003ok^k00>k
00?oPH402X400onk^`0m^`03oh6100R100CoPOoo9K/00omKF`04F`?o0[/00on1P@0:P@03oe]K00AK
0ol3F`03ok^k00fk0ol6F`03oe]K00YK00?oFe/00ol7^`03oh6100^100?o^k/00k/01?l00?l40003
o`0001d0000f0003o`0000T000Oo^l^kbk_o00b1037obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co00c;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100?oFe/00ol7F`0=ol^kbk_;
^l^kbk_;^`02o`YK00?oFe/025/04?mKoonkbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l0
0002oah0000g0003o`0000T000?o^k/00k/00on1P@0:P@;o:k/3o`AK00?o^k/02K/00on1P@03o`N1
00?o^k/09;/2o`Zk00?oPH4028401?n1ool;F`03ok^k00Vk00?oFe/02U/00omKF`04F`?o4;/00on1
P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0d
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01;_;
^ol<F`0=ol^kbk_;^l^kbk_;o`0<F`03oe]K00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;
^l^kbol00P000ol000020003o`0001/0000j0003o`0000T000?o^k/00[/00on1P@03o`R100?o^k/0
8[/2o`aK00?o^k/02K/00on1P@0:P@03ok^k032k00?oPH400ol7^`03oe]K00YK00?o^k/02K/00omK
F`08F`04oe_ooaNk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o00002@001Oo;
^l^k00;o38409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0<F`0=ol^kbk_;
^l^kbk_;o`0<P@0cok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;o00bkbk_;^l^kbk_;^ol6F`?o0U/03_nkbk_;^l^kbk_;^l_o1U/3o`9K01_obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038402_nkbk_;^l_o0?l50003o`0001T0000l0003o`0000T000?o^k/0
0k/00on1P@0:P@03ok^k02>k00?oFe/02U/00onk^`09^`03oh6100Z100?o^k/0?K/00omKF`03o`IK
00?o^k/02[/00omKF`03o`IK00?o^k/05k/00on1P@08P@03oh7o00Fk00Co003o10000ol0000I0000
?@000ol000090006ol^kbk_;0_l;P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o00IK0ol2F`0>ok_;^l^kbk_;^l^kbol6P@?o0h40@?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^kbk_;^l^kbk_;00;o
2U/06_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X44o`:100Sobk_;^l^ko`8000Co00000_lJ0000
?P000ol000090003ok^k00Bk00?oPH401843o`:100?o^k/08k/00omKF`03o`IK00?o^k/02[/00on1
P@03o`N100?o^k/0?;/00omKF`09F`03ok^k00Zk00?oFe/02E/00onk^`0G^`03oh6100?o1h400onk
^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;^l^kbk_o0X43o`J102Ko^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2U/03Onkbk_;^l^kbk_;^l/00_l;P@10ok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`]K
00kobk_;^l^kbk_;^l^ko`]K01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;^l^kbol0
0P000ol000030003o`0001H0001000;o2P000onk^`04^`;o2X400onk^`0S^`03oe]K00UK00?o^k/0
2[/00on1P@0:P@03ok^k03bk00?oFe/01e/00omKo`0<^`03oe]K00MK00?oFol06;/00on1P@0:P@03
ok^k00Bk00Co003o10000ol0000F0000@P000ol0000800;o00Jkbk_;^ol;P@0Wok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00]K00ko^l^kbk_;^l^kbk_;o`b103oo^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01U/3o`9K
00ko^l^kbk_;^l^kbk_;o`IK0ol3F`0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00?;oh402h402?nk
bk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/00k/00on1P@09P@03ok^k02>k
00?oFe/02E/00onk^`0:^`03oh6100B10ol2P@03ok^k03bk00?oFe/00ol6F`03ok^k00Zk00?oFe/0
0ol7F`03ok^k00nk0ol01Aoo^k_o00Z100?oPOl01K/01?l00?l50003o`0001@000140003o`0000T0
00Oo^l^kbk_o00^10_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01U/3o`0@
bk_;^l^kbk_;^l^kbk_;o`:10ol6P@0mol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`YK00go^l^kbk_;^l^kbk_;00;o2e/04Onkbk_;^l^k
bk_;^l^kbk_o00DO00?o^ol01X44o`:100Sobk_;^l^ko`8000Co00000_lF0000A@000ol000090003
ok^k00>k00?oPH401843o`>100?o^k/08[/00omKF`03oa>k0_l:P@03ok^k03Jk0ol2F`03oe]K00YK
00?o^k/02[/00omKF`0:F`03ok^k00Fk0_l5^`0:oelOGamO7onko`:10ol7P@03ok^k00Bk00Co003o
10000ol0000C0000AP000ol000090007ok_;^l^ko`02P@?o1h409?o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`?o01S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol;P@0eol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol6F`03oe]K00YK00ko^l^k
bk_;^l^kbk_;o`aK00Co^l^k0ol02QOo^l^kbk_;oal3o`03bk_o00?o2h402_o;^l^kbk_o0?l300?o
500004L000?o00002@000onk^`03^`;o2h400onk^`0M^`?o0e/00onk^`0E^`03oh6100V100?o^k/0
;[/3o`YK00?oFe/025/00omKo`0<^`03oe]K00AK0ol5^`07oelOGamOo`06^`03ok^k00?o0X400on1
P@0;P@03ok^k00>k00?o00000ol20003o`000180001800;o2P002?nkbk_;^l_o2h407?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`MK01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00^10_l0:k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol2F`03oe]K00UK00?oFe/0
15/3o`0A^l^kbk_;^l^kbk_;^l^kbol00U/3o`0E^l_ook_;^l_o7aLO5alGok_;^l^k00?o1X400on1
P@0;P@06ol^kbk_;0_l00`3o00020003o`000180001:0003o`0000P00_l5^`03oh6100V100?o^k/0
5;/4o`]K00?o^k/05K/00on1P@04P@?o0h400onk^`0U^`?o1U/00omKF`09F`03oe]K00?o5;/2o`:k
0ol00aoo^`04^`03oaoo00;o0k/4o`Z100?oPH401844o`Vk00?o0?l00`000ol0000B0000B`000ol0
00090007ol^kbk_;o`06P@?o0X404oo;^l^kbk_;^l^kbk_;^l^kbk/00ol3F`03oe]K00YK01Wobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:10ol7P@0Sok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/01?l:F`03oe]K00MK02koFooo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o7elOGaoobk_;
^l_obk_;0ol2P@03oh6100Z100?oPH400ol02;_;^l^kbk_;0ol50004o`00oa@0001<0003o`0000T0
00?o^k/00k/00on1P@03o`J100?o^k/03;/3o`MK00?oFe/02U/00onk^`0E^`;o2h400onk^`0L^`?o
0U/00omKF`0:F`04oe]KF`Go6;/2o`Fk00Oo7elOGaoo00Fk0ol6P@03oh6100Z10_l7^`Co2@001?l0
0?lC0000C@000ol000090006ol^kbk_;0_l:P@0<ol^kbk_;^l^kbk_;0_l;F`03oe]K00AK0ol07<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<P@0Kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o
1U/00omKF`0:F`?o01[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o00POok_;^l^kb`?o00C;^l^k
1?l:P@03oh6100B10ol02<^kbk_;^l^k0ol>0003o`3o01<0001>0003o`0000T000?o^k/00k/00on1
P@09P@03ok^k00Zk00?oFe/02E/00omKF`03oank00?oPH402X400onk^`0E^`;o2U/00omKF`04F`?o
7[/01omO7elOGol01k/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;
^l^kbol02h403_o;^l^kbk_;^l^kbk_o2e/2o`0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o1X43o`:101[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`]K00?oFe/00ol06l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02o`06^l^kbk_o1Al00onko`04o`R100?oPH402X42o`07bk_;^l^k
b`03oaH00_lC0000D@000ol000080003ok^k00>k00?oPH402H42o`^k00?oFe/015/3obNk00?oPH40
0ol6P@03ok^k01Jk00?oFe/02E/2oa^k0ol00aoo^`05^`?o00Bkoooo0X400on1P@09P@03oh6100B1
0ol7^`Co6003oa<0001B0003o`0000P00_l01K_;^l_o00J10ol3P@0=ok_;^l^kbk_;^l^ko`02F`?o
02_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X402oo;^l^kbk_;
^l^k00;o00g;^l^kbk_;^l^kbk_o00IK0ol0:/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;oamO
7elOol^kbk_;^`?o1X400on1P@09P@03oh6100?o00Nkbk_;^l^k00?o6@03oaH0001C0003o`0000T0
00?o^k/00[/00on1P@03o`N100?o^k/02K/2objk00?oPH402X400onk^`04^`?o0U/00onk^`0:^`03
oe]K00?o6K/3o`Fk00?o7al00al00onko`03o`Z100?oPH401h401?n1ool6^`Co6004oaT0001D0003
o`0000T000Go^l^kb`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00b100?obk/00ol6F`0=ol^kbk_;^l^kbk_;^`02o`0Ibk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1P@09P@03oh6100B1
0ol01l^kbk_;^l/00olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V100?o^k/0>K/00on1
P@08P@04oh7oo`YK00?o^k/09K/00olO7`037`03ok^k00>k0ol6P@03oh6100V100?oPH400ol6^`Co
6004ob00001F0003o`0000T000Oo^l^kbk_o00^10_l0>l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol3F`03oe]K00UK023obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo7`05o`Z100?oPH401h402_n1ooo;^l^k
bk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03oh6100?o1e/00omK
F`09F`03ok^k01Vk0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T0
00?o000020001onkbk_;^ol00X43o`N103Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l;F`03oe]K00AK0ol07[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`HO00Gobk_;^`03o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X0
00?o000020000onk^`03^`;o2h400onk^`0`^`Go0e/00omKF`0:F`03oe]K00?o6K/3o`Fk00?o7ol0
0_l3^`?o2X400on1P@07P@04oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h40<?o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o2E/00omKF`0:F`;o
01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1
PH45o`06bk_;^l^k0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/04[/4oaNk
00?oFe/025/00omKF`04F`?o0h400onk^`0G^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk
1?lH00?o=P0005d000?o00002@001oo;^l^kbol01X43o`:100oobk_;^l^kbk_;^l^kbk/01Ol4F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0:F`03oe]K00?o1h407?o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;ob<3o`03bk_;00Co2X400on1P@04P@?o00Rkbk_;^l^kb`?o6004ocT0001N0003o`0000T0
00?o^k/00k/00on1P@03o`J100?o^k/02K/2o`YK00?o^k/02;/2o`^k00?oFe/01U/01?mKool;P@03
ok^k01Nk00Co^k^k0ol2P@03oh6100Z100?oPH400ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o
2X403Oo;^l^kbk_;^l^kbol02e/01oo;^l^kbk/00ol2F`0=ol^kbk_;^l^kbk_;o`02F`Go00Bkbk_o
38406_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co
@000064000?o000020000onk^`03^`03oh6100V100?o^k/02K/00omKF`09F`03ok^k00?o1U/00onk
^`09^`;o2K/00on1P@0:P@03ok^k01:k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P0
00Oobk_;^l_o00^10_l02k_;^l^kbk_;^l_o00]K0_l:F`0Hol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`:1013o^l^kbk_;^l^kbk_;^l^k1Ol3P@03oh6100V100?oPH400ol01l^kbk_;^l/00olH00Co
A`0006<000?o00002002o`Bk00?oPH401843o`>100?o^k/02;/00omKF`04F`?o0U/00omKF`09F`03
ok^k01Bk00?oPH400ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T0
00Ko^l^kbol2P@?o1h403?nkbk_;^l^kbk_;o`9K0ol6F`03oe]K00UK01Oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`02o`Z100Oo^l^kbk_;00?o0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0
001U0003o`0000T000?o^k/00[/2o`^100?o^k/02;/2o`YK00?oFe/015/3oaVk00?oPH402H400onk
^`03o`J100?oPH402H400on1P@03o`Fk1?lG00CoDP0006H000?o00002@001onkbk_;^ol02h403Onk
bk_;^l^kbk_;^ol02U/00omKF`03o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2h42o`Z1
00?oPH401h402?n1ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k00?oPH402H400onk^`09^`03
oe]K00QK0_lQ^`03oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0001Y0003o`0000P0
00Oo^l^kbk_o00J10ol2P@0=ok_;^l^kbk_;^l^ko`02F`Go02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?oG@0006X000?o0000
20000onk^`03^`03oh6100?o1X400onk^`09^`;o:[/4o`Z100?oPH401843o`Nk0olH00CoH00006/0
00?o00002002o`04bk_;^`;o2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k1Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T0
00?o^k/00[/00on1P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T0
00Kobk_;^ol;P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03
oh6100V100?oPH401Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03
ok^k02>k0ol6P@03oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL0
1?mb0000L@000ol000080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o
6003ogH0001b0003o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402H42o`06^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o
0X400on1P@08P@03oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onk
bk_;^l^kbk_;^l^kb`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o0000
2@000onk^`02^`;o2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007
ok_;^l^ko`09P@07ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P0
00?o000020000onk^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003
o`0000P000Oo^l^kbk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol0
00080003ok^k00>k00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P0
00Ko^l^kbk/2o`V100?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH40
28400on1P@05o`Jk0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?o
W@0007h00_l:0003ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh40
0ol01[_;^l^kb`Co5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003
o`0000P000Oobk_;^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o0000
1`03oaL00onb0000Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT000280003
o`0000<000?o00003004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0
o`0400Coa`0008`00_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0002B0003o`0002L000?o0000WP0007<0
1?l300Co00@0ool00_l200;o1002o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003
o`0000L00ol400Go0P03o`<00_l400;o1002ogD0001b0005o`000?l00P000ol000030004o`00o`<0
0_l30004o`00o`@000?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o000010000ol0
00070003o`0000D000?o00000P001?l00?l200;o0`001?l00?l300;oM@00078000?o0?l00_l200Go
00D0o`00o`080004o`00oa0000Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D0
00?o00000P000ol000080004o`00ogX0001b0003o`0000@000Oo0000o`3o008000?o00001P001?l0
0?l@0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0000800?o
N`00078000Go0000o`0300?o00<0ool00ol80004o`00oa0000?o00001Ol300Co20000ol0000>0003
o`0000@00_l300Co20000ol0001k0000L`04oaD00_l?00Go2`000ol0000500;o3`05o`T000?o0000
2@03ogX0002/00;o8@000ol000020003o`0008H0003o05h00000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 0"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Last",
          ButtonData:>"AntTracker2D - Gen 59",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 4", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.362459 1.744509 0.003893 0.971811 [
[(Gen.4, Ind.1, Fit.7.)] .5 1 0 -1.5 Msboxa
[(5)] .22211 .10027 .8368 1 Msboxa
[(10)] .37126 .06795 .79278 1 Msboxa
[(15)] .52437 .03478 .74877 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .2882 .02373 .79718 1 Msboxa
P
[(5)] .71512 .06916 -1 .37823 Msboxa
[(10)] .7915 .12812 -1 .36695 Msboxa
[(15)] .86437 .18437 -1 .35633 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88635 .10137 -1 .36805 Msboxa
P
[(0)] .098 .15283 1 -0.38562 Msboxa
[(10)] .0818 .29752 1 -0.36307 Msboxa
[(20)] .06421 .45458 1 -0.3385 Msboxa
[(30)] .04506 .62567 1 -0.31166 Msboxa
[(40)] .02414 .81276 1 -0.2822 Msboxa
[(t)] -0.03877 .47162 1 -0.33889 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.4, Ind.1, Fit.7.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11988 .1347 m
.63097 .0243 L
s
P
p
.002 w
.2361 .10959 m
.2431 .11425 L
s
P
[(5)] .22211 .10027 .8368 1 Mshowa
p
.002 w
.38481 .07747 m
.39158 .08223 L
s
P
[(10)] .37126 .06795 .79278 1 Mshowa
p
.002 w
.53744 .0445 m
.54397 .04936 L
s
P
[(15)] .52437 .03478 .74877 1 Mshowa
p
.001 w
.26554 .10323 m
.26971 .10604 L
s
P
p
.001 w
.29512 .09684 m
.29927 .09966 L
s
P
p
.001 w
.32486 .09042 m
.32898 .09325 L
s
P
p
.001 w
.35476 .08396 m
.35885 .0868 L
s
P
p
.001 w
.41501 .07095 m
.41905 .07381 L
s
P
p
.001 w
.44538 .06439 m
.44939 .06727 L
s
P
p
.001 w
.4759 .05779 m
.47988 .06068 L
s
P
p
.001 w
.50659 .05116 m
.51054 .05407 L
s
P
p
.001 w
.20682 .11592 m
.21105 .1187 L
s
P
p
.001 w
.17769 .12221 m
.18194 .12498 L
s
P
p
.001 w
.14871 .12847 m
.15298 .13123 L
s
P
p
.001 w
.56845 .0378 m
.57234 .04073 L
s
P
p
.001 w
.59963 .03107 m
.60349 .03401 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .2882 .02373 .79718 1 Mshowa
P
P
p
p
.002 w
.63097 .0243 m
.88592 .2209 L
s
P
p
.002 w
.69472 .07346 m
.68453 .07561 L
s
P
[(5)] .71512 .06916 -1 .37823 Mshowa
p
.002 w
.77103 .13231 m
.7608 .1344 L
s
P
[(10)] .7915 .12812 -1 .36695 Mshowa
p
.002 w
.84383 .18844 m
.83356 .19048 L
s
P
[(15)] .86437 .18437 -1 .35633 Mshowa
p
.001 w
.71028 .08545 m
.70416 .08674 L
s
P
p
.001 w
.72569 .09734 m
.71956 .09861 L
s
P
p
.001 w
.74094 .1091 m
.73481 .11037 L
s
P
p
.001 w
.75606 .12076 m
.74992 .12202 L
s
P
p
.001 w
.78586 .14374 m
.77972 .14499 L
s
P
p
.001 w
.80056 .15508 m
.79441 .15632 L
s
P
p
.001 w
.81511 .1663 m
.80896 .16754 L
s
P
p
.001 w
.82954 .17742 m
.82338 .17865 L
s
P
p
.001 w
.67902 .06135 m
.6729 .06264 L
s
P
p
.001 w
.66316 .04912 m
.65705 .05042 L
s
P
p
.001 w
.64715 .03677 m
.64104 .03808 L
s
P
p
.001 w
.85798 .19936 m
.85182 .20058 L
s
P
p
.001 w
.87201 .21018 m
.86584 .21139 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88635 .10137 -1 .36805 Mshowa
P
P
p
p
.002 w
.11988 .1347 m
.04361 .82309 L
s
P
p
.002 w
.11835 .14846 m
.12852 .14628 L
s
P
[(0)] .098 .15283 1 -0.38562 Mshowa
p
.002 w
.1023 .29338 m
.11254 .2913 L
s
P
[(10)] .0818 .29752 1 -0.36307 Mshowa
p
.002 w
.08487 .45069 m
.0952 .44874 L
s
P
[(20)] .06421 .45458 1 -0.3385 Mshowa
p
.002 w
.06588 .62206 m
.07629 .62025 L
s
P
[(30)] .04506 .62567 1 -0.31166 Mshowa
p
.002 w
.04512 .80946 m
.05562 .80781 L
s
P
[(40)] .02414 .81276 1 -0.2822 Mshowa
p
.001 w
.11524 .17652 m
.12135 .17522 L
s
P
p
.001 w
.11208 .20503 m
.11821 .20375 L
s
P
p
.001 w
.10887 .23401 m
.115 .23274 L
s
P
p
.001 w
.10561 .26345 m
.11175 .26219 L
s
P
p
.001 w
.09893 .3238 m
.10508 .32257 L
s
P
p
.001 w
.0955 .35473 m
.10167 .35351 L
s
P
p
.001 w
.09202 .38618 m
.09819 .38498 L
s
P
p
.001 w
.08847 .41816 m
.09466 .41698 L
s
P
p
.001 w
.0812 .48378 m
.08741 .48263 L
s
P
p
.001 w
.07747 .51745 m
.08369 .51631 L
s
P
p
.001 w
.07368 .55171 m
.0799 .55059 L
s
P
p
.001 w
.06981 .58657 m
.07605 .58547 L
s
P
p
.001 w
.06188 .65819 m
.06814 .65712 L
s
P
p
.001 w
.05781 .69497 m
.06407 .69392 L
s
P
p
.001 w
.05366 .73243 m
.05993 .7314 L
s
P
p
.001 w
.04943 .77059 m
.05571 .76958 L
s
P
[(t)] -0.03877 .47162 1 -0.33889 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11835 .14846 m
.40208 .32862 L
s
P
p
.4 g
.002 w
.1023 .29338 m
.398 .46917 L
s
P
p
.4 g
.002 w
.08487 .45069 m
.3936 .62077 L
s
P
p
.4 g
.002 w
.06588 .62206 m
.38885 .78479 L
s
P
p
.4 g
.002 w
.04512 .80946 m
.38368 .96281 L
s
P
p
.4 g
.002 w
.19036 .17973 m
.12926 .86157 L
s
P
p
.4 g
.002 w
.27489 .23373 m
.23116 .90735 L
s
P
p
.4 g
.002 w
.35568 .28534 m
.32774 .95074 L
s
P
.002 w
.11988 .1347 m
.04361 .82309 L
s
.04361 .82309 m
.38331 .9757 L
s
.38331 .9757 m
.40247 .31523 L
s
.40247 .31523 m
.11988 .1347 L
s
.63097 .0243 m
.88592 .2209 L
s
.88592 .2209 m
.95639 .89651 L
s
.95639 .89651 m
.65597 .72755 L
s
.65597 .72755 m
.63097 .0243 L
s
.11988 .1347 m
.04361 .82309 L
s
.04361 .82309 m
.65597 .72755 L
s
.65597 .72755 m
.63097 .0243 L
s
.63097 .0243 m
.11988 .1347 L
s
p
.4 g
.51269 .29372 m
.51322 .95775 L
s
P
p
.4 g
.65347 .26625 m
.67977 .93474 L
s
P
p
.4 g
.79768 .23812 m
.85116 .91105 L
s
P
p
.4 g
.40208 .32862 m
.88733 .2345 L
s
P
p
.4 g
.398 .46917 m
.90225 .37746 L
s
P
p
.4 g
.3936 .62077 m
.91838 .53218 L
s
P
p
.4 g
.38885 .78479 m
.93591 .70018 L
s
P
p
.4 g
.38368 .96281 m
.955 .88323 L
s
P
.40247 .31523 m
.88592 .2209 L
s
.88592 .2209 m
.95639 .89651 L
s
.95639 .89651 m
.38331 .9757 L
s
.38331 .9757 m
.40247 .31523 L
s
p
.4 g
.2361 .10959 m
.51269 .29372 L
s
P
p
.4 g
.38481 .07747 m
.65347 .26625 L
s
P
p
.4 g
.53744 .0445 m
.79768 .23812 L
s
P
p
.4 g
.19036 .17973 m
.69472 .07346 L
s
P
p
.4 g
.27489 .23373 m
.77103 .13231 L
s
P
p
.4 g
.35568 .28534 m
.84383 .18844 L
s
P
P
p
.002 w
.40807 .32103 m .41579 .32596 L .40208 .32862 L p
.4 g
F P
s
P
p
.002 w
.40208 .32862 m .39434 .3237 L .40807 .32103 L p
.4 g
F P
s
P
p
.002 w
.88733 .2345 m .40208 .32862 L .11835 .14846 L p
.9 g
F P
s
P
p
.002 w
.42954 .32329 m .41579 .32596 L p
.40807 .32103 L .4 g
F P
s
P
p
.002 w
.40807 .32103 m .39434 .3237 L .38656 .31877 L p
.4 g
F P
s
P
p
.002 w
.43564 .31567 m .44332 .32062 L .42954 .32329 L p
.4 g
F P
s
P
p
.002 w
.40807 .32103 m .43564 .31567 L p
.42954 .32329 L .4 g
F P
s
P
p
.002 w
.38656 .31877 m .37875 .31381 L p
.40807 .32103 L .4 g
F P
s
P
p
.002 w
.37875 .31381 m .39253 .31111 L .40807 .32103 L p
.4 g
F P
s
P
p
.002 w
.45713 .31794 m .44332 .32062 L p
.43564 .31567 L .4 g
F P
s
P
p
.002 w
.46334 .31028 m .47097 .31526 L .45713 .31794 L p
.4 g
F P
s
P
p
.002 w
.43564 .31567 m .46334 .31028 L p
.45713 .31794 L .4 g
F P
s
P
p
.002 w
.48485 .31256 m .47097 .31526 L p
.46334 .31028 L .4 g
F P
s
P
p
.002 w
.39253 .31111 m .37875 .31381 L .37091 .30883 L p
.4 g
F P
s
P
p
.002 w
.49117 .30487 m .49876 .30987 L .48485 .31256 L p
.4 g
F P
s
P
p
.002 w
.46334 .31028 m .49117 .30487 L p
.48485 .31256 L .4 g
F P
s
P
p
.002 w
.37091 .30883 m .36303 .30382 L p
.39253 .31111 L .4 g
F P
s
P
p
.002 w
.36303 .30382 m .37685 .30111 L .39253 .31111 L p
.4 g
F P
s
P
p
.002 w
.5127 .30716 m .49876 .30987 L p
.49117 .30487 L .4 g
F P
s
P
p
.002 w
.51913 .29943 m .52668 .30445 L .5127 .30716 L p
.4 g
F P
s
P
p
.002 w
.49117 .30487 m .51913 .29943 L p
.5127 .30716 L .4 g
F P
s
P
p
.002 w
.54069 .30173 m .52668 .30445 L p
.51913 .29943 L .4 g
F P
s
P
p
.002 w
.37685 .30111 m .36303 .30382 L .35512 .2988 L p
.4 g
F P
s
P
p
.002 w
.54723 .29396 m .55474 .29901 L .54069 .30173 L p
.4 g
F P
s
P
p
.002 w
.51913 .29943 m .54723 .29396 L p
.54069 .30173 L .4 g
F P
s
P
p
.002 w
.35512 .2988 m .34717 .29375 L p
.37685 .30111 L .4 g
F P
s
P
p
.002 w
.34717 .29375 m .36103 .29101 L .37685 .30111 L p
.4 g
F P
s
P
p
.002 w
.56881 .29628 m .55474 .29901 L p
.54723 .29396 L .4 g
F P
s
P
p
.002 w
.57547 .28847 m .58293 .29354 L .56881 .29628 L p
.4 g
F P
s
P
p
.002 w
.54723 .29396 m .57547 .28847 L p
.56881 .29628 L .4 g
F P
s
P
p
.002 w
.43246 .29016 m .40459 .29565 L .38885 .2855 L p
.8 g
F P
s
P
p
.002 w
.57547 .28847 m .54723 .29396 L .53212 .2838 L p
.4 g
F P
s
P
p
.002 w
.36103 .29101 m .34717 .29375 L .33918 .28868 L p
.4 g
F P
s
P
p
.002 w
.59707 .2908 m .58293 .29354 L p
.57547 .28847 L .4 g
F P
s
P
p
.002 w
.33918 .28868 m .33116 .28359 L p
.36103 .29101 L .4 g
F P
s
P
p
.002 w
.33116 .28359 m .34507 .28082 L .36103 .29101 L p
.4 g
F P
s
P
p
.002 w
.60384 .28295 m .61125 .28805 L .59707 .2908 L p
.4 g
F P
s
P
p
.002 w
.57547 .28847 m .60384 .28295 L p
.59707 .2908 L .4 g
F P
s
P
p
.002 w
.46046 .28465 m .43246 .29016 L .41681 .27997 L p
.8 g
F P
s
P
p
.002 w
.38885 .2855 m .41681 .27997 L .43246 .29016 L p
.8 g
F P
s
P
p
.002 w
.53212 .2838 m .56045 .27826 L .57547 .28847 L p
.4 g
F P
s
P
p
.002 w
.62547 .28529 m .61125 .28805 L p
.60384 .28295 L .4 g
F P
s
P
p
.002 w
.41681 .27997 m .38885 .2855 L .37298 .27527 L p
.8 g
F P
s
P
p
.002 w
.63235 .27741 m .63972 .28253 L .62547 .28529 L p
.4 g
F P
s
P
p
.002 w
.60384 .28295 m .63235 .27741 L p
.62547 .28529 L .4 g
F P
s
P
p
.002 w
.41681 .27997 m .4449 .27441 L .46046 .28465 L p
.8 g
F P
s
P
p
.002 w
.56045 .27826 m .53212 .2838 L .51688 .27355 L p
.4 g
F P
s
P
p
.002 w
.34507 .28082 m .33116 .28359 L .32311 .27848 L p
.4 g
F P
s
P
p
.002 w
.654 .27976 m .63972 .28253 L p
.63235 .27741 L .4 g
F P
s
P
p
.002 w
.32311 .27848 m .31502 .27334 L p
.34507 .28082 L .4 g
F P
s
P
p
.002 w
.31502 .27334 m .32896 .27054 L .34507 .28082 L p
.4 g
F P
s
P
p
.002 w
.37298 .27527 m .40102 .26968 L .41681 .27997 L p
.8 g
F P
s
P
p
.002 w
.661 .27183 m .66832 .27698 L .654 .27976 L p
.4 g
F P
s
P
p
.002 w
.63235 .27741 m .661 .27183 L p
.654 .27976 L .4 g
F P
s
P
p
.002 w
.51688 .27355 m .4886 .27912 L .47313 .26882 L p
.8 g
F P
s
P
p
.002 w
.51688 .27355 m .54529 .26796 L .56045 .27826 L p
.4 g
F P
s
P
p
.002 w
.68267 .2742 m .66832 .27698 L p
.661 .27183 L .4 g
F P
s
P
p
.002 w
.68978 .26624 m .69706 .2714 L .68267 .2742 L p
.4 g
F P
s
P
p
.002 w
.661 .27183 m .68978 .26624 L p
.68267 .2742 L .4 g
F P
s
P
p
.002 w
.54529 .26796 m .51688 .27355 L .5015 .26321 L p
.8 g
F P
s
P
p
.002 w
.47313 .26882 m .5015 .26321 L .51688 .27355 L p
.8 g
F P
s
P
p
.002 w
.32896 .27054 m .31502 .27334 L .30689 .26818 L p
.4 g
F P
s
P
p
.002 w
.68978 .26624 m .661 .27183 L .64625 .26148 L p
.8 g
F P
s
P
p
.002 w
.71148 .26861 m .69706 .2714 L p
.68978 .26624 L .4 g
F P
s
P
p
.002 w
.30689 .26818 m .29872 .26299 L p
.32896 .27054 L .4 g
F P
s
P
p
.002 w
.29872 .26299 m .31271 .26017 L .32896 .27054 L p
.4 g
F P
s
P
p
.002 w
.71871 .26061 m .72594 .2658 L .71148 .26861 L p
.4 g
F P
s
P
p
.002 w
.68978 .26624 m .71871 .26061 L p
.71148 .26861 L .4 g
F P
s
P
p
.002 w
.57385 .26234 m .54529 .26796 L .53 .25757 L p
.8 g
F P
s
P
p
.002 w
.5015 .26321 m .53 .25757 L .54529 .26796 L p
.8 g
F P
s
P
p
.002 w
.71871 .26061 m .68978 .26624 L .67513 .25583 L p
.8 g
F P
s
P
p
.002 w
.64625 .26148 m .67513 .25583 L .68978 .26624 L p
.8 g
F P
s
P
p
1 .015 0 r
.01 w
.63928 .26947 m
.66804 .26386 L
s
P
p
.002 w
.74043 .26299 m .72594 .2658 L p
.71871 .26061 L .4 g
F P
s
P
p
.002 w
.53 .25757 m .5015 .26321 L .48598 .25277 L p
.4 g
F P
s
P
p
.002 w
.31271 .26017 m .29872 .26299 L .29052 .25778 L p
.4 g
F P
s
P
p
.002 w
.74778 .25495 m .75496 .26017 L .74043 .26299 L p
.4 g
F P
s
P
p
.002 w
.71871 .26061 m .74778 .25495 L p
.74043 .26299 L .4 g
F P
s
P
p
.002 w
.53 .25757 m .55865 .2519 L .57385 .26234 L p
.8 g
F P
s
P
p
.002 w
.74778 .25495 m .71871 .26061 L .70416 .25015 L p
.8 g
F P
s
P
p
.002 w
.67513 .25583 m .70416 .25015 L .71871 .26061 L p
.8 g
F P
s
P
p
1 .03 0 r
.01 w
.6681 .26523 m
.69702 .25959 L
s
P
p
.002 w
.29052 .25778 m .28228 .25255 L p
.31271 .26017 L .4 g
F P
s
P
p
.002 w
.28228 .25255 m .29632 .24971 L .31271 .26017 L p
.4 g
F P
s
P
p
.002 w
.76953 .25735 m .75496 .26017 L p
.74778 .25495 L .4 g
F P
s
P
p
.002 w
.48598 .25277 m .51457 .24708 L .53 .25757 L p
.4 g
F P
s
P
p
.002 w
.77699 .24927 m .78413 .25452 L .76953 .25735 L p
.4 g
F P
s
P
p
.002 w
.74778 .25495 m .77699 .24927 L p
.76953 .25735 L .4 g
F P
s
P
p
.002 w
.63137 .25102 m .60254 .2567 L .58743 .2462 L p
.8 g
F P
s
P
p
1 .045 0 r
.01 w
.69709 .26096 m
.72615 .2553 L
s
P
p
.002 w
.77699 .24927 m .74778 .25495 L .73332 .24444 L p
.8 g
F P
s
P
p
.002 w
.70416 .25015 m .73332 .24444 L .74778 .25495 L p
.8 g
F P
s
P
p
.002 w
.36901 .24883 m .34079 .25452 L .32449 .244 L p
.8 g
F P
s
P
p
.002 w
.79876 .25168 m .78413 .25452 L p
.77699 .24927 L .4 g
F P
s
P
p
.002 w
.51457 .24708 m .48598 .25277 L .47031 .24224 L p
.4 g
F P
s
P
p
.002 w
.29632 .24971 m .28228 .25255 L .27401 .2473 L p
.4 g
F P
s
P
p
.002 w
.80635 .24356 m .81343 .24883 L .79876 .25168 L p
.4 g
F P
s
P
p
.002 w
.77699 .24927 m .80635 .24356 L p
.79876 .25168 L .4 g
F P
s
P
p
.002 w
.66035 .24532 m .63137 .25102 L .61636 .24048 L p
.8 g
F P
s
P
p
.002 w
.58743 .2462 m .61636 .24048 L .63137 .25102 L p
.8 g
F P
s
P
p
1 .06 0 r
.01 w
.72624 .25667 m
.75546 .25098 L
s
P
p
.002 w
.27401 .2473 m .2657 .24202 L p
.29632 .24971 L .4 g
F P
s
P
p
.002 w
.2657 .24202 m .27977 .23915 L .29632 .24971 L p
.4 g
F P
s
P
p
.002 w
.80635 .24356 m .77699 .24927 L .76263 .23871 L p
.8 g
F P
s
P
p
.002 w
.73332 .24444 m .76263 .23871 L .77699 .24927 L p
.8 g
F P
s
P
p
.002 w
.82814 .24598 m .81343 .24883 L p
.80635 .24356 L .4 g
F P
s
P
p
.002 w
.39737 .24312 m .36901 .24883 L .35279 .23827 L p
.8 g
F P
s
P
p
.002 w
.32449 .244 m .35279 .23827 L .36901 .24883 L p
.8 g
F P
s
P
p
.002 w
.47031 .24224 m .499 .2365 L .51457 .24708 L p
.4 g
F P
s
P
p
.002 w
.83585 .23782 m .84288 .24312 L .82814 .24598 L p
.4 g
F P
s
P
p
.002 w
.80635 .24356 m .83585 .23782 L p
.82814 .24598 L .4 g
F P
s
P
p
.002 w
.68947 .23959 m .66035 .24532 L .64543 .23472 L p
.8 g
F P
s
P
p
.002 w
.61636 .24048 m .64543 .23472 L .66035 .24532 L p
.8 g
F P
s
P
p
.002 w
.76263 .23871 m .79209 .23295 L .80635 .24356 L p
.8 g
F P
s
P
p
1 .075 0 r
.01 w
.75555 .25236 m
.78493 .24664 L
s
P
p
.002 w
.85766 .24025 m .84288 .24312 L p
.83585 .23782 L .4 g
F P
s
P
p
.002 w
.35279 .23827 m .38124 .2325 L .39737 .24312 L p
.8 g
F P
s
P
p
.002 w
.499 .2365 m .47031 .24224 L .45451 .23161 L p
.4 g
F P
s
P
p
.002 w
.27977 .23915 m .2657 .24202 L .25734 .23672 L p
.4 g
F P
s
P
p
1 .211 0 r
.01 w
.71242 .25997 m
.72706 .27047 L
s
P
p
1 .226 0 r
.01 w
.72714 .27186 m
.72714 .27186 L
s
P
p
.002 w
.8655 .23206 m .87248 .23738 L .85766 .24025 L p
.4 g
F P
s
P
p
.002 w
.83585 .23782 m .8655 .23206 L p
.85766 .24025 L .4 g
F P
s
P
p
.002 w
.71873 .23383 m .68947 .23959 L .67465 .22894 L p
.8 g
F P
s
P
p
.002 w
.64543 .23472 m .67465 .22894 L .68947 .23959 L p
.8 g
F P
s
P
p
1 .241 0 r
.01 w
.72722 .27324 m
.72722 .27324 L
s
P
p
.002 w
.25734 .23672 m .24895 .23139 L p
.27977 .23915 L .4 g
F P
s
P
p
.002 w
.24895 .23139 m .26307 .22849 L .27977 .23915 L p
.4 g
F P
s
P
p
.002 w
.79209 .23295 m .76263 .23871 L .74814 .22805 L p
.8 g
F P
s
P
p
1 .256 0 r
.01 w
.7273 .27463 m
.7273 .27463 L
s
P
p
1 .271 0 r
.01 w
.72739 .27602 m
.72739 .27602 L
s
P
p
.002 w
.88733 .2345 m .87248 .23738 L p
.8655 .23206 L .4 g
F P
s
P
p
1 .286 0 r
.01 w
.72747 .27741 m
.72747 .27741 L
s
P
p
1 .09 0 r
.01 w
.78504 .24802 m
.81457 .24228 L
s
P
p
.002 w
.45451 .23161 m .48329 .22581 L .499 .2365 L p
.4 g
F P
s
P
p
1 .301 0 r
.01 w
.72755 .2788 m
.72755 .2788 L
s
P
p
1 .316 0 r
.01 w
.72763 .28019 m
.72763 .28019 L
s
P
p
.002 w
.8655 .23206 m .88038 .22916 L .88733 .2345 L p
.4 g
F P
s
P
p
.002 w
.11835 .14846 m .63147 .03823 L .88733 .2345 L p
.9 g
F P
s
P
p
1 .331 0 r
.01 w
.72772 .28158 m
.72772 .28158 L
s
P
p
.002 w
.67465 .22894 m .70401 .22313 L .71873 .23383 L p
.8 g
F P
s
P
p
1 .346 0 r
.01 w
.7278 .28298 m
.7278 .28298 L
s
P
p
.002 w
.74814 .22805 m .77769 .22223 L .79209 .23295 L p
.8 g
F P
s
P
p
.002 w
.40983 .22671 m .38124 .2325 L .36496 .22178 L p
.8 g
F P
s
P
p
1 .361 0 r
.01 w
.72788 .28437 m
.72788 .28437 L
s
P
p
1 .18 0 r
.01 w
.71226 .25719 m
.74167 .25146 L
s
P
p
.002 w
.88038 .22916 m .8655 .23206 L p
.85143 .22134 L .4 g
F P
s
P
p
.002 w
.48329 .22581 m .45451 .23161 L .43856 .22089 L p
.4 g
F P
s
P
p
1 .195 0 r
.01 w
.71234 .25858 m
.71234 .25858 L
s
P
p
.002 w
.26307 .22849 m .24895 .23139 L .24053 .22604 L p
.4 g
F P
s
P
p
1 .376 0 r
.01 w
.72797 .28577 m
.72797 .28577 L
s
P
p
1 .391 0 r
.01 w
.72805 .28717 m
.72805 .28717 L
s
P
p
1 .105 0 r
.01 w
.81469 .24366 m
.81469 .24366 L
s
P
p
1 .406 0 r
.01 w
.72813 .28857 m
.72813 .28857 L
s
P
p
1 .12 0 r
.01 w
.80049 .23436 m
.8148 .24504 L
s
P
p
.002 w
.87339 .2238 m .88038 .22916 L p
.85143 .22134 L .4 g
F P
s
P
p
.002 w
.70401 .22313 m .67465 .22894 L .65969 .21819 L p
.8 g
F P
s
P
p
1 .421 0 r
.01 w
.72821 .28996 m
.72821 .28996 L
s
P
p
.002 w
.24053 .22604 m .23206 .22066 L p
.26307 .22849 L .4 g
F P
s
P
p
.002 w
.23206 .22066 m .24622 .21774 L .26307 .22849 L p
.4 g
F P
s
P
p
.002 w
.77769 .22223 m .74814 .22805 L .73351 .21729 L p
.8 g
F P
s
P
p
1 .436 0 r
.01 w
.7283 .29136 m
.7283 .29136 L
s
P
p
1 .165 0 r
.01 w
.74158 .25008 m
.77113 .24431 L
s
P
p
1 .451 0 r
.01 w
.72838 .29277 m
.72838 .29277 L
s
P
p
.002 w
.36496 .22178 m .39364 .21594 L .40983 .22671 L p
.8 g
F P
s
P
p
1 .466 0 r
.01 w
.72846 .29417 m
.72846 .29417 L
s
P
p
.002 w
.43856 .22089 m .46743 .21504 L .48329 .22581 L p
.4 g
F P
s
P
p
1 .481 0 r
.01 w
.72855 .29557 m
.72855 .29557 L
s
P
p
1 .496 0 r
.01 w
.72863 .29698 m
.72863 .29698 L
s
P
p
.002 w
.85143 .22134 m .86636 .21841 L .87339 .2238 L p
.4 g
F P
s
P
p
1 .511 0 r
.01 w
.72872 .29838 m
.72872 .29838 L
s
P
p
.002 w
.65969 .21819 m .68915 .21233 L .70401 .22313 L p
.8 g
F P
s
P
p
1 .526 0 r
.01 w
.7288 .29979 m
.7288 .29979 L
s
P
p
1 .15 0 r
.01 w
.77103 .24293 m
.80071 .23714 L
s
P
p
.002 w
.73351 .21729 m .76317 .21142 L .77769 .22223 L p
.8 g
F P
s
P
p
.002 w
.39364 .21594 m .36496 .22178 L .34853 .21097 L p
.8 g
F P
s
P
p
1 .541 0 r
.01 w
.72888 .3012 m
.72888 .3012 L
s
P
p
.002 w
.86636 .21841 m .85143 .22134 L p
.83724 .21052 L .4 g
F P
s
P
p
.002 w
.46743 .21504 m .43856 .22089 L .42246 .21006 L p
.4 g
F P
s
P
p
1 .556 0 r
.01 w
.72897 .30261 m
.72897 .30261 L
s
P
p
.002 w
.24622 .21774 m .23206 .22066 L .22355 .21526 L p
.4 g
F P
s
P
p
1 .571 0 r
.01 w
.72905 .30402 m
.72905 .30402 L
s
P
p
1 .586 0 r
.01 w
.72913 .30543 m
.72913 .30543 L
s
P
p
.002 w
.85931 .213 m .86636 .21841 L p
.83724 .21052 L .4 g
F P
s
P
p
.002 w
.68915 .21233 m .65969 .21819 L .64459 .20734 L p
.8 g
F P
s
P
p
1 .602 0 r
.01 w
.72922 .30684 m
.72922 .30684 L
s
P
p
.002 w
.22355 .21526 m .21501 .20984 L p
.24622 .21774 L .4 g
F P
s
P
p
.002 w
.21501 .20984 m .22922 .20689 L .24622 .21774 L p
.4 g
F P
s
P
p
1 .135 0 r
.01 w
.8006 .23575 m
.8006 .23575 L
s
P
p
.002 w
.76317 .21142 m .73351 .21729 L .71875 .20643 L p
.8 g
F P
s
P
p
1 .617 0 r
.01 w
.7293 .30825 m
.7293 .30825 L
s
P
p
1 .632 0 r
.01 w
.72939 .30967 m
.72939 .30967 L
s
P
p
.002 w
.34853 .21097 m .3773 .20507 L .39364 .21594 L p
.8 g
F P
s
P
p
1 .647 0 r
.01 w
.72947 .31108 m
.72947 .31108 L
s
P
p
.002 w
.42246 .21006 m .45143 .20416 L .46743 .21504 L p
.4 g
F P
s
P
p
1 .662 0 r
.01 w
.72955 .3125 m
.72955 .3125 L
s
P
p
1 .677 0 r
.01 w
.72964 .31392 m
.72964 .31392 L
s
P
p
.002 w
.64459 .20734 m .61519 .21323 L .59985 .20233 L p
.4 g
F P
s
P
p
.002 w
.83724 .21052 m .85222 .20757 L .85931 .213 L p
.4 g
F P
s
P
p
1 .692 0 r
.01 w
.72972 .31534 m
.72972 .31534 L
s
P
p
.002 w
.64459 .20734 m .67415 .20142 L .68915 .21233 L p
.8 g
F P
s
P
p
1 .707 0 r
.01 w
.72981 .31676 m
.72981 .31676 L
s
P
p
.002 w
.79297 .20552 m .76317 .21142 L .74851 .20051 L p
.8 g
F P
s
P
p
.002 w
.71875 .20643 m .74851 .20051 L .76317 .21142 L p
.8 g
F P
s
P
p
1 .722 0 r
.01 w
.72989 .31818 m
.72989 .31818 L
s
P
p
.002 w
.85222 .20757 m .83724 .21052 L p
.82292 .19959 L .4 g
F P
s
P
p
.002 w
.45143 .20416 m .42246 .21006 L .40621 .19914 L p
.4 g
F P
s
P
p
1 .737 0 r
.01 w
.72998 .3196 m
.72998 .3196 L
s
P
p
.002 w
.22922 .20689 m .21501 .20984 L .20642 .20438 L p
.4 g
F P
s
P
p
1 .752 0 r
.01 w
.73006 .32102 m
.73006 .32102 L
s
P
p
.002 w
.59985 .20233 m .57049 .20825 L .55492 .19731 L p
.8 g
F P
s
P
p
1 .767 0 r
.01 w
.73015 .32245 m
.73015 .32245 L
s
P
p
.002 w
.8451 .20211 m .85222 .20757 L p
.82292 .19959 L .4 g
F P
s
P
p
.002 w
.59985 .20233 m .62936 .19639 L .64459 .20734 L p
.4 g
F P
s
P
p
.002 w
.67415 .20142 m .64459 .20734 L .62936 .19639 L p
.8 g
F P
s
P
p
1 .782 0 r
.01 w
.73023 .32387 m
.73023 .32387 L
s
P
p
.002 w
.20642 .20438 m .1978 .19891 L p
.22922 .20689 L .4 g
F P
s
P
p
.002 w
.1978 .19891 m .21205 .19593 L .22922 .20689 L p
.4 g
F P
s
P
p
1 .797 0 r
.01 w
.73032 .3253 m
.73032 .3253 L
s
P
p
.002 w
.82292 .19959 m .79297 .20552 L .77841 .19456 L p
.8 g
F P
s
P
p
.002 w
.74851 .20051 m .77841 .19456 L .79297 .20552 L p
.8 g
F P
s
P
p
1 .812 0 r
.01 w
.7304 .32672 m
.7304 .32672 L
s
P
p
1 .827 0 r
.01 w
.73048 .32815 m
.73048 .32815 L
s
P
p
.002 w
.48054 .19822 m .45143 .20416 L .43527 .19318 L p
.4 g
F P
s
P
p
.002 w
.40621 .19914 m .43527 .19318 L .45143 .20416 L p
.4 g
F P
s
P
p
1 .842 0 r
.01 w
.73057 .32958 m
.73057 .32958 L
s
P
p
1 .857 0 r
.01 w
.73065 .33101 m
.73065 .33101 L
s
P
p
.002 w
.62936 .19639 m .59985 .20233 L .58438 .19134 L p
.4 g
F P
s
P
p
.002 w
.55492 .19731 m .58438 .19134 L .59985 .20233 L p
.8 g
F P
s
P
p
.002 w
.82292 .19959 m .83795 .19662 L .8451 .20211 L p
.4 g
F P
s
P
p
1 .872 0 r
.01 w
.73074 .33245 m
.73074 .33245 L
s
P
p
.002 w
.70385 .19547 m .67415 .20142 L .65901 .19042 L p
.8 g
F P
s
P
p
.002 w
.62936 .19639 m .65901 .19042 L .67415 .20142 L p
.8 g
F P
s
P
p
1 .887 0 r
.01 w
.73083 .33388 m
.73083 .33388 L
s
P
p
1 .902 0 r
.01 w
.73091 .33531 m
.73091 .33531 L
s
P
p
.002 w
.83795 .19662 m .82292 .19959 L p
.80846 .18857 L .4 g
F P
s
P
p
.002 w
.77841 .19456 m .80846 .18857 L .82292 .19959 L p
.8 g
F P
s
P
p
.002 w
.43527 .19318 m .40621 .19914 L .38982 .18811 L p
.4 g
F P
s
P
p
1 .917 0 r
.01 w
.731 .33675 m
.731 .33675 L
s
P
p
.002 w
.21205 .19593 m .1978 .19891 L .18914 .19341 L p
.4 g
F P
s
P
p
.002 w
.43527 .19318 m .46448 .18719 L .48054 .19822 L p
.4 g
F P
s
P
p
1 .932 0 r
.01 w
.73108 .33818 m
.73108 .33818 L
s
P
p
1 .947 0 r
.01 w
.73117 .33962 m
.73117 .33962 L
s
P
p
.002 w
.83077 .19111 m .83795 .19662 L p
.80846 .18857 L .4 g
F P
s
P
p
.002 w
.58438 .19134 m .61398 .18534 L .62936 .19639 L p
.4 g
F P
s
P
p
1 .962 0 r
.01 w
.73125 .34106 m
.73125 .34106 L
s
P
p
.002 w
.18914 .19341 m .18043 .18788 L p
.21205 .19593 L .4 g
F P
s
P
p
.002 w
.18043 .18788 m .19473 .18488 L .21205 .19593 L p
.4 g
F P
s
P
p
.002 w
.73371 .1895 m .70385 .19547 L .68882 .18441 L p
.8 g
F P
s
P
p
.002 w
.65901 .19042 m .68882 .18441 L .70385 .19547 L p
.8 g
F P
s
P
p
1 .977 0 r
.01 w
.73134 .3425 m
.73134 .3425 L
s
P
p
.002 w
.80846 .18857 m .77841 .19456 L .76371 .18349 L p
.8 g
F P
s
P
p
1 .992 0 r
.01 w
.73142 .34394 m
.73142 .34394 L
s
P
p
.992 1 0 r
.01 w
.73151 .34538 m
.73151 .34538 L
s
P
p
.002 w
.46448 .18719 m .43527 .19318 L .41897 .1821 L p
.4 g
F P
s
P
p
.002 w
.38982 .18811 m .41897 .1821 L .43527 .19318 L p
.4 g
F P
s
P
p
.977 1 0 r
.01 w
.73159 .34682 m
.73159 .34682 L
s
P
p
.962 1 0 r
.01 w
.73168 .34827 m
.73168 .34827 L
s
P
p
.002 w
.61398 .18534 m .58438 .19134 L .56876 .18024 L p
.4 g
F P
s
P
p
.002 w
.80846 .18857 m .82355 .18557 L .83077 .19111 L p
.4 g
F P
s
P
p
.947 1 0 r
.01 w
.73177 .34971 m
.73177 .34971 L
s
P
p
.932 1 0 r
.01 w
.73185 .35116 m
.73185 .35116 L
s
P
p
.002 w
.76371 .18349 m .73371 .1895 L .71877 .17838 L p
.8 g
F P
s
P
p
.002 w
.68882 .18441 m .71877 .17838 L .73371 .1895 L p
.8 g
F P
s
P
p
.002 w
.34417 .18302 m .31521 .18903 L .29832 .17791 L p
.8 g
F P
s
P
p
.917 1 0 r
.01 w
.73194 .35261 m
.73194 .35261 L
s
P
p
.002 w
.82355 .18557 m .80846 .18857 L p
.79387 .17745 L .4 g
F P
s
P
p
.002 w
.76371 .18349 m .79387 .17745 L .80846 .18857 L p
.8 g
F P
s
P
p
.902 1 0 r
.01 w
.73202 .35406 m
.73202 .35406 L
s
P
p
.002 w
.19473 .18488 m .18043 .18788 L .17169 .18233 L p
.4 g
F P
s
P
p
.002 w
.41897 .1821 m .44827 .17605 L .46448 .18719 L p
.4 g
F P
s
P
p
.887 1 0 r
.01 w
.73211 .35551 m
.73211 .35551 L
s
P
p
.872 1 0 r
.01 w
.7322 .35696 m
.7322 .35696 L
s
P
p
.002 w
.81629 .18001 m .82355 .18557 L p
.79387 .17745 L .4 g
F P
s
P
p
.002 w
.56876 .18024 m .59846 .17418 L .61398 .18534 L p
.4 g
F P
s
P
p
.857 1 0 r
.01 w
.73228 .35841 m
.73228 .35841 L
s
P
p
.002 w
.17169 .18233 m .1629 .17675 L p
.19473 .18488 L .4 g
F P
s
P
p
.002 w
.1629 .17675 m .17724 .17372 L .19473 .18488 L p
.4 g
F P
s
P
p
.842 1 0 r
.01 w
.73237 .35986 m
.73237 .35986 L
s
P
p
.002 w
.79387 .17745 m .76371 .18349 L .74888 .17231 L p
.8 g
F P
s
P
p
.002 w
.71877 .17838 m .74888 .17231 L .76371 .18349 L p
.8 g
F P
s
P
p
.827 1 0 r
.01 w
.73246 .36132 m
.73246 .36132 L
s
P
p
.002 w
.29832 .17791 m .32737 .17185 L .34417 .18302 L p
.8 g
F P
s
P
p
.812 1 0 r
.01 w
.73254 .36277 m
.73254 .36277 L
s
P
p
.797 1 0 r
.01 w
.73263 .36423 m
.73263 .36423 L
s
P
p
.002 w
.52334 .17512 m .49383 .18117 L .47772 .16997 L p
.8 g
F P
s
P
p
.782 1 0 r
.01 w
.73272 .36568 m
.73272 .36568 L
s
P
p
.002 w
.59846 .17418 m .56876 .18024 L .55299 .16904 L p
.4 g
F P
s
P
p
.002 w
.79387 .17745 m .80901 .17442 L .81629 .18001 L p
.4 g
F P
s
P
p
.767 1 0 r
.01 w
.7328 .36714 m
.7328 .36714 L
s
P
p
.752 1 0 r
.01 w
.73289 .3686 m
.73289 .3686 L
s
P
p
.002 w
.32737 .17185 m .29832 .17791 L .28127 .16669 L p
.8 g
F P
s
P
p
.737 1 0 r
.01 w
.73298 .37006 m
.73298 .37006 L
s
P
p
.002 w
.80901 .17442 m .79387 .17745 L p
.77914 .16622 L .4 g
F P
s
P
p
.002 w
.74888 .17231 m .77914 .16622 L .79387 .17745 L p
.8 g
F P
s
P
p
.002 w
.40251 .17091 m .37327 .17698 L .35656 .16575 L p
.4 g
F P
s
P
p
.722 1 0 r
.01 w
.73306 .37153 m
.73306 .37153 L
s
P
p
.002 w
.17724 .17372 m .1629 .17675 L .15408 .17114 L p
.4 g
F P
s
P
p
.707 1 0 r
.01 w
.73315 .37299 m
.73315 .37299 L
s
P
p
.002 w
.47772 .16997 m .50732 .16387 L .52334 .17512 L p
.8 g
F P
s
P
p
.692 1 0 r
.01 w
.73324 .37445 m
.73324 .37445 L
s
P
p
.002 w
.80169 .1688 m .80901 .17442 L p
.77914 .16622 L .4 g
F P
s
P
p
.002 w
.62831 .1681 m .59846 .17418 L .58279 .16292 L p
.4 g
F P
s
P
p
.002 w
.55299 .16904 m .58279 .16292 L .59846 .17418 L p
.4 g
F P
s
P
p
.677 1 0 r
.01 w
.73332 .37592 m
.73332 .37592 L
s
P
p
.002 w
.15408 .17114 m .14521 .16551 L p
.17724 .17372 L .4 g
F P
s
P
p
.002 w
.14521 .16551 m .15959 .16245 L .17724 .17372 L p
.4 g
F P
s
P
p
.662 1 0 r
.01 w
.73341 .37739 m
.73341 .37739 L
s
P
p
.647 1 0 r
.01 w
.7335 .37885 m
.7335 .37885 L
s
P
p
.002 w
.28127 .16669 m .31041 .16056 L .32737 .17185 L p
.8 g
F P
s
P
p
.632 1 0 r
.01 w
.73359 .38032 m
.73359 .38032 L
s
P
p
.002 w
.43191 .16481 m .40251 .17091 L .3859 .15962 L p
.4 g
F P
s
P
p
.002 w
.35656 .16575 m .3859 .15962 L .40251 .17091 L p
.4 g
F P
s
P
p
.617 1 0 r
.01 w
.73367 .38179 m
.73367 .38179 L
s
P
p
.602 1 0 r
.01 w
.73376 .38326 m
.73376 .38326 L
s
P
p
.002 w
.77914 .16622 m .79433 .16316 L .80169 .1688 L p
.4 g
F P
s
P
p
.586 1 0 r
.01 w
.73385 .38474 m
.73385 .38474 L
s
P
p
.002 w
.65832 .16198 m .62831 .1681 L .61275 .15678 L p
.4 g
F P
s
P
p
.002 w
.58279 .16292 m .61275 .15678 L .62831 .1681 L p
.4 g
F P
s
P
p
.571 1 0 r
.01 w
.73394 .38621 m
.73394 .38621 L
s
P
p
.556 1 0 r
.01 w
.73402 .38768 m
.73402 .38768 L
s
P
p
.002 w
.79433 .16316 m .77914 .16622 L p
.76427 .15488 L .4 g
F P
s
P
p
.002 w
.3859 .15962 m .35656 .16575 L .3397 .15441 L p
.4 g
F P
s
P
p
.541 1 0 r
.01 w
.73411 .38916 m
.73411 .38916 L
s
P
p
.002 w
.15959 .16245 m .14521 .16551 L .1363 .15986 L p
.4 g
F P
s
P
p
.002 w
.3859 .15962 m .4154 .15346 L .43191 .16481 L p
.4 g
F P
s
P
p
.526 1 0 r
.01 w
.7342 .39064 m
.7342 .39064 L
s
P
p
.511 1 0 r
.01 w
.73429 .39212 m
.73429 .39212 L
s
P
p
.002 w
.78694 .15749 m .79433 .16316 L p
.76427 .15488 L .4 g
F P
s
P
p
.496 1 0 r
.01 w
.73437 .3936 m
.73437 .3936 L
s
P
p
.002 w
.1363 .15986 m .12735 .15417 L p
.15959 .16245 L .4 g
F P
s
P
p
.002 w
.12735 .15417 m .14178 .15108 L .15959 .16245 L p
.4 g
F P
s
P
p
.002 w
.68848 .15583 m .65832 .16198 L .64286 .15061 L p
.4 g
F P
s
P
p
.002 w
.61275 .15678 m .64286 .15061 L .65832 .16198 L p
.4 g
F P
s
P
p
.481 1 0 r
.01 w
.73446 .39508 m
.73446 .39508 L
s
P
p
.466 1 0 r
.01 w
.73455 .39656 m
.73455 .39656 L
s
P
p
.451 1 0 r
.01 w
.73464 .39804 m
.73464 .39804 L
s
P
p
.002 w
.4154 .15346 m .3859 .15962 L .36914 .14822 L p
.4 g
F P
s
P
p
.002 w
.3397 .15441 m .36914 .14822 L .3859 .15962 L p
.4 g
F P
s
P
p
.436 1 0 r
.01 w
.73473 .39952 m
.73473 .39952 L
s
P
p
.421 1 0 r
.01 w
.73482 .40101 m
.73482 .40101 L
s
P
p
.002 w
.56698 .15156 m .53707 .15773 L .52101 .14631 L p
.8 g
F P
s
P
p
.002 w
.76427 .15488 m .77951 .1518 L .78694 .15749 L p
.4 g
F P
s
P
p
.406 1 0 r
.01 w
.7349 .4025 m
.7349 .4025 L
s
P
p
.391 1 0 r
.01 w
.73499 .40398 m
.73499 .40398 L
s
P
p
.002 w
.64286 .15061 m .67312 .1444 L .68848 .15583 L p
.4 g
F P
s
P
p
.376 1 0 r
.01 w
.73508 .40547 m
.73508 .40547 L
s
P
p
.002 w
.77951 .1518 m .76427 .15488 L p
.74927 .14344 L .4 g
F P
s
P
p
.361 1 0 r
.01 w
.73517 .40696 m
.73517 .40696 L
s
P
p
.002 w
.14178 .15108 m .12735 .15417 L .11835 .14846 L p
.4 g
F P
s
P
p
.002 w
.44504 .14727 m .4154 .15346 L .39873 .142 L p
.4 g
F P
s
P
p
.002 w
.36914 .14822 m .39873 .142 L .4154 .15346 L p
.4 g
F P
s
P
p
.346 1 0 r
.01 w
.73526 .40845 m
.73526 .40845 L
s
P
p
.331 1 0 r
.01 w
.73535 .40994 m
.73535 .40994 L
s
P
p
.002 w
.77205 .14607 m .77951 .1518 L p
.74927 .14344 L .4 g
F P
s
P
p
.002 w
.52101 .14631 m .55101 .14008 L .56698 .15156 L p
.8 g
F P
s
P
p
.316 1 0 r
.01 w
.73543 .41144 m
.73543 .41144 L
s
P
p
.002 w
.1328 .14536 m .14729 .14224 L p
.14178 .15108 L .4 g
F P
s
P
p
.002 w
.17075 .14488 m .14178 .15108 L p
.14729 .14224 L .4 g
F P
s
P
p
.002 w
.11835 .14846 m .1328 .14536 L .14178 .15108 L p
.4 g
F P
s
P
p
.002 w
.67312 .1444 m .64286 .15061 L .62725 .13912 L p
.4 g
F P
s
P
p
.301 1 0 r
.01 w
.73552 .41293 m
.73552 .41293 L
s
P
p
.286 1 0 r
.01 w
.73561 .41443 m
.73561 .41443 L
s
P
p
.002 w
.32267 .14296 m .29329 .14918 L .27601 .13768 L p
.8 g
F P
s
P
p
.271 1 0 r
.01 w
.7357 .41593 m
.7357 .41593 L
s
P
p
.256 1 0 r
.01 w
.73579 .41742 m
.73579 .41742 L
s
P
p
.002 w
.47484 .14104 m .44504 .14727 L .42847 .13575 L p
.4 g
F P
s
P
p
.002 w
.39873 .142 m .42847 .13575 L .44504 .14727 L p
.4 g
F P
s
P
p
.241 1 0 r
.01 w
.73588 .41892 m
.73588 .41892 L
s
P
p
.002 w
.74927 .14344 m .76456 .14032 L .77205 .14607 L p
.4 g
F P
s
P
p
.226 1 0 r
.01 w
.73597 .42042 m
.73597 .42042 L
s
P
p
.002 w
.16182 .13912 m .17639 .13599 L p
.17075 .14488 L .4 g
F P
s
P
p
.002 w
.19987 .13864 m .17075 .14488 L p
.17639 .13599 L .4 g
F P
s
P
p
.002 w
.14729 .14224 m .16182 .13912 L .17075 .14488 L p
.4 g
F P
s
P
p
.211 1 0 r
.01 w
.73606 .42192 m
.73606 .42192 L
s
P
p
.002 w
.62725 .13912 m .65761 .13286 L .67312 .1444 L p
.4 g
F P
s
P
p
.195 1 0 r
.01 w
.73615 .42343 m
.73615 .42343 L
s
P
p
.002 w
.76456 .14032 m .74927 .14344 L p
.73411 .13189 L .4 g
F P
s
P
p
.002 w
.35221 .13672 m .32267 .14296 L .30549 .13141 L p
.8 g
F P
s
P
p
.002 w
.27601 .13768 m .30549 .13141 L .32267 .14296 L p
.8 g
F P
s
P
p
.18 1 0 r
.01 w
.73624 .42493 m
.73624 .42493 L
s
P
p
.165 1 0 r
.01 w
.73633 .42644 m
.73633 .42644 L
s
P
p
.002 w
.50479 .13479 m .47484 .14104 L .45836 .12947 L p
.4 g
F P
s
P
p
.002 w
.42847 .13575 m .45836 .12947 L .47484 .14104 L p
.4 g
F P
s
P
p
.15 1 0 r
.01 w
.73642 .42794 m
.73642 .42794 L
s
P
p
.002 w
.75703 .13455 m .76456 .14032 L p
.73411 .13189 L .4 g
F P
s
P
p
.135 1 0 r
.01 w
.73651 .42945 m
.73651 .42945 L
s
P
p
.002 w
.65761 .13286 m .62725 .13912 L .61148 .12753 L p
.4 g
F P
s
P
p
.12 1 0 r
.01 w
.7366 .43096 m
.7366 .43096 L
s
P
p
.002 w
.19099 .13286 m .20563 .12971 L p
.19987 .13864 L .4 g
F P
s
P
p
.002 w
.22914 .13237 m .19987 .13864 L p
.20563 .12971 L .4 g
F P
s
P
p
.002 w
.17639 .13599 m .19099 .13286 L .19987 .13864 L p
.4 g
F P
s
P
p
.105 1 0 r
.01 w
.73668 .43247 m
.73668 .43247 L
s
P
p
.09 1 0 r
.01 w
.73677 .43398 m
.73677 .43398 L
s
P
p
.002 w
.30549 .13141 m .33512 .1251 L .35221 .13672 L p
.8 g
F P
s
P
p
.075 1 0 r
.01 w
.73686 .43549 m
.73686 .43549 L
s
P
p
.06 1 0 r
.01 w
.73695 .43701 m
.73695 .43701 L
s
P
p
.002 w
.45836 .12947 m .48842 .12315 L .50479 .13479 L p
.4 g
F P
s
P
p
.002 w
.73411 .13189 m .74946 .12874 L .75703 .13455 L p
.4 g
F P
s
P
p
.045 1 0 r
.01 w
.73704 .43852 m
.73704 .43852 L
s
P
p
.03 1 0 r
.01 w
.73713 .44004 m
.73713 .44004 L
s
P
p
.002 w
.61148 .12753 m .64196 .1212 L .65761 .13286 L p
.4 g
F P
s
P
p
.002 w
.22031 .12656 m .23502 .1234 L p
.22914 .13237 L .4 g
F P
s
P
p
.002 w
.25856 .12607 m .22914 .13237 L p
.23502 .1234 L .4 g
F P
s
P
p
.002 w
.20563 .12971 m .22031 .12656 L .22914 .13237 L p
.4 g
F P
s
P
p
.015 1 0 r
.01 w
.73722 .44155 m
.73722 .44155 L
s
P
p
.002 w
.74946 .12874 m .73411 .13189 L p
.71882 .12023 L .4 g
F P
s
P
p
0 1 0 r
.01 w
.73732 .44307 m
.73732 .44307 L
s
P
p
.002 w
.41174 .12413 m .3819 .13044 L .3649 .11876 L p
.8 g
F P
s
P
p
0 1 .015 r
.01 w
.73741 .44459 m
.73741 .44459 L
s
P
p
.002 w
.48842 .12315 m .45836 .12947 L .44173 .11778 L p
.4 g
F P
s
P
p
0 1 .03 r
.01 w
.7375 .44611 m
.7375 .44611 L
s
P
p
.002 w
.74186 .12291 m .74946 .12874 L p
.71882 .12023 L .4 g
F P
s
P
p
.002 w
.56516 .12218 m .53489 .1285 L .51862 .1168 L p
.8 g
F P
s
P
p
0 1 .045 r
.01 w
.73759 .44763 m
.73759 .44763 L
s
P
p
.002 w
.64196 .1212 m .61148 .12753 L .59557 .11583 L p
.4 g
F P
s
P
p
0 1 .06 r
.01 w
.73768 .44916 m
.73768 .44916 L
s
P
p
0 1 .075 r
.01 w
.73777 .45068 m
.73777 .45068 L
s
P
p
.002 w
.24978 .12023 m .26457 .11705 L p
.25856 .12607 L .4 g
F P
s
P
p
.002 w
.28814 .11974 m .25856 .12607 L p
.26457 .11705 L .4 g
F P
s
P
p
.002 w
.23502 .1234 m .24978 .12023 L .25856 .12607 L p
.4 g
F P
s
P
p
0 1 .09 r
.01 w
.73786 .45221 m
.73786 .45221 L
s
P
p
0 1 .105 r
.01 w
.73795 .45373 m
.73795 .45373 L
s
P
p
.002 w
.44173 .11778 m .41174 .12413 L .39485 .11239 L p
.8 g
F P
s
P
p
.002 w
.3649 .11876 m .39485 .11239 L .41174 .12413 L p
.8 g
F P
s
P
p
0 1 .12 r
.01 w
.73804 .45526 m
.73804 .45526 L
s
P
p
.002 w
.44173 .11778 m .47188 .11141 L .48842 .12315 L p
.4 g
F P
s
P
p
.002 w
.71882 .12023 m .73422 .11705 L .74186 .12291 L p
.4 g
F P
s
P
p
0 1 .135 r
.01 w
.73813 .45679 m
.73813 .45679 L
s
P
p
.002 w
.51862 .1168 m .54899 .11042 L .56516 .12218 L p
.8 g
F P
s
P
p
0 1 .15 r
.01 w
.73822 .45832 m
.73822 .45832 L
s
P
p
.002 w
.59557 .11583 m .62615 .10944 L .64196 .1212 L p
.4 g
F P
s
P
p
0 1 .165 r
.01 w
.73831 .45985 m
.73831 .45985 L
s
P
p
.002 w
.73422 .11705 m .71882 .12023 L p
.70337 .10845 L .4 g
F P
s
P
p
.002 w
.2794 .11386 m .29427 .11067 L p
.28814 .11974 L .4 g
F P
s
P
p
.002 w
.31787 .11337 m .28814 .11974 L p
.29427 .11067 L .4 g
F P
s
P
p
.002 w
.26457 .11705 m .2794 .11386 L .28814 .11974 L p
.4 g
F P
s
P
p
0 1 .18 r
.01 w
.7384 .46139 m
.7384 .46139 L
s
P
p
0 1 .195 r
.01 w
.73849 .46292 m
.73849 .46292 L
s
P
p
.002 w
.39485 .11239 m .42494 .10599 L .44173 .11778 L p
.8 g
F P
s
P
p
0 1 .211 r
.01 w
.73859 .46446 m
.73859 .46446 L
s
P
p
.002 w
.72654 .11116 m .73422 .11705 L p
.70337 .10845 L .4 g
F P
s
P
p
.002 w
.54899 .11042 m .51862 .1168 L .50219 .105 L p
.8 g
F P
s
P
p
0 1 .226 r
.01 w
.73868 .46599 m
.73868 .46599 L
s
P
p
.002 w
.62615 .10944 m .59557 .11583 L .57951 .10401 L p
.4 g
F P
s
P
p
0 1 .241 r
.01 w
.73877 .46753 m
.73877 .46753 L
s
P
p
0 1 .256 r
.01 w
.73886 .46907 m
.73886 .46907 L
s
P
p
0 1 .271 r
.01 w
.73895 .47061 m
.73895 .47061 L
s
P
p
.002 w
.30918 .10747 m .32413 .10426 L p
.31787 .11337 L .4 g
F P
s
P
p
.002 w
.34775 .10697 m .31787 .11337 L p
.32413 .10426 L .4 g
F P
s
P
p
.002 w
.29427 .11067 m .30918 .10747 L .31787 .11337 L p
.4 g
F P
s
P
p
0 1 .286 r
.01 w
.73904 .47215 m
.73904 .47215 L
s
P
p
0 1 .301 r
.01 w
.73913 .47369 m
.73913 .47369 L
s
P
p
.002 w
.70337 .10845 m .71883 .10524 L .72654 .11116 L p
.4 g
F P
s
P
p
0 1 .316 r
.01 w
.73923 .47524 m
.73923 .47524 L
s
P
p
.002 w
.50219 .105 m .53266 .09855 L .54899 .11042 L p
.8 g
F P
s
P
p
0 1 .331 r
.01 w
.73932 .47678 m
.73932 .47678 L
s
P
p
.002 w
.57951 .10401 m .61019 .09756 L .62615 .10944 L p
.4 g
F P
s
P
p
0 1 .346 r
.01 w
.73941 .47833 m
.73941 .47833 L
s
P
p
.002 w
.71883 .10524 m .70337 .10845 L p
.68778 .09657 L .4 g
F P
s
P
p
0 1 .361 r
.01 w
.7395 .47988 m
.7395 .47988 L
s
P
p
.002 w
.33911 .10104 m .35414 .09781 L p
.34775 .10697 L .4 g
F P
s
P
p
.002 w
.37779 .10054 m .34775 .10697 L p
.35414 .09781 L .4 g
F P
s
P
p
.002 w
.32413 .10426 m .33911 .10104 L .34775 .10697 L p
.4 g
F P
s
P
p
0 1 .376 r
.01 w
.73959 .48143 m
.73959 .48143 L
s
P
p
.002 w
.45519 .09955 m .42494 .10599 L .40799 .09407 L p
.4 g
F P
s
P
p
0 1 .391 r
.01 w
.73969 .48298 m
.73969 .48298 L
s
P
p
.002 w
.71108 .0993 m .71883 .10524 L p
.68778 .09657 L .4 g
F P
s
P
p
.002 w
.53266 .09855 m .50219 .105 L .48561 .09308 L p
.8 g
F P
s
P
p
0 1 .406 r
.01 w
.73978 .48453 m
.73978 .48453 L
s
P
p
.002 w
.61019 .09756 m .57951 .10401 L .56329 .09208 L p
.4 g
F P
s
P
p
0 1 .421 r
.01 w
.73987 .48608 m
.73987 .48608 L
s
P
p
0 1 .436 r
.01 w
.73996 .48763 m
.73996 .48763 L
s
P
p
0 1 .451 r
.01 w
.74006 .48919 m
.74006 .48919 L
s
P
p
0 1 .466 r
.01 w
.74015 .49074 m
.74015 .49074 L
s
P
p
.002 w
.3692 .09457 m .3843 .09133 L p
.37779 .10054 L .4 g
F P
s
P
p
.002 w
.40799 .09407 m .37779 .10054 L p
.3843 .09133 L .4 g
F P
s
P
p
.002 w
.35414 .09781 m .3692 .09457 L .37779 .10054 L p
.4 g
F P
s
P
p
0 1 .481 r
.01 w
.74024 .4923 m
.74024 .4923 L
s
P
p
.002 w
.40799 .09407 m .43834 .08757 L .45519 .09955 L p
.4 g
F P
s
P
p
.002 w
.68778 .09657 m .70329 .09333 L .71108 .0993 L p
.4 g
F P
s
P
p
0 1 .496 r
.01 w
.74033 .49386 m
.74033 .49386 L
s
P
p
.002 w
.48561 .09308 m .51618 .08657 L .53266 .09855 L p
.8 g
F P
s
P
p
0 1 .511 r
.01 w
.74043 .49542 m
.74043 .49542 L
s
P
p
.002 w
.64103 .09108 m .61019 .09756 L .59408 .08557 L p
.4 g
F P
s
P
p
.002 w
.56329 .09208 m .59408 .08557 L .61019 .09756 L p
.4 g
F P
s
P
p
0 1 .526 r
.01 w
.74052 .49698 m
.74052 .49698 L
s
P
p
.002 w
.70329 .09333 m .68778 .09657 L p
.67204 .08456 L .4 g
F P
s
P
p
0 1 .541 r
.01 w
.74061 .49855 m
.74061 .49855 L
s
P
p
0 1 .556 r
.01 w
.74071 .50011 m
.74071 .50011 L
s
P
p
.002 w
.39945 .08808 m .41463 .08481 L p
.40799 .09407 L .4 g
F P
s
P
p
.002 w
.43834 .08757 m .40799 .09407 L p
.41463 .08481 L .4 g
F P
s
P
p
.002 w
.3843 .09133 m .39945 .08808 L .40799 .09407 L p
.4 g
F P
s
P
p
0 1 .571 r
.01 w
.7408 .50167 m
.7408 .50167 L
s
P
p
.002 w
.69547 .08732 m .70329 .09333 L p
.67204 .08456 L .4 g
F P
s
P
p
0 1 .586 r
.01 w
.74089 .50324 m
.74089 .50324 L
s
P
p
0 1 .602 r
.01 w
.74098 .50481 m
.74098 .50481 L
s
P
p
.002 w
.67204 .08456 m .64103 .09108 L .62503 .07902 L p
.4 g
F P
s
P
p
.002 w
.59408 .08557 m .62503 .07902 L .64103 .09108 L p
.4 g
F P
s
P
p
0 1 .617 r
.01 w
.74108 .50638 m
.74108 .50638 L
s
P
p
0 1 .632 r
.01 w
.74117 .50795 m
.74117 .50795 L
s
P
p
0 1 .647 r
.01 w
.74126 .50952 m
.74126 .50952 L
s
P
p
0 1 .662 r
.01 w
.74136 .51109 m
.74136 .51109 L
s
P
p
.002 w
.42986 .08154 m .44512 .07826 L p
.43834 .08757 L .4 g
F P
s
P
p
.002 w
.46886 .08104 m .43834 .08757 L p
.44512 .07826 L .4 g
F P
s
P
p
.002 w
.41463 .08481 m .42986 .08154 L .43834 .08757 L p
.4 g
F P
s
P
p
.002 w
.67204 .08456 m .6876 .08129 L .69547 .08732 L p
.4 g
F P
s
P
p
0 1 .677 r
.01 w
.74145 .51267 m
.74145 .51267 L
s
P
p
0 1 .692 r
.01 w
.74154 .51424 m
.74154 .51424 L
s
P
p
0 1 .707 r
.01 w
.74164 .51582 m
.74164 .51582 L
s
P
p
.002 w
.6876 .08129 m .67204 .08456 L p
.65614 .07244 L .4 g
F P
s
P
p
.002 w
.62503 .07902 m .65614 .07244 L .67204 .08456 L p
.4 g
F P
s
P
p
0 1 .722 r
.01 w
.74173 .5174 m
.74173 .5174 L
s
P
p
0 1 .737 r
.01 w
.74183 .51897 m
.74183 .51897 L
s
P
p
0 1 .752 r
.01 w
.74192 .52055 m
.74192 .52055 L
s
P
p
.002 w
.6797 .07523 m .6876 .08129 L p
.65614 .07244 L .4 g
F P
s
P
p
.002 w
.46042 .07498 m .47577 .07168 L p
.46886 .08104 L .4 g
F P
s
P
p
.002 w
.49953 .07447 m .46886 .08104 L p
.47577 .07168 L .4 g
F P
s
P
p
.002 w
.44512 .07826 m .46042 .07498 L .46886 .08104 L p
.4 g
F P
s
P
p
0 1 .767 r
.01 w
.74201 .52214 m
.74201 .52214 L
s
P
p
0 1 .782 r
.01 w
.74211 .52372 m
.74211 .52372 L
s
P
p
0 1 .797 r
.01 w
.7422 .5253 m
.7422 .5253 L
s
P
p
0 1 .812 r
.01 w
.7423 .52689 m
.7423 .52689 L
s
P
p
0 1 .827 r
.01 w
.74239 .52848 m
.74239 .52848 L
s
P
p
0 1 .842 r
.01 w
.74249 .53006 m
.74249 .53006 L
s
P
p
.002 w
.65614 .07244 m .67176 .06914 L .6797 .07523 L p
.4 g
F P
s
P
p
0 1 .857 r
.01 w
.74258 .53165 m
.74258 .53165 L
s
P
p
.002 w
.49115 .06838 m .50658 .06506 L p
.49953 .07447 L .4 g
F P
s
P
p
.002 w
.53037 .06787 m .49953 .07447 L p
.50658 .06506 L .4 g
F P
s
P
p
.002 w
.47577 .07168 m .49115 .06838 L .49953 .07447 L p
.4 g
F P
s
P
p
0 1 .872 r
.01 w
.74267 .53324 m
.74267 .53324 L
s
P
p
0 1 .887 r
.01 w
.74277 .53484 m
.74277 .53484 L
s
P
p
.002 w
.67176 .06914 m .65614 .07244 L p
.64009 .0602 L .4 g
F P
s
P
p
0 1 .902 r
.01 w
.74286 .53643 m
.74286 .53643 L
s
P
p
0 1 .917 r
.01 w
.74296 .53802 m
.74296 .53802 L
s
P
p
0 1 .932 r
.01 w
.74305 .53962 m
.74305 .53962 L
s
P
p
.002 w
.66378 .06302 m .67176 .06914 L p
.64009 .0602 L .4 g
F P
s
P
p
0 1 .947 r
.01 w
.74315 .54122 m
.74315 .54122 L
s
P
p
.002 w
.52204 .06174 m .53755 .05841 L p
.53037 .06787 L .4 g
F P
s
P
p
.002 w
.56138 .06123 m .53037 .06787 L p
.53755 .05841 L .4 g
F P
s
P
p
.002 w
.50658 .06506 m .52204 .06174 L .53037 .06787 L p
.4 g
F P
s
P
p
0 1 .962 r
.01 w
.74324 .54282 m
.74324 .54282 L
s
P
p
0 1 .977 r
.01 w
.74334 .54442 m
.74334 .54442 L
s
P
p
0 1 .992 r
.01 w
.74343 .54602 m
.74343 .54602 L
s
P
p
0 .992 1 r
.01 w
.74353 .54762 m
.74353 .54762 L
s
P
p
0 .977 1 r
.01 w
.74362 .54922 m
.74362 .54922 L
s
P
p
.002 w
.64009 .0602 m .65576 .05687 L .66378 .06302 L p
.4 g
F P
s
P
p
0 .962 1 r
.01 w
.74372 .55083 m
.74372 .55083 L
s
P
p
0 .947 1 r
.01 w
.74381 .55243 m
.74381 .55243 L
s
P
p
.002 w
.5531 .05507 m .56869 .05172 L p
.56138 .06123 L .4 g
F P
s
P
p
.002 w
.59254 .05455 m .56138 .06123 L p
.56869 .05172 L .4 g
F P
s
P
p
.002 w
.53755 .05841 m .5531 .05507 L .56138 .06123 L p
.4 g
F P
s
P
p
0 .932 1 r
.01 w
.74391 .55404 m
.74391 .55404 L
s
P
p
.002 w
.65576 .05687 m .64009 .0602 L p
.62388 .04784 L .4 g
F P
s
P
p
0 .917 1 r
.01 w
.74401 .55565 m
.74401 .55565 L
s
P
p
0 .902 1 r
.01 w
.7441 .55726 m
.7441 .55726 L
s
P
p
0 .887 1 r
.01 w
.7442 .55887 m
.7442 .55887 L
s
P
p
.002 w
.6477 .05069 m .65576 .05687 L p
.62388 .04784 L .4 g
F P
s
P
p
0 .872 1 r
.01 w
.74429 .56048 m
.74429 .56048 L
s
P
p
0 .857 1 r
.01 w
.74439 .5621 m
.74439 .5621 L
s
P
p
.002 w
.58432 .04836 m .6 .04499 L p
.59254 .05455 L .4 g
F P
s
P
p
.002 w
.62388 .04784 m .59254 .05455 L p
.6 .04499 L .4 g
F P
s
P
p
.002 w
.56869 .05172 m .58432 .04836 L .59254 .05455 L p
.4 g
F P
s
P
p
0 .842 1 r
.01 w
.74449 .56371 m
.74449 .56371 L
s
P
p
0 .827 1 r
.01 w
.74458 .56533 m
.74458 .56533 L
s
P
p
0 .812 1 r
.01 w
.74468 .56695 m
.74468 .56695 L
s
P
p
0 .797 1 r
.01 w
.74477 .56857 m
.74477 .56857 L
s
P
p
.002 w
.62388 .04784 m .63961 .04448 L .6477 .05069 L p
.4 g
F P
s
P
p
0 .782 1 r
.01 w
.74487 .57019 m
.74487 .57019 L
s
P
p
0 .767 1 r
.01 w
.74497 .57181 m
.74497 .57181 L
s
P
p
0 .752 1 r
.01 w
.74506 .57344 m
.74506 .57344 L
s
P
p
.002 w
.61571 .04162 m .63147 .03823 L p
.62388 .04784 L .4 g
F P
s
P
p
.002 w
.63961 .04448 m .62388 .04784 L p
.63147 .03823 L .4 g
F P
s
P
p
.002 w
.6 .04499 m .61571 .04162 L .62388 .04784 L p
.4 g
F P
s
P
p
0 .737 1 r
.01 w
.74516 .57506 m
.74516 .57506 L
s
P
p
0 .722 1 r
.01 w
.74526 .57669 m
.74526 .57669 L
s
P
p
0 .707 1 r
.01 w
.74535 .57831 m
.74535 .57831 L
s
P
p
0 .692 1 r
.01 w
.74545 .57994 m
.74545 .57994 L
s
P
p
0 .677 1 r
.01 w
.74555 .58157 m
.74555 .58157 L
s
P
p
0 .662 1 r
.01 w
.74564 .5832 m
.74564 .5832 L
s
P
p
0 .647 1 r
.01 w
.74574 .58484 m
.74574 .58484 L
s
P
p
0 .632 1 r
.01 w
.74584 .58647 m
.74584 .58647 L
s
P
p
0 .617 1 r
.01 w
.74594 .58811 m
.74594 .58811 L
s
P
p
0 .602 1 r
.01 w
.74603 .58974 m
.74603 .58974 L
s
P
p
0 .586 1 r
.01 w
.74613 .59138 m
.74613 .59138 L
s
P
p
0 .571 1 r
.01 w
.74623 .59302 m
.74623 .59302 L
s
P
p
0 .556 1 r
.01 w
.74632 .59466 m
.74632 .59466 L
s
P
p
0 .541 1 r
.01 w
.74642 .5963 m
.74642 .5963 L
s
P
p
0 .526 1 r
.01 w
.74652 .59795 m
.74652 .59795 L
s
P
p
0 .511 1 r
.01 w
.74662 .59959 m
.74662 .59959 L
s
P
p
0 .496 1 r
.01 w
.74672 .60124 m
.74672 .60124 L
s
P
p
0 .481 1 r
.01 w
.74681 .60289 m
.74681 .60289 L
s
P
p
0 .466 1 r
.01 w
.74691 .60454 m
.74691 .60454 L
s
P
p
0 .451 1 r
.01 w
.74701 .60619 m
.74701 .60619 L
s
P
p
0 .436 1 r
.01 w
.74711 .60784 m
.74711 .60784 L
s
P
p
0 .421 1 r
.01 w
.74721 .60949 m
.74721 .60949 L
s
P
p
0 .406 1 r
.01 w
.7473 .61115 m
.7473 .61115 L
s
P
p
0 .391 1 r
.01 w
.7474 .6128 m
.7474 .6128 L
s
P
p
0 .376 1 r
.01 w
.7475 .61446 m
.7475 .61446 L
s
P
p
0 .361 1 r
.01 w
.7476 .61612 m
.7476 .61612 L
s
P
p
0 .346 1 r
.01 w
.7477 .61778 m
.7477 .61778 L
s
P
p
0 .331 1 r
.01 w
.7478 .61944 m
.7478 .61944 L
s
P
p
0 .316 1 r
.01 w
.7479 .6211 m
.7479 .6211 L
s
P
p
0 .301 1 r
.01 w
.748 .62277 m
.748 .62277 L
s
P
p
0 .286 1 r
.01 w
.74809 .62443 m
.74809 .62443 L
s
P
p
0 .271 1 r
.01 w
.74819 .6261 m
.74819 .6261 L
s
P
p
0 .256 1 r
.01 w
.74829 .62777 m
.74829 .62777 L
s
P
p
0 .241 1 r
.01 w
.74839 .62944 m
.74839 .62944 L
s
P
p
0 .226 1 r
.01 w
.74849 .63111 m
.74849 .63111 L
s
P
p
0 .211 1 r
.01 w
.74859 .63278 m
.74859 .63278 L
s
P
p
0 .195 1 r
.01 w
.74869 .63445 m
.74869 .63445 L
s
P
p
0 .18 1 r
.01 w
.74879 .63613 m
.74879 .63613 L
s
P
p
0 .165 1 r
.01 w
.74889 .63781 m
.74889 .63781 L
s
P
p
0 .15 1 r
.01 w
.74899 .63948 m
.74899 .63948 L
s
P
p
0 .135 1 r
.01 w
.74909 .64116 m
.74909 .64116 L
s
P
p
0 .12 1 r
.01 w
.74919 .64284 m
.74919 .64284 L
s
P
p
0 .105 1 r
.01 w
.74929 .64453 m
.74929 .64453 L
s
P
p
0 .09 1 r
.01 w
.74939 .64621 m
.74939 .64621 L
s
P
p
0 .075 1 r
.01 w
.74949 .6479 m
.74949 .6479 L
s
P
p
0 .06 1 r
.01 w
.74959 .64958 m
.74959 .64958 L
s
P
p
0 .045 1 r
.01 w
.74969 .65127 m
.74969 .65127 L
s
P
p
0 .03 1 r
.01 w
.74979 .65296 m
.74979 .65296 L
s
P
p
0 .015 1 r
.01 w
.74989 .65465 m
.74989 .65465 L
s
P
p
0 0 1 r
.01 w
.74999 .65634 m
.74999 .65634 L
s
P
p
.015 0 1 r
.01 w
.75009 .65804 m
.75009 .65804 L
s
P
p
.03 0 1 r
.01 w
.75019 .65973 m
.75019 .65973 L
s
P
p
.045 0 1 r
.01 w
.75029 .66143 m
.75029 .66143 L
s
P
p
.06 0 1 r
.01 w
.75039 .66313 m
.75039 .66313 L
s
P
p
.075 0 1 r
.01 w
.7505 .66482 m
.7505 .66482 L
s
P
p
.09 0 1 r
.01 w
.7506 .66653 m
.7506 .66653 L
s
P
p
.105 0 1 r
.01 w
.7507 .66823 m
.7507 .66823 L
s
P
p
.12 0 1 r
.01 w
.7508 .66993 m
.7508 .66993 L
s
P
p
.135 0 1 r
.01 w
.7509 .67164 m
.7509 .67164 L
s
P
p
.15 0 1 r
.01 w
.751 .67334 m
.751 .67334 L
s
P
p
.165 0 1 r
.01 w
.7511 .67505 m
.7511 .67505 L
s
P
p
.18 0 1 r
.01 w
.7512 .67676 m
.7512 .67676 L
s
P
p
.195 0 1 r
.01 w
.75131 .67847 m
.75131 .67847 L
s
P
p
.211 0 1 r
.01 w
.75141 .68018 m
.75141 .68018 L
s
P
p
.226 0 1 r
.01 w
.75151 .6819 m
.75151 .6819 L
s
P
p
.241 0 1 r
.01 w
.75161 .68361 m
.75161 .68361 L
s
P
p
.256 0 1 r
.01 w
.75171 .68533 m
.75171 .68533 L
s
P
p
.271 0 1 r
.01 w
.75182 .68705 m
.75182 .68705 L
s
P
p
.286 0 1 r
.01 w
.75192 .68877 m
.75192 .68877 L
s
P
p
.301 0 1 r
.01 w
.75202 .69049 m
.75202 .69049 L
s
P
p
.316 0 1 r
.01 w
.75212 .69221 m
.75212 .69221 L
s
P
p
.331 0 1 r
.01 w
.75223 .69393 m
.75223 .69393 L
s
P
p
.346 0 1 r
.01 w
.75233 .69566 m
.75233 .69566 L
s
P
p
.361 0 1 r
.01 w
.75243 .69738 m
.75243 .69738 L
s
P
p
.376 0 1 r
.01 w
.75253 .69911 m
.75253 .69911 L
s
P
p
.391 0 1 r
.01 w
.75264 .70084 m
.75264 .70084 L
s
P
p
.406 0 1 r
.01 w
.75274 .70257 m
.75274 .70257 L
s
P
p
.421 0 1 r
.01 w
.75284 .70431 m
.75284 .70431 L
s
P
p
.436 0 1 r
.01 w
.75294 .70604 m
.75294 .70604 L
s
P
p
.451 0 1 r
.01 w
.75305 .70778 m
.75305 .70778 L
s
P
p
.466 0 1 r
.01 w
.75315 .70951 m
.75315 .70951 L
s
P
p
.481 0 1 r
.01 w
.75325 .71125 m
.75325 .71125 L
s
P
p
.496 0 1 r
.01 w
.75336 .71299 m
.75336 .71299 L
s
P
p
.511 0 1 r
.01 w
.75346 .71473 m
.75346 .71473 L
s
P
p
.526 0 1 r
.01 w
.75356 .71648 m
.75356 .71648 L
s
P
p
.541 0 1 r
.01 w
.75367 .71822 m
.75367 .71822 L
s
P
p
.556 0 1 r
.01 w
.75377 .71997 m
.75377 .71997 L
s
P
p
.571 0 1 r
.01 w
.75388 .72171 m
.75388 .72171 L
s
P
p
.586 0 1 r
.01 w
.75398 .72346 m
.75398 .72346 L
s
P
p
.602 0 1 r
.01 w
.75408 .72521 m
.75408 .72521 L
s
P
p
.617 0 1 r
.01 w
.75419 .72696 m
.75419 .72696 L
s
P
p
.632 0 1 r
.01 w
.75429 .72872 m
.75429 .72872 L
s
P
p
.647 0 1 r
.01 w
.7544 .73047 m
.7544 .73047 L
s
P
p
.662 0 1 r
.01 w
.7545 .73223 m
.7545 .73223 L
s
P
p
.677 0 1 r
.01 w
.75461 .73399 m
.75461 .73399 L
s
P
p
.692 0 1 r
.01 w
.75471 .73575 m
.75471 .73575 L
s
P
p
.707 0 1 r
.01 w
.75481 .73751 m
.75481 .73751 L
s
P
p
.722 0 1 r
.01 w
.75492 .73927 m
.75492 .73927 L
s
P
p
.737 0 1 r
.01 w
.75502 .74103 m
.75502 .74103 L
s
P
p
.752 0 1 r
.01 w
.75513 .7428 m
.75513 .7428 L
s
P
p
.767 0 1 r
.01 w
.75523 .74456 m
.75523 .74456 L
s
P
p
.782 0 1 r
.01 w
.75534 .74633 m
.75534 .74633 L
s
P
p
.797 0 1 r
.01 w
.75544 .7481 m
.75544 .7481 L
s
P
p
.812 0 1 r
.01 w
.75555 .74987 m
.75555 .74987 L
s
P
p
.827 0 1 r
.01 w
.75566 .75165 m
.75566 .75165 L
s
P
p
.842 0 1 r
.01 w
.75576 .75342 m
.75576 .75342 L
s
P
p
.857 0 1 r
.01 w
.75587 .7552 m
.75587 .7552 L
s
P
p
.872 0 1 r
.01 w
.75597 .75697 m
.75597 .75697 L
s
P
p
.887 0 1 r
.01 w
.75608 .75875 m
.75608 .75875 L
s
P
p
.902 0 1 r
.01 w
.75618 .76053 m
.75618 .76053 L
s
P
p
.917 0 1 r
.01 w
.75629 .76232 m
.75629 .76232 L
s
P
p
.932 0 1 r
.01 w
.7564 .7641 m
.7564 .7641 L
s
P
p
.947 0 1 r
.01 w
.7565 .76588 m
.7565 .76588 L
s
P
p
.962 0 1 r
.01 w
.75661 .76767 m
.75661 .76767 L
s
P
p
.977 0 1 r
.01 w
.75671 .76946 m
.75671 .76946 L
s
P
p
.992 0 1 r
.01 w
.75682 .77125 m
.75682 .77125 L
s
P
p
1 0 .992 r
.01 w
.75693 .77304 m
.75693 .77304 L
s
P
p
1 0 .977 r
.01 w
.75703 .77483 m
.75703 .77483 L
s
P
p
1 0 .962 r
.01 w
.75714 .77663 m
.75714 .77663 L
s
P
p
1 0 .947 r
.01 w
.75725 .77842 m
.75725 .77842 L
s
P
p
1 0 .932 r
.01 w
.75735 .78022 m
.75735 .78022 L
s
P
p
1 0 .917 r
.01 w
.75746 .78202 m
.75746 .78202 L
s
P
p
1 0 .902 r
.01 w
.75757 .78382 m
.75757 .78382 L
s
P
p
1 0 .887 r
.01 w
.75767 .78562 m
.75767 .78562 L
s
P
p
1 0 .872 r
.01 w
.75778 .78743 m
.75778 .78743 L
s
P
p
1 0 .857 r
.01 w
.75789 .78923 m
.75789 .78923 L
s
P
p
1 0 .842 r
.01 w
.758 .79104 m
.758 .79104 L
s
P
p
1 0 .827 r
.01 w
.7581 .79285 m
.7581 .79285 L
s
P
p
1 0 .812 r
.01 w
.75821 .79466 m
.75821 .79466 L
s
P
p
1 0 .797 r
.01 w
.75832 .79647 m
.75832 .79647 L
s
P
p
1 0 .782 r
.01 w
.75843 .79828 m
.75843 .79828 L
s
P
p
1 0 .767 r
.01 w
.75853 .8001 m
.75853 .8001 L
s
P
p
1 0 .752 r
.01 w
.75864 .80191 m
.75864 .80191 L
s
P
p
1 0 .737 r
.01 w
.75875 .80373 m
.75875 .80373 L
s
P
p
1 0 .722 r
.01 w
.75886 .80555 m
.75886 .80555 L
s
P
p
1 0 .707 r
.01 w
.75897 .80737 m
.75897 .80737 L
s
P
p
1 0 .692 r
.01 w
.75908 .80919 m
.75908 .80919 L
s
P
p
1 0 .677 r
.01 w
.75918 .81102 m
.75918 .81102 L
s
P
p
1 0 .662 r
.01 w
.75929 .81284 m
.75929 .81284 L
s
P
p
1 0 .647 r
.01 w
.7594 .81467 m
.7594 .81467 L
s
P
p
1 0 .632 r
.01 w
.75951 .8165 m
.75951 .8165 L
s
P
p
1 0 .617 r
.01 w
.75962 .81833 m
.75962 .81833 L
s
P
p
1 0 .602 r
.01 w
.75973 .82016 m
.75973 .82016 L
s
P
p
1 0 .586 r
.01 w
.75984 .822 m
.75984 .822 L
s
P
p
1 0 .571 r
.01 w
.75995 .82383 m
.75995 .82383 L
s
P
p
1 0 .556 r
.01 w
.76005 .82567 m
.76005 .82567 L
s
P
p
1 0 .541 r
.01 w
.76016 .82751 m
.76016 .82751 L
s
P
p
1 0 .526 r
.01 w
.76027 .82935 m
.76027 .82935 L
s
P
p
1 0 .511 r
.01 w
.76038 .83119 m
.76038 .83119 L
s
P
p
1 0 .496 r
.01 w
.76049 .83303 m
.76049 .83303 L
s
P
p
1 0 .481 r
.01 w
.7606 .83488 m
.7606 .83488 L
s
P
p
1 0 .466 r
.01 w
.76071 .83672 m
.76071 .83672 L
s
P
p
1 0 .451 r
.01 w
.76082 .83857 m
.76082 .83857 L
s
P
p
1 0 .436 r
.01 w
.76093 .84042 m
.76093 .84042 L
s
P
p
1 0 .421 r
.01 w
.76104 .84227 m
.76104 .84227 L
s
P
p
1 0 .406 r
.01 w
.76115 .84413 m
.76115 .84413 L
s
P
p
1 0 .391 r
.01 w
.76126 .84598 m
.76126 .84598 L
s
P
p
1 0 .376 r
.01 w
.76137 .84784 m
.76137 .84784 L
s
P
p
1 0 .361 r
.01 w
.76148 .84969 m
.76148 .84969 L
s
P
p
1 0 .346 r
.01 w
.76159 .85155 m
.76159 .85155 L
s
P
p
1 0 .331 r
.01 w
.7617 .85342 m
.7617 .85342 L
s
P
p
1 0 .316 r
.01 w
.76181 .85528 m
.76181 .85528 L
s
P
p
1 0 .301 r
.01 w
.76193 .85714 m
.76193 .85714 L
s
P
p
1 0 .286 r
.01 w
.76204 .85901 m
.76204 .85901 L
s
P
p
1 0 .271 r
.01 w
.76215 .86088 m
.76215 .86088 L
s
P
p
1 0 .256 r
.01 w
.76226 .86275 m
.76226 .86275 L
s
P
p
1 0 .241 r
.01 w
.76237 .86462 m
.76237 .86462 L
s
P
p
1 0 .226 r
.01 w
.76248 .86649 m
.76248 .86649 L
s
P
p
1 0 .211 r
.01 w
.76259 .86836 m
.76259 .86836 L
s
P
p
1 0 .195 r
.01 w
.7627 .87024 m
.7627 .87024 L
s
P
p
1 0 .18 r
.01 w
.76282 .87212 m
.76282 .87212 L
s
P
p
1 0 .165 r
.01 w
.76293 .874 m
.76293 .874 L
s
P
p
1 0 .15 r
.01 w
.76304 .87588 m
.76304 .87588 L
s
P
p
1 0 .135 r
.01 w
.76315 .87776 m
.76315 .87776 L
s
P
p
1 0 .12 r
.01 w
.76326 .87965 m
.76326 .87965 L
s
P
p
1 0 .105 r
.01 w
.76338 .88153 m
.76338 .88153 L
s
P
p
1 0 .09 r
.01 w
.76349 .88342 m
.76349 .88342 L
s
P
p
1 0 .075 r
.01 w
.7636 .88531 m
.7636 .88531 L
s
P
p
1 0 .06 r
.01 w
.76371 .8872 m
.76371 .8872 L
s
P
p
1 0 .045 r
.01 w
.76382 .88909 m
.76382 .88909 L
s
P
p
1 0 .03 r
.01 w
.76394 .89099 m
.76394 .89099 L
s
P
p
1 0 .015 r
.01 w
.76405 .89288 m
.76405 .89288 L
s
P
p
.002 w
.63097 .0243 m
.88592 .2209 L
s
.88592 .2209 m
.95639 .89651 L
s
.95639 .89651 m
.65597 .72755 L
s
.65597 .72755 m
.63097 .0243 L
s
.11988 .1347 m
.04361 .82309 L
s
.04361 .82309 m
.65597 .72755 L
s
.65597 .72755 m
.63097 .0243 L
s
.63097 .0243 m
.11988 .1347 L
s
P
p
p
.002 w
.11988 .1347 m
.63097 .0243 L
s
P
p
.002 w
.2361 .10959 m
.2431 .11425 L
s
P
[(5)] .22211 .10027 .8368 1 Mshowa
p
.002 w
.38481 .07747 m
.39158 .08223 L
s
P
[(10)] .37126 .06795 .79278 1 Mshowa
p
.002 w
.53744 .0445 m
.54397 .04936 L
s
P
[(15)] .52437 .03478 .74877 1 Mshowa
p
.001 w
.26554 .10323 m
.26971 .10604 L
s
P
p
.001 w
.29512 .09684 m
.29927 .09966 L
s
P
p
.001 w
.32486 .09042 m
.32898 .09325 L
s
P
p
.001 w
.35476 .08396 m
.35885 .0868 L
s
P
p
.001 w
.41501 .07095 m
.41905 .07381 L
s
P
p
.001 w
.44538 .06439 m
.44939 .06727 L
s
P
p
.001 w
.4759 .05779 m
.47988 .06068 L
s
P
p
.001 w
.50659 .05116 m
.51054 .05407 L
s
P
p
.001 w
.20682 .11592 m
.21105 .1187 L
s
P
p
.001 w
.17769 .12221 m
.18194 .12498 L
s
P
p
.001 w
.14871 .12847 m
.15298 .13123 L
s
P
p
.001 w
.56845 .0378 m
.57234 .04073 L
s
P
p
.001 w
.59963 .03107 m
.60349 .03401 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .2882 .02373 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004P0
0ol300;o0`03o`800ol20003o`000;X000170007o`000?l0o`020003o`3o008000Ko003o0?l20003
o`000;X0001;0003o`3o008000?o0?l00P001_l00?l0o`8000?o0000<@03o`<00on00000B003o`80
00Ko003o0?l20006o`00o`3o0P000ol0000b0003o`0000D000?o0000O@0004L000?o00001002o`80
00Go003o0006ocD000?o00001@000ol0001m0000A`001Ol0003o00`000?o0?l0=`000ol0000200?o
P00004P00ol?0003o`0003D000?o00000P000ol0000K00CoH@0009400_l400Co5@05o`8000?o0?l0
H0000:/01Ol70004o`00oel0002W00Co1@000ol000040003o`0000?oG@000:801Ol>00Go0`000ol0
001J0000J003o`@00_l/00Go1@000ol0000600Go0X400oo;o`040003o`0005T0001Y0003o`000080
00Co003o9`04o`030?oo00/01_l4P@Ko10000ol0001H0000J@000ol000020004o`00ob801Ol70004
o`0000Wo0X44o`05^l^kPOl00h42o`030?oo00;oF00006T000?o00000P001?l00?lM00Go0`000ol0
000600Co2H42o`Rk00?oPH400X42o`@000?o00002@03odT0001Y0003o`00008000Co003o6@04o`d0
1?l3P@03oh6100Go00fkbk_;^l^kbk_;^l_o00>11?l40003o`0000/000?o0000AP0006P00_l500;o
5@05o`@000?o00001P04o`R10_lA^`04ok_oo`B10_l00`3oo`02o`/000?o0000AP0008401_l=00Co
0h400on1P@04o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kb`06P@03o`00008000?o00001@03odT0
001m00Co1P000ol0000500Go1842o`:10_lI^`03ok^k00:k18400on1o`040003o`0000@000?o0000
B@0004H00ol_00Go00<0ool02P06o`B11?l08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
bk_;00Go0h400ol00002P@03o`0000<01?m80000B@000ol0000W00Go3008o`:11?lU^`Co18400on1
P@02P@?o0P02odl000190003o`0002<01?l30003o`2100L01?l8P@;o02?;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`07o`V100KoPH7oPOl40003o`0004`0001600?o8@05o`P000Go0861
0004o`>100?oPH401?lQ^`Ko1X42o`V10_l3P@04o`0000;oC@0004H000?o00007@04o`D000?o0000
1P04o`R10_l03/^kbk_;^l^kbk_;^l^k1_l03L^kbk_;^l^kbk_;^l/01?l3P@03oh6100N100?oPH40
1Ol01<^kbk/4P@?o0P02ob`01Ol01@3oool000?o0`02o`d0001600Co5`07o`/01Ol3P@03oh6100Co
18400onk^`07^`Co1U/2o`Vk0_l8P@03oh6100J10ol:^`>100?oPOl010000ol0000Y0003o`000080
00Co003o10001?l00?l>0000G005o`d01_l4P@;o0X42o`V100cobk_;^l^kbk_;^ol9F`0<ok_;^l^k
bk_;^l_o28400on1P@04o`0?^onkbk_;^l^kbk_;^l^k00;o0h400ol000020003o`0002P000?o0000
0`03o`800_l30003o`0000`0001H00Co0`000ol0000600So1844o`Jk00?oPH401h400onk^`08^`03
oe]K00MK0_l9^`03oh6100:10_l2P@;o1K/00onk^`0=^`B11_lY00Go0`000ol0o`050003o`0000`0
001C00Go3004o`>100?oPH401?l03/^kbk_;^l^kbk_;^l_o0X44o`0?bk_;^l^kbk_;^l^kbk_o009K
1?l4F`0:ol^kbk_;^l^kb`Co1X42o`0D^l^kok_;^l^kbk_;^l^kbk_;^l/4P@;o0`02obL000?o0000
0`02o`<00ol0103oool=0000CP05o`@000?o00001P04o`R10_l>^`Ko4k/2o`UK00?o^k/02;/00on1
P@07P@04ok^koa6k1_l40003o`0002@000?o00003@000ol0000<0000BP06o``01?l3P@03oh6100Co
00c;^l^kbk_;^l^kbk/6o`IK0_l01l^kbk_;^l/01?l02K_;^l^kbk_;o`09F`;o00Zkbk_;^l^kbk_o
1H42o`:10ol04[_;^l^kbk_;^l^kbk_;^l^kb`F11_lU00Go6P0004D01Ol60003o`0000@01Ol4P@;o
0X42o`bk1?l4F`03oe]K00MK00?o^k/01?l4P@03ok^k00Jk00?oFe/01?l4F`03ok^k00Nk1Ol6P@03
ok^k016k1H42o`<00_l:00?o1002obl0001000Go0`000ol000060003POoo00Co1844o`0@bk_;^l^k
bk_;^l^kbk_;^`;o2E/00omKF`07F`;o2H402Onkbk_;^l^kb`02o`UK00co^l^kbk_;^l^kbol8P@;o
01?;^l^kbk_;^l^kbk_;^l^kbk_;00>11?l40003o`0000P000?o00000P001?l00?l^0000?004o``0
2?l2P@Co6;/2o`QK00?oFe/01?l4^`03oh6100N10_l8^`03oe]K00MK00?o^k/02;/00on1P@05P@04
oh7ooa:k0_l4P@03o`3o00?o2@000ol000020004o`00obh0000g00Go10000ol0000500Co2842o`0@
bk_;^l^kbk_;^l^kbk_;^`Co00_;^l^kbk_;^l^ko`04F`;o0U/2o`0:^l^kbk_;^l^ko`:11?l4P@0:
ol^kbk_;^l^ko`9K1?l03k_;^l^kbk_;^l^kbk_;o`02P@Go0h405?nkbk_;^l^kbk_;^l^kbk_;^l^k
1H42o`<000?o00001P000ol000020004o`00obh0000b00Oo2`04o`>100?oPH401?lA^`?o15/2o`Vk
1?l>^`Co2H400onk^`06^`;o4k/2o`B100?oPH400X400onk^`0A^`>100CoPOoo0`02o`H000?o0000
0P001?l00?l^0000<002o`d01_l4P@03oh6100;o00o;^l^kbk_;^l^kbk_;^l/01_l9F`0Gok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/01?l4P@03oh6100N1023obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`>100?oPH400h42o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l4P@;o0h400ol0000200;o1@02obl0
000`0003o`3o00P01Ol5P@Co4;/4o`IK00?oFe/01e/00onk^`0=^`Ko2H400on1P@04ob:k00?oPH40
1?l4P@03ok^k016k1H42o`<000?o0000>@00030000?o00002_l2P@Co01Vkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00QK00?oFe/01?l03;_;^l^kbk_;^l^kb`Ko1X42o`R10_l03k_;^l^kbk_;^l^kbk_;
^`06o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0ol8P@0Dol^kbk_;^l^kbk_;^l^kbk_;^l/3P@04oh7oo`<0
0_li0000<005o`R10_lM^`03oe]K009K0_l2F`;o3;/4o`B10_l8P@03oh6100?o3k/4o`IK00?o^k/0
4K/00on1P@07P@;o4[/2o`B100?o0?l00olh0000;`02o`>100?oPH401?l08[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`0>^l^kbk_;^l^kbk_;^l/4o`Z100?oPH400X42o`:10_l05L^k
bk_;^l^kbk_;^l^kbk_;^l^ko`08F`0Col^kbk_;^l^kbk_;^l^kbk_;^`02o`:11?l4P@0Dok_;^l^k
bk_;^l^kbk_;^l^kbk/5P@;o0`000ol0000e00009P02o`L00_l4P@;o=K/3o`B10_l9P@Co6k/00omK
F`02F`;o0U/00onk^`0=^`Ko2H400onk^`0A^`>100CoPOoo0`000ol0000d00009@001?l00?l60004
o`3oo`B10_l0<K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l9P@03oh6100Co18407_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co00k;^l^kbk_;^l^k
bk_;^`Ko0X401On1PH7o00V101Co^l^kbk_;^l^kbk_;^l^kbk_;^`;o18400ol0o`03oc@0000U0004
o`00o`H000?o00000P05P@03ok^k02Bk1?l8^`03oh6100N10_l9P@03ok^k02Rk1?l4P@05oh61POl0
18400on1P@04oaRk1H42o`<000?o0000<@0002D000Co003o1P000ol000030003oh6100:10_l08<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4F`0:ok_;^l^kbk_;o`:11?l4P@03oh6100N1
01;o^l^kbk_;^l^kbk_;^l^kbk/4o`0>bk_;^l^kbk_;^l^kbk/6o`V100GoPH7oP@02o`:10_l07L^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>100CoPOoo0`000ol0000`00009@001?l00?l60003
o`0000@00_l4P@;o7;/2o`UK00?o^k/01[/2o`V100?oPH401?l@^`Co15/00onk^`07^`Co1X400on1
P@07P@Co8;/6o`B100?o0?l00ol`00009P02o`L000?o00001`05P@0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0_l8F`;o00S;^l^kbk_;^`;o2842o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l9F`0<
ol^kbk_;^l^kbk_o28400on1P@04o`0Pbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/6o`IK
00?oPH400X400ol000020003o`0000T00ol300?o6`0002h00ol90003oh6100:10_lM^`03oe]K00?o
15/2o`Rk00?oPH400ol<^`Co2;/2o`QK00?o^k/02;/00on1P@02P@;o0X42o`Rk00?o^k/05K/4o`AK
00?oFe/01U/01On1POn100;o0`000ol000090003o`0000D000?o0000600002l000?o00002@02o`B1
01kobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`UK00Wo^l^kbk_;^l/00_l03;_;^l^kbk_;
^l^kb`?o1842o`09bk_;^l^kbk_o009K0ol03/^kbk_;^l^kbk_;^l^k1?l6P@0Lok_;^l^kbk_o^l^k
bk_;^l^kbk_;^l^kbk_;^`Co2E/00omKF`02F`;o0U/2o`B100?o0?l00_l:0003o`0000D000?o0000
600002l000?o00002`000on1P@02P@03ok^k01bk00?oFe/01e/00onk^`0?^`Co2H400onk^`06^`;o
4k/00on1P@06P@03ok^k00Bk00?o^k/03K/4o`AK00?oFe/01e/4o`IK00?oPH400X401?l00002o`P0
00?o00000P03oa/0000^0003o`0000h00_l2P@;o01jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol2F`Co012kbk_;^l^kbk_;^l^kbk_;1?l4P@03oh6100N10_l07K_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00B10_l2P@;o00k;^l^kok_;^l^kbk_;^`Ko2E/00omKF`04o`05bk_;^ol025/01On1
POn100;o0`000ol000050003o`00008000?o00006`0002h000?o00003`02o`>10_lL^`;o4[/2o`V1
00?oPH401?l4P@03ok^k01Rk1_l6P@05ok^k^ol00k/6o`IK0_l8F`;o2K/00omKF`02F`;o0U/2o`B1
00GoPH61o`0500;o1004oaX0000^0003o`00014000?oPH400X40<_o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l8P@;o2H405onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00?o15/2o`N100?obk/01?l4F`03oe]K00MK1?l03/^kbk_;^l^kbk_;^l^k1_l6F`03oh6100:1
00Co00000_lW0000;P000ol0000A0004P@3oo`:10_la^`Co1X400on1P@07P@03ok^k016k0_l9F`03
oh6100:100?oPH400ol8F`03oe]K00Co4;/4o`AK00?oFe/01U/01On1POn100;o0`000ol0000T0000
;P000ol0000A0004P@00o`B103?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l7P@03oh6100Co01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00UK1?l5P@;o
25/2o`0>bk_;^l^kbk_;^l^kbk/6o`UK00?oFe/00U/2o`9K0_l3P@Ko9@0002d00olA0003P@000080
00?oPH400X400onk^`0T^`Co2K/00on1P@02P@03oh6100;o7K/00omKF`04o`Bk00?oPH401H400omK
F`04o`AK00?o^k/01k/4o`IK00?oFe/01e/4o`Jk1842o`<000?o00008P0002h000?o000040000h40
000400;o0X42o`0Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`AK00[o^l^kbk_;^l^k
1?l5P@;o01bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l02[_;^l^kbk_;^ol4P@03oh7o00;o
2E/03?o;^l^kbk_;^l^ko`QK00?oFe/01?l03L^kbk_;^l^kbk_;^l/00ol0187oool200;o8P0002h0
00?o000040000h4000060004oh61P@?o6k/2o`UK00?o^k/02;/00on1P@06P@03ok^k02Fk1?l2^`04
ok^ko`UK0_l9^`03oe]K009K0_l2F`;o4k/4P@?o0P000ol0000O0000;P000ol0000@0003P@0000L0
00?oPH400h42o`0K^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o25/2o`0:bk_;^l^kbk_;o`B1
0_l2P@;o033;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbol2F`Co
15/02_nkbk_;^l^kbk/4o`IK01Co^l^kbk_;^l^kbk_;^l^kbk_;^`B10_l30003o`0001h0000]0003
o`00014000>100002@02o`B100?o^k/06[/4o`IK00?o^k/01k/4o`J100?o^k/0:;/00onk^`02^`;o
2E/00onk^`08^`03oe]K00IK00?o^k/04K/:oal0000]0003o`00014000>100002P000on1P@03P@0N
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l7F`0<ol^kbk_;^l^kbk_o2840<Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk/00_l8F`;o00[;^l^kbk_;^l_o
15/2o`9K0_l04l^kbk_;^l^kbk_;^l^kbk_;^l/01842o`030?l001h0000]0003o`00014000>10000
2`000on1P@03P@;o7K/00omKF`02F`04oe]Ko`Zk00?oPH400X42o`:10_lW^`03ok^k00Bk1_l6F`03
ok^k00Nk1?l6F`03ok^k016k0h401?n1oolO0000;@02oa8000>100003P02o`>10_l06[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;1_l03k_;^l^kbk_;^l^kbk_;^`04o`J10_l0:L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00?o15/00omKF`06F`0<ol^kbk_;^l^kbk_o25/2o`0B
^l^kbk_;^l^kbk_;^l^kbk_;0_l01;_;^olO0000;@000ol0000A0003P@0000l00_l4P@03ok^k01>k
1?l4F`03ok^k012k00?oPH401h42ob6k1_l8F`03oe]K009K0_l2F`03ok^k00Rk00?oFe/00ol4F`9O
2[/4o`F10[/2oah0000]0003o`00014000>100004@000on1P@02P@;o00k;^l^kbk_;^l^kbk_;^`Go
2E/05?nkbk_;^l^kbk_;^l^kbk_;^l_o0X44o`B101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
1_l2F`05oe]KFol025/4o`0<bk_;^l^kbk_;^l^k1_l3F`03GamO00<O00AObk_;1_l5P@Go00<0o`00
7P0002d000?o00004@000h40000B00;o18400onk^`07^`Co1E/00omKF`07F`03ok^k012k0_l9P@03
ok^k01>k1?l4F`05oe]KFol015/00omKF`03o`bk1_l3F`eO00<OGal01846o`P000?o0000700002d0
00?o000040000h40000E0003oh6100:100cobk_;^l^kbk_;^ol7F`03oe]K00Co01Rkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol9P@;o017;^l^kbk_;^l^kbk_;^l^kb`02o`UK00GoFe_oF`02o`9K0_l02k_;
^l^kbk_;^l^k00Co15/05OmO7elOGamO7elOGalG7aLOGamO7`03P@;o3@000ol0000L0000;0000ol0
000A0003P@0001H000?oPH400X42o`Vk00?oFe/00U/00omKF`02oabk00?oPH401?l4P@03ok^k00Fk
1?l7^`03oe]K00MK1?l;^`Ko1E/00elGG`07G`097elOGamO7elO00;o00<OGol04P000ol0000L0000
;0000ol0000A0003P@0001H000>1ool01842o`08bk_;^l^kbk/4o`0Rbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;o2H400oo;^`04o`AK00Wo^l^kbk_;^ol00U/4o`0;^l^kboo;^l^kbk/0
1_l6F`0BoelOGamO7elOGamO7elOGamO1_lG0003o`0001`0000/0003o`00014000>100005P001840
0005P@03ok^k02fk0ol7P@;o2E/00onk^`05^`;o2;/01?nk^k/3o`AK00?o7al011l01UlO7aMO5`9O
00LOGan17elO00:10ol40003P@0001D000?o0000700002`00_lB0003P@0001H000>100000P03o`:1
0_l0;[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/6o`EK00?oFe/0
1e/04onkbk_;^l^kbk_;^l^kbk_;ol/00_l5F`097elOGamO7elO00=O00Co7alO0h45o`T000>10000
5@000ol0000L0000;0000ol0000A0003P@0001D000>100001@000on1P@02P@;o:;/4o`AK00?oFe/0
1E/00omKF`04oa>k00?o^k/02Ql01OlO7an100DO1?l@0003P@0001@000?o0000700002`000?o0000
4@000h40000E0003P@0000H000?oPH400h42o`0?^l^kbk_;^l^kbk_;^l^k00Co017;^l^kbk_;^l^k
bk_;^l^kb`02o`UK00?oFe/00U/00omKF`02o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^aoo1al00elO
o`09P@AO4`000h40000D0003o`0001`0000/0003o`00014000>100005@000h40000800;o18400onk
^`09^`?o15/00onk^`05^`Co1k/00omKF`07F`Co1H42oaBk00<Ooal00Ql4o`B11Ol500037el00180
00>1000050000ol0000L0000;0000ol0000A0003P@0001D000>100002@02o`B100Wo^l^kbk_;^l/0
0_l8F`03ol^k00Co15/02Onkbk_;^l^ko`02F`Co00Fkbk_;o`08P@;o00o;^l^kbk_;^l^kbk_;^l/0
1_l4P@Ko2P000aMO7`0B0003P@0001D000?o00006`0002`000?o00004@000h40000E0003P@0000/0
00?oPH400X42o`Rk0_l7F`;o2E/00onk^`05^`;o2K/00on1P@03o`B100?o^k/02K/3o`B100?oPH40
0X42oa0000<GG`004@000h40000E0003o`0001/0000[0003o`00018000>100005@000h40000<00;o
18402_o;^l^kbk_;^l/4o`EK00?oFe/01e/04onkbk_;^l^kbk_;^l^kbk_;^l/00_l8P@05ol^kbk/0
1_l4P@Go0P000h40000@008G4P000h40000E0003o`0001/0000[0003o`00014000>100005P000h40
000>0003oh6100:100?o^k/02;/00omKF`05F`03oe]K00Co5k/00on1P@06P@Co1845o`@000Go0000
P@0B008G4P000h40000E0003o`0001/0000[0004oh7ooa0000>100005P000h40000@0004oh61P@;o
00Zkbk_;^l^kbk_o15/00omKF`02o`0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol00X43o`:1
1?l3P@03o`0000L000Go0000P@0B00035a40014000>100005@000ol0000K00006P03o`@00_l80003
o`21014000>100005P000h40000A00;o0h43o`Nk1?lN^`Ko1844o`h000Go0000P@0B008A4P000h40
000E0003o`0001/0000K0003o`00008000Co003o1`000ol00002P@l000>100005P000h40000C0003
oh6100>10_l08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1ol4P@Go4`001Ol000210180
0Q4B0003P@0001D000?o00006`0001/000?o00000P001?l00?l70003o`0000800X4=0003P@0001H0
00>100004`00187oool4P@03ok^k01Nk1_l3P@Co0h400ol0000F0005o`0008404P024A8000>10000
5@000ol0000K00006`000ol000020004o`00o`L000?o000010000h40000:0003P@0001H000>10000
4`000h400002o`B101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/01?l8P@Co7@001Ol0002101800Q4B0003
P@0001D000?o00006`0001/000?o00000P001?l00?l70003o`0000D00X4:0003P@0001H000>10000
4`0018400002o`B10_l=^`Go1H45o`030840020000Go0000P@0B00:O4P000h40000E0003o`0001/0
000J00;o1@02o`P000?o00001`02P@P000>100005P000h40000C0003P@0000<00_l4P@07ok_;^l^k
b`06o`B11_l60003P@0001l000Go0000P@0B00:O4`000h40000E0003o`0001X0000Z0003o`0000X0
00>100001@000h40000F0003P@0001<000>100001@000on1P@02P@03ok^k00?o2H42o`/000>10000
80001Ol00021014000?OW`004P000h40000E0003o`0001X0000Z00?o2`02P@D000>100005@000h40
000D0003P@0000H00ol2P@;o1845oa0000>1000080001Ol00021014000>Og`004P000h40000E0003
o`0001X0000Z0003o`0000d00X430003P@0001D000>1000050000h4000080004ok^k^`Go5@000h40
000P0005o`0008404@02Wa<000>100005@000ol0000J0000:P000ol0000?0004P@00PAL000>10000
50000h40000900?o6P000h40000P0005o`0008404@02ga<000>100005@000ol0000J0000:P000ol0
000@00:160000h40000D0003P@0000T000?o00006P000h40000P0005o`0008404@000mnO000B0003
P@0001D000?o00006P0002X000?o00004@03PAH000>100004`000h40000:0003o`0001X000>10000
80001Ol0002101400mlB0003P@0001D000?o00006P0002X000?o00004@001840084E0003P@0001<0
00>100002P000ol0000J0003P@00020000Go0000P@0A0003WmoO018000>100005@000ol0000J0000
:P000ol0000A0004P@0000:14`000h40000C0003P@0000X000?o00006P000h40000P0005o`000840
4P02ga8000>100005@000ol0000J0000:P000ol0000A0003P@0000<00X4A0003P@0001<000>10000
2P000ol0000J0003P@00020000Go0000P@0B0003gmh0014000>100005P000ol0000I0000:@03oa80
00>100001@000h40000>0003P@0001<000>100002P000ol0000J0003P@00020000Go0000P@0B00;O
4P000h40000F0003o`0001T0000Y0003o`00018000>100001P02P@h000>100004`000h40000:0003
o`0001X000>1000080001Ol0002101800]hB0003P@0001H000?o00006@0002T000?o00004P000h40
000800:130000h40000C0003P@0000X000?o00006P000h40000P0005o`0008404P000mkO000A0003
P@0001H000?o00006@0002T000?o00004P000h40000:0003P@0000T000>100004`000h40000:0003
o`0001X000>1000080001Ol00021018000?OgP004P000h40000E0003o`0001T0000Y0003o`000180
00>100002`02P@T000>100004`000h40000:0003o`0001X000>1000080001Ol0002101800]hC0003
P@0001D000?o00006@0002T000?o00004P000h40000=00:11`000h40000C0003P@0000X000?o0000
6P000h40000P0005o`0008404P000mkO000B0003P@0001D000?o00006@0002T000?o00004@000h40
000@0003P@0000@000>100004`000h40000:0003o`0001X000>1000080001Ol0002101800]hC0003
P@0001D000?o00006@0002T000?o00004@000h40000A00:10`000h40000D0003P@0000X000?o0000
6P000h40000P0005o`0008404P000mia000B0003P@0001<00X400on1000I0000:0000ol0000B0003
P@0001<00X400`21000E0003P@0000T000?o00006`000h40000P0005o`0008404P000g7N000B0003
P@0000h01H430003o`0001P0000X00?o4P000h40000E00:15P000h4000090003o`0001/000>10000
80001Ol0002101800]hC0003P@0000P01X480003o`0001P0000X0003o`00018000>100005P02PAD0
00>100002@000ol0000K0003P@00020000Go0000P@0B009a4`000h40000200J13P000ol0000H0000
:0000ol0000B0003P@0001H000B108614`000h4000090003o`0001/000>1000080001Ol000210180
00=agP004P05PA@000?o0000600002P000?o00004P000h40000F0005P@0008404P000h4000090003
o`0001/000>1000080001Ol00021018000?NL@003007PAP000?o0000600002P000?o00004P000h40
000F0003P@0000800X4@0003P@0000T000?o00006`000h40000P0005o`0008404P000g7ML@0700F1
1P000h40000F0003o`0001P0000X0003o`00018000>100005P000h40000400:13P000h4000090003
o`0001/000>1000080001Ol00021018000CNgMd01X4;0003P@0001H000?o0000600002P000?o0000
4P000h40000F0003P@0000H000>100002`000h4000090003o`0001/000>1000080001Ol000210140
0X400g6EP@0B0003P@0001D000?o0000600002P000?o00004P000h40000F0003P@0000L00X4;0003
P@0000T000?o00006`000h40000P0003o`00008000>100002006P@8000>EL@004P000h40000E0003
o`0001P0000W00?o4P000h40000G0003P@0000T00X490003P@0000T000?o00006`000h40000P0003
o`00008000>100000P06P@P000?MU@004P000h40000E0003o`0001P0000W0003o`00018000>10000
5`000h40000;0003P@0000H000>100002@000ol0000K0003P@00020000?o00000P05P@h00YDC0003
P@0001H000?o00005`0002L000?o00004P000h40000G0003P@0000`00X460003P@0000T000?o0000
6`000h40000O0003POn100B14P000mbE000B0003P@0001H000?o00005`0002L000?o00004P000h40
000G0003P@0000h00X440003P@0000T000?o00006`000h40000J00F100<0o`000`000h40000@0003
UM`0018000>100005P000ol0000G00009`000ol0000B0003P@0001L000>1000040001840084<0003
o`0001/000>100005006P@H000?o00000P000h40000@00:E4`000h40000F0003o`0001L0000W0003
o`00018000>100005P000h40000B00>130000ol0000K0003P@0000h01X4=0005o`0008404P000mbE
000B0003P@0001H000?o00005`0002L000?o00004P000h40000F0003P@0001@00X4;0003o`0001/0
00>100002@05PA<000Go0000P@0B00;L4`000h40000F0003o`0001L0000W0003o`00018000>10000
5P000h40000D0003P@2100X000?o00006`000h40000300J160001Ol0002101800]`C0003P@0001H0
00?o00005`0002L000?o00004P000h40000F0003P@0001@000>100000X480003o`0001/01X4N0005
o`0008404P000ncL000B0003P@0001H000?o00005`0002H000CoPOoo4P000h40000F0003P@0001@0
00>100000P02P@H000?o00005P06PB<000Go0000P@0B0003g;L0018000>100005P000ol0000G0000
5P04o`<00_l70004o`21PA8000>100005P000h40000D0003P@0000@000>100000`000ol0000A00F1
1@000h40000Q0005o`0008404P02k1<000>100005`000ol0000F00005`000ol000020004o`00o`H0
00Co00000X4@0003P@0001H000>1000050000h40000500:10`000ol0000;00J12P000h40000Q0005
o`0008404P000mc/000C0003P@0001H000?o00005P0001P000Go0000o`020003o`0000@000?o0000
0`000h40000<0003P@0001L000>1000050000h40000700:100<0o`001P06PA0000>100008@001Ol0
002101800]`D0003P@0001H000?o00005P0001T000Co003o0P000ol000040003o`0000@00X4<0003
P@0001L000>1000050000h4000090004POl000F15P000h40000Q0005o`0008404P03k1<000>10000
5P000ol0000F00000P03oa4000Co003o0P001?l00?l60003o`0000H00X4:0003P@0001L000>10000
50000h40000:0003oh6101/000>100008@001Ol00021018000?Lk=`04`000h40000F0003o`0001H0
00020004o`00oa400_l400;o1`000ol0000800:120000h40000G0003P@0001@000>100002P000ol0
000K0003P@00024000Go0000P@0C00;/4`000h40000F0003o`0001H000020003o`00024000?o0000
2P02P@H000>100005`000h40000D0003P@0000X000?o00006`000h40000Q0005o`0008404`000nbg
000B0003P@0001H000?o00005P00008000?o000080000ol0000=0003P@0000<000>100005`000h40
000D0003P@0000X000?o00006`000h40000Q0005o`0008404`02]a<000>100005P000ol0000F0000
00<0ool00_lP00?o3P02P@<000>100005`000h40000D0003P@0000X000?o00006`000h40000Q0005
o`0008404`02]a<000>100005P000ol0000F00000P000ol0000P0003o`0001000X400`21000H0003
P@0001@000>100002P000ol0000K0003P@00024000Go0000P@0C0003][L0018000>100005P000ol0
000F00000P000ol0000P0003o`0001800X4H0003P@0001D000>100002P000ol0000K0003P@000240
00Go0000P@0C00:f4`000h40000G0003o`0001D0000U0003o`0001<00h4F0003P@0001D000>10000
2P000ol0000K0003P@00024000Go0000P@0C0003]kH0018000>100005`000ol0000E00009@000ol0
000C0003P@0000:150000h40000E0003P@0000X000?o00006`000h40000Q0005o`0008404`000kJg
000B0003P@0001L000?o00005@0002D000?o00004P000h4000030003P@00014000>100005@000h40
000:0003o`0001/000>100008@001Ol0002101<00[HC0003P@0001L000?o00005@0002D000?o0000
4P000h40000400:14@000h40000E0003P@0000X000?o00006`000h40000Q0003o`00008000>10000
40000obf000C0003P@0001H000?o00005@0002D000?o00004P000h40000600:13`000h40000E0003
P@0000X000?o00006`000h40000Q0003o`00008000>1000040000kKl000C0003P@0001H000?o0000
5@0002@00olC0003P@0000P00X4=0003P@0001D000>100002@000ol0000L0003P@00024000?o0000
0P000h40000@0003]_`001<000>100005P000ol0000E000090000ol0000C0003P@0000X00X4;0003
P@0001D000>100002@000ol0000L0003P@00024000?o00000P000h40000@0003][D001<000>10000
5P000ol0000E000090000ol0000C0003P@0000`00X490003P@0001D000>100002@000ol0000L0003
P@00024000?o00000P000h40000@00:e50000h40000F0003o`0001D0000T0003o`0001<000>10000
3P000h4000060003P@0001@000>100002P000ol0000L0003P@00024000?o00000P000h40000@00:e
50000h40000G0003o`0001@0000T0003o`0001<000>100003`02P@H000>1000050000h40000:0003
o`0001`000>100008@000ol000020003P@0001000[D00`d0000A0003P@0001L000?o0000500002@0
00?o00004`000h40000A00:110000h40000D0003P@0000X000?o000070000h40000Q0003o`000080
00>100004@000`fe000B0003P@0001@00h400ol0000D000090000ol0000C0003P@0001<00X420003
P@0001@000>100002P000ol0000L0003P@00024000?o00000P000h40000A00033KD0018000>10000
3P06P@<000?o0000500002@000?o00004`000h40000E00>15P000h40000:0003o`0001`000>10000
8@000ol000020003P@0001400PdC0003P@0000P01X490003o`0001@0000T0003o`00018000>10000
60000h40000D0003P@0000X000?o000070000h40000Q0003o`00008000>100004@023A<000>10000
0P06P@l000?o0000500002<00olC0003P@0001L000B1086150000h40000:0003o`0001`000>10000
8@000ol000020003P@00014000<=c0004@06PAD000?o0000500002<000?o00004`000h40000G0004
P@0000:14P000h40000:0003o`0001`000>100008P001Ol0002101<000?<3@002`06P@03084001P0
00?o0000500002<000?o00004`000h40000G0003P@0000<00X4@0003P@0000X000?o000070000h40
000R0005o`0008404`023@H01X480003P@0001H000?o0000500002<000?o00004`000h40000G0003
P@0000D00X4>0003P@0000X000?o000070000h40000R0005o`0008404`02c0J13P000h40000G0003
o`0001<0000S0003o`0001<000>100005`000h40000700:130000h40000:0003o`0001`000>10000
8P001Ol0002100l018400`g0000C0003P@0001L000?o00004`0002<000?o00004`000h40000G0003
P@0000T000>100002@000h40000:0003o`0001`000>100008P001Ol0002100T01X44008=50000h40
000G0003o`0001<0000S0003o`0001<000>100005`000h40000:00:12@000h40000:0003o`0001`0
00>100008P001Ol0002100<01X4:00;<50000h40000G0003o`0001<0000S0003o`0001<000>10000
5`000h40000<00:11`000h40000:0003o`0001`000>100008P000on1P@05PA0000<=c0004`000h40
000G0003o`0001<0000S0003o`0001<000>100005`000h40000>00:11@000h40000:0003o`0001`0
00>100007@05P@05o`0008404`000l`=000C0003P@0001L000?o00004`00028000?o000050000h40
000G0003P@0001000X430003P@0000X000?o000070000h40000G00J11@001Ol0002101<000?0c000
4`000h40000G0003o`0001<0000R00?o4`000h40000H0003P@0001800X400`21000;0003o`0001`0
00>100004@06P@/000Go0000P@0C00;050000h40000G0003o`0001<0000R0003o`0001<000>10000
60000h40000D00:130000ol0000L0003P@0000/01X4A0005o`0008404`02`1@000>100005`000ol0
000C00008P000ol0000C0003P@0001P000>100005@02P@/000?o000070000h40000500J15`001Ol0
002101<00l0C0003P@0001L000?o00004`00028000?o00004`000h40000H0003P@0001D000B10861
2@000ol0000L0003P@2100F17@001Ol0002101@00/HC0003P@0001P000?o00004P00028000?o0000
4`000h40000G0003P@0001H000B100000X470003o`0001P01X4S0003o`00008000>100004@02aQ@0
00>100005`000ol0000B00008P000ol0000C0003P@0001L000>100005P000h40000300:11@000ol0
000B00J110000h40000R0003o`00008000>100004@000lK0000C0003P@0001L000?o00004P000280
00?o00004`000h40000G0003P@0001H000>100001@000h4000020003o`0000`01X4:0003P@000280
00?o00000P000h40000A00;650000h40000G0003o`000180000Q0003o`0001@000>100005`000h40
000F0003P@0000H00X420003o`0000H01X4@0003P@00028000?o00000P000h40000A00:<50000h40
000G0003o`000180000Q0003o`0001@000>100005`000h40000F0003P@0000P00X400ol00006PAH0
00>100008P000ol000020003P@0001400X`D0003P@0001L000?o00004P00024000CoPOoo4`000h40
000G0003P@0001D000>100002`000on1P@0L0003P@00028000?o00000P000h40000A00:<50000h40
000G0003o`000180000A00?o1002o`L000Co08614`000h40000G0003P@0001D000>100002`000ol0
000L0003P@00028000?o00000P000h40000A0003C8`001<000>100005`000ol0000B000050001?l0
0?l20003o`0000@000Co00000X4A0003P@0001L000>100005@000h40000;0003o`0001d000>10000
8@000ol000020003P@00014000=<S0004`000h40000G0003o`000180000D0004o`00o`8000?o0000
10000ol0000300:13P000h40000H0003P@0001D000>100002`000ol0000M0003P@00024000?o0000
0P000h40000A00:<50000h40000H0003o`000140000B00;o0`001?l00?l60003o`0000D00X4<0003
P@0001P000>100005@000h40000;0003o`0001d000>100008@000ol000020003P@0001400X`D0003
P@0001P000?o00004@0001@000Co003o0P000ol000040003o`0000L00X4:0003P@0001P000>10000
5@000h40000;0003o`0001d000>100008@000ol000020003P@0001400T`D0003P@0001P000?o0000
4@0001400ol400;o1`000ol0000900:120000h40000H0003P@0001D000>100002`000ol0000M0003
P@00024000?o00000P000h40000A0003S4`001<000>1000060000ol0000A000080000ol0000<00:1
1P000h40000H0003P@0001D000>100002P000ol0000N0003P@00024000?o00000P000h40000A0003
S4`001<000>1000060000ol0000A000080000ol0000>00:110000h40000H0003P@0001D000>10000
2P000ol0000N0003P@00024000?o00000P000h40000A009<5@000h40000G0003o`000140000P0003
o`0001000X420003P@0001P000>100005@000h40000:0003o`0001h000>100008@000ol000020003
P@00014000=<d]8050000h40000G0003o`000140000P00?o4P03PAT000>100005P000h40000:0003
o`0001h000>100008@000ol000020003P@0001400d`D0003P@0001L000?o00004@00020000?o0000
50000h40000G0003P@0001H000>100002P000ol0000N0003P@00024000?o00000P000h40000B009<
50000h40000G0003o`000140000P0003o`0001@00h4G0003P@0001H000>100002P000ol0000N0003
P@00024000?o00000P000h40000B0003C4d001<000>100005`000ol0000A000080000ol0000D0003
P@0000:15@000h40000F0003P@0000X000?o00007P000h40000R0005o`0008405002C1@000>10000
60000ol0000@000080000ol0000C0003P@0000<00X4C0003P@0001H000>100002P000ol0000N0003
P@00028000Go0000P@0D009=50000h40000H0003o`000100000P0003o`0001<000>100001@02PA40
00>100005P000h40000:0003o`0001h000>100008P001Ol0002101@00TdD0003P@0001P000?o0000
400001l000?o000050000h40000700:13`000h40000F0003P@0000X000?o00007P000h40000R0005
o`00084050000de<000C0003P@0001P000?o0000400001l000?o000050000h40000900:13@000h40
000F0003P@0000X000?o00007P000h40000R0005o`00084050000de<000C0003P@0001P000?o0000
400001l000?o000050000h40000;00:12`000h40000F0003P@0000X000?o00007P000h40000R0005
o`0008405002CA@000>1000060000ol0000@00007`03oa@000>100003@02P@T000>100005P000h40
000:0003o`0001h000>100008P001Ol0002101@00TdD0003P@0001P000?o0000400001l000?o0000
50000h40000?00:11`000h40000F0003P@0000X000?o00007P000h40000R0005o`0008405002CA@0
00>1000060000ol0000@00007`000ol0000D0003P@0001400X450003P@0001H000>100002P000ol0
000N0003P@00028000?o00000P000h40000A0003CFH001@000>100005@02P@03oh400100000O0003
o`0001@000>100004`02P@<000>100005P000h40000:0003o`0001h000>100008P000ol000020003
P@00014000==IP0050000h40000?00J10`000ol0000?00007`000ol0000D0003P@0001D00X400`21
000G0003P@0000X000?o00007P000h40000R0003o`00008000>100004@000deV000D0003P@0000P0
1h490003o`0000l0000N0003o`0001D000>100005`02PAP000>100002P000ol0000N0003P@000280
00?o00000P000h40000A009>5@000h40000200J140000ol0000?00007P000ol0000D0003P@0001P0
00B108615@000h40000;0003o`0001h000>100008P000ol000020003P@0001400VHD00J15P000ol0
000?00007P000ol0000D0003P@0001P000B100000X4C0003P@0000/000?o00007P000h40000R0003
o`00008000>100004@000diVC@0<00N100<0P@006@000ol0000?00007P000ol0000D0003P@0001P0
00>100000`02PA4000>100002`000ol0000N0003P@00028000?o00000P000h40000A0003ITeV00H0
1X480003P@0001P000?o00003`0001h000?o000050000h40000H0003P@0000D00X4?0003P@0000/0
00?o00007P000h40000O00Go0`000h40000B009V1X4>0003P@0001P000?o00003`0001h00olD0003
P@0001P000>100001`02P@d000>100002`000ol0000N0003P@0001T01_l500;o00<0P@003P05P@9>
50000h40000H0003o`0000l0000N0003o`0001@000>1000060000h40000900:12`000h40000;0003
o`0001h000>100004P07o`d000?oP@002006P@D00VHD0003P@0001P000?o00003`0001h000?o0000
50000h40000H0003P@0000/00X490003P@0000/000?o00007P000h40000<00Ko5@02o`801X4;0003
CT8001<000>1000060000ol0000?00007P000ol0000D0003P@0001P000>100003@02P@L000>10000
2`000ol0000N0003P@0000H01_lH00F10_lA0003@VH001<000>100006@000ol0000>00007@000ol0
000E0003P@0001P000>100003`000h4000040003P@0000/000?o00007P000h400006oaP01X430004
P@0000;o3`000di2000D0003P@0001P000?o00003P0001d000?o00005@000h40000H0003P@000100
0X440003P@0000/000?o00006P07oaP01X490003P@0000<00_l=00925@000h40000H0003o`0000h0
000M0003o`0001D000>1000060000h40000B00:10P000h40000;0003o`0001@01_l40003P@000180
1X4?0003P@0000D000?o00002P02@QD000>1000060000ol0000>00007@000ol0000E0003P@0001P0
00>100005003P@d000?o00003P06o`X000>100002`07PAD000>100001P02o`X00T8E0003P@0001P0
00?o00003P0001d000?o000050000h40000I0003P@0001H00X4<0003o`0000P01_l@0003P@0000D0
1X4L0003P@0000P00_l8009?5@000h40000H0003o`0000h0000M0003o`0001@000>100006@000h40
000F0004P@21P@X000?o00000P06oaH000>108401H4R0003P@0000X00_l60003Cd8001@000>10000
60000ol0000>00007@03oa@000>100006@000h40000F0004P@0000:11P07oaL01h4X0003P@0000`0
00?o00000`000d9?000D0003P@0001P000?o00003P0001d000?o000050000h40000H0003P@0001L0
00>100000`06o`8000?o00004`06P@D000>100009`000h40000=00;o0`02CaD000>1000060000ol0
000>00007@000ol0000D0003P@0001P000>100005`06o`800X440003o`0000d01X4;0003P@0002L0
00>100003`02o`0303m?01D000>100006@000ol0000=000070000ol0000E0003P@0001P000>10000
4@06o`03P@0000L00X400`3o000800N14@000h40000W0003P@0001400_l00cl0000C0003P@0001T0
00?o00003@0001`000?o00005@000h40000H0003P@0000X01ol60003P@0000T000>1o`000P06PAP0
00>100009`000h40000B0003?ooo01@000>100006@000ol0000=000070000ol0000E0003P@0001P0
00>100001006o`d000>100002P001?n1PH4N0003P@0002L000>100004P0014lo?olC0003P@0001T0
00?o00003@0001`000?o00005@000h40000H0003POoo00Co4`000h40000:0003o`0001l000>10000
9`000h40000C0003Cb0000;o4@000h40000I0003o`0000d0000L0003o`0001D000>100004`06oaT0
00>100002P000ol0000O0003P@0002P000>100004P02C`<00_l@0003P@0001P000?o00003@0001`0
00?o00005@000h40000<00Oo1@000h40000G0003P@0000X000?o00007`000h40000X0003P@000180
0Sl500;o3P000h40000H0003o`0000d0000L0003o`0001@000>100001`06o``000>100005`000h40
000:0003o`0001l000>10000:0000h40000B0003Ccl000H000?o00002`000h40000H0003o`0000d0
000L0003o`0001@000B100001_lB0003P@0001L000>100002P000ol0000O0003P@0002P000>10000
4P02?`P00_l;0003P@0001P000?o00003@0000`00ol300;o20000on1o`0B00Ko60000h40000F0003
P@0000/000?o00007`000h40000X0003P@0001800Sl:00;o2@000h40000I0003o`0000`0000=0005
o`000?l00P000ol000040003o`0000:12`06o`8000>100006@000h40000F0003P@0000/000?o0000
7`000h40000X0003P@00018000<o80002`02o`L000>100006@000ol0000<00002`04o`8000Co003o
1P000ol0000200:10P07o`P000>100006@000h40000F0003P@0000/000?o00007`000h40000X0003
P@00018000<P?`003@02o`D000>100006@000ol0000<00002`000ol0o`030004o`00o`H000?o0000
1_l00h40000<0003P@0001T000>100005P000h40000;0003o`0001l000>10000:0000h40000B0003
824000l000?o00000P000h40000I0003o`0000`0000;0003o`3o00<000Co003o1P03o`L00X4<0003
P@0001T000>100005P000h40000;0003o`0001l000>10000:0000h40000B00038B0001000_l20003
P@0001T000?o0000300000`00_l400;o2@02o`P00X4:0003P@0001P000>100005`000h40000;0003
o`0001l000>10000:0000h40000B0003824001800_l00h40000I0003o`0000`0000O00?o1`02P@P0
00>1000060000h40000G0003P@0000/000?o00007`000h40000X0003P@0001800R0E00;o6P000ol0
000<00008P02o`L00X460003P@0001P000>100005`000h40000;0003o`0001l000>10000:0000h40
000B00038B0001@000>10?l06@000ol0000<00009002o`L00X440003P@0001P000>100005`000h40
000;0003o`0001l000>10000:0000h40000B0003824001@000>100000_lG0003o`0000`0000V00;o
1`04PA/000>100005`000h40000;0003o`0001l000>10000:0000h40000B008Q5P0018400002oaD0
00?o0000300002P00ol700:16P000h40000G0003P@0000/000?o00007`000h40000X0003P@000180
00<_8B405@000h40000300;o50000ol0000;0000:`02o`D000B1086160000h40000G0003P@0000/0
00?o00007`000h40000X0003P@00018000<Q;bl05@000h40000500;o4P000ol0000;0000;@02o`<0
00B100000X4F0003P@0001L000>100002`000ol0000O0003P@0002P000>100004`028AD000>10000
1`000ol0000?0003o`0000/0000_00;o00<0P@001002PA@000>100005`000h40000;0003o`0001l0
00>10000:0000h40000C0003;b8001@000>100002002o`l000?o00002`0003400ol600:14P000h40
000G0003P@0000/000?o00007`000h40000X0003P@0001<000<R;`0050000h40000:00;o3@000ol0
000;0000=002o`H00h4?0003P@0001L000>100002`000ol0000O0003P@0002P000>100004`028QD0
00>100003002o`/000?o00002`0003H00_l700:13@000h40000G0003P@0000/000?o00007`000h40
000X0003P@0001<000<R7`0050000h40000>0003o`0000P000?o00002`0003P00_l700:12`000h40
000G0003P@0000/000?o00007`000h40000X0003P@0001<00R8E0003P@0000l00_l80003o`0000/0
000j00?o1P02P@T000>100005`000h40000;0003o`0001l000>10000:0000h40000C008R5@000h40
000A00;o1P000ol0000;0000?@02o`H00X470003P@0001L000>100002`000ol0000O0003P@0002P0
00>100004`027aD000>100004`02o`D000?o00002P0003l00_l600>10`000h40000H0003P@0000/0
00?o00007`000h40000X0003P@0001<000<O8P0050000h40000E00;o0h400ol0000:0000@@02o`L0
0X400`21000I0003P@0000/000?o00007`000h40000Y0003P@00018000<R7`0050000h40000?00N1
00D0o`00o`0<0000@`03o`H00X4J0003P@0000/000?o00007`000h40000Y0003P@0001800QlF0003
P@0000L01h4900?o300004H00_l500>160000h40000;0003o`0001l000>10000:@000h40000B008O
5P000h400007P@h01Ol<0000B002o`<000>100000X4F0003P@0000/000?o00007`000h40000Y0003
P@0002D0284>00Oo4@0004X00_l00`21000300:14`000h40000<0003o`0001l000>10000:@000h40
000N00N11@000h40000700Oo600004`00ol500>140000h40000<0003o`0001l000>10000:@000h40
000G00N130000h400007oal0001?00;o1P02P@h000>100002`000ol0000P0003P@0002T000>10000
4007P@h02?lV0000D@02o`H00X4<0003P@0000/000?o000080000h40000Y0003P@0000P0284>00Oo
;P0005<00_l600:12P000h40000;0003o`00020000>10000:@0018400007P@l01ole0000E@03o`D0
0X480003P@0000/000?o000080000h40000V00N13`07oc`0001H00;o1@02P@H000>100002`000ol0
000P0003P@0001l01h430003P@0000P02?m30000FP02o`D00h430003P@0000/000?o000080000h40
000H00N12P0018400007od/0001L00;o1P02P@03084000`000?o000080000h40000@00R13P07oe80
001N00?o1@02P@d000?o000080000h40000900N13`07oeT0001Q00;o1003P@/000?o000080000h40
000200N13`07of00001S00;o0P000h400002P@T000?o00007P07P@h02?mW0000I@02o`03P@000080
0X470003o`0001H028420003P@0000T01om_0000I`03o`@00h440003o`0000l01h4:0003P@000080
1omf0000JP02o`D00X420003o`0000P01h4?00OoO@0006`00_l500:100Co00001h4>00SoQ00006h0
0_l50004oh61P@h01on<0000L003o`8000?o00002007oi<0001c00?o0`07oiX0001e00CoX@000?l0
6`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`0007P0
00?o00009`000ol0001e0000F@04o`<01?l0103oo`02o`800_l400?o0`000ol0000800Go00@0ool0
0_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`@000?o00000`02od`0001H0005
o`000?l00P000ol000030004o`00o`<00_l50003o`0000<000?o00002@001Ol0003o008000Co003o
0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o10000ol0
000300;oC00005P000?o0?l00_l200Go00D0o`00o`0800Co40001Ol0003o008000Co003o0`000ol0
00060003o`0000h000?o00001@000ol000020003o`0000X000?o0000D00005P000?o000010001ol0
003o0?l00P000ol000060003o`3o014000Go0000o`020004o`00o`<000?o00001P000ol0000>00?o
1@000ol000020003o`0000X000?o0000D00005P000Go0000o`0300?o00<0ool00ol80003o`3o0140
00?o00001Ol300Co20000ol0000>0003o`0000@00_l300Co2`000ol0001?0000F@04oaD00_l?00Go
2`000ol0000500;o3`05o`T000?o00002004oe40002B00;o8@000ol000020003o`0005d0003o01/0
0000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.172553, -0.0166081, 0.0021653, \
0.00388695}},
  CellTags->"AntTracker3D - Gen 4"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 0",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \(ifSensor[dust]\)[
          seq[advance, \ turnRight, \ 
            again], \ \n\ \ \ \ \ \ \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.4, Ind.1, Fit.7.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.4, Ind.1, Fit.7.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.44603 .5261 m .41861 .53422 L .40239 .51917 L p
.8 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.47374 .5179 m .44603 .5261 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.40239 .51917 m .42999 .5109 L .44603 .5261 L p
.8 g
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.42999 .5109 m .45788 .50253 L .47374 .5179 L p
.8 g
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .50173 .50961 L .48607 .49408 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.55862 .49278 m .53003 .50124 L .51456 .48554 L p
.8 g
F P
s
P
p
.002 w
.48607 .49408 m .51456 .48554 L .53003 .50124 L p
.8 g
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.58752 .48422 m .55862 .49278 L .54335 .47691 L p
.8 g
F P
s
P
p
.002 w
.51456 .48554 m .54335 .47691 L .55862 .49278 L p
.8 g
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .015 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .015 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.54335 .47691 m .57246 .46819 L .58752 .48422 L p
.8 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .03 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .03 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .015 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .03 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .045 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .06 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .075 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .09 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .105 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .12 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .135 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .15 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .165 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .18 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .195 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .211 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .226 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .241 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .256 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .271 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .286 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .301 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .316 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .331 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .346 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .361 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .376 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .391 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .406 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .421 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .436 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .451 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .466 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .481 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .496 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .511 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .526 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .541 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .556 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .571 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .586 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .602 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .617 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .632 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .647 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .662 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .677 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .692 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .707 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .722 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .737 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .752 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .767 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .782 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .797 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .812 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .827 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .842 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .857 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .872 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .887 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .902 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .917 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .932 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .947 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .962 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .977 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .992 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.992 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.977 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.962 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.947 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.932 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.917 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.902 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.887 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.872 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.857 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.842 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.827 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.812 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.797 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.782 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.767 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.752 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.737 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.722 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.707 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.692 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.677 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.662 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.647 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.632 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.617 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.602 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.586 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.571 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.556 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.541 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.526 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.511 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.496 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.481 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.466 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.451 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.436 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.421 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.406 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.391 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.376 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.361 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.346 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.331 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.316 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.301 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.286 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.271 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.256 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.241 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.226 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.211 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.195 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.18 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.165 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.15 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.135 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.12 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.105 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.09 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.075 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.06 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.045 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.03 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.015 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .015 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .03 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .045 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .06 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .075 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .09 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .105 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .12 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .135 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .15 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .165 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .18 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .195 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .211 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .226 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .241 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .256 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .271 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .286 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .301 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .316 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .331 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .346 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .361 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .376 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .391 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .406 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .421 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .436 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .451 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .466 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .481 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .496 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .511 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .526 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .541 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .556 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .571 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .586 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .602 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .617 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .632 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .647 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .662 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .677 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .692 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .707 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .722 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .737 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .752 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .767 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .782 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .797 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .812 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .827 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .842 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .857 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .872 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .887 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .902 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .917 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .932 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .947 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .962 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .977 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .992 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .992 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .977 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .962 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .947 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .932 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .917 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .902 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .887 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .872 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .857 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .842 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .827 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .812 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .797 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .782 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .767 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .752 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .737 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .722 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .707 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .692 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .677 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .662 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .647 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .632 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .617 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .602 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .586 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .571 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .556 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .541 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .526 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .511 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .496 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .481 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .466 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .451 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .436 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .421 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .406 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .391 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .376 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .361 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .346 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .331 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .316 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .301 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .286 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .271 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .256 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .241 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .226 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .211 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .195 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .18 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .165 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .15 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .135 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .12 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .105 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .09 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .075 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .06 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .045 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .03 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .015 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.015 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.03 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.045 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.06 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.075 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.09 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.105 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.12 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.135 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.15 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.165 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.18 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.195 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.211 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.226 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.241 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.256 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.271 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.286 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.301 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.316 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.331 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.346 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.361 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.376 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.391 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.406 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.421 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.436 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.451 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.466 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.481 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.496 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.511 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.526 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.541 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.556 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.571 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.586 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.602 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.617 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.632 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.647 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.662 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.677 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.692 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.707 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.722 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.737 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.752 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.767 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.782 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.797 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.812 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.827 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.842 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.857 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.872 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.887 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.902 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.917 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.932 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.947 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.962 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.977 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.992 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .992 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .977 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .962 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .947 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .932 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .917 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .902 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .887 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .872 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .857 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .842 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .827 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .812 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .797 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .782 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .767 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .752 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .737 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .722 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .707 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .692 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .677 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .662 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .647 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .632 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .617 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .602 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .586 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .571 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .556 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .541 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .526 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .511 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .496 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .481 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .466 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .451 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .436 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .421 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .406 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .391 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .376 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .361 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .346 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .331 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .316 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .301 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .286 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .271 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .256 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .241 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .226 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .211 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .045 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .015 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .03 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .045 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .06 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .075 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .09 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .105 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .12 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .135 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .15 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .165 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .18 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .195 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .211 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .226 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .241 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .256 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .271 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .286 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .301 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .316 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .331 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .346 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .361 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .376 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .391 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .406 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .421 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .436 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .451 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .466 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .481 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .496 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .511 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .526 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .541 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .556 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .571 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .586 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .602 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .617 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .632 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .647 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .662 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .677 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .692 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .707 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .722 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .737 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .752 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .767 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .782 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .797 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .812 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .827 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .842 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .857 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .872 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .887 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .902 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .917 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .932 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .947 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .962 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .977 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .992 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.992 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.977 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.962 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.947 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.932 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.917 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.902 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.887 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.872 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.857 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.842 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.827 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.812 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.797 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.782 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.767 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.752 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.737 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.722 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.707 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.692 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.677 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.662 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.647 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.632 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.617 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.602 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.586 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.571 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.556 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.541 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.526 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.511 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.496 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.481 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.466 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.451 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.436 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.421 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.406 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.391 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.376 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.361 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.346 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.331 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.316 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.301 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.286 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.271 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.256 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.241 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.226 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.211 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.195 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.18 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.165 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.15 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.135 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.12 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.105 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.09 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.075 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.06 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.045 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.03 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.015 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .015 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .03 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .045 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .06 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .075 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .09 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .105 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .12 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .135 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .15 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .165 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .18 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .195 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .211 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .226 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .241 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .256 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .271 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .286 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .301 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .316 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .331 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .346 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .361 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .376 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .391 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .406 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .421 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .436 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .451 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .466 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .481 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .496 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .511 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .526 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .541 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .556 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .571 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .586 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .602 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .617 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .632 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .647 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .662 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .677 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .692 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .707 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .722 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .737 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .752 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .767 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .782 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .797 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .812 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .827 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .842 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .857 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .872 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .887 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .902 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .917 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .932 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .947 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .962 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .977 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .992 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .992 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .977 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .962 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .947 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .932 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .917 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .902 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .887 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .872 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .857 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .842 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .827 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .812 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .797 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .782 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .767 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .752 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .737 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .722 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .707 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .692 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .677 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .662 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .647 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .632 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .617 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .602 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .586 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .571 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .556 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .541 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .526 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .511 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .496 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .481 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .466 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .451 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .436 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .421 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .406 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .391 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .376 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .361 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .346 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .331 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .316 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .301 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .286 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .271 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .256 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .241 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .226 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .211 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .195 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .18 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .165 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .15 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .135 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .12 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .105 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .09 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .075 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .06 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .045 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .03 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .015 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.015 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.03 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.045 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.06 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.075 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.09 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.105 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.12 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.135 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.15 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.165 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.18 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.195 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.211 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.226 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.241 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.256 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.271 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.286 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.301 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.316 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.331 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.346 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.361 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.376 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.391 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.406 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.421 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.436 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.451 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.466 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.481 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.496 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.511 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.526 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.541 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.556 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.571 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.586 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.602 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.617 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.632 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.647 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.662 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.677 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.692 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.707 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.722 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.737 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.752 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.767 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.782 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.797 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.812 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.827 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.842 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.857 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.872 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.887 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.902 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.917 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.932 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.947 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.962 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.977 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.992 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .992 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .977 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .962 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .947 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .932 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .917 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .902 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .887 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .872 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .857 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .842 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .827 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .812 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .797 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .782 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .767 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .752 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .737 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .722 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .707 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .692 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .677 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .662 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .647 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .632 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .617 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .602 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .586 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .571 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .556 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .541 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .526 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .511 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .496 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .481 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .466 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .451 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .436 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .421 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .406 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .391 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .376 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .361 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .346 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .331 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .316 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .301 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .286 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .271 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .256 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .241 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .226 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .211 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .045 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .06 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .06 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.73942 .45475 m .72426 .4592 L .71734 .45097 L p
1 .195 0 r
F P
s
P
p
.002 w
.73942 .45475 m .72426 .4592 L .71734 .45097 L p
1 .18 0 r
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .075 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.71734 .45097 m .73256 .44648 L .73942 .45475 L p
1 .195 0 r
F P
s
P
p
.002 w
.71734 .45097 m .73256 .44648 L .73942 .45475 L p
1 .18 0 r
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .075 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.76999 .44579 m .75467 .45028 L .74786 .44196 L p
1 .165 0 r
F P
s
P
p
.002 w
.73675 .44005 m .70625 .44907 L .69207 .43233 L p
.8 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .105 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .09 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.74786 .44196 m .76324 .43742 L .76999 .44579 L p
1 .165 0 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .105 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .09 0 r
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .15 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.69207 .43233 m .72279 .42312 L .73675 .44005 L p
.8 g
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .15 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
1 .135 0 r
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
1 .12 0 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
1 .135 0 r
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
1 .12 0 r
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o;k/3o`b100?o^k/01;/01?l00?l50003o`0002X0
000O0003o`0000T000Sobk_;^l^ko`b102Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^kbk_o00b100?oPH400ol05[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/3o`UK00gobk_;^l^kbk_;^l^k00;o2h400on1P@0:P@0_ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10ol^^`?o1e/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0]^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2e/00on1P@06P@?o00V1ok_;^l^kbol0
0P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omKF`04F`?o
0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42obbk1?l2F`03oe]K00YK
00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^kbk_;^l^k
bk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?^l^kbk_;
^l^kbk_;^l_o00J11?l2P@0[ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`MK00?oFe/02U/00on1o`02o`V100So^l^kbk_;o`8000?o00000P000ol0000500?o0`03oaT0
000U0003o`0000T000?o^k/00k/00on1P@03o`R100?o^k/09;/2o`]K00?o^k/07k/3o`:100?o^k/0
2k/00omKF`03F`;o4[/00on1P@03o`N100?o^k/08k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk
00Co003o1@000ol000050003o`0000D000?o00005P0002H000?o00002@001_nkbk_;^`;o3840:?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol6P@0@ol^kbk_;^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0_l;P@0Rok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0U/00omKF`0:F`03oe]K00AK
1?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol000050003o`0000D000?o00005P0002L0
00?o00002@000onk^`04^`03oh6100Z100?o^k/09;/00omKF`0:F`03ok^k01Jk1?l:P@03ok^k00^k
00?o^k/05k/00on1P@0:P@03ok^k01^k0ol6F`03oe]K00YK00?oFe/00ol7F`03oh6100^100?o^k/0
1;/01?l00?l40003o`0000@000?o00000P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`:100?oPH402X40:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b1
01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o2U/00omKF`08F`04oe_oo`]K00?oPH401X43o`09
POnkbk_;^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1
P@0:P@03ok^k02Bk00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k01>k
0ol00e_oF`0;F`03oe]K00AK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003
o`3o00@00_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2X400on1
P@08P@0[oh7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol5F`03oe]K00YK00?oFe/00ol01k_;^l^kbol03E/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000S0000;0000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k02Bk0_lI^`03oh6100V100?oPH401843o`>100?o^k/09K/00on1P@03o`J100?o^k/03;/3o`UK
00?oFe/025/01?mKool:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D000?o00008P0002d0
00?o00002@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N102Kobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X402oo;^l^kbk_;^l^k00?o35/00omKF`04F`Co013;^l^k
bk_;^l^kbk_;^l_o1U/4o`9K00?oPH402X402?o;^l^kbk_o0P000ol000030003o`000240000^0003
o`0000T000?o^k/01;/00on1P@09P@03ok^k03nk00?oPH402H42o`^100?o^k/07[/4o`9K00?oPH40
2X400onk^`04^`?o0U/00omKF`0;F`03oe]K00?o5;/00omKF`03o`MK00?oPH402X400onk^`04^`04
o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH40
2X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@03ol^k00?o1U/00omK
F`0;F`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l;F`03oh6100F10ol02X7o^l^kbk_;^ol20003
o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42od2k00?oPH400ol6P@03oh6100Z1
00?o^k/05k/2o`]K00?oPH4028401?n1ool:F`03oe]K00IK0olE^`Co0U/00omKF`0:F`03oh6100>1
0_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@11ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol035/00on1P@04P@?o0X400omK
F`0:F`03oe]K00=K0_l05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`MK00?oFe/02U/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X400omKF`0:F`03oe_o00;o
4k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol000090006
ok_;^l^k0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038400on1P@03o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`aK0_l:P@03oe]K00QK01KoFoo;^l^kbk_;^l^kbk_;^l^kbk_;0ol2F`03oe]K00YK00?oFe/0
15/4o`03bk_o00f100Oo^l^kbk_o008000?o00000`000ol0000M0000=@000ol000090003ok^k00>k
00?oPH402X400onk^`0m^`03oh6100R100CoPOoo9K/00omKF`04F`?o0[/00on1P@0:P@03oe]K00AK
0ol3F`03ok^k00fk0ol6F`03oe]K00YK00?oFe/00ol7^`03oh6100^100?o^k/00k/01?l00?l40003
o`0001d0000f0003o`0000T000Oo^l^kbk_o00b1037obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co00c;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100?oFe/00ol7F`0=ol^kbk_;
^l^kbk_;^`02o`YK00?oFe/025/04?mKoonkbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l0
0002oah0000g0003o`0000T000?o^k/00k/00on1P@0:P@;o:k/3o`AK00?o^k/02K/00on1P@03o`N1
00?o^k/09;/2o`Zk00?oPH4028401?n1ool;F`03ok^k00Vk00?oFe/02U/00omKF`04F`?o4;/00on1
P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0d
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01;_;
^ol<F`0=ol^kbk_;^l^kbk_;o`0<F`03oe]K00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;
^l^kbol00P000ol000020003o`0001/0000j0003o`0000T000?o^k/00[/00on1P@03o`R100?o^k/0
8[/2o`aK00?o^k/02K/00on1P@0:P@03ok^k032k00?oPH400ol7^`03oe]K00YK00?o^k/02K/00omK
F`08F`04oe_ooaNk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o00002@001Oo;
^l^k00;o38409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0<F`0=ol^kbk_;
^l^kbk_;o`0<P@0cok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;o00bkbk_;^l^kbk_;^ol6F`?o0U/03_nkbk_;^l^kbk_;^l_o1U/3o`9K01_obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038402_nkbk_;^l_o0?l50003o`0001T0000l0003o`0000T000?o^k/0
0k/00on1P@0:P@03ok^k02>k00?oFe/02U/00onk^`09^`03oh6100Z100?o^k/0?K/00omKF`03o`IK
00?o^k/02[/00omKF`03o`IK00?o^k/05k/00on1P@08P@03oh7o00Fk00Co003o10000ol0000I0000
?@000ol000090006ol^kbk_;0_l;P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o00IK0ol2F`0>ok_;^l^kbk_;^l^kbol6P@?o0h40@?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^kbk_;^l^kbk_;00;o
2U/06_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X44o`:100Sobk_;^l^ko`8000Co00000_lJ0000
?P000ol000090003ok^k00Bk00?oPH401843o`:100?o^k/08k/00omKF`03o`IK00?o^k/02[/00on1
P@03o`N100?o^k/0?;/00omKF`09F`03ok^k00Zk00?oFe/02E/00onk^`0G^`03oh6100?o1h400onk
^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;^l^kbk_o0X43o`J102Ko^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2U/03Onkbk_;^l^kbk_;^l/00_l;P@10ok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`]K
00kobk_;^l^kbk_;^l^ko`]K00So^l^kbk_;^`?o00nkbk_;^l^kbk_;^l^kbk/00_l;P@07ol^kbk_;
o`020003o`0000<000?o00005P0004000_l:0003ok^k00Bk0_l:P@03ok^k02>k00?oFe/02E/00onk
^`0:^`03oh6100Z100?o^k/0?;/00omKF`07F`03oe_o00bk00?oFe/01e/00omKo`03^`?o00<OGol0
3k/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000F0000@P000ol0000800;o00Jkbk_;^ol;P@0W
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00]K00ko^l^kbk_;^l^kbk_;o`b1
03oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol01U/3o`9K00ko^l^kbk_;^l^kbk_;o`IK0ol07K_;^l^kbolOGamO7oo;^l^kbk_;^l^kbk_;
^l_o00b100So^l^kbk_;o`8000?o00000P000ol0000E0000@`000ol000090003ok^k00>k00?oPH40
2H400onk^`0S^`03oe]K00UK00?o^k/02[/00on1P@04P@?o0X400onk^`0l^`03oe]K00?o1U/00onk
^`0:^`03oe]K00?o0[/3o`Fk00OoGamOoeoo00nk00?oPH4028400on1o`05^`04o`00o`D000?o0000
500004@000?o00002@001onkbk_;^ol02h42o`0Ubk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ko`06F`?o013;^l^kbk_;^l^kbk_;^l_o0X43o`J103gobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2U/03Onkbk_;^l^kbk_;^l/0
0_l00k_;o`02o`097eoo^l^kbk_;00?o01?;^l^kbk_;^l^kbk_;^l^kbk_o00J11?l2P@08ol^kbk_;
^ol20004o`0000;o5P0004D000?o00002@000onk^`03^`03oh6100B10ol3P@03ok^k02:k00?oFe/0
0olC^`;o2X400onk^`0f^`?o0U/00omKF`0:F`03ok^k00fk00?oGel00el00onk^`09^`;o3[/00on1
P@03o`N100?o^k/01;/01?l00?l40003o`0001<000160003o`0000T000Oo^l^kbk_o00:10ol7P@0T
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol06<^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`^103Gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`03o`IK00?oFe/02U/02?nkbk_;^l^k0ol04k_;^l^koelOGomOok_;^l^kbk/00ol03aOo^l^kbk_;
^l^kbk_;^`04o`^100[obk_;^l^ko`3o0`03oa@000170003o`0000T000?o^k/00k/2o`^100?o^k/0
7K/3o`=K00?o^k/05K/00on1P@09P@03ok^k02jk0ol:F`03oe]K00QK00?oFol00k/3o`=O00?o^k/0
0k/3o`Vk00OoGamO7eoo00Vk0ol2P@03oh6100^100?o^k/00k/00ol00003o`8000?o00004P0004P0
0_l:0008ok_;^l^kbol;P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1e/06Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol02h42o`0[^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`03o`9K00?oFe/02E/00omKF`04F`?o01Rkbk_;^l_o7elOGamOok_;^l^kbk_;^l/2o`0A
^l^kbolO5alG7aOo^l^kbk/00ol6P@03oh6100^100Kobk_;^l/2o`030?l0008000?o00004P0004X0
00?o00002002o`Fk00?oPH402H400onk^`0D^`Co2e/00onk^`0E^`03oh6100B10ol3P@03ok^k02Fk
0ol6F`03oe]K00UK00?oFe/00ol2^`?o1K/00omOo`02o`Vk0ol00aoo^`04^`03oaoo00;o0k/4o`Z1
00?oPH401844o`Vk00?o0?l00`000ol0000B0000B`000ol000090007ol^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol3F`03oe]K00YK01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:1
0ol7P@0Sok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l:F`03oe]K00MK00KoFooo
^l/3o`0U7elOol^kbk_;ol^kbk_;^l^kbk_;oamO7elOol^kbk_;ol^kb`03o`:100?oPH402X400on1
P@03o`08^l^kbk_;^l/3o`D000Co003o500004`000?o00002@000onk^`03^`03oh6100?o1X400onk
^`0<^`?o1e/00omKF`0:F`03ok^k01Fk0_l;P@03ok^k01bk0ol2F`03oe]K00YK00CoFe]K1Ol6^`08
oaMO5elGGol:^`;o1K/01olOGamO7ol01K/3o`J100?oPH402X42o`Nk1?l90004o`00oa<0001=0003
o`0000T000Kobk_;^l/2o`Z100cobk_;^l^kbk_;^l/2o`]K00?oFe/015/3o`0Lbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`b101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol6F`03oe]K00YK
0ol03/^kbk_;^l^kbk_;^omO0ol02K_;^l^kbk_;^`03o`087onkbk_;^l/3o`04bk_;^`Co2X400on1
P@04P@?o00S;^l^kbk_;^`?o3P000ol0o`0C0000CP000ol000090003ok^k00>k00?oPH402H400onk
^`0:^`03oe]K00UK00?oFe/00olO^`03oh6100Z100?o^k/05K/2o`YK00?oFe/015/3oa:k00?o^k/0
2K/01omO7elOGol01k/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;
^l^kbol02h403_o;^l^kbk_;^l^kbk_o2e/2o`0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o1X43o`:101[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`]K00?oFe/00ol06l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02o`06^l^kbk_o1Al00onko`04o`R100?oPH402X42o`07bk_;^l^k
b`03oaH00_lC0000D@000ol000080003ok^k00>k00?oPH402H42o`^k00?oFe/015/3obNk00?oPH40
0ol6P@03ok^k01Jk00?oFe/02E/2oa^k0ol00aoo^`05^`?o00Bkoooo0X400on1P@09P@03oh6100B1
0ol7^`Co6003oa<0001B0003o`0000P00_l01K_;^l_o00J10ol3P@0=ok_;^l^kbk_;^l^ko`02F`?o
02_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X402oo;^l^kbk_;
^l^k00;o00g;^l^kbk_;^l^kbk_o00IK0ol0:/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;oamO
7elOol^kbk_;^`?o1X400on1P@09P@03oh6100?o00Nkbk_;^l^k00?o6@03oaH0001C0003o`0000T0
00?o^k/00[/00on1P@03o`N100?o^k/02K/2objk00?oPH402X400onk^`04^`?o0U/00onk^`0:^`03
oe]K00?o6K/3o`Fk00?o7al00al00onko`03o`Z100?oPH401h401?n1ool6^`Co6004oaT0001D0003
o`0000T000Go^l^kb`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00b100?obk/00ol6F`0=ol^kbk_;^l^kbk_;^`02o`0Ibk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1P@09P@03oh6100B1
0ol01l^kbk_;^l/00olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V100?o^k/0>K/00on1
P@08P@04oh7oo`YK00?o^k/09K/00olO7`037`03ok^k00>k0ol6P@03oh6100V100?oPH400ol6^`Co
6004ob00001F0003o`0000T000Oo^l^kbk_o00^10_l0>l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol3F`03oe]K00UK023obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo7`05o`Z100?oPH401h402_n1ooo;^l^k
bk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03oh6100?o1e/00omK
F`09F`03ok^k01Vk0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T0
00?o000020001onkbk_;^ol00X43o`N103Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l;F`03oe]K00AK0ol07[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`HO00Gobk_;^`03o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X0
00?o000020000onk^`03^`;o2h400onk^`0`^`Go0e/00omKF`0:F`03oe]K00?o6K/3o`Fk00?o7ol0
0_l3^`?o2X400on1P@07P@04oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h40<?o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o2E/00omKF`0:F`;o
01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1
PH45o`06bk_;^l^k0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/04[/4oaNk
00?oFe/025/00omKF`04F`?o0h400onk^`0G^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk
1?lH00?o=P0005d000?o00002@001oo;^l^kbol01X43o`:100oobk_;^l^kbk_;^l^kbk/01Ol4F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0:F`03oe]K00?o1h407?o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;ob<3o`03bk_;00Co2X400on1P@04P@?o00Rkbk_;^l^kb`?o6004ocT0001N0003o`0000T0
00?o^k/00k/00on1P@03o`J100?o^k/02K/2o`YK00?o^k/02;/2o`^k00?oFe/01U/01?mKool;P@03
ok^k01Nk00Co^k^k0ol2P@03oh6100Z100?oPH400ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o
2X403Oo;^l^kbk_;^l^kbol02e/01oo;^l^kbk/00ol2F`0=ol^kbk_;^l^kbk_;o`02F`Go00Bkbk_o
38406_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co
@000064000?o000020000onk^`03^`03oh6100V100?o^k/02K/00omKF`09F`03ok^k00?o1U/00onk
^`09^`;o2K/00on1P@0:P@03ok^k01:k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P0
00Oobk_;^l_o00^10_l02k_;^l^kbk_;^l_o00]K0_l:F`0Hol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`:1013o^l^kbk_;^l^kbk_;^l^k1Ol3P@03oh6100V100?oPH400ol01l^kbk_;^l/00olH00Co
A`0006<000?o00002002o`Bk00?oPH401843o`>100?o^k/02;/00omKF`04F`?o0U/00omKF`09F`03
ok^k01Bk00?oPH400ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T0
00Ko^l^kbol2P@?o1h403?nkbk_;^l^kbk_;o`9K0ol6F`03oe]K00UK01Oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`02o`Z100Oo^l^kbk_;00?o0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0
001U0003o`0000T000?o^k/00[/2o`^100?o^k/02;/2o`YK00?oFe/015/3oaVk00?oPH402H400onk
^`03o`J100?oPH402H400on1P@03o`Fk1?lG00CoDP0006H000?o00002@001onkbk_;^ol02h403Onk
bk_;^l^kbk_;^ol02U/00omKF`03o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2h42o`Z1
00?oPH401h402?n1ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k00?oPH402H400onk^`09^`03
oe]K00QK0_lQ^`03oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0001Y0003o`0000P0
00Oo^l^kbk_o00J10ol2P@0=ok_;^l^kbk_;^l^ko`02F`Go02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?oG@0006X000?o0000
20000onk^`03^`03oh6100?o1X400onk^`09^`;o:[/4o`Z100?oPH401843o`Nk0olH00CoH00006/0
00?o00002002o`04bk_;^`;o2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k1Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T0
00?o^k/00[/00on1P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T0
00Kobk_;^ol;P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03
oh6100V100?oPH401Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03
ok^k02>k0ol6P@03oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL0
1?mb0000L@000ol000080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o
6003ogH0001b0003o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402H42o`06^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o
0X400on1P@08P@03oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onk
bk_;^l^kbk_;^l^kb`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o0000
2@000onk^`02^`;o2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007
ok_;^l^ko`09P@07ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P0
00?o000020000onk^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003
o`0000P000Oo^l^kbk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol0
00080003ok^k00>k00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P0
00Ko^l^kbk/2o`V100?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH40
28400on1P@05o`Jk0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?o
W@0007h00_l:0003ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh40
0ol01[_;^l^kb`Co5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003
o`0000P000Oobk_;^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o0000
1`03oaL00onb0000Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT000280003
o`0000<000?o00003004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0
o`0400Coa`0008`00_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0002B0003o`0002L000?o0000WP0007<0
1?l300Co00@0ool00_l200;o1003o`<000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003
o`0000L00ol400Go0P03o`<00_l40003o`0000<00_me0000LP001Ol0003o008000?o00000`001?l0
0?l300;o1@000ol000030003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003o`0000@0
00?o00001`000ol000050003o`00008000Co003o0P02o`@000?o00000`02ogD0001b0003o`3o00;o
0P05o`050?l00?l02004oa0000Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D0
00?o00000P000ol0000:0003o`0007T0001b0003o`0000@000Oo0000o`3o008000?o00001P000ol0
o`0A0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0000:0003
o`0007T0001b0005o`000?l00`03o`030?oo00?o20000ol0o`0A0003o`0000Go0`04o`P000?o0000
3P000ol0000400;o0`04o`/000?o0000N00007<01?lE00;o3`05o`/000?o00001@02o`l01Ol90003
o`0000P01?mj0000[002ob4000?o00000P000ol000260000o`1N0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 4"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 0",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 5", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.359276 1.73825 0.004203 0.971509 [
[(Gen.5, Ind.1, Fit.12.)] .5 1 0 -1.5 Msboxa
[(5)] .22208 .10062 .837 1 Msboxa
[(10)] .37129 .06817 .79276 1 Msboxa
[(15)] .52449 .03486 .74852 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Msboxa
P
[(5)] .7152 .06936 -1 .37828 Msboxa
[(10)] .7916 .12855 -1 .36695 Msboxa
[(15)] .86445 .18501 -1 .35627 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88608 .10179 -1 .36805 Msboxa
P
[(0)] .09796 .15325 1 -0.38573 Msboxa
[(10)] .08166 .2985 1 -0.36305 Msboxa
[(20)] .06397 .45624 1 -0.33834 Msboxa
[(30)] .04469 .62815 1 -0.31133 Msboxa
[(40)] .02361 .81623 1 -0.28167 Msboxa
[(t)] -0.03846 .47163 1 -0.33899 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.5, Ind.1, Fit.12.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11976 .13514 m
.63111 .02429 L
s
P
p
.002 w
.23603 .10993 m
.243 .11459 L
s
P
[(5)] .22208 .10062 .837 1 Mshowa
p
.002 w
.38479 .07768 m
.39154 .08244 L
s
P
[(10)] .37129 .06817 .79276 1 Mshowa
p
.002 w
.53751 .04458 m
.54402 .04944 L
s
P
[(15)] .52449 .03486 .74852 1 Mshowa
p
.001 w
.26547 .10355 m
.26963 .10636 L
s
P
p
.001 w
.29507 .09713 m
.2992 .09995 L
s
P
p
.001 w
.32482 .09069 m
.32892 .09352 L
s
P
p
.001 w
.35472 .0842 m
.3588 .08704 L
s
P
p
.001 w
.41501 .07113 m
.41903 .074 L
s
P
p
.001 w
.44539 .06455 m
.44939 .06743 L
s
P
p
.001 w
.47594 .05793 m
.4799 .06082 L
s
P
p
.001 w
.50664 .05127 m
.51058 .05417 L
s
P
p
.001 w
.20673 .11628 m
.21094 .11906 L
s
P
p
.001 w
.17759 .1226 m
.18183 .12537 L
s
P
p
.001 w
.1486 .12888 m
.15286 .13164 L
s
P
p
.001 w
.56854 .03785 m
.57242 .04078 L
s
P
p
.001 w
.59974 .03109 m
.60359 .03403 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Mshowa
P
P
p
p
.002 w
.63111 .02429 m
.88606 .22165 L
s
P
p
.002 w
.69488 .07366 m
.68472 .07581 L
s
P
[(5)] .7152 .06936 -1 .37828 Mshowa
p
.002 w
.7712 .13274 m
.761 .13483 L
s
P
[(10)] .7916 .12855 -1 .36695 Mshowa
p
.002 w
.84399 .18908 m
.83375 .19112 L
s
P
[(15)] .86445 .18501 -1 .35627 Mshowa
p
.001 w
.71044 .0857 m
.70434 .08698 L
s
P
p
.001 w
.72585 .09763 m
.71974 .0989 L
s
P
p
.001 w
.74111 .10944 m
.735 .11071 L
s
P
p
.001 w
.75623 .12115 m
.75011 .12241 L
s
P
p
.001 w
.78603 .14422 m
.77991 .14547 L
s
P
p
.001 w
.80072 .15559 m
.7946 .15683 L
s
P
p
.001 w
.81528 .16686 m
.80915 .16809 L
s
P
p
.001 w
.8297 .17802 m
.82356 .17925 L
s
P
p
.001 w
.67917 .0615 m
.67308 .06279 L
s
P
p
.001 w
.66331 .04921 m
.65722 .05052 L
s
P
p
.001 w
.64729 .03681 m
.6412 .03812 L
s
P
p
.001 w
.85814 .20004 m
.852 .20126 L
s
P
p
.001 w
.87216 .2109 m
.86602 .21211 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .88608 .10179 -1 .36805 Mshowa
P
P
p
p
.002 w
.11976 .13514 m
.04346 .82258 L
s
P
p
.002 w
.11823 .14888 m
.12837 .1467 L
s
P
[(0)] .09796 .15325 1 -0.38573 Mshowa
p
.002 w
.10209 .29436 m
.1123 .29229 L
s
P
[(10)] .08166 .2985 1 -0.36305 Mshowa
p
.002 w
.08455 .45235 m
.09484 .4504 L
s
P
[(20)] .06397 .45624 1 -0.33834 Mshowa
p
.002 w
.06544 .62454 m
.07581 .62274 L
s
P
[(30)] .04469 .62815 1 -0.31133 Mshowa
p
.002 w
.04453 .81294 m
.05498 .81129 L
s
P
[(40)] .02361 .81623 1 -0.28167 Mshowa
p
.001 w
.11511 .17705 m
.1212 .17575 L
s
P
p
.001 w
.11193 .20567 m
.11803 .20438 L
s
P
p
.001 w
.1087 .23475 m
.11481 .23348 L
s
P
p
.001 w
.10542 .26431 m
.11154 .26305 L
s
P
p
.001 w
.0987 .32491 m
.10483 .32368 L
s
P
p
.001 w
.09525 .35597 m
.10139 .35475 L
s
P
p
.001 w
.09174 .38755 m
.0979 .38635 L
s
P
p
.001 w
.08818 .41967 m
.09434 .41849 L
s
P
p
.001 w
.08086 .48559 m
.08704 .48444 L
s
P
p
.001 w
.07711 .51942 m
.0833 .51828 L
s
P
p
.001 w
.07329 .55384 m
.07949 .55272 L
s
P
p
.001 w
.0694 .58888 m
.07561 .58777 L
s
P
p
.001 w
.06141 .66085 m
.06764 .65979 L
s
P
p
.001 w
.0573 .69783 m
.06355 .69678 L
s
P
p
.001 w
.05312 .73549 m
.05938 .73446 L
s
P
p
.001 w
.04886 .77385 m
.05513 .77284 L
s
P
[(t)] -0.03846 .47163 1 -0.33899 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11823 .14888 m
.40213 .32966 L
s
P
p
.4 g
.002 w
.10209 .29436 m
.39803 .47072 L
s
P
p
.4 g
.002 w
.08455 .45235 m
.39361 .62294 L
s
P
p
.4 g
.002 w
.06544 .62454 m
.38882 .7877 L
s
P
p
.4 g
.002 w
.04453 .81294 m
.38363 .9666 L
s
P
p
.4 g
.002 w
.19031 .18033 m
.12919 .8612 L
s
P
p
.4 g
.002 w
.27489 .23452 m
.23116 .90714 L
s
P
p
.4 g
.002 w
.35572 .2863 m
.32778 .95067 L
s
P
.002 w
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.38336 .97571 L
s
.38336 .97571 m
.40251 .31629 L
s
.40251 .31629 m
.11976 .13514 L
s
.63111 .02429 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.63111 .02429 m
.11976 .13514 L
s
p
.4 g
.51275 .29471 m
.51327 .95771 L
s
P
p
.4 g
.65354 .26716 m
.67985 .93462 L
s
P
p
.4 g
.7978 .23893 m
.85127 .91086 L
s
P
p
.4 g
.40213 .32966 m
.88748 .23523 L
s
P
p
.4 g
.39803 .47072 m
.90247 .37874 L
s
P
p
.4 g
.39361 .62294 m
.91871 .53411 L
s
P
p
.4 g
.38882 .7877 m
.93634 .70288 L
s
P
p
.4 g
.38363 .9666 m
.95556 .88687 L
s
P
.40251 .31629 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.38336 .97571 L
s
.38336 .97571 m
.40251 .31629 L
s
p
.4 g
.23603 .10993 m
.51275 .29471 L
s
P
p
.4 g
.38479 .07768 m
.65354 .26716 L
s
P
p
.4 g
.53751 .04458 m
.7978 .23893 L
s
P
p
.4 g
.19031 .18033 m
.69488 .07366 L
s
P
p
.4 g
.27489 .23452 m
.7712 .13274 L
s
P
p
.4 g
.35572 .2863 m
.84399 .18908 L
s
P
P
p
.002 w
.40812 .32205 m .41584 .32699 L .40213 .32966 L p
.4 g
F P
s
P
p
.002 w
.40213 .32966 m .39438 .32473 L .40812 .32205 L p
.4 g
F P
s
P
p
.002 w
.88748 .23523 m .40213 .32966 L .11823 .14888 L p
.9 g
F P
s
P
p
.002 w
.42959 .32431 m .41584 .32699 L p
.40812 .32205 L .4 g
F P
s
P
p
.002 w
.40812 .32205 m .39438 .32473 L .38661 .31977 L p
.4 g
F P
s
P
p
.002 w
.43569 .31667 m .44336 .32163 L .42959 .32431 L p
.4 g
F P
s
P
p
.002 w
.40812 .32205 m .43569 .31667 L p
.42959 .32431 L .4 g
F P
s
P
p
.002 w
.38661 .31977 m .3788 .3148 L p
.40812 .32205 L .4 g
F P
s
P
p
.002 w
.3788 .3148 m .39257 .3121 L .40812 .32205 L p
.4 g
F P
s
P
p
.002 w
.45718 .31895 m .44336 .32163 L p
.43569 .31667 L .4 g
F P
s
P
p
.002 w
.46339 .31126 m .47102 .31625 L .45718 .31895 L p
.4 g
F P
s
P
p
.002 w
.43569 .31667 m .46339 .31126 L p
.45718 .31895 L .4 g
F P
s
P
p
.002 w
.4849 .31355 m .47102 .31625 L p
.46339 .31126 L .4 g
F P
s
P
p
.002 w
.39257 .3121 m .3788 .3148 L .37095 .3098 L p
.4 g
F P
s
P
p
.002 w
.49122 .30583 m .49881 .31085 L .4849 .31355 L p
.4 g
F P
s
P
p
.002 w
.46339 .31126 m .49122 .30583 L p
.4849 .31355 L .4 g
F P
s
P
p
.002 w
.37095 .3098 m .36307 .30479 L p
.39257 .3121 L .4 g
F P
s
P
p
.002 w
.36307 .30479 m .37689 .30206 L .39257 .3121 L p
.4 g
F P
s
P
p
.002 w
.51276 .30813 m .49881 .31085 L p
.49122 .30583 L .4 g
F P
s
P
p
.002 w
.51919 .30038 m .52674 .30541 L .51276 .30813 L p
.4 g
F P
s
P
p
.002 w
.49122 .30583 m .51919 .30038 L p
.51276 .30813 L .4 g
F P
s
P
p
.002 w
.54075 .30269 m .52674 .30541 L p
.51919 .30038 L .4 g
F P
s
P
p
.002 w
.37689 .30206 m .36307 .30479 L .35515 .29975 L p
.4 g
F P
s
P
p
.002 w
.54729 .29489 m .55479 .29996 L .54075 .30269 L p
.4 g
F P
s
P
p
.002 w
.51919 .30038 m .54729 .29489 L p
.54075 .30269 L .4 g
F P
s
P
p
.002 w
.35515 .29975 m .3472 .29468 L p
.37689 .30206 L .4 g
F P
s
P
p
.002 w
.3472 .29468 m .36106 .29193 L .37689 .30206 L p
.4 g
F P
s
P
p
.002 w
.56887 .29722 m .55479 .29996 L p
.54729 .29489 L .4 g
F P
s
P
p
.002 w
.57553 .28938 m .58299 .29447 L .56887 .29722 L p
.4 g
F P
s
P
p
.002 w
.54729 .29489 m .57553 .28938 L p
.56887 .29722 L .4 g
F P
s
P
p
.002 w
.4325 .29108 m .40463 .29658 L .38889 .28641 L p
.8 g
F P
s
P
p
.002 w
.57553 .28938 m .54729 .29489 L .53218 .2847 L p
.4 g
F P
s
P
p
.002 w
.36106 .29193 m .3472 .29468 L .33921 .2896 L p
.4 g
F P
s
P
p
.002 w
.59714 .29172 m .58299 .29447 L p
.57553 .28938 L .4 g
F P
s
P
p
.002 w
.33921 .2896 m .33119 .28449 L p
.36106 .29193 L .4 g
F P
s
P
p
.002 w
.33119 .28449 m .3451 .28171 L .36106 .29193 L p
.4 g
F P
s
P
p
.002 w
.60391 .28385 m .61132 .28896 L .59714 .29172 L p
.4 g
F P
s
P
p
.002 w
.57553 .28938 m .60391 .28385 L p
.59714 .29172 L .4 g
F P
s
P
p
.002 w
.46051 .28555 m .4325 .29108 L .41685 .28085 L p
.8 g
F P
s
P
p
.002 w
.38889 .28641 m .41685 .28085 L .4325 .29108 L p
.8 g
F P
s
P
p
.002 w
.53218 .2847 m .56051 .27914 L .57553 .28938 L p
.4 g
F P
s
P
p
.002 w
.62554 .28619 m .61132 .28896 L p
.60391 .28385 L .4 g
F P
s
P
p
.002 w
.41685 .28085 m .38889 .28641 L .37301 .27614 L p
.8 g
F P
s
P
p
.002 w
.63242 .27828 m .63979 .28342 L .62554 .28619 L p
.4 g
F P
s
P
p
.002 w
.60391 .28385 m .63242 .27828 L p
.62554 .28619 L .4 g
F P
s
P
p
.002 w
.41685 .28085 m .44494 .27528 L .46051 .28555 L p
.8 g
F P
s
P
p
.002 w
.56051 .27914 m .53218 .2847 L .51693 .27442 L p
.4 g
F P
s
P
p
.002 w
.3451 .28171 m .33119 .28449 L .32313 .27936 L p
.4 g
F P
s
P
p
.002 w
.65408 .28064 m .63979 .28342 L p
.63242 .27828 L .4 g
F P
s
P
p
.002 w
.32313 .27936 m .31504 .2742 L p
.3451 .28171 L .4 g
F P
s
P
p
.002 w
.31504 .2742 m .32899 .2714 L .3451 .28171 L p
.4 g
F P
s
P
p
.002 w
.37301 .27614 m .40105 .27054 L .41685 .28085 L p
.8 g
F P
s
P
p
.002 w
.66107 .27269 m .6684 .27785 L .65408 .28064 L p
.4 g
F P
s
P
p
.002 w
.63242 .27828 m .66107 .27269 L p
.65408 .28064 L .4 g
F P
s
P
p
.002 w
.51693 .27442 m .48865 .28 L .47318 .26967 L p
.8 g
F P
s
P
p
.002 w
.51693 .27442 m .54535 .26881 L .56051 .27914 L p
.4 g
F P
s
P
p
.002 w
.68275 .27506 m .6684 .27785 L p
.66107 .27269 L .4 g
F P
s
P
p
.002 w
.68987 .26708 m .69714 .27226 L .68275 .27506 L p
.4 g
F P
s
P
p
.002 w
.66107 .27269 m .68987 .26708 L p
.68275 .27506 L .4 g
F P
s
P
p
.002 w
.54535 .26881 m .51693 .27442 L .50155 .26404 L p
.8 g
F P
s
P
p
.002 w
.47318 .26967 m .50155 .26404 L .51693 .27442 L p
.8 g
F P
s
P
p
.002 w
.32899 .2714 m .31504 .2742 L .30691 .26902 L p
.4 g
F P
s
P
p
.002 w
.68987 .26708 m .66107 .27269 L .64633 .2623 L p
.8 g
F P
s
P
p
.002 w
.71157 .26946 m .69714 .27226 L p
.68987 .26708 L .4 g
F P
s
P
p
.002 w
.30691 .26902 m .29874 .26382 L p
.32899 .2714 L .4 g
F P
s
P
p
.002 w
.29874 .26382 m .31273 .26099 L .32899 .2714 L p
.4 g
F P
s
P
p
.002 w
.7188 .26143 m .72603 .26664 L .71157 .26946 L p
.4 g
F P
s
P
p
.002 w
.68987 .26708 m .7188 .26143 L p
.71157 .26946 L .4 g
F P
s
P
p
.002 w
.57391 .26317 m .54535 .26881 L .53006 .25838 L p
.8 g
F P
s
P
p
.002 w
.50155 .26404 m .53006 .25838 L .54535 .26881 L p
.8 g
F P
s
P
p
.002 w
.7188 .26143 m .68987 .26708 L .67522 .25663 L p
.8 g
F P
s
P
p
.002 w
.64633 .2623 m .67522 .25663 L .68987 .26708 L p
.8 g
F P
s
P
p
1 .015 0 r
.01 w
.63935 .27032 m
.66812 .26469 L
s
P
p
.002 w
.74053 .26382 m .72603 .26664 L p
.7188 .26143 L .4 g
F P
s
P
p
.002 w
.53006 .25838 m .50155 .26404 L .48602 .25357 L p
.4 g
F P
s
P
p
.002 w
.74788 .25576 m .75506 .26099 L .74053 .26382 L p
.4 g
F P
s
P
p
.002 w
.7188 .26143 m .74788 .25576 L p
.74053 .26382 L .4 g
F P
s
P
p
.002 w
.31273 .26099 m .29874 .26382 L .29053 .2586 L p
.4 g
F P
s
P
p
.002 w
.53006 .25838 m .55871 .25269 L .57391 .26317 L p
.8 g
F P
s
P
p
.002 w
.74788 .25576 m .7188 .26143 L .70425 .25093 L p
.8 g
F P
s
P
p
.002 w
.67522 .25663 m .70425 .25093 L .7188 .26143 L p
.8 g
F P
s
P
p
1 .03 0 r
.01 w
.66818 .26606 m
.69711 .26041 L
s
P
p
.002 w
.76963 .25816 m .75506 .26099 L p
.74788 .25576 L .4 g
F P
s
P
p
.002 w
.29053 .2586 m .28229 .25335 L p
.31273 .26099 L .4 g
F P
s
P
p
.002 w
.28229 .25335 m .29632 .25049 L .31273 .26099 L p
.4 g
F P
s
P
p
.002 w
.48602 .25357 m .51463 .24785 L .53006 .25838 L p
.4 g
F P
s
P
p
.002 w
.7771 .25006 m .78423 .25532 L .76963 .25816 L p
.4 g
F P
s
P
p
.002 w
.74788 .25576 m .7771 .25006 L p
.76963 .25816 L .4 g
F P
s
P
p
.002 w
.63145 .25181 m .60261 .2575 L .5875 .24697 L p
.8 g
F P
s
P
p
1 .045 0 r
.01 w
.69718 .26179 m
.72625 .2561 L
s
P
p
.002 w
.7771 .25006 m .74788 .25576 L .73343 .24521 L p
.8 g
F P
s
P
p
.002 w
.70425 .25093 m .73343 .24521 L .74788 .25576 L p
.8 g
F P
s
P
p
.002 w
.79888 .25247 m .78423 .25532 L p
.7771 .25006 L .4 g
F P
s
P
p
.002 w
.36904 .24962 m .34081 .25532 L .3245 .24477 L p
.8 g
F P
s
P
p
.002 w
.51463 .24785 m .48602 .25357 L .47036 .243 L p
.4 g
F P
s
P
p
.002 w
.29632 .25049 m .28229 .25335 L .27401 .24807 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .81355 .24962 L .79888 .25247 L p
.4 g
F P
s
P
p
.002 w
.7771 .25006 m .80647 .24433 L p
.79888 .25247 L .4 g
F P
s
P
p
.002 w
.66044 .24609 m .63145 .25181 L .61644 .24123 L p
.8 g
F P
s
P
p
.002 w
.5875 .24697 m .61644 .24123 L .63145 .25181 L p
.8 g
F P
s
P
p
1 .06 0 r
.01 w
.72634 .25748 m
.72634 .25748 L
s
P
p
.002 w
.27401 .24807 m .26569 .24278 L p
.29632 .25049 L .4 g
F P
s
P
p
.002 w
.26569 .24278 m .27977 .2399 L .29632 .25049 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .7771 .25006 L .76275 .23946 L p
.8 g
F P
s
P
p
.002 w
.73343 .24521 m .76275 .23946 L .7771 .25006 L p
.8 g
F P
s
P
p
1 .076 0 r
.01 w
.71183 .2483 m
.72642 .25886 L
s
P
p
.002 w
.82826 .24675 m .81355 .24962 L p
.80647 .24433 L .4 g
F P
s
P
p
.002 w
.3974 .24388 m .36904 .24962 L .35281 .23901 L p
.8 g
F P
s
P
p
.002 w
.3245 .24477 m .35281 .23901 L .36904 .24962 L p
.8 g
F P
s
P
p
.002 w
.47036 .243 m .49905 .23723 L .51463 .24785 L p
.4 g
F P
s
P
p
.002 w
.83598 .23857 m .84301 .24388 L .82826 .24675 L p
.4 g
F P
s
P
p
.002 w
.80647 .24433 m .83598 .23857 L p
.82826 .24675 L .4 g
F P
s
P
p
.002 w
.68956 .24034 m .66044 .24609 L .64552 .23546 L p
.8 g
F P
s
P
p
.002 w
.61644 .24123 m .64552 .23546 L .66044 .24609 L p
.8 g
F P
s
P
p
.002 w
.76275 .23946 m .79221 .23367 L .80647 .24433 L p
.8 g
F P
s
P
p
.002 w
.8578 .24101 m .84301 .24388 L p
.83598 .23857 L .4 g
F P
s
P
p
.002 w
.35281 .23901 m .38126 .23323 L .3974 .24388 L p
.8 g
F P
s
P
p
.002 w
.49905 .23723 m .47036 .243 L .45455 .23233 L p
.4 g
F P
s
P
p
.002 w
.27977 .2399 m .26569 .24278 L .25734 .23746 L p
.4 g
F P
s
P
p
.002 w
.86564 .23278 m .87262 .23812 L .8578 .24101 L p
.4 g
F P
s
P
p
.002 w
.83598 .23857 m .86564 .23278 L p
.8578 .24101 L .4 g
F P
s
P
p
.002 w
.71884 .23456 m .68956 .24034 L .67474 .22965 L p
.8 g
F P
s
P
p
.002 w
.64552 .23546 m .67474 .22965 L .68956 .24034 L p
.8 g
F P
s
P
p
.002 w
.25734 .23746 m .24894 .23211 L p
.27977 .2399 L .4 g
F P
s
P
p
.002 w
.24894 .23211 m .26306 .22921 L .27977 .2399 L p
.4 g
F P
s
P
p
.002 w
.79221 .23367 m .76275 .23946 L .74825 .22876 L p
.8 g
F P
s
P
p
1 .091 0 r
.01 w
.69717 .23903 m
.7119 .24968 L
s
P
p
.002 w
.88748 .23523 m .87262 .23812 L p
.86564 .23278 L .4 g
F P
s
P
p
.002 w
.45455 .23233 m .48333 .22652 L .49905 .23723 L p
.4 g
F P
s
P
p
.002 w
.86564 .23278 m .88053 .22988 L .88748 .23523 L p
.4 g
F P
s
P
p
.002 w
.11823 .14888 m .6316 .03821 L .88748 .23523 L p
.9 g
F P
s
P
p
.002 w
.67474 .22965 m .70411 .22382 L .71884 .23456 L p
.8 g
F P
s
P
p
.002 w
.74825 .22876 m .77782 .22292 L .79221 .23367 L p
.8 g
F P
s
P
p
.002 w
.40985 .22741 m .38126 .23323 L .36497 .22247 L p
.8 g
F P
s
P
p
.002 w
.88053 .22988 m .86564 .23278 L p
.85158 .22202 L .4 g
F P
s
P
p
.002 w
.48333 .22652 m .45455 .23233 L .43859 .22157 L p
.4 g
F P
s
P
p
.002 w
.26306 .22921 m .24894 .23211 L .24051 .22674 L p
.4 g
F P
s
P
p
.002 w
.87354 .2245 m .88053 .22988 L p
.85158 .22202 L .4 g
F P
s
P
p
.002 w
.70411 .22382 m .67474 .22965 L .65979 .21887 L p
.8 g
F P
s
P
p
.002 w
.24051 .22674 m .23204 .22135 L p
.26306 .22921 L .4 g
F P
s
P
p
.002 w
.23204 .22135 m .2462 .21841 L .26306 .22921 L p
.4 g
F P
s
P
p
.002 w
.77782 .22292 m .74825 .22876 L .73363 .21796 L p
.8 g
F P
s
P
p
.002 w
.36497 .22247 m .39366 .21661 L .40985 .22741 L p
.8 g
F P
s
P
p
1 .106 0 r
.01 w
.68237 .22966 m
.69724 .24042 L
s
P
p
.002 w
.43859 .22157 m .46747 .2157 L .48333 .22652 L p
.4 g
F P
s
P
p
.002 w
.85158 .22202 m .86652 .21909 L .87354 .2245 L p
.4 g
F P
s
P
p
.002 w
.65979 .21887 m .68925 .21298 L .70411 .22382 L p
.8 g
F P
s
P
p
.002 w
.73363 .21796 m .7633 .21207 L .77782 .22292 L p
.8 g
F P
s
P
p
.002 w
.39366 .21661 m .36497 .22247 L .34853 .21162 L p
.8 g
F P
s
P
p
.002 w
.86652 .21909 m .85158 .22202 L p
.83739 .21116 L .4 g
F P
s
P
p
.002 w
.46747 .2157 m .43859 .22157 L .42249 .21071 L p
.4 g
F P
s
P
p
.002 w
.2462 .21841 m .23204 .22135 L .22352 .21593 L p
.4 g
F P
s
P
p
1 .136 0 r
.01 w
.65307 .23828 m
.6825 .23245 L
s
P
p
1 .151 0 r
.01 w
.65312 .23967 m
.65312 .23967 L
s
P
p
.002 w
.85947 .21366 m .86652 .21909 L p
.83739 .21116 L .4 g
F P
s
P
p
.002 w
.68925 .21298 m .65979 .21887 L .64469 .20798 L p
.8 g
F P
s
P
p
.002 w
.22352 .21593 m .21497 .21048 L p
.2462 .21841 L .4 g
F P
s
P
p
.002 w
.21497 .21048 m .22918 .20752 L .2462 .21841 L p
.4 g
F P
s
P
p
1 .166 0 r
.01 w
.65318 .24106 m
.65318 .24106 L
s
P
p
.002 w
.7633 .21207 m .73363 .21796 L .71887 .20707 L p
.8 g
F P
s
P
p
1 .181 0 r
.01 w
.65323 .24246 m
.6827 .23663 L
s
P
p
.002 w
.34853 .21162 m .37731 .2057 L .39366 .21661 L p
.8 g
F P
s
P
p
.002 w
.42249 .21071 m .45146 .20478 L .46747 .2157 L p
.4 g
F P
s
P
p
1 .121 0 r
.01 w
.68244 .23105 m
.68244 .23105 L
s
P
p
.002 w
.64469 .20798 m .61527 .21389 L .59993 .20295 L p
.4 g
F P
s
P
p
.002 w
.83739 .21116 m .85238 .20821 L .85947 .21366 L p
.4 g
F P
s
P
p
.002 w
.64469 .20798 m .67426 .20204 L .68925 .21298 L p
.8 g
F P
s
P
p
.002 w
.79311 .20615 m .7633 .21207 L .74864 .20112 L p
.8 g
F P
s
P
p
.002 w
.71887 .20707 m .74864 .20112 L .7633 .21207 L p
.8 g
F P
s
P
p
.002 w
.85238 .20821 m .83739 .21116 L p
.82307 .2002 L .4 g
F P
s
P
p
.002 w
.45146 .20478 m .42249 .21071 L .40623 .19975 L p
.4 g
F P
s
P
p
1 .196 0 r
.01 w
.68277 .23802 m
.68277 .23802 L
s
P
p
.002 w
.22918 .20752 m .21497 .21048 L .20638 .20501 L p
.4 g
F P
s
P
p
1 .212 0 r
.01 w
.66779 .22858 m
.68284 .23942 L
s
P
p
.002 w
.59993 .20295 m .57056 .20889 L .55499 .19791 L p
.8 g
F P
s
P
p
.002 w
.84526 .20273 m .85238 .20821 L p
.82307 .2002 L .4 g
F P
s
P
p
.002 w
.59993 .20295 m .62945 .19699 L .64469 .20798 L p
.4 g
F P
s
P
p
.002 w
.67426 .20204 m .64469 .20798 L .62945 .19699 L p
.8 g
F P
s
P
p
.002 w
.20638 .20501 m .19775 .19952 L p
.22918 .20752 L .4 g
F P
s
P
p
.002 w
.19775 .19952 m .21201 .19653 L .22918 .20752 L p
.4 g
F P
s
P
p
.002 w
.82307 .2002 m .79311 .20615 L .77855 .19515 L p
.8 g
F P
s
P
p
.002 w
.74864 .20112 m .77855 .19515 L .79311 .20615 L p
.8 g
F P
s
P
p
.002 w
.48058 .19883 m .45146 .20478 L .4353 .19376 L p
.4 g
F P
s
P
p
.002 w
.40623 .19975 m .4353 .19376 L .45146 .20478 L p
.4 g
F P
s
P
p
.002 w
.62945 .19699 m .59993 .20295 L .58445 .19192 L p
.4 g
F P
s
P
p
.002 w
.55499 .19791 m .58445 .19192 L .59993 .20295 L p
.8 g
F P
s
P
p
.002 w
.82307 .2002 m .83811 .19722 L .84526 .20273 L p
.4 g
F P
s
P
p
.002 w
.70397 .19607 m .67426 .20204 L .65912 .19099 L p
.8 g
F P
s
P
p
.002 w
.62945 .19699 m .65912 .19099 L .67426 .20204 L p
.8 g
F P
s
P
p
.002 w
.83811 .19722 m .82307 .2002 L p
.80862 .18914 L .4 g
F P
s
P
p
.002 w
.77855 .19515 m .80862 .18914 L .82307 .2002 L p
.8 g
F P
s
P
p
.002 w
.4353 .19376 m .40623 .19975 L .38983 .18868 L p
.4 g
F P
s
P
p
.002 w
.21201 .19653 m .19775 .19952 L .18908 .19399 L p
.4 g
F P
s
P
p
.002 w
.4353 .19376 m .46452 .18775 L .48058 .19883 L p
.4 g
F P
s
P
p
1 .227 0 r
.01 w
.65265 .21905 m
.66785 .22998 L
s
P
p
.002 w
.83093 .19169 m .83811 .19722 L p
.80862 .18914 L .4 g
F P
s
P
p
.002 w
.58445 .19192 m .61407 .1859 L .62945 .19699 L p
.4 g
F P
s
P
p
.002 w
.18908 .19399 m .18037 .18845 L p
.21201 .19653 L .4 g
F P
s
P
p
.002 w
.18037 .18845 m .19467 .18543 L .21201 .19653 L p
.4 g
F P
s
P
p
.002 w
.73384 .19007 m .70397 .19607 L .68893 .18497 L p
.8 g
F P
s
P
p
.002 w
.65912 .19099 m .68893 .18497 L .70397 .19607 L p
.8 g
F P
s
P
p
.002 w
.80862 .18914 m .77855 .19515 L .76386 .18404 L p
.8 g
F P
s
P
p
.002 w
.46452 .18775 m .4353 .19376 L .41899 .18264 L p
.4 g
F P
s
P
p
.002 w
.38983 .18868 m .41899 .18264 L .4353 .19376 L p
.4 g
F P
s
P
p
.002 w
.61407 .1859 m .58445 .19192 L .56883 .18078 L p
.4 g
F P
s
P
p
.002 w
.80862 .18914 m .82371 .18613 L .83093 .19169 L p
.4 g
F P
s
P
p
.002 w
.76386 .18404 m .73384 .19007 L .7189 .17891 L p
.8 g
F P
s
P
p
.002 w
.68893 .18497 m .7189 .17891 L .73384 .19007 L p
.8 g
F P
s
P
p
.002 w
.34416 .18357 m .3152 .18961 L .29829 .17844 L p
.8 g
F P
s
P
p
.002 w
.82371 .18613 m .80862 .18914 L p
.79403 .17798 L .4 g
F P
s
P
p
.002 w
.76386 .18404 m .79403 .17798 L .80862 .18914 L p
.8 g
F P
s
P
p
.002 w
.19467 .18543 m .18037 .18845 L .17162 .18287 L p
.4 g
F P
s
P
p
.002 w
.41899 .18264 m .4483 .17657 L .46452 .18775 L p
.4 g
F P
s
P
p
.002 w
.81646 .18055 m .82371 .18613 L p
.79403 .17798 L .4 g
F P
s
P
p
.002 w
.56883 .18078 m .59855 .1747 L .61407 .1859 L p
.4 g
F P
s
P
p
1 .242 0 r
.01 w
.65271 .22045 m
.65271 .22045 L
s
P
p
.002 w
.17162 .18287 m .16283 .17728 L p
.19467 .18543 L .4 g
F P
s
P
p
.002 w
.16283 .17728 m .17717 .17423 L .19467 .18543 L p
.4 g
F P
s
P
p
1 .257 0 r
.01 w
.65276 .22186 m
.68264 .21589 L
s
P
p
.002 w
.79403 .17798 m .76386 .18404 L .74903 .17282 L p
.8 g
F P
s
P
p
.002 w
.7189 .17891 m .74903 .17282 L .76386 .18404 L p
.8 g
F P
s
P
p
.002 w
.29829 .17844 m .32735 .17235 L .34416 .18357 L p
.8 g
F P
s
P
p
.002 w
.52339 .17564 m .49388 .18171 L .47776 .17047 L p
.8 g
F P
s
P
p
.002 w
.59855 .1747 m .56883 .18078 L .55306 .16953 L p
.4 g
F P
s
P
p
.002 w
.79403 .17798 m .80917 .17493 L .81646 .18055 L p
.4 g
F P
s
P
p
.002 w
.32735 .17235 m .29829 .17844 L .28123 .16718 L p
.8 g
F P
s
P
p
.002 w
.80917 .17493 m .79403 .17798 L p
.7793 .16671 L .4 g
F P
s
P
p
.002 w
.74903 .17282 m .7793 .16671 L .79403 .17798 L p
.8 g
F P
s
P
p
1 .272 0 r
.01 w
.68271 .2173 m
.68271 .2173 L
s
P
p
.002 w
.40253 .17142 m .37327 .17751 L .35655 .16623 L p
.4 g
F P
s
P
p
.002 w
.17717 .17423 m .16283 .17728 L .15399 .17165 L p
.4 g
F P
s
P
p
1 .287 0 r
.01 w
.66752 .20762 m
.68278 .21871 L
s
P
p
.002 w
.47776 .17047 m .50737 .16434 L .52339 .17564 L p
.8 g
F P
s
P
p
.002 w
.80185 .1693 m .80917 .17493 L p
.7793 .16671 L .4 g
F P
s
P
p
.002 w
.62841 .16859 m .59855 .1747 L .58287 .1634 L p
.4 g
F P
s
P
p
.002 w
.55306 .16953 m .58287 .1634 L .59855 .1747 L p
.4 g
F P
s
P
p
.002 w
.15399 .17165 m .14512 .166 L p
.17717 .17423 L .4 g
F P
s
P
p
.002 w
.14512 .166 m .15951 .16293 L .17717 .17423 L p
.4 g
F P
s
P
p
1 .332 0 r
.01 w
.6677 .21186 m
.68298 .22294 L
s
P
p
1 .348 0 r
.01 w
.68305 .22435 m
.68305 .22435 L
s
P
p
.002 w
.28123 .16718 m .31038 .16103 L .32735 .17235 L p
.8 g
F P
s
P
p
1 .363 0 r
.01 w
.68312 .22576 m
.71323 .21978 L
s
P
p
.002 w
.43193 .16529 m .40253 .17142 L .38591 .16008 L p
.4 g
F P
s
P
p
.002 w
.35655 .16623 m .38591 .16008 L .40253 .17142 L p
.4 g
F P
s
P
p
.002 w
.7793 .16671 m .7945 .16364 L .80185 .1693 L p
.4 g
F P
s
P
p
.002 w
.65843 .16245 m .62841 .16859 L .61284 .15723 L p
.4 g
F P
s
P
p
.002 w
.58287 .1634 m .61284 .15723 L .62841 .16859 L p
.4 g
F P
s
P
p
.002 w
.7945 .16364 m .7793 .16671 L p
.76443 .15533 L .4 g
F P
s
P
p
.002 w
.38591 .16008 m .35655 .16623 L .33968 .15485 L p
.4 g
F P
s
P
p
.002 w
.15951 .16293 m .14512 .166 L .1362 .16032 L p
.4 g
F P
s
P
p
.002 w
.38591 .16008 m .41541 .1539 L .43193 .16529 L p
.4 g
F P
s
P
p
1 .378 0 r
.01 w
.71331 .22119 m
.7436 .21518 L
s
P
p
1 .302 0 r
.01 w
.66758 .20903 m
.66758 .20903 L
s
P
p
1 .317 0 r
.01 w
.66764 .21045 m
.66764 .21045 L
s
P
p
.002 w
.78711 .15795 m .7945 .16364 L p
.76443 .15533 L .4 g
F P
s
P
p
.002 w
.1362 .16032 m .12724 .15461 L p
.15951 .16293 L .4 g
F P
s
P
p
.002 w
.12724 .15461 m .14167 .15151 L .15951 .16293 L p
.4 g
F P
s
P
p
.002 w
.68861 .15628 m .65843 .16245 L .64297 .15103 L p
.4 g
F P
s
P
p
.002 w
.61284 .15723 m .64297 .15103 L .65843 .16245 L p
.4 g
F P
s
P
p
.002 w
.41541 .1539 m .38591 .16008 L .36913 .14864 L p
.4 g
F P
s
P
p
.002 w
.33968 .15485 m .36913 .14864 L .38591 .16008 L p
.4 g
F P
s
P
p
.002 w
.56705 .15199 m .53714 .15818 L .52107 .14672 L p
.8 g
F P
s
P
p
1 .393 0 r
.01 w
.74369 .2166 m
.77414 .21055 L
s
P
p
.002 w
.76443 .15533 m .77968 .15223 L .78711 .15795 L p
.4 g
F P
s
P
p
.002 w
.64297 .15103 m .67324 .1448 L .68861 .15628 L p
.4 g
F P
s
P
p
.002 w
.77968 .15223 m .76443 .15533 L p
.74942 .14384 L .4 g
F P
s
P
p
.002 w
.14167 .15151 m .12724 .15461 L .11823 .14888 L p
.4 g
F P
s
P
p
.002 w
.44507 .14768 m .41541 .1539 L .39873 .1424 L p
.4 g
F P
s
P
p
.002 w
.36913 .14864 m .39873 .1424 L .41541 .1539 L p
.4 g
F P
s
P
p
.002 w
.77222 .14648 m .77968 .15223 L p
.74942 .14384 L .4 g
F P
s
P
p
.002 w
.52107 .14672 m .55108 .14047 L .56705 .15199 L p
.8 g
F P
s
P
p
.002 w
.13269 .14576 m .14719 .14264 L p
.14167 .15151 L .4 g
F P
s
P
p
.002 w
.17065 .14528 m .14167 .15151 L p
.14719 .14264 L .4 g
F P
s
P
p
.002 w
.11823 .14888 m .13269 .14576 L .14167 .15151 L p
.4 g
F P
s
P
p
.002 w
.67324 .1448 m .64297 .15103 L .62735 .13951 L p
.4 g
F P
s
P
p
1 .408 0 r
.01 w
.77424 .21197 m
.77424 .21197 L
s
P
p
1 .423 0 r
.01 w
.77435 .2134 m
.77435 .2134 L
s
P
p
.002 w
.32264 .14336 m .29325 .1496 L .27596 .13806 L p
.8 g
F P
s
P
p
1 .438 0 r
.01 w
.77445 .21482 m
.77445 .21482 L
s
P
p
1 .453 0 r
.01 w
.77456 .21624 m
.77456 .21624 L
s
P
p
.002 w
.47488 .14144 m .44507 .14768 L .42848 .13612 L p
.4 g
F P
s
P
p
.002 w
.39873 .1424 m .42848 .13612 L .44507 .14768 L p
.4 g
F P
s
P
p
1 .469 0 r
.01 w
.77466 .21767 m
.77466 .21767 L
s
P
p
.002 w
.74942 .14384 m .76473 .14071 L .77222 .14648 L p
.4 g
F P
s
P
p
1 .484 0 r
.01 w
.77477 .21909 m
.77477 .21909 L
s
P
p
.002 w
.16172 .13951 m .17629 .13637 L p
.17065 .14528 L .4 g
F P
s
P
p
.002 w
.19978 .13902 m .17065 .14528 L p
.17629 .13637 L .4 g
F P
s
P
p
.002 w
.14719 .14264 m .16172 .13951 L .17065 .14528 L p
.4 g
F P
s
P
p
1 .499 0 r
.01 w
.77487 .22052 m
.77487 .22052 L
s
P
p
.002 w
.62735 .13951 m .65773 .13322 L .67324 .1448 L p
.4 g
F P
s
P
p
1 .514 0 r
.01 w
.77498 .22195 m
.77498 .22195 L
s
P
p
.002 w
.76473 .14071 m .74942 .14384 L p
.73427 .13225 L .4 g
F P
s
P
p
.002 w
.35219 .13709 m .32264 .14336 L .30545 .13176 L p
.8 g
F P
s
P
p
.002 w
.27596 .13806 m .30545 .13176 L .32264 .14336 L p
.8 g
F P
s
P
p
1 .529 0 r
.01 w
.77508 .22338 m
.77508 .22338 L
s
P
p
1 .544 0 r
.01 w
.77519 .22481 m
.77519 .22481 L
s
P
p
.002 w
.50484 .13516 m .47488 .14144 L .45839 .12982 L p
.4 g
F P
s
P
p
.002 w
.42848 .13612 m .45839 .12982 L .47488 .14144 L p
.4 g
F P
s
P
p
1 .559 0 r
.01 w
.77529 .22624 m
.77529 .22624 L
s
P
p
.002 w
.7572 .13491 m .76473 .14071 L p
.73427 .13225 L .4 g
F P
s
P
p
1 .574 0 r
.01 w
.7754 .22767 m
.7754 .22767 L
s
P
p
.002 w
.65773 .13322 m .62735 .13951 L .61159 .12787 L p
.4 g
F P
s
P
p
1 .589 0 r
.01 w
.77551 .22911 m
.77551 .22911 L
s
P
p
.002 w
.19089 .13322 m .20554 .13006 L p
.19978 .13902 L .4 g
F P
s
P
p
.002 w
.22906 .13273 m .19978 .13902 L p
.20554 .13006 L .4 g
F P
s
P
p
.002 w
.17629 .13637 m .19089 .13322 L .19978 .13902 L p
.4 g
F P
s
P
p
1 .605 0 r
.01 w
.77561 .23054 m
.77561 .23054 L
s
P
p
1 .62 0 r
.01 w
.77572 .23198 m
.77572 .23198 L
s
P
p
.002 w
.30545 .13176 m .33509 .12543 L .35219 .13709 L p
.8 g
F P
s
P
p
1 .635 0 r
.01 w
.77582 .23342 m
.77582 .23342 L
s
P
p
1 .65 0 r
.01 w
.77593 .23486 m
.77593 .23486 L
s
P
p
.002 w
.45839 .12982 m .48846 .12348 L .50484 .13516 L p
.4 g
F P
s
P
p
.002 w
.73427 .13225 m .74963 .12909 L .7572 .13491 L p
.4 g
F P
s
P
p
1 .665 0 r
.01 w
.77603 .2363 m
.77603 .2363 L
s
P
p
1 .68 0 r
.01 w
.77614 .23774 m
.77614 .23774 L
s
P
p
.002 w
.61159 .12787 m .64207 .12152 L .65773 .13322 L p
.4 g
F P
s
P
p
.002 w
.22022 .12689 m .23494 .12372 L p
.22906 .13273 L .4 g
F P
s
P
p
.002 w
.2585 .12641 m .22906 .13273 L p
.23494 .12372 L .4 g
F P
s
P
p
.002 w
.20554 .13006 m .22022 .12689 L .22906 .13273 L p
.4 g
F P
s
P
p
1 .695 0 r
.01 w
.77625 .23918 m
.77625 .23918 L
s
P
p
.002 w
.74963 .12909 m .73427 .13225 L p
.71897 .12054 L .4 g
F P
s
P
p
1 .71 0 r
.01 w
.77635 .24062 m
.77635 .24062 L
s
P
p
.002 w
.41174 .12445 m .38189 .13079 L .36489 .11907 L p
.8 g
F P
s
P
p
1 .725 0 r
.01 w
.77646 .24207 m
.77646 .24207 L
s
P
p
.002 w
.48846 .12348 m .45839 .12982 L .44175 .11808 L p
.4 g
F P
s
P
p
1 .741 0 r
.01 w
.77657 .24351 m
.77657 .24351 L
s
P
p
.002 w
.74202 .12323 m .74963 .12909 L p
.71897 .12054 L .4 g
F P
s
P
p
.002 w
.56524 .1225 m .53496 .12884 L .51868 .1171 L p
.8 g
F P
s
P
p
1 .756 0 r
.01 w
.77667 .24496 m
.77667 .24496 L
s
P
p
.002 w
.64207 .12152 m .61159 .12787 L .59567 .11612 L p
.4 g
F P
s
P
p
1 .771 0 r
.01 w
.77678 .24641 m
.77678 .24641 L
s
P
p
1 .786 0 r
.01 w
.77689 .24785 m
.77689 .24785 L
s
P
p
.002 w
.2497 .12054 m .2645 .11735 L p
.2585 .12641 L .4 g
F P
s
P
p
.002 w
.28808 .12005 m .2585 .12641 L p
.2645 .11735 L .4 g
F P
s
P
p
.002 w
.23494 .12372 m .2497 .12054 L .2585 .12641 L p
.4 g
F P
s
P
p
1 .801 0 r
.01 w
.77699 .2493 m
.77699 .2493 L
s
P
p
1 .816 0 r
.01 w
.7771 .25076 m
.7771 .25076 L
s
P
p
.002 w
.44175 .11808 m .41174 .12445 L .39484 .11267 L p
.8 g
F P
s
P
p
.002 w
.36489 .11907 m .39484 .11267 L .41174 .12445 L p
.8 g
F P
s
P
p
1 .831 0 r
.01 w
.77721 .25221 m
.77721 .25221 L
s
P
p
.002 w
.44175 .11808 m .47192 .11168 L .48846 .12348 L p
.4 g
F P
s
P
p
.002 w
.71897 .12054 m .73438 .11735 L .74202 .12323 L p
.4 g
F P
s
P
p
1 .846 0 r
.01 w
.77731 .25366 m
.77731 .25366 L
s
P
p
.002 w
.51868 .1171 m .54906 .1107 L .56524 .1225 L p
.8 g
F P
s
P
p
1 .861 0 r
.01 w
.77742 .25512 m
.77742 .25512 L
s
P
p
.002 w
.59567 .11612 m .62626 .10971 L .64207 .12152 L p
.4 g
F P
s
P
p
1 .877 0 r
.01 w
.77753 .25657 m
.77753 .25657 L
s
P
p
.002 w
.73438 .11735 m .71897 .12054 L p
.70353 .10872 L .4 g
F P
s
P
p
.002 w
.27934 .11415 m .29421 .11094 L p
.28808 .12005 L .4 g
F P
s
P
p
.002 w
.31782 .11366 m .28808 .12005 L p
.29421 .11094 L .4 g
F P
s
P
p
.002 w
.2645 .11735 m .27934 .11415 L .28808 .12005 L p
.4 g
F P
s
P
p
1 .892 0 r
.01 w
.77763 .25803 m
.77763 .25803 L
s
P
p
1 .907 0 r
.01 w
.77774 .25949 m
.77774 .25949 L
s
P
p
.002 w
.39484 .11267 m .42495 .10624 L .44175 .11808 L p
.8 g
F P
s
P
p
1 .922 0 r
.01 w
.77785 .26095 m
.77785 .26095 L
s
P
p
.002 w
.72671 .11144 m .73438 .11735 L p
.70353 .10872 L .4 g
F P
s
P
p
.002 w
.54906 .1107 m .51868 .1171 L .50224 .10525 L p
.8 g
F P
s
P
p
1 .937 0 r
.01 w
.77796 .26241 m
.77796 .26241 L
s
P
p
.002 w
.62626 .10971 m .59567 .11612 L .5796 .10426 L p
.4 g
F P
s
P
p
1 .952 0 r
.01 w
.77806 .26387 m
.77806 .26387 L
s
P
p
1 .967 0 r
.01 w
.77817 .26533 m
.77817 .26533 L
s
P
p
1 .982 0 r
.01 w
.77828 .2668 m
.77828 .2668 L
s
P
p
.002 w
.30913 .10773 m .32408 .1045 L p
.31782 .11366 L .4 g
F P
s
P
p
.002 w
.34772 .10723 m .31782 .11366 L p
.32408 .1045 L .4 g
F P
s
P
p
.002 w
.29421 .11094 m .30913 .10773 L .31782 .11366 L p
.4 g
F P
s
P
p
1 .997 0 r
.01 w
.77839 .26826 m
.77839 .26826 L
s
P
p
.987 1 0 r
.01 w
.7785 .26973 m
.7785 .26973 L
s
P
p
.002 w
.70353 .10872 m .71899 .1055 L .72671 .11144 L p
.4 g
F P
s
P
p
.972 1 0 r
.01 w
.7786 .2712 m
.7786 .2712 L
s
P
p
.002 w
.50224 .10525 m .53273 .09878 L .54906 .1107 L p
.8 g
F P
s
P
p
.957 1 0 r
.01 w
.77871 .27267 m
.77871 .27267 L
s
P
p
.002 w
.5796 .10426 m .6103 .09778 L .62626 .10971 L p
.4 g
F P
s
P
p
.942 1 0 r
.01 w
.77882 .27414 m
.77882 .27414 L
s
P
p
.002 w
.71899 .1055 m .70353 .10872 L p
.68793 .09678 L .4 g
F P
s
P
p
.927 1 0 r
.01 w
.77893 .27561 m
.77893 .27561 L
s
P
p
.002 w
.33907 .10127 m .35411 .09803 L p
.34772 .10723 L .4 g
F P
s
P
p
.002 w
.37777 .10077 m .34772 .10723 L p
.35411 .09803 L .4 g
F P
s
P
p
.002 w
.32408 .1045 m .33907 .10127 L .34772 .10723 L p
.4 g
F P
s
P
p
.912 1 0 r
.01 w
.77904 .27708 m
.77904 .27708 L
s
P
p
.002 w
.45522 .09978 m .42495 .10624 L .40798 .09428 L p
.4 g
F P
s
P
p
.897 1 0 r
.01 w
.77915 .27855 m
.77915 .27855 L
s
P
p
.002 w
.71124 .09953 m .71899 .1055 L p
.68793 .09678 L .4 g
F P
s
P
p
.002 w
.53273 .09878 m .50224 .10525 L .48565 .09328 L p
.8 g
F P
s
P
p
.882 1 0 r
.01 w
.77925 .28003 m
.77925 .28003 L
s
P
p
.002 w
.6103 .09778 m .5796 .10426 L .56337 .09228 L p
.4 g
F P
s
P
p
.866 1 0 r
.01 w
.77936 .2815 m
.77936 .2815 L
s
P
p
.851 1 0 r
.01 w
.77947 .28298 m
.77947 .28298 L
s
P
p
.836 1 0 r
.01 w
.77958 .28446 m
.77958 .28446 L
s
P
p
.821 1 0 r
.01 w
.77969 .28594 m
.77969 .28594 L
s
P
p
.002 w
.36918 .09478 m .38429 .09152 L p
.37777 .10077 L .4 g
F P
s
P
p
.002 w
.40798 .09428 m .37777 .10077 L p
.38429 .09152 L .4 g
F P
s
P
p
.002 w
.35411 .09803 m .36918 .09478 L .37777 .10077 L p
.4 g
F P
s
P
p
.806 1 0 r
.01 w
.7798 .28742 m
.7798 .28742 L
s
P
p
.002 w
.40798 .09428 m .43836 .08775 L .45522 .09978 L p
.4 g
F P
s
P
p
.002 w
.68793 .09678 m .70345 .09353 L .71124 .09953 L p
.4 g
F P
s
P
p
.791 1 0 r
.01 w
.77991 .2889 m
.77991 .2889 L
s
P
p
.002 w
.48565 .09328 m .51623 .08675 L .53273 .09878 L p
.8 g
F P
s
P
p
.776 1 0 r
.01 w
.78002 .29038 m
.78002 .29038 L
s
P
p
.002 w
.64116 .09127 m .6103 .09778 L .59418 .08574 L p
.4 g
F P
s
P
p
.002 w
.56337 .09228 m .59418 .08574 L .6103 .09778 L p
.4 g
F P
s
P
p
.761 1 0 r
.01 w
.78013 .29187 m
.78013 .29187 L
s
P
p
.002 w
.70345 .09353 m .68793 .09678 L p
.67218 .08473 L .4 g
F P
s
P
p
.746 1 0 r
.01 w
.78024 .29335 m
.78024 .29335 L
s
P
p
.73 1 0 r
.01 w
.78034 .29484 m
.78034 .29484 L
s
P
p
.002 w
.39944 .08826 m .41463 .08498 L p
.40798 .09428 L .4 g
F P
s
P
p
.002 w
.43836 .08775 m .40798 .09428 L p
.41463 .08498 L .4 g
F P
s
P
p
.002 w
.38429 .09152 m .39944 .08826 L .40798 .09428 L p
.4 g
F P
s
P
p
.715 1 0 r
.01 w
.78045 .29633 m
.78045 .29633 L
s
P
p
.002 w
.69562 .0875 m .70345 .09353 L p
.67218 .08473 L .4 g
F P
s
P
p
.7 1 0 r
.01 w
.78056 .29782 m
.78056 .29782 L
s
P
p
.685 1 0 r
.01 w
.78067 .29931 m
.78067 .29931 L
s
P
p
.002 w
.67218 .08473 m .64116 .09127 L .62515 .07917 L p
.4 g
F P
s
P
p
.002 w
.59418 .08574 m .62515 .07917 L .64116 .09127 L p
.4 g
F P
s
P
p
.67 1 0 r
.01 w
.78078 .3008 m
.78078 .3008 L
s
P
p
.655 1 0 r
.01 w
.78089 .30229 m
.78089 .30229 L
s
P
p
.64 1 0 r
.01 w
.781 .30379 m
.781 .30379 L
s
P
p
.625 1 0 r
.01 w
.78111 .30528 m
.78111 .30528 L
s
P
p
.002 w
.42986 .0817 m .44513 .07841 L p
.43836 .08775 L .4 g
F P
s
P
p
.002 w
.46889 .08119 m .43836 .08775 L p
.44513 .07841 L .4 g
F P
s
P
p
.002 w
.41463 .08498 m .42986 .0817 L .43836 .08775 L p
.4 g
F P
s
P
p
.002 w
.67218 .08473 m .68776 .08145 L .69562 .0875 L p
.4 g
F P
s
P
p
.61 1 0 r
.01 w
.78122 .30678 m
.78122 .30678 L
s
P
p
.594 1 0 r
.01 w
.78133 .30828 m
.78133 .30828 L
s
P
p
.579 1 0 r
.01 w
.78144 .30978 m
.78144 .30978 L
s
P
p
.002 w
.68776 .08145 m .67218 .08473 L p
.65628 .07256 L .4 g
F P
s
P
p
.002 w
.62515 .07917 m .65628 .07256 L .67218 .08473 L p
.4 g
F P
s
P
p
.564 1 0 r
.01 w
.78155 .31128 m
.78155 .31128 L
s
P
p
.549 1 0 r
.01 w
.78167 .31278 m
.78167 .31278 L
s
P
p
.534 1 0 r
.01 w
.78178 .31428 m
.78178 .31428 L
s
P
p
.002 w
.67985 .07536 m .68776 .08145 L p
.65628 .07256 L .4 g
F P
s
P
p
.002 w
.46045 .07511 m .4758 .0718 L p
.46889 .08119 L .4 g
F P
s
P
p
.002 w
.49958 .0746 m .46889 .08119 L p
.4758 .0718 L .4 g
F P
s
P
p
.002 w
.44513 .07841 m .46045 .07511 L .46889 .08119 L p
.4 g
F P
s
P
p
.519 1 0 r
.01 w
.78189 .31578 m
.78189 .31578 L
s
P
p
.504 1 0 r
.01 w
.782 .31729 m
.782 .31729 L
s
P
p
.489 1 0 r
.01 w
.78211 .31879 m
.78211 .31879 L
s
P
p
.474 1 0 r
.01 w
.78222 .3203 m
.78222 .3203 L
s
P
p
.458 1 0 r
.01 w
.78233 .32181 m
.78233 .32181 L
s
P
p
.443 1 0 r
.01 w
.78244 .32332 m
.78244 .32332 L
s
P
p
.002 w
.65628 .07256 m .67191 .06924 L .67985 .07536 L p
.4 g
F P
s
P
p
.428 1 0 r
.01 w
.78255 .32483 m
.78255 .32483 L
s
P
p
.002 w
.49119 .06848 m .50663 .06515 L p
.49958 .0746 L .4 g
F P
s
P
p
.002 w
.53044 .06797 m .49958 .0746 L p
.50663 .06515 L .4 g
F P
s
P
p
.002 w
.4758 .0718 m .49119 .06848 L .49958 .0746 L p
.4 g
F P
s
P
p
.413 1 0 r
.01 w
.78266 .32634 m
.78266 .32634 L
s
P
p
.398 1 0 r
.01 w
.78278 .32786 m
.78278 .32786 L
s
P
p
.002 w
.67191 .06924 m .65628 .07256 L p
.64022 .06027 L .4 g
F P
s
P
p
.383 1 0 r
.01 w
.78289 .32937 m
.78289 .32937 L
s
P
p
.368 1 0 r
.01 w
.783 .33089 m
.783 .33089 L
s
P
p
.353 1 0 r
.01 w
.78311 .33241 m
.78311 .33241 L
s
P
p
.002 w
.66393 .0631 m .67191 .06924 L p
.64022 .06027 L .4 g
F P
s
P
p
.338 1 0 r
.01 w
.78322 .33392 m
.78322 .33392 L
s
P
p
.002 w
.5221 .06181 m .53762 .05847 L p
.53044 .06797 L .4 g
F P
s
P
p
.002 w
.56146 .0613 m .53044 .06797 L p
.53762 .05847 L .4 g
F P
s
P
p
.002 w
.50663 .06515 m .5221 .06181 L .53044 .06797 L p
.4 g
F P
s
P
p
.322 1 0 r
.01 w
.78333 .33544 m
.78333 .33544 L
s
P
p
.307 1 0 r
.01 w
.78345 .33697 m
.78345 .33697 L
s
P
p
.292 1 0 r
.01 w
.78356 .33849 m
.78356 .33849 L
s
P
p
.277 1 0 r
.01 w
.78367 .34001 m
.78367 .34001 L
s
P
p
.262 1 0 r
.01 w
.78378 .34154 m
.78378 .34154 L
s
P
p
.002 w
.64022 .06027 m .65591 .05692 L .66393 .0631 L p
.4 g
F P
s
P
p
.247 1 0 r
.01 w
.78389 .34306 m
.78389 .34306 L
s
P
p
.232 1 0 r
.01 w
.78401 .34459 m
.78401 .34459 L
s
P
p
.002 w
.55318 .05511 m .56878 .05175 L p
.56146 .0613 L .4 g
F P
s
P
p
.002 w
.59265 .0546 m .56146 .0613 L p
.56878 .05175 L .4 g
F P
s
P
p
.002 w
.53762 .05847 m .55318 .05511 L .56146 .0613 L p
.4 g
F P
s
P
p
.217 1 0 r
.01 w
.78412 .34612 m
.78412 .34612 L
s
P
p
.002 w
.65591 .05692 m .64022 .06027 L p
.624 .04786 L .4 g
F P
s
P
p
.202 1 0 r
.01 w
.78423 .34765 m
.78423 .34765 L
s
P
p
.186 1 0 r
.01 w
.78435 .34918 m
.78435 .34918 L
s
P
p
.171 1 0 r
.01 w
.78446 .35071 m
.78446 .35071 L
s
P
p
.002 w
.64785 .05071 m .65591 .05692 L p
.624 .04786 L .4 g
F P
s
P
p
.156 1 0 r
.01 w
.78457 .35224 m
.78457 .35224 L
s
P
p
.141 1 0 r
.01 w
.78468 .35378 m
.78468 .35378 L
s
P
p
.002 w
.58442 .04838 m .60011 .045 L p
.59265 .0546 L .4 g
F P
s
P
p
.002 w
.624 .04786 m .59265 .0546 L p
.60011 .045 L .4 g
F P
s
P
p
.002 w
.56878 .05175 m .58442 .04838 L .59265 .0546 L p
.4 g
F P
s
P
p
.126 1 0 r
.01 w
.7848 .35532 m
.7848 .35532 L
s
P
p
.111 1 0 r
.01 w
.78491 .35685 m
.78491 .35685 L
s
P
p
.096 1 0 r
.01 w
.78502 .35839 m
.78502 .35839 L
s
P
p
.081 1 0 r
.01 w
.78514 .35993 m
.78514 .35993 L
s
P
p
.002 w
.624 .04786 m .63974 .04448 L .64785 .05071 L p
.4 g
F P
s
P
p
.065 1 0 r
.01 w
.78525 .36147 m
.78525 .36147 L
s
P
p
.05 1 0 r
.01 w
.78536 .36301 m
.78536 .36301 L
s
P
p
.035 1 0 r
.01 w
.78548 .36456 m
.78548 .36456 L
s
P
p
.002 w
.61583 .04161 m .6316 .03821 L p
.624 .04786 L .4 g
F P
s
P
p
.002 w
.63974 .04448 m .624 .04786 L p
.6316 .03821 L .4 g
F P
s
P
p
.002 w
.60011 .045 m .61583 .04161 L .624 .04786 L p
.4 g
F P
s
P
p
.02 1 0 r
.01 w
.78559 .3661 m
.78559 .3661 L
s
P
p
.005 1 0 r
.01 w
.7857 .36765 m
.7857 .36765 L
s
P
p
0 1 .01 r
.01 w
.78582 .3692 m
.78582 .3692 L
s
P
p
0 1 .025 r
.01 w
.78593 .37075 m
.78593 .37075 L
s
P
p
0 1 .04 r
.01 w
.78605 .3723 m
.78605 .3723 L
s
P
p
0 1 .055 r
.01 w
.78616 .37385 m
.78616 .37385 L
s
P
p
0 1 .071 r
.01 w
.78628 .3754 m
.78628 .3754 L
s
P
p
0 1 .086 r
.01 w
.78639 .37695 m
.78639 .37695 L
s
P
p
0 1 .101 r
.01 w
.7865 .37851 m
.7865 .37851 L
s
P
p
0 1 .116 r
.01 w
.78662 .38007 m
.78662 .38007 L
s
P
p
0 1 .131 r
.01 w
.78673 .38162 m
.78673 .38162 L
s
P
p
0 1 .146 r
.01 w
.78685 .38318 m
.78685 .38318 L
s
P
p
0 1 .161 r
.01 w
.78696 .38474 m
.78696 .38474 L
s
P
p
0 1 .176 r
.01 w
.78708 .38631 m
.78708 .38631 L
s
P
p
0 1 .191 r
.01 w
.78719 .38787 m
.78719 .38787 L
s
P
p
0 1 .207 r
.01 w
.78731 .38943 m
.78731 .38943 L
s
P
p
0 1 .222 r
.01 w
.78742 .391 m
.78742 .391 L
s
P
p
0 1 .237 r
.01 w
.78754 .39256 m
.78754 .39256 L
s
P
p
0 1 .252 r
.01 w
.78765 .39413 m
.78765 .39413 L
s
P
p
0 1 .267 r
.01 w
.78777 .3957 m
.78777 .3957 L
s
P
p
0 1 .282 r
.01 w
.78789 .39727 m
.78789 .39727 L
s
P
p
0 1 .297 r
.01 w
.788 .39885 m
.788 .39885 L
s
P
p
0 1 .312 r
.01 w
.78812 .40042 m
.78812 .40042 L
s
P
p
0 1 .327 r
.01 w
.78823 .40199 m
.78823 .40199 L
s
P
p
0 1 .343 r
.01 w
.78835 .40357 m
.78835 .40357 L
s
P
p
0 1 .358 r
.01 w
.78847 .40515 m
.78847 .40515 L
s
P
p
0 1 .373 r
.01 w
.78858 .40673 m
.78858 .40673 L
s
P
p
0 1 .388 r
.01 w
.7887 .40831 m
.7887 .40831 L
s
P
p
0 1 .403 r
.01 w
.78881 .40989 m
.78881 .40989 L
s
P
p
0 1 .418 r
.01 w
.78893 .41147 m
.78893 .41147 L
s
P
p
0 1 .433 r
.01 w
.78905 .41305 m
.78905 .41305 L
s
P
p
0 1 .448 r
.01 w
.78916 .41464 m
.78916 .41464 L
s
P
p
0 1 .463 r
.01 w
.78928 .41623 m
.78928 .41623 L
s
P
p
0 1 .479 r
.01 w
.7894 .41781 m
.7894 .41781 L
s
P
p
0 1 .494 r
.01 w
.78952 .4194 m
.78952 .4194 L
s
P
p
0 1 .509 r
.01 w
.78963 .42099 m
.78963 .42099 L
s
P
p
0 1 .524 r
.01 w
.78975 .42259 m
.78975 .42259 L
s
P
p
0 1 .539 r
.01 w
.78987 .42418 m
.78987 .42418 L
s
P
p
0 1 .554 r
.01 w
.78998 .42577 m
.78998 .42577 L
s
P
p
0 1 .569 r
.01 w
.7901 .42737 m
.7901 .42737 L
s
P
p
0 1 .584 r
.01 w
.79022 .42897 m
.79022 .42897 L
s
P
p
0 1 .599 r
.01 w
.79034 .43056 m
.79034 .43056 L
s
P
p
0 1 .615 r
.01 w
.79045 .43216 m
.79045 .43216 L
s
P
p
0 1 .63 r
.01 w
.79057 .43377 m
.79057 .43377 L
s
P
p
0 1 .645 r
.01 w
.79069 .43537 m
.79069 .43537 L
s
P
p
0 1 .66 r
.01 w
.79081 .43697 m
.79081 .43697 L
s
P
p
0 1 .675 r
.01 w
.79093 .43858 m
.79093 .43858 L
s
P
p
0 1 .69 r
.01 w
.79105 .44018 m
.79105 .44018 L
s
P
p
0 1 .705 r
.01 w
.79116 .44179 m
.79116 .44179 L
s
P
p
0 1 .72 r
.01 w
.79128 .4434 m
.79128 .4434 L
s
P
p
0 1 .736 r
.01 w
.7914 .44501 m
.7914 .44501 L
s
P
p
0 1 .751 r
.01 w
.79152 .44663 m
.79152 .44663 L
s
P
p
0 1 .766 r
.01 w
.79164 .44824 m
.79164 .44824 L
s
P
p
0 1 .781 r
.01 w
.79176 .44985 m
.79176 .44985 L
s
P
p
0 1 .796 r
.01 w
.79188 .45147 m
.79188 .45147 L
s
P
p
0 1 .811 r
.01 w
.792 .45309 m
.792 .45309 L
s
P
p
0 1 .826 r
.01 w
.79211 .45471 m
.79211 .45471 L
s
P
p
0 1 .841 r
.01 w
.79223 .45633 m
.79223 .45633 L
s
P
p
0 1 .856 r
.01 w
.79235 .45795 m
.79235 .45795 L
s
P
p
0 1 .872 r
.01 w
.79247 .45957 m
.79247 .45957 L
s
P
p
0 1 .887 r
.01 w
.79259 .4612 m
.79259 .4612 L
s
P
p
0 1 .902 r
.01 w
.79271 .46282 m
.79271 .46282 L
s
P
p
0 1 .917 r
.01 w
.79283 .46445 m
.79283 .46445 L
s
P
p
0 1 .932 r
.01 w
.79295 .46608 m
.79295 .46608 L
s
P
p
0 1 .947 r
.01 w
.79307 .46771 m
.79307 .46771 L
s
P
p
0 1 .962 r
.01 w
.79319 .46934 m
.79319 .46934 L
s
P
p
0 1 .977 r
.01 w
.79331 .47097 m
.79331 .47097 L
s
P
p
0 1 .992 r
.01 w
.79343 .4726 m
.79343 .4726 L
s
P
p
0 .992 1 r
.01 w
.79355 .47424 m
.79355 .47424 L
s
P
p
0 .977 1 r
.01 w
.79367 .47588 m
.79367 .47588 L
s
P
p
0 .962 1 r
.01 w
.79379 .47752 m
.79379 .47752 L
s
P
p
0 .947 1 r
.01 w
.79391 .47916 m
.79391 .47916 L
s
P
p
0 .932 1 r
.01 w
.79404 .4808 m
.79404 .4808 L
s
P
p
0 .917 1 r
.01 w
.79416 .48244 m
.79416 .48244 L
s
P
p
0 .902 1 r
.01 w
.79428 .48408 m
.79428 .48408 L
s
P
p
0 .887 1 r
.01 w
.7944 .48573 m
.7944 .48573 L
s
P
p
0 .872 1 r
.01 w
.79452 .48737 m
.79452 .48737 L
s
P
p
0 .856 1 r
.01 w
.79464 .48902 m
.79464 .48902 L
s
P
p
0 .841 1 r
.01 w
.79476 .49067 m
.79476 .49067 L
s
P
p
0 .826 1 r
.01 w
.79488 .49232 m
.79488 .49232 L
s
P
p
0 .811 1 r
.01 w
.79501 .49397 m
.79501 .49397 L
s
P
p
0 .796 1 r
.01 w
.79513 .49563 m
.79513 .49563 L
s
P
p
0 .781 1 r
.01 w
.79525 .49728 m
.79525 .49728 L
s
P
p
0 .766 1 r
.01 w
.79537 .49894 m
.79537 .49894 L
s
P
p
0 .751 1 r
.01 w
.79549 .5006 m
.79549 .5006 L
s
P
p
0 .736 1 r
.01 w
.79562 .50226 m
.79562 .50226 L
s
P
p
0 .72 1 r
.01 w
.79574 .50392 m
.79574 .50392 L
s
P
p
0 .705 1 r
.01 w
.79586 .50558 m
.79586 .50558 L
s
P
p
0 .69 1 r
.01 w
.79598 .50724 m
.79598 .50724 L
s
P
p
0 .675 1 r
.01 w
.7961 .50891 m
.7961 .50891 L
s
P
p
0 .66 1 r
.01 w
.79623 .51058 m
.79623 .51058 L
s
P
p
0 .645 1 r
.01 w
.79635 .51224 m
.79635 .51224 L
s
P
p
0 .63 1 r
.01 w
.79647 .51391 m
.79647 .51391 L
s
P
p
0 .615 1 r
.01 w
.7966 .51558 m
.7966 .51558 L
s
P
p
0 .599 1 r
.01 w
.79672 .51726 m
.79672 .51726 L
s
P
p
0 .584 1 r
.01 w
.79684 .51893 m
.79684 .51893 L
s
P
p
0 .569 1 r
.01 w
.79697 .5206 m
.79697 .5206 L
s
P
p
0 .554 1 r
.01 w
.79709 .52228 m
.79709 .52228 L
s
P
p
0 .539 1 r
.01 w
.79721 .52396 m
.79721 .52396 L
s
P
p
0 .524 1 r
.01 w
.79734 .52564 m
.79734 .52564 L
s
P
p
0 .509 1 r
.01 w
.79746 .52732 m
.79746 .52732 L
s
P
p
0 .494 1 r
.01 w
.79758 .529 m
.79758 .529 L
s
P
p
0 .479 1 r
.01 w
.79771 .53068 m
.79771 .53068 L
s
P
p
0 .463 1 r
.01 w
.79783 .53237 m
.79783 .53237 L
s
P
p
0 .448 1 r
.01 w
.79796 .53406 m
.79796 .53406 L
s
P
p
0 .433 1 r
.01 w
.79808 .53574 m
.79808 .53574 L
s
P
p
0 .418 1 r
.01 w
.7982 .53743 m
.7982 .53743 L
s
P
p
0 .403 1 r
.01 w
.79833 .53913 m
.79833 .53913 L
s
P
p
0 .388 1 r
.01 w
.79845 .54082 m
.79845 .54082 L
s
P
p
0 .373 1 r
.01 w
.79858 .54251 m
.79858 .54251 L
s
P
p
0 .358 1 r
.01 w
.7987 .54421 m
.7987 .54421 L
s
P
p
0 .343 1 r
.01 w
.79883 .5459 m
.79883 .5459 L
s
P
p
0 .327 1 r
.01 w
.79895 .5476 m
.79895 .5476 L
s
P
p
0 .312 1 r
.01 w
.79908 .5493 m
.79908 .5493 L
s
P
p
0 .297 1 r
.01 w
.7992 .551 m
.7992 .551 L
s
P
p
0 .282 1 r
.01 w
.79933 .55271 m
.79933 .55271 L
s
P
p
0 .267 1 r
.01 w
.79945 .55441 m
.79945 .55441 L
s
P
p
0 .252 1 r
.01 w
.79958 .55612 m
.79958 .55612 L
s
P
p
0 .237 1 r
.01 w
.79971 .55782 m
.79971 .55782 L
s
P
p
0 .222 1 r
.01 w
.79983 .55953 m
.79983 .55953 L
s
P
p
0 .207 1 r
.01 w
.79996 .56124 m
.79996 .56124 L
s
P
p
0 .191 1 r
.01 w
.80008 .56295 m
.80008 .56295 L
s
P
p
0 .176 1 r
.01 w
.80021 .56467 m
.80021 .56467 L
s
P
p
0 .161 1 r
.01 w
.80034 .56638 m
.80034 .56638 L
s
P
p
0 .146 1 r
.01 w
.80046 .5681 m
.80046 .5681 L
s
P
p
0 .131 1 r
.01 w
.80059 .56981 m
.80059 .56981 L
s
P
p
0 .116 1 r
.01 w
.80072 .57153 m
.80072 .57153 L
s
P
p
0 .101 1 r
.01 w
.80084 .57325 m
.80084 .57325 L
s
P
p
0 .086 1 r
.01 w
.80097 .57498 m
.80097 .57498 L
s
P
p
0 .071 1 r
.01 w
.8011 .5767 m
.8011 .5767 L
s
P
p
0 .055 1 r
.01 w
.80122 .57843 m
.80122 .57843 L
s
P
p
0 .04 1 r
.01 w
.80135 .58015 m
.80135 .58015 L
s
P
p
0 .025 1 r
.01 w
.80148 .58188 m
.80148 .58188 L
s
P
p
0 .01 1 r
.01 w
.8016 .58361 m
.8016 .58361 L
s
P
p
.005 0 1 r
.01 w
.80173 .58534 m
.80173 .58534 L
s
P
p
.02 0 1 r
.01 w
.80186 .58707 m
.80186 .58707 L
s
P
p
.035 0 1 r
.01 w
.80199 .58881 m
.80199 .58881 L
s
P
p
.05 0 1 r
.01 w
.80211 .59054 m
.80211 .59054 L
s
P
p
.065 0 1 r
.01 w
.80224 .59228 m
.80224 .59228 L
s
P
p
.081 0 1 r
.01 w
.80237 .59402 m
.80237 .59402 L
s
P
p
.096 0 1 r
.01 w
.8025 .59576 m
.8025 .59576 L
s
P
p
.111 0 1 r
.01 w
.80263 .5975 m
.80263 .5975 L
s
P
p
.126 0 1 r
.01 w
.80276 .59924 m
.80276 .59924 L
s
P
p
.141 0 1 r
.01 w
.80288 .60099 m
.80288 .60099 L
s
P
p
.156 0 1 r
.01 w
.80301 .60274 m
.80301 .60274 L
s
P
p
.171 0 1 r
.01 w
.80314 .60448 m
.80314 .60448 L
s
P
p
.186 0 1 r
.01 w
.80327 .60623 m
.80327 .60623 L
s
P
p
.202 0 1 r
.01 w
.8034 .60798 m
.8034 .60798 L
s
P
p
.217 0 1 r
.01 w
.80353 .60974 m
.80353 .60974 L
s
P
p
.232 0 1 r
.01 w
.80366 .61149 m
.80366 .61149 L
s
P
p
.247 0 1 r
.01 w
.80379 .61325 m
.80379 .61325 L
s
P
p
.262 0 1 r
.01 w
.80392 .615 m
.80392 .615 L
s
P
p
.277 0 1 r
.01 w
.80405 .61676 m
.80405 .61676 L
s
P
p
.292 0 1 r
.01 w
.80417 .61852 m
.80417 .61852 L
s
P
p
.307 0 1 r
.01 w
.8043 .62028 m
.8043 .62028 L
s
P
p
.322 0 1 r
.01 w
.80443 .62205 m
.80443 .62205 L
s
P
p
.338 0 1 r
.01 w
.80456 .62381 m
.80456 .62381 L
s
P
p
.353 0 1 r
.01 w
.80469 .62558 m
.80469 .62558 L
s
P
p
.368 0 1 r
.01 w
.80482 .62735 m
.80482 .62735 L
s
P
p
.383 0 1 r
.01 w
.80495 .62912 m
.80495 .62912 L
s
P
p
.398 0 1 r
.01 w
.80509 .63089 m
.80509 .63089 L
s
P
p
.413 0 1 r
.01 w
.80522 .63266 m
.80522 .63266 L
s
P
p
.428 0 1 r
.01 w
.80535 .63443 m
.80535 .63443 L
s
P
p
.443 0 1 r
.01 w
.80548 .63621 m
.80548 .63621 L
s
P
p
.458 0 1 r
.01 w
.80561 .63799 m
.80561 .63799 L
s
P
p
.474 0 1 r
.01 w
.80574 .63977 m
.80574 .63977 L
s
P
p
.489 0 1 r
.01 w
.80587 .64155 m
.80587 .64155 L
s
P
p
.504 0 1 r
.01 w
.806 .64333 m
.806 .64333 L
s
P
p
.519 0 1 r
.01 w
.80613 .64511 m
.80613 .64511 L
s
P
p
.534 0 1 r
.01 w
.80626 .6469 m
.80626 .6469 L
s
P
p
.549 0 1 r
.01 w
.8064 .64868 m
.8064 .64868 L
s
P
p
.564 0 1 r
.01 w
.80653 .65047 m
.80653 .65047 L
s
P
p
.579 0 1 r
.01 w
.80666 .65226 m
.80666 .65226 L
s
P
p
.594 0 1 r
.01 w
.80679 .65405 m
.80679 .65405 L
s
P
p
.61 0 1 r
.01 w
.80692 .65585 m
.80692 .65585 L
s
P
p
.625 0 1 r
.01 w
.80705 .65764 m
.80705 .65764 L
s
P
p
.64 0 1 r
.01 w
.80719 .65944 m
.80719 .65944 L
s
P
p
.655 0 1 r
.01 w
.80732 .66124 m
.80732 .66124 L
s
P
p
.67 0 1 r
.01 w
.80745 .66304 m
.80745 .66304 L
s
P
p
.685 0 1 r
.01 w
.80758 .66484 m
.80758 .66484 L
s
P
p
.7 0 1 r
.01 w
.80772 .66664 m
.80772 .66664 L
s
P
p
.715 0 1 r
.01 w
.80785 .66844 m
.80785 .66844 L
s
P
p
.73 0 1 r
.01 w
.80798 .67025 m
.80798 .67025 L
s
P
p
.746 0 1 r
.01 w
.80812 .67206 m
.80812 .67206 L
s
P
p
.761 0 1 r
.01 w
.80825 .67387 m
.80825 .67387 L
s
P
p
.776 0 1 r
.01 w
.80838 .67568 m
.80838 .67568 L
s
P
p
.791 0 1 r
.01 w
.80852 .67749 m
.80852 .67749 L
s
P
p
.806 0 1 r
.01 w
.80865 .6793 m
.80865 .6793 L
s
P
p
.821 0 1 r
.01 w
.80878 .68112 m
.80878 .68112 L
s
P
p
.836 0 1 r
.01 w
.80892 .68294 m
.80892 .68294 L
s
P
p
.851 0 1 r
.01 w
.80905 .68476 m
.80905 .68476 L
s
P
p
.866 0 1 r
.01 w
.80919 .68658 m
.80919 .68658 L
s
P
p
.882 0 1 r
.01 w
.80932 .6884 m
.80932 .6884 L
s
P
p
.897 0 1 r
.01 w
.80945 .69022 m
.80945 .69022 L
s
P
p
.912 0 1 r
.01 w
.80959 .69205 m
.80959 .69205 L
s
P
p
.927 0 1 r
.01 w
.80972 .69388 m
.80972 .69388 L
s
P
p
.942 0 1 r
.01 w
.80986 .69571 m
.80986 .69571 L
s
P
p
.957 0 1 r
.01 w
.80999 .69754 m
.80999 .69754 L
s
P
p
.972 0 1 r
.01 w
.81013 .69937 m
.81013 .69937 L
s
P
p
.987 0 1 r
.01 w
.81026 .7012 m
.81026 .7012 L
s
P
p
1 0 .997 r
.01 w
.8104 .70304 m
.8104 .70304 L
s
P
p
1 0 .982 r
.01 w
.81053 .70487 m
.81053 .70487 L
s
P
p
1 0 .967 r
.01 w
.81067 .70671 m
.81067 .70671 L
s
P
p
1 0 .952 r
.01 w
.8108 .70855 m
.8108 .70855 L
s
P
p
1 0 .937 r
.01 w
.81094 .7104 m
.81094 .7104 L
s
P
p
1 0 .922 r
.01 w
.81107 .71224 m
.81107 .71224 L
s
P
p
1 0 .907 r
.01 w
.81121 .71408 m
.81121 .71408 L
s
P
p
1 0 .892 r
.01 w
.81135 .71593 m
.81135 .71593 L
s
P
p
1 0 .877 r
.01 w
.81148 .71778 m
.81148 .71778 L
s
P
p
1 0 .861 r
.01 w
.81162 .71963 m
.81162 .71963 L
s
P
p
1 0 .846 r
.01 w
.81176 .72148 m
.81176 .72148 L
s
P
p
1 0 .831 r
.01 w
.81189 .72334 m
.81189 .72334 L
s
P
p
1 0 .816 r
.01 w
.81203 .72519 m
.81203 .72519 L
s
P
p
1 0 .801 r
.01 w
.81216 .72705 m
.81216 .72705 L
s
P
p
1 0 .786 r
.01 w
.8123 .72891 m
.8123 .72891 L
s
P
p
1 0 .771 r
.01 w
.81244 .73077 m
.81244 .73077 L
s
P
p
1 0 .756 r
.01 w
.81258 .73263 m
.81258 .73263 L
s
P
p
1 0 .741 r
.01 w
.81271 .73449 m
.81271 .73449 L
s
P
p
1 0 .725 r
.01 w
.81285 .73636 m
.81285 .73636 L
s
P
p
1 0 .71 r
.01 w
.81299 .73823 m
.81299 .73823 L
s
P
p
1 0 .695 r
.01 w
.81313 .74009 m
.81313 .74009 L
s
P
p
1 0 .68 r
.01 w
.81326 .74197 m
.81326 .74197 L
s
P
p
1 0 .665 r
.01 w
.8134 .74384 m
.8134 .74384 L
s
P
p
1 0 .65 r
.01 w
.81354 .74571 m
.81354 .74571 L
s
P
p
1 0 .635 r
.01 w
.81368 .74759 m
.81368 .74759 L
s
P
p
1 0 .62 r
.01 w
.81382 .74946 m
.81382 .74946 L
s
P
p
1 0 .605 r
.01 w
.81395 .75134 m
.81395 .75134 L
s
P
p
1 0 .589 r
.01 w
.81409 .75322 m
.81409 .75322 L
s
P
p
1 0 .574 r
.01 w
.81423 .75511 m
.81423 .75511 L
s
P
p
1 0 .559 r
.01 w
.81437 .75699 m
.81437 .75699 L
s
P
p
1 0 .544 r
.01 w
.81451 .75888 m
.81451 .75888 L
s
P
p
1 0 .529 r
.01 w
.81465 .76076 m
.81465 .76076 L
s
P
p
1 0 .514 r
.01 w
.81479 .76265 m
.81479 .76265 L
s
P
p
1 0 .499 r
.01 w
.81493 .76455 m
.81493 .76455 L
s
P
p
1 0 .484 r
.01 w
.81506 .76644 m
.81506 .76644 L
s
P
p
1 0 .469 r
.01 w
.8152 .76833 m
.8152 .76833 L
s
P
p
1 0 .453 r
.01 w
.81534 .77023 m
.81534 .77023 L
s
P
p
1 0 .438 r
.01 w
.81548 .77213 m
.81548 .77213 L
s
P
p
1 0 .423 r
.01 w
.81562 .77403 m
.81562 .77403 L
s
P
p
1 0 .408 r
.01 w
.81576 .77593 m
.81576 .77593 L
s
P
p
1 0 .393 r
.01 w
.8159 .77783 m
.8159 .77783 L
s
P
p
1 0 .378 r
.01 w
.81604 .77974 m
.81604 .77974 L
s
P
p
1 0 .363 r
.01 w
.81618 .78164 m
.81618 .78164 L
s
P
p
1 0 .348 r
.01 w
.81632 .78355 m
.81632 .78355 L
s
P
p
1 0 .332 r
.01 w
.81647 .78546 m
.81647 .78546 L
s
P
p
1 0 .317 r
.01 w
.81661 .78737 m
.81661 .78737 L
s
P
p
1 0 .302 r
.01 w
.81675 .78929 m
.81675 .78929 L
s
P
p
1 0 .287 r
.01 w
.81689 .7912 m
.81689 .7912 L
s
P
p
1 0 .272 r
.01 w
.81703 .79312 m
.81703 .79312 L
s
P
p
1 0 .257 r
.01 w
.81717 .79504 m
.81717 .79504 L
s
P
p
1 0 .242 r
.01 w
.81731 .79696 m
.81731 .79696 L
s
P
p
1 0 .227 r
.01 w
.81745 .79888 m
.81745 .79888 L
s
P
p
1 0 .212 r
.01 w
.8176 .80081 m
.8176 .80081 L
s
P
p
1 0 .196 r
.01 w
.81774 .80273 m
.81774 .80273 L
s
P
p
1 0 .181 r
.01 w
.81788 .80466 m
.81788 .80466 L
s
P
p
1 0 .166 r
.01 w
.81802 .80659 m
.81802 .80659 L
s
P
p
1 0 .151 r
.01 w
.81816 .80852 m
.81816 .80852 L
s
P
p
1 0 .136 r
.01 w
.81831 .81046 m
.81831 .81046 L
s
P
p
1 0 .121 r
.01 w
.81845 .81239 m
.81845 .81239 L
s
P
p
1 0 .106 r
.01 w
.81859 .81433 m
.81859 .81433 L
s
P
p
1 0 .091 r
.01 w
.81873 .81627 m
.81873 .81627 L
s
P
p
1 0 .076 r
.01 w
.81888 .81821 m
.81888 .81821 L
s
P
p
1 0 .06 r
.01 w
.81902 .82015 m
.81902 .82015 L
s
P
p
1 0 .045 r
.01 w
.81916 .82209 m
.81916 .82209 L
s
P
p
1 0 .03 r
.01 w
.81931 .82404 m
.81931 .82404 L
s
P
p
1 0 .015 r
.01 w
.81945 .82599 m
.81945 .82599 L
s
P
p
.002 w
.63111 .02429 m
.88606 .22165 L
s
.88606 .22165 m
.95654 .89627 L
s
.95654 .89627 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.11976 .13514 m
.04346 .82258 L
s
.04346 .82258 m
.65613 .72665 L
s
.65613 .72665 m
.63111 .02429 L
s
.63111 .02429 m
.11976 .13514 L
s
P
p
p
.002 w
.11976 .13514 m
.63111 .02429 L
s
P
p
.002 w
.23603 .10993 m
.243 .11459 L
s
P
[(5)] .22208 .10062 .837 1 Mshowa
p
.002 w
.38479 .07768 m
.39154 .08244 L
s
P
[(10)] .37129 .06817 .79276 1 Mshowa
p
.002 w
.53751 .04458 m
.54402 .04944 L
s
P
[(15)] .52449 .03486 .74852 1 Mshowa
p
.001 w
.26547 .10355 m
.26963 .10636 L
s
P
p
.001 w
.29507 .09713 m
.2992 .09995 L
s
P
p
.001 w
.32482 .09069 m
.32892 .09352 L
s
P
p
.001 w
.35472 .0842 m
.3588 .08704 L
s
P
p
.001 w
.41501 .07113 m
.41903 .074 L
s
P
p
.001 w
.44539 .06455 m
.44939 .06743 L
s
P
p
.001 w
.47594 .05793 m
.4799 .06082 L
s
P
p
.001 w
.50664 .05127 m
.51058 .05417 L
s
P
p
.001 w
.20673 .11628 m
.21094 .11906 L
s
P
p
.001 w
.17759 .1226 m
.18183 .12537 L
s
P
p
.001 w
.1486 .12888 m
.15286 .13164 L
s
P
p
.001 w
.56854 .03785 m
.57242 .04078 L
s
P
p
.001 w
.59974 .03109 m
.60359 .03403 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28847 .02397 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004P0
0ol300;o0`03o`800ol20003o`000;X000170007o`000?l0o`020003o`3o008000Ko003o0?l20003
o`000;X0001;0003o`3o008000?o0?l00P001_l00?l0o`8000?o0000<@03o`<00on00000B003o`80
00Ko003o0?l20006o`00o`3o0P000ol0000b0003o`0000D000?o0000O@0004L000?o00001002o`80
00Go003o0006ocD000?o00001@000ol0001m0000A`001Ol0003o00`000?o0?l0=`000ol0000200?o
P00004P00ol?0003o`0003D000?o00000P000ol0000K00CoH@0009400_l400Co5@05o`8000?o0?l0
H0000:/01Ol70004o`00oel0002W00Co1@000ol000040003o`0000?oG@000:801_l=00Go0`000ol0
001J0000J003o`@00_l/00Go3P05o`:10ol40003o`0005T0001Y0003o`00008000Co003o9`04o`80
00?oP@001P09o`B10ol2P@03o`00008000?o0000F00006T000?o00000P001?l00?lR00Go1`001?n1
0004o`B100?oPH401?l01K_;^h7o00>10_l00`3oo`02oeP0001Y0003o`00008000Co003o7@05o`<0
00?o00001P04o`V10_l8^`03oh6100:10_l40003o`0000T00om90000J@000ol000020004o`00oaP0
1Ol=00Co0h400on1P@05o`0=^l^kbk_;^l^kbk_;o`03P@Go0`000ol0000;0003o`0004H0001X00;o
1@02oaD01?l50003o`0000H01?l8P@;o4K/01?nkool5P@03o`3o00?o2`000ol000160000P@06o`d0
1?l3P@03oh6100Co01W;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00J100?o00000P000ol0000500?o
B@0007`01Ol60003o`0000D01Ol4P@;o0X42oaVk00?o^k/00[/4P@03oh7o00@000?o000010000ol0
00190000AP03obl01?l200;o2P06o`B11?l08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
bk_;00Go0h400ol00002P@03o`0000<01?m80000B@000ol0000W00Go3008o`:11?lU^`Co18400on1
P@02P@?o0P02odl000190003o`0002801Ol40003oh4000H01?l8P@;o02?;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`07o`V100KoPH7oPOl40003o`0004`0001600?o8@05o`X00X45o`>1
00?oPH401?lQ^`Ko1X42o`V10_l3P@04o`0000;oC@0004H000?o00007005o`D000?o00001@04o`V1
0_l03/^kbk_;^l^kbk_;^l^k1_l03L^kbk_;^l^kbk_;^l/01?l3P@03oh6100N100?oPH401Ol01<^k
bk/4P@?o0P02ob`01Ol01@3oool000?o0`02o`d0001600Co5P05o`030?oo00/01?l4P@03oh6100Co
18400onk^`07^`Co1U/2o`Vk0_l8P@03oh6100J10ol:^`>100?oPOl010000ol0000Y0003o`000080
00Co003o10001?l00?l>0000G004o`h01_l4P@;o0X42o`V100cobk_;^l^kbk_;^ol9F`0<ok_;^l^k
bk_;^l_o28400on1P@04o`0?^onkbk_;^l^kbk_;^l^k00;o0h400ol000020003o`0002P000?o0000
0`03o`800_l30003o`0000`0001G00Go0`000ol0000600Oo1H44o`Jk00?oPH401h400onk^`08^`03
oe]K00MK0_l9^`03oh6100:10_l2P@;o1K/00onk^`0=^`B11_lY00Go0`000ol0o`050003o`0000`0
001B00Go3@04o`>100?oPH401?l03/^kbk_;^l^kbk_;^l_o0X44o`0?bk_;^l^kbk_;^l^kbk_o009K
1?l4F`0:ol^kbk_;^l^kb`Co1X42o`0D^l^kok_;^l^kbk_;^l^kbk_;^l/4P@;o0`02obL000?o0000
0`02o`<00ol0103oool=0000C@05o`D000?o00001P04o`R10_l@^`Co4k/2o`UK00?o^k/02;/00on1
P@07P@04ok^koa6k1_l40003o`0002@000?o00003@000ol0000<0000B@04o`030?oo00`01?l3P@03
oh6100Co013;^l^kbk_;^l^kbk_;^l^k1?l4F`;o00O;^l^kbk_;00Co00Vkbk_;^l^kbol02E/2o`0:
^l^kbk_;^l^ko`F10_l2P@?o01:kbk_;^l^kbk_;^l^kbk_;^l/5P@Ko9@05oaX0001400Go1`000ol0
000400Go1842o`:10_l>^`Ko2U/00onk^`04o`B100?o^k/01[/00omKF`04o`AK00?o^k/01k/5o`J1
00?o^k/04K/5P@;o0`02o`X00ol400;o;`0003l01Ol40003o`0000H000>1ool01?l4P@Co013;^l^k
bk_;^l^kbk_;^l^k1?l6F`;o2E/2o`V100Wo^l^kbk_;^l/00_l9F`0<ok_;^l^kbk_;^l_o2842o`0C
bk_;^l^kbk_;^l^kbk_;^l^kb`03P@Co10000ol000080003o`00008000Co003o;P0003/01Ol<00So
0X44oaRk0_l8F`03oe]K00Co1;/00on1P@07P@;o2;/00omKF`07F`03ok^k00Rk00?oPH401H401?n1
oolB^`;o18400ol0o`03o`T000?o00000P001?l00?l^0000=P05o`D000?o00001@04o`R10_l04<^k
bk_;^l^kbk_;^l^kbk/4o`0;bk_;^l^kbk_;^ol015/2o`9K0_l02[_;^l^kbk_;^ol2P@Co18402_o;
^l^kbk_;^ol2F`Co00nkbk_;^l^kbk_;^l^kbol00X45o`>101Co^l^kbk_;^l^kbk_;^l^kbk_;^`F1
0_l30003o`0000H000?o00000P001?l00?l^0000<@05o`030?l000/01?l3P@03oh6100Co4K/3o`AK
0_l9^`Co3[/4o`V100?o^k/01[/2oa>k0_l4P@03oh6100:100?o^k/04K/3P@04oh7oo`<00_l60003
o`00008000Co003o;P0002l00_l70003o`0000@01_l4P@03oh6100;o00o;^l^kbk_;^l^kbk_;^l/0
1_l9F`0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l4P@03oh6100N1023obk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`>100?oPH400h42o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l4P@;o0h400ol0
000200;o1@02obl0000_0003o`3o00T01Ol5P@Co4;/4o`IK00?oFe/01e/00onk^`0=^`Ko2H400on1
P@04ob:k00?oPH401?l4P@03ok^k016k1H42o`<000?o0000>@0002l000?o00000_l00`3oo`06o`:1
1?l06K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol025/00omKF`04o`0<^l^kbk_;^l^kbk_;1_l6P@;o
2842o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l04/^kbk_;^l^kbk_;^l^kbk_;^`?o28405?o;^l^kbk_;
^l^kbk_;^l^kbk_;0h401?n1ool300;o>@0002l000?o0?l00ol8P@;o7K/00omKF`02F`;o0U/2o`bk
1?l4P@;o28400on1P@03oa6k1?l4F`03ok^k016k00?oPH401h42oa:k0_l4P@03o`3o00?o>00002l0
0_l3P@03oh6100Co02:kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l03[_;^l^kbk_;
^l^kbk_;1?l:P@03oh6100:10_l2P@;o01;;^l^kbk_;^l^kbk_;^l^kbk/2o`UK01?obk_;^l^kbk_;
^l^kbk_;^l^k00;o0X44o`B101Co^l^kbk_;^l^kbk_;^l^kbk_;^`F10_l30003o`0003D0000V00;o
1`02o`B10_le^`?o1842o`V11?lJ^`03oe]K00MK00?o^k/03K/6o`V100?o^k/04K/3P@04oh7oo`<0
00?o0000=00002D000Co003o1@000ol00002o`B10_l0<K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l9P@03oh6100Co18407_nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`9K1?l03<^kbk_;^l^kbk_;^`Ko0X401On1PH7o00V101Co^l^kbk_;^l^kbk_;^l^k
bk_;^`;o18400ol0o`03oc@0000U0004o`00o`D000?o00000`05P@03ok^k02Bk1?l8^`03oh6100N1
0_l9P@03ok^k01Zk0_l<^`Co18401On1PH7o00B100?oPH401?lH^`F10_l30003o`000340000U0004
o`00o`D000?o000010000on1P@02P@;o023;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co
15/02_nkbk_;^l^kbol2P@Co18400on1P@07P@0Bok_;^l^kbk_;^l^kbk_;^l^k1?l04<^kbk_;^l^k
bk_;^l^kbk/4o`V100GoPH7oP@02o`:10_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>1
00CoPOoo0`000ol0000`00009@001?l00?l50003o`0000D00_l4P@;o7;/2o`UK00?o^k/01[/2o`V1
00?oPH401?l@^`Co15/00onk^`09^`Co18400on1P@07P@Co8;/6o`>10_l00`3oo`02oc00000V00;o
1P000ol000070003oh6100>101ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`QK0_l02<^k
bk_;^l^k0_l8P@;o01;;^l^kbk_;^l^kbk_;^l^kbk/2o`UK00Wobk_;^l^kbk/00_l9P@03oh6100Co
023;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Ko1U/01?n1PH42o`@000?o00002@03o`<0
0olK0000;P03o`T000?oPH400X42oafk00?oFe/00ol4F`;o2;/00on1P@03o`bk1?l8^`03oe]K00MK
00?o^k/01k/00on1P@07P@;o2;/00onk^`0E^`Co15/00omKF`06F`05oh61oh400_l30003o`0000T0
00?o00001@000ol0000H0000;P000ol0000:00;o18407_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`;o2E/02Onkbk_;^l^kb`02o`0<^l^kbk_;^l^kbk_;0ol4P@;o00S;^l^kbk_;o`9K1?l03/^k
bk_;^l^kbk_;^l_o0X44o`B101co^l^kbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^k1?l9F`03oe]K009K
0_l2F`;o18400ol0o`02o`X000?o00001@000ol0000H0000;P000ol0000<0003oh6100:100?o^k/0
7;/00omKF`07F`03ok^k00nk1?l9P@03ok^k00Fk0_lB^`;o2H400onk^`04^`03ok^k00fk1?l4F`03
oe]K00MK1?l6F`03oh6100:100Co00000_l80003o`0000800olK0000;P000ol0000=0003oh6100:1
0_l07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`9K1?l04;_;^l^kbk_;^l^kbk_;^l/4o`B1
00?oPH401h42o`0K^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2842o`0>bk_;^onkbk_;^l^k
bk/6o`UK00?oFe/01?l01L^kbk_o00QK00GoPH7oP@02o`<000?o00001@000ol000020003o`0001/0
000]0003o`0000l00_l4P@;o7;/2oa:k0_l9P@03oh6100Co18400onk^`0H^`Ko1X401Onk^k_o00>k
1_l6F`03oe]K00MK0_l9^`03oe]K009K0_l2F`;o18401On1PH7o00D00_l400Co6P0002d000?o0000
4P05P@0col^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00V1
0_l9P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol4F`;o1h400oo;^`04o`AK00?oFe/01U/00omK
F`04o`0<bk_;^l^kbk_;^l^k1_l6F`03oh6100:100Co00000_lW0000;@000ol0000B0003POn100>1
0_l`^`03oh6100Co18400on1P@07P@03ok^k016k0_l9F`03oh6100:100?oPH400ol8F`03oe]K009K
0_l2F`;o3;/4o`AK00?oFe/01U/01On1POn100;o0`000ol0000T0000;@000ol0000B0004P@3oo`B1
037o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2H400on1
P@04o`0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`09F`Co1H42o`QK1?l03/^kbk_;^l^kbk_;^l^k
1?l9F`03oe]K009K0_l2F`;o1845obD0000]00?o4@000h4000020003oh6100:100?o^k/09;/4o`Nk
0ol7P@;o7K/00omKF`04o`Bk00?oPH401H400omKF`04o`AK00?o^k/02K/4o`AK00?oFe/01e/4o`Fk
1H42o`<000?o00008P0002d000?o00004@000h40000400;o0X42o`0Pbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/4o`AK00[o^l^kbk_;^l^k1?l5P@0Nol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0_l02[_;^l^kbk_;^ol4P@03oh7o00;o0e/3G`=K00Wobk_;^l^kbk/00_l9F`03oaLG008G
0_l03<^kbk_;^l^kbk_;^`>100?oPOl00_l200;o8P0002d000?o00004@000h4000060004oh61P@;o
7;/2o`UK00?o^k/02;/00on1P@05P@03ok^k02Jk1?l2^`04ok^ko`9K15l3F`;o2;/2o`AK00QO5elG
GaLA5`nk0_l4P@Ko8@0002d000?o00004@000h4000070003oh6100:101oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00UK0_l02/^kbk_;^l^kbol4P@03oh6100;o036kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l_o009K1El03amKFonkbk_;^l^k5elGG`075`0D
FaLGbk_;^l^kbk_;^l^kbk_;^l/5P@;o0`000ol0000N0000;@000ol0000A0003P@0000T00_l2P@;o
7;/00omKF`04o`AK00?o^k/01k/4o`F10_lZ^`09ok^kGamO7elO00AO0U/55`06GaMO5elG0Ul00aMO
F`04F`8G4k/3o`03POoo00Co7`0002`000?o00004P000h40000:0003oh6100:10_l06k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`UK00cobk_;^l^kbk_;^ol8P@0dol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kGaMO5eooF`UO00XGGaMO5k_;^l_o15/2o`0G4AOo^l^k
bk_;^l^kbk_;^l^kbk_;^l/01842o`030?l001h0000/0003o`00018000>100002`000on1P@03P@;o
6k/3o`MK00?o^k/02;/00on1P@02P@;o0X42obNk00?o^k/00[/00elOG`027`03GaLG00<G0e/00onk
^`07^`Co0U/24@03Fonk01>k1843oal0000/00?o4P000h40000>00;o0h42o`0J^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/6o`0?^l^kbk_;^l^kbk_;^l^k00Co1X42o`0Ybk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kboo;^l/00_l00amO7`02G`037elO00IK00cobk_;^l^kbk_;^ol3F`0I
Wa5KFonkbk_;^l^kbk_;^l^kbk_;^l^kb`06oal0000/0003o`00018000>100003`000on1P@03P@03
ok^k01>k1?l4F`03ok^k012k00?oPH401h42ob>k1?l015]OGel47`03GamO009K0_l2F`03ok^k00Rk
00?oFe/00Yl00omKF`02o`bk1?l5P@:k0_lN0000;0000ol0000B0003P@00010000?oPH400h42o`0>
bk_;^l^kbk_;^l^kbk/5o`UK01Co^l^kbk_;^l^kbk_;^l^kbk_;o`:11?l4P@0Ook_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`05o`9K00LOGalG7aLO00=O0al03aO;^l^kbk_;^l^kbk_;^`04o`:O
1E/2o`04^l^kb`Ko1H45o`030?l001h0000/0003o`00018000>100004P02o`B100?o^k/01k/4o`EK
00?oFe/01e/00onk^`0@^`;o2H400onk^`0E^`Ko15/02OmKFaMO5elGG`02o`8O00FkGalOG`09^`Co
0e/01?oOgil6F`Co1846o`P000?o0000700002`000?o00004@000h40000E0003oh6100:100cobk_;
^l^kbk_;^ol7F`03oe]K00Co01Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@;o017;^l^kbk_;^l^k
bk_;^l^kb`04o`IK0_l2F`06oe]K7aLO0_l03K_;^l^kbk_;5alG7el01_l8F`>O1?l9P@;o3@000ol0
000L0000;0000ol0000A0003P@0001D000>1oh400h42o`Vk00?oFe/00U/00omKF`02oabk00?oPH40
1?l4P@03ok^k012k00?oFe/01e/4o`fk0_l01ElOGamO00EK0_l7F`:O1X44oa8000?o0000700002`0
00?o00004@000h40000E0004P@3oo`B10_l02<^kbk_;^l^k1?l08/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/2o`V100Gobk_;^`06o`09bk_;^l^kbk_o009K1?l03k_;^l_obk_;^l^kbk_;
^`04o`=K00HG7elOGal5F`Co0h4019oOool3P@03o`0001@000?o0000700002/000?o00004P000h40
000E0003P@0000801H400onk^`0]^`;o2844o`IK0_l7^`;o2;/00onk^`03^`Go1E/57`03GamO00?o
28400ooOW`040003P@0001D000?o0000700002/000?o0?l04P000h40000E0003P@0000<000?oPH40
0X42o`0`^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o0X43o`AK
00?oFe/01e/04onkbk_;^l^kbk_;^l^kbk_;ol/01?l5F`0=7elOGamO7elOGomO7`05P@Co0`02g`@0
00>100005@000ol0000L0000:`02oa<000>100005@000h40000400;o18400onk^`0Y^`Ko25/00omK
F`04oa>k00?o^k/03Ql4P@Co0h400ol0000500;O1@000h40000D0003o`0001`0000[0003o`000180
00>1000050000h4000070003oh6100:101;o^l^kbk_;^l^kbk_;^l^kbk/4o`0Abk_;^l^kbk_;^l^k
bk_;^l/01?l6F`;o1e/2o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^aoo1al015lOGal8P@;o3P000mkO
00040003P@0001@000?o0000700002/000?o00004P000h40000D0003P@0000T00_l2P@;o2k/4o`AK
00?o^k/04;/00omKF`07F`Co1H400onk^`0C^`037olO008O1?l5P@Co4`000moN00040003P@0001@0
00?o0000700002/000?o00004P000h40000D0003P@0000X000?oPH400X42o`07^l^kbk_;^`02o`UK
00Gobk_;^`06o`09bk_;^l^kbk_o009K1?l01K_;^l_o00N101;obk_;^l^kbk_;^l^kbk_;^l/6o`B1
1?l2P@03o`0001D00]l50003P@0001D000?o00006`0002/000?o00004P000h40000D0003P@0000/0
00?oPH400h42o`Nk0_l8F`Co1U/2o`Nk0_l9^`03oh6100:100?oPH400_l<^`?o18400on1P@02P@;o
7@02gPD000>100005@000ol0000K0000:`000ol0000B0003P@0001@000>100003@02o`B100[obk_;
^l^kbk_o0U/3o`AK00?oFe/01e/04onkbk_;^l^kbk_;^l^kbk_;^l/01?l5P@;o00C;^l^k1_l4P@Go
0P000h40000M0003g]l000@000>100005@000ol0000K0000:`000ol0000A0003P@0001D000>10000
3`000on1P@02P@03ok^k00Jk0_l8F`03oe]K00Co5k/00on1P@06P@Co1845o`@000Go0000P@0O0003
gmh000@000>100005@000ol0000K0000:P001?l0oolA0003P@0001D000>100004@001?n1PH42o`08
^l^kbk_;^l/2o`MK0_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00:10ol9P@03o`0000L0
00Go0000P@0O00;N1@000h40000E0003o`0001/0000Z0003oh61018000>100005@000h40000B00;o
0h400onk^`07^`Co7[/6o`B11Ol=0005o`0008407`000moNgP040003P@0001D000?o00006`0001X0
0ol400;o1`000ol00002PA0000>100005@000h40000D000Yoh61POnkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/01_l4P@Go4`001Ol0002102000]h40003P@0001D000?o00006`0001/0
00?o00000P001?l00?l60003o`00008000>100003@000h40000E0003P@0001@000F1ooooP@02oank
0ol9P@03o`0001H000Go0000P@0P0003LMh000<000>100005@000ol0000K00006`000ol000020004
o`00o`H000?o00000`02P@d000>100005@000h40000D0004P@00o`>10ol05/^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/6o`B11OlL0005o`0008408002gP@000>100005@000ol0000K00006`000ol000020004
o`00o`H000?o00001@02P@/000>100005@000h40000D0005P@000?l01H42o`jk1_l4P@Co00<0P@00
80001Ol0002102000]h40003P@0001D000?o00006`0001/000?o00000P001?l00?l60003o`0000L0
00>1000020000h40000E0003P@0001@000>100000`02o`B100_o^l^kbk_;^l^kb`03o`>10ol3P@03
o`0000<000>100007`001Ol0002102000W450003P@0001D000?o00006P0001X00_l500;o1`000ol0
000800:120000h40000E0003P@0001@000>100001@000on1P@02P@03ok^k00:k1Ol5P@;o2`000h40
000P0005o`0008407`000mia00040003P@0001D000?o00006P0002X00_l;00:11P000h40000E0003
P@0001@000>100001P000on1P@02P@Co0h44oa0000>1000080001Ol0002101l000=agP0010000h40
000E0003o`0001X0000Y00;o3P000h4000030003P@0001D000>1000050000h40000700;o0k/3o`:1
00?o00004P000h40000P0005o`0008407`02L@D000>100005@000ol0000J0000:@000ol0000>00:1
0`000h40000D0003P@0001@000>100002P03oaX000>1000080001Ol0002101l000?ML@0010000h40
000E0003o`0001X0000Y0003o`0001000h4G0003P@0001@000>100002P000ol0000J0003P@000200
00Go0000P@0O0003LID000@000>100005@000ol0000J0000:@000ol0000B00:15P000h40000D0003
P@0000X000?o00006P000h40000P0005o`0008407`000iEa00040003P@0001D000?o00006P0002T0
00?o00004P000h40P@0E0003P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0O0003
LID000@000>100005@000ol0000J0000:@000ol0000B0003P@0000:14`000h40000D0003P@0000X0
00?o00006P000h40000P0005o`0008407`000iGMU@040003P@0001D000?o00006P0002T000?o0000
4P000h40000200:14@000h40000D0003P@0000X000?o00006P000h40000P0005o`0008407`000mfE
g0040003P@0001H000?o00006@0002T000?o00004P000h4000040003P@0000h000>1000050000h40
000:0003o`0001X000>1000080001Ol0002102000YD40003P@0001H000?o00006@0002T00olB0003
P@0000D00X4>0003P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0P00:E10000h40
000F0003o`0001T0000X0003o`0001<000>100001`02P@`000>1000050000h40000:0003o`0001X0
00>1000080001Ol0002102000]`40003P@0001H000?o00006@0002P000?o00004`000h4000090003
P@0000T000>1000050000h40000:0003o`0001X000>1000080001Ol0002102000]`50003P@0001D0
00?o00006@0002P000?o00004`000h40000:00:12@000h40000D0003P@0000X000?o00006P000h40
000P0005o`0008408002g0D000>100005@000ol0000I0000:0000ol0000C0003P@0000`00X470003
P@0001@000>100002P000ol0000J0003P@00020000Go0000P@0P0003g>`000@000>100005@000ol0
000I0000:0000ol0000B0003P@0000l000>1000010000h40000D0003P@0000X000?o00006P000h40
000P0005o`00084080000ncL00040003P@0001D000?o00006@0002P000?o00004P000h40000@00:1
10000h40000D0003P@0000X000?o00006P000h40000P0005o`00084080000ncL00040003P@0001<0
0X400on1000I0000:0000ol0000B0003P@0001800X420003P@0001@000>100002@000ol0000K0003
P@00020000Go0000P@0P0003k=`000@000>100003P05P@<000?o0000600002P00olB0003P@0001@0
0h4F0003P@0000T000?o00006`000h40000P0005o`0008408002g0D000>100002006P@P000?o0000
600002P000?o00004P000h40000E00:15P000h4000090003o`0001/000>1000080001Ol000210200
0^`50003P@0000801X4>0003o`0001P0000W0003o`0001<000>100005@001840PH4D0003P@0000T0
00?o00006`000h40000P0005o`00084080000ncL000400F150000ol0000H00009`000ol0000C0003
P@0001D000B100000X4B0003P@0000T000?o00006`000h40000P0005o`00084080000mc/g005PAP0
00?o0000600002L000?o00004`000h40000E0003P@0000<000>100003`000h4000090003o`0001/0
00>1000080001Ol0002101`01H42k0@000>100005P000ol0000H00009`000ol0000C0003P@0001D0
00>100001002P@l000>100002@000ol0000K0003P@00020000Go0000P@0F00J11@000nbg00030003
P@0001H000?o0000600002L000?o00004`000h40000E0003P@0000H00X4=0003P@0000T000?o0000
6`000h40000P0005o`0008404@05P@/00[L50003P@0001D000?o0000600002L000?o00004`000h40
000E0003P@0000P000>100002@000h40000:0003o`0001/000>1000080000ol000020003P@0000P0
1X4@0003]kH000@000>100005@000ol0000H00009`03oa8000>100005P000h40000900:12@000h40
000:0003o`0001/000>1000080000ol000020003P@0000801X4F00:f1@000h40000E0003o`0001P0
000W0003o`00018000>100005P000h40000;00:11`000h40000:0003o`0001/000>1000080000ol0
000200F17002]PD000>100005P000ol0000G00009`000ol0000B0003P@0001H000>100003@02P@D0
00>100002P000ol0000K0003P@0001l000>1oh40184P0003]kH000@000>100005P000ol0000G0000
9P000ol0000C0003P@0001H000>100003`000h4000020003P@0000X000?o00006`000h40000J00F1
00<0o`000`000h40000N00:f1@000h40000F0003o`0001L0000V0003o`0001<000>100005P000h40
000@00:10P000h40000:0003o`0001/000>100005006P@H000?o00000P000h40000N00:f1@000h40
000F0003o`0001L0000V0003o`0001<000>100005P000h40000B00>130000ol0000K0003P@0000h0
1X4=0005o`00084080000obf00040003P@0001H000?o00005`0002H000?o00004`000h40000F0003
P@0001@000>100002P000ol0000K0003P@0000T01H4C0005o`0008408002]PD000>100005P000ol0
000G00009P000ol0000C0003P@0001H000>100005003P@X000?o00006`000h40000300J160001Ol0
002102000[D50003P@0001H000?o00005`0002H000?o00004`000h40000F0003P@0001@000>10000
0X480003o`0001/01X4N0005o`00084080000kJeo0040003P@0001H000?o00005`0002H000CoPOoo
4P000h40000F0003P@0001@000>100000P000h4000050003o`0001H01X4S0005o`00084080000kD=
]@040003P@0001H000?o00005`0001H01?l300;o1`001?l0PH4B0003P@0001D000>100005@000h40
000300:11@000ol0000A00F11@000h40000Q0005o`0008408@000`fe00030003P@0001L000?o0000
5P0001L000?o00000P001?l00?l60005o`0008404@000h40000E0003P@0001D000>100001@02P@<0
00?o00002`06P@X000>100008@001Ol0002102400[D50003P@0001H000?o00005P0001P000Go0000
o`020003o`0000<000?o00000`02P@h000>100005P000h40000E0003P@0000L000B1003o1`06PA00
00>100008@001Ol0002102400[D50003P@0001H000?o00005P0001T000Co003o0P000ol000030003
o`0000D00X4<0003P@0001H000>100005@000h40000800:100?o00001H4F0003P@00024000Go0000
P@0Q0003]@d000@000>100005P000ol0000F00000P03oa4000Co003o0P001?l00?l50003o`0000L0
0X4:0003P@0001H000>100005@000h40000:0003oh6101/000>100008@001Ol0002102400Pd50003
P@0001H000?o00005P00008000Co003o4@02o`@00_l60003o`0000T00X480003P@0001H000>10000
5@000h40000:0003o`0001/000>100008@001Ol0002102400Pd50003P@0001H000?o00005P000080
00?o000080000ol0000;0003P@0000D000>100005P000h40000E0003P@0000X000?o00006`000h40
000Q0005o`0008408@000`g<00040003P@0001H000?o00005P00008000?o000080000ol0000<00:1
1@000h40000F0003P@0001D000>100002P000ol0000K0003P@00024000Go0000P@0Q0003c0d000@0
00>100005P000ol0000F000000<0ool00_lP00?o3P02P@<000>100005P000h40000E0003P@0000X0
00?o00006`000h40000Q0005o`0008408@000l`=00040003P@0001H000?o00005P00008000?o0000
80000ol0000@00:100<0P@005`000h40000E0003P@0000X000?o00006`000h40000Q0005o`000840
8@000l`=00040003P@0001H000?o00005P00008000?o000080000ol0000B00:160000h40000E0003
P@0000X000?o00006`000h40000Q0005o`0008408@023@D000>100005`000ol0000E00009@000ol0
000C00:15`000h40000D0003P@0000/000?o00006`000h40000Q0005o`0008408@000`g<00040003
P@0001L000?o00005@0002@000?o000050001840PH4E0003P@0001@000>100002`000ol0000K0003
P@00024000Go0000P@0Q008=00?<00000P000h40000G0003o`0001D0000T0003o`0001<000>10000
0P02PA<000>1000050000h40000;0003o`0001/000>100008@001Ol0002102400l`40003P@0001L0
00?o00005@0002@000?o00004`000h40000400:14@000h40000D0003P@0000/000?o00006`000h40
000Q0003o`00008000>100007`02c0D000>100005P000ol0000E000090000ol0000C0003P@0000H0
00>100003P000h40000D0003P@0000/000?o00006`000h40000Q0003o`00008000>100007`02c0D0
00>100005P000ol0000E000090000ol0000C0003P@0000L00X4=0003P@0001D000>100002P000ol0
000L0003P@00024000?o00000P000h40000O00;01@000h40000F0003o`0001D0000T00?o4`000h40
000900:12`000h40000E0003P@0000X000?o000070000h40000Q0003o`00008000>100007`02`0D0
00>100005P000ol0000E000090000ol0000C0003P@0000/00X490003P@0001D000>100002P000ol0
000L0003P@00024000?o00000P000h40000O0003`<H000@000>100005P000ol0000E000090000ol0
000C0003P@0000d00X470003P@0001D000>100002P000ol0000L0003P@00024000?o00000P000h40
000O0003`<H000@000>100005`000ol0000D000090000ol0000C0003P@0000l000>1000010000h40
000E0003P@0000X000?o000070000h40000Q0003o`00008000>100007`000lK000040003P@0001L0
00?o0000500002<000?o000050000h40000@00:110000h40000E0003P@0000X000?o000070000h40
000Q0003o`00008000>100007`02aPD000>100005003P@03o`0001@0000S0003o`0001@000>10000
4P02P@8000>100005@000h40000:0003o`0001`000>100008@000ol000020003P@0001l00/H50003
P@0000h01X430003o`0001@0000S0003o`0001@000>100005003PAL000>100002P000ol0000L0003
P@00024000?o00000P000h40000O0003S<H000@000>100002@05P@T000?o0000500002<000?o0000
4`000h40000G0003P@0001D000>100002P000ol0000L0003P@00024000?o00000P000h40000O00:<
1@000h40000300J13P000ol0000D00008`000ol0000C0003P@0001L00h4E0003P@0000X000?o0000
70000h40000Q0003o`00008000>100007`000ha<S00400J150000ol0000D00008`03oa<000>10000
5`000h400002PA<000>100002P000ol0000L0003P@00028000Go0000P@0Q00:<00=<PH400h4I0003
o`0001@0000S0003o`0001<000>100005`000h40000200:14@000h40000:0003o`0001`000>10000
8P001Ol0002101`01X42S0D000>100005P000ol0000D00008`000ol0000C0003P@0001L000>10000
1002P@l000>100002P000ol0000L0003P@00028000Go0000P@0G00F11P02C0D000>100005`000ol0
000C00008`000ol0000C0003P@0001L000>100001P000h40000<0003P@0000X000?o000070000h40
000R0005o`0008404@06P@/000><C00010000h40000G0003o`0001<0000R0003o`0001@000>10000
5`000h40000700:130000h40000:0003o`0001`000>100008P001Ol0002100/01X4A00:<1@000h40
000G0003o`0001<0000R0003o`0001@000>100005`000h40000900:12P000h40000:0003o`0001`0
00>100008P001Ol0002100D01X4G009<1@000h40000G0003o`0001<0000R0003o`0001@000>10000
5P000h40000<00:120000h40000:0003o`0001`000>100008P001?l00006PAd000=<S00010000h40
000G0003o`0001<0000R0003o`0001@000>100005P000h40000>00:11@000h40000;0003o`0001`0
00>100008@000h7oP@03PB8000><C00010000h40000G0003o`0001<0000R0003o`0001@000>10000
5P000h40000@0003P@00008000>100002`000ol0000L0003P@0001/01X400`3o00020003P@000200
0T`50003P@0001L000?o00004`0002800olC0003P@0001L000>100004@02P@8000>100002`000ol0
000L0003P@0001D01X470005o`0008408P000de<00040003P@0001L000?o00004`00028000?o0000
4`000h40000G0003P@0001<00h4=0003o`0001`000>100003`06P@d000Go0000P@0R0003C4d000@0
00>100005`000ol0000C00008P000ol0000C0003P@0001L000>100005@02P@`000?o000070000h40
000900J14`001Ol0002102800T`50003P@0001L000?o00004`00028000?o00004`000h40000G0003
P@0001D000>108402`000ol0000L0003P@0000@01H4I0005o`0008408P000de<00040003P@0001P0
00?o00004P00024000?o000050000h40000G0003P@0001D000>100000X490003o`0001`01h4N0003
o`00008000>100007`02C003C@0000<000>100005`000ol0000B00008@000ol0000D0003P@0001L0
00>100005@000h40000200:11`000ol0000G00J190000ol000020003P@0001l000==C4`01@000h40
000G0003o`000180000Q0003o`0001@000>100005`000h40000E0003P@0000@00X450003o`000140
1X450003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180000Q0003o`0001@0
00>100005`000h40000E0003P@0000H00X430003o`0000/01X4;0003P@00028000?o00000P000h40
000P0003C4d000@000>100005`000ol0000B00008@000ol0000D0003P@0001L000>100005@000h40
00080004P@00o`P01H4A0003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180
000Q0003o`0001@000>100005`000h40000E0003P@0000T00X400ol00006PAH000>100008P000ol0
00020003P@0002000Td50003P@0001L000?o00004P00024000CoPOoo4`000h40000G0003P@0001D0
00>100002`000on1P@0L0003P@00028000?o00000P000h40000P009=1@000h40000G0003o`000180
000A00?o1002o`L000Co08614`000h40000G0003P@0001D000>100002`000ol0000M0003P@000240
00?o00000P000h40000P0003ITd000@000>100005`000ol0000B000050001?l00?l20003o`0000@0
00Co00000X4@0003P@0001P000>100005@000h40000;0003o`0001d000>100008@000ol000020003
P@00020000==IP0010000h40000H0003o`000140000D0004o`00o`8000?o00000`000ol0000400:1
3P000h40000G0003P@0001H000>100002`000ol0000M0003P@00024000?o00000P000h40000P009V
1@000h40000H0003o`000140000B00;o0`001?l00?l50003o`0000H00X4<0003P@0001L000>10000
5P000h40000;0003o`0001d000>100008@000ol000020003P@00020000==CP0010000h40000H0003
o`000140000D0004o`00o`8000?o00000`000ol0000800:12P000h40000G0003P@0001H000>10000
2`000ol0000M0003P@00024000?o00000P000h40000P0003ITd000@000>1000060000ol0000A0000
4@03o`@00_l60003o`0000X00X480003P@0001L000>100005P000h40000:0003o`0001h000>10000
8@000ol000020003P@00020000=VCP0010000h40000H0003o`000140000P0003o`0000`00X460003
P@0001L000>100005P000h40000:0003o`0001h000>100008@000ol000020003P@0002000VH60003
P@0001L000?o00004@00020000?o00003P02P@@000>100005`000h40000F0003P@0000X000?o0000
7P000h40000Q0003o`00008000>100008003IPD000>100005`000ol0000A00008003oa000X420003
P@0001L000>100005P000h40000:0003o`0001h000>100008@000ol000020003P@00024000=VCP00
10000h40000G0003o`000140000P0003o`0001800h4I0003P@0001D000>100002`000ol0000N0003
P@00024000?o00000P000h40000Q0003@Th000@000>100005`000ol0000A000080000ol0000D00:1
60000h40000E0003P@0000/000?o00007P000h40000Q0003o`00008000>100008@000diV00040003
P@0001L000?o00004@0001l000?o00005@001840PH4F0003P@0001D000>100002`000ol0000N0003
P@00028000Go0000P@0S0003IT8000@000>1000060000ol0000@00007`000ol0000D0003P@000080
0X4D0003P@0001D000>100002`000ol0000N0003P@00028000Go0000P@0S00921@000h40000H0003
o`000100000O0003o`0001@000>100001002PA8000>100005@000h40000;0003o`0001h000>10000
8P001Ol0002102<00T850003P@0001P000?o0000400001l000?o000050000h40000600:140000h40
000E0003P@0000/000?o00007P000h40000R0005o`0008408`000d9?00040003P@0001P000?o0000
400001l000?o000050000h40000800:13P000h40000E0003P@0000/000?o00007P000h40000R0005
o`0008408`000dm200040003P@0001P000?o0000400001l000?o000050000h40000:00:130000h40
000E0003P@0000/000?o00007P000h40000R0005o`0008408`02@PD000>1000060000ol0000@0000
7`000ol0000D0003P@0000`00X4:0003P@0001D000>100002`000ol0000N0003P@00028000Go0000
P@0S0003@Tl000@000>1000060000ol0000@00007`03oa@000>100003P02P@L000>100005P000h40
000;0003o`0001h000>100008P001Ol0002102<000=?@P0010000h40000H0003o`000100000O0003
o`0001@000>100004002P@D000>100005P000h40000;0003o`0001h000>100008P000ol000020003
P@0002000Tl60003P@0001L000?o0000400001h000?o00005@000h40000B00:10`000h40000F0003
P@0000/000?o00007P000h40000R0003o`00008000>100008003C`D000>100005@03P@03o`0000l0
000N0003o`0001D000>100005002P@03084001L000>100002`000ol0000N0003P@00028000?o0000
0P000h40000P00=?1@000h40000>00N10`000ol0000?00007P000ol0000E0003P@0001H00X4H0003
P@0000/000?o00007P000h40000R0003o`00008000>100008@000cm?00040003P@0000P01X4:0003
o`0000l0000N0003o`0001@000>100006003PAH000>100002`000ol0000N0003P@00028000?o0000
0P000h40000Q0003Ccl000@000B100001h4@0003o`0000l0000N0003o`0001@000>1000060000h40
0002PA@000>100002`000ol0000N0003P@00028000?o00000P000h40000Q008o0P07PAL000?o0000
3`0001h000?o000050000h40000H0003P@0000800X4B0003P@0000/000?o00007P000h40000R0003
o`00008000>100007`02P@04Ccn1P@<000>1000060000ol0000?00007P000ol0000D0003P@0001P0
00>100001002PA0000>100002`000ol0000N0003P@0001l01Ol30003P@0001P01h42009?1@000h40
000H0003o`0000l0000N0003o`0001@000>1000060000h40000600:13P000h40000;0003o`0001h0
00>100006007o`D00_l00`21000C00J12@02?`D000>1000060000ol0000?00007P02oaD000>10000
60000h40000800:130000h40000;0003o`0001h000>100004P06o`h000?oP@003007P@l000=??`00
10000h40000H0003o`0000l0000M0003o`0001D000>1000060000h40000:00:12P000h40000;0003
o`0001h000>100002`07oaD00_l500N15P000cm?00040003P@0001P000?o00003`0001d000?o0000
5@000h40000H0003P@0000`00X480003P@0000/000?o00007P000h40000500Ko7002P@;o0h4M008o
1@000h40000I0003o`0000h0000M0003o`0001D000>1000060000h40000>00:11@000h40000<0003
o`0001h000>1ool01OlL00N10`02oah000<o80001@000h40000H0003o`0000h0000M0003o`0001D0
00>1000060000h40000@00:10`000h40000<0003o`0001T01_lM00J11P000h40000300;o700280H0
00>1000060000ol0000>00007@000ol0000E0003P@0001P000>100004P02P@03084000d000?o0000
4P07o`D000>100005007P@`000>100001@000ol0000I008P1P000h40000H0003o`0000h0000M0003
o`0001D000>1000060000h40000D00:13P000ol0000<00Ko30000h40000=00N14`000h40000600;o
6@028@03800000<000>1000060000ol0000>00007@000ol0000D0003P@0001P000>100005P03P@`0
00?o00001@07oa8000>100001`06PAX000>100002002oaP00R050003P@0001P000?o00003P0001d0
00?o000050000h40000H0003P@0001H000>100000X4:0003o`3o00Go6@000h400007PB0000>10000
2P02oaH00R050003P@0001P000?o00003P0001d000?o000050000h40000H0003P@0001H000>10000
0P02P@<01olL00J19`000h40000<0003o`0001<00R450003P@0001P000?o00003P0001`000?o0?l0
5@000h40000H0003P@0001H000B100001_l50003o`0001@01h430003P@0002L000>100003@02oa<0
0R450003P@0001P000?o00003P0001`00_lF0003P@0001P000>100005006o`D00X440003o`0000d0
1h4:0003P@0002L000>100003`02oa400R450003P@0001T000?o00003@0001`000?o00005@000h40
000H0003P@0000d01ol20003P@0000P00X400`3o000900J14@000h40000W0003P@0001400_l?008Q
1@000h40000I0003o`0000d0000L0003o`0001D000>1000060000h40000700Ko2@000h40000:0003
POl000801h4G0003P@0002L000>100004`02o`d00Rl50003P@0001T000?o00003@0001`000?o0000
5@000h40000H0003P@0000Oo3`000h40000;0004oh61PAh000>100009`000h40000E0003o`0000X0
0R450003P@0001T000?o00003@0001`000?o00005@000h40000E00Ko5P000h40000;0003o`0001l0
00>100009`000h40000F00;o2P000b4R00040003P@0001T000?o00003@0001`000?o00005@000h40
000>00Oo0`000h40000F0003P@0000/000?o00007`000h40000X0003P@0001L00_l80003;b8000D0
00>1000060000ol0000=000070000ol0000E0003P@0000P01_l:0003P@0001H000>100002`000ol0
000O0003P@0002P000>100006@02o`H000<Q8P001@000h40000H0003o`0000d0000L0003o`0001@0
00>100000P07oa0000>100005P000h40000;0003o`0001l000>10000:0000h40000K0003o`0000<0
0R860003P@0001P000?o00003@0001/000?o00005006oaL000>100005P000h40000;0003o`0001l0
00>10000:0000h40000L00;o0`028PH000>1000060000ol0000=00006`000ol0000=00Oo00<0P@00
6P000h40000F0003P@0000/000?o00007`000h40000X0003P@0001h00_l0100R8Ql50003P@0001T0
00?o0000300000`00ol300;o1`001?n1ool600Ko20000h40000I0003P@0001H000>100002`000ol0
000O0003P@0002P000>100008002o`037b8000@000>100006@000ol0000<00003@001Ol0003o0080
00?o000010000ol0P@07o`h000>100006@000h40000F0003P@0000/000?o00007`000h40000X0003
P@0002800_l50003P@0001T000?o0000300000/01?l20004o`00o`H00ol00`21P@0B0003P@0001P0
00>100005`000h40000;0003o`0001l000>10000:0000h40000R00037b;o00@000>100006@000ol0
000<00002`000ol0o`030004o`00o`P00_l200>13`000h40000H0003P@0001L000>100002`000ol0
000O0003P@0002P000>100008P027`030?oo008000>100006@000ol0000<00002`000ol0o`030004
o`00o`X00_l300:13@000h40000H0003P@0001H000>1000030000ol0000O0003P@0002P000>10000
8P027`<00_l00h40000I0003o`0000`0000<00;o1002o`d00ol200:12`000h40000H0003P@0001H0
00>1000030000ol0000O0003P@0002P000>10000:@02oaX000?o0000300002@00_l200:12@000h40
000H0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:@000h40o`0I0003o`0000`0
000V00;o0P02P@L000>1000060000h40000F0003P@0000`000?o00007`000h40000X0003P@0002T0
00>100000_lG0003o`0000`0000X00;o0P03P@<000>100006@000h40000F0003P@0000`000?o0000
7`000h40000X0003P@0002X000B100000_lE0003o`0000`0000Z00;o0`02P@03084001X000>10000
5P000h40000<0003o`0001l000>10000:0000h40000Z0003P@0000<00_lD0003o`0000/0000/00?o
0P02PA/000>100005P000h40000<0003o`0001l000>10000:0000h40000Z0003P@0000D00_lB0003
o`0000/0000_00;o00@0PH616@000h40000F0003P@0000`000?o00007`000h40000X0003P@0002X0
00>100001`000ol0000?0003o`0000/0000a00;o0P02PAL000>100005P000h40000<0003o`0001l0
00>10000:0000h40000Z0003P@0000P00_l?0003o`0000/0000b0003POoo00800h4D0003P@0001H0
00>1000030000ol0000O0003P@0002P000>10000:P000h40000:00;o3@000ol0000;0000=@02o`<0
0X4B0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:P000h40000<00;o2`000ol0
000;0000=`03o`800X4@0003P@0001H000>1000030000ol0000O0003P@0002P000>10000:P000h40
000>0003o`0000P000?o00002`0003X00_l200:13P000h40000F0003P@0000`000?o00007`000h40
000X0003P@0002X000>100003`02o`P000?o00002`0003`00_l200:130000h40000F0003P@0000`0
00?o00007`000h40000X0003P@0002X000>100004@02o`H000?o00002`0003h00_l200>120000h40
000G0003P@0000`000?o00007`000h40000X0003P@0002X000>100004`02o`D000?o00002P000400
0_l300:11P000h40000G0003P@0000`000?o00007`000h40000X0003P@0002X000>100005@02o`<0
00?o00002P0004800ol200:110000h40000G0003P@0000`000?o00007`000h40000Y0003P@0002T0
00>100005P001H7oPH7o00`0001500;o0P02P@8000>100005`000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000h01h4200?o300004L00_l200>16@000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000L01h4700Go300004T00_l200>15`000h40000<0003o`0001l000>10000
:@000h40000Z0003P@0000N11`07oa40001;00;o00>100000X4E0003P@0000`000?o00007`000h40
000Y0003P@0002D0284700Oo600004d00ol200:14`000h40000<0003o`0001l000>10000:@000h40
000N00N11@000h400007oal0001@00;o0P02PA0000>1000030000ol0000P0003P@0002T000>10000
5`07P@L02?lV0000DP02o`800X4>0003P@0000`000?o000080000h40000Y0003P@0001001h4700Oo
;P0005@00_l200>12`000h40000<0003o`00020000>10000:@000h40000800R11`07ocD0001F00;o
0`02P@T000>1000030000ol0000P0003P@0002T000B100001h4800Oo?00005P00ol200:11`000h40
000<0003o`00020000>100009P07P@L02?m30000F`02o`800X450003P@0000`000?o000080000h40
000O00N10`0018400007od/0001M00;o0P02P@<000>1000030000ol0000P0003P@0001P01h4700Oo
DP0005l00_l200B13P000ol0000P0003P@000100284700OoF@0006400_l300:13@000ol0000P0003
P@0000T01h4800OoH00006<00ol01840PH4;0003o`00020000>100000P07P@L02?mW0000IP02o`80
0X490003o`0001h01h4700OoK`0006P00_l200:11`000ol0000F00R10P000h40000200OoMP0006X0
0_l200>110000ol0000?00N12007ogd0001/00;o0`02P@8000?o00002007P@L02?n40000KP03o`80
0X401?l00007P@L01on<0000L@02o`8000CoPH611`07oi<0001c00?o0`07oiX0001e00CoX@000?l0
6`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`0007D0
00?o00009`000ol0001h0000EP04o`<01?l0103oo`02o`800_l300?o10000ol0000800Go00@0ool0
0_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<00ol300Co0`02odT0001E0005
o`000?l00P000ol000030004o`00o`<00_l60003o`00008000?o00002@001Ol0003o008000Co003o
0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o10000ol0
00030003o`0000<00_m90000E@000ol0o`02o`801Ol01@3o003o00/000?o00003P001Ol0003o0080
00Co003o0`000ol000060003o`0000h000?o00001@000ol000020003o`0000T000?o000010000ol0
001=0000E@000ol000040007o`000?l0o`020003o`0000H00olA0005o`000?l00P001?l00?l30003
o`0000H000?o00003P03o`D000?o00000P000ol000090003o`0000D000?o0000C00005D000Go0000
o`0300?o00<0ool00ol80003o`00014000?o00001Ol300Co20000ol0000>0003o`0000@00_l300Co
2@000ol000020004o`00odh0001F00Co5004o`h01Ol;0003o`0000D00_l?00Go2@000ol0000800;o
1@02odl0002?00;o8@000ol000020003o`000600003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.171525, -0.0166478, \
0.00217245, 0.003887}},
  CellTags->"AntTracker3D - Gen 5"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Movie",
          ButtonData:>{
            FrontEnd`FileName[ {
              ParentDirectory[ 
                ParentDirectory[ ]], "Movies", "AntTracker-Movies Folder"}, 
              "AntTracker-7i-Gen05.nb", CharacterEncoding -> 
              "MacintoshRoman"], None},
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[seq[stop], \ 
          advance], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ 
        advance, \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[seq[stop], \ 
          turnRight]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.5, Ind.1, Fit.12.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.5, Ind.1, Fit.12.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.44603 .5261 m .41861 .53422 L .40239 .51917 L p
.8 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.47374 .5179 m .44603 .5261 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.40239 .51917 m .42999 .5109 L .44603 .5261 L p
.8 g
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.42999 .5109 m .45788 .50253 L .47374 .5179 L p
.8 g
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .50173 .50961 L .48607 .49408 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.55862 .49278 m .53003 .50124 L .51456 .48554 L p
.8 g
F P
s
P
p
.002 w
.48607 .49408 m .51456 .48554 L .53003 .50124 L p
.8 g
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.58752 .48422 m .55862 .49278 L .54335 .47691 L p
.8 g
F P
s
P
p
.002 w
.51456 .48554 m .54335 .47691 L .55862 .49278 L p
.8 g
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .015 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .015 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.54335 .47691 m .57246 .46819 L .58752 .48422 L p
.8 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .03 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .03 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .06 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .045 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .76384 .4729 L .75043 .45663 L p
.8 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .06 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .045 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .7942 .46413 L .78102 .44769 L p
.8 g
F P
s
P
p
.002 w
.75043 .45663 m .78102 .44769 L .7942 .46413 L p
.8 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.73942 .45475 m .72426 .4592 L .71734 .45097 L p
1 .076 0 r
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.78102 .44769 m .81196 .43865 L .82489 .45527 L p
.8 g
F P
s
P
p
.002 w
.71734 .45097 m .73256 .44648 L .73942 .45475 L p
1 .076 0 r
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .091 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .091 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .166 0 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .151 0 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 .136 0 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .166 0 r
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .151 0 r
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 .136 0 r
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .196 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .181 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .121 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .106 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .196 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .181 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .121 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .106 0 r
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .212 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .212 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .242 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .227 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .242 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .227 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .348 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .332 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .272 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .257 0 r
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .348 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .332 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .272 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .257 0 r
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .363 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .363 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .317 0 r
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .302 0 r
F P
s
P
p
.002 w
.69927 .35817 m .68333 .36315 L .67578 .35393 L p
1 .287 0 r
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
1 .378 0 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .317 0 r
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .302 0 r
F P
s
P
p
.002 w
.67578 .35393 m .69178 .3489 L .69927 .35817 L p
1 .287 0 r
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
1 .378 0 r
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .015 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .03 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .045 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .06 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .076 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .091 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .106 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .121 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .136 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .151 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .166 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .181 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .196 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .212 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .227 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .242 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .257 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .272 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .287 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .302 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .317 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .332 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .348 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .363 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .378 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .393 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .408 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .423 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .438 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .453 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .469 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .484 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .499 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .514 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .529 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .544 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .559 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .574 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .589 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .605 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .62 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .635 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .65 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .665 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .68 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .695 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .71 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .725 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .741 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .756 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .771 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .786 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .801 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .816 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .831 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .846 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .861 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .877 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .892 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .907 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .922 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .937 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .952 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .967 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .982 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .997 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.987 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.972 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.957 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.942 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.927 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.912 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.897 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.882 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.866 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.851 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.836 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.821 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.806 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.791 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.776 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.761 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.746 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.73 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.715 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.7 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.685 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.67 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.655 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.64 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.625 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.61 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.594 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.579 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.564 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.549 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.534 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.519 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.504 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.489 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.474 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.458 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.443 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.428 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.413 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.398 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.383 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.368 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.353 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.338 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.322 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.307 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.292 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.277 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.262 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.247 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.232 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.217 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.202 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.186 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.171 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.156 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.141 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.126 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.111 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.096 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.081 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.065 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.05 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.035 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.02 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.005 0 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .01 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .025 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .04 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .055 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .071 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .086 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .101 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .116 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .131 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .146 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .161 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .176 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .191 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .207 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .222 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .237 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .252 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .267 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .282 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .297 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .312 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .327 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .343 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .358 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .373 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .388 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .403 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .418 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .433 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .448 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .463 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .479 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .494 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .509 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .524 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .539 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .554 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .569 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .584 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .599 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .615 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .63 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .645 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .66 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .675 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .69 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .705 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .72 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .736 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .751 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .766 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .781 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .796 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .811 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .826 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .841 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .856 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .872 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .887 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .902 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .917 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .932 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .947 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .962 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .977 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 .992 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .992 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .977 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .962 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .947 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .932 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .917 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .902 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .887 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .872 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .856 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .841 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .826 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .811 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .796 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .781 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .766 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .751 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .736 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .72 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .705 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .69 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .675 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .66 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .645 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .63 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .615 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .599 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .584 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .569 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .554 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .539 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .524 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .509 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .494 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .479 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .463 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .448 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .433 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .418 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .403 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .388 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .373 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .358 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .343 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .327 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .312 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .297 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .282 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .267 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .252 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .237 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .222 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .207 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .191 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .176 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .161 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .146 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .131 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .116 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .101 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .086 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .071 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .055 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .04 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .025 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
0 1 .01 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.005 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.02 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.035 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.05 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.065 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.081 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.096 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.111 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.126 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.141 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.156 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.171 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.186 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.202 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.217 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.232 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.247 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.262 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.277 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.292 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.307 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.322 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.338 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.353 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.368 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.383 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.398 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.413 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.428 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.443 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.458 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.474 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.489 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.504 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.519 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.534 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.549 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.564 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.579 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.594 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.61 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.625 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.64 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.655 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.67 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.685 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.7 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.715 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.73 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.746 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.761 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.776 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.791 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.806 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.821 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.836 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.851 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.866 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.882 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.897 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.912 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.927 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.942 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.957 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.972 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.987 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .997 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .982 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .967 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .952 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .937 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .922 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .907 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .892 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .877 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .861 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .846 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .831 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .816 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .801 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .786 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .771 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .756 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .741 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .725 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .71 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .695 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .68 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .665 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .65 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .635 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .62 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .605 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .589 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .574 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .559 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .544 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .529 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .514 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .499 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .484 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .469 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .453 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .438 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .423 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .408 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .393 0 r
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .015 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .03 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .045 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .06 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .076 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .091 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .106 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .121 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .136 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .151 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .166 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .181 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .196 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .212 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .227 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .242 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .257 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .272 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .287 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .302 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .317 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .332 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .348 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .363 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .378 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .393 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .408 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .423 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .438 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .453 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .469 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .484 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .499 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .514 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .529 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .544 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .559 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .574 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .589 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .605 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .62 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .635 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .65 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .665 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .68 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .695 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .71 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .725 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .741 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .756 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .771 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .786 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .801 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .816 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .831 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .846 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .861 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .877 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .892 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .907 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .922 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .937 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .952 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .967 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .982 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .997 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.987 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.972 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.957 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.942 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.927 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.912 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.897 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.882 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.866 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.851 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.836 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.821 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.806 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.791 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.776 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.761 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.746 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.73 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.715 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.7 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.685 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.67 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.655 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.64 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.625 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.61 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.594 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.579 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.564 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.549 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.534 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.519 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.504 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.489 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.474 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.458 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.443 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.428 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.413 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.398 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.383 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.368 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.353 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.338 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.322 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.307 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.292 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.277 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.262 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.247 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.232 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.217 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.202 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.186 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.171 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.156 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.141 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.126 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.111 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.096 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.081 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.065 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.05 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.035 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.02 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.005 0 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .01 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .025 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .04 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .055 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .071 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .086 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .101 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .116 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .131 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .146 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .161 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .176 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .191 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .207 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .222 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .237 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .252 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .267 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .282 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .297 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .312 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .327 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .343 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .358 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .373 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .388 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .403 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .418 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .433 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .448 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .463 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .479 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .494 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .509 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .524 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .539 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .554 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .569 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .584 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .599 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .615 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .63 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .645 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .66 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .675 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .69 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .705 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .72 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .736 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .751 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .766 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .781 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .796 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .811 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .826 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .841 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .856 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .872 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .887 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .902 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .917 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .932 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .947 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .962 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .977 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 .992 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .992 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .977 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .962 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .947 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .932 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .917 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .902 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .887 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .872 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .856 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .841 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .826 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .811 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .796 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .781 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .766 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .751 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .736 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .72 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .705 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .69 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .675 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .66 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .645 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .63 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .615 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .599 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .584 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .569 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .554 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .539 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .524 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .509 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .494 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .479 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .463 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .448 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .433 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .418 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .403 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .388 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .373 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .358 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .343 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .327 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .312 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .297 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .282 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .267 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .252 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .237 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .222 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .207 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .191 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .176 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .161 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .146 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .131 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .116 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .101 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .086 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .071 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .055 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .04 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .025 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
0 1 .01 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.005 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.02 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.035 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.05 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.065 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.081 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.096 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.111 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.126 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.141 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.156 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.171 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.186 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.202 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.217 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.232 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.247 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.262 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.277 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.292 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.307 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.322 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.338 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.353 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.368 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.383 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.398 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.413 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.428 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.443 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.458 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.474 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.489 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.504 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.519 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.534 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.549 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.564 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.579 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.594 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.61 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.625 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.64 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.655 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.67 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.685 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.7 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.715 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.73 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.746 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.761 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.776 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.791 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.806 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.821 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.836 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.851 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.866 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.882 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.897 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.912 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.927 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.942 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.957 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.972 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.987 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .997 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .982 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .967 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .952 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .937 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .922 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .907 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .892 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .877 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .861 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .846 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .831 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .816 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .801 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .786 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .771 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .756 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .741 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .725 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .71 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .695 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .68 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .665 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .65 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .635 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .62 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .605 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .589 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .574 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .559 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .544 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .529 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .514 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .499 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .484 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .469 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .453 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .438 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .423 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .408 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .393 0 r
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o<K/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0
000Z00007`000ol000090008ol^kbk_;^ol<P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol035/03onkbk_;^l^kbk_;^l^ko`0<P@03oh6100?o01Jkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0ol9F`0=ol^kbk_;^l^kbk_;^`02o`^100?oPH402X40=_nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10old^`;o0[/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0d^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00HGol^kbol8P@?o00V1ok_;
^l^kbol00P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omK
F`04F`?o0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42ocJk00Oo5elG
GaOo00:k00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol0
1X43o`B102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^k
bk_;^l^kbk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?
^l^kbk_;^l^kbk_;^l_o00J11?l2P@0aok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`06^l^kbk_o1QL01Oo;^on100?o2H402?nkbk_;^l_o0P000ol000020003
o`0000D00ol300?o6@0002D000?o00002@000onk^`03^`03oh6100?o28400onk^`0T^`;o2e/00onk
^`0O^`?o0X400onk^`0;^`03oe]K00=K0_lB^`03oh6100?o1h400onk^`0B^`?o5K/3o`03GaOo00Fk
00?oGol00_l3^`?o38400onk^`04^`04o`00o`D000?o00001@000ol000050003o`0001H0000V0003
o`0000T000Ko^l^kbk/2o`b102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
35/07_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1X404?o;^l^kbk_;^l^kbk_;oe/3o`0E
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2h404Onkbk_;^l^kbk_;^l^kbk_;00?o0el09?o;^l^kbk_;
^l^kbk_;^l^kbk_;oaMO5elGGonkbk_;^onkb`Co0U/00on1P@0;P@08ol^kbk_;^ol20003o`000080
00?o00001@000ol000050003o`0001H0000W0003o`0000T000?o^k/01;/00on1P@0:P@03ok^k02Bk
00?oFe/02U/00onk^`0F^`Co2X400onk^`0;^`03ok^k01Nk00?oPH402X400onk^`0>^`07oelOGamO
o`0B^`09oaMO5elGGaOo00Bk0ol7F`03oh6100^100?o^k/01;/01?l00?l40003o`0000@000?o0000
0P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^kb`03o`:100?oPH402X40:Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b101;o^l^kbk_;^l^kbk_;^l^kbol3G`0<
oeoobk_;^l^kbk_;1?l02;_;^l^koelG0ol01<^kbk/2o`]K00?oPH401X43o`09POnkbk_;^l_o0080
00?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1P@0:P@03ok^k02Bk
00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k00jk0ol9^`?o0aL00onk
^`04^`;o1k/00omKF`0;F`03oh6100>10_l5P@03ok^k00Bk00Co003o0P000ol0o`0400;o1004oaP0
000[0003o`0000T000Oobk_;^l_o00J10ol3P@0Xok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`9K0ol05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z100?oPH402840:on1ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01X43o`:101oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00EO017obk_;^l^kbk_;^l^kbk_;o`0=F`03oh7o00;o28402?nkbk_;^l_o
0P000ol000020003o`0002<0000/0003o`0000T000?o^k/00k/00on1P@03o`N100?o^k/09;/2oaVk
00?oPH402H400on1P@04P@?o0h400onk^`0U^`03oh6100?o1X400onk^`0B^`?o1[/01olG5aOo5ol0
3k/00omKF`0;F`03oh6100V100?o^k/01;/01?l00?l50003o`000280000]0003o`0000T000Kobk_;
^l/2o`^104?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00^100?oPH400ol7P@0Vol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/4o`Z1017obk_;^l^kbk_;^l^kbk_;^`03o`0:5elGok_;^l^kb`?o01C;^l^kbk_;^l^k
bk_;^l^kbk_;o`IK1?l2F`03oh6100Z100Sobk_;^l^ko`8000?o00000`000ol0000Q0000;P000ol0
00090003ok^k00Bk00?oPH402H400onk^`0o^`03oh6100V10_l;P@03ok^k01jk1?l2F`03oh6100Z1
00?o^k/03K/02?lOGamO7eoo7;/00omKF`03o`MK00?oPH402X400onk^`04^`04o`00o`@000?o0000
8@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH402X407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@09ol^kbk_;^l^k00;o00W;^l^kbomO5el0
0_l071Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`]K00?oPH401H43o`0:POnkbk_;^l^ko`80
00?o00000P000ol0000P0000<0000ol0000900;o1K/00on1P@09P@;o@;/00on1P@03o`J100?oPH40
2X400onk^`0G^`;o2e/00on1P@08P@03oh7o00Bk0ol00eoo^`05^`?o6[/4o`9K00?oFe/02U/00on1
P@03P@;o1H400onk^`04^`04o`00o`<000?o0?l08@0003400_l;0007ok_;^l^ko`06P@?o0h40@Oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00;o2X400on1P@0:P@0Kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00?oPH401843o`:1
02[o^l^koamO7elOok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`MK00?oFe/02U/00on1
o`02o`R100So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH40
0ol7P@03ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X402onk^olOGamO
7eoo01Zk1?l;F`03oe]K00QK00?oFol038400onk^`04^`04o`00o`@000?o00007P0003@000?o0000
2@001_nkbk_;^`;o2h40@Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100?oPH400ol08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol<F`;o2X401OnkbomO00?o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0U/00omK
F`0:F`03oe]K00AK1?l00l^ko`0=P@07ok_;^l^ko`020003o`0000<000?o00007@0003D000?o0000
2@000onk^`03^`03oh6100Z100?o^k/0?K/00on1P@08P@04oh7oobFk00?oFe/015/3o`:k00?oPH40
2X401?nk^olI^`?o1U/00omKF`0:F`03oe]K00?o1k/00on1P@0;P@03ok^k00>k00Co003o10000ol0
000M0000=P000ol000090007ok_;^l^ko`0<P@0aol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04o`0<bk_;^l^kbk_;^l_o1X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`07^l^kbk_;o`0<P@08ok_;^l^kbk/3o`0?^l^kbk_;
^l^kbk_;^l^k00;o2U/00omKF`08F`0@oe_ook_;^l^kbk_;^l^ko`J11?l2P@08ol^kbk_;^ol20004
o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z10_l[^`?o15/00onk^`09^`03oh6100?o
1h400onk^`0T^`;o2[/00on1P@08P@03oh7o00>k0ol27`03ok^k00fk00?oFe/02U/00omKF`04F`?o
4;/00on1P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;
0_l;P@0dok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J1
0ol01k_;^l^kbol01El04Oo;^l^kbk_;^l^kbk_;^l_o00aK00?oFe/00ol05<^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l;P@07ol^kbk_;o`020003o`00008000?o00006`0003X000?o00002@000onk^`02^`03
oh6100?o28400onk^`0R^`;o35/00onk^`09^`03oh6100Z100?o^k/0<;/00on1P@03o`Zk00Oo7alO
oaoo00nk00?oFe/025/01?mKoolG^`03oh6100Z100?o^k/01;/01?l00?l40003o`0001X0000k0003
o`0000T000Gobk_;^`02o`b102Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
35/03Oo;^l^kbk_;^l^kbol03840<onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`0>^l^kbk_;^l^kbk_;^l/3o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol6F`?o
0U/06oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0<P@0:ok_;^l^kbol0o`D000?o00006@0003`0
00?o00002@000onk^`03^`03oh6100Z100?o^k/08k/00omKF`0:F`03ok^k00Vk00?oPH402X400onk
^`1F^`03oe]K00?o1U/00onk^`0G^`03oh6100R100?oPOl01K/01?l00?l40003o`0001T0000m0003
o`0000T000Kobk_;^l/2o`^102Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1U/3o`9K00ko^l^kbk_;^l^kbk_;o`J10ol3P@16ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co00o;^l^kbk_;^l^kbk_;^l/0
0_l:F`0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l00002oaX0
000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0S^`03oe]K00?o1U/00onk^`0:^`03
oh6100?o1h400onk^`0o^`?o00DOGamOo`0>^`03oe]K00UK00?o^k/05k/00on1P@03o`N100?o^k/0
1;/01?l00?l40003o`0001L0000o0003o`0000T000Sobk_;^l^ko`:10ol6P@0Vok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^kbk_;^l^kbk_;00;o2h40@onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1Ql04?o;^l^kbk_;^l^kbk_;^ol;F`0Jok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`^100Oobk_;
^l_o008000?o00000`000ol0000F0000@002o`X000?o^k/01;/2o`Z100?o^k/08k/00omKF`09F`03
ok^k00Zk00?oPH402X400onk^`0f^`Co1K/00olOo`02oa6k00?oFe/01e/00omKo`0H^`03oh6100Z1
00?o^k/01;/01?l00?l40003o`0001H000120003o`0000P00_l01[_;^l^ko`^102Oo^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02e/03_nkbk_;^l^kbk_;^l_o3840=Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o11l07?nkbk_;^onk
bk_;^l^kbk_;^l^kbk_;^l^kbol6F`?o0e/06_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o38402?nk
bk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/00k/00on1P@09P@03ok^k02>k
00?oFe/02E/00onk^`0:^`03oh6100B10ol2P@03ok^k03>k00?oGel015l00onk^`08^`;o3[/00omK
F`03o`MK00?o^k/05[/00on1P@08P@03oh7o00Fk00Co003o1@000ol0000D0000A0000ol000090007
ok_;^l^ko`0;P@;o02G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00IK0ol04<^k
bk_;^l^kbk_;^l^kbol2P@?o1X40>?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbolO0ol00l^ko`02o`04^l^kb`?o014Ool^kbk_;^l^kbk_;^l^kb`02o`]K
01Wo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J11?l2P@08ol^kbk_;^ol20004o`0000;o5P0004D0
00?o00002@000onk^`03^`03oh6100B10ol3P@03ok^k02:k00?oFe/00olC^`;o2X400onk^`0c^`03
ok^k00?o0U/02onk^k_o7elOGaoo00nk00?oFe/02U/00onk^`0E^`03oh6100?o1h400onk^`04^`04
o`00o`@000?o00004`0004H000?o00002@001onkbk_;^ol00X43o`N102Cobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2h40=Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1U/06oo;^l_o7aLO
5aoobk_;^l^kbk_;^l^kbk_;o`0<F`0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co2h402_o;^l^kbk_o
0?l300?o500004L000?o00002@000onk^`03^`;o2h400onk^`0M^`?o0e/00onk^`0E^`03oh6100V1
00?o^k/0;[/3o`YK00Co^k^k0olC^`03oe]K00AK0ol2F`03ok^k012k0ol2P@03oh6100^100?o^k/0
0k/00ol00003o`8000?o00004P0004P00_l:0008ok_;^l^kbol;P@0Lol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/06Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02h42o`0[^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`9K00?oFe/02E/06oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02F`?o1U/03oo;^l^kbk_;^l^kbk_;^`03o`J100?oPH402h401_o;^l^kb`;o
00<0o`000P000ol0000B0000BP000ol0000800;o1K/00on1P@09P@03ok^k01Bk1?l;F`03ok^k01Fk
00?oPH401843o`>100?o^k/09K/3o`IK00?oFe/02E/00onk^`05^`?o3K/4o`YK00?o^k/01k/4o`Z1
00?oPH401844o`Vk00?o0?l00`000ol0000B0000B`000ol000090007ol^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol3F`03oe]K00YK01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:1
0ol7P@0Sok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l:F`03oe]K00MK00KoFoo;
^l/3o`0=7elOol^kbk_;^l^kb`03o`9K00?oFe/02E/01onkbk_;^l/00ol2P@03oh6100Z100?oPH40
0ol02;_;^l^kbk_;0ol50004o`00oa@0001<0003o`0000T000?o^k/00k/00on1P@03o`J100?o^k/0
3;/3o`MK00?oFe/02U/00onk^`0E^`;o2h400onk^`0L^`?o0U/00omKF`0:F`04oe]KF`Go1[/02?mO
7elOGaoo1K/3o`IK00?oFe/02E/00onk^`03o`J100?oPH402X42o`Nk1?l90004o`00oa<0001=0003
o`0000T000Kobk_;^l/2o`Z100cobk_;^l^kbk_;^l/2o`]K00?oFe/015/3o`0Lbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`b101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol6F`03oe]K00YK
0ol03/^kbk_;^l^kbk_;^omO0ol01K_;^l^k00;o2U/00omKF`07F`04oe_oo`Z100?oPH401843o`08
bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk^`03^`03oh6100V100?o^k/02[/00omK
F`09F`03oe]K00?o7k/00on1P@0:P@03ok^k01Fk0_l:F`03oe]K00AK0olB^`03ok^k00Jk00?oFe/0
2U/01?mKFe/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;^l^kbol0
2h403_o;^l^kbk_;^l^kbk_o2e/2o`0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1X43o`:101[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`]K00?oFe/00ol06l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`03^l_o00aK0ol8P@03oh6100Z10_l01l^kbk_;^l/00olF00;o4`000540
00?o000020000onk^`03^`03oh6100V10_l;^`03oe]K00AK0olW^`03oh6100?o1X400onk^`0F^`03
oe]K00UK0_lK^`?o00<Ook/00[/00omKF`04F`?o0X400on1P@09P@03oh6100B10ol7^`Co6003oa<0
001B0003o`0000P00_l01K_;^l_o00J10ol3P@0=ok_;^l^kbk_;^l^ko`02F`?o02_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X402oo;^l^kbk_;^l^k00;o00g;^l^k
bk_;^l^kbk_o00IK0ol0:<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;oamO7elOol^kbol2F`?o
1X400on1P@09P@03oh6100?o00Nkbk_;^l^k00?o6@03oaH0001C0003o`0000T000?o^k/00[/00on1
P@03o`N100?o^k/02K/2objk00?oPH402X400onk^`04^`?o0U/00onk^`0:^`03oe]K00?o6K/3o`Fk
00?o7al00al00onko`03o`Z100?oPH401h401?n1ool6^`Co6004oaT0001D0003o`0000T000Go^l^k
b`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00b100?obk/00ol6F`0=ol^kbk_;^l^kbk_;^`02o`0Ibk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1P@09P@03oh6100B10ol01l^kbk_;^l/0
0olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V100?o^k/0>K/00on1P@08P@04oh7oo`YK
00?o^k/09K/00olO7`037`03ok^k00>k0ol6P@03oh6100V100?oPH400ol6^`Co6004ob00001F0003
o`0000T000Oo^l^kbk_o00^10_l0>l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol3F`03oe]K00UK023obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo7`05o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000
E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03oh6100?o1e/00omKF`09F`03ok^k01Vk
0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T000?o000020001onk
bk_;^ol00X43o`N103Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/01?l;F`03oe]K00AK0ol07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`HO
00Gobk_;^`03o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X000?o000020000onk
^`03^`;o2h400onk^`0`^`Go0e/00omKF`0:F`03oe]K00?o6K/3o`Fk00?o7ol00_l3^`?o2X400on1
P@07P@04oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h40<?o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o2E/00omKF`0:F`;o01Vkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06bk_;^l^k
0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/04[/4oaNk00?oFe/025/00omK
F`04F`?o0h400onk^`0G^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk1?lH00?o=P0005d0
00?o00002@001oo;^l^kbol01X43o`:100oobk_;^l^kbk_;^l^kbk/01Ol4F`0Iol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`0:F`03oe]K00?o1h407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ob<3o`03
bk_;00Co2X400on1P@04P@?o00Rkbk_;^l^kb`?o6004ocT0001N0003o`0000T000?o^k/00k/00on1
P@03o`J100?o^k/02K/2o`YK00?o^k/02;/2o`^k00?oFe/01U/01?mKool;P@03ok^k01Nk00Co^k^k
0ol2P@03oh6100Z100?oPH400ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o2X403Oo;^l^kbk_;
^l^kbol02e/01oo;^l^kbk/00ol2F`0=ol^kbk_;^l^kbk_;o`02F`Go00Bkbk_o38406_o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co@000064000?o0000
20000onk^`03^`03oh6100V100?o^k/02K/00omKF`09F`03ok^k00?o1U/00onk^`09^`;o2K/00on1
P@0:P@03ok^k01:k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P000Oobk_;^l_o00^1
0_l02k_;^l^kbk_;^l_o00]K0_l:F`0Hol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`:1013o^l^k
bk_;^l^kbk_;^l^k1Ol3P@03oh6100V100?oPH400ol01l^kbk_;^l/00olH00CoA`0006<000?o0000
2002o`Bk00?oPH401843o`>100?o^k/02;/00omKF`04F`?o0U/00omKF`09F`03ok^k01Bk00?oPH40
0ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T000Ko^l^kbol2P@?o
1h403?nkbk_;^l^kbk_;o`9K0ol6F`03oe]K00UK01Oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z1
00Oo^l^kbk_;00?o0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0001U0003o`0000T0
00?o^k/00[/2o`^100?o^k/02;/2o`YK00?oFe/015/3oaVk00?oPH402H400onk^`03o`J100?oPH40
2H400on1P@03o`Fk1?lG00CoDP0006H000?o00002@001onkbk_;^ol02h403Onkbk_;^l^kbk_;^ol0
2U/00omKF`03o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2h42o`Z100?oPH401h402?n1
ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k00?oPH402H400onk^`09^`03oe]K00QK0_lQ^`03
oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0001Y0003o`0000P000Oo^l^kbk_o00J1
0ol2P@0=ok_;^l^kbk_;^l^ko`02F`Go02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?oG@0006X000?o000020000onk^`03^`03
oh6100?o1X400onk^`09^`;o:[/4o`Z100?oPH401843o`Nk0olH00CoH00006/000?o00002002o`04
bk_;^`;o2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T000?o^k/00[/00on1
P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T000Kobk_;^ol;P@0Z
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03oh6100V100?oPH40
1Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03ok^k02>k0ol6P@03
oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL01?mb0000L@000ol0
00080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o6003ogH0001b0003
o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V100?oPH402H42o`06
^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o0X400on1P@08P@03
oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onkbk_;^l^kbk_;^l^k
b`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o00002@000onk^`02^`;o
2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007ok_;^l^ko`09P@07
ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P000?o000020000onk
^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003o`0000P000Oo^l^k
bk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol000080003ok^k00>k
00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P000Ko^l^kbk/2o`V1
00?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH4028400on1P@05o`Jk
0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?oW@0007h00_l:0003
ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh400ol01[_;^l^kb`Co
5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003o`0000P000Oobk_;
^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o00001`03oaL00onb0000
Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT000280003o`0000<000?o0000
3004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0o`0400Coa`0008`0
0_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0002?0003o`0002L000?o0000X@0007001?l300Co00@0ool0
0_l200;o0`03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go
0P03o`<00_l300?o0`04o`<00_mb0000K`001Ol0003o008000?o00000`001?l00?l300;o1P000ol0
00020003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003o`0000@000?o00001`000ol0
00050003o`00008000Co003o0P02o`@000?o00000`000ol0000300;oLP0006l000?o0?l00_l200Go
00D0o`00o`0;0003o`0000h000Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D0
00?o00000P000ol000090003o`0000@000?o0000MP0006l000?o000010001ol0003o0?l00P000ol0
000600?o4@001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003o`00008000?o0000
2@000ol000050003o`0007D0001_0005o`000?l00`03o`030?oo00?o20000ol0000A0003o`0000Go
0`04o`P000?o00003P000ol0000400;o0`04o`T000?o00000P001?l00?mg0000L004oa@01?l>00Go
2`000ol0000500;o3`05o`T000?o00002002o`D00_mh0000Z@02ob4000?o00000P000ol000290000
o`1N0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 5"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 4",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 9", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.238964 1.50248 0.018379 0.957679 [
[(Gen.9, Ind.1, Fit.13.)] .5 1 0 -1.5 Msboxa
[(5)] .22099 .11589 .84618 1 Msboxa
[(10)] .37272 .07778 .79174 1 Msboxa
[(15)] .52951 .03841 .73731 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29879 .03484 .79718 1 Msboxa
P
[(5)] .71913 .07816 -1 .38072 Msboxa
[(10)] .79576 .14754 -1 .36669 Msboxa
[(15)] .86803 .21297 -1 .35366 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87643 .12011 -1 .36805 Msboxa
P
[(0)] .09651 .17173 1 -0.3906 Msboxa
[(10)] .07585 .34134 1 -0.3623 Msboxa
[(20)] .05296 .52934 1 -0.33078 Msboxa
[(30)] .02745 .7389 1 -0.29546 Msboxa
[(t)] -0.02652 .47215 1 -0.34365 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.9, Ind.1, Fit.13.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11556 .15446 m
.63693 .02394 L
s
P
p
.002 w
.23312 .12503 m
.23918 .1296 L
s
P
[(5)] .22099 .11589 .84618 1 Mshowa
p
.002 w
.38438 .08717 m
.39021 .09186 L
s
P
[(10)] .37272 .07778 .79174 1 Mshowa
p
.002 w
.54066 .04804 m
.54623 .05286 L
s
P
[(15)] .52951 .03841 .73731 1 Mshowa
p
.001 w
.26298 .11756 m
.26659 .12031 L
s
P
p
.001 w
.29304 .11003 m
.29662 .1128 L
s
P
p
.001 w
.32329 .10246 m
.32684 .10524 L
s
P
p
.001 w
.35373 .09484 m
.35726 .09764 L
s
P
p
.001 w
.41522 .07944 m
.41869 .08227 L
s
P
p
.001 w
.44627 .07167 m
.44971 .07452 L
s
P
p
.001 w
.47753 .06385 m
.48093 .06671 L
s
P
p
.001 w
.50899 .05597 m
.51236 .05885 L
s
P
p
.001 w
.20345 .13246 m
.20711 .13519 L
s
P
p
.001 w
.17396 .13984 m
.17766 .14255 L
s
P
p
.001 w
.14467 .14717 m
.14839 .14987 L
s
P
p
.001 w
.57253 .04006 m
.57585 .04297 L
s
P
p
.001 w
.60463 .03203 m
.60791 .03495 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29879 .03484 .79718 1 Mshowa
P
P
p
p
.002 w
.63693 .02394 m
.8917 .25439 L
s
P
p
.002 w
.70158 .08242 m
.6928 .08455 L
s
P
[(5)] .71913 .07816 -1 .38072 Mshowa
p
.002 w
.77813 .15166 m
.76931 .15372 L
s
P
[(10)] .79576 .14754 -1 .36669 Mshowa
p
.002 w
.85032 .21697 m
.84147 .21896 L
s
P
[(15)] .86803 .21297 -1 .35366 Mshowa
p
.001 w
.71726 .0966 m
.71199 .09787 L
s
P
p
.001 w
.73275 .11061 m
.72747 .11187 L
s
P
p
.001 w
.74805 .12446 m
.74277 .12571 L
s
P
p
.001 w
.76318 .13814 m
.75789 .13938 L
s
P
p
.001 w
.7929 .16503 m
.78761 .16626 L
s
P
p
.001 w
.80751 .17824 m
.80221 .17946 L
s
P
p
.001 w
.82194 .1913 m
.81664 .19251 L
s
P
p
.001 w
.83621 .2042 m
.83091 .20541 L
s
P
p
.001 w
.68571 .06807 m
.68045 .06935 L
s
P
p
.001 w
.66965 .05354 m
.6644 .05483 L
s
P
p
.001 w
.65339 .03883 m
.64814 .04013 L
s
P
p
.001 w
.86427 .22958 m
.85895 .23077 L
s
P
p
.001 w
.87806 .24206 m
.87274 .24324 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87643 .12011 -1 .36805 Mshowa
P
P
p
p
.002 w
.11556 .15446 m
.03756 .80103 L
s
P
p
.002 w
.114 .16738 m
.12275 .1652 L
s
P
[(0)] .09651 .17173 1 -0.3906 Mshowa
p
.002 w
.09351 .33726 m
.10234 .33523 L
s
P
[(10)] .07585 .34134 1 -0.3623 Mshowa
p
.002 w
.07079 .52558 m
.0797 .52371 L
s
P
[(20)] .05296 .52934 1 -0.33078 Mshowa
p
.002 w
.04547 .73551 m
.05447 .73381 L
s
P
[(30)] .02745 .7389 1 -0.29546 Mshowa
p
.001 w
.11006 .20001 m
.11532 .19872 L
s
P
p
.001 w
.10605 .2333 m
.11132 .23202 L
s
P
p
.001 w
.10195 .26725 m
.10723 .26599 L
s
P
p
.001 w
.09777 .3019 m
.10306 .30066 L
s
P
p
.001 w
.08915 .37336 m
.09446 .37216 L
s
P
p
.001 w
.08471 .41022 m
.09002 .40903 L
s
P
p
.001 w
.08017 .44786 m
.08549 .44669 L
s
P
p
.001 w
.07553 .4863 m
.08087 .48516 L
s
P
p
.001 w
.06595 .56573 m
.07131 .56462 L
s
P
p
.001 w
.061 .60676 m
.06637 .60568 L
s
P
p
.001 w
.05594 .64871 m
.06132 .64765 L
s
P
p
.001 w
.05076 .69162 m
.05615 .69058 L
s
P
p
.001 w
.04005 .78042 m
.04546 .77942 L
s
P
[(t)] -0.02652 .47215 1 -0.34365 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.114 .16738 m
.40462 .3743 L
s
P
p
.4 g
.002 w
.09351 .33726 m
.3996 .53769 L
s
P
p
.4 g
.002 w
.07079 .52558 m
.3941 .71703 L
s
P
p
.4 g
.002 w
.04547 .73551 m
.38803 .9148 L
s
P
p
.4 g
.002 w
.18872 .20688 m
.12684 .84586 L
s
P
p
.4 g
.002 w
.27561 .26912 m
.23183 .89857 L
s
P
p
.4 g
.002 w
.35779 .32799 m
.33013 .94793 L
s
P
.002 w
.11556 .15446 m
.03756 .80103 L
s
.03756 .80103 m
.38615 .97606 L
s
.38615 .97606 m
.405 .36182 L
s
.405 .36182 m
.11556 .15446 L
s
.63693 .02394 m
.8917 .25439 L
s
.8917 .25439 m
.96244 .88615 L
s
.96244 .88615 m
.66313 .68763 L
s
.66313 .68763 m
.63693 .02394 L
s
.11556 .15446 m
.03756 .80103 L
s
.03756 .80103 m
.66313 .68763 L
s
.66313 .68763 m
.63693 .02394 L
s
.63693 .02394 m
.11556 .15446 L
s
p
.4 g
.51518 .3375 m
.51569 .95585 L
s
P
p
.4 g
.65657 .30629 m
.68271 .92979 L
s
P
p
.4 g
.8022 .27415 m
.85568 .90281 L
s
P
p
.4 g
.40462 .3743 m
.89312 .26712 L
s
P
p
.4 g
.3996 .53769 m
.91182 .43411 L
s
P
p
.4 g
.3941 .71703 m
.93245 .61834 L
s
P
p
.4 g
.38803 .9148 m
.95532 .82263 L
s
P
.405 .36182 m
.8917 .25439 L
s
.8917 .25439 m
.96244 .88615 L
s
.96244 .88615 m
.38615 .97606 L
s
.38615 .97606 m
.405 .36182 L
s
p
.4 g
.23312 .12503 m
.51518 .3375 L
s
P
p
.4 g
.38438 .08717 m
.65657 .30629 L
s
P
p
.4 g
.54066 .04804 m
.8022 .27415 L
s
P
p
.4 g
.18872 .20688 m
.70158 .08242 L
s
P
p
.4 g
.27561 .26912 m
.77813 .15166 L
s
P
p
.4 g
.35779 .32799 m
.85032 .21697 L
s
P
P
p
.002 w
.41053 .36573 m .4183 .3713 L .40462 .3743 L p
.4 g
F P
s
P
p
.002 w
.40462 .3743 m .39683 .36875 L .41053 .36573 L p
.4 g
F P
s
P
p
.002 w
.89312 .26712 m .40462 .3743 L .114 .16738 L p
.9 g
F P
s
P
p
.002 w
.43202 .36829 m .4183 .3713 L p
.41053 .36573 L .4 g
F P
s
P
p
.002 w
.41053 .36573 m .39683 .36875 L .38899 .36317 L p
.4 g
F P
s
P
p
.002 w
.43806 .35967 m .44578 .36527 L .43202 .36829 L p
.4 g
F P
s
P
p
.002 w
.41053 .36573 m .43806 .35967 L p
.43202 .36829 L .4 g
F P
s
P
p
.002 w
.38899 .36317 m .38111 .35757 L p
.41053 .36573 L .4 g
F P
s
P
p
.002 w
.38111 .35757 m .39487 .35452 L .41053 .36573 L p
.4 g
F P
s
P
p
.002 w
.45958 .36224 m .44578 .36527 L p
.43806 .35967 L .4 g
F P
s
P
p
.002 w
.46576 .35357 m .47342 .3592 L .45958 .36224 L p
.4 g
F P
s
P
p
.002 w
.43806 .35967 m .46576 .35357 L p
.45958 .36224 L .4 g
F P
s
P
p
.002 w
.4873 .35616 m .47342 .3592 L p
.46576 .35357 L .4 g
F P
s
P
p
.002 w
.39487 .35452 m .38111 .35757 L .3732 .35193 L p
.4 g
F P
s
P
p
.002 w
.49361 .34744 m .50123 .3531 L .4873 .35616 L p
.4 g
F P
s
P
p
.002 w
.46576 .35357 m .49361 .34744 L p
.4873 .35616 L .4 g
F P
s
P
p
.002 w
.3732 .35193 m .36523 .34626 L p
.39487 .35452 L .4 g
F P
s
P
p
.002 w
.36523 .34626 m .37904 .34317 L .39487 .35452 L p
.4 g
F P
s
P
p
.002 w
.51519 .35004 m .50123 .3531 L p
.49361 .34744 L .4 g
F P
s
P
p
.002 w
.52163 .34127 m .52919 .34697 L .51519 .35004 L p
.4 g
F P
s
P
p
.002 w
.49361 .34744 m .52163 .34127 L p
.51519 .35004 L .4 g
F P
s
P
p
.002 w
.54324 .34389 m .52919 .34697 L p
.52163 .34127 L .4 g
F P
s
P
p
.002 w
.37904 .34317 m .36523 .34626 L .35723 .34056 L p
.4 g
F P
s
P
p
.002 w
.54982 .33507 m .55732 .3408 L .54324 .34389 L p
.4 g
F P
s
P
p
.002 w
.52163 .34127 m .54982 .33507 L p
.54324 .34389 L .4 g
F P
s
P
p
.002 w
.35723 .34056 m .34918 .33483 L p
.37904 .34317 L .4 g
F P
s
P
p
.002 w
.34918 .33483 m .36304 .33171 L .37904 .34317 L p
.4 g
F P
s
P
p
.002 w
.57145 .3377 m .55732 .3408 L p
.54982 .33507 L .4 g
F P
s
P
p
.002 w
.57817 .32882 m .58562 .33459 L .57145 .3377 L p
.4 g
F P
s
P
p
.002 w
.54982 .33507 m .57817 .32882 L p
.57145 .3377 L .4 g
F P
s
P
p
.002 w
.43469 .33075 m .40678 .33698 L .39088 .32545 L p
.8 g
F P
s
P
p
.002 w
.57817 .32882 m .54982 .33507 L .53469 .32351 L p
.4 g
F P
s
P
p
.002 w
.36304 .33171 m .34918 .33483 L .34109 .32907 L p
.4 g
F P
s
P
p
.002 w
.59983 .33147 m .58562 .33459 L p
.57817 .32882 L .4 g
F P
s
P
p
.002 w
.34109 .32907 m .33295 .32327 L p
.36304 .33171 L .4 g
F P
s
P
p
.002 w
.33295 .32327 m .34686 .32012 L .36304 .33171 L p
.4 g
F P
s
P
p
.002 w
.60669 .32255 m .61408 .32834 L .59983 .33147 L p
.4 g
F P
s
P
p
.002 w
.57817 .32882 m .60669 .32255 L p
.59983 .33147 L .4 g
F P
s
P
p
.002 w
.46275 .32448 m .43469 .33075 L .41889 .31915 L p
.8 g
F P
s
P
p
.002 w
.39088 .32545 m .41889 .31915 L .43469 .33075 L p
.8 g
F P
s
P
p
.002 w
.53469 .32351 m .56315 .3172 L .57817 .32882 L p
.4 g
F P
s
P
p
.002 w
.62838 .32521 m .61408 .32834 L p
.60669 .32255 L .4 g
F P
s
P
p
.002 w
.41889 .31915 m .39088 .32545 L .37481 .31379 L p
.8 g
F P
s
P
p
.002 w
.63538 .31623 m .64271 .32206 L .62838 .32521 L p
.4 g
F P
s
P
p
.002 w
.60669 .32255 m .63538 .31623 L p
.62838 .32521 L .4 g
F P
s
P
p
.002 w
.41889 .31915 m .44707 .31281 L .46275 .32448 L p
.8 g
F P
s
P
p
.002 w
.56315 .3172 m .53469 .32351 L .51939 .31183 L p
.4 g
F P
s
P
p
.002 w
.34686 .32012 m .33295 .32327 L .32477 .31745 L p
.4 g
F P
s
P
p
.002 w
.65709 .31891 m .64271 .32206 L p
.63538 .31623 L .4 g
F P
s
P
p
.002 w
.32477 .31745 m .31654 .31159 L p
.34686 .32012 L .4 g
F P
s
P
p
.002 w
.31654 .31159 m .33051 .3084 L .34686 .32012 L p
.4 g
F P
s
P
p
.002 w
.37481 .31379 m .40293 .30742 L .41889 .31915 L p
.8 g
F P
s
P
p
.002 w
.66424 .30987 m .67152 .31574 L .65709 .31891 L p
.4 g
F P
s
P
p
.002 w
.63538 .31623 m .66424 .30987 L p
.65709 .31891 L .4 g
F P
s
P
p
.002 w
.51939 .31183 m .49099 .31818 L .47541 .30644 L p
.8 g
F P
s
P
p
.002 w
.51939 .31183 m .54797 .30545 L .56315 .3172 L p
.4 g
F P
s
P
p
.002 w
.68598 .31257 m .67152 .31574 L p
.66424 .30987 L .4 g
F P
s
P
p
.002 w
.69327 .30348 m .70049 .30938 L .68598 .31257 L p
.4 g
F P
s
P
p
.002 w
.66424 .30987 m .69327 .30348 L p
.68598 .31257 L .4 g
F P
s
P
p
.002 w
.54797 .30545 m .51939 .31183 L .50393 .30002 L p
.8 g
F P
s
P
p
.002 w
.47541 .30644 m .50393 .30002 L .51939 .31183 L p
.8 g
F P
s
P
p
.002 w
.33051 .3084 m .31654 .31159 L .30827 .3057 L p
.4 g
F P
s
P
p
.002 w
.69327 .30348 m .66424 .30987 L .64956 .29804 L p
.8 g
F P
s
P
p
.002 w
.71504 .30619 m .70049 .30938 L p
.69327 .30348 L .4 g
F P
s
P
p
.002 w
.30827 .3057 m .29995 .29978 L p
.33051 .3084 L .4 g
F P
s
P
p
.002 w
.29995 .29978 m .31397 .29656 L .33051 .3084 L p
.4 g
F P
s
P
p
.002 w
.72248 .29705 m .72964 .30299 L .71504 .30619 L p
.4 g
F P
s
P
p
.002 w
.69327 .30348 m .72248 .29705 L p
.71504 .30619 L .4 g
F P
s
P
p
.002 w
.57671 .29903 m .54797 .30545 L .53261 .29357 L p
.8 g
F P
s
P
p
.002 w
.50393 .30002 m .53261 .29357 L .54797 .30545 L p
.8 g
F P
s
P
p
.002 w
.72248 .29705 m .69327 .30348 L .67871 .29158 L p
.8 g
F P
s
P
p
.002 w
.64956 .29804 m .67871 .29158 L .69327 .30348 L p
.8 g
F P
s
P
p
1 .019 0 r
.01 w
.64244 .30718 m
.67144 .30077 L
s
P
p
.002 w
.74428 .29978 m .72964 .30299 L p
.72248 .29705 L .4 g
F P
s
P
p
1 .372 0 r
.01 w
.58558 .35011 m
.6145 .34381 L
s
P
p
1 .26 0 r
.01 w
.61422 .3342 m
.64322 .32785 L
s
P
p
1 .39 0 r
.01 w
.58562 .35171 m
.58562 .35171 L
s
P
p
.002 w
.53261 .29357 m .50393 .30002 L .48829 .28808 L p
.4 g
F P
s
P
p
.002 w
.31397 .29656 m .29995 .29978 L .29159 .29382 L p
.4 g
F P
s
P
p
1 .279 0 r
.01 w
.61426 .3358 m
.61426 .3358 L
s
P
p
.002 w
.75186 .29058 m .75896 .29656 L .74428 .29978 L p
.4 g
F P
s
P
p
.002 w
.72248 .29705 m .75186 .29058 L p
.74428 .29978 L .4 g
F P
s
P
p
1 .409 0 r
.01 w
.58565 .35332 m
.58565 .35332 L
s
P
p
.002 w
.53261 .29357 m .56147 .28708 L .57671 .29903 L p
.8 g
F P
s
P
p
1 .297 0 r
.01 w
.61431 .3374 m
.61431 .3374 L
s
P
p
1 .427 0 r
.01 w
.58569 .35493 m
.58569 .35493 L
s
P
p
1 .316 0 r
.01 w
.61436 .339 m
.61436 .339 L
s
P
p
1 .446 0 r
.01 w
.58572 .35654 m
.58572 .35654 L
s
P
p
.002 w
.75186 .29058 m .72248 .29705 L .70804 .28508 L p
.8 g
F P
s
P
p
.002 w
.67871 .29158 m .70804 .28508 L .72248 .29705 L p
.8 g
F P
s
P
p
1 .037 0 r
.01 w
.67152 .30235 m
.70071 .2959 L
s
P
p
1 .334 0 r
.01 w
.6144 .3406 m
.6144 .3406 L
s
P
p
.002 w
.29159 .29382 m .28318 .28783 L p
.31397 .29656 L .4 g
F P
s
P
p
.002 w
.28318 .28783 m .29725 .28458 L .31397 .29656 L p
.4 g
F P
s
P
p
.002 w
.77369 .29332 m .75896 .29656 L p
.75186 .29058 L .4 g
F P
s
P
p
1 .464 0 r
.01 w
.57054 .34651 m
.58575 .35815 L
s
P
p
1 .353 0 r
.01 w
.61445 .34221 m
.61445 .34221 L
s
P
p
1 .241 0 r
.01 w
.64316 .32625 m
.67233 .31986 L
s
P
p
.002 w
.48829 .28808 m .51709 .28156 L .53261 .29357 L p
.4 g
F P
s
P
p
.002 w
.78142 .28407 m .78846 .29008 L .77369 .29332 L p
.4 g
F P
s
P
p
.002 w
.75186 .29058 m .78142 .28407 L p
.77369 .29332 L .4 g
F P
s
P
p
.002 w
.63472 .28608 m .60563 .29258 L .5905 .28055 L p
.8 g
F P
s
P
p
1 .056 0 r
.01 w
.7008 .29749 m
.73018 .29101 L
s
P
p
.002 w
.78142 .28407 m .75186 .29058 L .73754 .27854 L p
.8 g
F P
s
P
p
.002 w
.70804 .28508 m .73754 .27854 L .75186 .29058 L p
.8 g
F P
s
P
p
.002 w
.37046 .28357 m .34213 .29008 L .32552 .27803 L p
.8 g
F P
s
P
p
.002 w
.80328 .28683 m .78846 .29008 L p
.78142 .28407 L .4 g
F P
s
P
p
1 .223 0 r
.01 w
.67226 .31826 m
.70159 .31184 L
s
P
p
.002 w
.51709 .28156 m .48829 .28808 L .47248 .27601 L p
.4 g
F P
s
P
p
.002 w
.29725 .28458 m .28318 .28783 L .27472 .28181 L p
.4 g
F P
s
P
p
.002 w
.81116 .27753 m .81814 .28357 L .80328 .28683 L p
.4 g
F P
s
P
p
.002 w
.78142 .28407 m .81116 .27753 L p
.80328 .28683 L .4 g
F P
s
P
p
.002 w
.66399 .27955 m .63472 .28608 L .61971 .27398 L p
.8 g
F P
s
P
p
.002 w
.5905 .28055 m .61971 .27398 L .63472 .28608 L p
.8 g
F P
s
P
p
1 .074 0 r
.01 w
.73028 .2926 m
.75985 .28608 L
s
P
p
.002 w
.27472 .28181 m .26622 .27576 L p
.29725 .28458 L .4 g
F P
s
P
p
.002 w
.26622 .27576 m .28034 .27246 L .29725 .28458 L p
.4 g
F P
s
P
p
1 .204 0 r
.01 w
.7015 .31024 m
.73099 .30377 L
s
P
p
.002 w
.81116 .27753 m .78142 .28407 L .76722 .27196 L p
.8 g
F P
s
P
p
.002 w
.73754 .27854 m .76722 .27196 L .78142 .28407 L p
.8 g
F P
s
P
p
.002 w
.39896 .27702 m .37046 .28357 L .35395 .27145 L p
.8 g
F P
s
P
p
.002 w
.32552 .27803 m .35395 .27145 L .37046 .28357 L p
.8 g
F P
s
P
p
.002 w
.83305 .2803 m .81814 .28357 L p
.81116 .27753 L .4 g
F P
s
P
p
1 .483 0 r
.01 w
.55518 .33637 m
.57057 .34813 L
s
P
p
.002 w
.47248 .27601 m .50139 .26941 L .51709 .28156 L p
.4 g
F P
s
P
p
.002 w
.84108 .27094 m .848 .27702 L .83305 .2803 L p
.4 g
F P
s
P
p
.002 w
.81116 .27753 m .84108 .27094 L p
.83305 .2803 L .4 g
F P
s
P
p
.002 w
.69343 .27297 m .66399 .27955 L .6491 .26738 L p
.8 g
F P
s
P
p
.002 w
.61971 .27398 m .6491 .26738 L .66399 .27955 L p
.8 g
F P
s
P
p
1 .186 0 r
.01 w
.73089 .30217 m
.76055 .29566 L
s
P
p
.002 w
.76722 .27196 m .79709 .26533 L .81116 .27753 L p
.8 g
F P
s
P
p
1 .093 0 r
.01 w
.75997 .28767 m
.78974 .28112 L
s
P
p
.002 w
.35395 .27145 m .38257 .26482 L .39896 .27702 L p
.8 g
F P
s
P
p
.002 w
.86299 .27373 m .848 .27702 L p
.84108 .27094 L .4 g
F P
s
P
p
.002 w
.50139 .26941 m .47248 .27601 L .45649 .2638 L p
.4 g
F P
s
P
p
.002 w
.28034 .27246 m .26622 .27576 L .25767 .26967 L p
.4 g
F P
s
P
p
.002 w
.87118 .26431 m .87804 .27043 L .86299 .27373 L p
.4 g
F P
s
P
p
.002 w
.84108 .27094 m .87118 .26431 L p
.86299 .27373 L .4 g
F P
s
P
p
1 .167 0 r
.01 w
.76043 .29406 m
.79026 .28751 L
s
P
p
.002 w
.72306 .26636 m .69343 .27297 L .67866 .26073 L p
.8 g
F P
s
P
p
.002 w
.6491 .26738 m .67866 .26073 L .69343 .27297 L p
.8 g
F P
s
P
p
.002 w
.25767 .26967 m .24907 .26354 L p
.28034 .27246 L .4 g
F P
s
P
p
.002 w
.24907 .26354 m .26324 .26021 L .28034 .27246 L p
.4 g
F P
s
P
p
.002 w
.79709 .26533 m .76722 .27196 L .75286 .2597 L p
.8 g
F P
s
P
p
.002 w
.89312 .26712 m .87804 .27043 L p
.87118 .26431 L .4 g
F P
s
P
p
1 .502 0 r
.01 w
.5552 .33799 m
.5552 .33799 L
s
P
p
1 .111 0 r
.01 w
.78987 .28271 m
.78987 .28271 L
s
P
p
.002 w
.45649 .2638 m .48551 .25713 L .50139 .26941 L p
.4 g
F P
s
P
p
1 .52 0 r
.01 w
.55522 .33961 m
.58448 .33319 L
s
P
p
1 .13 0 r
.01 w
.79 .28431 m
.79 .28431 L
s
P
p
1 .985 0 r
.01 w
.61608 .39766 m
.58672 .40389 L
s
P
p
1 .873 0 r
.01 w
.64525 .38147 m
.61579 .38775 L
s
P
p
1 .149 0 r
.01 w
.79013 .28591 m
.79013 .28591 L
s
P
p
.997 1 0 r
.01 w
.58675 .40555 m
.58675 .40555 L
s
P
p
.002 w
.87118 .26431 m .8863 .26098 L .89312 .26712 L p
.4 g
F P
s
P
p
.002 w
.114 .16738 m .63745 .03705 L .89312 .26712 L p
.9 g
F P
s
P
p
1 .892 0 r
.01 w
.61584 .3894 m
.61584 .3894 L
s
P
p
.002 w
.67866 .26073 m .70841 .25404 L .72306 .26636 L p
.8 g
F P
s
P
p
.978 1 0 r
.01 w
.58679 .4072 m
.58679 .4072 L
s
P
p
1 .91 0 r
.01 w
.61589 .39105 m
.61589 .39105 L
s
P
p
.002 w
.75286 .2597 m .78285 .253 L .79709 .26533 L p
.8 g
F P
s
P
p
.96 1 0 r
.01 w
.58682 .40886 m
.58682 .40886 L
s
P
p
.002 w
.41135 .25816 m .38257 .26482 L .36598 .25249 L p
.8 g
F P
s
P
p
1 .929 0 r
.01 w
.61593 .3927 m
.61593 .3927 L
s
P
p
.002 w
.8863 .26098 m .87118 .26431 L p
.85736 .25197 L .4 g
F P
s
P
p
.941 1 0 r
.01 w
.58685 .41052 m
.58685 .41052 L
s
P
p
.002 w
.48551 .25713 m .45649 .2638 L .44032 .25145 L p
.4 g
F P
s
P
p
.002 w
.26324 .26021 m .24907 .26354 L .24042 .25739 L p
.4 g
F P
s
P
p
1 .947 0 r
.01 w
.61598 .39435 m
.61598 .39435 L
s
P
p
.923 1 0 r
.01 w
.58689 .41219 m
.57145 .40067 L
s
P
p
1 .966 0 r
.01 w
.61603 .396 m
.61603 .396 L
s
P
p
1 .854 0 r
.01 w
.64519 .37982 m
.67481 .37349 L
s
P
p
1 .539 0 r
.01 w
.58451 .33482 m
.61396 .32835 L
s
P
p
.002 w
.87944 .25481 m .8863 .26098 L p
.85736 .25197 L .4 g
F P
s
P
p
.002 w
.70841 .25404 m .67866 .26073 L .66373 .24834 L p
.8 g
F P
s
P
p
.002 w
.24042 .25739 m .23172 .25119 L p
.26324 .26021 L .4 g
F P
s
P
p
.002 w
.23172 .25119 m .24595 .24782 L .26324 .26021 L p
.4 g
F P
s
P
p
.002 w
.78285 .253 m .75286 .2597 L .73834 .2473 L p
.8 g
F P
s
P
p
.002 w
.36598 .25249 m .39488 .24575 L .41135 .25816 L p
.8 g
F P
s
P
p
.002 w
.44032 .25145 m .46946 .2447 L .48551 .25713 L p
.4 g
F P
s
P
p
1 .836 0 r
.01 w
.67474 .37184 m
.70453 .36548 L
s
P
p
.002 w
.85736 .25197 m .87254 .2486 L .87944 .25481 L p
.4 g
F P
s
P
p
.002 w
.66373 .24834 m .6936 .24158 L .70841 .25404 L p
.8 g
F P
s
P
p
1 .557 0 r
.01 w
.61401 .32998 m
.64365 .32349 L
s
P
p
.002 w
.73834 .2473 m .76845 .24053 L .78285 .253 L p
.8 g
F P
s
P
p
.002 w
.39488 .24575 m .36598 .25249 L .34921 .24001 L p
.8 g
F P
s
P
p
.002 w
.87254 .2486 m .85736 .25197 L p
.84338 .23949 L .4 g
F P
s
P
p
.002 w
.46946 .2447 m .44032 .25145 L .42396 .23896 L p
.4 g
F P
s
P
p
.002 w
.24595 .24782 m .23172 .25119 L .22297 .24497 L p
.4 g
F P
s
P
p
1 .817 0 r
.01 w
.70444 .36383 m
.7344 .35743 L
s
P
p
.904 1 0 r
.01 w
.57148 .40234 m
.55586 .3907 L
s
P
p
.002 w
.86561 .24236 m .87254 .2486 L p
.84338 .23949 L .4 g
F P
s
P
p
.002 w
.6936 .24158 m .66373 .24834 L .64862 .23582 L p
.8 g
F P
s
P
p
.002 w
.22297 .24497 m .21418 .2387 L p
.24595 .24782 L .4 g
F P
s
P
p
.002 w
.21418 .2387 m .22846 .23529 L .24595 .24782 L p
.4 g
F P
s
P
p
.002 w
.76845 .24053 m .73834 .2473 L .72365 .23477 L p
.8 g
F P
s
P
p
1 .576 0 r
.01 w
.64372 .32512 m
.67356 .31858 L
s
P
p
.002 w
.34921 .24001 m .37823 .23319 L .39488 .24575 L p
.8 g
F P
s
P
p
1 .799 0 r
.01 w
.7343 .35578 m
.76443 .34933 L
s
P
p
.002 w
.42396 .23896 m .45322 .23214 L .46946 .2447 L p
.4 g
F P
s
P
p
.002 w
.64862 .23582 m .61881 .24262 L .60341 .23003 L p
.4 g
F P
s
P
p
.002 w
.84338 .23949 m .85863 .23608 L .86561 .24236 L p
.4 g
F P
s
P
p
.002 w
.64862 .23582 m .67862 .22898 L .6936 .24158 L p
.8 g
F P
s
P
p
.002 w
.79875 .23372 m .76845 .24053 L .75389 .22792 L p
.8 g
F P
s
P
p
.002 w
.72365 .23477 m .75389 .22792 L .76845 .24053 L p
.8 g
F P
s
P
p
.002 w
.85863 .23608 m .84338 .23949 L p
.82924 .22686 L .4 g
F P
s
P
p
1 .78 0 r
.01 w
.76431 .34768 m
.79462 .34119 L
s
P
p
.002 w
.45322 .23214 m .42396 .23896 L .40742 .22633 L p
.4 g
F P
s
P
p
.002 w
.22846 .23529 m .21418 .2387 L .20533 .2324 L p
.4 g
F P
s
P
p
1 .594 0 r
.01 w
.67363 .32022 m
.70367 .31364 L
s
P
p
1 .687 0 r
.01 w
.77951 .32085 m
.79395 .33295 L
s
P
p
.002 w
.60341 .23003 m .57366 .23687 L .55796 .22421 L p
.8 g
F P
s
P
p
1 .706 0 r
.01 w
.79408 .3346 m
.79408 .3346 L
s
P
p
.885 1 0 r
.01 w
.55588 .39237 m
.55588 .39237 L
s
P
p
.002 w
.85161 .22977 m .85863 .23608 L p
.82924 .22686 L .4 g
F P
s
P
p
.002 w
.60341 .23003 m .63334 .22315 L .64862 .23582 L p
.4 g
F P
s
P
p
.002 w
.67862 .22898 m .64862 .23582 L .63334 .22315 L p
.8 g
F P
s
P
p
1 .724 0 r
.01 w
.79422 .33624 m
.79422 .33624 L
s
P
p
.002 w
.20533 .2324 m .19643 .22607 L p
.22846 .23529 L .4 g
F P
s
P
p
.002 w
.19643 .22607 m .21077 .22262 L .22846 .23529 L p
.4 g
F P
s
P
p
.867 1 0 r
.01 w
.5559 .39405 m
.58562 .38769 L
s
P
p
1 .743 0 r
.01 w
.79435 .33789 m
.79435 .33789 L
s
P
p
.402 1 0 r
.01 w
.61771 .4532 m
.58788 .45936 L
s
P
p
.002 w
.82924 .22686 m .79875 .23372 L .78432 .22103 L p
.8 g
F P
s
P
p
.002 w
.75389 .22792 m .78432 .22103 L .79875 .23372 L p
.8 g
F P
s
P
p
.514 1 0 r
.01 w
.64734 .43677 m
.61741 .44298 L
s
P
p
1 .762 0 r
.01 w
.79448 .33954 m
.79448 .33954 L
s
P
p
.384 1 0 r
.01 w
.58792 .46107 m
.58792 .46107 L
s
P
p
.495 1 0 r
.01 w
.61746 .44468 m
.61746 .44468 L
s
P
p
.002 w
.48265 .22527 m .45322 .23214 L .43679 .21943 L p
.4 g
F P
s
P
p
.002 w
.40742 .22633 m .43679 .21943 L .45322 .23214 L p
.4 g
F P
s
P
p
.365 1 0 r
.01 w
.58795 .46278 m
.58795 .46278 L
s
P
p
.477 1 0 r
.01 w
.61751 .44638 m
.61751 .44638 L
s
P
p
.347 1 0 r
.01 w
.58799 .46449 m
.58799 .46449 L
s
P
p
.458 1 0 r
.01 w
.61756 .44808 m
.61756 .44808 L
s
P
p
1 .613 0 r
.01 w
.70376 .31529 m
.734 .30867 L
s
P
p
.002 w
.63334 .22315 m .60341 .23003 L .58783 .2173 L p
.4 g
F P
s
P
p
.002 w
.55796 .22421 m .58783 .2173 L .60341 .23003 L p
.8 g
F P
s
P
p
.328 1 0 r
.01 w
.58803 .4662 m
.58803 .4662 L
s
P
p
.002 w
.82924 .22686 m .84456 .22342 L .85161 .22977 L p
.4 g
F P
s
P
p
.44 1 0 r
.01 w
.61761 .44979 m
.61761 .44979 L
s
P
p
.002 w
.7088 .22209 m .67862 .22898 L .66346 .21623 L p
.8 g
F P
s
P
p
.002 w
.63334 .22315 m .66346 .21623 L .67862 .22898 L p
.8 g
F P
s
P
p
.31 1 0 r
.01 w
.58806 .46792 m
.57239 .45654 L
s
P
p
.421 1 0 r
.01 w
.61766 .4515 m
.61766 .4515 L
s
P
p
.533 1 0 r
.01 w
.67738 .42882 m
.64728 .43507 L
s
P
p
.848 1 0 r
.01 w
.58565 .38937 m
.61557 .38298 L
s
P
p
.002 w
.84456 .22342 m .82924 .22686 L p
.81494 .21409 L .4 g
F P
s
P
p
.002 w
.78432 .22103 m .81494 .21409 L .82924 .22686 L p
.8 g
F P
s
P
p
.002 w
.43679 .21943 m .40742 .22633 L .39069 .21356 L p
.4 g
F P
s
P
p
.002 w
.21077 .22262 m .19643 .22607 L .18748 .2197 L p
.4 g
F P
s
P
p
1 .669 0 r
.01 w
.76479 .30696 m
.77939 .3192 L
s
P
p
.002 w
.43679 .21943 m .46635 .21248 L .48265 .22527 L p
.4 g
F P
s
P
p
.002 w
.83746 .21703 m .84456 .22342 L p
.81494 .21409 L .4 g
F P
s
P
p
.002 w
.58783 .2173 m .61789 .21034 L .63334 .22315 L p
.4 g
F P
s
P
p
.002 w
.18748 .2197 m .17848 .21329 L p
.21077 .22262 L .4 g
F P
s
P
p
.002 w
.17848 .21329 m .19287 .2098 L .21077 .22262 L p
.4 g
F P
s
P
p
1 .632 0 r
.01 w
.73411 .31032 m
.76455 .30366 L
s
P
p
.002 w
.73916 .21516 m .7088 .22209 L .69377 .20926 L p
.8 g
F P
s
P
p
.002 w
.66346 .21623 m .69377 .20926 L .7088 .22209 L p
.8 g
F P
s
P
p
.551 1 0 r
.01 w
.70757 .42082 m
.6773 .42711 L
s
P
p
.002 w
.81494 .21409 m .78432 .22103 L .76972 .20819 L p
.8 g
F P
s
P
p
.002 w
.46635 .21248 m .43679 .21943 L .42018 .20657 L p
.4 g
F P
s
P
p
.002 w
.39069 .21356 m .42018 .20657 L .43679 .21943 L p
.4 g
F P
s
P
p
.83 1 0 r
.01 w
.61562 .38466 m
.64573 .37823 L
s
P
p
.002 w
.61789 .21034 m .58783 .2173 L .57207 .20442 L p
.4 g
F P
s
P
p
.002 w
.81494 .21409 m .83032 .21061 L .83746 .21703 L p
.4 g
F P
s
P
p
.57 1 0 r
.01 w
.73793 .41279 m
.70748 .41912 L
s
P
p
.002 w
.76972 .20819 m .73916 .21516 L .72427 .20225 L p
.8 g
F P
s
P
p
.002 w
.69377 .20926 m .72427 .20225 L .73916 .21516 L p
.8 g
F P
s
P
p
.291 1 0 r
.01 w
.57241 .45826 m
.55655 .44676 L
s
P
p
.002 w
.34434 .20765 m .3151 .21463 L .29774 .20171 L p
.8 g
F P
s
P
p
1 .65 0 r
.01 w
.76467 .30531 m
.76467 .30531 L
s
P
p
.002 w
.83032 .21061 m .81494 .21409 L p
.80047 .20117 L .4 g
F P
s
P
p
.002 w
.76972 .20819 m .80047 .20117 L .81494 .21409 L p
.8 g
F P
s
P
p
.002 w
.19287 .2098 m .17848 .21329 L .16943 .20684 L p
.4 g
F P
s
P
p
.002 w
.42018 .20657 m .44985 .19955 L .46635 .21248 L p
.4 g
F P
s
P
p
.811 1 0 r
.01 w
.6458 .37991 m
.67612 .37344 L
s
P
p
.002 w
.82314 .20415 m .83032 .21061 L p
.80047 .20117 L .4 g
F P
s
P
p
.002 w
.57207 .20442 m .60225 .19738 L .61789 .21034 L p
.4 g
F P
s
P
p
.588 1 0 r
.01 w
.76844 .40471 m
.73782 .41108 L
s
P
p
.002 w
.16943 .20684 m .16033 .20036 L p
.19287 .2098 L .4 g
F P
s
P
p
.002 w
.16033 .20036 m .17477 .19683 L .19287 .2098 L p
.4 g
F P
s
P
p
.002 w
.80047 .20117 m .76972 .20819 L .75495 .1952 L p
.8 g
F P
s
P
p
.002 w
.72427 .20225 m .75495 .1952 L .76972 .20819 L p
.8 g
F P
s
P
p
.002 w
.29774 .20171 m .3271 .19466 L .34434 .20765 L p
.8 g
F P
s
P
p
.002 w
.52602 .19846 m .49609 .20549 L .47971 .19248 L p
.8 g
F P
s
P
p
.002 w
.60225 .19738 m .57207 .20442 L .55613 .19138 L p
.4 g
F P
s
P
p
.607 1 0 r
.01 w
.79912 .39659 m
.76832 .403 L
s
P
p
.002 w
.80047 .20117 m .81592 .19765 L .82314 .20415 L p
.4 g
F P
s
P
p
.793 1 0 r
.01 w
.6762 .37513 m
.70672 .36863 L
s
P
p
.7 1 0 r
.01 w
.78379 .37611 m
.79843 .38808 L
s
P
p
.002 w
.3271 .19466 m .29774 .20171 L .28018 .18865 L p
.8 g
F P
s
P
p
.681 1 0 r
.01 w
.79857 .38978 m
.79857 .38978 L
s
P
p
.002 w
.81592 .19765 m .80047 .20117 L p
.78584 .1881 L .4 g
F P
s
P
p
.002 w
.75495 .1952 m .78584 .1881 L .80047 .20117 L p
.8 g
F P
s
P
p
.272 1 0 r
.01 w
.55657 .44849 m
.55657 .44849 L
s
P
p
.002 w
.40337 .19357 m .37376 .20063 L .35664 .18756 L p
.4 g
F P
s
P
p
.663 1 0 r
.01 w
.7987 .39148 m
.7987 .39148 L
s
P
p
.002 w
.17477 .19683 m .16033 .20036 L .15117 .19384 L p
.4 g
F P
s
P
p
.254 1 0 r
.01 w
.55659 .45022 m
.58679 .44394 L
s
P
p
.644 1 0 r
.01 w
.79884 .39318 m
.79884 .39318 L
s
P
p
0 1 .211 r
.01 w
.6194 .51052 m
.58909 .5166 L
s
P
p
.002 w
.47971 .19248 m .50976 .18536 L .52602 .19846 L p
.8 g
F P
s
P
p
0 1 .099 r
.01 w
.6495 .49384 m
.61909 .49997 L
s
P
p
.625 1 0 r
.01 w
.79898 .39488 m
.79898 .39488 L
s
P
p
0 1 .229 r
.01 w
.58912 .51836 m
.58912 .51836 L
s
P
p
.002 w
.80866 .19111 m .81592 .19765 L p
.78584 .1881 L .4 g
F P
s
P
p
.002 w
.63263 .19029 m .60225 .19738 L .58644 .18426 L p
.4 g
F P
s
P
p
.002 w
.55613 .19138 m .58644 .18426 L .60225 .19738 L p
.4 g
F P
s
P
p
0 1 .118 r
.01 w
.61914 .50172 m
.61914 .50172 L
s
P
p
.002 w
.15117 .19384 m .14196 .18728 L p
.17477 .19683 L .4 g
F P
s
P
p
.002 w
.14196 .18728 m .15646 .18371 L .17477 .19683 L p
.4 g
F P
s
P
p
0 1 .248 r
.01 w
.58916 .52013 m
.58916 .52013 L
s
P
p
0 1 .136 r
.01 w
.61919 .50348 m
.61919 .50348 L
s
P
p
0 1 .266 r
.01 w
.5892 .52189 m
.5892 .52189 L
s
P
p
0 1 .155 r
.01 w
.61924 .50524 m
.61924 .50524 L
s
P
p
.774 1 0 r
.01 w
.70682 .37032 m
.73755 .36377 L
s
P
p
.002 w
.28018 .18865 m .30965 .18151 L .3271 .19466 L p
.8 g
F P
s
P
p
0 1 .285 r
.01 w
.58924 .52366 m
.58924 .52366 L
s
P
p
0 1 .173 r
.01 w
.61929 .507 m
.61929 .507 L
s
P
p
.002 w
.43316 .18646 m .40337 .19357 L .38636 .18041 L p
.4 g
F P
s
P
p
.002 w
.35664 .18756 m .38636 .18041 L .40337 .19357 L p
.4 g
F P
s
P
p
0 1 .303 r
.01 w
.58927 .52543 m
.57335 .51421 L
s
P
p
0 1 .192 r
.01 w
.61935 .50876 m
.61935 .50876 L
s
P
p
0 1 .08 r
.01 w
.68002 .48591 m
.64943 .49208 L
s
P
p
.235 1 0 r
.01 w
.58682 .44567 m
.61722 .43935 L
s
P
p
.002 w
.78584 .1881 m .80135 .18454 L .80866 .19111 L p
.4 g
F P
s
P
p
.718 1 0 r
.01 w
.76885 .36229 m
.78366 .37441 L
s
P
p
.002 w
.66319 .18316 m .63263 .19029 L .61694 .1771 L p
.4 g
F P
s
P
p
.002 w
.58644 .18426 m .61694 .1771 L .63263 .19029 L p
.4 g
F P
s
P
p
.002 w
.80135 .18454 m .78584 .1881 L p
.77103 .17488 L .4 g
F P
s
P
p
.002 w
.38636 .18041 m .35664 .18756 L .33931 .17433 L p
.4 g
F P
s
P
p
.002 w
.15646 .18371 m .14196 .18728 L .13269 .18068 L p
.4 g
F P
s
P
p
.755 1 0 r
.01 w
.73766 .36547 m
.7686 .35889 L
s
P
p
.002 w
.38636 .18041 m .41628 .17322 L .43316 .18646 L p
.4 g
F P
s
P
p
0 1 .062 r
.01 w
.71071 .47794 m
.67994 .48415 L
s
P
p
.002 w
.794 .17792 m .80135 .18454 L p
.77103 .17488 L .4 g
F P
s
P
p
.002 w
.13269 .18068 m .12337 .17405 L p
.15646 .18371 L .4 g
F P
s
P
p
.002 w
.12337 .17405 m .13793 .17044 L .15646 .18371 L p
.4 g
F P
s
P
p
.217 1 0 r
.01 w
.61727 .44109 m
.64788 .43473 L
s
P
p
.002 w
.69394 .17599 m .66319 .18316 L .64763 .16988 L p
.4 g
F P
s
P
p
.002 w
.61694 .1771 m .64763 .16988 L .66319 .18316 L p
.4 g
F P
s
P
p
.002 w
.41628 .17322 m .38636 .18041 L .36916 .1671 L p
.4 g
F P
s
P
p
.002 w
.33931 .17433 m .36916 .1671 L .38636 .18041 L p
.4 g
F P
s
P
p
0 1 .043 r
.01 w
.74156 .46993 m
.71061 .47618 L
s
P
p
0 1 .322 r
.01 w
.57338 .51598 m
.55727 .50464 L
s
P
p
.737 1 0 r
.01 w
.76873 .36059 m
.76873 .36059 L
s
P
p
.002 w
.57044 .171 m .54 .1782 L .52369 .16486 L p
.8 g
F P
s
P
p
.002 w
.77103 .17488 m .78661 .17127 L .794 .17792 L p
.4 g
F P
s
P
p
.002 w
.64763 .16988 m .67852 .16262 L .69394 .17599 L p
.4 g
F P
s
P
p
.198 1 0 r
.01 w
.64795 .43647 m
.67876 .43008 L
s
P
p
.002 w
.78661 .17127 m .77103 .17488 L p
.75605 .1615 L .4 g
F P
s
P
p
0 1 .025 r
.01 w
.77258 .46188 m
.74145 .46817 L
s
P
p
.002 w
.13793 .17044 m .12337 .17405 L .114 .16738 L p
.4 g
F P
s
P
p
.002 w
.44638 .16598 m .41628 .17322 L .3992 .15982 L p
.4 g
F P
s
P
p
.002 w
.36916 .1671 m .3992 .15982 L .41628 .17322 L p
.4 g
F P
s
P
p
.002 w
.77917 .16458 m .78661 .17127 L p
.75605 .1615 L .4 g
F P
s
P
p
.002 w
.52369 .16486 m .55425 .15757 L .57044 .171 L p
.8 g
F P
s
P
p
.002 w
.12859 .16374 m .14322 .1601 L p
.13793 .17044 L .4 g
F P
s
P
p
.002 w
.16719 .16318 m .13793 .17044 L p
.14322 .1601 L .4 g
F P
s
P
p
.002 w
.114 .16738 m .12859 .16374 L .13793 .17044 L p
.4 g
F P
s
P
p
.002 w
.67852 .16262 m .64763 .16988 L .63189 .15645 L p
.4 g
F P
s
P
p
.002 w
.32178 .16094 m .29201 .16821 L .27415 .15476 L p
.8 g
F P
s
P
p
0 1 .006 r
.01 w
.80376 .45378 m
.77245 .46012 L
s
P
p
.18 1 0 r
.01 w
.67884 .43182 m
.70987 .42539 L
s
P
p
.087 1 0 r
.01 w
.7882 .43316 m
.80305 .44499 L
s
P
p
.002 w
.47668 .1587 m .44638 .16598 L .42942 .1525 L p
.4 g
F P
s
P
p
.002 w
.3992 .15982 m .42942 .1525 L .44638 .16598 L p
.4 g
F P
s
P
p
.068 1 0 r
.01 w
.80319 .44675 m
.80319 .44675 L
s
P
p
0 1 .341 r
.01 w
.55729 .50642 m
.55729 .50642 L
s
P
p
.002 w
.75605 .1615 m .7717 .15785 L .77917 .16458 L p
.4 g
F P
s
P
p
.05 1 0 r
.01 w
.80334 .4485 m
.80334 .4485 L
s
P
p
0 1 .359 r
.01 w
.55731 .5082 m
.588 .50201 L
s
P
p
.002 w
.1579 .15645 m .17263 .15278 L p
.16719 .16318 L .4 g
F P
s
P
p
.002 w
.19663 .15588 m .16719 .16318 L p
.17263 .15278 L .4 g
F P
s
P
p
.002 w
.14322 .1601 m .1579 .15645 L .16719 .16318 L p
.4 g
F P
s
P
p
.031 1 0 r
.01 w
.80348 .45026 m
.80348 .45026 L
s
P
p
.002 w
.63189 .15645 m .66291 .1491 L .67852 .16262 L p
.4 g
F P
s
P
p
0 1 .824 r
.01 w
.62114 .5697 m
.59033 .57569 L
s
P
p
0 1 .712 r
.01 w
.65173 .55276 m
.62082 .5588 L
s
P
p
.012 1 0 r
.01 w
.80362 .45202 m
.80362 .45202 L
s
P
p
.002 w
.7717 .15785 m .75605 .1615 L p
.74089 .14797 L .4 g
F P
s
P
p
0 1 .842 r
.01 w
.59037 .57751 m
.59037 .57751 L
s
P
p
.002 w
.35175 .15363 m .32178 .16094 L .30405 .1474 L p
.8 g
F P
s
P
p
.002 w
.27415 .15476 m .30405 .1474 L .32178 .16094 L p
.8 g
F P
s
P
p
0 1 .731 r
.01 w
.62087 .56061 m
.62087 .56061 L
s
P
p
0 1 .861 r
.01 w
.59041 .57933 m
.59041 .57933 L
s
P
p
0 1 .749 r
.01 w
.62092 .56243 m
.62092 .56243 L
s
P
p
0 1 .879 r
.01 w
.59044 .58115 m
.59044 .58115 L
s
P
p
.002 w
.50717 .15137 m .47668 .1587 L .45985 .14513 L p
.4 g
F P
s
P
p
.002 w
.42942 .1525 m .45985 .14513 L .47668 .1587 L p
.4 g
F P
s
P
p
0 1 .768 r
.01 w
.62098 .56424 m
.62098 .56424 L
s
P
p
.161 1 0 r
.01 w
.70997 .42714 m
.74121 .42067 L
s
P
p
0 1 .898 r
.01 w
.59048 .58298 m
.59048 .58298 L
s
P
p
.002 w
.76417 .15108 m .7717 .15785 L p
.74089 .14797 L .4 g
F P
s
P
p
0 1 .786 r
.01 w
.62103 .56606 m
.62103 .56606 L
s
P
p
0 1 .916 r
.01 w
.59052 .58481 m
.57435 .57376 L
s
P
p
.002 w
.66291 .1491 m .63189 .15645 L .61596 .14285 L p
.4 g
F P
s
P
p
0 1 .805 r
.01 w
.62108 .56788 m
.62108 .56788 L
s
P
p
.002 w
.1874 .1491 m .20222 .14541 L p
.19663 .15588 L .4 g
F P
s
P
p
.002 w
.22626 .14853 m .19663 .15588 L p
.20222 .14541 L .4 g
F P
s
P
p
.002 w
.17263 .15278 m .1874 .1491 L .19663 .15588 L p
.4 g
F P
s
P
p
0 1 .693 r
.01 w
.68276 .54486 m
.65166 .55095 L
s
P
p
0 1 .378 r
.01 w
.58803 .5038 m
.61893 .49756 L
s
P
p
.105 1 0 r
.01 w
.77305 .41943 m
.78807 .4314 L
s
P
p
.002 w
.30405 .1474 m .33414 .14 L .35175 .15363 L p
.8 g
F P
s
P
p
.002 w
.45985 .14513 m .49047 .13771 L .50717 .15137 L p
.4 g
F P
s
P
p
.002 w
.74089 .14797 m .7566 .14427 L .76417 .15108 L p
.4 g
F P
s
P
p
.142 1 0 r
.01 w
.74133 .42242 m
.77279 .41591 L
s
P
p
0 1 .675 r
.01 w
.71395 .53693 m
.68267 .54305 L
s
P
p
.002 w
.61596 .14285 m .64711 .13542 L .66291 .1491 L p
.4 g
F P
s
P
p
.002 w
.21709 .14171 m .23201 .138 L p
.22626 .14853 L .4 g
F P
s
P
p
.002 w
.25609 .14114 m .22626 .14853 L p
.23201 .138 L .4 g
F P
s
P
p
.002 w
.20222 .14541 m .21709 .14171 L .22626 .14853 L p
.4 g
F P
s
P
p
.002 w
.7566 .14427 m .74089 .14797 L p
.72555 .13427 L .4 g
F P
s
P
p
0 1 .396 r
.01 w
.61898 .49935 m
.6501 .49308 L
s
P
p
.002 w
.41226 .13885 m .38191 .14626 L .36442 .13255 L p
.8 g
F P
s
P
p
.002 w
.49047 .13771 m .45985 .14513 L .44281 .1314 L p
.4 g
F P
s
P
p
.002 w
.74899 .13742 m .7566 .14427 L p
.72555 .13427 L .4 g
F P
s
P
p
.002 w
.56875 .13656 m .53786 .14399 L .52128 .13024 L p
.8 g
F P
s
P
p
0 1 .656 r
.01 w
.74532 .52894 m
.71385 .53511 L
s
P
p
.002 w
.64711 .13542 m .61596 .14285 L .59984 .12909 L p
.4 g
F P
s
P
p
0 1 .935 r
.01 w
.57438 .57559 m
.558 .56441 L
s
P
p
.124 1 0 r
.01 w
.77292 .41767 m
.77292 .41767 L
s
P
p
.002 w
.24697 .13427 m .26199 .13053 L p
.25609 .14114 L .4 g
F P
s
P
p
.002 w
.2861 .1337 m .25609 .14114 L p
.26199 .13053 L .4 g
F P
s
P
p
.002 w
.23201 .138 m .24697 .13427 L .25609 .14114 L p
.4 g
F P
s
P
p
.002 w
.44281 .1314 m .41226 .13885 L .3949 .12505 L p
.8 g
F P
s
P
p
.002 w
.36442 .13255 m .3949 .12505 L .41226 .13885 L p
.8 g
F P
s
P
p
0 1 .415 r
.01 w
.65017 .49488 m
.6815 .48857 L
s
P
p
.002 w
.44281 .1314 m .47356 .12389 L .49047 .13771 L p
.4 g
F P
s
P
p
.002 w
.72555 .13427 m .74133 .13053 L .74899 .13742 L p
.4 g
F P
s
P
p
0 1 .638 r
.01 w
.77685 .52092 m
.7452 .52713 L
s
P
p
.002 w
.52128 .13024 m .5523 .12273 L .56875 .13656 L p
.8 g
F P
s
P
p
.002 w
.59984 .12909 m .63112 .12157 L .64711 .13542 L p
.4 g
F P
s
P
p
.002 w
.74133 .13053 m .72555 .13427 L p
.71002 .12041 L .4 g
F P
s
P
p
.002 w
.27705 .12678 m .29216 .12302 L p
.2861 .1337 L .4 g
F P
s
P
p
.002 w
.31631 .1262 m .2861 .1337 L p
.29216 .12302 L .4 g
F P
s
P
p
.002 w
.26199 .13053 m .27705 .12678 L .2861 .1337 L p
.4 g
F P
s
P
p
.002 w
.3949 .12505 m .42557 .1175 L .44281 .1314 L p
.8 g
F P
s
P
p
0 1 .619 r
.01 w
.80856 .51285 m
.77672 .5191 L
s
P
p
.002 w
.73363 .1236 m .74133 .13053 L p
.71002 .12041 L .4 g
F P
s
P
p
.002 w
.5523 .12273 m .52128 .13024 L .50451 .11633 L p
.8 g
F P
s
P
p
0 1 .433 r
.01 w
.68158 .49037 m
.71313 .48402 L
s
P
p
.002 w
.63112 .12157 m .59984 .12909 L .58352 .11517 L p
.4 g
F P
s
P
p
0 1 .526 r
.01 w
.79276 .4921 m
.80783 .50377 L
s
P
p
0 1 .545 r
.01 w
.80797 .50559 m
.80797 .50559 L
s
P
p
0 1 .954 r
.01 w
.55803 .56625 m
.55803 .56625 L
s
P
p
0 1 .563 r
.01 w
.80812 .5074 m
.80812 .5074 L
s
P
p
.002 w
.30732 .11925 m .32253 .11546 L p
.31631 .1262 L .4 g
F P
s
P
p
.002 w
.34672 .11866 m .31631 .1262 L p
.32253 .11546 L .4 g
F P
s
P
p
.002 w
.29216 .12302 m .30732 .11925 L .31631 .1262 L p
.4 g
F P
s
P
p
0 1 .972 r
.01 w
.55805 .5681 m
.58924 .56199 L
s
P
p
0 1 .582 r
.01 w
.80827 .50921 m
.80827 .50921 L
s
P
p
0 .563 1 r
.01 w
.62293 .63084 m
.59161 .63672 L
s
P
p
0 1 .601 r
.01 w
.80842 .51103 m
.80842 .51103 L
s
P
p
0 .675 1 r
.01 w
.65403 .61363 m
.6226 .61957 L
s
P
p
0 .545 1 r
.01 w
.59165 .6386 m
.59165 .6386 L
s
P
p
.002 w
.71002 .12041 m .72588 .11663 L .73363 .1236 L p
.4 g
F P
s
P
p
0 .656 1 r
.01 w
.62266 .62144 m
.62266 .62144 L
s
P
p
.002 w
.50451 .11633 m .53566 .10873 L .5523 .12273 L p
.8 g
F P
s
P
p
0 .526 1 r
.01 w
.59169 .64049 m
.59169 .64049 L
s
P
p
0 .638 1 r
.01 w
.62271 .62332 m
.62271 .62332 L
s
P
p
.002 w
.58352 .11517 m .61494 .10756 L .63112 .12157 L p
.4 g
F P
s
P
p
0 .508 1 r
.01 w
.59173 .64237 m
.59173 .64237 L
s
P
p
0 1 .452 r
.01 w
.71323 .48583 m
.745 .47945 L
s
P
p
0 .619 1 r
.01 w
.62277 .6252 m
.62277 .6252 L
s
P
p
.002 w
.72588 .11663 m .71002 .12041 L p
.69431 .10638 L .4 g
F P
s
P
p
0 .489 1 r
.01 w
.59177 .64426 m
.59177 .64426 L
s
P
p
0 .601 1 r
.01 w
.62282 .62707 m
.62282 .62707 L
s
P
p
0 .471 1 r
.01 w
.59181 .64614 m
.57538 .63528 L
s
P
p
.002 w
.33779 .11166 m .35309 .10785 L p
.34672 .11866 L .4 g
F P
s
P
p
.002 w
.37732 .11108 m .34672 .11866 L p
.35309 .10785 L .4 g
F P
s
P
p
.002 w
.32253 .11546 m .33779 .11166 L .34672 .11866 L p
.4 g
F P
s
P
p
0 .582 1 r
.01 w
.62288 .62895 m
.62288 .62895 L
s
P
p
0 .693 1 r
.01 w
.68558 .60577 m
.65396 .61176 L
s
P
p
.002 w
.45645 .1099 m .42557 .1175 L .40812 .10344 L p
.4 g
F P
s
P
p
0 1 .991 r
.01 w
.58928 .56384 m
.6207 .5577 L
s
P
p
.002 w
.71808 .10961 m .72588 .11663 L p
.69431 .10638 L .4 g
F P
s
P
p
.002 w
.53566 .10873 m .50451 .11633 L .48753 .10226 L p
.8 g
F P
s
P
p
0 1 .508 r
.01 w
.77738 .47846 m
.79262 .49028 L
s
P
p
.002 w
.61494 .10756 m .58352 .11517 L .56701 .10108 L p
.4 g
F P
s
P
p
0 1 .471 r
.01 w
.74512 .48126 m
.77711 .47483 L
s
P
p
0 .712 1 r
.01 w
.7173 .59787 m
.68549 .6039 L
s
P
p
.002 w
.36845 .10403 m .38386 .10019 L p
.37732 .11108 L .4 g
F P
s
P
p
.002 w
.40812 .10344 m .37732 .11108 L p
.38386 .10019 L .4 g
F P
s
P
p
.002 w
.35309 .10785 m .36845 .10403 L .37732 .11108 L p
.4 g
F P
s
P
p
.002 w
.40812 .10344 m .43913 .09575 L .45645 .1099 L p
.4 g
F P
s
P
p
.002 w
.69431 .10638 m .71024 .10255 L .71808 .10961 L p
.4 g
F P
s
P
p
.002 w
.48753 .10226 m .51881 .09456 L .53566 .10873 L p
.8 g
F P
s
P
p
0 .991 1 r
.01 w
.62075 .55955 m
.65239 .55337 L
s
P
p
.002 w
.64657 .09989 m .61494 .10756 L .59857 .09337 L p
.4 g
F P
s
P
p
.002 w
.56701 .10108 m .59857 .09337 L .61494 .10756 L p
.4 g
F P
s
P
p
.002 w
.71024 .10255 m .69431 .10638 L p
.67841 .09218 L .4 g
F P
s
P
p
0 .731 1 r
.01 w
.7492 .58992 m
.7172 .59599 L
s
P
p
0 .452 1 r
.01 w
.57541 .63718 m
.55877 .62618 L
s
P
p
.002 w
.39932 .09634 m .41483 .09248 L p
.40812 .10344 L .4 g
F P
s
P
p
.002 w
.43913 .09575 m .40812 .10344 L p
.41483 .09248 L .4 g
F P
s
P
p
.002 w
.38386 .10019 m .39932 .09634 L .40812 .10344 L p
.4 g
F P
s
P
p
0 1 .489 r
.01 w
.77724 .47665 m
.77724 .47665 L
s
P
p
.002 w
.70235 .09545 m .71024 .10255 L p
.67841 .09218 L .4 g
F P
s
P
p
.002 w
.67841 .09218 m .64657 .09989 L .63034 .08562 L p
.4 g
F P
s
P
p
.002 w
.59857 .09337 m .63034 .08562 L .64657 .09989 L p
.4 g
F P
s
P
p
0 .972 1 r
.01 w
.65246 .55523 m
.68432 .54901 L
s
P
p
0 .749 1 r
.01 w
.78127 .58193 m
.74908 .58805 L
s
P
p
.002 w
.43039 .0886 m .44601 .08472 L p
.43913 .09575 L .4 g
F P
s
P
p
.002 w
.47034 .08801 m .43913 .09575 L p
.44601 .08472 L .4 g
F P
s
P
p
.002 w
.41483 .09248 m .43039 .0886 L .43913 .09575 L p
.4 g
F P
s
P
p
.002 w
.67841 .09218 m .69441 .08831 L .70235 .09545 L p
.4 g
F P
s
P
p
.002 w
.69441 .08831 m .67841 .09218 L p
.66231 .07781 L .4 g
F P
s
P
p
.002 w
.63034 .08562 m .66231 .07781 L .67841 .09218 L p
.4 g
F P
s
P
p
0 .768 1 r
.01 w
.81352 .5739 m
.78113 .58005 L
s
P
p
0 .954 1 r
.01 w
.68441 .55088 m
.71649 .54462 L
s
P
p
0 .861 1 r
.01 w
.79747 .55302 m
.81276 .56452 L
s
P
p
0 .842 1 r
.01 w
.81291 .56639 m
.81291 .56639 L
s
P
p
0 .433 1 r
.01 w
.55879 .62809 m
.55879 .62809 L
s
P
p
.002 w
.68642 .08112 m .69441 .08831 L p
.66231 .07781 L .4 g
F P
s
P
p
.002 w
.46167 .08082 m .47739 .07691 L p
.47034 .08801 L .4 g
F P
s
P
p
.002 w
.50176 .08022 m .47034 .08801 L p
.47739 .07691 L .4 g
F P
s
P
p
.002 w
.44601 .08472 m .46167 .08082 L .47034 .08801 L p
.4 g
F P
s
P
p
0 .824 1 r
.01 w
.81307 .56826 m
.81307 .56826 L
s
P
p
0 .415 1 r
.01 w
.55882 .62999 m
.59054 .62399 L
s
P
p
0 .805 1 r
.01 w
.81322 .57014 m
.81322 .57014 L
s
P
p
.05 0 1 r
.01 w
.62479 .69402 m
.59294 .6998 L
s
P
p
0 .786 1 r
.01 w
.81337 .57202 m
.81337 .57202 L
s
P
p
0 .062 1 r
.01 w
.65641 .67654 m
.62445 .68238 L
s
P
p
.068 0 1 r
.01 w
.59298 .70174 m
.59298 .70174 L
s
P
p
0 .043 1 r
.01 w
.62451 .68431 m
.62451 .68431 L
s
P
p
.087 0 1 r
.01 w
.59302 .70369 m
.59302 .70369 L
s
P
p
0 .025 1 r
.01 w
.62456 .68625 m
.62456 .68625 L
s
P
p
.105 0 1 r
.01 w
.59306 .70564 m
.59306 .70564 L
s
P
p
0 .935 1 r
.01 w
.7166 .54649 m
.74891 .5402 L
s
P
p
0 .006 1 r
.01 w
.62462 .68819 m
.62462 .68819 L
s
P
p
.002 w
.66231 .07781 m .67838 .07389 L .68642 .08112 L p
.4 g
F P
s
P
p
.124 0 1 r
.01 w
.5931 .70759 m
.5931 .70759 L
s
P
p
.012 0 1 r
.01 w
.62468 .69013 m
.62468 .69013 L
s
P
p
.002 w
.49315 .07298 m .50897 .06904 L p
.50176 .08022 L .4 g
F P
s
P
p
.002 w
.53338 .07237 m .50176 .08022 L p
.50897 .06904 L .4 g
F P
s
P
p
.002 w
.47739 .07691 m .49315 .07298 L .50176 .08022 L p
.4 g
F P
s
P
p
.142 0 1 r
.01 w
.59315 .70954 m
.57644 .69888 L
s
P
p
.031 0 1 r
.01 w
.62473 .69208 m
.62473 .69208 L
s
P
p
0 .08 1 r
.01 w
.68849 .66873 m
.65634 .6746 L
s
P
p
0 .396 1 r
.01 w
.59058 .6259 m
.62252 .61986 L
s
P
p
.002 w
.67838 .07389 m .66231 .07781 L p
.64602 .06326 L .4 g
F P
s
P
p
0 .879 1 r
.01 w
.78186 .5395 m
.79733 .55114 L
s
P
p
.002 w
.6703 .06661 m .67838 .07389 L p
.64602 .06326 L .4 g
F P
s
P
p
0 .916 1 r
.01 w
.74903 .54207 m
.78158 .53574 L
s
P
p
.002 w
.52485 .06509 m .54077 .06112 L p
.53338 .07237 L .4 g
F P
s
P
p
.002 w
.56522 .06448 m .53338 .07237 L p
.54077 .06112 L .4 g
F P
s
P
p
.002 w
.50897 .06904 m .52485 .06509 L .53338 .07237 L p
.4 g
F P
s
P
p
0 .099 1 r
.01 w
.72076 .66087 m
.6884 .66679 L
s
P
p
0 .378 1 r
.01 w
.62258 .62178 m
.65476 .6157 L
s
P
p
.002 w
.64602 .06326 m .66216 .05929 L .6703 .06661 L p
.4 g
F P
s
P
p
0 .118 1 r
.01 w
.75321 .65297 m
.72065 .65893 L
s
P
p
.002 w
.55675 .05715 m .57278 .05315 L p
.56522 .06448 L .4 g
F P
s
P
p
.002 w
.59726 .05653 m .56522 .06448 L p
.57278 .05315 L .4 g
F P
s
P
p
.002 w
.54077 .06112 m .55675 .05715 L .56522 .06448 L p
.4 g
F P
s
P
p
.161 0 1 r
.01 w
.57648 .70084 m
.55956 .69005 L
s
P
p
0 .898 1 r
.01 w
.78172 .53762 m
.78172 .53762 L
s
P
p
.002 w
.66216 .05929 m .64602 .06326 L p
.62953 .04853 L .4 g
F P
s
P
p
0 .359 1 r
.01 w
.65483 .61762 m
.68724 .61151 L
s
P
p
.002 w
.65398 .05192 m .66216 .05929 L p
.62953 .04853 L .4 g
F P
s
P
p
0 .136 1 r
.01 w
.78584 .64502 m
.75308 .65103 L
s
P
p
.002 w
.58887 .04915 m .60501 .04513 L p
.59726 .05653 L .4 g
F P
s
P
p
.002 w
.62953 .04853 m .59726 .05653 L p
.60501 .04513 L .4 g
F P
s
P
p
.002 w
.57278 .05315 m .58887 .04915 L .59726 .05653 L p
.4 g
F P
s
P
p
.002 w
.62953 .04853 m .64574 .04451 L .65398 .05192 L p
.4 g
F P
s
P
p
0 .155 1 r
.01 w
.81865 .63703 m
.7857 .64308 L
s
P
p
0 .341 1 r
.01 w
.68733 .61344 m
.71997 .60729 L
s
P
p
0 .248 1 r
.01 w
.80235 .61602 m
.81786 .62733 L
s
P
p
0 .229 1 r
.01 w
.81802 .62926 m
.81802 .62926 L
s
P
p
.002 w
.6212 .0411 m .63745 .03705 L p
.62953 .04853 L .4 g
F P
s
P
p
.002 w
.64574 .04451 m .62953 .04853 L p
.63745 .03705 L .4 g
F P
s
P
p
.002 w
.60501 .04513 m .6212 .0411 L .62953 .04853 L p
.4 g
F P
s
P
p
.18 0 1 r
.01 w
.55958 .69202 m
.55958 .69202 L
s
P
p
0 .211 1 r
.01 w
.81818 .6312 m
.81818 .6312 L
s
P
p
.198 0 1 r
.01 w
.55961 .694 m
.59187 .6881 L
s
P
p
0 .192 1 r
.01 w
.81834 .63314 m
.81834 .63314 L
s
P
p
.663 0 1 r
.01 w
.62671 .75936 m
.59431 .76502 L
s
P
p
0 .173 1 r
.01 w
.81849 .63508 m
.81849 .63508 L
s
P
p
.551 0 1 r
.01 w
.65887 .7416 m
.62636 .74732 L
s
P
p
.681 0 1 r
.01 w
.59436 .76703 m
.59436 .76703 L
s
P
p
.57 0 1 r
.01 w
.62642 .74932 m
.62642 .74932 L
s
P
p
.7 0 1 r
.01 w
.5944 .76904 m
.5944 .76904 L
s
P
p
.588 0 1 r
.01 w
.62648 .75133 m
.62648 .75133 L
s
P
p
.718 0 1 r
.01 w
.59444 .77106 m
.59444 .77106 L
s
P
p
0 .322 1 r
.01 w
.72008 .60922 m
.75296 .60303 L
s
P
p
.607 0 1 r
.01 w
.62653 .75333 m
.62653 .75333 L
s
P
p
.737 0 1 r
.01 w
.59448 .77308 m
.59448 .77308 L
s
P
p
.625 0 1 r
.01 w
.62659 .75534 m
.62659 .75534 L
s
P
p
.755 0 1 r
.01 w
.59453 .77509 m
.57754 .76466 L
s
P
p
.644 0 1 r
.01 w
.62665 .75735 m
.62665 .75735 L
s
P
p
.533 0 1 r
.01 w
.69151 .73384 m
.6588 .7396 L
s
P
p
.217 0 1 r
.01 w
.59191 .69008 m
.62441 .68416 L
s
P
p
0 .266 1 r
.01 w
.78649 .60263 m
.8022 .61408 L
s
P
p
0 .303 1 r
.01 w
.75308 .60497 m
.7862 .59874 L
s
P
p
.514 0 1 r
.01 w
.72434 .72603 m
.69142 .73183 L
s
P
p
.235 0 1 r
.01 w
.62447 .68614 m
.65721 .68017 L
s
P
p
.495 0 1 r
.01 w
.75736 .71818 m
.72423 .72403 L
s
P
p
.774 0 1 r
.01 w
.57758 .76669 m
.56037 .75613 L
s
P
p
0 .285 1 r
.01 w
.78635 .60068 m
.78635 .60068 L
s
P
p
.254 0 1 r
.01 w
.65728 .68216 m
.69026 .67616 L
s
P
p
.477 0 1 r
.01 w
.79056 .71029 m
.75723 .71617 L
s
P
p
.458 0 1 r
.01 w
.82396 .70234 m
.79042 .70827 L
s
P
p
.272 0 1 r
.01 w
.69035 .67816 m
.72357 .67212 L
s
P
p
.365 0 1 r
.01 w
.80739 .68121 m
.82314 .6923 L
s
P
p
.384 0 1 r
.01 w
.82331 .69431 m
.82331 .69431 L
s
P
p
.793 0 1 r
.01 w
.5604 .75817 m
.5604 .75817 L
s
P
p
.402 0 1 r
.01 w
.82347 .69631 m
.82347 .69631 L
s
P
p
.811 0 1 r
.01 w
.56043 .76021 m
.59325 .75444 L
s
P
p
.421 0 1 r
.01 w
.82363 .69832 m
.82363 .69832 L
s
P
p
1 0 .724 r
.01 w
.6287 .82698 m
.59573 .8325 L
s
P
p
.44 0 1 r
.01 w
.8238 .70033 m
.8238 .70033 L
s
P
p
1 0 .836 r
.01 w
.66142 .80892 m
.62833 .81451 L
s
P
p
1 0 .706 r
.01 w
.59578 .83458 m
.59578 .83458 L
s
P
p
1 0 .817 r
.01 w
.62839 .81658 m
.62839 .81658 L
s
P
p
1 0 .687 r
.01 w
.59582 .83666 m
.59582 .83666 L
s
P
p
1 0 .799 r
.01 w
.62845 .81866 m
.62845 .81866 L
s
P
p
1 0 .669 r
.01 w
.59586 .83875 m
.59586 .83875 L
s
P
p
.291 0 1 r
.01 w
.72368 .67412 m
.75715 .66804 L
s
P
p
1 0 .78 r
.01 w
.62852 .82073 m
.62852 .82073 L
s
P
p
1 0 .65 r
.01 w
.59591 .84084 m
.59591 .84084 L
s
P
p
1 0 .762 r
.01 w
.62858 .82281 m
.62858 .82281 L
s
P
p
1 0 .632 r
.01 w
.59595 .84293 m
.57868 .83274 L
s
P
p
1 0 .743 r
.01 w
.62864 .82489 m
.62864 .82489 L
s
P
p
1 0 .854 r
.01 w
.69463 .80122 m
.66134 .80685 L
s
P
p
.83 0 1 r
.01 w
.5933 .75649 m
.62637 .75069 L
s
P
p
.347 0 1 r
.01 w
.79128 .66796 m
.80723 .6792 L
s
P
p
.31 0 1 r
.01 w
.75728 .67005 m
.79099 .66394 L
s
P
p
1 0 .873 r
.01 w
.72804 .79347 m
.69454 .79915 L
s
P
p
.848 0 1 r
.01 w
.62643 .75274 m
.65974 .7469 L
s
P
p
1 0 .892 r
.01 w
.76165 .78568 m
.72793 .7914 L
s
P
p
1 0 .613 r
.01 w
.57872 .83484 m
.56122 .82453 L
s
P
p
.328 0 1 r
.01 w
.79114 .66595 m
.79114 .66595 L
s
P
p
.867 0 1 r
.01 w
.65982 .74896 m
.69338 .74309 L
s
P
p
1 0 .91 r
.01 w
.79545 .77784 m
.76152 .7836 L
s
P
p
1 0 .929 r
.01 w
.82945 .76996 m
.7953 .77576 L
s
P
p
.885 0 1 r
.01 w
.69348 .74515 m
.7273 .73924 L
s
P
p
.978 0 1 r
.01 w
.81261 .74871 m
.82861 .75956 L
s
P
p
.997 0 1 r
.01 w
.82878 .76164 m
.82878 .76164 L
s
P
p
1 0 .594 r
.01 w
.56125 .82664 m
.56125 .82664 L
s
P
p
1 0 .985 r
.01 w
.82894 .76372 m
.82894 .76372 L
s
P
p
1 0 .576 r
.01 w
.56127 .82876 m
.59468 .82313 L
s
P
p
1 0 .966 r
.01 w
.82911 .7658 m
.82911 .7658 L
s
P
p
1 0 .111 r
.01 w
.63076 .89698 m
.5972 .90235 L
s
P
p
1 0 .947 r
.01 w
.82928 .76788 m
.82928 .76788 L
s
P
p
1 0 .223 r
.01 w
.66405 .87862 m
.63038 .88407 L
s
P
p
1 0 .093 r
.01 w
.59725 .90451 m
.59725 .90451 L
s
P
p
1 0 .204 r
.01 w
.63044 .88621 m
.63044 .88621 L
s
P
p
1 0 .074 r
.01 w
.59729 .90667 m
.59729 .90667 L
s
P
p
1 0 .186 r
.01 w
.6305 .88836 m
.6305 .88836 L
s
P
p
1 0 .056 r
.01 w
.59734 .90883 m
.59734 .90883 L
s
P
p
.904 0 1 r
.01 w
.72741 .74131 m
.76148 .73536 L
s
P
p
1 0 .167 r
.01 w
.63057 .89051 m
.63057 .89051 L
s
P
p
1 0 .037 r
.01 w
.59738 .91099 m
.59738 .91099 L
s
P
p
1 0 .149 r
.01 w
.63063 .89266 m
.63063 .89266 L
s
P
p
1 0 .019 r
.01 w
.59743 .91315 m
.57986 .90324 L
s
P
p
1 0 .13 r
.01 w
.63069 .89482 m
.63069 .89482 L
s
P
p
1 0 .241 r
.01 w
.69787 .87099 m
.66397 .87648 L
s
P
p
1 0 .557 r
.01 w
.59473 .82525 m
.62839 .81958 L
s
P
p
.96 0 1 r
.01 w
.79625 .73562 m
.81245 .74663 L
s
P
p
.923 0 1 r
.01 w
.76162 .73744 m
.79594 .73146 L
s
P
p
1 0 .26 r
.01 w
.73188 .86331 m
.69777 .86884 L
s
P
p
1 0 .539 r
.01 w
.62845 .82171 m
.66237 .81601 L
s
P
p
1 0 .279 r
.01 w
.7661 .85559 m
.73176 .86116 L
s
P
p
.941 0 1 r
.01 w
.7961 .73354 m
.7961 .73354 L
s
P
p
1 0 .52 r
.01 w
.66245 .81814 m
.69662 .8124 L
s
P
p
1 0 .297 r
.01 w
.80052 .84782 m
.76596 .85344 L
s
P
p
1 0 .316 r
.01 w
.83514 .84001 m
.80036 .84566 L
s
P
p
1 0 .502 r
.01 w
.69672 .81454 m
.73116 .80877 L
s
P
p
1 0 .409 r
.01 w
.81802 .81864 m
.83427 .82923 L
s
P
p
1 0 .39 r
.01 w
.83444 .83138 m
.83444 .83138 L
s
P
p
1 0 .372 r
.01 w
.83462 .83353 m
.83462 .83353 L
s
P
p
1 0 .353 r
.01 w
.83479 .83569 m
.83479 .83569 L
s
P
p
1 0 .334 r
.01 w
.83497 .83785 m
.83497 .83785 L
s
P
p
1 0 .483 r
.01 w
.73128 .81092 m
.76597 .80511 L
s
P
p
1 0 .427 r
.01 w
.80139 .80574 m
.81785 .81648 L
s
P
p
1 0 .464 r
.01 w
.76611 .80726 m
.80108 .80142 L
s
P
p
1 0 .446 r
.01 w
.80124 .80358 m
.80124 .80358 L
s
P
p
.002 w
.63693 .02394 m
.8917 .25439 L
s
.8917 .25439 m
.96244 .88615 L
s
.96244 .88615 m
.66313 .68763 L
s
.66313 .68763 m
.63693 .02394 L
s
.11556 .15446 m
.03756 .80103 L
s
.03756 .80103 m
.66313 .68763 L
s
.66313 .68763 m
.63693 .02394 L
s
.63693 .02394 m
.11556 .15446 L
s
P
p
p
.002 w
.11556 .15446 m
.63693 .02394 L
s
P
p
.002 w
.23312 .12503 m
.23918 .1296 L
s
P
[(5)] .22099 .11589 .84618 1 Mshowa
p
.002 w
.38438 .08717 m
.39021 .09186 L
s
P
[(10)] .37272 .07778 .79174 1 Mshowa
p
.002 w
.54066 .04804 m
.54623 .05286 L
s
P
[(15)] .52951 .03841 .73731 1 Mshowa
p
.001 w
.26298 .11756 m
.26659 .12031 L
s
P
p
.001 w
.29304 .11003 m
.29662 .1128 L
s
P
p
.001 w
.32329 .10246 m
.32684 .10524 L
s
P
p
.001 w
.35373 .09484 m
.35726 .09764 L
s
P
p
.001 w
.41522 .07944 m
.41869 .08227 L
s
P
p
.001 w
.44627 .07167 m
.44971 .07452 L
s
P
p
.001 w
.47753 .06385 m
.48093 .06671 L
s
P
p
.001 w
.50899 .05597 m
.51236 .05885 L
s
P
p
.001 w
.20345 .13246 m
.20711 .13519 L
s
P
p
.001 w
.17396 .13984 m
.17766 .14255 L
s
P
p
.001 w
.14467 .14717 m
.14839 .14987 L
s
P
p
.001 w
.57253 .04006 m
.57585 .04297 L
s
P
p
.001 w
.60463 .03203 m
.60791 .03495 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29879 .03484 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004T0
0ol300;o0`03o`800ol20003o`0003000ol300?oP00004P000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<@000ol000050003o`0007d0001<0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<@000ol000050003o`0007d0001900?o0P001_l00?l0o`8000Ko003o0?l20003o`000340
00?o00000P03oa/01?mQ0000B0000ol0000400;o0P001Ol00?l000Ko=0000ol000020003o`0001L0
1?l20003o`3o060000180005o`000?l030000ol0o`0e00;o1004oa801?l60004o`00oel0001900?o
3`000ol0001;00Co0P000ol000050005o`000?l0GP000:D01?l<00Co0P02oed0002Q00Co00<0ool0
2@04o`:100CoPOoo0P000ol0001J0000W@04o``01?l3P@03oh6100Co0`000ol0001I0000V@06o`T0
1Ol8P@?o0h401Ol0003o05X0001W00?o1002obD01?l60003o`0000801?l4P@03oh6100Co00Fkbk_;
o`04P@03o`0000;oF@0006P000?o00000P001?l00?lP00Go2P04o`V10_l8^`03oh6100>100Go0000
o`1H0000J0000ol000020004o`00oa`01?l50003o`0000801Ol3P@03oh6100Go00jkbk_;^l^kbk_;
^l_ob`>10ol300;oEP0006P000?o00000P001?l00?lH00Go2@04o`V10_lA^`03ok^k00;o0h400ol0
00020003o`0000L00om90000J0000ol000020004o`00oa@01?l40003o`0000<01?l3P@03oh6100Go
01W;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00F10_l0103oool;0003o`0004H0001W00;o1@02oa40
1?l:00Co2842oaZk00?o^k/00[/5P@;o0`000ol000080003o`0004H0001m00Co10000ol0000200Go
0h400on1P@04o`0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;0h44o`<000?o0000
1003odT0001i00Co2@04o`V10_lS^`04ok^k^`Co0h42o`<000?o00000`000ol000190000M@04o`@0
00?o00000`03o`B100?oPH401?l09[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
1Ol4P@04oh61P@?o0X400ol0000200CoB00007401?l00h40000900;o2842obJk1?l00h7oP@07P@07
oh61POn1o`020003o`0004d0001300?o:003o`@000?oP@001@05o`:11Ol09[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l4P@;o2H43o`>100Co003oCP0004H000?o00008@04o`T0
00>10?l01?l4P@;o4[/3oa:k1?l9P@03oh6100>10ol3^`F100Co003oC@0004H000?o00007@04o`80
00?o00001P05o`B10ol3P@0=ok_;^l^kbk_;^l^kb`05o`=K00kobk_;^l^kbk_;^l^kb`Co0h400on1
P@07P@;o00^1oooobk_;^l^kb`05P@CoC00004<00olL00Co2`05o`>100?oPOl00_l7P@03ok^k00Nk
0_l9F`03ok^k00Rk0_l8P@03oh6100J100?oPOl02k/3P@?o0P02odX000130003o`0001P01?l20003
o`0000H01?l9P@03oh6100V100co^l^kbk_;^l^kbol9F`0<ol^kbk_;^l^kbk_o2H400on1P@06o`0>
^l^kbk_;^l^kbk_;^l/2o`>100Go0000o`190000@`04oa<01?l;00Co18400on1P@04o`Bk0_l9P@03
ok^k00Rk00?oFe/01e/2o`Vk00?oPH401h42o`Fk00?o^k/03K/5P@03o`0000;o9P05o`050?ooo`00
0ol300;o400005H01?l20003o`0000H01?l9P@;o00_;^l^kbk_;^l^ko`02P@Co00nkbk_;^l^kbk_;
^l^kbol00U/4o`AK00_o^l^kbk_;^l^ko`02P@Co1842o`0D^l^kok_;^l^kbk_;^l^kbk_;^l/5P@;o
0P000ol0000S0003o`00008000Co003o10001?l00?lA0000DP04o`/01?l3P@03oh6100Go3K/4oa>k
0_l9F`03ok^k00Nk0_l:P@04ok^koa6k0h43o`<000?o00008P000ol0000300?o0P02o`<000?o0000
3`0004h01?l20003o`0000H01?l8P@;o00fkbk_;^l^kbk_;^l^k00Go0e/05_nkbk_;^l^kbk_;^l^k
bk_;^l^kbol:F`0<ok_;^l^kbk_;^l_o2X405Onkok_;^l^kbk_;^l^kbk_;^l^kb`02o`>100Go0000
o`0S00Go0`000ol0o`050003o`0000l0001:00Co2`04o`>100?oPH401?l=^`Co2E/00onk^`05^`Co
2K/00omKF`08F`;o2K/00on1P@05o`>10_lC^`F10_l00`3oo`0R0003o`0000<00_l300?o00@0oooo
400004H01?l20003oh4000H01?l8P@;o00fkbk_;^l^kbk_;^l^k00Co15/00omKF`07F`03ok_;00Co
18402oo;^l^kbk_;^l_o009K1Ol4F`0:ol^kbk_;^l^kb`;o2H405Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`05P@;o0P000ol0000O0003o`0000d000?o00003`0004801?l70004oh4000Co0h400on1P@04o`nk
0_l9F`03oe]K00MK0_l9P@03ok^k00Nk0_l:F`03ok^k00Rk00?oPH401X42oaBk0h44o`8000?o0000
7P05oad0000n00Co0P000ol0000600Co2842o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`UK00?oFe/0
1?l01K_;^l_o00V100_obk_;^l^kbk_;^`02o`UK00cobk_;^l^kbk_;^ol7P@0Goh7o^l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l3P@;o0P000ol0000800?o1002obh0000j00Co2`04o`>100?oPH401?l=^`Co
2K/00omKF`07F`;o2K/00on1P@07P@;o2[/00omKF`04o`jk00?oPH401Ol2P@03ok^k01>k1842o`04
0?ooo`T000?o00000P001?l00?l]0000=P04o`8000?o00001P04o`R10_l03K_;^l^kbk_;^l^kbk/0
1?l4F`0;ok_;^l^kbk_;^ol00U/4o`0?^l^kbk_;^l^kbk_;^l_o00:11?l4P@0;ok_;^l^kbk_;^l/0
0_l04k_;^l^kbk_;^l^kbk_;^l^kbk/00_l4P@0Joh61POnkbk_;^l^kbk_;^l^kbk_;^l^kbk/3P@03
oh7o00<000?o00001P000ol000020004o`00obd0000b00Co2`04o`>100?oPH401?l=^`Co2E/00onk
^`07^`;o4K/4o`V100?o^k/07K/00on1P@02P@03oh6100:100?o^k/04k/2o`>100Go0000o`070003
o`00008000Co003o;@0002h01?l20003o`0000H01?l8P@;o00fkbk_;^l^kbk_;^l^k00Co15/00omK
F`07F`0Hok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4P@03oh6100N1027o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol00h400on1P@03P@;o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`F10_l2P@03
o`0000@000?o00000P001?l00?l]0000;002o`/01?l3P@03oh6100Co3k/2o`UK00?oFe/01e/00onk
^`0@^`Co2H400on1P@04ob>k00?oPH401?l4P@03ok^k01:k1H42o`8000?o00000P02o`D00_l^0000
;0000ol0o`0600Co2842o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`UK00?oFe/01?l04K_;^l^kbk_;
^l^kbk_;^l^k00Co18400on1P@07P@;o017;^l^kbk_;^l^kbk_;^l^kb`03o`0Dbk_;^l^kbk_;^l^k
bk_;^l^kbk/3o`R101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/00h44o`8000?o0000>00002`000Go003o
0004o`>100?oPH401?lJ^`03oe]K00MK0_lA^`Co2H400on1P@04oa6k1?l3F`03ok^k01>k00?oPH40
1h42oa>k0_l3P@;o0P000ol0000g0000;006o`B100?oPH400_l08;_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_o0U/4o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l4P@03oh6100N10_l04l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l8F`0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00;o0X44o`B101Co^l^kbk_;^l^k
bk_;^l^kbk_;^`F10_l00`3oo`0h0000:`02o`F11?lU^`;o4K/4o`V100?oPH401?lH^`03oe]K00MK
00?o^k/04K/4o`V100?o^k/04K/5P@;o0P000ol0000e00008P02o`L000?o0?l00_l4P@0fok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4P@03oh6100N1
0_l07/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`UK00oobk_;^l^kbk_;^l^kbk/01?l0187o
POl:P@0Dok_;^l^kbk_;^l^kbk_;^l^kbk/3P@Co0P000ol0000d00008@001?l00?l60003o`0000;o
1H400onk^`0`^`;o2H400on1P@04o`B100?o^k/06k/00omKF`04o`fk1?l5P@04oh61o`Z100?o^k/0
4K/2o`B100?o00000_ld00008@001?l00?l60003o`00008000?oPH400h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0:^l^kbk_;^l^ko`V10_l9P@0Nol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0_l03K_;^l^kbk_;^l^kbk/01?l3P@03oh6100>100GoPH61o`02P@Go
01Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/5P@Go<`00024000Co003o1P000ol0000300;o18400onk
^`0P^`Co0e/00onk^`07^`03oh6100Co18400on1P@07P@03ok^k012k1?lA^`Co28400on1P@02P@03
oh6100:10_lN^`>100CoPOoo0P000ol0000`00008@001?l00?l60003o`0000@00ol3P@0Pok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`QK00[o^l^kbk_;^l^k0_l9P@03oh6100N100kobk_;
^l^kbk_;^l^kb`Co15/03Oo;^l^kbk_;^l^kbk/01?l3P@03oh6100N100?oPH401?l08L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`>10_l20003o`0002l0000R00;o1`000ol000060003
oh6100:100?o^k/07K/00omKF`07F`03ok^k00Rk00?oPH401h400on1P@04o`jk0_l9F`03ok^k00Nk
0_l8P@03oh6100N10_l00k_o^`0N^`Co0e/00on1P@02P@Go<00002/000?o00001`000on1P@02P@0Q
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00UK0_l02/^kbk_;^l^kbol9P@;o01Fkbk_;
^l^kbk_;^l^kbk_;^l^kbol02E/02oo;^l^kbk_;^l_o00V100?oPH401?l08L^kbk_;ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`04o`QK00?oPH400X42o`8000?o0000;@0002X00ol:00;o0X42oajk
00?oFe/01?l4F`;o2;/00on1P@04o`bk1?l9^`03oe]K00MK00?o^k/01k/00on1P@07P@;o2K/00onk
^`0E^`Co0e/00omKF`07F`03oh6100Co0P000ol0000800?o0`03oa/0000Z0003o`0000/00_l3P@;o
01fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`YK00Wo^l^kbk_;^l/00_l03;_;^l^kbk_;
^l^kb`Co18402oo;^l^kbk_;^l_o009K1?l03/^kbk_;^l^kbk_;^l_o0X44o`B101go^l^kbk_;^l_o
bk_;^l^kbk_;^l^kbk_;^l^kb`04o`QK00?oFe/01e/2o`B100Co003o2P000ol000050003o`0001P0
000Z0003o`0000`00_l4P@03ok^k01bk0_l9F`03ok^k00nk1?l9P@03ok^k00Nk0_lB^`;o2H400onk
^`05^`03ok^k00bk1Ol4F`03oe]K00IK00?oFe/01?l4F`03oh6100:11?l90003o`0000D000?o0000
600002X000?o00003P000on1P@02P@;o01o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o009K
1?l04;_;^l^kbk_;^l^kbk_;^l/4o`B100?oPH401h408?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_o2H404_nkbk_;^l_obk_;^l^kbk_;^`Co2U/00omKF`02F`;o0U/2o`UK00GoPH7oP@02o`03
0?l000L000?o00000P03oa/0000Z0003o`0000l00_l4P@;o7K/2oa:k0_l9P@03oh6100N10_lM^`03
oh6100Co0h400onk^`03^`03ok^k00Bk1?l4F`03oe]K00QK1?l6^`03oe]K00MK0_l3P@;o00<0o`00
1P000ol000020003o`0001/0000Z0003o`00014000?oPH400h40<onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`R100?oPH401?l4P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`Co28402?nkbk_;ol^k1?l9F`03oe]K00Go00jkbk_;^l^kbk_;^l^ko`9K
1?l3F`03oh6100:10_l00h7oo`0400;o1004oaX0000Z0003o`00018000?oPH400h42oc:k00?oPH40
0X42o`:10_l9P@03ok^k01Bk1?l4F`03oh6100J100?o^k/01?l4F`03oe]K00MK0_lA^`Co25/00on1
P@02P@;o0P000ol0000U0000:P000ol0000B0004P@3oo`B103?obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l6P@03oh6100N101Co^l^kbk_;^l^kbk_;^l^k
bk_;^`;o2E/00on1P@02P@;o0X42o`03FomK00IK00?oFe/01?l04L^kbk_;^l^kbk_;^l^kbk_;00Co
15/00omKF`06F`03oh6100Co0P000ol0000T0000:P000ol0000A0004P@0000;o18400onk^`0`^`03
oh6100N100?oPH401?lH^`03oe]K00MK1?l6P@;o25/2oa6k1?l9F`03oe]K009K0_l2F`;o18401?l0
0?lU0000:@02oa<000>100000P02o`B102Oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol02[_;^l^kbk_;^ol9P@;o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`Co
00C;^l_o2H400omKF`04o`=K00gobk_;^l^kbk_;^l^k00Go0e/00omKF`08F`Co00Jkbk_;^l/5P@;o
00<0o`008`0002T000?o00004P000h4000040003oh6100:10_lP^`Co0e/00onk^`07^`03oh6100Co
18400onk^`0K^`;o2;/00on1P@06P@?o25/00onk^`07^`;o2E/00omKF`05o`fk0h401_n1ool0ob<0
000Y0003o`00018000>100001@02o`B101ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`QK
00[o^l^kbk_;^l^k0_l9P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
0X44o`05boo;^ol025/03?o;^l^kbk_;^l^ko`UK0_l04l^kbk_;^l^kbk_;^l^kbk_;^l/00_l2P@05
ol_o0?l08P0002T000?o00004P000h4000070003oh6100:100?o^k/07;/2o`MK00?o^k/02;/2o`R1
0_lV^`;o1K/01Onk^k_o00AK0_l2F`;o2K/00omKF`04o`=K00?o^k/04[/4P@Go8@0002T000?o0000
4P000h40000800;o0h42o`0Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`04F`03oe]K00;o
00_;^l^kbk_;^l^ko`02P@?o1840<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kboo;^l^k1?l6F`0:ok_;^l^kbk_;^`;o25/05Onkbk_;^l^kbk_;^l^kbk_;^l^kb`03P@06
oh7oo`3o800002T000?o00004P000h40000900?o0h400onk^`0L^`Co1E/2o`Vk0_l8P@03ok^k02Vk
00?o^k/00k/00omKF`07F`03ok^k00Rk00?oFe/01U/00onk^`0B^`;o0h42o`030?l001h0000Y0003
o`00018000>100002`000on1P@02P@0Pol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol9F`0<
ok_;^l^kbk_;^l_o2840<onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
bk_;^l^ko`09F`;o00[;^l^kbk_;^l_o15/2o`9K0_l04l^kbk_;^l^kbk_;^l^kbk_;^l/01H44oah0
000Y0003o`00018000>1000030000on1P@02P@03ok^k01bk00?oFe/01e/00onk^`08^`03oh6100:1
0_l2P@;o:;/00onk^`05^`03oe]K00Co15/00onk^`07^`Co1U/00onk^`0A^`F10olN0000:@000ol0
000B0003P@0000h00_l2P@;o01jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol2F`Co00jkbk_;
^l^kbk_;^l^kb`Co1X40;Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;
^`06o`UK00_obk_;^l^kbk_;o`09F`0Dol^kbk_;^l^kbk_;^l^kbk_;^l/3P@Co7P0002P00_lD0003
P@0000l00_l3P@;o6[/4oa>k00?oPH401h400onk^`0S^`Ko1U/00omKF`07F`03ok^k00Nk00?oFe/0
1e/2o`jk1_l00h6k^`02oad0000X0003o`00018000>100004P000on1P@02P@0Fol^kbk_;^l^kbk_;
^l^kbk_;^l^kb`Co15/05Oo;^l^kbk_;^l^kbk_;^l^kbk_;o`09P@;o022kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`?o0U/2o`UK00?oFe/01?l03/^kbk_;^l^kbk_;^l_o0U/4o`AK00So^l^k
bk_;^`Ko1844o`030?l001d0000X0003o`00018000>100004`000on1P@02P@;o3[/5o`UK00?o^k/0
4K/00on1P@04o`B100?o^k/06K/4o`EK00?oFol02E/2o`jk1_l9F`03ok^k00Co2H400ol000040003
o`0001/0000X0003o`00018000>100005002o`B100[o^l^kbk_;^l^k1?l5F`;o25/05?o;^l^kbk_;
^l^kbk_;^l^kbk_;0_l9P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l4F`03oe]K009K00CoFe_o
0U/4o`0<bk_;^l^kbk_;^l^k1_l6F`03oe]K00MK0_l6P@Co2P000ol0000K0000:0000ol0000B0003
P@0001H000?oPH400X400onk^`07^`03oe]K00MK00?oFe/00olH^`03oh6100N10_lB^`;o2E/01?mK
Fe/2o`9K0_l<^`Co0e/00omKF`07F`047emO7`?o2H400ol0000<0003o`0001/0000X0003o`000180
00>100005P000h7oP@03P@;o00W;^l^kbk_;^ol02E/2o`0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol00X44o`B101Gobk_;^l^kbk_;^l^kbk_;^l^kbol02E/4o`0=^l^kbk_;^l^kbk_;^`04o`QK
00goGamO7aLO5alG7elO00F11?lB0003o`0001/0000X0003o`00018000>100005P001840ool4P@;o
1k/00omKF`04ob6k0_l9P@03ok^k00:k1_l9^`03oe]K00Co1K/00onk^`07^`Co15/00omKF`02F`0;
7elOGamO7elOGal01El4P@03o`0001@000?o00006`0002P000?o00004P000h40000F0005P@000?l0
1H402?nkbk_;^l^k0_l09l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`R1
1?l6F`0:ol^kbk_;^l^kb`;o00nkbk_;^l^kbk_o^l^kbk/01?l7F`@O01=O7elOGamOoaLOGamO7elO
Gaoo008000>100005@000ol0000K00009`000ol0000C0003P@0001H000>100000P000on1P@03P@;o
<;/00on1P@03o`=K00?oFe/01e/00onk^`0A^`03ok^k00?o15/03_lO7amO7elOGamO7elO0h400elG
G`06G`H000>100005@000ol0000K00009`02oa@000>100005P000h40000400;o1840;oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co1e/00omKF`07F`0Col^kbk_;
^l^kbk_;^l^kbk_;^`03o`@O00EK7elOG`067`F100TG7aLO5amO7el02`000h40000D0003o`0001/0
000W0003o`0001<000>100005@000h4000060003oh6100>100?o^k/09k/4o`AK00?oFe/01E/00omK
F`04oaFk00?o7al02Al2o`F10Ql01elGGaMO5el00a400ilA00090003P@0001@000?o00006`0002L0
00?o00004`000h40000E0003P@0000L000?oPH400h42o`0@^l^kbk_;^l^kbk_;^l^kb`Co016kbk_;
^l^kbk_;^l^kbk_;^`02o`UK00?oFe/00U/00omKF`02o`0G^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0Ql02_lO7aooFamO7ol6P@AO11402IlAWa6O4IlAW`0:0003P@0001D000?o00006P0002L000?o0000
4P000h40000F0003P@0000T00_l4P@03ok^k00Vk1?l4F`03ok^k012k00?oFe/01e/4o`F100?o^k/0
5;/27`03ok^k00Co1H402UlO7alAWa6O4Il74@0309nO00:O2@000h40000E0003o`0001X0000W0003
o`00018000>100005P000h40000;0003oh6100:100Wo^l^kbk_;^l/00_l9F`05ok_;^l/01Ol02/^k
bk_;^l^kbol2F`Co00G;^l^ko`07P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2P@?o00AO7elO
2A40102O4Il700>O20000h40000E0003o`0001X0000W0003o`00018000>100005P000h40000<0003
oh6100:100?o^k/01k/00omKF`07F`Co1E/2o`Rk0_l9^`03oh6100:100?oPH400_l>^`Ko00>1oh40
0X4;4@03Wa4000l00il70003P@0001D000?o00006P0002L000?o00004P000h40000F0003P@0000d0
0ol2P@;o00W;^l^kbk_;^ol00U/4o`AK00?oFe/01U/05?nkbk_;^l^kbk_;^l^kbk_;^l^k1?l5P@08
ol^kbk_;^l/6o`>100XA5a4GoaLA5a4G1a4E00>O1P000h40000E0003o`0001X0000V0003o`0001<0
00>100005P000h40000?0003oh6100:100?o^k/01[/2o`UK00?oFe/00U/2o`9K00?o^k/04K/00on1
P@06P@03ok^k00Co1H401ALA5a4G00<A00?o4A400Q40100A4A4I00BO1@000h40000E0003o`0001X0
000V0003o`0001<000>100005P000h40000@0003oh6100:100[obk_;^l^kbk_;0_l8F`Co01Zkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`R10_l3P@DA00`G4ALA5a4G4AOo084Q0003WmnO00@000>10000
5@000ol0000J00009P000ol0000C0003P@0001H000>100004@000on1P@02P@;o2K/00omKF`03ob2k
00?oPH400ol02X4G5a4G4ALA5a425`0<4ALOGamO7elOo`218P03W`04g`00PAL000?o00006P0002H0
00?oPOl04`000h40000F0003P@0001800_l4P@0:ok_;^l^kbk_;^`;o023;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`Co0QL;4@<00el00aMO00040003o`2102<000>O4Il00P000h40000E0003
o`0001X0000F00?o1002o`L000?o08404`000h40000F0003P@0001@000?oPH400X400onk^`0R^`Ko
18475`T000<GG`001`000ol0P@0Q0005WmnOgil00P000h40000F0003o`0001T0000G0003o`000080
00Co003o1P000ol00002PA4000>100005P000h40000D0003POn100>10_l07l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00ol9P@04oa4A4@8G2@0015lGGaL80003o`2101d000JOgioOWml3W`<0
00>100005@000ol0000I00005`000ol000020004o`00o`H000?o00000P000h40000=0003P@0001L0
00>1000050001840ool4P@03ok^k01Rk1?l6P@?o1`034@045`0000PG20001?l0084H00;O00NOgioO
WmnO00L000>100005@000ol0000I00005`000ol000020004o`00o`H000?o00000`02P@d000>10000
5`000h40000D0003P@00008018405_o;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`:11?l2P@;o2`035`03
4ALG008G00=O5el02`001?l0084D00NO00?OW`002P000h40000E0003o`0001T0000G0003o`000080
00Co003o1P000ol000050003P@0000X000>100005`000h40000D0003P@0000<000CoPH610_l>^`Go
1H42o`D000>1000030000aLA5`024@l000Co00214P07g`l000>100005@000ol0000I00005P02o`D0
0_l60003o`0000L00X4:0003P@0001H000>100005@000h40000400;o0h42o`06bk_;^l^k1_l4P@?o
2P000h40000>00035a4G010000?o08403P001=lAga43W`D00mh00ml000080003P@0001D000?o0000
6@0002D000?o00002@000h4000070003P@0001H000>100005@000h4000060003oh6100:100?o^k/0
0ol9P@03o`0000/000>100003`000a4G000?0003o`2100X0014AWa6O4IlAgmkOg]oNgmkOgP02g`03
g]l000P000>100005@000ol0000I00009@000ol0000:00:11`000h40000F0003P@0001D000>10000
1`000on1P@02P@;o1845oa4000>100008@000ol0P@060006gioOWmlA0]l01=kOg]l9gP030=kN00;N
20000h40000E0003o`0001T0000U0003o`0000`000>1000010000h40000F0003P@0001D000>10000
2002o`:k1OlG0003P@00024000?o08400P05W`GO00[NgmkOg]l0gmkO20000moNg`070003P@0001D0
00?o00006@0002@00ol>00:110000h40000F0003P@0001D000>100002P02oa`000>100008@000ol0
P@02g`WN00?Og]l04@03gPH000>100005P000ol0000H00009@000ol0000?0005P@00084060000h40
000D0003P@0000/000?o00006`000h40000M00CN00?ogml02=lH0003gmkN00D000>100005P000ol0
000H00009@000ol0000@00:100<0P@005`000h40000D0003P@0000/000?o00006`000h40000E0009
g]oNgmkOg]oN00;O00KNomkOg]lN0004g]oNg`@000>100005P000ol0000H00009@000ol0000B00:1
60000h40000D0003P@0000/000?o00006`000h40000@00kN00JOgmoo084R00?N0`000h40000F0003
o`0001P0000T0003o`0001<000>108405`000h40000D0003P@0000/000?o00006`000h40000700;O
0P04g`0>g]oNgmkOgP3NgmkOWml40003o`2102<000?Og]h00`000h40000E0003o`0001P0000T0003
o`0001<000>100000X4E0003P@0001@000>100002`000ol0000K0003P@0000L02]h60003ginO00L0
00?o084090000g7N00020003P@0001D000?o0000600002@000?o00004`000h4000020003P@000180
00>1000050000h40000;0003o`0001/000>100001`05g`T00]l00ioO00070003o`2102801=h30003
P@0001D000?o0000600002@000?o00004`000h40000300:14P000h40000D0003P@0000/000?o0000
6`000h4000090005g]oNg]l00`08g`P000?o08407@002G7NLMiagW7NL@030003P@0001D000?o0000
600002@000?o00004`000h4000050003P@0000l000>1000050000h40000;0003o`0001/000>10000
2P03g`03g]oO00KO2`000ol0P@0I00[N1P000h40000E0003o`0001P0000T00;o50000h40000600:1
3`000h40000D0003P@0000/000?o00006`000h40000;0004g]oOgP?O3`000ol0P@0E0009LMiagW7N
LMia00/000>100005P000ol0000G00008`02oaD000>1000020000h40000<0003P@0001@000>10000
2`000ol0000K0003P@0000h000?Og]l040000ol0P@0A00WN3`000h40000F0003o`0001L0000T0003
o`0001<000>100002@02P@/000>100005@000h40000;0003o`0001/000>100003`000moN000?0003
o`2100d01g400mia00040004g9GLU@X000>100005P000ol0000G00008`000ol0000D0003P@0000/0
00>1000020000h40000E0003P@0000/000?o00006`000h40000Q0003o`2100/01mh;U@03LMbE00T0
00>100005P000ol0000G00008`000ol0000D0003P@0000`00X480003P@0001D000>100002`000ol0
000K0003P@00024000?o08401`04gP=a00nEg9GLUMbEg9GLUMbEg00019D80003P@0001H000?o0000
5`0002<000?o000050000h40000>0003P@0000D000>100005@000h40000:0003o`0001`000>10000
8@001?l008420005gW7NLMh02iD0102EUID80003UMbE00L000>100005P000ol0000G00008`000ol0
000C0003P@0001000X450003P@0001D000>100002P000ol0000L0003P@00024000Co0=kN0iD01mbE
g9GLUM`00YD00mbE000@00>E1P000h40000F0003o`0001L0000S0003o`0001<000>100004P000h40
00020003P@0001D000>100002P000ol0000L0003P@0001d000GMUMfEo`0;UAP000>Eg=`01P000h40
000D0003POn101P0000S0003o`0001<000>100004`02P@8000>100005@000h40000:0003o`0001`0
00>100006@08U@03oiFE00:E7`04U@D000>100003`05P@030?l001P0000S0003o`0001<000>10000
5@000h40P@0G0003P@0000X000?o000070000h40000C000<gIGMUMfEgIGMUMea0YD01?l0084R00?L
10000h40000:00F11`000ol0000F00008`02oa@000>100005P02PAL000>100002P000ol0000L0003
P@0000L0011ag@00UG6ELIGMUMfEgIGM0iD2gPD000Co00218`02U@05g00008401`05P@`000?o0000
5P00028000?o000050000h40000G00:15P000h40000:0003o`0001`000>100001`003G6ELIEaUG6E
gIGMUMd00`000mia00070004o`00PB@000>Eg0000P000h400005PA4000?o00005P00028000?o0000
50000h40000G0004P@21PA@000>100002P000ol0000L0003P@0000L000FELIEaU@0900Aa2@000ol0
P@0R00CL00<0PH400h4F0003o`0001H0000R0003o`0001@000>100005`001H40002101<000>10000
2P000ol0000L0003P@0000T000EaUG6EL@0300Ia00?NL@0020000ol0P@0N00SL00B1002160000ol0
000F00008P000ol0000D0003P@0001L000>100000P02PA4000>100002P000ol0000L0003P@0000X0
00?MLMd00W400meaL@04L@`000?o08407007g0H000>100005P000ol0000F00008P000ol0000D0003
P@0001L000>1000010000h40000>0003P@0000X000?o000070000h40000;0007LIEaUG7ML@0@0003
o`2101P000?/g>`01=`:0003P@0001H000?o00005P00028000?o00004`000h40000H0003P@0000D0
0X4=0003P@0000/000?o000070000h40000>00=a4@000ol0P@0C00_L2`000h40000F0003o`0001H0
000200?o7@000ol0000C0003P@0001P000>100001`000h40000:0003P@0000/000?o000070000h40
000?0003LID0010000?o08403`002]c/g>cLk=c/g>`@0003P@0001H000?o00005P00008000Co003o
70000ol0000C0003P@0001L000>100002@02P@X000>100002`000ol0000L0003P@00028000?o0840
2P000h7Lg008g0H000Bg][Jf2P000h40000G0003o`0001D000020003o`0001`000?o000050000h40
000G0003P@0000/000>100001`000h40000;0003o`0001`000>100008P000ol0P@0500B10m`01>cL
k=`200Bg00Rf]kJg][Nf]`:f2P000h40000F0003o`0001D000020003o`0001`000?o000050000h40
000G0003P@0000`00X470003P@0000/000?o000070000h40000R0003o`2100F100S/g>cLk;Nf]`:f
00jg][Nf]kJg][Nf]kJg00Bg2@000h40000F0003o`0001D000000`3oo`02oa`00_lE0003P@0001L0
00>100003P02P@D000>100002`000ol0000L0003P@0002000X401_n1P@3Lk0;L3[L0102f]kH80003
][Nf00P000>100005P000ol0000E00000P000ol0000L0003o`0001@000>100005`000h40000@0003
P@00008000>100002`000ol0000L0003P@0001/01H420003ombg00>g00bf]kJg][Nf]`2f]kHA00>g
1`000h40000F0003o`0001D000020003o`0001`000?o000050000h40000G0003P@0001400X420003
P@0000/000?o000070000h40000F00F10`002[O/]kKo][Nf]kH3]a/000>f]kH01P000h40000F0003
o`0001D0000Q0003o`0001@000>100005`000h40000C0003P@2100d000?o000070000h40000A00B1
00?/]n`02[L00ong]`0Q0004][Nf]`D000>100005P000ol0000E00008@000ol0000D0003P@0001L0
00>100005002P@d000?o000070000h40000<0004PKO/]`;/00fgk;O/]nbgk;O/]nbg00<000?o0840
8`000kJg]P040003P@0001H000?o00005@00024000?o000050000h40000G0003P@0001D00X4<0003
o`0001`000>100001`02k005]nbgk;L00^`01kO/]nbgk0000kL80004o`00PB<000>g][L00`000h40
000F0003o`0001D0000Q0003o`0001<000>1000060000h40000E0004P@21P@X000?o000070000h40
000300B100^gk;O/]nbg0>bgk00600;/20001?l0084T0003][L0008000>100005`000ol0000D0000
80000ol0000D0003P@0001P000>100005@001H40002100T000?o00007006P@@000>gk;L00^`800KL
20001?l0084R0004]_bf]P<000>100005`000ol0000D000080000ol0000D0003P@0001P000>10000
5@000h40000200:11`000ol0000H00F13003k005g03/k=`02>`80004o`00PAh02;H30003P@0001L0
00?o00005000020000?o000050000h40000H0003P@0001D000>1000010000h4000040003o`0001<0
1H440003P@0000/01>`2g004k=cLg0d000Co00216P03]P06o;Kl]_bf1P000h40000G0003o`0001@0
000P00?o50000h40000H0003P@0001D000>100001@02P@@000?o00003P05P@T000>100003@000mc/
g002k10000Co00215@07o0>f2`000h40000F0003o`0001@0000@00Co0`02o`L000?oP@0050000h40
000H0003P@0001D000>100001`001H40003o00/01H4>0003P@0000h01>`@0004o`00PA<02;H?0003
P@0001H000?o00005000014000?o00000P001?l00?l60004o`21PA<000>100005`000h40000F0003
P@0000P00X400`3o000500F14`000h40000?0003g>`0010000Co00213`07o1@000>100005P000ol0
000D00004P001Ol0003o008000?o000010001Ol00021018000>100005`000h40000F0003P@0000X0
00>1o`001H4H0003P@00028000Co00212`002_bfo;Kl]_bfo;H600043L`=c0/000>100005P000ol0
000D00004`001?l00?l20003o`0000@000?o00000P02PA0000>100005`000h40000F0003P@0000/0
00?oP@0070000h40000R0004o`00P@L000>fo;H01_`600063L`=c0g<0`d00l`000080003P@0001H0
00?o00005000010000Co003o0P001?l00?l50003o`0000D00X4>0003P@0001L000>100005P000h40
000;0003o`0001`000>100008P001?l00842000;]Obeo;Gl]Obeo;D00`004L`=c0g<3L`=c0g<3@3<
3L`=00T000>100005`000ol0000C00004@02o`@00_l60003o`0000L000>100002`000h40000G0003
P@0001H000>100002`000ol0000L0003P@000280013o002f]KKl]_bfo;H=c0g<2@d00l`=00070003
c0g<00P000>100005`000ol0000C00007`000ol0000800:12P000h40000H0003P@0001H000>10000
2P000ol0000M0003P@0002000kH01?nf][H;3@05c0g<3L`03`000`g<3@070003P@0001L000?o0000
4`0001l000?o00002P02P@P000>1000060000h40000E0003P@0000/000?o00007@000h40000N00D=
00co3L`=c0g<3L`=c0dH0003c0d=00H000>100005`000ol0000C00007`000ol0000<0003P@0000D0
00>1000060000h40000E0003P@0000/000?o00007@000h40000F00d=00?o3@d00PdO00C<1@000h40
000G0003o`0001<0000O0003o`0000d00X450003P@0001P000>100005@000h40000;0003o`0001d0
00>100003@000kD=]@0?3@0700g<3Ol0P@0S00<=10000h40000G0003o`0001<0000N00?o4002P@<0
00>1000060000h40000E0003P@0000/000?o00007@000h40000700033KD=00d=00@03@d=20000ol0
P@0T00C<0P000h40000G0003o`0001<0000O0003o`00014000B100216P000h40000E0003P@0000/0
00?o00007@000h4000070008]@fe3KD=]@033@@01;D90003o`2102D000<=c<`00`000h40000F0003
o`0001<0000N0003o`0001<00h4J0003P@0001D000>100002`000ol0000M0003P@0000L010d00kD0
000400053KD=]@d00kD90003o`2102H000?<3@000P000h40000G0003o`000180000N0003o`0001D0
0X4I0003P@0001D000>100002`000ol0000M0003P@0000X010d200Ne30000ol0P@0R00G<00D=0000
P@0I0003o`000180000N0003o`0001D000>1084060000h40000E0003P@0000/000?o00007@000h40
000;0003]@fe00Be00<=00003P000ol0P@0M000;3L`=c0g<3L`=c0d00`000h40000G0003o`000180
000N0003o`0001D000>100000X4F0003P@0001D000>100002`000ol0000M0003P@0000d01@dA0004
o`00PAP02/`80003P@0001L000?o00004P0001h000?o00005@000h40000200:14`000h40000F0003
P@0000/000?o00007@000h40000@00:e4@001?l0084C000;c0g<3L`=c0g<3L`030000h40000G0003
o`000180000N0003o`0001@000>100001@02PA4000>100005P000h40000;0003o`0001d000>10000
8`001?l0084?0004c0g<3@K<4@000h40000G0003o`000180000N0003o`0001@000>100001`000h40
000>0003P@0001H000>100002`000ol0000M0003P@0002<000Co00212`002Pg<3L`=c0g<3L`E0003
P@0001L000?o00004P0001h000?o000050000h40000800:13P000h40000F0003P@0000/000?o0000
7@000h40000S0004o`00P@T00l`010g<3L`;0004S4b<C0/000>100005`000ol0000B00007@000ol0
000E0003P@0000X00X4<0003P@0001H000>100002`000ol0000M0003P@0002<000Co002110002L`=
c0g<3L`=c00500^<00=<S4`02P000h40000G0003o`000180000M00;o5P000h40000<0003P@0000T0
00>100005P000h40000;0003o`0001d000>100008`001Ol0084=00S<00F<aXc60006S009C8a<S4b<
C8`000><00=<S0001`000h40000H0003o`000140000M0003o`0001D000>100003@02P@T000>10000
5P000h40000;0003o`0001d000>100008`000oo<c004c0033Lb<00f<00@0S8b<200014b<C8`70003
P@0001P000?o00004@0001d000?o00005@000h40000?00:11`000h40000F0003P@0000/000?o0000
7@000h40000O00;<010=c?o<3Hc6S<J<aXc6S<J<0P03S18000><C8`01P000h40000H0003o`000140
000M0003o`0001D000>100004@000h4000040003P@0001H000>100002`000ol0000M0003P@0001X0
0l`00hc6S002aP08S?n<aXc6S<H3S1`000><C4`01P000h40000D00>100?o00004@0001d000?o0000
5@000h40000B00:110000h40000F0003P@0000/000?o00007@000h40000D000<aXc6S<J<aXc6S<J<
0/H01HcoS<J<028018`50003P@0000l01H430003o`000140000M0003o`0001D000>100005002P@80
00>100005P000h40000;0003o`0001d000>100003P0;aP05S<J<aX`01@001?l0084T0003C8a<00@0
00>100002P05P@P000?o00004@0001d000?o000050000h40000G0003P@2101P000>100002`000ol0
000M0003P@0000L00/H03<36`<K0a/36S<J<aP@000?6`0001`001?l0084U0003S4b<00<000>10000
1006P@d000?o00004@0001d000?o000050000h40000H00:160000h40000;0003o`0001d000>10000
1`08aPD000G6`<K0aP02`0P000Co00219P02C0<000>10840184C0003o`000140000L0003o`0001D0
00>100006@03PAH000>100002`000ol0000M0003P@0000L000?0a/001LH00`30`008`0T000Co0021
900018a<aT`5PAP000?o00004@0001`000?o00005@000h40000I0004P@00PAD000>100002`000ol0
000M0003P@0000`000?6`<H00/02aP03`<H000d000Co00217`09S0<000>1000060000ol0000@0000
70000ol0000E0003P@0001T000B100000X4B0003P@0000`000?o00007@000h40000>0004a/36`180
00?o08407@0024b<C8a<S4b<1P000h40000H0003o`000100000L00;o5P000h40000H0003P@0000@0
0X4@0003P@0000`000?o00007@000h40000?0003`<K0018000?o084060000h6<S005S0/000>10000
60000ol0000@000070000ol0000E0003P@0001P000>100001P000h40000=0003P@0000`000?o0000
7@000h40000@0003a/00014000?o08404P02P@]<30000h40000H0003o`000100000L0003o`0001D0
00>1000060000h40000700:13@000h40000<0003o`0001d000>1000090000ol0P@0=00>100B<C8a<
1X`A0003P@0001P000?o0000400001`000?o00005@000h40000H0003P@0000T00X4;0003P@0000`0
00?o00007@000h40000T0003o`2100P018402Xa<S4b<C8a<S4`E0003P@0001P000?o0000400001`0
00?o00005@000h40000H0003P@0000/00X490003P@0000`000?o00007@000h40000T0005o`00P@00
1X402Ha<S4b<C8a<S00K0003P@0001L000?o0000400001/000?o00005P000h40000H0003P@0000d0
00>100001P000h40000<0003o`0001d000>1000090000on1P@02P@0304a<00U<30001Da=C4e<009=
2`000h40000G0003o`000100000K0003o`0001D000>100006@000h40000>00:11P000h40000<0003
o`0001d000>100007`05P@05o`00PH`00T`01Ha<S4b<00P000=<CD`03Td:0003P@0001L000?o0000
400001/000?o00005@000h40000I0003P@0001000X440003P@0000/000?o00007P000h40000I00J1
10002HcoS4b<C8a<S0030003C4e<00]=00E<CDa=C00400A=2@000h40000H0003o`0000l0000K0003
o`0001D000>100006@000h40000B0005P@0008403@000ol0000N0003P@0001@01H46000;C8a<S4co
C8a<S4`00Td03Da=C4e<CDa=C4e<CD`03`03C@P000>1000060000ol0000?00006`000ol0000E0003
P@0001T000>100004`02P@03084000`000?o00007P000h40000?00F11`05C0A=00?oCDd014d01Da=
C4e<01T014d60003P@0001P000?o00003`0001/000?o00005@000h40000I0003P@0001D00X4=0003
o`0001h000>100002@06P@P001=<CDa=C4e<CDa=C4e<oda=C4e<020014d50003P@0001P000?o0000
3`0001/000?o00005@000h40000I0003P@0001H00X4<0003o`0001h000>100001005P@D01Dd01Da=
C4e<00U=1Ol00`21000S0003CFI=00@000>1000060000ol0000?00006P03oaH000>100006@000h40
000F0004P@21P@X000?o00007P000h40P@04P@@00Td6C00<CDa=C4e<CD`0C4e<1Ol50003oh4002@0
0dd30003P@0001P000?o00003`0001X000?o00005P000h40000I0003P@0001H000B100000X480003
o`0001X01X4900M=00@0CDa=0P000dcoo`04o`/00_lU0003CFH0008000>1000060000ol0000?0000
6P000ol0000F0003P@0001T000>100005P000h4000030003P@0000D000?o00005@05P@@000>10000
2003C0A=00<0COl01?l01De<CDa=00`000>10?l090000deV00020003P@0001P000?o00003`0001X0
00?o00005P000h40000H0003P@0001L000>100001002P@D000?o00004005P@T000>100002`06o`03
CDa<009<4@000h400002ob0000A=ITe>0`000h40000H0003o`0000l0000J0003o`0001H000>10000
60000h40000G0003P@0000H00X430003o`0000X01X4>0003P@0000D01_l00`1=C@04C@03C0000180
00>100000P000ol0000H00UV10000h40000H0003o`0000h0000J0003o`0001D000>100006@000h40
000G0003P@0000P000B1003o1`05PA@000>100001Ol;00=<50000h40000300;o50002VI=ITeVCFI=
ITd70003P@0001P000?o00003P0001X000?o00005@000h40000I0003P@0001L000>100002@02P@03
o`0000F15P06oa400TdD0003P@0000D000?o000030001diVCVI>ITh00fH<0003P@0001P000?o0000
3P0001X000?o00005@000h40000I0003P@0001L000>100002`000on1P@0F00Go0`000h40000W0003
P@0000H00_l8000:CDi=ITeVCFI=IQ0000>1000060000ol0000>00006P000ol0000E0003P@0001T0
00>100005`000h40000;0003o`0001001_l80003P@0002L000>1000020001?l00007CP03ITh001@0
00>1000060000ol0000>00006@000ol0000F0003P@0001T000>100005`000h40000;0003o`0000/0
1Ol>0003P@0002L000>1000020002FKoodi=CTe>C@0I0003P@0001P000?o00003P0001T000?o0000
5P000h40000I0003P@0001L000>100002`000ol0000500Ko4`000h40000W0003P@0000<000Y=ITeV
CFI=C_m>7@000h40000H0003o`0000h0000I00?o5P000h40000I0003P@0001H000>1000030000ol0
o`05oaT000>100009`003840IVI=ITeVCFI=IP<00_l;0006@Tm2Cd9?2`000h40000H0003o`0000h0
000900?o1002o`L000?oP@005P000h40000I0003P@0001H000>100002@05oal000>1000090002VI=
ITeVCFI=ITd:0003od9200=200Q?@Tm2Cd9?@P9?00=2C`002@000h40000H0003o`0000h0000<0004
o`00o`8000?o000010001?l0PH4E0003P@0001T000>100005P000h40000300Ko0`000ol0000N0003
P@00020000=VCFH01fH60009Cdi?CTm2Cd9?00;o00U2Cd9?@Tm2Cd800`04C`T000>100006@000ol0
000=000030001?l00?l20003o`0000@000Co00000X4C0003P@0001T000>100005P000h7oo`03o`T0
00?o00007P000h40000K0006ITeVCFI=0VH01deV001?@Tl044800`3o000<0003Cd9?00P000>10000
6@000ol0000=00002P02o`<000Co003o1P000ol0000300:140000h40000J0003P@0001401_l>0003
o`0001h000>100006@001DeVCVI=00E200i?@Tm2Cd9?@Ti?CTm>C`/00_l<00=?00=2000010000h40
000I0003o`0000d0000<0004o`00o`8000?o000010000ol0000500:13P000h40000J0003P@0000`0
1Ol50003P@0000`000?o00007P000h40000E0003@Tm2009?00m2Cd9?@Tm2Cd9?@Tm2Ch405@000ol0
000:0003Cd9?009?1@000h40000H0003o`0000d0000900?o1002o`L000?o00001`02P@`000>10000
6P000h40000600Ko2P000h40000<0003o`0001h000>1000020000d9V@P020003Cd9?00m22@000h40
000D00;o3000149?@Tl40003P@0001P000?o00003@0001P000?o00002P000h4000090003P@0001X0
00>100001_l@0003P@0000`000?o00007P000h40000800Y200E?@Tm20004CP03IP0000X000>10000
5P000ol0000;00=?0`000h40000H0003o`0000d0000H0003o`0000/00X490003P@0001P01OlF0003
P@0000`000?o00007P000h4000080006@Tm2Cd9?1@08CP03IP0000X000>100005`02o``00Tl30003
P@0001P000?o00003@0001P000?o00003@02P@L000>100004P06o`03084001P000>1000030000ol0
000N0003P@0000/00d801FH0049V00E>40000h40000I0003o`0000T000<oC`000P000h40000H0003
o`0000d0000H0003o`0000l00X450003P@0000d01Ol70003P@0001L000>1000030000ol0000N0003
P@0000`000Q2IT9>@Ti2CQ@000>100006P02o`L000A??dm?0`000h40000H0003o`0000d0000H0003
o`0001400X430003P@0000L01_l<0003P@0001L000>1000030000ol0000N0003P@0000h000EV@VI2
IP0E0003P@0001`000_o04loCcm??dloC`030003P@0001T000?o0000300001P000?o00004`02P@03
084000<01OlB0003P@0001L000>1000030000ol0000N0003P@00014000=>@P0050000h40000J0003
84lo00;o00E??dloC`060003P@0001T000?o0000300001L00olF00Ko5`000h40000G0003P@0000`0
00?o00007P000h40000X0003P@0001D000/oCcm??dloCcm?o`0:0003P@0001T000?o0000300001P0
00?o00003`06o`040861PAT000>100005`000h40000<0003o`0001h000>10000:0000h40000A000:
Ccm?84lPCb1?80D00_l80003P@0001T000?o0000300001L000?o00002`05o`H000B100000X4G0003
P@0001L000>1000030000ol0000N0003P@0002P000>1000030001Sm??dloC`8o00=??`002`02o`H0
00>100006@000ol0000<00005`000ol0000500Ko2`000h40000300:15@000h40000G0003P@0000`0
00?o00007P000h40000X0003P@0000P000XoCcm??dloCcm?4P000ol000030003P@0001T000?o0000
300001L000?o00001OlA0003P@0000D00X4C0003P@0001L000>100002`000ol0000O0003P@0002P0
00>100000`002TloCcm??dloCclH00;o10000h40000H0003o`0000`0000G00?o5P000h40000700:1
4@000h40000G0003P@0000/000?o00007`000h40000X0003P@1?009?00LoCcm??dlo018000@Q824P
20001Ol0002101X000?o0000300001T00_lE0003P@0000T000>100003P000h40000G0003P@0000/0
00?o00007`000h40000U00Lo00=??dl03P0580058B0Q82400R000b40000700;o00<0P@006@000ol0
000<00006`02oa<000>100002P02P@h000>100005`000h40000;0003o`0001l000>100008`08C`P0
00DQ824P00078@0<824P8B0Q82408B0Q2P000on1000J0003o`0000/0000M00;o4@000h40000<00:1
30000h40000G0003P@0000/000?o00007`000h40000O00Lo0P000h408@0;8@PP00@0824P1P001B0Q
824P00T00_lJ0003o`0000/0000O00;o3`000h40000>00:12P000h40000G0003P@0000/000?o0000
7`000h40000J0007Cb1??dloC`0<80078B0Q824P8@0200<Q4@048@P000>10?l06@000ol0000;0000
8@02o`d000>100004002P@L000>100005`000h40000<0003o`0001l000>1000060000b4P8@028006
8B0Q824P2240100Q8B4M0004824P8@H000>100000_lG0003o`0000/0000S00;o2`000h40000B00:1
1@000h40000G0003P@0000`000?o00007`000h40000?000;8B0Q824P8B0Q82402200100P82030003
P@00024012450003P@00008000?o00004P02P@03oh4000/0000U00;o2@000h40000D00:10`000h40
000G0003P@0000`000?o00007`000h40000800XP00/Q824P8B0Q?b0Q800<0003P@0002<00b440003
P@0000<00_l<00J10P000ol0000;00009`02o`H000>100005`02P@03084001P000>1000030000ol0
000O0003P@0000P000`P8B0Q824P8@0Q8247?`03800000/000>1000090038@<000>100001@000ol0
000300J120000ol0000;0000:@02o`@000>100006@02PAT000>1000030000ol0000O0003P@0000P0
0b000clP?`02800903m??dloCcm?010000>100009@000blQ00020003P@0000D000>1ool00h4>0003
o`0000/0000[00;o0P000h40000J00>15`000h40000<0003o`0001l000>100003@0380@o5@000h40
000U008_0`000h40P@05P@<000?o00003P000ol0000;0000;@02o`03P@0001X000>100000X4E0003
P@0000`000?o00007`000h40000?00@P5P000h40000Q00048R4R8@8_1H4:00;o3`000ol0000:0000
;`02oa/000>100000P02PA<000>1000030000ol0000O0003P@00010000<o83l05P000h40000L000;
;b4_8BlQ;b4_8Bl010000h40000:0003o`0000`000?o00002P0003400_lI0003P@0000@000>10000
40000h40000<0003o`0001l000>100004@0281H000>1000060058@058R4R8B802@000h40000;00;o
30000ol0000:0000<`02oaL000>100001@02PA0000>1000030000ol0000O0003P@0002T000>10000
4`002b4R8B8Q8R4R8B8Q00d000>100003@000ol000090003o`0000X0000e00;o5@000h40000700:1
3P000h40000<0003o`0001l000>10000:@000h40000=00B100<_8B401B4B0003P@0000h00_l90003
o`0000X0000g00;o4`000h40000900:130000h40000<0003o`0001l000>10000:@000h40000700F1
00TR;b8_8RlR;b805P000h40000@0003o`0000H000?o00002P0003T00_lA0003P@0000/00X4:0003
P@0000`000?o00007`000h40000Y0004P@0000J100/08RlQ;b4_8BlQ;`0I0003P@0001400_l60003
o`0000X0000k00;o3`000h40000=00:120000h40000<0003o`0001l000>100009`06P@8000XQ8R4R
8B8Q8RlR7P000h40000C0003o`0000<000?o00002P0003d00_l=0003P@0000l00X460003P@0000`0
00?o00007`000h40000Q00J10P000h408P02;`078RlR;b8_8P0R0003P@0001@00_l30003o`0000X0
000o00;o2P000h40000B00:110000h40000<0003o`0001l000>100006`06P@D000XR8B8Q8R4R8B8Q
9`000h40000F0005o`000?l02`0004400_l80003P@0001@00X420003P@0000`000?o00007`000h40
000E00J11`028P08;b8_8RlR;b8[0003P@0001L00_l00`3o000:0000@`02o`H000>100005P03P@h0
00?o00007`000h40000?00J120002R4R8B8Q8R4R8B820003P@0002/000>100006@02o`/0001500;o
10000h40000H00:13@000ol0000O0003P@0000T01X4;00TR1P000h40000/0003P@0001H01?l;0000
A`001Ol0002101X000B108612`000ol0000O0003P@0000<01X4A00<R00<Q00002@000h40000/0003
P@0000l01ol?0000B002o`03084001T000F10000P@0:0003o`0001h01h4H008O30000h40000/0003
P@0000T01_lF0000BP02oaX000>100000P02P@P000?o00006006P@03084001X000@R7b8R3@000h40
000[0003P@0000<01_lL0000B`000h7oo`0H0003P@0000@00X460003o`0001801X470003P@0001@0
2B8=0003P@0002X01olR0000CP02oaH000>100001P02P@@000?o00003006P@d000>100003@000b8O
8P0200087b8O8QlR7b8@0003P@0002@01_l00`21000V0000D002oa<000>100002@02P@8000?o0000
1P06PA<000>100003@077`038P0001<000>100007@07obl0001B00;o4@000h40000;00:100?o0000
1X4I0003P@0000l000DR7b8O8P0F0003P@0001L01_lf0000E002o`l000>100003@000on1P@0O0003
P@0001800QlF0003P@0001001oll0000EP02o`d000>1000030000ol0000P0003P@0002X000>10000
2P06od<0001H00;o2`000h40000<0003o`00020000>10000:P000h40000400KoB@0005X00_l90003
P@0000`000?o000080000h40000Z00OoC`0005`00_l70003P@0000`000?o000080000h40000T00Ko
00>10000D`0005h00_l50003P@0000`000?o000080000h40000M00OoG00006000_l30003P@0000`0
00?o000080000h40000G00KoH`0006800_l00`21000=0003o`00020000>100004@06ofT0001T00;o
3P000ol0000P0003P@0000X01om_0000I@000h7oo`0<0003o`00020000>100001006ogH0001X00;o
2P000ol0000P00OoO00006X00_l80003o`0001X01_l00h4000200000K002o`H000?o00004`07ohT0
001^00;o10000ol0000=00KoT00007000_l20003o`0000L01_nF0000LP03o`801onL0000M003oj<0
003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0
001d0003o`0002L000?o0000N@0005D01?l300Co00@0ool00_l200;o0`03o`@000?o00002005o`04
0?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l300?o0`03o`@00_m:0000
E0001Ol0003o008000?o00000`001?l00?l300;o1P000ol000020003o`0000T000Go0000o`020004
o`00o`<000?o00000_l40003o`0000@000?o00001`000ol000050003o`00008000Co003o0P02o`@0
00?o00001@001?l00002odX0001D0003o`3o00;o0P05o`050?l00?l02@03oa0000Go0000o`020004
o`00o`<000?o00001P000ol0000>0003o`0000D000?o00000P000ol000090003o`0000D000?o0000
C@0005@000?o000010001ol0003o0?l00P000ol000060004o`00oa0000Go0000o`020004o`00o`<0
00?o00001P000ol0000>00?o1@000ol000020003o`0000T000?o00000`02oe00001D0005o`000?l0
0`03o`030?oo00?o20001?l00?l@0003o`0000Go0`04o`P000?o00003P000ol0000400;o0`04o`T0
00?o00001@000ol0001=0000E@04oaD00_l?00Go2`000ol0000500;o3`05o`T000?o00002002o`@0
0om@0000SP02ob4000?o00000P000ol0001Q0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.126485, -0.0203747, \
0.00248445, 0.0038978}},
  CellTags->"AntTracker3D - Gen 9"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 16",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \(ifSensor[dust]\)[seq[stop], \ 
          advance], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ 
        advance, \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[seq[turnLeft, \ again], \ 
          advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.9, Ind.1, Fit.13.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.9, Ind.1, Fit.13.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.44603 .5261 m .41861 .53422 L .40239 .51917 L p
.8 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.47374 .5179 m .44603 .5261 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.40239 .51917 m .42999 .5109 L .44603 .5261 L p
.8 g
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.42999 .5109 m .45788 .50253 L .47374 .5179 L p
.8 g
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .037 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .056 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .074 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .093 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .111 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .65 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .669 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .687 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .706 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 0 .724 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.737 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.718 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.7 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.681 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.663 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.124 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.105 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.087 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.068 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.05 0 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 .489 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 .508 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 .526 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 .545 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 .563 1 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .898 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .879 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .861 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .842 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .824 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .285 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .266 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .248 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .229 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
0 1 .211 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.328 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.347 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.365 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.384 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.402 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.941 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.96 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.978 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.997 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .985 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .446 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .427 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .409 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .39 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .372 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .037 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .056 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .074 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .093 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .111 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .65 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .669 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .687 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .706 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 0 .724 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.737 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.718 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.7 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.681 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.663 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.124 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.105 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.087 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.068 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.05 0 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 .489 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 .508 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 .526 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 .545 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 .563 1 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .898 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .879 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .861 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .842 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .824 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .285 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .266 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .248 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .229 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
0 1 .211 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.328 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.347 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.365 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.384 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.402 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.941 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.96 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.978 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.997 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .985 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .446 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .427 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .409 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .39 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .372 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.53003 .50124 m .50173 .50961 L .48607 .49408 L p
.8 g
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .13 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .149 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .167 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .186 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .204 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .223 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .743 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .762 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .78 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .799 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .817 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 0 .836 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.644 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.625 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.607 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.588 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.57 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.551 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.031 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.012 0 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .006 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .025 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .043 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .062 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .582 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .601 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .619 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .638 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .656 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 .675 1 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .805 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .786 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .768 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .749 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .731 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .712 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .192 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .173 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .155 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .136 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .118 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
0 1 .099 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.421 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.44 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.458 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.477 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.495 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.514 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .966 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .947 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .929 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .91 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .892 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .873 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .353 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .334 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .316 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .297 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .279 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .26 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .13 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .149 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .167 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .186 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .204 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .223 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .743 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .762 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .78 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .799 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .817 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 0 .836 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.644 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.625 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.607 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.588 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.57 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.551 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.031 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.012 0 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .006 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .025 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .043 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .062 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .582 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .601 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .619 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .638 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .656 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 .675 1 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .805 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .786 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .768 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .749 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .731 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .712 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .192 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .173 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .155 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .136 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .118 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
0 1 .099 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.421 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.44 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.458 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.477 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.495 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.514 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .966 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .947 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .929 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .91 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .892 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .873 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .353 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .334 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .316 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .297 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .279 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .26 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 0 .019 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 0 .632 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.755 0 1 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.142 0 1 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
0 .471 1 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
0 1 .916 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
0 1 .303 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.31 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.923 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .464 0 r
F P
s
P
p
.002 w
.55862 .49278 m .53003 .50124 L .51456 .48554 L p
.8 g
F P
s
P
p
.002 w
.48607 .49408 m .51456 .48554 L .53003 .50124 L p
.8 g
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 .241 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 .854 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
.533 0 1 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 .08 1 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 .693 1 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .693 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .08 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
.533 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .854 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .241 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 0 .019 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 0 .632 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.755 0 1 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.142 0 1 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
0 .471 1 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
0 1 .916 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
0 1 .303 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.31 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.923 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .464 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 .241 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 .854 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
.533 0 1 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 .08 1 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 .693 1 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .693 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .08 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
.533 1 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .854 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .241 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.51456 .48554 m .54335 .47691 L .55862 .49278 L p
.8 g
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 0 .26 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 0 .873 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.514 0 1 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 .099 1 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 .712 1 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .675 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .062 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.551 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .836 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .223 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .019 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 0 .26 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 0 .873 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.514 0 1 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 .099 1 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 .712 1 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .675 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .062 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.551 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .836 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .223 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .019 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .594 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .613 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.793 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.774 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.18 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.161 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .433 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .452 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .954 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .935 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .341 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .322 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.272 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.291 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.885 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.904 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .502 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .483 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 0 .279 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 0 .892 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.495 0 1 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
0 .118 1 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
0 .731 1 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
0 1 .656 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
0 1 .043 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.57 1 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .817 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .204 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .037 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .594 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .613 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.793 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.774 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.18 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.161 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .433 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .452 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .954 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .935 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .341 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .322 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.272 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.291 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.885 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.904 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .502 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .483 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 0 .279 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 0 .892 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.495 0 1 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
0 .118 1 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
0 .731 1 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
0 1 .656 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
0 1 .043 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.57 1 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .817 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .204 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .037 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 0 .576 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.811 0 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.198 0 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 .415 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .972 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .359 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.254 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.867 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .52 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .297 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 0 .91 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.477 0 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .136 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 .749 1 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .638 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
0 1 .025 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.588 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .799 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .186 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .056 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 0 .576 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.811 0 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.198 0 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 .415 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .972 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .359 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.254 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.867 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .52 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .297 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 0 .91 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.477 0 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .136 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 .749 1 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .638 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
0 1 .025 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.588 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .799 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .186 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .056 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .557 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.83 0 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.217 0 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 .396 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 1 .991 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 1 .378 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.235 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.848 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .539 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 0 .316 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 0 .929 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.458 0 1 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
0 .155 1 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
0 .768 1 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
0 1 .619 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
0 1 .006 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.607 1 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .78 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .167 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .074 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .557 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.83 0 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.217 0 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 .396 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 1 .991 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 1 .378 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.235 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.848 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .539 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 0 .316 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 0 .929 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.458 0 1 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
0 .155 1 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
0 .768 1 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
0 1 .619 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
0 1 .006 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.607 1 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .78 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .167 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .074 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 0 .539 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.848 0 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.235 0 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 .378 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 .991 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .396 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.217 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.83 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .557 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .334 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .353 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .372 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .39 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .409 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .947 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .966 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 0 .985 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.997 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.978 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.44 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.421 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.402 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.384 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.365 0 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .173 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .192 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .211 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .229 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .248 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .786 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .805 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .824 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .842 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 .861 1 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 1 .601 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 1 .582 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 1 .563 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 1 .545 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
0 1 .526 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.012 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.031 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.05 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.068 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.087 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.625 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.644 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.663 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.681 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.7 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .762 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .743 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .724 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .706 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .687 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .149 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .13 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .111 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .093 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 0 .539 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.848 0 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.235 0 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 .378 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 .991 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .396 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.217 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.83 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .557 0 r
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .334 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .353 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .372 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .39 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .409 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .947 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .966 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 0 .985 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.997 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.978 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.44 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.421 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.402 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.384 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.365 0 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .173 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .192 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .211 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .229 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .248 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .786 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .805 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .824 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .842 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 .861 1 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 1 .601 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 1 .582 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 1 .563 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 1 .545 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
0 1 .526 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.012 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.031 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.05 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.068 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.087 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.625 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.644 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.663 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.681 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.7 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .762 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .743 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .724 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .706 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .687 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .149 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .13 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .111 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .093 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 0 .52 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.867 0 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.254 0 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 .359 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 .972 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 1 .415 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.198 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.811 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .576 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 0 .52 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.867 0 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.254 0 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 .359 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 .972 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 1 .415 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.198 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.811 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .576 0 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 0 .502 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.885 0 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.272 0 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .341 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .954 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 1 .433 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.18 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.793 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .594 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 0 .427 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.96 0 1 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.347 0 1 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
0 .266 1 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
0 .879 1 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
0 1 .508 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.105 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.718 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .669 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 0 .502 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.885 0 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.272 0 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .341 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .954 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 1 .433 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.18 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.793 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .594 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 0 .427 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.96 0 1 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.347 0 1 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
0 .266 1 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
0 .879 1 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
0 1 .508 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.105 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.718 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .669 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
1 0 .483 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
.904 0 1 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
.291 0 1 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
0 .322 1 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
0 .935 1 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
0 1 .452 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
.161 1 0 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
.774 1 0 r
F P
s
P
p
.002 w
.75642 .42898 m .74098 .43356 L .73403 .42507 L p
1 .613 0 r
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
1 0 .483 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
.904 0 1 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
.291 0 1 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
0 .322 1 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
0 .935 1 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
0 1 .452 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
.161 1 0 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
.774 1 0 r
F P
s
P
p
.002 w
.73403 .42507 m .74954 .42044 L .75642 .42898 L p
1 .613 0 r
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 0 .446 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 0 .464 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.941 0 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.923 0 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.328 0 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.31 0 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 .285 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 .303 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 .898 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 .916 1 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 1 .489 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
0 1 .471 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.124 1 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.142 1 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.737 1 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.755 1 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .65 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .632 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 0 .446 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 0 .464 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.941 0 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.923 0 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.328 0 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.31 0 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 .285 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 .303 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 .898 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 .916 1 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 1 .489 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
0 1 .471 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.124 1 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.142 1 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.737 1 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.755 1 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .65 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .632 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o;k/3o`b100?o^k/01;/01?l00?l50003o`0002X0
000O0003o`0000T000Sobk_;^l^ko`b102Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^kbk_o00b100?oPH400ol05[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/3o`UK00gobk_;^l^kbk_;^l^k00;o2h400on1P@0:P@0_ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10ol^^`?o1e/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0]^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2e/00on1P@06P@?o00V1ok_;^l^kbol0
0P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omKF`04F`?o
0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42obbk1?l2F`03oe]K00YK
00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^kbk_;^l^k
bk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?^l^kbk_;
^l^kbk_;^l_o00J11?l2P@0[ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`MK00?oFe/02U/00on1o`02o`V100So^l^kbk_;o`8000?o00000P000ol0000500?o0`03oaT0
000U0003o`0000T000?o^k/00k/00on1P@03o`R100?o^k/09;/2o`]K00?o^k/07k/3o`:100?o^k/0
2k/00omKF`03F`;o4[/00on1P@03o`N100?o^k/08k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk
00Co003o1@000ol000050003o`0000D000?o00005P0002H000?o00002@001_nkbk_;^`;o3840:?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol6P@0@ol^kbk_;^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0_l;P@0Rok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0U/00omKF`0:F`03oe]K00AK
1?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol000050003o`0000D000?o00005P0002L0
00?o00002@000onk^`04^`03oh6100Z100?o^k/09;/00omKF`0:F`03ok^k01Jk1?l:P@03ok^k00^k
00?o^k/05k/00on1P@0:P@03ok^k01^k0ol6F`03oe]K00YK00?oFe/00ol7F`03oh6100^100?o^k/0
1;/01?l00?l40003o`0000@000?o00000P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`:100?oPH402X40:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b1
01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o2U/00omKF`08F`04oe_oo`]K00?oPH401X43o`09
POnkbk_;^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1
P@0:P@03ok^k02Bk00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k01>k
0ol00e_oF`0;F`03oe]K00AK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003
o`3o00@00_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2X400on1
P@08P@0[oh7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol5F`03oe]K00YK00?oFe/00ol01k_;^l^kbol03E/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000S0000;0000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k02Bk0_lI^`03oh6100V100?oPH401843o`>100?o^k/09K/00on1P@03o`J100?o^k/03;/3o`UK
00?oFe/025/01?mKool:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D000?o00008P0002d0
00?o00002@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N102Kobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X402oo;^l^kbk_;^l^k00?o35/00omKF`04F`Co013;^l^k
bk_;^l^kbk_;^l_o1U/4o`9K00?oPH402X402?o;^l^kbk_o0P000ol000030003o`000240000^0003
o`0000T000?o^k/01;/00on1P@09P@03ok^k03nk00?oPH402H42o`^100?o^k/07[/4o`9K00?oPH40
2X400onk^`04^`?o0U/00omKF`0;F`03oe]K00?o5;/00omKF`03o`MK00?oPH402X400onk^`04^`04
o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH40
2X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@03ol^k00?o1U/00omK
F`0;F`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l;F`03oh6100F10ol02X7o^l^kbk_;^ol20003
o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42od2k00?oPH400ol6P@03oh6100Z1
00?o^k/05k/2o`]K00?oPH4028401?n1ool:F`03oe]K00IK0olE^`Co0U/00omKF`0:F`03oh6100>1
0_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@11ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol035/00on1P@04P@?o0X400omK
F`0:F`03oe]K00=K0_l05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`MK00?oFe/02U/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X400omKF`0:F`03oe_o00;o
4k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol000090006
ok_;^l^k0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038400on1P@03o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`aK0_l:P@03oe]K00QK01KoFoo;^l^kbk_;^l^kbk_;^l^kbk_;0ol2F`03oe]K00YK00?oFe/0
15/4o`03bk_o00f100Oo^l^kbk_o008000?o00000`000ol0000M0000=@000ol000090003ok^k00>k
00?oPH402X400onk^`0m^`03oh6100R100CoPOoo9K/00omKF`04F`?o0[/00on1P@0:P@03oe]K00AK
0ol3F`03ok^k00fk0ol6F`03oe]K00YK00?oFe/00ol7^`03oh6100^100?o^k/00k/01?l00?l40003
o`0001d0000f0003o`0000T000Oo^l^kbk_o00b1037obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co00c;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100?oFe/00ol7F`0=ol^kbk_;
^l^kbk_;^`02o`YK00?oFe/025/04?mKoonkbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l0
0002oah0000g0003o`0000T000?o^k/00k/00on1P@0:P@;o:k/3o`AK00?o^k/02K/00on1P@03o`N1
00?o^k/09;/2o`Zk00?oPH4028401?n1ool;F`03ok^k00Vk00?oFe/02U/00omKF`04F`?o4;/00on1
P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0d
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01;_;
^ol<F`0=ol^kbk_;^l^kbk_;o`0<F`03oe]K00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;
^l^kbol00P000ol000020003o`0001/0000j0003o`0000T000?o^k/00[/00on1P@03o`R100?o^k/0
8[/2o`aK00?o^k/02K/00on1P@0:P@03ok^k032k00?oPH400ol7^`03oe]K00YK00?o^k/02K/00omK
F`08F`04oe_ooaNk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o00002@001Oo;
^l^k00;o38409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0<F`0=ol^kbk_;
^l^kbk_;o`0<P@0cok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;o00bkbk_;^l^kbk_;^ol6F`?o0U/03_nkbk_;^l^kbk_;^l_o1U/3o`0M^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038402_nkbk_;^l_o0?l50003o`0001T0000l0003o`0000T000?o^k/0
0k/00on1P@0:P@03ok^k02>k00?oFe/02U/00onk^`09^`03oh6100Z100?o^k/0?K/00omKF`03o`IK
00?o^k/02[/00omKF`03o`:k0_lL^`03oh6100R100?oPOl01K/01?l00?l40003o`0001T0000m0003
o`0000T000Kobk_;^l/2o`^102Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1U/3o`9K00ko^l^kbk_;^l^kbk_;o`J10ol3P@10ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2U/03Onkbk_;^l^kbk_;^l/00_l00k_;
o`02o`0OWa7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l0
0002oaX0000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0S^`03oe]K00?o1U/00onk
^`0:^`03oh6100?o1h400onk^`0l^`03oe]K00UK00?o^k/03K/00olA4@044@03ok^k01Vk00?oPH40
0ol7P@03ok^k00Bk00Co003o10000ol0000G0000?`000ol000090008ol^kbk_;^ol2P@?o1X409_nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l:F`0=ok_;^l^kbk_;^l^kb`02o`^1
043o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o2e/02Oo;^l^kbk_;^`02o`0Xbk_;^l^koa6O4IlAok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;o2h401oo;^l^kbol00P000ol000030003o`0001H0001000;o2P000onk^`04^`;o2X400onk
^`0S^`03oe]K00UK00?o^k/02[/00on1P@0:P@03ok^k03bk00?oFe/01e/00omKo`04^`?o00<Aok/0
1[/3oajk00?oPH402X400onk^`04^`04o`00o`@000?o00005P00048000?o00002002o`06^l^kbk_o
2h409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0;F`0>ok_;^l^kbk_;^l^k
bol<P@0ook_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00IK0ol01l^kbk_;^ol01A40:_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`b100So^l^kbk_;o`8000?o00000P000ol0000E0000@`000ol000090003ok^k00>k
00?oPH402H400onk^`0S^`03oe]K00UK00?o^k/02[/00on1P@04P@?o0X400onk^`0l^`03oe]K00?o
0k/2o`Fk00Oo4IlAWa7o00Zk0olK^`03oh6100R100?oPOl01K/01?l00?l50003o`0001@000140003
o`0000T000Oo^l^kbk_o00^10_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1U/3o`0@bk_;^l^kbk_;^l^kbk_;o`:10ol6P@0ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o00?;^l/00ol0217obk_;^l^k0ol02[_;
^l^kbk_;^l/3o`:O01go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o
0P001?l00002oaH000150003o`0000T000?o^k/00k/00on1P@04P@?o0h400onk^`0R^`03oe]K00?o
4k/2o`Z100?o^k/0?k/00olA4@034@03ok^k012k00?oWil00il00onk^`0I^`03oh6100?o1h400onk
^`04^`04o`00o`@000?o00004`0004H000?o00002@001onkbk_;^ol00X43o`N102Cobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2h40>oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o
00K;^l^kbol54@0Dol^kbk_;^l^kbk_;^l^kbk_;^ol3W`0Loioo^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`Co2h402_o;^l^kbk_o0?l300?o500004L000?o00002@000onk^`03^`;o2h400onk^`0M^`?o
0e/00onk^`0E^`03oh6100V100?o^k/0=;/3o`034Onk00Fk0olF^`?o6K/3o`:100?oPH402h400onk
^`03^`03o`0000?o0P000ol0000B0000B002o`X000So^l^kbk_;o`^101cobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0ol7F`0Iol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0;P@;o05jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o5a4G4AOo^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l04K_;^l^kbk_;^l^kbk_;^l^k00?o1X400on1P@0;P@06
ol^kbk_;0_l00`3o00020003o`000180001:0003o`0000P00_l5^`03oh6100V100?o^k/05;/4o`]K
00?o^k/05K/00on1P@04P@?o0h400onk^`0Z^`;o1K/00olA4@034@03ok^k01jk0ol00aoo^`0<^`Co
2X400on1P@04P@Co2K/00ol0o`030003o`000180001;0003o`0000T000Oobk_;^l_o00J10ol2P@0C
ol^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/06Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
0X43o`N102Wo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`084AOo^l^k
bk/3o`0b^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbolO5alG7oo;^l^kbk_;^l/3o`:1
00?oPH402X400on1P@03o`08^l^kbk_;^l/3o`D000Co003o500004`000?o00002@000onk^`03^`03
oh6100?o1X400onk^`0<^`?o1e/00omKF`0:F`03ok^k01Fk0_l;P@03ok^k02Bk00So4ALA5a4Gob>k
0_l5^`07oamO7elOo`05^`?o1X400on1P@0:P@;o1k/4o`T000Co003o4`0004d000?o00002@001_o;
^l^kb`;o2X403?o;^l^kbk_;^l^kb`;o2e/00omKF`04F`?o01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o38408?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l0;<^kbk_;^olG4ALA5onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol025oo^l^kbk_;0ol01<^kbk/4o`Z100?oPH40
1843o`08bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk^`03^`03oh6100V100?o^k/0
2[/00omKF`09F`03oe]K00?o7k/00on1P@0:P@03ok^k01Zk0_l00a4Go`06^`?o8K/01omO7elOGol0
1k/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;^l^kbol02h403_o;
^l^kbk_;^l^kbk_o2e/2o`0Tbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1X43o`:1
01gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`054@0Tol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0_l03K_;^l^koelOGamOok/01Ol8P@03oh6100Z10_l01l^kbk_;^l/00olF00;o
4`00054000?o000020000onk^`03^`03oh6100V10_l;^`03oe]K00AK0olW^`03oh6100?o1X400onk
^`0A^`?o1K/01olG4ALA5ol07k/3o`037onk00Fk0ol01;_oool2P@03oh6100V100?oPH401843o`Nk
1?lH00?o4`00058000?o00002002o`05^l^kbol01X43o`>100go^l^kbk_;^l^kbk_o009K0ol0:l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l:P@0@ol^kbk_;^l^kbk_;
^l^kb`?o0Q401onkbk_;^l/00ol08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol57`07
ol^kbk_;^`03o`J100?oPH402H400on1P@03o`07^l^kbk_;^`03oaT00olF0000D`000ol000090003
ok^k00:k00?oPH400ol7P@03ok^k00Vk0_l^^`03oh6100Z100?o^k/03;/00olG5`035`03ok^k022k
0ol5^`08oamO7elOok/4o`Z100?oPH401h401?n1ool6^`Co6004oaT0001D0003o`0000T000Go^l^k
b`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00b100Oobk_;^l^k00Co00G;^l^ko`034@0Qoa7o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00?o00TOGaoobk_;^l/00ol01<_oool2P@03oh6100V100?oPH401843o`07bk_;^l^k
b`03oaT00olM0000E@000ol000090003ok^k00>k00?oPH402H400onk^`0i^`03oh6100R100?oPOl0
0[/3o`@A00?o^k/00[/3ob:k00?o7al00al00onk^`03^`?o1X400on1P@09P@03oh6100?o1[/4oaP0
1?lP0000EP000ol000090007ok_;^l^ko`0;P@;o03_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@?o0e/01?o;^ol65`0Rol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo7`05o`Z100?oPH401h402_n1ooo;^l^k
bk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03oh6100?o1e/01Onk
^olA00?o8;/3o`<O00?o^k/00k/6o`:100?oPH402H400on1P@04P@?o1[/4oaP00olX0000F@000ol0
00080007ok_;^l^ko`02P@?o1h40>Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04o`]K02Sobk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_o1Ql01Oo;^l^k00?o1X400on1P@09P@03oh6100?o00Jkbk_;^l/3oaP01?l[0000FP000ol0
00080003ok^k00>k0_l;P@03ok^k032k1Ol3F`03oe]K00YK00?o^k/01;/3oaFk0ol5^`03oaoo00;o
0k/3o`Z100?oPH401h401?n1ool5^`Co6003obl0001K0003o`0000P00_l01/^kbk_;o`^1033obk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`UK00?oFe/02U/00oo;
^`03o`0E4AOobk_;^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1
PH45o`06bk_;^l^k0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/04[/4oaNk
00?oFe/025/00omKF`04F`?o0h402Onk^olG4ALAo`0;^`;o1;/00olS8`048`03ok^k00>k0ol6P@03
oh6100V10ol7^`Co6003ocH0001M0003o`0000T000Oobk_;^l_o00J10ol2P@0?ol^kbk_;^l^kbk_;
^l^k00Go15/06Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02U/00omKF`03o`N1017obk_o4AOo5oo;
^l^kbk_;^`02o`09GaOo^l^kbolS00?o00?;^l/01?l:P@03oh6100B10ol02;_;^l^kbk_;0olH00Co
>@0005h000?o00002@000onk^`03^`03oh6100?o1X400onk^`09^`;o2U/00onk^`08^`;o2k/00omK
F`06F`04oe_oo`^100?o^k/00_l:^`07oelOGamOo`04^`04ok^k^`?o0X400on1P@0:P@03oh6100?o
1k/4oaP00olm0000G`02o`X000Kobk_;^l/2o`Z100gobk_;^l^kbk_;^l_o00]K00Oobk_;^l^k00?o
0U/03Oo;^l^kbk_;^l^kbol00U/5o`04^l^ko`b100Sobk_;^l^kb`;o012kbk_;^olGGaMO5onkbk_;
0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co@000064000?o000020000onk^`03^`03oh6100V1
00?o^k/02K/00omKF`09F`03ok^k00?o1U/00onk^`09^`;o2K/00on1P@0:P@04ok^k^`?o00<Gok/0
1K/3o`>k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P000Oobk_;^l_o00^10_l02k_;
^l^kbk_;^l_o00]K0_l:F`0Hol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`:1013o^l_oGaMO5eoo
bk_;^l^k1Ol3P@03oh6100V100?oPH400ol01l^kbk_;^l/00olH00CoA`0006<000?o00002002o`Bk
00?oPH401843o`>100?o^k/02;/00omKF`04F`?o0U/00omKF`09F`03ok^k01Bk00?oPH400ol6P@05
ok^k^ol011L00onko`03o`V100?oPH402H42o`Jk1?lG00CoB`0006@000?o00002@001_nkbk_;o`:1
0ol7P@0<ok_;^l^kbk_;^l_o0U/3o`IK00?oFe/02E/05oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o
2X401?nkbk/2o`04boooo`:100?oPH402H400on1P@04P@?o00K;^l^kbk/3oaP00om?0000I@000ol0
00090003ok^k00:k0_l;P@03ok^k00Rk0_l:F`03oe]K00AK0olI^`03oh6100V100?o^k/00ol6P@03
oh6100V100?oPH400ol5^`Co5`04oe80001V0003o`0000T000Oo^l^kbk_o00^100go^l^kbk_;^l^k
bk_o00YK00?oFe/00ol07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`^10_l:P@03oh6100N1
00SoPOoobk_;^`Co6003oeH0001W00;o2P000onk^`03^`03oh6100V100?o^k/02K/00omKF`08F`;o
8K/00on1P@04P@?o0X400on1P@09P@04oh61P@Go1K/3oaP01?mI0000J@000ol000080007ok_;^l^k
o`06P@?o0X403Onkbk_;^l^kbk_;^ol00U/5o`0Wbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00:10ol6P@03oh6100V10ol01[_;^l^kb`Co6003oed0001Z0003o`0000P000?o^k/0
0k/00on1P@03o`J100?o^k/02K/2obZk1?l:P@03oh6100B10ol7^`?o6004of00001[0003o`0000P0
0_l01<^kbk/2o`Z103;o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`Go18400on1P@08P@03oh6100?o00K;^l^kbk/4oaP00omT0000K0000ol000090003ok^k00:k
00?oPH402H400onk^`0[^`?o2X400on1P@08P@;o1[/3oaP01?mW0000K@000ol000090006ol^kbk_o
2h40:_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0X400on1P@09P@03
oh6100Go00Jkbk_;^l/4oaP00om[0000KP02o`X000?o^k/00[/00on1P@04P@?o0X400onk^`0S^`?o
1X400on1P@09P@;o2;/3oaP01?m^0000L0000ol000080006ol^kbk_o0X43o`J1027o^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l:P@03oh6100B10ol01k_;^l^kbk/01?lG00CoLP000740
00?o000020000onk^`02^`;o2X400onk^`0H^`Go0h400on1P@09P@03oh6100?o1k/3oaP00omf0000
LP000ol000080007ol^kbk_;o`0:P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol9P@03oh6100V1
0_l01[_;^l^kb`Co5`04ogT0001c0003o`0000P00_l4^`03oh6100R100?o^k/04;/3o`:100?oPH40
28400on1P@04P@?o1[/3oaP00omm0000M0000ol000090006ok_;^l_o0X45o`>100oo^l^kbk_;^l^k
bk_;^l/00ol6P@03oh6100R100?oPH400ol01K_;^l^k00Co5`04oh00001e0003o`0000T000?o^k/0
0[/2o`V100?o^k/02;/3o`Z100?oPH401X401?n1ool5^`?o6003oh@0001f00;o2P001onkbk_;^ol0
2H401onkbk_;^l/00ol2P@03oh6100V100?oPH401Ol01L^kbk_;00Co5`04ohL0001h0003o`0000P0
00?o^k/00k/00on1P@07P@03ok^k00?o1X400on1P@09P@;o1k/3oaP00on;0000N@000ol000080007
ok_;^l^ko`07P@04oh7oo`Z100?oPH401843o`06bk_;^l^k1?lG00CoSP0007X000?o000020000onk
^`03^`03oh6100Co18400on1P@08P@03oh6100?o1[/3oaP00onB0000N`000ol000080006ok_;^l^k
0_l9P@03oh6100R10_l01L^kbk_;00Co5`04oiD0001l0003o`0000P00_l4^`03oh6100R100?oPH40
1Ol6^`?o5`04oiT0001m0003o`0000T000Kobk_;^ol:P@;o00Nkbk_;^l^k00Co5`03oid0001n00;o
2P000onk^`02^`03oh6100>10ol7^`?o5`04oj0000200003o`0000P000Oobk_;^on100?o00Jkbk_;
^l/4oaL00onT0000P@000ol000080003ok^k00:k00?o^k/01;/3oaL01?nW0000PP000ol000080007
ol^kbk_;^`04oaL00on[0000P`000ol000080003ok^k00?o5`04ojh000240003o`0000L00olG00?o
/P0008D00_l70003o`0001<01?ne0000Q`000ol000040003o`0001000oni0000R0000ol000030003
o`0000`01?nl0000R@001Ol0003o00/01?o00000RP001?l00?l800?oa00008/000?o0?l01004olL0
002<00;o00@0oooob`0008d00_o>0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000
o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000S`000ol0000W0003o`000:40001`00Co0`04o`04
0?oo00;o0P02o`<00ol40003o`0000P01Ol0103oo`02o`801Ol00`3oo`0300?o10000ol0000700?o
1005o`800ol300;o0`03o`<00ol400;oLP0006l000Go0000o`020003o`0000<000Co003o0`02o`H0
00?o00000P000ol000090005o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L0
00?o00001@000ol000020004o`00o`800_l40003o`0000D000Co00000_mb0000K`000ol0o`02o`80
1Ol01@3o003o00T00ol@0005o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003
o`00008000?o00002@000ol000050003o`0007D0001_0003o`0000@000Oo0000o`3o008000?o0000
1P001?l00?l@0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0
00090003o`0000<00_mh0000K`001Ol0003o00<00ol00`3oo`03o`P000Co003o40000ol00005o`<0
1?l80003o`0000h000?o00001002o`<01?l90003o`0000D000?o0000M@0007001?lE00;o3`05o`/0
00?o00001@02o`l01Ol90003o`0000P00_l400?oN0000:T00_lQ0003o`00008000?o0000R@000?l0
GP000001\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 9"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 5",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 16",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 16", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.222278 1.469942 0.020814 0.955304 [
[(Gen.16, Ind.1, Fit.17.)] .5 1 0 -1.5 Msboxa
[(5)] .22085 .11841 .84775 1 Msboxa
[(10)] .37295 .07937 .79157 1 Msboxa
[(15)] .5303 .039 .73538 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30024 .03665 .79718 1 Msboxa
P
[(5)] .71983 .07962 -1 .38114 Msboxa
[(10)] .79646 .15066 -1 .36665 Msboxa
[(15)] .86859 .21753 -1 .35322 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87522 .12313 -1 .36805 Msboxa
P
[(0)] .09633 .17477 1 -0.39145 Msboxa
[(10)] .07491 .34833 1 -0.36217 Msboxa
[(20)] .05109 .5414 1 -0.32943 Msboxa
[(30)] .02444 .75747 1 -0.29258 Msboxa
[(t)] -0.02485 .47232 1 -0.34446 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.16, Ind.1, Fit.17.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11501 .15763 m
.63789 .02388 L
s
P
p
.002 w
.23273 .12752 m
.23867 .13207 L
s
P
[(5)] .22085 .11841 .84775 1 Mshowa
p
.002 w
.38436 .08873 m
.39006 .09342 L
s
P
[(10)] .37295 .07937 .79157 1 Mshowa
p
.002 w
.54119 .04862 m
.54663 .05343 L
s
P
[(15)] .5303 .039 .73538 1 Mshowa
p
.001 w
.26265 .11987 m
.26619 .12261 L
s
P
p
.001 w
.29278 .11216 m
.29628 .11492 L
s
P
p
.001 w
.3231 .1044 m
.32658 .10718 L
s
P
p
.001 w
.35363 .0966 m
.35708 .09939 L
s
P
p
.001 w
.4153 .08082 m
.41869 .08364 L
s
P
p
.001 w
.44645 .07285 m
.44981 .07569 L
s
P
p
.001 w
.47781 .06483 m
.48114 .06768 L
s
P
p
.001 w
.50939 .05675 m
.51269 .05962 L
s
P
p
.001 w
.20301 .13512 m
.2066 .13784 L
s
P
p
.001 w
.17348 .14268 m
.1771 .14538 L
s
P
p
.001 w
.14415 .15018 m
.14779 .15287 L
s
P
p
.001 w
.5732 .04043 m
.57643 .04333 L
s
P
p
.001 w
.60543 .03219 m
.60863 .0351 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30024 .03665 .79718 1 Mshowa
P
P
p
p
.002 w
.63789 .02388 m
.8925 .2597 L
s
P
p
.002 w
.70266 .08387 m
.69407 .086 L
s
P
[(5)] .71983 .07962 -1 .38114 Mshowa
p
.002 w
.77921 .15477 m
.77058 .15683 L
s
P
[(10)] .79646 .15066 -1 .36665 Mshowa
p
.002 w
.85126 .22151 m
.8426 .2235 L
s
P
[(15)] .86859 .21753 -1 .35322 Mshowa
p
.001 w
.71835 .0984 m
.71319 .09967 L
s
P
p
.001 w
.73384 .11275 m
.72868 .11401 L
s
P
p
.001 w
.74915 .12693 m
.74398 .12818 L
s
P
p
.001 w
.76427 .14094 m
.7591 .14218 L
s
P
p
.001 w
.79396 .16844 m
.78879 .16967 L
s
P
p
.001 w
.80855 .18195 m
.80336 .18316 L
s
P
p
.001 w
.82295 .19529 m
.81777 .1965 L
s
P
p
.001 w
.83719 .20848 m
.832 .20968 L
s
P
p
.001 w
.68677 .06916 m
.68162 .07044 L
s
P
p
.001 w
.67068 .05426 m
.66554 .05555 L
s
P
p
.001 w
.65439 .03917 m
.64926 .04047 L
s
P
p
.001 w
.86517 .23439 m
.85997 .23558 L
s
P
p
.001 w
.87891 .24712 m
.87371 .2483 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87522 .12313 -1 .36805 Mshowa
P
P
p
p
.002 w
.11501 .15763 m
.03675 .79766 L
s
P
p
.002 w
.11344 .17042 m
.122 .16824 L
s
P
[(0)] .09633 .17477 1 -0.39145 Mshowa
p
.002 w
.09219 .34426 m
.10082 .34223 L
s
P
[(10)] .07491 .34833 1 -0.36217 Mshowa
p
.002 w
.06854 .53767 m
.07726 .5358 L
s
P
[(20)] .05109 .5414 1 -0.32943 Mshowa
p
.002 w
.04207 .75412 m
.05089 .75244 L
s
P
[(30)] .02444 .75747 1 -0.29258 Mshowa
p
.001 w
.10936 .20377 m
.11451 .20248 L
s
P
p
.001 w
.1052 .2378 m
.11036 .23653 L
s
P
p
.001 w
.10095 .27255 m
.10612 .27129 L
s
P
p
.001 w
.09662 .30803 m
.10179 .30679 L
s
P
p
.001 w
.08766 .38128 m
.09285 .38008 L
s
P
p
.001 w
.08304 .4191 m
.08824 .41792 L
s
P
p
.001 w
.07831 .45775 m
.08352 .45659 L
s
P
p
.001 w
.07348 .49727 m
.0787 .49612 L
s
P
p
.001 w
.06349 .57899 m
.06873 .57789 L
s
P
p
.001 w
.05832 .62126 m
.06357 .62018 L
s
P
p
.001 w
.05303 .66451 m
.0583 .66346 L
s
P
p
.001 w
.04762 .70879 m
.05289 .70776 L
s
P
[(t)] -0.02485 .47232 1 -0.34446 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11344 .17042 m
.40509 .38144 L
s
P
p
.4 g
.002 w
.09219 .34426 m
.39993 .54839 L
s
P
p
.4 g
.002 w
.06854 .53767 m
.39424 .73219 L
s
P
p
.4 g
.002 w
.04207 .75412 m
.38794 .93551 L
s
P
p
.4 g
.002 w
.18859 .21121 m
.12661 .84349 L
s
P
p
.4 g
.002 w
.27583 .27472 m
.23207 .89727 L
s
P
p
.4 g
.002 w
.35821 .33469 m
.33061 .94752 L
s
P
.002 w
.11501 .15763 m
.03675 .79766 L
s
.03675 .79766 m
.38669 .97612 L
s
.38669 .97612 m
.40547 .3691 L
s
.40547 .3691 m
.11501 .15763 L
s
.63789 .02388 m
.8925 .2597 L
s
.8925 .2597 m
.96325 .88461 L
s
.96325 .88461 m
.66428 .68137 L
s
.66428 .68137 m
.63789 .02388 L
s
.11501 .15763 m
.03675 .79766 L
s
.03675 .79766 m
.66428 .68137 L
s
.66428 .68137 m
.63789 .02388 L
s
.63789 .02388 m
.11501 .15763 L
s
p
.4 g
.51559 .34436 m
.51611 .95558 L
s
P
p
.4 g
.65702 .3126 m
.68313 .92907 L
s
P
p
.4 g
.80283 .27985 m
.85628 .90159 L
s
P
p
.4 g
.40509 .38144 m
.89393 .27229 L
s
P
p
.4 g
.39993 .54839 m
.91326 .44307 L
s
P
p
.4 g
.39424 .73219 m
.93466 .63208 L
s
P
p
.4 g
.38794 .93551 m
.95848 .84244 L
s
P
.40547 .3691 m
.8925 .2597 L
s
.8925 .2597 m
.96325 .88461 L
s
.96325 .88461 m
.38669 .97612 L
s
.38669 .97612 m
.40547 .3691 L
s
p
.4 g
.23273 .12752 m
.51559 .34436 L
s
P
p
.4 g
.38436 .08873 m
.65702 .3126 L
s
P
p
.4 g
.54119 .04862 m
.80283 .27985 L
s
P
p
.4 g
.18859 .21121 m
.70266 .08387 L
s
P
p
.4 g
.27583 .27472 m
.77921 .15477 L
s
P
p
.4 g
.35821 .33469 m
.85126 .22151 L
s
P
P
p
.002 w
.41099 .37273 m .41876 .37839 L .40509 .38144 L p
.4 g
F P
s
P
p
.002 w
.40509 .38144 m .3973 .3758 L .41099 .37273 L p
.4 g
F P
s
P
p
.002 w
.89393 .27229 m .40509 .38144 L .11344 .17042 L p
.9 g
F P
s
P
p
.002 w
.43247 .37533 m .41876 .37839 L p
.41099 .37273 L .4 g
F P
s
P
p
.002 w
.41099 .37273 m .3973 .3758 L .38945 .37012 L p
.4 g
F P
s
P
p
.002 w
.43851 .36656 m .44622 .37225 L .43247 .37533 L p
.4 g
F P
s
P
p
.002 w
.41099 .37273 m .43851 .36656 L p
.43247 .37533 L .4 g
F P
s
P
p
.002 w
.38945 .37012 m .38157 .36442 L p
.41099 .37273 L .4 g
F P
s
P
p
.002 w
.38157 .36442 m .39532 .36132 L .41099 .37273 L p
.4 g
F P
s
P
p
.002 w
.46002 .36918 m .44622 .37225 L p
.43851 .36656 L .4 g
F P
s
P
p
.002 w
.46619 .36036 m .47385 .36609 L .46002 .36918 L p
.4 g
F P
s
P
p
.002 w
.43851 .36656 m .46619 .36036 L p
.46002 .36918 L .4 g
F P
s
P
p
.002 w
.48773 .36299 m .47385 .36609 L p
.46619 .36036 L .4 g
F P
s
P
p
.002 w
.39532 .36132 m .38157 .36442 L .37364 .35868 L p
.4 g
F P
s
P
p
.002 w
.49403 .35412 m .50165 .35988 L .48773 .36299 L p
.4 g
F P
s
P
p
.002 w
.46619 .36036 m .49403 .35412 L p
.48773 .36299 L .4 g
F P
s
P
p
.002 w
.37364 .35868 m .36567 .35291 L p
.39532 .36132 L .4 g
F P
s
P
p
.002 w
.36567 .35291 m .37947 .34978 L .39532 .36132 L p
.4 g
F P
s
P
p
.002 w
.5156 .35676 m .50165 .35988 L p
.49403 .35412 L .4 g
F P
s
P
p
.002 w
.52205 .34784 m .52961 .35364 L .5156 .35676 L p
.4 g
F P
s
P
p
.002 w
.49403 .35412 m .52205 .34784 L p
.5156 .35676 L .4 g
F P
s
P
p
.002 w
.54365 .3505 m .52961 .35364 L p
.52205 .34784 L .4 g
F P
s
P
p
.002 w
.37947 .34978 m .36567 .35291 L .35765 .34711 L p
.4 g
F P
s
P
p
.002 w
.55024 .34153 m .55774 .34736 L .54365 .3505 L p
.4 g
F P
s
P
p
.002 w
.52205 .34784 m .55024 .34153 L p
.54365 .3505 L .4 g
F P
s
P
p
.002 w
.35765 .34711 m .34959 .34128 L p
.37947 .34978 L .4 g
F P
s
P
p
.002 w
.34959 .34128 m .36345 .33811 L .37947 .34978 L p
.4 g
F P
s
P
p
.002 w
.57187 .3442 m .55774 .34736 L p
.55024 .34153 L .4 g
F P
s
P
p
.002 w
.5786 .33517 m .58604 .34104 L .57187 .3442 L p
.4 g
F P
s
P
p
.002 w
.55024 .34153 m .5786 .33517 L p
.57187 .3442 L .4 g
F P
s
P
p
.002 w
.4351 .33713 m .4072 .34347 L .39128 .33173 L p
.8 g
F P
s
P
p
.002 w
.5786 .33517 m .55024 .34153 L .53511 .32976 L p
.4 g
F P
s
P
p
.002 w
.36345 .33811 m .34959 .34128 L .34149 .33542 L p
.4 g
F P
s
P
p
.002 w
.60025 .33786 m .58604 .34104 L p
.5786 .33517 L .4 g
F P
s
P
p
.002 w
.34149 .33542 m .33333 .32952 L p
.36345 .33811 L .4 g
F P
s
P
p
.002 w
.33333 .32952 m .34724 .32631 L .36345 .33811 L p
.4 g
F P
s
P
p
.002 w
.60713 .32878 m .61451 .33468 L .60025 .33786 L p
.4 g
F P
s
P
p
.002 w
.5786 .33517 m .60713 .32878 L p
.60025 .33786 L .4 g
F P
s
P
p
.002 w
.46316 .33075 m .4351 .33713 L .41929 .32532 L p
.8 g
F P
s
P
p
.002 w
.39128 .33173 m .41929 .32532 L .4351 .33713 L p
.8 g
F P
s
P
p
.002 w
.53511 .32976 m .56358 .32334 L .5786 .33517 L p
.4 g
F P
s
P
p
.002 w
.62881 .33149 m .61451 .33468 L p
.60713 .32878 L .4 g
F P
s
P
p
.002 w
.41929 .32532 m .39128 .33173 L .37518 .31986 L p
.8 g
F P
s
P
p
.002 w
.63583 .32234 m .64316 .32828 L .62881 .33149 L p
.4 g
F P
s
P
p
.002 w
.60713 .32878 m .63583 .32234 L p
.62881 .33149 L .4 g
F P
s
P
p
.002 w
.41929 .32532 m .44746 .31886 L .46316 .33075 L p
.8 g
F P
s
P
p
.002 w
.56358 .32334 m .53511 .32976 L .51981 .31787 L p
.4 g
F P
s
P
p
.002 w
.34724 .32631 m .33333 .32952 L .32513 .32358 L p
.4 g
F P
s
P
p
.002 w
.65755 .32507 m .64316 .32828 L p
.63583 .32234 L .4 g
F P
s
P
p
.002 w
.32513 .32358 m .31689 .31762 L p
.34724 .32631 L .4 g
F P
s
P
p
.002 w
.31689 .31762 m .33085 .31437 L .34724 .32631 L p
.4 g
F P
s
P
p
.002 w
.37518 .31986 m .4033 .31337 L .41929 .32532 L p
.8 g
F P
s
P
p
.002 w
.66472 .31587 m .67198 .32185 L .65755 .32507 L p
.4 g
F P
s
P
p
.002 w
.63583 .32234 m .66472 .31587 L p
.65755 .32507 L .4 g
F P
s
P
p
.002 w
.51981 .31787 m .4914 .32433 L .47581 .31237 L p
.8 g
F P
s
P
p
.002 w
.51981 .31787 m .5484 .31137 L .56358 .32334 L p
.4 g
F P
s
P
p
.002 w
.68646 .31862 m .67198 .32185 L p
.66472 .31587 L .4 g
F P
s
P
p
.002 w
.69378 .30936 m .70098 .31537 L .68646 .31862 L p
.4 g
F P
s
P
p
.002 w
.66472 .31587 m .69378 .30936 L p
.68646 .31862 L .4 g
F P
s
P
p
.002 w
.5484 .31137 m .51981 .31787 L .50434 .30584 L p
.8 g
F P
s
P
p
.002 w
.47581 .31237 m .50434 .30584 L .51981 .31787 L p
.8 g
F P
s
P
p
.002 w
.33085 .31437 m .31689 .31762 L .3086 .31162 L p
.4 g
F P
s
P
p
.002 w
.69378 .30936 m .66472 .31587 L .65006 .30382 L p
.8 g
F P
s
P
p
.002 w
.71555 .31212 m .70098 .31537 L p
.69378 .30936 L .4 g
F P
s
P
p
.002 w
.3086 .31162 m .30026 .30558 L p
.33085 .31437 L .4 g
F P
s
P
p
.002 w
.30026 .30558 m .31427 .3023 L .33085 .31437 L p
.4 g
F P
s
P
p
.002 w
.72302 .30281 m .73016 .30886 L .71555 .31212 L p
.4 g
F P
s
P
p
.002 w
.69378 .30936 m .72302 .30281 L p
.71555 .31212 L .4 g
F P
s
P
p
.002 w
.57716 .30483 m .5484 .31137 L .53304 .29926 L p
.8 g
F P
s
P
p
.002 w
.50434 .30584 m .53304 .29926 L .5484 .31137 L p
.8 g
F P
s
P
p
.002 w
.72302 .30281 m .69378 .30936 L .67924 .29723 L p
.8 g
F P
s
P
p
.002 w
.65006 .30382 m .67924 .29723 L .69378 .30936 L p
.8 g
F P
s
P
p
1 .019 0 r
.01 w
.64291 .31312 m
.67194 .30659 L
s
P
p
.002 w
.74482 .30558 m .73016 .30886 L p
.72302 .30281 L .4 g
F P
s
P
p
.002 w
.53304 .29926 m .50434 .30584 L .48869 .29367 L p
.4 g
F P
s
P
p
1 .038 0 r
.01 w
.67202 .30821 m
.67202 .30821 L
s
P
p
.002 w
.75244 .29621 m .75952 .3023 L .74482 .30558 L p
.4 g
F P
s
P
p
.002 w
.72302 .30281 m .75244 .29621 L p
.74482 .30558 L .4 g
F P
s
P
p
.002 w
.31427 .3023 m .30026 .30558 L .29187 .29952 L p
.4 g
F P
s
P
p
.002 w
.53304 .29926 m .56192 .29265 L .57716 .30483 L p
.8 g
F P
s
P
p
1 .058 0 r
.01 w
.6721 .30983 m
.6721 .30983 L
s
P
p
1 .077 0 r
.01 w
.67217 .31145 m
.70143 .30488 L
s
P
p
.002 w
.75244 .29621 m .72302 .30281 L .7086 .2906 L p
.8 g
F P
s
P
p
.002 w
.67924 .29723 m .7086 .2906 L .72302 .30281 L p
.8 g
F P
s
P
p
.002 w
.77427 .29901 m .75952 .3023 L p
.75244 .29621 L .4 g
F P
s
P
p
.002 w
.29187 .29952 m .28343 .29341 L p
.31427 .3023 L .4 g
F P
s
P
p
.002 w
.28343 .29341 m .2975 .29009 L .31427 .3023 L p
.4 g
F P
s
P
p
.002 w
.48869 .29367 m .51751 .28702 L .53304 .29926 L p
.4 g
F P
s
P
p
.002 w
.78204 .28958 m .78907 .29571 L .77427 .29901 L p
.4 g
F P
s
P
p
.002 w
.75244 .29621 m .78204 .28958 L p
.77427 .29901 L .4 g
F P
s
P
p
.002 w
.63523 .29163 m .6061 .29825 L .59098 .28599 L p
.8 g
F P
s
P
p
.002 w
.78204 .28958 m .75244 .29621 L .73815 .28393 L p
.8 g
F P
s
P
p
.002 w
.7086 .2906 m .73815 .28393 L .75244 .29621 L p
.8 g
F P
s
P
p
1 .096 0 r
.01 w
.70152 .30651 m
.73097 .2999 L
s
P
p
.002 w
.80391 .29239 m .78907 .29571 L p
.78204 .28958 L .4 g
F P
s
P
p
.002 w
.37077 .28907 m .34243 .29571 L .32577 .28342 L p
.8 g
F P
s
P
p
.002 w
.51751 .28702 m .48869 .29367 L .47286 .28136 L p
.4 g
F P
s
P
p
.002 w
.2975 .29009 m .28343 .29341 L .27495 .28727 L p
.4 g
F P
s
P
p
.002 w
.81183 .28291 m .81879 .28907 L .80391 .29239 L p
.4 g
F P
s
P
p
.002 w
.78204 .28958 m .81183 .28291 L p
.80391 .29239 L .4 g
F P
s
P
p
.002 w
.66453 .28496 m .63523 .29163 L .62023 .27929 L p
.8 g
F P
s
P
p
.002 w
.59098 .28599 m .62023 .27929 L .63523 .29163 L p
.8 g
F P
s
P
p
.002 w
.27495 .28727 m .26642 .2811 L p
.2975 .29009 L .4 g
F P
s
P
p
.002 w
.26642 .2811 m .28054 .27774 L .2975 .29009 L p
.4 g
F P
s
P
p
.002 w
.81183 .28291 m .78204 .28958 L .76788 .27722 L p
.8 g
F P
s
P
p
.002 w
.73815 .28393 m .76788 .27722 L .78204 .28958 L p
.8 g
F P
s
P
p
.002 w
.83373 .28573 m .81879 .28907 L p
.81183 .28291 L .4 g
F P
s
P
p
.002 w
.39928 .28239 m .37077 .28907 L .35422 .27671 L p
.8 g
F P
s
P
p
.002 w
.32577 .28342 m .35422 .27671 L .37077 .28907 L p
.8 g
F P
s
P
p
1 .115 0 r
.01 w
.73107 .30153 m
.73107 .30153 L
s
P
p
1 .134 0 r
.01 w
.73118 .30316 m
.73118 .30316 L
s
P
p
.002 w
.47286 .28136 m .5018 .27463 L .51751 .28702 L p
.4 g
F P
s
P
p
1 .153 0 r
.01 w
.73128 .30479 m
.76096 .29815 L
s
P
p
.002 w
.84181 .27619 m .84871 .28239 L .83373 .28573 L p
.4 g
F P
s
P
p
.002 w
.81183 .28291 m .84181 .27619 L p
.83373 .28573 L .4 g
F P
s
P
p
.002 w
.69402 .27826 m .66453 .28496 L .64965 .27255 L p
.8 g
F P
s
P
p
.002 w
.62023 .27929 m .64965 .27255 L .66453 .28496 L p
.8 g
F P
s
P
p
.002 w
.76788 .27722 m .7978 .27047 L .81183 .28291 L p
.8 g
F P
s
P
p
.002 w
.86373 .27904 m .84871 .28239 L p
.84181 .27619 L .4 g
F P
s
P
p
.002 w
.35422 .27671 m .38285 .26995 L .39928 .28239 L p
.8 g
F P
s
P
p
.002 w
.5018 .27463 m .47286 .28136 L .45684 .26891 L p
.4 g
F P
s
P
p
.002 w
.28054 .27774 m .26642 .2811 L .25784 .27489 L p
.4 g
F P
s
P
p
.002 w
.87198 .26943 m .8788 .27567 L .86373 .27904 L p
.4 g
F P
s
P
p
.002 w
.84181 .27619 m .87198 .26943 L p
.86373 .27904 L .4 g
F P
s
P
p
.792 1 0 r
.01 w
.41024 .43709 m
.38155 .44331 L
s
P
p
1 .92 0 r
.01 w
.61636 .39709 m
.58703 .40344 L
s
P
p
1 .173 0 r
.01 w
.76108 .29978 m
.79096 .2931 L
s
P
p
.002 w
.72369 .27151 m .69402 .27826 L .67926 .26577 L p
.8 g
F P
s
P
p
.002 w
.64965 .27255 m .67926 .26577 L .69402 .27826 L p
.8 g
F P
s
P
p
.002 w
.25784 .27489 m .2492 .26865 L p
.28054 .27774 L .4 g
F P
s
P
p
.002 w
.2492 .26865 m .26338 .26525 L .28054 .27774 L p
.4 g
F P
s
P
p
.773 1 0 r
.01 w
.38149 .44502 m
.38149 .44502 L
s
P
p
1 .939 0 r
.01 w
.58706 .40513 m
.58706 .40513 L
s
P
p
.002 w
.7978 .27047 m .76788 .27722 L .75355 .26472 L p
.8 g
F P
s
P
p
.754 1 0 r
.01 w
.38142 .44672 m
.36484 .4352 L
s
P
p
1 .958 0 r
.01 w
.5871 .40682 m
.5871 .40682 L
s
P
p
.002 w
.89393 .27229 m .8788 .27567 L p
.87198 .26943 L .4 g
F P
s
P
p
1 .978 0 r
.01 w
.58713 .4085 m
.57174 .39676 L
s
P
p
1 .863 0 r
.01 w
.64568 .38564 m
.61621 .39204 L
s
P
p
.002 w
.45684 .26891 m .4859 .2621 L .5018 .27463 L p
.4 g
F P
s
P
p
1 .882 0 r
.01 w
.61626 .39372 m
.61626 .39372 L
s
P
p
.812 1 0 r
.01 w
.43914 .42911 m
.41029 .43538 L
s
P
p
1 .901 0 r
.01 w
.61631 .39541 m
.61631 .39541 L
s
P
p
.002 w
.87198 .26943 m .88713 .26603 L .89393 .27229 L p
.4 g
F P
s
P
p
.002 w
.11344 .17042 m .63841 .03687 L .89393 .27229 L p
.9 g
F P
s
P
p
.002 w
.67926 .26577 m .70906 .25895 L .72369 .27151 L p
.8 g
F P
s
P
p
1 .192 0 r
.01 w
.79109 .29474 m
.79109 .29474 L
s
P
p
.002 w
.75355 .26472 m .7836 .25789 L .7978 .27047 L p
.8 g
F P
s
P
p
.002 w
.41165 .26315 m .38285 .26995 L .36622 .25736 L p
.8 g
F P
s
P
p
1 .211 0 r
.01 w
.77698 .28395 m
.79123 .29638 L
s
P
p
.002 w
.88713 .26603 m .87198 .26943 L p
.8582 .25684 L .4 g
F P
s
P
p
.869 1 0 r
.01 w
.46824 .41769 m
.43925 .424 L
s
P
p
1 .843 0 r
.01 w
.64562 .38396 m
.67527 .37752 L
s
P
p
.002 w
.4859 .2621 m .45684 .26891 L .44064 .25631 L p
.4 g
F P
s
P
p
.002 w
.26338 .26525 m .2492 .26865 L .24052 .26236 L p
.4 g
F P
s
P
p
.85 1 0 r
.01 w
.43921 .4257 m
.43921 .4257 L
s
P
p
.831 1 0 r
.01 w
.43918 .42741 m
.43918 .42741 L
s
P
p
.002 w
.8803 .25974 m .88713 .26603 L p
.8582 .25684 L .4 g
F P
s
P
p
.002 w
.70906 .25895 m .67926 .26577 L .66434 .25314 L p
.8 g
F P
s
P
p
1 .786 0 r
.01 w
.67503 .37247 m
.70482 .36598 L
s
P
p
.002 w
.24052 .26236 m .23179 .25605 L p
.26338 .26525 L .4 g
F P
s
P
p
.002 w
.23179 .25605 m .24602 .25261 L .26338 .26525 L p
.4 g
F P
s
P
p
.002 w
.7836 .25789 m .75355 .26472 L .73905 .25208 L p
.8 g
F P
s
P
p
1 .805 0 r
.01 w
.67511 .37415 m
.67511 .37415 L
s
P
p
.888 1 0 r
.01 w
.49743 .40963 m
.46827 .41598 L
s
P
p
1 .824 0 r
.01 w
.67519 .37583 m
.67519 .37583 L
s
P
p
.002 w
.36622 .25736 m .39515 .25049 L .41165 .26315 L p
.8 g
F P
s
P
p
.735 1 0 r
.01 w
.36477 .43692 m
.34798 .42527 L
s
P
p
.002 w
.44064 .25631 m .46982 .24942 L .4859 .2621 L p
.4 g
F P
s
P
p
1 .997 0 r
.01 w
.57177 .39845 m
.55619 .38657 L
s
P
p
.946 1 0 r
.01 w
.52676 .39812 m
.49745 .40452 L
s
P
p
.002 w
.8582 .25684 m .87342 .2534 L .8803 .25974 L p
.4 g
F P
s
P
p
1 .767 0 r
.01 w
.70472 .3643 m
.73469 .35777 L
s
P
p
.002 w
.66434 .25314 m .69427 .24623 L .70906 .25895 L p
.8 g
F P
s
P
p
.927 1 0 r
.01 w
.49744 .40622 m
.49744 .40622 L
s
P
p
.002 w
.73905 .25208 m .76923 .24517 L .7836 .25789 L p
.8 g
F P
s
P
p
.907 1 0 r
.01 w
.49744 .40792 m
.49744 .40792 L
s
P
p
.002 w
.39515 .25049 m .36622 .25736 L .3494 .24463 L p
.8 g
F P
s
P
p
.002 w
.87342 .2534 m .8582 .25684 L p
.84426 .2441 L .4 g
F P
s
P
p
.002 w
.46982 .24942 m .44064 .25631 L .42425 .24356 L p
.4 g
F P
s
P
p
1 .709 0 r
.01 w
.73436 .35273 m
.76447 .34615 L
s
P
p
1 .23 0 r
.01 w
.76269 .27301 m
.77711 .28559 L
s
P
p
.002 w
.24602 .25261 m .23179 .25605 L .223 .24969 L p
.4 g
F P
s
P
p
1 .728 0 r
.01 w
.73447 .35441 m
.73447 .35441 L
s
P
p
.965 1 0 r
.01 w
.55623 .38997 m
.52675 .39642 L
s
P
p
1 .748 0 r
.01 w
.73458 .35609 m
.73458 .35609 L
s
P
p
.002 w
.86651 .24703 m .87342 .2534 L p
.84426 .2441 L .4 g
F P
s
P
p
.002 w
.69427 .24623 m .66434 .25314 L .64924 .24035 L p
.8 g
F P
s
P
p
.002 w
.223 .24969 m .21417 .2433 L p
.24602 .25261 L .4 g
F P
s
P
p
.002 w
.21417 .2433 m .22846 .23982 L .24602 .25261 L p
.4 g
F P
s
P
p
.002 w
.76923 .24517 m .73905 .25208 L .72438 .23928 L p
.8 g
F P
s
P
p
.002 w
.3494 .24463 m .37844 .23767 L .39515 .25049 L p
.8 g
F P
s
P
p
1 .69 0 r
.01 w
.76435 .34448 m
.79463 .33785 L
s
P
p
.002 w
.42425 .24356 m .45354 .2366 L .46982 .24942 L p
.4 g
F P
s
P
p
.716 1 0 r
.01 w
.3479 .42698 m
.3479 .42698 L
s
P
p
.696 1 0 r
.01 w
.34782 .4287 m
.34782 .4287 L
s
P
p
.984 1 0 r
.01 w
.55621 .38827 m
.55621 .38827 L
s
P
p
.002 w
.64924 .24035 m .61938 .2473 L .60397 .23445 L p
.4 g
F P
s
P
p
.677 1 0 r
.01 w
.34774 .43042 m
.33073 .41865 L
s
P
p
.002 w
.84426 .2441 m .85955 .24062 L .86651 .24703 L p
.4 g
F P
s
P
p
.002 w
.64924 .24035 m .67929 .23337 L .69427 .24623 L p
.8 g
F P
s
P
p
1 .652 0 r
.01 w
.77997 .32215 m
.79436 .3345 L
s
P
p
.002 w
.7996 .23821 m .76923 .24517 L .75469 .23229 L p
.8 g
F P
s
P
p
.002 w
.72438 .23928 m .75469 .23229 L .76923 .24517 L p
.8 g
F P
s
P
p
1 .671 0 r
.01 w
.79449 .33617 m
.79449 .33617 L
s
P
p
.002 w
.85955 .24062 m .84426 .2441 L p
.83016 .23121 L .4 g
F P
s
P
p
.002 w
.45354 .2366 m .42425 .24356 L .40767 .23067 L p
.4 g
F P
s
P
p
.002 w
.22846 .23982 m .21417 .2433 L .20528 .23687 L p
.4 g
F P
s
P
p
1 .249 0 r
.01 w
.76281 .27466 m
.76281 .27466 L
s
P
p
.002 w
.60397 .23445 m .57417 .24143 L .55845 .2285 L p
.8 g
F P
s
P
p
1 .268 0 r
.01 w
.76294 .27631 m
.76294 .27631 L
s
P
p
.002 w
.85256 .23418 m .85955 .24062 L p
.83016 .23121 L .4 g
F P
s
P
p
.002 w
.60397 .23445 m .63396 .22742 L .64924 .24035 L p
.4 g
F P
s
P
p
.002 w
.67929 .23337 m .64924 .24035 L .63396 .22742 L p
.8 g
F P
s
P
p
1 .288 0 r
.01 w
.74845 .26525 m
.76306 .27796 L
s
P
p
.002 w
.20528 .23687 m .19634 .2304 L p
.22846 .23982 L .4 g
F P
s
P
p
.002 w
.19634 .2304 m .21069 .22688 L .22846 .23982 L p
.4 g
F P
s
P
p
.002 w
.83016 .23121 m .7996 .23821 L .78519 .22525 L p
.8 g
F P
s
P
p
.002 w
.75469 .23229 m .78519 .22525 L .7996 .23821 L p
.8 g
F P
s
P
p
.002 w
.48302 .22959 m .45354 .2366 L .43708 .22362 L p
.4 g
F P
s
P
p
.002 w
.40767 .23067 m .43708 .22362 L .45354 .2366 L p
.4 g
F P
s
P
p
.002 w
.63396 .22742 m .60397 .23445 L .58838 .22144 L p
.4 g
F P
s
P
p
.002 w
.55845 .2285 m .58838 .22144 L .60397 .23445 L p
.8 g
F P
s
P
p
.002 w
.83016 .23121 m .84552 .22769 L .85256 .23418 L p
.4 g
F P
s
P
p
1 .633 0 r
.01 w
.76529 .30797 m
.77984 .32047 L
s
P
p
.002 w
.70954 .22634 m .67929 .23337 L .66414 .22035 L p
.8 g
F P
s
P
p
.002 w
.63396 .22742 m .66414 .22035 L .67929 .23337 L p
.8 g
F P
s
P
p
.658 1 0 r
.01 w
.33064 .42038 m
.31342 .40847 L
s
P
p
.002 w
.84552 .22769 m .83016 .23121 L p
.81589 .21817 L .4 g
F P
s
P
p
.002 w
.78519 .22525 m .81589 .21817 L .83016 .23121 L p
.8 g
F P
s
P
p
.002 w
.43708 .22362 m .40767 .23067 L .39089 .21762 L p
.4 g
F P
s
P
p
.002 w
.21069 .22688 m .19634 .2304 L .18735 .22389 L p
.4 g
F P
s
P
p
.002 w
.43708 .22362 m .46668 .21652 L .48302 .22959 L p
.4 g
F P
s
P
p
.002 w
.83844 .22117 m .84552 .22769 L p
.81589 .21817 L .4 g
F P
s
P
p
.002 w
.58838 .22144 m .6185 .21433 L .63396 .22742 L p
.4 g
F P
s
P
p
.002 w
.18735 .22389 m .1783 .21735 L p
.21069 .22688 L .4 g
F P
s
P
p
.002 w
.1783 .21735 m .19271 .21378 L .21069 .22688 L p
.4 g
F P
s
P
p
.002 w
.73998 .21926 m .70954 .22634 L .69452 .21324 L p
.8 g
F P
s
P
p
.002 w
.66414 .22035 m .69452 .21324 L .70954 .22634 L p
.8 g
F P
s
P
p
1 .307 0 r
.01 w
.73378 .25405 m
.74857 .26691 L
s
P
p
.002 w
.81589 .21817 m .78519 .22525 L .77062 .21214 L p
.8 g
F P
s
P
p
1 .575 0 r
.01 w
.75021 .29027 m
.76491 .30293 L
s
P
p
.002 w
.46668 .21652 m .43708 .22362 L .42042 .21049 L p
.4 g
F P
s
P
p
.002 w
.39089 .21762 m .42042 .21049 L .43708 .22362 L p
.4 g
F P
s
P
p
1 .594 0 r
.01 w
.76504 .30461 m
.76504 .30461 L
s
P
p
1 .613 0 r
.01 w
.76516 .30629 m
.76516 .30629 L
s
P
p
.002 w
.6185 .21433 m .58838 .22144 L .57261 .20828 L p
.4 g
F P
s
P
p
.002 w
.81589 .21817 m .83132 .21461 L .83844 .22117 L p
.4 g
F P
s
P
p
.002 w
.77062 .21214 m .73998 .21926 L .7251 .20607 L p
.8 g
F P
s
P
p
.002 w
.69452 .21324 m .7251 .20607 L .73998 .21926 L p
.8 g
F P
s
P
p
.639 1 0 r
.01 w
.31333 .4102 m
.31333 .4102 L
s
P
p
.002 w
.34444 .21159 m .31516 .21871 L .29774 .20552 L p
.8 g
F P
s
P
p
.002 w
.83132 .21461 m .81589 .21817 L p
.80145 .20497 L .4 g
F P
s
P
p
.002 w
.77062 .21214 m .80145 .20497 L .81589 .21817 L p
.8 g
F P
s
P
p
.62 1 0 r
.01 w
.31323 .41193 m
.31323 .41193 L
s
P
p
.002 w
.19271 .21378 m .1783 .21735 L .1692 .21076 L p
.4 g
F P
s
P
p
.601 1 0 r
.01 w
.31313 .41367 m
.29567 .40163 L
s
P
p
.002 w
.42042 .21049 m .45014 .20331 L .46668 .21652 L p
.4 g
F P
s
P
p
.002 w
.82415 .20801 m .83132 .21461 L p
.80145 .20497 L .4 g
F P
s
P
p
.002 w
.57261 .20828 m .60285 .20109 L .6185 .21433 L p
.4 g
F P
s
P
p
.002 w
.1692 .21076 m .16005 .20414 L p
.19271 .21378 L .4 g
F P
s
P
p
.002 w
.16005 .20414 m .17451 .20053 L .19271 .21378 L p
.4 g
F P
s
P
p
.002 w
.80145 .20497 m .77062 .21214 L .75587 .19887 L p
.8 g
F P
s
P
p
.002 w
.7251 .20607 m .75587 .19887 L .77062 .21214 L p
.8 g
F P
s
P
p
1 .326 0 r
.01 w
.73389 .25571 m
.73389 .25571 L
s
P
p
1 .556 0 r
.01 w
.73521 .27578 m
.75009 .28859 L
s
P
p
.002 w
.29774 .20552 m .32713 .19831 L .34444 .21159 L p
.8 g
F P
s
P
p
1 .345 0 r
.01 w
.734 .25737 m
.734 .25737 L
s
P
p
1 .364 0 r
.01 w
.71912 .24603 m
.73411 .25904 L
s
P
p
.002 w
.52646 .2022 m .49647 .20938 L .48006 .19608 L p
.8 g
F P
s
P
p
.002 w
.60285 .20109 m .57261 .20828 L .55664 .19497 L p
.4 g
F P
s
P
p
.002 w
.80145 .20497 m .81695 .20137 L .82415 .20801 L p
.4 g
F P
s
P
p
.002 w
.32713 .19831 m .29774 .20552 L .2801 .19217 L p
.8 g
F P
s
P
p
.002 w
.81695 .20137 m .80145 .20497 L p
.78684 .19161 L .4 g
F P
s
P
p
.002 w
.75587 .19887 m .78684 .19161 L .80145 .20497 L p
.8 g
F P
s
P
p
.002 w
.40356 .1972 m .3739 .20441 L .35672 .19105 L p
.4 g
F P
s
P
p
.002 w
.17451 .20053 m .16005 .20414 L .15084 .19747 L p
.4 g
F P
s
P
p
.581 1 0 r
.01 w
.29557 .40338 m
.27789 .3912 L
s
P
p
.002 w
.48006 .19608 m .51017 .18881 L .52646 .2022 L p
.8 g
F P
s
P
p
1 .498 0 r
.01 w
.71985 .25776 m
.73488 .27074 L
s
P
p
.002 w
.8097 .19469 m .81695 .20137 L p
.78684 .19161 L .4 g
F P
s
P
p
.002 w
.6333 .19385 m .60285 .20109 L .58702 .18768 L p
.4 g
F P
s
P
p
.002 w
.55664 .19497 m .58702 .18768 L .60285 .20109 L p
.4 g
F P
s
P
p
1 .518 0 r
.01 w
.73499 .27242 m
.73499 .27242 L
s
P
p
.002 w
.15084 .19747 m .14157 .19077 L p
.17451 .20053 L .4 g
F P
s
P
p
.002 w
.14157 .19077 m .15609 .18712 L .17451 .20053 L p
.4 g
F P
s
P
p
1 .537 0 r
.01 w
.7351 .2741 m
.7351 .2741 L
s
P
p
.002 w
.2801 .19217 m .30962 .18487 L .32713 .19831 L p
.8 g
F P
s
P
p
.002 w
.43341 .18993 m .40356 .1972 L .38649 .18374 L p
.4 g
F P
s
P
p
.002 w
.35672 .19105 m .38649 .18374 L .40356 .1972 L p
.4 g
F P
s
P
p
1 .383 0 r
.01 w
.70405 .23455 m
.71923 .2477 L
s
P
p
.002 w
.78684 .19161 m .8024 .18797 L .8097 .19469 L p
.4 g
F P
s
P
p
.002 w
.66394 .18656 m .6333 .19385 L .6176 .18036 L p
.4 g
F P
s
P
p
.002 w
.58702 .18768 m .6176 .18036 L .6333 .19385 L p
.4 g
F P
s
P
p
.002 w
.8024 .18797 m .78684 .19161 L p
.77205 .17809 L .4 g
F P
s
P
p
.002 w
.38649 .18374 m .35672 .19105 L .33932 .17753 L p
.4 g
F P
s
P
p
.002 w
.15609 .18712 m .14157 .19077 L .13225 .18403 L p
.4 g
F P
s
P
p
.002 w
.38649 .18374 m .41647 .17639 L .43341 .18993 L p
.4 g
F P
s
P
p
1 .479 0 r
.01 w
.70453 .24294 m
.71974 .25608 L
s
P
p
.562 1 0 r
.01 w
.27778 .39295 m
.27778 .39295 L
s
P
p
.002 w
.79507 .1812 m .8024 .18797 L p
.77205 .17809 L .4 g
F P
s
P
p
.002 w
.13225 .18403 m .12288 .17724 L p
.15609 .18712 L .4 g
F P
s
P
p
.002 w
.12288 .17724 m .13745 .17355 L .15609 .18712 L p
.4 g
F P
s
P
p
.543 1 0 r
.01 w
.27766 .3947 m
.27766 .3947 L
s
P
p
.002 w
.69478 .17923 m .66394 .18656 L .64837 .17298 L p
.4 g
F P
s
P
p
.002 w
.6176 .18036 m .64837 .17298 L .66394 .18656 L p
.4 g
F P
s
P
p
.524 1 0 r
.01 w
.27754 .39645 m
.25962 .38414 L
s
P
p
.002 w
.41647 .17639 m .38649 .18374 L .36922 .17013 L p
.4 g
F P
s
P
p
.002 w
.33932 .17753 m .36922 .17013 L .38649 .18374 L p
.4 g
F P
s
P
p
.002 w
.57099 .17412 m .54048 .18149 L .52413 .16785 L p
.8 g
F P
s
P
p
.002 w
.77205 .17809 m .78768 .1744 L .79507 .1812 L p
.4 g
F P
s
P
p
1 .403 0 r
.01 w
.70415 .23622 m
.70415 .23622 L
s
P
p
1 .422 0 r
.01 w
.70424 .2379 m
.70424 .2379 L
s
P
p
.002 w
.64837 .17298 m .67935 .16556 L .69478 .17923 L p
.4 g
F P
s
P
p
1 .441 0 r
.01 w
.70434 .23958 m
.70434 .23958 L
s
P
p
.002 w
.78768 .1744 m .77205 .17809 L p
.75708 .16441 L .4 g
F P
s
P
p
1 .46 0 r
.01 w
.70444 .24126 m
.70444 .24126 L
s
P
p
.002 w
.13745 .17355 m .12288 .17724 L .11344 .17042 L p
.4 g
F P
s
P
p
.002 w
.44664 .16899 m .41647 .17639 L .39932 .16269 L p
.4 g
F P
s
P
p
.002 w
.36922 .17013 m .39932 .16269 L .41647 .17639 L p
.4 g
F P
s
P
p
.002 w
.78026 .16756 m .78768 .1744 L p
.75708 .16441 L .4 g
F P
s
P
p
.002 w
.52413 .16785 m .55477 .16039 L .57099 .17412 L p
.8 g
F P
s
P
p
.002 w
.12804 .1667 m .14269 .16297 L p
.13745 .17355 L .4 g
F P
s
P
p
.002 w
.16674 .16613 m .13745 .17355 L p
.14269 .16297 L .4 g
F P
s
P
p
.002 w
.11344 .17042 m .12804 .1667 L .13745 .17355 L p
.4 g
F P
s
P
p
.002 w
.67935 .16556 m .64837 .17298 L .63261 .15924 L p
.4 g
F P
s
P
p
.002 w
.32172 .16384 m .29189 .17127 L .27394 .15751 L p
.8 g
F P
s
P
p
.505 1 0 r
.01 w
.24135 .37343 m
.2595 .38589 L
s
P
p
.002 w
.47701 .16154 m .44664 .16899 L .42962 .15519 L p
.4 g
F P
s
P
p
.002 w
.39932 .16269 m .42962 .15519 L .44664 .16899 L p
.4 g
F P
s
P
p
.002 w
.75708 .16441 m .77278 .16068 L .78026 .16756 L p
.4 g
F P
s
P
p
.002 w
.15739 .15924 m .17214 .15548 L p
.16674 .16613 L .4 g
F P
s
P
p
.002 w
.19622 .15866 m .16674 .16613 L p
.17214 .15548 L .4 g
F P
s
P
p
.002 w
.14269 .16297 m .15739 .15924 L .16674 .16613 L p
.4 g
F P
s
P
p
.002 w
.63261 .15924 m .66373 .15172 L .67935 .16556 L p
.4 g
F P
s
P
p
.002 w
.77278 .16068 m .75708 .16441 L p
.74193 .15056 L .4 g
F P
s
P
p
.002 w
.35174 .15635 m .32172 .16384 L .30389 .14998 L p
.8 g
F P
s
P
p
.002 w
.27394 .15751 m .30389 .14998 L .32172 .16384 L p
.8 g
F P
s
P
p
.002 w
.50758 .15404 m .47701 .16154 L .46012 .14765 L p
.4 g
F P
s
P
p
.002 w
.42962 .15519 m .46012 .14765 L .47701 .16154 L p
.4 g
F P
s
P
p
.002 w
.76527 .15375 m .77278 .16068 L p
.74193 .15056 L .4 g
F P
s
P
p
.002 w
.66373 .15172 m .63261 .15924 L .61666 .14532 L p
.4 g
F P
s
P
p
.002 w
.18693 .15172 m .20178 .14794 L p
.19622 .15866 L .4 g
F P
s
P
p
.002 w
.2259 .15114 m .19622 .15866 L p
.20178 .14794 L .4 g
F P
s
P
p
.002 w
.17214 .15548 m .18693 .15172 L .19622 .15866 L p
.4 g
F P
s
P
p
.002 w
.30389 .14998 m .33405 .1424 L .35174 .15635 L p
.8 g
F P
s
P
p
.486 1 0 r
.01 w
.24121 .3752 m
.24121 .3752 L
s
P
p
.466 1 0 r
.01 w
.24108 .37697 m
.24108 .37697 L
s
P
p
.002 w
.46012 .14765 m .49082 .14006 L .50758 .15404 L p
.4 g
F P
s
P
p
.447 1 0 r
.01 w
.24094 .37873 m
.22254 .36614 L
s
P
p
.002 w
.74193 .15056 m .7577 .14678 L .76527 .15375 L p
.4 g
F P
s
P
p
.002 w
.61666 .14532 m .64792 .13771 L .66373 .15172 L p
.4 g
F P
s
P
p
.002 w
.21667 .14415 m .23162 .14035 L p
.2259 .15114 L .4 g
F P
s
P
p
.002 w
.25578 .14357 m .2259 .15114 L p
.23162 .14035 L .4 g
F P
s
P
p
.002 w
.20178 .14794 m .21667 .14415 L .2259 .15114 L p
.4 g
F P
s
P
p
.002 w
.7577 .14678 m .74193 .15056 L p
.72659 .13654 L .4 g
F P
s
P
p
.002 w
.41239 .14123 m .38197 .14882 L .3644 .13477 L p
.8 g
F P
s
P
p
.002 w
.49082 .14006 m .46012 .14765 L .44302 .1336 L p
.4 g
F P
s
P
p
.002 w
.75009 .13977 m .7577 .14678 L p
.72659 .13654 L .4 g
F P
s
P
p
.002 w
.56933 .13889 m .53835 .14649 L .52173 .13242 L p
.8 g
F P
s
P
p
.002 w
.64792 .13771 m .61666 .14532 L .60052 .13124 L p
.4 g
F P
s
P
p
.002 w
.24661 .13654 m .26166 .13271 L p
.25578 .14357 L .4 g
F P
s
P
p
.002 w
.28585 .13595 m .25578 .14357 L p
.26166 .13271 L .4 g
F P
s
P
p
.002 w
.23162 .14035 m .24661 .13654 L .25578 .14357 L p
.4 g
F P
s
P
p
.002 w
.44302 .1336 m .41239 .14123 L .39495 .12709 L p
.8 g
F P
s
P
p
.002 w
.3644 .13477 m .39495 .12709 L .41239 .14123 L p
.8 g
F P
s
P
p
.002 w
.44302 .1336 m .47386 .12591 L .49082 .14006 L p
.4 g
F P
s
P
p
.002 w
.72659 .13654 m .74243 .13271 L .75009 .13977 L p
.4 g
F P
s
P
p
.002 w
.52173 .13242 m .55284 .12472 L .56933 .13889 L p
.8 g
F P
s
P
p
.428 1 0 r
.01 w
.22239 .36791 m
.20375 .35516 L
s
P
p
.002 w
.60052 .13124 m .63191 .12353 L .64792 .13771 L p
.4 g
F P
s
P
p
.002 w
.74243 .13271 m .72659 .13654 L p
.71106 .12234 L .4 g
F P
s
P
p
.002 w
.27675 .12887 m .29189 .12502 L p
.28585 .13595 L .4 g
F P
s
P
p
.002 w
.31613 .12828 m .28585 .13595 L p
.29189 .12502 L .4 g
F P
s
P
p
.002 w
.26166 .13271 m .27675 .12887 L .28585 .13595 L p
.4 g
F P
s
P
p
.002 w
.39495 .12709 m .42571 .11936 L .44302 .1336 L p
.8 g
F P
s
P
p
.002 w
.73473 .12561 m .74243 .13271 L p
.71106 .12234 L .4 g
F P
s
P
p
.002 w
.55284 .12472 m .52173 .13242 L .5049 .11817 L p
.8 g
F P
s
P
p
.002 w
.63191 .12353 m .60052 .13124 L .58417 .11698 L p
.4 g
F P
s
P
p
.002 w
.30709 .12115 m .32234 .11727 L p
.31613 .12828 L .4 g
F P
s
P
p
.002 w
.34661 .12056 m .31613 .12828 L p
.32234 .11727 L .4 g
F P
s
P
p
.002 w
.29189 .12502 m .30709 .12115 L .31613 .12828 L p
.4 g
F P
s
P
p
.002 w
.71106 .12234 m .72698 .11847 L .73473 .12561 L p
.4 g
F P
s
P
p
.002 w
.5049 .11817 m .53615 .11038 L .55284 .12472 L p
.8 g
F P
s
P
p
.002 w
.58417 .11698 m .6157 .10918 L .63191 .12353 L p
.4 g
F P
s
P
p
.409 1 0 r
.01 w
.20359 .35694 m
.20359 .35694 L
s
P
p
.002 w
.72698 .11847 m .71106 .12234 L p
.69534 .10797 L .4 g
F P
s
P
p
.39 1 0 r
.01 w
.20343 .35872 m
.20343 .35872 L
s
P
p
.371 1 0 r
.01 w
.20328 .36051 m
.18437 .34761 L
s
P
p
.002 w
.33763 .11338 m .35298 .10948 L p
.34661 .12056 L .4 g
F P
s
P
p
.002 w
.3773 .11278 m .34661 .12056 L p
.35298 .10948 L .4 g
F P
s
P
p
.002 w
.32234 .11727 m .33763 .11338 L .34661 .12056 L p
.4 g
F P
s
P
p
.002 w
.45668 .11158 m .42571 .11936 L .40819 .10496 L p
.4 g
F P
s
P
p
.002 w
.71918 .11128 m .72698 .11847 L p
.69534 .10797 L .4 g
F P
s
P
p
.002 w
.53615 .11038 m .5049 .11817 L .48786 .10375 L p
.8 g
F P
s
P
p
.002 w
.6157 .10918 m .58417 .11698 L .56761 .10254 L p
.4 g
F P
s
P
p
.002 w
.36839 .10556 m .38384 .10163 L p
.3773 .11278 L .4 g
F P
s
P
p
.002 w
.40819 .10496 m .3773 .11278 L p
.38384 .10163 L .4 g
F P
s
P
p
.002 w
.35298 .10948 m .36839 .10556 L .3773 .11278 L p
.4 g
F P
s
P
p
.002 w
.40819 .10496 m .43929 .09708 L .45668 .11158 L p
.4 g
F P
s
P
p
.002 w
.69534 .10797 m .71133 .10405 L .71918 .11128 L p
.4 g
F P
s
P
p
.002 w
.48786 .10375 m .51925 .09586 L .53615 .11038 L p
.8 g
F P
s
P
p
.002 w
.64745 .10132 m .6157 .10918 L .59929 .09464 L p
.4 g
F P
s
P
p
.002 w
.56761 .10254 m .59929 .09464 L .6157 .10918 L p
.4 g
F P
s
P
p
.002 w
.71133 .10405 m .69534 .10797 L p
.67942 .09342 L .4 g
F P
s
P
p
.351 1 0 r
.01 w
.1842 .3494 m
.16505 .33635 L
s
P
p
.002 w
.39935 .09768 m .4149 .09373 L p
.40819 .10496 L .4 g
F P
s
P
p
.002 w
.43929 .09708 m .40819 .10496 L p
.4149 .09373 L .4 g
F P
s
P
p
.002 w
.38384 .10163 m .39935 .09768 L .40819 .10496 L p
.4 g
F P
s
P
p
.002 w
.70343 .09677 m .71133 .10405 L p
.67942 .09342 L .4 g
F P
s
P
p
.002 w
.67942 .09342 m .64745 .10132 L .63118 .08669 L p
.4 g
F P
s
P
p
.002 w
.59929 .09464 m .63118 .08669 L .64745 .10132 L p
.4 g
F P
s
P
p
.002 w
.43052 .08975 m .44618 .08577 L p
.43929 .09708 L .4 g
F P
s
P
p
.002 w
.47061 .08914 m .43929 .09708 L p
.44618 .08577 L .4 g
F P
s
P
p
.002 w
.4149 .09373 m .43052 .08975 L .43929 .09708 L p
.4 g
F P
s
P
p
.002 w
.67942 .09342 m .69548 .08945 L .70343 .09677 L p
.4 g
F P
s
P
p
.002 w
.69548 .08945 m .67942 .09342 L p
.66329 .07868 L .4 g
F P
s
P
p
.002 w
.63118 .08669 m .66329 .07868 L .67942 .09342 L p
.4 g
F P
s
P
p
.332 1 0 r
.01 w
.16487 .33815 m
.16487 .33815 L
s
P
p
.002 w
.68748 .08208 m .69548 .08945 L p
.66329 .07868 L .4 g
F P
s
P
p
.002 w
.4619 .08177 m .47767 .07776 L p
.47061 .08914 L .4 g
F P
s
P
p
.002 w
.50214 .08115 m .47061 .08914 L p
.47767 .07776 L .4 g
F P
s
P
p
.002 w
.44618 .08577 m .4619 .08177 L .47061 .08914 L p
.4 g
F P
s
P
p
.313 1 0 r
.01 w
.16469 .33994 m
.16469 .33994 L
s
P
p
.294 1 0 r
.01 w
.16451 .34174 m
.14508 .32854 L
s
P
p
.002 w
.66329 .07868 m .67943 .07466 L .68748 .08208 L p
.4 g
F P
s
P
p
.002 w
.4935 .07373 m .50938 .06969 L p
.50214 .08115 L .4 g
F P
s
P
p
.002 w
.53388 .07311 m .50214 .08115 L p
.50938 .06969 L .4 g
F P
s
P
p
.002 w
.47767 .07776 m .4935 .07373 L .50214 .08115 L p
.4 g
F P
s
P
p
.002 w
.67943 .07466 m .66329 .07868 L p
.64697 .06376 L .4 g
F P
s
P
p
.002 w
.67133 .0672 m .67943 .07466 L p
.64697 .06376 L .4 g
F P
s
P
p
.002 w
.52531 .06564 m .5413 .06157 L p
.53388 .07311 L .4 g
F P
s
P
p
.002 w
.56584 .06501 m .53388 .07311 L p
.5413 .06157 L .4 g
F P
s
P
p
.002 w
.50938 .06969 m .52531 .06564 L .53388 .07311 L p
.4 g
F P
s
P
p
.275 1 0 r
.01 w
.14489 .33035 m
.14489 .33035 L
s
P
p
.256 1 0 r
.01 w
.14469 .33216 m
.14469 .33216 L
s
P
p
.236 1 0 r
.01 w
.1445 .33397 m
.17518 .32675 L
s
P
p
.002 w
.64697 .06376 m .66318 .05969 L .67133 .0672 L p
.4 g
F P
s
P
p
.002 w
.55735 .05749 m .57345 .05339 L p
.56584 .06501 L .4 g
F P
s
P
p
.002 w
.59803 .05686 m .56584 .06501 L p
.57345 .05339 L .4 g
F P
s
P
p
.002 w
.5413 .06157 m .55735 .05749 L .56584 .06501 L p
.4 g
F P
s
P
p
.002 w
.66318 .05969 m .64697 .06376 L p
.63043 .04865 L .4 g
F P
s
P
p
.002 w
.65498 .05213 m .66318 .05969 L p
.63043 .04865 L .4 g
F P
s
P
p
.217 1 0 r
.01 w
.17501 .32857 m
.20592 .3213 L
s
P
p
.002 w
.5896 .04928 m .60582 .04516 L p
.59803 .05686 L .4 g
F P
s
P
p
.002 w
.63043 .04865 m .59803 .05686 L p
.60582 .04516 L .4 g
F P
s
P
p
.002 w
.57345 .05339 m .5896 .04928 L .59803 .05686 L p
.4 g
F P
s
P
p
.002 w
.63043 .04865 m .64672 .04452 L .65498 .05213 L p
.4 g
F P
s
P
p
.198 1 0 r
.01 w
.20575 .32312 m
.20575 .32312 L
s
P
p
.002 w
.62209 .04102 m .63841 .03687 L p
.63043 .04865 L .4 g
F P
s
P
p
.002 w
.64672 .04452 m .63043 .04865 L p
.63841 .03687 L .4 g
F P
s
P
p
.002 w
.60582 .04516 m .62209 .04102 L .63043 .04865 L p
.4 g
F P
s
P
p
0 1 .281 r
.01 w
.27166 .38851 m
.24038 .39557 L
s
P
p
.179 1 0 r
.01 w
.20559 .32494 m
.20559 .32494 L
s
P
p
0 1 .3 r
.01 w
.24024 .39743 m
.24024 .39743 L
s
P
p
.16 1 0 r
.01 w
.20543 .32677 m
.2366 .31946 L
s
P
p
0 1 .319 r
.01 w
.24009 .39929 m
.24009 .39929 L
s
P
p
0 1 .339 r
.01 w
.23995 .40116 m
.23995 .40116 L
s
P
p
0 1 .358 r
.01 w
.2398 .40302 m
.2398 .40302 L
s
P
p
0 1 .377 r
.01 w
.23966 .40489 m
.27102 .39784 L
s
P
p
0 1 .262 r
.01 w
.30327 .37953 m
.27179 .38664 L
s
P
p
.141 1 0 r
.01 w
.23646 .32129 m
.26786 .31393 L
s
P
p
0 1 .204 r
.01 w
.33526 .36678 m
.30361 .37395 L
s
P
p
0 1 .224 r
.01 w
.3035 .37581 m
.3035 .37581 L
s
P
p
0 1 .243 r
.01 w
.30339 .37767 m
.30339 .37767 L
s
P
p
0 1 .396 r
.01 w
.27089 .39972 m
.30248 .39262 L
s
P
p
0 1 .185 r
.01 w
.36722 .35769 m
.33536 .36492 L
s
P
p
.121 1 0 r
.01 w
.26773 .31577 m
.26773 .31577 L
s
P
p
.102 1 0 r
.01 w
.2676 .3176 m
.2676 .3176 L
s
P
p
0 1 .128 r
.01 w
.39948 .34483 m
.36745 .35212 L
s
P
p
.083 1 0 r
.01 w
.26747 .31944 m
.29915 .31204 L
s
P
p
0 1 .147 r
.01 w
.36737 .35397 m
.36737 .35397 L
s
P
p
0 1 .415 r
.01 w
.30237 .3945 m
.30237 .3945 L
s
P
p
0 1 .166 r
.01 w
.36729 .35583 m
.36729 .35583 L
s
P
p
0 1 .435 r
.01 w
.30226 .39638 m
.28318 .38316 L
s
P
p
0 1 .109 r
.01 w
.43178 .33564 m
.39954 .34298 L
s
P
p
.064 1 0 r
.01 w
.29903 .31388 m
.33095 .30643 L
s
P
p
0 1 .07 r
.01 w
.41357 .31824 m
.43187 .33193 L
s
P
p
0 1 .089 r
.01 w
.43182 .33378 m
.43182 .33378 L
s
P
p
0 1 .856 r
.01 w
.26773 .44529 m
.23596 .45227 L
s
P
p
0 1 .875 r
.01 w
.23581 .45419 m
.23581 .45419 L
s
P
p
0 1 .895 r
.01 w
.23566 .45612 m
.23566 .45612 L
s
P
p
0 1 .914 r
.01 w
.23551 .45804 m
.23551 .45804 L
s
P
p
.045 1 0 r
.01 w
.33085 .30827 m
.33085 .30827 L
s
P
p
0 1 .933 r
.01 w
.23536 .45997 m
.23536 .45997 L
s
P
p
0 1 .454 r
.01 w
.28306 .38504 m
.26372 .37166 L
s
P
p
.026 1 0 r
.01 w
.33076 .31012 m
.33076 .31012 L
s
P
p
0 1 .952 r
.01 w
.23521 .4619 m
.26707 .45494 L
s
P
p
.006 1 0 r
.01 w
.33066 .31197 m
.36285 .30448 L
s
P
p
0 1 .837 r
.01 w
.29985 .43634 m
.26787 .44337 L
s
P
p
0 1 .78 r
.01 w
.33236 .42349 m
.3002 .43057 L
s
P
p
0 1 .051 r
.01 w
.39509 .3025 m
.41362 .31638 L
s
P
p
0 1 .799 r
.01 w
.30008 .43249 m
.30008 .43249 L
s
P
p
0 1 .818 r
.01 w
.29997 .43442 m
.29997 .43442 L
s
P
p
0 1 .971 r
.01 w
.26693 .45687 m
.29903 .44986 L
s
P
p
0 1 .013 r
.01 w
.36277 .30633 m
.39522 .29878 L
s
P
p
0 1 .76 r
.01 w
.36483 .41442 m
.33245 .42157 L
s
P
p
0 1 .473 r
.01 w
.26358 .37355 m
.26358 .37355 L
s
P
p
0 1 .703 r
.01 w
.39762 .40146 m
.36507 .40867 L
s
P
p
0 1 .492 r
.01 w
.26345 .37545 m
.29563 .36813 L
s
P
p
0 1 .722 r
.01 w
.36499 .41058 m
.36499 .41058 L
s
P
p
0 1 .99 r
.01 w
.29892 .4518 m
.29892 .4518 L
s
P
p
0 1 .741 r
.01 w
.36491 .4125 m
.36491 .4125 L
s
P
p
0 1 .032 r
.01 w
.39515 .30064 m
.39515 .30064 L
s
P
p
0 .99 1 r
.01 w
.2988 .45375 m
.27939 .44069 L
s
P
p
0 1 .684 r
.01 w
.43044 .39229 m
.39768 .39955 L
s
P
p
0 1 .511 r
.01 w
.29551 .37003 m
.32795 .36266 L
s
P
p
0 1 .645 r
.01 w
.41192 .37491 m
.43053 .38845 L
s
P
p
0 1 .665 r
.01 w
.43049 .39037 m
.43049 .39037 L
s
P
p
0 .569 1 r
.01 w
.26367 .50396 m
.23139 .51084 L
s
P
p
0 .55 1 r
.01 w
.23123 .51283 m
.23123 .51283 L
s
P
p
0 .53 1 r
.01 w
.23108 .51482 m
.23108 .51482 L
s
P
p
0 1 .53 r
.01 w
.32785 .36456 m
.32785 .36456 L
s
P
p
0 .511 1 r
.01 w
.23092 .51681 m
.23092 .51681 L
s
P
p
0 .971 1 r
.01 w
.27926 .44264 m
.25957 .42941 L
s
P
p
0 1 .55 r
.01 w
.32774 .36647 m
.32774 .36647 L
s
P
p
0 .492 1 r
.01 w
.23077 .5188 m
.23077 .5188 L
s
P
p
0 1 .569 r
.01 w
.32764 .36838 m
.36036 .36097 L
s
P
p
0 .473 1 r
.01 w
.23061 .5208 m
.26298 .51393 L
s
P
p
0 .588 1 r
.01 w
.29631 .49504 m
.26381 .50197 L
s
P
p
0 1 .626 r
.01 w
.39312 .35926 m
.41198 .37299 L
s
P
p
0 .645 1 r
.01 w
.32935 .48208 m
.29667 .48908 L
s
P
p
0 .626 1 r
.01 w
.29655 .49106 m
.29655 .49106 L
s
P
p
0 .607 1 r
.01 w
.29643 .49305 m
.29643 .49305 L
s
P
p
0 1 .588 r
.01 w
.36028 .36288 m
.39325 .35542 L
s
P
p
0 .454 1 r
.01 w
.26285 .51593 m
.29547 .50902 L
s
P
p
0 .665 1 r
.01 w
.36235 .47305 m
.32945 .4801 L
s
P
p
0 .952 1 r
.01 w
.25943 .43137 m
.25943 .43137 L
s
P
p
0 .933 1 r
.01 w
.25929 .43333 m
.292 .42609 L
s
P
p
0 .722 1 r
.01 w
.39569 .45999 m
.36261 .4671 L
s
P
p
0 .703 1 r
.01 w
.36252 .46908 m
.36252 .46908 L
s
P
p
0 1 .607 r
.01 w
.39319 .35734 m
.39319 .35734 L
s
P
p
0 .684 1 r
.01 w
.36244 .47106 m
.36244 .47106 L
s
P
p
0 .435 1 r
.01 w
.29535 .51102 m
.29535 .51102 L
s
P
p
0 .415 1 r
.01 w
.29523 .51303 m
.27546 .50015 L
s
P
p
0 .741 1 r
.01 w
.42906 .45084 m
.39576 .45801 L
s
P
p
0 .914 1 r
.01 w
.29188 .42806 m
.32484 .42078 L
s
P
p
0 .78 1 r
.01 w
.41022 .4335 m
.42916 .44688 L
s
P
p
0 .76 1 r
.01 w
.42911 .44886 m
.42911 .44886 L
s
P
p
.006 0 1 r
.01 w
.25948 .56461 m
.22667 .57139 L
s
P
p
.026 0 1 r
.01 w
.22651 .57344 m
.22651 .57344 L
s
P
p
.045 0 1 r
.01 w
.22635 .57549 m
.22635 .57549 L
s
P
p
0 .895 1 r
.01 w
.32474 .42275 m
.32474 .42275 L
s
P
p
.064 0 1 r
.01 w
.22618 .57755 m
.22618 .57755 L
s
P
p
0 .875 1 r
.01 w
.32463 .42472 m
.32463 .42472 L
s
P
p
0 .396 1 r
.01 w
.27533 .50217 m
.25528 .48912 L
s
P
p
.083 0 1 r
.01 w
.22602 .57961 m
.22602 .57961 L
s
P
p
0 .856 1 r
.01 w
.32453 .42669 m
.35779 .41937 L
s
P
p
.102 0 1 r
.01 w
.22586 .58167 m
.25876 .57491 L
s
P
p
0 .013 1 r
.01 w
.29265 .55572 m
.25962 .56255 L
s
P
p
0 .799 1 r
.01 w
.39109 .41795 m
.41028 .43151 L
s
P
p
0 .07 1 r
.01 w
.32625 .54267 m
.29303 .54956 L
s
P
p
0 .051 1 r
.01 w
.2929 .55161 m
.2929 .55161 L
s
P
p
0 .032 1 r
.01 w
.29278 .55367 m
.29278 .55367 L
s
P
p
0 .837 1 r
.01 w
.3577 .42135 m
.39123 .41397 L
s
P
p
.121 0 1 r
.01 w
.25862 .57698 m
.29178 .57018 L
s
P
p
0 .089 1 r
.01 w
.3598 .53367 m
.32635 .54062 L
s
P
p
0 .377 1 r
.01 w
.25514 .49114 m
.25514 .49114 L
s
P
p
0 .358 1 r
.01 w
.25499 .49317 m
.28824 .48603 L
s
P
p
0 .147 1 r
.01 w
.3937 .52051 m
.36006 .52751 L
s
P
p
0 .128 1 r
.01 w
.35997 .52956 m
.35997 .52956 L
s
P
p
0 .818 1 r
.01 w
.39116 .41596 m
.39116 .41596 L
s
P
p
0 .109 1 r
.01 w
.35989 .53162 m
.35989 .53162 L
s
P
p
.141 0 1 r
.01 w
.29166 .57225 m
.29166 .57225 L
s
P
p
.16 0 1 r
.01 w
.29153 .57433 m
.2714 .56165 L
s
P
p
0 .166 1 r
.01 w
.42764 .51139 m
.39377 .51845 L
s
P
p
0 .339 1 r
.01 w
.28812 .48807 m
.32163 .48088 L
s
P
p
0 .204 1 r
.01 w
.40846 .4941 m
.42773 .50729 L
s
P
p
0 .185 1 r
.01 w
.42768 .50934 m
.42768 .50934 L
s
P
p
.581 0 1 r
.01 w
.25514 .62733 m
.22178 .63399 L
s
P
p
.601 0 1 r
.01 w
.22162 .63612 m
.22162 .63612 L
s
P
p
.62 0 1 r
.01 w
.22145 .63824 m
.22145 .63824 L
s
P
p
0 .319 1 r
.01 w
.32152 .48292 m
.32152 .48292 L
s
P
p
.639 0 1 r
.01 w
.22128 .64037 m
.22128 .64037 L
s
P
p
0 .3 1 r
.01 w
.32141 .48496 m
.32141 .48496 L
s
P
p
.179 0 1 r
.01 w
.27127 .56373 m
.25085 .55088 L
s
P
p
.658 0 1 r
.01 w
.22112 .6425 m
.22112 .6425 L
s
P
p
0 .281 1 r
.01 w
.3213 .487 m
.35513 .47978 L
s
P
p
.677 0 1 r
.01 w
.22095 .64464 m
.2544 .638 L
s
P
p
.562 0 1 r
.01 w
.28887 .61849 m
.25528 .62521 L
s
P
p
0 .224 1 r
.01 w
.38899 .47866 m
.40852 .49204 L
s
P
p
.505 0 1 r
.01 w
.32304 .60534 m
.28925 .61212 L
s
P
p
.524 0 1 r
.01 w
.28913 .61424 m
.28913 .61424 L
s
P
p
.543 0 1 r
.01 w
.289 .61636 m
.289 .61636 L
s
P
p
0 .262 1 r
.01 w
.35504 .48183 m
.38913 .47455 L
s
P
p
.696 0 1 r
.01 w
.25425 .64014 m
.28797 .63345 L
s
P
p
.486 0 1 r
.01 w
.35716 .59638 m
.32314 .60322 L
s
P
p
.198 0 1 r
.01 w
.2507 .55298 m
.2507 .55298 L
s
P
p
.217 0 1 r
.01 w
.25055 .55508 m
.28436 .54805 L
s
P
p
.428 0 1 r
.01 w
.39164 .58312 m
.35743 .59001 L
s
P
p
.447 0 1 r
.01 w
.35734 .59214 m
.35734 .59214 L
s
P
p
0 .243 1 r
.01 w
.38906 .4766 m
.38906 .4766 L
s
P
p
.466 0 1 r
.01 w
.35725 .59426 m
.35725 .59426 L
s
P
p
.716 0 1 r
.01 w
.28784 .6356 m
.28784 .6356 L
s
P
p
.735 0 1 r
.01 w
.28771 .63775 m
.2672 .62528 L
s
P
p
.409 0 1 r
.01 w
.42616 .57404 m
.39171 .581 L
s
P
p
.236 0 1 r
.01 w
.28422 .55015 m
.31831 .54308 L
s
P
p
.371 0 1 r
.01 w
.40664 .55681 m
.42626 .5698 L
s
P
p
.39 0 1 r
.01 w
.42621 .57192 m
.42621 .57192 L
s
P
p
1 0 .843 r
.01 w
.25065 .69225 m
.21673 .69878 L
s
P
p
1 0 .824 r
.01 w
.21656 .70098 m
.21656 .70098 L
s
P
p
1 0 .805 r
.01 w
.21638 .70318 m
.21638 .70318 L
s
P
p
.256 0 1 r
.01 w
.3182 .54519 m
.3182 .54519 L
s
P
p
1 0 .786 r
.01 w
.21621 .70538 m
.21621 .70538 L
s
P
p
.275 0 1 r
.01 w
.31808 .5473 m
.31808 .5473 L
s
P
p
.754 0 1 r
.01 w
.26706 .62744 m
.24625 .61482 L
s
P
p
1 0 .767 r
.01 w
.21604 .70759 m
.21604 .70759 L
s
P
p
.294 0 1 r
.01 w
.31797 .54942 m
.35237 .5423 L
s
P
p
1 0 .748 r
.01 w
.21587 .7098 m
.24988 .70329 L
s
P
p
1 0 .863 r
.01 w
.28495 .68346 m
.2508 .69005 L
s
P
p
.351 0 1 r
.01 w
.38681 .54151 m
.4067 .55469 L
s
P
p
1 0 .92 r
.01 w
.31971 .67021 m
.28535 .67686 L
s
P
p
1 0 .901 r
.01 w
.28522 .67906 m
.28522 .67906 L
s
P
p
1 0 .882 r
.01 w
.28509 .68126 m
.28509 .68126 L
s
P
p
.313 0 1 r
.01 w
.35228 .54442 m
.38696 .53725 L
s
P
p
1 0 .728 r
.01 w
.24973 .7055 m
.28402 .69895 L
s
P
p
1 0 .939 r
.01 w
.35442 .6613 m
.31982 .66801 L
s
P
p
.773 0 1 r
.01 w
.2461 .61699 m
.2461 .61699 L
s
P
p
.792 0 1 r
.01 w
.24594 .61916 m
.28033 .61225 L
s
P
p
1 0 .997 r
.01 w
.3895 .64794 m
.3547 .65471 L
s
P
p
1 0 .978 r
.01 w
.35461 .65691 m
.35461 .65691 L
s
P
p
.332 0 1 r
.01 w
.38689 .53938 m
.38689 .53938 L
s
P
p
1 0 .958 r
.01 w
.35452 .6591 m
.35452 .6591 L
s
P
p
1 0 .709 r
.01 w
.28389 .70117 m
.28389 .70117 L
s
P
p
1 0 .69 r
.01 w
.28375 .70339 m
.26286 .69118 L
s
P
p
.984 0 1 r
.01 w
.42463 .63891 m
.38958 .64574 L
s
P
p
.812 0 1 r
.01 w
.2802 .61443 m
.31487 .60748 L
s
P
p
.946 0 1 r
.01 w
.40475 .62176 m
.42473 .63452 L
s
P
p
.965 0 1 r
.01 w
.42468 .63672 m
.42468 .63672 L
s
P
p
1 0 .268 r
.01 w
.24599 .75946 m
.21149 .76585 L
s
P
p
1 0 .249 r
.01 w
.21132 .76813 m
.21132 .76813 L
s
P
p
1 0 .23 r
.01 w
.21114 .77041 m
.21114 .77041 L
s
P
p
.831 0 1 r
.01 w
.31475 .60966 m
.31475 .60966 L
s
P
p
1 0 .211 r
.01 w
.21096 .77269 m
.21096 .77269 L
s
P
p
.85 0 1 r
.01 w
.31463 .61185 m
.31463 .61185 L
s
P
p
1 0 .671 r
.01 w
.26271 .69341 m
.2415 .68103 L
s
P
p
1 0 .192 r
.01 w
.21078 .77498 m
.21078 .77498 L
s
P
p
.869 0 1 r
.01 w
.31452 .61404 m
.34952 .60705 L
s
P
p
1 0 .173 r
.01 w
.2106 .77727 m
.2452 .7709 L
s
P
p
1 0 .288 r
.01 w
.2809 .75074 m
.24615 .75718 L
s
P
p
.927 0 1 r
.01 w
.38456 .60661 m
.40481 .61956 L
s
P
p
1 0 .345 r
.01 w
.31627 .73739 m
.28131 .7439 L
s
P
p
1 0 .326 r
.01 w
.28117 .74618 m
.28117 .74618 L
s
P
p
1 0 .307 r
.01 w
.28104 .74846 m
.28104 .74846 L
s
P
p
.888 0 1 r
.01 w
.34942 .60924 m
.38471 .6022 L
s
P
p
1 0 .153 r
.01 w
.24504 .77319 m
.27993 .76678 L
s
P
p
1 0 .364 r
.01 w
.35159 .72855 m
.31638 .73512 L
s
P
p
1 0 .652 r
.01 w
.24134 .68328 m
.24134 .68328 L
s
P
p
1 0 .633 r
.01 w
.24118 .68553 m
.27616 .67876 L
s
P
p
1 0 .422 r
.01 w
.38729 .71509 m
.35188 .72172 L
s
P
p
1 0 .403 r
.01 w
.35178 .72399 m
.35178 .72399 L
s
P
p
.907 0 1 r
.01 w
.38464 .6044 m
.38464 .6044 L
s
P
p
1 0 .383 r
.01 w
.35169 .72627 m
.35169 .72627 L
s
P
p
1 0 .134 r
.01 w
.27979 .76909 m
.27979 .76909 L
s
P
p
1 0 .115 r
.01 w
.27965 .77139 m
.25835 .75945 L
s
P
p
1 0 .441 r
.01 w
.42304 .70612 m
.38737 .71281 L
s
P
p
1 0 .613 r
.01 w
.27602 .68102 m
.3113 .6742 L
s
P
p
1 0 .479 r
.01 w
.4028 .68906 m
.42315 .70156 L
s
P
p
1 0 .46 r
.01 w
.4231 .70384 m
.4231 .70384 L
s
P
p
1 0 .594 r
.01 w
.31118 .67646 m
.31118 .67646 L
s
P
p
1 0 .575 r
.01 w
.31106 .67873 m
.31106 .67873 L
s
P
p
1 0 .096 r
.01 w
.2582 .76176 m
.23657 .74965 L
s
P
p
1 0 .556 r
.01 w
.31094 .681 m
.34656 .67414 L
s
P
p
1 0 .498 r
.01 w
.38222 .67408 m
.40286 .68678 L
s
P
p
1 0 .537 r
.01 w
.34646 .67642 m
.38238 .66951 L
s
P
p
1 0 .077 r
.01 w
.2364 .75198 m
.2364 .75198 L
s
P
p
1 0 .058 r
.01 w
.23624 .75432 m
.27184 .74769 L
s
P
p
1 0 .518 r
.01 w
.3823 .6718 m
.3823 .6718 L
s
P
p
1 0 .038 r
.01 w
.2717 .75003 m
.30761 .74336 L
s
P
p
1 0 .019 r
.01 w
.30748 .74571 m
.30748 .74571 L
s
P
p
.002 w
.63789 .02388 m
.8925 .2597 L
s
.8925 .2597 m
.96325 .88461 L
s
.96325 .88461 m
.66428 .68137 L
s
.66428 .68137 m
.63789 .02388 L
s
.11501 .15763 m
.03675 .79766 L
s
.03675 .79766 m
.66428 .68137 L
s
.66428 .68137 m
.63789 .02388 L
s
.63789 .02388 m
.11501 .15763 L
s
P
p
p
.002 w
.11501 .15763 m
.63789 .02388 L
s
P
p
.002 w
.23273 .12752 m
.23867 .13207 L
s
P
[(5)] .22085 .11841 .84775 1 Mshowa
p
.002 w
.38436 .08873 m
.39006 .09342 L
s
P
[(10)] .37295 .07937 .79157 1 Mshowa
p
.002 w
.54119 .04862 m
.54663 .05343 L
s
P
[(15)] .5303 .039 .73538 1 Mshowa
p
.001 w
.26265 .11987 m
.26619 .12261 L
s
P
p
.001 w
.29278 .11216 m
.29628 .11492 L
s
P
p
.001 w
.3231 .1044 m
.32658 .10718 L
s
P
p
.001 w
.35363 .0966 m
.35708 .09939 L
s
P
p
.001 w
.4153 .08082 m
.41869 .08364 L
s
P
p
.001 w
.44645 .07285 m
.44981 .07569 L
s
P
p
.001 w
.47781 .06483 m
.48114 .06768 L
s
P
p
.001 w
.50939 .05675 m
.51269 .05962 L
s
P
p
.001 w
.20301 .13512 m
.2066 .13784 L
s
P
p
.001 w
.17348 .14268 m
.1771 .14538 L
s
P
p
.001 w
.14415 .15018 m
.14779 .15287 L
s
P
p
.001 w
.5732 .04043 m
.57643 .04333 L
s
P
p
.001 w
.60543 .03219 m
.60863 .0351 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30024 .03665 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004T0
0ol300;o0`03o`800ol20003o`0003000ol300?oP00004P000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<@000ol000050003o`0007d0001<0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<@000ol000050003o`0007d0001900?o0P001_l00?l0o`8000Ko003o0?l20003o`000340
00?o00000P03oa/01?mQ0000B0000ol0000400;o0P001Ol00?l000Ko=0000ol000020003o`0001L0
1?l20003o`3o060000180005o`000?l030000ol0o`0e00;o1004oa801?l60004o`00oel0001900?o
3`000ol0001;00Co0P000ol0000300Co0P000ol0001L0000Y@04o`P01Ol00h7ob`04oed0002R00?o
0P000ol0000300Oo0h401?n1^ol20003o`0005X0002N00Co1`08o`>100?oPH401Ol20003o`0005T0
002J00Go1P08o`R10ol3P@;o0P000ol0001H0000IP03o`@00_lW00Co1@000ol00006o`B100?oPH40
1?l01K_;^l_o00B10_l00`3oo`1I0000I`000ol000020004o`00ob801?l800Ko2H42o`Rk00?oPH40
0h42o`8000?o0000EP0006L000?o00000P001?l00?lN00Co10001?l00006o`>100?oPH401Ol03[_;
^l^kbk_;^l^kboo;0h44o`800_mF0000I`000ol000020004o`00oaX01?l800Go2H42oa6k00?o^k/0
0_l3P@;o0`000ol0000700?oB@0006L000?o00000P001?l00?lF00Co0`000ol0000200Go0h400on1
P@05o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kb`05P@;o00@0oooo2`000ol000160000IP02o`D0
0_lC00Co2005o`R10_lJ^`03ok^k00:k1H42o`<000?o000020000ol000160000O`03o`<000?o0000
0P05o`>100?oPH401?l09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`>11?l30003
o`0000@00om90000N`04o`L01Ol8P@;o8k/01?nk^k/4o`B100Go0000o`050003o`0004T0001g00Co
0P000ol0000200Oo1X43o`0Vbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`>1
00?oPH400h42o`:100?o00000P04odP0001c00Co2007o`>100?oPH400olU^`Go1h400on1P@03P@;o
0P000ol0001=0000@`03obT01?l00`3oP@0500Oo2842o`0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/01Ol3P@;o28401?n1PH44o`8000?o0000C00004H000?o00008P04o`H000?oPOl0
1_l3P@03oh6100Co3[/3oa:k1?l9P@03oh6100N10ol3P@;o0P000ol0001;0000AP000ol0000N00Ko
1P07o`R10_l03L^kbk_;^l^kbk_;^l/01Ol3F`0=ol^kbk_;^l^kbk_;^`05o`>100?oPH401h42o`:1
1?l01<^kbk/5P@;o00<0ool0C00004<00olM00Co2006o`B100?oPH401?l4P@03ok^k00Rk0_l9F`03
ok^k00Nk0_l9P@03oh6100J100CoPOoo2K/5P@;o0P02odX000130003o`0001T01_l600Ko2H42o`V1
00gobk_;^l^kbk_;^l_o00UK00cobk_;^l^kbk_;^ol9P@03oh6100Ko00fkbk_;^l^kbk_;^l^k00>1
1?l30003o`0004L0001300Co5@03o`P01_l3P@03oh6100Go0k/00on1P@08P@03ok^k00Vk00?oFe/0
1e/2o`Vk00?oPH401h42o`Fk00?o^k/03;/2o`B100Go0000o`0V00Go00D0oooo0003o`<00_l@0000
F005o`H01_l8P@;o00Zkbk_;^l^kbk_o2X403Oo;^l^kbk_;^l^kbol00U/4o`AK00_o^l^kbk_;^l^k
o`02P@Co18405_o;^l^kok_;^l^kbk_;^l^kbk_;^l/5P@03o`3o00;o9@000ol000020004o`00o`@0
00Co003o4@0005@01?l700Ko0h400on1P@04o`jk00?oPH401Ol?^`;o2E/00onk^`07^`;o2H401Onk
^k_o016k0h400on1o`030003o`00028000?o00000`03o`800_l30003o`0000l0001@00Go1`05o`R1
0_l04K_;^l^kbk_;^l^kbk_;^l^k00Co01K;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2U/02onkbk_;^l^k
bk_o00Z101Kobk_o^l^kbk_;^l^kbk_;^l^kbk_;0_l3P@05o`000?l08`05o`<000?o0?l01@000ol0
000?0000C004o`P01Ol3P@03oh6100Co4K/4o`AK0_l7^`Co2K/00omKF`08F`03ok^k00Nk00?oPH40
28400onko`0C^`F100Go0000o`0R0003o`0000<00_l300?o00@0oooo400004P01?l00h40000500Co
2H42o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l:F`03ok_;00Co18402oo;^l^kbk_;^l_o009K1Ol3F`0;
ok_;^l^kbk_;^ol00X45o`>10_l05;_;^l^kbk_;^l^kbk_;^l^kbk_;1H400ol0o`02ob4000?o0000
3@000ol0000?0000A004o`@000CoP@001?l4P@03oh6100Co4K/4o`AK0_l9F`;o2H400onk^`07^`;o
2E/00onk^`07^`;o2H400onk^`0C^`>11?l20003o`0001h01OlM0000@004o`P01?l9P@;o01>kbk_;
^l^kbk_;^l^kbk_;^l^k00;o2U/00omKF`04o`05^l^kbol02H403?o;^l^kbk_;^l^ko`UK00co^l^k
bk_;^l^kbol8P@;o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l3P@;o0P000ol0000800?o1002obh0
000l00Co10001?l00004o`B100?oPH401?lI^`03oe]K00QK0_l9^`03oh6100N100?o^k/02;/00omK
F`07F`03ok^k00Rk00?oPH401H401?n1oolD^`F10_l200;o2@000ol000020004o`00obd0000i00?o
2004o`V10_l04K_;^l^kbk_;^l^kbk_;^l^k00Co00[;^l^kbk_;^l_o1E/3o`0>bk_;^l^kbk_;^l^k
bol2P@Co0h403?o;^l^kbk_;^l^ko`9K1?l03k_;^l^kbk_;^l^kbk_;o`02P@Go0h405Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`05P@?o0P000ol000060003o`00008000Co003o;@0003D01?l30004o`0000Co
18400on1P@04oa6k1?l4F`03ok^k00Nk00?oFol00_l?^`Co28400onk^`08^`;o4k/2o`B100?oPH40
0X400onk^`0B^`>11?l30003o`0000D000?o00000P001?l00?l]0000<@04o`L01?l9P@;o016kbk_;
^l^kbk_;^l^kbk_;^`04o`UK01Sobk_;^l^kbk_;ol^kbk_;^l^kbk_;^l/5o`>100?oPH401h408_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol3P@03oh6100>101Go^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l4P@05o`000?l01P000ol000020004o`00obd0000]00Co0`001?l00004o`B100?oPH40
1?lA^`Co0e/00omKF`08F`03ok^k012k1?l9P@03oh6100N100?o^k/07[/00on1P@04o`>100?o^k/0
4[/6P@05oh61POl01002o`D00_l^0000:`02o`L01?l9P@;o01>kbk_;^l^kbk_;^l^kbk_;^l^k00;o
25/00omKF`08F`0>ol^kbk_;^l^kbk_;^l/4o`B100?oPH401h400on1P@04o`0Tbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol7P@0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00J100Go0000
o`0j0000:`000ol0o`0300?o18400on1P@04oaRk00?oFe/01e/00omKF`05o`bk1?l9P@03oh6100N1
0_lA^`Co5;/2o`R100?o^k/04[/4P@?o0`000ol0000g0000:`000ol0o`03o`R10_l07[_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`UK0_l03L^kbk_;^l^kbk_;^l/01?l4P@03oh6100N100?oPH40
1?l04L^kbk_;^l^kbk_;^l^kbk_;00Co15/05_o;^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@;o01?;^l^k
bk_;^l^kbk_;^l^kbk_;00?o0h401Ol0003o03P0000[00;o0h400on1P@04ob:k00?oFe/01?l=^`Co
2H400on1P@07P@;o4k/2o`UK00?o^k/04[/00on1P@04o`B100?o^k/04[/5P@Go=`0002800_l700;o
1842o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o00g;^l^kbk_;^l^k
bk_;00Co18400on1P@07P@03oh6100Co01[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`UK01?obk_;
^l^kbk_;^l^kbk_;^l^k00Co2H405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`04P@03oh7o008000?o0000
=000024000Co003o1@000ol00002o`B100?o^k/0<K/2o`V100?oPH401h42oajk00?oFe/01?lA^`Co
00B1oh7o2X400onk^`0B^`?o0h401?l00?le00008@001?l00?l50003o`00008000?oPH400X40=_nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`V100?oPH40
1?l3P@0Pol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0A^l^kbk_;^l^kbk_;^l^kbk/0
1?l5P@04oh61o`Z101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/01X400ol00002oc<0000Q0004o`00o`D0
00?o00000`000on1P@02P@03ok^k02Fk1?l9^`03oh6100N10_l8P@03ok^k02^k1?l3P@03oh6100>1
00GoPH61o`02P@Go6;/5P@?o0P000ol0000`00008@001?l00?l50003o`0000@000?oPH400X42o`0Q
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co15/02oo;^l^kbk_;^l_o00:11?l4P@03
oh6100J101Cobk_;^l^kbk_;^l^kbk_;^l^kb`?o01;;^l^kbk_;^l^kbk_;^l^kbk/4o`R100?oPH40
0X400on1P@02P@;o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3P@Co0`000ol0000_0000
8P02o`H000?o00001@02o`B10_lM^`;o2E/00onk^`07^`;o2H400on1P@02P@;o0X400onk^`0<^`Co
0e/00onk^`0;^`Co0h400on1P@07P@03oh6100Co8K/4o`>10_l30003o`0002h0000Z0003o`0000L0
00?oPH400h408?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2E/03?o;^l^kbk_;^l^ko`V1
1?l04L^kbk_;^l^kbk_;^l^kbk_;00;o25/02oo;^l^kbk_;^l^k00;o28400on1P@07P@;o027;ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l3F`03oh6100:10_l0103oool_0000:P000ol0
00080003oh6100>10_lM^`03oe]K00MK0_l9^`03oh6100Co6;/00omKF`07F`03ok^k00Vk00?oPH40
1X400on1P@04o`Fk00?o^k/06K/4o`QK00?oPH400X42o`<000?o0000;00002X00_l;00;o18407oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00U/4o`AK0_l02<^kbk_;^l^k0_l04L^kbk_;^l^k
bk_;^l^kbk_;00?o00[;^l^kbk_;^l_o2E/03Oo;^l^kbk_;^l^kbol01842o`:10_l08L^kbk_;^l^k
boo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`=K00?oFe/01e/00on1P@04o`<000?o00001`03o`<0
0olK0000:@000ol0000=0003oh6100:100?o^k/06k/2o`YK00?o^k/05;/4o`>100?o^k/01k/00omK
F`04o`nk1?l6P@03ok^k00Jk00?o^k/04K/4o`QK00?oFe/01e/2o`B100Go0000o`090003o`0000D0
00?o0000600002T000?o00003P000on1P@02P@0Ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`02o`UK01;obk_;^l^kbk_;^l^kbk_;^l/4o`R100[obk_;^l^kbk_;0_l05K_;^l^kbk_;^l^kbk_;
^l^kbk_;o`09P@0Hol^kbk_;^l_obk_;^l^kbk_;^l^kbk_;1?l4F`03oe]K00IK00?oFe/01?l4F`03
oh6100:11Ol80003o`0000D000?o0000600002T000?o00003`000on1P@02P@;o7[/00omKF`04oa2k
1?l3P@03oh6100N100?o^k/07K/00on1P@07P@03ok^k00Bk00?o^k/02K/4o`UK00?oFe/00U/2o`9K
0_l9F`06oh61oh7o0`000ol000050003o`0000800olK0000:@000ol0000@00;o1842o`0Mbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l04[_;^l^kbk_;^l^kbk_;^l^kb`;o28400on1P@07P@;o
01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:11?l3P@0=ol^kbk_;ol^kbk_;^`05o`AK
00?oFe/01e/4o`07^l^kbk_;o`09F`;o0h401?l00002o`D000?o00000P000ol0000K0000:@000ol0
000A0003oh6100B100?o^k/0<;/2o`N100?oPH401?l4P@;o6k/4o`R100?o^k/00[/00onk^`04o`YK
00?oFe/01?l=^`03oe]K00Co0e/00on1P@02P@03o`2100:100Co00000_l400Co6P0002T000?o0000
4P000on1P@04P@0eol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbol018400on1P@02o`Z101Oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`AK00?oPH401X400oo;
^`04o`AK00?oFe/025/2o`0@^l^kbk_;^l^kbk_;^l^kb`Co25/00on1P@02P@;o0`000ol0000T0000
:@000ol0000C0004P@3oo`>100?o^k/0<K/4o`F10_l9P@03ok^k016k0_l9F`03oh6100:10_l2P@;o
00=Koe/01U/00omKF`05oa2k1?l3F`03oe]K00MK00?oPH401?l30003o`0002<0000Y0003o`000180
00F10000o`04P@0eol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbol02H400on1P@04o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`09F`Co1X42o`QK0_l04L^k
bk_;^l^kbk_;^l^kbk_;00Co25/00omKF`07F`;o18400ol00002ob@0000X00?o4`000h4000020003
oh6100:100?o^k/09K/3o`Vk00?oPH401h42oafk00?oFe/01?l3^`03oh6100N100?oFe/01?l3F`03
ok^k00:k0aL6^`Co15/00omKF`06F`03oe]K00Co1;/5P@;o0P000ol0000Q0000:0000ol0000C0003
P@0000@000CoPH610_l08K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`=K00_obk_;
^l^kbk_;o`02P@Co0h407oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l02L^kbk_;^l^k
o`08P@?o25/01?nkbk/45`03bk_;00;o2E/00omKF`02F`;o0U/2o`09^l^kbk_;^l^k00>100?oPOl0
0`000ol0000P0000:0000ol0000C0003P@0000D00_l3P@;o7K/2o`QK00?o^k/01k/2o`R100?o^k/0
9[/00on1P@04o`04^onko`UK00Co^k/G0Q400elG^`02^`03oe]K00QK1?l@^`;o0h401Ol0003o0240
000X0003o`0001<000>100001P000on1P@03P@0Ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
o`09F`0<ol^kbk_;^l^kbk_o2840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00;o00W;^l^kboo;^ol02E/2o`HG00AO^l_o0U/5o`9K01Cobk_;^l^kbk_;^l^kbk_;^l^kb`J1
00?o0?l00_lP0000:0000ol0000C0003P@0000L000?oPH400h42oabk00?oFe/01e/2o`Vk00?oPH40
0X42o`:10_l]^`05ok^k^ol00U/4o`AK00?o^a400Q400elG5`02^`;o25/00onk^`0A^`J100Go0000
o`0O0000:0000ol0000C0003P@0000T00_l4P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
0U/4o`AK0_l02<^kbk_;^l^k1?l6P@;o033;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;ol^kbk/2o`UK00?obaL00QL00elGG`02G`03oe]K00MK01Cobk_;^l^kbk_;^l^kbk_;
^l^kb`B10ol30003o`0001`0000X0003o`0001<000>100002`000on1P@02P@03ok^k01Zk0_l:F`03
ok^k00Nk00?oPH401h400onk^`0X^`03ok^k00Bk00?oFe/01e/2o`<A0aL2G`03oe]K00MK0_lB^`?o
0h400ol0o`02oad0000X0003o`0001<000>1000030000on1P@02P@0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0_l9F`0;ol^kbk_;^l^kbol02H42o`0a^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_o^l^kbk_;o`02F`Co15/02QLA5a5O5elOGol2F`Co15/05?nkbk_;^l^k
bk_;^l^kbk_;^l^k1H401?l00?lM0000:0000ol0000C0003P@0000d000?oPH400X42oafk00?oFe/0
1?l=^`03oh6100Co18400onk^`0V^`03ok^k00>k1?l9F`04oa4A4@:k0el00aooF`08F`03ok^k016k
0h401On1o`3o01d0000W00?o4`000h40000?00;o18407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/4o`0B^l^kbk_;^l^kbk_;^l^kbk_;0_l9P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^onk1?l4F`03oe]K00MK00?o4AL00Q400k]O7`02G`03oe]K00MK0_l04/^kbk_;^l^k
bk_;^l^kbk_;^`;o00?;^l/00_lM00009`000ol0000C0003P@00014000?oPH400X400onk^`0D^`Co
15/00onk^`0A^`03oh6100N100?o^k/08[/4o`UK00?oFe/01?l4^`034ALA00>k00HOGalOGe/4o`AK
00?o^k/02K/4o`F10k/00ol0000K00009`000ol0000C0003P@0001<000CoPH610_l04;_;^l^kbk_;
^l^kbk_;^l/4o`UK01Go^l^kbk_;^l^kbk_;^l^kbk_;^ol00X44o`>1027o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00ol2F`03oe_o00UK0_l03l^kbk_;^l^k4ALA^l^kb`04G`037e]K00MK
00Gobk_;^`06o`F11Ol30003o`0001X0000W0003o`0001<000>100005002o`>10_l;^`?o15/2o`QK
00?o^k/04K/2o`R100?o^k/05k/6o`EK00CoFe_o0U/4o`bk00@G4ALA1?l01AmOGamO00UK1?l4P@Oo
20000ol0000J00009`000ol0000C0003P@0001D000?oPH400h402Oo;^l^kbk_;^`02o`UK00?oFe/0
0ol06K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol028405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`04o`IK
00?oFe/00U/01?mKFe/2o`0@bk_;^l^kbk_;^l^kbk_;^`;o00<A5a401U/00amO7`02F`Co2H44o``0
00?o00006P0002L000?o00004`000h40000F0003oh6100>100?o^k/01k/00omKF`07F`;o7;/00on1
P@02P@;o0X42oa>k00?oFe/01e/00omKF`03oa2k1?l3F`034ALA00IK00AO7aoo1X46oa4000?o0000
6P0002L000?o00004`000h40000F0004P@3oo`>100_obk_;^l^kbk_;o`02F`Co027;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l6P@08ol^kbk_;^l/4o`09^l^kbk_;^l_o00UK0_l03K_o
^l^kbk_;^l^kbk/01_l8F`044ALAF`Co00>1Gel00el3P@?o5@000ol0000J00009`000ol0000C0003
P@0001H000B1003o18400onk^`07^`;o9k/00on1P@06P@03ok^k00Co15/00onk^`06^`03oe]K00Co
1K/00onk^`03^`Ko1U/00omKF`06F`044ALAP@EO11l00ol0P@0H0003o`0001X0000V0003o`0001@0
00>100005P001H40003o00B101Cobk_;^l^kbk_;^l^kbk_;^l^kb`;L01k/g;_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol8P@;o2E/02Onkbk_;^l^kb`02o`0<^l^kbk_;^l^kok_;0ol3F`03oe]K00MK
11l01EooGamO00<A00HG7aLO5ol2G`<000>100005P000ol0000J00009P000ol0000D0003P@0001D0
00>1000010001?n1PH42o`Vk3M`K^`03oh6100?o15/00omKF`07F`03ok^k012k0ol7F`04oamO7`9O
00DOGamO7`08G`044ALA4@T000>100005P000ol0000J00009P02oa@000>100005P000h40000500;o
0h43g003UMcL00cL00?;g=`00m`05/^kbk_;^l^kbk_;^l^kbk_;^l^kbk/6o`QK00?oFe/01?l06;_;
^l^kbk_;^l^kbk_;^l^kbk_;^onkb`@O00EO7elOG`087`08oelOGamOPOl200<A2P000h40000E0003
o`0001X0000V0003o`0001<000>100005P0018400005U@06g9GLUMbE2=`01;_Lg=`7^`04g>cLk16k
1?l6F`03oe]K00IK0_lI^`03oalO00<O00YO7elOGaooGamO0h44o`P000>O4@002@000h40000F0003
o`0001T0000V0003o`0001<000>100004P02U@03gMcL00gL01:1g=cL^l^kbk_;^l^kbk_;^l/4o`?L
01;;^l^kbk_;^l^kbk_;^l^kbol9F`03oe]K00?o18405oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k008O
00Co7alO0_l00amO7`03P@Oo30000a6O4@090003P@0001H000?o00006@0002H000?o00004`000h40
000:0009g9GLUMbEg9GL00RE00@0UMbE0`02o`B100?o^k/01k/4o`EK00?/g>`01K/4o`Rk00?oFe/0
1e/2o`R100?o^k/04k/27`?o1H400on1P@03oa800a480003P@0001H000?o00006@0002H000?o0000
4`001X40002EgA2E00@0g=cL3@000on1P@02P@0;ok_;^l^kbk_;^ol01e/01Mc/g>c;00?o15/02_nk
bk_;^l^kbol2F`Co00G;^l^ko`08P@0Bol^kbk_;^l^kbk_;^l^kbk_;1?l00h7oP@03P@Go5`00116O
4Il60003P@0001H000?o00006@0002H000?o00003`000mfEg@08U@0;g9GLUMbEg03LUM`01`000h40
000=0004oh61P@;o2;/00omKF`06F`03k=c/00QK00?o^k/01[/2o`Vk00?oPH400ol3P@03ok^k00Zk
1?l5P@05oh61POl07@034@03W`0000<000>100005P000ol0000I00009@000ol0000:000@UG6EgIGM
UMfEgIGMUMfE00>E40000h40000>00;o0h42o`08^l^kbk_;^ol2F`Co0U/00ncLk008F`0Dok_;^l^k
bk_;^l^kbk_;^l^kbk/2o`N100Sobk_;^l^kb`Co1X44o`030840020000>O4Il010000h40000F0003
o`0001T0000U0003o`0000X000SMUMfEgIGM00>E60000h40000?0003oh6100>100?o^k/01K/2o`MK
00?/g>`00U/3oaRk00?oPH401H400onk^`04o`:11?l3P@07o`000?l0P@0R0003Wa6O00<000>10000
5P000ol0000I00009@000ol0000:0005UMfEgID00md20003P@0001H000>1000040000on1P@03P@;o
00S;^l^kbk_;o`EK00C/g;OL0_l07K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00B100?oPH40
0_l5P@?o2@000ol0P@0Q0003WmnO00:O0P000h40000F0003o`0001T0000U00?o3P03L@04UG7MPAP0
00>100004P02o`B100?o^k/01K/02Mc/g>cLk=c/g00M^`Ko1845o`d000?o08407@09W`8000>10000
5P000ol0000I00009@000on1000?0007gIGMgG7ML@0G0003P@0001<000?oPH400h40:Oo;^mc/g>cL
k=c/g>c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2H400ol0000@0003o`2101T00il01]nO
gioOW`H000>100005`000ol0000H00005@03o`@00_l70003o`2101<000?MLMd00W4E0003P@0001@0
00goPH61g>cLk=c/g>cL01fk1?l6P@Co5P000ol0P@0E0005gioOWml019l:0003P@0001L000?o0000
600001H000?o00000P001?l00?l60003o`0000:14@001h40LMeagG404`000h40000D0003P@3L00;L
02;/g>cL^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol3P@?o0h400ol0000H0003o`2101<0
00>Ogil019l?0003P@0001H000?o0000600001H000?o00000P001?l00?l60003o`00008000>10000
3P0018400006L@l000>100005@001H40k>cL00:10kH00obk^`0D^`Ko1H43ob0000?oP@004P000ioO
g`0C0003P@0001H000?o0000600001H000?o00000P001?l00?l50003o`0000@00X4>0003P@0000<0
00IagG5agW4=0003P@0001<03[H03l^kbk_;^l^kbk_;^l^kb`06o`B11Ol00`21000R0003o`2100h0
1YlD0003P@0001H000?o0000600001H000?o00000P001?l00?l50003o`0000H000>100002`000h40
000400Ia30000h40000:00>g0[H01KNf]kJg00Vf00>1][H00[H;^`?o2H42o`D000>100008@000ol0
P@0:000:WmnOgioOWmnOga@000>100005P000ol0000H00005@02o`D00_l60003o`0000L00X4;0003
P@0000P000AagW5a2P001h40002g][L00[H01KNf]kJg00Vf00Bg][Jf1@003?n1PKKl]/^kbk_;^`Co
1X43o`X000>100008@000ol0P@080003WmnO00BO6@000h40000F0003o`0001P0000T0003o`0000T0
00>1000020000h40000900=a00?NL@001@000kNf]P05]PRg00KL][Nf]n`40003P@0000H000?oPH40
0kH00k_oo`02o`:11?l2P@;o3@000h40000Q0003o`2100@000ROgioOWmnOga`000>100005P000ol0
000H000090000ol0000:00:120000h40000;00Ia0`003;Nf]kJg][L0][Nfg0K/20000h40000800;o
00Bfo;Kl1843oa<000>100008@000ol0P@020007Wa7OgioOW`0O0003P@0001H000?o0000600002@0
00?o000030000h4000050003P@0000d000MagW5agW4000Bf00>g00000P001NcLg>cL00`000>10000
2@001_nk][Kl]P;o5`000h40000Q0003o`2100FO8`000h40000G0003o`0001L0000T00;o3P02P@@0
00>100003`03L@03gW7N008000>1]kL00kL00ncLk002k0`000>100002`02o`040?clo1P000>10000
80002=oogioOWmnO90000h40000G0003o`0001L0000T0003o`0000l000F10000P@0E0008LMiag]c/
]kH2]`03]^`000h000>100002`001ol0002fo;H05`000h40000600?O4`05W`04oinOWbL000>10000
5`000ol0000G00008`000ol0000A00:100<0P@005@001]k/k>cLk0Fg3`000h40000;0003o`000080
0o`F0003P@0000@000?Og]l01=l>00KO00FOgol0P@0X0003P@0001L000?o00005`0002<000?o0000
4`02PA<000SLk=c/g>cLk0?N00D0][Nf]`0=0003P@0000/000Ko0000]KH2o1H000B100002ml;0003
WmnO00>O10000ol0P@0X0003P@0001L000?o00005`0002<000?o00005002PA0000?/g>`00n`5]`03
k;O/00Bg3@000h40000:0009o;Kl]_bfo;Kl01H00]l01]kOg]oNg`D01=l70003WmoO00;O1`000ol0
P@0Y0003P@0001H000?o00005`0002<000?o000050000h40P@0?00S/1kL00g6f]`0=0003P@0000H0
0kH01kFf]KJe][D05@001]oNgmkOgP?O2@04g`8000SOWmnOgioOW`P000?o0840:@000h40000F0003
o`0001L0000S0003o`0001@000>100000X4<00Rg00@0]nbg0P000g7NL@02gPd000n10000][Ff]KJe
]_bfo?l05`000mkOg`04g`l01=l01IoOWmnO00/000?o0840:@000h40000F0003o`0001L0000S0003
o`0001@000>100000P000h40000900?/1@000h4000040004gW7NL@;N00=agP0020000h40]P07]P@0
00?o00004`001MkOgmkO00<000>100003P04g`l000?o0840:@000h40000F0003o`0001L0000S0003
o`0001@000>100000`02PA4000>100001`07gPL000F10;Je]P090003o`0000l000SNgmkOg]oNg`@0
00>100003`02ga0000?o0840:@000h40000G0003o`0001H0000S0003o`0001@000>100001@000h40
000>0003P@0000P000?NLMh01=h60004]Ocl]@<00/`00l3<00020003o`0000d000ONgmkOg]oN00L0
00>100008@000ol0P@0Y0003P@0001L000?o00005P0002800olD0003P@0000L00X4>0003P@0000T0
00GN3L`=c002gP03]KJe00@=00[<3L`=c0g<3L3<0P000ol0000900CO00?Ngmh02`000h40000Q0003
o`2102T000>100005`000ol0000F00008P000ol0000D0003P@0000T000>100002`000h4000050006
3L`=c0g<0Pd@c00300d=00<=00?o00001@0:gP`000>100008@000ol0P@0Y0003P@0001L000?o0000
5P00028000?o000050000h40000:00:12`000h400002000:3L`=c0g<3L`=o0P=00CNc0g<2004c0L0
00?Ngml00]lA0003P@00024000?o0840:@000h40000G0003o`0001H0000R0003o`0001@000>10000
30000h400006000;3L`=c0g<3L`=c0d01[D3c0801Mh00ml0000900<=0P04g`;N50000h40000Q0003
o`2102T000>100005`000ol0000F00008P000ol0000D0003P@0000d00X460008c0g<3L`=c0d30003
]@fe00T00]h0103Og]l2gPP000_oc<`=g]oNgmkOgP0D0003P@00024000?o0840:@000h40000G0003
o`0001H0000R0003o`0001@000>100003`000h40000300033L`=00<=0`0010fe]KD=0003PMoN00;O
00?Ng`001002g`053L`=c0d06@000h40000Q0003o`2102T000>100005`000ol0000F00008P000ol0
000D0003P@0001000X450005P@3<3L`00Pd01;D=]@d=0003P@3O00GN00<0g]h01Mh010g<3L`H0003
P@00024000?o0840:P000h40000D00:100?o00005P00028000?o000050000h40000B0004P@003@:e
00<=]@d010d@0003P@0000<000?Og]l01=l00ol0000200033L`=01L000>100008@000ol0P@0Z0003
P@0000l01H430003o`0001D0000R0003o`0001@000>100004007]@033KD=00801@d>0003P@0000@0
0mh30003o`0000<00l`F0003P@00028000?o0840:@000h40000:00F120000ol0000E00008@000ol0
000E0003P@0000h000^e3@d=]@fe3@2100093@d000>100002P002Ol0c0g<3L`=c00F0003P@000280
00?o0840:@000h40000500F13@000ol0000E00008@03oa@000>100003`000kD=3@04000:]@fe3KD=
]@fe00<=3@000h400007000;`<c0c<3<`<c0c<005`000h40000R0003o`2102T000B10000184B0003
o`0001D0000Q0003o`0001@000>100004002]@063KD=]@fe0`dE0003P@0000D000S<3@g<3L`=c1`0
00>100008P000ol0P@0X00F15P000ol0000E00008@000ol0000D0003P@0000l000T=]@fe3KD=]H40
0P000h40000C0003P@0000W<00<0o`007@000h40000R0003o`2102<01H400`21000H0003o`0001D0
000Q0003o`0001@000>100003`000kD=]@050004P@0000:14P000h403@03c0043L`=c0@000?o0000
70000h40000R0003o`2101h01H460003P@0001L000?o00005@0000800olL0003o`0001@000>10000
5`000h4000030003P@0000l000>10<`00/`90003o`0001`000>100008P000ol0P@0J00B12`000h40
000G0003o`0001D000020004o`00oa/000?o000050000h40000G0003P@0000@00X4=00O<0`0014b<
S4`20003o`0001`000>100008P000ol0P@0E00F13`000h40000H0003o`0001@000020003o`0001`0
00?o000050000h40000G0003P@0000H000>100001P04c0B<00S<C8a<S4b<C0><00<0o`007@000h40
000R0003o`2101001H4D0003P@0001P000?o00005000008000?o00006`000ol0000E0003P@0001L0
00>100001`02P@0308b<00><01E<S4b<C8a<S4b<C8a<S4`0S4b<C?l07P000h40000R0003o`2100/0
1H4I0003P@0001P000?o0000500000030?oo00;o6`000ol0000E0003P@0001L000>100000P002LJ<
aXc6S<J<aP09S00508a<S4`020000ha<S00N0003P@00028000?o08401`04PAl000>100005`000ol0
000D00000P000ol0000K0003o`0001D000>100005@03S005aXc6S<H028`01<b<C8`60003P@0000X0
00=<S4`07@000h40000R0003o`2100801H4S0003P@0001L000?o00005000008000?o00006`000ol0
000D0003P@0001H000^<aXc6S<J<aXc6S002`005c000084020000h40000;0004S4b<S1/000>10000
8P000on1P@02PBP000>100005`000ol0000D00008002oaD000>100005P000hc6S003aPK000?<0000
0`02P@H000>100002`000om<S002C1X000>100007@05P@03o`2102X000>100005`000ol0000D0000
80000ol0000D0003P@0001P00/000lJ<aP03`0X000>100000`000h40000;0003o`0000><6@000h40
000H00F11@000ol0P@0Z0003P@0001L000?o00005000020000?o000050000h40000F0003a/3000;0
1LH;00:10`000h40000;0004o`0000=<60000h40000D00B12P000ol0P@0Z0003P@0001L000?o0000
5000020000?o000050000h40000A00W00`000l36`002aP/000B100213@000ol000020003S4c601L0
00>100003`05P@h000?o0840:P000h40000H0003o`0001<0000O0003o`0001D000>100003`003lK0
`<K0a/36`<K0a/36`004aP03`00000T00h4=0004o`0000:<00?6S0005P000h40000:00F14`000ol0
P@0Z0003P@0001P000?o00004`0001l000?o00005@000h40000?0009a/30a/36`<K000O600@0a/36
3@000h40000:0009S4b<C8a<S4b<01L000>100001@05PAP000?o0840:P000h40000H0003o`0001<0
000O0003o`0001D000>100003`003<36`<K0a/36PLK0aQD00h4600Z<6P0018400004PAd000?o0840
:P000h40000H0003o`0001<0000O0003o`0001D000>100003`000l36`0050003P@0001H000B10021
1d`018a<S?lM00F18@000ol0P@0Z0003P@0001P000?o00004`0001l000?o00005@000h40000G0003
P@0001H000>104`01h`40003o`0001H01H400`21000S0003o`2102X000>1000060000ol0000C0000
7`000ol0000D0003P@0001P000>100005P001h40C8a<08401`000ol0000A00F11P000h40000R0003
o`2102/000>100005`000ol0000C00007`03oa@000>1000060000h40000F0004S4a<S0<00X450003
o`0000d0184;0003P@00028000Co0021:P000h40000G0003o`0001<0000O0003oh4001@000>10000
60000h40000A0009aTc6C<I<aTc600<000A<CDe=0`000ol0000800F13`000h40000R0004o`00PBX0
00>100005`000ol0000C00003`04o`<00_l60003o`0000:14`000h40000H0003P@0000/000Q<CDa=
C8a<S09<00==C4d02Td20003o`0000<01H4D0003P@0002<000?o0840:P000h40000H0003o`000180
000@0003o`00008000Co003o1@000ol000020003P@00010000>1000060000h400006015=00Q<CDa=
C4e<00E=00?oPH400h4I0003P@0002<000?o0840:P000h40000H0003o`000180000A0005o`000?l0
0P000ol000030003o`0000<00X4@0003P@0001D00dd03X40001<CDa=C4e<CDa=0T`02De<CDa=C4e<
0003C@P014dN0003P@0002<000?o0840:P000h40000H0003o`000180000B0004o`00o`8000?o0000
0`000ol0000500:13P000h40000E0008C4e=C4e<CD`5C@03S4`0008014d60003P@0000X00ddM0003
P@0002<000?o0840:P000h40000H0003o`000180000?0004o`00o`8000Co003o1@000ol000070003
P@0000/000>100005@0024e<CDa=C4e<0P04C0d000>100002`001?m=CDdL0003P@0002<000?o0840
:P000h40000H0003o`000180000@00;o1002o`H000?o00002002P@/000>100005@0024e<CDe<CDa=
1T`=0003P@0000/000KoCDi=CTdJ0003P@0002<000?o0840:P000h40000H0003o`000180000N0003
o`0000X00X490003P@0001H014`5C@03C00000h000>100002`000ol00005CAP000>100008`000ol0
P@0Z0003P@0001P000?o00004P0001h000?o000030000h4000050003P@0001802d`014e<CD`@0003
P@0000/000?o00000P0014e>CDhG0003P@0002<000?o0840:P000h40000H0003o`000180000N0003
o`0000d00X450003P@00010024`00h4000020003CDa=00A=3@000h40000;0003o`0000@000=VC@00
5P000h40000S0003o`2102X000>1000060000ol0000B00007@000ol0000@00:10`000h40000@00=<
1002C009CDa=C4e<CDa=009<3@000h40000;0009o`1VCFI=ITeV01L000>100008`000ol0P@0[0003
P@0001P000?o00004@0001d00olB0004P@00PA8000i=C4a=C4e<CDa=C4e<C@<00Td>0003P@0000P0
00a>CDi=CTe>CDi=CTdG0003P@0002<000?o0840:`000h40000H0003o`000140000M0003o`0001<0
0h4B00Q<00>100005P000h4000060008CFI=ITeVCFHM0003P@0002<000?o0840:`000h40000H0003
o`000140000M0003o`0001D00X4A0003C4e<00D000>100005P003h40001VCFI=ITeVCFH0o`0O0003
P@0002<000?o0840:`000h40000H0003o`000140000M0003o`0001D000>1084060000h40000F000:
P@1=CFI=ITeVC@@000?o00007@000h40000S0003o`2102/000>1000060000ol0000A00007@000ol0
000E0003P@0000:15P000h40000F0003P@1V009V2@000ol0000M0003P@0002<000?o0840:`000h40
000H0003o`000140000M0003o`0001D000>100000P02PA@000>1000050001VI=ITeVC@X000?o0000
7@000h40000S0003o`2102/000>1000060000ol0000A00007@000ol0000E0003P@0000@000>10000
4@000h40000?000;ITiVCVI>ITiVCVH00`04@P<000?o00007@000h40000S0003o`2102/000>10000
60000ol0000A000070000ol0000E0003P@0000H00X4A0003P@0000d000MVCTeVCFI=00E200U?@Tm2
Cd9?@Tl00P000ol0000M0003P@0002<000?o0840:`000h40000H0003o`000140000L0003o`0001D0
00>100002002P@l000>100002005@P03Cd9?00I?24800`1?@P02@P030?l001h000>100008`000ol0
P@0[0003P@0001T000?o0000400001`000?o00005@000h40000:0003P@0000/000>100000P03@P09
Cd9?@Tm2Cd9?00Q200@0@Tm2200014m2Cd8O0003P@0002<000?o0840:`000h40000I0003o`000100
000L0003o`0001D000>100002`02P@T03d8400=?1P000h4000090004@Tm2Cah000>100008`000ol0
P@0/0003P@0001P000?o0000400001`00_lF0003P@0000d00X4700Q21VH>0003P@0000/000A2Cd9?
70000h40000S0003o`2102`000>1000060000ol0000@000070000ol0000E0003P@0000l000>10000
1003@P04IT9V@P9>00E=ITeVC@0>0003P@0000/000GoCd92C`0K0003P@0002<000Co0021:`000h40
000H0003o`000100000L0003o`0001D000>100004002P@D000UVCFI>@Ti2CT804P000h40000;0006
o`00Cd9?6P000h40000S0004o`00PB/000>1000060000ol0000@000070000ol0000E0003P@000180
2FH00`12IP03CQ4000>100002`001ol0001?@Tl06@000h40000S0004o`00PB/000>100005@03P@03
o`000100000K0003o`0001H000>100004002IP07CFI=ITeVP@040007@VI2CT9V@P0>0003P@0000/0
00?o00000P03CaP000>1000090000ol0P@0[0003P@0001001H430003o`000100000K0003o`0001H0
00>100004003IP8000>1CT8026H3CP03IP0000`000>100002`001?l00003C`03@P0001H000>10000
90000ol0P@0[0003P@0000/01H480003o`000100000K0003o`0001D000>100004@003VI>ITiVCVI>
IT9V@VI20`000d9>000=0003P@0000/000U?@Tm2Cd9?@Tl060000h40000T0003o`2102/000>10000
1@06P@h000?o00003`0001/000?o00005@000h40000@0009@Ti2CT9>@Th000:15`000h40000700Y?
6`000h40000T0003o`2102/000>100001H4D0003o`0000l0000K0003o`0001D000>1000040000diV
CP060004P@21PAD000>100000P08C`03@Too01l000>1000090000ol0P@0X00J16@000ol0000?0000
6`000ol0000E0003P@0001T000B100000X4C0003P@1?00Q?10000ol0000M0003P@0002@000?o0840
8`05P@<000>100006@000ol0000?00006`000ol0000E0003P@0001T000>100000`000h40000@0004
P@1??`9?2@000ol0000M0003P@0002@000?o08407P05P@P000>100006@000ol0000?00006`000ol0
000E0003P@0001T000>100001002PA0000<oCdl00Tl:0003o`0001d000>1000090000ol0P@0H00J1
3P000h40000H0003o`0000l0000J00?o5P000h40000H0003P@0000L00X4900U?2`000ol0000M0003
P@0002@000?o08404`05PA@000>1000060000ol0000?00006P000ol0000F0003P@0001P000>10000
2@000h400002000:Ccm??dloCcm??`L000@P8B0Q0`000ol0000M0003P@0002@000?o08403P05PAT0
00>1000060000ol0000?00006P000ol0000F0003P@0001P000>100002@000dloC`0480=?0P00320Q
82408B0Q824P8@8P00@Q003o7`000h40000T0003o`2100P01X4N0003P@0001P000?o00003`0001X0
00?o00005P000h40000H0003P@0000L000HP?b0o83l480058B0Q82400R002B4P8B0Q824P00028@8P
00?o00007P000h40000T0003o`2100<01H4T0003P@0001T000?o00003P0001X000?o00005@000h40
000G00<o10000b0o8008800>024P8B0Q824P020Q824800038B0Q020000>100008@05o`B1:@000h40
000I0003o`0000h0000J0003o`0001D000>100005`000b0o80068005?b0o83l01@000b0Q80060003
P@0000X00b0O0003P@0001`01Ol3P@8000?o0000:P000h40000I0003o`0000h0000J0003o`0001D0
00>100005`0023lP?b0o83lP1Tl800:110000h40000;00048B0Q8Ad000>100005`05o`>11`000h7o
o`0Z0003P@0001T000?o00003P0001X000?o00005@000h40000G00<P23l=0005P@0008403@000olP
800281`000>100004P05o`>1300018400?lY0003P@0001T000?o00003P0001T000?o00005P000h40
000B0007?dloCcm??`03C`@o00=??`003@02P@03084000`000?o0000124J0003P@0000`01_l2PA80
00B100000_lW0003P@0001T000?o00003P0001T000?o00005P000h40000@00Po00<0P@000P06?`03
C`0000`00X4=0004o`0000@P6@000h40000700Go0h4G0003P@0000<000?o000090000h40000I0003
o`0000h0000I0003o`0001H000>100004003?`@01Cl01dloCcm??dl00Sl>00:130000ol0000300<Q
60000h40000200Go0h4L0003P@0000@00_lT0003P@0001T000?o00003P0001T00_lG0003P@000100
00Q??dloCcm??`9?00PoCcm??dlo00<o3P001840PH4:0003o`00008000@Q820Q6005o`:18P000h40
00060003o`00028000>100006@000ol0000=00006@000ol0000F0003P@00010023l0100oCclG0004
P@0000:120002B4P8B0Q824P8@0B00Ko0X4W0003P@0000L00_lR0003P@0001T000?o00003@0001T0
00?o00005P000h40000@0003Ccm?00H000>100005`000h4000030003P@0000<Q00PP8B0Q824P8A00
1Ol3P@<000>100009`000h4000080003o`0001l000>100006@000ol0000=00006@000ol0000E0003
P@0001T000>1000060003h40000Q824P8B0Q824P8@0@00Go0X490003P@0002L000>100002@000ol0
000N0003P@0001T000?o00003@0001T000?o00005@000h40000I0003P@0001P000>102401b401H40
003o00/01Ol2P@h000>100009`000h40000:00;o7P000h40000I0003o`0000d0000I0003o`0001D0
00>100006@000h40000H0003P@0Q008Q1P0018400?l500Ko00>100004P000h40000W0003P@0000`0
00?o00006`000h40000I0003o`0000d0000H0003o`0001H000>100006@000h40000H00<Q00<_0000
1P02P@Ko0X4I0003P@0002L000>100003@02oa/000>100006@000ol0000=000060000ol0000F0003
P@0001T000>100004`002B4_8BlQ;b4_8@0600Go0X4N0003P@0002L000>100003`000ol0000H0003
P@0001T000?o00003@0001P000?o00005P000h40000I0003P@0000h000<Q;b40224400Go10000ol0
000N0003P@0002L000>100004002oaP000>100006@000ol0000=000060000ol0000F0003P@0001T0
00>100002@08;`038BlQ00<01_l90003o`0001h000>100009`000h40000B0003o`0001D000>10000
6P000ol0000<000060000ol0000F0003P@0001T000>100001`001RlQ;b4_8P<O0P05o`03P@0000`0
00?o00007P000h40000W0003P@0001<00_lE0003P@0001X000?o0000300001P000?o00005P000h40
000I0003P@00008000DO8QlR00067`Go1@000h40000<0003o`0001h000>100009`000h40000E0003
o`00018000>100006P000ol0000<00006003oaH000>100005`003B8O7b8O8QlR7b8O8Ql01Ol:0003
P@0000`000?o00007P000h40000W0003P@0001H00_lC0003P@0001T000?o0000300000P00ol400;o
1P000h7o000F0003P@0001P000LR7b8O8QlR00Ko00<R000030000h40000<0003o`0001h000>10000
9`000h40000H0003o`00010000>100006@000ol0000<00002`001?l00?l20003o`0000<000Co0861
5@000h40000H00037b;o00Co00@R8BlQ4@000h40000<0003o`0001h000>100009`000h40000I00;o
40000h40000I0003o`0000`0000;0004o`00o`8000?o00000`001?l00002PA<000>100004`000b8_
o`04o`07;b8R7b8O;`0C0003P@0000`000?o00007P000h40000W0003P@0001/000?o00003@000h40
000I0003o`0000`0000900;o0`001?l00?l50003o`0000<00X4A0003P@0001001Ol4;`04084000LR
00<O00003@000h40000<0003o`0001h000>100009`000h40000L00;o3@000h40000I0003o`0000`0
000;0004o`00o`8000?o00000`000ol0000500:13`000h40000:00Ko00@08R8R10088P03;al_008O
3`000h40000<0003o`0001h000>100009`000h40000N0003o`0000X000>100006@000ol0000<0000
2003o`@00_l60003o`0000L000>1000030000h40000500Go1`028P067b8O8QlR0Ql01R8O8QlR7`@R
3`000h40000<0003o`0001h000>100009`000h40000O00;o2P000h40000J0003o`0000/0000G0003
o`0000P00X4<0003P@0000Go30088P04PB8R8PH000<O;`003P000h40000<0003o`0001h000>10000
9`000h40000Q0003o`0000L000>100006P000ol0000;00005`000ol0000:00:12005oa4000<O8Ql0
1@000h40000H0003P@0000`000?o00007P000h40000W0003P@0002800_l70003P@0001X000?o0000
2`0001L000?o00003002P@Ko0P000h40000I0003P@0001P000>1000030000ol0000N0003P@0002L0
00>1000090000ol000040003P@0001X000?o00002`0001H000?o00002P05o`:11P000h40000I0003
P@0001P000>1000030000ol0000N0003P@0002L000>100009@000ol000030003P@0001X000?o0000
2`0001H000?o00001@05o`L00X430003P@0001X000>1000060000h40000<0003o`0001h000>10000
9`000h40000V00;o0`000h40000J0003o`0000/0000F0003o`0000Go3P02P@03084001/000>10000
60000h40000<0003o`0001h000>100009`000h40000X0005o`0008406`000ol0000;00005P03oaD0
0X4L0003P@0001P000>100002`000ol0000O0003P@0002P000>10000:002o`03084001X000?o0000
2`0001P00_lE00>16P000h40000H0003P@0000/000?o00007`000h40000X0003P@0002X000?oP@00
6P000ol0000;00006P02oa<000>100000X4H0003P@0001P000>100002`000ol0000O0003P@0002P0
00>10000:`02oa/000?o00002P0001`00_lA0003P@00008000>100005@000h40000H0003P@0000/0
00?o00007`000h40000X0003P@0002/000>10?l06P000ol0000:00007P02o`l000>100000`02PAD0
00>1000060000h40000;0003o`0001l000>10000:0000h40000[0003P@0000;o60000ol0000:0000
8002o`d000>100001@02PA<000>1000060000h40000;0003o`0001l000>10000:0000h40000[0003
P@00008000?o00005@000ol0000:00008P02o`/000>100001`02PA0000>1000060000h40000<0003
o`0001l000>10000:0000h40000[0003P@0000<00_lE0003o`0000X0000T00;o2@000h40000900:1
3P000h40000H0003P@0000`000?o00007`000h40000X0003P@0002/000>100001@000ol0000B0003
o`0000X0000V00;o1P000h40000<00:130000h40000H0003P@0000`000?o00007`000h40000X0003
P@0002/000>100001P02oa8000?o00002P0002P00_l40003P@0000h00X4:0003P@0001P000>10000
30000ol0000O0003P@0002P000>10000:`000h4000080003o`0000l000?o00002P0002X00_l20003
P@0001000X480003P@0001P000>1000030000ol0000O0003P@0002P000>10000:`000h40000900;o
3`000ol0000:0000;002o`03P@0001800X460003P@0001P000>1000030000ol0000O0003P@0002P0
00>10000;0000h40000:0003o`0000d000?o00002@0002h000?o00005002P@@000>1000060000h40
000<0003o`0001l000>10000:0000h40000/0003P@0000/00_l900B100?o00002@0002l00_lF0005
P@0008406P000h40000<0003o`0001l000>10000:0000h40000/0003P@0000d000?o00001X440003
o`0000T0000a00;o5@02P@03084001T000>1000030000ol0000O0003P@0002P000>10000;0000h40
000:00B100?oP@002@000ol000090000<`02oaD00X4J0003P@0000`000?o00007`000h40000X0003
P@0002`000>100001006P@D00_l90003o`0000T0000e00;o5003PAP000>1000030000ol0000O0003
P@0002P000>10000;007P@d000?o00001P000ol000090000=`02oa8000>100000X4F0003P@0000`0
00?o00007`000h40000X0003P@0002H01h4D00;o1P000ol000090000>@02oa0000>100000P02PA@0
00>1000030000ol0000O0003P@0002P000>100008006P@H000>1000050000ol000030003o`0000T0
000k00;o3P000h40000400:14P000h40000<0003o`0001l000>10000:0000h40000J00J130000h40
000E00;o0`000ol000090000?@02o`/000>100001`02PA0000>1000030000ol0000O0003P@0002P0
00>100005006PA8000>100005`001Ol0003o00X0000o00;o2@000h40000900:13P000h40000<0003
o`0001l000>10000:0000h40000>00J160000h40000H00;o00<0o`002@0004400_l70003P@0000/0
00>100002`000h40000<0003o`0001l000>10000:0000h40000800J17P000h40000J00;o2P0004<0
0_l50003P@0000`00X4;0003P@0000`000?o00007`000h40000X0003P@0000801X4U0003P@0001L0
1?l:0000A@02o`<000>100003P02P@T000>1000030000ol0000O0003P@0002H01h4[0003P@000140
1_l>0000A`02o`03084001400X470003P@0000`000?o00007`000h40000P00J10`000h40000/0003
P@0000X01olD0000B@02oa@00X450003P@0000`000?o00007`000h40000J00J12@000h40000/0003
P@0000@01_lK0000B`02oa@00X430003P@0000`000?o00007`000h40000D00J13`000h40000/0003
POoo00Co8@0004d00_lD00:100<0P@003@000ol0000O0003P@0000h01X4E0003P@0002L01_lW0000
C`02oa@00X4>0003o`0001l000>100002006PA/000>100008@06obd0001A00;o4P001840PH4<0003
o`0001l000>100000P06PB4000>100006P07oc<0001C00;o400018400002P@X000?o00007P06PBL0
00>100005006ocX0001E00;o3P000h4000030003P@0000L000?o00006006P@03084002X000>10000
3P06od00001G00;o30000h40000400:11P000ol0000B00N11`000h40000Y0003P@0000P01_m60000
F@02o`X000>100001P02P@@000?o00003006P@h000>10000:@000h40000200KoC00005/00_l80003
P@0000P00X420003o`0000H01X4D0003P@0002L01omB0000G@000ol000050003P@0000X00X400ol0
0006PAX000>100008@06oeT0001N00;o1@000h40000<0003oh61020000>100006`06oel0001P00;o
0`000h40000<0003o`00020000>100005@06ofD0001R00;o00<0P@003@000ol0000P0003P@0000l0
1_m[0000I002o`h000?o000080000h40000800OoL@0006H00_l<0003o`00020000>100000P06ogP0
001X00;o2P000ol0000O00KoOP0006X00_l80003o`0001T01_n40000K002o`H000?o00004`06ohX0
001^00;o10000ol0000<00OoT00007000_l20003o`0000H01_nG0000LP03o`801_nM0000M003oj<0
003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0001f0003
o`0002L000?o0000M`0005401?l300Co00@0ool00_l200;o0`03o`@00_l40003o`0000P01Ol0103o
o`02o`801Ol00`3oo`0300?o10000ol0000700?o1005o`800ol300;o0`03o`@000?o00000`02odP0
001@0005o`000?l00P000ol000030004o`00o`<00_l40003o`00008000Co003o10000ol000090005
o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L000?o00001@000ol000020004
o`00o`800_l40003o`0000<000?o00000`02odP0001@0003o`3o00;o0P05o`050?l00?l02@000ol0
00020004o`00oa0000Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D000?o0000
0P000ol000090003o`0000@000?o0000C000050000?o000010001ol0003o0?l00P000ol000070003
o`0000800olA0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0
00090003o`0000@000?o0000C000050000Go0000o`0300?o00<0ool00ol90003o`00008000?o0000
4@000ol00005o`<01?l80003o`0000h000?o00001002o`<01?l90003o`0000D000?o0000B`000540
1?lD00;o1@03o`h01Ol;0003o`0000D00_l?00Go2@000ol0000800;o1004odd0002@00;o8@000ol0
00020003o`0005l0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.119095, -0.0221209, \
0.00253531, 0.00390113}},
  CellTags->"AntTracker3D - Gen 16"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 17",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  ButtonBox["Movie",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ 
          ParentDirectory[ ]], "Movies", "AntTracker-Movies Folder"}, 
        "AntTracker-7i-Gen16.nb", CharacterEncoding -> "MacintoshRoman"], 
      None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \(ifSensor[wall]\)[seq[stop], \ 
          turnRight], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[turnLeft, \ again], \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.16, Ind.1, Fit.17.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.16, Ind.1, Fit.17.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.773 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.792 1 0 r
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.773 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.792 1 0 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.812 1 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.812 1 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
.754 1 0 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.831 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.85 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.869 1 0 r
F P
s
P
p
.002 w
.42999 .5109 m .40239 .51917 L .38586 .50383 L p
.8 g
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .958 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .939 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .92 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
.754 1 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.831 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.85 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.869 1 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .958 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .939 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .92 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.888 1 0 r
F P
s
P
p
.002 w
.38586 .50383 m .41364 .49539 L .42999 .5109 L p
.8 g
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .901 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .882 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .863 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.888 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.696 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.716 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.735 1 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .901 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .882 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .863 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.907 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.927 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.946 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .978 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.696 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.716 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.735 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .843 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.907 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.927 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.946 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .978 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .843 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.965 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .824 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .805 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .786 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .058 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .038 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .019 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.965 1 0 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
.677 1 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .824 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .805 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .786 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .058 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .038 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .019 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.984 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .997 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
.677 1 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .767 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .077 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.984 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .997 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .767 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .077 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .748 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .728 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .709 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .134 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .115 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .096 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.62 1 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.639 1 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.658 1 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .748 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .728 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .709 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .134 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .115 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .096 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.62 1 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.639 1 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.658 1 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .69 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .153 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .69 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .153 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.32279 .45406 m .30875 .45851 L .29974 .45028 L p
.601 1 0 r
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .671 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .652 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .192 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .173 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.29974 .45028 m .31382 .44579 L .32279 .45406 L p
.601 1 0 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .671 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .652 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .192 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .173 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.73675 .44005 m .70625 .44907 L .69207 .43233 L p
.8 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.30476 .43742 m .29063 .44196 L .28143 .43356 L p
.543 1 0 r
F P
s
P
p
.002 w
.30476 .43742 m .29063 .44196 L .28143 .43356 L p
.562 1 0 r
F P
s
P
p
.002 w
.30476 .43742 m .29063 .44196 L .28143 .43356 L p
.581 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .633 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .211 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.69207 .43233 m .72279 .42312 L .73675 .44005 L p
.8 g
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.28143 .43356 m .29561 .42898 L .30476 .43742 L p
.543 1 0 r
F P
s
P
p
.002 w
.28143 .43356 m .29561 .42898 L .30476 .43742 L p
.562 1 0 r
F P
s
P
p
.002 w
.28143 .43356 m .29561 .42898 L .30476 .43742 L p
.581 1 0 r
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .633 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .211 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.28637 .42044 m .27214 .42507 L .26276 .4165 L p
.524 1 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .613 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .594 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .575 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .268 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .249 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .23 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.26276 .4165 m .27703 .41182 L .28637 .42044 L p
.524 1 0 r
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .613 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .594 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .575 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .268 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .249 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .23 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.2676 .40311 m .25328 .40784 L .2437 .39909 L p
.466 1 0 r
F P
s
P
p
.002 w
.2676 .40311 m .25328 .40784 L .2437 .39909 L p
.486 1 0 r
F P
s
P
p
.002 w
.2676 .40311 m .25328 .40784 L .2437 .39909 L p
.505 1 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .556 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .288 0 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.2437 .39909 m .25806 .39431 L .2676 .40311 L p
.466 1 0 r
F P
s
P
p
.002 w
.2437 .39909 m .25806 .39431 L .2676 .40311 L p
.486 1 0 r
F P
s
P
p
.002 w
.2437 .39909 m .25806 .39431 L .2676 .40311 L p
.505 1 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .556 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .288 0 r
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.24843 .38541 m .23402 .39024 L .22424 .38131 L p
.447 1 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .537 0 r
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .518 0 r
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .498 0 r
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .345 0 r
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .326 0 r
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .307 0 r
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.22424 .38131 m .2387 .37643 L .24843 .38541 L p
.447 1 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .537 0 r
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .518 0 r
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .498 0 r
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .345 0 r
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .326 0 r
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .307 0 r
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.22886 .36735 m .21435 .37228 L .20436 .36315 L p
.39 1 0 r
F P
s
P
p
.002 w
.22886 .36735 m .21435 .37228 L .20436 .36315 L p
.409 1 0 r
F P
s
P
p
.002 w
.22886 .36735 m .21435 .37228 L .20436 .36315 L p
.428 1 0 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .479 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .364 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.20436 .36315 m .21892 .35817 L .22886 .36735 L p
.39 1 0 r
F P
s
P
p
.002 w
.20436 .36315 m .21892 .35817 L .22886 .36735 L p
.409 1 0 r
F P
s
P
p
.002 w
.20436 .36315 m .21892 .35817 L .22886 .36735 L p
.428 1 0 r
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .479 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .364 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.20888 .3489 m .19427 .35393 L .18407 .34461 L p
.371 1 0 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 .46 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 .441 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 .422 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 .403 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 .383 0 r
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.18407 .34461 m .19872 .33952 L .20888 .3489 L p
.371 1 0 r
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 .46 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 .441 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 .422 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 .403 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 .383 0 r
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.18846 .33005 m .17375 .33519 L .16333 .32567 L p
.313 1 0 r
F P
s
P
p
.002 w
.18846 .33005 m .17375 .33519 L .16333 .32567 L p
.332 1 0 r
F P
s
P
p
.002 w
.18846 .33005 m .17375 .33519 L .16333 .32567 L p
.351 1 0 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .192 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .211 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .23 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .249 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .268 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .767 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .786 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .805 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .824 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
1 0 .843 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.658 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.639 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.62 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.601 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.581 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.083 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.064 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.045 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.026 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.006 0 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 .492 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 .511 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 .53 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 .55 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 .569 1 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .933 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .914 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .895 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .875 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .856 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .358 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .339 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .319 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .3 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
0 1 .281 r
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.16333 .32567 m .17809 .32047 L .18846 .33005 L p
.313 1 0 r
F P
s
P
p
.002 w
.16333 .32567 m .17809 .32047 L .18846 .33005 L p
.332 1 0 r
F P
s
P
p
.002 w
.16333 .32567 m .17809 .32047 L .18846 .33005 L p
.351 1 0 r
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .192 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .211 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .23 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .249 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .268 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .767 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .786 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .805 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .824 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
1 0 .843 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.658 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.639 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.62 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.601 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.581 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.083 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.064 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.045 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.026 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.006 0 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 .492 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 .511 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 .53 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 .55 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 .569 1 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .933 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .914 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .895 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .875 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .856 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .358 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .339 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .319 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .3 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
0 1 .281 r
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
1 0 .173 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
1 0 .288 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
1 0 .748 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
1 0 .863 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.677 0 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.562 0 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.102 0 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 .013 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 .473 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 .588 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .952 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .837 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .377 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .262 r
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
1 0 .173 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
1 0 .288 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
1 0 .748 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
1 0 .863 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.677 0 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.562 0 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.102 0 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 .013 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 .473 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 .588 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .952 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .837 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .377 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .262 r
F P
s
P
p
.002 w
.1676 .31079 m .1528 .31604 L .14214 .30631 L p
.256 1 0 r
F P
s
P
p
.002 w
.1676 .31079 m .1528 .31604 L .14214 .30631 L p
.275 1 0 r
F P
s
P
p
.002 w
.1676 .31079 m .1528 .31604 L .14214 .30631 L p
.294 1 0 r
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .134 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .153 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .307 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .326 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .345 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .709 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .728 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .882 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .901 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
1 0 .92 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.716 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.696 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.543 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.524 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.505 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.141 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.121 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .032 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .051 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .07 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .435 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .454 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .607 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .626 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 .645 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .99 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .971 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .818 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .799 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .78 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .415 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .396 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .243 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .224 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
0 1 .204 r
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.14214 .30631 m .157 .301 L .1676 .31079 L p
.256 1 0 r
F P
s
P
p
.002 w
.14214 .30631 m .157 .301 L .1676 .31079 L p
.275 1 0 r
F P
s
P
p
.002 w
.14214 .30631 m .157 .301 L .1676 .31079 L p
.294 1 0 r
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .134 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .153 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .307 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .326 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .345 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .709 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .728 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .882 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .901 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
1 0 .92 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.716 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.696 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.543 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.524 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.505 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.141 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.121 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .032 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .051 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .07 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .435 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .454 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .607 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .626 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 .645 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .99 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .971 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .818 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .799 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .78 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .415 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .396 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .243 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .224 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
0 1 .204 r
F P
s
P
p
.002 w
.19747 .30018 m .18249 .3055 L .17194 .29565 L p
.236 1 0 r
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
1 0 .364 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
1 0 .939 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
.486 0 1 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
0 .089 1 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
0 .665 1 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
0 1 .76 r
F P
s
P
p
.002 w
.35973 .29689 m .34425 .30223 L .33456 .29234 L p
0 1 .185 r
F P
s
P
p
.002 w
.17194 .29565 m .18697 .29027 L .19747 .30018 L p
.236 1 0 r
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
1 0 .364 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
1 0 .939 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
.486 0 1 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
0 .089 1 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
0 .665 1 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
0 1 .76 r
F P
s
P
p
.002 w
.33456 .29234 m .35011 .28695 L .35973 .29689 L p
0 1 .185 r
F P
s
P
p
.002 w
.2277 .28944 m .21254 .29482 L .20209 .28486 L p
.179 1 0 r
F P
s
P
p
.002 w
.2277 .28944 m .21254 .29482 L .20209 .28486 L p
.198 1 0 r
F P
s
P
p
.002 w
.2277 .28944 m .21254 .29482 L .20209 .28486 L p
.217 1 0 r
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
1 0 .115 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
1 0 .69 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.735 0 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.16 0 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .415 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .99 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 1 .435 r
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .383 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .403 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .422 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .958 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .978 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
1 0 .997 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
.466 0 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
.447 0 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
.428 0 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .109 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .128 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .147 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .684 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .703 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 .722 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .741 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .722 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .703 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .166 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .147 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
0 1 .128 r
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.20209 .28486 m .2173 .27942 L .2277 .28944 L p
.179 1 0 r
F P
s
P
p
.002 w
.20209 .28486 m .2173 .27942 L .2277 .28944 L p
.198 1 0 r
F P
s
P
p
.002 w
.20209 .28486 m .2173 .27942 L .2277 .28944 L p
.217 1 0 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
1 0 .115 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
1 0 .69 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.735 0 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.16 0 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .415 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .99 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 1 .435 r
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .383 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .403 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .422 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .958 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .978 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
1 0 .997 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
.466 0 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
.447 0 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
.428 0 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .109 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .128 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .147 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .684 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .703 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 .722 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .741 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .722 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .703 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .166 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .147 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
0 1 .128 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
.16 1 0 r
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
1 0 .441 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
.984 0 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
.409 0 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
0 .166 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
0 .741 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
0 1 .684 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
0 1 .109 r
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
.16 1 0 r
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
1 0 .441 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
.984 0 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
.409 0 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
0 .166 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
0 .741 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
0 1 .684 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
0 1 .109 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
1 0 .077 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
1 0 .096 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
1 0 .652 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
1 0 .671 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.773 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.754 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.198 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.179 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .377 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .396 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .952 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .971 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 1 .473 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 1 .454 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.102 1 0 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.121 1 0 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.141 1 0 r
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
1 0 .46 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
1 0 .479 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.965 0 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.946 0 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.39 0 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.371 0 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 .185 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 .204 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 .76 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 .78 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 1 .665 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 1 .645 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 1 .089 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
0 1 .07 r
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
1 0 .077 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
1 0 .096 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
1 0 .652 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
1 0 .671 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.773 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.754 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.198 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.179 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .377 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .396 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .952 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .971 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 1 .473 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 1 .454 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.102 1 0 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.121 1 0 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.141 1 0 r
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
1 0 .46 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
1 0 .479 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.965 0 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.946 0 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.39 0 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.371 0 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 .185 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 .204 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 .76 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 .78 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 1 .665 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 1 .645 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 1 .089 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
0 1 .07 r
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
1 0 .058 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
1 0 .633 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.792 0 1 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.217 0 1 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
0 .358 1 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
0 .933 1 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
0 1 .492 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.083 1 0 r
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
1 0 .058 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
1 0 .633 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.792 0 1 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.217 0 1 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
0 .358 1 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
0 .933 1 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
0 1 .492 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.083 1 0 r
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
1 0 .019 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
1 0 .038 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
1 0 .575 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
1 0 .594 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
1 0 .613 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.85 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.831 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.812 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.275 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.256 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.236 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .3 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .319 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .339 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .875 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .895 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 .914 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 1 .55 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 1 .53 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 1 .511 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.026 1 0 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.045 1 0 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.064 1 0 r
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
1 0 .498 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.927 0 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.351 0 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .224 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .799 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 1 .626 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 1 .051 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
1 0 .019 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
1 0 .038 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
1 0 .575 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
1 0 .594 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
1 0 .613 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.85 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.831 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.812 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.275 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.256 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.236 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .3 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .319 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .339 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .875 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .895 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 .914 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 1 .55 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 1 .53 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 1 .511 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.026 1 0 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.045 1 0 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.064 1 0 r
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
1 0 .498 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.927 0 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.351 0 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .224 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .799 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 1 .626 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 1 .051 r
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
1 0 .556 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.869 0 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.294 0 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
0 .281 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
0 .856 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
0 1 .569 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.006 1 0 r
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
1 0 .556 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.869 0 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.294 0 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
0 .281 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
0 .856 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
0 1 .569 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.006 1 0 r
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
1 0 .518 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
1 0 .537 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.907 0 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.888 0 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.332 0 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.313 0 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 .243 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 .262 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 .818 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 .837 1 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 1 .607 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 1 .588 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 1 .032 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
0 1 .013 r
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
1 0 .518 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
1 0 .537 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.907 0 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.888 0 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.332 0 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.313 0 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 .243 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 .262 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 .818 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 .837 1 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 1 .607 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 1 .588 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 1 .032 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
0 1 .013 r
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l01K_;^l^k00;o00C;^l_o3H403oo;
^l^kbk_;^l^kbk_;o`0;F`0Aoe_obk_;^l^kbk_;^l^kbol02H43o`0OPOo;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`0=P@09ok_;^l^kbk_o008000?o00000`000ol000150000@P03o`H000?o0000
3`03o`Vk0ol;P@03oh6100^100?o^k/00k/3o`;L00Go^k^ko`08P@?o4;/00omKF`04F`Co0U/00onk
^`0<^`03oh6100>10ol5P@03ok^k01Zk00?oPH402h400onk^`04^`05o`000?l010000ol000150000
@002oaP00ol02K_;^l^kbk_;^`03o`03POn100b100?oPH401X43o`07bk_;^l^ko`06g005ol^kbol0
1H42o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l_o009K0ol7F`0Aok_;^l^kbk_;^l^kbk_;oh400ol9P@0M
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol03X402?nkbk_;^l_o0P000ol000030003o`0004@0
000m00?o5`04o`Rk0ol5P@03oh6100^100?oPH400h42o`Zk00?og=`01=`01_nk^k_oP@?o5k/2o`]K
00?o^k/03;/00on1P@0;P@03ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go
00D0oooo0003o`<00_lD0000>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1
o`02o`03^l^k00Co00S;^l^kbk_og0?o02:kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
3E/03onkbk_;^l^kbk_;^l^ko`0>P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol5P@08
ol^kbk_;^ol30003o`0000800_lN0003o`00008000Co003o10001?l00?lE0000=`03oaP00ol9^`;o
3H400on1P@09P@03oh7o00>k0ol4g003ok^k00Bk00?o^k/08k/00omKF`0;F`03ok^k00^k00?oPH40
38400onk^`0H^`03oh6100?o2H400onk^`04^`05o`000?l010000ol0000L0003o`0000<00ol200;o
0`000ol0000C0000=@02oaP01?l02;_;^l^kbk_;0ol2P@03oh6100^100?oPH401844o`07^l^kbk_;
o`07g00^ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`eK00oo^l^k
bk_;^l^kbk_;^ol03X406oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`80
00?o00000`000ol0000K00Go0`000ol0o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^1
00?oPH400ol4^`;o1K/00ooLg005g003ok^k00Vk0ol?^`;o3K/00omKF`09F`03oe_o00fk00?oPH40
1h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D000?o00006P000ol0000300;o0`03o`04
0?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V100?oPH402h42o`04bk_;^`?o00WLok_;
^l^kbol00]`3o`04^l^kb`;o00Bkbk_;0ol3g00<ol^kbk_;^l^kbk_;0ol04H7obk_;^l^kbk_;^l^k
bk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o00004`00010000Co003o
6@02oaP00ol:^`;o3H400on1P@06P@?o1[/01ooLUMbEg?l01[/2o`Bk0ol00e_o^`02^`09omc/g>cL
k=co00Rk0_l5P@03ok^k00bk00?oFe/00ol7F`03ok^k00bk00?oPOl00_l9P@03ok^k01Rk00?oPH40
38400onk^`04^`04o`00o`D000?o00006@05ob40000@0004o`00oaH00olG00Co00W;^l^kbk_;^l/0
0ol2P@03oh6100^100?oPH400h42o`0:bk_;^l^kbk_;o`KL00Wo^l^kbk_;^l/00ol5F`05ol^kbol0
1m`01Oo;^l^k00?o28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000
?P00010000Co003o4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_l4^`?o1K/02?nE
g9GLUMco1;/3o`UK00Oo^k^komc/00?o1K/00on1P@0:P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06K/00on1P@04o`N100?o^k/01;/01Ol0003o00<00_m0000040001?l00?lA00;o
6003o`0:bk_;^l^kbk_;^`?o2H400on1P@0;P@05ok_;^l/00ol3g008ol^kbk_;om`3o`06bk_;^l_o
3E/01?o;^l/2o`09^l^kbk_;^l_o00f100oobk_;^l^kbk_;^l^kbol03E/03oo;^l^kbk_;^l^kbk_;
o`0=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o38402?o;^l^kbk_o0P000ol000030003
o`0000H00ol400;o;P0001400_l?00?o5`04o`Vk0ol=P@03oh6100J10ol5^`03oiFE00FE00?o^k/0
0k/00onk^`08^`03oe]K00YK00?o^k/02k/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0;bk_;^l^kbk_;^ol0
1]`04_o;^l^kbk_;^l^kbk_;^l^ko`aK00Sobk_;^l^kb`Co00>kbol03H403oo;^l^kbk_;^l^kbk_;
o`0;F`0Aoe_obk_;^l^kbk_;^l^kbol02843o`0NPOnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
3H402Onkbk_;^l^ko`020003o`00008000?o00001P000ol000020004o`00obd0000L00?o10000ol0
000A00?o2K/3o`R100?oPH402X400on1o`02o`Bk0_l7^`03oiGo00;o1;/2o`fk00?oFe/02U/01?nk
^k/3o`05g>cLk?l00[/00on1P@06P@?o00>1ok/03K/00omKF`04F`Co4;/00on1P@03P@?o1H400onk
^`0I^`03oh6100^100?o^k/01;/01?l00?l50003o`0000D000?o00000P001?l00?l]00006P02oaP0
0ol02K_;^l^kbk_;^`03o`b100?oPH402X401Onkbk_;00?o0YD03Onkbk_;^l^kok_;^l/00ol04E_o
bk_;^l^kbk_;^l^kbk_o00IK0ol04/^kbk_;^oo/g>cLk=c/ok_;o`F10_l5P@0@ok_;^l^kbk_;^l^k
bk_;o`9K0ol05k_;^l^kbk_;^l^kbk_;^l^kbk_;^on100?o2H407Onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_o00^100[oPOnkbk_;^l_o0P000ol000030003o`0000@000?o00000P001?l00?l]0000
5`03oaL01?l8^`?o0X400on1P@0;P@03oh6100B10ol6^`08ombEg9GLUOl9^`;o1E/00onk^`0<^`03
oe]K00?o0k/2o`Fk00Wok=c/g>cLk?l00[/00on1o`02o`R100?o^k/03;/2oaVk00?oPH402h400onk
^`0H^`03oh6100F11?l2P@03ok^k00Fk00Co003o1002o`@00_l500;o;P0001@00ol00`3oo`0E00?o
00W;^l^kbk_;^l/00_l6P@03oh6100^100?oPH400ol00k_;^`02o`06bk_;^l_o1YD01_nkbk_;^`?o
25/03oo;^l^kbk_;^l^kbk_;^`02o`03bk_;00?o00_Lol^kbk_;^oo/g003o`03bk_;00?o3840:_nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f101gobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02P@Co1h402?o;^l^kbk_o0`001_l00?l0oc/0000C00;o1@000ol0000?00?o
2K/3o`V100?oPH402h42o`>k0ol00iGo^`05^`03omco00;o1[/00omKF`0:F`03ok^k00nk00Ook=c/
g>co00Jk0_l2^`Co0h400on1P@0:P@03ok^k02Jk00?oPH402h400onk^`0I^`;o38400onk^`04^`04
o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;^l^k00;o3H400on1P@06P@?o00Jkbk_;
^ol5U@0Cok_;^l^kboo;^l^kbk_;^l^ko`0<F`0Ool^kbk_;^l^kbk_;^l^kbk_;omc/g>cLol^kbk_;
^`03o`R100?oPH402X40:_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f1
01cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3H402Onkbk_;^l^ko`020003o`00008000?o0000
>00001<000Co003o3`04o`Vk0ol2P@03oh6100^100?oPH400h42o`Rk00Sog9GLUMbEo`fk0_l2^`03
oe]K00YK00?o^k/01k/2o`Jk00Ook=c/onco00:k0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l01<^kbk/2o`06bk_;^l_o1YD02_nkbk_;^l^k
bk/3o`06]onkbk_o35/01_o;^l^kb`?o00WLk?nkbk_;^l/00ol00l^ko`02o`03POn100f100?oPH40
1843o`0]^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:10ol7P@0M
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol03H402?nkbk_;^l_o0P000ol000030003o`0003H0
000C0003o`00008000?o00001P03o`Zk0ol9P@03oh6100^100?o^k/00[/3o`:E00?o^k/00k/00ooL
o`02o`Zk00Oo][Nf]kKo00>k00?oFe/015/3o`Nk00Sok=c/g>cLo`Rk0_l5P@03oh6100b100?oPH40
0ol`^`;o2h400onk^`0I^`03oh6100J10ol00h7o^`06^`04o`00o`D000?o0000=@0001<000?o0000
0`000ol0000200Co00W;^l^kbk_;^l/00ol=P@03oh6100J10ol08K_;^l^komfEgIGMUOo;^l^kboo;
^l^kbk_;^l^kbk_;o`06]`05ok_;^ol00U/3o`03bk_;00;o01:kbk_;^l_og>cLk=c/ok_;^l/3o`R1
00?oPH403842o`0G^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol06[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_o3H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol5P@?o1H402Oo;^l^kbk_;o`020004
o`0000;o=`00018000?o00001@000ol0o`02o`Vk0ol4P@03oh6100Z100?oPH400h42o`Vk00?oUID0
19D00onk^`0A^`08okNf]kJg]_l3^`;o0k/3o`03k;Oo00Jk00?ok?l00_l3^`?o38400on1P@07P@?o
5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl00_l9P@03ok^k00Bk00Co003o1@000ol0
000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03oh6100Z100?oPOl00_l00l^kb`03o`08
bk_;^l^komd3o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbong0ol06l^kbk_;^l^kbooL]mbgg;Oo^l^k
bk_;ol^kb`03o`>100?oPH402X400on1P@03P@?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol7F`0L
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
3H402?o;^l^kbk_o0P000ol000030003o`0003<0000B0004o`0000?o10000onk^`03^`;o38400on1
P@0:P@04ok^k^`?o00BEgIGo1[/00onk^`0H^`03ok^k00^k00Sok;O/]nbgo`Jk0ol7P@03oh6100Z1
00?oPOl00_lG^`;o2e/00onk^`0H^`03oh6100J10ol00h7o^`0I^`03oh6100^100?o^k/01K/01?l0
0?l40003o`0003<0000B00Co20001onkbk_;^ol03H400on1P@04P@?o03G;^l^kbk_;oiGMUMfEol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0:^l^kbk_;ombgg0;o00Bgok_;
0ol;P@03oh6100Z101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^k
bol20003o`0000<000?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03o`>k0ol5^`07
oiGMUMfEo`0S^`?o0]`00onk^`04^`?o0k/3o`03POn100b100?oPH401843oajk00?oFe/02e/00onk
^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/01;/01?l00?l50003o`000340000D0003
o`0000T000Oo^l^kbk_o00f10_l00l^kb`03o`0;UMfEol^kbk_;oiD00_l09K_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01^`02_nkbk_;^l^kbk/2o`F100?oPH402h400on1P@03o`0S
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol03E/06Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol<P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`J11?l2P@09ol^kbk_;^l_o0080
00?o00000P02oc80000E0003o`0000T000?o^k/00k/00on1P@06P@?o0h400onko`07L@03ok^k00>k
00?o^k/07[/2o`Fk00?og=`01=`00onk^`03^`?o28400on1P@0;P@;o9[/00omKF`06F`?o5[/4o`:1
00?oPH402X400onk^`0I^`03oh6100?o1h400onk^`04^`05o`000?l010000ol0000`00005P000ol0
00090007ok_;^l^ko`05P@;o1h40;Oo;^ooMUMfEgIGobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`03o`0:g?nkbk_;^l_ok0?o00O;^l^kbk_o00b100?oPH401X43o`0[POnkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`05F`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0ol7P@03oh6100Z101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l;P@08ol^kbk_;^ol20003
o`0000<000?o0000;`0001L000?o00002@02o`Bk00?oPOl00_l:P@05ok^kog400olS^`07omc/g>cL
o`06^`03ok^k00Rk00?oPH402X400on1P@03P@;o1H400onk^`0V^`03oe_o00;o5K/3o`^100?oPH40
28400on1o`0J^`03oh6100Z100?o^k/01K/01?l00?l40003o`0002l0000H0003o`0000X000Kobk_;
^ol>P@14ol^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_ok=c/g?nkbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh7o00;o2840?onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`03POn100b100?oPH401843o`0O^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0<P@09ok_;^l^kbk_o008000?o00000P000ol0000^0000
6@000ol0000:0003ok^k00>k00?oPH402h400onk^`06^`;o6;/3o`Jk00Kok=cog?l3^`;o3;/00on1
P@0:P@03oh6100Z100?o^k/0>;/3o`F100?oPH402h400on1P@03ob:k00?oPH402X400onk^`04^`04
o`00o`D000?o0000;@0001X00_l;0007ol^kbk_;o`0=P@05ol^kbk/00ol05g7o^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00?o0n`01onkbk_;^l/00_l00k_;^`03o`0@Fonkbk_;^l^kbk_;^l^ko`J10ol3P@03
oh6100Z103Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00?o2H400on1P@0;P@;o02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
1h43o`0:POo;^l^kbk_;o`8000?o00000P02obh0000L0003o`0000T000?o^k/00k/2o`R10_l2P@0:
ok^kog7MLMeaoa>k00Wog>cLk=c/g?l02;/2o`EK00?o^k/02k/00on1P@03o`N100?oPH402X400onk
^`0G^`;o5k/3o`f100?oPH401X43obVk00?oPH400h42o`F100?o^k/01K/01?l00?l300;o;P0001d0
00?o00002@002?o;^l^kbk_o1843o`F101oobk_;omeagG7o^l^kbk_;^l^kbk_;^l^kbk_;^l_o00K/
00Go^l^kb`03o`QK00ko^l^kbk_;^l^kbk_;^`;o2h400on1P@0:P@0Fok_;^l^kbk_;^l^kbk_;^l^k
bk_;^`?o0U/05?o;^l^kbk_;^l^kbk_;^l^kbk_;0ol3P@03oh6100Z100?oPH400h43o`0_^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^koh400ol8P@08ol^kbk_;^ol20003
o`0000<000?o0000:`0001h000?o00002@000onk^`04^`04oh7oo`V100[o^k^komeaog7o5;/00oo/
o`02o`Fk00?oFe/02U/00onk^`0;^`03oh6100Z100?oPH401843oaJk0_l6F`03ok^k00fk0ol7P@03
oh6100Z100?oPOl00_l_^`?o38400onk^`04^`04o`00o`D000?o0000:P0001l000?o00002@002?o;
^l^kbk_o38401?o;^l/2o`0S^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbol035/03onk
bk_;^l^kbk_;^l^ko`0<P@03oh6100?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol9F`0=ol^kbk_;
^l^kbk_;^`02o`^100?oPH402X40;onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00Co0U/00on1P@0;P@08ol^kbk_;^ol20003o`00008000?o0000:P00020000?o0000
2@02o`Fk00?oPH402X400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@;o6;/00omKF`0;F`03
ok^k00Vk00?oPH402h400on1P@04P@?o6[/2oa:k0ol7F`03oh6100^100?o^k/00k/01Ol0003o00@0
00?o0000:@0002400_l;0007ok_;^l^ko`0<P@08ol^kbk_;^l/3o`0Nbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_o35/03onkbk_;^l^kbk_;^l^ko`06P@?o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol=F`0=ol^kbk_;^l^kbk_;o`0=P@03oh6100?o01Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`?o010Gol^kbk_;^l^kbk_;^l^k1?l;F`03oh6100J10ol02H7o^l^kbk_;o`020003o`0000<0
00?o0000:00002<000?o00002@000onk^`03^`03oh6100Z10_l2^`?o0g400onk^`0K^`03oe]K00AK
0ol3F`03ok^k00^k00?oPH400olQ^`03oe]K00]K00?o^k/02K/00on1P@0;P@;o7;/01omO5elGGol0
2K/4o`9K00?oFe/02U/00on1P@03P@?o1H400onk^`04^`04o`00o`<00_lZ000090000ol000090007
ok_;^l^ko`06P@?o1840:?nkbooMLMeagOo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o
1e/03_nkbk_;^l^kbk_;^l^k0_l05/^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0=^l^kbk_;^l^kbk_;
o`08F`?o00nkbk_;^l^kbk_;^l^kbol01X44o`:101oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o00DG00Oo^l^kbk_;00?o1e/00omKF`0:F`03oh7o00;o2H402?nkbk_;^l_o0P000ol000020003
o`0000D00ol300?o6@0002D000?o00002@000onk^`03^`03oh6100?o28401?nk^ol3L@03og7o01fk
0_l;F`03ok^k01nk0ol2P@03ok^k00^k00?oFe/00e/2oa:k00?oPH400ol7P@03ok^k01^k00Oo5elG
oaOo00>k0_l;F`03oe]K00QK00?oFol038400onk^`04^`04o`00o`D000?o00001@000ol000050003
o`0001H0000V0003o`0000T000Ko^l^kbk/2o`b100?o^l/00ol08/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol6P@0@ol^kbk_;
^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l;P@0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol01k_;^l^kbol035/00omKF`04F`Co0U/00on1P@0;P@08ol^kbk_;^ol20003
o`00008000?o00001@000ol000050003o`0001H0000W0003o`0000T000?o^k/01;/00on1P@0:P@03
ok^k02Bk00?oFe/02U/00onk^`0F^`Co2X400onk^`0;^`03ok^k01Nk00?oPH402X400onk^`0T^`03
oe]K00YK00?oFe/00ol7F`03oh6100^100?o^k/01;/01?l00?l40003o`0000@000?o00000P03oaT0
000X0003o`0000T00_l01/^kbk_;o`b100Oo^l^kbk_;00Co01fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`0<F`0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0X400on1P@0:P@0Yol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038406_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0_l01L^kbk_;00Co00>kbol02U/01?mKool;F`03oh6100J10ol02H7o^l^kbk_;o`020003o`000080
0_l50003o`00008000?o00006@0002T00_l;0003ok^k00>k00?oPH402X401?nk^k/2o`Aa00?o^k/0
6[/00omKF`04F`?o5;/3o`J100?oPH402X400onk^`0U^`03oh6100Z100?o^k/04k/3o`04Fonk^`?o
0aL01Onk^k_o00IK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003o`3o00@0
0_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>102So^l^komiagW7Nok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2X400on1P@08P@0[
oh7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`06P@?o0X404oo;^l^kbk_;
^l^kbk_;^l^kbk/00ol5F`0>ok_;oelGGaMOol^kbol2F`?o00Nkbk_;^l_o00eK00?oPOl00_l8P@08
ok_;^l^kbol20003o`00008000?o00008`0002`000?o00002@000onk^`03^`03oh6100?o1h401Onk
^k_o00=a00?oLOl07;/2oaVk00?oPH402H400on1P@04P@?o0h400onk^`0U^`03oh6100?o1X400onk
^`0<^`?o2E/01?nk^ol35`03oaOo00>k0_l:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D0
00?o00008P0002d000?o00002@001_o;^l^kb`;o2h401?nkbk/3o`0l^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2h400on1P@03o`N102Kobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X402oo;^l^kbk_;^l^k00?o35/01?o;
^l/3o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol6F`Co0U/00on1P@0:P@08ol^kbk_;^ol20003o`0000<0
00?o00008@0002h000?o00002@000onk^`04^`03oh6100V100?o^k/0?k/00on1P@09P@;o2h400onk
^`0N^`Co0U/00on1P@0:P@03ok^k00Bk0ol2F`03oe]K00]K00?o^k/05k/00omKF`03o`MK00?oPH40
2X400onk^`04^`04o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h402?nkbk_;^l^k
0ol0>;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`:100?oPH402X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@03
ol^k00?o1U/00omKF`0;F`07ol^kbk_;^`04o`0=bk_;^l^kbk_;^l^kb`04o`]K00?oPH401H43o`0:
POnkbk_;^l^ko`8000?o00000P000ol0000P0000<0000ol0000900;o1K/00on1P@09P@;o0[/3o`04
gW7NocNk00?oPH400ol6P@03oh6100Z100?o^k/05k/2o`]K00?oPH4028401?n1ool:F`03oe]K00IK
0ol5^`?o15l00onk^`06^`Co0U/00omKF`0:F`03oh6100>10_l5P@03ok^k00Bk00Co003o0`000ol0
o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@04ol^ko`Ea03So^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2X400on1P@0:P@0Kol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00aK00?oPH401843o`:100?oFe/02U/00omKF`03F`;o01Fkbk_;^l^kbomO
7elOGamOol^kbk/00ol7F`03oe]K00YK00?oPOl00_l8P@08ok_;^l^kbol20003o`00008000?o0000
7`0003<000?o00002@000onk^`03^`03oh6100?o1h402_nk^ooNLMkog_lf^`03oh6100Z100?oPH40
1843oafk00?oFe/02U/00on1P@03o`J100?oFe/02U/00omKo`02o`^k00?oGel00ol4^`;o2e/00omK
F`08F`03oe_o00b100?o^k/01;/01?l00?l40003o`0001h0000d0003o`0000T000Ko^l^kbk/2o`^1
00?obk/00ol0>k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00b100?oPH400ol08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`;o
2X400omKF`08F`0Boe_obk_;^l^kbk_;^l^kbk_;0_l02;_;^l^kbk_o35/00omKF`04F`Co00?;^ol0
3H401onkbk_;^ol00P000ol000030003o`0001d0000e0003o`0000T000?o^k/00k/00on1P@0:P@03
ok^k03fk00?oPH4028401?n1oolU^`03oe]K00AK0ol2^`03oh6100Z100?oFe/015/3o`=K00?o^k/0
4k/2o`03^omK00]K00?oFe/00ol7^`03oh6100^100?o^k/00k/01?l00?l40003o`0001d0000f0003
o`0000T000Oo^l^kbk_o00b100Oobk_;^l^k00?o02Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/01?l03<^kbk_;^l^kbk_;o`J10ol3P@0Xok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`9K0ol01k_;^l^kbol038400omKF`03o`MK01;obk_;^l^kbk_;^l^kbk_;
^l/3o`05Goo;^ol02U/04?mKoonkbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l00002oah0
000g0003o`0000T000?o^k/00k/00on1P@0:P@;o0[/2o`04LMiaob>k0ol4F`03ok^k00Vk00?oPH40
0ol7P@03ok^k02Bk0_l:^`03oh6100R100CoPOoo2e/00onk^`0=^`07oelOGamOo`02^`03oe]K00AK
0ol@^`03oh6100?o1h400onk^`03^`04o`00o`D000?o00006`0003P00_l:00;o00G;^l^ko`06P@?o
1840:?nkbomagW7Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`QK00cobk_;^l^kbk_;
^l/2o`^103Co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1X43o`04^l^ko`aK013obk_;^l^kbk_;^l^kbk_o1Ul01?o;^ol2F`?o01C;^l^kbk_;^l^kbk_;^l^k
bk_;^`;o2h401oo;^l^kbol00P000ol000020003o`0001/0000j0003o`0000T000?o^k/00[/00on1
P@03o`R100Wo^k_ogW7oLOl07;/2o`aK00?o^k/02K/00on1P@0:P@03ok^k032k00?oPH400ol7^`03
oe]K00YK00?o^k/03;/00olOo`02o`Fk0_lG^`03oh6100Z100?o^k/01;/01?l00?l40003o`0001X0
000k0003o`0000T000Gobk_;^`02o`b100?o^l/00_l08[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^ol<F`0=ol^kbk_;^l^kbk_;o`0<P@0cok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o00bkbk_;^l^kbk_;^ol6F`?o0U/0=?nkbk_;^l^kbk_;^l^k
bk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<P@0:ok_;^l^kbol0o`D000?o0000
6@0003`000?o00002@000onk^`03^`03oh6100Z100?o^k/01K/3oa^k00?oFe/02U/00onk^`09^`03
oh6100Z100?o^k/0?K/00omKF`03o`IK00?o^k/04[/2oabk00?oPH4028400on1o`05^`04o`00o`@0
00?o00006@0003d000?o00002@001_o;^l^kb`;o2h401Onkbk_;00;o023NLMko^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`IK0ol2F`0>ok_;^l^kbk_;^l^kbol6P@?o0h40@?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK017o^l^k
bk_;^l^kbk_;^l^kb`03o`0OGaoo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;
^l^kbk_o0P001?l00002oaX0000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X401?nk^ol6gP03
ok^k01Vk00?oFe/00ol6F`03ok^k00Zk00?oPH400ol7P@03ok^k03bk00?oFe/02E/00onk^`0=^`08
oamO7elOGolK^`03oh6100?o1h400onk^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;
^l^kbk_o0X43o`J102Ko^l_oLMiagW7Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2U/03Onk
bk_;^l^kbk_;^l/00_l;P@10ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`]K03?obk_;^l^kbk_;^l^kbk_;^olOGamO7onkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00_l;P@07ol^kbk_;o`020003o`0000<000?o00005P0004000_l:0003
ok^k00Bk0_l:P@05ok^komh00olN^`03oe]K00UK00?o^k/02[/00on1P@0:P@03ok^k03bk00?oFe/0
1e/00omKo`0@^`?o7[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000F0000@P000ol0000800;o
00Jkbk_;^ol;P@0Wok_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00]K00ko^l^k
bk_;^l^kbk_;o`b103oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol01U/3o`9K03Co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o38402?nkbk_;^l_o0P000ol000020003o`0001D000130003o`0000T0
00?o^k/00k/00on1P@09P@03ok^k00Fk0olK^`03oe]K00UK00?o^k/02[/00on1P@04P@?o0X400onk
^`0l^`03oe]K00?o1U/00onk^`0B^`?o6k/00on1P@08P@03oh7o00Fk00Co003o1@000ol0000D0000
A0000ol000090007ok_;^l^ko`0;P@;o00?;^ol00_l0877NLOnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_o1U/3o`0@bk_;^l^kbk_;^l^kbk_;o`:10ol6P@0mol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`YK017o^l^kbk_;^l^kbk_;^l^k
b`03o`9O01go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l0
0002oaH000150003o`0000T000?o^k/00k/00on1P@04P@?o0h402_nk^ooNLMiag_lK^`03oe]K00?o
4k/2o`Z100?o^k/0=[/3o`9K00?oFe/02U/00onk^`0=^`03oalO00<O00?o^k/06K/00on1P@03o`N1
00?o^k/01;/01?l00?l40003o`0001<000160003o`0000T000Oo^l^kbk_o00:10ol7P@0Tol^kog7N
LOmaok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol06<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`^1
03Gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`IK
00?oFe/02U/04Onkbk_;^l^kbk_;^l^kbk_o00=O01coGonkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1?l;P@0:ol^kbk_;^ol0o`<00olD0000A`000ol000090003ok^k00>k0_l;P@03ok^k00?o6[/3o`=K
00?o^k/05K/00on1P@09P@03ok^k02jk0ol:F`03oe]K00QK00?oFol03k/3oaVk0ol2P@03oh6100^1
00?o^k/00k/00ol00003o`8000?o00004P0004P00_l:0008ok_;^l^kbol;P@09ol^kbk_;^l^k00;o
017;^l^kbk_;^l^kbk_;^l^kb`03o`MK01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00^10_l0:k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol2F`03oe]K00UK00?oFe/0
15/3o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l04K_;^l^kbk_;^l^kbk_;^l^k00?o1X400on1
P@0;P@06ol^kbk_;0_l00`3o00020003o`000180001:0003o`0000P00_l5^`03oh6100V100?o^k/0
0[/3o`03g_nk00bk1?l;F`03ok^k01Fk00?oPH401843o`>100?o^k/09K/3o`IK00?oFe/02E/00omK
F`03oaRk0ol00eoo^`0<^`Co2X400on1P@04P@Co2K/00ol0o`030003o`000180001;0003o`0000T0
00Oobk_;^l_o00J10ol2P@04ol^ko`GN00[o^l^kbk_;^l^k0ol3F`03oe]K00YK01Wobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00:10ol7P@0Sok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
1?l:F`03oe]K00MK02koFooo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o7aLO5aoobk_;^l^kbk_;
0ol2P@03oh6100Z100?oPH400ol02;_;^l^kbk_;0ol50004o`00oa@0001<0003o`0000T000?o^k/0
0k/00on1P@03o`J100[o^k_ogW7NLMko1K/3o`MK00?oFe/02U/00onk^`0E^`;o2h400onk^`0L^`?o
0U/00omKF`0:F`04oe]KF`Go6;/2o`Fk00?oGel00el00onk^`03^`?o1X400on1P@0:P@;o1k/4o`T0
00Co003o4`0004d000?o00002@001_o;^l^kb`;o2X401Oo;^ooN00;o00G;^l^kb`02o`]K00?oFe/0
15/3o`0Lbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`b101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00ol6F`03oe]K00YK0ol06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol025oo^l^kbk_;
0ol01<^kbk/4o`Z100?oPH401843o`08bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk
^`03^`03oh6100V100Co^k_o2K/00omKF`09F`03oe]K00?o7k/00on1P@0:P@03ok^k01Fk0_l:F`03
oe]K00AK0olN^`03oemO00=O00?o^k/01K/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0
001?00;o2P001oo;^l^kbol02h401oo;^l^kbk/00ol01;_;^ol;F`;o02C;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbol6P@?o0X406_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2e/00omK
F`03o`0Kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o00fkbk_;^omO7elOGonk00Go28400on1
P@0:P@;o00O;^l^kbk_;00?o5P02oa<0001A0003o`0000P000?o^k/00k/00on1P@09P@;o0[/2o`?N
00Go^k^ko`06F`?o9k/00on1P@03o`J100?o^k/05[/00omKF`09F`;o6k/3o`03Gonk00Fk0ol01;_o
ool2P@03oh6100V100?oPH401843o`Nk1?lH00?o4`00058000?o00002002o`05^l^kbol01X43o`>1
00Co^l_o1=h01Onkbk_o009K0ol0:l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l:P@0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6F`?o01k;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol57`07ol^kbk_;^`03o`J100?oPH402H400on1P@03o`07^l^kbk_;^`03oaT0
0olF0000D`000ol000090003ok^k00:k00?oPH400ol7P@04ok^ko`;N00?og_l00k/2objk00?oPH40
2X400onk^`0F^`03oe]K00?o6K/3o`Fk00SoGamO7eoo^`Co2X400on1P@07P@04oh7oo`Jk1?lH00Co
6@0005@000?o00002@001Onkbk_;00;o2h400onkb`02o`0h^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol<P@07ol^kbk_;^`04o`0>bk_;^l^kbk_;^l^k
bk/2o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1
P@09P@03oh6100B10ol01l^kbk_;^l/00olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V1
00?o^k/01K/2oc:k00?oPH4028400on1o`02^`?o1=l00onk^`0W^`07oamO7elOo`05^`?o1X400on1
P@09P@03oh6100?o1[/4oaP01?lP0000EP000ol000090007ok_;^l^ko`0;P@;o00?;^l/00_l2gP0d
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol01l^k
bk_;^ol01]l08_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0;bk_;^l_o7elOoal0
1Ol:P@03oh6100N100[oPOoobk_;^l^k0olH00Co900005L00_l:0003ok^k00>k00?oPH401843o`>1
00?o^ol01Mh00onk^`0`^`03oh6100?o0[/3o`Fk00?ogol00_lP^`?o0al00onk^`03^`Ko0X400on1
P@09P@03oh6100B10ol6^`Co6003obP0001I0003o`0000P000Oo^l^kbk_o00:10ol7P@03ol_o00GN
03?obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l00l^k
o`02o`0^g]oNok_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`HO00Gobk_;
^`03o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X000?o000020000onk^`03^`;o
2h400onko`02ocVk00?ogml01=l00onk^`07^`?o5K/3o`Fk00?o7ol00_l3^`?o2X400on1P@07P@04
oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h402?o;^l^kbk_;0_l0;;_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l01[_;^l_og`?o00?;^l/00ol00l^k
o`02o`;O01?obk_;^l^kbk_;^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1
PH45o`06bk_;^l^k0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100Co^k^k0ol00mko
^`0;^`Co6[/2o`05gmkOg_l01;/01?nk^k/3o`>100Co^k_o1=l00onk^`09^`;o1;/00olS8`048`03
ok^k00>k0ol6P@03oh6100V10ol7^`Co6003ocH0001M0003o`0000T000Oobk_;^l_o00J10ol2P@0?
ol_og]oNgmkobk_;^l^k00Go15/05?o;^l^kbk_;^l^kbk_;^l^kbk_;0_l01[_;^l^ko`GO00Go^l^k
b`03o`N100Cobk_o0]l02ooOol^kbk_;^l^k00;o0]l01onkbk_;ob<00ol00l^kb`04o`Z100?oPH40
1843o`08^l^kbk_;^l/3oaP01?li0000GP000ol000090003ok^k00>k00?oPH400ol6P@09ok^komoN
gmko00>k0_l:F`03ok^k00fk0ol00mko^`05^`?o1K/2o`^100?o^k/00_l:^`03oinO00>O00?o^k/0
0[/01?nk^k/3o`:100?oPH402X400on1P@03o`Nk1?lH00?o?@0005l00_l:0006ol^kbk_;0_l:P@03
ol^k00;o00S;^l^kbk_;o`]K02Cobk_;^l^kbk_;^l^kbooOg]oNgoo;^l^kbk_;^l^kbk_;^ol<P@08
ol^kbk_;^l/2o`06^l^kbk_o1Ml01Onkbk_;00?o1X400on1P@0:P@;o00Nkbk_;^l^k00?o6004od00
001Q0003o`0000P000?o^k/00k/00on1P@09P@03ok^k00Fk0_l2^`03oe]K00UK00?o^k/01;/3o`Fk
00KogmkOg_l>^`03oh6100Z100Co^k^k0ol00moo^`05^`?o0k/4o`Z100?oPH401843o`Nk1?lH00?o
A000068000?o000020001oo;^l^kbol02h42o`03^l^k00;o0]h01?nkbol;F`03ol^k00?o0]l01oo;
^l^kbk/00_l04l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:1013o^l_ogioOWmoobk_;^l^k1Ol3P@03
oh6100V100?oPH400ol01l^kbk_;^l/00olH00CoA`0006<000?o00002002o`Bk00?oPH401843o`>1
00Wo^ooNgmkOg_l00[/00omKF`04F`?o1K/00ooNgP02gP03ok^k01Rk00?oPH400ol6P@0;ok^k^onO
gioOok/01?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T000Ko^l^kbol2P@?o1h400onk
o`05gP04ok_;o`9K0ol02[_ooonkbk_;^ol2g`0Momoobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l:P@04ok_;^`;o00C;oooo0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0001U0003
o`0000T000?o^k/00[/2o`^100?o^ol00_l6^`;o00Bkoooo0ml00onk^`03^`;o7[/00on1P@09P@03
ok^k00?o1X400on1P@09P@03oh6100?o1K/4oaL01?mB0000IP000ol000090007ok_;^l^ko`0;P@08
ok_;^l^kbk/2o`0abk_;^ooOg]oNgonkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
o`0;P@;o2X400on1P@07P@08oh7ool^kbk/4oaP00omF0000I`02o`X000?o^k/00k/00on1P@09P@04
ok^k^`?o00?Ook/01;/01?oOoolX^`03oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0
001Y0003o`0000P000Oo^l^kbk_o00J10ol2P@03ok_o00GN03?o^l^kbk_o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?o
G@0006X000?o000020000onk^`03^`03oh6100?o1X401?nk^ol4g`03ok^k02fk1?l:P@03oh6100B1
0ol7^`?o6004of00001[0003o`0000P00_l01<^kbk/2o`Z100?o^l/00_l0;K_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`05o`B100?oPH4028400on1P@03o`06bk_;^l^k
1?lH00?oI00006`000?o00002@000onk^`02^`03oh6100V100?o^k/0:k/3o`Z100?oPH402842o`Jk
0olH00CoI`0006d000?o00002@001_o;^l^ko`^102[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/3o`:100?oPH402H400on1P@05o`06^l^kbk_;1?lH00?oJ`0006h00_l:0003
ok^k00:k00?oPH401843o`:100?o^k/08k/3o`J100?oPH402H42o`Rk0olH00CoKP00070000?o0000
20001_o;^l^ko`:10ol6P@0Qok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co2X400on1
P@04P@?o00Nkbk_;^l^k00Co5`04og80001a0003o`0000P000?o^k/00[/2o`Z100?o^k/06;/5o`>1
00?oPH402H400on1P@03o`Nk0olH00?oMP00078000?o000020001oo;^l^kbol02X405onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?o2H400on1P@09P@;o00Jkbk_;^l/4oaL01?mi0000L`000ol0000800;o
1;/00on1P@08P@03ok^k012k0ol2P@03oh6100R100?oPH401843o`Jk0olH00?oO@0007@000?o0000
2@001_nkbk_;o`:11Ol3P@0?ok_;^l^kbk_;^l^kbk_;00?o1X400on1P@08P@03oh6100?o00Fkbk_;
^`04oaL01?n00000M@000ol000090003ok^k00:k0_l9P@03ok^k00Rk0ol:P@03oh6100J100CoPOoo
1K/3oaP00on40000MP02o`X000Oo^l^kbk_o00V100Oo^l^kbk_;00?o0X400on1P@09P@03oh6100Go
00G;^l^kb`04oaL01?n70000N0000ol000080003ok^k00>k00?oPH401h400onk^`03o`J100?oPH40
2H42o`Nk0olH00?oR`0007T000?o000020001onkbk_;^ol01h401?n1ool:P@03oh6100B10ol01/^k
bk_;^`Co5`04ohh0001j0003o`0000P000?o^k/00k/00on1P@04o`B100?oPH4028400on1P@03o`Jk
0olH00?oTP0007/000?o000020001_nkbk_;^`;o2H400on1P@08P@;o00G;^l^kb`04oaL01?nE0000
O0000ol0000800;o1;/00on1P@08P@03oh6100Go1[/3oaL01?nI0000O@000ol000090006ol^kbk_o
2X42o`07^l^kbk_;^`04oaL00onM0000OP02o`X000?o^k/00[/00on1P@03P@?o1k/3oaL01?nP0000
P0000ol000080007ol^kbk_oP@03o`06^l^kbk_;1?lG00?oY000084000?o000020000onk^`02^`03
ok^k00Bk0olG00CoY`00088000?o000020001oo;^l^kbk/01?lG00?oZ`0008<000?o000020000onk
^`03oaL01?n^0000Q0000ol0000700?o5`03ok80002500;o1`000ol0000C00Co]@0008L000?o0000
10000ol0000@00?o^@0008P000?o00000`000ol0000<00Co_00008T000Go0000o`0;00Co`00008X0
00Co003o2003ol@0002;0003o`3o00@01?o70000S002o`040?oool/0002=00;ocP000?l0GP000?l0
GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000980
00?o00009`000ol0002N0000K@04o`<01?l0103oo`02o`800_l300?o1002o`@000?o00002005o`04
0?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l300?o10000ol0000300;o
K`0006`000Go0000o`020003o`0000<000Co003o0`02o`@000?o00000P001?l00?l40003o`0000T0
00Go0000o`020004o`00o`<000?o00000_l40003o`0000@000?o00001`000ol000050003o`000080
00Co003o0P02o`@000?o00000`000ol0000300;oK`0006`000?o0?l00_l200Go00D0o`00o`090003
o`00008000Co003o40001Ol0003o008000Co003o0`000ol000060003o`0000h000?o00001@000ol0
00020003o`0000T000?o000010000ol0001c0000K0000ol000040007o`000?l0o`020003o`0000L0
00?o00000P03oa4000Go0000o`020004o`00o`<000?o00001P000ol0000>00?o1@000ol000020003
o`0000T000?o000010000ol0001c0000K0001Ol0003o00<00ol00`3oo`03o`T000?o00000P000ol0
000A0003o`0000Go0`04o`P000?o00003P000ol0000400;o0`04o`T000?o00001@000ol0001b0000
K@04oa@00_l500?o3P05o`/000?o00001@02o`l01Ol90003o`0000P00_l400CoM0000:`00_lQ0003
o`00008000?o0000QP000?l0GP000001\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 16"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 9",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 17",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 17", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.228966 1.482978 0.019821 0.956272 [
[(Gen.17, Ind.1, Fit.18.)] .5 1 0 -1.5 Msboxa
[(5)] .2209 .11739 .84711 1 Msboxa
[(10)] .37286 .07872 .79164 1 Msboxa
[(15)] .52998 .03876 .73617 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29966 .03591 .79718 1 Msboxa
P
[(5)] .71954 .07902 -1 .38097 Msboxa
[(10)] .79618 .14939 -1 .36667 Msboxa
[(15)] .86836 .21568 -1 .3534 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .8757 .1219 -1 .36805 Msboxa
P
[(0)] .0964 .17354 1 -0.3911 Msboxa
[(10)] .07529 .34549 1 -0.36222 Msboxa
[(20)] .05185 .5365 1 -0.32998 Msboxa
[(30)] .02567 .74991 1 -0.29376 Msboxa
[(t)] -0.02552 .47225 1 -0.34413 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.17, Ind.1, Fit.18.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11523 .15634 m
.6375 .02391 L
s
P
p
.002 w
.23289 .12651 m
.23888 .13107 L
s
P
[(5)] .2209 .11739 .84711 1 Mshowa
p
.002 w
.38437 .0881 m
.39012 .09278 L
s
P
[(10)] .37286 .07872 .79164 1 Mshowa
p
.002 w
.54097 .04839 m
.54646 .0532 L
s
P
[(15)] .52998 .03876 .73617 1 Mshowa
p
.001 w
.26278 .11893 m
.26635 .12168 L
s
P
p
.001 w
.29288 .1113 m
.29642 .11406 L
s
P
p
.001 w
.32317 .10361 m
.32668 .10639 L
s
P
p
.001 w
.35367 .09588 m
.35715 .09868 L
s
P
p
.001 w
.41527 .08026 m
.41869 .08309 L
s
P
p
.001 w
.44638 .07237 m
.44977 .07521 L
s
P
p
.001 w
.4777 .06443 m
.48106 .06729 L
s
P
p
.001 w
.50923 .05643 m
.51256 .05931 L
s
P
p
.001 w
.20318 .13404 m
.20681 .13676 L
s
P
p
.001 w
.17367 .14152 m
.17732 .14423 L
s
P
p
.001 w
.14436 .14896 m
.14803 .15165 L
s
P
p
.001 w
.57293 .04028 m
.57619 .04318 L
s
P
p
.001 w
.6051 .03212 m
.60834 .03504 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29966 .03591 .79718 1 Mshowa
P
P
p
p
.002 w
.6375 .02391 m
.89218 .25755 L
s
P
p
.002 w
.70222 .08328 m
.69356 .08541 L
s
P
[(5)] .71954 .07902 -1 .38097 Mshowa
p
.002 w
.77877 .15351 m
.77007 .15557 L
s
P
[(10)] .79618 .14939 -1 .36667 Mshowa
p
.002 w
.85088 .21967 m
.84214 .22166 L
s
P
[(15)] .86836 .21568 -1 .3534 Mshowa
p
.001 w
.7179 .09767 m
.7127 .09894 L
s
P
p
.001 w
.7334 .11188 m
.72819 .11314 L
s
P
p
.001 w
.74871 .12593 m
.74349 .12718 L
s
P
p
.001 w
.76383 .1398 m
.75861 .14104 L
s
P
p
.001 w
.79354 .16705 m
.78831 .16828 L
s
P
p
.001 w
.80813 .18044 m
.8029 .18166 L
s
P
p
.001 w
.82255 .19367 m
.81731 .19488 L
s
P
p
.001 w
.8368 .20674 m
.83156 .20795 L
s
P
p
.001 w
.68634 .06871 m
.68115 .07 L
s
P
p
.001 w
.67026 .05396 m
.66508 .05526 L
s
P
p
.001 w
.65399 .03903 m
.6488 .04033 L
s
P
p
.001 w
.86481 .23244 m
.85956 .23363 L
s
P
p
.001 w
.87857 .24507 m
.87332 .24625 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .8757 .1219 -1 .36805 Mshowa
P
P
p
p
.002 w
.11523 .15634 m
.03707 .79902 L
s
P
p
.002 w
.11367 .16918 m
.1223 .167 L
s
P
[(0)] .0964 .17354 1 -0.3911 Mshowa
p
.002 w
.09272 .34142 m
.10143 .33939 L
s
P
[(10)] .07529 .34549 1 -0.36222 Mshowa
p
.002 w
.06945 .53276 m
.07825 .53088 L
s
P
[(20)] .05185 .5365 1 -0.32998 Mshowa
p
.002 w
.04346 .74655 m
.05235 .74486 L
s
P
[(30)] .02567 .74991 1 -0.29376 Mshowa
p
.001 w
.10965 .20224 m
.11483 .20095 L
s
P
p
.001 w
.10554 .23597 m
.11074 .2347 L
s
P
p
.001 w
.10136 .2704 m
.10657 .26914 L
s
P
p
.001 w
.09708 .30554 m
.1023 .3043 L
s
P
p
.001 w
.08826 .37807 m
.0935 .37686 L
s
P
p
.001 w
.08371 .41549 m
.08896 .41431 L
s
P
p
.001 w
.07906 .45373 m
.08432 .45257 L
s
P
p
.001 w
.07431 .49281 m
.07958 .49167 L
s
P
p
.001 w
.06449 .5736 m
.06978 .5725 L
s
P
p
.001 w
.05941 .61536 m
.06471 .61428 L
s
P
p
.001 w
.05421 .65809 m
.05953 .65703 L
s
P
p
.001 w
.0489 .7018 m
.05422 .70077 L
s
P
p
.001 w
.03789 .79235 m
.04323 .79136 L
s
P
[(t)] -0.02552 .47225 1 -0.34413 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11367 .16918 m
.4049 .37855 L
s
P
p
.4 g
.002 w
.09272 .34142 m
.39979 .54405 L
s
P
p
.4 g
.002 w
.06945 .53276 m
.39418 .72604 L
s
P
p
.4 g
.002 w
.04346 .74655 m
.38798 .9271 L
s
P
p
.4 g
.002 w
.18864 .20945 m
.1267 .84444 L
s
P
p
.4 g
.002 w
.27574 .27245 m
.23197 .8978 L
s
P
p
.4 g
.002 w
.35804 .33198 m
.33041 .94768 L
s
P
.002 w
.11523 .15634 m
.03707 .79902 L
s
.03707 .79902 m
.38647 .97609 L
s
.38647 .97609 m
.40528 .36615 L
s
.40528 .36615 m
.11523 .15634 L
s
.6375 .02391 m
.89218 .25755 L
s
.89218 .25755 m
.96293 .88523 L
s
.96293 .88523 m
.66382 .68391 L
s
.66382 .68391 m
.6375 .02391 L
s
.11523 .15634 m
.03707 .79902 L
s
.03707 .79902 m
.66382 .68391 L
s
.66382 .68391 m
.6375 .02391 L
s
.6375 .02391 m
.11523 .15634 L
s
p
.4 g
.51542 .34158 m
.51594 .95569 L
s
P
p
.4 g
.65684 .31004 m
.68296 .92936 L
s
P
p
.4 g
.80258 .27753 m
.85604 .90208 L
s
P
p
.4 g
.4049 .37855 m
.8936 .27019 L
s
P
p
.4 g
.39979 .54405 m
.91268 .43943 L
s
P
p
.4 g
.39418 .72604 m
.93376 .6265 L
s
P
p
.4 g
.38798 .9271 m
.95719 .83439 L
s
P
.40528 .36615 m
.89218 .25755 L
s
.89218 .25755 m
.96293 .88523 L
s
.96293 .88523 m
.38647 .97609 L
s
.38647 .97609 m
.40528 .36615 L
s
p
.4 g
.23289 .12651 m
.51542 .34158 L
s
P
p
.4 g
.38437 .0881 m
.65684 .31004 L
s
P
p
.4 g
.54097 .04839 m
.80258 .27753 L
s
P
p
.4 g
.18864 .20945 m
.70222 .08328 L
s
P
p
.4 g
.27574 .27245 m
.77877 .15351 L
s
P
p
.4 g
.35804 .33198 m
.85088 .21967 L
s
P
P
p
.002 w
.4108 .36989 m .41857 .37551 L .4049 .37855 L p
.4 g
F P
s
P
p
.002 w
.4049 .37855 m .3971 .37294 L .4108 .36989 L p
.4 g
F P
s
P
p
.002 w
.8936 .27019 m .4049 .37855 L .11367 .16918 L p
.9 g
F P
s
P
p
.002 w
.43229 .37247 m .41857 .37551 L p
.4108 .36989 L .4 g
F P
s
P
p
.002 w
.4108 .36989 m .3971 .37294 L .38926 .36731 L p
.4 g
F P
s
P
p
.002 w
.43833 .36377 m .44604 .36942 L .43229 .37247 L p
.4 g
F P
s
P
p
.002 w
.4108 .36989 m .43833 .36377 L p
.43229 .37247 L .4 g
F P
s
P
p
.002 w
.38926 .36731 m .38138 .36164 L p
.4108 .36989 L .4 g
F P
s
P
p
.002 w
.38138 .36164 m .39514 .35856 L .4108 .36989 L p
.4 g
F P
s
P
p
.002 w
.45984 .36637 m .44604 .36942 L p
.43833 .36377 L .4 g
F P
s
P
p
.002 w
.46601 .35761 m .47368 .3633 L .45984 .36637 L p
.4 g
F P
s
P
p
.002 w
.43833 .36377 m .46601 .35761 L p
.45984 .36637 L .4 g
F P
s
P
p
.002 w
.48755 .36022 m .47368 .3633 L p
.46601 .35761 L .4 g
F P
s
P
p
.002 w
.39514 .35856 m .38138 .36164 L .37346 .35594 L p
.4 g
F P
s
P
p
.002 w
.49386 .35141 m .50147 .35713 L .48755 .36022 L p
.4 g
F P
s
P
p
.002 w
.46601 .35761 m .49386 .35141 L p
.48755 .36022 L .4 g
F P
s
P
p
.002 w
.37346 .35594 m .36549 .35022 L p
.39514 .35856 L .4 g
F P
s
P
p
.002 w
.36549 .35022 m .37929 .3471 L .39514 .35856 L p
.4 g
F P
s
P
p
.002 w
.51543 .35404 m .50147 .35713 L p
.49386 .35141 L .4 g
F P
s
P
p
.002 w
.52188 .34518 m .52944 .35093 L .51543 .35404 L p
.4 g
F P
s
P
p
.002 w
.49386 .35141 m .52188 .34518 L p
.51543 .35404 L .4 g
F P
s
P
p
.002 w
.54348 .34782 m .52944 .35093 L p
.52188 .34518 L .4 g
F P
s
P
p
.002 w
.37929 .3471 m .36549 .35022 L .35748 .34446 L p
.4 g
F P
s
P
p
.002 w
.55007 .33891 m .55757 .3447 L .54348 .34782 L p
.4 g
F P
s
P
p
.002 w
.52188 .34518 m .55007 .33891 L p
.54348 .34782 L .4 g
F P
s
P
p
.002 w
.35748 .34446 m .34942 .33867 L p
.37929 .3471 L .4 g
F P
s
P
p
.002 w
.34942 .33867 m .36328 .33551 L .37929 .3471 L p
.4 g
F P
s
P
p
.002 w
.5717 .34156 m .55757 .3447 L p
.55007 .33891 L .4 g
F P
s
P
p
.002 w
.57842 .3326 m .58587 .33842 L .5717 .34156 L p
.4 g
F P
s
P
p
.002 w
.55007 .33891 m .57842 .3326 L p
.5717 .34156 L .4 g
F P
s
P
p
.002 w
.43493 .33454 m .40703 .34084 L .39112 .32918 L p
.8 g
F P
s
P
p
.002 w
.57842 .3326 m .55007 .33891 L .53494 .32723 L p
.4 g
F P
s
P
p
.002 w
.36328 .33551 m .34942 .33867 L .34132 .33284 L p
.4 g
F P
s
P
p
.002 w
.60008 .33527 m .58587 .33842 L p
.57842 .3326 L .4 g
F P
s
P
p
.002 w
.34132 .33284 m .33317 .32698 L p
.36328 .33551 L .4 g
F P
s
P
p
.002 w
.33317 .32698 m .34708 .3238 L .36328 .33551 L p
.4 g
F P
s
P
p
.002 w
.60695 .32625 m .61434 .33211 L .60008 .33527 L p
.4 g
F P
s
P
p
.002 w
.57842 .3326 m .60695 .32625 L p
.60008 .33527 L .4 g
F P
s
P
p
.002 w
.46299 .32821 m .43493 .33454 L .41912 .32282 L p
.8 g
F P
s
P
p
.002 w
.39112 .32918 m .41912 .32282 L .43493 .33454 L p
.8 g
F P
s
P
p
.002 w
.53494 .32723 m .56341 .32085 L .57842 .3326 L p
.4 g
F P
s
P
p
.002 w
.62864 .32894 m .61434 .33211 L p
.60695 .32625 L .4 g
F P
s
P
p
.002 w
.41912 .32282 m .39112 .32918 L .37503 .3174 L p
.8 g
F P
s
P
p
.002 w
.63565 .31986 m .64298 .32576 L .62864 .32894 L p
.4 g
F P
s
P
p
.002 w
.60695 .32625 m .63565 .31986 L p
.62864 .32894 L .4 g
F P
s
P
p
.002 w
.41912 .32282 m .4473 .31641 L .46299 .32821 L p
.8 g
F P
s
P
p
.002 w
.56341 .32085 m .53494 .32723 L .51964 .31542 L p
.4 g
F P
s
P
p
.002 w
.34708 .3238 m .33317 .32698 L .32498 .3211 L p
.4 g
F P
s
P
p
.002 w
.65737 .32257 m .64298 .32576 L p
.63565 .31986 L .4 g
F P
s
P
p
.002 w
.32498 .3211 m .31675 .31517 L p
.34708 .3238 L .4 g
F P
s
P
p
.002 w
.31675 .31517 m .33071 .31195 L .34708 .3238 L p
.4 g
F P
s
P
p
.002 w
.37503 .3174 m .40314 .31096 L .41912 .32282 L p
.8 g
F P
s
P
p
.002 w
.66452 .31344 m .6718 .31937 L .65737 .32257 L p
.4 g
F P
s
P
p
.002 w
.63565 .31986 m .66452 .31344 L p
.65737 .32257 L .4 g
F P
s
P
p
.002 w
.51964 .31542 m .49123 .32183 L .47565 .30996 L p
.8 g
F P
s
P
p
.002 w
.51964 .31542 m .54822 .30897 L .56341 .32085 L p
.4 g
F P
s
P
p
.002 w
.68627 .31616 m .6718 .31937 L p
.66452 .31344 L .4 g
F P
s
P
p
.002 w
.69357 .30698 m .70079 .31294 L .68627 .31616 L p
.4 g
F P
s
P
p
.002 w
.66452 .31344 m .69357 .30698 L p
.68627 .31616 L .4 g
F P
s
P
p
.002 w
.54822 .30897 m .51964 .31542 L .50417 .30348 L p
.8 g
F P
s
P
p
.002 w
.47565 .30996 m .50417 .30348 L .51964 .31542 L p
.8 g
F P
s
P
p
.002 w
.33071 .31195 m .31675 .31517 L .30846 .30922 L p
.4 g
F P
s
P
p
.002 w
.69357 .30698 m .66452 .31344 L .64986 .30148 L p
.8 g
F P
s
P
p
.002 w
.71535 .30972 m .70079 .31294 L p
.69357 .30698 L .4 g
F P
s
P
p
.002 w
.30846 .30922 m .30013 .30323 L p
.33071 .31195 L .4 g
F P
s
P
p
.002 w
.30013 .30323 m .31415 .29997 L .33071 .31195 L p
.4 g
F P
s
P
p
.002 w
.7228 .30047 m .72995 .30648 L .71535 .30972 L p
.4 g
F P
s
P
p
.002 w
.69357 .30698 m .7228 .30047 L p
.71535 .30972 L .4 g
F P
s
P
p
.002 w
.57698 .30248 m .54822 .30897 L .53287 .29696 L p
.8 g
F P
s
P
p
.002 w
.50417 .30348 m .53287 .29696 L .54822 .30897 L p
.8 g
F P
s
P
p
.002 w
.7228 .30047 m .69357 .30698 L .67902 .29494 L p
.8 g
F P
s
P
p
.002 w
.64986 .30148 m .67902 .29494 L .69357 .30698 L p
.8 g
F P
s
P
p
1 .019 0 r
.01 w
.64272 .31071 m
.67174 .30423 L
s
P
p
.002 w
.7446 .30323 m .72995 .30648 L p
.7228 .30047 L .4 g
F P
s
P
p
.002 w
.53287 .29696 m .50417 .30348 L .48853 .2914 L p
.4 g
F P
s
P
p
1 .284 0 r
.01 w
.61454 .33968 m
.64358 .33327 L
s
P
p
.002 w
.75221 .29393 m .7593 .29997 L .7446 .30323 L p
.4 g
F P
s
P
p
.002 w
.7228 .30047 m .75221 .29393 L p
.7446 .30323 L .4 g
F P
s
P
p
.002 w
.31415 .29997 m .30013 .30323 L .29175 .29721 L p
.4 g
F P
s
P
p
1 .416 0 r
.01 w
.58592 .35742 m
.61488 .35106 L
s
P
p
.002 w
.53287 .29696 m .56174 .29039 L .57698 .30248 L p
.8 g
F P
s
P
p
1 .303 0 r
.01 w
.61459 .3413 m
.61459 .3413 L
s
P
p
1 .435 0 r
.01 w
.58596 .35905 m
.58596 .35905 L
s
P
p
1 .322 0 r
.01 w
.61464 .34292 m
.61464 .34292 L
s
P
p
1 .454 0 r
.01 w
.58599 .36068 m
.58599 .36068 L
s
P
p
.002 w
.75221 .29393 m .7228 .30047 L .70837 .28836 L p
.8 g
F P
s
P
p
.002 w
.67902 .29494 m .70837 .28836 L .7228 .30047 L p
.8 g
F P
s
P
p
1 .038 0 r
.01 w
.67182 .30583 m
.70103 .29932 L
s
P
p
1 .341 0 r
.01 w
.61469 .34455 m
.61469 .34455 L
s
P
p
.002 w
.29175 .29721 m .28333 .29115 L p
.31415 .29997 L .4 g
F P
s
P
p
.002 w
.28333 .29115 m .2974 .28786 L .31415 .29997 L p
.4 g
F P
s
P
p
.002 w
.77404 .2967 m .7593 .29997 L p
.75221 .29393 L .4 g
F P
s
P
p
1 .473 0 r
.01 w
.58603 .36231 m
.58603 .36231 L
s
P
p
1 .36 0 r
.01 w
.61473 .34617 m
.61473 .34617 L
s
P
p
1 .492 0 r
.01 w
.58606 .36394 m
.58606 .36394 L
s
P
p
1 .379 0 r
.01 w
.61478 .3478 m
.61478 .3478 L
s
P
p
1 .511 0 r
.01 w
.57087 .35382 m
.5861 .36558 L
s
P
p
1 .265 0 r
.01 w
.64352 .33164 m
.67272 .32519 L
s
P
p
1 .397 0 r
.01 w
.61483 .34943 m
.61483 .34943 L
s
P
p
.002 w
.48853 .2914 m .51734 .2848 L .53287 .29696 L p
.4 g
F P
s
P
p
.002 w
.78179 .28735 m .78882 .29343 L .77404 .2967 L p
.4 g
F P
s
P
p
.002 w
.75221 .29393 m .78179 .28735 L p
.77404 .2967 L .4 g
F P
s
P
p
.002 w
.63502 .28938 m .60591 .29595 L .59079 .28379 L p
.8 g
F P
s
P
p
1 .057 0 r
.01 w
.70112 .30092 m
.73052 .29437 L
s
P
p
.002 w
.78179 .28735 m .75221 .29393 L .7379 .28175 L p
.8 g
F P
s
P
p
.002 w
.70837 .28836 m .7379 .28175 L .75221 .29393 L p
.8 g
F P
s
P
p
.002 w
.37064 .28684 m .34231 .29343 L .32567 .28123 L p
.8 g
F P
s
P
p
.002 w
.80365 .29014 m .78882 .29343 L p
.78179 .28735 L .4 g
F P
s
P
p
1 .246 0 r
.01 w
.67264 .32357 m
.70201 .31707 L
s
P
p
.002 w
.51734 .2848 m .48853 .2914 L .4727 .27919 L p
.4 g
F P
s
P
p
.002 w
.2974 .28786 m .28333 .29115 L .27485 .28506 L p
.4 g
F P
s
P
p
.002 w
.81156 .28072 m .81853 .28684 L .80365 .29014 L p
.4 g
F P
s
P
p
.002 w
.78179 .28735 m .81156 .28072 L p
.80365 .29014 L .4 g
F P
s
P
p
.002 w
.66431 .28277 m .63502 .28938 L .62002 .27714 L p
.8 g
F P
s
P
p
.002 w
.59079 .28379 m .62002 .27714 L .63502 .28938 L p
.8 g
F P
s
P
p
1 .076 0 r
.01 w
.73063 .29598 m
.76023 .28938 L
s
P
p
.002 w
.27485 .28506 m .26633 .27893 L p
.2974 .28786 L .4 g
F P
s
P
p
.002 w
.26633 .27893 m .28046 .2756 L .2974 .28786 L p
.4 g
F P
s
P
p
.002 w
.81156 .28072 m .78179 .28735 L .76761 .27509 L p
.8 g
F P
s
P
p
.002 w
.7379 .28175 m .76761 .27509 L .78179 .28735 L p
.8 g
F P
s
P
p
1 .871 0 r
.01 w
.43956 .39888 m
.41093 .40514 L
s
P
p
.002 w
.83345 .28353 m .81853 .28684 L p
.81156 .28072 L .4 g
F P
s
P
p
.002 w
.39915 .28021 m .37064 .28684 L .35411 .27457 L p
.8 g
F P
s
P
p
.002 w
.32567 .28123 m .35411 .27457 L .37064 .28684 L p
.8 g
F P
s
P
p
1 .227 0 r
.01 w
.70192 .31545 m
.73146 .30891 L
s
P
p
1 .89 0 r
.01 w
.41089 .4068 m
.41089 .4068 L
s
P
p
1 .909 0 r
.01 w
.41084 .40847 m
.39452 .39689 L
s
P
p
.002 w
.4727 .27919 m .50163 .27251 L .51734 .2848 L p
.4 g
F P
s
P
p
1 .53 0 r
.01 w
.5555 .34357 m
.5709 .35546 L
s
P
p
.002 w
.84152 .27406 m .84842 .28021 L .83345 .28353 L p
.4 g
F P
s
P
p
.002 w
.81156 .28072 m .84152 .27406 L p
.83345 .28353 L .4 g
F P
s
P
p
.002 w
.69378 .27611 m .66431 .28277 L .64943 .27045 L p
.8 g
F P
s
P
p
.002 w
.62002 .27714 m .64943 .27045 L .66431 .28277 L p
.8 g
F P
s
P
p
1 .852 0 r
.01 w
.46839 .39091 m
.4396 .39721 L
s
P
p
1 .208 0 r
.01 w
.73135 .30729 m
.76105 .3007 L
s
P
p
.002 w
.76761 .27509 m .79751 .26839 L .81156 .28072 L p
.8 g
F P
s
P
p
1 .095 0 r
.01 w
.76035 .29099 m
.79015 .28436 L
s
P
p
.002 w
.35411 .27457 m .38273 .26787 L .39915 .28021 L p
.8 g
F P
s
P
p
.002 w
.86344 .27688 m .84842 .28021 L p
.84152 .27406 L .4 g
F P
s
P
p
.002 w
.50163 .27251 m .4727 .27919 L .4567 .26683 L p
.4 g
F P
s
P
p
.002 w
.28046 .2756 m .26633 .27893 L .25776 .27277 L p
.4 g
F P
s
P
p
.002 w
.87166 .26735 m .8785 .27354 L .86344 .27688 L p
.4 g
F P
s
P
p
.002 w
.84152 .27406 m .87166 .26735 L p
.86344 .27688 L .4 g
F P
s
P
p
.002 w
.72343 .26942 m .69378 .27611 L .67902 .26372 L p
.8 g
F P
s
P
p
.002 w
.64943 .27045 m .67902 .26372 L .69378 .27611 L p
.8 g
F P
s
P
p
1 .833 0 r
.01 w
.49737 .3829 m
.46841 .38925 L
s
P
p
.002 w
.25776 .27277 m .24914 .26658 L p
.28046 .2756 L .4 g
F P
s
P
p
.002 w
.24914 .26658 m .26332 .2632 L .28046 .2756 L p
.4 g
F P
s
P
p
1 .189 0 r
.01 w
.76094 .29908 m
.79081 .29246 L
s
P
p
.002 w
.79751 .26839 m .76761 .27509 L .75327 .26269 L p
.8 g
F P
s
P
p
.002 w
.8936 .27019 m .8785 .27354 L p
.87166 .26735 L .4 g
F P
s
P
p
1 .114 0 r
.01 w
.79028 .28598 m
.79028 .28598 L
s
P
p
.002 w
.4567 .26683 m .48574 .26008 L .50163 .27251 L p
.4 g
F P
s
P
p
1 .927 0 r
.01 w
.39447 .39856 m
.37796 .38685 L
s
P
p
1 .132 0 r
.01 w
.79041 .28759 m
.79041 .28759 L
s
P
p
1 .549 0 r
.01 w
.55552 .34522 m
.55552 .34522 L
s
P
p
1 .151 0 r
.01 w
.79054 .28921 m
.79054 .28921 L
s
P
p
1 .814 0 r
.01 w
.49738 .38124 m
.5265 .37485 L
s
P
p
1 .568 0 r
.01 w
.55554 .34687 m
.58484 .34038 L
s
P
p
.002 w
.87166 .26735 m .8868 .26398 L .8936 .27019 L p
.4 g
F P
s
P
p
.002 w
.11367 .16918 m .63802 .03694 L .8936 .27019 L p
.9 g
F P
s
P
p
1 .17 0 r
.01 w
.79067 .29083 m
.79067 .29083 L
s
P
p
.002 w
.67902 .26372 m .7088 .25695 L .72343 .26942 L p
.8 g
F P
s
P
p
.002 w
.75327 .26269 m .7833 .25591 L .79751 .26839 L p
.8 g
F P
s
P
p
.002 w
.41153 .26113 m .38273 .26787 L .36612 .25539 L p
.8 g
F P
s
P
p
.002 w
.8868 .26398 m .87166 .26735 L p
.85786 .25486 L .4 g
F P
s
P
p
.002 w
.48574 .26008 m .4567 .26683 L .44051 .25434 L p
.4 g
F P
s
P
p
.002 w
.26332 .2632 m .24914 .26658 L .24048 .26034 L p
.4 g
F P
s
P
p
.618 1 0 r
.01 w
.40962 .45062 m
.3808 .45678 L
s
P
p
.599 1 0 r
.01 w
.38074 .45849 m
.38074 .45849 L
s
P
p
1 .795 0 r
.01 w
.52649 .37319 m
.55579 .36676 L
s
P
p
.58 1 0 r
.01 w
.38068 .46019 m
.38068 .46019 L
s
P
p
.002 w
.87995 .25774 m .8868 .26398 L p
.85786 .25486 L .4 g
F P
s
P
p
.002 w
.7088 .25695 m .67902 .26372 L .66409 .25119 L p
.8 g
F P
s
P
p
.002 w
.24048 .26034 m .23176 .25408 L p
.26332 .2632 L .4 g
F P
s
P
p
.002 w
.23176 .25408 m .24599 .25067 L .26332 .2632 L p
.4 g
F P
s
P
p
.562 1 0 r
.01 w
.38061 .4619 m
.38061 .4619 L
s
P
p
.002 w
.7833 .25591 m .75327 .26269 L .73876 .25014 L p
.8 g
F P
s
P
p
1 .587 0 r
.01 w
.58488 .34203 m
.61438 .3355 L
s
P
p
.543 1 0 r
.01 w
.38055 .46361 m
.38055 .46361 L
s
P
p
.002 w
.36612 .25539 m .39504 .24856 L .41153 .26113 L p
.8 g
F P
s
P
p
.524 1 0 r
.01 w
.38049 .46532 m
.36381 .45394 L
s
P
p
.637 1 0 r
.01 w
.43865 .44271 m
.40967 .44892 L
s
P
p
.002 w
.44051 .25434 m .46967 .24751 L .48574 .26008 L p
.4 g
F P
s
P
p
1 .776 0 r
.01 w
.55577 .36509 m
.58523 .35862 L
s
P
p
1 .946 0 r
.01 w
.36118 .37668 m
.37789 .38852 L
s
P
p
.002 w
.85786 .25486 m .87307 .25145 L .87995 .25774 L p
.4 g
F P
s
P
p
.002 w
.66409 .25119 m .694 .24434 L .7088 .25695 L p
.8 g
F P
s
P
p
.002 w
.73876 .25014 m .76892 .24329 L .7833 .25591 L p
.8 g
F P
s
P
p
.002 w
.39504 .24856 m .36612 .25539 L .34932 .24276 L p
.8 g
F P
s
P
p
.002 w
.87307 .25145 m .85786 .25486 L p
.84391 .24223 L .4 g
F P
s
P
p
.656 1 0 r
.01 w
.46784 .43476 m
.43869 .44101 L
s
P
p
1 .606 0 r
.01 w
.61443 .33715 m
.64413 .33058 L
s
P
p
.002 w
.46967 .24751 m .44051 .25434 L .42413 .2417 L p
.4 g
F P
s
P
p
.002 w
.24599 .25067 m .23176 .25408 L .22299 .24777 L p
.4 g
F P
s
P
p
1 .757 0 r
.01 w
.58519 .35696 m
.61482 .35045 L
s
P
p
.002 w
.86614 .24514 m .87307 .25145 L p
.84391 .24223 L .4 g
F P
s
P
p
.002 w
.694 .24434 m .66409 .25119 L .64899 .23851 L p
.8 g
F P
s
P
p
.002 w
.22299 .24777 m .21417 .24143 L p
.24599 .25067 L .4 g
F P
s
P
p
.002 w
.21417 .24143 m .22846 .23798 L .24599 .25067 L p
.4 g
F P
s
P
p
.002 w
.76892 .24329 m .73876 .25014 L .72409 .23745 L p
.8 g
F P
s
P
p
.675 1 0 r
.01 w
.49718 .42677 m
.46786 .43306 L
s
P
p
.002 w
.34932 .24276 m .37835 .23585 L .39504 .24856 L p
.8 g
F P
s
P
p
.002 w
.42413 .2417 m .45341 .23479 L .46967 .24751 L p
.4 g
F P
s
P
p
.505 1 0 r
.01 w
.36374 .45566 m
.34686 .44414 L
s
P
p
1 .738 0 r
.01 w
.61477 .34878 m
.64457 .34222 L
s
P
p
1 .625 0 r
.01 w
.64419 .33224 m
.6741 .32563 L
s
P
p
.002 w
.64899 .23851 m .61915 .2454 L .60374 .23265 L p
.4 g
F P
s
P
p
.002 w
.84391 .24223 m .85918 .23878 L .86614 .24514 L p
.4 g
F P
s
P
p
1 .965 0 r
.01 w
.3442 .36639 m
.36111 .37836 L
s
P
p
.002 w
.64899 .23851 m .67902 .23158 L .694 .24434 L p
.8 g
F P
s
P
p
.713 1 0 r
.01 w
.48107 .41164 m
.49719 .42336 L
s
P
p
.002 w
.79926 .23639 m .76892 .24329 L .75437 .23051 L p
.8 g
F P
s
P
p
.002 w
.72409 .23745 m .75437 .23051 L .76892 .24329 L p
.8 g
F P
s
P
p
.694 1 0 r
.01 w
.49719 .42506 m
.49719 .42506 L
s
P
p
.002 w
.85918 .23878 m .84391 .24223 L p
.82979 .22944 L .4 g
F P
s
P
p
.002 w
.45341 .23479 m .42413 .2417 L .40756 .22891 L p
.4 g
F P
s
P
p
.002 w
.22846 .23798 m .21417 .24143 L .2053 .23505 L p
.4 g
F P
s
P
p
1 .719 0 r
.01 w
.64451 .34056 m
.67449 .33396 L
s
P
p
.002 w
.60374 .23265 m .57396 .23958 L .55826 .22676 L p
.8 g
F P
s
P
p
1 .644 0 r
.01 w
.67417 .32729 m
.70428 .32065 L
s
P
p
.002 w
.85218 .23239 m .85918 .23878 L p
.82979 .22944 L .4 g
F P
s
P
p
.002 w
.60374 .23265 m .63371 .22569 L .64899 .23851 L p
.4 g
F P
s
P
p
.002 w
.67902 .23158 m .64899 .23851 L .63371 .22569 L p
.8 g
F P
s
P
p
.002 w
.2053 .23505 m .19637 .22864 L p
.22846 .23798 L .4 g
F P
s
P
p
.002 w
.19637 .22864 m .21072 .22515 L .22846 .23798 L p
.4 g
F P
s
P
p
.002 w
.82979 .22944 m .79926 .23639 L .78484 .22354 L p
.8 g
F P
s
P
p
.002 w
.75437 .23051 m .78484 .22354 L .79926 .23639 L p
.8 g
F P
s
P
p
1 .7 0 r
.01 w
.67441 .33229 m
.70456 .32565 L
s
P
p
.002 w
.48287 .22784 m .45341 .23479 L .43696 .22192 L p
.4 g
F P
s
P
p
.002 w
.40756 .22891 m .43696 .22192 L .45341 .23479 L p
.4 g
F P
s
P
p
.486 1 0 r
.01 w
.34678 .44587 m
.34678 .44587 L
s
P
p
.002 w
.63371 .22569 m .60374 .23265 L .58816 .21976 L p
.4 g
F P
s
P
p
.002 w
.55826 .22676 m .58816 .21976 L .60374 .23265 L p
.8 g
F P
s
P
p
.467 1 0 r
.01 w
.3467 .44759 m
.37586 .4413 L
s
P
p
.732 1 0 r
.01 w
.46478 .39807 m
.48109 .40993 L
s
P
p
.002 w
.82979 .22944 m .84513 .22596 L .85218 .23239 L p
.4 g
F P
s
P
p
.002 w
.70924 .22461 m .67902 .23158 L .66387 .21868 L p
.8 g
F P
s
P
p
.002 w
.63371 .22569 m .66387 .21868 L .67902 .23158 L p
.8 g
F P
s
P
p
1 .984 0 r
.01 w
.34412 .36808 m
.34412 .36808 L
s
P
p
1 .662 0 r
.01 w
.70437 .32231 m
.70437 .32231 L
s
P
p
.997 1 0 r
.01 w
.34403 .36977 m
.37322 .36322 L
s
P
p
1 .681 0 r
.01 w
.70447 .32398 m
.70447 .32398 L
s
P
p
.002 w
.84513 .22596 m .82979 .22944 L p
.81551 .21651 L .4 g
F P
s
P
p
.002 w
.78484 .22354 m .81551 .21651 L .82979 .22944 L p
.8 g
F P
s
P
p
.002 w
.43696 .22192 m .40756 .22891 L .3908 .21597 L p
.4 g
F P
s
P
p
.002 w
.21072 .22515 m .19637 .22864 L .1874 .22219 L p
.4 g
F P
s
P
p
.002 w
.43696 .22192 m .46654 .21488 L .48287 .22784 L p
.4 g
F P
s
P
p
.372 1 0 r
.01 w
.37553 .44997 m
.3463 .45624 L
s
P
p
.864 1 0 r
.01 w
.4485 .3741 m
.46494 .38613 L
s
P
p
.353 1 0 r
.01 w
.34622 .45798 m
.34622 .45798 L
s
P
p
.845 1 0 r
.01 w
.46492 .38783 m
.46492 .38783 L
s
P
p
.002 w
.83804 .21949 m .84513 .22596 L p
.81551 .21651 L .4 g
F P
s
P
p
.002 w
.58816 .21976 m .61825 .21271 L .63371 .22569 L p
.4 g
F P
s
P
p
.002 w
.1874 .22219 m .17837 .2157 L p
.21072 .22515 L .4 g
F P
s
P
p
.002 w
.17837 .2157 m .19277 .21217 L .21072 .22515 L p
.4 g
F P
s
P
p
.334 1 0 r
.01 w
.34614 .45971 m
.34614 .45971 L
s
P
p
.826 1 0 r
.01 w
.4649 .38953 m
.4649 .38953 L
s
P
p
.002 w
.73965 .2176 m .70924 .22461 L .69422 .21162 L p
.8 g
F P
s
P
p
.002 w
.66387 .21868 m .69422 .21162 L .70924 .22461 L p
.8 g
F P
s
P
p
.448 1 0 r
.01 w
.37579 .44303 m
.40515 .43671 L
s
P
p
.315 1 0 r
.01 w
.34606 .46145 m
.34606 .46145 L
s
P
p
.808 1 0 r
.01 w
.46487 .39124 m
.46487 .39124 L
s
P
p
.002 w
.81551 .21651 m .78484 .22354 L .77026 .21053 L p
.8 g
F P
s
P
p
.297 1 0 r
.01 w
.34598 .46319 m
.34598 .46319 L
s
P
p
.789 1 0 r
.01 w
.46485 .39294 m
.46485 .39294 L
s
P
p
.002 w
.46654 .21488 m .43696 .22192 L .42032 .2089 L p
.4 g
F P
s
P
p
.002 w
.3908 .21597 m .42032 .2089 L .43696 .22192 L p
.4 g
F P
s
P
p
.278 1 0 r
.01 w
.3459 .46493 m
.32871 .45334 L
s
P
p
.77 1 0 r
.01 w
.46483 .39465 m
.46483 .39465 L
s
P
p
.978 1 0 r
.01 w
.37315 .36492 m
.40253 .35834 L
s
P
p
.391 1 0 r
.01 w
.40499 .44191 m
.37559 .44823 L
s
P
p
0 1 .196 r
.01 w
.40745 .52553 m
.37804 .53159 L
s
P
p
.751 1 0 r
.01 w
.4648 .39636 m
.4648 .39636 L
s
P
p
.002 w
.61825 .21271 m .58816 .21976 L .57239 .20671 L p
.4 g
F P
s
P
p
0 1 .215 r
.01 w
.37797 .53336 m
.37797 .53336 L
s
P
p
.002 w
.81551 .21651 m .83091 .21298 L .83804 .21949 L p
.4 g
F P
s
P
p
0 1 .233 r
.01 w
.37791 .53514 m
.37791 .53514 L
s
P
p
.002 w
.77026 .21053 m .73965 .2176 L .72476 .20452 L p
.8 g
F P
s
P
p
.002 w
.69422 .21162 m .72476 .20452 L .73965 .2176 L p
.8 g
F P
s
P
p
0 1 .252 r
.01 w
.37784 .53692 m
.37784 .53692 L
s
P
p
.002 w
.34439 .20999 m .31513 .21705 L .29774 .20397 L p
.8 g
F P
s
P
p
.002 w
.83091 .21298 m .81551 .21651 L p
.80106 .20343 L .4 g
F P
s
P
p
.002 w
.77026 .21053 m .80106 .20343 L .81551 .21651 L p
.8 g
F P
s
P
p
0 1 .271 r
.01 w
.37778 .5387 m
.37778 .5387 L
s
P
p
.429 1 0 r
.01 w
.4051 .43844 m
.4051 .43844 L
s
P
p
.002 w
.19277 .21217 m .17837 .2157 L .16929 .20917 L p
.4 g
F P
s
P
p
0 1 .29 r
.01 w
.37771 .54049 m
.36067 .52931 L
s
P
p
.41 1 0 r
.01 w
.40505 .44018 m
.40505 .44018 L
s
P
p
.883 1 0 r
.01 w
.43191 .36023 m
.44853 .3724 L
s
P
p
.002 w
.42032 .2089 m .45002 .20178 L .46654 .21488 L p
.4 g
F P
s
P
p
0 1 .177 r
.01 w
.43709 .51766 m
.40751 .52375 L
s
P
p
.959 1 0 r
.01 w
.40248 .36003 m
.43207 .35341 L
s
P
p
.002 w
.82374 .20644 m .83091 .21298 L p
.80106 .20343 L .4 g
F P
s
P
p
.002 w
.57239 .20671 m .60261 .19958 L .61825 .21271 L p
.4 g
F P
s
P
p
.002 w
.16929 .20917 m .16016 .2026 L p
.19277 .21217 L .4 g
F P
s
P
p
.002 w
.16016 .2026 m .17461 .19903 L .19277 .21217 L p
.4 g
F P
s
P
p
.002 w
.80106 .20343 m .77026 .21053 L .7555 .19738 L p
.8 g
F P
s
P
p
.002 w
.72476 .20452 m .7555 .19738 L .77026 .21053 L p
.8 g
F P
s
P
p
.002 w
.29774 .20397 m .32711 .19683 L .34439 .20999 L p
.8 g
F P
s
P
p
0 1 .158 r
.01 w
.46689 .50974 m
.43713 .51588 L
s
P
p
.002 w
.52628 .20068 m .49632 .20781 L .47992 .19462 L p
.8 g
F P
s
P
p
.259 1 0 r
.01 w
.32862 .45509 m
.31123 .44336 L
s
P
p
.002 w
.60261 .19958 m .57239 .20671 L .55643 .19351 L p
.4 g
F P
s
P
p
.002 w
.80106 .20343 m .81653 .19986 L .82374 .20644 L p
.4 g
F P
s
P
p
.94 1 0 r
.01 w
.43203 .35511 m
.43203 .35511 L
s
P
p
.921 1 0 r
.01 w
.43199 .35682 m
.43199 .35682 L
s
P
p
.002 w
.32711 .19683 m .29774 .20397 L .28013 .19074 L p
.8 g
F P
s
P
p
.002 w
.81653 .19986 m .80106 .20343 L p
.78643 .19019 L .4 g
F P
s
P
p
.002 w
.7555 .19738 m .78643 .19019 L .80106 .20343 L p
.8 g
F P
s
P
p
.902 1 0 r
.01 w
.43195 .35852 m
.43195 .35852 L
s
P
p
.002 w
.40348 .19572 m .37384 .20288 L .35668 .18963 L p
.4 g
F P
s
P
p
0 1 .139 r
.01 w
.49685 .50179 m
.46692 .50796 L
s
P
p
.002 w
.17461 .19903 m .16016 .2026 L .15097 .196 L p
.4 g
F P
s
P
p
0 1 .309 r
.01 w
.36059 .5311 m
.34334 .51979 L
s
P
p
.002 w
.47992 .19462 m .51001 .18741 L .52628 .20068 L p
.8 g
F P
s
P
p
.002 w
.80928 .19323 m .81653 .19986 L p
.78643 .19019 L .4 g
F P
s
P
p
.002 w
.63303 .1924 m .60261 .19958 L .58678 .1863 L p
.4 g
F P
s
P
p
.002 w
.55643 .19351 m .58678 .1863 L .60261 .19958 L p
.4 g
F P
s
P
p
.002 w
.15097 .196 m .14173 .18935 L p
.17461 .19903 L .4 g
F P
s
P
p
.002 w
.14173 .18935 m .15624 .18574 L .17461 .19903 L p
.4 g
F P
s
P
p
0 1 .101 r
.01 w
.4804 .4867 m
.49687 .49823 L
s
P
p
.002 w
.28013 .19074 m .30963 .18351 L .32711 .19683 L p
.8 g
F P
s
P
p
0 1 .12 r
.01 w
.49686 .5 m
.49686 .5 L
s
P
p
.002 w
.43331 .18852 m .40348 .19572 L .38644 .18239 L p
.4 g
F P
s
P
p
.002 w
.35668 .18963 m .38644 .18239 L .40348 .19572 L p
.4 g
F P
s
P
p
.24 1 0 r
.01 w
.31113 .44512 m
.31113 .44512 L
s
P
p
.002 w
.78643 .19019 m .80198 .18657 L .80928 .19323 L p
.4 g
F P
s
P
p
.002 w
.66364 .18518 m .63303 .1924 L .61733 .17903 L p
.4 g
F P
s
P
p
.002 w
.58678 .1863 m .61733 .17903 L .63303 .1924 L p
.4 g
F P
s
P
p
.221 1 0 r
.01 w
.31103 .44687 m
.34061 .44047 L
s
P
p
.002 w
.80198 .18657 m .78643 .19019 L p
.77164 .17679 L .4 g
F P
s
P
p
.002 w
.38644 .18239 m .35668 .18963 L .33932 .17623 L p
.4 g
F P
s
P
p
.002 w
.15624 .18574 m .14173 .18935 L .13243 .18267 L p
.4 g
F P
s
P
p
.002 w
.38644 .18239 m .41639 .1751 L .43331 .18852 L p
.4 g
F P
s
P
p
0 1 .328 r
.01 w
.34326 .52159 m
.34326 .52159 L
s
P
p
.002 w
.79463 .17987 m .80198 .18657 L p
.77164 .17679 L .4 g
F P
s
P
p
.002 w
.13243 .18267 m .12307 .17595 L p
.15624 .18574 L .4 g
F P
s
P
p
.002 w
.12307 .17595 m .13764 .17229 L .15624 .18574 L p
.4 g
F P
s
P
p
0 1 .347 r
.01 w
.34317 .52339 m
.37294 .51721 L
s
P
p
0 1 .082 r
.01 w
.46376 .47326 m
.48042 .48492 L
s
P
p
.002 w
.69444 .17791 m .66364 .18518 L .64807 .17172 L p
.4 g
F P
s
P
p
.002 w
.61733 .17903 m .64807 .17172 L .66364 .18518 L p
.4 g
F P
s
P
p
.202 1 0 r
.01 w
.34053 .44223 m
.37031 .43579 L
s
P
p
.002 w
.41639 .1751 m .38644 .18239 L .3692 .1689 L p
.4 g
F P
s
P
p
.002 w
.33932 .17623 m .3692 .1689 L .38644 .18239 L p
.4 g
F P
s
P
p
.002 w
.57077 .17285 m .54029 .18015 L .52395 .16663 L p
.8 g
F P
s
P
p
0 1 .442 r
.01 w
.37259 .52625 m
.34275 .53241 L
s
P
p
.05 1 0 r
.01 w
.44713 .44896 m
.46393 .4608 L
s
P
p
.002 w
.77164 .17679 m .78725 .17313 L .79463 .17987 L p
.4 g
F P
s
P
p
0 1 .461 r
.01 w
.34267 .53422 m
.34267 .53422 L
s
P
p
.032 1 0 r
.01 w
.4639 .46257 m
.4639 .46257 L
s
P
p
.002 w
.64807 .17172 m .67901 .16437 L .69444 .17791 L p
.4 g
F P
s
P
p
0 1 .479 r
.01 w
.34258 .53603 m
.34258 .53603 L
s
P
p
.013 1 0 r
.01 w
.46388 .46435 m
.46388 .46435 L
s
P
p
0 1 .366 r
.01 w
.37287 .51901 m
.40285 .5128 L
s
P
p
.002 w
.78725 .17313 m .77164 .17679 L p
.75666 .16323 L .4 g
F P
s
P
p
0 1 .498 r
.01 w
.3425 .53784 m
.3425 .53784 L
s
P
p
0 1 .006 r
.01 w
.46385 .46613 m
.46385 .46613 L
s
P
p
.002 w
.13764 .17229 m .12307 .17595 L .11367 .16918 L p
.4 g
F P
s
P
p
0 1 .517 r
.01 w
.34241 .53966 m
.34241 .53966 L
s
P
p
0 1 .025 r
.01 w
.46383 .46791 m
.46383 .46791 L
s
P
p
.183 1 0 r
.01 w
.37024 .43755 m
.40023 .43107 L
s
P
p
.002 w
.44653 .16777 m .41639 .1751 L .39927 .16152 L p
.4 g
F P
s
P
p
.002 w
.3692 .1689 m .39927 .16152 L .41639 .1751 L p
.4 g
F P
s
P
p
0 1 .536 r
.01 w
.34233 .54148 m
.32476 .53009 L
s
P
p
0 1 .044 r
.01 w
.46381 .46969 m
.46381 .46969 L
s
P
p
0 1 .423 r
.01 w
.40268 .51823 m
.37266 .52443 L
s
P
p
0 .991 1 r
.01 w
.4052 .60366 m
.37516 .60959 L
s
P
p
0 1 .063 r
.01 w
.46378 .47147 m
.46378 .47147 L
s
P
p
.002 w
.77982 .16635 m .78725 .17313 L p
.75666 .16323 L .4 g
F P
s
P
p
.002 w
.52395 .16663 m .55456 .15924 L .57077 .17285 L p
.8 g
F P
s
P
p
.002 w
.12826 .1655 m .1429 .16181 L p
.13764 .17229 L .4 g
F P
s
P
p
.002 w
.16692 .16493 m .13764 .17229 L p
.1429 .16181 L .4 g
F P
s
P
p
.002 w
.11367 .16918 m .12826 .1655 L .13764 .17229 L p
.4 g
F P
s
P
p
0 .972 1 r
.01 w
.37509 .61145 m
.37509 .61145 L
s
P
p
.002 w
.67901 .16437 m .64807 .17172 L .63232 .1581 L p
.4 g
F P
s
P
p
0 .953 1 r
.01 w
.37502 .6133 m
.37502 .6133 L
s
P
p
.002 w
.32174 .16266 m .29193 .17003 L .27403 .15639 L p
.8 g
F P
s
P
p
0 .934 1 r
.01 w
.37495 .61516 m
.37495 .61516 L
s
P
p
0 .915 1 r
.01 w
.37489 .61702 m
.37489 .61702 L
s
P
p
0 1 .385 r
.01 w
.40279 .51461 m
.40279 .51461 L
s
P
p
.002 w
.47687 .16038 m .44653 .16777 L .42954 .1541 L p
.4 g
F P
s
P
p
.002 w
.39927 .16152 m .42954 .1541 L .44653 .16777 L p
.4 g
F P
s
P
p
0 .896 1 r
.01 w
.37482 .61888 m
.35739 .60793 L
s
P
p
0 1 .404 r
.01 w
.40274 .51642 m
.40274 .51642 L
s
P
p
.069 1 0 r
.01 w
.43017 .4352 m
.44716 .44718 L
s
P
p
0 1 .991 r
.01 w
.43547 .59584 m
.40525 .60181 L
s
P
p
.164 1 0 r
.01 w
.40017 .43284 m
.43037 .42632 L
s
P
p
.002 w
.75666 .16323 m .77234 .15953 L .77982 .16635 L p
.4 g
F P
s
P
p
.002 w
.15759 .1581 m .17233 .15439 L p
.16692 .16493 L .4 g
F P
s
P
p
.002 w
.19639 .15753 m .16692 .16493 L p
.17233 .15439 L .4 g
F P
s
P
p
.002 w
.1429 .16181 m .15759 .1581 L .16692 .16493 L p
.4 g
F P
s
P
p
.002 w
.63232 .1581 m .6634 .15066 L .67901 .16437 L p
.4 g
F P
s
P
p
.002 w
.77234 .15953 m .75666 .16323 L p
.74151 .14951 L .4 g
F P
s
P
p
.002 w
.35174 .15524 m .32174 .16266 L .30395 .14893 L p
.8 g
F P
s
P
p
.002 w
.27403 .15639 m .30395 .14893 L .32174 .16266 L p
.8 g
F P
s
P
p
0 1 .972 r
.01 w
.46591 .58797 m
.43551 .59398 L
s
P
p
.002 w
.50741 .15295 m .47687 .16038 L .46001 .14663 L p
.4 g
F P
s
P
p
.002 w
.42954 .1541 m .46001 .14663 L .47687 .16038 L p
.4 g
F P
s
P
p
0 1 .555 r
.01 w
.32466 .53192 m
.30687 .5204 L
s
P
p
.002 w
.76482 .15267 m .77234 .15953 L p
.74151 .14951 L .4 g
F P
s
P
p
.145 1 0 r
.01 w
.43033 .42809 m
.43033 .42809 L
s
P
p
.002 w
.6634 .15066 m .63232 .1581 L .61638 .14432 L p
.4 g
F P
s
P
p
.002 w
.18712 .15066 m .20196 .14691 L p
.19639 .15753 L .4 g
F P
s
P
p
.002 w
.22605 .15008 m .19639 .15753 L p
.20196 .14691 L .4 g
F P
s
P
p
.002 w
.17233 .15439 m .18712 .15066 L .19639 .15753 L p
.4 g
F P
s
P
p
.126 1 0 r
.01 w
.43029 .42986 m
.43029 .42986 L
s
P
p
.107 1 0 r
.01 w
.43025 .43164 m
.43025 .43164 L
s
P
p
.002 w
.30395 .14893 m .33408 .14142 L .35174 .15524 L p
.8 g
F P
s
P
p
.088 1 0 r
.01 w
.43021 .43342 m
.43021 .43342 L
s
P
p
0 1 .953 r
.01 w
.49651 .58005 m
.46593 .58611 L
s
P
p
.002 w
.46001 .14663 m .49068 .1391 L .50741 .15295 L p
.4 g
F P
s
P
p
0 .877 1 r
.01 w
.35731 .6098 m
.33966 .59872 L
s
P
p
.002 w
.74151 .14951 m .75726 .14576 L .76482 .15267 L p
.4 g
F P
s
P
p
.002 w
.61638 .14432 m .64759 .13678 L .6634 .15066 L p
.4 g
F P
s
P
p
.002 w
.21684 .14316 m .23177 .1394 L p
.22605 .15008 L .4 g
F P
s
P
p
.002 w
.2559 .14258 m .22605 .15008 L p
.23177 .1394 L .4 g
F P
s
P
p
.002 w
.20196 .14691 m .21684 .14316 L .22605 .15008 L p
.4 g
F P
s
P
p
.002 w
.75726 .14576 m .74151 .14951 L p
.72617 .13562 L .4 g
F P
s
P
p
0 1 .915 r
.01 w
.4797 .56504 m
.49653 .57634 L
s
P
p
0 1 .934 r
.01 w
.49652 .57819 m
.49652 .57819 L
s
P
p
.002 w
.41234 .14027 m .38194 .14778 L .3644 .13387 L p
.8 g
F P
s
P
p
.002 w
.49068 .1391 m .46001 .14663 L .44294 .1327 L p
.4 g
F P
s
P
p
.002 w
.74965 .13881 m .75726 .14576 L p
.72617 .13562 L .4 g
F P
s
P
p
.002 w
.56909 .13794 m .53815 .14547 L .52155 .13153 L p
.8 g
F P
s
P
p
0 1 .574 r
.01 w
.30677 .52223 m
.30677 .52223 L
s
P
p
.002 w
.64759 .13678 m .61638 .14432 L .60024 .13036 L p
.4 g
F P
s
P
p
0 1 .593 r
.01 w
.30666 .52407 m
.33687 .51778 L
s
P
p
.002 w
.24676 .13562 m .26179 .13183 L p
.2559 .14258 L .4 g
F P
s
P
p
.002 w
.28595 .13503 m .2559 .14258 L p
.26179 .13183 L .4 g
F P
s
P
p
.002 w
.23177 .1394 m .24676 .13562 L .2559 .14258 L p
.4 g
F P
s
P
p
.002 w
.44294 .1327 m .41234 .14027 L .39493 .12626 L p
.8 g
F P
s
P
p
.002 w
.3644 .13387 m .39493 .12626 L .41234 .14027 L p
.8 g
F P
s
P
p
.002 w
.44294 .1327 m .47374 .12509 L .49068 .1391 L p
.4 g
F P
s
P
p
.002 w
.72617 .13562 m .74199 .13183 L .74965 .13881 L p
.4 g
F P
s
P
p
.002 w
.52155 .13153 m .55262 .12391 L .56909 .13794 L p
.8 g
F P
s
P
p
0 .858 1 r
.01 w
.33957 .6006 m
.33957 .6006 L
s
P
p
.002 w
.60024 .13036 m .63159 .12274 L .64759 .13678 L p
.4 g
F P
s
P
p
0 1 .896 r
.01 w
.46269 .55174 m
.47972 .56318 L
s
P
p
0 .839 1 r
.01 w
.33949 .60248 m
.36989 .59643 L
s
P
p
.002 w
.74199 .13183 m .72617 .13562 L p
.71064 .12156 L .4 g
F P
s
P
p
.002 w
.27687 .12802 m .292 .12421 L p
.28595 .13503 L .4 g
F P
s
P
p
.002 w
.3162 .12744 m .28595 .13503 L p
.292 .12421 L .4 g
F P
s
P
p
.002 w
.26179 .13183 m .27687 .12802 L .28595 .13503 L p
.4 g
F P
s
P
p
0 1 .612 r
.01 w
.33678 .51962 m
.3672 .51329 L
s
P
p
.002 w
.39493 .12626 m .42566 .11861 L .44294 .1327 L p
.8 g
F P
s
P
p
.002 w
.73428 .12479 m .74199 .13183 L p
.71064 .12156 L .4 g
F P
s
P
p
.002 w
.55262 .12391 m .52155 .13153 L .50474 .11742 L p
.8 g
F P
s
P
p
0 1 .763 r
.01 w
.44569 .52711 m
.46287 .53873 L
s
P
p
0 .744 1 r
.01 w
.36953 .60586 m
.33905 .6119 L
s
P
p
.002 w
.63159 .12274 m .60024 .13036 L .5839 .11624 L p
.4 g
F P
s
P
p
0 1 .782 r
.01 w
.46284 .54058 m
.46284 .54058 L
s
P
p
0 .726 1 r
.01 w
.33896 .61379 m
.33896 .61379 L
s
P
p
0 1 .801 r
.01 w
.46282 .54243 m
.46282 .54243 L
s
P
p
0 .707 1 r
.01 w
.33887 .61568 m
.33887 .61568 L
s
P
p
0 .82 1 r
.01 w
.36982 .59831 m
.40044 .59222 L
s
P
p
.002 w
.30718 .12038 m .32241 .11654 L p
.3162 .12744 L .4 g
F P
s
P
p
.002 w
.34665 .11979 m .3162 .12744 L p
.32241 .11654 L .4 g
F P
s
P
p
.002 w
.292 .12421 m .30718 .12038 L .3162 .12744 L p
.4 g
F P
s
P
p
0 1 .82 r
.01 w
.46279 .54429 m
.46279 .54429 L
s
P
p
0 .688 1 r
.01 w
.33878 .61757 m
.33878 .61757 L
s
P
p
0 1 .839 r
.01 w
.46277 .54615 m
.46277 .54615 L
s
P
p
0 1 .631 r
.01 w
.36713 .51513 m
.39777 .50876 L
s
P
p
0 .669 1 r
.01 w
.33869 .61947 m
.33869 .61947 L
s
P
p
0 1 .858 r
.01 w
.46274 .54801 m
.46274 .54801 L
s
P
p
0 .65 1 r
.01 w
.33861 .62137 m
.32062 .61022 L
s
P
p
.002 w
.71064 .12156 m .72653 .11772 L .73428 .12479 L p
.4 g
F P
s
P
p
0 .763 1 r
.01 w
.40027 .59789 m
.3696 .60397 L
s
P
p
.002 w
.50474 .11742 m .53595 .10971 L .55262 .12391 L p
.8 g
F P
s
P
p
0 1 .877 r
.01 w
.46271 .54987 m
.46271 .54987 L
s
P
p
0 .177 1 r
.01 w
.40284 .68523 m
.37215 .69102 L
s
P
p
.002 w
.5839 .11624 m .61539 .10852 L .63159 .12274 L p
.4 g
F P
s
P
p
0 .158 1 r
.01 w
.37208 .69295 m
.37208 .69295 L
s
P
p
.002 w
.72653 .11772 m .71064 .12156 L p
.69492 .10732 L .4 g
F P
s
P
p
0 .139 1 r
.01 w
.37201 .69489 m
.37201 .69489 L
s
P
p
0 .12 1 r
.01 w
.37194 .69683 m
.37194 .69683 L
s
P
p
.002 w
.33769 .11268 m .35303 .10882 L p
.34665 .11979 L .4 g
F P
s
P
p
.002 w
.3773 .11209 m .34665 .11979 L p
.35303 .10882 L .4 g
F P
s
P
p
.002 w
.32241 .11654 m .33769 .11268 L .34665 .11979 L p
.4 g
F P
s
P
p
0 .801 1 r
.01 w
.40039 .59411 m
.40039 .59411 L
s
P
p
0 .101 1 r
.01 w
.37187 .69877 m
.37187 .69877 L
s
P
p
.002 w
.45659 .1109 m .42566 .11861 L .40816 .10434 L p
.4 g
F P
s
P
p
0 1 .744 r
.01 w
.42835 .51348 m
.44573 .52525 L
s
P
p
0 .782 1 r
.01 w
.40033 .596 m
.40033 .596 L
s
P
p
.002 w
.71873 .1106 m .72653 .11772 L p
.69492 .10732 L .4 g
F P
s
P
p
0 .082 1 r
.01 w
.3718 .70072 m
.35396 .69003 L
s
P
p
.002 w
.53595 .10971 m .50474 .11742 L .48772 .10314 L p
.8 g
F P
s
P
p
0 1 .65 r
.01 w
.39771 .51061 m
.42856 .5042 L
s
P
p
0 .196 1 r
.01 w
.43377 .67746 m
.4029 .68329 L
s
P
p
.002 w
.61539 .10852 m .5839 .11624 L .56737 .10194 L p
.4 g
F P
s
P
p
.002 w
.36841 .10494 m .38385 .10104 L p
.3773 .11209 L .4 g
F P
s
P
p
.002 w
.40816 .10434 m .3773 .11209 L p
.38385 .10104 L .4 g
F P
s
P
p
.002 w
.35303 .10882 m .36841 .10494 L .3773 .11209 L p
.4 g
F P
s
P
p
.002 w
.40816 .10434 m .43923 .09654 L .45659 .1109 L p
.4 g
F P
s
P
p
.002 w
.69492 .10732 m .71089 .10344 L .71873 .1106 L p
.4 g
F P
s
P
p
0 .215 1 r
.01 w
.46488 .66964 m
.43381 .67552 L
s
P
p
.002 w
.48772 .10314 m .51907 .09533 L .53595 .10971 L p
.8 g
F P
s
P
p
0 .631 1 r
.01 w
.32053 .61213 m
.30231 .60086 L
s
P
p
.002 w
.6471 .10074 m .61539 .10852 L .599 .09412 L p
.4 g
F P
s
P
p
.002 w
.56737 .10194 m .599 .09412 L .61539 .10852 L p
.4 g
F P
s
P
p
0 1 .669 r
.01 w
.42852 .50605 m
.42852 .50605 L
s
P
p
.002 w
.71089 .10344 m .69492 .10732 L p
.67901 .09292 L .4 g
F P
s
P
p
0 1 .688 r
.01 w
.42848 .50791 m
.42848 .50791 L
s
P
p
0 1 .707 r
.01 w
.42844 .50976 m
.42844 .50976 L
s
P
p
0 1 .726 r
.01 w
.42839 .51162 m
.42839 .51162 L
s
P
p
.002 w
.39933 .09714 m .41487 .09322 L p
.40816 .10434 L .4 g
F P
s
P
p
.002 w
.43923 .09654 m .40816 .10434 L p
.41487 .09322 L .4 g
F P
s
P
p
.002 w
.38385 .10104 m .39933 .09714 L .40816 .10434 L p
.4 g
F P
s
P
p
0 .233 1 r
.01 w
.49616 .66178 m
.4649 .6677 L
s
P
p
.002 w
.70299 .09623 m .71089 .10344 L p
.67901 .09292 L .4 g
F P
s
P
p
0 .063 1 r
.01 w
.35388 .69198 m
.33582 .68117 L
s
P
p
.002 w
.67901 .09292 m .6471 .10074 L .63084 .08625 L p
.4 g
F P
s
P
p
.002 w
.599 .09412 m .63084 .08625 L .6471 .10074 L p
.4 g
F P
s
P
p
0 .271 1 r
.01 w
.47897 .64686 m
.49618 .6579 L
s
P
p
0 .252 1 r
.01 w
.49617 .65984 m
.49617 .65984 L
s
P
p
.002 w
.43046 .08929 m .44611 .08534 L p
.43923 .09654 L .4 g
F P
s
P
p
.002 w
.4705 .08868 m .43923 .09654 L p
.44611 .08534 L .4 g
F P
s
P
p
.002 w
.41487 .09322 m .43046 .08929 L .43923 .09654 L p
.4 g
F P
s
P
p
.002 w
.67901 .09292 m .69504 .08898 L .70299 .09623 L p
.4 g
F P
s
P
p
0 .612 1 r
.01 w
.3022 .60277 m
.3022 .60277 L
s
P
p
.002 w
.69504 .08898 m .67901 .09292 L p
.6629 .07833 L .4 g
F P
s
P
p
.002 w
.63084 .08625 m .6629 .07833 L .67901 .09292 L p
.4 g
F P
s
P
p
0 .593 1 r
.01 w
.3021 .60468 m
.33296 .59853 L
s
P
p
.002 w
.68705 .08169 m .69504 .08898 L p
.6629 .07833 L .4 g
F P
s
P
p
.002 w
.4618 .08138 m .47755 .07741 L p
.4705 .08868 L .4 g
F P
s
P
p
.002 w
.50198 .08077 m .4705 .08868 L p
.47755 .07741 L .4 g
F P
s
P
p
.002 w
.44611 .08534 m .4618 .08138 L .4705 .08868 L p
.4 g
F P
s
P
p
0 .044 1 r
.01 w
.33573 .68313 m
.33573 .68313 L
s
P
p
0 .29 1 r
.01 w
.46157 .63373 m
.47899 .64491 L
s
P
p
0 .025 1 r
.01 w
.33564 .68509 m
.36671 .67918 L
s
P
p
0 .574 1 r
.01 w
.33287 .60045 m
.36395 .59425 L
s
P
p
.002 w
.6629 .07833 m .67901 .07435 L .68705 .08169 L p
.4 g
F P
s
P
p
.002 w
.49336 .07343 m .50921 .06943 L p
.50198 .08077 L .4 g
F P
s
P
p
.002 w
.53368 .07281 m .50198 .08077 L p
.50921 .06943 L .4 g
F P
s
P
p
.002 w
.47755 .07741 m .49336 .07343 L .50198 .08077 L p
.4 g
F P
s
P
p
0 .423 1 r
.01 w
.44419 .60876 m
.46176 .62013 L
s
P
p
.069 0 1 r
.01 w
.36633 .68905 m
.33518 .69493 L
s
P
p
.002 w
.67901 .07435 m .6629 .07833 L p
.64658 .06356 L .4 g
F P
s
P
p
0 .404 1 r
.01 w
.46173 .62207 m
.46173 .62207 L
s
P
p
.088 0 1 r
.01 w
.33509 .69691 m
.33509 .69691 L
s
P
p
0 .385 1 r
.01 w
.46171 .62401 m
.46171 .62401 L
s
P
p
.107 0 1 r
.01 w
.33499 .69889 m
.33499 .69889 L
s
P
p
0 .006 1 r
.01 w
.36663 .68115 m
.39793 .67521 L
s
P
p
0 .366 1 r
.01 w
.46168 .62595 m
.46168 .62595 L
s
P
p
.126 0 1 r
.01 w
.3349 .70087 m
.3349 .70087 L
s
P
p
0 .555 1 r
.01 w
.36388 .59618 m
.39519 .58994 L
s
P
p
.002 w
.67091 .06696 m .67901 .07435 L p
.64658 .06356 L .4 g
F P
s
P
p
0 .347 1 r
.01 w
.46165 .62789 m
.46165 .62789 L
s
P
p
.145 0 1 r
.01 w
.33481 .70285 m
.33481 .70285 L
s
P
p
0 .328 1 r
.01 w
.46163 .62983 m
.46163 .62983 L
s
P
p
.164 0 1 r
.01 w
.33472 .70483 m
.31631 .69396 L
s
P
p
.002 w
.52512 .06541 m .54109 .06139 L p
.53368 .07281 L .4 g
F P
s
P
p
.002 w
.56559 .0648 m .53368 .07281 L p
.54109 .06139 L .4 g
F P
s
P
p
.002 w
.50921 .06943 m .52512 .06541 L .53368 .07281 L p
.4 g
F P
s
P
p
.05 0 1 r
.01 w
.39775 .68114 m
.36641 .68707 L
s
P
p
0 .309 1 r
.01 w
.4616 .63178 m
.4616 .63178 L
s
P
p
.637 0 1 r
.01 w
.40038 .77045 m
.36901 .77608 L
s
P
p
.656 0 1 r
.01 w
.36894 .7781 m
.36894 .7781 L
s
P
p
.675 0 1 r
.01 w
.36886 .78013 m
.36886 .78013 L
s
P
p
.694 0 1 r
.01 w
.36879 .78216 m
.36879 .78216 L
s
P
p
.002 w
.64658 .06356 m .66277 .05953 L .67091 .06696 L p
.4 g
F P
s
P
p
.013 0 1 r
.01 w
.39787 .67718 m
.39787 .67718 L
s
P
p
.713 0 1 r
.01 w
.36871 .78419 m
.36871 .78419 L
s
P
p
0 .442 1 r
.01 w
.42645 .5953 m
.44423 .60682 L
s
P
p
.032 0 1 r
.01 w
.39781 .67916 m
.39781 .67916 L
s
P
p
.732 0 1 r
.01 w
.36864 .78622 m
.35038 .77583 L
s
P
p
0 .536 1 r
.01 w
.39513 .59187 m
.42667 .5856 L
s
P
p
.618 0 1 r
.01 w
.432 .76275 m
.40044 .76842 L
s
P
p
.002 w
.55711 .05735 m .57318 .0533 L p
.56559 .0648 L .4 g
F P
s
P
p
.002 w
.59772 .05673 m .56559 .0648 L p
.57318 .0533 L .4 g
F P
s
P
p
.002 w
.54109 .06139 m .55711 .05735 L .56559 .0648 L p
.4 g
F P
s
P
p
.002 w
.66277 .05953 m .64658 .06356 L p
.63006 .0486 L .4 g
F P
s
P
p
.002 w
.65457 .05205 m .66277 .05953 L p
.63006 .0486 L .4 g
F P
s
P
p
.599 0 1 r
.01 w
.4638 .75501 m
.43204 .76072 L
s
P
p
.183 0 1 r
.01 w
.3162 .69595 m
.29755 .68495 L
s
P
p
.002 w
.58931 .04923 m .60549 .04515 L p
.59772 .05673 L .4 g
F P
s
P
p
.002 w
.63006 .0486 m .59772 .05673 L p
.60549 .04515 L .4 g
F P
s
P
p
.002 w
.57318 .0533 m .58931 .04923 L .59772 .05673 L p
.4 g
F P
s
P
p
0 .517 1 r
.01 w
.42663 .58753 m
.42663 .58753 L
s
P
p
0 .498 1 r
.01 w
.42658 .58947 m
.42658 .58947 L
s
P
p
0 .479 1 r
.01 w
.42654 .59141 m
.42654 .59141 L
s
P
p
.002 w
.63006 .0486 m .64632 .04452 L .65457 .05205 L p
.4 g
F P
s
P
p
0 .461 1 r
.01 w
.42649 .59335 m
.42649 .59335 L
s
P
p
.58 0 1 r
.01 w
.49579 .74722 m
.46383 .75298 L
s
P
p
.751 0 1 r
.01 w
.3503 .77787 m
.3318 .76736 L
s
P
p
.002 w
.62173 .04105 m .63802 .03694 L p
.63006 .0486 L .4 g
F P
s
P
p
.002 w
.64632 .04452 m .63006 .0486 L p
.63802 .03694 L .4 g
F P
s
P
p
.002 w
.60549 .04515 m .62173 .04105 L .63006 .0486 L p
.4 g
F P
s
P
p
.543 0 1 r
.01 w
.47821 .73241 m
.49581 .74316 L
s
P
p
.562 0 1 r
.01 w
.4958 .74519 m
.4958 .74519 L
s
P
p
.202 0 1 r
.01 w
.29744 .68696 m
.29744 .68696 L
s
P
p
.221 0 1 r
.01 w
.29732 .68896 m
.32887 .68295 L
s
P
p
.77 0 1 r
.01 w
.33171 .76941 m
.33171 .76941 L
s
P
p
.524 0 1 r
.01 w
.46041 .71948 m
.47822 .73037 L
s
P
p
.789 0 1 r
.01 w
.33161 .77146 m
.36338 .76572 L
s
P
p
.24 0 1 r
.01 w
.32878 .68496 m
.36056 .67891 L
s
P
p
.391 0 1 r
.01 w
.44262 .69416 m
.4606 .70525 L
s
P
p
.883 0 1 r
.01 w
.36298 .77604 m
.33113 .78176 L
s
P
p
.41 0 1 r
.01 w
.46057 .70728 m
.46057 .70728 L
s
P
p
.902 0 1 r
.01 w
.33104 .78383 m
.33104 .78383 L
s
P
p
.429 0 1 r
.01 w
.46055 .7093 m
.46055 .7093 L
s
P
p
.921 0 1 r
.01 w
.33094 .78589 m
.33094 .78589 L
s
P
p
.808 0 1 r
.01 w
.3633 .76778 m
.39531 .762 L
s
P
p
.448 0 1 r
.01 w
.46052 .71133 m
.46052 .71133 L
s
P
p
.94 0 1 r
.01 w
.33084 .78797 m
.33084 .78797 L
s
P
p
.259 0 1 r
.01 w
.36048 .68093 m
.3925 .67484 L
s
P
p
.467 0 1 r
.01 w
.46049 .71337 m
.46049 .71337 L
s
P
p
.959 0 1 r
.01 w
.33075 .79004 m
.33075 .79004 L
s
P
p
.486 0 1 r
.01 w
.46046 .7154 m
.46046 .7154 L
s
P
p
.978 0 1 r
.01 w
.33065 .79211 m
.31179 .78155 L
s
P
p
.864 0 1 r
.01 w
.39512 .7682 m
.36306 .77397 L
s
P
p
.505 0 1 r
.01 w
.46043 .71744 m
.46043 .71744 L
s
P
p
1 0 .549 r
.01 w
.3978 .85959 m
.36573 .86504 L
s
P
p
1 0 .53 r
.01 w
.36565 .86716 m
.36565 .86716 L
s
P
p
1 0 .511 r
.01 w
.36557 .86928 m
.36557 .86928 L
s
P
p
1 0 .492 r
.01 w
.36549 .8714 m
.36549 .8714 L
s
P
p
.826 0 1 r
.01 w
.39524 .76406 m
.39524 .76406 L
s
P
p
1 0 .473 r
.01 w
.36542 .87352 m
.36542 .87352 L
s
P
p
.372 0 1 r
.01 w
.42446 .6809 m
.44266 .69213 L
s
P
p
.845 0 1 r
.01 w
.39518 .76613 m
.39518 .76613 L
s
P
p
1 0 .454 r
.01 w
.36534 .87565 m
.34664 .8656 L
s
P
p
.278 0 1 r
.01 w
.39244 .67686 m
.4247 .67074 L
s
P
p
1 0 .568 r
.01 w
.43014 .85197 m
.39786 .85747 L
s
P
p
1 0 .587 r
.01 w
.46268 .84432 m
.43019 .84985 L
s
P
p
.997 0 1 r
.01 w
.31168 .78364 m
.29257 .77295 L
s
P
p
.297 0 1 r
.01 w
.42465 .67277 m
.42465 .67277 L
s
P
p
.315 0 1 r
.01 w
.4246 .6748 m
.4246 .6748 L
s
P
p
.334 0 1 r
.01 w
.42456 .67683 m
.42456 .67683 L
s
P
p
.353 0 1 r
.01 w
.42451 .67886 m
.42451 .67886 L
s
P
p
1 0 .606 r
.01 w
.4954 .83661 m
.4627 .84219 L
s
P
p
1 0 .435 r
.01 w
.34655 .86773 m
.3276 .85756 L
s
P
p
1 0 .644 r
.01 w
.47741 .82194 m
.49542 .83236 L
s
P
p
1 0 .625 r
.01 w
.49541 .83448 m
.49541 .83448 L
s
P
p
1 0 .984 r
.01 w
.29245 .77505 m
.29245 .77505 L
s
P
p
1 0 .965 r
.01 w
.29233 .77714 m
.3246 .77131 L
s
P
p
1 0 .416 r
.01 w
.3275 .8597 m
.3275 .8597 L
s
P
p
1 0 .662 r
.01 w
.45919 .80924 m
.47743 .81981 L
s
P
p
1 0 .397 r
.01 w
.3274 .86185 m
.3599 .8563 L
s
P
p
1 0 .946 r
.01 w
.32449 .77341 m
.35701 .76753 L
s
P
p
1 0 .795 r
.01 w
.44098 .78358 m
.45939 .79434 L
s
P
p
1 0 .303 r
.01 w
.35948 .8671 m
.3269 .87264 L
s
P
p
1 0 .776 r
.01 w
.45936 .79646 m
.45936 .79646 L
s
P
p
1 0 .284 r
.01 w
.3268 .8748 m
.3268 .8748 L
s
P
p
1 0 .757 r
.01 w
.45933 .79859 m
.45933 .79859 L
s
P
p
1 0 .265 r
.01 w
.32669 .87697 m
.32669 .87697 L
s
P
p
1 0 .379 r
.01 w
.35981 .85845 m
.39256 .85286 L
s
P
p
1 0 .738 r
.01 w
.4593 .80071 m
.4593 .80071 L
s
P
p
1 0 .246 r
.01 w
.32659 .87914 m
.32659 .87914 L
s
P
p
1 0 .927 r
.01 w
.35692 .76964 m
.38968 .76373 L
s
P
p
1 0 .719 r
.01 w
.45927 .80284 m
.45927 .80284 L
s
P
p
1 0 .227 r
.01 w
.32649 .88131 m
.32649 .88131 L
s
P
p
1 0 .7 r
.01 w
.45924 .80497 m
.45924 .80497 L
s
P
p
1 0 .208 r
.01 w
.32639 .88348 m
.30706 .87328 L
s
P
p
1 0 .322 r
.01 w
.39236 .85936 m
.35956 .86494 L
s
P
p
1 0 .681 r
.01 w
.45921 .80711 m
.45921 .80711 L
s
P
p
1 0 .36 r
.01 w
.39249 .85502 m
.39249 .85502 L
s
P
p
1 0 .814 r
.01 w
.42238 .77054 m
.44102 .78145 L
s
P
p
1 0 .341 r
.01 w
.39243 .85719 m
.39243 .85719 L
s
P
p
1 0 .909 r
.01 w
.38961 .76585 m
.42263 .7599 L
s
P
p
1 0 .189 r
.01 w
.30695 .87546 m
.28735 .86513 L
s
P
p
1 0 .89 r
.01 w
.42258 .76202 m
.42258 .76202 L
s
P
p
1 0 .871 r
.01 w
.42253 .76415 m
.42253 .76415 L
s
P
p
1 0 .852 r
.01 w
.42248 .76628 m
.42248 .76628 L
s
P
p
1 0 .833 r
.01 w
.42243 .76841 m
.42243 .76841 L
s
P
p
1 0 .17 r
.01 w
.28722 .86732 m
.28722 .86732 L
s
P
p
1 0 .151 r
.01 w
.2871 .86952 m
.32011 .86388 L
s
P
p
1 0 .132 r
.01 w
.32001 .86608 m
.35328 .8604 L
s
P
p
1 0 .114 r
.01 w
.35319 .86261 m
.38673 .8569 L
s
P
p
1 0 .095 r
.01 w
.38666 .85912 m
.42046 .85336 L
s
P
p
1 0 .076 r
.01 w
.4204 .85559 m
.4204 .85559 L
s
P
p
1 0 .057 r
.01 w
.42035 .85782 m
.42035 .85782 L
s
P
p
1 0 .038 r
.01 w
.4203 .86005 m
.4203 .86005 L
s
P
p
1 0 .019 r
.01 w
.42025 .86229 m
.42025 .86229 L
s
P
p
.002 w
.6375 .02391 m
.89218 .25755 L
s
.89218 .25755 m
.96293 .88523 L
s
.96293 .88523 m
.66382 .68391 L
s
.66382 .68391 m
.6375 .02391 L
s
.11523 .15634 m
.03707 .79902 L
s
.03707 .79902 m
.66382 .68391 L
s
.66382 .68391 m
.6375 .02391 L
s
.6375 .02391 m
.11523 .15634 L
s
P
p
p
.002 w
.11523 .15634 m
.6375 .02391 L
s
P
p
.002 w
.23289 .12651 m
.23888 .13107 L
s
P
[(5)] .2209 .11739 .84711 1 Mshowa
p
.002 w
.38437 .0881 m
.39012 .09278 L
s
P
[(10)] .37286 .07872 .79164 1 Mshowa
p
.002 w
.54097 .04839 m
.54646 .0532 L
s
P
[(15)] .52998 .03876 .73617 1 Mshowa
p
.001 w
.26278 .11893 m
.26635 .12168 L
s
P
p
.001 w
.29288 .1113 m
.29642 .11406 L
s
P
p
.001 w
.32317 .10361 m
.32668 .10639 L
s
P
p
.001 w
.35367 .09588 m
.35715 .09868 L
s
P
p
.001 w
.41527 .08026 m
.41869 .08309 L
s
P
p
.001 w
.44638 .07237 m
.44977 .07521 L
s
P
p
.001 w
.4777 .06443 m
.48106 .06729 L
s
P
p
.001 w
.50923 .05643 m
.51256 .05931 L
s
P
p
.001 w
.20318 .13404 m
.20681 .13676 L
s
P
p
.001 w
.17367 .14152 m
.17732 .14423 L
s
P
p
.001 w
.14436 .14896 m
.14803 .15165 L
s
P
p
.001 w
.57293 .04028 m
.57619 .04318 L
s
P
p
.001 w
.6051 .03212 m
.60834 .03504 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29966 .03591 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004T0
0ol300;o0`03o`800ol20003o`0003000ol300?oP00004P000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<@000ol000050003o`0007d0001<0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<@000ol000050003o`0007d0001900?o0P001_l00?l0o`8000Ko003o0?l20003o`000340
00?o00000P03oa/01?mQ0000B0000ol0000400;o0P001Ol00?l000Ko=0000ol000020003o`0001L0
1?l20003o`3o060000180005o`000?l030000ol0o`0e00;o1004oa801?l60004o`00oel0001900?o
3`000ol0001;00Co0P000ol000050005o`000?l0GP000:D01?l<00Co00@0ooooG@000:800ol20003
o`0000L01?l2P@03oh7o00<000?o0000FP0009h01?l;00Co0h400on1P@04o`<000?o0000F@0009X0
1Ol900Go2843o`>100Go0000o`1J0000I`03o`@00_lV00Co1@000ol0000200Co18400on1P@04o`05
^l^kbol018400ol00002oeT0001X0003o`00008000Co003o8@04o`X01?l9P@;o2;/00on1P@03P@05
o`000?l0F00006P000?o00000P001?l00?lM00Co10000ol0000200Go0h400on1P@05o`0>^l^kbk_;
^l^kbk_;ol/3P@?o0`02oeH0001X0003o`00008000Co003o6@04o`T01?l9P@;o4K/00onk^`02o`>1
00?o00000P000ol0000700?oB@0006P000?o00000P001?l00?lE00Co0`000ol0000300Co0h400on1
P@05o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kb`05P@03o`0000?o2`000ol000160000I`02o`D0
0_lB00Co2@04o`R10_lJ^`03ok^k00:k1H42o`<000?o000020000ol000160000O`03o`<000?o0000
0P05o`>100?oPH401?l09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`>11?l30003
o`0000@00om90000N`04o`P00ol9P@;o8k/01?nk^k/4o`B100Go0000o`050003o`0004T0001g00Co
0P000ol0000500;o0h400on1P@04o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00Co0h400on1P@03P@05o`21POl01004odP0001c00Co2P04o`J10_lW^`Go1h400on1P@03P@;o
0P000ol0001=0000@`03obT01?l00`3oP@0700Go1H43o`0Ubk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`05o`>10_l8P@04oh61P@Co0P000ol0001<0000AP000ol0000R00Co1P001?n1
0005o`>100?oPH400ol?^`?o4[/4o`V100?oPH401h43o`B100Co003oC@0004H000?o00007P04o`03
0?l000L01Ol8P@;o00g;^l^kbk_;^l^kbk_;00Go0e/03Oo;^l^kbk_;^l^kbk/01Ol3P@03oh6100N1
0_l2P@Co00C;^l^k1X44od`0001300?o7@04o`X01?l4P@03oh6100Co1842o`Vk0_l9F`03ok^k00Nk
0_l9P@03oh6100J100CoPOoo2[/3P@03oh7o00800_m:0000@`000ol0000I00Co00<0o`001`04o`V1
0_l:P@0<ok_;^l^kbk_;^l_o2E/03?o;^l^kbk_;^l^ko`V100?oPH401_l03[_;^l^kbk_;^l^kbk_;
0_l3P@05o`000?l0B@0004<01?lE00?o2P04o`B100?oPH401?l4^`03oh6100R100?o^k/02;/00omK
F`07F`;o2K/00on1P@07P@;o1K/00onk^`0=^`F100Go0000o`0V00Go00D0oooo0003o`<00_l@0000
F005o`P01?l9P@;o00[;^l^kbk_;^l_o0X45o`0?^l^kbk_;^l^kbk_;^l_o009K1?l4F`0;ok_;^l^k
bk_;^ol00X44o`B101Kobk_;^onkbk_;^l^kbk_;^l^kbk_;1H400ol0o`02obD000?o00000P001?l0
0?l40004o`00oa40001D00Co2@04o`>100?oPH401Ol=^`?o5;/2o`UK00?o^k/01k/2o`V100Go^k^k
o`0A^`>10ol30003o`00028000?o00000`03o`800_l30003o`0000l0001@00Go2004o`R10_l03k_;
^l^kbk_;^l^kbk_;^`03o`=K01Ko^l^kbk_;^l^kbk_;^l^kbk_;^l_o2U/02onkbk_;^l^kbk_o00Z1
01Kobk_o^l^kbk_;^l^kbk_;^l^kbk_;0_l3P@05o`000?l08`05o`<000?o0?l01@000ol0000?0000
C004o`T01?l3P@03oh6100Co4;/3o`MK00?o^k/01K/4o`Vk00?oFe/025/00onk^`07^`03oh6100R1
0olC^`F100Go0000o`0R0003o`0000<00_l300?o00@0oooo400004P01?l00h40000600Co2842o`0A
^l^kbk_;^l^kbk_;^l^kbk/00ol;F`03ok_;00Co18402oo;^l^kbk_;^l_o009K1Ol3F`0;ok_;^l^k
bk_;^ol00X45o`B101Go^l^kbk_;^l^kbk_;^l^kbk_;^l/01H401Ol0o`3o024000?o00003@000ol0
000?0000A004o`@000?oP@000P04o`>100?oPH401?lA^`Co15/2o`UK0_l9P@03ok^k00Nk0_l9F`03
ok^k00Nk0_l9P@;o5;/3P@?o0`000ol0000N00Go7@0004001Ol800Co2842o`0C^l^kbk_;^l^kbk_;
^l^kbk_;^`02o`YK00?oFe/01?l01K_;^l_o00V100cobk_;^l^kbk_;^ol9F`0;ok_;^l^kbk_;^l/0
0_l7P@0Goh7o^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l3P@05o`000?l02P03o`@00_l^0000?004o`P0
1Ol3P@03oh6100Co6K/2o`UK0_l9^`03oh6100N100?o^k/02;/00omKF`07F`03ok^k00Vk00?oPH40
1Ol2P@03ok^k01:k1H42o`040?ooo`T000?o00000P001?l00?l]0000>@04o`P00ol9P@;o016kbk_;
^l^kbk_;^l^kbk_;^`04o`0;bk_;^l^kbk_;^ol00U/4o`0?^l^kbk_;^l^kbk_;^l_o00:11?l3P@0<
ol^kbk_;^l^kbk_o0U/4o`0?^l^kbk_;^l^kbk_;^l^k00;o18406On1PH7o^l^kbk_;^l^kbk_;^l^k
bk_;^l/01H42o`<000?o00001P000ol000020004o`00obd0000e00Co2004o`>100?oPH401?lA^`Co
15/2o`Vk0_lA^`Co28400onk^`08^`;o5;/00on1P@02P@03oh6100:100?o^k/04[/3P@Co0`000ol0
00050003o`00008000Co003o;@0003401?l800Co2842o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l:F`0H
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l3P@03oh6100N102;obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_o0h400on1P@03P@0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00;o0h42o`<000?o0000
10000ol000020004o`00obd0000]00Co2004o`>100?oPH401?lA^`Co15/2o`UK00?o^k/04;/4o`R1
00?oPH401h400onk^`0N^`03oh6100Co0h400onk^`0C^`B10_l3P@03o`0000800_l500;o;P0002/0
0_l800Co2842o`0C^l^kbk_;^l^kbk_;^l^kbk_;^`02o`YK00?oFe/01?l04;_;^l^kbk_;^l^kbk_;
^l/5o`>100?oPH401h400on1P@04o`0=bk_;^l^kbk_;^l^kb`03o`0Dbk_;^l^kbk_;^l^kbk_;^l^k
bk/3o`N101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0h400on1o`030003o`0003P0000[0003o`3o00<0
1?l3P@03oh6100Co6K/2o`UK0_l@^`Co2H400on1P@07P@;o3K/4o`=K00?o^k/04[/2o`R100?o^k/0
4k/2o`>100Go0000o`0i0000:`06o`R10_l08;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
0U/4o`0@^l^kbk_;^l^kbk_;^l^kb`Co18400on1P@07P@03oh6100Co00o;^l^kbk_;^l^kbk_;^l/0
0_l8F`0Fol^kbk_;^l^kbk_;^l^kbk_;^l^ko`V10_l05<^kbk_;^l^kbk_;^l^kbk_;^l^k1H401Ol0
003o03P0000[00;o0h400on1P@04obBk0_l@^`Co2H400on1P@07P@;o5;/00omKF`07F`03ok^k01:k
00?oPH401?l4P@;o4k/5P@?o00<0o`00=P0002800_l700;o1842o`0f^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l4P@03oh6100N100?oPH401?l06/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2E/04oo;^l^kbk_;^l^kbk_;^l^kbk/01?l:P@0Dok_;^l^k
bk_;^l^kbk_;^l^kbk/3P@Co0P000ol0000d00008@001?l00?l50003o`0000;o1842oc:k0_l9P@03
oh6100N10_lN^`03oe]K00Co4K/4o`05POn1POl02X400onk^`0A^`;o0h42o`8000?o0000<`000240
00Co003o1@000ol000020003oh6100>103Gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;o`09P@03oh6100Co1842o`0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l04K_;^l^kbk_;^l^kbk_;^l^k00Co1H401On1PH7o00:11Ol05k_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00F10_l0103ooolc00008@001?l00?l50003o`0000<000?oPH400h42obFk1?l9^`03
oh6100N10_l:P@03ok^k02Vk1?l4P@03oh6100:100?oPH400X42oafk1H42o`<000?o0000<0000240
00Co003o1@000ol0000500;o18408Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`AK
0_l02K_;^l^kbk_;o`02P@Co1842o`V101;obk_;^l^kbk_;^l^kbk_;^l/4o`0A^l^kbk_;^l^kbk_;
^l^kbk/01?l9P@03oh6100Co02;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0h44o`<0
00?o0000;`0002800_l60003o`0000L000?oPH400X400onk^`0K^`;o2U/00onk^`06^`;o2X400on1
P@04oa2k1?l4F`03ok^k00Zk1?l4P@03oh6100N10_l00k_o^`0R^`Co18401Ol0003o0300000Z0003
o`0000P000?oPH400X407onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l9F`;o00S;^l^k
bk_;^`;o2H42o`0B^l^kbk_;^l^kbk_;^l^kbk_;0_l9F`0:ok_;^l^kbk_;^`;o2H400on1P@04o`0U
bk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`AK00?oPH400X400ol0o`02obl0
000Z0003o`0000T000?oPH400X42oajk00?oFe/01?l4F`03ok^k00Nk00?oPH401?lH^`03oe]K00MK
00?o^k/02;/00on1P@07P@;o2K/00onk^`0I^`Co2E/01_n1POn1o`<000?o0000;00002X00_l;00;o
18407oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l9F`0:ol^kbk_;^l^kb`;o012kbk_;
^l^kbk_;^l^kbk_;1?l02[_;^l^kbk_;^ol2F`Co00nkbk_;^l^kbk_;^l^kbol00X44o`>102;obk_;
^l^kbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l4F`03oe]K00MK0_l3P@;o0P000ol0000700?o
0`03oa/0000Y0003o`0000d000?oPH400X400onk^`0M^`03oe]K00MK00?o^k/05;/4o`B100?o^k/0
1k/2oa>k0_l8P@03ok^k00Jk00?o^k/03k/6o`UK00?oFe/01?l3F`03oh6100:11Ol90003o`0000D0
00?o0000600002T000?o00003P000on1P@02P@0Qol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_o00UK01;obk_;^l^kbk_;^l^kbk_;^l/4o`V1023o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`V101Cobk_;^l^kboo;^l^kbk_;^l^kb`Ko1U/00omKF`07F`;o25/00on1P@02P@;o0P000ol0
00060003o`0000D000?o0000600002T000?o00003`000on1P@02P@;o7[/00omKF`04oa2k1?l4P@;o
2842oafk00?oPH401h42o`Fk00?o^k/01;/5o`=K00?oFe/01e/00omKF`04o`>k00?oFe/01e/00on1
P@04o`8000?o00001@000ol0000200?o6`0002T000?o00004002o`B10_l07L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;o01:kbk_;^l^kbk_;^l^kbk_;^l/2o`Z100?oPH400ol4P@0Ool^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@Co18402?nkbk_;ol^k1?l9F`03oe]K00MK0_l02K_;
^l^kbk_;o`09F`;o0h42o`800_l50003o`00008000?o00006`0002T000?o00004`05P@03ok^k032k
0_l9P@;o28400onk^`0G^`Ko2H400onk^`04o`=K00?oFe/025/00omKF`04o`fk00?oFe/01?l4F`04
oh61P@;o0h401?l00002o`@01?lJ0000:@000ol0000C0003POn100>10_l0<k_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@Co0h400on1P@07P@0Eol^kbk_;
^l^kbk_;^l^kbk_;^l^k00Co1U/00on1P@07P@;o00=Koe/01E/00omKF`08F`;o00jkbk_;^l^kbk_;
^l^kb`Ko2E/01_n1POn1o`<000?o0000900002T000?o00004`001840ool4P@;o<K/2o`R100?oPH40
1h400onk^`0B^`03oe]K00MK00?oPH401?l3P@03oe_o00MK00?oFe/01Ol<^`Ko1U/00omKF`07F`;o
0h401Ol0003o02D0000Y0003o`00018000F10000o`06P@0dol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`R100?oPH401?l06L^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol02E/2o`R10_l8F`;o00g;^l^kbk_;^l^kbk_;00Co0e/00omKF`07F`03oe]K00Co00>kbk/0
1H400ol0o`02ob@0000X00?o4`000h4000020003oh6100B100?o^k/08k/4o`Vk00?oPH400X42o`:1
0_lM^`03oe]K00Co1;/00on1P@06P@03oe]K00Co15/00onk^`08^`;o25/00omKF`07F`;o2;/5P@;o
0P000ol0000Q0000:0000ol0000C0003P@0000D00_l3P@0Qol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00Co15/02_nkbk_;^l^kbk/4o`J101ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2o`0:bk_;^l^kbk_;o`B10_l0187oool9F`0;ol^kbk_;^l^kbol02U/00omKF`04o`0=^l^kbk_;
^l^kbk_;^`03P@Co0P000ol0000P0000:0000ol0000C0003P@0000H000?oPH400X400onk^`0K^`;o
2E/00onk^`07^`03oh6100N100?o^k/09[/4o`>k00Co^k_o2E/00onk^`07^`03oe]K00QK0_lB^`;o
18401?l00?lQ0000:0000ol0000C0003P@0000L000?oPH400X407oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l8F`;o00W;^l^kbk_;^ol02H42o`0bbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbol2F`Co0e/02oo;^l^kbk_;^l_o009K1Ol3F`0Dok_;^l^k
bk_;^l^kbk_;^l^kbk/5P@?o00<0o`007`0002P000?o00004`000h4000080003oh6100:10_lN^`03
oe]K00?o15/00onk^`06^`03oh6100Co1842ob^k00?o^k/00[/2o`QK00?o^k/01k/2o`UK00?o^k/0
4K/3P@04oh7oo`8000?o00007@0002P000?o00004`000h40000900;o1842o`0Mbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00_l8F`09ol^kbk_;^l^k00;o2X40<onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^ko`08F`0<ol^kbk_;^l^kbk_o2E/05?nkbk_;^l^k
bk_;^l^kbk_;^l^k0_l3P@;o0P000ol0000L0000:0000ol0000C0003P@0000`01H400onk^`0K^`03
oe]K00MK00?o^k/01k/2o`V100?o^k/09k/00onk^`05^`03oe]K009K0_l2F`;o2K/00omKF`04o`=K
00?o^k/04[/4P@Go7@0002P000?o00004`000h40000=0003oh6100:10_l07K_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00UK00cobk_;^l^kbk_;^ol2P@Co0h40<?nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;^`Ko1U/02_nkbk_;^l^kbk/2o`QK01Go^l^kbk_;^l^k
bk_;^l^kbk_;^l/00h401On1o`3o01d0000X0003o`0001<000>100003P02o`B100?o^k/06[/00omK
F`04o`jk0_l8P@03ok^k02Jk00?o^ol00ol3F`03oe]K00MK00?o^k/02;/00omKF`06F`03ok^k01:k
0_l3^`;o7@0002L00olC0003P@00010000?oPH400h406Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
1_l05;_;^l^kbk_;^l^kbk_;^l^kbk_o2H409_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k1?l8F`03oe]K00MK00co^l^kbk_;^l^kbol4F`;o0U/2o`0<bk_;^l^kbk_;^l^k1?l5P@04
^l^koad0000W0003o`0001<000>100004@000on1P@03P@03ok^k00nk1_l6F`03ok^k016k00?oPH40
1h42ob2k0ol2F`03oe_o00QK00?oFe/01?l<^`Ko1U/00onk^`05^`Co1X44o`8000?o00006`0002L0
00?o00004`000h40000D00;o0X42o`0<bk_;^l^kbk_;^l^k0ol4F`03oe]K00IK01Go^l^kbk_;^l^k
bk_;^l^kbk_;^ol00X44o`B101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l5F`04oe]Ko`AK
0_l2F`;o00c;^l^kbk_;^l^kbk/4o`=K00?oFe/01e/00oo;^`04o`V100?o00001@000ol0000J0000
9`000ol0000C0003P@0001D000?oPH400X400onk^`07^`;o25/00omKF`06F`03ok^k016k0_l9P@03
ok^k01Bk1?l4F`03oe]K009K00CoFe]K1?l>^`Co25/00omKF`07F`;o1X44o`/000?o00006P0002L0
00?o00004`000h40000F0003oh6100:100cobk_;^l^kbk_;^ol8F`03oe]K00?o01Vkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00V10_l04[_;^l^kbk_;^l^kbk_;^l^kb`;o2E/00omKF`03o`0@bk_;^l^k
bk_;^l^kbk_;^`Co15/00omKF`06F`8O00=O7ol00_l9P@03o`0000d000?o00006P0002L000?o0000
4`000h40000F0003POn100>10_l9^`03oe]K009K0_l2F`;o7;/00on1P@04o`B100?o^k/04K/00omK
F`07F`;o00>kok/03;/4o`UK00<OGal00Ul01AmO7elO00=O0h45oa<000?o00006P0002L000?o0000
4`000h40000F0004P@3oo`B10_l02<^kbk_;^l^k1?l08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;o2H401Onkbk_;00Ko00Zkbk_;^l^kbk_o0U/4o`0?^l^kbk_o^l^kbk_;^l^k00Co
15/00omKF`02F`05GamO7el021l01elO7eoo084060000ol0000J00009`000ol0000C0003P@0001H0
00>100000P05P@03ok^k02jk0_l8P@Co1U/00onk^`07^`;o2K/00onk^`03^`Co1e/03AmO7elOGamO
7elOPEl02Al30003P@0001H000?o00006P0002H000?o000050000h40000F0003P@0000<000?oPH40
0X42o`0a^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o
0e/00omKF`07F`0Gok_;^l^kbk_;^l^kbk_;^l^kbk_o^l/00ol4F`03oelO00PO00=O7el00h42G`07
7elOGamO7`060003P@0001H000?o00006P0002H00olD0003P@0001H000>100001002o`B100?o^k/0
;;/4o`MK00?oFe/01e/00onk^`0@^`?o2al015lOGal5P@TO2`000h40000E0003o`0001X0000V0003
o`0001<000>100005P000h4000060003oh6100>102[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/4o`AK00?oFe/01E/00omKF`04o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`@O
00MO7elOGamO00;o1X400omOG`05G`l000>100005@000ol0000J00009P000ol0000C0003P@0001H0
00>100001`000on1P@03P@;o3k/4oa:k0_l9F`03oe]K009K00?oFe/00_lG^`8O00Go7alOo`037`;o
28400elOG`037a<000>100005P000ol0000I00009P000ol0000C0003P@0001H000>100002@02o`B1
00cobk_;^l^kbk_;^l/3o`AK0_l04l^kbk_;^l^kbk_;^l^kbk_;^ol02E/4o`F101Oobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`027`Oo1843o`09GamO7elOGamO01@000>100005P000ol0000I00009P000ol0
000C0003P@0001H000>100002P000on1P@03P@03ok^k00Jk0_l9F`03ok^k00:k1Ol9^`03oe]K00Co
1;/00on1P@05P@03ok^k012k1_l4P@Go00UO7elOGamO7el060000h40000F0003o`0001T0000V0003
o`0001<000>100005P000h40000;0003oh6100>10_l02K_;^l^kbk_;o`09F`Co1E/02_nkbk_;^l^k
bk/2o`0:bk_;^l^kbk_;o`B100?oPH400_l03;_;^l^kbk_;^l^kb`Co1H401_n1PH7o00AO00BO4IlA
0YlK0003P@0001H000?o00006@0002H000?o00004`000h40000F0003P@0000h00_l3P@03ok^k00Jk
00?oFe/01?l4F`03oe]K00EK00?o^k/04[/4o`F100?o^k/01K/4o`J11?l00`210003W`054IlAWa40
19lK0003P@0001H000?o00006@0002D000?o000050000h40000F0003P@0000l000?oPH400X402Onk
bk_;^l^kb`02o`UK00?oFe/00U/06OmKFonkbk_;^l^kbk_;^l^kbk_;^l^kbol028400onkb`04o`V1
00DAWa6Oo`054@0:Wa6OgioOWmnOga/000>100005P000ol0000I00009@000ol0000D0003P@0001H0
00>1000040000on1P@02P@03ok^k00Nk00?oFe/01e/4oaVk00?oPH401X42o`J10ol64@:O00GoWinO
g`08Wah000>100005P000ol0000I00009@000ol0000D0003P@0001H000>100004P02o`:10_l02L^k
bk_;^l^ko`02F`Co026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X43o`>10ol03H4A
5a4G4IlAWa6O4El00Q400onOW`04W`03gil0024000>100005P000ol0000I00009@001?n1oolC0003
P@0001H000>100004`000on1P@02P@03ok^k00Jk0_lQ^`Ko18400aLA4@0:4@0<GamOgioOWonOgioO
9P000h40000F0003o`0001T0000F00?o1002o`H000?o08404`000h40000G0003P@0001@000?oPH40
0X409Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01_l4P@TA00@G4ALA0`0025lG
WmnOgioO0Yl00ol0P@0X0003P@0001L000?o0000600001L000?o00000P001?l00?l50003o`0000:1
4@000h40000G0003P@0001@000>1oh400h42oank0ol9P@08oaLA5a4G4AL90007gioOWmnOg`030003
o`2102T000>100005P000ol0000H00005`000ol000020004o`00o`D000?o00000P000h40000>0003
P@0001L000>1000050001840ool4P@0Kok_;^l^kbk_;g]oNgk_;^l^kbk_;^l^kbk_;00Co1X43o`@0
0a400aLA000600FO00?OW`001P000ol0P@0Y0003P@0001H000?o0000600001L000?o00000P001?l0
0?l50003o`0000<00X4>0003P@0001L000>1000050001H40003o00B100Co^k^k1ml00mjk^`08^`Co
0X44o`:10_l:000?5a4G5`2OgioOWmnOgioO00T000?oP@00:0000h40000F0003o`0001P0000G0003
o`00008000Co003o10000ol000060003P@0000/000>100005`000h40000D0003P@0000<000?oPH40
0]l02=kOg]oNgmk;0]l01Mk;^l^k00Go1H42o`D000>100002P00114GWml5W`034AL000/000?o0840
:0000h40000F0003o`0001P0000F00;o1@02o`D000?o00001`02P@/000>100005P000h40000E0003
PMoO00_O1K/01=kOg]l3o`B10ol:0003P@0000P000VOgioOWmnOga4040000ol0P@0X0003P@0001H0
00?o0000600002@000?o00002@000h4000080003P@0001H000>100004@0>g`B100?o^l/00ol0187N
gmh5P@03o`0000/000>100001003W`0:gioOWmnO014G4A0000?o0840:0000h40000F0003o`0001P0
000T0003o`0000X00X480003P@0001H000>100004@06g`040=oOg`@000?oPH400X42o`F100COg]oo
4@0018400005g`03WmnO00H00QL@0003o`2102P000>100005P000ol0000H000090000ol0000<0003
P@0000D000>100005P000h40000A00?O00>Og`002@02o`03^l_o00?o0X401_l0g]oNga0000<Agil0
1IlL0003o`2102P000>100005P000ol0000H00009002o`h00X450003P@0001H000>100005003g`03
W`0000P00_l90004gmkNgP/000JO4IlAWa43gal000?o0840:0000h40000G0003o`0001L0000T0003
o`0000l000F10000P@0I0003P@0001@000>1gil00ml80003o`0000X00ml60009WmlAga7O4MlA02<0
00?o0840:0000h40000G0003o`0001L0000T0003o`0001000X400`21000H0003P@0001@000R1002O
gioOW`H000?o00002`03gP0309nO00FO00<AW`000P000h40000Q0003o`2102P000>100005`000ol0
000G00008`000ol0000C00:16@000h40000D0003P@0000800ml00il000030003o`0000/000WOg]kO
WmnOgil01`000h40000Q0003o`2102P000>100005`000ol0000G00008`000ol0000D00:160000h40
000D0003P@0000<000COWmnO10000ol0000700FO00CNginO2`000h40000Q0003o`2102T000>10000
5P000ol0000G00008`000ol0000D0003P@2101L000>1000050000h4000050007WmnOga40o`0700OO
0]h=0003P@00024000?o0840:@000h40000F0003o`0001L0000S0003o`0001@000>100000X4E0003
P@0001@000>100001P001YoOWmnOg`@000?OWml00il40003g]oO00`000>100008@000ol0P@0Y0003
P@0001H000?o00005`0002<000?o000050000h4000020003P@00018000>1000050000h400007000>
WmlAga7OWmnOgioOWml60003gmkO00/000>100008@000ol0P@0Y0003P@0001H000?o00005`0002<0
00?o000050000h40000300:14P000h40000D0003P@0000/000KOWmoOWml;0003gmkO00X000>10000
8@000ol0P@0Y0003P@0001H000?o00005`0002<000?o000050000h4000050003P@0000l000>10000
50000h40000;0003omlA00l000COg]oN20000h40000Q0003o`2102T000>100005`000ol0000F0000
8`02oaD000>100001P02P@l000>1000050000h40000;0003o`00010000GOg]oNg`060003P@000240
00?o0840:@000h40000G0003o`0001H0000S0003o`0001<000>100002@000h40000;0003P@0001D0
00>100002`000ol0000B00CN1@000h40000Q0003o`2102T000>100005`000ol0000F00008P000ol0
000D0003P@0000X00X4;0003P@0001D000>100002`000ol0000D0003gmkN00@000>100008@000ol0
P@0Y0003P@0001L000?o00005P00028000?o000050000h40000<0003P@0000P000>100005@000h40
000;0005o`000=`00iD>00;N00?OgP000`000h40000Q0003o`2102T000>100005`000ol0000F0000
8P000ol0000D0003P@0000d00X480003P@0001D000>100001`05U@05g9GLUM`00YD:00SN10000h40
000Q0003o`2102T000>100005`000ol0000F00008P000ol0000D0003P@0000l000>100001@000h40
000E0003P@0000<000kLUMbEg9GLUMbEg9GL00;L1P09gPL000>100008@000ol0P@0Y0003P@0001L0
00?o00005P00028000?o000050000h40000@00:11@000h40000E00^E00CNUMbE1@03U@030=kN00ON
2`000h40000Q0003o`2102X000>100005P000ol0000F00008P000ol0000D0003P@0001800X430003
P@0000l000?MUID01iD00mbEg008L@D000CNg9GL1Mh?0003P@00024000?o0840:P000h40000D00:1
00?o00005P00028000?o000050000h40000D0004P@00P@/000>EgID02YD02miagW7NLMeagG7M00=a
00X0gW7NLMiaUMbE4`000h40000Q0003o`2102X000>100003`05P@<000?o00005@00028000?o0000
50000h40000E00>12`001mfEgIGMUMd00P001g7NLMiag]d027400`3ogP06gP8000CLUMbE4@000h40
000Q0004o`00PBT000>100002P05P@P000?o00005@0002400olE0003P@0001L000>100002@04U@03
gG7M008000?NLG401G400meag@020007gW7NLMiagP070005UMcLUM`03`000h40000R0003o`2102T0
00>100001@05P@d000?o00005@00024000?o000050000h40000H00>130001IEaUMfE00;M00MagG7M
LMgN009a0mh01W7NLMiagPX000BEg9GL3P000h40000R0003o`2102T000>100001H4B0003o`0001D0
000Q0003o`0001@000>1000060001840084<000<gIGMLMeaUG610=ia1Mh01G7N003o00h000?LUM`0
3@000h40000R0003o`2102L01H4G0003o`0001D0000Q0003o`0001@000>10000600018400002P@h0
00GMUMd0P@040004LMiagP@000?o00003@02g0d000>100008P000ol0P@0R00F10P000h40000G0003
o`0001D0000Q0003o`0001@000>1000060000h4000030003P@0000`000=agH401P03gP@000?o0000
3@02g0d000>100008P000ol0P@0M00F11`000h40000G0003o`0001D0000200?o70000ol0000D0003
P@0001P000>100001002P@h000>100002`000ol0000=00;L3@000h40000R0003o`2101P01H4<0003
P@0001L000?o00005@00008000Co003o6`000ol0000D0003P@0001L000>100001`000h40000;0003
P@0000/000?o00003@000ncLk00<0003P@00028000?o08405004PA4000>1000060000ol0000D0000
0P000ol0000L0003o`0001@000>100005`000h40000800:12`000h40000;0003o`0000d000CLk=c/
2`000h40000R0003o`2100l01H4E0003P@0001P000?o00005000008000?o00006`000ol0000E0003
P@0001L000>100002P000h4000080003P@0000/000?o00003`000ncLk00:0003P@00028000?o0840
2P05PA/000>100005`000ol0000D000000<0ool00_lK0003o`0001D000>100005`000h40000;00:1
20000h40000;0003o`00010000C/g>cL20000h40000R0003o`2100D01H4P0003P@0001L000?o0000
5000008000?o00006`000ol0000E0003P@0001L000>100003@000h4000050003P@0000/000?o0000
4@001NcLg>cL00H000>100008P000ol0P@05PBD000>100005`000ol0000D00000P000ol0000K00?o
50000h40000H0003P@0000h00X450003P@0000/000?o00004`04g0D000>100008002P@03oh6102X0
00>100005`000ol0000D000080000ol0000D0003P@0001P000>1000040000h4000020003P@0000/0
00?o00005@000mc/g0040003P@0001/01H420003o`2102X000>100005`000ol0000D000080000ol0
000D0003P@0001P000>100004@02P@8000>100002`000ol0000D00;L00?/g0000`000h40000F00F1
1`000ol0P@0Z0003P@0001L000?o00005000020000?o000050000h40000H0003P@0001<000>10840
3@001Ol0002f00?l2`07k003g000008000>100004@05P@`000?o0840:P000h40000G0003o`0001@0
000P0003o`0001@000>1000060000h40000D00:12@003?bfo;Kl]_bfo;Je]PL000?/g=`01]`70003
P@0000`01H4A0003o`2102X000>1000060000ol0000C00007`000ol0000E0003P@0001P000>10000
5@02P@03o;Kl00Rf00Ol]_bfo;H000;l00>f00002N`;0003P@0000P0184F0003o`2102X000>10000
60000ol0000C00007`000ol0000E0003P@0001P000>100004`001KKl]_bf00;l00^fo;Kl]_bgo;Kl
]`04000:]KJe]]c/g>cLk0l000>100000`05PAX000?o0840:P000h40000H0003o`0001<0000O0003
o`0001D000>1000060000h4000090004]kJg00Bf00Sl]_bfo;Klk0>f2KL00`3/k003k004][Ffk1<0
1X4O0003o`2102X000>1000060000ol0000C00007`000ol0000E0003P@0001P000>100002@09]P0A
o;Jgk;O/]`2f]kJg][Nf]kH00[L02]bgg;OL]`2f]KH?00F190000ol0P@0Z0003P@0001P000?o0000
4`0001l000?o00005@000h40000H0003P@0000T01KH40008k;O/k;Nf]kH5]`030=cL00;L0n`60004
][Ff]@P01H440003P@00028000?o0840:`000h40000G0003o`0001<0000O00?o50000h40000H0003
P@0000d000Bg][Nf0P002[Jg][Nf]kJg][L:k0P000Bf]Obe0P05P@T000>100008P000ol0P@0[0003
P@0001L000?o00004`0000l01?l300;o1`000on1000D0003P@0001P000>100003P001;Nf][L3]P03
]kJg00;/00GLk=cLk003g08000?o00002@001H6eo;F100h000>100008P001?l0084Z0003P@0001L0
00?o00004`00010000?o00000P001?l00?l60004o`21PA<000>1000060000h40000@0007][Nf]kH0
P@0300G/0P02P@030?l000D01H420004]Obeo0d000>100008P001?l0084Z0003P@0001L000?o0000
4`00014000Go0000o`020003o`0000<000?o00000P000h40000@0003P@0001P000>100004P001KJg
]P2100D000?Lk=`010000h7o0005P@P000>e3KD03@000h40000R0004o`00PBX000>1000060000ol0
000B00004P001?l00?l20003o`0000<000?o00000`02PA0000>1000060000h40000C0004]kH0P@H0
0^`50003oh4000d00[D=0003P@0002<000?o0840:P000h40000H0003o`000180000?0004o`00o`80
00Co003o1@000ol0000500:13P000h40000H0003P@0001H000>100002`000ol0000=00:e3@000h40
000S0003o`2102X000>1000060000ol0000B00004002o`@00_l60003o`0000L000>100002`000h40
000H0003P@0001H000>100002P000ol0000=0003]@ff00d000>100008`000ol0P@0Z0003P@0001P0
00?o00004P0001h000?o00002002P@/000>1000060000h40000E0003P@0000/000?o00003@05]@/0
00>100008`000ol0P@0Z0003P@0001P000?o00004P0001h000?o00002P02P@T000>1000060000h40
000E0003P@0000/000?o00003`001;D=]@d:0003P@0002<000?o0840:P000h40000H0003o`000180
000N0003o`0000`00X470003P@0001P000>100005@000h40000;0003o`0001401;D80003P@0002<0
00?o0840:P000h40000H0003o`000180000N0003o`0000h000>100000`000h40000I0003P@0001D0
00>100002`000ol0000B00043KD=3@L000>100008`000ol0P@0Z0003P@0001P000?o00004P0001h0
0_l@00:10`000h40000I0003P@0001D000>100002`000ol0000D00>e1P000h40000S0003o`2102/0
00>100005`000ol0000B00007@000ol0000B00:100<0P@006P000h40000E0003P@0000/000?o0000
5@033@D000>100008`000ol0P@0[0003P@0001P000?o00004@0001d000?o00005002PA/000>10000
5@000h40000;0003o`0001@000Fe3KFe3@040003P@0002<000?o0840:`000h40000H0003o`000140
000M0003o`0001D00X4J0003P@0001D000>100002`000ol0000@00093KD=]@fe3KD=00@000>10000
8`000ol0P@0[0003P@0001P000?o00004@0001d000?o00005@001840PH4G0003P@0001H000>10000
2`001_l00<36`0?61P023@07]@fe3KD=]@080003P@0002<000?o0840:`000h40000H0003o`000140
000M0003o`0001D000F10000P@0F0003P@0001H000>100001`002/K0a/36`<K0a/03aP8000T=]@fe
3KD=]@d030000h40000S0003o`2102/000>1000060000ol0000A00007@000ol0000E0003P@000080
0X4D0003P@0001H000^10<36`<K0a/36`002aP05`<K0a/000`000lK0`0063A0000>100008`000ol0
P@0[0003P@0001P000?o00004@0001d000?o00005@000h40000400:14P000h40000@00[000S6`<K0
a/363@;<00<=c00010d3aP03`0d001<000>100008`000ol0P@0[0003P@0001P000?o00004@0001d0
00?o00005@000h40000600:140000h40000900[001?6`<K0a/3<`<K0c0g<3L`=c0g<00H=00@0`<K0
50000h40000S0003o`2102/000>1000060000ol0000A000070000ol0000E0003P@0000T000>10000
3@000h40000900S000L0`<303L`=00;<00?0c<`01/`53@H000?0a/004`000h40000S0003o`2102/0
00>1000060000ol0000A000070000ol0000E0003P@0000X00X4=0003P@0000T01l000l`000020009
c0g<3L`=c0g<00T=20000l36aP0B0003P@0002<000?o0840:`000h40000I0003o`000100000L00?o
5@000h40000<00:12`000h40000=0006c<3<`<c00l`01<3<`<`43@04c0d=3@8000?o000020001LK0
a/36010000>100008`000ol0P@0[0003P@0001T000?o0000400001`000?o00005@000h40000>0003
P@0000P000>100003P02`004c<3<`0;<00N10000c0g<008=1@000ol0000:00C63`000h40000S0003
o`2102`000>1000060000ol0000@000070000ol0000E0003P@0000l00X480003P@00018000G0c<00
P@0500<=1@000ol0000<00?63P000h40000S0003o`2102`000>1000060000ol0000@000070000ol0
000E0003P@0001400X460003P@0001<000C0c0211P000`g<00040003o`0000d00/H>0003P@0002<0
00Co0021:`000h40000H0003o`000100000L0003o`0001D000>100004`02P@@000>100005P000h40
000;0003o`0000d00X`>0003P@0002<000Co0021:`000h40000E00>100?o0000400001`000?o0000
5@000h40000E0005P@00084060000h40000;0003o`0000d00X`>0003P@0002<000Co0021:`000h40
000@00F10`000ol0000@00006`000ol0000F0003P@0001H00X400`21000G0003P@0000/000?o0000
3@000db<S00=0003P@0002<000Co0021:`000h40000:00J120000ol0000@00006`000ol0000F0003
P@0001P00X4H0003P@0000/000?o00003@001Ha<S4b<00/000>1000090000ol0P@0[0003P@0000@0
1X4>0003o`000100000K0003o`0001D000>100006P02PAH000>1000030000ol0000?00B<2P000h40
000T0003o`2102/000>10840184E0003o`0000l0000K0003o`0001D000>100006@000h400002PA@0
00>1000030000ol0000A0004S4b<C0P000>1000090000ol0P@0W00J16P000ol0000?00006`000ol0
000E0003P@0001T000>100000P02PA8000>1000030000ol0000B00><00=<00001@000h40000T0003
o`2102801H440003P@0001T000?o00003`0001/000?o00005@000h40000I0003P@0000@000>10000
3`000h40000<0003o`0001@000=<S4`01P000h40000T0003o`2101`01X490003P@0001T000?o0000
3`0001/00_lF0003P@0001T000>100001@02P@l000>1000030000ol0000E0004C8b<S0@000>10000
90000ol0P@0G00F13`000h40000I0003o`0000l0000K0003o`0001D000>100006@000h40000700:1
3@000h40000<0003o`0001@000F<C4a<S0040003P@0002@000?o08404@06PAD000>1000060000ol0
000?00006P000ol0000F0003P@0001T000>100002@02P@/000>1000030000ol0000@00R<1@000h40
000T0003o`2100/01X4K0003P@0001P000?o00003`0001X000?o00005P000h40000I0003P@0000/0
00>1000020000h40000<0003o`0000`000V<C8a<S4b<C8`020000h40000T0003o`2100H01H4Q0003
P@0001P000?o00003`0001X000?o00005P000h40000I0003P@0000`00X480003P@0000/000?o0000
14d00da=00020006S4b<C8a<0h`<0003P@0002@000?o08401X4V0003P@0001P000?o00003`0001X0
00?o00005P000h40000I0003P@0000h00X460003P@0000H000=<CD`00Td01da=C4e<CD`00Td024b<
C8a<S4b<40000h40000R00:100?oPH40;0000h40000I0003o`0000h0000J0003o`0001D000>10000
6P000h40000@0003P@0000=<4Td3S09=00A>S4b<50000h40000L00J10P000ol0P@0/0003P@0001T0
00?o00003P0001X000?o00005@000h40000J0003P@0000T00dd2000ECDa=C4e<CDa=C4e<CDa=C4e<
CDa=00Q<1DdE0003P@0001L01H4500Go00>10000:P000h40000I0003o`0000h0000J0003o`0001D0
00>100006P000h4000090009C4e<CDa=C4e<00E=00F<C01<C@07C003aTb<00:<1@0014i=CTdD0003
P@0001401X4500Go1@000ol0000Z0003P@0001T000?o00003P0001X000?o00005@000h40000J0003
P@0000T000I<CDa=C4d6000:C4e<CDa=C4e<C@F<00?o00002003CA<000>100002`06P@D01_l:0003
POoo02X000>100006@000ol0000>00006@000ol0000F0003P@0001X000>100003@0014e<CD`2000=
CDa=C4e<CDb<C8a<aP040003o`0000T000==CTd04P000h40000600F11P05oa0000B1003o:@000h40
000I0003o`0000h0000I0003o`0001H000>100006P000h40000>00I=0T`01h40PH6<C8`00T`50003
o`0000T000EVCFI=IP0@0003P@0000J11P05oaD000B100000_lW0003P@0001T000?o00003P0001T0
0olF0003P@0001T000>100004@001da=C4e<08400`02P@03C8a<00D000?o00002`0014eVCFH=00F1
1P06oaX000>100000`000ol0000T0003P@0001T000?o00003P0001T000?o00005P000h40000I0003
P@0001<00dd00`2100040003PDb<00D000?o00003@000fI=CP0600J10P0018400005ob0000>10000
1002obD000>100006@000ol0000=00006@000ol0000F0003P@0001T000>10000500014e<084600:1
1@000ol0000>009=00<0PH400h4600Ko9@000h4000060003o`00028000>100006@000ol0000=0000
6@000ol0000F0003P@0001T000>100005`000h40000600:10`000ol0000;00>100=>IX401P05o`80
00>100009`000h40000600;o8P000h40000I0003o`0000d0000I0003o`0001D000>100006P000h40
000G0003P@0000P000B1003o1`06P@<000A>IP001Ol70003P@0002L000>1000020000ol0000O0003
P@0001T000?o00003@0001T000?o00005@000h40000J0003P@0001L000>100002@02P@03o`0000F1
1`06o``000>100009`000h40000900;o7`000h40000I0003o`0000d0000I0003o`0001D000>10000
6P000h40000G0003P@0000/000?oPH401`05o`801FH;0003P@0002L000>100002`000ol0000L0003
P@0001T000?o00003@0001P000?o00005P000h40000J0003P@0001L000>100002`001?l00006o`T0
00A=ITeV2P000h40000W0003P@0000`00_lL0003P@0001T000?o00003@0001P000?o00005P000h40
000J0003P@0001H000>100002`05oa4016H80003P@0002L000>100003P000ol0000I0003P@0001T0
00?o00003@0001P000?o00005P000h40000J0003P@0001H000>100001@06o`030?l001@000AVCDi=
1`000h40000W0003P@0000l00_lI0003P@0001T000?o00003@0001P000?o00005P000h40000J0003
P@0001H000>100001Ol70003o`0001D00fH60003P@0002L000>100004@000ol0000F0003P@0001X0
00?o0000300001P00olF0003P@0001X000>100005005o``000?o00005P02C@03IP0000<000>10000
9`000h40000B00;o5P000h40000J0003o`0000`0000800?o1002o`L000?oP@005P000h40000J0003
P@0000h01_l20003P@0000`000?o00005@0016I=IVH50003P@0002L000>1000050000ol0000C0003
P@0001X000?o0000300000/000Co003o0P000ol000040004o`21PAD000>100006P000h40000900Go
20000h40000<0003o`00014026H50003P@0002L000>100005@02oa@000>100006@000ol0000<0000
2`001?l00?l20003o`0000@000Co00000X4B0003P@0001/000>100000`06o`d000>1000030000ol0
000=00=V00I=ITeVCFH80003P@0002L000>100005`000ol0000A0003P@0001T000?o0000300000T0
0_l30004o`00o`D000?o00001002PA0000>100006P000h40o`04oa<000>1000030000ol000020004
Ccm??`802VH<0003P@0002L000>100006002oa4000>100006@000ol0000<00002`001?l00?l20003
o`0000<000?o00001P02P@h000>100005P06oaP000>1000020003DloCcm?84lPCb1??dl026H@0003
P@0002L000>100006P000ol0000>0003P@0001T000?o0000300000P00ol400;o1P000ol0000800:1
30000h40000A00Go10000h40000D000IIT9VP@1??dloCcm??dloCcm??dloCcm?IP02?`=V5@000h40
000W0003P@0001/00_l>0003P@0001T000?o0000300001L000?o00002P000h4000090003P@0000`0
1Ol90003P@0001@01dl01cm??dloCcl00dl00b1?@P05IP03?dlP01L000>100009`000h40000M0003
o`0000/000>100006@000ol0000<00005`000ol0000;00:12@000h40000600Ko3P000h40000:00=?
00<0Cdl00Tl063m??dloCcm?@TloCd9?@Tm2Cd9?@TiVCP<00cl00b0o000D0003P@0002L000>10000
7P02o`/000>100006P000ol0000;00005`000ol0000=00:11`0018400005oa@000>100002P0024lo
Ccm??dlo0dl2@P05PD9>Cdh00Tl0149?@Tl4CP03o`0000H000@PCb1?50000h40000W0003P@000200
00?o000020000h40000J0003o`0000/0000G0003o`0000l00X4300Ko6@000h40000:00Q?0P0;@P9V
1@000ol000080003?b0o01<000>100009`000h40000Q00;o20000h40000J0003o`0000/0000G0003
o`0000l01Ol20003P@0001X000>100003P03C`0?@Tm2Cd9?CTm>04i2CT9>00H000?o00002@000dlP
?`0B0003P@0002L000>100008`000ol000050003P@0001X000?o00002`0001H000?o00002`05o`@0
0X400`21000K0003P@0000l01dl00`210005009>1P000ol0000900E?40000h40000W0003P@0002@0
0_l50003P@0001X000?o00002`0001H00ol500Ko2`02PA`000>100004`001D9?@P2100h000?o0000
2`04?`l000>100009`000h40000V0003o`00008000>100006P000ol0000;00005P000ol00005oa40
00B108616P000h40000D009?00<0P@0030000ol0000>009?00<o000030000h40000W0003P@0002L0
0_l30003P@0001T000?o00002`0001H00olF0004P@0000:160000h40000G0003P@0000/000?o0000
3`000dlo000=0003P@0002P000>10000:0001?l0084K0003o`0000/0000H00;o5@000h40000300:1
5P000h40000G0003P@0000/000?o00003`02?`h000>10000:0000h40000Y00;o00>100006@000ol0
000;00006P02oa<000>100001@02PA@000>100005`000h40000;0003o`0000l00Sl>0003P@0002P0
00>10000:`000ol0000J0003o`0000X0000L00;o4@000h40000700:14P000h40000G0003P@0000/0
00?o00003P03?`h000>10000:0000h40000[0003POoo01X000?o00002P0001h00_l?0003P@0000T0
00>100003P000h40000H0003P@0000/000?o00003P05?``000>10000:0000h40000[0004P@00oaT0
00?o00002P0002000_l=0003P@0000X00X4>0003P@0001P000>100002`000ol0000@00@o2`000h40
000X0003P@0002/000B100000_lG0003o`0000X0000R00;o2`000h40000<00:130000h40000G0003
P@0000`000?o00004P03?`03800000L000>10000:0000h40000[0003P@0000<000?o000050000ol0
000:00009002o`T000>100003P02P@X000>100005`000h40000<0003o`0001<00Sl00b0o80070003
P@0002P000>10000:`000h40000400;o50000ol0000:00009P02o`H000>100004@02P@P000>10000
5`000h40000<0003o`0001D000@P?b0o1P000h40000X0003P@0002/000>100001P000ol0000A0003
o`0000X0000X00;o10000h40000C00:11P000h40000G0003P@0000`000?o00005`000b0o?`050003
P@0002P000>10000:`000h40000700;o3P03P@03o`0000X0000Z00;o0P000h40000E00:110000h40
000G0003P@0000`000?o00005P00120o82050003P@0002P000>10000:`000h4000090003o`0000D0
1X430003o`0000X0000/00;o00>100005`02P@8000>100005`000h40000<0003o`0001402B050003
P@0002P000>10000;0000h40000900;o1H4:0003o`0000T0000^00;o6P03PAT000>1000030000ol0
000=000:8B0o83lP?b0o80P000>10000:0000h40000/0003P@0000@01X400`3o000=0003o`0000T0
000`00;o6P02PAP000>1000030000ol0000900TP3@000h40000X0003P@0002`01h4800;o30000ol0
00090000<P02oaP000B108615P000h40000:0004;b4_8@H00R001b4P8B0Q82404@000h40000X0003
P@0002H01h4@0003o`0000T000?o00002@0003@00_lF0004P@0000:15000184000058@03;b4R00<R
0Rl00`0R8P028P037b8Q00<P5@000h40000X0003P@0002001X460003P@0000l00_l90003o`0000T0
000f00;o50000h4000030003P@0000h000<P8B400R400b8O8P027`0?8QlR7b8O8QlR7b8O8QlR008O
6@000h40000X0003P@0001X01X4<0003P@00014000?o00001P000ol000090000>002oa8000>10000
1002P@X000/O8QlR7b8O8QlR7`088P038B8R00@R0`027aT000>10000:0000h40000D00J14P000h40
000B00;o1P000ol000090000>P02oa0000>100001P02P@03028R00LR01DO8QlR7b8O8R4O8QlQ;b4_
8BlQ8?l01P000alR000H0003P@0002P000>100003P06PAP000>1000050000ol000030003o`0000T0
000l00;o3@000h400009000>PB8O8QlR7b8O01lR7`088@038R4P00D000?o00007`000h40000X0003
P@0000P01X4N0003P@0001D00_l30003o`0000T0000n00;o2`000h40000:00<R00HO8QlR7b820008
8B8Q8R4R8B848@03800000<000?o00007`000h40000X0003P@0000801X4T0003P@0001L000Go0000
o`0:0000@002o`T000>100003@02P@03028R00@R0R400h4000040003824P00D000?o00007`000h40
000V00N1:P000h40000H00;o00<0o`002@0004800_l70003P@0000l00X400`0R8P038P03084000d0
00?o00007`000h40000P00J10P000h40000/0003P@0001X00_l:0000A002o`D000>100004@02P@06
028R8P213P000ol0000O0003P@0001X01X480003P@0002d000>100005`04o`X0001600;o0`000h40
000C00:10R800`21000=0003o`0001l000>100005006P@l000>10000;0000h40000@00Oo3P0004P0
0_l00`21000F00:100<0P@003@000ol0000O0003P@0000h01X4E0003P@0002`000>100002P06oaD0
001:00;o6@02P@h000?o00007`000h40000800J16`000h40000/0003P@0000<01olK0000C002oaP0
0h4<0003o`0001l000>100000P06PB4000>10000;006ob80001>00;o5P001840084;0003o`0001h0
1X4W0003P@0002D01ol00h40000U0000D002oa<000>100000P02P@T000?o00006006P@03084002X0
00>100007`06obl0001B00;o4@000h40000400:11`000ol0000A00N11`000h40000Y0003P@0001T0
1_le0000E002o`l000>100001P02P@D000?o00002`06P@h000>10000:@000h40000B00Oo>`0005H0
0_l=0003P@0000P00X420003o`0000H01X4D0003P@0002T000>100003006od80001H00;o2`000h40
000:00:100?o00001X4J0003P@0002T000>100001@07odP0001J00;o2@000h40000<0003oh610200
00>10000:@000h40o`05odl0001L00;o1`000h40000<0003o`00020000>100009007oeD0001N00;o
1@000h40000<0003o`00020000>100007P06oe`0001P00;o0`000h40000<0003o`00020000>10000
5`07of80001R00;o00<0P@003@000ol0000P0003P@0001401_mY0000I002o`h000?o000080000h40
000:00OoK`0006D000>1ool030000ol0000P0003P@0000@01_mf0000J002o`X000?o000080000h7o
o`04og`0001Z00;o20000ol0000J00OoPP0006`00_l60003o`0001@01_n90000KP02o`@000?o0000
3@07ohl0001`00;o0P000ol0000700KoUP0007800ol200OoW00007@00onS0000o`0K0000o`0K0000
o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000MP000ol0000W0003
o`0007L0001A00Co0`04o`040?oo00;o0P02o`<00ol40003o`0000<000?o00002005o`040?oo00;o
0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l300?o1002o`@00_m80000D0001Ol0
003o008000?o00000`001?l00?l300;o10000ol000030003o`0000@000?o00002@001Ol0003o0080
00Co003o0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o
10000ol000020004o`00o`<00_m80000D0000ol0o`02o`801Ol01@3o003o00T000?o000010000ol0
000?0005o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003o`00008000?o0000
2@000ol000020004o`00odd0001@0003o`0000@000Oo0000o`3o008000?o00001`000ol000040003
o`0000l000Go0000o`020004o`00o`<000?o00001P000ol0000>00?o1@000ol000020003o`0000T0
00?o00000`02odh0001@0005o`000?l00`03o`030?oo00?o2@000ol000050003o`0000h000?o0000
1Ol300Co20000ol0000>0003o`0000@00_l300Co2@000ol000020004o`00odd0001A00Co5002o`@0
1?l>00Go2`000ol0000500;o3`05o`T000?o00002002o`D00_m>0000T002ob4000?o00000P000ol0
001O0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.122096, -0.0214021, \
0.00251467, 0.00389973}},
  CellTags->"AntTracker3D - Gen 17"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 16",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 18",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[\(ifSensor[dust]\)[seq[turnLe*ft, \ again], \ nop, \ 
              nop], \ \n\ \ \ \ \ \ \ \ advance, \ \(ifSensor[wall]\)[
              seq[stop], \ advance]], \ 
          advance], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ 
        advance, \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[seq[turnLeft, \ again], \ 
          advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.17, Ind.1, Fit.18.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.17, Ind.1, Fit.18.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .473 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .492 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .511 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .53 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .549 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.713 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.694 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.675 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.656 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.637 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .101 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .12 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .139 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .158 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .177 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .915 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .934 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .953 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .972 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .991 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .271 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .252 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .233 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .215 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .196 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.543 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.562 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.58 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.599 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.618 1 0 r
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .473 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .492 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .511 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .53 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .549 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.713 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.694 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.675 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.656 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.637 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .101 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .12 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .139 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .158 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .177 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .915 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .934 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .953 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .972 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .991 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .271 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .252 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .233 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .215 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .196 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.543 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.562 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.58 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.599 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.618 1 0 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 0 .568 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.618 0 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .196 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .991 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .177 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.637 1 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 .89 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 .871 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 0 .568 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.618 0 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .196 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .991 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .177 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.637 1 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 .89 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 .871 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 0 .454 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
.732 0 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 .082 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 .896 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .29 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
.524 1 0 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 0 .587 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.599 0 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 .215 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .972 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .158 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.656 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .852 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .492 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .473 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .454 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .435 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
1 .416 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 0 .454 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
.732 0 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 .082 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 .896 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .29 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
.524 1 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 0 .587 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.599 0 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 .215 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .972 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .158 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.656 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .852 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .492 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .473 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .454 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .435 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
1 .416 0 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
1 .909 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 0 .606 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.58 0 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .233 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .953 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .139 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.675 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 .833 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .397 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .379 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .36 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .341 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .322 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .303 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .284 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
1 .909 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 0 .606 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.58 0 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .233 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .953 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .139 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.675 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 .833 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .227 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .246 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .265 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .284 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .303 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .416 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 0 .435 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.959 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.94 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.921 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.902 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.883 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.77 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.751 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.145 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.126 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.107 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.088 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.069 0 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .044 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .063 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .669 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .688 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .707 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .726 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .744 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .858 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 .877 1 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .517 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .498 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .479 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .461 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .442 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .328 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
0 1 .309 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.297 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.315 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.334 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.353 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.372 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.486 1 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
.505 1 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .397 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .379 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .36 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .341 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .322 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .303 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .284 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 0 .625 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 0 .644 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.562 0 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.543 0 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .252 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .271 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .934 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .915 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .12 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .101 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.694 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.713 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .814 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .511 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .227 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .246 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .265 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .284 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .303 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .416 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 0 .435 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.959 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.94 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.921 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.902 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.883 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.77 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.751 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.145 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.126 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.107 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.088 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.069 0 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .044 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .063 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .669 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .688 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .707 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .726 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .744 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .858 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 .877 1 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .517 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .498 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .479 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .461 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .442 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .328 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
0 1 .309 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.297 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.315 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.334 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.353 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.372 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.486 1 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
.505 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .265 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 0 .625 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 0 .644 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.562 0 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.543 0 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .252 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .271 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .934 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .915 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .12 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .101 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.694 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.713 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .814 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .511 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
1 0 .322 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
1 0 .397 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.864 0 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.789 0 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.05 0 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 .025 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 .763 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 .839 1 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .423 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .347 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.391 1 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.467 1 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
1 .927 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .265 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
1 .795 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
1 0 .322 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
1 0 .397 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.864 0 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.789 0 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.05 0 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 .025 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 .763 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 .839 1 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .423 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .347 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.391 1 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.467 1 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
1 .927 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .246 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .019 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
1 .795 0 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
1 0 .208 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
.978 0 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
.164 0 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 .65 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 1 .536 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
.278 1 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
1 0 .341 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
1 0 .36 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
1 0 .379 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.845 0 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.826 0 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.808 0 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.032 0 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.013 0 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 .006 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 .782 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 .801 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 .82 1 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 1 .404 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 1 .385 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
0 1 .366 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.41 1 0 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.429 1 0 r
F P
s
P
p
.002 w
.43057 .48505 m .41651 .48933 L .4082 .4814 L p
.448 1 0 r
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .246 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .019 0 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
1 0 .662 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
.524 0 1 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
0 .29 1 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
0 1 .896 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
0 1 .082 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
.732 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .776 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .549 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .53 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
1 0 .208 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
.978 0 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
.164 0 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 .65 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 1 .536 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
.278 1 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
1 0 .341 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
1 0 .36 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
1 0 .379 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.845 0 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.826 0 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.808 0 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.032 0 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.013 0 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 .006 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 .782 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 .801 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 .82 1 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 1 .404 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 1 .385 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
0 1 .366 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.41 1 0 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.429 1 0 r
F P
s
P
p
.002 w
.4082 .4814 m .42231 .47708 L .43057 .48505 L p
.448 1 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .227 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .038 0 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
1 0 .662 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
.524 0 1 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
0 .29 1 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
0 1 .896 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
0 1 .082 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
.732 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .776 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .549 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .53 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
1 .946 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .227 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .038 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .757 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .568 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
1 .946 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .208 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .057 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
1 0 .17 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
1 0 .189 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
1 0 .984 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.997 0 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.202 0 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.183 0 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 .612 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 .631 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 1 .574 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 1 .555 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.24 1 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
.259 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .757 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .568 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .681 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .7 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .719 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .738 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .757 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .776 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
1 0 .795 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.505 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.486 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.467 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.448 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.429 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.41 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.391 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .309 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .328 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .347 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .366 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .385 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .404 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 .423 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .877 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .858 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .839 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .82 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .801 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .782 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .763 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .063 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .044 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .025 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .006 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.013 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.032 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.05 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.751 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.77 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.789 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.808 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.826 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.845 1 0 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.864 1 0 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .208 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .057 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
1 0 .17 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
1 0 .189 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
1 0 .984 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.997 0 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.202 0 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.183 0 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 .612 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 .631 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 1 .574 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 1 .555 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.24 1 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
.259 1 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .738 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .587 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .681 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .7 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .719 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .738 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .757 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .776 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
1 0 .795 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.505 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.486 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.467 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.448 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.429 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.41 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.391 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .309 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .328 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .347 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .366 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .385 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .404 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 .423 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .877 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .858 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .839 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .82 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .801 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .782 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .763 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .063 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .044 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .025 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .006 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.013 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.032 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.05 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.751 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.77 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.789 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.808 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.826 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.845 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.864 1 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .189 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .076 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 0 .151 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 0 .965 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
.221 0 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .593 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .593 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
.221 1 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 .984 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 .965 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .738 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .587 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .189 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .076 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 0 .151 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 0 .965 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
.221 0 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .593 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .593 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
.221 1 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 .984 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 .965 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .719 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .606 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .17 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .151 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .132 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .114 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .095 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
1 0 .132 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
1 0 .946 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
.24 0 1 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 .574 1 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .612 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
.202 1 0 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
.997 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .719 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .606 0 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
1 0 .814 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.372 0 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 .442 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .744 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.069 1 0 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.883 1 0 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .17 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .151 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .132 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .114 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .095 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
1 0 .132 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
1 0 .946 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
.24 0 1 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 .574 1 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .612 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
.202 1 0 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
.997 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .7 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .625 0 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
1 0 .814 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.372 0 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 .442 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .744 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.069 1 0 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.883 1 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
1 0 .114 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
1 0 .927 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
.259 0 1 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 .555 1 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 1 .631 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
.183 1 0 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
.978 1 0 r
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .7 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .625 0 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
1 0 .114 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
1 0 .927 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
.259 0 1 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 .555 1 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 1 .631 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
.183 1 0 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
.978 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .681 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .662 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .644 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .019 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .038 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .057 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .076 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .095 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .833 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .852 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .871 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .89 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
1 0 .909 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.353 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.334 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.315 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.297 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.278 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 .461 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 .479 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 .498 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 .517 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 .536 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .726 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .707 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .688 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .669 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .65 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.088 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.107 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.126 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.145 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.164 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.902 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.921 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.94 1 0 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.959 1 0 r
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .681 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .662 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .644 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .019 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .038 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .057 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .076 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .095 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .833 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .852 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .871 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .89 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
1 0 .909 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.353 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.334 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.315 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.297 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.278 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 .461 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 .479 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 .498 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 .517 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 .536 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .726 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .707 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .688 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .669 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .65 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.088 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.107 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.126 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.145 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.164 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.902 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.921 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.94 1 0 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.959 1 0 r
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o;k/3o`b100?o^k/01;/01?l00?l50003o`0002X0
000O0003o`0000T000Sobk_;^l^ko`b102Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^kbk_o00b100?oPH400ol05[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/3o`UK00gobk_;^l^kbk_;^l^k00;o2h400on1P@0:P@0_ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10ol^^`?o1e/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0]^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co2e/00on1P@06P@?o00V1ok_;^l^kbol0
0P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omKF`04F`?o
0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42obbk1?l2F`03oe]K00YK
00?oPH400h43o`F100?o^k/01;/01?l00?l300;o:P0002@000?o00002@001onkbk_;^ol01X43o`B1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`MK00ko^l^kbk_;^l^k
bk_;^`;o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03K_;^l^kbk_;^l^kbol025/3o`0?^l^kbk_;
^l^kbk_;^l_o00J11?l2P@0[ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`MK00?oFe/02U/00on1o`02o`V100So^l^kbk_;o`8000?o00000P000ol0000500?o0`03oaT0
000U0003o`0000T000?o^k/00k/00on1P@03o`R100?o^k/09;/2o`]K00?o^k/07k/3o`:100?o^k/0
2k/00omKF`03F`;o4[/00on1P@03o`N100?o^k/08k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk
00Co003o1@000ol000050003o`0000D000?o00005P0002H000?o00002@001_nkbk_;^`;o3840:?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol6P@0@ol^kbk_;^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0_l;P@0Rok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0U/00omKF`0:F`03oe]K00AK
1?l2F`03oh6100^100Sobk_;^l^ko`8000?o00000P000ol000050003o`0000D000?o00005P0002L0
00?o00002@000onk^`04^`03oh6100Z100?o^k/09;/00omKF`0:F`03ok^k01Jk1?l:P@03ok^k00^k
00?o^k/05k/00on1P@0:P@03ok^k01^k0ol6F`03oe]K00YK00?oFe/00ol7F`03oh6100^100?o^k/0
1;/01?l00?l40003o`0000@000?o00000P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o35/05Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`:100?oPH402X40:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b1
01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o2U/00omKF`08F`04oe_oo`]K00?oPH401X43o`09
POnkbk_;^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1
P@0:P@03ok^k02Bk00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k01>k
0ol00e_oF`0;F`03oe]K00AK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003
o`3o00@00_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o2X400on1
P@08P@0[oh7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`06P@?o0X404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol5F`03oe]K00YK00?oFe/00ol01k_;^l^kbol03E/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000S0000;0000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k02Bk0_lI^`03oh6100V100?oPH401843o`>100?o^k/09K/00on1P@03o`J100?o^k/03;/3o`UK
00?oFe/025/01?mKool:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D000?o00008P0002d0
00?o00002@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N102Kobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X402oo;^l^kbk_;^l^k00?o35/00omKF`04F`Co013;^l^k
bk_;^l^kbk_;^l_o1U/4o`9K00?oPH402X402?o;^l^kbk_o0P000ol000030003o`000240000^0003
o`0000T000?o^k/01;/00on1P@09P@03ok^k03nk00?oPH402H42o`^100?o^k/07[/4o`9K00?oPH40
2X400onk^`04^`?o0U/00omKF`0;F`03oe]K00?o5;/00omKF`03o`MK00?oPH402X400onk^`04^`04
o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH40
2X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@03ol^k00?o1U/00omK
F`0;F`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l;F`03oh6100F10ol02X7o^l^kbk_;^ol20003
o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42od2k00?oPH400ol6P@03oh6100Z1
00?o^k/05k/2o`]K00?oPH4028401?n1ool:F`03oe]K00IK0olE^`Co0U/00omKF`0:F`03oh6100>1
0_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@11ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol035/00on1P@04P@?o0X400omK
F`0:F`03oe]K00=K0_l05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`MK00?oFe/02U/00on1o`02o`R1
00So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH400ol7P@03
ok^k03fk00?oPH402X400on1P@04P@?o7K/00omKF`0:F`03oh6100?o1X400omKF`0:F`03oe_o00;o
4k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol000090006
ok_;^l^k0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038400on1P@03o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`aK0_l:P@03oe]K00QK01KoFoo;^l^kbk_;^l^kbk_;^l^kbk_;0ol2F`03oe]K00YK00?oFe/0
15/4o`03bk_o00f100Oo^l^kbk_o008000?o00000`000ol0000M0000=@000ol000090003ok^k00>k
00?oPH402X400onk^`0m^`03oh6100R100CoPOoo9K/00omKF`04F`?o0[/00on1P@0:P@03oe]K00AK
0ol3F`03ok^k00fk0ol6F`03oe]K00YK00?oFe/00ol7^`03oh6100^100?o^k/00k/01?l00?l40003
o`0001d0000f0003o`0000T000Oo^l^kbk_o00b1037obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co00c;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100?oFe/00ol7F`0=ol^kbk_;
^l^kbk_;^`02o`YK00?oFe/025/04?mKoonkbk_;^l^kbk_;^ol6P@Co0X402?o;^l^kbk_o0P001?l0
0002oah0000g0003o`0000T000?o^k/00k/00on1P@0:P@;o:k/3o`AK00?o^k/02K/00on1P@03o`N1
00?o^k/09;/2o`Zk00?oPH4028401?n1ool;F`03ok^k00Vk00?oFe/02U/00omKF`04F`?o4;/00on1
P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0d
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01;_;
^ol<F`0=ol^kbk_;^l^kbk_;o`0<F`03oe]K00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;
^l^kbol00P000ol000020003o`0001/0000j0003o`0000T000?o^k/00[/00on1P@03o`R100?o^k/0
8[/2o`aK00?o^k/02K/00on1P@0:P@03ok^k032k00?oPH400ol7^`03oe]K00YK00?o^k/02K/00omK
F`08F`04oe_ooaNk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o00002@001Oo;
^l^k00;o38409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0<F`0=ol^kbk_;
^l^kbk_;o`0<P@0cok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;o00bkbk_;^l^kbk_;^ol6F`?o0U/03_nkbk_;^l^kbk_;^l_o1U/3o`9K01_obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol038402_nkbk_;^l_o0?l50003o`0001T0000l0003o`0000T000?o^k/0
0k/00on1P@0:P@03ok^k02>k00?oFe/02U/00onk^`09^`03oh6100Z100?o^k/0?K/00omKF`03o`IK
00?o^k/02[/00omKF`03o`IK00?o^k/05k/00on1P@08P@03oh7o00Fk00Co003o10000ol0000I0000
?@000ol000090006ol^kbk_;0_l;P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o00IK0ol2F`0>ok_;^l^kbk_;^l^kbol6P@?o0h40@?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^kbk_;^l^kbk_;00;o
2U/06_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X44o`:100Sobk_;^l^ko`8000Co00000_lJ0000
?P000ol000090003ok^k00Bk00?oPH401843o`:100?o^k/08k/00omKF`03o`IK00?o^k/02[/00on1
P@03o`N100?o^k/0?;/00omKF`09F`03ok^k00Zk00?oFe/02E/00onk^`0G^`03oh6100?o1h400onk
^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;^l^kbk_o0X43o`J102Ko^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2U/03Onkbk_;^l^kbk_;^l/00_l;P@10ok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`]K
00kobk_;^l^kbk_;^l^ko`]K01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;^l^kbol0
0P000ol000030003o`0001H0001000;o2P000onk^`04^`;o2X400onk^`0S^`03oe]K00UK00?o^k/0
2[/00on1P@0:P@03ok^k03bk00?oFe/01e/00omKo`0<^`03oe]K00MK00?oFol06;/00on1P@0:P@03
ok^k00Bk00Co003o10000ol0000F0000@P000ol0000800;o00Jkbk_;^ol;P@0Wok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00]K00Wo^l^kbk_;^l/00_l00k_;o`0<P@0ook_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00IK
0ol04<^kbk_;^l^kbk_;^l^kbol6F`?o0e/06_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o38402?nk
bk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/00k/00on1P@09P@03ok^k02>k
00?oFe/02E/00onk^`02^`?o0]l01?nk^ol6P@?o0X400onk^`0l^`03oe]K00?o0k/2o`jk00?oFe/0
0ol7F`03ok^k01Jk00?oPH4028400on1o`05^`04o`00o`D000?o0000500004@000?o00002@001onk
bk_;^ol02h42o`0Ubk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06F`?o013;^l^k
booOg]oNgmko^l_o0X43o`J103oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l00l^kb`03o`0AWoo;^l^kbk_;^l^kbk_;^l/00_l;F`0I
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l00002oaH000150003
o`0000T000?o^k/00k/00on1P@04P@?o0h400onk^`0R^`03oe]K00?o0[/2o`Jk00?ogml00ml00onk
^`02o`Z100?o^k/0?k/01olAWa6O4Ol03k/00omKF`0:F`03ok^k01Fk00?oPH400ol7P@03ok^k00Bk
00Co003o10000ol0000C0000AP000ol000090007ok_;^l^ko`02P@?o1h409Oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l00l^kb`02o`;O00Oobk_;^l^k00?o00Nkbk_;^l_o00^1
03_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`02o`0Lbk_;^l_oWa6O4Ioobk_;^l^kbk_;^l^kbk_;o`aK01Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1?l;P@0:ol^kbk_;^ol0o`<00olD0000A`000ol000090003ok^k00>k0_l;P@03ok^k02Fk00?ogml0
0ml00onk^`0=^`03oh6100V100?o^k/0=;/3o`03Wonk00Fk0olC^`03oe]K00AK0olE^`?o0X400on1
P@0;P@03ok^k00>k00?o00000ol20003o`000180001800;o2P002?nkbk_;^l_o2h408Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`06bk_;^l_o1Ml02_o;^l^kbk_;^l/4o`03^l_o00^1
0_l0=;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol54@0N
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`0E^l_ook_;^l^kbk_;^l^kbk_;^l^k00?o
1X400on1P@0;P@06ol^kbk_;0_l00`3o00020003o`000180001:0003o`0000P00_l5^`03oh6100V1
00?o^k/06[/3o`;O00?o^k/00k/3o`Zk0_l01MkOg]oo00:k00?oPH401843o`>100?o^k/0:[/2o`Fk
00?oWil00il00onk^`0J^`;o0[/3o`03Gonk00bk1?l:P@03oh6100B11?l9^`03o`3o00<000?o0000
4P0004/000?o00002@001oo;^l^kbol01X43o`:101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1]l07Oo;^l^kbk_;^l^kbk_;^l^kbooOg]oNgmko^l_o00:10ol7P@0Yok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol0216Ook_;^l^k0ol08k_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00DO00[obk_;^l^kbk_;0ol2P@03oh6100Z100?oPH400ol02;_;^l^kbk_;
0ol50004o`00oa@0001<0003o`0000T000?o^k/00k/00on1P@03o`J100?o^k/04K/3o`Fk00?ogml0
0ml00onk^`0?^`03omko00;o1K/2o`^100?o^k/09;/00olA4@044@03ok^k026k0_l5^`07oelOGamO
o`05^`?o1X400on1P@0:P@;o1k/4o`T000Co003o4`0004d000?o00002@001_o;^l^kb`;o2X404?o;
^l^kbk_;^l^kbk_;^l/3o`09gioo^l^kbk_;00?o023;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^k
bk_;o`b1023o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o02c;^l^kbk_oWa6O4Ioo^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o00QOok_;^l^kb`?o00C;^l^k1?l:P@03oh6100B1
0ol02<^kbk_;^l^k0ol>0003o`3o01<0001>0003o`0000T000?o^k/00k/00on1P@09P@03ok^k00fk
00?ogml00]l00onk^`0Q^`?o0[/00on1P@0:P@03ok^k01Zk0_l24@03ok^k00Bk0olQ^`07oelOGamO
o`07^`Go0X400on1P@0:P@03oh6100?o1k/4oa4000?o0?l04`0004l00_l:0007ol^kbk_;o`0;P@07
ol^kbk_;^`03o`0[^l^kbk_;omnOoioo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`;O
00Gobk_;o`06P@?o0X40A_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o4ALA5a7obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0=^l^kbk_oGamO7eoo^`05o`R100?oPH402X42o`07
bk_;^l^kb`03oaH00_lC0000D@000ol000080003ok^k00>k00?oPH402H42o`:k0_l019GMUOl6^`;o
8k/00ooNgP02gP05ok^k^ol00X43o`J100?o^k/04K/3o`Fk00?o4A400a400onk^`0M^`?o00<Ook/0
1K/3o`04^oooo`:100?oPH402H400on1P@04P@?o1k/4oaP00olC0000DP000ol0000800;o00Fkbk_;
o`06P@?o0h405?nkbonELIEaok_;^l^kbk_;^l^k0_l07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol00]l01_oOol^kb`;o2X404?o;^l^kbk_;^l^kbk_;^l/3o`8A00Oo^l^kbk_;00?o02;;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1Al01oo;^l^kbk/00ol6P@03oh6100V100?oPH40
0ol01k_;^l^kbk/00olI00?o5P0005<000?o00002@000onk^`02^`03oh6100?o1h402Onk^ooMUOnE
o`08^`;o00>Ogol07[/2o`Jk00?oPH402X400onk^`0<^`07oaLA5a4Go`0R^`?o1K/02?lOGamO7onk
1?l:P@03oh6100N100CoPOoo1[/4oaP01?lI0000E0000ol000090005ok_;^l/00_l;P@03ok_;00;o
00^kbk_;^l^kbk_;o`05g`0Tol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l00k_o
P@0;P@07ol^kbk_;^`04o`05bk_;^ol00a408OlAok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`097elOol^kbk_;00?o00C;oooo0X400on1P@09P@03oh6100B10ol01l^kbk_;^l/00olI00?o
7@0005D000?o00002@000onk^`03^`03oh6100V100?o^k/01K/2o`Fk00OogioOWmoo00Vk1?lB^`?o
00GNgonko`0:P@03oh7o00:k0ol01A4G4AOo00Bk0olR^`03oalO00<O00?o^k/00k/3o`J100?oPH40
2H400on1P@03o`Jk1?lH00Co800005H000?o00002@001onkbk_;^ol02h42o`03bk_;00;o00SMUOo;
^l^kb`?o00W;^l^kbk_;^l/00ol4L@0Kok_;^l^kbk_;^l^kbk_;^l_og]oNgmkOok_o00J10ol0;l^k
bk_;^olG4ALA5a7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o00_;^l^kbolOGaoo
7`05o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o
0h402OnkomeagG7Mo`0A^`08og7NLMiag_lA^`09omoNgmkOok_o00:10ol2^`?o1K/00olAo`02ob2k
0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T000?o000020001onk
bk_;^ol00X43o`N101;obonEgIGMUOo;^l^kbk_;^l/4o`06^l^kboma0ol05<^kbk_;^l^kbk_;^l^k
bk_;^l^k0ol01K_;^l^k00;o00?;^ol00_l3W`0[ok_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`067`05ol^kbk/00ol6P@03oh6100V100?oPH400ol01[_;^l^kb`?o6004ob/0
001J0003o`0000P000?o^k/00k/2o`^100?o^ol00_l9^`?o00GOWmnOo`04^`03ok^k026k00?ogml0
1=l00onk^`07^`?o5K/3o`Fk00?o7ol00_l3^`?o2X400on1P@07P@04oh7oo`Fk1?lH00?o;`0005/0
00?o00002002o`06bk_;^l_o2h402?o;^l^kbk_;0_l0;;_;^l_ogioOWmnOok_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;1?l01[_;^l_oW`?o00?;^l/00ol00l^ko`02o`0E5a7obk_;^l^kbk_;
^l^kbk_;^l^k00?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06bk_;^l^k0olH00Co
<P0005`000?o00002@000onk^`03^`03oh6100V100Co^k^k0ol00mko^`04^`03omoo00;o8;/2o`05
Wa6O4Ol01;/01?nk^k/3o`>100Co^k_o11L00onk^`09^`;o1;/00olS8`048`03ok^k00>k0ol6P@03
oh6100V10ol7^`Co6003ocH0001M0003o`0000T000Oobk_;^l_o00J10ol2P@0/ol_oLMiagW7obk_;
^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0@^l^kbk_o4MlAga7o^l^kb`?o1h404Oo;
^olG4OlAol^kbk_;^l^k00;o0Ul01onkbk_;ob<00ol00l^kb`04o`Z100?oPH401843o`08^l^kbk_;
^l/3oaP01?li0000GP000ol000090003ok^k00>k00?oPH400ol6P@09ok^kog7NLMko00Vk1?lB^`?o
00>Ook/01K/3o`Fk0_l;P@03ok^k00;o2[/01olOGamO7ol01;/01?nk^k/3o`:100?oPH402X400on1
P@03o`Nk1?lH00?o?@0005l00_l:0006ol^kbk_;0_l:P@03ol^k00;o00[;^l^kbk_;^l^k0_l0:mlA
ga7o^l^kbk_;^l^kbk_;^l^kbooOWmnOgoo;^l^kbk_;^l^kbk_;^ol038402?o;^l^kbk_;0_l01[_;
^l^ko`EO00Go^l^kb`03o`J100?oPH402X42o`07^l^kbk_;^`03oaP01?m00000H@000ol000080003
ok^k00>k00?oPH402H400onk^`05^`;o1;/02?oOWmnOgioo2K/3o`Fk00?oWil00Yl00onk^`0<^`03
oh6100Z100Co^k^k0ol00aOo^`05^`?o0k/4o`Z100?oPH401843o`Nk1?lH00?oA000068000?o0000
20001oo;^l^kbol02h42o`03^l^k00;o00Uag_nkbk_;oml00ol02<^kbk_;^l^k0ol2g`07ol^kbk_;
^`02o`0Cbk_;^l^kbk_;^l^kbk_;^l^ko`06P@?o0X404?nkbolG4ALA5oo;^l^kbk/5o`>100?oPH40
2H400on1P@03o`07bk_;^l^kb`03oaP01?m70000H`000ol0000800;o1;/00on1P@04P@?o0h400onk
o`05gP03ok^k00:k00?o^k/02[/00onOW`02W`03ok^k01Rk00?oPH400ol6P@05ok^k^ol011L00onk
o`03o`V100?oPH402H42o`Jk1?lG00CoB`0006@000?o00002@001_nkbk_;o`:10ol7P@0Bok_ogW7N
LMko^l^kbk_;^l^k0ol01[_;^l^ko`;O01gogoo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z1
00Co^l^k0_l01<_oool2P@03oh6100V100?oPH401843o`06bk_;^l^k0olH00?oC`0006D000?o0000
2@000onk^`02^`;o2h400onko`02o`Vk0ol01=nOgol5^`;o7[/00on1P@09P@03ok^k00?o1X400on1
P@09P@03oh6100?o1K/4oaL01?mB0000IP000ol000090007ok_;^l^ko`0;P@08ok_;^l^kbk/2o`0a
bk_;^onOgioOWonkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0;P@;o2X400on1
P@07P@08oh7ool^kbk/4oaP00omF0000I`02o`X000?o^k/00k/00on1P@09P@04ok^k^`?o00=aok/0
1;/01?oOoolX^`03oh6100B10ol2P@03oh6100V100CoPH611Ol5^`?o6004oeT0001Y0003o`0000P0
00Oo^l^kbk_o00J10ol2P@0kok_oLMiagW7o^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol00X43o`J100?oPH402H43o`06^l^kbk_;1?lH00?oG@0006X000?o0000
20000onk^`03^`03oh6100?o1X402Onk^ooNLMiao`0_^`Co2X400on1P@04P@?o1k/3oaP01?mP0000
J`000ol0000800;o00C;^l^k0_l:P@03ok_;00;o02fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/01Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003
o`0000T000?o^k/00[/00on1P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003
o`0000T000Kobk_;^ol;P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0ol2P@03oh6100V100?oPH401Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B1
0ol2P@03ok^k02>k0ol6P@03oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o
1X408Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;
^`04oaL01?mb0000L@000ol000080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH40
0ol7^`?o6003ogH0001b0003o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`V100?oPH402H42o`06^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk
^`0@^`?o0X400on1P@08P@03oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go
0h403onkbk_;^l^kbk_;^l^kb`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D0
00?o00002@000onk^`02^`;o2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H0
0_l:0007ok_;^l^ko`09P@07ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00Co
Q`0007P000?o000020000onk^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0
001i0003o`0000P000Oo^l^kbk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000
NP000ol000080003ok^k00>k00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003
o`0000P000Ko^l^kbk/2o`V100?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk
00?oPH4028400on1P@05o`Jk0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/0
1?lG00?oW@0007h00_l:0003ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;
^l^koh400ol01[_;^l^kb`Co5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL0
00220003o`0000P000Oobk_;^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@0
00?o00001`03oaL00onb0000Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT0
00280003o`0000<000?o00003004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000
R`000ol0o`0400Coa`0008`00_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0002B0003o`0002L000?o0000
WP0006d01?l300Co00@0ool00_l200;o0`03o`@000?o00000`000ol0000800Go00@0ool00_l200Go
00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<00ol400;o1002ofl0001/0005o`000?l0
0P000ol000030004o`00o`<00_l40003o`0000<000?o000010000ol000090005o`000?l00P001?l0
0?l30003o`0000;o10000ol000040003o`0000L000?o00001@000ol000020004o`00o`800_l40003
o`00008000Co003o0`02ofl0001/0003o`3o00;o0P05o`050?l00?l02@000ol000040003o`0000l0
00Go0000o`020004o`00o`<000?o00001P000ol0000>0003o`0000D000?o00000P000ol000090003
o`00008000Co003oM00006`000?o000010001ol0003o0?l00P000ol000070003o`0000@000?o0000
3`001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003o`00008000?o00002@000ol0
000300;oM@0006`000Go0000o`0300?o00<0ool00ol90003o`0000D000?o00003P000ol00005o`<0
1?l80003o`0000h000?o00001002o`<01?l90003o`00008000Co003oM00006d01?lD00;o1004o`h0
1Ol;0003o`0000D00_l?00Go2@000ol0000800;o1@02ogD0002/00;o8@000ol000020003o`0008H0
003o05h00000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 17"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 16",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 18",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 18", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.150262 1.331236 0.024119 0.964767 [
[(Gen.18, Ind.1, Fit.21.)] .5 1 0 -1.5 Msboxa
[(5)] .22044 .13424 .8579 1 Msboxa
[(10)] .37435 .08956 .79044 1 Msboxa
[(15)] .53473 .04302 .72297 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30681 .04696 .79718 1 Msboxa
P
[(5)] .72442 .08911 -1 .38389 Msboxa
[(10)] .80075 .17024 -1 .36637 Msboxa
[(15)] .87169 .24565 -1 .35038 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87145 .14157 -1 .36805 Msboxa
P
[(0)] .09587 .19406 1 -0.397 Msboxa
[(10)] .06944 .39141 1 -0.36129 Msboxa
[(20)] .03936 .61617 1 -0.3203 Msboxa
[(t)] -0.01756 .47453 1 -0.34979 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.18, Ind.1, Fit.21.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11292 .17763 m
.64361 .02412 L
s
P
p
.002 w
.23128 .1434 m
.23669 .14797 L
s
P
[(5)] .22044 .13424 .8579 1 Mshowa
p
.002 w
.38467 .09902 m
.38983 .10375 L
s
P
[(10)] .37435 .08956 .79044 1 Mshowa
p
.002 w
.54448 .0528 m
.54935 .05768 L
s
P
[(15)] .53473 .04302 .72297 1 Mshowa
p
.001 w
.26146 .13466 m
.26468 .13743 L
s
P
p
.001 w
.29189 .12586 m
.29508 .12864 L
s
P
p
.001 w
.32257 .11699 m
.32572 .11979 L
s
P
p
.001 w
.35349 .10804 m
.35662 .11086 L
s
P
p
.001 w
.41611 .08993 m
.41917 .09279 L
s
P
p
.001 w
.4478 .08076 m
.45083 .08364 L
s
P
p
.001 w
.47976 .07152 m
.48275 .07441 L
s
P
p
.001 w
.51198 .06219 m
.51494 .06511 L
s
P
p
.001 w
.20133 .15206 m
.20461 .15479 L
s
P
p
.001 w
.17163 .16065 m
.17494 .16336 L
s
P
p
.001 w
.14216 .16918 m
.14549 .17187 L
s
P
p
.001 w
.57724 .04332 m
.58013 .04627 L
s
P
p
.001 w
.61028 .03376 m
.61314 .03673 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30681 .04696 .79718 1 Mshowa
P
P
p
p
.002 w
.64361 .02412 m
.89616 .2923 L
s
P
p
.002 w
.70888 .09344 m
.70112 .0956 L
s
P
[(5)] .72442 .08911 -1 .38389 Mshowa
p
.002 w
.78512 .17439 m
.77731 .17646 L
s
P
[(10)] .80075 .17024 -1 .36637 Mshowa
p
.002 w
.85599 .24964 m
.84813 .25163 L
s
P
[(15)] .87169 .24565 -1 .35038 Mshowa
p
.001 w
.72459 .11011 m
.71992 .1114 L
s
P
p
.001 w
.74006 .12654 m
.73539 .12782 L
s
P
p
.001 w
.7553 .14273 m
.75063 .14399 L
s
P
p
.001 w
.77032 .15867 m
.76564 .15993 L
s
P
p
.001 w
.7997 .18987 m
.79501 .19111 L
s
P
p
.001 w
.81408 .20514 m
.80938 .20636 L
s
P
p
.001 w
.82825 .22018 m
.82355 .2214 L
s
P
p
.001 w
.84222 .23501 m
.83751 .23622 L
s
P
p
.001 w
.69294 .0765 m
.68828 .07781 L
s
P
p
.001 w
.67675 .05931 m
.6721 .06063 L
s
P
p
.001 w
.66031 .04185 m
.65566 .04318 L
s
P
p
.001 w
.86956 .26406 m
.86485 .26524 L
s
P
p
.001 w
.88295 .27827 m
.87823 .27945 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87145 .14157 -1 .36805 Mshowa
P
P
p
p
.002 w
.11292 .17763 m
.03328 .77768 L
s
P
p
.002 w
.11133 .18961 m
.11907 .18738 L
s
P
[(0)] .09587 .19406 1 -0.397 Mshowa
p
.002 w
.08509 .38731 m
.09292 .38527 L
s
P
[(10)] .06944 .39141 1 -0.36129 Mshowa
p
.002 w
.05521 .61249 m
.06313 .61065 L
s
P
[(20)] .03936 .61617 1 -0.3203 Mshowa
p
.001 w
.10634 .22719 m
.11099 .22588 L
s
P
p
.001 w
.10123 .26572 m
.10589 .26443 L
s
P
p
.001 w
.09599 .30523 m
.10066 .30395 L
s
P
p
.001 w
.09061 .34574 m
.09529 .34449 L
s
P
p
.001 w
.07943 .42998 m
.08414 .42877 L
s
P
p
.001 w
.07362 .47378 m
.07833 .4726 L
s
P
p
.001 w
.06764 .51877 m
.07237 .51761 L
s
P
p
.001 w
.06151 .56499 m
.06625 .56386 L
s
P
p
.001 w
.04872 .66133 m
.05349 .66026 L
s
P
p
.001 w
.04206 .71157 m
.04683 .71052 L
s
P
p
.001 w
.03519 .76326 m
.03999 .76225 L
s
P
[(t)] -0.01756 .47453 1 -0.34979 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11133 .18961 m
.40853 .42434 L
s
P
p
.4 g
.002 w
.08509 .38731 m
.4024 .61238 L
s
P
p
.4 g
.002 w
.05521 .61249 m
.39553 .8233 L
s
P
p
.4 g
.002 w
.18898 .23808 m
.12657 .82943 L
s
P
p
.4 g
.002 w
.27819 .30898 m
.23468 .8894 L
s
P
p
.4 g
.002 w
.36151 .3752 m
.33438 .94471 L
s
P
.002 w
.11292 .17763 m
.03328 .77768 L
s
.03328 .77768 m
.39056 .97588 L
s
.39056 .97588 m
.40891 .41287 L
s
.40891 .41287 m
.11292 .17763 L
s
.64361 .02412 m
.89616 .2923 L
s
.89616 .2923 m
.96672 .87536 L
s
.96672 .87536 m
.67121 .64359 L
s
.67121 .64359 m
.64361 .02412 L
s
.11292 .17763 m
.03328 .77768 L
s
.03328 .77768 m
.67121 .64359 L
s
.67121 .64359 m
.64361 .02412 L
s
.64361 .02412 m
.11292 .17763 L
s
p
.4 g
.51824 .38581 m
.51875 .95352 L
s
P
p
.4 g
.65938 .35089 m
.68515 .92448 L
s
P
p
.4 g
.80573 .31467 m
.85882 .89418 L
s
P
p
.4 g
.40853 .42434 m
.89758 .30405 L
s
P
p
.4 g
.4024 .61238 m
.92099 .49745 L
s
P
p
.4 g
.39553 .8233 m
.94744 .71607 L
s
P
.40891 .41287 m
.89616 .2923 L
s
.89616 .2923 m
.96672 .87536 L
s
.96672 .87536 m
.39056 .97588 L
s
.39056 .97588 m
.40891 .41287 L
s
p
.4 g
.23128 .1434 m
.51824 .38581 L
s
P
p
.4 g
.38467 .09902 m
.65938 .35089 L
s
P
p
.4 g
.54448 .0528 m
.80573 .31467 L
s
P
p
.4 g
.18898 .23808 m
.70888 .09344 L
s
P
p
.4 g
.27819 .30898 m
.78512 .17439 L
s
P
p
.4 g
.36151 .3752 m
.85599 .24964 L
s
P
P
p
.002 w
.41431 .41483 m .42208 .42101 L .40853 .42434 L p
.4 g
F P
s
P
p
.002 w
.40853 .42434 m .40073 .41818 L .41431 .41483 L p
.4 g
F P
s
P
p
.002 w
.89758 .30405 m .40853 .42434 L .11133 .18961 L p
.9 g
F P
s
P
p
.002 w
.43567 .41767 m .42208 .42101 L p
.41431 .41483 L .4 g
F P
s
P
p
.002 w
.41431 .41483 m .40073 .41818 L .39288 .41198 L p
.4 g
F P
s
P
p
.002 w
.44161 .40808 m .44931 .41431 L .43567 .41767 L p
.4 g
F P
s
P
p
.002 w
.41431 .41483 m .44161 .40808 L p
.43567 .41767 L .4 g
F P
s
P
p
.002 w
.39288 .41198 m .38498 .40574 L p
.41431 .41483 L .4 g
F P
s
P
p
.002 w
.38498 .40574 m .39862 .40234 L .41431 .41483 L p
.4 g
F P
s
P
p
.002 w
.463 .41094 m .44931 .41431 L p
.44161 .40808 L .4 g
F P
s
P
p
.002 w
.4691 .40129 m .47674 .40756 L .463 .41094 L p
.4 g
F P
s
P
p
.002 w
.44161 .40808 m .4691 .40129 L p
.463 .41094 L .4 g
F P
s
P
p
.002 w
.49053 .40417 m .47674 .40756 L p
.4691 .40129 L .4 g
F P
s
P
p
.002 w
.39862 .40234 m .38498 .40574 L .37703 .39946 L p
.4 g
F P
s
P
p
.002 w
.49679 .39445 m .50437 .40077 L .49053 .40417 L p
.4 g
F P
s
P
p
.002 w
.4691 .40129 m .49679 .39445 L p
.49053 .40417 L .4 g
F P
s
P
p
.002 w
.37703 .39946 m .36902 .39313 L p
.39862 .40234 L .4 g
F P
s
P
p
.002 w
.36902 .39313 m .38272 .38969 L .39862 .40234 L p
.4 g
F P
s
P
p
.002 w
.51825 .39735 m .50437 .40077 L p
.49679 .39445 L .4 g
F P
s
P
p
.002 w
.52467 .38756 m .53219 .39393 L .51825 .39735 L p
.4 g
F P
s
P
p
.002 w
.49679 .39445 m .52467 .38756 L p
.51825 .39735 L .4 g
F P
s
P
p
.002 w
.54618 .39049 m .53219 .39393 L p
.52467 .38756 L .4 g
F P
s
P
p
.002 w
.38272 .38969 m .36902 .39313 L .36096 .38677 L p
.4 g
F P
s
P
p
.002 w
.55276 .38063 m .56021 .38703 L .54618 .39049 L p
.4 g
F P
s
P
p
.002 w
.52467 .38756 m .55276 .38063 L p
.54618 .39049 L .4 g
F P
s
P
p
.002 w
.36096 .38677 m .35285 .38036 L p
.38272 .38969 L .4 g
F P
s
P
p
.002 w
.35285 .38036 m .36661 .37687 L .38272 .38969 L p
.4 g
F P
s
P
p
.002 w
.5743 .38357 m .56021 .38703 L p
.55276 .38063 L .4 g
F P
s
P
p
.002 w
.58106 .37364 m .58844 .38009 L .5743 .38357 L p
.4 g
F P
s
P
p
.002 w
.55276 .38063 m .58106 .37364 L p
.5743 .38357 L .4 g
F P
s
P
p
.002 w
.43801 .37579 m .41026 .38277 L .39428 .36985 L p
.8 g
F P
s
P
p
.002 w
.58106 .37364 m .55276 .38063 L .53771 .36768 L p
.4 g
F P
s
P
p
.002 w
.36661 .37687 m .35285 .38036 L .34468 .37391 L p
.4 g
F P
s
P
p
.002 w
.60263 .3766 m .58844 .38009 L p
.58106 .37364 L .4 g
F P
s
P
p
.002 w
.34468 .37391 m .33645 .36741 L p
.36661 .37687 L .4 g
F P
s
P
p
.002 w
.33645 .36741 m .35028 .36388 L .36661 .37687 L p
.4 g
F P
s
P
p
.002 w
.60955 .3666 m .61687 .3731 L .60263 .3766 L p
.4 g
F P
s
P
p
.002 w
.58106 .37364 m .60955 .3666 L p
.60263 .3766 L .4 g
F P
s
P
p
.002 w
.46596 .36877 m .43801 .37579 L .42215 .36279 L p
.8 g
F P
s
P
p
.002 w
.39428 .36985 m .42215 .36279 L .43801 .37579 L p
.8 g
F P
s
P
p
.002 w
.53771 .36768 m .56614 .3606 L .58106 .37364 L p
.4 g
F P
s
P
p
.002 w
.63116 .36958 m .61687 .3731 L p
.60955 .3666 L .4 g
F P
s
P
p
.002 w
.42215 .36279 m .39428 .36985 L .37808 .35677 L p
.8 g
F P
s
P
p
.002 w
.63826 .35951 m .6455 .36605 L .63116 .36958 L p
.4 g
F P
s
P
p
.002 w
.60955 .3666 m .63826 .35951 L p
.63116 .36958 L .4 g
F P
s
P
p
.002 w
.42215 .36279 m .45023 .35567 L .46596 .36877 L p
.8 g
F P
s
P
p
.002 w
.56614 .3606 m .53771 .36768 L .52246 .35457 L p
.4 g
F P
s
P
p
.002 w
.35028 .36388 m .33645 .36741 L .32818 .36087 L p
.4 g
F P
s
P
p
.002 w
.6599 .36251 m .6455 .36605 L p
.63826 .35951 L .4 g
F P
s
P
p
.002 w
.32818 .36087 m .31984 .35429 L p
.35028 .36388 L .4 g
F P
s
P
p
.002 w
.31984 .35429 m .33373 .35071 L .35028 .36388 L p
.4 g
F P
s
P
p
.002 w
.37808 .35677 m .40608 .3496 L .42215 .36279 L p
.8 g
F P
s
P
p
.002 w
.66718 .35236 m .67435 .35896 L .6599 .36251 L p
.4 g
F P
s
P
p
.002 w
.63826 .35951 m .66718 .35236 L p
.6599 .36251 L .4 g
F P
s
P
p
.002 w
.52246 .35457 m .49411 .36169 L .47851 .3485 L p
.8 g
F P
s
P
p
.002 w
.52246 .35457 m .55103 .34739 L .56614 .3606 L p
.4 g
F P
s
P
p
.002 w
.68885 .35539 m .67435 .35896 L p
.66718 .35236 L .4 g
F P
s
P
p
.002 w
.6963 .34517 m .7034 .35181 L .68885 .35539 L p
.4 g
F P
s
P
p
.002 w
.66718 .35236 m .6963 .34517 L p
.68885 .35539 L .4 g
F P
s
P
p
.002 w
.55103 .34739 m .52246 .35457 L .50701 .34127 L p
.8 g
F P
s
P
p
.002 w
.47851 .3485 m .50701 .34127 L .52246 .35457 L p
.8 g
F P
s
P
p
.002 w
.33373 .35071 m .31984 .35429 L .31145 .34767 L p
.4 g
F P
s
P
p
.002 w
.6963 .34517 m .66718 .35236 L .65268 .33904 L p
.8 g
F P
s
P
p
.002 w
.71801 .34822 m .7034 .35181 L p
.6963 .34517 L .4 g
F P
s
P
p
.002 w
.31145 .34767 m .30301 .34099 L p
.33373 .35071 L .4 g
F P
s
P
p
.002 w
.30301 .34099 m .31696 .33736 L .33373 .35071 L p
.4 g
F P
s
P
p
.002 w
.72565 .33792 m .73267 .34461 L .71801 .34822 L p
.4 g
F P
s
P
p
.002 w
.6963 .34517 m .72565 .33792 L p
.71801 .34822 L .4 g
F P
s
P
p
.002 w
.5798 .34016 m .55103 .34739 L .53571 .334 L p
.8 g
F P
s
P
p
.002 w
.50701 .34127 m .53571 .334 L .55103 .34739 L p
.8 g
F P
s
P
p
.002 w
.72565 .33792 m .6963 .34517 L .68196 .33175 L p
.8 g
F P
s
P
p
.002 w
.65268 .33904 m .68196 .33175 L .6963 .34517 L p
.8 g
F P
s
P
p
1 .023 0 r
.01 w
.64543 .34933 m
.67453 .34211 L
s
P
p
.002 w
.74739 .34099 m .73267 .34461 L p
.72565 .33792 L .4 g
F P
s
P
p
.002 w
.53571 .334 m .50701 .34127 L .49134 .3278 L p
.4 g
F P
s
P
p
.002 w
.31696 .33736 m .30301 .34099 L .2945 .33428 L p
.4 g
F P
s
P
p
1 .046 0 r
.01 w
.67462 .34392 m
.67462 .34392 L
s
P
p
.002 w
.75521 .33062 m .76216 .33736 L .74739 .34099 L p
.4 g
F P
s
P
p
.002 w
.72565 .33792 m .75521 .33062 L p
.74739 .34099 L .4 g
F P
s
P
p
.002 w
.53571 .334 m .56462 .32666 L .5798 .34016 L p
.8 g
F P
s
P
p
1 .069 0 r
.01 w
.67471 .34573 m
.67471 .34573 L
s
P
p
1 .092 0 r
.01 w
.6748 .34755 m
.70416 .34028 L
s
P
p
.002 w
.75521 .33062 m .72565 .33792 L .71145 .3244 L p
.8 g
F P
s
P
p
.002 w
.68196 .33175 m .71145 .3244 L .72565 .33792 L p
.8 g
F P
s
P
p
.002 w
.77698 .33371 m .76216 .33736 L p
.75521 .33062 L .4 g
F P
s
P
p
.002 w
.2945 .33428 m .28594 .32751 L p
.31696 .33736 L .4 g
F P
s
P
p
.002 w
.28594 .32751 m .29995 .32383 L .31696 .33736 L p
.4 g
F P
s
P
p
.002 w
.49134 .3278 m .52018 .32042 L .53571 .334 L p
.4 g
F P
s
P
p
.002 w
.78499 .32326 m .79186 .33006 L .77698 .33371 L p
.4 g
F P
s
P
p
.002 w
.75521 .33062 m .78499 .32326 L p
.77698 .33371 L .4 g
F P
s
P
p
.002 w
.63799 .32553 m .60879 .33287 L .59375 .31928 L p
.8 g
F P
s
P
p
.002 w
.78499 .32326 m .75521 .33062 L .74116 .317 L p
.8 g
F P
s
P
p
.002 w
.71145 .3244 m .74116 .317 L .75521 .33062 L p
.8 g
F P
s
P
p
1 .115 0 r
.01 w
.70427 .3421 m
.73386 .33479 L
s
P
p
.002 w
.37328 .32269 m .34501 .33006 L .32814 .31642 L p
.8 g
F P
s
P
p
.002 w
.8068 .32638 m .79186 .33006 L p
.78499 .32326 L .4 g
F P
s
P
p
1 .46 0 r
.01 w
.64684 .38403 m
.67626 .37686 L
s
P
p
.002 w
.52018 .32042 m .49134 .3278 L .47545 .31413 L p
.4 g
F P
s
P
p
.002 w
.29995 .32383 m .28594 .32751 L .27732 .3207 L p
.4 g
F P
s
P
p
1 .483 0 r
.01 w
.64692 .38588 m
.64692 .38588 L
s
P
p
.002 w
.81499 .31585 m .82179 .32269 L .8068 .32638 L p
.4 g
F P
s
P
p
.002 w
.78499 .32326 m .81499 .31585 L p
.8068 .32638 L .4 g
F P
s
P
p
1 .506 0 r
.01 w
.64699 .38772 m
.64699 .38772 L
s
P
p
.002 w
.66741 .31814 m .63799 .32553 L .6231 .31184 L p
.8 g
F P
s
P
p
.002 w
.59375 .31928 m .6231 .31184 L .63799 .32553 L p
.8 g
F P
s
P
p
1 .529 0 r
.01 w
.64707 .38958 m
.67653 .38242 L
s
P
p
1 .391 0 r
.01 w
.67598 .37132 m
.70557 .36409 L
s
P
p
.002 w
.27732 .3207 m .26863 .31385 L p
.29995 .32383 L .4 g
F P
s
P
p
.002 w
.26863 .31385 m .28271 .31011 L .29995 .32383 L p
.4 g
F P
s
P
p
.002 w
.81499 .31585 m .78499 .32326 L .77109 .30954 L p
.8 g
F P
s
P
p
.002 w
.74116 .317 m .77109 .30954 L .78499 .32326 L p
.8 g
F P
s
P
p
1 .414 0 r
.01 w
.67607 .37317 m
.67607 .37317 L
s
P
p
.002 w
.83683 .31899 m .82179 .32269 L p
.81499 .31585 L .4 g
F P
s
P
p
.002 w
.40175 .31528 m .37328 .32269 L .35653 .30896 L p
.8 g
F P
s
P
p
.002 w
.32814 .31642 m .35653 .30896 L .37328 .32269 L p
.8 g
F P
s
P
p
1 .437 0 r
.01 w
.67617 .37501 m
.67617 .37501 L
s
P
p
1 .138 0 r
.01 w
.73399 .33661 m
.76382 .32925 L
s
P
p
.002 w
.47545 .31413 m .50443 .30665 L .52018 .32042 L p
.4 g
F P
s
P
p
.002 w
.84522 .30839 m .85194 .31528 L .83683 .31899 L p
.4 g
F P
s
P
p
.002 w
.81499 .31585 m .84522 .30839 L p
.83683 .31899 L .4 g
F P
s
P
p
.002 w
.69705 .31069 m .66741 .31814 L .65267 .30434 L p
.8 g
F P
s
P
p
.002 w
.6231 .31184 m .65267 .30434 L .66741 .31814 L p
.8 g
F P
s
P
p
1 .368 0 r
.01 w
.70546 .36225 m
.73524 .35497 L
s
P
p
1 .552 0 r
.01 w
.67663 .38427 m
.70633 .37706 L
s
P
p
.002 w
.77109 .30954 m .80125 .30202 L .81499 .31585 L p
.8 g
F P
s
P
p
.002 w
.86709 .31155 m .85194 .31528 L p
.84522 .30839 L .4 g
F P
s
P
p
.002 w
.35653 .30896 m .38514 .30144 L .40175 .31528 L p
.8 g
F P
s
P
p
.002 w
.50443 .30665 m .47545 .31413 L .45934 .30028 L p
.4 g
F P
s
P
p
.002 w
.28271 .31011 m .26863 .31385 L .25989 .30694 L p
.4 g
F P
s
P
p
1 .161 0 r
.01 w
.76396 .33107 m
.79404 .32365 L
s
P
p
1 .345 0 r
.01 w
.73512 .35312 m
.76511 .34578 L
s
P
p
.002 w
.87567 .30086 m .88231 .30781 L .86709 .31155 L p
.4 g
F P
s
P
p
.002 w
.84522 .30839 m .87567 .30086 L p
.86709 .31155 L .4 g
F P
s
P
p
.002 w
.72692 .30318 m .69705 .31069 L .68246 .29679 L p
.8 g
F P
s
P
p
.002 w
.65267 .30434 m .68246 .29679 L .69705 .31069 L p
.8 g
F P
s
P
p
1 .966 0 r
.01 w
.64851 .42516 m
.61894 .43221 L
s
P
p
.002 w
.25989 .30694 m .25109 .29999 L p
.28271 .31011 L .4 g
F P
s
P
p
.002 w
.25109 .29999 m .26524 .29621 L .28271 .31011 L p
.4 g
F P
s
P
p
.002 w
.80125 .30202 m .77109 .30954 L .757 .29562 L p
.8 g
F P
s
P
p
1 .989 0 r
.01 w
.619 .4341 m
.619 .4341 L
s
P
p
.851 1 0 r
.01 w
.61942 .4474 m
.58993 .45438 L
s
P
p
.989 1 0 r
.01 w
.61906 .43599 m
.61906 .43599 L
s
P
p
.002 w
.89758 .30405 m .88231 .30781 L p
.87567 .30086 L .4 g
F P
s
P
p
.828 1 0 r
.01 w
.58997 .45628 m
.58997 .45628 L
s
P
p
1 .575 0 r
.01 w
.70644 .37893 m
.73639 .37166 L
s
P
p
.966 1 0 r
.01 w
.61912 .43789 m
.61912 .43789 L
s
P
p
.002 w
.45934 .30028 m .48847 .2927 L .50443 .30665 L p
.4 g
F P
s
P
p
.805 1 0 r
.01 w
.59001 .45819 m
.59001 .45819 L
s
P
p
1 .897 0 r
.01 w
.64828 .41949 m
.67803 .41238 L
s
P
p
.943 1 0 r
.01 w
.61918 .43979 m
.61918 .43979 L
s
P
p
.782 1 0 r
.01 w
.59006 .4601 m
.59006 .4601 L
s
P
p
1 .92 0 r
.01 w
.64836 .42138 m
.64836 .42138 L
s
P
p
1 .322 0 r
.01 w
.76497 .34393 m
.79517 .33653 L
s
P
p
.92 1 0 r
.01 w
.61924 .44169 m
.61924 .44169 L
s
P
p
1 .184 0 r
.01 w
.7942 .32549 m
.82452 .31802 L
s
P
p
.759 1 0 r
.01 w
.5901 .46201 m
.5901 .46201 L
s
P
p
1 .943 0 r
.01 w
.64844 .42327 m
.64844 .42327 L
s
P
p
.002 w
.87567 .30086 m .89098 .29708 L .89758 .30405 L p
.4 g
F P
s
P
p
.002 w
.11133 .18961 m .64415 .03631 L .89758 .30405 L p
.9 g
F P
s
P
p
.897 1 0 r
.01 w
.6193 .44359 m
.6193 .44359 L
s
P
p
.002 w
.68246 .29679 m .71248 .28918 L .72692 .30318 L p
.8 g
F P
s
P
p
.736 1 0 r
.01 w
.59014 .46393 m
.59014 .46393 L
s
P
p
.874 1 0 r
.01 w
.61936 .4455 m
.61936 .4455 L
s
P
p
.002 w
.757 .29562 m .78732 .288 L .80125 .30202 L p
.8 g
F P
s
P
p
.713 1 0 r
.01 w
.59019 .46584 m
.57478 .45296 L
s
P
p
.002 w
.41397 .29387 m .38514 .30144 L .3683 .28741 L p
.8 g
F P
s
P
p
.002 w
.89098 .29708 m .87567 .30086 L p
.86225 .28683 L .4 g
F P
s
P
p
.002 w
.48847 .2927 m .45934 .30028 L .44301 .28624 L p
.4 g
F P
s
P
p
.002 w
.26524 .29621 m .25109 .29999 L .24223 .29299 L p
.4 g
F P
s
P
p
1 .874 0 r
.01 w
.67793 .41049 m
.70788 .40332 L
s
P
p
1 .299 0 r
.01 w
.795 .33469 m
.82541 .32723 L
s
P
p
1 .598 0 r
.01 w
.73652 .37353 m
.73652 .37353 L
s
P
p
1 .621 0 r
.01 w
.73664 .3754 m
.73664 .3754 L
s
P
p
.002 w
.88434 .29006 m .89098 .29708 L p
.86225 .28683 L .4 g
F P
s
P
p
.002 w
.71248 .28918 m .68246 .29679 L .66766 .28269 L p
.8 g
F P
s
P
p
1 .644 0 r
.01 w
.73677 .37727 m
.767 .36996 L
s
P
p
.002 w
.24223 .29299 m .2333 .28594 L p
.26524 .29621 L .4 g
F P
s
P
p
.002 w
.2333 .28594 m .24751 .2821 L .26524 .29621 L p
.4 g
F P
s
P
p
1 .207 0 r
.01 w
.8247 .31985 m
.8247 .31985 L
s
P
p
.002 w
.78732 .288 m .757 .29562 L .74272 .28151 L p
.8 g
F P
s
P
p
1 .23 0 r
.01 w
.82487 .32169 m
.82487 .32169 L
s
P
p
.002 w
.3683 .28741 m .39727 .27973 L .41397 .29387 L p
.8 g
F P
s
P
p
1 .253 0 r
.01 w
.82505 .32354 m
.82505 .32354 L
s
P
p
1 .851 0 r
.01 w
.70777 .40143 m
.73793 .3942 L
s
P
p
.002 w
.44301 .28624 m .47228 .27855 L .48847 .2927 L p
.4 g
F P
s
P
p
1 .276 0 r
.01 w
.82523 .32538 m
.82523 .32538 L
s
P
p
.002 w
.86225 .28683 m .87765 .28299 L .88434 .29006 L p
.4 g
F P
s
P
p
.002 w
.66766 .28269 m .69783 .27498 L .71248 .28918 L p
.8 g
F P
s
P
p
.002 w
.74272 .28151 m .77319 .27378 L .78732 .288 L p
.8 g
F P
s
P
p
1 .667 0 r
.01 w
.76714 .37184 m
.79762 .36448 L
s
P
p
.002 w
.39727 .27973 m .3683 .28741 L .35123 .27319 L p
.8 g
F P
s
P
p
1 .828 0 r
.01 w
.7378 .39231 m
.76817 .38503 L
s
P
p
.002 w
.87765 .28299 m .86225 .28683 L p
.84864 .27259 L .4 g
F P
s
P
p
.69 1 0 r
.01 w
.57481 .45489 m
.55918 .44183 L
s
P
p
.002 w
.47228 .27855 m .44301 .28624 L .42645 .27199 L p
.4 g
F P
s
P
p
.002 w
.24751 .2821 m .2333 .28594 L .22432 .27884 L p
.4 g
F P
s
P
p
.002 w
.87091 .27587 m .87765 .28299 L p
.84864 .27259 L .4 g
F P
s
P
p
.002 w
.69783 .27498 m .66766 .28269 L .65266 .2684 L p
.8 g
F P
s
P
p
.138 1 0 r
.01 w
.44075 .5166 m
.41155 .5234 L
s
P
p
.002 w
.22432 .27884 m .21526 .27169 L p
.24751 .2821 L .4 g
F P
s
P
p
.002 w
.21526 .27169 m .22954 .2678 L .24751 .2821 L p
.4 g
F P
s
P
p
.002 w
.77319 .27378 m .74272 .28151 L .72823 .2672 L p
.8 g
F P
s
P
p
.115 1 0 r
.01 w
.41149 .52537 m
.41149 .52537 L
s
P
p
1 .805 0 r
.01 w
.76802 .38314 m
.79861 .3758 L
s
P
p
.092 1 0 r
.01 w
.41143 .52735 m
.39459 .51476 L
s
P
p
.002 w
.35123 .27319 m .38033 .2654 L .39727 .27973 L p
.8 g
F P
s
P
p
1 .69 0 r
.01 w
.79778 .36636 m
.79778 .36636 L
s
P
p
.002 w
.42645 .27199 m .45586 .26419 L .47228 .27855 L p
.4 g
F P
s
P
p
1 .713 0 r
.01 w
.79795 .36824 m
.79795 .36824 L
s
P
p
1 .736 0 r
.01 w
.79811 .37013 m
.79811 .37013 L
s
P
p
.002 w
.65266 .2684 m .62256 .27617 L .60719 .26178 L p
.4 g
F P
s
P
p
.161 1 0 r
.01 w
.4702 .50777 m
.44079 .51463 L
s
P
p
.002 w
.84864 .27259 m .86412 .2687 L .87091 .27587 L p
.4 g
F P
s
P
p
1 .759 0 r
.01 w
.79828 .37201 m
.79828 .37201 L
s
P
p
.002 w
.65266 .2684 m .68298 .26057 L .69783 .27498 L p
.8 g
F P
s
P
p
1 .782 0 r
.01 w
.79844 .3739 m
.79844 .3739 L
s
P
p
.002 w
.8039 .266 m .77319 .27378 L .75887 .25936 L p
.8 g
F P
s
P
p
.002 w
.72823 .2672 m .75887 .25936 L .77319 .27378 L p
.8 g
F P
s
P
p
.002 w
.86412 .2687 m .84864 .27259 L p
.83484 .25815 L .4 g
F P
s
P
p
.002 w
.45586 .26419 m .42645 .27199 L .40966 .25755 L p
.4 g
F P
s
P
p
.23 1 0 r
.01 w
.49986 .49493 m
.47028 .50185 L
s
P
p
.002 w
.22954 .2678 m .21526 .27169 L .20615 .26449 L p
.4 g
F P
s
P
p
.667 1 0 r
.01 w
.55921 .44377 m
.55921 .44377 L
s
P
p
.207 1 0 r
.01 w
.47025 .50382 m
.47025 .50382 L
s
P
p
.644 1 0 r
.01 w
.55923 .4457 m
.58918 .43856 L
s
P
p
.002 w
.60719 .26178 m .57717 .2696 L .56142 .25512 L p
.8 g
F P
s
P
p
.184 1 0 r
.01 w
.47023 .50579 m
.47023 .50579 L
s
P
p
.002 w
.85729 .26148 m .86412 .2687 L p
.83484 .25815 L .4 g
F P
s
P
p
.002 w
.60719 .26178 m .63744 .2539 L .65266 .2684 L p
.4 g
F P
s
P
p
.002 w
.68298 .26057 m .65266 .2684 L .63744 .2539 L p
.8 g
F P
s
P
p
.002 w
.20615 .26449 m .19697 .25724 L p
.22954 .2678 L .4 g
F P
s
P
p
.002 w
.19697 .25724 m .21131 .2533 L .22954 .2678 L p
.4 g
F P
s
P
p
.002 w
.83484 .25815 m .8039 .266 L .78974 .25147 L p
.8 g
F P
s
P
p
.002 w
.75887 .25936 m .78974 .25147 L .8039 .266 L p
.8 g
F P
s
P
p
.253 1 0 r
.01 w
.52966 .48599 m
.49987 .49296 L
s
P
p
.069 1 0 r
.01 w
.39452 .51674 m
.37744 .50398 L
s
P
p
.002 w
.48549 .25633 m .45586 .26419 L .43921 .24964 L p
.4 g
F P
s
P
p
.002 w
.40966 .25755 m .43921 .24964 L .45586 .26419 L p
.4 g
F P
s
P
p
.002 w
.63744 .2539 m .60719 .26178 L .59159 .24719 L p
.4 g
F P
s
P
p
.002 w
.56142 .25512 m .59159 .24719 L .60719 .26178 L p
.8 g
F P
s
P
p
.002 w
.83484 .25815 m .8504 .25421 L .85729 .26148 L p
.4 g
F P
s
P
p
.621 1 0 r
.01 w
.58922 .4405 m
.61942 .43331 L
s
P
p
.002 w
.71354 .25269 m .68298 .26057 L .66792 .24597 L p
.8 g
F P
s
P
p
.002 w
.63744 .2539 m .66792 .24597 L .68298 .26057 L p
.8 g
F P
s
P
p
.276 1 0 r
.01 w
.55965 .47698 m
.52965 .48401 L
s
P
p
.002 w
.8504 .25421 m .83484 .25815 L p
.82085 .24351 L .4 g
F P
s
P
p
.002 w
.78974 .25147 m .82085 .24351 L .83484 .25815 L p
.8 g
F P
s
P
p
.002 w
.43921 .24964 m .40966 .25755 L .39262 .2429 L p
.4 g
F P
s
P
p
.002 w
.21131 .2533 m .19697 .25724 L .18773 .24994 L p
.4 g
F P
s
P
p
.002 w
.43921 .24964 m .46899 .24167 L .48549 .25633 L p
.4 g
F P
s
P
p
.002 w
.84347 .24689 m .8504 .25421 L p
.82085 .24351 L .4 g
F P
s
P
p
.002 w
.59159 .24719 m .622 .2392 L .63744 .2539 L p
.4 g
F P
s
P
p
.002 w
.18773 .24994 m .17842 .24259 L p
.21131 .2533 L .4 g
F P
s
P
p
.002 w
.17842 .24259 m .19282 .23858 L .21131 .2533 L p
.4 g
F P
s
P
p
.002 w
.74434 .24474 m .71354 .25269 L .69864 .23797 L p
.8 g
F P
s
P
p
.002 w
.66792 .24597 m .69864 .23797 L .71354 .25269 L p
.8 g
F P
s
P
p
.299 1 0 r
.01 w
.58984 .46792 m
.55962 .47501 L
s
P
p
.598 1 0 r
.01 w
.61948 .43525 m
.64993 .42801 L
s
P
p
.002 w
.82085 .24351 m .78974 .25147 L .77537 .23673 L p
.8 g
F P
s
P
p
.002 w
.46899 .24167 m .43921 .24964 L .42232 .23487 L p
.4 g
F P
s
P
p
.002 w
.39262 .2429 m .42232 .23487 L .43921 .24964 L p
.4 g
F P
s
P
p
.046 1 0 r
.01 w
.37736 .50597 m
.36002 .49304 L
s
P
p
.002 w
.622 .2392 m .59159 .24719 L .57578 .23239 L p
.4 g
F P
s
P
p
.002 w
.82085 .24351 m .83649 .23951 L .84347 .24689 L p
.4 g
F P
s
P
p
.322 1 0 r
.01 w
.62023 .45879 m
.58979 .46594 L
s
P
p
.002 w
.77537 .23673 m .74434 .24474 L .7296 .2299 L p
.8 g
F P
s
P
p
.002 w
.69864 .23797 m .7296 .2299 L .74434 .24474 L p
.8 g
F P
s
P
p
.002 w
.34573 .23611 m .31635 .24413 L .29853 .22928 L p
.8 g
F P
s
P
p
.002 w
.83649 .23951 m .82085 .24351 L p
.80665 .22866 L .4 g
F P
s
P
p
.002 w
.77537 .23673 m .80665 .22866 L .82085 .24351 L p
.8 g
F P
s
P
p
.575 1 0 r
.01 w
.65001 .42996 m
.65001 .42996 L
s
P
p
.002 w
.19282 .23858 m .17842 .24259 L .16904 .23518 L p
.4 g
F P
s
P
p
.002 w
.42232 .23487 m .45225 .22679 L .46899 .24167 L p
.4 g
F P
s
P
p
0 1 .644 r
.01 w
.43924 .58506 m
.40945 .59173 L
s
P
p
.552 1 0 r
.01 w
.65009 .43191 m
.65009 .43191 L
s
P
p
.391 1 0 r
.01 w
.65065 .44566 m
.62004 .45288 L
s
P
p
0 1 .667 r
.01 w
.40939 .59379 m
.40939 .59379 L
s
P
p
.529 1 0 r
.01 w
.65017 .43387 m
.6809 .42658 L
s
P
p
.368 1 0 r
.01 w
.6201 .45485 m
.6201 .45485 L
s
P
p
.002 w
.82946 .23208 m .83649 .23951 L p
.80665 .22866 L .4 g
F P
s
P
p
.002 w
.57578 .23239 m .60634 .22429 L .622 .2392 L p
.4 g
F P
s
P
p
0 1 .69 r
.01 w
.40932 .59584 m
.40932 .59584 L
s
P
p
.002 w
.16904 .23518 m .15959 .22772 L p
.19282 .23858 L .4 g
F P
s
P
p
.002 w
.15959 .22772 m .17407 .22366 L .19282 .23858 L p
.4 g
F P
s
P
p
.345 1 0 r
.01 w
.62016 .45682 m
.62016 .45682 L
s
P
p
0 1 .713 r
.01 w
.40926 .5979 m
.40926 .5979 L
s
P
p
.002 w
.80665 .22866 m .77537 .23673 L .7608 .22178 L p
.8 g
F P
s
P
p
.002 w
.7296 .2299 m .7608 .22178 L .77537 .23673 L p
.8 g
F P
s
P
p
0 1 .736 r
.01 w
.4092 .59996 m
.39198 .58762 L
s
P
p
.002 w
.29853 .22928 m .32805 .22115 L .34573 .23611 L p
.8 g
F P
s
P
p
0 1 .621 r
.01 w
.46928 .57627 m
.43928 .58301 L
s
P
p
.414 1 0 r
.01 w
.6814 .43641 m
.65057 .44369 L
s
P
p
.002 w
.52925 .22554 m .499 .23363 L .48241 .21864 L p
.8 g
F P
s
P
p
.023 1 0 r
.01 w
.35992 .49504 m
.35992 .49504 L
s
P
p
.002 w
.60634 .22429 m .57578 .23239 L .55973 .21738 L p
.4 g
F P
s
P
p
.002 w
.80665 .22866 m .82238 .2246 L .82946 .23208 L p
.4 g
F P
s
P
p
0 1 0 r
.01 w
.35983 .49704 m
.35983 .49704 L
s
P
p
.506 1 0 r
.01 w
.681 .42854 m
.712 .42119 L
s
P
p
0 1 .023 r
.01 w
.35974 .49905 m
.34211 .48595 L
s
P
p
.002 w
.32805 .22115 m .29853 .22928 L .28045 .21422 L p
.8 g
F P
s
P
p
.002 w
.82238 .2246 m .80665 .22866 L p
.79224 .21359 L .4 g
F P
s
P
p
.002 w
.7608 .22178 m .79224 .21359 L .80665 .22866 L p
.8 g
F P
s
P
p
.002 w
.40519 .2199 m .37534 .22804 L .35781 .21296 L p
.4 g
F P
s
P
p
0 1 .598 r
.01 w
.49952 .56743 m
.46931 .57422 L
s
P
p
.002 w
.17407 .22366 m .15959 .22772 L .15008 .22021 L p
.4 g
F P
s
P
p
.437 1 0 r
.01 w
.71236 .4271 m
.6813 .43444 L
s
P
p
.002 w
.48241 .21864 m .51281 .21042 L .52925 .22554 L p
.8 g
F P
s
P
p
.002 w
.81524 .21706 m .82238 .2246 L p
.79224 .21359 L .4 g
F P
s
P
p
.002 w
.63714 .21612 m .60634 .22429 L .59045 .20916 L p
.4 g
F P
s
P
p
.002 w
.55973 .21738 m .59045 .20916 L .60634 .22429 L p
.4 g
F P
s
P
p
.002 w
.15008 .22021 m .1405 .21264 L p
.17407 .22366 L .4 g
F P
s
P
p
.002 w
.1405 .21264 m .15504 .20852 L .17407 .22366 L p
.4 g
F P
s
P
p
0 1 .552 r
.01 w
.48286 .55064 m
.49954 .56332 L
s
P
p
.483 1 0 r
.01 w
.71212 .42316 m
.71212 .42316 L
s
P
p
.002 w
.28045 .21422 m .31012 .20598 L .32805 .22115 L p
.8 g
F P
s
P
p
0 1 .575 r
.01 w
.49953 .56538 m
.49953 .56538 L
s
P
p
0 .966 1 r
.01 w
.39101 .61471 m
.40837 .62695 L
s
P
p
0 1 .759 r
.01 w
.39191 .58969 m
.37443 .57718 L
s
P
p
.46 1 0 r
.01 w
.71224 .42513 m
.71224 .42513 L
s
P
p
.002 w
.43527 .21169 m .40519 .2199 L .3878 .2047 L p
.4 g
F P
s
P
p
.002 w
.35781 .21296 m .3878 .2047 L .40519 .2199 L p
.4 g
F P
s
P
p
0 .943 1 r
.01 w
.4083 .62904 m
.4083 .62904 L
s
P
p
0 .92 1 r
.01 w
.40824 .63114 m
.43836 .62454 L
s
P
p
.002 w
.79224 .21359 m .80806 .20947 L .81524 .21706 L p
.4 g
F P
s
P
p
.002 w
.66819 .20788 m .63714 .21612 L .62142 .20087 L p
.4 g
F P
s
P
p
.002 w
.59045 .20916 m .62142 .20087 L .63714 .21612 L p
.4 g
F P
s
P
p
0 1 .046 r
.01 w
.34201 .48796 m
.34201 .48796 L
s
P
p
.002 w
.80806 .20947 m .79224 .21359 L p
.77763 .1983 L .4 g
F P
s
P
p
.002 w
.3878 .2047 m .35781 .21296 L .34003 .19766 L p
.4 g
F P
s
P
p
0 1 .069 r
.01 w
.3419 .48998 m
.37184 .48281 L
s
P
p
.002 w
.15504 .20852 m .1405 .21264 L .13085 .20502 L p
.4 g
F P
s
P
p
.002 w
.3878 .2047 m .41803 .19638 L .43527 .21169 L p
.4 g
F P
s
P
p
.002 w
.80082 .20183 m .80806 .20947 L p
.77763 .1983 L .4 g
F P
s
P
p
.002 w
.13085 .20502 m .12113 .19734 L p
.15504 .20852 L .4 g
F P
s
P
p
.002 w
.12113 .19734 m .13574 .19316 L .15504 .20852 L p
.4 g
F P
s
P
p
0 .897 1 r
.01 w
.43832 .62665 m
.46869 .62 L
s
P
p
0 1 .529 r
.01 w
.46597 .5357 m
.48288 .54858 L
s
P
p
.002 w
.69947 .19959 m .66819 .20788 L .65262 .19251 L p
.4 g
F P
s
P
p
.002 w
.62142 .20087 m .65262 .19251 L .66819 .20788 L p
.4 g
F P
s
P
p
0 .989 1 r
.01 w
.37349 .60019 m
.39109 .61261 L
s
P
p
.002 w
.41803 .19638 m .3878 .2047 L .37017 .18928 L p
.4 g
F P
s
P
p
.002 w
.34003 .19766 m .37017 .18928 L .3878 .2047 L p
.4 g
F P
s
P
p
0 1 .782 r
.01 w
.37435 .57926 m
.3566 .56658 L
s
P
p
0 1 .345 r
.01 w
.44914 .50614 m
.46621 .51926 L
s
P
p
0 1 .092 r
.01 w
.37175 .48483 m
.40194 .47761 L
s
P
p
.002 w
.57433 .1938 m .54345 .20215 L .52693 .18669 L p
.8 g
F P
s
P
p
0 1 .368 r
.01 w
.46618 .52131 m
.46618 .52131 L
s
P
p
.002 w
.77763 .1983 m .79353 .19412 L .80082 .20183 L p
.4 g
F P
s
P
p
0 1 .391 r
.01 w
.46615 .52336 m
.46615 .52336 L
s
P
p
.002 w
.65262 .19251 m .68408 .18409 L .69947 .19959 L p
.4 g
F P
s
P
p
0 1 .414 r
.01 w
.46612 .52541 m
.46612 .52541 L
s
P
p
0 .874 1 r
.01 w
.46866 .62211 m
.4993 .61542 L
s
P
p
.002 w
.79353 .19412 m .77763 .1983 L p
.7628 .18279 L .4 g
F P
s
P
p
0 1 .437 r
.01 w
.46609 .52746 m
.46609 .52746 L
s
P
p
0 1 .161 r
.01 w
.43222 .47643 m
.44946 .48981 L
s
P
p
.002 w
.13574 .19316 m .12113 .19734 L .11133 .18961 L p
.4 g
F P
s
P
p
0 1 .46 r
.01 w
.46606 .52952 m
.46606 .52952 L
s
P
p
0 1 .184 r
.01 w
.44942 .49184 m
.44942 .49184 L
s
P
p
.002 w
.4485 .18799 m .41803 .19638 L .40055 .18084 L p
.4 g
F P
s
P
p
.002 w
.37017 .18928 m .40055 .18084 L .41803 .19638 L p
.4 g
F P
s
P
p
0 1 .483 r
.01 w
.46603 .53157 m
.46603 .53157 L
s
P
p
0 1 .207 r
.01 w
.44938 .49387 m
.44938 .49387 L
s
P
p
0 1 .506 r
.01 w
.466 .53364 m
.466 .53364 L
s
P
p
0 1 .23 r
.01 w
.44934 .49591 m
.44934 .49591 L
s
P
p
.002 w
.78619 .18637 m .79353 .19412 L p
.7628 .18279 L .4 g
F P
s
P
p
.002 w
.52693 .18669 m .55798 .17822 L .57433 .1938 L p
.8 g
F P
s
P
p
0 1 .115 r
.01 w
.40187 .47964 m
.43232 .47236 L
s
P
p
.002 w
.12598 .18539 m .14068 .18116 L p
.13574 .19316 L .4 g
F P
s
P
p
.002 w
.16513 .18474 m .13574 .19316 L p
.14068 .18116 L .4 g
F P
s
P
p
.002 w
.11133 .18961 m .12598 .18539 L .13574 .19316 L p
.4 g
F P
s
P
p
0 1 .253 r
.01 w
.4493 .49795 m
.4493 .49795 L
s
P
p
.002 w
.68408 .18409 m .65262 .19251 L .63683 .17692 L p
.4 g
F P
s
P
p
0 1 .989 r
.01 w
.35573 .58547 m
.37357 .59809 L
s
P
p
0 1 .276 r
.01 w
.44926 .49999 m
.44926 .49999 L
s
P
p
.002 w
.32198 .18214 m .29193 .19058 L .27347 .17495 L p
.8 g
F P
s
P
p
0 1 .299 r
.01 w
.44922 .50204 m
.44922 .50204 L
s
P
p
0 .851 1 r
.01 w
.49929 .61753 m
.53019 .61079 L
s
P
p
0 1 .322 r
.01 w
.44918 .50409 m
.44918 .50409 L
s
P
p
.002 w
.47921 .17953 m .4485 .18799 L .43117 .17232 L p
.4 g
F P
s
P
p
.002 w
.40055 .18084 m .43117 .17232 L .4485 .18799 L p
.4 g
F P
s
P
p
0 1 .805 r
.01 w
.35651 .56867 m
.33849 .55581 L
s
P
p
.002 w
.7628 .18279 m .77879 .17855 L .78619 .18637 L p
.4 g
F P
s
P
p
.002 w
.15544 .17692 m .17026 .17265 L p
.16513 .18474 L .4 g
F P
s
P
p
.002 w
.19476 .17626 m .16513 .18474 L p
.17026 .17265 L .4 g
F P
s
P
p
.002 w
.14068 .18116 m .15544 .17692 L .16513 .18474 L p
.4 g
F P
s
P
p
.002 w
.63683 .17692 m .66846 .16837 L .68408 .18409 L p
.4 g
F P
s
P
p
0 1 .138 r
.01 w
.43227 .4744 m
.43227 .4744 L
s
P
p
.002 w
.77879 .17855 m .7628 .18279 L p
.74775 .16705 L .4 g
F P
s
P
p
.002 w
.35227 .17364 m .32198 .18214 L .30367 .16639 L p
.8 g
F P
s
P
p
.002 w
.27347 .17495 m .30367 .16639 L .32198 .18214 L p
.8 g
F P
s
P
p
.002 w
.51017 .17101 m .47921 .17953 L .46204 .16374 L p
.4 g
F P
s
P
p
.002 w
.43117 .17232 m .46204 .16374 L .47921 .17953 L p
.4 g
F P
s
P
p
0 .828 1 r
.01 w
.5302 .61292 m
.56137 .60612 L
s
P
p
.002 w
.77134 .17068 m .77879 .17855 L p
.74775 .16705 L .4 g
F P
s
P
p
0 1 .966 r
.01 w
.33773 .57056 m
.35583 .58336 L
s
P
p
.002 w
.66846 .16837 m .63683 .17692 L .62081 .16109 L p
.4 g
F P
s
P
p
.002 w
.18514 .16837 m .20008 .16407 L p
.19476 .17626 L .4 g
F P
s
P
p
.002 w
.22462 .16771 m .19476 .17626 L p
.20008 .16407 L .4 g
F P
s
P
p
.002 w
.17026 .17265 m .18514 .16837 L .19476 .17626 L p
.4 g
F P
s
P
p
.002 w
.30367 .16639 m .33411 .15776 L .35227 .17364 L p
.8 g
F P
s
P
p
.002 w
.46204 .16374 m .49316 .15509 L .51017 .17101 L p
.4 g
F P
s
P
p
.002 w
.74775 .16705 m .76383 .16275 L .77134 .17068 L p
.4 g
F P
s
P
p
0 1 .828 r
.01 w
.33838 .55791 m
.32008 .54486 L
s
P
p
0 .805 1 r
.01 w
.5614 .60825 m
.5614 .60825 L
s
P
p
.002 w
.62081 .16109 m .65261 .15241 L .66846 .16837 L p
.4 g
F P
s
P
p
0 .782 1 r
.01 w
.56142 .61039 m
.56142 .61039 L
s
P
p
.002 w
.21508 .15976 m .23014 .15542 L p
.22462 .16771 L .4 g
F P
s
P
p
.002 w
.25473 .15909 m .22462 .16771 L p
.23014 .15542 L .4 g
F P
s
P
p
.002 w
.20008 .16407 m .21508 .15976 L .22462 .16771 L p
.4 g
F P
s
P
p
.002 w
.76383 .16275 m .74775 .16705 L p
.73248 .15107 L .4 g
F P
s
P
p
0 .759 1 r
.01 w
.56145 .61252 m
.59293 .60569 L
s
P
p
.002 w
.41359 .15643 m .38281 .16507 L .3648 .14906 L p
.8 g
F P
s
P
p
.002 w
.49316 .15509 m .46204 .16374 L .44461 .14772 L p
.4 g
F P
s
P
p
0 1 .943 r
.01 w
.31948 .55543 m
.33784 .56844 L
s
P
p
.002 w
.75627 .15476 m .76383 .16275 L p
.73248 .15107 L .4 g
F P
s
P
p
.002 w
.57284 .15375 m .54138 .16242 L .52453 .14637 L p
.8 g
F P
s
P
p
.002 w
.65261 .15241 m .62081 .16109 L .60455 .14502 L p
.4 g
F P
s
P
p
.002 w
.24526 .15107 m .26044 .14671 L p
.25473 .15909 L .4 g
F P
s
P
p
.002 w
.28508 .1504 m .25473 .15909 L p
.26044 .14671 L .4 g
F P
s
P
p
.002 w
.23014 .15542 m .24526 .15107 L .25473 .15909 L p
.4 g
F P
s
P
p
0 .736 1 r
.01 w
.59298 .60783 m
.62472 .60095 L
s
P
p
.002 w
.44461 .14772 m .41359 .15643 L .39573 .14029 L p
.8 g
F P
s
P
p
.002 w
.3648 .14906 m .39573 .14029 L .41359 .15643 L p
.8 g
F P
s
P
p
.002 w
.44461 .14772 m .4759 .13894 L .49316 .15509 L p
.4 g
F P
s
P
p
.002 w
.73248 .15107 m .74865 .14671 L .75627 .15476 L p
.4 g
F P
s
P
p
.002 w
.52453 .14637 m .55616 .13758 L .57284 .15375 L p
.8 g
F P
s
P
p
0 1 .851 r
.01 w
.31996 .54697 m
.31996 .54697 L
s
P
p
.002 w
.60455 .14502 m .63652 .13622 L .65261 .15241 L p
.4 g
F P
s
P
p
0 1 .874 r
.01 w
.31984 .54908 m
.31984 .54908 L
s
P
p
.002 w
.74865 .14671 m .73248 .15107 L p
.71698 .13486 L .4 g
F P
s
P
p
.002 w
.27568 .14232 m .29099 .13792 L p
.28508 .1504 L .4 g
F P
s
P
p
.002 w
.31567 .14164 m .28508 .1504 L p
.29099 .13792 L .4 g
F P
s
P
p
.002 w
.26044 .14671 m .27568 .14232 L .28508 .1504 L p
.4 g
F P
s
P
p
0 1 .897 r
.01 w
.31972 .5512 m
.31972 .5512 L
s
P
p
0 1 .92 r
.01 w
.3196 .55332 m
.3196 .55332 L
s
P
p
.002 w
.39573 .14029 m .42692 .13145 L .44461 .14772 L p
.8 g
F P
s
P
p
0 .713 1 r
.01 w
.62479 .6031 m
.65682 .59616 L
s
P
p
.002 w
.74097 .1386 m .74865 .14671 L p
.71698 .13486 L .4 g
F P
s
P
p
.002 w
.55616 .13758 m .52453 .14637 L .50743 .13008 L p
.8 g
F P
s
P
p
.002 w
.63652 .13622 m .60455 .14502 L .58804 .12871 L p
.4 g
F P
s
P
p
.002 w
.30635 .1335 m .32178 .12906 L p
.31567 .14164 L .4 g
F P
s
P
p
.002 w
.34652 .13281 m .31567 .14164 L p
.32178 .12906 L .4 g
F P
s
P
p
.002 w
.29099 .13792 m .30635 .1335 L .31567 .14164 L p
.4 g
F P
s
P
p
.002 w
.71698 .13486 m .73324 .13042 L .74097 .1386 L p
.4 g
F P
s
P
p
.002 w
.50743 .13008 m .53923 .12116 L .55616 .13758 L p
.8 g
F P
s
P
p
0 .69 1 r
.01 w
.65691 .59832 m
.68922 .59133 L
s
P
p
.002 w
.58804 .12871 m .62018 .11978 L .63652 .13622 L p
.4 g
F P
s
P
p
.002 w
.73324 .13042 m .71698 .13486 L p
.70124 .1184 L .4 g
F P
s
P
p
.002 w
.33728 .1246 m .35283 .12012 L p
.34652 .13281 L .4 g
F P
s
P
p
.002 w
.37761 .12391 m .34652 .13281 L p
.35283 .12012 L .4 g
F P
s
P
p
.002 w
.32178 .12906 m .33728 .1246 L .34652 .13281 L p
.4 g
F P
s
P
p
.002 w
.45837 .12254 m .42692 .13145 L .40897 .11494 L p
.4 g
F P
s
P
p
.002 w
.72544 .12219 m .73324 .13042 L p
.70124 .1184 L .4 g
F P
s
P
p
.002 w
.53923 .12116 m .50743 .13008 L .49007 .11355 L p
.8 g
F P
s
P
p
.002 w
.62018 .11978 m .58804 .12871 L .57128 .11216 L p
.4 g
F P
s
P
p
0 .667 1 r
.01 w
.68933 .5935 m
.72192 .58646 L
s
P
p
.002 w
.36845 .11563 m .38414 .11112 L p
.37761 .12391 L .4 g
F P
s
P
p
.002 w
.40897 .11494 m .37761 .12391 L p
.38414 .11112 L .4 g
F P
s
P
p
.002 w
.35283 .12012 m .36845 .11563 L .37761 .12391 L p
.4 g
F P
s
P
p
.002 w
.40897 .11494 m .44058 .10589 L .45837 .12254 L p
.4 g
F P
s
P
p
.002 w
.70124 .1184 m .71759 .1139 L .72544 .12219 L p
.4 g
F P
s
P
p
.002 w
.49007 .11355 m .52204 .10449 L .53923 .12116 L p
.8 g
F P
s
P
p
.002 w
.65259 .11077 m .62018 .11978 L .6036 .10309 L p
.4 g
F P
s
P
p
.002 w
.57128 .11216 m .6036 .10309 L .62018 .11978 L p
.4 g
F P
s
P
p
.002 w
.71759 .1139 m .70124 .1184 L p
.68527 .10169 L .4 g
F P
s
P
p
0 .644 1 r
.01 w
.72205 .58863 m
.72205 .58863 L
s
P
p
.002 w
.39988 .10659 m .4157 .10204 L p
.40897 .11494 L .4 g
F P
s
P
p
.002 w
.44058 .10589 m .40897 .11494 L p
.4157 .10204 L .4 g
F P
s
P
p
.002 w
.38414 .11112 m .39988 .10659 L .40897 .11494 L p
.4 g
F P
s
P
p
0 .621 1 r
.01 w
.72218 .5908 m
.70634 .57767 L
s
P
p
.002 w
.70968 .10554 m .71759 .1139 L p
.68527 .10169 L .4 g
F P
s
P
p
.002 w
.68527 .10169 m .65259 .11077 L .63619 .09394 L p
.4 g
F P
s
P
p
.002 w
.6036 .10309 m .63619 .09394 L .65259 .11077 L p
.4 g
F P
s
P
p
.002 w
.43158 .09747 m .44752 .09288 L p
.44058 .10589 L .4 g
F P
s
P
p
.002 w
.47245 .09676 m .44058 .10589 L p
.44752 .09288 L .4 g
F P
s
P
p
.002 w
.4157 .10204 m .43158 .09747 L .44058 .10589 L p
.4 g
F P
s
P
p
.002 w
.68527 .10169 m .70171 .09712 L .70968 .10554 L p
.4 g
F P
s
P
p
.002 w
.70171 .09712 m .68527 .10169 L p
.66905 .08472 L .4 g
F P
s
P
p
.002 w
.63619 .09394 m .66905 .08472 L .68527 .10169 L p
.4 g
F P
s
P
p
.002 w
.69367 .08863 m .70171 .09712 L p
.66905 .08472 L .4 g
F P
s
P
p
.002 w
.46353 .08827 m .47961 .08365 L p
.47245 .09676 L .4 g
F P
s
P
p
.002 w
.50458 .08756 m .47245 .09676 L p
.47961 .08365 L .4 g
F P
s
P
p
.002 w
.44752 .09288 m .46353 .08827 L .47245 .09676 L p
.4 g
F P
s
P
p
0 .598 1 r
.01 w
.70646 .57985 m
.69036 .56652 L
s
P
p
.002 w
.66905 .08472 m .68558 .08008 L .69367 .08863 L p
.4 g
F P
s
P
p
.002 w
.49576 .079 m .51197 .07434 L p
.50458 .08756 L .4 g
F P
s
P
p
.002 w
.53699 .07829 m .50458 .08756 L p
.51197 .07434 L .4 g
F P
s
P
p
.002 w
.47961 .08365 m .49576 .079 L .50458 .08756 L p
.4 g
F P
s
P
p
.002 w
.68558 .08008 m .66905 .08472 L p
.65257 .06749 L .4 g
F P
s
P
p
.002 w
.67742 .07146 m .68558 .08008 L p
.65257 .06749 L .4 g
F P
s
P
p
.002 w
.52825 .06965 m .5446 .06495 L p
.53699 .07829 L .4 g
F P
s
P
p
.002 w
.56966 .06893 m .53699 .07829 L p
.5446 .06495 L .4 g
F P
s
P
p
.002 w
.51197 .07434 m .52825 .06965 L .53699 .07829 L p
.4 g
F P
s
P
p
0 .575 1 r
.01 w
.69048 .56872 m
.67412 .55519 L
s
P
p
.002 w
.65257 .06749 m .6692 .06277 L .67742 .07146 L p
.4 g
F P
s
P
p
.002 w
.56102 .06023 m .5775 .05548 L p
.56966 .06893 L .4 g
F P
s
P
p
.002 w
.60262 .0595 m .56966 .06893 L p
.5775 .05548 L .4 g
F P
s
P
p
.002 w
.5446 .06495 m .56102 .06023 L .56966 .06893 L p
.4 g
F P
s
P
p
.002 w
.6692 .06277 m .65257 .06749 L p
.63584 .04999 L .4 g
F P
s
P
p
.002 w
.66091 .05402 m .6692 .06277 L p
.63584 .04999 L .4 g
F P
s
P
p
.002 w
.59406 .05072 m .61069 .04594 L p
.60262 .0595 L .4 g
F P
s
P
p
.002 w
.63584 .04999 m .60262 .0595 L p
.61069 .04594 L .4 g
F P
s
P
p
.002 w
.5775 .05548 m .59406 .05072 L .60262 .0595 L p
.4 g
F P
s
P
p
0 .552 1 r
.01 w
.67422 .5574 m
.6576 .54367 L
s
P
p
.002 w
.63584 .04999 m .65257 .0452 L .66091 .05402 L p
.4 g
F P
s
P
p
.002 w
.62738 .04113 m .64415 .03631 L p
.63584 .04999 L .4 g
F P
s
P
p
.002 w
.65257 .0452 m .63584 .04999 L p
.64415 .03631 L .4 g
F P
s
P
p
.002 w
.61069 .04594 m .62738 .04113 L .63584 .04999 L p
.4 g
F P
s
P
p
0 .529 1 r
.01 w
.65769 .54589 m
.6408 .53195 L
s
P
p
0 .506 1 r
.01 w
.64088 .53418 m
.64088 .53418 L
s
P
p
0 .483 1 r
.01 w
.64096 .53641 m
.67496 .52878 L
s
P
p
0 .46 1 r
.01 w
.67506 .53102 m
.67506 .53102 L
s
P
p
0 .437 1 r
.01 w
.67517 .53326 m
.67517 .53326 L
s
P
p
0 .414 1 r
.01 w
.67527 .53551 m
.67527 .53551 L
s
P
p
0 .391 1 r
.01 w
.67538 .53776 m
.67538 .53776 L
s
P
p
0 .368 1 r
.01 w
.67549 .54001 m
.67549 .54001 L
s
P
p
0 .345 1 r
.01 w
.67559 .54227 m
.67559 .54227 L
s
P
p
0 .322 1 r
.01 w
.6757 .54453 m
.6757 .54453 L
s
P
p
0 .299 1 r
.01 w
.67581 .54679 m
.71028 .53912 L
s
P
p
0 .276 1 r
.01 w
.71041 .54139 m
.71041 .54139 L
s
P
p
0 .253 1 r
.01 w
.71054 .54367 m
.71054 .54367 L
s
P
p
0 .23 1 r
.01 w
.71067 .54594 m
.71067 .54594 L
s
P
p
0 .207 1 r
.01 w
.7108 .54822 m
.7108 .54822 L
s
P
p
0 .184 1 r
.01 w
.71093 .5505 m
.71093 .5505 L
s
P
p
0 .161 1 r
.01 w
.71106 .55278 m
.71106 .55278 L
s
P
p
0 .138 1 r
.01 w
.7112 .55507 m
.7112 .55507 L
s
P
p
0 .115 1 r
.01 w
.71133 .55736 m
.74629 .54967 L
s
P
p
0 .092 1 r
.01 w
.74645 .55197 m
.74645 .55197 L
s
P
p
0 .069 1 r
.01 w
.74661 .55427 m
.74661 .55427 L
s
P
p
0 .046 1 r
.01 w
.74676 .55657 m
.74676 .55657 L
s
P
p
0 .023 1 r
.01 w
.74692 .55888 m
.74692 .55888 L
s
P
p
0 0 1 r
.01 w
.74708 .56119 m
.74708 .56119 L
s
P
p
.023 0 1 r
.01 w
.74723 .56351 m
.74723 .56351 L
s
P
p
.046 0 1 r
.01 w
.74739 .56582 m
.74739 .56582 L
s
P
p
.069 0 1 r
.01 w
.74755 .56814 m
.74755 .56814 L
s
P
p
.092 0 1 r
.01 w
.74771 .57047 m
.74771 .57047 L
s
P
p
.115 0 1 r
.01 w
.74786 .57279 m
.74786 .57279 L
s
P
p
.138 0 1 r
.01 w
.74802 .57512 m
.74802 .57512 L
s
P
p
.161 0 1 r
.01 w
.74818 .57746 m
.74818 .57746 L
s
P
p
.184 0 1 r
.01 w
.74834 .57979 m
.74834 .57979 L
s
P
p
.207 0 1 r
.01 w
.7485 .58213 m
.7485 .58213 L
s
P
p
.23 0 1 r
.01 w
.74866 .58447 m
.74866 .58447 L
s
P
p
.253 0 1 r
.01 w
.74881 .58682 m
.74881 .58682 L
s
P
p
.276 0 1 r
.01 w
.74897 .58917 m
.74897 .58917 L
s
P
p
.299 0 1 r
.01 w
.74913 .59152 m
.74913 .59152 L
s
P
p
.322 0 1 r
.01 w
.74929 .59388 m
.74929 .59388 L
s
P
p
.345 0 1 r
.01 w
.74945 .59623 m
.74945 .59623 L
s
P
p
.368 0 1 r
.01 w
.74961 .5986 m
.74961 .5986 L
s
P
p
.391 0 1 r
.01 w
.74977 .60096 m
.74977 .60096 L
s
P
p
.414 0 1 r
.01 w
.74993 .60333 m
.74993 .60333 L
s
P
p
.437 0 1 r
.01 w
.7501 .6057 m
.7501 .6057 L
s
P
p
.46 0 1 r
.01 w
.75026 .60807 m
.75026 .60807 L
s
P
p
.483 0 1 r
.01 w
.75042 .61045 m
.75042 .61045 L
s
P
p
.506 0 1 r
.01 w
.75058 .61283 m
.75058 .61283 L
s
P
p
.529 0 1 r
.01 w
.75074 .61522 m
.75074 .61522 L
s
P
p
.552 0 1 r
.01 w
.7509 .6176 m
.7509 .6176 L
s
P
p
.575 0 1 r
.01 w
.75107 .62 m
.75107 .62 L
s
P
p
.598 0 1 r
.01 w
.75123 .62239 m
.75123 .62239 L
s
P
p
.621 0 1 r
.01 w
.75139 .62479 m
.75139 .62479 L
s
P
p
.644 0 1 r
.01 w
.75155 .62719 m
.75155 .62719 L
s
P
p
.667 0 1 r
.01 w
.75172 .62959 m
.75172 .62959 L
s
P
p
.69 0 1 r
.01 w
.75188 .632 m
.75188 .632 L
s
P
p
.713 0 1 r
.01 w
.75204 .63441 m
.75204 .63441 L
s
P
p
.736 0 1 r
.01 w
.75221 .63683 m
.75221 .63683 L
s
P
p
.759 0 1 r
.01 w
.75237 .63924 m
.75237 .63924 L
s
P
p
.782 0 1 r
.01 w
.75254 .64166 m
.75254 .64166 L
s
P
p
.805 0 1 r
.01 w
.7527 .64409 m
.7527 .64409 L
s
P
p
.828 0 1 r
.01 w
.75286 .64652 m
.75286 .64652 L
s
P
p
.851 0 1 r
.01 w
.75303 .64895 m
.75303 .64895 L
s
P
p
.874 0 1 r
.01 w
.75319 .65138 m
.75319 .65138 L
s
P
p
.897 0 1 r
.01 w
.75336 .65382 m
.75336 .65382 L
s
P
p
.92 0 1 r
.01 w
.75353 .65626 m
.75353 .65626 L
s
P
p
.943 0 1 r
.01 w
.75369 .6587 m
.75369 .6587 L
s
P
p
.966 0 1 r
.01 w
.75386 .66115 m
.75386 .66115 L
s
P
p
.989 0 1 r
.01 w
.75402 .6636 m
.75402 .6636 L
s
P
p
1 0 .989 r
.01 w
.75419 .66606 m
.75419 .66606 L
s
P
p
1 0 .966 r
.01 w
.75436 .66852 m
.75436 .66852 L
s
P
p
1 0 .943 r
.01 w
.75452 .67098 m
.75452 .67098 L
s
P
p
1 0 .92 r
.01 w
.75469 .67344 m
.75469 .67344 L
s
P
p
1 0 .897 r
.01 w
.75486 .67591 m
.75486 .67591 L
s
P
p
1 0 .874 r
.01 w
.75503 .67838 m
.75503 .67838 L
s
P
p
1 0 .851 r
.01 w
.75519 .68086 m
.75519 .68086 L
s
P
p
1 0 .828 r
.01 w
.75536 .68334 m
.75536 .68334 L
s
P
p
1 0 .805 r
.01 w
.75553 .68582 m
.75553 .68582 L
s
P
p
1 0 .782 r
.01 w
.7557 .68831 m
.7557 .68831 L
s
P
p
1 0 .759 r
.01 w
.75587 .69079 m
.75587 .69079 L
s
P
p
1 0 .736 r
.01 w
.75604 .69329 m
.75604 .69329 L
s
P
p
1 0 .713 r
.01 w
.75621 .69578 m
.75621 .69578 L
s
P
p
1 0 .69 r
.01 w
.75638 .69828 m
.75638 .69828 L
s
P
p
1 0 .667 r
.01 w
.75655 .70079 m
.75655 .70079 L
s
P
p
1 0 .644 r
.01 w
.75672 .70329 m
.75672 .70329 L
s
P
p
1 0 .621 r
.01 w
.75689 .7058 m
.75689 .7058 L
s
P
p
1 0 .598 r
.01 w
.75706 .70832 m
.75706 .70832 L
s
P
p
1 0 .575 r
.01 w
.75723 .71084 m
.75723 .71084 L
s
P
p
1 0 .552 r
.01 w
.7574 .71336 m
.7574 .71336 L
s
P
p
1 0 .529 r
.01 w
.75757 .71588 m
.75757 .71588 L
s
P
p
1 0 .506 r
.01 w
.75774 .71841 m
.75774 .71841 L
s
P
p
1 0 .483 r
.01 w
.75791 .72094 m
.75791 .72094 L
s
P
p
1 0 .46 r
.01 w
.75809 .72348 m
.75809 .72348 L
s
P
p
1 0 .437 r
.01 w
.75826 .72602 m
.75826 .72602 L
s
P
p
1 0 .414 r
.01 w
.75843 .72856 m
.75843 .72856 L
s
P
p
1 0 .391 r
.01 w
.7586 .73111 m
.7586 .73111 L
s
P
p
1 0 .368 r
.01 w
.75878 .73366 m
.75878 .73366 L
s
P
p
1 0 .345 r
.01 w
.75895 .73621 m
.75895 .73621 L
s
P
p
1 0 .322 r
.01 w
.75912 .73877 m
.75912 .73877 L
s
P
p
1 0 .299 r
.01 w
.7593 .74133 m
.7593 .74133 L
s
P
p
1 0 .276 r
.01 w
.75947 .74389 m
.75947 .74389 L
s
P
p
1 0 .253 r
.01 w
.75964 .74646 m
.75964 .74646 L
s
P
p
1 0 .23 r
.01 w
.75982 .74903 m
.75982 .74903 L
s
P
p
1 0 .207 r
.01 w
.75999 .75161 m
.75999 .75161 L
s
P
p
1 0 .184 r
.01 w
.76017 .75419 m
.76017 .75419 L
s
P
p
1 0 .161 r
.01 w
.76034 .75677 m
.76034 .75677 L
s
P
p
1 0 .138 r
.01 w
.76052 .75936 m
.76052 .75936 L
s
P
p
1 0 .115 r
.01 w
.7607 .76195 m
.7607 .76195 L
s
P
p
1 0 .092 r
.01 w
.76087 .76454 m
.76087 .76454 L
s
P
p
1 0 .069 r
.01 w
.76105 .76714 m
.76105 .76714 L
s
P
p
1 0 .046 r
.01 w
.76122 .76974 m
.76122 .76974 L
s
P
p
1 0 .023 r
.01 w
.7614 .77234 m
.7614 .77234 L
s
P
p
.002 w
.64361 .02412 m
.89616 .2923 L
s
.89616 .2923 m
.96672 .87536 L
s
.96672 .87536 m
.67121 .64359 L
s
.67121 .64359 m
.64361 .02412 L
s
.11292 .17763 m
.03328 .77768 L
s
.03328 .77768 m
.67121 .64359 L
s
.67121 .64359 m
.64361 .02412 L
s
.64361 .02412 m
.11292 .17763 L
s
P
p
p
.002 w
.11292 .17763 m
.64361 .02412 L
s
P
p
.002 w
.23128 .1434 m
.23669 .14797 L
s
P
[(5)] .22044 .13424 .8579 1 Mshowa
p
.002 w
.38467 .09902 m
.38983 .10375 L
s
P
[(10)] .37435 .08956 .79044 1 Mshowa
p
.002 w
.54448 .0528 m
.54935 .05768 L
s
P
[(15)] .53473 .04302 .72297 1 Mshowa
p
.001 w
.26146 .13466 m
.26468 .13743 L
s
P
p
.001 w
.29189 .12586 m
.29508 .12864 L
s
P
p
.001 w
.32257 .11699 m
.32572 .11979 L
s
P
p
.001 w
.35349 .10804 m
.35662 .11086 L
s
P
p
.001 w
.41611 .08993 m
.41917 .09279 L
s
P
p
.001 w
.4478 .08076 m
.45083 .08364 L
s
P
p
.001 w
.47976 .07152 m
.48275 .07441 L
s
P
p
.001 w
.51198 .06219 m
.51494 .06511 L
s
P
p
.001 w
.20133 .15206 m
.20461 .15479 L
s
P
p
.001 w
.17163 .16065 m
.17494 .16336 L
s
P
p
.001 w
.14216 .16918 m
.14549 .17187 L
s
P
p
.001 w
.57724 .04332 m
.58013 .04627 L
s
P
p
.001 w
.61028 .03376 m
.61314 .03673 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30681 .04696 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`000?l0
6`0009400ol300?oP000098000?o00001@000ol0001m0000B@03o`<00_l300?o0P03o`8000?o0000
<@000ol000050003o`0001T00omQ0000B0001ol0003o0?l00P000ol0o`020006o`00o`3o0P000ol0
000a0003o`0000800olI00?o0P000ol0001O0000C0000ol0o`020003o`3o008000Ko003o0?l20003
o`00034000?o00000P000ol0000E00Co1@02of00001900?o0P001_l00?l0o`8000Ko003o0?l20003
o`0003000_l400Co4@05o`D00ol00`3o001N0000B0000ol0000400;o0P001Ol00?l000KoBP04o`L0
1?l01H7o003o05h000180005o`000?l030000ol0o`1900?o1`06o`>10_l00`3oo`1M0000B@03o`l0
00?o0000@`04o`8000?o00000P06o`>100?oPH401?l00`3o001K0000WP03o`L01Ol9P@?o0h400ol0
o`1K0000VP05o`H01?l3P@03oh6100Go00G;^h61o`04P@03o`3o05X0002G00?o10000h7o0004o`R1
0_l8^`03POn100B100Co0?ooF00009<01?l700Go1X43o`0=bk_;^l^kbk_;^l^ko`05P@CoF00006H0
0ol400;o8@03o`8000?o00000P06o`>100?oPH400ol?^`03oh6100?o00F1o`00o`1G0000I`000ol0
00020004o`00oa`01?l700Co2H42o`0Ebk_;^l^kbk_;^l^kbk_;^l^kok_o00F100Co003oEP0006L0
00?o00000P001?l00?lI00Go1@04o`:100?oPH401843oaJk00?o^k/01H401?l00?mE0000I`000ol0
00020004o`00oaD01?l700Co1X400on1P@03o`0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l/0
1H401?l0ool900?oB00006L000?o00000P001?l00?lB00?o1`06o`N11?lL^`03ok^k00:k0h43o`80
00?o00002@000ol000150000IP02o`D00_l?00Co0P000ol0000200Go18400on1P@04o`0U^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^`03o`>100Co003o2P000ol000150000N`03o`L0
1Ol9P@;o9;/00onko`02o`03POn100B100Co003o1P03odP0001g00Ko1@04o`>100?oPH401Ol09k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`F100?oPH400h401?l00?l50003
o`0004P0001d00?o1`04o`R10_lX^`Co00>1oh401X400on1P@03P@03oh7o00D01?m70000L004o`L0
1Ol6P@?o02Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Go0h400on1o`08P@04
oh61P@?o00<0o`00CP0006d00ol40003o`0000Ko0h400on1P@03obJk0ol9P@;o2H43o`>100?o0?l0
CP0006X00ol700Go2842o`0B^l^kbk_;^l^kbk_;^l^kbk_;1?l04;_;^l^kbk_;^l^kbk_;^l/3o`:1
00?oPH4028400on1P@05o`03^l^k00J100?o0?l0C@0004800olQ00Ko1004o`B100?oPH401?l4P@03
ok^k00^k1?l4F`03ok^k00Zk0ol6P@03oh6100N10ol9^`J11?m;0000A@000ol0000K00?o1`04o`R1
0_l9P@0;ok_;^l^kbk_;^l/00_l9F`0:ok_;^l^kbk_;^`;o2X400on1P@03P@Co00c;^l^kbk_;^l^k
bk/4P@?o00<0o`00BP0004D000?o00005`04o`L01Ol6P@?o0[/00on1P@08P@03ok^k00Rk00?oFe/0
25/00onk^`08^`03oh6100R100?oPOl00_l3^`03ok^k00^k0ol3P@03o`3o04X0001200?o5`03o`@0
00?o00001_l3P@03oh6100?o00Nkbk_;^l_o00Z100co^l^kbk_;^l^kbol:F`0<ok_;^l^kbk_;^l_o
2X405_nkbk_;^l_obk_;^l^kbk_;^l^kbk/6P@03o`3o04T000120003o`0001<01?l700Go2842o`Zk
00?oPH400h43o`fk00?oFe/01Ol3F`03ok^k00Rk00?oPH401Ol3P@03ok^k00>k00?o^k/03K/5P@03
o`0000;oA`0004801?l?00?o0P000ol0000200Go0h400on1P@04o`0Abk_;^l^kbk_;^l^kbk_;oh40
0ol04L^kbk_;^l^kbk_;^l^kbk_;00;o2E/02onkbk_;^l^kbk_;00;o2H405_nkbk_;ol^kbk_;^l^k
bk_;^l^kbk/5P@04o`3oob<01Ol01@3oool000?o0`02oa80001A00Co1`04o`R10_lB^`?o5K/00omK
F`08F`03ok^k00Rk00?oPH4028401Onk^k_o016k0h43o`8000?o000080000ol000020004o`00o`@0
00Co003o4`0004h01Ol500Co0X400on1P@03P@?o012kbk_;^l^kbk_;^l^kbk_;1Ol3F`0Gol^kbk_;
^l^kbk_;^l^kbk_;^l^kbol02U/03?nkbk_;^l^kbk_;o`Z101Ko^l_obk_;^l^kbk_;^l^kbk_;^l^k
0_l3P@04o`00ob4000?o00000`03o`800_l30003o`000140001:00Co1`05o`F100?oPOl00_l@^`?o
2E/00onk^`06^`Co2K/00omKF`03F`?o0U/00onk^`08^`03oh6100Go0h400onko`0C^`F100Co003o
8005o`<000?o0?l01@000ol0000A0000A`04o`H01_l9P@0Aok_;^l^kbk_;^l^kbk_;^l/00ol2F`03
oe]K00QK00?obk/01Ol4P@0<ol^kbk_;^l^kbomK0ol6F`0;ok_;^l^kbk_;^l/00_l9P@;o01C;^l^k
bk_;^l^kbk_;^l^kbk_;^`F100Co0?oo7`000ol0000300;o0`03o`040?oooa80001300Co10000ol0
0005o`B100?oPH401?l@^`?o1U/00omKF`08F`;o2X400onk^`07^`03oe]K00QK00?o^k/02;/00on1
P@08P@03ok^k01>k0h43o`8000?o000070000ol0000=0003o`000140001000?o1`05o`V10_l05<^k
bk_;^l^kbk_;^l^kbk_;^l_o2U/00omKF`03F`?o00Bkbk_o2X402oo;^l^kbk_;^l_o00YK00co^l^k
bk_;^l^kbol9P@;o01Fkbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l3P@04o`00oad01OlO0000?004o`80
00?o00000P04o`B100?oPH401?lI^`03oe]K00MK00?oFol00_l7^`03oh6100R100?o^k/01k/00omK
F`08F`03ok^k00Rk00?oPH400h44o`03POnk01Bk1H401?l00?l900?o1002obh0000i00?o1`04o`V1
0_l04L^kbk_;^l^kbk_;^l^kbk_;00Co00Zkbk_;^l^kbk_o2E/03Onkbk_;^l^kbk_;^ol00X45o`>1
00_obk_;^l^kbk_;o`02F`Go012kbk_;^l^kbk_;^l^kbon10ol3P@0Ioh61ok_;^l^kbk_;^l^kbk_;
^l^kbk_;^`05P@04o`3oo`T000?o00000P001?l00?l]0000=@06o`D01?l00h7oP@05P@?o4;/4o`AK
00?o^k/01k/00omKF`04o`jk0ol9P@03ok^k00Nk0_lD^`03oh6100F100CoPH7o5K/3P@?o00<0o`00
20000ol000020004o`00obd0000b00?o1`06o`B100?oPH400ol03l^kbk_;^l^kbk_;^l^kb`04o`UK
00[o^l^kbk_;^l^k0_l03l^kbk_;^l^kbk_;^l^kb`03o`:100?oPH4028408Oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;o`06P@0Joh61POnkbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`>100?o0?l0
20000ol000020004o`00obd0000^00Co1`06o`R10_l>^`Co15/00omKF`07F`03ok^k01Bk0ol6P@03
oh6100R100?o^k/07K/00on1P@03P@03oh6100:100?o^k/04[/6P@03o`3o00L000?o00000P001?l0
0?l]0000:`03o`@000?o00001_l3P@03oh6100Co012kbk_;^l^kbk_;^l^kbk_;0_l9F`03oe]K00MK
01?o^l^kbk_;^l^kbk_;^l^kbk_;00?o2X400on1P@03P@?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02P@Go0h405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`06P@04oh7oP@@00_l500;o
;P0002T00_l700Go2842oaBk00?oFe/02E/00omKF`04oa6k1?l4P@03oh6100N100?oPOl00_l@^`;o
5;/2o`:100?oPH4018400onk^`0B^`F10_l00`3o000j0000:@000ol0o`0200Go0h400on1P@04o`0J
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol;F`;o017;^l^kbk_;^l^kbk_;^l^kb`04o`V100?oPH40
1h404Onkbk_;^l^kbk_;^l^kbk_;00?o01QKol^kbk_;^l^kbk_;^l^kbk_;^l^kbol2P@03oh6100F1
01Go^l^kbk_;^l^kbk_;^l^kbk_;^l/00X42o`05POl00?l0>P0002T000?o0?l00ol8P@;o7[/00omK
F`04F`?o4;/4o`>100?oPH4028400on1P@04oa2k0ol5F`03ok^k01>k00?oPOl028400onk^`0B^`03
oh6100:100Co003o>@0002T00_l4P@03oh6100?o02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^ol2F`?o013;^l^kbk_;^l^kbk_;^l^k0ol8P@03oh6100R10_l05<^kbk_;^l^kbk_;^l^k
bk_;^l_o2E/05_o;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`03POoo00?o0h405Onkbk_;^l^kbk_;^l^k
bk_;^l^kb`05P@03o`0000;o=`0002T000?o0?l01842obNk0_l@^`?o0X400on1P@07P@03oh6100Go
6;/00omKF`07F`03ok^k016k1?l9P@03ok^k01:k1H401?l0oolg00008@02o`D000Co00000_l4P@0f
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol6P@03
oh6100N10_l07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02E/03oo;^l^kbk_;^l^kbk_;
^`04o`:100?oPOl02H405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`03P@?o0P000ol0000d000080001?l0
0?l40005o`000?l01X400onk^`0`^`;o2X400on1P@04o`B100?o^k/07;/00omKF`04o`jk0ol6P@04
oh61o`V100?o^k/04[/2o`>100Co003o=@00020000Co003o10000ol000020003oh6100B103Go^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0:P@;o2H407onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l03k_;^l^kbk_;^l^kbk_;^`03o`03POn100J1
00GoPH61o`02P@Co01Rkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/5P@04o`00oc@0000P0004o`00o`@0
00?o00000`000on1P@04P@03ok^k02Bk1?l9^`03oh6100>10ol2P@03oh6100R100?o^k/0:K/3o`F1
00?oPH4018400on1P@02P@;o7K/5P@Co<`00020000Co003o10000ol000050004oh7oo`:102;o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4F`0<ok_;^l^kbk_;^on10ol6P@03oh6100R1
01?o^l^kbk_;^l^kbk_;^l^kbk_;00?o01;;^l^kbk_;^l^kbk_;^l^kbk/3o`V100?oPH400h44o`0Q
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00>10ol20003o`000300000Q00;o1@000ol0
00060003oh6100>100?o^k/07;/2o`UK00?o^k/01k/00on1P@08P@03oh6100>10ol@^`Co0e/00onk
^`0:^`Go0h400on1P@07P@03oh6100?o8k/4o`>100Co003o<@0002P000?o00001`000on1P@03P@0Q
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00UK00co^l^kbk_;^l^kbol9P@03oh7o00;o
017;^l^kbk_;^l^kbk_;^l^kb`02o`QK00[obk_;^l^kbk_;0_l9P@03oh6100N10_l08L^kok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`05o`=K00?oPH400X401?l00?l`00009`000ol000090003
oh6100>100?o^k/07K/00omKF`07F`;o2K/00on1P@07P@03ok^k01>k00?oFe/01e/00onk^`08^`03
oh6100N100?oPH401?l6^`03ok^k01Rk1?l9F`03oh6100:11?l_00009`03o`/000?oPH400X42o`0O
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02F`Co15/02oo;^l^kbk_;^l_o00:11?l03/^k
bk_;^l^kbk_;^l^k0_l02/^kbk_;^l^kbol9F`0<ol^kbk_;^l^kbk_o2H42o`0Qbk_;^l^kbk_;^onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co0e/00omKF`08F`03oh6100?o0P000ol0000/00009`000ol0
000<00;o18400onk^`0L^`;o2E/00onk^`07^`;o3k/3o`:100?o^k/01k/00omKF`04o`jk00?oPH40
1?l3P@03ok^k00Rk00?o^k/04;/4o`QK00?oFe/025/2o`>100?o0?l0;P0002L000?o00003@000on1
P@03P@0Qol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00UK01Oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`03o`J100[obk_;^l^kbk_;0_l04k_;^l^kbk_;^l^kbk_;^l^kbk/00_l8P@0Iok_;^l^k
bk_;^onkbk_;^l^kbk_;^l^kb`04o`=K00?oFe/01e/00omKF`05o`=K00?oPH400X400ol0o`0900?o
0`03oa/0000W0003o`0000h000?oPH400h400onk^`0M^`03oe]K00MK00?o^k/04;/3o`Z100?o^k/0
7;/00on1P@07P@03ok^k00Jk00?o^k/02K/3o`QK00?oFe/01e/2o`UK00?oPH400X43o`T000?o0000
1@000ol0000H00009`000ol0000@0003oh6100:10_l07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbol00U/4o`0Abk_;^l^kbk_;^l^kbk_;^l/01?l3P@03oh6100R1023obk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`V1017o^l^kbk_;^onkbk_;^l^kb`03o`9K00?oFe/01e/00omKF`04o`04
^l^ko`YK00?oPH400ol00`3o00070003o`0000D000?o0000600002L000?o00004@02o`B100?o^k/0
7;/2oa>k0_l8P@03oh6100>10ol2P@03ok^k01bk00?oPH401?l3P@03ok^k00Bk00?o^k/00k/3o`IK
00?oFe/01e/2o`Rk00?oFe/025/2o`>100?o0?l01`000ol0000200?o6`0002L000?o00004`000on1
P@02P@0eok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
2H400on1o`02o`J101gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`R100Oo^l^kbk_;00Go
2U/00omKF`04o`0>^l^kbk_;^l^kbk_;^ol2F`Go0U/00on1P@03P@03o`3o00H000?o00000P000ol0
000K00009P000ol0000E0003oh6100:100?o^k/0<K/00on1P@07P@03oh6100R100?o^k/05K/4o`=K
00?oPH401h400onk^`04o`AK00?oFe/025/2oa2k1?l8F`03oh6100:100CoPH7o1002o`@01?lJ0000
9P000ol0000E0003POn100>10_l0<l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`02P@Co1842o`R101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/00_l8F`03oh6100N1
0_l3F`03oe]K00=K00?oFe/01Ol04;_;^l^kbk_;^l^kbk_;^l/4o`=K00?oFe/01e/00on1P@03o`80
00?o00009@0002H000?o000050000h400002o`B10_la^`;o2X400on1P@03oaRk00?oFe/01e/00on1
P@04o`>100GoFe]Ko`06F`;o4K/4o`QK00?oFe/01e/2o`>100Co003o9P0002H00olD0005P@000?l0
1X40=?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol:P@;o
01g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`09F`;o28401?mKFol2F`?o0U/03_o;^l^kbk_;
^l^kbk_;1?l3F`03oe]K00MK00?oFe/01?l00k_;^`05P@03o`0000;o900002H000?o000050000h40
00020003oh6100B10_lT^`Co2K/00on1P@03P@?o0X400onk^`0K^`03oe]K00Co0k/00on1P@07P@03
oe_o00;o1U/00onk^`08^`;o25/00omKF`07F`;o2;/5P@;o00<0o`008`0002H000?o000050000h40
000500;o18408?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l4F`0<ol^kbk_;^l^kbon1
0ol6P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l02L^kbk_;^l^ko`09P@;o2E/03?o;
^l^kbk_;^l^ko`UK00?oFe/01?l03K_;^l^kbk_;^l^kbk/00h43o`8000?o00008@0002H000?o0000
50000h4000060003oh6100>100?o^k/06[/2o`UK00?o^k/01k/00on1P@08P@03ok^k02Fk00?oPH40
1?l3^`;o2E/00onk^`08^`03oe]K00MK0_lB^`;o0h401?l00?lR00009P000ol0000D0003P@0000L0
00?oPH400h407oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02E/03?o;^l^kbk_;^l^ko`V1
02So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l02/^kbk_;^l_obol2F`Co
0e/03?o;^l^kbk_;^l^ko`9K1?l3F`0Dok_;^l^kbk_;^l^kbk_;^l^kbk/5P@;o00<0o`00800002D0
00?o00005@000h4000090003oh6100:100?o^k/06k/00omKF`07F`;o2K/00on1P@04o`>100?o^k/0
;K/00onk^`02o`QK00?o^k/02;/2o`QK00?o^k/04K/6P@03o`3o0200000U0003o`0001D000>10000
2P02o`>101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o009K1?l4F`0:ok_;^l^kbk_;^`;o
2840=?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbol9F`0;
ol^kbk_;^l^kbol02U/05?nkbk_;^l^kbk_;^l^kbk_;^l^k0X42o`:100?o0?l07`0002D000?o0000
5@000h40000;0003oh6100:100?o^k/06k/2o`UK00?o^k/01k/00on1P@07P@03ok^k02^k00?o^k/0
0[/00omKF`07F`03ok^k00Nk00?oFe/025/00onk^`0A^`03oh6100>100?o0?l07P0002D000?o0000
50000h40000=0003oh6100:101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o25/02onk
bk_;^l^kbk_o00V10_l0</^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
bk_;^l_o0U/4o`=K00_obk_;^l^kbk_;o`02F`Go0U/05Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`05P@Co
7@0002D000?o000050000h40000?0004oh61P@;o7[/00omKF`03o`fk00?oPH401?l4P@03ok^k02Rk
00?o^k/00[/4o`QK00?o^k/01k/2o`QK00?o^k/04[/3P@05oh7o0?l07@0002D000?o000050000h40
000@00;o0h407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co016kbk_;^l^kbk_;^l^kbk_;
^`02o`V102[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/5o`=K00?oFe/0
1e/02oo;^l^kbk_;^l_o00UK01Gobk_;^l^kbk_;^l^kbk_;^l^kbk/00_l00l^kb`02oad0000U00;o
5@000h40000A0003oh6100:100?o^k/05K/4o`=K00?o^k/04K/00on1P@07P@03ok^k02>k1?l8F`03
oe]K00MK00?o^k/01k/00omKF`07F`;o3;/4o`J10[/00ol0000K000090000ol0000E0003P@000180
00?oPH400X404onkbk_;^l^kbk_;^l^kbk_;^l/01?l8F`0Eol^kbk_;^l^kbk_;^l^kbk_;^l_o00V1
027obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l3F`03oe]K00MK00?oFe/01?l03/^k
bk_;^l^kbk_;^l_o0U/4o`AK00So^l^kbk_;^`Co1X44o`8000?o00006`0002@000?o00005@000h40
000C0003oh6100:10_l<^`Co0e/00omKF`07F`03ok^k016k00?oPH401?l3P@03ok^k01Vk1?l7F`;o
2E/2oa2k1?l9F`03ok^k00Co2H400ol000050003o`0001X0000T0003o`0001D000>100005002o`B1
0_l02;_;^l^kbk_;0_l8F`03oe]K00MK01Cobk_;^l^kbk_;^l^kbk_;^l^kb`;o28406?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`?o0e/00omKF`05F`03oe_o009K1?l04<^kbk_;^l^kbk_;^l^kbk/4o`AK
00?oFe/01e/2o`J11?l;0003o`0001X0000T0003o`0001D000>100005P000on1P@03P@03ok^k00Nk
00?oFe/01U/00omKF`04oaNk00?oPH401h400onk^`0B^`;o1e/00omKF`04F`03oe]K00;o4;/4o`UK
00?oFe/01?l0185O5el27`>100?o00003@000ol0000J000090000ol0000E0003P@0001L000?oPH40
0h402onkbk_;^l^kbk_o00QK0_l07K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00V10_l05;_;
^l^kbk_;^l^kbk_;^l^kbk_o25/00omKF`04o`0@bk_;^l^kbk_;^l^kbk_;^`Co15/00omKF`06F`0;
GamO7aLO5alG7aL00UlC0003o`0001X0000T0003o`0001@000>1000060001840ool3P@03ok^k00Nk
00?oFe/00olQ^`03oh6100Co18400onk^`05^`?o2K/00omKF`06F`;o0k/00onk^`0:^`Co2E/01?mK
Fol7G`055elGGaL00el00amO000B0003o`0001X0000T0003o`0001@000>10000600018400?l4P@0:
ok_;^l^kbk_;^`;o02G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2H400onk
b`04o`=K00_o^l^kbk_;^l^ko`02F`?o013;^l^kbk_;ol^kbk_;^l^k1?l4F`03oe]K00IK0Ql04ElO
GamO7eoo5alGGamO7elO009O4`000ol0000J000090000ol0000D0003P@0001L000>100000P000on1
P@02P@03ok^k02nk00?oPH401h42o`QK00?o^k/01k/2o`Zk00?o^k/00[/4o`UK00AO7elO2El3P@03
o`0000MO5P000ol0000J00008`000ol0000E0003P@0001L000>100000`000on1P@02P@;o037;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00:11?l3F`03oe]K00MK
01Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4F`03oe]K009K00EO7elOG`087`Co1003G`047el0PAP0
00?o00006P0002<000?o00005@000h40000G0003P@0000@00_l4P@03ok^k02bk1?l8F`03oe]K00MK
00?o^k/04;/3o`@O15/02QmOGamO7elOGh43G`>100?o00000P08G`8000>100005`000ol0000I0000
8`03oaD000>100005`000h4000060003oh6100:102_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00?o0e/00omKF`07F`03oe]K00Co01Bkbk_;^l^kbk_;^l^kbk_;^l^kb`<O
00ko7amO7aLO5alG7elOG`B11?l400UO1@000h40000G0003o`0001T0000S0003o`0001D000>10000
5`000h4000070003oh6100:100?o^k/03k/3oa>k0_l7F`03oe]K00MK0_lF^`DO00[o7e/OGamO7elO
1h402_l0001O5elGGaL4G`T000>100005`000ol0000I00008`000ol0000E0003P@0001L000>10000
20000on1P@02P@;o00bkbk_;^l^kbk_;^l/3o`=K01Gobk_;^l^kbk_;^l^kbk_;^l^kbol025/00omK
F`04o`B101Kobk_;^l^kbk_;^l^kbk_;^l^kbk_;0al00l^ko`02o`035alG00B11?l500QO3@000h40
000G0003o`0001T0000S0003o`0001D000>100005`000h40000900;o18400onk^`07^`;o1e/00onk
^`05^`?o2K/00omKF`06F`;o2H400onk^`0C^`Go28400ol0000600045elGGa8000>100005`000ol0
000I00008`000ol0000E0003P@0001L000>100002`000on1P@02P@0;ok_;^l^kbk_;^ol025/00oo;
^`04o`=K00_obk_;^l^kbk_;o`02F`?o00Fkbk_;o`09P@0Aol^kbk_;^l^kbk_;^l^kbk/01?l4P@03
oh7o00?o200025lGGaMO5elG4P000h40000G0003o`0001T0000S0003o`0001@000>1000060000h40
000<0003oh6100:10_l8^`03oe]K00IK0_l8F`03ok^k00Nk0_l8^`03oh6100Co0h400onk^`0:^`?o
2842o`P000=O5aL01QL?00BO0P000h40000G0003o`0001T0000R0003o`0001D000>1000060000h40
000=00;o18402_o;^l^kbk_;^ol2F`?o15/2o`MK01Cobk_;^l^kbk_;^l^kbk_;^l^kb`;o28402?o;
^l^kbk_;1?l6P@?o0P000ol0000300HG00=O5el03`09W`03084001P000?o00006@00028000?o0000
5@000h40000H0003P@0000l000?oPH400X400onk^`06^`;o2E/00omKF`02F`04oe]KoaBk00?oPH40
1X400onk^`04o`R10_l5000;o`0005lGGaMO5el01`0011LA5a440003Wa6O00JO00H0WmnO084I0003
o`0001T0000R0003o`0001D000>1000060000h40000@0003oh6100:100_obk_;^l^kbk_;o`09F`Co
01Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`R10_l6P@Co2@001?l000035`L01a42W`054IlAWa40
0il400:O00COW`216P000ol0000H00008P000ol0000E0003P@0001P000>100004@000on1P@02P@;o
2;/00omKF`04ob2k00?oPH400ol9P@03o`0000/000?o01L00Q400aL00002000A5a4G4ALA5a4G09lA
Wa6O4Il00`08g`04W`00PAT000?o00006000028000?o00005@000h40000G0003P@0001<00_l4P@09
ok_;^l^kbk_;00;o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`B11Ol?008G
00co5a4G4ALA5a4G4AL34@D000>O4Il01@08W`D000>100005`000ol0000H00008P000on1o`0E0003
P@0001L000>100005@000on1P@02P@03ok^k02Jk1?l2P@Co50025`054AOo5a400QL01Q4G4ALA5`l0
0Yl3g`X000>100005`000ol0000H00004`03o`@00_l60003o`2101D000>100005`000h40000E0003
POn100>102;o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1_l5P@03o`0001H000/A5a4G
oaLA014G4@0?0008ga7O4MlAga4;0003P@0001L000?o0000600001@000?o00000P001?l00?l40005
o`00084050000h40000G0003P@0001D000B10?oo0h400onk^`0H^`Ko1844oa`000DA5a40o`0A00VO
3P000h40000G0003o`0001P0000D0003o`00008000Co003o10000ol0000200:14@000h40000H0003
P@0001D000B1003o18405onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o2H400ol0000R0003oh4000/0
00WOWmnOgioO4Ml04P000h40000G0003o`0001P0000D0003o`00008000Co003o10000ol000040003
P@0000h000>1000060000h40000E0005P@000?l018400onk^`0?^`Co1X44o`03084002@000?oP@00
2@07WaH000>100005`000ol0000H000050000ol000020004o`00o`@000?o00001@02P@h000>10000
60000h40000E0003P@0000<00_l2P@;o00c;^l^kbk_;^l^kbk/3o`R10_l50003P@0002<000?oP@00
1`001MnOgioO01X000>1000060000ol0000G00004`02o`D00_l50003o`0000L000>100002`000h40
000H0003P@0001D000>100001@04P@03ok^k00Fk1?l5P@Co2@000h40000S0003oh4000<000SOWmnO
gioOWa/000>1000060000ol0000G00008@000ol000080003P@0000X000>1000060000h40000E0003
P@0000H000OoPH61ol^k00Co28400ol0000;0003P@0002<000?oPMl00]l01YoOWmnOgah000>10000
60000ol0000G00008@000ol0000900:12P000h40000H0003P@0001D000>100001`001?n1PH42o`J1
1?l@0003P@00024000WOWonOgioOWml08`000h40000G0003o`0001L0000Q0003o`0000/000>10000
1`000h40000H0003P@0001@000>100002@02o`03^l^100F100?o00004P000h40000O0005gioOgol0
0]lW0003P@0001L000?o00005`00020000?o00003@02P@L000>1000060000h40000D0003P@0000/0
1OlH0003P@0001l000JOgml0oh490005gW7NgW406P000h40000G0003o`0001L0000P0003o`0000l0
00>1000010000h40000H0003P@0001@000>100002`000ol0000J0003P@0001d000?Og]h00]h2000?
o`3NLMiagW7NLMiagW7N01X000>100005`000ol0000G00008003oa0000>100000P000h40000H0003
P@0001D000>100002`000ol0000J0003P@0001T000KNLMiagW45gP03omkN00;N2G4K0003P@0001L0
00?o00005`00020000?o00004@02P@8000>1000060000h40000E0003P@0000/000?o00006P000h40
000E00[N0100gW7NLOmagP3NLMiagW7N7P000h40000H0003o`0001H0000P0003o`0001<000>10840
6P000h40000E0003P@0000/000?o00006P000h40000=00CN00EagW7NL@02gP03LMh000D00mh00`3o
0005LB8000>1000060000ol0000F000080000ol0000D00:16P000h40000E0003P@0000/000?o0000
6P000h40000700?N00EagW7NL@07gP800]l8009a00?oLG400g4S0003P@0001P000?o00005P000200
00?o00005@02PAT000>100005@000h40000;0003o`0001X000>100001`07gP04077NL@H000?Ng`00
0`000g7ML@03L@03og5a02H000>1000060000ol0000F000080000ol0000E0003P@2101P000>10000
5@000h40000;0003o`0001X000>100001`001=iag]l90006g]oNgmkO2G400`3o000W0003P@0001P0
00?o00005P0001l000?o00005P000h400002PAH000>100005@000h40000;0003o`0001X000>10000
2@04gP03g`0000SN0g401=eagG450003o`0002L000>100005`000ol0000F00007`000ol0000F0003
P@00008000>100004`000h40000E0003P@0000/000?o00006P000h40000:0003gmkO00;N00H0g]kN
gmh300;M00=a00001`000ol0000W0003P@0001L000?o00005P0001l000?o00005P000h40000300:1
4`000h40000E0003P@0000/000?o00006P000h40000;00;N00GOg]oOgP040004UG7ML@X000?o0000
9`000h40000G0003o`0001H0000O0003o`0001H000>100001@000h40000@0003P@0001D000>10000
2`000ol0000J0003P@0000h00mh02MeagG7MLMeag@0:0003o`0002L000>1000060000ol0000E0000
7`000ol0000E0003P@0000L000>100003`000h40000E0003P@0000/000?o00006P000h40000=00=a
00NELIEaUG6E00d000?o00009`000h40000H0003o`0001D0000O00;o5P000h40000800:13`000h40
000E0003P@0000X000So0000g>cLk1H000>100002@002IEaUG6ELMeag@0B0003o`0002L000>10000
60000ol0000E00000P03oaX000?o00005@000h40000:0003P@0000`000>100005@000h40000:0005
g>cLk=`01>`E0003P@0000L01g4F0003o`0002L000>1000060000ol0000E00000P001?l00?lH0003
o`0001H000>100002`02P@/000>100005P000h400006000:g;OLk=c/g>cL00?L00?/00004P000h40
00030007UG6ELIEaU@0J0003oh4002L000>1000060000ol0000E00000P000ol0000I0003o`0001H0
00>100003@000h4000080003P@0001H000Z1k=c/g>cLk=c/0]`00ncL000600?/4`000h40g@09gA/0
00?oP@009`000h40000H0003o`0001D000020003o`0001T000?o00005P000h40000>0003P@0000L0
00>100004@003mc/g>cLk=c/g;OL]mbgg0030003o`0000H000?/g>`04P001iEaUG6ELID080000on1
000W0003P@0001P000?o00005@0000030?oo00;o6@000ol0000F0003P@0000l00X470003P@000140
00_/g>cLk=c/0>cLk0070003o`0000L00^`00kL0000;0008LIEaUG6ELIDS0003oh4002L000>10000
60000ol0000E00000P000ol0000I0003o`0001H000>100004@000h4000040003P@00014000?Lk=`0
1=`00iD000080003o`0000P000?Lk0002003U@06LIEaUG6E9P000on1000X0003P@0001L000?o0000
5@00008000?o00006@000ol0000F0003P@0001800X440003P@0001D01=`00iD000070003o`0000P0
00?Lk00010002MfEgIGMUG6EL@030003P@0002@000?oP@00:0000h40000E00>100?o0000500001h0
00?o00005@000h40000E0005P@0008405`001X7Lg9GLU@P000?o000020000mc/000200NE1`000h40
000T0003oh4002P000>100004005P@<000?o0000500001h000?o00005@000h40000F0004P@00PAL0
00J10000UM`2U@H000?o00002002k0<000?MUID02`000h40000T0003oh4002P000>100003004P@P0
00?o0000500001d000?o00005P000h40000G00>15`000h4000020005UMbEg9D010000ol0000800?/
0iD00mbE000:0003P@0002@000?oP@00:0000h40000700F130000ol0000D00007@000ol0000F0003
P@0001T000>100005@000h4000040004UMbEg0<000?o00001`0029GL]nbgg9GL30000h40000U0003
o`0002L000>100000`04PA4000?o0000500001d00olF0003P@0001T00X4F0003P@0000H000JEg9GL
0?l50003UMbE00BE0n`>0003P@0002D000?o00009`06PAD000?o0000500001d000?o00005P000h40
000I0004P@21PA@000>100001`000mbEU@02U@8000SLUMbEg9GLU@<00kL=0003P@0002D000?o0000
9004PAX000?o0000500001d000?o00005P000h40000I0005P@0008404`000h4000090004g9GLU@;L
00>Eg9D020000kJg000<0003P@0002D000?o00007`05P@<000>1000060000ol0000D00007@000ol0
000F0003P@0001P000>100000`02PA4000>100002`03U@03g00000T000>f]`0030000h40000U0003
ol3001/018480003P@0001T000?o00004`0001d000?o00005P000h40000H0003P@0000D000>10000
3P000h40000;0003oiGL00`00[L=0003P@0001d000?0a/000P03aP04olK6aQD01H4=0003P@0001P0
00?o00004`0001d000?o00005@000h40000I0003P@0000H000>100003@000h40000;0003o`0000`0
0kL<0003P@0001d00/H6`004o`36aQ40184B0003P@0001P000?o00004`0001`000?o00005P000h40
000I0003P@0000L00X4=0003P@0000/000?o000030001;Nf]kH;0003P@0001d01/H20004o`2<aPD0
00A<S4b<0`05PAH000>1000060000ol0000C000070000ol0000F0003P@0001T000>100002@000h40
000:0003P@0000/000?o00003P000kNf]`0:0003P@0001d00l002<K0a/H0o`3628`00db<P@02PA/0
00>1000060000ol0000C000070000ol0000F0003P@0001T000>100002P02P@>e1`000h40000;0003
o`0000l000>f]kH02@000h40000Q000A`<K0a_l0S4b<C8a<S4b1C8`07P000h40000H0003o`0001<0
000L0003o`0001H000>100006@000h40000<00:e00<=]@d01@000h40000;0003o`00010000>g][L0
20000h40000R0005a/30o`000h`2P@@000><aP00100014b<C8`E0003P@0001P000?o00004`0001`0
00?o00005P000h40000I0003P@0000`000<=]KD00kD40003P@0000/000?o00004@000kJg]P070003
P@0002<000F1a_o6P@08009<00Z<C8a<S4b<C8a<50000h40000H0003o`0001<0000L0003o`0001H0
00>100006@000h40000<00083KFeP@fe3KD20003P@0000/000?o00004P000kJg]P060003P@0001l0
18420004ol36`0L000R<C8a<S4b<C0800T`D0003P@0001T000?o00004P0001`000?o00005P000h40
000I0003P@0000`000D=]@fe3@05]@03P@0000/000?o00004`000kJg]P050003P@0001/018460003
olK000?01@000ha<S00700;B50000h40000I0003o`000180000K00?o5`000h40000I0003P@0000h0
00Fe3KD=P@04]@d000?o000050000kJg]P040003P@0001H01H4:0007oh40`<K0aP0>009<50000h40
000I0003o`000180000K0003o`0001L000>100006@000h40000@00053KD=P@001;D;0003o`0001<0
1;H40003P@000180184?0003oh4000800l0=0003CD`001<000>100006@000ol0000B00006`000ol0
000F0003P@0001X000>100004@001@fe3H4000Fe2@000ol0000?00Rf10000h40000=00F14`000on1
00020003`<K000;02`000de<000D0003P@0001P000?o00004P0001/000?o00005P000h40000I0003
P@0001801@d01h40]Obeo;D01`000ol0000;0003]_bf00Jf1`000h40000900B160000on1000400C0
2P000de<000D0003P@0001P000?o00004P0001/000?o00005P000h40000I0003P@0001@000D=]@fe
P@0200Be1P000ol000070006]_bfo;Kl0kH;0003P@0000@01H4L0003oh4000H01<08009=5@000h40
000H0003o`000180000K0003o`0001H000>100006@000h40000F00<=0X401@3l]KJe00D000?o0000
1@001kKl]_bfo;H03`000h400004PB4000?oP@001`03`003c00000D000=<C@0050000h40000H0003
o`000180000K0003o`0001H000>100006@000h40000F0006PKD=3@210P000kGl]@02o0030?l000<0
00?l]_`00[H00obf000@00F19@000on100090004`<c0`0D000=<C@0050000h40000I0003o`000140
000K0003o`0001H000>100006@000h40000F0003P@d=008=00H0P@00]KH3]@0;oobfo;Kl]_bfo;H0
3P04P@8000>100009@001_n100g<3@S<00?0c00010000da=000D0003P@0001T000?o00004@0001X0
00?o00005`000h40000I0003P@0001H000>100000`d01@21P@2e00Cl0[H00obfo00>00F11P000h40
000S00;<00?oc<`02/`00`30c00500==50000h40000I0003o`000140000J0003o`0001L000>10000
6@000h40000F0004P@0000<=0P0018400003]@03]P0000/0184;0003P@0001d01L`020g<3Ol=c0d0
0l`=009=00=V00004P000h40000I0003o`000140000J0003o`0001L000>100006@000h40000F0003
P@0000800`d200:10P03o0P01H4?0003P@0001L000T=c0g<3L`=c0d01<`20003o`00018000=>C@00
4`000h40000I0003o`000140000J0003o`0001H000>100006P000h40000F0003P@0000801@d20003
P@3o00:e1004PA@000>100001P001<0=`0d400C<00L=c0g<3L`=00G<20000ol0000B0003CDh001<0
00>100006@000ol0000A00006P03oaH000>100006P000h40000F0003P@0000@010d20003POl000F1
600;c0073L`=c0g<3@02c0073L`=c0g<3@0>0003o`00018000=VCP0050000h40000H0003o`000140
000J0003oh4001H000>100006P000h40000F0003P@0000H00`d20003oh4001P000l=c0g<3L`=`0g0
3L0=`0001l`0100=c0dC0003o`0001800VHE0003P@0001P000?o00004@0000/01?l300;o1P000ol0
P@0F0003P@0001X000>100005P000h40000700<=00<0o`005@000`g<c006c0040<c<c0H000<=c0d0
6`000ol0000B0003CFH001@000>1000060000ol0000A000030000ol000020004o`00o`D000?o0000
0X4D0003P@0001X000>100005P000h4000070005c0g<3L`03P053@08c0g<3L`=c0d30003P@0002H0
00?o00004P02IQD000>100006@000ol0000@00003@001Ol0003o008000?o00000P000ol0000300:1
4P000h40000I0003P@0001L000>100002@043@D000?<3L`00Pd03<`=c0g<3L`=c0g<3@L000>10000
9P000ol0000B0003ITh001@000>100006@000ol0000@00003P001?l00?l20003o`00008000?o0000
1@000h40000?0003P@0001T000>100005`000h40000;0009c0d=3L`=c0g<00L=00@03L`=2`000h40
000V0003o`0001800ThE0003P@0001T000?o0000400000/000Co003o0P001?l00?l40003o`0000H0
0X4?0003P@0001T000>100005`000h40000;000<ol`=c0g<3L`03L`=4`000h40000V0003o`000180
0VHE0003P@0001T000?o0000400000`00_l400;o1@000ol000080003P@0000`000>100006@000h40
000G0003P@0000/000Co3L`=6`000h40000V0003o`0001800T8E0003P@0001T000?o0000400001T0
00?o00002@02P@`000>100006@000h40000G0003P@0000/000?o000070000h40000V0003o`000180
00=>@P0050000h40000I0003o`000100000I0003o`0000/00X490003P@0001X000>100005`000h40
000;0003o`0001`000>100009004oa<00T8E0003P@0001T000?o0000400001T000?o00003@000h40
00060003P@0001X000>100005`000h40000;0003o`0001`000>100007`05o`<000>1o`004@000dm2
000E0003P@0001P000?o0000400001P000?o00003`02P@H000>100006P000h40000G0003P@0000/0
00?o000070000h40000J00Go20000h40o`0A00=25@000h40000I0003o`0000l0000H0003o`000140
00>100000`000h40000J0003P@0001L000>100002`000ol0000L0003P@0001D01Ol=0004P@00oa00
0d8E0003P@0001T000?o00003`0001P000?o00004P02P@<000>100006P000h40000G0003P@0000/0
00?o000070000h40000A00Co4P0018400002o`l000=2C`0050000h40000I0003o`0000l0000H00;o
5@02P@03084001/000>100005P000h40000<0003o`0001`000>100003005oaH000>100000`000ol0
000<009?5@000h40000I0003o`0000l0000H0003o`0001H00X4L0003P@0001H000>1000030000ol0
000L0003P@0000L01OlK0003P@0000@000?o00002`02CaD000>100006@000ol0000?000060000ol0
000G00:16`000h40000F0003P@0000`000?o000070000h40000200Go80000h40000500;o2`000dlo
000D0003P@0001T000?o00003`0001P000?o00005`000h40P@0I0003P@0001L000>1000030000ol0
000L0003POoo00;o9@000h4000070003o`0000P000<oC`0050000h40000I0003o`0000l0000H0003
o`0001H000B100000X4G0003P@0001L000>1000030000ol0000H00Go:@000h4000080003o`0000L0
00<oC`0050000h40000I0003o`0000l0000G0003o`0001L000>100000`02PAD000>100005`000h40
000<0003o`0001<01Ol40003P@0002L000>100002@000ol000060003?dl001@000>100006P000ol0
000>00005`000ol0000G0003P@0000D000>100004P000h40000G0003P@0000`000?o00003P05o`T0
00>100009`000h40000:00;o1P02CaD000>100006P000ol0000>00005`000ol0000G0003P@0000H0
0X4B0003P@0001L000>1000030000ol0000:00Co3P000h40000W0003P@0000`000?o00000`000dlo
000E0003P@0001T000?o00003P0001L000?o00005`000h4000080003P@0000l000>100005`000h40
000<0003o`0000D01OlB0003P@0002L000>100003@000ol000020003?dl001D000>100006@000ol0
000>00005`000ol0000G0003P@0000T00X4?0003P@0001L000>1000030000ol00005oaL000>10000
9`000h40000>0004o`00008o5P000h40000I0003o`0000h0000G0003o`0001L000>100002`02P@d0
00>100005`000h40000:00Go70000h40000W0003P@0000l00_l00`0o?`0F0003P@0001T000?o0000
3P0001L000?o00005`000h40000=0003P@0000X000>100005`000h40000600Co00<0o`007P000h40
000W0003P@00014000?o83l05P000h40000I0003o`0000h0000G0003o`0001L000>100003P02P@X0
00>100005`0018400005o`D000?o00007@000h40000W0003P@00018000?o82005@000h40000I0003
o`0000h0000F00?o5`000h40000A0003P@0000L000>100005P05o`X000?o00007@000h40000W0003
P@0001<000?o800050000h40000I0003o`0000h0000F0003o`0001L000>100004P02P@L000>10000
4@05o`03084000`000?o00007@000h40000W0003P@0001<000<Qool050000h40000J0003o`0000d0
000F0003o`0001L000>100005002P@D000>100003@04o`H000>100002`000ol0000M0003P@0002L0
00>100004`00120Q0?lC0003P@0001H018400ol0000=00005P000ol0000G0003P@0001H000F10000
P@0;00Go2P000h40000;0003o`0001d000>100009`000h40000C008P0P000ol0000@0003P@000140
1H440003o`0000d0000F0003o`0001L000>100005`02P@03084000D01Ol?0003P@0000/000?o0000
7@000h40000X0003P@0001800R4300;o4@000h40000;00F12@000ol0000=00005P000ol0000G0003
P@0001T00X400`3oo`03oa@000>100002`000ol0000M0003P@0002P000>100004P028@D000?o0000
3P000h40000600F13P000ol0000=00005P000ol0000G0003P@0001P01?lI0003P@0000/000?o0000
7@000h40000X0003P@00018000<_8@001@000ol0000=0004P@0000F14`000ol0000=00005@000ol0
000H0003P@0001<01Ol20003P@2101P000>100002`000ol0000M0003P@0002P000>100004P000b4_
00060003o`0000/01H4H0003o`0000d0000E0003o`0001P000>100003P05o`L000>100000X4F0003
P@0000/000?o00007@000h40000X0003P@00018000<R8@001`02o`H01H400`21000J0003o`0000d0
000E0003o`0001P000>100002@05o``000>100000P02PA<000>1000030000ol0000M0003P@0002P0
00>100004P02;`X000?oPH400h460003P@0001X000?o0000300001D000?o00005`000h40000600Co
4@000h4000040003P@00010000>1000030000ol0000M0003P@0002P000>100004P028PH01H400ol0
00080003P@0001X000?o0000300001D000?o00005`0018400005oaD000>100001@02PA0000>10000
30000ol0000M0003P@0002P000>100004P028P03086100>11P000ol000070003P@0001X000?o0000
300001D000?o00005P05oaX000>100001`000h40000=0003P@0000`000?o00007@000h40000X0003
P@0000l00h400b8OP@0<00;o1`000h40000J0003o`0000`0000E0003o`0001401Ol00`21000L0003
P@0000P00X4=0003P@0000`000?o00007@000h40000X0003P@0000X01H4300038Ql000h000?o0000
10000h40000J0003o`0000`0000E00;o3P04o`H000>100006`000h40000:00:12`000h40000<0003
o`0001d000>10000:0000h40000500F120000b8_7`0?0003o`0000<000>100006P000ol0000<0000
50000ol0000900Go2P000h40000K0003P@0000`000>1000020000h40000<0003o`0001d000>10000
:0000h400005P@h000<R7`003`02o`@000>100006@000ol0000<000050000ol0000400Go3`000h40
000J0003P@0000h00X480003P@0000`000?o00007@000h40000V00F14`000b8O000A0005o`000840
6`000ol0000<000050000ol0o`04oa@000>100006P000h40000@0003P@0000D000>1000030000ol0
000M0003P@0002401H420003P@0001<00QlC0004o`00PA`000?o00002`0001@00_lI0003P@0001X0
00>100004@02P@D000>1000030000ol0000M0003P@0001`01H470003P@0001<000<R7`004`000ol0
P@0L0003o`0000/0000F00;o5P000h40000K0003P@0001<00X430003P@0000`000?o00007@000h40
000G00F130000h40000Z00;o70000ol0000;000060000ol0000C0003P@0001/000>100005@001840
084>0003o`0001d000>100004P05PA4000>10000:`000h7o000J0003o`0000/0000I00;o4`000h40
000K0003P@0001H00h4>0003o`0001d000>100003006PAH000>10000:`000h40o`0J0003o`0000/0
000K00;o4@000h40000K0003P@0001P000>1000030000ol0000M0003P@0000L01H4L0003P@0002/0
00B1003o6@000ol0000;00007@02o`l000>100006`000h40000H00>130000ol0000M0003P@000080
1H4Q0003P@0002/000B100000_lG0003o`0000/0000O00;o3@000h40000K0003P@0001P000>10000
0X4:0003o`0001d01H4V0003P@0002/000>100000`000ol0000D0003o`0000/0000Q0003o`0000X0
00>100006`000h40000H0003P@00008000>100001`000ol0000H00J1:P000h40000/0003P@0000<0
00?o000050000ol0000:00008P02o`X000>100006`000h40000H0003P@0000<00X470003o`0001<0
1H450003P@0002T000>10000:`000h40000400;o50000ol0000:00009002o`P000>100006`000h40
000H0003P@0000D000>100000`000ol0000?00F12P000h40000Y0003P@0002/000>100001P000ol0
000A0003o`0000X0000V00;o1@000h40000L0003P@0001P000>100001P02P@<000?o00002P05P@l0
00>10000:@000h40000[0003P@0000L000?o000040000ol0000:0000:0000ol000020003P@0001/0
00>100006@000h40000800:100<0o`001P05PA@000>10000:@000h40000[0003P@0000P000?o0000
3`000ol0000:0000:@02o`8000>100006`000h40000I0003P@0000X000B1o`001H4I0003P@0002T0
00>10000:`000h40000900;o3`000ol0000:0000:`02o`03P@0001/000>1000060000h40000<0003
oh6101h000>10000:@000h40000[0003P@0000/000?o000030000ol0000:0000;@02oa`000>10000
60000h40000<0003o`0001h000>10000:@000h40000[0003P@0000`000?o00002`000ol0000:0000
;`02oaX000>1000060000h40000<0003o`0001h000>10000:@000h40000[0003P@0000d000?o0000
2P000ol0000:0000<@000ol0000G0003P@0001P000>1000030000ol0000N0003P@0002T000>10000
:`000h40000>00;o2`000ol000090000<P02oaL000>1000060000h40000<0003o`0001h000>10000
:@000h40000/0003P@0000l000?o000020000ol000090000=002oaD000>1000060000h40000<0003
o`0001h000>10000:@000h40000/0003P@00010000?o00001`000ol000090000=P02oa<000>10000
60000h40000<0003o`0001h000>10000:@000h40000/0003P@00014000?o00001P000ol000090000
>0000ol0000@0003P@0001P000>1000030000ol0000N0003P@0002T000>10000;0000h40000B00;o
1P000ol000090000>@02oa0000>1000060000h40000<0003o`0001h000>10000:@000h40000/0003
P@0001@000?o00000`000ol000090000>`02o`h000>1000060000h40000<0003o`0001h000>10000
:@000h40000/0003P@0001D000?o00000P000ol000090000?@02o``000>1000060000h40000<0003
o`0001h000>10000:@000h40000/0003P@0001H00_l20003o`0000T0000o00;o2@000h40000I0003
P@0000`000?o00007P000h40000Y0003P@0002`000>1000060001?l00?l:0000@@000ol000060003
P@0001T000>1000030000ol0000N0003P@0002T000>10000;0000h40000I0003o`3o00X0001200;o
1P000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002`000>100006P02o`X0001400;o
10000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002`000>100006004o`X0001600;o
0P000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002d000>100004@06o`h000180003
o`2101/000>1000030000ol0000N0003P@0002T000>10000;@000h40000<00Go500004T00_lK0003
P@0000`000?o00007P000h40000Z0003P@0002`000>100001P06oaT0001;00;o6@000h40000<0003
o`0001h000>10000:P000h40000/0003P@0000Ko7`0004d00_lG0003P@0000`000?o00007P000h40
000Z0003P@0002T01_lU0000C`02oaD000>1000030000ol0000N0003P@0002X000>100009005ob/0
001A0003o`00018000>1000030000ol0000N0003P@0002X000>100007P06oc00001B00;o4@000h40
000=0003o`0001h000>10000:P000h40000H00Ko=P0005@00_l?0003P@0000d000?o00007P000h40
000Z0003P@0001801_ll0000EP02o`d000>100003@000ol0000N0003P@0002X000>100003@05od80
001H0003o`0000X000>100003@000ol0000N0003P@0002X000>100001`06odL0001I00;o2P000h40
000=0003o`0001h000>10000:P0018400006odd0001K00;o20000h40000<0003o`0001l000>10000
:006oe<0001M00;o1P000h40000<0003o`0001l000>100008`05oeT0001O00;o10000h40000<0003
o`0001l000>100007@06oeh0001Q0005o`0008403P000ol0000O0003P@0001L01_mT0000HP02o`03
084000d000?o00007`000h40000B00GoJP0006@00_l>0003o`0001l000>100003006ofl0001V00;o
30000ol0000O0003P@0000H01_me0000J0000ol000090003o`0001l000>100001_mk0000J@02o`T0
00?o00007@05oh40001[00;o1`000ol0000G00KoQP0006d00_l50003o`0001401_n<0000K`02o`<0
00?o00002`06oi80001a0004o`00o`P01OnH0000LP03o`801_nM0000M003oj<0003o01/0003o01/0
003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0003o01/0001e0003o`0002L000?o0000
N00005001?l300Co00@0ool00_l200;o0`03o`@00_l40003o`0000P01Ol0103oo`02o`801Ol00`3o
o`0300?o10000ol0000700?o1005o`800ol300;o0`04o`800ol400;oB@0004l000Go0000o`020003
o`0000<000Co003o0`02o`@000?o00000P001?l00?l40003o`0000T000Go0000o`020004o`00o`<0
00?o00000_l40003o`0000@000?o00001`000ol000050003o`00008000Co003o0P02o`@000?o0000
0`000ol0000300;oB@0004l000?o0?l00_l200Go00D0o`00o`090003o`00008000Co003o40001Ol0
003o008000Co003o0`000ol000060003o`0000h000?o00001@000ol000020003o`0000X000?o0000
0P000ol0001>0000C`000ol000040007o`000?l0o`020003o`0000L000?o00000`02oa4000Go0000
o`020004o`00o`<000?o00001P000ol0000>00?o1@000ol000020003o`0000/000Go0000o`1@0000
C`001Ol0003o00<00ol00`3oo`03o`T000?o00000P001?l00?l@0003o`0000Go0`04o`P000?o0000
3P000ol0000400;o0`04o`P000Co003o0`000ol0001>0000D004oa@00_l500;o3`05o`/000?o0000
1@02o`l01Ol90003o`0000T00_l300;oD00008l00_lQ0003o`00008000?o0000H0000?l06`000001
\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.080396, -0.025005, 0.00279772, \
0.00386045}},
  CellTags->"AntTracker3D - Gen 18"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 17",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 19",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \(ifSensor[wall]\)[seq[stop], \ 
          turnRight], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[turnLeft, \ again], \ \n\ \ \ \ \ \ \ seq[
            advance, \ \(ifSensor[dust]\)[seq[stop], \ 
              advance], \ \n\ \ \ \ \ \ \ \ \(ifSensor[dust]\)[
              seq[turnLeft, \ again], \ nop], \ advance, \ 
            advance]]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.18, Ind.1, Fit.21.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.18, Ind.1, Fit.21.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .943 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .966 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .713 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .69 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .667 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .644 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.115 1 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.138 1 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .943 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .966 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .713 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .69 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .667 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .644 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.115 1 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.138 1 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 .92 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .621 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.161 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.736 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.759 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.782 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.805 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.828 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.851 1 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 .92 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .621 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.161 1 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.736 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.759 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.782 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.805 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.828 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.851 1 0 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 .989 1 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .736 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
.092 1 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .897 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .598 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.184 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.207 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.23 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.874 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.897 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.92 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.943 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.966 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.989 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .989 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
1 .966 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 .989 1 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .736 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
.092 1 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .897 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .598 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.184 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.207 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.23 1 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.874 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.897 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.92 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.943 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.966 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.989 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .989 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
1 .966 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .874 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .575 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .552 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.253 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.713 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .943 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .92 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .897 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .506 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .483 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .46 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .874 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .575 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .552 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.253 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.713 1 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .989 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .759 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
.069 1 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .943 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .92 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .897 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .506 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .483 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .46 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 .851 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.276 1 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .989 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .759 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
.069 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .874 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .529 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .437 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .414 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .391 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .069 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .046 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .023 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 .851 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.276 1 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .874 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .529 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .437 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .414 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .391 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .069 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .046 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .023 0 r
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
0 1 .529 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .782 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .805 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .828 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.299 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.667 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.69 1 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .851 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .552 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .368 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .092 0 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
0 1 .529 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .782 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .805 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .828 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.299 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.667 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.69 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .966 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .782 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
.023 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
.046 1 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .851 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .552 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .368 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .092 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 .759 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.322 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.644 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .966 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .782 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
.023 1 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
.046 1 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .828 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .621 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .598 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .575 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .345 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .115 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 .759 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.322 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.644 1 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .506 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .483 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .46 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .437 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .414 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .391 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .368 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
0 1 .345 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .828 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .621 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .598 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .575 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .345 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .115 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 .736 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.345 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.368 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.391 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.621 1 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .506 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .483 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .46 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .437 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .414 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .391 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .368 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
0 1 .345 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .805 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .644 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .322 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .138 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .943 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .805 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .046 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .023 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 .736 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.345 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.368 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.391 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.621 1 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .805 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .644 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .322 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .138 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .943 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .805 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .046 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .023 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 .713 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.414 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.552 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.575 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.598 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .782 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .759 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .736 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .713 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .69 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .667 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .299 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .161 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .069 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 .713 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.414 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.552 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.575 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.598 1 0 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .322 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .299 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .276 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .253 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .23 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .207 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .184 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
0 1 .161 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .782 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .759 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .736 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .713 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .69 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .667 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .299 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .161 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .069 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 .69 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.437 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.529 1 0 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .322 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .299 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .276 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .253 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .23 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .207 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .184 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
0 1 .161 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .92 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .897 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .874 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .851 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 1 .828 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .276 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .253 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .23 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .207 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .184 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 1 .092 r
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 .69 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.437 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.529 1 0 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .92 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .897 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .874 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .851 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 1 .828 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .276 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .253 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .23 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .207 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .184 0 r
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 1 .092 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .644 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 .667 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.46 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.483 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.506 1 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .138 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
0 1 .115 r
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .644 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 .667 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.46 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.483 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.506 1 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .138 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
0 1 .115 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
0 .621 1 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
0 .621 1 r
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
0 .598 1 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
0 .598 1 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .81705 .39486 L .80355 .37699 L p
.8 g
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
0 .575 1 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
0 .575 1 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.80355 .37699 m .83594 .36716 L .84918 .38523 L p
.8 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
0 .552 1 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
0 .552 1 r
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.65218 .34967 m .63631 .3547 L .62847 .34539 L p
0 .506 1 r
F P
s
P
p
.002 w
.65218 .34967 m .63631 .3547 L .62847 .34539 L p
0 .529 1 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.62847 .34539 m .64441 .34031 L .65218 .34967 L p
0 .506 1 r
F P
s
P
p
.002 w
.62847 .34539 m .64441 .34031 L .65218 .34967 L p
0 .529 1 r
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .322 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .345 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .368 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .391 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .414 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .437 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .46 1 r
F P
s
P
p
.002 w
.68421 .33952 m .66815 .34461 L .66044 .33519 L p
0 .483 1 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .322 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .345 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .368 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .391 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .414 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .437 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .46 1 r
F P
s
P
p
.002 w
.66044 .33519 m .67657 .33005 L .68421 .33952 L p
0 .483 1 r
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .138 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .161 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .184 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .207 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .23 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .253 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .276 1 r
F P
s
P
p
.002 w
.71662 .32925 m .70037 .3344 L .69278 .32487 L p
0 .299 1 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .138 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .161 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .184 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .207 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .23 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .253 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .276 1 r
F P
s
P
p
.002 w
.69278 .32487 m .7091 .31966 L .71662 .32925 L p
0 .299 1 r
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .023 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .046 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .069 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .092 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .115 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .138 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .161 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .184 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .207 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .23 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .253 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .276 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .299 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .322 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .345 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .368 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .391 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .414 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .437 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .46 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .483 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .506 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .529 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .552 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .575 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .598 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .621 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .644 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .667 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .69 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .713 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .736 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .759 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .782 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .805 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .828 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .851 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .874 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .897 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .92 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .943 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .966 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
1 0 .989 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.989 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.966 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.943 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.92 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.897 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.874 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.851 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.828 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.805 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.782 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.759 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.736 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.713 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.69 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.667 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.644 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.621 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.598 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.575 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.552 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.529 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.506 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.483 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.46 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.437 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.414 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.391 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.368 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.345 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.322 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.299 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.276 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.253 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.23 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.207 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.184 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.161 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.138 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.115 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.092 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.069 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.046 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
.023 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 0 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .023 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .046 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .069 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .092 1 r
F P
s
P
p
.002 w
.7494 .31886 m .73296 .32407 L .72551 .31443 L p
0 .115 1 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .023 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .046 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .069 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .092 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .115 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .138 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .161 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .184 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .207 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .23 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .253 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .276 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .299 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .322 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .345 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .368 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .391 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .414 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .437 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .46 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .483 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .506 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .529 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .552 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .575 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .598 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .621 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .644 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .667 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .69 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .713 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .736 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .759 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .782 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .805 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .828 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .851 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .874 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .897 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .92 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .943 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .966 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
1 0 .989 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.989 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.966 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.943 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.92 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.897 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.874 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.851 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.828 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.805 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.782 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.759 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.736 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.713 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.69 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.667 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.644 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.621 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.598 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.575 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.552 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.529 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.506 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.483 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.46 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.437 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.414 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.391 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.368 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.345 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.322 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.299 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.276 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.253 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.23 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.207 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.184 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.161 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.138 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.115 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.092 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.069 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.046 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
.023 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 0 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .023 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .046 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .069 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .092 1 r
F P
s
P
p
.002 w
.72551 .31443 m .74202 .30916 L .7494 .31886 L p
0 .115 1 r
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@08ok_;^l^k
bk/4o`0@bk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl00k/3o`04C8a<oa2k00?oPH402X400onk^`05^`04o`00o`@0
00?o0000;`0001P000?o00002P001_o;^l^ko`j104Cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`b100?oPOl00_l8P@0ook_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o
00>1oh4038400on1P@04P@?o01nkbk_;^l_oC8a<S4b<ok_;^l^kbk_;^l^kbk_;^l_o00b100Wo^l^k
bk_;^ol00P000ol000020003o`0002h0000I0003o`0000X000?o^k/00k/00on1P@0;P@03ok^k03:k
0_l<^`03oh6100Z100?oPH402X400onk^`0h^`?o1H400on1P@0;P@03oh6100?o0k/2o`Fk00SoS4b<
C8a<oa2k00?oPH402X400onk^`04^`04o`00o`D000?o0000;@0001X00_l;0007ol^kbk_;o`0=P@0a
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`0@Fonkbk_;
^l^kbk_;^l^ko`J10ol3P@03oh6100Z103Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o2H400on1P@0;P@;o00>kbk/00ol02Tco^l^kbk_;od`3o`0D
bk_;^l^kbk_;^l^kbk_;^l^kbol7P@?o00Z1ol^kbk_;^l_o0P000ol0000200;o;P0001`000?o0000
2@000onk^`03^`;o2842o`:100?o^k/0:k/2o`EK00?o^k/02k/00on1P@03o`N100?oPH402X400onk
^`0G^`;o5k/3o`f100?oPH401X43o`Fk00?oS8`00h`00onk^`04^`03ok^k01Bk00?oPH400h42o`F1
00?o^k/01K/01?l00?l300;o;P0001d000?o00002@002?o;^l^kbk_o1843o`F102[obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`QK00ko^l^kbk_;^l^kbk_;^`;o2h400on1
P@0:P@0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0U/05?o;^l^kbk_;^l^kbk_;^l^kbk_;0ol3P@03
oh6100Z100?oPH400h43o`0_^l^kbk_;^l_oS4b<C8a<ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^koh400ol8P@08ol^kbk_;^ol20003o`0000<000?o0000:`0001h000?o00002@000onk^`04^`04
oh7oo`V100?o^k/09K/00omKF`0:F`03ok^k00^k00?oPH402X400on1P@04P@?o5[/2o`IK00?o^k/0
3K/3o`N100?oPH402X400on1o`02o`>k0ol6^`03ohco00;o7[/3o`b100?o^k/01;/01?l00?l50003
o`0002X0000O0003o`0000T000Sobk_;^l^ko`b102Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^kbk_o00b100?oPH400ol05[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`UK00gobk_;^l^kbk_;^l^k00;o2h400on1P@0:P@04ok_;^`?o0lH09Onkbk_;^l_o
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l2F`03oh6100^100Sobk_;^l^ko`8000?o0000
0P000ol0000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03
oh6100Z10_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10ol7^`03ol3000?000?o^k/0
7[/3o`MK00?oPH402h400onk^`03^`05o`000?l010000ol0000Y00008@02o`/000Oo^l^kbk_o00b1
02Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0<F`0?ok_;^l^kbk_;^l^k
bk_o00J10ol07/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`eK00gobk_;^l^kbk_;^l_o00f1
00?oPH400ol00k_;^`02o`07bk_;^l^ko`03aP0NolKo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
1?l;F`03oh6100J10ol02H7o^l^kbk_;o`020003o`0000<000?o0000:00002<000?o00002@000onk
^`03^`03oh6100Z10_lV^`03oe]K00AK0ol3F`03ok^k00^k00?oPH400olQ^`03oe]K00]K00?o^k/0
2K/00on1P@0;P@;o0k/3o`03`?nk00Jk0olJ^`Co0U/00omKF`0:F`03oh6100>10ol5P@03ok^k00Bk
00Co003o0`02obX0000T0003o`0000T000Oo^l^kbk_o00J10ol4P@0Xok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`9K0ol7F`0>ok_;^l^kbk_;^l^kbk/2o`0Fbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`?o00fkbk_;^l^kbk_;^l_o00QK0ol03k_;^l^kbk_;^l^kbk_;o`06P@Co0X40:onk
bk_oa/36`<Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol7F`03oe]K00YK00?oPOl0
0_l9P@08ok_;^l^kbol20003o`00008000?o00001@03o`<00olI00009@000ol000090003ok^k00>k
00?oPH400ol8P@03ok^k02Bk0_l;F`03ok^k01nk0ol2P@03ok^k00^k00?oFe/00e/2oa:k00?oPH40
0ol7P@0;ok^kolK0a/36`?l06k/4o`]K00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o1@000ol0
00050003o`0000D000?o00005P0002H000?o00002@001_nkbk_;^`;o3840:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
0ol6P@0@ol^kbk_;^l^kbk_;^l_oF`?o01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l;P@05ok_;ol00
0ol06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`03oe]K00YK00?oFe/015/4o`9K00?oPH40
2h402?o;^l^kbk_o0P000ol000020003o`0000D000?o00001@000ol0000F00009`000ol000090003
ok^k00Bk00?oPH402X400onk^`0T^`03oe]K00YK00?o^k/05[/4o`Z100?o^k/02k/00onk^`0G^`03
oh6100Z100Co^k_o6[/3o`IK00?oFe/02U/00omKF`03o`MK00?oPH402h400onk^`04^`04o`00o`@0
00?o000010000ol0000200?o6@0002P000?o00002@02o`06bk_;^l_o3840:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0X400on1
P@0:P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^k
b`02o`0?^l^kbk_;^l^kbk_;^l^k00?o2U/00omKF`08F`04oe_oo`]K00?oPH401X43o`09POnkbk_;
^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1P@0:P@03
ok^k02Bk00?oFe/015/3oaBk0ol6P@03oh6100Z100?o^k/09K/00on1P@0:P@03ok^k00:k0ol00l3o
^`0;^`?o00=Koe/02e/00omKF`04F`?o0[/00omKF`0;F`03oh6100>10_l5P@03ok^k00Bk00Co003o
0P000ol0o`0400;o1004oaP0000[0003o`0000T000Oobk_;^l_o00J10ol3P@0Xok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`9K0ol05K_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z1
00?oPH402840:on1ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01X43o`:1
01?obk_;ol36`<K0ol^kbk_;^l^k00?o1E/00omKF`0:F`03oe]K00?o00Nkbk_;^l_o00eK00?oPOl0
0_l8P@08ok_;^l^kbol20003o`00008000?o00008`0002`000?o00002@000onk^`03^`03oh6100?o
1h400onk^`0T^`;o6K/00on1P@09P@03oh6100B10ol3P@03ok^k02Fk00?oPH400ol6P@0;ok^kolK0
a/36`?l01;/3o`UK00?oFe/025/01?mKool:^`03oe]K00]K00?oPH402H400onk^`04^`04o`00o`D0
00?o00008P0002d000?o00002@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N102Kobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co2X401Oo;^oo600?o00Jkbk_;^ol<F`03
oe]K00AK1?l04<^kbk_;^l^kbk_;^l^kbol6F`Co0U/00on1P@0:P@08ol^kbk_;^ol20003o`0000<0
00?o00008@0002h000?o00002@000onk^`04^`03oh6100V100?o^k/0?k/00on1P@09P@;o2h400onk
^`0N^`Co0U/00on1P@0:P@04ok^ko`Rk00?oFe/02e/00omKF`03oaBk00?oFe/00ol7F`03oh6100Z1
00?o^k/01;/01?l00?l40003o`000240000_0003o`0000T000Sobk_;^l^ko`^104?o^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J1
0ol2P@03oh6100Z101gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`MK00?oPH402X402Oo;
^l^kbk_;^`02o`03bomK00aK0_l05[_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`]K00?oPH401H43o`0:
POnkbk_;^l^ko`8000?o00000P000ol0000P0000<0000ol0000900;o1K/00on1P@09P@;o@;/00on1
P@03o`J100?oPH402X400onk^`0G^`;o2e/00on1P@08P@03oh7o00Bk0ol01LKo^k_o00QK0olE^`Co
0U/00omKF`0:F`03oh6100>10_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^k
bk_o00J10ol3P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
35/00on1P@04P@?o0X401Onkbk_o00G000Co^l_o1E/2o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o
1e/00omKF`0:F`03oh7o00;o28402?nkbk_;^l_o0P000ol000020003o`0001l0000c0003o`0000T0
00?o^k/00k/00on1P@03o`N100?o^k/0?K/00on1P@0:P@03oh6100B10olM^`03oe]K00YK00?oPH40
0ol6P@0;ok^kol36`<K0a_l00[/00omKo`02oa>k1?l;F`03oe]K00QK00?oFol038400onk^`04^`04
o`00o`@000?o00007P0003@000?o00002@001_nkbk_;^`;o2h40@Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100?oPH400ol08/^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`;o2X401Onkboo000?o01W;^l^kboo;^l^k
bk_;^l^kbk_;^l^kbk_;00?o0U/00omKF`0:F`03oe]K00AK1?l00l^ko`0=P@07ok_;^l^ko`020003
o`0000<000?o00007@0003D000?o00002@000onk^`03^`03oh6100Z100?o^k/0?K/00on1P@08P@04
oh7oobFk00?oFe/015/3o`:k00?oPH402X401?nk^olI^`?o1U/00omKF`0:F`03oe]K00?o1k/00on1
P@0;P@03ok^k00>k00Co003o10000ol0000M0000=P000ol000090007ok_;^l^ko`0<P@0aol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`0<bk_;^l^kbk_;^l_o
1X43o`>102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/3o`07^l^kbk_;
o`0<P@08ok_;^l^kbk/3o`0?^l^kbk_;^l^kbk_;^l^k00;o2U/00omKF`08F`0@oe_ook_;^l^kbk_;
^l^ko`J11?l2P@08ol^kbk_;^ol20004o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z1
0_l[^`?o15/00onk^`09^`03oh6100?o1h400onk^`0T^`;o2[/00on1P@08P@03oh7o00>k0ol2`003
ok^k00fk00?oFe/02U/00omKF`04F`?o4;/00on1P@03o`N100?o^k/00k/01?l00?l50003o`0001/0
000h00;o2P02o`05bk_;^ol01X43o`B102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0dok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01k_;^l^kbol01L004Oo;^l^kbk_;^l^kbk_;^l_o00aK
00?oFe/00ol05<^kbk_;^l^kbk_;^l^kbk_;^l^k0_l;P@07ol^kbk_;o`020003o`00008000?o0000
6`0003X000?o00002@000onk^`02^`03oh6100?o28400onk^`0R^`;o35/00onk^`09^`03oh6100Z1
00?o^k/0<;/00on1P@03o`Zk00Oo`<30ol3o00nk00?oFe/025/01?mKoolG^`03oh6100Z100?o^k/0
1;/01?l00?l40003o`0001X0000k0003o`0000T000Gobk_;^`02o`b102Oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/03Oo;^l^kbk_;^l^kbol03840<onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0>^l^kbk_;^l^kbk_;^l/3o`0D
bk_;^l^kbk_;^l^kbk_;^l^kbol6F`?o0U/06oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0<P@0:
ok_;^l^kbol0o`D000?o00006@0003`000?o00002@000onk^`03^`03oh6100Z100?o^k/08k/00omK
F`0:F`03ok^k00Vk00?oPH402X400onk^`1F^`03oe]K00?o1U/00onk^`0G^`03oh6100R100?oPOl0
1K/01?l00?l40003o`0001T0000m0003o`0000T000Kobk_;^l/2o`^102Oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01U/3o`9K00ko^l^kbk_;^l^kbk_;o`J10ol3P@16ok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`Co00o;^l^kbk_;^l^kbk_;^l/00_l:F`0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@Co
0X402?o;^l^kbk_o0P001?l00002oaX0000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk
^`0S^`03oe]K00?o1U/00onk^`0:^`03oh6100?o1h400onk^`0o^`?o00G0c<3<o`0>^`03oe]K00UK
00?o^k/05k/00on1P@03o`N100?o^k/01;/01?l00?l40003o`0001L0000o0003o`0000T000Sobk_;
^l^ko`:10ol6P@0Vok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`YK00go^l^k
bk_;^l^kbk_;00;o2h40FOnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^oo<`<c0c<3obk_;^l^kbk_;^l^kbk_o00]K01[o^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;o2h401oo;^l^kbol00P000ol000030003o`0001H0001000;o2P000onk
^`04^`;o2X400onk^`0S^`03oe]K00UK00?o^k/02[/00on1P@0:P@03ok^k03nk00?o`?l00_lA^`03
oe]K00MK00?oFol06;/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000F0000@P000ol0000800;o
00Jkbk_;^ol;P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00]K00Wo^l^k
bk_;^l/00_l00k_;o`0<P@1Hok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;o`IK0ol3F`0Jok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbol<P@08ok_;^l^kbol20003o`00008000?o00005@0004<000?o0000
2@000onk^`03^`03oh6100V100?o^k/08k/00omKF`09F`03ok^k00:k0ol00ncLo`02^`03oh6100B1
0ol2P@03ok^k04Fk0_l>^`03oe]K00?o1e/00onk^`0F^`03oh6100R100?oPOl01K/01?l00?l50003
o`0001@000140003o`0000T000Oo^l^kbk_o00^10_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol01U/3o`0@bk_;^l_og>cLk=c/ok_;o`:10ol6P@14ol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0ALOo;^l^k
bk_;^l^kbk_;^l/00_l;F`0Iok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o
0P001?l00002oaH000150003o`0000T000?o^k/00k/00on1P@04P@?o0h400onk^`0R^`03oe]K00?o
0[/2o`Jk00Oog>cLk=co00:k0_l:P@03ok^k03nk00OogW7NLMko00nk00?oFe/02U/00onk^`05^`;o
3[/00on1P@03o`N100?o^k/01;/01?l00?l40003o`0001<000160003o`0000T000Oo^l^kbk_o00:1
0ol7P@0Col^kbk_;^l^kbk_;^l^kbk_;^`04o`0>bk_;^l^kbk_;^l^kbk/2o`03bk_;00;o00Vgg?o;
^l^kbk/00ol01k_;^l^kbol02h40>oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01c;^l^kbomagW7NLOo;^l^kbk_;^l^kbk_;^l_o35/01?nk
bk/3o`0?5onkbk_;^l^kbk_;^l^k00Co2h402_o;^l^kbk_o0?l300?o500004L000?o00002@000onk
^`03^`;o2h400onk^`0<^`?o00D=]@feo`0A^`07omc/g>cLo`0?^`03oh6100V100?o^k/0=;/3o`03
g_nk00Fk0olC^`03oe]K00AK0ol5^`07oaMO5elGo`09^`?o0X400on1P@0;P@03ok^k00>k00?o0000
0ol20003o`000180001800;o2P002?nkbk_;^l_o2h404?o;^l^kbk_;^l^kbk_;^ol6]@0;ol^kbk_;
^l^kbk/00_l05L^kbk_;ombgg;OLol^kbk_;^l^kb`04o`03^l_o00^10_l0Ek_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ooNLMiag_nkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02F`?o01Fkbooo^l^kbolO5alG7aOo^l^kbk/00ol6P@03oh6100^100Kobk_;
^l/2o`030?l0008000?o00004P0004X000?o00002002o`Fk00?oPH402H400onk^`0<^`03o`go00;o
2K/3o`03k=co00Fk0ol:^`;o1>`01?nk^ol6P@?o0h400onk^`0Z^`;o1K/00ooNgP03gP03ok^k01Zk
0_l2^`?o00=Ook/01;/00omOo`02o`>k1?l:P@03oh6100B11?l9^`03o`3o00<000?o00004P0004/0
00?o00002@001oo;^l^kbol01X43o`:103oobk_;^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_ok=c/g>cL
ol^kbk_;^l^kbk_;^l^kbk_;omc/g>cLk?nkbol00X43o`N102Wo^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`;N00Ko^l^kbk/3o`0b^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbolOGamO7oo;^l^kboo;^l/3o`:100?oPH402X400on1P@03o`08^l^kbk_;^l/3o`D0
00Co003o500004`000?o00002@000onk^`03^`03oh6100?o1X400onk^`0A^`?o1K/01ooLk=c/g?l0
4K/00oo/o`02o`Fk0_l;P@03ok^k02Bk00SoLMiagW7Nob>k0_l5^`03oemO00=O00?o^k/00k/3o`J1
00?oPH402X42o`Nk1?l90004o`00oa<0001=0003o`0000T000Kobk_;^l/2o`Z1013obk_;^l^kbk_;
^l^kbk_;0ol2g007ok_;^l^kb`03o`0Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbol<P@0P
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`07bk_;^l^ko`05gP0Pok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/3o`087onkbk_;^l/3o`04bk_;^`Co2X400on1P@04P@?o00S;^l^k
bk_;^`?o3P000ol0o`0C0000CP000ol000090003ok^k00>k00?oPH402H400onk^`0=^`03omcL00;L
00?o^k/08K/3o`:k00?oPH402X400onk^`0J^`;o00=ag_l01[/3ob6k00?oGel00el00onk^`05^`Go
0X400on1P@0:P@03oh6100?o1k/4oa4000?o0?l04`0004l00_l:0007ol^kbk_;o`0;P@0Aol^kbk_;
^l^kbk_;^l^kbol00]`08_oLok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`;/00Gobk_;
o`06P@?o0X407Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00GN02Cobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`06^l^kbk_o1Al00onko`04o`R100?oPH402X42o`07bk_;^l^k
b`03oaH00_lC0000D@000ol000080003ok^k00>k00?oPH402H42o`jk0_lS^`06okO/]nco0k/00on1
P@03o`J100?o^k/04K/3o`Fk00OogW7NLMko01nk0ol00eoo^`05^`?o00Bkoooo0X400on1P@09P@03
oh6100B10ol7^`Co6003oa<0001B0003o`0000P00_l01K_;^l_o00J10ol3P@0Dok_;^l^kbk_;^l^k
bk_;^l^kbk/2o`0Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02k006oncobk_;0_l:P@0@
ol^kbk_;^l^kbk_;^l^kb`?o00WNLOnkbk_;^l/00ol0;/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbolOGamO7oo;^l^kbk/3o`J100?oPH402H400on1P@03o`07^l^kbk_;^`03oaT00olF0000
D`000ol000090003ok^k00:k00?oPH400ol7P@03ok^k00jk0_l00iGLo`0N^`;o1[/00on1P@0:P@03
ok^k00bk00?og]h00mh00onk^`0P^`?o1K/02?mO7elOGonk1?l:P@03oh6100N100CoPOoo1[/4oaP0
1?lI0000E0000ol000090005ok_;^l/00_l;P@0iok_;^l^kbk_;^l^kbk_;ombEg9GLol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o00>koh402h401oo;^l^kbk/01?l0:L^kbk_oLMia
og7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o00TO5aoobk_;^l/00ol01<_oool2P@03
oh6100V100?oPH401843o`07bk_;^l^kb`03oaT00olM0000E@000ol000090003ok^k00>k00?oPH40
2H400onk^`0<^`07ombEg9GLo`0O^`?o00Fg]_nko`0:P@03oh7o00:k0ol4gP03ok^k00:k0olR^`07
oamO7elOo`05^`?o1X400on1P@09P@03oh6100?o1[/4oaP01?lP0000EP000ol000090007ok_;^l^k
o`0;P@;o00g;^l^kbk_;^l^kbk_;00?o02_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
][Nf]kJgok_o00J10ol0;l^kbk_;^ooOg]oNgmkobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00?o00_;^l^kbolO5aoo7`05o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000E`02o`X0
00?o^k/00k/00on1P@04P@?o0h400onk^`0`^`09okJg][Nfok_o00:10ol2^`?o1K/00ooNo`02ob2k
0ol37`03ok^k00>k1_l2P@03oh6100V100?oPH401843o`Jk1?lH00?o:00005T000?o000020001onk
bk_;^ol00X43o`N101;obk_;^l^kbk_;^l^kbk_;^l/4o`0M^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol01K_;^l^k00;o00?;^ol00_l0;W6ELOnkbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol67`05ol^kbk/00ol6P@03oh6100V100?oPH400ol01[_;^l^kb`?o6004ob/0
001J0003o`0000P000?o^k/00k/2o`^100?o^k/02k/3o`05UMbEg?l0:;/00ooMg@04g@03ok^k00Nk
0olE^`?o1K/00olOo`02o`>k0ol:P@03oh6100N100CoPOoo1K/4oaP00ol_0000F`000ol0000800;o
00K;^l^kbol;P@0fol^kbk_;^l^kbk_;^l_og9GLUMbEok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;1?l01[_;^l_oU@?o00?;^l/00ol00l^ko`02o`;N01?obk_;^l^kbk_;^l^kbk_;^l^k00?o
0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06bk_;^l^k0olH00Co<P0005`000?o0000
2@000onk^`03^`03oh6100V100?o^k/02k/00onEo`02ob2k0_l01IEaUG7o00Bk00Co^k^k0ol3P@09
ok^komoNgmko00^k0_l4^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk1?lH00?o=P0005d0
00?o00002@001oo;^l^kbol01X43o`:102cobk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`;o012kbk_;^omaUG6ELOnkbk_;0ol7P@04ol^ko`;N00_og_o;^l^kbk_;^`02o`09
gioo^l^kbolS00?o00?;^l/01?l:P@03oh6100B10ol02;_;^l^kbk_;0olH00Co>@0005h000?o0000
2@000onk^`03^`03oh6100?o1X400onk^`0?^`Co4[/3o`03UOnk00Fk0ol5^`;o2h400onk^`02o`Zk
00?ogml00ml00onk^`02^`04ok^k^`?o0X400on1P@0:P@03oh6100?o1k/4oaP00olm0000G`02o`X0
00Kobk_;^l/2o`Z100oobk_;^l^kbk_;^l^kbk/00_l05]bEg9Go^l^kbk_;^l^kbk_;^l^kbol5U@0@
ol^kbk_;^l^kbk_;^l^ko`b100Sobk_;^l^kb`;o012kbk_;^onOgioOWonkbk_;0ol6P@03oh6100Z1
0_l01k_;^l^kbk/00olH00Co@000064000?o000020000onk^`03^`03oh6100V100?o^k/02k/00onE
U@04U@03ok^k00Nk0ol5^`06omfEgIGo3[/00on1P@0:P@04ok^k^`?o00?Nok/01K/3o`>k1?l:P@03
oh6100B10ol7^`Co6003od@0001R0003o`0000P000Oobk_;^l_o00^10_l03[_;^l^kbk_;^l^kbooL
0ol02<^kbk_;^l^k0ol2U@07ol^kbk_;^`02o`0Cbk_;^l^kbk_;^l^kbk_;^l^ko`06P@?o0X404?nk
booOg]oNgoo;^l^kbk/5o`>100?oPH402H400on1P@03o`07bk_;^l^kb`03oaP01?m70000H`000ol0
000800;o1;/00on1P@04P@?o0h400onk^`0:^`03ok^k00Zk00KoUMbEg?lJ^`03oh6100?o1X401Onk
^k_o00CN00?o^ol00ol9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T000Ko^l^kbol2P@?o
1h404_nkbk_;^l^kbk_;^l^kbk_;^`?o00Jkbk_;^ol2U@0MoiGobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00_l:P@04ok_;^`;o00C;oooo0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0
001U0003o`0000T000?o^k/00[/2o`^100?o^k/02k/3o`04UMbEo`Fk0_lN^`03oh6100V100?o^k/0
0ol6P@03oh6100V100?oPH400ol5^`Co5`04oe80001V0003o`0000T000Oo^l^kbk_o00^103_o^l^k
bk_;^l^kbk_;^ooLUMbEg?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0;P@;o
2X400on1P@07P@08oh7ool^kbk/4oaP00omF0000I`02o`X000?o^k/00k/00on1P@09P@03ok^k00^k
00CoUOoo:;/00on1P@04P@?o0X400on1P@09P@04oh61P@Go1K/3oaP01?mI0000J@000ol000080007
ok_;^l^ko`06P@?o0X40>onkbk_;^l^kbk_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00:10ol6P@03oh6100V10ol01[_;^l^kb`Co6003oed0001Z0003o`0000P0
00?o^k/00k/00on1P@03o`J100?o^k/0=K/4o`Z100?oPH401843o`Nk0olH00CoH00006/000?o0000
2002o`04bk_;^`;o2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k1Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T000?o^k/0
0[/00on1P@09P@03ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T000Kobk_;
^ol;P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03oh6100V1
00?oPH401Ol01[_;^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03ok^k02>k
0ol6P@03oh6100V10_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL01?mb0000
L@000ol000080003ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o6003ogH0
001b0003o`0000P000Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V100?oPH40
2H42o`06^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o0X400on1
P@08P@03oh6100B10ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onkbk_;^l^k
bk_;^l^kb`03o`J100?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o00002@000onk
^`02^`;o2H400onk^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007ok_;^l^k
o`09P@07ok_;^l^kb`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P000?o0000
20000onk^`03^`03oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003o`0000P0
00Oo^l^kbk_o00N100CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol000080003
ok^k00>k00?oPH401?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P000Ko^l^k
bk/2o`V100?oPH402842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH4028400on1
P@05o`Jk0olG00CoV@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?oW@0007h0
0_l:0003ok^k00:k00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh400ol01[_;
^l^kb`Co5`03oj@000210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003o`0000P0
00Oobk_;^l^k00Co5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o00001`03oaL0
0onb0000Q@02o`L000?o00004`04okD000270003o`0000@000?o00004003okT000280003o`0000<0
00?o00003004ok`000290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0o`0400Co
a`0008`00_l0103oooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0003o05h0003o05h0002B0003o`0002L000?o0000WP0006d01?l300Co
00@0ool00_l200;o0`03o`@00_l40003o`0000P01Ol0103oo`02o`801Ol00`3oo`0300?o10000ol0
000700?o1005o`800ol300;o0`04o`800ol400;oK`0006`000Go0000o`020003o`0000<000Co003o
0`02o`@000?o00000P001?l00?l40003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003
o`0000@000?o00001`000ol000050003o`00008000Co003o0P02o`@000?o00000`000ol0000300;o
K`0006`000?o0?l00_l200Go00D0o`00o`090003o`00008000Co003o40001Ol0003o008000Co003o
0`000ol000060003o`0000h000?o00001@000ol000020003o`0000X000?o00000P000ol0001d0000
K0000ol000040007o`000?l0o`020003o`0000L000?o00000`02oa4000Go0000o`020004o`00o`<0
00?o00001P000ol0000>00?o1@000ol000020003o`0000/000Go0000o`1f0000K0001Ol0003o00<0
0ol00`3oo`03o`T000?o00000P001?l00?l@0003o`0000Go0`04o`P000?o00003P000ol0000400;o
0`04o`P000Co003o0`000ol0001d0000K@04oa@00_l500;o3`05o`/000?o00001@02o`l01Ol90003
o`0000T00_l300;oMP000:`00_lQ0003o`00008000?o0000QP000?l0GP000001\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 18"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 17",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 19",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 19", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.252232 1.528385 0.016538 0.959476 [
[(Gen.19, Ind.1, Fit.28.)] .5 1 0 -1.5 Msboxa
[(5)] .2211 .11397 .84498 1 Msboxa
[(10)] .37254 .07657 .79187 1 Msboxa
[(15)] .5289 .03796 .73876 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29763 .03347 .79718 1 Msboxa
P
[(5)] .71861 .07705 -1 .3804 Msboxa
[(10)] .79523 .14516 -1 .36673 Msboxa
[(15)] .8676 .20948 -1 .354 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87741 .11781 -1 .36805 Msboxa
P
[(0)] .09665 .16941 1 -0.38996 Msboxa
[(10)] .07657 .33599 1 -0.3624 Msboxa
[(20)] .05438 .52014 1 -0.33179 Msboxa
[(30)] .02972 .72478 1 -0.29761 Msboxa
[(t)] -0.02784 .47204 1 -0.34304 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.19, Ind.1, Fit.28.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11601 .15203 m
.6362 .02399 L
s
P
p
.002 w
.23343 .12313 m
.23959 .12771 L
s
P
[(5)] .2211 .11397 .84498 1 Mshowa
p
.002 w
.3844 .08597 m
.39033 .09067 L
s
P
[(10)] .37254 .07657 .79187 1 Mshowa
p
.002 w
.54025 .04761 m
.54593 .05243 L
s
P
[(15)] .5289 .03796 .73876 1 Mshowa
p
.001 w
.26324 .11579 m
.26691 .11855 L
s
P
p
.001 w
.29325 .10841 m
.29689 .11118 L
s
P
p
.001 w
.32344 .10097 m
.32706 .10377 L
s
P
p
.001 w
.35382 .09349 m
.35741 .0963 L
s
P
p
.001 w
.41517 .07839 m
.4187 .08123 L
s
P
p
.001 w
.44614 .07077 m
.44964 .07362 L
s
P
p
.001 w
.47731 .0631 m
.48078 .06596 L
s
P
p
.001 w
.50868 .05538 m
.51212 .05826 L
s
P
p
.001 w
.2038 .13042 m
.20752 .13316 L
s
P
p
.001 w
.17435 .13767 m
.1781 .14039 L
s
P
p
.001 w
.14509 .14488 m
.14887 .14758 L
s
P
p
.001 w
.57203 .03978 m
.5754 .04269 L
s
P
p
.001 w
.60401 .03191 m
.60735 .03483 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29763 .03347 .79718 1 Mshowa
P
P
p
p
.002 w
.6362 .02399 m
.89107 .25032 L
s
P
p
.002 w
.70075 .08131 m
.69183 .08344 L
s
P
[(5)] .71861 .07705 -1 .3804 Mshowa
p
.002 w
.7773 .14929 m
.76833 .15135 L
s
P
[(10)] .79523 .14516 -1 .36673 Mshowa
p
.002 w
.84959 .21349 m
.84058 .21549 L
s
P
[(15)] .8676 .20948 -1 .354 Mshowa
p
.001 w
.71642 .09523 m
.71106 .0965 L
s
P
p
.001 w
.7319 .10898 m
.72654 .11024 L
s
P
p
.001 w
.74721 .12257 m
.74184 .12382 L
s
P
p
.001 w
.76234 .136 m
.75696 .13725 L
s
P
p
.001 w
.79208 .16242 m
.7867 .16365 L
s
P
p
.001 w
.8067 .1754 m
.80131 .17662 L
s
P
p
.001 w
.82116 .18824 m
.81576 .18945 L
s
P
p
.001 w
.83545 .20093 m
.83005 .20214 L
s
P
p
.001 w
.6849 .06724 m
.67955 .06852 L
s
P
p
.001 w
.66886 .05299 m
.66352 .05429 L
s
P
p
.001 w
.65263 .03858 m
.64729 .03988 L
s
P
p
.001 w
.86357 .2259 m
.85816 .22709 L
s
P
p
.001 w
.87739 .23818 m
.87198 .23936 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87741 .11781 -1 .36805 Mshowa
P
P
p
p
.002 w
.11601 .15203 m
.03821 .80363 L
s
P
p
.002 w
.11445 .16505 m
.12335 .16287 L
s
P
[(0)] .09665 .16941 1 -0.38996 Mshowa
p
.002 w
.09453 .3319 m
.10351 .32986 L
s
P
[(10)] .07657 .33599 1 -0.3624 Mshowa
p
.002 w
.07251 .51636 m
.08157 .51447 L
s
P
[(20)] .05438 .52014 1 -0.33179 Mshowa
p
.002 w
.04803 .72136 m
.05719 .71965 L
s
P
[(30)] .02972 .72478 1 -0.29761 Mshowa
p
.001 w
.11062 .19714 m
.11597 .19584 L
s
P
p
.001 w
.10672 .22984 m
.11207 .22857 L
s
P
p
.001 w
.10273 .2632 m
.1081 .26194 L
s
P
p
.001 w
.09867 .29721 m
.10405 .29597 L
s
P
p
.001 w
.0903 .3673 m
.0957 .36609 L
s
P
p
.001 w
.08599 .40342 m
.0914 .40223 L
s
P
p
.001 w
.08159 .44029 m
.08701 .43912 L
s
P
p
.001 w
.0771 .47793 m
.08253 .47677 L
s
P
p
.001 w
.06782 .55561 m
.07327 .5545 L
s
P
p
.001 w
.06303 .59571 m
.0685 .59462 L
s
P
p
.001 w
.05814 .63668 m
.06361 .63561 L
s
P
p
.001 w
.05314 .67856 m
.05863 .67751 L
s
P
p
.001 w
.04281 .76513 m
.04831 .76413 L
s
P
[(t)] -0.02784 .47204 1 -0.34304 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11445 .16505 m
.40427 .36881 L
s
P
p
.4 g
.002 w
.09453 .3319 m
.39937 .52945 L
s
P
p
.4 g
.002 w
.07251 .51636 m
.39401 .70539 L
s
P
p
.4 g
.002 w
.04803 .72136 m
.38811 .89893 L
s
P
p
.4 g
.002 w
.18885 .20356 m
.12705 .8477 L
s
P
p
.4 g
.002 w
.27545 .26482 m
.23167 .89959 L
s
P
p
.4 g
.002 w
.35748 .32285 m
.32978 .94825 L
s
P
.002 w
.11601 .15203 m
.03821 .80363 L
s
.03821 .80363 m
.38576 .97601 L
s
.38576 .97601 m
.40465 .35621 L
s
.40465 .35621 m
.11601 .15203 L
s
.6362 .02399 m
.89107 .25032 L
s
.89107 .25032 m
.96179 .88735 L
s
.96179 .88735 m
.66225 .69244 L
s
.66225 .69244 m
.6362 .02399 L
s
.11601 .15203 m
.03821 .80363 L
s
.03821 .80363 m
.66225 .69244 L
s
.66225 .69244 m
.6362 .02399 L
s
.6362 .02399 m
.11601 .15203 L
s
p
.4 g
.51486 .33222 m
.51538 .95606 L
s
P
p
.4 g
.65621 .30145 m
.68239 .93036 L
s
P
p
.4 g
.8017 .26978 m
.85519 .90376 L
s
P
p
.4 g
.40427 .36881 m
.89249 .26315 L
s
P
p
.4 g
.39937 .52945 m
.91071 .42723 L
s
P
p
.4 g
.39401 .70539 m
.93075 .60781 L
s
P
p
.4 g
.38811 .89893 m
.95293 .80751 L
s
P
.40465 .35621 m
.89107 .25032 L
s
.89107 .25032 m
.96179 .88735 L
s
.96179 .88735 m
.38576 .97601 L
s
.38576 .97601 m
.40465 .35621 L
s
p
.4 g
.23343 .12313 m
.51486 .33222 L
s
P
p
.4 g
.3844 .08597 m
.65621 .30145 L
s
P
p
.4 g
.54025 .04761 m
.8017 .26978 L
s
P
p
.4 g
.18885 .20356 m
.70075 .08131 L
s
P
p
.4 g
.27545 .26482 m
.7773 .14929 L
s
P
p
.4 g
.35748 .32285 m
.84959 .21349 L
s
P
P
p
.002 w
.41019 .36035 m .41796 .36584 L .40427 .36881 L p
.4 g
F P
s
P
p
.002 w
.40427 .36881 m .39648 .36333 L .41019 .36035 L p
.4 g
F P
s
P
p
.002 w
.89249 .26315 m .40427 .36881 L .11445 .16505 L p
.9 g
F P
s
P
p
.002 w
.43168 .36287 m .41796 .36584 L p
.41019 .36035 L .4 g
F P
s
P
p
.002 w
.41019 .36035 m .39648 .36333 L .38865 .35783 L p
.4 g
F P
s
P
p
.002 w
.43774 .35437 m .44545 .35989 L .43168 .36287 L p
.4 g
F P
s
P
p
.002 w
.41019 .36035 m .43774 .35437 L p
.43168 .36287 L .4 g
F P
s
P
p
.002 w
.38865 .35783 m .38078 .35229 L p
.41019 .36035 L .4 g
F P
s
P
p
.002 w
.38078 .35229 m .39454 .34928 L .41019 .36035 L p
.4 g
F P
s
P
p
.002 w
.45926 .35691 m .44545 .35989 L p
.43774 .35437 L .4 g
F P
s
P
p
.002 w
.46544 .34836 m .4731 .35391 L .45926 .35691 L p
.4 g
F P
s
P
p
.002 w
.43774 .35437 m .46544 .34836 L p
.45926 .35691 L .4 g
F P
s
P
p
.002 w
.48698 .35091 m .4731 .35391 L p
.46544 .34836 L .4 g
F P
s
P
p
.002 w
.39454 .34928 m .38078 .35229 L .37287 .34673 L p
.4 g
F P
s
P
p
.002 w
.4933 .34231 m .50091 .34789 L .48698 .35091 L p
.4 g
F P
s
P
p
.002 w
.46544 .34836 m .4933 .34231 L p
.48698 .35091 L .4 g
F P
s
P
p
.002 w
.37287 .34673 m .36491 .34114 L p
.39454 .34928 L .4 g
F P
s
P
p
.002 w
.36491 .34114 m .37873 .3381 L .39454 .34928 L p
.4 g
F P
s
P
p
.002 w
.51487 .34487 m .50091 .34789 L p
.4933 .34231 L .4 g
F P
s
P
p
.002 w
.52132 .33622 m .52888 .34184 L .51487 .34487 L p
.4 g
F P
s
P
p
.002 w
.4933 .34231 m .52132 .33622 L p
.51487 .34487 L .4 g
F P
s
P
p
.002 w
.54292 .3388 m .52888 .34184 L p
.52132 .33622 L .4 g
F P
s
P
p
.002 w
.37873 .3381 m .36491 .34114 L .35692 .33552 L p
.4 g
F P
s
P
p
.002 w
.5495 .3301 m .55701 .33575 L .54292 .3388 L p
.4 g
F P
s
P
p
.002 w
.52132 .33622 m .5495 .3301 L p
.54292 .3388 L .4 g
F P
s
P
p
.002 w
.35692 .33552 m .34888 .32987 L p
.37873 .3381 L .4 g
F P
s
P
p
.002 w
.34888 .32987 m .36274 .32679 L .37873 .3381 L p
.4 g
F P
s
P
p
.002 w
.57113 .3327 m .55701 .33575 L p
.5495 .3301 L .4 g
F P
s
P
p
.002 w
.57784 .32395 m .5853 .32963 L .57113 .3327 L p
.4 g
F P
s
P
p
.002 w
.5495 .3301 m .57784 .32395 L p
.57113 .3327 L .4 g
F P
s
P
p
.002 w
.43438 .32585 m .40647 .33199 L .39059 .32062 L p
.8 g
F P
s
P
p
.002 w
.57784 .32395 m .5495 .3301 L .53437 .31871 L p
.4 g
F P
s
P
p
.002 w
.36274 .32679 m .34888 .32987 L .3408 .32419 L p
.4 g
F P
s
P
p
.002 w
.5995 .32656 m .5853 .32963 L p
.57784 .32395 L .4 g
F P
s
P
p
.002 w
.3408 .32419 m .33268 .31847 L p
.36274 .32679 L .4 g
F P
s
P
p
.002 w
.33268 .31847 m .34659 .31537 L .36274 .32679 L p
.4 g
F P
s
P
p
.002 w
.60635 .31776 m .61375 .32347 L .5995 .32656 L p
.4 g
F P
s
P
p
.002 w
.57784 .32395 m .60635 .31776 L p
.5995 .32656 L .4 g
F P
s
P
p
.002 w
.46245 .31967 m .43438 .32585 L .4186 .31441 L p
.8 g
F P
s
P
p
.002 w
.39059 .32062 m .4186 .31441 L .43438 .32585 L p
.8 g
F P
s
P
p
.002 w
.53437 .31871 m .56282 .31249 L .57784 .32395 L p
.4 g
F P
s
P
p
.002 w
.62804 .32038 m .61375 .32347 L p
.60635 .31776 L .4 g
F P
s
P
p
.002 w
.4186 .31441 m .39059 .32062 L .37454 .30913 L p
.8 g
F P
s
P
p
.002 w
.63503 .31153 m .64237 .31728 L .62804 .32038 L p
.4 g
F P
s
P
p
.002 w
.60635 .31776 m .63503 .31153 L p
.62804 .32038 L .4 g
F P
s
P
p
.002 w
.4186 .31441 m .44678 .30816 L .46245 .31967 L p
.8 g
F P
s
P
p
.002 w
.56282 .31249 m .53437 .31871 L .51907 .3072 L p
.4 g
F P
s
P
p
.002 w
.34659 .31537 m .33268 .31847 L .32451 .31273 L p
.4 g
F P
s
P
p
.002 w
.65674 .31417 m .64237 .31728 L p
.63503 .31153 L .4 g
F P
s
P
p
.002 w
.32451 .31273 m .3163 .30696 L p
.34659 .31537 L .4 g
F P
s
P
p
.002 w
.3163 .30696 m .33026 .30382 L .34659 .31537 L p
.4 g
F P
s
P
p
.002 w
.37454 .30913 m .40265 .30285 L .4186 .31441 L p
.8 g
F P
s
P
p
.002 w
.66387 .30527 m .67115 .31105 L .65674 .31417 L p
.4 g
F P
s
P
p
.002 w
.63503 .31153 m .66387 .30527 L p
.65674 .31417 L .4 g
F P
s
P
p
.002 w
.51907 .3072 m .49068 .31345 L .47511 .30188 L p
.8 g
F P
s
P
p
.002 w
.51907 .3072 m .54764 .30091 L .56282 .31249 L p
.4 g
F P
s
P
p
.002 w
.68561 .30792 m .67115 .31105 L p
.66387 .30527 L .4 g
F P
s
P
p
.002 w
.69288 .29897 m .70011 .30479 L .68561 .30792 L p
.4 g
F P
s
P
p
.002 w
.66387 .30527 m .69288 .29897 L p
.68561 .30792 L .4 g
F P
s
P
p
.002 w
.54764 .30091 m .51907 .3072 L .50362 .29556 L p
.8 g
F P
s
P
p
.002 w
.47511 .30188 m .50362 .29556 L .51907 .3072 L p
.8 g
F P
s
P
p
.002 w
.33026 .30382 m .3163 .30696 L .30804 .30115 L p
.4 g
F P
s
P
p
.002 w
.69288 .29897 m .66387 .30527 L .64918 .29361 L p
.8 g
F P
s
P
p
.002 w
.71465 .30164 m .70011 .30479 L p
.69288 .29897 L .4 g
F P
s
P
p
.002 w
.30804 .30115 m .29974 .29532 L p
.33026 .30382 L .4 g
F P
s
P
p
.002 w
.29974 .29532 m .31376 .29214 L .33026 .30382 L p
.4 g
F P
s
P
p
.002 w
.72206 .29263 m .72923 .29848 L .71465 .30164 L p
.4 g
F P
s
P
p
.002 w
.69288 .29897 m .72206 .29263 L p
.71465 .30164 L .4 g
F P
s
P
p
.002 w
.57636 .29459 m .54764 .30091 L .53229 .28921 L p
.8 g
F P
s
P
p
.002 w
.50362 .29556 m .53229 .28921 L .54764 .30091 L p
.8 g
F P
s
P
p
.002 w
.72206 .29263 m .69288 .29897 L .6783 .28724 L p
.8 g
F P
s
P
p
.002 w
.64918 .29361 m .6783 .28724 L .69288 .29897 L p
.8 g
F P
s
P
p
1 .018 0 r
.01 w
.64207 .30261 m
.67105 .29629 L
s
P
p
.002 w
.74385 .29532 m .72923 .29848 L p
.72206 .29263 L .4 g
F P
s
P
p
.002 w
.53229 .28921 m .50362 .29556 L .48799 .2838 L p
.4 g
F P
s
P
p
.002 w
.75141 .28626 m .75852 .29214 L .74385 .29532 L p
.4 g
F P
s
P
p
.002 w
.72206 .29263 m .75141 .28626 L p
.74385 .29532 L .4 g
F P
s
P
p
.002 w
.31376 .29214 m .29974 .29532 L .29139 .28945 L p
.4 g
F P
s
P
p
.002 w
.53229 .28921 m .56113 .28281 L .57636 .29459 L p
.8 g
F P
s
P
p
.002 w
.75141 .28626 m .72206 .29263 L .7076 .28084 L p
.8 g
F P
s
P
p
.002 w
.6783 .28724 m .7076 .28084 L .72206 .29263 L p
.8 g
F P
s
P
p
1 .036 0 r
.01 w
.67113 .29785 m
.70029 .2915 L
s
P
p
.002 w
.77323 .28896 m .75852 .29214 L p
.75141 .28626 L .4 g
F P
s
P
p
.002 w
.29139 .28945 m .283 .28355 L p
.31376 .29214 L .4 g
F P
s
P
p
.002 w
.283 .28355 m .29707 .28034 L .31376 .29214 L p
.4 g
F P
s
P
p
.002 w
.48799 .2838 m .51677 .27737 L .53229 .28921 L p
.4 g
F P
s
P
p
.002 w
.78093 .27985 m .78799 .28577 L .77323 .28896 L p
.4 g
F P
s
P
p
.002 w
.75141 .28626 m .78093 .27985 L p
.77323 .28896 L .4 g
F P
s
P
p
.002 w
.63433 .28183 m .60526 .28823 L .59013 .27638 L p
.8 g
F P
s
P
p
1 .054 0 r
.01 w
.70038 .29306 m
.72973 .28668 L
s
P
p
.002 w
.78093 .27985 m .75141 .28626 L .73706 .27439 L p
.8 g
F P
s
P
p
.002 w
.7076 .28084 m .73706 .27439 L .75141 .28626 L p
.8 g
F P
s
P
p
.002 w
.80278 .28257 m .78799 .28577 L p
.78093 .27985 L .4 g
F P
s
P
p
.002 w
.37024 .27935 m .34191 .28577 L .32533 .2739 L p
.8 g
F P
s
P
p
.002 w
.51677 .27737 m .48799 .2838 L .47219 .27191 L p
.4 g
F P
s
P
p
.002 w
.29707 .28034 m .283 .28355 L .27457 .27762 L p
.4 g
F P
s
P
p
.002 w
.81063 .2734 m .81762 .27935 L .80278 .28257 L p
.4 g
F P
s
P
p
.002 w
.78093 .27985 m .81063 .2734 L p
.80278 .28257 L .4 g
F P
s
P
p
1 .906 0 r
.01 w
.4103 .40086 m
.38181 .40693 L
s
P
p
.002 w
.66357 .27539 m .63433 .28183 L .61932 .26991 L p
.8 g
F P
s
P
p
.002 w
.59013 .27638 m .61932 .26991 L .63433 .28183 L p
.8 g
F P
s
P
p
1 .924 0 r
.01 w
.38175 .40855 m
.38175 .40855 L
s
P
p
1 .073 0 r
.01 w
.72983 .28824 m
.75936 .28182 L
s
P
p
.002 w
.27457 .27762 m .26609 .27166 L p
.29707 .28034 L .4 g
F P
s
P
p
.002 w
.26609 .27166 m .28021 .26841 L .29707 .28034 L p
.4 g
F P
s
P
p
1 .943 0 r
.01 w
.38169 .41017 m
.38169 .41017 L
s
P
p
.002 w
.81063 .2734 m .78093 .27985 L .76671 .26791 L p
.8 g
F P
s
P
p
.002 w
.73706 .27439 m .76671 .26791 L .78093 .27985 L p
.8 g
F P
s
P
p
.002 w
.83251 .27613 m .81762 .27935 L p
.81063 .2734 L .4 g
F P
s
P
p
.002 w
.39873 .2729 m .37024 .27935 L .35376 .26741 L p
.8 g
F P
s
P
p
.002 w
.32533 .2739 m .35376 .26741 L .37024 .27935 L p
.8 g
F P
s
P
p
1 .961 0 r
.01 w
.38163 .41179 m
.38163 .41179 L
s
P
p
.586 1 0 r
.01 w
.44145 .4688 m
.41282 .47468 L
s
P
p
1 .979 0 r
.01 w
.38157 .41341 m
.36515 .4022 L
s
P
p
.695 1 0 r
.01 w
.47037 .45298 m
.44164 .45891 L
s
P
p
.002 w
.47219 .27191 m .50108 .26541 L .51677 .27737 L p
.4 g
F P
s
P
p
.568 1 0 r
.01 w
.41277 .47633 m
.41277 .47633 L
s
P
p
.804 1 0 r
.01 w
.4993 .43715 m
.47048 .44313 L
s
P
p
.677 1 0 r
.01 w
.44161 .46055 m
.44161 .46055 L
s
P
p
1 .888 0 r
.01 w
.43899 .39314 m
.41035 .39924 L
s
P
p
.55 1 0 r
.01 w
.41273 .47798 m
.41273 .47798 L
s
P
p
.785 1 0 r
.01 w
.47046 .44477 m
.47046 .44477 L
s
P
p
.002 w
.8405 .26691 m .84744 .2729 L .83251 .27613 L p
.4 g
F P
s
P
p
.002 w
.81063 .2734 m .8405 .26691 L p
.83251 .27613 L .4 g
F P
s
P
p
.659 1 0 r
.01 w
.44158 .4622 m
.44158 .4622 L
s
P
p
.002 w
.69298 .26891 m .66357 .27539 L .64867 .2634 L p
.8 g
F P
s
P
p
.002 w
.61932 .26991 m .64867 .2634 L .66357 .27539 L p
.8 g
F P
s
P
p
.532 1 0 r
.01 w
.41268 .47964 m
.41268 .47964 L
s
P
p
.767 1 0 r
.01 w
.47044 .44641 m
.47044 .44641 L
s
P
p
.64 1 0 r
.01 w
.44155 .46385 m
.44155 .46385 L
s
P
p
.876 1 0 r
.01 w
.48352 .41947 m
.49932 .43061 L
s
P
p
.514 1 0 r
.01 w
.41264 .48129 m
.39636 .47043 L
s
P
p
.749 1 0 r
.01 w
.47043 .44805 m
.47043 .44805 L
s
P
p
.622 1 0 r
.01 w
.44152 .4655 m
.44152 .4655 L
s
P
p
.858 1 0 r
.01 w
.49932 .43224 m
.49932 .43224 L
s
P
p
.002 w
.76671 .26791 m .79653 .26139 L .81063 .2734 L p
.8 g
F P
s
P
p
.731 1 0 r
.01 w
.47041 .44969 m
.47041 .44969 L
s
P
p
1 .091 0 r
.01 w
.75948 .28339 m
.7892 .27693 L
s
P
p
.002 w
.86241 .26966 m .84744 .2729 L p
.8405 .26691 L .4 g
F P
s
P
p
.002 w
.35376 .26741 m .38236 .26089 L .39873 .2729 L p
.8 g
F P
s
P
p
.604 1 0 r
.01 w
.44148 .46715 m
.44148 .46715 L
s
P
p
.84 1 0 r
.01 w
.49931 .43388 m
.49931 .43388 L
s
P
p
.713 1 0 r
.01 w
.47039 .45134 m
.47039 .45134 L
s
P
p
.002 w
.50108 .26541 m .47219 .27191 L .45622 .25988 L p
.4 g
F P
s
P
p
.822 1 0 r
.01 w
.49931 .43552 m
.49931 .43552 L
s
P
p
.002 w
.28021 .26841 m .26609 .27166 L .25756 .26566 L p
.4 g
F P
s
P
p
1 .87 0 r
.01 w
.46783 .38538 m
.43903 .39152 L
s
P
p
.002 w
.87056 .26039 m .87743 .26641 L .86241 .26966 L p
.4 g
F P
s
P
p
.002 w
.8405 .26691 m .87056 .26039 L p
.86241 .26966 L .4 g
F P
s
P
p
.002 w
.72256 .2624 m .69298 .26891 L .6782 .25686 L p
.8 g
F P
s
P
p
.002 w
.64867 .2634 m .6782 .25686 L .69298 .26891 L p
.8 g
F P
s
P
p
.002 w
.25756 .26566 m .24898 .25963 L p
.28021 .26841 L .4 g
F P
s
P
p
.002 w
.24898 .25963 m .26315 .25635 L .28021 .26841 L p
.4 g
F P
s
P
p
.002 w
.79653 .26139 m .76671 .26791 L .75233 .25585 L p
.8 g
F P
s
P
p
.002 w
.89249 .26315 m .87743 .26641 L p
.87056 .26039 L .4 g
F P
s
P
p
1 .852 0 r
.01 w
.49681 .37758 m
.46785 .38376 L
s
P
p
1 .109 0 r
.01 w
.78933 .2785 m
.78933 .2785 L
s
P
p
.002 w
.45622 .25988 m .48522 .25332 L .50108 .26541 L p
.4 g
F P
s
P
p
1 .997 0 r
.01 w
.36509 .40383 m
.36509 .40383 L
s
P
p
1 .127 0 r
.01 w
.78945 .28007 m
.78945 .28007 L
s
P
p
.985 1 0 r
.01 w
.36502 .40546 m
.39369 .39933 L
s
P
p
.894 1 0 r
.01 w
.46756 .40657 m
.48353 .41783 L
s
P
p
1 .145 0 r
.01 w
.78958 .28164 m
.78958 .28164 L
s
P
p
.002 w
.87056 .26039 m .88565 .25711 L .89249 .26315 L p
.4 g
F P
s
P
p
.002 w
.11445 .16505 m .63672 .0372 L .89249 .26315 L p
.9 g
F P
s
P
p
1 .163 0 r
.01 w
.78971 .28322 m
.78971 .28322 L
s
P
p
.002 w
.6782 .25686 m .7079 .25027 L .72256 .2624 L p
.8 g
F P
s
P
p
1 .181 0 r
.01 w
.77554 .27279 m
.78984 .28479 L
s
P
p
.002 w
.75233 .25585 m .78227 .24926 L .79653 .26139 L p
.8 g
F P
s
P
p
.495 1 0 r
.01 w
.3963 .47209 m
.3963 .47209 L
s
P
p
.002 w
.41113 .25433 m .38236 .26089 L .36582 .24875 L p
.8 g
F P
s
P
p
.002 w
.88565 .25711 m .87056 .26039 L p
.8567 .24824 L .4 g
F P
s
P
p
.477 1 0 r
.01 w
.39625 .47376 m
.39625 .47376 L
s
P
p
1 .834 0 r
.01 w
.52594 .36973 m
.49682 .37595 L
s
P
p
.002 w
.48522 .25332 m .45622 .25988 L .44007 .24773 L p
.4 g
F P
s
P
p
.002 w
.26315 .25635 m .24898 .25963 L .24036 .25357 L p
.4 g
F P
s
P
p
.459 1 0 r
.01 w
.3962 .47542 m
.3962 .47542 L
s
P
p
.441 1 0 r
.01 w
.39615 .47709 m
.39615 .47709 L
s
P
p
.423 1 0 r
.01 w
.39609 .47876 m
.39609 .47876 L
s
P
p
.002 w
.87877 .25103 m .88565 .25711 L p
.8567 .24824 L .4 g
F P
s
P
p
.002 w
.7079 .25027 m .6782 .25686 L .66326 .24467 L p
.8 g
F P
s
P
p
.967 1 0 r
.01 w
.39364 .40097 m
.4225 .39481 L
s
P
p
.002 w
.24036 .25357 m .23169 .24747 L p
.26315 .25635 L .4 g
F P
s
P
p
.002 w
.23169 .24747 m .24591 .24416 L .26315 .25635 L p
.4 g
F P
s
P
p
.405 1 0 r
.01 w
.39604 .48043 m
.37953 .46947 L
s
P
p
.002 w
.78227 .24926 m .75233 .25585 L .73779 .24365 L p
.8 g
F P
s
P
p
1 .816 0 r
.01 w
.52593 .36811 m
.55521 .36185 L
s
P
p
.002 w
.36582 .24875 m .39469 .24211 L .41113 .25433 L p
.8 g
F P
s
P
p
.002 w
.44007 .24773 m .46919 .24109 L .48522 .25332 L p
.4 g
F P
s
P
p
.912 1 0 r
.01 w
.45145 .39354 m
.46758 .40493 L
s
P
p
.002 w
.8567 .24824 m .87186 .24492 L .87877 .25103 L p
.4 g
F P
s
P
p
.002 w
.66326 .24467 m .69308 .23801 L .7079 .25027 L p
.8 g
F P
s
P
p
.002 w
.73779 .24365 m .76785 .23698 L .78227 .24926 L p
.8 g
F P
s
P
p
.949 1 0 r
.01 w
.42246 .39645 m
.4515 .39026 L
s
P
p
1 .798 0 r
.01 w
.55519 .36023 m
.58463 .35393 L
s
P
p
.002 w
.39469 .24211 m .36582 .24875 L .34908 .23647 L p
.8 g
F P
s
P
p
1 .199 0 r
.01 w
.7612 .26223 m
.77566 .27437 L
s
P
p
.002 w
.87186 .24492 m .8567 .24824 L p
.84269 .23595 L .4 g
F P
s
P
p
.002 w
.46919 .24109 m .44007 .24773 L .42375 .23544 L p
.4 g
F P
s
P
p
.002 w
.24591 .24416 m .23169 .24747 L .22297 .24134 L p
.4 g
F P
s
P
p
.002 w
.8649 .23878 m .87186 .24492 L p
.84269 .23595 L .4 g
F P
s
P
p
.002 w
.69308 .23801 m .66326 .24467 L .64815 .23234 L p
.8 g
F P
s
P
p
.002 w
.22297 .24134 m .2142 .23518 L p
.24591 .24416 L .4 g
F P
s
P
p
.002 w
.2142 .23518 m .22848 .23183 L .24591 .24416 L p
.4 g
F P
s
P
p
.002 w
.76785 .23698 m .73779 .24365 L .72309 .23131 L p
.8 g
F P
s
P
p
1 .779 0 r
.01 w
.5846 .35231 m
.61421 .34597 L
s
P
p
.387 1 0 r
.01 w
.37947 .47115 m
.37947 .47115 L
s
P
p
.002 w
.34908 .23647 m .37807 .22976 L .39469 .24211 L p
.8 g
F P
s
P
p
.369 1 0 r
.01 w
.37941 .47282 m
.40842 .46684 L
s
P
p
.931 1 0 r
.01 w
.45147 .3919 m
.45147 .3919 L
s
P
p
.002 w
.42375 .23544 m .45297 .22872 L .46919 .24109 L p
.4 g
F P
s
P
p
.002 w
.64815 .23234 m .61838 .23904 L .60298 .22665 L p
.4 g
F P
s
P
p
.002 w
.84269 .23595 m .85791 .2326 L .8649 .23878 L p
.4 g
F P
s
P
p
.002 w
.64815 .23234 m .67809 .22561 L .69308 .23801 L p
.8 g
F P
s
P
p
1 .761 0 r
.01 w
.61416 .34435 m
.64393 .33797 L
s
P
p
.002 w
.7981 .23028 m .76785 .23698 L .75327 .22457 L p
.8 g
F P
s
P
p
.002 w
.72309 .23131 m .75327 .22457 L .76785 .23698 L p
.8 g
F P
s
P
p
.002 w
.85791 .2326 m .84269 .23595 L p
.82852 .22353 L .4 g
F P
s
P
p
.002 w
.45297 .22872 m .42375 .23544 L .40724 .22301 L p
.4 g
F P
s
P
p
1 .218 0 r
.01 w
.74669 .25154 m
.76132 .26381 L
s
P
p
.002 w
.22848 .23183 m .2142 .23518 L .20539 .22898 L p
.4 g
F P
s
P
p
.35 1 0 r
.01 w
.40837 .46852 m
.43757 .46251 L
s
P
p
.002 w
.60298 .22665 m .57328 .23338 L .55759 .22093 L p
.8 g
F P
s
P
p
.002 w
.85088 .22639 m .85791 .2326 L p
.82852 .22353 L .4 g
F P
s
P
p
.002 w
.60298 .22665 m .63287 .21988 L .64815 .23234 L p
.4 g
F P
s
P
p
.002 w
.67809 .22561 m .64815 .23234 L .63287 .21988 L p
.8 g
F P
s
P
p
1 .743 0 r
.01 w
.64387 .33635 m
.67381 .32993 L
s
P
p
.002 w
.20539 .22898 m .19652 .22275 L p
.22848 .23183 L .4 g
F P
s
P
p
.002 w
.19652 .22275 m .21085 .21936 L .22848 .23183 L p
.4 g
F P
s
P
p
.002 w
.82852 .22353 m .7981 .23028 L .78364 .21779 L p
.8 g
F P
s
P
p
.002 w
.75327 .22457 m .78364 .21779 L .7981 .23028 L p
.8 g
F P
s
P
p
.002 w
.48238 .22197 m .45297 .22872 L .43658 .21622 L p
.4 g
F P
s
P
p
.002 w
.40724 .22301 m .43658 .21622 L .45297 .22872 L p
.4 g
F P
s
P
p
.002 w
.63287 .21988 m .60298 .22665 L .58741 .21412 L p
.4 g
F P
s
P
p
.002 w
.55759 .22093 m .58741 .21412 L .60298 .22665 L p
.8 g
F P
s
P
p
.332 1 0 r
.01 w
.43753 .46419 m
.46692 .45814 L
s
P
p
1 .725 0 r
.01 w
.67373 .32831 m
.70383 .32184 L
s
P
p
.002 w
.82852 .22353 m .8438 .22014 L .85088 .22639 L p
.4 g
F P
s
P
p
.002 w
.70822 .21884 m .67809 .22561 L .66294 .21307 L p
.8 g
F P
s
P
p
.002 w
.63287 .21988 m .66294 .21307 L .67809 .22561 L p
.8 g
F P
s
P
p
.002 w
.8438 .22014 m .82852 .22353 L p
.8142 .21097 L .4 g
F P
s
P
p
.002 w
.78364 .21779 m .8142 .21097 L .82852 .22353 L p
.8 g
F P
s
P
p
.002 w
.43658 .21622 m .40724 .22301 L .39054 .21044 L p
.4 g
F P
s
P
p
.002 w
.21085 .21936 m .19652 .22275 L .18761 .21648 L p
.4 g
F P
s
P
p
.002 w
.43658 .21622 m .4661 .20939 L .48238 .22197 L p
.4 g
F P
s
P
p
1 .236 0 r
.01 w
.732 .24073 m
.7468 .25313 L
s
P
p
1 .689 0 r
.01 w
.68862 .30656 m
.70365 .3186 L
s
P
p
1 .707 0 r
.01 w
.70374 .32022 m
.70374 .32022 L
s
P
p
.002 w
.83669 .21386 m .8438 .22014 L p
.8142 .21097 L .4 g
F P
s
P
p
.002 w
.58741 .21412 m .61742 .20728 L .63287 .21988 L p
.4 g
F P
s
P
p
1 .508 0 r
.01 w
.68779 .29039 m
.71803 .2838 L
s
P
p
.002 w
.18761 .21648 m .17864 .21018 L p
.21085 .21936 L .4 g
F P
s
P
p
.002 w
.17864 .21018 m .19303 .20675 L .21085 .21936 L p
.4 g
F P
s
P
p
.002 w
.73853 .21202 m .70822 .21884 L .69319 .20622 L p
.8 g
F P
s
P
p
.002 w
.66294 .21307 m .69319 .20622 L .70822 .21884 L p
.8 g
F P
s
P
p
.314 1 0 r
.01 w
.4669 .45983 m
.49648 .45375 L
s
P
p
1 .526 0 r
.01 w
.68787 .292 m
.68787 .292 L
s
P
p
0 1 .048 r
.01 w
.40731 .5059 m
.37799 .51182 L
s
P
p
.002 w
.8142 .21097 m .78364 .21779 L .76903 .20517 L p
.8 g
F P
s
P
p
1 .544 0 r
.01 w
.6728 .28141 m
.68796 .29361 L
s
P
p
0 1 .066 r
.01 w
.37793 .51354 m
.37793 .51354 L
s
P
p
.002 w
.4661 .20939 m .43658 .21622 L .42 .20358 L p
.4 g
F P
s
P
p
.002 w
.39054 .21044 m .42 .20358 L .43658 .21622 L p
.4 g
F P
s
P
p
0 1 .085 r
.01 w
.37786 .51526 m
.37786 .51526 L
s
P
p
0 1 .103 r
.01 w
.3778 .51697 m
.3778 .51697 L
s
P
p
.002 w
.61742 .20728 m .58741 .21412 L .57167 .20146 L p
.4 g
F P
s
P
p
0 1 .556 r
.01 w
.43937 .57604 m
.4099 .58176 L
s
P
p
0 1 .121 r
.01 w
.37774 .51869 m
.36081 .50774 L
s
P
p
1 .489 0 r
.01 w
.71793 .28219 m
.74834 .27555 L
s
P
p
.002 w
.8142 .21097 m .82954 .20754 L .83669 .21386 L p
.4 g
F P
s
P
p
0 1 .447 r
.01 w
.46914 .55978 m
.43957 .56555 L
s
P
p
0 1 .574 r
.01 w
.40985 .58351 m
.40985 .58351 L
s
P
p
0 1 .338 r
.01 w
.49893 .54351 m
.46926 .54933 L
s
P
p
0 1 .465 r
.01 w
.43954 .56729 m
.43954 .56729 L
s
P
p
0 1 .03 r
.01 w
.43684 .49822 m
.40735 .50418 L
s
P
p
.002 w
.76903 .20517 m .73853 .21202 L .72362 .19933 L p
.8 g
F P
s
P
p
.002 w
.69319 .20622 m .72362 .19933 L .73853 .21202 L p
.8 g
F P
s
P
p
0 1 .592 r
.01 w
.40981 .58526 m
.40981 .58526 L
s
P
p
0 1 .356 r
.01 w
.46924 .55107 m
.46924 .55107 L
s
P
p
.002 w
.34427 .20464 m .31506 .2115 L .29776 .1988 L p
.8 g
F P
s
P
p
0 1 .483 r
.01 w
.43951 .56904 m
.43951 .56904 L
s
P
p
.002 w
.82954 .20754 m .8142 .21097 L p
.79971 .19827 L .4 g
F P
s
P
p
.002 w
.76903 .20517 m .79971 .19827 L .8142 .21097 L p
.8 g
F P
s
P
p
0 1 .61 r
.01 w
.40976 .58702 m
.40976 .58702 L
s
P
p
0 1 .375 r
.01 w
.46922 .55281 m
.46922 .55281 L
s
P
p
.296 1 0 r
.01 w
.49648 .45544 m
.52625 .44932 L
s
P
p
0 1 .502 r
.01 w
.43947 .57079 m
.43947 .57079 L
s
P
p
0 1 .266 r
.01 w
.48268 .5257 m
.49895 .53657 L
s
P
p
1 .671 0 r
.01 w
.67333 .29276 m
.68853 .30494 L
s
P
p
.002 w
.19303 .20675 m .17864 .21018 L .16963 .20384 L p
.4 g
F P
s
P
p
0 1 .628 r
.01 w
.40971 .58877 m
.39293 .5782 L
s
P
p
0 1 .393 r
.01 w
.4692 .55455 m
.4692 .55455 L
s
P
p
.002 w
.42 .20358 m .44963 .19667 L .4661 .20939 L p
.4 g
F P
s
P
p
0 1 .52 r
.01 w
.43944 .57253 m
.43944 .57253 L
s
P
p
0 1 .284 r
.01 w
.49894 .5383 m
.49894 .5383 L
s
P
p
0 1 .411 r
.01 w
.46918 .55629 m
.46918 .55629 L
s
P
p
0 1 .538 r
.01 w
.43941 .57428 m
.43941 .57428 L
s
P
p
0 1 .302 r
.01 w
.49894 .54003 m
.49894 .54003 L
s
P
p
1 .471 0 r
.01 w
.74823 .27394 m
.77881 .26726 L
s
P
p
1 .254 0 r
.01 w
.71714 .22978 m
.73211 .24232 L
s
P
p
0 1 .429 r
.01 w
.46916 .55803 m
.46916 .55803 L
s
P
p
.002 w
.82235 .20119 m .82954 .20754 L p
.79971 .19827 L .4 g
F P
s
P
p
.002 w
.57167 .20146 m .6018 .19454 L .61742 .20728 L p
.4 g
F P
s
P
p
0 1 .32 r
.01 w
.49893 .54177 m
.49893 .54177 L
s
P
p
.002 w
.16963 .20384 m .16056 .19747 L p
.19303 .20675 L .4 g
F P
s
P
p
.002 w
.16056 .19747 m .175 .194 L .19303 .20675 L p
.4 g
F P
s
P
p
0 1 .012 r
.01 w
.46652 .4905 m
.43687 .4965 L
s
P
p
.002 w
.79971 .19827 m .76903 .20517 L .75425 .1924 L p
.8 g
F P
s
P
p
.002 w
.72362 .19933 m .75425 .1924 L .76903 .20517 L p
.8 g
F P
s
P
p
.002 w
.29776 .1988 m .32708 .19186 L .34427 .20464 L p
.8 g
F P
s
P
p
1 .562 0 r
.01 w
.65754 .27069 m
.67288 .28303 L
s
P
p
.278 1 0 r
.01 w
.52626 .45102 m
.55623 .44486 L
s
P
p
.002 w
.52568 .1956 m .4958 .20252 L .47945 .18972 L p
.8 g
F P
s
P
p
1 .453 0 r
.01 w
.77868 .26565 m
.80944 .25892 L
s
P
p
.002 w
.6018 .19454 m .57167 .20146 L .55574 .18865 L p
.4 g
F P
s
P
p
.002 w
.79971 .19827 m .81512 .1948 L .82235 .20119 L p
.4 g
F P
s
P
p
.006 1 0 r
.01 w
.49636 .48273 m
.46654 .48878 L
s
P
p
0 1 .139 r
.01 w
.36074 .50947 m
.36074 .50947 L
s
P
p
0 1 .157 r
.01 w
.36067 .51119 m
.39018 .50521 L
s
P
p
.002 w
.32708 .19186 m .29776 .1988 L .28026 .18596 L p
.8 g
F P
s
P
p
0 1 .248 r
.01 w
.46624 .51297 m
.48269 .52396 L
s
P
p
1 .653 0 r
.01 w
.65789 .27882 m
.67325 .29114 L
s
P
p
.002 w
.81512 .1948 m .79971 .19827 L p
.78506 .18542 L .4 g
F P
s
P
p
.002 w
.75425 .1924 m .78506 .18542 L .79971 .19827 L p
.8 g
F P
s
P
p
.002 w
.40323 .19079 m .37366 .19773 L .35659 .18488 L p
.4 g
F P
s
P
p
.002 w
.175 .194 m .16056 .19747 L .15144 .19106 L p
.4 g
F P
s
P
p
1 .417 0 r
.01 w
.79455 .24318 m
.80916 .2557 L
s
P
p
1 .435 0 r
.01 w
.8093 .25731 m
.8093 .25731 L
s
P
p
0 1 .647 r
.01 w
.39287 .57996 m
.39287 .57996 L
s
P
p
.002 w
.47945 .18972 m .50945 .18273 L .52568 .1956 L p
.8 g
F P
s
P
p
0 1 .665 r
.01 w
.39282 .58172 m
.39282 .58172 L
s
P
p
.024 1 0 r
.01 w
.52635 .47493 m
.49637 .48102 L
s
P
p
.26 1 0 r
.01 w
.55625 .44657 m
.58642 .44038 L
s
P
p
.002 w
.80785 .18838 m .81512 .1948 L p
.78506 .18542 L .4 g
F P
s
P
p
.002 w
.63211 .18757 m .6018 .19454 L .58599 .18165 L p
.4 g
F P
s
P
p
.002 w
.55574 .18865 m .58599 .18165 L .6018 .19454 L p
.4 g
F P
s
P
p
1 .272 0 r
.01 w
.71723 .23138 m
.71723 .23138 L
s
P
p
.002 w
.15144 .19106 m .14227 .18461 L p
.175 .194 L .4 g
F P
s
P
p
.002 w
.14227 .18461 m .15677 .18111 L .175 .194 L p
.4 g
F P
s
P
p
0 1 .683 r
.01 w
.39276 .58349 m
.39276 .58349 L
s
P
p
1 .29 0 r
.01 w
.71733 .23298 m
.74802 .22613 L
s
P
p
0 1 .701 r
.01 w
.39271 .58525 m
.39271 .58525 L
s
P
p
.002 w
.28026 .18596 m .3097 .17894 L .32708 .19186 L p
.8 g
F P
s
P
p
0 1 .719 r
.01 w
.39265 .58702 m
.39265 .58702 L
s
P
p
0 1 .175 r
.01 w
.39012 .50695 m
.41983 .50093 L
s
P
p
.002 w
.43298 .1838 m .40323 .19079 L .38627 .17786 L p
.4 g
F P
s
P
p
.002 w
.35659 .18488 m .38627 .17786 L .40323 .19079 L p
.4 g
F P
s
P
p
0 1 .737 r
.01 w
.39259 .58879 m
.37557 .57813 L
s
P
p
1 .58 0 r
.01 w
.6421 .25984 m
.65761 .27232 L
s
P
p
.042 1 0 r
.01 w
.5565 .46709 m
.52634 .47321 L
s
P
p
.002 w
.78506 .18542 m .80053 .18192 L .80785 .18838 L p
.4 g
F P
s
P
p
.002 w
.66261 .18056 m .63211 .18757 L .61643 .1746 L p
.4 g
F P
s
P
p
.002 w
.58599 .18165 m .61643 .1746 L .63211 .18757 L p
.4 g
F P
s
P
p
0 1 .23 r
.01 w
.44963 .5001 m
.46626 .51123 L
s
P
p
.242 1 0 r
.01 w
.58645 .44208 m
.61682 .43586 L
s
P
p
1 .634 0 r
.01 w
.64228 .26473 m
.65782 .27719 L
s
P
p
1 .399 0 r
.01 w
.77965 .22889 m
.79442 .24157 L
s
P
p
.002 w
.80053 .18192 m .78506 .18542 L p
.77024 .17243 L .4 g
F P
s
P
p
1 .308 0 r
.01 w
.74813 .22773 m
.77902 .22084 L
s
P
p
.002 w
.38627 .17786 m .35659 .18488 L .33932 .17188 L p
.4 g
F P
s
P
p
.002 w
.15677 .18111 m .14227 .18461 L .13305 .17813 L p
.4 g
F P
s
P
p
.002 w
.38627 .17786 m .41614 .17079 L .43298 .1838 L p
.4 g
F P
s
P
p
0 1 .193 r
.01 w
.41979 .50267 m
.44969 .49662 L
s
P
p
.06 1 0 r
.01 w
.58681 .45921 m
.55648 .46537 L
s
P
p
.002 w
.79318 .17542 m .80053 .18192 L p
.77024 .17243 L .4 g
F P
s
P
p
.002 w
.13305 .17813 m .12378 .17161 L p
.15677 .18111 L .4 g
F P
s
P
p
.002 w
.12378 .17161 m .13832 .16806 L .15677 .18111 L p
.4 g
F P
s
P
p
.002 w
.6933 .17351 m .66261 .18056 L .64706 .16752 L p
.4 g
F P
s
P
p
.002 w
.61643 .1746 m .64706 .16752 L .66261 .18056 L p
.4 g
F P
s
P
p
.224 1 0 r
.01 w
.61687 .43756 m
.64745 .4313 L
s
P
p
.002 w
.41614 .17079 m .38627 .17786 L .36912 .16478 L p
.4 g
F P
s
P
p
.002 w
.33932 .17188 m .36912 .16478 L .38627 .17786 L p
.4 g
F P
s
P
p
.079 1 0 r
.01 w
.61727 .45129 m
.58677 .45749 L
s
P
p
1 .326 0 r
.01 w
.77915 .22245 m
.77915 .22245 L
s
P
p
0 1 .755 r
.01 w
.37551 .5799 m
.37551 .5799 L
s
P
p
1 .598 0 r
.01 w
.64216 .26147 m
.64216 .26147 L
s
P
p
1 .344 0 r
.01 w
.77927 .22406 m
.77927 .22406 L
s
P
p
.002 w
.57001 .16861 m .53964 .17569 L .52335 .16258 L p
.8 g
F P
s
P
p
0 1 .773 r
.01 w
.37544 .58168 m
.40531 .57586 L
s
P
p
.002 w
.77024 .17243 m .78578 .16888 L .79318 .17542 L p
.4 g
F P
s
P
p
0 1 .211 r
.01 w
.44966 .49836 m
.44966 .49836 L
s
P
p
1 .363 0 r
.01 w
.7794 .22567 m
.7794 .22567 L
s
P
p
1 .616 0 r
.01 w
.64222 .2631 m
.64222 .2631 L
s
P
p
1 .381 0 r
.01 w
.77953 .22728 m
.77953 .22728 L
s
P
p
.002 w
.64706 .16752 m .67787 .16038 L .6933 .17351 L p
.4 g
F P
s
P
p
.002 w
.78578 .16888 m .77024 .17243 L p
.75525 .15928 L .4 g
F P
s
P
p
.002 w
.13832 .16806 m .12378 .17161 L .11445 .16505 L p
.4 g
F P
s
P
p
.097 1 0 r
.01 w
.6479 .44332 m
.61722 .44956 L
s
P
p
.002 w
.4462 .16368 m .41614 .17079 L .39911 .15763 L p
.4 g
F P
s
P
p
.002 w
.36912 .16478 m .39911 .15763 L .41614 .17079 L p
.4 g
F P
s
P
p
.205 1 0 r
.01 w
.64751 .43301 m
.67829 .42672 L
s
P
p
.002 w
.77834 .16231 m .78578 .16888 L p
.75525 .15928 L .4 g
F P
s
P
p
.002 w
.52335 .16258 m .55385 .15542 L .57001 .16861 L p
.8 g
F P
s
P
p
.002 w
.12902 .16148 m .14364 .15791 L p
.13832 .16806 L .4 g
F P
s
P
p
.002 w
.16755 .16093 m .13832 .16806 L p
.14364 .15791 L .4 g
F P
s
P
p
.002 w
.11445 .16505 m .12902 .16148 L .13832 .16806 L p
.4 g
F P
s
P
p
.002 w
.67787 .16038 m .64706 .16752 L .63133 .15432 L p
.4 g
F P
s
P
p
0 1 .792 r
.01 w
.40526 .57764 m
.43533 .57179 L
s
P
p
.002 w
.32185 .15873 m .29211 .16587 L .27433 .15265 L p
.8 g
F P
s
P
p
.115 1 0 r
.01 w
.67869 .43531 m
.64783 .4416 L
s
P
p
.002 w
.47644 .15653 m .4462 .16368 L .42928 .15044 L p
.4 g
F P
s
P
p
.002 w
.39911 .15763 m .42928 .15044 L .4462 .16368 L p
.4 g
F P
s
P
p
.187 1 0 r
.01 w
.67837 .42843 m
.70935 .4221 L
s
P
p
.002 w
.75525 .15928 m .77085 .1557 L .77834 .16231 L p
.4 g
F P
s
P
p
.002 w
.15831 .15432 m .17302 .15071 L p
.16755 .16093 L .4 g
F P
s
P
p
.002 w
.19696 .15376 m .16755 .16093 L p
.17302 .15071 L .4 g
F P
s
P
p
.002 w
.14364 .15791 m .15831 .15432 L .16755 .16093 L p
.4 g
F P
s
P
p
.002 w
.63133 .15432 m .66227 .1471 L .67787 .16038 L p
.4 g
F P
s
P
p
.002 w
.77085 .1557 m .75525 .15928 L p
.74008 .14599 L .4 g
F P
s
P
p
0 1 .81 r
.01 w
.43529 .57357 m
.46556 .56768 L
s
P
p
.133 1 0 r
.01 w
.70964 .42726 m
.67861 .43359 L
s
P
p
.002 w
.35177 .15155 m .32185 .15873 L .30418 .14543 L p
.8 g
F P
s
P
p
.002 w
.27433 .15265 m .30418 .14543 L .32185 .15873 L p
.8 g
F P
s
P
p
.002 w
.50687 .14933 m .47644 .15653 L .45965 .1432 L p
.4 g
F P
s
P
p
.002 w
.42928 .15044 m .45965 .1432 L .47644 .15653 L p
.4 g
F P
s
P
p
.002 w
.76333 .14905 m .77085 .1557 L p
.74008 .14599 L .4 g
F P
s
P
p
.002 w
.66227 .1471 m .63133 .15432 L .61541 .14096 L p
.4 g
F P
s
P
p
.169 1 0 r
.01 w
.70945 .42382 m
.70945 .42382 L
s
P
p
.002 w
.18777 .1471 m .20258 .14348 L p
.19696 .15376 L .4 g
F P
s
P
p
.002 w
.22656 .14655 m .19696 .15376 L p
.20258 .14348 L .4 g
F P
s
P
p
.002 w
.17302 .15071 m .18777 .1471 L .19696 .15376 L p
.4 g
F P
s
P
p
.151 1 0 r
.01 w
.70954 .42554 m
.70954 .42554 L
s
P
p
.002 w
.30418 .14543 m .33422 .13816 L .35177 .15155 L p
.8 g
F P
s
P
p
0 1 .828 r
.01 w
.46554 .56947 m
.49601 .56355 L
s
P
p
0 .81 1 r
.01 w
.40413 .61731 m
.37393 .62307 L
s
P
p
.002 w
.45965 .1432 m .4902 .13592 L .50687 .14933 L p
.4 g
F P
s
P
p
0 .792 1 r
.01 w
.37387 .62489 m
.37387 .62489 L
s
P
p
.002 w
.74008 .14599 m .75576 .14236 L .76333 .14905 L p
.4 g
F P
s
P
p
0 .773 1 r
.01 w
.3738 .62671 m
.3738 .62671 L
s
P
p
.002 w
.61541 .14096 m .64649 .13367 L .66227 .1471 L p
.4 g
F P
s
P
p
0 .755 1 r
.01 w
.37373 .62853 m
.37373 .62853 L
s
P
p
.002 w
.21742 .13984 m .23232 .1362 L p
.22656 .14655 L .4 g
F P
s
P
p
.002 w
.25634 .13928 m .22656 .14655 L p
.23232 .1362 L .4 g
F P
s
P
p
.002 w
.20258 .14348 m .21742 .13984 L .22656 .14655 L p
.4 g
F P
s
P
p
.002 w
.75576 .14236 m .74008 .14599 L p
.72475 .13254 L .4 g
F P
s
P
p
0 .737 1 r
.01 w
.37367 .63036 m
.3562 .61972 L
s
P
p
0 .302 1 r
.01 w
.43716 .68979 m
.40681 .69534 L
s
P
p
0 .411 1 r
.01 w
.46784 .67307 m
.43738 .67866 L
s
P
p
0 .52 1 r
.01 w
.49853 .65633 m
.46797 .66198 L
s
P
p
0 .284 1 r
.01 w
.40676 .6972 m
.40676 .6972 L
s
P
p
.002 w
.41217 .13704 m .38187 .14432 L .36444 .13085 L p
.8 g
F P
s
P
p
0 .828 1 r
.01 w
.43455 .60969 m
.40418 .61549 L
s
P
p
0 .393 1 r
.01 w
.43734 .68051 m
.43734 .68051 L
s
P
p
0 .502 1 r
.01 w
.46795 .66382 m
.46795 .66382 L
s
P
p
0 .266 1 r
.01 w
.40671 .69906 m
.40671 .69906 L
s
P
p
.002 w
.4902 .13592 m .45965 .1432 L .44266 .12972 L p
.4 g
F P
s
P
p
0 .375 1 r
.01 w
.43731 .68237 m
.43731 .68237 L
s
P
p
0 1 .846 r
.01 w
.49601 .56535 m
.52669 .55939 L
s
P
p
0 .483 1 r
.01 w
.46792 .66567 m
.46792 .66567 L
s
P
p
.002 w
.74814 .13564 m .75576 .14236 L p
.72475 .13254 L .4 g
F P
s
P
p
0 .248 1 r
.01 w
.40666 .70092 m
.40666 .70092 L
s
P
p
.002 w
.56831 .13479 m .53749 .14208 L .52095 .12859 L p
.8 g
F P
s
P
p
0 .592 1 r
.01 w
.48178 .63842 m
.49855 .64896 L
s
P
p
0 .356 1 r
.01 w
.43727 .68422 m
.43727 .68422 L
s
P
p
0 .465 1 r
.01 w
.4679 .66752 m
.4679 .66752 L
s
P
p
0 .23 1 r
.01 w
.4066 .70278 m
.38929 .69255 L
s
P
p
.002 w
.64649 .13367 m .61541 .14096 L .59932 .12746 L p
.4 g
F P
s
P
p
0 .574 1 r
.01 w
.49855 .6508 m
.49855 .6508 L
s
P
p
0 .338 1 r
.01 w
.43724 .68608 m
.43724 .68608 L
s
P
p
0 .447 1 r
.01 w
.46788 .66936 m
.46788 .66936 L
s
P
p
0 .556 1 r
.01 w
.49854 .65264 m
.49854 .65264 L
s
P
p
0 .32 1 r
.01 w
.4372 .68794 m
.4372 .68794 L
s
P
p
.002 w
.24726 .13254 m .26225 .12887 L p
.25634 .13928 L .4 g
F P
s
P
p
.002 w
.2863 .13198 m .25634 .13928 L p
.26225 .12887 L .4 g
F P
s
P
p
.002 w
.23232 .1362 m .24726 .13254 L .25634 .13928 L p
.4 g
F P
s
P
p
0 .429 1 r
.01 w
.46786 .67121 m
.46786 .67121 L
s
P
p
0 .538 1 r
.01 w
.49854 .65449 m
.49854 .65449 L
s
P
p
0 .846 1 r
.01 w
.46513 .60203 m
.43459 .60787 L
s
P
p
.002 w
.44266 .12972 m .41217 .13704 L .39486 .12349 L p
.8 g
F P
s
P
p
.002 w
.36444 .13085 m .39486 .12349 L .41217 .13704 L p
.8 g
F P
s
P
p
.002 w
.44266 .12972 m .47334 .12235 L .4902 .13592 L p
.4 g
F P
s
P
p
.002 w
.72475 .13254 m .74049 .12887 L .74814 .13564 L p
.4 g
F P
s
P
p
.002 w
.52095 .12859 m .55189 .12121 L .56831 .13479 L p
.8 g
F P
s
P
p
0 1 .864 r
.01 w
.52669 .56119 m
.55758 .55519 L
s
P
p
.002 w
.59932 .12746 m .63052 .12007 L .64649 .13367 L p
.4 g
F P
s
P
p
.002 w
.74049 .12887 m .72475 .13254 L p
.70923 .11893 L .4 g
F P
s
P
p
.002 w
.27729 .12519 m .29237 .1215 L p
.2863 .13198 L .4 g
F P
s
P
p
.002 w
.31646 .12462 m .2863 .13198 L p
.29237 .1215 L .4 g
F P
s
P
p
.002 w
.26225 .12887 m .27729 .12519 L .2863 .13198 L p
.4 g
F P
s
P
p
0 .864 1 r
.01 w
.49588 .59433 m
.46516 .60021 L
s
P
p
0 .719 1 r
.01 w
.35612 .62155 m
.35612 .62155 L
s
P
p
0 .701 1 r
.01 w
.35605 .62339 m
.38645 .61758 L
s
P
p
.002 w
.39486 .12349 m .42547 .11608 L .44266 .12972 L p
.8 g
F P
s
P
p
0 .61 1 r
.01 w
.46484 .6259 m
.4818 .63657 L
s
P
p
.002 w
.73278 .12206 m .74049 .12887 L p
.70923 .11893 L .4 g
F P
s
P
p
.002 w
.55189 .12121 m .52095 .12859 L .50421 .11493 L p
.8 g
F P
s
P
p
.002 w
.63052 .12007 m .59932 .12746 L .58303 .11379 L p
.4 g
F P
s
P
p
0 .211 1 r
.01 w
.38923 .69442 m
.38923 .69442 L
s
P
p
0 1 .882 r
.01 w
.5576 .557 m
.5887 .55097 L
s
P
p
0 .882 1 r
.01 w
.52679 .58659 m
.49589 .5925 L
s
P
p
0 .193 1 r
.01 w
.38917 .69629 m
.38917 .69629 L
s
P
p
.002 w
.3075 .11779 m .32268 .11408 L p
.31646 .12462 L .4 g
F P
s
P
p
.002 w
.34681 .11722 m .31646 .12462 L p
.32268 .11408 L .4 g
F P
s
P
p
.002 w
.29237 .1215 m .3075 .11779 L .31646 .12462 L p
.4 g
F P
s
P
p
0 .175 1 r
.01 w
.38911 .69816 m
.38911 .69816 L
s
P
p
0 .157 1 r
.01 w
.38905 .70004 m
.38905 .70004 L
s
P
p
.002 w
.70923 .11893 m .72504 .11522 L .73278 .12206 L p
.4 g
F P
s
P
p
0 .139 1 r
.01 w
.389 .70192 m
.389 .70192 L
s
P
p
0 .683 1 r
.01 w
.38639 .61942 m
.417 .61358 L
s
P
p
.002 w
.50421 .11493 m .53528 .10747 L .55189 .12121 L p
.8 g
F P
s
P
p
0 .121 1 r
.01 w
.38894 .7038 m
.37137 .69348 L
s
P
p
.002 w
.58303 .11379 m .61437 .10632 L .63052 .12007 L p
.4 g
F P
s
P
p
0 .9 1 r
.01 w
.55787 .5788 m
.52679 .58476 L
s
P
p
.002 w
.72504 .11522 m .70923 .11893 L p
.69353 .10517 L .4 g
F P
s
P
p
.002 w
.33791 .11035 m .35319 .10661 L p
.34681 .11722 L .4 g
F P
s
P
p
.002 w
.37735 .10977 m .34681 .11722 L p
.35319 .10661 L .4 g
F P
s
P
p
.002 w
.32268 .11408 m .33791 .11035 L .34681 .11722 L p
.4 g
F P
s
P
p
0 1 .9 r
.01 w
.58874 .55278 m
.62005 .54672 L
s
P
p
0 .628 1 r
.01 w
.44771 .61324 m
.46486 .62405 L
s
P
p
.002 w
.45628 .10862 m .42547 .11608 L .40808 .10228 L p
.4 g
F P
s
P
p
.002 w
.71724 .10834 m .72504 .11522 L p
.69353 .10517 L .4 g
F P
s
P
p
.002 w
.53528 .10747 m .50421 .11493 L .48728 .10112 L p
.8 g
F P
s
P
p
.002 w
.61437 .10632 m .58303 .11379 L .56655 .09996 L p
.4 g
F P
s
P
p
0 .918 1 r
.01 w
.58912 .57098 m
.55785 .57698 L
s
P
p
0 .665 1 r
.01 w
.41695 .61542 m
.44777 .60954 L
s
P
p
.002 w
.36851 .10286 m .38389 .09909 L p
.37735 .10977 L .4 g
F P
s
P
p
.002 w
.40808 .10228 m .37735 .10977 L p
.38389 .09909 L .4 g
F P
s
P
p
.002 w
.35319 .10661 m .36851 .10286 L .37735 .10977 L p
.4 g
F P
s
P
p
.002 w
.40808 .10228 m .43901 .09474 L .45628 .10862 L p
.4 g
F P
s
P
p
0 1 .918 r
.01 w
.62011 .54853 m
.65163 .54243 L
s
P
p
.002 w
.69353 .10517 m .7094 .10141 L .71724 .10834 L p
.4 g
F P
s
P
p
.002 w
.48728 .10112 m .51848 .09357 L .53528 .10747 L p
.8 g
F P
s
P
p
0 .937 1 r
.01 w
.62053 .56311 m
.58908 .56915 L
s
P
p
.002 w
.6459 .0988 m .61437 .10632 L .59802 .0924 L p
.4 g
F P
s
P
p
.002 w
.56655 .09996 m .59802 .0924 L .61437 .10632 L p
.4 g
F P
s
P
p
0 .103 1 r
.01 w
.3713 .69537 m
.3713 .69537 L
s
P
p
.002 w
.7094 .10141 m .69353 .10517 L p
.67764 .09124 L .4 g
F P
s
P
p
0 .085 1 r
.01 w
.37123 .69726 m
.40201 .69162 L
s
P
p
0 .647 1 r
.01 w
.44774 .61139 m
.44774 .61139 L
s
P
p
.002 w
.39931 .09532 m .41478 .09153 L p
.40808 .10228 L .4 g
F P
s
P
p
.002 w
.43901 .09474 m .40808 .10228 L p
.41478 .09153 L .4 g
F P
s
P
p
.002 w
.38389 .09909 m .39931 .09532 L .40808 .10228 L p
.4 g
F P
s
P
p
.002 w
.70152 .09444 m .7094 .10141 L p
.67764 .09124 L .4 g
F P
s
P
p
0 .955 1 r
.01 w
.65211 .5552 m
.62048 .56128 L
s
P
p
0 1 .937 r
.01 w
.6517 .54425 m
.68345 .53811 L
s
P
p
.002 w
.67764 .09124 m .6459 .0988 L .62969 .0848 L p
.4 g
F P
s
P
p
.002 w
.59802 .0924 m .62969 .0848 L .6459 .0988 L p
.4 g
F P
s
P
p
0 .066 1 r
.01 w
.40196 .69352 m
.43295 .68785 L
s
P
p
.002 w
.4303 .08773 m .44588 .08392 L p
.43901 .09474 L .4 g
F P
s
P
p
.002 w
.47014 .08714 m .43901 .09474 L p
.44588 .08392 L .4 g
F P
s
P
p
.002 w
.41478 .09153 m .4303 .08773 L .43901 .09474 L p
.4 g
F P
s
P
p
.002 w
.67764 .09124 m .69359 .08744 L .70152 .09444 L p
.4 g
F P
s
P
p
0 .973 1 r
.01 w
.68387 .54725 m
.65205 .55337 L
s
P
p
.002 w
.69359 .08744 m .67764 .09124 L p
.66157 .07714 L .4 g
F P
s
P
p
.002 w
.62969 .0848 m .66157 .07714 L .67764 .09124 L p
.4 g
F P
s
P
p
0 1 .955 r
.01 w
.68353 .53994 m
.7155 .53376 L
s
P
p
0 .991 1 r
.01 w
.7158 .53925 m
.68379 .54542 L
s
P
p
.002 w
.68561 .08039 m .69359 .08744 L p
.66157 .07714 L .4 g
F P
s
P
p
0 .048 1 r
.01 w
.43291 .68975 m
.46411 .68405 L
s
P
p
.002 w
.4615 .08009 m .47717 .07626 L p
.47014 .08714 L .4 g
F P
s
P
p
.002 w
.50147 .0795 m .47014 .08714 L p
.47717 .07626 L .4 g
F P
s
P
p
.002 w
.44588 .08392 m .4615 .08009 L .47014 .08714 L p
.4 g
F P
s
P
p
0 1 .973 r
.01 w
.7156 .53559 m
.7156 .53559 L
s
P
p
0 1 .991 r
.01 w
.7157 .53742 m
.7157 .53742 L
s
P
p
.002 w
.66157 .07714 m .67758 .0733 L .68561 .08039 L p
.4 g
F P
s
P
p
.002 w
.49289 .07241 m .50867 .06855 L p
.50147 .0795 L .4 g
F P
s
P
p
.002 w
.533 .07181 m .50147 .0795 L p
.50867 .06855 L .4 g
F P
s
P
p
.002 w
.47717 .07626 m .49289 .07241 L .50147 .0795 L p
.4 g
F P
s
P
p
0 .03 1 r
.01 w
.46409 .68596 m
.49551 .68022 L
s
P
p
.332 0 1 r
.01 w
.40075 .73569 m
.36963 .74125 L
s
P
p
.002 w
.67758 .0733 m .66157 .07714 L p
.6453 .06288 L .4 g
F P
s
P
p
.35 0 1 r
.01 w
.36956 .74319 m
.36956 .74319 L
s
P
p
.369 0 1 r
.01 w
.36949 .74512 m
.36949 .74512 L
s
P
p
.387 0 1 r
.01 w
.36942 .74706 m
.36942 .74706 L
s
P
p
.002 w
.6695 .06616 m .67758 .0733 L p
.6453 .06288 L .4 g
F P
s
P
p
.405 0 1 r
.01 w
.36934 .749 m
.3513 .73874 L
s
P
p
.84 0 1 r
.01 w
.43482 .81069 m
.40352 .81602 L
s
P
p
.731 0 1 r
.01 w
.46645 .79347 m
.43505 .79885 L
s
P
p
.622 0 1 r
.01 w
.49811 .77624 m
.46659 .78168 L
s
P
p
.858 0 1 r
.01 w
.40347 .81799 m
.40347 .81799 L
s
P
p
.002 w
.52449 .06467 m .54037 .06079 L p
.533 .07181 L .4 g
F P
s
P
p
.002 w
.56474 .06407 m .533 .07181 L p
.54037 .06079 L .4 g
F P
s
P
p
.002 w
.50867 .06855 m .52449 .06467 L .533 .07181 L p
.4 g
F P
s
P
p
.314 0 1 r
.01 w
.43212 .72816 m
.40081 .73376 L
s
P
p
.749 0 1 r
.01 w
.43501 .80082 m
.43501 .80082 L
s
P
p
.64 0 1 r
.01 w
.46657 .78364 m
.46657 .78364 L
s
P
p
.876 0 1 r
.01 w
.40341 .81997 m
.40341 .81997 L
s
P
p
.767 0 1 r
.01 w
.43497 .80279 m
.43497 .80279 L
s
P
p
0 .012 1 r
.01 w
.49551 .68213 m
.52715 .67637 L
s
P
p
.659 0 1 r
.01 w
.46654 .7856 m
.46654 .7856 L
s
P
p
.894 0 1 r
.01 w
.40336 .82195 m
.40336 .82195 L
s
P
p
.55 0 1 r
.01 w
.48083 .75824 m
.49814 .7684 L
s
P
p
.785 0 1 r
.01 w
.43493 .80476 m
.43493 .80476 L
s
P
p
.677 0 1 r
.01 w
.46652 .78756 m
.46652 .78756 L
s
P
p
.912 0 1 r
.01 w
.4033 .82393 m
.38543 .8141 L
s
P
p
.568 0 1 r
.01 w
.49813 .77036 m
.49813 .77036 L
s
P
p
.804 0 1 r
.01 w
.43489 .80674 m
.43489 .80674 L
s
P
p
.695 0 1 r
.01 w
.4665 .78953 m
.4665 .78953 L
s
P
p
.586 0 1 r
.01 w
.49812 .77231 m
.49812 .77231 L
s
P
p
.822 0 1 r
.01 w
.43486 .80871 m
.43486 .80871 L
s
P
p
.002 w
.6453 .06288 m .66138 .05899 L .6695 .06616 L p
.4 g
F P
s
P
p
.713 0 1 r
.01 w
.46648 .7915 m
.46648 .7915 L
s
P
p
.604 0 1 r
.01 w
.49811 .77427 m
.49811 .77427 L
s
P
p
.296 0 1 r
.01 w
.46366 .72059 m
.43216 .72622 L
s
P
p
.002 w
.5563 .05689 m .57228 .05297 L p
.56474 .06407 L .4 g
F P
s
P
p
.002 w
.59668 .05628 m .56474 .06407 L p
.57228 .05297 L .4 g
F P
s
P
p
.002 w
.54037 .06079 m .5563 .05689 L .56474 .06407 L p
.4 g
F P
s
P
p
.002 w
.66138 .05899 m .6453 .06288 L p
.62883 .04844 L .4 g
F P
s
P
p
.006 0 1 r
.01 w
.52716 .67828 m
.55902 .67248 L
s
P
p
.002 w
.65321 .05177 m .66138 .05899 L p
.62883 .04844 L .4 g
F P
s
P
p
.278 0 1 r
.01 w
.49537 .71297 m
.46368 .71865 L
s
P
p
.423 0 1 r
.01 w
.35122 .74069 m
.35122 .74069 L
s
P
p
.441 0 1 r
.01 w
.35114 .74264 m
.38249 .73704 L
s
P
p
.002 w
.58831 .04905 m .60439 .04511 L p
.59668 .05628 L .4 g
F P
s
P
p
.002 w
.62883 .04844 m .59668 .05628 L p
.60439 .04511 L .4 g
F P
s
P
p
.002 w
.57228 .05297 m .58831 .04905 L .59668 .05628 L p
.4 g
F P
s
P
p
.532 0 1 r
.01 w
.46334 .74598 m
.48085 .75628 L
s
P
p
.931 0 1 r
.01 w
.38536 .81609 m
.38536 .81609 L
s
P
p
.002 w
.62883 .04844 m .64499 .04451 L .65321 .05177 L p
.4 g
F P
s
P
p
.024 0 1 r
.01 w
.55904 .6744 m
.59113 .66857 L
s
P
p
.26 0 1 r
.01 w
.52726 .70531 m
.49538 .71103 L
s
P
p
.949 0 1 r
.01 w
.3853 .81809 m
.3853 .81809 L
s
P
p
.967 0 1 r
.01 w
.38524 .82008 m
.38524 .82008 L
s
P
p
.985 0 1 r
.01 w
.38517 .82208 m
.38517 .82208 L
s
P
p
.002 w
.62053 .04116 m .63672 .0372 L p
.62883 .04844 L .4 g
F P
s
P
p
.002 w
.64499 .04451 m .62883 .04844 L p
.63672 .0372 L .4 g
F P
s
P
p
.002 w
.60439 .04511 m .62053 .04116 L .62883 .04844 L p
.4 g
F P
s
P
p
1 0 .997 r
.01 w
.38511 .82408 m
.38511 .82408 L
s
P
p
.459 0 1 r
.01 w
.38242 .739 m
.41399 .73336 L
s
P
p
1 0 .979 r
.01 w
.38505 .82608 m
.3669 .81617 L
s
P
p
.242 0 1 r
.01 w
.55933 .69761 m
.52726 .70337 L
s
P
p
.042 0 1 r
.01 w
.59117 .67049 m
.62349 .66462 L
s
P
p
.514 0 1 r
.01 w
.44566 .7336 m
.46337 .74402 L
s
P
p
.224 0 1 r
.01 w
.59157 .68987 m
.5593 .69566 L
s
P
p
.477 0 1 r
.01 w
.41394 .73533 m
.44573 .72966 L
s
P
p
.06 0 1 r
.01 w
.62354 .66655 m
.65609 .66065 L
s
P
p
.205 0 1 r
.01 w
.624 .68208 m
.59153 .68792 L
s
P
p
1 0 .961 r
.01 w
.36682 .81818 m
.36682 .81818 L
s
P
p
1 0 .943 r
.01 w
.36675 .82019 m
.3985 .81478 L
s
P
p
.495 0 1 r
.01 w
.4457 .73163 m
.4457 .73163 L
s
P
p
.187 0 1 r
.01 w
.6566 .67425 m
.62394 .68013 L
s
P
p
.079 0 1 r
.01 w
.65616 .66258 m
.68894 .65664 L
s
P
p
1 0 .924 r
.01 w
.39844 .8168 m
.43041 .81136 L
s
P
p
.169 0 1 r
.01 w
.68939 .66637 m
.65653 .6723 L
s
P
p
.097 0 1 r
.01 w
.68903 .65858 m
.72204 .6526 L
s
P
p
.151 0 1 r
.01 w
.72236 .65845 m
.6893 .66442 L
s
P
p
1 0 .906 r
.01 w
.43037 .81339 m
.46257 .80791 L
s
P
p
.115 0 1 r
.01 w
.72214 .65455 m
.72214 .65455 L
s
P
p
.133 0 1 r
.01 w
.72225 .6565 m
.72225 .6565 L
s
P
p
1 0 .888 r
.01 w
.46255 .80994 m
.49498 .80444 L
s
P
p
1 0 .526 r
.01 w
.39716 .86173 m
.36504 .86705 L
s
P
p
1 0 .508 r
.01 w
.36497 .86911 m
.36497 .86911 L
s
P
p
1 0 .489 r
.01 w
.36489 .87118 m
.36489 .87118 L
s
P
p
1 0 .471 r
.01 w
.36482 .87324 m
.36482 .87324 L
s
P
p
1 0 .453 r
.01 w
.36474 .87531 m
.34608 .8655 L
s
P
p
1 0 .018 r
.01 w
.43232 .93942 m
.40002 .94449 L
s
P
p
1 0 .127 r
.01 w
.46498 .92167 m
.43256 .9268 L
s
P
p
1 0 .236 r
.01 w
.49766 .90391 m
.46512 .9091 L
s
P
p
1 0 .544 r
.01 w
.42953 .85431 m
.39722 .85967 L
s
P
p
1 0 .109 r
.01 w
.43252 .9289 m
.43252 .9289 L
s
P
p
1 0 .218 r
.01 w
.4651 .91119 m
.4651 .91119 L
s
P
p
1 0 .091 r
.01 w
.43248 .931 m
.43248 .931 L
s
P
p
1 0 .87 r
.01 w
.49497 .80647 m
.52764 .80093 L
s
P
p
1 0 .199 r
.01 w
.46508 .91328 m
.46508 .91328 L
s
P
p
1 0 .308 r
.01 w
.47982 .88586 m
.49769 .89556 L
s
P
p
1 0 .073 r
.01 w
.43244 .9331 m
.43244 .9331 L
s
P
p
1 0 .181 r
.01 w
.46505 .91538 m
.46505 .91538 L
s
P
p
1 0 .29 r
.01 w
.49768 .89765 m
.49768 .89765 L
s
P
p
1 0 .054 r
.01 w
.4324 .9352 m
.4324 .9352 L
s
P
p
1 0 .163 r
.01 w
.46503 .91747 m
.46503 .91747 L
s
P
p
1 0 .272 r
.01 w
.49767 .89973 m
.49767 .89973 L
s
P
p
1 0 .036 r
.01 w
.43236 .93731 m
.43236 .93731 L
s
P
p
1 0 .145 r
.01 w
.465 .91957 m
.465 .91957 L
s
P
p
1 0 .254 r
.01 w
.49767 .90182 m
.49767 .90182 L
s
P
p
1 0 .562 r
.01 w
.46209 .84685 m
.42958 .85224 L
s
P
p
1 0 .852 r
.01 w
.52765 .80298 m
.56055 .7974 L
s
P
p
1 0 .58 r
.01 w
.49483 .83934 m
.46212 .84478 L
s
P
p
1 0 .435 r
.01 w
.346 .86758 m
.346 .86758 L
s
P
p
1 0 .417 r
.01 w
.34591 .86966 m
.37826 .8643 L
s
P
p
1 0 .326 r
.01 w
.46175 .87393 m
.47984 .88376 L
s
P
p
1 0 .834 r
.01 w
.56058 .79945 m
.59372 .79385 L
s
P
p
1 0 .598 r
.01 w
.52776 .83179 m
.49484 .83727 L
s
P
p
1 0 .399 r
.01 w
.37819 .86639 m
.41078 .861 L
s
P
p
1 0 .616 r
.01 w
.56088 .8242 m
.52775 .82972 L
s
P
p
1 0 .816 r
.01 w
.59376 .7959 m
.62715 .79026 L
s
P
p
1 0 .344 r
.01 w
.44348 .86187 m
.46178 .87183 L
s
P
p
1 0 .634 r
.01 w
.59419 .81657 m
.56086 .82213 L
s
P
p
1 0 .381 r
.01 w
.41073 .86309 m
.44355 .85767 L
s
P
p
1 0 .798 r
.01 w
.62721 .79232 m
.66084 .78665 L
s
P
p
1 0 .653 r
.01 w
.62769 .80889 m
.59415 .81449 L
s
P
p
1 0 .363 r
.01 w
.44352 .85977 m
.44352 .85977 L
s
P
p
1 0 .671 r
.01 w
.66138 .80116 m
.62763 .80681 L
s
P
p
1 0 .779 r
.01 w
.66091 .78872 m
.69479 .78301 L
s
P
p
1 0 .689 r
.01 w
.69527 .7934 m
.6613 .79908 L
s
P
p
1 0 .761 r
.01 w
.69489 .78508 m
.72901 .77934 L
s
P
p
1 0 .707 r
.01 w
.72936 .78558 m
.69517 .79131 L
s
P
p
1 0 .743 r
.01 w
.72913 .78142 m
.72913 .78142 L
s
P
p
1 0 .725 r
.01 w
.72924 .7835 m
.72924 .7835 L
s
P
p
.002 w
.6362 .02399 m
.89107 .25032 L
s
.89107 .25032 m
.96179 .88735 L
s
.96179 .88735 m
.66225 .69244 L
s
.66225 .69244 m
.6362 .02399 L
s
.11601 .15203 m
.03821 .80363 L
s
.03821 .80363 m
.66225 .69244 L
s
.66225 .69244 m
.6362 .02399 L
s
.6362 .02399 m
.11601 .15203 L
s
P
p
p
.002 w
.11601 .15203 m
.6362 .02399 L
s
P
p
.002 w
.23343 .12313 m
.23959 .12771 L
s
P
[(5)] .2211 .11397 .84498 1 Mshowa
p
.002 w
.3844 .08597 m
.39033 .09067 L
s
P
[(10)] .37254 .07657 .79187 1 Mshowa
p
.002 w
.54025 .04761 m
.54593 .05243 L
s
P
[(15)] .5289 .03796 .73876 1 Mshowa
p
.001 w
.26324 .11579 m
.26691 .11855 L
s
P
p
.001 w
.29325 .10841 m
.29689 .11118 L
s
P
p
.001 w
.32344 .10097 m
.32706 .10377 L
s
P
p
.001 w
.35382 .09349 m
.35741 .0963 L
s
P
p
.001 w
.41517 .07839 m
.4187 .08123 L
s
P
p
.001 w
.44614 .07077 m
.44964 .07362 L
s
P
p
.001 w
.47731 .0631 m
.48078 .06596 L
s
P
p
.001 w
.50868 .05538 m
.51212 .05826 L
s
P
p
.001 w
.2038 .13042 m
.20752 .13316 L
s
P
p
.001 w
.17435 .13767 m
.1781 .14039 L
s
P
p
.001 w
.14509 .14488 m
.14887 .14758 L
s
P
p
.001 w
.57203 .03978 m
.5754 .04269 L
s
P
p
.001 w
.60401 .03191 m
.60735 .03483 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29763 .03347 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004P0
0ol300;o0`03o`800ol20003o`0003400ol300?oP00004L000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<P000ol000050003o`0007d0001;0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<P000ol000050003o`0007d0001800?o0P001_l00?l0o`8000Ko003o0?l20003o`000380
00?o00000P03oa/01?mQ0000A`000ol0000400;o0P001Ol00?l000Ko=@000ol000020003o`0001L0
1?l20003o`3o060000170005o`000?l030000ol0o`0f00;o1004oa801?l60004o`00oel0001800?o
3`000ol0001<00Co0P000ol000050005o`000?l0GP000:D01?l<00Co0P02oed0002Q00Co00<0ool0
2@04o`:100CoPOoo0P000ol0001J0000W@04o``01?l3P@03oh6100Co0`000ol0001I0000I`03o`@0
0_lY00Ko2@05o`R10ol3P@05o`000?l0FP0006P000?o00000P001?l00?lT00Co1P000ol0000200Co
18400on1P@04o`05^l^kbol018400ol00002oeT0001X0003o`00008000Co003o8005o`X01?l9P@;o
2;/00on1P@03P@;o0P02oeL0001X0003o`00008000Co003o7004o`D000?o00000`04o`>100?oPH40
1Ol03[_;^l^kbk_;^l^kboo;0h43o`@000?o0000E00006P000?o00000P001?l00?lH00Go2@05o`R1
0_lA^`03ok^k00;o0h42o`<000?o00001`03odT0001W00;o1@02oaD01?l50003o`0000801?l4P@03
oh6100Co01W;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00F10_l0103oool;0003o`0004H0002100Co
2P04o`V10_lI^`03ok^k00:k1H42o`<000?o000020000ol000160000O@04o`@000?o00000`04o`>1
00?oPH401Ol08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;00>11?l30003o`0000@0
0om90000N@04o`T01Ol8P@;o8k/01?nk^k/4o`>10_l30003o`0000<000?o0000B@0007D01?l40003
o`0000801?l4P@03oh6100Co02Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Go
18401?n1PH43o`:100?o00000P04odP0001400?o:P04o`03P@0000H01?l9P@;o9[/4o`03POn100N1
00OoPH61oh7o00800_m>0000A`000ol0000T00?o10000on1000200Co0h400on1P@05o`0V^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`B10_l9P@?o0h401Ol0003o04d000170003
o`0002001?l900?o2842oa:k0olB^`Co2H42o`:11?l4^`F100?o00000_m<0000A003oal01?l30003
o`0000@00ol2P@03oh6100Co18403Onkbk_;^l^kbk_;^l/01Ol3F`0>ol^kbk_;^l^kbk_;^l/4o`B1
00?oPH401X403On1ooo;^l^kbk_;^l/01H42o`8000?o0000B@0004@000?o00006`04o`T01_l5P@;o
2H400onk^`07^`;o2E/00onk^`08^`;o2H400on1P@06o`fk0h43o`<000?o0000B00004@01?lF00Co
0P000ol0000400Oo0X44o`05bk_;^ol02H403?nkbk_;^l^kbk_;o`UK00gobk_;^l^kbk_;^l_o00V1
0_l05;_;^l^kok_;^l^kbk_;^l^kbk_;0_l3P@05o`000?l0:005o`050?ooo`000ol300;o3`0005X0
1?l900Oo1842o`Vk00?oPH401h400onk^`08^`03oe]K00MK0_l:^`03oh6100Co18400onk^`02^`03
ok^k00fk1H400ol0o`02obL000?o00000P001?l00?l40004o`00oa00001F00Co0P000ol0000400Oo
0X44o`0?bk_;^l^kbk_;^l^kbk_o00:11?l03k_;^l^kbk_;^l^kbk_;o`02F`Co15/2o`09bk_;^l^k
bk_;00;o2H405Onkbk_o^l^kbk_;^l^kbk_;^l^kb`05P@;o0P000ol0000T0003o`0000<00ol200;o
0`000ol0000>0000DP04o`T01_l5P@;o4K/4oa>k0_l:F`03ok^k00Nk00?oPH4028401?nk^olA^`>1
1?l20003o`0002<01Ol30003o`3o00D000?o00003P0004h01?l20003o`0000@01ol2P@Co017;^l^k
bk_;^l^kbk_;^l^kb`04o`=K01Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0:F`0;ol^kbk_;^l^kbol0
2X405Onkok_;^l^kbk_;^l^kbk_;^l^kb`02o`>10_l200;o8`000ol0000300;o0`03o`040?ooo`l0
001:00Co1`08o`F10_lA^`Co25/00onk^`06^`Co2K/00omKF`05o`=K00?o^k/01k/00on1P@05o`>1
0_lD^`B11_lR0003o`0000d000?o00003P0004H01?l30004o`0000Co18400on1P@04o`0@bk_;^l^k
bk_;^l^kbk_;^`Go0e/00omKF`07F`03ok_;00Go18402_nkbk_;^l^kbk/2o`UK00[obk_;^l^kbk_;
0_l9P@0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`>100?oPOl00`000ol0000O00Go700004801?l700Co
2H42oa:k0_l9F`03oe]K00MK0_l:P@03ok^k00Rk00?oFe/01e/00onk^`08^`03oh6100J10_lE^`;o
0h401Ol0003o00X00ol400;o;P0003h01?l20003o`0000801?l4P@03oh6100Co01W;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00UK00?oFe/01?l01;_;^l/2o`V10_l02/^kbk_;^l^kbol9F`0<ol^kbk_;
^l^kbk_o1h406?n1ooo;^l^kbk_;^l^kbk_;^l^kbk_;^`F100?o00000_l:0003o`00008000Co003o
;@0003X01?l700Co2H42oa2k1?l9^`03oe]K00MK0_l:^`03oh6100Co18400onk^`07^`03oe]K00Co
3[/00on1P@05o`>100?o^k/04[/5P@;o0P000ol000070003o`00008000Co003o;@0003H01?l30004
o`0000Co18400on1P@04o`0@bk_;^l^kbk_;^l^kbk_;^`Co15/02onkbk_;^l^kbk_o009K1?l03K_;
^l^kbk_;^l^kbk/01?l9P@0:ol^kbk_;^l^kb`;o01>kbk_;^l^kbk_;^l^kbk_;^l^k00;o18400on1
P@02P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00>11?l20003o`0000H000?o00000P001?l00?l]0000
<P04o`L01?l9P@;o4;/4o`UK00?o^k/01k/2o`fk1?l3P@03oh6100R100?o^k/07K/01On1PH7o00F1
00?o^k/04[/2o`>10_l20003o`0000D000?o00000P001?l00?l]0000;P04o`L01?l4P@03oh6100Co
013;^l^kbk_;^l^kbk_;^l^k1?l4F`;o25/05?nkbk_;^l^kbk_;^l^kbk_;^l^k1?l8P@03oh6100R1
027obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X44o`>101Gobk_;^l^kbk_;^l^kbk_;
^l^kbk/01H42o`:100?o00000`02o`D00_l^0000;002o`L01?l9P@;o4[/2o`YK00?oFe/00U/2o`9K
00?o^k/03;/4o`>100?oPH401h400on1P@05ob>k0ol7P@03ok^k01:k1H42o`800_lj0000;0000ol0
o`0200Co18400on1P@04o`0Hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l9F`Co00nkbk_;^l^kbk_;
^l^kbk/01?l8P@03oh6100N10_l03l^kbk_;^l^kbk_;^l^kb`06o`0D^l^kbk_;^l^kbk_;^l^kbk_;
^l/2o`R101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/00h44o`<000?o0000=`0002`000?o0?l00_l9P@;o
7[/00omKF`04oa6k1?l3P@03oh6100N100?oPH401?l?^`Co1U/00onk^`0B^`03oh6100N10_lC^`;o
1842o`030?oo03P0000/00;o0h400on1P@04o`0Sbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l04K_;^l^kbk_;^l^kbk_;^l^k00Co28400on1P@07P@;o01G;^l^kbk_;^l^kbk_;^l^k
bk_;^ol02E/05?nkbk_;^l^kbk_;^l^kbk_;^l^k0_l2P@Co18405Onkbk_;^l^kbk_;^l^kbk_;^l^k
b`05P@;o0P000ol0000e00008`02o`L00_l4P@;o=[/4o`>100?oPH401h400on1P@04oaVk00?oFe/0
1e/00onk^`0@^`Co2H400onk^`0B^`>100CoPOoo0P000ol0000d00008P001?l00?l50003o`0000;o
1842o`0bbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`R1
00?oPH401h42o`0Obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02F`Co016kbk_;^l^kbk_;
^l^kbk_;^`04o`05POn1POl02H405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`02o`>10_l20003o`0003<0
000R0004o`00o`D000?o00000P000on1P@03P@03ok^k036k00?oPH401X400on1P@04o`B10_lM^`;o
4K/4o`F100GoPH61o`02P@Co6;/5P@Go=000028000Co003o1@000ol000030003oh6100>10_l09K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l02/^kbk_;^l^kbol4P@;o0X42o`Z1
02co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co18400on1P@02P@03
oh6100:10_l07L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00F10_l20003o`000340000R0004
o`00o`D000?o00001@02o`B100?o^k/07[/4o`AK00?o^k/01k/4o`J10_l9P@03ok^k00nk1?l?^`Ko
2H400on1P@04ob:k0h44o`8000?o0000<00002<00_l60003o`0000H000?oPH400h407_nkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2E/03?o;^l^kbk_;^l^ko`V100?oPH401?l04;_;^l^kbk_;
^l^kbk_;^l/4o`AK0_l02K_;^l^kbk_;^`04o`J100?oPH401h42o`0Sboo;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/01_l4P@;o00<0ool0<00002/000?o00001`000on1P@03P@03ok^k01bk
0_l8F`;o2K/00on1P@07P@;o4[/2o`YK00?o^k/01k/00on1P@07P@03oh6100Co1K/00onk^`0I^`Ko
1U/00on1P@02P@;o0P000ol0000]0000:`02o`X000?oPH400X42o`0Obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`02F`?o15/02onkbk_;^l^kbk_o00:11?l06;_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`;o2E/02onkbk_;^l^kbk_o00V10_l08L^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`04o`=K00?oFe/01e/01On1POn100;o0P000ol0000800?o0`03oa/0000[0003o`0000X00_l4P@;o
7K/2o`QK00?o^k/01k/2o`jk1_l:^`03oe]K00Co3K/00on1P@04o`B100?o^k/01[/00onk^`0A^`Co
25/00omKF`07F`;o0h42o`8000?o000020000ol000050003o`0001P0000Z0003o`0000`000?oPH40
18407onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02E/04onkbk_;^l^kbk_;^l^kbk_;^l/0
1_l6P@;o00Vkbk_;^l^kbk/00_l04/^kbk_;^l^kbk_;^l^kbk_;^`;o2H405oo;^l^kbk_;ol^kbk_;
^l^kbk_;^l^k00Go0e/00omKF`07F`03oe]K00Co15/4P@Go2@000ol000050003o`0001P0000Z0003
o`0000d000?oPH4018400onk^`0K^`03oe]K00MK00?o^k/02k/4o`B100?oPH401h400onk^`0L^`03
oh6100N100?o^k/01;/00onk^`08^`Co2E/00omKF`07F`;o2E/01?n1PH42o`8000?o00001P000ol0
000200?o6`0002X000?o00004002o`>101oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o009K
1?l03[_;^l^kbk_;^l^kbk_;0_l9P@03oh6100N10_l07/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`:11?l3P@0=ol^kbk_;ol^kbk_;^`04o`=K00?oFe/025/00omKF`04o`05^l^kbol02E/6o`80
00?o00001@000ol000020003o`0001/0000Z0003o`00014000?oPH400X400onk^`0K^`;o5;/00on1
P@07P@03oh6100Co18400onk^`0I^`Co28400onk^`02^`03ok^k00Co25/00omKF`08F`;o2K/00omK
F`04o`=K00?oPH400X42o`03POl000@00_l400Co6P0002X000?o00004P000on1P@02P@0eok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02H42o`V101Oobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`04o`=K00?oPH401h400oo;^`04o`AK00?oFe/01U/00omKF`05o`0<
^l^kbk_;^l^kbk_;1?l8F`03oh6100:10_l00`3oo`0W0000:P000ol0000B0003P@3o00>10_lb^`03
oh6100Co18400on1P@07P@03ok^k016k0_l8F`03oh6100N10_l00e_oF`06F`03oe]K009K0_l2F`;o
3;/2o`EO00?oFe/025/00on1P@04o`8000?o0000900002X000?o00004@0018400002o`>10_l0<K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l9P@03oh6100Co
01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00QK00?oPH401?l4P@;o25/4o`0<bk_;^l^kbk_;^l^k
1El01AmO7elO00=O00=Koe/02E/2o`>10_l20003o`0002<0000Z00;o4P000h4000030003oh6100:1
00?o^k/09;/4o`Rk00?oPH401h42oafk00?oFe/00U/2o`9K0_l9P@03oe]K00Co0e/00onk^`06^`07
GalOGamO7`08G`9K00EO5e]Ko`02F`Go0k/5P@?o00<0o`008`0002X000?o00004@000h4000040003
oh6100:10_l08<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l4F`0:ok_;^l^kbk_;o`:1
1?l4P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l01l^kbk_;^ol02843o`QK00So^l^k
bk_;^`MO00AKGamO0U/01?mKFe/25`03oe]K00;o00W;^l^kbk_;^l/00h401?n1ool20003o`000240
000Y0003o`00018000>100001@02o`B10_lL^`;o2E/00onk^`06^`;o2H400onk^`0U^`03oh6100Co
00Fkok^ko`08F`03ok^k00Bk00DOGalOo`09F`?o0aL>^`;o0h43o`030?l00240000Y0003o`000180
00>100001`000on1P@03P@0Ook_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`09F`0:ok_;^l^k
bk_;^`;o2842o`0Vbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`0:bk_;^l_o
bk_;o`AK0_l2F`;o00K;^l^kbk/4G`9K1?l3F`03ol^k00<G00nkbk_;^l^kbk_;^l^kbk/018400onk
o`02ob40000Y0003o`00018000>1000020000on1P@03P@03ok^k01^k00?oFe/01e/2o`Vk00?oPH40
0ol4P@03ok^k02Zk00?o^k/00[/4o`IK00?o^k/01;/01AmO7eoo00QK00?o^k/011L>^`B100Go^ol0
o`0P0000:@000ol0000B0003P@0000X00_l3P@0Ook_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
o`02F`Co15/02_o;^l^kbk_;^l/2o`R103?obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kboo;^l^kbol02E/01oo;^l^kbk/015l00omKF`06F`03ol^k00<G00lAbk_;^l^kbk_;
^l^kbk/01ol00`3o000N0000:@000ol0000B0003P@0000/000?oPH400X400onk^`0K^`;o2E/00onk
^`07^`03oh6100N100?o^k/0:;/00onk^`04^`03oe]K00MK0_l6^`04GamO7`AK0_l2F`;o0[/35`jk
1H44oah0000Y0003o`00018000>1000030000on1P@02P@0Pok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol9F`0;ol^kbk_;^l^kbol02H42o`0a^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kboo;^l^kbk_;o`02F`Co15/01onkbk_;^l/015l3o`IK01Co^l/A5a7;^l^kbk_;^l^k
bk_;^`F10olN0000:@000ol0000B0003P@0000h00_l2P@;o7K/00omKF`04o`fk00?oPH401?l4P@03
ok^k02Fk00?o^k/00k/5o`UK00?o^k/01;/015lOGal9F`03ok/A008G00<A^k/03;/3P@Co7P0002P0
0olC0003P@00010000CoPH610_l06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l04[_;^l^kbk_;
^l^kbk_;^l^kb`;o2H40:Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k4OlA00Co
1E/00omKF`07F`0:ok_;^l^kbk]O7`9O15/95`0;^l^kbk_;^l^kbk/01_l00h6kb`02oad0000X0003
o`00018000>100004P000on1P@02P@03ok^k01Bk0ol4F`;o4[/00on1P@07P@;o8;/3o`044Ioo4@UK
00?oFe/01?l;^`0>7elO7e/G4ALA5a4G4Ol7^`Ko1844o`030?l001d0000X0003o`00018000>10000
4`000on1P@02P@;o00k;^l^kbk_;^l^kbk_;^`Ko2E/05?o;^l^kbk_;^l^kbk_;^l^kbk_o0X44o`B1
01cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l3F`03Wa7o008A00<GFe/01U/2o`0>bk_;^l^k
bk_;^l^kbk/2o`045a4G4@<G1U/00oo;^`04o`V100?o000010000ol0000K0000:0000ol0000B0003
P@0001@00_l4P@03ok^k00Nk1?l6F`03oe]K00MK00?o^k/04;/2o`V100?o^k/05;/4o`AK00?oFe/0
0U/01_lA4A4GF`Co3;/4o`0:5a4G4ALA5a4G4@QK0_l6P@Co2P000ol0000K0000:0000ol0000B0003
P@0001H000?oPH400X403?o;^l^kbk_;^l^ko`QK00?oFe/01?l05l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00;o2842o`0B^l^kbk_;^l^kbk_;^l^kbk_;0_l9F`07oe]KFolAW`024@0=5l^kbk_;^l^kbk_;
^`04o`095a4G4ALA5a4G009K0Ul011LOGal3o`V100?o000030000ol0000K0000:0000ol0000B0003
P@0001L000>1oh400X42o`Vk00?oFe/00U/2o`9K0_lM^`03oh6100?o18400onk^`0A^`03oe]K00MK
1?l00k/A4@024@8G1[/4o`XA00IO7elOGal2G`035emO00F11?lB0003o`0001/0000X0003o`000180
00>100005`001840ool3P@;o00S;^l^kbk_;^`Co02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/2o`R100Go^l^kb`06o`0:^l^kbk_;^l^ko`9K1?l02[_;^l^kok^O4Il24@035a6k00Co
0U/0614G5a4G4AMO7elOGalG7aLO5alG7aLOo`>100?o000050000ol0000K0000:0000ol0000B0003
P@0001L000F10000o`04P@03ok^k02nk00?oPH401X44o`IK00?o^k/01k/2o`Vk00Ko^k^k4Il34@03
5e]K00PG00aO7elOGamO7olOGal3P@;o00EO5`00P@0H0003o`0001/0000X0003o`00018000>10000
5`000h4000020003oh6100:10_l0<K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol00X43o`=K00?oFe/01e/05onkbk_;^l^kbk_;^l^kbk_;^l^kok_;00;o00<AWa40
0a401QLA5a4G4@@O00=O7el01844o`T000>100005P000ol0000K00009`03oa<000>100005P000h40
000400;o18400onk^`0/^`Co1e/00omKF`07F`03ok^k012k0ol37`054InO5a400QL01AmO7elO00V1
00?o000030000h40000E0003o`0001/0000W0003o`0001<000>100005P000h4000050003oh6100>1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`AK00?oFe/01E/00omK
F`04o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`HO0il24@;o1X44oa8000>100005@000ol0000K0000
9`000ol0000C0003P@0001H000>100001P000on1P@03P@;o4;/4oa6k0_l9F`03oe]K009K00?oFe/0
0_lG^`8O00Ko7alOoe/27`>O28400ol0000D0003P@0001H000?o00006P0002L000?o00004P000h40
000G0003P@0000T00_l3P@;o00Zkbk_;^l^kbk_;1?l4F`07ol^kbk_;^`04o`09bk_;^l^kbk_o00UK
1?l5P@;o01Fkbk_;^l^kbk_;^l^kbk_;^l^kbk/00Ql7o`:119l3oaX000>100005P000ol0000J0000
9`000ol0000B0003P@0001L000>100002P000on1P@03P@03ok^k00Fk0_l9F`03ok^k00?o15/00onk
^`06^`03oe]K00Co1;/00on1P@06P@03ok^k00nk1_l4P@Go19lL0003P@0001H000?o00006P0002L0
00?o00004P000h40000G0003P@0000/000?oPH400h42o`08bk_;^l^kbol9F`;o25/02Oo;^l^kbk_;
^`02o`0:bk_;^l^kbk_;o`B10_l2P@;o00_;^l^kbk_;^l^kb`04o`F100GoPH61o`070003WmnO01/0
00>100005P000ol0000J00009`000ol0000B0003P@0001L000>100003@02o`B100?o^k/01K/00omK
F`04o`AK00?oFe/01U/00onk^`0A^`Co1X400onk^`04^`Co1X44o`8000>100001`000ioOW`0J0003
P@0001H000?o00006P0002L000?o00004P000h40000G0003P@0000h000?oPH400h402?o;^l^kbk_;
0_l9F`03oe]K009K0_l2F`0Fol^kbk_;^l^kbk_;^l^kbk_;^l^ko`R100?obk/00ol9P@05o`000?l0
0P000h40000600BO6P000h40000F0003o`0001X0000W0003o`00018000>100005`000h40000?0003
oh6100>10_l7^`;o25/4oaZk00?oPH400X42o`:10_l4P@Go1`001?l008440008gioOWmnOgilJ0003
P@0001H000?o00006P0002H000Co0?oo4P000h40000G0003P@0001400_l4P@0:ok_;^l^kbk_;o`9K
0ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01_l4P@Go3@001_l0086O4@NO7@000h40
000F0003o`0001X0000V0003oh4001<000>100005`000h40000B0003oh6100>100?o^k/01[/2oajk
1?l9P@03o`00010000GogioOW`02g`03Wml0020000>100005P000ol0000J00005P03o`@00_l70003
o`2101<000>100005`000h40000C0003oh6100>10_l08/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/4o`J11?lB00>O00HAoa6O4IlV0003P@0001H000?o00006@0001L000?o00000P001?l0
0?l60003o`0000:14@000h40000G0003P@0001@000B1oooo0h42oafk0ol3P@?o0h400ol0000@0009
WmnOgioOWmoo008000>100009@000h40000F0003o`0001T0000G0003o`00008000Co003o1P000ol0
00020003P@0000h000>100005`000h40000D0004P@00o`F101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`06o`F10olE00NO0`001?l0084W0003P@0001H000?o00006@0001L000?o00000P001?l00?l60003
o`0000<00X4=0003P@0001L000>100005@001H40003o00F10_l>^`Ko1845o`03084001<000NOgioO
WmnO00L000Co00219`000h40000F0003o`0001T0000G0003o`00008000Co003o1P000ol0000500:1
2`000h40000G0003P@0001D000>100000P03o`B100_obk_;^l^kbk_;^`03o`V10_l50003P@0000h0
00ZOgioOWmnOgioO20001Ol0002102H000>100005P000ol0000I00005P02o`D00_l70003o`0000L0
00>1000020000h40000G0003P@0001D000>1000010000on1P@03P@03ok^k00:k1Ol5P@Go2@000h40
000:00CO00FOgioOW`0=0005o`0008409P000h40000F0003o`0001T0000U0003o`0000T00X480003
P@0001L000>100005@000h4000050003oh6100>11?l3P@Oo3P000h40000600ZO4@001?l0084V0003
P@0001H000?o00006@0002D000?o00002`000h4000050003P@0001L000>1000050000h40000800;o
0k/5P@?o4`000h4000030003Wa6O00GO5P001?l0084V0003P@0001H000?o00006@0002D00ol<00:1
1@000h40000G0003P@0001@000>100002@000onkb`05oaL000^1017O4MlAga7O4@0I0004o`00PBH0
00>100005P000ol0000I00009@000ol0000>0003P@00008000>100005`000h40000D0003P@0000X0
0_lL00>O00@AWa6O7@001?l0084V0003P@0001L000?o0000600002D000?o00003`02P@8000>10000
5`000h40000D0003P@0000X000?o00005`0029oOWmnOgioO80001?l0084V0003P@0001L000?o0000
600002D000?o00004@000h40P@0I0003P@0001@000>100002P000ol0000C00VO8`001?l0084W0003
P@0001H000?o0000600002D000?o00004P02PAT000>1000050000h40000:0003o`0000l01]l00ioO
W`030003P@00024000Co00219`000h40000F0003o`0001P0000U0003o`0001<00X4H0003P@0001@0
00>100002P000ol0000;0003WmnO00JO1`000h40000Q0004o`00PBL000>100005P000ol0000H0000
90000ol0000C0003P@0000:15P000h40000D0003P@0000X000?o00001`04g`03WmoO00;O2`000h40
000Q0004o`00PBL000>100005P000ol0000H000090000ol0000C0003P@0000800X4D0003P@0001@0
00>100002P000ol000030009gmkOg]oNgmkO00l000>100008@001?l0084W0003P@0001H000?o0000
600002@000?o00004`000h4000040003P@00014000>1000050000h40000:0003g]oN00SO00D0g]oN
g`0>0003P@00024000Co00219`000h40000F0003o`0001P0000T0003o`0001<000>100001@02PA00
00>100005@000h40000300cO00?Ng`001P000moNg`0=0003P@00024000Co00219`000h40000F0003
o`0001P0000T00;o50000h4000070003P@0000d000>100005@000h40g`06g`08g]oNgmkOWml;0003
gmkO00`000>100008@001?l0084W0003P@0001L000?o00005`0002@000?o00004`000h40000800:1
3@000h40000E0003P@3O00KO00FOgioOo`0?0003gmkN00/000>100008@001?l0084W0003P@0001L0
00?o00005`0002@000?o00004`000h40000:0003P@0000X000>100005@0018400003g`03Wml000<0
00?o00003@04g`X000>100008@001?l0084W0003P@0001L000?o00005`0002@000?o00004`000h40
000;00:12P000h40000E0003P@0000800ml50003o`0000l000?Ngmh02@000h40000Q0004o`00PBL0
00>100005`000ol0000G00008`000ol0000D0003P@0000d000>100001`000h40000E0003P@0000<0
0]l50003o`0001000ml00mh000050003P@00024000Co00219`000h40000G0003o`0001L0000S0003
o`0001@000>100003P02P@L000>100005@000h4000090003o`00018000GNgmkOgP050003P@000240
00Co00212@02U@03g9D001X000>100005P000ol0000G00008`000ol0000C0003P@00014000>10000
10000h40000E0003P@0000T000?o000050001=kOg]l40003P@00024000Co002119D01mbEg9GLUM`0
0YDK0003P@0001D000>1oh40600002<000?o00004`000h40000B00:110000h40000E0003P@0000T0
00?o00005P03gP<000>100007@04U@03oiFE00NE00OLUMbEg9GL01/000>100004005P@030?l001P0
000S0003o`0001<000>100005002P@8000>100005@000h4000090003o`0001L000?OgP000P000h40
000I0005LIEaUG400iD00onEU@02U@;L00NEg9GLUMbE01h000>100002`05P@H000?o00005`0002<0
0_lD0003P@0001H000>108405`000h4000090003o`0001D00]l2gP<000>100004`0019GMUMd7U@04
09FEo`NE00?LU@008@000h40000600F130000ol0000F00008`000ol0000C0003P@0001L00X4F0003
P@0000X000?o00004@08gP<000>100002`003g6ELIEaUG6ELIEaUG6EL@050008gMcog=gLgM`V0004
P@0000F14@000ol0000F00008`000ol0000C0003P@0001P00X4E0003P@0000X000?o00003`000mkO
g`04g`H000>100001@002MeagIGMUMfEg@02U@04gIGMU@L01YD01Ol0002102H01H4F0003o`0001H0
000S0003o`0001<000>1000060001840PH4C0003P@0000X000?o00003`000mkOgP0:000?gIGMUMfE
gIGMUG6ELIEa00/000^Eg9GLUMbEg9GLo`030003P@0001l01H400`21000H0003o`0001H0000R0003
o`0001@000>1000060001H400021018000>100002P000ol0000=00;N00?OgP000P000iEaU@07L@07
gG7MLMeag@0=0004UMbEg0FE1@001Ol0002101`01H460003P@0001L000?o00005P00028000?o0000
50000h40000G0003P@0000<00X4@0003P@0000X000?o00002@003=kOg]oNgmiagG7ML@;M00ZEgIGM
UMd0gIGM3@002YGLUMbEg9GLUM`90004o`00PAL01H4;0003P@0001L000?o00005P00028000?o0000
50000h40000G0003P@0000D000>100003@000h40000:0003o`0000L00mh4g@08UG6ELIEaU@03L@<0
00>100003@001mbEUMbEg9D03P001?l0084C00B140000h40000G0003o`0001H0000R0003o`0001@0
00>100005`000h40000600:13@000h40000:0003o`00008000=agG402Md00g7ML@0;0003P@0000T0
00REg9GLUMbEg14000Co00213P05PAD000>100005P000ol0000F00008P000ol0000C0003P@0001P0
00>1000020000h40000:0003P@0000L017402=eagG7MLMea1MdA0003P@0000D000WLUMbEg9GLUM`0
50001?l0084900F16P000h40000F0003o`0001H0000200?o7@000ol0000C0003P@0001P000>10000
2@02P@X000>100000`004G7MLMeagG7MLMeagG7NLMia00;N4`003H40002Eg9GLUMbEg9D060001?l0
084400F17`000h40000G0003o`0001D000020004o`00oa`000?o00004`000h40000H0003P@0000/0
0X480003P@0000<01G400miagP02gP=a00?NLMh05P03g006UMbEg9GL70000ol00005PB@000>10000
5`000ol0000E00000P000ol0000M00;o50000h40000H0003P@0000d000>100001@000h40000500Aa
00KNLG5agW4F0009UMbEg9GLUMbE01h00X401?n1PH4X0003P@0001L000?o00005@00008000?o0000
70000ol0000D0003P@0001P000>100003P02P@D000>100001`03L@03omkN00;N4P09g1d01H420004
o`00PBP000>100005`000ol0000E000000<0ool00_lL0003o`0001@000>1000060000h40000@0003
P@00008000>100002002L@04o`1aL@l01]`00iGLU@030003P@0001H01H470004o`00PBP000>10000
5`000ol0000E00000P000ol0000L0003o`0001@000>1000060000h40000A00:10P000h40000:0003
o`0000`02M`70003P@0001401H4<0004o`00PBP000>100005`000ol0000E00000P000ol0000L0003
o`0001@000>1000060000h40000C0003P@2100`000?o00002009g0/000>100003005PA4000Co0021
:0000h40000G0003o`0001D0000Q0003o`0001@000>1000060000h40000D00:130000ol0000400WL
3`000h40000800B15P001?l0084X0003P@0001L000?o00005@00024000?o000050000h40000H0003
P@0001D00X4;0004o`3L]`_/40000h40000300F16P001?l0084X0003P@0001L000?o00005@000240
00?o000050000h40000H0003P@0001D000B108610`0:k0GL0`001NcLk=c/00h01X4O0004o`00PBT0
00>100005`000ol0000D00008@000ol0000C0003P@0001P000>100005P004H7Lg=c/g>cLk=bgg;OL
]mc/00X000C/g>cL2@05PB@000Co0021:@000h40000G0003o`0001@0000P0003o`0001@000>10000
60000h40000F0003PNc/00G/00KLk>c/g?l?0004k=c/g0801H440003P@00028000Co0021:@000h40
000G0003o`0001@0000P0004oh7ooa<000>1000060000h40000F0007PMc/g>cLk002g0@000?o0000
3P001Mc/k>b100T000>100008P001?l0084Y0003P@0001L000?o0000500001401?l300;o1P001?l0
PH4C0003P@0001P000>100005@000h4000030005g>cL08400`000ol0000900F10P000mc/g0090003
P@00028000Co0021:@000h40000G0003o`0001@0000B0003o`00008000Co003o1@001Ol000210180
00>1000060000h40000E0003P@0000@000C/g0000X400`3o000500F12003k0P000>100008P001?l0
084Y0003P@0001L000?o0000500001<000Go0000o`020003o`0000<000?o00000P02PA0000>10000
60000h40000E0003P@0000X000>1o`001H4>0003g>c/00L000>100008P001?l0084Y0003P@0001L0
00?o0000500001@000Co003o0P000ol000030003o`0000@00X4>0003P@0001P000>100005@000h40
000;0003oh40018000CLk=c/1P000h40000R0005o`000840:0000h40000G0003o`0001@0000A0004
o`00o`8000Co003o1@000ol000060003P@0000/000>1000060000h40000E0003P@0000/000?o0000
50000ncLk0050003P@00028000Go0000P@0600043KD=]@<=6`000h40000G0003o`0001@0000B00;o
1002o`H000?o00001`02P@/000>1000060000h40000E0003P@0000/000?o00005@001>cLk=`30003
P@00028000Go0000P@023@05]@fe3KD01PdK0003P@0001P000?o00004`00020000?o00002@02P@T0
00>1000060000h40000E0003P@0000/000?o00005005k0<000>100007P04]@06okD=]@fe0Pd00kD=
3@073A/000>1000060000ol0000C00007`000ol0000<0003P@0000H000>1000060000h40000E0003
P@0000X000?o00004P08k0<000>100005P0010fe3KD83@03o`d=008=00?<3@d01PdO0003P@0001P0
00?o00004`0001l000?o00003@02P@D000>100006@000h40000E0003P@0000X000?o000040000nbg
k003k0L000>100003@0B]@0400feo`T=90000h40000G0003o`0001<0000O00?o3`02P@<000>10000
6@000h40000E0003P@0000X000?o00004002]`03k00000P000>100002@003o`=o0gl3KD=]@fe3KD=
00033@D000P=c0go3L`=c2P000>100005`000ol0000C00007`000ol0000A0004P@00PA/000>10000
5@000h40000:0003o`00010000>f]`002P000h40000300033KD=00Re00@0]KFe2P073@04o`00PBT0
00>100005`000ol0000C00007`000ol0000B00>16P000h40000F0003P@0000X000?o000030001;Nf
]kH2]`T01;D02`fe3KD=]@feo0gl00h000`=c0g<3L`=c0g<0?l20003P@0002L000>100005`000ol0
000C00007`000ol0000D00:16@000h40000F0003P@0000X000?o000020002KJg][Nf]kJg]P020003
]@fe008=00be3KD=]@fe3KD=]@d@0003c0g<00H=1P001?l0084Y0003P@0001L000?o00004`0001l0
00?o000050000h40P@0H0003P@0001H000>100002P000ol0000800>g00<=]@d03[D00`21000A00X=
2@001?l0084Y0003P@0001L000?o00004`0001l000?o000050000h400002PAH000>100005P000h40
000:0003o`0000@03;D010fe3KD90003P@0000`000W<3L`=c0g<3L`03P001?l0084Y0003P@0001P0
00?o00004P0001h000?o00005@000h40000200:150000h40000F0003P@0000T000Be][Ff1kD01@fe
3KD=014000>100001`002l`=c0g<3L`=c0g<014000Co0021:@000h40000H0003o`000180000N0003
o`0001D000>100001002PA8000>100005P000h4000030003o;Fe00be00Ff]kJg]P0C0003P@0000<0
00?<3L`00Pd01L`=c0g<01H000Co0021:@000h40000H0003o`000180000N0003o`0001D000>10000
1P000h40000?0003P@0001H000>100000`002;Ff]KJe][Ff0kD2]P04]kJg]QH000>100d02@dJ0004
o`00PBT000>1000060000ol0000B00007P000ol0000E0003P@0000L00X4?0003P@0001H000>10000
0`03]@?l1[H00kL0000H0007c0g<3L`=c00O0004o`00PBT000>1000060000ol0000B00007P000ol0
000D0003P@0000X00X4=0003P@0001H000>100001`03]@05o`2fo;H05`002<`=c0g<3L`=8P001?l0
084Z0003P@0001L000?o00004P0001h00_lE0003P@0000`000>100002P000h40000F0003P@0000P0
0_`00ol00002]Q<00l`01Pg<3L`=c2D000Co0021:P000h40000G0003o`000180000N0003o`0001@0
00>100003@02P@X000>100005@000h40000;0003o`0001001`d00l`=c0030003P@0002<000Co0021
:P000h40000G0003o`000180000N0003o`0001@000>100003`02P@P000>100005@000h40000;0003
o`0000`02/`70003P@0002<000Co0021:P000h40000G0003o`000180000M0003o`0001D000>10000
4@000h4000050003P@0001D000>100002`000ol0000800063L`=c0g<0`d<0003P@0002<000Co0021
:P000h40000H0003o`000140000M0003o`0001D000>100004P02P@D000>100005@000h40000;0003
o`0000@01/`00l3<c00@0003P@0002<000Co0021:P000h40000E00>100?o00004@0001d000?o0000
5@000h40000D00:10P000h40000F0003P@0000/000?o00002l`00l3<000?0003P@0002<000Co0021
:P000h40000@00F10`000ol0000A00007@000ol0000E0003P@0001H000>1084060000h40000501;<
00<0`<000/0?0003P@0002<000Co0021:P000h40000:00J120000ol0000A00007@000ol0000E0003
P@0001L00X4H0009P@3<c0g<3L`=00W<00@0c<c<1`000lc0c00>0003P@0002<000Go0000P@0Y0003
P@0000D01H4>0003o`000140000M0003o`0001D000>100006003PAH000>10<`01/`01Pg<c<`=o`l0
0l000l`0000:0003P@0002<000Go0000P@0Y0003P@2100F14`000ol0000A00007@000ol0000E0003
P@0001P000B100215@001h403L`=c0d00l`40003o`0000h000?<`<000/0:0003P@0002<000Go0000
P@0V00F16@000ol0000A00007@000ol0000D0003P@0001T000B100000X4C0003P@0000<000?<3L`0
1@000ol0000@0004c<3<`0T000>100008`001Ol0002102001X440003P@0001L000?o00004@0001`0
0olE0003P@0001T000>100000`02PA4000>1000010000l`=00040003o`0001800l080003P@0002<0
00Go0000P@0J00J12P000h40000G0003o`000140000L0003o`0001D000>100006@000h4000050003
P@0000h000>100002`000ol0000C0003`<c000L000>100008`001Ol0002101D01H4@0003P@0001P0
00?o0000400001`000?o00005@000h40000I0003P@0000H00X4>0003P@0000/000?o00004`04`0H0
00>100008`001Ol0002100l01X4E0003P@0001P000?o0000400001`000?o00005@000h40000I0003
P@0000P00X4<0003P@0000/000?o00005@03`0D000>1000090001?l0084:00F16`000h40000H0003
o`000100000L0003o`0001D000>100006@000h40000:00:12P000h40000;0003o`0001H00l001LH0
002102H000Co00211006PB0000>1000060000ol0000@000070000ol0000E0003P@0001T000>10000
30000h4000070003P@0000/000?o00005`02`005aP0008409P000ol00005P@<000A=C4e<0TdM0003
P@0001P000?o0000400001`000?o00005@000h40000I0003P@0000d00X470003P@0000/000?o0000
4`07`0<000>100008@03P@06oh5<CDa=1d`014e<C4`M0003P@0001P000?o0000400001`000?o0000
5@000h40000I0003P@0000l00X450003P@0000/000?o00003`0:aP@000>1000070003H5<CDa=C4e<
oda=C4d00T`:CAd000>1000060000ol0000@000070000ol0000E0003P@0001P000>100004P000h40
00020003P@0000/000?o00003`000l36`002`0T000>100005@000de<C@0;C00?COm=C85<CDa=C4e<
CDa=020000>1000060000ol0000@00006`000ol0000E0003P@0001T000>100004`02P@8000>10000
2P000ol0000@0003a/0000/000>10000300>C004CDa=C0H000?oCDd01TdU0003P@0001P000?o0000
400001/000?o00005@000h40000I0003P@0001D00h4<0003o`0000h01<H<0003P@0000@01D`03De<
CDa=C4e<CDa=C4d02P002Da=C4goCDa=C00Y0003P@0001T000?o00003`0001/00olE0003P@0001T0
00>100005P02P@`000?o00002P08aPX04T`>00U=00Co0021:`000h40000H0003o`0000l0000K0003
o`0001D000>100006@000h40000F0004P@21P@X000?o000020000lJ<aP04aPL000><C4`03D`00h40
000?00==00M<CDa=C4e<00<000Co0021:`000h40000H0003o`0000l0000K0003o`0001D000>10000
6@000h40000F0004P@0000:120000ol0000800:<00K6002<C8`=C0B14P07C0==20001?l0084[0003
P@0001P000?o00003`0001/000?o00005@000h40000I0003P@0001H000>100000`000h4000050003
o`0000D000A<S4b<1d`01ha<S4b<C8`018430003P@00010024d<0004o`00PB/000>1000060000ol0
000?00006`000ol0000E0003P@0001T000>100005P000h40000400:10`0058a<S4b<C8a<S4b<C8a<
S4b<C8`00d`4P@P000>1000030000de<C@04C0h01Ol00`21000Z0003P@0001P000?o00003`0001/0
00?o00005@000h40000I0003P@0001H000>100001002C00=S4b<C8a<S4b<C8a<S005C003086100>1
3P000h400008000:CDa=C4e<CDa=C0X01Ol50003oh4002X000>1000060000ol0000?00006P000ol0
000F0003P@0001T000>100005P000h400004000;C8a<S4b<C8a<S4`018`6PA<000>1000010002De<
CDa=C4e<C@0900Ko2`02obX000>1000060000ol0000?00006P000ol0000F0003P@0001T000>10000
5P000h400004000<S4b<C8a<S?l0S4b<0h4I0003P@1=00Y=1`05oa4000>10?l0:@000h40000H0003
o`0000l0000J0003o`0001H000>100006@000h40000F0003P@0000T000=<S?l00X400db<000I000:
C4e<CDa=C4e<C@H01_lF0003P@0000;o9`000h40000I0003o`0000h0000J0003o`0001D000>10000
6P000h40000F0003P@0000/000?o00005`0;C@@01_lM0005P@000?l09P000h40000I0003o`0000h0
000J0003o`0001D000>100006P000h40000F0003P@0000/000?o00004`000da=C002C@07C4e<CD`0
P@0200Go8`000h40000200;o90000h40000I0003o`0000h0000J0003o`0001D000>100006@000h40
000G0003P@0000/000?o00003`0:C@801_lX0003P@0000@00_lS0003P@0001P000?o00003P0000X0
0ol400;o1`000on1o`0E0003P@0001T000>100005`000h40000;0003o`0000/000U<CDa=C4e<CD`0
0P05o`<000>10000:0000h4000060003o`00020000>1000060000ol0000>00003@001?l00?l20003
o`0000@000Co086150000h40000I0003P@0001L000>100002`000ol0000700U=1_l80003P@0002P0
00>100001`02ob0000>1000060000ol0000>00003@001?l00?l20003o`0000<000?o00000P02PA80
00>100006@000h40000G0003P@0000/000?o00000`04C@04C6I>IPGo3P000h40000X0003P@0000T0
00?o00007@000h40000H0003o`0000h0000;00;o0`001?l00?l50003o`0000@00X4@0003P@0001T0
00>100005`000h40000;0008oda=ITeVCFH6o`9=4@000h40000X0003P@0000X00_lM0003P@0001P0
00?o00003P0000d000Co003o0P000ol000030003o`0000H00X4>0003P@0001T000>100005`000h40
00050003CFI=00EV1_l01DiVCVH0009>00==ITd03`000h40000X0003P@0000`000?o00006P000h40
000H0003o`0000h0000:00?o1002o`H000?o000020000h40000;0003P@0001T000>100005`002h40
CFI=CTe>CDi=00Go00I=IP1VCFH70004CFI=IPh000>10000:0000h40000=00;o6P000h40000I0003
o`0000d0000I0003o`0000T00X4;0003P@0001T000>100005`001H40CFI=00Ko0VH00`3o000?0003
CFI=00d000>10000:0000h40000?0003o`0001L000>100006@000ol0000=00006@000ol0000;00:1
2@000h40000I0003P@0001L01Ol014i=CTd50003o`0000l000=VCFH030000h40000X0003P@000100
0_lG0003P@0001T000?o00003@0001T000?o00003@02P@H000>100006P000h40000A00Ko00>10000
10000deV00040003o`0000l000IVCFI=ITd90003P@0002P000>100004P000ol0000D0003P@0001T0
00?o00003@0001T000?o00003`02P@@000>100006P000h40000<00Go1@000h40000<0003o`000140
1FH80003P@0002P000>100004`02oa@000>100006@000ol0000=00006@000ol0000A00:10P000h40
000J0003P@0000H01_l:0003P@0000`000?o000050000deVC@070003P@0002P000>100005@000ol0
000B0003P@0001P000?o00003@0001P00olD00>170000h400006oa0000>1000030000ol0000D0004
CVI>IPH000>10000:0000h40000F00;o4P000h40000H0003o`0000d0000H0003o`0001H00X4I00Go
5P000h40000<0003o`0001H000==CTd01@000h40000X0003P@0001P00_l@0003P@0001P000?o0000
3@0001P000?o00005P001840PH4A00Ko0P000h40000F0003P@0000`000?o00005`000fI=IP040003
P@0002P000>100006P000ol0000=0003P@0001P000?o00003@0001P000?o00005P001H40002100/0
1Ol70003P@0001L000>1000030000ol0000H009V10000h40000X0003P@0001/00_l=0003P@0001T0
00?o0000300001P000?o00005P000h40000200:10`06o``000>100005`000h40000<0003o`0001@0
00I>ITiVCVH40003P@0002P000>100007@000ol0000:0003P@0001T000?o0000300001P000?o0000
5P000h40000200Go4P000h40000G0003P@0000`000?o000040002VI>CVI>ITiVCVH40003P@0002P0
00J103m??dl30003Ccm?008o00=?00004002o`X000>100006@000ol0000<000060000ol0000E00Ko
1002PA4000>100005`000h40000<0003o`00010000EVCTiVCP090003P@00024013l01dloCcm??dl0
2clD0003o`0000L000>100006@000ol0000<000060000ol0000?00Ko00<0P@002@02P@l000>10000
5`000h40000<0003o`0001000VH<0003P@0001P000@P?b0o24l02Cm??dloCcl0?`02C`08?dloCcm?
?dlE00;o1`000h40000I0003o`0000`0000G0003o`0000/01Ol60003P@0000/00X4=0003P@0001L0
00>100002`000ol0000?0004CT9V@P`000>100003`002cm??dlPCb1?84lP00Po00@0Ccm?0P001840
?dl8?aX000?o000010000h40000I0003o`0000`0000G0003o`0000D01_l;0003P@0000d00X4;0003
P@0001L000>100002`000ol0000:00Q>00=V00002P000h40000600`o00PP?b0o83lP00=?2007?`03
Ccm?02000_l40003P@0001T000?o0000300001L000?o00001OlA0003P@0000l00X490003P@0001L0
00>100002`000ol000080008@VI2CT9>@Th?0003?dlo00U?00/oCcm??dlo021?800=008o00Q??dlo
Ccm??bH000Go0000P@0K0003o`0000`0000G00?o5P000h40000A00:11`000h40000G0003P@0000/0
00?o000020000di2@P0;000;Ccm??dloCcm??dl023l0100o?clA00Xo0`000h40000V00;o0P000h40
000H0003o`0000`0000I00;o5@000h40000C00:11@000h40000G0003P@0000/000?o00002003@P<0
1Dl03Sm??dloCcm??dloCcl00dlF0003?b0o00Lo1`000h40000X0003o`2101P00h400ol0000;0000
6`02oa<000>100005@000h4000020003P@0001L000>100002`000ol000040004@TloC`8o015??dlo
Ccm??dloCcm?04loC`040003P@0001<000Ho83lP?b04?``000>10000:@02oa801X430003o`0000/0
000M00;o4@000h40000F00:10P000h40000G0003P@0000@00dl200I?00DoCcm??`09C`0404loC``0
00>100003`002R0o83lP?b0o83l@0003P@0002X000>1ool02P06P@T000?o00002`0001l00_l?0003
P@0001P00h4I0003P@0000@001@oCcm??dloCcm??dloCcm?03m??aD000>100002P078003?b0o01D0
00>10000:P0018400?l300J13`000ol0000;00008@02o`d000>100006P02PAP000>100001009C`03
?dlo01d000>10000200023lP?b0o83lP6@000h40000Z00B10_l00h40000C0003o`0000/0000S00;o
2`000h40000I0003P@0000:15P000h40000800=?00?o00000T8M0003P@0000@000@P?b0o0b0N0003
P@0002D01X450003o`0001<000?o00002`0002D00_l90003P@0001T000>100000P02PA@000>10000
2@02C`03o`0001l000>102002R0O0003P@0001l01X450003P@0000@00_lC0003o`0000/0000W00;o
1P000h40000J0003P@0000@00X4A0003P@0000`000?o00007@048006?b0o83lP90000h40000I00J1
2`000h4000060003o`00010000?o00002`0002T00_l40003P@0001X000>100001P02P@l000>10000
30000ol0000H00/P:0000h40000C00J14@000h40000700;o40000ol0000;0000:`02o`8000>10000
6P000h40000800:13@000h40000<0003o`0001@02R000`21000Z0003P@0000d01X4G0003P@0000T0
00?o00003P000ol0000:0000;@02o`03P@0001X000>100002P02P@/000>1000030000ol0000@000:
824P8B0Q824P8@D000>10000:@000h40000700J17P000h40000900;o3P000ol0000:0000;`02oa/0
00>1000030000h4000080003P@0000`000?o000030000b4P8@0680X000>10000:@0018400006PB@0
00>100002`000ol0000;0003o`0000X0000a00;o6@000h40000=00:120000h40000<0003o`0000L0
00/Q824P8B0Q824P8@0=0003P@0002H01h4Z0003P@0000`00_l;0003o`0000X0000c00;o5`000h40
000?00:11P000h40000<0003o`0000<000<Q82400R001B4_8BlQ018000>100008006P@<000>10000
:`000h40000>0003o`0000P000?o00002P0003D00_lE0003P@0001400X440003P@0000`000?o8200
2b42;a8000>100006P06P@T000>10000:`000h40000?00;o20000ol0000:0000=`02oa<000>10000
4`02P@8000>100001P0<8@08;b4_8BlQ;`028@03;`0000l000>100005006P@l000>10000:`000h40
000A00;o1P000ol0000:0000>@02oa4000>100005@03P@800R401B0Q824P00TQ00@08B4Q1P06;`h0
00>100003P06PAD000>10000:`000h40000C0003o`0000<000?o00002P0003/00_l?0003P@0001L0
0X488@06824Q8@3o3`001BlQ;b4_00d000>100002006PA/000>10000:`000h40000D00;o0`000ol0
000:0000?@02o`d000>100005`0018408B068@D000?o00003`000b4_;`0=0003P@0000801X4Q0003
P@0002/000>100005P001Ol0003o00/0000o00;o2P000h40000H0004P@0000:10P000b4P00040003
o`0000l000H_8RlR;b8900J19`000h40000[0003P@0001L00_l00`3o000:0000@@02o`P000>10000
60000h4000030003P@0000H000?o00004@001B4_8BlQ00801X400`21000Z0003P@0002/000>10000
6@02o`/0001300;o1P000h40000H0003P@0000@00X460003o`0001800X40128_8H470003P@0002T0
00>10000;0000h40000F00Co2`0004D00ol30003P@0001P000>100001P02P@@000?o00003006P@80
00DR8B8Q8P060003P@0002X000>10000:`000h40000?00Oo3`0004P00_l00`21000I0003P@0000P0
0X420003o`0000H01X4:00@Q1@000h40000Z0003P@0002/000>100002@06oaH0001:00;o6P000h40
000:00:100?o00001X4B00038R4R00@000>10000:P000h40000[0003P@0000<01_lL0000B`000h7o
o`0H0003P@0000`000?oPH406@000b8Q00030003P@0002X000>10000:P07ob80001>00;o5P000h40
000<0003o`0001D000H_8RlR8B840003P@0002X000>100009006o`03084002H0001@00;o50000h40
000<0003o`00010000/_8RlR;b8_8RlR;`040003P@0002X000>100007@07obl0001B00;o4@000h40
000=0003o`0001000b800blR;`090003P@0002X000>100005`06ocH0001D00;o3`000h40000<0003
o`00018000<R7`002`000h40000Z0003P@0001001oll0000EP02o`d000>1000030000ol0000B008R
30000h40000Z0003P@0000X01_m30000F002o`/000>1000030000ol0000=00HO00<R00002P000h40
000Z0003P@0000@01_m90000FP02o`T000>1000030000ol0000900037b8R00LR3@000h40000Z00Oo
C`0005`00_l70003P@0000`000?o00002@000alR7`027a8000>100009006o`03P@0005<0001N00;o
1@000h40000<0003o`0000T000<O8P0050000h40000M00OoG00006000_l30003P@0000`000?o0000
1`027`038Ql001@000>100005`06of<0001R00;o00<0P@003@000ol0000200078QlR7b8O8P027aD0
00>100004@06ofT0001T00;o3P000ol000087aP000>100002P07ofl0001U0003POoo00`000Ko000R
7b8M0003P@0000@01_mf0000J002o`X000?o00008007og`0001Z00;o20000ol0000J00Ko00>10000
P00006`00_l60003o`0001<01on90000KP02o`@000?o00003@06oi00001`00;o0P000ol0000700Ko
UP0007800ol200OoW00007@00onS0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000
o`0K0000o`0K0000o`0K0000o`0K0000M`000ol0000W0003o`0007H0001B00Co0`04o`040?oo00;o
0P02o`<00ol300?o10000ol0000800Go00@0ool00_l200Go00<0ool00`03o`@000?o00001`03o`@0
1Ol200?o0`02o`<01?l300;o1002odL0001A0005o`000?l00P000ol000030004o`00o`<00_l40003
o`0000D000?o00000P000ol000090005o`000?l00P001?l00?l30003o`0000;o10000ol000040003
o`0000L000?o00001@000ol000020004o`00o`800_l40003o`00008000Co003o0`02odL0001A0003
o`3o00;o0P05o`050?l00?l02@000ol0000300?o40001Ol0003o008000Co003o0`000ol000060003
o`0000h000?o00001@000ol000020003o`0000X000Go0000o`020003o`0004X0001A0003o`0000@0
00Oo0000o`3o008000?o00001`000ol000020004o`00oa0000Go0000o`020004o`00o`<000?o0000
1P000ol0000>00?o1@000ol000020003o`0000/000Co00000_m=0000D@001Ol0003o00<00ol00`3o
o`03o`T000?o00000P001?l00?l@0003o`0000Go0`04o`P000?o00003P000ol0000400;o0`04o`P0
00Co003o0P001?l00?m<0000DP04oa@00_l500;o3`05o`/000?o00001@02o`l01Ol90003o`0000T0
0_l400;oC@0009400_lQ0003o`00008000?o0000GP000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.13214, -0.0191773, 0.00244548, \
0.0038955}},
  CellTags->"AntTracker3D - Gen 19"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 18",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 22",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[advance, \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[seq[stop], \ 
          advance], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ 
        advance, \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[turnLeft, \ \(ifSensor[phero]\)[turnLeft, \ 
              seq[stop]]], \ \n\ \ \ \ \ \ \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.19, Ind.1, Fit.28.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.19, Ind.1, Fit.28.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
1 0 .018 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.894 0 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.876 0 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.858 0 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.84 0 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 .248 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 .266 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 .284 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 .302 1 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 1 .61 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 1 .592 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 1 .574 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
0 1 .556 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.532 1 0 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.55 1 0 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.568 1 0 r
F P
s
P
p
.002 w
.43952 .56184 m .4261 .56572 L .41823 .55853 L p
.586 1 0 r
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
1 0 .018 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.894 0 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.876 0 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.858 0 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.84 0 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 .248 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 .266 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 .284 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 .302 1 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 1 .61 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 1 .592 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 1 .574 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
0 1 .556 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.532 1 0 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.55 1 0 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.568 1 0 r
F P
s
P
p
.002 w
.41823 .55853 m .43169 .55461 L .43952 .56184 L p
.586 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .036 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .054 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .073 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .091 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .109 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
1 0 .127 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.822 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.804 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.785 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.767 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.749 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.731 0 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .32 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .338 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .356 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .375 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .393 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 .411 1 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .538 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .52 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .502 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .483 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .465 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
0 1 .447 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.604 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.622 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.64 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.659 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.677 1 0 r
F P
s
P
p
.002 w
.46656 .554 m .45301 .55793 L .44522 .55066 L p
.695 1 0 r
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .036 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .054 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .073 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .091 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .109 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
1 0 .127 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.822 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.804 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.785 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.767 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.749 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.731 0 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .32 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .338 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .356 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .375 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .393 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 .411 1 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .538 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .52 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .502 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .483 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .465 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
0 1 .447 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.604 1 0 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.622 1 0 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.64 1 0 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.659 1 0 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.677 1 0 r
F P
s
P
p
.002 w
.44522 .55066 m .45882 .5467 L .46656 .554 L p
.695 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
1 0 .997 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.985 0 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.967 0 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.949 0 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.931 0 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.912 0 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .139 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .157 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .175 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .193 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .211 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 .23 1 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .719 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .701 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .683 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .665 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .647 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
0 1 .628 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.423 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.441 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.459 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.477 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.495 1 0 r
F P
s
P
p
.002 w
.42379 .54731 m .41028 .55127 L .40226 .54395 L p
.514 1 0 r
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .145 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .163 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .181 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .199 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .218 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
1 0 .236 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.713 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.695 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.677 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.659 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.64 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.622 0 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .429 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .447 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .465 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .483 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .502 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 .52 1 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .429 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .411 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .393 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .375 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .356 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
0 1 .338 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.713 1 0 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.731 1 0 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.749 1 0 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.767 1 0 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.785 1 0 r
F P
s
P
p
.002 w
.49388 .54609 m .48019 .55006 L .47249 .54272 L p
.804 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
1 0 .997 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.985 0 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.967 0 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.949 0 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.931 0 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.912 0 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .139 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .157 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .175 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .193 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .211 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 .23 1 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .719 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .701 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .683 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .665 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .647 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
0 1 .628 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.423 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.441 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.459 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.477 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.495 1 0 r
F P
s
P
p
.002 w
.40226 .54395 m .41581 .53995 L .42379 .54731 L p
.514 1 0 r
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .145 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .163 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .181 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .199 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .218 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
1 0 .236 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.713 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.695 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.677 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.659 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.64 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.622 0 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .429 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .447 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .465 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .483 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .502 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 .52 1 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .429 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .411 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .393 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .375 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .356 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
0 1 .338 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.713 1 0 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.731 1 0 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.749 1 0 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.767 1 0 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.785 1 0 r
F P
s
P
p
.002 w
.47249 .54272 m .48623 .53871 L .49388 .54609 L p
.804 1 0 r
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
1 0 .254 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
1 0 .272 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
1 0 .29 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
1 0 .308 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.604 0 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.586 0 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.568 0 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.55 0 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 .538 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 .556 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 .574 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 .592 1 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 1 .32 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 1 .302 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 1 .284 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
0 1 .266 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.822 1 0 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.84 1 0 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.858 1 0 r
F P
s
P
p
.002 w
.52148 .5381 m .50765 .5421 L .50004 .53469 L p
.876 1 0 r
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
1 0 .254 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
1 0 .272 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
1 0 .29 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
1 0 .308 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.604 0 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.586 0 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.568 0 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.55 0 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 .538 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 .556 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 .574 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 .592 1 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 1 .32 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 1 .302 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 1 .284 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
0 1 .266 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.822 1 0 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.84 1 0 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.858 1 0 r
F P
s
P
p
.002 w
.50004 .53469 m .51392 .53064 L .52148 .5381 L p
.876 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .471 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .489 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .508 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .526 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .961 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 0 .979 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.387 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.369 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.35 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.332 0 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .103 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .121 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .755 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .773 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .792 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 .81 1 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .755 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .737 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .103 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .085 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .066 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .048 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.387 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
.405 1 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 .961 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 .943 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 .924 0 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
1 .906 0 r
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .471 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .489 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .508 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .526 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .961 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 0 .979 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.387 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.369 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.35 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.332 0 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .103 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .121 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .755 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .773 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .792 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 .81 1 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .755 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .737 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .103 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .085 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .066 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .048 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.387 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
.405 1 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 .961 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 .943 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 .924 0 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
1 .906 0 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 0 .544 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 0 .943 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.314 0 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .085 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 .828 1 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .773 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .03 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
.369 1 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 .888 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
1 0 .326 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
.532 0 1 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 .61 1 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .248 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
.894 1 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 0 .544 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 0 .943 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.314 0 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .085 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 .828 1 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .773 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .03 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
.369 1 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 .888 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
1 0 .326 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
.532 0 1 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 .61 1 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .248 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
.894 1 0 r
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 0 .435 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 0 .453 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
.423 0 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
.405 0 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 .719 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 .737 1 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .139 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .121 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 .997 0 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 .979 0 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 0 .562 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 0 .924 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.296 0 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 .066 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 .846 1 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .792 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .012 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.35 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .87 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 0 .435 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 0 .453 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
.423 0 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
.405 0 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 .719 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 .737 1 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .139 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .121 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 .997 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 .979 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 0 .562 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 0 .924 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.296 0 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 .066 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 .846 1 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .792 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .012 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.35 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .87 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
1 0 .417 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
.441 0 1 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 .701 1 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .157 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
.985 1 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 0 .344 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 0 .58 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 0 .906 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.514 0 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.278 0 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .048 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .628 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 .864 1 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .81 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .23 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.006 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.332 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.912 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 .852 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
1 0 .417 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
.441 0 1 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 .701 1 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .157 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
.985 1 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 0 .344 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 0 .58 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 0 .906 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.514 0 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.278 0 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .048 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .628 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 .864 1 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .81 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .23 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.006 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.332 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.912 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 .852 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.44686 .50075 m .43289 .50495 L .42474 .49718 L p
1 0 .399 r
F P
s
P
p
.002 w
.44686 .50075 m .43289 .50495 L .42474 .49718 L p
.459 0 1 r
F P
s
P
p
.002 w
.44686 .50075 m .43289 .50495 L .42474 .49718 L p
0 .683 1 r
F P
s
P
p
.002 w
.44686 .50075 m .43289 .50495 L .42474 .49718 L p
0 1 .175 r
F P
s
P
p
.002 w
.44686 .50075 m .43289 .50495 L .42474 .49718 L p
.967 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 0 .598 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 0 .888 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.26 0 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .03 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 .882 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .828 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.024 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.314 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .834 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.42474 .49718 m .43876 .49294 L .44686 .50075 L p
1 0 .399 r
F P
s
P
p
.002 w
.42474 .49718 m .43876 .49294 L .44686 .50075 L p
.459 0 1 r
F P
s
P
p
.002 w
.42474 .49718 m .43876 .49294 L .44686 .50075 L p
0 .683 1 r
F P
s
P
p
.002 w
.42474 .49718 m .43876 .49294 L .44686 .50075 L p
0 1 .175 r
F P
s
P
p
.002 w
.42474 .49718 m .43876 .49294 L .44686 .50075 L p
.967 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 0 .598 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 0 .888 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.26 0 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .03 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 .882 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .828 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.024 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.314 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .834 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
1 0 .363 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
1 0 .381 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
.495 0 1 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
.477 0 1 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
0 .647 1 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
0 .665 1 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
0 1 .211 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
0 1 .193 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
.931 1 0 r
F P
s
P
p
.002 w
.47502 .49228 m .4609 .49653 L .45285 .48867 L p
.949 1 0 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
1 0 .616 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
1 0 .87 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.242 0 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 .012 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 .9 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .846 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.042 1 0 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.296 1 0 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
1 .816 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .018 0 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
1 0 .363 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
1 0 .381 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
.495 0 1 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
.477 0 1 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
0 .647 1 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
0 .665 1 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
0 1 .211 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
0 1 .193 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
.931 1 0 r
F P
s
P
p
.002 w
.45285 .48867 m .46701 .48439 L .47502 .49228 L p
.949 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
1 0 .616 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
1 0 .87 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.242 0 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 .012 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 .9 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .846 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.042 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.296 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
1 .816 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .018 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .634 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .852 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.224 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.006 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 .918 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .864 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.06 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.278 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .798 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .036 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .634 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .852 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.224 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.006 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 .918 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .864 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.06 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.278 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .798 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .036 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 0 .653 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 0 .834 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.205 0 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.024 0 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 .937 1 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .882 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.079 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
.26 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .779 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .054 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 0 .653 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 0 .834 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.205 0 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.024 0 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 .937 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .882 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.079 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
.26 1 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .779 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.37997 .46345 m .35181 .47222 L .33428 .45595 L p
.8 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .054 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .671 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .816 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.187 0 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.042 0 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 .955 1 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 1 .9 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.097 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
.242 1 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .761 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .073 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .671 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .816 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.187 0 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.042 0 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 .955 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 1 .9 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.097 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
.242 1 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .761 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.40842 .45458 m .37997 .46345 L .36262 .447 L p
.8 g
F P
s
P
p
.002 w
.33428 .45595 m .36262 .447 L .37997 .46345 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .073 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 0 .689 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 0 .798 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.169 0 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.06 0 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 .973 1 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .918 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.115 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
.224 1 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .743 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .163 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .145 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .127 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .109 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .091 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 0 .689 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 0 .798 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.169 0 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.06 0 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 .973 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .918 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.115 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
.224 1 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .743 0 r
F P
s
P
p
.002 w
.36262 .447 m .39127 .43795 L .40842 .45458 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .163 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .145 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .127 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .109 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .091 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 0 .707 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 0 .779 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.151 0 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.079 0 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 .991 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
0 1 .937 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.133 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
.205 1 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .725 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 0 .707 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 0 .779 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.151 0 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.079 0 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 .991 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
0 1 .937 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.133 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
.205 1 0 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .725 0 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 0 .725 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 0 .743 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 0 .761 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.133 0 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.115 0 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.097 0 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 1 .991 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 1 .973 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
0 1 .955 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.151 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.169 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
.187 1 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .707 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .689 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .181 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 0 .725 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 0 .743 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 0 .761 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.133 0 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.115 0 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.097 0 1 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 1 .991 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 1 .973 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
0 1 .955 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.151 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.169 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
.187 1 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .707 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .689 0 r
F P
s
P
p
.002 w
.42024 .4288 m .39127 .43795 L .37377 .42098 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .181 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.37377 .42098 m .40293 .41164 L .42024 .4288 L p
.8 g
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .671 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .526 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .508 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .199 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .671 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .526 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .508 0 r
F P
s
P
p
.002 w
.40293 .41164 m .37377 .42098 L .3559 .40366 L p
.8 g
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .199 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.74258 .41182 m .72701 .4165 L .71992 .40784 L p
1 .489 0 r
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.71992 .40784 m .73554 .40311 L .74258 .41182 L p
1 .489 0 r
F P
s
P
p
.002 w
.3559 .40366 m .38527 .39412 L .40293 .41164 L p
.8 g
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .653 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .544 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .471 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .218 0 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .653 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .544 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .471 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .218 0 r
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
1 .453 0 r
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
1 .453 0 r
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .634 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .562 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .236 0 r
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .435 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .417 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .634 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .562 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .236 0 r
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .435 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .417 0 r
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 .616 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 .598 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 .58 0 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .272 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .254 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.82444 .36506 m .80821 .37001 L .80135 .36086 L p
1 .399 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 .616 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 .598 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 .58 0 r
F P
s
P
p
.002 w
.34882 .35798 m .31904 .36792 L .30002 .34948 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .272 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .254 0 r
F P
s
P
p
.002 w
.80135 .36086 m .81765 .35586 L .82444 .36506 L p
1 .399 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
1 .29 0 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.30002 .34948 m .33001 .33932 L .34882 .35798 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
1 .29 0 r
F P
s
P
p
.002 w
.53722 .34481 m .50613 .3549 L .48898 .33618 L p
.8 g
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .381 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .363 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .344 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .326 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 .308 0 r
F P
s
P
p
.002 w
.33001 .33932 m .30002 .34948 L .28059 .33064 L p
.8 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .381 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .363 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .344 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .326 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 .308 0 r
F P
s
P
p
.002 w
.48898 .33618 m .5203 .32587 L .53722 .34481 L p
.8 g
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.28059 .33064 m .31079 .32027 L .33001 .33932 L p
.8 g
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.58406 .30488 m .55199 .31544 L .53495 .29586 L p
.8 g
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.53495 .29586 m .56727 .28507 L .58406 .30488 L p
.8 g
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.32193 .29006 m .29116 .30079 L .27108 .28089 L p
.8 g
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.35308 .27921 m .32193 .29006 L .30208 .26992 L p
.8 g
F P
s
P
p
.002 w
.27108 .28089 m .30208 .26992 L .32193 .29006 L p
.8 g
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.30208 .26992 m .33346 .25882 L .35308 .27921 L p
.8 g
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.41651 .2571 m .3846 .26822 L .36521 .24758 L p
.8 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.58307 .25365 m .5501 .26481 L .53254 .2441 L p
.8 g
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.4488 .24584 m .41651 .2571 L .39736 .23621 L p
.8 g
F P
s
P
p
.002 w
.36521 .24758 m .39736 .23621 L .41651 .2571 L p
.8 g
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.53254 .2441 m .56578 .23268 L .58307 .25365 L p
.8 g
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.39736 .23621 m .42991 .22469 L .4488 .24584 L p
.8 g
F P
s
P
p
.002 w
.56578 .23268 m .53254 .2441 L .51459 .22291 L p
.8 g
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.51459 .22291 m .5481 .21123 L .56578 .23268 L p
.8 g
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00_l=P@03oh6100N10ol00k_oP@0=P@08ol^kbk_;^ol20003o`0000<000?o0000B`000480
00?o00004`03oaP00ol:^`?o2H400on1P@0<P@03ok^k01Fk0ol00e_o^`0G^`?o00>1oh403H400on1
P@03P@?o1K/00on1P@0;P@03ok^k00Fk00Co003o1@000ol0001:0000@P04o`l00olH00?o00^kbk_;
^l^kbk_;^`02o`f100?oPH401h43o`0FPOo;^l^kbk_;^l^kbk_;^l^kbk_;^`?o1E/05Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<0
00?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0>^`?o
2E/00onk^`0>^`?o2H400on1P@0<P@03ok^k00^k00?oPH402H400on1o`06^`05o`000?l010000ol0
00190000D002o`<000?o00004`03o`0:bk_;^l^kbk_;^`?o1H400on1P@0<P@03oh7o00;o2H404?o;
^l^kbk_;^l^kbk_;^ol=F`0>ok_;^l^kbk_;^l^kbk/2o`f100?oPH401h43o`0@bk_;^l^kbk_;^l^k
bk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o2H400on1
P@0<P@03oh6100^100?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH4038400on1P@04P@?o4k/00on1
P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N1
0ol00k_;o`0=P@0?ol^kbk_;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;^l^kbol03X400on1P@03o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003o`00008000?o0000A`0004P0
0_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk
^`0;^`03oh6100b10_lJ^`03oh6100b100?o^k/01;/01?l00?l50003o`0004H0001500?o0P000ol0
000C00?o00Vkbk_;^l^kbk/00ol7P@03oh6100^100?oPOl00_l02k_;^l^kbk_;^l_o00f100oobk_;
^l^kbk_;^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l0
0ol9^`?o2h400on1P@0;P@03ok^k00bk00?oPH401X43oa2k00?oFe/015/4o`9K00?o^k/03;/00on1
P@03P@?o1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o
00Vkbk_;^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l05K_;
^l^kbk_;^l^kbk_;^l^kbk_;o`02F`?o1e/04Onkbk_;^l^kbk_;^l^kbon100?o2H407Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000?@03oaL0
1?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o5k/2o`]K00?o^k/03;/00on1P@0;P@03
ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo0003o`<00_lD0000
>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=F`0?ok_;^l^kbk_;^l^k
bk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`F100Sobk_;^l^ko`<000?o0000
0P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o6003o`Vk0_l=P@03oh6100V100?oPOl0
5k/3o`03Fonk01Zk00?oFe/02e/00onk^`0;^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/0
1;/01Ol0003o00@000?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;
^l^kb`?o0X400on1P@0;P@03oh6100B11?l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1E/07Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00eK00oo^l^kbk_;^l^kbk_;^ol03X406oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`f100Sobk_;^l^ko`8000?o00000`000ol0000K00Go0`000ol0
o`050003o`0001<0000b00Go5P03o`Vk0_l6P@03oh6100^100?oPH400olH^`?o2E/00onk^`0:^`;o
3K/00omKF`09F`03oe_o00fk00?oPH401h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D0
00?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V1
00?oPH402h42o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`eK00Wo^l^kbk_;^l/00ol04H7o
bk_;^l^kbk_;^l^kbk_o00IK1?l2F`0@ol^kbk_;^l^kbk_;^l^ko`F10ol5P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`j100So^l^kbk_;o`<000?o00000P000ol0000J0003o`0000d000?o0000
4`00010000Co003o6@02oaP00ol:^`;o3H400on1P@06P@?o6K/3o`03FomK00eK00?o^k/00k/2o`F1
00?o^k/03;/00omKF`03o`MK00?o^k/03;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk
00Co003o1@000ol0000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH40
2h400on1P@03P@;o01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1E/00omKF`0<F`03ok_o00;o
28403oo;^l^kbk_;^l^kbk_;^`02o`]K013obk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_lH^`?o2E/00omKF`0<F`03oh6100Z1
00?o^k/02k/00omKF`0;F`03ok^k00^k00?oPH402h400onk^`0I^`03oh6100Co1h400onk^`04^`05
o`000?l00`02od00000@0004o`00oa400_lH00?o00[;^l^kbk_;^l^k0ol9P@03oh6100^101co^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/00omKF`07F`?o00?;oh4038403oo;^l^kbk_;^l^kbk_;
o`0=F`0?ol^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@08
ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f100?oPH40
1X43oajk00?oFe/02U/00omKF`03F`?o1K/00on1P@0;P@03ok^k00^k00?oFe/02e/00onk^`0;^`03
oh6100^100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000060003o`00008000Co003o
;@0001l01?lG00?o00Vkbk_;^l^kbk/00ol4P@03oh6100Z100?oPH400h42o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol035/00omKo`02o`0:bk_;^l^kbk_;o`f100oobk_;^l^kbk_;
^l^kbol02e/04OmKol^kbk_;^l^kbk_;^l_o00R10ol07X7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l00?l]00007003o`@0
00?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lF^`;o3K/00omKF`0:F`03ok^k00^k00?oPH40
1X43o`03POnk00fk00?oFe/015/4oa2k00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03ok^k00Bk
00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/00ol<P@03
oh6100Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0AFoo;^l^kbk_;^l^kbk_;^ol01U/3o`0B
bk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1013o^l^kbk_;^l^kbk_;^l_o0U/3o`0G^l^kbk_;^l^kbk_;
^l^kbk_;^l^koh400ol9P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^k
bol20003o`0000<000?o000010000ol000020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^1
00?oPH401843oaNk0_l5F`03ok^k00bk00?oFe/00olE^`03oh7o00;o28400onk^`0<^`;o6K/00on1
P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D00_l^00005003o`03
0?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0G^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol8F`0?ol^kbk_;^l^kbk_;^l^k00;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`b1
02[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o0000
3`03o`Vk0ol9P@03oh6100^10_lG^`?o35/00onk^`0P^`Co0h400on1P@0:P@03ok^k02Jk00?oPH40
2h400onk^`0I^`;o38400onk^`04^`04o`00o`D000?o0000>00001<000?o0?l04`04o`09^l^kbk_;
^l^k00;o3H400on1P@06P@?o01Nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`=K00?oFe/02U/07oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol8P@03oh6100Z102[o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f1
00Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o0X400on1P@0;P@03
oh6100>10_lG^`?o1e/00omKF`0:F`03ok^k01Rk0ol<P@03oh6100Z100?o^k/09[/00on1P@04P@Co
0X400onk^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o
00Zkbk_;^l^kbk_;0_l6P@03oh6100^100?oPOl00_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o
2e/00omKF`0:F`0Gol^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol00h7oP@0=P@03oh6100B10ol0;K_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o1h407Onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0000f00004`000ol0
00020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k01Rk00?oFe/02e/00omKF`04F`?o5k/2o`F1
00?oPH4038400on1P@03oc2k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0
000e00004`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`0N^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3E/00omKF`03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol8P@03oh6100b10_l05k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Zkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol0
0P001?l00002ocL0000B0003o`0000D000?o0?l00_l9^`?o18400on1P@0:P@03oh6100>10_lQ^`03
oe]K00]K0_lG^`?o38400on1P@07P@?o5[/4o`9K00?o^k/06;/00on1P@0;P@03ok^k01Rk00?oPOl0
0_l9P@03ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03
oh6100Z100?oPOl00_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol025/3o`0G
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0F^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o1e/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l00003o`@0
00?o^k/00k/2o`b100?oPH402X400onk^`0V^`03oe]K00=K0_lG^`?o1h400on1P@0:P@03oh7o00;o
5k/2o`]K00?o^k/06;/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o10000ol0
000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`0^bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oF`?o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol;P@03oh6100Z1
01co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3E/07?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^ol5P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08ok_;^l^kbol20003o`0000<0
00?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oc2k00?o^k/05;/3o`03POn100b1
00?oPH401843oajk00?oFe/02e/00onk^`0H^`03oh7o00;o28400onk^`0H^`03oh6100^100?o^k/0
1;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
1H400on1P@0;P@03oh6100?o02>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`0=F`0I
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Wobk_;^l^kbol00P000ol0000200;o<P0001D000?o00002@000onk^`03^`03oh6100J1
0ol3P@03ok^k04:k0ol8P@03oh6100^10_lV^`03oe]K00IK0olF^`Co0X400on1P@0:P@03ok^k01Vk
00?oPH400ol7P@03ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F1
0_l7P@14ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol<P@03oh6100J10ol0:h7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01E/2o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003
o`0000T00_l4^`03oh7o00;o2X400onk^`10^`03oh6100Z100?oPH400h42o`F100?o^k/09[/00omK
o`02oaFk0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_0000
60000ol0000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R103oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol00h7oP@0<P@03
oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003
o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0<[/2o`bk00?oPH40
2X400on1P@0:P@03ok^k03Rk0ol5P@03oh6100^100?oPH400olR^`03oh6100Z100?o^k/01;/01?l0
0?l50003o`0002d0000J00;o2`001oo;^l^kbol03H40<Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol045_o^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0g
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V1
00?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00N10ol02X7o
bk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k0_l8P@;o0X400onk^`0[^`;o
1E/00onk^`0;^`03oh6100?o1h400on1P@0:P@03ok^k01Nk0_lG^`?o3H400on1P@06P@?o:K/00on1
P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol000090008ol^kbk_;^ol4P@?o1H40:_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o25/03_nkbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z101Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2F`0Dol^kbk_;^l^kbk_;^l^kbk_;
^l/3o`>100?oPH402X400on1P@03P@?o02nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`8000?o00000`000ol0000[00007P000ol000090003
ok^k00Bk00CoPOoo2H400onk^`0U^`03oe]K00YK00?o^k/02k/00on1P@0:P@03oh6100B10olF^`;o
1U/00onk^`0=^`?o1h400on1P@0:P@03oh7o00;o<K/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0
000Z00007`000ol000090008ol^kbk_;^ol<P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol035/03onkbk_;^l^kbk_;^l^ko`0<P@03oh6100?o01Jkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;0ol9F`0=ol^kbk_;^l^kbk_;^`02o`^100?oPH402X40=_nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000P000ol0
000Z000080000ol0000900;o1K/00on1P@0:P@03ok^k02Fk00?oFe/02U/00onk^`0;^`03oh6100Z1
0_lH^`03oe]K00]K00?o^k/02K/00on1P@0;P@03oh6100B10old^`;o0[/00on1P@0;P@03ok^k00>k
00Go0000o`040003o`0002T0000Q00;o2`001onkbk_;^ol03840:Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o00aK00oo^l^kbk_;^l^kbk_;^ol01X43o`0Nbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3E/03Oo;^l^kbk_;^l^kbol03H400on1P@03o`0d^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00IOol^kbol8P@?o00V1ok_;
^l^kbol00P000ol000030003o`0002P0000S0003o`0000T000?o^k/00k/00on1P@0:P@;o9[/00omK
F`04F`?o0e/00onk^`0;^`03oh6100?o8K/00omKF`0;F`03ok^k00Vk00?oPH402h42ocJk00?oGel0
0el01?nk^ol5P@?o1H400onk^`04^`04o`00o`<00_lZ000090000ol000090007ok_;^l^ko`06P@?o
1840:?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o1e/03_nkbk_;^l^k
bk_;^l^k0_l05/^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0=^l^kbk_;^l^kbk_;o`08F`?o00nkbk_;
^l^kbk_;^l^kbol01X44o`:1037o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;o016kbk_;^olOGamO7eoobk_oP@03o`V100So^l^kbk_;o`8000?o00000P000ol0
000500?o0`03oaT0000U0003o`0000T000?o^k/00k/00on1P@03o`R100?o^k/09;/2o`]K00?o^k/0
7k/3o`:100?o^k/02k/00omKF`03F`;o4[/00on1P@03o`N100?o^k/0:[/3o`03Gaoo00Fk00?oGol0
0_l5^`03oh6100Z100?o^k/01;/01?l00?l50003o`0000D000?o00001@000ol0000F00009P000ol0
00090006ok_;^l^k0_l<P@0Xok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`aK
01ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`J1013obk_;^l^kbk_;^l^kbomK0ol05L^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02o`^102co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`IO013o^l^kbk_o^l^kbk_;^l_o3H402?o;^l^kbk_o0P000ol000020003o`0000D0
00?o00001@000ol0000F00009`000ol000090003ok^k00Bk00?oPH402X400onk^`0T^`03oe]K00YK
00?o^k/05[/4o`Z100?o^k/02k/00onk^`0G^`03oh6100Z100?o^k/09k/02OlOGamO7elOo`0;^`;o
00>koh4038400onk^`04^`04o`00o`@000?o000010000ol0000200?o6@0002P000?o00002@02o`06
bk_;^l_o3840:?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<F`0Eok_;^l^k
bk_;^l^kbk_;^l^kbk_;00?o0X400on1P@0:P@0Yol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol038402Onkbk_;^l^kb`02o`0?^l^kbk_;^l^kbk_;^l^k00;o00G;^l^kb`04o`06
^l^kbk_o0Ul3o`0:bk_;^l^kbk_;^`?o00DGok_;o`08P@?o00V1ok_;^l^kbol00P000ol0000200;o
1@000ol000020003o`0001T0000Y00;o2`000onk^`03^`03oh6100Z100?o^k/09;/00omKF`04F`?o
5;/3o`J100?oPH402X400onk^`0U^`03oh6100Z100?o^k/00[/3o`034Onk00^k0ol015_o^k/3o`04
7elOo`Jk0_l;^`;o1AL01?nk^ol5P@;o1H400onk^`04^`04o`00o`8000?o0?l01002o`@01?lH0000
:`000ol000090007ol^kbk_;o`06P@?o0h40:?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol2F`?o01Fkbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l:P@03oh6100R102_oPOo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00J10ol2P@0Col^kbolA5a4G4Oo;^l^kbk_;
^`03o`EK00Co^l_o1El05?o;^l^kbk_;^l^kbk_;^l^kbk_o1aL01Onkbon100?o28402?nkbk_;^l_o
0P000ol000020003o`0002<0000/0003o`0000T000?o^k/00k/00on1P@03o`N100?o^k/09;/2oaVk
00?oPH402H400on1P@04P@?o0h400onk^`0U^`03oh6100?o1X401?nk^ol64@03ok^k00:k0ol9F`0:
ok^koamO7olOoa:k00?o5aL00ol5^`03oh6100V100?o^k/01;/01?l00?l50003o`000280000]0003
o`0000T000Kobk_;^l/2o`^104?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00^100?oPH400ol7P@0Vol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`Z100Gobk_o5`03o`06^l^kbk_o35/01?o;^l/3o`0Fbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;o00W;^l^kbk_;^ol038402?o;^l^kbk_o0P000ol000030003o`000240
000^0003o`0000T000?o^k/01;/00on1P@09P@03ok^k03nk00?oPH402H42o`^100?o^k/07[/4o`9K
00?oPH402X401?nk^ol8^`03oe]K00]K00?o^k/08;/2o`:k00?oPH402X400onk^`04^`04o`00o`@0
00?o00008@0002l000?o00002@002?o;^l^kbk_o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:100?oPH402X407Oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o1e/00on1P@0:P@09ol^kbk_;^l^k00;o00?;oe/0
35/01oo;^l^kbk/01?l05<^kbk_;^l^kbk_;^l^kbk_;^l^k0ol01Q7o^l^ko`N10ol02X7o^l^kbk_;
^ol20003o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42od2k00?oPH400ol6P@03
oh6100Z100?o^k/05k/2o`]K00?oPH4028400on1o`04^`?o00DGok^ko`08F`?o1K/3o`05GamO7ol0
4[/00olG5`035`04ok^ko`F10_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^k
bk_o00J10ol3P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00_l:P@03oh6100Z101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
35/00on1P@04P@?o0X403_nkbk_o5a4G4AOo^l_o1E/2o`09^l^kbk_;^l_o00MO00_obk_;^l^kbk_;
^`02o`0Abk_;^l_o5a4G4ALAok_;oh400ol8P@08ok_;^l^kbol20003o`00008000?o00007`0003<0
00?o00002@000onk^`03^`03oh6100?o1h400onk^`0m^`03oh6100Z100?oPH401843oafk00?oFe/0
2U/00on1P@03o`J100_o^k_o4ALA5a4Go`02^`03oe_o00;o2k/00olOG`03o`Vk0ol00aLAo`05^`03
oaOo00;o1K/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol000090006ok_;^l^k
0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol038400on1P@03o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`aK
0_l:P@05ok_;oa400ol05L^kbk_;ol^kbk_;^l^kbk_;^l^kb`02o`0<^l^kbk_;^l^kbk_o1QL04?o;
^l^kboo;^l^kbk_;^ol=P@07ok_;^l^ko`020003o`0000<000?o00007@0003D000?o00002@000onk
^`03^`03oh6100Z100?o^k/0?K/00on1P@08P@04oh7oobFk00?oFe/015/3o`:k00?oPH402X401?nk
^olO^`;o1;/02OlA5a4G4ALAo`0>^`03oh6100^100?o^k/00k/01?l00?l40003o`0001d0000f0003
o`0000T000Oo^l^kbk_o00b1037obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^k00Co00c;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100So^l^kbk_;^`?o01Bkbk_;^l^kbk_;^l^kbk_;
^l^kb`?o00QOol^kbk_;o`8G0ol04[_;^l^kbk_;^l^kbk_;^l^ko`J11?l2P@08ol^kbk_;^ol20004
o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z10_l[^`?o15/00onk^`09^`03oh6100?o
1h400onk^`0T^`;o2[/00on1P@08P@03oh7o00>k0ol00a4Go`0C^`07oamO7elOo`05^`;o5K/00on1
P@03o`N100?o^k/00k/01?l00?l50003o`0001/0000h00;o2P02o`05bk_;^ol01X43o`B102So^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol8F`0<ol^kbk_;^l^kbk_;0_l;P@0d
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol01k_;
^l^kbol01A40=oo;^l^kbk_;^l^kbk_;^l^kbk_o7elOGamOol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00_l;P@07ol^kbk_;o`020003o`00008000?o00006`0003X000?o00002@000onk^`02^`03
oh6100?o28400onk^`0R^`;o35/00onk^`09^`03oh6100Z100?o^k/0<;/00on1P@03o`Zk00Oo5a4G
oaOo00Zk0ol5^`03oeoo00;o7[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000J0000>`000ol0
00090005ol^kbk/00_l<P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00aK
00gobk_;^l^kbk_;^l_o00b103?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l03[_;^l^kbk_;^l^kbk_;0ol02/^kbk_;^l^kbk/3o`0]4ALAok_;^l^kok_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100[o^l^kbk_;o`3o1@000ol0000I0000
?0000ol000090003ok^k00>k00?oPH402X400onk^`0S^`03oe]K00YK00?o^k/02K/00on1P@0:P@03
ok^k04bk00?o4A4011400onk^`08^`;o7;/00on1P@08P@03oh7o00Fk00Co003o10000ol0000I0000
?@000ol000090006ol^kbk_;0_l;P@0Wok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o00IK0ol2F`0>ok_;^l^kbk_;^l^kbol6P@?o0h40A_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`07bk_;^l_o5`03o`09
bk_;^l^kbk_;00?o0Ul07Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J11?l2P@08ol^kbk_;
^ol20004o`0000;o6P0003h000?o00002@000onk^`04^`03oh6100B10ol2P@03ok^k02>k00?oFe/0
0ol6F`03ok^k00Zk00?oPH400ol7P@03ok^k03nk0ol45`03ok^k00>k00?o^k/02K/00olO7`047`03
ok^k01Vk00?oPH400ol7P@03ok^k00Bk00Co003o10000ol0000G0000?`000ol000090008ol^kbk_;
^ol2P@?o1X409_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l:F`0=ok_;^l^k
bk_;^l^kb`02o`^105go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o5a4G4ALAol^kbk_;^l^kbk_;^l^kbk_;^ol01El07?nkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2o`^100Oobk_;^l_o008000?o00000`000ol0000F0000@002o`X0
00?o^k/01;/2o`Z100?o^k/08k/00omKF`09F`03ok^k00Zk00?oPH402X400onk^`0o^`03oaOo00;o
5K/3oajk00?oPH402X400onk^`04^`04o`00o`@000?o00005P00048000?o00002002o`06^l^kbk_o
2h409onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0;F`0>ok_;^l^kbk_;^l^k
bol<P@1nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_o38402?nkbk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/0
0k/00on1P@09P@03ok^k02>k00?oFe/02E/00onk^`0:^`03oh6100B10ol2P@03ok^k04Fk0_lF^`?o
6k/00on1P@08P@03oh7o00Fk00Co003o1@000ol0000D0000A0000ol000090007ok_;^l^ko`0;P@;o
02G;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00IK0ol04<^kbk_;^l^kbk_;^l^k
bol2P@?o1X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0ol05Ioobk_;^l^kbk_;^l^kbk_;^l^kb`03o`0O7aOo^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l00002oaH000150003o`0000T0
00?o^k/00k/00on1P@04P@?o0h400onk^`0R^`03oe]K00?o4k/2o`Z100?o^k/0?k/00onOW`03W`03
ok^k012k00Oo5elGGaOo01^k00?oPH400ol7P@03ok^k00Bk00Co003o10000ol0000C0000AP000ol0
00090007ok_;^l^ko`02P@?o1h409?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o
01S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol;P@0kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l0?/^kbk_;oioOWmnOol^kbk_;^l^kbk_;^l^k
bk_;^olG7aOo5onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l;P@0:ol^kbk_;^ol0o`<00olD0000
A`000ol000090003ok^k00>k0_l;P@03ok^k01fk0ol3F`03ok^k01Fk00?oPH402H400onk^`0d^`?o
00?Ook/01K/3oaJk0olI^`?o0X400on1P@0;P@03ok^k00>k00?o00000ol20003o`000180001800;o
2P002?nkbk_;^l_o2h407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`MK01Wobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00^10_l0=;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol5W`0Uok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0A
^l^kbk_;^l^kbk_;^l^kbk/00ol6P@03oh6100^100Kobk_;^l/2o`030?l0008000?o00004P0004X0
00?o00002002o`Fk00?oPH402H400onk^`0D^`Co2e/00onk^`0E^`03oh6100B10ol3P@03ok^k02Zk
0_l5^`07omnOgioOo`0P^`?o00<Ook/03;/4o`Z100?oPH401844o`Vk00?o0?l00`000ol0000B0000
B`000ol000090007ol^kbk_;o`06P@?o0X404oo;^l^kbk_;^l^kbk_;^l^kbk/00ol3F`03oe]K00YK
01Wobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:10ol7P@0Yok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l/00ol029lAok_;^l^k0ol0<[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o7aLO5aoobk_;^l^kbk_;0ol2P@03oh6100Z100?oPH400ol02;_;^l^kbk_;0ol50004
o`00oa@0001<0003o`0000T000?o^k/00k/00on1P@03o`J100?o^k/03;/3o`MK00?oFe/02U/00onk
^`0E^`;o2h400onk^`0T^`08omnOgioOWolS^`;o1K/01olOGamO7ol01K/3o`J100?oPH402X42o`Nk
1?l90004o`00oa<0001=0003o`0000T000Kobk_;^l/2o`Z100cobk_;^l^kbk_;^l/2o`]K00?oFe/0
15/3o`0Lbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`b1023o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;o02c;^l^kbk_o4IlAWa7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o
00QOok_;^l^kb`?o00C;^l^k1?l:P@03oh6100B10ol02<^kbk_;^l^k0ol>0003o`3o01<0001>0003
o`0000T000?o^k/00k/00on1P@09P@03ok^k00Zk00?oFe/02E/00omKF`03oank00?oPH402X400onk
^`0J^`;o00>Ogol01[/3ob6k00OoGamO7eoo00Nk1Ol2P@03oh6100Z100?oPH400ol7^`Co4@000ol0
o`0C0000C`02o`X000Oobk_;^l_o00^100kobk_;^l^kbk_;^l^ko`]K0_l09<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol2P@0Mol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol0
1Il09?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o00fkbk_;^omO7elOGonk00Go
28400on1P@0:P@;o00O;^l^kbk_;00?o5P02oa<0001A0003o`0000P000?o^k/00k/00on1P@09P@;o
2k/00omKF`04F`?o9k/00on1P@03o`J100?o^k/04K/3o`Fk00OogioOWmoo01nk0ol00aoo^`05^`?o
00Bkoooo0X400on1P@09P@03oh6100B10ol7^`Co6003oa<0001B0003o`0000P00_l01K_;^l_o00J1
0ol3P@0=ok_;^l^kbk_;^l^ko`02F`?o02_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;o2X404?o;^l^kbk_;^l^kbk_;^l/3o`09Wmoo^l^kbk_;00?o02;;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1Al01oo;^l^kbk/00ol6P@03oh6100V100?oPH400ol01k_;
^l^kbk/00olI00?o5P0005<000?o00002@000onk^`02^`03oh6100?o1h400onk^`09^`;o;[/00on1
P@0:P@03ok^k00bk00OoWmnOgioo02:k0ol5^`08oamO7elOok/4o`Z100?oPH401h401?n1ool6^`Co
6004oaT0001D0003o`0000T000Go^l^kb`02o`^103go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00b100Oobk_;^l^k00Co02W;^l^komnOgooO
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`097elOol^kbk_;00?o00C;oooo0X400on1
P@09P@03oh6100B10ol01l^kbk_;^l/00olI00?o7@0005D000?o00002@000onk^`03^`03oh6100V1
00?o^k/0>K/00on1P@08P@03oh7o00:k0ol4g`03ok^k00:k0olR^`03oalO00<O00?o^k/00k/3o`J1
00?oPH402H400on1P@03o`Jk1?lH00Co800005H000?o00002@001onkbk_;^ol02h42o`0kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`07
bk_;^l^ko`06W`0Rol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o00_;^l^kbolOGaoo
7`05o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o
0h400onk^`0Y^`;o3K/00on1P@03o`:k0ol5^`03omoo00;o8;/3o`<O00?o^k/00k/6o`:100?oPH40
2H400on1P@04P@?o1[/4oaP00olX0000F@000ol000080007ok_;^l^ko`02P@?o1h40:?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0@goo;^l^kbk_;^l^kbk_;^`;o00?;^ol0
0_l0;Q7O4Onkbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol67`05ol^kbk/0
0ol6P@03oh6100V100?oPH400ol01[_;^l^kb`?o6004ob/0001J0003o`0000P000?o^k/00k/2o`^1
00?o^k/08k/01ooOg]oNgol04K/02?nO4IlAWa7o8K/3o`Fk00?o7ol00_l3^`?o2X400on1P@07P@04
oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06bk_;^l_o2h407_o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`Co00Jkbk_;^ol4g`0:ol^kbk_;^l^kb`Co00Jkbk_;oml3o`03bk_;00?o01[;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06
bk_;^l^k0olH00Co<P0005`000?o00002@000onk^`03^`03oh6100V100?o^k/06;/2o`CO00?o^k/0
0k/2o`Zk0_l4W`03ok^k00:k00Co^k^k0ol3P@03ok^k01Nk00?o8b<012<00onk^`03^`?o1X400on1
P@09P@?o1k/4oaP00olf0000G@000ol000090007ol^kbk_;o`06P@?o0X40;?o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ooNgmkOg_nkbk_;^l^kbk_;0_l04;_;^l^koioOWmnOok_;^l/3o`N101cobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbolS0ol00l^kb`04o`Z100?oPH401843o`08^l^kbk_;^l/3oaP0
1?li0000GP000ol000090003ok^k00>k00?oPH400ol6P@03ok^k00nk1?l5^`04omooo`Vk0ol00ioo
^`05^`?o1K/2o`^100?o^k/05k/01?nk^k/3o`:100?oPH402X400on1P@03o`Nk1?lH00?o?@0005l0
0_l:0006ol^kbk_;0_l:P@0?ol^kbk_;^l^kbk_;^l^k00;o1=l04_nkbk_;^onkbk_;^l^kbk_;o`GO
013obk_;^l^kbk_;^l^kbk_o38406_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z1
0_l01k_;^l^kbk/00olH00Co@000064000?o000020000onk^`03^`03oh6100V100?o^k/01K/2o`Bk
00?ogml01=l00onk^`07^`?o1K/00onOW`02W`03ok^k00bk00?oPH402X400onk^`0B^`Co2X400on1
P@04P@?o1k/4oaP00om40000HP000ol000080007ol^kbk_;o`0;P@;o00>kbk/00_l2g`07ok_;^l_o
g`03o`08bk_;^l^kbk/3o`09Wmoobk_;^l^k00;o01?;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol2P@0@
ok_;^l^kbk_;^l^kbk_;^`Go0h400on1P@09P@03oh6100?o00O;^l^kbk_;00?o6004odL0001S0003
o`0000P00_l4^`03oh6100B10ol3P@03ok_o00GO00?o^k/00[/00onk^`0:^`06omnOgioo2k/2o`fk
00?oPH400ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co5`04od/0001T0003o`0000T000Ko^l^k
bol2P@?o1h400onko`05g`0:ok_;^l^kbk_;^`?o01:kbk_;^onOgooOol^kbk_;^l/3o`;O00ko^l^k
bk_;^l^kbk_;^`;o2X401onkbk_;^l/00ol2P@03oh6100V100?oPH401843o`06bk_;^l^k0olH00?o
C`0006D000?o00002@000onk^`02^`;o2h400onko`02o`Vk0ol01=nOgol5^`;o2K/02?oNgmkOg]oo
3K/00on1P@09P@03ok^k00?o1X400on1P@09P@03oh6100?o1K/4oaL01?mB0000IP000ol000090007
ok_;^l^ko`0;P@08ok_;^l^kbk/2o`0Mbk_;^onOgioOWonkbk_;^l^kbk_;^l^kbk_;^ol01Ml03onk
bk_;^l^kbk_;^l^ko`0;P@;o2X400on1P@07P@08oh7ool^kbk/4oaP00omF0000I`02o`X000?o^k/0
0k/00on1P@09P@04ok^k^`?o00?Ook/01;/01?oOoolD^`?o4K/00on1P@04P@?o0X400on1P@09P@04
oh61P@Go1K/3oaP01?mI0000J@000ol000080007ok_;^l^ko`06P@?o0X400onko`05g`0Sok_;^l^k
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l03[_;^l^kbk_;^l^kbk_o0X43o`J100?oPH40
2H43o`06^l^kbk_;1?lH00?oG@0006X000?o000020000onk^`03^`03oh6100?o1X402Onk^onOgioO
o`0O^`;o00?Ngol02k/4o`Z100?oPH401843o`Nk0olH00CoH00006/000?o00002002o`04bk_;^`;o
2X400onkb`02o`0]^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^komkOg]oNok_;^l^k00Go
18400on1P@08P@03oh6100?o00K;^l^kbk/4oaP00omT0000K0000ol000090003ok^k00:k00?oPH40
2H400onk^`05^`;o5;/3o`Fk00SogmkOg]oo^`?o2X400on1P@08P@;o1[/3oaP01?mW0000K@000ol0
00090006ol^kbk_o2h401?nkbk/3o`9a017obk_;^l^kbk_;^l^kbk_;^`03o`?N00Ko^l^kbk/3o`04
^oooo`:100?oPH402H400on1P@05o`06^l^kbk_;1?lH00?oJ`0006h00_l:0003ok^k00:k00?oPH40
1843o`:100?o^ol01]h00onk^`0>^`03omoO00?O00?o^k/00k/3o`J100?oPH402H42o`Rk0olH00Co
KP00070000?o000020001_o;^l^ko`:10ol6P@04ok_;o`Ea00Wobk_;^l^kbk/01?l01/^kbk_ogP;o
00?;^l/01?l:P@03oh6100B10ol01k_;^l^kbk/01?lG00CoLP00074000?o000020000onk^`02^`;o
2X400onk^`03o`Vk0_l4gP03ok^k00:k1_l3P@03oh6100V100?oPH400ol7^`?o6003ogH0001b0003
o`0000P000Oobk_;^l_o00Z100Oo^l^kbk_;00Co00bkbk_;omkOg]oNol/3o`V100?oPH402H42o`06
^l^kbk_;1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028401?nk^k/2o`05LMiag_l01;/3o`04
^oooo`:100?oPH4028400on1P@04P@?o1[/3oaP00omm0000M0000ol000090006ok_;^l_o0X45o`>1
00oo^l_ogW7NLMiaok_;^l/00ol6P@03oh6100R100?oPH400ol01K_;^l^k00Co5`04oh00001e0003
o`0000T000?o^k/00[/2o`V100Go^k_oL@03o`>k0ol:P@03oh6100J100CoPOoo1K/3oaP00on40000
MP02o`X000Oo^l^kbk_o00V100Oo^l_obk_;00?o0X400on1P@09P@03oh6100Go00G;^l^kb`04oaL0
1?n70000N0000ol000080003ok^k00>k00?oPH401h400onk^`03o`J100?oPH402H42o`Nk0olH00?o
R`0007T000?o000020001onkbk_;^ol01h401?n1ool:P@03oh6100B10ol01/^kbk_;^`Co5`04ohh0
001j0003o`0000P000?o^k/00k/00on1P@04o`B100?oPH4028400on1P@03o`Jk0olH00?oTP0007/0
00?o000020001_nkbk_;^`;o2H400on1P@08P@;o00G;^l^kb`04oaL01?nE0000O0000ol0000800;o
1;/00on1P@08P@03oh6100Go1[/3oaL01?nI0000O@000ol000090006ol^kbk_o2X42o`07^l^kbk_;
^`04oaL00onM0000OP02o`X000?o^k/00[/00on1P@03P@?o1k/3oaL01?nP0000P0000ol000080007
ol^kbk_oP@03o`06^l^kbk_;1?lG00?oY000084000?o000020000onk^`02^`03ok^k00Bk0olG00Co
Y`00088000?o000020001oo;^l^kbk/01?lG00?oZ`0008<000?o000020000onk^`03oaL01?n^0000
Q0000ol0000700?o5`03ok80002500;o1`000ol0000C00Co]@0008L000?o000010000ol0000@00?o
^@0008P000?o00000`000ol0000<00Co_00008T000Go0000o`0;00Co`00008X000Co003o2003ol@0
002;0003o`3o00@01?o70000S002o`040?oool/0002=00;ocP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP00098000?o00009`000ol0
002N0000K@04o`<01?l0103oo`02o`800_l300?o0`03o`@000?o00002005o`040?oo00;o0P05o`03
0?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l300Co0`02o`@00_m_0000K0001Ol0003o0080
00?o00000`001?l00?l300;o10000ol000050003o`00008000?o00002@001Ol0003o008000Co003o
0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o10000ol0
00020004o`00o`<00_m_0000K0000ol0o`02o`801Ol01@3o003o00T000?o00000`03oa0000Go0000
o`020004o`00o`<000?o00001P000ol0000>0003o`0000D000?o00000P000ol0000:0005o`000?l0
0P000ol0001b0000K0000ol000040007o`000?l0o`020003o`0000L000?o00000P001?l00?l@0005
o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0000;0004o`0000;o
M@0006`000Go0000o`0300?o00<0ool00ol90003o`00008000Co003o40000ol00005o`<01?l80003
o`0000h000?o00001002o`<01?l80004o`00o`8000Co003oM00006d01?lD00;o1@02o`l01Ol;0003
o`0000D00_l?00Go2@000ol0000900;o1002ogD0002/00;o8@000ol000020003o`0008H0003o05h0
0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 19"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 18",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 22",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 22", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.158069 1.346129 0.024067 0.962696 [
[(Gen.22, Ind.1, Fit.33.)] .5 1 0 -1.5 Msboxa
[(5)] .22047 .13215 .85653 1 Msboxa
[(10)] .37417 .08821 .79059 1 Msboxa
[(15)] .53416 .04248 .72465 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30608 .04563 .79718 1 Msboxa
P
[(5)] .72379 .08784 -1 .38351 Msboxa
[(10)] .80018 .16766 -1 .36641 Msboxa
[(15)] .8713 .24198 -1 .35076 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87174 .13915 -1 .36805 Msboxa
P
[(0)] .09589 .19151 1 -0.39624 Msboxa
[(10)] .07016 .38579 1 -0.36141 Msboxa
[(20)] .04095 .60633 1 -0.32158 Msboxa
[(t)] -0.01836 .47416 1 -0.34906 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.22, Ind.1, Fit.33.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11312 .175 m
.64285 .02407 L
s
P
p
.002 w
.23142 .14129 m
.23689 .14586 L
s
P
[(5)] .22047 .13215 .85653 1 Mshowa
p
.002 w
.3846 .09765 m
.38982 .10237 L
s
P
[(10)] .37417 .08821 .79059 1 Mshowa
p
.002 w
.54404 .05222 m
.54897 .05709 L
s
P
[(15)] .53416 .04248 .72465 1 Mshowa
p
.001 w
.26157 .1327 m
.26483 .13546 L
s
P
p
.001 w
.29197 .12404 m
.29519 .12682 L
s
P
p
.001 w
.3226 .11531 m
.3258 .11811 L
s
P
p
.001 w
.35348 .10651 m
.35664 .10933 L
s
P
p
.001 w
.41598 .08871 m
.41908 .09156 L
s
P
p
.001 w
.44761 .0797 m
.45067 .08256 L
s
P
p
.001 w
.47949 .07061 m
.48252 .0735 L
s
P
p
.001 w
.51163 .06145 m
.51463 .06436 L
s
P
p
.001 w
.2015 .14982 m
.20481 .15254 L
s
P
p
.001 w
.17181 .15827 m
.17515 .16098 L
s
P
p
.001 w
.14235 .16667 m
.14572 .16936 L
s
P
p
.001 w
.57671 .04291 m
.57963 .04586 L
s
P
p
.001 w
.60964 .03353 m
.61253 .03649 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30608 .04563 .79718 1 Mshowa
P
P
p
p
.002 w
.64285 .02407 m
.89575 .28806 L
s
P
p
.002 w
.70808 .09215 m
.70022 .09431 L
s
P
[(5)] .72379 .08784 -1 .38351 Mshowa
p
.002 w
.78438 .1718 m
.77648 .17387 L
s
P
[(10)] .80018 .16766 -1 .36641 Mshowa
p
.002 w
.85542 .24596 m
.84748 .24795 L
s
P
[(15)] .8713 .24198 -1 .35076 Mshowa
p
.001 w
.72379 .10855 m
.71907 .10983 L
s
P
p
.001 w
.73926 .12471 m
.73454 .12598 L
s
P
p
.001 w
.75452 .14063 m
.74979 .14189 L
s
P
p
.001 w
.76955 .15633 m
.76482 .15758 L
s
P
p
.001 w
.79899 .18705 m
.79424 .18828 L
s
P
p
.001 w
.81339 .20209 m
.80864 .20331 L
s
P
p
.001 w
.8276 .21692 m
.82284 .21813 L
s
P
p
.001 w
.84161 .23154 m
.83685 .23275 L
s
P
p
.001 w
.69214 .07551 m
.68743 .07682 L
s
P
p
.001 w
.67596 .05862 m
.67125 .05994 L
s
P
p
.001 w
.65953 .04148 m
.65483 .0428 L
s
P
p
.001 w
.86905 .26019 m
.86428 .26137 L
s
P
p
.001 w
.88249 .27422 m
.87771 .27539 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87174 .13915 -1 .36805 Mshowa
P
P
p
p
.002 w
.11312 .175 m
.03365 .7802 L
s
P
p
.002 w
.11154 .18707 m
.11936 .18486 L
s
P
[(0)] .09589 .19151 1 -0.39624 Mshowa
p
.002 w
.08598 .3817 m
.09389 .37965 L
s
P
[(10)] .07016 .38579 1 -0.36141 Mshowa
p
.002 w
.05697 .60264 m
.06498 .6008 L
s
P
[(20)] .04095 .60633 1 -0.32158 Mshowa
p
.001 w
.10667 .22412 m
.11138 .22281 L
s
P
p
.001 w
.10169 .26207 m
.1064 .26078 L
s
P
p
.001 w
.09658 .30096 m
.10131 .29969 L
s
P
p
.001 w
.09135 .34082 m
.09608 .33958 L
s
P
p
.001 w
.08048 .42362 m
.08523 .42241 L
s
P
p
.001 w
.07483 .46663 m
.0796 .46545 L
s
P
p
.001 w
.06903 .51077 m
.07381 .50962 L
s
P
p
.001 w
.06308 .55609 m
.06787 .55496 L
s
P
p
.001 w
.05069 .65047 m
.05551 .64939 L
s
P
p
.001 w
.04423 .69962 m
.04906 .69857 L
s
P
p
.001 w
.0376 .75016 m
.04244 .74914 L
s
P
[(t)] -0.01836 .47416 1 -0.34906 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11154 .18707 m
.40805 .41884 L
s
P
p
.4 g
.002 w
.08598 .3817 m
.40205 .60419 L
s
P
p
.4 g
.002 w
.05697 .60264 m
.39533 .81157 L
s
P
p
.4 g
.002 w
.18886 .23456 m
.12649 .83119 L
s
P
p
.4 g
.002 w
.27783 .30454 m
.23427 .89039 L
s
P
p
.4 g
.002 w
.36103 .36998 m
.33383 .94508 L
s
P
.002 w
.11312 .175 m
.03365 .7802 L
s
.03365 .7802 m
.39001 .97593 L
s
.39001 .97593 m
.40842 .40725 L
s
.40842 .40725 m
.11312 .175 L
s
.64285 .02407 m
.89575 .28806 L
s
.89575 .28806 m
.96635 .87651 L
s
.96635 .87651 m
.67029 .64846 L
s
.67029 .64846 m
.64285 .02407 L
s
.11312 .175 m
.03365 .7802 L
s
.03365 .7802 m
.67029 .64846 L
s
.67029 .64846 m
.64285 .02407 L
s
.64285 .02407 m
.11312 .175 L
s
p
.4 g
.51789 .38048 m
.51839 .95379 L
s
P
p
.4 g
.65909 .34594 m
.68491 .92506 L
s
P
p
.4 g
.8054 .31016 m
.85855 .89511 L
s
P
p
.4 g
.40805 .41884 m
.89717 .29992 L
s
P
p
.4 g
.40205 .60419 m
.92002 .49041 L
s
P
p
.4 g
.39533 .81157 m
.94578 .70513 L
s
P
.40842 .40725 m
.89575 .28806 L
s
.89575 .28806 m
.96635 .87651 L
s
.96635 .87651 m
.39001 .97593 L
s
.39001 .97593 m
.40842 .40725 L
s
p
.4 g
.23142 .14129 m
.51789 .38048 L
s
P
p
.4 g
.3846 .09765 m
.65909 .34594 L
s
P
p
.4 g
.54404 .05222 m
.8054 .31016 L
s
P
p
.4 g
.18886 .23456 m
.70808 .09215 L
s
P
p
.4 g
.27783 .30454 m
.78438 .1718 L
s
P
p
.4 g
.36103 .36998 m
.85542 .24596 L
s
P
P
p
.002 w
.41384 .40942 m .42161 .41554 L .40805 .41884 L p
.4 g
F P
s
P
p
.002 w
.40805 .41884 m .40024 .41274 L .41384 .40942 L p
.4 g
F P
s
P
p
.002 w
.89717 .29992 m .40805 .41884 L .11154 .18707 L p
.9 g
F P
s
P
p
.002 w
.43522 .41223 m .42161 .41554 L p
.41384 .40942 L .4 g
F P
s
P
p
.002 w
.41384 .40942 m .40024 .41274 L .39239 .4066 L p
.4 g
F P
s
P
p
.002 w
.44117 .40275 m .44888 .40891 L .43522 .41223 L p
.4 g
F P
s
P
p
.002 w
.41384 .40942 m .44117 .40275 L p
.43522 .41223 L .4 g
F P
s
P
p
.002 w
.39239 .4066 m .38449 .40043 L p
.41384 .40942 L .4 g
F P
s
P
p
.002 w
.38449 .40043 m .39815 .39707 L .41384 .40942 L p
.4 g
F P
s
P
p
.002 w
.46259 .40558 m .44888 .40891 L p
.44117 .40275 L .4 g
F P
s
P
p
.002 w
.46869 .39603 m .47634 .40223 L .46259 .40558 L p
.4 g
F P
s
P
p
.002 w
.44117 .40275 m .46869 .39603 L p
.46259 .40558 L .4 g
F P
s
P
p
.002 w
.49015 .39888 m .47634 .40223 L p
.46869 .39603 L .4 g
F P
s
P
p
.002 w
.39815 .39707 m .38449 .40043 L .37654 .39421 L p
.4 g
F P
s
P
p
.002 w
.49641 .38926 m .504 .39551 L .49015 .39888 L p
.4 g
F P
s
P
p
.002 w
.46869 .39603 m .49641 .38926 L p
.49015 .39888 L .4 g
F P
s
P
p
.002 w
.37654 .39421 m .36854 .38796 L p
.39815 .39707 L .4 g
F P
s
P
p
.002 w
.36854 .38796 m .38225 .38455 L .39815 .39707 L p
.4 g
F P
s
P
p
.002 w
.5179 .39213 m .504 .39551 L p
.49641 .38926 L .4 g
F P
s
P
p
.002 w
.52432 .38245 m .53184 .38874 L .5179 .39213 L p
.4 g
F P
s
P
p
.002 w
.49641 .38926 m .52432 .38245 L p
.5179 .39213 L .4 g
F P
s
P
p
.002 w
.54584 .38534 m .53184 .38874 L p
.52432 .38245 L .4 g
F P
s
P
p
.002 w
.38225 .38455 m .36854 .38796 L .36048 .38166 L p
.4 g
F P
s
P
p
.002 w
.55243 .37559 m .55989 .38192 L .54584 .38534 L p
.4 g
F P
s
P
p
.002 w
.52432 .38245 m .55243 .37559 L p
.54584 .38534 L .4 g
F P
s
P
p
.002 w
.36048 .38166 m .35237 .37532 L p
.38225 .38455 L .4 g
F P
s
P
p
.002 w
.35237 .37532 m .36615 .37187 L .38225 .38455 L p
.4 g
F P
s
P
p
.002 w
.57398 .37849 m .55989 .38192 L p
.55243 .37559 L .4 g
F P
s
P
p
.002 w
.58074 .36867 m .58813 .37506 L .57398 .37849 L p
.4 g
F P
s
P
p
.002 w
.55243 .37559 m .58074 .36867 L p
.57398 .37849 L .4 g
F P
s
P
p
.002 w
.4376 .37081 m .40983 .3777 L .39385 .36493 L p
.8 g
F P
s
P
p
.002 w
.58074 .36867 m .55243 .37559 L .53737 .36279 L p
.4 g
F P
s
P
p
.002 w
.36615 .37187 m .35237 .37532 L .34421 .36894 L p
.4 g
F P
s
P
p
.002 w
.60232 .3716 m .58813 .37506 L p
.58074 .36867 L .4 g
F P
s
P
p
.002 w
.34421 .36894 m .336 .36252 L p
.36615 .37187 L .4 g
F P
s
P
p
.002 w
.336 .36252 m .34983 .35902 L .36615 .37187 L p
.4 g
F P
s
P
p
.002 w
.60925 .36171 m .61657 .36814 L .60232 .3716 L p
.4 g
F P
s
P
p
.002 w
.58074 .36867 m .60925 .36171 L p
.60232 .3716 L .4 g
F P
s
P
p
.002 w
.46557 .36386 m .4376 .37081 L .42175 .35795 L p
.8 g
F P
s
P
p
.002 w
.39385 .36493 m .42175 .35795 L .4376 .37081 L p
.8 g
F P
s
P
p
.002 w
.53737 .36279 m .56581 .35579 L .58074 .36867 L p
.4 g
F P
s
P
p
.002 w
.63087 .36467 m .61657 .36814 L p
.60925 .36171 L .4 g
F P
s
P
p
.002 w
.42175 .35795 m .39385 .36493 L .37766 .352 L p
.8 g
F P
s
P
p
.002 w
.63796 .3547 m .64521 .36118 L .63087 .36467 L p
.4 g
F P
s
P
p
.002 w
.60925 .36171 m .63796 .3547 L p
.63087 .36467 L .4 g
F P
s
P
p
.002 w
.42175 .35795 m .44984 .35091 L .46557 .36386 L p
.8 g
F P
s
P
p
.002 w
.56581 .35579 m .53737 .36279 L .52211 .34982 L p
.4 g
F P
s
P
p
.002 w
.34983 .35902 m .336 .36252 L .32773 .35606 L p
.4 g
F P
s
P
p
.002 w
.65961 .35768 m .64521 .36118 L p
.63796 .3547 L .4 g
F P
s
P
p
.002 w
.32773 .35606 m .3194 .34955 L p
.34983 .35902 L .4 g
F P
s
P
p
.002 w
.3194 .34955 m .3333 .34601 L .34983 .35902 L p
.4 g
F P
s
P
p
.002 w
.37766 .352 m .40568 .34492 L .42175 .35795 L p
.8 g
F P
s
P
p
.002 w
.66687 .34764 m .67406 .35416 L .65961 .35768 L p
.4 g
F P
s
P
p
.002 w
.63796 .3547 m .66687 .34764 L p
.65961 .35768 L .4 g
F P
s
P
p
.002 w
.52211 .34982 m .49374 .35687 L .47814 .34382 L p
.8 g
F P
s
P
p
.002 w
.52211 .34982 m .55068 .34273 L .56581 .35579 L p
.4 g
F P
s
P
p
.002 w
.68856 .35064 m .67406 .35416 L p
.66687 .34764 L .4 g
F P
s
P
p
.002 w
.696 .34053 m .70312 .3471 L .68856 .35064 L p
.4 g
F P
s
P
p
.002 w
.66687 .34764 m .696 .34053 L p
.68856 .35064 L .4 g
F P
s
P
p
.002 w
.55068 .34273 m .52211 .34982 L .50664 .33668 L p
.8 g
F P
s
P
p
.002 w
.47814 .34382 m .50664 .33668 L .52211 .34982 L p
.8 g
F P
s
P
p
.002 w
.3333 .34601 m .3194 .34955 L .31102 .343 L p
.4 g
F P
s
P
p
.002 w
.696 .34053 m .66687 .34764 L .65236 .33448 L p
.8 g
F P
s
P
p
.002 w
.71772 .34355 m .70312 .3471 L p
.696 .34053 L .4 g
F P
s
P
p
.002 w
.31102 .343 m .30259 .33641 L p
.3333 .34601 L .4 g
F P
s
P
p
.002 w
.30259 .33641 m .31655 .33282 L .3333 .34601 L p
.4 g
F P
s
P
p
1 .022 0 r
.01 w
.64512 .34464 m
.64512 .34464 L
s
P
p
1 .045 0 r
.01 w
.64519 .34643 m
.64519 .34643 L
s
P
p
.002 w
.72534 .33337 m .73238 .33999 L .71772 .34355 L p
.4 g
F P
s
P
p
.002 w
.696 .34053 m .72534 .33337 L p
.71772 .34355 L .4 g
F P
s
P
p
.002 w
.57946 .33558 m .55068 .34273 L .53535 .32949 L p
.8 g
F P
s
P
p
.002 w
.50664 .33668 m .53535 .32949 L .55068 .34273 L p
.8 g
F P
s
P
p
1 .067 0 r
.01 w
.64526 .34821 m
.67439 .34108 L
s
P
p
.002 w
.72534 .33337 m .696 .34053 L .68163 .32727 L p
.8 g
F P
s
P
p
.002 w
.65236 .33448 m .68163 .32727 L .696 .34053 L p
.8 g
F P
s
P
p
.002 w
.74709 .33641 m .73238 .33999 L p
.72534 .33337 L .4 g
F P
s
P
p
.002 w
.53535 .32949 m .50664 .33668 L .49097 .32337 L p
.4 g
F P
s
P
p
.002 w
.31655 .33282 m .30259 .33641 L .2941 .32977 L p
.4 g
F P
s
P
p
.002 w
.75488 .32616 m .76186 .33282 L .74709 .33641 L p
.4 g
F P
s
P
p
.002 w
.72534 .33337 m .75488 .32616 L p
.74709 .33641 L .4 g
F P
s
P
p
.002 w
.53535 .32949 m .56427 .32225 L .57946 .33558 L p
.8 g
F P
s
P
p
1 .09 0 r
.01 w
.67448 .34287 m
.67448 .34287 L
s
P
p
.002 w
.75488 .32616 m .72534 .33337 L .71111 .32001 L p
.8 g
F P
s
P
p
.002 w
.68163 .32727 m .71111 .32001 L .72534 .33337 L p
.8 g
F P
s
P
p
1 .112 0 r
.01 w
.67457 .34467 m
.67457 .34467 L
s
P
p
.002 w
.2941 .32977 m .28555 .32309 L p
.31655 .33282 L .4 g
F P
s
P
p
.002 w
.28555 .32309 m .29958 .31945 L .31655 .33282 L p
.4 g
F P
s
P
p
.002 w
.77667 .32922 m .76186 .33282 L p
.75488 .32616 L .4 g
F P
s
P
p
1 .135 0 r
.01 w
.67465 .34646 m
.70404 .33929 L
s
P
p
.002 w
.49097 .32337 m .51982 .31608 L .53535 .32949 L p
.4 g
F P
s
P
p
.002 w
.78465 .31889 m .79154 .3256 L .77667 .32922 L p
.4 g
F P
s
P
p
.002 w
.75488 .32616 m .78465 .31889 L p
.77667 .32922 L .4 g
F P
s
P
p
.002 w
.63765 .32113 m .60845 .32838 L .5934 .31496 L p
.8 g
F P
s
P
p
.002 w
.78465 .31889 m .75488 .32616 L .7408 .3127 L p
.8 g
F P
s
P
p
.002 w
.71111 .32001 m .7408 .3127 L .75488 .32616 L p
.8 g
F P
s
P
p
.002 w
.80647 .32197 m .79154 .3256 L p
.78465 .31889 L .4 g
F P
s
P
p
.002 w
.37291 .31833 m .34463 .3256 L .32778 .31214 L p
.8 g
F P
s
P
p
1 .157 0 r
.01 w
.70415 .34109 m
.70415 .34109 L
s
P
p
.002 w
.51982 .31608 m .49097 .32337 L .47509 .30988 L p
.4 g
F P
s
P
p
.002 w
.29958 .31945 m .28555 .32309 L .27695 .31636 L p
.4 g
F P
s
P
p
1 .18 0 r
.01 w
.70425 .34289 m
.70425 .34289 L
s
P
p
.002 w
.81463 .31157 m .82145 .31833 L .80647 .32197 L p
.4 g
F P
s
P
p
.002 w
.78465 .31889 m .81463 .31157 L p
.80647 .32197 L .4 g
F P
s
P
p
1 .202 0 r
.01 w
.70436 .34469 m
.73401 .33747 L
s
P
p
.002 w
.66706 .31383 m .63765 .32113 L .62274 .30761 L p
.8 g
F P
s
P
p
.002 w
.5934 .31496 m .62274 .30761 L .63765 .32113 L p
.8 g
F P
s
P
p
.002 w
.27695 .31636 m .26828 .30959 L p
.29958 .31945 L .4 g
F P
s
P
p
.002 w
.26828 .30959 m .28237 .30591 L .29958 .31945 L p
.4 g
F P
s
P
p
.002 w
.81463 .31157 m .78465 .31889 L .77071 .30534 L p
.8 g
F P
s
P
p
.002 w
.7408 .3127 m .77071 .30534 L .78465 .31889 L p
.8 g
F P
s
P
p
.002 w
.40139 .31101 m .37291 .31833 L .35619 .30477 L p
.8 g
F P
s
P
p
.002 w
.32778 .31214 m .35619 .30477 L .37291 .31833 L p
.8 g
F P
s
P
p
.002 w
.83648 .31468 m .82145 .31833 L p
.81463 .31157 L .4 g
F P
s
P
p
.002 w
.47509 .30988 m .50407 .30249 L .51982 .31608 L p
.4 g
F P
s
P
p
.002 w
.84483 .3042 m .85157 .31101 L .83648 .31468 L p
.4 g
F P
s
P
p
.002 w
.81463 .31157 m .84483 .3042 L p
.83648 .31468 L .4 g
F P
s
P
p
.002 w
.69668 .30647 m .66706 .31383 L .65229 .30021 L p
.8 g
F P
s
P
p
.002 w
.62274 .30761 m .65229 .30021 L .66706 .31383 L p
.8 g
F P
s
P
p
1 .225 0 r
.01 w
.73413 .33928 m
.73413 .33928 L
s
P
p
1 .247 0 r
.01 w
.73425 .34109 m
.73425 .34109 L
s
P
p
.002 w
.77071 .30534 m .80085 .29792 L .81463 .31157 L p
.8 g
F P
s
P
p
.002 w
.86672 .30733 m .85157 .31101 L p
.84483 .3042 L .4 g
F P
s
P
p
.002 w
.35619 .30477 m .38481 .29735 L .40139 .31101 L p
.8 g
F P
s
P
p
1 .27 0 r
.01 w
.73437 .3429 m
.76429 .33564 L
s
P
p
.002 w
.50407 .30249 m .47509 .30988 L .45899 .2962 L p
.4 g
F P
s
P
p
.002 w
.28237 .30591 m .26828 .30959 L .25956 .30278 L p
.4 g
F P
s
P
p
.002 w
.87525 .29677 m .88191 .30363 L .86672 .30733 L p
.4 g
F P
s
P
p
.002 w
.84483 .3042 m .87525 .29677 L p
.86672 .30733 L .4 g
F P
s
P
p
.002 w
.72653 .29906 m .69668 .30647 L .68206 .29275 L p
.8 g
F P
s
P
p
.002 w
.65229 .30021 m .68206 .29275 L .69668 .30647 L p
.8 g
F P
s
P
p
.002 w
.25956 .30278 m .25078 .29591 L p
.28237 .30591 L .4 g
F P
s
P
p
.002 w
.25078 .29591 m .26493 .29218 L .28237 .30591 L p
.4 g
F P
s
P
p
.002 w
.80085 .29792 m .77071 .30534 L .75659 .2916 L p
.8 g
F P
s
P
p
.002 w
.89717 .29992 m .88191 .30363 L p
.87525 .29677 L .4 g
F P
s
P
p
.002 w
.45899 .2962 m .48811 .28871 L .50407 .30249 L p
.4 g
F P
s
P
p
1 .292 0 r
.01 w
.76443 .33745 m
.76443 .33745 L
s
P
p
1 .315 0 r
.01 w
.76457 .33927 m
.76457 .33927 L
s
P
p
1 .337 0 r
.01 w
.76471 .34109 m
.79491 .33378 L
s
P
p
.002 w
.87525 .29677 m .89054 .29304 L .89717 .29992 L p
.4 g
F P
s
P
p
.002 w
.11154 .18707 m .64339 .03636 L .89717 .29992 L p
.9 g
F P
s
P
p
.002 w
.68206 .29275 m .71206 .28524 L .72653 .29906 L p
.8 g
F P
s
P
p
.002 w
.75659 .2916 m .78687 .28408 L .80085 .29792 L p
.8 g
F P
s
P
p
.002 w
.41364 .28987 m .38481 .29735 L .36799 .2835 L p
.8 g
F P
s
P
p
.002 w
.89054 .29304 m .87525 .29677 L p
.86178 .28292 L .4 g
F P
s
P
p
.002 w
.48811 .28871 m .45899 .2962 L .44268 .28234 L p
.4 g
F P
s
P
p
.002 w
.26493 .29218 m .25078 .29591 L .24194 .289 L p
.4 g
F P
s
P
p
.002 w
.88387 .28611 m .89054 .29304 L p
.86178 .28292 L .4 g
F P
s
P
p
.002 w
.71206 .28524 m .68206 .29275 L .66725 .27884 L p
.8 g
F P
s
P
p
.002 w
.24194 .289 m .23304 .28205 L p
.26493 .29218 L .4 g
F P
s
P
p
.002 w
.23304 .28205 m .24725 .27826 L .26493 .29218 L p
.4 g
F P
s
P
p
.002 w
.78687 .28408 m .75659 .2916 L .74227 .27767 L p
.8 g
F P
s
P
p
1 .36 0 r
.01 w
.79506 .33561 m
.79506 .33561 L
s
P
p
1 .382 0 r
.01 w
.78116 .32381 m
.79522 .33743 L
s
P
p
.002 w
.36799 .2835 m .39696 .27592 L .41364 .28987 L p
.8 g
F P
s
P
p
.002 w
.44268 .28234 m .47194 .27475 L .48811 .28871 L p
.4 g
F P
s
P
p
.002 w
.86178 .28292 m .87715 .27913 L .88387 .28611 L p
.4 g
F P
s
P
p
.002 w
.66725 .27884 m .69739 .27123 L .71206 .28524 L p
.8 g
F P
s
P
p
.002 w
.74227 .27767 m .77271 .27005 L .78687 .28408 L p
.8 g
F P
s
P
p
.472 1 0 r
.01 w
.62011 .47554 m
.59032 .48238 L
s
P
p
.002 w
.39696 .27592 m .36799 .2835 L .35095 .26946 L p
.8 g
F P
s
P
p
.002 w
.87715 .27913 m .86178 .28292 L p
.84812 .26887 L .4 g
F P
s
P
p
.449 1 0 r
.01 w
.59037 .4843 m
.59037 .4843 L
s
P
p
.002 w
.47194 .27475 m .44268 .28234 L .42614 .26828 L p
.4 g
F P
s
P
p
.002 w
.24725 .27826 m .23304 .28205 L .22408 .27504 L p
.4 g
F P
s
P
p
.427 1 0 r
.01 w
.59041 .48622 m
.59041 .48622 L
s
P
p
.404 1 0 r
.01 w
.59045 .48814 m
.59045 .48814 L
s
P
p
.539 1 0 r
.01 w
.64988 .46289 m
.61993 .46979 L
s
P
p
.382 1 0 r
.01 w
.5905 .49006 m
.57495 .47742 L
s
P
p
.002 w
.87039 .27211 m .87715 .27913 L p
.84812 .26887 L .4 g
F P
s
P
p
.002 w
.69739 .27123 m .66725 .27884 L .65222 .26474 L p
.8 g
F P
s
P
p
.517 1 0 r
.01 w
.61999 .47171 m
.61999 .47171 L
s
P
p
.002 w
.22408 .27504 m .21505 .26799 L p
.24725 .27826 L .4 g
F P
s
P
p
.002 w
.21505 .26799 m .22933 .26415 L .24725 .27826 L p
.4 g
F P
s
P
p
.002 w
.77271 .27005 m .74227 .27767 L .72776 .26355 L p
.8 g
F P
s
P
p
.494 1 0 r
.01 w
.62005 .47362 m
.62005 .47362 L
s
P
p
.002 w
.35095 .26946 m .38005 .26178 L .39696 .27592 L p
.8 g
F P
s
P
p
.607 1 0 r
.01 w
.67978 .45019 m
.64965 .45716 L
s
P
p
1 .404 0 r
.01 w
.78131 .32565 m
.78131 .32565 L
s
P
p
.002 w
.42614 .26828 m .45553 .26059 L .47194 .27475 L p
.4 g
F P
s
P
p
.584 1 0 r
.01 w
.64973 .45907 m
.64973 .45907 L
s
P
p
1 .427 0 r
.01 w
.78147 .32748 m
.78147 .32748 L
s
P
p
.562 1 0 r
.01 w
.64981 .46098 m
.64981 .46098 L
s
P
p
1 .449 0 r
.01 w
.76734 .31552 m
.78162 .32932 L
s
P
p
.002 w
.65222 .26474 m .62215 .2724 L .60677 .25821 L p
.4 g
F P
s
P
p
.002 w
.84812 .26887 m .86358 .26503 L .87039 .27211 L p
.4 g
F P
s
P
p
.674 1 0 r
.01 w
.70979 .43744 m
.6795 .44447 L
s
P
p
.002 w
.65222 .26474 m .68252 .25702 L .69739 .27123 L p
.8 g
F P
s
P
p
.652 1 0 r
.01 w
.67959 .44638 m
.67959 .44638 L
s
P
p
.002 w
.80338 .26237 m .77271 .27005 L .75835 .25582 L p
.8 g
F P
s
P
p
.002 w
.72776 .26355 m .75835 .25582 L .77271 .27005 L p
.8 g
F P
s
P
p
0 1 0 r
.01 w
.44008 .52517 m
.41075 .53187 L
s
P
p
.629 1 0 r
.01 w
.67968 .44828 m
.67968 .44828 L
s
P
p
.002 w
.86358 .26503 m .84812 .26887 L p
.83428 .25463 L .4 g
F P
s
P
p
.002 w
.45553 .26059 m .42614 .26828 L .40937 .25403 L p
.4 g
F P
s
P
p
0 1 .022 r
.01 w
.41069 .53383 m
.41069 .53383 L
s
P
p
.002 w
.22933 .26415 m .21505 .26799 L .20597 .26088 L p
.4 g
F P
s
P
p
.742 1 0 r
.01 w
.73993 .42464 m
.70946 .43173 L
s
P
p
0 1 .045 r
.01 w
.41063 .53579 m
.41063 .53579 L
s
P
p
.719 1 0 r
.01 w
.70957 .43363 m
.70957 .43363 L
s
P
p
.002 w
.60677 .25821 m .57677 .26592 L .56103 .25164 L p
.8 g
F P
s
P
p
0 1 .067 r
.01 w
.41058 .53776 m
.41058 .53776 L
s
P
p
.067 1 0 r
.01 w
.46971 .51253 m
.44021 .51929 L
s
P
p
.697 1 0 r
.01 w
.70968 .43554 m
.70968 .43554 L
s
P
p
.002 w
.85672 .25791 m .86358 .26503 L p
.83428 .25463 L .4 g
F P
s
P
p
.002 w
.60677 .25821 m .63699 .25044 L .65222 .26474 L p
.4 g
F P
s
P
p
.002 w
.68252 .25702 m .65222 .26474 L .63699 .25044 L p
.8 g
F P
s
P
p
0 1 .09 r
.01 w
.41052 .53972 m
.3936 .52733 L
s
P
p
.002 w
.20597 .26088 m .19682 .25373 L p
.22933 .26415 L .4 g
F P
s
P
p
.002 w
.19682 .25373 m .21116 .24984 L .22933 .26415 L p
.4 g
F P
s
P
p
.045 1 0 r
.01 w
.44017 .52125 m
.44017 .52125 L
s
P
p
.36 1 0 r
.01 w
.57498 .47935 m
.57498 .47935 L
s
P
p
.809 1 0 r
.01 w
.73954 .41894 m
.77019 .41179 L
s
P
p
.022 1 0 r
.01 w
.44013 .52321 m
.44013 .52321 L
s
P
p
.337 1 0 r
.01 w
.57502 .48128 m
.57502 .48128 L
s
P
p
.002 w
.83428 .25463 m .80338 .26237 L .78918 .24804 L p
.8 g
F P
s
P
p
.002 w
.75835 .25582 m .78918 .24804 L .80338 .26237 L p
.8 g
F P
s
P
p
.787 1 0 r
.01 w
.73967 .42084 m
.73967 .42084 L
s
P
p
.315 1 0 r
.01 w
.57505 .48322 m
.55926 .47041 L
s
P
p
.135 1 0 r
.01 w
.49946 .49984 m
.46979 .50667 L
s
P
p
.764 1 0 r
.01 w
.7398 .42274 m
.7398 .42274 L
s
P
p
.002 w
.48515 .25284 m .45553 .26059 L .43891 .24623 L p
.4 g
F P
s
P
p
.002 w
.40937 .25403 m .43891 .24623 L .45553 .26059 L p
.4 g
F P
s
P
p
.112 1 0 r
.01 w
.46976 .50862 m
.46976 .50862 L
s
P
p
.876 1 0 r
.01 w
.76975 .4061 m
.80057 .39889 L
s
P
p
.09 1 0 r
.01 w
.46974 .51057 m
.46974 .51057 L
s
P
p
.002 w
.63699 .25044 m .60677 .25821 L .59117 .24382 L p
.4 g
F P
s
P
p
.002 w
.56103 .25164 m .59117 .24382 L .60677 .25821 L p
.8 g
F P
s
P
p
.854 1 0 r
.01 w
.76989 .40799 m
.76989 .40799 L
s
P
p
.002 w
.83428 .25463 m .84981 .25074 L .85672 .25791 L p
.4 g
F P
s
P
p
1 .472 0 r
.01 w
.76748 .31737 m
.76748 .31737 L
s
P
p
.002 w
.71304 .24924 m .68252 .25702 L .66744 .24261 L p
.8 g
F P
s
P
p
.002 w
.63699 .25044 m .66744 .24261 L .68252 .25702 L p
.8 g
F P
s
P
p
.202 1 0 r
.01 w
.52932 .4871 m
.49948 .49399 L
s
P
p
.831 1 0 r
.01 w
.77004 .40989 m
.77004 .40989 L
s
P
p
1 .494 0 r
.01 w
.76763 .31921 m
.76763 .31921 L
s
P
p
.18 1 0 r
.01 w
.49947 .49593 m
.49947 .49593 L
s
P
p
.944 1 0 r
.01 w
.80007 .3932 m
.83107 .38593 L
s
P
p
1 .517 0 r
.01 w
.75328 .30709 m
.76778 .32106 L
s
P
p
.002 w
.84981 .25074 m .83428 .25463 L p
.82024 .24019 L .4 g
F P
s
P
p
.002 w
.78918 .24804 m .82024 .24019 L .83428 .25463 L p
.8 g
F P
s
P
p
.157 1 0 r
.01 w
.49946 .49788 m
.49946 .49788 L
s
P
p
.002 w
.43891 .24623 m .40937 .25403 L .39236 .23959 L p
.4 g
F P
s
P
p
.002 w
.21116 .24984 m .19682 .25373 L .18761 .24653 L p
.4 g
F P
s
P
p
.921 1 0 r
.01 w
.80024 .3951 m
.80024 .3951 L
s
P
p
.002 w
.43891 .24623 m .46867 .23837 L .48515 .25284 L p
.4 g
F P
s
P
p
.27 1 0 r
.01 w
.55931 .4743 m
.5293 .48125 L
s
P
p
.899 1 0 r
.01 w
.8004 .39699 m
.8004 .39699 L
s
P
p
.247 1 0 r
.01 w
.52931 .4832 m
.52931 .4832 L
s
P
p
.002 w
.84286 .24352 m .84981 .25074 L p
.82024 .24019 L .4 g
F P
s
P
p
1 .989 0 r
.01 w
.83052 .38026 m
.8617 .37292 L
s
P
p
.002 w
.59117 .24382 m .62155 .23594 L .63699 .25044 L p
.4 g
F P
s
P
p
.225 1 0 r
.01 w
.52931 .48515 m
.52931 .48515 L
s
P
p
.002 w
.18761 .24653 m .17833 .23928 L p
.21116 .24984 L .4 g
F P
s
P
p
.002 w
.17833 .23928 m .19274 .23533 L .21116 .24984 L p
.4 g
F P
s
P
p
.989 1 0 r
.01 w
.8307 .38215 m
.8307 .38215 L
s
P
p
.002 w
.7438 .2414 m .71304 .24924 L .69812 .23472 L p
.8 g
F P
s
P
p
.002 w
.66744 .24261 m .69812 .23472 L .71304 .24924 L p
.8 g
F P
s
P
p
0 1 .112 r
.01 w
.39353 .5293 m
.39353 .5293 L
s
P
p
.966 1 0 r
.01 w
.83089 .38404 m
.83089 .38404 L
s
P
p
.002 w
.82024 .24019 m .78918 .24804 L .77478 .23351 L p
.8 g
F P
s
P
p
0 1 .135 r
.01 w
.39346 .53128 m
.39346 .53128 L
s
P
p
1 .899 0 r
.01 w
.84699 .35166 m
.86089 .36538 L
s
P
p
0 1 .157 r
.01 w
.39339 .53326 m
.37622 .52071 L
s
P
p
1 .921 0 r
.01 w
.86109 .36726 m
.86109 .36726 L
s
P
p
.002 w
.46867 .23837 m .43891 .24623 L .42204 .23167 L p
.4 g
F P
s
P
p
.002 w
.39236 .23959 m .42204 .23167 L .43891 .24623 L p
.4 g
F P
s
P
p
.292 1 0 r
.01 w
.55928 .47236 m
.55928 .47236 L
s
P
p
1 .944 0 r
.01 w
.86129 .36914 m
.86129 .36914 L
s
P
p
1 .966 0 r
.01 w
.86149 .37103 m
.86149 .37103 L
s
P
p
.002 w
.62155 .23594 m .59117 .24382 L .57536 .22923 L p
.4 g
F P
s
P
p
.002 w
.82024 .24019 m .83586 .23625 L .84286 .24352 L p
.4 g
F P
s
P
p
.002 w
.77478 .23351 m .7438 .2414 L .72903 .22678 L p
.8 g
F P
s
P
p
.002 w
.69812 .23472 m .72903 .22678 L .7438 .2414 L p
.8 g
F P
s
P
p
.002 w
.34552 .2329 m .31614 .2408 L .29838 .22616 L p
.8 g
F P
s
P
p
.002 w
.83586 .23625 m .82024 .24019 L p
.80601 .22555 L .4 g
F P
s
P
p
.002 w
.77478 .23351 m .80601 .22555 L .82024 .24019 L p
.8 g
F P
s
P
p
.002 w
.19274 .23533 m .17833 .23928 L .16899 .23198 L p
.4 g
F P
s
P
p
1 .539 0 r
.01 w
.75342 .30894 m
.75342 .30894 L
s
P
p
.002 w
.42204 .23167 m .45195 .2237 L .46867 .23837 L p
.4 g
F P
s
P
p
1 .562 0 r
.01 w
.75355 .3108 m
.75355 .3108 L
s
P
p
1 .584 0 r
.01 w
.75369 .31266 m
.75369 .31266 L
s
P
p
1 .831 0 r
.01 w
.83234 .33209 m
.84642 .34601 L
s
P
p
.002 w
.82881 .22892 m .83586 .23625 L p
.80601 .22555 L .4 g
F P
s
P
p
.002 w
.57536 .22923 m .60589 .22124 L .62155 .23594 L p
.4 g
F P
s
P
p
1 .607 0 r
.01 w
.75383 .31452 m
.78494 .30688 L
s
P
p
1 .854 0 r
.01 w
.84661 .34789 m
.84661 .34789 L
s
P
p
.002 w
.16899 .23198 m .15958 .22463 L p
.19274 .23533 L .4 g
F P
s
P
p
.002 w
.15958 .22463 m .17406 .22062 L .19274 .23533 L p
.4 g
F P
s
P
p
1 .876 0 r
.01 w
.8468 .34978 m
.8468 .34978 L
s
P
p
.002 w
.80601 .22555 m .77478 .23351 L .76018 .21877 L p
.8 g
F P
s
P
p
.002 w
.72903 .22678 m .76018 .21877 L .77478 .23351 L p
.8 g
F P
s
P
p
.002 w
.29838 .22616 m .32789 .21815 L .34552 .2329 L p
.8 g
F P
s
P
p
0 1 .18 r
.01 w
.37613 .5227 m
.37613 .5227 L
s
P
p
.002 w
.52887 .22247 m .49866 .23045 L .48209 .21567 L p
.8 g
F P
s
P
p
0 1 .202 r
.01 w
.37605 .52469 m
.37605 .52469 L
s
P
p
.002 w
.60589 .22124 m .57536 .22923 L .55932 .21443 L p
.4 g
F P
s
P
p
.002 w
.80601 .22555 m .82171 .22155 L .82881 .22892 L p
.4 g
F P
s
P
p
0 1 .225 r
.01 w
.37597 .52668 m
.35852 .51398 L
s
P
p
1 .629 0 r
.01 w
.7851 .30875 m
.7851 .30875 L
s
P
p
.002 w
.32789 .21815 m .29838 .22616 L .28036 .21132 L p
.8 g
F P
s
P
p
1 .764 0 r
.01 w
.81753 .31231 m
.83179 .32645 L
s
P
p
.002 w
.82171 .22155 m .80601 .22555 L p
.79157 .2107 L .4 g
F P
s
P
p
.002 w
.76018 .21877 m .79157 .2107 L .80601 .22555 L p
.8 g
F P
s
P
p
1 .652 0 r
.01 w
.78526 .31062 m
.78526 .31062 L
s
P
p
.002 w
.40494 .21691 m .37512 .22493 L .35763 .21008 L p
.4 g
F P
s
P
p
.002 w
.17406 .22062 m .15958 .22463 L .15011 .21722 L p
.4 g
F P
s
P
p
1 .787 0 r
.01 w
.83197 .32833 m
.83197 .32833 L
s
P
p
1 .674 0 r
.01 w
.78542 .31249 m
.81682 .3048 L
s
P
p
1 .809 0 r
.01 w
.83216 .33021 m
.83216 .33021 L
s
P
p
.002 w
.48209 .21567 m .51245 .20758 L .52887 .22247 L p
.8 g
F P
s
P
p
.002 w
.81456 .21412 m .82171 .22155 L p
.79157 .2107 L .4 g
F P
s
P
p
.002 w
.63665 .21319 m .60589 .22124 L .59 .20633 L p
.4 g
F P
s
P
p
.002 w
.55932 .21443 m .59 .20633 L .60589 .22124 L p
.4 g
F P
s
P
p
.002 w
.15011 .21722 m .14057 .20977 L p
.17406 .22062 L .4 g
F P
s
P
p
.002 w
.14057 .20977 m .15511 .2057 L .17406 .22062 L p
.4 g
F P
s
P
p
.002 w
.28036 .21132 m .31001 .2032 L .32789 .21815 L p
.8 g
F P
s
P
p
.002 w
.435 .20883 m .40494 .21691 L .3876 .20194 L p
.4 g
F P
s
P
p
.002 w
.35763 .21008 m .3876 .20194 L .40494 .21691 L p
.4 g
F P
s
P
p
1 .697 0 r
.01 w
.817 .30667 m
.817 .30667 L
s
P
p
.002 w
.79157 .2107 m .80735 .20664 L .81456 .21412 L p
.4 g
F P
s
P
p
1 .719 0 r
.01 w
.81718 .30855 m
.81718 .30855 L
s
P
p
.002 w
.66764 .20508 m .63665 .21319 L .62092 .19816 L p
.4 g
F P
s
P
p
.002 w
.59 .20633 m .62092 .19816 L .63665 .21319 L p
.4 g
F P
s
P
p
0 1 .247 r
.01 w
.35843 .51598 m
.35843 .51598 L
s
P
p
1 .742 0 r
.01 w
.81736 .31043 m
.81736 .31043 L
s
P
p
0 1 .27 r
.01 w
.35834 .51798 m
.35834 .51798 L
s
P
p
.002 w
.80735 .20664 m .79157 .2107 L p
.77693 .19564 L .4 g
F P
s
P
p
.002 w
.3876 .20194 m .35763 .21008 L .3399 .19501 L p
.4 g
F P
s
P
p
0 1 .292 r
.01 w
.35824 .51999 m
.34051 .50712 L
s
P
p
.002 w
.15511 .2057 m .14057 .20977 L .13096 .20225 L p
.4 g
F P
s
P
p
.002 w
.3876 .20194 m .4178 .19374 L .435 .20883 L p
.4 g
F P
s
P
p
.002 w
.8001 .19911 m .80735 .20664 L p
.77693 .19564 L .4 g
F P
s
P
p
.002 w
.13096 .20225 m .12128 .19469 L p
.15511 .2057 L .4 g
F P
s
P
p
.002 w
.12128 .19469 m .13589 .19057 L .15511 .2057 L p
.4 g
F P
s
P
p
.002 w
.69888 .1969 m .66764 .20508 L .65208 .18994 L p
.4 g
F P
s
P
p
.002 w
.62092 .19816 m .65208 .18994 L .66764 .20508 L p
.4 g
F P
s
P
p
.002 w
.4178 .19374 m .3876 .20194 L .37001 .18676 L p
.4 g
F P
s
P
p
.002 w
.3399 .19501 m .37001 .18676 L .3876 .20194 L p
.4 g
F P
s
P
p
.002 w
.57389 .19121 m .54306 .19942 L .52656 .1842 L p
.8 g
F P
s
P
p
.002 w
.77693 .19564 m .7928 .19152 L .8001 .19911 L p
.4 g
F P
s
P
p
.002 w
.65208 .18994 m .68348 .18164 L .69888 .1969 L p
.4 g
F P
s
P
p
.002 w
.7928 .19152 m .77693 .19564 L p
.76208 .18036 L .4 g
F P
s
P
p
.002 w
.13589 .19057 m .12128 .19469 L .11154 .18707 L p
.4 g
F P
s
P
p
.002 w
.44824 .18548 m .4178 .19374 L .40036 .17844 L p
.4 g
F P
s
P
p
.002 w
.37001 .18676 m .40036 .17844 L .4178 .19374 L p
.4 g
F P
s
P
p
0 1 .315 r
.01 w
.34041 .50914 m
.34041 .50914 L
s
P
p
0 1 .337 r
.01 w
.3403 .51116 m
.3403 .51116 L
s
P
p
.002 w
.78544 .18388 m .7928 .19152 L p
.76208 .18036 L .4 g
F P
s
P
p
.002 w
.52656 .1842 m .55755 .17587 L .57389 .19121 L p
.8 g
F P
s
P
p
0 1 .36 r
.01 w
.3402 .51318 m
.3402 .51318 L
s
P
p
.002 w
.12618 .18292 m .14088 .17876 L p
.13589 .19057 L .4 g
F P
s
P
p
.002 w
.16528 .18228 m .13589 .19057 L p
.14088 .17876 L .4 g
F P
s
P
p
.002 w
.11154 .18707 m .12618 .18292 L .13589 .19057 L p
.4 g
F P
s
P
p
.002 w
.68348 .18164 m .65208 .18994 L .63629 .17458 L p
.4 g
F P
s
P
p
0 1 .382 r
.01 w
.34009 .5152 m
.37029 .50817 L
s
P
p
.002 w
.32191 .17972 m .29188 .18803 L .27348 .17264 L p
.8 g
F P
s
P
p
.002 w
.47891 .17715 m .44824 .18548 L .43095 .17006 L p
.4 g
F P
s
P
p
.002 w
.40036 .17844 m .43095 .17006 L .44824 .18548 L p
.4 g
F P
s
P
p
.002 w
.76208 .18036 m .77803 .17619 L .78544 .18388 L p
.4 g
F P
s
P
p
.002 w
.15563 .17458 m .17045 .17038 L p
.16528 .18228 L .4 g
F P
s
P
p
.002 w
.19489 .17393 m .16528 .18228 L p
.17045 .17038 L .4 g
F P
s
P
p
.002 w
.14088 .17876 m .15563 .17458 L .16528 .18228 L p
.4 g
F P
s
P
p
.002 w
.63629 .17458 m .66785 .16617 L .68348 .18164 L p
.4 g
F P
s
P
p
.002 w
.77803 .17619 m .76208 .18036 L p
.74701 .16487 L .4 g
F P
s
P
p
0 1 .404 r
.01 w
.3702 .5102 m
.3702 .5102 L
s
P
p
.002 w
.35217 .17135 m .32191 .17972 L .30365 .16422 L p
.8 g
F P
s
P
p
.002 w
.27348 .17264 m .30365 .16422 L .32191 .17972 L p
.8 g
F P
s
P
p
0 1 .427 r
.01 w
.37011 .51223 m
.37011 .51223 L
s
P
p
0 1 .449 r
.01 w
.37003 .51426 m
.40051 .50719 L
s
P
p
.002 w
.50982 .16876 m .47891 .17715 L .46177 .16161 L p
.4 g
F P
s
P
p
.002 w
.43095 .17006 m .46177 .16161 L .47891 .17715 L p
.4 g
F P
s
P
p
.002 w
.77057 .16844 m .77803 .17619 L p
.74701 .16487 L .4 g
F P
s
P
p
.002 w
.66785 .16617 m .63629 .17458 L .62027 .159 L p
.4 g
F P
s
P
p
.002 w
.18532 .16617 m .20025 .16194 L p
.19489 .17393 L .4 g
F P
s
P
p
.002 w
.22474 .16552 m .19489 .17393 L p
.20025 .16194 L .4 g
F P
s
P
p
.002 w
.17045 .17038 m .18532 .16617 L .19489 .17393 L p
.4 g
F P
s
P
p
.002 w
.30365 .16422 m .33406 .15572 L .35217 .17135 L p
.8 g
F P
s
P
p
.002 w
.46177 .16161 m .49284 .1531 L .50982 .16876 L p
.4 g
F P
s
P
p
.002 w
.74701 .16487 m .76305 .16063 L .77057 .16844 L p
.4 g
F P
s
P
p
0 1 .472 r
.01 w
.40044 .50922 m
.40044 .50922 L
s
P
p
0 1 .494 r
.01 w
.40037 .51127 m
.38258 .49807 L
s
P
p
.002 w
.62027 .159 m .652 .15046 L .66785 .16617 L p
.4 g
F P
s
P
p
.002 w
.21523 .15769 m .23028 .15342 L p
.22474 .16552 L .4 g
F P
s
P
p
.002 w
.25482 .15703 m .22474 .16552 L p
.23028 .15342 L .4 g
F P
s
P
p
.002 w
.20025 .16194 m .21523 .15769 L .22474 .16552 L p
.4 g
F P
s
P
p
.002 w
.76305 .16063 m .74701 .16487 L p
.73173 .14914 L .4 g
F P
s
P
p
.002 w
.4134 .15441 m .38267 .16291 L .36471 .14716 L p
.8 g
F P
s
P
p
.002 w
.49284 .1531 m .46177 .16161 L .44439 .14584 L p
.4 g
F P
s
P
p
.002 w
.75548 .15277 m .76305 .16063 L p
.73173 .14914 L .4 g
F P
s
P
p
.002 w
.57237 .15178 m .54097 .1603 L .52415 .14451 L p
.8 g
F P
s
P
p
.002 w
.652 .15046 m .62027 .159 L .60402 .14319 L p
.4 g
F P
s
P
p
.002 w
.24539 .14914 m .26055 .14485 L p
.25482 .15703 L .4 g
F P
s
P
p
.002 w
.28514 .14848 m .25482 .15703 L p
.26055 .14485 L .4 g
F P
s
P
p
.002 w
.23028 .15342 m .24539 .14914 L .25482 .15703 L p
.4 g
F P
s
P
p
.002 w
.44439 .14584 m .4134 .15441 L .39561 .13853 L p
.8 g
F P
s
P
p
.002 w
.36471 .14716 m .39561 .13853 L .4134 .15441 L p
.8 g
F P
s
P
p
.002 w
.44439 .14584 m .47561 .1372 L .49284 .1531 L p
.4 g
F P
s
P
p
.002 w
.73173 .14914 m .74785 .14485 L .75548 .15277 L p
.4 g
F P
s
P
p
.002 w
.52415 .14451 m .55572 .13587 L .57237 .15178 L p
.8 g
F P
s
P
p
.002 w
.60402 .14319 m .63592 .13453 L .652 .15046 L p
.4 g
F P
s
P
p
0 1 .517 r
.01 w
.3825 .50012 m
.3825 .50012 L
s
P
p
.002 w
.74785 .14485 m .73173 .14914 L p
.71622 .13319 L .4 g
F P
s
P
p
.002 w
.27578 .14053 m .29107 .1362 L p
.28514 .14848 L .4 g
F P
s
P
p
.002 w
.3157 .13987 m .28514 .14848 L p
.29107 .1362 L .4 g
F P
s
P
p
.002 w
.26055 .14485 m .27578 .14053 L .28514 .14848 L p
.4 g
F P
s
P
p
0 1 .539 r
.01 w
.38242 .50218 m
.38242 .50218 L
s
P
p
0 1 .562 r
.01 w
.38234 .50423 m
.36425 .49087 L
s
P
p
.002 w
.39561 .13853 m .42674 .12984 L .44439 .14584 L p
.8 g
F P
s
P
p
.002 w
.74017 .13687 m .74785 .14485 L p
.71622 .13319 L .4 g
F P
s
P
p
.002 w
.55572 .13587 m .52415 .14451 L .50709 .12849 L p
.8 g
F P
s
P
p
.002 w
.63592 .13453 m .60402 .14319 L .58753 .12715 L p
.4 g
F P
s
P
p
.002 w
.30641 .13185 m .32182 .12748 L p
.3157 .13987 L .4 g
F P
s
P
p
.002 w
.3465 .13118 m .3157 .13987 L p
.32182 .12748 L .4 g
F P
s
P
p
.002 w
.29107 .1362 m .30641 .13185 L .3157 .13987 L p
.4 g
F P
s
P
p
.002 w
.71622 .13319 m .73243 .12883 L .74017 .13687 L p
.4 g
F P
s
P
p
.002 w
.50709 .12849 m .53881 .11972 L .55572 .13587 L p
.8 g
F P
s
P
p
.002 w
.58753 .12715 m .6196 .11836 L .63592 .13453 L p
.4 g
F P
s
P
p
.002 w
.73243 .12883 m .71622 .13319 L p
.70048 .117 L .4 g
F P
s
P
p
.002 w
.33729 .1231 m .35282 .1187 L p
.3465 .13118 L .4 g
F P
s
P
p
.002 w
.37755 .12242 m .3465 .13118 L p
.35282 .1187 L .4 g
F P
s
P
p
.002 w
.32182 .12748 m .33729 .1231 L .3465 .13118 L p
.4 g
F P
s
P
p
.002 w
.45813 .12107 m .42674 .12984 L .40884 .1136 L p
.4 g
F P
s
P
p
0 1 .584 r
.01 w
.36415 .49293 m
.36415 .49293 L
s
P
p
.002 w
.72464 .12073 m .73243 .12883 L p
.70048 .117 L .4 g
F P
s
P
p
.002 w
.53881 .11972 m .50709 .12849 L .48977 .11224 L p
.8 g
F P
s
P
p
0 1 .607 r
.01 w
.36406 .495 m
.36406 .495 L
s
P
p
.002 w
.6196 .11836 m .58753 .12715 L .5708 .11087 L p
.4 g
F P
s
P
p
0 1 .629 r
.01 w
.36397 .49707 m
.34558 .48353 L
s
P
p
.002 w
.36842 .11428 m .38407 .10984 L p
.37755 .12242 L .4 g
F P
s
P
p
.002 w
.40884 .1136 m .37755 .12242 L p
.38407 .10984 L .4 g
F P
s
P
p
.002 w
.35282 .1187 m .36842 .11428 L .37755 .12242 L p
.4 g
F P
s
P
p
.002 w
.40884 .1136 m .44039 .1047 L .45813 .12107 L p
.4 g
F P
s
P
p
.002 w
.70048 .117 m .71678 .11258 L .72464 .12073 L p
.4 g
F P
s
P
p
.002 w
.48977 .11224 m .52166 .10333 L .53881 .11972 L p
.8 g
F P
s
P
p
.002 w
.65192 .1095 m .6196 .11836 L .60303 .10195 L p
.4 g
F P
s
P
p
.002 w
.5708 .11087 m .60303 .10195 L .6196 .11836 L p
.4 g
F P
s
P
p
.002 w
.71678 .11258 m .70048 .117 L p
.68451 .10057 L .4 g
F P
s
P
p
.002 w
.39979 .10539 m .41557 .10092 L p
.40884 .1136 L .4 g
F P
s
P
p
.002 w
.44039 .1047 m .40884 .1136 L p
.41557 .10092 L .4 g
F P
s
P
p
.002 w
.38407 .10984 m .39979 .10539 L .40884 .1136 L p
.4 g
F P
s
P
p
.002 w
.70887 .10436 m .71678 .11258 L p
.68451 .10057 L .4 g
F P
s
P
p
.002 w
.68451 .10057 m .65192 .1095 L .63553 .09296 L p
.4 g
F P
s
P
p
.002 w
.60303 .10195 m .63553 .09296 L .65192 .1095 L p
.4 g
F P
s
P
p
0 1 .652 r
.01 w
.34547 .48561 m
.34547 .48561 L
s
P
p
0 1 .674 r
.01 w
.34537 .48769 m
.34537 .48769 L
s
P
p
0 1 .697 r
.01 w
.34526 .48978 m
.32656 .47606 L
s
P
p
.002 w
.43142 .09643 m .44733 .09192 L p
.44039 .1047 L .4 g
F P
s
P
p
.002 w
.47219 .09573 m .44039 .1047 L p
.44733 .09192 L .4 g
F P
s
P
p
.002 w
.41557 .10092 m .43142 .09643 L .44039 .1047 L p
.4 g
F P
s
P
p
.002 w
.68451 .10057 m .7009 .09608 L .70887 .10436 L p
.4 g
F P
s
P
p
.002 w
.7009 .09608 m .68451 .10057 L p
.6683 .0839 L .4 g
F P
s
P
p
.002 w
.63553 .09296 m .6683 .0839 L .68451 .10057 L p
.4 g
F P
s
P
p
.002 w
.69287 .08774 m .7009 .09608 L p
.6683 .0839 L .4 g
F P
s
P
p
.002 w
.4633 .08739 m .47934 .08285 L p
.47219 .09573 L .4 g
F P
s
P
p
.002 w
.50425 .08669 m .47219 .09573 L p
.47934 .08285 L .4 g
F P
s
P
p
.002 w
.44733 .09192 m .4633 .08739 L .47219 .09573 L p
.4 g
F P
s
P
p
0 1 .719 r
.01 w
.32644 .47815 m
.32644 .47815 L
s
P
p
.002 w
.6683 .0839 m .68478 .07934 L .69287 .08774 L p
.4 g
F P
s
P
p
0 1 .742 r
.01 w
.32632 .48025 m
.32632 .48025 L
s
P
p
.002 w
.49545 .07828 m .51162 .0737 L p
.50425 .08669 L .4 g
F P
s
P
p
.002 w
.53657 .07758 m .50425 .08669 L p
.51162 .0737 L .4 g
F P
s
P
p
.002 w
.47934 .08285 m .49545 .07828 L .50425 .08669 L p
.4 g
F P
s
P
p
0 1 .764 r
.01 w
.32621 .48235 m
.30718 .46844 L
s
P
p
.002 w
.68478 .07934 m .6683 .0839 L p
.65184 .06697 L .4 g
F P
s
P
p
.002 w
.67663 .07087 m .68478 .07934 L p
.65184 .06697 L .4 g
F P
s
P
p
.002 w
.52786 .0691 m .54416 .06448 L p
.53657 .07758 L .4 g
F P
s
P
p
.002 w
.56916 .06839 m .53657 .07758 L p
.54416 .06448 L .4 g
F P
s
P
p
.002 w
.51162 .0737 m .52786 .0691 L .53657 .07758 L p
.4 g
F P
s
P
p
.002 w
.65184 .06697 m .66841 .06234 L .67663 .07087 L p
.4 g
F P
s
P
p
.002 w
.56053 .05984 m .57697 .05518 L p
.56916 .06839 L .4 g
F P
s
P
p
.002 w
.60201 .05913 m .56916 .06839 L p
.57697 .05518 L .4 g
F P
s
P
p
.002 w
.54416 .06448 m .56053 .05984 L .56916 .06839 L p
.4 g
F P
s
P
p
0 1 .787 r
.01 w
.30705 .47055 m
.30705 .47055 L
s
P
p
.002 w
.66841 .06234 m .65184 .06697 L p
.63513 .04979 L .4 g
F P
s
P
p
0 1 .809 r
.01 w
.30692 .47266 m
.30692 .47266 L
s
P
p
0 1 .831 r
.01 w
.30679 .47478 m
.28744 .46068 L
s
P
p
.002 w
.66014 .05375 m .66841 .06234 L p
.63513 .04979 L .4 g
F P
s
P
p
.002 w
.59347 .05051 m .61004 .04581 L p
.60201 .05913 L .4 g
F P
s
P
p
.002 w
.63513 .04979 m .60201 .05913 L p
.61004 .04581 L .4 g
F P
s
P
p
.002 w
.57697 .05518 m .59347 .05051 L .60201 .05913 L p
.4 g
F P
s
P
p
.002 w
.63513 .04979 m .6518 .04509 L .66014 .05375 L p
.4 g
F P
s
P
p
.002 w
.62668 .04109 m .64339 .03636 L p
.63513 .04979 L .4 g
F P
s
P
p
.002 w
.6518 .04509 m .63513 .04979 L p
.64339 .03636 L .4 g
F P
s
P
p
.002 w
.61004 .04581 m .62668 .04109 L .63513 .04979 L p
.4 g
F P
s
P
p
0 1 .854 r
.01 w
.28729 .4628 m
.28729 .4628 L
s
P
p
0 1 .876 r
.01 w
.28715 .46493 m
.28715 .46493 L
s
P
p
0 1 .899 r
.01 w
.287 .46706 m
.26731 .45277 L
s
P
p
0 1 .921 r
.01 w
.26715 .45491 m
.26715 .45491 L
s
P
p
0 1 .944 r
.01 w
.26699 .45705 m
.26699 .45705 L
s
P
p
.494 0 1 r
.01 w
.61037 .67504 m
.6276 .68775 L
s
P
p
0 1 .966 r
.01 w
.26684 .4592 m
.2468 .4447 L
s
P
p
.517 0 1 r
.01 w
.62767 .69004 m
.62767 .69004 L
s
P
p
.539 0 1 r
.01 w
.62774 .69234 m
.62774 .69234 L
s
P
p
.562 0 1 r
.01 w
.62782 .69464 m
.62782 .69464 L
s
P
p
.584 0 1 r
.01 w
.62789 .69694 m
.62789 .69694 L
s
P
p
.607 0 1 r
.01 w
.62796 .69925 m
.62796 .69925 L
s
P
p
.629 0 1 r
.01 w
.62803 .70156 m
.62803 .70156 L
s
P
p
.652 0 1 r
.01 w
.62811 .70387 m
.62811 .70387 L
s
P
p
.674 0 1 r
.01 w
.62818 .70618 m
.62818 .70618 L
s
P
p
.292 0 1 r
.01 w
.5409 .63542 m
.55876 .64851 L
s
P
p
.427 0 1 r
.01 w
.59272 .65521 m
.61019 .66815 L
s
P
p
.697 0 1 r
.01 w
.62825 .7085 m
.62825 .7085 L
s
P
p
.315 0 1 r
.01 w
.55878 .65079 m
.55878 .65079 L
s
P
p
.449 0 1 r
.01 w
.61025 .67044 m
.61025 .67044 L
s
P
p
.719 0 1 r
.01 w
.62833 .71082 m
.62833 .71082 L
s
P
p
.337 0 1 r
.01 w
.55881 .65308 m
.59252 .64602 L
s
P
p
.472 0 1 r
.01 w
.61031 .67274 m
.61031 .67274 L
s
P
p
.742 0 1 r
.01 w
.6284 .71315 m
.6284 .71315 L
s
P
p
.764 0 1 r
.01 w
.62847 .71547 m
.62847 .71547 L
s
P
p
.787 0 1 r
.01 w
.62854 .7178 m
.62854 .7178 L
s
P
p
0 1 .989 r
.01 w
.24662 .44686 m
.24662 .44686 L
s
P
p
.809 0 1 r
.01 w
.62862 .72013 m
.62862 .72013 L
s
P
p
0 .989 1 r
.01 w
.24645 .44902 m
.24645 .44902 L
s
P
p
.831 0 1 r
.01 w
.62869 .72247 m
.62869 .72247 L
s
P
p
0 .966 1 r
.01 w
.24628 .45118 m
.24628 .45118 L
s
P
p
.854 0 1 r
.01 w
.62877 .72481 m
.62877 .72481 L
s
P
p
0 .944 1 r
.01 w
.2461 .45335 m
.27863 .44542 L
s
P
p
.876 0 1 r
.01 w
.62884 .72715 m
.62884 .72715 L
s
P
p
.225 0 1 r
.01 w
.52274 .61525 m
.54085 .62857 L
s
P
p
.36 0 1 r
.01 w
.59257 .64832 m
.59257 .64832 L
s
P
p
.899 0 1 r
.01 w
.62891 .7295 m
.62891 .7295 L
s
P
p
.247 0 1 r
.01 w
.54086 .63085 m
.54086 .63085 L
s
P
p
.382 0 1 r
.01 w
.59262 .65061 m
.59262 .65061 L
s
P
p
.921 0 1 r
.01 w
.62899 .73184 m
.62899 .73184 L
s
P
p
.27 0 1 r
.01 w
.54088 .63314 m
.54088 .63314 L
s
P
p
.404 0 1 r
.01 w
.59267 .65291 m
.59267 .65291 L
s
P
p
.944 0 1 r
.01 w
.62906 .73419 m
.62906 .73419 L
s
P
p
.966 0 1 r
.01 w
.62914 .73655 m
.62914 .73655 L
s
P
p
.989 0 1 r
.01 w
.62921 .7389 m
.62921 .7389 L
s
P
p
1 0 .989 r
.01 w
.62928 .74126 m
.62928 .74126 L
s
P
p
1 0 .966 r
.01 w
.62936 .74363 m
.62936 .74363 L
s
P
p
0 .921 1 r
.01 w
.27847 .44759 m
.27847 .44759 L
s
P
p
1 0 .944 r
.01 w
.62943 .74599 m
.62943 .74599 L
s
P
p
0 .899 1 r
.01 w
.27832 .44976 m
.27832 .44976 L
s
P
p
1 0 .921 r
.01 w
.62951 .74836 m
.62951 .74836 L
s
P
p
0 .876 1 r
.01 w
.27817 .45194 m
.31103 .44395 L
s
P
p
.157 0 1 r
.01 w
.50437 .59484 m
.52273 .6084 L
s
P
p
1 0 .899 r
.01 w
.62958 .75074 m
.62958 .75074 L
s
P
p
.18 0 1 r
.01 w
.52273 .61068 m
.52273 .61068 L
s
P
p
1 0 .876 r
.01 w
.62966 .75311 m
.62966 .75311 L
s
P
p
.202 0 1 r
.01 w
.52274 .61296 m
.52274 .61296 L
s
P
p
1 0 .854 r
.01 w
.62973 .75549 m
.62973 .75549 L
s
P
p
1 0 .831 r
.01 w
.62981 .75787 m
.62981 .75787 L
s
P
p
1 0 .809 r
.01 w
.62988 .76026 m
.62988 .76026 L
s
P
p
1 0 .787 r
.01 w
.62996 .76264 m
.62996 .76264 L
s
P
p
1 0 .764 r
.01 w
.63003 .76504 m
.63003 .76504 L
s
P
p
0 .854 1 r
.01 w
.3109 .44614 m
.3109 .44614 L
s
P
p
1 0 .742 r
.01 w
.63011 .76743 m
.63011 .76743 L
s
P
p
0 .831 1 r
.01 w
.31077 .44832 m
.31077 .44832 L
s
P
p
1 0 .719 r
.01 w
.63018 .76983 m
.63018 .76983 L
s
P
p
.09 0 1 r
.01 w
.48578 .57418 m
.50439 .58798 L
s
P
p
0 .809 1 r
.01 w
.31063 .45051 m
.34384 .44247 L
s
P
p
1 0 .697 r
.01 w
.63026 .77223 m
.63026 .77223 L
s
P
p
.112 0 1 r
.01 w
.50439 .59027 m
.50439 .59027 L
s
P
p
1 0 .674 r
.01 w
.63034 .77463 m
.63034 .77463 L
s
P
p
.135 0 1 r
.01 w
.50438 .59255 m
.50438 .59255 L
s
P
p
1 0 .652 r
.01 w
.63041 .77704 m
.63041 .77704 L
s
P
p
1 0 .629 r
.01 w
.63049 .77945 m
.63049 .77945 L
s
P
p
1 0 .607 r
.01 w
.63056 .78186 m
.63056 .78186 L
s
P
p
1 0 .584 r
.01 w
.63064 .78428 m
.63064 .78428 L
s
P
p
1 0 .562 r
.01 w
.63072 .7867 m
.63072 .7867 L
s
P
p
1 0 .539 r
.01 w
.63079 .78912 m
.63079 .78912 L
s
P
p
0 .787 1 r
.01 w
.34373 .44467 m
.34373 .44467 L
s
P
p
1 0 .517 r
.01 w
.63087 .79155 m
.63087 .79155 L
s
P
p
0 .764 1 r
.01 w
.34362 .44687 m
.34362 .44687 L
s
P
p
1 0 .494 r
.01 w
.63095 .79397 m
.63095 .79397 L
s
P
p
0 .742 1 r
.01 w
.3435 .44907 m
.37707 .44097 L
s
P
p
.045 0 1 r
.01 w
.52 .56203 m
.48582 .56961 L
s
P
p
1 0 .472 r
.01 w
.63102 .79641 m
.63102 .79641 L
s
P
p
.067 0 1 r
.01 w
.4858 .57189 m
.4858 .57189 L
s
P
p
1 0 .449 r
.01 w
.6311 .79884 m
.6311 .79884 L
s
P
p
1 0 .427 r
.01 w
.63118 .80128 m
.63118 .80128 L
s
P
p
0 .022 1 r
.01 w
.55439 .54753 m
.51999 .55518 L
s
P
p
1 0 .404 r
.01 w
.63125 .80372 m
.63125 .80372 L
s
P
p
0 0 1 r
.01 w
.51999 .55746 m
.51999 .55746 L
s
P
p
1 0 .382 r
.01 w
.63133 .80617 m
.63133 .80617 L
s
P
p
.022 0 1 r
.01 w
.52 .55975 m
.52 .55975 L
s
P
p
1 0 .36 r
.01 w
.63141 .80862 m
.63141 .80862 L
s
P
p
1 0 .337 r
.01 w
.63148 .81107 m
.63148 .81107 L
s
P
p
0 .09 1 r
.01 w
.58895 .53295 m
.55431 .54069 L
s
P
p
0 .719 1 r
.01 w
.37698 .44318 m
.37698 .44318 L
s
P
p
1 0 .315 r
.01 w
.63156 .81352 m
.63156 .81352 L
s
P
p
0 .067 1 r
.01 w
.55434 .54296 m
.55434 .54296 L
s
P
p
0 .697 1 r
.01 w
.37688 .44539 m
.37688 .44539 L
s
P
p
1 0 .292 r
.01 w
.63164 .81598 m
.63164 .81598 L
s
P
p
0 .045 1 r
.01 w
.55437 .54524 m
.55437 .54524 L
s
P
p
0 .674 1 r
.01 w
.37679 .44761 m
.41071 .43946 L
s
P
p
0 .18 1 r
.01 w
.57058 .50936 m
.58875 .52386 L
s
P
p
1 0 .27 r
.01 w
.63172 .81844 m
.63172 .81844 L
s
P
p
0 .157 1 r
.01 w
.5888 .52612 m
.5888 .52612 L
s
P
p
1 0 .247 r
.01 w
.63179 .82091 m
.63179 .82091 L
s
P
p
0 .135 1 r
.01 w
.58885 .5284 m
.58885 .5284 L
s
P
p
1 0 .225 r
.01 w
.63187 .82338 m
.63187 .82338 L
s
P
p
0 .112 1 r
.01 w
.5889 .53067 m
.5889 .53067 L
s
P
p
1 0 .202 r
.01 w
.63195 .82585 m
.63195 .82585 L
s
P
p
1 0 .18 r
.01 w
.63203 .82832 m
.63203 .82832 L
s
P
p
1 0 .157 r
.01 w
.63211 .8308 m
.63211 .8308 L
s
P
p
1 0 .135 r
.01 w
.63218 .83328 m
.63218 .83328 L
s
P
p
1 0 .112 r
.01 w
.63226 .83577 m
.63226 .83577 L
s
P
p
0 .652 1 r
.01 w
.41064 .44168 m
.41064 .44168 L
s
P
p
1 0 .09 r
.01 w
.63234 .83825 m
.63234 .83825 L
s
P
p
0 .629 1 r
.01 w
.41057 .4439 m
.41057 .4439 L
s
P
p
0 .247 1 r
.01 w
.55203 .48779 m
.57047 .50255 L
s
P
p
1 0 .067 r
.01 w
.63242 .84075 m
.63242 .84075 L
s
P
p
0 .607 1 r
.01 w
.4105 .44613 m
.44479 .43792 L
s
P
p
0 .225 1 r
.01 w
.5705 .50481 m
.5705 .50481 L
s
P
p
1 0 .045 r
.01 w
.6325 .84324 m
.6325 .84324 L
s
P
p
0 .202 1 r
.01 w
.57054 .50708 m
.57054 .50708 L
s
P
p
1 0 .022 r
.01 w
.63258 .84574 m
.63258 .84574 L
s
P
p
0 .584 1 r
.01 w
.44474 .44015 m
.44474 .44015 L
s
P
p
0 .315 1 r
.01 w
.53326 .46595 m
.55196 .48098 L
s
P
p
0 .562 1 r
.01 w
.44469 .44239 m
.44469 .44239 L
s
P
p
0 .539 1 r
.01 w
.44465 .44463 m
.4793 .43636 L
s
P
p
0 .292 1 r
.01 w
.55198 .48324 m
.55198 .48324 L
s
P
p
0 .27 1 r
.01 w
.55201 .48551 m
.55201 .48551 L
s
P
p
0 .517 1 r
.01 w
.47928 .43861 m
.47928 .43861 L
s
P
p
0 .382 1 r
.01 w
.51426 .44385 m
.53323 .45914 L
s
P
p
0 .494 1 r
.01 w
.47925 .44086 m
.47925 .44086 L
s
P
p
0 .36 1 r
.01 w
.53324 .46141 m
.53324 .46141 L
s
P
p
0 .472 1 r
.01 w
.47923 .44311 m
.51426 .43478 L
s
P
p
0 .337 1 r
.01 w
.53325 .46368 m
.53325 .46368 L
s
P
p
0 .449 1 r
.01 w
.51426 .43704 m
.51426 .43704 L
s
P
p
0 .427 1 r
.01 w
.51426 .43931 m
.51426 .43931 L
s
P
p
0 .404 1 r
.01 w
.51426 .44158 m
.51426 .44158 L
s
P
p
.002 w
.64285 .02407 m
.89575 .28806 L
s
.89575 .28806 m
.96635 .87651 L
s
.96635 .87651 m
.67029 .64846 L
s
.67029 .64846 m
.64285 .02407 L
s
.11312 .175 m
.03365 .7802 L
s
.03365 .7802 m
.67029 .64846 L
s
.67029 .64846 m
.64285 .02407 L
s
.64285 .02407 m
.11312 .175 L
s
P
p
p
.002 w
.11312 .175 m
.64285 .02407 L
s
P
p
.002 w
.23142 .14129 m
.23689 .14586 L
s
P
[(5)] .22047 .13215 .85653 1 Mshowa
p
.002 w
.3846 .09765 m
.38982 .10237 L
s
P
[(10)] .37417 .08821 .79059 1 Mshowa
p
.002 w
.54404 .05222 m
.54897 .05709 L
s
P
[(15)] .53416 .04248 .72465 1 Mshowa
p
.001 w
.26157 .1327 m
.26483 .13546 L
s
P
p
.001 w
.29197 .12404 m
.29519 .12682 L
s
P
p
.001 w
.3226 .11531 m
.3258 .11811 L
s
P
p
.001 w
.35348 .10651 m
.35664 .10933 L
s
P
p
.001 w
.41598 .08871 m
.41908 .09156 L
s
P
p
.001 w
.44761 .0797 m
.45067 .08256 L
s
P
p
.001 w
.47949 .07061 m
.48252 .0735 L
s
P
p
.001 w
.51163 .06145 m
.51463 .06436 L
s
P
p
.001 w
.2015 .14982 m
.20481 .15254 L
s
P
p
.001 w
.17181 .15827 m
.17515 .16098 L
s
P
p
.001 w
.14235 .16667 m
.14572 .16936 L
s
P
p
.001 w
.57671 .04291 m
.57963 .04586 L
s
P
p
.001 w
.60964 .03353 m
.61253 .03649 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30608 .04563 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`000?l0
6`0009400ol300?oP000098000?o00001@000ol0001m0000B@03o`<00_l300?o0P03o`8000?o0000
<@000ol000050003o`0001T00omQ0000B0001ol0003o0?l00P000ol0o`020006o`00o`3o0P000ol0
000a0003o`0000800olI00?o0P000ol0001O0000C0000ol0o`020003o`3o008000Ko003o0?l20003
o`00034000?o00000P000ol0000E00Co1@02of00001900?o0P001_l00?l0o`8000Ko003o0?l20003
o`0003000_l400Co4@05o`D00ol00`3o001N0000B0000ol0000400;o0P001Ol00?l000KoBP04o`L0
1?l01H7o003o05h000180005o`000?l030000ol0o`1800Co1`06o`>10_l00`3oo`1M0000B@03o`l0
00?o0000@`03o`<000?o00000P05o`B100?oPH400ol20003o`0005X0002M00Co1`05o`V10ol2P@04
o`00oe/0002J00Go1P04o`>100?oPH401Ol01L^kbh7o00>10_l00`3o001I0000UP04o`D000?o0?l0
0ol8P@;o2K/00on1P@03P@04o`3ooeP0001V00?o1002ob@00ol800Go1X43o`0=bk_;^l^kbk_;^l^k
o`04P@?o00<0o`00E`0006L000?o00000P001?l00?lO00Co0P000ol0000200Ko0h400on1P@03o`nk
00?o^ol00_l2P@04o`00oeL0001W0003o`00008000Co003o7003o`P01?l9P@;o01G;^l^kbk_;^l^k
bk_;^l^kbk_o^l/01H401?l00?mF0000I`000ol000020004o`00oaP01?l00`3o000400Co0h400on1
P@05oaNk00?o^k/01H401?l00?l:00?oB00006L000?o00000P001?l00?lE00?o2004o`N10_l08;_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;1H401?l0ool<0003o`0004D0001V00;o1@02oa80
1?l700Ko1H43oank00?o^k/00[/3P@?o0P000ol000090003o`0004D0001m00Co0`000ol0000200Go
18400on1o`02o`0V^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l/4o`>100Co003o
1`03odP0001j00?o2005o`V100?o^k/08[/5o`:100?oPH400h401?l00?l60003o`0004P0001f00Co
0P000ol0000200Go0h400on1P@05o`0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0ol00h7oP@05P@03oh6100>100CoPH7o1@04odL0001c00?o2003o`V10_lV^`?o00F1oh61o`07P@03
oh6100:10_l20003o`0004d0001_00Go1`03o`03POn100F10ol09[_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0ol5P@03oh7o00R100CoPOoo0X401?l00?m>0000K003o`D000?o0000
1Ol4P@03oh6100?o4;/2oa>k1?l9P@;o1h400on1o`05P@04o`00odd0001200?o8`04o`P01Ol8P@;o
012kbk_;^l^kbk_;^l^kbk_;0ol2F`0>ok_;^l^kbk_;^l^kbk/5o`B100?oPH401h400on1P@05o`03
^l^k00J100Co003oC00004D000?o00007@03o`<000?o00000P05o`>100?oPH401?l4P@03ok^k00Zk
0ol6F`03ok^k00Rk0_l:P@03oh6100J10ol9^`J11?m;0000A@000ol0000I00Co1`04o`V10_l9P@0<
ok_;^l^kbk_;^l_o2U/03?nkbk_;^l^kbk_;o`^100?oPH401?l03/_obk_;^l^kbk_;^l^k1843o`80
00?o0000B00004800olH00Co0P000ol0000300?o18400on1P@04o`Bk00?oPH401h400onk^`08^`03
oe]K00QK00?o^k/02;/00on1P@09P@;o1K/00onk^`0;^`?o0h400ol0o`1:0000@P000ol0000E00?o
2@03o`R10_l02[_;^l^kbk_;^ol9P@0<ok_;^l^kbk_;^l_o2U/03?nkbk_;^l^kbk_;o`J10ol0687o
^l^kbk_;ol^kbk_;^l^kbk_;^l^kb`F100?o0?l0B@0004801?l@00Go2004o`J10ol=^`03oh6100Co
3[/00omKF`05o`=K00?o^k/02;/00on1P@03o`F100?o^k/00k/00onk^`0>^`F11?m70000D`03o`@0
00?o00000P05o`>100?oPH400ol04;_;^l^kbk_;^l^kbk_;^l/3o`0Cbk_;^l^kbk_;^l^kbk_;^l^k
b`02o`UK00_o^l^kbk_;^l^kb`02o`V101Oo^l^kboo;^l^kbk_;^l^kbk_;^l^kb`03P@?o00<0o`00
8P05o`050?ooo`000ol300;o4P0004l01?l800Go2842oa2k0ol2F`03ok^k01>k00?oFe/01e/00onk
^`08^`03oh6100R100Go^k^ko`0B^`;o0h400ol0o`0R0003o`00008000Co003o10001?l00?lC0000
C003o`<000?o00000P04o`B100?oPH401?l04L^kbk_;^l^kbk_;^l^kbk_;00?o1U/02_nkbk_;^l^k
bk/2o`0;bk_;^l^kbk_;^ol02E/2o`0:bk_;^l^kbk_;o`Z101Ko^l_obk_;^l^kbk_;^l^kbk_;^l^k
1X400ol0o`0Q0003o`0000<00ol200;o0`000ol0000A0000B004o`L01?l9P@;o4K/4o`YK00?o^k/0
0k/3o`:100?o^k/02;/00omKF`04o`AK00?o^k/01k/00on1P@05o`>100?o^ol04k/6P@04o`3ooal0
1Ol30003o`3o00D000?o00004@0004D00ol20003oh4000<00ol4P@03oh6100Co017;^l^kbk_;^l^k
bk_;^l^kb`04o`AK00?oFe/025/00onko`02o`J100_obk_;^l^kbk_;^`02o`UK00[obk_;^l^kbk_;
0_l9P@;o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`F11?lO0003o`0000<00_l300?o00@0oooo4P000440
1?l60003oh4000;o2842oa>k0_l9F`03oe]K00QK00?oPH4028400onk^`07^`03oe]K00UK00?o^k/0
2;/00on1P@07P@03ok^k01>k0X42o`05POl00?l07P000ol0000=0003o`000140000n00Go1`05o`F1
0ol06K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02E/00omKF`05o`04^l^ko`Z100_obk_;^l^kbk_;
o`0;F`0<ol^kbk_;^l^kbk_o2843o`0Ebk_;^l^kbk_;^l^kbk_;^l^kbk_o00B100Co003o7@05oal0
000j00Co2@04o`B100?oPOl00_l@^`;o2[/00omKF`07F`;o2K/00on1P@08P@03ok^k00Nk00?oFe/0
15/3o`fk00?oPH401?l01H7oPH7o01Bk1H400ol00002o`P00ol400;o;P0003H01?l900Co2H404Onk
bk_;^l^kbk_;^l^kbk_;00?o0U/03?nkbk_;^l^kbk_;o`9K1?l03l^kbk_;^l^kbk_;^l^ko`02P@Go
0h402oo;^l^kbk_;^l_o009K0ol04K_;^l^kbk_;^l^kbk_;^l^k00;o1H406On1PH7obk_;^l^kbk_;
^l^kbk_;^l^kbk/01H401?l0ool90003o`00008000Co003o;@0003<00ol40003o`0000801?l4P@03
oh6100Co4;/3o`IK00?o^k/02;/2oa6k1?l9P@03ok^k00Nk0_lE^`03oh6100B100GoPH61o`0D^`>1
0ol20003o`0000H000?o00000P001?l00?l]0000;`04o`P01?l9P@;o017;^l^kbk_;^l^kbk_;^l^k
b`03o`YK01Wo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co18400on1P@07P@0Rol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`F100?oPH400X405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`>1
00Co003o1`000ol000020004o`00obd0000/00?o0`000ol0000200Co18400on1P@04oa6k1?l4F`03
oe]K00MK00?o^k/04K/4o`V100?oPH401h400onk^`0N^`03oh6100Go0h400onk^`0B^`F100Co003o
1P000ol000020004o`00obd0000Z00;o1`04o`V10_l04l^kbk_;^l^kbk_;^l^kbk_;^l/00_l9F`03
oe]K00MK00oo^l^kbk_;^l^kbk_;^l/01?l4P@03oh6100N100?oPH401?l09<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o0X400on1P@04P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00F1
00CoPH7o1002o`D00_l^0000:P000ol0o`0300?o18400on1P@04oaVk00?oFe/01e/00omKF`04o`jk
0ol9P@03oh6100N10_lA^`?o5K/01?n1POl7P@03ok^k01:k0h43o`8000?o0000>00002X000?o0000
0ol8P@;o01o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00UK0_l03l^kbk_;^l^kbk_;^l^k
b`03o`03POn100Z100?oPH401?l04L^kbk_;^l^kbk_;^l^kbk_;00Co0e/06Onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_oPOl028405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`>100Co003o>@0002X01Ol5P@?o
8[/00omKF`04oa2k0ol5P@03oh6100V10_lC^`;o25/00onk^`0C^`;o00>1ool00ol3P@03ok^k01:k
1H401?l00?lh0000:@02o`B100?oPOl00_l09/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l04L^kbk_;^l^kbk_;^l^kbk_;00?o2H400on1P@04P@?o01Rkbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^ol9F`0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00?o2H405Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^`05P@Co=`0002400_l60003o`3o00B10_lf^`Go0h400on1P@07P@03oh6100?o6k/00omKF`07F`03
ok^k00jk0ol00h7oP@0:P@03ok^k01:k0h43o`8000?o0000=000020000Co003o1@000ol00002o`B1
03Co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l9P@03
oh6100N10_l08;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o0U/4o`0@^l^kbk_;^l^kbk_;
^l^kb`?o1842o`^101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/00_l3P@04o`00ocD0000P0004o`00o`D0
00Go0000o`05P@03ok^k03:k00?oPH401h400on1P@04o`B100?o^k/07K/2oa6k0ol7P@03oh7o00J1
0olG^`F100Co003o=000020000Co003o1@000ol000020003oh6100>102So^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l02/^kbk_;^l^kbol9P@;o2H40;_nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`>100?oPH4018401?n1POl2P@?o01^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01H44oc<0000P0004o`00o`D000?o000010000on1P@02P@;o
8K/4o`AK00?o^k/01k/00on1P@04o`B100?oPH401h400onk^`0A^`?o4[/4o`R100?oPH400h401?n1
PH42oank0h43o`030?l00380000Q00;o1P000ol0000500;o18407oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l9F`0:ol^kbk_;^l^kb`;o2H400on1P@07P@0?ok_;^l^kbk_;^l^kbk_;00Co
0e/03Onkbk_;^l^kbk_;^l/01Ol3P@03oh6100N100?oPH401?l08/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/4o`>100?o0?l0<P0002T000?o00001P02o`B100?o^k/07K/00omKF`07F`03
ok^k00Rk00?oPH401h400on1P@04o`nk0_l8F`03ok^k00Nk0_l9P@03oh6100N10_l2^`03ok^k01bk
1Ol3F`03oh6100:100?o0?l0<@0002P000?o00002@000on1P@02P@0Qol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00UK0_l02[_;^l^kbk_;^ol9P@;o01G;^l^kbk_;^l^kbk_;^l^kbk_;^ol0
2E/03?nkbk_;^l^kbk_;o`V100?oPH401?l08L^kbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`04o`UK00?oPH400X43oc00000X00;o2`000on1P@02P@;o7[/00omKF`04o`AK00?o^k/01k/00on1
P@04oaVk00?oFe/01e/00onk^`08^`03oh6100N10_l:^`03ok^k01Bk1?l3F`03oe]K00QK00?oPH40
0ol00`3o000^0000:0000ol0000;00;o18407onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0_l9F`0:ok_;^l^kbk_;^`;o017;^l^kbk_;^l^kbk_;^l^kb`03o`0;bk_;^l^kbk_;^ol00U/4o`0?
^l^kbk_;^l^kbk_;^l_o00:11?l3P@0Ool^kbk_;^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^`03o`QK
00?oFe/025/2o`>100?o0?l0;P0002P000?o00003@000on1P@02P@03ok^k01fk00?oFe/01e/00onk
^`0E^`Co0h400onk^`08^`;o4k/2o`R100?o^k/01k/00onk^`0>^`?o0U/00omKF`07F`03oe]K00Go
0U/00on1P@03P@03o`3o00T00ol300?o6`0002P000?o00003P000on1P@02P@0Qok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00UK01?o^l^kbk_;^l^kbk_;^l^kbk_;00Co28408Oo;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`09P@0Gol^kbk_;^l^kok_;^l^kbk_;^l^kbk/00ol6F`03
oe]K00MK0_l8F`03oh6100>10ol90003o`0000D000?o0000600002P000?o00003`000on1P@02P@;o
7[/00omKF`04oa6k1?l3P@03oh6100N100?o^k/07K/00on1P@07P@03ok^k00Fk00?o^k/02;/3o`YK
00?oFe/01?l3^`03oe]K00MK00CoPH610ol00`3o00070003o`0000D000?o0000600002P000?o0000
4002o`B101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o01?;^l^kbk_;^l^kbk_;^l^k
bk_;00;o28400on1P@07P@;o01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:11?l3P@0=
ol^kbk_;^onkbk_;^`05o`AK00?oFe/01e/2o`09^l^kbk_;^l_o00UK0ol3P@03o`3o00L000?o0000
0P03oa/0000X0003o`00018000?oPH400X400onk^`0a^`03oh6100N100?oPH401?l4P@03ok^k01Zk
1?l8P@03ok^k00>k00?o^ol00ol:F`03oe]K00Co3K/00omKF`04o`=K00?oPH400h400ol0o`060003
o`00008000?o00006`0002L000?o000050000on1P@02P@0eol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02H42o`V101So^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/4o`=K00?oPH401h400oo;^`04o`=K00?oFe/02E/2o`0@^l^kbk_;^l^kbk_;^l^kb`Co25/00on1
P@02P@04oh61o`@00_l400Co6P0002L000?o000050000h7oP@03P@;o<[/00on1P@04o`B10_l8P@03
ok^k01:k0_l8F`03oh6100N10_l3F`03oe]K009K00?oFe/015/3o`nk1?l3F`03oe]K00MK00?oPH40
0ol20003o`0002D0000W0003o`0001<000>100000_l4P@;o037;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X400on1P@03o`0I^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;o`09F`03oh6100Co0h401OmKFe_o00EK00?oFe/00ol03[_;^l^kbk_;^l^kbk_;1?l8F`03
oe]K00MK0_l3P@04o`00obH0000W0003o`0001<000>100000P000on1P@03P@03ok^k032k00?oPH40
2842oabk00?oFe/01e/2o`R100CoFe_o1U/2o`fk1?l3F`03oe]K00MK00?oFe/01?l3^`F100?o0000
0_lT00009`02oa@000>100000`000on1P@03P@;o02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/4o`0:^l^kbk_;^l^ko`F10ol2P@0Ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
o`02F`Co00C;^l_o2H400omKo`04o`AK00_o^l^kbk_;^l^kb`02o`QK00?oFe/01e/2o`08^l^kbk_;
^l/5P@;o00<0o`008`0002L000?o00004`000h40000400?o18400onk^`0M^`Co15/00onk^`07^`03
oh7o00;o1X400onk^`0K^`;o2;/00on1P@07P@;o2E/00onk^`08^`03oe]K00MK00?oFe/01?l=^`>1
0ol20003o`000240000W0003o`0001<000>100001P000on1P@03P@0Mok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l9F`0;ok_;^l^kbk_;^ol02X40:Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00:11?l00l^kb`02o`UK00co^l^kbk_;^l^kbol9F`;o01:kbk_;^l^kbk_;
^l^kbk_;^l/2o`>100Co003o8P0002H000?o000050000h4000070003oh6100>100?o^k/06k/00omK
F`07F`03ok^k00Rk00?oPH401h400onk^`0U^`;o1k/00onko`02F`Co0e/00onk^`08^`03oe]K00Co
0U/00onk^`0C^`B11?lQ00009P000ol0000D0003P@0000P00_l4P@0Ook_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`09F`;o00[;^l^kbk_;^l_o0X44o`>103?obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk/00_l8F`0;ok_;^l^kbk_;^l/00_l7F`0Fok_;^l^k
bk_;^l^kbk_;^l^kbk_;^`>100GoPOl0o`0P00009P000ol0000D0003P@0000X00_l3P@03ok^k01^k
00?oFe/01?l4F`03ok^k00Nk0_l8P@03ok^k02bk00Go^k^ko`09F`03ok^k00Nk00?oFe/01e/00onk
^`0C^`;o0h400ol0o`0O00009P000ol0000D0003P@0000/000?oPH400X407_nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`;o2E/02oo;^l^kbk_;^l_o00V103Cobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_o2E/02onkbk_;^l^kbk_o00UK0_l04l^kbk_;^l^k
bk_;^l^kbk_;^l/01X400ol0o`0N00009P000ol0000C0003P@0000d000?oPH400X400onk^`0L^`;o
25/00onk^`07^`03oh6100N10_l[^`03ok^k00>k00?oFe/01?l3F`03ok^k00Nk00?oFe/01?l4F`03
ok^k016k1H44oad0000V0003o`0001<000>100003P02o`>10_l07l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol00U/3o`0>bk_;^l^kbk_;^l^kbol2P@Co1840<?nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^`Co25/02_nkbk_;^l^kbk/2o`UK01Cobk_;^l^kbk_;
^l^kbk_;^l^kb`>10ol00`3o000L00009P000ol0000C0003P@0001000_l3P@03ok^k01Zk1?lA^`;o
2H400onk^`0W^`Go0e/00omKF`07F`03ok^k00Rk00?oFe/01e/00onk^`0A^`;o0k/2oad0000U00;o
5@000h40000A0003oh6100:101Sobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`=K01Go^l^kbk_;^l^k
bk_;^l^kbk_;^ol02H409_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l8F`03
oe]K00MK00co^l^kbk_;^l^kbol2F`Co0e/03Oo;^l^kbk_;^l^kbk/01?l5P@04^l^koad0000U0003
o`0001@000>100004P000on1P@02P@03ok^k012k1?l8F`03ok^k016k00?oPH401h42oank1?l3F`03
oe]K00MK00?oFe/01?l<^`Co25/4W`Bk1?l6P@Co0P000ol0000K00009@000ol0000D0003P@0001<0
00?oPH400X42o`0<^l^kbk_;^l^kbk_;1?l3F`03oe]K00MK01Go^l^kbk_;^l^kbk_;^l^kbk_;^ol0
0X44o`B101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l7F`;o2E/2o`0<bk_;^l^kbk_;^l^k
0a401?mKFe/34@ZO1?l9P@03o`0000D000?o00006P0002D000?o000050000h40000D00;o1842o`Rk
0_l8F`03oe]K00MK00?o^k/04K/2o`V100?o^k/05;/3o`=K00?oFe/01E/00omKo`02F`Co3;/4o`08
5a4A4IlAWa49W`03FioO00J11?l;0003o`0001X0000U0003o`0001@000>100005P000on1P@03P@0;
ol^kbk_;^l^kbol025/00omKF`04o`0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`09P@0Dol^kbk_;
^l^kbk_;^l^kbk_;^l/2o`MK00?oFe/015/00omKF`02o`0<bk_;^l^kbk_;^l^k1?l3F`03oe/A00HA
00AKWinO1?l2P@03Wa6O00B100?o00003@000ol0000J00009@000ol0000D0003P@0001L000>1oh40
0h400onk^`07^`03oe]K00IK0_lM^`03oh6100Co0h400onk^`0A^`03oe]K00IK00?oFe/01?l<^`Co
25/01OlAWa4G008A0e/2o`J100CogioO4`000ol0000J00009@000ol0000D0003P@0001L000B10?oo
0h402oo;^l^kbk_;^l_o009K0ol08[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`R1
00Sobk_;^l^kb`?o00[;^l^kbk_;^l_o25/2o`0<bk_;ol^kbk_;^l^k1?l3F`03oe]K00MK00?oFa40
0Q4011LA5aL7P@03o`0000>O4P000ol0000J00009@000ol0000C0003P@0001P000B1003o18400onk
^`07^`;o9[/00on1P@07P@03ok^k00Co0e/00onk^`07^`03oe]K00?o1k/00onk^`02^`Co25/00omK
F`07F`;o0QL00a4G4@025`?o00<0P@001003ga4000?o00006P0002@000?o000050000h40000H0005
P@000?l01840<oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
o`09P@;o25/02_o;^l^kbk_;^l/2o`0:^l^kbk_;^l^kb`Go0e/00omKF`07F`03oe]K00Co1h400a4G
4@025`<000>100001002Wa4000?o00006P0002@000?o000050000h40000G0003P@0000<000?oPH40
0X42oc2k00?oPH401?l3F`03oe]K00MK00?o^k/04K/2o`QK00?oFe/01e/2o`J11?l200044ALGG`8G
0P000h40000300;O4@000ol0000J000090000ol0000D0003P@0001L000>100001002o`B10_l0;L^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`QK00?oFe/01e/05Oo;
^l^kbk_;^l^kbk_;^l^kbk_;o`09F`03oe]K00Co00>1Gel00Ul02An1PH4OGamO7`05G`<G0P000h40
00030003gioO014000?o00006@0002@00_lE0003P@0001L000>100001P000on1P@03P@03ok^k02Nk
0ol4F`03oe]K00IK00?oFe/01?lG^`06oamO7elO0e/3G`035alO00DO0Ul01AmO7elO00QO00<05el0
0P000h40000400>O40000ol0000I000090000ol0000D0003P@0001L000>100001`000on1P@03P@0A
ol^kbk_;^l^kbk_;^l^kbk/00ol04k_;^l^kbk_;^l^kbk_;^l^kbk/00_l8F`03oe]K009K0_l2F`;o
01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^amO7eooGamO00LO1el0200OGamO7elO0P03G`T000>10000
1@000mnOg`0?0003o`0001T0000T0003o`0001@000>100005`000h40000900;o0h400onk^`0:^`?o
0e/00onk^`0B^`03oe]K00IK1?l6P@03ok^k01>k00POGamO7olOo`MO00Co7alO1@000elOG`0B0003
P@0000H000>Ogil03P000ol0000I000090000ol0000D0003P@0001L000>100002P000on1P@02P@0:
ol^kbk_;^l^kb`;o1e/02?nkbk_;^l^k1?l02/^kbk_;^l^kbol2F`?o00Fkbk_;o`08P@0Hok_;^l^k
bk_;^l^kbk_;^l^kbk_;GamO0ol2P@<O0h400ol0000L0003P@0000L000?OW`003@000ol0000I0000
8`000ol0000E0003P@0001L000>100002`000on1P@02P@03ok^k00Rk00?oFe/01E/00onk^`04o`AK
00?o^k/01k/2o`Rk00?oPH401X42oa2k1?l3P@03oh7o00?o8P000h4000070003gil000d000?o0000
6@0002<000?o000050000h40000H0003P@0000`000?oPH400X42o`0:^l^kbk_;^l^ko`AK00?oFe/0
0_l9F`0Eol^kbk_;^l^kbk_;^l^kbk_;^l_o00:10ol4P@0<ol^kbk_;^l^kbk_;1?l2P@Co00>1ool0
9P000h40000700?O3@000ol0000I00008`000ol0000D0003P@0001P000>100003@02o`B10_l8^`Co
1E/2o`QK00?o^k/04K/2o`R100?o^k/00[/6o`F10_l40003o`0002D000>1000020000ioOW`0<0003
o`0001T0000S0003o`0001@000>1000060000h40000?0003oh6100>100[obk_;^l^kbk_o2E/00omK
F`03o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`08P@Co1845o`P000?o00009@000h40000900CO
2P000ol0000I00008`000ol0000D0003P@0001P000>1000040000on1P@03P@03ok^k00Jk00?oFe/0
1e/2oabk00?oPH400ol9P@;o30000ol0000U0003P@0000X000>Ogml02`000ol0000H00008`000ol0
000D0003P@0001P000>100004P02o`>100[obk_;^l^kbk_o0U/4o`0O^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`04o`F11Ol@0003o`0002H000>100002003g`03W`0000T000?o0000600002<0
0_lE0003P@0001P000>100004`000on1P@02P@03ok^k00Jk0_lO^`Co2842oa@000?o00009P000h40
000300WO2`000ol0000H00008P000h7o000E0003P@0001L000>100005@000on1P@02P@0Uol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`J11?lH0003o`0002H000F10000gP07g`h0
00?o0000600001<00ol400;o1P000ol0P@0E0003P@0001L000>100005@000h7oP@03P@;o7k/3o`V1
00?o00006P000ol0000V0004P@3OgP?O4`000ol0000H000050000ol000020004o`00o`D000?o0000
0X4C0003P@0001L000>100005@001840ool4P@0Kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co
1H44ob0000?oP@009008ga@000?o0000600001@000?o00000P001?l00?l50003o`00008000>10000
40000h40000G0003P@0001D000F10000o`04P@03ok^k01>k1?l8P@03o`00028000?oP@008P001moN
gmkOg]l05`000ol0000H000050000ol000020004o`00o`D000?o00000`000h40000>0003P@0001P0
00>100005@000h4000020003oh6100:10_l03l^kbk_;^l^kbk_;^l^kb`04o`J11?l00`21000T0003
oh4002800ml00`21000H0003o`0001P0000D0003o`00008000Co003o1@000ol0000400:13P000h40
000H0003P@0001D000>100000`02o`B100?o^k/02K/3o`:11?l3P@03o`0000<000>100008`000on1
000P0004g]oNg`8000>1000060000ol0000G00004`02o`D00_l60003o`0000H000>100002`000h40
000H0003P@0001D000>100001@000on1P@02P@05ol^kbk/01_l4P@?o2`000h40000S0003oh4001`0
00SNgmkOg]oNg`8000>1000060000ol0000G00008P000ol0000700:12`000h40000H0003P@0001D0
00>100001P000on1P@02P@Co1845o`l000>100008`000on1000J00?N00COg]oN1@000h40000H0003
o`0001L0000Q0003o`0000X000>1000020000h40000H0003P@0001D000>100002002o`03^l^100F1
0_lC0003P@0002<000?oP@006003gP03gmh000T000>100005`000ol0000G00008@000ol0000;0003
P@0000L000>1000060000h40000D0003P@0000X000?o^k/01?lG0003P@0002<000?oP@005008g`/0
00>100005`000ol0000G00008@000ol0000<00:11`000h40000H0003P@0001@000>100002`02oa/0
00>100008`000on1000B00ON3P000h40000G0003o`0001L0000Q00;o3`000h4000040003P@0001P0
00>1000050000h40000;0003o`0001X000>100008`000on1000B0003gmkO018000>100005`000ol0
000G00008@000ol0000?00:110000h40000H0003P@0001@000>100002`000ol0000J0003P@0002<0
00?oP@003P06gQ<000>100005`000ol0000G00008@000ol0000A0004P@00PAX000>100005@000h40
000;0003o`0001X000>1000090000ol00009000:gmkOg]oNgmkOgQ<000>1000060000ol0000F0000
8@000ol0000B00>16P000h40000E0003P@0000/000?o00005P001LK0a/2102H000?o00002@000moN
gP02gQP000>1000060000ol0000F000080000ol0000E0003P@0001P000>100005@000h40000900?<
1P001<c0`<05000:a/36a/36`<K0aP;000?6P@009@000ol0000700CN6`000h40000H0003o`0001H0
000P0003o`0001D00X4I0003P@0000l01<`20005P@30c<000/`200G<00?0c<001l000lK0`006`008
a/36`<K0aP02aP03P@0002@000?o00000`08gQ/000>1000060000ol0000F000080000ol0000E0004
P@21PA0000>e3@d0100010g<3L`500043Lc<c0P=00S<3L`=c0g<3@W<01G0c<3<`<c0c030a/36`<K0
aP30a/001P03aRH000Co00001mhN0003P@0001P000?o00005P00020000?o00005@001H40002100l0
00<=c0d020d01/`=c0g<3@[<00S0c<3<`<c000K<0`04`0H00l0?00C69@000ol0gP04gR8000>10000
60000ol0000F000080000ol0000E0003P@0000800X4=000Bc0g<3L`=c0fec0g<3L`=c0d00`d50003
c0g<008000B100000l`70003o`0001X000?6S<H08P001G7Nomia00;N00=a00008P000h40000G0003
o`0001H0000P0003o`0001D000>1000010000h40000:00L=00Fe3L`=c00C0003P@0000/000?o0000
6P001876a/HO00CN00?og]h09`000h40000G0003o`0001H0000P0003o`0001D000>100001@000h40
000>00033KD=00Be00<=]@0040000h40000;0003o`0001X000>10<H00X`00lH0000K00;N00=a0?l0
:@000h40000G0003o`0001H0000P00;o5P000h40000600:13`023@070;D=]@ff]@0@0003P@0000/0
00?o00006P0018400<H2S1/000CNLMma0P000ol0000W0003P@0001P000?o00005@0001l000?o0000
5@000h4000090003P@0000d000>100001;D01Pfe3KGl]@/000>100002P000ol0000K0003P@0000><
5`08gP8000?o00009`000h40000H0003o`0001D0000O0003o`0001D000>100002P02P@d000N10000
]@d000Fe00?l]@002@000h40000:0003o`0001/000N1001<S4b<00<000?MLID03P001miagW7NLMh0
1@000on1000W0003P@0001P000?o00005@0000800olJ0003o`0001D000>1000030000h40000:0003
P@0000H000H=]@feo;D3]PH000>100002P000ol0000K0003P@0000800h`3g@04LMfEL@X000Eag]ia
gP090003oh4002L000>1000060000ol0000E00000P001?l00?lI0003o`0001D000>100003@02P@T0
00>100002002]@070;Gl]KJe]P050003P@0000X000?o00006`002h40002EgHa<S=fE00;M00EagG7M
L@030008gW7NLMiagW4:0003oh4002L000>1000060000ol0000E00000P000ol0000J0003o`0001D0
00>100003`000h4000060003P@0000`000>eo;D01[H00`21000;0003o`0001/000F10=fEL@02g@><
00Q<0000LIEag@9a00KNLMiagW4=0003oh4002L000>1000060000ol0000E00000P000ol0000J0003
o`0001D000>1000040000h4000050003P@0000d000Zeo02f]KKl]_b130000ol0000K00>E00=aU@00
0P000ha<S0040003LMea00=a00?N00003`000on1000W0003P@0001P000?o00005@0000030?oo00;o
6P000ol0000E0003P@0001400X450003P@0001401[H00kNf]`090003o`0001L02ID300:<0T`60003
LMea018000?oP@00:0000h40000E00:100?o00005@00008000?o00006@000ol0000F0003P@0001<0
00>100000P000h40000B0006][D0o;Kl0[H00kL000060003o`0001D01iD900><1P02LA8000?oP@00
:0000h40000@00F10`000ol0000D00000P000ol0000I0003o`0001H000>100005002P@8000>10000
5@001h6f][Jg][L00kH40003o`0001D000>Eg9D00`000h4000080003C8a<01T000?oP@00:0000h40
000<00B120000ol0000D00007P000ol0000E0003P@0001L000>108405`002840o;H0]kJg0[H01KL0
003o01D000>Eg9D00YD30003P@0000T00h`H0003oh4002P000>100001`05P@`000?o0000500001h0
00?o00005@000h40000H00:15`000h4000030003]kJg00>f0P000ol0000?0008UMbEg9GLUM`40003
P@0000X00d`G0003oh4002P000>100000`04PA4000?o0000500001h00_lF0003P@0001T00X4B0006
k=c/08401;L02@2g]P2g][Nfo`0?0007UMcLg9GLU@070003P@0000X00h`G0003oh4002P01X4E0003
o`0001@0000N0003o`0001D000>100006@000h40P@0A000>k;Ngk;O/]nbf]kJg][L4]P03o`0000/0
00?LUID00YD;0003P@0000X000B<aXc65P000on1000U00B16P000ol0000D00007P000ol0000E0003
P@0001T000>100000X4?00Ng00`0]kJg][Nf]`2g]_l90008g9GLUMbEg9D<0003P@0000`000><C8`0
5@000on1000P00F10`000h40000H0003o`0001@0000N0003o`0001D000>100006@000h4000020003
P@0000`000Jgk;O/g>`2g004][Nfk0H000?o00001@02g0:E00?LUM`03`000h40000=0003aXc601D0
00?o00006`04P@P000>1000060000ol0000D00007@000ol0000F0003P@0001T000>100000`02PA00
0n`00mc/g002k003g00000<000?o00001@000mbEg00C0003P@0000h000><C8`050000ol0000F00F1
30000h40000I0003o`0001<0000M0003o`0001H000>1000060000h4000060003P@0000d000J10000
k=`4k005g>c/0?l01006g1<000>100003`03S1<000?o00004P04PA4000>100006@000ol0000C0000
7@000ol0000F0003P@0001P000>100001`000h40000<0003P@00008000GLk03Lk003g003]ooL00SL
50000h40000?0003C8a<01<000?o00003@05PAH000>1000060000ol0000C00007@000ol0000E0003
P@0001T000>100002002P@`000>100001P04k003g>cL00CL60000h40000=0005S4b<S4`04`000ol0
000900B16`000h40000H0003o`0001<0000M0003o`0001D000>100006@000h40000:0003P@0000T0
00>100001`001mc/0;OL]m`06`000h4000080009aTc6C<I<aTc601@000?o00001005PAl000>10000
60000ol0000C00007@000ol0000E0003P@0001T000>100002`02P@T000>100002`000ncLk00K0003
P@0000H000Q<S4b<C8a<S1L000?o0000184T0003P@0001P000?o00004`0001d000?o00005@000h40
000I0003P@0000d000>100001P000h40000;0003o`0001/000>100001P000ha<aP0J00:100?oPH40
:0000h40000H0003o`0001<0000L0003o`0001H000>100006@000h40000>0003P@0000D000>10000
2`000ol0000K0003P@0000@014`G00B10P000ol0000X0003P@0001P000?o00004`0001`000?o0000
5P000h40000I0003P@0000l00X450003P@0000/000?o00006`000h40C008C1<018460003o`0002P0
00>1000060000ol0000C00007002oaL000>100006@000h40000A0003P@00008000>100002`000ol0
000K00;B1T`A00F12P000on1000X0003P@0001T000?o00004P0001`000?o00005P000h40000I0003
P@0001800X420003P@0000/000?o00006@000da=C002C180184?0003oh4002P000>100006@000ol0
000B000070000ol0000F0003P@0001T000>1000050000h40P@0=0003o`0001@02D`>00F14`000on1
000X0003P@0001T000?o00004P0001`000?o00005P000h40000I0003P@0001D00X4=0003o`000180
00Y=C4e<CDa=C0212`04PAP000?oP@00:@000h40000H0003o`000180000L0003o`0001D000>10000
6P000h40000F00:130000ol0000B0003C4e<00H000>100001005PA`000?oP@00:@000h40000H0003
o`000180000K0003o`0001H000>100006@000h40000G0003P@2100/000?o00004P000de<C@060003
P@0000B18@000on1000Y0003P@0001P000?o00004P0001/000?o00005P000h40000I0003P@0001H0
00B100000X490003o`00018000E<CDa=C00200F19@000on1000Y0003P@0001P000?o00004P0001/0
00?o00005P000h40000I0003P@0001H000>100000`000h4000050003o`0001D000E=C4e<P@020003
P@0002D000?oP@00:@000h40000H0003o`000180000K0003o`0001H000>100006@000h40000F0003
P@0000@00X450003o`0001401H40101<CD`20003P@0002D000?oP@00:@000h40000I0003o`000140
000K0003o`0001H000>100006@000h40000F0003P@0000H000>100000P000ol0000=00B11`02C080
00>100009@000on1000Y0003P@0001T000?o00004@0001/000?o00005P000h40000I0003P@0001H0
00>100001`001H40003o00X01H4;00==00<0P@009P000on1000Y0003P@0001T000?o00004@0001/0
00?o00005P000h40000I0003P@0001H000>100002002P@030?l000D0184@0005C4e<CH409`000on1
000Y0003P@0001T000?o00004@0001/000?oPOl05P000h40000I0003P@0001H000>100002P000h7o
0005PAH00ddW0003oh4002T000>100006@000ol0000A00002`04o`<00_l60004o`00PAD000>10000
6P000h40000F0003P@0000/000?oP@006`000de<C@0V0003oh4002X000>1000060000ol0000A0000
30000ol000020004o`00o`D000Co00000X4C0003P@0001X000>100005P000h40000;0003o`0001`0
0ddV0003o`0002T000>1000060000ol0000A00003@001Ol0003o008000?o00000`000ol0000300:1
4@000h40000J0003P@0001H000>100002`000ol0000L0003PDe=02H000?o0000:@000h40000H0003
o`000140000>0004o`00o`8000?o00000`000ol000050003P@0000h000>100006P000h40000F0003
P@0000/000?o00007000185<C4`U0003o`0002T000>100006@000ol0000@00002`001?l00?l20004
o`00o`D000?o00001P02P@h000>100006P000h40000F0003P@0000/000?o000070001H5<CDa=02@0
00?o0000:@000h40000I0003o`000100000<00;o1002o`H000?o000020000h40000;0003P@0001X0
00>100005P000h40000;0003o`0001`000J1001<CD`S0003o`0002T000>100006@000ol0000@0000
6P000ol0000900:12`000h40000I0003P@0001L000>100002`000ol0000L0007P@0004e<C@0R0003
o`0002T000>100006@000ol0000@00006@000ol0000<00:12@000h40000I0003P@0001L000>10000
2`000ol0000L0003P@0000800T`00dd0000O0003o`0002T000>100006@000ol0000@00006@000ol0
000>0003P@0000H000>100006@000h40000G0003P@0000/000?o000070000h400002009=00=<0000
7`000ol0000Y0003P@0001T000?o0000400001T000?o00003`02P@H000>100006@000h40000G0003
P@0000/000?o000070000h4000020004CDa=C20000?oP@00:@000h40000I0003o`000100000I0003
o`00014000>100000P000h40000J0003P@0001L000>100002`000ol0000L0003P@0000@00ddO0003
oh4002T000>100006@000ol0000@00006@000ol0000B00:10P000h40000J0003P@0001L000>10000
2`000ol0000L0003P@0000D000=<CD`01P05CA<000?oP@00:P000h40000H0003o`000100000I00;o
5@03PA`000>100005`000h40000;0003o`0001`000>100001P02C@03C4e=00Q=4@04ob/000>10000
6@000ol0000?00006@000ol0000F0003P@0001X000>100005`000h40000;0003o`0001`000>10000
1`08C@0406IVC@`01Ol30003POl002T000>100006@000ol0000?00006@000ol0000F00>16P000h40
000G0003P@0000/000?o000070000h40000700==1P0016I=CTd600Go20000h40o`0Y0003P@0001T0
00?o00003`0001P000?o00005`000h400002PAP000>100005P000h40000<0003o`0001`000>10000
4P000fI=IP05o`d000>100000_lW0003P@0001T000?o00003`0001P000?o00005`000h4000020003
P@0001D000>100005P000h40000<0003o`0001`000>100004005o`03C@0000l000>100000P000ol0
000T0003P@0001T000?o00003`0001P000?o00005`000h40000300:15@000h40000F0003P@0000`0
00?o000070000h40000;00Go1003IQ0000>100000`000ol0000S0003P@0001T000?o00003`0001P0
00?o00005`000h4000050003P@00018000>100005P000h40000<0003o`0001`000>100001P05o`X0
00==CP003`000h40000400;o8`000h40000I0003o`0000l0000H0003o`0001H000>100001`02PA40
00>100005`000h40000<0003o`0001`000B100001Ol?009V00=>00003@000h4000060003o`000200
00>100006@000ol0000?000060000ol0000F0003P@0000T00X4?0003P@0001L000>1000030000ol0
000K00Go50001DeVCFI=00d000>100001`000ol0000O0003P@0001X000?o00003P0001P000?o0000
5P000h40000;0003P@0000`000>100005`000h40000<0003o`0001L01?l00`21000H00A>30000h40
00080003o`0001l000>100006@000ol0000>00005`000ol0000G0003P@0000`00X4<0003P@0001L0
00>1000030000ol0000B00Go1@000h40000I0003CFI=00/000>100002@02oal000>100006@000ol0
000>00005`000ol0000G0003P@0000h000>100002@000h40000G0003P@0000`000?o00003@05o`X0
00>100006P000deV000:0003P@0000/000?o000070000h40000I0003o`0000h0000G0003o`0001L0
00>100003`02P@T000>100005`000h40000;0003o`0000T01Ol?0003P@0001X000==IP002P000h40
000<0003o`0001/000>100006@000ol0000>00005`02oaP000>100004@02P@L000>100005`000h40
000;0003o`0000@01OlD0003P@0001X000=VCP002P000h40000=00;o6`000h40000I0003o`0000h0
000G0003o`0001L000>100004`000h4000040003P@0001L000>100002`000ol0o`04oaT000>10000
6P000fI>000:0003P@0000l000?o000060000h40000I0003o`0000h0000G0003o`0001L000>10000
5002P@@000>100005`000h40000800Go7P000h40000J0003CT8000X000>1000040000ol0000G0003
P@0001H00h400ol0000>00005`000ol0000G0003P@0001H000F10000P@0I0003P@0000<01Ol30003
o`0001d000>100006P000fI2000:0003P@0001400_lG0003P@0001401H440003o`0000d0000F0003
o`0001L000>100006002P@03084001P000>1ool00ol80003o`0001d000>100006P000d9>000:0003
P@0001<000?o000050000h40000<00F12@000ol0000=00005P000ol0000G0003P@0001X00X4F00Co
3@000ol0000M0003P@0001X00T8;0003P@0001@000?o00004`000h40000600J13P000ol0000=0000
5P000ol0000G0003P@0001/00X4@00Go0`000h40000;0003o`0001d000>100006P000d9?000;0003
P@0001@00_lC0004P@0000F150000ol0000=00005P000ol0000G0003P@0001X000>100000X4900Go
20000h40000;0003o`0001d000>100006P02@P`000>100005P000ol0000?00F16@000ol0000=0000
5P000ol0000G0003P@0001X000>100000P0018400005o`d000>100002`000ol0000M0003P@0001X0
0T8<0003P@0001L000?o00002@05P@8000>100006@000ol0000=00005P000ol0000G0003P@0001X0
00B100001OlB0003P@0000/000?o00007@000h40000J0003@Tl000/000>100006002o`<01X470003
P@0001T000?o00003@0001H000?o00005`000h40000I00Go1002PA4000>100002`000ol0000M0003
P@0001X000=?@P002`000h40000H00:100?oPH403@000h40000I0003o`0000d0000F0003o`0001L0
00>100005005o`03084000P000>100003P000h40000;0003o`0001d000>100006P02C``000>10000
4`05P@<000?o000030000h40000I0003o`0000d0000E0003o`0001P000>100003`05o`H000>10000
2002P@d000>1000030000ol0000M0003P@0001X00Tl<0003P@0000d01X490003o`0000/000>10000
6P000ol0000<00005@000ol0000G0003P@0000`01?l;0003P@0000X000>100002P000h40000<0003
o`0001d000>100006P000cm?000;0003P@0000P01H4@00;o2`000h40000J0003o`0000`0000E00?o
5`000h40000700Go3`000h40000;00:12P000h40000<0003o`0001d000>100006P000cm?000;0003
P@0000<01H4G0003o`0000P000>100006P000ol0000<00005@000ol0000G0003P@0000801OlD0003
P@0000d00X480003P@0000`000?o00007@000h40000J009?3006PAd000?o00001`000h40000J0003
o`0000`0000E0003o`0001L01OlI0003P@0000l000>100001@000h40000<0003o`0001d000>10000
6P000cm?C`0600J18`02o`L000>100006P000ol0000<00005@000ol0000B00Go00>100006`000h40
000@00:11@000h40000<0003o`0001d000>100006`02?`03086100>11@000h40000S0003o`0000D0
00>100006@000ol0000<00005@000ol0000=00Go1@000h40000K0003P@0001800X430003P@0000`0
00?o00007@000h40000I00:100<oCh402P000h40000T0003o`0000@000>100006@000ol0000<0000
50000ol0000900Go2P000h40000K0003P@0001@000B100213P000ol0000M0003P@0001<01X42008o
2`000h40000U00;o10000h40000I0003o`0000`0000D0003o`0000@01Ol?0003P@0001X000>10000
5P03P@h000?o00007@000h40000>00F12002?`/000>100009`001Ol0002101`000?o00002`0001@0
00?o0?l01?lD0003P@0001X000>1000060000h40000<0003o`0001d000>100002@05P@d000<o8000
2P000h40000X0004o`00PA`000?o00002`0001@00_lI0003P@0001X000>100006003P@`000?o0000
7@000h40000400F14P000clP000:0003P@0002T00_l00h40000J0003o`0000/0000F00;o5P000h40
000K0003P@0001P000>100000X4:0003o`0001d01h4G0003824000X000>10000:`000ol0000J0003
o`0000/0000H00;o50000h40000K0003P@0001P000>100000P000h4000070003o`0001T01H4M0003
824000X000>10000:`000h7o000J0003o`0000/0000J0003o`00014000>100006`000h40000H0003
P@0000<00X470003o`0001@01H440003P@0001/000<Q80002P000h40000[0003P@3o01X000?o0000
2`0001/00_lA0003P@0001/000>1000060000h4000050003P@0000@000?o00003P06P@T000>10000
6`000b4P000:0003P@0002/000>100000_lH0003o`0000/0000M00;o3`000h40000K0003P@0001P0
00>100001P02P@@000?o00002@05P@l000>100006`028@/000>10000:`000h4000020003o`0001D0
00?o00002`0001l00_l=0003P@0001/000>1000060000h40000800:10P000ol0000400F150000h40
000K008Q2`000h40000/0003P@00008000?o00005@000ol0000:00008@02o`/000>100006`000h40
000H0003P@0000X000B10?l01H4I0003P@0001/000<_8@002`000h40000[0003P@0000<00_lE0003
o`0000X0000S0003o`0000P000>100006`000h40000H0003P@0000/000?oPH407P000h40000K008_
30000h40000[0003P@0000D000?o00004P000ol0000:00009002o`P000>100006`000h40000H0003
P@0000/000?o00007P000h40000K00038R4000/000>10000:`000h4000060003o`00014000?o0000
2P0002H00_l50003P@0001`000>1000060000h40000;0003o`0001h000>100006`02;``000>10000
:`000h40000700;o4@000ol0000:0000:002o`<000>100006`000h40000I0003P@0000/000?o0000
7P000h40000K00038R4000/000>10000:`000h4000090003o`0000h000?o00002P0002X00_l00`21
000L0003P@0001P000>1000030000ol0000N0003P@0001/00R8<0003P@0002/000>100002P000ol0
000=0003o`0000X0000/0003oh4001`000>1000060000h40000<0003o`0001h000>100006`028P`0
00>10000:`000h40000;00;o3@000ol0000:0000;@02oa`000>1000060000h40000<0003o`0001h0
00>100006`000b8O000;0003P@0002/000>100003@000ol0000:0003o`0000X0000_00;o6P000h40
000H0003P@0000`000?o00007P000h40000K008O30000h40000[0003P@0000h000?o00002P000ol0
00090000<@02oaP000>1000060000h40000<0003o`0001h000>100006`000alR000;0003P@0002`0
00>100003P02o`X000?o00002@0003<00_lF0003P@0001P000>1000030000ol0000N0003P@0001/0
00<O8P002`000h40000/0003P@00010000?o00001`000ol000090000=@02oa@000>1000060000h40
000<0003o`0001h000>100006`027``000>10000;0000h40000A0003o`0000H000?o00002@0003L0
00?o00004@000h40000H0003P@0000`000?o00007P000h40000Y0003P@0002`000>100004P000ol0
00050003o`0000T0000h00;o4@000h40000H0003P@0000`000?o00007P000h40000Y0003P@0002`0
00>100004`02o`D000?o00002@0003X00_l?0003P@0001P000>1000030000ol0000N0003P@0002T0
00>10000;0000h40000E0003o`00008000?o00002@0003`00_l=0003P@0001P000>1000030000ol0
000N0003P@0002T000>10000;0000h40000F0005o`000?l02`0003h00_l;0003P@0001P000>10000
30000ol0000N0003P@0002T000>10000;0000h40000G00;o0P000ol000080000@0000ol000070003
P@0001T000>1000030000ol0000N0003P@0002T000>10000;0000h40000I0003o`3o00X0001100;o
1`000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002`000>100006P02o`X0001300;o
1@000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002`000>100006004o`X0001500;o
0`000h40000I0003P@0000`000?o00007P000h40000Y0003P@0002d000>100004@06o`h0001700;o
00<0P@006P000h40000<0003o`0001h000>10000:@000h40000]0003P@0000`01OlD0000B@000on1
000J0003P@0000`000?o00007P000h40000Z0003P@0002`000>100001P06oaT0001:00;o6P000h40
000<0003o`0001h000>10000:P000h40000/0003P@0000Ko7`0004`00_lH0003P@0000`000?o0000
7P000h40000Z0003P@0002T01_lU0000CP02oaH000>1000030000ol0000N0003P@0002X000>10000
9005ob/0001@00;o50000h40000<0003o`0001h000>10000:P000h40000N00Ko<000058000?o0000
40000h40000=0003o`0001h000>10000:P000h40000H00Ko=P0005<00_l@0003P@0000d000?o0000
7P000h40000Z0003P@0001801_ll0000E@02o`h000>100003@000ol0000N0003P@0002X000>10000
3@05od80001G00;o30000h40000=0003o`0001h000>10000:P000h40000700KoA`0005T00_l:0003
P@0000d000?o00007P000h40000Z0004P@0000KoC@0005/00_l80003P@0000`000?o00007`000h40
000X00KoD`0005d000?o00001@000h40000<0003o`0001l000>100008`05oeT0001N00;o1@000h40
000<0003o`0001l000>100007@06oeh0001P00;o0`000h40000<0003o`0001l000>100005`06of@0
001R00;o00<0P@003@000ol0000O0003P@0001801OmZ0000I002o`h000?o00007`000h40000<00Ko
K`0006H000?o00002`000ol0000O0003P@0000H01_me0000I`02o`/000?o00007`000h400006og/0
001Y00;o2@000ol0000M00GoP@0006/00_l70003o`0001L01_n60000K@02o`D000?o00004@06oh`0
001_0003o`00008000?o00002`06oi80001`00;o0P000ol0000600GoV00007800ol200KoW@0007@0
0onS0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000
M@000ol0000W0003o`0007P0001@00Co0`04o`040?oo00;o0P02o`<01?l200Co0`000ol0000800Go
00@0ool00_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<00ol300?o1002odT0
001?0005o`000?l00P000ol000030004o`00o`<00_l40003o`0000<000?o000010000ol000090005
o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L000?o00001@000ol000020004
o`00o`800_l60003o`0000<000Co00000_m90000C`000ol0o`02o`801Ol01@3o003o00X000?o0000
0`000ol0000?0005o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003o`000080
00?o00002`000ol000030003o`0004`0001?0003o`0000@000Oo0000o`3o008000?o00002@000ol0
00030003o`0000h000Go0000o`020004o`00o`<000?o00001P000ol0000>00?o1@000ol000020003
o`0000T00_l400;oC`0004l000Go0000o`0300?o00<0ool00ol80004o`00o`8000Co003o40000ol0
0005o`<01?l80003o`0000h000?o00001002o`<01?l;0003o`0000<000?o0000C00005001?lE00;o
1002o`l01Ol;0003o`0000D00_l?00Go2@000ol0000800?o0`03odl0002?00;o8@000ol000020003
o`000600003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.0850089, -0.0250048, \
0.00276677, 0.00386875}},
  CellTags->"AntTracker3D - Gen 22"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 19",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 35",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  ButtonBox["Movie",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ 
          ParentDirectory[ ]], "Movies", "AntTracker-Movies Folder"}, 
        "AntTracker-7i-Gen22.nb", CharacterEncoding -> "MacintoshRoman"], 
      None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[{}, \ \(ifSensor[wall]\)[seq[turnLeft, \ again], \ 
          turnRight], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[turnLeft, \ again], \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.22, Ind.1, Fit.33.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.22, Ind.1, Fit.33.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .067 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .045 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .022 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .067 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .045 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .022 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.022 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.045 1 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
.067 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.404 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.427 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.449 1 0 r
F P
s
P
p
.002 w
.60601 .51361 m .59174 .51774 L .58442 .5101 L p
.472 1 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.022 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.045 1 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
.067 1 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.404 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.427 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.449 1 0 r
F P
s
P
p
.002 w
.58442 .5101 m .59875 .50592 L .60601 .51361 L p
.472 1 0 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .135 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .112 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .09 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.09 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.112 1 0 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
.135 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.494 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.517 1 0 r
F P
s
P
p
.002 w
.63478 .50528 m .62036 .50945 L .61314 .50172 L p
.539 1 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .135 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .112 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .09 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.09 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.112 1 0 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
.135 1 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.494 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.517 1 0 r
F P
s
P
p
.002 w
.61314 .50172 m .62762 .49751 L .63478 .50528 L p
.539 1 0 r
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.157 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.18 1 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.202 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.337 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.36 1 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
.382 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
.562 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
.584 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
.607 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .045 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .022 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.157 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.18 1 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.202 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.337 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.36 1 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
.382 1 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .202 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .18 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .157 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
.562 1 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
.584 1 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
.607 1 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .045 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .022 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.225 1 0 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.247 1 0 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.27 1 0 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .202 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .18 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .157 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.629 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.652 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.674 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .112 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .09 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
1 .067 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.225 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.247 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.27 1 0 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.629 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.652 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.674 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .112 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .09 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
1 .067 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.292 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
.315 1 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.697 1 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.719 1 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.742 1 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .18 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .157 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
1 .135 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.292 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
.315 1 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .27 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .247 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .225 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.697 1 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.719 1 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.742 1 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .18 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .157 0 r
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
1 .135 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .27 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .247 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .225 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.64625 .46684 m .61673 .47557 L .60187 .45937 L p
.8 g
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.764 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.787 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.809 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .247 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .225 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
1 .202 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.764 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.787 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.809 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .247 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .225 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
1 .202 0 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.67609 .458 m .64625 .46684 L .63161 .45045 L p
.8 g
F P
s
P
p
.002 w
.60187 .45937 m .63161 .45045 L .64625 .46684 L p
.8 g
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.831 1 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.854 1 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.876 1 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .315 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .292 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
1 .27 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .36 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .337 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .315 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 .292 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.831 1 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.854 1 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.876 1 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .315 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .292 0 r
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
1 .27 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .36 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .337 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .315 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 .292 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.70625 .44907 m .67609 .458 L .66167 .44144 L p
.8 g
F P
s
P
p
.002 w
.63161 .45045 m .66167 .44144 L .67609 .458 L p
.8 g
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.899 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.921 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.944 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .36 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
1 .337 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .427 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .404 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 1 .382 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.899 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.921 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.944 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .36 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
1 .337 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .427 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .404 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 1 .382 r
F P
s
P
p
.002 w
.73675 .44005 m .70625 .44907 L .69207 .43233 L p
.8 g
F P
s
P
p
.002 w
.66167 .44144 m .69207 .43233 L .70625 .44907 L p
.8 g
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
.966 1 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
.989 1 0 r
F P
s
P
p
.002 w
.84497 .4444 m .82942 .4489 L .82298 .44057 L p
1 .989 0 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 1 .472 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 1 .449 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
.966 1 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
.989 1 0 r
F P
s
P
p
.002 w
.82298 .44057 m .83859 .43602 L .84497 .4444 L p
1 .989 0 r
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 1 .472 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 1 .449 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .427 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .404 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
1 .382 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.69207 .43233 m .72279 .42312 L .73675 .44005 L p
.8 g
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .966 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .944 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .921 0 r
F P
s
P
p
.002 w
.87631 .43532 m .8606 .43987 L .85428 .43145 L p
1 .899 0 r
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .427 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .404 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
1 .382 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .966 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .944 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .921 0 r
F P
s
P
p
.002 w
.85428 .43145 m .87006 .42685 L .87631 .43532 L p
1 .899 0 r
F P
s
P
p
.002 w
.72279 .42312 m .69207 .43233 L .67759 .41524 L p
.8 g
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
0 1 .539 r
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
0 1 .517 r
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
0 1 .494 r
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .022 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .045 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .067 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .09 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .112 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .135 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .157 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .18 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .202 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .225 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .247 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .27 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .292 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .315 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .337 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .36 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .382 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .404 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .427 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .449 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .472 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .494 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .517 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .539 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .562 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .584 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .607 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .629 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .652 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .674 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .697 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .719 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .742 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .764 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .787 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .809 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .831 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .854 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .876 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .899 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .921 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .944 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .966 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
1 0 .989 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.989 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.966 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.944 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.921 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.899 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.876 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.854 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.831 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.809 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.787 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.764 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.742 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.719 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.697 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.674 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.652 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.629 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.607 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.584 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.562 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.539 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.517 0 1 r
F P
s
P
p
.002 w
.63562 .42258 m .62045 .4272 L .61286 .41865 L p
.494 0 1 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
0 1 .539 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
0 1 .517 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
0 1 .494 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .494 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .472 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
1 .449 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.67759 .41524 m .70855 .40584 L .72279 .42312 L p
.8 g
F P
s
P
p
.002 w
.86374 .41829 m .8479 .42294 L .84146 .41434 L p
1 .876 0 r
F P
s
P
p
.002 w
.86374 .41829 m .8479 .42294 L .84146 .41434 L p
1 .854 0 r
F P
s
P
p
.002 w
.86374 .41829 m .8479 .42294 L .84146 .41434 L p
1 .831 0 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .022 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .045 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .067 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .09 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .112 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .135 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .157 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .18 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .202 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .225 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .247 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .27 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .292 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .315 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .337 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .36 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .382 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .404 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .427 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .449 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .472 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .494 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .517 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .539 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .562 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .584 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .607 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .629 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .652 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .674 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .697 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .719 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .742 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .764 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .787 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .809 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .831 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .854 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .876 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .899 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .921 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .944 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .966 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
1 0 .989 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.989 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.966 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.944 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.921 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.899 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.876 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.854 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.831 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.809 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.787 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.764 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.742 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.719 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.697 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.674 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.652 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.629 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.607 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.584 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.562 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.539 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.517 0 1 r
F P
s
P
p
.002 w
.61286 .41865 m .62809 .41398 L .63562 .42258 L p
.494 0 1 r
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .494 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .472 0 r
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
1 .449 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.84146 .41434 m .85736 .40965 L .86374 .41829 L p
1 .876 0 r
F P
s
P
p
.002 w
.84146 .41434 m .85736 .40965 L .86374 .41829 L p
1 .854 0 r
F P
s
P
p
.002 w
.84146 .41434 m .85736 .40965 L .86374 .41829 L p
1 .831 0 r
F P
s
P
p
.002 w
.70855 .40584 m .67759 .41524 L .6628 .3978 L p
.8 g
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 1 .607 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 1 .584 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 1 .562 r
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.62047 .40529 m .60519 .41001 L .59744 .40128 L p
.472 0 1 r
F P
s
P
p
.002 w
.62047 .40529 m .60519 .41001 L .59744 .40128 L p
.449 0 1 r
F P
s
P
p
.002 w
.62047 .40529 m .60519 .41001 L .59744 .40128 L p
.427 0 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 1 .607 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 1 .584 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 1 .562 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .584 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .562 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .539 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .517 0 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.6628 .3978 m .69401 .3882 L .70855 .40584 L p
.8 g
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 .809 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 .787 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 .764 0 r
F P
s
P
p
.002 w
.59744 .40128 m .61278 .39652 L .62047 .40529 L p
.472 0 1 r
F P
s
P
p
.002 w
.59744 .40128 m .61278 .39652 L .62047 .40529 L p
.449 0 1 r
F P
s
P
p
.002 w
.59744 .40128 m .61278 .39652 L .62047 .40529 L p
.427 0 1 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .584 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .562 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .539 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .517 0 r
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
.315 0 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
.292 0 1 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 .809 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 .787 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 .764 0 r
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.69401 .3882 m .6628 .3978 L .64772 .38 L p
.8 g
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
1 .652 0 r
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
1 .629 0 r
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
1 .607 0 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
.315 0 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
.292 0 1 r
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
0 1 .674 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
0 1 .652 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
0 1 .629 r
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
1 .652 0 r
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
1 .629 0 r
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
1 .607 0 r
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
.404 0 1 r
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
.382 0 1 r
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
.36 0 1 r
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
.337 0 1 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
0 1 .674 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
0 1 .652 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
0 1 .629 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.72557 .3785 m .69401 .3882 L .67916 .3702 L p
.8 g
F P
s
P
p
.002 w
.64772 .38 m .67916 .3702 L .69401 .3882 L p
.8 g
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .742 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .719 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .697 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 .674 0 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
.404 0 1 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
.382 0 1 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
.36 0 1 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
.337 0 1 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
.27 0 1 r
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
.247 0 1 r
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
.225 0 1 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .742 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .719 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .697 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 .674 0 r
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
.27 0 1 r
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
.247 0 1 r
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
.225 0 1 r
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 1 .742 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 1 .719 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 1 .697 r
F P
s
P
p
.002 w
.75748 .36868 m .72557 .3785 L .71097 .36028 L p
.8 g
F P
s
P
p
.002 w
.67916 .3702 m .71097 .36028 L .72557 .3785 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .80355 .37699 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 1 .742 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 1 .719 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 1 .697 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .75748 .36868 L .74314 .35025 L p
.8 g
F P
s
P
p
.002 w
.71097 .36028 m .74314 .35025 L .75748 .36868 L p
.8 g
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.78977 .35875 m .82243 .3487 L .83594 .36716 L p
.8 g
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
.202 0 1 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
.18 0 1 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
.157 0 1 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
.202 0 1 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
.18 0 1 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
.157 0 1 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
0 1 .809 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
0 1 .787 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
0 1 .764 r
F P
s
P
p
.002 w
.82243 .3487 m .78977 .35875 L .77569 .34011 L p
.8 g
F P
s
P
p
.002 w
.74314 .35025 m .77569 .34011 L .78977 .35875 L p
.8 g
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
0 1 .809 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
0 1 .787 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
0 1 .764 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.77569 .34011 m .80861 .32985 L .82243 .3487 L p
.8 g
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
.135 0 1 r
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
.112 0 1 r
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
.09 0 1 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
.135 0 1 r
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
.112 0 1 r
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
.09 0 1 r
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 1 .876 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 1 .854 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 1 .831 r
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 1 .876 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 1 .854 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 1 .831 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
.067 0 1 r
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
.045 0 1 r
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
.067 0 1 r
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
.045 0 1 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .944 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .921 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 1 .899 r
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.53979 .31322 m .52392 .31846 L .5153 .30875 L p
.022 0 1 r
F P
s
P
p
.002 w
.53979 .31322 m .52392 .31846 L .5153 .30875 L p
0 0 1 r
F P
s
P
p
.002 w
.53979 .31322 m .52392 .31846 L .5153 .30875 L p
0 .022 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .944 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .921 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 1 .899 r
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.5153 .30875 m .53124 .30345 L .53979 .31322 L p
.022 0 1 r
F P
s
P
p
.002 w
.5153 .30875 m .53124 .30345 L .53979 .31322 L p
0 0 1 r
F P
s
P
p
.002 w
.5153 .30875 m .53124 .30345 L .53979 .31322 L p
0 .022 1 r
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
0 .045 1 r
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
0 .067 1 r
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
0 .09 1 r
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .966 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .989 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 1 .989 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 1 .966 r
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
0 .045 1 r
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
0 .067 1 r
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
0 .09 1 r
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .966 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .989 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 1 .989 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 1 .966 r
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
0 .112 1 r
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
0 .135 1 r
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
0 .157 1 r
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
0 .18 1 r
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .899 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .921 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .944 1 r
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
0 .112 1 r
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
0 .135 1 r
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
0 .157 1 r
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
0 .18 1 r
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .899 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .921 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .944 1 r
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
0 .831 1 r
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
0 .854 1 r
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
0 .876 1 r
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 .202 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 .225 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 .247 1 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
0 .831 1 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
0 .854 1 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
0 .876 1 r
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 .202 1 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 .225 1 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 .247 1 r
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
0 .764 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
0 .787 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
0 .809 1 r
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
0 .764 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
0 .787 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
0 .809 1 r
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
0 .697 1 r
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
0 .719 1 r
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
0 .742 1 r
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
0 .27 1 r
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
0 .292 1 r
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
0 .315 1 r
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
0 .697 1 r
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
0 .719 1 r
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
0 .742 1 r
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
0 .27 1 r
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
0 .292 1 r
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
0 .315 1 r
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .629 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .652 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .674 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .629 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .652 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .674 1 r
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
0 .562 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
0 .584 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
0 .607 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 .337 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 .36 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 .382 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
0 .562 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
0 .584 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
0 .607 1 r
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 .337 1 r
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 .36 1 r
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 .382 1 r
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
0 .494 1 r
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
0 .517 1 r
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
0 .539 1 r
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
0 .494 1 r
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
0 .517 1 r
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
0 .539 1 r
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
0 .404 1 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
0 .427 1 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
0 .449 1 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
0 .472 1 r
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
0 .404 1 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
0 .427 1 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
0 .449 1 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
0 .472 1 r
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00[;^l^kbk_;^l_o3h402?o;^l^kbk_o0`000ol0
00020003o`0005T0001b0003o`00008000Co003o4`03oaP00ol9^`?o3H400on1P@0<P@03ok^k00^k
00?oPH402843o`03POnk00Jk00Co003o1@000ol0001H0000L@02o`D00_lA00?o6@02o`0:^l^kbk_;
^l^kb`;o00>1oh403H400on1P@08P@?o016kbk_;^l^kbk_;^l^kbk_;o`06P@?o1H402?nkbk_;^l_o
0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH401843oaBk00?oPH40
0ol9P@03ok^k00Bk00Go0000o`0400;oF00008H00_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R1
00?oPH4038400on1P@03o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l<P@09ol^kbk_;^l_o0080
00?o00000`000ol0001F0000P`03oaP00ol;^`;o2h400on1P@0<P@;o6k/00on1P@0<P@03ok^k00Fk
00Co003o1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`0P
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol0
00080003o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10olS^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F100?oPH40
3H400on1o`02o`0X^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^k
bk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k0ol9P@03oh6100f1
00?o^k/0:;/00on1P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT0
0ol02l^kbk_;^l^kbk_;00;o3H400on1P@08P@?o02k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o1H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o
6003o`^k0ol00h7oP@0=P@03oh6100B10ola^`03oh7o00;o2H400onk^`05^`04o`00o`<000?o0?l0
D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH4038400on1P@03o`0dbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o3H402?o;^l^kbk_o0`000ol0
00030003o`000500001]00?o6@02o`^k0ol9P@03oh6100b10_ld^`?o00>1oh403H400onk^`04^`05
o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o03C;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol5P@03oh6100b1
00Sobk_;^l^ko`8000?o00000`000ol0001?0000J003oaP00ol;^`?o00>1oh403H400on1P@03P@?o
=;/3o`V100?oPH4038400onk^`04^`04o`00o`D000?o0000CP0006D00ol00`3o000E00?o00^kbk_;
^l^kbk_;^`03o`F100?oPH4038400on1o`02o`0dbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003
o`0004h0001200?o7P02oaT00ol:^`?o2H400on1P@0<P@03ok^k03:k0ol00h7oP@0=P@03oh6100B1
0ol5P@03ok^k00Bk00Co003o1@02odh000150003o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH401h43o`0c^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nkbk_;^l_o0P000ol0000200;oCP0004D000?o0000
5@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o<k/3o`V100?oPH403842o`b100?o^k/01;/01Ol0
003o00@000?o0000C00004800olF00;o0P000ol0000C00Co00Zkbk_;^l^kbk_;0ol5P@03oh6100b1
00?oPOl00_l0=;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/2o`f100?oPH401h43o`03^on100f100Sobk_;^l^ko`8000?o00000`000ol0001;0000@P000ol0
000C00?o6003o`Zk0ol9P@03oh6100b100?o^k/0<[/3o`03POn100f100?oPH400h43o`Fk00?oPH40
2h400onk^`05^`04o`00o`D000?o0000BP0004801?l?00?o6003o`0;^l^kbk_;^l^kbk/00_l=P@03
oh6100N10ol0<h7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<000?o00000`000ol0
00190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o1H400onk^`0F^`;o4k/3o`V100?oPH40
38400onk^`0;^`03oh6100V100?oPOl01[/01Ol0003o00@000?o0000B@0005000_l30003o`0001<0
0ol02/^kbk_;^l^kbk/3o`F100?oPH4038400on1o`02o`V101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/0
0ol04l3o^l^kbk_;^l^kbk_;^l^kbk/00_l=P@03oh6100N10ol04<^kbk_;^l^kbk_;^l^kbol7P@Co
0X402Oo;^l^kbk_;o`020003o`0000<000?o0000B00004d00olH00?o2[/3o`V100?oPH4038400on1
P@0;P@03ok^k012k00Ooa/36`<Ko012k00?oPH4038400on1P@04P@?o4k/00on1P@04o`N100?o^k/0
1K/01?l00?l400;oB@0004X00olH00?o00[;^l^kbk_;^l^k0ol=P@03oh6100N10ol00k_;o`0=P@0[
ol^kbk_;^l^kbk_;^l^kbk_;olK0a/36`?nkbk_;^l^kbk_;^l^kbk_;o`0>P@03oh6100?o01O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`02o`b100Sobk_;^l^ko`<000?o00000P000ol000170000B002oaP0
1?l9^`?o0h400on1P@0;P@03oh6100>10ol6^`03oh6100^100?o^k/01k/2o`Jk00So`<K0a/36oa2k
00?oPH403842oaZk00?oPH4038400onk^`04^`04o`00o`D000?o0000AP0004D00ol20003o`0001<0
0ol02K_;^l^kbk_;^`03o`N100?oPH402h400on1o`02o`0;^l^kbk_;^l^kbol03H401_o;^l^kb`?o
00_0ol^kbk_;^l_oaP03o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol9P@?o01n1ol^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o00f100Wo^l^kbk_;^ol00P000ol000030003o`0004D0001200?o1P000ol0
000?00?o2K/3o`^100?oPH402h400onk^`0<^`03oh6100J10ol6^`07olK0a/36o`07^`03ok^k01Fk
00?oPH400h43o`F100?o^k/06[/00on1P@0;P@03ok^k00Bk00Go0000o`040003o`0004D0001000;o
6003o`09^l^kbk_;^l^k00?o00>1oh4038400on1P@06P@?o01;;^l^kbk_;^l^kbk_;^l^kbol5P@;o
00Zkbk_;^l^kbk_o1/003_o;^l^kbk_;^l^kbk_;0_l04[_;^l^kbk_;^l^kbk_;^l_oP@?o2H407Oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00j100So^l^kbk_;o`8000?o00000`000ol000140000
?@03oaL01?l8^`?o1H400on1P@0;P@03oh6100>10_lE^`03oh7o00;o1;/2o`Jk00So`<K0a/36o`Vk
0ol00hco^`0@^`03oh6100^100?o^k/06K/00on1P@07P@?o00>1ok/01[/01?l00?l50003o`0001d0
1Ol01@3oool000?o0`02oa@0000j00?o0`000ol0000B00?o00S;^l^kbk_;^`?o2H400on1P@0;P@03
oh7o00;o01fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^`03o`;000Wobk_;^l^kol000ol02K_;
^l^kbk_;^`02o`G601;obk_;^l^kbk_;^l^kbk_;^ol>P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`J10ol5P@08ol^kbk_;^ol30003o`0000800_lN0003o`00008000Co003o10001?l00?lE0000
=`03oaP00ol9^`;o3H400on1P@09P@03oh7o01nk00Soc<3<`<c0o`Jk00?o^k/02[/02On<aXc6S<J<
o`0@^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/01;/01Ol0003o00@000?o000070000ol0
000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;^l^kb`?o0X400on1P@0;P@03oh6100B1
1?l09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`K001Gobk_;^l^kbk_;^l^kbk_;
^l^kbol01lH04_o;^l^kbk_;^l^kbk_;^l^ko`j101_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l=P@08ol^kbk_;^ol20003o`0000<000?o00006`05o`<000?o0?l01@000ol0000C0000<P05oaH0
0ol9^`;o1X400on1P@0;P@03oh6100?o7k/3o`Jk00?oc?l00_l4^`;o4;/00on<aP03oa>k00?oPH40
1h43o`03POnk01Vk00?oPH4038400onk^`05^`04o`00o`D000?o00006P000ol0000300;o0`03o`04
0?oooa@0000A00;o7003oaP00ol02K_;^l^kbk_;^`03o`V100?oPH402h42o`0Obk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`?<00cobk_;^l^kok_;^l/3o`0CPOo;^l^kbk_;^l^kbk_;^l^k
b`02o`0H^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1H43o`F101co^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o3X402?nkbk_;^l_o0`000ol000020003o`0001X000?o00003@000ol0000C000040001?l0
0?lI00;o6003o`Zk0_l=P@03oh6100J10olQ^`03olc<00G<00?o^k/01[/2o`F100?o^k/05[/2oa2k
00?oPOl00_l9P@03ok^k01Rk00?oPH4038400onk^`04^`04o`00o`D000?o00006@05ob40000@0004
o`00oaH00olG00Co00W;^l^kbk_;^l/00ol2P@03oh6100^100?oPH400h42o`0Vbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol7c005ol^kbk/00ol8P@0Eol^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o01A<ok_;^l^kbk_;^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1h44o`:100Wobk_;^l^kbol00P000ol000030003o`0003h0000@0004o`00oa<00ol20003o`0001<0
0ol:^`;o1X400on1P@0;P@03oh7o00;o7k/3o`Jk00?oc<`00ol5^`03oh6100Z100?o^k/03k/2o`F<
00?o^k/03[/00on1P@0;P@03ok^k01Vk00?oPH401?l7P@03ok^k00Bk00Go0000o`0300;o@0000100
00Co003o4@02oaP00ol02/^kbk_;^l^kbk/3o`V100?oPH402h408?nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol02/3<`?nkbk_;^l/2o`09^l^kbk_;^l_o00f102_obk_;^l^kbk_;^l^kbk_;
^om<S4b<C8a<ok_;^l^kbk_;^l^kbk_;^l_o00f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0_l<P@08ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f1
00?oPH401X43ob6k00So3L`=c0g<oa2k00?oPH402h400onk^`0>^`03ohb<00F<00?o^k/03[/00on1
P@0;P@03ok^k01Rk00?oPH4038400onk^`04^`04o`00o`D000?o00001P000ol000020004o`00obd0
000O00Co5`03o`09^l^kbk_;^l^k00?o18400on1P@0:P@03oh6100>10_l07L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;o01nkbk_;^l_oc<3<`<c0ok_;^l^kbk_;^l^kbk_;^l_o00f101Cobk_;
^l^kbk_;^l^kbk_;^om<S0?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`R10ol07X7o^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o00000P001?l0
0?l]00007003o`@000?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_lL^`?o0Pd00onk^`04^`03
o`go00;o4k/00on1P@06P@?o00>1ok/04;/2oaJk00?oPH400h43o`F100?o^k/06K/00on1P@0;P@03
ok^k00Bk00Co003o1@000ol000050003o`00008000Co003o;@0001X00_lH00?o00Vkbk_;^l^kbk/0
0ol<P@03oh6100Z1023o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`K<023o^l^kbk_;ol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`F10_l5P@0Hok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l04/^k
bk_;^l^kbk_;^l^kbk_oP@?o2H407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00^100[oPOnk
bk_;^l_o0P000ol000030003o`0000@000?o00000P001?l00?l]00005`03oaL01?l8^`?o0X400on1
P@0;P@03oh6100B10olR^`03o`d=00@=00?o^k/07;/00on1o`02o`R100?o^k/04K/3o`03S?nk012k
00?oPH402h400onk^`0H^`03oh6100F11?l2P@03ok^k00Fk00Co003o1002o`@00_l500;o;P0001@0
0ol00`3oo`0E00?o00W;^l^kbk_;^l/00_l6P@03oh6100^100?oPH400ol07[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`;o00Nkbk_;^l_o00?<0_l07/co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`?o38404onkbk_;^l^kbk_;^l^kbk_;^ol01H`04_nkbk_;^l^kbk_;^l^kbk_;o`f101gobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@Co1h402?o;^l^kbk_o0`001_l00?l0oc/0000C00;o
1@000ol0000?00?o2K/3o`V100?oPH402h42oajk0ol00l`=o`06^`?o7;/4o`>100?oPH402X400onk
^`0?^`07oha<S4b<o`0@^`03oh6100^100?o^k/06K/2o`b100?o^k/01;/01?l00?l50003o`0003P0
000C0003o`3o01<01?l02K_;^l^kbk_;^`02o`f100?oPH401X43o`19^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o3L`=c0g<ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`R1
00?oPH402X404onkbk_;^l^kbk_;^l^kbk_;^ol00h`05?n<ok_;^l^kbk_;^l^kbk_;^l_o3H407?o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o008000?o00000P000ol0000h0000
4`001?l00?l?00Co2K/3o`:100?oPH402h400on1P@03P@;o7K/2o`Fk00Soc0g<3L`=oafk0ol<P@03
oh6100Z100?o^k/03k/3oaBk00?oPH401844o`:100?o^k/06K/00on1P@0;P@03ok^k00Bk00Go0000
o`040003o`0003L0000C0005o`000?l03003o`0:^l^kbk_;^l^kb`;o1X400on1P@0;P@03oh7o00;o
01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol02Pgo^l^kbk_;o`d3o`0Lbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`?o00>1oh403H400on1P@04P@?o02fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X43o`N101go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
o`0=P@08ok_;^l^kbol20003o`0000<000?o0000=P0001<000?o00000P000ol0000600?o2[/3o`V1
00?oPH402h400onk^`0L^`07ol`=c0g<o`06^`03ok^k01^k0_l5P@03oh6100b100?oPH400olN^`;o
4;/2o`^100?o^k/06K/00on1P@06P@?o00>1ok/01[/01?l00?l50003o`0003D0000C0003o`0000<0
00?o00000P04o`09bk_;^l^kbk_;00?o3H400on1P@06P@?o026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol01Pd08Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`R100?oPH40
3842o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol04db<ok_;^l^kbk_;^l^kbk_;^ol0
3H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol5P@?o1H402Oo;^l^kbk_;o`020004o`0000;o
=`00018000?o00001@000ol0o`02o`Vk0ol4P@03oh6100Z100?oPH400h42oafk0_l5^`08o`g<3L`=
c?lL^`?o38400on1P@07P@?o8;/02?n<aXc6S<Ko3k/00on1P@0;P@03ok^k01Rk00?oPOl00_l9P@03
ok^k00Bk00Co003o1@000ol0000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03oh6100Z1
00?oPOl00_l07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`8=00Sobk_;^l_o3@?o01_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0L^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`;o01jkbk_;^on<C8a<S4b<ok_;^l^kbk_;^l^kbk_;^ol=P@0Lok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000`000ol0000c00004P001?l0
0003o`@000?o^k/00k/2o`b100?oPH402X400onk^`0L^`08okD=]@fe3Ol5^`03ok^k01Vk0ol7P@03
oh6100Z100?oPOl00_lL^`?o00=<ok/01K/00oo6S003oa:k00?oPH401X43o`03POnk01Vk00?oPH40
2h400onk^`05^`04o`00o`@000?o0000<`0001801?l80007ok_;^l^ko`0=P@03oh6100B10ol08l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00H=01kobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`^100?oPH402X40;?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_oC<I<aTco
bk_;^l^k0_l05l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00F10_l5P@0Lol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f100So^l^kbk_;o`8000?o00000`000ol0000b00004P02o`/000?o^k/00k/00on1
P@0;P@03oh6100?o9[/00oneo`02oabk0ol00h7oP@0<P@03oh6100B10olR^`07odb<C8a<o`0N^`03
oh7o00;o28400onk^`0H^`03oh6100^100?o^k/01;/01?l00?l50003o`000340000D0003o`0000T0
00Oo^l^kbk_o00f10_l0B<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o1H400on1P@0;P@03oh6100?o01jkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0Y^l^kbk_;odc6C?m<ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk/00ol<P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`J11?l2P@09ol^kbk_;^l_o0080
00?o00000P02oc80000E0003o`0000T000?o^k/00k/00on1P@06P@?o0h400onk^`0^^`;o4[/3o`R1
00?oPH402h42oajk0ol2C003ok^k00Bk0olK^`Co0X400on1P@0:P@03ok^k01Vk00?oPH400ol7P@03
ok^k00Bk00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F10_l7P@0]ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o01Beok_;^l^kbk_;^l^kbk_;
^l^ko`b100?oPH401X43o`0QPOnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00I<027o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol7P@03oh6100Z101co^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0_l;P@08ol^kbk_;^ol20003o`0000<000?o0000;`0001L000?o00002@02o`Bk
00?oPOl00_l:P@03ok^k02Rk00?o]KD00kD00onk^`0?^`03oh6100Z100?oPH400h42o`F100?o^k/0
5;/2o`Fk00?oC4`01D`00onk^`0J^`?o2h400on1P@08P@03oh7o01Zk00?oPH402X400onk^`05^`04
o`00o`@000?o0000;`0001P000?o00002P001_o;^l^ko`j104Cobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol=]@feok_;^l^kbk_;^l^kbk_;^l^ko`b100?oPOl00_l8P@0C
ok_;^l^kbk_;^l^kbk_;^l^kb`03o`09C4go^l^kbk_o009<0ol06l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03o`03POn100b100?oPH401843o`0O^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
o`0<P@09ok_;^l^kbk_o008000?o00000P000ol0000^00006@000ol0000:0003ok^k00>k00?oPH40
2h400onk^`0Y^`06okFeokGo4K/00on1P@0:P@03oh6100Z100?o^k/03[/00om<C004C003ok^k00>k
0_lK^`?o1H400on1P@0;P@03oh6100?o8[/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0000]0000
6P02o`/000Oobk_;^l_o00f102cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X43o`>100?oPH402X40=onkbk_;^l^kbk_;^l^k
bk_;oda=C4e<COnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol9P@03oh6100^10_l09k_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`07P@?o00Z1ol^kbk_;^l_o0P000ol0
000200;o;P0001`000?o00002@000onk^`03^`;o2842o`:100?o^k/0@;/00on1P@03o`N100?oPH40
2X400onk^`0>^`03odco00;o7K/3o`f100?oPH401X43obVk00?oPH400h42o`F100?o^k/01K/01?l0
0?l300;o;P0001d000?o00002@002?o;^l^kbk_o1843o`F1033obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0@bk_;^l^kbk_;^l^kbk_;^`;o2h400on1P@0:P@0_
ok_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol3P@03oh6100Z1
00?oPH400h43o`0_^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^koh40
0ol8P@08ol^kbk_;^ol20003o`0000<000?o0000:`0001h000?o00002@000onk^`04^`04oh7oo`V1
00?o^k/0:K/3o`04]@feoa2k00?oPH402X400on1P@04P@?o;[/3o`N100?oPH402X400on1o`02obnk
0ol<P@03ok^k00Bk00Co003o1@000ol0000Z00007`000ol000090008ol^kbk_;^ol<P@0/ol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6]@0Bol^kbk_;^l^kbk_;^l^kbk_o
38400on1P@03o`0L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o013;^l^kbk_;^l^kbk_;^l^k
0_l;P@03oh6100Z102oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`04o`9K00?oPH402h402?o;^l^kbk_o0P000ol000020003o`0002X0000P0003o`0000T00_l5^`03
oh6100Z100?o^k/0:;/02?l=]@fe3KGo4;/00on1P@0:P@;o7;/3o`04C4e<o`nk00?oPH402h400on1
P@04P@?o;[/3o`MK00?oPH402h400onk^`03^`05o`000?l010000ol0000Y00008@02o`/000Oo^l^k
bk_o00b102gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kokD00ol05;_;
^l^kbk_;^l^kbk_;^l^kbk_o1X43o`0hbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;oda=
C4e<ol^kbk_;^l^kbk_;^l^kbol=P@03oh6100?o02fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/01?l;F`03oh6100J10ol02H7o^l^kbk_;o`020003o`0000<000?o0000
:00002<000?o00002@000onk^`03^`03oh6100Z10_lY^`03ok^k01Fk00?oPH400olU^`07oda=C?m<
o`0?^`03oh6100^10_l/^`Co0U/00omKF`0:F`03oh6100>10ol5P@03ok^k00Bk00Co003o0`02obX0
000T0003o`0000T000Oo^l^kbk_o00J10ol4P@0`ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^k0_l04<^kbk_;^l^kbk_;^l^kbk/2o`0Fbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`?o012kbk_;^l^kbk_;^l^kbk_;0ol05<^kbk_;^l^kbk_;^l^kbk_;^l_o1X44o`:102_o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o1e/00omKF`0:F`03oh7o00;o
2H402?nkbk_;^l_o0P000ol000020003o`0000D00ol300?o6@0002D000?o00002@000onk^`03^`03
oh6100?o28400onk^`0Y^`?o00?l]Ol09;/3o`:100?o^k/09K/00on1P@03o`N100?o^k/08k/4o`]K
00?oFe/025/00omKo`0<P@03ok^k00Bk00Co003o1@000ol000050003o`0000D000?o00005P0002H0
00?o00002@001_nkbk_;^`;o3840D_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ool]Obeo;Gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`J101Gobk_;^l^kbk_;
^l^kbk_;^l^kbk/01?l03l^kbk_;^l^kbk_;^l^kb`02o`^102;o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k0ol2F`03oe]K00YK00?oFe/015/4o`9K00?oPH402h402?o;^l^kbk_o0P000ol0
00020003o`0000D000?o00001@000ol0000F00009`000ol000090003ok^k00Bk00?oPH402X400onk
^`0W^`08oobeo;Gl]OlK^`Co2X400onk^`0>^`?o0dd00onk^`0>^`03oh6100Z100?o^k/06k/3o`IK
00?oFe/02U/00omKF`03o`MK00?oPH402h400onk^`04^`04o`00o`@000?o000010000ol0000200?o
6@0002P000?o00002@02o`06bk_;^l_o3840;?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ool0ol06[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol2P@03oh6100Z102Wobk_;
^l^kbk_;^l^kbk_;^om=C4e<COnkbk_;^l^kbk_;^l^kbk_;o`0<P@0Jok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/3o`YK00?oFe/025/01?mKool;F`03oh6100J10ol02H7o^l^kbk_;o`020003o`000080
0_l50003o`00008000?o00006@0002T00_l;0003ok^k00>k00?oPH402X400onk^`0W^`03ok^k01Rk
0ol6P@03oh6100Z100?o^k/03[/01om=CDgoCOl04;/00on1P@0:P@03ok^k01>k0ol00e_oF`0;F`03
oe]K00AK0ol2^`03oe]K00]K00?oPH400h42o`F100?o^k/01;/01?l00?l20003o`3o00@00_l400Co
600002/000?o00002@001oo;^l^kbol01X43o`>1033o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2o`0@bk_;^l^kbk_;^l^kbk_;^`;o2X400on1P@08P@0Coh7obk_;
^l^kbk_;^l^kbk_;^`03o`0E^l^kbk_;^l^kbk_;^l^kbk_;^l_o00J10ol2P@0Col^kbk_;^l^kbk_;
^l^kbk_;^`03o`EK00?oFe/02U/00omKF`03o`07^l^kbk_;o`0=F`03oh7o00;o28402?nkbk_;^l_o
0P000ol000020003o`0002<0000/0003o`0000T000?o^k/00k/00on1P@03o`N100?o^k/0:K/3o`:f
00?o^k/03[/00on1P@09P@03oh6100B10ol3P@03ok^k02Fk00?oPH400ol6P@03ok^k00bk0ol9F`03
oe]K00QK00CoFooo2[/00omKF`0;F`03oh6100V100?o^k/01;/01?l00?l50003o`000280000]0003
o`0000T000Kobk_;^l/2o`^104?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o][Ff]KJeol^kbk_;^l^kbk_;^l^kbk_o00^100?oPH400ol7P@0Eol^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o012kbk_;^l^kbk_;^l^kbk_;0_l:P@0;ol^kbk_;^l^kbk/00ol<F`03oe]K00AK1?l04<^k
bk_;^l^kbk_;^l^kbol6F`Co00?;^ol038402?o;^l^kbk_o0P000ol000030003o`000240000^0003
o`0000T000?o^k/01;/00on1P@09P@03ok^k02Nk00?o][H01;H00onk^`0>^`03oh6100V10_l;P@03
ok^k00jk0ol014e<COl?^`03oh6100Z100?o^k/01;/3o`9K00?oFe/02e/00omKF`03oaBk00?oFe/0
0ol3^`;o0[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000Q0000;`000ol000090008ol^kbk_;
^ol;P@0/ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kokH3o`0D^l^kbk_;
^l^kbk_;^l^kbk_;^ol6P@?o0X400on1P@0:P@0Xol^kbk_;^l^kbk_;^l^kbk_oC4e<CDco^l^kbk_;
^l^kbk_;^l^ko`b100?obk/00ol6F`03oe]K00]K0_l06;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o
00>kbk/00ol01Yoo^l^ko`N10ol02X7o^l^kbk_;^ol20003o`00008000?o00008000030000?o0000
2@02o`Fk00?oPH402H42obRk00?o^k/05K/00on1P@03o`J100?oPH402X400onk^`0>^`07ode<COm=
o`09^`Co0[/00on1P@08P@04oh7oo`YK00?oFe/01U/3oank00?oWil00il01?nk^ol5P@;o1H400onk
^`04^`04o`00o`<000?o0?l08@0003400_l;0007ok_;^l^ko`06P@?o0h40;oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o013;^l^kbk_;^l^kbk_;^l^k0_l:P@03
oh6100Z1017obk_;^l^kbk_;^l^kbk_;^`03o`09^l^kbk_;^l^k00?o14d01?o;^ol6P@?o0X400omK
F`0:F`03oe]K00=K0_l06k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`06bk_;^l_o1Yl01Onk
bon100?o28402?nkbk_;^l_o0P000ol000020003o`0001l0000c0003o`0000T000?o^k/00k/00on1
P@03o`N100?o^k/0:;/3o`:f00?o^k/03K/00on1P@0:P@03oh6100B10olP^`03ode=00A=00Co^k_o
0X43o`J100?oFe/02U/00omKo`02oaZk0ol00ilAo`05^`03oioo00;o1K/00on1P@0:P@03ok^k00Bk
00Co003o10000ol0000N0000=0000ol000090006ok_;^l^k0_l;P@11ol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o]_bfo;Klol^kbk_;^l^kbk_;^l^kbol038400on1P@03o`0K
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o00S;^l^kbk_oC@?o00Fkbk_;^`02o`Z100?oFe/0
25/08?mKol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1Q404?o;^l^kboo;^l^kbk_;^ol=P@07
ok_;^l^ko`020003o`0000<000?o00007@0003D000?o00002@000onk^`03^`03oh6100Z100?o^k/0
9k/00onf]P03]P03ok^k00fk00?oPH4028401?n1oolK^`?o00A=C4go1[/00onk^`06^`03oh6100Z1
00?oFe/015/3o`=K00?o^k/04k/2o`Bk00Wo4IlAWa6O4Ol02K/3o`:k00?oPH402h400onk^`03^`04
o`00o`@000?o00007@0003H000?o00002@001onkbk_;^ol03840:_o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol3P@0Nok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1Dd03?o;^l^kbk_;^l^kb`;o00>kbol038400omKF`03o`MK
01;obk_;^l^kbk_;^l^kbk_;^l/3o`084Oo;^l^kbol24@?o00Rkbk_;^l^kb`?o0Yl01Onkbk_o00J1
1?l2P@08ol^kbk_;^ol20004o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z10_ln^`03
oh6100?o1h400onk^`0J^`07ode<COm=o`07^`?o00=VCOl00[/00on1P@08P@04oh7oo`]K00?o^k/0
3K/00olG5`035`03ok^k00>k0_l;^`07oioOWmnOo`03^`03oh6100?o1h400onk^`03^`04o`00o`D0
00?o00006`0003P00_l:00;o00G;^l^ko`06P@?o1840;Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`0?bk_;^l^kbk_;^l^kbk_;00;o2h407Onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?o01C;^l^kbk_;^l_oCFI=ITeVok_;o`J10ol01;_;^ol<F`0@ol^kbk_;
^l^kbk_;^l^ko`HA01Cobk_;^l^kbk_;^l^kbk_;^l^ko`>O00KoWonkbk/2o`^100Oobk_;^l_o0080
00?o00000P000ol0000K0000>P000ol000090003ok^k00:k00?oPH400ol8P@03ok^k02Jk0ol01;Jg
]_l?^`03oh6100Z100?o^k/09[/02?mVCFI=ITgo0[/00on1P@03o`Nk00?oFe/02U/00onk^`0<^`03
oaOo00;o5K/3o`Jk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o00002@001Oo;
^l^k00;o3840@?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;okJg][Nfol^k
bk_;^l^kbk_;^l^kbol<P@0[ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
C@03o`05bk_;^l/00_l03;_;^l^kbk_;^l^ko`IK0ol2F`0dok_;^l^kbk_;^l^kbk_;^onkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`b100[o^l^kbk_;o`3o1@000ol0000I0000?0000ol0
00090003ok^k00>k00?oPH402X400onk^`0V^`07okJg]_nfo`0?^`03oh6100Z100?o^k/09[/00onk
^`0D^`03oe]K00?o1U/00onk^`0B^`;o5[/4o`:k00?oPH4028400on1o`05^`04o`00o`@000?o0000
6@0003d000?o00002@001_o;^l^kb`;o2h40:Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol3P@0^ok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o013;^l^kbk_;^l^kbk_;^l^k0_l:F`0Aok_;^l^k
bk_;^l^kbk_;^l/00ol05ALAok_;^l^kbk_;^l^kbk_;^l^kb`03o`07gioOWonko`06P@Co0X402?o;
^l^kbk_o0P001?l00002oaX0000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0/^`;o
3[/00on1P@03o`N100?o^k/09k/3o`9>00?o^k/03K/00omKF`09F`03ok^k00fk00So5a4G4ALAoa6k
00?oWil01Il00onko`02P@?o1h400onk^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;
^l^kbk_o0X43o`J102_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o
016g]_nkbk_;^l^kbk_;^l^kb`02o`^1043o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kofI=ITeVCOo;^l^kbk_;^l^kbk_;^l_o2e/0;?o;^l^kbk_;^l^kbk_;^l^koa4G4ALAok_;
^l^kbk_;^l^kbk_;^l^koioO0ol01<^kbk/2o`^100Oobk_;^l_o008000?o00000`000ol0000F0000
@002o`X000?o^k/01;/2o`Z100?o^k/09[/00onf]P04]P03ok^k00bk00?oPH402X400onk^`0V^`03
odi>00=>00?o^k/03K/00omKF`07F`03oe_o012k0olE^`;o1k/00on1P@0:P@03ok^k00Bk00Co003o
10000ol0000F0000@P000ol0000800;o00Jkbk_;^ol;P@10ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o]kJg][Nfok_;^l^kbk_;^l^kbk_;o`b102Wo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0Cbk_;^l^kbk_;^l^kbk_;^l^ko`06F`?o0U/0<?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00?;oh402h402?nk
bk_;^l_o0P000ol000020003o`0001D000130003o`0000T000?o^k/00k/00on1P@09P@03ok^k02Jk
00?o]_l00_lA^`03oh6100B10ol2P@03ok^k03bk00?oFe/00ol6F`03ok^k01:k0olD^`?o00GOok^k
o`0:P@03oh7o00Fk00Co003o1@000ol0000D0000A0000ol000090007ok_;^l^ko`0;P@;o03k;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;o`:1
0ol6P@0mol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`04o`YK017o^l^kbk_;^l^kbk_;^l^kb`03o`8G01Go^l^kbk_;^l^kbk_;^l^kbk_;^ol0
1Ml00onko`06P@Co0X402?o;^l^kbk_o0P001?l00002oaH000150003o`0000T000?o^k/00k/00on1
P@04P@?o0h400onk^`0Z^`;o3k/2o`Z100?o^k/0=[/3o`9K00?oFe/02U/00onk^`0=^`07oaMO5elG
o`0;^`;o1K/02_nOgioOWmoo^ol2P@?o1h400onk^`04^`04o`00o`@000?o00004`0004H000?o0000
2@001onkbk_;^ol00X43o`N102[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l/2o`0C][Oobk_;^l^kbk_;^l^kbk_;o`0;P@0eol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol6F`03oe]K00YK017o^l^kbk_;^l^kbk_;^l^ko`035`0:
oaOo^l^kbk_;^`?o00[Ook_;^l^kbooO0ol00l^ko`03o`^100[obk_;^l^ko`3o0`03oa@000170003
o`0000T000?o^k/00k/2o`^100?o^k/09K/01ong][Nf]ol03k/00on1P@09P@03ok^k02jk0ol:F`03
oe]K00QK00?oFol03k/3o`Vk00?ogml00ml00onk^`04^`03ok^k00?o0X400on1P@0;P@03ok^k00>k
00?o00000ol20003o`000180001800;o2P002?nkbk_;^l_o2h408Oo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`02o`0Lbk_;^l_o]kJg][Oobk_;^l^kbk_;^l^kbk_;o`^10_l0:k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00ol2F`03oe]K00UK00?oFe/015/3o`0H
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l01K_;^l_o00KO00Ko^l^kbk/3o`J100?oPH402h401_o;
^l^kb`;o00<0o`000P000ol0000B0000BP000ol0000800;o1K/00on1P@09P@03ok^k01Zk0ol00kO/
o`05^`?o4k/00on1P@04P@?o0h400onk^`0U^`?o1U/00omKF`09F`03oe]K00?o6;/3o`03Gonk00Bk
00?ogol00_l3^`Co2X400on1P@04P@Co2K/00ol0o`030003o`000180001;0003o`0000T000Oobk_;
^l_o00J10ol2P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`Jg01gobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`02P@?o1h408onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co
2U/00omKF`07F`0Ooe_ook_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`05G`0:ol^kbk_;ol^kb`?o
0X400on1P@0:P@03oh6100?o00Rkbk_;^l^kb`?o1@001?l00?lD0000C0000ol000090003ok^k00>k
00?oPH400ol6P@03ok^k016k0ol5^`07onbgk;O/o`0K^`;o2h400onk^`0L^`?o0U/00omKF`0:F`04
oe]KF`Go6;/2o`Fk00?oGel00el00onk^`03^`?o1X400on1P@0:P@;o1k/4o`T000Co003o4`0004d0
00?o00002@001_o;^l^kb`;o2X404?o;^l^kbk_;^l^kbk_;^l/3o`;/00Oo^l^kbk_;00?o023;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`b101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/0
0ol6F`03oe]K00YK0ol06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol021oo^l^kbk_;0ol01<^k
bk/4o`Z100?oPH401843o`08bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk^`03^`03
oh6100V100?o^k/03K/01_o/g>cLobRk00?oPH402X400onk^`0E^`;o2U/00omKF`04F`?o7[/01olO
GamO7ol01k/5o`:100?oPH402X400on1P@03o`Nk1?lA0003o`3o01<0001?00;o2P001oo;^l^kbol0
2h404Oo;^l^kbk_;^l^kbk_;^l_o00;/02cok?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;o`J10ol2P@0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol;F`03oe]K00?o01_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l03K_;^l^koamO7elOok/01Ol8P@03oh6100Z10_l01l^k
bk_;^l/00olF00;o4`00054000?o000020000onk^`03^`03oh6100V10_l>^`;o;;/00on1P@03o`J1
00?o^k/05[/00omKF`09F`;o6k/3o`037onk00Fk0ol01;_oool2P@03oh6100V100?oPH401843o`Nk
1?lH00?o4`00058000?o00002002o`05^l^kbol01X43o`>101Co^l^kbk_;^l^kbk_;^l^kbk_;^`;o
02O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l:P@0Jol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^ol6F`?o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol5G`07ol^kbk_;
^`03o`J100?oPH402H400on1P@03o`07^l^kbk_;^`03oaT00olF0000D`000ol000090003ok^k00:k
00?oPH400ol7P@03ok^k00jk0_l00ncLo`0V^`03oh6100Z100?o^k/05[/00omKF`03oaVk0ol5^`03
oalO00<O00?o^ol00ol:P@03oh6100N100CoPOoo1[/4oaP01?lI0000E0000ol000090005ok_;^l/0
0_l;P@0mok_;^l^kbk_;^l^kbk_;oncLk=c/ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ko`0<P@07ol^kbk_;^`04o`0>bk_;^l^kbk_;^l^kbk/2o`0Ibk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`03o`<O00Kobk_;^l/3o`04boooo`:100?oPH402H400on1P@04P@?o00O;^l^kbk_;00?o
6@03oad0001E0003o`0000T000?o^k/00k/00on1P@09P@03ok^k00bk00Oog>cLk=co02Jk00?oPH40
28400on1o`02^`?o00EaUG6Eo`0Y^`03oemO00=O00?o^k/00k/3o`J100?oPH402H400on1P@03o`Jk
1?lH00Co800005H000?o00002@001onkbk_;^ol02h42o`0=bk_;^l^kbk_;^l^kb`03o`0[bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@?o02o;^l^kbk_oLMeagG7Mol^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`06bk_;^l_o0al00olOo`04o`Z100?oPH40
1h402_n1ooo;^l^kbk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o0h400onk^`0h^`03
oh6100?o0[/3o`Fk00?oLOl00_lP^`?o00@OGaoo1K/6o`:100?oPH402H400on1P@04P@?o1[/4oaP0
0olX0000F@000ol000080007ok_;^l^ko`02P@?o1h404_o;^l^kbk_;^l^kbk_;^l^kb`Co02Fkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o00?;^ol00_l0>MfEgOnkbk_;^onkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^omO7elOGaoobk_;^`03o`J100?oPH402H400on1
P@03o`06^l^kbk_;0olH00Co:`0005X000?o000020000onk^`03^`;o2h400onk^`0;^`?o1>`00onk
^`0V^`03omgM00CM00?o^k/01k/3oaFk0ol5^`03oeoo00;o0k/3o`Z100?oPH401h401?n1ool5^`Co
6003obl0001K0003o`0000P00_l01/^kbk_;o`^103Kobk_;^l^kbk_;^l^kbooLk=c/g>co^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`06^l^kbonE0ol00l^kb`03o`03bk_o00;o0W404oo;
^l^kbk_;^l^kbk_;^l^kbk/00ol38`0:ok_;^l^kok_;^`?o0X400on1P@09P@04oh61P@Go00K;^l^k
bk/3oaP01?lb0000G0000ol000090003ok^k00>k00?oPH402H400onk^`0;^`03onco00;o8;/2o`BE
00?o^k/00[/01?nk^k/3o`>100Wo^k_oLMeagOl02k/2o`Bk00?o8b<012<00onk^`03^`?o1X400on1
P@09P@?o1k/4oaP00olf0000G@000ol000090007ol^kbk_;o`06P@?o0X40;?o;^l^kbk_;^l^kbk_;
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l01[_;^l^ko`FE00Go^l^kb`03o`N100Cobk_o
0W402omaol^kbk_;^l^k00;o00Uag_nkbk_;ob<00ol00l^kb`04o`Z100?oPH401843o`08^l^kbk_;
^l/3oaP01?li0000GP000ol000090003ok^k00>k00?oPH400ol6P@03ok^k00nk1?lB^`?o00?Lok/0
1K/3o`Fk0_l;P@03ok^k00;o2[/00ooNgP03gP03ok^k00:k00Co^k^k0ol2P@03oh6100Z100?oPH40
0ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o2X403oo;^l^kbk_;^l^kbk_;^`02o`0[g;OL]onk
bk_;^l^kbk_;^l^kbk_;oiGLUMbEol^kbk_;^l^kbk_;^l^ko`0<P@08ol^kbk_;^l/2o`0@^l^kbk_o
gW7NLMko^l^kb`?o1X400on1P@0:P@;o00Nkbk_;^l^k00?o6004od00001Q0003o`0000P000?o^k/0
0k/00on1P@09P@03ok^k00^k00Sog>cLk=c/o`Vk0ol5^`06oiGLUMco3[/00on1P@0:P@04ok^k^`?o
00=aok/01K/3o`>k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P000Oobk_;^l_o00^1
0_l03[_;^l^kbk_;^l^kbooL0ol02<^kbk_;^l^k0ol02IGLol^kbk_;^`02o`0Cbk_;^l^kbk_;^l^k
bk_;^l^ko`06P@?o0X404?nkbomagW7NLOo;^l^kbk/5o`>100?oPH402H400on1P@03o`07bk_;^l^k
b`03oaP01?m70000H`000ol0000800;o1;/00on1P@04P@?o0h400onk^`0:^`03ok^k00Zk00Kog9GL
UOlJ^`03oh6100?o1X402onk^k_ogW7NLOnk00Co2H400on1P@09P@;o1[/4oaL01?m;0000I0000ol0
00090006ok_;^l_o0X43o`N101;o^l^kbk_;^l^kbk_;^l^kbk/3o`0U^l^kbk_oUMcog?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`Z100Co^l^k0_l01<_oool2P@03oh6100V100?oPH401843o`06
bk_;^l^k0olH00?oC`0006D000?o00002@000onk^`02^`;o2h400onk^`0;^`?o0m`00onk^`03^`;o
7[/00on1P@09P@03ok^k00?o1X400on1P@09P@03oh6100?o1K/4oaL01?mB0000IP000ol000090007
ok_;^l^ko`0;P@0?ok_;^l^kbk_;^l^kbk_o00GL02Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol02h42o`Z100?oPH401h402?n1ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k
00?oPH402H400onk^`0;^`04omcoobRk00?oPH401843o`:100?oPH402H401?n1PH45o`Fk0olH00Co
F@0006T000?o000020001onkbk_;^ol01X43o`:103_o^l^kbk_;^l^kbk_;^onkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02P@?o1X400on1P@09P@?o00Jkbk_;^l/4oaP0
0omM0000JP000ol000080003ok^k00>k00?oPH400ol6P@03ok^k03Fk1?l:P@03oh6100B10ol7^`?o
6004of00001[0003o`0000P00_l01<^kbk/2o`Z103;o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Go18400on1P@08P@03oh6100?o00K;^l^kbk/4oaP00omT0000
K0000ol000090003ok^k00:k00?oPH402H400onk^`0[^`?o2X400on1P@08P@;o1[/3oaP01?mW0000
K@000ol000090006ol^kbk_o2h40:_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`?o0X400on1P@09P@03oh6100Go00Jkbk_;^l/4oaP00om[0000KP02o`X000?o^k/00[/00on1
P@04P@?o0X400onk^`0S^`?o1X400on1P@09P@;o2;/3oaP01?m^0000L0000ol000080006ol^kbk_o
0X43o`J1027o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l:P@03oh6100B10ol01k_;
^l^kbk/01?lG00CoLP00074000?o000020000onk^`02^`;o2X400onk^`0H^`Go0h400on1P@09P@03
oh6100?o1k/3oaP00omf0000LP000ol000080007ol^kbk_;o`0:P@0Gok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00ol9P@03oh6100V10_l01[_;^l^kb`Co5`04ogT0001c0003o`0000P00_l4^`03oh6100R1
00?o^k/04;/3o`:100?oPH4028400on1P@04P@?o1[/3oaP00omm0000M0000ol000090006ok_;^l_o
0X45o`>100oo^l^kbk_;^l^kbk_;^l/00ol6P@03oh6100R100?oPH400ol01K_;^l^k00Co5`04oh00
001e0003o`0000T000?o^k/00[/2o`V100?o^k/02;/3o`Z100?oPH401X401?n1ool5^`?o6003oh@0
001f00;o2P001onkbk_;^ol02H401onkbk_;^l/00ol2P@03oh6100V100?oPH401Ol01L^kbk_;00Co
5`04ohL0001h0003o`0000P000?o^k/00k/00on1P@07P@03ok^k00?o1X400on1P@09P@;o1k/3oaP0
0on;0000N@000ol000080007ok_;^l^ko`07P@04oh7oo`Z100?oPH401843o`06bk_;^l^k1?lG00Co
SP0007X000?o000020000onk^`03^`03oh6100Co18400on1P@08P@03oh6100?o1[/3oaP00onB0000
N`000ol000080006ok_;^l^k0_l9P@03oh6100R10_l01L^kbk_;00Co5`04oiD0001l0003o`0000P0
0_l4^`03oh6100R100?oPH401Ol6^`?o5`04oiT0001m0003o`0000T000Kobk_;^ol:P@;o00Nkbk_;
^l^k00Co5`03oid0001n00;o2P000onk^`02^`03oh6100>10ol7^`?o5`04oj0000200003o`0000P0
00Oobk_;^on100?o00Jkbk_;^l/4oaL00onT0000P@000ol000080003ok^k00:k00?o^k/01;/3oaL0
1?nW0000PP000ol000080007ol^kbk_;^`04oaL00on[0000P`000ol000080003ok^k00?o5`04ojh0
00240003o`0000L00olG00?o/P0008D00_l70003o`0001<01?ne0000Q`000ol000040003o`000100
0oni0000R0000ol000030003o`0000`01?nl0000R@001Ol0003o00/01?o00000RP001?l00?l800?o
a00008/000?o0?l01004olL0002<00;o00@0oooob`0008d00_o>0000o`1N0000o`1N0000o`1N0000
o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000TP000ol0000W0003
o`0009h0001]00Co0`04o`040?oo00;o0P02o`<01?l200Co0`000ol0000800Go00@0ool00_l200Go
00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`<00ol300?o1002ofl0001/0005o`000?l0
0P000ol000030004o`00o`<00_l40003o`0000<000?o000010000ol000090005o`000?l00P001?l0
0?l30003o`0000;o10000ol000040003o`0000L000?o00001@000ol000020004o`00o`800_l60003
o`0000<000Co00000_m_0000K0000ol0o`02o`801Ol01@3o003o00X000?o00000`000ol0000?0005
o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003o`00008000?o00002`000ol0
00030003o`000780001/0003o`0000@000Oo0000o`3o008000?o00002@000ol000030003o`0000h0
00Go0000o`020004o`00o`<000?o00001P000ol0000>00?o1@000ol000020003o`0000T00_l400;o
M@0006`000Go0000o`0300?o00<0ool00ol80004o`00o`8000Co003o40000ol00005o`<01?l80003
o`0000h000?o00001002o`<01?l;0003o`0000<000?o0000LP0006d01?lE00;o1002o`l01Ol;0003
o`0000D00_l?00Go2@000ol0000800?o0`03ogD0002/00;o8@000ol000020003o`0008H0003o05h0
0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 22"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 19",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 35",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 35", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.218927 1.463413 0.02132 0.95481 [
[(Gen.35, Ind.1, Fit.34.)] .5 1 0 -1.5 Msboxa
[(5)] .22082 .11893 .84808 1 Msboxa
[(10)] .373 .0797 .79153 1 Msboxa
[(15)] .53046 .03912 .73498 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30054 .03702 .79718 1 Msboxa
P
[(5)] .71997 .07992 -1 .38123 Msboxa
[(10)] .7966 .1513 -1 .36664 Msboxa
[(15)] .8687 .21847 -1 .35312 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87498 .12375 -1 .36805 Msboxa
P
[(0)] .0963 .1754 1 -0.39162 Msboxa
[(10)] .07472 .34977 1 -0.36214 Msboxa
[(20)] .0507 .54389 1 -0.32915 Msboxa
[(30)] .02381 .76131 1 -0.29198 Msboxa
[(t)] -0.02452 .47235 1 -0.34463 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.35, Ind.1, Fit.34.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.1149 .15829 m
.63809 .02387 L
s
P
p
.002 w
.23266 .12803 m
.23857 .13258 L
s
P
[(5)] .22082 .11893 .84808 1 Mshowa
p
.002 w
.38436 .08906 m
.39003 .09374 L
s
P
[(10)] .373 .0797 .79153 1 Mshowa
p
.002 w
.5413 .04874 m
.54671 .05355 L
s
P
[(15)] .53046 .03912 .73498 1 Mshowa
p
.001 w
.26259 .12034 m
.26611 .12309 L
s
P
p
.001 w
.29272 .1126 m
.29622 .11536 L
s
P
p
.001 w
.32306 .10481 m
.32653 .10758 L
s
P
p
.001 w
.35361 .09696 m
.35704 .09975 L
s
P
p
.001 w
.41532 .0811 m
.41869 .08393 L
s
P
p
.001 w
.44649 .0731 m
.44983 .07593 L
s
P
p
.001 w
.47787 .06503 m
.48119 .06789 L
s
P
p
.001 w
.50948 .05691 m
.51276 .05978 L
s
P
p
.001 w
.20292 .13567 m
.2065 .13839 L
s
P
p
.001 w
.17339 .14326 m
.17699 .14596 L
s
P
p
.001 w
.14404 .1508 m
.14767 .15348 L
s
P
p
.001 w
.57334 .04051 m
.57655 .04341 L
s
P
p
.001 w
.6056 .03222 m
.60878 .03513 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30054 .03702 .79718 1 Mshowa
P
P
p
p
.002 w
.63809 .02387 m
.89266 .2608 L
s
P
p
.002 w
.70288 .08417 m
.69433 .0863 L
s
P
[(5)] .71997 .07992 -1 .38123 Mshowa
p
.002 w
.77943 .15541 m
.77084 .15747 L
s
P
[(10)] .7966 .1513 -1 .36664 Mshowa
p
.002 w
.85145 .22245 m
.84283 .22443 L
s
P
[(15)] .8687 .21847 -1 .35312 Mshowa
p
.001 w
.71857 .09877 m
.71344 .10004 L
s
P
p
.001 w
.73407 .1132 m
.72893 .11446 L
s
P
p
.001 w
.74937 .12744 m
.74423 .12869 L
s
P
p
.001 w
.76449 .14151 m
.75935 .14275 L
s
P
p
.001 w
.79418 .16914 m
.78902 .17037 L
s
P
p
.001 w
.80876 .18271 m
.8036 .18393 L
s
P
p
.001 w
.82316 .19611 m
.81799 .19732 L
s
P
p
.001 w
.83739 .20936 m
.83222 .21056 L
s
P
p
.001 w
.68699 .06938 m
.68187 .07067 L
s
P
p
.001 w
.6709 .0544 m
.66578 .0557 L
s
P
p
.001 w
.6546 .03923 m
.64948 .04054 L
s
P
p
.001 w
.86535 .23538 m
.86017 .23656 L
s
P
p
.001 w
.87909 .24816 m
.8739 .24934 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87498 .12375 -1 .36805 Mshowa
P
P
p
p
.002 w
.1149 .15829 m
.03659 .79698 L
s
P
p
.002 w
.11333 .17104 m
.12185 .16887 L
s
P
[(0)] .0963 .1754 1 -0.39162 Mshowa
p
.002 w
.09192 .34571 m
.10052 .34368 L
s
P
[(10)] .07472 .34977 1 -0.36214 Mshowa
p
.002 w
.06807 .54016 m
.07676 .53829 L
s
P
[(20)] .0507 .54389 1 -0.32915 Mshowa
p
.002 w
.04137 .75797 m
.05015 .7563 L
s
P
[(30)] .02381 .76131 1 -0.29198 Mshowa
p
.001 w
.10922 .20454 m
.11434 .20325 L
s
P
p
.001 w
.10503 .23873 m
.11016 .23746 L
s
P
p
.001 w
.10075 .27364 m
.10589 .27239 L
s
P
p
.001 w
.09638 .30929 m
.10153 .30805 L
s
P
p
.001 w
.08735 .38291 m
.09252 .38171 L
s
P
p
.001 w
.08269 .42093 m
.08787 .41975 L
s
P
p
.001 w
.07793 .45979 m
.08312 .45863 L
s
P
p
.001 w
.07306 .49953 m
.07826 .49839 L
s
P
p
.001 w
.06298 .58172 m
.0682 .58063 L
s
P
p
.001 w
.05776 .62425 m
.063 .62318 L
s
P
p
.001 w
.05243 .66778 m
.05767 .66673 L
s
P
p
.001 w
.04696 .71234 m
.05222 .71131 L
s
P
[(t)] -0.02452 .47235 1 -0.34463 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11333 .17104 m
.40519 .3829 L
s
P
p
.4 g
.002 w
.09192 .34571 m
.39999 .55059 L
s
P
p
.4 g
.002 w
.06807 .54016 m
.39427 .7353 L
s
P
p
.4 g
.002 w
.04137 .75797 m
.38793 .93978 L
s
P
p
.4 g
.002 w
.18857 .2121 m
.12657 .84301 L
s
P
p
.4 g
.002 w
.27588 .27587 m
.23213 .89701 L
s
P
p
.4 g
.002 w
.3583 .33607 m
.33071 .94744 L
s
P
.002 w
.1149 .15829 m
.03659 .79698 L
s
.03659 .79698 m
.3868 .97613 L
s
.3868 .97613 m
.40557 .37059 L
s
.40557 .37059 m
.1149 .15829 L
s
.63809 .02387 m
.89266 .2608 L
s
.89266 .2608 m
.96341 .8843 L
s
.96341 .8843 m
.66452 .68009 L
s
.66452 .68009 m
.63809 .02387 L
s
.1149 .15829 m
.03659 .79698 L
s
.03659 .79698 m
.66452 .68009 L
s
.66452 .68009 m
.63809 .02387 L
s
.63809 .02387 m
.1149 .15829 L
s
p
.4 g
.51568 .34577 m
.5162 .95552 L
s
P
p
.4 g
.65711 .31389 m
.68322 .92892 L
s
P
p
.4 g
.80295 .28102 m
.8564 .90134 L
s
P
p
.4 g
.40519 .3829 m
.89409 .27336 L
s
P
p
.4 g
.39999 .55059 m
.91355 .44491 L
s
P
p
.4 g
.39427 .7353 m
.93512 .63492 L
s
P
p
.4 g
.38793 .93978 m
.95913 .84653 L
s
P
.40557 .37059 m
.89266 .2608 L
s
.89266 .2608 m
.96341 .8843 L
s
.96341 .8843 m
.3868 .97613 L
s
.3868 .97613 m
.40557 .37059 L
s
p
.4 g
.23266 .12803 m
.51568 .34577 L
s
P
p
.4 g
.38436 .08906 m
.65711 .31389 L
s
P
p
.4 g
.5413 .04874 m
.80295 .28102 L
s
P
p
.4 g
.18857 .2121 m
.70288 .08417 L
s
P
p
.4 g
.27588 .27587 m
.77943 .15541 L
s
P
p
.4 g
.3583 .33607 m
.85145 .22245 L
s
P
P
p
.002 w
.41109 .37416 m .41886 .37984 L .40519 .3829 L p
.4 g
F P
s
P
p
.002 w
.40519 .3829 m .39739 .37724 L .41109 .37416 L p
.4 g
F P
s
P
p
.002 w
.89409 .27336 m .40519 .3829 L .11333 .17104 L p
.9 g
F P
s
P
p
.002 w
.43257 .37677 m .41886 .37984 L p
.41109 .37416 L .4 g
F P
s
P
p
.002 w
.41109 .37416 m .39739 .37724 L .38955 .37155 L p
.4 g
F P
s
P
p
.002 w
.4386 .36798 m .44632 .37369 L .43257 .37677 L p
.4 g
F P
s
P
p
.002 w
.41109 .37416 m .4386 .36798 L p
.43257 .37677 L .4 g
F P
s
P
p
.002 w
.38955 .37155 m .38167 .36583 L p
.41109 .37416 L .4 g
F P
s
P
p
.002 w
.38167 .36583 m .39541 .36271 L .41109 .37416 L p
.4 g
F P
s
P
p
.002 w
.46011 .3706 m .44632 .37369 L p
.4386 .36798 L .4 g
F P
s
P
p
.002 w
.46628 .36175 m .47394 .3675 L .46011 .3706 L p
.4 g
F P
s
P
p
.002 w
.4386 .36798 m .46628 .36175 L p
.46011 .3706 L .4 g
F P
s
P
p
.002 w
.48782 .36439 m .47394 .3675 L p
.46628 .36175 L .4 g
F P
s
P
p
.002 w
.39541 .36271 m .38167 .36583 L .37374 .36007 L p
.4 g
F P
s
P
p
.002 w
.49412 .35549 m .50173 .36127 L .48782 .36439 L p
.4 g
F P
s
P
p
.002 w
.46628 .36175 m .49412 .35549 L p
.48782 .36439 L .4 g
F P
s
P
p
.002 w
.37374 .36007 m .36576 .35428 L p
.39541 .36271 L .4 g
F P
s
P
p
.002 w
.36576 .35428 m .37956 .35113 L .39541 .36271 L p
.4 g
F P
s
P
p
.002 w
.51569 .35814 m .50173 .36127 L p
.49412 .35549 L .4 g
F P
s
P
p
.002 w
.52214 .34919 m .52969 .35501 L .51569 .35814 L p
.4 g
F P
s
P
p
.002 w
.49412 .35549 m .52214 .34919 L p
.51569 .35814 L .4 g
F P
s
P
p
.002 w
.54374 .35186 m .52969 .35501 L p
.52214 .34919 L .4 g
F P
s
P
p
.002 w
.37956 .35113 m .36576 .35428 L .35774 .34846 L p
.4 g
F P
s
P
p
.002 w
.55032 .34285 m .55782 .3487 L .54374 .35186 L p
.4 g
F P
s
P
p
.002 w
.52214 .34919 m .55032 .34285 L p
.54374 .35186 L .4 g
F P
s
P
p
.002 w
.35774 .34846 m .34968 .34261 L p
.37956 .35113 L .4 g
F P
s
P
p
.002 w
.34968 .34261 m .36353 .33942 L .37956 .35113 L p
.4 g
F P
s
P
p
.002 w
.57195 .34554 m .55782 .3487 L p
.55032 .34285 L .4 g
F P
s
P
p
.002 w
.57868 .33647 m .58612 .34236 L .57195 .34554 L p
.4 g
F P
s
P
p
.002 w
.55032 .34285 m .57868 .33647 L p
.57195 .34554 L .4 g
F P
s
P
p
.002 w
.43518 .33844 m .40729 .34481 L .39136 .33302 L p
.8 g
F P
s
P
p
.002 w
.57868 .33647 m .55032 .34285 L .5352 .33105 L p
.4 g
F P
s
P
p
.002 w
.36353 .33942 m .34968 .34261 L .34157 .33672 L p
.4 g
F P
s
P
p
.002 w
.60034 .33918 m .58612 .34236 L p
.57868 .33647 L .4 g
F P
s
P
p
.002 w
.34157 .33672 m .33341 .3308 L p
.36353 .33942 L .4 g
F P
s
P
p
.002 w
.33341 .3308 m .34732 .32758 L .36353 .33942 L p
.4 g
F P
s
P
p
.002 w
.60722 .33006 m .6146 .33598 L .60034 .33918 L p
.4 g
F P
s
P
p
.002 w
.57868 .33647 m .60722 .33006 L p
.60034 .33918 L .4 g
F P
s
P
p
.002 w
.46325 .33204 m .43518 .33844 L .41937 .32659 L p
.8 g
F P
s
P
p
.002 w
.39136 .33302 m .41937 .32659 L .43518 .33844 L p
.8 g
F P
s
P
p
.002 w
.5352 .33105 m .56367 .3246 L .57868 .33647 L p
.4 g
F P
s
P
p
.002 w
.6289 .33278 m .6146 .33598 L p
.60722 .33006 L .4 g
F P
s
P
p
.002 w
.41937 .32659 m .39136 .33302 L .37526 .32111 L p
.8 g
F P
s
P
p
.002 w
.63593 .3236 m .64325 .32956 L .6289 .33278 L p
.4 g
F P
s
P
p
.002 w
.60722 .33006 m .63593 .3236 L p
.6289 .33278 L .4 g
F P
s
P
p
.002 w
.41937 .32659 m .44755 .32011 L .46325 .33204 L p
.8 g
F P
s
P
p
.002 w
.56367 .3246 m .5352 .33105 L .5199 .31911 L p
.4 g
F P
s
P
p
.002 w
.34732 .32758 m .33341 .3308 L .32521 .32485 L p
.4 g
F P
s
P
p
.002 w
.65764 .32634 m .64325 .32956 L p
.63593 .3236 L .4 g
F P
s
P
p
.002 w
.32521 .32485 m .31696 .31886 L p
.34732 .32758 L .4 g
F P
s
P
p
.002 w
.31696 .31886 m .33092 .3156 L .34732 .32758 L p
.4 g
F P
s
P
p
.002 w
.37526 .32111 m .40338 .3146 L .41937 .32659 L p
.8 g
F P
s
P
p
.002 w
.66481 .31711 m .67208 .3231 L .65764 .32634 L p
.4 g
F P
s
P
p
.002 w
.63593 .3236 m .66481 .31711 L p
.65764 .32634 L .4 g
F P
s
P
p
.002 w
.5199 .31911 m .49149 .32559 L .4759 .31359 L p
.8 g
F P
s
P
p
.002 w
.5199 .31911 m .54849 .31258 L .56367 .3246 L p
.4 g
F P
s
P
p
.002 w
.68656 .31986 m .67208 .3231 L p
.66481 .31711 L .4 g
F P
s
P
p
.002 w
.69388 .31057 m .70108 .3166 L .68656 .31986 L p
.4 g
F P
s
P
p
.002 w
.66481 .31711 m .69388 .31057 L p
.68656 .31986 L .4 g
F P
s
P
p
.002 w
.54849 .31258 m .5199 .31911 L .50443 .30703 L p
.8 g
F P
s
P
p
.002 w
.4759 .31359 m .50443 .30703 L .5199 .31911 L p
.8 g
F P
s
P
p
.002 w
.33092 .3156 m .31696 .31886 L .30867 .31284 L p
.4 g
F P
s
P
p
1 .463 0 r
.01 w
.44055 .3669 m
.45639 .37863 L
s
P
p
1 .482 0 r
.01 w
.45637 .38028 m
.45637 .38028 L
s
P
p
.002 w
.69388 .31057 m .66481 .31711 L .65016 .30501 L p
.8 g
F P
s
P
p
.002 w
.71565 .31334 m .70108 .3166 L p
.69388 .31057 L .4 g
F P
s
P
p
1 .502 0 r
.01 w
.45634 .38193 m
.45634 .38193 L
s
P
p
.002 w
.30867 .31284 m .30032 .30678 L p
.33092 .3156 L .4 g
F P
s
P
p
.002 w
.30032 .30678 m .31434 .30348 L .33092 .3156 L p
.4 g
F P
s
P
p
1 .521 0 r
.01 w
.44045 .37186 m
.45631 .38359 L
s
P
p
1 .019 0 r
.01 w
.64301 .31434 m
.64301 .31434 L
s
P
p
1 .309 0 r
.01 w
.49782 .34083 m
.51337 .35274 L
s
P
p
1 .039 0 r
.01 w
.62826 .30384 m
.64307 .31597 L
s
P
p
.002 w
.72313 .30399 m .73027 .31006 L .71565 .31334 L p
.4 g
F P
s
P
p
.002 w
.69388 .31057 m .72313 .30399 L p
.71565 .31334 L .4 g
F P
s
P
p
.002 w
.57726 .30602 m .54849 .31258 L .53313 .30043 L p
.8 g
F P
s
P
p
.002 w
.50443 .30703 m .53313 .30043 L .54849 .31258 L p
.8 g
F P
s
P
p
1 .328 0 r
.01 w
.51337 .35438 m
.51337 .35438 L
s
P
p
1 .347 0 r
.01 w
.51338 .35603 m
.51338 .35603 L
s
P
p
.002 w
.72313 .30399 m .69388 .31057 L .67934 .29839 L p
.8 g
F P
s
P
p
.002 w
.65016 .30501 m .67934 .29839 L .69388 .31057 L p
.8 g
F P
s
P
p
1 .367 0 r
.01 w
.4978 .34577 m
.51338 .35767 L
s
P
p
.002 w
.74493 .30678 m .73027 .31006 L p
.72313 .30399 L .4 g
F P
s
P
p
1 .424 0 r
.01 w
.44062 .36359 m
.46911 .35718 L
s
P
p
1 .154 0 r
.01 w
.55537 .31463 m
.57063 .32673 L
s
P
p
1 .559 0 r
.01 w
.41197 .38154 m
.44038 .37518 L
s
P
p
1 .444 0 r
.01 w
.44059 .36524 m
.44059 .36524 L
s
P
p
1 .174 0 r
.01 w
.57065 .32836 m
.57065 .32836 L
s
P
p
.002 w
.53313 .30043 m .50443 .30703 L .48877 .29482 L p
.4 g
F P
s
P
p
1 .579 0 r
.01 w
.41192 .3832 m
.41192 .3832 L
s
P
p
.002 w
.31434 .30348 m .30032 .30678 L .29193 .30069 L p
.4 g
F P
s
P
p
.002 w
.75256 .29737 m .75964 .30348 L .74493 .30678 L p
.4 g
F P
s
P
p
.002 w
.72313 .30399 m .75256 .29737 L p
.74493 .30678 L .4 g
F P
s
P
p
1 .193 0 r
.01 w
.57068 .32999 m
.57068 .32999 L
s
P
p
.002 w
.53313 .30043 m .56202 .29379 L .57726 .30602 L p
.8 g
F P
s
P
p
1 .598 0 r
.01 w
.39568 .37309 m
.41187 .38486 L
s
P
p
1 .212 0 r
.01 w
.55543 .31955 m
.57071 .33163 L
s
P
p
.002 w
.75256 .29737 m .72313 .30399 L .70872 .29174 L p
.8 g
F P
s
P
p
.002 w
.67934 .29839 m .70872 .29174 L .72313 .30399 L p
.8 g
F P
s
P
p
.002 w
.77439 .30018 m .75964 .30348 L p
.75256 .29737 L .4 g
F P
s
P
p
.002 w
.29193 .30069 m .28349 .29456 L p
.31434 .30348 L .4 g
F P
s
P
p
.002 w
.28349 .29456 m .29756 .29123 L .31434 .30348 L p
.4 g
F P
s
P
p
1 .27 0 r
.01 w
.49783 .33754 m
.52657 .33103 L
s
P
p
1 .405 0 r
.01 w
.46913 .35553 m
.49778 .34906 L
s
P
p
1 .289 0 r
.01 w
.49783 .33919 m
.49783 .33919 L
s
P
p
1 .54 0 r
.01 w
.44041 .37352 m
.44041 .37352 L
s
P
p
.002 w
.48877 .29482 m .5176 .28814 L .53313 .30043 L p
.4 g
F P
s
P
p
.002 w
.78217 .29071 m .78919 .29686 L .77439 .30018 L p
.4 g
F P
s
P
p
.002 w
.75256 .29737 m .78217 .29071 L p
.77439 .30018 L .4 g
F P
s
P
p
.002 w
.63533 .29277 m .6062 .29941 L .59108 .28711 L p
.8 g
F P
s
P
p
1 .058 0 r
.01 w
.61333 .2932 m
.62832 .30547 L
s
P
p
1 .637 0 r
.01 w
.36717 .38281 m
.39556 .37642 L
s
P
p
1 .116 0 r
.01 w
.55532 .31137 m
.58431 .30475 L
s
P
p
1 .251 0 r
.01 w
.52657 .32939 m
.55547 .32283 L
s
P
p
.002 w
.78217 .29071 m .75256 .29737 L .73827 .28505 L p
.8 g
F P
s
P
p
.002 w
.70872 .29174 m .73827 .28505 L .75256 .29737 L p
.8 g
F P
s
P
p
1 .656 0 r
.01 w
.3671 .38447 m
.3671 .38447 L
s
P
p
1 .386 0 r
.01 w
.49779 .34741 m
.49779 .34741 L
s
P
p
1 .135 0 r
.01 w
.55535 .313 m
.55535 .313 L
s
P
p
.002 w
.80403 .29354 m .78919 .29686 L p
.78217 .29071 L .4 g
F P
s
P
p
.002 w
.37083 .2902 m .3425 .29686 L .32583 .28453 L p
.8 g
F P
s
P
p
1 .675 0 r
.01 w
.3505 .37432 m
.36703 .38614 L
s
P
p
.002 w
.5176 .28814 m .48877 .29482 L .47294 .28246 L p
.4 g
F P
s
P
p
.002 w
.29756 .29123 m .28349 .29456 L .275 .2884 L p
.4 g
F P
s
P
p
.002 w
.81197 .28401 m .81892 .2902 L .80403 .29354 L p
.4 g
F P
s
P
p
.002 w
.78217 .29071 m .81197 .28401 L p
.80403 .29354 L .4 g
F P
s
P
p
.002 w
.66464 .28608 m .63533 .29277 L .62033 .28039 L p
.8 g
F P
s
P
p
.002 w
.59108 .28711 m .62033 .28039 L .63533 .29277 L p
.8 g
F P
s
P
p
1 .617 0 r
.01 w
.39562 .37475 m
.39562 .37475 L
s
P
p
1 .096 0 r
.01 w
.58428 .30312 m
.61343 .29647 L
s
P
p
1 .232 0 r
.01 w
.55545 .32119 m
.55545 .32119 L
s
P
p
.002 w
.275 .2884 m .26646 .2822 L p
.29756 .29123 L .4 g
F P
s
P
p
.002 w
.26646 .2822 m .28059 .27883 L .29756 .29123 L p
.4 g
F P
s
P
p
.002 w
.81197 .28401 m .78217 .29071 L .76801 .27831 L p
.8 g
F P
s
P
p
.002 w
.73827 .28505 m .76801 .27831 L .78217 .29071 L p
.8 g
F P
s
P
p
.002 w
.39935 .28349 m .37083 .2902 L .35428 .27779 L p
.8 g
F P
s
P
p
.002 w
.32583 .28453 m .35428 .27779 L .37083 .2902 L p
.8 g
F P
s
P
p
.002 w
.83386 .28685 m .81892 .2902 L p
.81197 .28401 L .4 g
F P
s
P
p
.002 w
.47294 .28246 m .50188 .27571 L .5176 .28814 L p
.4 g
F P
s
P
p
1 .077 0 r
.01 w
.61338 .29483 m
.61338 .29483 L
s
P
p
.002 w
.84196 .27727 m .84885 .28349 L .83386 .28685 L p
.4 g
F P
s
P
p
.002 w
.81197 .28401 m .84196 .27727 L p
.83386 .28685 L .4 g
F P
s
P
p
.002 w
.69414 .27935 m .66464 .28608 L .64977 .27362 L p
.8 g
F P
s
P
p
.002 w
.62033 .28039 m .64977 .27362 L .66464 .28608 L p
.8 g
F P
s
P
p
.002 w
.76801 .27831 m .79794 .27153 L .81197 .28401 L p
.8 g
F P
s
P
p
.002 w
.35428 .27779 m .38291 .27101 L .39935 .28349 L p
.8 g
F P
s
P
p
.002 w
.86388 .28013 m .84885 .28349 L p
.84196 .27727 L .4 g
F P
s
P
p
1 .695 0 r
.01 w
.35042 .376 m
.35042 .376 L
s
P
p
.002 w
.50188 .27571 m .47294 .28246 L .45692 .26996 L p
.4 g
F P
s
P
p
.002 w
.28059 .27883 m .26646 .2822 L .25787 .27597 L p
.4 g
F P
s
P
p
1 .714 0 r
.01 w
.35034 .37767 m
.35034 .37767 L
s
P
p
1 .733 0 r
.01 w
.33351 .3674 m
.35026 .37935 L
s
P
p
.002 w
.87214 .27048 m .87896 .27675 L .86388 .28013 L p
.4 g
F P
s
P
p
.002 w
.84196 .27727 m .87214 .27048 L p
.86388 .28013 L .4 g
F P
s
P
p
.002 w
.72382 .27257 m .69414 .27935 L .67939 .26681 L p
.8 g
F P
s
P
p
.002 w
.64977 .27362 m .67939 .26681 L .69414 .27935 L p
.8 g
F P
s
P
p
.002 w
.25787 .27597 m .24924 .2697 L p
.28059 .27883 L .4 g
F P
s
P
p
.002 w
.24924 .2697 m .26342 .26628 L .28059 .27883 L p
.4 g
F P
s
P
p
.002 w
.79794 .27153 m .76801 .27831 L .75369 .26576 L p
.8 g
F P
s
P
p
.002 w
.89409 .27336 m .87896 .27675 L p
.87214 .27048 L .4 g
F P
s
P
p
.002 w
.45692 .26996 m .48598 .26312 L .50188 .27571 L p
.4 g
F P
s
P
p
.002 w
.87214 .27048 m .8873 .26707 L .89409 .27336 L p
.4 g
F P
s
P
p
.002 w
.11333 .17104 m .63861 .03683 L .89409 .27336 L p
.9 g
F P
s
P
p
.002 w
.67939 .26681 m .7092 .25996 L .72382 .27257 L p
.8 g
F P
s
P
p
.002 w
.75369 .26576 m .78375 .2589 L .79794 .27153 L p
.8 g
F P
s
P
p
.002 w
.41172 .26418 m .38291 .27101 L .36627 .25837 L p
.8 g
F P
s
P
p
.002 w
.8873 .26707 m .87214 .27048 L p
.85837 .25784 L .4 g
F P
s
P
p
.002 w
.48598 .26312 m .45692 .26996 L .44071 .25731 L p
.4 g
F P
s
P
p
.002 w
.26342 .26628 m .24924 .2697 L .24055 .26339 L p
.4 g
F P
s
P
p
1 .752 0 r
.01 w
.33342 .36909 m
.33342 .36909 L
s
P
p
.002 w
.88047 .26075 m .8873 .26707 L p
.85837 .25784 L .4 g
F P
s
P
p
.002 w
.7092 .25996 m .67939 .26681 L .66446 .25412 L p
.8 g
F P
s
P
p
.002 w
.24055 .26339 m .23181 .25704 L p
.26342 .26628 L .4 g
F P
s
P
p
.002 w
.23181 .25704 m .24604 .25359 L .26342 .26628 L p
.4 g
F P
s
P
p
1 .772 0 r
.01 w
.33334 .37077 m
.36206 .36425 L
s
P
p
.002 w
.78375 .2589 m .75369 .26576 L .73919 .25306 L p
.8 g
F P
s
P
p
.002 w
.36627 .25837 m .3952 .25146 L .41172 .26418 L p
.8 g
F P
s
P
p
.002 w
.44071 .25731 m .46989 .2504 L .48598 .26312 L p
.4 g
F P
s
P
p
.002 w
.85837 .25784 m .8736 .25439 L .88047 .26075 L p
.4 g
F P
s
P
p
.002 w
.66446 .25412 m .6944 .24719 L .7092 .25996 L p
.8 g
F P
s
P
p
.002 w
.73919 .25306 m .76939 .24612 L .78375 .2589 L p
.8 g
F P
s
P
p
.002 w
.3952 .25146 m .36627 .25837 L .34944 .24558 L p
.8 g
F P
s
P
p
1 .791 0 r
.01 w
.36198 .36593 m
.36198 .36593 L
s
P
p
.002 w
.8736 .25439 m .85837 .25784 L p
.84444 .24505 L .4 g
F P
s
P
p
.002 w
.46989 .2504 m .44071 .25731 L .42431 .24451 L p
.4 g
F P
s
P
p
1 .81 0 r
.01 w
.34504 .35548 m
.36191 .36762 L
s
P
p
.002 w
.24604 .25359 m .23181 .25704 L .22302 .25066 L p
.4 g
F P
s
P
p
.002 w
.86669 .24799 m .8736 .25439 L p
.84444 .24505 L .4 g
F P
s
P
p
.002 w
.6944 .24719 m .66446 .25412 L .64937 .24129 L p
.8 g
F P
s
P
p
.002 w
.22302 .25066 m .21417 .24424 L p
.24604 .25359 L .4 g
F P
s
P
p
.002 w
.21417 .24424 m .22846 .24075 L .24604 .25359 L p
.4 g
F P
s
P
p
.002 w
.76939 .24612 m .73919 .25306 L .72453 .24021 L p
.8 g
F P
s
P
p
.002 w
.34944 .24558 m .37849 .2386 L .3952 .25146 L p
.8 g
F P
s
P
p
.002 w
.42431 .24451 m .45361 .23752 L .46989 .2504 L p
.4 g
F P
s
P
p
.002 w
.64937 .24129 m .61949 .24826 L .60408 .23535 L p
.4 g
F P
s
P
p
.002 w
.84444 .24505 m .85974 .24156 L .86669 .24799 L p
.4 g
F P
s
P
p
.002 w
.64937 .24129 m .67943 .23427 L .6944 .24719 L p
.8 g
F P
s
P
p
.002 w
.79977 .23913 m .76939 .24612 L .75485 .23319 L p
.8 g
F P
s
P
p
.002 w
.72453 .24021 m .75485 .23319 L .76939 .24612 L p
.8 g
F P
s
P
p
.002 w
.85974 .24156 m .84444 .24505 L p
.83035 .2321 L .4 g
F P
s
P
p
.002 w
.45361 .23752 m .42431 .24451 L .40772 .23156 L p
.4 g
F P
s
P
p
.002 w
.22846 .24075 m .21417 .24424 L .20528 .23779 L p
.4 g
F P
s
P
p
1 .83 0 r
.01 w
.34496 .35717 m
.34496 .35717 L
s
P
p
.002 w
.60408 .23535 m .57427 .24236 L .55856 .22939 L p
.8 g
F P
s
P
p
1 .849 0 r
.01 w
.34488 .35887 m
.37395 .35223 L
s
P
p
.002 w
.85275 .23508 m .85974 .24156 L p
.83035 .2321 L .4 g
F P
s
P
p
.002 w
.60408 .23535 m .63409 .2283 L .64937 .24129 L p
.4 g
F P
s
P
p
.002 w
.67943 .23427 m .64937 .24129 L .63409 .2283 L p
.8 g
F P
s
P
p
.002 w
.20528 .23779 m .19633 .23129 L p
.22846 .24075 L .4 g
F P
s
P
p
.002 w
.19633 .23129 m .21068 .22776 L .22846 .24075 L p
.4 g
F P
s
P
p
.002 w
.83035 .2321 m .79977 .23913 L .78537 .22612 L p
.8 g
F P
s
P
p
.002 w
.75485 .23319 m .78537 .22612 L .79977 .23913 L p
.8 g
F P
s
P
p
.002 w
.4831 .23048 m .45361 .23752 L .43714 .22448 L p
.4 g
F P
s
P
p
.002 w
.40772 .23156 m .43714 .22448 L .45361 .23752 L p
.4 g
F P
s
P
p
.002 w
.63409 .2283 m .60408 .23535 L .58849 .2223 L p
.4 g
F P
s
P
p
.002 w
.55856 .22939 m .58849 .2223 L .60408 .23535 L p
.8 g
F P
s
P
p
.002 w
.83035 .2321 m .84571 .22857 L .85275 .23508 L p
.4 g
F P
s
P
p
.002 w
.70969 .22721 m .67943 .23427 L .66428 .2212 L p
.8 g
F P
s
P
p
.002 w
.63409 .2283 m .66428 .2212 L .67943 .23427 L p
.8 g
F P
s
P
p
1 .868 0 r
.01 w
.37389 .35393 m
.37389 .35393 L
s
P
p
1 .887 0 r
.01 w
.35683 .34328 m
.37382 .35564 L
s
P
p
.002 w
.84571 .22857 m .83035 .2321 L p
.81609 .21901 L .4 g
F P
s
P
p
.002 w
.78537 .22612 m .81609 .21901 L .83035 .2321 L p
.8 g
F P
s
P
p
.002 w
.43714 .22448 m .40772 .23156 L .39093 .21846 L p
.4 g
F P
s
P
p
.002 w
.21068 .22776 m .19633 .23129 L .18733 .22476 L p
.4 g
F P
s
P
p
.002 w
.43714 .22448 m .46675 .21736 L .4831 .23048 L p
.4 g
F P
s
P
p
.002 w
.83864 .22202 m .84571 .22857 L p
.81609 .21901 L .4 g
F P
s
P
p
.002 w
.58849 .2223 m .61862 .21516 L .63409 .2283 L p
.4 g
F P
s
P
p
.002 w
.18733 .22476 m .17827 .21818 L p
.21068 .22776 L .4 g
F P
s
P
p
.002 w
.17827 .21818 m .19267 .2146 L .21068 .22776 L p
.4 g
F P
s
P
p
.002 w
.74015 .2201 m .70969 .22721 L .69467 .21405 L p
.8 g
F P
s
P
p
.002 w
.66428 .2212 m .69467 .21405 L .70969 .22721 L p
.8 g
F P
s
P
p
.002 w
.81609 .21901 m .78537 .22612 L .7708 .21295 L p
.8 g
F P
s
P
p
.002 w
.46675 .21736 m .43714 .22448 L .42047 .21129 L p
.4 g
F P
s
P
p
.002 w
.39093 .21846 m .42047 .21129 L .43714 .22448 L p
.4 g
F P
s
P
p
.002 w
.61862 .21516 m .58849 .2223 L .57272 .20908 L p
.4 g
F P
s
P
p
.002 w
.81609 .21901 m .83152 .21543 L .83864 .22202 L p
.4 g
F P
s
P
p
.002 w
.7708 .21295 m .74015 .2201 L .72526 .20686 L p
.8 g
F P
s
P
p
.002 w
.69467 .21405 m .72526 .20686 L .74015 .2201 L p
.8 g
F P
s
P
p
.002 w
.34446 .2124 m .31518 .21955 L .29774 .20631 L p
.8 g
F P
s
P
p
.002 w
.83152 .21543 m .81609 .21901 L p
.80165 .20575 L .4 g
F P
s
P
p
.002 w
.7708 .21295 m .80165 .20575 L .81609 .21901 L p
.8 g
F P
s
P
p
1 .907 0 r
.01 w
.35676 .34499 m
.35676 .34499 L
s
P
p
.002 w
.19267 .2146 m .17827 .21818 L .16916 .21157 L p
.4 g
F P
s
P
p
1 .926 0 r
.01 w
.35668 .3467 m
.38612 .33995 L
s
P
p
.002 w
.42047 .21129 m .45021 .20408 L .46675 .21736 L p
.4 g
F P
s
P
p
.002 w
.82436 .2088 m .83152 .21543 L p
.80165 .20575 L .4 g
F P
s
P
p
.002 w
.57272 .20908 m .60298 .20185 L .61862 .21516 L p
.4 g
F P
s
P
p
.002 w
.16916 .21157 m .15999 .20492 L p
.19267 .2146 L .4 g
F P
s
P
p
.002 w
.15999 .20492 m .17446 .2013 L .19267 .2146 L p
.4 g
F P
s
P
p
.002 w
.80165 .20575 m .7708 .21295 L .75605 .19962 L p
.8 g
F P
s
P
p
.002 w
.72526 .20686 m .75605 .19962 L .7708 .21295 L p
.8 g
F P
s
P
p
.002 w
.29774 .20631 m .32714 .19906 L .34446 .2124 L p
.8 g
F P
s
P
p
.002 w
.52655 .20297 m .49656 .21019 L .48013 .19682 L p
.8 g
F P
s
P
p
1 .945 0 r
.01 w
.38606 .34166 m
.38606 .34166 L
s
P
p
.002 w
.60298 .20185 m .57272 .20908 L .55675 .1957 L p
.4 g
F P
s
P
p
.002 w
.80165 .20575 m .81716 .20213 L .82436 .2088 L p
.4 g
F P
s
P
p
1 .965 0 r
.01 w
.36889 .33081 m
.38599 .34338 L
s
P
p
.002 w
.32714 .19906 m .29774 .20631 L .28009 .1929 L p
.8 g
F P
s
P
p
.002 w
.81716 .20213 m .80165 .20575 L p
.78705 .19233 L .4 g
F P
s
P
p
.002 w
.75605 .19962 m .78705 .19233 L .80165 .20575 L p
.8 g
F P
s
P
p
.002 w
.4036 .19794 m .37393 .20519 L .35674 .19177 L p
.4 g
F P
s
P
p
.002 w
.17446 .2013 m .15999 .20492 L .15077 .19822 L p
.4 g
F P
s
P
p
.002 w
.48013 .19682 m .51026 .18952 L .52655 .20297 L p
.8 g
F P
s
P
p
.002 w
.80991 .19542 m .81716 .20213 L p
.78705 .19233 L .4 g
F P
s
P
p
.002 w
.63344 .19458 m .60298 .20185 L .58714 .18839 L p
.4 g
F P
s
P
p
.002 w
.55675 .1957 m .58714 .18839 L .60298 .20185 L p
.4 g
F P
s
P
p
.002 w
.15077 .19822 m .1415 .19149 L p
.17446 .2013 L .4 g
F P
s
P
p
.002 w
.1415 .19149 m .15602 .18783 L .17446 .2013 L p
.4 g
F P
s
P
p
.002 w
.28009 .1929 m .30961 .18556 L .32714 .19906 L p
.8 g
F P
s
P
p
.002 w
.43346 .19065 m .4036 .19794 L .38652 .18443 L p
.4 g
F P
s
P
p
.002 w
.35674 .19177 m .38652 .18443 L .4036 .19794 L p
.4 g
F P
s
P
p
.002 w
.78705 .19233 m .80262 .18867 L .80991 .19542 L p
.4 g
F P
s
P
p
.002 w
.6641 .18726 m .63344 .19458 L .61773 .18103 L p
.4 g
F P
s
P
p
.002 w
.58714 .18839 m .61773 .18103 L .63344 .19458 L p
.4 g
F P
s
P
p
1 .984 0 r
.01 w
.3515 .31981 m
.36882 .33253 L
s
P
p
.002 w
.80262 .18867 m .78705 .19233 L p
.77226 .17875 L .4 g
F P
s
P
p
.002 w
.38652 .18443 m .35674 .19177 L .33933 .17819 L p
.4 g
F P
s
P
p
.002 w
.15602 .18783 m .1415 .19149 L .13217 .18472 L p
.4 g
F P
s
P
p
.002 w
.38652 .18443 m .41651 .17705 L .43346 .19065 L p
.4 g
F P
s
P
p
.002 w
.79528 .18188 m .80262 .18867 L p
.77226 .17875 L .4 g
F P
s
P
p
.002 w
.13217 .18472 m .12278 .1779 L p
.15602 .18783 L .4 g
F P
s
P
p
.002 w
.12278 .1779 m .13735 .17419 L .15602 .18783 L p
.4 g
F P
s
P
p
.002 w
.69496 .17989 m .6641 .18726 L .64853 .17362 L p
.4 g
F P
s
P
p
.002 w
.61773 .18103 m .64853 .17362 L .6641 .18726 L p
.4 g
F P
s
P
p
.977 1 0 r
.01 w
.32157 .33017 m
.35133 .32327 L
s
P
p
.002 w
.41651 .17705 m .38652 .18443 L .36924 .17076 L p
.4 g
F P
s
P
p
.002 w
.33933 .17819 m .36924 .17076 L .38652 .18443 L p
.4 g
F P
s
P
p
.958 1 0 r
.01 w
.32148 .3319 m
.32148 .3319 L
s
P
p
.939 1 0 r
.01 w
.32138 .33363 m
.32138 .33363 L
s
P
p
.002 w
.57111 .17476 m .54058 .18216 L .52422 .16846 L p
.8 g
F P
s
P
p
.92 1 0 r
.01 w
.32128 .33536 m
.35109 .32847 L
s
P
p
.002 w
.77226 .17875 m .7879 .17505 L .79528 .18188 L p
.4 g
F P
s
P
p
.002 w
.64853 .17362 m .67952 .16616 L .69496 .17989 L p
.4 g
F P
s
P
p
.997 1 0 r
.01 w
.35142 .32154 m
.35142 .32154 L
s
P
p
.002 w
.7879 .17505 m .77226 .17875 L p
.75729 .16501 L .4 g
F P
s
P
p
.002 w
.13735 .17419 m .12278 .1779 L .11333 .17104 L p
.4 g
F P
s
P
p
.002 w
.44669 .16961 m .41651 .17705 L .39935 .16328 L p
.4 g
F P
s
P
p
.002 w
.36924 .17076 m .39935 .16328 L .41651 .17705 L p
.4 g
F P
s
P
p
.002 w
.78048 .16817 m .7879 .17505 L p
.75729 .16501 L .4 g
F P
s
P
p
.002 w
.52422 .16846 m .55488 .16097 L .57111 .17476 L p
.8 g
F P
s
P
p
.002 w
.12794 .16731 m .14259 .16357 L p
.13735 .17419 L .4 g
F P
s
P
p
.002 w
.16665 .16674 m .13735 .17419 L p
.14259 .16357 L .4 g
F P
s
P
p
.002 w
.11333 .17104 m .12794 .16731 L .13735 .17419 L p
.4 g
F P
s
P
p
.002 w
.67952 .16616 m .64853 .17362 L .63276 .15981 L p
.4 g
F P
s
P
p
.9 1 0 r
.01 w
.35101 .3302 m
.35101 .3302 L
s
P
p
.881 1 0 r
.01 w
.33333 .3191 m
.35092 .33194 L
s
P
p
.002 w
.3217 .16443 m .29187 .1719 L .2739 .15807 L p
.8 g
F P
s
P
p
.002 w
.47708 .16212 m .44669 .16961 L .42966 .15575 L p
.4 g
F P
s
P
p
.002 w
.39935 .16328 m .42966 .15575 L .44669 .16961 L p
.4 g
F P
s
P
p
.002 w
.75729 .16501 m .77301 .16126 L .78048 .16817 L p
.4 g
F P
s
P
p
.002 w
.15729 .15981 m .17204 .15604 L p
.16665 .16674 L .4 g
F P
s
P
p
.002 w
.19614 .15923 m .16665 .16674 L p
.17204 .15604 L .4 g
F P
s
P
p
.002 w
.14259 .16357 m .15729 .15981 L .16665 .16674 L p
.4 g
F P
s
P
p
.002 w
.63276 .15981 m .6639 .15226 L .67952 .16616 L p
.4 g
F P
s
P
p
.002 w
.77301 .16126 m .75729 .16501 L p
.74214 .15109 L .4 g
F P
s
P
p
.002 w
.35174 .15691 m .3217 .16443 L .30387 .15051 L p
.8 g
F P
s
P
p
.002 w
.2739 .15807 m .30387 .15051 L .3217 .16443 L p
.8 g
F P
s
P
p
.002 w
.50766 .15459 m .47708 .16212 L .46018 .14817 L p
.4 g
F P
s
P
p
.002 w
.42966 .15575 m .46018 .14817 L .47708 .16212 L p
.4 g
F P
s
P
p
.002 w
.76549 .1543 m .77301 .16126 L p
.74214 .15109 L .4 g
F P
s
P
p
.002 w
.6639 .15226 m .63276 .15981 L .61681 .14583 L p
.4 g
F P
s
P
p
.002 w
.18684 .15226 m .20169 .14847 L p
.19614 .15923 L .4 g
F P
s
P
p
.002 w
.22583 .15168 m .19614 .15923 L p
.20169 .14847 L .4 g
F P
s
P
p
.002 w
.17204 .15604 m .18684 .15226 L .19614 .15923 L p
.4 g
F P
s
P
p
.862 1 0 r
.01 w
.33323 .32084 m
.31541 .30784 L
s
P
p
.002 w
.30387 .15051 m .33403 .1429 L .35174 .15691 L p
.8 g
F P
s
P
p
.002 w
.46018 .14817 m .4909 .14054 L .50766 .15459 L p
.4 g
F P
s
P
p
.002 w
.74214 .15109 m .75793 .1473 L .76549 .1543 L p
.4 g
F P
s
P
p
.002 w
.61681 .14583 m .64809 .13819 L .6639 .15226 L p
.4 g
F P
s
P
p
.002 w
.21659 .14466 m .23154 .14084 L p
.22583 .15168 L .4 g
F P
s
P
p
.002 w
.25572 .14407 m .22583 .15168 L p
.23154 .14084 L .4 g
F P
s
P
p
.002 w
.20169 .14847 m .21659 .14466 L .22583 .15168 L p
.4 g
F P
s
P
p
.002 w
.75793 .1473 m .74214 .15109 L p
.7268 .13701 L .4 g
F P
s
P
p
.002 w
.41242 .14172 m .38198 .14934 L .3644 .13523 L p
.8 g
F P
s
P
p
.823 1 0 r
.01 w
.3152 .31134 m
.28508 .3184 L
s
P
p
.002 w
.4909 .14054 m .46018 .14817 L .44307 .13405 L p
.4 g
F P
s
P
p
.804 1 0 r
.01 w
.28496 .32015 m
.28496 .32015 L
s
P
p
.002 w
.75032 .14025 m .75793 .1473 L p
.7268 .13701 L .4 g
F P
s
P
p
.002 w
.56945 .13937 m .53845 .147 L .52182 .13286 L p
.8 g
F P
s
P
p
.785 1 0 r
.01 w
.28484 .3219 m
.28484 .3219 L
s
P
p
.002 w
.64809 .13819 m .61681 .14583 L .60066 .13168 L p
.4 g
F P
s
P
p
.765 1 0 r
.01 w
.28472 .32366 m
.3149 .31661 L
s
P
p
.002 w
.24654 .13701 m .26159 .13316 L p
.25572 .14407 L .4 g
F P
s
P
p
.002 w
.2858 .13642 m .25572 .14407 L p
.26159 .13316 L .4 g
F P
s
P
p
.002 w
.23154 .14084 m .24654 .13701 L .25572 .14407 L p
.4 g
F P
s
P
p
.842 1 0 r
.01 w
.31531 .30959 m
.31531 .30959 L
s
P
p
.002 w
.44307 .13405 m .41242 .14172 L .39497 .12752 L p
.8 g
F P
s
P
p
.002 w
.3644 .13523 m .39497 .12752 L .41242 .14172 L p
.8 g
F P
s
P
p
.002 w
.44307 .13405 m .47392 .12633 L .4909 .14054 L p
.4 g
F P
s
P
p
.002 w
.7268 .13701 m .74266 .13316 L .75032 .14025 L p
.4 g
F P
s
P
p
.002 w
.52182 .13286 m .55296 .12513 L .56945 .13937 L p
.8 g
F P
s
P
p
.002 w
.60066 .13168 m .63207 .12394 L .64809 .13819 L p
.4 g
F P
s
P
p
.002 w
.74266 .13316 m .7268 .13701 L p
.71127 .12274 L .4 g
F P
s
P
p
.002 w
.27669 .1293 m .29184 .12543 L p
.2858 .13642 L .4 g
F P
s
P
p
.002 w
.3161 .12871 m .2858 .13642 L p
.29184 .12543 L .4 g
F P
s
P
p
.002 w
.26159 .13316 m .27669 .1293 L .2858 .13642 L p
.4 g
F P
s
P
p
.746 1 0 r
.01 w
.3148 .31836 m
.3148 .31836 L
s
P
p
.727 1 0 r
.01 w
.31469 .32012 m
.29658 .30699 L
s
P
p
.002 w
.39497 .12752 m .42574 .11975 L .44307 .13405 L p
.8 g
F P
s
P
p
.002 w
.73496 .12603 m .74266 .13316 L p
.71127 .12274 L .4 g
F P
s
P
p
.002 w
.55296 .12513 m .52182 .13286 L .50498 .11855 L p
.8 g
F P
s
P
p
.002 w
.63207 .12394 m .60066 .13168 L .5843 .11735 L p
.4 g
F P
s
P
p
.002 w
.30704 .12155 m .3223 .11765 L p
.3161 .12871 L .4 g
F P
s
P
p
.002 w
.34659 .12095 m .3161 .12871 L p
.3223 .11765 L .4 g
F P
s
P
p
.002 w
.29184 .12543 m .30704 .12155 L .3161 .12871 L p
.4 g
F P
s
P
p
.002 w
.71127 .12274 m .7272 .11885 L .73496 .12603 L p
.4 g
F P
s
P
p
.002 w
.50498 .11855 m .53625 .11072 L .55296 .12513 L p
.8 g
F P
s
P
p
.002 w
.5843 .11735 m .61586 .10951 L .63207 .12394 L p
.4 g
F P
s
P
p
.002 w
.7272 .11885 m .71127 .12274 L p
.69555 .1083 L .4 g
F P
s
P
p
.002 w
.3376 .11374 m .35296 .10981 L p
.34659 .12095 L .4 g
F P
s
P
p
.002 w
.37729 .11314 m .34659 .12095 L p
.35296 .10981 L .4 g
F P
s
P
p
.002 w
.3223 .11765 m .3376 .11374 L .34659 .12095 L p
.4 g
F P
s
P
p
.002 w
.45673 .11193 m .42574 .11975 L .4082 .10527 L p
.4 g
F P
s
P
p
.707 1 0 r
.01 w
.29646 .30876 m
.27811 .29546 L
s
P
p
.002 w
.7194 .11163 m .7272 .11885 L p
.69555 .1083 L .4 g
F P
s
P
p
.002 w
.53625 .11072 m .50498 .11855 L .48793 .10405 L p
.8 g
F P
s
P
p
.002 w
.61586 .10951 m .5843 .11735 L .56774 .10284 L p
.4 g
F P
s
P
p
.002 w
.36837 .10588 m .38384 .10193 L p
.37729 .11314 L .4 g
F P
s
P
p
.002 w
.4082 .10527 m .37729 .11314 L p
.38384 .10193 L .4 g
F P
s
P
p
.002 w
.35296 .10981 m .36837 .10588 L .37729 .11314 L p
.4 g
F P
s
P
p
.002 w
.4082 .10527 m .43933 .09735 L .45673 .11193 L p
.4 g
F P
s
P
p
.002 w
.69555 .1083 m .71155 .10436 L .7194 .11163 L p
.4 g
F P
s
P
p
.002 w
.48793 .10405 m .51934 .09613 L .53625 .11072 L p
.8 g
F P
s
P
p
.669 1 0 r
.01 w
.27786 .29901 m
.24736 .30623 L
s
P
p
.002 w
.64763 .10162 m .61586 .10951 L .59944 .0949 L p
.4 g
F P
s
P
p
.002 w
.56774 .10284 m .59944 .0949 L .61586 .10951 L p
.4 g
F P
s
P
p
.65 1 0 r
.01 w
.24722 .308 m
.24722 .308 L
s
P
p
.002 w
.71155 .10436 m .69555 .1083 L p
.67962 .09368 L .4 g
F P
s
P
p
.63 1 0 r
.01 w
.24708 .30978 m
.24708 .30978 L
s
P
p
.611 1 0 r
.01 w
.24694 .31156 m
.27749 .30435 L
s
P
p
.002 w
.39935 .09796 m .41492 .09398 L p
.4082 .10527 L .4 g
F P
s
P
p
.002 w
.43933 .09735 m .4082 .10527 L p
.41492 .09398 L .4 g
F P
s
P
p
.002 w
.38384 .10193 m .39935 .09796 L .4082 .10527 L p
.4 g
F P
s
P
p
.002 w
.70365 .09704 m .71155 .10436 L p
.67962 .09368 L .4 g
F P
s
P
p
.688 1 0 r
.01 w
.27799 .29724 m
.27799 .29724 L
s
P
p
.002 w
.67962 .09368 m .64763 .10162 L .63136 .08691 L p
.4 g
F P
s
P
p
.002 w
.59944 .0949 m .63136 .08691 L .64763 .10162 L p
.4 g
F P
s
P
p
.592 1 0 r
.01 w
.27737 .30613 m
.27737 .30613 L
s
P
p
.002 w
.43054 .08999 m .44622 .08599 L p
.43933 .09735 L .4 g
F P
s
P
p
.002 w
.47066 .08938 m .43933 .09735 L p
.44622 .08599 L .4 g
F P
s
P
p
.002 w
.41492 .09398 m .43054 .08999 L .43933 .09735 L p
.4 g
F P
s
P
p
.002 w
.67962 .09368 m .6957 .08968 L .70365 .09704 L p
.4 g
F P
s
P
p
.572 1 0 r
.01 w
.27724 .30791 m
.25858 .29448 L
s
P
p
.002 w
.6957 .08968 m .67962 .09368 L p
.6635 .07887 L .4 g
F P
s
P
p
.002 w
.63136 .08691 m .6635 .07887 L .67962 .09368 L p
.4 g
F P
s
P
p
.002 w
.6877 .08228 m .6957 .08968 L p
.6635 .07887 L .4 g
F P
s
P
p
.002 w
.46195 .08197 m .47773 .07793 L p
.47066 .08938 L .4 g
F P
s
P
p
.002 w
.50221 .08135 m .47066 .08938 L p
.47773 .07793 L .4 g
F P
s
P
p
.002 w
.44622 .08599 m .46195 .08197 L .47066 .08938 L p
.4 g
F P
s
P
p
.002 w
.6635 .07887 m .67965 .07482 L .6877 .08228 L p
.4 g
F P
s
P
p
.002 w
.49357 .07389 m .50946 .06983 L p
.50221 .08135 L .4 g
F P
s
P
p
.002 w
.53398 .07326 m .50221 .08135 L p
.50946 .06983 L .4 g
F P
s
P
p
.002 w
.47773 .07793 m .49357 .07389 L .50221 .08135 L p
.4 g
F P
s
P
p
.553 1 0 r
.01 w
.25845 .29627 m
.25845 .29627 L
s
P
p
.534 1 0 r
.01 w
.25831 .29806 m
.28927 .29072 L
s
P
p
.002 w
.67965 .07482 m .6635 .07887 L p
.64716 .06387 L .4 g
F P
s
P
p
.002 w
.67155 .06732 m .67965 .07482 L p
.64716 .06387 L .4 g
F P
s
P
p
.002 w
.52541 .06575 m .54141 .06166 L p
.53398 .07326 L .4 g
F P
s
P
p
.002 w
.56597 .06512 m .53398 .07326 L p
.54141 .06166 L .4 g
F P
s
P
p
.002 w
.50946 .06983 m .52541 .06575 L .53398 .07326 L p
.4 g
F P
s
P
p
.514 1 0 r
.01 w
.28915 .29251 m
.28915 .29251 L
s
P
p
.495 1 0 r
.01 w
.28903 .29431 m
.27022 .28063 L
s
P
p
.002 w
.64716 .06387 m .66339 .05977 L .67155 .06732 L p
.4 g
F P
s
P
p
.002 w
.55747 .05756 m .57359 .05344 L p
.56597 .06512 L .4 g
F P
s
P
p
.002 w
.59818 .05693 m .56597 .06512 L p
.57359 .05344 L .4 g
F P
s
P
p
.002 w
.54141 .06166 m .55747 .05756 L .56597 .06512 L p
.4 g
F P
s
P
p
.002 w
.66339 .05977 m .64716 .06387 L p
.63062 .04867 L .4 g
F P
s
P
p
.002 w
.65518 .05217 m .66339 .05977 L p
.63062 .04867 L .4 g
F P
s
P
p
0 .759 1 r
.01 w
.55506 .53809 m
.57212 .55018 L
s
P
p
0 .74 1 r
.01 w
.57215 .55213 m
.57215 .55213 L
s
P
p
.002 w
.58976 .04931 m .60598 .04516 L p
.59818 .05693 L .4 g
F P
s
P
p
.002 w
.63062 .04867 m .59818 .05693 L p
.60598 .04516 L .4 g
F P
s
P
p
.002 w
.57359 .05344 m .58976 .04931 L .59818 .05693 L p
.4 g
F P
s
P
p
0 .72 1 r
.01 w
.57219 .55407 m
.57219 .55407 L
s
P
p
0 .701 1 r
.01 w
.57222 .55602 m
.55513 .54395 L
s
P
p
.476 1 0 r
.01 w
.27009 .28243 m
.27009 .28243 L
s
P
p
.002 w
.63062 .04867 m .64692 .04452 L .65518 .05217 L p
.4 g
F P
s
P
p
.457 1 0 r
.01 w
.26996 .28424 m
.30133 .27676 L
s
P
p
.002 w
.62227 .041 m .63861 .03683 L p
.63062 .04867 L .4 g
F P
s
P
p
.002 w
.64692 .04452 m .63062 .04867 L p
.63861 .03683 L .4 g
F P
s
P
p
.002 w
.60598 .04516 m .62227 .041 L .63062 .04867 L p
.4 g
F P
s
P
p
0 .797 1 r
.01 w
.58745 .52758 m
.55501 .5342 L
s
P
p
0 .662 1 r
.01 w
.55517 .54787 m
.52284 .55442 L
s
P
p
0 .778 1 r
.01 w
.55503 .53615 m
.55503 .53615 L
s
P
p
0 .643 1 r
.01 w
.52284 .55637 m
.52284 .55637 L
s
P
p
.36 1 0 r
.01 w
.33244 .27831 m
.35105 .29215 L
s
P
p
0 .624 1 r
.01 w
.52285 .55833 m
.52285 .55833 L
s
P
p
.341 1 0 r
.01 w
.35096 .29397 m
.35096 .29397 L
s
P
p
0 .605 1 r
.01 w
.52285 .5603 m
.55524 .55375 L
s
P
p
.437 1 0 r
.01 w
.30122 .27857 m
.30122 .27857 L
s
P
p
.322 1 0 r
.01 w
.35088 .29579 m
.38267 .28832 L
s
P
p
0 .836 1 r
.01 w
.57027 .51133 m
.58737 .52369 L
s
P
p
.418 1 0 r
.01 w
.30111 .28038 m
.30111 .28038 L
s
P
p
0 .817 1 r
.01 w
.58741 .52563 m
.58741 .52563 L
s
P
p
.399 1 0 r
.01 w
.30099 .28219 m
.33263 .27467 L
s
P
p
0 .682 1 r
.01 w
.55515 .54591 m
.55515 .54591 L
s
P
p
0 .585 1 r
.01 w
.55526 .55572 m
.55526 .55572 L
s
P
p
.302 1 0 r
.01 w
.3826 .29014 m
.41463 .28262 L
s
P
p
0 .566 1 r
.01 w
.55529 .55769 m
.53791 .5455 L
s
P
p
.379 1 0 r
.01 w
.33254 .27649 m
.33254 .27649 L
s
P
p
0 .894 1 r
.01 w
.55288 .49295 m
.57018 .50549 L
s
P
p
0 .875 1 r
.01 w
.57021 .50743 m
.57021 .50743 L
s
P
p
0 .971 1 r
.01 w
.50258 .47936 m
.52021 .49199 L
s
P
p
0 .855 1 r
.01 w
.57024 .50938 m
.57024 .50938 L
s
P
p
0 .952 1 r
.01 w
.52022 .49393 m
.52022 .49393 L
s
P
p
0 .932 1 r
.01 w
.52022 .49587 m
.55284 .48906 L
s
P
p
.958 0 1 r
.01 w
.47805 .77792 m
.49587 .78863 L
s
P
p
.977 0 1 r
.01 w
.49586 .79073 m
.49586 .79073 L
s
P
p
.283 1 0 r
.01 w
.41458 .28445 m
.41458 .28445 L
s
P
p
.997 0 1 r
.01 w
.49585 .79283 m
.52841 .78706 L
s
P
p
.264 1 0 r
.01 w
.41452 .28628 m
.39614 .27226 L
s
P
p
.206 1 0 r
.01 w
.39595 .27777 m
.41436 .29178 L
s
P
p
.186 1 0 r
.01 w
.41431 .29362 m
.41431 .29362 L
s
P
p
0 .913 1 r
.01 w
.55286 .491 m
.55286 .491 L
s
P
p
0 .547 1 r
.01 w
.53792 .54748 m
.5203 .53514 L
s
P
p
.167 1 0 r
.01 w
.41425 .29546 m
.44664 .2879 L
s
P
p
0 .99 1 r
.01 w
.48472 .46461 m
.50258 .47742 L
s
P
p
1 0 .984 r
.01 w
.52842 .78917 m
.56123 .78336 L
s
P
p
.939 0 1 r
.01 w
.46003 .76496 m
.47807 .77581 L
s
P
p
0 1 .875 r
.01 w
.60108 .44291 m
.56803 .44995 L
s
P
p
.148 1 0 r
.01 w
.4466 .28975 m
.47923 .28213 L
s
P
p
0 .508 1 r
.01 w
.52031 .53912 m
.48754 .54581 L
s
P
p
0 1 .894 r
.01 w
.56806 .45189 m
.56806 .45189 L
s
P
p
.244 1 0 r
.01 w
.39608 .27409 m
.39608 .27409 L
s
P
p
0 .489 1 r
.01 w
.48752 .5478 m
.48752 .5478 L
s
P
p
0 1 .913 r
.01 w
.56809 .45382 m
.55058 .4408 L
s
P
p
.225 1 0 r
.01 w
.39602 .27593 m
.39602 .27593 L
s
P
p
1 0 .965 r
.01 w
.56126 .78548 m
.56126 .78548 L
s
P
p
0 .469 1 r
.01 w
.48751 .54979 m
.46947 .5374 L
s
P
p
1 0 .945 r
.01 w
.56129 .7876 m
.54373 .77678 L
s
P
p
0 1 .817 r
.01 w
.63417 .43002 m
.60094 .43712 L
s
P
p
0 1 .971 r
.01 w
.51758 .4537 m
.48475 .46072 L
s
P
p
0 1 .836 r
.01 w
.60099 .43905 m
.60099 .43905 L
s
P
p
0 1 .99 r
.01 w
.48474 .46266 m
.48474 .46266 L
s
P
p
.881 0 1 r
.01 w
.44187 .7476 m
.46012 .75862 L
s
P
p
0 1 .855 r
.01 w
.60103 .44098 m
.60103 .44098 L
s
P
p
0 .527 1 r
.01 w
.52031 .53713 m
.52031 .53713 L
s
P
p
.9 0 1 r
.01 w
.46009 .76073 m
.46009 .76073 L
s
P
p
1 0 .887 r
.01 w
.54378 .78317 m
.56137 .79397 L
s
P
p
.92 0 1 r
.01 w
.46006 .76284 m
.46006 .76284 L
s
P
p
1 0 .868 r
.01 w
.56139 .7961 m
.56139 .7961 L
s
P
p
0 1 .778 r
.01 w
.61691 .41291 m
.63404 .42616 L
s
P
p
.129 1 0 r
.01 w
.47921 .28398 m
.47921 .28398 L
s
P
p
1 0 .849 r
.01 w
.56142 .79823 m
.5946 .79241 L
s
P
p
0 1 .797 r
.01 w
.6341 .42809 m
.6341 .42809 L
s
P
p
.109 1 0 r
.01 w
.47919 .28584 m
.46103 .27165 L
s
P
p
0 1 .952 r
.01 w
.55063 .44469 m
.51758 .45176 L
s
P
p
.785 0 1 r
.01 w
.42362 .72584 m
.44206 .73705 L
s
P
p
.804 0 1 r
.01 w
.44202 .73916 m
.44202 .73916 L
s
P
p
.823 0 1 r
.01 w
.44198 .74126 m
.44198 .74126 L
s
P
p
0 1 .932 r
.01 w
.5506 .44275 m
.5506 .44275 L
s
P
p
.842 0 1 r
.01 w
.44194 .74337 m
.44194 .74337 L
s
P
p
0 .45 1 r
.01 w
.46944 .5394 m
.46944 .5394 L
s
P
p
1 0 .83 r
.01 w
.59464 .79455 m
.62807 .78869 L
s
P
p
.862 0 1 r
.01 w
.44191 .74549 m
.44191 .74549 L
s
P
p
1 0 .926 r
.01 w
.54374 .77891 m
.54374 .77891 L
s
P
p
0 .431 1 r
.01 w
.46942 .5414 m
.46942 .5414 L
s
P
p
0 1 .72 r
.01 w
.59941 .39368 m
.61674 .40712 L
s
P
p
1 0 .907 r
.01 w
.54376 .78104 m
.54376 .78104 L
s
P
p
0 .412 1 r
.01 w
.46939 .5434 m
.45108 .53087 L
s
P
p
0 1 .74 r
.01 w
.6168 .40905 m
.6168 .40905 L
s
P
p
0 1 .643 r
.01 w
.54816 .37974 m
.56584 .39328 L
s
P
p
0 1 .759 r
.01 w
.61685 .41098 m
.61685 .41098 L
s
P
p
0 1 .662 r
.01 w
.56587 .3952 m
.56587 .3952 L
s
P
p
0 1 .682 r
.01 w
.5659 .39713 m
.59932 .38982 L
s
P
p
.727 0 1 r
.01 w
.40512 .70814 m
.42377 .71952 L
s
P
p
.09 1 0 r
.01 w
.461 .27351 m
.461 .27351 L
s
P
p
.746 0 1 r
.01 w
.42372 .72162 m
.42372 .72162 L
s
P
p
.65 0 1 r
.01 w
.35358 .69442 m
.37259 .70591 L
s
P
p
.071 1 0 r
.01 w
.46097 .27537 m
.49406 .26761 L
s
P
p
.765 0 1 r
.01 w
.42367 .72373 m
.42367 .72373 L
s
P
p
1 0 .81 r
.01 w
.62814 .79083 m
.62814 .79083 L
s
P
p
.669 0 1 r
.01 w
.37252 .70801 m
.37252 .70801 L
s
P
p
1 0 .791 r
.01 w
.6282 .79298 m
.61088 .78207 L
s
P
p
.688 0 1 r
.01 w
.37244 .71011 m
.40523 .70392 L
s
P
p
1 0 .733 r
.01 w
.61105 .78855 m
.62839 .79944 L
s
P
p
0 1 .701 r
.01 w
.59936 .39175 m
.59936 .39175 L
s
P
p
1 0 .714 r
.01 w
.62846 .8016 m
.62846 .8016 L
s
P
p
1 0 .695 r
.01 w
.62852 .80375 m
.66233 .79789 L
s
P
p
0 1 .624 r
.01 w
.53023 .36408 m
.54814 .37781 L
s
P
p
.051 1 0 r
.01 w
.49405 .26948 m
.49405 .26948 L
s
P
p
0 .392 1 r
.01 w
.45105 .53288 m
.45105 .53288 L
s
P
p
.032 1 0 r
.01 w
.49404 .27134 m
.49404 .27134 L
s
P
p
0 .373 1 r
.01 w
.45101 .53489 m
.48422 .52804 L
s
P
p
.707 0 1 r
.01 w
.40517 .70602 m
.40517 .70602 L
s
P
p
.013 1 0 r
.01 w
.49403 .27321 m
.52742 .2654 L
s
P
p
.63 0 1 r
.01 w
.33441 .68067 m
.35367 .69232 L
s
P
p
1 0 .675 r
.01 w
.66241 .80005 m
.69648 .79414 L
s
P
p
1 0 .772 r
.01 w
.61094 .78423 m
.61094 .78423 L
s
P
p
1 0 .752 r
.01 w
.61099 .78639 m
.61099 .78639 L
s
P
p
0 .354 1 r
.01 w
.48421 .53006 m
.48421 .53006 L
s
P
p
0 1 .585 r
.01 w
.56386 .35271 m
.53021 .36023 L
s
P
p
0 1 .006 r
.01 w
.52742 .26728 m
.52742 .26728 L
s
P
p
0 .334 1 r
.01 w
.48419 .53208 m
.46574 .51931 L
s
P
p
0 1 .605 r
.01 w
.53022 .36215 m
.53022 .36215 L
s
P
p
0 1 .026 r
.01 w
.52743 .26915 m
.52743 .26915 L
s
P
p
0 1 .045 r
.01 w
.52744 .27103 m
.52744 .27103 L
s
P
p
0 1 .064 r
.01 w
.52745 .27291 m
.52745 .27291 L
s
P
p
.592 0 1 r
.01 w
.36762 .67007 m
.33461 .67645 L
s
P
p
0 1 .547 r
.01 w
.54585 .33482 m
.5638 .34885 L
s
P
p
0 1 .084 r
.01 w
.52746 .27479 m
.56118 .26694 L
s
P
p
1 0 .656 r
.01 w
.69659 .79632 m
.69659 .79632 L
s
P
p
.611 0 1 r
.01 w
.33451 .67856 m
.33451 .67856 L
s
P
p
0 1 .566 r
.01 w
.56383 .35078 m
.56383 .35078 L
s
P
p
1 0 .637 r
.01 w
.69669 .79849 m
.67963 .78749 L
s
P
p
.553 0 1 r
.01 w
.34847 .65394 m
.36778 .66586 L
s
P
p
.572 0 1 r
.01 w
.3677 .66796 m
.3677 .66796 L
s
P
p
0 1 .103 r
.01 w
.56121 .26883 m
.56121 .26883 L
s
P
p
0 1 .122 r
.01 w
.56123 .27071 m
.56123 .27071 L
s
P
p
0 .315 1 r
.01 w
.46572 .52134 m
.46572 .52134 L
s
P
p
.418 0 1 r
.01 w
.32961 .62706 m
.34911 .6392 L
s
P
p
0 1 .141 r
.01 w
.56126 .2726 m
.59529 .2647 L
s
P
p
0 1 .508 r
.01 w
.57979 .32327 m
.54581 .33096 L
s
P
p
0 .296 1 r
.01 w
.46569 .52337 m
.49938 .51639 L
s
P
p
.437 0 1 r
.01 w
.34902 .6413 m
.34902 .6413 L
s
P
p
.341 0 1 r
.01 w
.27708 .61303 m
.29695 .62527 L
s
P
p
0 1 .527 r
.01 w
.54583 .33289 m
.54583 .33289 L
s
P
p
.457 0 1 r
.01 w
.34893 .6434 m
.38221 .63685 L
s
P
p
0 1 .412 r
.01 w
.61374 .3059 m
.5796 .31366 L
s
P
p
.36 0 1 r
.01 w
.29683 .62736 m
.29683 .62736 L
s
P
p
0 1 .431 r
.01 w
.57964 .31558 m
.57964 .31558 L
s
P
p
.379 0 1 r
.01 w
.29671 .62946 m
.32982 .62286 L
s
P
p
0 1 .45 r
.01 w
.57968 .3175 m
.57968 .3175 L
s
P
p
.514 0 1 r
.01 w
.38198 .64318 m
.34865 .64971 L
s
P
p
1 0 .617 r
.01 w
.67973 .78968 m
.67973 .78968 L
s
P
p
0 1 .469 r
.01 w
.57972 .31942 m
.57972 .31942 L
s
P
p
0 1 .354 r
.01 w
.64789 .29233 m
.61357 .30015 L
s
P
p
.534 0 1 r
.01 w
.34856 .65182 m
.34856 .65182 L
s
P
p
1 0 .598 r
.01 w
.67982 .79187 m
.71439 .78585 L
s
P
p
0 1 .489 r
.01 w
.57976 .32135 m
.57976 .32135 L
s
P
p
0 1 .373 r
.01 w
.61362 .30207 m
.61362 .30207 L
s
P
p
0 1 .392 r
.01 w
.61368 .30398 m
.61368 .30398 L
s
P
p
0 1 .161 r
.01 w
.59534 .2666 m
.59534 .2666 L
s
P
p
0 .277 1 r
.01 w
.49937 .51842 m
.49937 .51842 L
s
P
p
0 1 .18 r
.01 w
.59538 .26849 m
.59538 .26849 L
s
P
p
0 .257 1 r
.01 w
.49936 .52046 m
.49936 .52046 L
s
P
p
.476 0 1 r
.01 w
.38213 .63896 m
.38213 .63896 L
s
P
p
0 1 .199 r
.01 w
.59543 .27039 m
.59543 .27039 L
s
P
p
0 1 .315 r
.01 w
.63017 .2739 m
.64774 .2885 L
s
P
p
0 .238 1 r
.01 w
.49935 .52251 m
.53335 .51548 L
s
P
p
.495 0 1 r
.01 w
.38206 .64107 m
.38206 .64107 L
s
P
p
0 1 .219 r
.01 w
.59548 .27229 m
.59548 .27229 L
s
P
p
.399 0 1 r
.01 w
.32972 .62496 m
.32972 .62496 L
s
P
p
0 1 .334 r
.01 w
.64782 .29042 m
.64782 .29042 L
s
P
p
0 1 .238 r
.01 w
.59552 .2742 m
.6299 .26625 L
s
P
p
.322 0 1 r
.01 w
.25708 .59852 m
.27721 .61093 L
s
P
p
1 0 .579 r
.01 w
.7145 .78805 m
.7145 .78805 L
s
P
p
1 0 .559 r
.01 w
.71462 .79025 m
.69746 .77905 L
s
P
p
0 .219 1 r
.01 w
.53336 .51753 m
.56762 .51046 L
s
P
p
0 1 .257 r
.01 w
.62997 .26816 m
.62997 .26816 L
s
P
p
0 1 .277 r
.01 w
.63003 .27007 m
.63003 .27007 L
s
P
p
0 1 .296 r
.01 w
.6301 .27198 m
.6301 .27198 L
s
P
p
.283 0 1 r
.01 w
.2907 .58751 m
.25737 .59432 L
s
P
p
.302 0 1 r
.01 w
.25723 .59642 m
.25723 .59642 L
s
P
p
0 .199 1 r
.01 w
.56765 .51251 m
.56765 .51251 L
s
P
p
0 .18 1 r
.01 w
.56769 .51457 m
.5494 .50139 L
s
P
p
.244 0 1 r
.01 w
.27075 .5706 m
.29095 .58331 L
s
P
p
1 0 .54 r
.01 w
.69757 .78126 m
.68017 .76991 L
s
P
p
.264 0 1 r
.01 w
.29083 .58541 m
.29083 .58541 L
s
P
p
.109 0 1 r
.01 w
.39281 .54786 m
.3589 .55486 L
s
P
p
.129 0 1 r
.01 w
.35881 .55695 m
.35881 .55695 L
s
P
p
.148 0 1 r
.01 w
.35872 .55904 m
.33889 .5461 L
s
P
p
.051 0 1 r
.01 w
.42712 .53454 m
.39301 .5416 L
s
P
p
.206 0 1 r
.01 w
.30468 .55943 m
.27103 .5664 L
s
P
p
.071 0 1 r
.01 w
.39294 .54369 m
.39294 .54369 L
s
P
p
.225 0 1 r
.01 w
.27089 .5685 m
.27089 .5685 L
s
P
p
.09 0 1 r
.01 w
.39288 .54577 m
.39288 .54577 L
s
P
p
0 .161 1 r
.01 w
.54942 .50346 m
.53086 .4901 L
s
P
p
1 0 .521 r
.01 w
.68026 .77213 m
.68026 .77213 L
s
P
p
.013 0 1 r
.01 w
.4078 .51719 m
.42722 .53037 L
s
P
p
1 0 .502 r
.01 w
.68036 .77436 m
.68036 .77436 L
s
P
p
.032 0 1 r
.01 w
.42717 .53245 m
.42717 .53245 L
s
P
p
.186 0 1 r
.01 w
.33869 .55031 m
.3048 .55733 L
s
P
p
1 0 .482 r
.01 w
.68046 .77658 m
.66278 .76511 L
s
P
p
1 0 .424 r
.01 w
.66305 .77183 m
.68075 .78328 L
s
P
p
1 0 .405 r
.01 w
.68084 .78552 m
.68084 .78552 L
s
P
p
0 .122 1 r
.01 w
.53089 .49425 m
.49618 .5015 L
s
P
p
1 0 .386 r
.01 w
.68094 .78776 m
.71635 .78158 L
s
P
p
0 .103 1 r
.01 w
.49618 .50358 m
.49618 .50358 L
s
P
p
.167 0 1 r
.01 w
.33879 .5482 m
.33879 .5482 L
s
P
p
0 .084 1 r
.01 w
.49617 .50565 m
.47714 .49224 L
s
P
p
0 .026 1 r
.01 w
.44237 .50579 m
.40792 .51301 L
s
P
p
0 .006 1 r
.01 w
.40786 .5151 m
.40786 .5151 L
s
P
p
0 .141 1 r
.01 w
.53088 .49217 m
.53088 .49217 L
s
P
p
1 0 .058 r
.01 w
.86087 .82436 m
.87728 .8355 L
s
P
p
1 0 .367 r
.01 w
.71647 .78383 m
.75216 .77761 L
s
P
p
1 0 .463 r
.01 w
.66287 .76734 m
.66287 .76734 L
s
P
p
1 0 .039 r
.01 w
.87749 .83778 m
.87749 .83778 L
s
P
p
0 .045 1 r
.01 w
.4771 .49641 m
.44241 .5037 L
s
P
p
1 0 .444 r
.01 w
.66296 .76959 m
.66296 .76959 L
s
P
p
1 0 .019 r
.01 w
.87771 .84006 m
.87771 .84006 L
s
P
p
0 .064 1 r
.01 w
.47712 .49433 m
.47712 .49433 L
s
P
p
1 0 .347 r
.01 w
.7523 .77987 m
.7523 .77987 L
s
P
p
1 0 .328 r
.01 w
.75244 .78213 m
.73506 .77055 L
s
P
p
1 0 .116 r
.01 w
.84363 .80618 m
.86026 .81751 L
s
P
p
1 0 .096 r
.01 w
.86046 .81979 m
.86046 .81979 L
s
P
p
1 0 .077 r
.01 w
.86066 .82207 m
.86066 .82207 L
s
P
p
1 0 .27 r
.01 w
.73545 .77736 m
.75286 .78891 L
s
P
p
1 0 .251 r
.01 w
.75301 .79118 m
.75301 .79118 L
s
P
p
1 0 .232 r
.01 w
.75315 .79345 m
.78927 .78722 L
s
P
p
1 0 .135 r
.01 w
.82659 .79239 m
.84344 .80389 L
s
P
p
1 0 .212 r
.01 w
.78943 .7895 m
.82585 .78323 L
s
P
p
1 0 .309 r
.01 w
.73519 .77281 m
.73519 .77281 L
s
P
p
1 0 .289 r
.01 w
.73532 .77509 m
.73532 .77509 L
s
P
p
1 0 .193 r
.01 w
.82603 .78552 m
.82603 .78552 L
s
P
p
1 0 .174 r
.01 w
.82622 .7878 m
.82622 .7878 L
s
P
p
1 0 .154 r
.01 w
.8264 .7901 m
.8264 .7901 L
s
P
p
.002 w
.63809 .02387 m
.89266 .2608 L
s
.89266 .2608 m
.96341 .8843 L
s
.96341 .8843 m
.66452 .68009 L
s
.66452 .68009 m
.63809 .02387 L
s
.1149 .15829 m
.03659 .79698 L
s
.03659 .79698 m
.66452 .68009 L
s
.66452 .68009 m
.63809 .02387 L
s
.63809 .02387 m
.1149 .15829 L
s
P
p
p
.002 w
.1149 .15829 m
.63809 .02387 L
s
P
p
.002 w
.23266 .12803 m
.23857 .13258 L
s
P
[(5)] .22082 .11893 .84808 1 Mshowa
p
.002 w
.38436 .08906 m
.39003 .09374 L
s
P
[(10)] .373 .0797 .79153 1 Mshowa
p
.002 w
.5413 .04874 m
.54671 .05355 L
s
P
[(15)] .53046 .03912 .73498 1 Mshowa
p
.001 w
.26259 .12034 m
.26611 .12309 L
s
P
p
.001 w
.29272 .1126 m
.29622 .11536 L
s
P
p
.001 w
.32306 .10481 m
.32653 .10758 L
s
P
p
.001 w
.35361 .09696 m
.35704 .09975 L
s
P
p
.001 w
.41532 .0811 m
.41869 .08393 L
s
P
p
.001 w
.44649 .0731 m
.44983 .07593 L
s
P
p
.001 w
.47787 .06503 m
.48119 .06789 L
s
P
p
.001 w
.50948 .05691 m
.51276 .05978 L
s
P
p
.001 w
.20292 .13567 m
.2065 .13839 L
s
P
p
.001 w
.17339 .14326 m
.17699 .14596 L
s
P
p
.001 w
.14404 .1508 m
.14767 .15348 L
s
P
p
.001 w
.57334 .04051 m
.57655 .04341 L
s
P
p
.001 w
.6056 .03222 m
.60878 .03513 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30054 .03702 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004T0
0ol300;o0`03o`800ol20003o`0003000ol300?oP00004P000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<@000ol000050003o`0007d0001<0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<@000ol000050003o`0007d0001900?o0P001_l00?l0o`8000Ko003o0?l20003o`000340
00?o00000P03oa/01?mQ0000B0000ol0000400;o0P001Ol00?l000Ko=0000ol000020003o`0001L0
1?l20003o`3o060000180005o`000?l030000ol0o`0e00;o1004oa801?l60004o`00oel0001900?o
3`000ol0001;00Co0P000ol0000300Co0P000ol0001L0000Y@04o`P01Ol00h7oP@04oed0002R00?o
0P000ol0000300Oo0h401?n1ool20003o`0005X0002N00Co1`08o`>100?oPOl00_l00h7oo`020003
o`0005T0002J00Go1P08o`R100?oPOl00h42o`8000?o0000F00006H00ol400;o9`04o`D000?o0000
1_l4P@03oh6100Co00Fkbk_;o`04P@;o00<0ool0F@0006L000?o00000P001?l00?lR00Co2006o`V1
0_l8^`03oh6100>10_l20003o`0005H0001W0003o`00008000Co003o7P04o`@000Co00001_l3P@03
oh6100Go00jkbk_;^l^kbk_;^l_ob`>11?l20003o`0005D0001W0003o`00008000Co003o6P04o`P0
1Ol9P@;o4K/00onk^`02o`>10_l20003o`0000P00om90000I`000ol000020004o`00oaH01?l30003
o`0000801Ol3P@03oh6100Go01W;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;00F10_l20003o`0000X0
00?o0000AP0006H00_l500;o4`04o`P01Ol8P@;o6[/00onk^`02^`J10_l00`3oo`0:0003o`0004H0
001o00?o0`000ol0000200Go0h400on1P@04o`0T^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^onkbk_;1843o`<000?o00001003odT0001k00Co1`05o`R10_lS^`04ok^k^`Go0h401Ol0003o00D0
00?o0000B@0007L01?l00`3o000400Oo1X43o`0Vbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/4o`B100?oPH400X42o`:100?o00000P04odP0001c00Co2007o`>100?oPH400olU^`Go
28400on1P@02P@;o0P000ol0001=0000@`03obT01?l00`3oP@0500Oo2842o`0Sbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01Ol3P@;o2H400on1P@04o`8000?o0000C00004H000?o0000
8P04o`H000?oPOl01_l3P@03oh6100Co3K/4oa:k1?l9P@03oh6100R10_l3P@;o0P000ol0001;0000
AP000ol0000N00Ko1P06o`V10_l03L^kbk_;^l^kbk_;^l/01?l4F`0=ol^kbk_;^l^kbk_;^`05o`>1
00?oPH401h42o`:11Ol00k_;^`05P@;o00<0ool0C00004<00olM00Co2006o`B100?oPH401?l4P@03
ok^k00Rk0_l9F`03ok^k00Nk0_l9P@03oh6100J100CoPOoo2K/5P@;o0P000ol000190000@`000ol0
000I00Ko1P06o`V10_l9P@0=ol^kbk_;^l^kbk_;o`09F`0<ol^kbk_;^l^kbk_o2H400on1P@06o`0=
^l^kbk_;^l^kbk_;^`03P@Co0P000ol000180000@`04oaD00ol800Ko0h400on1P@05o`>k00?oPH40
28400onk^`09^`03oe]K00MK0_l9^`03oh6100N10_l5^`03ok^k00bk0_l3P@;o0P000ol000170000
F004o`L01_l8P@;o00Zkbk_;^l^kbk_o2X403Oo;^l^kbk_;^l^kbol00U/4o`AK00_o^l^kbk_;^l^k
o`02P@Co18405_o;^l^kok_;^l^kbk_;^l^kbk_;^l/4P@;o00<0ool09P05o`050?ooo`000ol300;o
400005@01?l40003o`0000Ko0h400on1P@04o`jk00?oPH401Ol?^`;o2E/00onk^`07^`;o2H401Onk
^k_o016k0h400on1o`020003o`0002<000?o00000P001?l00?l40004o`00oa40001@00Co2005o`R1
0_l04K_;^l^kbk_;^l^kbk_;^l^k00Co01K;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2U/02onkbk_;^l^k
bk_o00Z101Kobk_o^l^kbk_;^l^kbk_;^l^kbk_;0_l3P@03o`0000;o8`000ol0000300?o0P02o`<0
00?o00003`0004`01?l40004o`0000Co18400on1P@04oa6k1?l4F`03ok^k00Nk0ol9^`03oe]K00QK
00?o^k/01k/00on1P@08P@03ok_o01>k1H401Ol0003o02801Ol30003o`3o00D000?o00003`0004P0
1?l00h40000500Co2H42o`0A^l^kbk_;^l^kbk_;^l^kbk/01?l9F`06ol^kbk_;0ol3P@0;ol^kbk_;
^l^kbol00U/5o`=K00_o^l^kbk_;^l^ko`02P@Go0h42o`0D^l^kbk_;^l^kbk_;^l^kbk_;^l/5P@03
o`3o00;o8@000ol0000300;o0`03o`040?oooa00001400Co10001?n10004o`B100?oPH401?lA^`Co
15/00omKF`07F`03ok_o00;o1h400onk^`07^`;o2E/00onk^`07^`;o2H400onk^`0C^`>11?l20003
o`0001h000?o00003@000ol0000?0000@004o`P01?l9P@;o01>kbk_;^l^kbk_;^l^kbk_;^l^k00;o
2E/00omKF`07F`03oh6100V100cobk_;^l^kbk_;^ol9F`0<ok_;^l^kbk_;^l_o2842o`0Ebk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;o0h42o`8000?o00002003o`@00_l<00Go7@0003`01?l40004o`0000Co
18400on1P@04oaVk00?oFe/01e/00omKF`04o`Bk0_l9P@03ok^k00Rk00?oFe/01e/00onk^`08^`03
oh6100F100CoPOoo5;/5P@;o0P000ol000080003o`00008000Co003o;@0003T00ol800Co2H42o`0A
^l^kbk_;^l^kbk_;^l^kbk/00ol02k_;^l^kbk_;^l_o00UK0_l02k_;^l^kbk_;^l_o00:11?l3P@0<
ol^kbk_;^l^kbk_o0U/4o`0?^l^kbk_;^l^kbk_;^l_o00:11Ol3P@0Eok_;^l^kbk_;^l^kbk_;^l^k
bk_;00J11?l90003o`00008000Co003o;@0003D01?l30004o`0000Co18400on1P@04oa6k1?l3F`03
ok^k00Rk00?oFe/01?l=^`Co28400onk^`08^`;o4k/2o`B100?oPH400X400onk^`0B^`B10ol20003
o`0000H000?o00000P001?l00?l]0000<@04o`L01?l9P@;o016kbk_;^l^kbk_;^l^kbk_;^`04o`QK
00_o^l^kbk_;^l^kb`02o`0<^l^kbk_;^l^kbk_;1Ol3P@03oh6100N102;obk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_o0h400on1P@03P@0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0h401?l0
0?l70003o`00008000Co003o;@0002d01?l30004o`0000Co18400on1P@04oa6k1?l3F`03oe]K00MK
00?o^k/04K/4o`V100?oPH401h400onk^`0N^`03oh6100Co0h400onk^`0B^`J100CoPH7o1@02o`D0
0_l^0000:`02o`L01?l9P@;o01>kbk_;^l^kbk_;^l^kbk_;^l^k00;o25/00omKF`07F`0?ok_;^l^k
bk_;^l^kbk_;00Co18400on1P@07P@03oh6100Co02C;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/3o`N101Go^l^kbk_;^l^kbk_;^l^kbk_;^l/01X401?l00?lk0000:`000ol0o`0200Co
18400on1P@04oaRk00?oFe/01e/00omKF`04o`fk1?l9P@03oh6100N10_lA^`Co5;/2o`R100?o^k/0
4[/4P@?o0P000ol0000h0000:`000ol0o`02o`V10_l07[_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`UK0_l03L^kbk_;^l^kbk_;^l/01?l4P@03oh6100N100?oPH401?l04L^kbk_;^l^kbk_;^l^k
bk_;00Co15/05_o;^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@;o01?;^l^kbk_;^l^kbk_;^l^kbk_;00?o
0h400ol00002ocP0000[00;o0h400on1P@04ob:k00?oFe/01?l=^`Co2H400on1P@07P@;o4k/2o`UK
00?o^k/04[/00on1P@04o`B100?o^k/04K/6P@03o`3o00;o=`0002/00_l4P@;o02Nkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l03L^kbk_;^l^kbk_;^l/01?l4P@03oh6100N1
00?oPH401?l06/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o2E/04oo;^l^kbk_;^l^kbk_;^l^kbk/0
1?l9P@0Dol^kbk_;^l^kbk_;^l^kbk_;^l/6P@05o`000?l0=P0002800_l60003o`0000;o18400onk
^`0a^`;o2H400on1P@07P@;o7[/00omKF`04oa6k1?l0187oPOl:P@03ok^k016k1844o`8000?o0000
<`00024000Co003o1@000ol000020003oh6100:103Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol9P@03oh6100Co0h408?o;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;0_l04K_;^l^kbk_;^l^kbk_;^l^k00Co1H401?n1POl:P@0Dol^kbk_;^l^kbk_;
^l^kbk_;^l/3o`B100Co003o=000024000Co003o1@000ol000030003oh6100:100?o^k/09K/4o`Vk
00?oPH401h42o`R100?o^k/0:k/4o`>100?oPH400h401On1PH7o00:11OlH^`J11?lc00008@001?l0
0?l50003o`0000@000?oPH400X42o`0Qbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co
15/02oo;^l^kbk_;^l_o00:11?l3P@03oh6100N101Cobk_;^l^kbk_;^l^kbk_;^l^kb`?o01;;^l^k
bk_;^l^kbk_;^l^kbk/4o`R100?oPH400X400on1P@02P@;o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk/4P@03oh7o008000?o0000<000024000Co003o1@000ol0000500;o18400onk^`0L^`;o
2E/00onk^`07^`;o28400on1P@07P@03ok^k00bk1?l3F`03ok^k00^k1?l3P@03oh6100N100?oPH40
1?lQ^`Go0X42o`8000?o0000;`0002800_l60003o`0000L000?oPH400X408Oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;o`09F`0;ol^kbk_;^l^kbol02H400on1P@04o`0?bk_;^l^kbk_;^l^k
bk_;00;o25/02oo;^l^kbk_;^l^k00;o28400on1P@07P@;o027;ol^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/01?l3F`03oh6100:10_l20003o`0002h0000Z0003o`0000P000?oPH400X400onk
^`0M^`03oe]K00MK0_l8^`03oh6100N10_lD^`03oe]K00MK00?o^k/02;/00on1P@07P@03oh6100Co
1K/00onk^`0I^`Co25/00on1P@02P@?o00<0o`00;P0002T00ol:0003oh6100:10_l07k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00U/4o`AK00[o^l^kbk_;^l_o0X44o`0=bk_;^l^kbk_;^l^k
b`03o`0:bk_;^l^kbk_;o`UK00cobk_;^l^kbk_;^ol9P@;o027;^l^kbk_;^l_obk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/01?l3F`03oe]K00MK00?oPH401?l20003o`0000P00ol300?o6`0002T000?o0000
2`02o`B10_lM^`;o2E/00onk^`06^`;o3K/4o`>100?o^k/01k/00omKF`04o`jk00?oPH401?l4P@03
ok^k00Jk00?o^k/04K/4o`QK00?oFe/01e/2o`>10_l20003o`0000P000?o00001@000ol0000H0000
:@000ol0000=0003oh6100>101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o25/04onk
bk_;^l^kbk_;^l^kbk_;^l/01?l8P@0:ol^kbk_;^l^kb`;o01>kbk_;^l^kbk_;^l^kbk_;^l^k00;o
2H406?o;^l^kbk_;ol^kbk_;^l^kbk_;^l^kb`Co0e/00omKF`07F`03oe]K00Co15/01?n1PH45o`T0
00?o00001@000ol0000H0000:@000ol0000?0003oh6100:10_lN^`03oe]K009K0_l2F`03ok^k00^k
1?l3P@03oh6100N100?o^k/07K/00on1P@07P@03ok^k00Bk00?o^k/02K/4o`QK00?oFe/01e/2o`UK
00KoPH7oPOl200;o1`000ol0000200?o6`0002T000?o00004002o`B101oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00Co012kbk_;^l^kbk_;^l^kbk_;0_l8P@03oh6100N10_l07k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X44o`>100gobk_;^l_obk_;^l^k00Go0e/00omKF`07F`03
oe]K00Co00Fkbk_;o`09F`;o0h401Ol0003o00H000?o00000P000ol0000K0000:@000ol0000A0003
oh6100>100?o^k/0<K/00on1P@06P@03oh6100Co1842oa^k1?l8P@03ok^k00:k00?o^k/01?l9F`03
oe]K00MK0_l9^`03oe]K00Co0e/00on1P@02P@05o`21POl01002o`@01?lJ0000:@000ol0000B0003
oh6100>103Go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
o`08P@;o2X405oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co0e/00on1P@07P@03ol^k00Co15/00omK
F`07F`03oe]K00Co00bkbk_;^l^kbk_;^l/4o`QK00?oPH400X42o`8000?o00009@0002T000?o0000
4`000h7oP@03P@;o<[/00on1P@03o`B10_l9P@03ok^k016k0_l8F`03oh6100N10_l00e_oF`06F`03
oe]K00=K0_l2F`;o3;/4o`=K00?oFe/01e/00on1P@04o`8000?o0000900002T000?o00004P000h40
0002o`B103?obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l9P@03oh6100Co01S;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol9F`03oh6100Co1842o`QK1Ol03[_;
^l^kbk_;^l^kbk_;1?l8F`03oe]K00MK0_l3P@;o0P000ol0000S0000:003oa<000>100000P000on1
P@02P@03ok^k036k00?oPH401h42oabk00?oFe/01e/2o`V100?oFe/01?l3F`03ok^k00^k1?l3F`03
oe]K00MK00?oFe/01?l4^`B11OlT0000:0000ol0000C0003P@0000@000CoPH610_l08k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Ko00[;^l^kbk_;^l_o0X44o`>101oobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o009K1?l01L^kbk_o00R10ol8F`0;ok_;^l^kbk_;^l/00_l8F`03
oe]K00MK0_l02K_;^l^kbk_;^`03P@03oh7o008000?o00008@0002P000?o00004`000h40000500;o
0h400onk^`0L^`Co1U/00onk^`07^`;o28400onk^`0K^`;o2K/00on1P@04o`04^onko`UK00?o^k/0
2;/00omKF`07F`03oe]K00Co3[/2o`>100Co003o8P0002P000?o00004`000h4000060003oh6100:1
023o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`UK00_obk_;^l^kbk_;o`09P@0Yol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l02L^kbk_;ol^ko`09F`;o00[;^l^k
bk_;^l_o1E/2o`9K0_l04[_;^l^kbk_;^l^kbk_;^l^kb`J100Co0?oo8@0002P000?o00004`000h40
00070003oh6100:100?o^k/07;/00omKF`07F`;o2;/00on1P@07P@;o;K/01Onk^k_o009K1?l4F`03
ok^k00Nk1Ol5F`03ok^k016k1X401?l00?lP0000:0000ol0000C0003P@0000P000?oPH400X42o`0N
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0U/4o`AK0_l02<^kbk_;^l_o0X44o`B10_l0<<^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;^`;o2E/02oo;^l^kbk_;
^l_o00UK01Cobk_;^l^kbk_;^l^kbk_;^l^kb`B10ol20003o`0001d0000X0003o`0001<000>10000
2@02o`B10_lL^`;o2U/00onk^`05^`;o2X400onk^`0X^`03ok^k00Bk00?oFe/01e/00onk^`07^`03
oe]K00MK0_lB^`?o0X42o`8000?o0000700002P000?o00004`000h40000<00F101ko^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2o`UK00Wobk_;^l^kbk/00_l9P@0col^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;^l_o009K1?l3F`0;ol^kbk_;^l^kbol00U/4o`AK
01Co^l^kbk_;^l^kbk_;^l^kbk_;^`B11OlM00009`000ol0000D0003P@0000d000?oPH400X42oafk
00?oFe/01?l=^`03oh6100Co00F1g9GLU@05^`CL1K/01>cLk=`5^`?/00>g^k/00k/01>cLk=`4^`03
ok^k00>k1?l8F`03ok^k00Nk0_l9F`03ok^k016k0h401On1o`3o01d0000W0003o`0001<000>10000
3`02o`B101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l06k_;^l^kbk_;^l^kbk_;^l^kbiGL
UMbEg9GLU@09g00;k=c/g>cLk=c/g>`02=`:k006bk_;^onk1?l3F`03oe]K00MK00cobk_;^l^kbk_;
^ol9F`0Dok_;^l^kbk_;^l^kbk_;^l^kbk/2o`03bk_;00;o7@0002L00olC0003P@00010000?oPH40
0h400onk^`09^`Aa1k/4o`=K00CogIFE3k/02IGLUMbEg9GLP@08g00:^mc/g>cLk=c/^`S/00^kg>cL
k=c/g>bkg002k003^ooo00;o25/00omKF`07F`03ok^k00Rk00?oFe/01?l3F`03ok^k00Zk1?l5P@>k
00?o00006`0002L000?o00004`000h40000A0003oh6100>10_l01K]agW7N00Ma00CMLK_;1?l8F`:E
01EaUIG;^l^kbk_;^l^kbk_;UMbEg9D00h401?oLg=`2o`0=^l^kbncLk<^kbk_;^`03g006^l^kbk_;
0n`02/^kbk_;^ncLk=`2F`03oe_o00QK00?oFe/01?l03<^kbk_;^l^kbk_;^`Co25/02?nkbk_;^l^k
1?l6P@Co0P000ol0000K00009`000ol0000C0003P@0001@000ONLMiagW7N00Qa00>kgMd00W400omK
F`02F`;o1U/4U@;M00=a^k/03;/3U@03g?n100F100?o^k/06K/4o`06Fnc/k5_o0U/00omKF`02F`;o
0U/2o`bk1?l3F`03oe]K00MK00?o^k/01?l9P@03o`0000D000?o00006P0002L000?o00004`000h40
000D0008LMiagW7NLK/3L@05^l^kbk/00_l00meag@06F`03oe]K009K00>ELID01YD02;_;^l^kbk_;
1iD00mbEP@07P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l4F`06oe_Lk=co0e/4o`0>bk_;^l^k
bk_;^l^kbk/4o`QK00?oFe/01e/2o`J11?l;0003o`0001X0000W0003o`0001<000>1000050001Mia
g]ia00:100?o^k/02;/01?magG46F`03LIEa00Ea0iD00mea^`03^`0;UMcLUMbEg9GLUK/00YD9P@;o
4[/2o`UK00CoFnc/0_l@^`Co15/00omKF`06F`03oe]K00Co0X44o`>100?o00003@000ol0000J0000
9`000ol0000C0003P@0001H000J1gW7NLH42o`0Kbk_;^l^kbk_;omeagG7MLMeagG6ELIFkbk_;00:E
00?LUID029D02L^kbk_;^l^ko`02P@Co18402?o;^l^kbk_;0ol02/^kbk_;^l^kbol2F`037emK00AK
016gk>co^l^kbk_;^l^kbk_;^`04o`UK00?oFe/00U/2o`9K0_l5P@?o5@000ol0000J00009`000ol0
000C0003P@00010000=ag]h01Mh00g7NL@03P@03ok^k00Nk00WoUG6ELIEaUG402K/02=bEg9GLUMbE
3K/2o`V100?o^k/01?l3F`03ok^k00Nk00dOGelO]nbgk;O/]nco00Vk1?l4F`03oe]K00MK1?l4P@Go
00<0P@005`000ol0000J00009P000ol0000D0003P@00010000MagW7NLMia00?N00=aPH400X406oo;
^l^kbk_;^l]agG7;^l^kbk_;^l^kbk_;^`03U@0E^l^kbk_;^l^kbk_;^l^kbk_;^l_o00V10_l8F`05
ol^kbk/01Ql03nbgk;O/]nbgbk_o^l^kb`05o`UK00?oFe/01?l9P@;o1@000h40000F0003o`0001X0
000V0003o`0001@000>100003`04gPEa00GOg]oNo`03P@;o<;/00on1P@04o`AK00?oFe/01U/02amO
7elOGamO7k_/00:g00@OGalO0k/5o`EK00?oFe/01e/2o`J11?l:0003P@0001H000?o00006P0002H0
0_lD0003P@0000h02mh200?N03COoh7Og]oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;1?l9F`0:oe]KFamO7elOG`<O00>kbk/01;L00l/O7`027`06Gl^kok_o25/00omK
F`04o`V100?o00003@000h40000E0003o`0001X0000V0003o`0001<000>100003P002G7NLMiagW7N
P@02L@<000CNgmkO1Mh00onk^`0W^`?o15/2o`QK00SoGelOGamO7`:k2KL2^`03GalO008O00Fkok^k
o`08F`;o1X44oa<000>100005@000ol0000J00009P000ol0000C0003P@0000h00mh50003P@000080
00KOg]oOg]l2gP?O0_l03k_;^l^kbk_;^l^kbk_;^`04o`0Bbk_;^l^kbk_;^l^kbk_;^l^k0_l9F`03
oe]K00?o0h437`04^l^kb`Rg012kbk_;^l^kbelOGonkbk_o0U/3o`V100?o00005@000h40000F0003
o`0001T0000V0003o`0001<000>100005P000h400002g`?N00KOg]kOg_l3gP03gonk00?O1k/3o`AK
0_l6^`?o2K/00omKF`07F`;o1X427`9O0k/00kJg]`0>^`8O1ol4P@Go6`000h40000F0003o`0001T0
000V0003o`0001<000>100005P000h400009gP03gon100?O00?Ngml00ml01;_;^l/2o`UK00?o^l/0
0ol3F`0;ol^kbk_;^l^kbol00U/4o`05bk_;^ol00h46G`0A7kNf][Nkbk_;^l^kbk_;^l/01_l4P@Go
8@000h40000F0003o`0001T0000V0003o`0001<000>100005P0028400=kOg]oN1P02g`?N1]l5^`03
oe]K00MK0_l7F`03ok^k00Nk0_l8^`06GamO7elO1kL2]PRk1?l5P@05oh61POl09P000h40000F0003
o`0001T0000U0003o`0001@000>100005P000h40000900;O00WNgmoOg]oNgol00ml01YoO^l^ko`9K
1?l4F`03oe]K00EK017obk_;^l^kbk_;^l^kbk]O7`06G`0?][Nf]kJg][O;^l^kbk_;00Co1X44o`03
084002L000>100005P000ol0000I00009@000ol0000D0003P@0001H000>100002@001]oNgmkOgP;O
00CNgh7o1Ml3^`;o2E/00omKF`02F`04oe]Ko`Zk00AO7elO0Ul01QmO^k_o]P:g0X437`03ok^k00Co
2H401ol0003o0840:0000h40000F0003o`0001T0000U0003o`0001@000>100005P000h400009000:
g]oNgmkOg_oNg`:100_ogmoOWmnkbk_;o`09F`Co00bkbk_;^l^kbk_;^l/2G`0>7elOGk_;^l^kbk^f
]kH3P@9O00>1ool01X44o`L000?o0840:0000h40000F0003o`0001T0000U0003o`0001@000>10000
5P000h4000090003gmkO00D000?oPH400X42o`05^moOgil00k/00omKF`04oa:k00=O7el02k/00kNf
]`03o`>10ol3P@03o`0000T000?o0840:0000h40000F0003o`0001T0000U0003oh7o01<000>10000
5`000h40000B000?oa7OWmnOgioOWmnkbk_;00;o026kbk_;^l^kbk_;^l^kbk_;^l^kbk_;5elOGk_;
^l^kbk/01?l3]PB100?o000040000ol0P@0X0003P@0001H000?o00006@0001D00ol400;o1`000ol0
P@0C0003P@0001L000>100004`002=nOgioOWmnk0]lJ^`8G00=O5aL00Ul6o`B100Co]kJg5P000ol0
P@0X0003P@0001L000?o0000600001H000?o00000P001?l00?l60003o`0000:14@000h40000G0003
P@0001<000FOgioOW`02g`;o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`095`=O28400onf]`03]QD0
00?o0840:@000h40000F0003o`0001P0000F0003o`00008000Co003o1P000ol000020003P@0000h0
00>100005`000h40000@00JO00COWmnO0X400onk^`0@^`TG0ol45`:10_l9]P03]`0001@000?oP@00
:0000h40000F0003o`0001P0000F0003o`00008000Co003o1@000ol0000400:13P000h40000F0003
P@00014000WOWmnOgil0Wml018404oo;^l^kbk_;^l^kbk_;4ALA5a4011L3o`F100=O5el00_l02;Nf
]kJg][Nf6P000on1000X0003P@0001H000?o0000600001H000?o00000P001?l00?l50003o`0000H0
00>100002`000h40000F0003P@0001400il3g`@000CoPH610_l9^`035a4G00@G0ol5P@Go0QL00h40
]P02]Ql000?o0840:0000h40000F0003o`0001P0000E00;o1@02o`H000?o00001`02P@/000>10000
5P000h40000>00:O00OOWmnOgioO00D00_l3P@0<ok_;^l^kbk_o4ALA0_l4P@?o2P001X40][Kl]Qh0
00?o0840:0000h40000F0003o`0001P0000T0003o`0000T000>1000020000h40000F0003P@0000h0
00OOWmnOgil000;O1`001On1PH7o00:k1?l00h4G5`025`054H61POl03@0018400003o1d000?o0840
:0000h40000F0003o`0001P0000T0003o`0000X00X480003P@0001H000>100003P001MnOgioO00:O
00>100001P034@:10_l3P@035a4A00@A00<G00003P000h40000200>f70000ol0P@0X0003P@0001H0
00?o0000600002@000?o000030000h4000050003P@0001H000>100004@000mnOg`03W`@00a400ilA
4@024@06^olG4ALA0QL0114G5aL24@l000>100000`04o1X000?o0840:0000h40000F0003o`0001P0
000T00;o3P02P@@000>100005`000h40000B0003ginO00^O11401ALA5a4G00@00a400aL0000=0003
P@0000@00[H00obf000H0003o`2102P000>100005`000ol0000G000090000ol0000?0005P@000840
6@000h40000D0003P@2O00:O0a4600<A00<G00001P035`l000>100001P000obfo00H0003o`2102P0
00>100005`000ol0000G00008`000ol0000A00:100<0P@0060000h40000D0003P@0000:O2@000olA
4@0:008A3`000h4000070003]_bf00H000Cl]_bf3@000ol0P@0X0003P@0001L000?o00005`0002<0
00?o00004`02PAT000>1000050000h40000;0003o`0001/000>100002003o007]KJe][Ff]@03]P`0
00?o0840:0000h40000G0003o`0001L0000S0003o`0001@00X4H0003P@0001@000>100002`000ol0
000K0003P@0000T000ffo;Kl]_bfo02e][Gl00/000?o0840:@000h40000F0003o`0001L0000S0003
o`0001@000>108405`000h40000D0003P@0000/000?o00006`000h4000090003]KJe00P000>fo;H0
2P000ol0P@0Y0003P@0001H000?o00005`0002<000?o000050000h400002PAD000>1000050000h40
000;0003o`0001/000>100005@000obeo0090003o`2102T000>100005P000ol0000G00008`000ol0
000D0003P@00008000>100004P000h40000D0003P@0000/000?o00006`000h40000F0003]_be00P0
00?o0840:@000h40000F0003o`0001L0000S0003o`0001@000>100000`02PA4000>100005@000h40
000;0003o`0001/000>100005`000kJe00070003o`2102T000>100005P000ol0000G00008`000ol0
000D0003P@0000D000>100003P000h40000E0003P@0000/000?o00006`000h40000G0003]Obe00L0
00?o0840:@000h40000G0003o`0001H0000R00?o50000h40000700:13P000h40000E0003P@0000/0
00?o00006`000h40000H0003]KJe00H000?o0840:@000h40000G0003o`0001H0000R0003o`0001@0
00>100002@000h40000;0003P@0001D000>100002`000ol0000K0003P@0001T00kD50003o`2102T0
00>100005`000ol0000F00008P000ol0000D0003P@0000X00X4;0003P@0001D000>100002`000ol0
000K0003P@0001X00kD40003o`2102T000>100005`000ol0000F00008P000ol0000D0003P@0000`0
00>1000020000h40000E0003P@0000/000?o00006`000h40000I00Be10000ol0P@0Y0003P@0001L0
00?o00005P00028000?o000050000h40000=00:120000h40000E0003P@0000X000?o000070000h40
000D0009]@fe3KD=]@fe00@000?o0840:@000h40000G0003o`0001H0000R0003o`0001@000>10000
3`000h4000050003P@0001D000>100002P000ol0000L0003P@0001800[D00`fe]@03]@L000?o0840
:P000h40000F0003o`0001H0000R0003o`0001@000>100004002P@D000>100005@000h40000:0003
o`0001`000>100001@000kD=3@0800Fe30000ol0P@0Z0003P@0001H000?o00005P00028000?o0000
50000h40000B0003P@00008000>100005@000h40000:0003o`0001`000>100000`0010fe]@d3]@80
20d00kD0000:0003o`2102X000>100005003P@03o`0001D0000Q0003o`0001D000>100004`001H40
002101L000>100002P000ol0000L0009P@fe3KD=]@fe00D=1[DA0003o`2102T000>100003`05P@<0
00?o00005@00024000?o00005@000h40000D00:100<0P@005P000h40000:0003o`0001T00Pd02;D=
]@fe3KD=1@03]@033@0001<000?o0840:@000h40000:00F120000ol0000E00008@000ol0000D0003
P@0001L00X4G0003P@0000X000?o000050002[D=]@fe3KD=]@d;008=5P000ol0P@0Y0003P@0000D0
1H4=0003o`0001D0000Q00;o5@000h40000G00>15P000h40000:0003o`00018020d20003P@000280
00?o0840:@000h400005PA8000?o00005@00024000?o000050000h40000G0004P@00PAD000>10000
2P000ol0000B008=00>e00001@000h40000R0003o`2102L01H4G0003o`0001D0000Q0003o`0001@0
00>100005`0018400002PA<000>100002P000ol0000B00@=1P000h40000R0003o`2102801H420003
P@0001L000?o00005@0000800olL0003o`0001@000>100005`000h4000030003P@0000l000>10000
2`000ol0000D00<=1@000h40000R0003o`2101d01H470003P@0001L000?o00005@00008000Co003o
6`000ol0000D0003P@0001L000>100001002P@l000>100002`000ol0000E00<=10000h40000R0003
o`2101P01H4<0003P@0001L000?o00005@00008000?o00006`000ol0000E0003P@0001L000>10000
1P000h40000<0003P@0000/000?o00005P043@8000>100008P000ol0P@0C00F14@000h40000H0003
o`0001@000020003o`0001/000?o00005@000h40000G0003P@0000L00X4<0003P@0000/000?o0000
5`043@03084002<000?o08403P05PAL000>100005`000ol0000D000000<0ool00_lK0003o`0001D0
00>100005`000h4000090003P@0000T000>100002`000ol0000I00043L`=PB@000?o08402@05PA`0
00>100005`000ol0000D00000P000ol0000K0003o`0001D000>100005`000h40000:00:12@000h40
000;0003o`0001X00`d200><00D=c0g<3@0J0003o`2100@01H4Q0003P@0001L000?o000050000080
00?o00006`000ol0000D0003P@0001P000>1000030000h4000060003P@0000/000?o00004002C003
S00000H00Pd00db<C002C005S0g<3L`06P000ol0P@04PBH000>100005`000ol0000D00008002oaD0
00>1000060000h40000=00:11P000h40000;0003o`0000h00d`018a<S4`30008S4b<C8a<S4`4S005
c0g<3L`05P02P@03oh6102X000>100005`000ol0000D000080000ol0000D0003P@0001P000>10000
3`000h4000030003P@0000/000?o00002@005Tb<C8a<S4b<C8a<S4b<C8a<S4b<C<`30004S4b<C0@=
4005P@8000?o0840:P000h40000G0003o`0001@0000P0003o`0001@000>1000060000h40000@00:1
0`000h40000;0003o`0000D02T`50005C8a<C8`00`000h40000400B<00@0c0g<2P05P@L000?o0840
:P000h40000G0003o`0001@0000P0003o`0001@000>1000060000h40000B0004P@00P@d000go002<
C8a<S4b<C8a<00/000=<S00010000h4000050005S4b<C0000Pd500F130000ol0P@0Z0003P@0001L0
00?o0000500001l000?o00005@000h40000G0003P@0001@00h4=0003oda<00I<5P000h4000050005
C8b<aX`00T`00lb1P@02PA4000?o0840:P000h40000H0003o`0001<0000O0003o`0001D000>10000
5`000h40000F0003P@0000/000CoC4b<4`04S0@000Z1S8b<C8a<S4b<0T`01Xa<S0g<3A<000?o0840
:P000h40000H0003o`0001<0000O0003o`0001D000>100005`000h40000F00>12`000om<C002C0/0
0X`01Tb<C8a<S09<00n<C8a<S4b<C8a<S4b<C8400P000hc60004c18000?o0840:P000h40000H0003
o`0001<0000O0003o`0001D000>100005`000h40000F0004P@00P@X000?o00000d`:00R<00<0S8`0
1X`3P@`000<=`0d04@000ol0P@0Z0003P@0001P000?o00004`0001l000?o00005@000h40000G0003
P@0001H000B100000X480004o`0000=<2@000db<C003S006aP00C8a<184?008=00?<`00040000ol0
P@0[0003P@0001L000?o00004`0001l000?o000050000h40000H0003P@0001H000>100000`000h40
00050003o`0000800T`00dd0000200;600J<aXc6S<H3S0>11@000h40000800W<4@000ol0P@0[0003
P@0001L000?o00004`0001l000?o000050000h40000H0003P@0001H000>100001002P@D000Go0000
C@03C0@02<H00h6<S0080003a/3600H000?<3@d01@dD0003o`2102/000>100005`000ol0000C0000
7`03oa@000>1000060000h40000F0003P@0000H000B100002D`30004PHc6S0C600?000001`000lK0
aP03`0D000?<3L`06@001?l0084Z0003P@0001L000?o00004`0000l01?l300;o1P000on1000E0003
P@0001P000>100005P000h400007000:PDa=C4e<CDa=00F11@03aP03`<K000802<H01<36`<H40005
c0g<3L`060000ol0P@0Z0003P@0001L000?o00004`00010000?o00000P001?l00?l50004o`21PA@0
00>1000060000h40000B0005C4e<08402P0014e<C?l5P@/00/H01<36`<H2`007a/36`<H0P@0200C0
0P06c1L000?o0840:P000h40000H0003o`000180000A0005o`000?l00P000ol000030005o`000840
4`000h40000H0003P@0001001Td00h4000030004C4e<C@9<00==POl050001<36`<H60005P@000<H0
0/000lK0c004c0033L`001D000?o0840:P000h40000H0003o`000180000B0004o`00o`8000?o0000
0`000ol0000200:14@000h40000H0003P@0000/000U=C4e<CDa=C4d00d`03Te<CDa=C4e<CDa=C03o
5@000lK0000600K<1<02c0043L`=c1H000?o0840:P000h40000H0003o`000180000?0004o`00o`80
00Co003o1@000ol0000400:13`000h40000H0003P@0000T024d400==00E<CDa=C0060003o`0001d0
0/`7`004a/0000?<5P000ol0P@0Z0003P@0001P000?o00004P0001000_l400;o1P000ol000060003
P@0000`000>1000060000h40000700==00=<C@0020001H5<C4a=00T000?o00007@002Lc0c<3<`<c0
0002`0<000<=c0005@000ol0P@0Z0003P@0001P000?o00004P0001h000?o00001`02P@`000>10000
5`000h40000300U<2P001840CDd:0003o`0001d00l0S0003o`2102X000>1000060000ol0000B0000
7P000ol0000900:12@000h40000H0006P@0004e<1Td=0003P@0000/000?o00007@000h40000S0003
o`2102X000>1000060000ol0000B00007@000ol0000<0003P@0000H000>1000060001H40001=009<
4P000h40000;0003o`0001d000>100008`000ol0P@0[0003P@0001L000?o00004P0001d000?o0000
3@02P@H000>10000600018400005CA0000>100002`000ol0000M0003P@0002<000?o0840:`000h40
000H0003o`000140000M00;o4002P@@000>1000060000h4000030004CDa=C0l000>100002`000ol0
000M0003P@0002<000?o0840:`000h40000H0003o`000140000M0003o`00014000F10000P@0J0003
P@0000D000==C4d03P000h40000;0003o`0001d000>100008`000ol0P@0[0003P@0001P000?o0000
4@0001d000?o00004P02P@03084001T000>10000100014e<CD`>0003P@0000/000?o00007@000h40
000S0003o`2102/000>1000060000ol0000A00007@000ol0000D00:16P000h40C@08C@h000>10000
2`000ol0000M0003P@0002<000?o0840:`000h40000H0003o`000140000M0003o`0001D00h4H009=
00I<CDa=C4dA0003P@0000/000?o00007@000h40000S0003o`2102/000>1000060000ol0000A0000
7@000ol0000E0004P@00PAL000==C4d05P000h40000;0003o`0001d000>100008`000ol0P@0[0003
P@0001P000?o00004@0001`000?o00005P0018400002PAD014dE0003P@0000/000?o00007@000h40
000S0003o`2102/000>1000060000ol0000A000070000ol0000E0003P@0000@00X4C0003P@1=009=
50000h40000;0003o`0001d000>100008`000ol0P@0[0003P@0001P000?o00004@0001`000?o0000
5@000h4000060003P@00010000>100000ddC0003P@0000/000?o00007@000h40000S0003o`2102/0
00>100006@000ol0000@000070000ol0000E0003P@0000L00X4@0004P@0000A=4@000h40000;0003
o`0001d000>100008`000ol0P@0[0003P@0001T000?o0000400001`000?o00005@000h40000900:1
3@000h40000300E=3`000h40000;0003o`0001d000>100008`000ol0P@0/0003P@0001P000?o0000
400001`000?o00005@000h40000;0003P@0000X000>100001@05C@d000>100002`000ol0000M0003
P@0002<000?o0840;0000h40000H0003o`000100000L00;o5P000h40000<00:12P000h40000700A=
0`001VI=ITeVC@<000>100002`000ol0000M0003P@0002<000Co0021:`000h40000H0003o`000100
000L0003o`0001D000>100003P02P@P000>100002@0:C@05ITd008403@000ol0000M0003P@0002<0
00Co0021:`000h40000H0003o`000100000K0003o`0001H000>1000040000h4000050003P@0000T0
00I=ITeVCFH30006CFI=ITf13@000ol0000M0003P@0002<000Co0021:`000h40000H0003o`000100
000K0003o`0001H000>100004@02P@D000>100005004C@H000A=ITeV0`000ol0000M0003P@0002@0
00?o0840:`000h40000E00>100?o0000400001/000?o00005P000h40000C00:10`000h40000F0003
CFI=00MV0Th30003o`0001d000>1000090000ol0P@0[0003P@0001001H430003o`000100000K0003
o`0001D000>100005P02P@03084001P000IVCFI=ITd2IP9=00E>0000o`0O0003P@0002@000?o0840
:`000h40000;00F12@000ol0000?00006`000ol0000E0003P@0001P00X4H000<PFIVCFI=ITeVCFI=
0`000ol0000M0003P@0002@000?o0840:`000h40000500J13P000ol0000?00006`000ol0000E0003
P@0001T00X4G0009PFIVCFI=ITeV00H000?o00007@000h40000T0003o`2102/000>100001H4D0003
o`0000l0000K0003o`0001D000>100006@001840PH4E0004PDeVC@/000?o00007@000h40000T0003
o`2102P01X4I0003o`0000l0000K0003o`0001D000>100006@001H40002101@000J1CFI=ITd90003
o`0001d000>1000090000ol0P@0S00F10`000h40000I0003o`0000l0000J0003o`0001H000>10000
6@000h40000200:14P001h4006I=ITd020000ol0000M0003P@0002@000?o08407P05P@T000>10000
60000ol0000?00006P000ol0000F0003P@0001T000>100001002PA0000>100000P000deVC@070003
o`0001d000>1000090000ol0P@0H00J13P000h40000H0003o`0000l0000J00?o5P000h40000H0003
P@0000L000>100003@0018400002IP03CFH000H000?o00007@000h40000T0003o`2101<01H4D0003
P@0001P000?o00003`0001X000?o00005P000h40000H0003P@0000P00X4<00QV00=>00001@000ol0
000M0003P@0002@000?o08403P05PAT000>1000060000ol0000?00006P000ol0000F0003P@0001P0
00>100002P02P@P000=VCVH01FH90003o`0001h000>1000090000ol0P@0800J17P000h40000I0003
o`0000h0000J0003o`0001D000>100006@000h40000<0003P@0000D00fH00h40000;0003o`0001h0
00>100008@05o`04P@0000F190000h40000I0003o`0000h0000J0003o`0001D000>100006@000h40
000=00:11@05IP`000?o00007P000h40000L00Go0`02P@04oh61PBT000>100006@000ol0000>0000
6P000ol0000E0003P@0001T000>100003`02P@D000AVCVI>2`000ol0000N0003P@0001H01_l300F1
0P000h7oo`0Z0003P@0001T000?o00003P0001T000?o00005P000h40000I0003P@0001400X440004
PFIVIPX000?o00007P000h40000A00Go1005P@L000B1003o:@000h40000I0003o`0000h0000I0003
o`0001H000>100006@000h40000C0009P@000840CVI>00T000?o00007P000h40000<00Go0`06P@`0
00B100000_lW0003P@0001T000?o00003P0001T000?o00005P000h40000I0003P@0001@00X402021
06I>ITiV1`000ol0000N0003P@0000H01_l300F14P000h4000030003o`0002@000>100006@000ol0
000>00006@000ol0000F0003P@0001T000>100005P02P@<000A>ITiV1P00149V@VHM0004P@0000Go
1005PAL000>100001002ob@000>100006@000ol0000>00006@000ol0000F0003P@0001T000>10000
5`02P@@000=VCTh01fH00diV000J00Ko0`06PA`000>100001P000ol0000R0003P@0001P000?o0000
3P0001T00_lG0003P@0001T000>100005`001840PH43000<IT9V@VI2IT80@VI25@05o`8000>10840
184R0003P@0000L00_lR0003P@0001T000?o00003@0001T000?o00005P000h40000I0003P@0001L0
00B100000X40101VIVH40003o`1>00A>3P05o`@01H4X0003P@0000P000?o00007`000h40000I0003
o`0000d0000I0003o`0001D000>100006P000h40000G0003P@0000<000>100001@002?l00012IT9V
1`06o`<01X430003P@0002L000>100002@000ol0000N0003P@0001T000?o00003@0001T000?o0000
5@000h40000I0003P@0001P000>100001002P@D000?o00000`0014i2IP05o`@01H490003P@0002L0
00>100002P02oah000>100006@000ol0000=000060000ol0000F0003P@0001T000>1000060000h40
000600:10`001?l00006o`<01X4>0003P@0002L000>1000030000ol0000K0003P@0001T000?o0000
3@0001P000?o00005P000h40000I0003P@0001P000>1000020000h40o`04o`<000=2CT800T800h40
000B0003P@0002L000>100003@02oa/000>100006@000ol0000=000060000ol0000F0003P@0001T0
00>100005`000h40000500Ko00B1o`001H401@1>@Ti201@000>100009`000h40000?0003o`0001P0
00>100006@000ol0000=000060000ol0000F0003P@0001T000>100005`000h400005o`L000?oPH40
2003@Q<000>100009`000h40000@00;o60000h40000I0003o`0000d0000H0003o`0001H000>10000
6@000h40000E00Go30000ol0000900924`000h40000W0003P@00018000?o00005@000h40000J0003
o`0000`0000H0003o`0001H000>100006@000h40000?00Ko0P000h40000<0003o`0000T000=2C`00
4P000h40000W0003P@0001<00_lE0003P@0001X000?o0000300001P000?o00005P000h40000I0003
P@0000X01Ol80003P@0000`000?o00002@000d9?C`0B0003P@0002L000>100005@000ol0000C0003
P@0001T000?o0000300001P000?o00005P000h40000I0003P@0000@01_l=0003P@0000`000?o0000
2@05@Q0000>100009`000h40000F00;o4`000h40000I0003o`0000`0000G0003o`0001H000>10000
6P000h40o`04oa<000>1000030000ol0000;0004Cdi?CPl000>100009`000h40000H0003o`000100
00>100006@000ol0000<00001`03o`@00_l70004oh7ooaD000>100005P06oaP000>1000030000ol0
000=00=23P000h40000W0003P@0001T00_l@0003P@0001T000?o0000300000X000Co003o0P000ol0
00040004o`21PAD000>100004@05o`@000>100005`000h40000<0003o`0000h000=2C`003@000h40
000W0003P@0001/000?o00003@000h40000I0003o`0000`0000:0004o`00o`8000?o000010001?l0
0002PA<000>100003005o`T000>100005`000h40000<0003o`0000h000=2Cdl03@000h40000S0005
824P08407P02o`d000>100006@000ol0000<00002002o`<000Co003o1P000ol0000300:14@000h40
000600Ko3@000h40000H0003P@0000`000?o00003P00149?@Tl<0003P@0002<000<P8B400R4380/0
00<_8Bl03`000ol0000:0003P@0001T000?o0000300000X000Co003o0P000ol000040003o`0000D0
0X4?0004P@0000Go4`000h40000H0003P@0000`000?o000040000dm2C`0;0003P@0002<000<Q8240
0b000b4P8@0:00058R4_;b803P02o`X000>100006P000ol0000;00001`03o`@00_l70003o`0000L0
00>100002P06oaP000>1000060000h40000<0003o`00014000A?@Tm22@000h4000030003?dm?01d0
00DP8B0Q80028@<P2@001b8Q8R4_8Bl03P000ol000070003P@0001X000?o00002`0001L000?o0000
2002P@D01Ol20003P@0001T000>1000060000h40000<0003o`00018000E?@Tm2C`070003P@0000<0
00E??dloC`0=00=?3@048@04800Q808Q00D_8BlQ00028@H_00<R00003@02o`L000>100006P000ol0
000;00005P000ol0000;00Go1`000h40000I0003P@0001P000>1000030000ol0000D0004@Tm2C`H0
00>100000`000b1??`03C`03?`0000T01Cl=0003824Q00PQ00T_8BlQ;b4R;b800Rl=00@R00?o8R80
10000h40000J0003o`0000/0000F0003o`0000D01_l200:120000h40000I0003P@0001P000>10000
30000ol0000F0003Cd9?00<024l013m??dl2?`03C`0000T000=??cl00dl00cl000090009PB4_8BlQ
;b4_00DQ1@03;`H000<R;b802B800olR00030003P@0001X000?o00002`0001H000?o00001Ol:00:1
1@000h40000J0003P@0001P000>1000030000ol0000G00m?00<oCcl00Tl50005?dloCcl00Tl013m?
?dl2?`/000B18B4Q1R000b4P000700098B808RlR;b8_00LR10000b;oo`040003P@0001T000?o0000
2`0001H00olA00:10`000h40000J0003P@0001P000>1000030000ol0000G00I?00<0P@00200A?`04
Ccm?C`/000>182000b001Sl0000P8@P000TR;b8_8RlR;b802`0011lR7ol30003P@0001T000?o0000
2`0001P00_lB00:100<0P@006`000h40000H0003P@0000/000?o00007`000h400008000<Ccm??dlo
Ccl0?dlo1@000dloC`030003Ccm?00`o3@0012lR;b8B00067b;oo`216`000ol0000;00006P02oa80
0X4L0003P@0001P000>100002`000ol0000O0003P@0000P00cl?00lo0`0282@000DR7b;oP@0K0003
o`0000/0000L00;o4@03PAX000>1000060000h40000;0003o`0001l000>100006P001Sm??dloC`P0
00>10000:0000alR;`02oa/000?o00002P0001h00_l?0003P@0000:160000h40000H0003P@0000/0
00?o00007`000h40000X0003P@0002T012800ol0000H0003o`0000X0000P00;o3@000h4000020003
P@0001D000>1000060000h40000;0003o`0001l000>10000:0000h40000[00037blO00;o60000ol0
000:00008P000ol0000:0003P@0000<00X4E0003P@0001P000>100002`000ol0000O0003P@0002P0
00>10000:`001X4R8R80oaL000?o00002P0002<00_l:0003P@0000D00X4B0003P@0001P000>10000
30000ol0000O0003P@0002P000>10000:`0018407b8200;o5@000ol0000:00009@02o`P000>10000
1`02PA0000>1000060000h40000<0003o`0001l000>10000:0000h40000[0003P@0O008R0`000ol0
000B0003o`0000X0000W00;o1@000h40000:00:13P000h40000H0003P@0000`000?o00007`000h40
000X0003P@0002/000N101lR7b8O00800_lB0003o`0000X0000Y00;o0`000h40000<00:130000h40
000H0003P@0000`000?o00007`000h40000X0003P@0002/000R100008QlR7`<000?o00003`000ol0
000:0000:`02o`03084000l00X4:0003P@0001P000>1000030000ol0000O0003P@0002P000>10000
;0000h40000200<O0`02o`l000?o00002P0002d00_lB00:120000h40000H0003P@0000`000?o0000
7`000h40000X0003P@0002`000>100000`027`D000?o00003@000ol000090000;P000h7oo`0B00:1
1P000h40000H0003P@0000`000?o00007`000h40000X0003P@0002`000>100000`000b8O000500;o
3@000ol000090000<@02oa800X440003P@0001P000>1000030000ol0000O0003P@0002P000>10000
;0000h40000=0003o`0000L00h400ol000090000<`02oa8000F10000P@0J0003P@0000`000?o0000
7`000h40000X0003P@0002`000>100003P000ol00006P@<000?o00002@0003D00_lA00:100<0P@00
6@000h40000<0003o`0001l000>10000:0000h40000/0003P@0000/01842o`T000?o00002@0003L0
0_lA00:16P000h40000<0003o`0001l000>10000:0000h40000/0003P@0000@01h460003o`0000H0
00?o00002@0003T000?o00003`03PAP000>1000030000ol0000O0003P@0002P000>10000;007P@h0
0_l60003o`0000T0000j00;o3`000h400002PAH000>1000030000ol0000O0003P@0002P000>10000
9`06PAH000?o00000`000ol000090000?002o`d000>100000P02PA@000>1000030000ol0000O0003
P@0002P000>100008@06P@D000>100005@02o`<000?o00002@0003h00_l:0003P@0000D00X4B0003
P@0000`000?o00007`000h40000X0003P@0001/01X4;0003P@0001L000Go0000o`0:0000@002o`P0
00>100001`02PA0000>1000030000ol0000O0003P@0002P000>100005@06PA4000>100006002o`03
0?l000T0001200;o1P000h40000900:13P000h40000<0003o`0001l000>10000:0000h40000>00N1
60000h40000I00;o2P0004@00_l40003P@0000/000>100002`000h40000<0003o`0001l000>10000
:0000h40000800J17`000h40000G00Co2P0004H00_l20003P@0000`00X4;0003P@0000`000?o0000
7`000h40000Y0004P@0000J19@000h40000A00Ko3P0004P00_l00h40000>00:12@000h40000<0003
o`0001l000>100009`06PB/000>100002P07oa@0001:00;o4@02P@L000>1000030000ol0000O0003
P@0002401X420003P@0002`000>100001006oa/0001<00;o4@02P@D000>1000030000ol0000O0003
P@0001/01X480003P@0002`000>1ool01?lQ0000CP02oa400X430003P@0000`000?o00007`000h40
000E00J13P000h40000W00Ko9`0005000_lA00>13`000ol0000O0003P@0000h01h4D0003P@000240
1_l]0000DP000ol0000@00:13P000ol0000O0003P@0000P01X4K0003P@0001X01olc0000D`02oa00
00B1086130000ol0000O0003P@0000801X4Q0003P@0001@01_lj0000E@02o`h000B100000X4:0003
o`0001h01X4W0003P@0000h01_m00000E`02o``000>100000`000h4000060003o`0001T01X400`21
000Z0003P@0000P01_m60000F@02o`X000>100001002P@H000?o00004`06P@L000>10000:@000h40
000200KoC00005/00_l80003P@0000H00X440003o`0000`01h4=0003P@0002L01omB0000G@02o`H0
00>100002002P@8000?o00001P06PA@000>100008@06oeT0001O00;o10000h40000:00:100?o0000
1X4J0003P@0001/01_mO0000H@02o`8000>1000030000on1P@0P0003P@0001D01_mU0000H`02o`03
P@0000`000?o000080000h40000?00KoJ`0006D00_l=0003o`00020000>100002007og40001W00;o
2`000ol0000P0003P@0000801_mh0000J@000ol000080003o`0001l01_mn0000JP02o`P000?o0000
6@06oh@0001/00;o1P000ol0000C00KoRP0006h00_l40003o`0000`01on@0000L002o`8000?o0000
1P06oiL0001b00?o0P06oid0001d00?oX`000?l06`000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`000?l06`000?l06`0007H000?o00009`000ol0001g0000D@04o`<01?l0103oo`02o`80
0_l300?o0`03o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go
0P03o`<00_l300?o1003o`<00_m80000D0001Ol0003o008000?o00000`001?l00?l300;o1P000ol0
00030003o`00008000?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o000010000ol0
00070003o`0000D000?o00000P001?l00?l200;o1P000ol000020003o`0000800_m80000D0000ol0
o`02o`801Ol01@3o003o00/000?o00000`000ol0000>0005o`000?l00P001?l00?l30003o`0000H0
00?o00003P000ol000050003o`00008000?o00002`000ol00004odd0001@0003o`0000@000Oo0000
o`3o008000?o00001`02o`<00olA0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D0
00?o00000P000ol0000900;o0`000ol0o`1>0000D0001Ol0003o00<00ol00`3oo`03o`/000Co003o
4`000ol00005o`<01?l80003o`0000h000?o00001002o`<01?l;0006o`00o`3oCP0005401?lD00?o
0`04o`h01Ol;0003o`0000D00_l?00Go2@000ol0000800?o1002odh0002@00;o8@000ol000020003
o`0005l0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.117567, -0.0224935, \
0.00254581, 0.00390189}},
  CellTags->"AntTracker3D - Gen 35"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 22",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 38",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[{}, \ \(ifSensor[wall]\)[
          seq[turnLeft, \ 
            again], \ \n\ \ \ \ \ \ \ seq[{}, \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              turnRight], \ \n\ \ \ \ \ \ \ \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              advance]]], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[turnLeft, \ again], \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.35, Ind.1, Fit.34.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.35, Ind.1, Fit.34.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.47851 .53127 m .46472 .53531 L .45688 .52783 L p
1 .502 0 r
F P
s
P
p
.002 w
.47851 .53127 m .46472 .53531 L .45688 .52783 L p
1 .482 0 r
F P
s
P
p
.002 w
.47851 .53127 m .46472 .53531 L .45688 .52783 L p
1 .463 0 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.45688 .52783 m .47071 .52375 L .47851 .53127 L p
1 .502 0 r
F P
s
P
p
.002 w
.45688 .52783 m .47071 .52375 L .47851 .53127 L p
1 .482 0 r
F P
s
P
p
.002 w
.45688 .52783 m .47071 .52375 L .47851 .53127 L p
1 .463 0 r
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 .579 0 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
1 .559 0 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 .579 0 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
1 .559 0 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 .656 0 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
1 .637 0 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .54 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .521 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .444 0 r
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
1 .424 0 r
F P
s
P
p
.002 w
.53437 .51488 m .52029 .51901 L .51264 .51138 L p
1 .347 0 r
F P
s
P
p
.002 w
.53437 .51488 m .52029 .51901 L .51264 .51138 L p
1 .328 0 r
F P
s
P
p
.002 w
.53437 .51488 m .52029 .51901 L .51264 .51138 L p
1 .309 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 .656 0 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
1 .637 0 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .54 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .521 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .444 0 r
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
1 .424 0 r
F P
s
P
p
.002 w
.51264 .51138 m .52676 .50721 L .53437 .51488 L p
1 .347 0 r
F P
s
P
p
.002 w
.51264 .51138 m .52676 .50721 L .53437 .51488 L p
1 .328 0 r
F P
s
P
p
.002 w
.51264 .51138 m .52676 .50721 L .53437 .51488 L p
1 .309 0 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
1 .617 0 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
1 .598 0 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
1 .405 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
1 .617 0 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
1 .598 0 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
1 .405 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 .714 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 .695 0 r
F P
s
P
p
.002 w
.37476 .50205 m .36099 .50624 L .3525 .49848 L p
1 .675 0 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.977 0 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
.958 0 1 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .386 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .367 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .289 0 r
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
1 .27 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .193 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .174 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .154 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 .714 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 .695 0 r
F P
s
P
p
.002 w
.3525 .49848 m .36631 .49425 L .37476 .50205 L p
1 .675 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .019 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.977 0 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
.958 0 1 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .386 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .367 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .289 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
1 .27 0 r
F P
s
P
p
.002 w
.70407 .49015 m .67467 .49864 L .6606 .4829 L p
.8 g
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .193 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .174 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .154 0 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .019 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
.997 0 1 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
1 .251 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
.997 0 1 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
1 .251 0 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
1 .752 0 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
1 .733 0 r
F P
s
P
p
.002 w
.7338 .48157 m .70407 .49015 L .69022 .47424 L p
.8 g
F P
s
P
p
.002 w
.6606 .4829 m .69022 .47424 L .70407 .49015 L p
.8 g
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.50348 .48372 m .48921 .48802 L .48125 .48008 L p
.939 0 1 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .868 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .887 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .965 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 0 .984 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .232 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .212 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .135 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .116 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
1 .752 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
1 .733 0 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.64967 .48107 m .63499 .48538 L .62773 .47741 L p
1 .039 0 r
F P
s
P
p
.002 w
.48125 .48008 m .49557 .47574 L .50348 .48372 L p
.939 0 1 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .868 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .887 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .965 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 0 .984 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .232 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .212 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .135 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .116 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
1 .791 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
1 .772 0 r
F P
s
P
p
.002 w
.76384 .4729 m .7338 .48157 L .72016 .46548 L p
.8 g
F P
s
P
p
.002 w
.69022 .47424 m .72016 .46548 L .7338 .48157 L p
.8 g
F P
s
P
p
.002 w
.62773 .47741 m .64247 .47306 L .64967 .48107 L p
1 .039 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 0 .849 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .096 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
1 .791 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
1 .772 0 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 0 .849 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .096 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .76384 .4729 L .75043 .45663 L p
.8 g
F P
s
P
p
.002 w
.72016 .46548 m .75043 .45663 L .76384 .4729 L p
.8 g
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.92 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.9 0 1 r
F P
s
P
p
.002 w
.48758 .46768 m .47321 .47206 L .46509 .46396 L p
.881 0 1 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.56133 .46633 m .54675 .47071 L .53899 .4626 L p
1 0 .907 r
F P
s
P
p
.002 w
.56133 .46633 m .54675 .47071 L .53899 .4626 L p
1 0 .926 r
F P
s
P
p
.002 w
.56133 .46633 m .54675 .47071 L .53899 .4626 L p
1 0 .945 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .714 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .733 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .81 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 0 .83 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .077 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .058 0 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.92 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.9 0 1 r
F P
s
P
p
.002 w
.46509 .46396 m .47951 .45954 L .48758 .46768 L p
.881 0 1 r
F P
s
P
p
.002 w
.53899 .4626 m .55362 .45817 L .56133 .46633 L p
1 0 .907 r
F P
s
P
p
.002 w
.53899 .4626 m .55362 .45817 L .56133 .46633 L p
1 0 .926 r
F P
s
P
p
.002 w
.53899 .4626 m .55362 .45817 L .56133 .46633 L p
1 0 .945 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 .83 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
1 .81 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .714 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .733 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .81 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 0 .83 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .077 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .058 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .7942 .46413 L .78102 .44769 L p
.8 g
F P
s
P
p
.002 w
.75043 .45663 m .78102 .44769 L .7942 .46413 L p
.8 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 .83 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
1 .81 0 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 0 .695 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
1 .868 0 r
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
1 .849 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 0 .695 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.862 0 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.842 0 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.823 0 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.804 0 1 r
F P
s
P
p
.002 w
.47136 .45131 m .45689 .45578 L .44861 .44752 L p
.785 0 1 r
F P
s
P
p
.002 w
.78102 .44769 m .81196 .43865 L .82489 .45527 L p
.8 g
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.62043 .44855 m .60553 .45303 L .59798 .44475 L p
1 0 .752 r
F P
s
P
p
.002 w
.62043 .44855 m .60553 .45303 L .59798 .44475 L p
1 0 .772 r
F P
s
P
p
.002 w
.62043 .44855 m .60553 .45303 L .59798 .44475 L p
1 0 .791 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
1 .868 0 r
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
1 .849 0 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 0 .656 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 0 .675 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.862 0 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.842 0 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.823 0 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.804 0 1 r
F P
s
P
p
.002 w
.44861 .44752 m .46313 .44301 L .47136 .45131 L p
.785 0 1 r
F P
s
P
p
.002 w
.73675 .44005 m .70625 .44907 L .69207 .43233 L p
.8 g
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.59798 .44475 m .61293 .44022 L .62043 .44855 L p
1 0 .752 r
F P
s
P
p
.002 w
.59798 .44475 m .61293 .44022 L .62043 .44855 L p
1 0 .772 r
F P
s
P
p
.002 w
.59798 .44475 m .61293 .44022 L .62043 .44855 L p
1 0 .791 r
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.81196 .43865 m .78102 .44769 L .76758 .43092 L p
.8 g
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 0 .656 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 0 .675 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.37972 .43602 m .36537 .44057 L .35655 .43215 L p
1 .907 0 r
F P
s
P
p
.002 w
.37972 .43602 m .36537 .44057 L .35655 .43215 L p
1 .887 0 r
F P
s
P
p
.002 w
.69207 .43233 m .72279 .42312 L .73675 .44005 L p
.8 g
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.765 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.746 0 1 r
F P
s
P
p
.002 w
.45481 .43462 m .44024 .43917 L .43179 .43074 L p
.727 0 1 r
F P
s
P
p
.002 w
.76758 .43092 m .79875 .42169 L .81196 .43865 L p
.8 g
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.35655 .43215 m .37095 .42756 L .37972 .43602 L p
1 .907 0 r
F P
s
P
p
.002 w
.35655 .43215 m .37095 .42756 L .37972 .43602 L p
1 .887 0 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 0 .617 r
F P
s
P
p
.002 w
.68083 .43039 m .6656 .43497 L .65828 .4265 L p
1 0 .637 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.765 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.746 0 1 r
F P
s
P
p
.002 w
.43179 .43074 m .44641 .42614 L .45481 .43462 L p
.727 0 1 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
.669 0 1 r
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
.65 0 1 r
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
1 .945 0 r
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
1 .926 0 r
F P
s
P
p
.002 w
.79875 .42169 m .76758 .43092 L .75386 .4138 L p
.8 g
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 0 .617 r
F P
s
P
p
.002 w
.65828 .4265 m .67356 .42187 L .68083 .43039 L p
1 0 .637 r
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
.669 0 1 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
.65 0 1 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
1 .945 0 r
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
1 .926 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 0 .579 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 0 .598 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.43792 .41758 m .42325 .42223 L .41462 .41362 L p
.707 0 1 r
F P
s
P
p
.002 w
.43792 .41758 m .42325 .42223 L .41462 .41362 L p
.688 0 1 r
F P
s
P
p
.002 w
.75386 .4138 m .78528 .40438 L .79875 .42169 L p
.8 g
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 0 .579 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 0 .598 r
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
0 .72 1 r
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
0 .74 1 r
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
0 .759 1 r
F P
s
P
p
.002 w
.41462 .41362 m .42935 .40893 L .43792 .41758 L p
.707 0 1 r
F P
s
P
p
.002 w
.41462 .41362 m .42935 .40893 L .43792 .41758 L p
.688 0 1 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
0 .72 1 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
0 .74 1 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
0 .759 1 r
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
.63 0 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
1 .965 0 r
F P
s
P
p
.002 w
.78528 .40438 m .75386 .4138 L .73986 .39633 L p
.8 g
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
0 .624 1 r
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
0 .643 1 r
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
0 .662 1 r
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
.63 0 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
1 .965 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 0 .559 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
0 .624 1 r
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
0 .643 1 r
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
0 .662 1 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.34407 .40165 m .32953 .40639 L .32033 .39762 L p
.939 1 0 r
F P
s
P
p
.002 w
.34407 .40165 m .32953 .40639 L .32033 .39762 L p
.958 1 0 r
F P
s
P
p
.002 w
.34407 .40165 m .32953 .40639 L .32033 .39762 L p
.977 1 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 0 .019 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 0 .039 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
1 0 .058 r
F P
s
P
p
.002 w
.81705 .39486 m .78528 .40438 L .77153 .38672 L p
.8 g
F P
s
P
p
.002 w
.73986 .39633 m .77153 .38672 L .78528 .40438 L p
.8 g
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 0 .559 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .585 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .605 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .682 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .701 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .778 1 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
0 .797 1 r
F P
s
P
p
.002 w
.32033 .39762 m .33493 .39283 L .34407 .40165 L p
.939 1 0 r
F P
s
P
p
.002 w
.32033 .39762 m .33493 .39283 L .34407 .40165 L p
.958 1 0 r
F P
s
P
p
.002 w
.32033 .39762 m .33493 .39283 L .34407 .40165 L p
.977 1 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 0 .019 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 0 .039 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
1 0 .058 r
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .585 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .605 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .682 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .701 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .778 1 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
0 .797 1 r
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
.611 0 1 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
.592 0 1 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
.9 1 0 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
.92 1 0 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
.997 1 0 r
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
1 .984 0 r
F P
s
P
p
.002 w
.77153 .38672 m .80355 .37699 L .81705 .39486 L p
.8 g
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
0 .817 1 r
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
0 .836 1 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
.611 0 1 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
.592 0 1 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
.9 1 0 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
.92 1 0 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
.997 1 0 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
1 .984 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 0 .405 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 0 .424 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 0 .502 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 0 .521 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 0 .54 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 0 .077 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 0 .096 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
1 0 .116 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
0 .817 1 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
0 .836 1 r
F P
s
P
p
.002 w
.40308 .38243 m .38821 .38727 L .37922 .37831 L p
.572 0 1 r
F P
s
P
p
.002 w
.40308 .38243 m .38821 .38727 L .37922 .37831 L p
.553 0 1 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 0 .405 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 0 .424 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 0 .502 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 0 .521 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 0 .54 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
0 .566 1 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 0 .077 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 0 .096 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
1 0 .116 r
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.37922 .37831 m .39415 .37341 L .40308 .38243 L p
.572 0 1 r
F P
s
P
p
.002 w
.37922 .37831 m .39415 .37341 L .40308 .38243 L p
.553 0 1 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 0 .386 r
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
0 .566 1 r
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
.881 1 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 0 .386 r
F P
s
P
p
.002 w
.51109 .37114 m .49581 .37605 L .48732 .36697 L p
0 .489 1 r
F P
s
P
p
.002 w
.51109 .37114 m .49581 .37605 L .48732 .36697 L p
0 .508 1 r
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
0 .855 1 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
0 .875 1 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
0 .894 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
.881 1 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 0 .444 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 0 .463 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
1 0 .482 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 0 .251 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 0 .27 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 0 .347 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 0 .367 r
F P
s
P
p
.002 w
.48732 .36697 m .50266 .36201 L .51109 .37114 L p
0 .489 1 r
F P
s
P
p
.002 w
.48732 .36697 m .50266 .36201 L .51109 .37114 L p
0 .508 1 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.30692 .36582 m .29217 .37076 L .28259 .36162 L p
.785 1 0 r
F P
s
P
p
.002 w
.30692 .36582 m .29217 .37076 L .28259 .36162 L p
.804 1 0 r
F P
s
P
p
.002 w
.30692 .36582 m .29217 .37076 L .28259 .36162 L p
.823 1 0 r
F P
s
P
p
.002 w
.82444 .36506 m .80821 .37001 L .80135 .36086 L p
1 0 .135 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
0 .855 1 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
0 .875 1 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
0 .894 1 r
F P
s
P
p
.002 w
.38511 .3643 m .37013 .36925 L .36095 .36009 L p
.534 0 1 r
F P
s
P
p
.002 w
.38511 .3643 m .37013 .36925 L .36095 .36009 L p
.514 0 1 r
F P
s
P
p
.002 w
.38511 .3643 m .37013 .36925 L .36095 .36009 L p
.437 0 1 r
F P
s
P
p
.002 w
.38511 .3643 m .37013 .36925 L .36095 .36009 L p
.418 0 1 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 0 .444 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 0 .463 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
1 0 .482 r
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 0 .251 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 0 .27 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 0 .347 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 0 .367 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
0 .527 1 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
0 .547 1 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
0 .952 1 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
0 .971 1 r
F P
s
P
p
.002 w
.28259 .36162 m .29738 .35663 L .30692 .36582 L p
.785 1 0 r
F P
s
P
p
.002 w
.28259 .36162 m .29738 .35663 L .30692 .36582 L p
.804 1 0 r
F P
s
P
p
.002 w
.28259 .36162 m .29738 .35663 L .30692 .36582 L p
.823 1 0 r
F P
s
P
p
.002 w
.80135 .36086 m .81765 .35586 L .82444 .36506 L p
1 0 .135 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.36095 .36009 m .37598 .35509 L .38511 .3643 L p
.534 0 1 r
F P
s
P
p
.002 w
.36095 .36009 m .37598 .35509 L .38511 .3643 L p
.514 0 1 r
F P
s
P
p
.002 w
.36095 .36009 m .37598 .35509 L .38511 .3643 L p
.437 0 1 r
F P
s
P
p
.002 w
.36095 .36009 m .37598 .35509 L .38511 .3643 L p
.418 0 1 r
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
1 0 .232 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
0 .527 1 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
0 .547 1 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
0 .952 1 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
0 .971 1 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.36 0 1 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.341 0 1 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.746 1 0 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.765 1 0 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.842 1 0 r
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
.862 1 0 r
F P
s
P
p
.002 w
.41534 .35432 m .40018 .35932 L .39111 .35006 L p
.495 0 1 r
F P
s
P
p
.002 w
.41534 .35432 m .40018 .35932 L .39111 .35006 L p
.476 0 1 r
F P
s
P
p
.002 w
.41534 .35432 m .40018 .35932 L .39111 .35006 L p
.457 0 1 r
F P
s
P
p
.002 w
.49415 .35277 m .47875 .35779 L .47009 .34851 L p
0 .431 1 r
F P
s
P
p
.002 w
.49415 .35277 m .47875 .35779 L .47009 .34851 L p
0 .45 1 r
F P
s
P
p
.002 w
.49415 .35277 m .47875 .35779 L .47009 .34851 L p
0 .469 1 r
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
1 0 .232 r
F P
s
P
p
.002 w
.57309 .35122 m .55746 .35625 L .54921 .34695 L p
0 .913 1 r
F P
s
P
p
.002 w
.57309 .35122 m .55746 .35625 L .54921 .34695 L p
0 .932 1 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.36 0 1 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.341 0 1 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.746 1 0 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.765 1 0 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.842 1 0 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
.862 1 0 r
F P
s
P
p
.002 w
.39111 .35006 m .40632 .345 L .41534 .35432 L p
.495 0 1 r
F P
s
P
p
.002 w
.39111 .35006 m .40632 .345 L .41534 .35432 L p
.476 0 1 r
F P
s
P
p
.002 w
.39111 .35006 m .40632 .345 L .41534 .35432 L p
.457 0 1 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 0 .289 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 0 .309 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
1 0 .328 r
F P
s
P
p
.002 w
.47009 .34851 m .48554 .34344 L .49415 .35277 L p
0 .431 1 r
F P
s
P
p
.002 w
.47009 .34851 m .48554 .34344 L .49415 .35277 L p
0 .45 1 r
F P
s
P
p
.002 w
.47009 .34851 m .48554 .34344 L .49415 .35277 L p
0 .469 1 r
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .154 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .174 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .193 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
1 0 .212 r
F P
s
P
p
.002 w
.54921 .34695 m .5649 .34187 L .57309 .35122 L p
0 .913 1 r
F P
s
P
p
.002 w
.54921 .34695 m .5649 .34187 L .57309 .35122 L p
0 .932 1 r
F P
s
P
p
.002 w
.36676 .34578 m .35167 .35084 L .34229 .34148 L p
.399 0 1 r
F P
s
P
p
.002 w
.36676 .34578 m .35167 .35084 L .34229 .34148 L p
.379 0 1 r
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 0 .289 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 0 .309 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
1 0 .328 r
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
0 .99 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .154 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .174 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .193 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
1 0 .212 r
F P
s
P
p
.002 w
.34229 .34148 m .35743 .33637 L .36676 .34578 L p
.399 0 1 r
F P
s
P
p
.002 w
.34229 .34148 m .35743 .33637 L .36676 .34578 L p
.379 0 1 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
0 .99 1 r
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
.322 0 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
.727 1 0 r
F P
s
P
p
.002 w
.47684 .33401 m .46133 .33913 L .45248 .32965 L p
0 .392 1 r
F P
s
P
p
.002 w
.47684 .33401 m .46133 .33913 L .45248 .32965 L p
0 .412 1 r
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
.322 0 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
.727 1 0 r
F P
s
P
p
.002 w
.45248 .32965 m .46805 .32447 L .47684 .33401 L p
0 .392 1 r
F P
s
P
p
.002 w
.45248 .32965 m .46805 .32447 L .47684 .33401 L p
0 .412 1 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.63 1 0 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.65 1 0 r
F P
s
P
p
.002 w
.26816 .32846 m .25321 .33361 L .24321 .32407 L p
.669 1 0 r
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
0 .354 1 r
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
0 .373 1 r
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
0 1 .99 r
F P
s
P
p
.002 w
.50813 .32367 m .49244 .32885 L .48371 .31926 L p
0 1 .971 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.63 1 0 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.65 1 0 r
F P
s
P
p
.002 w
.24321 .32407 m .25821 .31886 L .26816 .32846 L p
.669 1 0 r
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
0 1 .894 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
0 1 .875 r
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
0 .354 1 r
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
0 .373 1 r
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
0 1 .99 r
F P
s
P
p
.002 w
.48371 .31926 m .49946 .31402 L .50813 .32367 L p
0 1 .971 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.302 0 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.283 0 1 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.592 1 0 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.611 1 0 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.688 1 0 r
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
.707 1 0 r
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
0 1 .894 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
0 1 .875 r
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.53979 .31322 m .52392 .31846 L .5153 .30875 L p
0 1 .952 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.302 0 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.283 0 1 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.592 1 0 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.611 1 0 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.688 1 0 r
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
.707 1 0 r
F P
s
P
p
.002 w
.62057 .3116 m .60444 .31685 L .59626 .30713 L p
0 1 .855 r
F P
s
P
p
.002 w
.62057 .3116 m .60444 .31685 L .59626 .30713 L p
0 1 .836 r
F P
s
P
p
.002 w
.62057 .3116 m .60444 .31685 L .59626 .30713 L p
0 1 .817 r
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.5153 .30875 m .53124 .30345 L .53979 .31322 L p
0 1 .952 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.264 0 1 r
F P
s
P
p
.002 w
.32885 .30753 m .31354 .31281 L .30375 .30305 L p
.244 0 1 r
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.59626 .30713 m .61245 .30182 L .62057 .3116 L p
0 1 .855 r
F P
s
P
p
.002 w
.59626 .30713 m .61245 .30182 L .62057 .3116 L p
0 1 .836 r
F P
s
P
p
.002 w
.59626 .30713 m .61245 .30182 L .62057 .3116 L p
0 1 .817 r
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.49069 .30427 m .47488 .30957 L .46595 .29977 L p
0 .315 1 r
F P
s
P
p
.002 w
.49069 .30427 m .47488 .30957 L .46595 .29977 L p
0 .334 1 r
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
0 1 .932 r
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
0 1 .913 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.264 0 1 r
F P
s
P
p
.002 w
.30375 .30305 m .31911 .29771 L .32885 .30753 L p
.244 0 1 r
F P
s
P
p
.002 w
.65312 .301 m .6368 .30631 L .62874 .29647 L p
0 1 .797 r
F P
s
P
p
.002 w
.65312 .301 m .6368 .30631 L .62874 .29647 L p
0 1 .778 r
F P
s
P
p
.002 w
.46595 .29977 m .48182 .29441 L .49069 .30427 L p
0 .315 1 r
F P
s
P
p
.002 w
.46595 .29977 m .48182 .29441 L .49069 .30427 L p
0 .334 1 r
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
.553 1 0 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
.572 1 0 r
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
0 1 .932 r
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
0 1 .913 r
F P
s
P
p
.002 w
.62874 .29647 m .64513 .2911 L .65312 .301 L p
0 1 .797 r
F P
s
P
p
.002 w
.62874 .29647 m .64513 .2911 L .65312 .301 L p
0 1 .778 r
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.52259 .29359 m .50659 .29894 L .49779 .28903 L p
0 .257 1 r
F P
s
P
p
.002 w
.52259 .29359 m .50659 .29894 L .49779 .28903 L p
0 .277 1 r
F P
s
P
p
.002 w
.52259 .29359 m .50659 .29894 L .49779 .28903 L p
0 .296 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
.553 1 0 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
.572 1 0 r
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.49779 .28903 m .51385 .28361 L .52259 .29359 L p
0 .257 1 r
F P
s
P
p
.002 w
.49779 .28903 m .51385 .28361 L .52259 .29359 L p
0 .277 1 r
F P
s
P
p
.002 w
.49779 .28903 m .51385 .28361 L .52259 .29359 L p
0 .296 1 r
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.225 0 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.206 0 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.514 1 0 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.534 1 0 r
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
.129 0 1 r
F P
s
P
p
.002 w
.39099 .28611 m .37531 .29152 L .36575 .28151 L p
.109 0 1 r
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.55488 .28277 m .53869 .28819 L .53001 .27816 L p
0 .238 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.225 0 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.206 0 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.514 1 0 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.534 1 0 r
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.63705 .2811 m .6206 .28653 L .61237 .27647 L p
0 1 .759 r
F P
s
P
p
.002 w
.63705 .2811 m .6206 .28653 L .61237 .27647 L p
0 1 .74 r
F P
s
P
p
.002 w
.63705 .2811 m .6206 .28653 L .61237 .27647 L p
0 1 .72 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
.129 0 1 r
F P
s
P
p
.002 w
.36575 .28151 m .38148 .27605 L .39099 .28611 L p
.109 0 1 r
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.53001 .27816 m .54626 .27267 L .55488 .28277 L p
0 .238 1 r
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
.186 0 1 r
F P
s
P
p
.002 w
.61237 .27647 m .62888 .27098 L .63705 .2811 L p
0 1 .759 r
F P
s
P
p
.002 w
.61237 .27647 m .62888 .27098 L .63705 .2811 L p
0 1 .74 r
F P
s
P
p
.002 w
.61237 .27647 m .62888 .27098 L .63705 .2811 L p
0 1 .72 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
.09 0 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
.071 0 1 r
F P
s
P
p
.002 w
.42262 .27521 m .40676 .28068 L .39731 .27055 L p
.051 0 1 r
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 .199 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 .219 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 1 .662 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
0 1 .643 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
.186 0 1 r
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
.09 0 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
.071 0 1 r
F P
s
P
p
.002 w
.39731 .27055 m .41323 .26503 L .42262 .27521 L p
.051 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.476 1 0 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.495 1 0 r
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 .199 1 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 .219 1 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 1 .662 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
0 1 .643 r
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.167 0 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.148 0 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.341 1 0 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.36 1 0 r
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.032 0 1 r
F P
s
P
p
.002 w
.45463 .26417 m .43858 .26971 L .42925 .25946 L p
.013 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.476 1 0 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.495 1 0 r
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
0 1 .701 r
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
0 1 .682 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.167 0 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.148 0 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.341 1 0 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.36 1 0 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.032 0 1 r
F P
s
P
p
.002 w
.42925 .25946 m .44536 .25387 L .45463 .26417 L p
.013 0 1 r
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.418 1 0 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.437 1 0 r
F P
s
P
p
.002 w
.32059 .25645 m .30487 .26203 L .29475 .2517 L p
.457 1 0 r
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
0 1 .701 r
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
0 1 .682 r
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
.322 1 0 r
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
0 .18 1 r
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
0 1 .624 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.418 1 0 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.437 1 0 r
F P
s
P
p
.002 w
.29475 .2517 m .31052 .24606 L .32059 .25645 L p
.457 1 0 r
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
.322 1 0 r
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
0 .18 1 r
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
0 1 .624 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.379 1 0 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.399 1 0 r
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .006 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
0 .026 1 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.186 1 0 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.206 1 0 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.283 1 0 r
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.302 1 0 r
F P
s
P
p
.002 w
.51983 .24169 m .50338 .24736 L .4943 .23687 L p
0 .103 1 r
F P
s
P
p
.002 w
.51983 .24169 m .50338 .24736 L .4943 .23687 L p
0 .122 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.379 1 0 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.399 1 0 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .006 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
0 .026 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.186 1 0 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.206 1 0 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.283 1 0 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.302 1 0 r
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.4943 .23687 m .51082 .23113 L .51983 .24169 L p
0 .103 1 r
F P
s
P
p
.002 w
.4943 .23687 m .51082 .23113 L .51983 .24169 L p
0 .122 1 r
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
0 .045 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.167 1 0 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 .141 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 .161 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 1 .605 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
0 1 .585 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
0 .045 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.167 1 0 r
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 .141 1 r
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 .161 1 r
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 1 .605 r
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
0 1 .585 r
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.225 1 0 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.244 1 0 r
F P
s
P
p
.002 w
.41692 .22224 m .40062 .22803 L .39086 .21731 L p
.264 1 0 r
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
0 .064 1 r
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
0 .084 1 r
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
.129 1 0 r
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
.148 1 0 r
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.58665 .21866 m .56979 .22447 L .56098 .21371 L p
0 1 .566 r
F P
s
P
p
.002 w
.58665 .21866 m .56979 .22447 L .56098 .21371 L p
0 1 .547 r
F P
s
P
p
.002 w
.5481 .21123 m .51459 .22291 L .49622 .20123 L p
.8 g
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.225 1 0 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.244 1 0 r
F P
s
P
p
.002 w
.39086 .21731 m .40723 .21145 L .41692 .22224 L p
.264 1 0 r
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
0 .064 1 r
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
0 .084 1 r
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
.129 1 0 r
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
.148 1 0 r
F P
s
P
p
.002 w
.56098 .21371 m .57791 .20783 L .58665 .21866 L p
0 1 .566 r
F P
s
P
p
.002 w
.56098 .21371 m .57791 .20783 L .58665 .21866 L p
0 1 .547 r
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.49622 .20123 m .53 .18928 L .5481 .21123 L p
.8 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.48316 .19872 m .46645 .20465 L .45695 .19366 L p
.09 1 0 r
F P
s
P
p
.002 w
.48316 .19872 m .46645 .20465 L .45695 .19366 L p
.109 1 0 r
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.56907 .19688 m .55207 .20283 L .54306 .19182 L p
0 1 .527 r
F P
s
P
p
.002 w
.56907 .19688 m .55207 .20283 L .54306 .19182 L p
0 1 .508 r
F P
s
P
p
.002 w
.45695 .19366 m .47373 .18766 L .48316 .19872 L p
.09 1 0 r
F P
s
P
p
.002 w
.45695 .19366 m .47373 .18766 L .48316 .19872 L p
.109 1 0 r
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.54306 .19182 m .56013 .1858 L .56907 .19688 L p
0 1 .527 r
F P
s
P
p
.002 w
.54306 .19182 m .56013 .1858 L .56907 .19688 L p
0 1 .508 r
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.032 1 0 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.051 1 0 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.071 1 0 r
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
0 1 .489 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
0 1 .469 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
0 1 .45 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
0 1 .431 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
0 1 .412 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.032 1 0 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.051 1 0 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.071 1 0 r
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
0 1 .489 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
0 1 .469 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
0 1 .45 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
0 1 .431 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
0 1 .412 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
0 1 .064 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
0 1 .045 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
0 1 .026 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
0 1 .006 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.013 1 0 r
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
0 1 .392 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
0 1 .373 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
0 1 .354 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
0 1 .064 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
0 1 .045 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
0 1 .026 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
0 1 .006 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.013 1 0 r
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
0 1 .392 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
0 1 .373 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
0 1 .354 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
0 1 .122 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
0 1 .103 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
0 1 .084 r
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
0 1 .334 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
0 1 .315 r
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
0 1 .122 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
0 1 .103 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
0 1 .084 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
0 1 .334 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
0 1 .315 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
0 1 .219 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
0 1 .199 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
0 1 .18 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
0 1 .161 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
0 1 .141 r
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
0 1 .219 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
0 1 .199 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
0 1 .18 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
0 1 .161 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
0 1 .141 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
0 1 .296 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
0 1 .277 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
0 1 .257 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
0 1 .238 r
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
0 1 .296 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
0 1 .277 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
0 1 .257 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
0 1 .238 r
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00G;^l^kb`02o`03^l_o00n100Sobk_;^l^ko`<0
00?o00000P000ol0001I0000LP000ol000020004o`00oa<00olH00?o2K/3o`f100?oPH4038400onk
^`03^`?o00?Lk?l00[/00on1P@08P@?o00>1ok/01[/01?l00?l50003o`0005P0001a00;o1@02oa40
0olI00;o00Zkbk_;^l^kbk_;0_l00h7oP@0=P@03oh6100R10ol01K_;^l^k00;o1^`01?nkbol6P@?o
1H402?nkbk_;^l_o0`000ol000030003o`0005L0002800?o6@03o`Vk0ol4P@03oh6100b100?oPH40
1843o`Rk00[og>cLk=c/g>co0[/00on1P@03o`V100?o^k/01;/01Ol0003o00@00_mH0000QP02o`80
00?o00005003o`0:bk_;^l^kbk_;^`;o28400on1P@0<P@03oh6100?o00Bkbk_;0_l01k_;^l^kbol0
1>`2o`05bk_;^l/00_l<P@09ol^kbk_;^l_o008000?o00000`000ol0001F0000P`03oaP00ol;^`;o
2h400on1P@0<P@;o1;/3o`03k?nk00Jk00Cog?oo1k/00on1P@0<P@03ok^k00Fk00Co003o1@000ol0
000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`05^l^kbk/00_l5g00D
ol^kbk_;^l_obk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol000080003o`0004T0
001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10ol8^`03onc/00G/00?o^k/02k/2o`>k00?oPH40
2h400onk^`05^`04o`00o`D000?o000020000ol000190000N`04oaL00ol02k_;^l^kbk_;^l^k00?o
1H400on1P@0=P@03oh7o00;o00Fkbk_;^`02o`06bk_;^l_o1m`02_o;^l^kbk_;^l/3o`07k?o;^l^k
o`0=P@09ok_;^l^kbk_o008000?o00000`000ol0000400?oC00007P00ol40003o`0001400ol;^`?o
2H400on1P@0=P@03ok^k00>k0ol00nco^`05^`03onc/00?o2[/00oo/k003k005ok^k^ol02H43o`03
POnk00Jk00Go0000o`050003o`0000<000?o0000C00007H00_lI00?o00_;^l^kbk_;^l^kb`02o`f1
00?oPH402843o`05bk_;^l/00_l03>cLk=c/ok_;^l^kb`;o01Vkbk_;^l^kbk_;^l^komc/g>cLk?o;
^l_o00F10ol5P@09ol^kbk_;^l_o00<000?o00000P02o`@01?m;0000L`03oaP00ol;^`?o00>1oh40
3H400on1P@04P@?o2;/02Oo/g>cLk=c/o`0=^`;o1[/00oo/k004k006ok^k^on10ol9P@03ok^k00Fk
00Co003o0`000ol0o`1C0000L005oaH00ol02l^kbk_;^l^kbk_;00?o1H400on1P@0<P@03oh6100?o
00C;^l^k0_l06<^kbk_;^oo/g>cLk=c/ok_;^l^kbk_;^`?o00^gok_;^l^kboo/g003o`05^l^kbk/0
0_l=P@08ol^kbk_;^ol30003o`0000<000?o0000D00006d00olI00;o2k/3o`V100?oPH403842o`Bk
0ol00mco^`06^`03oncL00?o2K/2o`06]nbgk;Oo1[/2o`Fk0ol00h7oP@0=P@03ok^k00Bk00Go0000
o`040003o`000500001[00;o6@03o`0;^l^kbk_;^l^kbk/00_l=P@03oh6100N10ol01l^kbk_;^ol0
1M`02?nkbk_;^l^k0_l07/^kbk_;^l^kbk_;^ongk;O/]nbgok_;^l^kbk_;^`?o1H400on1P@0<P@08
ol^kbk_;^ol20003o`0000<000?o0000C`0006P00olH00?o2k/3o`03POn100f100?oPH400h43o`Vk
00?og=`01=`00onk^`0;^`;o1[/02Ongk;O/]nbgo`05^`?o2H400on1P@0<P@03ok^k00Bk00Co003o
1@000ol0001>0000I@03o`030?l001D00ol02k_;^l^kbk_;^l^k00?o1H400on1P@0<P@03oh7o00;o
00G;^l^kb`02o`07^l^kbk_;o`06g00:ok_;^l^kbk_;^`?o00bgok_;^l^kbk_o]n`3o`04bk_;^`?o
3H400on1P@07P@?o00V1ok_;^l^kbol00`000ol000020003o`0004h0001200?o7P02oaT00ol:^`?o
2H400on1P@0<P@03ok^k00>k0ol00iGo^`06^`03omco00;o2[/00ong]`03]`03ok^k00Fk0_l4^`?o
00>1oh403H400on1P@04P@?o1H400onk^`04^`04o`00o`D00_m>0000A@000ol0000H00?o6003o`0;
bk_;^l^kbk_;^l/00_l=P@03oh6100N10ol01K_;^l^k00;o01cLUMbEg?o;^l^kbk_;ol^kbk_;^l^k
bk_;^l_o1[L02_nkbk_;^l^kbk/3o`F100?oPH4038400on1P@03o`V100So^l^kbk_;o`8000?o0000
0P02odh000150003o`0001D00olH00?o2k/3o`03POn100f100?oPH400h43o`Rk00WoUMbEg9GLUOl0
3K/2o`Jk00?o]kL01;L00onk^`03^`?o2H400on1P@0<P@;o38400onk^`04^`05o`000?l010000ol0
001<0000@P03oaH00_l20003o`0001<01?l02[_;^l^kbk_;^l/3o`F100?oPH4038400on1o`02o`05
^l^kbk/00_l04<^kbk_;ombEg9GLUMcobk/2o`05bk_;^l/00ol02kKobk_;^l^kbong00?o00G;^l^k
b`02o`f100?oPH401h43o`03^on100f100Sobk_;^l^ko`8000?o00000`000ol0001;0000@P000ol0
000C00?o6003o`Zk0ol9P@03oh6100b100?o^k/00k/3o`03UOnk00Fk00?oUM`00ol01[_ooomKo`Bk
00?o]kL00kL00onk^`05^`03ok^k00>k0ol00h7oP@0=P@03oh6100>10ol5^`03oh6100^100?o^k/0
1K/01?l00?l50003o`0004X0001200Co3`03oaP00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o
00F1ol^kb`02o`0<UMbEg9Go^l^kbk_;0_l01;_oool5F`0Eok_;^ong][Nf]kKobk_;^l^kbk_;00?o
1H400on1P@0<P@03oh7o00;o00Zkbk_;^l^kbk_o3H402?nkbk_;^l_o0`000ol000030003o`0004T0
001B00?o6003o`^k0ol00h7oP@0=P@03oh6100>10ol5P@05ok^k^ol01YD00onk^`03^`?o2E/01Onk
^k_o00Jg00?o^k/00k/3o`V100?oPH4038400onk^`0;^`03oh6100V100?oPOl01[/01Ol0003o00@0
00?o0000B@0005000_l30003o`0001<00ol02/^kbk_;^l^kbk/3o`F100?oPH4038400on1o`02o`V1
013obk_;ombEg9GLUOnkbk_o3E/01_nkbk_o]`?o00Fkbk_;^`02o`f100?oPH401h43o`0@bk_;^l^k
bk_;^l^kbk_;o`N11?l2P@09ol^kbk_;^l_o008000?o00000`000ol000180000C@03oaP00ol:^`?o
2H400on1P@0<P@03oh6100^100Ko^k^koiD3o`Fk00?oFe/02e/00onk^`02^`03ok^k00Jk00?oPH40
38400on1P@04P@?o4k/00on1P@04o`N100?o^k/01K/01?l00?l400;oB@0004X00olH00?o00[;^l^k
bk_;^l^k0ol=P@03oh6100N10ol00k_;o`0=P@0?ol^kboo;^l^kbk_;^l_o00eK00oobk_;^l^kbk_;
^l^kbol03X400on1P@03o`0Gbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l<P@08ol^kbk_;^ol30003
o`00008000?o0000A`0004P00_lH00Co2K/3o`>100?oPH402h400on1P@03P@?o1[/00on1P@0;P@03
ok^k00Nk0_l2^`03oe]K00]K00?o^k/01K/4o`:k00?oPH403842oaZk00?oPH4038400onk^`04^`04
o`00o`D000?o0000AP0004D00ol20003o`0001<00ol02K_;^l^kbk_;^`03o`N100?oPH402h400on1
o`02o`05^l^kbk/00_l01<^kbol=P@06ol^kbk_;0ol01YGobk_;o`]K00KoFoo;^l/3o`Bf00Co^l_o
2H43o`0OPOo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=P@09ok_;^l^kbk_o008000?o0000
0`000ol000150000@P03o`H000?o00003`03o`Vk0ol;P@03oh6100^100?o^k/00k/3o`;M00Go^k^k
o`08P@?o1[/01ooLUMbEg?l00k/00omKF`04F`Co1[/02Onf]kJg][Nfo`02^`03oh6100>10ol5P@03
ok^k01Zk00?oPH402h400onk^`04^`05o`000?l010000ol000150000@002oaP00ol02K_;^l^kbk_;
^`03o`03POn100b100?oPH401X43o`07bk_;^l^ko`06U@05ol^kbol01H42o`0:^l^kbk_;^l^ko`JE
00Gobk_;o`02F`?o00Bkbk_;0_l01[_;^l^ko`Nf00Go^l_oP@03o`V101gobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;o`0>P@08ok_;^l^kbol20003o`0000<000?o0000A00003d00olG00Co2;/3o`F1
00?oPH402h400on1P@03P@;o2[/00ooMg@04g@06ok^k^on10ol4^`;o1[/02?nEg9GLUMco0k/2o`Bk
0ol00kKo^`05^`03okJg00?o1K/00on1P@0;P@03ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o
1@000ol0000M00Go00D0oooo0003o`<00_lD0000>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V1
00?oPH402h400on1o`02o`0?^l^kbk_;^l^kbk_;^onE00?o00^kbk_;^l_obk_;^`03o`:E00Wobk_;
^l^koiD00ol02K_;^l^kbk_;^`02o`0<][Nf]kKobk_;^l^k0_l02L^kbk_;^l^ko`0>P@0Lol^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol5P@08ol^kbk_;^ol30003o`0000800_lN0003o`000080
00Co003o10001?l00?lE0000=`03oaP00ol9^`;o3H400on1P@09P@03oh7o016k00?o^k/02k/02?oL
UMbEg9Go1[/00onk^`0:^`03okJf00Ff00?o^k/03[/00on1P@0<P@03ok^k01Rk00?oPH400ol9P@03
ok^k00Bk00Go0000o`040003o`0001`000?o00000`03o`800_l30003o`0001<0000e00;o6004o`08
^l^kbk_;^l/3o`:100?oPH402h400on1P@04P@Co02Bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^ol6U@0=ol^kbk_;^l^kbk_;^`02o`0Obk_;^l_o][Nf]kJg]_o;^l^kbk_;^l^kbk_;^l^k
o`0>P@0Kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o3H402?o;^l^kbk_o0P000ol000030003
o`0001/01Ol30003o`3o00D000?o00004`0003801OlF00?o2K/2o`J100?oPH402h400on1P@03o`Bk
0_lI^`?o1[/00ooLo`02o`Bk0_l5^`?o00=<ok/01K/00onf]P03oa>k00?oPH401h43o`03POnk01Vk
00?oPH4038400onk^`05^`04o`00o`D000?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o
7003oaP00ol02K_;^l^kbk_;^`03o`V100?oPH402h42o`04bk_;^`?o01Qaok_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`0?UG6Eol^kbk_;^onkbk_;00?o01>1ol^kbk_oS4b<C8co^l^kbk_;00;o01Rkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^ol5P@?o1H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol>P@08
ok_;^l^kbol30003o`00008000?o00006P000ol0000=0003o`0001<0000@0004o`00oaT00_lH00?o
2[/2o`f100?oPH401X43o`Jk00?oLG400g400onk^`0B^`03og5a00Ea00?o^k/01[/2o`F100co^k^k
oha<S4b<C?l=^`;o4;/00on1o`02o`V100?o^k/06;/00on1P@0<P@03ok^k00Bk00Co003o1@000ol0
000I00Go8@00010000Co003o5P03oaL01?l02L^kbk_;^l^kb`03o`:100?oPH402h400on1P@03P@;o
00[;^l^kbk_;^l_o1W408_nkbk_;^l^kbk_;^l^kbk_;^l^kbonELIEaUG6Eol^kbk/3o`R101Gobk_;
odb<C8a<S?nkbk_;^l^kbk/00ol05;Ko^l^kbk_;^l^kbk_;^l^kbk_o3H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000?P00010000Co003o
4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_l4^`?o1K/00omaL@04L@03ok^k00Vk
0ol6^`03og5a00?o1K/00on1P@0:P@06ok^k^on<0ol9^`;o1O`00onk^`0>^`03oh6100^100?o^k/0
6K/00on1P@04o`N100?o^k/01;/01Ol0003o00<00_m0000040001?l00?lA00;o6003o`0:bk_;^l^k
bk_;^`?o2H400on1P@0;P@05ok_;^l/00ol02g7NLOo;^l^kboma00?o00[;^l^kbk_;^l^k0ol02W7M
LOnkbk_;^l/2o`09^l^kbk_;^l_o00f101;obk_;ol^kbk_;^l^kbk_;^ol7]P0Bok_;^l^kbk_;^l^k
bk_;^l_o3H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`b100Sobk_;^l^ko`8000?o0000
0`000ol0000600?o1002obh0000A00;o3`03oaL01?l9^`?o3H400on1P@06P@?o1K/02OmagW7NLMia
o`05^`03ok^k00^k00SoUG6ELIEaoa2k00?oPH402h400onk^`0>^`03oocl00Gl00?o^k/02;/3o`>k
00?oPH402h400onk^`0H^`03oh6100b100?o^k/01;/01?l00?l50003o`0000H000?o00000P001?l0
0?l]00007`04oaL00ol02K_;^l^kbk_;^`03o`B100?oPH402X400on1P@03P@;o01g;^l^kbk_;^l^k
omiagW7NLOo;^l^kbk_;^l^kb`02o`0H^l^kbk_;omeagG7MLOnkbk_;^l^kbk_;1?l00k_;o`0=P@0B
ol^kbk_;^l^kbk_;^l^kbk_o0[H3o`09bk_;^l^kbk_;00?o00Sl]_cobk_;o`R10ol07X7o^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H000?o0000
0P001?l00?l]00007003o`@000?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_l4^`;o1k/00ooN
o`02o`Zk0ol00g7Mo`06^`03oiGo00;o2K/3o`A<00Co^k_o2843o`03POnk012k0_l<^`08okJe][Ff
]Ol2^`03oh6100>10ol5P@03ok^k01Vk00?oPH402h400onk^`04^`04o`00o`D000?o00001@000ol0
00020004o`00obd0000J00;o6003o`09^l^kbk_;^l^k00?o38400on1P@0:P@05ok_;^l/00ol0<g7N
ok_;^l^kbk_o^l^kbk_;^l^kbk_;omeagG7MLOnkbk_;^l_obk_;^l^kbk_;^l^ko`07C004ok_;o`F1
0_l5P@0Hok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l04/^kbk_;^onfo;Kl]_cobk_oP@?o2H407Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00^100[oPOnkbk_;^l_o0P000ol000030003o`0000@0
00?o00000P001?l00?l]00005`03oaL01?l8^`?o0X400on1P@0;P@03oh6100B10ol6^`08omiagW7N
LOlD^`08og7MLMeagOl<^`;o1K/00om<C005C005ok^koh400ol8P@03ok^k016k0ol00oco^`06^`03
okKo00;o1K/00on1P@0;P@03ok^k01Rk00?oPH401H44o`:100?o^k/01K/01?l00?l400;o1002o`D0
0_l^00005003o`030?oo01D00ol02L^kbk_;^l^kb`02o`J100?oPH402h400on1P@03o`0N^l^kbk_;
^l^kbomagW7NLMko^l^kbk_;^l^kbk_;0_l02[_;^l^kbooMLMd2o`0:LOnkbk_;^l^kb`?o00U<ol^k
bk_;^ol00T`3o`03bk_;00?o3840:_nkbk_;^l^kbk_;^l^kbk_;^onfo;Kl]_nkbk_;^l^kok_;^l^k
bk_;o`f101gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@Co1h402?o;^l^kbk_o0`001_l0
0?l0oc/0000C00;o1@000ol0000?00?o2K/3o`V100?oPH402h42o`jk00?og_l00_l;^`?o0Td00onk
^`04^`?o2k/01om<CDa=C?l01[/2o`:k1?l3P@03oh6100Z100?o^k/03k/01ool]_bfo?l03K/2o`03
^on100b100?o^k/06K/2o`b100?o^k/01;/01?l00?l50003o`0003P0000C0003o`3o01<01?l02K_;
^l^kbk_;^`02o`f100?oPH401X43o`0m^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbk_;^l_oC4e<
CDa=ok_;^l^kbk_;^l^kbk_;^l^kbk_;o`05C007ol^kbk_;^`03o`R100?oPH402X402_nkbk_;^l^k
bk/2o`0Fbk_;^l^kokKl]_nfok_;^l^kbk_;^`?o00Glok_;o`0=P@0Lol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0003P0000C0004o`00o`l01?l9^`?o
0X400on1P@0;P@03oh6100>10_lM^`;o1K/00om=C@04C@03ok^k00Zk0_l6^`07oda=C?m<o`02^`?o
38400on1P@0:P@03ok^k00>k0ol00hco^`06^`?o2[/2o`06]_bfo;Ko0[/00on1P@04P@Co0X400onk
^`0I^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000=`0001<000Go0000o`0<00?o00Zkbk_;
^l^kbk_;0_l6P@03oh6100^100?oPOl00_l07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0:
g_nkbk_;^l_oC0?o00_;^l^kbk_;^l^kb`03o`09C4go^l^kbk_;00?o00?;^ol00_l00h7oP@0=P@03
oh6100B10ol01[_;^l^kb`;o1H`08?nkbk_;^l^kbk_;^l^kbk_;^l^kboneo;Gl]Oo;^l_o0X43o`N1
01go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`0=P@08ok_;^l^kbol20003o`0000<000?o0000
=P0001<000?o00000P000ol0000600?o2[/3o`V100?oPH402h400onk^`0L^`03omkN00?N00?o^k/0
1;/00onk^`0;^`08ode<CDa=C?l8^`;o1H400on1P@0<P@03oh6100?o0k/2o`Fk00SoC8a<S4b<oaBk
00Ooo;Klooco00>k0_l;P@03ok^k01Vk00?oPH401X43o`03POnk00Jk00Co003o1@000ol0000e0000
4`000ol000030003o`0000801?l02L^kbk_;^l^kb`03o`f100?oPH401X43o`18^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_oLMiagW7Nok_;^l^kbk_;^l^kbk_;^l^kbk_;oda=C4e<COnkbk_;
0ol8P@03oh6100b10_l00k_;^`03o`0:S?nkbk_;^l_oS0?o01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`07bk_;^l^ko`0=P@0Lok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`F10ol5P@09ol^kbk_;
^l_o008000Co00000_lg00004P000ol000050003o`3o00;o2K/3o`B100?oPH402X400on1P@03P@;o
7K/2o`Fk00?og]h01=h00onk^`0B^`03odgo00;o0k/3o`b100?oPH401h43o`Fk00OoC8a<S4co00Jk
00?o^k/08[/00on1P@0;P@03ok^k01Rk00?oPOl00_l9P@03ok^k00Bk00Co003o1@000ol0000d0000
4P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03oh6100Z100?oPOl00_l07<^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/3o`;N00Sobk_;^l_oL@?o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l/0
0ol3P@03oh6100Z100?oPH400h43o`0:^l^kbk_;^l^ko`F<00go^l^kbk_;^l^kbk_;00;o01Vkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o00?;^ol03H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bol=P@08ol^kbk_;^ol20003o`0000<000?o0000<`00018000Co00000ol40003ok^k00>k0_l<P@03
oh6100Z100?o^k/07;/00omaL@04L@03ok^k00>k00?o^k/06K/3o`N100?oPH402X400on1o`02o`Fk
0_l6^`07odb<C?m<o`08^`?o00>eok/05K/3o`:e00Co^k_o2843o`03POnk01Vk00?oPH402h400onk
^`05^`04o`00o`@000?o0000<`0001801?l80007ok_;^l^ko`0=P@03oh6100B10ol08l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00KN00cobk_;^l^kbk_;^l/2o`0@^l^kbk_;^l^kbk_;
^l^kb`?o2h400on1P@0:P@06ok_;^l^k0ol02Hco^l^kbk_;^`03o`0;^l^kbk_;^l^kbol01@d08?o;
^l^kbk_;^l^kbk_;^l^kbk_;^onf]KJe][Gobk_o1H42o`F101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_o3H402?nkbk_;^l_o0P000ol000030003o`000380000B00;o2`000onk^`03^`03oh6100^1
00?oPH400olV^`03og7o00;o2[/3o`03C4go00bk0ol00h7oP@0<P@03oh6100B10ol6^`;o1H`00onk
^`0B^`03okFe00>e00?o^k/02[/2o`Fk00?o]KD01KD01Onk^on100?o28400onk^`0H^`03oh6100^1
00?o^k/01;/01?l00?l50003o`000340000D0003o`0000T000Oo^l^kbk_o00f10_l0><^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;^l^kbk_;^l_o1Td02_nkbk_;^l^k
bk/2o`F100?oPH402h400on1P@03o`0;^l^kbk_;^l^kbol01X`03Onkbk_;^l^kbk_;^l/00_l01k_;
^l^kbol00`d02ol=ol^kbk_;^l^k00?o00/=ok_;^l^kbone]P03o`03^l^k00?o38407?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@Co0X402Oo;^l^kbk_;o`020003o`0000800_lb00005@000ol0
00090003ok^k00>k00?oPH401X43o`>100?o^k/0;[/2o`Fk00SoC4e<CDa=o`Fk0ol8P@03oh6100^1
0_l>^`03ohco00;o2k/3o`033KGo00Jk0ol:^`03okFe00>e00?o^k/01;/2o`:k1?l2P@03oh6100Z1
00?o^k/06K/00on1P@03o`N100?o^k/01;/01Ol0003o00@000?o0000<00001H000?o00002@001onk
bk_;^ol01H42o`N102gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0ol02]ko^l^kbk_;odd3o`07bk_;^l^ko`0<P@03oh6100J10ol0B87o^l^kbk_;^l^kbk_;^l^kboo;
^l^kbk_;^l^kbk_;o`fe3KD=]Onkbk_;^l^kbk_;^l^kbk_;^l^ko`fe3KD=ok_;^l^kb`?o1h400on1
P@0:P@0Lok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h402?o;^l^kbk_o0P000ol000030003
o`0002l0000G0003o`0000T00_l4^`03oh7o00;o2X400onk^`0X^`07omoNgmkOo`06^`03ok^k00Rk
00?oPH402X400on1P@03P@;o1H400onk^`0D^`;o1K/02One3KD=]@feo`0;^`;o1[/01one]KGo]Ol0
0[/3o`^100?oPH4028400on1o`0J^`03oh6100Z100?o^k/01K/01?l00?l40003o`0002l0000H0003
o`0000X000Kobk_;^ol>P@0]ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_o00CN01?o^l^kbk_;^l^kbk_;^l^kbk_o00b100?oPOl00_l8P@0Cok_;^l^kbk_;^l^kbk_;^l^k
b`03o`0;3KGo^l^kbk_o]@d00ol02/^kbk_;^l^kbk/3o`09]Onkbk_;^l^k00?o00>kbol00_l00h7o
P@0<P@03oh6100B10ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^k
o`020003o`00008000?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/08;/3o`Jk
00Kog]oogolA^`03oh6100Z100?oPH402X400onk^`0>^`03o`d=00@=00?o^k/00k/2o`bk00?o3@d0
0`d00onk^`06^`?o1H400on1P@0;P@03oh6100?o8[/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0
000]00006P02o`/000Oobk_;^l_o00f101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o
0mh01onkbk_;^l/00_l05[_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@?o0h400on1P@0:P@0/ok_;^l^k
bk_;^l^kbk_;^l_o3KD=]@feok_;^l^kbk_;^l^kbk_;^l^kbol6]@05ok_;^l/00ol9P@03oh6100^1
0_l09k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`07P@?o00Z1ol^kbk_;^l_o
0P000ol0000200;o;P0001`000?o00002@000onk^`03^`;o2842o`:100?o^k/06[/00ooNgP05gP03
ok^k01^k00?oPH400ol7P@03oh6100Z100?o^k/01K/3o`Jk00?o3Ol00_lE^`03o`go00;o0k/3o`f1
00?oPH401X43obVk00?oPH400h42o`F100?o^k/01K/01?l00?l300;o;P0001d000?o00002@002?o;
^l^kbk_o1843o`F101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00KN00_o^l^kbk_;^l^k
b`03o`0@bk_;^l^kbk_;^l^kbk_;^`;o2h400on1P@0:P@04ok_;^`?o0lH09Onkbk_;^l_obk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kboo;^l/00ol3P@03oh6100Z100?oPH400h43o`0_^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^koh400ol8P@08ol^kbk_;^ol20003o`0000<0
00?o0000:`0001h000?o00002@000onk^`04^`04oh7oo`V100?o^k/06k/00ooNo`02o`Vk0ol01=kO
g_l@^`03oh6100Z100?oPH401843o`Jk00?oa/H01<H00onk^`0N^`?o1h400on1P@0:P@03oh7o00;o
<K/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0000Z00007`000ol000090008ol^kbk_;^ol<P@14
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbk_;^ooOg]oNgmkobk_;^l^kbk_;
^l^kbk_;^ol<P@03oh6100?o00^kbk_;^l^kbk_;o`06aP0;ok_;^l^kbk_;^l/00ol04<^kbk_;^l^k
bk_;^l^kbk/2o`^100?oPH402X40=_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000P000ol0000Z000080000ol0000900;o
1K/00on1P@0:P@03ok^k02Rk00SogmkOg]oNo`Zk0ol3^`03oh6100Z10_l>^`03olKo00;o2K/3o`<=
00?o^k/03K/00on1P@0;P@03oh6100B10olJ^`;o6;/2o`:k00?oPH402h400onk^`03^`05o`000?l0
10000ol0000Y00008@02o`/000Oo^l^kbk_o00b102gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^koml00ol02K_;^l^kbk_;^`03o`==00Go^l^ko`06P@?o02;;^l^kbk_;^l^k
bk_;^l^kbk_;ol^kbk_;^l^kbk_;^l_o1@d03Oo;^l^kbk_;^l^kbk/00_l00l_oP@0<P@03oh6100?o
01Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o01L_ol^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`06
8_o;^l_o2843o`09POnkbk_;^l_o008000?o00000`000ol0000X00008`000ol000090003ok^k00>k
00?oPH402X42obVk00?o^k/02k/01omVCFI=I_l00k/00on1P@03o`>k0_lH^`;o1[/01ol=3@go3Ol0
2;/3o`05c?nk^ol03H42oabk00Oo;b8_8Roo01>k00?o8R800b801?nk^ol5P@?o1H400onk^`04^`04
o`00o`<00_lZ000090000ol000090007ok_;^l^ko`06P@?o1840<?nkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00O;^l^kbk_o00==00KoCOnkbk/2o`03bk_;00?o
011=ol^kbk_;^l^kbk_;^l^k0ol01;_;^l/3o`09a/3o^l^kbk_;00?o01C;^l^kbk_;^l^kol`=c0g<
ok_;o`J11?l2P@0aok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kob4_8BlQok_;^l^kbk_;^l^k
b`02o`06^l^kbk_o1R801Oo;^on100?o2H402?nkbk_;^l_o0P000ol000020003o`0000D00ol300?o
6@0002D000?o00002@000onk^`03^`03oh6100?o28400onk^`0Y^`?o0]h00onk^`04^`?o2[/00omV
IP03IP03ok^k00Rk0ol2P@0<ok^k^oo0a/36`<Ko4[/01ol=c0g<3Ol00k/00on1P@03o`N100?o^k/0
6k/01olR;b;o8_l02;/3o`038Roo00Fk00?o8_l00_l5^`03oh6100Z100?o^k/01;/01?l00?l50003
o`0000D000?o00001@000ol0000F00009P000ol000090006ok_;^l^k0_l<P@0[ok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06g`0Qol^kbk_;^l^kbk_;^l^kbk_;^l_oCFI=
ITgobk_;^l^k00?o1X405Oo;^l_oa/36`<K0ok_;^l^kbk_;^`04o`0?bk_;^l_o3L`=o`gobk_;00;o
2h407_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o026kbk_;^l^kbk_;ob8_8RlR;onkbk_;
^onkbk_;^l^kbol03H402?o;^l^kbk_o0P000ol000020003o`0000D000?o00001@000ol0000F0000
9`000ol000090003ok^k00Bk00?oPH402X400onk^`0P^`;o1K/00ooNgP04gP03ok^k00Rk0ol6^`08
ofIVI_mVok/4o`Z100Ko^k^kol03o`Rk0ol33@03ok^k00Bk0ol7^`03oh6100Z100?o^k/09k/02Ol_
8RlR;b8_o`0;^`;o00>koh4038400onk^`04^`04o`00o`@000?o000010000ol0000200?o6@0002P0
00?o00002@02o`06bk_;^l_o38407onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol02]oN
ok_;^l^koml3o`09^l^kbk_;^l^k00?o0dd01onkbk_;^l/00ol01<_oool2P@03oh6100Z102Wobk_;
ol^kbk_;^l^kbk_;^oo<3L`=c?nkbk_;^l^kbk_;^l^kbk_;o`0<P@09ok_;^l^kbk_;00;o01Jkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;1?l02;_;^l^koblR0ol02/^kbk_;^l^kbk/3o`057onkbol02843o`09
POnkbk_;^l_o008000?o00000P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1
P@0:P@03ok^k01Zk00?og]h01=h00onk^`03^`03ok^k00^k00OoCFI=ITgo00Jk0ol6P@03oh6100Z1
00?o^k/01[/2o`Jk00Oo3@d=o`go00Zk0ol3^`03oh6100Z100?o^k/00[/3o`038?nk01:k0ol38@03
ok^k00Bk0_l;^`;o00HR7b8O8_l2^`03oh6100>10_l5P@03ok^k00Bk00Co003o0P000ol0o`0400;o
1004oaP0000[0003o`0000T000Oobk_;^l_o00J10ol3P@0`ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_ogmkOg]oNok_;^l^kbk_;^l^k0_l01l^kbk_;^ol00dd01_m=ok_;^`;o2X400on1P@08P@07
oh7obk_;^`03o`09a/3obk_;^l^k00?o00Zkbk_;^l^kbk_;0ol33@05ol^kbol01X43o`:100Gobk_;
o`058@0jol^kbk_;^l^kbk_;^l^kbk_;^l_o;b4_8Boobk_;^l^kbk_;^l^kbk_;^l^koalR7b8O8Qoo
^l_oP@?o28402?nkbk_;^l_o0P000ol000020003o`0002<0000/0003o`0000T000?o^k/00k/00on1
P@03o`N100?o^k/06[/00ooNo`02o`Zk0ol00moNo`06^`?o1k/00on1P@09P@03oh6100B10ol3P@04
ok^ko`K600?o^k/04K/01oo<3L`=c?l00k/00on1P@03o`J100Co^k_o1R000onk^`08^`?o1[/01olQ
8B7o8Ol04[/00olR7`03o`Fk00?oPH402H400onk^`04^`04o`00o`D000?o00008P0002d000?o0000
2@001_o;^l^kb`;o2h40@onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbk_;^ooN
gmkOg]oobk_;^l^kbk_;^l^kbk_;^ol02h400on1P@03o`N101Gobk_oa/36`<K0ol^kbk_;^l^kbk/0
0ol01k_;^l^kbol00`d01_l=ol^kb`;o2X401Oo;^olQ00?o00Vkbk_;^l^kbk/00ol38@07ok_;^l^k
b`03o`0Fbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o00W;^l^kbk_;^ol038402?o;^l^kbk_o0P000ol0
00030003o`000240000^0003o`0000T000?o^k/01;/00on1P@09P@03ok^k02Nk00SogmkOg]oNo`Zk
0ol3^`03oh6100V10_l;P@05ok^kolH00ol9^`?o00C6`<Ko1[/3o`Jk00?oPH402X401?nk^ol<^`08
oblQ;b4_8OlU^`;o0[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000Q0000;`000ol000090008
ol^kbk_;^ol;P@0/ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^komh3o`09
^l^kbk_;^l^k00?o00Q=ITgo^l^ko`J10ol2P@03oh6100Z101;obk_o^l^kbk_;^l^kbk_;^ol5`00A
ok_;^l^kbk_;^l^kbk_;^ol038402Oo;^l^kbk_;^`02o`06bk_;^l_o0b42o`0L8Onkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`?o00C;^l^k0ol01Roo^l^ko`N10ol02X7o^l^kbk_;^ol20003o`000080
00?o00008000030000?o00002@02o`Fk00?oPH402H42obRk00?o^k/02k/01om=ITeVCOl00k/00on1
P@03o`J100?oPH402X400onk^`0>^`07olK0a_o6o`09^`Co0[/00on1P@08P@03oh7o00Bk0ol00b3o
^`05^`?o6[/4o`9K00Go^k^ko`058P04ok^ko`F10_l5P@03ok^k00Bk00Co003o0`000ol0o`0Q0000
<@02o`/000Oo^l^kbk_o00J10ol3P@0_ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l04<^kbk_;^om=ITgoCOnkbk/2o`Z100?oPH402X404Oo;^l^kbk_;^l^kbk_;
^l^k00?o00Vkbk_;^l^kbk/00ol02<`=c0gobk_o1X43o`:100Go^l^ko`05800Pok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/3o`MK00oo^l_o7blO;al_ok_;oh400ol8P@08ok_;^l^kbol20003
o`00008000?o00007`0003<000?o00002@000onk^`03^`03oh6100?o1h400onk^`0X^`?o0]l00onk
^`04^`?o1[/00on1P@0:P@03oh6100B10olP^`03olc<00C<00Co^k_o0X43o`J100_o^k_o8B0Q824P
o`0J^`Co2e/01Onk^olR00?o1K/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000N0000=0000ol0
00090006ok_;^l^k0_l;P@0Zol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1]l04Oo;^l^kbk_;^l^kbk_;^l_o00b100?oPH400ol06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`03o`08bk_;^l^kol`3o`05^l^kbk/00_l:P@05ok_;ob000ol06L^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00ol2F`03oe]K00YK00kobk_;ol^kbk_;^l^ko`f100Oo^l^kbk_o008000?o00000`000ol0
000M0000=@000ol000090003ok^k00>k00?oPH402X400onk^`0O^`;o1[/00ooOg`03g`03ok^k00fk
00?oPH4028401?n1oolK^`?o0`d00onk^`04^`03ok^k00Jk00?oPH402X401?nk^olI^`?o1U/00omK
F`0:F`03ok^k00Fk0ol2^`03oh6100^100?o^k/00k/01?l00?l40003o`0001d0000f0003o`0000T0
00Oo^l^kbk_o00b101oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o0]l01onkbk_;^l/0
0ol05<^kbk_;^l^kbk_;^l^kbk_;^l_o1X43o`>101ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bol5c00Aol^kbk_;^l^kbk_;^l^kbol038402?nkbk_;^l^k0ol03k_;^l^kbk_;^l^kbk_;^`02o`YK
00?oFe/025/01_mKol^kb`?o00LO8_nkbk_o00J11?l2P@08ol^kbk_;^ol20004o`0000;o7P0003L0
00?o00002@000onk^`03^`03oh6100Z10_lK^`03omoO00?O00?o^k/06[/00on1P@03o`N100?o^k/0
4K/3o`Jk00Oo3@d=o`go00nk00?oPH4028400on1o`03^`?o00<Q8?l03k/00omKF`0:F`03oe]K00AK
0ol6^`07ob8O8QlRo`03^`03oh6100?o1h400onk^`03^`04o`00o`D000?o00006`0003P00_l:00;o
00G;^l^ko`06P@?o18407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00GO00_o^l^kbk_;^l^k
b`03o`0?bk_;^l^kbk_;^l^kbk_;00;o2h404?nkbk_;^l^kbk_;^l^kbk/3o`?<00Oo^l^kbk_;00?o
01C;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol07K_;^l^kbolP8B0Q8?o;^l^kbk_;^l^kbk_;^l_o00aK
00?oFe/00ol05<^kbk_;^l^kbk_o8QlRob;o^l^k0_l;P@07ol^kbk_;o`020003o`00008000?o0000
6`0003X000?o00002@000onk^`02^`03oh6100?o28400onk^`0I^`04omooo`Vk0ol3g`03ok^k00fk
00?oPH402X400onk^`0=^`03olc<00?<00?o^k/02K/2o`nk00?oPH400ol:^`07ob0Q8?lPo`0?^`03
oe]K00QK00CoFooo3[/3o`Jk00?oPH402X400onk^`04^`04o`00o`@000?o00006P0003/000?o0000
2@001Oo;^l^k00;o3840>onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_;omnO
gioOol^kbk_;^l^kbk_;00;o00>kbol038404Onkbk_;^l^kbk_;^l^kbk_o00?<00[oc?nkbk_;^l^k
0ol2c00@ol^kbk_;^l^kbk_;^l^kb`;o00jkbk_;^l^kbk_;^l^kb`?o01C;^l^kbk_;^l^kbk_;^l^k
bk_;o`IK0ol2F`0Kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100[o^l^kbk_;o`3o1@000ol0
000I0000?0000ol000090003ok^k00>k00?oPH402X400onk^`0V^`07omoOgooOo`08^`;o0VH01?nk
^ol<P@03ok^k00fk0ol9^`08ol`=c0g<3Ole^`03oe]K00?o1U/00onk^`0G^`03oh6100R100?oPOl0
1K/01?l00?l40003o`0001T0000m0003o`0000T000Kobk_;^l/2o`^102Wo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`0Dbk_;^l^kbk_;^omV@VI2I_nkbol6P@?o0h407Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00K<02?obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^`04o`0?bk_;^l^kbk_;^l^kbk_;00;o2U/06_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X44o`:100Sobk_;^l^ko`8000Co00000_lJ0000?P000ol000090003ok^k00Bk00?oPH401843o`:1
00?o^k/0;;/2o`Bk00?oIVH016H01?nk^ol2P@?o1h400onk^`0I^`03olco00;o8K/3o`@P00?o^k/0
3;/00omKF`09F`03ok^k01Nk00?oPH400ol7P@03ok^k00Bk00Co003o10000ol0000G0000?`000ol0
00090008ol^kbk_;^ol2P@?o1X40:onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00ol02MnOok_;^l_o@P03o`05bk_;^l/00_l;P@13ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06800@ol^kbk_;^l^kbk_;
^l^ko`]K01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2h401oo;^l^kbol00P000ol000030003
o`0001H0001000;o2P000onk^`04^`;o2X400onk^`0V^`08omnOgioOWol4^`03ok^k00Nk00?oPH40
2X400onk^`0f^`Co1K/00olPo`02o`:k0ol<^`03oe]K00MK00?oFol06;/00on1P@0:P@03ok^k00Bk
00Co003o10000ol0000F0000@P000ol0000800;o00Jkbk_;^ol;P@0kok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_ogioOWmnOok_;^l^kbk_;^l/00_l00k_;o`0<P@0eok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol4?`09ok_;^l^k
ok_;00?o0U/03_nkbk_;^l^kbk_;^l_o1U/3o`=K01[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`b1
00So^l^kbk_;o`8000?o00000P000ol0000E0000@`000ol000090003ok^k00>k00?oPH402H400onk
^`0M^`Co1K/00ooOo`02o`Vk0ol2CP04ok^ko`J10ol2P@03ok^k03>k00?o820012000onk^`02^`?o
1U/00onk^`0:^`03oe]K00?o1e/00onk^`0F^`03oh6100R100?oPOl01K/01?l00?l50003o`0001@0
00140003o`0000T000Oo^l^kbk_o00^10_l06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0Q
WmnOgoo;^l^kboo;^l^kbk_;^l^kbom2IT9V@VKo^l_o00:10ol6P@0hol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ocl3o`04bk_;^`;o2U/03Onkbk_;^l^k
bk_;^l/00_l;F`0Iok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l0
0002oaH000150003o`0000T000?o^k/00k/00on1P@04P@?o0h400onk^`0H^`08omnOgioOWolB^`03
odi>00=>00?o^k/00_l:P@03ok^k03>k00?o^k/01K/00omKF`0:F`03ok^k00Zk00?oFe/02U/00onk
^`0E^`03oh6100?o1h400onk^`04^`04o`00o`@000?o00004`0004H000?o00002@001onkbk_;^ol0
0X43o`N101gobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_oW`03o`0E^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00?o00Nkbk_;^l_o00^103_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`03bomK00]K00ko^l^kbk_;^l^kbk_;o`aK01Ko^l^kbk_;^l^k
bk_;^l^kbk_;^l^k1?l;P@0:ol^kbk_;^ol0o`<00olD0000A`000ol000090003ok^k00>k0_l;P@03
ok^k01Rk00?o^k/08;/00on1P@09P@03ok^k01fk1?lC^`?o00Dook^ko`0:F`03oe_o00bk00?oFe/0
15/3o`9K00?o^k/04;/3o`:100?oPH402h400onk^`03^`03o`0000?o0P000ol0000B0000B002o`X0
00So^l^kbk_;o`^1027obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/00_l05L^kbk_;^l^k
bk_;^l^kbk_;^l^kb`04o`03^l_o00^10_l06k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`@o
01?o^l^kbk_;^l^kbk_;^l^kbk_o00Do00Co^l_o1U/3o`0A^l^kbk_;^l^kbk_;^l^kbol00U/3o`IK
00oobk_;^l^kbk_;^l^kbk/00ol6P@03oh6100^100Kobk_;^l/2o`030?l0008000?o00004P0004X0
00?o00002002o`Fk00?oPH402H400onk^`0J^`?o0Yl00onk^`0@^`;o14801?nk^ol6P@?o0h400onk
^`0H^`03odm?00A?00?o^k/02;/2o`Fk00?o?cl00cl01?nk^ol2F`?o4[/4o`YK00?o^k/01k/4o`Z1
00?oPH401844o`Vk00?o0?l00`000ol0000B0000B`000ol000090007ol^kbk_;o`06P@?o0X40?oo;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onOgioOWmoobk_;^l^kbk_;^l^kbk_;^l_o@Ti2CT9>ok_;
o`02P@?o1h407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbolo00?o00W;^l^kbk_;^l/00ol023m?
ok_;^l^k0ol01[_;^l^kb`;o01:kbk_;^l^kbk_;^l^kbk_;^l/3o`9K00?oFe/02E/01onkbk_;^l/0
0ol2P@03oh6100Z100?oPH400ol02;_;^l^kbk_;0ol50004o`00oa@0001<0003o`0000T000?o^k/0
0k/00on1P@03o`J100?o^k/04K/3o`Fk00?oWil00il00onk^`0?^`03od;o00;o1K/2o`^100?o^k/0
6;/00onk^`09^`03oclo00@o00?o^k/07;/3o`IK00?oFe/02E/00onk^`03o`J100?oPH402X42o`Nk
1?l90004o`00oa<0001=0003o`0000T000Kobk_;^l/2o`Z1013obk_;^l^kbk_;^l^kbk_;0ol02IoO
ok_;^l^kb`03o`0Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^l^kbol<P@0Pok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2o`0Vbk_;^l^kodloCcm?ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/4o`YK00?oFe/01e/01?mKool:P@03oh6100B10ol02<^kbk_;^l^k0ol>0003o`3o01<0001>0003
o`0000T000?o^k/00k/00on1P@09P@03ok^k00fk00?ogml00]l00onk^`0Q^`?o0[/00on1P@0:P@03
ok^k00>k1?lC^`;o00=O7ol01[/3oaVk0ol2F`03oe]K00YK00CoFe]K1Ol2P@03oh6100Z100?oPH40
0ol7^`Co4@000ol0o`0C0000C`02o`X000Oobk_;^l_o00^103Gobk_;^l^kbk_;^l^kbk_;oioOomoo
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`07CToobk_;o`06P@?o0X400oo;^`03o`A?
01?obk_;^l^kbk_;^l^kbk_;^l_o00DO01oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o
1U/00omKF`0:F`?o28400on1P@0:P@;o00O;^l^kbk_;00?o5P02oa<0001A0003o`0000P000?o^k/0
0k/00on1P@09P@;o3[/2ob>k00?o@T800T801Onk^k_o00:10ol6P@0;ok^kocm??dloCol02K/3o`Fk
00Oo7elOGaoo01Vk1?l:F`03oe]K00AK0ol2P@03oh6100V100?oPH401843o`Nk1?lH00?o4`000580
00?o00002002o`05^l^kbol01X43o`>101Co^l^kbk_;^l^kbk_;^l^kbk_;^`;o02O;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_oCTooCoo;^l/00_l:P@05ol^kodl00ol02;_;^l^kbk_;0ol27`07
ok_;^l^kb`03o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`9K00?oFe/02U/00omKF`03o`J1
00?oPH402H400on1P@03o`07^l^kbk_;^`03oaT00olF0000D`000ol000090003ok^k00:k00?oPH40
0ol7P@03ok^k00jk0_l00ioOo`0N^`;o1[/00on1P@0:P@04ok^ko`^k00Oo7elOGaoo00^k0_lA^`?o
1U/00omKF`0:F`;o2X400on1P@07P@04oh7oo`Jk1?lH00Co6@0005@000?o00002@001Onkbk_;00;o
2h40>Onkbk_;^l^kbk_;^l^kbonOgioOWoo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
b`02o`03^on100^100Oobk_;^l^k00Co00G;^l^ko`037`0:oaoo^l^kbk_;^`?o00mO7oo;^l^kbk_;
^l^kbk/01?l:F`03oe]K00AK0ol2P@03oh6100V100?oPH401843o`07bk_;^l^kb`03oaT00olM0000
E@000ol000090003ok^k00>k00?oPH402H400onk^`05^`;o1K/01ooOWmnOgol07k/3o`05Cd;o^ol0
2X400on1o`02^`?o00DOGamOo`04^`?o2K/00olO7`047`03ok^k00Jk0ol2F`03oe]K00YK00?oFe/0
0ol6P@03oh6100V100?oPH400ol6^`Co6004ob00001F0003o`0000T000Oo^l^kbk_o00^10_l00l^k
b`02o`08gioobk_;^l/3o`0[bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;odm2Cd9?@_nk
o`06P@?o02[;^l^kbk_oGamO7elOol^kbk_;^l^kbk_;^l^kbk_;oamO7elOol^kbk/3o`IK00?oFe/0
2U/2o`Z100?oPH401h402_n1ooo;^l^kbk/3oaP01?lT0000E`02o`X000?o^k/00k/00on1P@04P@?o
0h402OnkoioOWmnOo`0Z^`09od9?@Tm2ok_o00:10ol2^`?o1K/00olOo`02oaBk0ol5^`;o2U/00omK
F`04F`?o0X400on1P@09P@03oh6100B10ol6^`Co6003obP0001I0003o`0000P000Oo^l^kbk_o00:1
0ol7P@0col_oWmnOgioobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o
00Fkbk_;^`02o`03bk_o00;o0el0:?nkbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bol;F`03oe]K00?o1X400on1P@09P@03oh6100?o00Jkbk_;^l/3oaP01?l[0000FP000ol000080003
ok^k00>k0_l;P@03ok_o00;o>K/02?lOGamO7eoo2K/3oaFk0ol2^`03oe]K00UK0_l:P@03oh6100N1
00CoPOoo1K/4oaP00ol_0000F`000ol0000800;o00K;^l^kbol;P@08ol^kbk_;^l/2o`0/^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/4o`06^l^kbomO0ol00l^kb`03o`03
bk_o00;o01EO7oo;^l^kbk_;^l^kbk_;^l^kbk/00ol38`04ok_;o`IK0ol2P@03oh6100V100CoPH61
1Ol01/^kbk_;^`?o6004oc80001L0003o`0000T000?o^k/00k/00on1P@09P@04ok^k^`?o00>Ook/0
:K/2o`05GamO7ol01;/01?nk^k/3o`>100Co^k_o15l00onk^`0?^`03ob<S00@S00Co^k_o0U/3o`J1
00?oPH402H43o`Nk1?lH00?o=P0005d000?o00002@001oo;^l^kbol01X43o`:100?obol01Il09?o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o012kbk_;^olOGamO7onkbk_;0ol7P@0L
ol^koelOoaoobk_;^l^kbk_;^l^kbk_;^l_o8`?o00?;^l/01?l:P@03oh6100B10ol02;_;^l^kbk_;
0olH00Co>@0005h000?o00002@000onk^`03^`03oh6100?o1X401?nk^ol4W`03ok^k00Nk1?lB^`?o
00<Gok/01K/3o`Fk0_l;P@03ok^k00;o5K/01?nk^k/3o`:100?oPH402X400on1P@03o`Nk1?lH00?o
?@0005l00_l:0006ol^kbk_;0_l:P@03ol^k00;o00[;^l^kbk_;^l^k0_l44@0Bok_;^l^kbk_;^l^k
bk_;^l_o1AL04?o;^l^kbk_;^l^kbk_;^ol<P@0Jol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`J1
00?oPH402X42o`07^l^kbk_;^`03oaP01?m00000H@000ol000080003ok^k00>k00?oPH402H400onk
^`05^`;o1;/00olA4@044@03ok^k00Nk0ol5^`03oaLG008G00?o^k/01k/4o`03^on100^100?o^k/0
4[/4o`Z100?oPH401843o`Nk1?lH00?oA000068000?o000020001oo;^l^kbol02h42o`03^l^k00;o
0Yl01onkbk_;oa400ol02<^kbk_;^l^k0ol02A4Gol^kbk_;^`02o`0:bk_;^l^kbk_;^`;o00MO7elO
ok_o00J10ol2P@0@ok_;^l^kbk_;^l^kbk_;^`Go0h400on1P@09P@03oh6100?o00O;^l^kbk_;00?o
6004odL0001S0003o`0000P00_l4^`03oh6100B10ol3P@03ok_o00DA00?o^k/00[/00onk^`0:^`03
oaLG008G00?o^k/04;/00omOG`03G`03ok_o00:10ol6P@03ok^k00Rk1?l9P@03oh6100V10_l6^`Co
5`04od/0001T0003o`0000T000Ko^l^kbol2P@?o1h400onko`05W`0:ok_;^l^kbk_;^`?o01fkbk_;
^olA5olGol^kbk_;^l^kbk_;^l^kbk_;^`03o`05^l^kbk/00_l:P@07ok_;^l^kb`03o`:100?oPH40
2H400on1P@04P@?o00K;^l^kbk/3oaP00om?0000I@000ol000090003ok^k00:k0_l;P@03ok_o00;o
2K/3o`045a4Go`Fk0_lN^`03oh6100V100?o^k/00ol6P@03oh6100V100?oPH400ol5^`Co5`04oe80
001V0003o`0000T000Oo^l^kbk_o00^101ko^l^kbk_;^l^kbk_;^olG4ALA5onkbk_;^l^kbk/3o`0J
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol;P@;o2X400on1P@07P@08oh7ool^kbk/4oaP00omF0000
I`02o`X000?o^k/00k/00on1P@09P@03ok^k00^k00Co5ooo2;/3o`045a4GoaVk00?oPH401843o`:1
00?oPH402H401?n1PH45o`Fk0olH00CoF@0006T000?o000020001onkbk_;^ol01X43o`:103_o^l^k
bk_;^l^kbk_;^onkbk_;^l^kbk_;^olA5a4G4Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02P@?o
1X400on1P@09P@?o00Jkbk_;^l/4oaP00omM0000JP000ol000080003ok^k00>k00?oPH400ol6P@03
ok^k01Nk00Co5ooo6[/4o`Z100?oPH401843o`Nk0olH00CoH00006/000?o00002002o`04bk_;^`;o
2X40<_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1Ol4P@03
oh6100R100?oPH400ol01/^kbk_;^`Co6003of@0001/0003o`0000T000?o^k/00[/00on1P@09P@03
ok^k02^k0ol:P@03oh6100R10_l6^`?o6004ofL0001]0003o`0000T000Kobk_;^ol;P@0Zok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol2P@03oh6100V100?oPH401Ol01[_;
^l^kb`Co6003of/0001^00;o2P000onk^`02^`03oh6100B10ol2P@03ok^k02>k0ol6P@03oh6100V1
0_l8^`?o6004ofh0001`0003o`0000P000Kobk_;^ol2P@?o1X408Onkbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`04o`Z100?oPH401843o`07^l^kbk_;^`04oaL01?mb0000L@000ol000080003
ok^k00:k0_l:P@03ok^k01Rk1Ol3P@03oh6100V100?oPH400ol7^`?o6003ogH0001b0003o`0000P0
00Oobk_;^l_o00Z101Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`V100?oPH402H42o`06^l^kbk_;
1?lG00CoN@0007<000?o00002002o`Bk00?oPH4028400onk^`0@^`?o0X400on1P@08P@03oh6100B1
0ol6^`?o6003ogd0001d0003o`0000T000Ko^l^kbol2P@Go0h403onkbk_;^l^kbk_;^l^kb`03o`J1
00?oPH4028400on1P@03o`05^l^kbk/01?lG00CoP00007D000?o00002@000onk^`02^`;o2H400onk
^`08^`?o2X400on1P@06P@04oh7oo`Fk0olH00?oQ00007H00_l:0007ok_;^l^ko`09P@07ok_;^l^k
b`03o`:100?oPH402H400on1P@05o`05bk_;^l/01?lG00CoQ`0007P000?o000020000onk^`03^`03
oh6100N100?o^k/00ol6P@03oh6100V10_l7^`?o6003oh/0001i0003o`0000P000Oo^l^kbk_o00N1
00CoPOoo2X400on1P@04P@?o00K;^l^kbk/4oaL01?n>0000NP000ol000080003ok^k00>k00?oPH40
1?l4P@03oh6100R100?oPH400ol6^`?o6003oi80001k0003o`0000P000Ko^l^kbk/2o`V100?oPH40
2842o`05bk_;^l/01?lG00CoU@0007`000?o00002002o`Bk00?oPH4028400on1P@05o`Jk0olG00Co
V@0007d000?o00002@001_o;^l^ko`Z10_l01k_;^l^kbk/01?lG00?oW@0007h00_l:0003ok^k00:k
00?oPH400h43o`Nk0olG00CoX000080000?o000020001oo;^l^koh400ol01[_;^l^kb`Co5`03oj@0
00210003o`0000P000?o^k/00[/00onk^`04^`?o5`04ojL000220003o`0000P000Oobk_;^l^k00Co
5`03oj/000230003o`0000P000?o^k/00olG00Co[P0008@000?o00001`03oaL00onb0000Q@02o`L0
00?o00004`04okD000270003o`0000@000?o00004003okT000280003o`0000<000?o00003004ok`0
00290005o`000?l02`04ol00002:0004o`00o`P00oo40000R`000ol0o`0400Coa`0008`00_l0103o
ooo;0000S@02olh0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0003o05h0
003o05h0003o05h0003o05h0002B0003o`0002L000?o0000WP0006d01?l300Co00@0ool00_l200;o
0`03o`<00ol40003o`0000P01Ol0103oo`02o`801Ol00`3oo`0300?o10000ol0000700?o1005o`80
0ol300;o0`03o`@00ol300;oK`0006`000Go0000o`020003o`0000<000Co003o0`02o`H000?o0000
0`000ol000020003o`0000T000Go0000o`020004o`00o`<000?o00000_l40003o`0000@000?o0000
1`000ol000050003o`00008000Co003o0P02o`H000?o00000P000ol0000200;oK`0006`000?o0?l0
0_l200Go00D0o`00o`0;0003o`0000<000?o00003P001Ol0003o008000Co003o0`000ol000060003
o`0000h000?o00001@000ol000020003o`0000/000?o00001?md0000K0000ol000040007o`000?l0
o`020003o`0000L00_l300?o4@001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003
o`00008000?o00002@02o`<000?o0?l0M@0006`000Go0000o`0300?o00<0ool00ol;0004o`00oa<0
00?o00001Ol300Co20000ol0000>0003o`0000@00_l300Co2`001_l00?l0ogD0001]00Co5003o`<0
1?l>00Go2`000ol0000500;o3`05o`T000?o00002003o`@00_me0000[002ob4000?o00000P000ol0
00260000o`1N0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 35"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 22",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 38",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 38", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.20716 1.440505 0.023144 0.95303 [
[(Gen.38, Ind.1, Fit.44.)] .5 1 0 -1.5 Msboxa
[(5)] .22073 .12079 .84926 1 Msboxa
[(10)] .37318 .08088 .7914 1 Msboxa
[(15)] .53104 .03956 .73354 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30157 .03836 .79718 1 Msboxa
P
[(5)] .7205 .081 -1 .38155 Msboxa
[(10)] .79712 .15361 -1 .36661 Msboxa
[(15)] .86911 .22183 -1 .35279 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87417 .12598 -1 .36805 Msboxa
P
[(0)] .09618 .17764 1 -0.39226 Msboxa
[(10)] .07402 .35493 1 -0.36204 Msboxa
[(20)] .0493 .55282 1 -0.32812 Msboxa
[(30)] .02153 .77513 1 -0.28978 Msboxa
[(t)] -0.02334 .47249 1 -0.34524 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.38, Ind.1, Fit.44.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11451 .16063 m
.6388 .02383 L
s
P
p
.002 w
.23239 .12987 m
.23822 .13441 L
s
P
[(5)] .22073 .12079 .84926 1 Mshowa
p
.002 w
.38435 .09022 m
.38994 .09489 L
s
P
[(10)] .37318 .08088 .7914 1 Mshowa
p
.002 w
.54169 .04916 m
.54702 .05397 L
s
P
[(15)] .53104 .03956 .73354 1 Mshowa
p
.001 w
.26236 .12205 m
.26583 .12479 L
s
P
p
.001 w
.29255 .11418 m
.29599 .11693 L
s
P
p
.001 w
.32294 .10625 m
.32635 .10902 L
s
P
p
.001 w
.35354 .09826 m
.35692 .10105 L
s
P
p
.001 w
.41538 .08212 m
.4187 .08494 L
s
P
p
.001 w
.44662 .07397 m
.44992 .0768 L
s
P
p
.001 w
.47809 .06576 m
.48135 .06861 L
s
P
p
.001 w
.50978 .05749 m
.51301 .06036 L
s
P
p
.001 w
.20262 .13764 m
.20614 .14035 L
s
P
p
.001 w
.17305 .14536 m
.1766 .14805 L
s
P
p
.001 w
.14368 .15302 m
.14726 .1557 L
s
P
p
.001 w
.57383 .04078 m
.57699 .04368 L
s
P
p
.001 w
.6062 .03233 m
.60933 .03525 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30157 .03836 .79718 1 Mshowa
P
P
p
p
.002 w
.6388 .02383 m
.89323 .26471 L
s
P
p
.002 w
.70367 .08524 m
.69526 .08737 L
s
P
[(5)] .7205 .081 -1 .38155 Mshowa
p
.002 w
.78022 .15771 m
.77176 .15976 L
s
P
[(10)] .79712 .15361 -1 .36661 Mshowa
p
.002 w
.85213 .2258 m
.84364 .22778 L
s
P
[(15)] .86911 .22183 -1 .35279 Mshowa
p
.001 w
.71937 .10011 m
.71432 .10137 L
s
P
p
.001 w
.73487 .11478 m
.72982 .11604 L
s
P
p
.001 w
.75018 .12927 m
.74512 .13052 L
s
P
p
.001 w
.76529 .14358 m
.76022 .14482 L
s
P
p
.001 w
.79495 .17167 m
.78988 .17289 L
s
P
p
.001 w
.80951 .18545 m
.80443 .18666 L
s
P
p
.001 w
.82389 .19906 m
.81881 .20027 L
s
P
p
.001 w
.8381 .21251 m
.83301 .21371 L
s
P
p
.001 w
.68777 .07019 m
.68273 .07147 L
s
P
p
.001 w
.67166 .05494 m
.66662 .05623 L
s
P
p
.001 w
.65533 .03948 m
.6503 .04078 L
s
P
p
.001 w
.866 .23892 m
.8609 .2401 L
s
P
p
.001 w
.87969 .25189 m
.87459 .25306 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87417 .12598 -1 .36805 Mshowa
P
P
p
p
.002 w
.11451 .16063 m
.03601 .79453 L
s
P
p
.002 w
.11294 .17329 m
.12132 .17112 L
s
P
[(0)] .09618 .17764 1 -0.39226 Mshowa
p
.002 w
.09095 .35087 m
.09942 .34884 L
s
P
[(10)] .07402 .35493 1 -0.36204 Mshowa
p
.002 w
.0664 .5491 m
.07496 .54725 L
s
P
[(20)] .0493 .55282 1 -0.32812 Mshowa
p
.002 w
.03883 .77181 m
.04747 .77016 L
s
P
[(30)] .02153 .77513 1 -0.28978 Mshowa
p
.001 w
.10873 .20731 m
.11377 .20602 L
s
P
p
.001 w
.10443 .24206 m
.10948 .24078 L
s
P
p
.001 w
.10003 .27755 m
.10509 .27629 L
s
P
p
.001 w
.09554 .31381 m
.10061 .31257 L
s
P
p
.001 w
.08626 .38875 m
.09135 .38756 L
s
P
p
.001 w
.08146 .42749 m
.08657 .42631 L
s
P
p
.001 w
.07656 .46711 m
.08167 .46595 L
s
P
p
.001 w
.07154 .50763 m
.07666 .5065 L
s
P
p
.001 w
.06115 .59155 m
.06629 .59046 L
s
P
p
.001 w
.05577 .63501 m
.06092 .63394 L
s
P
p
.001 w
.05026 .67951 m
.05542 .67846 L
s
P
p
.001 w
.04461 .7251 m
.04979 .72408 L
s
P
[(t)] -0.02334 .47249 1 -0.34524 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11294 .17329 m
.40556 .38814 L
s
P
p
.4 g
.002 w
.09095 .35087 m
.40024 .55843 L
s
P
p
.4 g
.002 w
.0664 .5491 m
.39438 .74643 L
s
P
p
.4 g
.002 w
.03883 .77181 m
.38787 .95505 L
s
P
p
.4 g
.002 w
.1885 .21529 m
.12642 .84129 L
s
P
p
.4 g
.002 w
.27607 .27999 m
.23233 .89607 L
s
P
p
.4 g
.002 w
.35863 .34098 m
.33109 .94715 L
s
P
.002 w
.11451 .16063 m
.03601 .79453 L
s
.03601 .79453 m
.38721 .97617 L
s
.38721 .97617 m
.40594 .37593 L
s
.40594 .37593 m
.11451 .16063 L
s
.6388 .02383 m
.89323 .26471 L
s
.89323 .26471 m
.96399 .88318 L
s
.96399 .88318 m
.66538 .6755 L
s
.66538 .6755 m
.6388 .02383 L
s
.11451 .16063 m
.03601 .79453 L
s
.03601 .79453 m
.66538 .6755 L
s
.66538 .6755 m
.6388 .02383 L
s
.6388 .02383 m
.11451 .16063 L
s
p
.4 g
.51599 .35081 m
.51651 .95533 L
s
P
p
.4 g
.65744 .31852 m
.68352 .9284 L
s
P
p
.4 g
.8034 .28521 m
.85683 .90046 L
s
P
p
.4 g
.40556 .38814 m
.89466 .27717 L
s
P
p
.4 g
.40024 .55843 m
.9146 .4515 L
s
P
p
.4 g
.39438 .74643 m
.93674 .64506 L
s
P
p
.4 g
.38787 .95505 m
.96147 .86121 L
s
P
.40594 .37593 m
.89323 .26471 L
s
.89323 .26471 m
.96399 .88318 L
s
.96399 .88318 m
.38721 .97617 L
s
.38721 .97617 m
.40594 .37593 L
s
p
.4 g
.23239 .12987 m
.51599 .35081 L
s
P
p
.4 g
.38435 .09022 m
.65744 .31852 L
s
P
p
.4 g
.54169 .04916 m
.8034 .28521 L
s
P
p
.4 g
.1885 .21529 m
.70367 .08524 L
s
P
p
.4 g
.27607 .27999 m
.78022 .15771 L
s
P
p
.4 g
.35863 .34098 m
.85213 .2258 L
s
P
P
p
.002 w
.41144 .37929 m .41921 .38504 L .40556 .38814 L p
.4 g
F P
s
P
p
.002 w
.40556 .38814 m .39776 .38241 L .41144 .37929 L p
.4 g
F P
s
P
p
.002 w
.89466 .27717 m .40556 .38814 L .11294 .17329 L p
.9 g
F P
s
P
p
.002 w
.43291 .38193 m .41921 .38504 L p
.41144 .37929 L .4 g
F P
s
P
p
.002 w
.41144 .37929 m .39776 .38241 L .38991 .37665 L p
.4 g
F P
s
P
p
.002 w
.43893 .37303 m .44666 .37881 L .43291 .38193 L p
.4 g
F P
s
P
p
.002 w
.41144 .37929 m .43893 .37303 L p
.43291 .38193 L .4 g
F P
s
P
p
.002 w
.38991 .37665 m .38202 .37085 L p
.41144 .37929 L .4 g
F P
s
P
p
.002 w
.38202 .37085 m .39576 .3677 L .41144 .37929 L p
.4 g
F P
s
P
p
.002 w
.46044 .37568 m .44666 .37881 L p
.43893 .37303 L .4 g
F P
s
P
p
.002 w
.4666 .36673 m .47427 .37255 L .46044 .37568 L p
.4 g
F P
s
P
p
.002 w
.43893 .37303 m .4666 .36673 L p
.46044 .37568 L .4 g
F P
s
P
p
.002 w
.48814 .3694 m .47427 .37255 L p
.4666 .36673 L .4 g
F P
s
P
p
.002 w
.39576 .3677 m .38202 .37085 L .37408 .36503 L p
.4 g
F P
s
P
p
.002 w
.49444 .36039 m .50205 .36624 L .48814 .3694 L p
.4 g
F P
s
P
p
.002 w
.4666 .36673 m .49444 .36039 L p
.48814 .3694 L .4 g
F P
s
P
p
.002 w
.37408 .36503 m .3661 .35917 L p
.39576 .3677 L .4 g
F P
s
P
p
.002 w
.3661 .35917 m .37989 .35598 L .39576 .3677 L p
.4 g
F P
s
P
p
.002 w
.516 .36308 m .50205 .36624 L p
.49444 .36039 L .4 g
F P
s
P
p
.002 w
.52245 .35401 m .53 .3599 L .516 .36308 L p
.4 g
F P
s
P
p
.002 w
.49444 .36039 m .52245 .35401 L p
.516 .36308 L .4 g
F P
s
P
p
.002 w
.54404 .35671 m .53 .3599 L p
.52245 .35401 L .4 g
F P
s
P
p
.002 w
.37989 .35598 m .3661 .35917 L .35807 .35327 L p
.4 g
F P
s
P
p
.002 w
.55063 .34759 m .55813 .35352 L .54404 .35671 L p
.4 g
F P
s
P
p
.002 w
.52245 .35401 m .55063 .34759 L p
.54404 .35671 L .4 g
F P
s
P
p
.002 w
.35807 .35327 m .35 .34735 L p
.37989 .35598 L .4 g
F P
s
P
p
.002 w
.35 .34735 m .36385 .34412 L .37989 .35598 L p
.4 g
F P
s
P
p
.002 w
.57226 .35031 m .55813 .35352 L p
.55063 .34759 L .4 g
F P
s
P
p
.002 w
.579 .34113 m .58643 .3471 L .57226 .35031 L p
.4 g
F P
s
P
p
.002 w
.55063 .34759 m .579 .34113 L p
.57226 .35031 L .4 g
F P
s
P
p
.002 w
.43549 .34313 m .40761 .34957 L .39167 .33764 L p
.8 g
F P
s
P
p
.002 w
.579 .34113 m .55063 .34759 L .53551 .33564 L p
.4 g
F P
s
P
p
.002 w
.36385 .34412 m .35 .34735 L .34188 .34138 L p
.4 g
F P
s
P
p
.002 w
.60065 .34387 m .58643 .3471 L p
.579 .34113 L .4 g
F P
s
P
p
.002 w
.34188 .34138 m .33371 .33539 L p
.36385 .34412 L .4 g
F P
s
P
p
.002 w
.33371 .33539 m .34762 .33212 L .36385 .34412 L p
.4 g
F P
s
P
p
.002 w
.60754 .33463 m .61491 .34064 L .60065 .34387 L p
.4 g
F P
s
P
p
.002 w
.579 .34113 m .60754 .33463 L p
.60065 .34387 L .4 g
F P
s
P
p
.002 w
.46356 .33664 m .43549 .34313 L .41967 .33112 L p
.8 g
F P
s
P
p
.002 w
.39167 .33764 m .41967 .33112 L .43549 .34313 L p
.8 g
F P
s
P
p
.002 w
.53551 .33564 m .56399 .3291 L .579 .34113 L p
.4 g
F P
s
P
p
.002 w
.62922 .33739 m .61491 .34064 L p
.60754 .33463 L .4 g
F P
s
P
p
.002 w
.41967 .33112 m .39167 .33764 L .37555 .32557 L p
.8 g
F P
s
P
p
.002 w
.63626 .32809 m .64357 .33413 L .62922 .33739 L p
.4 g
F P
s
P
p
.002 w
.60754 .33463 m .63626 .32809 L p
.62922 .33739 L .4 g
F P
s
P
p
.002 w
.41967 .33112 m .44785 .32456 L .46356 .33664 L p
.8 g
F P
s
P
p
.002 w
.56399 .3291 m .53551 .33564 L .52021 .32354 L p
.4 g
F P
s
P
p
.002 w
.34762 .33212 m .33371 .33539 L .3255 .32936 L p
.4 g
F P
s
P
p
.002 w
.65797 .33087 m .64357 .33413 L p
.63626 .32809 L .4 g
F P
s
P
p
.002 w
.3255 .32936 m .31724 .32329 L p
.34762 .33212 L .4 g
F P
s
P
p
.002 w
.31724 .32329 m .33119 .31999 L .34762 .33212 L p
.4 g
F P
s
P
p
.002 w
.37555 .32557 m .40366 .31897 L .41967 .33112 L p
.8 g
F P
s
P
p
.002 w
.66516 .32151 m .67241 .32759 L .65797 .33087 L p
.4 g
F P
s
P
p
.002 w
.63626 .32809 m .66516 .32151 L p
.65797 .33087 L .4 g
F P
s
P
p
.002 w
.52021 .32354 m .4918 .33011 L .4762 .31795 L p
.8 g
F P
s
P
p
.002 w
.52021 .32354 m .54881 .31693 L .56399 .3291 L p
.4 g
F P
s
P
p
.002 w
.6869 .3243 m .67241 .32759 L p
.66516 .32151 L .4 g
F P
s
P
p
.002 w
.69424 .31489 m .70144 .321 L .6869 .3243 L p
.4 g
F P
s
P
p
.002 w
.66516 .32151 m .69424 .31489 L p
.6869 .3243 L .4 g
F P
s
P
p
.002 w
.54881 .31693 m .52021 .32354 L .50474 .31131 L p
.8 g
F P
s
P
p
.002 w
.4762 .31795 m .50474 .31131 L .52021 .32354 L p
.8 g
F P
s
P
p
.002 w
.33119 .31999 m .31724 .32329 L .30893 .31719 L p
.4 g
F P
s
P
p
.002 w
.69424 .31489 m .66516 .32151 L .65052 .30925 L p
.8 g
F P
s
P
p
.002 w
.71602 .3177 m .70144 .321 L p
.69424 .31489 L .4 g
F P
s
P
p
.002 w
.30893 .31719 m .30057 .31105 L p
.33119 .31999 L .4 g
F P
s
P
p
.002 w
.30057 .31105 m .31458 .30771 L .33119 .31999 L p
.4 g
F P
s
P
p
1 .02 0 r
.01 w
.64335 .31872 m
.64335 .31872 L
s
P
p
1 .039 0 r
.01 w
.62862 .30807 m
.64342 .32036 L
s
P
p
.002 w
.72351 .30822 m .73064 .31438 L .71602 .3177 L p
.4 g
F P
s
P
p
.002 w
.69424 .31489 m .72351 .30822 L p
.71602 .3177 L .4 g
F P
s
P
p
.002 w
.57759 .31028 m .54881 .31693 L .53345 .30462 L p
.8 g
F P
s
P
p
.002 w
.50474 .31131 m .53345 .30462 L .54881 .31693 L p
.8 g
F P
s
P
p
.002 w
.72351 .30822 m .69424 .31489 L .67973 .30255 L p
.8 g
F P
s
P
p
.002 w
.65052 .30925 m .67973 .30255 L .69424 .31489 L p
.8 g
F P
s
P
p
.002 w
.74532 .31105 m .73064 .31438 L p
.72351 .30822 L .4 g
F P
s
P
p
1 .158 0 r
.01 w
.5557 .31903 m
.57096 .33128 L
s
P
p
1 .178 0 r
.01 w
.57099 .33294 m
.57099 .33294 L
s
P
p
.002 w
.53345 .30462 m .50474 .31131 L .48907 .29892 L p
.4 g
F P
s
P
p
.002 w
.75297 .30152 m .76004 .30771 L .74532 .31105 L p
.4 g
F P
s
P
p
.002 w
.72351 .30822 m .75297 .30152 L p
.74532 .31105 L .4 g
F P
s
P
p
.002 w
.31458 .30771 m .30057 .31105 L .29216 .30487 L p
.4 g
F P
s
P
p
1 .197 0 r
.01 w
.57101 .3346 m
.57101 .3346 L
s
P
p
.002 w
.53345 .30462 m .56235 .29789 L .57759 .31028 L p
.8 g
F P
s
P
p
1 .217 0 r
.01 w
.57104 .33626 m
.57104 .33626 L
s
P
p
1 .237 0 r
.01 w
.57107 .33792 m
.57107 .33792 L
s
P
p
.002 w
.75297 .30152 m .72351 .30822 L .70912 .29581 L p
.8 g
F P
s
P
p
.002 w
.67973 .30255 m .70912 .29581 L .72351 .30822 L p
.8 g
F P
s
P
p
.002 w
.7748 .30436 m .76004 .30771 L p
.75297 .30152 L .4 g
F P
s
P
p
.002 w
.29216 .30487 m .2837 .29866 L p
.31458 .30771 L .4 g
F P
s
P
p
.002 w
.2837 .29866 m .29777 .29529 L .31458 .30771 L p
.4 g
F P
s
P
p
1 .257 0 r
.01 w
.5558 .32734 m
.5711 .33958 L
s
P
p
.002 w
.48907 .29892 m .51791 .29216 L .53345 .30462 L p
.4 g
F P
s
P
p
.002 w
.78262 .29476 m .78962 .301 L .7748 .30436 L p
.4 g
F P
s
P
p
.002 w
.75297 .30152 m .78262 .29476 L p
.7748 .30436 L .4 g
F P
s
P
p
.002 w
.6357 .29685 m .60655 .30358 L .59144 .29111 L p
.8 g
F P
s
P
p
1 .059 0 r
.01 w
.6137 .29729 m
.62868 .30972 L
s
P
p
1 .118 0 r
.01 w
.55565 .31571 m
.58466 .30901 L
s
P
p
.002 w
.78262 .29476 m .75297 .30152 L .73871 .28902 L p
.8 g
F P
s
P
p
.002 w
.70912 .29581 m .73871 .28902 L .75297 .30152 L p
.8 g
F P
s
P
p
1 .138 0 r
.01 w
.55568 .31737 m
.55568 .31737 L
s
P
p
.002 w
.37108 .29424 m .34274 .301 L .32604 .28849 L p
.8 g
F P
s
P
p
.002 w
.80448 .29763 m .78962 .301 L p
.78262 .29476 L .4 g
F P
s
P
p
.002 w
.51791 .29216 m .48907 .29892 L .47323 .2864 L p
.4 g
F P
s
P
p
.002 w
.29777 .29529 m .2837 .29866 L .27519 .29242 L p
.4 g
F P
s
P
p
.002 w
.81245 .28797 m .81939 .29424 L .80448 .29763 L p
.4 g
F P
s
P
p
.002 w
.78262 .29476 m .81245 .28797 L p
.80448 .29763 L .4 g
F P
s
P
p
.002 w
.66504 .29007 m .6357 .29685 L .62071 .28429 L p
.8 g
F P
s
P
p
.002 w
.59144 .29111 m .62071 .28429 L .6357 .29685 L p
.8 g
F P
s
P
p
1 .099 0 r
.01 w
.58462 .30735 m
.6138 .3006 L
s
P
p
.002 w
.27519 .29242 m .26663 .28613 L p
.29777 .29529 L .4 g
F P
s
P
p
.002 w
.26663 .28613 m .28076 .28271 L .29777 .29529 L p
.4 g
F P
s
P
p
.002 w
.81245 .28797 m .78262 .29476 L .76848 .28219 L p
.8 g
F P
s
P
p
.002 w
.73871 .28902 m .76848 .28219 L .78262 .29476 L p
.8 g
F P
s
P
p
.002 w
.83435 .29085 m .81939 .29424 L p
.81245 .28797 L .4 g
F P
s
P
p
.002 w
.3996 .28745 m .37108 .29424 L .35449 .28166 L p
.8 g
F P
s
P
p
.002 w
.32604 .28849 m .35449 .28166 L .37108 .29424 L p
.8 g
F P
s
P
p
1 .276 0 r
.01 w
.55582 .32901 m
.55582 .32901 L
s
P
p
1 .296 0 r
.01 w
.55584 .33068 m
.58498 .324 L
s
P
p
.002 w
.47323 .2864 m .50219 .27955 L .51791 .29216 L p
.4 g
F P
s
P
p
1 .079 0 r
.01 w
.61375 .29895 m
.61375 .29895 L
s
P
p
.002 w
.84248 .28113 m .84935 .28745 L .83435 .29085 L p
.4 g
F P
s
P
p
.002 w
.81245 .28797 m .84248 .28113 L p
.83435 .29085 L .4 g
F P
s
P
p
.002 w
.69456 .28324 m .66504 .29007 L .65017 .27743 L p
.8 g
F P
s
P
p
.002 w
.62071 .28429 m .65017 .27743 L .66504 .29007 L p
.8 g
F P
s
P
p
.002 w
.76848 .28219 m .79845 .27531 L .81245 .28797 L p
.8 g
F P
s
P
p
.002 w
.8644 .28403 m .84935 .28745 L p
.84248 .28113 L .4 g
F P
s
P
p
.002 w
.35449 .28166 m .38313 .27478 L .3996 .28745 L p
.8 g
F P
s
P
p
.002 w
.50219 .27955 m .47323 .2864 L .45719 .27372 L p
.4 g
F P
s
P
p
.002 w
.28076 .28271 m .26663 .28613 L .25802 .27981 L p
.4 g
F P
s
P
p
1 .316 0 r
.01 w
.58501 .32567 m
.58501 .32567 L
s
P
p
1 .336 0 r
.01 w
.56966 .3149 m
.58505 .32735 L
s
P
p
.002 w
.8727 .27425 m .87951 .2806 L .8644 .28403 L p
.4 g
F P
s
P
p
.002 w
.84248 .28113 m .8727 .27425 L p
.8644 .28403 L .4 g
F P
s
P
p
.002 w
.72427 .27637 m .69456 .28324 L .67982 .27052 L p
.8 g
F P
s
P
p
.002 w
.65017 .27743 m .67982 .27052 L .69456 .28324 L p
.8 g
F P
s
P
p
.002 w
.25802 .27981 m .24936 .27345 L p
.28076 .28271 L .4 g
F P
s
P
p
.002 w
.24936 .27345 m .26354 .26999 L .28076 .28271 L p
.4 g
F P
s
P
p
.002 w
.79845 .27531 m .76848 .28219 L .75418 .26946 L p
.8 g
F P
s
P
p
1 .395 0 r
.01 w
.56975 .31995 m
.58515 .33238 L
s
P
p
.002 w
.89466 .27717 m .87951 .2806 L p
.8727 .27425 L .4 g
F P
s
P
p
1 .414 0 r
.01 w
.58519 .33407 m
.58519 .33407 L
s
P
p
.002 w
.45719 .27372 m .48627 .26679 L .50219 .27955 L p
.4 g
F P
s
P
p
1 .434 0 r
.01 w
.58523 .33575 m
.61465 .32904 L
s
P
p
.002 w
.8727 .27425 m .88789 .27079 L .89466 .27717 L p
.4 g
F P
s
P
p
.002 w
.11294 .17329 m .63932 .03669 L .89466 .27717 L p
.9 g
F P
s
P
p
.002 w
.67982 .27052 m .70967 .26357 L .72427 .27637 L p
.8 g
F P
s
P
p
.002 w
.75418 .26946 m .78428 .2625 L .79845 .27531 L p
.8 g
F P
s
P
p
.002 w
.41195 .26786 m .38313 .27478 L .36647 .26196 L p
.8 g
F P
s
P
p
.002 w
.88789 .27079 m .8727 .27425 L p
.85897 .26143 L .4 g
F P
s
P
p
.002 w
.48627 .26679 m .45719 .27372 L .44096 .26089 L p
.4 g
F P
s
P
p
.002 w
.26354 .26999 m .24936 .27345 L .24065 .26705 L p
.4 g
F P
s
P
p
1 .454 0 r
.01 w
.6147 .33072 m
.64433 .32397 L
s
P
p
.002 w
.88108 .26438 m .88789 .27079 L p
.85897 .26143 L .4 g
F P
s
P
p
.002 w
.70967 .26357 m .67982 .27052 L .66491 .25766 L p
.8 g
F P
s
P
p
1 .355 0 r
.01 w
.56969 .31658 m
.56969 .31658 L
s
P
p
.002 w
.24065 .26705 m .23188 .26062 L p
.26354 .26999 L .4 g
F P
s
P
p
.002 w
.23188 .26062 m .24612 .25712 L .26354 .26999 L p
.4 g
F P
s
P
p
.002 w
.78428 .2625 m .75418 .26946 L .73971 .25658 L p
.8 g
F P
s
P
p
1 .375 0 r
.01 w
.56972 .31826 m
.56972 .31826 L
s
P
p
.002 w
.36647 .26196 m .39541 .25496 L .41195 .26786 L p
.8 g
F P
s
P
p
.002 w
.44096 .26089 m .47016 .25387 L .48627 .26679 L p
.4 g
F P
s
P
p
.002 w
.85897 .26143 m .87423 .25793 L .88108 .26438 L p
.4 g
F P
s
P
p
.002 w
.66491 .25766 m .69489 .25062 L .70967 .26357 L p
.8 g
F P
s
P
p
1 .474 0 r
.01 w
.6444 .32566 m
.6444 .32566 L
s
P
p
.002 w
.73971 .25658 m .76994 .24953 L .78428 .2625 L p
.8 g
F P
s
P
p
.002 w
.39541 .25496 m .36647 .26196 L .3496 .24899 L p
.8 g
F P
s
P
p
1 .493 0 r
.01 w
.62927 .31477 m
.64446 .32735 L
s
P
p
.002 w
.87423 .25793 m .85897 .26143 L p
.84508 .24845 L .4 g
F P
s
P
p
.002 w
.47016 .25387 m .44096 .26089 L .42454 .2479 L p
.4 g
F P
s
P
p
.002 w
.24612 .25712 m .23188 .26062 L .22306 .25414 L p
.4 g
F P
s
P
p
1 .553 0 r
.01 w
.62945 .31987 m
.64466 .33244 L
s
P
p
.002 w
.86733 .25143 m .87423 .25793 L p
.84508 .24845 L .4 g
F P
s
P
p
.002 w
.69489 .25062 m .66491 .25766 L .64982 .24463 L p
.8 g
F P
s
P
p
1 .572 0 r
.01 w
.64472 .33414 m
.64472 .33414 L
s
P
p
.002 w
.22306 .25414 m .21419 .24763 L p
.24612 .25712 L .4 g
F P
s
P
p
.002 w
.21419 .24763 m .22849 .24409 L .24612 .25712 L p
.4 g
F P
s
P
p
.002 w
.76994 .24953 m .73971 .25658 L .72506 .24354 L p
.8 g
F P
s
P
p
1 .592 0 r
.01 w
.64479 .33584 m
.67472 .32906 L
s
P
p
.002 w
.3496 .24899 m .37866 .2419 L .39541 .25496 L p
.8 g
F P
s
P
p
.002 w
.42454 .2479 m .45386 .2408 L .47016 .25387 L p
.4 g
F P
s
P
p
.002 w
.64982 .24463 m .6199 .25171 L .60449 .23861 L p
.4 g
F P
s
P
p
.002 w
.84508 .24845 m .8604 .2449 L .86733 .25143 L p
.4 g
F P
s
P
p
.002 w
.64982 .24463 m .67992 .23751 L .69489 .25062 L p
.8 g
F P
s
P
p
.002 w
.80038 .24245 m .76994 .24953 L .75543 .23641 L p
.8 g
F P
s
P
p
.002 w
.72506 .24354 m .75543 .23641 L .76994 .24953 L p
.8 g
F P
s
P
p
.002 w
.8604 .2449 m .84508 .24845 L p
.83101 .23531 L .4 g
F P
s
P
p
1 .612 0 r
.01 w
.6748 .33076 m
.70494 .32394 L
s
P
p
.002 w
.45386 .2408 m .42454 .2479 L .40792 .23476 L p
.4 g
F P
s
P
p
.002 w
.22849 .24409 m .21419 .24763 L .20527 .24108 L p
.4 g
F P
s
P
p
1 .513 0 r
.01 w
.62933 .31647 m
.62933 .31647 L
s
P
p
1 .533 0 r
.01 w
.62939 .31817 m
.62939 .31817 L
s
P
p
.002 w
.60449 .23861 m .57465 .24572 L .55892 .23255 L p
.8 g
F P
s
P
p
.002 w
.85343 .23833 m .8604 .2449 L p
.83101 .23531 L .4 g
F P
s
P
p
.002 w
.60449 .23861 m .63454 .23145 L .64982 .24463 L p
.4 g
F P
s
P
p
.002 w
.67992 .23751 m .64982 .24463 L .63454 .23145 L p
.8 g
F P
s
P
p
.002 w
.20527 .24108 m .19629 .23448 L p
.22849 .24409 L .4 g
F P
s
P
p
.002 w
.19629 .23448 m .21064 .2309 L .22849 .24409 L p
.4 g
F P
s
P
p
.002 w
.83101 .23531 m .80038 .24245 L .786 .22924 L p
.8 g
F P
s
P
p
.002 w
.75543 .23641 m .786 .22924 L .80038 .24245 L p
.8 g
F P
s
P
p
.002 w
.48338 .23366 m .45386 .2408 L .43736 .22757 L p
.4 g
F P
s
P
p
.002 w
.40792 .23476 m .43736 .22757 L .45386 .2408 L p
.4 g
F P
s
P
p
1 .632 0 r
.01 w
.70504 .32565 m
.70504 .32565 L
s
P
p
1 .651 0 r
.01 w
.69016 .31465 m
.70514 .32736 L
s
P
p
.002 w
.63454 .23145 m .60449 .23861 L .5889 .22535 L p
.4 g
F P
s
P
p
.002 w
.55892 .23255 m .5889 .22535 L .60449 .23861 L p
.8 g
F P
s
P
p
.002 w
.83101 .23531 m .84641 .23173 L .85343 .23833 L p
.4 g
F P
s
P
p
.002 w
.71023 .23034 m .67992 .23751 L .66478 .22424 L p
.8 g
F P
s
P
p
.002 w
.63454 .23145 m .66478 .22424 L .67992 .23751 L p
.8 g
F P
s
P
p
.002 w
.84641 .23173 m .83101 .23531 L p
.81678 .22201 L .4 g
F P
s
P
p
.002 w
.786 .22924 m .81678 .22201 L .83101 .23531 L p
.8 g
F P
s
P
p
.002 w
.43736 .22757 m .40792 .23476 L .39109 .22146 L p
.4 g
F P
s
P
p
.002 w
.21064 .2309 m .19629 .23448 L .18725 .22785 L p
.4 g
F P
s
P
p
.002 w
.43736 .22757 m .46701 .22034 L .48338 .23366 L p
.4 g
F P
s
P
p
.002 w
.83935 .22507 m .84641 .23173 L p
.81678 .22201 L .4 g
F P
s
P
p
.002 w
.5889 .22535 m .61907 .2181 L .63454 .23145 L p
.4 g
F P
s
P
p
.002 w
.18725 .22785 m .17816 .22118 L p
.21064 .2309 L .4 g
F P
s
P
p
.002 w
.17816 .22118 m .19257 .21754 L .21064 .2309 L p
.4 g
F P
s
P
p
.002 w
.74074 .22313 m .71023 .23034 L .69522 .21698 L p
.8 g
F P
s
P
p
.002 w
.66478 .22424 m .69522 .21698 L .71023 .23034 L p
.8 g
F P
s
P
p
.002 w
.81678 .22201 m .786 .22924 L .77145 .21586 L p
.8 g
F P
s
P
p
.002 w
.46701 .22034 m .43736 .22757 L .42066 .21418 L p
.4 g
F P
s
P
p
.002 w
.39109 .22146 m .42066 .21418 L .43736 .22757 L p
.4 g
F P
s
P
p
.002 w
.61907 .2181 m .5889 .22535 L .57311 .21193 L p
.4 g
F P
s
P
p
.002 w
.81678 .22201 m .83224 .21838 L .83935 .22507 L p
.4 g
F P
s
P
p
1 .671 0 r
.01 w
.67507 .3035 m
.69025 .31636 L
s
P
p
.002 w
.77145 .21586 m .74074 .22313 L .72587 .20968 L p
.8 g
F P
s
P
p
.002 w
.69522 .21698 m .72587 .20968 L .74074 .22313 L p
.8 g
F P
s
P
p
.002 w
.34455 .2153 m .31525 .22257 L .29776 .20912 L p
.8 g
F P
s
P
p
.002 w
.83224 .21838 m .81678 .22201 L p
.80237 .20855 L .4 g
F P
s
P
p
.002 w
.77145 .21586 m .80237 .20855 L .81678 .22201 L p
.8 g
F P
s
P
p
.002 w
.19257 .21754 m .17816 .22118 L .16902 .21446 L p
.4 g
F P
s
P
p
.002 w
.42066 .21418 m .45043 .20686 L .46701 .22034 L p
.4 g
F P
s
P
p
.002 w
.82509 .21165 m .83224 .21838 L p
.80237 .20855 L .4 g
F P
s
P
p
.002 w
.57311 .21193 m .60342 .2046 L .61907 .2181 L p
.4 g
F P
s
P
p
.002 w
.16902 .21446 m .15982 .20771 L p
.19257 .21754 L .4 g
F P
s
P
p
.002 w
.15982 .20771 m .17428 .20403 L .19257 .21754 L p
.4 g
F P
s
P
p
1 .711 0 r
.01 w
.64475 .31393 m
.67524 .30694 L
s
P
p
.002 w
.80237 .20855 m .77145 .21586 L .75672 .20233 L p
.8 g
F P
s
P
p
.002 w
.72587 .20968 m .75672 .20233 L .77145 .21586 L p
.8 g
F P
s
P
p
.002 w
.29776 .20912 m .32718 .20176 L .34455 .2153 L p
.8 g
F P
s
P
p
1 .73 0 r
.01 w
.64482 .31565 m
.64482 .31565 L
s
P
p
1 .849 0 r
.01 w
.67582 .31906 m
.69106 .33189 L
s
P
p
1 .75 0 r
.01 w
.64489 .31738 m
.64489 .31738 L
s
P
p
1 .868 0 r
.01 w
.69115 .33363 m
.69115 .33363 L
s
P
p
.002 w
.52688 .20573 m .49685 .21306 L .4804 .19949 L p
.8 g
F P
s
P
p
1 .77 0 r
.01 w
.64495 .3191 m
.64495 .3191 L
s
P
p
1 .888 0 r
.01 w
.69124 .33536 m
.72194 .32844 L
s
P
p
.002 w
.60342 .2046 m .57311 .21193 L .55712 .19835 L p
.4 g
F P
s
P
p
1 .789 0 r
.01 w
.64502 .32083 m
.64502 .32083 L
s
P
p
.002 w
.80237 .20855 m .8179 .20488 L .82509 .21165 L p
.4 g
F P
s
P
p
1 .809 0 r
.01 w
.64509 .32256 m
.67566 .31559 L
s
P
p
1 .691 0 r
.01 w
.67516 .30522 m
.67516 .30522 L
s
P
p
.002 w
.32718 .20176 m .29776 .20912 L .28005 .1955 L p
.8 g
F P
s
P
p
0 1 .704 r
.01 w
.40663 .57879 m
.42357 .59006 L
s
P
p
.002 w
.8179 .20488 m .80237 .20855 L p
.78778 .19493 L .4 g
F P
s
P
p
.002 w
.75672 .20233 m .78778 .19493 L .80237 .20855 L p
.8 g
F P
s
P
p
.002 w
.40375 .20062 m .37405 .20799 L .35681 .19435 L p
.4 g
F P
s
P
p
0 1 .724 r
.01 w
.42352 .59193 m
.42352 .59193 L
s
P
p
.002 w
.17428 .20403 m .15982 .20771 L .15056 .20091 L p
.4 g
F P
s
P
p
0 1 .743 r
.01 w
.42347 .5938 m
.42347 .5938 L
s
P
p
0 1 .092 r
.01 w
.68102 .49432 m
.65037 .50071 L
s
P
p
.002 w
.4804 .19949 m .51057 .19206 L .52688 .20573 L p
.8 g
F P
s
P
p
0 1 .763 r
.01 w
.42343 .59568 m
.40647 .58443 L
s
P
p
0 1 .112 r
.01 w
.65044 .50254 m
.65044 .50254 L
s
P
p
.002 w
.81067 .19806 m .8179 .20488 L p
.78778 .19493 L .4 g
F P
s
P
p
.002 w
.63393 .19721 m .60342 .2046 L .58757 .19092 L p
.4 g
F P
s
P
p
.002 w
.55712 .19835 m .58757 .19092 L .60342 .2046 L p
.4 g
F P
s
P
p
.002 w
.15056 .20091 m .14124 .19407 L p
.17428 .20403 L .4 g
F P
s
P
p
.002 w
.14124 .19407 m .15577 .19035 L .17428 .20403 L p
.4 g
F P
s
P
p
0 1 .132 r
.01 w
.65052 .50437 m
.65052 .50437 L
s
P
p
1 .908 0 r
.01 w
.72205 .33018 m
.75297 .32321 L
s
P
p
0 1 .546 r
.01 w
.46699 .55144 m
.48359 .5629 L
s
P
p
0 1 .151 r
.01 w
.65059 .5062 m
.68128 .49982 L
s
P
p
0 1 .566 r
.01 w
.48358 .56476 m
.48358 .56476 L
s
P
p
0 1 .033 r
.01 w
.71157 .4824 m
.68076 .48884 L
s
P
p
1 .829 0 r
.01 w
.67574 .31733 m
.67574 .31733 L
s
P
p
.002 w
.28005 .1955 m .3096 .18805 L .32718 .20176 L p
.8 g
F P
s
P
p
0 1 .586 r
.01 w
.48356 .56662 m
.48356 .56662 L
s
P
p
0 1 .053 r
.01 w
.68085 .49067 m
.68085 .49067 L
s
P
p
.002 w
.43365 .19321 m .40375 .20062 L .38663 .1869 L p
.4 g
F P
s
P
p
.002 w
.35681 .19435 m .38663 .1869 L .40375 .20062 L p
.4 g
F P
s
P
p
0 1 .605 r
.01 w
.48355 .56849 m
.46692 .55704 L
s
P
p
0 1 .072 r
.01 w
.68094 .49249 m
.68094 .49249 L
s
P
p
.002 w
.78778 .19493 m .80338 .19121 L .81067 .19806 L p
.4 g
F P
s
P
p
0 1 .664 r
.01 w
.43669 .56888 m
.40674 .57504 L
s
P
p
.002 w
.66465 .18977 m .63393 .19721 L .61822 .18344 L p
.4 g
F P
s
P
p
.002 w
.58757 .19092 m .61822 .18344 L .63393 .19721 L p
.4 g
F P
s
P
p
0 1 .803 r
.01 w
.40636 .5882 m
.3765 .5943 L
s
P
p
0 1 .684 r
.01 w
.40669 .57692 m
.40669 .57692 L
s
P
p
0 1 .822 r
.01 w
.37643 .59618 m
.37643 .59618 L
s
P
p
0 1 .013 r
.01 w
.74247 .47408 m
.71147 .48057 L
s
P
p
1 .928 0 r
.01 w
.7531 .32495 m
.7531 .32495 L
s
P
p
.002 w
.80338 .19121 m .78778 .19493 L p
.77301 .18113 L .4 g
F P
s
P
p
0 1 .842 r
.01 w
.37636 .59807 m
.37636 .59807 L
s
P
p
.002 w
.38663 .1869 m .35681 .19435 L .33935 .18055 L p
.4 g
F P
s
P
p
0 1 .171 r
.01 w
.68137 .50166 m
.68137 .50166 L
s
P
p
1 .947 0 r
.01 w
.73823 .31372 m
.75322 .3267 L
s
P
p
.002 w
.15577 .19035 m .14124 .19407 L .13187 .18719 L p
.4 g
F P
s
P
p
0 1 .862 r
.01 w
.37629 .59995 m
.37629 .59995 L
s
P
p
.002 w
.38663 .1869 m .41666 .17939 L .43365 .19321 L p
.4 g
F P
s
P
p
0 1 .191 r
.01 w
.68146 .50349 m
.66601 .49161 L
s
P
p
0 1 .882 r
.01 w
.37622 .60184 m
.35887 .59057 L
s
P
p
0 1 .507 r
.01 w
.49727 .54143 m
.46704 .54771 L
s
P
p
.046 1 0 r
.01 w
.77327 .46207 m
.74211 .46861 L
s
P
p
0 1 .645 r
.01 w
.46687 .56079 m
.43673 .567 L
s
P
p
.002 w
.79606 .1843 m .80338 .19121 L p
.77301 .18113 L .4 g
F P
s
P
p
0 1 .783 r
.01 w
.40641 .58631 m
.40641 .58631 L
s
P
p
0 1 .526 r
.01 w
.46701 .54957 m
.46701 .54957 L
s
P
p
.026 1 0 r
.01 w
.74223 .47043 m
.74223 .47043 L
s
P
p
.002 w
.13187 .18719 m .12243 .18026 L p
.15577 .19035 L .4 g
F P
s
P
p
.002 w
.12243 .18026 m .13702 .17649 L .15577 .19035 L p
.4 g
F P
s
P
p
.002 w
.69557 .18228 m .66465 .18977 L .64907 .17591 L p
.4 g
F P
s
P
p
.002 w
.61822 .18344 m .64907 .17591 L .66465 .18977 L p
.4 g
F P
s
P
p
.007 1 0 r
.01 w
.74235 .47226 m
.74235 .47226 L
s
P
p
0 1 .309 r
.01 w
.5888 .5037 m
.60476 .51554 L
s
P
p
.002 w
.41666 .17939 m .38663 .1869 L .3693 .173 L p
.4 g
F P
s
P
p
.002 w
.33935 .18055 m .3693 .173 L .38663 .1869 L p
.4 g
F P
s
P
p
0 1 .329 r
.01 w
.60481 .51739 m
.60481 .51739 L
s
P
p
0 1 .487 r
.01 w
.52769 .53325 m
.49727 .53957 L
s
P
p
.066 1 0 r
.01 w
.80449 .45366 m
.77313 .46025 L
s
P
p
0 1 .625 r
.01 w
.46689 .55892 m
.46689 .55892 L
s
P
p
0 1 .349 r
.01 w
.60486 .51925 m
.60486 .51925 L
s
P
p
.002 w
.57152 .17707 m .54094 .18459 L .52456 .17067 L p
.8 g
F P
s
P
p
.002 w
.77301 .18113 m .78869 .17736 L .79606 .1843 L p
.4 g
F P
s
P
p
0 1 .368 r
.01 w
.60491 .5211 m
.58891 .50928 L
s
P
p
.145 1 0 r
.01 w
.78913 .43407 m
.80388 .44637 L
s
P
p
.002 w
.64907 .17591 m .68014 .16833 L .69557 .18228 L p
.4 g
F P
s
P
p
0 1 .428 r
.01 w
.55825 .52128 m
.52767 .52765 L
s
P
p
.125 1 0 r
.01 w
.80403 .44819 m
.80403 .44819 L
s
P
p
.002 w
.78869 .17736 m .77301 .18113 L p
.75805 .16716 L .4 g
F P
s
P
p
0 1 .447 r
.01 w
.52768 .52952 m
.52768 .52952 L
s
P
p
.105 1 0 r
.01 w
.80418 .45001 m
.80418 .45001 L
s
P
p
.002 w
.13702 .17649 m .12243 .18026 L .11294 .17329 L p
.4 g
F P
s
P
p
.002 w
.44689 .17183 m .41666 .17939 L .39945 .1654 L p
.4 g
F P
s
P
p
.002 w
.3693 .173 m .39945 .1654 L .41666 .17939 L p
.4 g
F P
s
P
p
0 1 .467 r
.01 w
.52769 .53138 m
.52769 .53138 L
s
P
p
.086 1 0 r
.01 w
.80433 .45183 m
.80433 .45183 L
s
P
p
1 .967 0 r
.01 w
.72316 .30233 m
.73834 .31547 L
s
P
p
0 1 .211 r
.01 w
.66609 .49345 m
.65044 .48142 L
s
P
p
0 1 .901 r
.01 w
.35878 .59247 m
.35878 .59247 L
s
P
p
.002 w
.78127 .17037 m .78869 .17736 L p
.75805 .16716 L .4 g
F P
s
P
p
.002 w
.52456 .17067 m .55527 .16305 L .57152 .17707 L p
.8 g
F P
s
P
p
.283 1 0 r
.01 w
.77323 .40887 m
.78812 .42136 L
s
P
p
.974 1 0 r
.01 w
.66109 .32182 m
.69218 .31474 L
s
P
p
.002 w
.12756 .1695 m .14222 .16569 L p
.13702 .17649 L .4 g
F P
s
P
p
.002 w
.16634 .16891 m .13702 .17649 L p
.14222 .16569 L .4 g
F P
s
P
p
.002 w
.11294 .17329 m .12756 .1695 L .13702 .17649 L p
.4 g
F P
s
P
p
0 1 .921 r
.01 w
.3587 .59437 m
.38878 .5882 L
s
P
p
.002 w
.68014 .16833 m .64907 .17591 L .6333 .16187 L p
.4 g
F P
s
P
p
0 1 .27 r
.01 w
.61958 .49351 m
.58872 .49999 L
s
P
p
.263 1 0 r
.01 w
.78827 .42317 m
.78827 .42317 L
s
P
p
.954 1 0 r
.01 w
.66116 .32358 m
.66116 .32358 L
s
P
p
0 1 .408 r
.01 w
.58899 .513 m
.55822 .51942 L
s
P
p
0 1 .289 r
.01 w
.58876 .50185 m
.58876 .50185 L
s
P
p
.243 1 0 r
.01 w
.78841 .42498 m
.81997 .41824 L
s
P
p
.934 1 0 r
.01 w
.66124 .32534 m
.66124 .32534 L
s
P
p
.002 w
.32167 .16657 m .29179 .17416 L .27376 .16011 L p
.8 g
F P
s
P
p
.914 1 0 r
.01 w
.66132 .3271 m
.66132 .3271 L
s
P
p
.895 1 0 r
.01 w
.6614 .32887 m
.64568 .31577 L
s
P
p
.002 w
.47732 .16423 m .44689 .17183 L .42982 .15775 L p
.4 g
F P
s
P
p
.002 w
.39945 .1654 m .42982 .15775 L .44689 .17183 L p
.4 g
F P
s
P
p
.184 1 0 r
.01 w
.82045 .4237 m
.78884 .43043 L
s
P
p
.993 1 0 r
.01 w
.72338 .30585 m
.69209 .31298 L
s
P
p
.002 w
.75805 .16716 m .7738 .16334 L .78127 .17037 L p
.4 g
F P
s
P
p
.164 1 0 r
.01 w
.78898 .43225 m
.78898 .43225 L
s
P
p
0 1 .25 r
.01 w
.65058 .48513 m
.61953 .49166 L
s
P
p
.002 w
.15694 .16187 m .1717 .15804 L p
.16634 .16891 L .4 g
F P
s
P
p
.002 w
.19586 .16129 m .16634 .16891 L p
.1717 .15804 L .4 g
F P
s
P
p
.002 w
.14222 .16569 m .15694 .16187 L .16634 .16891 L p
.4 g
F P
s
P
p
0 1 .388 r
.01 w
.58895 .51114 m
.58895 .51114 L
s
P
p
.836 1 0 r
.01 w
.64589 .32109 m
.66163 .33417 L
s
P
p
.002 w
.6333 .16187 m .66451 .1542 L .68014 .16833 L p
.4 g
F P
s
P
p
0 1 .941 r
.01 w
.38872 .59011 m
.38872 .59011 L
s
P
p
.816 1 0 r
.01 w
.66171 .33594 m
.66171 .33594 L
s
P
p
.002 w
.7738 .16334 m .75805 .16716 L p
.7429 .15301 L .4 g
F P
s
P
p
.002 w
.35175 .15893 m .32167 .16657 L .30377 .15242 L p
.8 g
F P
s
P
p
.002 w
.27376 .16011 m .30377 .15242 L .32167 .16657 L p
.8 g
F P
s
P
p
0 1 .961 r
.01 w
.38865 .59202 m
.37117 .58054 L
s
P
p
.796 1 0 r
.01 w
.66178 .33772 m
.69303 .33065 L
s
P
p
.224 1 0 r
.01 w
.82013 .42006 m
.82013 .42006 L
s
P
p
.204 1 0 r
.01 w
.82029 .42188 m
.82029 .42188 L
s
P
p
.002 w
.50796 .15656 m .47732 .16423 L .46038 .15004 L p
.4 g
F P
s
P
p
.002 w
.42982 .15775 m .46038 .15004 L .47732 .16423 L p
.4 g
F P
s
P
p
.303 1 0 r
.01 w
.75802 .3944 m
.7731 .40706 L
s
P
p
1 .987 0 r
.01 w
.72327 .30409 m
.72327 .30409 L
s
P
p
.002 w
.76629 .15627 m .7738 .16334 L p
.7429 .15301 L .4 g
F P
s
P
p
0 1 .23 r
.01 w
.65051 .48328 m
.65051 .48328 L
s
P
p
.002 w
.66451 .1542 m .6333 .16187 L .61733 .14766 L p
.4 g
F P
s
P
p
.002 w
.18652 .1542 m .20138 .15034 L p
.19586 .16129 L .4 g
F P
s
P
p
.002 w
.22558 .1536 m .19586 .16129 L p
.20138 .15034 L .4 g
F P
s
P
p
.002 w
.1717 .15804 m .18652 .1542 L .19586 .16129 L p
.4 g
F P
s
P
p
.002 w
.30377 .15242 m .33398 .14468 L .35175 .15893 L p
.8 g
F P
s
P
p
.461 1 0 r
.01 w
.82055 .366 m
.83527 .37886 L
s
P
p
.776 1 0 r
.01 w
.69312 .33243 m
.72459 .32532 L
s
P
p
.441 1 0 r
.01 w
.83543 .38066 m
.83543 .38066 L
s
P
p
.875 1 0 r
.01 w
.64575 .31754 m
.64575 .31754 L
s
P
p
.002 w
.46038 .15004 m .49116 .14228 L .50796 .15656 L p
.4 g
F P
s
P
p
.002 w
.7429 .15301 m .75873 .14915 L .76629 .15627 L p
.4 g
F P
s
P
p
.421 1 0 r
.01 w
.8356 .38247 m
.8356 .38247 L
s
P
p
.855 1 0 r
.01 w
.64582 .31931 m
.64582 .31931 L
s
P
p
.401 1 0 r
.01 w
.83577 .38428 m
.82103 .37143 L
s
P
p
.002 w
.61733 .14766 m .64868 .13989 L .66451 .1542 L p
.4 g
F P
s
P
p
.002 w
.2163 .14647 m .23127 .14258 L p
.22558 .1536 L .4 g
F P
s
P
p
.002 w
.25551 .14587 m .22558 .1536 L p
.23127 .14258 L .4 g
F P
s
P
p
.002 w
.20138 .15034 m .2163 .14647 L .22558 .1536 L p
.4 g
F P
s
P
p
.002 w
.75873 .14915 m .7429 .15301 L p
.72757 .13869 L .4 g
F P
s
P
p
.342 1 0 r
.01 w
.78954 .38385 m
.75777 .39077 L
s
P
p
.002 w
.41253 .14348 m .38203 .15123 L .36439 .13688 L p
.8 g
F P
s
P
p
0 1 .98 r
.01 w
.37109 .58246 m
.35338 .57085 L
s
P
p
.322 1 0 r
.01 w
.75789 .39259 m
.75789 .39259 L
s
P
p
.002 w
.49116 .14228 m .46038 .15004 L .44323 .13568 L p
.4 g
F P
s
P
p
.002 w
.75112 .14198 m .75873 .14915 L p
.72757 .13869 L .4 g
F P
s
P
p
.002 w
.56988 .14109 m .53882 .14885 L .52215 .13447 L p
.8 g
F P
s
P
p
.757 1 0 r
.01 w
.72471 .32711 m
.72471 .32711 L
s
P
p
.002 w
.64868 .13989 m .61733 .14766 L .60116 .13327 L p
.4 g
F P
s
P
p
.52 1 0 r
.01 w
.80518 .34754 m
.82006 .36058 L
s
P
p
.737 1 0 r
.01 w
.72482 .32889 m
.70933 .31565 L
s
P
p
.5 1 0 r
.01 w
.82022 .36239 m
.82022 .36239 L
s
P
p
.002 w
.24629 .13869 m .26136 .13477 L p
.25551 .14587 L .4 g
F P
s
P
p
.002 w
.28564 .13808 m .25551 .14587 L p
.26136 .13477 L .4 g
F P
s
P
p
.002 w
.23127 .14258 m .24629 .13869 L .25551 .14587 L p
.4 g
F P
s
P
p
.362 1 0 r
.01 w
.82136 .37506 m
.78939 .38203 L
s
P
p
.48 1 0 r
.01 w
.82039 .36419 m
.82039 .36419 L
s
P
p
.678 1 0 r
.01 w
.70964 .32102 m
.72515 .33425 L
s
P
p
.002 w
.44323 .13568 m .41253 .14348 L .39502 .12903 L p
.8 g
F P
s
P
p
.002 w
.36439 .13688 m .39502 .12903 L .41253 .14348 L p
.8 g
F P
s
P
p
.658 1 0 r
.01 w
.72526 .33604 m
.72526 .33604 L
s
P
p
.002 w
.44323 .13568 m .47415 .12782 L .49116 .14228 L p
.4 g
F P
s
P
p
0 .98 1 r
.01 w
.35321 .5747 m
.3228 .581 L
s
P
p
.002 w
.72757 .13869 m .74347 .13477 L .75112 .14198 L p
.4 g
F P
s
P
p
.638 1 0 r
.01 w
.72538 .33784 m
.75719 .3307 L
s
P
p
.002 w
.52215 .13447 m .55336 .12661 L .56988 .14109 L p
.8 g
F P
s
P
p
0 .961 1 r
.01 w
.3227 .58292 m
.3227 .58292 L
s
P
p
.002 w
.60116 .13327 m .63265 .12539 L .64868 .13989 L p
.4 g
F P
s
P
p
0 .941 1 r
.01 w
.32259 .58484 m
.32259 .58484 L
s
P
p
.382 1 0 r
.01 w
.8212 .37324 m
.8212 .37324 L
s
P
p
.002 w
.74347 .13477 m .72757 .13869 L p
.71203 .12418 L .4 g
F P
s
P
p
0 .921 1 r
.01 w
.32249 .58677 m
.32249 .58677 L
s
P
p
.002 w
.27648 .13085 m .29166 .12691 L p
.28564 .13808 L .4 g
F P
s
P
p
.002 w
.31598 .13024 m .28564 .13808 L p
.29166 .12691 L .4 g
F P
s
P
p
.002 w
.26136 .13477 m .27648 .13085 L .28564 .13808 L p
.4 g
F P
s
P
p
0 .901 1 r
.01 w
.32239 .5887 m
.30426 .57706 L
s
P
p
.002 w
.39502 .12903 m .42586 .12113 L .44323 .13568 L p
.8 g
F P
s
P
p
0 1 1 r
.01 w
.3533 .57277 m
.3533 .57277 L
s
P
p
.002 w
.73576 .12752 m .74347 .13477 L p
.71203 .12418 L .4 g
F P
s
P
p
.002 w
.55336 .12661 m .52215 .13447 L .50528 .11991 L p
.8 g
F P
s
P
p
.539 1 0 r
.01 w
.78995 .33253 m
.80502 .34574 L
s
P
p
.002 w
.63265 .12539 m .60116 .13327 L .58478 .11869 L p
.4 g
F P
s
P
p
.618 1 0 r
.01 w
.75732 .33249 m
.78936 .32531 L
s
P
p
.717 1 0 r
.01 w
.70943 .31744 m
.70943 .31744 L
s
P
p
.697 1 0 r
.01 w
.70953 .31923 m
.70953 .31923 L
s
P
p
.002 w
.30689 .12296 m .32217 .11899 L p
.31598 .13024 L .4 g
F P
s
P
p
.002 w
.34652 .12235 m .31598 .13024 L p
.32217 .11899 L .4 g
F P
s
P
p
.002 w
.29166 .12691 m .30689 .12296 L .31598 .13024 L p
.4 g
F P
s
P
p
.002 w
.71203 .12418 m .72801 .12022 L .73576 .12752 L p
.4 g
F P
s
P
p
.002 w
.50528 .11991 m .53662 .11194 L .55336 .12661 L p
.8 g
F P
s
P
p
.002 w
.58478 .11869 m .61642 .11071 L .63265 .12539 L p
.4 g
F P
s
P
p
.002 w
.72801 .12022 m .71203 .12418 L p
.6963 .10948 L .4 g
F P
s
P
p
.599 1 0 r
.01 w
.78951 .32711 m
.78951 .32711 L
s
P
p
.002 w
.3375 .11501 m .35289 .11102 L p
.34652 .12235 L .4 g
F P
s
P
p
.002 w
.37729 .1144 m .34652 .12235 L p
.35289 .11102 L .4 g
F P
s
P
p
.002 w
.32217 .11899 m .3375 .11501 L .34652 .12235 L p
.4 g
F P
s
P
p
.579 1 0 r
.01 w
.78966 .32891 m
.78966 .32891 L
s
P
p
0 .882 1 r
.01 w
.30415 .579 m
.30415 .579 L
s
P
p
.002 w
.45691 .11317 m .42586 .12113 L .40826 .1064 L p
.4 g
F P
s
P
p
.559 1 0 r
.01 w
.78981 .33072 m
.78981 .33072 L
s
P
p
0 .862 1 r
.01 w
.30404 .58094 m
.33468 .57457 L
s
P
p
.002 w
.72021 .11287 m .72801 .12022 L p
.6963 .10948 L .4 g
F P
s
P
p
.002 w
.53662 .11194 m .50528 .11991 L .48818 .10516 L p
.8 g
F P
s
P
p
.002 w
.61642 .11071 m .58478 .11869 L .56819 .10392 L p
.4 g
F P
s
P
p
.002 w
.36833 .10701 m .38383 .10299 L p
.37729 .1144 L .4 g
F P
s
P
p
.002 w
.40826 .1064 m .37729 .1144 L p
.38383 .10299 L .4 g
F P
s
P
p
.002 w
.35289 .11102 m .36833 .10701 L .37729 .1144 L p
.4 g
F P
s
P
p
.002 w
.40826 .1064 m .43945 .09833 L .45691 .11317 L p
.4 g
F P
s
P
p
.002 w
.6963 .10948 m .71235 .10547 L .72021 .11287 L p
.4 g
F P
s
P
p
.002 w
.48818 .10516 m .51967 .09709 L .53662 .11194 L p
.8 g
F P
s
P
p
0 .842 1 r
.01 w
.33458 .57652 m
.33458 .57652 L
s
P
p
.002 w
.64828 .10268 m .61642 .11071 L .59997 .09584 L p
.4 g
F P
s
P
p
.002 w
.56819 .10392 m .59997 .09584 L .61642 .11071 L p
.4 g
F P
s
P
p
0 .822 1 r
.01 w
.33449 .57847 m
.31621 .56662 L
s
P
p
.002 w
.71235 .10547 m .6963 .10948 L p
.68036 .0946 L .4 g
F P
s
P
p
.002 w
.39938 .09896 m .41498 .09491 L p
.40826 .1064 L .4 g
F P
s
P
p
.002 w
.43945 .09833 m .40826 .1064 L p
.41498 .09491 L .4 g
F P
s
P
p
.002 w
.38383 .10299 m .39938 .09896 L .40826 .1064 L p
.4 g
F P
s
P
p
0 .763 1 r
.01 w
.31589 .57249 m
.3342 .58432 L
s
P
p
.002 w
.70445 .09802 m .71235 .10547 L p
.68036 .0946 L .4 g
F P
s
P
p
0 .743 1 r
.01 w
.3341 .58628 m
.3341 .58628 L
s
P
p
0 .724 1 r
.01 w
.33401 .58823 m
.36498 .58185 L
s
P
p
.002 w
.68036 .0946 m .64828 .10268 L .63198 .08771 L p
.4 g
F P
s
P
p
.002 w
.59997 .09584 m .63198 .08771 L .64828 .10268 L p
.4 g
F P
s
P
p
.002 w
.43064 .09084 m .44635 .08677 L p
.43945 .09833 L .4 g
F P
s
P
p
.002 w
.47087 .09022 m .43945 .09833 L p
.44635 .08677 L .4 g
F P
s
P
p
.002 w
.41498 .09491 m .43064 .09084 L .43945 .09833 L p
.4 g
F P
s
P
p
.002 w
.68036 .0946 m .69649 .09053 L .70445 .09802 L p
.4 g
F P
s
P
p
.002 w
.69649 .09053 m .68036 .0946 L p
.66422 .07952 L .4 g
F P
s
P
p
.002 w
.63198 .08771 m .66422 .07952 L .68036 .0946 L p
.4 g
F P
s
P
p
0 .704 1 r
.01 w
.3649 .58381 m
.3961 .57739 L
s
P
p
0 .803 1 r
.01 w
.31611 .56857 m
.31611 .56857 L
s
P
p
0 .783 1 r
.01 w
.316 .57053 m
.316 .57053 L
s
P
p
.002 w
.68848 .08299 m .69649 .09053 L p
.66422 .07952 L .4 g
F P
s
P
p
.002 w
.46212 .08267 m .47795 .07857 L p
.47087 .09022 L .4 g
F P
s
P
p
.002 w
.5025 .08204 m .47087 .09022 L p
.47795 .07857 L .4 g
F P
s
P
p
.002 w
.44635 .08677 m .46212 .08267 L .47087 .09022 L p
.4 g
F P
s
P
p
0 .684 1 r
.01 w
.39604 .57936 m
.39604 .57936 L
s
P
p
0 .664 1 r
.01 w
.39598 .58133 m
.37789 .56936 L
s
P
p
.002 w
.66422 .07952 m .68042 .0754 L .68848 .08299 L p
.4 g
F P
s
P
p
.002 w
.49383 .07445 m .50976 .07031 L p
.5025 .08204 L .4 g
F P
s
P
p
.002 w
.53435 .07381 m .5025 .08204 L p
.50976 .07031 L .4 g
F P
s
P
p
.002 w
.47795 .07857 m .49383 .07445 L .5025 .08204 L p
.4 g
F P
s
P
p
.002 w
.68042 .0754 m .66422 .07952 L p
.64786 .06424 L .4 g
F P
s
P
p
.002 w
.67231 .06776 m .68042 .0754 L p
.64786 .06424 L .4 g
F P
s
P
p
.002 w
.52576 .06616 m .54181 .06199 L p
.53435 .07381 L .4 g
F P
s
P
p
.002 w
.56644 .06552 m .53435 .07381 L p
.54181 .06199 L .4 g
F P
s
P
p
.002 w
.50976 .07031 m .52576 .06616 L .53435 .07381 L p
.4 g
F P
s
P
p
.002 w
.64786 .06424 m .66414 .06007 L .67231 .06776 L p
.4 g
F P
s
P
p
0 .645 1 r
.01 w
.37782 .57134 m
.35949 .55923 L
s
P
p
.002 w
.55792 .05781 m .57408 .05362 L p
.56644 .06552 L .4 g
F P
s
P
p
.002 w
.59875 .05717 m .56644 .06552 L p
.57408 .05362 L .4 g
F P
s
P
p
.002 w
.54181 .06199 m .55792 .05781 L .56644 .06552 L p
.4 g
F P
s
P
p
.002 w
.66414 .06007 m .64786 .06424 L p
.63129 .04876 L .4 g
F P
s
P
p
.002 w
.65592 .05232 m .66414 .06007 L p
.63129 .04876 L .4 g
F P
s
P
p
0 .605 1 r
.01 w
.35932 .5632 m
.32775 .56978 L
s
P
p
.002 w
.5903 .04941 m .60658 .04518 L p
.59875 .05717 L .4 g
F P
s
P
p
.002 w
.63129 .04876 m .59875 .05717 L p
.60658 .04518 L .4 g
F P
s
P
p
.002 w
.57408 .05362 m .5903 .04941 L .59875 .05717 L p
.4 g
F P
s
P
p
0 .586 1 r
.01 w
.32765 .57177 m
.32765 .57177 L
s
P
p
0 .566 1 r
.01 w
.32755 .57376 m
.32755 .57376 L
s
P
p
0 .546 1 r
.01 w
.32744 .57575 m
.35907 .56919 L
s
P
p
.002 w
.63129 .04876 m .64765 .04453 L .65592 .05232 L p
.4 g
F P
s
P
p
0 .625 1 r
.01 w
.3594 .56121 m
.3594 .56121 L
s
P
p
.002 w
.62292 .04094 m .63932 .03669 L p
.63129 .04876 L .4 g
F P
s
P
p
.002 w
.64765 .04453 m .63129 .04876 L p
.63932 .03669 L .4 g
F P
s
P
p
.002 w
.60658 .04518 m .62292 .04094 L .63129 .04876 L p
.4 g
F P
s
P
p
0 .526 1 r
.01 w
.35898 .57119 m
.35898 .57119 L
s
P
p
0 .507 1 r
.01 w
.3589 .57319 m
.34024 .56095 L
s
P
p
0 .487 1 r
.01 w
.34015 .56296 m
.32124 .55057 L
s
P
p
0 .447 1 r
.01 w
.32102 .55461 m
.28903 .56134 L
s
P
p
0 .428 1 r
.01 w
.2889 .56336 m
.2889 .56336 L
s
P
p
0 .408 1 r
.01 w
.28878 .56538 m
.28878 .56538 L
s
P
p
0 .388 1 r
.01 w
.28865 .5674 m
.3207 .56069 L
s
P
p
0 .467 1 r
.01 w
.32113 .55259 m
.32113 .55259 L
s
P
p
0 .368 1 r
.01 w
.32059 .56272 m
.32059 .56272 L
s
P
p
0 .349 1 r
.01 w
.32048 .56475 m
.30123 .55224 L
s
P
p
0 .329 1 r
.01 w
.30111 .55428 m
.28159 .54161 L
s
P
p
0 .289 1 r
.01 w
.28133 .54571 m
.2489 .55259 L
s
P
p
0 .27 1 r
.01 w
.24875 .55464 m
.24875 .55464 L
s
P
p
0 .25 1 r
.01 w
.2486 .55669 m
.2486 .55669 L
s
P
p
0 .23 1 r
.01 w
.24845 .55875 m
.28093 .55188 L
s
P
p
0 .309 1 r
.01 w
.28146 .54366 m
.28146 .54366 L
s
P
p
0 .211 1 r
.01 w
.2808 .55394 m
.2808 .55394 L
s
P
p
0 .191 1 r
.01 w
.28067 .55601 m
.26079 .5432 L
s
P
p
0 .171 1 r
.01 w
.26064 .54528 m
.24048 .5323 L
s
P
p
0 .132 1 r
.01 w
.24016 .53647 m
.20728 .54352 L
s
P
p
0 .112 1 r
.01 w
.20711 .5456 m
.20711 .5456 L
s
P
p
0 .092 1 r
.01 w
.20693 .54769 m
.20693 .54769 L
s
P
p
0 .072 1 r
.01 w
.20675 .54977 m
.23968 .54274 L
s
P
p
0 .151 1 r
.01 w
.24032 .53439 m
.24032 .53439 L
s
P
p
0 .053 1 r
.01 w
.23952 .54484 m
.23952 .54484 L
s
P
p
0 .033 1 r
.01 w
.23936 .54694 m
.21882 .53383 L
s
P
p
.086 0 1 r
.01 w
.25127 .53936 m
.27173 .55252 L
s
P
p
0 .013 1 r
.01 w
.21865 .53594 m
.21865 .53594 L
s
P
p
.105 0 1 r
.01 w
.27159 .55464 m
.27159 .55464 L
s
P
p
.007 0 1 r
.01 w
.21848 .53805 m
.21848 .53805 L
s
P
p
.125 0 1 r
.01 w
.27145 .55676 m
.30508 .54966 L
s
P
p
.026 0 1 r
.01 w
.2183 .54016 m
.2183 .54016 L
s
P
p
.046 0 1 r
.01 w
.21813 .54227 m
.25158 .53511 L
s
P
p
.145 0 1 r
.01 w
.30495 .55179 m
.33885 .54464 L
s
P
p
.066 0 1 r
.01 w
.25143 .53723 m
.25143 .53723 L
s
P
p
.164 0 1 r
.01 w
.33875 .54677 m
.33875 .54677 L
s
P
p
.184 0 1 r
.01 w
.33865 .54891 m
.31844 .53558 L
s
P
p
.303 0 1 r
.01 w
.35224 .54122 m
.37235 .55461 L
s
P
p
.204 0 1 r
.01 w
.31833 .53772 m
.31833 .53772 L
s
P
p
.322 0 1 r
.01 w
.37227 .55677 m
.37227 .55677 L
s
P
p
.224 0 1 r
.01 w
.31821 .53987 m
.31821 .53987 L
s
P
p
.342 0 1 r
.01 w
.37218 .55893 m
.40681 .55171 L
s
P
p
.243 0 1 r
.01 w
.31809 .54203 m
.31809 .54203 L
s
P
p
.263 0 1 r
.01 w
.31798 .54418 m
.35243 .5369 L
s
P
p
1 0 .079 r
.01 w
.52119 .80655 m
.54015 .81807 L
s
P
p
1 0 .059 r
.01 w
.54016 .82039 m
.54016 .82039 L
s
P
p
1 0 .039 r
.01 w
.54018 .82272 m
.57556 .81651 L
s
P
p
.362 0 1 r
.01 w
.40675 .55388 m
.44167 .5466 L
s
P
p
.283 0 1 r
.01 w
.35233 .53906 m
.35233 .53906 L
s
P
p
1 0 .02 r
.01 w
.5756 .81884 m
.5756 .81884 L
s
P
p
1 0 .099 r
.01 w
.50197 .79252 m
.52119 .80422 L
s
P
p
.382 0 1 r
.01 w
.44163 .54878 m
.44163 .54878 L
s
P
p
.401 0 1 r
.01 w
.44159 .55095 m
.44159 .55095 L
s
P
p
.421 0 1 r
.01 w
.44154 .55313 m
.47681 .54582 L
s
P
p
1 0 .138 r
.01 w
.53763 .78143 m
.50198 .78785 L
s
P
p
.441 0 1 r
.01 w
.47678 .548 m
.51235 .54063 L
s
P
p
1 0 .118 r
.01 w
.50198 .79019 m
.50198 .79019 L
s
P
p
1 0 .158 r
.01 w
.57351 .77262 m
.53761 .7791 L
s
P
p
1 0 .237 r
.01 w
.55432 .75116 m
.57337 .76329 L
s
P
p
.461 0 1 r
.01 w
.51235 .54282 m
.51235 .54282 L
s
P
p
1 0 .217 r
.01 w
.5734 .76562 m
.5734 .76562 L
s
P
p
.48 0 1 r
.01 w
.51235 .54502 m
.49283 .53127 L
s
P
p
1 0 .197 r
.01 w
.57344 .76795 m
.57344 .76795 L
s
P
p
1 0 .178 r
.01 w
.57348 .77029 m
.57348 .77029 L
s
P
p
1 0 .276 r
.01 w
.59052 .73983 m
.55427 .74649 L
s
P
p
1 0 .257 r
.01 w
.55429 .74882 m
.55429 .74882 L
s
P
p
.5 0 1 r
.01 w
.49282 .53348 m
.49282 .53348 L
s
P
p
1 0 .316 r
.01 w
.57133 .72272 m
.59042 .73516 L
s
P
p
.52 0 1 r
.01 w
.49281 .53569 m
.49281 .53569 L
s
P
p
1 0 .296 r
.01 w
.59047 .7375 m
.59047 .7375 L
s
P
p
.539 0 1 r
.01 w
.4928 .5379 m
.4928 .5379 L
s
P
p
.559 0 1 r
.01 w
.49278 .54011 m
.52895 .5326 L
s
P
p
1 0 .355 r
.01 w
.6079 .71121 m
.57126 .71804 L
s
P
p
.579 0 1 r
.01 w
.52896 .53482 m
.52896 .53482 L
s
P
p
1 0 .336 r
.01 w
.57129 .72038 m
.57129 .72038 L
s
P
p
.599 0 1 r
.01 w
.52897 .53705 m
.52897 .53705 L
s
P
p
.618 0 1 r
.01 w
.52898 .53927 m
.52898 .53927 L
s
P
p
.638 0 1 r
.01 w
.52899 .5415 m
.52899 .5415 L
s
P
p
1 0 .513 r
.01 w
.53217 .6738 m
.55171 .68672 L
s
P
p
.658 0 1 r
.01 w
.529 .54374 m
.529 .54374 L
s
P
p
1 0 .395 r
.01 w
.58865 .69376 m
.60778 .70654 L
s
P
p
1 0 .493 r
.01 w
.55174 .68904 m
.55174 .68904 L
s
P
p
.678 0 1 r
.01 w
.52901 .54597 m
.52901 .54597 L
s
P
p
1 0 .375 r
.01 w
.60784 .70887 m
.60784 .70887 L
s
P
p
1 0 .474 r
.01 w
.55176 .69137 m
.58846 .68441 L
s
P
p
.697 0 1 r
.01 w
.52902 .54821 m
.56564 .54066 L
s
P
p
1 0 .454 r
.01 w
.58851 .68674 m
.58851 .68674 L
s
P
p
.717 0 1 r
.01 w
.56567 .54291 m
.56567 .54291 L
s
P
p
1 0 .434 r
.01 w
.58855 .68908 m
.58855 .68908 L
s
P
p
.737 0 1 r
.01 w
.5657 .54516 m
.5657 .54516 L
s
P
p
1 0 .533 r
.01 w
.51232 .65835 m
.53215 .67147 L
s
P
p
1 0 .414 r
.01 w
.5886 .69142 m
.5886 .69142 L
s
P
p
.757 0 1 r
.01 w
.56574 .54741 m
.56574 .54741 L
s
P
p
.776 0 1 r
.01 w
.56577 .54966 m
.56577 .54966 L
s
P
p
.796 0 1 r
.01 w
.5658 .55192 m
.5658 .55192 L
s
P
p
.816 0 1 r
.01 w
.56583 .55418 m
.56583 .55418 L
s
P
p
.836 0 1 r
.01 w
.56587 .55644 m
.60295 .54887 L
s
P
p
1 0 .572 r
.01 w
.5493 .64648 m
.51232 .65368 L
s
P
p
1 0 .553 r
.01 w
.51232 .65601 m
.51232 .65601 L
s
P
p
.855 0 1 r
.01 w
.603 .55113 m
.603 .55113 L
s
P
p
.875 0 1 r
.01 w
.60306 .55341 m
.60306 .55341 L
s
P
p
.895 0 1 r
.01 w
.60312 .55568 m
.60312 .55568 L
s
P
p
1 0 .868 r
.01 w
.66066 .58957 m
.62312 .59702 L
s
P
p
1 0 .73 r
.01 w
.62361 .61322 m
.58621 .62058 L
s
P
p
.914 0 1 r
.01 w
.60317 .55796 m
.60317 .55796 L
s
P
p
1 0 .849 r
.01 w
.62319 .59933 m
.62319 .59933 L
s
P
p
1 0 .592 r
.01 w
.58654 .63688 m
.54928 .64414 L
s
P
p
1 0 .711 r
.01 w
.58626 .6229 m
.58626 .6229 L
s
P
p
.934 0 1 r
.01 w
.60323 .56024 m
.60323 .56024 L
s
P
p
1 0 .829 r
.01 w
.62326 .60164 m
.62326 .60164 L
s
P
p
1 0 .947 r
.01 w
.64122 .5664 m
.66029 .58036 L
s
P
p
1 0 .691 r
.01 w
.5863 .62522 m
.5863 .62522 L
s
P
p
.954 0 1 r
.01 w
.60329 .56253 m
.60329 .56253 L
s
P
p
1 0 .809 r
.01 w
.62333 .60395 m
.62333 .60395 L
s
P
p
1 0 .928 r
.01 w
.66038 .58266 m
.66038 .58266 L
s
P
p
1 0 .671 r
.01 w
.58635 .62754 m
.58635 .62754 L
s
P
p
.974 0 1 r
.01 w
.60334 .56481 m
.6409 .55721 L
s
P
p
1 0 .789 r
.01 w
.6234 .60626 m
.6234 .60626 L
s
P
p
1 0 .908 r
.01 w
.66047 .58496 m
.66047 .58496 L
s
P
p
1 0 .651 r
.01 w
.5864 .62987 m
.5864 .62987 L
s
P
p
1 0 .77 r
.01 w
.62347 .60857 m
.62347 .60857 L
s
P
p
1 0 .888 r
.01 w
.66057 .58726 m
.66057 .58726 L
s
P
p
1 0 .632 r
.01 w
.58644 .6322 m
.58644 .6322 L
s
P
p
1 0 .75 r
.01 w
.62354 .61089 m
.62354 .61089 L
s
P
p
1 0 .612 r
.01 w
.58649 .63454 m
.58649 .63454 L
s
P
p
.993 0 1 r
.01 w
.64098 .5595 m
.64098 .5595 L
s
P
p
1 0 .987 r
.01 w
.64106 .5618 m
.64106 .5618 L
s
P
p
1 0 .967 r
.01 w
.64114 .5641 m
.64114 .5641 L
s
P
p
.002 w
.6388 .02383 m
.89323 .26471 L
s
.89323 .26471 m
.96399 .88318 L
s
.96399 .88318 m
.66538 .6755 L
s
.66538 .6755 m
.6388 .02383 L
s
.11451 .16063 m
.03601 .79453 L
s
.03601 .79453 m
.66538 .6755 L
s
.66538 .6755 m
.6388 .02383 L
s
.6388 .02383 m
.11451 .16063 L
s
P
p
p
.002 w
.11451 .16063 m
.6388 .02383 L
s
P
p
.002 w
.23239 .12987 m
.23822 .13441 L
s
P
[(5)] .22073 .12079 .84926 1 Mshowa
p
.002 w
.38435 .09022 m
.38994 .09489 L
s
P
[(10)] .37318 .08088 .7914 1 Mshowa
p
.002 w
.54169 .04916 m
.54702 .05397 L
s
P
[(15)] .53104 .03956 .73354 1 Mshowa
p
.001 w
.26236 .12205 m
.26583 .12479 L
s
P
p
.001 w
.29255 .11418 m
.29599 .11693 L
s
P
p
.001 w
.32294 .10625 m
.32635 .10902 L
s
P
p
.001 w
.35354 .09826 m
.35692 .10105 L
s
P
p
.001 w
.41538 .08212 m
.4187 .08494 L
s
P
p
.001 w
.44662 .07397 m
.44992 .0768 L
s
P
p
.001 w
.47809 .06576 m
.48135 .06861 L
s
P
p
.001 w
.50978 .05749 m
.51301 .06036 L
s
P
p
.001 w
.20262 .13764 m
.20614 .14035 L
s
P
p
.001 w
.17305 .14536 m
.1766 .14805 L
s
P
p
.001 w
.14368 .15302 m
.14726 .1557 L
s
P
p
.001 w
.57383 .04078 m
.57699 .04368 L
s
P
p
.001 w
.6062 .03233 m
.60933 .03525 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .30157 .03836 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`000940
0ol300?oP00004T00ol300;o0`03o`800ol20003o`00034000?o00001@000ol0001m0000B0001ol0
003o0?l00P000ol0o`020006o`00o`3o0P000ol0000a0003o`0000D000?o0000O@0004`000?o0?l0
0P000ol0o`020006o`00o`3o0P000ol0000a0003o`0000800olK00CoH@0004T00ol20006o`00o`3o
0P001_l00?l0o`8000?o0000<@000ol000020003o`0001L01?l20003o`3o060000180003o`0000@0
0_l20005o`00o`001_lc00;o1004oa<00ol60004o`00oel000180005o`000?l030000ol0o`1>00Co
00<0o`001@04o`030?l005d0001900?o3`000ol0001800Co2004o`04POn1^`?oG@000:801?l00`3o
000500Co00>1oh400X400on1o`02o`030?l005/0002N00Co2@05o`B100?oPOl00_l01X7o^ol0oe/0
002K00Co2006o`R100?oPOl00h401Onko`3o05X0001V00?o1002obP01?l40004o`0000Go18400on1
P@04o`05^l^kbol018401Onko`3o05T0001W0003o`00008000Co003o8`04o`P01Ol9P@;o2;/00on1
P@03P@05ok_o0?l0F00006L000?o00000P001?l00?lO00Co0`000ol0000200Go0h400on1P@05o`0>
^l^kbk_;^l^kbk_;ol/3P@?o00Bko`3oE`0006L000?o00000P001?l00?lK00Co2004o`V10_lA^`03
ok^k00;o0h401Onko`3o00X00om90000I`000ol000020004o`00oaP00ol20003o`0000<01?l3P@03
oh6100Go01W;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;00F10ol00`3oo`0;0003o`0004H0001V00;o
1@02oaD01?l700Co2842oa^k00Co^k^k1X42o`030?l000X000?o0000AP0008001?l00`3o000500?o
0X400on1P@03P@?o02?;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`04P@Co00<0o`00
1P03odT0001l00Co2005o`F100?oPOl00_lQ^`04ok^k^`Go0h42o`030?l000D000?o0000B@0007T0
1?l700Ko2H409Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l4P@03oh6100:1
0_l00h7oo`0400CoB00007D01?l700Ko0h400on1P@05ob>k1Ol8P@03oh6100:10_l20003o`0004d0
001a00Co2005o`R10_l08l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Go0h42o`V1
00?oPH401?l20003o`0004`0001300?o9`04o`@000Co00001Ol3P@03oh6100Co8k/4o`V100?oPH40
2842o`>10_l20003o`0004/000160003o`0002001?l800Co2H42o`0Abk_;^l^kbk_;^l^kbk_;^l/0
1?l03K_;^l^kbk_;^l^kbk/01Ol3P@03oh6100N10_l2P@Go00>kbk/01H42o`8000?o0000BP0004H0
00?o00007@03o`<000?o00000P04o`B100?oPH401?l4P@03ok^k00Zk1?l4F`03ok^k00Rk0_l9P@03
oh6100J100CoPOoo2K/5P@?o00<0o`00BP0004<00olL00Co1`04o`V10_l9P@0:ol^kbk_;^l^kb`;o
2E/03Onkbk_;^l^kbk_;^ol02H400on1P@06o`0=^l^kbk_;^l^kbk_;^`03P@Co0P000ol000180000
@`000ol0000H00Co0P000ol0000200Co0h400on1P@05o`>k00?oPH4028400onk^`08^`03oe]K00MK
00?o^k/02K/00on1P@07P@;o1K/00onk^`0<^`;o0h42o`8000?o0000A`0004<01?lC00Co1`04o`R1
0_l02[_;^l^kbk_;^ol:P@0<ol^kbk_;^l^kbk_o2E/2o`0;bk_;^l^kbk_;^ol00X44o`B101Gobk_;
^onkbk_;^l^kbk_;^l^kbk/01H42o`8000?o00009005o`050?ooo`000ol300;o400005L00ol00`3o
000400Co0h400on1P@04o`jk00?oPH401Ol>^`03oe]K00Co15/00onk^`08^`;o2H401Onk^k_o012k
1H43o`030?l002@000?o00000P001?l00?l40004o`00oa40001B00Go1`03o`R10_l04K_;^l^kbk_;
^l^kbk_;^l^k00Co01C;^l^kbk_;^l^kbk_;^l^kbk_;^`;o2E/03?o;^l^kbk_;^l^ko`Z101Gobk_o
^l^kbk_;^l^kbk_;^l^kbk/00h43o`04bol0ob@000?o00000`03o`800_l30003o`0000l0001?00Go
1P07o`:11?lA^`Co15/00onk^`0B^`03oe]K00QK0_l9^`03oh6100R100?o^ol04[/2o`>100Go^ol0
o`0S00Go0`000ol0o`050003o`0000l0001:00Go1`06o`F10_l04K_;^l^kbk_;^l^kbk_;^l^k00Co
2E/02?o;^l^kbk_;1?l02[_;^l^kbk_;^ol5F`?o0e/02onkbk_;^l^kbk_o00:11Ol3P@;o01>kbk_;
^l^kbk_;^l^kbk_;^l^k00F10ol00`3o000Q0003o`0000<00_l300?o00@0oooo400004L01Ol00h40
000300Ko1H43oa2k1?l4F`03oe]K00MK00?o^k/01?l4P@03ok^k00Nk00?oFol00_l7F`03ok^k00Nk
0_l9P@03ok^k01:k1X42o`030?l0020000?o00003@000ol0000?0000@P000ol0o`02o`D000?oPOl0
1Ol4P@03oh7o00;o016kbk_;^l^kbk_;^l^kbk_;^`02o`UK00?oFe/01e/2o`V100_o^l^kbk_;^l^k
o`0;F`0<ok_;^l^kbk_;^l_o2842o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbk/4P@Co00<0o`007`05oad0
001000Co1`05o`V100?o^k/04k/00omKF`08F`03oe]K00Co0k/00on1P@08P@03ok^k00Rk0_l9F`03
ok^k00Rk00?oPH401H400on1o`0D^`?o0h42o`030?l000T00ol400;o;P0003`01?l700Go0h400on1
P@05o`0=^l^kbk_;^l^kbk_;^`03o`0:^l^kbk_;^l^ko`YK0_l02K_;^l^kbk_;o`0:P@0=ok_;^l^k
bk_;^l^ko`02F`Co00nkbk_;^l^kbk_;^l^kbol00X45o`:101Gobk_;^l^kbk_;^l^kbk_;^l^kbk/0
1X45o`T000?o00000P001?l00?l]0000>004o`L01Ol8P@;o3K/5o`=K00?o^k/01k/00omKF`05o`fk
00?oPH401Ol3P@03ok^k00Vk0_lC^`;o18401On1PH7o01Bk1X42o`8000?o00001P000ol000020004
o`00obd0000d00Co1`05o`>100?oPH401?l03L^kbk_;^l^kbk_;^l/01?l9F`0:ok_;^l^kbk_;^`;o
017;^l^kbk_;^l^kbk_;^l^kb`04o`V102;o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1H406On1PH7obk_;^l^kbk_;^l^kbk_;^l^kbk/01844o`8000?o00001@000ol000020004o`00obd0
000a00?o1`05o`R10_l=^`Co15/00omKF`07F`03ok^k01Fk1?l4P@03oh6100N100?o^k/07[/00on1
P@02P@03oh6100:10_lC^`?o18401?l00?l60003o`00008000Co003o;@0002d01?l600Go0h400on1
P@04o`0?bk_;^l^kbk_;^l^kbk_;00;o2E/00omKF`07F`0Cok_;^l^kbk_;^l^kbk_;^l^kb`04o`V1
00?oPH401h408_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2P@Co18405Onkbk_;^l^k
bk_;^l^kbk_;^l^kb`06P@04oh61o`@00_l500;o;P0002/00_l700Co2842oaFk00?oFe/01e/00omK
F`04oa6k1?l4P@03oh6100N100?oPH401?l=^`?o5;/2o`03POn100J100?o^k/04[/4P@03oh7o0080
00?o0000>00002/000?o0?l00P04o`B100?oPH400ol06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
o`09F`;o017;^l^kbk_;^l^kbk_;^l^kb`04o`V100?oPH401h42o`0=bk_;^l^kbk_;^l^kb`04o`=K
01So^l^kbk_;^l^kbk_;^l^kbk_;^l_oPOl8P@0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00?o0h401?l0
0?li0000:`05o`V10_lN^`03oe]K00Co4K/4o`B100?oPH401h400on1P@04o`nk0_l8F`03ok^k01:k
0_l9P@;o4k/6P@04o`00ocP0000Z00;o18400on1P@04o`0S^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk/00_l04L^kbk_;^l^kbk_;^l^kbk_;00Co2H400on1P@07P@;o01G;^l^kbk_;^l^k
bk_;^l^kbk_;^ol02E/05_nkbk_;^l^kbk_;^l^kbk_;^l^kbol2P@Go18405?o;^l^kbk_;^l^kbk_;
^l^kbk_;1X44ocL0000R00;o1`02o`B10_lf^`Co18400on1P@07P@03oh6100Co6K/00omKF`07F`03
ok^k012k1?l:P@03ok^k016k1843o`8000?o0000=000024000Co003o1@000ol00002o`B103Cobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l9P@03oh6100N1
0_l07l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol00U/4o`0A^l^kbk_;^l^kbk_;^l^kbk/0
1?l01H7oPH7o00Z101Cobk_;^l^kbk_;^l^kbk_;^l^kb`?o0h401?l00?le00008@001?l00?l50005
o`000?l01H400onk^`0b^`03oh6100N100?oPH401?l4P@03ok^k01bk0_lA^`Co1H401On1PH7o00:1
1OlG^`J100Co003o=000024000Co003o1@000ol000020003oh6100>102Sobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;1?l02[_;^l^kbk_;^ol9P@;o2H40;Oo;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`B100?oPH400X400on1P@02P@;o01g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`06P@;o00<0o`00<P00024000Co003o1@000ol000040003
oh6100:10_lQ^`Co15/00onk^`07^`03oh6100Co18400on1P@07P@03ok^k012k0olB^`Co2H400on1
P@04ob:k1843o`8000?o0000<00002800_l60003o`0000D00_l4P@;o01g;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`02o`UK00[o^l^kbk_;^l^k0_l9P@03oh6100Co017;^l^kbk_;^l^kbk_;^l^k
b`04o`=K00go^l^kbk_;^l^kbk_;00Go18400on1P@07P@;o02G;ol^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00Go0h42o`030?l00300000Z0003o`0000L000?oPH400h400onk^`0L^`03
oe]K00MK00?o^k/02;/00on1P@07P@;o4k/2o`QK00?o^k/01k/2o`Z100?oPH401?l5^`03ok^k01fk
1?l4F`F11?l`0000:P000ol0000800;o1842o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
2E/2o`0:bk_;^l^kbk_;o`:11?l06L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02E/02onkbk_;^l^k
bk_;00;o2H42o`0Ubk_;^l^kbk_;ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`04o`UK00WoPH61
ok_o0?l0;`0002T00_l<00;o18400onk^`0K^`03oe]K00Co15/00onk^`07^`;o4K/3o`Vk00?oFe/0
1e/00onk^`09^`03oh6100Co0h400onk^`07^`03ok^k01Fk1?l4F`03oe]K00MK1ol00`3oo`0900?o
0`03oa/0000Y0003o`0000`000?oPH400h407_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o
2E/06?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co0h402onkbk_;^l^kbk_o009K1?l03k_;^l^kbk_;
^l^kbk_;^`02o`R101go^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kb`04o`UK00?oFe/01?l3F`03
oh6100:10_l20003o`0000L000?o00001@000ol0000H0000:@000ol0000=0003oh6100>100?o^k/0
7;/2o`QK00?o^k/04;/4o`R100?o^k/01k/2oaBk00?oPH401h400onk^`05^`03ok^k00fk1?l4F`03
oe]K00MK0_l8F`03oh6100:11Ol80003o`0000D000?o0000600002T000?o00003`000on1P@02P@;o
01o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o009K0ol04L^kbk_;^l^kbk_;^l^kbk_;00Co
0h400on1P@07P@0Qok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00V101?o^l^kbk_;ol^k
bk_;^l^kbk_;00Co2E/00omKF`04o`04^l^ko`UK00?oPH401?l20003o`0000D000?o00000P03oa/0
000Y0003o`0001000_l4P@03ok^k01bk0_lB^`;o28400on1P@07P@;o7[/00on1P@04o`>100?o^k/0
0k/00onk^`04^`Go15/00omKF`07F`;o2;/00omKF`07F`;o0h42o`8000?o000010000ol000020003
o`0001/0000Y0003o`00014000?oPH400h40=?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@03oh6100Co1842o`0K^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00Co28402?nkbk_;ol^k1?l:F`03oe]K00Co00jkbk_;^l^kbk_;^l^ko`9K1?l3F`03oh6100:1
0_l2P@03o`0000800_l400Co6P0002T000?o00004P000on1P@03P@;o<K/00on1P@07P@;o2X400onk
^`0D^`Co0e/00on1P@07P@03ok^k00Co15/00omKF`08F`;o4;/4o`QK00?oPH400X42o`8000?o0000
9@0002T000?o00004P000h40o`02o`>103?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol00X44o`B10_l9P@0Dok_;^l^kbk_;^l^kbk_;^l^kbk/2o`QK00?oPH40
1h42o`9K00?oFe/015/00omKF`05o`0@^l^kbk_;^l^kbk_;^l^kb`Co0e/00omKF`07F`03oh6100Co
0P000ol0000T0000:@000ol0000A0004P@0000;o18400onk^`0_^`;o2X400on1P@04oaRk00?oFe/0
1U/00on1P@04o`B100?oFol01e/2oa6k1?l8F`03oe]K00MK0_l4P@04o`00obD0000X00;o4`000h40
00030003oh6100:102So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol02;_;
^l^kbk_;0_l9P@;o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol4F`;o0U/2o`V10_l00e_o
o`02o`=K00kobk_;^l^kbk_;^l^kb`Co15/00omKF`06F`03oe]K00Co00Bkbk_;1H44ob@0000X0003
o`00018000>1000010000on1P@02P@;o8K/4o`=K00?o^k/01k/00on1P@04o`>100?o^k/07;/4o`Jk
00?oPH401h42o`QK00?o^k/02;/2o`UK00?oFe/00U/2o`9K0_l9^`>100?oPOl00P000ol0000Q0000
:0000ol0000B0003P@0000D00_l4P@0Ool^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`QK
00[o^l^kbk_;^l^k0_l8P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
0X44o`04bk_oo`UK00cobk_;^l^kbk_;^ol:F`Co012kbk_;^l^kbk_;^l^kbk_;0_l3P@04o`00ob80
000X0003o`00018000>100001`000on1P@02P@03ok^k01bk00?oFe/01e/00onk^`07^`03oh6100N1
00?o^k/09[/2o`Jk00?o^ol02E/2o`Vk00?oFe/01Ol2F`03ok^k01:k1H401?l0oolQ0000:0000ol0
000B0003P@0000P000?oPH400X408?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o2E/2o`09
bk_;^l^kbk_o00V10_l0</^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_o^l_o0U/4o`AK00[o^l^kbk_;^l^k0_l8F`0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00F100Co003o
800002P000?o00004P000h40000:00;o0X42oafk00?oFe/01?l4F`03ok^k00Jk00?oPH401?l4P@03
ok^k02^k00Co^k^k0_l9F`03ok^k00Nk00?oFe/01e/00onk^`0B^`>10ol20003o`0001d0000X0003
o`00018000>100002`02o`>10_l07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`UK00Wobk_;
^l^kbk/00_l9P@0dol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;
^l^ko`UK00_o^l^kbk_;^l^ko`09F`;o01?;^l^kbk_;^l^kbk_;^l^kbk_;00;o0h401?l00?lN0000
:0000ol0000B0003P@0000`00_l4P@03ok^k01^k0_l8F`03ok^k00Nk0_l8P@;o:[/00onk^`04^`03
oe]K00Co0e/00onk^`07^`03oe]K00Co15/00onk^`0A^`F11?lM00009`000ol0000C0003P@0000h0
00?oPH400X42o`0N^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o0U/3o`0?bk_;^l^kbk_;^l^k
bk_o00:10ol4P@0`ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^k
1?l8F`0:ok_;^l^kbk_;^`;o2E/05?o;^l^kbk_;^l^kbk_;^l^kbk_;0h401On1o`3o01d0000W0003
o`0001<000>100003`02o`B100?o^k/06K/4oa:k0_l8P@03ok^k02Jk00?o^ol00ol3F`03oe]K00MK
00?o^k/02;/00omKF`07F`03ok^k016k0_l3^`;o7@0002L00_lC0003P@00014000?oPH400h405onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co0e/05_nkbk_;^l^kbk_;^l^kbk_;^l^kbol8P@0Vok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/4o`QK00?oFe/01e/03?nkbk_;^l^kbk_;o`9K
1?l3F`0=ol^kbk_;^l^kbk_;^`04o`F100Bkbk_o7@0002L000?o00004P000h40000B0003oh6100>1
0_l@^`Co25/00onk^`0B^`03oh6100:10_l2P@;o8;/3o`9K00?oFol025/00omKF`04o`bk1?l8F`03
ok^k00Fk1?l6P@Co0P000ol0000K00009`000ol0000B0003P@0001@00_l4P@0<ol^kbk_;^l^kbk_;
1?l4F`03oe]K00IK01Go^l^kbk_;^l^kbk_;^l^kbk_;^l/01?l6P@0Lol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`Co1E/01?mKFol4F`;o0U/2o`0<bk_;^l^kbk_;^l^k1?l3F`03oe]K00MK00?obk/0
1?l9P@03o`0000D000?o00006P0002L000?o00004P000h40000F0003oh6100:100?o^k/01[/2o`UK
00?oFe/01U/00onk^`0B^`03oh6100N100?o^k/05;/4o`AK00?oFe/00U/01?mKFe/4o`jk1?l8F`03
oe]K00MK0_l6P@Co2`000ol0000J00009`000ol0000B0003P@0001L000?oPH400X402_o;^l^kbk_;
^l/2o`QK00?oFe/00ol06K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol02H42o`0B^l^kbk_;^l^kbk_;
^l^kbk_;0_l9F`03oe]K00?o013;^l^kbk_;^l^kbk_;^l^k1?l4F`03oe]K00IK00?oFe/01?l9P@03
o`0000d000?o00006P0002L000?o00004P000h40000G0003POn100>10_l9^`03oe]K009K0_l2F`;o
7;/00on1P@04o`B100?o^k/01K/3o`Vk00GoFe]O7`05F`;o00>kok/03;/4o`UK00?oFe/00U/2o`9K
0_l5P@Go4`000ol0000J00009P000ol0000C0003P@0001L000B10?oo18402_nkbk_;^l^kbk/4o`0S
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l9P@03ok_;00Co0e/02_nkbk_;^l^k
bk/37`0CGaoook_;^l^kok_;^l^kbk_;^`04o`AK00?oFe/01e/4o`B11_l00h40000F0003o`0001X0
000V0003o`0001<000>100005`001H40003o00B100?o^k/0;k/00on1P@07P@;o25/00onk^`02^`05
7elOGal00Ul00amO7`06^`03ok^k00>k0il00omKF`07F`?O1?l9P@?o10000h40000F0003o`0001X0
000V0003o`0001<000>100005`000h40000200;o0h42o`0abk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`02P@Co0e/00omKF`07F`037elO00HO00>kbk/00al02Eo;
^l^kok_;o`03W`04ginOo`IK1=l00ioOP@04P@Go2@000h40000F0003o`0001X0000V00;o50000h40
000F0003P@0000D00_l3P@;o;K/4o`QK00?oFe/00U/02AmO7elOGamO7`08^`047elO7`>k00OoWmnO
gioO00BO00?oFml02]l3P@;o3P000h40000E0003o`0001X0000V0003o`00018000>100005`000h40
00060003oh6100>102[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`AK
0_l7F`05oe/OGal015l03K_;^l^kbk_;^l^kbk/00Q401QMOgmnOo`JO00=Kg]l01Ml01=kOPH42o`04
gioOga4000>100005@000ol0000J00009P000ol0000B0003P@0001L000>100001`000on1P@03P@03
ok^k00jk1?lB^`;o2E/00omKF`02F`04oe]Ko`9O00@O^aLG0Ul<^`044ALA4@;N00?Ooml02ml01X7N
g]j1o`<00ml00il0000>0003P@0001H000?o00006@0002H000?o00004P000h40000G0003P@0000T0
0_l3P@0=ok_;^l^kbk_;^l^kb`03o`AK0_l04l^kbk_;^l^kbk_;^l^kbk_;^ol02E/4o`B10al2G`8G
0el03<^kbk_;^l^kbk/A5`8A0ml02OoOg]oNgmkOgP02P@03Wa6O00;N00?OgP001@04g`h000>10000
5P000ol0000I00009P000ol0000B0003P@0001L000>100002P000on1P@02P@03ok^k00Nk0_l9F`03
ok^k00:k1Ol9^`03oe]K00Co0k/00on1P@04P@05GalOGal00aL2G`Rk00HG4ALA5a43gP04omkOgP;o
19l0116OWa46gP08gioOWmnOgil60004gW5agP@000>100005P000ol0000I00009P000ol0000B0003
P@0001L000>100002`000on1P@02P@0<ok_;^l^kbk_;^l_o2E/4o`EK00[o^l^kbk_;^l^k0_l02L^k
bk_;^l^ko`05P@IO00PGGaMObk_;^`PG00TA5a4AgooOg]l00Q400ioOgP03gP03gmkO00KN00CO4MlA
1Mh0277NLMiag]ma10000h40000F0003o`0001T0000U0003o`0001<000>100005`000h40000<0003
oh6100:10_l9^`03oe]K00Co0e/00omKF`06F`03ok^k016k00?oPH400_l00amO7`037`09^aLG5a4G
4ALA008G00<A5h400h401A4G4A7o00?N1ml01MkOg]oN00;O0mh03g7NLMiagW7NLMiagW7N0003gP<0
00>100005P000ol0000I00009@000ol0000C0003P@0001L000>100003@02o`B10_l02;_;^l^kbk_;
0_l8F`03oe]K00IK01Co^l^kbk_;^l^kbk_;^l^kbk_;^`;o18401UlGGeoo^`LG1h42o`<A00?o4Mh0
1]h2g`06g]oOWmnO0P07gP040=iagPH000CNLMia0P000h40000F0003o`0001T0000U0003o`0001<0
00>100005`000h40000@00F100?o^k/01k/00omKF`06F`03oe]K00?o6;/00on1P@02P@087elOPOlA
5a44P@Go10034@03oh7O00;O10000mnOg`070003LMia01000mh00`21000G0003o`0001T0000U0003
o`0001<000>100005`000h40000A0003oh6100:10_l02L^kbk_;^l^ko`04F`;o0U/2o`0M^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X42o`03GaN100N10_l;0003oh4002@000AagW6160000ol0
000I00009@03oa<000>100005`000h40000B00;o18400onk^`06^`Co8K/4o`J10ol@0003oh4002D0
0mhH0003o`0001T0000T0003POl001@000>100005`000h40000D0003oh6100:102Wobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`:11?l2P@;o4`000on1000U00Aa60000ol0
000H00005@03o`@00_l70003oh40018000>1000060000h40000D0003POn100>10_lQ^`Go1H43oaT0
00?oP@009`03gQL000?o0000600001H000?o00000P001?l00?l60004o`21PA4000>1000060000h40
000D0004P@3oo`B101_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01_l3P@Ko7@000on1000X00=a
5P000ol0000H00005P000ol000020004o`00o`D000?o00000P000h40000>0003P@0001L000>10000
5@0018400?l5P@03ok^k01>k1?l8P@?o8@000on1000X0003PG7N01H000?o0000600001H000?o0000
0P001?l00?l50003o`0000<00X4>0003P@0001L000>100005@001H40003o00F10_l03l^kbk_;^l^k
bk_;^l^kb`04o`J11?l00`21000S0003o`2102P000B1gW7N5@000ol0000H00005P000ol000020004
o`00o`D000?o00001@000h40000;0003P@0001L000>100005@000h40000300;o18400onk^`09^`?o
2H400ol000030003P@00028000?o0840:0001H5aLG7N01@000?o0000600001D00_l500;o1P000ol0
000600:12`000h40000G0003P@0001D000>100001@000on1P@02P@05ol^kbk/01_l5P@Co2@000h40
000R0003o`2102L00md3L@03gP00014000?o0000600002@000?o000020000h4000080003P@0001L0
00>100005@000h4000060003oh6100:11?l4P@Ko3P000h40000R0003o`2102<027401=eaLMhB0003
o`0001P0000T0003o`0000T00X480003P@0001L000>100005@000h40000800;o00>kbh401H43oa80
00>100008P000ol0P@0Q00OM00>10000174B0003o`0001P0000T0003o`0000/000>100001@000h40
000G0003P@0001D000>100002@000onk^`05oaH000>100008P000ol0P@0M00CM0g440004P@0000=a
4`000ol0000G00008`02o`h00X450003P@0001L000>1000050000h40000;00;o6`000h40000R0003
o`2101P000_MLMeagG7MLMeag@050003P@0000800W4C0003o`0001L0000S0003o`0000l000F10000
P@0J0003P@0001@000>100002`000ol0000J0003P@0002<000?oP@005`000mfEL@03g@X000>10000
5`000ol0000G00008`000ol0000@00:100<0P@006@000h40000D0003P@0000/000?o00006P000h40
000S0003oh4001L000>ELMd03P000h40000F0003o`0001L0000S0003o`0001800X4J0003P@0001@0
00>100002`000ol0000J0003P@0002<000?oP@006003L@d000>100005P000ol0000G00008`000ol0
000C00:16@000h40000D0003P@0000/000?o00006P000h40000S0003oh4001T000>ELID030000h40
000F0003o`0001L0000S0003o`0001<000>1084060000h40000D0003P@0000/000?o00006P000h40
000S0003oh4001X00g4;0003P@0001H000?o00005`0002<000?o00004`000h400002PAD000>10000
5@000h40000;0003o`0001X000>100008`000on1000K0003UG6E00X000>100005P000ol0000G0000
8`000ol0000C0003P@00008000>100004P000h40000E0003P@0000/000?o00006P000h40000S0003
oh4001`000?MLMd02@000h40000G0003o`0001H0000S0003o`0001<000>100000`02PA8000>10000
5@000h40000;0003o`0001X000>100008`000on1000M0003UG6E00H000AaUG6E60000ol0000F0000
8P000ol0000D0003P@0000D000>100003`000h40000E0003P@0000/000?o00006P000h40000S0003
oh4001h000SMLMgMUMfEg@BE60000ol0000F00008P02oaD000>100001P02P@l000>100005@000h40
000;0003o`0001X000>100008`000on1000O0008UG6Eg9GLUM`3UAP000?o00005P00028000?o0000
50000h4000080003P@0000`000>100005@000h40000;0003o`0001X000>100008`000on1000P0003
UMbE00BE00<0P@0060000ol0000F00008P000ol0000C0003P@0000X00X4<0003P@0001D000>10000
2`000ol0000J0003P@0002<000?oP@0080000mbEg0050003P@0001L000?o00005P00028000?o0000
4`000h40000<0003P@0000T000>100005@000h40000:0003o`0001/000>100008`000on1000P0004
g9GLU@@000>100005`000ol0000F00008P000ol0000C0003P@0000d00X490003P@0001D000>10000
2P000ol0000K0003P@0002<000?oP@008P03U@@000>100005P000ol0000F00008P000ol0000C0003
P@0000l000>100001P000h40000E0003P@0000X000?o00006`000h40000S0003oh4002<000>Eg9D0
0`000h40000F0003o`0001H0000R0003o`0001<000>100004002P@H000>100005@000h40000:0003
o`0001/000>100008`000on1000T0003UM`0008000>100005`000ol0000E00008@000ol0000D0003
P@0001800X440003P@0001D000>100002P000ol0000K0003P@0002<000?o08408P0019GLUID30003
P@0001@00h400ol0000E00008@000ol0000D0003P@0001@000F10000P@0G0003P@0000X000?o0000
6`000h40000S0003o`2101d000KLUMbEg9D3g0<000>100003`05P@<000?o00005@00024000?o0000
50000h40000E00:100<0P@005P000h40000:0003o`0001/000>100008`000ol0P@0K0008g9GLUMbE
g9D60003P@0000X01H480003o`0001D0000Q0003o`0001@000>100005`000h40000F0003P@0000X0
00?o00006`000h40000S0003o`2101P000JEg9GLUM`;0003P@0000D01H4=0003o`0001D0000P00?o
5@000h40000G00>15P000h40000:0003o`0001/000>100008`000ol0P@0C000;UMbEg9GLUMbEg9D0
2`000h400005PA8000?o00005@0000800olL0003o`0001<000>1000060001840084E0003P@0000X0
00?o00006`000h40000S0003o`2101<00m`00iGLU@0>00F15`000ol0000E00000P001?l00?lK0003
o`0001<000>10000600018400002PA8000>100002`000ol0000K0003P@0002@000?oP@004004g0d0
1H420003P@0001L000?o00005@00008000?o000070000ol0000C0003P@0001P000>100000`000h40
000?0003P@0000/000?o00006`000h40000T0003oh4000`02=`800F11`000h40000G0003o`0001D0
00020003o`0001/000?o000050000h40000H0003P@0000@00X4?0003P@0000/000?o00006`000h40
000Q0005k=cLoh402@09g0H01H4<0003P@0001P000?o0000500000030?oo00;o6`000ol0000D0003
P@0001P000>100001P000h40000<0003P@0000/000?o00006`000h40000O00?/00CLk?n11@001]c/
g>cLk0?L1@05PA8000>100005`000ol0000D00000P000ol0000K0003o`0001@000>1000060000h40
000700:130000h40000;0003o`0001/000>100006P002=c/g>cLk=c/0]`00ooLg0020003k=cL00CL
1005PAL000>100005`000ol0000D00000P000ol0000K0003o`0001@000>1000060000h4000090003
P@0000T000>100002`000ol0000K0003P@0001H000?Lk>`01n`40008onc/k;OLk=`300F170000h40
000G0003o`0001@0000P0003o`0001@000>1000060000h40000:00:12@000h40000;0003o`0001/0
00>100004P001NcLk=c/00;L00?/g0001`000ncog003g003k=b100>18@000h40000G0003o`0001@0
000P0003o`0001@000>1000060000h40000<0003P@0000H000>100002`000ol0000K0003P@000100
0^`01Mc/g>cL00X000GLk=cog005k2D000>100005`000ol0000D000080000ol0000D0003P@0001P0
00>100003@02P@H000>100002`000ol0000K0003P@00010000?/g>`03P03k004onc/k0?L9@000h40
000G0003o`0001@0000O00;o5P000h40000H0003P@0000l000>100000`000h40000;0003o`0001/0
00>1000040001;O/]n`800F100GLk=cog00300;/9@000h40000G0003o`0001@0000O0003o`0001@0
00>100006@000h40000@00:10`000h40000;0003o`0001/000>100003P03]`04k;Ngk0801H480003
oh4002T000>100005`000ol0000D00007`000ol0000D0003P@0001P000>100004`001840084=0003
o`0001/000>100002P06]`07k;Ngk;O/P@0=0003oh4002T000>1000060000ol0000C00007`000ol0
000D0003P@0001P000>100005003P@d000?o00006`000h4000060003]kJg00Jg0h40102g]kL>0003
oh4002T000>1000060000ol0000C00007`000ol0000D0003P@0001P000>100005P000h40000;0003
o`0001/000>100000P09]`:11`000kO/000=0003oh4002T000>1000060000ol0000C00007`000ol0
000D0003P@0001P000>100005P03P@/000?o00006`002h400;Nf]kJg][N101`000?oP@00:@000h40
000H0003o`0001<0000O0003o`0001@000>100004P000ha<S0030003P@0001H000B100212P000ol0
000D0003ITeV00@00h400kJg]`0Q0003oh4002X000>100005`000ol0000C00007`000ol0000D0003
P@0000d00d`20003S4a<009<00<0P@003@03C@L000B100000X480003o`0001@000A=ITiV0X42]P04
ITeVIR8000?oP@00:P000h40000G0003o`0001<0000O0003o`0001@000>100003@0034a=C4e<CDa=
C4e<P@h00T`2C@@000A=C4e=10000h4000050003o`0001800X400diVIP09IR8000?oP@00:P000h40
000G0003o`0001<0000N0003o`0001D000>100002P02S0Q<00@0CDa=0d`200><1`0034e<CDe<CDa=
C4e<C@D00X450003o`0000d01H40302gITeVCFI=ITeV009>1P02IP03CVH001L000?o0840:P000h40
000G0003o`0001<0000N00?o5@000h40000:000:aTa=C4e<S4b<C0<000A<CDa=0h`014b<S8`5000>
CDa=C4e<CDa=C4e<CD`50003P@00008000?o0000100016I=ITd5P@0706I=ITe>C@05IP03CFI=0080
00aVCP12IT9V@VI2IT8H0003o`2102X000>1000060000ol0000B00007P000on1000D0003P@0000X0
00V<C8a<S4b<C0000T`3009<00==C4d00T`4S008CDa=C4e<CD`5C@8000>1CDd00dd400:10P000ol0
C@07C@0EITe=ITeVCFI=ITeVCFI=ITd0ITj100802FH00`12@P060004@Tm?@Ph000?o0840:P000h40
000H0003o`000180000>00Co0`02o`L000?o084050000h40000:0003C8a<00T000><C8`00X`02De<
C4a=C4e<C@09C00304a=008000N1001<CDa=00D00dd05FI=ITeVCFH0ITeVCFI=ITeV]Ti=CP080007
P@00IT9V@P060009Cd80@Tm2Cd9?00=23P000ol0P@0Z0003P@0001P000?o00004P0000l000?o0000
0P001?l00?l60003o`0000:14P000h40000F0005S4b<C8`00T`024e<CDa=C4f<0dd00lK0aP03`0@0
00>100000P0<C@H000AVCFI=0`02o003][Nf00T000>100002P002T9?@Tm2Cd9?@P02@PH014l50003
oh4002T000>1000060000ol0000B000040001Ol0003o008000?o000010000ol0000200:140000h40
000F0005S4b<C8`00T`03de<S<K0a/36`8c6S<J<0004aP04`840c0;000<0CDd01Td00ol0000<00;l
0kH00obf]P080003P@0000X000A?@Tm21P002D9?04m2Cd9?@P03C`D000?oP@00:@000h40000H0003
o`000180000A0004o`00o`8000?o000010000ol000040003P@0000d000>100005P0018a<S8460007
`<J<aXc6S002aP04S<H000?00lH01<3<c<`3C@D000?o000020001obfo;Kl]_`01[H70003P@0001@0
2Dl00`1?C`050003oh4002T000>1000060000ol0000B00003P001?l00?l20004o`00o`H000?o0000
1@02P@d000>1000060000h400005000>aXc6S<J<aXc<aXc<`<`2aP05`<K0a/001/`40003o`0000@0
2O`50003]_bf00L000>100005000149?@Tl60003?dm?00@000?oP@00:@000h40000H0003o`000180
000?00;o1002o`H000?o00002002P@/000>1000060000h4000050003S<J<00D000C<3Lc00/H00l36
`004aP8000?0c<000/`30003o`0000Ol00>fo0002@02]PL000>100007P001DloCcm?008000?oP@00
:@000h40000H0003o`000180000M0003o`0000X000>1000020000h40000H0003P@0000X00Pd0103<
c<`7`006]<K0]@d01L`20003oobf00Gl5`000h40000P00A?00<0oh40:`000h40000G0003o`000180
000M0003o`0000/00X480003P@0001P000>100002P06c004a/36`0T=00>ec0d01<`01?nf]O`K0003
P@00028000E??dooP@0[0003P@0001P000?o00004@0001d000?o00003@02P@H000>1000060000h40
000:00L=0l`200k<00Ko]Obeo;DI0003P@0002<000A?8?n1:`000h40000H0003o`000140000M0003
o`0000l000>100000`000h40000H0003P@0000`001C<3Lc<3@3<3L`=c0g<3L`=c0g<]@8=0/`3]@04
o;Gl]QP000>100008`0014looh4[0003P@0001P000?o00004@0001`00olA00:10P000h40000I0003
P@0000d00`d00l`0c004c0080;D=]@fe3KD33@Be00Kl]Obeo;DG0003P@0002400dl00cooP@0[0003
P@0001P000?o00004@0001d000?o00004P03PA/000>100003P000l`=00050008P@2e3KD=]@d2]@05
3KFe]Ol010000obeo00G0003P@0001`02Cl00on1000Z0003P@0001P000?o00004@0001d000?o0000
50000h40000I0003P@0001H000N10;D=]@gl008=00>e00000P000ol000030003o;D001H000>10000
6@000dloC`06C`<000?oP@00:P000h40000H0003o`000140000L0003o`0001D00h4I0003P@0001H0
00>100000`03]@D000?o000070000h40000I009?0Sl80003oh4002X000>1000060000ol0000A0000
70000ol0000E0003P@0000:15`000h40000F0003P@0000@000<=o00010000ol0000L0003P@0001T0
0Sl:0003oh4002X000>1000060000ol0000A000070000ol0000E0003P@00008000>1000050000h40
000F0003P@0000/000?o000070000h40000I0003?dl000T000?oP@00:P000h40000H0003o`000140
000L0003o`0001D000>100000`02PA@000>100005P000h40000;0003o`0001`000>100005`0013m?
?cl:0003oh4002X000>100006@000ol0000@000070000ol0000E0003P@0000D00X4A0003P@0001L0
00>100002`000ol0000L0003P@00018000ToCcm??dloCcl02P000on1000[0003P@0001P000?o0000
400001`000?o00005@000h4000070003P@0000h000>100005`000h40000;0003o`0001`000>10000
3`002Cm??dloCcm??`0=0003oh4002/000>1000060000ol0000@000070000ol0000E0003P@0000P0
0X4>0003P@0001L000>100002`000ol0000L0003P@0000l00Sl00dlo000A0003oh4002/000>10000
60000ol0000@000070000ol0000D0003P@0000/00X4<0003P@0001L000>100002`000ol0000L0003
P@0000l000<o83l04`000ol0P@0[0003P@0001P000?o0000400001/000?o00005@000h40000=0003
P@0000T000>100005`000h40000;0003o`0001`000>10000400281<000?o0840:`000h40000H0003
o`000100000K00;o5P000h40000>00:12@000h40000G0003P@0000/000?o000070000h40000=00<P
00<o80004P000ol0P@0[0003P@0001P000?o0000400001/000?o00005@000h40000@00:11`000h40
000G0003P@0000/000?o000070000h40000800TP00<o00004P000on1000Z0003P@0001P000?o0000
400001/000?o00005@000h40000B0003P@0000@000>100005`000h40000;0003o`0001`000>10000
1@0981P000?oP@00:P000h40000I0003o`0000l0000K0003o`0001D000>100004`02P@@000>10000
5P000h40000<0003o`0001`000>100000`000b4P800381d000?oP@00:P000h40000E00B100?o0000
3`0001/000?o00005@000h40000E00:10P000h40000F0003P@0000`000?o000070000h4P800781l0
00?oP@00:P000h40000@00F110000ol0000?00006`000ol0000E0003P@0001L000>1084060000h40
000<0003o`0001X000TQ824P8B0Q82408P000on1000Z0003P@0000/01H490003o`0000l0000K0003
o`0001D000>100006002PAP000>1000030000ol0000J0004824P82L000?oP@00:P000h40000500J1
3P000ol0000?00006`000ol0000E0003P@0001T00h4F0003P@0000`000?o00006P00120Q824W0003
oh4002/000>10840184D0003o`0000l0000J0003o`0001H000>100006@001840084E0003P@0000`0
00?o00007000120Q824U0003oh4002L01X4I0003o`0000l0000J0003o`0001D000>100006@000h40
000200:14`000h40000<0003o`0001d000@Q824P90000on1000R00F110000h40000H0003o`0000l0
000J0003o`0001D000>100006@000h40000400:14@000h40000<0003o`0001d000J1024P8B0R0003
oh4001d01H490003P@0001P000?o00003`0001X000?o00005@000h40000I0003P@0000H000>10000
3P000h40000<0003o`0001d000B1000P0b4N00Go6006P@h000>100006@000ol0000>00006@03oaH0
00>100006@000h40000700:13P000h40000;0003o`0001h000>100000P0381P01Ol40003POl00140
1H4D0003P@0001T000?o00003P0001X000?o00005@000h40000I0003P@0000T00X4<0003P@0000/0
00?o00007P000h40000300<Q1`00120Q824700Go2@001840ool;00F16@000h40000I0003o`0000h0
000J0003o`0001D000>100006@000h40000;0003P@0000T000>100002`000ol0000N0003P@0000@0
0R0022408B0Q824P0b4200Go3P001H40003o00@01X4N0003P@0001T000?o00003P0001X000?o0000
5@000h40000I0003P@0000`00X490003P@0000/000?o00007P000h4000050008824P8B0Q8246oa<0
00J10000POl3PB@000>100006@000ol0000>00006@000ol0000F0003P@0001T000>100003P02P@L0
00>100002`000ol0000N0003P@0000D000<P8B001Ol20003824_01801X4200;o9@000h40000I0003
o`0000h0000I0003o`0001H000>100006@000h40000@0003P@0000@000>100002`000ol0000N0003
P@0000<01Ol700DQ2`05P@8000>100001@000ol0000R0003P@0001T000?o00003P0001T000?o0000
5P000h40000I0003P@0001400X440003P@0000/000?o00007P06o`h000@_8BlQ1@05P@L000>10000
1P02ob8000>100006@000ol0000>00006@000ol0000E0003P@0001X000>100004`02P@8000>10000
2`000ol0000I00Go00>100004`038@B130000h4000080003o`00020000>1000060000ol0000>0000
6@000ol0000E0003P@0001X000>100005@000h40P@0=0003o`0001@01Ol50003P@0000l00h43;`03
8@0000h000>100002@02ob0000>100006@000ol0000=00006@000ol0000E0003P@0001X000>10000
5P02P@d000?o00003`05o`X000>100002P03P@068BlQ;b4_0b4A0003P@0000X000?o00007@000h40
000I0003o`0000d0000I0003o`0001D000>100006P000h40000G00>12`000ol0000900Ko3`000h40
000400J12BlD0003P@0000/000?o000070000h40000I0003o`0000d0000I0003o`0001D000>10000
6@000h40000H0004P@00P@X000?o00001005oaD000>10840184600<_00<Q00005`000h40000<00;o
70000h40000I0003o`0000d0000H00;o5`000h40000I0003P@0001P000B100000X480003o`3o00Co
5`05P@/00blJ0003P@0000h000?o00006@000h40000I0003o`0000d0000H0003o`0001H000>10000
6@000h40000H0003P@0000<00X4200Ko5P06P@<000>100002P001B4R8B8Q01P000>100003`02oaT0
00>100006@000ol0000=000060000ol0000F0003P@0001T000>1000060000h40000200Go10000ol0
000@00F12@000h40000<0004;b4_8AL000>100004@000ol0000F0003P@0001T000?o00003@0001P0
00?o00005P000h40000I0003P@0001L000>1ool00ol400:10`000ol0000:00J13P000h40000>0004
8B8Q8AD000>100004P02oaH000>100006@000ol0000=000060000ol0000F0003P@0001T000>10000
4`05o`/00X400`3o000600F150000h40000=00058B8Q8Rl05@000h40000D0003o`0001<000>10000
6@000ol0000=000060000ol0000F0003P@0001T000>100003@06o`@000>100002`00187o0005PAT0
00>100002009;aH000>100005@000ol0000B0003P@0001X000?o0000300001P000?o00005@000h40
000J0003P@0000P01Ol:0003P@0000`000?oPH407P000h40000600088R4R8B8Q8R4I0003P@0001H0
0_lB0003P@0001X000?o0000300001P000?o00005@000h40000J0003P@0000<01Ol?0003P@0000`0
00?o00007P000h40000600038Rl_01h000>1000060000ol0000@0003P@0001T000?o0000300001L0
00?o00005P000h40000J00Ko50000h40000<0003o`0001h000>100001P001B8_8RlR01`000>10000
6@02oa0000>100006@000ol0000<00005`000ol0000F0003P@0001D01Ol00h40000G0003P@0000`0
00?o00007P000h4000080004;b8_8Q/000>100006`000ol0000=0003P@0001T000?o0000300001L0
00?o00005P000h40000@00Go1@000h40000G0003P@0000`000?o00007P000h40000:00038RlR01X0
00>100007002o`d000>100006@000ol0000<00005`000ol0000F0003P@0000/01Ol:0003P@0001L0
00>1000030000ol0000N0003P@0000/00R8J0003P@0001h000?o00002P000h40000I0003o`0000`0
000G00?o5P000h40000500Ko3`000h40000G0003P@0000`000?o00007P000h40000;008R6P000h40
000O0003o`0000T000>100006@000ol0000<00001`03o`@00_l60003POl001L000>100001OlD0003
P@0001P000>1000030000ol0000N0003P@0000T000@O8R8O6P000h40000P00;o2@000h40000J0003
o`0000/0000:0004o`00o`8000?o000010000on1P@0D00Go6@000h40000H0003P@0000`000?o0000
7P000h40000400TR6P000h40000R0003o`0000H000>100006P000ol0000;00002P001?l00?l20003
o`0000@000?o00000X4<00Ko0P000h40000I0003P@0001P000>1000030000ol0000N000=P@0O8QlR
7b8O8QlR7`0M0003P@0002<00_l60003P@0001X000?o00002`0000P00_l30004o`00o`D000?o0000
0`02P@D01Ol70003P@0001X000>1000060000h40000<0003o`0001/000HR7b8O8Ql58R8000>10000
9@000ol000030003P@0001X000?o00002`0000X000Co003o0P000ol000030003o`0000D01Ol<0003
P@0001X000>1000060000h40000<0003o`0001T00b801AlR7b8O02L000>100009P02o`<000>10000
6P000ol0000;00001`03o`@00_l60003o`0000Go0P02P@d000>100006P000h40000H0003P@0000`0
00?o00006@000al_8P020003P@0002L000>10000:0001?l0084L0003o`0000/0000F00?o2@000h40
000:0003P@0001X000>1000060000h40000<0003o`0001T01B800h40000W0003P@0002T000Co0021
6`000ol0000;00006002o`T00X4:0003P@0001X000>1000060000h40000;0003o`0001`000@O8QlR
:@000h40000Z00;o00>100006@000ol0000;00006P02o`T00X480003P@0001X000>1000060000h40
000;0003o`0001h00b8Y0003P@0002/000?o00006@000ol0000;00007002o`T00X460003P@0001X0
00>1000060000h40000;0003o`0001l000<R7b80:0000h40000[0003POoo01X000?o00002P0001h0
0_l900:110000h40000J0003P@0001P000>100002`000ol0000O00058QlR7b809P000h40000[0004
P@00oaT000?o00002P0002000_l900:10P000h40000J0003P@0001P000>100002`000ol0000O0006
P@0R7b8O9@000h40000[0004P@0000;o5`000ol0000:00008P000ol0000800>170000h40000H0003
P@0000/000?o00007`001h40000R7b800`0011lR7b837aX000>10000:`000h4000030003o`0001@0
00?o00002P0002<00_l:00:16P000h40000H0003P@0000`000?o00007`000h40000200/O00<R0000
60000h40000[0003P@0000@000?o00004`000ol0000:00009@02o`L000>100000X4H0003P@0001P0
00>1000030000ol0000O0003P@00008000HR7b8O8QlP0003P@0002/000>100001@02oa<000?o0000
2P0002L00_l50003P@0000800X4F0003P@0001P000>1000030000ol0000O0003P@0002P000>10000
:`000h4000070003o`00010000?o00002P0002T00_l30003P@0000@00X4D0003P@0001P000>10000
30000ol0000O0003P@0002P000>10000:`000h40000800;o40000ol0000:0000:`02o`03084000L0
0X4B0003P@0001P000>1000030000ol0000O0003P@0002P000>10000;0000h4000090003o`0000d0
00?o00002P0002d00_l:0003P@0000l000>1000060000h40000<0003o`0001l000>10000:0000h40
000/0003P@0000X00_l>0003o`0000T0000_00;o2@02P@l000>1000060000h40000<0003o`0001l0
00>10000:0000h40000/0003P@0000`000?o00002`000ol000090000<@02o`T00X4=0003P@0001P0
00>1000030000ol0000O0003P@0002P000>10000;0000h40000=0003o`0000X000?o00002@0003<0
0_l900:12`000h40000H0003P@0000`000?o00007`000h40000X0003P@0002`000>100003P02o`X0
00?o00002@0003D00_l900:12@000h40000H0003P@0000`000?o00007`000h40000X0003P@0002`0
00>1000040000ol000070003o`0000T0000g00;o2@02P@L000>1000060000h40000<0003o`0001l0
00>10000:0000h40000/0003P@0001400_l70003o`0000T0000i0003o`0000P00X450003P@0001P0
00>1000030000ol0000O0003P@0002P000>10000;0000h40000C0004o`0000>100?o00002@0003X0
0_l:00:10`000h40000H0003P@0000`000?o00007`000h40000X0003P@0002`000>100004@03P@;o
00F10000o`0;0000?002o`X00X400`21000I0003P@0000`000?o00007`000h40000X0003P@0002`0
00>100002`06P@D000Go0000o`0;0000?P02o`X00X4J0003P@0000`000?o00007`000h40000X0003
P@0002`000>100001007P@`000Go0000o`0:0000@002o`P000B1086160000h40000<0003o`0001l0
00>10000:0000h40000/00N15002o`030?l000T0001200;o1P0018400002PAH000>1000030000ol0
000O0003P@0002P000>100009`07PA/00_l:0000A002o`@000>100000`02PA@000>1000030000ol0
000O0003P@0002P000>100008@06P@H000>100005`04o`X0001600;o0P000h4000050003P@000140
00>1000030000ol0000O0003P@0002T000>100006P06P@`000>100004@06o`h0001800;o00>10000
1P02PA4000>1000030000ol0000O0003P@0002T000>100005006PA8000>100002P07oa@0001:00;o
2@02P@l000>1000030000ol0000O0003P@0002T000>100003@07PAP000>100001006oa/0001<00;o
2@02P@d000>1000030000ol0000O0003P@0002T000>100001`06PAl000>1ool01?lQ0000CP02o`T0
0X4;0003P@0000`000?o00007`000h40000Y0004P@0000J18006obL0001@00;o2@02P@P000>10000
3@000ol0000O0003P@0002L01X4P00Ko;@00058000?o00002002P@H000>100003@000ol0000O0003
P@0002401X420003P@0001X01olc0000D`02o`X00X440003P@0000d000?o00007`000h40000K00J1
20000h40000D00Ko>P0005D00_l:00:10P000h40000=0003o`0001l000>100005@06P@h000>10000
3P06od00001G00;o2P03P@h000?o000080000h40000>00N150000h40000800KoAP0005T00_l:00:1
3@000ol0000P0003P@0000P01X4K0003P@0000801_m<0000F`02o`P000B108612`000ol0000P0003
P@0000801X4O00OoDP0005d00_l60005P@0008402P000ol0000O00J17`06oeT0001O00;o10000h40
000200:120000ol0000I00J100<0P@007006oel0001Q00;o0P000h40000400:11P000ol0000C00J1
1`000h40000E00KoI@0006<00_l00h40000600:110000ol0000<00N13@000h40000?00KoJ`0006D0
0_l900:10P000ol0000600J150000h40000800OoL@0006L00_l900:100?o00001X4J0003P@000080
1_mh0000J@000ol000080003oh6101l01_mn0000JP02o`P000?o00006@06oh@0001/00;o1P000ol0
000C00KoRP0006h00_l40003o`0000`01on@0000L002o`8000?o00001P06oiL0001b00?o0P06oid0
001d00?oX`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l0
6`0007H000?o00009`000ol0001g0000D@04o`<01?l0103oo`02o`800_l300?o1002o`@000?o0000
2005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l400?o0`03o`<0
0_m80000D0001Ol0003o008000?o00000`001?l00?l300;o1P001?l00?l20003o`00008000?o0000
2@001Ol0003o008000Co003o0`000ol00002o`@000?o000010000ol000070003o`0000D000?o0000
0P001?l00?l200;o1@000ol000030003o`0000800_m80000D0000ol0o`02o`801Ol01@3o003o00/0
00Co003o0P000ol0000>0005o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003
o`00008000?o00002004o`801?m=0000D0000ol000040007o`000?l0o`020003o`0000L00_l400;o
4@001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003o`00008000?o000020000ol0
o`030003o`3o04h0001@0005o`000?l00`03o`030?oo00?o2`001?l00?l20003o`0000h000?o0000
1Ol300Co20000ol0000>0003o`0000@00_l300Co20000ol0o`030003o`3o04h0001A00Co5003o`@0
0_l?00Go2`000ol0000500;o3`05o`T000?o00002@02o`@00_m>0000T002ob4000?o00000P000ol0
001O0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.11179, -0.0242899, 0.0025855, \
0.00390799}},
  CellTags->"AntTracker3D - Gen 38"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 35",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker3D - Gen 59",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[{}, \ \(ifSensor[wall]\)[
          seq[turnLeft, \ 
            again], \ \n\ \ \ \ \ \ \ seq[{}, \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              turnRight], \ \n\ \ \ \ \ \ \ \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              advance]]], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again], \ nop], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[\(ifSensor[dust]\)[advance]], \ advance]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.38, Ind.1, Fit.44.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.38, Ind.1, Fit.44.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .743 r
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .724 r
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .704 r
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .743 r
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .724 r
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .704 r
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .862 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .842 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .822 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .803 r
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .862 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .842 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .822 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .803 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .783 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .763 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .684 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .664 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .586 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .566 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .546 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .783 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .763 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .684 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .664 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .586 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .566 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .546 r
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .901 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .882 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .645 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .901 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .882 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .645 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .941 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .921 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .625 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .605 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .526 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .507 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .941 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .921 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .625 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .605 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .526 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .507 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .487 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .237 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .217 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .197 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .178 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .158 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .132 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .112 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .092 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .02 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .487 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .237 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .217 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .197 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .178 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .158 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .961 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .132 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .112 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .092 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .02 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .467 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .447 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .428 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .349 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .329 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .309 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .961 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .171 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .151 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .072 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .053 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .033 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .467 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .447 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .428 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 .921 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 .941 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 .961 1 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 .98 1 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .349 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .329 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .309 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .171 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .151 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .072 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .053 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .033 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .408 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .276 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .257 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .138 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .118 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 .921 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 .941 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 .961 1 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 .98 1 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.64967 .48107 m .63499 .48538 L .62773 .47741 L p
1 .039 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
0 1 .013 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .408 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .276 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .257 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .138 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .118 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 1 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .98 r
F P
s
P
p
.002 w
.62773 .47741 m .64247 .47306 L .64967 .48107 L p
1 .039 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
0 1 .013 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .388 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .368 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .289 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .27 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .414 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .395 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .316 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .296 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .099 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 1 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .98 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.67926 .47239 m .66443 .47674 L .65728 .46869 L p
0 1 .191 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.007 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.026 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.046 1 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 .882 1 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 .901 1 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .388 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .368 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .289 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .27 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .414 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .395 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .316 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .296 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .099 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.65728 .46869 m .67217 .4643 L .67926 .47239 L p
0 1 .191 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.007 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.026 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.046 1 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 .882 1 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 .901 1 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 1 .25 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .434 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .079 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .059 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.066 1 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .743 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .763 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .842 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .862 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 1 .25 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .434 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .079 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .059 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.066 1 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .375 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .355 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .336 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .743 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .763 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .842 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .862 1 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .23 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .211 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .572 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .553 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .474 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .454 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.086 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.105 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.125 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.145 1 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .375 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .355 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .336 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 .724 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .23 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .211 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .572 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .553 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .474 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .454 0 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.086 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.105 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.125 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.145 1 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 .724 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .592 0 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .783 1 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .803 1 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .822 1 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 .684 1 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 .704 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .592 0 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .783 1 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .803 1 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .822 1 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .533 0 r
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .513 0 r
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .493 0 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 .684 1 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 .704 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .632 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .612 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.164 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.184 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.263 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.283 1 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .533 0 r
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .513 0 r
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .493 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .632 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .612 0 r
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.164 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.184 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.263 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.283 1 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.204 1 0 r
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.224 1 0 r
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.243 1 0 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
0 .664 1 r
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.204 1 0 r
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.224 1 0 r
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.243 1 0 r
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
0 .664 1 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .868 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .849 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .651 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.303 1 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .566 1 r
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .586 1 r
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .605 1 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .868 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .849 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .651 0 r
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.303 1 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .566 1 r
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .586 1 r
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .605 1 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .789 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .77 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .75 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .73 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .711 0 r
F P
s
P
p
.002 w
.74258 .41182 m .72701 .4165 L .71992 .40784 L p
1 .888 0 r
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .526 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .546 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .625 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .645 1 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .789 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .77 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .75 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .73 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .711 0 r
F P
s
P
p
.002 w
.71992 .40784 m .73554 .40311 L .74258 .41182 L p
1 .888 0 r
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .526 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .546 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .625 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .645 1 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .829 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .809 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .691 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .671 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
.322 1 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
.342 1 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .928 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .908 0 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.421 1 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.441 1 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.461 1 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .829 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .809 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .691 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .671 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
.322 1 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
.342 1 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .928 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .908 0 r
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.421 1 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.441 1 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.461 1 0 r
F P
s
P
p
.002 w
.61662 .38969 m .58588 .39927 L .57 .38149 L p
.8 g
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
.362 1 0 r
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
0 .507 1 r
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
.362 1 0 r
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
0 .507 1 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.816 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.836 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.914 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.934 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.954 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.974 1 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.57 .38149 m .60098 .37171 L .61662 .38969 L p
.8 g
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .947 0 r
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .408 1 r
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .428 1 r
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .447 1 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.382 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.401 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.48 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.5 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.52 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.816 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.836 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.914 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.934 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.954 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.974 1 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .947 0 r
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
1 0 .059 r
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
1 0 .079 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .408 1 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .428 1 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .447 1 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.382 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.401 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.48 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.5 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.52 1 0 r
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
.796 1 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
.993 1 0 r
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
1 0 .059 r
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
1 0 .079 r
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .368 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .388 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .467 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .487 1 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
.796 1 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
.993 1 0 r
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .02 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .039 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .368 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .388 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .467 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .487 1 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.855 1 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.875 1 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.895 1 0 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.658 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.678 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.757 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.776 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .987 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .967 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.82444 .36506 m .80821 .37001 L .80135 .36086 L p
.539 1 0 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .02 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .039 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.855 1 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.875 1 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.895 1 0 r
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.658 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.678 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.757 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.776 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .987 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .967 0 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
1 0 .099 r
F P
s
P
p
.002 w
.80135 .36086 m .81765 .35586 L .82444 .36506 L p
.539 1 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
.638 1 0 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
1 0 .099 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
0 .349 1 r
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
.638 1 0 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
0 .349 1 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.697 1 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.717 1 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.737 1 0 r
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .25 1 r
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .27 1 r
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .289 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.559 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.579 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.599 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.618 1 0 r
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.697 1 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.717 1 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.737 1 0 r
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
1 0 .118 r
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
1 0 .138 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .25 1 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .27 1 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .289 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.559 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.579 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.599 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.618 1 0 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
1 0 .118 r
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
1 0 .138 r
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .211 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .23 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .309 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .329 1 r
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.55662 .33242 m .54087 .33756 L .53244 .32806 L p
1 0 .158 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .211 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .23 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .309 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .329 1 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.53244 .32806 m .54825 .32287 L .55662 .33242 L p
1 0 .158 r
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .178 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .197 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .217 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .237 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 .191 1 r
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .178 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .197 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .217 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .237 r
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 .191 1 r
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .092 1 r
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .112 1 r
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .132 1 r
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .092 1 r
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .112 1 r
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .132 1 r
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
1 0 .257 r
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
1 0 .276 r
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .053 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .072 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .151 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .171 1 r
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
1 0 .257 r
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
1 0 .276 r
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .053 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .072 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .151 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .171 1 r
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
1 0 .296 r
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
1 0 .316 r
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.105 0 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
.086 0 1 r
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
1 0 .296 r
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
1 0 .316 r
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.105 0 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
.086 0 1 r
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
.026 0 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
.007 0 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .013 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .033 1 r
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
.125 0 1 r
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
.026 0 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
.007 0 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .013 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .033 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
1 0 .336 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
1 0 .355 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
.125 0 1 r
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.066 0 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
.046 0 1 r
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
1 0 .336 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
1 0 .355 r
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.164 0 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
.145 0 1 r
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.066 0 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
.046 0 1 r
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
1 0 .375 r
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
1 0 .395 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.164 0 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
.145 0 1 r
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
1 0 .375 r
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
1 0 .395 r
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
.322 0 1 r
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
.303 0 1 r
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
1 0 .493 r
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
1 0 .513 r
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
.322 0 1 r
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
.303 0 1 r
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
1 0 .493 r
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
1 0 .513 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.243 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.224 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.204 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.184 0 1 r
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.342 0 1 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .414 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .434 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .454 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .474 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.243 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.224 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.204 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.184 0 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.342 0 1 r
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .414 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .434 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .454 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .474 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.283 0 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.263 0 1 r
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.401 0 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.382 0 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.362 0 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
1 0 .533 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.283 0 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.263 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.401 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.382 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.362 0 1 r
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
1 0 .533 r
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
.421 0 1 r
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
.421 0 1 r
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
1 0 .553 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
1 0 .572 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
.461 0 1 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
.441 0 1 r
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
1 0 .553 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
1 0 .572 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
.461 0 1 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
.441 0 1 r
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.56907 .19688 m .55207 .20283 L .54306 .19182 L p
1 0 .592 r
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.54306 .19182 m .56013 .1858 L .56907 .19688 L p
1 0 .592 r
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.539 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.52 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.5 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.48 0 1 r
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .612 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .632 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .651 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .671 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .691 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .711 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .73 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.539 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.52 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.5 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.48 0 1 r
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .612 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .632 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .651 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .671 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .691 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .711 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .73 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.678 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.658 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.638 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.618 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.599 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.579 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.559 0 1 r
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .75 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .77 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .789 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .809 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .829 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .849 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .868 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.678 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.658 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.638 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.618 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.599 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.579 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.559 0 1 r
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .75 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .77 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .789 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .809 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .829 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .849 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .868 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.816 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.796 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.776 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.757 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.737 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.717 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.697 0 1 r
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
1 0 .888 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
1 0 .908 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
1 0 .928 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
1 0 .947 r
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.816 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.796 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.776 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.757 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.737 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.717 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.697 0 1 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
1 0 .888 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
1 0 .908 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
1 0 .928 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
1 0 .947 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.954 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.934 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.914 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.895 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.875 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.855 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.836 0 1 r
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.954 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.934 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.914 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.895 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.875 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.855 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.836 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
1 0 .967 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
1 0 .987 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.993 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.974 0 1 r
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
1 0 .967 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
1 0 .987 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.993 0 1 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.974 0 1 r
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00G;^l^kb`02o`03^l_o00n100Sobk_;^l^ko`<0
00?o00000P000ol0001I0000LP000ol000020004o`00oa<00olH00?o2K/3o`f100?oPH4038400onk
^`03^`?o0Tl01?nk^ol:P@?o00>1ok/01[/01?l00?l50003o`0005P0001a00;o1@02oa400olI00;o
00Zkbk_;^l^kbk_;0_l00h7oP@0=P@03oh6100R10ol01K_;^l^k00;o00Y?@Tm2Cd;o^l_o1X43o`F1
00So^l^kbk_;o`<000?o00000`000ol0001G0000R003oaT00ol9^`?o18400on1P@0<P@03oh6100B1
0ol8^`03odm?00I?00Co^k_o0X43o`V100?o^k/01;/01Ol0003o00@00_mH0000QP02o`8000?o0000
5003o`0:bk_;^l^kbk_;^`;o28400on1P@0<P@03oh6100?o00Bkbk_;0_l02k_;^l^kbom?@Tm200;o
00G;^l^kb`02o`b100Wobk_;^l^kbol00P000ol000030003o`0005H0002300?o6003o`^k0_l;P@03
oh6100b10_l4^`?o00=2ok/01[/01?m?ool7^`03oh6100b100?o^k/01K/01?l00?l50003o`0000H0
0om<0000P003oaT00_l03<^kbk_;^l^kbk_;^`;o3X400on1P@07P@?o00Fkbk_;^`02o`0I@Tm2Cd;o
bk_;^l^kboo;^l^kbk_;^l^ko`0=P@09ok_;^l^kbk_o00<000?o00000`000ol000080003o`0004T0
001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10ol8^`09od9?@Tm2Cd;o00fk0_l3^`03oh6100^1
00?o^k/01K/01?l00?l50003o`0000P000?o0000B@0007/01?lG00?o00^kbk_;^l^kbk_;^`03o`F1
00?oPH403H400on1o`02o`05^l^kbk/00_l05l^kbk_;od9?@Tm2Cd;obk_;^l^kbk_;00?o00M?ol^k
bk_o00f100Wo^l^kbk_;^ol00P000ol000030003o`0000@00om<0000N003o`@000?o00004@03o`^k
0ol9P@03oh6100f100?o^k/00k/3o`03I_nk00Fk00?o@Tl00ol:^`07odloCcm?o`03^`03oh6100N1
0ol00h7o^`06^`05o`000?l01@000ol000030003o`0004`0001f00;o6@03o`0;bk_;^l^kbk_;^l/0
0_l=P@03oh6100R10ol01L^kbk_;00;o00aV@VI2I_nkbk_;^l/2o`0>^l^kbk_;^l^kbk_;^ol6C`05
ol^kbol01H43o`F100Wobk_;^l^kbol00`000ol0000200;o1004od/0001c00?o6003o`^k0ol00h7o
P@0=P@03oh6100B10ol8^`03ofIV00EV00?o^k/02k/2o`Jk00So?dloCcm?o`>k00?oPOl00_l9P@03
ok^k00Fk00Co003o0`000ol0o`1C0000L005oaH00ol02l^kbk_;^l^kbk_;00?o1H400on1P@0<P@03
oh6100?o00C;^l^k0_l06<^kbk_;^omV@VI2IT9Vok_;^l^kbk_;^`?o00U?ok_;^l^kbol00Tl3o`05
^l^kbk/00_l=P@08ol^kbk_;^ol30003o`0000<000?o0000D00006d00olI00;o2k/3o`V100?oPH40
3842o`Bk0ol00dgo^`06^`03ofIV00?o2K/2o`Do00?o^k/01;/2o`Fk0ol00h7oP@0=P@03ok^k00Bk
00Go0000o`040003o`000500001[00;o6@03o`0;^l^kbk_;^l^kbk/00_l=P@03oh6100N10ol01l^k
bk_;^ol01FH02?nkbk_;^l^k0_l03L^kbk_;^l^kbk_;^ol01dl02_nkbk_;^l^kbk/3o`F100?oPH40
38402?o;^l^kbk_o0P000ol000030003o`0004l0001X00?o6003o`^k0ol00h7oP@0=P@03oh6100>1
0ol9^`08ofI=ITeVCOl=^`;o1[/00olo?`05?`03ok^k00>k0ol9P@03oh6100b100?o^k/01;/01?l0
0?l50003o`0004h0001U00?o00<0o`005@03o`0;^l^kbk_;^l^kbk/00ol5P@03oh6100b100?oPOl0
0_l01L^kbk_;00;o00Nkbk_;^l_o00IV00[o^l^kbk_;^l^k0ol02Too^l^kbk_;^ol2C`?o00C;^l^k
0ol=P@03oh6100N10ol02H7o^l^kbk_;o`030003o`00008000?o0000CP0004800olN00;o6@03o`Zk
0ol9P@03oh6100b100?o^k/00k/3o`03C_nk00Jk00?oI_l00_l:^`07odloCcm?o`07^`;o1;/3o`03
POn100f100?oPH401843o`F100?o^k/01;/01?l00?l500;oCP0004D000?o00006003oaP00ol02l^k
bk_;^l^kbk_;00;o3H400on1P@07P@?o00Fkbk_;^`02o`0/CFI=ITgobk_;^l^kboo;^l^kbk_;^l^k
bk_;ocm??dloConkbk_;^l^kbk/3o`F100?oPH4038400on1P@03o`V100So^l^kbk_;o`8000?o0000
0P02odh000150003o`0001D00olH00?o2k/3o`03POn100f100?oPH400h43o`Rk00WoCVI>ITiVC_l0
3K/2o`Jk00So?dloCcm?o`Fk0ol9P@03oh6100b10_l<P@03ok^k00Bk00Go0000o`040003o`0004`0
001200?o5P02o`8000?o00004`04o`0:^l^kbk_;^l^kb`?o1H400on1P@0<P@03oh7o00;o01jkbk_;
^l^kbk_;^l_oCFI=ITeVCOo;^l^kbk_;^l/3o`0;8?o;^l^kbk_;ocl00ol01L^kbk_;00;o3H400on1
P@07P@?o00>koh403H402?o;^l^kbk_o0P000ol000030003o`0004/000120003o`0001<00olH00?o
2[/3o`V100?oPH4038400onk^`0>^`03odiV00?o2[/00olP80038003ok^k00Fk00?o^k/00k/3o`03
POn100f100?oPH400h43o`Fk00?oPH402h400onk^`05^`04o`00o`D000?o0000BP0004801?l?00?o
6003o`0;^l^kbk_;^l^kbk/00_l=P@03oh6100N10ol04h7obk_;^l^kbk_;^l^kbk_;^l/00_l03[_;
^l^kbk_;^l^kbk_o1R002_o;^l^kbk_;^l/3o`F100?oPH4038400on1o`02o`0:^l^kbk_;^l^ko`f1
00So^l^kbk_;o`<000?o00000`000ol000190000DP03oaP00ol;^`?o00>1oh403H400on1P@03P@?o
1H400onk^`0F^`;o1[/00olP80048003ok^k00>k0ol9P@03oh6100b100?o^k/02k/00on1P@09P@03
oh7o00Jk00Go0000o`040003o`0004T0001@00;o0`000ol0000C00?o00[;^l^kbk_;^l^k0ol5P@03
oh6100b100?oPOl00_l9P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00?o00]>ok_;^l^kbk_o8003o`05
^l^kbk/00_l=P@03oh6100N10ol04<^kbk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003
o`0000<000?o0000B00004d00olH00?o2[/3o`V100?oPH4038400on1P@0;P@03ok^k012k00OoCFI=
ITgo00Nk00?o^k/01[/00on1P@0<P@03oh6100B10olC^`03oh6100Co1h400onk^`05^`04o`00o`@0
0_m90000BP03oaP00ol02/^kbk_;^l^kbk/3o`f100?oPH401h43o`03^l_o00f102_obk_;^l^kbk_;
^l^kbk_;^l_oCDi=CTe>ok_;^l^kbk_;^l^kbk_;^l_o00j100?oPH400ol05l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;o38402?o;^l^kbk_o0`000ol000020003o`0004L0001800;o6004o`Vk0ol3P@03
oh6100^100?oPH400h43o`Jk00?oPH402h400onk^`07^`;o1[/02?mVCFI=ITgo4;/00on1P@0<P@;o
6[/00on1P@0<P@03ok^k00Bk00Co003o1@000ol000160000A@03o`8000?o00004`03o`09^l^kbk_;
^l^k00?o1h400on1P@0;P@03oh7o00;o00^kbk_;^l^kbk_;o`0=P@06ol^kbk_;0ol02dgobk_;^l^k
bom=00?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`V10ol07h7obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^ol03H402Onkbk_;^l^ko`020003o`0000<000?o0000A@0004800ol60003o`0000l00ol9^`?o
2h400on1P@0;P@03ok^k00bk00?oPH401X43o`Jk00OoITeVCFKo00Nk00?o^k/05K/00on1P@03P@?o
1H400onk^`0J^`03oh6100^100?o^k/01;/01Ol0003o00@000?o0000A@0004000_lH00?o00Vkbk_;
^l^kbk/00ol00h7oP@0<P@03oh6100J10ol04/^kbk_;^l^kbk_;^l^kbk_;o`F10_l07[_;^l^kbk_;
^omVCFI=ITgobk_;^l^kbk_;^l^kb`;o01:kbk_;^l^kbk_;^l^kbk_;oh43o`V101gobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;o`0>P@08ok_;^l^kbol20003o`0000<000?o0000A00003d00olG00Co
2;/3o`F100?oPH402h400on1P@03P@;o5K/00on1o`02o`Bk0_l6^`08odeVCFI=I_l9^`?o00<Qok/0
4;/00on1P@0;P@03ok^k01Vk00?oPH401h43o`03POnk00Jk00Co003o1@000ol0000M00Go00D0oooo
0003o`<00_lD0000>P03o`<000?o00004P03o`08bk_;^l^kbk/3o`V100?oPH402h400on1o`02o`03
^l^k00Co01K;^l^kbk_;^l^kbk_;^l^kboo;^l^k0ol02fI=ol^kbk_;^omV00?o00Vkbk_;^l^kbk/0
0_l05b0Q824Pol^kbk_;^l^kbk_;^l^kbk_o00j101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`F100Sobk_;^l^ko`<000?o00000P02oah000?o00000P001?l00?l40004o`00oaD0000g00?o
6003o`Vk0_l=P@03oh6100V100?oPOl00k/3o`05C4e<COl05;/00om=C@04C@03ok^k00Bk00?o^k/0
2[/02OlQ824P8B0Qo`0@^`03oh6100b100?o^k/06;/00on1P@03o`V100?o^k/01;/01Ol0003o00@0
00?o000070000ol0000300?o0P02o`<000?o00004`0003D00_lH00Co00Rkbk_;^l^kb`?o0X400on1
P@0;P@03oh6100B11?l0DK_;^l^kbom=C4e<CDa=ol^kbk_;^l^kbk_;^l^kbk_;^l^kofI=ITeVCOo;
^l^kbk_;^l^kbk_;^l^kbk_;ob0Q824P8B3obk_;^l^kbk_;^`04o`03bk_o00j101_obk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk/00_l=P@08ol^kbk_;^ol20003o`0000<000?o00006`05o`<000?o0?l0
1@000ol0000C0000<P05oaH00ol9^`;o1X400on1P@0;P@03oh6100?o1;/2o`Fk00WoCDa=C4e<COl0
2k/3o`Jk00?oCOl00_l4^`;o4;/00olQ8003o`Vk0ol01B4P8B3o00:k00?oPH401h43o`03POnk01Vk
00?oPH4038400onk^`05^`04o`00o`D000?o00006P000ol0000300;o0`03o`040?oooa@0000A00;o
7003oaP00ol02K_;^l^kbk_;^`03o`V100?oPH402h42o`04bk_;^`?o00]=ok_;^l^kbom=C003o`0:
^l^kbk_;^l^kb`?o0dd03?o;^l^kbk_o^l^kb`?o01>1ol^kbk_;^l^kbk_;^l^kbk_;00;o01Rkbk_;
^l^kbk_;^l_o8B0Q824P8Oo;^ol5P@?o1H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol>P@08
ok_;^l^kbol30003o`00008000?o00006P000ol0000=0003o`0001<0000@0004o`00oaT00_lH00?o
2[/2o`f100?oPH401X43o`Jk00?oCDd00dd00onk^`04^`;o3;/00om=C@05C@03ok^k00Jk0_l5P@03
ok^k01Jk0_l5^`09ob0Q824P8B3o00:k00?oPOl00_l9P@03ok^k01Rk00?oPH4038400onk^`04^`04
o`00o`D000?o00006@05ob40000@0004o`00oaH00olG00Co00W;^l^kbk_;^l/00ol2P@03oh6100^1
00?oPH400h42o`0Vbk_;^l^kbk_;oda=C4e<COnkbk_;^l^kbk_;^l^kbk_;^l^kbol7C@05ol^kbk/0
0ol8P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00?o00/Pok_;^l^kbolQ8003o`06^l^kbk_o3H407?nk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol7P@Co0X402Oo;^l^kbk_;o`020003o`0000<000?o0000
?P00010000Co003o4`03o`8000?o00004`03o`Zk0_l6P@03oh6100^100?oPOl00_l<^`03ode=00A=
00?o^k/02K/3o`Jk00?oCDd00ol5^`03oh6100Z100?o^k/03k/2o`DQ00?o^k/01;/2o`Rk00?oPH40
2h400onk^`0I^`03oh6100Co1h400onk^`04^`05o`000?l00`02od00000@0004o`00oa400_lH00?o
00[;^l^kbk_;^l^k0ol9P@03oh6100^101?o^l^kbk_;^l^kbk_;^l^kbom<00?o00[;^l^kbk_;^l^k
0ol02Ta=C?nkbk_;^l/2o`09^l^kbk_;^l_o00f101;obk_;^l^kbk_;^l^kbk_;^ol7800Bok_;^l^k
bk_;^l^kbk_;^l_o3H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`b100Sobk_;^l^ko`80
00?o00000`000ol0000600?o1002obh0000A00;o3`03oaL01?l9^`?o3H400on1P@06P@?o4k/00onk
^`0;^`03ode=00A=00?o^k/03[/00on1P@0;P@03ok^k00jk00?o8B401B400onk^`08^`?o0k/00on1
P@0;P@03ok^k01Rk00?oPH4038400onk^`04^`04o`00o`D000?o00001P000ol000020004o`00obd0
000O00Co5`03o`09^l^kbk_;^l^k00?o18400on1P@0:P@03oh6100>10_l07L^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;o01nkbk_;^l_oCDa=C4e<ok_;^l^kbk_;^l^kbk_;^l_o00f101;obk_;
^l^kbk_;^l^kbk_;^ol280?o00W;^l^kbk_;^l/00ol0224_8Oo;^l_o2843o`0NPOnkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_o3H402Onkbk_;^l^ko`020003o`00008000?o00001P000ol000020004
o`00obd0000L00?o10000ol0000A00?o2K/3o`R100?oPH402X400on1o`02o`Bk0_lF^`?o0Td00onk
^`04^`03odgo00;o4k/00on1P@06P@?o00>1ok/04;/2o`bk00?o8B4012401?nk^ol5P@?o1H400onk
^`0I^`03oh6100^100?o^k/01;/01?l00?l50003o`0000D000?o00000P001?l00?l]00006P02oaP0
0ol02K_;^l^kbk_;^`03o`b100?oPH402X401Onkbk_;00?o01Q<COnkbk_;^l^kbk_;^l^kbk_;^l^k
bol6C00Pok_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol5P@;o1H406?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`;o01;;^l^kbk_o;b4_8BlQol^koh43o`V101go^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^ko`0;P@0:oh7o^l^kbk_;o`8000?o00000`000ol000040003o`00008000Co003o;@0001L0
0olG00Co2;/3o`:100?oPH402h400on1P@04P@?o1[/00om<C004C003ok^k01:k00?oCDd014d00onk
^`0L^`03oh7o00;o28400onk^`0A^`?o00<_ok/01[/00olQo`02o`Fk00?oPH402h400onk^`0H^`03
oh6100F11?l2P@03ok^k00Fk00Co003o1002o`@00_l500;o;P0001@00ol00`3oo`0E00?o00W;^l^k
bk_;^l/00_l6P@03oh6100^100?oPH400ol00k_;^`02o`0Ibk_;^l_oC4e<CDa=ok_;^l^kbk_;^l^k
b`02o`07^l^kbk_;o`03C0;o01i<ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`b101?o^l^k
bk_;^l^kbk_;^l^kbk_o00D_01;o^l^kbk_;^onkbk_;^l^kbol=P@0Mol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol00X44o`N100Sobk_;^l^ko`<000Ko003o0?lk00004`02o`D000?o00003`03o`Vk
0ol9P@03oh6100^10_l3^`?o00=<ok/01K/00om<o`02o`^k0ol00de<o`06^`?o7;/4o`>100?oPH40
2X400onk^`0?^`07oblQ;b4_o`0@^`03oh6100^100?o^k/06K/2o`b100?o^k/01;/01?l00?l50003
o`0003P0000C0003o`3o01<01?l02K_;^l^kbk_;^`02o`f100?oPH401X43o`19^l^kbk_oS4b<C8co
^l^kbk_;ol^kbk_;^l^kbk_;^l_oC4e<CDa=ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^`03o`R100?oPH402X404onkbk_;^l^kbk_;^l^kbk_;^ol00bl05?l_ok_;^l^kbk_;^l^kbk_;^l_o
3H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o008000?o00000P000ol0
000h00004`001?l00?l?00Co2K/3o`:100?oPH402h400on1P@03P@;o2;/00om<C004C003ok^k00^k
0_l5^`08ode<CDa=C?lM^`?o38400on1P@0:P@03ok^k00nk0olD^`03oh6100B11?l2P@03ok^k01Vk
00?oPH402h400onk^`04^`05o`000?l010000ol0000g00004`001Ol0003o00`00ol02[_;^l^kbk_;
^l/2o`J100?oPH402h400on1o`02o`0Lbk_;^l^kbk_;^l_oC8a<S4b<ok_;^l^kbk_;^`?o00Y=ok_;
^l^kbom<0ol07<^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`03POn100f100?oPH401843o`0]
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:10ol7P@0Mok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol03H402?nkbk_;^l_o0P000ol000030003o`0003H0000C0003
o`00008000?o00001P03o`Zk0ol9P@03oh6100^100?o^k/03K/00om<o`02o`Zk00OoCDa=C4go00Jk
00?o^k/06k/2o`F100?oPH4038400on1P@03oajk0_l@^`;o2h400onk^`0I^`03oh6100J10ol00h7o
^`06^`04o`00o`D000?o0000=@0001<000?o00000`000ol0000200Co00W;^l^kbk_;^l/00ol=P@03
oh6100J10ol0B;_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;oda=C4e<COnkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o28400on1P@0<P@;o01jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`0C;b7o^l^kbk_;^l^kbk_;^l^ko`0=P@0Lok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;o`F10ol5P@09ol^kbk_;^l_o008000Co00000_lg00004P000ol000050003o`3o00;o2K/3o`B1
00?oPH402X400on1P@03P@;o7K/2o`Fk00SoC4e<CDa=oabk0ol<P@03oh6100N10olP^`08ob8Q8R4R
8Ol?^`03oh6100^100?o^k/06;/00on1o`02o`V100?o^k/01;/01?l00?l50003o`0003@0000B0003
o`0000@00ol02L^kbk_;^l^kb`03o`R100?oPH402X400on1o`02o`0Lbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`?o00Z<C?o;^l^kbom<0ol06l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`>1
00?oPH402X400on1P@03P@?o01bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0_l07[_;^l^kob4_
8BlQ;b7o^l^kbk_;^l^kbk_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o3H402?o;
^l^kbk_o0P000ol000030003o`0003<0000B0004o`0000?o10000onk^`03^`;o38400on1P@0:P@03
ok^k01bk00?oS8`018`00onk^`03^`03ok^k01Vk0ol7P@03oh6100Z100?oPOl00_lL^`?o00<_ok/0
1K/00olQ8P03oa:k00?oPH401X43o`03POnk01Vk00?oPH402h400onk^`05^`04o`00o`@000?o0000
<`0001801?l80007ok_;^l^ko`0=P@03oh6100B10ol0Al^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_oS4b<C8a<ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o2h400on1P@0:P@0/
ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbolR8B8Q8_o;^l^kbk/2o`0Gbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^ol01H42o`F101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o3H402?nkbk_;^l_o
0P000ol000030003o`000380000B00;o2`000onk^`03^`03oh6100^100?oPH400olM^`?o1[/00on<
o`02oabk0ol00h7oP@0<P@03oh6100B10olR^`03obl_00<_00?o^k/07;/00on1o`02o`R100?o^k/0
6;/00on1P@0;P@03ok^k00Bk00Co003o1@000ol0000a000050000ol000090007ok_;^l^ko`0=P@;o
01g;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`=<02Gobk_;^l^kok_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^k00;o1H400on1P@0;P@03oh6100?o04Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbolR8B;o8_o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o38407?o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol6P@Co0X402Oo;^l^kbk_;o`020003o`0000800_lb0000
5@000ol000090003ok^k00>k00?oPH401X43o`>100?o^k/06k/00on<S003S003ok^k00Zk0_lB^`?o
28400on1P@0;P@;o:[/3oa^k1?l2P@03oh6100Z100?o^k/06K/00on1P@03o`N100?o^k/01;/01Ol0
003o00@000?o0000<00001H000?o00002@001onkbk_;^ol01H42o`N101oobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l_o00=<00_oC?o;^l^kbk_;^`03o`0DS?nkbk_;^l^kbk_;^l^kbk_;^ol<P@03
oh6100J10ol0B87o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`?o1h400on1P@0:P@0Lok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^`;o2h402?o;^l^kbk_o0P000ol000030003o`0002l0000G0003o`0000T00_l4^`03oh7o00;o
2X400onk^`0K^`?o2[/00om<C003C003ok^k00nk00?oPH402X400on1P@03P@;o1H400onk^`0_^`;o
3k/3o`^100?oPH4028400on1o`0J^`03oh6100Z100?o^k/01K/01?l00?l40003o`0002l0000H0003
o`0000X000Kobk_;^ol>P@0]ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_o00B<01?o^l^kbk_;^l^kbk_;^l^kbk_o00b100?oPOl00_l8P@0^ok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o00h_ok_;^l^kbk_;^l^kb`?o00>1oh4038400on1
P@04P@?o01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00b100Wo^l^kbk_;^ol00P000ol0
00020003o`0002h0000I0003o`0000X000?o^k/00k/00on1P@0;P@03ok^k02Vk00KoC4coC?lA^`03
oh6100Z100?oPH402X400onk^`0Y^`07oblR;b8_o`08^`?o1H400on1P@0;P@03oh6100?o8[/00on1
P@0:P@03ok^k00Bk00Co003o1@000ol0000]00006P02o`/000Oobk_;^l_o00f102cobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`>100?oPH402X409?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o017;^l^k
bolR;b8_8Roo^l^kb`03o`V100?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00N10ol02X7obk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k
0_l8P@;o0X400onk^`10^`03oh6100?o1h400on1P@0:P@03ok^k01fk0ol00b8Oo`05^`03ob;o00;o
0k/3o`f100?oPH401X43obVk00?oPH400h42o`F100?o^k/01K/01?l00?l300;o;P0001d000?o0000
2@002?o;^l^kbk_o1843o`F1033obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`0@bk_;^l^kbk_;^l^kbk_;^`;o2h400on1P@0:P@0Ook_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^ko`068P0:ol^kbk_;ol^kb`?o0h400on1P@0:P@03oh6100>10ol0;k_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^on100?o28402?o;^l^kbk_o0P000ol0
00030003o`0002/0000N0003o`0000T000?o^k/01;/01?n1ool9P@03ok^k02Vk0ol3S003ok^k00jk
00?oPH402X400on1P@04P@?o8K/02?lR7b8O8Qoo1K/3o`N100?oPH402X400on1o`02oc6k00?oPH40
2X400onk^`04^`04o`00o`D000?o0000:P0001l000?o00002@002?o;^l^kbk_o3840;?o;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X`04_o;^l^kbk_;^l^kbk_;^l^ko`b1
00?oPH400ol07;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`08bk_;^l^kob83o`05^l^kbk/0
0_l;P@03oh6100Z103Ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol=P@08ol^kbk_;^ol20003o`00008000?o0000:P00020000?o00002@02o`Fk00?oPH40
2X400onk^`0Q^`;o1K/00on<S004S003ok^k00jk00?oPH402X42oabk0ol011lR7ol6^`03ok^k00Jk
00?oPH402h400on1P@04P@?o6[/2oaRk0_l2^`03oh6100^100?o^k/00k/01Ol0003o00@000?o0000
:@0002400_l;0007ok_;^l^ko`0<P@0Pol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`:<
00So^l^kbk_oS0?o01Bkbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol0><^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbolR7b8O8_o;^l^kbk_;^l^kbk_;^l_o3H400on1P@03o`0J^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/3o`0Gg_o;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol01]kobk_;o`R10ol02H7o
^l^kbk_;o`020003o`0000<000?o0000:00002<000?o00002@000onk^`03^`03oh6100Z10_lL^`08
oha<S4b<C?l5^`03ok^k01Fk00?oPH400olU^`07oalR7olOo`0?^`03oh6100^10_lL^`07omkOg]oN
o`0C^`07omiagW7No`02^`03oh6100>10ol5P@03ok^k00Bk00Co003o0`02obX0000T0003o`0000T0
00Oo^l^kbk_o00J10ol4P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1X`03?nkbk_;^l^k
bk_;^`;o013;^l^kbk_;^l^kbk_;^l^k0_l05/^kbk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0@^l^kbk_;
^l^kbk_;^l^kb`?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`J11?l2P@0aok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^komoNgmkOok_;^l^kbk_;^l^kb`02o`0A^l^kbk_oLMiagW7Nol^koh400ol9P@08
ok_;^l^kbol20003o`00008000?o00001@03o`<00olI00009@000ol000090003ok^k00>k00?oPH40
0ol8P@03ok^k01Zk00?oS?l00_l:^`?o00?6S?l09;/3o`:100?o^k/09K/00on1P@03o`N100?o^k/0
6k/01ooOg]oogol02;/3o`03gW7o00Fk00?oLOl00_l5^`03oh6100Z100?o^k/01;/01?l00?l50003
o`0000D000?o00001@000ol0000F00009P000ol000090006ok_;^l^k0_l<P@1Bok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kolJ<aXc6S?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^`?o1X405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`0?bk_;^l^kbk_;^l^kbk_;00;o
2h407_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`?o00^kbk_;^l^kbk_;o`06gP0@ok_;^l^k
ok_;^l^kbk_;o`f100Sobk_;^l^ko`8000?o00000P000ol000050003o`0000D000?o00005P0002L0
00?o00002@000onk^`04^`03oh6100Z100?o^k/09k/02?o6S<J<aXco6k/4o`Z100?o^k/03[/3o`<R
00?o^k/03[/00on1P@0:P@03ok^k02Nk00WoLMiagW7NLOl02k/2o`03^on100b100?o^k/01;/01?l0
0?l40003o`0000@000?o00000P03oaT0000X0003o`0000T00_l01/^kbk_;o`b102co^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_oaP?o01Zkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`?o0X400on1P@0:P@0Yol^kbk_;^l^kbk_;^l^kbk_o8QlR7b;o^l^kbk_;^l^kbk_;^l^kbol0
38402Onkbk_;^l^kb`02o`0F^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co00Jkbk_;^ol2gP?o00[;^l^k
bk_;^l^k0ol01Mko^l_o00R10ol02H7o^l^kbk_;o`020003o`0000800_l50003o`00008000?o0000
6@0002T00_l;0003ok^k00>k00?oPH402X400onk^`0W^`03ok^k01Rk0ol6P@03oh6100Z100?o^k/0
3[/01olR8R;o8_l02[/3o`>k00?oPH402X400onk^`02^`?o00?Nok/04[/3o`?O00?o^k/01;/2o`^k
0_l5gP04ok^ko`F10_l5P@03ok^k00Bk00Co003o0P000ol0o`0400;o1004oaP0000[0003o`0000T0
00Oobk_;^l_o00J10ol3P@0`ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l04<^kbk_;^l^kbk_;^l^kbk/2o`Z100?oPH4028404on1ol^kbk_;^l^kbk_;^l^kbk/0
0ol02[_;^l^kbk_;^l/3o`<O00Gobk_;o`06P@?o0X401Oo;^l_o00GO03[obk_;^l^kbk_;^l^kbk_;
^l^kbooOWmnOgoo;^l^kbk_;^l^kbk_;^l^kbk_ogW7NLMiag_nkbon10ol8P@08ok_;^l^kbol20003
o`00008000?o00008`0002`000?o00002@000onk^`03^`03oh6100?o1h400onk^`0Y^`?o0/000onk
^`0>^`03oh6100V100?oPH401843o`>100?o^k/06k/01olO8QlR7ol00k/00on1P@03o`J100_o^k_o
gmkOg]oNo`0:^`?o1[/01ooOgmoogol04[/00ooNgP03o`Fk00?oPH402H400onk^`04^`04o`00o`D0
00?o00008P0002d000?o00002@001_o;^l^kb`;o2h40:onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol01/H04_o;^l^kbk_;^l^kbk_;^l^ko`^100?oPH400ol7P@0Eol^kbk_;
^l^kbk_;^l^kbk_;^l^k00?o00Nkbk_;^l_o00<O00Co7oo;1?l:P@05ol^koml00ol02K_;^l^kbk_;
^`03o`?O00Oo^l^kbk_;00?o01K;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l02L^kbk_;^l^ko`0<P@08
ol^kbk_;^ol20003o`0000<000?o00008@0002h000?o00002@000onk^`04^`03oh6100V100?o^k/0
8;/2o`Fk00?o`<001<000onk^`0>^`03oh6100V10_l;P@03ok^k00jk0ol011lR7ol6^`Oo0U/00on1
P@0:P@04ok^ko`bk00?ogml01=l00onk^`0S^`;o0[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0
000Q0000;`000ol000090008ol^kbk_;^ol;P@0Pok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/2o`0:a/3o^l^kbk_oaP?o01Bkbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol2P@03oh6100Z101gobk_;
^l^kbk_;^l^kbk_;^olR7b8O8_nkbk_;^`03o`MK00?oPH402X402Oo;^l^kbk_;^`02o`06bk_;^l_o
0ml2o`0;gonkbk_;^l^kbk/01?l05<^kbk_;^l^kbk_;^l^kbk_;^l^k0ol01W7o^l^ko`N10ol02X7o
^l^kbk_;^ol20003o`00008000?o00008000030000?o00002@02o`Fk00?oPH402H42oabk00Oo`<K0
a/3o00Fk00?o^k/05K/00on1P@03o`J100?oPH402X400onk^`0>^`07oalR7olOo`02^`;o2e/00on1
P@08P@03oh7o00Bk0ol00moo^`05^`?o2[/3o`05WmnOgol04[/00ooNgP03gP04ok^ko`F10_l5P@03
ok^k00Bk00Co003o0`000ol0o`0Q0000<@02o`/000Oo^l^kbk_o00J10ol3P@0_ol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_o`<K0a/3o^l^kbk_;^l^kbk/00_l04<^kbk_;^l^kbk_;^l^kbk/2o`Z1
00?oPH402X404Oo;^l^kbk_;^l^kbk_;^l^k00?o00Nkbk_;^l_o00aK00?oPH401843o`:101ko^l^k
omkOg]oNok_;^l^kbk_;^l^kbk_;^l^kbol7g`0;ol^kbk_;^l^kbk/00_l01/^kbk_;o`Ia00Go^l_o
P@03o`R100So^l^kbk_;o`8000?o00000P000ol0000O0000<`000ol000090003ok^k00>k00?oPH40
0ol7P@03ok^k01Zk00Co`?oo2[/3o`;600?o^k/03K/00on1P@0:P@03oh6100B10olM^`03oe]K00YK
00?oPH400ol6P@04ok^ko`KO00?o^k/04;/00ooOW`03o`Vk0ol2L@03ok^k00>k00?og_l00_l5^`03
oh6100Z100?o^k/01;/01?l00?l40003o`0001h0000d0003o`0000T000Ko^l^kbk/2o`^1047obk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^onkbk_;^l^kbk_;^oo6`<K0a/3obk_;^l^kbk_;^l^kbk_;
o`0<P@03oh6100?o02;;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o35/2o`Z100Go^l_o
g`03o`0Ebk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o00bkbk_;^l^kbk_;^ol6g@0@ol^kbk_;ol^kbk_;
^l^ko`f100Oo^l^kbk_o008000?o00000`000ol0000M0000=@000ol000090003ok^k00>k00?oPH40
2X400onk^`0W^`03olK600?600?o^k/03K/00on1P@08P@04oh7oobFk00?oFe/015/3o`:k00?oPH40
2X401?nk^olO^`;o1;/00omaL@05L@03ok^k00Nk0ol2^`03oh6100^100?o^k/00k/01?l00?l40003
o`0001d0000f0003o`0000T000Oo^l^kbk_o00b102[obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l/3o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol6P@?o0h40:?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol2F`?o00Nkbk_;^l_o00b100So^l^kbk_;^`?o01Bkbk_;
^l^kbk_;^l^kbk_;^l^kb`?o00SOol^kbk_;o`;M0ol02;_;^l^kbk_;0ol01g7Nok_;^ol01X44o`:1
00Sobk_;^l^ko`8000Co00000_lN0000=`000ol000090003ok^k00>k00?oPH402X42ocjk00?oPH40
0ol7P@03ok^k02Bk0_l:^`03oh6100R100?oPOl00k/3o`:O00?o^k/04K/01ooOWmnOgol01K/2o`^k
00OogW7NLMko00>k00?oPH400ol7P@03ok^k00>k00Co003o1@000ol0000K0000>002o`X00_l01L^k
bk_o00J10ol4P@0]ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o
00o;^l^kbk_;^l^kbk_;^l/00_l;P@0dok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;o`J10ol01k_;^l^kbol01Il0=oo;^l^kbk_;^l^kbk_;^l^kbk_o4MlAga7O
ol^kbk_;^l^kbk_;^l^kbk_;^ooNLMkog_nkbk/00_l;P@07ol^kbk_;o`020003o`00008000?o0000
6`0003X000?o00002@000onk^`02^`03oh6100?o28400onk^`0V^`?o00C0c<3o3k/00on1P@0:P@03
ok^k032k00?oPH400ol3^`;o1K/01onOWiooWol02[/3o`Fk00?oWol00_lE^`?o1[/00on1P@0:P@03
ok^k00Bk00Co003o10000ol0000J0000>`000ol000090005ol^kbk/00_l<P@0Zok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1L`04Oo;^l^kbk_;^l^kbk_;^l_o00b103?o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l00k_;^`03o`08
Wonkbk_;^l/3o`0:bk_;^l^kbk_;^`?o02fOgioo^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbol038402_nkbk_;^l_o0?l50003o`0001T0000l0003o`0000T000?o^k/00k/00on1
P@0:P@03ok^k01fk0ol6^`07ol3<`?o0o`0?^`03oh6100Z100?o^k/0<[/2o`06gioOWmoo4[/02?nO
gioOWmoo2[/2oabk00?oPH4028400on1o`05^`04o`00o`@000?o00006@0003d000?o00002@001_o;
^l^kb`;o2h407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o00[<`<co^l^kbk_;0ol05<^k
bk_;^l^kbk_;^l^kbk_;^l_o1X43o`>103Oo^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00FO00[o^l^kbk_;^l^k1?l01l^kbk_;oml00ol02L^kbk_;^l^k
b`03o`0OUG7o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l0
0002oaX0000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0J^`03ol3000;000?o^k/0
2[/2o`jk00?oPH400ol7P@03ok^k03>k0ol9^`?o00DAWa6Oo`05^`03ok^k00Vk00?oLG4017400onk
^`0I^`03oh6100?o1h400onk^`04^`04o`00o`@000?o00005`0003l000?o00002@002?o;^l^kbk_o
0X43o`J102_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo0c?o<ok_;^l^kbk_;00?o0/`03onk
bk_;^l^kbk_;^l^kb`02o`^106co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o4IlAWa6Ool^kbk_;^l^kbk_;^l^kbk_;^omaUG6ELOnk
bk_;^l^kbk/3o`0?^l^kbk_;^l^kbk_;^l^k00;o2h401oo;^l^kbol00P000ol000030003o`0001H0
001000;o2P000onk^`04^`;o2X400onk^`0J^`;o2[/00oo<c004c003ok^k00bk00?oPH402X400onk
^`0o^`03oa7o00;o5K/3o`Vk0ol00mfEo`0?^`03oh6100Z100?o^k/01;/01?l00?l40003o`0001H0
00120003o`0000P00_l01[_;^l^ko`^102[o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol6c00@ok_;^l^kbk_;^l^kbk_;o`b107ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;oiEaUG6Eol^kbk_;^l^kbk_;^l^kbol<P@08ok_;^l^kbol20003o`000080
00?o00005@0004<000?o00002@000onk^`03^`03oh6100V100?o^k/09[/00oo<o`02oa6k00?oPH40
1843o`:100?o^k/0AK/2oaJk0ol5^`07oiGMUOnEo`0?^`03oh6100R100?oPOl01K/01?l00?l50003
o`0001@000140003o`0000T000Oo^l^kbk_o00^10_l0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0X43o`J102gobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l04l^kbk_;^l^kbk_;^l^kbk_;^l/00ol05A7o
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`09UG7o^l^kbk_;00?o01?;^l^kbk_;^l^kbk_;^l^kbk_o00J1
1?l2P@08ol^kbk_;^ol20004o`0000;o5P0004D000?o00002@000onk^`03^`03oh6100B10ol3P@03
ok^k02Zk0_l?^`;o2X400onk^`0V^`?o11400onk^`0?^`07oa6O4IlAo`0B^`07og7MLMeao`0K^`03
oh6100?o1h400onk^`04^`04o`00o`@000?o00004`0004H000?o00002@001onkbk_;^ol00X43o`N1
01?obk_;^l^kbk_;^l^kbk_;^l^k00Co01?;^l^kbk_;^l^kbk_;^l^kbk_;00;o0/`04Oo;^l^kbk_;
^l^kbk_;^l_o00^103_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^olA5a4G
4AOobk_;^l^kbk_;^`02o`0nbk_;^l_o4IlAWa7obk_;^l^kbk_;^l^kbk_;^l^kog6ELOmaok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/4o`^100[obk_;^l^ko`3o0`03oa@000170003o`0000T000?o^k/0
0k/2o`^100?o^k/03;/3o`05`<c0c?l04K/01oo<3L`=c?l03k/00on1P@09P@03ok^k02Jk00?o4Ol0
0_l9^`?o00<Aok/01K/3oaJk0olI^`?o0X400on1P@0;P@03ok^k00>k00?o00000ol20003o`000180
001800;o2P002?nkbk_;^l_o2h408Oo;^l^kbk_;^l^kbk_;^oo<3L`=c0gobk_;^l^kbk_;^`02o`06
bk_;^l_o1L`04Oo;^l^kbk_;^l^kbk_;^l_o00^10_l0=;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^onkbk_;^l^kbk_;^ol54@0Uok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kb`02o`0A^l^kbk_;^l^kbk_;^l^kbk/00ol6P@03oh6100^100Kobk_;^l/2o`030?l00080
00?o00004P0004X000?o00002002o`Fk00?oPH402H400onk^`0<^`03ol3o00;o2K/3o`033Lco00Fk
0olC^`03oh6100B10ol3P@03ok^k02Zk0_l5^`03oa4A00<A00?o^k/07[/3o`03g?nk00bk1?l:P@03
oh6100B11?l9^`03o`3o00<000?o00004P0004/000?o00002@001oo;^l^kbol01X43o`:101cobk_;
^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_o1/`07Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:1
0ol7P@0Cok_;^l^kbk_;^l^kbk_;^l^kb`03o`0Cbk_;^l^kbk_;^l^kbk_;^l^kb`03o`8G00Ko^l^k
bk/3o`0S^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol01ID02_o;^l^kbk_;^l/3o`:1
00?oPH402X400on1P@03o`08^l^kbk_;^l/3o`D000Co003o500004`000?o00002@000onk^`03^`03
oh6100?o1X400onk^`0A^`?o1K/01oo<3L`=c?l06k/2o`^100?o^k/03;/3o`=O00?o^k/03k/02?lA
5a4G4AOo8k/2o`Fk00Oog9GLUMco00Fk0ol6P@03oh6100Z10_l7^`Co2@001?l00?lC0000C@000ol0
00090006ol^kbk_;0_l:P@0@ol^kbk_;^l^kbk_;^l^kb`?o0Pd01onkbk_;^l/00ol08<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o38403onkbk_;^l^kbk_;^l^ko`06G`0;ol^kbk_;^l^kbk/0
0_l01l^kbk_;^ol01AL08?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol029Go^l^kbk_;
0ol01<^kbk/4o`Z100?oPH401843o`08bk_;^l^kbk/3o`h000?o0?l04`0004h000?o00002@000onk
^`03^`03oh6100V100?o^k/03K/00oo<c002c003ok^k02Jk00?oPH402X400onk^`0;^`03oeoo00;o
2[/2o`03Gaoo00Jk0olQ^`07ombEg9GLo`07^`Go0X400on1P@0:P@03oh6100?o1k/4oa4000?o0?l0
4`0004l00_l:0007ol^kbk_;o`0;P@07ol^kbk_;^`03o`07^l^kbk_;o`023@0/o`go^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol6P@?o0X407Oo;^l^kbk_;^l^kbk_;^onkbk_;
^l^kbk_;^l_o00DO02Cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/2o`0=^l^kbk_o
UMbEg9Go^`05o`R100?oPH402X42o`07bk_;^l^kb`03oaH00_lC0000D@000ol000080003ok^k00>k
00?oPH402H42o`:k0_l010g<3Ol6^`;o;;/00on1P@03o`J100?o^k/04K/3o`Fk00Oo7elOGaoo00Vk
0olC^`?o00?Lok/01K/3o`04^oooo`:100?oPH402H400on1P@04P@?o1k/4oaP00olC0000DP000ol0
000800;o00Fkbk_;o`06P@?o0h401?nkbol43@0<ok_;^l^kbk_;^l^k0_l09l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`Z1013obk_;^l^kbk_;^l^kbk_;0ol27`07ok_;^l^k
b`03o`09bk_;^l^kbk_;00?o0n`07oo;^l^kbk_;^l^kbk_;^l^kbooLUMbEg?o;^l^kbk/00ol6P@03
oh6100V100?oPH400ol01k_;^l^kbk/00olI00?o5P0005<000?o00002@000onk^`02^`03oh6100?o
1h402Onk^oo<3Ol=o`08^`;o0Pd00onk^`0T^`03oh6100Z100?o^k/03;/01olOGamO7ol02k/2o`Bk
00?og=`01=`00onk^`07^`?o1K/02?oLUMbEg?nk1?l:P@03oh6100N100CoPOoo1[/4oaP01?lI0000
E0000ol000090005ok_;^l/00_l;P@03ok_;00;o03Rkbk_;^l^kbk_;o`fe3KD=ol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`b100Oobk_;^l^k00Co00G;^l^ko`037`0:oaoo^l^k
bk_;^`?o00UO7oo;^l^kon`00ol02;_;^l^kbk_;0ol3g006ol^kbk_;0ol01<_oool2P@03oh6100V1
00?oPH401843o`07bk_;^l^kb`03oaT00olM0000E@000ol000090003ok^k00>k00?oPH402H400onk
^`05^`;o1K/00ol=3@033@03ok^k02Bk00?oPH4028400on1o`02^`?o00DOGamOo`04^`?o2K/00olO
7`047`03ok^k00:k00?o^k/02[/00ooLg003g003ok^k00>k0ol6P@03oh6100V100?oPH400ol6^`Co
6004ob00001F0003o`0000T000Oo^l^kbk_o00^10_l00l^kb`02o`8=00Kobk_;^l/3o`0[bk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@?o01S;^l^kbk_oGamO7elOol^k
bk_;^l^kbk/2o`0Ebk_;^l_o7elOGaoobk_;^l^kbk_;00?o00K;^l^kbol3g003omco00Co2X400on1
P@07P@0:oh7ool^kbk_;^`?o6004ob@0001G00;o2P000onk^`03^`03oh6100B10ol3P@03ok_o00D=
00?o^k/0<;/00on1P@03o`:k0ol5^`03oaoo00;o2K/3o`03k?nk00Fk0ol9^`?o0m`00onk^`03^`Ko
0X400on1P@09P@03oh6100B10ol6^`Co6003obP0001I0003o`0000P000Oo^l^kbk_o00:10ol7P@03
ol_o00D=00[obk_;^l^kbk_;1?l09K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/0
0_l00l^ko`02o`>g03Ko^l^kbk_o^l^kbk_;^l^kbk_og>cLk=co^l^kbk_;^l^kbk_;^l^kbk_ok=c/
g>cLol^kbk/3o`J100?oPH402H400on1P@03o`06^l^kbk_;0olH00Co:`0005X000?o000020000onk
^`03^`;o2h400onko`02o`Vk0ol01@fe3KGo02Rk00So]kJg][Nfo`Vk0ol5^`03onc/00?/00?o^k/0
1k/3o`Fk00?og?l00_l3^`?o2X400on1P@07P@04oh7oo`Fk1?lH00?o;`0005/000?o00002002o`06
bk_;^l_o2h403oo;^l^kbk_;^l^kbk_;o`063@0Qok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00Co00Jkbk_;okL3o`03bk_;00?o00?;^ol00_l02ElOol^kbk_;^`03o`09^l^kbk_;^l^k00?o
0b<02_nkbk_;^onkbk/3o`:100?oPH402H401?n1PH45o`06bk_;^l^k0olH00Co<P0005`000?o0000
2@000onk^`03^`03oh6100V100?o^k/02k/00ol=o`02ob2k0_l4]P03ok^k00:k00Co^k^k0ol3P@04
ok^ko`AO00?o^k/03k/00olS8`048`03ok^k00>k0ol6P@03oh6100V10ol7^`Co6003ocH0001M0003
o`0000T000Oobk_;^l_o00J10ol2P@0/ol^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/2o`06^l^kbk_o1KL01Onkbk_;00?o1h407?o;^omO7olOol^kbk_;^l^kbk_;^l^kbk_;
ob<3o`03bk_;00Co2X400on1P@04P@?o00Rkbk_;^l^kb`?o6004ocT0001N0003o`0000T000?o^k/0
0k/00on1P@03o`J100?o^k/03k/4oa:k0ol00kOo^`05^`?o1K/2o`^100?o^k/00_lE^`04ok^k^`?o
0X400on1P@0:P@03oh6100?o1k/4oaP00olm0000G`02o`X000Kobk_;^l/2o`Z100oobk_;^l^kbk_;
^l^kbk/00_l0:`fe3KGo^l^kbk_;^l^kbk_;^l^kbonf]kJg]_o;^l^kbk_;^l^kbk_;^ol038406_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co@0000640
00?o000020000onk^`03^`03oh6100V100?o^k/01K/2o`Bk00So]@fe3KD=o`Vk0ol5^`03okNg00:g
00?o^k/03;/00on1P@0:P@03ok^k01:k1?l:P@03oh6100B10ol7^`Co6003od@0001R0003o`0000P0
00Oobk_;^l_o00^10_l00k_;^`02o`093Oco^l^kbol=00?o00S;^l^kbk_;^`?o0_`01oo;^l^kbk/0
0_l04l^kbk_;^l^kbk_;^l^kbk_;^ol01X43o`:1013o^l^kbk_;^l^kbk_;^l^k1Ol3P@03oh6100V1
00?oPH400ol01l^kbk_;^l/00olH00CoA`0006<000?o00002002o`Bk00?oPH401843o`>100?o^ol0
1KD00onk^`02^`03ok^k00Zk00Koo;Kl]_l;^`;o3K/00on1P@03o`J100?o^k/02;/4o`V100?oPH40
2H42o`Jk1?lG00CoB`0006@000?o00002@001_nkbk_;o`:10ol7P@0Bok_oo0gl3Oco^l^kbk_;^l^k
0ol01[_;^l^ko`;l00[oo?o;^l^kbk_;0ol2]P0>ok_;^l^kbk_;^l^kbk/2o`Z100Oo^l^kbk_;00?o
0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0001U0003o`0000T000?o^k/00[/2o`^1
00?o^ol00_l9^`?o0o`00onk^`03^`;o2K/02?ng][Nf]kKo3K/00on1P@09P@03ok^k00?o1X400on1
P@09P@03oh6100?o1K/4oaL01?mB0000IP000ol000090007ok_;^l^ko`0;P@08ok_;^l^kbk/2o`05
bk_;^ol01O`04onkbk_;^l^kbk_;^l^kbk_;^ol01KH03onkbk_;^l^kbk_;^l^ko`0;P@;o2X400on1
P@07P@08oh7ool^kbk/4oaP00omF0000I`02o`X000?o^k/00k/00on1P@09P@04ok^k^`?o00>eok/0
1;/01?oloolD^`?o4K/00on1P@04P@?o0X400on1P@09P@04oh61P@Go1K/3oaP01?mI0000J@000ol0
00080007ok_;^l^ko`06P@?o0X400onko`05]@0cok_;^l^kok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00:10ol6P@03oh6100V10ol01[_;^l^kb`Co6003oed0001Z0003
o`0000P000?o^k/00k/00on1P@03o`J100Co^k_o1;D00onk^`07^`?o8k/4o`Z100?oPH401843o`Nk
0olH00CoH00006/000?o00002002o`04bk_;^`;o2X400onkb`02o`09^l^kbk_;^l^k00?o027l]Oco
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01Ol4P@03oh6100R100?oPH400ol01/^kbk_;^`Co
6003of@0001/0003o`0000T000?o^k/00[/00on1P@09P@03ok^k00bk00?o][H00[H00onk^`0G^`?o
2X400on1P@08P@;o1[/3oaP01?mW0000K@000ol000090006ol^kbk_o2h403onkbk_;^l^kbk_;^l^k
b`02o`0I^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`:100?oPH402H400on1P@05o`06^l^kbk_;
1?lH00?oJ`0006h00_l:0003ok^k00:k00?oPH401843o`:100?o^k/08k/3o`J100?oPH402H42o`Rk
0olH00CoKP00070000?o000020001_o;^l^ko`:10ol6P@0Qok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00Co2X400on1P@04P@?o00Nkbk_;^l^k00Co5`04og80001a0003o`0000P000?o^k/0
0[/2o`Z100?o^k/06;/5o`>100?oPH402H400on1P@03o`Nk0olH00?oMP00078000?o000020001oo;
^l^kbol02X405onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;00?o2H400on1P@09P@;o00Jkbk_;^l/4oaL0
1?mi0000L`000ol0000800;o1;/00on1P@08P@03ok^k012k0ol2P@03oh6100R100?oPH401843o`Jk
0olH00?oO@0007@000?o00002@001_nkbk_;o`:11Ol3P@0?ok_;^l^kbk_;^l^kbk_;00?o1X400on1
P@08P@03oh6100?o00Fkbk_;^`04oaL01?n00000M@000ol000090003ok^k00:k0_l9P@03ok^k00Rk
0ol:P@03oh6100J100CoPOoo1K/3oaP00on40000MP02o`X000Oo^l^kbk_o00V100Oo^l^kbk_;00?o
0X400on1P@09P@03oh6100Go00G;^l^kb`04oaL01?n70000N0000ol000080003ok^k00>k00?oPH40
1h400onk^`03o`J100?oPH402H42o`Nk0olH00?oR`0007T000?o000020001onkbk_;^ol01h401?n1
ool:P@03oh6100B10ol01/^kbk_;^`Co5`04ohh0001j0003o`0000P000?o^k/00k/00on1P@04o`B1
00?oPH4028400on1P@03o`Jk0olH00?oTP0007/000?o000020001_nkbk_;^`;o2H400on1P@08P@;o
00G;^l^kb`04oaL01?nE0000O0000ol0000800;o1;/00on1P@08P@03oh6100Go1[/3oaL01?nI0000
O@000ol000090006ol^kbk_o2X42o`07^l^kbk_;^`04oaL00onM0000OP02o`X000?o^k/00[/00on1
P@03P@?o1k/3oaL01?nP0000P0000ol000080007ol^kbk_oP@03o`06^l^kbk_;1?lG00?oY0000840
00?o000020000onk^`02^`03ok^k00Bk0olG00CoY`00088000?o000020001oo;^l^kbk/01?lG00?o
Z`0008<000?o000020000onk^`03oaL01?n^0000Q0000ol0000700?o5`03ok80002500;o1`000ol0
000C00Co]@0008L000?o000010000ol0000@00?o^@0008P000?o00000`000ol0000<00Co_00008T0
00Go0000o`0;00Co`00008X000Co003o2003ol@0002;0003o`3o00@01?o70000S002o`040?oool/0
002=00;ocP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP00098000?o00009`000ol0002N0000K@04o`<01?l0103oo`02o`800_l300?o
1002o`@000?o00002005o`040?oo00;o0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<0
0_l400?o0`03o`<00_m_0000K0001Ol0003o008000?o00000`001?l00?l300;o1P001?l00?l20003
o`00008000?o00002@001Ol0003o008000Co003o0`000ol00002o`@000?o000010000ol000070003
o`0000D000?o00000P001?l00?l200;o1@000ol000030003o`0000800_m_0000K0000ol0o`02o`80
1Ol01@3o003o00/000Co003o0P000ol0000>0005o`000?l00P001?l00?l30003o`0000H000?o0000
3P000ol000050003o`00008000?o00002004o`801?md0000K0000ol000040007o`000?l0o`020003
o`0000L00_l400;o4@001Ol0003o008000Co003o0`000ol000060003o`0000h00ol50003o`000080
00?o000020000ol0o`030003o`3o07D0001/0005o`000?l00`03o`030?oo00?o2`001?l00?l20003
o`0000h000?o00001Ol300Co20000ol0000>0003o`0000@00_l300Co20000ol0o`030003o`3o07D0
001]00Co5003o`@00_l?00Go2`000ol0000500;o3`05o`T000?o00002@02o`@00_me0000[002ob40
00?o00000P000ol000260000o`1N0000\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 38"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 35",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["Next",
          ButtonData:>"AntTracker2D - Gen 59",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generation 59", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.230635 1.486233 0.019577 0.95651 [
[(Gen.59, Ind.1, Fit.45.)] .5 1 0 -1.5 Msboxa
[(5)] .22092 .11714 .84695 1 Msboxa
[(10)] .37284 .07856 .79165 1 Msboxa
[(15)] .5299 .0387 .73636 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Msboxa
P
[(5)] .71947 .07888 -1 .38093 Msboxa
[(10)] .79611 .14908 -1 .36667 Msboxa
[(15)] .86831 .21523 -1 .35344 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87582 .1216 -1 .36805 Msboxa
P
[(0)] .09642 .17323 1 -0.39101 Msboxa
[(10)] .07539 .34479 1 -0.36223 Msboxa
[(20)] .05204 .53529 1 -0.33012 Msboxa
[(30)] .02597 .74805 1 -0.29405 Msboxa
[(t)] -0.02569 .47223 1 -0.34405 Msboxa
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.59, Ind.1, Fit.45.)] .5 1 0 -1.5 Mshowa
p
p
.002 w
.11528 .15603 m
.63741 .02391 L
s
P
p
.002 w
.23292 .12626 m
.23893 .13082 L
s
P
[(5)] .22092 .11714 .84695 1 Mshowa
p
.002 w
.38437 .08794 m
.39013 .09263 L
s
P
[(10)] .37284 .07856 .79165 1 Mshowa
p
.002 w
.54092 .04833 m
.54642 .05314 L
s
P
[(15)] .5299 .0387 .73636 1 Mshowa
p
.001 w
.26282 .1187 m
.26639 .12145 L
s
P
p
.001 w
.29291 .11108 m
.29645 .11385 L
s
P
p
.001 w
.32319 .10342 m
.32671 .1062 L
s
P
p
.001 w
.35368 .0957 m
.35717 .0985 L
s
P
p
.001 w
.41526 .08012 m
.41869 .08295 L
s
P
p
.001 w
.44636 .07225 m
.44976 .0751 L
s
P
p
.001 w
.47767 .06433 m
.48104 .06719 L
s
P
p
.001 w
.50919 .05636 m
.51252 .05923 L
s
P
p
.001 w
.20323 .13377 m
.20686 .1365 L
s
P
p
.001 w
.17372 .14124 m
.17738 .14395 L
s
P
p
.001 w
.14441 .14866 m
.14809 .15135 L
s
P
p
.001 w
.57286 .04024 m
.57613 .04315 L
s
P
p
.001 w
.60502 .03211 m
.60826 .03503 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Mshowa
P
P
p
p
.002 w
.63741 .02391 m
.8921 .25702 L
s
P
p
.002 w
.70211 .08313 m
.69343 .08526 L
s
P
[(5)] .71947 .07888 -1 .38093 Mshowa
p
.002 w
.77866 .1532 m
.76994 .15526 L
s
P
[(10)] .79611 .14908 -1 .36667 Mshowa
p
.002 w
.85079 .21921 m
.84203 .2212 L
s
P
[(15)] .86831 .21523 -1 .35344 Mshowa
p
.001 w
.7178 .09749 m
.71258 .09876 L
s
P
p
.001 w
.73329 .11167 m
.72807 .11293 L
s
P
p
.001 w
.7486 .12568 m
.74337 .12693 L
s
P
p
.001 w
.76372 .13952 m
.75849 .14076 L
s
P
p
.001 w
.79343 .16671 m
.78819 .16794 L
s
P
p
.001 w
.80802 .18007 m
.80278 .18129 L
s
P
p
.001 w
.82244 .19327 m
.8172 .19448 L
s
P
p
.001 w
.8367 .20631 m
.83145 .20752 L
s
P
p
.001 w
.68624 .0686 m
.68103 .06989 L
s
P
p
.001 w
.67016 .05389 m
.66496 .05519 L
s
P
p
.001 w
.65389 .039 m
.64869 .0403 L
s
P
p
.001 w
.86472 .23196 m
.85946 .23315 L
s
P
p
.001 w
.87849 .24456 m
.87322 .24574 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .87582 .1216 -1 .36805 Mshowa
P
P
p
p
.002 w
.11528 .15603 m
.03716 .79936 L
s
P
p
.002 w
.11372 .16888 m
.12237 .1667 L
s
P
[(0)] .09642 .17323 1 -0.39101 Mshowa
p
.002 w
.09285 .34072 m
.10159 .33869 L
s
P
[(10)] .07539 .34479 1 -0.36223 Mshowa
p
.002 w
.06968 .53155 m
.0785 .52967 L
s
P
[(20)] .05204 .53529 1 -0.33012 Mshowa
p
.002 w
.0438 .74468 m
.05271 .74299 L
s
P
[(30)] .02597 .74805 1 -0.29405 Mshowa
p
.001 w
.10972 .20186 m
.11492 .20057 L
s
P
p
.001 w
.10563 .23552 m
.11084 .23425 L
s
P
p
.001 w
.10146 .26987 m
.10668 .26861 L
s
P
p
.001 w
.0972 .30493 m
.10243 .30369 L
s
P
p
.001 w
.08841 .37727 m
.09366 .37607 L
s
P
p
.001 w
.08388 .4146 m
.08914 .41342 L
s
P
p
.001 w
.07925 .45274 m
.08452 .45158 L
s
P
p
.001 w
.07452 .49171 m
.0798 .49057 L
s
P
p
.001 w
.06473 .57227 m
.07004 .57117 L
s
P
p
.001 w
.05968 .61391 m
.06499 .61283 L
s
P
p
.001 w
.0545 .6565 m
.05983 .65545 L
s
P
p
.001 w
.04921 .70008 m
.05455 .69905 L
s
P
p
.001 w
.03825 .79033 m
.04361 .78934 L
s
P
[(t)] -0.02569 .47223 1 -0.34405 Mshowa
P
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
p
p
.4 g
.002 w
.11372 .16888 m
.40485 .37783 L
s
P
p
.4 g
.002 w
.09285 .34072 m
.39976 .54298 L
s
P
p
.4 g
.002 w
.06968 .53155 m
.39417 .72452 L
s
P
p
.4 g
.002 w
.0438 .74468 m
.38799 .92503 L
s
P
p
.4 g
.002 w
.18866 .20901 m
.12672 .84468 L
s
P
p
.4 g
.002 w
.27571 .27188 m
.23195 .89793 L
s
P
p
.4 g
.002 w
.358 .33131 m
.33036 .94772 L
s
P
.002 w
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.38641 .97609 L
s
.38641 .97609 m
.40523 .36542 L
s
.40523 .36542 m
.11528 .15603 L
s
.63741 .02391 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.63741 .02391 m
.11528 .15603 L
s
p
.4 g
.51538 .34089 m
.5159 .95571 L
s
P
p
.4 g
.65679 .30941 m
.68292 .92943 L
s
P
p
.4 g
.80251 .27696 m
.85598 .9022 L
s
P
p
.4 g
.40485 .37783 m
.89352 .26968 L
s
P
p
.4 g
.39976 .54298 m
.91253 .43853 L
s
P
p
.4 g
.39417 .72452 m
.93354 .62513 L
s
P
p
.4 g
.38799 .92503 m
.95688 .8324 L
s
P
.40523 .36542 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.38641 .97609 L
s
.38641 .97609 m
.40523 .36542 L
s
p
.4 g
.23292 .12626 m
.51538 .34089 L
s
P
p
.4 g
.38437 .08794 m
.65679 .30941 L
s
P
p
.4 g
.54092 .04833 m
.80251 .27696 L
s
P
p
.4 g
.18866 .20901 m
.70211 .08313 L
s
P
p
.4 g
.27571 .27188 m
.77866 .1532 L
s
P
p
.4 g
.358 .33131 m
.85079 .21921 L
s
P
P
p
.002 w
.41076 .36919 m .41853 .3748 L .40485 .37783 L p
.4 g
F P
s
P
p
.002 w
.40485 .37783 m .39706 .37224 L .41076 .36919 L p
.4 g
F P
s
P
p
.002 w
.89352 .26968 m .40485 .37783 L .11372 .16888 L p
.9 g
F P
s
P
p
.002 w
.43224 .37177 m .41853 .3748 L p
.41076 .36919 L .4 g
F P
s
P
p
.002 w
.41076 .36919 m .39706 .37224 L .38922 .36661 L p
.4 g
F P
s
P
p
.002 w
.43828 .36308 m .446 .36872 L .43224 .37177 L p
.4 g
F P
s
P
p
.002 w
.41076 .36919 m .43828 .36308 L p
.43224 .37177 L .4 g
F P
s
P
p
.002 w
.38922 .36661 m .38134 .36095 L p
.41076 .36919 L .4 g
F P
s
P
p
.002 w
.38134 .36095 m .39509 .35788 L .41076 .36919 L p
.4 g
F P
s
P
p
.002 w
.4598 .36567 m .446 .36872 L p
.43828 .36308 L .4 g
F P
s
P
p
.002 w
.46597 .35693 m .47363 .36261 L .4598 .36567 L p
.4 g
F P
s
P
p
.002 w
.43828 .36308 m .46597 .35693 L p
.4598 .36567 L .4 g
F P
s
P
p
.002 w
.48751 .35954 m .47363 .36261 L p
.46597 .35693 L .4 g
F P
s
P
p
.002 w
.39509 .35788 m .38134 .36095 L .37341 .35527 L p
.4 g
F P
s
P
p
.002 w
.49382 .35074 m .50143 .35646 L .48751 .35954 L p
.4 g
F P
s
P
p
.002 w
.46597 .35693 m .49382 .35074 L p
.48751 .35954 L .4 g
F P
s
P
p
.002 w
.37341 .35527 m .36545 .34955 L p
.39509 .35788 L .4 g
F P
s
P
p
.002 w
.36545 .34955 m .37925 .34644 L .39509 .35788 L p
.4 g
F P
s
P
p
.002 w
.51539 .35337 m .50143 .35646 L p
.49382 .35074 L .4 g
F P
s
P
p
.002 w
.52184 .34452 m .5294 .35027 L .51539 .35337 L p
.4 g
F P
s
P
p
.002 w
.49382 .35074 m .52184 .34452 L p
.51539 .35337 L .4 g
F P
s
P
p
.002 w
.54344 .34716 m .5294 .35027 L p
.52184 .34452 L .4 g
F P
s
P
p
.002 w
.37925 .34644 m .36545 .34955 L .35744 .3438 L p
.4 g
F P
s
P
p
.002 w
.55003 .33826 m .55753 .34404 L .54344 .34716 L p
.4 g
F P
s
P
p
.002 w
.52184 .34452 m .55003 .33826 L p
.54344 .34716 L .4 g
F P
s
P
p
.002 w
.35744 .3438 m .34938 .33802 L p
.37925 .34644 L .4 g
F P
s
P
p
.002 w
.34938 .33802 m .36324 .33487 L .37925 .34644 L p
.4 g
F P
s
P
p
.002 w
.57166 .34091 m .55753 .34404 L p
.55003 .33826 L .4 g
F P
s
P
p
.002 w
.57838 .33196 m .58583 .33778 L .57166 .34091 L p
.4 g
F P
s
P
p
.002 w
.55003 .33826 m .57838 .33196 L p
.57166 .34091 L .4 g
F P
s
P
p
.002 w
.43489 .3339 m .40699 .34019 L .39108 .32856 L p
.8 g
F P
s
P
p
.002 w
.57838 .33196 m .55003 .33826 L .5349 .3266 L p
.4 g
F P
s
P
p
.002 w
.36324 .33487 m .34938 .33802 L .34128 .3322 L p
.4 g
F P
s
P
p
.002 w
.60004 .33463 m .58583 .33778 L p
.57838 .33196 L .4 g
F P
s
P
p
.002 w
.34128 .3322 m .33314 .32636 L p
.36324 .33487 L .4 g
F P
s
P
p
.002 w
.33314 .32636 m .34705 .32318 L .36324 .33487 L p
.4 g
F P
s
P
p
.002 w
.60691 .32563 m .6143 .33148 L .60004 .33463 L p
.4 g
F P
s
P
p
.002 w
.57838 .33196 m .60691 .32563 L p
.60004 .33463 L .4 g
F P
s
P
p
.002 w
.46295 .32758 m .43489 .3339 L .41909 .3222 L p
.8 g
F P
s
P
p
.002 w
.39108 .32856 m .41909 .3222 L .43489 .3339 L p
.8 g
F P
s
P
p
.002 w
.5349 .3266 m .56336 .32024 L .57838 .33196 L p
.4 g
F P
s
P
p
.002 w
.62859 .32831 m .6143 .33148 L p
.60691 .32563 L .4 g
F P
s
P
p
.002 w
.41909 .3222 m .39108 .32856 L .37499 .31679 L p
.8 g
F P
s
P
p
.002 w
.6356 .31925 m .64294 .32514 L .62859 .32831 L p
.4 g
F P
s
P
p
.002 w
.60691 .32563 m .6356 .31925 L p
.62859 .32831 L .4 g
F P
s
P
p
.002 w
.41909 .3222 m .44726 .3158 L .46295 .32758 L p
.8 g
F P
s
P
p
.002 w
.56336 .32024 m .5349 .3266 L .5196 .31482 L p
.4 g
F P
s
P
p
.002 w
.34705 .32318 m .33314 .32636 L .32495 .32048 L p
.4 g
F P
s
P
p
.002 w
.65732 .32195 m .64294 .32514 L p
.6356 .31925 L .4 g
F P
s
P
p
.002 w
.32495 .32048 m .31671 .31457 L p
.34705 .32318 L .4 g
F P
s
P
p
.002 w
.31671 .31457 m .33067 .31135 L .34705 .32318 L p
.4 g
F P
s
P
p
.002 w
.37499 .31679 m .40311 .31036 L .41909 .3222 L p
.8 g
F P
s
P
p
.002 w
.66448 .31284 m .67175 .31876 L .65732 .32195 L p
.4 g
F P
s
P
p
.002 w
.6356 .31925 m .66448 .31284 L p
.65732 .32195 L .4 g
F P
s
P
p
.002 w
.5196 .31482 m .49119 .32122 L .47561 .30937 L p
.8 g
F P
s
P
p
.002 w
.5196 .31482 m .54818 .30838 L .56336 .32024 L p
.4 g
F P
s
P
p
.002 w
.68622 .31556 m .67175 .31876 L p
.66448 .31284 L .4 g
F P
s
P
p
.002 w
.69352 .30639 m .70074 .31234 L .68622 .31556 L p
.4 g
F P
s
P
p
.002 w
.66448 .31284 m .69352 .30639 L p
.68622 .31556 L .4 g
F P
s
P
p
.002 w
.54818 .30838 m .5196 .31482 L .50413 .3029 L p
.8 g
F P
s
P
p
.002 w
.47561 .30937 m .50413 .3029 L .5196 .31482 L p
.8 g
F P
s
P
p
.002 w
.33067 .31135 m .31671 .31457 L .30843 .30863 L p
.4 g
F P
s
P
p
.002 w
.69352 .30639 m .66448 .31284 L .64981 .3009 L p
.8 g
F P
s
P
p
.002 w
.7153 .30912 m .70074 .31234 L p
.69352 .30639 L .4 g
F P
s
P
p
.002 w
.30843 .30863 m .3001 .30265 L p
.33067 .31135 L .4 g
F P
s
P
p
.002 w
.3001 .30265 m .31412 .2994 L .33067 .31135 L p
.4 g
F P
s
P
p
1 .019 0 r
.01 w
.64267 .31011 m
.64267 .31011 L
s
P
p
1 .038 0 r
.01 w
.62792 .29974 m
.64274 .31171 L
s
P
p
.002 w
.72275 .2999 m .7299 .30589 L .7153 .30912 L p
.4 g
F P
s
P
p
.002 w
.69352 .30639 m .72275 .2999 L p
.7153 .30912 L .4 g
F P
s
P
p
.002 w
.57693 .3019 m .54818 .30838 L .53282 .29639 L p
.8 g
F P
s
P
p
.002 w
.50413 .3029 m .53282 .29639 L .54818 .30838 L p
.8 g
F P
s
P
p
.002 w
.72275 .2999 m .69352 .30639 L .67897 .29437 L p
.8 g
F P
s
P
p
.002 w
.64981 .3009 m .67897 .29437 L .69352 .30639 L p
.8 g
F P
s
P
p
.002 w
.74455 .30265 m .7299 .30589 L p
.72275 .2999 L .4 g
F P
s
P
p
1 .151 0 r
.01 w
.55505 .31038 m
.57031 .32232 L
s
P
p
1 .17 0 r
.01 w
.57034 .32393 m
.57034 .32393 L
s
P
p
.002 w
.53282 .29639 m .50413 .3029 L .48849 .29084 L p
.4 g
F P
s
P
p
.002 w
.75215 .29337 m .75924 .2994 L .74455 .30265 L p
.4 g
F P
s
P
p
.002 w
.72275 .2999 m .75215 .29337 L p
.74455 .30265 L .4 g
F P
s
P
p
.002 w
.31412 .2994 m .3001 .30265 L .29172 .29664 L p
.4 g
F P
s
P
p
1 .189 0 r
.01 w
.57036 .32554 m
.57036 .32554 L
s
P
p
.002 w
.53282 .29639 m .56169 .28983 L .57693 .3019 L p
.8 g
F P
s
P
p
1 .208 0 r
.01 w
.57039 .32715 m
.57039 .32715 L
s
P
p
1 .226 0 r
.01 w
.57042 .32876 m
.57042 .32876 L
s
P
p
.002 w
.75215 .29337 m .72275 .2999 L .70832 .28781 L p
.8 g
F P
s
P
p
.002 w
.67897 .29437 m .70832 .28781 L .72275 .2999 L p
.8 g
F P
s
P
p
.002 w
.77398 .29613 m .75924 .2994 L p
.75215 .29337 L .4 g
F P
s
P
p
.002 w
.29172 .29664 m .2833 .29059 L p
.31412 .2994 L .4 g
F P
s
P
p
.002 w
.2833 .29059 m .29737 .2873 L .31412 .2994 L p
.4 g
F P
s
P
p
1 .245 0 r
.01 w
.55515 .31846 m
.57044 .33038 L
s
P
p
.002 w
.48849 .29084 m .51729 .28426 L .53282 .29639 L p
.4 g
F P
s
P
p
.002 w
.78173 .2868 m .78876 .29286 L .77398 .29613 L p
.4 g
F P
s
P
p
.002 w
.75215 .29337 m .78173 .2868 L p
.77398 .29613 L .4 g
F P
s
P
p
.002 w
.63497 .28882 m .60586 .29538 L .59074 .28324 L p
.8 g
F P
s
P
p
1 .057 0 r
.01 w
.61298 .28925 m
.62797 .30135 L
s
P
p
1 .113 0 r
.01 w
.55501 .30717 m
.58398 .30064 L
s
P
p
.002 w
.78173 .2868 m .75215 .29337 L .73784 .2812 L p
.8 g
F P
s
P
p
.002 w
.70832 .28781 m .73784 .2812 L .75215 .29337 L p
.8 g
F P
s
P
p
1 .132 0 r
.01 w
.55503 .30877 m
.55503 .30877 L
s
P
p
.002 w
.80359 .28958 m .78876 .29286 L p
.78173 .2868 L .4 g
F P
s
P
p
.002 w
.37061 .28629 m .34228 .29286 L .32564 .28069 L p
.8 g
F P
s
P
p
.002 w
.51729 .28426 m .48849 .29084 L .47266 .27865 L p
.4 g
F P
s
P
p
.002 w
.29737 .2873 m .2833 .29059 L .27483 .28451 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .81847 .28629 L .80359 .28958 L p
.4 g
F P
s
P
p
.002 w
.78173 .2868 m .8115 .28018 L p
.80359 .28958 L .4 g
F P
s
P
p
.002 w
.66426 .28222 m .63497 .28882 L .61997 .27661 L p
.8 g
F P
s
P
p
.002 w
.59074 .28324 m .61997 .27661 L .63497 .28882 L p
.8 g
F P
s
P
p
1 .094 0 r
.01 w
.58394 .29903 m
.61307 .29246 L
s
P
p
.002 w
.27483 .28451 m .26631 .2784 L p
.29737 .2873 L .4 g
F P
s
P
p
.002 w
.26631 .2784 m .28044 .27507 L .29737 .2873 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .78173 .2868 L .76755 .27456 L p
.8 g
F P
s
P
p
.002 w
.73784 .2812 m .76755 .27456 L .78173 .2868 L p
.8 g
F P
s
P
p
.002 w
.83338 .28299 m .81847 .28629 L p
.8115 .28018 L .4 g
F P
s
P
p
.002 w
.39912 .27967 m .37061 .28629 L .35408 .27405 L p
.8 g
F P
s
P
p
.002 w
.32564 .28069 m .35408 .27405 L .37061 .28629 L p
.8 g
F P
s
P
p
1 .264 0 r
.01 w
.55517 .32008 m
.55517 .32008 L
s
P
p
1 .283 0 r
.01 w
.55519 .3217 m
.58428 .31519 L
s
P
p
.002 w
.47266 .27865 m .50159 .27199 L .51729 .28426 L p
.4 g
F P
s
P
p
.002 w
.84144 .27353 m .84835 .27967 L .83338 .28299 L p
.4 g
F P
s
P
p
.002 w
.8115 .28018 m .84144 .27353 L p
.83338 .28299 L .4 g
F P
s
P
p
1 .075 0 r
.01 w
.61303 .29085 m
.61303 .29085 L
s
P
p
.002 w
.69372 .27558 m .66426 .28222 L .64937 .26993 L p
.8 g
F P
s
P
p
.002 w
.61997 .27661 m .64937 .26993 L .66426 .28222 L p
.8 g
F P
s
P
p
.002 w
.76755 .27456 m .79744 .26787 L .8115 .28018 L p
.8 g
F P
s
P
p
.002 w
.86336 .27635 m .84835 .27967 L p
.84144 .27353 L .4 g
F P
s
P
p
.002 w
.35408 .27405 m .3827 .26736 L .39912 .27967 L p
.8 g
F P
s
P
p
.002 w
.50159 .27199 m .47266 .27865 L .45666 .26632 L p
.4 g
F P
s
P
p
.002 w
.28044 .27507 m .26631 .2784 L .25775 .27225 L p
.4 g
F P
s
P
p
1 .302 0 r
.01 w
.58431 .31681 m
.58431 .31681 L
s
P
p
1 .321 0 r
.01 w
.56897 .30632 m
.58435 .31844 L
s
P
p
.002 w
.87158 .26684 m .87842 .27302 L .86336 .27635 L p
.4 g
F P
s
P
p
.002 w
.84144 .27353 m .87158 .26684 L p
.86336 .27635 L .4 g
F P
s
P
p
.002 w
.72337 .2689 m .69372 .27558 L .67896 .26322 L p
.8 g
F P
s
P
p
.002 w
.64937 .26993 m .67896 .26322 L .69372 .27558 L p
.8 g
F P
s
P
p
.002 w
.25775 .27225 m .24913 .26606 L p
.28044 .27507 L .4 g
F P
s
P
p
.002 w
.24913 .26606 m .26331 .2627 L .28044 .27507 L p
.4 g
F P
s
P
p
.002 w
.79744 .26787 m .76755 .27456 L .7532 .26218 L p
.8 g
F P
s
P
p
1 .377 0 r
.01 w
.56905 .31122 m
.58445 .32332 L
s
P
p
.002 w
.89352 .26968 m .87842 .27302 L p
.87158 .26684 L .4 g
F P
s
P
p
1 .396 0 r
.01 w
.58448 .32496 m
.58448 .32496 L
s
P
p
.002 w
.45666 .26632 m .4857 .25959 L .50159 .27199 L p
.4 g
F P
s
P
p
1 .415 0 r
.01 w
.58452 .32659 m
.61389 .32005 L
s
P
p
.002 w
.87158 .26684 m .88671 .26348 L .89352 .26968 L p
.4 g
F P
s
P
p
.002 w
.11372 .16888 m .63792 .03696 L .89352 .26968 L p
.9 g
F P
s
P
p
.002 w
.67896 .26322 m .70873 .25646 L .72337 .2689 L p
.8 g
F P
s
P
p
.002 w
.7532 .26218 m .78322 .25542 L .79744 .26787 L p
.8 g
F P
s
P
p
.002 w
.4115 .26062 m .3827 .26736 L .3661 .2549 L p
.8 g
F P
s
P
p
.002 w
.88671 .26348 m .87158 .26684 L p
.85778 .25437 L .4 g
F P
s
P
p
.002 w
.4857 .25959 m .45666 .26632 L .44048 .25385 L p
.4 g
F P
s
P
p
.002 w
.26331 .2627 m .24913 .26606 L .24046 .25985 L p
.4 g
F P
s
P
p
1 .434 0 r
.01 w
.61394 .32169 m
.6435 .31512 L
s
P
p
.002 w
.87987 .25724 m .88671 .26348 L p
.85778 .25437 L .4 g
F P
s
P
p
.002 w
.70873 .25646 m .67896 .26322 L .66403 .25071 L p
.8 g
F P
s
P
p
1 .34 0 r
.01 w
.56899 .30795 m
.56899 .30795 L
s
P
p
.002 w
.24046 .25985 m .23175 .25359 L p
.26331 .2627 L .4 g
F P
s
P
p
.002 w
.23175 .25359 m .24598 .25019 L .26331 .2627 L p
.4 g
F P
s
P
p
.002 w
.78322 .25542 m .7532 .26218 L .73869 .24966 L p
.8 g
F P
s
P
p
1 .358 0 r
.01 w
.56902 .30959 m
.56902 .30959 L
s
P
p
.002 w
.3661 .2549 m .39501 .24809 L .4115 .26062 L p
.8 g
F P
s
P
p
.002 w
.44048 .25385 m .46963 .24704 L .4857 .25959 L p
.4 g
F P
s
P
p
.002 w
.85778 .25437 m .87298 .25097 L .87987 .25724 L p
.4 g
F P
s
P
p
.002 w
.66403 .25071 m .69393 .24388 L .70873 .25646 L p
.8 g
F P
s
P
p
1 .453 0 r
.01 w
.64357 .31676 m
.64357 .31676 L
s
P
p
.002 w
.73869 .24966 m .76884 .24282 L .78322 .25542 L p
.8 g
F P
s
P
p
.002 w
.39501 .24809 m .3661 .2549 L .34931 .24229 L p
.8 g
F P
s
P
p
1 .472 0 r
.01 w
.62844 .30616 m
.64363 .3184 L
s
P
p
.002 w
.87298 .25097 m .85778 .25437 L p
.84382 .24176 L .4 g
F P
s
P
p
.002 w
.46963 .24704 m .44048 .25385 L .4241 .24124 L p
.4 g
F P
s
P
p
.002 w
.24598 .25019 m .23175 .25359 L .22298 .2473 L p
.4 g
F P
s
P
p
1 .528 0 r
.01 w
.6286 .31111 m
.64382 .32333 L
s
P
p
.002 w
.86605 .24467 m .87298 .25097 L p
.84382 .24176 L .4 g
F P
s
P
p
.002 w
.69393 .24388 m .66403 .25071 L .64893 .23806 L p
.8 g
F P
s
P
p
1 .547 0 r
.01 w
.64388 .32498 m
.64388 .32498 L
s
P
p
.002 w
.22298 .2473 m .21417 .24097 L p
.24598 .25019 L .4 g
F P
s
P
p
.002 w
.21417 .24097 m .22846 .23753 L .24598 .25019 L p
.4 g
F P
s
P
p
.002 w
.76884 .24282 m .73869 .24966 L .72401 .237 L p
.8 g
F P
s
P
p
1 .566 0 r
.01 w
.64394 .32663 m
.6738 .32003 L
s
P
p
.002 w
.34931 .24229 m .37833 .2354 L .39501 .24809 L p
.8 g
F P
s
P
p
.002 w
.4241 .24124 m .45338 .23434 L .46963 .24704 L p
.4 g
F P
s
P
p
.002 w
.64893 .23806 m .61909 .24493 L .60369 .23221 L p
.4 g
F P
s
P
p
.002 w
.84382 .24176 m .85909 .23832 L .86605 .24467 L p
.4 g
F P
s
P
p
.002 w
.64893 .23806 m .67895 .23114 L .69393 .24388 L p
.8 g
F P
s
P
p
.002 w
.79917 .23594 m .76884 .24282 L .75429 .23008 L p
.8 g
F P
s
P
p
.002 w
.72401 .237 m .75429 .23008 L .76884 .24282 L p
.8 g
F P
s
P
p
.002 w
.85909 .23832 m .84382 .24176 L p
.8297 .22901 L .4 g
F P
s
P
p
1 .585 0 r
.01 w
.67387 .32168 m
.70393 .31504 L
s
P
p
.002 w
.45338 .23434 m .4241 .24124 L .40754 .22847 L p
.4 g
F P
s
P
p
1 .491 0 r
.01 w
.62849 .30781 m
.62849 .30781 L
s
P
p
.002 w
.22846 .23753 m .21417 .24097 L .2053 .23461 L p
.4 g
F P
s
P
p
1 .509 0 r
.01 w
.62855 .30946 m
.62855 .30946 L
s
P
p
.002 w
.60369 .23221 m .57391 .23912 L .55821 .22633 L p
.8 g
F P
s
P
p
.002 w
.85208 .23194 m .85909 .23832 L p
.8297 .22901 L .4 g
F P
s
P
p
.002 w
.60369 .23221 m .63365 .22526 L .64893 .23806 L p
.4 g
F P
s
P
p
.002 w
.67895 .23114 m .64893 .23806 L .63365 .22526 L p
.8 g
F P
s
P
p
.002 w
.2053 .23461 m .19638 .22821 L p
.22846 .23753 L .4 g
F P
s
P
p
.002 w
.19638 .22821 m .21073 .22472 L .22846 .23753 L p
.4 g
F P
s
P
p
.002 w
.8297 .22901 m .79917 .23594 L .78475 .22311 L p
.8 g
F P
s
P
p
.002 w
.75429 .23008 m .78475 .22311 L .79917 .23594 L p
.8 g
F P
s
P
p
.002 w
.48284 .2274 m .45338 .23434 L .43693 .2215 L p
.4 g
F P
s
P
p
.002 w
.40754 .22847 m .43693 .2215 L .45338 .23434 L p
.4 g
F P
s
P
p
1 .604 0 r
.01 w
.70402 .3167 m
.70402 .3167 L
s
P
p
1 .623 0 r
.01 w
.68912 .306 m
.70411 .31836 L
s
P
p
.002 w
.63365 .22526 m .60369 .23221 L .5881 .21934 L p
.4 g
F P
s
P
p
.002 w
.55821 .22633 m .5881 .21934 L .60369 .23221 L p
.8 g
F P
s
P
p
.002 w
.8297 .22901 m .84503 .22553 L .85208 .23194 L p
.4 g
F P
s
P
p
.002 w
.70916 .22419 m .67895 .23114 L .6638 .21826 L p
.8 g
F P
s
P
p
.002 w
.63365 .22526 m .6638 .21826 L .67895 .23114 L p
.8 g
F P
s
P
p
.002 w
.84503 .22553 m .8297 .22901 L p
.81541 .2161 L .4 g
F P
s
P
p
.002 w
.78475 .22311 m .81541 .2161 L .8297 .22901 L p
.8 g
F P
s
P
p
.002 w
.43693 .2215 m .40754 .22847 L .39078 .21556 L p
.4 g
F P
s
P
p
.002 w
.21073 .22472 m .19638 .22821 L .18741 .22177 L p
.4 g
F P
s
P
p
.002 w
.43693 .2215 m .46651 .21448 L .48284 .2274 L p
.4 g
F P
s
P
p
.002 w
.83794 .21907 m .84503 .22553 L p
.81541 .2161 L .4 g
F P
s
P
p
.002 w
.5881 .21934 m .61819 .21231 L .63365 .22526 L p
.4 g
F P
s
P
p
.002 w
.18741 .22177 m .17839 .21529 L p
.21073 .22472 L .4 g
F P
s
P
p
.002 w
.17839 .21529 m .19279 .21177 L .21073 .22472 L p
.4 g
F P
s
P
p
.002 w
.73957 .21718 m .70916 .22419 L .69414 .21122 L p
.8 g
F P
s
P
p
.002 w
.6638 .21826 m .69414 .21122 L .70916 .22419 L p
.8 g
F P
s
P
p
.002 w
.81541 .2161 m .78475 .22311 L .77017 .21014 L p
.8 g
F P
s
P
p
.002 w
.46651 .21448 m .43693 .2215 L .42029 .20851 L p
.4 g
F P
s
P
p
.002 w
.39078 .21556 m .42029 .20851 L .43693 .2215 L p
.4 g
F P
s
P
p
.002 w
.61819 .21231 m .5881 .21934 L .57234 .20632 L p
.4 g
F P
s
P
p
.002 w
.81541 .2161 m .83081 .21258 L .83794 .21907 L p
.4 g
F P
s
P
p
1 .642 0 r
.01 w
.67403 .29515 m
.6892 .30766 L
s
P
p
.002 w
.77017 .21014 m .73957 .21718 L .72468 .20414 L p
.8 g
F P
s
P
p
.002 w
.69414 .21122 m .72468 .20414 L .73957 .21718 L p
.8 g
F P
s
P
p
.002 w
.34438 .20959 m .31513 .21664 L .29774 .20359 L p
.8 g
F P
s
P
p
.002 w
.83081 .21258 m .81541 .2161 L p
.80096 .20305 L .4 g
F P
s
P
p
.002 w
.77017 .21014 m .80096 .20305 L .81541 .2161 L p
.8 g
F P
s
P
p
.002 w
.19279 .21177 m .17839 .21529 L .16931 .20878 L p
.4 g
F P
s
P
p
.002 w
.42029 .20851 m .44999 .2014 L .46651 .21448 L p
.4 g
F P
s
P
p
.002 w
.82364 .20605 m .83081 .21258 L p
.80096 .20305 L .4 g
F P
s
P
p
.002 w
.57234 .20632 m .60255 .19921 L .61819 .21231 L p
.4 g
F P
s
P
p
.002 w
.16931 .20878 m .16018 .20222 L p
.19279 .21177 L .4 g
F P
s
P
p
.002 w
.16018 .20222 m .17464 .19866 L .19279 .21177 L p
.4 g
F P
s
P
p
1 .679 0 r
.01 w
.6438 .30528 m
.67418 .29849 L
s
P
p
.002 w
.80096 .20305 m .77017 .21014 L .75541 .19701 L p
.8 g
F P
s
P
p
.002 w
.72468 .20414 m .75541 .19701 L .77017 .21014 L p
.8 g
F P
s
P
p
.002 w
.29774 .20359 m .32711 .19646 L .34438 .20959 L p
.8 g
F P
s
P
p
1 .698 0 r
.01 w
.64386 .30695 m
.64386 .30695 L
s
P
p
1 .811 0 r
.01 w
.67474 .31024 m
.68998 .32271 L
s
P
p
1 .717 0 r
.01 w
.64393 .30862 m
.64393 .30862 L
s
P
p
1 .83 0 r
.01 w
.69007 .32439 m
.69007 .32439 L
s
P
p
.002 w
.52623 .20031 m .49628 .20742 L .47988 .19426 L p
.8 g
F P
s
P
p
1 .736 0 r
.01 w
.64399 .3103 m
.64399 .3103 L
s
P
p
1 .849 0 r
.01 w
.69016 .32607 m
.72074 .31934 L
s
P
p
.002 w
.60255 .19921 m .57234 .20632 L .55638 .19315 L p
.4 g
F P
s
P
p
.002 w
.80096 .20305 m .81643 .19948 L .82364 .20605 L p
.4 g
F P
s
P
p
1 .755 0 r
.01 w
.64405 .31197 m
.64405 .31197 L
s
P
p
1 .774 0 r
.01 w
.64412 .31365 m
.67458 .30687 L
s
P
p
1 .66 0 r
.01 w
.6741 .29682 m
.6741 .29682 L
s
P
p
.002 w
.32711 .19646 m .29774 .20359 L .28014 .19039 L p
.8 g
F P
s
P
p
0 1 .585 r
.01 w
.40634 .56212 m
.4232 .57314 L
s
P
p
.002 w
.81643 .19948 m .80096 .20305 L p
.78633 .18983 L .4 g
F P
s
P
p
.002 w
.75541 .19701 m .78633 .18983 L .80096 .20305 L p
.8 g
F P
s
P
p
.002 w
.40346 .19536 m .37383 .2025 L .35667 .18928 L p
.4 g
F P
s
P
p
0 1 .604 r
.01 w
.42316 .57495 m
.42316 .57495 L
s
P
p
.002 w
.17464 .19866 m .16018 .20222 L .151 .19563 L p
.4 g
F P
s
P
p
0 1 .623 r
.01 w
.42311 .57676 m
.42311 .57676 L
s
P
p
0 1 0 r
.01 w
.67992 .48022 m
.64938 .48645 L
s
P
p
.002 w
.47988 .19426 m .50997 .18706 L .52623 .20031 L p
.8 g
F P
s
P
p
0 1 .642 r
.01 w
.42307 .57857 m
.40619 .56756 L
s
P
p
0 1 .019 r
.01 w
.64944 .48822 m
.64944 .48822 L
s
P
p
.002 w
.80917 .19288 m .81643 .19948 L p
.78633 .18983 L .4 g
F P
s
P
p
.002 w
.63296 .19205 m .60255 .19921 L .58673 .18595 L p
.4 g
F P
s
P
p
.002 w
.55638 .19315 m .58673 .18595 L .60255 .19921 L p
.4 g
F P
s
P
p
.002 w
.151 .19563 m .14176 .189 L p
.17464 .19866 L .4 g
F P
s
P
p
.002 w
.14176 .189 m .15627 .1854 L .17464 .19866 L p
.4 g
F P
s
P
p
0 1 .038 r
.01 w
.64951 .48999 m
.64951 .48999 L
s
P
p
1 .868 0 r
.01 w
.72084 .32102 m
.75164 .31425 L
s
P
p
0 1 .434 r
.01 w
.46652 .53555 m
.48307 .54676 L
s
P
p
0 1 .057 r
.01 w
.64958 .49176 m
.68016 .48553 L
s
P
p
0 1 .453 r
.01 w
.48305 .54855 m
.48305 .54855 L
s
P
p
.057 1 0 r
.01 w
.71036 .46863 m
.67967 .47492 L
s
P
p
1 .792 0 r
.01 w
.67466 .30855 m
.67466 .30855 L
s
P
p
.002 w
.28014 .19039 m .30963 .18317 L .32711 .19646 L p
.8 g
F P
s
P
p
0 1 .472 r
.01 w
.48304 .55036 m
.48304 .55036 L
s
P
p
.038 1 0 r
.01 w
.67975 .47668 m
.67975 .47668 L
s
P
p
.002 w
.43328 .18817 m .40346 .19536 L .38643 .18206 L p
.4 g
F P
s
P
p
.002 w
.35667 .18928 m .38643 .18206 L .40346 .19536 L p
.4 g
F P
s
P
p
0 1 .491 r
.01 w
.48302 .55216 m
.46645 .54097 L
s
P
p
.019 1 0 r
.01 w
.67983 .47845 m
.67983 .47845 L
s
P
p
.002 w
.78633 .18983 m .80187 .18623 L .80917 .19288 L p
.4 g
F P
s
P
p
0 1 .547 r
.01 w
.43632 .55247 m
.40645 .5585 L
s
P
p
.002 w
.66356 .18484 m .63296 .19205 L .61726 .17871 L p
.4 g
F P
s
P
p
.002 w
.58673 .18595 m .61726 .17871 L .63296 .19205 L p
.4 g
F P
s
P
p
0 1 .679 r
.01 w
.40608 .5712 m
.3763 .57717 L
s
P
p
0 1 .566 r
.01 w
.4064 .56031 m
.4064 .56031 L
s
P
p
0 1 .698 r
.01 w
.37623 .57899 m
.37623 .57899 L
s
P
p
.075 1 0 r
.01 w
.74113 .46054 m
.71026 .46687 L
s
P
p
1 .887 0 r
.01 w
.75176 .31594 m
.75176 .31594 L
s
P
p
.002 w
.80187 .18623 m .78633 .18983 L p
.77153 .17647 L .4 g
F P
s
P
p
0 1 .717 r
.01 w
.37617 .58081 m
.37617 .58081 L
s
P
p
.002 w
.38643 .18206 m .35667 .18928 L .33931 .17591 L p
.4 g
F P
s
P
p
0 1 .075 r
.01 w
.68025 .4873 m
.68025 .4873 L
s
P
p
1 .906 0 r
.01 w
.73687 .30502 m
.75188 .31763 L
s
P
p
.002 w
.15627 .1854 m .14176 .189 L .13247 .18233 L p
.4 g
F P
s
P
p
0 1 .736 r
.01 w
.3761 .58263 m
.3761 .58263 L
s
P
p
.002 w
.38643 .18206 m .41637 .17478 L .43328 .18817 L p
.4 g
F P
s
P
p
0 1 .094 r
.01 w
.68033 .48908 m
.66489 .47748 L
s
P
p
0 1 .755 r
.01 w
.37603 .58445 m
.35877 .57342 L
s
P
p
0 1 .396 r
.01 w
.49671 .52582 m
.46657 .53195 L
s
P
p
.132 1 0 r
.01 w
.77181 .44887 m
.74079 .45525 L
s
P
p
0 1 .528 r
.01 w
.46641 .54459 m
.43636 .55066 L
s
P
p
.002 w
.79453 .17954 m .80187 .18623 L p
.77153 .17647 L .4 g
F P
s
P
p
0 1 .66 r
.01 w
.40614 .56938 m
.40614 .56938 L
s
P
p
0 1 .415 r
.01 w
.46654 .53375 m
.46654 .53375 L
s
P
p
.113 1 0 r
.01 w
.7409 .45701 m
.7409 .45701 L
s
P
p
.002 w
.13247 .18233 m .12312 .17563 L p
.15627 .1854 L .4 g
F P
s
P
p
.002 w
.12312 .17563 m .13769 .17197 L .15627 .1854 L p
.4 g
F P
s
P
p
.002 w
.69436 .17759 m .66356 .18484 L .648 .17141 L p
.4 g
F P
s
P
p
.002 w
.61726 .17871 m .648 .17141 L .66356 .18484 L p
.4 g
F P
s
P
p
.094 1 0 r
.01 w
.74102 .45877 m
.74102 .45877 L
s
P
p
0 1 .208 r
.01 w
.58792 .48917 m
.60386 .50073 L
s
P
p
.002 w
.41637 .17478 m .38643 .18206 L .36919 .16859 L p
.4 g
F P
s
P
p
.002 w
.33931 .17591 m .36919 .16859 L .38643 .18206 L p
.4 g
F P
s
P
p
0 1 .226 r
.01 w
.60391 .50252 m
.60391 .50252 L
s
P
p
0 1 .377 r
.01 w
.52703 .51784 m
.49671 .52402 L
s
P
p
.151 1 0 r
.01 w
.80289 .44068 m
.77168 .44711 L
s
P
p
0 1 .509 r
.01 w
.46643 .54278 m
.46643 .54278 L
s
P
p
0 1 .245 r
.01 w
.60395 .50431 m
.60395 .50431 L
s
P
p
.002 w
.57071 .17254 m .54024 .17982 L .52391 .16634 L p
.8 g
F P
s
P
p
.002 w
.77153 .17647 m .78714 .17282 L .79453 .17954 L p
.4 g
F P
s
P
p
0 1 .264 r
.01 w
.604 .5061 m
.58803 .49456 L
s
P
p
.226 1 0 r
.01 w
.78753 .42166 m
.80232 .43364 L
s
P
p
.002 w
.648 .17141 m .67893 .16407 L .69436 .17759 L p
.4 g
F P
s
P
p
0 1 .321 r
.01 w
.55748 .50622 m
.52701 .51244 L
s
P
p
.208 1 0 r
.01 w
.80246 .4354 m
.80246 .4354 L
s
P
p
.002 w
.78714 .17282 m .77153 .17647 L p
.75656 .16294 L .4 g
F P
s
P
p
0 1 .34 r
.01 w
.52702 .51424 m
.52702 .51424 L
s
P
p
.189 1 0 r
.01 w
.8026 .43716 m
.8026 .43716 L
s
P
p
.002 w
.13769 .17197 m .12312 .17563 L .11372 .16888 L p
.4 g
F P
s
P
p
.002 w
.44651 .16747 m .41637 .17478 L .39926 .16124 L p
.4 g
F P
s
P
p
.002 w
.36919 .16859 m .39926 .16124 L .41637 .17478 L p
.4 g
F P
s
P
p
0 1 .358 r
.01 w
.52703 .51604 m
.52703 .51604 L
s
P
p
.17 1 0 r
.01 w
.80275 .43892 m
.80275 .43892 L
s
P
p
1 .925 0 r
.01 w
.72178 .29395 m
.73698 .30671 L
s
P
p
0 1 .113 r
.01 w
.66496 .47926 m
.64933 .46753 L
s
P
p
0 1 .774 r
.01 w
.3587 .57525 m
.3587 .57525 L
s
P
p
.002 w
.77971 .16605 m .78714 .17282 L p
.75656 .16294 L .4 g
F P
s
P
p
.002 w
.52391 .16634 m .55451 .15896 L .57071 .17254 L p
.8 g
F P
s
P
p
.358 1 0 r
.01 w
.77166 .39721 m
.78658 .40936 L
s
P
p
1 .981 0 r
.01 w
.65997 .31287 m
.69093 .30599 L
s
P
p
.002 w
.12832 .1652 m .14296 .16152 L p
.13769 .17197 L .4 g
F P
s
P
p
.002 w
.16696 .16464 m .13769 .17197 L p
.14296 .16152 L .4 g
F P
s
P
p
.002 w
.11372 .16888 m .12832 .1652 L .13769 .17197 L p
.4 g
F P
s
P
p
0 1 .792 r
.01 w
.35862 .57708 m
.38861 .57106 L
s
P
p
.002 w
.67893 .16407 m .648 .17141 L .63225 .15782 L p
.4 g
F P
s
P
p
0 1 .17 r
.01 w
.61859 .47927 m
.58785 .48559 L
s
P
p
.34 1 0 r
.01 w
.78671 .41112 m
.78671 .41112 L
s
P
p
1 1 0 r
.01 w
.66005 .31457 m
.66005 .31457 L
s
P
p
0 1 .302 r
.01 w
.58811 .49816 m
.55746 .50442 L
s
P
p
0 1 .189 r
.01 w
.58788 .48738 m
.58788 .48738 L
s
P
p
.321 1 0 r
.01 w
.78685 .41287 m
.81825 .40631 L
s
P
p
.981 1 0 r
.01 w
.66012 .31627 m
.66012 .31627 L
s
P
p
.002 w
.32175 .16237 m .29195 .16972 L .27405 .15611 L p
.8 g
F P
s
P
p
.962 1 0 r
.01 w
.66019 .31798 m
.66019 .31798 L
s
P
p
.943 1 0 r
.01 w
.66027 .31969 m
.64456 .30697 L
s
P
p
.002 w
.47684 .1601 m .44651 .16747 L .42952 .15383 L p
.4 g
F P
s
P
p
.002 w
.39926 .16124 m .42952 .15383 L .44651 .16747 L p
.4 g
F P
s
P
p
.264 1 0 r
.01 w
.81871 .41158 m
.78726 .41814 L
s
P
p
1 .962 0 r
.01 w
.72199 .29736 m
.69085 .30428 L
s
P
p
.002 w
.75656 .16294 m .77223 .15925 L .77971 .16605 L p
.4 g
F P
s
P
p
.245 1 0 r
.01 w
.7874 .4199 m
.7874 .4199 L
s
P
p
0 1 .151 r
.01 w
.64946 .47111 m
.61854 .47748 L
s
P
p
.002 w
.15765 .15782 m .17238 .15411 L p
.16696 .16464 L .4 g
F P
s
P
p
.002 w
.19643 .15725 m .16696 .16464 L p
.17238 .15411 L .4 g
F P
s
P
p
.002 w
.14296 .16152 m .15765 .15782 L .16696 .16464 L p
.4 g
F P
s
P
p
0 1 .283 r
.01 w
.58807 .49636 m
.58807 .49636 L
s
P
p
.887 1 0 r
.01 w
.64476 .31211 m
.66049 .32482 L
s
P
p
.002 w
.63225 .15782 m .66331 .15039 L .67893 .16407 L p
.4 g
F P
s
P
p
0 1 .811 r
.01 w
.38855 .5729 m
.38855 .5729 L
s
P
p
.868 1 0 r
.01 w
.66056 .32654 m
.66056 .32654 L
s
P
p
.002 w
.77223 .15925 m .75656 .16294 L p
.7414 .14925 L .4 g
F P
s
P
p
.002 w
.35174 .15497 m .32175 .16237 L .30397 .14867 L p
.8 g
F P
s
P
p
.002 w
.27405 .15611 m .30397 .14867 L .32175 .16237 L p
.8 g
F P
s
P
p
0 1 .83 r
.01 w
.38849 .57474 m
.37111 .56352 L
s
P
p
.849 1 0 r
.01 w
.66064 .32825 m
.69174 .32139 L
s
P
p
.302 1 0 r
.01 w
.8184 .40806 m
.8184 .40806 L
s
P
p
.283 1 0 r
.01 w
.81856 .40982 m
.81856 .40982 L
s
P
p
.002 w
.50737 .15268 m .47684 .1601 L .45998 .14637 L p
.4 g
F P
s
P
p
.002 w
.42952 .15383 m .45998 .14637 L .47684 .1601 L p
.4 g
F P
s
P
p
.377 1 0 r
.01 w
.75645 .38314 m
.77153 .39545 L
s
P
p
1 .943 0 r
.01 w
.72189 .29565 m
.72189 .29565 L
s
P
p
.002 w
.76471 .1524 m .77223 .15925 L p
.7414 .14925 L .4 g
F P
s
P
p
0 1 .132 r
.01 w
.6494 .46932 m
.6494 .46932 L
s
P
p
.002 w
.66331 .15039 m .63225 .15782 L .61631 .14407 L p
.4 g
F P
s
P
p
.002 w
.18717 .15039 m .202 .14666 L p
.19643 .15725 L .4 g
F P
s
P
p
.002 w
.22608 .14982 m .19643 .15725 L p
.202 .14666 L .4 g
F P
s
P
p
.002 w
.17238 .15411 m .18717 .15039 L .19643 .15725 L p
.4 g
F P
s
P
p
.002 w
.30397 .14867 m .33409 .14118 L .35174 .15497 L p
.8 g
F P
s
P
p
.528 1 0 r
.01 w
.81869 .3556 m
.83344 .36811 L
s
P
p
.83 1 0 r
.01 w
.69183 .32311 m
.72315 .31621 L
s
P
p
.509 1 0 r
.01 w
.8336 .36985 m
.8336 .36985 L
s
P
p
.925 1 0 r
.01 w
.64463 .30868 m
.64463 .30868 L
s
P
p
.002 w
.45998 .14637 m .49064 .13887 L .50737 .15268 L p
.4 g
F P
s
P
p
.002 w
.7414 .14925 m .75715 .14551 L .76471 .1524 L p
.4 g
F P
s
P
p
.491 1 0 r
.01 w
.83376 .3716 m
.83376 .3716 L
s
P
p
.906 1 0 r
.01 w
.6447 .3104 m
.6447 .3104 L
s
P
p
.472 1 0 r
.01 w
.83392 .37335 m
.81915 .36086 L
s
P
p
.002 w
.61631 .14407 m .64751 .13655 L .66331 .15039 L p
.4 g
F P
s
P
p
.002 w
.21688 .14292 m .23181 .13916 L p
.22608 .14982 L .4 g
F P
s
P
p
.002 w
.25593 .14234 m .22608 .14982 L p
.23181 .13916 L .4 g
F P
s
P
p
.002 w
.202 .14666 m .21688 .14292 L .22608 .14982 L p
.4 g
F P
s
P
p
.002 w
.75715 .14551 m .7414 .14925 L p
.72606 .13539 L .4 g
F P
s
P
p
.415 1 0 r
.01 w
.7878 .3729 m
.7562 .37963 L
s
P
p
.002 w
.41233 .14003 m .38194 .14752 L .36441 .13365 L p
.8 g
F P
s
P
p
0 1 .849 r
.01 w
.37104 .56537 m
.35344 .55402 L
s
P
p
.396 1 0 r
.01 w
.75632 .38139 m
.75632 .38139 L
s
P
p
.002 w
.49064 .13887 m .45998 .14637 L .44292 .13248 L p
.4 g
F P
s
P
p
.002 w
.74954 .13858 m .75715 .14551 L p
.72606 .13539 L .4 g
F P
s
P
p
.002 w
.56904 .13771 m .5381 .14522 L .5215 .13132 L p
.8 g
F P
s
P
p
.811 1 0 r
.01 w
.72325 .31793 m
.72325 .31793 L
s
P
p
.002 w
.64751 .13655 m .61631 .14407 L .60017 .13015 L p
.4 g
F P
s
P
p
.585 1 0 r
.01 w
.80331 .3377 m
.81822 .35037 L
s
P
p
.792 1 0 r
.01 w
.72336 .31966 m
.70787 .3068 L
s
P
p
.566 1 0 r
.01 w
.81838 .35211 m
.81838 .35211 L
s
P
p
.002 w
.24679 .13539 m .26182 .13161 L p
.25593 .14234 L .4 g
F P
s
P
p
.002 w
.28598 .13481 m .25593 .14234 L p
.26182 .13161 L .4 g
F P
s
P
p
.002 w
.23181 .13916 m .24679 .13539 L .25593 .14234 L p
.4 g
F P
s
P
p
.434 1 0 r
.01 w
.81946 .36436 m
.78767 .37115 L
s
P
p
.547 1 0 r
.01 w
.81853 .35386 m
.81853 .35386 L
s
P
p
.736 1 0 r
.01 w
.70817 .31201 m
.72368 .32485 L
s
P
p
.002 w
.44292 .13248 m .41233 .14003 L .39492 .12606 L p
.8 g
F P
s
P
p
.002 w
.36441 .13365 m .39492 .12606 L .41233 .14003 L p
.8 g
F P
s
P
p
.717 1 0 r
.01 w
.72379 .32658 m
.72379 .32658 L
s
P
p
.002 w
.44292 .13248 m .47371 .12489 L .49064 .13887 L p
.4 g
F P
s
P
p
0 1 .887 r
.01 w
.35328 .55773 m
.32297 .56389 L
s
P
p
.002 w
.72606 .13539 m .74188 .13161 L .74954 .13858 L p
.4 g
F P
s
P
p
.698 1 0 r
.01 w
.72389 .32832 m
.75553 .32138 L
s
P
p
.002 w
.5215 .13132 m .55257 .12371 L .56904 .13771 L p
.8 g
F P
s
P
p
0 1 .906 r
.01 w
.32287 .56574 m
.32287 .56574 L
s
P
p
.002 w
.60017 .13015 m .63151 .12254 L .64751 .13655 L p
.4 g
F P
s
P
p
0 1 .925 r
.01 w
.32277 .5676 m
.32277 .5676 L
s
P
p
.453 1 0 r
.01 w
.8193 .36261 m
.8193 .36261 L
s
P
p
.002 w
.74188 .13161 m .72606 .13539 L p
.71054 .12136 L .4 g
F P
s
P
p
0 1 .943 r
.01 w
.32268 .56946 m
.32268 .56946 L
s
P
p
.002 w
.2769 .12781 m .29203 .12401 L p
.28598 .13481 L .4 g
F P
s
P
p
.002 w
.31622 .12723 m .28598 .13481 L p
.29203 .12401 L .4 g
F P
s
P
p
.002 w
.26182 .13161 m .2769 .12781 L .28598 .13481 L p
.4 g
F P
s
P
p
0 1 .962 r
.01 w
.32258 .57132 m
.30459 .55994 L
s
P
p
.002 w
.39492 .12606 m .42564 .11842 L .44292 .13248 L p
.8 g
F P
s
P
p
0 1 .868 r
.01 w
.35336 .55587 m
.35336 .55587 L
s
P
p
.002 w
.73417 .12459 m .74188 .13161 L p
.71054 .12136 L .4 g
F P
s
P
p
.002 w
.55257 .12371 m .5215 .13132 L .5047 .11724 L p
.8 g
F P
s
P
p
.604 1 0 r
.01 w
.78808 .32313 m
.80317 .33595 L
s
P
p
.002 w
.63151 .12254 m .60017 .13015 L .58384 .11606 L p
.4 g
F P
s
P
p
.679 1 0 r
.01 w
.75566 .32312 m
.78752 .31615 L
s
P
p
.774 1 0 r
.01 w
.70797 .30854 m
.70797 .30854 L
s
P
p
.755 1 0 r
.01 w
.70807 .31027 m
.70807 .31027 L
s
P
p
.002 w
.3072 .12019 m .32243 .11635 L p
.31622 .12723 L .4 g
F P
s
P
p
.002 w
.34666 .1196 m .31622 .12723 L p
.32243 .11635 L .4 g
F P
s
P
p
.002 w
.29203 .12401 m .3072 .12019 L .31622 .12723 L p
.4 g
F P
s
P
p
.002 w
.71054 .12136 m .72642 .11754 L .73417 .12459 L p
.4 g
F P
s
P
p
.002 w
.5047 .11724 m .5359 .10954 L .55257 .12371 L p
.8 g
F P
s
P
p
.002 w
.58384 .11606 m .61532 .10836 L .63151 .12254 L p
.4 g
F P
s
P
p
.002 w
.72642 .11754 m .71054 .12136 L p
.69482 .10717 L .4 g
F P
s
P
p
.66 1 0 r
.01 w
.78766 .31789 m
.78766 .31789 L
s
P
p
.002 w
.33771 .11251 m .35304 .10865 L p
.34666 .1196 L .4 g
F P
s
P
p
.002 w
.37731 .11192 m .34666 .1196 L p
.35304 .10865 L .4 g
F P
s
P
p
.002 w
.32243 .11635 m .33771 .11251 L .34666 .1196 L p
.4 g
F P
s
P
p
.642 1 0 r
.01 w
.7878 .31963 m
.7878 .31963 L
s
P
p
0 1 .981 r
.01 w
.30448 .56181 m
.30448 .56181 L
s
P
p
.002 w
.45656 .11073 m .42564 .11842 L .40816 .10419 L p
.4 g
F P
s
P
p
.623 1 0 r
.01 w
.78794 .32138 m
.78794 .32138 L
s
P
p
0 1 1 r
.01 w
.30437 .56368 m
.33491 .55746 L
s
P
p
.002 w
.71862 .11043 m .72642 .11754 L p
.69482 .10717 L .4 g
F P
s
P
p
.002 w
.5359 .10954 m .5047 .11724 L .48769 .10299 L p
.8 g
F P
s
P
p
.002 w
.61532 .10836 m .58384 .11606 L .56731 .1018 L p
.4 g
F P
s
P
p
.002 w
.36842 .10478 m .38385 .1009 L p
.37731 .11192 L .4 g
F P
s
P
p
.002 w
.40816 .10419 m .37731 .11192 L p
.38385 .1009 L .4 g
F P
s
P
p
.002 w
.35304 .10865 m .36842 .10478 L .37731 .11192 L p
.4 g
F P
s
P
p
.002 w
.40816 .10419 m .43921 .0964 L .45656 .11073 L p
.4 g
F P
s
P
p
.002 w
.69482 .10717 m .71078 .10329 L .71862 .11043 L p
.4 g
F P
s
P
p
.002 w
.48769 .10299 m .51903 .0952 L .5359 .10954 L p
.8 g
F P
s
P
p
0 .981 1 r
.01 w
.33482 .55934 m
.33482 .55934 L
s
P
p
.002 w
.64701 .1006 m .61532 .10836 L .59893 .094 L p
.4 g
F P
s
P
p
.002 w
.56731 .1018 m .59893 .094 L .61532 .10836 L p
.4 g
F P
s
P
p
0 .962 1 r
.01 w
.33473 .56121 m
.3166 .54964 L
s
P
p
.002 w
.71078 .10329 m .69482 .10717 L p
.67891 .09279 L .4 g
F P
s
P
p
.002 w
.39933 .097 m .41487 .09309 L p
.40816 .10419 L .4 g
F P
s
P
p
.002 w
.43921 .0964 m .40816 .10419 L p
.41487 .09309 L .4 g
F P
s
P
p
.002 w
.38385 .1009 m .39933 .097 L .40816 .10419 L p
.4 g
F P
s
P
p
0 .906 1 r
.01 w
.31629 .5553 m
.33445 .56685 L
s
P
p
.002 w
.70288 .0961 m .71078 .10329 L p
.67891 .09279 L .4 g
F P
s
P
p
0 .887 1 r
.01 w
.33436 .56874 m
.33436 .56874 L
s
P
p
0 .868 1 r
.01 w
.33427 .57063 m
.36511 .56439 L
s
P
p
.002 w
.67891 .09279 m .64701 .1006 L .63076 .08615 L p
.4 g
F P
s
P
p
.002 w
.59893 .094 m .63076 .08615 L .64701 .1006 L p
.4 g
F P
s
P
p
.002 w
.43045 .08917 m .44609 .08524 L p
.43921 .0964 L .4 g
F P
s
P
p
.002 w
.47047 .08857 m .43921 .0964 L p
.44609 .08524 L .4 g
F P
s
P
p
.002 w
.41487 .09309 m .43045 .08917 L .43921 .0964 L p
.4 g
F P
s
P
p
.002 w
.67891 .09279 m .69494 .08887 L .70288 .0961 L p
.4 g
F P
s
P
p
.002 w
.69494 .08887 m .67891 .09279 L p
.6628 .07824 L .4 g
F P
s
P
p
.002 w
.63076 .08615 m .6628 .07824 L .67891 .09279 L p
.4 g
F P
s
P
p
0 .849 1 r
.01 w
.36504 .56628 m
.3961 .56001 L
s
P
p
0 .943 1 r
.01 w
.31649 .55153 m
.31649 .55153 L
s
P
p
0 .925 1 r
.01 w
.31639 .55341 m
.31639 .55341 L
s
P
p
.002 w
.68694 .08159 m .69494 .08887 L p
.6628 .07824 L .4 g
F P
s
P
p
.002 w
.46178 .08129 m .47753 .07733 L p
.47047 .08857 L .4 g
F P
s
P
p
.002 w
.50194 .08068 m .47047 .08857 L p
.47753 .07733 L .4 g
F P
s
P
p
.002 w
.44609 .08524 m .46178 .08129 L .47047 .08857 L p
.4 g
F P
s
P
p
0 .83 1 r
.01 w
.39604 .56191 m
.39604 .56191 L
s
P
p
0 .811 1 r
.01 w
.39598 .5638 m
.37804 .55212 L
s
P
p
.002 w
.6628 .07824 m .6789 .07427 L .68694 .08159 L p
.4 g
F P
s
P
p
.002 w
.49332 .07335 m .50917 .06936 L p
.50194 .08068 L .4 g
F P
s
P
p
.002 w
.53363 .07274 m .50194 .08068 L p
.50917 .06936 L .4 g
F P
s
P
p
.002 w
.47753 .07733 m .49332 .07335 L .50194 .08068 L p
.4 g
F P
s
P
p
.002 w
.6789 .07427 m .6628 .07824 L p
.64649 .06351 L .4 g
F P
s
P
p
.002 w
.67081 .0669 m .6789 .07427 L p
.64649 .06351 L .4 g
F P
s
P
p
.002 w
.52508 .06536 m .54103 .06134 L p
.53363 .07274 L .4 g
F P
s
P
p
.002 w
.56553 .06474 m .53363 .07274 L p
.54103 .06134 L .4 g
F P
s
P
p
.002 w
.50917 .06936 m .52508 .06536 L .53363 .07274 L p
.4 g
F P
s
P
p
.002 w
.64649 .06351 m .66266 .05949 L .67081 .0669 L p
.4 g
F P
s
P
p
0 .792 1 r
.01 w
.37797 .55403 m
.35979 .54221 L
s
P
p
.002 w
.55705 .05731 m .57311 .05327 L p
.56553 .06474 L .4 g
F P
s
P
p
.002 w
.59764 .05669 m .56553 .06474 L p
.57311 .05327 L .4 g
F P
s
P
p
.002 w
.54103 .06134 m .55705 .05731 L .56553 .06474 L p
.4 g
F P
s
P
p
.002 w
.66266 .05949 m .64649 .06351 L p
.62997 .04859 L .4 g
F P
s
P
p
.002 w
.65447 .05202 m .66266 .05949 L p
.62997 .04859 L .4 g
F P
s
P
p
0 .755 1 r
.01 w
.35963 .54604 m
.32821 .55245 L
s
P
p
.002 w
.58923 .04921 m .60541 .04514 L p
.59764 .05669 L .4 g
F P
s
P
p
.002 w
.62997 .04859 m .59764 .05669 L p
.60541 .04514 L .4 g
F P
s
P
p
.002 w
.57311 .05327 m .58923 .04921 L .59764 .05669 L p
.4 g
F P
s
P
p
0 .736 1 r
.01 w
.32812 .55437 m
.32812 .55437 L
s
P
p
0 .717 1 r
.01 w
.32802 .55628 m
.32802 .55628 L
s
P
p
0 .698 1 r
.01 w
.32793 .5582 m
.35939 .5518 L
s
P
p
.002 w
.62997 .04859 m .64622 .04452 L .65447 .05202 L p
.4 g
F P
s
P
p
0 .774 1 r
.01 w
.35971 .54412 m
.35971 .54412 L
s
P
p
.002 w
.62164 .04106 m .63792 .03696 L p
.62997 .04859 L .4 g
F P
s
P
p
.002 w
.64622 .04452 m .62997 .04859 L p
.63792 .03696 L .4 g
F P
s
P
p
.002 w
.60541 .04514 m .62164 .04106 L .62997 .04859 L p
.4 g
F P
s
P
p
0 .679 1 r
.01 w
.35931 .55372 m
.35931 .55372 L
s
P
p
0 .66 1 r
.01 w
.35923 .55565 m
.34074 .54371 L
s
P
p
0 .642 1 r
.01 w
.34065 .54565 m
.32192 .53357 L
s
P
p
0 .604 1 r
.01 w
.32172 .53746 m
.28991 .54401 L
s
P
p
0 .585 1 r
.01 w
.28979 .54595 m
.28979 .54595 L
s
P
p
0 .566 1 r
.01 w
.28967 .5479 m
.28967 .5479 L
s
P
p
0 .547 1 r
.01 w
.28955 .54985 m
.32142 .5433 L
s
P
p
0 .623 1 r
.01 w
.32182 .53551 m
.32182 .53551 L
s
P
p
0 .528 1 r
.01 w
.32131 .54525 m
.32131 .54525 L
s
P
p
0 .509 1 r
.01 w
.32121 .54721 m
.30217 .53502 L
s
P
p
0 .491 1 r
.01 w
.30205 .53698 m
.28275 .52464 L
s
P
p
0 .453 1 r
.01 w
.2825 .52858 m
.25027 .53528 L
s
P
p
0 .434 1 r
.01 w
.25013 .53725 m
.25013 .53725 L
s
P
p
0 .415 1 r
.01 w
.24999 .53923 m
.24999 .53923 L
s
P
p
0 .396 1 r
.01 w
.24985 .5412 m
.28213 .53451 L
s
P
p
0 .472 1 r
.01 w
.28263 .52661 m
.28263 .52661 L
s
P
p
0 .377 1 r
.01 w
.282 .53649 m
.282 .53649 L
s
P
p
0 .358 1 r
.01 w
.28188 .53848 m
.26224 .52602 L
s
P
p
0 .34 1 r
.01 w
.2621 .52801 m
.2422 .51539 L
s
P
p
0 .302 1 r
.01 w
.2419 .51939 m
.20925 .52624 L
s
P
p
0 .283 1 r
.01 w
.20908 .52824 m
.20908 .52824 L
s
P
p
0 .264 1 r
.01 w
.20892 .53025 m
.20892 .53025 L
s
P
p
0 .245 1 r
.01 w
.20875 .53225 m
.24145 .52541 L
s
P
p
0 .321 1 r
.01 w
.24205 .51739 m
.24205 .51739 L
s
P
p
0 .226 1 r
.01 w
.2413 .52743 m
.2413 .52743 L
s
P
p
0 .208 1 r
.01 w
.24115 .52944 m
.22089 .5167 L
s
P
p
0 .094 1 r
.01 w
.25314 .52191 m
.27333 .53471 L
s
P
p
0 .189 1 r
.01 w
.22073 .51872 m
.22073 .51872 L
s
P
p
0 .075 1 r
.01 w
.27319 .53674 m
.27319 .53674 L
s
P
p
0 .17 1 r
.01 w
.22057 .52074 m
.22057 .52074 L
s
P
p
0 .057 1 r
.01 w
.27306 .53877 m
.30641 .53187 L
s
P
p
0 .151 1 r
.01 w
.2204 .52277 m
.2204 .52277 L
s
P
p
0 .132 1 r
.01 w
.22024 .5248 m
.25343 .51784 L
s
P
p
0 .038 1 r
.01 w
.3063 .53391 m
.33992 .52696 L
s
P
p
0 .113 1 r
.01 w
.25329 .51987 m
.25329 .51987 L
s
P
p
0 .019 1 r
.01 w
.33982 .52901 m
.33982 .52901 L
s
P
p
0 0 1 r
.01 w
.33972 .53106 m
.31978 .51811 L
s
P
p
1 0 .151 r
.01 w
.55803 .82342 m
.57639 .83433 L
s
P
p
1 0 .132 r
.01 w
.57642 .83655 m
.57642 .83655 L
s
P
p
1 0 .113 r
.01 w
.57646 .83878 m
.57646 .83878 L
s
P
p
1 0 .094 r
.01 w
.5765 .84101 m
.5581 .83013 L
s
P
p
.113 0 1 r
.01 w
.3533 .52342 m
.37315 .53643 L
s
P
p
.019 0 1 r
.01 w
.31967 .52016 m
.31967 .52016 L
s
P
p
1 0 .189 r
.01 w
.59293 .81298 m
.55797 .81896 L
s
P
p
.132 0 1 r
.01 w
.37307 .5385 m
.37307 .5385 L
s
P
p
1 0 .057 r
.01 w
.55816 .83462 m
.52332 .84052 L
s
P
p
.038 0 1 r
.01 w
.31957 .52222 m
.31957 .52222 L
s
P
p
1 0 .17 r
.01 w
.558 .82119 m
.558 .82119 L
s
P
p
.151 0 1 r
.01 w
.37299 .54057 m
.4073 .53355 L
s
P
p
1 0 .038 r
.01 w
.52332 .84276 m
.52332 .84276 L
s
P
p
.057 0 1 r
.01 w
.31946 .52429 m
.31946 .52429 L
s
P
p
1 0 .019 r
.01 w
.52333 .84501 m
.52333 .84501 L
s
P
p
.075 0 1 r
.01 w
.31935 .52635 m
.35348 .51928 L
s
P
p
1 0 .34 r
.01 w
.5205 .77876 m
.53926 .79006 L
s
P
p
1 0 .226 r
.01 w
.57444 .79734 m
.59284 .80851 L
s
P
p
1 0 .321 r
.01 w
.53928 .79228 m
.53928 .79228 L
s
P
p
1 0 .208 r
.01 w
.59289 .81074 m
.59289 .81074 L
s
P
p
1 0 .302 r
.01 w
.53929 .7945 m
.5743 .78841 L
s
P
p
1 0 .075 r
.01 w
.55813 .83237 m
.55813 .83237 L
s
P
p
.17 0 1 r
.01 w
.40724 .53563 m
.44181 .52856 L
s
P
p
.094 0 1 r
.01 w
.35339 .52135 m
.35339 .52135 L
s
P
p
1 0 .283 r
.01 w
.57433 .79064 m
.57433 .79064 L
s
P
p
1 0 .264 r
.01 w
.57437 .79287 m
.57437 .79287 L
s
P
p
1 0 .358 r
.01 w
.50148 .76507 m
.52049 .77654 L
s
P
p
1 0 .245 r
.01 w
.57441 .7951 m
.57441 .7951 L
s
P
p
.189 0 1 r
.01 w
.44177 .53065 m
.44177 .53065 L
s
P
p
.208 0 1 r
.01 w
.44173 .53273 m
.44173 .53273 L
s
P
p
.226 0 1 r
.01 w
.44169 .53482 m
.47659 .52772 L
s
P
p
1 0 .396 r
.01 w
.53674 .75433 m
.50149 .76061 L
s
P
p
.245 0 1 r
.01 w
.47657 .52981 m
.51175 .52265 L
s
P
p
1 0 .377 r
.01 w
.50149 .76284 m
.50149 .76284 L
s
P
p
1 0 .415 r
.01 w
.57223 .74576 m
.53673 .7521 L
s
P
p
1 0 .491 r
.01 w
.55324 .72498 m
.57209 .73684 L
s
P
p
.264 0 1 r
.01 w
.51175 .52475 m
.51175 .52475 L
s
P
p
1 0 .472 r
.01 w
.57212 .73907 m
.57212 .73907 L
s
P
p
.283 0 1 r
.01 w
.51174 .52686 m
.49246 .51352 L
s
P
p
1 0 .453 r
.01 w
.57216 .7413 m
.57216 .7413 L
s
P
p
1 0 .434 r
.01 w
.57219 .74352 m
.57219 .74352 L
s
P
p
1 0 .528 r
.01 w
.58901 .71402 m
.55319 .72052 L
s
P
p
1 0 .509 r
.01 w
.55321 .72275 m
.55321 .72275 L
s
P
p
.302 0 1 r
.01 w
.49244 .51563 m
.49244 .51563 L
s
P
p
1 0 .566 r
.01 w
.57002 .6974 m
.58892 .70956 L
s
P
p
.321 0 1 r
.01 w
.49243 .51774 m
.49243 .51774 L
s
P
p
1 0 .547 r
.01 w
.58896 .71179 m
.58896 .71179 L
s
P
p
.34 0 1 r
.01 w
.49242 .51986 m
.49242 .51986 L
s
P
p
.358 0 1 r
.01 w
.49241 .52198 m
.52815 .51469 L
s
P
p
1 0 .604 r
.01 w
.60614 .68627 m
.56996 .69294 L
s
P
p
.377 0 1 r
.01 w
.52816 .51682 m
.52816 .51682 L
s
P
p
1 0 .585 r
.01 w
.56999 .69517 m
.56999 .69517 L
s
P
p
.396 0 1 r
.01 w
.52817 .51895 m
.52817 .51895 L
s
P
p
.415 0 1 r
.01 w
.52818 .52108 m
.52818 .52108 L
s
P
p
.434 0 1 r
.01 w
.52819 .52321 m
.52819 .52321 L
s
P
p
1 0 .755 r
.01 w
.53132 .65019 m
.55064 .66277 L
s
P
p
.453 0 1 r
.01 w
.5282 .52535 m
.5282 .52535 L
s
P
p
1 0 .642 r
.01 w
.5871 .66935 m
.60603 .68181 L
s
P
p
1 0 .736 r
.01 w
.55066 .66499 m
.55066 .66499 L
s
P
p
.472 0 1 r
.01 w
.52821 .52749 m
.52821 .52749 L
s
P
p
1 0 .623 r
.01 w
.60609 .68404 m
.60609 .68404 L
s
P
p
1 0 .717 r
.01 w
.55068 .66721 m
.58692 .66043 L
s
P
p
.491 0 1 r
.01 w
.52822 .52963 m
.56438 .52231 L
s
P
p
1 0 .698 r
.01 w
.58697 .66265 m
.58697 .66265 L
s
P
p
.509 0 1 r
.01 w
.56441 .52446 m
.56441 .52446 L
s
P
p
1 0 .679 r
.01 w
.58701 .66489 m
.58701 .66489 L
s
P
p
.528 0 1 r
.01 w
.56444 .52661 m
.56444 .52661 L
s
P
p
1 0 .774 r
.01 w
.51172 .63519 m
.53131 .64796 L
s
P
p
1 0 .66 r
.01 w
.58706 .66712 m
.58706 .66712 L
s
P
p
.547 0 1 r
.01 w
.56447 .52876 m
.56447 .52876 L
s
P
p
.566 0 1 r
.01 w
.5645 .53091 m
.5645 .53091 L
s
P
p
.585 0 1 r
.01 w
.56453 .53307 m
.56453 .53307 L
s
P
p
.604 0 1 r
.01 w
.56456 .53523 m
.56456 .53523 L
s
P
p
.623 0 1 r
.01 w
.5646 .53739 m
.60119 .53005 L
s
P
p
1 0 .811 r
.01 w
.54822 .62372 m
.51172 .63073 L
s
P
p
1 0 .792 r
.01 w
.51172 .63296 m
.51172 .63296 L
s
P
p
.642 0 1 r
.01 w
.60124 .53222 m
.60124 .53222 L
s
P
p
.66 0 1 r
.01 w
.6013 .53439 m
.6013 .53439 L
s
P
p
.679 0 1 r
.01 w
.60135 .53656 m
.60135 .53656 L
s
P
p
.906 0 1 r
.01 w
.65812 .56903 m
.6211 .57626 L
s
P
p
1 0 .962 r
.01 w
.62155 .59172 m
.58466 .59887 L
s
P
p
.698 0 1 r
.01 w
.6014 .53874 m
.6014 .53874 L
s
P
p
.925 0 1 r
.01 w
.62116 .57846 m
.62116 .57846 L
s
P
p
1 0 .83 r
.01 w
.58496 .61443 m
.5482 .62149 L
s
P
p
1 0 .943 r
.01 w
.5847 .60109 m
.5847 .60109 L
s
P
p
.717 0 1 r
.01 w
.60146 .54092 m
.60146 .54092 L
s
P
p
.943 0 1 r
.01 w
.62123 .58067 m
.62123 .58067 L
s
P
p
.83 0 1 r
.01 w
.6389 .54669 m
.65777 .56023 L
s
P
p
1 0 .925 r
.01 w
.58475 .6033 m
.58475 .6033 L
s
P
p
.736 0 1 r
.01 w
.60151 .5431 m
.60151 .5431 L
s
P
p
.962 0 1 r
.01 w
.62129 .58287 m
.62129 .58287 L
s
P
p
.849 0 1 r
.01 w
.65786 .56243 m
.65786 .56243 L
s
P
p
1 0 .906 r
.01 w
.58479 .60552 m
.58479 .60552 L
s
P
p
.755 0 1 r
.01 w
.60156 .54529 m
.6386 .53791 L
s
P
p
.981 0 1 r
.01 w
.62136 .58508 m
.62136 .58508 L
s
P
p
.868 0 1 r
.01 w
.65795 .56462 m
.65795 .56462 L
s
P
p
1 0 .887 r
.01 w
.58483 .60775 m
.58483 .60775 L
s
P
p
1 0 1 r
.01 w
.62142 .58729 m
.62142 .58729 L
s
P
p
.887 0 1 r
.01 w
.65803 .56682 m
.65803 .56682 L
s
P
p
1 0 .868 r
.01 w
.58488 .60997 m
.58488 .60997 L
s
P
p
1 0 .981 r
.01 w
.62149 .5895 m
.62149 .5895 L
s
P
p
1 0 .849 r
.01 w
.58492 .6122 m
.58492 .6122 L
s
P
p
.774 0 1 r
.01 w
.63867 .5401 m
.63867 .5401 L
s
P
p
.792 0 1 r
.01 w
.63875 .5423 m
.63875 .5423 L
s
P
p
.811 0 1 r
.01 w
.63882 .54449 m
.63882 .54449 L
s
P
p
.002 w
.63741 .02391 m
.8921 .25702 L
s
.8921 .25702 m
.96284 .88539 L
s
.96284 .88539 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.11528 .15603 m
.03716 .79936 L
s
.03716 .79936 m
.6637 .68453 L
s
.6637 .68453 m
.63741 .02391 L
s
.63741 .02391 m
.11528 .15603 L
s
P
p
p
.002 w
.11528 .15603 m
.63741 .02391 L
s
P
p
.002 w
.23292 .12626 m
.23893 .13082 L
s
P
[(5)] .22092 .11714 .84695 1 Mshowa
p
.002 w
.38437 .08794 m
.39013 .09263 L
s
P
[(10)] .37284 .07856 .79165 1 Mshowa
p
.002 w
.54092 .04833 m
.54642 .05314 L
s
P
[(15)] .5299 .0387 .73636 1 Mshowa
p
.001 w
.26282 .1187 m
.26639 .12145 L
s
P
p
.001 w
.29291 .11108 m
.29645 .11385 L
s
P
p
.001 w
.32319 .10342 m
.32671 .1062 L
s
P
p
.001 w
.35368 .0957 m
.35717 .0985 L
s
P
p
.001 w
.41526 .08012 m
.41869 .08295 L
s
P
p
.001 w
.44636 .07225 m
.44976 .0751 L
s
P
p
.001 w
.47767 .06433 m
.48104 .06719 L
s
P
p
.001 w
.50919 .05636 m
.51252 .05923 L
s
P
p
.001 w
.20323 .13377 m
.20686 .1365 L
s
P
p
.001 w
.17372 .14124 m
.17738 .14395 L
s
P
p
.001 w
.14441 .14866 m
.14809 .15135 L
s
P
p
.001 w
.57286 .04024 m
.57613 .04315 L
s
P
p
.001 w
.60502 .03211 m
.60826 .03503 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .29951 .03573 .79718 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{282, 282},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J00016PP10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`0004T0
0ol300;o0`03o`800ol20003o`0003000ol300?oP00004P000Oo0000o`3o008000?o0?l00P001_l0
0?l0o`8000?o0000<@000ol000050003o`0007d0001<0003o`3o008000?o0?l00P001_l00?l0o`80
00?o0000<@000ol000050003o`0007d0001900?o0P001_l00?l0o`8000Ko003o0?l20003o`000340
00?o00000P03oa/01?mQ0000B0000ol0000400;o0P001Ol00?l000Ko=0000ol000020003o`0001L0
1?l20003o`3o060000180005o`000?l030000ol0o`0e00;o1004oa801?l60004o`00oel0001900?o
3`000ol0001;00Co0P000ol000050005o`000?l0GP000:D01?l<00Co00@0ooooG@000:800ol20003
o`0000L01?l2P@03oh7o00<000?o0000FP0009h01?l;00Co0h400on1P@04o`<000?o0000F@0009X0
1Ol900Go2843o`>100Go0000o`1J0000I`03o`@00_lV00Co1@000ol0000200Co18400on1P@04o`05
^l^kbol018400ol00002oeT0001X0003o`00008000Co003o8@04o`X01?l9P@;o2;/00on1P@03P@05
o`000?l0F00006P000?o00000P001?l00?lM00Co10000ol0000200Go0h400on1P@05o`0>^l^kbk_;
^l^kbk_;ol/3P@?o0`02oeH0001X0003o`00008000Co003o6@04o`T01?l9P@;o4K/00onk^`02o`>1
00?o00000P000ol0000700?oB@0006P000?o00000P001?l00?lE00Co0`000ol0000300Co0h400on1
P@05o`0Ibk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kb`05P@03o`0000?o2`000ol000160000I`02o`D0
0_lB00Co2@04o`R10_lJ^`03ok^k00:k1H42o`<000?o000020000ol000160000O`03o`<000?o0000
0P05o`>100?oPH401?l09;_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kb`>11?l30003
o`0000@00om90000N`04o`P00ol9P@;o8k/01?nk^k/4o`B100Go0000o`050003o`0004T0001g00Co
0P000ol0000500;o0h400on1P@04o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^k00Co0h400on1P@03P@05o`21POl01004odP0001c00Co2P04o`J10_lW^`Go1h400on1P@03P@;o
0P000ol0001=0000@`03obT01?l00`3oP@0700Go1H43o`0Ubk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kb`05o`>10_l8P@04oh61P@Co0P000ol0001<0000AP000ol0000R00Co1P001?n1
0005o`>100?oPH400ol?^`?o4[/4o`V100?oPH401h43o`B100Co003oC@0004H000?o00007P04o`03
0?l000L01Ol8P@;o00g;^l^kbk_;^l^kbk_;00Go0e/03Oo;^l^kbk_;^l^kbk/01Ol3P@03oh6100N1
0_l2P@Co00C;^l^k1X44od`0001300?o7@04o`X01?l4P@03oh6100Co1842o`Vk0_l9F`03ok^k00Nk
0_l9P@03oh6100J100CoPOoo2[/3P@03oh7o00800_m:0000@`000ol0000I00Co00<0o`001`04o`V1
0_l:P@0<ok_;^l^kbk_;^l_o2E/03?o;^l^kbk_;^l^ko`V100?oPH401_l03[_;^l^kbk_;^l^kbk_;
0_l3P@05o`000?l0B@0004<01?lD00Co2P04o`B100?oPH401?l4^`;o2H400onk^`08^`03oe]K00MK
0_l9^`03oh6100N10_l5^`03ok^k00fk1H401Ol0003o02H01Ol01@3oool000?o0`02oa00001H00Go
2004o`V10_l02l^kbk_;^l^kbk_o00:11?l03k_;^l^kbk_;^l^kbk_;o`02F`Co15/02onkbk_;^l^k
bk_o00:11?l4P@0Fol^kbk_o^l^kbk_;^l^kbk_;^l^kb`F100?o0?l00_lU0003o`00008000Co003o
10001?l00?lA0000E004o`T01?l3P@03oh6100Go3K/4oa>k0_l9F`03ok^k00Nk0_l9P@05ok^k^ol0
4K/3P@?o0`000ol0000R0003o`0000<00ol200;o0`000ol0000?0000D005o`P01?l8P@;o00fkbk_;
^l^kbk_;^l^k00Go0e/05_nkbk_;^l^kbk_;^l^kbk_;^l^kbol:F`0;ok_;^l^kbk_;^ol02X405_o;
^onkbk_;^l^kbk_;^l^kbk_;^l/2o`>100Go0000o`0S00Go0`000ol0o`050003o`0000l0001<00Co
2@04o`>100?oPH401?l>^`?o2E/00onk^`05^`Co2K/00omKF`08F`03ok^k00Nk00?oPH402843oa>k
1H401Ol0003o028000?o00000`02o`<00ol0103oool@0000B004o`03P@0000H01?l8P@;o00nkbk_;
^l^kbk_;^l^kbk/00ol3F`03oe]K00MK00?o^l/01?l4P@0;ol^kbk_;^l^kbol00U/5o`=K00_o^l^k
bk_;^l^ko`02P@Go18405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`05P@05o`3o0?l08@000ol0000=0003
o`0000l0001400Co10000on1000200Co0h400on1P@04oa2k0ol7F`03oe]K00MK0_l9P@03ok^k00Nk
0_l9F`03ok^k00Nk0_l9P@;o5;/3P@?o0`000ol0000N00Go7@0004001Ol800Co2842o`0D^l^kbk_;
^l^kbk_;^l^kbk_;^ol;F`03oe]K00Co00Fkbk_;o`09P@0<ol^kbk_;^l^kbk_o2E/02onkbk_;^l^k
bk_;00;o1h405on1ok_;^l^kbk_;^l^kbk_;^l^kbk_;00;o0h401Ol0003o00X00ol400;o;P0003`0
1?l900Co0h400on1P@04oaVk0_l9F`;o2K/00on1P@07P@03ok^k00Rk00?oFe/01e/00onk^`09^`03
oh6100Go0X400onk^`0B^`F10_l0103oool90003o`00008000Co003o;@0003T01?l800Co2842o`0A
^l^kbk_;^l^kbk_;^l^kbk/01?l02l^kbk_;^l^kbk_o009K1?l03k_;^l^kbk_;^l^kbk_;o`02P@Co
0h403?o;^l^kbk_;^l^ko`9K1?l03k_;^l^kbk_;^l^kbk_;^`02o`B101WoPH61ok_;^l^kbk_;^l^k
bk_;^l^kbk_;00F10_l30003o`0000H000?o00000P001?l00?l]0000=@04o`P01?l3P@03oh6100Co
4K/4o`AK0_l9^`;o4K/4o`R100?o^k/02;/2oaBk00?oPH400X400on1P@02P@03ok^k01:k0h44o`<0
00?o00001@000ol000020004o`00obd0000a00Co2004o`R10_l04K_;^l^kbk_;^l^kbk_;^l^k00Co
2U/06?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co0h400on1P@07P@0Rol^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`>100?oPH400h405Onkbk_;^l^kbk_;^l^kbk_;^l^kb`02o`>10_l30003
o`0000@000?o00000P001?l00?l]0000;@04o`P01?l3P@03oh6100Co4K/4o`AK0_l9F`03ok^k012k
1?l8P@03oh6100N100?o^k/07[/00on1P@04o`>100?o^k/04k/4P@;o0h400ol0000200;o1@02obh0
000[00;o2004o`R10_l04k_;^l^kbk_;^l^kbk_;^l^kbk/00_l:F`03oe]K00Co012kbk_;^l^kbk_;
^l^kbk_;1Ol3P@03oh6100N100?oPH401?l03L^kbk_;^l^kbk_;^l/00ol05<^kbk_;^l^kbk_;^l^k
bk_;^l^k0ol7P@0Fok_;^l^kbk_;^l^kbk_;^l^kbk_;^`>100?oPOl00`000ol0000h0000:`000ol0
o`0300Co0h400on1P@04oaVk0_l9F`;o4;/4o`V100?oPH401h42o`fk1?l3F`03ok^k01:k0_l8P@03
ok^k01>k0_l3P@05o`000?l0>@0002/01_l8P@;o022kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^ko`9K1?l04;_;^l^kbk_;^l^kbk_;^l/4o`B100?oPH401h400on1P@04o`0?bk_;^l^kbk_;^l^k
bk_;00;o25/05_o;^l^kbk_;^l^kbk_;^l^kbk_;^ol9P@;o01C;^l^kbk_;^l^kbk_;^l^kbk_;^`F1
00Go0000o`0h0000:`02o`>100?oPH401?lT^`;o4;/4o`V100?oPH401h42oaBk00?oFe/01e/00onk
^`0B^`03oh6100Co1842oa>k1H43o`030?l003H0000R00;o1`02o`B10_l0=[_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co18400on1P@07P@03oh6100Co
01[;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`UK01?obk_;^l^kbk_;^l^kbk_;^l^k00Co2X405?nk
bk_;^l^kbk_;^l^kbk_;^l^k0h44o`8000?o0000=000024000Co003o1@000ol00002o`B10_lb^`;o
2H400on1P@07P@;o7[/00omKF`04oa6k1?l01H7oPH7o00Z100?o^k/04K/2o`>10_l20003o`0003<0
000Q0004o`00o`D000?o00000P000on1P@03P@0dol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o28400on1P@04o`B10_l07L^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;00;o016kbk_;^l^kbk_;^l^kbk_;^`04o`F100GoPH61o`02P@Go01Nkbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^`05P@;o00@0oooo<`00024000Co003o1@000ol000030003oh6100>10_lU^`Co
2[/00on1P@02P@;o0X42o`Z100?o^k/0:K/4o`B100?oPH400X400on1P@02P@;o7K/5P@;o0`000ol0
000`00008@001?l00?l50003o`0000D00_l4P@0Qok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;00Co15/2o`09^l^kbk_;^l^k00Co1X42o`V101;obk_;^l^kbk_;^l^kbk_;^l/4o`0?^l^kbk_;
^l^kbk_;^l^k00Ko2H400on1P@04o`0Rbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`>1
1?l30003o`0002l0000R00;o1P000ol000070003oh6100:100?o^k/06k/2o`YK00?o^k/02;/00on1
P@07P@03oh6100Co4;/4o`AK00?o^k/02;/4o`J100?oPH401h42o`03^onk02:k1?l4P@05o`000?l0
<00002X000?o000020000on1P@02P@0Ook_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`UK
0_l02/^kbk_;^l^kbol9P@;o01:kbk_;^l^kbk_;^l^kbk_;^l/2o`UK00co^l^kbk_;^l^kbol9P@03
oh6100Co02G;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00Co15/00on1P@02P@Go
;`0002X00_l:0003oh6100:10_lN^`03oe]K00Co15/00onk^`07^`03oh6100Co6;/00omKF`07F`03
ok^k00Rk00?oPH401h42o`Vk00?o^k/05k/6o`UK00KoPH7oPOl30003o`0002`0000Z0003o`0000X0
0_l4P@;o01fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`02o`UK00[obk_;^l^kbk_;0_l04;_;
^l^kbk_;^l^kbk_;^l/4o`0:^l^kbk_;^l^ko`9K1?l03k_;^l^kbk_;^l^kbk_;o`02P@Co0h407_o;
^l^kbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kb`Ko1U/00omKF`07F`;o0h42o`8000?o00001`03o`<0
0olK0000:@000ol0000=0003oh6100>100?o^k/07;/00omKF`07F`03ok^k01Bk1?l4P@03ok^k00Nk
0_lC^`;o28400onk^`06^`03ok^k00bk1Ol3F`03oe]K00MK00?oFe/01?l3F`03oh6100:11Ol90003
o`0000D000?o0000600002T000?o00003P000on1P@03P@;o01k;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbol9F`0@ol^kbk_;^l^kbk_;^l^kb`Ko2H408?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o2H404oo;^l^kbk_;ol^kbk_;^l^kbk/01?l9F`03oe]K00MK0_l8F`03oh6100:10_l20003
o`0000H000?o00001@000ol0000H0000:@000ol0000@00;o18400onk^`0K^`03oe]K00Co3[/4o`J1
0_l8P@;o7K/00on1P@07P@;o1K/00onk^`04^`Co15/00omKF`07F`03oe]K00Co0k/00omKF`07F`03
oh6100Co0P000ol000050003o`0000800olK0000:@000ol0000A00;o18407_o;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kb`;o01Fkbk_;^l^kbk_;^l^kbk_;^l^kbol02H400on1P@03o`B101oobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o00:11?l4P@08ok_;^l_obk/4o`UK00?oFe/01e/2o`09
^l^kbk_;^l_o00UK0_l4P@03oh6100;o1@000ol000020003o`0001/0000Y0003o`0001<000?oPH40
0X400onk^`0a^`03oh6100N10_l8P@03ok^k01Nk1_l9P@03ok^k00Co0e/00omKF`08F`03oe]K00Co
3K/00omKF`04o`AK00?oPH400X401Ol0003o00<00_l400Co6P0002T000?o00004`000h7oP@03P@;o
03>kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol00X44o`>1
00?oPH401h405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`IK00?oPH401h42o`03FomK00EK00?oFe/0
25/2o`0>^l^kbk_;^l^kbk_;^l/6o`UK00KoPH7oPOl30003o`0002@0000Y0003o`0001<000B10?oo
1842oc6k0_l8P@03oh6100N100?o^k/04[/00omKF`07F`03oh6100Co0h400omKo`07F`03oe]K00Go
3;/6o`IK00?oFe/01e/2o`>100Go0000o`0U0000:@02oa<000F10000o`06P@0dol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`R100?oPH401?l06L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^ol02E/2o`R10_l8F`;o00g;^l^kbk_;^l^kbk_;00Co0e/00omKF`07F`03
oe]K00Co00>kbk/01H400ol0o`02ob@0000X00;o50000h4000020003oh6100B100?o^k/08k/4o`Vk
00?oPH400X42o`:10_lM^`03oe]K00Co1;/00on1P@06P@03oe]K00Co15/00onk^`08^`;o25/00omK
F`07F`;o2;/5P@;o0P000ol0000Q0000:0000ol0000C0003P@0000D00_l3P@0Qol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Co15/02_nkbk_;^l^kbk/4o`J101ko^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk/2o`0:bk_;^l^kbk_;o`B10_l0187oool9F`0;ol^kbk_;^l^kbol02U/00omK
F`04o`0=^l^kbk_;^l^kbk_;^`03P@Co0P000ol0000P0000:0000ol0000C0003P@0000H000?oPH40
0X400onk^`0K^`;o2E/00onk^`07^`03oh6100N100?o^k/09[/4o`>k00Co^k_o2E/2o`Rk00?oFe/0
25/2oa:k0_l4P@04o`00ob40000X0003o`0001<000>100001`000on1P@02P@0Ool^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^`02o`QK0_l02L^kbk_;^l^ko`09P@;o03;;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_obk_;o`9K1?l4F`0:ok_;^l^kbk_;o`9K1Ol3F`0D
ok_;^l^kbk_;^l^kbk_;^l^kbk/5P@?o00<0o`007`0002P000?o00004`000h4000090004oh61P@;o
7[/00omKF`03o`AK00?o^k/01[/00on1P@04o`B10_l[^`03ok^k00:k0_l9F`03ok^k00Jk0_l9F`03
ok^k016k0h401?n1ool20003o`0001d0000X0003o`0001<000>100002P02o`>10_l07L^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o25/02Oo;^l^kbk_;^`02o`Z103?o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ol^kbk_;^ol02E/02onkbk_;^l^kbk_o00UK01Co^l^k
bk_;^l^kbk_;^l^kbk_;^`;o0h42o`8000?o0000700002P000?o00004`000h40000<0003oh6100:1
00?o^k/07;/00omKF`06F`03ok^k00Nk0_l9P@03ok^k02Nk00?o^k/01K/00omKF`04o`=K00?o^k/0
1k/00omKF`04o`=K00?o^k/04[/4P@Go7@0002P000?o00004`000h40000=0003oh6100:10_l07[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`AK0_l2F`0<ol^kbk_;^l^kbk_o0X44o`>1033o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kbk/4o`QK00[o^l^kbk_;^l^k
0_l8F`0Eok_;^l^kbk_;^l^kbk_;^l^kbk_;00>100GoPOl0o`0M0000:0000ol0000C0003P@0000h0
0_l4P@;o6[/6oa2k0_l8P@03ok^k02Jk00?o^ol00ol3F`03oe]K00MK00?o^k/02;/00omKF`06F`03
ok^k01:k0_l3^`;o7@0002L00olC0003P@00010000?oPH4018405_o;^l^kbk_;^l^kbk_;^l^kbk_;
^l/4o`=K01Ko^l^kbk_;^l^kbk_;^l^kbk_;^l_o28409_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^k1?l8F`03oe]K00MK00co^l^kbk_;^l^kbol4F`;o0U/2o`0<bk_;^l^kbk_;^l^k
1?l5P@04^l^koad0000W0003o`0001<000>100004@000on1P@04P@03ok^k00jk1?l8F`03ok^k01:k
00?oPH400X42o`:10_lP^`?o0U/00omKo`08F`03oe]K00Co3;/6o`IK00?o^k/01K/4o`J11?l20003
o`0001/0000W0003o`0001<000>100005002o`>100gobk_;^l^kbk_;^l^k00?o15/2o`MK01Go^l^k
bk_;^l^kbk_;^l^kbk_;^l/01?l6P@0Lol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`Co1E/01?mK
Fol4F`;o0U/2o`0<bk_;^l^kbk_;^l^k1?l3F`03oe]K00MK00?obk/01?l9P@03o`0000D000?o0000
6P0002L000?o00004`000h40000E0003oh6100:100?o^k/01k/2o`UK00?oFe/00U/01?mKFolD^`03
oh6100N100?o^k/05;/4o`AK00?oFe/00U/01?mKFe/4o`jk1?l8F`03oe]K00MK0_l6P@Co2`000ol0
000J00009`000ol0000C0003P@0001H000?oPH400X403?o;^l^kbk_;^l^ko`UK1?l06/^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o2H42o`0B^l^kbk_;^l^kbk_;^l^kbk_;0_l9F`03oe]K00?o013;^l^k
bk_;^l^kbk_;^l^k1?l4F`03oe]K00IK00?oFe/01?l2P@Co0h400ol0000=0003o`0001X0000W0003
o`0001<000>100005P000h7oP@03P@;o2K/00omKF`04ob2k00?oPH401?l4P@03ok^k00Fk0ol9^`05
oe]KGal01E/2o`03^onk00bk1?l9F`03oe]K009K0_l2F`;o1H43oaD000?o00006P0002L000?o0000
4`000h40000F0004P@3oo`B10_l02<^kbk_;^l^k0_l09L^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l/00_l9P@03ok_;00Co0e/02_nkbk_;^l^kbk/37`0CGalOok_;^l^kok_;^l^kbk_;
^`04o`AK00?oFe/01e/4o`B11Ol00`21000G0003o`0001X0000W0003o`0001<000>100005P000h40
000200F100?o^k/0;[/2o`R10_l8F`03ok^k00:k00LOGamO7elO009O00<OGk/01;/00onk^`02^`05
oinOWol01e/3g`03Wmoo00?o2H42o`D000>100005P000ol0000J00009P000ol0000D0003P@0001H0
00>100000`000on1P@02P@;o036kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00:10ol4F`03oe]K00IK00<OGal01Ql01;_;^l/47`03^l^k00Co0il0116O4Ol2F`05
WmnOgil00ml00ioOP@04P@Co2P000h40000F0003o`0001X0000V00?o50000h40000F0003P@0000@0
0_l4P@03ok^k02bk1?l8F`0=oe]KFamO7elOGamO7`09^`04GalO7`:k00?oWil01Yl00a6Og`06g`>1
00COWmoO0X400ol0000=0003P@0001D000?o00006P0002H000?o00004`000h40000F0003P@0000L0
00?oPH400X40:_nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`Co15/00omK
F`06F`04oalO7`9O010GGk_;^l^kbk_;^l^kbk/A0QL015oOg_l4W`04ginOF`;O00FOgin1g`02gP:1
0_l01=nOgmlA0003P@0001D000?o00006P0002H000?o00004`000h40000F0003P@0000P000?oPH40
0X42o`nk1?lB^`;o2E/00omKF`03o`>10Ul011nkGaL2G`bk0QL24@05gmkogil02]l019oogmh2g`05
o`000=l00Yl00ml0000>0003P@0001H000?o00006@0002H000?o00004`000h40000F0003P@0000T0
0_l4P@0<ol^kbk_;^l^kbk_;0ol4F`;o00K;^l^kbk/4o`09bk_;^l^kbk_o00UK0_l6P@037elO009O
0aL045lObk_;^l^kbk_;^a4G4AL2g`03omoO00OO00>1oa400Q42gP04gmkNg`@01=l600CN10000h40
000F0003o`0001T0000V0003o`0001<000>100005P000h40000;0003oh6100:100?o^k/01[/2o`UK
00?o^k/00ol4F`03ok^k00Jk00?oFe/01?l4^`03oh6100>100DOGamO7`05G`Rk00TA5a4G4ANOg_l0
0]h2g`034ALA00?O0Q43gP03gmkO00;O1Il01=nOg`09gP@000>100005P000ol0000I00009P000ol0
000C0003P@0001H000>1000030000on1P@02P@;o00Vkbk_;^l^kbol02E/2o`QK00Wobk_;^l^kbk/0
0_l02/^kbk_;^l^kbol4P@MO0aL01/^k5a4G4@PG00@A5ooN0ml24@095a7NgmkOg]oN00;O00?Ngmh0
1Ml00mkOgP07gP030=kN00@000>100005P000ol0000I00009P000ol0000C0003P@0001H000>10000
3P02o`>10_l7^`03oe]K00Co15/00omKF`06F`03ok^k016k1?l01AmO7amO008O00>k5aL01QL00a4G
4@04P@06oaLAomkO2mh4W`03gmkO00[N1P000miaL@030003P@0001H000?o00006@0002D000?o0000
50000h40000F0003P@0000l000?oPH400h402?o;^l^kbk_;0_l9F`03oe]K009K0_l2F`0Fol^kbk_;
^l^kbk_;^l^kbk_;^l^ko`B115l01[/G4ALA5`V1017o014Ao`3Og]oNgmkOg]nOg`060008gmkOg]oN
gmh;00?N0P000h40000F0003o`0001T0000U0003o`0001@000>100005P000h40000@0003oh6100>1
00?o^k/01[/2o`QK1?lJ^`03oh6100:100=O7el00_l5P@Go1`000ol0P@03gPd00mhA0005LMia0840
60000ol0000I00009@001?l0oolC0003P@0001H000>100004P02o`>100_obk_;^l^kbk_;o`02F`?o
01nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00Ko1845o`d000?o08409@03gP03P@0001H0
00?o00006@0002D000?oP@0050000h40000F0003P@0001<000?oPH400X400onk^`07^`;o7[/4o`V1
00?o000040000ol0P@0V0003LMia01P000?o00006@0001H00ol400;o1P000ol0P@0C0003P@0001L0
00>1000050000on1P@02P@0Uol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`04o`J1
1?lF0003o`2102L000?NLMh060000ol0000H00005`000ol000020004o`00o`D000?o00000X4A0003
P@0001L000>1000050001840ool2P@;o7k/3o`V100?o000060000ol0P@0X0003LMia01L000?o0000
600001L000?o00000P001?l00?l50003o`00008000>100003P000h40000G0003P@0001@000B10000
18406Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/01_l5P@Co7P000ol0P@0Y00;N00=a000050000ol0
000H00005`000ol000020004o`00o`D000?o00000`02P@h000>100005`000h40000D0003P@000080
00GoPH61o`0A^`Ko1845o`030840028000?oP@00:000187Ng]hE0003o`0001P0000G0003o`000080
00Co003o10000ol000060003P@0000/000>100005`000h40000D0003P@0000<00ol03h7ool^kbk_;
^l^kbk_;^`03o`V10_l50003P@00024000?o0840:0001H7NLMia01@000?o0000600001H00_l500;o
1@000ol0000700:12`000h40000F0003P@0001D000>100001@001?n1PH42o`Jk1?l6P@?o2P000h40
000Q0003o`2102L00g401=iag]hC0003o`0001P0000T0003o`0000T00X490003P@0001H000>10000
5@000h4000060003oh6100:100?o^l/00ol8P@;o3@000h40000Q0003o`2102<000GNLMiagP03L@04
gW7NLA8000?o0000600002@000?o00002`000h4000060003P@0001H000>100005@000h40000800;o
0X42o`B11OlA0003P@00024000?o08408@07L@05P@00LMh00W4B0003o`0001P0000T0003o`0000`0
0X460003P@0001H000>100005@000h4000090003ok_;00Go5`000h40000Q0003o`2101d017400mia
gP040007P@00077NL@0B0003o`0001P0000T00?o3P000h4000030003P@0001H000>100005@000h40
000:00;o70000h40000Q0003o`2101P02g450003P@00008000=agP004P000ol0000G000090000ol0
000?00:10P000h40000G0003P@0001@000>100002`000ol0000K0003P@00024000?o084060000g7M
L@03L@X000>100005`000ol0000G000090000ol0000A0003P@2101T000>1000050000h40000;0003
o`0001/000>100008@000ol0P@0H009a00?M00002`000h40000G0003o`0001L0000S0003o`0001<0
0X4I0003P@0001@000>100002`000ol0000K0003P@00024000?o08406@03L@`000>100005`000ol0
000G00008`000ol0000D00:160000h40000D0003P@0000/000?o00006`000h40000Q0003o`2101X0
0md<0003P@0001H000?o00005`0002<000?o000050001840PH4F0003P@0001@000>100002`000ol0
000K0003P@00024000?o08406`03L@03g@0000P000>100005P000ol0000G00008`000ol0000D0005
P@0008405@000h40000D0003P@0000/000?o00006`000h40000Q0003o`2101`00md00g4000070003
P@0001H000?o00005`0002<000?o000050000h40000200:14`000h40000D0003P@0000/000?o0000
6`000h40000Q0003o`2101h000?MLMd020000h40000F0003o`0001L0000S0003o`0001@000>10000
10000h40000@0003P@0001@000>100002`000ol0000K0003P@00024000?o08407`000g7ML@030006
UG6ELMea5`000ol0000G00008`000ol0000D0003P@0000D00X4@0003P@0001@000>100002`000ol0
000K0003P@00024000?o084080001meagG7MLMd00YD00g6E000G0003o`0001H0000S00;o5@000h40
000700:13P000h40000D0003P@0000/000?o00006`000h40000Q0003o`21020000=aUMd02=dH0003
o`0001H0000S0003o`0001<000>100002P000h40000:0003P@0001D000>100002`000ol0000K0003
P@00024000?o084080000iGMU@05U@03084001P000?o00005P00028000?o000050000h40000;00:1
2P000h40000E0003P@0000/000?o00006`000h40000Q0003o`21020000CMUG6E1@000h40000G0003
o`0001H0000R0003o`0001@000>100003@000h4000070003P@0001D000>100002`000ol0000K0003
P@00024000?o08408@00176ELID40003P@0001L000?o00005P00028000?o000050000h40000>00:1
1`000h40000E0003P@0000X000?o000070000h40000Q0003o`2102<00iD30003P@0001L000?o0000
5P00028000?o000050000h40000@0003P@0000@000>100005@000h40000:0003o`0001`000>10000
8@000ol0P@0T00>E0P000h40000G0003o`0001H0000R0003o`0001@000>100004@02P@@000>10000
5@000h40000:0003o`0001`000>100008@000ol0P@0U0003UM`0008000>100005002P@03o`0001H0
000R0003o`0001@000>100004`001H40002101L000>100002P000ol0000L0003P@00024000?o0840
8`04U@<000>100003`05P@8000?o00005P00028000?o000050000h40000D00:100<0P@005P000h40
000:0003o`0001`000>100008@000ol0P@0N0009UMbEg9GLUMbE00<000>100002P05P@P000?o0000
5@00028000?o000050000h40000F00:15`000h40000:0003o`0001`000>100008@001?l0084I0003
UMbE00NE1P000h40000500F13@000ol0000E00008@03oaD000>100005`02PAH000>100002P000ol0
000L0003P@00028000?o08405@002IGLUMbEg9GLU@0;0003P@0000F14P000ol0000E00008@000ol0
000D0003P@0001P000>108405@000h40000:0003o`0001`000>100008P000ol0P@0C0007g9FEg9GL
U@0=00F15`000ol0000E00008@000ol0000D0003P@0001P000>100000X4C0003P@0000X000?o0000
70000h40000R0003o`21014000?LUID00YD<00F10P000h40000G0003o`0001D0000Q0003o`0001@0
00>1000060000h4000020003P@00010000>100002P000ol0000L0003P@00028000?o08403@002=bE
g9GLUMbE2005P@L000>100005`000ol0000E00008@000ol0000D0003P@0001P000>100000`02P@l0
00>100002`000ol0000L0003P@0001l00n`00ol0P@090009UMcLUMbEg9GL00H01H4<0003P@0001L0
00?o00005@0000800olL0003o`0001@000>1000060000h40000500:13@000h40000;0003o`0001`0
00>100007P001mc/g=cok8401@002MbEg9GLUMbEg00600B14@000h40000G0003o`0001D000020004
o`00oa/000?o000050000h40000G0003P@0000P000>100002P000h40000;0003o`0001`000>10000
6@09k003oncL00<000NEg9GLUMbE00D01H4E0003P@0001P000?o00005000008000?o000070000ol0
000D0003P@0001L000>100002@02P@X000>100002`000ol0000L0003P@0001D000[/g>cLk=c/g>cL
0`001?o/g>`3g003UM`000<01H4J0003P@0001P000?o00005000008000?o00006`000ol0000E0003
P@0001L000>100002`000h4000070003P@0000/000?o000070000h40000A00W/1`001mcog=c/g>`0
0]`5PB0000>100005`000ol0000D000000<0ool00_lK0003o`0001D000>100005`000h40000<00:1
1`000h40000;0003o`0001`000>100003`001mc/k=c/g>`02@03g003omcL00CL00?/00008`000h40
000G0003o`0001@000020003o`0001/00olE0003P@0001L000>100003P000h4000040003P@0000/0
00?o000070000h40000?00;L00?/00002`03g004omc/g0;/00?Lk00090000h40000G0003o`0001@0
00020003o`0001/000?o000050000h40000H0003P@0000l00X440003P@0000/000?o000070000h40
000?0004g>cLk0P01H42g003omcL00;L00<0g=`09@000h40000G0003o`0001@0000P0003o`0001@0
00>1000060000h40000A0005P@0008403@000ol0000L0003P@0000d00n`01=c/g=`200F11@001NcL
o`2102X000>100005`000ol0000D000080000ol0000D0003P@0001P000>100004P02P@03084000`0
00?o000070000h4000090005g>cLk=`00n`01Mc/g>b100`000?o0840:P000h40000G0003o`0001@0
000P0003o`0001@000>1000060000h40000D00:13@000ol0000L0003P@0000D02N`3P@030=c/00;L
30000ol0P@0Z0003P@0001L000?o00005000020000?o000050000h40000H0003P@0001D00X4<0003
o`0001`000B100001^`00mc/g002P@L000?Lk>`030000ol0P@0Z0003P@0001P000?o00004`0001l0
00?o00005@000h40000H0003P@0001D000>108402`000ol0000D0003CDa=00D000>10>`01^`2PAX0
00?o0840:P000h40000H0003o`0001<0000O0003o`0001D000>100003@03S0800h`30003P@0001D0
00>100000X490003o`0001@014d40006ITe=CNb17`000ol0P@0Z0003P@0001P000?o00004`0001l0
00?o00005@000h40000=00:<0T`5S003C02100h00T`00m8000020004CDa<C@<00X470003o`0001D0
2Td00dh0000O0003o`2102X000>1000060000ol0000C00007`000ol0000E0003P@0000/02T`018a<
C8`40003`<K000L00T`01de<CDa=C4d00d`40003P@0000@000?o00004`002h5VCFI=ITeVCFJg009=
1P0016I=CFHG0003o`2102X000>1000060000ol0000C00007`000ol0000E0003P@0000T000><C8`0
1X`2C00508a<S4`00X`01<36`<H2`0H000e<CDa=C4e<C@1<CDa=00@00X440003o`0000D014d50005
C4e<CKL01Dd2C004CDb1009V00<0CTh01Dh00de>000F0003o`2102/000>100005`000ol0000C0000
7`000on1o`0D0003P@0000X02h`20003aTa<00=<00J<`<K0a/05C004CDa=C0?B00M<0840C4e<00D0
00F10000o`020006CDa=C4e<14d01Da=C4e<00Y=0140CDf106I=ITeVCFI=IP1=IP0600=V00=>0000
2`000ol0P@0[0003P@0001L000?o00004`0000l01?l300;o1`001?l0PH4C0003P@0000X000I<S4b<
C8`3009<00K6`<K0aX`2C007S4b<C8a<S009C0;B0P001X4004e<C@D00X4:C@0>PDe<CDa=C4e<]da=
C4d80003P@1>00=>1P02IP0304i>00E>00=2IP0030001?l0084Z0003P@0001L000?o00004`000100
00?o00000P001?l00?l60005o`0008404P000h40000E0007a/36S<J<aP08C005`4b<C<`00/000lc0
c0030006P@0004a=0d`02De<CDa=C4e<C@03P@<000==C4d00`000kNf]`02]`X000>100002@09IP03
06I200H000A>@VI20`001?l0084Z0003P@0001L000?o00004`00014000Go0000o`020003o`0000<0
00?o00000`02PA0000>100005@07aP04C8a<S0800l06aP04c<3<`0;<00>10<`00Pd9C@03oh4000d0
00Jf]kNg][L90003P@0000T014h6009>00P0IT9V@VI2IP920`001?l0084Z0003P@0001P000?o0000
4P00018000Co003o0P000ol000030003o`0000D00X4>0003P@0001D000C6S<J11`08`003a/360080
00C<`<c00l`01Pg<CDa=C0D000?o00002@001[Jg][Nf]`:f0kL80003P@0001<000]>@Ti2CT9>@Th0
C`02@P<000?o0840:P000h40000H0003o`000180000?0004o`00o`8000Co003o1@000ol000070003
P@0000/000>1000060000h4000050009a/36`<K0a/0=00;600@03Lc01L`53@H000?o00001@002[Jg
][Nf]kJg][L4]P03]`0000H000>100004`00149V@VH60004@Tm2C`8000?o0840:P000h40000H0003
o`000180000@00;o1002o`H000?o00002002P@/000>1000060000h40000500?010000`g<3@02c007
3Lc<c0g<`002c0800l`01@d0003o00@01KH01;Nf]kH70003]kJg00P000>100007`03@P040?l0PBX0
00>1000060000ol0000B00007P000ol0000:00:12@000h40000H0003P@0000`000?<3@d02l`00kD0
00053@0<0?nf]kJg][Nf]kJg2`02]PP000>1000080001Tm2Col0PBX000>1000060000ol0000B0000
7P000ol0000<0003P@0000H000>1000060000h4000090003]@fd00@=00G<3L`=c002]@033Lc000:e
0`000`g<3@02c0Ff6P000h40000Q009200?o0840:P000h40000H0003o`000180000N0003o`0000d0
0X460003P@0001P000>100002@05]0053L`=c0d00[D00h40c009c0<=0[H00kNf]P0J0003P@000280
00A2o`21:P000h40000H0003o`000180000N0003o`0000l00X430003P@0001T000>100002@03]0<=
00>e3L`01`d04L`=c0g<3L`=0<`=o;Kl]kJg01T000>1000080001Tm2Col0PBX000>1000060000ol0
000B00007P02oa8000B100216`000h40000=00043KD=00O<00Bfc<c<0[D01Pfe3KFf]@?l00Bfo;Jf
60000h40000K00Q200?o0840:`000h40000G0003o`000180000M0003o`0001<00h4K0003P@0000h0
0Pd01P0=3@d0P@802[D01obfo;Kl]_`00[HH0003P@0001P000U?@Tm2Cd9?@Tl00P000ol0P@0[0003
P@0001P000?o00004@0001d000?o00005@02PAX000>100005@000h400005]@07o;Je3KD0o`040003
o;Kl01P000>100006000149?@T870003o`2102/000>1000060000ol0000A00007@000ol0000E0003
P@2101T000>100005@000h4000030003o;Gl00D000?o00000`000kKl000G0003P@0001P000=?@P00
20000ol0P@0[0003P@0001P000?o00004@0001d000?o00005@000h400002PAH000>100005P000h40
00040003][D000@000?o00007@000h40000H009?2@000ol0P@0[0003P@0001P000?o00004@0001d0
00?o00005@000h40000200:150000h40000F0003P@0000/000?o00007@000h40000F0004Ccm?C`T0
00?o0840:`000h40000H0003o`000140000M0003o`0001D000>1000010000h40000A0003P@0001H0
00>100002`000ol0000M0003P@0001402Dl90003o`2102/000>1000060000ol0000A00007@000ol0
000E0003P@0000D00X4A0003P@0001H000>100002`000ol0000M0003P@0000h000U??dloCcm??dl0
30000ol0P@0[0003P@0001P000?o00004@0001d000?o00005@000h40000700:13`000h40000F0003
P@0000/000?o00007@000h40000>0004?dm?Ca4000?o0840:`000h40000H0003o`000140000L0003
o`0001D000>100002P000h40000<0003P@0001H000>100002`000ol0000M0003P@0000h000=??`00
4P000ol0P@0[0003P@0001P000?o00004@0001`000?o00005@000h40000;00:130000h40000F0003
P@0000/000?o00007@000h40000>008o4`000ol0P@0[0003P@0001T000?o0000400001`00olE0003
P@0000d00X4:0003P@0001H000>100002`000ol0000M0003P@0000`000A??dlo4`000ol0P@0[0003
P@0001T000?o0000400001`000?o00005@000h40000?0003P@0000L000>100005P000h40000;0003
o`0001d000>100001`09?a<000?o0840;0000h40000H0003o`000100000L0003o`0001D000>10000
4002P@L000>100005P000h40000;0003o`0001d000>1000010002DloCcm??dloC`0F0003o`2102`0
00>1000060000ol0000@000070000ol0000E0003P@0001800X450003P@0001H000>100002`000ol0
000M0003P@0000800Tl4?a/000Co0021:`000h40000E00>100?o0000400001`000?o00005@000h40
000D0003P@00008000>100005P000h40000;0003o`0001d000U??dloCcm??dl07@001?l0084[0003
P@0001001H430003o`000100000L0003o`0001D000>100005@02P@8000>100005P000h40000;0003
o`0001/024lP0004o`00PB/000>100002`05P@P000?o0000400001/000?o00005P000h40000G00>1
60000h40000;0003o`0001/00Sl00dl0000S0004o`00PB/000>100001@06P@d000?o0000400001/0
00?o00005P000h40000I0003P@0001H000>100002`000ol0000K0005Ccm??dl090000ol0P@0[0003
P@0000F14`000ol0000@00006`000ol0000E0003P@0001X00h4E0003P@0000`000?o00007@0014lo
CclS0003o`2102P01X4I0003o`0000l0000K0003o`0001D000>100006@0018400002PA<000>10000
30000ol0000M0005P@1??dl08P000ol0P@0S00F10`000h40000I0003o`0000l0000K0003o`0001D0
00>100006@000h4000030003P@00010000>1000030000ol0000M0006P@00?dlo8@000ol0P@0N00F1
20000h40000I0003o`0000l0000K00;o5P000h40000I0003P@0000@00X4@0003P@0000`000?o0000
7@00284003m??dlo7`000ol0P@0H00J13@000h40000I0003o`0000l0000K0003o`0001D000>10000
6@000h40000600:13P000h40000<0003o`0001d000>100000P04?ah000?o08404`05PA<000>10000
6@000ol0000?00006`000ol0000E0003P@0001T000>1000020000h40000;0003P@0000`000?o0000
7@000h4000040003?dlo00H000@oCclo4`000ol0P@0>00F16@000h40000H0003o`0000l0000J0003
o`0001H000>100006@000h40000900:12`000h40000<0003o`0001d000>100001@000dlo0007?`03
83l0018000?o08402006PAh000>1000060000ol0000?00006P000ol0000F0003P@0001T000>10000
2`02P@T000>1000030000ol0000M0003P@0000D000XoCcm??dloCcl00Sl00b00000@0003o`2100<0
1H4T0003P@0001P000?o00003`0001X000?o00005P000h40000I0003P@0000d000>100001P000h40
000;0003o`0001h000>100001@04?`H000DP?b0o800@0003oh6100>1:@000h40000H0003o`0000l0
000J0003o`0001H000>100006@000h40000>00:11P000h40000;0003o`0001h000>100004@00120o
83l:00F100?o0840;0000h40000I0003o`0000h0000J0003o`0001D000>100006P000h40000@00:1
10000h40000;0003o`0001h000>100004`000b0o800400F11@000ol0P@0/0003P@0001T000?o0000
3P0001X000?o00005@000h40000J0003P@00018000F10000P@0=0003o`0001h000>100005002?`B1
1`05o`03P@0002X000>100006@000ol0000>00006P000ol0000E0003P@0001X000>100004`02P@03
084000`000?o00007P000h40000?0005?b0o83l00R0600Go1@000ol0000Z0003P@0001T000?o0000
3P0001X000?o00005@000h40000J0003P@0001D00X4=0003o`0001h000>100002P0<80Ko2P000h7o
o`0Z0003P@0001T000?o00003P0001T000?o00005P000h40000J0003P@0001H00X4<0003o`0001h0
00>100001006P@07824P?b0o0005oa0000B1003o:@000h40000I0003o`0000h0000I00?o5P000h40
000J0003P@0001H000B108612P000ol0000N0003P@2100B11P0280Go5@0018400002obL000>10000
6@000ol0000>00006@000ol0000F0003P@0001T000>100005`0018400002P@P000?o00006`05P@L0
1_l381L000>100000`000ol0000T0003P@0001T000?o00003P0001T000?o00005P000h40000I0003
P@0001L000>100000`000h4000050003o`0001D01X430004P@0000Go1P00124P8B0F0003P@0000@0
0_lU0003P@0001T000?o00003@0001T000?o00005P000h40000I0003P@0001L000>100001002P@D0
00?o00004005P@L01_l=00<P5@000h4000060003o`00028000>100006@000ol0000=00006@000ol0
000F0003P@0001T000>100005`000h40000600:10`000ol0000:00J11`05o`8000>100003@00124P
8B0F0003P@0000H00_lR0003P@0001T000?o00003@0001T000?o00005@000h40000J0003P@0001L0
00>10000200018400?l700F12005o`L000>1000020002B0Q824P8B0Q800F0003P@0000P000?o0000
7`000h40000I0003o`0000d0000I0003o`0001D000>100006P000h40000G0003P@0000T00X400ol0
0005P@L01_l<0003P@0000H00R401R0Q824P8AT000>100002@02oal000>100006@000ol0000=0000
6@000ol0000E0003P@0001X000>100005`000h40000;0003oh6100L01OlB0003P@0000H000<P8B00
7P000h40000;0003o`0001`000>100006@000ol0000=000060000ol0000F0003P@0001X000>10000
5`000h40000;0004o`0000Ko5`000h40000600DP70000h40000<00;o70000h40000I0003o`0000d0
000H0003o`0001H000>100006P000h40000F0003P@0000/01OlM0003P@0000P000@Q824P6`000h40
000>0003o`0001T000>100006@000ol0000=000060000ol0000F0003P@0001X000>100005P000h40
000500Ko00<0o`007`000h40000:00<P6P000h40000?00;o6@000h40000I0003o`0000d0000H0003
o`0001H000>100006P000h40000F0003P@0000Go1`000ol0000N0003P@0000/00R4J0003P@000140
00?o00005P000h40000J0003o`0000`0000H0004oh7ooaD000>100006P000h40000D00Go30000ol0
000N0003P@0000/000<Q80006@000h40000B00;o5P000h40000J0003o`0000`0000800?o1002o`L0
00Co08615@000h40000J0003P@0000h01_l20003P@0000`000?o00007P000h40000600048B0Q80<Q
6P000h40000D0003o`0001<000>100006P000ol0000<00002`001?l00?l20003o`0000@000Co0000
0X4C0003P@0001X000>100002@05o`P000>1000030000ol0000N0004P@0000`Q6P000h40000E00;o
50000h40000I0003o`0000`0000;0004o`00o`8000?o000010000ol0000300:140000h40000K0003
P@0000<01_l=0003P@0000`000?o00007P002X40;b4P8B0Q824P0003P@0001L000?o00004@000h40
000I0003o`0000`0000900;o0`001?l00?l50003o`0000H000>100003@000h40000J0003P@3o00Co
4`000h40000<0003o`0001/02B4T0003P@0001P00_lA0003P@0001T000?o0000300000/000Co003o
0P000ol000030003o`0000L00X4=0003P@0001H01_lH0003P@0000`000?o00006@038@05;b4_8Bl0
9`000h40000J0003o`0000h000>100006@000ol0000<00002003o`@00_l60003o`0000T00X4;0003
P@0001401Ol40003P@0001L000>1000030000ol0000I008_00@Q0021:@000h40000K00;o3P000h40
000I0003o`0000`0000G0003o`0000/00X490003P@0000`01Ol90003P@0001L000>1000030000ol0
000I0006;b4_8Bn1:@000h40000M0003o`0000/000>100006@000ol0000<00005`000ol0000=00:1
1`000h40000600Ko3P000h40000G0003P@0000`000?o00006`0012lQ;b4Y0003P@0001h00_l;0003
P@0001X000?o00002`0001L000?o00003`02P@D000B100001OlD0003P@0001L000>1000030000ol0
000M0004;b4_8BL000>1000080000ol000080003P@0001X000?o00002`0001L000?o00004@02P@03
0?oo00Co6@000h40000G0003P@0000`000?o00007P00124_;blV0003P@0002400_l80003P@0001X0
00?o00002`0001L000?o00003`05o`03P@2101`000>100005`000h40000<0003o`0001h000F1024_
8@0U0003P@0002<000?o00001@000h40000J0003o`0000/0000F0003o`3o00/01Ol600:170000h40
000G0003P@0000`000?o00007P000h400003;`H012400bl0000G0003P@0002@00_l50003P@0001X0
00?o00002`0001H00_l600Ko2`03PA/000>100005`000h40000<0003o`0001h000n100008BlQ8R4R
8B8Q8R400R8I0003P@0002H000?o00000P000h40000J0003o`0000/0000F0003o`0000Go4@000h40
0002PAT000>100005`000h40000;0003o`0001l000>100000P088@04028Q8QT000>100009`02o`<0
00>100006@000ol0000;00005P03oaH000>100000P02PAL000>100005`000h40000;0003o`0001l0
00>100000P000b8Q8P0600058B8_8R4060000h40000X0004o`00PA/000?o00002`0001P00_lE0003
P@0000@00X4E0003P@0001L000>100002`000ol0000O0003P@0000d0128G0003P@0002T00_l00h40
000I0003o`0000/0000J00;o4`000h40000600:14`000h40000G0003P@0000/000?o00007`000h40
000?00038B8Q01H000>10000:`000ol0000J0003o`0000X0000L00;o4@000h40000800:14@000h40
000G0003P@0000/000?o00007`000h40000@00<R5@000h40000[0003POoo01X000?o00002P0001h0
0_l?0003P@0000X00X4>0003P@0001P000>100002`000ol0000O0003P@0000`000@R7b8O0b8E0003
P@0002/000B1003o6@000ol0000:00008002o`d000>1000030000h40000;0003P@0001P000>10000
2`000ol0000O0003P@0000L02b8F0003P@0002/000B100000_lG0003o`0000X0000R00;o2`000h40
000=00:12`000h40000G0003P@0000`000?o00007`000h400007008R00@O8QlR6`000h40000[0003
P@0000<000?o000050000ol0000:00009002o`T000>100003`02P@T000>100005`000h40000<0003
o`0001l000>100001`001B8O7b8O01`000>10000:`000h40000400;o50000ol0000:00009P02o`H0
00>100004P02P@L000>100005`000h40000<0003o`0001l000>100001`000b8O8P038Q/000>10000
:`000h4000060003o`00014000?o00002P0002P00_l40003P@0001@00X450003P@0001L000>10000
30000ol0000O0003P@0000D000@O8R8O12800al0000H0003P@0002/000>100001`02o`h00h400ol0
000:0000:P02o`8000>100005P02P@<000>100005`000h40000<0003o`0001l00161000O8QlR7b8O
8QlR7b8O8P0J0003P@0002/000>100002@000ol0000500J10`000ol0000:0000;002o`03P@0001P0
0X400`21000H0003P@0000`000?o00007`002H4R7b8O8QlR7`0500<R6P000h40000/0003P@0000T0
0_l5P@X000?o00002@0002h00_lK00:16@000h40000<0003o`0001l000B17b8O2`000alR000I0003
P@0002`000>100001006P@030?l000d000?o00002@0003000_lJ00>15`000h40000<0003o`0001l0
00>17al0:0000h40000/00N12002o``000?o00002@0003800_lH0004P@00PAH000>1000030000ol0
000O0003P@0002P000>100009P07PA0000?o00002@000ol000090000=002oaH000B100000X4D0003
P@0000`000?o00007`000h40000X0003P@0002001X460003P@0000l00_l90003o`0000T0000f00;o
50000h40000300:14P000h40000<0003o`0001l000>10000:0000h40000J00J130000h40000A0003
o`0000H000?o00002@0003P00_lB0003P@0000D00X4@0003P@0000`000?o00007`000h40000X0003
P@0001@01X4B0003P@0001800_l60003o`0000T0000j00;o40000h40000700:13P000h40000<0003
o`0001l000>10000:0000h40000>00J160000h40000D0003o`0000<000?o00002@0003`00_l=0003
P@0000X00X4<0003P@0000`000?o00007`000h40000X0003P@0000P01X4N0003P@0001D00_l30003
o`0000T0000n00;o2`000h40000<00:12P000h40000<0003o`0001l000>10000:0000h40000200J1
90000h40000G0005o`000?l02P0004000_l90003P@0000h00X480003P@0000`000?o00007`000h40
000V00N1:P000h40000H00;o00<0o`002@0004800_l70003P@00010000>100001@000h40000<0003
o`0001l000>100008006P@8000>10000;0000h40000J00;o2P0004@00_l50003P@0001400X450003
P@0000`000?o00007`000h40000J00J120000h40000]0003P@0001L01?l:0000AP02o`<000>10000
4`02P@<000>1000030000ol0000O0003P@0001@01X4?0003P@0002`000>100004007o`h0001800;o
00<0P@005P02P@03084000d000?o00007`000h40000>00J15@000h40000/0003P@0000X01_lE0000
BP02oaT00X4>0003o`0001l000>100002006PA/000>10000;0000h40000300Oo6`0004`00_lH00>1
30000ol0000O0003P@0000801X4Q0003P@0002`01_lR0000CP02oaH000>100000X4:0003o`0001h0
1X4W0003P@0002D01ol00h40000U0000D002oa<000>100000`02P@P000?o00006006P@03084002X0
00>100007`06obl0001B00;o4@000h4000050003P@0000D000?o00004@07P@L000>10000:@000h40
000I00Ko=@0005@00_l?0003P@0000H00X450003o`0000/01X4>0003P@0002T000>100004P07oc/0
001F00;o3@000h40000800:10P000ol0000600J150000h40000Y0003P@0000`01_m20000F002o`/0
00>100002P02P@03o`0000J16P000h40000Y0003P@0000D01om80000FP02o`T000>1000030000on1
P@0P0003P@0002T000>10?l01Om?0000G002o`L000>1000030000ol0000P0003P@0002@01omE0000
GP02o`D000>1000030000ol0000P0003P@0001h01_mL0000H002o`<000>1000030000ol0000P0003
P@0001L01omR0000HP02o`03084000d000?o000080000h40000A00KoJ@0006@00_l>0003o`000200
00>100002P07ofl0001U0003POoo00`000?o000080000h40000400KoMP0006P00_l:0003o`000200
00>1ool01?ml0000JP02o`P000?o00006P07oh80001/00;o1P000ol0000D00KoR@0006h00_l40003
o`0000d01on?0000L002o`8000?o00001`06oiH0001b00?o0P07oi`0001d00?oX`000?l06`000?l0
6`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`000?l06`0007H000?o0000
9`000ol0001g0000D@04o`<01?l0103oo`02o`800_l300?o0`03o`@000?o00002005o`040?oo00;o
0P05o`030?oo00<00ol40003o`0000L00ol400Go0P03o`<00_l400?o0P03o`@00_m80000D0001Ol0
003o008000?o00000`001?l00?l300;o1P000ol000030003o`00008000?o00002@001Ol0003o0080
00Co003o0`000ol00002o`@000?o000010000ol000070003o`0000D000?o00000P001?l00?l200;o
1@000ol000040004o`0000;oB000050000?o0?l00_l200Go00D0o`00o`0;0004o`0000?o40001Ol0
003o008000Co003o0`000ol000060003o`0000h000?o00001@000ol000020003o`0000P01?l50003
o`0004/0001@0003o`0000@000Oo0000o`3o008000?o00001P03o`<000Co003o40001Ol0003o0080
00Co003o0`000ol000060003o`0000h00ol50003o`00008000?o000020000ol0o`0300?oCP000500
00Go0000o`0300?o00<0ool00ol80003o`0000<000Co003o40000ol00005o`<01?l80003o`0000h0
00?o00001002o`<01?l80003o`3o00<000?o0000CP0005401?lD00Co0`02o`l01Ol;0003o`0000D0
0_l?00Go2@000ol0000900;o0`04odd0002@00;o8@000ol000020003o`0005l0003o01/00000\
\>"],
  ImageRangeCache->{{{0, 281}, {281, 0}} -> {0.122835, -0.0212284, \
0.00250958, 0.0038994}},
  CellTags->"AntTracker3D - Gen 59"],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker3D - Gen 38",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"AntTracker3D - Gen 0",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  ButtonBox["Movie",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ 
          ParentDirectory[ ]], "Movies", "AntTracker-Movies Folder"}, 
        "AntTracker-7i-Gen59.nb", CharacterEncoding -> "MacintoshRoman"], 
      None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(AntTracker[
      seq[{}, \ \(ifSensor[wall]\)[
          seq[turnLeft, \ turnLeft, \ 
            again], \ \n\ \ \ \ \ \ \ seq[{}, \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              turnRight], \ \n\ \ \ \ \ \ \ \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ 
              advance]]], \ \n\ \ \ \ \ \ \(ifSensor[dust]\)[
          seq[turnLeft, \ again]], \ \n\ \ \ \ \ \ \(ifSensor[wall]\)[
          seq[\(ifSensor[dust]\)[
              advance]], \ \n\ \ \ \ \ \ \ seq[\(ifSensor[dust]\)[
              seq[turnLeft, \ again]], \ \n\ \ \ \ \ \ \ \ \(ifSensor[wall]\)[
              seq[turnLeft, \ again], \ advance]]]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .65193 
MathPictureStart
%% Graphics3D
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024901 0.996051 -0.124802 0.996051 [
[(Gen.59, Ind.1, Fit.45.)] .5 .65193 0 -1.5 Msboxa
[(0)] .03427 .25765 1 .88946 Msboxa
[(5)] .18575 .2008 1 .9893 Msboxa
[(10)] .3469 .14034 .89735 1 Msboxa
[(15)] .51867 .07593 .78389 1 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Msboxa
P
[(0)] .70932 .03278 -1 .37049 Msboxa
[(5)] .7915 .15335 -1 .34381 Msboxa
[(10)] .86461 .26063 -1 .32071 Msboxa
[(15)] .93008 .35669 -1 .30052 Msboxa
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Msboxa
P
[ 0 0 0 0 ]
[ 1 .65193 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
[(Gen.59, Ind.1, Fit.45.)] .5 .65193 0 -1.5 Mshowa
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
P
p
.002 w
.69764 .03711 m
.69181 .03927 L
s
P
[(0)] .70932 .03278 -1 .37049 Mshowa
p
.002 w
.77972 .1574 m
.77384 .15942 L
s
P
[(5)] .7915 .15335 -1 .34381 Mshowa
p
.002 w
.85275 .26443 m
.84682 .26633 L
s
P
[(10)] .86461 .26063 -1 .32071 Mshowa
p
.002 w
.91815 .36028 m
.91219 .36207 L
s
P
[(15)] .93008 .35669 -1 .30052 Mshowa
p
.001 w
.71486 .06234 m
.71135 .06362 L
s
P
p
.001 w
.73167 .08697 m
.72815 .08823 L
s
P
p
.001 w
.74807 .11101 m
.74455 .11225 L
s
P
p
.001 w
.76408 .13448 m
.76055 .13571 L
s
P
p
.001 w
.795 .17979 m
.79146 .18099 L
s
P
p
.001 w
.80993 .20168 m
.80639 .20286 L
s
P
p
.001 w
.82453 .22306 m
.82098 .22423 L
s
P
p
.001 w
.8388 .24398 m
.83525 .24513 L
s
P
p
.001 w
.8664 .28443 m
.86284 .28556 L
s
P
p
.001 w
.87976 .30401 m
.87619 .30512 L
s
P
p
.001 w
.89283 .32316 m
.88926 .32426 L
s
P
p
.001 w
.90562 .34192 m
.90205 .343 L
s
P
p
.001 w
.93042 .37826 m
.92684 .37932 L
s
P
p
.001 w
.94244 .39587 m
.93885 .39692 L
s
P
p
.001 w
.95421 .41312 m
.95062 .41416 L
s
P
p
.001 w
.96575 .43003 m
.96216 .43106 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(East)] .9169 .23131 -1 .32288 Mshowa
P
P
0 0 m
1 0 L
1 .65193 L
0 .65193 L
closepath
clip
newpath
p
.002 w
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
.40264 .59968 m
.02969 .2711 L
s
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
.40264 .59968 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.40169 .62703 L
s
.40169 .62703 m
.40264 .59968 L
s
P
p
.002 w
.95262 .44873 m .40715 .60339 L .05204 .29048 L p
.9 g
F P
s
P
p
.002 w
.43883 .5853 m .41247 .59282 L .39681 .57888 L p
.4 g
F P
s
P
p
.002 w
.46545 .57771 m .43883 .5853 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.39681 .57888 m .42334 .57122 L .43883 .5853 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .39681 .57888 L .38086 .56468 L p
.4 g
F P
s
P
p
.002 w
.49235 .57003 m .46545 .57771 L .45013 .56348 L p
.4 g
F P
s
P
p
.002 w
.42334 .57122 m .45013 .56348 L .46545 .57771 L p
.4 g
F P
s
P
p
.002 w
.38086 .56468 m .40755 .55687 L .42334 .57122 L p
.4 g
F P
s
P
p
.002 w
.51951 .56228 m .49235 .57003 L .4772 .55567 L p
.4 g
F P
s
P
p
.002 w
.45013 .56348 m .4772 .55567 L .49235 .57003 L p
.4 g
F P
s
P
p
.002 w
.40755 .55687 m .38086 .56468 L .3646 .55021 L p
.4 g
F P
s
P
p
.002 w
.54695 .55446 m .51951 .56228 L .50454 .54777 L p
.4 g
F P
s
P
p
.002 w
.4772 .55567 m .50454 .54777 L .51951 .56228 L p
.4 g
F P
s
P
p
.002 w
.3646 .55021 m .39147 .54226 L .40755 .55687 L p
.4 g
F P
s
P
p
.002 w
.57468 .54655 m .54695 .55446 L .53217 .53979 L p
.4 g
F P
s
P
p
.002 w
.50454 .54777 m .53217 .53979 L .54695 .55446 L p
.4 g
F P
s
P
p
.002 w
.39147 .54226 m .3646 .55021 L .34804 .53546 L p
.4 g
F P
s
P
p
.002 w
.60268 .53856 m .57468 .54655 L .56008 .53173 L p
.4 g
F P
s
P
p
.002 w
.53217 .53979 m .56008 .53173 L .57468 .54655 L p
.4 g
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .623 r
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .604 r
F P
s
P
p
.002 w
.45101 .53933 m .43736 .54333 L .42943 .53593 L p
0 1 .585 r
F P
s
P
p
.002 w
.34804 .53546 m .37507 .52736 L .39147 .54226 L p
.4 g
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .623 r
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .604 r
F P
s
P
p
.002 w
.42943 .53593 m .44312 .53189 L .45101 .53933 L p
0 1 .585 r
F P
s
P
p
.002 w
.63098 .53049 m .60268 .53856 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.56008 .53173 m .58828 .52359 L .60268 .53856 L p
.4 g
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .736 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .717 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .698 r
F P
s
P
p
.002 w
.40776 .53251 m .39417 .53655 L .38599 .52908 L p
0 1 .679 r
F P
s
P
p
.002 w
.37507 .52736 m .34804 .53546 L .33116 .52044 L p
.4 g
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .736 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .717 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .698 r
F P
s
P
p
.002 w
.38599 .52908 m .39963 .52501 L .40776 .53251 L p
0 1 .679 r
F P
s
P
p
.002 w
.58828 .52359 m .56008 .53173 L .5452 .51663 L p
.4 g
F P
s
P
p
.002 w
.65957 .52233 m .63098 .53049 L .61677 .51536 L p
.4 g
F P
s
P
p
.002 w
.58828 .52359 m .61677 .51536 L .63098 .53049 L p
.4 g
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .66 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .642 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .566 r
F P
s
P
p
.002 w
.43515 .52438 m .42142 .52845 L .41333 .52091 L p
0 1 .547 r
F P
s
P
p
.002 w
.33116 .52044 m .35836 .51217 L .37507 .52736 L p
.4 g
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .472 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .453 r
F P
s
P
p
.002 w
.50629 .52312 m .49236 .5272 L .48461 .51964 L p
0 1 .434 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .66 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .642 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .566 r
F P
s
P
p
.002 w
.41333 .52091 m .42711 .51679 L .43515 .52438 L p
0 1 .547 r
F P
s
P
p
.002 w
.5452 .51663 m .57359 .50833 L .58828 .52359 L p
.4 g
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .472 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .453 r
F P
s
P
p
.002 w
.48461 .51964 m .49859 .51552 L .50629 .52312 L p
0 1 .434 r
F P
s
P
p
.002 w
.68847 .51409 m .65957 .52233 L .64557 .50705 L p
.4 g
F P
s
P
p
.002 w
.61677 .51536 m .64557 .50705 L .65957 .52233 L p
.4 g
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .774 r
F P
s
P
p
.002 w
.39142 .51743 m .37774 .52154 L .36941 .51393 L p
0 1 .755 r
F P
s
P
p
.002 w
.35836 .51217 m .33116 .52044 L .31395 .50512 L p
.4 g
F P
s
P
p
.002 w
.46284 .51616 m .44896 .52028 L .44096 .51265 L p
0 1 .528 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .774 r
F P
s
P
p
.002 w
.36941 .51393 m .38313 .50977 L .39142 .51743 L p
0 1 .755 r
F P
s
P
p
.002 w
.57359 .50833 m .5452 .51663 L .53003 .50124 L p
.4 g
F P
s
P
p
.002 w
.44096 .51265 m .45489 .50849 L .46284 .51616 L p
0 1 .528 r
F P
s
P
p
.002 w
.71766 .50576 m .68847 .51409 L .67467 .49864 L p
.4 g
F P
s
P
p
.002 w
.64557 .50705 m .67467 .49864 L .68847 .51409 L p
.4 g
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .811 r
F P
s
P
p
.002 w
.41899 .50913 m .40517 .51329 L .39693 .5056 L p
0 1 .792 r
F P
s
P
p
.002 w
.31395 .50512 m .34133 .49669 L .35836 .51217 L p
.4 g
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .509 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .491 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .415 r
F P
s
P
p
.002 w
.49081 .50785 m .47679 .51201 L .46888 .50431 L p
0 1 .396 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .811 r
F P
s
P
p
.002 w
.39693 .5056 m .4108 .5014 L .41899 .50913 L p
0 1 .792 r
F P
s
P
p
.002 w
.53003 .50124 m .55862 .49278 L .57359 .50833 L p
.4 g
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .509 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .491 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .415 r
F P
s
P
p
.002 w
.46888 .50431 m .48295 .5001 L .49081 .50785 L p
0 1 .396 r
F P
s
P
p
.002 w
.74716 .49734 m .71766 .50576 L .70407 .49015 L p
.4 g
F P
s
P
p
.002 w
.67467 .49864 m .70407 .49015 L .71766 .50576 L p
.4 g
F P
s
P
p
.002 w
.34133 .49669 m .31395 .50512 L .2964 .4895 L p
.4 g
F P
s
P
p
.002 w
.51908 .49946 m .5049 .50366 L .4971 .49588 L p
0 1 .377 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .226 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .208 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .189 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .17 0 r
F P
s
P
p
.002 w
.59141 .49816 m .57704 .50237 L .56957 .49457 L p
1 .151 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .038 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 .019 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
0 1 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 .019 0 r
F P
s
P
p
.002 w
.66386 .49686 m .64928 .50108 L .64217 .49327 L p
1 0 0 r
F P
s
P
p
.002 w
.4971 .49588 m .51132 .49163 L .51908 .49946 L p
0 1 .377 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .226 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .208 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .189 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .17 0 r
F P
s
P
p
.002 w
.56957 .49457 m .584 .49032 L .59141 .49816 L p
1 .151 0 r
F P
s
P
p
.002 w
.40252 .49359 m .3886 .49783 L .3802 .48999 L p
0 1 .83 r
F P
s
P
p
.002 w
.77698 .48884 m .74716 .49734 L .7338 .48157 L p
.4 g
F P
s
P
p
.002 w
.70407 .49015 m .7338 .48157 L .74716 .49734 L p
.4 g
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .038 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 .019 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
0 1 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 .019 0 r
F P
s
P
p
.002 w
.64217 .49327 m .6568 .489 L .66386 .49686 L p
1 0 0 r
F P
s
P
p
.002 w
.2964 .4895 m .32396 .48091 L .34133 .49669 L p
.4 g
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .358 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .34 r
F P
s
P
p
.002 w
.54764 .49097 m .53332 .49523 L .52561 .48736 L p
0 1 .321 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .245 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .226 r
F P
s
P
p
.002 w
.62038 .48966 m .60586 .49392 L .5985 .48604 L p
0 1 .208 r
F P
s
P
p
.002 w
.3802 .48999 m .39416 .48571 L .40252 .49359 L p
0 1 .83 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .075 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
0 1 .057 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.019 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.038 1 0 r
F P
s
P
p
.002 w
.69324 .48834 m .67851 .49261 L .6715 .48472 L p
.057 1 0 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .358 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .34 r
F P
s
P
p
.002 w
.52561 .48736 m .53998 .48306 L .54764 .49097 L p
0 1 .321 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 1 .943 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 1 .925 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 1 .906 r
F P
s
P
p
.002 w
.35778 .48637 m .34392 .49065 L .33526 .48273 L p
0 1 .887 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .245 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .226 r
F P
s
P
p
.002 w
.5985 .48604 m .61308 .48174 L .62038 .48966 L p
0 1 .208 r
F P
s
P
p
.002 w
.32396 .48091 m .2964 .4895 L .27851 .47357 L p
.4 g
F P
s
P
p
.002 w
.80711 .48024 m .77698 .48884 L .76384 .4729 L p
.4 g
F P
s
P
p
.002 w
.7338 .48157 m .76384 .4729 L .77698 .48884 L p
.4 g
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .075 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
0 1 .057 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.019 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.038 1 0 r
F P
s
P
p
.002 w
.6715 .48472 m .68629 .48041 L .69324 .48834 L p
.057 1 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
0 1 .302 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .264 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .245 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .132 0 r
F P
s
P
p
.002 w
.57652 .4824 m .56204 .4867 L .55443 .47874 L p
1 .113 0 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 1 .943 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 1 .925 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 1 .906 r
F P
s
P
p
.002 w
.33526 .48273 m .34916 .47841 L .35778 .48637 L p
0 1 .887 r
F P
s
P
p
.002 w
.54335 .47691 m .51456 .48554 L .49879 .46953 L p
.4 g
F P
s
P
p
.002 w
.64967 .48107 m .63499 .48538 L .62773 .47741 L p
1 .038 0 r
F P
s
P
p
.002 w
.72294 .47974 m .70805 .48406 L .70115 .47608 L p
.075 1 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
0 1 .302 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .264 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .245 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .132 0 r
F P
s
P
p
.002 w
.55443 .47874 m .56896 .4744 L .57652 .4824 L p
1 .113 0 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .868 r
F P
s
P
p
.002 w
.38572 .47775 m .37171 .48207 L .36314 .47407 L p
0 1 .849 r
F P
s
P
p
.002 w
.62773 .47741 m .64247 .47306 L .64967 .48107 L p
1 .038 0 r
F P
s
P
p
.002 w
.27851 .47357 m .30624 .46481 L .32396 .48091 L p
.4 g
F P
s
P
p
.002 w
.83757 .47155 m .80711 .48024 L .7942 .46413 L p
.4 g
F P
s
P
p
.002 w
.76384 .4729 m .7942 .46413 L .80711 .48024 L p
.4 g
F P
s
P
p
.002 w
.70115 .47608 m .71609 .47172 L .72294 .47974 L p
.075 1 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .283 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .264 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .189 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
0 1 .17 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .396 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .377 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .302 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .283 0 r
F P
s
P
p
.002 w
.6057 .47373 m .59107 .47808 L .58356 .47004 L p
1 .094 0 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .868 r
F P
s
P
p
.002 w
.36314 .47407 m .37719 .4697 L .38572 .47775 L p
0 1 .849 r
F P
s
P
p
.002 w
.49879 .46953 m .52778 .46073 L .54335 .47691 L p
.4 g
F P
s
P
p
.002 w
.67926 .47239 m .66443 .47674 L .65728 .46869 L p
0 1 .094 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.094 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.113 1 0 r
F P
s
P
p
.002 w
.75295 .47105 m .73791 .47541 L .73112 .46734 L p
.132 1 0 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 1 .981 r
F P
s
P
p
.002 w
.34046 .47038 m .32651 .47474 L .31767 .46667 L p
0 1 .962 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .283 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .264 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .189 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
0 1 .17 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .396 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .377 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .302 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .283 0 r
F P
s
P
p
.002 w
.58356 .47004 m .59824 .46565 L .6057 .47373 L p
1 .094 0 r
F P
s
P
p
.002 w
.30624 .46481 m .27851 .47357 L .26025 .45732 L p
.4 g
F P
s
P
p
.002 w
.65728 .46869 m .67217 .4643 L .67926 .47239 L p
0 1 .094 r
F P
s
P
p
.002 w
.86836 .46277 m .83757 .47155 L .82489 .45527 L p
.4 g
F P
s
P
p
.002 w
.7942 .46413 m .82489 .45527 L .83757 .47155 L p
.4 g
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.094 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.113 1 0 r
F P
s
P
p
.002 w
.73112 .46734 m .74622 .46294 L .75295 .47105 L p
.132 1 0 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 1 .981 r
F P
s
P
p
.002 w
.31767 .46667 m .33167 .46226 L .34046 .47038 L p
0 1 .962 r
F P
s
P
p
.002 w
.52778 .46073 m .49879 .46953 L .4827 .45321 L p
.4 g
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
0 1 .151 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .415 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .075 0 r
F P
s
P
p
.002 w
.63519 .46498 m .6204 .46937 L .613 .46124 L p
1 .057 0 r
F P
s
P
p
.002 w
.78329 .46226 m .76808 .46667 L .76141 .45851 L p
.151 1 0 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .887 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .906 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 .981 1 r
F P
s
P
p
.002 w
.36858 .46158 m .35448 .46599 L .34574 .45783 L p
0 1 1 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
0 1 .151 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .415 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .075 0 r
F P
s
P
p
.002 w
.613 .46124 m .62785 .45681 L .63519 .46498 L p
1 .057 0 r
F P
s
P
p
.002 w
.26025 .45732 m .28817 .44838 L .30624 .46481 L p
.4 g
F P
s
P
p
.002 w
.89948 .45389 m .86836 .46277 L .85592 .44631 L p
.4 g
F P
s
P
p
.002 w
.82489 .45527 m .85592 .44631 L .86836 .46277 L p
.4 g
F P
s
P
p
.002 w
.76141 .45851 m .77668 .45406 L .78329 .46226 L p
.151 1 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .358 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .34 0 r
F P
s
P
p
.002 w
.59072 .45749 m .57598 .46192 L .56832 .45372 L p
1 .321 0 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .887 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .906 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 .981 1 r
F P
s
P
p
.002 w
.34574 .45783 m .35989 .45338 L .36858 .46158 L p
0 1 1 r
F P
s
P
p
.002 w
.4827 .45321 m .51189 .44422 L .52778 .46073 L p
.4 g
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .132 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
0 1 .113 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .547 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .528 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .453 0 r
F P
s
P
p
.002 w
.66501 .45612 m .65006 .46056 L .64277 .45235 L p
1 .434 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.17 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.189 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.208 1 0 r
F P
s
P
p
.002 w
.81396 .45338 m .79859 .45783 L .79203 .44959 L p
.226 1 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .358 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .34 0 r
F P
s
P
p
.002 w
.56832 .45372 m .58311 .44925 L .59072 .45749 L p
1 .321 0 r
F P
s
P
p
.002 w
.28817 .44838 m .26025 .45732 L .24163 .44074 L p
.4 g
F P
s
P
p
.002 w
.39701 .45269 m .38276 .45715 L .37411 .4489 L p
0 .868 1 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .132 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
0 1 .113 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .547 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .528 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .453 0 r
F P
s
P
p
.002 w
.64277 .45235 m .65777 .44786 L .66501 .45612 L p
1 .434 0 r
F P
s
P
p
.002 w
.93094 .44492 m .89948 .45389 L .88729 .43725 L p
.4 g
F P
s
P
p
.002 w
.85592 .44631 m .88729 .43725 L .89948 .45389 L p
.4 g
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.17 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.189 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.208 1 0 r
F P
s
P
p
.002 w
.79203 .44959 m .80746 .44509 L .81396 .45338 L p
.226 1 0 r
F P
s
P
p
.002 w
.51189 .44422 m .4827 .45321 L .46628 .43655 L p
.4 g
F P
s
P
p
.002 w
.37411 .4489 m .38841 .4444 L .39701 .45269 L p
0 .868 1 r
F P
s
P
p
.002 w
.69515 .44717 m .68004 .45166 L .67286 .44336 L p
1 .566 0 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .925 1 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .943 1 r
F P
s
P
p
.002 w
.3511 .44509 m .33691 .44959 L .32799 .44127 L p
0 .962 1 r
F P
s
P
p
.002 w
.05204 .29048 m .68081 .05933 L .95262 .44873 L p
.9 g
F P
s
P
p
.002 w
.24163 .44074 m .26973 .43162 L .28817 .44838 L p
.4 g
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 .83 1 r
F P
s
P
p
.002 w
.42575 .4437 m .41134 .44821 L .40279 .43987 L p
0 .849 1 r
F P
s
P
p
.002 w
.67286 .44336 m .68802 .43882 L .69515 .44717 L p
1 .566 0 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .925 1 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .943 1 r
F P
s
P
p
.002 w
.32799 .44127 m .34223 .43672 L .3511 .44509 L p
0 .962 1 r
F P
s
P
p
.002 w
.88729 .43725 m .919 .42809 L .93094 .44492 L p
.4 g
F P
s
P
p
.002 w
.46628 .43655 m .49569 .42738 L .51189 .44422 L p
.4 g
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .509 0 r
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .491 0 r
F P
s
P
p
.002 w
.65046 .43952 m .6354 .44405 L .62796 .43567 L p
1 .472 0 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 .83 1 r
F P
s
P
p
.002 w
.40279 .43987 m .41725 .43532 L .42575 .4437 L p
0 .849 1 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .604 0 r
F P
s
P
p
.002 w
.72562 .43812 m .71034 .44266 L .70328 .43427 L p
1 .585 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.245 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.264 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.34 1 0 r
F P
s
P
p
.002 w
.8009 .43672 m .78541 .44127 L .77871 .43286 L p
.358 1 0 r
F P
s
P
p
.002 w
.26973 .43162 m .24163 .44074 L .22263 .42383 L p
.4 g
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .509 0 r
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .491 0 r
F P
s
P
p
.002 w
.62796 .43567 m .64308 .4311 L .65046 .43952 L p
1 .472 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .604 0 r
F P
s
P
p
.002 w
.70328 .43427 m .71861 .42968 L .72562 .43812 L p
1 .585 0 r
F P
s
P
p
.002 w
.919 .42809 m .88729 .43725 L .87484 .42026 L p
.4 g
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.245 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.264 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.34 1 0 r
F P
s
P
p
.002 w
.77871 .43286 m .79427 .42827 L .8009 .43672 L p
.358 1 0 r
F P
s
P
p
.002 w
.49569 .42738 m .46628 .43655 L .44953 .41955 L p
.4 g
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.283 1 0 r
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.302 1 0 r
F P
s
P
p
.002 w
.83215 .42756 m .81648 .43215 L .80991 .42365 L p
.321 1 0 r
F P
s
P
p
.002 w
.22263 .42383 m .25091 .41452 L .26973 .43162 L p
.4 g
F P
s
P
p
.002 w
.40866 .42685 m .39415 .43145 L .38543 .42294 L p
0 .811 1 r
F P
s
P
p
.002 w
.87484 .42026 m .90681 .41092 L .919 .42809 L p
.4 g
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.283 1 0 r
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.302 1 0 r
F P
s
P
p
.002 w
.80991 .42365 m .82564 .41901 L .83215 .42756 L p
.321 1 0 r
F P
s
P
p
.002 w
.44953 .41955 m .47914 .41019 L .49569 .42738 L p
.4 g
F P
s
P
p
.002 w
.38543 .42294 m .39998 .41829 L .40866 .42685 L p
0 .811 1 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .83 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .811 0 r
F P
s
P
p
.002 w
.71153 .42116 m .69614 .42579 L .68893 .41722 L p
1 .623 0 r
F P
s
P
p
.002 w
.78757 .41973 m .77196 .42436 L .76513 .41578 L p
.377 1 0 r
F P
s
P
p
.002 w
.25091 .41452 m .22263 .42383 L .20324 .40657 L p
.4 g
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .717 1 r
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .736 1 r
F P
s
P
p
.002 w
.36208 .41901 m .34763 .42365 L .33863 .41506 L p
0 .755 1 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .83 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .811 0 r
F P
s
P
p
.002 w
.68893 .41722 m .70438 .41254 L .71153 .42116 L p
1 .623 0 r
F P
s
P
p
.002 w
.90681 .41092 m .87484 .42026 L .86215 .40293 L p
.4 g
F P
s
P
p
.002 w
.76513 .41578 m .7808 .4111 L .78757 .41973 L p
.377 1 0 r
F P
s
P
p
.002 w
.47914 .41019 m .44953 .41955 L .43243 .4022 L p
.4 g
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
1 0 .113 r
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
1 0 .132 r
F P
s
P
p
.002 w
.58999 .4147 m .57487 .41937 L .56701 .41074 L p
1 0 .151 r
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .717 1 r
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .736 1 r
F P
s
P
p
.002 w
.33863 .41506 m .35312 .41037 L .36208 .41901 L p
0 .755 1 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .755 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .736 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .717 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .698 0 r
F P
s
P
p
.002 w
.66622 .41326 m .65088 .41794 L .6434 .40929 L p
1 .679 0 r
F P
s
P
p
.002 w
.74258 .41182 m .72701 .4165 L .71992 .40784 L p
1 .849 0 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
1 0 .113 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
1 0 .132 r
F P
s
P
p
.002 w
.56701 .41074 m .58218 .40602 L .58999 .4147 L p
1 0 .151 r
F P
s
P
p
.002 w
.20324 .40657 m .2317 .39707 L .25091 .41452 L p
.4 g
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .679 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .698 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .774 1 r
F P
s
P
p
.002 w
.39122 .40965 m .37661 .41434 L .3677 .40566 L p
0 .792 1 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .755 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .736 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .717 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .698 0 r
F P
s
P
p
.002 w
.6434 .40929 m .6588 .40457 L .66622 .41326 L p
1 .679 0 r
F P
s
P
p
.002 w
.71992 .40784 m .73554 .40311 L .74258 .41182 L p
1 .849 0 r
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
1 0 .019 r
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
1 0 .038 r
F P
s
P
p
.002 w
.54392 .40675 m .52886 .41146 L .52073 .40274 L p
1 0 .057 r
F P
s
P
p
.002 w
.86215 .40293 m .89438 .39339 L .90681 .41092 L p
.4 g
F P
s
P
p
.002 w
.43243 .4022 m .46226 .39265 L .47914 .41019 L p
.4 g
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .679 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .698 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .774 1 r
F P
s
P
p
.002 w
.3677 .40566 m .38236 .40092 L .39122 .40965 L p
0 .792 1 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .792 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .774 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .66 0 r
F P
s
P
p
.002 w
.69715 .40384 m .68164 .40856 L .67428 .39982 L p
1 .642 0 r
F P
s
P
p
.002 w
.6628 .3978 m .63195 .40729 L .61662 .38969 L p
.4 g
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
.396 1 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
.415 1 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .887 0 r
F P
s
P
p
.002 w
.77397 .40238 m .75823 .40711 L .75126 .39835 L p
1 .868 0 r
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
1 0 .019 r
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
1 0 .038 r
F P
s
P
p
.002 w
.52073 .40274 m .53584 .39799 L .54392 .40675 L p
1 0 .057 r
F P
s
P
p
.002 w
.2317 .39707 m .20324 .40657 L .18345 .38895 L p
.4 g
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.491 1 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.509 1 0 r
F P
s
P
p
.002 w
.85091 .40092 m .83494 .40566 L .82837 .39688 L p
.528 1 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .792 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .774 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .66 0 r
F P
s
P
p
.002 w
.67428 .39982 m .68985 .39504 L .69715 .40384 L p
1 .642 0 r
F P
s
P
p
.002 w
.89438 .39339 m .86215 .40293 L .84918 .38523 L p
.4 g
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
.396 1 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
.415 1 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .887 0 r
F P
s
P
p
.002 w
.75126 .39835 m .76706 .39357 L .77397 .40238 L p
1 .868 0 r
F P
s
P
p
.002 w
.46226 .39265 m .43243 .4022 L .41497 .38448 L p
.4 g
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
1 0 .075 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
1 0 .094 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
1 0 .17 r
F P
s
P
p
.002 w
.57429 .39725 m .55907 .40201 L .55104 .3932 L p
1 0 .189 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.491 1 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.509 1 0 r
F P
s
P
p
.002 w
.82837 .39688 m .8444 .39209 L .85091 .40092 L p
.528 1 0 r
F P
s
P
p
.002 w
.61662 .38969 m .64772 .38 L .6628 .3978 L p
.4 g
F P
s
P
p
.002 w
.80571 .39283 m .78979 .39762 L .78295 .38876 L p
.434 1 0 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
1 0 .075 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
1 0 .094 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
1 0 .17 r
F P
s
P
p
.002 w
.55104 .3932 m .56633 .38839 L .57429 .39725 L p
1 0 .189 r
F P
s
P
p
.002 w
.18345 .38895 m .21209 .37925 L .2317 .39707 L p
.4 g
F P
s
P
p
.002 w
.37341 .39209 m .3587 .39688 L .34961 .38802 L p
0 .66 1 r
F P
s
P
p
.002 w
.84918 .38523 m .88168 .37549 L .89438 .39339 L p
.4 g
F P
s
P
p
.002 w
.78295 .38876 m .79893 .38392 L .80571 .39283 L p
.434 1 0 r
F P
s
P
p
.002 w
.49242 .38299 m .46226 .39265 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.41497 .38448 m .44501 .37473 L .46226 .39265 L p
.4 g
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
1 0 .208 r
F P
s
P
p
.002 w
.60501 .38765 m .58961 .39246 L .5817 .38355 L p
1 0 .226 r
F P
s
P
p
.002 w
.34961 .38802 m .36437 .38318 L .37341 .39209 L p
0 .66 1 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.868 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.887 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.962 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
.981 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 1 0 r
F P
s
P
p
.002 w
.68248 .38616 m .66684 .39098 L .65933 .38206 L p
1 .981 0 r
F P
s
P
p
.002 w
.64772 .38 m .61662 .38969 L .60098 .37171 L p
.4 g
F P
s
P
p
.002 w
.76008 .38467 m .74421 .3895 L .7371 .38056 L p
1 .906 0 r
F P
s
P
p
.002 w
.21209 .37925 m .18345 .38895 L .16323 .37095 L p
.4 g
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .566 1 r
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .585 1 r
F P
s
P
p
.002 w
.32569 .38392 m .31104 .38876 L .30166 .37981 L p
0 .604 1 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.453 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.472 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.547 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.566 1 0 r
F P
s
P
p
.002 w
.83782 .38318 m .82172 .38802 L .815 .37906 L p
.585 1 0 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
1 0 .208 r
F P
s
P
p
.002 w
.5817 .38355 m .59716 .37868 L .60501 .38765 L p
1 0 .226 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.868 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.887 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.962 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
.981 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 1 0 r
F P
s
P
p
.002 w
.65933 .38206 m .67502 .37718 L .68248 .38616 L p
1 .981 0 r
F P
s
P
p
.002 w
.88168 .37549 m .84918 .38523 L .83594 .36716 L p
.4 g
F P
s
P
p
.002 w
.7371 .38056 m .75303 .37568 L .76008 .38467 L p
1 .906 0 r
F P
s
P
p
.002 w
.44501 .37473 m .41497 .38448 L .39715 .3664 L p
.4 g
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
1 0 .321 r
F P
s
P
p
.002 w
.55827 .37943 m .54293 .3843 L .53474 .3753 L p
1 0 .34 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .566 1 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .585 1 r
F P
s
P
p
.002 w
.30166 .37981 m .31635 .37492 L .32569 .38392 L p
0 .604 1 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.453 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.472 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.547 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.566 1 0 r
F P
s
P
p
.002 w
.815 .37906 m .83116 .37417 L .83782 .38318 L p
.585 1 0 r
F P
s
P
p
.002 w
.44501 .37473 m .4754 .36487 L .49242 .38299 L p
.4 g
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
.849 1 0 r
F P
s
P
p
.002 w
.71401 .37643 m .6982 .38131 L .6908 .37228 L p
1 .962 0 r
F P
s
P
p
.002 w
.60098 .37171 m .63231 .36181 L .64772 .38 L p
.4 g
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
1 0 .321 r
F P
s
P
p
.002 w
.53474 .3753 m .55014 .37038 L .55827 .37943 L p
1 0 .34 r
F P
s
P
p
.002 w
.16323 .37095 m .19207 .36105 L .21209 .37925 L p
.4 g
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .528 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .547 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .623 1 r
F P
s
P
p
.002 w
.35523 .37417 m .34042 .37906 L .33113 .37001 L p
0 .642 1 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
.849 1 0 r
F P
s
P
p
.002 w
.6908 .37228 m .70668 .36735 L .71401 .37643 L p
1 .962 0 r
F P
s
P
p
.002 w
.83594 .36716 m .86871 .35721 L .88168 .37549 L p
.4 g
F P
s
P
p
.002 w
.4754 .36487 m .44501 .37473 L .42741 .35644 L p
.4 g
F P
s
P
p
.002 w
.39715 .3664 m .42741 .35644 L .44501 .37473 L p
.4 g
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .245 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .264 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .283 r
F P
s
P
p
.002 w
.58922 .36963 m .5737 .37454 L .56562 .36544 L p
1 0 .302 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .528 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .547 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .623 1 r
F P
s
P
p
.002 w
.33113 .37001 m .346 .36506 L .35523 .37417 L p
0 .642 1 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.906 1 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.925 1 0 r
F P
s
P
p
.002 w
.66749 .36811 m .65174 .37303 L .64406 .36392 L p
.943 1 0 r
F P
s
P
p
.002 w
.63231 .36181 m .60098 .37171 L .58499 .35335 L p
.4 g
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.717 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.736 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.811 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
.83 1 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .943 0 r
F P
s
P
p
.002 w
.7459 .36659 m .72991 .37152 L .72264 .36239 L p
1 .925 0 r
F P
s
P
p
.002 w
.19207 .36105 m .16323 .37095 L .14259 .35258 L p
.4 g
F P
s
P
p
.002 w
.82444 .36506 m .80821 .37001 L .80135 .36086 L p
.604 1 0 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .245 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .264 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .283 r
F P
s
P
p
.002 w
.56562 .36544 m .5812 .36047 L .58922 .36963 L p
1 0 .302 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.906 1 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.925 1 0 r
F P
s
P
p
.002 w
.64406 .36392 m .65988 .35894 L .66749 .36811 L p
.943 1 0 r
F P
s
P
p
.002 w
.86871 .35721 m .83594 .36716 L .82243 .3487 L p
.4 g
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.717 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.736 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.811 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
.83 1 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .943 0 r
F P
s
P
p
.002 w
.72264 .36239 m .73869 .3574 L .7459 .36659 L p
1 .925 0 r
F P
s
P
p
.002 w
.54191 .36124 m .52646 .36621 L .51809 .35702 L p
1 0 .358 r
F P
s
P
p
.002 w
.80135 .36086 m .81765 .35586 L .82444 .36506 L p
.604 1 0 r
F P
s
P
p
.002 w
.42741 .35644 m .45801 .34637 L .4754 .36487 L p
.4 g
F P
s
P
p
.002 w
.58499 .35335 m .61657 .34324 L .63231 .36181 L p
.4 g
F P
s
P
p
.002 w
.77815 .35663 m .76198 .36162 L .75484 .35238 L p
.698 1 0 r
F P
s
P
p
.002 w
.51809 .35702 m .5336 .352 L .54191 .36124 L p
1 0 .358 r
F P
s
P
p
.002 w
.14259 .35258 m .17162 .34246 L .19207 .36105 L p
.4 g
F P
s
P
p
.002 w
.33667 .35586 m .32175 .36086 L .31227 .35161 L p
0 .509 1 r
F P
s
P
p
.002 w
.82243 .3487 m .85546 .33854 L .86871 .35721 L p
.4 g
F P
s
P
p
.002 w
.75484 .35238 m .77108 .34734 L .77815 .35663 L p
.698 1 0 r
F P
s
P
p
.002 w
.31227 .35161 m .32724 .34656 L .33667 .35586 L p
0 .509 1 r
F P
s
P
p
.002 w
.61657 .34324 m .58499 .35335 L .56867 .3346 L p
.4 g
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.755 1 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.774 1 0 r
F P
s
P
p
.002 w
.73141 .34812 m .71529 .35316 L .70787 .34383 L p
.792 1 0 r
F P
s
P
p
.002 w
.17162 .34246 m .14259 .35258 L .12151 .33381 L p
.4 g
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .415 1 r
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .434 1 r
F P
s
P
p
.002 w
.28775 .34734 m .2729 .35238 L .26311 .34305 L p
0 .453 1 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.623 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.642 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.66 1 0 r
F P
s
P
p
.002 w
.81078 .34656 m .79442 .35161 L .78742 .34227 L p
.679 1 0 r
F P
s
P
p
.002 w
.85546 .33854 m .82243 .3487 L .80861 .32985 L p
.4 g
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.755 1 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.774 1 0 r
F P
s
P
p
.002 w
.70787 .34383 m .72406 .33873 L .73141 .34812 L p
.792 1 0 r
F P
s
P
p
.002 w
.40942 .33775 m .37895 .34792 L .36035 .32905 L p
.4 g
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
1 0 .377 r
F P
s
P
p
.002 w
.5252 .34266 m .50963 .34773 L .50108 .33834 L p
1 0 .396 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .415 1 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .434 1 r
F P
s
P
p
.002 w
.26311 .34305 m .27801 .33795 L .28775 .34734 L p
0 .453 1 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.623 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.642 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.66 1 0 r
F P
s
P
p
.002 w
.78742 .34227 m .80384 .33716 L .81078 .34656 L p
.679 1 0 r
F P
s
P
p
.002 w
.64851 .33302 m .61657 .34324 L .60049 .32427 L p
.4 g
F P
s
P
p
.002 w
.56867 .3346 m .60049 .32427 L .61657 .34324 L p
.4 g
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
1 0 .377 r
F P
s
P
p
.002 w
.50108 .33834 m .51671 .33322 L .5252 .34266 L p
1 0 .396 r
F P
s
P
p
.002 w
.12151 .33381 m .15072 .32347 L .17162 .34246 L p
.4 g
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .377 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .396 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .472 1 r
F P
s
P
p
.002 w
.3177 .33716 m .30268 .34227 L .29299 .33282 L p
0 .491 1 r
F P
s
P
p
.002 w
.80861 .32985 m .84193 .31946 L .85546 .33854 L p
.4 g
F P
s
P
p
.002 w
.44025 .32746 m .40942 .33775 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.36035 .32905 m .39105 .31866 L .40942 .33775 L p
.4 g
F P
s
P
p
.002 w
.55662 .33242 m .54087 .33756 L .53244 .32806 L p
1 0 .415 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .377 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .396 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .472 1 r
F P
s
P
p
.002 w
.29299 .33282 m .30807 .32766 L .3177 .33716 L p
0 .491 1 r
F P
s
P
p
.002 w
.15072 .32347 m .12151 .33381 L .09996 .31463 L p
.4 g
F P
s
P
p
.002 w
.68082 .32267 m .64851 .33302 L .63268 .31382 L p
.4 g
F P
s
P
p
.002 w
.60049 .32427 m .63268 .31382 L .64851 .33302 L p
.4 g
F P
s
P
p
.002 w
.53244 .32806 m .54825 .32287 L .55662 .33242 L p
1 0 .415 r
F P
s
P
p
.002 w
.84193 .31946 m .80861 .32985 L .7945 .31058 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .36035 .32905 L .34135 .30977 L p
.4 g
F P
s
P
p
.002 w
.39105 .31866 m .42211 .30814 L .44025 .32746 L p
.4 g
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .434 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .453 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .472 r
F P
s
P
p
.002 w
.58841 .32207 m .57247 .32726 L .56416 .31765 L p
1 0 .491 r
F P
s
P
p
.002 w
.09996 .31463 m .12937 .30407 L .15072 .32347 L p
.4 g
F P
s
P
p
.002 w
.29833 .31806 m .2832 .32327 L .2733 .31362 L p
0 .358 1 r
F P
s
P
p
.002 w
.71352 .3122 m .68082 .32267 L .66526 .30325 L p
.4 g
F P
s
P
p
.002 w
.63268 .31382 m .66526 .30325 L .68082 .32267 L p
.4 g
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .434 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .453 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .472 r
F P
s
P
p
.002 w
.56416 .31765 m .58016 .31241 L .58841 .32207 L p
1 0 .491 r
F P
s
P
p
.002 w
.7945 .31058 m .8281 .29997 L .84193 .31946 L p
.4 g
F P
s
P
p
.002 w
.42211 .30814 m .39105 .31866 L .37227 .29915 L p
.4 g
F P
s
P
p
.002 w
.34135 .30977 m .37227 .29915 L .39105 .31866 L p
.4 g
F P
s
P
p
.002 w
.2733 .31362 m .28848 .30835 L .29833 .31806 L p
0 .358 1 r
F P
s
P
p
.002 w
.12937 .30407 m .09996 .31463 L .07794 .29503 L p
.4 g
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .264 1 r
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .283 1 r
F P
s
P
p
.002 w
.24815 .30916 m .2331 .31443 L .22287 .30468 L p
0 .302 1 r
F P
s
P
p
.002 w
.66526 .30325 m .69822 .29255 L .71352 .3122 L p
.4 g
F P
s
P
p
.002 w
.8281 .29997 m .7945 .31058 L .78008 .29089 L p
.4 g
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .264 1 r
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .283 1 r
F P
s
P
p
.002 w
.22287 .30468 m .23798 .29936 L .24815 .30916 L p
0 .302 1 r
F P
s
P
p
.002 w
.45354 .2975 m .42211 .30814 L .40356 .2884 L p
.4 g
F P
s
P
p
.002 w
.37227 .29915 m .40356 .2884 L .42211 .30814 L p
.4 g
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
1 0 .509 r
F P
s
P
p
.002 w
.57183 .30264 m .55576 .30794 L .54727 .29812 L p
1 0 .528 r
F P
s
P
p
.002 w
.15913 .29338 m .12937 .30407 L .10754 .28423 L p
.4 g
F P
s
P
p
.002 w
.07794 .29503 m .10754 .28423 L .12937 .30407 L p
.4 g
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .226 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .245 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .321 1 r
F P
s
P
p
.002 w
.27853 .29853 m .26329 .30386 L .25318 .294 L p
0 .34 1 r
F P
s
P
p
.002 w
.69822 .29255 m .66526 .30325 L .64935 .2834 L p
.4 g
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
1 0 .509 r
F P
s
P
p
.002 w
.54727 .29812 m .5634 .29276 L .57183 .30264 L p
1 0 .528 r
F P
s
P
p
.002 w
.78008 .29089 m .81396 .28005 L .8281 .29997 L p
.4 g
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .226 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .245 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .321 1 r
F P
s
P
p
.002 w
.25318 .294 m .26846 .28861 L .27853 .29853 L p
0 .34 1 r
F P
s
P
p
.002 w
.48534 .28674 m .45354 .2975 L .43523 .27753 L p
.4 g
F P
s
P
p
.002 w
.40356 .2884 m .43523 .27753 L .45354 .2975 L p
.4 g
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
1 0 .547 r
F P
s
P
p
.002 w
.60425 .29193 m .58799 .2973 L .57962 .28736 L p
1 0 .566 r
F P
s
P
p
.002 w
.18924 .28256 m .15913 .29338 L .1375 .27331 L p
.4 g
F P
s
P
p
.002 w
.10754 .28423 m .1375 .27331 L .15913 .29338 L p
.4 g
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .075 1 r
F P
s
P
p
.002 w
.30927 .28778 m .29385 .29317 L .28384 .28319 L p
0 .094 1 r
F P
s
P
p
.002 w
.64935 .2834 m .68258 .27246 L .69822 .29255 L p
.4 g
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
1 0 .547 r
F P
s
P
p
.002 w
.57962 .28736 m .59595 .28193 L .60425 .29193 L p
1 0 .566 r
F P
s
P
p
.002 w
.81396 .28005 m .78008 .29089 L .76534 .27077 L p
.4 g
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .075 1 r
F P
s
P
p
.002 w
.28384 .28319 m .29931 .27774 L .30927 .28778 L p
0 .094 1 r
F P
s
P
p
.002 w
.51752 .27584 m .48534 .28674 L .46727 .26652 L p
.4 g
F P
s
P
p
.002 w
.43523 .27753 m .46727 .26652 L .48534 .28674 L p
.4 g
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .151 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .17 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .189 1 r
F P
s
P
p
.002 w
.25829 .27858 m .24295 .28403 L .23261 .27394 L p
0 .208 1 r
F P
s
P
p
.002 w
.68258 .27246 m .64935 .2834 L .63308 .2631 L p
.4 g
F P
s
P
p
.002 w
.21971 .27161 m .18924 .28256 L .16782 .26225 L p
.4 g
F P
s
P
p
.002 w
.1375 .27331 m .16782 .26225 L .18924 .28256 L p
.4 g
F P
s
P
p
.002 w
.34038 .27689 m .32478 .28235 L .31488 .27225 L p
0 .057 1 r
F P
s
P
p
.002 w
.76534 .27077 m .79951 .25968 L .81396 .28005 L p
.4 g
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .151 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .17 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .189 1 r
F P
s
P
p
.002 w
.23261 .27394 m .248 .26843 L .25829 .27858 L p
0 .208 1 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
1 0 .585 r
F P
s
P
p
.002 w
.58755 .27183 m .57117 .27732 L .56262 .26716 L p
1 0 .604 r
F P
s
P
p
.002 w
.31488 .27225 m .33054 .26673 L .34038 .27689 L p
0 .057 1 r
F P
s
P
p
.002 w
.46727 .26652 m .49971 .25538 L .51752 .27584 L p
.4 g
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .113 1 r
F P
s
P
p
.002 w
.28925 .26758 m .27372 .2731 L .26349 .26289 L p
0 .132 1 r
F P
s
P
p
.002 w
.63308 .2631 m .66659 .25192 L .68258 .27246 L p
.4 g
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
1 0 .585 r
F P
s
P
p
.002 w
.56262 .26716 m .57907 .26161 L .58755 .27183 L p
1 0 .604 r
F P
s
P
p
.002 w
.25056 .26053 m .21971 .27161 L .19851 .25105 L p
.4 g
F P
s
P
p
.002 w
.16782 .26225 m .19851 .25105 L .21971 .27161 L p
.4 g
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
0 .019 1 r
F P
s
P
p
.002 w
.37186 .26588 m .35607 .2714 L .34629 .26118 L p
0 .038 1 r
F P
s
P
p
.002 w
.79951 .25968 m .76534 .27077 L .75026 .25019 L p
.4 g
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .113 1 r
F P
s
P
p
.002 w
.26349 .26289 m .27907 .25731 L .28925 .26758 L p
0 .132 1 r
F P
s
P
p
.002 w
.49971 .25538 m .46727 .26652 L .4488 .24584 L p
.4 g
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
1 0 .623 r
F P
s
P
p
.002 w
.62063 .26075 m .60404 .2663 L .59562 .25602 L p
1 0 .642 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
0 .019 1 r
F P
s
P
p
.002 w
.34629 .26118 m .36214 .25559 L .37186 .26588 L p
0 .038 1 r
F P
s
P
p
.002 w
.66659 .25192 m .63308 .2631 L .61645 .24235 L p
.4 g
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
1 0 .623 r
F P
s
P
p
.002 w
.59562 .25602 m .61228 .2504 L .62063 .26075 L p
1 0 .642 r
F P
s
P
p
.002 w
.28178 .24932 m .25056 .26053 L .22957 .23972 L p
.4 g
F P
s
P
p
.002 w
.19851 .25105 m .22957 .23972 L .25056 .26053 L p
.4 g
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
.132 0 1 r
F P
s
P
p
.002 w
.40373 .25473 m .38775 .26032 L .37809 .24997 L p
.113 0 1 r
F P
s
P
p
.002 w
.75026 .25019 m .78473 .23885 L .79951 .25968 L p
.4 g
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
1 0 .736 r
F P
s
P
p
.002 w
.57049 .25127 m .55397 .25688 L .54523 .24649 L p
1 0 .755 r
F P
s
P
p
.002 w
.4488 .24584 m .48149 .23445 L .49971 .25538 L p
.4 g
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
.132 0 1 r
F P
s
P
p
.002 w
.37809 .24997 m .39413 .24432 L .40373 .25473 L p
.113 0 1 r
F P
s
P
p
.002 w
.61645 .24235 m .65023 .23091 L .66659 .25192 L p
.4 g
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
1 0 .736 r
F P
s
P
p
.002 w
.54523 .24649 m .56181 .24082 L .57049 .25127 L p
1 0 .755 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.057 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.038 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
.019 0 1 r
F P
s
P
p
.002 w
.35231 .24519 m .3364 .25084 L .32639 .24038 L p
0 0 1 r
F P
s
P
p
.002 w
.78473 .23885 m .75026 .25019 L .73484 .22914 L p
.4 g
F P
s
P
p
.002 w
.31339 .23797 m .28178 .24932 L .26102 .22825 L p
.4 g
F P
s
P
p
.002 w
.22957 .23972 m .26102 .22825 L .28178 .24932 L p
.4 g
F P
s
P
p
.002 w
.43599 .24344 m .41981 .2491 L .41027 .23863 L p
.151 0 1 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .66 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .679 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .698 r
F P
s
P
p
.002 w
.60383 .23994 m .58711 .24562 L .5785 .23511 L p
1 0 .717 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.057 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.038 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
.019 0 1 r
F P
s
P
p
.002 w
.32639 .24038 m .34236 .23467 L .35231 .24519 L p
0 0 1 r
F P
s
P
p
.002 w
.41027 .23863 m .42651 .2329 L .43599 .24344 L p
.151 0 1 r
F P
s
P
p
.002 w
.65023 .23091 m .61645 .24235 L .59943 .22112 L p
.4 g
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .66 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .679 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .698 r
F P
s
P
p
.002 w
.5785 .23511 m .59529 .22936 L .60383 .23994 L p
1 0 .717 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.094 0 1 r
F P
s
P
p
.002 w
.38442 .23378 m .36831 .2395 L .35843 .22892 L p
.075 0 1 r
F P
s
P
p
.002 w
.73484 .22914 m .76961 .21754 L .78473 .23885 L p
.4 g
F P
s
P
p
.002 w
.34538 .22647 m .31339 .23797 L .29286 .21664 L p
.4 g
F P
s
P
p
.002 w
.26102 .22825 m .29286 .21664 L .31339 .23797 L p
.4 g
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.208 0 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.189 0 1 r
F P
s
P
p
.002 w
.46865 .23202 m .45227 .23775 L .44285 .22714 L p
.17 0 1 r
F P
s
P
p
.002 w
.55303 .23025 m .53638 .23599 L .52744 .22536 L p
1 0 .774 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.094 0 1 r
F P
s
P
p
.002 w
.35843 .22892 m .37459 .22313 L .38442 .23378 L p
.075 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.208 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.189 0 1 r
F P
s
P
p
.002 w
.44285 .22714 m .45929 .22134 L .46865 .23202 L p
.17 0 1 r
F P
s
P
p
.002 w
.59943 .22112 m .6335 .20942 L .65023 .23091 L p
.4 g
F P
s
P
p
.002 w
.52744 .22536 m .54416 .21955 L .55303 .23025 L p
1 0 .774 r
F P
s
P
p
.002 w
.76961 .21754 m .73484 .22914 L .71907 .20761 L p
.4 g
F P
s
P
p
.002 w
.37778 .21484 m .34538 .22647 L .3251 .20488 L p
.4 g
F P
s
P
p
.002 w
.29286 .21664 m .3251 .20488 L .34538 .22647 L p
.4 g
F P
s
P
p
.002 w
.50171 .22045 m .48512 .22625 L .47584 .21551 L p
.226 0 1 r
F P
s
P
p
.002 w
.46286 .21304 m .42991 .22469 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.6335 .20942 m .59943 .22112 L .58203 .1994 L p
.4 g
F P
s
P
p
.002 w
.47584 .21551 m .49249 .20965 L .50171 .22045 L p
.226 0 1 r
F P
s
P
p
.002 w
.71907 .20761 m .75414 .19573 L .76961 .21754 L p
.4 g
F P
s
P
p
.002 w
.41057 .20306 m .37778 .21484 L .35774 .19297 L p
.4 g
F P
s
P
p
.002 w
.3251 .20488 m .35774 .19297 L .37778 .21484 L p
.4 g
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
1 0 .792 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
1 0 .811 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
.264 0 1 r
F P
s
P
p
.002 w
.53518 .20874 m .51839 .21461 L .50924 .20374 L p
.245 0 1 r
F P
s
P
p
.002 w
.41057 .20306 m .44379 .19113 L .46286 .21304 L p
.4 g
F P
s
P
p
.002 w
.668 .19757 m .6335 .20942 L .61638 .18743 L p
.4 g
F P
s
P
p
.002 w
.58203 .1994 m .61638 .18743 L .6335 .20942 L p
.4 g
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
1 0 .792 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
1 0 .811 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
.264 0 1 r
F P
s
P
p
.002 w
.50924 .20374 m .5261 .1978 L .53518 .20874 L p
.245 0 1 r
F P
s
P
p
.002 w
.75414 .19573 m .71907 .20761 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.44379 .19113 m .41057 .20306 L .39079 .18092 L p
.4 g
F P
s
P
p
.002 w
.35774 .19297 m .39079 .18092 L .41057 .20306 L p
.4 g
F P
s
P
p
.002 w
.56907 .19688 m .55207 .20283 L .54306 .19182 L p
1 0 .83 r
F P
s
P
p
.002 w
.70293 .18557 m .668 .19757 L .65117 .1753 L p
.4 g
F P
s
P
p
.002 w
.61638 .18743 m .65117 .1753 L .668 .19757 L p
.4 g
F P
s
P
p
.002 w
.54306 .19182 m .56013 .1858 L .56907 .19688 L p
1 0 .83 r
F P
s
P
p
.002 w
.70293 .18557 m .73831 .17342 L .75414 .19573 L p
.4 g
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.34 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.321 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.302 0 1 r
F P
s
P
p
.002 w
.51691 .18673 m .49998 .19274 L .49062 .18161 L p
.283 0 1 r
F P
s
P
p
.002 w
.47742 .17905 m .44379 .19113 L .42427 .1687 L p
.4 g
F P
s
P
p
.002 w
.39079 .18092 m .42427 .1687 L .44379 .19113 L p
.4 g
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .849 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .868 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .887 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .906 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .925 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .943 r
F P
s
P
p
.002 w
.60339 .18487 m .58618 .1909 L .57731 .17975 L p
1 0 .962 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.34 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.321 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.302 0 1 r
F P
s
P
p
.002 w
.49062 .18161 m .50761 .17553 L .51691 .18673 L p
.283 0 1 r
F P
s
P
p
.002 w
.73831 .17342 m .70293 .18557 L .68641 .16302 L p
.4 g
F P
s
P
p
.002 w
.65117 .1753 m .68641 .16302 L .70293 .18557 L p
.4 g
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .849 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .868 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .887 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .906 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .925 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .943 r
F P
s
P
p
.002 w
.57731 .17975 m .59459 .17365 L .60339 .18487 L p
1 0 .962 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.472 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.453 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.434 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.415 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.396 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.377 0 1 r
F P
s
P
p
.002 w
.55108 .17459 m .53394 .18068 L .52471 .16941 L p
.358 0 1 r
F P
s
P
p
.002 w
.51148 .16681 m .47742 .17905 L .45817 .15634 L p
.4 g
F P
s
P
p
.002 w
.42427 .1687 m .45817 .15634 L .47742 .17905 L p
.4 g
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 .981 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
1 0 1 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
.981 0 1 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
.962 0 1 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
.943 0 1 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
.925 0 1 r
F P
s
P
p
.002 w
.63815 .17271 m .62071 .17881 L .61199 .16752 L p
.906 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.472 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.453 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.434 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.415 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.396 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.377 0 1 r
F P
s
P
p
.002 w
.52471 .16941 m .54193 .16325 L .55108 .17459 L p
.358 0 1 r
F P
s
P
p
.002 w
.68641 .16302 m .7221 .15058 L .73831 .17342 L p
.4 g
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 .981 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
1 0 1 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
.981 0 1 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
.962 0 1 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
.943 0 1 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
.925 0 1 r
F P
s
P
p
.002 w
.61199 .16752 m .6295 .16135 L .63815 .17271 L p
.906 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.604 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.585 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.566 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.547 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.528 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.509 0 1 r
F P
s
P
p
.002 w
.58569 .1623 m .56833 .16847 L .55925 .15706 L p
.491 0 1 r
F P
s
P
p
.002 w
.54597 .15442 m .51148 .16681 L .49251 .14381 L p
.4 g
F P
s
P
p
.002 w
.45817 .15634 m .49251 .14381 L .51148 .16681 L p
.4 g
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
.887 0 1 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
.868 0 1 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
.849 0 1 r
F P
s
P
p
.002 w
.67335 .1604 m .65569 .16658 L .64712 .15514 L p
.83 0 1 r
F P
s
P
p
.002 w
.7221 .15058 m .68641 .16302 L .66949 .13992 L p
.4 g
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.604 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.585 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.566 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.547 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.528 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.509 0 1 r
F P
s
P
p
.002 w
.55925 .15706 m .57668 .15082 L .58569 .1623 L p
.491 0 1 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
.887 0 1 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
.868 0 1 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
.849 0 1 r
F P
s
P
p
.002 w
.64712 .15514 m .66485 .14889 L .67335 .1604 L p
.83 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.736 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.717 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.698 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.679 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.66 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.642 0 1 r
F P
s
P
p
.002 w
.62074 .14985 m .60316 .1561 L .59423 .14454 L p
.623 0 1 r
F P
s
P
p
.002 w
.58092 .14187 m .54597 .15442 L .5273 .13112 L p
.4 g
F P
s
P
p
.002 w
.49251 .14381 m .5273 .13112 L .54597 .15442 L p
.4 g
F P
s
P
p
.002 w
.66949 .13992 m .7055 .12718 L .7221 .15058 L p
.4 g
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.736 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.717 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.698 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.679 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.66 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.642 0 1 r
F P
s
P
p
.002 w
.59423 .14454 m .61189 .13822 L .62074 .14985 L p
.623 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.811 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.792 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.774 0 1 r
F P
s
P
p
.002 w
.65625 .13724 m .63844 .14357 L .62966 .13186 L p
.755 0 1 r
F P
s
P
p
.002 w
.61631 .12915 m .58092 .14187 L .56254 .11827 L p
.4 g
F P
s
P
p
.002 w
.5273 .13112 m .56254 .11827 L .58092 .14187 L p
.4 g
F P
s
P
p
.002 w
.7055 .12718 m .66949 .13992 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.811 0 1 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.792 0 1 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.774 0 1 r
F P
s
P
p
.002 w
.62966 .13186 m .64755 .12546 L .65625 .13724 L p
.755 0 1 r
F P
s
P
p
.002 w
.65217 .11627 m .61631 .12915 L .59825 .10524 L p
.4 g
F P
s
P
p
.002 w
.56254 .11827 m .59825 .10524 L .61631 .12915 L p
.4 g
F P
s
P
p
.002 w
.65217 .11627 m .6885 .10322 L .7055 .12718 L p
.4 g
F P
s
P
p
.002 w
.6885 .10322 m .65217 .11627 L .63442 .09205 L p
.4 g
F P
s
P
p
.002 w
.59825 .10524 m .63442 .09205 L .65217 .11627 L p
.4 g
F P
s
P
p
.002 w
.63442 .09205 m .67108 .07867 L .6885 .10322 L p
.4 g
F P
s
P
p
.002 w
.68931 .0249 m
.97115 .43795 L
s
.97115 .43795 m
.9751 .46684 L
s
.9751 .46684 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.02969 .2711 m
.0249 .30131 L
s
.0249 .30131 m
.69115 .0565 L
s
.69115 .0565 m
.68931 .0249 L
s
.68931 .0249 m
.02969 .2711 L
s
P
p
p
.002 w
.02969 .2711 m
.68931 .0249 L
s
P
p
.002 w
.04357 .26592 m
.04822 .27006 L
s
P
[(0)] .03427 .25765 1 .88946 Mshowa
p
.002 w
.1946 .20955 m
.19902 .21393 L
s
P
[(5)] .18575 .2008 1 .9893 Mshowa
p
.002 w
.35521 .1496 m
.35937 .15424 L
s
P
[(10)] .3469 .14034 .89735 1 Mshowa
p
.002 w
.52635 .08573 m
.53019 .09063 L
s
P
[(15)] .51867 .07593 .78389 1 Mshowa
p
.001 w
.07305 .25492 m
.07581 .25743 L
s
P
p
.001 w
.10289 .24378 m
.10563 .24632 L
s
P
p
.001 w
.13309 .23251 m
.1358 .23508 L
s
P
p
.001 w
.16365 .2211 m
.16634 .2237 L
s
P
p
.001 w
.22593 .19786 m
.22855 .20052 L
s
P
p
.001 w
.25764 .18602 m
.26024 .18871 L
s
P
p
.001 w
.28976 .17403 m
.29232 .17675 L
s
P
p
.001 w
.32228 .1619 m
.32481 .16464 L
s
P
p
.001 w
.38856 .13715 m
.39102 .13997 L
s
P
p
.001 w
.42235 .12455 m
.42477 .12739 L
s
P
p
.001 w
.45657 .11177 m
.45895 .11465 L
s
P
p
.001 w
.49123 .09884 m
.49358 .10174 L
s
P
p
.001 w
.56193 .07245 m
.56419 .07542 L
s
P
p
.001 w
.59799 .05899 m
.6002 .06199 L
s
P
p
.001 w
.63452 .04535 m
.6367 .04839 L
s
P
p
.001 w
.67155 .03153 m
.67368 .0346 L
s
P
p
/Helvetica findfont 9 scalefont setfont
[(South)] .28845 .10048 .9087 1 Mshowa
P
P
p
P
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True,
  ImageSize->{349, 227},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005M0000h`P10`4000010?ooooooc?ooZ_ooI_oo
<ooo0?o<ooo<c?o<VC/k>gYjN[Vi^OShn03ooeGooj[ooonI<onI0?mVoomVc?mVVOmVI_mV<omV0?lc
oclo?ginO[fm_Oclo5H/1JX00?l00?l0VOl0I_l0<ol00<coolcoc<coVLcoIP<30d92@X61PL30`000
EED0EJX0EOl0ELbIolbIc<bIVLbII/bI<lbI0<aVolaVc0L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0Z/`c
<l`c0<`0ol`0c<`0VL`0I/`0<l`000/;2dY:BXV9RLS8b000oeD0ojX0ool0oiW<VIW<IYW<<iW<09VI
oiVIc9VIVIVIIPl?3di>CXf=SLc<c01E05EE0:YE0?mE09TcoiTcc9TcVITcIYTc<iTc09T0oiT0c1<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEEFKo<fKo06K<ofK<c6K<VFK<IVK<<fK<01LG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZVIVVFIVIVIV<fIV06HcofHcc6HcVFHcIQ/K6eYJFYVIVMSHf01EoeEEojYEoomEoc?o
oc?oc3?oVC?oIS?o<c?o03?<oc?<c1lO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ03>I<c>I03=Voc=Vc3=V
VC=VIS=V<c=V02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZEC<0VC<0IS<0<c<0003oo`3oc03oV@3oIRLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2Io`2Ic02IV@2IIP2I<`2I001Vo`1Vc2/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`0c<`0c0000o`00c000V@00IP00<nh002l_;fi^KZf][Nc/k03o05Go0:[o0?oo0140
003^003M002k002Z0028001g001E03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@00M`00E@00A0008P00
4Nk^k]gMgK^k^cLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l0GP000?l0GP000?l0GP000?l0GP000?l0
GP000?l0GP000?l0GP000?@00_mW0000l`001?l00?mV0000jP02o`L000Co003oIP000>L00ol00`3o
00060004o`00ofH0003T00?o1002o`H000Co003oIP000>800_l20003o`00008000?o0?l01P02ofL0
003O00?o2@04ofh0003L00?o30001?l00?m^0000f@03oa0000Co003oK@000=L00_l00`3o000@0004
o`00ofd0003D00?o5@001Ol0003o06`0002Z00?o0`03oah00olH0003o`00008000?o0000J@000:/0
00?o00001@000ol0000I00;o6P02o`D000?o0000J0000:/000?o00001@000ol0000F00?o6@03o`03
0?l000@000?o0000J0000:/000?o00000P03oaH00ol20003o`0001@00ol00k_o00020003o`0000<0
0_mX0000Z`000ol000020003o`0001@00_lI00?o00Jkbk_;^ol30003o`0000<000?o0000IP000:X0
0_l400Co4003oaT00_l9^`04o`00o`D000?o0000IP000<400olI00?o00c;^l^kbk_;^l^kbol30003
o`0000<000?o0000I@000;h00ol20003o`0001@00ol?^`05o`000?l01@000ol0001T0000_002oaT0
0ol02l^kbk_;^l^kbk_;00;o00Nkbk_;^l_o00<000?o00000P000ol0001T0000D`03o`<00_l300?o
0P03o`8000?o0000CP03oaT00ol:^`?o00>1ok/01[/01?l00?l50003o`0006<0001B0007o`000?l0
o`020003o`3o008000Ko003o0?l20003o`0004/00olI00?o00^kbk_;^l^kbk_;^`02o`F100Sobk_;
^l^ko`<000?o00000`000ol0001R0000EP000ol0o`020003o`3o008000Ko003o0?l20003o`0004T0
0olH00?o3;/2o`R100?o^k/01;/01Ol0003o00@00_mS0000D`03o`8000Ko003o0?l20006o`00o`3o
0P000ol0001600?o0`000ol0000C00;o00bkbk_;^l^kbk_;^l/3o`Z100Wo^l^kbk_;^ol00P000ol0
00030003o`000640001B0003o`0000@00_l20005o`00o`001_m600?o6@03o`bk0_l>P@03ok^k00Bk
00Go0000o`050003o`000600001B0005o`000?l030000ol0o`1600;o6@03o`0<bk_;^l^kbk_;^l^k
0ol00h7oP@0=P@09ol^kbk_;^l_o00<000?o00000`000ol0001O0000D`03o`l000?o0000@@03oaP0
0ol<^`?o1H400on1P@0<P@03ok^k00Fk00Co003o1@000ol0001O0000YP03o`8000?o00005002o`0<
bk_;^l^kbk_;^l^k0ol9P@03oh6100b100Sobk_;^l^ko`<000?o00000`000ol0001N0000X`03oaT0
0ol;^`?o38400on1P@08P@?o00>1ok/01[/01Ol0003o00D000?o0000G@000:400_lI00?o00^kbk_;
^l^kbk_;^`03o`03POn100f100?oPH401H42o`F100Wo^l^kbk_;^ol00P000ol000030003o`0005d0
002N00?o6@02o`^k0ol5P@03oh6100^100?oPH400h42o`R100?o^k/01K/01?l00?l500;oG@0009/0
0ol20003o`0001@00ol02/^kbk_;^l^kbk/3o`V100?oPH402h400on1o`02o`^100So^l^kbk_;o`<0
00?o00000`000ol0001K0000L@03o`@00_lO00;o6@03o`Zk0ol=P@03oh6100^100?oPH4038400onk
^`05^`05o`000?l010000ol0001K0000LP000ol000020004o`00oa/00olH00?o00[;^l^kbk_;^l^k
0ol00h7oP@0=P@03oh6100N10ol00l_oP@0>P@09ol^kbk_;^l_o008000?o00000`000ol0001J0000
LP000ol000020004o`00oaP00olI00;o2[/3o`F100?oPH4038400on1P@03P@?o1K/00on1P@0=P@03
ok^k00Bk00Go0000o`050003o`0005T0001b0003o`00008000Co003o5P02o`8000?o00005003o`09
^l^kbk_;^l^k00?o2H400on1P@0<P@03oh7o00;o00G;^l^kb`02o`03^l_o00n100Sobk_;^l^ko`<0
00?o00000P000ol0001I0000LP000ol000020004o`00oa<00olH00?o2K/3o`f100?oPH4038400onk
^`03^`?o00=2I_l00[/00on1P@08P@?o00>1ok/01[/01?l00?l50003o`0005P0001a00;o1@02oa40
0olI00;o00Zkbk_;^l^kbk_;0_l00h7oP@0=P@03oh6100R10ol01K_;^l^k00;o00Y2CT9>@Tko^l_o
1X43o`F100So^l^kbk_;o`<000?o00000`000ol0001G0000R003oaT00ol9^`?o18400on1P@0<P@03
oh6100B10ol8^`0:od9V@VI2IT9Vo`:k00?oPH400ol9P@03ok^k00Bk00Go0000o`0400;oF00008H0
0_l20003o`0001@00ol02/^kbk_;^l^kbk/2o`R100?oPH4038400on1P@03o`04^l^kb`;o00^kbk_;
^l_o@Ti2CP02o`05bk_;^l/00_l<P@09ol^kbk_;^l_o008000?o00000`000ol0001F0000P`03oaP0
0ol;^`;o2h400on1P@0<P@;o1;/3o`03C_nk00Jk00Co@_oo1k/00on1P@0<P@03ok^k00Fk00Co003o
1@000ol0000600?oC00008000olI00;o00c;^l^kbk_;^l^kbk/2o`j100?oPH401h43o`05^l^kbk/0
0_l5IP0Dol^kbk_;^l_obk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o00<000?o00000`000ol000080003
o`0004T0001n00;o6@03o`^k0ol00h7oP@0>P@03oh6100>10ol8^`03odi>00E>00?o^k/02k/2o`>k
00?oPH402h400onk^`05^`04o`00o`D000?o000020000ol000190000N`04oaL00ol02k_;^l^kbk_;
^l^k00?o1H400on1P@0=P@03oh7o00;o00Fkbk_;^`02o`06bk_;^l_o1fH02_o;^l^kbk_;^l/3o`07
@_o;^l^ko`0=P@09ok_;^l^kbk_o008000?o00000`000ol0000400?oC00007P00ol40003o`000140
0ol;^`?o2H400on1P@0=P@03ok^k00>k0ol00dko^`05^`03odi>00?o2[/01om2Cd9?@_l00k/00on1
P@07P@?o00>1ok/01[/01Ol0003o00D000?o00000`000ol0001<0000MP02oaT00ol02l^kbk_;^l^k
bk_;00;o3H400on1P@08P@?o00G;^l^kb`02o`0<ITeVCFKo^l^kbk_;0_l03[_;^l^kbk_;^l^kbk_o
1T801Oo;^l_o00F10ol5P@09ol^kbk_;^l_o00<000?o00000P02o`@01?m;0000L`03oaP00ol;^`?o
00>1oh403H400on1P@04P@?o2;/00om>CP05CP03ok^k00^k0_l6^`08odm2Cd9?@_l3^`03oh7o00;o
2H400onk^`05^`04o`00o`<000?o0?l0D`0007001OlF00?o00_;^l^kbk_;^l^kb`03o`F100?oPH40
38400on1P@03o`04bk_;^`;o01S;^l^kbk_oITeVCFI=I_nkbk_;^l^kbk/3o`09@_nkbk_;^l_o0092
0ol01K_;^l^k00;o3H402?o;^l^kbk_o0`000ol000030003o`000500001]00?o6@02o`^k0ol9P@03
oh6100b10_l4^`?o00==ok/01[/00om>CP03o`Vk0_l5@P03ok^k00Bk0_l5^`?o00>1oh403H400onk
^`04^`05o`000?l010000ol0001@0000J`02oaT00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o
01C;^l^kbk_oITeVCFKo^l^kbk_;^`;o01k;^l^kbk_;^l^kbk_o@Tm2Cd9?@_nkbk_;^l^kbk/3o`F1
00?oPH4038402?o;^l^kbk_o0P000ol000030003o`0004l0001X00?o6003o`^k0ol00h7oP@0=P@03
oh6100>10ol9^`03ode=00A=00?o^k/02k/2o`Jk00?o@T801D800onk^`03^`?o2H400on1P@0<P@03
ok^k00Bk00Co003o1@000ol0001>0000I@03o`030?l001D00ol02k_;^l^kbk_;^l^k00?o1H400on1
P@0<P@03oh7o00;o00G;^l^kb`02o`0G^l^kbk_;odeVCFI=I_nkbk_;^l^kbk/00ol033oo^l^kbk_;
^om2C`?o00C;^l^k0ol=P@03oh6100N10ol02H7o^l^kbk_;o`030003o`00008000?o0000CP000480
0olN00;o6@03o`Zk0ol9P@03oh6100b100?o^k/00k/3o`03COnk00Jk00?oCOl00_l:^`03odm?00=?
00?o^k/01K/2o`Bk0ol00h7oP@0=P@03oh6100B10ol5P@03ok^k00Bk00Co003o1@02odh000150003
o`0001P00olH00?o00_;^l^kbk_;^l^kb`02o`f100?oPH401h43o`05^l^kbk/00_l5C@0Wol^kbk_;
^l_obk_;^l^kbk_;^l^kbom??dloCcoo^l^kbk_;^l^k00?o1H400on1P@0<P@03oh6100?o2H402?nk
bk_;^l_o0P000ol0000200;oCP0004D000?o00005@03oaP00ol;^`?o00>1oh403H400on1P@03P@?o
2;/02Om=C4e<CDa=o`0=^`;o1[/00om?C`04C`03ok^k00>k0ol9P@03oh6100b10_l<P@03ok^k00Bk
00Go0000o`040003o`0004`0001200?o5P02o`8000?o00004`04o`0:^l^kbk_;^l^kb`?o1H400on1
P@0<P@03oh7o00;o00fkbk_;^l^kbk_;^l_o00M=00[obk_;^l^kbk_;0ol02doobk_;^l^kbom?00?o
00G;^l^kb`02o`f100?oPH401h43o`03^on100f100Sobk_;^l^ko`8000?o00000`000ol0001;0000
@P000ol0000C00?o6003o`Zk0ol9P@03oh6100b100?o^k/03[/00om=C003o`Zk00?o?cl00cl00onk
^`05^`03ok^k00>k0ol00h7oP@0=P@03oh6100>10ol5^`03oh6100^100?o^k/01K/01?l00?l50003
o`0004X0001200Co3`03oaP00ol02k_;^l^kbk_;^l^k00;o3H400on1P@07P@?o01>1ol^kbk_;^l^k
bk_;^l^kbk_;00;o01jkbk_;^l^kbk_;^l^kocm??dloCoo;^l^kbk_;^l/3o`F100?oPH4038400on1
o`02o`0:^l^kbk_;^l^ko`f100So^l^kbk_;o`<000?o00000`000ol000190000DP03oaP00ol;^`?o
00>1oh403H400on1P@03P@?o1H400onk^`0F^`;o1[/00olo?`04?`03ok^k00>k0ol9P@03oh6100b1
00?o^k/02k/00on1P@09P@03oh7o00Jk00Go0000o`040003o`0004T0001@00;o0`000ol0000C00?o
00[;^l^kbk_;^l^k0ol5P@03oh6100b100?oPOl00_l9P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00?o
00]=ok_;^l^kbk_o?`03o`05^l^kbk/00_l=P@03oh6100N10ol04<^kbk_;^l^kbk_;^l^kbol7P@Co
0X402Oo;^l^kbk_;o`020003o`0000<000?o0000B00004d00olH00?o2[/3o`V100?oPH4038400on1
P@0;P@03ok^k012k00OoCDa=C4go00Nk00?o^k/01[/00on1P@0<P@03oh6100B10olC^`03oh6100Co
1h400onk^`05^`04o`00o`@00_m90000BP03oaP00ol02/^kbk_;^l^kbk/3o`f100?oPH401h43o`03
^l_o00f101?obk_;^l^kbk_;^l^kbk_;^l_o00I=01;o^l^kbk_;^l^kbk_;^l^kbol>P@03oh6100?o
01O;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`b100Sobk_;^l^ko`<000?o00000P000ol000170000
B002oaP01?l9^`?o0h400on1P@0;P@03oh6100>10ol6^`03oh6100^100?o^k/01k/2o`Jk00SoC4e<
CDa=oa2k00?oPH403842oaZk00?oPH4038400onk^`04^`04o`00o`D000?o0000AP0004D00ol20003
o`0001<00ol02K_;^l^kbk_;^`03o`N100?oPH402h400on1o`02o`0;^l^kbk_;^l^kbol03H401_o;
^l^kb`?o00]=ol^kbk_;^l_oC@03o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol9P@?o01n1ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100Wo^l^kbk_;^ol00P000ol000030003o`0004D0001200?o
1P000ol0000?00?o2K/3o`^100?oPH402h400onk^`0<^`03oh6100J10ol6^`07oda=C4e<o`07^`03
ok^k01Fk00?oPH400h43o`F100?o^k/06[/00on1P@0;P@03ok^k00Bk00Go0000o`040003o`0004D0
001000;o6003o`09^l^kbk_;^l^k00?o00>1oh4038400on1P@06P@?o01;;^l^kbk_;^l^kbk_;^l^k
bol5P@;o01jkbk_;^l^kbk_oC4e<CDa=ol^kbk_;^l^kbk_;^l/2o`0B^l^kbk_;^l^kbk_;^l^kbon1
0ol9P@0Mol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol03X402?nkbk_;^l_o0P000ol000030003
o`0004@0000m00?o5`04o`Rk0ol5P@03oh6100^100?oPH400h42oaFk00?oPOl00_l4^`;o1[/02?m=
C4e<CDco2K/3o`03Conk012k00?oPH402h400onk^`0I^`03oh6100N10ol00h7o^`06^`04o`00o`D0
00?o00007@05o`050?ooo`000ol300;o500003X00ol30003o`0001800ol02<^kbk_;^l^k0ol9P@03
oh6100^100?oPOl00_l00k_;^`04o`0Fbk_;^l^kbk_;^l^kbk_;^l_obk_;^`?o00]=C?o;^l^kbk_o
C003o`09^l^kbk_;^l^k00;o01LoCcm??oo;^l^kbk_;^l^kbk_;^l^ko`0>P@0Lol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^ko`J10ol5P@08ol^kbk_;^ol30003o`0000800_lN0003o`00008000Co003o
10001?l00?lE0000=`03oaP00ol9^`;o3H400on1P@09P@03oh7o00>k0ol01De<CDco01Bk00?oCDd0
14d00onk^`04^`03ok^k00Zk00WoCcm??dloCol04;/00on1P@0<P@03ok^k01Rk00?oPH400ol9P@03
ok^k00Bk00Go0000o`040003o`0001`000?o00000`03o`800_l30003o`0001<0000e00;o6004o`08
^l^kbk_;^l/3o`:100?oPH402h400on1P@04P@Co056kbk_;^l_oC4e<CDa=C?o;^l^kbk_;^l^kbk_;
^l^kbk_;^om=C4e<CDcobk_;^l^kbk_;^l^kbk_;^l^kboloCcm??dlool^kbk_;^l^kbk/01?l00l^k
o`0>P@0Kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o3H402?o;^l^kbk_o0P000ol000030003
o`0001/01Ol30003o`3o00D000?o00004`0003801OlF00?o2K/2o`J100?oPH402h400on1P@03o`Bk
0_l5^`09oda=C4e<CDco00^k0ol6^`03odgo00;o1;/2oa2k00?oCcl00ol9^`?o00E??dloo`02^`03
oh6100N10ol00h7o^`0I^`03oh6100b100?o^k/01K/01?l00?l50003o`0001X000?o00000`02o`<0
0ol0103ooolD00004@02oa`00olH00?o00Vkbk_;^l^kbk/00ol9P@03oh6100^10_l01<^kbk/3o`0;
d_nkbk_;^l_oC4d00ol02[_;^l^kbk_;^l/3o`0?C4e<ol^kbk_;^onkbk_;00?o01>1ol^kbk_;^l^k
bk_;^l^kbk_;00;o00fkbk_;^l^kbk_;^l_o00Lo00Cobk_o1H43o`F101co^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l_o3X402?nkbk_;^l_o0`000ol000020003o`0001X000?o00003@000ol0000C0000
40001?l00?lI00;o6003o`Zk0_l=P@03oh6100J10ol6^`03om;B00?B00?o^k/01;/2o`bk00?oCDd0
1Dd00onk^`06^`;o1H400onk^`0F^`;o1K/02OloCcm??dloo`02^`03oh7o00;o2H400onk^`0H^`03
oh6100b100?o^k/01;/01?l00?l50003o`0001T01OlQ000040001?l00?lF00?o5`04o`09bk_;^l^k
bk_;00?o0X400on1P@0;P@03oh6100>10_l02/^kbk_;^l^kbol6dP0Rok_;^l^kbk_;^l^kbk_;^l^k
bk_;oda=C4e<CDcobk_;^`?o28405Oo;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`09?onkbk_;^l_o008o
0ol01[_;^l^ko`f101co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1h44o`:100Wobk_;^l^kbol0
0P000ol000030003o`0003h0000@0004o`00oa<00ol20003o`0001<00ol:^`;o1X400on1P@0;P@03
oh7o00;o3;/00ooBdP04dP03ok^k00Vk0ol6^`03ode=00?o1K/00on1P@0:P@03ok^k00nk0_l01Sm?
?dloo`Jk0_l8^`03oh6100^100?o^k/06K/00on1P@04o`N100?o^k/01;/01Ol0003o00<00_m00000
40001?l00?lA00;o6003o`0:bk_;^l^kbk_;^`?o2H400on1P@0;P@0Cok_;^l^kbk_;^l^kbk_;^l_o
dP03o`0:bk_;^l^kbk_;^`?o00Y=C4go^l^kbk_;0_l02K_;^l^kbk_;o`0=P@0Bol^kbk_;^l^kbk_;
^l^kbk_o1cl04_nkbk_;^l^kbk_;^l^kbk_;o`f101cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
0_l<P@08ol^kbk_;^ol20003o`0000<000?o00001P03o`@00_l^00004@02o`l00olG00Co2K/3o`f1
00?oPH401X43oa>k00?o^k/02k/02?m=C4e<CDco4;/00on1P@0;P@03ok^k00jk00Wo?dloCcm??ol0
2[/3o`>k00?oPH402h400onk^`0H^`03oh6100b100?o^k/01;/01?l00?l50003o`0000H000?o0000
0P001?l00?l]00007`04oaL00ol02K_;^l^kbk_;^`03o`B100?oPH402X400on1P@03P@;o01g;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0O^l^kbk_;oda=C4e<COnkbk_;^l^kbk_;^l^kbk_;
o`0=P@0Bol^kbk_;^l^kbk_;^l^kbk_o0Sl3o`09bk_;^l^kbk_;00?o00Po83oobk_;o`R10ol07X7o
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`f100Wo^l^kbk_;^ol00P000ol000020003o`0000H0
00?o00000P001?l00?l]00007003o`@000?o00004@03o`Vk0ol8P@03oh6100Z100?oPOl00_l4^`;o
5[/3o`9<00?o^k/01;/00om=o`02oa>k00?oPH401X43o`03POnk012k0_l<^`08oclP?b0o8?l2^`03
oh6100>10ol5P@03ok^k01Vk00?oPH402h400onk^`04^`04o`00o`D000?o00001@000ol000020004
o`00obd0000J00;o6003o`09^l^kbk_;^l^k00?o38400on1P@0:P@05ok_;^l/00ol2C00lok_;^l^k
bk_;^l^kbk_;^l^kbk_;odb<C8a<S?nkbk_;^l_obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o1H42o`F1
01So^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`0Bbk_;^l^kob0o83lP?oo;^on10ol9P@0Mok_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol02h402_n1ok_;^l^kbol20003o`0000<000?o000010000ol0
00020004o`00obd0000G00?o5`04o`Rk0ol2P@03oh6100^100?oPH401843o`Jk00?oS8`018`00onk
^`0B^`03oda<00A<00?o^k/07;/00on1o`02o`R100?o^k/04K/3o`038?nk00Jk00?o?ol00_l5^`03
oh6100^100?o^k/06;/00on1P@05P@Co0X400onk^`05^`04o`00o`@00_l400;o1@02obh0000D00?o
00<0ool05@03o`09bk_;^l^kbk_;00;o1X400on1P@0;P@03oh6100?o00>kbk/00_l01/^kbk_;o`I<
00go^l^kbk_;^l^kbk_;00;o00Zkbk_;^l_oC8a<0_l07Xco^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`?o3840:_nkbk_;^l^kbk_;^l^kbk_;^olo83lP?onkbk_;^l^kok_;^l^kbk_;o`f101gobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@Co1h402?o;^l^kbk_o0`001_l00?l0oc/0000C00;o
1@000ol0000?00?o2K/3o`V100?oPH402h42o`>k0ol00dco^`05^`03ohco00;o2k/3o`03C8co00Jk
0olL^`Co0h400on1P@0:P@03ok^k00nk00?o82000b000onk^`0>^`03oh6100^100?o^k/06K/2o`b1
00?o^k/01;/01?l00?l50003o`0003P0000C0003o`3o01<01?l02K_;^l^kbk_;^`02o`f100?oPH40
1X43o`06^l^kbk_o1H`05_nkbk_;^l_obk_;^l^kbk_;^l^kbol6C00Rok_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^`?o28400on1P@0:P@0Zok_;^l^kbk_;^l^kbk_;^l^koclP?olook_;^l^k
bk_;^l^kbk_;^l_o3H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@09ok_;^l^kbk_o0080
00?o00000P000ol0000h00004`001?l00?l?00Co2K/3o`:100?oPH402h400on1P@03P@;o2;/00om<
C004C003ok^k00^k0_l5^`08odb<C8a<S?lM^`?o38400on1P@0:P@03ok^k00nk0olD^`03oh6100B1
1?l2P@03ok^k01Vk00?oPH402h400onk^`04^`05o`000?l010000ol0000g00004`001Ol0003o00`0
0ol02[_;^l^kbk_;^l/2o`J100?oPH402h400on1o`02o`0<bk_;^l^kbk_;^l_o1X`02_nkbk_;^l^k
bk/3o`0:C?nkbk_;^l_oC0?o01c;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol00h7oP@0=P@03
oh6100B10ol0;K_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`02P@?o
1h407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00f100So^l^kbk_;o`8000?o00000`000ol0
000f00004`000ol000020003o`0000H00ol:^`?o2H400on1P@0;P@03ok^k00fk00?oC?l00_l:^`07
odb<C8a<o`06^`03ok^k01^k0_l5P@03oh6100b100?oPH400olN^`;o4;/2o`^100?o^k/06K/00on1
P@06P@?o00>1ok/01[/01?l00?l50003o`0003D0000C0003o`0000<000?o00000P04o`09bk_;^l^k
bk_;00?o3H400on1P@06P@?o026kbk_;^l^kbk_;^l^kbk_;^l_obk_;^l^kbk_;^l^kbol01T`08Onk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`03o`R100?oPH403842o`0N^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;0ol2800Aok_;^l^kbk_;^l^kbk_;^ol03H407?nkbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbol5P@?o1H402Oo;^l^kbk_;o`020004o`0000;o=`00018000?o00001@000ol0
o`02o`Vk0ol4P@03oh6100Z100?oPH400h42oafk0_l5^`08oha<S4b<C?lL^`?o38400on1P@07P@?o
8;/02?lP8B0Q827o3k/00on1P@0;P@03ok^k01Rk00?oPOl00_l9P@03ok^k00Bk00Co003o1@000ol0
000d00004P000ol0000400?o00W;^l^kbk_;^l/00ol8P@03oh6100Z100?oPOl00_l07<^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/3o`0:aXcobk_;^l_oC0?o01_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/00ol3P@03oh6100Z100?oPH400h43o`0L^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o
00Jkbk_;^ol7800Aok_;^l^kbk_;^l^kbk_;^ol03H407?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bol=P@08ol^kbk_;^ol20003o`0000<000?o0000<`00018000Co00000ol40003ok^k00>k0_l<P@03
oh6100Z100?o^k/07;/00on<S004S003ok^k00>k00?o^k/06K/3o`N100?oPH402X400on1o`02oabk
0ol00b7o^`05^`03ob4P00?o4[/00on1P@06P@?o00>1ok/06K/00on1P@0;P@03ok^k00Fk00Co003o
10000ol0000c00004P04o`P000Oo^l^kbk_o00f100?oPH401843o`17bk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^oo6S<J<aXcobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol;P@03
oh6100Z102co^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;ob0Q824Pol^kbk_;^`;o01O;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ko`05P@;o1H407?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^ol=P@08
ok_;^l^kbol20003o`0000<000?o0000<P0001800_l;0003ok^k00>k00?oPH402h400on1P@03oafk
0ol6^`03ohco00;o7;/3o`03POn100b100?oPH401843ob:k00Oo8B0Q827o01jk00?oPOl00_l8P@03
ok^k01Rk00?oPH402h400onk^`04^`04o`00o`D000?o0000<@0001@000?o00002@001onkbk_;^ol0
3H42o`0Mbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol0:8a<S?o;^l^kbk_o^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk/2o`F100?oPH402h400on1P@03o`19^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l_o824Pob3obk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`03o`b1
01cobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o1X44o`:100Wobk_;^l^kbol00P000ol0000200;o
<P0001D000?o00002@000onk^`03^`03oh6100J10ol3P@03ok^k01^k00?oS8`00h`00onk^`0:^`;o
4[/3o`R100?oPH402h42obZk0olK^`Co0X400on1P@0:P@03ok^k01Vk00?oPH400ol7P@03ok^k00Bk
00Go0000o`040003o`000300000F0003o`0000T000Oo^l^kbk_o00F10_l7P@0]ol^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;oha<S?n<ol^kbk_;^l^k00?o01C6ok_;^l^kbk_;^l^kbk_;^l^ko`b1
00?oPH401X43o`18POnkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol7P@03oh6100Z101co^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l;P@08ol^kbk_;^ol20003o`0000<000?o0000;`0001L000?o00002@02o`Bk00?oPOl0
0_l:P@03ok^k01^k0ol:^`07ohc6S<J<o`0A^`03oh6100Z100?oPH400h42o`F100?o^k/0;k/2o`nk
0ol;P@03oh6100R100?oPOl06[/00on1P@0:P@03ok^k00Fk00Co003o10000ol0000_000060000ol0
000:0006ol^kbk_o3X40A?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
ohc6S<Ko^l^kbk_;^l^kbk_;^l^kbk_o38400on1o`02o`R102ko^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol03R3o^l^kbk_;^l^kbk_;0ol00h7oP@0<P@03oh6100B1
0ol07k_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402Onkbk_;^l^ko`020003o`000080
00?o0000;P0001T000?o00002P000onk^`03^`03oh6100^100?o^k/0:K/01_o6S?n<oa6k00?oPH40
2X400on1P@0:P@03ok^k02Vk00?o82000b000onk^`06^`?o1H400on1P@0;P@03oh6100?o8[/00on1
P@0:P@03ok^k00Bk00Co003o1@000ol0000]00006P02o`/000Oobk_;^l_o00f102cobk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kb`;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_o
1X43o`>100?oPH402X409?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`;o017;^l^k
bolQ824P8B3o^l^kb`03o`V100?oPH402h42o`0W^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l_o00N10ol02X7obk_;^l^kbol20003o`0000800_l^000070000ol000090003ok^k00>k
0_l8P@;o0X400onk^`10^`03oh6100?o1h400on1P@0:P@03ok^k01fk0ol28@03ok^k00>k00?o8?l0
0_l3^`?o3H400on1P@06P@?o:K/00on1P@03P@;o1H400onk^`05^`04o`00o`<00_l^00007@000ol0
00090008ol^kbk_;^ol4P@?o1H40<?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`?o013;^l^kbk_;^l^kbk_;^l^k0_l;P@03oh6100Z102oo^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_o824P8B0Qol^kbk_;ol^kb`03o`>100?oPH402X400on1P@03P@?o02nkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_oP@03o`R100Sobk_;^l^ko`80
00?o00000`000ol0000[00007P000ol000090003ok^k00Bk00CoPOoo2H400onk^`0Y^`?o0l000onk
^`0>^`03oh6100Z100?oPH401843ob6k00?o8B4012400onk^`03^`?o1h400on1P@0:P@03oh7o00;o
<K/00on1P@0:P@03ok^k00Bk00Co003o1@000ol0000Z00007`000ol000090008ol^kbk_;^ol<P@14
ol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^oo0a/36`<Kobk_;^l^kbk_;
^l^kbk_;^ol<P@03oh6100?o01bkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol02<^kbk_;^olP
0ol01K_;^l^k00;o2h400on1P@0:P@0fok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l_o3H402?o;^l^kbk_o0P000ol000020003o`0002X0000P0003o`0000T0
0_l5^`03oh6100Z100?o^k/08K/2o`Fk00?o`<001<000onk^`0>^`03oh6100Z10_lL^`?o0b400onk
^`04^`03ok^k00Jk00?oPH402h400on1P@04P@?o6[/2oaRk0_l2^`03oh6100^100?o^k/00k/01Ol0
003o00@000?o0000:@0002400_l;0007ok_;^l^ko`0<P@0Pol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l/3o`;600So^l^kbk_o`0?o01Bkbk_;^l^kbk_;^l^kbk_;^l^ko`J10ol0><^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbolQ;b4_8Oo;^l^kbk_;^l^kbk_;^l_o3H400on1P@03o`0J
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0Gg_o;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol01]ko
bk_;o`R10ol02H7o^l^kbk_;o`020003o`0000<000?o0000:00002<000?o00002@000onk^`03^`03
oh6100Z10_lL^`08ol36`<K0a_l5^`03ok^k01Fk00?oPH400olU^`07ob4Q8OlQo`0?^`03oh6100^1
0_lL^`03omoO00?O00?o^k/04K/00ooNgP03gP04ok^ko`F10ol5P@03ok^k00Bk00Co003o0`02obX0
000T0003o`0000T000Oo^l^kbk_o00J10ol4P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o
1/H03?nkbk_;^l^kbk_;^`;o013;^l^kbk_;^l^kbk_;^l^k0_l05/^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/3o`0@^l^kbk_;^l^kbk_;^l^kb`?o01C;^l^kbk_;^l^kbk_;^l^kbk_;o`J11?l2P@0Ook_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`05gP0=ok_;^l^kbk_;^l^kb`02o`06^l^kbk_o1]h01Oo;
^on100?o2H402?nkbk_;^l_o0P000ol000020003o`0000D00ol300?o6@0002D000?o00002@000onk
^`03^`03oh6100?o28400onk^`0J^`03ol3o00;o2[/3o`;600?o^k/08[/3o`:100?o^k/09K/00on1
P@03o`N100?o^k/06k/01ooOgmoogol02;/3o`;N00?o^k/00k/00ooNo`02o`Fk00?oPH402X400onk
^`04^`04o`00o`D000?o00001@000ol000050003o`0001H0000V0003o`0000T000Ko^l^kbk/2o`b1
05;o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_oa/36`<K0ol^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol6P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00Co00o;^l^k
bk_;^l^kbk_;^l/00_l;P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0ol08K_;^l^kbk_;
^l_og]oNgmkOok_;^l^kok_;^l^kbk_;o`0=P@08ol^kbk_;^ol20003o`00008000?o00001@000ol0
00050003o`0001H0000W0003o`0000T000?o^k/01;/00on1P@0:P@03ok^k02Nk00?oa/H01<H00onk
^`0I^`Co2X400onk^`0>^`?o00@_8Boo4;/00on1P@0:P@03ok^k02Nk00?og]h01Mh00onk^`09^`;o
00>koh4038400onk^`04^`04o`00o`@000?o000010000ol0000200?o6@0002P000?o00002@02o`06
bk_;^l_o3840;?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^oo60ol06[_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol2P@03oh6100Z102Wobk_;^l^kbk_;^l^kbk_;^olQ;b4_
8Onkbk_;^l^kbk_;^l^kbk_;o`0<P@09ok_;^l^kbk_;00;o01Jkbk_;^l^kbk_;^l^kbk_;^l^kbk_;
1?l02;_;^l^komoN0ol02/^kbk_;^l^kbk/3o`05g_nkbol02843o`09POnkbk_;^l_o008000?o0000
0P02o`D000?o00000P000ol0000I0000:@02o`/000?o^k/00k/00on1P@0:P@03ok^k02Nk00?o^k/0
6;/3o`J100?oPH402X400onk^`0>^`07oblQ;ol_o`0:^`?o0k/00on1P@0:P@03ok^k00:k0ol00moo
^`0B^`?o00COWmoo1[/2o`^k0_l01]iagW7No`:k00?oPH400h42o`F100?o^k/01;/01?l00?l20003
o`3o00@00_l400Co600002/000?o00002@001oo;^l^kbol01X43o`>1033o^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/2o`0@bk_;^l^kbk_;^l^kbk_;^`;o2X400on1
P@08P@0Coh7obk_;^l^kbk_;^l^kbk_;^`03o`0:^l^kbk_;^l^kb`?o00PR8B;obk_;o`J10ol2P@05
ol^kbol01Ml0;_o;^l^kbk_;^l^kbk_;^l^kbk_;omnOgioOol^kbk_;^l^kbk_;^l^kbk_;^ol7gP05
ok_;oh400ol8P@08ok_;^l^kbol20003o`00008000?o00008`0002`000?o00002@000onk^`03^`03
oh6100?o1h400onk^`0Y^`?o00?<`?l04;/00on1P@09P@03oh6100B10ol3P@03ok^k01^k00?o8B40
0b401Onk^k_o00:10ol6P@0;ok^komkOg]oNgol02[/3o`Jk00OogioOomoo01:k00?ogW400ol5^`03
oh6100V100?o^k/01;/01?l00?l50003o`000280000]0003o`0000T000Kobk_;^l/2o`^104?o^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o`<c0c<3<ol^kbk_;^l^kbk_;^l^k
bk_o00^100?oPH400ol7P@0Eol^kbk_;^l^kbk_;^l^kbk_;^l^k00?o012kbk_;^l_o8R4Rob;obk_;
0_l:P@05ol^koml00ol02K_;^l^kbk_;^`03o`0:WmnOok_;^l^kb`?o01K;^l^kbk_;^l^kbk_;^l^k
bk_;^l^k0_l02L^kbk_;^l^ko`0<P@08ol^kbk_;^ol20003o`0000<000?o00008@0002h000?o0000
2@000onk^`04^`03oh6100V100?o^k/08;/2o`Fk00Soc<3<`<c0oa2k00?oPH402H42o`^100?o^k/0
3[/3o`<_00?o^k/01;/3o`Jk00?oPH402X401?nk^ol<^`03omoO00CO00?o^k/08k/2o`:k00?oPH40
2X400onk^`04^`04o`00o`@000?o00008@0002l000?o00002@002?o;^l^kbk_o2h408?nkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k0_l02/3<ok_;^l^kol03o`0D^l^kbk_;^l^kbk_;^l^kbk_;
^ol6P@?o0X400on1P@0:P@0Xol^kbk_;^l^kbk_;^l^kbk_o8BlQ;b7o^l^kbk_;^l^kbk_;^l^ko`b1
00Wobk_;^l^kbk/00_l02L^kbk_;omnOg`02o`0;Wonkbk_;^l^kbk/01?l05<^kbk_;^l^kbk_;^l^k
bk_;^l^k0ol01W7o^l^ko`N10ol02X7o^l^kbk_;^ol20003o`00008000?o00008000030000?o0000
2@02o`Fk00?oPH402H42oabk00?o`<000l000onk^`03^`03ok^k01Fk00?oPH400ol6P@03oh6100Z1
00?o^k/03[/01ol_;boo;ol02K/4o`:k00?oPH4028400on1o`04^`?o00?Ook/01K/3o`Zk0ol01MnO
gioo01:k00OogW7NLMko00:k00?oPH400h42o`F100?o^k/01;/01?l00?l30003o`3o0240000a00;o
2`001onkbk_;^ol01X43o`>102oobk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^oo<`<c0c?nkbk_;
^l^kbk_;^`02o`0@bk_;^l^kbk_;^l^kbk_;^`;o2X400on1P@0:P@0Aol^kbk_;^l^kbk_;^l^kbk/0
0ol02K_;^l^kbk_;^`03o`088B8Q8_o;^ol6P@?o0X401Onkbk_o00GO01Co^l^kbk_;^l^kbk_;^l^k
bk_;o`OO00_obk_;^l^kbk_;^`02o`0Abk_;^l_ogW7NLMiaok_;oh400ol8P@08ok_;^l^kbol20003
o`00008000?o00007`0003<000?o00002@000onk^`03^`03oh6100?o1h400onk^`0J^`04ol3oo`Zk
0ol2c003ok^k00fk00?oPH402X400on1P@04P@?o8;/00olR8P048P04ok^ko`:10ol6P@04ok^ko`KO
00?o^k/04;/00onOg`03o`Vk0ol2L@03ok^k00>k00?oLOl00_l5^`03oh6100Z100?o^k/01;/01?l0
0?l40003o`0001h0000d0003o`0000T000Ko^l^kbk/2o`^1047obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^onkbk_;^l^kbk_;^oo0c<3<`<cobk_;^l^kbk_;^l^kbk_;o`0<P@03oh6100?o01_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol02<^kbk_;^olQ0ol01K_;^l^k00;o2X401OnkbooO00?o
01G;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l08[_;^l^kbk_;^l^komiagW7NLOo;^l^kboo;^l^kbk_;
^ol=P@07ok_;^l^ko`020003o`0000<000?o00007@0003D000?o00002@000onk^`03^`03oh6100Z1
00?o^k/09k/00oo<c003c003ok^k00fk00?oPH4028401?n1oolK^`?o0b800onk^`04^`03ok^k00Jk
00?oPH402X401?nk^olO^`;o1;/00omaL@05L@03ok^k00Nk0ol2^`03oh6100^100?o^k/00k/01?l0
0?l40003o`0001d0000f0003o`0000T000Oo^l^kbk_o00b102[obk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0Dbk_;^l^kbk_;^l^kbk_;^l^kbol6P@?o0h40=?nkbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;ob8O8QlRol^kbk_;^l^kbk_;^l^kbol<P@08ok_;^l^kbk/3o`0D
^l^kbk_;^l^kbk_;^l^kbk_;^l/3o`0:goo;^l^kbomagP?o00Rkbk_;^l^kb`?o00Mag_nkbk_o00J1
1?l2P@08ol^kbk_;^ol20004o`0000;o7P0003L000?o00002@000onk^`03^`03oh6100Z10_ln^`03
oh6100?o1h400onk^`0A^`?o1[/01olR8R;o8_l03k/00on1P@08P@03oh7o00>k0ol00ilAo`0C^`03
oinO00>O00?o^k/00k/2o`^k00?og]h00mh01Onk^k_o00:10ol7P@03ok^k00>k00Co003o1@000ol0
000K0000>002o`X00_l01L^kbk_o00J10ol4P@0]ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00?o00o;^l^kbk_;^l^kbk_;^l/00_l;P@0@ok_;^l^kbk_;^l^kbk_;^`?o
00XR7b;o^l^kbk_;0ol05<^kbk_;^l^kbk_;^l^kbk_;^l_o1X43o`0P^l^kbk_;oilAWa6Ool^kbk_;
^l^kbk_;^l^kbk_;^ol6g`0Mol^kbk_;^l^kbk_;^l^kbk_;^ooNLMkog_nkbk/00_l;P@07ol^kbk_;
o`020003o`00008000?o00006`0003X000?o00002@000onk^`02^`03oh6100?o28400onk^`0V^`?o
0`d00onk^`0=^`03oh6100Z100?o^k/03K/01olR7b8O8_l02k/2o`nk00?oPH400ol3^`;o1K/01olA
Wa7o4Ol02[/3o`Fk00?oWol00_lE^`?o1[/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000J0000
>`000ol000090005ol^kbk/00_l<P@0Zok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_o1L`04Oo;^l^kbk_;^l^kbk_;^l_o00b101ko^l^kbk_;^l^kbk_;^l^kob8O8_lRok_;^l^k
bk/3o`8R013obk_;^l^kbk_;^l^kbk_;0_l00k_;^`03o`08Wonkbk_;^l/3o`0:bk_;^l^kbk_;^`?o
02fOgioo^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol038402_nkbk_;^l_o
0?l50003o`0001T0000l0003o`0000T000?o^k/00k/00on1P@0:P@03ok^k01fk0ol6^`07o`d=3Ol=
o`0?^`03oh6100Z100?o^k/03K/3o`Vk00So8QlR7b8Ooa6k0_l5W`03ok^k012k00?oWil019l00onk
^`08^`;o7;/00on1P@08P@03oh7o00Fk00Co003o10000ol0000I0000?@000ol000090006ol^kbk_;
0_l;P@0Mok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00_l3c007ok_;^l^kb`03o`0Dbk_;^l^k
bk_;^l^kbk_;^l^kbol6P@?o0h407Onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00HR01Cobk_;
^l^kbk_;^l^kbk_;^l^ko`FO00[o^l^kbk_;^l^k1?l01l^kbk_;oml00ol02L^kbk_;^l^kb`03o`9a
01go^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^ko`06P@Co0X402?o;^l^kbk_o0P001?l00002oaX0
000n0003o`0000T000?o^k/01;/00on1P@04P@?o0X400onk^`0J^`06o`g<3Lco3;/2o`jk00?oPH40
0ol7P@03ok^k01Vk00?o8_l00_lE^`?o2K/3o`BO00?o^k/00k/00onk^`09^`03omgM00CM00?o^k/0
6K/00on1P@03o`N100?o^k/01;/01?l00?l40003o`0001L0000o0003o`0000T000Sobk_;^l^ko`:1
0ol6P@0Nok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0/`02oo<ok_;^l^kbk_;00?o017<3Onk
bk_;^l^kbk_;^l^kb`02o`^104?o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00HA01Cobk_;^l^kbk_;^l^kbk_;^l^ko`Ea00[o^l^k
bk_;^l^k0ol03k_;^l^kbk_;^l^kbk_;^`02o`^100Oobk_;^l_o008000?o00000`000ol0000F0000
@002o`X000?o^k/01;/2o`Z100?o^k/06[/2o`Zk00?o3@d010d00onk^`0<^`03oh6100Z100?o^k/0
?k/00onOo`02oaFk0ol9^`?o00=aUOl03k/00on1P@0:P@03ok^k00Bk00Co003o10000ol0000F0000
@P000ol0000800;o00Jkbk_;^ol;P@10ok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l_oc0g<3L`=ok_;^l^kbk_;^l^kbk_;o`b107ko^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;omeagG7Mol^kbk_;^l^kbk_;^l^kbol<P@08ok_;^l^kbol20003o`000080
00?o00005@0004<000?o00002@000onk^`03^`03oh6100V100?o^k/09[/00ol=o`02oa6k00?oPH40
1843o`:100?o^k/0AK/2oaJk0ol5^`07oiEaUOnEo`0?^`03oh6100R100?oPOl01K/01?l00?l50003
o`0001@000140003o`0000T000Oo^l^kbk_o00^10_l0?/^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;^l_o0X43o`J102gobk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk/01?l04l^kbk_;^l^kbk_;^l^kbk_;^l/00ol05A7o
bk_;^l^kbk_;^l^kbk_;^l^kb`03o`09gG7o^l^kbk_;00?o01?;^l^kbk_;^l^kbk_;^l^kbk_o00J1
1?l2P@08ol^kbk_;^ol20004o`0000;o5P0004D000?o00002@000onk^`03^`03oh6100B10ol3P@03
ok^k02Zk0_l?^`;o2X400onk^`0V^`?o00DG4ALAo`0A^`03oa4A00<A00?o^k/04;/01ooMLMeagOl0
6k/00on1P@03o`N100?o^k/01;/01?l00?l40003o`0001<000160003o`0000T000Oo^l^kbk_o00:1
0ol7P@0Col^kbk_;^l^kbk_;^l^kbk_;^`04o`0Cbk_;^l^kbk_;^l^kbk_;^l^kb`02o`0Cc0gobk_;
^l^kbk_;^l^kbk_;o`0;P@0kol^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o
4ALA5a4Gol^kbk_;^l^kbk/00_l0?/^kbk_;oa4G4ALAol^kbk_;^l^kbk_;^l^kbk_;^omagG7oLOnk
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k1?l;P@0:ol^kbk_;^ol0o`<00olD0000A`000ol000090003
ok^k00>k0_l;P@03ok^k00bk0ol43@03ok^k00nk00?oc<`00l`00onk^`0=^`03oh6100V100?o^k/0
9[/00olGo`02o`Vk0ol00aOo^`05^`?o5[/3oaVk0ol2P@03oh6100^100?o^k/00k/00ol00003o`80
00?o00004P0004P00_l:0008ok_;^l^kbol;P@0Qol^kbk_;^l^kbk_;^l^kol`=c0g<3Oo;^l^kbk_;
^l^k00;o01c;^l^kbol=c0g<3Oo;^l^kbk_;^l^kbk_;^l_o2h42o`0d^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kok_;^l^kbk_;^l^ko`DA02Go^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;00;o016kbk_;^l^kbk_;^l^kbk_;^`03o`J100?oPH402h401_o;^l^kb`;o
00<0o`000P000ol0000B0000BP000ol0000800;o1K/00on1P@09P@03ok^k00bk00?o3Ol00_l9^`?o
0/`00onk^`03^`?o4k/00on1P@04P@?o0h400onk^`0Z^`;o1K/01olG4ALA5ol08;/3o`03UOnk00bk
1?l:P@03oh6100B11?l9^`03o`3o00<000?o00004P0004/000?o00002@001oo;^l^kbol01X43o`:1
01cobk_;^l^kbk_;^l^kbk_o^l^kbk_;^l^kbk_o1Pd07Oo;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l_o00:10ol7P@0Cok_;^l^kbk_;^l^kbk_;^l^kb`03o`0Cbk_;^l^kbk_;^l^kbk_;^l^kb`03o`8G
00Ko^l^kbk/3o`0b^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbonELIEaUOo;^l^kbk_;
^l/3o`:100?oPH402X400on1P@03o`08^l^kbk_;^l/3o`D000Co003o500004`000?o00002@000onk
^`03^`03oh6100?o1X400onk^`0A^`?o1K/00oo<c003c003ok^k01Vk0_l;P@03ok^k00bk0ol3G`03
ok^k00nk00So5a4G4ALAob>k0_l5^`03oiFE00>E00?o^k/00k/3o`J100?oPH402X42o`Nk1?l90004
o`00oa<0001=0003o`0000T000Kobk_;^l/2o`Z1013obk_;^l^kbk_;^l^kbk_;0ol2]007ok_;^l^k
b`03o`0Pbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbol<P@0?ok_;^l^kbk_;^l^kbk_o00IO
00_obk_;^l^kbk_;^`02o`07bk_;^l^ko`055`0Pok_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk/3o`08UOnkbk_;^l/3o`04bk_;^`Co2X400on1P@04P@?o00S;^l^kbk_;^`?o3P000ol0o`0C0000
CP000ol000090003ok^k00>k00?oPH402H400onk^`0=^`03okBd00:d00?o^k/09[/00on1P@0:P@03
ok^k00^k00?oGol00_l:^`;o00=O7ol01[/3ob6k00OoUMbEg9Go00Nk1Ol2P@03oh6100Z100?oPH40
0ol7^`Co4@000ol0o`0C0000C`02o`X000Oobk_;^l_o00^100Oobk_;^l^k00?o00Nkbk_;^l_o00:d
02co]?nkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;o`J10ol2P@0Mol^kbk_;
^l^kbk_;^l^kok_;^l^kbk_;^l^kbol01Al09?o;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kb`;o00Jkbk_;^ol5U@03ok_o00Co28400on1P@0:P@;o00O;^l^kbk_;00?o5P02oa<0001A0003
o`0000P000?o^k/00k/00on1P@09P@;o0[/2o`04]@feo`Jk0_l/^`03oh6100?o1X400onk^`0A^`?o
1K/01olOGamO7ol02K/3oa>k0ol00mco^`05^`?o00Bkoooo0X400on1P@09P@03oh6100B10ol7^`Co
6003oa<0001B0003o`0000P00_l01K_;^l_o00J10ol3P@04ok_;o`@=00co^l^kbk_;^l^kbk/2o`0W
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;00;o2X404?o;^l^kbk_;^l^kbk_;
^l/3o`8O00Oo^l^kbk_;00?o00W;^l^kbk_;^l/00ol3g00Ool^kbk_;^l^kbk_;^l^kbk_;oiGLUMbE
ol^kbk_;^`03o`J100?oPH402H400on1P@03o`07^l^kbk_;^`03oaT00olF0000D`000ol000090003
ok^k00:k00?oPH400ol7P@09ok^ko`feokGo00Rk0_l00kD=o`0V^`03oh6100Z100?o^k/03;/01olO
GamO7ol02k/2o`Bk00Sog>cLk=c/o`Vk0ol5^`08ombEg9GLok/4o`Z100?oPH401h401?n1ool6^`Co
6004oaT0001D0003o`0000T000Go^l^kb`02o`^100?o^l/00_l02k_;^l^kbk_;^l_o00Fe02Sobk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o38401oo;^l^kbk/01?l01L^kbk_o00<O
00[o7onkbk_;^l^k0ol02ElOol^kbk_og003o`08^l^kbk_;^l/3o`09g9GLol^kbk_;00?o00C;oooo
0X400on1P@09P@03oh6100B10ol01l^kbk_;^l/00olI00?o7@0005D000?o00002@000onk^`03^`03
oh6100V100?o^k/01K/2o`Fk00Oo3KD=]@go02Jk00?oPH4028400on1o`02^`?o00DOGamOo`04^`?o
2K/00olO7`047`03ok^k00:k00?o^k/02[/01onEg9GLUOl01K/3o`J100?oPH402H400on1P@03o`Jk
1?lH00Co800005H000?o00002@001onkbk_;^ol02h42o`03bk_;00;o00Re3Oo;^l^kb`?o02_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol06<^kbk_;^omO7elOGaoo
bk_;^l^kbk_;^`;o01G;^l^kbolOGamO7oo;^l^kbk_;^l/00ol02l^kbk_;ombEg?oL00Go2X400on1
P@07P@0:oh7ool^kbk_;^`?o6004ob@0001G00;o2P000onk^`03^`03oh6100B10ol3P@03ok_o00Fe
00?o^k/0<;/00on1P@03o`:k0ol5^`03oaoo00;o2K/3o`03g?nk00Fk0ol9^`?o00CLUMco1K/6o`:1
00?oPH402H400on1P@04P@?o1[/4oaP00olX0000F@000ol000080007ok_;^l^ko`02P@?o1h404_o;
o`fe3KD=ol^kbk_;^l^kb`Co02Fkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00;o
00?;^ol00_l3k00Cok_;^l^kok_;^l^kbk_;^l^ko`05k00Nok_;^l^kbk_;^l^kbk_;^l^koiGLUMbE
g?o;^l^k0ol6P@03oh6100V100?oPH400ol01[_;^l^kb`?o6004ob/0001J0003o`0000P000?o^k/0
0k/2o`^100?o^ol00_l9^`?o00Fe3KD=o`0X^`03onc/00C/00?o^k/01k/3o`Fk00?og=`00m`00onk
^`07^`?o1K/00onEo`02o`>k0ol:P@03oh6100N100CoPOoo1K/4oaP00ol_0000F`000ol0000800;o
00K;^l^kbol;P@0?ol^kbk_;^l^kbk_;^l_o00Je027o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/01?l01[_;^l_ok0?o00?;^l/00ol00l^ko`02o`09Gaoobk_;^l^k00?o00Vkbk_;^l^kbk/0
0ol38`0:ok_;^l^kok_;^`?o0X400on1P@09P@04oh61P@Go00K;^l^kbk/3oaP01?lb0000G0000ol0
00090003ok^k00>k00?oPH402H400onk^`0;^`03okGo00;o8;/2o`C/00?o^k/00[/01?nk^k/3o`>1
00Co^k_o15l00onk^`0?^`03ob<S00@S00?o^k/00k/3o`J100?oPH402H43o`Nk1?lH00?o=P0005d0
00?o00002@001oo;^l^kbol01X43o`:102cobk_;^l^kbk_;^l^kboo;^l^kbk_;^l^kbk_;^l^kbk_;
^l^kbk_;^l^kb`;o00Jkbk_;^ol5]`05ok_;^l/00ol7P@0Lol^koelOoaoobk_;^l^kbk_;^l^kbk_;
^l_o8`?o00?;^l/01?l:P@03oh6100B10ol02;_;^l^kbk_;0olH00Co>@0005h000?o00002@000onk
^`03^`03oh6100?o1X400onk^`0?^`Co4[/3o`03]onk00Fk0ol5^`;o2h400onk^`02oaFk00Co^k^k
0ol2P@03oh6100Z100?oPH400ol7^`Co6003ocd0001O00;o2P001_o;^l^kb`;o2X403oo;^l^kbk_;
^l^kbk_;^`02o`Be02Oo^l^kbk_;^l^kbk_;^l^kbongk;O/]oo;^l^kbk_;^l^kbk_;^ol038406_o;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;0ol6P@03oh6100Z10_l01k_;^l^kbk/00olH00Co@0000640
00?o000020000onk^`03^`03oh6100V100?o^k/01K/2o`Bk00?o]KD01;D00onk^`07^`?o1K/00ong
]`02]`03ok^k00bk00?oPH402X400onk^`0B^`Co2X400on1P@04P@?o1k/4oaP00om40000HP000ol0
00080007ol^kbk_;o`0;P@;o00>kbk/00_l02KGlok_;^l_o]@03o`08bk_;^l^kbk/3o`09]kKobk_;
^l^k00;o01?;^l^kbk_;^l^kbk_;^l^kbk_o00J10ol2P@0@ok_;^l^kbk_;^l^kbk_;^`Go0h400on1
P@09P@03oh6100?o00O;^l^kbk_;00?o6004odL0001S0003o`0000P00_l4^`03oh6100B10ol3P@09
ok_o][Ff]KKo00Bk00?o^k/02[/01_nf]kJgo`^k0_l=^`03oh6100?o1X400onk^`08^`Co2H400on1
P@09P@;o1[/4oaL01?m;0000I0000ol000090006ok_;^l_o0X43o`N101;o^ool]Obeo?nkbk_;^l^k
bk/3o`0B^l^kbk_o]kKo]_o;^l^kbk_;0ol2]`0>ok_;^l^kbk_;^l^kbk/2o`Z100Oo^l^kbk_;00?o
0X400on1P@09P@03oh6100B10ol01/^kbk_;^`?o6003odl0001U0003o`0000T000?o^k/00[/2o`^1
00?o^ol00_l9^`?o00Bf]kKo1K/2o`Vk00So]kJg][Nfo`fk00?oPH402H400onk^`03o`J100?oPH40
2H400on1P@03o`Fk1?lG00CoDP0006H000?o00002@001onkbk_;^ol02h402?nkbk_;^l^k0_l01L^k
bk_o00Ff01?o^l^kbk_;^l^kbk_;^l^kbk_o00Fg00oo^l^kbk_;^l^kbk_;^ol02h42o`Z100?oPH40
1h402?n1ooo;^l^k1?lH00?oEP0006L00_l:0003ok^k00>k00?oPH402H401?nk^k/3o`03]_nk00Bk
00Co]_oo5;/3oa6k00?oPH401843o`:100?oPH402H401?n1PH45o`Fk0olH00CoF@0006T000?o0000
20001onkbk_;^ol01X43o`:103_o^onfo;Kl]_nkbk_;^onkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l^kbk_;^l^kbk_;^l^ko`02P@?o1X400on1P@09P@?o00Jkbk_;^l/4oaP00omM0000JP000ol0
00080003ok^k00>k00?oPH400ol6P@09ok^kokFf]KKo00Vk0olS^`Co2X400on1P@04P@?o1k/3oaP0
1?mP0000J`000ol0000800;o00C;^l^k0_l:P@03ok_;00;o00Vkbk_;^l^kbk/00ol08KNf]onkbk_;
^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^`05o`B100?oPH4028400on1P@03o`06bk_;^l^k1?lH00?o
I00006`000?o00002@000onk^`02^`03oh6100V100?o^k/03;/00onf]P02]P03ok^k01Nk0ol:P@03
oh6100R10_l6^`?o6004ofL0001]0003o`0000T000Kobk_;^ol;P@0?ok_;^l^kbk_;^l^kbk_;00;o
01Vkbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k00?o0X400on1P@09P@03oh6100Go00Jkbk_;^l/4oaP0
0om[0000KP02o`X000?o^k/00[/00on1P@04P@?o0X400onk^`0S^`?o1X400on1P@09P@;o2;/3oaP0
1?m^0000L0000ol000080006ol^kbk_o0X43o`J1027o^l^kbk_;^l^kbk_;^l^kbk_;^l^kbk_;^l^k
bk_;^l/01?l:P@03oh6100B10ol01k_;^l^kbk/01?lG00CoLP00074000?o000020000onk^`02^`;o
2X400onk^`0H^`Go0h400on1P@09P@03oh6100?o1k/3oaP00omf0000LP000ol000080007ol^kbk_;
o`0:P@0Gok_;^l^kbk_;^l^kbk_;^l^kbk_;^l/00ol9P@03oh6100V10_l01[_;^l^kb`Co5`04ogT0
001c0003o`0000P00_l4^`03oh6100R100?o^k/04;/3o`:100?oPH4028400on1P@04P@?o1[/3oaP0
0omm0000M0000ol000090006ok_;^l_o0X45o`>100oo^l^kbk_;^l^kbk_;^l/00ol6P@03oh6100R1
00?oPH400ol01K_;^l^k00Co5`04oh00001e0003o`0000T000?o^k/00[/2o`V100?o^k/02;/3o`Z1
00?oPH401X401?n1ool5^`?o6003oh@0001f00;o2P001onkbk_;^ol02H401onkbk_;^l/00ol2P@03
oh6100V100?oPH401Ol01L^kbk_;00Co5`04ohL0001h0003o`0000P000?o^k/00k/00on1P@07P@03
ok^k00?o1X400on1P@09P@;o1k/3oaP00on;0000N@000ol000080007ok_;^l^ko`07P@04oh7oo`Z1
00?oPH401843o`06bk_;^l^k1?lG00CoSP0007X000?o000020000onk^`03^`03oh6100Co18400on1
P@08P@03oh6100?o1[/3oaP00onB0000N`000ol000080006ok_;^l^k0_l9P@03oh6100R10_l01L^k
bk_;00Co5`04oiD0001l0003o`0000P00_l4^`03oh6100R100?oPH401Ol6^`?o5`04oiT0001m0003
o`0000T000Kobk_;^ol:P@;o00Nkbk_;^l^k00Co5`03oid0001n00;o2P000onk^`02^`03oh6100>1
0ol7^`?o5`04oj0000200003o`0000P000Oobk_;^on100?o00Jkbk_;^l/4oaL00onT0000P@000ol0
00080003ok^k00:k00?o^k/01;/3oaL01?nW0000PP000ol000080007ol^kbk_;^`04oaL00on[0000
P`000ol000080003ok^k00?o5`04ojh000240003o`0000L00olG00?o/P0008D00_l70003o`0001<0
1?ne0000Q`000ol000040003o`0001000oni0000R0000ol000030003o`0000`01?nl0000R@001Ol0
003o00/01?o00000RP001?l00?l800?oa00008/000?o0?l01004olL0002<00;o00@0oooob`0008d0
0_o>0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000o`1N0000
o`1N0000o`1N0000TP000ol0000W0003o`0009h0001]00Co0`04o`040?oo00;o0P02o`<00ol300?o
10000ol0000800Go00@0ool00_l200Go00<0ool00`03o`@000?o00001`03o`@01Ol200?o0`02o`@0
0ol200?o1002ofl0001/0005o`000?l00P000ol000030004o`00o`<00_l60003o`0000<000?o0000
0P000ol000090005o`000?l00P001?l00?l30003o`0000;o10000ol000040003o`0000L000?o0000
1@000ol000020004o`00o`800_l50003o`0000@000Co00000_m_0000K0000ol0o`02o`801Ol01@3o
003o00/000Co00000ol@0005o`000?l00P001?l00?l30003o`0000H000?o00003P000ol000050003
o`00008000?o00002004o`D000?o0000LP0006`000?o000010001ol0003o0?l00P000ol0000600?o
0`001?l00?l@0005o`000?l00P001?l00?l30003o`0000H000?o00003P03o`D000?o00000P000ol0
00080003o`3o00<00ome0000K0001Ol0003o00<00ol00`3oo`03o`P000?o00000`001?l00?l@0003
o`0000Go0`04o`P000?o00003P000ol0000400;o0`04o`P000?o0?l00`000ol0001e0000K@04oa@0
1?l300;o3`05o`/000?o00001@02o`l01Ol90003o`0000T00_l300CoM0000:`00_lQ0003o`000080
00?o0000QP000?l0GP000001\
\>"],
  ImageRangeCache->{{{0, 348}, {226, 0}} -> {-0.0564445, 0.125294, \
0.00306567, 0.00306567}},
  CellTags->"AntTracker2D - Gen 59"]
}, Open  ]],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        ButtonBox["Previous",
          ButtonData:>"AntTracker2D - Gen 38",
          ButtonStyle->"Hyperlink"], TraditionalForm]]],
  " ",
  Cell[BoxData[
      FormBox[
        ButtonBox["First",
          ButtonData:>"AntTracker2D - Gen 0",
          ButtonStyle->"Hyperlink"], TraditionalForm]]]
}], "Text",
  TextAlignment->Right,
  TextJustification->0]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ant champion programs", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
$RecursionLimit = 1000;
Map[
  showAntPrograms[$basicDirectory,$basicExperiment,#//First,1,
    Generation -> (#//First),
    Fitness -> N[bestFits[[#//First]],2]]&,
    newChampPositions-1
]
\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\
Gen: 0
Gen: 4
Gen: 5
Gen: 9
Gen: 16
Gen: 17
Gen: 18
Gen: 19
Gen: 22
Gen: 35
Gen: 38
Gen: 59\
\>", "Print",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
{TableForm[{\"Gen: 0, Ant: 1\", 5, \
AntTracker[seq[advance]], 
    AntTracker[advance]}], TableForm[{\"Gen: 4, Ant: 1\", 6, 
    AntTracker[seq[seq[advance], 
      ifSensor[dust][seq[seq[advance], seq[turnRight, again]], 
       seq[advance]], seq[nop, nop]]], 
    AntTracker[seq[advance, ifSensor[dust][seq[advance, turnRight, again], 
       advance]]]}], TableForm[{\"Gen: 5, Ant: 1\", 11, 
    AntTracker[seq[seq[advance], 
      ifSensor[dust][seq[seq[stop]], seq[advance]], 
      seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
          ifSensor[phero][seq[turnLeft], seq[stop]]], seq[turnRight]]], 
       seq[nop]]]], AntTracker[seq[advance, 
      ifSensor[dust][seq[stop], advance], 
      ifSensor[dust][seq[turnLeft, again], nop], advance, 
      ifSensor[wall][seq[stop], turnRight]]]}], 
  TableForm[{\"Gen: 9, Ant: 1\", 12, 
    AntTracker[seq[seq[advance], 
      ifSensor[dust][seq[seq[stop]], seq[advance]], 
      seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[seq[advance], ifSensor[wall][seq[seq[turnLeft, again], 
          seq[nop], ifSensor[phero][seq[turnLeft], seq[stop]]], 
         seq[seq[advance]]]], seq[nop]]]], 
    AntTracker[seq[advance, ifSensor[dust][seq[stop], advance], 
      ifSensor[dust][seq[turnLeft, again], nop], advance, 
      ifSensor[wall][seq[turnLeft, again], advance]]]}], 
  TableForm[{\"Gen: 16, Ant: 1\", 16, 
    AntTracker[seq[seq[advance], 
      ifSensor[wall][seq[seq[stop], seq[nop], 
        ifSensor[phero][seq[turnLeft], seq[advance]]], seq[turnRight]], 
      seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
          ifSensor[phero][seq[stop]]], seq[seq[advance]]]], seq[nop]]]], 
    AntTracker[seq[advance, ifSensor[wall][seq[stop], turnRight], 
      ifSensor[dust][seq[turnLeft, again], nop], 
      ifSensor[wall][seq[turnLeft, again], advance]]]}], 
  TableForm[{\"Gen: 17, Ant: 1\", 17, 
    AntTracker[seq[seq[advance], 
      ifSensor[dust][seq[ifSensor[dust][seq[turnLeft, again], seq[nop], 
         seq[nop]], seq[seq[advance], 
         ifSensor[wall][seq[seq[stop], seq[nop], 
           ifSensor[phero][seq[stop], seq[turnLeft]]], seq[seq[advance]]]
], seq[nop]], seq[advance]], seq[ifSensor[dust][seq[turnLeft, again], 
        seq[nop]], seq[seq[advance], 
        ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
          ifSensor[phero][seq[turnLeft], seq[stop]]], seq[seq[advance]]]], 
       seq[nop]]]], AntTracker[seq[advance, 
      ifSensor[dust][seq[ifSensor[dust][seq[turnLe*ft, again], nop, nop], 
        advance, ifSensor[wall][seq[stop], advance]], advance], 
      ifSensor[dust][seq[turnLeft, again], nop], advance, 
      ifSensor[wall][seq[turnLeft, again], advance]]]}], 
  TableForm[{\"Gen: 18, Ant: 1\", 20, 
    AntTracker[seq[seq[advance], 
      ifSensor[wall][seq[seq[stop], seq[nop], 
        ifSensor[phero][seq[turnLeft], seq[advance], seq[advance]]], 
       seq[turnRight]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
          ifSensor[phero][seq[stop]]], 
         seq[seq[advance], ifSensor[dust][seq[seq[stop]], seq[advance]], 
          seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
           seq[seq[advance]], seq[advance]]]]], seq[nop]]]], 
    AntTracker[seq[advance, ifSensor[wall][seq[stop], turnRight], 
      ifSensor[dust][seq[turnLeft, again], nop], 
      ifSensor[wall][seq[turnLeft, again], 
       seq[advance, ifSensor[dust][seq[stop], advance], 
        ifSensor[dust][seq[turnLeft, again], nop], advance, advance]]]]}], 
  TableForm[{\"Gen: 19, Ant: 1\", 27, 
    AntTracker[seq[seq[advance], 
      ifSensor[dust][seq[seq[stop]], seq[advance]], 
      seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[seq[advance], ifSensor[wall][seq[seq[turnLeft], seq[nop], 
          ifSensor[phero][seq[turnLeft], seq[stop]]], seq[seq[advance]]]], 
       seq[nop]]]], AntTracker[seq[advance, 
      ifSensor[dust][seq[stop], advance], 
      ifSensor[dust][seq[turnLeft, again], nop], advance, 
      ifSensor[wall][seq[turnLeft, ifSensor[phero][turnLeft, seq[stop]]], 
       advance]]]}], TableForm[{\"Gen: 22, Ant: 1\", 32, 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
       seq[turnRight]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
          ifSensor[phero][seq[stop]]], seq[seq[advance]]]], seq[nop]]]], 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
      ifSensor[dust][seq[turnLeft, again], nop], 
      ifSensor[wall][seq[turnLeft, again], advance]]]}], 
  TableForm[{\"Gen: 35, Ant: 1\", 33, 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
       seq[{}, ifSensor[wall][ENCAPS[seq, seq$1844827][], seq[turnRight]], 
        seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
            ifSensor[wall][seq[again], seq[seq[nop]]]], seq[seq[advance]]]]
]]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[ifSensor[wall][seq[ifSensor[wall][seq[seq[turnLeft, again], 
            seq[nop], ifSensor[phero][seq[stop]]], 
           seq[seq[seq[nop], seq[seq[advance]]]]]], seq[seq[advance]]]]]]], 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
       seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
        ifSensor[wall][seq[turnLeft, again], advance]]], 
      ifSensor[dust][seq[turnLeft, again], nop], 
      ifSensor[wall][seq[turnLeft, again], advance]]]}], 
  TableForm[{\"Gen: 38, Ant: 1\", 43, 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
       seq[{}, ifSensor[wall][ENCAPS[seq, seq$1844827][], seq[turnRight]], 
        seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
            ifSensor[wall][seq[again], seq[seq[nop]]]], seq[seq[advance]]]]
]]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
       seq[ifSensor[wall][seq[ifSensor[dust][seq[advance]]], 
         seq[seq[advance]]]]]]], 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
       seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
        ifSensor[wall][seq[turnLeft, again], advance]]], 
      ifSensor[dust][seq[turnLeft, again], nop], 
      ifSensor[wall][seq[ifSensor[dust][advance]], advance]]]}], 
  TableForm[{\"Gen: 59, Ant: 1\", 44, 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, turnLeft, again], 
       seq[{}, ifSensor[wall][seq[turnLeft, again], seq[turnRight]], 
        seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
            ifSensor[wall][seq[again], seq[seq[nop], seq[nop]]]], 
           seq[seq[advance]]]]]]], 
      seq[ifSensor[dust][seq[turnLeft, again]], 
       seq[ifSensor[wall][seq[ifSensor[dust][seq[advance]]], 
         seq[ifSensor[dust][seq[turnLeft, again]], 
          seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
             ifSensor[dust][seq[stop], seq[stop], seq[turnLeft]]], 
            seq[seq[advance]]]], seq[nop]]]]]]], 
    AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, turnLeft, again], 
       seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
        ifSensor[wall][seq[turnLeft, again], advance]]], 
      ifSensor[dust][seq[turnLeft, again]], 
      ifSensor[wall][seq[ifSensor[dust][advance]], 
       seq[ifSensor[dust][seq[turnLeft, again]], 
        ifSensor[wall][seq[turnLeft, again], advance]]]]]}]}\
\>", "\<\
      \
                     Gen: 4, Ant: 1

{Gen: 0, Ant: 1          , 6                                                 \
\\

 5                         AntTracker[seq[seq[advance], 
                            
 AntTracker[seq[advance]]     ifSensor[dust][seq[seq[advance], 
                            
 AntTracker[advance]            seq[turnRight, again]], seq[advance]], 
                            
                              seq[nop, nop]]]

                           AntTracker[seq[advance, 
                            
                              ifSensor[dust][seq[advance, turnRight, again], 
                            
                               advance]]]
 
     Gen: 5, Ant: 1

   , 11                                                                     , \


     AntTracker[seq[seq[advance], ifSensor[dust][seq[seq[stop]], 
      
         seq[advance]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
      
         seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
      
            ifSensor[phero][seq[turnLeft], seq[stop]]], seq[turnRight]]], 
      
         seq[nop]]]]

     AntTracker[seq[advance, ifSensor[dust][seq[stop], advance], 
      
        ifSensor[dust][seq[turnLeft, again], nop], advance, 
      
        ifSensor[wall][seq[stop], turnRight]]]
 
  Gen: 9, Ant: 1

  12                                                                         \
\\

  AntTracker[seq[seq[advance], ifSensor[dust][seq[seq[stop]], seq[advance]], 
   
     seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
   
      seq[seq[advance], ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
   
         ifSensor[phero][seq[turnLeft], seq[stop]]], seq[seq[advance]]]], 
   
      seq[nop]]]]

  AntTracker[seq[advance, ifSensor[dust][seq[stop], advance], 
   
     ifSensor[dust][seq[turnLeft, again], nop], advance, 
   
     ifSensor[wall][seq[turnLeft, again], advance]]]
 
     Gen: 16, Ant: 1

   , 16                                                                   , 

     AntTracker[seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
      
          ifSensor[phero][seq[turnLeft], seq[advance]]], seq[turnRight]], 
      
        seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
      
         seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
            ifSensor[phero][seq[stop]]], seq[seq[advance]]]], seq[nop]]]]

     AntTracker[seq[advance, ifSensor[wall][seq[stop], turnRight], 
      
        ifSensor[dust][seq[turnLeft, again], nop], 
      
        ifSensor[wall][seq[turnLeft, again], advance]]]
 
  Gen: 17, Ant: 1

  17

  AntTracker[seq[seq[advance], ifSensor[dust][seq[ifSensor[dust][          , 
   
        seq[turnLeft, again], seq[nop], seq[nop]], 
   
       seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop], 
   
          ifSensor[phero][seq[stop], seq[turnLeft]]], seq[seq[advance]]]], 
   
       seq[nop]], seq[advance]], 
   
     seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
   
      seq[seq[advance], ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
   
         ifSensor[phero][seq[turnLeft], seq[stop]]], seq[seq[advance]]]], 
   
      seq[nop]]]]

  AntTracker[seq[advance, ifSensor[dust][seq[ifSensor[dust][seq[turnLe ft, 
   
         again], nop, nop], advance, ifSensor[wall][seq[stop], advance]], 
   
      advance], ifSensor[dust][seq[turnLeft, again], nop], advance, 
   
     ifSensor[wall][seq[turnLeft, again], advance]]]
 
  Gen: 18, Ant: 1

  20

  AntTracker[seq[seq[advance], ifSensor[wall][seq[seq[stop], seq[nop],     , 
   
       ifSensor[phero][seq[turnLeft], seq[advance], seq[advance]]], 
   
      seq[turnRight]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
   
      seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
   
         ifSensor[phero][seq[stop]]], 
   
        seq[seq[advance], ifSensor[dust][seq[seq[stop]], seq[advance]], 
   
         seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
   
          seq[seq[advance]], seq[advance]]]]], seq[nop]]]]

  AntTracker[seq[advance, ifSensor[wall][seq[stop], turnRight], 
   
     ifSensor[dust][seq[turnLeft, again], nop], 
   
     ifSensor[wall][seq[turnLeft, again], 
   
      seq[advance, ifSensor[dust][seq[stop], advance], 
   
       ifSensor[dust][seq[turnLeft, again], nop], advance, advance]]]]
 
  Gen: 19, Ant: 1

  27                                                                         \
\\

  AntTracker[seq[seq[advance], ifSensor[dust][seq[seq[stop]], seq[advance]], 
   
     seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
   
      seq[seq[advance], ifSensor[wall][seq[seq[turnLeft], seq[nop], 
   
         ifSensor[phero][seq[turnLeft], seq[stop]]], seq[seq[advance]]]], 
   
      seq[nop]]]]

  AntTracker[seq[advance, ifSensor[dust][seq[stop], advance], 
   
     ifSensor[dust][seq[turnLeft, again], nop], advance, 
   
     ifSensor[wall][seq[turnLeft, ifSensor[phero][turnLeft, seq[stop]]], 
   
      advance]]]
 
     Gen: 22, Ant: 1

   , 32

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], seq[turnRight]], \

      
        seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
      
         seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
            ifSensor[phero][seq[stop]]], seq[seq[advance]]]], seq[nop]]]]

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
      
        ifSensor[dust][seq[turnLeft, again], nop], 
      
        ifSensor[wall][seq[turnLeft, again], advance]]]
 
     Gen: 35, Ant: 1

     33

   , AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
      
         seq[{}, ifSensor[wall][ENCAPS[seq, seq$1844827][], seq[turnRight]], 
      
          seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
              ifSensor[wall][seq[again], seq[seq[nop]]]], \
seq[seq[advance]]]]]
      
           ]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
      
         seq[ifSensor[wall][seq[ifSensor[wall][seq[seq[turnLeft, again], 
      
              seq[nop], ifSensor[phero][seq[stop]]], 
      
             seq[seq[seq[nop], seq[seq[advance]]]]]], seq[seq[advance]]]]]]]

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
      
         seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
      
          ifSensor[wall][seq[turnLeft, again], advance]]], 
      
        ifSensor[dust][seq[turnLeft, again], nop], 
      
        ifSensor[wall][seq[turnLeft, again], advance]]]
 
     Gen: 38, Ant: 1

     43
   , 
     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
      
         seq[{}, ifSensor[wall][ENCAPS[seq, seq$1844827][], seq[turnRight]], 
      
          seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
              ifSensor[wall][seq[again], seq[seq[nop]]]], \
seq[seq[advance]]]]]
      
           ]], seq[ifSensor[dust][seq[turnLeft, again], seq[nop]], 
      
         seq[ifSensor[wall][seq[ifSensor[dust][seq[advance]]], 
      
           seq[seq[advance]]]]]]]

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, again], 
      
         seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
      
          ifSensor[wall][seq[turnLeft, again], advance]]], 
      
        ifSensor[dust][seq[turnLeft, again], nop], 
      
        ifSensor[wall][seq[ifSensor[dust][advance]], advance]]]
 
     Gen: 59, Ant: 1

     44

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, turnLeft, again], 
   ,                                                                   }
         seq[{}, ifSensor[wall][seq[turnLeft, again], seq[turnRight]], 
      
          seq[seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
              ifSensor[wall][seq[again], seq[seq[nop], seq[nop]]]], 
      
             seq[seq[advance]]]]]]], 
      
        seq[ifSensor[dust][seq[turnLeft, again]], 
      
         seq[ifSensor[wall][seq[ifSensor[dust][seq[advance]]], 
      
           seq[ifSensor[dust][seq[turnLeft, again]], 
      
            seq[ifSensor[wall][seq[seq[turnLeft, again], seq[nop], 
      
               ifSensor[dust][seq[stop], seq[stop], seq[turnLeft]]], 
      
              seq[seq[advance]]]], seq[nop]]]]]]]

     AntTracker[seq[{}, ifSensor[wall][seq[turnLeft, turnLeft, again], 
      
         seq[{}, ifSensor[wall][seq[turnLeft, again], turnRight], 
      
          ifSensor[wall][seq[turnLeft, again], advance]]], 
      
        ifSensor[dust][seq[turnLeft, again]], 
      
        ifSensor[wall][seq[ifSensor[dust][advance]], 
      
         seq[ifSensor[dust][seq[turnLeft, again]], 
      
          ifSensor[wall][seq[turnLeft, again], advance]]]]]\
\>"], "Output",
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reference", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 8.2.\n"
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Working",
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{774, 697},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> \
FrontEnd`FileName[{ParentDirectory[ParentDirectory[ParentDirectory[]]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "AntTracker3D - Gen 59"->{
    Cell[2001, 62, 76232, 5766, 300, 49471, 5429, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 59"],
    Cell[4295134, 279364, 85795, 5884, 352, 49471, 5429, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 59"]},
  "Fitness chart 3D - Part 1"->{
    Cell[732041, 31360, 652267, 49443, 338, 601287, 48807, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Fitness chart 3D - Part 1"]},
  "Fitness chart 3D - Part 2"->{
    Cell[1384955, 80832, 662172, 48390, 338, 604493, 47671, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"Fitness chart 3D - Part 2"]},
  "AntTracker3D - Gen 0"->{
    Cell[2107824, 131903, 89254, 6487, 352, 54351, 6049, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 0"]},
  "AntTracker2D - Gen 0"->{
    Cell[2197953, 138424, 123348, 8584, 297, 87615, 8136, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 0"]},
  "AntTracker3D - Gen 4"->{
    Cell[2321843, 147034, 89053, 6472, 352, 54260, 6035, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 4"]},
  "AntTracker2D - Gen 4"->{
    Cell[2411505, 153532, 123368, 8543, 297, 87550, 8094, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 4"]},
  "AntTracker3D - Gen 5"->{
    Cell[2535418, 162101, 88901, 6457, 352, 54142, 6021, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 5"]},
  "AntTracker2D - Gen 5"->{
    Cell[2625447, 168597, 122377, 8446, 297, 86526, 7996, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 5"]},
  "AntTracker3D - Gen 9"->{
    Cell[2748369, 177069, 87793, 5940, 352, 49797, 5464, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 9"]},
  "AntTracker2D - Gen 9"->{
    Cell[2836898, 183037, 110358, 7396, 297, 74507, 6946, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 9"]},
  "AntTracker3D - Gen 16"->{
    Cell[2947803, 190459, 85747, 5846, 352, 49227, 5388, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 16"]},
  "AntTracker2D - Gen 16"->{
    Cell[3034557, 196341, 109499, 7214, 297, 72489, 6750, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 16"]},
  "AntTracker3D - Gen 17"->{
    Cell[3144603, 203581, 85944, 5880, 352, 49436, 5422, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 17"]},
  "AntTracker2D - Gen 17"->{
    Cell[3231465, 209492, 109248, 7248, 297, 72906, 6792, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 17"]},
  "AntTracker3D - Gen 18"->{
    Cell[3341261, 216766, 82820, 5458, 352, 46086, 4997, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 18"]},
  "AntTracker2D - Gen 18"->{
    Cell[3425014, 222255, 100100, 6422, 297, 63706, 5966, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 18"]},
  "AntTracker3D - Gen 19"->{
    Cell[3525662, 228703, 87284, 5985, 352, 50171, 5520, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 19"]},
  "AntTracker2D - Gen 19"->{
    Cell[3613765, 234717, 109816, 7303, 297, 73563, 6848, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 19"]},
  "AntTracker3D - Gen 22"->{
    Cell[3724129, 242046, 82623, 5493, 352, 46434, 5039, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 22"]},
  "AntTracker2D - Gen 22"->{
    Cell[3807768, 247575, 99635, 6342, 297, 62977, 5882, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 22"]},
  "AntTracker3D - Gen 35"->{
    Cell[3907951, 253943, 85652, 5833, 352, 49059, 5374, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 35"]},
  "AntTracker2D - Gen 35"->{
    Cell[3994551, 259808, 108290, 6968, 297, 69676, 6484, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 35"]},
  "AntTracker3D - Gen 38"->{
    Cell[4103389, 266802, 85107, 5782, 352, 48682, 5325, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker3D - Gen 38"]},
  "AntTracker2D - Gen 38"->{
    Cell[4189454, 272616, 105132, 6722, 297, 67150, 6246, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 38"]},
  "AntTracker2D - Gen 59"->{
    Cell[4382357, 285292, 107286, 6906, 297, 69150, 6428, "GraphicsData", 
    "PostScript", "Graphics",
      Evaluatable->False,
      CellTags->"AntTracker2D - Gen 59"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"AntTracker3D - Gen 59", 4508520, 292727},
  {"Fitness chart 3D - Part 1", 4508891, 292736},
  {"Fitness chart 3D - Part 2", 4509103, 292741},
  {"AntTracker3D - Gen 0", 4509311, 292746},
  {"AntTracker2D - Gen 0", 4509511, 292751},
  {"AntTracker3D - Gen 4", 4509712, 292756},
  {"AntTracker2D - Gen 4", 4509912, 292761},
  {"AntTracker3D - Gen 5", 4510113, 292766},
  {"AntTracker2D - Gen 5", 4510313, 292771},
  {"AntTracker3D - Gen 9", 4510514, 292776},
  {"AntTracker2D - Gen 9", 4510714, 292781},
  {"AntTracker3D - Gen 16", 4510916, 292786},
  {"AntTracker2D - Gen 16", 4511118, 292791},
  {"AntTracker3D - Gen 17", 4511321, 292796},
  {"AntTracker2D - Gen 17", 4511523, 292801},
  {"AntTracker3D - Gen 18", 4511726, 292806},
  {"AntTracker2D - Gen 18", 4511928, 292811},
  {"AntTracker3D - Gen 19", 4512131, 292816},
  {"AntTracker2D - Gen 19", 4512333, 292821},
  {"AntTracker3D - Gen 22", 4512536, 292826},
  {"AntTracker2D - Gen 22", 4512738, 292831},
  {"AntTracker3D - Gen 35", 4512940, 292836},
  {"AntTracker2D - Gen 35", 4513142, 292841},
  {"AntTracker3D - Gen 38", 4513345, 292846},
  {"AntTracker2D - Gen 38", 4513547, 292851},
  {"AntTracker2D - Gen 59", 4513750, 292856}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 107, 2, 91, "Title",
  Evaluatable->False],
Cell[1886, 57, 112, 3, 62, "Subsubtitle"],
Cell[2001, 62, 76232, 5766, 300, 49471, 5429, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 59"],
Cell[78236, 5830, 151, 3, 26, "Text"],

Cell[CellGroupData[{
Cell[78412, 5837, 79, 2, 78, "Section",
  Evaluatable->False],
Cell[78494, 5841, 214, 7, 26, "Text",
  Evaluatable->False],
Cell[78711, 5850, 89, 3, 26, "Text"],
Cell[78803, 5855, 148, 5, 26, "Text"],
Cell[78954, 5862, 168, 6, 26, "Text"],
Cell[79125, 5870, 65, 2, 26, "Text"],
Cell[79193, 5874, 236, 8, 44, "Text",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[79466, 5887, 89, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[79580, 5893, 85, 2, 56, "Subsection",
  Evaluatable->False],
Cell[79668, 5897, 208, 6, 44, "Text"],
Cell[79879, 5905, 355, 13, 26, "Text"],
Cell[80237, 5920, 219, 4, 73, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[80493, 5929, 85, 2, 56, "Subsection",
  Evaluatable->False],
Cell[80581, 5933, 113, 2, 26, "Text",
  Evaluatable->False],
Cell[80697, 5937, 63, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[80785, 5942, 88, 2, 41, "Input",
  InitializationCell->True],
Cell[80876, 5946, 161, 4, 23, "Message",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[81086, 5956, 101, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[81212, 5962, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[81304, 5966, 115, 2, 41, "Input",
  InitializationCell->True],
Cell[81422, 5970, 109, 2, 41, "Input",
  InitializationCell->True],
Cell[81534, 5974, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[81638, 5978, 101, 2, 41, "Input",
  InitializationCell->True],
Cell[81742, 5982, 98, 2, 41, "Input",
  InitializationCell->True],
Cell[81843, 5986, 112, 5, 56, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[81992, 5996, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[82085, 6000, 126, 6, 71, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[82272, 6013, 84, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[82381, 6019, 84, 2, 56, "Subsection",
  Evaluatable->False],
Cell[82468, 6023, 569, 25, 356, "Input",
  InitializationCell->True],
Cell[83040, 6050, 2477, 38, 1286, "Input",
  InitializationCell->True],
Cell[85520, 6090, 155, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[85712, 6103, 96, 2, 40, "Subsection",
  Evaluatable->False],
Cell[85811, 6107, 219, 7, 71, "Input"],

Cell[CellGroupData[{
Cell[86055, 6118, 92, 1, 41, "Input"],
Cell[86150, 6121, 712, 22, 91, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[86899, 6148, 68, 1, 41, "Input"],
Cell[86970, 6151, 294, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[87301, 6166, 119, 5, 71, "Input"],
Cell[87423, 6173, 123, 4, 23, "Print",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[87571, 6181, 88865, 6456, 352, 54142, 6021, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[176439, 12639, 122341, 8445, 297, 86526, 7996, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[298795, 21087, 809, 32, 139, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[299641, 21124, 79, 1, 41, "Input"],
Cell[299723, 21127, 194, 9, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[299954, 21141, 95, 1, 41, "Input"],
Cell[300052, 21144, 520, 21, 91, "Output",
  Evaluatable->False]
}, Open  ]],
Cell[300587, 21168, 119, 6, 86, "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[300755, 21180, 174, 7, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[300954, 21191, 86, 2, 56, "Subsection",
  Evaluatable->False],
Cell[301043, 21195, 151, 7, 101, "Input"],
Cell[301197, 21204, 100, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[301322, 21209, 91, 1, 41, "Input"],
Cell[301416, 21212, 430458, 10136, 371, 337650, 8984, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[731911, 31353, 127, 5, 71, "Input"],
Cell[732041, 31360, 652267, 49443, 338, 601287, 48807, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Fitness chart 3D - Part 1"]
}, Open  ]],
Cell[1384323, 80806, 231, 6, 29, "Text"],
Cell[1384557, 80814, 184, 6, 26, "Text"],

Cell[CellGroupData[{
Cell[1384766, 80824, 186, 6, 86, "Input"],
Cell[1384955, 80832, 662172, 48390, 338, 604493, 47671, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"Fitness chart 3D - Part 2"]
}, Open  ]],
Cell[2047142, 129225, 231, 6, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2047410, 129236, 54, 0, 56, "Subsection"],
Cell[2047467, 129238, 139, 6, 71, "Input",
  InitializationCell->True],
Cell[2047609, 129246, 218, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[2047852, 129255, 51, 1, 41, "Input"],
Cell[2047906, 129258, 876, 26, 107, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2048819, 129289, 138, 5, 56, "Input"],
Cell[2048960, 129296, 286, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2049283, 129311, 75, 1, 41, "Input"],
Cell[2049361, 129314, 296, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2049694, 129329, 98, 1, 41, "Input"],
Cell[2049795, 129332, 298, 10, 43, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2050130, 129347, 77, 1, 41, "Input"],
Cell[2050210, 129350, 25611, 781, 244, 5158, 522, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[2075858, 130136, 441, 18, 266, "Input"],
Cell[2076302, 130156, 30643, 1688, 228, 18862, 1536, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2106994, 131850, 149, 6, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2107168, 131860, 47, 0, 60, "Subsubsection"],

Cell[CellGroupData[{
Cell[2107240, 131864, 236, 10, 146, "Input"],
Cell[2107479, 131876, 208, 17, 188, "Print",
  Evaluatable->False]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2107736, 131899, 85, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2107824, 131903, 89254, 6487, 352, 54351, 6049, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 0"],
Cell[2197081, 138392, 792, 25, 29, "Text"],

Cell[CellGroupData[{
Cell[2197898, 138421, 52, 1, 41, "Input"],
Cell[2197953, 138424, 123348, 8584, 297, 87615, 8136, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 0"]
}, Open  ]],
Cell[2321316, 147011, 402, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2321755, 147030, 85, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2321843, 147034, 89053, 6472, 352, 54260, 6035, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 4"],
Cell[2410899, 153508, 405, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[2411329, 153526, 173, 4, 73, "Input"],
Cell[2411505, 153532, 123368, 8543, 297, 87550, 8094, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 4"]
}, Open  ]],
Cell[2534888, 162078, 405, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2535330, 162097, 85, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2535418, 162101, 88901, 6457, 352, 54142, 6021, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 5"],
Cell[2624322, 168560, 795, 25, 29, "Text"],

Cell[CellGroupData[{
Cell[2625142, 168589, 302, 6, 89, "Input"],
Cell[2625447, 168597, 122377, 8446, 297, 86526, 7996, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 5"]
}, Open  ]],
Cell[2747839, 177046, 405, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2748281, 177065, 85, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2748369, 177069, 87793, 5940, 352, 49797, 5464, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 9"],
Cell[2836165, 183011, 406, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[2836596, 183029, 299, 6, 73, "Input"],
Cell[2836898, 183037, 110358, 7396, 297, 74507, 6946, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 9"]
}, Open  ]],
Cell[2947271, 190436, 406, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2947714, 190455, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[2947803, 190459, 85747, 5846, 352, 49227, 5388, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 16"],
Cell[3033553, 196307, 695, 23, 29, "Text"],

Cell[CellGroupData[{
Cell[3034273, 196334, 281, 5, 73, "Input"],
Cell[3034557, 196341, 109499, 7214, 297, 72489, 6750, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 16"]
}, Open  ]],
Cell[3144071, 203558, 406, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3144514, 203577, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3144603, 203581, 85944, 5880, 352, 49436, 5422, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 17"],
Cell[3230550, 209463, 407, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[3230982, 209481, 480, 9, 121, "Input"],
Cell[3231465, 209492, 109248, 7248, 297, 72906, 6792, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 17"]
}, Open  ]],
Cell[3340728, 216743, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3341172, 216762, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3341261, 216766, 82820, 5458, 352, 46086, 4997, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 18"],
Cell[3424084, 222226, 407, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[3424516, 222244, 495, 9, 121, "Input"],
Cell[3425014, 222255, 100100, 6422, 297, 63706, 5966, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 18"]
}, Open  ]],
Cell[3525129, 228680, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3525573, 228699, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3525662, 228703, 87284, 5985, 352, 50171, 5520, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 19"],
Cell[3612949, 234690, 407, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[3613381, 234708, 381, 7, 121, "Input"],
Cell[3613765, 234717, 109816, 7303, 297, 73563, 6848, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 19"]
}, Open  ]],
Cell[3723596, 242023, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3724040, 242042, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3724129, 242046, 82623, 5493, 352, 46434, 5039, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 22"],
Cell[3806755, 247541, 696, 23, 29, "Text"],

Cell[CellGroupData[{
Cell[3807476, 247568, 289, 5, 89, "Input"],
Cell[3807768, 247575, 99635, 6342, 297, 62977, 5882, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 22"]
}, Open  ]],
Cell[3907418, 253920, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3907862, 253939, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3907951, 253943, 85652, 5833, 352, 49059, 5374, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 35"],
Cell[3993606, 259778, 407, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[3994038, 259796, 510, 10, 105, "Input"],
Cell[3994551, 259808, 108290, 6968, 297, 69676, 6484, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 35"]
}, Open  ]],
Cell[4102856, 266779, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4103300, 266798, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[4103389, 266802, 85107, 5782, 352, 48682, 5325, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 38"],
Cell[4188499, 272586, 407, 14, 29, "Text"],

Cell[CellGroupData[{
Cell[4188931, 272604, 520, 10, 105, "Input"],
Cell[4189454, 272616, 105132, 6722, 297, 67150, 6246, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 38"]
}, Open  ]],
Cell[4294601, 279341, 407, 14, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4295045, 279360, 86, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[4295134, 279364, 85795, 5884, 352, 49471, 5429, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker3D - Gen 59"],
Cell[4380932, 285250, 696, 23, 29, "Text"],

Cell[CellGroupData[{
Cell[4381653, 285277, 701, 13, 137, "Input"],
Cell[4382357, 285292, 107286, 6906, 297, 69150, 6428, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False,
  CellTags->"AntTracker2D - Gen 59"]
}, Open  ]],
Cell[4489658, 292201, 407, 14, 29, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[4490114, 292221, 91, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[4490230, 292227, 243, 10, 146, "Input"],
Cell[4490476, 292239, 216, 17, 188, "Print",
  Evaluatable->False],
Cell[4490695, 292258, 16331, 420, 2235, "Output",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[4507087, 292685, 76, 2, 78, "Section",
  Evaluatable->False],
Cell[4507166, 292689, 206, 5, 62, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

