(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    227999,       6411]*)
(*NotebookOutlinePosition[    229662,       6460]*)
(*  CellTagsIndexPosition[    229474,       6452]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Templates identifying substructures", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  April 1997 / February 2001\
\[Copyright]\
\>", "Subsubtitle"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.205655 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .02381 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .02381 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .02381 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .0717 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .23544 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .23544 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .15357 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .29802 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .42778 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .3629 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(i)] .57222 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .70198 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .70198 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .6371 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .84643 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .91131 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .91131 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .97619 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .91131 .45617 0 0 Msboxa
P
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.08869 .45617 L
s
.5 .60332 m
.3629 .45617 L
s
.5 .60332 m
.6371 .45617 L
s
.5 .60332 m
.91131 .45617 L
s
.08869 .45617 m
.02381 .30902 L
s
.08869 .45617 m
.15357 .30902 L
s
.02381 .30902 m
.02381 .16187 L
s
.9 g
.05 w
.02381 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .02381 .30902 0 0 Mshowa
P
.004 w
.02381 .16187 m
.02381 .01472 L
s
.9 g
.05 w
.02381 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .02381 .16187 0 0 Mshowa
P
1 g
.04 w
.02381 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .02381 .01472 0 0 Mshowa
P
.004 w
.15357 .30902 m
.0717 .16187 L
s
.15357 .30902 m
.23544 .16187 L
s
1 g
.05 w
.0717 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .0717 .16187 0 0 Mshowa
P
.004 w
.23544 .16187 m
.23544 .01472 L
s
.9 g
.05 w
.23544 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .23544 .16187 0 0 Mshowa
P
1 g
.04 w
.23544 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .23544 .01472 0 0 Mshowa
P
.9 g
.05 w
.15357 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .15357 .30902 0 0 Mshowa
P
.9 g
.08869 .45617 Mdot
0 g
.025 w
.08869 .45617 Mdot
.004 w
.3629 .45617 m
.29802 .30902 L
s
.3629 .45617 m
.42778 .30902 L
s
1 g
.05 w
.29802 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .29802 .30902 0 0 Mshowa
P
1 g
.42778 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .42778 .30902 0 0 Mshowa
P
.9 g
.3629 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .3629 .45617 0 0 Mshowa
P
.004 w
.6371 .45617 m
.57222 .30902 L
s
.6371 .45617 m
.70198 .30902 L
s
1 g
.05 w
.57222 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(i)] .57222 .30902 0 0 Mshowa
P
.004 w
.70198 .30902 m
.70198 .16187 L
s
.9 g
.05 w
.70198 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .70198 .30902 0 0 Mshowa
P
1 g
.04 w
.70198 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .70198 .16187 0 0 Mshowa
P
.9 g
.05 w
.6371 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .6371 .45617 0 0 Mshowa
P
.004 w
.91131 .45617 m
.84643 .30902 L
s
.91131 .45617 m
.91131 .30902 L
s
.91131 .45617 m
.97619 .30902 L
s
1 g
.05 w
.84643 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .84643 .30902 0 0 Mshowa
P
.004 w
.91131 .30902 m
.91131 .16187 L
s
.9 g
.05 w
.91131 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .91131 .30902 0 0 Mshowa
P
1 g
.04 w
.91131 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(d)] .91131 .16187 0 0 Mshowa
P
1 g
.05 w
.97619 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .97619 .30902 0 0 Mshowa
P
.9 g
.91131 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .91131 .45617 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
.025 w
.5 .60332 Mdot
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[Q000`40O003h00Oog=i6g=i003oLgTK
LgT000QcN@AoocIcN@AoomAcN@001W=i0Woo10000Woo<W=i1@000goodW=i0006LgT00goo00000002
Ool200000gooLgUcN@0`LgT017oo000007oo0P000WoodW=i0005LgT2Ool20006Ool`LgT2Ool20000
0goo00000003OooALgT000EcN@9oo`80009oo`80009ooc1cN@9oo`800003Ool0000000=oom5cN@00
1G=i0goo10000goo<7=i0Woo100017oodG=i0005LgT:Ool`LgT2Ool20006OooALgT000IcN@Qooc9c
N@<000Eoom9cN@001W=i27oo<W=i27oodW=i0008LgT4OolfLgT4OooDLgT000YcN@03001cNG=i03Mc
N@03001cNG=i0==cN@002W=i00<007=iLgT0=g=i00<007=iLgT0dg=i000:LgT00`00LgUcN@0gLgT0
0`00LgUcN@3CLgT000YcN@03001cNG=i03McN@03001cNG=i0==cN@002W=i00<007=iLgT0=g=i00<0
07=iLgT0dg=i000:LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03001cNG=i03McN@03001c
NG=i0==cN@002W=i00<007=iLgT0=g=i00<007=iLgT0dg=i000:LgT00`00LgUcN@0gLgT00`00LgUc
N@3CLgT000YcN@03001cNG=i03McN@03001cNG=i0==cN@002W=i00<007=iLgT0=g=i00<007=iLgT0
dg=i000:LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03001cNG=i03McN@03001cNG=i0==c
N@002W=i00<007=iLgT0=g=i00<007=iLgT0dg=i000:LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT0
00YcN@03001cNG=i03McN@03001cNG=i0==cN@002W=i00<007=iLgT0=g=i00<007=iLgT0dg=i000:
LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03001cNG=i03McN@03001cNG=i0==cN@002W=i
00<007=iLgT0=g=i00<007=iLgT0dg=i000:LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03
001cNG=i03McN@03001cNG=i0==cN@002W=i00<007=iLgT0=g=i00<007=iLgT0dg=i000:LgT00`00
LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03001cNG=i03McN@03001cNG=i0==cN@002W=i00<007=i
LgT0=g=i00<007=iLgT0dg=i000:LgT00`00LgUcN@0gLgT00`00LgUcN@3CLgT000YcN@03001cNG=i
03McN@03001cNG=i0==cN@0027=i1G>L27=i1Goo9g=i1G>Le7=i0006LgT9Li`4LgT9OolSLgT9LicB
LgT000EcN@]cW09cN@]oob5cN@=cW0@000AcW7QcN@AoocEcN@AooaacN@001G=i2g>L0W=i2goo8G=i
1W>L0P000g>LMW=i27oo<G=i27oo6W=i0004LgT3Li`70003Li`4Ool50004OolOLgT4Li`50004Liae
LgT2Ool40002OolaLgT2Ool500000gooLgUcN@0HLgT000AcN@AcW0800003Li`0000000AcW0=oo`80
0003Ool0000000EooamcN@=cW080009cW08000AcW7AcN@9oo`80009oo`80009oobmcN@9oo`800003
Ool0000000=ooaUcN@0017=i17>L0P0000=cW000000017>L17oo10001Goo7g=i0g>L0P000W>L0P00
17>LM7=i0Woo0P001Woo;g=i0Woo0P0000=oo`0000000goo6G=i0004LgT4Li`200000g>L00000004
Li`3Ool200000goo00000005OolOLgT3Li`20002Li`20004LiadLgT2Ool20002Ool20002Ool_LgT2
Ool200000goo00000003OolILgT000AcN@AcW0@000EcW0Aoo`<000IooamcN@AcW0H000=cW7AcN@=o
o`@000=oobmcN@=oo`@000=ooaUcN@001G=i0g>L0P001W>L0W=i2goo8G=i2g>LMW=i27oo<G=i17oo
0P000Woo6W=i0005LgT2Li`30006Li`2LgT;OolQLgT;LiafLgT8OolaLgT3Ool30002OolJLgT000Ic
N@UcW0AcN@Uoob=cN@UcW7UcN@AoocEcN@AooaacN@0027=i1G>L27=i1Goo00<007=iLgT097=i1G>L
OG=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0>LgT00`00LgUcN@0RLgT00`00
LgUcN@20LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i00icN@03001cNG=i029c
N@03001cNG=i081cN@03001cNG=i03IcN@03001cNG=i01]cN@002W=i00<007=iLgT03g=i00<007=i
LgT087=i00<007=iLgT0PG=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0?LgT0
0`00LgUcN@0PLgT00`00LgUcN@21LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i
011cN@03001cNG=i01icN@03001cNG=i089cN@03001cNG=i03IcN@03001cNG=i01]cN@002W=i00<0
07=iLgT047=i00<007=iLgT07G=i00<007=iLgT0Pg=i00<007=iLgT0=W=i00<007=iLgT06g=i000:
LgT00`00LgUcN@0ALgT00`00LgUcN@0LLgT00`00LgUcN@23LgT00`00LgUcN@0fLgT00`00LgUcN@0K
LgT000YcN@03001cNG=i015cN@03001cNG=i01]cN@03001cNG=i08AcN@03001cNG=i03IcN@03001c
NG=i01]cN@002W=i00<007=iLgT04W=i00<007=iLgT06W=i00<007=iLgT0Q7=i00<007=iLgT0=W=i
00<007=iLgT06g=i000:LgT00`00LgUcN@0CLgT00`00LgUcN@0HLgT00`00LgUcN@25LgT00`00LgUc
N@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i01=cN@03001cNG=i01QcN@03001cNG=i08EcN@03
001cNG=i03IcN@03001cNG=i01]cN@002W=i00<007=iLgT057=i00<007=iLgT05W=i00<007=iLgT0
QW=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0DLgT00`00LgUcN@0ELgT00`00
LgUcN@27LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i01EcN@03001cNG=i01Ac
N@03001cNG=i08McN@03001cNG=i03IcN@03001cNG=i01]cN@002W=i00<007=iLgT05G=i00<007=i
LgT04g=i00<007=iLgT0R7=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0FLgT0
0`00LgUcN@0BLgT00`00LgUcN@28LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i
01IcN@03001cNG=i015cN@03001cNG=i08UcN@03001cNG=i03IcN@03001cNG=i01]cN@002W=i00<0
07=iLgT05g=i00<007=iLgT03g=i00<007=iLgT0RW=i00<007=iLgT0=W=i00<007=iLgT06g=i000:
LgT00`00LgUcN@0GLgT00`00LgUcN@0?LgT00`00LgUcN@2:LgT00`00LgUcN@0fLgT00`00LgUcN@0K
LgT000YcN@03001cNG=i01QcN@03001cNG=i00ecN@03001cNG=i08]cN@03001cNG=i03IcN@03001c
NG=i01]cN@002W=i00<007=iLgT06G=i00<007=iLgT037=i00<007=iLgT0Rg=i00<007=iLgT0=W=i
00<007=iLgT06g=i000:LgT00`00LgUcN@0ILgT00`00LgUcN@0;LgT00`00LgUcN@2<LgT00`00LgUc
N@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i01YcN@03001cNG=i00YcN@03001cNG=i08acN@03
001cNG=i03IcN@03001cNG=i01]cN@002W=i00<007=iLgT06W=i00<007=iLgT02G=i00<007=iLgT0
SG=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0KLgT00`00LgUcN@07LgT00`00
LgUcN@2>LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000YcN@03001cNG=i01]cN@03001cNG=i00Mc
N@03001cNG=i08icN@03001cNG=i03IcN@03001cNG=i01]cN@002W=i00<007=iLgT077=i00<007=i
LgT01G=i00<007=iLgT0Sg=i00<007=iLgT0=W=i00<007=iLgT06g=i000:LgT00`00LgUcN@0LLgT0
0`00LgUcN@05LgT00`00LgUcN@2?LgT00`00LgUcN@0fLgT00`00LgUcN@0KLgT000QcN@EcW1ecN@03
001cW7>L00=cW003001cNG=i021cN@EooaicN@Eoob9cN@EooamcN@EcW29cN@Eoo`ecN@EcW0ecN@Eo
o`UcN@001W=i2G>L6W=i0W>L10000g>L7g=i2Goo6W=i2Goo7W=i2Goo6g=i0W>L10000g>L7W=i2Goo
2G=i0W>L10000g>L2G=i2Goo1g=i0005LgT;Li`HLgT6Li`20003Li`MLgT;OolHLgT;OolLLgT;OolI
LgT6Li`20003Li`LLgT;Ool7LgT6Li`20003Li`7LgT;Ool6LgT000EcN@9cW0H000=cW1QcN@=cW0D0
00=cW1ecN@9oo`D000AooaQcN@9oo`D000AooaacN@9oo`H000=ooaUcN@=cW0D000=cW1acN@=oo`@0
00Aoo`McN@=cW0D000=cW0McN@03Ool0000000<000Eoo`IcN@0017=i1G>L0P001W>L5W=i0g>L0P00
0W>L0P0017>L6g=i0Woo0P0000=oo`0000001Woo5W=i17oo0P0000=oo`00000017oo6W=i1Goo0P00
1Woo5g=i0g>L0P000W>L0P0017>L6W=i0goo0P000Woo0P0017oo1G=i0g>L0P000W>L0P0017>L1G=i
0goo0P0000=oo`0000001Goo1G=i0004LgT5Li`20006Li`FLgT3Li`20002Li`20004Li`KLgT3Ool4
0006OolFLgT4Ool200000goo00000004OolJLgT5Ool20006OolGLgT3Li`20002Li`20004Li`JLgT3
Ool20008Ool5LgT3Li`20002Li`20004Li`5LgT3Ool200000goo00000005Ool5LgT000AcN@EcW080
00IcW1IcN@=cW080009cW08000AcW1]cN@9oo`800003Ool0000000IooaIcN@Aoo`800003Ool00000
00AooaYcN@Eoo`8000IooaMcN@=cW080009cW08000AcW1YcN@=oo`80009oo`8000Aoo`EcN@=cW080
009cW08000AcW0EcN@=oo`800003Ool0000000Eoo`EcN@0017=i17>L1@0017>L5W=i17>L1P000g>L
6g=i0goo0`001goo5W=i17oo10001Goo6W=i0goo10001Woo5g=i17>L1P000g>L6W=i17oo10001Goo
1G=i17>L1P000g>L1G=i0goo10001Woo1G=i0004LgT5Li`20006Li`FLgT=Li`KLgT=OolFLgT4Ool2
0007OolJLgT=OolGLgT=Li`JLgT=Ool5LgT=Li`5LgT3Ool20008Ool5LgT000EcN@EcW0<000=cW1Qc
N@]cW1ecN@]ooaQcN@9oo`<000IooaacN@Aoo`8000EooaUcN@]cW1acN@]oo`McN@]cW0McN@04Ool0
00000007Ool6LgT000EcN@]cW1QcN@]cW1ecN@]ooaQcN@]ooaacN@]ooaUcN@]cW1acN@]oo`McN@]c
W0McN@]oo`IcN@001W=i2G>L6W=i2G>L7g=i2Goo6W=i2Goo7W=i2Goo6g=i2G>L7W=i2Goo2G=i2G>L
2G=i2Goo1g=i0008LgT5Li`00`00LgUcN@0JLgT00`00LiacW003Li`SLgT5Ool00`00LgUcN@0JLgT0
0`00Oomoo`03OolRLgT5Ool00g=i001cN@0KLgT00`00LiacW003Li`RLgT5Ool00g=i001cN@0:LgT5
Li`<LgT00`00Oomoo`03Ool9LgT000ecN@03001cNG=i01YcN@03001cNG=i02]cN@03001cNG=i01Yc
N@03001cNG=i02]cN@03001cNG=i01YcN@03001cNG=i02]cN@03001cNG=i00]cN@03001cNG=i00ac
N@03001cNG=i00acN@003W=i00<007=iLgT067=i00<007=iLgT0;G=i00<007=iLgT067=i00<007=i
LgT0;G=i00<007=iLgT067=i00<007=iLgT0;G=i00<007=iLgT02W=i00<007=iLgT02g=i00<007=i
LgT03G=i000>LgT00`00LgUcN@0HLgT00`00LgUcN@0]LgT00`00LgUcN@0HLgT00`00LgUcN@0]LgT0
0`00LgUcN@0HLgT00`00LgUcN@0]LgT00`00LgUcN@0:LgT00`00LgUcN@0;LgT00`00LgUcN@0=LgT0
00mcN@03001cNG=i01McN@03001cNG=i02icN@03001cNG=i01McN@03001cNG=i02ecN@03001cNG=i
01McN@03001cNG=i02icN@03001cNG=i00YcN@03001cNG=i00YcN@03001cNG=i00icN@003g=i00<0
07=iLgT05W=i00<007=iLgT0;g=i00<007=iLgT05W=i00<007=iLgT0;g=i00<007=iLgT05W=i00<0
07=iLgT0;g=i00<007=iLgT02G=i00<007=iLgT02W=i00<007=iLgT03W=i000?LgT00`00LgUcN@0F
LgT00`00LgUcN@0_LgT00`00LgUcN@0FLgT00`00LgUcN@0_LgT00`00LgUcN@0FLgT00`00LgUcN@0_
LgT00`00LgUcN@09LgT00`00LgUcN@0:LgT00`00LgUcN@0>LgT0011cN@03001cNG=i01AcN@03001c
NG=i035cN@03001cNG=i01AcN@03001cNG=i035cN@03001cNG=i01AcN@03001cNG=i035cN@03001c
NG=i00QcN@03001cNG=i00UcN@03001cNG=i00mcN@0047=i00<007=iLgT057=i00<007=iLgT0<G=i
00<007=iLgT057=i00<007=iLgT0<G=i00<007=iLgT057=i00<007=iLgT0<G=i00<007=iLgT027=i
00<007=iLgT02G=i00<007=iLgT03g=i000ALgT00`00LgUcN@0CLgT00`00LgUcN@0bLgT00`00LgUc
N@0CLgT00`00LgUcN@0aLgT00`00LgUcN@0CLgT00`00LgUcN@0bLgT00`00LgUcN@08LgT00`00LgUc
N@08LgT00`00LgUcN@0@LgT0015cN@03001cNG=i019cN@03001cNG=i03=cN@03001cNG=i019cN@03
001cNG=i03=cN@03001cNG=i019cN@03001cNG=i03=cN@03001cNG=i00McN@03001cNG=i00QcN@03
001cNG=i011cN@004W=i00<007=iLgT04G=i00<007=iLgT0=7=i00<007=iLgT04G=i00<007=iLgT0
<g=i00<007=iLgT04G=i00<007=iLgT0=7=i00<007=iLgT01g=i00<007=iLgT01g=i00<007=iLgT0
4G=i000BLgT00`00LgUcN@0@LgT00`00LgUcN@0eLgT00`00LgUcN@0@LgT00`00LgUcN@0eLgT00`00
LgUcN@0@LgT00`00LgUcN@0eLgT00`00LgUcN@06LgT00`00LgUcN@07LgT00`00LgUcN@0ALgT001=c
N@03001cNG=i00mcN@03001cNG=i03IcN@03001cNG=i00mcN@03001cNG=i03EcN@03001cNG=i00mc
N@03001cNG=i03IcN@03001cNG=i00IcN@03001cNG=i00IcN@03001cNG=i019cN@004g=i00<007=i
LgT03W=i00<007=iLgT0=g=i00<007=iLgT03W=i00<007=iLgT0=g=i00<007=iLgT03W=i00<007=i
LgT0=g=i00<007=iLgT01G=i00<007=iLgT01W=i00<007=iLgT04W=i000CLgT00`00LgUcN@0>LgT0
0`00LgUcN@0gLgT00`00LgUcN@0>LgT00`00LgUcN@0gLgT00`00LgUcN@0>LgT00`00LgUcN@0gLgT0
0`00LgUcN@05LgT00`00LgUcN@06LgT00`00LgUcN@0BLgT001AcN@03001cNG=i00ecN@03001cNG=i
03QcN@03001cNG=i00ecN@03001cNG=i03McN@03001cNG=i00ecN@03001cNG=i03QcN@03001cNG=i
00EcN@03001cNG=i00EcN@03001cNG=i01=cN@0057=i00<007=iLgT037=i00<007=iLgT0>G=i00<0
07=iLgT037=i00<007=iLgT0>G=i00<007=iLgT037=i00<007=iLgT0>G=i00<007=iLgT017=i00<0
07=iLgT01G=i00<007=iLgT04g=i000ELgT00`00LgUcN@0;LgT00`00LgUcN@0jLgT00`00LgUcN@0;
LgT00`00LgUcN@0iLgT00`00LgUcN@0;LgT00`00LgUcN@0jLgT00`00LgUcN@04LgT00`00LgUcN@04
LgT00`00LgUcN@0DLgT001EcN@03001cNG=i00YcN@03001cNG=i03]cN@03001cNG=i00YcN@03001c
NG=i03]cN@03001cNG=i00YcN@03001cNG=i03]cN@03001cNG=i00=cN@03001cNG=i00AcN@03001c
NG=i01AcN@005W=i00<007=iLgT02G=i00<007=iLgT0?7=i00<007=iLgT02G=i00<007=iLgT0>g=i
00<007=iLgT02G=i00<007=iLgT0?7=i00<007=iLgT00g=i00<007=iLgT00g=i00<007=iLgT05G=i
000FLgT00`00LgUcN@09LgT00`00LgUcN@0lLgT00`00LgUcN@09LgT00`00LgUcN@0kLgT00`00LgUc
N@09LgT00`00LgUcN@0lLgT00`00LgUcN@03LgT00`00LgUcN@03LgT00`00LgUcN@0ELgT001McN@03
001cNG=i00McN@03001cNG=i03icN@03001cNG=i00McN@03001cNG=i03ecN@03001cNG=i00McN@03
001cNG=i03icN@03001cNG=i009cN@03001cNG=i009cN@03001cNG=i01IcN@005g=i00<007=iLgT0
1g=i00<007=iLgT0?W=i00<007=iLgT01g=i00<007=iLgT0?G=i00<007=iLgT01g=i00<007=iLgT0
?W=i00<007=iLgT00W=i00<007=iLgT00W=i00<007=iLgT05W=i000GLgT00`00LgUcN@06LgT00`00
LgUcN@0oLgT00`00LgUcN@06LgT00`00LgUcN@0oLgT00`00LgUcN@06LgT00`00LgUcN@0oLgT01@00
LgUcNG=i000017=i00<007=iLgT05W=i000HLgT00`00LgUcN@05LgT00`00LgUcN@10LgT00`00LgUc
N@05LgT00`00LgUcN@0oLgT00`00LgUcN@05LgT00`00LgUcN@10LgT01@00LgUcNG=i00000g=i00<0
07=iLgT05g=i000HLgT00`00LgUcN@05LgT00`00LgUcN@10LgT00`00LgUcN@05LgT00`00LgUcN@0o
LgT00`00LgUcN@05LgT00`00LgUcN@10LgT01@00LgUcNG=i00000g=i00<007=iLgT05g=i000ILgT0
0`00LgUcN@03LgT00`00LgUcN@12LgT00`00LgUcN@03LgT00`00LgUcN@11LgT00`00LgUcN@03LgT0
0`00LgUcN@12LgT01000LgUcN@000W=i00<007=iLgT067=i000ILgT5Li`00g=i001cN@13LgT5Li`0
0g=i001cN@12LgT00`00LiacW003Li`00`00LgUcN@12LgT00`00LiacW003Li`00`00LgUcN@0HLgT0
01McN@UcW49cN@9cW0@000=cW49cN@UcW49cN@9cW0@000=cW1UcN@005W=i2g>L@7=i1W>L0P000g>L
@7=i2g>L@7=i1W>L0P000g>L67=i000FLgT4Li`40003Lia0LgT3Li`50003Lia0LgT2Li`70002Lia0
LgT3Li`50003Li`HLgT001EcN@AcW0H000=cW3icN@=cW080009cW08000AcW3icN@AcW0800003Li`0
000000AcW3icN@=cW080009cW08000AcW1McN@005G=i17>L1P000g>L?W=i0g>L0P000W>L0P0017>L
?W=i17>L0P0000=cW000000017>L?W=i0g>L0P000W>L0P0017>L5g=i000ELgT4Li`60003Li`nLgT3
Li`20002Li`20004Li`nLgT4Li`200000g>L00000004Li`nLgT3Li`20002Li`20004Li`GLgT001Ec
N@AcW0H000=cW3icN@AcW0H000=cW3icN@AcW0@000EcW3icN@AcW0H000=cW1McN@005G=i1G>L1000
17>L0P00?7=i3G>L?W=i17>L0P001g>L?G=i00<007>LLi`02g>L5g=i000FLgT;Li`3LgT3000jLgT;
Lia0LgT2Li`30006Li`kLgT30002LgT;Li`HLgT001IcN@]cW0IcN@<003McN@]cW41cN@]cW3QcN@<0
00EcN@]cW1QcN@005g=i2G>L2W=i0P00=W=i2G>L00<007=iLgT0?g=i2G>L=g=i0P002G=i2G>L6G=i
000ILgT5Li`>LgT3000eLgT5Li`3LgT00`00LgUcN@0mLgT00`00LgUcN@05Li`fLgT3000=LgT5Li`K
LgT002mcN@<003]cN@03001cNG=i03]cN@03001cNG=i03UcN@<0031cN@00<W=i0`00>G=i00<007=i
LgT0>G=i00<007=iLgT0=g=i0`00<g=i000eLgT3000gLgT00`00LgUcN@0gLgT00`00LgUcN@0eLgT3
000fLgT003QcN@8003IcN@03001cNG=i03EcN@03001cNG=i03AcN@8003UcN@00>W=i0`00=7=i00<0
07=iLgT0<g=i00<007=iLgT0<W=i0`00>g=i000mLgT3000bLgT00`00LgUcN@0aLgT00`00LgUcN@0`
LgT3000nLgT0041cN@<0031cN@03001cNG=i02mcN@03001cNG=i02icN@<0045cN@00@g=i0`00;G=i
00<007=iLgT0;g=i00<007=iLgT0:g=i0`00A7=i0016LgT2000/LgT00`00LgUcN@0]LgT00`00LgUc
N@0ZLgT20017LgT004QcN@<002YcN@03001cNG=i02]cN@03001cNG=i02QcN@<004UcN@00Bg=i0`00
:7=i00<007=iLgT0:G=i00<007=iLgT09W=i0`00C7=i001>LgT3000VLgT00`00LgUcN@0WLgT00`00
LgUcN@0TLgT3001?LgT0055cN@<002AcN@03001cNG=i02EcN@03001cNG=i029cN@<0059cN@00E7=i
0P008g=i00<007=iLgT08g=i00<007=iLgT08G=i0P00EG=i001FLgT3000QLgT00`00LgUcN@0QLgT0
0`00LgUcN@0OLgT3001GLgT005UcN@<001mcN@03001cNG=i01mcN@03001cNG=i01ecN@<005YcN@00
G7=i0`007G=i00<007=iLgT07G=i00<007=iLgT06g=i0`00GG=i001OLgT3000KLgT00`00LgUcN@0K
LgT00`00LgUcN@0ILgT3001PLgT0069cN@8001YcN@03001cNG=i01UcN@03001cNG=i01QcN@8006=c
N@00I7=i0`0067=i00<007=iLgT05g=i00<007=iLgT05W=i0`00IG=i001WLgT3000FLgT00`00LgUc
N@0ELgT00`00LgUcN@0DLgT3001XLgT006YcN@<001=cN@03001cNG=i01EcN@03001cNG=i015cN@<0
06]cN@00KG=i0`004G=i00<007=iLgT04g=i00<007=iLgT03g=i0`00KW=i001`LgT2000@LgT00`00
LgUcN@0ALgT00`00LgUcN@0>LgT2001aLgT0079cN@<000icN@03001cNG=i00mcN@03001cNG=i00ac
N@<007=cN@00MG=i0`0037=i00<007=iLgT03G=i00<007=iLgT02W=i0`00MW=i001hLgT3000:LgT0
0`00LgUcN@0;LgT00`00LgUcN@08LgT3001iLgT007]cN@<000QcN@04001cNG=iLgT5Li`3LgT00`00
LgUcN@06LgT3001lLgT007icN@8000McN@03001cW7>L00McW003001cNG=i00EcN@8007mcN@00P7=i
0`0017=i2g>L17=i0`00PG=i0023LgT300000g=iLiacW009Li`017=i00000000Q7=i0026LgT4Li`4
0005Lib7LgT008IcN@=cW0H000AcW8McN@00QW=i0g>L1P0017>LQg=i0026LgT3Li`60004Lib7LgT0
08IcN@=cW0H000AcW8McN@00Qg=i0g>L100017>LR7=i0027LgT;Lib8LgT008QcN@UcW8UcN@00RW=i
1G>LRg=i0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-2.50272, -0.827382, 0.0178129, \
0.00497899}}],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
This notebook demonstrates by some brief examples how templates (as \
introduced in the previous section) can be used to identify selected \
substructures within symbolic expressions.\
\>", "Text"],

Cell[TextData[{
  "Starting from simple ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " patterns, we introduce ",
  StyleBox["hierarchical patterns",
    FontSlant->"Italic"],
  " that may as well be attributed with weights."
}], "Text"],

Cell["\<\
A number of examples illustrate the basic concepts in a step by \
step manner.\
\>", "Text"],

Cell["\<\
The mechanisms discussed here are used by the genetic operators in \
order to identify the set of substructures selectable for further, \
operator-specific modifications.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Please make sure to evaluate all ",
  StyleBox["Initialization Cells",
    FontSlant->"Italic"],
  " in this notebook, ",
  StyleBox["before",
    FontWeight->"Bold"],
  " you try any of the following examples."
}], "Text"],

Cell[CellGroupData[{

Cell["Simple Structure Selection", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TT = Transpose; MM = MatrixForm;", "Input",
  AspectRatioFixed->True,
  CellTags->"Simple structure selection"],

Cell["\<\
symbExpr = 
  f[h[c]][g[a,g[b]]][g[a,b], h[i,g[c]], g[c,g[d],b]];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[symbExpr //. exprToTerm, TreeWidth -> .1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.205655 0.603319 0.735755 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.02381 .16187 -5 -6 ]
[.02381 .16187 5 6 ]
[.02381 .01472 -5 -6 ]
[.02381 .01472 5 6 ]
[.0717 .16187 -5 -6 ]
[.0717 .16187 5 6 ]
[.23544 .16187 -5 -6 ]
[.23544 .16187 5 6 ]
[.23544 .01472 -5 -6 ]
[.23544 .01472 5 6 ]
[.15357 .30902 -5 -6 ]
[.15357 .30902 5 6 ]
[.29802 .30902 -5 -6 ]
[.29802 .30902 5 6 ]
[.42778 .30902 -5 -6 ]
[.42778 .30902 5 6 ]
[.3629 .45617 -5 -6 ]
[.3629 .45617 5 6 ]
[.57222 .30902 -5 -6 ]
[.57222 .30902 5 6 ]
[.70198 .30902 -5 -6 ]
[.70198 .30902 5 6 ]
[.70198 .16187 -5 -6 ]
[.70198 .16187 5 6 ]
[.6371 .45617 -5 -6 ]
[.6371 .45617 5 6 ]
[.84643 .30902 -5 -6 ]
[.84643 .30902 5 6 ]
[.91131 .30902 -5 -6 ]
[.91131 .30902 5 6 ]
[.91131 .16187 -5 -6 ]
[.91131 .16187 5 6 ]
[.97619 .30902 -5 -6 ]
[.97619 .30902 5 6 ]
[.91131 .45617 -5 -6 ]
[.91131 .45617 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.08869 .45617 L
s
.5 .60332 m
.3629 .45617 L
s
.5 .60332 m
.6371 .45617 L
s
.5 .60332 m
.91131 .45617 L
s
.08869 .45617 m
.02381 .30902 L
s
.08869 .45617 m
.15357 .30902 L
s
.02381 .30902 m
.02381 .16187 L
s
.9 g
.05 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.5 Mabswid
.02381 .16187 m
.02381 .01472 L
s
.9 g
.05 w
.02381 .16187 Mdot
0 g
gsave
.02381 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.04 w
.02381 .01472 Mdot
0 g
gsave
.02381 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.15357 .30902 m
.0717 .16187 L
s
.15357 .30902 m
.23544 .16187 L
s
1 g
.05 w
.0717 .16187 Mdot
0 g
gsave
.0717 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.23544 .16187 m
.23544 .01472 L
s
.9 g
.05 w
.23544 .16187 Mdot
0 g
gsave
.23544 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.23544 .01472 Mdot
0 g
gsave
.23544 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.05 w
.15357 .30902 Mdot
0 g
gsave
.15357 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.08869 .45617 Mdot
0 g
.025 w
.08869 .45617 Mdot
.5 Mabswid
.3629 .45617 m
.29802 .30902 L
s
.3629 .45617 m
.42778 .30902 L
s
1 g
.05 w
.29802 .30902 Mdot
0 g
gsave
.29802 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.42778 .30902 Mdot
0 g
gsave
.42778 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.3629 .45617 Mdot
0 g
gsave
.3629 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.6371 .45617 m
.57222 .30902 L
s
.6371 .45617 m
.70198 .30902 L
s
1 g
.05 w
.57222 .30902 Mdot
0 g
gsave
.57222 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i) show
1.000 setlinewidth
grestore
.5 Mabswid
.70198 .30902 m
.70198 .16187 L
s
.9 g
.05 w
.70198 .30902 Mdot
0 g
gsave
.70198 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.70198 .16187 Mdot
0 g
gsave
.70198 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.05 w
.6371 .45617 Mdot
0 g
gsave
.6371 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.5 Mabswid
.91131 .45617 m
.84643 .30902 L
s
.91131 .45617 m
.91131 .30902 L
s
.91131 .45617 m
.97619 .30902 L
s
1 g
.05 w
.84643 .30902 Mdot
0 g
gsave
.84643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.91131 .30902 m
.91131 .16187 L
s
.9 g
.05 w
.91131 .30902 Mdot
0 g
gsave
.91131 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.91131 .16187 Mdot
0 g
gsave
.91131 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.05 w
.97619 .30902 Mdot
0 g
gsave
.97619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.91131 .45617 Mdot
0 g
gsave
.91131 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
.025 w
.5 .60332 Mdot
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.938},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`002?ooool4o`0003Gooooo1Ol0
003Cooooo`001oooool2o`0000;ooooo0_l0000eooooo`;o000000?oooooo`000?l00000d_ooool0
00Oooooo0_l0000iooooo`;o000000?oooooo`000?l00000d_ooool000Oooooo0_l00002ooooo`;o
0000=Oooool2o`000003ooooool0003o00000=;ooooo0008ooooo`Co0000=_ooool4o`000=?ooooo
0012ooooo`;o0000eOooool0047ooooo0ol0003Eooooo`002_ooool00ol0003oooooooooo`0goooo
o`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000oooooooo
ool0d_ooool000[ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`3Booooo`002_oo
ool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool0d_ooool000[ooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`3Booooo`002_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0=;o
oooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0d_ooool000[ooooo00?o
0000ooooooooool0=oooool00ol0003oooooooooo`3Booooo`002_ooool00ol0003oooooooooo`0g
ooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000oooo
ooooool0d_ooool000[ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`3Booooo`00
2_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oo
oooooooo03Oooooo00?o0000ooooooooool0d_ooool000[ooooo00?o0000ooooooooool0=oooool0
0ol0003oooooooooo`3Booooo`002_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo
0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0d_ooool000[ooooo
00?o0000ooooooooool0=oooool00ol0003oooooooooo`3Booooo`002_ooool00ol0003ooooooooo
o`0gooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000
ooooooooool0d_ooool000[ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`3Boooo
o`002_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`00
0?oooooooooo03Oooooo00?o0000ooooooooool0d_ooool000[ooooo00?o0000ooooooooool0=ooo
ool00ol0003oooooooooo`3Booooo`002_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooo
oooo0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0d_ooool000[o
oooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`3Booooo`002_ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo0=;ooooo000:ooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool0d_ooool000Sooooo1OoVi^Hdooooo`Goi^KVdoooool000Kooooo2OoVi^H`oooo
o`Woi^KVdOooool000Gooooo2ooVi^H^ooooo`Coi^KV1?l00003onKVi]3ooooo0005ooooo`_oi^KV
;_ooool7onKViP;o00000_oVi^K@ooooo`001?ooool3onKViPOo00000ooVi^H4ooooo`Go00008ooo
ool5onKViPGo00000ooVi^Igooooo`Co0000=Oooool5o`0001[ooooo0004ooooo`Coi^KV0_l00000
0ooVi^Ko0000o`000004onKViP?ooooo0_l000000ooooooo0000o`00000Tooooo`Coi^KV0_l00002
onKViP;o00000ooVi^Ifooooo`;o00000_ooool2o`0003?ooooo0_l000000ooooooo0000o`00000K
ooooo`001?ooool4onKViP;o000000?oi^KVo`000?l000001?oVi^H4ooooo`Co00009?ooool4onKV
iP;o00000_oVi^H2o`0000?oi^KVM_ooool2o`0003Oooooo0_l000000ooooooo0000o`00000Koooo
o`001?ooool4onKViP;o000000?oi^KVo`000?l000001?oVi^H3ooooo`;o000000?oooooo`000?l0
00009?ooool4onKViP;o00000_oVi^H2o`0000?oi^KVM_ooool2o`0000;ooooo0_l0000cooooo`;o
000000?oooooo`000?l000006oooool000Cooooo1?oVi^H4o`0000Goi^KV1?ooool3o`0002Gooooo
1OoVi^H6o`0000;oi^KVMoooool4o`0003Gooooo1?l0000Kooooo`001Oooool3onKViP;o00001_oV
i^H^ooooo`_oi^KV/oooool2o`0001_ooooo0005ooooo`;oi^KV0ol00006onKViRkooooo2ooVi^Jb
ooooo`?o00006oooool000Kooooo2OoVi^H`ooooo`Woi^KVdOooool000Sooooo1OoVi^H=ooooo`03
o`000?oooooooooo02Cooooo1OoVi^Imooooo`03o`000?oooooooooo03Kooooo00?o0000oooooooo
ool06_ooool000[ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo083ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Jooooo`002_oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0P?oo
ool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`21ooooo`03o`000?oooooo
oooo03Kooooo00?o0000ooooooooool06_ooool000[ooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0Jooooo`002_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool0P_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01[o
oooo000:ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`23ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool06_ooool000[ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo08?ooooo00?o
0000ooooooooool0=_ooool00ol0003oooooooooo`0Jooooo`002_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0Q?ooool00ol0003oooooooooo`0f
ooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo03Kooooo00?o0000oooo
ooooool06_ooool000[ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo08Gooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Jooooo`00
2_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
QOooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`000?oo
oooooooo01Cooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`26ooooo`03o`000?oo
oooooooo03Kooooo00?o0000ooooooooool06_ooool000[ooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0=_ooool0
0ol0003oooooooooo`0Jooooo`002_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Cooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo
01[ooooo000:ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`28ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool06_ooool000[ooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo08Sooooo
00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Jooooo`002_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0ROooool00ol0003ooooooooo
o`0fooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo03Kooooo00?o0000
ooooooooool06_ooool000[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo08[ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Joooo
o`002_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0Roooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2;ooooo`03o`00
0?oooooooooo03Kooooo00?o0000ooooooooool06_ooool000[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool0=_oo
ool00ol0003oooooooooo`0Jooooo`002_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0S?ooool00ol0003oooooooooo`0fooooo`03o`000?oooooo
oooo01[ooooo000:ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`2=ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool06_ooool000[o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo08ko
oooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Jooooo`002_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0S_ooool00ol0003ooooo
ooooo`0fooooo`03o`000?oooooooooo01[ooooo000:ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03Kooooo00?o
0000ooooooooool06_ooool000Sooooo1OoVi^HLooooo`03o`000?ooooooi^KV00Coi^KV00?ooooo
o`000?ooool0SOooool5onKViSCooooo1OoVi^HKooooo`001_ooool9onKViQ[ooooo2OoVi^J<oooo
o`Woi^KV<?ooool9onKViQWooooo0005ooooo`_oi^KV6?ooool4onKViPCo00000ooVi^J:ooooo`Co
i^KV1?l00003onKViRkooooo1?oVi^H4o`0000?oi^KV6?ooool000Gooooo2ooVi^HHooooo`Ooi^KV
0_l00002onKViX[ooooo1ooVi^H2o`0000;oi^KV;_ooool7onKViP;o00000_oVi^HHooooo`001?oo
ool3onKViPKo00001?oVi^HFooooo`Goi^KV1Ol00003onKViQoooooo1Ol0000Mooooo`Go00008_oo
ool6o`0001[ooooo1OoVi^H5o`0000?oi^KV7oooool4o`0000Wooooo1OoVi^H5o`0000?oi^KV2?oo
ool5o`0000[ooooo0004ooooo`Goi^KV0_l00006onKViQKooooo1?oVi^H2o`0000;oi^KV0_l00003
onKViQkooooo0_l000000ooooooo0000o`00000Oooooo`;o000000?oooooo`000?l000008oooool2
o`0001cooooo1?oVi^H2o`0000;oi^KV0_l00003onKViQkooooo0_l00002ooooo`;o00002?ooool4
onKViP;o00000_oVi^H2o`0000?oi^KV2Oooool2o`000003ooooool0003o000000Wooooo0004oooo
o`Goi^KV0_l00006onKViQKooooo1?oVi^H2o`0000;oi^KV0_l00003onKViQoooooo1?l0000Ooooo
o`;o000000?oooooo`000?l000008oooool2o`0001cooooo1?oVi^H2o`0000;oi^KV0_l00003onKV
iQkooooo0_l0000<ooooo`Coi^KV0_l00002onKViP;o00000ooVi^H9ooooo`;o000000?oooooo`00
0?l000002Oooool000Cooooo1OoVi^H2o`0000Koi^KV5_ooool4onKViP;o00000_oVi^H2o`0000?o
i^KV7_ooool2o`000003ooooool0003o000001oooooo0_l000000ooooooo0000o`00000Sooooo`;o
00007?ooool4onKViP;o00000_oVi^H2o`0000?oi^KV7_ooool2o`0000;ooooo0_l00008ooooo`Co
i^KV0_l00002onKViP;o00000ooVi^H9ooooo`;o000000?oooooo`000?l000002Oooool000Cooooo
1?oVi^H5o`0000Coi^KV5_ooool5onKViPKo00000_oVi^HOooooo`?o00008?ooool4o`0002;ooooo
1?l0000Looooo`Goi^KV1_l00002onKViQoooooo1?l00009ooooo`Goi^KV1_l00002onKViPWooooo
1?l0000:ooooo`001Oooool4onKViP;o00001OoVi^HHooooo`_oi^KV@oooool2o`0004Gooooo2ooV
i^H^ooooo`_oi^KV2_ooool2o`0000cooooo0005ooooo`Goi^KV0ol00003onKViQSooooo2ooVi^I2
ooooo`?o00009_ooool2o`0001gooooo2ooVi^H^ooooo`_oi^KV2Oooool3o`0000cooooo0006oooo
o`Woi^KV6_ooool9onKViXcooooo2OoVi^H`ooooo`Woi^KV6Oooool000Sooooo1OoVi^HNooooo`Go
i^KVT?ooool5onKViSCooooo1OoVi^HKooooo`003Oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo000>ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0=ooooo`003_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0/ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0;?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool03Oooool000oo
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00go
oooo000?ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0;oooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0>ooooo`004?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02oooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0<?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool03_ooool0013ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0a
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00oooooo000Aooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0<Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03;ooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`0?ooooo`004Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo03?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool04?ooool0017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
<_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo013ooooo000Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo03Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0dooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0@ooooo`004_ooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`0dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0=?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool04Oooool0
01?ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
03Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
017ooooo000Cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0fooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0Booooo`005?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0>?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool04_ooool001Cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0iooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0>?ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo01?ooooo000Eooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0>Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo03[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0Cooooo`005Oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo03Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0joooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04oooool001Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0>_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo03[ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo03cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0looooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Dooooo`005_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0??oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool05Ooo
ool001Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0mooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo03kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo01Gooooo000Gooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0nooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000H
ooooo`006?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0@?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool05_ooool0
01Sooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
043ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Kooooo000Ioooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo04;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`12oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05oooool001Wooooo00?o0000onKV
i_oVi^H00ooVi^H00ol0003oooooooooo`11ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000oooo
ooooool0@_ooool00ol0003oi^KVonKViP03onKViP03o`000?oooooooooo04;ooooo1OoVi^H00ooo
oooo0000ooooo`0Hooooo`006?ooool9onKViT7ooooo2OoVi^I2ooooo`Woi^KV@Oooool9onKViQWo
oooo000Gooooo`_oi^KV?oooool3onKViPCo00001?oVi^I0ooooo`_oi^KV?oooool4onKViPCo0000
0ooVi^HHooooo`005oooool;onKViSoooooo1_oVi^H2o`0000?oi^KV@?ooool;onKViSoooooo1ooV
i^H2o`0000;oi^KV6?ooool001Kooooo1?oVi^H4o`0000Goi^KV?Oooool4onKViPGo00001?oVi^Hn
ooooo`?oi^KV1ol00003onKViSgooooo1OoVi^H5o`0000?oi^KV5oooool001Kooooo0ooVi^H6o`00
00Coi^KV?Oooool3onKViP;o00000_oVi^H2o`0000Coi^KV?_ooool4onKViP;o000000?oi^KVo`00
0?l000001?oVi^Hmooooo`Coi^KV0_l00002onKViP;o00000ooVi^HGooooo`005_ooool3onKViPKo
00001?oVi^Hmooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hnooooo`Coi^KV0_l000000ooVi^Ko
0000o`000004onKViSgooooo1?oVi^H2o`0000;oi^KV0_l00003onKViQOooooo000Fooooo`?oi^KV
1_l00004onKViSgooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSkooooo1?oVi^H2o`000003onKV
i_l0003o000000Coi^KV?Oooool4onKViP;o00000_oVi^H2o`0000?oi^KV5oooool001Kooooo0ooV
i^H6o`0000Coi^KV00?o0000ooooooooool0>_ooool4onKViPKo00000ooVi^Hnooooo`Coi^KV1?l0
0005onKViSgooooo1OoVi^H6o`0000;oi^KV5oooool001Oooooo0ooVi^H4o`0000Coi^KV0_ooool3
o`0003[ooooo2ooVi^I0ooooo`?oi^KV0_l00006onKViS_ooooo0ol000000oooooooi^KVonKViP09
onKViQSooooo000Gooooo`_oi^KV1Oooool3o`0003Oooooo2ooVi^I0ooooo`;oi^KV0ol00006onKV
iSSooooo0ol00004ooooo`_oi^KV6?ooool001Sooooo2OoVi^H9ooooo`;o0000=_ooool9onKViT;o
oooo2OoVi^Hgooooo`;o00002?ooool9onKViQWooooo000Jooooo`Goi^KV3Oooool3o`0003Gooooo
1OoVi^H2ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool01OoVi^Hfooooo`?o0000
3?ooool5onKViQ_ooooo000_ooooo`?o0000>_ooool00ol0003oooooooooo`0looooo`03o`000?oo
oooooooo03Wooooo0ol0000_ooooo`00<_ooool3o`0003Sooooo00?o0000ooooooooool0>_ooool0
0ol0003oooooooooo`0gooooo`?o0000<_ooool003Gooooo0ol0000fooooo`03o`000?oooooooooo
03Sooooo00?o0000ooooooooool0=Oooool3o`0003Gooooo000hooooo`;o0000=Oooool00ol0003o
ooooooooo`0fooooo`03o`000?oooooooooo03Cooooo0_l0000hooooo`00>_ooool3o`0003?ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0booooo`?o0000>_ooool003gooooo0ol0
000aooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<?ooool3o`0003gooooo0010
ooooo`?o0000;oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02kooooo0ol00010
ooooo`00@oooool3o`0002gooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0[oooo
o`?o0000@oooool004Kooooo0_l0000/ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0:_ooool2o`0004Kooooo0018ooooo`?o0000:_ooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo02Sooooo0ol00018ooooo`00Boooool3o`0002Sooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`0Vooooo`?o0000Boooool004kooooo0ol0000Vooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool09?ooool3o`0004kooooo001Aooooo`?o00009?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo02;ooooo0ol0001Aooooo`00E?ooool2o`0002?o
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Qooooo`;o0000E?ooool005Kooooo
0ol0000Pooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool07oooool3o`0005Kooooo
001Iooooo`?o00007_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01gooooo0ol0
001Iooooo`00G?ooool3o`0001cooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0K
ooooo`?o0000G?ooool005oooooo0ol0000Jooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool06Oooool3o`0005oooooo001Rooooo`;o00006Oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01Sooooo0_l0001Rooooo`00I?ooool3o`0001Oooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0Fooooo`?o0000I?ooool006Oooooo0ol0000Eooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05?ooool3o`0006Oooooo001Zooooo`?o00004oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo017ooooo0ol0001Zooooo`00KOooool3o`00
017ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0?ooooo`?o0000KOooool0073o
oooo0_l0000@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool03_ooool2o`00073o
oooo001booooo`?o00003_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00cooooo
0ol0001booooo`00MOooool3o`0000cooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0:ooooo`?o0000MOooool007Sooooo0ol0000:ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02?ooool3o`0007Sooooo001kooooo`?o00002?ooool00ol0003oooooooooo`05onKV
iPCooooo00?o0000ooooooooool01_ooool3o`0007_ooooo001nooooo`;o00001oooool9onKViP03
ooooool0003ooooo00Kooooo0_l0001nooooo`00P?ooool3o`0000?ooooo2ooVi^H5ooooo`?o0000
P?ooool008?ooooo0ol0000;onKViP;ooooo0ol00023ooooo`00QOooool5onKViPCo00001?oVi^H0
0ol0003oooooooooo`24ooooo`00QOooool4onKViPKo00000ooVi^J7ooooo`00QOooool4onKViPKo
00000ooVi^J7ooooo`00QOooool4onKViPKo00000ooVi^J7ooooo`00QOooool4onKViPKo00000ooV
i^J7ooooo`00Q_ooool4onKViPCo00000ooVi^J8ooooo`00Q_ooool;onKViXSooooo0027ooooo`Wo
i^KVROooool008Wooooo1OoVi^J;ooooo`00\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.938, 0}} -> {-2.50612, -0.829972, \
0.017873, 0.00499577}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[symbExpr, TreeWidth -> .1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.196721 0.603319 0.981006 [
[.02381 .21092 -5 -6 ]
[.02381 .21092 5 6 ]
[.18931 .21092 -5 -6 ]
[.18931 .21092 5 6 ]
[.10656 .40712 -5 -6 ]
[.10656 .40712 5 6 ]
[.41725 .21092 -5 -6 ]
[.41725 .21092 5 6 ]
[.58275 .21092 -5 -6 ]
[.58275 .21092 5 6 ]
[.58275 .01472 -5 -6 ]
[.58275 .01472 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.81069 .21092 -5 -6 ]
[.81069 .21092 5 6 ]
[.89344 .21092 -5 -6 ]
[.89344 .21092 5 6 ]
[.89344 .01472 -5 -6 ]
[.89344 .01472 5 6 ]
[.97619 .21092 -5 -6 ]
[.97619 .21092 5 6 ]
[.89344 .40712 -5 -6 ]
[.89344 .40712 5 6 ]
[.5 .60332 -57.7812 -6 ]
[.5 .60332 57.7812 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.10656 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.89344 .40712 L
s
.10656 .40712 m
.02381 .21092 L
s
.10656 .40712 m
.18931 .21092 L
s
1 g
.05 w
.02381 .21092 Mdot
0 g
gsave
.02381 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.18931 .21092 Mdot
0 g
gsave
.18931 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.10656 .40712 Mdot
0 g
gsave
.10656 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.5 .40712 m
.41725 .21092 L
s
.5 .40712 m
.58275 .21092 L
s
1 g
.05 w
.41725 .21092 Mdot
0 g
gsave
.41725 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i) show
1.000 setlinewidth
grestore
.5 Mabswid
.58275 .21092 m
.58275 .01472 L
s
.9 g
.05 w
.58275 .21092 Mdot
0 g
gsave
.58275 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.58275 .01472 Mdot
0 g
gsave
.58275 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.05 w
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.5 Mabswid
.89344 .40712 m
.81069 .21092 L
s
.89344 .40712 m
.89344 .21092 L
s
.89344 .40712 m
.97619 .21092 L
s
1 g
.05 w
.81069 .21092 Mdot
0 g
gsave
.81069 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.89344 .21092 m
.89344 .01472 L
s
.9 g
.05 w
.89344 .21092 Mdot
0 g
gsave
.89344 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.89344 .01472 Mdot
0 g
gsave
.89344 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.05 w
.97619 .21092 Mdot
0 g
gsave
.97619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.89344 .40712 Mdot
0 g
gsave
.89344 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -118.781 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.000 13.000 moveto
(@) show
75.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.000 13.000 moveto
(@) show
87.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
93.000 13.000 moveto
(D) show
99.000 13.000 moveto
(D) show
105.000 13.000 moveto
(@) show
111.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
117.000 13.000 moveto
(@) show
123.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
129.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
138.562 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
144.562 13.000 moveto
(@) show
150.562 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
156.562 13.000 moveto
(D) show
162.562 13.000 moveto
(D) show
168.562 13.000 moveto
(D) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.938},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00X?ooool4o`00057ooooo1Ol0
000Oooooo`00Woooool2o`0000;ooooo0_l0001?ooooo`;o000000?oooooo`000?l000008?ooool0
09oooooo0_l0001Cooooo`;o000000?oooooo`000?l000008?ooool009oooooo0_l00002ooooo`;o
0000Coooool2o`000003ooooool0003o0000023ooooo002Pooooo`Co0000DOooool4o`00023ooooo
003gooooo`;o00008?ooool00?Kooooo0ol0000Pooooo`00X_ooool00ol0003oooooooooo`1Boooo
o`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000oooooooo
ool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00X_oo
ool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooo
oooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0
003oooooooooo`0Oooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oo
oooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o
0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003oooooooooo`1B
ooooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000oooo
ooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00
X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oo
oooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool0
0ol0003oooooooooo`0Oooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo
00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003ooooooooo
o`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Ooooo
o`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`00
0?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_oo
ool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooo
oooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;o
oooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003ooooo
ooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o
0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0O
ooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03
o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0
D_ooool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool0
0:;ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Oooooo`00X_ooool00ol0003o
ooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Rooooo`03o`000?oooooooooo05;ooooo
00?o0000ooooooooool07oooool00:;ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`0Oooooo`00X_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01oooooo002Roooo
o`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07oooool00:;ooooo00?o0000oooooooo
ool0D_ooool00ol0003oooooooooo`0Oooooo`00X?ooool5onKViU3ooooo1OoVi^HOooooo`00W_oo
ool9onKViTcooooo2OoVi^HMooooo`00WOooool3onKViPCo00001?oVi^I:ooooo`?oi^KV1?l00004
onKViQcooooo002Mooooo`Koi^KV0_l00003onKViT[ooooo1_oVi^H2o`0000?oi^KV7?ooool000So
oooo1Ol0000Wooooo`Go0000>Oooool6o`0002Cooooo1?oVi^H5o`0000Coi^KV=Oooool4o`0000oo
oooo1?oVi^H5o`0000Coi^KV3?ooool5o`0000[ooooo0007ooooo`;o000000?oooooo`000?l00000
:Oooool2o`000003ooooool0003o000003[ooooo0_l0000Vooooo`?oi^KV0_l00002onKViP;o0000
1?oVi^Hdooooo`;o00000_ooool2o`0000kooooo0ooVi^H2o`0000;oi^KV0_l00004onKViPgooooo
0_l000000ooooooo0000o`000009ooooo`002?ooool4o`0002Wooooo0_l000000ooooooo0000o`00
000jooooo`;o00009_ooool3onKViP;o00000_oVi^H2o`0000Coi^KV=?ooool2o`0001;ooooo0ooV
i^H2o`0000;oi^KV0_l00004onKViPgooooo0_l000000ooooooo0000o`000009ooooo`001oooool2
o`000003ooooool0003o000002Wooooo0_l000000ooooooo0000o`00000jooooo`;o00009_ooool3
onKViP;o00000_oVi^H2o`0000Coi^KV=?ooool2o`0000;ooooo0_l0000>ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^H=ooooo`;o000000?oooooo`000?l000002Oooool000Sooooo0ol0000Zoooo
o`Co0000>Oooool4o`0002Kooooo1?oVi^H6o`0000?oi^KV=Oooool4o`0000oooooo1?oVi^H6o`00
00?oi^KV3Oooool4o`0000[ooooo000eooooo`;o0000I_ooool;onKViT[ooooo2ooVi^H>ooooo`;o
00003?ooool003Cooooo0ol0000mooooo`;o00009oooool;onKViT[ooooo2ooVi^H=ooooo`?o0000
3?ooool009kooooo2OoVi^I<ooooo`Woi^KV7Oooool00:3ooooo1OoVi^I@ooooo`Goi^KV7oooool0
00gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool09?ooool00ol0003o
ooooooooo`11ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0@Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03?ooool000kooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0@oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03Oooool000kooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`13ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0@oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03Oooool000oooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0A?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03Oooool000oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`15oooo
o`03o`000?oooooooooo023ooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool000oooooo00?o0000oooooooo
ool08?ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool0AOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03_ooool0013ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`17ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03oooool0013ooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Aooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03ooo
ool0017ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`18ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03oooool0017ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`19ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0BOooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool04?ooool001;o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool04?ooool001;ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`1;ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Boooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool04Oooool001;ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool0Boooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool04Oooool001?ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1=
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool04_ooool001?ooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool0COooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool04_ooool001Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`1>ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool04_ooool001Cooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
Coooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
4oooool001Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1@ooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool04oooool001Gooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool05?ooool0
01Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`1Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool05?ooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool0Doooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool05Oooool001Oooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool05Oooool001Oooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool0EOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool05_ooool001Sooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1Foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool05_ooool001Sooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool0E_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool05_ooool001Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Hooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool05oooool001Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05ooo
ool001Wooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool06?ooool001[ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`1Jooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0F_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06?ooool001[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool06Oooool001_ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`1Looooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0G?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06Oooool001_ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool06Oooool001cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1N
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool06_ooool001cooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool06_ooool001cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Oooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000007Oooool001gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`1Pooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0H?ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool06oooool001gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`1Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0H?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool06oooool001ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0H_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
01cooooo000Nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0H_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo06;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Looooo`007_ooool5onKViP03o`000?oooooooooo06?ooooo1OoVi^H00ol0003o
ooooooooo`1Tooooo`Goi^KV7oooool001cooooo0ooVi^H4o`0000;oi^KVH_ooool9onKViV?ooooo
0_oVi^H4o`0000?oi^KV7Oooool001_ooooo1ooVi^H2o`0000;oi^KVH?ooool;onKViV7ooooo1_oV
i^H2o`0000?oi^KV7?ooool001_ooooo1?oVi^H5o`0000;oi^KVH?ooool3onKViPOo000000?oi^KV
ooooooooool0Goooool3onKViPGo00000ooVi^HLooooo`006_ooool4onKViP;o00000_oVi^H2o`00
00?oi^KVG_ooool5onKViP;o000000?oi^KVo`000?l000000ooVi^IOooooo`?oi^KV0_l00002onKV
iP;o00001?oVi^HKooooo`006_ooool4onKViP;o00000_oVi^H2o`0000?oi^KVG_ooool5onKViP;o
000000?oi^KVo`000?l000000ooVi^IOooooo`?oi^KV0_l00002onKViP;o00001?oVi^HKooooo`00
6_ooool4onKViP;o00000_oVi^H2o`0000?oi^KVG_ooool5onKViP;o000000?oi^KVo`000?l00000
0ooVi^IOooooo`?oi^KV0_l00002onKViP;o00001?oVi^HKooooo`006_ooool5onKViPKo00000_oV
i^INooooo`Goi^KV1?l00004onKViUoooooo1?oVi^H6o`0000?oi^KV6oooool001[ooooo3OoVi^H2
o`0005cooooo1OoVi^H2o`0000Koi^KVG_ooool00ol0003oi^KVonKViP0;onKViQ_ooooo000Koooo
o`_oi^KV0oooool2o`0005_ooooo0ooVi^H3o`0000Goi^KVGOooool2o`0000;ooooo2ooVi^HLoooo
o`006oooool;onKViPGooooo0_l0001Iooooo`_oi^KVFoooool2o`0000Cooooo2ooVi^HLooooo`00
7?ooool9onKViPSooooo0_l0001Hooooo`Woi^KVF_ooool2o`0000Oooooo2OoVi^HMooooo`007_oo
ool5onKViPcooooo0_l0001Hooooo`Goi^KVF_ooool2o`0000_ooooo1OoVi^HOooooo`00<Oooool2
o`0005Wooooo00?o0000ooooooooool0Eoooool2o`00037ooooo000cooooo`;o0000Eoooool00ol0
003oooooooooo`1Eooooo`;o0000<oooool003Gooooo0_l0001Eooooo`03o`000?oooooooooo05?o
oooo0_l0000eooooo`00=oooool2o`0005?ooooo00?o0000ooooooooool0DOooool2o`0003Oooooo
000iooooo`;o0000DOooool00ol0003oooooooooo`1?ooooo`;o0000>Oooool003_ooooo0_l0001?
ooooo`03o`000?oooooooooo04gooooo0_l0000kooooo`00?Oooool2o`0004gooooo00?o0000oooo
ooooool0Boooool2o`0003gooooo000oooooo`;o0000Boooool00ol0003oooooooooo`19ooooo`;o
0000?oooool0047ooooo0_l00019ooooo`03o`000?oooooooooo04Oooooo0_l00011ooooo`00@ooo
ool2o`0004Oooooo00?o0000ooooooooool0AOooool2o`0004?ooooo0015ooooo`;o0000AOooool0
0ol0003oooooooooo`13ooooo`;o0000AOooool004Oooooo0_l00013ooooo`03o`000?oooooooooo
047ooooo0_l00017ooooo`00BOooool2o`00047ooooo00?o0000ooooooooool0?oooool2o`0004Wo
oooo001;ooooo`;o0000?oooool00ol0003oooooooooo`0mooooo`;o0000Boooool004gooooo0_l0
000mooooo`03o`000?oooooooooo03_ooooo0_l0001=ooooo`00Coooool2o`0003_ooooo00?o0000
ooooooooool0>Oooool2o`0004oooooo001Aooooo`;o0000>Oooool00ol0003oooooooooo`0goooo
o`;o0000DOooool005?ooooo0_l0000gooooo`03o`000?oooooooooo03Gooooo0_l0001Cooooo`00
EOooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0005Gooooo001Gooooo`03o`000?oo
oooooooo03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`1Eooooo`00F?ooool2
o`0003;ooooo00?o0000ooooooooool0<?ooool2o`0005Sooooo001Jooooo`;o0000<?ooool00ol0
003oooooooooo`0^ooooo`;o0000F_ooool005cooooo0_l0000^ooooo`03o`000?oooooooooo02co
oooo0_l0001Looooo`00G_ooool2o`0002cooooo00?o0000ooooooooool0:_ooool2o`0005kooooo
001Pooooo`;o0000:_ooool00ol0003oooooooooo`0Xooooo`;o0000H?ooool006;ooooo0_l0000X
ooooo`03o`000?oooooooooo02Kooooo0_l0001Rooooo`00I?ooool2o`0002Kooooo00?o0000oooo
ooooool09?ooool2o`0006Cooooo001Vooooo`;o00009?ooool00ol0003oooooooooo`0Rooooo`;o
0000I_ooool006Sooooo0_l0000Rooooo`03o`000?oooooooooo023ooooo0_l0001Xooooo`00J_oo
ool2o`00023ooooo00?o0000ooooooooool07_ooool2o`0006[ooooo001/ooooo`;o00007_ooool0
0ol0003oooooooooo`0Looooo`;o0000K?ooool006kooooo0_l0000Looooo`03o`000?oooooooooo
01[ooooo0_l0001^ooooo`00L?ooool2o`0001[ooooo00?o0000ooooooooool06?ooool2o`00073o
oooo001booooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`;o0000L_ooool007Cooooo0_l0
000Fooooo`03o`000?oooooooooo01Cooooo0_l0001dooooo`00M_ooool2o`0001Cooooo00?o0000
ooooooooool04_ooool2o`0007Kooooo001hooooo`;o00004_ooool00ol0003oooooooooo`0@oooo
o`;o0000N?ooool007[ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0001jooooo`00
O?ooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0007cooooo001nooooo`;o00003?oo
ool00ol0003oooooooooo`0:ooooo`;o0000O_ooool0083ooooo0_l00007ooooo`Goi^KV2Oooool2
o`00083ooooo0022ooooo`;o00000oooool9onKViPGooooo0_l00022ooooo`00GOooool2o`0000[o
oooo0_l00008ooooo`;o00001?ooool2o`0000Kooooo0_l000000ooooooo0000o`000003o`0000Co
i^KV0_l00002onKViP;ooooo0_l00003ooooo`;o00001oooool4o`0000Cooooo0_l00008ooooo`;o
00001?ooool2o`0000Cooooo0_l0001Hooooo`00GOooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00;ooooo0_oVi^H2o`0000?oi^KV00Co0000onKVi_oVi^Koi^KV0_l00006ooooo`;o
00002Oooool2o`0000?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0E_ooool005Cooooo1_l00003ooooo`03o`00
0?oooooooooo00Oo00000_ooool01?l0003oooooooooooooool4o`0000?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`Go00000ooVi^H01?l0
003oi^KVonKVi_oVi^H5o`0000?ooooo0_l00006ooooo`Go00000oooool00ol0003oooooooooo`05
o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo05Kooooo001Fooooo`;o00001Oooool01?l0003oooooooooooooool2o`000003ooooool0003o
000000?ooooo00?o0000ooooooooool00_l00002ooooo`;o00000_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l00002onKViP;o00000ooVi^H0
0ol0003oi^KVonKViP02o`000003ooooool0003o000000_ooooo0_l00002ooooo`;o00000oooool0
1?l0003oooooooooooooool2o`000003ooooool0003o000000;ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05Kooooo001Fooooo`;o00001Oooool0
1?l0003oooooooooooooool2o`000003ooooool0003o000000?ooooo00?o0000ooooooooool00_l0
0006ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02o`0000;oi^KV0_l00003onKViP04o`000?oVi^Koi^KVonKViPCo00002oooool2o`0000;ooooo
0_l00003ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?l000000_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0E_ooool005Kooooo
0_l00005ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?l000000oooool00ol0003o
ooooooooo`02o`0000;ooooo0_l00002ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`02o`0000;oi^KV0_l00003onKViP03o`000?oVi^Koi^KV00;o
000000?oooooo`000?l000002oooool2o`0000;ooooo0_l00003ooooo`04o`000?oooooooooooooo
o`;o000000?oooooo`000?l000000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0E_ooool005Gooooo1Ol00003ooooo`04o`000?oooooooooooooo
o`Co00001?ooool01?l0003oooooooooooooool4o`0000?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`Ko00000_oVi^H01?l0003oi^KVonKV
i_oVi^H3o`0000gooooo1_l00002ooooo`04o`000?ooooooooooooooo`Co00000oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0E_ooool005Kooooo
0_l00005ooooo`;o00000_ooool2o`0000Kooooo0_l00008ooooo`;o00001?ooool2o`0000Kooooo
0_l00003ooooo`Ooi^KV0_l00002onKViQSooooo0_l00002ooooo`;o00001?ooool2o`0000Cooooo
0_l00004ooooo`;o0000F?ooool005Oooooo0ol00006ooooo`?o00008oooool;onKViQ_ooooo0ol0
001Zooooo`00Qoooool9onKViXWooooo0029ooooo`Goi^KVRoooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.938, 0}} -> {-2.61994, -0.622479, \
0.0186847, 0.00374683}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, _] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"a", \({1, 1}\)},
            {"b", \({1, 2}\)},
            {\(g[a, b]\), \({1}\)},
            {"i", \({2, 1}\)},
            {"c", \({2, 2, 1}\)},
            {\(g[c]\), \({2, 2}\)},
            {\(h[i, g[c]]\), \({2}\)},
            {"c", \({3, 1}\)},
            {"d", \({3, 2, 1}\)},
            {\(g[d]\), \({3, 2}\)},
            {"b", \({3, 3}\)},
            {\(g[c, g[d], b]\), \({3}\)},
            {\(\(\(f[h[c]]\)[g[a, g[b]]]\)[g[a, b], h[i, g[c]], 
                g[c, g[d], b]]\), \({}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, _g] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(g[a, b]\), \({1}\)},
            {\(g[c]\), \({2, 2}\)},
            {\(g[d]\), \({3, 2}\)},
            {\(g[c, g[d], b]\), \({3}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, _g, Heads -> True] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(g[b]\), \({0, 1, 2}\)},
            {\(g[a, g[b]]\), \({0, 1}\)},
            {\(g[a, b]\), \({1}\)},
            {\(g[c]\), \({2, 2}\)},
            {\(g[d]\), \({3, 2}\)},
            {\(g[c, g[d], b]\), \({3}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
exprInstances[symbExpr, g[x__/; Length[{x}] > 1] , 
  Heads -> True] // TT // MM\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(g[a, g[b]]\), \({0, 1}\)},
            {\(g[a, b]\), \({1}\)},
            {\(g[c, g[d], b]\), \({3}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
exprInstances[symbExpr, g[___, b, ___], Heads -> True] // TT // \
MM\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(g[b]\), \({0, 1, 2}\)},
            {\(g[a, b]\), \({1}\)},
            {\(g[c, g[d], b]\), \({3}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Expressions Containing Expressions Containing Expressions ...\
\>", \
"Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TT = Transpose; MM = MatrixForm;", "Input",
  AspectRatioFixed->True,
  CellTags->"Hierarchical selection"],

Cell["\<\
symbExpr =
 g[
   f[e, k[3], k[b, g[3]]],
   h[b],
   f[1, k[e], 3],
   k[1, 2, h[c]],
   g[a],
   f[h[a], b, 1],
   f[d, k[h[b], 2, 3]]
   
 ];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[symbExpr, TreeWidth -> .5];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.432135 0.180954 0.603319 0.735755 [
[.02522 .30902 -5 -6 ]
[.02522 .30902 5 6 ]
[.07023 .30902 -5 -6 ]
[.07023 .30902 5 6 ]
[.07023 .16187 -5 -6 ]
[.07023 .16187 5 6 ]
[.02381 .16187 -5 -6 ]
[.02381 .16187 5 6 ]
[.20666 .16187 -5 -6 ]
[.20666 .16187 5 6 ]
[.20666 .01472 -5 -6 ]
[.20666 .01472 5 6 ]
[.11523 .30902 -5 -6 ]
[.11523 .30902 5 6 ]
[.07023 .45617 -5 -6 ]
[.07023 .45617 5 6 ]
[.19086 .45617 -5 -6 ]
[.19086 .45617 5 6 ]
[.19086 .30902 -5 -6 ]
[.19086 .30902 5 6 ]
[.26649 .30902 -5 -6 ]
[.26649 .30902 5 6 ]
[.3115 .30902 -5 -6 ]
[.3115 .30902 5 6 ]
[.3115 .16187 -5 -6 ]
[.3115 .16187 5 6 ]
[.35651 .30902 -5 -6 ]
[.35651 .30902 5 6 ]
[.3115 .45617 -5 -6 ]
[.3115 .45617 5 6 ]
[.38713 .30902 -5 -6 ]
[.38713 .30902 5 6 ]
[.43214 .30902 -5 -6 ]
[.43214 .30902 5 6 ]
[.47714 .30902 -5 -6 ]
[.47714 .30902 5 6 ]
[.47714 .16187 -5 -6 ]
[.47714 .16187 5 6 ]
[.43214 .45617 -5 -6 ]
[.43214 .45617 5 6 ]
[.55277 .45617 -5 -6 ]
[.55277 .45617 5 6 ]
[.55277 .30902 -5 -6 ]
[.55277 .30902 5 6 ]
[.6284 .30902 -5 -6 ]
[.6284 .30902 5 6 ]
[.6284 .16187 -5 -6 ]
[.6284 .16187 5 6 ]
[.67341 .30902 -5 -6 ]
[.67341 .30902 5 6 ]
[.71842 .30902 -5 -6 ]
[.71842 .30902 5 6 ]
[.67341 .45617 -5 -6 ]
[.67341 .45617 5 6 ]
[.74904 .30902 -5 -6 ]
[.74904 .30902 5 6 ]
[.70191 .16187 -5 -6 ]
[.70191 .16187 5 6 ]
[.70191 .01472 -5 -6 ]
[.70191 .01472 5 6 ]
[.83905 .16187 -5 -6 ]
[.83905 .16187 5 6 ]
[.97619 .16187 -5 -6 ]
[.97619 .16187 5 6 ]
[.83905 .30902 -5 -6 ]
[.83905 .30902 5 6 ]
[.79404 .45617 -5 -6 ]
[.79404 .45617 5 6 ]
[.43214 .60332 -5 -6 ]
[.43214 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.43214 .60332 m
.07023 .45617 L
s
.43214 .60332 m
.19086 .45617 L
s
.43214 .60332 m
.3115 .45617 L
s
.43214 .60332 m
.43214 .45617 L
s
.43214 .60332 m
.55277 .45617 L
s
.43214 .60332 m
.67341 .45617 L
s
.43214 .60332 m
.79404 .45617 L
s
.07023 .45617 m
.02522 .30902 L
s
.07023 .45617 m
.07023 .30902 L
s
.07023 .45617 m
.11523 .30902 L
s
1 g
.05 w
.02522 .30902 Mdot
0 g
gsave
.02522 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.07023 .30902 m
.07023 .16187 L
s
.9 g
.05 w
.07023 .30902 Mdot
0 g
gsave
.07023 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
1 g
.04 w
.07023 .16187 Mdot
0 g
gsave
.07023 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 Mabswid
.11523 .30902 m
.02381 .16187 L
s
.11523 .30902 m
.20666 .16187 L
s
1 g
.05 w
.02381 .16187 Mdot
0 g
gsave
.02381 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.20666 .16187 m
.20666 .01472 L
s
.9 g
.05 w
.20666 .16187 Mdot
0 g
gsave
.20666 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20666 .01472 Mdot
0 g
gsave
.20666 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.05 w
.11523 .30902 Mdot
0 g
gsave
.11523 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.9 g
.07023 .45617 Mdot
0 g
gsave
.07023 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.5 Mabswid
.19086 .45617 m
.19086 .30902 L
s
.9 g
.05 w
.19086 .45617 Mdot
0 g
gsave
.19086 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.04 w
.19086 .30902 Mdot
0 g
gsave
.19086 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.3115 .45617 m
.26649 .30902 L
s
.3115 .45617 m
.3115 .30902 L
s
.3115 .45617 m
.35651 .30902 L
s
1 g
.05 w
.26649 .30902 Mdot
0 g
gsave
.26649 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 Mabswid
.3115 .30902 m
.3115 .16187 L
s
.9 g
.05 w
.3115 .30902 Mdot
0 g
gsave
.3115 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
1 g
.04 w
.3115 .16187 Mdot
0 g
gsave
.3115 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.05 w
.35651 .30902 Mdot
0 g
gsave
.35651 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.3115 .45617 Mdot
0 g
gsave
.3115 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.5 Mabswid
.43214 .45617 m
.38713 .30902 L
s
.43214 .45617 m
.43214 .30902 L
s
.43214 .45617 m
.47714 .30902 L
s
1 g
.05 w
.38713 .30902 Mdot
0 g
gsave
.38713 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
1 g
.43214 .30902 Mdot
0 g
gsave
.43214 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.47714 .30902 m
.47714 .16187 L
s
.9 g
.05 w
.47714 .30902 Mdot
0 g
gsave
.47714 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.04 w
.47714 .16187 Mdot
0 g
gsave
.47714 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.05 w
.43214 .45617 Mdot
0 g
gsave
.43214 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.5 Mabswid
.55277 .45617 m
.55277 .30902 L
s
.9 g
.05 w
.55277 .45617 Mdot
0 g
gsave
.55277 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.55277 .30902 Mdot
0 g
gsave
.55277 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.67341 .45617 m
.6284 .30902 L
s
.67341 .45617 m
.67341 .30902 L
s
.67341 .45617 m
.71842 .30902 L
s
.6284 .30902 m
.6284 .16187 L
s
.9 g
.05 w
.6284 .30902 Mdot
0 g
gsave
.6284 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.04 w
.6284 .16187 Mdot
0 g
gsave
.6284 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.05 w
.67341 .30902 Mdot
0 g
gsave
.67341 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.71842 .30902 Mdot
0 g
gsave
.71842 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.9 g
.67341 .45617 Mdot
0 g
gsave
.67341 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.5 Mabswid
.79404 .45617 m
.74904 .30902 L
s
.79404 .45617 m
.83905 .30902 L
s
1 g
.05 w
.74904 .30902 Mdot
0 g
gsave
.74904 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.83905 .30902 m
.70191 .16187 L
s
.83905 .30902 m
.83905 .16187 L
s
.83905 .30902 m
.97619 .16187 L
s
.70191 .16187 m
.70191 .01472 L
s
.9 g
.05 w
.70191 .16187 Mdot
0 g
gsave
.70191 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.04 w
.70191 .01472 Mdot
0 g
gsave
.70191 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.05 w
.83905 .16187 Mdot
0 g
gsave
.83905 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.97619 .16187 Mdot
0 g
gsave
.97619 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.83905 .30902 Mdot
0 g
gsave
.83905 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.9 g
.79404 .45617 Mdot
0 g
gsave
.79404 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.9 g
.43214 .60332 Mdot
0 g
gsave
.43214 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{469.438, 290.125},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007E00018R000`400?l00000o`00003ooooooooF
ooooo`00oooooooFooooo`00oooooooFooooo`00oooooooFooooo`00oooooooFooooo`00oooooooF
ooooo`00oooooooFooooo`00oooooooFooooo`00H_ooool4o`000=gooooo1Ol0002=ooooo`00HOoo
ool2o`0000;ooooo0_l0003Mooooo`;o000000?oooooo`000?l00000S?ooool006Gooooo0_l0003M
ooooo`;o000000?oooooo`000?l00000S?ooool006?ooooo0ol0003Nooooo`;o000000?oooooo`00
0?l00000S?ooool006Gooooo0_l0003Mooooo`Co0000SOooool0067ooooo0_l00002ooooo`;o0000
gOooool2o`0008oooooo001Rooooo`Co0000gOooool3o`0008oooooo003oooooomKooooo003ooooo
omKooooo003oooooomKooooo003oooooomKooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o
0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<
ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03
o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0
goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oo
oooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool0
06Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003o
ooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo
00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003ooooooooo
o`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Toooo
o`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000oooooooo
ool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`00
0?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?oo
ool006Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0
003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oo
oooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003ooooo
ooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001T
ooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000oooo
ooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03
o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0
S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool0
0ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo
0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003o
ooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo
001Tooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000
ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Ooooo
o`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000oooooooo
ool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?oo
ool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooo
oooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0
003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08co
oooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o
0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3O
ooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oooooooooo0=oooooo00?o0000oooo
ooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`2<ooooo`00
I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo08cooooo001Tooooo`03o`000?oo
oooooooo0=oooooo00?o0000ooooooooool0S?ooool006Cooooo00?o0000ooooooooool0goooool0
0ol0003oooooooooo`2<ooooo`00I?ooool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo
08cooooo001Qooooo`Koi^KVg?ooool6onKViXcooooo001Nooooo`coi^KVe_ooool<onKViXWooooo
001Mooooo`koi^KVe?ooool>onKViXSooooo001Loooooa3oi^KVd_ooool@onKViXOooooo001Koooo
oa;oi^KVd?oooolBonKViXKooooo001JoooooaCoi^KVc_oooolDonKViXGooooo001Jooooo`Soi^KV
1?l00008onKVi/kooooo5?oVi^J5ooooo`00F_ooool;onKViP;o00001ooVi^K>oooooaCoi^KVQOoo
ool000gooooo1Ol0000Booooo`Co0000<Oooool9onKViPGo00002?oVi^HSooooo`Co0000Aoooool4
o`00047ooooo1Ol0000Dooooo`Soi^KV1ol00007onKViS3ooooo1_l0000jooooo`Co00004?ooool0
00kooooo0_l000000ooooooo0000o`00000@ooooo`;o00000_ooool2o`00033ooooo2?oVi^H2o`00
00;oi^KV0_l00008onKViR;ooooo0_l00019ooooo`;o00000_ooool2o`0003oooooo0_l000000ooo
oooo0000o`00000Eooooo`Woi^KV0_l000000ooVi^Ko0000o`000008onKViS7ooooo0_l000000ooo
oooo0000o`00000iooooo`;o00000_ooool2o`0000oooooo000>ooooo`;o000000?oooooo`000?l0
00005?ooool2o`00033ooooo2?oVi^H2o`0000;oi^KV0_l00008onKViR;ooooo1_l00015ooooo`;o
0000A?ooool4o`0001Gooooo2OoVi^H2o`000003onKVi_l0003o000000Soi^KV<_ooool2o`0003oo
oooo0_l0000?ooooo`003_ooool2o`000003ooooool0003o000001;ooooo0ol0000aooooo`Soi^KV
0_l00002onKViP;o00002?oVi^HRooooo`;o00000_ooool2o`0004Gooooo0_l00002ooooo`;o0000
?oooool2o`000003ooooool0003o000001Gooooo2OoVi^H2o`000003onKVi_l0003o000000Soi^KV
<oooool2o`0003cooooo0ol0000@ooooo`003_ooool4o`0001Gooooo0_l0000`ooooo`Woi^KV1_l0
0007onKViR?ooooo1?l00017ooooo`Co0000@Oooool3o`0001Kooooo2OoVi^H4o`0000Woi^KV<?oo
ool2o`0000;ooooo0_l0000mooooo`;o00003oooool000kooooo0_l0000Cooooo`;o00000_ooool2
o`00033ooooo5_oVi^K<ooooo`Woi^KV0_l0000;onKViS3ooooo0_l00002ooooo`;o0000>Oooool2
o`0000;ooooo0_l0000?ooooo`003Oooool3o`0001Cooooo1?l0000boooooaCoi^KVc_ooool7onKV
iP?o00002_oVi^Hbooooo`Co0000>oooool4o`00013ooooo001JoooooaCoi^KVc_oooolDonKViXGo
oooo001JoooooaCoi^KVc_oooolDonKViXGooooo001Koooooa;oi^KVd?oooolBonKViXKooooo001L
oooooa3oi^KVd_ooool@onKViXOooooo000Vooooo`03o`000?oooooooooo03Cooooo3_oVi^HYoooo
o`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0Hoooo
o`koi^KV00?oooooo`000?ooool0Joooool00ol0003oooooooooo`0Gooooo`009_ooool00ol0003o
ooooooooo`0eooooo`coi^KV:_ooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;o
oooo00?o0000ooooooooool06Oooool<onKViP?ooooo00?o0000ooooooooool0J?ooool00ol0003o
ooooooooo`0Hooooo`005oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03Cooooo
00Co0000oooooooooooooooo1_oVi^H]ooooo`03o`000?oooooooooo04Sooooo00?o0000oooooooo
ool0@_ooool00ol0003oooooooooo`0Looooo`Koi^KV1oooool00ol0003oooooooooo`1Vooooo`03
o`000?oooooooooo01Wooooo000Gooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
=?ooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0
@_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0
<Oooool00ol0003oooooooooo`0Jooooo`006?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`18ooooo`03o`000?oo
oooooooo04;ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`03o`000?oo
oooooooo033ooooo00?o0000ooooooooool06oooool001Sooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0cooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0B?ooool0
0ol0003oooooooooo`12ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01cooooo000Iooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Mooooo`006_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool07_ooool001[ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo02kooooo
00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01oooooo
000Kooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool00ol0003ooooooooo
o`0hooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?ooool00ol0003ooooooooo
o`0Oooooo`007?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0>Oooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000
ooooooooool0<?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool08?ooool001cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0_oooo
o`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12oooo
o`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo027ooooo000Mooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0;_ooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo04Sooooo00?o0000oooooooo
ool0@_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0Rooooo`007Oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo02kooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`18ooooo`03o`00
0?oooooooooo04;ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo02Sooooo00?o0000ooooooooool08oooool001kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0B?oo
ool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Cooooo000Oooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0looooo`03o`000?oooooo
oooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0eooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Uooooo`007oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0??ooool00ol0
003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09_ooool0023o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo03go
oooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo03Oo
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Oo
oooo000Qooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0nooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003ooooo
ooooo`0hooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`0Xooooo`008Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool0?_ooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o
0000ooooooooool0>?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool0:Oooool002;ooooo00Go0000ooooooooooooooooo`00000[ooooo`03o`000?oo
oooooooo03oooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oo
oooooooo03Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo02[ooooo000Rooooo`05o`000?ooooooooooooooool00000:oooool00ol0003ooooooooo
o`0oooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003ooooooooo
o`0jooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0[ooooo`008oooool01?l0003oooooooooool0000Zooooo`03o`000?oooooooooo043ooooo00?o
0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo03_ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo02cooooo000T
ooooo`03o`000?oooooo000002Wooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`18
ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0;Oooool002Cooooo00?o0000oooo
ool00000:Oooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo04Sooooo00?o0000oooo
ooooool0@_ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0^ooooo`009Oooool2o`0002Sooooo00?o0000oooooooo
ool0@_ooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000oooooooo
ool0?_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool0;oooool002Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`13ooooo`03o`00
0?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0oooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0_ooooo`009_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0B?oo
ool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo033ooooo000Vooooo`;o00009Oooool0
0ol0003oooooooooo`14ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool0
0ol0003oooooooooo`11ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0aooooo`009_ooool00ol0003oooooo`00000Sooooo`03o`000?oooooooooo
04Gooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo
04;ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
03;ooooo000Vooooo`03o`000?oooooo000002?ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0<oooool002Kooooo
00Co0000oooooooooooo00008Oooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo04So
oooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0dooooo`009_ooool01?l0003ooooo
ooooool0000Qooooo`03o`000?oooooooooo04Kooooo00?o0000ooooooooool0B?ooool00ol0003o
ooooooooo`12ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`0Fooooo`03o`000?oooooooooo03Gooooo000Vooooo`05o`000?ooooooooooooooool0
00007oooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo04Sooooo00?o0000oooooooo
ool0@_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0fooooo`009_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`18ooooo`03o`00
0?oooooooooo04;ooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo01Cooooo00?o0000ooooooooool0=oooool002Kooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0B?oo
ool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03Sooooo000Vooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`19ooooo`03o`000?oooooo
oooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`18ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0iooooo`009_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0B_ooool00ol0
003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0BOooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0>_ooool002Ko
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo04[o
oooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo04[o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03_o
oooo000Vooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`1;ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003ooooo
ooooo`1;ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`0looooo`009_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0Boooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o
0000ooooooooool0?Oooool002Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo03kooooo000Vooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04Sooooo00?o0000oooo
ooooool0@_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0nooooo`009_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`18ooooo`03
o`000?oooooooooo04;ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool0?oooool002Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0
B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043ooooo000Vooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo04Sooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`11ooooo`009_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Coooool0
0ol0003oooooooooo`18ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0@_ooool0
02Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
053ooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo
05;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
04?ooooo000Sooooo`Koi^KV2_ooool01?l0003oooooooooooooool6onKViPCooooo00?o0000oooo
ooooool0COooool6onKViTGooooo1_oVi^Hoooooo`Koi^KVDoooool00ol0003oooooooooo`05oooo
o`Koi^KV1_ooool00ol0003oooooooooo`14ooooo`008?ooool<onKViPSooooo3?oVi^H00ol0003o
ooooooooo`1;ooooo`coi^KV?oooool<onKViSWooooo3?oVi^IAooooo`04o`000?oooooooooooooo
o`coi^KV0_ooool00ol0003oooooooooo`15ooooo`007oooool>onKViPKooooo3_oVi^I<ooooo`ko
i^KV?Oooool>onKViSOooooo3_oVi^IAooooo`03o`000?ooooooi^KV00goi^KV00?o0000oooooooo
ool0A_ooool001kooooo4?oVi^H4oooooa3oi^KVB_ooool@onKViS_ooooo4?oVi^Heoooooa3oi^KV
DOooool@onKViTSooooo000Moooooa;oi^KV0_oooolBonKViTSooooo4_oVi^Hioooooa;oi^KV<ooo
oolBonKViToooooo4_oVi^I7ooooo`007?oooolXonKViTKooooo5?oVi^HgoooooaCoi^KV<OoooolD
onKViTgooooo5?oVi^I6ooooo`007?oooolXonKViTKooooo5?oVi^HgoooooaCoi^KV<OoooolDonKV
iTgooooo5?oVi^I6ooooo`007?oooolXonKViTKooooo5?oVi^HgoooooaCoi^KV<OoooolDonKViTgo
oooo5?oVi^I6ooooo`003oooool4o`0000Sooooo2?oVi^H6o`0000koi^KV1_l00008onKViQGooooo
1Ol0000Nooooo`Co00002?ooool8onKViPKo00001_oVi^H9ooooo`Co00002_ooool4o`00013ooooo
1_l00006ooooo`Soi^KV1ol00007onKViQKooooo1Ol0000Dooooo`Soi^KV1ol00006onKViPSooooo
1Ol0000@ooooo`Co00002_ooool5o`0001cooooo1ooVi^H6o`0000Woi^KVAOooool000kooooo0_l0
000;ooooo`Woi^KV1?l0000@onKViPCo00002OoVi^HFooooo`;o000000?oooooo`000?l000007_oo
ool2o`0000Wooooo2OoVi^H4o`0000Ooi^KV2?ooool2o`0000;ooooo0_l0000:ooooo`;o00004_oo
ool2o`000003ooooool0003o000000Kooooo2OoVi^H2o`000003onKVi_l0003o000000Soi^KV5Ooo
ool2o`000003ooooool0003o000001Gooooo2OoVi^H2o`000003onKVi_l0003o000000Ooi^KV2Ooo
ool2o`000003ooooool0003o0000013ooooo0_l0000:ooooo`;o000000?oooooo`000?l000007Ooo
ool8onKViPCo00002_oVi^I5ooooo`003_ooool6o`0000Oooooo2OoVi^H3o`00017oi^KV0ol0000:
onKViQKooooo0_l000000ooooooo0000o`00000Nooooo`;o00002Oooool9onKViP?o00002?oVi^H<
ooooo`;o00002_ooool2o`0001?ooooo0_l00008ooooo`Woi^KV0_l000000ooVi^Ko0000o`000008
onKViQKooooo1?l0000Eooooo`Woi^KV0_l000000ooVi^Ko0000o`000007onKViPWooooo0_l00000
0ooooooo0000o`00000@ooooo`;o00002_ooool2o`000003ooooool0003o000001gooooo2?oVi^H3
o`0000_oi^KVAOooool000kooooo0_l00002ooooo`;o00001oooool9onKViPCo00004?oVi^H4o`00
00Woi^KV5_ooool2o`000003ooooool0003o000001kooooo0_l00009ooooo`Woi^KV1?l00007onKV
iP[ooooo0ol0000;ooooo`;o00005?ooool2o`0000Oooooo2OoVi^H2o`000003onKVi_l0003o0000
00Soi^KV5Oooool2o`000003ooooool0003o000001Gooooo2OoVi^H2o`000003onKVi_l0003o0000
00Ooi^KV2Oooool2o`000003ooooool0003o0000013ooooo0_l0000:ooooo`;o000000?oooooo`00
0?l000007Oooool8onKViPCo00002_oVi^I5ooooo`003oooool4o`0000Sooooo2OoVi^H5o`0000oo
i^KV1Ol00008onKViQKooooo1?l0000Oooooo`;o00002Oooool9onKViPGo00001_oVi^H<ooooo`;o
00002_ooool2o`00017ooooo0_l00002ooooo`;o00001_ooool9onKViPCo00002OoVi^HFooooo`?o
00005_ooool9onKViPCo00002?oVi^H9ooooo`Co00004Oooool2o`0000_ooooo1?l0000Mooooo`So
i^KV1Ol00009onKViTGooooo000Kooooo`Woi^KV0_l0000BonKViP;o00002ooVi^HFooooo`;o0000
8?ooool3o`0000Wooooo2OoVi^H2o`0000Woi^KV2?ooool2o`0000;ooooo0_l00009ooooo`?o0000
4Oooool2o`0000;ooooo0_l00006ooooo`Woi^KV0_l0000;onKViRoooooo2OoVi^H2o`0000[oi^KV
2Oooool2o`0001;ooooo0ol0000=ooooo`;o00007Oooool8onKViP;o00003?oVi^I5ooooo`007?oo
ool7onKViP?o00004OoVi^H3o`0000[oi^KV5_ooool3o`00027ooooo0_l0000:ooooo`Ooi^KV0ol0
000:onKViPSooooo1?l0000;ooooo`;o00004_ooool4o`0000Sooooo1ooVi^H3o`0000[oi^KV<Ooo
ool7onKViP?o00002_oVi^H8ooooo`?o00004oooool2o`0000cooooo0ol0000Nooooo`Koi^KV0ol0
000;onKViTKooooo000LooooobSoi^KVA_oooolDonKViSOooooo5?oVi^HaoooooaCoi^KVCOoooolD
onKViTKooooo000LooooobSoi^KVA_oooolDonKViSOooooo5?oVi^HaoooooaCoi^KVCOoooolDonKV
iTKooooo000Moooooa;oi^KV0_oooolBonKViTSooooo4_oVi^Hioooooa;oi^KV<ooooolBonKViToo
oooo4_oVi^I7ooooo`007_ooool@onKViPCooooo4?oVi^I:oooooa3oi^KV>oooool@onKViSGooooo
4?oVi^IAoooooa3oi^KVB?ooool001oooooo3_oVi^H6ooooo`koi^KV7?ooool00ol0003ooooooooo
o`0]ooooo`koi^KV?Oooool>onKViQcooooo00?o0000ooooooooool06?ooool>onKViU?ooooo3_oV
i^I9ooooo`008?ooool<onKViPSooooo3?oVi^HMooooo`03o`000?oooooooooo02kooooo3?oVi^Ho
ooooo`coi^KV7Oooool00ol0003oooooooooo`0Iooooo`coi^KVEOooool<onKViT[ooooo000Doooo
o`03o`000?oooooooooo00cooooo1_oVi^H>ooooo`Koi^KV8?ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00cooooo1_oVi^HRooooo`03o`000?oooooooooo023ooooo1_oVi^HPoooo
o`03o`000?oooooooooo01cooooo1_oVi^H00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool08?ooool00ol0003oi^KVonKViP04onKViTgooooo000Eooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo057ooooo000Eooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo05;ooooo000Eooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Tooooo`03o`000?oo
oooooooo02?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo02Cooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Nooooo`03o`000?oo
oooooooo05;ooooo000Fooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo05;ooooo000Fooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
05?ooooo000Fooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09?ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo05?ooooo000Fooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo05?ooooo
000Gooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo05Cooooo000Gooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo05Cooooo000Goooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo05Cooooo000Hooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05Cooooo000Hooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo05Gooooo000Hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo05Gooooo000Iooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo02Oooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo05Gooooo000Iooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo05Kooooo000Iooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo05Ko
oooo000Jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo05Kooooo000Jooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0:?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo05Oooooo000J
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo05Oooooo000Kooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo05Oooooo000Kooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo05Oooooo000Kooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo05Sooooo000Looooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo023ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo05Sooooo000Looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo05Sooooo000Looooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
05Wooooo000Looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo05Wooooo000Mooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo05Wooooo
000Mooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo05Wooooo000Mooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo05[ooooo000Noooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo02cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo02Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo05[ooooo000Nooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02cooooo00?o0000oooooooo
ool0;?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05[ooooo000Nooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo02cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo05_ooooo000Oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05_ooooo000Oooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo05_ooooo000Oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0^ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo05cooooo000Pooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05co
oooo000Pooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo05cooooo000Pooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02Sooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool0;_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0:?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05cooooo000Q
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05gooooo000Qooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ooooool0;oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05gooooo000Qooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo05gooooo000Qooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`00000booooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000002gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000003;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool00000;Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05kooooo000R
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0`ooooo`03o`000?oo
oooooooo033ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo02cooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool0<?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0;?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05kooooo000Rooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00Go0000oooo
ooooooooooooo`000003ooooo`03o`000?oooooooooo02cooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0<?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo05kooooo000Rooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`0aooooo`03o`000?oooooooooo033ooooo00Go0000ooooooooooooooooo`000002ooooo`03
o`000?oooooooooo02gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool0<?ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05oooooo000Soooo
o`Koi^KV00?o0000ooooooooool0;_ooool6onKViS7ooooo1_oVi^H00ol0003oooooooooo`0^oooo
o`Koi^KV00?o0000ooooooooool0;_ooool6onKViS7ooooo1_oVi^H00ol0003oooooooooo`0^oooo
o`Koi^KV00?o0000ooooooooool0Goooool0023ooooo3?oVi^H[ooooo`coi^KV:oooool<onKViR_o
oooo3?oVi^H[ooooo`coi^KV:oooool<onKViR_ooooo3?oVi^IOooooo`007oooool>onKViRWooooo
3_oVi^HYooooo`koi^KV:Oooool>onKViRWooooo3_oVi^HYooooo`koi^KV:Oooool>onKViUkooooo
000Noooooa3oi^KV9oooool@onKViROooooo4?oVi^HWoooooa3oi^KV9oooool@onKViROooooo4?oV
i^HWoooooa3oi^KVGOooool001gooooo4_oVi^HUoooooa;oi^KV9OoooolBonKViRGooooo4_oVi^HU
oooooa;oi^KV9OoooolBonKViRGooooo4_oVi^ILooooo`007?oooolDonKViR?ooooo5?oVi^HSoooo
oaCoi^KV8ooooolDonKViR?ooooo5?oVi^HSoooooaCoi^KV8ooooolDonKViU_ooooo000LoooooaCo
i^KV8ooooolDonKViR?ooooo5?oVi^HSoooooaCoi^KV8oooool8onKViPCo00002?oVi^HSoooooaCo
i^KV8ooooolDonKViU_ooooo000LoooooaCoi^KV8ooooolDonKViR?ooooo5?oVi^HSoooooaCoi^KV
8oooool;onKViP;o00001ooVi^HSoooooaCoi^KV8ooooolDonKViU_ooooo000Kooooo`Soi^KV1_l0
0008onKViR7ooooo2?oVi^H7o`0000Ooi^KV8Oooool8onKViPKo00002?oVi^HQooooo`Soi^KV1_l0
0008onKViR7ooooo2OoVi^H5o`0000Soi^KV8Oooool8onKViPKo00002?oVi^HQooooo`Soi^KV1_l0
0008onKViU[ooooo000Kooooo`[oi^KV0_l0000:onKViR7ooooo2OoVi^H2o`000003onKVi_l0003o
000000Soi^KV8Oooool:onKViP;o00002_oVi^HQooooo`Woi^KV1?l00009onKViR7ooooo2?oVi^H2
o`0000;oi^KV0_l00008onKViR7ooooo2_oVi^H2o`0000[oi^KV8Oooool:onKViP;o00002_oVi^IJ
ooooo`006oooool:onKViP;o00002_oVi^HQooooo`Woi^KV0_l000000ooVi^Ko0000o`000008onKV
iR7ooooo2_oVi^H2o`0000[oi^KV8Oooool9onKViP?o00002_oVi^HQooooo`Soi^KV0_l00002onKV
iP;o00002?oVi^HQooooo`[oi^KV0_l0000:onKViR7ooooo2_oVi^H2o`0000[oi^KVF_ooool001_o
oooo2_oVi^H2o`0000[oi^KV8Oooool9onKViP;o000000?oi^KVo`000?l000002?oVi^HQooooo`[o
i^KV0_l0000:onKViR7ooooo2OoVi^H4o`0000Woi^KV8Oooool8onKViP;o00000_oVi^H2o`0000So
i^KV8Oooool:onKViP;o00002_oVi^HQooooo`[oi^KV0_l0000:onKViU[ooooo000Kooooo`Woi^KV
1Ol00008onKViR7ooooo2OoVi^H4o`0000Woi^KV8Oooool9onKViPGo00002?oVi^HQooooo`Woi^KV
1Ol00008onKViR7ooooo2OoVi^H6o`0000Ooi^KV8Oooool9onKViPGo00002?oVi^HQooooo`Woi^KV
1Ol00008onKViU[ooooo000Kooooo`[oi^KV0_l0000:onKViR7ooooo2OoVi^H2o`0000_oi^KV8Ooo
ool:onKViP;o00002_oVi^HQooooo`Woi^KV0_l0000;onKViR7ooooo5_oVi^HQooooo`[oi^KV0_l0
000:onKViR7ooooo2_oVi^H2o`0000[oi^KVF_ooool001cooooo2_oVi^H3o`0000Ooi^KV0_l0000Q
ooooo`Ooi^KV0ol0000:onKViR?ooooo2_oVi^H3o`0000Ooi^KV8oooool7onKViP?o00002_oVi^HS
oooooaCoi^KV8oooool:onKViP?o00001ooVi^HRooooo`03o`000?oVi^Koi^KV00Soi^KV0ol00007
onKViU_ooooo000LoooooaCoi^KV0_ooool3o`0001kooooo5?oVi^HSoooooaCoi^KV8ooooolDonKV
iR?ooooo5?oVi^HSoooooaCoi^KV7oooool3o`000003oooooooVi^Koi^KV01;oi^KVFoooool001co
oooo5?oVi^H5ooooo`;o00007?oooolDonKViP;o00008OoooolDonKViR?ooooo5?oVi^HSoooooaCo
i^KV8_ooool00ol0003oi^KVonKViP0BonKViQgooooo0_l00004oooooaCoi^KVFoooool001gooooo
4_oVi^H8ooooo`;o00006ooooolBonKViP?ooooo00?o0000ooooooooool07ooooolBonKViRGooooo
4_oVi^HUoooooa;oi^KV8_ooool00ol0003oooooooooo`0BonKViQcooooo0_l00007oooooa;oi^KV
G?ooool001kooooo4?oVi^H;ooooo`?o00006Oooool@onKViPGooooo0_l0000Poooooa3oi^KV9ooo
ool@onKViROooooo4?oVi^HQooooo`;o00001?ooool@onKViQ[ooooo0ol0000:oooooa3oi^KVGOoo
ool001oooooo3_oVi^H?ooooo`;o00006?ooool>onKViPSooooo0_l0000Oooooo`koi^KV00?o0000
ooooooooool09_ooool>onKViRWooooo3_oVi^HPooooo`;o00001oooool>onKViQWooooo0_l0000>
ooooo`koi^KVG_ooool0023ooooo3?oVi^HBooooo`?o00005_ooool<onKViP_ooooo00?o0000oooo
ooooool07Oooool<onKViP;ooooo00?o0000ooooooooool09_ooool<onKViRWooooo00?o0000oooo
oooVi^H02ooVi^HPooooo`03o`000?oooooooooo00Sooooo3?oVi^HGooooo`?o00004Oooool<onKV
iUoooooo000Sooooo`Koi^KV6?ooool2o`0001Oooooo1_oVi^H?ooooo`;o00008?ooool6onKViPKo
oooo00?o0000ooooooooool0:?ooool6onKViR_ooooo00?o0000ooooooooool00oooool6onKViR7o
oooo0_l0000>ooooo`Koi^KV6?ooool2o`0001Oooooo1_oVi^IRooooo`00@oooool3o`0002_ooooo
0_l0000Zooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Xooooo`;o0000:oooool3o`00087ooooo0016ooooo`;o0000:oooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02Wooooo0_l00024ooooo`00B?ooool3o`0002Wooooo0_l0000Y
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0W
ooooo`;o0000:Oooool3o`0008Kooooo001;ooooo`;o0000:Oooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo02Oooooo0_l00029ooooo`00COooool3o`0002Oooooo0_l0000Xooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Vooooo`;o
00009oooool3o`0008_ooooo001@ooooo`;o00009oooool2o`0002Oooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Gooooo0_l0000Wooooo`;o0000
S_ooool005;ooooo0ol0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?oo
ool3o`00093ooooo001Eooooo`;o00009Oooool2o`0002Gooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02?ooooo0_l0000Uooooo`;o0000Toooool0
05Oooooo0_l0000Uooooo`;o00009?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool08_ooool2o`0002Gooooo0_l0002Eooooo`00FOooool3o`0002Co
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`?o0000Uoooool005cooooo
0_l0000Sooooo`;o00008oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool08Oooool2o`0002?ooooo0_l0002Jooooo`00G_ooool3o`0002;ooooo0_l0
000Qooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0Oooooo`;o00008_ooool3o`0009cooooo001Qooooo`;o00008_ooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo023ooooo0_l0002Oooooo`00Hoooool3o`00023ooooo0_l0000Poooo
o`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Noooo
o`;o00008?ooool3o`000:7ooooo001Vooooo`;o00008?ooool2o`0001oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01gooooo0_l0000Pooooo`;o
0000Y?ooool006Sooooo0ol0000Oooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool3o`000:Kooooo001[ooooo`;o00007_ooool2o`0001kooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01cooooo0_l0000Nooooo`;o0000ZOoo
ool006gooooo0ol0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool3
o`000:_ooooo001`ooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01[ooooo0_l0000Looooo`;o0000[_ooool007;o
oooo0ol0000Kooooo`;o00006oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol0002`ooooo`00MOooool2o`0001_ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`;o0000/oooool007Oooooo0ol0
000Iooooo`;o00006_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool06?ooool2o`0001Wooooo0ol0002eooooo`00N_ooool2o`0001Wooooo0_l0000I
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0G
ooooo`;o00006Oooool2o`000;Sooooo001looooo`;o00006Oooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo01Oooooo0_l0002jooooo`00O_ooool3o`0001Oooooo0_l0000Gooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Eooooo`;o
00005oooool3o`000;cooooo0021ooooo`;o00005oooool2o`0001Kooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Cooooo0_l0000Gooooo`;o0000
_oooool008?ooooo0ol0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?oo
ool3o`000<7ooooo0026ooooo`;o00005Oooool2o`0001Gooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01?ooooo0_l0000Eooooo`;o0000a?ooool0
08Sooooo0ol0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool3o`00
0<Kooooo002;ooooo`;o00004oooool2o`0001?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo017ooooo0_l0000Cooooo`;o0000bOooool008gooooo
0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04?ooool2o`0001;ooooo0ol0003;ooooo`00T?ooool2o`0001;ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000c_ooool009;ooooo0ol0000@
ooooo`;o00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool03oooool2o`00013ooooo0ol0003@ooooo`00UOooool2o`00013ooooo0_l0000@oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0>oooo
o`;o00004?ooool2o`000=?ooooo002Gooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo0ol0003Eooooo`00V_ooool2o`0000kooooo0_l0000>ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0<ooooo`;o0000
3_ooool2o`000=Sooooo002Looooo`;o00003_ooool2o`0000gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00_ooooo0_l0000>ooooo`;o0000f_oo
ool009kooooo0ol0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool3
o`000=cooooo002Qooooo`;o00003?ooool2o`0000cooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo0_l0000<ooooo`;o0000goooool00:?o
oooo0ol0000;ooooo`;o00002_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02?ooool2o`0000_ooooo0ol0003Qooooo`00Y_ooool2o`0000_ooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`;o0000i?ooool00:Sooooo0ol0
0009ooooo`;o00002Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool01oooool2o`0000Wooooo0ol0003Vooooo`00Zoooool2o`0000Wooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`;o0000jOooool00:gooooo0ol00007oooo
o`;o00002?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool2o`0000Oooooo0ol0003[ooooo`00/?ooool2o`0000Oooooo0_l00007ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`;o
00001oooool2o`000>kooooo002booooo`?o00001_ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo1_oVi^H6ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool3o`000?3ooooo002eooooo`;o00001Oooool2o`0000Gooooo00?o0000oooooooVi^H02ooV
i^H2ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`;o0000loooool00;Oooooo0ol00004
ooooo`;o00001?ooool>onKViP03o`000?oooooooooo00;ooooo0_l00004ooooo`?o0000mOooool0
0;[ooooo0_l00004ooooo`03o`000?oooooooooo013oi^KV0oooool00ol0003oooooooooo`02oooo
o`;o0000n?ooool00;cooooo0_l00003ooooo`03o`000?oVi^Koi^KV013oi^KV0_l00003ooooo`;o
0000n_ooool00;kooooo0ol0000DonKViP04ooooool0003o0000o`000?cooooo0031ooooo`Soi^KV
1?l00008onKViP03o`000?oooooooooo0?gooooo0031ooooo`_oi^KV0_l00007onKVi_oooooo0Ooo
ool00<3ooooo2OoVi^H5o`0000Soi^KVooooool00<3ooooo2?oVi^H2o`0000;oi^KV0_l00008onKV
i_oooooo0030ooooo`Soi^KV0_l00002onKViP;o00002?oVi^Koooooo`00`?ooool8onKViP;o0000
0_oVi^H2o`0000Soi^KVooooool00<3ooooo2OoVi^H6o`0000Ooi^KVooooool00<3ooooo5_oVi^Ko
ooooo`00`OoooolDonKVi_oooooo0Oooool00<7ooooo5?oVi^Koooooo`7ooooo0031oooooaCoi^KV
ooooool1ooooo`00`_oooolBonKVi_oooooo0_ooool00<?ooooo4?oVi^Koooooo`?ooooo0034oooo
o`koi^KVooooool4ooooo`00aOooool<onKVi_oooooo1Oooool00<Sooooo1_oVi^Koooooo`Sooooo
0000\
\>"],
  ImageRangeCache->{{{0, 468.438}, {289.125, 0}} -> {-2.46149, -0.82718, \
0.0121106, 0.00297852}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", \({3, 1}\)},
            {"1", \({4, 1}\)},
            {"1", \({6, 3}\)},
            {"2", \({4, 2}\)},
            {"2", \({7, 2, 2}\)},
            {"3", \({3, 3}\)},
            {"3", \({1, 2, 1}\)},
            {"3", \({7, 2, 3}\)},
            {"3", \({1, 3, 2, 1}\)},
            {"a", \({5, 1}\)},
            {"a", \({6, 1, 1}\)},
            {"b", \({2, 1}\)},
            {"b", \({6, 2}\)},
            {"b", \({1, 3, 1}\)},
            {"b", \({7, 2, 1, 1}\)},
            {"c", \({4, 3, 1}\)},
            {"d", \({7, 1}\)},
            {"e", \({1, 1}\)},
            {"e", \({3, 2, 1}\)},
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[1, k[e], 3]\), \({3}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)},
            {\(f[h[a], b, 1]\), \({6}\)},
            {\(g[3]\), \({1, 3, 2}\)},
            {\(g[a]\), \({5}\)},
            {\(g[f[e, k[3], k[b, g[3]]], h[b], f[1, k[e], 3], k[1, 2, h[c]], 
                g[a], f[h[a], b, 1], f[d, k[h[b], 2, 3]]]\), \({}\)},
            {\(h[a]\), \({6, 1}\)},
            {\(h[b]\), \({2}\)},
            {\(h[b]\), \({7, 2, 1}\)},
            {\(h[c]\), \({4, 3}\)},
            {\(k[3]\), \({1, 2}\)},
            {\(k[e]\), \({3, 2}\)},
            {\(k[b, g[3]]\), \({1, 3}\)},
            {\(k[1, 2, h[c]]\), \({4}\)},
            {\(k[h[b], 2, 3]\), \({7, 2}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_Symbol}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"a", \({5, 1}\)},
            {"a", \({6, 1, 1}\)},
            {"b", \({2, 1}\)},
            {"b", \({6, 2}\)},
            {"b", \({1, 3, 1}\)},
            {"b", \({7, 2, 1, 1}\)},
            {"c", \({4, 3, 1}\)},
            {"d", \({7, 1}\)},
            {"e", \({1, 1}\)},
            {"e", \({3, 2, 1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_f}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[1, k[e], 3]\), \({3}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)},
            {\(f[h[a], b, 1]\), \({6}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_f}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[1, k[e], 3]\), \({3}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)},
            {\(f[h[a], b, 1]\), \({6}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_f, _k}]  // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[1, k[e], 3]\), \({3}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr, {_f, _k, _Integer}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
exprInstances[symbExpr,
  {_f, k[x__/;Length[{x}]>2], _Integer}] // TT // MM\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Expressions Contained in Expressions Contained in Expressions ...\
\
\>", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TT = Transpose; MM = MatrixForm;", "Input",
  AspectRatioFixed->True,
  CellTags->"Embedded structure selection"],

Cell["\<\
symbExpr =
 g[
   f[e, k[3], k[b, g[3]]],
   h[b],
   f[1, k[e], 3],
   k[1, 2, h[c]],
   g[a],
   f[h[a], b, 1],
   f[d, k[h[b], 2, 3]]
   
 ];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr,{_f, _k, _Symbol}] // TT // MM", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(f[d, k[h[b], 2, 3]]\), \({7}\)},
            {\(f[1, k[e], 3]\), \({3}\)},
            {\(f[e, k[3], k[b, g[3]]]\), \({1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr,{_f, \[Section] _k, _Symbol}] // TT // MM", \
"Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(k[e]\), \({3, 2}\)},
            {\(k[b, g[3]]\), \({1, 3}\)},
            {\(k[h[b], 2, 3]\), \({7, 2}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprInstances[symbExpr,{_f, _k, \[Section] _Symbol}] // TT // MM", \
"Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"b", \({1, 3, 1}\)},
            {"b", \({7, 2, 1, 1}\)},
            {"d", \({7, 1}\)},
            {"e", \({1, 1}\)},
            {"e", \({3, 2, 1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
exprInstances[symbExpr,
  {_f, _k, \[Section] x_Symbol /; MemberQ[{a,b,c},x]}] // TT // MM\
\>", \
"Input",
  AspectRatioFixed->True],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"b", \({1, 3, 1}\)},
            {"b", \({7, 2, 1, 1}\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hierarchical Pattern Extraction: The Basic Idea", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "In the following example we illustrate the basic idea of hierarchical \
pattern extraction. Let us assume we want to extract any expression with head \
",
  StyleBox["f",
    FontWeight->"Bold"],
  ", that contains an expression with head ",
  StyleBox["k",
    FontWeight->"Bold"],
  ", that in turn contains an ",
  StyleBox["integer",
    FontWeight->"Bold"],
  ". In other words, we are looking for an ",
  StyleBox["f",
    FontWeight->"Bold"],
  "-expression with a ",
  StyleBox["k",
    FontWeight->"Bold"],
  "-subexpression, which, in turn, has an ",
  StyleBox["integer",
    FontWeight->"Bold"],
  " as a subexpression."
}], "Text"],

Cell["\<\
We set up a list of the hierarchical patterns (for the \
subexpressions) we are looking for:\
\>", "Text"],

Cell["thePatterns = {_f, _k, _Integer};", "Input",
  AspectRatioFixed->True],

Cell["\<\

In order to create a threaded pattern, we need a list of unique \
variables.\
\>", "Text"],

Cell[CellGroupData[{

Cell["uniqueVariables = Table[Unique[x],{Length[thePatterns]-1}]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({x$200, x$201}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Here is how we construct a threaded pattern list, with ",
  StyleBox["f ",
    FontWeight->"Bold"],
  "and ",
  StyleBox["k",
    FontWeight->"Bold"],
  " as respective heads."
}], "Text"],

Cell[CellGroupData[{

Cell["\<\
threadedPats = 
  MapThread[
    Hold[Condition[Pattern[#2,#1],
                   MemberQ[#2, innerTempl, Infinity]]]&,
    {Drop[thePatterns,-1],uniqueVariables}
  ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({Hold[x$200_f /; MemberQ[x$200, innerTempl, \[Infinity]]], 
      Hold[x$201_k /; MemberQ[x$201, innerTempl, \[Infinity]]]}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "We then append the ",
  StyleBox["_Integer",
    FontWeight->"Bold"],
  " pattern."
}], "Text"],

Cell[CellGroupData[{

Cell["AppendTo[threadedPats, Last[thePatterns]]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({Hold[x$200_f /; MemberQ[x$200, innerTempl, \[Infinity]]], 
      Hold[x$201_k /; 
          MemberQ[x$201, innerTempl, \[Infinity]]], _Integer}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["threadedPats", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({Hold[x$200_f /; MemberQ[x$200, innerTempl, \[Infinity]]], 
      Hold[x$201_k /; 
          MemberQ[x$201, innerTempl, \[Infinity]]], _Integer}\)], "Output"]
}, Open  ]],

Cell["\<\
The function to build the final hierarchical template is defined as \
follows:\
\>", "Text"],

Cell["\<\
buildTemplate[pats_List] :=
    Fold[(#1 /. {innerTempl -> #2})&, 
      pats//First, Drop[pats,1]] //. {Hold[x_] :> x}\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\
 
Now we apply this function to our threaded patterns.\
\>", "Text"],

Cell[CellGroupData[{

Cell["theTemplate = buildTemplate[threadedPats]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(x$200_f /; 
      MemberQ[x$200, 
        x$201_k /; 
          MemberQ[x$201, _Integer, \[Infinity]], \[Infinity]]\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "A simple application of the ",
  StyleBox["Cases",
    FontWeight->"Bold"],
  " function, together with the hierachical template, extracts the two \
expressions, that meet the criterion described above."
}], "Text"],

Cell[CellGroupData[{

Cell["\<\
Cases[
  {f[k[h[3]]], g[4], f[a, h[g[b, k[1]]], c], f[g[d]]}, 
  theTemplate]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({f[k[h[3]]], f[a, h[g[b, k[1]]], c]}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Both extracted expressions are ",
  StyleBox["f",
    FontWeight->"Bold"],
  "-expressions, that contain a ",
  StyleBox["k",
    FontWeight->"Bold"],
  "-expression, that contains an integer. Note that the subexpressions can \
appear at any level within the surrounding expression."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Implementation", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Simple Selection of Substructures", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[exprInstances]", "Input",
  AspectRatioFixed->True],

Cell["\<\
exprInstances[expr_, pat_, opts___] :=
Module[{},
  
   {Cases[expr, pat, {0, Infinity}, 
      Heads -> (Heads /. {opts} /. Options[exprInstances])],
    Position[expr, pat, {0, Infinity}, 
      Heads -> (Heads /. {opts} /. Options[exprInstances])]}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[exprInstances] =
{
  Heads -> False
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Example ...", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["exprInstances[f[a,g[b]], _]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({{a, b, g[b], f[a, g[b]]}, {{1}, {2, 1}, {2}, {}}}\)], "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Hierarchical, Weighted Templates and Selection of \
Substructures\
\>", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Hierarchical Selection of Substructures with Masked Templates\
\>", \
"Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprInstances[expr_, patternList_List, opts___] :=
Module[{retIndex, newPatsList},

  retIndex = returnIndex[patternList];
  newPatsList = 
    patternList //. {Times[x___,\[Section],y___] :> Times[x,y]};
  
  exprExtraction[expr, newPatsList, retIndex, opts]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Hierarchical Selection of Substructures", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Pattern Extraction Function: exprExtraction", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[exprExtraction]", "Input",
  AspectRatioFixed->True],

Cell[TextData[{
  "exprExtraction[expr_, patsList_List, \n               retIndex_Integer:1, \
opts___] :=\n\nModule[{vars, threadedPats, template, innerTempl,\n        \
idExprs, idPos, buildTemplate, retTemplate,\n        retExprs, retPos, \
theExprs, thePos},\n  \n  ",
  StyleBox["(* Unique list of variables *)\n  ",
    FontSlant->"Italic"],
  "\n  vars = Table[Unique[x],{Length[patsList]-1}];\n  \n  ",
  StyleBox["(* Function to build up recursive templates *)\n  ",
    FontSlant->"Italic"],
  "\n  buildTemplate[pats_List] :=\n    Fold[(#1 /. {innerTempl -> #2})&, \n  \
    pats//First, Drop[pats,1]] //. {Hold[x_] :> x};\n      \n  ",
  StyleBox["(* Construct a sub-template for each pattern given, *)\n  (* \
except the last one                              *)\n  ",
    FontSlant->"Italic"],
  "\n  threadedPats = \n  MapThread[\n    Hold[Condition[Pattern[#2,#1],\n    \
               MemberQ[#2, innerTempl, Infinity]]]&,\n    \
{Drop[patsList,-1],vars}\n  ];\n  \n  ",
  StyleBox["(* Append the last pattern which needs no recursive *)\n  (* \
template                                         *)\n  ",
    FontSlant->"Italic"],
  "\n  AppendTo[threadedPats, Last[patsList]];\n  \n  ",
  StyleBox["(* Construct the recursive template and ... *)\n  (* search for \
matching expressions          *)\n  ",
    FontSlant->"Italic"],
  "\n  template = buildTemplate[threadedPats];\n  \n  {idExprs, idPos} = \n  \
exprInstances[expr, template, opts];\n  \n  ",
  StyleBox["(* For the (sub-)expression to be returned we again *)\n  (* have \
to search among the matching expressions    *)\n  ",
    FontSlant->"Italic"],
  "\n  retTemplate =\n    buildTemplate[Drop[threadedPats,retIndex-1]];\n  \n \
 {retExprs, retPos} = Transpose[\n  Map[exprInstances[#, retTemplate, opts]&, \
idExprs]];\n  \n  ",
  StyleBox["(* As the Outer function does not cope with nested *)\n  (* lists \
properly, we have to find a work around   *)\n  (* by inserting a dummy LIST \
header, which will be *)\n  (* replaced after applying the Outer function     \
 *)\n  ",
    FontSlant->"Italic"],
  "\n  ",
  StyleBox["(* Finally, return the matching sub-expressions *)\n  (* together \
with their positions                *)\n  ",
    FontSlant->"Italic"],
  "\n  Attributes[LIST] = {Flat};\n  \n  {theExprs, thePos} =\n  {retExprs,\n \
  Flatten[\n     MapThread[Outer[LIST,#1,#2]&,\n       {idPos /. \
{{x___Integer} :> {LIST[x]}},\n        retPos /. {{x___Integer} :> LIST[x]}}\n\
     ] /. {LIST -> List}, 1]\n  };\n  \n  Transpose[Union[Flatten[\n    \
MapThread[MapThread[List,{#1,#2}]&,{theExprs, thePos}],\n    1]\n  ]]\n]"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Extending the Definition of Outer", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Unprotect[Outer];

Outer[f_, x_List, {}]   := {f /@ x}
Outer[f_, x_List, {{}}] := {f /@ x}

Protect[Outer];\
\>", "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Calculating the Returned Index", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
returnIndex[patList_List] :=
Module[{pos},

  If[(pos = Position[patList, \[Section]]) === {}, 
    1, pos//First//First]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples ...", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theExpr =
 f[
   g[a],
   h[b,g[d]],
   k[3]
 ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(f[g[a], h[b, g[d]], k[3]]\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["T = Transpose; M = MatrixForm;", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Set::"wrsym" \(\(:\)\(\ \)\) 
      "Symbol \!\(M\) is Protected."\)], "Message"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
{theExprs, thePos} =
exprInstances[theExpr, {_}, Heads -> False];

{theExprs, thePos} // T // M\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(M[{{3, {3, 1}}, {a, {1, 1}}, {b, {2, 1}}, {d, {2, 2, 1}}, {f[g[a], 
            h[b, g[d]], k[3]], {}}, {g[a], {1}}, {g[d], {2, 2}}, {h[b, 
            g[d]], {2}}, {k[3], {3}}}]\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
{theExprs, thePos} =
exprInstances[theExpr, {_, _}, Heads -> False];

{theExprs, thePos} // T // M\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(M[{{f[g[a], h[b, g[d]], k[3]], {}}, {g[a], {1}}, {g[d], {2, 2}}, {h[b, 
            g[d]], {2}}, {k[3], {3}}}]\)], "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection of Hierarchical, Weighted Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
The new expression ranks will be hierarchical:

{
  PRexpr[pattern1,rank1,{PRsubexprs}],
  PRexpr[pattern2,rank2,{PRexpr[pattern21,rank21,{}],
                                          PRexpr[pattern22,rank22,{}] 
                                        }],
  PRexpr[...], ...
}\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Note that in general pattern(i) is not only a single pattern but a \
pattern with restricting conditions ( p /; ... ).\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
TestexprMutationRANKS =
{
  PRexpr[_f,3,{PRexpr[_g,2,{}],PRexpr[_k,1,{}]}],
  PRexpr[_g,1,{}],
  PRexpr[_h,1,{}],
  PRexpr[_k,1,{}]
};\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\

This defines a function which returns a list of patterns due to a \
hierarchical pattern ranks description as above. The returned list of pattern \
descriptions {p(1),p(2),p(3),...} means that an expression has to be found \
where an expression satisfying p(i+1) is a subexpression of p(i).\
\>", "Text",\

  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patternSelection[{},opts___] = {};

patternSelection[patternsAndRanks_List,opts___] :=

Module[{
        selectedIndex, 
        selectedPattern,
        selectionFunction =
           PatternSelectionFunction /. {opts}     
           /.Options[patternSelection]},
  
  selectedIndex = 
    selectionFunction[Map[#[[2]]&,patternsAndRanks]];
    
  selectedPattern =
    First[Part[patternsAndRanks,selectedIndex]];
    
  {selectedPattern,
  patternSelection[
    Part[patternsAndRanks,selectedIndex][[3]]]}
   // Flatten
];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[patternSelection] :=
{
  PatternSelectionFunction -> rouletteWheelSelectionAttributesOnly
}\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Roulette-wheel Selection (Fitness-proportionate)", "Subsubsection"],

Cell["\<\

rouletteWheelSelection[rules_List,
                       attributes_List] :=

Module[ {members, totalsum, partsum, index, randpos},

\tmembers\t\t=\tLength[rules];
\ttotalsum\t= \tApply[Plus,attributes];
\tpartsum  \t= \tattributes[[1]];
\tindex    \t= \t1;
\t
\trandpos  \t=\tRandom[Real,totalsum];
\t
\tWhile[partsum < randpos && index < members,
\t
\t\tindex = index + 1;
\t\tpartsum = partsum + attributes[[index]];
\t\t
\t]; (* end while *)
\t
\tPrint[\"Selected rule: \",rules[[index]]];
\tindex

] (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\

rouletteWheelSelectionAttributesOnly[attributes_List] :=

Module[ {members, totalsum, partsum, index, randpos},

\tmembers\t\t=\tLength[attributes];
\ttotalsum\t= \tApply[Plus,attributes];
\tpartsum  \t= \tattributes[[1]];
\tindex    \t= \t1;
\t
\trandpos  \t=\tRandom[Real,{0,N[totalsum]}];
\t
\tWhile[partsum < randpos && index < members,
\t
\t\tindex = index + 1;
\t\tpartsum = partsum + attributes[[index]];
\t\t
\t]; (* end while *)
\t
\t(** Print[\"Selected index: \",index]; **)
\tindex

] (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Rank-based Selection", "Subsubsection"],

Cell["\<\

rankBasedSelection[ranks_Integer] :=

Module[ {totalsum, partsum, partsumTable, index, randpos},

\ttotalsum\t= \tSum[i,{i,1,ranks}];
        Print[\"totalsum: \",totalsum];
\tpartsumTable \t= \tTable[i,{i,ranks,1,-1}];
        Print[\"partsumTable: \",partsumTable];
\tpartsum\t\t=\tpartsumTable[[1]];
\tindex    \t= \t1;
\t
\trandpos  \t=\tRandom[Integer,{1,totalsum}];
\t
\tWhile[partsum < randpos && index < ranks,
\t
\t\tindex = index + 1;
\t\tpartsum = partsum + partsumTable[[index]];
\t\t
\t]; (* end while *)
\t
\t(** Print[\"Selected index: \",index]; **)
\tindex

]; (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\

rankBasedSelectionExp[ranks_Integer] :=

Module[ {totalsum, partsum, partsumTable, index, randpos},

\tpartsumTable \t= \tTable[N[Exp[-i]],{i,0,ranks-1,1}];
        Print[\"partsumTable: \",partsumTable];
\ttotalsum\t= \tSum[partsumTable[[i]],{i,1,ranks}];
        Print[\"totalsum: \",totalsum];

\tpartsum\t\t=\tpartsumTable[[1]];
\tindex    \t= \t1;
\t
\trandpos  \t=\tRandom[Real,{0,totalsum}];
\tPrint[\"randpos: \",randpos];

\tWhile[partsum < randpos && index < ranks,
\t
\t\tindex = index + 1;
\t\tpartsum = partsum + partsumTable[[index]];
\t\t
\t]; (* end while *)
\t
\t(** Print[\"Selected index: \",index]; **)
\tindex

]; (* end module *)
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Representation of Terms", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Conversion from Expressions to Terms", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprToTerm = {(f_/; Not[AtomQ[f]])[x___] :> \"EXPR\"[f,x]};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["TermPlot", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot Function", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
TermPlot[expr_, opts___] := 
  Show[Graphics[TermPlot0[expr, 0, 0, 1,opts]], 
    PlotRange -> All,
    DefaultFont -> {\"Courier-Bold\",10}]
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[TermPlot] =
{
  TreeWidth -> 1,
  TreeHeight -> 0.2,
  
  GridBranches -> False,
  
  ColorFunction -> GrayLevel,
  LineColor -> 0, 
  TextColor -> 0, TextFont -> {\"Courier-Bold\",10},
  LabelColor -> 0.9, LabelSize -> .05
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Utility Function: TermPlot0", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[TermPlot0]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(TermPlot0[expr_, x_, y_, n_, opts___] := 
      Block[{xl, xr, f$, c$, xi, gnew, gthis, dx, th, tw, colFun, lineCol, 
          textCol, textFnt, labelCol, lSize, 
          gridBran}, \[IndentingNewLine]\[IndentingNewLine]th = \(TreeHeight /. \
{opts}\) /. Options[
              TermPlot]; \[IndentingNewLine]tw = \(TreeWidth /. {opts}\) /. 
            Options[TermPlot]; \[IndentingNewLine]colFun = \(ColorFunction /. \
{opts}\) /. Options[
              TermPlot]; \[IndentingNewLine]lineCol = \(LineColor /. {opts}\) \
/. Options[TermPlot]; \[IndentingNewLine]textCol = \(TextColor /. {opts}\) /. 
            Options[TermPlot]; \[IndentingNewLine]textFnt = \(TextFont /. \
{opts}\) /. Options[
              TermPlot]; \[IndentingNewLine]labelCol = \(LabelColor /. {opts}\
\) /. Options[TermPlot]; \[IndentingNewLine]lSize = \(LabelSize /. {opts}\) /. 
            Options[TermPlot]; \[IndentingNewLine]gridBran = \(GridBranches /. \
{opts}\) /. Options[TermPlot]; \[IndentingNewLine]\[IndentingNewLine]f$ = 
          Head[expr]; \[IndentingNewLine]c$ = 
          List @@ expr; \ \[IndentingNewLine]\[IndentingNewLine]If[
          Length[c$] \[Equal] 1, \[IndentingNewLine]Return[
            Flatten[{colFun[lineCol], Line[{{x, y}, {x, y - th}}], 
                colFun[labelCol], PointSize[lSize], Point[{x, y}], 
                colFun[textCol], Text[FontForm[f$, textFnt], {x, y}], 
                TermPlot0[First[c$], x, y - th, 1, 
                  opts]}]]]; \[IndentingNewLine]\[IndentingNewLine]xl = 
          x - tw^\((Abs[y])\)\ 2/n; \ 
        xr = x + tw^\((Abs[y])\)\ 2/n; \ \ dx = 
          N[\((xr - xl)\)/\((Length[c$] - 
                  1)\)]; \[IndentingNewLine]\[IndentingNewLine]gnew = \
\[IndentingNewLine]Table[\[IndentingNewLine]If[\(! AtomQ[c$[\([i$ + 1]\)]]\), 
              TermPlot0[c$[\([i$ + 1]\)], xl + i$\ dx, y - th, Length[c$], 
                opts], {GrayLevel[1], PointSize[lSize], 
                Point[{xl + i$\ dx, y - th}], colFun[textCol], 
                Text[FontForm[c$[\([i$ + 1]\)], textFnt], {xl + i$\ dx, 
                    y - th}]}], \[IndentingNewLine]{i$, 0, 
              Length[c$] - 
                1}]; \ \[IndentingNewLine]\[IndentingNewLine]gthis = \
\[IndentingNewLine]If[
            gridBran, \[IndentingNewLine]Table[
              xi = xl + i\ dx; \ {colFun[lineCol], 
                Line[{{xi, y}, {xi, y - th}}]}, {i, 0, 
                Length[c$] - 1}], \[IndentingNewLine]Table[
              xi = xl + i\ dx; \ {colFun[lineCol], 
                Line[{{x, y}, {xi, y - th}}]}, {i, 0, 
                Length[c$] - 
                  1}]\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine]Flatten[\[IndentingNewLine]{gthis, 
            gnew, \[IndentingNewLine]If[
              gridBran, {colFun[lineCol], Line[{{xl, y}, {xr, y}}]}, {}], 
            colFun[labelCol], \[IndentingNewLine]If[
              f$ === "\<EXPR\>", \[IndentingNewLine]{PointSize[lSize], 
                Point[{x, y}], GrayLevel[0], PointSize[ .5\ lSize], 
                Point[{x, y}]}, {PointSize[lSize], Point[{x, y}], 
                colFun[textCol], 
                Text[FontForm[f$, textFnt], {x, 
                    y}]}\[IndentingNewLine]]\[IndentingNewLine]}\
\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell["\<\
TermPlot0[expr_, x_, y_, n_, opts___] :=
Block[{xl, xr, f$, c$, xi, gnew, gthis, dx, th, tw,
       colFun, lineCol, textCol, textFnt, labelCol, 
       lSize, gridBran},
\t\t
  th = TreeHeight /. {opts} /. Options[TermPlot];
  tw = TreeWidth /. {opts} /. Options[TermPlot];
  
  colFun = ColorFunction /. {opts} /. Options[TermPlot];
  lineCol = LineColor /. {opts} /. Options[TermPlot];
  textCol = TextColor /. {opts} /. Options[TermPlot];
  textFnt = TextFont /. {opts} /. Options[TermPlot];
  labelCol = LabelColor /. {opts} /. Options[TermPlot];
  lSize  = LabelSize /. {opts} /. Options[TermPlot];
  gridBran = GridBranches /. {opts} /. Options[TermPlot];
  
  f$ = Head[expr];
  c$ = List @@ expr; 
  If[Length[c$]==1, 
    Return[
      Flatten[
        { colFun[lineCol], Line[{{x, y}, {x, y-th}}],
          colFun[labelCol], PointSize[lSize], Point[{x,y}],
          colFun[textCol], Text[FontForm[f$,textFnt],{x,y}],
          TermPlot0[First[c$], x, y-th, 1,opts] } ] ] ] ;
          
  xl = x - tw^(Abs[y]) 2/n ; 
  xr = x + tw^(Abs[y]) 2/n ;  
  dx = N[(xr - xl)/(Length[c$] - 1)] ;
                
  gnew = 
  Table[ 
    If[!AtomQ[c$[[i$+1]]],
      TermPlot0[c$[[i$+1]], xl + i$ dx, y-th, Length[c$],opts], 
      {GrayLevel[1], PointSize[lSize], Point[{xl + i$ dx,y-th}],
       colFun[textCol],
       Text[FontForm[c$[[i$+1]],textFnt],{xl + i$ dx,y-th}]
      } ],  
    {i$, 0, Length[c$]-1} ] ; 
  
  gthis = 
  If[gridBran,
    Table[
      xi = xl + i dx ; 
      {colFun[lineCol], Line[{{xi, y}, {xi, y-th}}]}, 
      {i, 0, Length[c$]-1}],
  
    Table[
      xi = xl + i dx ; 
      {colFun[lineCol], Line[{{x, y}, {xi, y-th}}]}, 
      {i, 0, Length[c$]-1}] 
  ];
  
  Flatten[{gthis, gnew,
           If[gridBran,
             {colFun[lineCol], Line[{{xl, y}, {xr, y}}]},{}],
           colFun[labelCol], 
           If[f$ === \"EXPR\", 
             {PointSize[lSize], Point[{x,y}],
              GrayLevel[0], PointSize[.5 lSize], Point[{x,y}]}, 
             {PointSize[lSize], Point[{x,y}], 
              colFun[textCol], Text[FontForm[f$,textFnt],{x,y}]}
           ]
          }]
]
\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[ f[a,b,g[c],d], GridBranches -> False];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 1.47151 [
[.02381 .30902 -5 -6.59375 ]
[.02381 .30902 5 6.59375 ]
[.34127 .30902 -5 -6.59375 ]
[.34127 .30902 5 6.59375 ]
[.65873 .30902 -5 -6.59375 ]
[.65873 .30902 5 6.59375 ]
[.65873 .01472 -20 -6.59375 ]
[.65873 .01472 20 6.59375 ]
[.97619 .30902 -5 -6.59375 ]
[.97619 .30902 5 6.59375 ]
[.5 .60332 -5 -6.59375 ]
[.5 .60332 5 6.59375 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .30902 L
s
.5 .60332 m
.34127 .30902 L
s
.5 .60332 m
.65873 .30902 L
s
.5 .60332 m
.97619 .30902 L
s
1 g
.05 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.34127 .30902 Mdot
0 g
gsave
.34127 .30902 -66 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.65873 .30902 m
.65873 .01472 L
s
.9 g
.05 w
.65873 .30902 Mdot
0 g
gsave
.65873 .30902 -66 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.65873 .01472 Mdot
0 g
gsave
.65873 .01472 -81 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Symbol) show
1.000 setlinewidth
grestore
1 g
.97619 .30902 Mdot
0 g
gsave
.97619 .30902 -66 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.813, 174.188},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCacheValid->False]
}, Closed]],

Cell["\<\
TermPlot0[e_?AtomQ, x_, y_, n_,opts___] := 
Module[{colFun, textCol, textFnt},

  colFun = ColorFunction /. {opts} /. Options[TermPlot];
  textCol = TextColor /. {opts} /. Options[TermPlot];
  textFnt = TextFont /. {opts} /. Options[TermPlot];
  
  {GrayLevel[1], PointSize[.04], Point[{x,y}],
   colFun[textCol],
   Text[FontForm[e,textFnt],{x,y}]}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 8.\n"
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
InitializationCellEvaluation->True,
CellGrouping->Automatic,
WindowSize->{815, 689},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> FrontEnd`FileName[{ParentDirectory[ParentDirectory[]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Simple structure selection"->{
    Cell[22306, 636, 117, 2, 41, "Input",
      CellTags->"Simple structure selection"]},
  "Hierarchical selection"->{
    Cell[103635, 2855, 113, 2, 41, "Input",
      CellTags->"Hierarchical selection"]},
  "Embedded structure selection"->{
    Cell[198676, 5252, 119, 2, 41, "Input",
      CellTags->"Embedded structure selection"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Simple structure selection", 229111, 6439},
  {"Hierarchical selection", 229231, 6442},
  {"Embedded structure selection", 229355, 6445}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 100, 2, 91, "Title",
  Evaluatable->False],
Cell[1879, 57, 112, 3, 62, "Subsubtitle"],
Cell[1994, 62, 18965, 516, 244, 4899, 336, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[20984, 582, 80, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[21067, 586, 207, 4, 44, "Text"],
Cell[21277, 592, 248, 8, 44, "Text"],
Cell[21528, 602, 102, 3, 26, "Text"],
Cell[21633, 607, 194, 4, 44, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21864, 616, 76, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[21943, 620, 242, 8, 44, "Text"],

Cell[CellGroupData[{
Cell[22210, 632, 93, 2, 78, "Section",
  Evaluatable->False],
Cell[22306, 636, 117, 2, 41, "Input",
  CellTags->"Simple structure selection"],
Cell[22426, 640, 116, 4, 56, "Input"],

Cell[CellGroupData[{
Cell[22567, 648, 94, 1, 41, "Input"],
Cell[22664, 651, 41493, 1140, 244, 20422, 874, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[64194, 1796, 79, 1, 41, "Input"],
Cell[64276, 1799, 36426, 942, 244, 16788, 694, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[100739, 2746, 81, 1, 41, "Input"],
Cell[100823, 2749, 699, 19, 242, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[101559, 2773, 82, 1, 41, "Input"],
Cell[101644, 2776, 329, 9, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[102010, 2790, 97, 1, 41, "Input"],
Cell[102110, 2793, 410, 11, 130, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[102557, 2809, 131, 4, 56, "Input"],
Cell[102691, 2815, 299, 8, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[103027, 2828, 119, 4, 41, "Input"],
Cell[103149, 2834, 296, 8, 82, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[103494, 2848, 138, 5, 62, "Section",
  Evaluatable->False],
Cell[103635, 2855, 113, 2, 41, "Input",
  CellTags->"Hierarchical selection"],
Cell[103751, 2859, 195, 13, 191, "Input"],

Cell[CellGroupData[{
Cell[103971, 2876, 79, 1, 41, "Input"],
Cell[104053, 2879, 89890, 2206, 361, 36775, 1544, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[193980, 5090, 83, 1, 41, "Input"],
Cell[194066, 5093, 1549, 41, 594, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[195652, 5139, 89, 1, 41, "Input"],
Cell[195744, 5142, 507, 15, 194, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[196288, 5162, 84, 1, 41, "Input"],
Cell[196375, 5165, 362, 9, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[196774, 5179, 84, 1, 41, "Input"],
Cell[196861, 5182, 362, 9, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[197260, 5196, 89, 1, 41, "Input"],
Cell[197352, 5199, 320, 8, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[197709, 5212, 98, 1, 41, "Input"],
Cell[197810, 5215, 278, 7, 66, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[198125, 5227, 127, 4, 56, "Input"],
Cell[198255, 5233, 227, 6, 52, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[198531, 5245, 142, 5, 62, "Section",
  Evaluatable->False],
Cell[198676, 5252, 119, 2, 41, "Input",
  CellTags->"Embedded structure selection"],
Cell[198798, 5256, 195, 13, 191, "Input"],

Cell[CellGroupData[{
Cell[199018, 5273, 96, 1, 41, "Input"],
Cell[199117, 5276, 320, 8, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199474, 5289, 109, 2, 41, "Input"],
Cell[199586, 5293, 302, 8, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199925, 5306, 109, 2, 41, "Input"],
Cell[200037, 5310, 346, 10, 114, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[200420, 5325, 143, 5, 56, "Input"],
Cell[200566, 5332, 250, 7, 66, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[200865, 5345, 114, 2, 62, "Section",
  Evaluatable->False],
Cell[200982, 5349, 663, 22, 80, "Text"],
Cell[201648, 5373, 116, 3, 26, "Text"],
Cell[201767, 5378, 76, 1, 41, "Input"],
Cell[201846, 5381, 101, 4, 44, "Text"],

Cell[CellGroupData[{
Cell[201972, 5389, 101, 1, 41, "Input"],
Cell[202076, 5392, 48, 1, 40, "Output"]
}, Open  ]],
Cell[202139, 5396, 207, 8, 26, "Text"],

Cell[CellGroupData[{
Cell[202371, 5408, 218, 8, 116, "Input"],
Cell[202592, 5418, 157, 2, 56, "Output"]
}, Open  ]],
Cell[202764, 5423, 114, 5, 26, "Text"],

Cell[CellGroupData[{
Cell[202903, 5432, 84, 1, 41, "Input"],
Cell[202990, 5435, 178, 3, 56, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[203205, 5443, 55, 1, 41, "Input"],
Cell[203263, 5446, 178, 3, 56, "Output"]
}, Open  ]],
Cell[203456, 5452, 102, 3, 26, "Text"],
Cell[203561, 5457, 170, 5, 71, "Input"],
Cell[203734, 5464, 78, 3, 44, "Text"],

Cell[CellGroupData[{
Cell[203837, 5471, 84, 1, 41, "Input"],
Cell[203924, 5474, 149, 4, 40, "Output"]
}, Open  ]],
Cell[204088, 5481, 234, 6, 44, "Text"],

Cell[CellGroupData[{
Cell[204347, 5491, 128, 5, 71, "Input"],
Cell[204478, 5498, 70, 1, 40, "Output"]
}, Open  ]],
Cell[204563, 5502, 314, 9, 44, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[204926, 5517, 82, 2, 50, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[205033, 5523, 100, 2, 78, "Section",
  Evaluatable->False],
Cell[205136, 5527, 66, 1, 41, "Input"],
Cell[205205, 5530, 332, 11, 146, "Input",
  InitializationCell->True],
Cell[205540, 5543, 125, 7, 86, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[205690, 5554, 84, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[205799, 5560, 70, 1, 41, "Input"],
Cell[205872, 5563, 84, 1, 40, "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[206017, 5571, 140, 5, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[206182, 5580, 141, 5, 56, "Subsection",
  Evaluatable->False],
Cell[206326, 5587, 340, 12, 161, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[206703, 5604, 109, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[206837, 5610, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[206956, 5614, 67, 1, 41, "Input"],
Cell[207026, 5617, 2690, 49, 1121, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[209753, 5671, 106, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[209862, 5675, 158, 8, 116, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[210057, 5688, 103, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[210163, 5692, 202, 9, 116, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[210402, 5706, 85, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[210512, 5712, 98, 8, 116, "Input"],
Cell[210613, 5722, 59, 1, 40, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[210709, 5728, 73, 1, 41, "Input"],
Cell[210785, 5731, 101, 2, 23, "Message"]
}, Closed]],

Cell[CellGroupData[{
Cell[210923, 5738, 146, 6, 86, "Input"],
Cell[211072, 5746, 212, 3, 80, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[211321, 5754, 149, 6, 98, "Input"],
Cell[211473, 5762, 144, 2, 61, "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[211678, 5771, 115, 2, 55, "Subsection",
  Evaluatable->False],
Cell[211796, 5775, 350, 12, 170, "Text",
  Evaluatable->False],
Cell[212149, 5789, 190, 5, 44, "Text",
  Evaluatable->False],
Cell[212342, 5796, 185, 9, 152, "Input"],
Cell[212530, 5807, 365, 9, 80, "Text",
  Evaluatable->False],
Cell[212898, 5818, 604, 25, 356, "Input",
  InitializationCell->True],
Cell[213505, 5845, 178, 7, 86, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[213732, 5858, 86, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[213843, 5864, 73, 0, 60, "Subsubsection"],
Cell[213919, 5866, 603, 28, 401, "Input",
  InitializationCell->True],
Cell[214525, 5896, 594, 27, 386, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[215156, 5928, 45, 0, 60, "Subsubsection"],
Cell[215204, 5930, 675, 29, 416, "Input",
  InitializationCell->True],
Cell[215882, 5961, 732, 31, 446, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[216663, 5998, 90, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[216778, 6004, 106, 2, 56, "Subsection",
  Evaluatable->False],
Cell[216887, 6008, 130, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[217054, 6015, 78, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[217157, 6021, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[217250, 6025, 221, 8, 101, "Input",
  InitializationCell->True],
Cell[217474, 6035, 313, 15, 206, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[217824, 6055, 100, 2, 61, "Subsubsection",
  Evaluatable->False],
Cell[217927, 6059, 62, 1, 44, "Input"],
Cell[217992, 6062, 3328, 56, 889, "Input"],
Cell[221323, 6120, 2200, 69, 1016, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[223548, 6193, 91, 1, 44, "Input"],
Cell[223642, 6196, 3526, 177, 245, 3351, 171, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False,
  ImageCacheValid->False]
}, Closed]],
Cell[227183, 6376, 430, 14, 191, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[227686, 6398, 78, 2, 50, "Subtitle",
  Evaluatable->False],
Cell[227767, 6402, 204, 5, 62, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

