(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   3973042,     108250]*)
(*NotebookOutlinePosition[   3975283,     108315]*)
(*  CellTagsIndexPosition[   3974926,     108303]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " Evolution on Symbolic Expressions\n\nGenetic Operators"
}], "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Christian Jacob, jacob@cpsc.ucalgary.ca  April 1997 / February 2001 \
\[Copyright]\
\>", "Subsubtitle"],

Cell[TextData[{
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .45617 0 0 Mshowa
P
.004 w
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .12963 .30902 0 0 Mshowa
P
1 g
.27072 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .27072 .30902 0 0 Mshowa
P
.9 g
.20018 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .20018 .45617 0 0 Mshowa
P
1 g
.37654 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .37654 .45617 0 0 Mshowa
P
.004 w
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(e)] .48236 .30902 0 0 Mshowa
P
.004 w
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .44709 .16187 0 0 Mshowa
P
.004 w
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .62346 .01472 0 0 Mshowa
P
1 g
.97619 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(4)] .97619 .01472 0 0 Mshowa
P
.9 g
.79982 .16187 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .79982 .16187 0 0 Mshowa
P
.9 g
.62346 .30902 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .62346 .30902 0 0 Mshowa
P
.9 g
.55291 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .55291 .45617 0 0 Mshowa
P
1 g
.72928 .45617 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .72928 .45617 0 0 Mshowa
P
.9 g
.37654 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .37654 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{226, 139.375},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003R0000Ra000`40O003h00OhW=i0029LgT4Oom8
LgT4Ool9LgT008McN@QoodAcN@Qoo`McN@00Qg=i1@000gooA7=i0goo100000=oog=iLgT01G=i0026
LgT2Ool200000goo00000003Oom2LgT5Ool20003Ool6LgT008IcN@9oo`800003Ool0000000=ood9c
N@9oo`H0009oo`IcN@00QW=i0Woo0P0000=oo`0000000goo@W=i0Woo0P0000=oo`0000000goo1W=i
0026LgT2Ool40004Oom2LgT3Ool40003Ool6LgT008McN@03Ool0000000EoodAcN@=oo`<0009oo`Mc
N@00Qg=i0`001Goo00<007=iLgT0@G=i17oo0P000Woo1g=i0029LgT4Ool3LgT2000oLgT20002LgT4
Ool9LgT0099cN@03001cNG=i03]cN@03001cNG=i00mcN@00Tg=i00<007=iLgT0>G=i00<007=iLgT0
47=i002DLgT00`00LgUcN@0gLgT00`00LgUcN@0ALgT009EcN@03001cNG=i03EcN@03001cNG=i019c
N@00UW=i0P00<g=i0P005G=i002HLgT00`00LgUcN@0_LgT00`00LgUcN@0ELgT009UcN@03001cNG=i
02ecN@03001cNG=i01IcN@00VW=i00<007=iLgT0:g=i00<007=iLgT05g=i002KLgT2000YLgT2000J
LgT009ecN@03001cNG=i02EcN@03001cNG=i01YcN@00WW=i00<007=iLgT08g=i00<007=iLgT06g=i
002OLgT00`00LgUcN@0QLgT00`00LgUcN@0LLgT00:1cN@03001cNG=i01mcN@03001cNG=i01ecN@00
XG=i0P007G=i0P0087=i002SLgT00`00LgUcN@0ILgT00`00LgUcN@0PLgT00:AcN@03001cNG=i01Mc
N@03001cNG=i025cN@00YG=i00<007=iLgT05G=i00<007=iLgT08W=i002VLgT2000CLgT2000ULgT0
0:QcN@03001cNG=i00mcN@03001cNG=i02EcN@00ZG=i00<007=iLgT03G=i00<007=iLgT09W=i002Z
LgT00`00LgUcN@0;LgT00`00LgUcN@0WLgT00:]cN@03001cNG=i00UcN@03001cNG=i02QcN@00Hg=i
17ooAG=i1P0000=cW7=iLgT00P00:g=i001QLgT8Oom4LgT4Li`20002Li`]LgT0065cN@03Ool00000
008000=oodAcN@03Li`0000000<0009cW2ecN@00H7=i00=oo`0000000Woo0P000goo@W=i00=cW000
00000W>L0P000g>L;7=i001PLgT00goo00000007Oom2LgT00g>L00000002Li`20003Li`/LgT0061c
N@03Ool00000009oo`8000=ood9cN@03Li`00000009cW08000=cW2acN@00H7=i0Woo100017oo@W=i
0W>L1P000W>L;7=i001QLgT8Ool00`00LgUcN@11LgT8Li`]LgT0065cN@Qoo`03LgT007=i041cN@03
001cW7>L00IcW2ecN@00Hg=i17oo17=i0P00?G=i0P000g=i17>L;g=i001]LgT00`00LgUcN@0iLgT0
0`00LgUcN@0fLgT006icN@03001cNG=i03McN@03001cNG=i03McN@00Kg=i00<007=iLgT0=G=i00<0
07=iLgT0>7=i001`LgT00`00LgUcN@0cLgT00`00LgUcN@0iLgT0075cN@03001cNG=i035cN@03001c
NG=i03YcN@00LW=i0P00;g=i0P00?G=i001dLgT00`00LgUcN@0[LgT00`00LgUcN@0mLgT007EcN@03
001cNG=i02UcN@03001cNG=i03icN@00MW=i00<007=iLgT09g=i00<007=iLgT0?g=i001gLgT00`00
LgUcN@0ULgT00`00LgUcN@10LgT007QcN@8002=cN@8004=cN@00NW=i00<007=iLgT07g=i00<007=i
LgT0@g=i001kLgT00`00LgUcN@0MLgT00`00LgUcN@14LgT007acN@03001cNG=i01]cN@03001cNG=i
04EcN@00OG=i00<007=iLgT06G=i00<007=iLgT0AW=i001nLgT2000GLgT20019LgT0081cN@03001c
NG=i01=cN@03001cNG=i04UcN@00PG=i00<007=iLgT04G=i00<007=iLgT0BW=i0022LgT00`00LgUc
N@0?LgT00`00LgUcN@1;LgT008=cN@03001cNG=i00ecN@03001cNG=i04acN@00Q7=i00<007=iLgT0
2g=i00<007=iLgT0CG=i0025LgT20009LgT2001@LgT001icN@Aooa]cN@AoobUcN@AooaUcN@D00004
LiacNG=i001BLgT001acN@QooaMcN@QoobEcN@QooaMcN@AcW080009cW5=cN@0077=i1@000goo5g=i
00=oo`0000000P000goo9G=i0Woo10000Woo5g=i00=cW00000000`000W>LDg=i000KLgT2Ool20000
0goo00000003OolELgT00goo00000002Ool20003OolSLgT2Ool20006OolELgT00g>L00000002Li`2
0003LiaBLgT001]cN@9oo`800003Ool0000000=ooaEcN@Eoo`8000=oob=cN@9oo`H0009ooaEcN@03
Li`00000009cW08000=cW59cN@006g=i0Woo0P0000=oo`0000000goo5G=i0goo0`0017oo8g=i0Woo
0P000Woo0P000Woo5G=i00=cW00000000W>L0P000g>LDW=i000KLgT2Ool40004OolELgT5Ool20003
OolSLgT3Ool40003OolELgT2Li`60002LiaBLgT001acN@03Ool0000000EooaMcN@80009oo`80009o
obEcN@QooaMcN@QcW5=cN@0077=i0`001Goo5g=i00=oo`0000000P000goo9G=i27oo5g=i27>LDg=i
000NLgT4Ool00`00LgUcN@0GLgT00`00Oomoo`02OolYLgT4Ool00`00LgUcN@0HLgT4LiaELgT002=c
N@03001cNG=i01EcN@03001cNG=i035cN@03001cNG=i01IcN@03001cNG=i05McN@008g=i00<007=i
LgT05G=i00<007=iLgT0<G=i00<007=iLgT05W=i00<007=iLgT0Eg=i000TLgT00`00LgUcN@0CLgT0
0`00LgUcN@0cLgT00`00LgUcN@0DLgT00`00LgUcN@1HLgT002AcN@03001cNG=i01=cN@03001cNG=i
03=cN@03001cNG=i01AcN@03001cNG=i05QcN@0097=i00<007=iLgT04g=i00<007=iLgT0<g=i00<0
07=iLgT04g=i00<007=iLgT0FG=i000ULgT00`00LgUcN@0ALgT00`00LgUcN@0eLgT00`00LgUcN@0B
LgT00`00LgUcN@1ILgT002EcN@03001cNG=i015cN@03001cNG=i03EcN@03001cNG=i015cN@03001c
NG=i05YcN@009W=i00<007=iLgT03g=i00<007=iLgT0=g=i00<007=iLgT047=i00<007=iLgT0FW=i
000VLgT00`00LgUcN@0?LgT00`00LgUcN@0gLgT00`00LgUcN@0?LgT00`00LgUcN@1KLgT002McN@03
001cNG=i00ecN@03001cNG=i03UcN@03001cNG=i00icN@03001cNG=i05]cN@009g=i00<007=iLgT0
3G=i00<007=iLgT0>G=i00<007=iLgT03G=i00<007=iLgT0G7=i000XLgT00`00LgUcN@0;LgT00`00
LgUcN@0kLgT00`00LgUcN@0<LgT00`00LgUcN@1LLgT002QcN@03001cNG=i00]cN@03001cNG=i03]c
N@03001cNG=i00]cN@03001cNG=i05ecN@00:G=i00<007=iLgT02G=i00<007=iLgT0?G=i00<007=i
LgT02W=i00<007=iLgT0GG=i000YLgT00`00LgUcN@09LgT00`00LgUcN@0mLgT00`00LgUcN@09LgT0
0`00LgUcN@1NLgT002YcN@03001cNG=i00McN@03001cNG=i03mcN@03001cNG=i00QcN@03001cNG=i
05icN@00:W=i00<007=iLgT01g=i00<007=iLgT0?g=i00<007=iLgT01g=i00<007=iLgT0Gg=i000[
LgT00`00LgUcN@05LgT00`00LgUcN@11LgT00`00LgUcN@06LgT00`00LgUcN@1OLgT002]cN@03001c
NG=i00EcN@03001cNG=i045cN@03001cNG=i00EcN@03001cNG=i061cN@00:g=i00<007=iLgT01G=i
00<007=iLgT0@G=i00<007=iLgT01G=i00<007=iLgT0H7=i000/LgT00`00LgUcN@03LgT00`00LgUc
N@13LgT00`00LgUcN@03LgT00`00LgUcN@1QLgT002acN@03001cNG=i00=cN@03001cNG=i04=cN@03
001cNG=i00=cN@03001cNG=i065cN@001g=i17oo8W=i1@008G=i17oo8W=i00<007>LLi`00W>L8W=i
17oo?W=i0005LgT8OolNLgT5Li`200000g>LLgUcN@0LLgT8OolOLgT8Li`NLgT8OollLgT000EcN@03
Ool0000000<0009ooaicN@9cW0D00003LiacNG=i01acN@9oo`@0009ooamcN@L00003LiacNG=i01ac
N@H0009oocacN@0017=i00Aoo`00001oo`8000AooaacN@9cW080009cW080009cW1acN@9oo`80009o
o`80009ooaecN@9cW0800003Li`0000000=cW1acN@9oo`800003Ool0000000=ooc]cN@0017=i0Woo
100017oo77=i0W>L0P000W>L0P000W>L77=i0Woo0P001Woo7G=i0W>L0P0000=cW00000000g>L77=i
0goo0P001Goo>g=i0004LgT017oo000007oo0P0017oo77=i0W>L0P000W>L0P000W>L77=i0Woo0P00
0Woo0P000Woo7G=i0W>L0P0000=cW00000000g>L77=i17oo0P0017oo>g=i0004LgT2Ool30005Ool2
000JLgT3Li`600000g>LLgUcN@0JLgT3Ool40003OolMLgT2Li`40004Li`KLgT01000Ool000000Woo
0P000goo>g=i0005LgT8Ool3LgT2000ILgT8Li`00`00LgUcN@0KLgT8OolNLgT01000Li`000001G>L
6W=i0P000W=i0P000Woo0P000Woo?7=i0005LgT8Ool5LgT3000FLgT8Li`00g=i001cN@0KLgT8OolM
LgT00`00LgT000020005Li`GLgT30004LgT00goo000000020003OollLgT000McN@Aoo`YcN@8001Ic
N@AcW0AcN@8001acN@AooaecN@8000AcN@AcW1McN@8000UcN@AoocicN@005g=i0P007W=i00<007=i
LgT06g=i00<007=iLgT06g=i00<007=iLgT077=i0`00CG=i000ILgT3000LLgT00`00LgUcN@0JLgT0
0`00LgUcN@0JLgT00`00LgUcN@0KLgT2001@LgT001acN@8001]cN@03001cNG=i01UcN@03001cNG=i
01UcN@03001cNG=i01YcN@80059cN@007W=i0`006G=i00<007=iLgT067=i00<007=iLgT067=i00<0
07=iLgT067=i0`00E7=i000QLgT2000HLgT00`00LgUcN@0GLgT00`00LgUcN@0GLgT00`00LgUcN@0G
LgT2001GLgT002=cN@8001McN@8001McN@03001cNG=i01EcN@8001McN@<005UcN@009G=i0`005W=i
00<007=iLgT057=i00<007=iLgT057=i00<007=iLgT05G=i0P00G7=i000XLgT2000ELgT00`00LgUc
N@0CLgT00`00LgUcN@0CLgT00`00LgUcN@0DLgT2001NLgT002YcN@8001AcN@03001cNG=i019cN@03
001cNG=i019cN@03001cNG=i019cN@<0061cN@00;7=i0`004W=i00<007=iLgT04G=i00<007=iLgT0
4G=i00<007=iLgT04G=i0P00Hg=i000_LgT2000ALgT2000ALgT00`00LgUcN@0?LgT2000ALgT3001U
LgT0035cN@<0011cN@03001cNG=i00icN@03001cNG=i00icN@03001cNG=i00mcN@8006QcN@00=7=i
0P003g=i00<007=iLgT03G=i00<007=iLgT03G=i00<007=iLgT03G=i0`00JW=i000fLgT2000>LgT0
0`00LgUcN@0<LgT00`00LgUcN@0<LgT00`00LgUcN@0<LgT2001]LgT003QcN@<000acN@03001cNG=i
00]cN@03001cNG=i00]cN@03001cNG=i00]cN@8006mcN@00>g=i0P002g=i0P002g=i00<007=iLgT0
2G=i0P002g=i0`00LG=i000mLgT2000;LgT00`00LgUcN@08LgT00`00LgUcN@08LgT00`00LgUcN@09
LgT2001dLgT003mcN@<000UcN@03001cNG=i00McN@03001cNG=i00McN@03001cNG=i00McN@<007Ic
N@00@W=i0P0027=i00<007=iLgT01W=i00<007=iLgT01W=i00<007=iLgT01W=i0P00NG=i0014LgT3
0006LgT00`00LgUcN@05LgT00`00LgUcN@05LgT00`00LgUcN@05LgT2001kLgT004McN@8000EcN@03
001cNG=i00AcN@03001cNG=i00AcN@03001cNG=i00=cN@<007ecN@00BG=i0P0017=i0P0017=i00<0
07=iLgT00W=i0P0017=i0P00P7=i001;LgT30003LgT00`00LgUcW003Li`2LgT01000LgUcNG=i0`00
PW=i001>LgT200000g=iLi`0000500000g>LLgUcN@020025LgT0051cN@04001cW7>LLi`20003Li`2
0027LgT0051cN@AcW08000AcW8QcN@00D7=i17>L0P0017>LR7=i001@LgT3Li`50002Lib8LgT0051c
N@AcW08000AcW8QcN@00DG=i17>L0`0000=cW7=iLgT0Qg=i001ALgT8Lib9LgT005=cN@AcW8]cN@00
\
\>"],
    ImageRangeCache->{{{0, 225}, {138.375, 0}} -> {-2, 0, 0, 0}},
    CellTags->"Mutation - basic expression 2"],
  " ",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Msboxa
P
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Msboxa
P
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
.004 w
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .02381 .40712 0 0 Mshowa
P
.004 w
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .179 .21092 0 0 Mshowa
P
1 g
.34481 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .34481 .21092 0 0 Mshowa
P
.9 g
.2619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .2619 .40712 0 0 Mshowa
P
1 g
.5 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(c)] .5 .40712 0 0 Mshowa
P
.004 w
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.7381 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(5)] .65519 .21092 0 0 Mshowa
P
.004 w
.7381 .21092 m
.6178 .01472 L
s
.7381 .21092 m
.85839 .01472 L
s
1 g
.05 w
.6178 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .6178 .01472 0 0 Mshowa
P
1 g
.85839 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(3)] .85839 .01472 0 0 Mshowa
P
.9 g
.7381 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .7381 .21092 0 0 Mshowa
P
.004 w
.821 .21092 m
.70071 .01472 L
s
.821 .21092 m
.9413 .01472 L
s
1 g
.05 w
.70071 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(a)] .70071 .01472 0 0 Mshowa
P
1 g
.9413 .01472 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(b)] .9413 .01472 0 0 Mshowa
P
.9 g
.821 .21092 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(g)] .821 .21092 0 0 Mshowa
P
.9 g
.7381 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(h)] .7381 .40712 0 0 Mshowa
P
1 g
.97619 .40712 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(2)] .97619 .40712 0 0 Mshowa
P
.9 g
.5 .60332 Mdot
0 g
p
/Courier-Bold findfont 10 scalefont setfont
[(f)] .5 .60332 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    Evaluatable->False,
    AspectRatioFixed->True,
    ImageSize->{226, 139.375},
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    AnimationDisplayTime->1.00948,
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003R0000Ra000`40O003h00OhW=i0028LgT4Ool>
LgT4OolNLgT4Ool>LgT4Ool@LgT008IcN@Qoo`YcN@QooaYcN@Qoo`YcN@Qoo`icN@00QW=i00=oo`00
00000`000Woo2W=i00=oo`0000000`000Woo6W=i00=oo`0000000P000goo2W=i1@000goo3W=i0025
LgT017oo000007oo0P0017oo27=i00Aoo`00001oo`8000AooaQcN@03Ool00000009oo`8000=oo`Qc
N@9oo`800003Ool0000000=oo`ecN@00QG=i0Woo100017oo27=i0Woo100017oo67=i1Goo0P000goo
27=i0Woo0P0000=oo`0000000goo3G=i0025LgT017oo000007oo0P0017oo27=i00Aoo`00001oo`80
00AooaQcN@=oo`<000Aoo`QcN@9oo`800003Ool0000000=oo`ecN@00QG=i0Woo0`001Goo27=i0Woo
0`001Goo67=i1Goo0P000goo27=i0Woo100017oo3G=i0026LgT8Ool:LgT8OolJLgT20002Ool20002
Ool:LgT00goo00000005Ool>LgT008IcN@Qoo`YcN@QooaYcN@03Ool00000008000=oo`YcN@<000Eo
o`icN@00R7=i17oo3W=i17oo7W=i17oo3G=i00<007ooOol00Woo47=i002<LgT00`00LgUcN@0?LgT0
0`00LgUcN@0JLgT00`00LgUcN@0>LgT00`00LgUcN@0CLgT008ecN@03001cNG=i00icN@03001cNG=i
01YcN@03001cNG=i00icN@03001cNG=i01=cN@00SG=i00<007=iLgT03g=i00<007=iLgT067=i00<0
07=iLgT03W=i00<007=iLgT057=i002>LgT00`00LgUcN@0?LgT00`00LgUcN@0FLgT00`00LgUcN@0>
LgT00`00LgUcN@0ELgT008icN@03001cNG=i00mcN@03001cNG=i01IcN@03001cNG=i00icN@03001c
NG=i01EcN@00Sg=i00<007=iLgT03g=i00<007=iLgT057=i00<007=iLgT03W=i00<007=iLgT05W=i
002@LgT00`00LgUcN@0?LgT00`00LgUcN@0BLgT00`00LgUcN@0>LgT00`00LgUcN@0GLgT0091cN@03
001cNG=i00mcN@03001cNG=i019cN@03001cNG=i00icN@03001cNG=i01McN@00TG=i00<007=iLgT0
3g=i00<007=iLgT047=i00<007=iLgT03W=i00<007=iLgT067=i002BLgT00`00LgUcN@0>LgT00`00
LgUcN@0@LgT00`00LgUcN@0>LgT00`00LgUcN@0HLgT0099cN@03001cNG=i00mcN@03001cNG=i00ic
N@03001cNG=i00icN@03001cNG=i01UcN@00Tg=i00<007=iLgT03g=i00<007=iLgT037=i00<007=i
LgT03W=i00<007=iLgT06W=i002DLgT00`00LgUcN@0>LgT00`00LgUcN@0<LgT00`00LgUcN@0>LgT0
0`00LgUcN@0JLgT009AcN@03001cNG=i00mcN@03001cNG=i00YcN@03001cNG=i00icN@03001cNG=i
01]cN@00UG=i00<007=iLgT03W=i00<007=iLgT02W=i00<007=iLgT03W=i00<007=iLgT06g=i002F
LgT00`00LgUcN@0>LgT00`00LgUcN@08LgT00`00LgUcN@0>LgT00`00LgUcN@0LLgT009IcN@03001c
NG=i00mcN@03001cNG=i00IcN@03001cNG=i00icN@03001cNG=i01ecN@00Ug=i00<007=iLgT03W=i
00<007=iLgT01W=i00<007=iLgT03W=i00<007=iLgT07G=i002GLgT00`00LgUcN@0?LgT00`00LgUc
N@04LgT00`00LgUcN@0>LgT00`00LgUcN@0NLgT009QcN@03001cNG=i00mcN@03001cNG=i009cN@03
001cNG=i00icN@03001cNG=i01mcN@00VG=i00<007=iLgT03W=i00<007=iLgT00W=i00<007=iLgT0
3W=i00<007=iLgT07g=i002ILgT00`00LgUcN@0?LgT01000LgUcN@0047=i00<007=iLgT087=i002J
LgT00`00LgUcN@0>LgT01000LgUcN@0047=i00<007=iLgT087=i002KLgT00`00LgUcN@0>LgT2000@
LgT00`00LgUcN@0QLgT009]cN@03001cNG=i00icN@8000mcN@03001cNG=i029cN@00W7=i00<007=i
LgT03G=i0P003g=i00<007=iLgT08W=i002MLgT00`00LgUcN@0;LgT01000LgUcN@003G=i00<007=i
LgT08g=i002MLgT00`00LgUcN@0:LgT00`00LgUcN@02LgT00`00LgUcN@09LgT00`00LgUcN@0TLgT0
09icN@03001cNG=i00UcN@03001cNG=i009cN@03001cNG=i00UcN@03001cNG=i02AcN@00Wg=i00<0
07=iLgT01g=i00<007=iLgT017=i00<007=iLgT01g=i00<007=iLgT09G=i002OLgT00`00LgUcN@07
LgT00`00LgUcN@04LgT00`00LgUcN@07LgT00`00LgUcN@0ULgT00:1cN@03001cNG=i00EcN@03001c
NG=i00IcN@03001cNG=i00EcN@03001cNG=i02IcN@00X7=i00<007=iLgT017=i00<007=iLgT027=i
00<007=iLgT00g=i00<007=iLgT09g=i000YLgT4OolPLgT4OoloLgT4Ool=LgT400000g>LLgT0000:
LgT500000g>L001cN@0XLgT002McN@QooaacN@Qooc]cN@Qoo`YcN@AcW080009cW0YcN@AcW080009c
W2QcN@009g=i1@000goo77=i00=oo`0000000P000goo>g=i00=oo`0000000P000goo2W=i00=cW000
00000`000W>L2W=i00=cW00000000`000W>L:7=i000VLgT2Ool200000goo00000003OolJLgT00goo
00000002Ool20003OoliLgT00goo00000002Ool20003Ool8LgT00g>L00000002Li`20003Li`8LgT0
0g>L00000002Li`20003Li`WLgT002IcN@9oo`800003Ool0000000=ooaYcN@Eoo`8000=oocUcN@Eo
o`8000=oo`QcN@03Li`00000009cW08000=cW0QcN@03Li`00000009cW08000=cW2McN@009W=i0Woo
0P0000=oo`0000000goo6W=i0goo0`0017oo>G=i1Goo0P000goo27=i00=cW00000000W>L0P000g>L
27=i00=cW00000000W>L0P000g>L9g=i000VLgT2Ool40004OolJLgT5Ool20003OoliLgT00goo0000
00030004Ool8LgT2Li`60002Li`8LgT2Li`60002Li`WLgT002McN@03Ool0000000EooaacN@80009o
o`80009ooc]cN@8000Ioo`YcN@QcW0YcN@QcW2QcN@009g=i0`001Goo77=i00=oo`0000000P000goo
>g=i1P000Woo2W=i27>L2W=i27>L:7=i000YLgT4Ool00`00LgUcN@0LLgT00`00Oomoo`02OoloLgT4
Ool00`00LgUcN@0;LgT4Li`=LgT00`00LiacW002Li`ZLgT002ecN@03001cNG=i01acN@03001cNG=i
04EcN@03001cNG=i00ecN@03001cNG=i00acN@03001cNG=i02acN@00;W=i00<007=iLgT06W=i00<0
07=iLgT0Ag=i00<007=iLgT037=i00<007=iLgT02g=i00<007=iLgT0;G=i000^LgT00`00LgUcN@0J
LgT00`00LgUcN@17LgT00`00LgUcN@0<LgT00`00LgUcN@0;LgT00`00LgUcN@0]LgT002icN@03001c
NG=i01UcN@03001cNG=i04UcN@03001cNG=i00]cN@03001cNG=i00]cN@03001cNG=i02ecN@00;g=i
00<007=iLgT067=i00<007=iLgT0BG=i00<007=iLgT02g=i00<007=iLgT02W=i00<007=iLgT0;W=i
000_LgT00`00LgUcN@0HLgT00`00LgUcN@19LgT00`00LgUcN@0;LgT00`00LgUcN@0:LgT00`00LgUc
N@0^LgT0031cN@03001cNG=i01IcN@03001cNG=i04]cN@03001cNG=i00YcN@03001cNG=i00UcN@03
001cNG=i02mcN@00<7=i00<007=iLgT05W=i00<007=iLgT0Bg=i00<007=iLgT02W=i00<007=iLgT0
2G=i00<007=iLgT0;g=i000`LgT00`00LgUcN@0ELgT00`00LgUcN@1=LgT00`00LgUcN@09LgT00`00
LgUcN@09LgT00`00LgUcN@0_LgT0035cN@03001cNG=i01AcN@03001cNG=i04ecN@03001cNG=i00Uc
N@03001cNG=i00QcN@03001cNG=i031cN@00<G=i00<007=iLgT057=i00<007=iLgT0CG=i00<007=i
LgT02G=i00<007=iLgT027=i00<007=iLgT0<7=i000bLgT00`00LgUcN@0BLgT00`00LgUcN@1?LgT0
0`00LgUcN@08LgT00`00LgUcN@07LgT00`00LgUcN@0aLgT0039cN@03001cNG=i019cN@03001cNG=i
04mcN@03001cNG=i00QcN@03001cNG=i00McN@03001cNG=i035cN@00<W=i00<007=iLgT04G=i00<0
07=iLgT0DG=i00<007=iLgT01g=i00<007=iLgT01g=i00<007=iLgT0<G=i000cLgT00`00LgUcN@0@
LgT00`00LgUcN@1ALgT00`00LgUcN@07LgT00`00LgUcN@06LgT00`00LgUcN@0bLgT003=cN@03001c
NG=i00mcN@03001cNG=i05=cN@03001cNG=i00IcN@03001cNG=i00IcN@03001cNG=i039cN@00=7=i
00<007=iLgT03W=i00<007=iLgT0Dg=i00<007=iLgT01W=i00<007=iLgT01G=i00<007=iLgT0<g=i
000dLgT00`00LgUcN@0>LgT00`00LgUcN@1CLgT00`00LgUcN@06LgT00`00LgUcN@05LgT00`00LgUc
N@0cLgT003AcN@03001cNG=i00ecN@03001cNG=i05EcN@03001cNG=i00EcN@03001cNG=i00EcN@03
001cNG=i03=cN@00=G=i00<007=iLgT037=i00<007=iLgT0EG=i00<007=iLgT01G=i00<007=iLgT0
17=i00<007=iLgT0=7=i000eLgT00`00LgUcN@0;LgT00`00LgUcN@1GLgT00`00LgUcN@04LgT00`00
LgUcN@04LgT00`00LgUcN@0dLgT003EcN@03001cNG=i00]cN@03001cNG=i05McN@03001cNG=i00Ac
N@03001cNG=i00AcN@03001cNG=i03AcN@00=W=i00<007=iLgT02G=i00<007=iLgT0FG=i00<007=i
LgT00g=i00<007=iLgT00g=i00<007=iLgT0=G=i000fLgT00`00LgUcN@09LgT00`00LgUcN@1ILgT0
0`00LgUcN@03LgT00`00LgUcN@03LgT00`00LgUcN@0eLgT003McN@03001cNG=i00QcN@03001cNG=i
05UcN@03001cNG=i00=cN@03001cNG=i009cN@03001cNG=i03IcN@00=g=i00<007=iLgT01g=i00<0
07=iLgT0Fg=i00<007=iLgT00W=i00<007=iLgT00W=i00<007=iLgT0=W=i000gLgT00`00LgUcN@07
LgT00`00LgUcN@1KLgT00`00LgUcN@02LgT00`00LgUcN@02LgT00`00LgUcN@0fLgT003QcN@03001c
NG=i00EcN@03001cNG=i05ecN@05001cNG=iLgT00003LgT00`00LgUcN@0gLgT003QcN@03001cNG=i
00EcN@03001cNG=i05ecN@05001cNG=iLgT00003LgT00`00LgUcN@0gLgT003UcN@03001cNG=i00Ac
N@03001cNG=i05ecN@05001cNG=iLgT00002LgT00`00LgUcN@0hLgT003UcN@03001cNG=i00=cN@03
001cNG=i05mcN@04001cNG=i0002LgT00`00LgUcN@0hLgT003UcN@03001cNG=i00=cN@03001cNG=i
05mcN@04001cNG=i0002LgT00`00LgUcN@0hLgT000McN@AoobmcN@@00003LiacNG=i02ecN@Aooc1c
N@AcW003001cNG=i02acN@Aoo`UcN@001G=i27oo;7=i17>L0P000W>L:g=i27oo;7=i27>L:g=i27oo
1g=i0005LgT00goo000000030002Ool/LgT00g>L000000030002Li`[LgT2Ool40002Ool/LgT70000
0g>LLgUcN@0YLgT00goo0000000400000gooLgUcN@05LgT000AcN@04Ool00000Ool20004OolZLgT0
0g>L00000002Li`20003Li`YLgT2Ool20002Ool20002OolZLgT2Li`200000g>L00000003Li`YLgT3
Ool200000goo00000002Ool6LgT000AcN@9oo`@000AoobYcN@03Li`00000009cW08000=cW2UcN@9o
o`8000IoobYcN@9cW0800003Li`0000000=cW2UcN@Aoo`8000Aoo`IcN@0017=i00Aoo`00001oo`80
00AoobYcN@03Li`00000009cW08000=cW2UcN@9oo`80009oo`80009oobYcN@9cW0800003Li`00000
00=cW2UcN@Eoo`8000=oo`IcN@0017=i0Woo0`001Goo:W=i0W>L1P000W>L:G=i0goo10000goo:W=i
0W>L100017>L:G=i0Woo0P000Woo0P000Woo1W=i0005LgT8Ool00g=i0000000YLgT8Li`[LgT8Ool/
LgT00g>L00000005Li`YLgT200000goo00000002Ool200000gooLgUcN@05LgT000EcN@Qoo`=cN@<0
02IcN@QcW2]cN@QoobacN@<000EcW2IcN@<0009cN@9oo`@0009oo`McN@001g=i17oo27=i0P009W=i
17>L0W=i0P00:g=i17oo;7=i0P000W=i17>L9W=i0P001g=i17oo2G=i000ELgT2000/LgT00`00LgUc
N@0ZLgT00`00LgUcN@0ZLgT00`00LgUcN@0ZLgT2000FLgT001McN@<002YcN@03001cNG=i02UcN@03
001cNG=i02UcN@03001cNG=i02QcN@<001QcN@006W=i0P00:G=i00<007=iLgT0:7=i00<007=iLgT0
:7=i00<007=iLgT09g=i0P006g=i000LLgT3000WLgT2000XLgT00`00LgUcN@0VLgT2000WLgT3000M
LgT001mcN@8002McN@03001cNG=i02EcN@03001cNG=i02EcN@03001cNG=i02EcN@80021cN@008G=i
0`009G=i00<007=iLgT097=i00<007=iLgT097=i00<007=iLgT08g=i0`008W=i000TLgT2000TLgT0
0`00LgUcN@0SLgT00`00LgUcN@0SLgT00`00LgUcN@0RLgT2000ULgT002IcN@<0029cN@03001cNG=i
029cN@03001cNG=i029cN@03001cNG=i021cN@<002McN@00:G=i0P008G=i0P008W=i00<007=iLgT0
87=i0P008G=i0P00:W=i000[LgT3000PLgT00`00LgUcN@0OLgT00`00LgUcN@0OLgT00`00LgUcN@0N
LgT3000/LgT002icN@8001mcN@03001cNG=i01icN@03001cNG=i01icN@03001cNG=i01ecN@8002mc
N@00<7=i0P007W=i00<007=iLgT07G=i00<007=iLgT07G=i00<007=iLgT077=i0P00<G=i000bLgT3
000LLgT2000MLgT00`00LgUcN@0KLgT2000LLgT3000cLgT003EcN@8001acN@03001cNG=i01YcN@03
001cNG=i01YcN@03001cNG=i01YcN@8003IcN@00=g=i0`006W=i00<007=iLgT06G=i00<007=iLgT0
6G=i00<007=iLgT067=i0`00>7=i000jLgT2000ILgT00`00LgUcN@0HLgT00`00LgUcN@0HLgT00`00
LgUcN@0GLgT2000kLgT003acN@<001McN@8001QcN@03001cNG=i01IcN@8001McN@<003ecN@00?g=i
0P005g=i00<007=iLgT05G=i00<007=iLgT05G=i00<007=iLgT05G=i0P00@7=i0011LgT3000ELgT0
0`00LgUcN@0DLgT00`00LgUcN@0DLgT00`00LgUcN@0CLgT30012LgT004AcN@8001AcN@03001cNG=i
01=cN@03001cNG=i01=cN@03001cNG=i019cN@8004EcN@00AW=i0`004W=i0P004g=i00<007=iLgT0
4G=i0P004W=i0`00Ag=i0019LgT2000BLgT00`00LgUcN@0@LgT00`00LgUcN@0@LgT00`00LgUcN@0@
LgT2001:LgT004]cN@80015cN@03001cNG=i00mcN@03001cNG=i00mcN@03001cNG=i00mcN@8004ac
N@00CG=i0`003g=i00<007=iLgT03W=i00<007=iLgT03W=i00<007=iLgT03G=i0`00CW=i001@LgT2
000>LgT2000>LgT00`00LgUcN@0<LgT2000>LgT2001ALgT0059cN@<000ecN@03001cNG=i00]cN@03
001cNG=i00]cN@03001cNG=i00]cN@<005=cN@00EG=i0P0037=i00<007=iLgT02W=i00<007=iLgT0
2W=i00<007=iLgT02W=i0P00EW=i001GLgT3000:LgT00`00LgUcN@09LgT00`00LgUcN@09LgT00`00
LgUcN@08LgT3001HLgT005YcN@8000UcN@03001cNG=i00QcN@03001cNG=i00QcN@03001cNG=i00Mc
N@8005]cN@00G7=i0`001g=i0P0027=i00<007=iLgT01W=i0P001g=i0`00GG=i001OLgT20007LgT0
0`00LgUcN@05LgT00`00LgUcN@05LgT00`00LgUcN@05LgT2001PLgT0065cN@<000EcN@03001cNG=i
00AcN@03001cNG=i00AcN@03001cNG=i00=cN@<0069cN@00I7=i0P0017=i00<007=iLgT00g=i00<0
07=iLgT00g=i00<007=iLgT00W=i0P00IG=i001VLgT20003LgT200000g=iLiacW002Li`2LgT20003
LgT2001WLgT006QcN@<00003LgUcW00000D00003LiacNG=i00<006UcN@00Jg=i00@007>LLiacW080
00=cW08006acN@00Jg=i17>L0P0017>LKG=i001[LgT4Li`20004Lia]LgT006]cN@=cW0D0009cW6ec
N@00Jg=i17>L0P0017>LKG=i001/LgT4Li`300000g>LLgUcN@1/LgT006acN@QcW6icN@00KW=i17>L
L7=i0000\
\>"],
    ImageRangeCache->{{{0, 225}, {138.375, 0}} -> {-2, 0, 0, 0}},
    CellTags->"Mutation - mutant 9"]
}], "Text"],

Cell[CellGroupData[{

Cell["Introduction", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "This notebook contains programs and examples of operators used in the ",
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " evolutionary algorithm environment. In the current version of ",
  StyleBox["Evolvica",
    FontSlant->"Italic"],
  " the following genetic operators are implemented: "
}], "Text"],

Cell[TextData[
"\[Bullet] mutation \n\[Bullet] recombination \n\[Bullet] duplication \n\
\[Bullet] deletion \n\[Bullet] inversion \n\[Bullet] encapsulation \n\
\[Bullet] decapsulation \n\[Bullet] macro extraction"], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Operator examples", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Mutation", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Mutation - Intro"],

Cell[CellGroupData[{

Cell["Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patterns =
{
  f[__, _g, __, _h, __],
  
  g[a | b | c, __],
  
  h[_Integer | _Symbol, __g],
  
  a, b, c, d, e,
  
  Sequence @@ Range[1,5]
};\
\>", "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating S-expression chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos =
createChromosomes[1, 
                 StartPattern -> _f,
                 SequenceRange -> {1,2},
                 MaxDepth -> 6,
                 ExprPatterns -> patterns]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> .2];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.18254 .45617 -5 -6 ]
[.18254 .45617 5 6 ]
[.29197 .30902 -5 -6 ]
[.29197 .30902 5 6 ]
[.34127 .30902 -5 -6 ]
[.34127 .30902 5 6 ]
[.30719 .16187 -5 -6 ]
[.30719 .16187 5 6 ]
[.39057 .16187 -5 -6 ]
[.39057 .16187 5 6 ]
[.47396 .16187 -5 -6 ]
[.47396 .16187 5 6 ]
[.39057 .30902 -5 -6 ]
[.39057 .30902 5 6 ]
[.34127 .45617 -5 -6 ]
[.34127 .45617 5 6 ]
[.5 .45617 -5 -6 ]
[.5 .45617 5 6 ]
[.60943 .30902 -5 -6 ]
[.60943 .30902 5 6 ]
[.57535 .16187 -5 -6 ]
[.57535 .16187 5 6 ]
[.74211 .16187 -5 -6 ]
[.74211 .16187 5 6 ]
[.65873 .30902 -5 -6 ]
[.65873 .30902 5 6 ]
[.62465 .16187 -5 -6 ]
[.62465 .16187 5 6 ]
[.70077 .01472 -5 -6 ]
[.70077 .01472 5 6 ]
[.79142 .01472 -5 -6 ]
[.79142 .01472 5 6 ]
[.88207 .01472 -5 -6 ]
[.88207 .01472 5 6 ]
[.79142 .16187 -5 -6 ]
[.79142 .16187 5 6 ]
[.70803 .30902 -5 -6 ]
[.70803 .30902 5 6 ]
[.65873 .45617 -5 -6 ]
[.65873 .45617 5 6 ]
[.81746 .45617 -5 -6 ]
[.81746 .45617 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.18254 .45617 L
s
.5 .60332 m
.34127 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.65873 .45617 L
s
.5 .60332 m
.81746 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.18254 .45617 Mdot
0 g
gsave
.18254 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.34127 .45617 m
.29197 .30902 L
s
.34127 .45617 m
.34127 .30902 L
s
.34127 .45617 m
.39057 .30902 L
s
1 g
.05 w
.29197 .30902 Mdot
0 g
gsave
.29197 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.34127 .30902 Mdot
0 g
gsave
.34127 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39057 .30902 m
.30719 .16187 L
s
.39057 .30902 m
.39057 .16187 L
s
.39057 .30902 m
.47396 .16187 L
s
1 g
.05 w
.30719 .16187 Mdot
0 g
gsave
.30719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39057 .16187 Mdot
0 g
gsave
.39057 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.47396 .16187 Mdot
0 g
gsave
.47396 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39057 .30902 Mdot
0 g
gsave
.39057 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.34127 .45617 Mdot
0 g
gsave
.34127 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .45617 Mdot
0 g
gsave
.5 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.65873 .45617 m
.60943 .30902 L
s
.65873 .45617 m
.65873 .30902 L
s
.65873 .45617 m
.70803 .30902 L
s
1 g
.05 w
.60943 .30902 Mdot
0 g
gsave
.60943 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.65873 .30902 m
.57535 .16187 L
s
.65873 .30902 m
.74211 .16187 L
s
1 g
.05 w
.57535 .16187 Mdot
0 g
gsave
.57535 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.74211 .16187 Mdot
0 g
gsave
.74211 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.65873 .30902 Mdot
0 g
gsave
.65873 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70803 .30902 m
.62465 .16187 L
s
.70803 .30902 m
.79142 .16187 L
s
1 g
.05 w
.62465 .16187 Mdot
0 g
gsave
.62465 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.79142 .16187 m
.70077 .01472 L
s
.79142 .16187 m
.79142 .01472 L
s
.79142 .16187 m
.88207 .01472 L
s
1 g
.05 w
.70077 .01472 Mdot
0 g
gsave
.70077 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.79142 .01472 Mdot
0 g
gsave
.79142 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.88207 .01472 Mdot
0 g
gsave
.88207 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.79142 .16187 Mdot
0 g
gsave
.79142 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70803 .30902 Mdot
0 g
gsave
.70803 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.65873 .45617 Mdot
0 g
gsave
.65873 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.81746 .45617 Mdot
0 g
gsave
.81746 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.625, 174.062},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[R000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00`?ooool5
o`0001Cooooo1?l0000Cooooo`Go00009?ooool00;oooooo0_l000000ooooooo0000o`00000Doooo
o`;o00000_ooool2o`0001?ooooo0_l000000ooooooo0000o`00000Sooooo`00`?ooool4o`0001So
oooo0_l0000Cooooo`;o000000?oooooo`000?l000008oooool00;oooooo0_l000000ooooooo0000
o`00000Hooooo`;o00004oooool2o`000003ooooool0003o000002?ooooo0030ooooo`?o00005Ooo
ool5o`0001Cooooo1?l0000Tooooo`00f?ooool2o`0001Oooooo0_l0000Vooooo`00f?ooool6o`00
01;ooooo0ol0000Vooooo`00oooooolJooooo`00aOooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo02Kooooo0036ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Wooooo`00aoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool0:?ooool00<Oooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo02Sooooo0038ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00bOooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0:Oooool00<Wooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo02[ooooo003:
ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0[
ooooo`00b_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool0:oooool00<_ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo02cooooo003<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0/ooooo`00c?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0;Oooool00<gooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo02kooooo003>ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0^ooooo`00c_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0;oooool00<oooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02oooooo
003?ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0`ooooo`00d?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<Oooool00=7ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo037ooooo003Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`0booooo`00d_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0<_ooool00=?ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03?ooooo003Cooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0dooooo`00e?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=?ooool00=Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Go
oooo003Eooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0eooooo`00e_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0=_ooool00=Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000003Wooooo003Gooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool0>?ooool0
0=Oooooo2OoVi^Hiooooo`00e_ooool3onKViPCo00001?oVi^Hhooooo`00e_ooool6onKViP;o0000
0ooVi^Hhooooo`00E_ooool5o`00017ooooo1Ol0000Aooooo`Ko00005_ooool4o`0000[ooooo1Ol0
000Jooooo`Co00001_ooool4onKViPGo00001?oVi^Hgooooo`00EOooool2o`000003ooooool0003o
0000017ooooo0_l000000ooooooo0000o`00000Cooooo`;o000000?oooooo`000?l000005Oooool2
o`0000;ooooo0_l00008ooooo`;o000000?oooooo`000?l000006_ooool2o`0000;ooooo0_l00005
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`00E_ooool4o`0001;ooooo1?l0000Doooo
o`;o00005oooool2o`0000gooooo1?l0000Nooooo`;o00001Oooool3onKViP;o00000_oVi^H2o`00
00Coi^KV=oooool005Gooooo0_l000000ooooooo0000o`00000Aooooo`;o000000?oooooo`000?l0
00005Oooool2o`0001Kooooo0_l00002ooooo`;o00002?ooool2o`000003ooooool0003o000001ko
oooo0_l00005ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`00E_ooool3o`0001?ooooo
0ol0000Cooooo`;o00000_ooool2o`0001Kooooo1?l0000:ooooo`?o00006oooool5o`0000Kooooo
1?oVi^H6o`0000?oi^KV=oooool008;ooooo0_l00002ooooo`;o0000@_ooool2o`0000[ooooo2ooV
i^Hhooooo`00Poooool4o`0004?ooooo1_l00006ooooo`_oi^KV>?ooool00=Oooooo2OoVi^Hioooo
o`00Foooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00_ooooo00?o0000onKVi_oV
i^H00ooVi^Hkooooo`00G?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool08?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01Cooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0oooooo`00G?ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0oooooo`00GOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`10ooooo`00GOooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`10oooo
o`00G_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`11ooooo`00G_ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`12ooooo`00Gooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`12ooooo`00Goooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`13ooooo`00H?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`13ooooo`00HOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`14ooooo`00HOooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`14ooooo`00H_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0;?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`15ooooo`00H_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`16
ooooo`00Hoooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`16ooooo`00Hoooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`17ooooo`00
I?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
<?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`17ooooo`00I?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`18ooooo`00IOooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`19ooooo`00IOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`19ooooo`00I_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool00ol0003o
ooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool0B_ooool006Oo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Ko
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool0B_ooool006Oooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Sooooo
00?o0000ooooooooool02_ooool2o`0000cooooo00?o0000ooooooooool0Boooool006Sooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Sooooo00?o
0000ooooooooool02_ooool2o`0000cooooo00?o0000ooooooooool0Boooool006Sooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03[ooooo00?o0000
ooooooooool02Oooool2o`0000_ooooo00?o0000ooooooooool0C?ooool006Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03cooooo00?o0000oooo
ooooool01oooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo04gooooo001Yoooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0loooo
o`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`1=
ooooo`00J_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0?_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`1>ooooo`00J_ooool00ol0003oooooonKViP04onKViP03ooooool0003ooooo
03oooooo00?o0000oooooooVi^H01?oVi^H00ooooooo0000ooooo`03ooooo`03o`000?ooooooi^KV
00Coi^KV00?oooooo`000?ooool0Coooool006[ooooo2OoVi^I0ooooo`Woi^KV1?ooool9onKViU3o
oooo001Yooooo`?oi^KV1?l00004onKViSkooooo0ooVi^H4o`0000Coi^KV0_ooool3onKViPCo0000
1?oVi^I?ooooo`00JOooool6onKViP;o00000ooVi^Hnooooo`Koi^KV0_l00003onKViP;ooooo1_oV
i^H2o`0000?oi^KVCoooool0057ooooo1Ol00009ooooo`Co00001Oooool4onKViPGo00001?oVi^Hb
ooooo`Go00001Oooool4onKViPGo00002?oVi^H5o`0000Coi^KVC_ooool0053ooooo0_l000000ooo
oooo0000o`000009ooooo`;o00000_ooool2o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKV
iS7ooooo0_l000000ooooooo0000o`000006ooooo`?oi^KV0_l00002onKViP;o00001ooVi^H2o`00
00;oi^KV0_l00004onKViTkooooo001Aooooo`Co00003Oooool2o`0000Cooooo0ooVi^H2o`0000;o
i^KV0_l00004onKViS7ooooo0_l000000ooooooo0000o`000006ooooo`?oi^KV0_l00002onKViP;o
00001ooVi^H2o`0000;oi^KV0_l00004onKViTkooooo001@ooooo`;o000000?oooooo`000?l00000
3Oooool2o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKViS7ooooo0_l000000ooooooo0000
o`000006ooooo`?oi^KV0_l00002onKViP;o00001ooVi^H2o`0000;oi^KV0_l00004onKViTkooooo
001Aooooo`?o00002_ooool5o`0000Gooooo1?oVi^H6o`0000?oi^KV<_ooool4o`0000Kooooo1?oV
i^H6o`0000Ooi^KV1_l00003onKViTkooooo001Nooooo`;o00002Oooool;onKViSGooooo0_l00007
ooooo`_oi^KV0_ooool;onKViToooooo001Nooooo`Ko00001Oooool;onKViSCooooo0ol00007oooo
o`_oi^KV0_ooool;onKViToooooo001Zooooo`Woi^KV@?ooool9onKViPCooooo2OoVi^I@ooooo`00
K?ooool5onKViTCooooo1OoVi^H8ooooo`Goi^KVD_ooool005Gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Cooooo001Fooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0mooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Dooooo`00E_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0EOooool005Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Go
oooo001Gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0oooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Eooooo`00Eoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0@?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0E_ooool005Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo05Kooooo001Hooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Fooooo`00F?ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0Eoooool005Sooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Oooooo001Iooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`13ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Gooooo`00FOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0A?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0F?ooool0
05Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
04Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
05Sooooo001Jooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`15ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Hooooo`00F_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0A_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0FOooool005_ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo05Wooooo001Kooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Iooooo`00Foooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0F_ooool005cooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05[ooooo001Looooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Jooooo`00G?oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000C?ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool00000GOooool005gooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo04_ooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooooooo05_ooooo001Mooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`1;ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1K
ooooo`00GOooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0C?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0G?ooool005kooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`1=ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0G?ooool005kooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`1=ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0G?ooool005kooooo
00Ko0000oooooooooooo0000ooooool0001@ooooo`06o`000?ooooooooooo`000?oooooo0000Gooo
ool005oooooo1OoVi^IAooooo`Goi^KVGoooool005gooooo2OoVi^I=ooooo`Woi^KVGOooool005co
oooo0ooVi^H4o`0000Coi^KVBoooool;onKViUcooooo001Looooo`Koi^KV0_l00003onKViT_ooooo
2ooVi^ILooooo`002?ooool5o`0002Oooooo1?l0000Sooooo`Coi^KV1Ol00004onKViR;ooooo1Ol0
000Rooooo`?oi^KV1ol00003onKViR7ooooo1_l0000Uooooo`Ko00002Oooool000Wooooo0_l00000
0ooooooo0000o`00000Uooooo`;o00009_ooool3onKViP;o00000_oVi^H2o`0000Coi^KV8Oooool2
o`000003ooooool0003o000002?ooooo1?oVi^H2o`000003onKVi_l0003o000000Coi^KV8_ooool2
o`000003ooooool0003o000002Kooooo0_l000000ooooooo0000o`000009ooooo`002Oooool2o`00
0003ooooool0003o000002Gooooo1_l0000Rooooo`?oi^KV0_l00002onKViP;o00001?oVi^HQoooo
o`;o000000?oooooo`000?l000008oooool4onKViP;o000000?oi^KVo`000?l000001?oVi^HSoooo
o`;o0000:Oooool2o`0000_ooooo0009ooooo`;o000000?oooooo`000?l000009Oooool2o`0000;o
oooo0_l0000Rooooo`?oi^KV0_l00002onKViP;o00001?oVi^HQooooo`;o000000?oooooo`000?l0
00008oooool4onKViP;o000000?oi^KVo`000?l000001?oVi^HTooooo`;o0000:Oooool2o`0000[o
oooo0009ooooo`Co00001Oooool2o`00023ooooo1?l0000Sooooo`Coi^KV1_l00003onKViR;ooooo
1?l0000Sooooo`Coi^KV1?l00005onKViR7ooooo0_l00002ooooo`;o00008?ooool2o`0000?ooooo
0_l00002ooooo`;o00002Oooool000Wooooo0_l00009ooooo`?o00009Oooool3o`0001gooooo2ooV
i^HUooooo`;o00009?ooool3onKViP;o00001_oVi^HMooooo`?o00000_ooool2o`0000;ooooo0_l0
000Mooooo`?o00001Oooool2o`0000;ooooo0_l00009ooooo`002?ooool3o`0000cooooo1?l0000T
ooooo`;o00006oooool;onKViRCooooo0ol0000Tooooo`;oi^KV0ol00006onKViQ_ooooo0_l00006
ooooo`Co00006_ooool4o`0000Wooooo1?l0000:ooooo`006oooool3o`0002?ooooo0_l0000Joooo
o`Woi^KV00?oooooo`000?ooool0B?ooool00ol0003oooooonKViP08onKViQ[ooooo0_l0000Soooo
o`?o00006oooool001kooooo0ol0000Rooooo`;o00006_ooool5onKViPCooooo00?o0000oooooooo
ool0AOooool00ol0003oooooooooo`02ooooo`Goi^KV6_ooool2o`0002;ooooo0ol0000Nooooo`00
8Oooool3o`00027ooooo0_l0000Rooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0Pooooo`;o00008Oooool3o`00027ooooo000Tooooo`?o00008?oo
ool2o`00027ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01oooooo0_l0000Pooooo`?o00009?ooool002Oooooo1?l0000Nooooo`;o00008?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool2
o`0001kooooo1?l0000Wooooo`00:oooool3o`0001gooooo0ol0000Nooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Looooo`?o00007Oooool3o`00
02_ooooo000^ooooo`?o00007Oooool2o`0001gooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01_ooooo0_l0000Mooooo`?o0000;_ooool0037ooooo
0ol0000Looooo`;o00007?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool06_ooool2o`0001cooooo0ol0000aooooo`00=?ooool4o`0001[ooooo0_l0
000Kooooo`;o00006oooool00ol0003oooooooooo`0Iooooo`;o00006oooool2o`0001[ooooo1?l0
000dooooo`00>?ooool3o`0001Wooooo0_l0000Kooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0Iooooo`;o00006Oooool3o`0003Sooooo000koooo
o`?o00006?ooool2o`0001[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Sooooo0_l0000Hooooo`?o0000>oooool003kooooo0ol0000Gooooo`;o
00006Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool05oooool2o`0001Oooooo0ol0000nooooo`00@Oooool3o`0001Kooooo0ol0000Gooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`?o0000
5_ooool3o`00047ooooo0014ooooo`Co00005Oooool2o`0001Kooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo0_l0000Eooooo`Co0000A?oo
ool004Sooooo0ol0000Dooooo`;o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool04oooool2o`0001Cooooo0ol00018ooooo`00Boooool3o`00
01?ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`;o00004oooool3o`0004_ooooo001>ooooo`?o00004_ooool2o`0001?o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo0_l0000Booooo`?o0000C_ooool0057ooooo1?l0000@ooooo`;o00004_ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool2o`00013ooooo
1?l0001Aooooo`00EOooool3o`0000oooooo0ol0000@ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`?o00003oooool3o`0005Gooooo001H
ooooo`?o00003oooool2o`0000oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00gooooo0_l0000?ooooo`?o0000F?ooool005_ooooo0ol0000>oooo
o`;o00003_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03?ooool2o`0000kooooo0ol0001Kooooo`00G_ooool3o`0000gooooo0_l0000=ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`;o
00003Oooool3o`0005kooooo001Qooooo`Co00002oooool2o`0000cooooo0_l0000<ooooo`03o`00
0?oooooooooo00[ooooo0_l0000<ooooo`;o00002oooool4o`00067ooooo001Uooooo`?o00002_oo
ool2o`0000cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00[ooooo0_l0000:ooooo`?o0000IOooool006Sooooo0ol00009ooooo`;o00002oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool2
o`0000Wooooo0ol0001Xooooo`00Joooool3o`0000Sooooo0ol00009ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`?o00002?ooool3o`00
06_ooooo001^ooooo`Co00001oooool2o`0000Sooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`Co0000K_ooool007;ooooo
0ol00006ooooo`;o00001oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool2o`0000Kooooo0ol0001booooo`00MOooool3o`0000Gooooo0_l0
0006ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`;o00001Oooool3o`0007Gooooo001hooooo`?o00001?ooool2o`0000Gooooo00Co0000
oooooooooooooooo1OoVi^H3ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`?o0000N?oo
ool007_ooooo0ol00003ooooo`;o00001?ooool00ol0003oi^KVonKViP07onKViP03o`000?oooooo
oooo00;ooooo0_l00003ooooo`?o0000Noooool007kooooo1?l000000ooooooo0000o`000002oooo
o`_oi^KV0_ooool2o`000003ooooool0003o000000;o0000O_ooool008;ooooo1Ol0000;onKViPGo
0000P_ooool008Gooooo00Co0000onKVi_oVi^Koi^KV1_l00004onKViP03o`000?oooooooooo08?o
oooo0026ooooo`Goi^KV0_l00006onKViXKooooo0026ooooo`Goi^KV0_l00006onKViXKooooo0026
ooooo`Goi^KV0_l00006onKViXKooooo0026ooooo`Coi^KV1Ol00004onKViXKooooo0027ooooo`Co
i^KV0_l00005onKViXOooooo0027ooooo`Goi^KV0ol00003onKViXOooooo0028ooooo`Woi^KVR?oo
ool008[ooooo1OoVi^J:ooooo`00\
\>"],
  ImageRangeCache->{{{0, 280.625}, {173.062, 0}} -> {-2.17456, -0.833972, \
0.015498, 0.00501525}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simple GP mutation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["A set of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
mutChromos = Join @@ Table[
Mutation[theChromos, RespectHead -> False,

         MaxDepth -> 6, SequenceRange -> {1,2},
         ExprPatterns -> patterns,
         SelectionMode -> RANDOM], {10}]

mutChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, d, g[a, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], 2, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, c, g[a, g[a, 5, b]]], 2, 2]]], 
      chromo[q[undef], 
        p[f[b, e, g[a, 5, 5], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]], 
      chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, 4]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[3, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, g[e, 5], g[a, g[a, 5, b]]], 2, 
            2]]], chromo[q[undef], 
        p[f[b, e, g[2, 5, g[a, a, 2]], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, 
                  h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, d, g[a, 5, g[a, a, 2]], d, 
                  h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], 2, 
                  h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, h[d, c, g[a, g[a, 5, b]]], 2, 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, 5], d, h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, 
                  h[d, g[c, 5], g[a, g[a, 5, 4]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, 
                  h[3, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, 
                  h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[a, 5, g[a, a, 2]], d, 
                  h[d, g[e, 5], g[a, g[a, 5, b]]], 2, 2]]]\)},
          {\(chromo[q[undef], 
              p[f[b, e, g[2, 5, g[a, a, 2]], d, 
                  h[d, g[c, 5], g[a, g[a, 5, b]]], 2, 2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, d, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], 2, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, c, 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 5], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, 4]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ 3, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ a, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ e, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ b, e, 
                g[ 2, 5, 
                  g[ a, a, 2]], d, 
                h[ d, 
                  g[ c, 5], 
                  g[ a, 
                    g[ a, 5, b]]], 2, 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ mutChromos;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Go00002_ooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001[ooooo`;o000000?oooooo`000?l000004Oooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006cooooo1?l0000E
ooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??ooool2o`000003ooooool0003o
000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViVgooooo001[ooooo`;o000000?oooooo`000?l000005Oooool2o`0000[ooooo1OoVi^H2o`00
00;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00K?ooool3o`0001;o
oooo1Ol0000;ooooo`Koi^KV1_l00006onKViSgooooo1?l0000;ooooo`Ooi^KV1_l00005onKViPCo
oooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo0_l0000>oooooa;oi^KV?oooool2o`0000_ooooo
4_oVi^H4oooooa;oi^KVKOooool0087ooooo1_l0000;oooooa3oi^KV?oooool3o`0000cooooo4?oV
i^H6oooooa3oi^KVK_ooool009;ooooo4?oVi^I>oooooa3oi^KV1_ooool@onKViVkooooo002Coooo
o`koi^KVD?ooool>onKViPSooooo3_oVi^I_ooooo`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`co
i^KVL?ooool009Gooooo2_oVi^IDooooo`[oi^KV3?ooool:onKViW7ooooo001aooooo`03o`000?oo
oooooooo02;ooooo00?o0000onKVi_oVi^H01?oVi^IHooooo`Koi^KV4?ooool6onKViW?ooooo001b
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1g
ooooo`00L_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0C_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Moooool007?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`1hooooo`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0N?ooool007Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001dooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1iooooo`00MOooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Doooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo
001eooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1jooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0Noooool007Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo07_ooooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo001hooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1mooooo`00N?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0F_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0OOooool007Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05_o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07ko
oooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Looooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`1nooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0O_ooool007[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo07oooooo001jooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1oooooo`00Noooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083ooooo001kooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Pooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`20ooooo`00O?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool0
07cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
06;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
087ooooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0P_ooool007gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo08;ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`23ooooo`00O_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Poooool007oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Wooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`24ooooo`00Oooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000J_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool0083ooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo08Gooooo0020ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Yooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`25ooooo`00POooool6onKViP03o`000?oooooooooo06_ooooo1_oVi^H00ol0003o
ooooooooo`26ooooo`00Ooooool:onKViV[ooooo2_oVi^J7ooooo`00O_ooool<onKViVSooooo3?oV
i^J6ooooo`00OOooool>onKViVKooooo3_oVi^J5ooooo`00O?ooool6onKViPCo00001_oVi^IToooo
oa3oi^KVQ?ooool007cooooo2OoVi^H2o`0000Goi^KVI?ooool@onKViXCooooo000<ooooo`Go0000
=_ooool4o`00033ooooo1ooVi^H5o`0000Koi^KV;oooool5o`0002kooooo1_oVi^H7o`0000Goi^KV
;oooool6o`0003Cooooo1_l0000Dooooo`003Oooool2o`000003ooooool0003o000003Cooooo0_l0
000cooooo`Koi^KV0_l00002onKViP;o00001_oVi^H^ooooo`;o000000?oooooo`000?l00000;ooo
ool7onKViP;o000000?oi^KVo`000?l000001_oVi^H`ooooo`;o000000?oooooo`000?l00000=Ooo
ool2o`000003ooooool0003o000001Cooooo000=ooooo`;o000000?oooooo`000?l00000=?ooool6
o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViRkooooo0_l000000ooooooo0000o`00000_
ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViS7ooooo0_l0000hooooo`;o00005_ooool0
00gooooo0_l000000ooooooo0000o`00000dooooo`;o00000_ooool2o`0002oooooo1_oVi^H2o`00
00;oi^KV0_l00006onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooV
i^Ko0000o`000006onKViS;ooooo0_l0000hooooo`;o00005Oooool000gooooo1?l0000fooooo`Co
0000<?ooool7onKViPKo00001OoVi^H_ooooo`Co0000;oooool7onKViPCo00001ooVi^H_ooooo`;o
00000_ooool2o`0003Cooooo0_l00002ooooo`;o00005?ooool000gooooo0_l00009ooooo`?o0000
H?oooolBonKViS7ooooo0_l0000_ooooo`Ooi^KV0_l00009onKViRoooooo0_l00002ooooo`;o0000
;?ooool2o`0000Kooooo0_l00002ooooo`;o00005?ooool000cooooo0ol0000<ooooo`?o0000<ooo
ool3o`0002Sooooo4?oVi^Haooooo`?o0000<?ooool5onKViP?o00002?oVi^HYooooo`;o00001_oo
ool4o`0002[ooooo0ol00009ooooo`Co00005Oooool001kooooo1?l0000booooo`;o00009_ooool@
onKViVCooooo4?oVi^HWooooo`;o0000<_ooool4o`0002Gooooo000Rooooo`?o0000<Oooool2o`00
02Gooooo3_oVi^H00ol0003oooooooooo`1Sooooo`koi^KV9_ooool2o`00037ooooo0ol0000Yoooo
o`009Oooool3o`00033ooooo0_l0000Tooooo`coi^KV0_ooool00ol0003oooooooooo`1Qooooo`03
o`000?ooooooi^KV00_oi^KV9Oooool2o`00033ooooo0ol0000/ooooo`00:?ooool3o`0002oooooo
0_l0000Sooooo`[oi^KV1?ooool00ol0003oooooooooo`1Oooooo`04o`000?ooooooooooooooo`[o
i^KV9?ooool2o`0002oooooo0ol0000_ooooo`00:oooool3o`0002kooooo0_l0000Sooooo`Koi^KV
1oooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo00Cooooo1_oVi^HTooooo`;o0000
;_ooool3o`0003;ooooo000^ooooo`?o0000;Oooool2o`0002oooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo0_l0000]ooooo`?o0000=Ooo
ool0037ooooo1?l0000[ooooo`;o0000;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0;?ooool2o`0002_ooooo1?l0000hooooo`00=Oooool3o`00
02[ooooo0ol0000/ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0Zooooo`?o0000:_ooool3o`0003cooooo000hooooo`?o0000:_ooool2o`0002_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wo
oooo0_l0000Zooooo`?o0000?oooool003_ooooo0ol0000Yooooo`;o0000:_ooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool2o`0002Wooooo
0ol00012ooooo`00?_ooool3o`0002Sooooo0_l0000Yooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0004Gooooo0011
ooooo`Co00009_ooool2o`0002Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo02Kooooo0_l0000Vooooo`Co0000B?ooool004Gooooo0ol0000Uoooo
o`;o00009oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool09Oooool2o`0002Gooooo0ol0001<ooooo`00B?ooool3o`0002Cooooo0_l0000Vooooo`;o
00009Oooool00ol0003oooooooooo`0Sooooo`;o00009_ooool2o`0002Cooooo0ol0001?ooooo`00
Boooool3o`0002?ooooo0_l0000Vooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0Tooooo`;o00008oooool3o`0005;ooooo001>ooooo`?o00008_oo
ool3o`0002Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo02;ooooo0ol0000Rooooo`?o0000EOooool0057ooooo0ol0000Rooooo`;o00008oooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08Oooool2
o`0002;ooooo0ol0001Hooooo`00E?ooool4o`00023ooooo0_l0000Rooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o00008?ooool4o`00
05_ooooo001Hooooo`?o00007oooool2o`00027ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo01oooooo0_l0000Oooooo`?o0000Goooool005_ooooo
0ol0000Nooooo`;o00008?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool07_ooool2o`0001kooooo0ol0001Rooooo`00G_ooool3o`0001gooooo0_l0
000Oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0Mooooo`;o00007Oooool3o`0006Gooooo001Qooooo`?o00007?ooool2o`0001kooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01cooooo0_l0000L
ooooo`?o0000J?ooool006Cooooo1?l0000Jooooo`?o00007?ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool3o`0001[ooooo1?l0001[oooo
o`00J?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`0Iooooo`;o00006_ooool3o`0006oooooo001[ooooo`?o0000
6Oooool2o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo01Sooooo0_l0000Iooooo`?o0000L_ooool006kooooo0ol0000Hooooo`;o00006Ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05ooo
ool2o`0001Sooooo0ol0001eooooo`00LOooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`;o00005oooool3
o`0007Sooooo001dooooo`?o00005_ooool2o`0001Oooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo0_l0000Fooooo`?o0000Noooool007Oo
oooo1?l0000Dooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Co
oooo00?o0000ooooooooool05?ooool2o`0001Cooooo1?l0001nooooo`00Noooool3o`0001?ooooo
0_l0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Cooooo`;o00004oooool3o`0008;ooooo001nooooo`?o00004_ooool3o`0001?ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo0ol0
000Booooo`?o0000QOooool0087ooooo0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool2o`0001;ooooo0ol00028
ooooo`00Q?ooool3o`00017ooooo0_l0000Aooooo`;o00004Oooool00ol0003oooooooooo`0?oooo
o`;o00004Oooool2o`00017ooooo0ol0002;ooooo`00Qoooool4o`0000oooooo0_l0000Aooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`;o
00003oooool4o`0008kooooo002;ooooo`?o00003_ooool2o`00013ooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo0_l0000>ooooo`?o0000
T_ooool008kooooo0ol0000=ooooo`;o00003oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool2o`0000gooooo0ol0002Eooooo`00TOooool3
o`0000cooooo0_l0000>ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0<ooooo`;o00003?ooool3o`0009Sooooo002Dooooo`?o00002oooool2o`00
00gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00_ooooo0_l0000;ooooo`?o0000Voooool009Oooooo0ol0000:ooooo`?o00002oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool3o`0000[o
oooo0ol0002Nooooo`00V_ooool4o`0000Wooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o00002Oooool4o`000:7ooooo
002Nooooo`?o00002?ooool2o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo0_l00008ooooo`?o0000YOooool00:7ooooo0ol00007
ooooo`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool2o`0000Oooooo0ol0002Xooooo`00Y?ooool3o`0000Kooooo0_l00007oooo
o`03o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo00Gooooo0_l00006oooo
o`?o0000Zoooool00:Oooooo0ol00005ooooo`;o00001_ooool00ol0003oooooonKViP09onKViP;o
oooo00?o0000ooooooooool01?ooool2o`0000Gooooo0ol0002^ooooo`00Z_ooool4o`0000?ooooo
0_l00005ooooo`coi^KV00?o0000ooooooooool00oooool2o`0000?ooooo1?l0002aooooo`00[_oo
ool3o`0000;ooooo0_l00002ooooo`koi^KV0oooool2o`0000;ooooo0ol0002eooooo`00/Oooool3
o`000003ooooool0003oi^KV00ooi^KV0_l000001?oooooo0000o`000?l0002hooooo`00]?ooool2
o`00013oi^KV0ol0002kooooo`00]Oooool6onKViPKo00001_oVi^Jmooooo`00]Oooool8onKViP;o
00002?oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmooooo`00]Oooool8onKViP;o00002?oV
i^Jmooooo`00]Oooool7onKViPGo00001_oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmoooo
o`00]_ooool8onKViP?o00001OoVi^Jnooooo`00]_ooool@onKVi[kooooo002gooooo`koi^KV_ooo
ool00;Sooooo3?oVi^K0ooooo`00^Oooool:onKVi/7ooooo002kooooo`Koi^KV`oooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Go00002_ooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001[ooooo`;o000000?oooooo`000?l000004Oooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006cooooo1?l0000E
ooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??ooool2o`000003ooooool0003o
000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViVgooooo001[ooooo`;o000000?oooooo`000?l000005Oooool2o`0000[ooooo1OoVi^H2o`00
00;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00K?ooool3o`0001;o
oooo1Ol0000;ooooo`Koi^KV1_l00006onKViSgooooo1?l0000;ooooo`Ooi^KV1_l00005onKViPCo
oooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo0_l0000>oooooa;oi^KV?oooool2o`0000_ooooo
4_oVi^H4oooooa;oi^KVKOooool0087ooooo1_l0000;oooooa3oi^KV?oooool3o`0000cooooo4?oV
i^H6oooooa3oi^KVK_ooool009;ooooo4?oVi^I>oooooa3oi^KV1_ooool@onKViVkooooo002Coooo
o`koi^KVD?ooool>onKViPSooooo3_oVi^I_ooooo`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`co
i^KVL?ooool009Gooooo2_oVi^IDooooo`[oi^KV3?ooool:onKViW7ooooo001aooooo`03o`000?oo
oooooooo02;ooooo00?o0000onKVi_oVi^H01?oVi^IHooooo`Koi^KV4?ooool6onKViW?ooooo001b
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1g
ooooo`00L_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0C_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Moooool007?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`1hooooo`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0N?ooool007Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001dooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1iooooo`00MOooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Doooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo
001eooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1jooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0Noooool007Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo07_ooooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo001hooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1mooooo`00N?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0F_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0OOooool007Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05_o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07ko
oooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Looooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`1nooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0O_ooool007[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo07oooooo001jooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1oooooo`00Noooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083ooooo001kooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Pooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`20ooooo`00O?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool0
07cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
06;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
087ooooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0P_ooool007gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo08;ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`23ooooo`00O_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Poooool007oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Wooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`24ooooo`00Oooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000J_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool0083ooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo08Gooooo0020ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Yooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`25ooooo`00POooool6onKViP03o`000?oooooooooo06_ooooo1_oVi^H00ol0003o
ooooooooo`26ooooo`00Ooooool:onKViV[ooooo2_oVi^J7ooooo`00O_ooool<onKViVSooooo3?oV
i^J6ooooo`00OOooool>onKViVKooooo3_oVi^J5ooooo`00O?ooool6onKViPCo00001_oVi^IToooo
oa3oi^KVQ?ooool007cooooo2OoVi^H2o`0000Goi^KVI?ooool@onKViXCooooo000<ooooo`Go0000
=_ooool5o`0002oooooo1ooVi^H5o`0000Koi^KV;oooool5o`0002kooooo1_oVi^H7o`0000Goi^KV
;oooool6o`0003Cooooo1_l0000Dooooo`003Oooool2o`000003ooooool0003o000003Cooooo0_l0
00000ooooooo0000o`00000`ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H^ooooo`;o000000?o
ooooo`000?l00000;oooool7onKViP;o000000?oi^KVo`000?l000001_oVi^H`ooooo`;o000000?o
ooooo`000?l00000=Oooool2o`000003ooooool0003o000001Cooooo000=ooooo`;o000000?ooooo
o`000?l00000=?ooool2o`000003ooooool0003o0000033ooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006
onKViS7ooooo0_l0000hooooo`;o00005_ooool000gooooo0_l000000ooooooo0000o`00000doooo
o`;o000000?oooooo`000?l00000<?ooool6onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`00
0003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV<_ooool2o`00
03Sooooo0_l0000Eooooo`003Oooool4o`0003Kooooo1?l0000`ooooo`Ooi^KV1_l00005onKViRoo
oooo1?l0000_ooooo`Ooi^KV1?l00007onKViRoooooo0_l00002ooooo`;o0000=?ooool2o`0000;o
oooo0_l0000Dooooo`003Oooool2o`0000Wooooo0ol0000^ooooo`;o0000<?oooolBonKViS7ooooo
0_l0000_ooooo`Ooi^KV0_l00009onKViRoooooo0_l00002ooooo`;o0000;?ooool2o`0000Kooooo
0_l00002ooooo`;o00005?ooool000cooooo0ol0000<ooooo`?o0000:_ooool3o`0000Kooooo0ol0
000Xoooooa3oi^KV<Oooool3o`00033ooooo1OoVi^H3o`0000Soi^KV:Oooool2o`0000Kooooo1?l0
000Zooooo`?o00002Oooool4o`0001Gooooo000Nooooo`Co0000<_ooool2o`0002Kooooo4?oVi^IT
oooooa3oi^KV9oooool2o`0003;ooooo1?l0000Uooooo`008_ooool3o`00037ooooo0_l0000Uoooo
o`koi^KV00?o0000ooooooooool0Hoooool>onKViRKooooo0_l0000aooooo`?o0000:Oooool002Go
oooo0ol0000`ooooo`;o00009?ooool<onKViP;ooooo00?o0000ooooooooool0HOooool00ol0003o
ooooonKViP0;onKViRGooooo0_l0000`ooooo`?o0000;?ooool002Sooooo0ol0000_ooooo`;o0000
8oooool:onKViPCooooo00?o0000ooooooooool0Goooool01?l0003oooooooooooooool:onKViRCo
oooo0_l0000_ooooo`?o0000;oooool002_ooooo0ol0000^ooooo`;o00008oooool6onKViPOooooo
00?o0000ooooooooool0GOooool00ol0003oooooooooo`04ooooo`Koi^KV9?ooool2o`0002kooooo
0ol0000booooo`00;_ooool3o`0002gooooo0_l0000_ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool0;?ooool00ol0003oooooooooo`0]ooooo`;o0000;Oooool3o`0003Gooooo000a
ooooo`Co0000:oooool2o`0002kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo02cooooo0_l0000[ooooo`Co0000>?ooool003Gooooo0ol0000Zoooo
o`?o0000;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool0:_ooool3o`0002[ooooo0ol0000looooo`00>?ooool3o`0002[ooooo0_l0000[ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`;o
0000:_ooool3o`0003oooooo000kooooo`?o0000:Oooool2o`0002[ooooo00?o0000ooooooooool0
:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0_l0000Yooooo`?o0000
@_ooool003kooooo0ol0000Xooooo`;o0000:Oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool09oooool2o`0002Sooooo0ol00015ooooo`00@Oooool4
o`0002Kooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0Vooooo`;o00009_ooool4o`0004Sooooo0015ooooo`?o00009Oooool2o`00
02Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
02Gooooo0_l0000Uooooo`?o0000C?ooool004Sooooo0ol0000Tooooo`;o00009_ooool2o`0002Go
oooo00?o0000ooooooooool08oooool2o`0002Kooooo0_l0000Tooooo`?o0000Coooool004_ooooo
0ol0000Sooooo`;o00009_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool09?ooool2o`0002?ooooo0ol0001Booooo`00C_ooool3o`0002;ooooo0ol0
000Tooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`?o00008_ooool3o`0005Gooooo001Aooooo`?o00008_ooool2o`0002?ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo027ooooo0_l0000R
ooooo`?o0000F?ooool005Cooooo1?l0000Pooooo`;o00008_ooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool2o`00023ooooo1?l0001Koooo
o`00F?ooool3o`0001oooooo0_l0000Qooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`0Oooooo`;o00007oooool3o`0005oooooo001Kooooo`?o0000
7_ooool2o`00023ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo01kooooo0_l0000Nooooo`?o0000H_ooool005kooooo0ol0000Mooooo`;o00007ooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07Ooo
ool2o`0001gooooo0ol0001Uooooo`00HOooool3o`0001cooooo0_l0000Nooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`;o00007?ooool3
o`0006Sooooo001Tooooo`Co00006_ooool3o`0001cooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo0ol0000Jooooo`Co0000Joooool006So
oooo0ol0000Jooooo`;o00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06Oooool2o`0001[ooooo0ol0001_ooooo`00Joooool3o`0001Wooooo
0_l0000Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0Hooooo`;o00006Oooool3o`0007;ooooo001^ooooo`?o00006?ooool2o`0001Wooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0_l0
000Hooooo`?o0000MOooool0077ooooo0ol0000Gooooo`;o00006?ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool2o`0001Oooooo0ol0001h
ooooo`00M?ooool3o`0001Kooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`0Eooooo`;o00005_ooool3o`0007_ooooo001gooooo`Co
00005?ooool2o`0001Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo01Cooooo0_l0000Dooooo`Co0000O_ooool007_ooooo0ol0000Cooooo`;o0000
5Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4oooool2o`0001?ooooo0ol00022ooooo`00O_ooool3o`0001;ooooo0ol0000Cooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`?o00004_oo
ool3o`0008Gooooo0021ooooo`?o00004_ooool2o`0001;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo0_l0000Booooo`?o0000R?ooool0
08Cooooo0ol0000Aooooo`;o00004Oooool2o`00017ooooo00?o0000ooooooooool03oooool2o`00
017ooooo0_l0000Aooooo`?o0000Roooool008Oooooo1?l0000?ooooo`;o00004Oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03oooool2o`0000oo
oooo1?l0002>ooooo`00Roooool3o`0000kooooo0_l0000@ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`;o00003_ooool3o`0009;ooooo
002>ooooo`?o00003Oooool2o`0000oooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00gooooo0_l0000=ooooo`?o0000UOooool0097ooooo0ol0000<
ooooo`;o00003_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool03?ooool2o`0000cooooo0ol0002Hooooo`00U?ooool3o`0000_ooooo0_l0000=oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;oooo
o`;o00002oooool3o`0009_ooooo002Gooooo`?o00002_ooool3o`0000_ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo0ol0000:ooooo`?o
0000W_ooool009[ooooo1?l00009ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool02?ooool2o`0000Wooooo1?l0002Qooooo`00W_oo
ool3o`0000Sooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`07ooooo`;o00002?ooool3o`000:Gooooo002Qooooo`?o00001oooool2
o`0000Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Kooooo0_l00007ooooo`?o0000Z?ooool00:Cooooo0ol00006ooooo`;o00001oooool00ol0
003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`05ooooo`;o00001_ooool3o`00
0:_ooooo002Wooooo`?o00001Oooool2o`0000Kooooo00?o0000oooooooVi^H02OoVi^H2ooooo`03
o`000?oooooooooo00Cooooo0_l00005ooooo`?o0000[_ooool00:[ooooo1?l00003ooooo`;o0000
1Oooool<onKViP03o`000?oooooooooo00?ooooo0_l00003ooooo`Co0000/Oooool00:kooooo0ol0
0002ooooo`;o00000_ooool>onKViP?ooooo0_l00002ooooo`?o0000]Oooool00;7ooooo0ol00000
0ooooooo0000onKViP0?onKViP;o000000Coooooo`000?l0003o0000^?ooool00;Cooooo0_l0000@
onKViP?o0000^oooool00;Gooooo1_oVi^H6o`0000Koi^KV_Oooool00;Gooooo2?oVi^H2o`0000So
i^KV_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV_Ooo
ool00;Gooooo1ooVi^H5o`0000Koi^KV_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV_Oooool00;Ko
oooo2?oVi^H3o`0000Goi^KV__ooool00;Kooooo4?oVi^Jnooooo`00]oooool>onKVi[oooooo002h
ooooo`coi^KV`?ooool00;Wooooo2_oVi^K1ooooo`00^oooool6onKVi/?ooooo0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Go00002_ooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001[ooooo`;o000000?oooooo`000?l000004Oooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006cooooo1?l0000E
ooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??ooool2o`000003ooooool0003o
000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViVgooooo001[ooooo`;o000000?oooooo`000?l000005Oooool2o`0000[ooooo1OoVi^H2o`00
00;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00K?ooool3o`0001;o
oooo1Ol0000;ooooo`Koi^KV1_l00006onKViSgooooo1?l0000;ooooo`Ooi^KV1_l00005onKViPCo
oooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo0_l0000>oooooa;oi^KV?oooool2o`0000_ooooo
4_oVi^H4oooooa;oi^KVKOooool0087ooooo1_l0000;oooooa3oi^KV?oooool3o`0000cooooo4?oV
i^H6oooooa3oi^KVK_ooool009;ooooo4?oVi^I>oooooa3oi^KV1_ooool@onKViVkooooo002Coooo
o`koi^KVD?ooool>onKViPSooooo3_oVi^I_ooooo`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`co
i^KVL?ooool009Gooooo2_oVi^IDooooo`[oi^KV3?ooool:onKViW7ooooo001aooooo`03o`000?oo
oooooooo02;ooooo00?o0000onKVi_oVi^H01?oVi^IHooooo`Koi^KV4?ooool6onKViW?ooooo001b
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1g
ooooo`00L_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0C_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Moooool007?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`1hooooo`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0N?ooool007Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001dooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1iooooo`00MOooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Doooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo
001eooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1jooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0Noooool007Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo07_ooooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo001hooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1mooooo`00N?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0F_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0OOooool007Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05_o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07ko
oooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Looooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`1nooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0O_ooool007[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo07oooooo001jooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1oooooo`00Noooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083ooooo001kooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Pooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`20ooooo`00O?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool0
07cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
06;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
087ooooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0P_ooool007gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo08;ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`23ooooo`00O_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Poooool007oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Wooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`24ooooo`00Oooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000J_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool0083ooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo08Gooooo0020ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Yooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`25ooooo`00POooool6onKViP03o`000?oooooooooo06_ooooo1_oVi^H00ol0003o
ooooooooo`26ooooo`00Ooooool:onKViV[ooooo2_oVi^J7ooooo`00O_ooool<onKViVSooooo3?oV
i^J6ooooo`00OOooool>onKViVKooooo3_oVi^J5ooooo`00O?ooool6onKViPCo00001_oVi^IToooo
oa3oi^KVQ?ooool007cooooo2OoVi^H2o`0000Goi^KVI?ooool@onKViXCooooo000<ooooo`Go0000
=_ooool4o`00033ooooo1ooVi^H5o`0000Koi^KV;_ooool6o`0002kooooo1_oVi^H7o`0000Goi^KV
;oooool6o`0003Cooooo1_l0000Dooooo`003Oooool2o`000003ooooool0003o000003Cooooo0_l0
000cooooo`Koi^KV0_l00002onKViP;o00001_oVi^H_ooooo`;o000000?oooooo`000?l00000;_oo
ool7onKViP;o000000?oi^KVo`000?l000001_oVi^H`ooooo`;o000000?oooooo`000?l00000=Ooo
ool2o`000003ooooool0003o000001Cooooo000=ooooo`;o000000?oooooo`000?l00000=?ooool6
o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViS3ooooo0_l0000`ooooo`Ooi^KV0_l00000
0ooVi^Ko0000o`000006onKViS7ooooo0_l0000hooooo`;o00005_ooool000gooooo0_l000000ooo
oooo0000o`00000dooooo`;o00000_ooool2o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006onKV
iS7ooooo0_l0000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViS;ooooo0_l0000hoooo
o`;o00005Oooool000gooooo1?l0000fooooo`Co0000<?ooool7onKViPKo00001OoVi^H^ooooo`;o
00000_ooool2o`0002kooooo1ooVi^H4o`0000Ooi^KV;oooool2o`0000;ooooo0_l0000dooooo`;o
00000_ooool2o`0001Cooooo000=ooooo`;o00002Oooool3o`00063ooooo4_oVi^H^ooooo`;o0000
0_ooool2o`0002kooooo1ooVi^H2o`0000Woi^KV;oooool2o`0000;ooooo0_l0000/ooooo`;o0000
1_ooool2o`0000;ooooo0_l0000Dooooo`003?ooool3o`0000cooooo0ol0000cooooo`?o0000:?oo
ool@onKViS3ooooo1?l0000`ooooo`Goi^KV0ol00008onKViRWooooo0_l00006ooooo`Co0000:_oo
ool3o`0000Wooooo1?l0000Eooooo`007_ooool4o`0003;ooooo0_l0000Voooooa3oi^KVI?ooool@
onKViROooooo0_l0000booooo`Co00009Oooool002;ooooo0ol0000aooooo`;o00009Oooool>onKV
iP03o`000?oooooooooo06?ooooo3_oVi^HVooooo`;o0000<Oooool3o`0002Wooooo000Uooooo`?o
0000<?ooool2o`0002Cooooo3?oVi^H2ooooo`03o`000?oooooooooo067ooooo00?o0000oooooooV
i^H02ooVi^HUooooo`;o0000<?ooool3o`0002cooooo000Xooooo`?o0000;oooool2o`0002?ooooo
2_oVi^H4ooooo`03o`000?oooooooooo05oooooo00Co0000oooooooooooooooo2_oVi^HTooooo`;o
0000;oooool3o`0002oooooo000[ooooo`?o0000;_ooool2o`0002?ooooo1_oVi^H7ooooo`03o`00
0?oooooooooo05gooooo00?o0000ooooooooool01?ooool6onKViRCooooo0_l0000^ooooo`?o0000
<_ooool002kooooo0ol0000]ooooo`;o0000;oooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool0;Oooool2o`0002gooooo0ol0000eooooo`00<Oooool4
o`0002_ooooo0_l0000^ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0/ooooo`;o0000:oooool4o`0003Sooooo000eooooo`?o0000:_ooool3o`00
02cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02[ooooo0ol0000Zooooo`?o0000??ooool003Sooooo0ol0000Zooooo`;o0000:oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool2o`0002[o
oooo0ol0000oooooo`00>oooool3o`0002Wooooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`;o0000:Oooool3o`0004;ooooo
000nooooo`?o0000:?ooool2o`0002Wooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo02Oooooo0_l0000Xooooo`?o0000AOooool0047ooooo1?l0000V
ooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool09_ooool2o`0002Kooooo1?l00018ooooo`00AOooool3o`0002Gooooo0_l0000Woooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uoooo
o`;o00009Oooool3o`0004cooooo0018ooooo`?o00009?ooool2o`0002Kooooo0_l0000Uooooo`03
o`000?oooooooooo02?ooooo0_l0000Vooooo`;o00009?ooool3o`0004oooooo001;ooooo`?o0000
8oooool2o`0002Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo02Cooooo0_l0000Sooooo`?o0000D_ooool004kooooo0ol0000Rooooo`?o00009?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08_oo
ool3o`0002;ooooo0ol0001Eooooo`00DOooool3o`0002;ooooo0_l0000Sooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qooooo`;o00008_ooool3
o`0005Sooooo001Dooooo`Co00008?ooool2o`0002;ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo0_l0000Pooooo`Co0000Foooool005So
oooo0ol0000Oooooo`;o00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07oooool2o`0001oooooo0ol0001Oooooo`00Foooool3o`0001kooooo
0_l0000Pooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Nooooo`;o00007_ooool3o`0006;ooooo001Nooooo`?o00007Oooool2o`0001oooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo0_l0
000Mooooo`?o0000IOooool0067ooooo0ol0000Looooo`;o00007_ooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool07?ooool2o`0001cooooo0ol0001X
ooooo`00I?ooool4o`0001[ooooo0ol0000Looooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`?o00006_ooool4o`0006_ooooo001Xooooo`?o
00006_ooool2o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01Wooooo0_l0000Jooooo`?o0000Koooool006_ooooo0ol0000Iooooo`;o0000
6_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
6?ooool2o`0001Wooooo0ol0001booooo`00K_ooool3o`0001Sooooo0_l0000Iooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o00006?oo
ool3o`0007Gooooo001aooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000N?ooool0
07Cooooo0ol0000Fooooo`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool05Oooool2o`0001Kooooo0ol0001kooooo`00Moooool4o`0001Co
oooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Dooooo`;o00005?ooool4o`0007kooooo001kooooo`?o00004oooool2o`0001Gooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo
0_l0000Cooooo`?o0000P_ooool007kooooo0ol0000Booooo`?o00004oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool3o`0001;ooooo0ol0
0025ooooo`00POooool3o`0001;ooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`;o00004_ooool3o`0008Sooooo0024oooo
o`?o00004Oooool2o`00017ooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000Aoooo
o`;o00004Oooool3o`0008_ooooo0027ooooo`Co00003oooool2o`00017ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0000?ooooo`Co
0000S_ooool008_ooooo0ol0000>ooooo`;o00004?ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`0000kooooo0ol0002Booooo`00S_oo
ool3o`0000gooooo0_l0000?ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`;o00003Oooool3o`0009Gooooo002Aooooo`?o00003?ooool2
o`0000kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00cooooo0_l0000<ooooo`?o0000V?ooool009Cooooo0ol0000;ooooo`;o00003Oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool2o`00
00_ooooo0ol0002Kooooo`00Uoooool3o`0000[ooooo0ol0000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`?o00002_ooool3o`0009ko
oooo002Jooooo`Co00002Oooool2o`0000[ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l00009ooooo`Co0000XOooool009kooooo0ol0
0008ooooo`;o00002Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool2o`0000Sooooo0ol0002Uooooo`00XOooool3o`0000Oooooo0_l00008
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`;o00001oooool3o`000:Sooooo002Tooooo`?o00001_ooool2o`0000Oooooo00?o0000oooo
ooooool00_ooool6onKViPGooooo00?o0000ooooooooool01Oooool2o`0000Kooooo0ol0002[oooo
o`00Yoooool3o`0000Gooooo0_l00006ooooo`03o`000?ooooooi^KV00Woi^KV0_ooool00ol0003o
ooooooooo`04ooooo`;o00001Oooool3o`000:kooooo002Zooooo`Co00000oooool2o`0000Gooooo
3?oVi^H00ol0003oooooooooo`03ooooo`;o00000oooool4o`000;7ooooo002^ooooo`?o00000_oo
ool2o`0000;ooooo3_oVi^H3ooooo`;o00000_ooool3o`000;Gooooo002aooooo`?o000000?ooooo
o`000?oVi^H03ooVi^H2o`000004ooooool0003o0000o`000;Sooooo002dooooo`;o00004?oVi^H3
o`000;_ooooo002eooooo`Koi^KV1_l00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[go
oooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002e
ooooo`Ooi^KV1Ol00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002fooooo`So
i^KV0ol00005onKVi[kooooo002foooooa3oi^KV__ooool00;Oooooo3_oVi^Joooooo`00^?ooool<
onKVi/3ooooo002iooooo`[oi^KV`Oooool00;_ooooo1_oVi^K3ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002Oooooo1_l0000Gooooo`Go0000C?ooool7onKViPGo00001_oVi^I1ooooo`00J_oo
ool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000Yooooo`;o000000?o
ooooo`000?l000005_ooool2o`000003ooooool0003o000004gooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViT7ooooo001[ooooo`Co0000:?ooool4o`0002[ooooo0_l0000Iooooo`Co0000COooool6
onKViP;o00000_oVi^H2o`0000Koi^KV@Oooool006[ooooo0_l000000ooooooo0000o`00000Woooo
o`;o000000?oooooo`000?l00000:oooool2o`0001Oooooo0_l000000ooooooo0000o`00001=oooo
o`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool3o`0002Wooooo0ol0000Yooooo`;o
00000_ooool2o`0001Oooooo0ol0001>ooooo`Ooi^KV1_l00005onKViT7ooooo0033ooooo`;o0000
0_ooool2o`0006Sooooo4_oVi^I1ooooo`00a?ooool4o`0006[ooooo4?oVi^I2ooooo`00oooooolc
oooooa3oi^KV@_ooool00?oooooo=?ooool>onKViT?ooooo003oooooocGooooo3?oVi^I4ooooo`00
Loooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
BOooool00ol0003oi^KVonKViP08onKViTGooooo001dooooo`03o`000?oooooooooo04Sooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`17ooooo`04o`000?ooooooooooooooo`Koi^KV
Aoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`1?ooooo`00MOooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`15ooooo`03o`000?oooooooooo04oooooo001fooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
04?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0@Oooool00ol0003o
ooooooooo`1Aooooo`00N?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo05;ooooo
001iooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`0aooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0Doooool007Wooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo03;ooooo00?o0000
ooooooooool0?Oooool00ol0003oooooooooo`1Cooooo`00N_ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0koooo
o`03o`000?oooooooooo05Cooooo001kooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo03Wooooo00?o0000oooooooo
ool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo03Oooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`1Fooooo`00OOoo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0>Ooo
ool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo05Oooooo001mooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0jooooo`03o`000?oooooo
oooo03Gooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool0<oooool00ol0
003oooooooooo`1Hooooo`00Ooooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo05Wo
oooo0020ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0oooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0F_ooool0087ooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo047ooooo00?o
0000ooooooooool0;Oooool00ol0003oooooooooo`1Kooooo`00POooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05_ooooo0022ooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo04Kooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1Mooooo`00
Q?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
Aoooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo05kooooo0025ooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`19ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`1Oooooo`00Q_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
063ooooo0027ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`1>ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0HOooool008Sooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`1Rooooo`00ROooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo06?ooooo0029ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo05Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1Toooo
o`00Roooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0E_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo06Gooooo002<ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Hooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`1Wooooo`00SOooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo06Oooooo002>ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`1Looooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool008oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05ko
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Yooooo`00T?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0H?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0Joooool0097ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo06;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1[
ooooo`00T_ooool00ol0003oooooooooo`02ooooo`Koi^KV0oooool00ol0003oooooooooo`1Toooo
o`04o`000?ooooooooooooooo`Koi^KV1?ooool00ol0003oooooooooo`1/ooooo`00Toooool00ol0
003oooooonKViP09onKViP03o`000?oooooooooo06Kooooo00?o0000onKVi_oVi^H02?oVi^H00ooo
oooo0000ooooo`1^ooooo`00U?ooool<onKViVSooooo3?oVi^I`ooooo`00Toooool>onKViVKooooo
3_oVi^I_ooooo`00T_ooool5onKViPCo00001ooVi^ITooooo`Koi^KV1?l00006onKViVkooooo002B
ooooo`Soi^KV0_l00006onKViVCooooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aoooo
o`Co00002oooool6onKViPGo00001ooVi^Hmooooo`Go00004Oooool4o`0000_ooooo1ooVi^H5o`00
00Koi^KVKOooool006_ooooo0_l000000ooooooo0000o`00000Aooooo`;o00000_ooool2o`0000[o
oooo1OoVi^H2o`0000;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000o`00000Aooooo`;o
00000_ooool2o`0000[ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVgooooo001/ooooo`Co0000
5Oooool2o`0000[ooooo1OoVi^H2o`0000;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000
o`00000Aooooo`;o00003_ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006_ooooo0_l0
00000ooooooo0000o`00000Eooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??oo
ool2o`000003ooooool0003o0000017ooooo0_l00002ooooo`;o00002_ooool6onKViP;o00000_oV
i^H2o`0000Koi^KVKOooool006cooooo0ol0000Booooo`Go00002oooool6onKViPKo00001_oVi^Hm
ooooo`Co00004_ooool4o`0000_ooooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo0_l0000>oooo
oa;oi^KV?oooool2o`00027ooooo4_oVi^I]ooooo`00POooool6o`0000_ooooo4?oVi^Hoooooo`?o
00008_ooool@onKViVkooooo002Boooooa3oi^KVI?ooool@onKViVkooooo002Cooooo`koi^KVI_oo
ool>onKViVoooooo002Dooooo`coi^KVJ?ooool<onKViW3ooooo002Eooooo`[oi^KVJ_ooool:onKV
iW7ooooo001aooooo`03o`000?oooooooooo02;ooooo00?o0000onKVi_oVi^H01?oVi^I^ooooo`Ko
i^KVLoooool007;ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo04kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo07Oooooo001booooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`1gooooo`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool0N?ooool007?ooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1hooooo`00M?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0D_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0NOooool007Cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001e
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1C
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1j
ooooo`00MOooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0E?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0N_ooool007Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo05Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo07[ooooo001fooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`1kooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0Noooool007Oooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo001gooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Sooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo07gooooo
001hooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`1Jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`1mooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0Foooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0O_ooool007Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo07kooooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`1nooooo`00N_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0Ooooool007[ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo07oooooo001kooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Oooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`20ooooo`00Noooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo063o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083o
oooo001looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1Qooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`21ooooo`00O?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0H_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0POooool007gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo08;ooooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0I?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0P_ooool007kooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo08?ooooo001nooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`23ooooo`00Ooooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Ioooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool0
07oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
06Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
08Cooooo001oooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00001Zoooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`24oooo
o`00P?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0JOooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0QOooool0083ooooo00Go0000oooo
ooooooooooooo`000003ooooo`03o`000?oooooooooo06Wooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo08Gooooo0021ooooo`Koi^KV00?o0000ooooooooool0Joooool6
onKViP03o`000?oooooooooo08Kooooo001oooooo`[oi^KVJ_ooool:onKViXOooooo001nooooo`co
i^KVJ?ooool<onKViXKooooo001mooooo`koi^KVI_ooool>onKViXGooooo001looooo`Koi^KV1?l0
0006onKViVCooooo4?oVi^J4ooooo`00O?ooool9onKViP;o00001OoVi^IToooooa3oi^KVQ?ooool0
00cooooo1Ol0000fooooo`Co0000<?ooool7onKViPGo00001_oVi^H_ooooo`Go0000;_ooool6onKV
iPOo00001OoVi^H_ooooo`Ko0000=?ooool6o`0001Cooooo000=ooooo`;o000000?oooooo`000?l0
0000=?ooool2o`0003?ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViRkooooo0_l000000ooooooo
0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViS3ooooo0_l000000ooooooo
0000o`00000eooooo`;o000000?oooooo`000?l000005?ooool000gooooo0_l000000ooooooo0000
o`00000dooooo`Ko0000;oooool6onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`000003oooo
ool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV<Oooool2o`0003Sooooo
0_l0000Fooooo`003Oooool2o`000003ooooool0003o000003Cooooo0_l00002ooooo`;o0000;ooo
ool6onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`000003ooooool0003o000002oooooo1ooV
i^H2o`000003onKVi_l0003o000000Koi^KV<_ooool2o`0003Sooooo0_l0000Eooooo`003Oooool4
o`0003Kooooo1?l0000`ooooo`Ooi^KV1_l00005onKViRoooooo1?l0000_ooooo`Ooi^KV1?l00007
onKViRoooooo0_l00002ooooo`;o0000=?ooool2o`0000;ooooo0_l0000Dooooo`003Oooool2o`00
00Wooooo0ol0001Poooooa;oi^KV<Oooool2o`0002oooooo1ooVi^H2o`0000Woi^KV;oooool2o`00
00;ooooo0_l0000/ooooo`;o00001_ooool2o`0000;ooooo0_l0000Dooooo`003?ooool3o`0000co
oooo0ol0000cooooo`?o0000:?ooool@onKViS7ooooo0ol0000`ooooo`Goi^KV0ol00008onKViRWo
oooo0_l00006ooooo`Co0000:_ooool3o`0000Wooooo1?l0000Eooooo`007_ooool4o`0003;ooooo
0_l0000Voooooa3oi^KVI?ooool@onKViROooooo0_l0000booooo`Co00009Oooool002;ooooo0ol0
000aooooo`;o00009Oooool>onKViP03o`000?oooooooooo06?ooooo3_oVi^HVooooo`;o0000<Ooo
ool3o`0002Wooooo000Uooooo`?o0000<?ooool2o`0002Cooooo3?oVi^H2ooooo`03o`000?oooooo
oooo067ooooo00?o0000oooooooVi^H02ooVi^HUooooo`;o0000<?ooool3o`0002cooooo000Xoooo
o`?o0000;oooool2o`0002?ooooo2_oVi^H4ooooo`03o`000?oooooooooo05oooooo00Co0000oooo
oooooooooooo2_oVi^HTooooo`;o0000;oooool3o`0002oooooo000[ooooo`?o0000;_ooool2o`00
02?ooooo1_oVi^H7ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool01?ooool6onKV
iRCooooo0_l0000^ooooo`?o0000<_ooool002kooooo0ol0000]ooooo`;o0000;oooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;Oooool2o`0002go
oooo0ol0000eooooo`00<Oooool4o`0002_ooooo0_l0000^ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0/ooooo`;o0000:oooool4o`0003Sooooo
000eooooo`?o0000:_ooool3o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02[ooooo0ol0000Zooooo`?o0000??ooool003Sooooo0ol0000Z
ooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0:Oooool2o`0002[ooooo0ol0000oooooo`00>oooool3o`0002Wooooo0_l0000Zoooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xoooo
o`;o0000:Oooool3o`0004;ooooo000nooooo`?o0000:?ooool2o`0002Wooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo0_l0000Xooooo`?o
0000AOooool0047ooooo1?l0000Vooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool09_ooool2o`0002Kooooo1?l00018ooooo`00AOoo
ool3o`0002Gooooo0_l0000Wooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Uooooo`;o00009Oooool3o`0004cooooo0018ooooo`?o00009?ooool2
o`0002Kooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo0_l0000Vooooo`;o00009?ooool3
o`0004oooooo001;ooooo`?o00008oooool2o`0002Kooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo02Cooooo0_l0000Sooooo`?o0000D_ooool004ko
oooo0ol0000Rooooo`?o00009?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool08_ooool3o`0002;ooooo0ol0001Eooooo`00DOooool3o`0002;ooooo
0_l0000Sooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`0Qooooo`;o00008_ooool3o`0005Sooooo001Dooooo`Co00008?ooool2o`0002;ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo0_l0
000Pooooo`Co0000Foooool005Sooooo0ol0000Oooooo`;o00008Oooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2o`0001oooooo0ol0001O
ooooo`00Foooool3o`0001kooooo0_l0000Pooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0Nooooo`;o00007_ooool3o`0006;ooooo001Nooooo`?o
00007Oooool2o`0001oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01gooooo0_l0000Mooooo`?o0000IOooool0067ooooo0ol0000Looooo`;o0000
7_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
7?ooool2o`0001cooooo0ol0001Xooooo`00I?ooool4o`0001[ooooo0ol0000Looooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`?o00006_oo
ool4o`0006_ooooo001Xooooo`?o00006_ooool2o`0001_ooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`?o0000Koooool0
06_ooooo0ol0000Iooooo`;o00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool06?ooool2o`0001Wooooo0ol0001booooo`00K_ooool3o`0001So
oooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`0Gooooo`;o00006?ooool3o`0007Gooooo001aooooo`?o00005oooool2o`0001Sooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo
0_l0000Gooooo`?o0000N?ooool007Cooooo0ol0000Fooooo`;o00005oooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool2o`0001Kooooo0ol0
001kooooo`00Moooool4o`0001Cooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`;o00005?ooool4o`0007kooooo001koooo
o`?o00004oooool2o`0001Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo0_l0000Cooooo`?o0000P_ooool007kooooo0ol0000Booooo`?o
00004oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool3o`0001;ooooo0ol00025ooooo`00POooool3o`0001;ooooo0_l0000Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`;o0000
4_ooool3o`0008Sooooo0024ooooo`?o00004Oooool2o`00017ooooo0_l0000Aooooo`03o`000?oo
oooooooo00oooooo0_l0000Aooooo`;o00004Oooool3o`0008_ooooo0027ooooo`Co00003oooool2
o`00017ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00oooooo0_l0000?ooooo`Co0000S_ooool008_ooooo0ol0000>ooooo`;o00004?ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`00
00kooooo0ol0002Booooo`00S_ooool3o`0000gooooo0_l0000?ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`;o00003Oooool3o`0009Go
oooo002Aooooo`?o00003?ooool2o`0000kooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00cooooo0_l0000<ooooo`?o0000V?ooool009Cooooo0ol0
000;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02oooool2o`0000_ooooo0ol0002Kooooo`00Uoooool3o`0000[ooooo0ol0000;
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`?o00002_ooool3o`0009kooooo002Jooooo`Co00002Oooool2o`0000[ooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l00009oooo
o`Co0000XOooool009kooooo0ol00008ooooo`;o00002Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool2o`0000Sooooo0ol0002Uooooo`00
XOooool3o`0000Oooooo0_l00008ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`;o00001oooool3o`000:Sooooo002Tooooo`?o00001_oo
ool2o`0000Oooooo00?o0000ooooooooool00_ooool6onKViPGooooo00?o0000ooooooooool01Ooo
ool2o`0000Kooooo0ol0002[ooooo`00Yoooool3o`0000Gooooo0_l00006ooooo`03o`000?oooooo
i^KV00Woi^KV0_ooool00ol0003oooooooooo`04ooooo`;o00001Oooool3o`000:kooooo002Zoooo
o`Co00000oooool2o`0000Gooooo3?oVi^H00ol0003oooooooooo`03ooooo`;o00000oooool4o`00
0;7ooooo002^ooooo`?o00000_ooool2o`0000;ooooo3_oVi^H3ooooo`;o00000_ooool3o`000;Go
oooo002aooooo`?o000000?oooooo`000?oVi^H03ooVi^H2o`000004ooooool0003o0000o`000;So
oooo002dooooo`;o00004?oVi^H3o`000;_ooooo002eooooo`Koi^KV1_l00006onKVi[gooooo002e
ooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`So
i^KV0_l00008onKVi[gooooo002eooooo`Ooi^KV1Ol00006onKVi[gooooo002eooooo`Soi^KV0_l0
0008onKVi[gooooo002fooooo`Soi^KV0ol00005onKVi[kooooo002foooooa3oi^KV__ooool00;Oo
oooo3_oVi^Joooooo`00^?ooool<onKVi/3ooooo002iooooo`[oi^KV`Oooool00;_ooooo1_oVi^K3
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo003:ooooo`Co0000
4_ooool5o`0003gooooo1?l0000;ooooo`Ooi^KV1Ol00006onKViT7ooooo0039ooooo`;o00000_oo
ool2o`00013ooooo0_l000000ooooooo0000o`00000mooooo`;o00000_ooool2o`0000[ooooo1_oV
i^H2o`0000;oi^KV0_l00006onKViT7ooooo0039ooooo`;o00005Oooool4o`00047ooooo0_l0000:
ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00bOooool2o`0000;ooooo0_l0000@oooo
o`;o000000?oooooo`000?l00000@Oooool2o`0000[ooooo1_oVi^H2o`0000;oi^KV0_l00006onKV
iT7ooooo003:ooooo`Co00004_ooool3o`0003kooooo1Ol0000;ooooo`Ooi^KV1_l00005onKViT7o
oooo003oooooob;ooooo0_l0000>oooooa;oi^KV@Oooool00?oooooo8_ooool6o`0000_ooooo4?oV
i^I2ooooo`00oooooolcoooooa3oi^KV@_ooool00?oooooo=?ooool>onKViT?ooooo003oooooocGo
oooo3?oVi^I4ooooo`00d_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool04oooool00ol0003oi^KVonKViP08onKViTGooooo003Cooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool00=Cooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool00=Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool00=Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool00=Kooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool00=Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool00=Sooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool00=Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool00=Wooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00=[o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool00=_ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool00=cooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool00=cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool00=gooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool00=kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool00=oooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool00>3ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool00>3ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
0>7ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool00>;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool00>?ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool00>Cooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool00>Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool00>Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool00>Kooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool00>Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool00>Sooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool00>Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool00>Wooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool00>[o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool00>_ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool00>cooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo003/ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00kOooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
0>kooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo003_ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo003`ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo003`ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo003aooooo`04o`000?ooooooooooooooo`Koi^KV1?ooool00ol0003ooooo
ooooo`05ooooo`04o`000?ooooooooooooooo`Koi^KV1?ooool00ol0003oooooooooo`1/ooooo`00
l_ooool00ol0003oi^KVonKViP08onKViP03ooooool0003ooooo00Sooooo00?o0000onKVi_oVi^H0
2?oVi^H00ooooooo0000ooooo`1^ooooo`00l_ooool<onKViP[ooooo3?oVi^I`ooooo`00lOooool>
onKViPSooooo3_oVi^I_ooooo`00l?ooool6onKViPCo00001_oVi^H6ooooo`Koi^KV1?l00006onKV
iVkooooo003`ooooo`Woi^KV0_l00005onKViPKooooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo
1Ol0000Aooooo`Co00004Oooool4o`0004Gooooo1Ol0000:ooooo`Ooi^KV1Ol00006onKViPCooooo
1ooVi^H5o`0000Koi^KVKOooool006_ooooo0_l000000ooooooo0000o`00000Aooooo`;o00000_oo
ool2o`0000oooooo0_l00002ooooo`;o0000@oooool2o`000003ooooool0003o000000_ooooo1_oV
i^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVgooooo001/
ooooo`Co00005Oooool2o`0001?ooooo0_l00013ooooo`;o000000?oooooo`000?l000002oooool6
onKViP;o00000_oVi^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool0
06_ooooo0_l000000ooooooo0000o`00000Eooooo`;o00004oooool2o`0004?ooooo0_l000000ooo
oooo0000o`00000;ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^I]ooooo`00K?ooool3o`0001;ooooo1Ol0000@ooooo`Go0000AOooool4o`0000_o
oooo1ooVi^H6o`0000Goi^KV1?ooool7onKViPKo00001OoVi^I]ooooo`00POooool2o`0001?ooooo
0_l0001:ooooo`;o00002ooooolBonKViPCooooo4_oVi^I]ooooo`00POooool6o`0000oooooo1_l0
0015ooooo`?o00003?ooool@onKViPKooooo4?oVi^I^ooooo`00l?ooool@onKViPKooooo4?oVi^I^
ooooo`00lOooool>onKViPSooooo3_oVi^I_ooooo`00l_ooool<onKViP[ooooo3?oVi^I`ooooo`00
loooool:onKViPcooooo2_oVi^Iaooooo`00LOooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo05cooooo1_oVi^H@ooooo`Koi^KVLoooool007;ooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo07Oooooo001booooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1gooooo`00Loooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0Coooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0N?ooool007?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo053ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo07Sooooo
001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`1hooooo`00M?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0NOooool007Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo07Wooooo001eooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1jooooo`00MOooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo001fooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1kooooo`00M_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0E_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Noooool007Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07co
oooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`1Hooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0O?ooool007Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo07gooooo001hooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1mooooo`00NOooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0O_ooool007Wooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07kooooo001iooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Looooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1nooooo`00N_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0GOooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Ooooool0
07[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
05kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
07oooooo001kooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1Oooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`20ooooo`00Noooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo083ooooo001looooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`21ooooo`00O?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool007gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08;ooooo001mooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Sooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`22ooooo`00OOoo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0I?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0P_oo
ool007kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo06Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo08?ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`23ooooo`00Ooooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0Q?ooool007oooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`00001Zooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`24ooooo`00P?ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool0JOooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0QOooool0083ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wo
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo08Gooooo0021ooooo`Ko
i^KV00?o0000ooooooooool0Joooool6onKViP03o`000?oooooooooo08Kooooo001oooooo`[oi^KV
J_ooool:onKViXOooooo001nooooo`coi^KVJ?ooool<onKViXKooooo001mooooo`koi^KVI_ooool>
onKViXGooooo001looooo`Koi^KV1?l00006onKViVCooooo4?oVi^J4ooooo`00O?ooool9onKViP;o
00001OoVi^IToooooa3oi^KVQ?ooool000cooooo1Ol0000fooooo`Co0000<?ooool7onKViPGo0000
1_oVi^H_ooooo`Go0000;_ooool6onKViPOo00001OoVi^H_ooooo`Ko0000=?ooool6o`0001Cooooo
000=ooooo`;o000000?oooooo`000?l00000=?ooool2o`0003?ooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`00
0006onKViS3ooooo0_l000000ooooooo0000o`00000eooooo`;o000000?oooooo`000?l000005?oo
ool000gooooo0_l000000ooooooo0000o`00000dooooo`Ko0000;oooool6onKViP;o00000_oVi^H2
o`0000Koi^KV;_ooool2o`000003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o
000000Koi^KV<Oooool2o`0003Sooooo0_l0000Fooooo`003Oooool2o`000003ooooool0003o0000
03Cooooo0_l00002ooooo`;o0000;oooool6onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`00
0003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV<_ooool2o`00
03Sooooo0_l0000Eooooo`003Oooool4o`0003Kooooo1?l0000`ooooo`Ooi^KV1_l00005onKViRoo
oooo1?l0000_ooooo`Ooi^KV1?l00007onKViRoooooo0_l00002ooooo`;o0000=?ooool2o`0000;o
oooo0_l0000Dooooo`003Oooool2o`0000Wooooo0ol0001Poooooa;oi^KV<Oooool2o`0002oooooo
1ooVi^H2o`0000Woi^KV;oooool2o`0000;ooooo0_l0000/ooooo`;o00001_ooool2o`0000;ooooo
0_l0000Dooooo`003?ooool3o`0000cooooo0ol0000cooooo`?o0000:?ooool@onKViS7ooooo0ol0
000`ooooo`Goi^KV0ol00008onKViRWooooo0_l00006ooooo`Co0000:_ooool3o`0000Wooooo1?l0
000Eooooo`007_ooool4o`0003;ooooo0_l0000Voooooa3oi^KVI?ooool@onKViROooooo0_l0000b
ooooo`Co00009Oooool002;ooooo0ol0000aooooo`;o00009Oooool>onKViP03o`000?oooooooooo
06?ooooo3_oVi^HVooooo`;o0000<Oooool3o`0002Wooooo000Uooooo`?o0000<?ooool2o`0002Co
oooo3?oVi^H2ooooo`03o`000?oooooooooo067ooooo00?o0000oooooooVi^H02ooVi^HUooooo`;o
0000<?ooool3o`0002cooooo000Xooooo`?o0000;oooool2o`0002?ooooo2_oVi^H4ooooo`03o`00
0?oooooooooo05oooooo00Co0000oooooooooooooooo2_oVi^HTooooo`;o0000;oooool3o`0002oo
oooo000[ooooo`?o0000;_ooool2o`0002?ooooo1_oVi^H7ooooo`03o`000?oooooooooo05gooooo
00?o0000ooooooooool01?ooool6onKViRCooooo0_l0000^ooooo`?o0000<_ooool002kooooo0ol0
000]ooooo`;o0000;oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool0;Oooool2o`0002gooooo0ol0000eooooo`00<Oooool4o`0002_ooooo0_l0000^
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0/
ooooo`;o0000:oooool4o`0003Sooooo000eooooo`?o0000:_ooool3o`0002cooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo0ol0000Zoooo
o`?o0000??ooool003Sooooo0ol0000Zooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool2o`0002[ooooo0ol0000oooooo`00
>oooool3o`0002Wooooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
:?ooool00ol0003oooooooooo`0Xooooo`;o0000:Oooool3o`0004;ooooo000nooooo`?o0000:?oo
ool2o`0002Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo02Oooooo0_l0000Xooooo`?o0000AOooool0047ooooo1?l0000Vooooo`;o0000:?ooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09_ooool2
o`0002Kooooo1?l00018ooooo`00AOooool3o`0002Gooooo0_l0000Wooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`;o00009Oooool3o`00
04cooooo0018ooooo`?o00009?ooool2o`0002Kooooo0_l0000Uooooo`03o`000?oooooooooo02?o
oooo0_l0000Vooooo`;o00009?ooool3o`0004oooooo001;ooooo`?o00008oooool2o`0002Kooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02Cooooo
0_l0000Sooooo`?o0000D_ooool004kooooo0ol0000Rooooo`?o00009?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08_ooool3o`0002;ooooo0ol0
001Eooooo`00DOooool3o`0002;ooooo0_l0000Sooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0Qooooo`;o00008_ooool3o`0005Sooooo001Doooo
o`Co00008?ooool2o`0002;ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo023ooooo0_l0000Pooooo`Co0000Foooool005Sooooo0ol0000Oooooo`;o
00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool07oooool2o`0001oooooo0ol0001Oooooo`00Foooool3o`0001kooooo0_l0000Pooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Nooooo`;o0000
7_ooool3o`0006;ooooo001Nooooo`?o00007Oooool2o`0001oooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo0_l0000Mooooo`?o0000IOoo
ool0067ooooo0ol0000Looooo`;o00007_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool07?ooool2o`0001cooooo0ol0001Xooooo`00I?ooool4o`00
01[ooooo0ol0000Looooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`?o00006_ooool4o`0006_ooooo001Xooooo`?o00006_ooool2o`0001_o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wo
oooo0_l0000Jooooo`?o0000Koooool006_ooooo0ol0000Iooooo`;o00006_ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool2o`0001Wooooo
0ol0001booooo`00K_ooool3o`0001Sooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o00006?ooool3o`0007Gooooo001a
ooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000N?ooool007Cooooo0ol0000Foooo
o`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05Oooool2o`0001Kooooo0ol0001kooooo`00Moooool4o`0001Cooooo0_l0000Fooooo`03
o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`;o
00005?ooool4o`0007kooooo001kooooo`?o00004oooool2o`0001Gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0_l0000Cooooo`?o0000
P_ooool007kooooo0ol0000Booooo`?o00004oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04Oooool3o`0001;ooooo0ol00025ooooo`00POooool3
o`0001;ooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0@ooooo`;o00004_ooool3o`0008Sooooo0024ooooo`?o00004Oooool2o`00
017ooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000Aooooo`;o00004Oooool3o`00
08_ooooo0027ooooo`Co00003oooool2o`00017ooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0000?ooooo`Co0000S_ooool008_ooooo
0ol0000>ooooo`;o00004?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool2o`0000kooooo0ol0002Booooo`00S_ooool3o`0000gooooo0_l0
000?ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0=ooooo`;o00003Oooool3o`0009Gooooo002Aooooo`?o00003?ooool2o`0000kooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo0_l0000<
ooooo`?o0000V?ooool009Cooooo0ol0000;ooooo`;o00003Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool2o`0000_ooooo0ol0002Koooo
o`00Uoooool3o`0000[ooooo0ol0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`?o00002_ooool3o`0009kooooo002Jooooo`Co0000
2Oooool2o`0000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Sooooo0_l00009ooooo`Co0000XOooool009kooooo0ol00008ooooo`;o00002Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool2o`0000Sooooo0ol0002Uooooo`00XOooool3o`0000Oooooo0_l00008ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`;o00001oooool3
o`000:Sooooo002Tooooo`?o00001_ooool2o`0000Oooooo00?o0000ooooooooool00_ooool6onKV
iPGooooo00?o0000ooooooooool01Oooool2o`0000Kooooo0ol0002[ooooo`00Yoooool3o`0000Go
oooo0_l00006ooooo`03o`000?ooooooi^KV00Woi^KV0_ooool00ol0003oooooooooo`04ooooo`;o
00001Oooool3o`000:kooooo002Zooooo`Co00000oooool2o`0000Gooooo3?oVi^H00ol0003ooooo
ooooo`03ooooo`;o00000oooool4o`000;7ooooo002^ooooo`?o00000_ooool2o`0000;ooooo3_oV
i^H3ooooo`;o00000_ooool3o`000;Gooooo002aooooo`?o000000?oooooo`000?oVi^H03ooVi^H2
o`000004ooooool0003o0000o`000;Sooooo002dooooo`;o00004?oVi^H3o`000;_ooooo002eoooo
o`Koi^KV1_l00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Soi^KV
0_l00008onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Ooi^KV1Ol00006
onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002fooooo`Soi^KV0ol00005onKVi[ko
oooo002foooooa3oi^KV__ooool00;Oooooo3_oVi^Joooooo`00^?ooool<onKVi/3ooooo002ioooo
o`[oi^KV`Oooool00;_ooooo1_oVi^K3ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000gooooo`Co0000
3Oooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Oooooo0_l0
000>ooooo`00o_ooool4o`0003Wooooo0_l0000dooooo`Ko00003Oooool00?gooooo0_l000000ooo
oooo0000o`00000iooooo`;o0000=?ooool2o`000003ooooool0003o000000kooooo003nooooo`?o
0000=_ooool5o`0003Kooooo1?l0000>ooooo`00oooooolhooooo`;o0000>_ooool3o`0000kooooo
003oooooocSooooo1_l0000gooooo`;o00003_ooool00?ooooooQOooool00?oooooo2?ooool00ol0
003oooooooooo`1Sooooo`03o`000?oooooooooo01Cooooo003oooooo`Wooooo00?o0000oooooooo
ool0HOooool00ol0003oooooooooo`0Eooooo`00ooooool:ooooo`03o`000?oooooooooo05oooooo
00?o0000ooooooooool05_ooool00?oooooo2oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool05oooool00?oooooo3?ooool00ol0003oooooooooo`0/
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool06?ooool00?oooooo3Oooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool06Oooool00?oo
oooo3_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool06_ooool00?oooooo3oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool06oooool00?oooooo4?ooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool07?ooool00?oooooo4Oooool00ol0003oooooooooo`0W
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool07Oooool00?oooooo4_ooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool07_ooool00?oo
oooo4oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool07oooool00?oooooo5?ooool2o`0002Gooooo00?o0000ooooooooool08oooool2o`0002;ooooo
003ooooooaKooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo02;ooooo003ooooooaOooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo02?ooooo003ooooooaSooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo02Cooooo003ooooooaWooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo02Gooooo003ooooooa[ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Kooooo
003ooooooa_ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo02Oooooo003ooooooacooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo02Sooooo003ooooooagooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo02Wooooo003ooooooakooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02[ooooo003ooooooaoooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02_ooooo
003oooooob3ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo02cooooo003oooooob7ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo02gooooo003oooooob;ooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo02kooooo003oooooob?ooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02oooooo003oooooobCooooo
00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo033ooooo
003oooooobGooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo037ooooo003oooooobKooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo03;ooooo003oooooobOooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo03?ooooo003oooooobSooooo0_l0000Aooooo`03
o`000?oooooooooo00oooooo0_l0000fooooo`00oooooolZooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0fooooo`00ooooool[ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0gooooo`00ooooool/
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0h
ooooo`00ooooool]ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0iooooo`00ooooool^ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0jooooo`00ooooool_ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0kooooo`00ooooool`ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0looooo`00oooooola
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0m
ooooo`00oooooolbooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0nooooo`00oooooolcooooo`03o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03
o`000?oooooooooo03oooooo003oooooocCooooo00?o0000oooooooVi^H02OoVi^H2ooooo`03o`00
0?oooooooooo043ooooo003oooooocGooooo3?oVi^H00ol0003oooooooooo`11ooooo`00oooooold
ooooo`koi^KV@oooool00?oooooo<oooool6onKViPCo00001_oVi^I2ooooo`00oooooolcooooo`Wo
i^KV0_l00005onKViT;ooooo001[ooooo`Go00009oooool5o`0002kooooo1?l0000Booooo`Go0000
?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV@Oooool006[ooooo0_l000000ooooooo0000o`00
000Wooooo`;o000000?oooooo`000?l00000;_ooool2o`0000;ooooo0_l0000@ooooo`;o000000?o
ooooo`000?l00000?Oooool2o`0000;ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oV
i^I1ooooo`00Joooool4o`0002Sooooo1?l0000^ooooo`;o00005Oooool4o`00047ooooo0_l0000:
ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00J_ooool2o`000003ooooool0003o0000
02Oooooo0_l000000ooooooo0000o`00000^ooooo`;o00000_ooool2o`00013ooooo0_l000000ooo
oooo0000o`000011ooooo`;o00002_ooool6onKViP;o00000_oVi^H2o`0000Koi^KV@Oooool006_o
oooo0ol0000Yooooo`?o0000<?ooool4o`0001;ooooo0ol0000nooooo`Go00002oooool7onKViPKo
00001OoVi^I1ooooo`00oooooolRooooo`;o00003_oooolBonKViT7ooooo003oooooob;ooooo1_l0
000;oooooa3oi^KV@_ooool00?oooooo<oooool@onKViT;ooooo003oooooocCooooo3_oVi^I3oooo
o`00ooooooleooooo`coi^KVA?ooool007?ooooo00?o0000ooooooooool0B_ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KVAOooool007Cooooo00?o0000ooooooooool0B?oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`0Cooooo`04o`000?ooooooooooooooo`Koi^KVAoooool007Gooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Coooool007Gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Kooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0D?ooool007Oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0[ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0DOooool007Sooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
D_ooool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Nooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Doooool007Wooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Doooool0
07[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0E?ooool007_ooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0EOooool007cooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0E_ooool007gooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007gooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Eoooool007kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0F?ooool007oooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0FOooool0083ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0F_ooool0087ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Fooo
ool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Foooool008;ooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0G?ooool008?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo033o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0GOooool008Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0G_ooool008Gooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Goooool008Gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Kooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0H?ooool008Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo03Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0HOooool008Sooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
H_ooool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo03_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Hoooool008Wooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hoooool0
08[ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
03kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0I?ooool008_ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0IOooool008cooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool04oooool01Ol0003ooooooooooooooooo000001Gooooo00?o0000oooooooo
ool0I_ooool008gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo04?ooooo00?o0000ooooooooool04oooool00ol0003oooooo`00000Eooooo`03o`00
0?oooooooooo06Oooooo002=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooool000005Ooo
ool00ol0003oooooooooo`1Wooooo`00S_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0J?ooool008oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool04Oooool00ol0
003oooooo`00000Cooooo`03o`000?oooooooooo06Wooooo002@ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo00oo
oooo00Go0000ooooooooooooooooo`00000Aooooo`03o`000?oooooooooo06[ooooo002Aooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo06_ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Booooo`03o`000?oo
oooooooo00;ooooo1_oVi^H3ooooo`03o`000?oooooooooo04kooooo00Co0000oooooooooooooooo
1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03
o`000?oooooooooo06cooooo002Cooooo`03o`000?ooooooi^KV00Woi^KV00?o0000ooooooooool0
D?ooool00ol0003oi^KVonKViP08onKViP03ooooool0003ooooo00Sooooo00?o0000onKVi_oVi^H0
2?oVi^H00ooooooo0000ooooo`1^ooooo`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?oo
ool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>onKViVoooooo002Booooo`Goi^KV1?l00007onKV
iTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKViPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o
00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKooooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo
1Ol0000Aooooo`Co00002oooool6onKViPGo00001ooVi^Hmooooo`Go00002_ooool7onKViPGo0000
1_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo001[ooooo`;o000000?oooooo`000?l000004Ooo
ool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l00002onKViP;o00001ooVi^Hlooooo`;o000000?o
ooooo`000?l000002oooool6onKViP;o00000_oVi^H2o`0000Koi^KV1?ooool6onKViP;o00000_oV
i^H2o`0000Koi^KVKOooool006cooooo1?l0000Eooooo`;o00002_ooool5onKViP;o00000_oVi^H2
o`0000Ooi^KV??ooool2o`000003ooooool0003o000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVgooooo001[ooooo`;o000000?oooooo`00
0?l000005Oooool2o`0000[ooooo1OoVi^H2o`0000;oi^KV0_l00007onKViScooooo0_l000000ooo
oooo0000o`00000;ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^I]ooooo`00K?ooool3o`0001;ooooo1Ol0000;ooooo`Koi^KV1_l00006onKViSgo
oooo1?l0000;ooooo`Ooi^KV1_l00005onKViPCooooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo
0_l0000>oooooa;oi^KV?oooool2o`0000_ooooo4_oVi^H4oooooa;oi^KVKOooool0087ooooo1_l0
000;oooooa3oi^KV?oooool3o`0000cooooo4?oVi^H6oooooa3oi^KVK_ooool009;ooooo4?oVi^I>
oooooa3oi^KV1_ooool@onKViVkooooo002Cooooo`koi^KVD?ooool>onKViPSooooo3_oVi^I_oooo
o`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009Gooooo2_oVi^IDooooo`[oi^KV
3?ooool:onKViW7ooooo001aooooo`03o`000?oooooooooo02;ooooo00?o0000onKVi_oVi^H01?oV
i^IHooooo`Koi^KV4?ooool6onKViW?ooooo001booooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`1gooooo`00L_ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Moooool007?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo07Sooooo001cooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1@ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1hooooo`00Looo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0D?oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0N?oo
ool007Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo05;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo07Wooooo001dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`1Booooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`1iooooo`00MOooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0N_ooool007Gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo05Cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo07[ooooo001eooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`1jooooo`00M_ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Noooool007Kooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Kooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo07_ooooo001gooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Gooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1looooo`00
Moooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
F?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
O?ooool007Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo05Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo07cooooo001hooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Iooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1mooooo`00N?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0OOooool007Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo07kooooo001iooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`1nooooo`00NOooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0G?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0O_ooool007[ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05gooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo07oooooo001joooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Noooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1ooooo
o`00Noooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0Goooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0P?ooool007_ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo083ooooo001kooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1Pooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`20ooooo`00O?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0POooool007cooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo06;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo087ooooo001mooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`22ooooo`00OOooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Hoooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0P_ooool007gooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08;ooooo001n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1U
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`23
ooooo`00O_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0IOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0Poooool007oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo06Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo08Cooooo001oooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`24ooooo`00Ooooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool00000J_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0Q?ooool0083ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo06Wooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo08Go
oooo0020ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1Yooooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`25ooooo`00POooool6onKViP03
o`000?oooooooooo06_ooooo1_oVi^H00ol0003oooooooooo`26ooooo`00Ooooool:onKViV[ooooo
2_oVi^J7ooooo`00O_ooool<onKViVSooooo3?oVi^J6ooooo`00OOooool>onKViVKooooo3_oVi^J5
ooooo`00O?ooool6onKViPCo00001_oVi^IToooooa3oi^KVQ?ooool007cooooo2OoVi^H2o`0000Go
i^KVI?ooool@onKViXCooooo000<ooooo`Go0000=_ooool4o`00033ooooo1ooVi^H5o`0000Koi^KV
;oooool5o`0002kooooo1_oVi^H7o`0000Goi^KV;oooool6o`0003Cooooo1_l0000Dooooo`003Ooo
ool2o`000003ooooool0003o000003Cooooo0_l0000cooooo`Koi^KV0_l00002onKViP;o00001_oV
i^H^ooooo`;o000000?oooooo`000?l00000;oooool7onKViP;o000000?oi^KVo`000?l000001_oV
i^H`ooooo`;o000000?oooooo`000?l00000=Oooool2o`000003ooooool0003o000001Cooooo000=
ooooo`;o000000?oooooo`000?l00000=?ooool6o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006
onKViS7ooooo0_l0000hooooo`;o00005_ooool000gooooo0_l000000ooooooo0000o`00000doooo
o`;o00000_ooool2o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViRkooooo0_l000000ooo
oooo0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViS;ooooo0_l0000hoooo
o`;o00005Oooool000gooooo1?l0000fooooo`Co0000<?ooool7onKViPKo00001OoVi^H_ooooo`Co
0000;oooool7onKViPCo00001ooVi^H_ooooo`;o00000_ooool2o`0003Cooooo0_l00002ooooo`;o
00005?ooool000gooooo0_l00009ooooo`?o0000H?oooolBonKViS7ooooo0_l0000_ooooo`Ooi^KV
0_l00009onKViRoooooo0_l00002ooooo`;o0000;?ooool2o`0000Kooooo0_l00002ooooo`;o0000
5?ooool000cooooo0ol0000<ooooo`?o0000<oooool3o`0002Sooooo4?oVi^Haooooo`?o0000<?oo
ool5onKViP?o00002?oVi^HYooooo`;o00001_ooool4o`0002[ooooo0ol00009ooooo`Co00005Ooo
ool001kooooo1?l0000booooo`;o00009_ooool@onKViVCooooo4?oVi^HWooooo`;o0000<_ooool4
o`0002Gooooo000Rooooo`?o0000<Oooool2o`0002Gooooo3_oVi^H00ol0003oooooooooo`1Soooo
o`koi^KV9_ooool2o`00037ooooo0ol0000Yooooo`009Oooool3o`00033ooooo0_l0000Tooooo`co
i^KV0_ooool00ol0003oooooooooo`1Qooooo`03o`000?ooooooi^KV00_oi^KV9Oooool2o`00033o
oooo0ol0000/ooooo`00:?ooool3o`0002oooooo0_l0000Sooooo`[oi^KV1?ooool00ol0003ooooo
ooooo`1Oooooo`04o`000?ooooooooooooooo`[oi^KV9?ooool2o`0002oooooo0ol0000_ooooo`00
:oooool3o`0002kooooo0_l0000Sooooo`Koi^KV1oooool00ol0003oooooooooo`1Mooooo`03o`00
0?oooooooooo00Cooooo1_oVi^HTooooo`;o0000;_ooool3o`0003;ooooo000^ooooo`?o0000;Ooo
ool2o`0002oooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02gooooo0_l0000]ooooo`?o0000=Oooool0037ooooo1?l0000[ooooo`;o0000;_ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?ooool2
o`0002_ooooo1?l0000hooooo`00=Oooool3o`0002[ooooo0ol0000/ooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`?o0000:_ooool3o`00
03cooooo000hooooo`?o0000:_ooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0_l0000Zooooo`?o0000?oooool003_ooooo
0ol0000Yooooo`;o0000:_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool0:?ooool2o`0002Wooooo0ol00012ooooo`00?_ooool3o`0002Sooooo0_l0
000Yooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Wooooo`;o0000:?ooool3o`0004Gooooo0011ooooo`Co00009_ooool2o`0002Sooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo0_l0000V
ooooo`Co0000B?ooool004Gooooo0ol0000Uooooo`;o00009oooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool2o`0002Gooooo0ol0001<oooo
o`00B?ooool3o`0002Cooooo0_l0000Vooooo`;o00009Oooool00ol0003oooooooooo`0Sooooo`;o
00009_ooool2o`0002Cooooo0ol0001?ooooo`00Boooool3o`0002?ooooo0_l0000Vooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Tooooo`;o0000
8oooool3o`0005;ooooo001>ooooo`?o00008_ooool3o`0002Cooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02;ooooo0ol0000Rooooo`?o0000EOoo
ool0057ooooo0ol0000Rooooo`;o00008oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool08Oooool2o`0002;ooooo0ol0001Hooooo`00E?ooool4o`00
023ooooo0_l0000Rooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Pooooo`;o00008?ooool4o`0005_ooooo001Hooooo`?o00007oooool2o`00027o
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01oo
oooo0_l0000Oooooo`?o0000Goooool005_ooooo0ol0000Nooooo`;o00008?ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07_ooool2o`0001kooooo
0ol0001Rooooo`00G_ooool3o`0001gooooo0_l0000Oooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Mooooo`;o00007Oooool3o`0006Gooooo001Q
ooooo`?o00007?ooool2o`0001kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo01cooooo0_l0000Looooo`?o0000J?ooool006Cooooo1?l0000Joooo
o`?o00007?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool3o`0001[ooooo1?l0001[ooooo`00J?ooool3o`0001[ooooo0_l0000Kooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`;o
00006_ooool3o`0006oooooo001[ooooo`?o00006Oooool2o`0001[ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0_l0000Iooooo`?o0000
L_ooool006kooooo0ol0000Hooooo`;o00006Oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool05oooool2o`0001Sooooo0ol0001eooooo`00LOooool3
o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Fooooo`;o00005oooool3o`0007Sooooo001dooooo`?o00005_ooool2o`00
01Oooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Gooooo0_l0000Fooooo`?o0000Noooool007Oooooo1?l0000Dooooo`;o00005_ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool2o`0001Co
oooo1?l0001nooooo`00Noooool3o`0001?ooooo0_l0000Eooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`;o00004oooool3o`0008;ooooo
001nooooo`?o00004_ooool3o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo0ol0000Booooo`?o0000QOooool0087ooooo0ol0000B
ooooo`;o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool2o`0001;ooooo0ol00028ooooo`00Q?ooool3o`00017ooooo0_l0000Aoooo
o`;o00004Oooool00ol0003oooooooooo`0?ooooo`;o00004Oooool2o`00017ooooo0ol0002;oooo
o`00Qoooool4o`0000oooooo0_l0000Aooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0?ooooo`;o00003oooool4o`0008kooooo002;ooooo`?o0000
3_ooool2o`00013ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00kooooo0_l0000>ooooo`?o0000T_ooool008kooooo0ol0000=ooooo`;o00003ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool2o`0000gooooo0ol0002Eooooo`00TOooool3o`0000cooooo0_l0000>ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`;o00003?ooool3
o`0009Sooooo002Dooooo`?o00002oooool2o`0000gooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo0_l0000;ooooo`?o0000Voooool009Oo
oooo0ol0000:ooooo`?o00002oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool3o`0000[ooooo0ol0002Nooooo`00V_ooool4o`0000Wooooo
0_l0000:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`;o00002Oooool4o`000:7ooooo002Nooooo`?o00002?ooool2o`0000Wooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0_l0
0008ooooo`?o0000YOooool00:7ooooo0ol00007ooooo`;o00002?ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool2o`0000Oooooo0ol0002X
ooooo`00Y?ooool3o`0000Kooooo0_l00007ooooo`03o`000?oooooooooo00;ooooo1_oVi^H5oooo
o`03o`000?oooooooooo00Gooooo0_l00006ooooo`?o0000Zoooool00:Oooooo0ol00005ooooo`;o
00001_ooool00ol0003oooooonKViP09onKViP;ooooo00?o0000ooooooooool01?ooool2o`0000Go
oooo0ol0002^ooooo`00Z_ooool4o`0000?ooooo0_l00005ooooo`coi^KV00?o0000ooooooooool0
0oooool2o`0000?ooooo1?l0002aooooo`00[_ooool3o`0000;ooooo0_l00002ooooo`koi^KV0ooo
ool2o`0000;ooooo0ol0002eooooo`00/Oooool3o`000003ooooool0003oi^KV00ooi^KV0_l00000
1?oooooo0000o`000?l0002hooooo`00]?ooool2o`00013oi^KV0ol0002kooooo`00]Oooool6onKV
iPKo00001_oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmooooo`00]Oooool8onKViP;o0000
2?oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmooooo`00]Oooool7onKViPGo00001_oVi^Jm
ooooo`00]Oooool8onKViP;o00002?oVi^Jmooooo`00]_ooool8onKViP?o00001OoVi^Jnooooo`00
]_ooool@onKVi[kooooo002gooooo`koi^KV_oooool00;Sooooo3?oVi^K0ooooo`00^Oooool:onKV
i/7ooooo002kooooo`Koi^KV`oooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Co00002oooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001[ooooo`;o000000?oooooo`000?l000004Oooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o00000_ooool2o`0000[ooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVgooooo001/ooooo`Co00005Oooool2
o`0000[ooooo1OoVi^H2o`0000;oi^KV0_l00007onKViT3ooooo0_l0000:ooooo`Koi^KV0_l00002
onKViP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00Joooool2o`00
0003ooooool0003o000001Gooooo0_l0000:ooooo`Goi^KV0_l00002onKViP;o00001ooVi^Hnoooo
o`?o00002oooool6onKViP;o00000_oVi^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`00
00Koi^KVKOooool006cooooo0ol0000Booooo`Go00002oooool6onKViPKo00001_oVi^I0ooooo`;o
00002_ooool7onKViPKo00001OoVi^H4ooooo`Ooi^KV1_l00005onKViVgooooo0021ooooo`;o0000
3_oooolBonKViScooooo0_l00002ooooo`;o00002_oooolBonKViPCooooo4_oVi^I]ooooo`00POoo
ool6o`0000_ooooo4?oVi^Hnooooo`Co00003?ooool@onKViPKooooo4?oVi^I^ooooo`00T_ooool@
onKViTkooooo4?oVi^H6oooooa3oi^KVK_ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>onKV
iVoooooo002Dooooo`coi^KVD_ooool<onKViP[ooooo3?oVi^I`ooooo`00UOooool:onKViUCooooo
2_oVi^H<ooooo`[oi^KVLOooool0077ooooo00?o0000ooooooooool08_ooool00ol0003oi^KVonKV
iP04onKViUSooooo1_oVi^H@ooooo`Koi^KVLoooool007;ooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo07Oooooo001booooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1gooooo`00Loooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0Coooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0N?ooool007?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo053ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo07Sooooo
001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`1hooooo`00M?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0NOooool007Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo07Wooooo001eooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1jooooo`00MOooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo001fooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1kooooo`00M_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0E_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Noooool007Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07co
oooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`1Hooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0O?ooool007Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo07gooooo001hooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1mooooo`00NOooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0O_ooool007Wooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07kooooo001iooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Looooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1nooooo`00N_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0GOooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Ooooool0
07[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
05kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
07oooooo001kooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1Oooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`20ooooo`00Noooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo083ooooo001looooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`21ooooo`00O?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool007gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08;ooooo001mooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Sooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`22ooooo`00OOoo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0I?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0P_oo
ool007kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo06Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo08?ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`23ooooo`00Ooooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0Q?ooool007oooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`00001Zooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`24ooooo`00P?ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool0JOooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0QOooool0083ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wo
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo08Gooooo0021ooooo`Ko
i^KV00?o0000ooooooooool0Joooool6onKViP03o`000?oooooooooo08Kooooo001oooooo`[oi^KV
J_ooool:onKViXOooooo001nooooo`coi^KVJ?ooool<onKViXKooooo001mooooo`koi^KVI_ooool>
onKViXGooooo001looooo`Koi^KV1?l00006onKViVCooooo4?oVi^J4ooooo`00O?ooool9onKViP;o
00001OoVi^IToooooa3oi^KVQ?ooool000cooooo1Ol0000fooooo`Co0000<?ooool7onKViPGo0000
1_oVi^H_ooooo`Go0000;_ooool6onKViPOo00001OoVi^H_ooooo`Ko0000=?ooool6o`0001Cooooo
000=ooooo`;o000000?oooooo`000?l00000=?ooool2o`0003?ooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooVi^Ko0000o`00
0006onKViS3ooooo0_l000000ooooooo0000o`00000eooooo`;o000000?oooooo`000?l000005?oo
ool000gooooo0_l000000ooooooo0000o`00000dooooo`Ko0000;oooool6onKViP;o00000_oVi^H2
o`0000Koi^KV;_ooool2o`000003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o
000000Koi^KV<Oooool2o`0003Sooooo0_l0000Fooooo`003Oooool2o`000003ooooool0003o0000
03Cooooo0_l00002ooooo`;o0000;oooool6onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`00
0003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV<_ooool2o`00
03Sooooo0_l0000Eooooo`003Oooool4o`0003Kooooo1?l0000`ooooo`Ooi^KV1_l00005onKViRoo
oooo1?l0000_ooooo`Ooi^KV1?l00007onKViRoooooo0_l00002ooooo`;o0000=?ooool2o`0000;o
oooo0_l0000Dooooo`003Oooool2o`0000Wooooo0ol0001Poooooa;oi^KV<Oooool2o`0002oooooo
1ooVi^H2o`0000Woi^KV;oooool2o`0000;ooooo0_l0000/ooooo`;o00001_ooool2o`0000;ooooo
0_l0000Dooooo`003?ooool3o`0000cooooo0ol0000cooooo`?o0000:?ooool@onKViS7ooooo0ol0
000`ooooo`Goi^KV0ol00008onKViRWooooo0_l00006ooooo`Co0000:_ooool3o`0000Wooooo1?l0
000Eooooo`007_ooool4o`0003;ooooo0_l0000Voooooa3oi^KVI?ooool@onKViROooooo0_l0000b
ooooo`Co00009Oooool002;ooooo0ol0000aooooo`;o00009Oooool>onKViP03o`000?oooooooooo
06?ooooo3_oVi^HVooooo`;o0000<Oooool3o`0002Wooooo000Uooooo`?o0000<?ooool2o`0002Co
oooo3?oVi^H2ooooo`03o`000?oooooooooo067ooooo00?o0000oooooooVi^H02ooVi^HUooooo`;o
0000<?ooool3o`0002cooooo000Xooooo`?o0000;oooool2o`0002?ooooo2_oVi^H4ooooo`03o`00
0?oooooooooo05oooooo00Co0000oooooooooooooooo2_oVi^HTooooo`;o0000;oooool3o`0002oo
oooo000[ooooo`?o0000;_ooool2o`0002?ooooo1_oVi^H7ooooo`03o`000?oooooooooo05gooooo
00?o0000ooooooooool01?ooool6onKViRCooooo0_l0000^ooooo`?o0000<_ooool002kooooo0ol0
000]ooooo`;o0000;oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool0;Oooool2o`0002gooooo0ol0000eooooo`00<Oooool4o`0002_ooooo0_l0000^
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0/
ooooo`;o0000:oooool4o`0003Sooooo000eooooo`?o0000:_ooool3o`0002cooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo0ol0000Zoooo
o`?o0000??ooool003Sooooo0ol0000Zooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool2o`0002[ooooo0ol0000oooooo`00
>oooool3o`0002Wooooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
:?ooool00ol0003oooooooooo`0Xooooo`;o0000:Oooool3o`0004;ooooo000nooooo`?o0000:?oo
ool2o`0002Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo02Oooooo0_l0000Xooooo`?o0000AOooool0047ooooo1?l0000Vooooo`;o0000:?ooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09_ooool2
o`0002Kooooo1?l00018ooooo`00AOooool3o`0002Gooooo0_l0000Wooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`;o00009Oooool3o`00
04cooooo0018ooooo`?o00009?ooool2o`0002Kooooo0_l0000Uooooo`03o`000?oooooooooo02?o
oooo0_l0000Vooooo`;o00009?ooool3o`0004oooooo001;ooooo`?o00008oooool2o`0002Kooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02Cooooo
0_l0000Sooooo`?o0000D_ooool004kooooo0ol0000Rooooo`?o00009?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08_ooool3o`0002;ooooo0ol0
001Eooooo`00DOooool3o`0002;ooooo0_l0000Sooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0Qooooo`;o00008_ooool3o`0005Sooooo001Doooo
o`Co00008?ooool2o`0002;ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo023ooooo0_l0000Pooooo`Co0000Foooool005Sooooo0ol0000Oooooo`;o
00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool07oooool2o`0001oooooo0ol0001Oooooo`00Foooool3o`0001kooooo0_l0000Pooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Nooooo`;o0000
7_ooool3o`0006;ooooo001Nooooo`?o00007Oooool2o`0001oooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo0_l0000Mooooo`?o0000IOoo
ool0067ooooo0ol0000Looooo`;o00007_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool07?ooool2o`0001cooooo0ol0001Xooooo`00I?ooool4o`00
01[ooooo0ol0000Looooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Jooooo`?o00006_ooool4o`0006_ooooo001Xooooo`?o00006_ooool2o`0001_o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wo
oooo0_l0000Jooooo`?o0000Koooool006_ooooo0ol0000Iooooo`;o00006_ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool2o`0001Wooooo
0ol0001booooo`00K_ooool3o`0001Sooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o00006?ooool3o`0007Gooooo001a
ooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000N?ooool007Cooooo0ol0000Foooo
o`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05Oooool2o`0001Kooooo0ol0001kooooo`00Moooool4o`0001Cooooo0_l0000Fooooo`03
o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`;o
00005?ooool4o`0007kooooo001kooooo`?o00004oooool2o`0001Gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0_l0000Cooooo`?o0000
P_ooool007kooooo0ol0000Booooo`?o00004oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04Oooool3o`0001;ooooo0ol00025ooooo`00POooool3
o`0001;ooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0@ooooo`;o00004_ooool3o`0008Sooooo0024ooooo`?o00004Oooool2o`00
017ooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000Aooooo`;o00004Oooool3o`00
08_ooooo0027ooooo`Co00003oooool2o`00017ooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0000?ooooo`Co0000S_ooool008_ooooo
0ol0000>ooooo`;o00004?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool2o`0000kooooo0ol0002Booooo`00S_ooool3o`0000gooooo0_l0
000?ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0=ooooo`;o00003Oooool3o`0009Gooooo002Aooooo`?o00003?ooool2o`0000kooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo0_l0000<
ooooo`?o0000V?ooool009Cooooo0ol0000;ooooo`;o00003Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool2o`0000_ooooo0ol0002Koooo
o`00Uoooool3o`0000[ooooo0ol0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`?o00002_ooool3o`0009kooooo002Jooooo`Co0000
2Oooool2o`0000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Sooooo0_l00009ooooo`Co0000XOooool009kooooo0ol00008ooooo`;o00002Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool2o`0000Sooooo0ol0002Uooooo`00XOooool3o`0000Oooooo0_l00008ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`;o00001oooool3
o`000:Sooooo002Tooooo`?o00001_ooool2o`0000Oooooo00?o0000ooooooooool00_ooool6onKV
iPGooooo00?o0000ooooooooool01Oooool2o`0000Kooooo0ol0002[ooooo`00Yoooool3o`0000Go
oooo0_l00006ooooo`03o`000?ooooooi^KV00Woi^KV0_ooool00ol0003oooooooooo`04ooooo`;o
00001Oooool3o`000:kooooo002Zooooo`Co00000oooool2o`0000Gooooo3?oVi^H00ol0003ooooo
ooooo`03ooooo`;o00000oooool4o`000;7ooooo002^ooooo`?o00000_ooool2o`0000;ooooo3_oV
i^H3ooooo`;o00000_ooool3o`000;Gooooo002aooooo`?o000000?oooooo`000?oVi^H03ooVi^H2
o`000004ooooool0003o0000o`000;Sooooo002dooooo`;o00004?oVi^H3o`000;_ooooo002eoooo
o`Koi^KV1_l00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Soi^KV
0_l00008onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Ooi^KV1Ol00006
onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002fooooo`Soi^KV0ol00005onKVi[ko
oooo002foooooa3oi^KV__ooool00;Oooooo3_oVi^Joooooo`00^?ooool<onKVi/3ooooo002ioooo
o`[oi^KV`Oooool00;_ooooo1_oVi^K3ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006cooooo1Ol0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Go00002_ooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001[ooooo`;o000000?oooooo`000?l000004Oooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006cooooo1?l0000E
ooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??ooool2o`000003ooooool0003o
000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViVgooooo001[ooooo`;o000000?oooooo`000?l000005Oooool2o`0000[ooooo1OoVi^H2o`00
00;oi^KV0_l00007onKViScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00K?ooool3o`0001;o
oooo1Ol0000;ooooo`Koi^KV1_l00006onKViSgooooo1?l0000;ooooo`Ooi^KV1_l00005onKViPCo
oooo1ooVi^H6o`0000Goi^KVKOooool0087ooooo0_l0000>oooooa;oi^KV?oooool2o`0000_ooooo
4_oVi^H4oooooa;oi^KVKOooool0087ooooo1_l0000;oooooa3oi^KV?oooool3o`0000cooooo4?oV
i^H6oooooa3oi^KVK_ooool009;ooooo4?oVi^I>oooooa3oi^KV1_ooool@onKViVkooooo002Coooo
o`koi^KVD?ooool>onKViPSooooo3_oVi^I_ooooo`00U?ooool<onKViU;ooooo3?oVi^H:ooooo`co
i^KVL?ooool009Gooooo2_oVi^IDooooo`[oi^KV3?ooool:onKViW7ooooo001aooooo`03o`000?oo
oooooooo02;ooooo00?o0000onKVi_oVi^H01?oVi^IHooooo`Koi^KV4?ooool6onKViW?ooooo001b
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1g
ooooo`00L_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0C_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Moooool007?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`1hooooo`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0N?ooool007Cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001dooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1iooooo`00MOooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Doooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo
001eooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1jooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0Noooool007Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo07_ooooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo001hooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1mooooo`00N?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0F_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0OOooool007Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05_o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07ko
oooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Looooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`1nooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0O_ooool007[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo07oooooo001jooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1oooooo`00Noooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083ooooo001kooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Pooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`20ooooo`00O?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool0
07cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
06;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
087ooooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0P_ooool007gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo08;ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`23ooooo`00O_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Poooool007oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Wooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`24ooooo`00Oooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000J_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool0083ooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Wooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo08Gooooo0020ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Yooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`25ooooo`00POooool6onKViP03o`000?oooooooooo06_ooooo1_oVi^H00ol0003o
ooooooooo`26ooooo`00Ooooool:onKViV[ooooo2_oVi^J7ooooo`00O_ooool<onKViVSooooo3?oV
i^J6ooooo`00OOooool>onKViVKooooo3_oVi^J5ooooo`00O?ooool6onKViPCo00001_oVi^IToooo
oa3oi^KVQ?ooool007cooooo2OoVi^H2o`0000Goi^KVI?ooool@onKViXCooooo000<ooooo`Go0000
=_ooool4o`00033ooooo1ooVi^H5o`0000Koi^KV;oooool5o`0002kooooo1_oVi^H7o`0000Goi^KV
;oooool6o`0003Cooooo1_l0000Dooooo`003Oooool2o`000003ooooool0003o000003Cooooo0_l0
000cooooo`Koi^KV0_l00002onKViP;o00001_oVi^H^ooooo`;o000000?oooooo`000?l00000;ooo
ool7onKViP;o000000?oi^KVo`000?l000001_oVi^H`ooooo`;o000000?oooooo`000?l00000=Ooo
ool2o`000003ooooool0003o000001Cooooo000=ooooo`;o000000?oooooo`000?l00000=?ooool6
o`0002oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViRkooooo0_l000000ooooooo0000o`00000_
ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViS7ooooo0_l0000hooooo`;o00005_ooool0
00gooooo0_l000000ooooooo0000o`00000dooooo`;o00000_ooool2o`0002oooooo1_oVi^H2o`00
00;oi^KV0_l00006onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l000000ooV
i^Ko0000o`000006onKViS;ooooo0_l0000hooooo`;o00005Oooool000gooooo1?l0000fooooo`Co
0000<?ooool7onKViPKo00001OoVi^H_ooooo`Co0000;oooool7onKViPCo00001ooVi^H_ooooo`;o
00000_ooool2o`0003Cooooo0_l00002ooooo`;o00005?ooool000gooooo0_l00009ooooo`?o0000
H?oooolBonKViS7ooooo0_l0000_ooooo`Ooi^KV0_l00009onKViRoooooo0_l00002ooooo`;o0000
;?ooool2o`0000Kooooo0_l00002ooooo`;o00005?ooool000cooooo0ol0000<ooooo`?o0000<ooo
ool3o`0002Sooooo4?oVi^Haooooo`?o0000<?ooool5onKViP?o00002?oVi^HYooooo`;o00001_oo
ool4o`0002[ooooo0ol00009ooooo`Co00005Oooool001kooooo1?l0000booooo`;o00009_ooool@
onKViVCooooo4?oVi^HWooooo`;o0000<_ooool4o`0002Gooooo000Rooooo`?o0000<Oooool2o`00
02Gooooo3_oVi^H00ol0003oooooooooo`1Sooooo`koi^KV9_ooool2o`00037ooooo0ol0000Yoooo
o`009Oooool3o`00033ooooo0_l0000Tooooo`coi^KV0_ooool00ol0003oooooooooo`1Qooooo`03
o`000?ooooooi^KV00_oi^KV9Oooool2o`00033ooooo0ol0000/ooooo`00:?ooool3o`0002oooooo
0_l0000Sooooo`[oi^KV1?ooool00ol0003oooooooooo`1Oooooo`04o`000?ooooooooooooooo`[o
i^KV9?ooool2o`0002oooooo0ol0000_ooooo`00:oooool3o`0002kooooo0_l0000Sooooo`Koi^KV
1oooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo00Cooooo1_oVi^HTooooo`;o0000
;_ooool3o`0003;ooooo000^ooooo`?o0000;Oooool2o`0002oooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02gooooo0_l0000]ooooo`?o0000=Ooo
ool0037ooooo1?l0000[ooooo`;o0000;_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0;?ooool2o`0002_ooooo1?l0000hooooo`00=Oooool3o`00
02[ooooo0ol0000/ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0Zooooo`?o0000:_ooool3o`0003cooooo000hooooo`?o0000:_ooool2o`0002_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wo
oooo0_l0000Zooooo`?o0000?oooool003_ooooo0ol0000Yooooo`;o0000:_ooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool2o`0002Wooooo
0ol00012ooooo`00?_ooool3o`0002Sooooo0_l0000Yooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0004Gooooo0011
ooooo`Co00009_ooool2o`0002Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo02Kooooo0_l0000Vooooo`Co0000B?ooool004Gooooo0ol0000Uoooo
o`;o00009oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool09Oooool2o`0002Gooooo0ol0001<ooooo`00B?ooool3o`0002Cooooo0_l0000Vooooo`;o
00009Oooool00ol0003oooooooooo`0Sooooo`;o00009_ooool2o`0002Cooooo0ol0001?ooooo`00
Boooool3o`0002?ooooo0_l0000Vooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0Tooooo`;o00008oooool3o`0005;ooooo001>ooooo`?o00008_oo
ool3o`0002Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo02;ooooo0ol0000Rooooo`?o0000EOooool0057ooooo0ol0000Rooooo`;o00008oooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08Oooool2
o`0002;ooooo0ol0001Hooooo`00E?ooool4o`00023ooooo0_l0000Rooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o00008?ooool4o`00
05_ooooo001Hooooo`?o00007oooool2o`00027ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo01oooooo0_l0000Oooooo`?o0000Goooool005_ooooo
0ol0000Nooooo`;o00008?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool07_ooool2o`0001kooooo0ol0001Rooooo`00G_ooool3o`0001gooooo0_l0
000Oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0Mooooo`;o00007Oooool3o`0006Gooooo001Qooooo`?o00007?ooool2o`0001kooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01cooooo0_l0000L
ooooo`?o0000J?ooool006Cooooo1?l0000Jooooo`?o00007?ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool3o`0001[ooooo1?l0001[oooo
o`00J?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`0Iooooo`;o00006_ooool3o`0006oooooo001[ooooo`?o0000
6Oooool2o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo01Sooooo0_l0000Iooooo`?o0000L_ooool006kooooo0ol0000Hooooo`;o00006Ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05ooo
ool2o`0001Sooooo0ol0001eooooo`00LOooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`;o00005oooool3
o`0007Sooooo001dooooo`?o00005_ooool2o`0001Oooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo0_l0000Fooooo`?o0000Noooool007Oo
oooo1?l0000Dooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Co
oooo00?o0000ooooooooool05?ooool2o`0001Cooooo1?l0001nooooo`00Noooool3o`0001?ooooo
0_l0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Cooooo`;o00004oooool3o`0008;ooooo001nooooo`?o00004_ooool3o`0001?ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo0ol0
000Booooo`?o0000QOooool0087ooooo0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool2o`0001;ooooo0ol00028
ooooo`00Q?ooool3o`00017ooooo0_l0000Aooooo`;o00004Oooool00ol0003oooooooooo`0?oooo
o`;o00004Oooool2o`00017ooooo0ol0002;ooooo`00Qoooool4o`0000oooooo0_l0000Aooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`;o
00003oooool4o`0008kooooo002;ooooo`?o00003_ooool2o`00013ooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo0_l0000>ooooo`?o0000
T_ooool008kooooo0ol0000=ooooo`;o00003oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool2o`0000gooooo0ol0002Eooooo`00TOooool3
o`0000cooooo0_l0000>ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0<ooooo`;o00003?ooool3o`0009Sooooo002Dooooo`?o00002oooool2o`00
00gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00_ooooo0_l0000;ooooo`?o0000Voooool009Oooooo0ol0000:ooooo`?o00002oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool3o`0000[o
oooo0ol0002Nooooo`00V_ooool4o`0000Wooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o00002Oooool4o`000:7ooooo
002Nooooo`?o00002?ooool2o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo0_l00008ooooo`?o0000YOooool00:7ooooo0ol00007
ooooo`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool2o`0000Oooooo0ol0002Xooooo`00Y?ooool3o`0000Kooooo0_l00007oooo
o`03o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo00Gooooo0_l00006oooo
o`?o0000Zoooool00:Oooooo0ol00005ooooo`;o00001_ooool00ol0003oooooonKViP09onKViP;o
oooo00?o0000ooooooooool01?ooool2o`0000Gooooo0ol0002^ooooo`00Z_ooool4o`0000?ooooo
0_l00005ooooo`coi^KV00?o0000ooooooooool00oooool2o`0000?ooooo1?l0002aooooo`00[_oo
ool3o`0000;ooooo0_l00002ooooo`koi^KV0oooool2o`0000;ooooo0ol0002eooooo`00/Oooool3
o`000003ooooool0003oi^KV00ooi^KV0_l000001?oooooo0000o`000?l0002hooooo`00]?ooool2
o`00013oi^KV0ol0002kooooo`00]Oooool6onKViPKo00001_oVi^Jmooooo`00]Oooool8onKViP;o
00002?oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmooooo`00]Oooool8onKViP;o00002?oV
i^Jmooooo`00]Oooool7onKViPGo00001_oVi^Jmooooo`00]Oooool8onKViP;o00002?oVi^Jmoooo
o`00]_ooool8onKViP?o00001OoVi^Jnooooo`00]_ooool@onKVi[kooooo002gooooo`koi^KV_ooo
ool00;Sooooo3?oVi^K0ooooo`00^Oooool:onKVi/7ooooo002kooooo`Koi^KV`oooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0001Cooooo0_l000000ooooooo0000o`00000mooooo`;o00000_ooool2o`0000[ooooo1_oV
i^H2o`0000;oi^KV0_l00006onKViT7ooooo001[ooooo`Co0000:?ooool4o`0002kooooo1_l0000A
ooooo`Co0000@Oooool2o`0000[ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViT7ooooo001Zoooo
o`;o000000?oooooo`000?l000009oooool2o`000003ooooool0003o000002kooooo0_l00002oooo
o`;o00004?ooool2o`000003ooooool0003o0000047ooooo0_l0000:ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^I1ooooo`00Joooool3o`0002Wooooo0ol0000`ooooo`Co00004_ooool3o`0003ko
oooo1Ol0000;ooooo`Ooi^KV1_l00005onKViT7ooooo003oooooob;ooooo0_l0000>oooooa;oi^KV
@Oooool00?oooooo8_ooool6o`0000_ooooo4?oVi^I2ooooo`00oooooolcoooooa3oi^KV@_ooool0
0?oooooo=?ooool>onKViT?ooooo003oooooocGooooo3?oVi^I4ooooo`00Loooool00ol0003ooooo
ooooo`1:ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo01?ooooo00?o0000onKVi_oVi^H02?oVi^I5ooooo`00M?oo
ool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooooooo
1_oVi^I7ooooo`00MOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02oooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`1?ooooo`00MOooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1?
ooooo`00M_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`1@ooooo`00Moooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Aooooo`00
N?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`1Booooo`00NOooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Cooooo`00NOooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`1Cooooo`00N_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Dooooo`00Noooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`1Eooooo`00O?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`1Fooooo`00OOooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`1Gooooo`00OOooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`1Gooooo`00O_ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Hoooo
o`00Ooooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`1Iooooo`00P?ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Jooooo`00POoo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`1Kooooo`00POooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Kooooo`00P_ooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0;_ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`1Looooo`00Poooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Mooooo`00Q?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`1Nooooo`00QOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`1Oooooo`00QOooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1O
ooooo`00Q_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool0=_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`1Pooooo`00Qoooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Qooooo`00
R?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
>Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`1Rooooo`00ROooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Sooooo`00ROooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0??ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`1Sooooo`00R_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Tooooo`00Roooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0@?ooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`1Uooooo`00S?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool0@_ooool00ol0003oooooooooo`0Cooooo`05o`000?ooooooooooooooool0
00005Oooool00ol0003oooooooooo`1Vooooo`00SOooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooo000001Gooooo00?o0000ooooooooool0Ioooool008gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool04ooo
ool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002>ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`16ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Xooooo`00Soooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0B?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooo000001?ooooo00?o0000ooooooooool0JOooool0093o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04[o
oooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo0000017ooooo00?o0000oooo
ooooool0J_ooool0097ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0Joooool0097ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
Joooool009;ooooo00?o0000ooooooooool00_ooool6onKViP?ooooo00?o0000ooooooooool0C_oo
ool01?l0003oooooooooooooool6onKViPCooooo00?o0000ooooooooool01Oooool01?l0003ooooo
ooooooooool6onKViPCooooo00?o0000ooooooooool0K?ooool009?ooooo00?o0000oooooooVi^H0
2OoVi^H00ol0003oooooooooo`1@ooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool0
2?ooool00ol0003oi^KVonKViP08onKViP03ooooool0003ooooo06kooooo002Dooooo`coi^KVD_oo
ool<onKViP[ooooo3?oVi^I`ooooo`00Toooool>onKViU3ooooo3_oVi^H8ooooo`koi^KVKoooool0
09;ooooo1OoVi^H4o`0000Ooi^KVC_ooool6onKViPCo00001_oVi^H6ooooo`Koi^KV1?l00006onKV
iVkooooo002Booooo`Soi^KV0_l00006onKViTkooooo2OoVi^H2o`0000Goi^KV1_ooool9onKViP;o
00001OoVi^I^ooooo`00K?ooool5o`00017ooooo1?l0000;ooooo`Koi^KV1Ol00007onKViSgooooo
1Ol0000:ooooo`Ooi^KV1Ol00006onKViPCooooo1ooVi^H5o`0000Koi^KVKOooool006_ooooo0_l0
00000ooooooo0000o`00000Aooooo`;o00000_ooool2o`0000[ooooo1OoVi^H2o`0000;oi^KV0_l0
0007onKViScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKViP;o00001_oV
i^H4ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00K?ooool4o`0001Gooooo0_l0000:
ooooo`Goi^KV0_l00002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6
onKViP;o00000_oVi^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool0
06_ooooo0_l000000ooooooo0000o`00000Eooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`00
00Ooi^KV??ooool2o`000003ooooool0003o000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKV
iPCooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVgooooo001/ooooo`?o00004_ooool5o`0000_o
oooo1_oVi^H6o`0000Koi^KV?Oooool4o`0000_ooooo1ooVi^H6o`0000Goi^KV1?ooool7onKViPKo
00001OoVi^I]ooooo`00POooool2o`0000kooooo4_oVi^Hoooooo`;o00002ooooolBonKViPCooooo
4_oVi^I]ooooo`00POooool6o`0000_ooooo4?oVi^Hoooooo`?o00003?ooool@onKViPKooooo4?oV
i^I^ooooo`00T_ooool@onKViTkooooo4?oVi^H6oooooa3oi^KVK_ooool009?ooooo3_oVi^I@oooo
o`koi^KV2?ooool>onKViVoooooo002Dooooo`coi^KVD_ooool<onKViP[ooooo3?oVi^I`ooooo`00
UOooool:onKViUCooooo2_oVi^H<ooooo`[oi^KVLOooool0077ooooo00?o0000ooooooooool08_oo
ool00ol0003oi^KVonKViP04onKViUSooooo1_oVi^H@ooooo`Koi^KVLoooool007;ooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo07Oooooo001boooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1>oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1goooo
o`00Loooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0Coooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0N?ooool007?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo053ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo07Sooooo001cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`1hooooo`00M?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool0NOooool007Cooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo07Wooooo001eooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1jooooo`00MOooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0E?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0N_ooool007Gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo07[ooooo001f
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1E
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1k
ooooo`00M_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0E_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0Noooool007Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo05Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo07cooooo001gooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1looooo`00Moooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool0O?ooool007Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo07gooooo001hooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1mooooo`00NOooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Foooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0O_ooool007Wooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05cooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07kooooo
001iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Looooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`1nooooo`00N_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0GOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0Ooooool007[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo05kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo07oooooo001kooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`20ooooo`00Noooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0P?ooool007_ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083ooooo001looooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Qooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`21ooooo`00O?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0H_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0POooool007go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08;o
oooo001mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`1Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`22ooooo`00OOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0I?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0P_ooool007kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo08?ooooo001nooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`23ooooo`00Ooooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0Q?ooool007oooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08Cooooo001oooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`00001Zooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`24ooooo`00P?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0JOooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool0QOooool0083ooooo00Go0000ooooooooooooooooo`000003ooooo`03
o`000?oooooooooo06Wooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
08Gooooo0021ooooo`Koi^KV00?o0000ooooooooool0Joooool6onKViP03o`000?oooooooooo08Ko
oooo001oooooo`[oi^KVJ_ooool:onKViXOooooo001nooooo`coi^KVJ?ooool<onKViXKooooo001m
ooooo`koi^KVI_ooool>onKViXGooooo001looooo`Koi^KV1?l00006onKViVCooooo4?oVi^J4oooo
o`00O?ooool9onKViP;o00001OoVi^IToooooa3oi^KVQ?ooool000cooooo1Ol0000fooooo`Co0000
<?ooool7onKViPGo00001_oVi^H_ooooo`Go0000;_ooool6onKViPOo00001OoVi^H_ooooo`Ko0000
=?ooool6o`0001Cooooo000=ooooo`;o000000?oooooo`000?l00000=?ooool2o`0003?ooooo1_oV
i^H2o`0000;oi^KV0_l00006onKViRkooooo0_l000000ooooooo0000o`00000_ooooo`Ooi^KV0_l0
00000ooVi^Ko0000o`000006onKViS3ooooo0_l000000ooooooo0000o`00000eooooo`;o000000?o
ooooo`000?l000005?ooool000gooooo0_l000000ooooooo0000o`00000dooooo`Ko0000;oooool6
onKViP;o00000_oVi^H2o`0000Koi^KV;_ooool2o`000003ooooool0003o000002oooooo1ooVi^H2
o`000003onKVi_l0003o000000Koi^KV<Oooool2o`0003Sooooo0_l0000Fooooo`003Oooool2o`00
0003ooooool0003o000003Cooooo0_l00002ooooo`;o0000;oooool6onKViP;o00000_oVi^H2o`00
00Koi^KV;_ooool2o`000003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o0000
00Koi^KV<_ooool2o`0003Sooooo0_l0000Eooooo`003Oooool4o`0003Kooooo1?l0000`ooooo`Oo
i^KV1_l00005onKViRoooooo1?l0000_ooooo`Ooi^KV1?l00007onKViRoooooo0_l00002ooooo`;o
0000=?ooool2o`0000;ooooo0_l0000Dooooo`003Oooool2o`0000Wooooo0ol0001Poooooa;oi^KV
<Oooool2o`0002oooooo1ooVi^H2o`0000Woi^KV;oooool2o`0000;ooooo0_l0000/ooooo`;o0000
1_ooool2o`0000;ooooo0_l0000Dooooo`003?ooool3o`0000cooooo0ol0000cooooo`?o0000:?oo
ool@onKViS7ooooo0ol0000`ooooo`Goi^KV0ol00008onKViRWooooo0_l00006ooooo`Co0000:_oo
ool3o`0000Wooooo1?l0000Eooooo`007_ooool4o`0003;ooooo0_l0000Voooooa3oi^KVI?ooool@
onKViROooooo0_l0000booooo`Co00009Oooool002;ooooo0ol0000aooooo`;o00009Oooool>onKV
iP03o`000?oooooooooo06?ooooo3_oVi^HVooooo`;o0000<Oooool3o`0002Wooooo000Uooooo`?o
0000<?ooool2o`0002Cooooo3?oVi^H2ooooo`03o`000?oooooooooo067ooooo00?o0000oooooooV
i^H02ooVi^HUooooo`;o0000<?ooool3o`0002cooooo000Xooooo`?o0000;oooool2o`0002?ooooo
2_oVi^H4ooooo`03o`000?oooooooooo05oooooo00Co0000oooooooooooooooo2_oVi^HTooooo`;o
0000;oooool3o`0002oooooo000[ooooo`?o0000;_ooool2o`0002?ooooo1_oVi^H7ooooo`03o`00
0?oooooooooo05gooooo00?o0000ooooooooool01?ooool6onKViRCooooo0_l0000^ooooo`?o0000
<_ooool002kooooo0ol0000]ooooo`;o0000;oooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool0;Oooool2o`0002gooooo0ol0000eooooo`00<Oooool4
o`0002_ooooo0_l0000^ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0/ooooo`;o0000:oooool4o`0003Sooooo000eooooo`?o0000:_ooool3o`00
02cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02[ooooo0ol0000Zooooo`?o0000??ooool003Sooooo0ol0000Zooooo`;o0000:oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool2o`0002[o
oooo0ol0000oooooo`00>oooool3o`0002Wooooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`;o0000:Oooool3o`0004;ooooo
000nooooo`?o0000:?ooool2o`0002Wooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo02Oooooo0_l0000Xooooo`?o0000AOooool0047ooooo1?l0000V
ooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool09_ooool2o`0002Kooooo1?l00018ooooo`00AOooool3o`0002Gooooo0_l0000Woooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uoooo
o`;o00009Oooool3o`0004cooooo0018ooooo`?o00009?ooool2o`0002Kooooo0_l0000Uooooo`03
o`000?oooooooooo02?ooooo0_l0000Vooooo`;o00009?ooool3o`0004oooooo001;ooooo`?o0000
8oooool2o`0002Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo02Cooooo0_l0000Sooooo`?o0000D_ooool004kooooo0ol0000Rooooo`?o00009?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08_oo
ool3o`0002;ooooo0ol0001Eooooo`00DOooool3o`0002;ooooo0_l0000Sooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qooooo`;o00008_ooool3
o`0005Sooooo001Dooooo`Co00008?ooool2o`0002;ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo0_l0000Pooooo`Co0000Foooool005So
oooo0ol0000Oooooo`;o00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07oooool2o`0001oooooo0ol0001Oooooo`00Foooool3o`0001kooooo
0_l0000Pooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Nooooo`;o00007_ooool3o`0006;ooooo001Nooooo`?o00007Oooool2o`0001oooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo0_l0
000Mooooo`?o0000IOooool0067ooooo0ol0000Looooo`;o00007_ooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool07?ooool2o`0001cooooo0ol0001X
ooooo`00I?ooool4o`0001[ooooo0ol0000Looooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`?o00006_ooool4o`0006_ooooo001Xooooo`?o
00006_ooool2o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01Wooooo0_l0000Jooooo`?o0000Koooool006_ooooo0ol0000Iooooo`;o0000
6_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
6?ooool2o`0001Wooooo0ol0001booooo`00K_ooool3o`0001Sooooo0_l0000Iooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o00006?oo
ool3o`0007Gooooo001aooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000N?ooool0
07Cooooo0ol0000Fooooo`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool05Oooool2o`0001Kooooo0ol0001kooooo`00Moooool4o`0001Co
oooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Dooooo`;o00005?ooool4o`0007kooooo001kooooo`?o00004oooool2o`0001Gooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo
0_l0000Cooooo`?o0000P_ooool007kooooo0ol0000Booooo`?o00004oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool3o`0001;ooooo0ol0
0025ooooo`00POooool3o`0001;ooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`;o00004_ooool3o`0008Sooooo0024oooo
o`?o00004Oooool2o`00017ooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000Aoooo
o`;o00004Oooool3o`0008_ooooo0027ooooo`Co00003oooool2o`00017ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0000?ooooo`Co
0000S_ooool008_ooooo0ol0000>ooooo`;o00004?ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`0000kooooo0ol0002Booooo`00S_oo
ool3o`0000gooooo0_l0000?ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`;o00003Oooool3o`0009Gooooo002Aooooo`?o00003?ooool2
o`0000kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00cooooo0_l0000<ooooo`?o0000V?ooool009Cooooo0ol0000;ooooo`;o00003Oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool2o`00
00_ooooo0ol0002Kooooo`00Uoooool3o`0000[ooooo0ol0000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`?o00002_ooool3o`0009ko
oooo002Jooooo`Co00002Oooool2o`0000[ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l00009ooooo`Co0000XOooool009kooooo0ol0
0008ooooo`;o00002Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool2o`0000Sooooo0ol0002Uooooo`00XOooool3o`0000Oooooo0_l00008
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`;o00001oooool3o`000:Sooooo002Tooooo`?o00001_ooool2o`0000Oooooo00?o0000oooo
ooooool00_ooool6onKViPGooooo00?o0000ooooooooool01Oooool2o`0000Kooooo0ol0002[oooo
o`00Yoooool3o`0000Gooooo0_l00006ooooo`03o`000?ooooooi^KV00Woi^KV0_ooool00ol0003o
ooooooooo`04ooooo`;o00001Oooool3o`000:kooooo002Zooooo`Co00000oooool2o`0000Gooooo
3?oVi^H00ol0003oooooooooo`03ooooo`;o00000oooool4o`000;7ooooo002^ooooo`?o00000_oo
ool2o`0000;ooooo3_oVi^H3ooooo`;o00000_ooool3o`000;Gooooo002aooooo`?o000000?ooooo
o`000?oVi^H03ooVi^H2o`000004ooooool0003o0000o`000;Sooooo002dooooo`;o00004?oVi^H3
o`000;_ooooo002eooooo`Koi^KV1_l00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[go
oooo002eooooo`Soi^KV0_l00008onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002e
ooooo`Ooi^KV1Ol00006onKVi[gooooo002eooooo`Soi^KV0_l00008onKVi[gooooo002fooooo`So
i^KV0ol00005onKVi[kooooo002foooooa3oi^KV__ooool00;Oooooo3_oVi^Joooooo`00^?ooool<
onKVi/3ooooo002iooooo`[oi^KV`Oooool00;_ooooo1_oVi^K3ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.490619 0.233404 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.17941 .45617 -5 -6 ]
[.17941 .45617 5 6 ]
[.27696 .30902 -5 -6 ]
[.27696 .30902 5 6 ]
[.33502 .30902 -5 -6 ]
[.33502 .30902 5 6 ]
[.27514 .16187 -5 -6 ]
[.27514 .16187 5 6 ]
[.39307 .16187 -5 -6 ]
[.39307 .16187 5 6 ]
[.51099 .16187 -5 -6 ]
[.51099 .16187 5 6 ]
[.39307 .30902 -5 -6 ]
[.39307 .30902 5 6 ]
[.33502 .45617 -5 -6 ]
[.33502 .45617 5 6 ]
[.49062 .45617 -5 -6 ]
[.49062 .45617 5 6 ]
[.58817 .30902 -5 -6 ]
[.58817 .30902 5 6 ]
[.5283 .16187 -5 -6 ]
[.5283 .16187 5 6 ]
[.76415 .16187 -5 -6 ]
[.76415 .16187 5 6 ]
[.64622 .30902 -5 -6 ]
[.64622 .30902 5 6 ]
[.58635 .16187 -5 -6 ]
[.58635 .16187 5 6 ]
[.66821 .01472 -5 -6 ]
[.66821 .01472 5 6 ]
[.8222 .01472 -5 -6 ]
[.8222 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8222 .16187 -5 -6 ]
[.8222 .16187 5 6 ]
[.70428 .30902 -5 -6 ]
[.70428 .30902 5 6 ]
[.64622 .45617 -5 -6 ]
[.64622 .45617 5 6 ]
[.80182 .45617 -5 -6 ]
[.80182 .45617 5 6 ]
[.95743 .45617 -5 -6 ]
[.95743 .45617 5 6 ]
[.49062 .60332 -5 -6 ]
[.49062 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49062 .60332 m
.02381 .45617 L
s
.49062 .60332 m
.17941 .45617 L
s
.49062 .60332 m
.33502 .45617 L
s
.49062 .60332 m
.49062 .45617 L
s
.49062 .60332 m
.64622 .45617 L
s
.49062 .60332 m
.80182 .45617 L
s
.49062 .60332 m
.95743 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.17941 .45617 Mdot
0 g
gsave
.17941 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.33502 .45617 m
.27696 .30902 L
s
.33502 .45617 m
.33502 .30902 L
s
.33502 .45617 m
.39307 .30902 L
s
1 g
.05 w
.27696 .30902 Mdot
0 g
gsave
.27696 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.33502 .30902 Mdot
0 g
gsave
.33502 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.39307 .30902 m
.27514 .16187 L
s
.39307 .30902 m
.39307 .16187 L
s
.39307 .30902 m
.51099 .16187 L
s
1 g
.05 w
.27514 .16187 Mdot
0 g
gsave
.27514 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.39307 .16187 Mdot
0 g
gsave
.39307 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.51099 .16187 Mdot
0 g
gsave
.51099 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.39307 .30902 Mdot
0 g
gsave
.39307 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.33502 .45617 Mdot
0 g
gsave
.33502 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49062 .45617 Mdot
0 g
gsave
.49062 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .45617 m
.58817 .30902 L
s
.64622 .45617 m
.64622 .30902 L
s
.64622 .45617 m
.70428 .30902 L
s
1 g
.05 w
.58817 .30902 Mdot
0 g
gsave
.58817 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.64622 .30902 m
.5283 .16187 L
s
.64622 .30902 m
.76415 .16187 L
s
1 g
.05 w
.5283 .16187 Mdot
0 g
gsave
.5283 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76415 .16187 Mdot
0 g
gsave
.76415 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.64622 .30902 Mdot
0 g
gsave
.64622 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.70428 .30902 m
.58635 .16187 L
s
.70428 .30902 m
.8222 .16187 L
s
1 g
.05 w
.58635 .16187 Mdot
0 g
gsave
.58635 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.8222 .16187 m
.66821 .01472 L
s
.8222 .16187 m
.8222 .01472 L
s
.8222 .16187 m
.97619 .01472 L
s
1 g
.05 w
.66821 .01472 Mdot
0 g
gsave
.66821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.8222 .01472 Mdot
0 g
gsave
.8222 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.8222 .16187 Mdot
0 g
gsave
.8222 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.70428 .30902 Mdot
0 g
gsave
.70428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.64622 .45617 Mdot
0 g
gsave
.64622 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.80182 .45617 Mdot
0 g
gsave
.80182 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.95743 .45617 Mdot
0 g
gsave
.95743 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49062 .60332 Mdot
0 g
gsave
.49062 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00o_ooool5o`0003Gooooo1?l0000eooooo`Go0000
3_ooool00?gooooo0_l000000ooooooo0000o`00000eooooo`;o00000_ooool2o`0003Gooooo0_l0
00000ooooooo0000o`00000=ooooo`00o_ooool4o`0003Wooooo0_l0000eooooo`;o000000?ooooo
o`000?l000003Oooool00?gooooo0_l000000ooooooo0000o`00000iooooo`;o0000=Oooool2o`00
0003ooooool0003o000000gooooo003nooooo`?o0000=_ooool5o`0003Kooooo1?l0000>ooooo`00
oooooolhooooo`;o0000>Oooool2o`00013ooooo003oooooocSooooo1_l0000dooooo`?o00004?oo
ool00?ooooooQOooool00?oooooo2?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo
01Cooooo003oooooo`Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Eooooo`00
ooooool:ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool05_ooool00?oooooo2ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool05ooo
ool00?oooooo3?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool06?ooool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool06Oooool00?oooooo3_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool06_ooool00?oooooo3oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool06oooool00?oooooo4?oo
ool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07?oo
ool00?oooooo4Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool07Oooool00?oooooo4_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool07_ooool00?oooooo4oooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07oooool00?oooooo5?ooool2o`0002Gooooo
00?o0000ooooooooool08oooool2o`0002;ooooo003ooooooaKooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo003ooooooaOooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02?ooooo003ooooo
oaSooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
02Cooooo003ooooooaWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo02Gooooo003ooooooa[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo02Kooooo003ooooooa_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02Oooooo003ooooooacooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02Sooooo003ooooo
oagooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02Wooooo003ooooooakooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02[ooooo003ooooooaoooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo02_ooooo003oooooob3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02cooooo003oooooob7ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02gooooo003ooooo
ob;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
02kooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo02oooooo003oooooobCooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo033ooooo003oooooobGooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo003oooooobKooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03;ooooo003ooooo
obOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03?ooooo003oooooobSooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0000fooooo`00
oooooolZooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0fooooo`00ooooool[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0gooooo`00ooooool/ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0hooooo`00ooooool]ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0iooooo`00ooooool^ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0jooooo`00
ooooool_ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0kooooo`00ooooool`ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0looooo`00oooooolaooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0mooooo`00oooooolbooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`00oooooolcooooo`03
o`000?oooooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo03oooooo003oooooocCooooo
00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo043ooooo003oooooocGooooo3?oV
i^H00ol0003oooooooooo`11ooooo`00ooooooldooooo`koi^KV@oooool00?oooooo<oooool6onKV
iPCo00001_oVi^I2ooooo`00oooooolcooooo`Woi^KV0_l00005onKViT;ooooo001[ooooo`Go0000
9oooool5o`0002kooooo1?l0000Booooo`Go0000?Oooool4o`0000_ooooo1ooVi^H5o`0000Koi^KV
@Oooool006[ooooo0_l000000ooooooo0000o`00000Wooooo`;o000000?oooooo`000?l00000;_oo
ool2o`0000;ooooo0_l0000@ooooo`;o000000?oooooo`000?l00000?Oooool2o`0000;ooooo0_l0
000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1ooooo`00Joooool4o`0002Sooooo1?l0000^
ooooo`;o00005Oooool4o`00047ooooo0_l0000:ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I1
ooooo`00J_ooool2o`000003ooooool0003o000002Oooooo0_l000000ooooooo0000o`00000^oooo
o`;o00000_ooool2o`00013ooooo0_l000000ooooooo0000o`000011ooooo`;o00002_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV@Oooool006_ooooo0ol0000Yooooo`?o0000<?ooool4o`0001;o
oooo0ol0000nooooo`Go00002oooool7onKViPKo00001OoVi^I1ooooo`00oooooolRooooo`;o0000
3_oooolBonKViT7ooooo003oooooob;ooooo1_l0000;oooooa3oi^KV@_ooool00?oooooo<oooool@
onKViT;ooooo003oooooocCooooo3_oVi^I3ooooo`00ooooooleooooo`coi^KVA?ooool007?ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV00Soi^KV
AOooool007Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Cooooo`04o`000?oo
ooooooooooooo`Koi^KVAoooool007Gooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Coooool007Gooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Coooool007Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool007Oooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0DOooool007Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0D_ooool007Wooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Dooo
ool007Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Doooool007[ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool007_o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0EOooool007cooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E_ooool007gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Eoooool007gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool007kooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0F?ooool007oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0FOooool0083ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
F_ooool0087ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0Foooool0087ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool0
08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
02kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0G?ooool008?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0GOooool008Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo037ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0G_ooool008Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool008Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Goooool008Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo03Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H?ooool008Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0HOooool008Sooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool008Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Hooo
ool008Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0Hoooool008[ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0I?ooool008_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0IOooool008cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool04oooool01Ol0003ooooo
oooooooooooo000001Gooooo00?o0000ooooooooool0I_ooool008gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
4oooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo06Oooooo002=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooool000005Oooool00ol0003oooooooooo`1Wooooo`00S_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0J?ooool0
08oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04Sooooo00?o0000ooooooooool04Oooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo
06Wooooo002@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo00oooooo00Go0000ooooooooooooooooo`00000Aoooo
o`03o`000?oooooooooo06[ooooo002Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06_ooooo002Aooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo06_ooooo002Booooo`03o`000?oooooooooo00;ooooo1_oVi^H3ooooo`03o`000?oo
oooooooo04kooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oooooooooo06cooooo002Cooooo`03o`00
0?ooooooi^KV00Woi^KV00?o0000ooooooooool0D?ooool00ol0003oi^KVonKViP08onKViP03oooo
ool0003ooooo00Sooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1^ooooo`00U?oo
ool<onKViU;ooooo3?oVi^H:ooooo`coi^KVL?ooool009?ooooo3_oVi^I@ooooo`koi^KV2?ooool>
onKViVoooooo002Booooo`Goi^KV1?l00007onKViTkooooo1_oVi^H4o`0000Koi^KV1_ooool6onKV
iPCo00001_oVi^I^ooooo`00T_ooool8onKViP;o00001_oVi^I>ooooo`Woi^KV0_l00005onKViPKo
oooo2OoVi^H2o`0000Goi^KVK_ooool006_ooooo1_l0000Aooooo`Co00002oooool6onKViPGo0000
1ooVi^Hmooooo`Go00002_ooool7onKViPGo00001_oVi^H4ooooo`Ooi^KV1Ol00006onKViVgooooo
001/ooooo`;o000000?oooooo`000?l000004?ooool2o`0000;ooooo0_l0000:ooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hlooooo`;o000000?oooooo`000?l000002oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV1?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVKOooool006gooooo0_l0000F
ooooo`;o00002_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV??ooool2o`000003ooooool0003o
000000_ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViPCooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViVgooooo001^ooooo`;o00005Oooool2o`0000[ooooo1OoVi^H2o`0000;oi^KV0_l00007onKV
iScooooo0_l000000ooooooo0000o`00000;ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H4oooo
o`Koi^KV0_l00002onKViP;o00001_oVi^I]ooooo`00Joooool2o`0000;ooooo0_l0000@ooooo`Go
00002oooool6onKViPKo00001_oVi^Hmooooo`Co00002oooool7onKViPKo00001OoVi^H4ooooo`Oo
i^KV1_l00005onKViVgooooo001[ooooo`;o00000_ooool2o`00013ooooo0_l0000>oooooa;oi^KV
?oooool2o`0000_ooooo4_oVi^H4oooooa;oi^KVKOooool006cooooo1?l0000Aooooo`Ko00002ooo
ool@onKViSoooooo0ol0000<oooooa3oi^KV1_ooool@onKViVkooooo002Boooooa3oi^KVC_ooool@
onKViPKooooo4?oVi^I^ooooo`00Toooool>onKViU3ooooo3_oVi^H8ooooo`koi^KVKoooool009Co
oooo3?oVi^IBooooo`coi^KV2_ooool<onKViW3ooooo002Eooooo`[oi^KVE?ooool:onKViPcooooo
2_oVi^Iaooooo`00LOooool00ol0003oooooooooo`0Rooooo`03o`000?oVi^Koi^KV00Coi^KVF?oo
ool6onKViQ3ooooo1_oVi^Icooooo`00L_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool0Moooool007;ooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo07Oooooo001cooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1hooooo`00Loooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0D?ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0N?ooool007?ooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo053ooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo07Sooooo001d
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1B
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1i
ooooo`00M?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool0NOooool007Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo05?ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo07[ooooo001eooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`1jooooo`00MOooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool0N_ooool007Kooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo07_ooooo001fooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1kooooo`00Moooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Eoooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0O?ooool007Oooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Sooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07cooooo
001gooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`1Hooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`1looooo`00N?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0FOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0OOooool007Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo05[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo07gooooo001iooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`1nooooo`00NOooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0G?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool0O_ooool007Wooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07kooooo001jooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Mooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1oooooo`00N_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0G_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Ooooool007_o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo083o
oooo001kooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1Oooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`20ooooo`00Noooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0P?ooool007cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo087ooooo001looooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`21ooooo`00OOooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0P_ooool007gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08;ooooo001mooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Tooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`22ooooo`00O_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0IOooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Poooool0
07kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
08?ooooo001oooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`1Wooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`24ooooo`00Ooooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0Ioooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0Q?ooool007oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000006[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo08Cooooo0020ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`1Yooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`25ooooo`00
P?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0JOooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool0QOooool0087ooooo1_oVi^H00ol0003o
ooooooooo`1[ooooo`Koi^KV00?o0000ooooooooool0Q_ooool007oooooo2_oVi^IZooooo`[oi^KV
Qoooool007kooooo3?oVi^IXooooo`coi^KVQ_ooool007gooooo3_oVi^IVooooo`koi^KVQOooool0
07cooooo1_oVi^H4o`0000Koi^KVI?ooool@onKViXCooooo001looooo`Woi^KV0_l00005onKViVCo
oooo4?oVi^J4ooooo`003?ooool5o`0003Kooooo1?l0000`ooooo`Ooi^KV1Ol00006onKViRoooooo
1Ol0000^ooooo`Koi^KV1ol00005onKViRoooooo1_l0000dooooo`Ko00005?ooool000gooooo0_l0
00000ooooooo0000o`00000dooooo`;o0000<oooool6onKViP;o00000_oVi^H2o`0000Koi^KV;_oo
ool2o`000003ooooool0003o000002oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV<?oo
ool2o`000003ooooool0003o000003Gooooo0_l000000ooooooo0000o`00000Dooooo`003Oooool2
o`000003ooooool0003o000003Cooooo1_l0000_ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H^
ooooo`;o000000?oooooo`000?l00000;oooool7onKViP;o000000?oi^KVo`000?l000001_oVi^Ha
ooooo`;o0000>?ooool2o`0001Kooooo000=ooooo`;o000000?oooooo`000?l00000=?ooool2o`00
00;ooooo0_l0000_ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H^ooooo`;o000000?oooooo`00
0?l00000;oooool7onKViP;o000000?oi^KVo`000?l000001_oVi^Hbooooo`;o0000>?ooool2o`00
01Gooooo000=ooooo`Co0000=_ooool4o`00033ooooo1ooVi^H6o`0000Goi^KV;oooool4o`0002oo
oooo1ooVi^H4o`0000Ooi^KV;oooool2o`0000;ooooo0_l0000dooooo`;o00000_ooool2o`0001Co
oooo000=ooooo`;o00002Oooool3o`00063ooooo4_oVi^Haooooo`;o0000;oooool7onKViP;o0000
2OoVi^H_ooooo`;o00000_ooool2o`0002cooooo0_l00006ooooo`;o00000_ooool2o`0001Cooooo
000<ooooo`?o00003?ooool3o`0003?ooooo0ol0000Xoooooa3oi^KV<Oooool3o`00033ooooo1OoV
i^H3o`0000Soi^KV:Oooool2o`0000Kooooo1?l0000Zooooo`?o00002Oooool4o`0001Gooooo000N
ooooo`Co0000<_ooool2o`0002Kooooo4?oVi^IToooooa3oi^KV9oooool2o`0003;ooooo1?l0000U
ooooo`008_ooool3o`00037ooooo0_l0000Uooooo`koi^KV00?o0000ooooooooool0Hoooool>onKV
iRKooooo0_l0000aooooo`?o0000:Oooool002Gooooo0ol0000`ooooo`;o00009?ooool<onKViP;o
oooo00?o0000ooooooooool0HOooool00ol0003oooooonKViP0;onKViRGooooo0_l0000`ooooo`?o
0000;?ooool002Sooooo0ol0000_ooooo`;o00008oooool:onKViPCooooo00?o0000ooooooooool0
Goooool01?l0003oooooooooooooool:onKViRCooooo0_l0000_ooooo`?o0000;oooool002_ooooo
0ol0000^ooooo`;o00008oooool6onKViPOooooo00?o0000ooooooooool0GOooool00ol0003ooooo
ooooo`04ooooo`Koi^KV9?ooool2o`0002kooooo0ol0000booooo`00;_ooool3o`0002gooooo0_l0
000_ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003ooooooooo
o`0]ooooo`;o0000;Oooool3o`0003Gooooo000aooooo`Co0000:oooool2o`0002kooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0_l0000[
ooooo`Co0000>?ooool003Gooooo0ol0000Zooooo`?o0000;?ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool3o`0002[ooooo0ol0000loooo
o`00>?ooool3o`0002[ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0Yooooo`;o0000:_ooool3o`0003oooooo000kooooo`?o0000
:Oooool2o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`00
0?oooooooooo02Sooooo0_l0000Yooooo`?o0000@_ooool003kooooo0ol0000Xooooo`;o0000:Ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09ooo
ool2o`0002Sooooo0ol00015ooooo`00@Oooool4o`0002Kooooo0_l0000Xooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o00009_ooool4
o`0004Sooooo0015ooooo`?o00009Oooool2o`0002Oooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo0_l0000Uooooo`?o0000C?ooool004So
oooo0ol0000Tooooo`;o00009_ooool2o`0002Gooooo00?o0000ooooooooool08oooool2o`0002Ko
oooo0_l0000Tooooo`?o0000Coooool004_ooooo0ol0000Sooooo`;o00009_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool09?ooool2o`0002?ooooo
0ol0001Booooo`00C_ooool3o`0002;ooooo0ol0000Tooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0Rooooo`?o00008_ooool3o`0005Gooooo001A
ooooo`?o00008_ooool2o`0002?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo027ooooo0_l0000Rooooo`?o0000F?ooool005Cooooo1?l0000Poooo
o`;o00008_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool08?ooool2o`00023ooooo1?l0001Kooooo`00F?ooool3o`0001oooooo0_l0000Qooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`;o
00007oooool3o`0005oooooo001Kooooo`?o00007_ooool2o`00023ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01kooooo0_l0000Nooooo`?o0000
H_ooool005kooooo0ol0000Mooooo`;o00007oooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool07Oooool2o`0001gooooo0ol0001Uooooo`00HOooool3
o`0001cooooo0_l0000Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Looooo`;o00007?ooool3o`0006Sooooo001Tooooo`Co00006_ooool3o`00
01cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01[ooooo0ol0000Jooooo`Co0000Joooool006Sooooo0ol0000Jooooo`;o00006oooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool2o`0001[o
oooo0ol0001_ooooo`00Joooool3o`0001Wooooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`;o00006Oooool3o`0007;ooooo
001^ooooo`?o00006?ooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo01Oooooo0_l0000Hooooo`?o0000MOooool0077ooooo0ol0000G
ooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000
ooooooooool05_ooool2o`0001Oooooo0ol0001hooooo`00M?ooool3o`0001Kooooo0_l0000Goooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eoooo
o`;o00005_ooool3o`0007_ooooo001gooooo`Co00005?ooool2o`0001Kooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo0_l0000Dooooo`Co
0000O_ooool007_ooooo0ol0000Cooooo`;o00005Oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool04oooool2o`0001?ooooo0ol00022ooooo`00O_oo
ool3o`0001;ooooo0ol0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`?o00004_ooool3o`0008Gooooo0021ooooo`?o00004_ooool2
o`0001;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo0_l0000Booooo`?o0000R?ooool008Cooooo0ol0000Aooooo`;o00004Oooool2o`00
017ooooo00?o0000ooooooooool03oooool2o`00017ooooo0_l0000Aooooo`?o0000Roooool008Oo
oooo1?l0000?ooooo`;o00004Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03oooool2o`0000oooooo1?l0002>ooooo`00Roooool3o`0000kooooo
0_l0000@ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0>ooooo`;o00003_ooool3o`0009;ooooo002>ooooo`?o00003Oooool2o`0000oooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo0_l0
000=ooooo`?o0000UOooool0097ooooo0ol0000<ooooo`;o00003_ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool2o`0000cooooo0ol0002H
ooooo`00U?ooool3o`0000_ooooo0_l0000=ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0;ooooo`;o00002oooool3o`0009_ooooo002Gooooo`?o
00002_ooool3o`0000_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo0ol0000:ooooo`?o0000W_ooool009[ooooo1?l00009ooooo`;o0000
2_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool2o`0000Wooooo1?l0002Qooooo`00W_ooool3o`0000Sooooo0_l00009ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`;o00002?oo
ool3o`000:Gooooo002Qooooo`?o00001oooool2o`0000Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000Z?ooool0
0:Cooooo0ol00006ooooo`;o00001oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0
003oooooooooo`05ooooo`;o00001_ooool3o`000:_ooooo002Wooooo`?o00001Oooool2o`0000Ko
oooo00?o0000oooooooVi^H02OoVi^H2ooooo`03o`000?oooooooooo00Cooooo0_l00005ooooo`?o
0000[_ooool00:[ooooo1?l00003ooooo`;o00001Oooool<onKViP03o`000?oooooooooo00?ooooo
0_l00003ooooo`Co0000/Oooool00:kooooo0ol00002ooooo`;o00000_ooool>onKViP?ooooo0_l0
0002ooooo`?o0000]Oooool00;7ooooo0ol000000ooooooo0000onKViP0?onKViP;o000000Cooooo
o`000?l0003o0000^?ooool00;Cooooo0_l0000@onKViP?o0000^oooool00;Gooooo1_oVi^H6o`00
00Koi^KV_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV
_Oooool00;Gooooo2?oVi^H2o`0000Soi^KV_Oooool00;Gooooo1ooVi^H5o`0000Koi^KV_Oooool0
0;Gooooo2?oVi^H2o`0000Soi^KV_Oooool00;Kooooo2?oVi^H3o`0000Goi^KV__ooool00;Kooooo
4?oVi^Jnooooo`00]oooool>onKVi[oooooo002hooooo`coi^KV`?ooool00;Wooooo2_oVi^K1oooo
o`00^oooool6onKVi/?ooooo0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17673, -0.833976, \
0.011433, 0.00362689}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selective mutations", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["The basic expression", "Subsubsection"],

Cell["\<\
theChromos = 
pop[chromo[q[undef], 
  p[f[a, g[b, 3], c, h[e, g[c, g[b, 4]]], 2]]]];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.44709 .16187 -5 -6 ]
[.44709 .16187 5 6 ]
[.62346 .01472 -5 -6 ]
[.62346 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79982 .16187 -5 -6 ]
[.79982 .16187 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.44709 .16187 L
s
.62346 .30902 m
.79982 .16187 L
s
1 g
.05 w
.44709 .16187 Mdot
0 g
gsave
.44709 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.79982 .16187 m
.62346 .01472 L
s
.79982 .16187 m
.97619 .01472 L
s
1 g
.05 w
.62346 .01472 Mdot
0 g
gsave
.62346 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.79982 .16187 Mdot
0 g
gsave
.79982 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00kOooool5o`00087ooooo1?l0000=ooooo`00k_oo
ool2o`000003ooooool0003o0000087ooooo0_l0000>ooooo`00k_ooool2o`000003ooooool0003o
000007kooooo1_l0000=ooooo`00k_ooool2o`000003ooooool0003o000007kooooo0_l000000ooo
oooo0000o`00000>ooooo`00k_ooool4o`00083ooooo1?l0000>ooooo`00k_ooool2o`0008?ooooo
0ol0000>ooooo`00kOooool3o`0008Cooooo0_l0000>ooooo`00moooool00ol0003oooooooooo`2:
ooooo`00n?ooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo01Gooooo003iooooo`03
o`000?oooooooooo06oooooo00?o0000ooooooooool05_ooool00?[ooooo00?o0000ooooooooool0
KOooool00ol0003oooooooooo`0Gooooo`00noooool00ol0003oooooooooo`1[ooooo`03o`000?oo
oooooooo01Sooooo003looooo`;o0000JOooool2o`0001_ooooo003nooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool06oooool00?oooooo00?o0000ooooooooool0Hoooool00ol0003o
ooooooooo`0Looooo`00ooooool1ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool0
7Oooool00?oooooo0_ooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo01kooooo003o
ooooo`?ooooo0_l0001Mooooo`;o00008Oooool00?oooooo1Oooool00ol0003oooooooooo`1Ioooo
o`03o`000?oooooooooo027ooooo003oooooo`Kooooo00?o0000ooooooooool0Eoooool00ol0003o
ooooooooo`0Rooooo`00ooooool7ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool0
8oooool00?oooooo2?ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo02Cooooo003o
ooooo`Wooooo0_l0001Aooooo`;o00009oooool00?oooooo2oooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo02Oooooo003oooooo`cooooo00?o0000ooooooooool0Boooool00ol0003o
ooooooooo`0Xooooo`00ooooool=ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool0
:Oooool00?oooooo3_ooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo02[ooooo003o
ooooo`oooooo0_l00015ooooo`;o0000;Oooool00?oooooo4Oooool00ol0003oooooooooo`11oooo
o`03o`000?oooooooooo02gooooo003ooooooa;ooooo00?o0000ooooooooool0?oooool00ol0003o
ooooooooo`0^ooooo`00oooooolCooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0
;oooool00?oooooo5?ooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo033ooooo003o
oooooaGooooo0_l0000iooooo`;o0000<oooool00?oooooo5oooool00ol0003oooooooooo`0eoooo
o`03o`000?oooooooooo03?ooooo003ooooooaSooooo00?o0000ooooooooool0<oooool00ol0003o
ooooooooo`0dooooo`00oooooolIooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0
=Oooool00?oooooo6_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo03Kooooo003o
oooooa_ooooo0_l0000]ooooo`;o0000>Oooool00?oooooo7Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo03Wooooo003ooooooakooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`0jooooo`00oooooolOooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
>oooool00?oooooo8?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03cooooo003o
ooooob7ooooo0_l0000Qooooo`;o0000?oooool00?oooooo8oooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo03oooooo003oooooobCooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`10ooooo`00oooooolUooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
@Oooool00?oooooo9_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo04;ooooo003o
ooooobOooooo0_l0000Eooooo`;o0000AOooool00?oooooo:Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo04Gooooo003oooooob[ooooo00?o0000ooooooooool00oooool6onKViPKo
oooo00?o0000ooooooooool0A_ooool00?oooooo:oooool00ol0003oooooooooo`0:onKViP?ooooo
00?o0000ooooooooool0Aoooool00?oooooo;?ooool00ol0003oi^KVonKViP0:onKViP03ooooool0
003ooooo04Wooooo003oooooobcooooo3_oVi^I;ooooo`00ooooool[ooooo`Koi^KV1?l00006onKV
iT[ooooo003oooooob_ooooo2OoVi^H2o`0000Goi^KVB_ooool00:cooooo1?l0001iooooo`Ooi^KV
1Ol00006onKViTWooooo002[ooooo`;o00000_ooool2o`0007Sooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViTWooooo002[ooooo`;o0000O?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVBOooool0
0:_ooooo0_l00002ooooo`;o0000N?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVBOooool00:co
oooo1?l0001iooooo`Ooi^KV1_l00005onKViTWooooo003oooooob[ooooo4_oVi^I9ooooo`00oooo
ool[oooooa3oi^KVB_ooool00?oooooo:oooool@onKViT[ooooo002fooooo`03o`000?oooooooooo
077ooooo00?o0000onKVi_oVi^H03?oVi^I;ooooo`00]oooool00ol0003oooooooooo`1_ooooo`03
o`000?oooooooooo00coi^KVC?ooool00;Sooooo00?o0000ooooooooool0KOooool00ol0003ooooo
ooooo`02ooooo`[oi^KVCOooool00;Wooooo00?o0000ooooooooool0Joooool00ol0003ooooooooo
o`05ooooo`Koi^KVCoooool00;[ooooo0_l0001Yooooo`;o0000GOooool00;cooooo00?o0000oooo
ooooool0IOooool00ol0003oooooooooo`1Mooooo`00_Oooool00ol0003oooooooooo`1Sooooo`03
o`000?oooooooooo05kooooo002nooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool0
Goooool00;oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`1Pooooo`00`?ooool2
o`0005gooooo0_l0001Sooooo`00`_ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo
06?ooooo0033ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool0I?ooool00<Cooooo
00?o0000ooooooooool0EOooool00ol0003oooooooooo`1Uooooo`00aOooool00ol0003ooooooooo
o`1Cooooo`03o`000?oooooooooo06Kooooo0036ooooo`;o0000DOooool2o`0006Wooooo0038oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0JOooool00<Wooooo00?o0000oooooooo
ool0Boooool00ol0003oooooooooo`1Zooooo`00b_ooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo06_ooooo003;ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool0K?oo
ool00<cooooo0_l00015ooooo`;o0000Koooool00<kooooo00?o0000ooooooooool0@Oooool00ol0
003oooooooooo`1_ooooo`00coooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo073o
oooo003@ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0LOooool00=7ooooo00?o
0000ooooooooool0>oooool00ol0003oooooooooo`1booooo`00d_ooool2o`0003Wooooo0_l0001e
ooooo`00e?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo07Gooooo003Eooooo`03
o`000?oooooooooo03?ooooo00?o0000ooooooooool0M_ooool00=Kooooo00?o0000ooooooooool0
<Oooool00ol0003oooooooooo`1gooooo`00eoooool00ol0003oooooooooo`0_ooooo`03o`000?oo
oooooooo07Sooooo003Hooooo`;o0000;Oooool2o`0007_ooooo003Jooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool0Noooool00=_ooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`1looooo`00g?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo07gooooo
003Mooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0O_ooool00=kooooo0_l0000Q
ooooo`;o0000POooool00>3ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`21oooo
o`00hOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo08;ooooo003Rooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool0Poooool00>?ooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`24ooooo`00i?ooool2o`0001Gooooo0_l00027ooooo`00i_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo08Oooooo003Wooooo`03o`000?oooooooooo00?o
oooo1_oVi^H6ooooo`03o`000?oooooooooo08Sooooo003Xooooo`03o`000?oooooooooo00[oi^KV
0oooool00ol0003oooooooooo`29ooooo`00jOooool00ol0003oi^KVonKViP0:onKViP03ooooool0
003ooooo08_ooooo003Yooooo`koi^KVSOooool00>Sooooo1_oVi^H4o`0000Koi^KVS?ooool00>So
oooo2OoVi^H2o`0000Goi^KVS?ooool003Cooooo1Ol0000`ooooo`Co0000C?ooool4o`0002[ooooo
1ooVi^H5o`0000Koi^KVRoooool003Gooooo0_l000000ooooooo0000o`00000^ooooo`;o00000_oo
ool2o`0004[ooooo0_l0000]ooooo`Koi^KV0_l00002onKViP;o00001_oVi^J;ooooo`00=Oooool2
o`000003ooooool0003o000003;ooooo0_l0001:ooooo`Ko0000:Oooool6onKViP;o00000_oVi^H2
o`0000Koi^KVRoooool003Gooooo0_l000000ooooooo0000o`00000`ooooo`?o0000Boooool2o`00
00;ooooo0_l0000Yooooo`Koi^KV0_l00002onKViP;o00001_oVi^J;ooooo`00=Oooool4o`0003?o
oooo0_l0001;ooooo`Co0000:_ooool7onKViPKo00001OoVi^J;ooooo`00=Oooool2o`00037ooooo
0_l00002ooooo`;o0000NOoooolBonKViX_ooooo000dooooo`?o0000<_ooool4o`0007_ooooo4?oV
i^J<ooooo`00j?ooool@onKViXcooooo003Yooooo`koi^KVSOooool00>[ooooo3?oVi^J>ooooo`00
joooool:onKViXoooooo000kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0EOoo
ool00ol0003oooooooooo`0Zooooo`03o`000?oVi^Koi^KV00Coi^KVTOooool003_ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0U_ooool003cooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`1Goooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0U_ooool003cooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool0Uoooool003gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1Iooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool0Uoooool003gooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0V?oo
ool003kooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1Kooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool0V?ooool003kooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`1Kooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0VOooool003oo
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0VOooool003oooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`1Mooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0V_ooool0043ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0V_ooool0043ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1O
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0Voooool0047ooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool0Voooool0047ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`1Qooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool0W?ooool004;ooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
W?ooool004;ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1Sooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool0WOooool004?ooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`1Uooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0WOooool0
04?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0W_ooool004Cooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`1Wooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0W_ooool004Cooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool0Woooool004Cooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`1Wooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Woooool004Gooooo00?o0000
ooooooooool05Oooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo01Kooooo00?o0000
ooooooooool0Woooool004Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1Yoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0X?ooool004Kooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool0X?ooool004Kooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1[ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0XOooool004Oooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0XOoo
ool004Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1]ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0X_ooool004Sooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`1_ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0X_ooool004So
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1_ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool0Xoooool004Wooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`1aooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0Xoooool004Wooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0Y?ooool004[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1c
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Y?ooool004[ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`1cooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0YOooool004_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1eooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0YOooool004_ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
Y_ooool004cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1gooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0Y_ooool004cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Yoooool0
04gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0Yoooool004gooooo00?o0000onKVi_oVi^H01?oVi^H00ooooooo
0000ooooo`1jooooo`03o`000?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool0ZOooool004cooooo
2_oVi^Ijooooo`[oi^KVZ_ooool004_ooooo3?oVi^Ihooooo`coi^KVZOooool004[ooooo3_oVi^If
ooooo`koi^KVZ?ooool004Wooooo1_oVi^H4o`0000Koi^KVM?ooool@onKViZOooooo0019ooooo`Wo
i^KV0_l00005onKViWCooooo4?oVi^JWooooo`003Oooool5o`0003Kooooo1ooVi^H5o`0000Koi^KV
=oooool4o`0003Oooooo1_oVi^H7o`0000Goi^KV=_ooool6o`0006[ooooo000<ooooo`;o000000?o
ooooo`000?l00000=oooool6onKViP;o00000_oVi^H2o`0000Koi^KV=_ooool2o`0000;ooooo0_l0
000fooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViSOooooo0_l000000ooooooo0000o`00
001Zooooo`003Oooool4o`0003Oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViSKooooo0_l0000j
ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViSSooooo0_l0001/ooooo`003?ooool2o`00
0003ooooool0003o000003Oooooo1_oVi^H2o`0000;oi^KV0_l00006onKViSKooooo0_l00002oooo
o`;o0000=_ooool7onKViP;o000000?oi^KVo`000?l000001_oVi^Hiooooo`;o0000Joooool000go
oooo0ol0000hooooo`Ooi^KV1_l00005onKViSOooooo1?l0000gooooo`Ooi^KV1?l00007onKViSKo
oooo0_l00002ooooo`;o0000J_ooool004Sooooo4_oVi^Ibooooo`Ooi^KV0_l00009onKViSKooooo
0_l00002ooooo`;o0000J_ooool001Sooooo0ol0000^oooooa3oi^KVM?ooool5onKViP?o00002?oV
i^H_ooooo`?o00001_ooool4o`0006_ooooo000Kooooo`;o0000;?ooool@onKViWCooooo4?oVi^H]
ooooo`;o0000N?ooool001gooooo0ol0000Zooooo`koi^KV00?oooooo`000?ooool0L_ooool00ol0
003oi^KVonKViP0<onKViR_ooooo0ol0001jooooo`008?ooool2o`0002Wooooo3?oVi^H3ooooo`03
o`000?oooooooooo06oooooo00?o0000ooooooooool03?oVi^HZooooo`;o0000OOooool002;ooooo
0_l0000Xooooo`[oi^KV1Oooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo00;ooooo
2_oVi^HYooooo`;o0000Ooooool002Cooooo0ol0000Wooooo`Koi^KV2?ooool00ol0003ooooooooo
o`1[ooooo`03o`000?oooooooooo00Gooooo1_oVi^HXooooo`?o0000POooool002Oooooo0_l0000d
ooooo`;o0000=?ooool00ol0003oooooooooo`0booooo`;o0000=?ooool2o`0008Cooooo000Yoooo
o`?o0000<oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000oooo
ooooool0<Oooool3o`0008Kooooo000/ooooo`;o0000<_ooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo033ooooo00?o0000ooooooooool0<?ooool2o`0008Wooooo000^ooooo`;o0000
<Oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
;oooool2o`0008_ooooo000`ooooo`?o0000;oooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool0;Oooool3o`0008gooooo000cooooo`;o0000;_ooool2
o`0002kooooo00?o0000ooooooooool0;?ooool2o`0002kooooo0_l0002@ooooo`00=Oooool3o`00
02gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo0ol0002Booooo`00>?ooool2o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo0_l0002Eooooo`00>_ooool2o`0002_ooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo
0_l0002Gooooo`00??ooool3o`0002Wooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02Oooooo0ol0002Iooooo`00?oooool2o`0002Sooooo0_l0000X
ooooo`03o`000?oooooooooo02Kooooo0_l0000Xooooo`;o0000W?ooool0047ooooo0ol0000Woooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uoooo
o`?o0000W_ooool004Cooooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`0Tooooo`;o0000XOooool004Kooooo0_l0000Uooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`;o0000
Xoooool004Sooooo0ol0000Sooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Qooooo`?o0000YOooool004_ooooo0_l0000Rooooo`;o00008_ooool0
0ol0003oooooooooo`0Pooooo`;o00008_ooool2o`000:Sooooo001=ooooo`?o00008Oooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool3o`00
0:[ooooo001@ooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07_ooool2o`000:gooooo001Booooo`;o00007oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool2o`000:oooooo
001Dooooo`?o00007Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool06oooool3o`000;7ooooo001Gooooo`;o00007?ooool2o`0001cooooo00?o0000
ooooooooool06_ooool2o`0001cooooo0_l0002dooooo`00FOooool3o`0001_ooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0ol0002foooo
o`00G?ooool2o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo01Sooooo0_l0002iooooo`00G_ooool2o`0001Wooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0_l0002kooooo`00H?oo
ool3o`0001Oooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo01Gooooo0ol0002mooooo`00Hoooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooo
oooo01Cooooo0_l0000Fooooo`;o0000`?ooool006Gooooo0ol0000Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`?o0000`_ooool006So
oooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`;o0000aOooool006[ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000aoooool006cooooo0ol0
000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0?ooooo`?o0000bOooool006oooooo0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>
ooooo`;o00004?ooool2o`000<cooooo001aooooo`?o00003oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool3o`000<kooooo001dooooo`;o
00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool2o`000=7ooooo001fooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool2o`000=?ooooo001hooooo`?o00002ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool3o`000=Gooooo001kooooo`;o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2
o`0000[ooooo0_l0003Hooooo`00OOooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0ol0003Jooooo`00P?ooool2o`0000So
oooo00?o0000ooooooooool00oooool6onKViPKooooo00?o0000ooooooooool01_ooool2o`000=go
oooo0022ooooo`;o00001oooool00ol0003oooooooooo`0:onKViP?ooooo00?o0000ooooooooool0
1Oooool2o`000=oooooo0024ooooo`?o00001Oooool00ol0003oi^KVonKViP0:onKViP03ooooool0
003ooooo00Cooooo0ol0003Qooooo`00Qoooool2o`0000?ooooo3_oVi^H4ooooo`;o0000i?ooool0
08Wooooo0_l0000@onKViP?o0000i_ooool008_ooooo4?oVi^KYooooo`00R_ooool6onKViPKo0000
1_oVi^KXooooo`00R_ooool8onKViP;o00002?oVi^KXooooo`00R_ooool8onKViP;o00002?oVi^KX
ooooo`00R_ooool8onKViP;o00002?oVi^KXooooo`00R_ooool7onKViPGo00001_oVi^KXooooo`00
R_ooool8onKViP;o00002?oVi^KXooooo`00Roooool8onKViP?o00001OoVi^KYooooo`00Roooool@
onKVi^Wooooo002<ooooo`koi^KVj_ooool008gooooo3?oVi^K[ooooo`00S_ooool:onKVi^cooooo
002@ooooo`Koi^KVk_ooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.23388, -0.833976, \
0.0151304, 0.00362689}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["A set of mutated expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
According to the selection templates for subexpressions, only a \
restricted set of nodes is in the scope of the mutation operator.\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
mutChromos = Join @@ Table[
Mutation[theChromos, Templates -> {{{_h, \[Section] _g}, 3},
                                   {{_h},       1}},
                                   
         MaxDepth -> 6, SequenceRange -> {1,2},
         ExprPatterns -> patterns,
         SelectionMode -> RANDOM], {10}]
         
mutChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, c, 1]], 2]]], 
      chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[a, b, 5]], 2]]], 
      chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, g[b, 1, c]]], 2]]], 
      chromo[q[undef], p[f[a, g[b, 3], c, h[4, g[a, b]], 2]]], 
      chromo[q[undef], 
        p[f[a, g[b, 3], c, 
            h[e, g[c, 
                g[a, c, f[b, g[c, a], g[b, g[b, b, c]], h[e, g[c, 1]], 1]]]], 
            2]]], chromo[q[undef], 
        p[f[a, g[b, 3], c, h[e, g[c, g[a, e]]], 2]]], 
      chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, d, 2]], 2]]], 
      chromo[q[undef], 
        p[f[a, g[b, 3], c, h[d, g[c, h[b, g[c, d, 2], g[a, 4]]], g[c, b]], 
            2]]], chromo[q[undef], 
        p[f[a, g[b, 3], c, h[e, g[a, c], g[b, c]], 2]]], 
      chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, a, 5]], 2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, c, 1]], 2]]]\)},
          {\(chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[a, b, 5]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[a, g[b, 3], c, h[e, g[c, g[b, 1, c]]], 2]]]\)},
          {\(chromo[q[undef], p[f[a, g[b, 3], c, h[4, g[a, b]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[a, g[b, 3], c, 
                  h[e, g[c, 
                      g[a, c, 
                        f[b, g[c, a], g[b, g[b, b, c]], h[e, g[c, 1]], 1]]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[a, g[b, 3], c, h[e, g[c, g[a, e]]], 2]]]\)},
          {\(chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[c, d, 2]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[a, g[b, 3], c, 
                  h[d, g[c, h[b, g[c, d, 2], g[a, 4]]], g[c, b]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[a, g[b, 3], c, h[e, g[a, c], g[b, c]], 2]]]\)},
          {\(chromo[q[undef], p[f[a, g[b, 3], c, h[e, g[b, a, 5]], 2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ b, c, 1]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ a, b, 5]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ c, 
                    g[ b, 1, c]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ 4, 
                  g[ a, b]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ c, 
                    g[ a, c, 
                      f[ b, 
                        g[ c, a], 
                        g[ b, 
                          g[ b, b, c]], 
                        h[ e, 
                          g[ c, 1]], 1]]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ c, 
                    g[ a, e]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ c, d, 2]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ d, 
                  g[ c, 
                    h[ b, 
                      g[ c, d, 2], 
                      g[ a, 4]]], 
                  g[ c, b]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ a, c], 
                  g[ b, c]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ a, 
                g[ b, 3], c, 
                h[ e, 
                  g[ b, a, 5]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  AnimationDisplayTime->1.00948],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ mutChromos;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.80041 .01472 -5 -6 ]
[.80041 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.80041 .01472 Mdot
0 g
gsave
.80041 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00kOooool5o`0003kooooo1?l0000nooooo`Co0000
3_ooool00>kooooo0_l000000ooooooo0000o`00000looooo`;o00000_ooool2o`0003kooooo0_l0
000?ooooo`00k_ooool2o`000003ooooool0003o000003cooooo0_l00012ooooo`;o00003oooool0
0>kooooo0_l000000ooooooo0000o`00000looooo`;o00000_ooool2o`0003kooooo0_l0000?oooo
o`00k_ooool4o`0003kooooo1?l0000oooooo`;o00003oooool00>kooooo0_l00022ooooo`?o0000
3oooool00>gooooo0ol00023ooooo`;o00003oooool00?ooooooQOooool00?ooooooQOooool00?Ko
oooo00?o0000ooooooooool0MOooool00ol0003oooooooooo`0Cooooo`00moooool00ol0003ooooo
ooooo`1cooooo`03o`000?oooooooooo01Cooooo003hooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool0=oooool00ol0003oooooooooo`0Eooooo`00nOooool00ol0003oooooooooo`0f
ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool05_ooool00?Wooooo00?o0000oooo
ooooool0=_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo01Kooooo003jooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Gooooo`00
noooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0
6?ooool00?cooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo01Wooooo003mooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0Jooooo`00o_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool06oooool00?oooooo00?o0000ooooooooool0<?ooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo01cooooo003oooooo`7ooooo00?o0000ooooooooool0
;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01gooooo003oooooo`;ooooo00?o
0000ooooooooool0;_ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01kooooo003o
ooooo`?ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo01oooooo003oooooo`Cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo023ooooo003oooooo`Cooooo00?o0000ooooooooool0;?ooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo023ooooo003oooooo`Gooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo027ooooo003oooooo`Kooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02;ooooo003o
ooooo`Oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo02?ooooo003oooooo`Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo02Cooooo003oooooo`Wooooo00?o0000ooooooooool09oooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo02Gooooo003oooooo`[ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo003oooooo`_ooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Oooooo003o
ooooo`cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo02Sooooo003oooooo`gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02Wooooo003oooooo`gooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo02Wooooo003oooooo`kooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02[ooooo003oooooo`oooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02_ooooo003o
oooooa3ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo02cooooo003ooooooa7ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo02gooooo003ooooooa;ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo02kooooo003ooooooa?ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02oooooo003ooooooaCooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo033ooooo003o
oooooaGooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo037ooooo003ooooooaKooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo03;ooooo003ooooooaOooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo03?ooooo003ooooooaOooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03?ooooo003ooooooaSooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Cooooo003o
oooooaWooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo03Gooooo003ooooooa[ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo03Kooooo003ooooooa_ooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo03Oooooo003ooooooacooooo00?o0000ooooooooool0
5?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo03Sooooo003ooooooagooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03Wooooo003o
oooooakooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo03[ooooo003ooooooaoooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo03_ooooo003oooooob3ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo03cooooo003oooooob3ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03cooooo003oooooob7ooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03gooooo003o
ooooob;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo03kooooo003oooooob?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo03oooooo003oooooobCooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo043ooooo003oooooobGooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo047ooooo003oooooobKooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04;ooooo003o
ooooobOooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo04?ooooo003oooooobSooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo04Cooooo003oooooobWooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo04Gooooo003oooooob[ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04Kooooo003oooooob[ooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04Kooooo003o
ooooob_ooooo00?o0000ooooooooool00_ooool6onKViPGooooo00?o0000ooooooooool0Aoooool0
0?oooooo;?ooool00ol0003oooooonKViP09onKViP;ooooo00?o0000ooooooooool0B?ooool00?oo
oooo;Oooool<onKViP03o`000?oooooooooo04Wooooo003oooooobcooooo3_oVi^I;ooooo`00oooo
ool[ooooo`Koi^KV1?l00006onKViT[ooooo003oooooob_ooooo2OoVi^H2o`0000Goi^KVB_ooool0
04Gooooo1Ol0000hooooo`Co0000KOooool4o`0003;ooooo1ooVi^H5o`0000Koi^KVBOooool004Ko
oooo0_l000000ooooooo0000o`00000fooooo`;o00000_ooool2o`0006_ooooo0_l0000eooooo`Ko
i^KV0_l00002onKViP;o00001_oVi^I9ooooo`00A_ooool2o`000003ooooool0003o000003[ooooo
0_l0001[ooooo`Ko0000<Oooool6onKViP;o00000_oVi^H2o`0000Koi^KVBOooool004Kooooo0_l0
00000ooooooo0000o`00000hooooo`?o0000K?ooool2o`0000;ooooo0_l0000aooooo`Koi^KV0_l0
0002onKViP;o00001_oVi^I9ooooo`00A_ooool4o`0003_ooooo0_l0001/ooooo`Co0000<_ooool7
onKViPKo00001OoVi^I9ooooo`00A_ooool2o`0003Wooooo0_l00002ooooo`;o0000X_oooolBonKV
iTWooooo0015ooooo`?o0000>_ooool4o`000:Cooooo4?oVi^I:ooooo`00ooooool[oooooa3oi^KV
B_ooool00?oooooo;?ooool>onKViT_ooooo003oooooobgooooo3?oVi^I<ooooo`00ooooool^oooo
o`[oi^KVCOooool004_ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0cooooo`Ko
i^KVCoooool004cooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`1fooooo`03o`00
0?oooooooooo03;ooooo00?o0000ooooooooool0Doooool004cooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`1fooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0Dooo
ool004gooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1hooooo`03o`000?oooooo
oooo033ooooo00?o0000ooooooooool0E?ooool004gooooo00?o0000ooooooooool0;oooool00ol0
003oooooooooo`1hooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0E?ooool004go
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo02oo
oooo00?o0000ooooooooool0E?ooool004kooooo00?o0000ooooooooool0;Oooool00ol0003ooooo
ooooo`1jooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0EOooool004kooooo00?o
0000ooooooooool0;Oooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool0EOooool004oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1l
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0E_ooool004oooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo02cooooo00?o0000oooo
ooooool0E_ooool0053ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1nooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool0Eoooool0053ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0
Eoooool0053ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1oooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0Eoooool0057ooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`20ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0F?ooool0
057ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo
02Sooooo00?o0000ooooooooool0F?ooool005;ooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`22ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0FOooool005;ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool0FOooool005;ooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`23ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0FOooool005?ooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0F_ooool005?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`25oooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0F_ooool005Cooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0Foooool005Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`26ooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool0Foooool005Cooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0Fooo
ool005Gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`28ooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0G?ooool005Gooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0G?ooool005Ko
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool0GOooool005Kooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`2:ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0GOooool005Kooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`2;ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool0GOooool005Oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2<
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0G_ooool005Oooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool0G_ooool005Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2>ooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool0Goooool005Sooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
Goooool005Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2?ooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool0Goooool005Wooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`2@ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0H?ooool0
05Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool0H?ooool005[ooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`2Booooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0HOooool005[ooooo
00?o0000ooooooooool05Oooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool0HOooool005[ooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`2Cooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0HOooool005_ooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`2Dooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0H_ooool005_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Eoooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0H_ooool005cooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`2Fooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0Hoooool005cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`2Gooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool0Hoooool005cooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Hooo
ool005gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool0I?ooool005gooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`2Iooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0I?ooool005ko
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool0IOooool005kooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`2Kooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0IOooool005oooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`2Looooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool0I_ooool005oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2M
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0I_ooool005oooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0I_ooool0063ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Oooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0Ioooool0063ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
Ioooool0067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Pooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0J?ooool0067ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`2Qooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?ooool0
067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0J?ooool006;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`2Sooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0JOooool006;ooooo
00?o0000onKVi_oVi^H01?oVi^H00ooooooo0000ooooo`2Tooooo`03o`000?oVi^Koi^KV00Coi^KV
00?oooooo`000?ooool0J_ooool0067ooooo2_oVi^JTooooo`[oi^KVJoooool0063ooooo3?oVi^JR
ooooo`coi^KVJ_ooool005oooooo3_oVi^JPooooo`koi^KVJOooool005kooooo4?oVi^JNoooooa3o
i^KVJ?ooool005kooooo1_oVi^H4o`0000Koi^KVW_ooool@onKViVSooooo001Mooooo`[oi^KV0_l0
0006onKViYcooooo4_oVi^IWooooo`003Oooool5o`0004_ooooo1ooVi^H5o`0000Koi^KVC?ooool4
o`0004cooooo1_oVi^H7o`0000Goi^KVBoooool6o`0001Kooooo000<ooooo`;o000000?oooooo`00
0?l00000C?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVBoooool2o`0000;ooooo0_l0001;oooo
o`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViTcooooo0_l000000ooooooo0000o`00000Foooo
o`003Oooool4o`0004cooooo1_oVi^H2o`0000;oi^KV0_l00006onKViT_ooooo0_l0001?ooooo`Oo
i^KV0_l000000ooVi^Ko0000o`000006onKViTgooooo0_l0000Hooooo`003?ooool2o`000003oooo
ool0003o000004cooooo1_oVi^H2o`0000;oi^KV0_l00006onKViT_ooooo0_l00002ooooo`;o0000
Boooool7onKViP;o000000?oi^KVo`000?l000001_oVi^I>ooooo`;o00005oooool000gooooo0ol0
001=ooooo`Ooi^KV1_l00005onKViTcooooo1?l0001<ooooo`Ooi^KV1?l00007onKViT_ooooo0_l0
0002ooooo`;o00005_ooool001Oooooo00?o0000ooooooooool0A?ooool@onKViYkooooo1_oVi^H2
o`0000Soi^KVC?ooool2o`0000;ooooo0_l0000Fooooo`006?ooool3o`0004?ooooo4?oVi^JNoooo
o`Goi^KV0ol00008onKViTCooooo0ol00006ooooo`Co00005oooool001_ooooo0_l00012ooooo`ko
i^KV00?o0000ooooooooool0WOooool>onKViT?ooooo0_l0000Tooooo`007Oooool2o`00047ooooo
3?oVi^H2ooooo`03o`000?oooooooooo09_ooooo00?o0000oooooooVi^H02ooVi^I2ooooo`;o0000
9_ooool001oooooo0ol0000oooooo`[oi^KV1?ooool00ol0003oooooooooo`2Iooooo`04o`000?oo
ooooooooooooo`[oi^KV@?ooool3o`0002Sooooo000Rooooo`;o0000?oooool6onKViPOooooo00?o
0000ooooooooool0Uoooool00ol0003oooooooooo`04ooooo`Koi^KV@?ooool2o`0002_ooooo000T
ooooo`?o0000B_ooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo04Wooooo00?o0000
ooooooooool0B?ooool3o`0002gooooo000Wooooo`;o0000BOooool2o`0004Wooooo00?o0000oooo
ooooool0Aoooool2o`0004Wooooo0_l0000`ooooo`00:Oooool2o`0004Wooooo00?o0000oooooooo
ool0A_ooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo04Oooooo0_l0000booooo`00
:oooool3o`0004Oooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`03o`00
0?oooooooooo04Gooooo0ol0000dooooo`00;_ooool2o`0004Kooooo00?o0000ooooooooool0A?oo
ool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo04Cooooo0_l0000gooooo`00<?ooool3
o`0004Cooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`13ooooo`03o`000?oooooo
oooo04;ooooo0ol0000iooooo`00<oooool2o`0004?ooooo00?o0000ooooooooool0@_ooool00ol0
003oooooooooo`12ooooo`03o`000?oooooooooo047ooooo0_l0000looooo`00=Oooool2o`0004;o
oooo0_l00012ooooo`03o`000?oooooooooo043ooooo0_l00012ooooo`;o0000?_ooool003Oooooo
0ol00011ooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`0oooooo`?o0000@?ooool003[ooooo0_l00010ooooo`03o`000?oooooooooo03kooooo00?o
0000ooooooooool0?_ooool00ol0003oooooooooo`0nooooo`;o0000@oooool003cooooo0_l0000o
ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0m
ooooo`;o0000AOooool003kooooo0ol0000mooooo`03o`000?oooooooooo03cooooo00?o0000oooo
ooooool0??ooool00ol0003oooooooooo`0kooooo`?o0000Aoooool0047ooooo0_l0000looooo`;o
0000??ooool00ol0003oooooooooo`0jooooo`;o0000??ooool2o`0004[ooooo0013ooooo`?o0000
>oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0
>Oooool3o`0004cooooo0016ooooo`;o0000>_ooool00ol0003oooooooooo`0hooooo`03o`000?oo
oooooooo03Sooooo00?o0000ooooooooool0>?ooool2o`0004oooooo0018ooooo`;o0000>Oooool0
0ol0003oooooooooo`0gooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool2
o`00057ooooo001:ooooo`?o0000=oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo
03Kooooo00?o0000ooooooooool0=Oooool3o`0005?ooooo001=ooooo`;o0000=_ooool2o`0003Ko
oooo00?o0000ooooooooool0=?ooool2o`0003Kooooo0_l0001Fooooo`00Coooool3o`0003Gooooo
00?o0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03?ooooo
0ol0001Hooooo`00D_ooool2o`0003Cooooo00?o0000ooooooooool0<_ooool00ol0003ooooooooo
o`0booooo`03o`000?oooooooooo03;ooooo0_l0001Kooooo`00E?ooool2o`0003?ooooo00?o0000
ooooooooool0<Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo0_l0001M
ooooo`00E_ooool3o`00037ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`oooo
o`03o`000?oooooooooo02oooooo0ol0001Oooooo`00FOooool2o`00033ooooo0_l0000`ooooo`03
o`000?oooooooooo02kooooo0_l0000`ooooo`;o0000H_ooool005_ooooo0_l0000`ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`;o0000
I?ooool005gooooo0ol0000^ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0/ooooo`?o0000I_ooool0063ooooo0_l0000]ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`;o0000JOooool0
06;ooooo0ol0000[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0Yooooo`?o0000Joooool006Gooooo0_l0000Zooooo`;o0000:_ooool00ol0003o
ooooooooo`0Xooooo`;o0000:_ooool2o`0006kooooo001Wooooo`;o0000:_ooool00ol0003ooooo
ooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0:?ooool2o`00073ooooo
001Yooooo`?o0000:?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool09_ooool3o`0007;ooooo001/ooooo`;o00009oooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool2o`0007Gooooo001^oooo
o`?o00009Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool08oooool3o`0007Oooooo001aooooo`;o00009?ooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool08_ooool2o`0007[ooooo001cooooo`;o0000
8oooool2o`0002?ooooo00?o0000ooooooooool08Oooool2o`0002?ooooo0_l0001looooo`00MOoo
ool3o`0002;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo023ooooo0ol0001nooooo`00N?ooool2o`00027ooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo0_l00021ooooo`00N_ooool2o`00
023ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
01kooooo0_l00023ooooo`00O?ooool3o`0001kooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo01cooooo0ol00025ooooo`00Ooooool2o`0001gooooo
0_l0000Mooooo`03o`000?oooooooooo01_ooooo0_l0000Mooooo`;o0000R?ooool0087ooooo0ol0
000Looooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`?o0000R_ooool008Cooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`;o0000SOooool008Kooooo0_l0000Joooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hoooo
o`;o0000Soooool008Sooooo0ol0000Hooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0Fooooo`?o0000TOooool008_ooooo0_l0000Gooooo`;o0000
5oooool00ol0003oooooooooo`0Eooooo`;o00005oooool2o`0009Cooooo002=ooooo`?o00005_oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?oo
ool3o`0009Kooooo002@ooooo`;o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool04oooool2o`0009Wooooo002Booooo`;o00005?ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool2o`00
09_ooooo002Dooooo`?o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04?ooool3o`0009gooooo002Gooooo`;o00004Oooool2o`00017ooooo
00?o0000ooooooooool03oooool2o`00017ooooo0_l0002Pooooo`00VOooool2o`00017ooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0
002Rooooo`00Voooool3o`0000oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo0ol0002Tooooo`00W_ooool2o`0000kooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0_l0002Woooo
o`00X?ooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00[ooooo0ol0002Yooooo`00Xoooool2o`0000_ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo0_l0002/ooooo`00YOoo
ool2o`0000[ooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo0_l0000:ooooo`;o0000[_oo
ool00:Oooooo0ol00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`?o0000/?ooool00:[ooooo0_l00008ooooo`03o`000?oooooooooo
00?ooooo1_oVi^H6ooooo`03o`000?oooooooooo00Kooooo0_l0002cooooo`00[?ooool3o`0000Ko
oooo00?o0000ooooooooool02_oVi^H3ooooo`03o`000?oooooooooo00Cooooo0ol0002eooooo`00
[oooool2o`0000Gooooo00?o0000onKVi_oVi^H02_oVi^H00ooooooo0000ooooo`04ooooo`;o0000
^?ooool00;7ooooo0_l00003ooooo`koi^KV1?ooool2o`000;[ooooo002cooooo`;o00004?oVi^H3
o`000;cooooo002eoooooa3oi^KV_oooool00;Cooooo1_oVi^H6o`0000Koi^KV__ooool00;Cooooo
2?oVi^H2o`0000Soi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Cooooo2?oVi^H2
o`0000Soi^KV__ooool00;Cooooo1ooVi^H5o`0000Koi^KV__ooool00;Cooooo2?oVi^H2o`0000So
i^KV__ooool00;Gooooo2?oVi^H3o`0000Goi^KV_oooool00;Gooooo4?oVi^Joooooo`00]_ooool>
onKVi/3ooooo002gooooo`coi^KV`Oooool00;Sooooo2_oVi^K2ooooo`00^_ooool6onKVi/Cooooo
0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17784, -0.625483, \
0.011505, 0.00272017}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.80041 .01472 -5 -6 ]
[.80041 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.80041 .01472 Mdot
0 g
gsave
.80041 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00k_ooool5o`0003cooooo1Ol0000nooooo`Co0000
3_ooool00>gooooo0_l000000ooooooo0000o`00000nooooo`;o000000?oooooo`000?l00000??oo
ool2o`0000;ooooo0_l0000=ooooo`00k_ooool4o`0003kooooo0_l000000ooooooo0000o`000010
ooooo`;o00003Oooool00>gooooo0_l000000ooooooo0000o`00000nooooo`;o000000?oooooo`00
0?l00000@?ooool2o`0000gooooo003^ooooo`?o0000?oooool4o`0003gooooo1Ol0000>ooooo`00
oooooolaooooo`;o0000?oooool2o`00017ooooo003ooooooc3ooooo0ol0000oooooo`Ko00003Ooo
ool00?ooooooQOooool00?ooooooQOooool00?Kooooo00?o0000ooooooooool0MOooool00ol0003o
ooooooooo`0Cooooo`00moooool00ol0003oooooooooo`1cooooo`03o`000?oooooooooo01Cooooo
003hooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool00ol0003ooooooooo
o`0Eooooo`00nOooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Kooooo00?o0000
ooooooooool05_ooool00?Wooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0foooo
o`03o`000?oooooooooo01Kooooo003jooooo`03o`000?oooooooooo03Gooooo00?o0000oooooooo
ool0=Oooool00ol0003oooooooooo`0Gooooo`00noooool00ol0003oooooooooo`0dooooo`03o`00
0?oooooooooo03Cooooo00?o0000ooooooooool06?ooool00?cooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Wooooo003mooooo`03o`000?oooooo
oooo03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Jooooo`00o_ooool00ol0
003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06oooool00?oo
oooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo01co
oooo003oooooo`7ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`03o`00
0?oooooooooo01gooooo003oooooo`;ooooo00?o0000ooooooooool0;_ooool00ol0003ooooooooo
o`0^ooooo`03o`000?oooooooooo01kooooo003oooooo`?ooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01oooooo003oooooo`Cooooo00?o0000oooo
ooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo023ooooo003oooooo`Co
oooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo023o
oooo003oooooo`Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo027ooooo003oooooo`Kooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02;ooooo003oooooo`Oooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02?ooooo003oooooo`Sooooo00?o0000oooo
ooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Cooooo003oooooo`Wo
oooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Go
oooo003oooooo`[ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo02Kooooo003oooooo`_ooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo02Oooooo003oooooo`cooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Sooooo003oooooo`gooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Wooooo003oooooo`go
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Wo
oooo003oooooo`kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo02[ooooo003oooooo`oooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo02_ooooo003ooooooa3ooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo02cooooo003ooooooa7ooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo02gooooo003ooooooa;o
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02ko
oooo003ooooooa?ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo02oooooo003ooooooaCooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo033ooooo003ooooooaGooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo037ooooo003ooooooaKooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03;ooooo003ooooooaOo
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03?o
oooo003ooooooaOooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo03?ooooo003ooooooaSooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Cooooo003ooooooaWooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo03Gooooo003ooooooa[ooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Kooooo003ooooooa_o
oooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Oo
oooo003ooooooacooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo03Sooooo003ooooooagooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo03Wooooo003ooooooakooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[ooooo003ooooooaoooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03_ooooo003oooooob3o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03co
oooo003oooooob3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo03cooooo003oooooob7ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo03gooooo003oooooob;ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03kooooo003oooooob?ooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03oooooo003oooooobCo
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo043o
oooo003oooooobGooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo047ooooo003oooooobKooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo04;ooooo003oooooobOooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo04?ooooo003oooooobSooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04Cooooo003oooooobWo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04Go
oooo003oooooob[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo04Kooooo003oooooob[ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo04Kooooo003oooooob_ooooo00?o0000ooooooooool00_ooool6
onKViPGooooo00?o0000ooooooooool0Aoooool00?oooooo;?ooool00ol0003oooooonKViP09onKV
iP;ooooo00?o0000ooooooooool0B?ooool00?oooooo;Oooool<onKViP03o`000?oooooooooo04Wo
oooo003oooooobcooooo3_oVi^I;ooooo`00ooooool[ooooo`Koi^KV1?l00006onKViT[ooooo003o
ooooob_ooooo2OoVi^H2o`0000Goi^KVB_ooool004Gooooo1Ol0000hooooo`Co0000KOooool4o`00
03;ooooo1ooVi^H5o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo0000o`00000fooooo`;o
00000_ooool2o`0006_ooooo0_l0000eooooo`Koi^KV0_l00002onKViP;o00001_oVi^I9ooooo`00
A_ooool2o`000003ooooool0003o000003[ooooo0_l0001[ooooo`Ko0000<Oooool6onKViP;o0000
0_oVi^H2o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo0000o`00000hooooo`?o0000K?oo
ool2o`0000;ooooo0_l0000aooooo`Koi^KV0_l00002onKViP;o00001_oVi^I9ooooo`00A_ooool4
o`0003_ooooo0_l0001/ooooo`Co0000<_ooool7onKViPKo00001OoVi^I9ooooo`00A_ooool2o`00
03Wooooo0_l00002ooooo`;o0000X_oooolBonKViTWooooo0015ooooo`?o0000>_ooool4o`000:Co
oooo4?oVi^I:ooooo`00ooooool[oooooa3oi^KVB_ooool00?oooooo;?ooool>onKViT_ooooo003o
ooooobgooooo3?oVi^I<ooooo`00ooooool^ooooo`[oi^KVCOooool004_ooooo00?o0000oooooooo
ool0Zoooool00ol0003oooooooooo`0cooooo`Koi^KVCoooool004cooooo00?o0000ooooooooool0
<Oooool00ol0003oooooooooo`1fooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0
Doooool004cooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`1fooooo`03o`000?oo
oooooooo03;ooooo00?o0000ooooooooool0Doooool004gooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`1hooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0E?ooool0
04gooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1hooooo`03o`000?oooooooooo
033ooooo00?o0000ooooooooool0E?ooool004gooooo00?o0000ooooooooool0;oooool00ol0003o
ooooooooo`1iooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0E?ooool004kooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo02kooooo
00?o0000ooooooooool0EOooool004kooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`1jooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0EOooool004oooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool0E_ooool004oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1loooo
o`03o`000?oooooooooo02cooooo00?o0000ooooooooool0E_ooool0053ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool0Eoooool0053ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1nooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool0Eoooool0053ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`1oooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Eooo
ool0057ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`20ooooo`03o`000?oooooo
oooo02Sooooo00?o0000ooooooooool0F?ooool0057ooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`20ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0F?ooool005;o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool0FOooool005;ooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`22ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0FOooool005;ooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0FOooool005?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`24
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0F_ooool005?ooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool0F_ooool005Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`26ooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0Foooool005Cooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
Foooool005Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`27ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool0Foooool005Gooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`28ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0G?ooool0
05Gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool0G?ooool005Kooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`2:ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0GOooool005Kooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool0GOooool005Kooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`2;ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0GOooool005Oooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool0G_ooool005Oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2=oooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0G_ooool005Sooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`2>ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool0Goooool005Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2?ooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool0Goooool005Sooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Gooo
ool005Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`2@ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0H?ooool005Wooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`2Aooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0H?ooool005[o
oooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`2Booooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0HOooool005[ooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`2Cooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0HOooool005[ooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0HOooool005_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0H_ooool005_ooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0H_ooool005cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`2Fooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0Hoooool005cooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
Hoooool005cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`2Gooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0Hoooool005gooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0I?ooool0
05gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0I?ooool005kooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`2Jooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0IOooool005kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0IOooool005oooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`2Looooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0I_ooool005oooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0I_ooool005oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Moooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0I_ooool0063ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0Ioooool0063ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Oooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0Ioooool0067ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0J?oo
ool0067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Qooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0J?ooool0067ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`2Qooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?ooool006;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0JOooool006;ooooo00?o0000onKVi_oVi^H01?oVi^H00ooooooo0000
ooooo`2Tooooo`03o`000?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool0J_ooool0067ooooo2_oV
i^JTooooo`[oi^KVJoooool0063ooooo3?oVi^JRooooo`coi^KVJ_ooool005oooooo3_oVi^JPoooo
o`koi^KVJOooool005kooooo4?oVi^JNoooooa3oi^KVJ?ooool005kooooo1_oVi^H4o`0000Koi^KV
W_ooool@onKViVSooooo001Mooooo`[oi^KV0_l00006onKViYcooooo4_oVi^IWooooo`003Oooool5
o`0004_ooooo1ooVi^H5o`0000Koi^KVC?ooool4o`0004cooooo1_oVi^H7o`0000Goi^KVBoooool6
o`0001Kooooo000<ooooo`;o000000?oooooo`000?l00000C?ooool6onKViP;o00000_oVi^H2o`00
00Koi^KVBoooool2o`0000;ooooo0_l0001;ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKV
iTcooooo0_l000000ooooooo0000o`00000Fooooo`003Oooool4o`0004cooooo1_oVi^H2o`0000;o
i^KV0_l00006onKViT_ooooo0_l0001?ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViTgo
oooo0_l0000Hooooo`003?ooool2o`000003ooooool0003o000004cooooo1_oVi^H2o`0000;oi^KV
0_l00006onKViT_ooooo0_l00002ooooo`;o0000Boooool7onKViP;o000000?oi^KVo`000?l00000
1_oVi^I>ooooo`;o00005oooool000gooooo0ol0001=ooooo`Ooi^KV1_l00005onKViTcooooo1?l0
001<ooooo`Ooi^KV1?l00007onKViT_ooooo0_l00002ooooo`;o00005_ooool001Oooooo00?o0000
ooooooooool0A?ooool@onKViYkooooo1_oVi^H2o`0000Soi^KVC?ooool2o`0000;ooooo0_l0000F
ooooo`006?ooool3o`0004?ooooo4?oVi^JNooooo`Goi^KV0ol00008onKViTCooooo0ol00006oooo
o`Co00005oooool001_ooooo0_l00012ooooo`koi^KV00?o0000ooooooooool0WOooool>onKViT?o
oooo0_l0000Tooooo`007Oooool2o`00047ooooo3?oVi^H2ooooo`03o`000?oooooooooo09_ooooo
00?o0000oooooooVi^H02ooVi^I2ooooo`;o00009_ooool001oooooo0ol0000oooooo`[oi^KV1?oo
ool00ol0003oooooooooo`2Iooooo`04o`000?ooooooooooooooo`[oi^KV@?ooool3o`0002Sooooo
000Rooooo`;o0000?oooool6onKViPOooooo00?o0000ooooooooool0Uoooool00ol0003ooooooooo
o`04ooooo`Koi^KV@?ooool2o`0002_ooooo000Tooooo`?o0000B_ooool00ol0003oooooooooo`19
ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool0B?ooool3o`0002gooooo000Woooo
o`;o0000BOooool2o`0004Wooooo00?o0000ooooooooool0Aoooool2o`0004Wooooo0_l0000`oooo
o`00:Oooool2o`0004Wooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`16ooooo`03
o`000?oooooooooo04Oooooo0_l0000booooo`00:oooool3o`0004Oooooo00?o0000ooooooooool0
AOooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo0ol0000dooooo`00;_oo
ool2o`0004Kooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`14ooooo`03o`000?oo
oooooooo04Cooooo0_l0000gooooo`00<?ooool3o`0004Cooooo00?o0000ooooooooool0@oooool0
0ol0003oooooooooo`13ooooo`03o`000?oooooooooo04;ooooo0ol0000iooooo`00<oooool2o`00
04?ooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo
047ooooo0_l0000looooo`00=Oooool2o`0004;ooooo0_l00012ooooo`03o`000?oooooooooo043o
oooo0_l00012ooooo`;o0000?_ooool003Oooooo0ol00011ooooo`03o`000?oooooooooo03oooooo
00?o0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`?o0000@?ooool003[ooooo0_l0
0010ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0?_ooool00ol0003ooooooooo
o`0nooooo`;o0000@oooool003cooooo0_l0000oooooo`03o`000?oooooooooo03gooooo00?o0000
ooooooooool0?Oooool00ol0003oooooooooo`0mooooo`;o0000AOooool003kooooo0ol0000moooo
o`03o`000?oooooooooo03cooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`0koooo
o`?o0000Aoooool0047ooooo0_l0000looooo`;o0000??ooool00ol0003oooooooooo`0jooooo`;o
0000??ooool2o`0004[ooooo0013ooooo`?o0000>oooool00ol0003oooooooooo`0iooooo`03o`00
0?oooooooooo03Wooooo00?o0000ooooooooool0>Oooool3o`0004cooooo0016ooooo`;o0000>_oo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?oo
ool2o`0004oooooo0018ooooo`;o0000>Oooool00ol0003oooooooooo`0gooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool0=oooool2o`00057ooooo001:ooooo`?o0000=oooool00ol0
003oooooooooo`0fooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0=Oooool3o`00
05?ooooo001=ooooo`;o0000=_ooool2o`0003Kooooo00?o0000ooooooooool0=?ooool2o`0003Ko
oooo0_l0001Fooooo`00Coooool3o`0003Gooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo03?ooooo0ol0001Hooooo`00D_ooool2o`0003Cooooo00?o
0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo0_l0
001Kooooo`00E?ooool2o`0003?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0a
ooooo`03o`000?oooooooooo037ooooo0_l0001Mooooo`00E_ooool3o`00037ooooo00?o0000oooo
ooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02oooooo0ol0001Ooooo
o`00FOooool2o`00033ooooo0_l0000`ooooo`03o`000?oooooooooo02kooooo0_l0000`ooooo`;o
0000H_ooool005_ooooo0_l0000`ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0^ooooo`;o0000I?ooool005gooooo0ol0000^ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`?o0000I_oo
ool0063ooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0[ooooo`;o0000JOooool006;ooooo0ol0000[ooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Yooooo`?o0000Joooool006Go
oooo0_l0000Zooooo`;o0000:_ooool00ol0003oooooooooo`0Xooooo`;o0000:_ooool2o`0006ko
oooo001Wooooo`;o0000:_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool0:?ooool2o`00073ooooo001Yooooo`?o0000:?ooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09_ooool3o`0007;ooooo001/
ooooo`;o00009oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool09Oooool2o`0007Gooooo001^ooooo`?o00009Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo02Cooooo00?o0000ooooooooool08oooool3o`0007Oooooo001aooooo`;o
00009?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool08_ooool2o`0007[ooooo001cooooo`;o00008oooool2o`0002?ooooo00?o0000ooooooooool0
8Oooool2o`0002?ooooo0_l0001looooo`00MOooool3o`0002;ooooo00?o0000ooooooooool08?oo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0001nooooo`00N?ooool2
o`00027ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo01oooooo0_l00021ooooo`00N_ooool2o`00023ooooo00?o0000ooooooooool07_ooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo0_l00023ooooo`00O?ooool3o`0001ko
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01co
oooo0ol00025ooooo`00Ooooool2o`0001gooooo0_l0000Mooooo`03o`000?oooooooooo01_ooooo
0_l0000Mooooo`;o0000R?ooool0087ooooo0ol0000Looooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`?o0000R_ooool008Cooooo0_l0000K
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0I
ooooo`;o0000SOooool008Kooooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0Hooooo`;o0000Soooool008Sooooo0ol0000Hooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Fooooo`?o
0000TOooool008_ooooo0_l0000Gooooo`;o00005oooool00ol0003oooooooooo`0Eooooo`;o0000
5oooool2o`0009Cooooo002=ooooo`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oo
oooooooo01Cooooo00?o0000ooooooooool05?ooool3o`0009Kooooo002@ooooo`;o00005Oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool2
o`0009Wooooo002Booooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool2o`0009_ooooo002Dooooo`?o00004_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool3o`0009go
oooo002Gooooo`;o00004Oooool2o`00017ooooo00?o0000ooooooooool03oooool2o`00017ooooo
0_l0002Pooooo`00VOooool2o`00017ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00oooooo0_l0002Rooooo`00Voooool3o`0000oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo0ol0002T
ooooo`00W_ooool2o`0000kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00cooooo0_l0002Wooooo`00X?ooool3o`0000cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo0ol0002Yooooo`00
Xoooool2o`0000_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo0_l0002/ooooo`00YOooool2o`0000[ooooo0_l0000:ooooo`03o`000?oo
oooooooo00Sooooo0_l0000:ooooo`;o0000[_ooool00:Oooooo0ol00009ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`?o0000/?ooool0
0:[ooooo0_l00008ooooo`03o`000?oooooooooo00?ooooo1_oVi^H6ooooo`03o`000?oooooooooo
00Kooooo0_l0002cooooo`00[?ooool3o`0000Kooooo00?o0000ooooooooool02_oVi^H3ooooo`03
o`000?oooooooooo00Cooooo0ol0002eooooo`00[oooool2o`0000Gooooo00?o0000onKVi_oVi^H0
2_oVi^H00ooooooo0000ooooo`04ooooo`;o0000^?ooool00;7ooooo0_l00003ooooo`koi^KV1?oo
ool2o`000;[ooooo002cooooo`;o00004?oVi^H3o`000;cooooo002eoooooa3oi^KV_oooool00;Co
oooo1_oVi^H6o`0000Koi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Cooooo2?oV
i^H2o`0000Soi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Cooooo1ooVi^H5o`00
00Koi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Gooooo2?oVi^H3o`0000Goi^KV
_oooool00;Gooooo4?oVi^Joooooo`00]_ooool>onKVi/3ooooo002gooooo`coi^KV`Oooool00;So
oooo2_oVi^K2ooooo`00^_ooool6onKVi/Cooooo0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17784, -0.625483, \
0.011505, 0.00272017}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.15406 .30902 -5 -6 ]
[.15406 .30902 5 6 ]
[.29323 .30902 -5 -6 ]
[.29323 .30902 5 6 ]
[.22364 .45617 -5 -6 ]
[.22364 .45617 5 6 ]
[.42348 .45617 -5 -6 ]
[.42348 .45617 5 6 ]
[.55373 .30902 -5 -6 ]
[.55373 .30902 5 6 ]
[.54145 .16187 -5 -6 ]
[.54145 .16187 5 6 ]
[.71251 .01472 -5 -6 ]
[.71251 .01472 5 6 ]
[.84435 .01472 -5 -6 ]
[.84435 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.84435 .16187 -5 -6 ]
[.84435 .16187 5 6 ]
[.6929 .30902 -5 -6 ]
[.6929 .30902 5 6 ]
[.62332 .45617 -5 -6 ]
[.62332 .45617 5 6 ]
[.82315 .45617 -5 -6 ]
[.82315 .45617 5 6 ]
[.42348 .60332 -5 -6 ]
[.42348 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
gsave
.15406 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.29323 .30902 Mdot
0 g
gsave
.29323 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.22364 .45617 Mdot
0 g
gsave
.22364 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.42348 .45617 Mdot
0 g
gsave
.42348 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
gsave
.55373 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
gsave
.54145 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.84435 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
gsave
.71251 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.84435 .01472 Mdot
0 g
gsave
.84435 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.84435 .16187 Mdot
0 g
gsave
.84435 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.6929 .30902 Mdot
0 g
gsave
.6929 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.62332 .45617 Mdot
0 g
gsave
.62332 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.82315 .45617 Mdot
0 g
gsave
.82315 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.42348 .60332 Mdot
0 g
gsave
.42348 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00ooooool?ooooo`Go0000;Oooool4o`0002kooooo
1?l0000>ooooo`00ooooool@ooooo`;o000000?oooooo`000?l00000;Oooool2o`0002kooooo0_l0
0002ooooo`;o00003Oooool00?oooooo4?ooool2o`000003ooooool0003o000002gooooo0_l0000^
ooooo`;o00004Oooool00?oooooo4?ooool2o`000003ooooool0003o000002gooooo0_l0000^oooo
o`;o00000_ooool2o`0000gooooo003ooooooa3ooooo1?l0000^ooooo`;o0000;oooool4o`0000ko
oooo003ooooooa3ooooo0_l0000_ooooo`?o0000@Oooool00?oooooo3oooool3o`00033ooooo0_l0
0011ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooolHooooo`03o`000?oooooooooo05Co
oooo00?o0000ooooooooool04oooool00?oooooo6Oooool00ol0003oooooooooo`1Booooo`03o`00
0?oooooooooo01Cooooo003ooooooa[ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo01Gooooo003ooooooa[ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01Kooooo003ooooooa_ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Oooooo003ooooooaco
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Oo
oooo003ooooooagooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Tooooo`03o`00
0?oooooooooo01Sooooo003ooooooakooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0Sooooo`03o`000?oooooooooo01Wooooo003ooooooaoooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01[ooooo003oooooob3ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01_ooooo003oooooob7o
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01co
oooo003oooooob;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01gooooo003oooooob;ooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo01kooooo003oooooob?ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01oooooo003oooooobCooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo023ooooo003oooooobGo
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo027o
oooo003oooooobKooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo027ooooo003oooooobOooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo02;ooooo003oooooobSooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02?ooooo003oooooobWooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo02Cooooo003oooooob[o
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Go
oooo003oooooob_ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo02Kooooo003oooooob_ooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo02Oooooo003oooooobcooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo02Sooooo003oooooobgooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02Wooooo003oooooobko
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo02[o
oooo003ooooooboooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo02_ooooo003ooooooc3ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo02_ooooo003ooooooc7ooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo02cooooo003ooooooc;ooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02gooooo003ooooooc?o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo02ko
oooo003ooooooc?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo02oooooo003oooooocCooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo033ooooo003oooooocGooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo037ooooo003oooooocKooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo03;ooooo003oooooocOo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03?o
oooo003oooooocSooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo03Cooooo003oooooocWooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo03Gooooo003ooooooc[ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Gooooo003ooooooc_ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03Kooooo003ooooooc_o
oooo00?o0000ooooooooool00oooool6onKViPCooooo00?o0000ooooooooool0=oooool00?oooooo
??ooool00ol0003oooooooooo`0:onKViP03ooooool0003ooooo03Wooooo003oooooocgooooo00?o
0000onKVi_oVi^H02_oVi^Hkooooo`00oooooolmooooo`koi^KV>_ooool00?oooooo??ooool5onKV
iPCo00001ooVi^Hiooooo`00oooooollooooo`Soi^KV0_l00006onKViSWooooo003?ooooo`Co0000
Ioooool6onKViPGo00001ooVi^Hhooooo`00c_ooool2o`0000;ooooo0_l0001Vooooo`Goi^KV0_l0
0002onKViP;o00001ooVi^Hhooooo`00c_ooool2o`0006[ooooo1OoVi^H2o`0000;oi^KV0_l00007
onKViSSooooo003>ooooo`;o00000_ooool2o`0006Kooooo1OoVi^H2o`0000;oi^KV0_l00007onKV
iSSooooo003?ooooo`Co0000Ioooool6onKViPKo00001_oVi^Hhooooo`00oooooolkoooooa;oi^KV
>?ooool00?oooooo??ooool@onKViSWooooo003ooooooccooooo4?oVi^Hiooooo`00f?ooool00ol0
003oooooooooo`1Pooooo`03o`000?oVi^Koi^KV00coi^KV>_ooool00=Wooooo00?o0000oooooooo
ool0G_ooool00ol0003oooooooooo`0<onKViS_ooooo003Jooooo`03o`000?oooooooooo05cooooo
00?o0000ooooooooool00_ooool:onKViScooooo003Kooooo`03o`000?oooooooooo05[ooooo00?o
0000ooooooooool01Oooool6onKViSkooooo003Looooo`03o`000?oooooooooo05Sooooo00?o0000
ooooooooool0B_ooool00=gooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`1;oooo
o`00g_ooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo04cooooo003Oooooo`03o`00
0?oooooooooo05;ooooo00?o0000ooooooooool0COooool00>3ooooo00?o0000ooooooooool0D?oo
ool00ol0003oooooooooo`1>ooooo`00hOooool00ol0003oooooooooo`1>ooooo`03o`000?oooooo
oooo04oooooo003Rooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0D?ooool00>?o
oooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`1Aooooo`00i?ooool00ol0003ooooo
ooooo`18ooooo`03o`000?oooooooooo05;ooooo003Uooooo`03o`000?oooooooooo04Kooooo00?o
0000ooooooooool0Doooool00>Kooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`1D
ooooo`00ioooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo05Gooooo003Xooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool0E_ooool00>Wooooo00?o0000ooooooooool0
?_ooool00ol0003oooooooooo`1Gooooo`00j_ooool00ol0003oooooooooo`0looooo`03o`000?oo
oooooooo05Sooooo003[ooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0FOooool0
0>cooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`1Jooooo`00kOooool2o`0003Oo
oooo00?o0000ooooooooool0Foooool00>oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`1Looooo`00l?ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo05gooooo003a
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0G_ooool00?;ooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`1Oooooo`00loooool00ol0003oooooooooo`0[ooooo`03
o`000?oooooooooo063ooooo003dooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
HOooool00?Gooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`1Rooooo`00m_ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo06?ooooo003gooooo`03o`000?oooooooooo
02?ooooo00?o0000ooooooooool0I?ooool00?Sooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`1Uooooo`00nOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo06Kooooo
003jooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Ioooool00?_ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`1Xooooo`00o?ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo06Wooooo003mooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0J_ooool00?kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1[ooooo`00oooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo06cooooo003oooooo`7ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`1]ooooo`00ooooool2ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0K_ooool00?oooooo0oooool00ol0003oooooooooo`02ooooo`Ko
i^KV1Oooool00ol0003oooooooooo`1_ooooo`00ooooool4ooooo`03o`000?ooooooi^KV00Woi^KV
0_ooool00ol0003oooooooooo`1`ooooo`00ooooool5ooooo`coi^KV00?o0000ooooooooool0LOoo
ool00?oooooo1?ooool>onKViW?ooooo003oooooo`?ooooo1_oVi^H4o`0000Koi^KVL_ooool00?oo
oooo0oooool9onKViP;o00001OoVi^Ibooooo`00?Oooool5o`00033ooooo1?l0001Nooooo`Co0000
:Oooool7onKViPGo00001_oVi^Iaooooo`00?_ooool2o`000003ooooool0003o000002kooooo0_l0
0002ooooo`;o0000G?ooool2o`0002cooooo1_oVi^H2o`0000;oi^KV0_l00006onKViW7ooooo000n
ooooo`;o000000?oooooo`000?l00000<_ooool2o`0005cooooo1_l0000Xooooo`Koi^KV0_l00002
onKViP;o00001_oVi^Iaooooo`00?_ooool2o`000003ooooool0003o0000033ooooo0ol0001Moooo
o`;o00000_ooool2o`0002Sooooo1_oVi^H2o`0000;oi^KV0_l00006onKViW7ooooo000nooooo`Co
0000<oooool2o`0005gooooo1?l0000Yooooo`Ooi^KV1_l00005onKViW7ooooo000nooooo`;o0000
<Oooool2o`0000;ooooo0_l0002:oooooa;oi^KVLOooool003gooooo0ol0000booooo`Co0000S?oo
ool@onKViW;ooooo003oooooo`?ooooo4?oVi^Ibooooo`00ooooool4ooooo`koi^KVLoooool00?oo
oooo1Oooool<onKViWCooooo003oooooo`Kooooo2_oVi^Ieooooo`00A?ooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0:Oooool00ol0003oi^KVonKV
iP04onKViWOooooo0014ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Ioooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo07_ooooo0015ooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0JOooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
07cooooo0015ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0JOooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo07cooooo0016ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo07gooooo
0016ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0Joooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo07gooooo0017ooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool0KOooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo07kooooo0017oooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0KOooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo07kooooo0018ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0Koooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo07oooooo0018ooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0Koooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo07oooooo0019ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0LOoo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo083ooooo0019ooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool0LOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo083ooooo001:ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Loooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo087ooooo001:ooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo087o
oooo001;ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0MOooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo08;ooooo001;ooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool0MOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo08;ooooo001<
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Moooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo08?ooooo001<ooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool0Moooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo08?ooooo001=ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo08Cooooo001=ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
NOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo08Cooooo001=ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo08Cooooo001>ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo08Gooooo001>ooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
08Gooooo001?ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0OOooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo08Kooooo001?ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0OOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo08Kooooo
001@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Ooooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo08Oooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool0Ooooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo08Oooooo001Aoooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo08Sooooo001Aooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool0POooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo08Sooooo001Booooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo08Wooooo001Booooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Pooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo08Wooooo001Cooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo08[ooooo001Cooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0QOooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo08[ooooo001Dooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo08_o
oooo001Dooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Qoooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo08_ooooo001Eooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0ROooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo08cooooo001E
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo08cooooo001Fooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0Roooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo08gooooo001Fooooo`03
o`000?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool0S?ooool00ol0003oi^KVonKViP04onKViP03
ooooool0003ooooo08kooooo001Eooooo`[oi^KVS?ooool:onKViXoooooo001Dooooo`coi^KVR_oo
ool<onKViXkooooo001Cooooo`koi^KVR?ooool>onKViXgooooo001Booooo`Koi^KV1?l00006onKV
iXKooooo4?oVi^J<ooooo`00D_ooool9onKViP;o00001OoVi^J6oooooa3oi^KVS?ooool000gooooo
1Ol0000oooooo`Ooi^KV1Ol00006onKViT3ooooo1?l00010ooooo`Koi^KV1ol00005onKViSoooooo
1_l00016ooooo`003?ooool2o`000003ooooool0003o0000043ooooo1_oVi^H2o`0000;oi^KV0_l0
0006onKViSoooooo0_l00002ooooo`;o0000?oooool7onKViP;o000000?oi^KVo`000?l000001_oV
i^I0ooooo`;o000000?oooooo`000?l00000A_ooool000gooooo1?l00010ooooo`Koi^KV0_l00002
onKViP;o00001_oVi^Hoooooo`;o0000@oooool7onKViP;o000000?oi^KVo`000?l000001_oVi^I1
ooooo`;o0000B?ooool000cooooo0_l000000ooooooo0000o`000010ooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^Hoooooo`;o00000_ooool2o`0003oooooo1ooVi^H2o`000003onKVi_l0003o0000
00Koi^KV@_ooool2o`0004Oooooo000=ooooo`?o0000@Oooool7onKViPKo00001OoVi^I0ooooo`Co
0000@?ooool7onKViPCo00001ooVi^Hoooooo`;o00000_ooool2o`0004Kooooo000Hooooo`;o0000
=ooooolBonKViXCooooo1ooVi^H2o`0000Woi^KV>?ooool00ol0003oooooooooo`04ooooo`;o0000
0_ooool2o`0004Kooooo000Jooooo`;o0000=_ooool@onKViXKooooo1OoVi^H3o`0000Soi^KV=ooo
ool2o`0000Sooooo1?l00017ooooo`007?ooool3o`0003?ooooo4?oVi^H00ol0003oooooooooo`23
oooooa3oi^KV=?ooool3o`0005Gooooo000Oooooo`?o0000<Oooool>onKViP;ooooo00?o0000oooo
ooooool0POooool00ol0003oooooonKViP0=onKViS;ooooo0ol0001Hooooo`008_ooool2o`00033o
oooo3?oVi^H4ooooo`03o`000?oooooooooo07oooooo00Co0000oooooooooooooooo3?oVi^Haoooo
o`;o0000Foooool002Cooooo0ol0000^ooooo`[oi^KV1_ooool2o`0007gooooo0_l00005ooooo`[o
i^KV;oooool3o`0005gooooo000Wooooo`?o0000;Oooool6onKViP[ooooo00?o0000ooooooooool0
NOooool00ol0003oooooooooo`07ooooo`Koi^KV;_ooool3o`00063ooooo000Zooooo`?o0000>ooo
ool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0>Ooo
ool3o`0006?ooooo000]ooooo`;o0000>_ooool2o`0003[ooooo00?o0000ooooooooool0>?ooool2
o`0003[ooooo0_l0001Vooooo`00;oooool3o`0003Wooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`0gooooo`03o`000?oooooooooo03Oooooo0ol0001Xooooo`00<_ooool3o`0003Oo
oooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Go
oooo0ol0001[ooooo`00=Oooool3o`0003Gooooo0_l0000fooooo`03o`000?oooooooooo03Cooooo
0_l0000eooooo`?o0000K_ooool003Sooooo0_l0000eooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`;o0000LOooool003[ooooo0ol0000c
ooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`;o0000<oooool3o`0007?ooooo000moooo
o`?o0000<_ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o0000oooo
ooooool0<?ooool3o`0007Kooooo0010ooooo`;o0000<Oooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool2o`0007Wooooo0012ooooo`?o0000
;oooool2o`0002oooooo00?o0000ooooooooool0;Oooool2o`0002oooooo0ol0001kooooo`00AOoo
ool3o`0002kooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02cooooo0ol0001nooooo`00B?ooool3o`0002cooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo0ol00021ooooo`00Boooool2o`00
02_ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo0_l0000[ooooo`;o0000Q?ooool004go
oooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003o
ooooooooo`0Xooooo`?o0000Q_ooool0053ooooo0ol0000Xooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`0Vooooo`?o0000ROooool005?ooooo0ol0
000Vooooo`;o00009oooool00ol0003oooooooooo`0Uooooo`;o00009_ooool3o`0008cooooo001F
ooooo`;o00009_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool09?ooool2o`0008oooooo001Hooooo`?o00009?ooool2o`0002Cooooo00?o0000oooo
ooooool08_ooool2o`0002Cooooo0ol0002Aooooo`00Foooool3o`0002?ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo0ol0002Dooooo`00
G_ooool2o`0002;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo023ooooo0_l0002Gooooo`00H?ooool3o`00023ooooo0_l0000Pooooo`03o`000?oo
oooooooo01kooooo0_l0000Pooooo`?o0000VOooool006?ooooo0ol0000Oooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`?o0000W?ooool0
06Kooooo0ol0000Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Kooooo`?o0000Woooool006Wooooo0_l0000Looooo`;o00007?ooool00ol0003o
ooooooooo`0Jooooo`;o00007?ooool2o`000:;ooooo001[ooooo`?o00006oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool3o`000:Cooooo
001^ooooo`?o00006Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool05oooool3o`000:Oooooo001aooooo`?o00005oooool2o`0001Sooooo00?o0000
ooooooooool05_ooool2o`0001Oooooo0ol0002Zooooo`00M?ooool2o`0001Oooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo0_l0002]oooo
o`00M_ooool3o`0001Gooooo0_l0000Eooooo`03o`000?oooooooooo01?ooooo0_l0000Eooooo`?o
0000[oooool007Wooooo0ol0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`?o0000/_ooool007cooooo0_l0000Cooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000]Ooo
ool007kooooo0ol0000Aooooo`;o00004Oooool00ol0003oooooooooo`0?ooooo`;o00004Oooool3
o`000;Oooooo0021ooooo`?o00004?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool03_ooool3o`000;[ooooo0024ooooo`?o00003_ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool3o`000;go
oooo0027ooooo`;o00003Oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo
0_l00030ooooo`00ROooool3o`0000cooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00[ooooo0ol00032ooooo`00S?ooool3o`0000[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0ol00035
ooooo`00Soooool3o`0000Sooooo0_l00006ooooo`Koi^KV1oooool2o`0000Sooooo0ol00038oooo
o`00T_ooool2o`0000Sooooo00Co0000oooooooooooooooo2_oVi^H4ooooo`03o`000?oooooooooo
00Kooooo0_l0003;ooooo`00U?ooool3o`0000Kooooo0_l0000<onKViP03ooooool0003o000000Ko
oooo0ol0003=ooooo`00Uoooool3o`0000Cooooo3_oVi^H5ooooo`?o0000d?ooool009[ooooo0_l0
00000oooooooi^KVonKViP0>onKViP;ooooo0_l0003Cooooo`00W?ooool00ol0003oi^KVonKViP0>
onKViP;o0000eOooool009cooooo1_oVi^H6o`0000Koi^KVe_ooool009cooooo2?oVi^H2o`0000So
i^KVe_ooool009cooooo2?oVi^H2o`0000Soi^KVe_ooool009cooooo2?oVi^H2o`0000Soi^KVe_oo
ool009cooooo1ooVi^H5o`0000Koi^KVe_ooool009cooooo2?oVi^H2o`0000Soi^KVe_ooool009go
oooo2?oVi^H3o`0000Goi^KVeoooool009gooooo4?oVi^KGooooo`00W_ooool>onKVi]Sooooo002O
ooooo`coi^KVfOooool00:3ooooo2_oVi^KJooooo`00X_ooool6onKVi]cooooo0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.20642, -0.833976, \
0.0133535, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00k_ooool5o`0007kooooo1Ol0000>ooooo`00kOoo
ool2o`000003ooooool0003o0000083ooooo0_l000000ooooooo0000o`00000=ooooo`00k_ooool4
o`00083ooooo0_l000000ooooooo0000o`00000=ooooo`00kOooool2o`000003ooooool0003o0000
083ooooo0_l000000ooooooo0000o`00000=ooooo`00k_ooool3o`00087ooooo1?l0000>ooooo`00
oooooomcooooo`;o00004?ooool00?ooooooL_ooool3o`00013ooooo003oooooohGooooo003ooooo
ohGooooo003fooooo`03o`000?oooooooooo07Gooooo00?o0000ooooooooool04oooool00?Oooooo
00?o0000ooooooooool0Loooool00ol0003oooooooooo`0Dooooo`00n?ooool00ol0003ooooooooo
o`1aooooo`03o`000?oooooooooo01Gooooo003iooooo`03o`000?oooooooooo06oooooo00?o0000
ooooooooool05_ooool00?Wooooo00?o0000ooooooooool0Koooool00ol0003oooooooooo`0Foooo
o`00n_ooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo01Oooooo003kooooo`03o`00
0?oooooooooo06_ooooo00?o0000ooooooooool06?ooool00?cooooo00?o0000ooooooooool0JOoo
ool00ol0003oooooooooo`0Iooooo`00oOooool00ol0003oooooooooo`1Wooooo`03o`000?oooooo
oooo01[ooooo003nooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool06oooool00?oo
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`0Looooo`00ooooool1ooooo`03o`00
0?oooooooooo067ooooo00?o0000ooooooooool07Oooool00?oooooo0_ooool00ol0003ooooooooo
o`1Oooooo`03o`000?oooooooooo01kooooo003oooooo`?ooooo00?o0000ooooooooool0GOooool0
0ol0003oooooooooo`0Oooooo`00ooooool4ooooo`03o`000?oooooooooo05_ooooo00?o0000oooo
ooooool08?ooool00?oooooo1?ooool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo023o
oooo003oooooo`Gooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0Qooooo`00oooo
ool6ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool08_ooool00?oooooo1oooool0
0ol0003oooooooooo`1Eooooo`03o`000?oooooooooo02?ooooo003oooooo`Sooooo00?o0000oooo
ooooool0Doooool00ol0003oooooooooo`0Tooooo`00ooooool9ooooo`03o`000?oooooooooo057o
oooo00?o0000ooooooooool09Oooool00?oooooo2_ooool00ol0003oooooooooo`1?ooooo`03o`00
0?oooooooooo02Kooooo003oooooo`_ooooo00?o0000ooooooooool0COooool00ol0003ooooooooo
o`0Wooooo`00ooooool<ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0:?ooool0
0?oooooo3Oooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo02Wooooo003oooooo`go
oooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0Yooooo`00ooooool>ooooo`03o`00
0?oooooooooo04Oooooo00?o0000ooooooooool0:_ooool00?oooooo3oooool00ol0003ooooooooo
o`15ooooo`03o`000?oooooooooo02_ooooo003ooooooa3ooooo00?o0000ooooooooool0@oooool0
0ol0003oooooooooo`0/ooooo`00oooooolAooooo`03o`000?oooooooooo047ooooo00?o0000oooo
ooooool0;Oooool00?oooooo4_ooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo02ko
oooo003ooooooa?ooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0_ooooo`00oooo
oolDooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0<?ooool00?oooooo5Oooool0
0ol0003oooooooooo`0iooooo`03o`000?oooooooooo037ooooo003ooooooaKooooo00?o0000oooo
ooooool0=oooool00ol0003oooooooooo`0booooo`00oooooolGooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool0<oooool00?oooooo5oooool00ol0003oooooooooo`0eooooo`03o`00
0?oooooooooo03?ooooo003ooooooaSooooo00?o0000ooooooooool0<oooool00ol0003ooooooooo
o`0dooooo`00oooooolIooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0=Oooool0
0?oooooo6_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo03Kooooo003ooooooa_o
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0gooooo`00oooooolLooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool0>?ooool00?oooooo7Oooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo03Wooooo003ooooooakooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`0jooooo`00oooooolOooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0>oooool00?oooooo8?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03co
oooo003oooooob3ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0looooo`00oooo
oolQooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0?Oooool00?oooooo8_ooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo03kooooo003oooooob?ooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0oooooo`00oooooolTooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool0@?ooool00?oooooo9Oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo047ooooo003oooooobKooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`12ooooo`00oooooolWooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0@oooool0
0?oooooo:?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04Cooooo003oooooobWo
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`15ooooo`00oooooolZooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool0A_ooool00?oooooo:_ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo04Kooooo003oooooob_ooooo00?o0000ooooooooool00_ooool6
onKViPGooooo00?o0000ooooooooool0Aoooool00?oooooo;?ooool00ol0003oooooonKViP09onKV
iP;ooooo00?o0000ooooooooool0B?ooool00?oooooo;Oooool<onKViP03o`000?oooooooooo04Wo
oooo003oooooobcooooo3_oVi^I;ooooo`00ooooool[ooooo`Koi^KV1?l00006onKViT[ooooo003o
ooooob_ooooo2OoVi^H2o`0000Goi^KVB_ooool004Gooooo1Ol0000hooooo`Co0000K_ooool4o`00
037ooooo1ooVi^H5o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo0000o`00000fooooo`;o
00000_ooool2o`0006kooooo0_l0000booooo`Koi^KV0_l00002onKViP;o00001_oVi^I9ooooo`00
A_ooool2o`000003ooooool0003o000003[ooooo0_l0001[ooooo`Ko0000<Oooool6onKViP;o0000
0_oVi^H2o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo0000o`00000hooooo`?o0000K?oo
ool2o`000003ooooool0003o000003;ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViTWooooo0016
ooooo`Co0000>oooool2o`0006cooooo1?l0000booooo`Ooi^KV1_l00005onKViTWooooo0016oooo
o`;o0000>Oooool2o`0000;ooooo0_l0001]ooooo`?o0000<_oooolBonKViTWooooo0015ooooo`?o
0000>_ooool4o`0006oooooo0_l0000coooooa3oi^KVB_ooool00?oooooo:oooool@onKViT[ooooo
003oooooobcooooo3_oVi^I;ooooo`00ooooool]ooooo`coi^KVC?ooool00?oooooo;_ooool:onKV
iTgooooo001;ooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0<oooool6onKViToo
oooo001<ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0M_ooool00ol0003ooooo
ooooo`0booooo`03o`000?oooooooooo05?ooooo001<ooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool0M_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo05?ooooo001=
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0N?ooool00ol0003oooooooooo`0`
ooooo`03o`000?oooooooooo05Cooooo001=ooooo`03o`000?oooooooooo02oooooo00?o0000oooo
ooooool0N?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo05Cooooo001=ooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`0_ooooo`03
o`000?oooooooooo05Cooooo001>ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
N_ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo05Gooooo001>ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0N_ooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo05Gooooo001?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0O?ooool0
0ol0003oooooooooo`0/ooooo`03o`000?oooooooooo05Kooooo001?ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool0O?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo
05Kooooo001@ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0O_ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo05Oooooo001@ooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0O_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05Oooooo
001@ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Ooooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo05Oooooo001Aooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool0P?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo05Sooooo001Aoooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0P?ooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo05Sooooo001Booooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0P_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo05Wooooo001Booooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0P_ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo05Wooooo001Booooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0Pooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05Wooooo001Cooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0Q?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo05[ooooo001Cooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0QOooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo05[ooooo001Dooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool0Q_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo05_o
oooo001Dooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0Q_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo05_ooooo001Dooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool0Qoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo05_ooooo001E
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0R?ooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo05cooooo001Eooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool0ROooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo05cooooo001Fooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool0R_ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo05gooooo001Fooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
R_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo05gooooo001Fooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo05gooooo001Gooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0S?ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo05kooooo001Gooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
05kooooo001Hooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0S_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo05oooooo001Hooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05oooooo
001Hooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Soooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo05oooooo001Iooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0T?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo063ooooo001Ioooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo063ooooo001Jooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool0T_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo067ooooo001Jooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`0Eooooo`03o`00
0?oooooooooo067ooooo001Jooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0Tooo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo067ooooo001Kooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool0U?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo06;ooooo001Kooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0UOooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo06;ooooo001Looooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0U_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo06?o
oooo001Looooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Uoooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo06?ooooo001Looooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0Uoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo06?ooooo001M
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo06Cooooo001Mooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0VOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo06Cooooo001Nooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo06Gooooo001Nooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
Voooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06Gooooo001Oooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo06Kooooo001Oooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0WOooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo06Kooooo001Oooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
06Kooooo001Pooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Woooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo06Oooooo001Pooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0Woooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Oooooo
001Qooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0X?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo06Sooooo001Qooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0XOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06Sooooo001Qoooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo06Sooooo001Rooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0Xoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06Wooooo001Rooooo`03o`00
0?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool0Y?ooool00ol0003oi^KVonKViP04onKViP03oooo
ool0003ooooo06[ooooo001Qooooo`[oi^KVY?ooool:onKViV_ooooo001Pooooo`coi^KVX_ooool<
onKViV[ooooo001Oooooo`koi^KVX?ooool>onKViVWooooo001Noooooa3oi^KVW_ooool@onKViVSo
oooo001Nooooo`Koi^KV1?l00006onKViYkooooo4?oVi^IXooooo`00GOooool:onKViP;o00001_oV
i^JLoooooa;oi^KVIoooool000gooooo1Ol0001;ooooo`Ooi^KV1Ol00006onKViTcooooo1?l0001<
ooooo`Koi^KV1ol00005onKViT_ooooo1_l0000Fooooo`003?ooool2o`000003ooooool0003o0000
04cooooo1_oVi^H2o`0000;oi^KV0_l00006onKViT_ooooo0_l00002ooooo`;o0000Boooool7onKV
iP;o000000?oi^KVo`000?l000001_oVi^I<ooooo`;o000000?oooooo`000?l000005_ooool000go
oooo1?l0001<ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I;ooooo`;o0000Coooool7onKViP;o
000000?oi^KVo`000?l000001_oVi^I=ooooo`;o00006?ooool000cooooo0_l000000ooooooo0000
o`00001<ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I;ooooo`;o00000_ooool2o`0004_ooooo
1ooVi^H2o`000003onKVi_l0003o000000Koi^KVC_ooool2o`0001Oooooo000=ooooo`?o0000COoo
ool7onKViPKo00001OoVi^I<ooooo`Co0000C?ooool7onKViPCo00001ooVi^I;ooooo`;o00000_oo
ool2o`0001Kooooo000Gooooo`03o`000?oooooooooo04Cooooo4?oVi^JNooooo`Koi^KV0_l00008
onKViTcooooo0_l00002ooooo`;o00005_ooool001Sooooo0ol00013oooooa3oi^KVW_ooool5onKV
iP?o00002?oVi^I4ooooo`?o00001_ooool4o`0001Oooooo000Kooooo`;o0000@_ooool>onKViP03
o`000?oooooooooo09gooooo3_oVi^I3ooooo`;o00009?ooool001gooooo0_l00011ooooo`coi^KV
0_ooool00ol0003oooooooooo`2Kooooo`03o`000?ooooooi^KV00_oi^KV@_ooool2o`0002Kooooo
000Oooooo`?o0000?oooool:onKViPCooooo00?o0000ooooooooool0VOooool01?l0003ooooooooo
ooooool:onKViT3ooooo0ol0000Xooooo`008_ooool2o`0003oooooo1_oVi^H7ooooo`03o`000?oo
oooooooo09Oooooo00?o0000ooooooooool01?ooool6onKViT3ooooo0_l0000[ooooo`009?ooool3
o`0004[ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`19ooooo`03o`000?oooooo
oooo04Sooooo0ol0000]ooooo`009oooool2o`0004Wooooo0_l00019ooooo`03o`000?oooooooooo
04Oooooo0_l00019ooooo`;o0000<?ooool002Wooooo0_l00019ooooo`03o`000?oooooooooo04Ko
oooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`17ooooo`;o0000<_ooool002_ooooo
0ol00017ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0AOooool00ol0003ooooo
ooooo`15ooooo`?o0000=?ooool002kooooo0_l00016ooooo`03o`000?oooooooooo04Cooooo00?o
0000ooooooooool0A?ooool00ol0003oooooooooo`14ooooo`;o0000=oooool0033ooooo0ol00014
ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`12
ooooo`?o0000>Oooool003?ooooo0_l00013ooooo`03o`000?oooooooooo04;ooooo00?o0000oooo
ooooool0@_ooool00ol0003oooooooooo`11ooooo`;o0000??ooool003Gooooo0_l00012ooooo`;o
0000@_ooool00ol0003oooooooooo`10ooooo`;o0000@_ooool2o`0003kooooo000gooooo`?o0000
@Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool0
?oooool3o`00043ooooo000jooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`03o`000?oo
oooooooo03kooooo00?o0000ooooooooool0?_ooool2o`0004?ooooo000looooo`;o0000?oooool0
0ol0003oooooooooo`0mooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0?Oooool2
o`0004Gooooo000nooooo`?o0000?Oooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo
03cooooo00?o0000ooooooooool0>oooool3o`0004Oooooo0011ooooo`;o0000??ooool2o`0003co
oooo00?o0000ooooooooool0>_ooool2o`0003cooooo0_l0001:ooooo`00@oooool3o`0003_ooooo
00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo03Wooooo
0ol0001<ooooo`00A_ooool2o`0003[ooooo00?o0000ooooooooool0>?ooool00ol0003ooooooooo
o`0hooooo`03o`000?oooooooooo03Sooooo0_l0001?ooooo`00B?ooool2o`0003Wooooo00?o0000
ooooooooool0=oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo03Oooooo0_l0001A
ooooo`00B_ooool3o`0003Oooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0foooo
o`03o`000?oooooooooo03Gooooo0ol0001Cooooo`00COooool2o`0003Kooooo0_l0000fooooo`03
o`000?oooooooooo03Cooooo0_l0000fooooo`;o0000E_ooool004oooooo0ol0000eooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`?o0000
F?ooool005;ooooo0_l0000dooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_oo
ool00ol0003oooooooooo`0booooo`;o0000Foooool005Cooooo0_l0000cooooo`03o`000?oooooo
oooo037ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0aooooo`;o0000GOooool0
05Kooooo0ol0000aooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0<?ooool00ol0
003oooooooooo`0_ooooo`?o0000Goooool005Wooooo0_l0000`ooooo`;o0000<?ooool00ol0003o
ooooooooo`0^ooooo`;o0000<?ooool2o`0006;ooooo001Kooooo`;o0000<?ooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;_ooool2o`0006Cooooo
001Mooooo`?o0000;_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool0;?ooool3o`0006Kooooo001Pooooo`;o0000;Oooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool2o`0006Wooooo001Roooo
o`?o0000:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool0:Oooool3o`0006_ooooo001Uooooo`;o0000:_ooool2o`0002[ooooo00?o0000oooooooo
ool0:?ooool2o`0002[ooooo0_l0001^ooooo`00Ioooool2o`0002[ooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Sooooo0_l0001`ooooo`00JOoo
ool3o`0002Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo02Kooooo0ol0001booooo`00K?ooool2o`0002Oooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo0_l0001eooooo`00K_ooool3o`00
02Gooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02?ooooo0ol0001gooooo`00LOooool2o`0002Cooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0_l0001jooooo`00Loooool2o`0002?ooooo
0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Sooooo`;o0000O?ooool007Gooooo0ol0
000Rooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Pooooo`?o0000O_ooool007Sooooo0_l0000Qooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Oooooo`;o0000POooool007[ooooo0_l0000Poooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Noooo
o`;o0000Poooool007cooooo0ol0000Nooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0Looooo`?o0000QOooool007oooooo0_l0000Mooooo`;o0000
7Oooool00ol0003oooooooooo`0Kooooo`;o00007Oooool2o`0008Sooooo0021ooooo`?o00007?oo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_oo
ool3o`0008[ooooo0024ooooo`;o00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06Oooool2o`0008gooooo0026ooooo`;o00006_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool2o`00
08oooooo0028ooooo`?o00006?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool05_ooool3o`00097ooooo002;ooooo`;o00005oooool2o`0001Oooooo
00?o0000ooooooooool05Oooool2o`0001Oooooo0_l0002Dooooo`00SOooool3o`0001Kooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo0ol0
002Fooooo`00T?ooool2o`0001Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo01?ooooo0_l0002Iooooo`00T_ooool2o`0001Cooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo0_l0002Koooo
o`00U?ooool3o`0001;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo013ooooo0ol0002Mooooo`00Uoooool2o`00017ooooo0_l0000Aooooo`03o`00
0?oooooooooo00oooooo0_l0000Aooooo`;o0000X?ooool009Wooooo0_l0000Aooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`;o0000X_oo
ool009_ooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`?o0000Y?ooool009kooooo0_l0000>ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`;o0000Yoooool00:3o
oooo0ol0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0:ooooo`?o0000ZOooool00:?ooooo0_l0000;ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`;o0000[?ooool00:Gooooo0_l0
000:ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`;o00002_ooool2o`000:kooooo002W
ooooo`?o00002Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool3o`000;3ooooo002Zooooo`;o00002?ooool00ol0003oooooooooo`03oooo
o`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`;o0000/oooool00:cooooo0ol00006ooooo`03
o`000?oooooooooo00[oi^KV0oooool00ol0003oooooooooo`04ooooo`?o0000]Oooool00:oooooo
0_l00005ooooo`03o`000?oVi^Koi^KV00[oi^KV00?oooooo`000?ooool01?ooool2o`000;Sooooo
002aooooo`;o00000oooool>onKViPCooooo0_l0002jooooo`00/oooool2o`00013oi^KV0ol0002l
ooooo`00]Oooool@onKVi[oooooo002dooooo`Koi^KV1_l00006onKVi[kooooo002dooooo`Soi^KV
0_l00008onKVi[kooooo002dooooo`Soi^KV0_l00008onKVi[kooooo002dooooo`Soi^KV0_l00008
onKVi[kooooo002dooooo`Ooi^KV1Ol00006onKVi[kooooo002dooooo`Soi^KV0_l00008onKVi[ko
oooo002eooooo`Soi^KV0ol00005onKVi[oooooo002eoooooa3oi^KV_oooool00;Kooooo3_oVi^K0
ooooo`00]oooool<onKVi/7ooooo002hooooo`[oi^KV`_ooool00;[ooooo1_oVi^K4ooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17784, -0.625483, \
0.011505, 0.00272017}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.364398 0.170294 0.603319 0.420431 [
[.02381 .51923 -5 -6 ]
[.02381 .51923 5 6 ]
[.1348 .43515 -5 -6 ]
[.1348 .43515 5 6 ]
[.2534 .43515 -5 -6 ]
[.2534 .43515 5 6 ]
[.1941 .51923 -5 -6 ]
[.1941 .51923 5 6 ]
[.3644 .51923 -5 -6 ]
[.3644 .51923 5 6 ]
[.47539 .43515 -5 -6 ]
[.47539 .43515 5 6 ]
[.46493 .35106 -5 -6 ]
[.46493 .35106 5 6 ]
[.6107 .26697 -5 -6 ]
[.6107 .26697 5 6 ]
[.72305 .26697 -5 -6 ]
[.72305 .26697 5 6 ]
[.7702 .18289 -5 -6 ]
[.7702 .18289 5 6 ]
[.76874 .0988 -5 -6 ]
[.76874 .0988 5 6 ]
[.83686 .0988 -5 -6 ]
[.83686 .0988 5 6 ]
[.8028 .18289 -5 -6 ]
[.8028 .18289 5 6 ]
[.80135 .0988 -5 -6 ]
[.80135 .0988 5 6 ]
[.79534 .01472 -5 -6 ]
[.79534 .01472 5 6 ]
[.86946 .01472 -5 -6 ]
[.86946 .01472 5 6 ]
[.94359 .01472 -5 -6 ]
[.94359 .01472 5 6 ]
[.86946 .0988 -5 -6 ]
[.86946 .0988 5 6 ]
[.8354 .18289 -5 -6 ]
[.8354 .18289 5 6 ]
[.83395 .0988 -5 -6 ]
[.83395 .0988 5 6 ]
[.82794 .01472 -5 -6 ]
[.82794 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.90207 .0988 -5 -6 ]
[.90207 .0988 5 6 ]
[.86801 .18289 -5 -6 ]
[.86801 .18289 5 6 ]
[.90061 .18289 -5 -6 ]
[.90061 .18289 5 6 ]
[.8354 .26697 -5 -6 ]
[.8354 .26697 5 6 ]
[.72305 .35106 -5 -6 ]
[.72305 .35106 5 6 ]
[.59399 .43515 -5 -6 ]
[.59399 .43515 5 6 ]
[.53469 .51923 -5 -6 ]
[.53469 .51923 5 6 ]
[.70499 .51923 -5 -6 ]
[.70499 .51923 5 6 ]
[.3644 .60332 -5 -6 ]
[.3644 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.3644 .60332 m
.02381 .51923 L
s
.3644 .60332 m
.1941 .51923 L
s
.3644 .60332 m
.3644 .51923 L
s
.3644 .60332 m
.53469 .51923 L
s
.3644 .60332 m
.70499 .51923 L
s
1 g
.05 w
.02381 .51923 Mdot
0 g
gsave
.02381 .51923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.1941 .51923 m
.1348 .43515 L
s
.1941 .51923 m
.2534 .43515 L
s
1 g
.05 w
.1348 .43515 Mdot
0 g
gsave
.1348 .43515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.2534 .43515 Mdot
0 g
gsave
.2534 .43515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.1941 .51923 Mdot
0 g
gsave
.1941 .51923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.3644 .51923 Mdot
0 g
gsave
.3644 .51923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.53469 .51923 m
.47539 .43515 L
s
.53469 .51923 m
.59399 .43515 L
s
1 g
.05 w
.47539 .43515 Mdot
0 g
gsave
.47539 .43515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.59399 .43515 m
.46493 .35106 L
s
.59399 .43515 m
.72305 .35106 L
s
1 g
.05 w
.46493 .35106 Mdot
0 g
gsave
.46493 .35106 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.72305 .35106 m
.6107 .26697 L
s
.72305 .35106 m
.72305 .26697 L
s
.72305 .35106 m
.8354 .26697 L
s
1 g
.05 w
.6107 .26697 Mdot
0 g
gsave
.6107 .26697 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.72305 .26697 Mdot
0 g
gsave
.72305 .26697 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.8354 .26697 m
.7702 .18289 L
s
.8354 .26697 m
.8028 .18289 L
s
.8354 .26697 m
.8354 .18289 L
s
.8354 .26697 m
.86801 .18289 L
s
.8354 .26697 m
.90061 .18289 L
s
1 g
.05 w
.7702 .18289 Mdot
0 g
gsave
.7702 .18289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.8028 .18289 m
.76874 .0988 L
s
.8028 .18289 m
.83686 .0988 L
s
1 g
.05 w
.76874 .0988 Mdot
0 g
gsave
.76874 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.83686 .0988 Mdot
0 g
gsave
.83686 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.8028 .18289 Mdot
0 g
gsave
.8028 .18289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.8354 .18289 m
.80135 .0988 L
s
.8354 .18289 m
.86946 .0988 L
s
1 g
.05 w
.80135 .0988 Mdot
0 g
gsave
.80135 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.86946 .0988 m
.79534 .01472 L
s
.86946 .0988 m
.86946 .01472 L
s
.86946 .0988 m
.94359 .01472 L
s
1 g
.05 w
.79534 .01472 Mdot
0 g
gsave
.79534 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86946 .01472 Mdot
0 g
gsave
.86946 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.94359 .01472 Mdot
0 g
gsave
.94359 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.86946 .0988 Mdot
0 g
gsave
.86946 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.8354 .18289 Mdot
0 g
gsave
.8354 .18289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.86801 .18289 m
.83395 .0988 L
s
.86801 .18289 m
.90207 .0988 L
s
1 g
.05 w
.83395 .0988 Mdot
0 g
gsave
.83395 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.90207 .0988 m
.82794 .01472 L
s
.90207 .0988 m
.97619 .01472 L
s
1 g
.05 w
.82794 .01472 Mdot
0 g
gsave
.82794 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.9 g
.90207 .0988 Mdot
0 g
gsave
.90207 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.86801 .18289 Mdot
0 g
gsave
.86801 .18289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.90061 .18289 Mdot
0 g
gsave
.90061 .18289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.9 g
.8354 .26697 Mdot
0 g
gsave
.8354 .26697 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
.9 g
.72305 .35106 Mdot
0 g
gsave
.72305 .35106 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.59399 .43515 Mdot
0 g
gsave
.59399 .43515 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.53469 .51923 Mdot
0 g
gsave
.53469 .51923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.70499 .51923 Mdot
0 g
gsave
.70499 .51923 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.3644 .60332 Mdot
0 g
gsave
.3644 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00ooooool^ooooo`Go00002?ooool4o`0000_ooooo
1Ol0000Hooooo`Co00002?ooool4o`0000kooooo003ooooooboooooo0_l000000ooooooo0000o`00
0006ooooo`;o00000_ooool2o`0000_ooooo0_l000000ooooooo0000o`00000Fooooo`;o00000_oo
ool2o`0000Sooooo0_l0000?ooooo`00ooooool_ooooo`;o000000?oooooo`000?l000001_ooool2
o`0000oooooo0_l000000ooooooo0000o`00000Fooooo`;o00003?ooool2o`0000oooooo003ooooo
oboooooo0_l000000ooooooo0000o`000006ooooo`;o00000_ooool2o`0000_ooooo0_l000000ooo
oooo0000o`00000Fooooo`;o00000_ooool2o`0000Sooooo0_l0000?ooooo`00ooooool_ooooo`Co
00002?ooool4o`0000cooooo1?l0000Hooooo`Co00002Oooool2o`0000oooooo003ooooooboooooo
0_l0000Jooooo`;o00009_ooool3o`0000oooooo003oooooobkooooo0ol0000Iooooo`?o00009ooo
ool2o`0000oooooo003oooooohGooooo003oooooohGooooo003oooooocOooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool04oooool00?oooooo>?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Dooooo`00ooooooliooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool05Oooool00?oooooo>_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo01Kooooo003ooooooc[ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0Fooooo`00oooooolkooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool05oooool00?oooooo??ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Sooooo
003oooooocgooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000oooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Iooooo`00oooooolnooooo`03o`000?oo
oooooooo00Wooooo00Co0000oooooooooooo00003_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo01[ooooo003oooooocoooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00
000=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool06oooool00?oooooo@?ooool0
0ol0003oooooooooo`09ooooo`;o00003?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo01cooooo003ooooood7ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool07Oooool00?oooooo@_ooool00ol0003o
ooooooooo`08ooooo`;o00002Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01ko
oooo003ooooood?ooooo00?o0000ooooooooool01oooool00ol0003oooooo`000007ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool07oooool00?ooooooA?ooool00ol0003ooooooooo
o`06ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Pooooo`00oooooom4ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo023ooooo003oooooodGooooo00?o
0000ooooooooool00_ooool6onKViP03ooooool0003ooooo00;ooooo00?o0000onKVi_oVi^H01?oV
i^H5ooooo`03o`000?oooooooooo027ooooo003oooooodKooooo00?o0000oooooooVi^H02OoVi^H0
0ol0003oooooonKViP09onKViP;ooooo00?o0000ooooooooool08_ooool00?ooooooAooooolHonKV
iP03o`000?oooooooooo02?ooooo003oooooodOooooo6OoVi^HUooooo`00oooooom8ooooo`?oi^KV
1?l00008onKViPCo00001_oVi^HTooooo`00oooooom8ooooo`Koi^KV0_l0000:onKViP;o00001OoV
i^HTooooo`00oooooolUooooo`Co00001oooool5o`0000Wooooo1?l00007ooooo`;oi^KV1Ol00007
onKViPGo00001_oVi^HSooooo`00oooooolTooooo`;o00000_ooool2o`0000Oooooo0_l000000ooo
oooo0000o`000007ooooo`;o00002_ooool00ooVi^Ko0000o`000002onKViP;o00001_oVi^H2o`00
00;oi^KV0_l00006onKViR?ooooo003oooooobCooooo0_l0000;ooooo`;o000000?oooooo`000?l0
00001oooool6o`0000Kooooo00?oi^KVo`000?l000000_oVi^H2o`0000Koi^KV0_l00002onKViP;o
00001_oVi^HSooooo`00oooooolTooooo`;o00000_ooool2o`0000Oooooo0_l000000ooooooo0000
o`000007ooooo`;o00000_ooool2o`0000Kooooo00?oi^KVo`000?l000000_oVi^H2o`0000Koi^KV
0_l00002onKViP;o00001_oVi^HSooooo`00oooooolUooooo`Co00002?ooool4o`0000Wooooo1?l0
0007ooooo`;oi^KV1Ol00007onKViPKo00001OoVi^HSooooo`00oooooolaooooo`;o00005_oooolI
onKViR?ooooo003ooooooc3ooooo0ol0000EoooooaWoi^KV9?ooool00?ooooooB?oooolIonKViRCo
oooo003oooooodOooooo6OoVi^HUooooo`00oooooom7oooooaSoi^KV9_ooool00?ooooooB?ooool:
onKViP;ooooo2_oVi^HWooooo`00oooooolZooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool01?ooool6onKViPKooooo1_oVi^HYooooo`00ooooool[ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0]ooooo`00ooooool[ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0]ooooo`00oooo
ool/ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`000007ooooo`05o`00
0?ooooooooooooooool000002oooool00ol0003oooooooooo`0^ooooo`00ooooool/ooooo`03o`00
0?oooooooooo00Wooooo00Go0000ooooooooooooooooo`000008ooooo`04o`000?ooooooooooo`00
00_ooooo00?o0000ooooooooool0;_ooool00?oooooo;?ooool00ol0003oooooooooo`09ooooo`05
o`000?ooooooooooooooool000002?ooool01?l0003oooooooooool0000;ooooo`03o`000?oooooo
oooo02kooooo003oooooobgooooo00?o0000ooooooooool02Oooool00ol0003oooooo`000009oooo
o`03o`000?oooooo000000_ooooo00?o0000ooooooooool0;oooool00?oooooo;Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooo000000[ooooo0_l0000;ooooo`03o`000?oooooooooo02oo
oooo003oooooobkooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0<?ooool00?oooooo;_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`03o`000?oooooooooo033ooooo003o
oooooboooooo00?o0000ooooooooool01oooool00ol0003oooooo`000009ooooo`03o`000?oooooo
000000Wooooo00?o0000ooooooooool0<Oooool00?oooooo;oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooo000000Wooooo00?o0000ooooool000002Oooool00ol0003oooooooooo`0aoooo
o`00ooooool_ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000002Oooool01?l0003o
ooooooooool00008ooooo`03o`000?oooooooooo037ooooo003ooooooc3ooooo00?o0000oooooooo
ool01Oooool01Ol0003ooooooooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo03;ooooo003ooooooc3ooooo00?o0000onKVi_oVi^H01?oVi^H00ooo
oooo0000ooooo`02ooooo`03o`000?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool00_ooool00ol0
003oooooonKViP05onKViP03o`000?oooooooooo03;ooooo003ooooooboooooo2_oVi^H2ooooo`[o
i^KV0oooool:onKViS?ooooo003oooooobkooooo6?oVi^H00oooooooi^KVonKViP0:onKViS;ooooo
003oooooobgooooo9OoVi^Hcooooo`00ooooool/ooooobGoi^KV=?ooool00?oooooo;?ooool6onKV
iPCo00002?oVi^H4o`0000ooi^KV=?ooool00?oooooo:oooool:onKViP;o00002_oVi^H2o`0000go
i^KV=Oooool00?oooooo9Oooool5o`000003oooooooVi^Koi^KV00Goi^KV1Ol00007onKViPGo0000
1_oVi^H7o`0000Oooooo1?l0000Zooooo`00oooooolVooooo`;o000000?oooooo`000?l000001_oV
i^H2o`0000;oi^KV0_l00006onKViP;o00000_oVi^H2o`0000Ooi^KV0_l000001?oVi^Ko0000o`00
0?oVi^H8ooooo`;o0000:oooool00?oooooo9_ooool2o`000003ooooool0003o000000Koi^KV0_l0
0002onKViP;o00001_oVi^H2o`0000;oi^KV0_l00007onKViP;o000000Coi^KVo`000?l0003oi^KV
2?ooool2o`0002_ooooo003oooooobKooooo0_l000000ooooooo0000o`000006onKViP;o00000_oV
i^H2o`0000Koi^KV0_l00002onKViP;o00001ooVi^H2o`000004onKVi_l0003o0000onKViPSooooo
0_l0000[ooooo`00oooooolVooooo`Co000000?oooooonKVi_oVi^H01OoVi^H5o`0000Ooi^KV1_l0
0006onKViPCo00000_oVi^H8ooooo`;o0000:oooool00?oooooo9_ooool2o`0000Cooooo7_oVi^H2
o`0000Goi^KV1_ooool3o`0002_ooooo003oooooobGooooo0ol00004oooooagoi^KV0ol00005onKV
iPOooooo0_l0000[ooooo`00ooooool]ooooobGoi^KV<oooool00?oooooo;_oooolHonKViP03oooo
oooVi^Koi^KV00[oi^KV<_ooool00?oooooo;Oooool00ol0003oooooonKViP09onKViP;ooooo2_oV
i^H3ooooo`[oi^KV<oooool00?oooooo;_ooool00ol0003oooooooooo`06onKViP03o`000?oooooo
oooo00?ooooo1_oVi^H6ooooo`03o`000?oVi^Koi^KV00Coi^KV0oooool00ol0003oooooooooo`0_
ooooo`00ooooool_ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0<?ooool00?oo
oooo;oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo037ooooo003ooooooc3ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aooooo`00oooooolaooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0<_ooool00?oooooo<_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo03?ooooo003ooooooc;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0dooooo`00oooooolcooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0=Oooool00?oooooo=?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Kooooo
003oooooocGooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0fooooo`00oooooolf
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=oooool00?oooooo=_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo03Sooooo003oooooocOooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0iooooo`00oooooolhooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0>_ooool00?oooooo>Oooool01?l0
003oooooooooool00003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooooooo
o`0jooooo`00ooooooliooooo`04o`000?ooooooooooooooo`Koi^KV00Go0000oooooooooooooooo
o`00000mooooo`00ooooooljooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool0?Ooo
ool00?oooooo>_ooool<onKViSoooooo003oooooocWooooo3_oVi^Hnooooo`00oooooolhoooooa3o
i^KV?Oooool00?oooooo>?ooool@onKViSgooooo003Yooooo`Go00009Oooool4o`0001oooooo1_oV
i^H6o`0000Koi^KV??ooool00>Sooooo0_l000000ooooooo0000o`00000Uooooo`;o00000_ooool2
o`0001kooooo2?oVi^H2o`0000Soi^KV??ooool00>Wooooo1?l0000Uooooo`;o00008_ooool8onKV
iP;o00002?oVi^Hlooooo`00j?ooool2o`000003ooooool0003o000002Gooooo0_l00002ooooo`;o
00007_ooool8onKViP;o00002?oVi^Hlooooo`00jOooool3o`0002Oooooo1?l0000Oooooo`Ooi^KV
1Ol00006onKViScooooo003oooooocOooooo2?oVi^H2o`0000Soi^KV??ooool00?oooooo>?ooool8
onKViP?o00001OoVi^Hmooooo`00oooooolhoooooa3oi^KV?Oooool00??ooooo0_l00011ooooo`;o
00003_oVi^Hnooooo`00mOooool00ol0003oooooooooo`0mooooo`04o`000?ooooooooooooooo`co
i^KV?oooool00?Kooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`03ooooo`[oi^KV
@?ooool00?Oooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`06ooooo`Koi^KV@_oo
ool00?Sooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0001Aooooo`00n_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0DOooool00?_o
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo05;o
oooo003looooo`;o00005oooool00ol0003oooooooooo`0Eooooo`;o0000EOooool00?kooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo05Gooooo003o
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1F
ooooo`00ooooool1ooooo`;o00004oooool00ol0003oooooooooo`0Aooooo`;o0000FOooool00?oo
oooo0oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool0FOooool00?oooooo1?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool0F_ooool00?oooooo1Oooool2o`0000oooooo00?o0000ooooooooool03Ooo
ool2o`0005gooooo003oooooo`Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo05gooooo003oooooo`Sooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo05kooooo003oooooo`Wooooo0_l0000;ooooo`03
o`000?oooooooooo00Wooooo0_l0001Qooooo`00ooooool;ooooo`03o`000?oooooooooo00Gooooo
1_oVi^H8ooooo`03o`000?oooooooooo067ooooo003oooooo`cooooo00?o0000ooooooooool00_oo
ool:onKViPGooooo00?o0000ooooooooool0H_ooool00?oooooo3Oooool00ol0003oooooooooo`0<
onKViP?ooooo00?o0000ooooooooool0Hoooool00?oooooo3_ooool00ol0003oi^KVonKViP0<onKV
iP;o0000I_ooool00?oooooo3_ooool@onKViVOooooo003oooooo`kooooo1_oVi^H4o`0000Koi^KV
Ioooool00?oooooo3Oooool:onKViP;o00001_oVi^IVooooo`00/_ooool4o`0005Kooooo1ooVi^H5
o`0000Koi^KVI_ooool00;7ooooo0_l00002ooooo`;o0000EOooool6onKViP;o00000_oVi^H2o`00
00Koi^KVI_ooool00;7ooooo0_l0001Iooooo`Koi^KV0_l00002onKViP;o00001_oVi^IVooooo`00
/Oooool2o`0000;ooooo0_l0001Eooooo`Koi^KV0_l00002onKViP;o00001_oVi^IVooooo`00/_oo
ool4o`0005Kooooo1ooVi^H6o`0000Goi^KVI_ooool00?oooooo3_ooool@onKViVOooooo003ooooo
o`kooooo4?oVi^IWooooo`00_?ooool2o`0004kooooo0_l0000>onKViVSooooo002nooooo`03o`00
0?oooooooooo04[ooooo00Co0000oooooooooooooooo3?oVi^IYooooo`00_oooool2o`0004Sooooo
0_l00005ooooo`[oi^KVJ_ooool00<7ooooo00?o0000ooooooooool0A?ooool00ol0003ooooooooo
o`07ooooo`Koi^KVK?ooool00<;ooooo0_l00012ooooo`;o0000O?ooool00<Cooooo0_l0000ooooo
o`03o`000?oooooooooo07cooooo0036ooooo`03o`000?oooooooooo03[ooooo0_l0001oooooo`00
aoooool2o`0003Wooooo00?o0000ooooooooool0Ooooool00<Wooooo00?o0000ooooooooool0=?oo
ool2o`0008;ooooo003:ooooo`;o0000<oooool00ol0003oooooooooo`22ooooo`00c?ooool2o`00
02oooooo0_l00025ooooo`00c_ooool00ol0003oooooooooo`0Zooooo`;o0000Qoooool00<oooooo
0_l0000Yooooo`03o`000?oooooooooo08Oooooo003Aooooo`03o`000?oooooooooo02Cooooo0_l0
002:ooooo`00d_ooool2o`0002?ooooo00?o0000ooooooooool0R_ooool00=Cooooo00?o0000oooo
ooooool07_ooool2o`0008gooooo003Eooooo`;o00007Oooool00ol0003oooooooooo`2=ooooo`00
eoooool2o`0001Wooooo0_l0002@ooooo`00fOooool00ol0003oooooooooo`06ooooo`Koi^KV2Ooo
ool00ol0003oooooooooo`2@ooooo`00f_ooool2o`0000Cooooo2_oVi^H5ooooo`;o0000Toooool0
0=cooooo00?o0000ooooooooool03?oVi^H3ooooo`03o`000?oooooooooo09?ooooo003Mooooo`03
o`000?oVi^Koi^KV00coi^KV0_l0002Fooooo`00gOooool6onKViPCo00001_oVi^JGooooo`00gOoo
ool9onKViP;o00001OoVi^JGooooo`00=_ooool5o`0002Sooooo1?l0001?ooooo`Co00008_ooool7
onKViPGo00001_oVi^JFooooo`00=oooool2o`000003ooooool0003o000002Kooooo0_l00002oooo
o`;o0000COooool2o`0002Gooooo1_oVi^H2o`0000;oi^KV0_l00006onKViYKooooo000gooooo`;o
000000?oooooo`000?l00000:_ooool2o`0004gooooo1_l0000Qooooo`Koi^KV0_l00002onKViP;o
00001_oVi^JFooooo`00=oooool2o`000003ooooool0003o000002Sooooo0ol0001>ooooo`;o0000
0_ooool2o`00027ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViYKooooo000gooooo`Co0000:ooo
ool2o`0004kooooo1?l0000Rooooo`Ooi^KV1_l00005onKViYKooooo000gooooo`;o0000:Oooool2
o`0000;ooooo0_l0001doooooa;oi^KVU_ooool003Kooooo0ol0000Zooooo`Co0000M_ooool@onKV
iYOooooo003Moooooa3oi^KVUoooool00=kooooo3_oVi^JHooooo`00goooool<onKViYWooooo000n
ooooo`03o`000?oooooooooo07cooooo00?o0000ooooooooool08?ooool:onKViY[ooooo000ooooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool0G?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00Koi^KVW?ooool0043ooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`1Nooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0Xoooool0043ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0Y?ooool0047ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`1Pooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Y?ooool004;ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0YOooool004;ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`1Roooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Y_ooool004?ooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`1Tooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0Y_ooool004Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Vooooo`03o`00
0?oooooooooo01Cooooo00?o0000ooooooooool0Yoooool004Cooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Z?oo
ool004Gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Xooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0ZOooool004Kooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`1Zooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0ZOooool004Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1Zooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool0Z_ooool004Oooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`1/ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Zoooool004Sooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`1^ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool0Zoooool004Sooooo00Co0000oooooooooooooooo1_oVi^H4ooooo`03o`000?oo
oooooooo06kooooo00?o0000ooooooooool00_ooool6onKViP?ooooo00?o0000ooooooooool0[?oo
ool004Wooooo00?o0000onKVi_oVi^H02?oVi^H00ooooooo0000ooooo`1aooooo`03o`000?oooooo
i^KV00Woi^KV00?o0000ooooooooool0[Oooool004Wooooo3?oVi^Idooooo`coi^KV[oooool004So
oooo3_oVi^Ibooooo`koi^KV[_ooool004Oooooo4?oVi^I`oooooa3oi^KV[Oooool004Oooooo1_oV
i^H4o`0000Koi^KVL?ooool@onKViZgooooo0016ooooo`[oi^KV0_l00006onKViVkooooo4_oVi^J/
ooooo`003Oooool5o`0003Cooooo1ooVi^H5o`0000Koi^KV=Oooool4o`0003Gooooo1OoVi^H7o`00
00Koi^KV<oooool6o`0007?ooooo000<ooooo`;o000000?oooooo`000?l00000=Oooool6onKViP;o
00000_oVi^H2o`0000Koi^KV=?ooool2o`0000;ooooo0_l0000dooooo`Koi^KV0_l000000ooVi^Ko
0000o`000007onKViSCooooo0_l000000ooooooo0000o`00001cooooo`003Oooool4o`0003Gooooo
1_oVi^H2o`0000;oi^KV0_l00006onKViSCooooo0_l0000hooooo`Koi^KV0_l000000ooVi^Ko0000
o`000007onKViSGooooo0_l0001eooooo`003?ooool2o`000003ooooool0003o000003Gooooo1_oV
i^H2o`0000;oi^KV0_l00006onKViSCooooo0_l00002ooooo`;o0000=?ooool6onKViP;o000000?o
i^KVo`000?l000001ooVi^Hfooooo`;o0000M?ooool000gooooo0ol00008ooooo`;o0000;?ooool7
onKViPKo00001OoVi^Heooooo`Co0000=Oooool6onKViPCo00002?oVi^H/ooooo`03o`000?oooooo
oooo00Cooooo0_l00002ooooo`;o0000Loooool001[ooooo1?l0000Yoooooa3oi^KVL?ooool5onKV
iP;o00002OoVi^HYooooo`Co00001oooool2o`0000;ooooo0_l0001cooooo`007_ooool5o`0002Co
oooo4?oVi^H2o`0006cooooo0_l00004onKViP?o00002OoVi^HUooooo`Co00003?ooool4o`0007Co
oooo000Sooooo`Co00008Oooool>onKViP?ooooo0_l0001Xooooo`;o00000oooool>onKViR7ooooo
1Ol00028ooooo`009oooool4o`0001kooooo3?oVi^H6ooooo`;o0000I?ooool2o`0000Kooooo3?oV
i^HNooooo`Co0000SOooool002_ooooo1?l0000Kooooo`[oi^KV2Oooool2o`00063ooooo0_l00009
ooooo`[oi^KV6oooool4o`00097ooooo000_ooooo`Co00006Oooool6onKViPgooooo0ol0001Koooo
o`;o00003Oooool6onKViQWooooo1?l0002Eooooo`00<oooool4o`0002_ooooo0_l0000[ooooo`03
o`000?oooooooooo02Wooooo0_l0000Zooooo`Co0000VOooool003Oooooo1?l0000Yooooo`;o0000
:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool4o`0009gooooo000kooooo`Co00009ooo
ool2o`0002Oooooo00?o0000ooooooooool09Oooool2o`0002Kooooo1?l0002Qooooo`00?oooool5
o`0002Cooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo0_l0000Tooooo`Co0000YOooool0
04Cooooo1?l0000Rooooo`;o00008oooool00ol0003oooooooooo`0Qooooo`;o00008_ooool4o`00
0:Wooooo0018ooooo`Co00008?ooool2o`00027ooooo00?o0000ooooooooool07oooool2o`00023o
oooo1?l0002]ooooo`00C?ooool4o`0001kooooo0_l0000Oooooo`03o`000?oooooooooo01cooooo
0ol0000Mooooo`Go0000/Oooool0053ooooo1?l0000Looooo`;o00007Oooool00ol0003ooooooooo
o`0Jooooo`;o00007?ooool4o`000;Kooooo001Dooooo`Co00006_ooool2o`0001_ooooo00?o0000
ooooooooool06?ooool2o`0001[ooooo1?l0002jooooo`00F?ooool4o`0001Sooooo0_l0000Ioooo
o`03o`000?oooooooooo01Kooooo0_l0000Hooooo`Co0000__ooool005cooooo1Ol0000Eooooo`;o
00005oooool00ol0003oooooooooo`0Dooooo`;o00005_ooool4o`000<;ooooo001Qooooo`Co0000
4oooool2o`0001Gooooo00?o0000ooooooooool04_ooool2o`0001Cooooo1?l00036ooooo`00IOoo
ool4o`00017ooooo0_l0000Cooooo`03o`000?oooooooooo013ooooo0_l0000Booooo`Co0000b_oo
ool006Wooooo1?l0000?ooooo`;o00004Oooool00ol0003oooooooooo`0>ooooo`;o00004?ooool4
o`000<kooooo001]ooooo`Co00003Oooool3o`0000_ooooo1_oVi^H<ooooo`;o00003_ooool4o`00
0=;ooooo001aooooo`Co00003?ooool2o`0000Oooooo2_oVi^H8ooooo`;o00003?ooool4o`000=Ko
oooo001eooooo`Co00002_ooool2o`0000Cooooo3?oVi^H5ooooo`;o00002_ooool4o`000=[ooooo
001iooooo`Co00002?ooool2o`000003oooooooVi^Koi^KV00coi^KV0_ooool2o`0000Oooooo1Ol0
003Nooooo`00OOooool5o`0000Gooooo4?oVi^H00ol0003oooooooooo`03ooooo`Co0000hoooool0
08;ooooo1?l000000oooooooi^KVonKViP0>onKViP;ooooo1?l0003Wooooo`00Q_ooool6onKViPKo
00001_oVi^H00ol0003oooooooooo`3Yooooo`00Q_ooool8onKViP;o00002?oVi^K/ooooo`00Q_oo
ool8onKViP;o00002?oVi^K/ooooo`00Q_ooool8onKViP;o00002?oVi^K/ooooo`00Q_ooool7onKV
iPGo00001_oVi^K/ooooo`00Q_ooool8onKViP;o00002?oVi^K/ooooo`00Qoooool8onKViP?o0000
1OoVi^K]ooooo`00Qoooool@onKVi^gooooo0028ooooo`koi^KVk_ooool008Wooooo3?oVi^K_oooo
o`00R_ooool:onKVi_3ooooo002<ooooo`Koi^KVl_ooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.24223, -1.45946, \
0.01567, 0.00634707}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.42348 0.199835 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.15406 .30902 -5 -6 ]
[.15406 .30902 5 6 ]
[.29323 .30902 -5 -6 ]
[.29323 .30902 5 6 ]
[.22364 .45617 -5 -6 ]
[.22364 .45617 5 6 ]
[.42348 .45617 -5 -6 ]
[.42348 .45617 5 6 ]
[.55373 .30902 -5 -6 ]
[.55373 .30902 5 6 ]
[.54145 .16187 -5 -6 ]
[.54145 .16187 5 6 ]
[.71251 .01472 -5 -6 ]
[.71251 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.84435 .16187 -5 -6 ]
[.84435 .16187 5 6 ]
[.6929 .30902 -5 -6 ]
[.6929 .30902 5 6 ]
[.62332 .45617 -5 -6 ]
[.62332 .45617 5 6 ]
[.82315 .45617 -5 -6 ]
[.82315 .45617 5 6 ]
[.42348 .60332 -5 -6 ]
[.42348 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.42348 .60332 m
.02381 .45617 L
s
.42348 .60332 m
.22364 .45617 L
s
.42348 .60332 m
.42348 .45617 L
s
.42348 .60332 m
.62332 .45617 L
s
.42348 .60332 m
.82315 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.22364 .45617 m
.15406 .30902 L
s
.22364 .45617 m
.29323 .30902 L
s
1 g
.05 w
.15406 .30902 Mdot
0 g
gsave
.15406 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.29323 .30902 Mdot
0 g
gsave
.29323 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.22364 .45617 Mdot
0 g
gsave
.22364 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.42348 .45617 Mdot
0 g
gsave
.42348 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.62332 .45617 m
.55373 .30902 L
s
.62332 .45617 m
.6929 .30902 L
s
1 g
.05 w
.55373 .30902 Mdot
0 g
gsave
.55373 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.6929 .30902 m
.54145 .16187 L
s
.6929 .30902 m
.84435 .16187 L
s
1 g
.05 w
.54145 .16187 Mdot
0 g
gsave
.54145 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.84435 .16187 m
.71251 .01472 L
s
.84435 .16187 m
.97619 .01472 L
s
1 g
.05 w
.71251 .01472 Mdot
0 g
gsave
.71251 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.9 g
.84435 .16187 Mdot
0 g
gsave
.84435 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.6929 .30902 Mdot
0 g
gsave
.6929 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.62332 .45617 Mdot
0 g
gsave
.62332 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.82315 .45617 Mdot
0 g
gsave
.82315 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.42348 .60332 Mdot
0 g
gsave
.42348 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00ooooool@ooooo`Go0000G_ooool4o`0000kooooo
003oooooo`oooooo0_l000000ooooooo0000o`00001Nooooo`;o00004Oooool00?oooooo4?ooool4
o`0005kooooo1_l0000=ooooo`00ooooool?ooooo`;o000000?oooooo`000?l00000G_ooool2o`00
00;ooooo0_l0000=ooooo`00ooooool@ooooo`?o0000H?ooool4o`0000kooooo003oooooohGooooo
003oooooohGooooo003oooooohGooooo003oooooohGooooo003ooooooaSooooo00?o0000oooooooo
ool0E?ooool00ol0003oooooooooo`0Cooooo`00oooooolIooooo`03o`000?oooooooooo05;ooooo
00?o0000ooooooooool05?ooool00?oooooo6_ooool00ol0003oooooooooo`1@ooooo`03o`000?oo
oooooooo01Gooooo003ooooooa[ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0F
ooooo`00oooooolKooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool05oooool00?oo
oooo7?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo01Oooooo003ooooooagooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Hooooo`00oooooolNooooo`03o`000?oo
oooooooo04Sooooo00?o0000ooooooooool06Oooool00?oooooo7oooool00ol0003oooooooooo`16
ooooo`03o`000?oooooooooo01[ooooo003oooooob3ooooo00?o0000ooooooooool0A?ooool00ol0
003oooooooooo`0Kooooo`00oooooolQooooo`03o`000?oooooooooo04;ooooo00?o0000oooooooo
ool07?ooool00?oooooo8_ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo01gooooo
003oooooob;ooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0Nooooo`00oooooolS
ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool07oooool00?oooooo9?ooool00ol0
003oooooooooo`0kooooo`03o`000?oooooooooo023ooooo003oooooobGooooo00?o0000oooooooo
ool0>Oooool00ol0003oooooooooo`0Qooooo`00oooooolVooooo`03o`000?oooooooooo03Sooooo
00?o0000ooooooooool08Oooool00?oooooo9oooool00ol0003oooooooooo`0fooooo`03o`000?oo
oooooooo02;ooooo003oooooobSooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0S
ooooo`00oooooolYooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool09?ooool00?oo
oooo:_ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Gooooo003oooooob_ooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Vooooo`00ooooool[ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool09oooool00?oooooo;?ooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo02Sooooo003oooooobgooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Yooooo`00ooooool^ooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool0:_ooool00?oooooo;oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02_ooooo
003ooooooc3ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0[ooooo`00oooooola
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0;?ooool00?oooooo<_ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo02gooooo003ooooooc?ooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`0^ooooo`00oooooolcooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool0;oooool00?oooooo=?ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo033ooooo003oooooocGooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0a
ooooo`00oooooolfooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0<_ooool00?oo
oooo=oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03?ooooo003oooooocSooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0dooooo`00ooooooliooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0=Oooool00?oooooo>_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo03Gooooo003ooooooc_ooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0fooooo`00oooooolkooooo`03o`000?oooooooooo00?ooooo1_oVi^H4ooooo`03
o`000?oooooooooo03Oooooo003ooooooccooooo00?o0000ooooooooool02_oVi^H00ooooooo0000
ooooo`0iooooo`00oooooolmooooo`03o`000?oVi^Koi^KV00[oi^KV>oooool00?oooooo?Oooool>
onKViS[ooooo003ooooooccooooo1OoVi^H4o`0000Ooi^KV>Oooool00?oooooo??ooool8onKViP;o
00001_oVi^Hiooooo`00coooool4o`0006Oooooo1_oVi^H5o`0000Ooi^KV>?ooool00<kooooo0_l0
0002ooooo`;o0000I_ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV>?ooool00<kooooo0_l0001Z
ooooo`Goi^KV0_l00002onKViP;o00001ooVi^Hhooooo`00c_ooool2o`0000;ooooo0_l0001Voooo
o`Goi^KV0_l00002onKViP;o00001ooVi^Hhooooo`00coooool4o`0006Oooooo1_oVi^H6o`0000Ko
i^KV>?ooool00?oooooo>ooooolBonKViSSooooo003ooooooccooooo4?oVi^Hiooooo`00ooooooll
oooooa3oi^KV>Oooool00=Sooooo00?o0000ooooooooool0H?ooool00ol0003oi^KVonKViP0<onKV
iS[ooooo003Iooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool03?oVi^Hkooooo`00
f_ooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00;ooooo2_oVi^Hlooooo`00fooo
ool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo00Gooooo1_oVi^Hnooooo`00g?ooool0
0ol0003oooooooooo`1Hooooo`03o`000?oooooooooo04[ooooo003Mooooo`03o`000?oooooooooo
05Kooooo00?o0000ooooooooool0Boooool00=kooooo00?o0000ooooooooool0E?ooool00ol0003o
ooooooooo`1<ooooo`00goooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo04gooooo
003Pooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0C_ooool00>7ooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`1?ooooo`00h_ooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo053ooooo003Sooooo`03o`000?oooooooooo04[ooooo00?o0000oooooooo
ool0DOooool00>Cooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`1Booooo`00iOoo
ool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo05?ooooo003Vooooo`03o`000?oooooo
oooo04Cooooo00?o0000ooooooooool0E?ooool00>Oooooo00?o0000ooooooooool0@_ooool00ol0
003oooooooooo`1Eooooo`00j?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo05Ko
oooo003Yooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0Eoooool00>[ooooo00?o
0000ooooooooool0??ooool00ol0003oooooooooo`1Hooooo`00joooool00ol0003oooooooooo`0j
ooooo`03o`000?oooooooooo05Wooooo003/ooooo`03o`000?oooooooooo03Sooooo00?o0000oooo
ooooool0F_ooool00>gooooo0_l0000gooooo`03o`000?oooooooooo05_ooooo003_ooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool0G?ooool00?3ooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`1Mooooo`00lOooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo05kooooo003booooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0Goooool00??o
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1Pooooo`00m?ooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo067ooooo003eooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0H_ooool00?Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1S
ooooo`00moooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo06Cooooo003hooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0IOooool00?Wooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`1Vooooo`00n_ooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo06Oooooo003kooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0J?ooool0
0?cooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1Yooooo`00oOooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo06[ooooo003nooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool0Joooool00?oooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`1/ooooo`00ooooool1ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0KOooool0
0?oooooo0_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo06kooooo003oooooo`?o
oooo00?o0000ooooooooool00_ooool6onKViPGooooo00?o0000ooooooooool0Koooool00?oooooo
1?ooool00ol0003oooooonKViP09onKViP;ooooo00?o0000ooooooooool0L?ooool00?oooooo1Ooo
ool<onKViP03o`000?oooooooooo077ooooo003oooooo`Cooooo3_oVi^Icooooo`00ooooool3oooo
o`Koi^KV1?l00006onKViW;ooooo003oooooo`?ooooo2OoVi^H2o`0000Goi^KVL_ooool003gooooo
1Ol0000`ooooo`Co0000G_ooool4o`0002Wooooo1ooVi^H5o`0000Koi^KVLOooool003kooooo0_l0
00000ooooooo0000o`00000^ooooo`;o00000_ooool2o`0005cooooo0_l0000/ooooo`Koi^KV0_l0
0002onKViP;o00001_oVi^Iaooooo`00?_ooool2o`000003ooooool0003o000003;ooooo0_l0001L
ooooo`Ko0000:?ooool6onKViP;o00000_oVi^H2o`0000Koi^KVLOooool003kooooo0_l000000ooo
oooo0000o`00000`ooooo`?o0000GOooool2o`0000;ooooo0_l0000Xooooo`Koi^KV0_l00002onKV
iP;o00001_oVi^Iaooooo`00?_ooool4o`0003?ooooo0_l0001Mooooo`Co0000:Oooool7onKViPKo
00001OoVi^Iaooooo`00?_ooool2o`00037ooooo0_l00002ooooo`;o0000R_oooolBonKViW7ooooo
000mooooo`?o0000<_ooool4o`0008cooooo4?oVi^Ibooooo`00ooooool3oooooa3oi^KVL_ooool0
0?oooooo1?ooool>onKViW?ooooo003oooooo`Gooooo3?oVi^Idooooo`00ooooool6ooooo`[oi^KV
MOooool004Cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1Wooooo`03o`000?oo
oooooooo02Wooooo00?o0000onKVi_oVi^H01?oVi^Igooooo`00A?ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1k
ooooo`00AOooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo06Wooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`1looooo`00AOooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo06Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`1looooo`00
A_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`1mooooo`00A_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo06_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1mooooo`00Aoooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`1nooooo`00Aoooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
06gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1nooooo`00B?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`1oooooo`00B?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo06oooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`1oooooo`00BOooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo077ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`20ooooo`00BOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo077ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`20ooooo`00B_ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo07?ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`21oooo
o`00B_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo07?ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`21ooooo`00Boooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo07Gooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`22ooooo`00Booo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo07Gooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`22ooooo`00C?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo07Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`23ooooo`00C?ooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo07Oooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`23ooooo`00COooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo07Wo
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`24ooooo`00COooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo07Wooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`24ooooo`00COooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo07Wooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`24ooooo`00C_ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`25
ooooo`00C_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`25ooooo`00Coooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo07gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`26ooooo`00
Coooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo07gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`26ooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo07oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`27ooooo`00D?ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`27ooooo`00DOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
087ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`28ooooo`00DOooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`28ooooo`00D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo08?ooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`29ooooo`00D_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo08?ooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`29ooooo`00Doooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo08Gooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`2:ooooo`00Doooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo08Gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2:oooo
o`00E?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo08Oooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`2;ooooo`00E?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo08Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2;ooooo`00EOoo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`2<ooooo`00EOooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo08Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2<ooooo`00E_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo08_ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`2=ooooo`00E_ooool00ol0003oi^KVonKViP04onKViP03ooooool0003ooooo08co
oooo00?o0000onKVi_oVi^H01?oVi^H00ooooooo0000ooooo`2>ooooo`00EOooool:onKViXcooooo
2_oVi^J?ooooo`00E?ooool<onKViX[ooooo3?oVi^J>ooooo`00Doooool>onKViXSooooo3_oVi^J=
ooooo`00D_ooool6onKViPCo00001_oVi^J6oooooa3oi^KVS?ooool005;ooooo2OoVi^H2o`0000Go
i^KVQ_ooool@onKViXcooooo000=ooooo`Go0000?oooool7onKViPGo00001_oVi^I0ooooo`Co0000
@?ooool6onKViPOo00001OoVi^Hoooooo`Ko0000A_ooool000cooooo0_l000000ooooooo0000o`00
0010ooooo`Koi^KV0_l00002onKViP;o00001_oVi^Hoooooo`;o00000_ooool2o`0003oooooo1ooV
i^H2o`000003onKVi_l0003o000000Koi^KV@?ooool2o`000003ooooool0003o000004Kooooo000=
ooooo`Co0000@?ooool6onKViP;o00000_oVi^H2o`0000Koi^KV?oooool2o`0004?ooooo1ooVi^H2
o`000003onKVi_l0003o000000Koi^KV@Oooool2o`0004Sooooo000<ooooo`;o000000?oooooo`00
0?l00000@?ooool6onKViP;o00000_oVi^H2o`0000Koi^KV?oooool2o`0000;ooooo0_l0000ooooo
o`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViT;ooooo0_l00017ooooo`003Oooool3o`00047o
oooo1ooVi^H6o`0000Goi^KV@?ooool4o`00043ooooo1ooVi^H4o`0000Ooi^KV?oooool2o`0000;o
oooo0_l00016ooooo`006?ooool2o`0003Oooooo4_oVi^J4ooooo`Ooi^KV0_l00009onKViSSooooo
00?o0000ooooooooool01?ooool2o`0000;ooooo0_l00016ooooo`006_ooool2o`0003Kooooo4?oV
i^J6ooooo`Goi^KV0ol00008onKViSOooooo0_l00008ooooo`Co0000Aoooool001cooooo0ol0000c
oooooa3oi^KV00?o0000ooooooooool0Poooool@onKViSCooooo0ol0001Eooooo`007oooool3o`00
037ooooo3_oVi^H2ooooo`03o`000?oooooooooo087ooooo00?o0000oooooooVi^H03OoVi^Hboooo
o`?o0000F?ooool002;ooooo0_l0000`ooooo`coi^KV1?ooool00ol0003oooooooooo`1oooooo`04
o`000?ooooooooooooooo`coi^KV<Oooool2o`0005_ooooo000Tooooo`?o0000;_ooool:onKViPKo
oooo0_l0001mooooo`;o00001Oooool:onKViRoooooo0ol0001Mooooo`009oooool3o`0002gooooo
1_oVi^H:ooooo`03o`000?oooooooooo07Wooooo00?o0000ooooooooool01oooool6onKViRkooooo
0ol0001Pooooo`00:_ooool3o`0003_ooooo00?o0000ooooooooool0>_ooool00ol0003ooooooooo
o`0jooooo`03o`000?oooooooooo03Wooooo0ol0001Sooooo`00;Oooool2o`0003[ooooo0_l0000j
ooooo`03o`000?oooooooooo03Sooooo0_l0000jooooo`;o0000I_ooool002oooooo0ol0000ioooo
o`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0goooo
o`?o0000J?ooool003;ooooo0ol0000gooooo`03o`000?oooooooooo03Kooooo00?o0000oooooooo
ool0=_ooool00ol0003oooooooooo`0eooooo`?o0000Joooool003Gooooo0ol0000eooooo`;o0000
=_ooool00ol0003oooooooooo`0dooooo`;o0000=Oooool3o`0006kooooo000hooooo`;o0000=Ooo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0<ooo
ool2o`00077ooooo000jooooo`?o0000<oooool2o`0003?ooooo00?o0000ooooooooool0<Oooool2
o`0003?ooooo0ol0001cooooo`00?Oooool3o`0003;ooooo00?o0000ooooooooool0<?ooool00ol0
003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo0ol0001fooooo`00@?ooool2o`00037o
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oo
oooo0_l0001iooooo`00@_ooool3o`0002oooooo0_l0000_ooooo`03o`000?oooooooooo02gooooo
0_l0000_ooooo`?o0000Noooool004Gooooo0ol0000^ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`?o0000O_ooool004Sooooo0ol0000/
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Z
ooooo`?o0000POooool004_ooooo0_l0000[ooooo`;o0000:oooool00ol0003oooooooooo`0Yoooo
o`;o0000:oooool2o`0008Cooooo001=ooooo`?o0000:_ooool00ol0003oooooooooo`0Xooooo`03
o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool3o`0008Kooooo001@ooooo`?o0000
:?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0
9_ooool3o`0008Wooooo001Cooooo`?o00009_ooool2o`0002Oooooo00?o0000ooooooooool09Ooo
ool2o`0002Kooooo0ol0002<ooooo`00E_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo0_l0002?ooooo`00F?ooool3o`00
02Cooooo0_l0000Tooooo`03o`000?oooooooooo02;ooooo0_l0000Tooooo`?o0000TOooool005_o
oooo0ol0000Sooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0Qooooo`?o0000U?ooool005kooooo0_l0000Rooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`;o0000Uoooool0063ooooo0ol0
000Pooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o00008?ooool3o`0009Wooooo001S
ooooo`?o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool07Oooool3o`0009cooooo001Vooooo`?o00007Oooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool06oooool3o`0009oooooo001Yooooo`;o
00007?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo0_l0002Rooooo`00
Joooool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo01Wooooo0ol0002Tooooo`00K_ooool3o`0001Wooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo0ol0002Wooooo`00LOooool3
o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000Z_ooool0
07Cooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0Eooooo`;o0000[Oooool007Kooooo0ol0000Eooooo`;o00005Oooool00ol0003o
ooooooooo`0Cooooo`;o00005Oooool3o`000:oooooo001iooooo`?o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool3o`000;;ooooo
001looooo`;o00004oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool2o`000;Gooooo001nooooo`?o00004Oooool2o`00017ooooo00?o0000
ooooooooool03oooool2o`00017ooooo0ol0002gooooo`00POooool3o`00013ooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo0ol0002joooo
o`00Q?ooool3o`0000kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00cooooo0ol0002mooooo`00Qoooool2o`0000gooooo0_l0000=ooooo`03o`00
0?oooooooooo00_ooooo0_l0000=ooooo`;o0000`?ooool008Wooooo0ol0000<ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`?o0000`_oo
ool008cooooo0ol0000:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`?o0000aOooool008oooooo0ol00008ooooo`;o00001_ooool6onKV
iPOooooo0_l00008ooooo`?o0000b?ooool009;ooooo0_l00008ooooo`04o`000?oooooooooooooo
o`[oi^KV1?ooool00ol0003oooooooooo`06ooooo`;o0000boooool009Cooooo0ol00006ooooo`;o
00003?oVi^H00ooooooo0000o`000006ooooo`?o0000cOooool009Oooooo0ol00004ooooo`koi^KV
1Oooool3o`000=3ooooo002Jooooo`;o000000?oooooonKVi_oVi^H03_oVi^H2ooooo`;o0000dooo
ool009cooooo00?o0000onKVi_oVi^H03_oVi^H2o`000=Gooooo002Looooo`Koi^KV1_l00006onKV
i]Kooooo002Looooo`Soi^KV0_l00008onKVi]Kooooo002Looooo`Soi^KV0_l00008onKVi]Kooooo
002Looooo`Soi^KV0_l00008onKVi]Kooooo002Looooo`Ooi^KV1Ol00006onKVi]Kooooo002Loooo
o`Soi^KV0_l00008onKVi]Kooooo002Mooooo`Soi^KV0ol00005onKVi]Oooooo002Moooooa3oi^KV
eoooool009kooooo3_oVi^KHooooo`00Woooool<onKVi]Wooooo002Pooooo`[oi^KVf_ooool00:;o
oooo1_oVi^KLooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.20642, -0.833976, \
0.0133535, 0.00362689}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.80041 .01472 -5 -6 ]
[.80041 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.80041 .01472 Mdot
0 g
gsave
.80041 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00k_ooool4o`0003kooooo1Ol0000looooo`Ko0000
3Oooool00>gooooo0_l00002ooooo`;o0000??ooool2o`000003ooooool0003o000003kooooo0_l0
00000ooooooo0000o`00000=ooooo`00kOooool2o`00043ooooo0_l000000ooooooo0000o`00000o
ooooo`;o00003oooool00>gooooo0_l00002ooooo`;o0000??ooool2o`000003ooooool0003o0000
043ooooo0_l0000>ooooo`00k_ooool4o`0003kooooo1?l0000mooooo`;o00000_ooool2o`0000go
oooo003ooooooc?ooooo0_l0000mooooo`;o00000_ooool2o`0000gooooo003ooooooc;ooooo0ol0
000nooooo`Co00003_ooool00?ooooooQOooool00?ooooooQOooool00?Kooooo00?o0000oooooooo
ool0MOooool00ol0003oooooooooo`0Cooooo`00moooool00ol0003oooooooooo`1cooooo`03o`00
0?oooooooooo01Cooooo003hooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=ooo
ool00ol0003oooooooooo`0Eooooo`00nOooool00ol0003oooooooooo`0fooooo`03o`000?oooooo
oooo03Kooooo00?o0000ooooooooool05_ooool00?Wooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0fooooo`03o`000?oooooooooo01Kooooo003jooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Gooooo`00noooool00ol0003ooooo
ooooo`0dooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool06?ooool00?cooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Wooooo003m
ooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0J
ooooo`00o_ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000oooo
ooooool06oooool00?oooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo01cooooo003oooooo`7ooooo00?o0000ooooooooool0;oooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo01gooooo003oooooo`;ooooo00?o0000ooooooooool0;_oo
ool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01kooooo003oooooo`?ooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01oooooo003ooooo
o`Cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo
023ooooo003oooooo`Cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03
o`000?oooooooooo023ooooo003oooooo`Gooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo027ooooo003oooooo`Kooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02;ooooo003oooooo`Oooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02?ooooo003ooooo
o`Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
02Cooooo003oooooo`Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo02Gooooo003oooooo`[ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo02Kooooo003oooooo`_ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Oooooo003oooooo`cooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Sooooo003ooooo
o`gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
02Wooooo003oooooo`gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo02Wooooo003oooooo`kooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo02[ooooo003oooooo`oooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02_ooooo003ooooooa3ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo02cooooo003ooooo
oa7ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
02gooooo003ooooooa;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo02kooooo003ooooooa?ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo02oooooo003ooooooaCooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo033ooooo003ooooooaGooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo037ooooo003ooooo
oaKooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
03;ooooo003ooooooaOooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo03?ooooo003ooooooaOooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo03?ooooo003ooooooaSooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Cooooo003ooooooaWooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo03Gooooo003ooooo
oa[ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
03Kooooo003ooooooa_ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo03Oooooo003ooooooacooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo03Sooooo003ooooooagooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03Wooooo003ooooooakooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[ooooo003ooooo
oaoooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
03_ooooo003oooooob3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo03cooooo003oooooob3ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo03cooooo003oooooob7ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03gooooo003oooooob;ooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03kooooo003ooooo
ob?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
03oooooo003oooooobCooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo043ooooo003oooooobGooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo047ooooo003oooooobKooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04;ooooo003oooooobOooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo04?ooooo003ooooo
obSooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
04Cooooo003oooooobWooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo04Gooooo003oooooob[ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo04Kooooo003oooooob[ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04Kooooo003oooooob_ooooo00?o0000
ooooooooool00_ooool6onKViPGooooo00?o0000ooooooooool0Aoooool00?oooooo;?ooool00ol0
003oooooonKViP09onKViP;ooooo00?o0000ooooooooool0B?ooool00?oooooo;Oooool<onKViP03
o`000?oooooooooo04Wooooo003oooooobcooooo3_oVi^I;ooooo`00ooooool[ooooo`Koi^KV1?l0
0006onKViT[ooooo003oooooob_ooooo2OoVi^H2o`0000Goi^KVB_ooool004Gooooo1Ol0000hoooo
o`Co0000KOooool4o`0003;ooooo1ooVi^H5o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo
0000o`00000fooooo`;o00000_ooool2o`0006_ooooo0_l0000eooooo`Koi^KV0_l00002onKViP;o
00001_oVi^I9ooooo`00A_ooool2o`000003ooooool0003o000003[ooooo0_l0001[ooooo`Ko0000
<Oooool6onKViP;o00000_oVi^H2o`0000Koi^KVBOooool004Kooooo0_l000000ooooooo0000o`00
000hooooo`?o0000K?ooool2o`0000;ooooo0_l0000aooooo`Koi^KV0_l00002onKViP;o00001_oV
i^I9ooooo`00A_ooool4o`0003_ooooo0_l0001/ooooo`Co0000<_ooool7onKViPKo00001OoVi^I9
ooooo`00A_ooool2o`0003Wooooo0_l00002ooooo`;o0000X_oooolBonKViTWooooo0015ooooo`?o
0000>_ooool4o`000:Cooooo4?oVi^I:ooooo`00ooooool[oooooa3oi^KVB_ooool00?oooooo;?oo
ool>onKViT_ooooo003oooooobgooooo3?oVi^I<ooooo`00ooooool^ooooo`[oi^KVCOooool004_o
oooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0cooooo`Koi^KVCoooool004cooooo
00?o0000ooooooooool0<Oooool00ol0003oooooooooo`1fooooo`03o`000?oooooooooo03;ooooo
00?o0000ooooooooool0Doooool004cooooo00?o0000ooooooooool0<Oooool00ol0003ooooooooo
o`1fooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0Doooool004gooooo00?o0000
ooooooooool0;oooool00ol0003oooooooooo`1hooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool0E?ooool004gooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1hoooo
o`03o`000?oooooooooo033ooooo00?o0000ooooooooool0E?ooool004gooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo02oooooo00?o0000oooooooo
ool0E?ooool004kooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1jooooo`03o`00
0?oooooooooo02kooooo00?o0000ooooooooool0EOooool004kooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0EOoo
ool004oooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1looooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool0E_ooool004oooooo00?o0000ooooooooool0:oooool00ol0
003oooooooooo`1looooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0E_ooool0053o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0Eoooool0053ooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`1nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0Eoooool0053ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`1oooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0Eoooool0057ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`20
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0F?ooool0057ooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo02Sooooo00?o0000oooo
ooooool0F?ooool005;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`22ooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool0FOooool005;ooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
FOooool005;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`23ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0FOooool005?ooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`24ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0F_ooool0
05?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo
02?ooooo00?o0000ooooooooool0F_ooool005Cooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`26ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Foooool005Cooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0Foooool005Cooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`27ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0Foooool005Gooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool0G?ooool005Gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`29oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0G?ooool005Kooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool0GOooool005Kooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2:ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0GOooool005Kooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`2;ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0GOoo
ool005Oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2<ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool0G_ooool005Oooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`2=ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0G_ooool005So
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2>ooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool0Goooool005Sooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`2?ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0Goooool005Sooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool0Goooool005Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`2@
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0H?ooool005Wooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool0H?ooool005[ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`2Booooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool0HOooool005[ooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
HOooool005[ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`2Cooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool0HOooool005_ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`2Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0H_ooool0
05_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0H_ooool005cooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`2Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0Hoooool005cooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0Hoooool005cooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`2Gooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Hoooool005gooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool0I?ooool005gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2Ioooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0I?ooool005kooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0IOooool005kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Kooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0IOooool005oooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`2Looooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0I_oo
ool005oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0I_ooool005oooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`2Mooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0I_ooool0063o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0Ioooool0063ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`2Oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Ioooool0067ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0J?ooool0067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Q
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?ooool0067ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0J?ooool006;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Sooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0JOooool006;ooooo00?o0000onKVi_oVi^H0
1?oVi^H00ooooooo0000ooooo`2Tooooo`03o`000?oVi^Koi^KV00Coi^KV00?oooooo`000?ooool0
J_ooool0067ooooo2_oVi^JTooooo`[oi^KVJoooool0063ooooo3?oVi^JRooooo`coi^KVJ_ooool0
05oooooo3_oVi^JPooooo`koi^KVJOooool005kooooo4?oVi^JNoooooa3oi^KVJ?ooool005kooooo
1_oVi^H4o`0000Koi^KVW_ooool@onKViVSooooo001Mooooo`[oi^KV0_l00006onKViYcooooo4_oV
i^IWooooo`003Oooool5o`0004_ooooo1ooVi^H5o`0000Koi^KVC?ooool4o`0004cooooo1_oVi^H7
o`0000Goi^KVBoooool6o`0001Kooooo000<ooooo`;o000000?oooooo`000?l00000C?ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KVBoooool2o`0000;ooooo0_l0001;ooooo`Ooi^KV0_l000000ooV
i^Ko0000o`000006onKViTcooooo0_l000000ooooooo0000o`00000Fooooo`003Oooool4o`0004co
oooo1_oVi^H2o`0000;oi^KV0_l00006onKViT_ooooo0_l0001?ooooo`Ooi^KV0_l000000ooVi^Ko
0000o`000006onKViTgooooo0_l0000Hooooo`003?ooool2o`000003ooooool0003o000004cooooo
1_oVi^H2o`0000;oi^KV0_l00006onKViT_ooooo0_l00002ooooo`;o0000Boooool7onKViP;o0000
00?oi^KVo`000?l000001_oVi^I>ooooo`;o00005oooool000gooooo0ol0001=ooooo`Ooi^KV1_l0
0005onKViTcooooo1?l0001<ooooo`Ooi^KV1?l00007onKViT_ooooo0_l00002ooooo`;o00005_oo
ool001Oooooo00?o0000ooooooooool0A?ooool@onKViYkooooo1_oVi^H2o`0000Soi^KVC?ooool2
o`0000;ooooo0_l0000Fooooo`006?ooool3o`0004?ooooo4?oVi^JNooooo`Goi^KV0ol00008onKV
iTCooooo0ol00006ooooo`Co00005oooool001_ooooo0_l00012ooooo`koi^KV00?o0000oooooooo
ool0WOooool>onKViT?ooooo0_l0000Tooooo`007Oooool2o`00047ooooo3?oVi^H2ooooo`03o`00
0?oooooooooo09_ooooo00?o0000oooooooVi^H02ooVi^I2ooooo`;o00009_ooool001oooooo0ol0
000oooooo`[oi^KV1?ooool00ol0003oooooooooo`2Iooooo`04o`000?ooooooooooooooo`[oi^KV
@?ooool3o`0002Sooooo000Rooooo`;o0000?oooool6onKViPOooooo00?o0000ooooooooool0Uooo
ool00ol0003oooooooooo`04ooooo`Koi^KV@?ooool2o`0002_ooooo000Tooooo`?o0000B_ooool0
0ol0003oooooooooo`19ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool0B?ooool3
o`0002gooooo000Wooooo`;o0000BOooool2o`0004Wooooo00?o0000ooooooooool0Aoooool2o`00
04Wooooo0_l0000`ooooo`00:Oooool2o`0004Wooooo00?o0000ooooooooool0A_ooool00ol0003o
ooooooooo`16ooooo`03o`000?oooooooooo04Oooooo0_l0000booooo`00:oooool3o`0004Oooooo
00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo
0ol0000dooooo`00;_ooool2o`0004Kooooo00?o0000ooooooooool0A?ooool00ol0003ooooooooo
o`14ooooo`03o`000?oooooooooo04Cooooo0_l0000gooooo`00<?ooool3o`0004Cooooo00?o0000
ooooooooool0@oooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo04;ooooo0ol0000i
ooooo`00<oooool2o`0004?ooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`12oooo
o`03o`000?oooooooooo047ooooo0_l0000looooo`00=Oooool2o`0004;ooooo0_l00012ooooo`03
o`000?oooooooooo043ooooo0_l00012ooooo`;o0000?_ooool003Oooooo0ol00011ooooo`03o`00
0?oooooooooo03oooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`?o0000
@?ooool003[ooooo0_l00010ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0?_oo
ool00ol0003oooooooooo`0nooooo`;o0000@oooool003cooooo0_l0000oooooo`03o`000?oooooo
oooo03gooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0mooooo`;o0000AOooool0
03kooooo0ol0000mooooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool0??ooool00ol0
003oooooooooo`0kooooo`?o0000Aoooool0047ooooo0_l0000looooo`;o0000??ooool00ol0003o
ooooooooo`0jooooo`;o0000??ooool2o`0004[ooooo0013ooooo`?o0000>oooool00ol0003ooooo
ooooo`0iooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0>Oooool3o`0004cooooo
0016ooooo`;o0000>_ooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o
0000ooooooooool0>?ooool2o`0004oooooo0018ooooo`;o0000>Oooool00ol0003oooooooooo`0g
ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool2o`00057ooooo001:oooo
o`?o0000=oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Kooooo00?o0000oooo
ooooool0=Oooool3o`0005?ooooo001=ooooo`;o0000=_ooool2o`0003Kooooo00?o0000oooooooo
ool0=?ooool2o`0003Kooooo0_l0001Fooooo`00Coooool3o`0003Gooooo00?o0000ooooooooool0
<oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03?ooooo0ol0001Hooooo`00D_oo
ool2o`0003Cooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oo
oooooooo03;ooooo0_l0001Kooooo`00E?ooool2o`0003?ooooo00?o0000ooooooooool0<Oooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo0_l0001Mooooo`00E_ooool3o`00
037ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
02oooooo0ol0001Oooooo`00FOooool2o`00033ooooo0_l0000`ooooo`03o`000?oooooooooo02ko
oooo0_l0000`ooooo`;o0000H_ooool005_ooooo0_l0000`ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`;o0000I?ooool005gooooo0ol0
000^ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003ooooooooo
o`0/ooooo`?o0000I_ooool0063ooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`;o0000JOooool006;ooooo0ol0000[oooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Yoooo
o`?o0000Joooool006Gooooo0_l0000Zooooo`;o0000:_ooool00ol0003oooooooooo`0Xooooo`;o
0000:_ooool2o`0006kooooo001Wooooo`;o0000:_ooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool0:?ooool2o`00073ooooo001Yooooo`?o0000:?oo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09_oo
ool3o`0007;ooooo001/ooooo`;o00009oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool09Oooool2o`0007Gooooo001^ooooo`?o00009Oooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool08oooool3o`00
07Oooooo001aooooo`;o00009?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool08_ooool2o`0007[ooooo001cooooo`;o00008oooool2o`0002?ooooo
00?o0000ooooooooool08Oooool2o`0002?ooooo0_l0001looooo`00MOooool3o`0002;ooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0
001nooooo`00N?ooool2o`00027ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01oooooo0_l00021ooooo`00N_ooool2o`00023ooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo0_l00023oooo
o`00O?ooool3o`0001kooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01cooooo0ol00025ooooo`00Ooooool2o`0001gooooo0_l0000Mooooo`03o`00
0?oooooooooo01_ooooo0_l0000Mooooo`;o0000R?ooool0087ooooo0ol0000Looooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`?o0000R_oo
ool008Cooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`0Iooooo`;o0000SOooool008Kooooo0_l0000Jooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`;o0000Soooool008So
oooo0ol0000Hooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`0Fooooo`?o0000TOooool008_ooooo0_l0000Gooooo`;o00005oooool00ol0003ooooo
ooooo`0Eooooo`;o00005oooool2o`0009Cooooo002=ooooo`?o00005_ooool00ol0003ooooooooo
o`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool3o`0009Kooooo002@
ooooo`;o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04oooool2o`0009Wooooo002Booooo`;o00005?ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool2o`0009_ooooo002Dooooo`?o
00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04?ooool3o`0009gooooo002Gooooo`;o00004Oooool2o`00017ooooo00?o0000ooooooooool0
3oooool2o`00017ooooo0_l0002Pooooo`00VOooool2o`00017ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo0_l0002Rooooo`00Voooool3
o`0000oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo0ol0002Tooooo`00W_ooool2o`0000kooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0_l0002Wooooo`00X?ooool3o`0000co
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[o
oooo0ol0002Yooooo`00Xoooool2o`0000_ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo0_l0002/ooooo`00YOooool2o`0000[ooooo0_l0
000:ooooo`03o`000?oooooooooo00Sooooo0_l0000:ooooo`;o0000[_ooool00:Oooooo0ol00009
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`?o0000/?ooool00:[ooooo0_l00008ooooo`03o`000?oooooooooo00?ooooo1_oVi^H6oooo
o`03o`000?oooooooooo00Kooooo0_l0002cooooo`00[?ooool3o`0000Kooooo00?o0000oooooooo
ool02_oVi^H3ooooo`03o`000?oooooooooo00Cooooo0ol0002eooooo`00[oooool2o`0000Gooooo
00?o0000onKVi_oVi^H02_oVi^H00ooooooo0000ooooo`04ooooo`;o0000^?ooool00;7ooooo0_l0
0003ooooo`koi^KV1?ooool2o`000;[ooooo002cooooo`;o00004?oVi^H3o`000;cooooo002eoooo
oa3oi^KV_oooool00;Cooooo1_oVi^H6o`0000Koi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV
__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool0
0;Cooooo1ooVi^H5o`0000Koi^KV__ooool00;Cooooo2?oVi^H2o`0000Soi^KV__ooool00;Gooooo
2?oVi^H3o`0000Goi^KV_oooool00;Gooooo4?oVi^Joooooo`00]_ooool>onKVi/3ooooo002goooo
o`coi^KV`Oooool00;Sooooo2_oVi^K2ooooo`00^_ooool6onKVi/Cooooo0000\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17784, -0.625483, \
0.011505, 0.00272017}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.442633 0.209412 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.1603 .36788 -5 -6 ]
[.1603 .36788 5 6 ]
[.30614 .36788 -5 -6 ]
[.30614 .36788 5 6 ]
[.23322 .4856 -5 -6 ]
[.23322 .4856 5 6 ]
[.44263 .4856 -5 -6 ]
[.44263 .4856 5 6 ]
[.57912 .36788 -5 -6 ]
[.57912 .36788 5 6 ]
[.54624 .25016 -5 -6 ]
[.54624 .25016 5 6 ]
[.61969 .13244 -5 -6 ]
[.61969 .13244 5 6 ]
[.67766 .01472 -5 -6 ]
[.67766 .01472 5 6 ]
[.75785 .01472 -5 -6 ]
[.75785 .01472 5 6 ]
[.83803 .01472 -5 -6 ]
[.83803 .01472 5 6 ]
[.75785 .13244 -5 -6 ]
[.75785 .13244 5 6 ]
[.81582 .01472 -5 -6 ]
[.81582 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.89601 .13244 -5 -6 ]
[.89601 .13244 5 6 ]
[.75785 .25016 -5 -6 ]
[.75785 .25016 5 6 ]
[.65204 .36788 -5 -6 ]
[.65204 .36788 5 6 ]
[.61916 .25016 -5 -6 ]
[.61916 .25016 5 6 ]
[.83077 .25016 -5 -6 ]
[.83077 .25016 5 6 ]
[.72497 .36788 -5 -6 ]
[.72497 .36788 5 6 ]
[.65204 .4856 -5 -6 ]
[.65204 .4856 5 6 ]
[.86146 .4856 -5 -6 ]
[.86146 .4856 5 6 ]
[.44263 .60332 -5 -6 ]
[.44263 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.44263 .60332 m
.02381 .4856 L
s
.44263 .60332 m
.23322 .4856 L
s
.44263 .60332 m
.44263 .4856 L
s
.44263 .60332 m
.65204 .4856 L
s
.44263 .60332 m
.86146 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.23322 .4856 m
.1603 .36788 L
s
.23322 .4856 m
.30614 .36788 L
s
1 g
.05 w
.1603 .36788 Mdot
0 g
gsave
.1603 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.30614 .36788 Mdot
0 g
gsave
.30614 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.23322 .4856 Mdot
0 g
gsave
.23322 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.44263 .4856 Mdot
0 g
gsave
.44263 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.65204 .4856 m
.57912 .36788 L
s
.65204 .4856 m
.65204 .36788 L
s
.65204 .4856 m
.72497 .36788 L
s
1 g
.05 w
.57912 .36788 Mdot
0 g
gsave
.57912 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 Mabswid
.65204 .36788 m
.54624 .25016 L
s
.65204 .36788 m
.75785 .25016 L
s
1 g
.05 w
.54624 .25016 Mdot
0 g
gsave
.54624 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.75785 .25016 m
.61969 .13244 L
s
.75785 .25016 m
.75785 .13244 L
s
.75785 .25016 m
.89601 .13244 L
s
1 g
.05 w
.61969 .13244 Mdot
0 g
gsave
.61969 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.5 Mabswid
.75785 .13244 m
.67766 .01472 L
s
.75785 .13244 m
.75785 .01472 L
s
.75785 .13244 m
.83803 .01472 L
s
1 g
.05 w
.67766 .01472 Mdot
0 g
gsave
.67766 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.75785 .01472 Mdot
0 g
gsave
.75785 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.83803 .01472 Mdot
0 g
gsave
.83803 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.75785 .13244 Mdot
0 g
gsave
.75785 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.89601 .13244 m
.81582 .01472 L
s
.89601 .13244 m
.97619 .01472 L
s
1 g
.05 w
.81582 .01472 Mdot
0 g
gsave
.81582 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.89601 .13244 Mdot
0 g
gsave
.89601 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.75785 .25016 Mdot
0 g
gsave
.75785 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.65204 .36788 Mdot
0 g
gsave
.65204 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.72497 .36788 m
.61916 .25016 L
s
.72497 .36788 m
.83077 .25016 L
s
1 g
.05 w
.61916 .25016 Mdot
0 g
gsave
.61916 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.83077 .25016 Mdot
0 g
gsave
.83077 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.72497 .36788 Mdot
0 g
gsave
.72497 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.65204 .4856 Mdot
0 g
gsave
.65204 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.86146 .4856 Mdot
0 g
gsave
.86146 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.44263 .60332 Mdot
0 g
gsave
.44263 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00ooooool3ooooo`Co00006_ooool5o`00017ooooo
1Ol00006ooooo`;o0000<?ooool4o`0000gooooo003oooooo`;ooooo0_l00002ooooo`;o00006?oo
ool2o`000003ooooool0003o0000017ooooo0_l000000ooooooo0000o`000007ooooo`;o0000<Ooo
ool2o`0000kooooo003oooooo`;ooooo0_l0000Looooo`;o000000?oooooo`000?l000004_ooool4
o`0003Oooooo1_l0000=ooooo`00ooooool2ooooo`;o00000_ooool2o`0001Sooooo0_l000000ooo
oooo0000o`00000Aooooo`;o000000?oooooo`000?l000001oooool00ol0003oooooooooo`0]oooo
o`;o000000?oooooo`000?l000003_ooool00?oooooo0oooool4o`0001[ooooo1?l0000Booooo`?o
00002?ooool2o`0002oooooo1?l0000>ooooo`00oooooolSooooo`;o00007Oooool2o`00033ooooo
0ol0000>ooooo`00oooooolRooooo`?o00007?ooool2o`0003;ooooo0_l0000>ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00ooooool:ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooool00000<Oooool00ol0003oooooooooo`0Booooo`00ooooool;ooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05Oooool01Ol0003ooooooooooooooooo000002oooooo
00?o0000ooooooooool04oooool00?oooooo2oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Gooooo00Go0000ooooooooooooooooo`00000_ooooo`03o`000?oooooooooo01?ooooo
003oooooo`cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Dooooo`00ooooool=
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool05Oooool00?oooooo3_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo01Kooooo003oooooo`kooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool09oooool00ol0003oooooooooo`0Fooooo`00ooooool?ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool05oooool00?oooooo4?ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo01Sooooo003ooooooa3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0H
ooooo`00oooooolAooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool06Oooool00?oo
oooo4_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01[ooooo003ooooooa;ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Jooooo`00oooooolCooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool06oooool00?oooooo5?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo01cooooo003ooooooaCooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0Looooo`00oooooolEooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool07Oooool00?oooooo5_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01kooooo
003ooooooaKooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Nooooo`00oooooolG
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool07oooool00?oooooo6?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo023ooooo003ooooooaSooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Pooooo`00oooooolIooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool08Oooool00?oooooo6_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo02;ooooo003ooooooa[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0R
ooooo`00oooooolKooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08oooool00?oo
oooo7?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Cooooo003ooooooagooooo
00?o0000ooooooooool01_oVi^H3ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
1_oVi^H3ooooo`03o`000?oooooooooo02Gooooo003ooooooagooooo00?o0000onKVi_oVi^H02?oV
i^H00ooooooo0000ooooo`0Vooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool09_oo
ool00?oooooo7Oooool<onKViRSooooo3?oVi^HXooooo`00oooooolLooooo`koi^KV9_ooool>onKV
iROooooo003ooooooa_ooooo4?oVi^HToooooa3oi^KV9_ooool00?oooooo6oooool6onKViPCo0000
1_oVi^HTooooo`Koi^KV1?l00006onKViRKooooo003ooooooa[ooooo2_oVi^H2o`0000Koi^KV8_oo
ool:onKViP;o00001_oVi^HUooooo`00joooool5o`0002Wooooo1ooVi^H5o`0000Koi^KV8_ooool7
onKViPGo00001_oVi^HUooooo`00k?ooool2o`000003ooooool0003o000002Sooooo1_oVi^H2o`00
00;oi^KV0_l00006onKViR;ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViRGooooo003/ooooo`;o
000000?oooooo`000?l00000:?ooool6onKViP;o00000_oVi^H2o`0000Koi^KV8_ooool6onKViP;o
00000_oVi^H2o`0000Koi^KV9Oooool00>cooooo0_l000000ooooooo0000o`00000Xooooo`Koi^KV
0_l00002onKViP;o00001_oVi^HRooooo`Koi^KV0_l00002onKViP;o00001_oVi^HUooooo`00k?oo
ool4o`0002Wooooo1ooVi^H6o`0000Goi^KV8_ooool7onKViPKo00001OoVi^HUooooo`00k?ooool2
o`0002cooooo4?oVi^HToooooa3oi^KV9_ooool00>_ooooo0ol0000/oooooa3oi^KV9?ooool@onKV
iRKooooo003eooooo`03o`000?oooooooooo02?ooooo3_oVi^HVooooo`koi^KV9oooool00?Kooooo
00?o0000ooooooooool08oooool<onKViRKooooo00?o0000oooooooVi^H02ooVi^HXooooo`00mooo
ool00ol0003oooooooooo`0Sooooo`[oi^KV9_ooool01?l0003oooooooooooooool:onKViRWooooo
003hooooo`03o`000?oooooooooo02Cooooo1_oVi^HWooooo`03o`000?oooooooooo00Cooooo1_oV
i^H[ooooo`00nOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0=_ooool00?[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo03Oooooo003kooooo`;o00009Oooool00ol0003oooooooooo`0Sooooo`;o
0000>_ooool00?gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo03[ooooo003nooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0kooooo`00ooooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0??ooool00?oooooo0Oooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0?Oooool00?oooooo0_ooool2o`0001oo
oooo00?o0000ooooooooool07Oooool2o`00043ooooo003oooooo`Cooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo043ooooo003oooooo`Gooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo047ooooo003o
ooooo`Kooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo04;ooooo003oooooo`Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo04?ooooo003oooooo`Sooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo04Cooooo003oooooo`Wooooo0_l0000Hooooo`03o`00
0?oooooooooo01Kooooo0_l00017ooooo`00ooooool;ooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`17ooooo`00ooooool<ooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`18ooooo`00ooooool=oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`19oooo
o`00ooooool>ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`1:ooooo`00ooooool?ooooo`;o00004_ooool00ol0003oooooooooo`0@ooooo`;o0000
COooool00?oooooo4Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0COooool00?oooooo4_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool0C_ooool00?oooooo4oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Coooool00?oooooo5?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0D?ooool00?oooooo
5Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
DOooool00?oooooo5_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2o`0005Cooooo003o
oooooaSooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo05Cooooo003ooooooaWooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Gooooo003ooooooa[ooooo00?o0000ooooooooool00oooool6onKViPKo
oooo00?o0000ooooooooool0E_ooool00?oooooo6oooool00ol0003oooooooooo`0:onKViP?ooooo
00?o0000ooooooooool0Eoooool00?oooooo7?ooool00ol0003oi^KVonKViP0:onKViP;o0000F_oo
ool00?oooooo7?ooool>onKViU_ooooo003ooooooa_ooooo4?oVi^IJooooo`00oooooolKoooooa3o
i^KVF_ooool00=7ooooo1?l0000Gooooo`Co0000:Oooool6onKViPOo00001OoVi^H?ooooo`Go0000
AOooool00=3ooooo0_l00002ooooo`;o00005Oooool2o`0000;ooooo0_l0000Xooooo`Ooi^KV0_l0
00000ooVi^Ko0000o`000006onKViQ3ooooo0_l000000ooooooo0000o`000014ooooo`00d?ooool2
o`0001Wooooo0_l0000/ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViQ3ooooo0_l00000
0ooooooo0000o`000014ooooo`00d?ooool2o`0000;ooooo0_l0000Eooooo`;o00000_ooool2o`00
02Sooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV4?ooool2o`000003ooooool0003o0000
04Cooooo003Aooooo`Co00005oooool4o`0002Wooooo1ooVi^H4o`0000Ooi^KV4?ooool4o`0004Go
oooo003ooooooa[ooooo1ooVi^H2o`0000Woi^KV4?ooool2o`0004Oooooo003ooooooa_ooooo1OoV
i^H3o`0000Soi^KV4?ooool3o`0004Oooooo003ooooooa_ooooo4?oVi^IJooooo`00oooooolLoooo
o`koi^KVFoooool00=Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Uooooo`co
i^KV3oooool00ol0003oooooooooo`1:ooooo`00f_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo02?ooooo00?o0000oooooooVi^H02OoVi^H?ooooo`03o`000?oooooooooo04_ooooo
003Kooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`02ooooo`Koi^KV4?ooool00ol0003oooooooooo`1<ooooo`00foooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1<
ooooo`00g?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`1=ooooo`00gOooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1>ooooo`00
g_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`1?ooooo`00goooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1@ooooo`00h?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`1Aooooo`00hOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Booooo`00h_ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`1Cooooo`00hoooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Dooooo`00hoooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`1Dooooo`00i?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`1Eooooo`00iOooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1Foooo
o`00i_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`1Gooooo`00ioooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Hooooo`00j?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`1Iooooo`00jOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1Jooooo`00j_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`1Kooooo`00j_ooool00ol0003oooooooooo`0Iooooo`05o`000?oooooooooooooo
ool000006oooool00ol0003oooooooooo`1Kooooo`00joooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooo000001_ooooo00?o0000ooooooooool0G?ooool00>cooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05gooooo003]ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooool000006Oooool00ol0003oooooooooo`1Nooooo`00k_ooool0
0ol0003oooooooooo`0Eooooo`05o`000?ooooooooooooooool000005oooool00ol0003ooooooooo
o`1Oooooo`00koooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`1Pooooo`00l?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Qoooo
o`00lOooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`1Rooooo`00l_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1Sooooo`00l_oo
ool00ol0003oooooooooo`03ooooo`Koi^KV1?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00;ooooo1_oVi^H5ooooo`03o`000?oooooooooo06?ooooo003cooooo`03o`000?oooooo
oooo00[oi^KV00?oooooo`000?ooool03?ooool00ol0003oooooonKViP09onKViP;ooooo00?o0000
ooooooooool0I?ooool00?Cooooo00?o0000onKVi_oVi^H02_oVi^H?ooooo`coi^KV00?o0000oooo
ooooool0IOooool00?Cooooo3_oVi^H=ooooo`koi^KVIoooool00??ooooo1OoVi^H4o`0000Ooi^KV
2oooool6onKViPCo00001_oVi^IVooooo`00loooool8onKViP;o00001_oVi^H;ooooo`Woi^KV0_l0
0005onKViVKooooo000oooooo`Go0000<oooool4o`0006;ooooo1Ol0000@ooooo`Koi^KV1Ol00007
onKViPWooooo1ooVi^H5o`0000Koi^KVIOooool0043ooooo0_l000000ooooooo0000o`00000aoooo
o`;o00000_ooool2o`00063ooooo0_l000000ooooooo0000o`00000Aooooo`Goi^KV0_l00002onKV
iP;o00001ooVi^H9ooooo`Koi^KV0_l00002onKViP;o00001_oVi^IUooooo`00@?ooool2o`000003
ooooool0003o000003Gooooo0_l0001Pooooo`;o000000?oooooo`000?l000004Oooool5onKViP;o
00000_oVi^H2o`0000Ooi^KV2Oooool6onKViP;o00000_oVi^H2o`0000Koi^KVIOooool0043ooooo
0_l000000ooooooo0000o`00000cooooo`?o0000HOooool2o`000003ooooool0003o0000017ooooo
1OoVi^H2o`0000;oi^KV0_l00007onKViPWooooo1_oVi^H2o`0000;oi^KV0_l00006onKViVGooooo
0010ooooo`Co0000=_ooool2o`00067ooooo1?l0000Aooooo`Koi^KV1_l00006onKViPWooooo1ooV
i^H6o`0000Goi^KVIOooool0043ooooo0_l0000dooooo`;o00000_ooool2o`0006?ooooo0_l0000A
oooooa;oi^KV2OoooolBonKViVGooooo000oooooo`?o0000=Oooool4o`0006?ooooo0ol0000Boooo
oa3oi^KV2oooool@onKViVKooooo003coooooa3oi^KV2oooool@onKViVKooooo003dooooo`koi^KV
3Oooool>onKViVOooooo003eooooo`coi^KV3oooool<onKViVSooooo0017ooooo`03o`000?oooooo
oooo09[ooooo00?o0000ooooooooool03oooool:onKViQ7ooooo2_oVi^IYooooo`00Aoooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool04Oooool6onKV
iQ?ooooo00?o0000oooooooVi^H01OoVi^I[ooooo`00B?ooool00ol0003oooooooooo`0Xooooo`03
o`000?oooooooooo06oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo077ooooo0018ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0
L?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
L_ooool004Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`1aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`1booooo`00B_ooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo07?ooooo001:ooooo`03o`000?oooooooooo
02?ooooo00?o0000ooooooooool0M?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0M?ooool004_ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`1eooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`1dooooo`00C?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo07Oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo07Gooooo
001<ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0N?ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0M_ooool004gooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`1fooooo`00COooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo07[ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo07Oooooo001>ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool0Noooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0Moooool004oooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`1mooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1hooooo`00Cooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo07Wooooo001@ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0Ooooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0NOooool0053ooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`20ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`1jooooo`00DOooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo08;o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo07_o
oooo001Booooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0Poooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Noooool005;ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`1looooo`00Doooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo08Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo07gooooo001Cooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0Q_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0OOooool005Cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`28ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1nooooo`00
EOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo07kooooo001Eooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0R_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0Ooooool005Kooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`2<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`20ooooo`00Eoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
08gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
083ooooo001Gooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0S_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0POooool005Sooooo
00?o0000ooooooooool01_oVi^H00ooooooo0000ooooo`2Aooooo`03o`000?oooooooooo00Koi^KV
00?oooooo`000?ooool0Poooool005Sooooo00?o0000onKVi_oVi^H02?oVi^JBooooo`03o`000?oV
i^Koi^KV00Soi^KVQ?ooool005Sooooo3?oVi^JAooooo`coi^KVPoooool005Oooooo3_oVi^J?oooo
o`koi^KVP_ooool005Kooooo1OoVi^H4o`0000Ooi^KVSOooool@onKViX7ooooo001Fooooo`Soi^KV
0_l00006onKViXgooooo4?oVi^J1ooooo`003Oooool5o`0004?ooooo1_oVi^H5o`0000Ooi^KV@ooo
ool4o`0004Cooooo1OoVi^H7o`0000Koi^KV@_ooool6o`0003Sooooo000<ooooo`;o000000?ooooo
o`000?l00000A?ooool5onKViP;o00000_oVi^H2o`0000Ooi^KV@_ooool2o`0000;ooooo0_l00013
ooooo`Koi^KV0_l000000ooVi^Ko0000o`000007onKViT?ooooo0_l000000ooooooo0000o`00000h
ooooo`003Oooool4o`0004Cooooo1OoVi^H2o`0000;oi^KV0_l00007onKViT;ooooo0_l00017oooo
o`Koi^KV0_l000000ooVi^Ko0000o`000007onKViTCooooo0_l0000jooooo`003?ooool2o`000003
ooooool0003o000004Cooooo1OoVi^H2o`0000;oi^KV0_l00007onKViT;ooooo0_l00002ooooo`;o
0000@oooool6onKViP;o000000?oi^KVo`000?l000001ooVi^I5ooooo`;o0000>Oooool000gooooo
0ol00008ooooo`03o`000?oooooooooo03[ooooo1_oVi^H6o`0000Koi^KV@oooool4o`0004Cooooo
1_oVi^H4o`0000Soi^KV@_ooool2o`0000;ooooo0_l0000hooooo`006Oooool3o`0003Wooooo4_oV
i^J;ooooo`Koi^KV0_l0000:onKViSWooooo0ol00006ooooo`;o00000_ooool2o`0003Sooooo000L
ooooo`Co0000=_ooool@onKViXcooooo00?o0000onKVi_oVi^H00_oVi^H3o`0000Woi^KV=_ooool4
o`0000[ooooo1?l0000iooooo`008?ooool4o`0003;ooooo4?oVi^H2o`0008Sooooo0_l000000ooo
ooooi^KVonKViP0>onKViS;ooooo1?l0001;ooooo`009?ooool3o`00033ooooo3_oVi^H3ooooo`;o
0000Q?ooool2o`0000Cooooo3_oVi^H`ooooo`?o0000Coooool002Oooooo1?l0000]ooooo`coi^KV
1_ooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo00Gooooo3?oVi^H]ooooo`Co0000
D_ooool002_ooooo0ol0000[ooooo`[oi^KV2?ooool2o`0007kooooo0_l00009ooooo`[oi^KV:ooo
ool3o`0005Kooooo000^ooooo`Co0000:Oooool6onKViPcooooo0_l0001jooooo`;o00003Oooool6
onKViRWooooo1?l0001Iooooo`00<_ooool3o`0003[ooooo0_l0000kooooo`03o`000?oooooooooo
03Sooooo0_l0000kooooo`?o0000GOooool003Gooooo1?l0000hooooo`;o0000>Oooool00ol0003o
ooooooooo`0gooooo`03o`000?oooooooooo03Oooooo1?l0001Pooooo`00>Oooool4o`0003Kooooo
00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0eooooo`;o0000=_ooool4o`0006Cooooo
000mooooo`?o0000=?ooool2o`0003Kooooo00?o0000ooooooooool0<oooool2o`0003Gooooo0ol0
001Xooooo`00@?ooool4o`0003;ooooo0_l0000dooooo`03o`000?oooooooooo037ooooo0_l0000c
ooooo`Co0000Joooool004Cooooo0ol0000aooooo`;o0000<_ooool00ol0003oooooooooo`0`oooo
o`03o`000?oooooooooo033ooooo0ol0001_ooooo`00Aoooool4o`0002oooooo0_l0000`ooooo`03
o`000?oooooooooo02kooooo0_l0000_ooooo`Co0000L_ooool004_ooooo0ol0000^ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;?ooool2o`0002kooooo0ol0001fooooo`00C_oo
ool4o`0002_ooooo0_l0000]ooooo`03o`000?oooooooooo02[ooooo0_l0000/ooooo`Co0000NOoo
ool005;ooooo1?l0000Yooooo`;o0000:oooool00ol0003oooooooooo`0Xooooo`;o0000:_ooool4
o`0007gooooo001Fooooo`?o0000:?ooool2o`0002Wooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0Wooooo`?o0000POooool005Wooooo1?l0000Vooooo`;o00009oooool00ol0003o
ooooooooo`0Uooooo`;o00009_ooool4o`0008Cooooo001Mooooo`?o00009Oooool00ol0003ooooo
ooooo`0Tooooo`03o`000?oooooooooo02?ooooo0_l0000Uooooo`?o0000R?ooool0063ooooo1?l0
000Rooooo`;o00009?ooool00ol0003oooooooooo`0Qooooo`;o00008oooool4o`0008_ooooo001T
ooooo`?o00008Oooool2o`0002;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0P
ooooo`?o0000Soooool006Oooooo1?l0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Noooo
o`;o00007oooool4o`0009;ooooo001[ooooo`Co00007Oooool2o`0001kooooo00?o0000oooooooo
ool07?ooool2o`0001gooooo1?l0002Fooooo`00Koooool3o`0001cooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0Jooooo`;o00007?ooool3o`0009[ooooo001booooo`Co00006Ooo
ool2o`0001_ooooo00?o0000ooooooooool06?ooool2o`0001[ooooo1?l0002Mooooo`00M_ooool3
o`0001Sooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool3
o`000:7ooooo001iooooo`Co00005_ooool2o`0001Oooooo00?o0000ooooooooool05Oooool2o`00
01Kooooo1?l0002Tooooo`00OOooool3o`0001Gooooo0_l0000Eooooo`03o`000?oooooooooo01?o
oooo0_l0000Eooooo`?o0000Z?ooool0083ooooo1?l0000Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool2o`0001?ooooo1?l0002[ooooo`00Q?ooool4o`00013ooooo0_l0
000Booooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool4o`000:oooooo0028
ooooo`?o00003oooool2o`00013ooooo00?o0000ooooooooool03_ooool2o`0000oooooo0ol0002c
ooooo`00Roooool4o`0000gooooo0_l0000>ooooo`03o`000?oooooooooo00cooooo0_l0000=oooo
o`Co0000]_ooool008oooooo0ol0000<ooooo`;o00002Oooool6onKViP[ooooo0_l0000<ooooo`?o
0000^_ooool009;ooooo1?l0000:ooooo`03o`000?oooooooooo00Cooooo2_oVi^H7ooooo`03o`00
0?oooooooooo00Sooooo1?l0002mooooo`00U_ooool3o`0000Sooooo0_l00003ooooo`coi^KV1?oo
ool2o`0000Sooooo0ol00031ooooo`00VOooool4o`0000Kooooo0_l0000>onKViP03ooooool0003o
000000Kooooo1?l00034ooooo`00WOooool4o`0000?ooooo4?oVi^H4ooooo`Co0000b?ooool00:7o
oooo0ol0000@onKViP04ooooool0003o0000o`000<cooooo002Sooooo`Koi^KV1_l00006onKVi/oo
oooo002Sooooo`Soi^KV0_l00008onKVi/oooooo002Sooooo`Soi^KV0_l00008onKVi/oooooo002S
ooooo`Soi^KV0_l00008onKVi/oooooo002Sooooo`Ooi^KV1Ol00006onKVi/oooooo002Sooooo`So
i^KV0_l00008onKVi/oooooo002Tooooo`Soi^KV0ol00005onKVi]3ooooo002Toooooa3oi^KVd?oo
ool00:Gooooo3_oVi^KAooooo`00Y_ooool<onKVi];ooooo002Wooooo`[oi^KVdoooool00:Wooooo
1_oVi^KEooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.19697, -1.04247, \
0.0127428, 0.00453362}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.179 .21092 -5 -6 ]
[.179 .21092 5 6 ]
[.34481 .21092 -5 -6 ]
[.34481 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.65519 .21092 -5 -6 ]
[.65519 .21092 5 6 ]
[.6178 .01472 -5 -6 ]
[.6178 .01472 5 6 ]
[.85839 .01472 -5 -6 ]
[.85839 .01472 5 6 ]
[.7381 .21092 -5 -6 ]
[.7381 .21092 5 6 ]
[.70071 .01472 -5 -6 ]
[.70071 .01472 5 6 ]
[.9413 .01472 -5 -6 ]
[.9413 .01472 5 6 ]
[.821 .21092 -5 -6 ]
[.821 .21092 5 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.179 .21092 L
s
.2619 .40712 m
.34481 .21092 L
s
1 g
.05 w
.179 .21092 Mdot
0 g
gsave
.179 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.34481 .21092 Mdot
0 g
gsave
.34481 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.65519 .21092 L
s
.7381 .40712 m
.7381 .21092 L
s
.7381 .40712 m
.821 .21092 L
s
1 g
.05 w
.65519 .21092 Mdot
0 g
gsave
.65519 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .21092 m
.6178 .01472 L
s
.7381 .21092 m
.85839 .01472 L
s
1 g
.05 w
.6178 .01472 Mdot
0 g
gsave
.6178 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.85839 .01472 Mdot
0 g
gsave
.85839 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.7381 .21092 Mdot
0 g
gsave
.7381 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.821 .21092 m
.70071 .01472 L
s
.821 .21092 m
.9413 .01472 L
s
1 g
.05 w
.70071 .01472 Mdot
0 g
gsave
.70071 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.9413 .01472 Mdot
0 g
gsave
.9413 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.821 .21092 Mdot
0 g
gsave
.821 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00k?ooool5o`0001Wooooo1Ol0000gooooo`Co0000
6oooool4o`0001_ooooo003[ooooo`;o000000?oooooo`000?l000006oooool2o`000003ooooool0
003o000003Gooooo0_l00002ooooo`;o00006Oooool2o`0000;ooooo0_l0000Jooooo`00k?ooool4
o`0001_ooooo0_l000000ooooooo0000o`00000eooooo`;o00007Oooool2o`0001kooooo003[oooo
o`;o000000?oooooo`000?l000006oooool2o`000003ooooool0003o000003Gooooo0_l00002oooo
o`;o00006Oooool2o`0000;ooooo0_l0000Jooooo`00k?ooool3o`0001cooooo1?l0000gooooo`Co
00006oooool4o`0001_ooooo003oooooo`cooooo0_l0001gooooo`00ooooool;ooooo`?o0000Mooo
ool00?ooooooQOooool00?ooooooQOooool00?ooooooQOooool00??ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
7oooool00??ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool07oooool00?Cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool08?ooool0
0?Cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool08?ooool00?Gooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool08Oooool00?Kooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool08_ooool00?Kooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool08_ooool00?Oooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool08oooool00?Sooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool09?ooool00?Sooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool09?ooool00?Wooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool09Oooool00?Wooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool09Ooo
ool00?[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool09_ooool00?_ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool09oooool00?_o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool09oooool00?cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0:?ooool00?cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool0:?ooool00?gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0:Oooool00?kooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool0:_ooool00?kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0:_ooool00?oooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
:oooool00?oooooo0Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0/ooooo`00ooooool1ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo02cooooo003oooooo`;ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool0;Oooool00?oooooo0_ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0]ooooo`00ooooool3ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo02kooooo003oooooo`Cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool0;oooool00?oooooo1?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0_ooooo`00ooooool5oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo033ooooo003oooooo`Kooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0<Oooool00?oooooo
1_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0aooooo`00ooooool7ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo03;ooooo003o
ooooo`Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool0<_ooool00?oooooo2?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0coooo
o`00ooooool9ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo03Cooooo003oooooo`Wooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
=?ooool00?oooooo2_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0eooooo`00ooooool:ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo03Gooooo003oooooo`_ooooo00?o0000ooooooooool07?ooool01?l0003oooooooooool0000N
ooooo`03o`000?oooooooooo03Kooooo003oooooo`cooooo00?o0000ooooooooool07?ooool2o`00
01kooooo00?o0000ooooooooool0=oooool00?oooooo3?ooool00ol0003oooooooooo`0Looooo`;o
00007_ooool00ol0003oooooooooo`0gooooo`00ooooool=ooooo`03o`000?oooooooooo01_ooooo
0_l0000Mooooo`03o`000?oooooooooo03Sooooo003oooooo`kooooo00?o0000ooooooooool06Ooo
ool01?l0003oooooooooool0000Kooooo`03o`000?oooooooooo03Wooooo003oooooo`kooooo00?o
0000ooooooooool06Oooool01?l0003oooooooooool0000Kooooo`03o`000?oooooooooo03Wooooo
003oooooo`oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool0>_ooool00?oooooo3oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0j
ooooo`00ooooool@ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo03_ooooo003ooooooa7ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0??ooool00?oooooo4Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0looooo`00oooooolBooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo03gooooo003ooooooa;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0?Oooool00?oooooo4oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0nooooo`00oooooolDooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03oooooo003ooooooaCooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0?oooool00?oooooo5Oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`10ooooo`00oooooolF
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo047ooooo003ooooooaKooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0@Oooool00?oo
oooo5oooool00ol0003oooooonKViP05onKViP;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooonKViP05onKViP;ooooo00?o0000ooooooooool0@_ooool00?oooooo5oooool:onKViP03o`00
0?oooooooooo01;ooooo2_oVi^H00ol0003oooooooooo`12ooooo`00oooooolFooooo`coi^KV4ooo
ool<onKViTCooooo003ooooooaGooooo3_oVi^HAooooo`koi^KV@oooool00?oooooo5?ooool6onKV
iPCo00001_oVi^H?ooooo`Koi^KV1?l00006onKViT;ooooo003ooooooaCooooo2OoVi^H2o`0000Go
i^KV3oooool9onKViP;o00001OoVi^I2ooooo`00A_ooool5o`0003[ooooo1?l0001aooooo`Co0000
5?ooool7onKViPGo00001_oVi^H=ooooo`Ooi^KV1Ol00006onKViT7ooooo0017ooooo`;o000000?o
ooooo`000?l00000>?ooool2o`0000;ooooo0_l0001_ooooo`;o00005oooool6onKViP;o00000_oV
i^H2o`0000Koi^KV3Oooool6onKViP;o00000_oVi^H2o`0000Koi^KV@Oooool004Oooooo0_l00000
0ooooooo0000o`00000looooo`;o0000Koooool6o`0001?ooooo1_oVi^H2o`0000;oi^KV0_l00006
onKViPgooooo1_oVi^H2o`0000;oi^KV0_l00006onKViT7ooooo0017ooooo`;o000000?oooooo`00
0?l00000>_ooool3o`00073ooooo0_l00002ooooo`;o00004oooool6onKViP;o00000_oVi^H2o`00
00Koi^KV3Oooool6onKViP;o00000_oVi^H2o`0000Koi^KV@Oooool004Oooooo1?l0000mooooo`;o
0000L?ooool4o`0001Cooooo1ooVi^H6o`0000Goi^KV3Oooool7onKViPKo00001OoVi^I1ooooo`00
Aoooool2o`0003_ooooo0_l00002ooooo`;o0000R?oooolBonKViPgooooo4_oVi^I1ooooo`00A_oo
ool3o`0003cooooo1?l0002:oooooa3oi^KV3oooool@onKViT;ooooo003ooooooaCooooo4?oVi^H?
oooooa3oi^KV@_ooool00?oooooo5Oooool>onKViQ7ooooo3_oVi^I3ooooo`00oooooolFooooo`co
i^KV4oooool<onKViTCooooo003ooooooaOooooo2_oVi^HEooooo`[oi^KVAOooool004gooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo01Gooooo1_oV
i^HHooooo`03o`000?oVi^Koi^KV00Coi^KVAoooool004gooooo00?o0000ooooooooool0<oooool0
0ol0003oooooooooo`1jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`1;ooooo`00COooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo
07[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
04_ooooo001>ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0O?ooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0C?ooool004kooooo
00?o0000ooooooooool0<Oooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`1<ooooo`00Coooool00ol0003ooooooooo
o`0_ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo04gooooo001?ooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0O_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000
ooooooooool0COooool004oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1noooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=oooo
o`00D?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo083ooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo04kooooo001@ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0P?ooool00ol0003oooooooooo`0Eooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool0C_ooool0057ooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`1?ooooo`00DOooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo08;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo04oooooo001Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Q?ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0D?ooool005;o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1@ooooo`00D_ooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo08Cooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo053ooooo001Cooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0Q_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool0DOooool005?ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`26
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`1A
ooooo`00E?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo08Sooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo05;ooooo001Dooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0R?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool0D_ooool005Gooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`1Cooooo`00EOooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo08[ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo05?ooooo001Eooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0R_ooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0Doooool0
05Kooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1Dooooo`00E_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo05Cooooo001Gooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool0S_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool0EOooool005Oooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`2>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`1Eooooo`00Eoooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo08kooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo05Gooooo001Hoooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool0T?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool0E_ooool005Sooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`2@ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`1Fooooo`00FOooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo09;ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo05Oooooo001Iooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0T_oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Eooo
ool005[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`2Dooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Hooooo`00F_ooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo05Sooooo001Jooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool0U?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool0F?ooool005_ooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`2Fooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1Iooooo`00Foooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo09Kooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Wooooo001L
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0V?ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0F_ooool005cooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1Jooooo`00G?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo09Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo05[ooooo001Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
V_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
Foooool005gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`2Jooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Kooooo`00G_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo05cooooo001Nooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0G?ooool005oooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`2Nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1Mooooo`00Goooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo09kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05gooooo
001Oooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0W_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0GOooool0063ooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`1Nooooo`00H?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo05kooooo001Qooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0X_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0Goooool0067ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Rooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Oooooo`00H_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo063ooooo001Rooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0H?ooool006;ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`2Tooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`1Pooooo`00Hoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:Ko
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo067o
oooo001Sooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0HOooool006Cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`2Xooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`1Rooooo`00I?ooool00ol0003oi^KVonKViP04onKViP03ooooool0
003ooooo0:Wooooo00?o0000onKVi_oVi^H01?oVi^H00ooooooo0000ooooo`1Sooooo`00Hoooool:
onKViZWooooo2_oVi^ITooooo`00H_ooool<onKViZOooooo3?oVi^ISooooo`00HOooool>onKViZGo
oooo3_oVi^IRooooo`00H?ooool@onKViZ?ooooo4?oVi^IQooooo`00H?ooool6onKViPCo00001_oV
i^JSoooooa3oi^KVHOooool005oooooo2_oVi^H2o`0000Koi^KVXOoooolBonKViV3ooooo000=oooo
o`Go0000COooool7onKViPGo00001_oVi^I>ooooo`Co0000Coooool6onKViPOo00001OoVi^I=oooo
o`Ko00003Oooool000cooooo0_l000000ooooooo0000o`00001>ooooo`Koi^KV0_l00002onKViP;o
00001_oVi^I=ooooo`;o00000_ooool2o`0004kooooo1ooVi^H2o`000003onKVi_l0003o000000Ko
i^KVC_ooool2o`000003ooooool0003o000000gooooo000=ooooo`Co0000C_ooool6onKViP;o0000
0_oVi^H2o`0000Koi^KVCOooool2o`0005;ooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV
Coooool2o`0000oooooo000<ooooo`;o000000?oooooo`000?l00000C_ooool6onKViP;o00000_oV
i^H2o`0000Koi^KVCOooool2o`0000;ooooo0_l0001>ooooo`Ooi^KV0_l000000ooVi^Ko0000o`00
0006onKViU3ooooo0_l0000>ooooo`003Oooool3o`0004oooooo1ooVi^H6o`0000Goi^KVC_ooool4
o`0004oooooo1ooVi^H4o`0000Ooi^KVCOooool2o`0000;ooooo0_l0000=ooooo`005oooool2o`00
04Oooooo4?oVi^JSooooo`Koi^KV0_l00008onKViTSooooo00?o0000ooooooooool00oooool2o`00
00;ooooo0_l0000=ooooo`006Oooool2o`0004Gooooo4?oVi^JSooooo`Goi^KV0ol00008onKViTKo
oooo0_l00007ooooo`Co00003_ooool001_ooooo0_l00014ooooo`koi^KV00?o0000ooooooooool0
X_ooool>onKViTGooooo0_l0000Kooooo`007Oooool3o`0004;ooooo3?oVi^H2ooooo`03o`000?oo
oooooooo0:3ooooo00?o0000oooooooVi^H02ooVi^I3ooooo`?o00007Oooool0023ooooo0_l00011
ooooo`[oi^KV1?ooool00ol0003oooooooooo`2Nooooo`04o`000?ooooooooooooooo`[oi^KV@_oo
ool2o`00023ooooo000Rooooo`?o0000@?ooool6onKViPOooooo00?o0000ooooooooool0W?ooool0
0ol0003oooooooooo`04ooooo`Koi^KV@Oooool3o`0002;ooooo000Uooooo`;o0000C?ooool2o`00
04cooooo00?o0000ooooooooool0Boooool2o`0004cooooo0_l0000Uooooo`009oooool3o`0004_o
oooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04Wo
oooo0ol0000Wooooo`00:_ooool2o`0004[ooooo00?o0000ooooooooool0B?ooool00ol0003ooooo
ooooo`19ooooo`03o`000?oooooooooo04Sooooo0_l0000Zooooo`00;?ooool2o`0004Wooooo00?o
0000ooooooooool0Aoooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04Kooooo0ol0
000/ooooo`00;_ooool3o`0004Oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`16
ooooo`;o0000Aoooool2o`0002oooooo000aooooo`;o0000A_ooool2o`0004Kooooo00?o0000oooo
ooooool0AOooool00ol0003oooooooooo`14ooooo`?o0000<Oooool003?ooooo0ol00015ooooo`03
o`000?oooooooooo04?ooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`13ooooo`;o
0000=?ooool003Kooooo0_l00014ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0
@oooool00ol0003oooooooooo`12ooooo`;o0000=_ooool003Sooooo0ol00012ooooo`03o`000?oo
oooooooo047ooooo00?o0000ooooooooool0@Oooool2o`0004;ooooo0ol0000hooooo`00>oooool2
o`00047ooooo0_l00011ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool2
o`0003_ooooo000mooooo`?o0000@?ooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo
03oooooo00?o0000ooooooooool0?_ooool3o`0003gooooo0010ooooo`;o0000?oooool00ol0003o
ooooooooo`0mooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0?Oooool2o`00043o
oooo0012ooooo`;o0000?_ooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo03cooooo
0_l0000mooooo`?o0000@_ooool004Cooooo0ol0000looooo`03o`000?oooooooooo03_ooooo00?o
0000ooooooooool0>oooool00ol0003oooooooooo`0kooooo`;o0000AOooool004Oooooo0_l0000k
ooooo`;o0000>oooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo03Wooooo0ol00017
ooooo`00BOooool3o`0003[ooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0ioooo
o`03o`000?oooooooooo03Sooooo0_l0001:ooooo`00C?ooool2o`0003Wooooo00?o0000oooooooo
ool0=oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Kooooo0ol0001<ooooo`00
C_ooool3o`0003Oooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0fooooo`;o0000
=oooool2o`0004oooooo001Aooooo`;o0000=_ooool2o`0003Kooooo00?o0000ooooooooool0=Ooo
ool00ol0003oooooooooo`0eooooo`;o0000DOooool005?ooooo0_l0000fooooo`03o`000?oooooo
oooo03?ooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0cooooo`?o0000Doooool0
05Gooooo0ol0000dooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<oooool00ol0
003oooooooooo`0booooo`;o0000E_ooool005Sooooo0_l0000cooooo`03o`000?oooooooooo037o
oooo00?o0000ooooooooool0<Oooool2o`0003;ooooo0ol0001Hooooo`00F_ooool3o`00037ooooo
00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo
0_l0001Kooooo`00GOooool2o`00033ooooo0_l0000`ooooo`03o`000?oooooooooo02oooooo00?o
0000ooooooooool0;_ooool3o`0005gooooo001Oooooo`?o0000;oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool2o`00063ooooo001Roooo
o`;o0000;_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo0_l0000]oooo
o`?o0000H_ooool006Cooooo0ol0000/ooooo`03o`000?oooooooooo02_ooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`0[ooooo`;o0000IOooool006Oooooo0_l0000[ooooo`;o0000
:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo0ol0001Wooooo`00JOoo
ool2o`0002_ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo02Sooooo0_l0001Zooooo`00Joooool3o`0002Wooooo00?o0000ooooooooool09oooool0
0ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Oooooo0_l0001/ooooo`00K_ooool2o`00
02Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`00
06kooooo001`ooooo`?o00009_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool09Oooool2o`00077ooooo001cooooo`;o00009Oooool2o`0002Gooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`?o0000Loooool007Gooooo0ol0
000Tooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0Rooooo`;o0000M_ooool007Sooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool08Oooool2o`0002;ooooo0ol0001hooooo`00N_ooool3o`00027ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0_l0001koooo
o`00OOooool2o`00023ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo01kooooo0ol0001mooooo`00Ooooool2o`0001oooooo0_l0000Oooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool07Oooool2o`00083ooooo0021ooooo`?o00007_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo0_l0000Nooooo`;o0000P_oo
ool008Cooooo0_l0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`?o0000Q?ooool008Kooooo0ol0000Kooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`;o0000Qoooool008Wo
oooo0_l0000Jooooo`;o00006_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01So
oooo0ol00029ooooo`00Roooool3o`0001Wooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo01Oooooo0_l0002<ooooo`00S_ooool2o`0001Sooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`;o00005oooool3o`0008kooooo002@
ooooo`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool05Oooool2o`00097ooooo002Booooo`?o00005Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool04oooool3o`0009?ooooo002Eooooo`;o
00005?ooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`;o
0000U_ooool009Oooooo0ol0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool2o`0001;ooooo0ol0002Hooooo`00V_ooool2o`0001;ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo0_l0002Kooooo`00W?ooool3
o`00013ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo00oooooo0_l0002Mooooo`00Woooool2o`0000oooooo0_l0000?ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool03Oooool3o`0009oooooo002Qooooo`?o00003_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0_l0000>ooooo`;o0000X_ooool00:Cooooo
0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`?o0000Y?ooool00:Kooooo0_l0000<ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`;o0000Yoooool00:Sooooo0ol0000:
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`?o0000ZOooool00:_ooooo0_l00009ooooo`;o00002Oooool00ol0003oooooooooo`07oooo
o`;o00002Oooool2o`000:cooooo002]ooooo`?o00002?ooool00ol0003oooooooooo`04ooooo`Ko
i^KV1Oooool00ol0003oooooooooo`06ooooo`?o0000[_ooool00;3ooooo0_l00007ooooo`04o`00
0?ooooooooooooooo`[oi^KV0_ooool00ol0003oooooooooo`05ooooo`;o0000/Oooool00;;ooooo
0ol00005ooooo`03o`000?ooooooi^KV00_oi^KV00?o0000ooooooooool00oooool3o`000;?ooooo
002eooooo`;o00001?ooool>onKViP?ooooo0_l0002fooooo`00]oooool2o`000003oooooooVi^Ko
i^KV00koi^KV0_l0002hooooo`00^Oooool00ol0003oi^KVonKViP0>onKVi[[ooooo002iooooo`Go
i^KV1_l00007onKVi[Wooooo002iooooo`Ooi^KV0_l00009onKVi[Wooooo002iooooo`Ooi^KV0_l0
0009onKVi[Wooooo002iooooo`Ooi^KV0_l00009onKVi[Wooooo002iooooo`Koi^KV1Ol00007onKV
i[Wooooo002iooooo`Ooi^KV0_l00009onKVi[Wooooo002jooooo`Ooi^KV0ol00006onKVi[[ooooo
002joooooa3oi^KV^_ooool00;_ooooo3_oVi^Jkooooo`00_?ooool<onKVi[cooooo002mooooo`[o
i^KV_Oooool00;oooooo1_oVi^Joooooo`00\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17325, -0.625483, \
0.0112077, 0.00272017}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.80041 .01472 -5 -6 ]
[.80041 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.80041 .01472 Mdot
0 g
gsave
.80041 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{388.812, 240.312},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->1.00948,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000640000l2000`400?l00000o`00003ooooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5ooooo`00oooooon5
ooooo`00oooooon5ooooo`00oooooon5ooooo`00kOooool5o`0003kooooo1Ol0000mooooo`Co0000
3_ooool00>kooooo0_l000000ooooooo0000o`00000looooo`;o000000?oooooo`000?l00000?Ooo
ool2o`0000;ooooo0_l0000=ooooo`00k_ooool2o`000003ooooool0003o000003gooooo1?l00011
ooooo`;o00003Oooool00>kooooo0_l000000ooooooo0000o`00000looooo`;o000000?oooooo`00
0?l00000@Oooool2o`0000gooooo003^ooooo`Co0000?_ooool3o`0003kooooo1Ol0000>ooooo`00
k_ooool2o`00087ooooo0_l0000Aooooo`00kOooool3o`00087ooooo1_l0000=ooooo`00oooooon5
ooooo`00oooooon5ooooo`00m_ooool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo01?o
oooo003gooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool05?ooool00?Sooooo00?o
0000ooooooooool0=oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo01Gooooo003i
ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0F
ooooo`00nOooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Kooooo00?o0000oooo
ooooool05_ooool00?[ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo01Oooooo003kooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0
=?ooool00ol0003oooooooooo`0Hooooo`00o?ooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool06Oooool00?gooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo01[ooooo003nooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Kooooo`00ooooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool07?ooool00?oooooo
0Oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
7Oooool00?oooooo0_ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o
0000ooooooooool07_ooool00?oooooo0oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool07oooool00?oooooo1?ooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo02cooooo00?o0000ooooooooool08?ooool00?oooooo1?ooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool08?ooool00?oooooo
1Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
8Oooool00?oooooo1_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool08_ooool00?oooooo1oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool08oooool00?oooooo2?ooool00ol0003oooooooooo`0Xoooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooooooool09?ooool00?oooooo2Oooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09Oooool00?oooooo
2_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
9_ooool00?oooooo2oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool09oooool00?oooooo3?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool0:?ooool00?oooooo3Oooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0:Oooool00?oooooo3Oooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0:Oooool00?oooooo
3_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
:_ooool00?oooooo3oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool0:oooool00?oooooo4?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0;?ooool00?oooooo4Oooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0;Oooool00?oooooo4_ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0;_ooool00?oooooo
4oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
;oooool00?oooooo5?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool0<?ooool00?oooooo5Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool0<Oooool00?oooooo5_ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0<_ooool00?oooooo5oooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0<oooool00?oooooo
5oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
<oooool00?oooooo6?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool0=?ooool00?oooooo6Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0=Oooool00?oooooo6_ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0=_ooool00?oooooo6oooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0=oooool00?oooooo
7?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0
>?ooool00?oooooo7Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0>Oooool00?oooooo7_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0>_ooool00?oooooo7oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool0>oooool00?oooooo8?ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0??ooool00?oooooo
8?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
??ooool00?oooooo8Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0?Oooool00?oooooo8_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool0?_ooool00?oooooo8oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool0?oooool00?oooooo9?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0@?ooool00?oooooo
9Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
@Oooool00?oooooo9_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0@_ooool00?oooooo9oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0@oooool00?oooooo:?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0A?ooool00?oooooo:Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0AOooool00?oooooo
:_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
A_ooool00?oooooo:_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0A_ooool00?oooooo:oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool0
0ol0003oooooooooo`17ooooo`00ooooool/ooooo`03o`000?ooooooi^KV00Woi^KV0_ooool00ol0
003oooooooooo`18ooooo`00ooooool]ooooo`coi^KV00?o0000ooooooooool0BOooool00?oooooo
;?ooool>onKViT_ooooo003oooooob_ooooo1_oVi^H4o`0000Koi^KVB_ooool00?oooooo:oooool9
onKViP;o00001OoVi^I:ooooo`00AOooool5o`0003Sooooo1?l0001]ooooo`Co0000<_ooool7onKV
iPGo00001_oVi^I9ooooo`00A_ooool2o`000003ooooool0003o000003Kooooo0_l00002ooooo`;o
0000Joooool2o`0003Gooooo1_oVi^H2o`0000;oi^KV0_l00006onKViTWooooo0016ooooo`;o0000
00?oooooo`000?l00000>_ooool2o`0006_ooooo1_l0000aooooo`Koi^KV0_l00002onKViP;o0000
1_oVi^I9ooooo`00A_ooool2o`000003ooooool0003o000003Sooooo0ol0001/ooooo`;o00000_oo
ool2o`00037ooooo1_oVi^H2o`0000;oi^KV0_l00006onKViTWooooo0016ooooo`Co0000>oooool2
o`0006cooooo1?l0000booooo`Ooi^KV1_l00005onKViTWooooo0016ooooo`;o0000>Oooool2o`00
00;ooooo0_l0002Roooooa;oi^KVBOooool004Gooooo0ol0000jooooo`Co0000Y?ooool@onKViT[o
oooo003oooooob_ooooo4?oVi^I:ooooo`00ooooool/ooooo`koi^KVBoooool00?oooooo;Oooool<
onKViTcooooo003oooooobkooooo2_oVi^I=ooooo`00Boooool00ol0003oooooooooo`2[ooooo`03
o`000?oooooooooo03?ooooo1_oVi^I?ooooo`00C?ooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo07Kooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`1Cooooo`00C?oo
ool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo07Kooooo00?o0000ooooooooool0<_oo
ool00ol0003oooooooooo`1Cooooo`00COooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo07Sooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`1Dooooo`00COooool00ol0
003oooooooooo`0_ooooo`03o`000?oooooooooo07Sooooo00?o0000ooooooooool0<?ooool00ol0
003oooooooooo`1Dooooo`00COooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo07Wo
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`1Dooooo`00C_ooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo07[ooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`1Eooooo`00C_ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo07[ooooo00?o
0000ooooooooool0;_ooool00ol0003oooooooooo`1Eooooo`00Coooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo07cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`1F
ooooo`00Coooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo07cooooo00?o0000oooo
ooooool0;?ooool00ol0003oooooooooo`1Fooooo`00D?ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo07kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Gooooo`00
D?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`1Gooooo`00D?ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo07oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1Gooooo`00DOooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo083ooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`1Hooooo`00DOooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
083ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`1Hooooo`00D_ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo08;ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`1Iooooo`00D_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo08;ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`1Iooooo`00D_ooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo08?ooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`1Iooooo`00Doooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo08Cooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`1Jooooo`00Doooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo08Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1Joooo
o`00E?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo08Kooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`1Kooooo`00E?ooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo08Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Kooooo`00E?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`1Kooooo`00EOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo08Sooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`1Looooo`00EOooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`1Looooo`00E_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo08[o
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Mooooo`00E_ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo08[ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`1Mooooo`00E_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo08_ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`1Mooooo`00Eoooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1N
ooooo`00Eoooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo08gooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`1Nooooo`00F?ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo08kooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`1Oooooo`00
F?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`1Oooooo`00F?ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo08oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1Oooooo`00FOooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo093ooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`1Pooooo`00FOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
097ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`1Pooooo`00F_ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo09;ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`1Qooooo`00F_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo09?ooooo
00?o0000ooooooooool05Oooool00ol0003oooooooooo`1Qooooo`00F_ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo09?ooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`1Qooooo`00Foooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo09Cooooo00?o0000
ooooooooool05?ooool00ol0003oooooooooo`1Rooooo`00Foooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo09Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Roooo
o`00G?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo09Kooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`1Sooooo`00G?ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo09Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Sooooo`00G?oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo09Oooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`1Sooooo`00GOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo09Wooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1Tooooo`00GOooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo09Wooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`1Tooooo`00G_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo09[o
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1Uooooo`00G_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`1Uooooo`00Goooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo09cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`1Vooooo`00Goooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1V
ooooo`00Goooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo09gooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`1Vooooo`00H?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo09oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Wooooo`00
H?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Wooooo`00HOooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo0:3ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Xooooo`00HOooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:7ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1Xooooo`00HOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
0:7ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Xooooo`00H_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0:?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`1Yooooo`00H_ooool00ol0003oi^KVonKViP04onKViP03ooooool0003ooooo0:Cooooo
00?o0000onKVi_oVi^H01?oVi^H00ooooooo0000ooooo`1Zooooo`00HOooool:onKViZCooooo2_oV
i^I[ooooo`00H?ooool<onKViZ;ooooo3?oVi^IZooooo`00Goooool>onKViZ3ooooo3_oVi^IYoooo
o`00G_ooool@onKViYkooooo4?oVi^IXooooo`00G_ooool6onKViPCo00001_oVi^JNoooooa3oi^KV
J?ooool005gooooo2_oVi^H2o`0000Koi^KVW?oooolBonKViVOooooo000=ooooo`Go0000Boooool7
onKViPGo00001_oVi^I<ooooo`Co0000C?ooool6onKViPOo00001OoVi^I;ooooo`Ko00005_ooool0
00cooooo0_l000000ooooooo0000o`00001<ooooo`Koi^KV0_l00002onKViP;o00001_oVi^I;oooo
o`;o00000_ooool2o`0004_ooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KVC?ooool2o`00
0003ooooool0003o000001Kooooo000=ooooo`Co0000C?ooool6onKViP;o00000_oVi^H2o`0000Ko
i^KVBoooool2o`0004oooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KVCOooool2o`0001So
oooo000<ooooo`;o000000?oooooo`000?l00000C?ooool6onKViP;o00000_oVi^H2o`0000Koi^KV
Boooool2o`0000;ooooo0_l0001;ooooo`Ooi^KV0_l000000ooVi^Ko0000o`000006onKViTkooooo
0_l0000Gooooo`003Oooool3o`0004gooooo1ooVi^H6o`0000Goi^KVC?ooool4o`0004cooooo1ooV
i^H4o`0000Ooi^KVBoooool2o`0000;ooooo0_l0000Fooooo`005oooool00ol0003oooooooooo`14
oooooa3oi^KVW_ooool6onKViP;o00002?oVi^I<ooooo`;o00000_ooool2o`0001Kooooo000Hoooo
o`?o0000@oooool@onKViYkooooo1OoVi^H3o`0000Soi^KVA?ooool3o`0000Kooooo1?l0000Goooo
o`006oooool2o`0004;ooooo3_oVi^H00ol0003oooooooooo`2Mooooo`koi^KV@oooool2o`0002Co
oooo000Mooooo`;o0000@Oooool<onKViP;ooooo00?o0000ooooooooool0Voooool00ol0003ooooo
onKViP0;onKViT;ooooo0_l0000Vooooo`007oooool3o`0003oooooo2_oVi^H4ooooo`03o`000?oo
oooooooo09Wooooo00Co0000oooooooooooooooo2_oVi^I0ooooo`?o0000:?ooool002;ooooo0_l0
000oooooo`Koi^KV1oooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00Cooooo1_oV
i^I0ooooo`;o0000:oooool002Cooooo0ol0001:ooooo`03o`000?oooooooooo04Wooooo00?o0000
ooooooooool0BOooool00ol0003oooooooooo`18ooooo`?o0000;Oooool002Oooooo0_l00019oooo
o`;o0000BOooool00ol0003oooooooooo`17ooooo`;o0000BOooool2o`00033ooooo000Yooooo`;o
0000BOooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo04Kooooo00?o0000oooooooo
ool0Aoooool2o`0003;ooooo000[ooooo`?o0000Aoooool00ol0003oooooooooo`15ooooo`03o`00
0?oooooooooo04Gooooo00?o0000ooooooooool0AOooool3o`0003Cooooo000^ooooo`;o0000A_oo
ool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool0A?oo
ool2o`0003Oooooo000`ooooo`?o0000A?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooo
oooo04?ooooo00?o0000ooooooooool0@_ooool3o`0003Wooooo000cooooo`;o0000@oooool00ol0
003oooooooooo`12ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@Oooool2o`00
03cooooo000eooooo`;o0000@_ooool2o`0004;ooooo00?o0000ooooooooool0@?ooool2o`0004;o
oooo0_l0000nooooo`00=oooool3o`00047ooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`0oooooo`03o`000?oooooooooo03oooooo0ol00010ooooo`00>_ooool2o`00043ooooo00?o
0000ooooooooool0?_ooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo03kooooo0_l0
0013ooooo`00??ooool2o`0003oooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0m
ooooo`03o`000?oooooooooo03gooooo0_l00015ooooo`00?_ooool3o`0003gooooo00?o0000oooo
ooooool0??ooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo03_ooooo0ol00017oooo
o`00@Oooool2o`0003cooooo0_l0000looooo`03o`000?oooooooooo03[ooooo0_l0000looooo`;o
0000B_ooool004?ooooo0ol0000kooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0
>Oooool00ol0003oooooooooo`0iooooo`?o0000C?ooool004Kooooo0_l0000jooooo`03o`000?oo
oooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0hooooo`;o0000Cooo
ool004Sooooo0_l0000iooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool0
0ol0003oooooooooo`0gooooo`;o0000DOooool004[ooooo0ol0000gooooo`03o`000?oooooooooo
03Kooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0eooooo`?o0000Doooool004go
oooo0_l0000fooooo`;o0000=_ooool00ol0003oooooooooo`0dooooo`;o0000=_ooool2o`0005Ko
oooo001?ooooo`?o0000=Oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool0<oooool3o`0005Sooooo001Booooo`;o0000=?ooool00ol0003ooooooooo
o`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool2o`0005_ooooo001D
ooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000
ooooooooool0<Oooool2o`0005gooooo001Fooooo`?o0000<Oooool00ol0003oooooooooo`0`oooo
o`03o`000?oooooooooo033ooooo00?o0000ooooooooool0;oooool3o`0005oooooo001Iooooo`;o
0000<?ooool2o`00033ooooo00?o0000ooooooooool0;_ooool2o`00033ooooo0_l0001Rooooo`00
Foooool2o`00033ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo02kooooo0_l0001Tooooo`00GOooool3o`0002kooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo0ol0001Vooooo`00H?ooool2
o`0002gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02_ooooo0_l0001Yooooo`00H_ooool3o`0002_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo0ol0001[ooooo`00IOooool2o`0002[o
oooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo0_l0000Zooooo`;o0000K_ooool006Oooooo
0_l0000Zooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Xooooo`;o0000L?ooool006Wooooo0ol0000Xooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`?o0000L_ooool006cooooo0_l0000W
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0U
ooooo`;o0000MOooool006kooooo0ol0000Uooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool09?ooool00ol0003oooooooooo`0Sooooo`?o0000Moooool0077ooooo0_l0000Tooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Rooooo`;o
0000N_ooool007?ooooo0_l0000Sooooo`;o00008oooool00ol0003oooooooooo`0Qooooo`;o0000
8oooool2o`0007cooooo001eooooo`?o00008_ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo023ooooo00?o0000ooooooooool08?ooool3o`0007kooooo001hooooo`;o00008Oooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool2
o`00087ooooo001jooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool07_ooool2o`0008?ooooo001looooo`?o00007_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool3o`0008Go
oooo001oooooo`;o00007Oooool2o`0001gooooo00?o0000ooooooooool06oooool2o`0001gooooo
0_l00028ooooo`00POooool3o`0001cooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01[ooooo0ol0002:ooooo`00Q?ooool2o`0001_ooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0_l0002=
ooooo`00Q_ooool2o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo01Sooooo0_l0002?ooooo`00R?ooool3o`0001Sooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Kooooo0ol0002Aooooo`00
Roooool2o`0001Oooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo0_l0000Gooooo`;o0000
U?ooool008gooooo0ol0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`0Dooooo`?o0000U_ooool0093ooooo0_l0000Eooooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`;o0000VOooool0
09;ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`;o0000Voooool009Cooooo0ol0000Booooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`?o0000WOooool009Oooooo
0_l0000Aooooo`;o00004Oooool00ol0003oooooooooo`0?ooooo`;o00004Oooool2o`000:3ooooo
002Iooooo`;o00004Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o
0000ooooooooool03oooool2o`000:;ooooo002Kooooo`?o00003oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool3o`000:Cooooo002Noooo
o`;o00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool03?ooool2o`000:Oooooo002Pooooo`?o00003?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool3o`000:Wooooo002Sooooo`;o0000
2oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool2o`000:cooooo002Uooooo`;o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?oo
ool2o`0000[ooooo0_l0002^ooooo`00Yoooool3o`0000Wooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0ol0002`ooooo`00Z_ooool2o`00
00Sooooo00?o0000ooooooooool00oooool6onKViPKooooo00?o0000ooooooooool01_ooool2o`00
0;?ooooo002/ooooo`?o00001_ooool00ol0003oooooooooo`0:onKViP?ooooo00?o0000oooooooo
ool01?ooool3o`000;Gooooo002_ooooo`;o00001Oooool00ol0003oi^KVonKViP0:onKViP03oooo
ool0003ooooo00Cooooo0_l0002hooooo`00/Oooool2o`0000?ooooo3_oVi^H4ooooo`;o0000^_oo
ool00;?ooooo0_l0000@onKViP?o0000_?ooool00;Gooooo4?oVi^Joooooo`00]?ooool6onKViPKo
00001_oVi^Jnooooo`00]?ooool8onKViP;o00002?oVi^Jnooooo`00]?ooool8onKViP;o00002?oV
i^Jnooooo`00]?ooool8onKViP;o00002?oVi^Jnooooo`00]?ooool7onKViPGo00001_oVi^Jnoooo
o`00]?ooool8onKViP;o00002?oVi^Jnooooo`00]Oooool8onKViP?o00001OoVi^Joooooo`00]Ooo
ool@onKVi[oooooo002fooooo`koi^KV`?ooool00;Oooooo3?oVi^K1ooooo`00^?ooool:onKVi/;o
oooo002jooooo`Koi^KVa?ooool00001\
\>"],
  ImageRangeCache->{{{0, 387.812}, {239.312, 0}} -> {-2.17784, -0.625483, \
0.011505, 0.00272017}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Recombination - Intro"],

Cell[CellGroupData[{

Cell["Templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
patterns =
{
  f[__, _g, __, _h, __],
  
  g[a | b | c, __],
  
  h[_Integer | _Symbol, __g],
  
  a, b, c, d, e,
  
  Sequence @@ Range[1,5]
};\
\>", "Input",
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating S-expression chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos =
createChromosomes[2, 
                 StartPattern -> _f,
                 SequenceRange -> {1,2},
                 MaxDepth -> 6,
                 ExprPatterns -> patterns]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> .2];", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.66907 .21092 -5 -6 ]
[.66907 .21092 5 6 ]
[.68205 .01472 -5 -6 ]
[.68205 .01472 5 6 ]
[.93219 .01472 -5 -6 ]
[.93219 .01472 5 6 ]
[.80712 .21092 -5 -6 ]
[.80712 .21092 5 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
gsave
.66907 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .21092 m
.68205 .01472 L
s
.80712 .21092 m
.93219 .01472 L
s
1 g
.05 w
.68205 .01472 Mdot
0 g
gsave
.68205 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.93219 .01472 Mdot
0 g
gsave
.93219 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80712 .21092 Mdot
0 g
gsave
.80712 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{444.625, 274.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006l00014R000`400?l00000o`00003ooooooonm
ooooo`00oooooonmooooo`00oooooonmooooo`00oooooonmooooo`00oooooonmooooo`00oooooonm
ooooo`00oooooonmooooo`00oooooonmooooo`00oooooolZooooo`Co0000J?ooool4o`0002?ooooo
003oooooobWooooo0_l00002ooooo`;o0000I_ooool2o`0000;ooooo0_l0000Rooooo`00oooooolY
ooooo`;o0000K_ooool2o`0002;ooooo003oooooobWooooo0_l00002ooooo`;o0000J_ooool2o`00
02;ooooo003oooooob[ooooo1?l0001Wooooo`Go00008oooool00?ooooooUOooool2o`0002Kooooo
003ooooooiGooooo1_l0000Rooooo`00oooooonmooooo`00oooooonmooooo`00oooooonmooooo`00
oooooonmooooo`00oooooonmooooo`00oooooolbooooo`03o`000?oooooooooo08Sooooo003ooooo
oc?ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0Yooooo`00oooooolcooooo`03
o`000?oooooooooo05_ooooo00?o0000ooooooooool0:Oooool00?oooooo=?ooool00ol0003ooooo
ooooo`1Iooooo`03o`000?oooooooooo02[ooooo003oooooocGooooo00?o0000ooooooooool0Eooo
ool00ol0003oooooooooo`0[ooooo`00ooooooleooooo`03o`000?oooooooooo05Oooooo00?o0000
ooooooooool0:oooool00?oooooo=_ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo
02cooooo003oooooocKooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0/ooooo`00
oooooolgooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool0;Oooool00?oooooo>?oo
ool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo02kooooo003oooooocSooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0^ooooo`00ooooooliooooo`03o`000?oooooooooo
04oooooo00?o0000ooooooooool0;oooool00?oooooo>_ooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo033ooooo003ooooooc[ooooo00?o0000ooooooooool0COooool00ol0003ooooo
ooooo`0`ooooo`00oooooolkooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0<Ooo
ool00?oooooo??ooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo03;ooooo003ooooo
occooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0booooo`00oooooolmooooo`03
o`000?oooooooooo04Oooooo00?o0000ooooooooool0<oooool00?oooooo?Oooool00ol0003ooooo
ooooo`17ooooo`03o`000?oooooooooo03?ooooo003oooooockooooo00?o0000ooooooooool0AOoo
ool00ol0003oooooooooo`0dooooo`00ooooooloooooo`03o`000?oooooooooo04?ooooo00?o0000
ooooooooool0=Oooool00?oooooo?oooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo
03Gooooo003ooooood3ooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`0fooooo`00
oooooom1ooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool0=oooool00?oooooo@Ooo
ool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo03Oooooo003ooooood;ooooo00?o0000
ooooooooool0?Oooool00ol0003oooooooooo`0hooooo`00oooooom3ooooo`03o`000?oooooooooo
03_ooooo00?o0000ooooooooool0>Oooool00?oooooo@oooool00ol0003oooooooooo`0kooooo`03
o`000?oooooooooo03Wooooo003oooooodCooooo00?o0000ooooooooool0>Oooool00ol0003ooooo
ooooo`0jooooo`00oooooom4ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0>_oo
ool00?ooooooAOooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo03_ooooo003ooooo
odKooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0looooo`00oooooom6ooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool0??ooool00?ooooooAoooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo03gooooo003oooooodSooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`0nooooo`00oooooom8ooooo`03o`000?oooooooooo037ooooo00?o0000
ooooooooool0?_ooool00?ooooooBOooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo
03oooooo003ooooood[ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`10ooooo`00
oooooom:ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0@?ooool00?ooooooBooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo047ooooo003ooooood_ooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`11ooooo`00oooooom<ooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool0@_ooool00?ooooooCOooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo04?ooooo003oooooodgooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`13ooooo`00oooooom>ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0A?oo
ool00?ooooooCoooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo04Gooooo003ooooo
odoooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`15ooooo`00oooooom@ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0A_ooool00?ooooooDOooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo04Oooooo003ooooooe7ooooo00?o0000ooooooooool07ooo
ool00ol0003oooooooooo`17ooooo`00oooooomBooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0B?ooool00?ooooooD_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
04Sooooo003ooooooe?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`19ooooo`00
oooooomDooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0B_ooool00?ooooooE?oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo04[ooooo003ooooooeGooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`1;ooooo`00oooooomFooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool0C?ooool00?ooooooE_ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo04cooooo003ooooooeOooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`1=ooooo`00oooooomHooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0C_oo
ool00?ooooooF?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo04kooooo003ooooo
oeWooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1?ooooo`00oooooomIooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0Coooool00?ooooooF_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo053ooooo003ooooooe_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1Aooooo`00oooooomKooooo`04o`000?ooooooooooooooo`Ooi^KV0ooo
ool00ol0003oooooooooo`1Aooooo`00oooooomLooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000
ooooooooool0D_ooool00?ooooooG?ooool=onKViUCooooo003ooooooe_ooooo3ooVi^ICooooo`00
oooooomJoooooa7oi^KVD_ooool00?ooooooFOoooolConKViU7ooooo003ooooooeWooooo1ooVi^H4
o`0000Soi^KVDOooool00?ooooooF?ooool;onKViP;o00002?oVi^I@ooooo`00Eoooool5o`0003So
oooo1?l0002<ooooo`Co0000;oooool8onKViPGo00002?oVi^I@ooooo`00F?ooool2o`000003oooo
ool0003o000003Sooooo0_l0002<ooooo`;o0000<_ooool7onKViP;o00000_oVi^H2o`0000Soi^KV
D?ooool005Sooooo0_l000000ooooooo0000o`00000eooooo`Ko0000Roooool6o`0002kooooo1ooV
i^H2o`0000;oi^KV0_l00008onKViU3ooooo001Hooooo`;o000000?oooooo`000?l00000=Oooool2
o`000003ooooool0003o000008cooooo0_l00002ooooo`;o0000;_ooool7onKViP;o00000_oVi^H2
o`0000Soi^KVD?ooool005Sooooo1?l0000gooooo`Co0000SOooool4o`0002oooooo2?oVi^H6o`00
00Ooi^KVD?ooool005Sooooo0_l0000jooooo`?o0000`?oooolEonKViU3ooooo001Gooooo`?o0000
>oooool2o`000<7ooooo4ooVi^IAooooo`00oooooomIoooooa?oi^KVDOooool00?ooooooF_oooolA
onKViU;ooooo003ooooooe_ooooo3ooVi^ICooooo`00oooooomLooooo`goi^KVE?ooool00?oooooo
GOooool;onKViUGooooo001Mooooo`03o`000?oooooooooo0?kooooo1ooVi^IGooooo`00G_ooool0
0ol0003oooooooooo`0`ooooo`03o`000?oooooooooo09Kooooo00?o0000ooooooooool0<?ooool0
0ol0003oooooooooo`1Looooo`00G_ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
09Kooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`1Looooo`00G_ooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo09Kooooo00?o0000ooooooooool0<?ooool00ol0003o
ooooooooo`1Looooo`00Goooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo09Sooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`1Mooooo`00Goooool00ol0003ooooooooo
o`0^ooooo`03o`000?oooooooooo09Sooooo00?o0000ooooooooool0;_ooool00ol0003ooooooooo
o`1Mooooo`00Goooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo09Wooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Nooooo`00H?ooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`1Noooo
o`00H?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo09[ooooo00?o0000oooooooo
ool0;?ooool00ol0003oooooooooo`1Nooooo`00H?ooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo09_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1Oooooo`00HOoo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`1Oooooo`00HOooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo09cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Oooooo`00HOooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`1Pooooo`00H_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo09ko
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`1Pooooo`00H_ooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo09kooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`1Pooooo`00H_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo09oooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`1Qooooo`00Hoooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`1Q
ooooo`00Hoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0:3ooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`1Qooooo`00Hoooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo0:7ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1Rooooo`00
I?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo0:;ooooo00?o0000ooooooooool0
9?ooool00ol0003oooooooooo`1Rooooo`00I?ooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo0:?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1Sooooo`00IOooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`1Sooooo`00IOooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
0:Cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Sooooo`00IOooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`1Tooooo`00I_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool08?ooool00ol0003oooooooooo`1Tooooo`00I_ooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`1Tooooo`00I_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo0:Oooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`1Uooooo`00Ioooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Uoooo
o`00Ioooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`1Uooooo`00Ioooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo0:Wooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`1Vooooo`00J?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`1Vooooo`00J?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo0:[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Vooooo`00J?ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`1Wooooo`00JOooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0:co
oooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`1Wooooo`00JOooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo0:gooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`1Xooooo`00JOooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0:gooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`1Xooooo`00J_ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo0:kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1X
ooooo`00J_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo0:oooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`1Yooooo`00J_ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo0:oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`1Yooooo`00
Joooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;3ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`1Yooooo`00Joooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo0;7ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1Zooooo`00Joooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0;7ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`1Zooooo`00K?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
0;;ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`1Zooooo`00K?ooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`1[ooooo`00K?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0;?ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`1[ooooo`00KOooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo0;Cooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`1[ooooo`00KOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0;Gooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`1/ooooo`00K_ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`1/oooo
o`00K_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0;Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`1]ooooo`00K_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo0;Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1]ooooo`00Kooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`1]ooooo`00Koooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo0;Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1^ooooo`00Koooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`1^ooooo`00L?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0;[o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1^ooooo`00L?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo0;_ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`1_ooooo`00L?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0;_ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`1_ooooo`00LOooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo0;cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1_
ooooo`00LOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0;gooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1`ooooo`00LOooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo0;gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1`ooooo`00
L_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0;kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`1`ooooo`00L_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo0;oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1aooooo`00L_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0;oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1aooooo`00Loooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0<7ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1booooo`00Loooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0<7ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`1booooo`00Loooool00ol0003oi^KVonKViP05onKViP03o`000?oooooooooo0<7ooooo
00?o0000onKVi_oVi^H01OoVi^H00ol0003oooooooooo`1booooo`00L_ooool;onKVi/7ooooo2ooV
i^Icooooo`00LOooool=onKVi[oooooo3OoVi^Ibooooo`00L?ooool?onKVi[gooooo3ooVi^Iaoooo
o`00KooooolAonKVi[_ooooo4OoVi^I`ooooo`00K_oooolConKVi[Wooooo4ooVi^I_ooooo`00K_oo
ool7onKViPCo00002?oVi^Jioooooa?oi^KVKoooool006gooooo2ooVi^H2o`0000Soi^KV]ooooolE
onKViVkooooo000@ooooo`Co0000FOooool8onKViPGo00002?oVi^IIooooo`Co0000F_ooool7onKV
iPOo00001ooVi^IIooooo`Go00004?ooool0017ooooo0_l0001Jooooo`Ooi^KV0_l00002onKViP;o
00002?oVi^IHooooo`;o0000GOooool8onKViP;o000000?oi^KVo`000?l000002?oVi^IHooooo`;o
000000?oooooo`000?l000004Oooool000kooooo1_l0001Iooooo`Ooi^KV0_l00002onKViP;o0000
2?oVi^IHooooo`Ko0000FOooool8onKViP;o000000?oi^KVo`000?l000002?oVi^IIooooo`Co0000
4Oooool000kooooo0_l000000ooooooo0000o`00001Jooooo`Ooi^KV0_l00002onKViP;o00002?oV
i^IHooooo`;o00000_ooool2o`0005Wooooo2?oVi^H2o`000003onKVi_l0003o000000Soi^KVF?oo
ool2o`000003ooooool0003o0000017ooooo000?ooooo`Co0000F_ooool8onKViPKo00001ooVi^II
ooooo`Co0000F_ooool8onKViPCo00002OoVi^IIooooo`?o00004_ooool0013ooooo0ol0001Joooo
oaGoi^KV]oooool8onKViP;o00002ooVi^I^ooooo`004Oooool2o`0000Sooooo0_l0001Aoooooa?o
i^KV^Oooool6onKViP?o00002_oVi^IAooooo`;o00007?ooool001gooooo0_l0001?oooooa?oi^KV
^OoooolConKViToooooo0_l0000Nooooo`007oooool3o`0004gooooo4OoVi^Jkoooooa7oi^KVCOoo
ool3o`00023ooooo000Rooooo`;o0000C?ooool?onKViP03ooooool0003ooooo0;Sooooo00?o0000
oooooooVi^H03_oVi^I<ooooo`;o00008oooool002Cooooo0ol0001:ooooo`goi^KV0oooool00ol0
003oooooooooo`2eooooo`04o`000?ooooooooooooooo`goi^KVB_ooool3o`0002Gooooo000Woooo
o`;o0000BOooool;onKViPGooooo0_l0002cooooo`;o00001Oooool;onKViTWooooo0_l0000Xoooo
o`00:Oooool3o`0004Sooooo1ooVi^H9ooooo`03o`000?oooooooooo0:oooooo00?o0000oooooooo
ool01oooool7onKViTSooooo0ol0000Zooooo`00;?ooool2o`0005Oooooo00?o0000ooooooooool0
EOooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo05Gooooo0_l0000]ooooo`00;_oo
ool2o`0005Kooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`1Dooooo`03o`000?oo
oooooooo05Cooooo0_l0000_ooooo`00<?ooool3o`0005Cooooo00?o0000ooooooooool0Doooool0
0ol0003oooooooooo`1Cooooo`03o`000?oooooooooo05;ooooo0ol0000aooooo`00<oooool2o`00
05?ooooo0_l0001Cooooo`03o`000?oooooooooo057ooooo0_l0001Cooooo`;o0000=?ooool003Go
oooo0ol0001Booooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0D?ooool00ol0003o
ooooooooo`1@ooooo`?o0000=_ooool003Sooooo0_l0001Aooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`;o0000>Oooool003[ooooo0ol0
001?ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1=ooooo`?o0000>oooool003gooooo0_l0001>ooooo`03o`000?oooooooooo04gooooo00?o0000
ooooooooool0COooool00ol0003oooooooooo`1<ooooo`;o0000?_ooool003oooooo0_l0001=oooo
o`;o0000COooool00ol0003oooooooooo`1;ooooo`;o0000COooool2o`00043ooooo0011ooooo`?o
0000C?ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04[ooooo00?o0000oooooooo
ool0B_ooool3o`0004;ooooo0014ooooo`;o0000Boooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo04Wooooo00?o0000ooooooooool0BOooool2o`0004Gooooo0016ooooo`?o0000BOoo
ool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0Aooo
ool3o`0004Oooooo0019ooooo`;o0000B?ooool2o`0004Sooooo00?o0000ooooooooool0A_ooool2
o`0004Sooooo0_l0001:ooooo`00Boooool3o`0004Oooooo00?o0000ooooooooool0AOooool00ol0
003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo0ol0001<ooooo`00C_ooool2o`0004Ko
oooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo04Co
oooo0_l0001?ooooo`00D?ooool2o`0004Gooooo00?o0000ooooooooool0@oooool00ol0003ooooo
ooooo`13ooooo`03o`000?oooooooooo04?ooooo0_l0001Aooooo`00D_ooool3o`0004?ooooo00?o
0000ooooooooool0@_ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo047ooooo0ol0
001Cooooo`00EOooool2o`0004;ooooo0_l00012ooooo`03o`000?oooooooooo043ooooo0_l00012
ooooo`;o0000E_ooool005Oooooo0ol00011ooooo`03o`000?oooooooooo03oooooo00?o0000oooo
ooooool0?oooool00ol0003oooooooooo`0oooooo`?o0000F?ooool005[ooooo0_l00010ooooo`03
o`000?oooooooooo03kooooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0nooooo`;o
0000Foooool005cooooo0ol0000nooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0
?Oooool00ol0003oooooooooo`0looooo`?o0000GOooool005oooooo0_l0000mooooo`03o`000?oo
oooooooo03cooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`0kooooo`;o0000H?oo
ool0067ooooo0_l0000looooo`;o0000??ooool00ol0003oooooooooo`0jooooo`;o0000??ooool2
o`0006;ooooo001Sooooo`?o0000>oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo
03Wooooo00?o0000ooooooooool0>Oooool3o`0006Cooooo001Vooooo`;o0000>_ooool00ol0003o
ooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool2o`0006Oo
oooo001Xooooo`?o0000>?ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool0=_ooool3o`0006Wooooo001[ooooo`;o0000=oooool2o`0003Oooooo00?o
0000ooooooooool0=Oooool2o`0003Oooooo0_l0001/ooooo`00KOooool3o`0003Kooooo00?o0000
ooooooooool0=?ooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo03Cooooo0ol0001^
ooooo`00L?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0coooo
o`03o`000?oooooooooo03?ooooo0_l0001aooooo`00L_ooool2o`0003Cooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo0_l0001cooooo`00
M?ooool3o`0003;ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0aooooo`03o`00
0?oooooooooo033ooooo0ol0001eooooo`00Moooool2o`00037ooooo0_l0000aooooo`03o`000?oo
oooooooo02oooooo0_l0000aooooo`;o0000N?ooool007Wooooo0ol0000`ooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0^ooooo`?o0000N_ooool0
07cooooo0_l0000_ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`0]ooooo`;o0000OOooool007kooooo0ol0000]ooooo`03o`000?oooooooooo02co
oooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0[ooooo`?o0000Ooooool0087ooooo
0_l0000/ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Zooooo`;o0000P_ooool008?ooooo0_l0000[ooooo`;o0000:oooool00ol0003ooooooooo
o`0Yooooo`;o0000:oooool2o`0008Cooooo0025ooooo`?o0000:_ooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool3o`0008Kooooo0028oooo
o`;o0000:Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool09oooool2o`0008Wooooo002:ooooo`?o00009oooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool09Oooool3o`0008_ooooo002=ooooo`;o0000
9_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0_l0002>ooooo`00Sooo
ool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo02?ooooo0ol0002@ooooo`00T_ooool2o`0002Cooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo0_l0002Cooooo`00U?ooool2o`00
02?ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
027ooooo0_l0002Eooooo`00U_ooool3o`00027ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo01oooooo0ol0002Gooooo`00VOooool2o`00023ooooo
0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Pooooo`;o0000V_ooool009_ooooo0ol0
000Oooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`0Mooooo`?o0000W?ooool009kooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`;o0000Woooool00:3ooooo0ol0000Loooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Joooo
o`?o0000XOooool00:?ooooo0_l0000Kooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Iooooo`;o0000Y?ooool00:Gooooo0_l0000Jooooo`;o0000
6_ooool00ol0003oooooooooo`0Hooooo`;o00006_ooool2o`000:Kooooo002Wooooo`?o00006Ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05ooo
ool3o`000:Sooooo002Zooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool05_ooool2o`000:_ooooo002/ooooo`?o00005_ooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool3o`00
0:gooooo002_ooooo`;o00005Oooool2o`0001Gooooo00?o0000ooooooooool04oooool2o`0001Go
oooo0_l0002`ooooo`00/Oooool3o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo0ol0002booooo`00]?ooool2o`0001?ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0_l0
002eooooo`00]_ooool2o`0001;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo013ooooo0_l0002gooooo`00^?ooool3o`00013ooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo0ol0002ioooo
o`00^oooool2o`0000oooooo0_l0000?ooooo`03o`000?oooooooooo00gooooo0_l0000?ooooo`;o
0000_?ooool00;gooooo0ol0000>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0<ooooo`?o0000__ooool00<3ooooo0_l0000=ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000`Ooo
ool00<;ooooo0ol0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`09ooooo`?o0000`oooool00<Gooooo0_l0000:ooooo`03o`000?oooooooooo
00Kooooo1ooVi^H8ooooo`03o`000?oooooooooo00Sooooo0_l00036ooooo`00aoooool2o`0000Wo
oooo0_l00004ooooo`_oi^KV1?ooool2o`0000Wooooo0_l00038ooooo`00bOooool3o`0000Sooooo
00?o0000ooooooooool03OoVi^H2ooooo`03o`000?oooooooooo00Kooooo0ol0003:ooooo`00c?oo
ool2o`0000Oooooo00?o0000onKVi_oVi^H03OoVi^H00ol0003oooooooooo`05ooooo`;o0000cOoo
ool00<kooooo0ol00004oooooa7oi^KV1?ooool3o`000<oooooo003Aooooo`;o000000?oooooonKV
i_oVi^H04OoVi^H00ooooooo0000o`00003Booooo`00doooool00ol0003oi^KVonKViP0AonKViP03
o`000?oooooooooo0=;ooooo003CoooooaGoi^KVe?ooool00=?ooooo1ooVi^H6o`0000Soi^KVe?oo
ool00=?ooooo2OoVi^H2o`0000[oi^KVe?ooool00=?ooooo2OoVi^H2o`0000[oi^KVe?ooool00=?o
oooo2OoVi^H2o`0000[oi^KVe?ooool00=?ooooo2?oVi^H5o`0000Soi^KVe?ooool00=?ooooo2OoV
i^H2o`0000[oi^KVe?ooool00=Cooooo2OoVi^H3o`0000Ooi^KVeOooool00=Cooooo4ooVi^KEoooo
o`00eOoooolAonKVi]Kooooo003Fooooo`ooi^KVeoooool00=Oooooo3OoVi^KHooooo`00f?ooool;
onKVi]Wooooo003Jooooo`Ooi^KVfoooool00001\
\>"],
  ImageRangeCache->{{{0, 443.625}, {273.812, 0}} -> {-2.17278, -0.625483, \
0.00979557, 0.00237743}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.411358 0.193774 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.13201 .36788 -5 -6 ]
[.13201 .36788 5 6 ]
[.17883 .36788 -5 -6 ]
[.17883 .36788 5 6 ]
[.15778 .25016 -5 -6 ]
[.15778 .25016 5 6 ]
[.22564 .25016 -5 -6 ]
[.22564 .25016 5 6 ]
[.2935 .25016 -5 -6 ]
[.2935 .25016 5 6 ]
[.22564 .36788 -5 -6 ]
[.22564 .36788 5 6 ]
[.17883 .4856 -5 -6 ]
[.17883 .4856 5 6 ]
[.33385 .4856 -5 -6 ]
[.33385 .4856 5 6 ]
[.44205 .36788 -5 -6 ]
[.44205 .36788 5 6 ]
[.43389 .25016 -5 -6 ]
[.43389 .25016 5 6 ]
[.63747 .25016 -5 -6 ]
[.63747 .25016 5 6 ]
[.53568 .36788 -5 -6 ]
[.53568 .36788 5 6 ]
[.48887 .4856 -5 -6 ]
[.48887 .4856 5 6 ]
[.64389 .4856 -5 -6 ]
[.64389 .4856 5 6 ]
[.75209 .36788 -5 -6 ]
[.75209 .36788 5 6 ]
[.73105 .25016 -5 -6 ]
[.73105 .25016 5 6 ]
[.79299 .13244 -5 -6 ]
[.79299 .13244 5 6 ]
[.83112 .01472 -5 -6 ]
[.83112 .01472 5 6 ]
[.90241 .01472 -5 -6 ]
[.90241 .01472 5 6 ]
[.86677 .13244 -5 -6 ]
[.86677 .13244 5 6 ]
[.9049 .01472 -5 -6 ]
[.9049 .01472 5 6 ]
[.94054 .01472 -5 -6 ]
[.94054 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.94054 .13244 -5 -6 ]
[.94054 .13244 5 6 ]
[.86677 .25016 -5 -6 ]
[.86677 .25016 5 6 ]
[.79891 .36788 -5 -6 ]
[.79891 .36788 5 6 ]
[.77786 .25016 -5 -6 ]
[.77786 .25016 5 6 ]
[.84572 .25016 -5 -6 ]
[.84572 .25016 5 6 ]
[.91358 .25016 -5 -6 ]
[.91358 .25016 5 6 ]
[.84572 .36788 -5 -6 ]
[.84572 .36788 5 6 ]
[.79891 .4856 -5 -6 ]
[.79891 .4856 5 6 ]
[.41136 .60332 -5 -6 ]
[.41136 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.41136 .60332 m
.02381 .4856 L
s
.41136 .60332 m
.17883 .4856 L
s
.41136 .60332 m
.33385 .4856 L
s
.41136 .60332 m
.48887 .4856 L
s
.41136 .60332 m
.64389 .4856 L
s
.41136 .60332 m
.79891 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.17883 .4856 m
.13201 .36788 L
s
.17883 .4856 m
.17883 .36788 L
s
.17883 .4856 m
.22564 .36788 L
s
1 g
.05 w
.13201 .36788 Mdot
0 g
gsave
.13201 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.17883 .36788 Mdot
0 g
gsave
.17883 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.22564 .36788 m
.15778 .25016 L
s
.22564 .36788 m
.22564 .25016 L
s
.22564 .36788 m
.2935 .25016 L
s
1 g
.05 w
.15778 .25016 Mdot
0 g
gsave
.15778 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.22564 .25016 Mdot
0 g
gsave
.22564 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.2935 .25016 Mdot
0 g
gsave
.2935 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.22564 .36788 Mdot
0 g
gsave
.22564 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.17883 .4856 Mdot
0 g
gsave
.17883 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.33385 .4856 Mdot
0 g
gsave
.33385 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.48887 .4856 m
.44205 .36788 L
s
.48887 .4856 m
.53568 .36788 L
s
1 g
.05 w
.44205 .36788 Mdot
0 g
gsave
.44205 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.53568 .36788 m
.43389 .25016 L
s
.53568 .36788 m
.63747 .25016 L
s
1 g
.05 w
.43389 .25016 Mdot
0 g
gsave
.43389 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.63747 .25016 Mdot
0 g
gsave
.63747 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.53568 .36788 Mdot
0 g
gsave
.53568 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.48887 .4856 Mdot
0 g
gsave
.48887 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.64389 .4856 Mdot
0 g
gsave
.64389 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.79891 .4856 m
.75209 .36788 L
s
.79891 .4856 m
.79891 .36788 L
s
.79891 .4856 m
.84572 .36788 L
s
1 g
.05 w
.75209 .36788 Mdot
0 g
gsave
.75209 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.79891 .36788 m
.73105 .25016 L
s
.79891 .36788 m
.86677 .25016 L
s
1 g
.05 w
.73105 .25016 Mdot
0 g
gsave
.73105 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.86677 .25016 m
.79299 .13244 L
s
.86677 .25016 m
.86677 .13244 L
s
.86677 .25016 m
.94054 .13244 L
s
1 g
.05 w
.79299 .13244 Mdot
0 g
gsave
.79299 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.86677 .13244 m
.83112 .01472 L
s
.86677 .13244 m
.90241 .01472 L
s
1 g
.05 w
.83112 .01472 Mdot
0 g
gsave
.83112 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.90241 .01472 Mdot
0 g
gsave
.90241 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.86677 .13244 Mdot
0 g
gsave
.86677 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.94054 .13244 m
.9049 .01472 L
s
.94054 .13244 m
.94054 .01472 L
s
.94054 .13244 m
.97619 .01472 L
s
1 g
.05 w
.9049 .01472 Mdot
0 g
gsave
.9049 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.94054 .01472 Mdot
0 g
gsave
.94054 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.94054 .13244 Mdot
0 g
gsave
.94054 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.86677 .25016 Mdot
0 g
gsave
.86677 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.79891 .36788 Mdot
0 g
gsave
.79891 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.84572 .36788 m
.77786 .25016 L
s
.84572 .36788 m
.84572 .25016 L
s
.84572 .36788 m
.91358 .25016 L
s
1 g
.05 w
.77786 .25016 Mdot
0 g
gsave
.77786 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.84572 .25016 Mdot
0 g
gsave
.84572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.91358 .25016 Mdot
0 g
gsave
.91358 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.84572 .36788 Mdot
0 g
gsave
.84572 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.79891 .4856 Mdot
0 g
gsave
.79891 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.41136 .60332 Mdot
0 g
gsave
.41136 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{444.625, 274.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006l00014R000`400?l00000o`00003ooooooonm
ooooo`00oooooonmooooo`00oooooonmooooo`00oooooonmooooo`00oooooonmooooo`00oooooonm
ooooo`00oooooonmooooo`00oooooonmooooo`00oooooomYooooo`Go00007?ooool5o`0000[ooooo
1Ol0000:ooooo`Co00004Oooool00?ooooooJ_ooool2o`000003ooooool0003o000001[ooooo0_l0
00000ooooooo0000o`00000:ooooo`;o000000?oooooo`000?l000002_ooool2o`0000;ooooo0_l0
000@ooooo`00oooooomZooooo`;o000000?oooooo`000?l000006oooool4o`0000[ooooo0_l00000
0ooooooo0000o`00000:ooooo`;o00005?ooool00?ooooooJ_ooool2o`000003ooooool0003o0000
01[ooooo0_l000000ooooooo0000o`00000:ooooo`;o000000?oooooo`000?l000002_ooool2o`00
00;ooooo0_l0000@ooooo`00oooooomZooooo`Co00007?ooool3o`0000cooooo1?l0000;ooooo`Co
00004Oooool00?ooooooJ_ooool2o`0002oooooo0_l0000Pooooo`00oooooomYooooo`?o0000;_oo
ool3o`00023ooooo003ooooookgooooo003ooooookgooooo003ooooookgooooo003ooooookgooooo
003ooooookgooooo003ooooookgooooo003ooooookgooooo003oooooog3ooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0Cooooo`00oooooom`ooooo`03o`000?oooooooooo01Cooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool05?ooool00?ooooooL?ooool00ol0003oooooooooo`0Dooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo01Cooooo003oooooog7ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0D
ooooo`00oooooomaooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool05Oooool00?oo
ooooLOooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Gooooo003oooooog7ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Eooooo`00oooooombooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool05Oooool00?ooooooL_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo01Kooooo003oooooog;ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0Fooooo`00oooooomcooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool05_ooool00?ooooooLoooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Oooooo
003oooooog?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Gooooo`00oooooomd
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool00?ooooooM?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo01Sooooo003oooooogCooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0Hooooo`00oooooomeooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool06?ooool00?ooooooMOooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo01Sooooo003oooooogGooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0I
ooooo`00oooooomfooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06Oooool00?oo
ooooM_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Wooooo003oooooogKooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Jooooo`00oooooomgooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool06_ooool00?ooooooMoooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo01[ooooo003oooooogOooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0Jooooo`00oooooomgooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool05?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool06oooool00?oo
ooooN?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo01_ooooo003oooooogSooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`0Kooooo`00oooooomhooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool05_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01cooooo003oooooogSo
oooo1ooVi^H00ol0003oooooooooo`0Fooooo`Ooi^KV7_ooool00?ooooooM_ooool;onKViQGooooo
2ooVi^HLooooo`00oooooomeooooo`goi^KV4oooool=onKViQ_ooooo003oooooogCooooo3ooVi^HA
ooooo`ooi^KV6_ooool00?ooooooLooooolAonKViPoooooo4OoVi^HIooooo`00oooooomboooooa?o
i^KV3OoooolConKViQSooooo003oooooog;ooooo2?oVi^H4o`0000Ooi^KV3Oooool7onKViPCo0000
2?oVi^HHooooo`00oooooomaooooo`coi^KV0_l00007onKViP_ooooo2ooVi^H2o`0000Soi^KV5ooo
ool00?ooooooF_ooool4o`0001?ooooo2OoVi^H5o`0000Ooi^KV2oooool8onKViPGo00002?oVi^HG
ooooo`00oooooomIooooo`;o00000_ooool2o`0001;ooooo2?oVi^H2o`0000;oi^KV0_l00007onKV
iP_ooooo1ooVi^H2o`0000;oi^KV0_l00008onKViQOooooo003ooooooegooooo0_l0000Booooo`So
i^KV0_l00002onKViP;o00001ooVi^H;ooooo`Ooi^KV0_l00002onKViP;o00002?oVi^HGooooo`00
oooooomMooooo`;o00004_ooool8onKViP;o00000_oVi^H2o`0000Ooi^KV2oooool7onKViP;o0000
0_oVi^H2o`0000Soi^KV5oooool00?ooooooFOooool5o`0001?ooooo2OoVi^H6o`0000Koi^KV2ooo
ool8onKViPKo00001ooVi^HGooooo`00oooooomIooooo`;o00005_oooolEonKViP_ooooo5OoVi^HG
ooooo`00oooooomIooooo`Ko00004ooooolConKViPgooooo4ooVi^HHooooo`00oooooomboooooa?o
i^KV3OoooolConKViQSooooo003oooooog?ooooo4OoVi^H?oooooa7oi^KV6Oooool00?ooooooM?oo
ool?onKViQ7ooooo3ooVi^HJooooo`00oooooomeooooo`goi^KV4oooool=onKViQ_ooooo003ooooo
ogKooooo2ooVi^HEooooo`_oi^KV7?ooool00?ooooooH_ooool00ol0003oooooooooo`0Cooooo`Oo
i^KV5_ooool00ol0003oooooooooo`07onKViQkooooo003oooooof?ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02Kooooo003oooooof?ooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02Kooooo003o
ooooofCooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo02Oooooo003oooooofGooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo02Oooooo003oooooofGooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo02Sooooo003oooooofKooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo02Wooooo003oooooofOooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo02Wooooo003o
ooooofOooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo02[ooooo003oooooofSooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo02[ooooo003oooooofSooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo02_ooooo003oooooofWooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo003oooooof[ooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo003o
ooooof[ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo02gooooo003oooooof_ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo02kooooo003oooooofcooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo02kooooo003oooooofcooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02oooooo003oooooofgooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02oooooo003o
ooooofkooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo033ooooo003oooooofkooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo037ooooo003oooooofoooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo037ooooo003oooooog3ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03;ooooo003oooooog3ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03?ooooo003o
ooooog7ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo03?ooooo003oooooog7ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo03Cooooo003oooooog;ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo03Cooooo003oooooog?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03Gooooo003oooooog?ooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Kooooo003o
ooooogCooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo03Kooooo003oooooogGooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo03Oooooo003oooooogGooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03Oooooo003oooooogKooooo00?o0000oooooooVi^H0
1_oVi^H3ooooo`03o`000?oooooooooo03Sooooo003oooooogSooooo2OoVi^H00ol0003ooooooooo
o`0iooooo`00oooooomiooooo`Woi^KV>oooool00?ooooooN_ooool9onKViS[ooooo003oooooog_o
oooo2OoVi^Hiooooo`00oooooomlooooo`Woi^KV>?ooool00?ooooooO?ooool9onKViSSooooo0019
ooooo`Go00006Oooool4o`0001Wooooo1?l0000fooooo`Go0000D_ooool5o`0002Cooooo1Ol0000?
ooooo`Co00006_ooool4o`0000Sooooo0ol00005onKViPWooooo1Ol0000Zooooo`00B?ooool2o`00
0003ooooool0003o000001_ooooo0_l0000Kooooo`;o0000>?ooool2o`000003ooooool0003o0000
05;ooooo0_l000000ooooooo0000o`00000Rooooo`;o000000?oooooo`000?l000003oooool2o`00
00;ooooo0_l0000Hooooo`;o00002oooool2o`0000Koi^KV2?ooool2o`000003ooooool0003o0000
02_ooooo0019ooooo`Co00006?ooool6o`0001Oooooo1_l0000gooooo`;o000000?oooooo`000?l0
0000D_ooool2o`000003ooooool0003o000002?ooooo1?l0000?ooooo`;o00007?ooool6o`0000Oo
oooo0_l00006onKViPSooooo0_l000000ooooooo0000o`00000[ooooo`00B?ooool2o`000003oooo
ool0003o000001Sooooo0_l000000ooooooo0000o`00000Hooooo`;o000000?oooooo`000?l00000
>?ooool2o`000003ooooool0003o000005;ooooo0_l000000ooooooo0000o`00000Rooooo`;o0000
00?oooooo`000?l000003oooool2o`0000;ooooo0_l0000Hooooo`;o00000_ooool2o`0000Oooooo
0_l00006onKViPSooooo0_l000000ooooooo0000o`00000[ooooo`00BOooool3o`0001[ooooo1?l0
000Iooooo`Co0000>?ooool4o`0005?ooooo1?l0000Tooooo`?o00004Oooool4o`0001[ooooo1?l0
0008ooooo`03o`000?oVi^Koi^KV00Goi^KV2Oooool4o`0002_ooooo001Wooooo`?o00006_ooool3
o`0003Sooooo0_l0001Eooooo`;o0000I?ooool8onKViP_ooooo0_l0000[ooooo`00J?ooool2o`00
01_ooooo0_l0000gooooo`?o0000E?ooool3o`0006Cooooo2?oVi^H:ooooo`?o0000:oooool00?oo
ooooO?ooool9onKViSSooooo003oooooogcooooo2OoVi^Hhooooo`00oooooomkooooo`Woi^KV>Ooo
ool00?ooooooN_ooool9onKViS[ooooo0038ooooo`03o`000?oooooooooo04Kooooo00?o0000oooo
ooooool0I?ooool9onKViS_ooooo001@ooooo`03o`000?oooooooooo07Kooooo00?o0000oooooooo
ool0A?ooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo01[ooooo2OoVi^Hlooooo`00
DOooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0
@_ooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooonKViP06onKViP_ooooo00?o0000ooooooooool0<?ooool005;ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool0@?ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool05?ooool00ol0003oooooo`00000Cooooo`03o`000?oooooooooo037ooooo001B
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1;
ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooool000004oooool00ol0003oooooooooo`0a
ooooo`00Doooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool0COooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo03Sooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Cooooo`;o00004oooool00ol0003oooooooooo`0boooo
o`00Doooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0C_ooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03Wooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0<_ooool005Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0kooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo03?ooooo001Dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0??oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo013ooooo0_l0000Cooooo`03o`000?oo
oooooooo03?ooooo001Eooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`1Booooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0?_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo0_l0000Booooo`03o`000?oooooo
oooo03Cooooo001Fooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`1Dooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0@?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00kooooo00?o0000ooooool000004Oooool00ol0
003oooooooooo`0eooooo`00E_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo043o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo0000017o
oooo00?o0000ooooooooool0=Oooool005Oooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`12ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool03?ooool01?l0003ooooo
ooooool0000@ooooo`03o`000?oooooooooo03Kooooo001Gooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0@oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00[ooooo
00Go0000ooooooooooooooooo`00000@ooooo`03o`000?oooooooooo03Kooooo001Hooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Iooooo`03o`00
0?oooooooooo02kooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo00[ooooo00Go0000ooooooooooooooooo`00000?ooooo`03o`000?oooooooooo03Oo
oooo001Hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`1Jooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0A_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo03Oooooo001Iooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool0B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03Sooooo001J
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1N
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo03Wooooo001Jooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool0B_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo03Wooooo001Kooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Qooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo03[ooooo001Kooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
COooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo03[ooooo001Looooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Sooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo03_ooooo001Looooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Tooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0D?ooool0
0ol0003oooooooooo`0Booooo`04o`000?ooooooooooo`0000Sooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0kooooo`00GOooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo05;ooooo00?o0000ooooooooool04_ooool2o`0000Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0looooo`00GOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
05;ooooo00?o0000ooooooooool04_ooool2o`0000Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`0looooo`00G_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0JOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo05Co
oooo00?o0000ooooooooool04Oooool2o`0000Wooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0mooooo`00Goooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05Kooooo
00?o0000ooooooooool04?ooool2o`0000Wooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`0nooooo`00Goooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0K?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo05Oooooo00?o
0000ooooooooool03oooool01?l0003oooooooooool00008ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0?_ooool0063ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`1Iooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00002?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo03oooooo001Pooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`1^ooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03oooooo001Q
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1`
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo043ooooo001Qooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0G?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo001Rooooo`03
o`000?ooooooi^KV00Koi^KV0oooool00ol0003oooooooooo`1cooooo`03o`000?oooooooooo00;o
oooo1ooVi^H6ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool01ooVi^H2ooooo`03
o`000?oooooooooo00Kooooo00?o0000oooooooVi^H01_oVi^H3ooooo`03o`000?oooooooooo047o
oooo001Rooooo`_oi^KV00?o0000ooooooooool0MOooool00ol0003oooooonKViP0:onKViP?ooooo
00?o0000ooooooooool0H?ooool;onKViP03o`000?oooooooooo00Kooooo2ooVi^H00ol0003ooooo
ooooo`12ooooo`00HOooool=onKViWSooooo3OoVi^H00ooooooo0000ooooo`1Qooooo`goi^KV1ooo
ool=onKViTCooooo001Pooooo`ooi^KVM_ooool?onKViV;ooooo3ooVi^H5ooooo`ooi^KV@oooool0
05oooooo4OoVi^Idoooooa7oi^KVH?oooolAonKViP?ooooo4OoVi^I2ooooo`00G_oooolConKViW;o
oooo4ooVi^INoooooa?oi^KV00?oooooonKVi_oVi^H04OoVi^I1ooooo`00G_ooool8onKViPCo0000
1ooVi^Ibooooo`Soi^KV1?l00007onKViUkooooo1ooVi^H4o`0000Soi^KV00?oooooonKVi_oVi^H0
1_oVi^H4o`0000Ooi^KV@Oooool005gooooo3?oVi^H2o`0000Ooi^KVL?ooool<onKViP;o00001ooV
i^ILooooo`_oi^KV0_l0000ConKViP;o00001ooVi^I0ooooo`00?_ooool5o`0000oooooo1?l00007
ooooo`Woi^KV1Ol00007onKViToooooo1_l0000Kooooo`Woi^KV1Ol00007onKViU3ooooo1?l00008
ooooo`Soi^KV1Ol0000@onKViPGo00001ooVi^I0ooooo`00?Oooool2o`000003ooooool0003o0000
00oooooo0_l0000:ooooo`Soi^KV0_l00002onKViP;o00001ooVi^I@ooooo`;o000000?oooooo`00
0?l000006oooool8onKViP;o00000_oVi^H2o`0000Ooi^KVCoooool2o`0000;ooooo0_l00007oooo
o`Ooi^KV0_l00002onKViP;o00003ooVi^H2o`0000;oi^KV0_l00007onKViT3ooooo000nooooo`Co
00003oooool6o`0000Kooooo2?oVi^H2o`0000;oi^KV0_l00007onKViU7ooooo0_l0000Mooooo`So
i^KV0_l00002onKViP;o00001ooVi^ICooooo`;o00001oooool7onKViP;o00000_oVi^H2o`0000oo
i^KV0_l00002onKViP;o00001ooVi^I0ooooo`00?Oooool2o`000003ooooool0003o000000oooooo
0_l00002ooooo`;o00001_ooool8onKViP;o00000_oVi^H2o`0000Ooi^KVD_ooool2o`0001cooooo
2?oVi^H2o`0000;oi^KV0_l00007onKViU?ooooo0_l00007ooooo`Ooi^KV0_l00002onKViP;o0000
3ooVi^H2o`0000;oi^KV0_l00007onKViT3ooooo000nooooo`?o00004Oooool4o`0000Oooooo2OoV
i^H6o`0000Koi^KVCoooool2o`0000;ooooo0_l0000Kooooo`Woi^KV1_l00006onKViToooooo1Ol0
0008ooooo`Soi^KV1_l0000?onKViPKo00001_oVi^I0ooooo`00GOoooolEonKViToooooo0_l00002
ooooo`;o00006ooooolEonKViToooooo0_l0000;ooooobWoi^KV@?ooool005kooooo4ooVi^IAoooo
o`Co00007OoooolConKViU3ooooo1_l00008oooooa?oi^KV00?oooooonKVi_oVi^H04OoVi^I1oooo
o`00G_oooolConKViW;ooooo4ooVi^INoooooa?oi^KV00?oooooonKVi_oVi^H04OoVi^I1ooooo`00
GooooolAonKViWCooooo4OoVi^IPoooooa7oi^KV0ooooolAonKViT;ooooo001Pooooo`ooi^KVM_oo
ool?onKViV;ooooo3ooVi^H5ooooo`ooi^KV@oooool0067ooooo3OoVi^Ihooooo`goi^KVI?ooool=
onKViPOooooo3OoVi^I4ooooo`00H_ooool;onKViW[ooooo2ooVi^IVooooo`_oi^KV2Oooool;onKV
iTGooooo0014ooooo`03o`000?oooooooooo01gooooo1ooVi^IMooooo`03o`000?oooooooooo01ko
oooo1ooVi^IMooooo`03o`000?oooooooooo00[ooooo1ooVi^H=ooooo`Ooi^KVAoooool004Cooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo067ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`1;ooooo`00AOooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Hoooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo04cooooo0015ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool0Hoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0C?ooool004Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1Soooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1=oooo
o`00A_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0IOooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo06Gooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo04gooooo0016ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Vooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0C_ooool004Oooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1>ooooo`00Aoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo06Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo04kooooo0017ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`1Xooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Ioooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Coooool004So
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Wo
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1?ooooo`00B?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0J_ooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo053ooooo0019ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0Joooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0D?ooool004Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`1[
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1@
ooooo`00BOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0K?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo06_ooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo057ooooo001:ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1]ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0KOooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0DOooool004[ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`1Booooo`00Boooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0Koooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo06oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo05;ooooo001;ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1`ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Koooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Doooool0
04_ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
073ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1_ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Cooooo`00C?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0LOooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo077ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo05?ooooo001<ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0LOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0E?ooool004gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1cooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`1Dooooo`00COooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0M?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo07?ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05Gooooo001=oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1doooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0EOooool004kooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo07Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`1Eooooo`00C_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo07Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo05Kooooo001?ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`1gooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Mooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0E_oo
ool004oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo07Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1gooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Gooooo`00Coooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0N?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo07Oooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo05Oooooo001@ooooo`Ooi^KV00?oooooo`000?oo
ool0Noooool7onKViP03ooooool0003ooooo07[ooooo00?o0000onKVi_oVi^H01OoVi^H00ol0003o
ooooooooo`1Hooooo`00C_ooool;onKViW[ooooo2ooVi^Ijooooo`_oi^KVFOooool004gooooo3OoV
i^Ihooooo`goi^KVN?ooool=onKViUSooooo001<ooooo`ooi^KVM_ooool?onKViWKooooo3ooVi^IG
ooooo`00BooooolAonKViWCooooo4OoVi^Idoooooa7oi^KVE_ooool004[ooooo4ooVi^Iboooooa?o
i^KVL_oooolConKViUGooooo001:ooooo`Soi^KV1?l00007onKViW;ooooo4ooVi^Iboooooa?oi^KV
EOooool004Wooooo3?oVi^H2o`0000Ooi^KVL?oooolEonKViW3ooooo5OoVi^IDooooo`004?ooool4
o`0003Gooooo2OoVi^H5o`0000Ooi^KV=_ooool4o`0003Kooooo2?oVi^H7o`0000Koi^KV=Oooool6
o`0003Gooooo1ooVi^H7o`0000Ooi^KVE?ooool0017ooooo0_l0000fooooo`Soi^KV0_l00002onKV
iP;o00001ooVi^Heooooo`;o00000_ooool2o`0003Gooooo2OoVi^H2o`000003onKVi_l0003o0000
00Ooi^KV=_ooool2o`000003ooooool0003o000003Gooooo2?oVi^H2o`000003onKVi_l0003o0000
00Soi^KVE?ooool000kooooo1_l0000eooooo`Soi^KV0_l00002onKViP;o00001ooVi^Heooooo`;o
0000>Oooool9onKViP;o000000?oi^KVo`000?l000001ooVi^Hgooooo`;o0000=oooool8onKViP;o
000000?oi^KVo`000?l000002?oVi^IDooooo`003_ooool2o`000003ooooool0003o000003Kooooo
2?oVi^H2o`0000;oi^KV0_l00007onKViSGooooo0_l00002ooooo`;o0000=Oooool9onKViP;o0000
00?oi^KVo`000?l000001ooVi^Hhooooo`;o0000=_ooool8onKViP;o000000?oi^KVo`000?l00000
2?oVi^IDooooo`003oooool4o`0003Kooooo2OoVi^H6o`0000Koi^KV=_ooool4o`0003Kooooo2OoV
i^H4o`0000Soi^KV=Oooool2o`0000;ooooo0_l0000eooooo`Soi^KV1?l00009onKViUCooooo000@
ooooo`?o00002Oooool00ol0003oooooooooo`0ZoooooaGoi^KVL?ooool9onKViP;o00002_oVi^He
ooooo`;o00000_ooool2o`0003Cooooo00?o0000onKVi_oVi^H01_oVi^H2o`0000_oi^KVE?ooool0
017ooooo0_l0000:ooooo`Co0000:OoooolConKViP03o`000?oooooooooo06oooooo1ooVi^H3o`00
00Woi^KV=oooool4o`00037ooooo1?l00002ooooo`Koi^KV0ol0000:onKViUGooooo000Qooooo`?o
00009_oooolConKViP03ooooool0003o000006oooooo4ooVi^H^ooooo`;o0000>Oooool3o`0000Ko
oooo4ooVi^IEooooo`009?ooool3o`0002Cooooo4OoVi^H4ooooo`;o0000K_oooolAonKViRgooooo
0_l0000hooooo`?o00002_oooolAonKViUKooooo000Wooooo`?o00008_ooool?onKViPOooooo0_l0
001]ooooo`ooi^KV;?ooool2o`0003Oooooo0ol0000>ooooo`ooi^KVEoooool002[ooooo1?l0000O
ooooo`goi^KV2_ooool2o`0006cooooo3OoVi^H[ooooo`;o0000=Oooool4o`0001;ooooo3OoVi^IH
ooooo`00;_ooool3o`0001gooooo2ooVi^H=ooooo`03o`000?oooooooooo03?ooooo00?o0000oooo
ooooool0=?ooool;onKViR[ooooo0_l0000dooooo`?o00005oooool;onKViUWooooo000aooooo`?o
00007?ooool7onKViQ3ooooo0_l0000cooooo`03o`000?oooooooooo03Cooooo00?o0000oooooooV
i^H01_oVi^HZooooo`;o0000<oooool3o`0001cooooo1ooVi^IKooooo`00=?ooool3o`0003;ooooo
0_l0000booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0;oooool2o`0003;ooooo
0ol00021ooooo`00=oooool4o`00033ooooo0_l0000`ooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool0;_ooool2o`00033ooooo1?l00024ooooo`00>oooool3o`0002oooooo0_l0000_
ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]
ooooo`?o0000R?ooool003kooooo0ol0000^ooooo`;o0000;_ooool00ol0003oooooooooo`0^oooo
o`03o`000?oooooooooo02cooooo0_l0000]ooooo`?o0000Roooool0047ooooo0ol0000]ooooo`;o
0000;?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02_ooooo0_l0000/ooooo`?o
0000S_ooool004Cooooo1?l0000[ooooo`;o0000:oooool00ol0003oooooooooo`0/ooooo`03o`00
0?oooooooooo02Wooooo0_l0000Zooooo`Co0000TOooool004Sooooo0ol0000Zooooo`;o0000:_oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Sooooo0_l0000Yooooo`?o0000UOoo
ool004_ooooo0ol0000Yooooo`;o0000:?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo02Oooooo0_l0000Xooooo`?o0000V?ooool004kooooo0ol0000Xooooo`;o00009oooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Gooooo0_l0000Wooooo`?o0000Voooool0057o
oooo1?l0000Vooooo`;o00009_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Co
oooo0_l0000Uooooo`Co0000W_ooool005Gooooo0ol0000Uooooo`;o00009?ooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo02?ooooo0_l0000Tooooo`?o0000X_ooool005Sooooo0ol0
000Tooooo`;o00008oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo027ooooo0_l0
000Sooooo`?o0000YOooool005_ooooo0ol0000Sooooo`;o00008_ooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o0000Z?ooool005kooooo1?l0000Qoooo
o`;o00008?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01oooooo0_l0000Poooo
o`Co0000Zoooool006;ooooo0ol0000Pooooo`;o00007oooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo01gooooo0_l0000Oooooo`?o0000[oooool006Gooooo0ol0000Oooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Looooo`;o0000
7_ooool3o`000;;ooooo001Xooooo`Co00007?ooool2o`0001gooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Kooooo`;o00007?ooool4o`000;Gooooo001/ooooo`?o00006oooool2
o`0001cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Iooooo`;o00006oooool3
o`000;Wooooo001_ooooo`?o00006_ooool2o`0001[ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0Hooooo`;o00006_ooool3o`000;cooooo001booooo`?o00006Oooool2o`0001Wo
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Gooooo`;o00006Oooool3o`000;oo
oooo001eooooo`Co00005oooool2o`0001Sooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0Eooooo`;o00005oooool4o`000<;ooooo001iooooo`?o00005_ooool2o`0001Kooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0Dooooo`;o00005_ooool3o`000<Kooooo001l
ooooo`?o00005Oooool2o`0001Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0C
ooooo`;o00005Oooool3o`000<Wooooo001oooooo`?o00005?ooool2o`0001Cooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`0Aooooo`;o00005?ooool3o`000<cooooo0022ooooo`Co
00004_ooool2o`0001;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0@ooooo`;o
00004_ooool4o`000<oooooo0026ooooo`?o00004Oooool2o`00017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0?ooooo`;o00004Oooool3o`000=?ooooo0029ooooo`?o00004?oo
ool2o`00013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0=ooooo`;o00004?oo
ool3o`000=Kooooo002<ooooo`?o00003oooool2o`0000kooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo0ol0003Iooooo`00Soooool4o`00
00gooooo0_l0000=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool2o`00
00cooooo1?l0003Looooo`00Toooool3o`0000cooooo0_l0000<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool02_ooool2o`0000_ooooo0ol0003Pooooo`00U_ooool3o`0000_ooooo
0_l0000:ooooo`04o`000?ooooooooooooooo`Ooi^KV0oooool00ol0003oooooooooo`09ooooo`;o
00002_ooool3o`000>?ooooo002Iooooo`?o00002_ooool2o`0000Wooooo00?o0000onKVi_oVi^H0
2OoVi^H00ol0003oooooooooo`08ooooo`;o00002Oooool3o`000>Kooooo002Looooo`Co00002?oo
ool00ol0003oooooooooo`06ooooo`goi^KV2?ooool2o`0000Oooooo1?l0003Yooooo`00X?ooool3
o`0000Kooooo0_l00005ooooo`ooi^KV1Oooool2o`0000Kooooo0ol0003]ooooo`00Xoooool3o`00
00Gooooo0_l00002oooooa7oi^KV0_ooool2o`0000Gooooo0ol0003`ooooo`00Y_ooool3o`0000Co
oooo00?o0000onKVi_oVi^H04OoVi^H00ol0003oooooooooo`02ooooo`?o0000loooool00:Wooooo
1?l000000oooooooi^KVonKViP0AonKViP03ooooool0003o000000;o0000m_ooool00:gooooo5OoV
i^Kjooooo`00[Oooool7onKViPKo00002?oVi^Kjooooo`00[Oooool9onKViP;o00002_oVi^Kjoooo
o`00[Oooool9onKViP;o00002_oVi^Kjooooo`00[Oooool9onKViP;o00002_oVi^Kjooooo`00[Ooo
ool8onKViPGo00002?oVi^Kjooooo`00[Oooool9onKViP;o00002_oVi^Kjooooo`00[_ooool9onKV
iP?o00001ooVi^Kkooooo`00[_oooolConKVi__ooooo002_oooooa7oi^KVo?ooool00;3ooooo3ooV
i^Kmooooo`00/Oooool=onKVi_kooooo002booooo`_oi^KVooooool00;Cooooo1ooVi^Koooooo`;o
oooo0000\
\>"],
  ImageRangeCache->{{{0, 443.625}, {273.812, 0}} -> {-2.2123, -1.04247, \
0.0120361, 0.00396239}}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination without restricting templates", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of recombined chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
recChromos = Join @@ Table[
  Recombination[theChromos, SelectionMode -> RANDOM], {5}];

recChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[b, 4], g[c, 5], h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, e], a]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
                  h[5, g[a, 
                      h[5, g[f[4, g[b, 4], e, h[e, g[c, 5]], a], 5], 
                        g[a, d, c]]], g[c, e, d]]]]]\)},
          {\(chromo[q[undef], p[b]]\)},
          {\(chromo[q[undef], p[f[4, g[b, e], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[4, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, e, e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], g[b, 4], h[e, g[c, 5]], a]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], 
                g[ c, 5], 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, e], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ a, 4, 4]], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ 
                        f[ 4, 
                          g[ b, 4], e, 
                          h[ e, 
                            g[ c, 5]], a], 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]], 
          chromo[ 
            q[ undef], 
            p[ b]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, e], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ 4, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, e, e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], 
                g[ b, 4], 
                h[ e, 
                  g[ c, 5]], a]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ recChromos;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co0000@_ooool4o`0001kooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000@_ooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o00000_ooool2o`0001gooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`Co00008_ooool4o`0004?ooooo1?l0
000Nooooo`?oi^KV1_l00002onKViRoooooo000[ooooo`;o00009Oooool3o`0006Kooooo2OoVi^H`
ooooo`00:_ooool3o`0002Kooooo0_l0001Wooooo`Ooi^KV<Oooool009cooooo00?o0000oooooooo
ool07_ooool5onKViS;ooooo000_ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
B?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo000`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo03Gooooo000`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0B_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000aooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo000aooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo
000booooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Oooooo000coooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo03Sooooo000dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Wooooo000dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Doooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[o
oooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03_ooooo000f
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo03_ooooo000gooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Eoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo000gooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo03cooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
FOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03gooooo000hooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0F_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03gooooo000iooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
03kooooo000iooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0G?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0GOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo
000jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo000koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo043ooooo000kooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo043ooooo000looooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOoo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo047ooooo000mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Hoooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04;o
oooo000nooooo`Goi^KVIoooool5onKViTGooooo000mooooo`03onKVi_l0003o000000;o00000_oV
i^IUooooo`Ooi^KVA?ooool003cooooo1OoVi^H2o`0000;oi^KVHoooool9onKViT?ooooo0009oooo
o`Co0000;_ooool3onKViPGo00000ooVi^H^ooooo`Co0000;oooool2onKViPOo00000_oVi^H_oooo
o`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o
0000<_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l0
00003oooool000Oooooo1_l0000^ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`Ko0000
;_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H_ooooo`Co00003oooool000Oooooo0_l0
00000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o00000_oo
ool2o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_ooool2o`000003ooooool0
003o000000oooooo0008ooooo`Co00000oooool2o`0002[ooooo0ooVi^H6o`0000;oi^KV;_ooool4
o`0002oooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009ooooo`?o00001Oooool2o`00
02Wooooo2OoVi^ISooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0H?ooool00ol0003oooooo`000002o`0000Co
i^KV:?ooool3o`0001Wooooo000Fooooo`;o00009_ooool5onKViP?ooooo0_l0001Mooooo`;o0000
0oooool5onKViROooooo0_l0000Looooo`006?ooool3o`0002gooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0ol0000Nooooo`006oooool2
o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02_ooooo0_l0000Qooooo`007Oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0ol0000Sooooo`007oooool3o`0002Wo
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo0_l0000Vooooo`008_ooool2o`0002Sooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo
0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0000Wooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`?o0000:_ooool002Oooooo0_l0000V
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0U
ooooo`;o0000;Oooool002Wooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000;oooool002_ooooo0ol0000Sooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o
0000<_ooool002kooooo0_l0000Rooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`;o0000
8_ooool3o`0003Cooooo000`ooooo`?o00008Oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool08?ooool2o`0003Oooooo000cooooo`;o00008?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2
o`0003Wooooo000eooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool3o`0003_ooooo000gooooo`?o00007Oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`0003ko
oooo000jooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo
0ol00010ooooo`00??ooool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo0_l00013ooooo`00?oooool2o`0001[ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0ol00015
ooooo`00@Oooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo0_l00018ooooo`00@oooool3o`0001Oooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0001:ooooo`00
A_ooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo0_l0000Fooooo`?o0000
C?ooool004Sooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Dooooo`;o0000Coooool004_ooooo0_l0000Dooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`?o0000DOooool0
04gooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`;o0000E?ooool004oooooo0ol0000Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000E_ooool005;ooooo
0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o00004?ooool3o`0005Sooooo
001Dooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool2o`0005_ooooo001Gooooo`;o00003_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0005gooooo001Ioooo
o`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool2o`00063ooooo001Kooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3o`0006;ooooo001Nooooo`;o0000
2_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo0_l0001Uooooo`00H?oo
ool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo0_l0001Wooooo`00Hoooool2o`0000Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0ol0001Yooooo`00IOooool2o`00
00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo0_l0001/ooooo`00Ioooool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0001^ooooo`00J_ooool2o`0000Cooooo
0_l00004ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000LOooool006cooooo0ol0
0003ooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool00_ooool3o`0007?ooooo001_
ooooo`;o00000_ooool7onKViP;ooooo0_l0001fooooo`00LOooool00ol0003oi^KVo`000005o`00
00;oi^KV00?o0000ooooooooool0M_ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo
1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5
o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;o
i^KVNOooool007?ooooo1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co0000@_ooool4o`0001kooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000@_ooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o00000_ooool2o`0001gooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`Co00008_ooool4o`0004?ooooo1?l0
000Nooooo`?oi^KV1_l00002onKViRoooooo000[ooooo`;o00009Oooool3o`0006Kooooo2OoVi^H`
ooooo`00:_ooool3o`0002Kooooo0_l0001Wooooo`Ooi^KV<Oooool009cooooo00?o0000oooooooo
ool07_ooool5onKViS;ooooo000_ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
B?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo000`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo03Gooooo000`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0B_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000aooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo000aooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo
000booooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Oooooo000coooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo03Sooooo000dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Wooooo000dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Doooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[o
oooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03_ooooo000f
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo03_ooooo000gooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Eoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo000gooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo03cooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
FOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03gooooo000hooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0F_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03gooooo000iooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
03kooooo000iooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0G?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0GOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo
000jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo000koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo043ooooo000kooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo043ooooo000looooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOoo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo047ooooo000mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Hoooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04;o
oooo000nooooo`Goi^KVIoooool5onKViTGooooo000mooooo`03onKVi_l0003o000000;o00000_oV
i^IUooooo`Ooi^KVA?ooool003cooooo1OoVi^H2o`0000;oi^KVHoooool9onKViT?ooooo0009oooo
o`Co0000;_ooool3onKViPGo00000ooVi^H^ooooo`Co0000;oooool2onKViPOo00000_oVi^H_oooo
o`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o
0000<_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l0
00003oooool000Oooooo1_l0000^ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`Ko0000
;_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H_ooooo`Co00003oooool000Oooooo0_l0
00000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o00000_oo
ool2o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_ooool2o`000003ooooool0
003o000000oooooo0008ooooo`Co00000oooool2o`0002[ooooo0ooVi^H6o`0000;oi^KV;_ooool4
o`0002oooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009ooooo`?o00001Oooool2o`00
02Wooooo2OoVi^ISooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0H?ooool00ol0003oooooo`000002o`0000Co
i^KV:?ooool3o`0001Wooooo000Fooooo`;o00009_ooool5onKViP?ooooo0_l0001Mooooo`;o0000
0oooool5onKViROooooo0_l0000Looooo`006?ooool3o`0002gooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0ol0000Nooooo`006oooool2
o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02_ooooo0_l0000Qooooo`007Oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0ol0000Sooooo`007oooool3o`0002Wo
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo0_l0000Vooooo`008_ooool2o`0002Sooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo
0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0000Wooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`?o0000:_ooool002Oooooo0_l0000V
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0U
ooooo`;o0000;Oooool002Wooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000;oooool002_ooooo0ol0000Sooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o
0000<_ooool002kooooo0_l0000Rooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`;o0000
8_ooool3o`0003Cooooo000`ooooo`?o00008Oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool08?ooool2o`0003Oooooo000cooooo`;o00008?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2
o`0003Wooooo000eooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool3o`0003_ooooo000gooooo`?o00007Oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`0003ko
oooo000jooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo
0ol00010ooooo`00??ooool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo0_l00013ooooo`00?oooool2o`0001[ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0ol00015
ooooo`00@Oooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo0_l00018ooooo`00@oooool3o`0001Oooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0001:ooooo`00
A_ooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo0_l0000Fooooo`?o0000
C?ooool004Sooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Dooooo`;o0000Coooool004_ooooo0_l0000Dooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`?o0000DOooool0
04gooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`;o0000E?ooool004oooooo0ol0000Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000E_ooool005;ooooo
0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o00004?ooool3o`0005Sooooo
001Dooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool2o`0005_ooooo001Gooooo`;o00003_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0005gooooo001Ioooo
o`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool2o`00063ooooo001Kooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3o`0006;ooooo001Nooooo`;o0000
2_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo0_l0001Uooooo`00H?oo
ool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo0_l0001Wooooo`00Hoooool2o`0000Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0ol0001Yooooo`00IOooool2o`00
00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo0_l0001/ooooo`00Ioooool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0001^ooooo`00J_ooool2o`0000Cooooo
0_l00004ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000LOooool006cooooo0ol0
0003ooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool00_ooool3o`0007?ooooo001_
ooooo`;o00000_ooool7onKViP;ooooo0_l0001fooooo`00LOooool00ol0003oi^KVo`000005o`00
00;oi^KV00?o0000ooooooooool0M_ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo
1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5
o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;o
i^KVNOooool007?ooooo1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.40693 .21092 -5 -6 ]
[.40693 .21092 5 6 ]
[.56847 .21092 -5 -6 ]
[.56847 .21092 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.4877 .40712 m
.40693 .21092 L
s
.4877 .40712 m
.56847 .21092 L
s
1 g
.05 w
.40693 .21092 Mdot
0 g
gsave
.40693 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.56847 .21092 Mdot
0 g
gsave
.56847 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co00002oooool4o`0002;ooooo1?l0000=ooooo`Co00007_ooool3
onKViPGo00000ooVi^H_ooooo`00:oooool2o`000003ooooool0003o000002?ooooo0_l0000;oooo
o`;o00000_ooool2o`00023ooooo0_l00002ooooo`;o00002oooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`0000[o
oooo0_l0000Xooooo`;o00002oooool6o`0001gooooo0_oVi^H2o`0000;oi^KV0_l00003onKViRoo
oooo000[ooooo`;o000000?oooooo`000?l000008?ooool2o`000003ooooool0003o000000_ooooo
0_l00002ooooo`;o00009?ooool2o`0000_ooooo0_l00002ooooo`;o00007Oooool2onKViP;o0000
0_oVi^H2o`0000?oi^KV;oooool002_ooooo1?l0000Rooooo`Co00003?ooool4o`00027ooooo1Ol0
000=ooooo`Co00007_ooool3onKViPKo00000_oVi^H_ooooo`00:oooool2o`0002Gooooo0ol0000a
ooooo`;o0000<oooool9onKViS3ooooo000Zooooo`?o00009_ooool2o`00037ooooo1_l0000`oooo
o`Ooi^KV<Oooool009cooooo00?o0000ooooooooool07_ooool5onKViS;ooooo000_ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0dooooo`00<?oo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0=Ooo
ool0033ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo03Gooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0fooooo`00<Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Go
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool0=_ooool0037ooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo03Kooooo000booooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0gooooo`00<_ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0=oooool003?ooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo03Sooooo000cooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0hooooo`00
<oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
>?ooool003Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo03Wooooo000dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0iooooo`00=Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0>_ooool003Gooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0jooooo`00=_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0>oooool003Kooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03_ooooo000goooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0loooo
o`00=oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0??ooool003Sooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Sooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0mooooo`00>?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0?Oooool003Wooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo03kooooo000iooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0nooooo`00>_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Wooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0?oooool003[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo000j
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0o
ooooo`00>oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0@?ooool003_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo043ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`11ooooo`00??ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0@Oooool003cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0;?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo047ooooo000mooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`12ooooo`00?Oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@_ooool003kooooo
1OoVi^Haooooo`Goi^KV<Oooool5onKViTGooooo000mooooo`03onKVi_l0003o000000;o00000_oV
i^H_ooooo`03onKVi_l0003o000000;o00000_oVi^H_ooooo`Ooi^KVA?ooool003cooooo1OoVi^H2
o`0000;oi^KV;Oooool5onKViP;o00000_oVi^H]ooooo`Woi^KV@oooool000Wooooo1?l0000^oooo
o`?oi^KV1Ol00003onKViR_ooooo0ooVi^H5o`0000?oi^KV:oooool2onKViPOo00000_oVi^H_oooo
o`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H[ooooo`;o
i^KV0_l00002onKViP;o00000ooVi^H[ooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViRko
oooo0_l000000ooooooo0000o`00000?ooooo`001oooool6o`0002kooooo0_oVi^H2o`0000;oi^KV
0_l00003onKViR_ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViR_ooooo0ooVi^H2o`000003onKV
i_l0003o000000?oi^KV;oooool4o`0000oooooo0007ooooo`;o000000?oooooo`000?l00000;ooo
ool2onKViP;o00000_oVi^H2o`0000?oi^KV:oooool2onKViP;o00000_oVi^H2o`0000?oi^KV:ooo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l000003ooo
ool000Sooooo1?l00003ooooo`;o0000:_ooool3onKViPKo00000_oVi^H[ooooo`?oi^KV1_l00002
onKViR_ooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009ooooo`?o00001Oooool2o`00
02Wooooo2OoVi^H]ooooo`Woi^KV;Oooool2onKViP;o00001OoVi^HZooooo`;o00005oooool000[o
oooo0_l00007ooooo`?o00009oooool7onKViP03ooooool0003ooooo02cooooo1ooVi^H]ooooo`03
o`000?oooooo000000;o00001?oVi^HXooooo`?o00006Oooool001Kooooo0_l0000Vooooo`Goi^KV
0oooool2o`0002cooooo1OoVi^H/ooooo`;o00000oooool5onKViROooooo0_l0000Looooo`006?oo
ool3o`0002gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo02cooooo0ol0000Nooooo`006oooool2o`0002cooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02_ooooo0_l0000Qooooo`007Oooool2o`00
02_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
02Wooooo0ol0000Sooooo`007oooool3o`0002Wooooo00?o0000ooooooooool0:?ooool00ol0003o
ooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0_l0000Vooooo`008_ooool2o`0002Sooooo
0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0
000Wooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Vooooo`?o0000:_ooool002Oooooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`;o0000;Oooool002Wooooo0_l0000Uoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Soooo
o`?o0000;oooool002_ooooo0ol0000Sooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0Rooooo`;o0000<_ooool002kooooo0_l0000Rooooo`;o0000
8_ooool00ol0003oooooooooo`0Pooooo`;o00008_ooool3o`0003Cooooo000`ooooo`?o00008Ooo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?oo
ool2o`0003Oooooo000cooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool07oooool2o`0003Wooooo000eooooo`;o00007oooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool3o`00
03_ooooo000gooooo`?o00007Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool07?ooool2o`0003kooooo000jooooo`;o00007?ooool2o`0001cooooo
00?o0000ooooooooool06_ooool2o`0001cooooo0ol00010ooooo`00??ooool3o`0001_ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo0_l0
0013ooooo`00?oooool2o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo01Sooooo0ol00015ooooo`00@Oooool2o`0001Wooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0_l00018oooo
o`00@oooool3o`0001Oooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Kooooo0_l0001:ooooo`00A_ooool2o`0001Kooooo0_l0000Fooooo`03o`00
0?oooooooooo01Cooooo0_l0000Fooooo`?o0000C?ooool004Sooooo0ol0000Eooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Dooooo`;o0000Cooo
ool004_ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`?o0000DOooool004gooooo0_l0000Cooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000E?ooool004oo
oooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0@ooooo`;o0000E_ooool005;ooooo0_l0000@ooooo`;o00004?ooool00ol0003ooooo
ooooo`0>ooooo`;o00004?ooool3o`0005Sooooo001Dooooo`?o00003oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`0005_ooooo001G
ooooo`;o00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool3o`0005gooooo001Iooooo`;o00003Oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool2o`00063ooooo001Kooooo`?o
00002oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02Oooool3o`0006;ooooo001Nooooo`;o00002_ooool2o`0000[ooooo00?o0000ooooooooool0
2?ooool2o`0000[ooooo0_l0001Uooooo`00H?ooool3o`0000Wooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo0_l0001Wooooo`00Hoooool2
o`0000Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Kooooo0ol0001Yooooo`00IOooool2o`0000Oooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo0_l0001/ooooo`00Ioooool3o`0000Go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo0ol0001^ooooo`00J_ooool2o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo
0_l00004ooooo`;o0000LOooool006cooooo0ol00003ooooo`03o`000?ooooooi^KV00Coi^KV00?o
ooooo`000?ooool00_ooool3o`0007?ooooo001_ooooo`;o00000_ooool7onKViP;ooooo0_l0001f
ooooo`00LOooool00ol0003oi^KVo`000005o`0000;oi^KV00?o0000ooooooooool0M_ooool0077o
oooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oV
i^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`00
00Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;oi^KVNOooool007?ooooo1ooVi^Ijooooo`00M?oo
ool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 1.47151 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.179 .01472 -5 -6 ]
[.179 .01472 5 6 ]
[.34481 .01472 -5 -6 ]
[.34481 .01472 5 6 ]
[.2619 .30902 -5 -6 ]
[.2619 .30902 5 6 ]
[.5 .30902 -5 -6 ]
[.5 .30902 5 6 ]
[.65519 .01472 -5 -6 ]
[.65519 .01472 5 6 ]
[.821 .01472 -5 -6 ]
[.821 .01472 5 6 ]
[.7381 .30902 -5 -6 ]
[.7381 .30902 5 6 ]
[.97619 .30902 -5 -6 ]
[.97619 .30902 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .30902 L
s
.5 .60332 m
.2619 .30902 L
s
.5 .60332 m
.5 .30902 L
s
.5 .60332 m
.7381 .30902 L
s
.5 .60332 m
.97619 .30902 L
s
1 g
.05 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .30902 m
.179 .01472 L
s
.2619 .30902 m
.34481 .01472 L
s
1 g
.05 w
.179 .01472 Mdot
0 g
gsave
.179 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.34481 .01472 Mdot
0 g
gsave
.34481 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.2619 .30902 Mdot
0 g
gsave
.2619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .30902 Mdot
0 g
gsave
.5 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .30902 m
.65519 .01472 L
s
.7381 .30902 m
.821 .01472 L
s
1 g
.05 w
.65519 .01472 Mdot
0 g
gsave
.65519 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.821 .01472 Mdot
0 g
gsave
.821 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.9 g
.7381 .30902 Mdot
0 g
gsave
.7381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .30902 Mdot
0 g
gsave
.97619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool002_ooooo1Ol0000Tooooo`Co0000@oooool4o`0002?ooooo1?l0
000^ooooo`00;?ooool2o`000003ooooool0003o000002Cooooo0_l00013ooooo`;o00009Oooool2
o`00037ooooo000/ooooo`;o000000?oooooo`000?l000008Oooool6o`0004;ooooo1_l0000Qoooo
o`Ko0000;Oooool002cooooo0_l000000ooooooo0000o`00000Qooooo`;o000000?oooooo`000?l0
0000@oooool2o`0000;ooooo0_l0000Qooooo`;o00000_ooool2o`0002gooooo000/ooooo`Co0000
8oooool4o`0004Cooooo1?l0000Sooooo`Co0000;_ooool002cooooo0_l0000Vooooo`?o0000WOoo
ool002_ooooo0ol0000Wooooo`;o0000WOooool00?Cooooo000`ooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo02oo
oooo000`ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0BOooool00ol0003ooooo
ooooo`0Pooooo`03o`000?oooooooooo02oooooo000`ooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0BOooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo02oooooo000`
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo02oooooo000aooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool0Boooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo033ooooo000aooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo033ooooo000aooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
Boooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo033ooooo000aooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo033ooooo000booooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0COooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo037ooooo000booooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
037ooooo000booooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0COooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo037ooooo000cooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03;ooooo
000cooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Coooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo03;ooooo000cooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool0Coooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03;ooooo000coooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo03;ooooo000dooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool0DOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03?ooooo000dooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo03?ooooo000dooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Dooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo03?ooooo000dooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo03?ooooo000eooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0Doooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo03Cooooo000eooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Co
oooo000eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0EOooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo03Cooooo000fooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo03Gooooo000f
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo03Gooooo000fooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0Eoooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03Gooooo000fooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo03Gooooo000gooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
Eoooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03Kooooo000gooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo03Kooooo000gooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0FOooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Kooooo000hooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
03Oooooo000hooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0FOooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo03Oooooo000hooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool0Foooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03Oooooo
000hooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Foooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo03Oooooo000iooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool0Foooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03Sooooo000ioooo
o`03o`000?oooooooooo00kooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo03Sooooo000iooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0GOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03Sooooo000iooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo03Sooooo000jooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0GOoo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03Wooooo000jooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo03Wooooo000jooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Goooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo03Wooooo000kooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo03[o
oooo000kooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Goooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo03[ooooo000kooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0HOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03[ooooo000k
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo03[ooooo000looooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0HOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03_ooooo000looooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo03_ooooo000looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
Hoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo03_ooooo000mooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0IOooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03cooooo000mooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03cooooo000mooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0IOooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo03cooooo000nooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0IOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03gooooo
000nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Ioooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo03gooooo000nooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0Ioooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03gooooo000noooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo03gooooo000oooooo`05o`000?ooooooooooooooool00000Joooool01Ol0
003ooooooooooooooooo0000043ooooo000oooooo`05o`000?ooooooooooooooool00000Joooool0
1Ol0003ooooooooooooooooo0000043ooooo000oooooo`05o`000?ooooooooooooooool00000Jooo
ool01Ol0003ooooooooooooooooo0000043ooooo000oooooo`Goi^KVJ_ooool5onKViP03o`000?oo
oooooooo03kooooo000nooooo`03onKVi_l0003o000000;o00000_oVi^IXooooo`Ooi^KV@?ooool0
03gooooo1OoVi^H2o`0000;oi^KVI_ooool9onKViSoooooo0009ooooo`Co0000;oooool3onKViPGo
00000ooVi^H`ooooo`Co0000<?ooool3onKViPOo000000?oi^KVooooooooool0;_ooool5o`0000Wo
oooo000:ooooo`;o0000<?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool2o`0003?ooooo
1?oVi^H2o`000003onKVi_l0003o000000;oi^KV;oooool2o`000003ooooool0003o000000[ooooo
0007ooooo`Ko0000;oooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool6o`0002oooooo1?oV
i^H2o`000003onKVi_l0003o000000;oi^KV<?ooool4o`0000[ooooo0007ooooo`;o000000?ooooo
o`000?l00000<?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool2o`0000;ooooo0_l0000_
ooooo`Coi^KV0_l000000ooVi^Ko0000o`000002onKViRoooooo0_l000000ooooooo0000o`00000:
ooooo`002?ooool4o`00033ooooo0ooVi^H6o`0000;oi^KV<?ooool4o`00033ooooo1?oVi^H4o`00
00?oi^KV<?ooool3o`0000_ooooo0009ooooo`?o00000oooool2o`0002cooooo2OoVi^IVooooo`?o
i^KV0_l00004onKViRgooooo0_l0000@ooooo`002_ooool2o`0000Gooooo00?o0000ooooooooool0
:_ooool7onKViVSooooo00Coi^KVo`000?l0003o00000ooVi^H]ooooo`03o`000?oooooooooo013o
oooo000Booooo`;o0000:oooool5onKViP03ooooool0003ooooo06Kooooo00?o0000onKVi_oVi^H0
0ooVi^H/ooooo`;o00004oooool001Cooooo0_l0000`ooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0<?ooool00ol0003oooooooooo`0^ooooo`;o00005Oooool001Kooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0Eooooo`005oooool2o`0002kooooo00?o0000oooo
ooooool0;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02cooooo0_l0000Hoooo
o`006Oooool2o`0002gooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0^ooooo`03
o`000?oooooooooo02_ooooo0_l0000Jooooo`006oooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo01[ooooo000Looooo`;o0000;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool0:_ooool2o`0001gooooo000Nooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool07Oooool001oooooo0_l0000Zooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Xooooo`;o00008?ooool0027o
oooo0_l0000Yooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`0Wooooo`;o00008_ooool002?ooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Rooooo`009?ooool2o`0002Sooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02Kooooo0_l0000Uooooo`009_ooool2o`0002Oooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Gooooo0_l0000W
ooooo`00:?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Oooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Oooooo000Yooooo`;o
00009Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool08oooool2o`0002[ooooo000[ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
:_ooool002cooooo0_l0000Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?oo
ool00ol0003oooooooooo`0Rooooo`;o0000;Oooool002kooooo0_l0000Sooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Qooooo`;o0000;oooool0
033ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0_ooooo`00<Oooool2o`00027o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01oo
oooo0_l0000booooo`00<oooool2o`00023ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01kooooo0_l0000dooooo`00=Oooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo03Cooooo000fooooo`;o00007oooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07Oooool2o`0003Oooooo000hoooo
o`;o00007_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07?ooool2o`0003Wooooo000jooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0>Oooool003_ooooo0_l0000Looooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Jooooo`;o0000??ooool003gooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0looooo`00?_ooool2o`0001_ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Wooooo0_l0000oooooo`00@?ooool2o`00
01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo
01Sooooo0_l00011ooooo`00@_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo047o
oooo0013ooooo`;o00006?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool05_ooool2o`0004Cooooo0015ooooo`;o00005oooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05Oooool2o`0004Kooooo0017
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0A_ooool004Sooooo0_l0000Foooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Doooo
o`;o0000BOooool004[ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`19ooooo`00
Boooool2o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo01?ooooo0_l0001<ooooo`00COooool2o`0001?ooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo017ooooo0_l0001>ooooo`00Coooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo04kooooo001@ooooo`;o00004_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04?ooool2o`00
057ooooo001Booooo`;o00004Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool03oooool2o`0005?ooooo001Dooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool0Doooool005Gooooo0_l0000?ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0=ooooo`;o0000E_ooool005Oooooo0_l0000>
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0<
ooooo`;o0000F?ooool005Wooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Hoooo
o`00F_ooool2o`0000gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00_ooooo0_l0001Kooooo`00G?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo05_ooooo001Mooooo`;o00003?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02_ooool2o`0005kooooo001Oooooo`;o00002_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool2
o`00063ooooo001Qooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0H?ooool006;o
oooo0_l00009ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`07ooooo`;o0000Hoooool006Cooooo0_l00008ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`;o0000IOooool006Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`1Uooooo`00Ioooool2o`0000Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo0_l0001X
ooooo`00JOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06Sooooo001Zooooo`;o
00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool00oooool2o`0006_ooooo001/ooooo`;o00001?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_ooool2o`0006gooooo001^ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0KOooool006oooooo0_l00003ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool2o`00073ooooo001a
ooooo`;o000000?oooooo`000?ooool00oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
0000o`0007;ooooo001cooooo`04o`000?oooooo0000ooooo`Goi^KV00Coooooo`000?oooooo0000
M?ooool007Cooooo0_l00007onKViP;o0000MOooool007Gooooo00?oi^KVo`000?l000001?l00002
onKViWKooooo001dooooo`Coi^KV0_l00005onKViWGooooo001dooooo`Coi^KV0_l00005onKViWGo
oooo001dooooo`Coi^KV0_l00005onKViWGooooo001dooooo`?oi^KV1Ol00003onKViWGooooo001d
ooooo`Coi^KV0_l00005onKViWGooooo001eooooo`Coi^KV0ol00002onKViWKooooo001fooooo`Oo
i^KVMoooool007Oooooo1OoVi^Ihooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18051, -0.417422, \
0.0179466, 0.00290382}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.367877 [
[.02381 .52974 -5 -6 ]
[.02381 .52974 5 6 ]
[.11133 .45617 -5 -6 ]
[.11133 .45617 5 6 ]
[.16114 .45617 -5 -6 ]
[.16114 .45617 5 6 ]
[.12422 .38259 -5 -6 ]
[.12422 .38259 5 6 ]
[.21096 .38259 -5 -6 ]
[.21096 .38259 5 6 ]
[.29769 .38259 -5 -6 ]
[.29769 .38259 5 6 ]
[.21096 .45617 -5 -6 ]
[.21096 .45617 5 6 ]
[.16114 .52974 -5 -6 ]
[.16114 .52974 5 6 ]
[.29847 .52974 -5 -6 ]
[.29847 .52974 5 6 ]
[.38599 .45617 -5 -6 ]
[.38599 .45617 5 6 ]
[.35552 .38259 -5 -6 ]
[.35552 .38259 5 6 ]
[.61572 .38259 -5 -6 ]
[.61572 .38259 5 6 ]
[.48562 .45617 -5 -6 ]
[.48562 .45617 5 6 ]
[.43581 .52974 -5 -6 ]
[.43581 .52974 5 6 ]
[.57314 .52974 -5 -6 ]
[.57314 .52974 5 6 ]
[.66066 .45617 -5 -6 ]
[.66066 .45617 5 6 ]
[.62374 .38259 -5 -6 ]
[.62374 .38259 5 6 ]
[.68395 .30902 -5 -6 ]
[.68395 .30902 5 6 ]
[.64564 .16187 -5 -6 ]
[.64564 .16187 5 6 ]
[.65867 .08829 -5 -6 ]
[.65867 .08829 5 6 ]
[.71844 .08829 -5 -6 ]
[.71844 .08829 5 6 ]
[.68856 .16187 -5 -6 ]
[.68856 .16187 5 6 ]
[.73147 .16187 -5 -6 ]
[.73147 .16187 5 6 ]
[.7445 .08829 -5 -6 ]
[.7445 .08829 5 6 ]
[.73923 .01472 -5 -6 ]
[.73923 .01472 5 6 ]
[.86933 .01472 -5 -6 ]
[.86933 .01472 5 6 ]
[.80428 .08829 -5 -6 ]
[.80428 .08829 5 6 ]
[.77439 .16187 -5 -6 ]
[.77439 .16187 5 6 ]
[.81731 .16187 -5 -6 ]
[.81731 .16187 5 6 ]
[.73147 .23544 -5 -6 ]
[.73147 .23544 5 6 ]
[.86293 .23544 -5 -6 ]
[.86293 .23544 5 6 ]
[.7972 .30902 -5 -6 ]
[.7972 .30902 5 6 ]
[.84473 .23544 -5 -6 ]
[.84473 .23544 5 6 ]
[.91046 .23544 -5 -6 ]
[.91046 .23544 5 6 ]
[.97619 .23544 -5 -6 ]
[.97619 .23544 5 6 ]
[.91046 .30902 -5 -6 ]
[.91046 .30902 5 6 ]
[.7972 .38259 -5 -6 ]
[.7972 .38259 5 6 ]
[.71047 .45617 -5 -6 ]
[.71047 .45617 5 6 ]
[.67355 .38259 -5 -6 ]
[.67355 .38259 5 6 ]
[.76029 .38259 -5 -6 ]
[.76029 .38259 5 6 ]
[.84702 .38259 -5 -6 ]
[.84702 .38259 5 6 ]
[.76029 .45617 -5 -6 ]
[.76029 .45617 5 6 ]
[.71047 .52974 -5 -6 ]
[.71047 .52974 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .52974 L
s
.36714 .60332 m
.16114 .52974 L
s
.36714 .60332 m
.29847 .52974 L
s
.36714 .60332 m
.43581 .52974 L
s
.36714 .60332 m
.57314 .52974 L
s
.36714 .60332 m
.71047 .52974 L
s
1 g
.05 w
.02381 .52974 Mdot
0 g
gsave
.02381 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .52974 m
.11133 .45617 L
s
.16114 .52974 m
.16114 .45617 L
s
.16114 .52974 m
.21096 .45617 L
s
1 g
.05 w
.11133 .45617 Mdot
0 g
gsave
.11133 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .45617 Mdot
0 g
gsave
.16114 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .45617 m
.12422 .38259 L
s
.21096 .45617 m
.21096 .38259 L
s
.21096 .45617 m
.29769 .38259 L
s
1 g
.05 w
.12422 .38259 Mdot
0 g
gsave
.12422 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.21096 .38259 Mdot
0 g
gsave
.21096 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.29769 .38259 Mdot
0 g
gsave
.29769 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .45617 Mdot
0 g
gsave
.21096 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .52974 Mdot
0 g
gsave
.16114 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .52974 Mdot
0 g
gsave
.29847 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .52974 m
.38599 .45617 L
s
.43581 .52974 m
.48562 .45617 L
s
1 g
.05 w
.38599 .45617 Mdot
0 g
gsave
.38599 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .45617 m
.35552 .38259 L
s
.48562 .45617 m
.61572 .38259 L
s
1 g
.05 w
.35552 .38259 Mdot
0 g
gsave
.35552 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .38259 Mdot
0 g
gsave
.61572 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .45617 Mdot
0 g
gsave
.48562 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .52974 Mdot
0 g
gsave
.43581 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .52974 Mdot
0 g
gsave
.57314 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .52974 m
.66066 .45617 L
s
.71047 .52974 m
.71047 .45617 L
s
.71047 .52974 m
.76029 .45617 L
s
1 g
.05 w
.66066 .45617 Mdot
0 g
gsave
.66066 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .45617 m
.62374 .38259 L
s
.71047 .45617 m
.7972 .38259 L
s
1 g
.05 w
.62374 .38259 Mdot
0 g
gsave
.62374 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .38259 m
.68395 .30902 L
s
.7972 .38259 m
.7972 .30902 L
s
.7972 .38259 m
.91046 .30902 L
s
1 g
.05 w
.68395 .30902 Mdot
0 g
gsave
.68395 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .30902 m
.73147 .23544 L
s
.7972 .30902 m
.86293 .23544 L
s
.73147 .23544 m
.64564 .16187 L
s
.73147 .23544 m
.68856 .16187 L
s
.73147 .23544 m
.73147 .16187 L
s
.73147 .23544 m
.77439 .16187 L
s
.73147 .23544 m
.81731 .16187 L
s
1 g
.05 w
.64564 .16187 Mdot
0 g
gsave
.64564 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.68856 .16187 m
.65867 .08829 L
s
.68856 .16187 m
.71844 .08829 L
s
1 g
.05 w
.65867 .08829 Mdot
0 g
gsave
.65867 .08829 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.71844 .08829 Mdot
0 g
gsave
.71844 .08829 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.68856 .16187 Mdot
0 g
gsave
.68856 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.73147 .16187 Mdot
0 g
gsave
.73147 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.77439 .16187 m
.7445 .08829 L
s
.77439 .16187 m
.80428 .08829 L
s
1 g
.05 w
.7445 .08829 Mdot
0 g
gsave
.7445 .08829 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80428 .08829 m
.73923 .01472 L
s
.80428 .08829 m
.86933 .01472 L
s
1 g
.05 w
.73923 .01472 Mdot
0 g
gsave
.73923 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.86933 .01472 Mdot
0 g
gsave
.86933 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80428 .08829 Mdot
0 g
gsave
.80428 .08829 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.77439 .16187 Mdot
0 g
gsave
.77439 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.81731 .16187 Mdot
0 g
gsave
.81731 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.73147 .23544 Mdot
0 g
gsave
.73147 .23544 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
1 g
.86293 .23544 Mdot
0 g
gsave
.86293 .23544 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .30902 Mdot
0 g
gsave
.7972 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .30902 m
.84473 .23544 L
s
.91046 .30902 m
.91046 .23544 L
s
.91046 .30902 m
.97619 .23544 L
s
1 g
.05 w
.84473 .23544 Mdot
0 g
gsave
.84473 .23544 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .23544 Mdot
0 g
gsave
.91046 .23544 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .23544 Mdot
0 g
gsave
.97619 .23544 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .30902 Mdot
0 g
gsave
.91046 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .38259 Mdot
0 g
gsave
.7972 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .45617 Mdot
0 g
gsave
.71047 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .45617 m
.67355 .38259 L
s
.76029 .45617 m
.76029 .38259 L
s
.76029 .45617 m
.84702 .38259 L
s
1 g
.05 w
.67355 .38259 Mdot
0 g
gsave
.67355 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .38259 Mdot
0 g
gsave
.76029 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .38259 Mdot
0 g
gsave
.84702 .38259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .45617 Mdot
0 g
gsave
.76029 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .52974 Mdot
0 g
gsave
.71047 .52974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:oooooo1?l0000Jooooo`Co00008oooool00:kooooo0_l00002
ooooo`;o00006?ooool2o`0000;ooooo0_l0000Rooooo`00[_ooool2o`00023ooooo0_l0000Roooo
o`00[_ooool2o`0000;ooooo0_l0000Looooo`;o00008_ooool00:oooooo1?l0000Iooooo`Go0000
8oooool00<cooooo0_l0000Vooooo`00c?ooool6o`0002;ooooo002eooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool09_ooool00;Kooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Wooooo`00]oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02Sooooo
002hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:Oooool00;Wooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0Zooooo`00^Oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo02[ooooo002jooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0:oooool00;_ooooo00?o0000ooooooooool01OoVi^H2ooooo`03o`000?oooooooooo02cooooo
002looooo`03o`000?oVi^Ko000000?o00000_oVi^H00ol0003oooooooooo`0]ooooo`00_?ooool5
onKViP;o00000_oVi^H_ooooo`00Voooool5o`0000_ooooo0_l00003ooooo`Co00001oooool3onKV
iPGo00000ooVi^H^ooooo`00W?ooool2o`000003ooooool0003o000000_ooooo00?o0000oooooooo
ool00_l0000:ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H^ooooo`00W?ooool2o`000003oooo
ool0003o000000Sooooo1?l00002ooooo`Ko00001_ooool2onKViP;o00000_oVi^H2o`0000?oi^KV
;_ooool009cooooo0_l000000ooooooo0000o`000008ooooo`;o000000Coooooo`000?oooooooooo
0_l00002ooooo`;o00001_ooool2onKViP;o00000_oVi^H2o`0000?oi^KV;_ooool009cooooo1?l0
000:ooooo`?o00000oooool4o`0000Oooooo0ooVi^H6o`0000;oi^KV;_ooool009cooooo0_l0000=
ooooo`?o00003_ooool9onKViRoooooo002Kooooo`?o00003_ooool2o`0000oooooo1ooVi^H`oooo
o`00__ooool5onKViS7ooooo002Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo002Qooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo03Cooooo002Qooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Cooooo002Rooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
03Gooooo002Rooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo03Gooooo002Rooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Gooooo
002Sooooo`Goi^KV3oooool5onKViSSooooo002Rooooo`03onKVi_l0003o000000;o00000_oVi^H=
ooooo`Ooi^KV=oooool00:7ooooo1OoVi^H2o`0000;oi^KV2oooool9onKViSKooooo002Jooooo`Co
00000_ooool3onKViPGo00000_oVi^H3ooooo`Co00000oooool2onKViPOo000000Coi^KVoooooooo
oooooooo1Ol0000^ooooo`00Voooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00002onKViP;o
oooo0_l00006ooooo`?oi^KV0_l000000ooVi^Ko0000o`000002onKViP;ooooo0_l000000ooooooo
0000o`00000_ooooo`00V?ooool6o`0000;ooooo0_oVi^H2o`0000;oi^KV0_l00002onKViP;ooooo
1_l00002ooooo`?oi^KV0_l000000ooVi^Ko0000o`000002onKViP?ooooo1?l0000_ooooo`00V?oo
ool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l00002onKViP;ooooo0_l0
0002ooooo`;o00000_ooool3onKViP;o000000?oi^KVo`000?l000000_oVi^H2ooooo`;o000000?o
ooooo`000?l00000;oooool009Wooooo1?l00003ooooo`?oi^KV1_l000001?oVi^Kooooooooooooo
ool4o`0000?ooooo0ooVi^H4o`0000?oi^KV0oooool3o`00033ooooo002Jooooo`?o00001?ooool9
onKViP_ooooo0_oVi^H2o`0000Goi^KV=_ooool009_ooooo0_l00003ooooo`03o`000?ooooooi^KV
00Koi^KV3Oooool3o`0000Coi^KV00?oooooo`000?ooool0=?ooool00:7ooooo00?o0000oooooooV
i^H01?oVi^H00ol0003oooooooooo`0;ooooo`03o`000?oVi^Koi^KV00?oi^KV00?oooooo`000?oo
ool0=Oooool00:;ooooo0_l00004ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`02ooooo`;o0000=oooool00:Cooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0gooooo`00YOooool01Ol0003ooooooooooooooooo000000Gooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000003[ooooo002Vooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
0000>oooool00:Oooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`0jooooo`00Z?ooool2o`000003ooooool0003ooooo00;o
oooo00Ko0000ooooooooooooooooo`000?ooool2o`0003gooooo002Zooooo`03o`000?oooooo0000
00;ooooo00Ko0000oooooooooooo0000ooooool0000oooooo`00Zoooool2o`0000Goi^KV0_l00010
ooooo`00[?ooool7onKViT7ooooo002[ooooo`03onKVi_l0003o000000Co00000_oVi^HDooooo`Go
000000?oooooo`000?l000001oooool5o`0000[ooooo1?l0000:ooooo`00Z_ooool4onKViP;o0000
1OoVi^HBooooo`;o000000?oooooo`000?l000000oooool2o`0000Gooooo0_l000000ooooooo0000
o`00000:ooooo`;o00000_ooool2o`0000Wooooo002Zooooo`Coi^KV0_l00005onKViQ?ooooo1?l0
0003ooooo`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00Z_ooool4
onKViP;o00001OoVi^HBooooo`;o000000?oooooo`000?l000000oooool2o`0000Gooooo0_l00000
0ooooooo0000o`00000:ooooo`;o00000_ooool2o`0000Wooooo002Zooooo`?oi^KV1Ol00003onKV
iQ?ooooo0ol00004ooooo`03o`000?oooooooooo00Gooooo1?l0000;ooooo`Co00002_ooool00:[o
oooo1?oVi^H2o`0000Goi^KV9?ooool2o`0001Wooooo002[ooooo`Coi^KV0ol00002onKViQ[ooooo
0ol00007ooooo`?o00006Oooool00:cooooo1ooVi^H00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool03Oooool00:gooooo1OoVi^H2ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0>ooooo`00]Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00kooooo002fooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool03oooool00;Oooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo017ooooo002h
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool04_ooool00;Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0Cooooo`00^_ooool00ol0003oooooonKViP04onKViP?o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`05onKViP;ooooo00?o0000oooooooo
ool04oooool00;_ooooo0_oVi^H4o`000003onKVi_oooooo0000017ooooo00?o0000onKVi_l00000
0ol00002onKViP03o`000?oooooooooo01Cooooo002jooooo`Koi^KV0_l000000ooVi^Kooooooooo
o`0@ooooo`Goi^KV0_l00002onKViQKooooo002Rooooo`Co00004oooool4onKViPGo00000_oVi^H@
ooooo`?oi^KV1Ol00003onKViQGooooo002Qooooo`;o00000_ooool2o`0001;ooooo0ooVi^H2o`00
00;oi^KV0_l00002onKViQ3ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o
00004_ooool3onKViP;o00000_oVi^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?o
i^KV5Oooool00:Gooooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV
0_l00002onKViP;o00000ooVi^HEooooo`00XOooool5o`0001?ooooo1?oVi^H6o`000003onKVi_oo
oooooooo00kooooo0ooVi^H6o`0000;oi^KV5Oooool00:7ooooo0_l00006ooooo`;o00003oooool9
onKViQ7ooooo00?o0000onKVi_oVi^H01ooVi^HFooooo`00XOooool6o`0000Cooooo00?o0000oooo
ooooool03Oooool7onKViQ3ooooo0_l00002ooooo`Ooi^KV5oooool00:cooooo0_l0000>ooooo`Go
i^KV4?ooool00ol0003oooooooooo`03ooooo`Goi^KV6?ooool00:kooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0=ooooo`;o00008oooool00:oooooo0_l0000>ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool08oooool00;7ooooo0_l0000<ooooo`03o`000?oooooo
oooo00[ooooo0_l0000Vooooo`00/oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Sooooo0_l0000Xooooo`00]?ooool2o`0000Wooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
0_l0000[ooooo`00_?ooool5onKViPGooooo00?o0000ooooooooool0:oooool00;_ooooo1ooVi^H2
ooooo`;o0000;_ooool00;_ooooo2?oVi^H00ol0003oooooooooo`0^ooooo`007oooool5o`00013o
oooo1?l0000Aooooo`Co00001oooool5o`0003_ooooo1Ol00007ooooo`Co00004?ooool4o`0000Co
oooo1ol000000ooVi^Koooooooooo`02ooooo`Go00009oooool001kooooo0_l000000ooooooo0000
o`00000Booooo`;o00004oooool2o`0000Wooooo0_l000000ooooooo0000o`00000iooooo`;o0000
00?oooooo`000?l000001oooool2o`0000;ooooo0_l0000>ooooo`;o00001oooool01?oVi^Ko0000
o`000?oVi^H2o`0000;oi^KV0oooool2o`000003ooooool0003o000002Sooooo000Oooooo`Co0000
3oooool6o`0000oooooo1_l00008ooooo`;o000000?oooooo`000?l00000>_ooool4o`0000Oooooo
0_l0000Booooo`Ko00000oooool01?oVi^Ko0000o`000?oVi^H2o`0000;oi^KV0oooool2o`000003
ooooool0003o000002Sooooo000Nooooo`;o000000?oooooo`000?l000003oooool2o`000003oooo
ool0003o0000013ooooo0_l000000ooooooo0000o`000009ooooo`;o000000?oooooo`000?l00000
>Oooool2o`000003ooooool0003o000000Oooooo0_l00002ooooo`;o00003_ooool2o`0000;ooooo
0_l00003ooooo`04onKVi_l0003o0000onKViP;o00000_oVi^H3ooooo`;o000000?oooooo`000?l0
0000:?ooool001oooooo0ol0000Aooooo`Co00004Oooool4o`0000Wooooo1?l0000kooooo`?o0000
2Oooool4o`00013ooooo1?l00004ooooo`03onKVi_l0003o000000;o00000ooVi^H4ooooo`Co0000
:?ooool003Cooooo0ol0000Booooo`?o00002Oooool2o`0000Kooooo00?o0000ooooooooool0;_oo
ool2o`0001Kooooo00?o0000ooooooooool04_ooool2onKViP;o00001?oVi^H7ooooo`;o0000:?oo
ool002Kooooo00?o0000ooooooooool03?ooool2o`0000gooooo0_l00004ooooo`;o00002?ooool3
o`0000Oooooo0_l0000/ooooo`;o00000oooool2o`0000Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0@ooooo`03o`000?oVi^Ko000000;o00000ooVi^H3ooooo`04o`000?oooooo
ooooooooo`?o0000:?ooool002Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0J
ooooo`;o0000:?ooool2o`00013ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0A
ooooo`Goi^KV0oooool00ol0003oooooooooo`0]ooooo`00:?ooool2o`0000_ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0Mooooo`;o00009Oooool00ol0003oooooooooo`0Aoooo
o`;o00002_ooool2o`0000_ooooo0_l0000:ooooo`;o0000<?ooool002[ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo023ooooo0_l0000Qooooo`;o
00005_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0`ooooo`00:oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo0_l0000Uooooo`;o00007Oooool2o`0001Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`05ooooo`?o00002Oooool00ol0003oooooooooo`0aooooo`00;?oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0Hooooo`;o00007?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00?ooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`0booooo`00;Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:Ooo
ool2o`0001Kooooo0_l0000Oooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0<oooool002kooooo0_l0
0005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;?ooool2o`0001?ooooo00?o
0000ooooooooool08?ooool2o`0000[ooooo0ol00004ooooo`03o`000?oooooooooo00?ooooo0_l0
000fooooo`00<?ooool00ol0003oooooooooo`05onKViP?ooooo00?o0000ooooooooool0;oooool2
o`0000Cooooo1OoVi^H6ooooo`;o00009Oooool00ol0003oooooooooo`05onKViP?ooooo0_l00002
ooooo`Goi^KV0_ooool00ol0003oooooooooo`0fooooo`00<Oooool00ol0003oi^KVo`000003o`00
00;oi^KV0_l0000dooooo`;o000000?oooooonKVi_oVi^H01?l000001?oVi^Koooooooooooooool2
o`0002Sooooo00?o0000onKVi_l000000ol00002onKViP;o00000_ooool00ol0003oi^KVo`000003
o`0000;oi^KV00?o0000ooooooooool0=oooool0037ooooo1OoVi^H2o`0000;oi^KV=oooool6onKV
iP;o000000?oi^KVo`000?l00000:_ooool5onKViP;o00000_oVi^H3ooooo`Goi^KV0_l00002onKV
iSWooooo000Looooo`Go00001oooool4o`0000Cooooo0ooVi^H5o`0000?oi^KV8?ooool6o`0000oo
oooo1?oVi^H5o`0000;oi^KV8_ooool4o`0000Cooooo0ooVi^H5o`0000?oi^KV00CoooooonKVi_oV
i^Koi^KV1Ol00003onKViSSooooo000Kooooo`;o000000?oooooo`000?l000001oooool2o`0000Oo
oooo0_oVi^H2o`0000;oi^KV0_l00003onKViR7ooooo0_l000000ooooooo0000o`00000?ooooo`?o
i^KV0_l00002onKViP;o00000_oVi^HQooooo`;o00000_ooool2o`0000?ooooo0_oVi^H2o`0000;o
i^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?ooool001cooooo
1?l00007ooooo`Ko00000oooool2onKViP;o00000_oVi^H2o`0000?oi^KV8_ooool2o`00017ooooo
0ooVi^H2o`0000;oi^KV0_l00002onKViRGooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^H00oooooooi^KVonKViP02o`0000;oi^KV0_l00003onKViSSooooo000Kooooo`;o000000?o
ooooo`000?l000001oooool2o`0000;ooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o00000ooV
i^HSooooo`;o00004?ooool3onKViP;o00000_oVi^H2o`0000;oi^KV9Oooool2o`0000?ooooo0_oV
i^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?oo
ool001cooooo0ol00009ooooo`Co00001?ooool3onKViPKo00000_oVi^HPooooo`;o00000_ooool2
o`0000oooooo1?oVi^H6o`000003onKVi_oooooooooo01oooooo1Ol00004ooooo`?oi^KV1_l00002
onKViP04oooooooVi^Koi^KVonKViPKo00000_oVi^Hhooooo`00<Oooool9onKViR7ooooo0_l00002
ooooo`;o00004?ooool9onKViR;ooooo0_l00008ooooo`Woi^KV0oooool9onKViSWooooo000boooo
o`Ooi^KV8oooool4o`0001;ooooo1ooVi^HSooooo`Ko00001Oooool7onKViPGooooo1ooVi^Hjoooo
o`008Oooool00ol0003oooooooooo`0>ooooo`03o`000?oVi^Koi^KV00?oi^KV:Oooool00ol0003o
ooooooooo`0?ooooo`Goi^KV:_ooool00ol0003oooooooooo`03ooooo`Goi^KV1_ooool00ol0003o
i^KVonKViP03onKViS_ooooo000Rooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
;_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
?oooool002?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo02oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0_ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`10ooooo`008oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0<?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo000Tooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0@Oooool002Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0cooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`12ooooo`009Oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
0000=_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo04;ooooo000Vooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0=Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0@oooool0
02Oooooo00?oi^KVo`000?l000000_l000000ooooooo0000ooooo`0hooooo`03o`000?oVi^Koi^KV
00?oi^KV00?o0000ooooooooool0=oooool00ol0003oi^KVonKViP03onKViP03o`000?oooooooooo
04Cooooo000Vooooo`Goi^KV0_l0000jooooo`Ooi^KV>Oooool7onKViTKooooo0009ooooo`Co0000
6?ooool3onKViPGo000000?oi^KVooooooooool06?ooool4o`0001[ooooo00?oi^KVo`000?l00000
1Ol000000ooVi^Koooooooooo`0Fooooo`Ko00006Oooool00ooVi^Ko0000o`000005o`000003onKV
i_oooooooooo04?ooooo000:ooooo`;o00006?ooool3onKViP;o00000_oVi^H2o`0000;oi^KV6?oo
ool2o`0000;ooooo0_l0000Hooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViQSooooo0_l0
00000ooooooo0000o`00000Hooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViTCooooo0007
ooooo`Ko00005oooool3onKViP;o00000_oVi^H2o`0000;oi^KV6?ooool2o`0001cooooo0ooVi^H2
o`000003onKVi_l0003o000000?oi^KV6Oooool2o`0001[ooooo0ooVi^H2o`000003onKVi_l0003o
000000?oi^KVA?ooool000Oooooo0_l000000ooooooo0000o`000003ooooo`?o00004_ooool3onKV
iP;o00000_oVi^H2o`0000;oi^KV6?ooool2o`0000;ooooo0_l0000Hooooo`?oi^KV0_l000000ooV
i^Ko0000o`000003onKViQ[ooooo0_l0000Gooooo`;o00000ooVi^H2o`000003onKVi_l0003o0000
00?oi^KVA?ooool000Sooooo1?l00006ooooo`Go00003Oooool4onKViPKo000000Coi^KVo`000?l0
003o00005_ooool4o`0001Wooooo0ooVi^H4o`0000Coi^KV4oooool2o`0000;ooooo0_l00002oooo
o`;o00004Oooool5o`0000;ooooo0ooVi^H4o`0000Coi^KVA?ooool000Wooooo0ol0000;ooooo`Co
00002Oooool;onKViP?ooooo0ol0000`ooooo`?oi^KV0_l00006onKViQ3ooooo0ol00004ooooo`;o
00000_ooool2o`0000gooooo1?l00007ooooo`?oi^KV0_l00006onKViTCooooo000:ooooo`;o0000
3oooool5o`0000Gooooo2OoVi^H7ooooo`?o0000;_ooool01?oVi^Ko0000o`000?l00005onKViPko
oooo0ol00008ooooo`Co00002Oooool5o`0000cooooo00Coi^KVo`000?l0003o00001OoVi^I5oooo
o`008?ooool5o`000003oooooooVi^Koi^KV00Goi^KV2oooool3o`0001?ooooo00?o0000oooooooo
ool05Oooool00ol0003oi^KVonKViP05onKViPcooooo0ol0000Cooooo`Go00004_ooool7onKViTKo
oooo000Uooooo`;o00001OoVi^H?ooooo`;o00004_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo00Goi^KV2oooool2o`0001?ooooo0ol0000Hooooo`Goi^KVAoooool002[ooooo1?l0
000?ooooo`?o00004?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00kooooo0ol0
000?ooooo`Co0000JOooool002kooooo1Ol0000=ooooo`?o00003_ooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00cooooo0ol0000=ooooo`Go0000KOooool003?ooooo1Ol0000;oooo
o`?o00003?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00[ooooo0ol0000;oooo
o`Go0000L_ooool003Sooooo1?l0000:ooooo`?o00002_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00Sooooo0ol0000:ooooo`Co0000Moooool003cooooo1Ol00008ooooo`;o0000
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo0_l00008ooooo`Go0000
Noooool0047ooooo1Ol00005ooooo`?o00001oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Gooooo0ol00005ooooo`Go0000P?ooool004Kooooo1Ol00003ooooo`?o00001Oooool0
0ol0003oooooonKViP04onKViP03ooooool0003ooooo00Cooooo0ol00003ooooo`Go0000QOooool0
04_ooooo1?l00002ooooo`?o00000oooool7onKViP?ooooo0ol00002ooooo`Co0000R_ooool004oo
oooo1ol000000ooVi^Ko0000o`000004o`0000;oi^KV1ol0002>ooooo`00E?ooool00ol0003oi^KV
onKViP02onKViP;o00001OoVi^H00ol0003oooooooooo`2Aooooo`00EOooool4onKViP;o00001OoV
i^JDooooo`00EOooool4onKViP;o00001OoVi^JDooooo`00EOooool3onKViPGo00000ooVi^JDoooo
o`00EOooool4onKViP;o00001OoVi^JDooooo`00E_ooool4onKViP?o00000_oVi^JEooooo`00Eooo
ool7onKViYKooooo001Hooooo`Goi^KVUoooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.66969, \
0.0248915, 0.0116153}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[.5 .30902 -5 -6 ]
[.5 .30902 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
1 g
.04 w
.5 .30902 Mdot
0 g
gsave
.5 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?oo
ool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00
m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003doooo
o`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003d
ooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo
003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Co
oooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool0
0?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?oo
ool00?Cooooo003dooooo`00m?ooool007Kooooo1Ol0001iooooo`00Moooool2o`000003ooooool0
003o000007Sooooo001gooooo`;o000000?oooooo`000?l00000N?ooool007Oooooo0_l000000ooo
oooo0000o`00001hooooo`00Moooool4o`0007Wooooo001gooooo`;o0000Noooool007Kooooo0ol0
001kooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Co
oooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool0
0?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?oo
ool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00
m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003doooo
o`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003d
ooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo
003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Cooooo003dooooo`00m?ooool00?Co
oooo003dooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-1.05304, -1.05001, \
0.00866696, 0.0140234}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Rooooo`Co0000@oooool4o`0001kooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Pooooo`;o0000AOooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l00002ooooo`;o0000@Oooool2o`0000;ooooo0_l0000Mooooo`;oi^KV
0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool4o`0002;ooooo1?l00013ooooo`Co00007_oo
ool3onKViPKo00000_oVi^H_ooooo`00:oooool2o`0008kooooo2OoVi^H`ooooo`00:_ooool3o`00
08oooooo1ooVi^Haooooo`00W?ooool00ol0003oooooooooo`0Nooooo`Goi^KV<_ooool002oooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool0=?ooool0033ooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`1:ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0=Oooool0033ooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool0=Oooool0037ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1;oooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0=_ooool0037ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool0=_ooool0037ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool0=_ooool003;ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0=ooo
ool003;ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0=oooool003?ooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`1?ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0>?ooool003?o
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0>?ooool003?ooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`1@ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0>?ooool003Cooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0>Oooool003Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1B
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0>Oooool003Gooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0>_ooool003Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Dooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0>_ooool003Gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
>_ooool003Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Eooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0>oooool003Kooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`1Fooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0>oooool0
03Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0??ooool003Oooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`1Hooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0??ooool003Sooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0?Oooool003Sooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`1Iooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0?Oooool003Sooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0?Oooool003Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Koooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0?_ooool003Wooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0?_ooool003[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Mooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0?oooool003[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0?ooo
ool003[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Nooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0?oooool003_ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1Oooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0@?ooool003_o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Pooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool0@?ooool003cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1Qooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0@Oooool003cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0@Oooool003cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1R
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool003gooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0@_ooool003gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Sooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0@_ooool003kooooo1OoVi^IWooooo`Goi^KV
AOooool003gooooo00?oi^KVo`000?l000000_l00002onKViVGooooo1ooVi^I4ooooo`00??ooool5
onKViP;o00000_oVi^ISooooo`Woi^KV@oooool000Wooooo1?l0000^ooooo`?oi^KV1Ol00003onKV
iRkooooo1?l0000_ooooo`;oi^KV1ol00002onKViRoooooo1Ol0000>ooooo`002_ooool2o`0002oo
oooo0_oVi^H2o`0000;oi^KV0_l00003onKViRgooooo0_l0000booooo`?oi^KV0_l000000ooVi^Ko
0000o`000003onKViRkooooo0_l000000ooooooo0000o`00000?ooooo`001oooool6o`0002kooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViRgooooo1_l0000^ooooo`?oi^KV0_l000000ooVi^Ko0000
o`000003onKViRoooooo1?l0000?ooooo`001oooool2o`000003ooooool0003o000002oooooo0_oV
i^H2o`0000;oi^KV0_l00003onKViRgooooo0_l00002ooooo`;o0000;_ooool3onKViP;o000000?o
i^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l000003oooool000Sooooo1?l00003
ooooo`;o0000:_ooool3onKViPKo00000_oVi^H^ooooo`Co0000;oooool3onKViPCo00001?oVi^H_
ooooo`?o00004?ooool000Wooooo0ol00005ooooo`;o0000:Oooool9onKViV?ooooo0_oVi^H2o`00
00Goi^KV:_ooool2o`0001Oooooo000:ooooo`;o00001oooool3o`0002Oooooo1ooVi^H00ooooooo
0000ooooo`1Pooooo`03o`000?oooooo000000;o00001?oVi^HXooooo`?o00006Oooool001Kooooo
0_l0000Vooooo`Goi^KV0oooool2o`0005gooooo0_l00003ooooo`Goi^KV9oooool2o`0001cooooo
000Hooooo`?o0000;Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool0;?ooool3o`0001kooooo000Kooooo`;o0000;?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:oooool2o`00027ooooo000Moooo
o`;o0000:oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0:Oooool3o`0002?ooooo000Oooooo`?o0000:Oooool00ol0003oooooooooo`0Xooooo`03
o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool2o`0002Kooooo000Rooooo`;o0000
:?ooool2o`0002Sooooo00?o0000ooooooooool09_ooool2o`0002Wooooo0_l0000Xooooo`009?oo
ool3o`0002Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo02Kooooo0ol0000Zooooo`009oooool2o`0002Kooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Gooooo0_l0000]ooooo`00:Oooool2o`00
02Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
02?ooooo0ol0000_ooooo`00:oooool3o`0002?ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo0_l0000booooo`00;_ooool2o`0002;ooooo
0_l0000Rooooo`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o0000=?ooool0033ooooo0ol0
000Qooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0Pooooo`;o0000=oooool003?ooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`0Oooooo`;o0000>Oooool003Gooooo0_l0000Ooooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Moooo
o`?o0000>oooool003Oooooo0ol0000Mooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0Looooo`;o0000?_ooool003[ooooo0_l0000Looooo`;o0000
7?ooool00ol0003oooooooooo`0Jooooo`;o00007?ooool3o`00043ooooo000looooo`?o00006ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_oo
ool2o`0004?ooooo000oooooo`;o00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool06?ooool3o`0004Gooooo0011ooooo`;o00006Oooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool2o`00
04Sooooo0013ooooo`?o00005oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool2o`0004[ooooo0016ooooo`;o00005_ooool2o`0001Kooooo
00?o0000ooooooooool05?ooool2o`0001Kooooo0ol0001<ooooo`00B?ooool3o`0001Gooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Cooooo0_l0
001?ooooo`00Boooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo0ol0001Aooooo`00COooool2o`0001?ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0_l0001Doooo
o`00Coooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo013ooooo0_l0001Fooooo`00D_ooool2o`00013ooooo0_l0000@ooooo`03o`00
0?oooooooooo00kooooo0_l0000@ooooo`?o0000F?ooool005Cooooo0ol0000?ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`;o0000Fooo
ool005Oooooo0_l0000>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`?o0000GOooool005Wooooo0_l0000=ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000H?ooool005_o
oooo0ol0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`?o0000H_ooool005kooooo0_l0000:ooooo`;o00002_ooool00ol0003ooooo
ooooo`08ooooo`;o00002_ooool2o`0006Gooooo001Pooooo`?o00002Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool2o`0006Oooooo001S
ooooo`;o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool3o`0006Wooooo001Uooooo`;o00001oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool2o`0006cooooo001Wooooo`?o
00001Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool3o`0006kooooo001Zooooo`;o00001?ooool2o`0000Cooooo00?o0000ooooooooool0
0_ooool2o`0000Cooooo0_l0001aooooo`00K?ooool3o`0000?ooooo00?o0000oooooooVi^H01?oV
i^H00ooooooo0000ooooo`02ooooo`?o0000Loooool006oooooo0_l00002ooooo`Ooi^KV0_ooool2
o`0007Kooooo001aooooo`03o`000?oVi^Ko000000Go00000_oVi^H00ol0003oooooooooo`1foooo
o`00LOooool4onKViP;o00001OoVi^Ihooooo`00LOooool4onKViP;o00001OoVi^Ihooooo`00LOoo
ool4onKViP;o00001OoVi^Ihooooo`00LOooool3onKViPGo00000ooVi^Ihooooo`00LOooool4onKV
iP;o00001OoVi^Ihooooo`00L_ooool4onKViP?o00000_oVi^Iiooooo`00Loooool7onKViW[ooooo
001dooooo`Goi^KVNoooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co0000@oooool4o`0001gooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000AOooool2o`0001kooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o000000?oooooo`000?l00000
7_ooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool002_ooooo1?l0000Rooooo`Co0000@ooo
ool4o`0001kooooo0ooVi^H6o`0000;oi^KV;oooool002_ooooo0_l0000Uooooo`?o0000A?ooool3
o`0001oooooo2OoVi^H`ooooo`00:_ooool3o`0002Kooooo0_l00015ooooo`;o00008?ooool7onKV
iS7ooooo002Looooo`03o`000?oooooooooo01kooooo1OoVi^Hbooooo`00;oooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0dooooo`00<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0eooooo`00<?ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0e
ooooo`00<Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo04_ooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`0fooooo`00<Oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0fooooo`00
<Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`0fooooo`00<_ooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0gooooo`00<_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0gooooo`00<oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
04oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0hooooo`00<oooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`0hooooo`00<oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo053ooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0hooooo`00=?ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`0iooooo`00=?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool05?ooool00ol0003oooooooooo`0iooooo`00=Oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo05?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0joooo
o`00=Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo05Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0jooooo`00=Oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo05Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0jooooo`00=_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0kooooo`00=_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo05Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0kooooo`00=oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0looooo`00=oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo05So
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0looooo`00>?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0mooooo`00>?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05Wooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0mooooo`00>?ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo05[ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0m
ooooo`00>Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0nooooo`00>Oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo05cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0nooooo`00
>_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0oooooo`00>_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo05gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0oooooo`00>_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0oooooo`00>oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
05oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`10ooooo`00>oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`10ooooo`00??ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo067ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`11ooooo`00??ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`11ooooo`00??ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06;ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`11ooooo`00?Oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo06?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`12oooo
o`00?Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`12ooooo`00?_ooool5onKViVOooooo1OoVi^I5ooooo`00?Ooo
ool00ooVi^Ko0000o`000002o`0000;oi^KVIOooool7onKViTCooooo000looooo`Goi^KV0_l00002
onKViV?ooooo2OoVi^I3ooooo`002Oooool4o`0002kooooo0ooVi^H5o`0000?oi^KV;_ooool4o`00
02oooooo0_oVi^H7o`0000;oi^KV;oooool5o`0000kooooo000:ooooo`;o0000;oooool2onKViP;o
00000_oVi^H2o`0000?oi^KV;Oooool2o`0003;ooooo0ooVi^H2o`000003onKVi_l0003o000000?o
i^KV;_ooool2o`000003ooooool0003o000000oooooo0007ooooo`Ko0000;_ooool2onKViP;o0000
0_oVi^H2o`0000?oi^KV;Oooool6o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV
;oooool4o`0000oooooo0007ooooo`;o000000?oooooo`000?l00000;oooool2onKViP;o00000_oV
i^H2o`0000?oi^KV;Oooool2o`0000;ooooo0_l0000^ooooo`?oi^KV0_l000000ooVi^Ko0000o`00
0003onKViRkooooo0_l000000ooooooo0000o`00000?ooooo`002?ooool4o`0000?ooooo0_l0000Z
ooooo`?oi^KV1_l00002onKViRkooooo1?l0000_ooooo`?oi^KV1?l00004onKViRoooooo0ol0000@
ooooo`002Oooool3o`0000Gooooo0_l0000Yooooo`Woi^KVHoooool2onKViP;o00001OoVi^HZoooo
o`;o00005oooool000[ooooo0_l00007ooooo`?o00009oooool7onKViP03ooooool0003ooooo063o
oooo00?o0000ooooool000000_l00004onKViRSooooo0ol0000Iooooo`005_ooool2o`0002Kooooo
1OoVi^H3ooooo`;o0000GOooool2o`0000?ooooo1OoVi^HWooooo`;o00007?ooool001Sooooo0ol0
000]ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0/ooooo`?o00007_ooool001_ooooo0_l0000/ooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0[ooooo`;o00008Oooool001gooooo0_l0000[oooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yoooo
o`?o00008oooool001oooooo0ol0000Yooooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool0:?ooool00ol0003oooooooooo`0Xooooo`;o00009_ooool002;ooooo0_l0000Xooooo`;o0000
:?ooool00ol0003oooooooooo`0Vooooo`;o0000:Oooool2o`0002Sooooo000Tooooo`?o00009ooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09_oo
ool3o`0002[ooooo000Wooooo`;o00009_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool09Oooool2o`0002gooooo000Yooooo`;o00009Oooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool3o`00
02oooooo000[ooooo`?o00008oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool08_ooool2o`0003;ooooo000^ooooo`;o00008_ooool2o`0002;ooooo
00?o0000ooooooooool08?ooool2o`0002;ooooo0ol0000dooooo`00<?ooool3o`00027ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo0_l0
000gooooo`00<oooool2o`00023ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo01oooooo0_l0000iooooo`00=Oooool2o`0001oooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo0ol0000koooo
o`00=oooool3o`0001gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01cooooo0_l0000nooooo`00>_ooool2o`0001cooooo0_l0000Looooo`03o`00
0?oooooooooo01[ooooo0_l0000Looooo`?o0000@?ooool003cooooo0ol0000Kooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Jooooo`;o0000@ooo
ool003oooooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0Hooooo`?o0000AOooool0047ooooo0_l0000Iooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o0000B?ooool004?o
oooo0ol0000Gooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`0Fooooo`;o0000B_ooool004Kooooo0_l0000Fooooo`;o00005_ooool00ol0003ooooo
ooooo`0Dooooo`;o00005_ooool3o`0004cooooo0018ooooo`?o00005Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool05?ooool2o`0004oooooo001;
ooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool3o`00057ooooo001=ooooo`;o00004oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool2o`0005Cooooo001?ooooo`?o
00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool2o`0005Kooooo001Booooo`;o00004?ooool2o`00013ooooo00?o0000ooooooooool0
3_ooool2o`00013ooooo0ol0001Hooooo`00E?ooool3o`0000oooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo0_l0001Kooooo`00Eoooool2
o`0000kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00cooooo0ol0001Mooooo`00FOooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0001Pooooo`00Foooool3o`0000_o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wo
oooo0ol0001Rooooo`00G_ooool2o`0000[ooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo
0_l0000:ooooo`;o0000IOooool0063ooooo0ol00009ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`;o0000Ioooool006?ooooo0_l00008
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`?o0000JOooool006Gooooo0_l00007ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`;o0000K?ooool006Oooooo0ol00005ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`?o
0000K_ooool006[ooooo0_l00004ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`;o0000
1?ooool2o`00077ooooo001/ooooo`?o00000oooool00ol0003oooooonKViP04onKViP03ooooool0
003ooooo00;ooooo0ol0001cooooo`00Koooool2o`0000;ooooo1ooVi^H2ooooo`;o0000M_ooool0
077ooooo00?o0000onKVi_l000001Ol00002onKViP03o`000?oooooooooo07Kooooo001aooooo`Co
i^KV0_l00005onKViWSooooo001aooooo`Coi^KV0_l00005onKViWSooooo001aooooo`Coi^KV0_l0
0005onKViWSooooo001aooooo`?oi^KV1Ol00003onKViWSooooo001aooooo`Coi^KV0_l00005onKV
iWSooooo001booooo`Coi^KV0ol00002onKViWWooooo001cooooo`Ooi^KVN_ooool007Cooooo1OoV
i^Ikooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool009Sooooo1?l0000Nooooo`?oi^KV1Ol00003onKViRoooooo002Gooooo`;o00008Oooool2onKV
iP;o00000_oVi^H2o`0000?oi^KV;oooool009Oooooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o
00000ooVi^H_ooooo`00Uoooool2o`0000;ooooo0_l0000Mooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^H_ooooo`00V?ooool4o`0001kooooo0ooVi^H6o`0000;oi^KV;oooool00;_ooooo2OoVi^H`
ooooo`00_?ooool7onKViS7ooooo002Looooo`03o`000?oooooooooo01kooooo1OoVi^Hbooooo`00
W?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo002Mooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool0=Oooool009gooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0eooooo`00WOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo002Nooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0=_ooool009kooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`0fooooo`00Woooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo002Oooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0=oooool009oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0hoooo
o`00X?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo002Pooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool0>?ooool00:3ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0iooooo`00XOooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo002Qooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0>_ooool00:;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0jooooo`00X_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo002Rooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0>oooool00:?ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0k
ooooo`00Xoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo002Tooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool0??ooool00:Cooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0mooooo`00Y?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo002Uooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0?Oooool0
0:Gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0nooooo`00Y_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo002Vooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0?oooool00:Kooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0oooooo`00Yoooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo002Woooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0@?ooool00:Sooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`10ooooo`00Z?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo002Xooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0@Ooo
ool00:Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`11ooooo`00ZOooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo002Yooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0@_ooool00:[ooooo1OoVi^I5ooooo`00ZOooool7onKViTCooooo002X
ooooo`Woi^KV@oooool000Wooooo1?l0000aooooo`Co0000<_ooool4o`0002oooooo0_oVi^H7o`00
00;oi^KV;oooool5o`0000kooooo000:ooooo`;o0000<Oooool2o`0003Cooooo0_l0000booooo`?o
i^KV0_l000000ooVi^Ko0000o`000003onKViRkooooo0_l000000ooooooo0000o`00000?ooooo`00
1oooool6o`00033ooooo1_l0000`ooooo`Ko0000;_ooool3onKViP;o000000?oi^KVo`000?l00000
0ooVi^H_ooooo`Co00003oooool000Oooooo0_l000000ooooooo0000o`00000aooooo`;o00000_oo
ool2o`00033ooooo0_l00002ooooo`;o0000;_ooool3onKViP;o000000?oi^KVo`000?l000000ooV
i^H^ooooo`;o000000?oooooo`000?l000003oooool000Sooooo1?l00003ooooo`;o0000;Oooool4
o`0003;ooooo1?l0000_ooooo`?oi^KV1?l00004onKViRoooooo0ol0000@ooooo`002Oooool3o`00
00Gooooo0_l0002Eooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000_ooooo`03o`000?oooooooooo05oooooo00?o0000ooooool000000_l00004onKViRSo
oooo0ol0000Iooooo`005_ooool2o`0002kooooo0_l0001Mooooo`;o00000oooool5onKViROooooo
0_l0000Looooo`006?ooool3o`0002gooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02cooooo0ol0000Nooooo`006oooool2o`0002cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02_ooooo0_l0000Q
ooooo`007Oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo02Wooooo0ol0000Sooooo`007oooool3o`0002Wooooo00?o0000oooooooo
ool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0_l0000Vooooo`00
8_ooool2o`0002Sooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Yooooo`;o0000
:?ooool002Cooooo0ol0000Wooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Vooooo`?o0000:_ooool002Oooooo0_l0000Vooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`;o0000;Oooool0
02Wooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0Sooooo`?o0000;oooool002_ooooo0ol0000Sooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o0000<_ooool002kooooo
0_l0000Rooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`;o00008_ooool3o`0003Cooooo
000`ooooo`?o00008Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool08?ooool2o`0003Oooooo000cooooo`;o00008?ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2o`0003Wooooo000eoooo
o`;o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool07Oooool3o`0003_ooooo000gooooo`?o00007Oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`0003kooooo000jooooo`;o0000
7?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo0ol00010ooooo`00??oo
ool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo01[ooooo0_l00013ooooo`00?oooool2o`0001[ooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0ol00015ooooo`00@Oooool2o`00
01Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
01Oooooo0_l00018ooooo`00@oooool3o`0001Oooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0001:ooooo`00A_ooool2o`0001Kooooo
0_l0000Fooooo`03o`000?oooooooooo01Cooooo0_l0000Fooooo`?o0000C?ooool004Sooooo0ol0
000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Dooooo`;o0000Coooool004_ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`?o0000DOooool004gooooo0_l0000Coooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`;o0000E?ooool004oooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`;o0000E_ooool005;ooooo0_l0000@ooooo`;o0000
4?ooool00ol0003oooooooooo`0>ooooo`;o00004?ooool3o`0005Sooooo001Dooooo`?o00003ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_oo
ool2o`0005_ooooo001Gooooo`;o00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03?ooool3o`0005gooooo001Iooooo`;o00003Oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool2o`00
063ooooo001Kooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02Oooool3o`0006;ooooo001Nooooo`;o00002_ooool2o`0000[ooooo
00?o0000ooooooooool02?ooool2o`0000[ooooo0_l0001Uooooo`00H?ooool3o`0000Wooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo0_l0
001Wooooo`00Hoooool2o`0000Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo0ol0001Yooooo`00IOooool2o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo0_l0001/oooo
o`00Ioooool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00?ooooo0ol0001^ooooo`00J_ooool2o`0000Cooooo0_l00004ooooo`03o`00
0?oooooooooo00;ooooo0_l00004ooooo`;o0000LOooool006cooooo0ol00003ooooo`03o`000?oo
ooooi^KV00Coi^KV00?oooooo`000?ooool00_ooool3o`0007?ooooo001_ooooo`;o00000_ooool7
onKViP;ooooo0_l0001fooooo`00LOooool00ol0003oi^KVo`000005o`0000;oi^KV00?o0000oooo
ooooool0M_ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KV
N?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5o`0000?oi^KVN?ooool0
077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;oi^KVNOooool007?ooooo
1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.40693 .21092 -5 -6 ]
[.40693 .21092 5 6 ]
[.56847 .21092 -5 -6 ]
[.56847 .21092 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.4877 .40712 m
.40693 .21092 L
s
.4877 .40712 m
.56847 .21092 L
s
1 g
.05 w
.40693 .21092 Mdot
0 g
gsave
.40693 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.56847 .21092 Mdot
0 g
gsave
.56847 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co00002_ooool5o`0002?ooooo1?l0000<ooooo`Co00007_ooool3
onKViPGo00000ooVi^H_ooooo`00:oooool2o`000003ooooool0003o000002?ooooo0_l0000<oooo
o`;o000000?oooooo`000?l000008oooool2o`0000cooooo0_l0000Qooooo`;oi^KV0_l00002onKV
iP;o00000ooVi^H_ooooo`00:oooool2o`000003ooooool0003o0000023ooooo1_l0000;ooooo`;o
000000?oooooo`000?l000008?ooool6o`0000_ooooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o
00000ooVi^H_ooooo`00:oooool2o`000003ooooool0003o0000023ooooo0_l000000ooooooo0000
o`00000<ooooo`;o000000?oooooo`000?l000008?ooool2o`000003ooooool0003o000000cooooo
0_l00002ooooo`;o00007Oooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool002_ooooo1?l0
000Rooooo`Co00003?ooool4o`0002;ooooo1?l0000=ooooo`Co00007_ooool3onKViPKo00000_oV
i^H_ooooo`00:oooool2o`0002Gooooo0ol0000<ooooo`;o00009Oooool3o`00033ooooo2OoVi^H`
ooooo`00:_ooool3o`0002Kooooo0_l0000;ooooo`?o00009_ooool2o`00037ooooo1ooVi^Haoooo
o`00W?ooool00ol0003oooooooooo`0Nooooo`Goi^KV<_ooool002oooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo000`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo01Cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0eooooo`00<?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0=Oooool0
037ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0fooooo`00<Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool0=_ooool003;ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0gooooo`00<oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0>?ooool003?ooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0hooooo`00=?oo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0>Ooo
ool003Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0jooooo`00=Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0>_ooool003Gooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0kooooo`00=_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0>oooool003Oooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo000gooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0looooo`00
>?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
?Oooool003Sooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0mooooo`00>Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0?_ooool003Wooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`0oooooo`00>_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0?oooool003[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0:?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo000koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`10oooo
o`00>oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0@?ooool003cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`11ooooo`00??ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0@Oooool003gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`12ooooo`00?_ooool5onKViS7ooooo
1OoVi^Haooooo`Goi^KVAOooool003gooooo00?oi^KVo`000?l000000_l00002onKViRoooooo00?o
i^KVo`000?l000000_l00002onKViRoooooo1ooVi^I4ooooo`00??ooool5onKViP;o00000_oVi^H]
ooooo`Goi^KV0_l00002onKViRgooooo2OoVi^I3ooooo`002Oooool4o`0002kooooo0ooVi^H5o`00
00?oi^KV:oooool3onKViPGo00000ooVi^H[ooooo`;oi^KV1ol00002onKViRoooooo1Ol0000>oooo
o`002_ooool2o`0002oooooo0_oVi^H2o`0000;oi^KV0_l00003onKViR_ooooo0_oVi^H2o`0000;o
i^KV0_l00003onKViR_ooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_ooool2o`000003
ooooool0003o000000oooooo0007ooooo`Ko0000;_ooool2onKViP;o00000_oVi^H2o`0000?oi^KV
:oooool2onKViP;o00000_oVi^H2o`0000?oi^KV:oooool3onKViP;o000000?oi^KVo`000?l00000
0ooVi^H_ooooo`Co00003oooool000Oooooo0_l000000ooooooo0000o`00000_ooooo`;oi^KV0_l0
0002onKViP;o00000ooVi^H[ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H[ooooo`?oi^KV0_l0
00000ooVi^Ko0000o`000003onKViRkooooo0_l000000ooooooo0000o`00000?ooooo`002?ooool4
o`0000?ooooo0_l0000Zooooo`?oi^KV1_l00002onKViR_ooooo0ooVi^H6o`0000;oi^KV:oooool3
onKViPCo00001?oVi^H_ooooo`?o00004?ooool000Wooooo0ol00005ooooo`;o0000:Oooool9onKV
iRgooooo2OoVi^H]ooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0;?ooool7onKViRgooooo00?o0000ooooool0
00000_l00004onKViRSooooo0ol0000Iooooo`005_ooool2o`0002Kooooo1OoVi^H3ooooo`;o0000
;?ooool5onKViRcooooo0_l00003ooooo`Goi^KV9oooool2o`0001cooooo000Hooooo`?o0000;Ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?oo
ool3o`0001kooooo000Kooooo`;o0000;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool0:oooool2o`00027ooooo000Mooooo`;o0000:oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool3o`00
02?ooooo000Oooooo`?o0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0:?ooool2o`0002Kooooo000Rooooo`;o0000:?ooool2o`0002Sooooo
00?o0000ooooooooool09_ooool2o`0002Wooooo0_l0000Xooooo`009?ooool3o`0002Oooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Kooooo0ol0
000Zooooo`009oooool2o`0002Kooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo02Gooooo0_l0000]ooooo`00:Oooool2o`0002Gooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo0ol0000_oooo
o`00:oooool3o`0002?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo02;ooooo0_l0000booooo`00;_ooool2o`0002;ooooo0_l0000Rooooo`03o`00
0?oooooooooo023ooooo0_l0000Rooooo`?o0000=?ooool0033ooooo0ol0000Qooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o0000=ooo
ool003?ooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`0Oooooo`;o0000>Oooool003Gooooo0_l0000Oooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`?o0000>oooool003Oo
oooo0ol0000Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0Looooo`;o0000?_ooool003[ooooo0_l0000Looooo`;o00007?ooool00ol0003ooooo
ooooo`0Jooooo`;o00007?ooool3o`00043ooooo000looooo`?o00006oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool2o`0004?ooooo000o
ooooo`;o00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool06?ooool3o`0004Gooooo0011ooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool2o`0004Sooooo0013ooooo`?o
00005oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool05_ooool2o`0004[ooooo0016ooooo`;o00005_ooool2o`0001Kooooo00?o0000ooooooooool0
5?ooool2o`0001Kooooo0ol0001<ooooo`00B?ooool3o`0001Gooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Cooooo0_l0001?ooooo`00Boooool2
o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo0ol0001Aooooo`00COooool2o`0001?ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0_l0001Dooooo`00Coooool3o`00017o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013o
oooo0_l0001Fooooo`00D_ooool2o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo
0_l0000@ooooo`?o0000F?ooool005Cooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`;o0000Foooool005Oooooo0_l0000>
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<
ooooo`?o0000GOooool005Wooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000H?ooool005_ooooo0ol0000;ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`?o
0000H_ooool005kooooo0_l0000:ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`;o0000
2_ooool2o`0006Gooooo001Pooooo`?o00002Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool02?ooool2o`0006Oooooo001Sooooo`;o00002?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool3
o`0006Wooooo001Uooooo`;o00001oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool2o`0006cooooo001Wooooo`?o00001Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool3o`0006ko
oooo001Zooooo`;o00001?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool2o`0000Cooooo
0_l0001aooooo`00K?ooool3o`0000?ooooo00?o0000oooooooVi^H01?oVi^H00ooooooo0000oooo
o`02ooooo`?o0000Loooool006oooooo0_l00002ooooo`Ooi^KV0_ooool2o`0007Kooooo001aoooo
o`03o`000?oVi^Ko000000Go00000_oVi^H00ol0003oooooooooo`1fooooo`00LOooool4onKViP;o
00001OoVi^Ihooooo`00LOooool4onKViP;o00001OoVi^Ihooooo`00LOooool4onKViP;o00001OoV
i^Ihooooo`00LOooool3onKViPGo00000ooVi^Ihooooo`00LOooool4onKViP;o00001OoVi^Ihoooo
o`00L_ooool4onKViP?o00000_oVi^Iiooooo`00Loooool7onKViW[ooooo001dooooo`Goi^KVNooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Template controlled recombination", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of selectively recombined chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
recChromos = Join @@ Table[
  Recombination[theChromos, Templates -> {{{_g}, 1}},
    SelectionMode -> RANDOM], {5}];

recChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[a, e, g[a, 4, 4]]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[b, b], c, h[2, g[b, b]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[b, 4]], c, h[2, g[b, b]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]\)},
          {\(chromo[q[undef], p[f[4, g[a, 4, 4], e, h[e, g[c, 5]], a]]]\)},
          {\(chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, e, d]], a]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, 5]]]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]\)},
          {\(chromo[q[undef], 
              p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
                  h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ a, 4, 4]], c, 
                h[ 2, 
                  g[ a, e, 
                    g[ a, 4, 4]]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, b], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ b, 4]], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, 4, 4], e, 
                h[ e, 
                  g[ c, 5]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ b, 4], e, 
                h[ e, 
                  g[ c, e, d]], a]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ a, 4, 4]], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, 5]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ a, 4, 4]], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 4, 
                g[ a, e, 
                  g[ a, 4, 4]], c, 
                h[ 2, 
                  g[ b, b]], 2, 
                h[ 5, 
                  g[ a, 
                    h[ 5, 
                      g[ b, 5], 
                      g[ a, d, c]]], 
                  g[ c, e, d]]]]]]],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["recChromos", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]], 
      chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, 5]], a]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[a, e, g[a, 4, 4]]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]], 
      chromo[q[undef], 
        p[f[4, g[b, b], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[b, 4]], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]], 
      chromo[q[undef], p[f[4, g[a, 4, 4], e, h[e, g[c, 5]], a]]], 
      chromo[q[undef], p[f[4, g[b, 4], e, h[e, g[c, e, d]], a]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, 5]]]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]], 
      chromo[q[undef], 
        p[f[4, g[a, e, g[a, 4, 4]], c, h[2, g[b, b]], 2, 
            h[5, g[a, h[5, g[b, 5], g[a, d, c]]], g[c, e, d]]]]]]\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["TermPlot[#, TreeWidth -> .5]& /@ recChromos;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co0000@_ooool4o`0001kooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000@_ooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o00000_ooool2o`0001gooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`Co00008_ooool4o`0004?ooooo1?l0
000Nooooo`?oi^KV1_l00002onKViRoooooo000[ooooo`;o00009Oooool3o`0006Kooooo2OoVi^H`
ooooo`00:_ooool3o`0002Kooooo0_l0001Wooooo`Ooi^KV<Oooool009cooooo00?o0000oooooooo
ool07_ooool5onKViS;ooooo000_ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
B?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo000`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo03Gooooo000`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0B_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000aooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo000aooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo
000booooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Oooooo000coooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo03Sooooo000dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Wooooo000dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Doooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[o
oooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03_ooooo000f
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo03_ooooo000gooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Eoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo000gooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo03cooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
FOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03gooooo000hooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0F_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03gooooo000iooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
03kooooo000iooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0G?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0GOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo
000jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo000koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo043ooooo000kooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo043ooooo000looooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOoo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo047ooooo000mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Hoooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04;o
oooo000nooooo`Goi^KVIoooool5onKViTGooooo000mooooo`03onKVi_l0003o000000;o00000_oV
i^IUooooo`Ooi^KVA?ooool003cooooo1OoVi^H2o`0000;oi^KVHoooool9onKViT?ooooo0009oooo
o`Co0000;_ooool3onKViPGo00000ooVi^H^ooooo`Co0000;oooool2onKViPOo00000_oVi^H_oooo
o`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o
0000<_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l0
00003oooool000Oooooo1_l0000^ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`Ko0000
;_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H_ooooo`Co00003oooool000Oooooo0_l0
00000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o00000_oo
ool2o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_ooool2o`000003ooooool0
003o000000oooooo0008ooooo`Co00000oooool2o`0002[ooooo0ooVi^H6o`0000;oi^KV;_ooool4
o`0002oooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009ooooo`?o00001Oooool2o`00
02Wooooo2OoVi^ISooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0H?ooool00ol0003oooooo`000002o`0000Co
i^KV:?ooool3o`0001Wooooo000Fooooo`;o00009_ooool5onKViP?ooooo0_l0001Mooooo`;o0000
0oooool5onKViROooooo0_l0000Looooo`006?ooool3o`0002gooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0ol0000Nooooo`006oooool2
o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02_ooooo0_l0000Qooooo`007Oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0ol0000Sooooo`007oooool3o`0002Wo
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo0_l0000Vooooo`008_ooool2o`0002Sooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo
0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0000Wooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`?o0000:_ooool002Oooooo0_l0000V
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0U
ooooo`;o0000;Oooool002Wooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000;oooool002_ooooo0ol0000Sooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o
0000<_ooool002kooooo0_l0000Rooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`;o0000
8_ooool3o`0003Cooooo000`ooooo`?o00008Oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool08?ooool2o`0003Oooooo000cooooo`;o00008?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2
o`0003Wooooo000eooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool3o`0003_ooooo000gooooo`?o00007Oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`0003ko
oooo000jooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo
0ol00010ooooo`00??ooool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo0_l00013ooooo`00?oooool2o`0001[ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0ol00015
ooooo`00@Oooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo0_l00018ooooo`00@oooool3o`0001Oooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0001:ooooo`00
A_ooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo0_l0000Fooooo`?o0000
C?ooool004Sooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Dooooo`;o0000Coooool004_ooooo0_l0000Dooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`?o0000DOooool0
04gooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`;o0000E?ooool004oooooo0ol0000Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000E_ooool005;ooooo
0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o00004?ooool3o`0005Sooooo
001Dooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool2o`0005_ooooo001Gooooo`;o00003_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0005gooooo001Ioooo
o`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool2o`00063ooooo001Kooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3o`0006;ooooo001Nooooo`;o0000
2_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo0_l0001Uooooo`00H?oo
ool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo0_l0001Wooooo`00Hoooool2o`0000Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0ol0001Yooooo`00IOooool2o`00
00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo0_l0001/ooooo`00Ioooool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0001^ooooo`00J_ooool2o`0000Cooooo
0_l00004ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000LOooool006cooooo0ol0
0003ooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool00_ooool3o`0007?ooooo001_
ooooo`;o00000_ooool7onKViP;ooooo0_l0001fooooo`00LOooool00ol0003oi^KVo`000005o`00
00;oi^KV00?o0000ooooooooool0M_ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo
1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5
o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;o
i^KVNOooool007?ooooo1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002[ooooo1Ol0000Sooooo`Co0000@_ooool4o`0001kooooo0ooVi^H5o`0000?oi^KV;oooool0
02_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000@_ooool2o`00027ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l000008?ooool6o`00047o
oooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00:oooool2o`000003oooo
ool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o00000_ooool2o`0001gooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`Co00008_ooool4o`0004?ooooo1?l0
000Nooooo`?oi^KV1_l00002onKViRoooooo000[ooooo`;o00009Oooool3o`0006Kooooo2OoVi^H`
ooooo`00:_ooool3o`0002Kooooo0_l0001Wooooo`Ooi^KV<Oooool009cooooo00?o0000oooooooo
ool07_ooool5onKViS;ooooo000_ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
B?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo000`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo03Gooooo000`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0B_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000aooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo000aooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo
000booooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Oooooo000coooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo03Sooooo000dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Wooooo000dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Doooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[o
oooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03_ooooo000f
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo03_ooooo000gooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Eoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo03cooooo000gooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo03cooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
FOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03gooooo000hooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0F_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03gooooo000iooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
03kooooo000iooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0G?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0GOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo
000jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03oooooo000koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo043ooooo000kooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo043ooooo000looooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOoo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo047ooooo000mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Hoooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04;o
oooo000nooooo`Goi^KVIoooool5onKViTGooooo000mooooo`03onKVi_l0003o000000;o00000_oV
i^IUooooo`Ooi^KVA?ooool003cooooo1OoVi^H2o`0000;oi^KVHoooool9onKViT?ooooo0009oooo
o`Co0000;_ooool3onKViPGo00000ooVi^H^ooooo`Co0000;oooool2onKViPOo00000_oVi^H_oooo
o`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o
0000<_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o000000?oooooo`000?l0
00003oooool000Oooooo1_l0000^ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`Ko0000
;_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H_ooooo`Co00003oooool000Oooooo0_l0
00000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H]ooooo`;o00000_oo
ool2o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_ooool2o`000003ooooool0
003o000000oooooo0008ooooo`Co00000oooool2o`0002[ooooo0ooVi^H6o`0000;oi^KV;_ooool4
o`0002oooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009ooooo`?o00001Oooool2o`00
02Wooooo2OoVi^ISooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Gooooo`002_ooool2o`0000Oo
oooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0H?ooool00ol0003oooooo`000002o`0000Co
i^KV:?ooool3o`0001Wooooo000Fooooo`;o00009_ooool5onKViP?ooooo0_l0001Mooooo`;o0000
0oooool5onKViROooooo0_l0000Looooo`006?ooool3o`0002gooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0ol0000Nooooo`006oooool2
o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02_ooooo0_l0000Qooooo`007Oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0ol0000Sooooo`007oooool3o`0002Wo
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo0_l0000Vooooo`008_ooool2o`0002Sooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo
0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0000Wooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`?o0000:_ooool002Oooooo0_l0000V
ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0U
ooooo`;o0000;Oooool002Wooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000;oooool002_ooooo0ol0000Sooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o
0000<_ooool002kooooo0_l0000Rooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`;o0000
8_ooool3o`0003Cooooo000`ooooo`?o00008Oooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool08?ooool2o`0003Oooooo000cooooo`;o00008?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07oooool2
o`0003Wooooo000eooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool3o`0003_ooooo000gooooo`?o00007Oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`0003ko
oooo000jooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo
0ol00010ooooo`00??ooool3o`0001_ooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01[ooooo0_l00013ooooo`00?oooool2o`0001[ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo0ol00015
ooooo`00@Oooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo0_l00018ooooo`00@oooool3o`0001Oooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0001:ooooo`00
A_ooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo0_l0000Fooooo`?o0000
C?ooool004Sooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Dooooo`;o0000Coooool004_ooooo0_l0000Dooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`?o0000DOooool0
04gooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`;o0000E?ooool004oooooo0ol0000Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000E_ooool005;ooooo
0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o00004?ooool3o`0005Sooooo
001Dooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool2o`0005_ooooo001Gooooo`;o00003_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0005gooooo001Ioooo
o`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool2o`00063ooooo001Kooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3o`0006;ooooo001Nooooo`;o0000
2_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo0_l0001Uooooo`00H?oo
ool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo0_l0001Wooooo`00Hoooool2o`0000Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0ol0001Yooooo`00IOooool2o`00
00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo0_l0001/ooooo`00Ioooool3o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0001^ooooo`00J_ooool2o`0000Cooooo
0_l00004ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000LOooool006cooooo0ol0
0003ooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool00_ooool3o`0007?ooooo001_
ooooo`;o00000_ooool7onKViP;ooooo0_l0001fooooo`00LOooool00ol0003oi^KVo`000005o`00
00;oi^KV00?o0000ooooooooool0M_ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo
1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo0ooVi^H5
o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;ooooo1?oVi^H3o`0000;o
i^KVNOooool007?ooooo1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.16114 .36788 -5 -6 ]
[.16114 .36788 5 6 ]
[.12422 .25016 -5 -6 ]
[.12422 .25016 5 6 ]
[.21096 .25016 -5 -6 ]
[.21096 .25016 5 6 ]
[.29769 .25016 -5 -6 ]
[.29769 .25016 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.48562 .25016 -5 -6 ]
[.48562 .25016 5 6 ]
[.54021 .13244 -5 -6 ]
[.54021 .13244 5 6 ]
[.61572 .13244 -5 -6 ]
[.61572 .13244 5 6 ]
[.69122 .13244 -5 -6 ]
[.69122 .13244 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.76029 .25016 -5 -6 ]
[.76029 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.16114 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .36788 Mdot
0 g
gsave
.16114 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .36788 m
.12422 .25016 L
s
.21096 .36788 m
.21096 .25016 L
s
.21096 .36788 m
.29769 .25016 L
s
1 g
.05 w
.12422 .25016 Mdot
0 g
gsave
.12422 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.21096 .25016 Mdot
0 g
gsave
.21096 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.29769 .25016 Mdot
0 g
gsave
.29769 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.48562 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.48562 .25016 Mdot
0 g
gsave
.48562 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.61572 .25016 m
.54021 .13244 L
s
.61572 .25016 m
.61572 .13244 L
s
.61572 .25016 m
.69122 .13244 L
s
1 g
.05 w
.54021 .13244 Mdot
0 g
gsave
.54021 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.61572 .13244 Mdot
0 g
gsave
.61572 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.69122 .13244 Mdot
0 g
gsave
.69122 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.76029 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .25016 Mdot
0 g
gsave
.76029 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo0020ooooo`Go00003_ooool4o`00
00_ooooo1?l0000Dooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0@ooooo`;oi^KV1Ol00002onKV
iQKooooo001oooooo`;o000000?oooooo`000?l000004?ooool2o`0000_ooooo0_l00002ooooo`;o
00004_ooool3onKViP;o00000_oVi^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?o
i^KV5Oooool0083ooooo1?l0000=ooooo`Ko00003_ooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV
0_l00002onKViQ3ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo001oooooo`;o000000?o
ooooo`000?l000003Oooool2o`000003ooooool0003o000000oooooo0_l0000Booooo`?oi^KV0_l0
0002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o00000ooVi^HEooooo`00P?ooool3
o`0000oooooo1?l0000;ooooo`Go00004oooool4onKViPKo000000?oi^KVooooooooool03_ooool3
onKViPKo00000_oVi^HEooooo`00Toooool3o`0000_ooooo0_l0000Fooooo`_oi^KV4?ooool;onKV
iQGooooo002Dooooo`;o00002oooool6o`0001?ooooo2OoVi^HBooooo`Woi^KV5_ooool00:Sooooo
00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H01OoVi^HGooooo`00Q_oo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo013ooooo1OoVi^HCooooo`03o`000?oo
oooooooo00Goi^KV6?ooool008Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01kooooo0027ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Oooooo`00Qoooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool08?ooool008Sooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo027ooooo0029ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Rooooo`00ROooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool08oooool0
08[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
02Cooooo002;ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0Uooooo`00Roooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool09Oooool008cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo02Kooooo002=ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`0Wooooo`00SOooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0:?ooool008kooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo02Wooooo002?ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Zooooo`00Sooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0:ooo
ool0093ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01kooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02cooooo002@
ooooo`04o`000?ooooooi^KVonKViRKooooo00?o0000oooooooVi^H01?oVi^H3ooooo`03o`000?oo
oooooooo02gooooo002Aooooo`03onKVi_l0003ooooo02Oooooo1ooVi^H00ooooooo0000ooooo`0_
ooooo`00T?ooool2onKViRWooooo2?oVi^Haooooo`007oooool5o`00013ooooo1?l0000Aooooo`Co
00002?ooool5o`0001[ooooo1?l0000Gooooo`;oi^KV0oooool5o`0000Oooooo1?l0000@ooooo`Co
00001?ooool7o`000003onKVi_oooooooooo00;ooooo1Ol0000Wooooo`007_ooool2o`000003oooo
ool0003o000001;ooooo0_l0000Cooooo`;o00002?ooool2o`000003ooooool0003o000001[ooooo
0_l0000Jooooo`;oi^KV0_ooool2o`000003ooooool0003o000000Oooooo0_l00002ooooo`;o0000
3_ooool2o`0000Oooooo00Coi^KVo`000?l0003oi^KV0_l00002onKViP?ooooo0_l000000ooooooo
0000o`00000Xooooo`007oooool4o`0000oooooo1_l0000?ooooo`Ko00002?ooool4o`0001[ooooo
1_l0000Fooooo`;oi^KV0oooool4o`0000Oooooo0_l0000Booooo`Ko00000oooool01?oVi^Ko0000
o`000?oVi^H2o`0000;oi^KV0oooool2o`000003ooooool0003o000002Sooooo000Nooooo`;o0000
00?oooooo`000?l000003oooool2o`000003ooooool0003o0000013ooooo0_l000000ooooooo0000
o`000008ooooo`;o000000?oooooo`000?l000006_ooool2o`0000;ooooo0_l0000Fooooo`;oi^KV
0_ooool2o`000003ooooool0003o000000Oooooo0_l00002ooooo`;o00003_ooool2o`0000;ooooo
0_l00003ooooo`04onKVi_l0003o0000onKViP;o00000_oVi^H3ooooo`;o000000?oooooo`000?l0
0000:?ooool001oooooo0ol0000Aooooo`Co00004Oooool4o`0000Wooooo0ol0000Looooo`Co0000
5oooool2onKViP?ooooo0ol00009ooooo`Co00004?ooool4o`0000Cooooo00?oi^KVo`000?l00000
0_l00003onKViPCooooo1?l0000Xooooo`00=?ooool3o`0001;ooooo0ol00014ooooo`;oi^KV:Ooo
ool2onKViP;o00001?oVi^H7ooooo`;o0000:?ooool003Gooooo0_l0000Cooooo`;o00004?ooool0
0ol0003oooooooooo`0`ooooo`04o`000?ooooooi^KVonKViQ;ooooo00?o0000ooooooooool04ooo
ool01?oVi^Ko0000o`000?l00003onKViPOooooo0ol0000Xooooo`009?ooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0;_ooool01?l0003ooooooooo
ooooool2onKViPGooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oVi^Koi^KV00?oi^KV1_ooool00ol0003oooooooooo`0Zooooo`009Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo02_ooooo000Vooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0Gooooo`;o00005Oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0<
ooooo`05o`000?ooooooooooooooool000002_ooool00ol0003oooooooooo`0/ooooo`009oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00Co0000oooooooooooo00002_oo
ool00ol0003oooooooooo`0]ooooo`009oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo0_l0000Aooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02oooool0
0ol0003oooooo`00000;ooooo`03o`000?oooooooooo02gooooo000Xooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo
02kooooo000Yooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0Oooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool2o`0000[o
oooo00?o0000ooooooooool0;oooool002[ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02?ooooo0_l0
000>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Oooooo0_l0000:ooooo`03o`000?oooooooooo033ooooo000[
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000009
ooooo`03o`000?oooooooooo037ooooo000/ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool01?ooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo03;ooooo000/ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00008oooo
o`03o`000?oooooooooo03;ooooo000]ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0<oooool002ko
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`;o00008_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0dooooo`00;oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool08oooool00ol0003oooooooooo`09ooooo`;o00001?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo03Gooooo000_ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0`ooooo`;o00001_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=Oooool0033ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool01oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0=_ooool0037ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo03Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo02Sooooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000iooooo`00<_ooool5o`000003onKVi_l0003ooooo03Sooooo00?o
0000onKVi_l000000ol00002ooooo`03o`000?oooooooooo02[ooooo1Ol000000ooVi^Ko0000oooo
o`04ooooo`Go000000?oi^KVo`000?ooool0>Oooool003;ooooo1?oVi^H2o`000003onKVi_oooooo
oooo03Oooooo1OoVi^H3o`0002gooooo1?oVi^H2o`000003onKVi_oooooooooo00?ooooo1?oVi^H2
o`000003onKVi_oooooooooo03Sooooo000Looooo`Go00001oooool4o`0000Gooooo0_oVi^H5o`00
00;oi^KV8Oooool6o`00013ooooo0ooVi^H5o`000003onKVi_oooooooooo027ooooo1?l00005oooo
o`;oi^KV1Ol00002onKViP?ooooo0_oVi^H5o`0000;oi^KV>Oooool001_ooooo0_l000000ooooooo
0000o`000007ooooo`;o00001oooool2onKViP;o00000_oVi^H2o`0000?oi^KV8Oooool2o`000003
ooooool0003o000000oooooo0ooVi^H2o`0000;oi^KV0_l00002onKViR7ooooo0_l00002ooooo`;o
00000oooool2onKViP;o00000_oVi^H2o`0000?oi^KV00?oooooonKVi_oVi^H00_l00002onKViP;o
00000ooVi^Hhooooo`007?ooool4o`0000Oooooo1_l00003ooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^HRooooo`;o00004Oooool3onKViP;o00000_oVi^H2o`0000;oi^KV9Oooool2o`0000?ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV
>?ooool001_ooooo0_l000000ooooooo0000o`000007ooooo`;o00000_ooool2o`0000?ooooo0_oV
i^H2o`0000;oi^KV0_l00003onKViR?ooooo0_l0000@ooooo`?oi^KV0_l00002onKViP;o00000_oV
i^HUooooo`;o00000oooool2onKViP;o00000_oVi^H2o`0000?oi^KV00?oooooonKVi_oVi^H00_l0
0002onKViP;o00000ooVi^Hhooooo`007?ooool3o`0000Wooooo1?l00004ooooo`?oi^KV1_l00002
onKViR3ooooo0_l00002ooooo`;o00003oooool4onKViPKo000000?oi^KVooooooooool07oooool5
o`0000Cooooo0ooVi^H6o`0000;oi^KV00CoooooonKVi_oVi^Koi^KV1_l00002onKViSSooooo000`
ooooo`_oi^KV8?ooool2o`0000;ooooo0_l0000?ooooo`_oi^KV8Oooool2o`0000Oooooo2ooVi^H0
0oooooooi^KVonKViP09onKViSSooooo000aooooo`Woi^KV8_ooool4o`00017ooooo2OoVi^HRoooo
o`Ko00001?ooool9onKViP?ooooo2OoVi^Hiooooo`00<_ooool7onKViSWooooo1ooVi^H^ooooo`Oo
i^KV1Oooool7onKViS[ooooo000cooooo`Goi^KV>oooool5onKViRWooooo00?o0000ooooooooool0
1?ooool5onKViPOooooo1OoVi^Hkooooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo03kooooo000Qooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0/ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0;?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool0
02;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0oooooo`008_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;_ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo03oooooo000Sooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0@?ooool002?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0`ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`10ooooo`008oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0<?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo000Toooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0aoooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@Oooool002Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`11ooooo`009Oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo03?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo04;ooooo000Uooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0@_oo
ool002Kooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo03Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0eooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`13ooooo`009_ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool0=Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Gooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo04?ooooo000Vooooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0=_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo
04?ooooo000Wooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo03Oooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`14ooooo`009oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0gooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool0A?ooool002Oooooo1OoVi^H00ol0003oooooooooo`0i
ooooo`Goi^KV>oooool5onKViTOooooo000Vooooo`;oi^KV1?l000000ooVi^Koooooooooo`0hoooo
o`Ooi^KV>Oooool7onKViTKooooo000Uooooo`Koi^KV0_l000000ooVi^Koooooooooo`0fooooo`Wo
i^KV=oooool9onKViTGooooo0009ooooo`Co00005oooool4onKViPGo00000_oVi^HIooooo`Co0000
6Oooool2onKViPOo00000_oVi^HGooooo`Ko00006?ooool2onKViPOo00000_oVi^I4ooooo`002_oo
ool2o`0001Sooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQSooooo0_l00002ooooo`;o00006?oo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^HHooooo`;o000000?oooooo`000?l000006?oo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`001oooool6o`0001Oooooo0ooVi^H2
o`0000;oi^KV0_l00002onKViQSooooo0_l0000Looooo`?oi^KV0_l000000ooVi^Ko0000o`000003
onKViQWooooo0_l0000Jooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViTCooooo0007oooo
o`;o000000?oooooo`000?l000006?ooool3onKViP;o00000_oVi^H2o`0000;oi^KV6?ooool2o`00
00;ooooo0_l0000Hooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViQ[ooooo0_l0000Ioooo
o`?oi^KV0_l000000ooVi^Ko0000o`000003onKViTCooooo0008ooooo`Co00000oooool3o`0001;o
oooo1?oVi^H6o`000003onKVi_oooooooooo01Oooooo1?l0000Iooooo`?oi^KV1?l00004onKViQOo
oooo0_l00002ooooo`;o00005_ooool2o`0000?oi^KV1?l00004onKViTCooooo0009ooooo`?o0000
1_ooool3o`00013ooooo2OoVi^H00ooooooo0000o`00000eooooo`;oi^KV0_l00005onKViQGooooo
0_l000000ooooooo0000o`000002ooooo`;o00004oooool3o`0000?ooooo0_oVi^H2o`0000Goi^KV
AOooool000[ooooo0_l00009ooooo`?o00003_ooool7onKViPCooooo0_l0000dooooo`?o00001?oV
i^HDooooo`;o00001?ooool4o`00017ooooo0ol00007ooooo`?o00001?oVi^I6ooooo`006?ooool3
o`0000cooooo1OoVi^H7ooooo`;o00006?ooool00ol0003oooooooooo`0Gooooo`03o`000?oVi^Ko
i^KV00?oi^KV4oooool2o`0001Sooooo0ol0000;ooooo`Goi^KVAoooool001_ooooo0ol0000Goooo
o`;o00005_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Cooooo0_l0000Goooo
o`?o0000F_ooool001kooooo0ol0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo0ol0001Mooooo`00
8Oooool3o`0001Cooooo0_l0000Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
4_ooool2o`0001Cooooo0ol0001Pooooo`009?ooool3o`0001?ooooo0_l0000Cooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool04Oooool2o`0001?ooooo0ol0001Sooooo`009oooool3
o`0001;ooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool2
o`0001;ooooo0ol0001Vooooo`00:_ooool3o`00017ooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool3o`00
06Wooooo000]ooooo`?o00003oooool2o`00013ooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0>ooooo`;o00003oooool3o`0006cooooo000`ooooo`?o00003_ooool2o`0000kooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0<ooooo`;o00003_ooool3o`0006oooooo
000cooooo`?o00003Oooool2o`0000gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0;ooooo`;o00003Oooool3o`0007;ooooo000fooooo`?o00003?ooool2o`0000cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`;o00003?ooool3o`0007Gooooo000ioooo
o`?o00002oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`?o0000N?ooool003cooooo0ol00009ooooo`;o
00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l00009ooooo`?o
0000Noooool003oooooo0ol00008ooooo`;o00002?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Kooooo0_l00008ooooo`?o0000O_ooool004;ooooo0ol00007ooooo`;o00001ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo0_l00007ooooo`?o0000POoo
ool004Gooooo0ol00006ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo0ol00024ooooo`00B?ooool3o`00
00Cooooo0_l00005ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool2o`00
00Cooooo0ol00027ooooo`00Boooool3o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool2o`0000?ooooo0ol0002:ooooo`00C_ooool3o`0000;ooooo
0_l00002ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool00_l00002ooooo`?o0000
SOooool0057ooooo0ol000000ooooooo0000o`000007onKViP;o000000Coooooo`000?l0003o0000
T?ooool005Cooooo0_l000000ooVi^Ko0000o`000004o`0000;oi^KV0_l0002Cooooo`00EOooool4
onKViP;o00001OoVi^JDooooo`00EOooool4onKViP;o00001OoVi^JDooooo`00EOooool4onKViP;o
00001OoVi^JDooooo`00EOooool3onKViPGo00000ooVi^JDooooo`00EOooool4onKViP;o00001OoV
i^JDooooo`00E_ooool4onKViP?o00000_oVi^JEooooo`00Eoooool7onKViYKooooo001Hooooo`Go
i^KVUoooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.76029 .25016 -5 -6 ]
[.76029 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.76029 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .25016 Mdot
0 g
gsave
.76029 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo002Rooooo`Co00005?ooool3onKV
iPGo000000?oi^KVooooooooool04?ooool2onKViPGo00000_oVi^HFooooo`00XOooool2o`0000;o
oooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^HEooooo`00YOooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQ3ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o00004_ooool3onKViP;o00000_oV
i^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV5Oooool00:7ooooo1Ol0000C
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0>ooooo`?oi^KV1_l00002onKViQGooooo002Qoooo
o`;o00005_ooool;onKViQ3ooooo2ooVi^HEooooo`00XOooool6o`0001?ooooo2OoVi^HBooooo`Wo
i^KV5_ooool00:Sooooo00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H0
1OoVi^HGooooo`00ZOooool00ol0003oooooooooo`0@ooooo`Goi^KV4oooool00ol0003ooooooooo
o`05onKViQSooooo002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Nooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool07oooool00:cooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo023ooooo002]ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Qooooo`00[_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08_ooool00:oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02?ooooo002`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Toooo
o`00/Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool09Oooool00;;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Gooooo002cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool09oooool00;Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo002fooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool00;Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02_ooooo002i
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/
ooooo`00^_ooool00ol0003oooooonKViP04onKViP?ooooo00?o0000ooooooooool0;Oooool00;_o
oooo1ooVi^H00ooooooo0000ooooo`0_ooooo`00^oooool8onKViS7ooooo001Dooooo`Go0000>ooo
ool5o`0000Oooooo1?l0000@ooooo`Co00001?ooool7o`000003onKVi_oooooooooo00;ooooo1Ol0
000Wooooo`00EOooool2o`000003ooooool0003o000003Wooooo0_l000000ooooooo0000o`000007
ooooo`;o00000_ooool2o`0000kooooo0_l00007ooooo`04onKVi_l0003o0000onKViP;o00000_oV
i^H3ooooo`;o000000?oooooo`000?l00000:?ooool005Gooooo0_l000000ooooooo0000o`00000j
ooooo`Co00001oooool2o`0001;ooooo1_l00003ooooo`04onKVi_l0003o0000onKViP;o00000_oV
i^H3ooooo`;o000000?oooooo`000?l00000:?ooool005Gooooo0_l000000ooooooo0000o`00000i
ooooo`;o000000?oooooo`000?l000001oooool2o`0000;ooooo0_l0000>ooooo`;o00000_ooool2
o`0000?ooooo00Coi^KVo`000?l0003oi^KV0_l00002onKViP?ooooo0_l000000ooooooo0000o`00
000Xooooo`00EOooool4o`0003_ooooo0ol00009ooooo`Co00004?ooool4o`0000Cooooo00?oi^KV
o`000?l000000_l00003onKViPCooooo1?l0000Xooooo`00EOooool2o`0006Cooooo0_oVi^H2o`00
00Coi^KV1oooool2o`0002Sooooo001Dooooo`?o00001Oooool00ol0003oooooooooo`0`ooooo`04
o`000?oooooo0000o`0001;ooooo00?o0000ooooooooool04oooool01?oVi^Ko0000o`000?l00003
onKViPOooooo0ol0000Xooooo`00GOooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV
00?oi^KV1_ooool00ol0003oooooooooo`0Zooooo`00G_ooool00ol0003oooooooooo`0/ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0[ooooo`00
Goooool2o`0002_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00cooooo00Go0000ooooooooooooooooo`00000:ooooo`03o`000?oooooooooo02co
oooo001Qooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00_ooooo00Co0000oooooooooooo00002_ooool00ol0003o
ooooooooo`0]ooooo`00H_ooool00ol0003oooooooooo`0Tooooo`;o00004Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooool000002oooool00ol0003ooooo
ooooo`0]ooooo`00Hoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000[ooooo00?o
0000ooooooooool0;_ooool006Cooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool2o`0000[ooooo00?o0000
ooooooooool0;oooool006Gooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo033ooooo001Vooooo`;o00007Oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool2o`0000[ooooo00?o0000oooooooo
ool0<?ooool006Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000009ooooo`03o`00
0?oooooooooo037ooooo001Yooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000002?oo
ool00ol0003oooooooooo`0booooo`00J_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooo
ooooo`0000Sooooo00?o0000ooooooooool0<_ooool006_ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0<oooool006cooooo00?o0000
ooooooooool04?ooool2o`0002;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`000004
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=?ooool006gooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Wooooo0_l00004oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=Oooool006kooooo0_l0000=ooooo`03
o`000?oooooooooo02Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0=Oooool0073ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool00000
1?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Kooooo001aooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`05ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Wooooo001booooo`03o`00
0?oVi^Ko000000?o00000_ooool00ol0003oooooooooo`0Zooooo`Go000000?oi^KVo`000?ooool0
1?ooool5o`000003onKVi_l0003ooooo03Wooooo001booooo`Goi^KV0ol0000]ooooo`Coi^KV0_l0
00000ooVi^Koooooooooo`03ooooo`Coi^KV0_l000000ooVi^Koooooooooo`0hooooo`006oooool5
o`0001;ooooo1Ol0000Tooooo`Ko00004?ooool3onKViPGo000000?oi^KVooooooooool08Oooool4
o`0000Gooooo0_oVi^H5o`0000;oi^KV0oooool2onKViPGo00000_oVi^Hiooooo`007?ooool2o`00
0003ooooool0003o000001;ooooo0_l000000ooooooo0000o`00000Tooooo`;o000000?oooooo`00
0?l000003oooool3onKViP;o00000_oVi^H2o`0000;oi^KV8Oooool2o`0000;ooooo0_l00003oooo
o`;oi^KV0_l00002onKViP;o00000ooVi^H00oooooooi^KVonKViP02o`0000;oi^KV0_l00003onKV
iSSooooo000Looooo`;o000000?oooooo`000?l000004_ooool2o`000003ooooool0003o000002Go
oooo0_l0000Aooooo`?oi^KV0_l00002onKViP;o00000_oVi^HUooooo`;o00000oooool2onKViP;o
00000_oVi^H2o`0000?oi^KV00?oooooonKVi_oVi^H00_l00002onKViP;o00000ooVi^Hhooooo`00
7?ooool2o`000003ooooool0003o000001;ooooo0_l000000ooooooo0000o`00000Vooooo`;o0000
4?ooool3onKViP;o00000_oVi^H2o`0000;oi^KV9Oooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV
0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?ooool001cooooo1?l0
000Cooooo`Co00009?ooool2o`0000;ooooo0_l0000?ooooo`Coi^KV1_l000000ooVi^Kooooooooo
o`0Oooooo`Go00001?ooool3onKViPKo00000_oVi^H01?ooooooi^KVonKVi_oVi^H6o`0000;oi^KV
>?ooool001cooooo0_l0000Eooooo`;o00009_ooool2o`0000;ooooo0_l0000?ooooo`_oi^KV8Ooo
ool2o`0000Oooooo2ooVi^H00oooooooi^KVonKViP09onKViSSooooo000Kooooo`?o00005?ooool3
o`0002Oooooo1?l0000Aooooo`Woi^KV8_ooool6o`0000Cooooo2OoVi^H3ooooo`Woi^KV>Oooool0
07;ooooo1ooVi^H^ooooo`Ooi^KV1Oooool7onKViS[ooooo001cooooo`Goi^KV:Oooool00ol0003o
ooooooooo`04ooooo`Goi^KV1oooool5onKViS_ooooo000Qooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03kooooo
000Qooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0;?ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo03kooooo000Rooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03oooooo000Roooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo02kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo03oooooo000Sooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02oooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo000Sooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo033ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo043ooooo000Sooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo000Tooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo037ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo047ooooo000Tooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0<_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo047ooooo000Uooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;o
oooo000Uooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo04;ooooo000Vooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0=Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Gooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo04?ooooo000Vooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo03Gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo04?ooooo
000Vooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo03Kooooo00Co0000oooooooooooo00000oooool00ol0003ooooo
ooooo`13ooooo`009oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0gooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0A?ooool002Oooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo04Cooooo000Wooooo`Goi^KV00?o0000ooooooooool0>Ooo
ool5onKViS_ooooo1OoVi^I7ooooo`009_ooool2onKViPCo000000?oi^KVooooooooool0>?ooool7
onKViSWooooo1ooVi^I6ooooo`009Oooool6onKViP;o000000?oi^KVooooooooool0=_ooool9onKV
iSOooooo2OoVi^I5ooooo`002Oooool4o`0001Oooooo1?oVi^H5o`0000;oi^KV6Oooool4o`0001Wo
oooo0_oVi^H7o`0000;oi^KV5oooool6o`0001Sooooo0_oVi^H7o`0000;oi^KVA?ooool000[ooooo
0_l0000Hooooo`?oi^KV0_l00002onKViP;o00000_oVi^HHooooo`;o00000_ooool2o`0001Sooooo
0ooVi^H2o`000003onKVi_l0003o000000?oi^KV6?ooool2o`000003ooooool0003o000001Sooooo
0ooVi^H2o`000003onKVi_l0003o000000?oi^KVA?ooool000Oooooo1_l0000Gooooo`?oi^KV0_l0
0002onKViP;o00000_oVi^HHooooo`;o00007?ooool3onKViP;o000000?oi^KVo`000?l000000ooV
i^HIooooo`;o00006_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`001oooool2
o`000003ooooool0003o000001Sooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQSooooo0_l00002
ooooo`;o00006?ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^HJooooo`;o00006Oooool3
onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`002?ooool4o`0000?ooooo0ol0000Boooo
o`Coi^KV1_l000000ooVi^Koooooooooo`0Gooooo`Co00006Oooool3onKViPCo00001?oVi^HGoooo
o`;o00000_ooool2o`0001Kooooo0_l00003onKViPCo00001?oVi^I4ooooo`002Oooool3o`0000Ko
oooo0ol0000@ooooo`Woi^KV00?oooooo`000?l00000=Oooool2onKViP;o00001OoVi^HEooooo`;o
000000?oooooo`000?l000000_ooool2o`0001?ooooo0ol00003ooooo`;oi^KV0_l00005onKViTGo
oooo000:ooooo`;o00002Oooool3o`0000kooooo1ooVi^H4ooooo`;o0000=?ooool3o`0000Coi^KV
5?ooool2o`0000Cooooo1?l0000Aooooo`?o00001oooool3o`0000Coi^KVA_ooool001Sooooo0ol0
000<ooooo`Goi^KV1oooool2o`0001Sooooo00?o0000ooooooooool05oooool00ol0003oi^KVonKV
iP03onKViQ?ooooo0_l0000Hooooo`?o00002oooool5onKViTOooooo000Kooooo`?o00005oooool2
o`0001Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Dooooo`;o00005oooool3
o`0005[ooooo000Nooooo`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`?o0000GOooool0027o
oooo0ol0000Dooooo`;o00005?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01;o
oooo0_l0000Dooooo`?o0000H?ooool002Cooooo0ol0000Cooooo`;o00004oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo017ooooo0_l0000Cooooo`?o0000Hoooool002Oooooo0ol0
000Booooo`;o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo0_l0
000Booooo`?o0000I_ooool002[ooooo0ol0000Aooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo0ol0001Y
ooooo`00;Oooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool03_ooool2o`0000oooooo0ol0001/ooooo`00<?ooool3o`0000kooooo0_l0000>ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001_ooooo`00
<oooool3o`0000gooooo0_l0000=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
2oooool2o`0000gooooo0ol0001booooo`00=_ooool3o`0000cooooo0_l0000<ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02_ooool2o`0000cooooo0ol0001eooooo`00>Oooool3
o`0000_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02Oooool3o`0007Sooooo000looooo`?o00002Oooool2o`00
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`;o00002Oooool3o`00
07_ooooo000oooooo`?o00002?ooool2o`0000Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`06ooooo`;o00002?ooool3o`0007kooooo0012ooooo`?o00001oooool2o`0000Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00001oooool3o`00087ooooo
0015ooooo`?o00001_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`?o0000Q?ooool004Sooooo0ol00004
ooooo`;o00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo0_l00004
ooooo`?o0000Qoooool004_ooooo0ol00003ooooo`;o00001?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo0_l00003ooooo`?o0000R_ooool004kooooo0ol00002ooooo`;o
00000_ooool00ol0003oi^KVonKViP03onKViP03o`000?oooooooooo00;o00000_ooool3o`0008go
oooo001Aooooo`?o000000?oooooo`000?l000001ooVi^H2o`000004ooooool0003o0000o`00093o
oooo001Dooooo`;o000000?oi^KVo`000?l000001?l00002onKViP;o0000Toooool005Gooooo1?oV
i^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`00
00Goi^KVU?ooool005Gooooo0ooVi^H5o`0000?oi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KV
U?ooool005Kooooo1?oVi^H3o`0000;oi^KVUOooool005Oooooo1ooVi^JFooooo`00F?ooool5onKV
iYOooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.16114 .36788 -5 -6 ]
[.16114 .36788 5 6 ]
[.12422 .25016 -5 -6 ]
[.12422 .25016 5 6 ]
[.29769 .25016 -5 -6 ]
[.29769 .25016 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.76029 .25016 -5 -6 ]
[.76029 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.16114 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .36788 Mdot
0 g
gsave
.16114 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .36788 m
.12422 .25016 L
s
.21096 .36788 m
.29769 .25016 L
s
1 g
.05 w
.12422 .25016 Mdot
0 g
gsave
.12422 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.29769 .25016 Mdot
0 g
gsave
.29769 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.76029 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .25016 Mdot
0 g
gsave
.76029 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo002Rooooo`Co00005?ooool3onKV
iPGo000000?oi^KVooooooooool04?ooool2onKViPGo00000_oVi^HFooooo`00XOooool2o`0000;o
oooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^HEooooo`00YOooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQ3ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o00004_ooool3onKViP;o00000_oV
i^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV5Oooool00:7ooooo1Ol0000C
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0>ooooo`?oi^KV1_l00002onKViQGooooo002Qoooo
o`;o00005_ooool;onKViQ3ooooo2ooVi^HEooooo`00XOooool6o`0001?ooooo2OoVi^HBooooo`Wo
i^KV5_ooool00:Sooooo00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H0
1OoVi^HGooooo`00ZOooool00ol0003oooooooooo`0@ooooo`Goi^KV4oooool00ol0003ooooooooo
o`05onKViQSooooo002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Nooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool07oooool00:cooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo023ooooo002]ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Qooooo`00[_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08_ooool00:oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02?ooooo002`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Toooo
o`00/Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool09Oooool00;;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Gooooo002cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool09oooool00;Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo002fooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool00;Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02_ooooo002i
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/
ooooo`00^_ooool00ol0003oooooonKViP04onKViP?ooooo00?o0000ooooooooool0;Oooool00;_o
oooo1ooVi^H00ooooooo0000ooooo`0_ooooo`00^oooool8onKViS7ooooo000Nooooo`Go00009_oo
ool4o`0000Oooooo1Ol0000kooooo`Go00001oooool4o`00013ooooo1?l00004ooooo`Oo000000?o
i^KVooooooooool00_ooool5o`0002Oooooo000Oooooo`;o000000?oooooo`000?l000009_ooool2
o`0000Wooooo0_l000000ooooooo0000o`00000iooooo`;o000000?oooooo`000?l000001oooool2
o`0000;ooooo0_l0000>ooooo`;o00001oooool01?oVi^Ko0000o`000?oVi^H2o`0000;oi^KV0ooo
ool2o`000003ooooool0003o000002Sooooo000Oooooo`;o000000?oooooo`000?l000008oooool6
o`0000Sooooo0_l000000ooooooo0000o`00000jooooo`Co00001oooool2o`0001;ooooo1_l00003
ooooo`04onKVi_l0003o0000onKViP;o00000_oVi^H3ooooo`;o000000?oooooo`000?l00000:?oo
ool001oooooo0_l000000ooooooo0000o`00000Sooooo`;o000000?oooooo`000?l000002Oooool2
o`000003ooooool0003o000003Wooooo0_l000000ooooooo0000o`000007ooooo`;o00000_ooool2
o`0000kooooo0_l00002ooooo`;o00000oooool01?oVi^Ko0000o`000?oVi^H2o`0000;oi^KV0ooo
ool2o`000003ooooool0003o000002Sooooo000Oooooo`Co00009Oooool4o`0000Wooooo1?l0000k
ooooo`?o00002Oooool4o`00013ooooo1?l00004ooooo`03onKVi_l0003o000000;o00000ooVi^H4
ooooo`Co0000:?ooool001oooooo0_l0000Xooooo`?o00002Oooool2o`0006Cooooo0_oVi^H2o`00
00Coi^KV1oooool2o`0002Sooooo000Nooooo`?o0000:Oooool2o`0000Sooooo0ol00005ooooo`03
o`000?oooooooooo033ooooo00Co0000ooooool0003o00004_ooool00ol0003oooooooooo`0Coooo
o`04onKVi_l0003o0000o`0000?oi^KV1oooool3o`0002Sooooo000Tooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Cooooo`03o`000?oVi^Koi^KV
00?oi^KV1_ooool00ol0003oooooooooo`0Zooooo`009Oooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo01Gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0:oooool002Kooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Gooooo`;o0000:oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool03?ooool01Ol0003ooooooooooooooooo000000[o
oooo00?o0000ooooooooool0;?ooool002Oooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00_ooooo00Co0000oooooooooooo00002_ooool00ol0003o
ooooooooo`0]ooooo`009oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool09?ooool2o`00017ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooo000000_ooooo00?o0000ooooooooool0;Oooool002Sooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooool000002_ooool00ol0003oooooooooo`0^ooooo`00:Oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool2o`0000[ooooo00?o0000
ooooooooool0;oooool002[ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0`oooo
o`00:_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02?ooooo0_l0000Mooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`;o
00002_ooool00ol0003oooooooooo`0`ooooo`00:oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000009ooooo`03o`00
0?oooooooooo037ooooo000/ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool0<_oo
ool002cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00?ooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`0booooo`00;Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0<oooool002kooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo013ooooo0_l0000R
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo03Cooooo000_ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool02Oooool2o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0eoooo
o`00;oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo033ooooo0_l0000=ooooo`03
o`000?oooooooooo02Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0=Oooool0033ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0fooooo`00<Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000>Oooool003;ooooo1Ol000000ooVi^Ko0000ooooo`0hooooo`03o`000?oVi^Ko000000?o0000
0_ooool00ol0003oooooooooo`0Zooooo`Go000000?oi^KVo`000?ooool01?ooool5o`000003onKV
i_l0003ooooo03Wooooo000booooo`Coi^KV0_l000000ooVi^Koooooooooo`0gooooo`Goi^KV0ol0
000]ooooo`Coi^KV0_l000000ooVi^Koooooooooo`03ooooo`Coi^KV0_l000000ooVi^Kooooooooo
o`0hooooo`007?ooool5o`0000Oooooo1?l00005ooooo`;oi^KV1Ol00002onKViR7ooooo1_l0000@
ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Qooooo`Co00001Oooool2onKViPGo00000_oVi^H3
ooooo`;oi^KV1Ol00002onKViSWooooo000Kooooo`;o000000?oooooo`000?l000001oooool2o`00
00Oooooo0_oVi^H2o`0000;oi^KV0_l00003onKViR7ooooo0_l000000ooooooo0000o`00000?oooo
o`?oi^KV0_l00002onKViP;o00000_oVi^HQooooo`;o00000_ooool2o`0000?ooooo0_oVi^H2o`00
00;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?ooool001co
oooo1?l00007ooooo`Ko00000oooool2onKViP;o00000_oVi^H2o`0000?oi^KV8_ooool2o`00017o
oooo0ooVi^H2o`0000;oi^KV0_l00002onKViRGooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^H00oooooooi^KVonKViP02o`0000;oi^KV0_l00003onKViSSooooo000Kooooo`;o0000
00?oooooo`000?l000001oooool2o`0000;ooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^HSooooo`;o00004?ooool3onKViP;o00000_oVi^H2o`0000;oi^KV9Oooool2o`0000?ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV
>?ooool001cooooo0ol00009ooooo`Co00001?ooool3onKViPKo00000_oVi^HPooooo`;o00000_oo
ool2o`0000oooooo1?oVi^H6o`000003onKVi_oooooooooo01oooooo1Ol00004ooooo`?oi^KV1_l0
0002onKViP04oooooooVi^Koi^KVonKViPKo00000_oVi^Hhooooo`00<?ooool;onKViR3ooooo0_l0
0002ooooo`;o00003oooool;onKViR7ooooo0_l00007ooooo`_oi^KV00?oooooonKVi_oVi^H02OoV
i^Hhooooo`00<Oooool9onKViR;ooooo1?l0000Aooooo`Woi^KV8_ooool6o`0000Cooooo2OoVi^H3
ooooo`Woi^KV>Oooool003;ooooo1ooVi^Hiooooo`Ooi^KV;_ooool7onKViPGooooo1ooVi^Hjoooo
o`00<oooool5onKViS_ooooo1OoVi^HYooooo`03o`000?oooooooooo00Cooooo1OoVi^H7ooooo`Go
i^KV>oooool0027ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo02cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0/ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`008Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03kooooo000Rooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0?oooool002;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0^ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`0oooooo`008oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02oo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043o
oooo000Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0`ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0<?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@?ooool002?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`10ooooo`009?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo047ooooo000Tooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0<_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0@Oooool002Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo03?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0cooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`12ooooo`00
9Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
<oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;ooooo000Vooooo`05o`000?oo
ooooooooooooool000000oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0@oooool002Kooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo03Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0eooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`13ooooo`009_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03Kooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`13ooooo`009oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0gooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0A?oo
ool002Oooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0gooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0=oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo04Cooooo000Wooooo`Goi^KV00?o0000ooooooooool0>Oooool5onKViS_ooooo1OoV
i^I7ooooo`009_ooool2onKViPCo000000?oi^KVooooooooool0>?ooool7onKViSWooooo1ooVi^I6
ooooo`009Oooool6onKViP;o000000?oi^KVooooooooool0=_ooool9onKViSOooooo2OoVi^I5oooo
o`002Oooool4o`0001Oooooo1?oVi^H5o`0000;oi^KV6Oooool4o`0001Wooooo0_oVi^H7o`0000;o
i^KV5oooool6o`0001Sooooo0_oVi^H7o`0000;oi^KVA?ooool000[ooooo0_l0000Hooooo`?oi^KV
0_l00002onKViP;o00000_oVi^HHooooo`;o00000_ooool2o`0001Sooooo0ooVi^H2o`000003onKV
i_l0003o000000?oi^KV6?ooool2o`000003ooooool0003o000001Sooooo0ooVi^H2o`000003onKV
i_l0003o000000?oi^KVA?ooool000Oooooo1_l0000Gooooo`?oi^KV0_l00002onKViP;o00000_oV
i^HHooooo`;o00007?ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^HIooooo`;o00006_oo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`001oooool2o`000003ooooool0003o
000001Sooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQSooooo0_l00002ooooo`;o00006?ooool3
onKViP;o000000?oi^KVo`000?l000000ooVi^HJooooo`;o00006Oooool3onKViP;o000000?oi^KV
o`000?l000000ooVi^I4ooooo`002?ooool4o`0000?ooooo0ol0000Booooo`Coi^KV1_l000000ooV
i^Koooooooooo`0Gooooo`Co00006Oooool3onKViPCo00001?oVi^HGooooo`;o00000_ooool2o`00
01Kooooo0_l00003onKViPCo00001?oVi^I4ooooo`002Oooool3o`0000Kooooo0ol0000@ooooo`Wo
i^KV00?oooooo`000?l00000=Oooool2onKViP;o00001OoVi^HEooooo`;o000000?oooooo`000?l0
00000_ooool2o`0001?ooooo0ol00003ooooo`;oi^KV0_l00005onKViTGooooo000:ooooo`;o0000
2Oooool3o`0000kooooo1ooVi^H4ooooo`;o0000=?ooool3o`0000Coi^KV5?ooool2o`0000Cooooo
1?l0000Aooooo`?o00001oooool3o`0000Coi^KVA_ooool001Sooooo0ol0000<ooooo`Goi^KV1ooo
ool2o`0001Sooooo00?o0000ooooooooool05oooool00ol0003oi^KVonKViP03onKViQ?ooooo0_l0
000Hooooo`?o00002oooool5onKViTOooooo000Kooooo`?o00005oooool2o`0001Kooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Dooooo`;o00005oooool3o`0005[ooooo000Noooo
o`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`0Dooooo`?o0000GOooool0027ooooo0ol0000Dooooo`;o
00005?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01;ooooo0_l0000Dooooo`?o
0000H?ooool002Cooooo0ol0000Cooooo`;o00004oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo017ooooo0_l0000Cooooo`?o0000Hoooool002Oooooo0ol0000Booooo`;o00004_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo0_l0000Booooo`?o0000I_oo
ool002[ooooo0ol0000Aooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo0ol0001Yooooo`00;Oooool3o`00
00oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool2o`00
00oooooo0ol0001/ooooo`00<?ooool3o`0000kooooo0_l0000>ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001_ooooo`00<oooool3o`0000gooooo
0_l0000=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool02oooool2o`0000gooooo
0ol0001booooo`00=_ooool3o`0000cooooo0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool02_ooool2o`0000cooooo0ol0001eooooo`00>Oooool3o`0000_ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool3o`0007Sooooo000looooo`?o00002Oooool2o`0000[ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`;o00002Oooool3o`0007_ooooo000oooooo`?o
00002?ooool2o`0000Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`;o
00002?ooool3o`0007kooooo0012ooooo`?o00001oooool2o`0000Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`05ooooo`;o00001oooool3o`00087ooooo0015ooooo`?o00001_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`04ooooo`?o0000Q?ooool004Sooooo0ol00004ooooo`;o00001Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`?o0000Qoooool0
04_ooooo0ol00003ooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00;ooooo0_l00003ooooo`?o0000R_ooool004kooooo0ol00002ooooo`;o00000_ooool00ol0003o
i^KVonKViP03onKViP03o`000?oooooooooo00;o00000_ooool3o`0008gooooo001Aooooo`?o0000
00?oooooo`000?l000001ooVi^H2o`000004ooooool0003o0000o`00093ooooo001Dooooo`;o0000
00?oi^KVo`000?l000001?l00002onKViP;o0000Toooool005Gooooo1?oVi^H2o`0000Goi^KVU?oo
ool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Go
oooo0ooVi^H5o`0000?oi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Kooooo1?oV
i^H3o`0000;oi^KVUOooool005Oooooo1ooVi^JFooooo`00F?ooool5onKViYOooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.25575 .21092 -5 -6 ]
[.25575 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.25575 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.25575 .21092 Mdot
0 g
gsave
.25575 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0001>ooooo`Co00002_ooool009?ooooo0_l00002
ooooo`;o0000C?ooool2o`0000;ooooo0_l00009ooooo`00Toooool2o`0005Cooooo0_l00009oooo
o`00Toooool2o`0000;ooooo0_l0001@ooooo`;o00002Oooool009Cooooo1?l0001=ooooo`Go0000
2_ooool00>Gooooo0_l0000=ooooo`00iOooool6o`0000Wooooo002Jooooo`03o`000?oooooooooo
04Oooooo00?o0000ooooooooool03Oooool009_ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0>ooooo`00W?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00oooooo
002Mooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool04?ooool009kooooo00?o0000
ooooooooool0?oooool00ol0003oooooooooo`0Aooooo`00W_ooool00ol0003oooooooooo`0ooooo
o`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo03gooooo00?o0000oooooooo
ool04_ooool00:3ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0Cooooo`00XOoo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo01Cooooo002Rooooo`03o`000?oooooo
oooo03Oooooo00?o0000ooooooooool05Oooool00:?ooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0Fooooo`00Y?ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Oo
oooo002Uooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool06?ooool00:Kooooo00?o
0000ooooooooool0;oooool00ol0003oooooooooo`0Iooooo`00Y_ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool06_ooool00:Sooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Kooooo`00
ZOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01cooooo002Zooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool07Oooool00:_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Nooooo`00[?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
01oooooo002]ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00:kooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Qooooo`00[oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool08_ooool00;3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Soooo
o`00/Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo02Cooooo002booooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool09Oooool00;?ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo02Oooooo002eooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0:?ooool00;Ko
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0:_ooool00;Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0[
ooooo`00^Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02cooooo002jooooo`03
o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00^oooool00ol0003oi^KV
o`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoVi^H2o`0000;oi^KV<?oo
ool002_ooooo1Ol0000?ooooo`Co00003oooool4o`0004;ooooo1?l0000Nooooo`?oi^KV1Ol00003
onKViRoooooo000Zooooo`;o000000?oooooo`000?l000004Oooool2o`00017ooooo0_l00012oooo
o`;o00008Oooool2onKViP;o00000_oVi^H2o`0000?oi^KV;oooool002_ooooo1?l0000>ooooo`Ko
00003Oooool6o`00047ooooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00
:_ooool2o`000003ooooool0003o000000kooooo0_l000000ooooooo0000o`00000>ooooo`;o0000
00?oooooo`000?l00000@_ooool2o`0000;ooooo0_l0000Mooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^H_ooooo`00:oooool3o`00013ooooo1?l0000?ooooo`Co0000@oooool4o`0001kooooo0ooV
i^H6o`0000;oi^KV;oooool003oooooo0ol0000@ooooo`?o0000I_ooool9onKViS3ooooo0010oooo
o`;o00004Oooool2o`0006Oooooo1ooVi^Haooooo`00W?ooool00ol0003oooooooooo`0Nooooo`Go
i^KV<_ooool002oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo04Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0dooooo`00<?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0B_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000`ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1:ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool0=Oooool0037ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0fooooo`00<Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Ko
oooo000aooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0=_ooool003;ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04kooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0gooooo`00<_ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo03Oooooo000cooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool0>?ooool003?ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo053ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0hooooo`00
<oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Sooooo000dooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool0>Oooool003Cooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0iooooo`00=Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
03[ooooo000eooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`1Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0>_ooool003Gooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0jooooo`00=_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0EOooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo03_ooooo000fooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool0>oooool003Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0loooo
o`00=oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0F?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo03cooooo000hooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Iooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0?Oooool003Sooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0mooooo`00>?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo03gooooo000iooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`1Kooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0?_ooool003Wo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05co
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0nooooo`00>_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0GOooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0?oooool003[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0o
ooooo`00>oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Goooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo043ooooo000kooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Pooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0@?ooool003cooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`11ooooo`00??ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0HOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0@Oooool003gooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@_ooool003gooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0@_ooool003kooooo1OoVi^IWooooo`Goi^KVAOooool003gooooo00?o
i^KVo`000?l000000_l00002onKViVGooooo1ooVi^I4ooooo`00??ooool5onKViP;o00000_oVi^IS
ooooo`Woi^KV@oooool000Wooooo1?l0000^ooooo`?oi^KV1Ol00003onKViRkooooo1?l0000_oooo
o`;oi^KV1ol00002onKViRoooooo1Ol0000>ooooo`002_ooool2o`0002oooooo0_oVi^H2o`0000;o
i^KV0_l00003onKViRgooooo0_l0000booooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViRko
oooo0_l000000ooooooo0000o`00000?ooooo`001oooool6o`0002kooooo0_oVi^H2o`0000;oi^KV
0_l00003onKViRgooooo1_l0000^ooooo`?oi^KV0_l000000ooVi^Ko0000o`000003onKViRoooooo
1?l0000?ooooo`001oooool2o`000003ooooool0003o000002oooooo0_oVi^H2o`0000;oi^KV0_l0
0003onKViRgooooo0_l00002ooooo`;o0000;_ooool3onKViP;o000000?oi^KVo`000?l000000ooV
i^H^ooooo`;o000000?oooooo`000?l000003oooool000Sooooo1?l00003ooooo`;o0000:_ooool3
onKViPKo00000_oVi^H^ooooo`Co0000;oooool3onKViPCo00001?oVi^H_ooooo`?o00004?ooool0
00Wooooo0ol00005ooooo`;o0000:Oooool9onKViV?ooooo0_oVi^H2o`0000Goi^KV:_ooool2o`00
01Oooooo000:ooooo`;o00001oooool3o`0002Oooooo1ooVi^H00ooooooo0000ooooo`1Pooooo`03
o`000?oooooo000000;o00001?oVi^HXooooo`?o00006Oooool001Kooooo0_l0000Vooooo`Goi^KV
0oooool2o`0005gooooo0_l00003ooooo`Goi^KV9oooool2o`0001cooooo000Hooooo`?o0000;Ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?oo
ool3o`0001kooooo000Kooooo`;o0000;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool0:oooool2o`00027ooooo000Mooooo`;o0000:oooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool3o`00
02?ooooo000Oooooo`?o0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0:?ooool2o`0002Kooooo000Rooooo`;o0000:?ooool2o`0002Sooooo
00?o0000ooooooooool09_ooool2o`0002Wooooo0_l0000Xooooo`009?ooool3o`0002Oooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Kooooo0ol0
000Zooooo`009oooool2o`0002Kooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo02Gooooo0_l0000]ooooo`00:Oooool2o`0002Gooooo00?o0000oooo
ooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo0ol0000_oooo
o`00:oooool3o`0002?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo02;ooooo0_l0000booooo`00;_ooool2o`0002;ooooo0_l0000Rooooo`03o`00
0?oooooooooo023ooooo0_l0000Rooooo`?o0000=?ooool0033ooooo0ol0000Qooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o0000=ooo
ool003?ooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`0Oooooo`;o0000>Oooool003Gooooo0_l0000Oooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`?o0000>oooool003Oo
oooo0ol0000Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0Looooo`;o0000?_ooool003[ooooo0_l0000Looooo`;o00007?ooool00ol0003ooooo
ooooo`0Jooooo`;o00007?ooool3o`00043ooooo000looooo`?o00006oooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06_ooool2o`0004?ooooo000o
ooooo`;o00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool06?ooool3o`0004Gooooo0011ooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool2o`0004Sooooo0013ooooo`?o
00005oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool05_ooool2o`0004[ooooo0016ooooo`;o00005_ooool2o`0001Kooooo00?o0000ooooooooool0
5?ooool2o`0001Kooooo0ol0001<ooooo`00B?ooool3o`0001Gooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Cooooo0_l0001?ooooo`00Boooool2
o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo0ol0001Aooooo`00COooool2o`0001?ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0_l0001Dooooo`00Coooool3o`00017o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013o
oooo0_l0001Fooooo`00D_ooool2o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo
0_l0000@ooooo`?o0000F?ooool005Cooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`;o0000Foooool005Oooooo0_l0000>
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<
ooooo`?o0000GOooool005Wooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000H?ooool005_ooooo0ol0000;ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`?o
0000H_ooool005kooooo0_l0000:ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`;o0000
2_ooool2o`0006Gooooo001Pooooo`?o00002Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool02?ooool2o`0006Oooooo001Sooooo`;o00002?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool3
o`0006Wooooo001Uooooo`;o00001oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01Oooool2o`0006cooooo001Wooooo`?o00001Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool3o`0006ko
oooo001Zooooo`;o00001?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool2o`0000Cooooo
0_l0001aooooo`00K?ooool3o`0000?ooooo00?o0000oooooooVi^H01?oVi^H00ooooooo0000oooo
o`02ooooo`?o0000Loooool006oooooo0_l00002ooooo`Ooi^KV0_ooool2o`0007Kooooo001aoooo
o`03o`000?oVi^Ko000000Go00000_oVi^H00ol0003oooooooooo`1fooooo`00LOooool4onKViP;o
00001OoVi^Ihooooo`00LOooool4onKViP;o00001OoVi^Ihooooo`00LOooool4onKViP;o00001OoV
i^Ihooooo`00LOooool3onKViPGo00000ooVi^Ihooooo`00LOooool4onKViP;o00001OoVi^Ihoooo
o`00L_ooool4onKViP?o00000_oVi^Iiooooo`00Loooool7onKViW[ooooo001dooooo`Goi^KVNooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.487698 0.231944 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.17499 .21092 -5 -6 ]
[.17499 .21092 5 6 ]
[.33652 .21092 -5 -6 ]
[.33652 .21092 5 6 ]
[.25575 .40712 -5 -6 ]
[.25575 .40712 5 6 ]
[.4877 .40712 -5 -6 ]
[.4877 .40712 5 6 ]
[.63887 .21092 -5 -6 ]
[.63887 .21092 5 6 ]
[.62463 .01472 -5 -6 ]
[.62463 .01472 5 6 ]
[.80041 .01472 -5 -6 ]
[.80041 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80041 .21092 -5 -6 ]
[.80041 .21092 5 6 ]
[.71964 .40712 -5 -6 ]
[.71964 .40712 5 6 ]
[.95159 .40712 -5 -6 ]
[.95159 .40712 5 6 ]
[.4877 .60332 -5 -6 ]
[.4877 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.4877 .60332 m
.02381 .40712 L
s
.4877 .60332 m
.25575 .40712 L
s
.4877 .60332 m
.4877 .40712 L
s
.4877 .60332 m
.71964 .40712 L
s
.4877 .60332 m
.95159 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.25575 .40712 m
.17499 .21092 L
s
.25575 .40712 m
.33652 .21092 L
s
1 g
.05 w
.17499 .21092 Mdot
0 g
gsave
.17499 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.33652 .21092 Mdot
0 g
gsave
.33652 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.25575 .40712 Mdot
0 g
gsave
.25575 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.4877 .40712 Mdot
0 g
gsave
.4877 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.71964 .40712 m
.63887 .21092 L
s
.71964 .40712 m
.80041 .21092 L
s
1 g
.05 w
.63887 .21092 Mdot
0 g
gsave
.63887 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.80041 .21092 m
.62463 .01472 L
s
.80041 .21092 m
.80041 .01472 L
s
.80041 .21092 m
.97619 .01472 L
s
1 g
.05 w
.62463 .01472 Mdot
0 g
gsave
.62463 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.80041 .01472 Mdot
0 g
gsave
.80041 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.80041 .21092 Mdot
0 g
gsave
.80041 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71964 .40712 Mdot
0 g
gsave
.71964 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.95159 .40712 Mdot
0 g
gsave
.95159 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.9 g
.4877 .60332 Mdot
0 g
gsave
.4877 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Cooooo1?l0000Uooooo`Co00009Oooool5o`0000Wooooo002C
ooooo`;o00000_ooool2o`0002?ooooo0_l0000Wooooo`;o000000?oooooo`000?l000002_ooool0
09?ooooo0_l0000Wooooo`Ko00008oooool2o`000003ooooool0003o000000[ooooo002Cooooo`;o
00000_ooool2o`0002?ooooo0_l00002ooooo`;o00008oooool2o`000003ooooool0003o000000[o
oooo002Dooooo`Co00009Oooool4o`0002Gooooo1?l0000:ooooo`00j?ooool2o`0000[ooooo003W
ooooo`?o00002_ooool009[ooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0=oooo
o`00Voooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool03_ooool009cooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo00oooooo002Mooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07ooo
ool00ol0003oooooooooo`0@ooooo`00W_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool04Oooool009kooooo00?o0000ooooooooool07_ooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo017ooooo002Oooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Booooo`00X?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool04oooool00:7ooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Cooooo002R
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0E
ooooo`00Xoooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool05_ooool00:Cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo01Oooooo002Uooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Hooooo`00Y_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool06Oooool00:Kooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Wooooo002Wooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Jooooo`00Z?ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool06oooool00:Wooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01cooooo
002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Mooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool07_ooool00:cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0Pooooo`00[_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool08Oooool00:oooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02;ooooo002_ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Rooooo`00/?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool08oooool00;7o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02Co
oooo002booooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0Uooooo`00/oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool09_ooool00;Cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo02Oooooo002eooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0:Oooool00;Oooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02[ooooo002gooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Zooooo`00^?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0:oooool0
0;Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
02cooooo002jooooo`03o`000?oooooooooo00Goi^KV0_ooool00ol0003oooooooooo`0]ooooo`00
^oooool00ol0003oi^KVo`000003o`0000;oi^KV00?o0000ooooooooool0;_ooool00;_ooooo1OoV
i^H2o`0000;oi^KV<?ooool002[ooooo1Ol0000Sooooo`Co0000@_ooool4o`0001kooooo0ooVi^H5
o`0000?oi^KV;oooool002_ooooo0_l000000ooooooo0000o`00000Sooooo`;o0000@_ooool2o`00
027ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`;o000000?oooooo`000?l0
00008?ooool6o`00047ooooo1_l0000Mooooo`;oi^KV0_l00002onKViP;o00000ooVi^H_ooooo`00
:oooool2o`000003ooooool0003o0000023ooooo0_l000000ooooooo0000o`000012ooooo`;o0000
0_ooool2o`0001gooooo0_oVi^H2o`0000;oi^KV0_l00003onKViRoooooo000[ooooo`Co00008_oo
ool4o`0004?ooooo1?l0000Nooooo`?oi^KV1_l00002onKViRoooooo000[ooooo`;o00009Oooool3
o`0006Kooooo2OoVi^H`ooooo`00:_ooool3o`0002Kooooo0_l0001Wooooo`Ooi^KV<Oooool009co
oooo00?o0000ooooooooool07_ooool5onKViS;ooooo000_ooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo03Cooooo
000`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0B_ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo03Gooooo000`ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0B_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo03Gooooo000aoooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo03Kooooo000aooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0C?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo03Kooooo000aooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo03Kooooo000booooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0C_oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03Oooooo000booooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo03Oooooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Coooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo03Sooooo000cooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03So
oooo000cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0D?ooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo03Sooooo000dooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0DOooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo03Wooooo000d
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo03Wooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0Doooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo03[ooooo000eooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo03[ooooo000eooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
E?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo03[ooooo000fooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo03_ooooo000fooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0E_ooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo03_ooooo000gooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
03cooooo000gooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0F?ooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo03cooooo000hooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0FOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03gooooo
000hooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0FOooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo03gooooo000hooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0F_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03gooooo000ioooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo03kooooo000iooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0G?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo03kooooo000jooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo03oooooo000jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0GOoo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03oooooo000jooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo03oooooo000kooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Goooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo043ooooo000kooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0H?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo043o
oooo000looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0HOooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo047ooooo000looooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0HOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo047ooooo000l
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0H_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo047ooooo000mooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0Hoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04;ooooo000mooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo04;ooooo000nooooo`Goi^KVIoooool5onKViTGooooo000mooooo`03onKVi_l0
003o000000;o00000_oVi^IUooooo`Ooi^KVA?ooool003cooooo1OoVi^H2o`0000;oi^KVHoooool9
onKViT?ooooo0009ooooo`Co0000;_ooool3onKViPGo00000ooVi^H^ooooo`Co0000;oooool2onKV
iPOo00000_oVi^H_ooooo`Go00003_ooool000[ooooo0_l0000_ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^H]ooooo`;o0000<_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H^ooooo`;o
000000?oooooo`000?l000003oooool000Oooooo1_l0000^ooooo`;oi^KV0_l00002onKViP;o0000
0ooVi^H]ooooo`Ko0000;_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^H_ooooo`Co0000
3oooool000Oooooo0_l000000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o00000ooV
i^H]ooooo`;o00000_ooool2o`0002kooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV;_oo
ool2o`000003ooooool0003o000000oooooo0008ooooo`Co00000oooool2o`0002[ooooo0ooVi^H6
o`0000;oi^KV;_ooool4o`0002oooooo0ooVi^H4o`0000Coi^KV;oooool3o`00013ooooo0009oooo
o`?o00001Oooool2o`0002Wooooo2OoVi^ISooooo`;oi^KV0_l00005onKViR[ooooo0_l0000Goooo
o`002_ooool2o`0000Oooooo0ol0000Wooooo`Ooi^KV00?oooooo`000?ooool0H?ooool00ol0003o
ooooo`000002o`0000Coi^KV:?ooool3o`0001Wooooo000Fooooo`;o00009_ooool5onKViP?ooooo
0_l0001Mooooo`;o00000oooool5onKViROooooo0_l0000Looooo`006?ooool3o`0002gooooo00?o
0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo0ol0
000Nooooo`006oooool2o`0002cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo02_ooooo0_l0000Qooooo`007Oooool2o`0002_ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0ol0000Soooo
o`007oooool3o`0002Wooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03
o`000?oooooooooo02Sooooo0_l0000Vooooo`008_ooool2o`0002Sooooo0_l0000Xooooo`03o`00
0?oooooooooo02Kooooo0_l0000Yooooo`;o0000:?ooool002Cooooo0ol0000Wooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`?o0000:_oo
ool002Oooooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Uooooo`;o0000;Oooool002Wooooo0_l0000Uooooo`03o`000?oooooooooo
02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000;oooool002_o
oooo0ol0000Sooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`0Rooooo`;o0000<_ooool002kooooo0_l0000Rooooo`;o00008_ooool00ol0003ooooo
ooooo`0Pooooo`;o00008_ooool3o`0003Cooooo000`ooooo`?o00008Oooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool2o`0003Oooooo000c
ooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool07oooool2o`0003Wooooo000eooooo`;o00007oooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool3o`0003_ooooo000gooooo`?o
00007Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool07?ooool2o`0003kooooo000jooooo`;o00007?ooool2o`0001cooooo00?o0000ooooooooool0
6_ooool2o`0001cooooo0ol00010ooooo`00??ooool3o`0001_ooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo0_l00013ooooo`00?oooool2
o`0001[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo01Sooooo0ol00015ooooo`00@Oooool2o`0001Wooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0_l00018ooooo`00@oooool3o`0001Oo
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Ko
oooo0_l0001:ooooo`00A_ooool2o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo
0_l0000Fooooo`?o0000C?ooool004Sooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Dooooo`;o0000Coooool004_ooooo0_l0000D
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`?o0000DOooool004gooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000E?ooool004oooooo0ol0000Aooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o
0000E_ooool005;ooooo0_l0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o0000
4?ooool3o`0005Sooooo001Dooooo`?o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03_ooool2o`0005_ooooo001Gooooo`;o00003_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool3
o`0005gooooo001Iooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool2o`00063ooooo001Kooooo`?o00002oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3o`0006;o
oooo001Nooooo`;o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo
0_l0001Uooooo`00H?ooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Sooooo0_l0001Wooooo`00Hoooool2o`0000Sooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo0ol0001Y
ooooo`00IOooool2o`0000Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo0_l0001/ooooo`00Ioooool3o`0000Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0001^ooooo`00
J_ooool2o`0000Cooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000
LOooool006cooooo0ol00003ooooo`03o`000?ooooooi^KV00Coi^KV00?oooooo`000?ooool00_oo
ool3o`0007?ooooo001_ooooo`;o00000_ooool7onKViP;ooooo0_l0001fooooo`00LOooool00ol0
003oi^KVo`000005o`0000;oi^KV00?o0000ooooooooool0M_ooool0077ooooo1?oVi^H2o`0000Go
i^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?oo
ool0077ooooo0ooVi^H5o`0000?oi^KVN?ooool0077ooooo1?oVi^H2o`0000Goi^KVN?ooool007;o
oooo1?oVi^H3o`0000;oi^KVNOooool007?ooooo1ooVi^Ijooooo`00M?ooool5onKViW_ooooo0000
\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.1853, -0.626133, \
0.0184226, 0.00435573}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.16114 .36788 -5 -6 ]
[.16114 .36788 5 6 ]
[.12422 .25016 -5 -6 ]
[.12422 .25016 5 6 ]
[.21096 .25016 -5 -6 ]
[.21096 .25016 5 6 ]
[.29769 .25016 -5 -6 ]
[.29769 .25016 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.16114 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .36788 Mdot
0 g
gsave
.16114 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .36788 m
.12422 .25016 L
s
.21096 .36788 m
.21096 .25016 L
s
.21096 .36788 m
.29769 .25016 L
s
1 g
.05 w
.12422 .25016 Mdot
0 g
gsave
.12422 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.21096 .25016 Mdot
0 g
gsave
.21096 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.29769 .25016 Mdot
0 g
gsave
.29769 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo002Rooooo`Co00005?ooool3onKV
iPGo000000?oi^KVooooooooool04?ooool2onKViPGo00000_oVi^HFooooo`00XOooool2o`0000;o
oooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^HEooooo`00YOooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQ3ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o00004_ooool3onKViP;o00000_oV
i^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV5Oooool00:7ooooo1Ol0000C
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0>ooooo`?oi^KV1_l00002onKViQGooooo002Qoooo
o`;o00005_ooool;onKViQ3ooooo2ooVi^HEooooo`00XOooool6o`0001?ooooo2OoVi^HBooooo`Wo
i^KV5_ooool00:Sooooo00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H0
1OoVi^HGooooo`00ZOooool00ol0003oooooooooo`0@ooooo`Goi^KV4oooool00ol0003ooooooooo
o`05onKViQSooooo002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Nooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool07oooool00:cooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo023ooooo002]ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Qooooo`00[_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08_ooool00:oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02?ooooo002`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Toooo
o`00/Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool09Oooool00;;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Gooooo002cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool09oooool00;Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo002fooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool00;Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02_ooooo002i
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/
ooooo`00^_ooool00ol0003oooooonKViP04onKViP?ooooo00?o0000ooooooooool0;Oooool00;_o
oooo1ooVi^H00ooooooo0000ooooo`0_ooooo`00^_ooool9onKViS7ooooo000Oooooo`Go00004?oo
ool4o`00017ooooo1?l00007ooooo`Go0000>oooool5o`0000Oooooo1?l0000Eooooo`?oi^KV1ol0
00000ooVi^Koooooooooo`02ooooo`Co0000:?ooool001kooooo0_l000000ooooooo0000o`00000B
ooooo`;o00004oooool2o`0000Wooooo0_l000000ooooooo0000o`00000iooooo`;o000000?ooooo
o`000?l000001oooool2o`0000;ooooo0_l0000Dooooo`Coi^KV0_l000000ooVi^Ko0000o`000002
onKViP?ooooo0_l00002ooooo`;o00009oooool001oooooo1?l0000?ooooo`Ko00003oooool6o`00
00Sooooo0_l000000ooooooo0000o`00000jooooo`Co00001oooool2o`0001Sooooo1?oVi^H2o`00
0003onKVi_l0003o000000;oi^KV1oooool2o`0002Oooooo000Nooooo`;o000000?oooooo`000?l0
00003oooool2o`000003ooooool0003o0000013ooooo0_l000000ooooooo0000o`000009ooooo`;o
000000?oooooo`000?l00000>Oooool2o`000003ooooool0003o000000Oooooo0_l00002ooooo`;o
00005?ooool4onKViP;o000000?oi^KVo`000?l000000_oVi^H7ooooo`;o00009oooool001oooooo
0ol0000Aooooo`Co00004Oooool4o`0000Wooooo1?l0000kooooo`?o00002Oooool4o`0001Gooooo
1?oVi^H4o`0000?oi^KV0oooool5o`0002Sooooo000dooooo`?o00004_ooool3o`0000Wooooo0_l0
001Sooooo`?oi^KV0_l00004onKViPCooooo0_l0000[ooooo`00=Oooool2o`0001?ooooo0_l00008
ooooo`?o00001Oooool00ol0003oooooooooo`0`ooooo`04o`000?oooooo0000o`0001;ooooo00?o
0000ooooooooool04oooool01?oVi^Ko0000o`000?l00003onKViPGooooo1_l0000Wooooo`009?oo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0;_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool04ooo
ool00ol0003oi^KVonKViP03onKViPKooooo00?o0000ooooooooool0:_ooool002Gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool0;?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02_ooooo000Voooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Goooo
o`;o0000:oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02cooooo000Wooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0]ooooo`00
9oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Tooooo`;o00004Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0]ooooo`00:?oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0;_oo
ool002Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo02oooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`0`ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool08oooool2o`0001gooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0`ooooo`00:oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0<Oooool002cooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo03;ooooo000/ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0booooo`00;Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo
000000_ooooo00?o0000ooooooooool0<oooool002kooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool04?ooool2o`00
02;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo
03Cooooo000_ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`09ooooo`;o00002_ooool00ol0003oooooooooo`0eooooo`00;oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0<?ooool2o`0000gooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0=Oooool0033ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000002Oooool00ol0003ooooooooo
o`0fooooo`00<Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0=Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool01Ooo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0=oooool003;ooooo1Ol0
00000ooVi^Ko0000ooooo`0hooooo`03o`000?oVi^Ko000000?o00000_ooool00ol0003ooooooooo
o`0Zooooo`Go000000?oi^KVo`000?ooool01?ooool5o`000003onKVi_l0003ooooo03Wooooo000b
ooooo`Coi^KV0_l000000ooVi^Koooooooooo`0gooooo`Goi^KV0ol0000]ooooo`Coi^KV0_l00000
0ooVi^Koooooooooo`03ooooo`Coi^KV0_l000000ooVi^Koooooooooo`0hooooo`007?ooool5o`00
00Oooooo1?l00005ooooo`;oi^KV1Ol00002onKViR7ooooo1_l0000@ooooo`?oi^KV1Ol000000ooV
i^Koooooooooo`0Qooooo`Co00001Oooool2onKViPGo00000_oVi^H3ooooo`;oi^KV1Ol00002onKV
iSWooooo000Kooooo`;o000000?oooooo`000?l000001oooool2o`0000Oooooo0_oVi^H2o`0000;o
i^KV0_l00003onKViR7ooooo0_l000000ooooooo0000o`00000?ooooo`?oi^KV0_l00002onKViP;o
00000_oVi^HQooooo`;o00000_ooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViP03
oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?ooool001cooooo1?l00007ooooo`Ko0000
0oooool2onKViP;o00000_oVi^H2o`0000?oi^KV8_ooool2o`00017ooooo0ooVi^H2o`0000;oi^KV
0_l00002onKViRGooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o00000ooVi^H00oooooooi^KV
onKViP02o`0000;oi^KV0_l00003onKViSSooooo000Kooooo`;o000000?oooooo`000?l000001ooo
ool2o`0000;ooooo0_l00003ooooo`;oi^KV0_l00002onKViP;o00000ooVi^HSooooo`;o00004?oo
ool3onKViP;o00000_oVi^H2o`0000;oi^KV9Oooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l0
0003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2o`0000?oi^KV>?ooool001cooooo0ol00009
ooooo`Co00001?ooool3onKViPKo00000_oVi^HPooooo`;o00000_ooool2o`0000oooooo1?oVi^H6
o`000003onKVi_oooooooooo01oooooo1Ol00004ooooo`?oi^KV1_l00002onKViP04oooooooVi^Ko
i^KVonKViPKo00000_oVi^Hhooooo`00<?ooool;onKViR3ooooo0_l00002ooooo`;o00003oooool;
onKViR7ooooo0_l00007ooooo`_oi^KV00?oooooonKVi_oVi^H02OoVi^Hhooooo`00<Oooool9onKV
iR;ooooo1?l0000Aooooo`Woi^KV8_ooool6o`0000Cooooo2OoVi^H3ooooo`Woi^KV>Oooool003;o
oooo1ooVi^Hiooooo`Ooi^KV;_ooool7onKViPGooooo1ooVi^Hjooooo`00<oooool5onKViS_ooooo
1OoVi^HYooooo`03o`000?oooooooooo00Cooooo1OoVi^H7ooooo`Goi^KV>oooool0027ooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02cooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`0nooooo`008Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo03kooooo000Rooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0?oooool002;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo02kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0^ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0oooooo`00
8oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
;oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo043ooooo000Sooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0`ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0@?ooool002?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0`ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`10ooooo`009?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
047ooooo000Tooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`0booooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0<_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@Oooool002Gooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`12ooooo`009Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0<oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo04;ooooo000Vooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=Ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0@oooool002Kooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`0eooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`13ooooo`009_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool0=_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Kooooo00Co0000oooooooo
oooo00000oooool00ol0003oooooooooo`13ooooo`009oooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo03Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0goooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0A?ooool002Oooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0=oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo04Cooooo000W
ooooo`Goi^KV00?o0000ooooooooool0>Oooool5onKViS_ooooo1OoVi^I7ooooo`009_ooool2onKV
iPCo000000?oi^KVooooooooool0>?ooool7onKViSWooooo1ooVi^I6ooooo`009Oooool6onKViP;o
000000?oi^KVooooooooool0=_ooool9onKViSOooooo2OoVi^I5ooooo`002Oooool4o`0001Oooooo
1?oVi^H5o`0000;oi^KV6Oooool4o`0001Wooooo0_oVi^H7o`0000;oi^KV5oooool6o`0001Sooooo
0_oVi^H7o`0000;oi^KVA?ooool000[ooooo0_l0000Hooooo`?oi^KV0_l00002onKViP;o00000_oV
i^HHooooo`;o00000_ooool2o`0001Sooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV6?oo
ool2o`000003ooooool0003o000001Sooooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KVA?oo
ool000Oooooo1_l0000Gooooo`?oi^KV0_l00002onKViP;o00000_oVi^HHooooo`;o00007?ooool3
onKViP;o000000?oi^KVo`000?l000000ooVi^HIooooo`;o00006_ooool3onKViP;o000000?oi^KV
o`000?l000000ooVi^I4ooooo`001oooool2o`000003ooooool0003o000001Sooooo0ooVi^H2o`00
00;oi^KV0_l00002onKViQSooooo0_l00002ooooo`;o00006?ooool3onKViP;o000000?oi^KVo`00
0?l000000ooVi^HJooooo`;o00006Oooool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4oooo
o`002?ooool4o`0000?ooooo0ol0000Booooo`Coi^KV1_l000000ooVi^Koooooooooo`0Gooooo`Co
00006Oooool3onKViPCo00001?oVi^HGooooo`;o00000_ooool2o`0001Kooooo0_l00003onKViPCo
00001?oVi^I4ooooo`002Oooool3o`0000Kooooo0ol0000@ooooo`Woi^KV00?oooooo`000?l00000
=Oooool2onKViP;o00001OoVi^HEooooo`;o000000?oooooo`000?l000000_ooool2o`0001?ooooo
0ol00003ooooo`;oi^KV0_l00005onKViTGooooo000:ooooo`;o00002Oooool3o`0000kooooo1ooV
i^H4ooooo`;o0000=?ooool3o`0000Coi^KV5?ooool2o`0000Cooooo1?l0000Aooooo`?o00001ooo
ool3o`0000Coi^KVA_ooool001Sooooo0ol0000<ooooo`Goi^KV1oooool2o`0001Sooooo00?o0000
ooooooooool05oooool00ol0003oi^KVonKViP03onKViQ?ooooo0_l0000Hooooo`?o00002oooool5
onKViTOooooo000Kooooo`?o00005oooool2o`0001Kooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`0Dooooo`;o00005oooool3o`0005[ooooo000Nooooo`?o00005_ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Dooooo`?o0000GOooool0027ooooo0ol0000Dooooo`;o00005?ooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo01;ooooo0_l0000Dooooo`?o0000H?ooool002Cooooo0ol0
000Cooooo`;o00004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo017ooooo0_l0
000Cooooo`?o0000Hoooool002Oooooo0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo0_l0000Booooo`?o0000I_ooool002[ooooo0ol0000Aoooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00oooooo0ol0001Yooooo`00;Oooool3o`0000oooooo0_l0000@ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool2o`0000oooooo0ol0001/ooooo`00
<?ooool3o`0000kooooo0_l0000>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
3?ooool2o`0000kooooo0ol0001_ooooo`00<oooool3o`0000gooooo0_l0000=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool02oooool2o`0000gooooo0ol0001booooo`00=_ooool3
o`0000cooooo0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool2
o`0000cooooo0ol0001eooooo`00>Oooool3o`0000_ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool3o`00
07Sooooo000looooo`?o00002Oooool2o`0000[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`;o00002Oooool3o`0007_ooooo000oooooo`?o00002?ooool2o`0000Sooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`;o00002?ooool3o`0007kooooo
0012ooooo`?o00001oooool2o`0000Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`05ooooo`;o00001oooool3o`00087ooooo0015ooooo`?o00001_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04
ooooo`?o0000Q?ooool004Sooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00?ooooo0_l00004ooooo`?o0000Qoooool004_ooooo0ol00003ooooo`;o
00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`?o
0000R_ooool004kooooo0ol00002ooooo`;o00000_ooool00ol0003oi^KVonKViP03onKViP03o`00
0?oooooooooo00;o00000_ooool3o`0008gooooo001Aooooo`?o000000?oooooo`000?l000001ooV
i^H2o`000004ooooool0003o0000o`00093ooooo001Dooooo`;o000000?oi^KVo`000?l000001?l0
0002onKViP;o0000Toooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`00
00Goi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo0ooVi^H5o`0000?oi^KV
U?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Kooooo1?oVi^H3o`0000;oi^KVUOooool0
05Oooooo1ooVi^JFooooo`00F?ooool5onKViYOooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.16114 .36788 -5 -6 ]
[.16114 .36788 5 6 ]
[.12422 .25016 -5 -6 ]
[.12422 .25016 5 6 ]
[.21096 .25016 -5 -6 ]
[.21096 .25016 5 6 ]
[.29769 .25016 -5 -6 ]
[.29769 .25016 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.76029 .25016 -5 -6 ]
[.76029 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.16114 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .36788 Mdot
0 g
gsave
.16114 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .36788 m
.12422 .25016 L
s
.21096 .36788 m
.21096 .25016 L
s
.21096 .36788 m
.29769 .25016 L
s
1 g
.05 w
.12422 .25016 Mdot
0 g
gsave
.12422 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.21096 .25016 Mdot
0 g
gsave
.21096 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.29769 .25016 Mdot
0 g
gsave
.29769 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.76029 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .25016 Mdot
0 g
gsave
.76029 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo002Rooooo`Co00005?ooool3onKV
iPGo000000?oi^KVooooooooool04?ooool2onKViPGo00000_oVi^HFooooo`00XOooool2o`0000;o
oooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^HEooooo`00YOooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQ3ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o00004_ooool3onKViP;o00000_oV
i^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV5Oooool00:7ooooo1Ol0000C
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0>ooooo`?oi^KV1_l00002onKViQGooooo002Qoooo
o`;o00005_ooool;onKViQ3ooooo2ooVi^HEooooo`00XOooool6o`0001?ooooo2OoVi^HBooooo`Wo
i^KV5_ooool00:Sooooo00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H0
1OoVi^HGooooo`00ZOooool00ol0003oooooooooo`0@ooooo`Goi^KV4oooool00ol0003ooooooooo
o`05onKViQSooooo002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Nooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool07oooool00:cooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo023ooooo002]ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Qooooo`00[_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08_ooool00:oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02?ooooo002`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Toooo
o`00/Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool09Oooool00;;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Gooooo002cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool09oooool00;Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo002fooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool00;Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02_ooooo002i
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/
ooooo`00^_ooool00ol0003oooooonKViP04onKViP?ooooo00?o0000ooooooooool0;Oooool00;_o
oooo1ooVi^H00ooooooo0000ooooo`0_ooooo`00^oooool8onKViS7ooooo000Oooooo`Go00004?oo
ool4o`00017ooooo1?l00007ooooo`Go0000>oooool5o`0000Oooooo1?l0000@ooooo`Co00001?oo
ool7o`000003onKVi_oooooooooo00;ooooo1Ol0000Wooooo`007_ooool2o`000003ooooool0003o
000001;ooooo0_l0000Cooooo`;o00002Oooool2o`000003ooooool0003o000003Wooooo0_l00000
0ooooooo0000o`000007ooooo`;o00000_ooool2o`0000kooooo0_l00007ooooo`04onKVi_l0003o
0000onKViP;o00000_oVi^H3ooooo`;o000000?oooooo`000?l00000:?ooool001oooooo1?l0000?
ooooo`Ko00003oooool6o`0000Sooooo0_l000000ooooooo0000o`00000jooooo`Co00001oooool2
o`0001;ooooo1_l00003ooooo`04onKVi_l0003o0000onKViP;o00000_oVi^H3ooooo`;o000000?o
ooooo`000?l00000:?ooool001kooooo0_l000000ooooooo0000o`00000?ooooo`;o000000?ooooo
o`000?l000004?ooool2o`000003ooooool0003o000000Wooooo0_l000000ooooooo0000o`00000i
ooooo`;o000000?oooooo`000?l000001oooool2o`0000;ooooo0_l0000>ooooo`;o00000_ooool2
o`0000?ooooo00Coi^KVo`000?l0003oi^KV0_l00002onKViP?ooooo0_l000000ooooooo0000o`00
000Xooooo`007oooool3o`00017ooooo1?l0000Aooooo`Co00002Oooool4o`0003_ooooo0ol00009
ooooo`Co00004?ooool4o`0000Cooooo00?oi^KVo`000?l000000_l00003onKViPCooooo1?l0000X
ooooo`00=?ooool3o`0001;ooooo0ol00009ooooo`;o0000I?ooool2onKViP;o00001?oVi^H7oooo
o`;o0000:?ooool003Gooooo0_l0000Cooooo`;o00002?ooool3o`0000Gooooo00?o0000oooooooo
ool0<?ooool01?l0003oooooo`000?l0000Booooo`03o`000?oooooooooo01?ooooo00Coi^KVo`00
0?l0003o00000ooVi^H7ooooo`?o0000:?ooool002Cooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo01?ooooo00?o0000onKVi_oVi^H00ooVi^H6oooo
o`03o`000?oooooooooo02[ooooo000Uooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02_ooooo000Vooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Gooooo`;o0000
:oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
3?ooool01Ol0003ooooooooooooooooo000000[ooooo00?o0000ooooooooool0;?ooool002Oooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo02go
oooo000Wooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo02Cooooo0_l0000Aooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02oooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo02gooooo
000Xooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooool000002_ooool00ol0003ooooooooo
o`0^ooooo`00:Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`;o00002_ooool00ol0003oooooooooo`0_
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0<?ooool002[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo02?ooooo0_l0000Mooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`07ooooo`;o00002_ooool00ol0003oooooooooo`0`ooooo`00
:oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Wooooo00?o0000ooooooooool0
<Oooool002cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000008ooooo`03o`000?oo
oooooooo03;ooooo000/ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00002?oo
ool00ol0003oooooooooo`0booooo`00;Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0cooooo`00;_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0@
ooooo`;o00008_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0dooooo`00;oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool02Oooool2o`0000Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0eooooo`00;oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0<?ooool2o`0000gooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0eooooo`00<?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool01oooool00ol0003oooooo`000004ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0=_ooool0037ooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000>Oooool003;ooooo1Ol000000ooVi^Ko0000ooooo`0hooooo`03
o`000?oVi^Ko000000?o00000_ooool00ol0003oooooooooo`0Zooooo`Go000000?oi^KVo`000?oo
ool01?ooool5o`000003onKVi_l0003ooooo03Wooooo000booooo`Coi^KV0_l000000ooVi^Kooooo
ooooo`0gooooo`Goi^KV0ol0000]ooooo`Coi^KV0_l000000ooVi^Koooooooooo`03ooooo`Coi^KV
0_l000000ooVi^Koooooooooo`0hooooo`007?ooool5o`0000Oooooo1?l00005ooooo`;oi^KV1Ol0
0002onKViR7ooooo1_l0000@ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Qooooo`Co00001Ooo
ool2onKViPGo00000_oVi^H3ooooo`;oi^KV1Ol00002onKViSWooooo000Kooooo`;o000000?ooooo
o`000?l000001oooool2o`0000Oooooo0_oVi^H2o`0000;oi^KV0_l00003onKViR7ooooo0_l00000
0ooooooo0000o`00000?ooooo`?oi^KV0_l00002onKViP;o00000_oVi^HQooooo`;o00000_ooool2
o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2
o`0000?oi^KV>?ooool001cooooo1?l00007ooooo`Ko00000oooool2onKViP;o00000_oVi^H2o`00
00?oi^KV8_ooool2o`00017ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViRGooooo0_l00003oooo
o`;oi^KV0_l00002onKViP;o00000ooVi^H00oooooooi^KVonKViP02o`0000;oi^KV0_l00003onKV
iSSooooo000Kooooo`;o000000?oooooo`000?l000001oooool2o`0000;ooooo0_l00003ooooo`;o
i^KV0_l00002onKViP;o00000ooVi^HSooooo`;o00004?ooool3onKViP;o00000_oVi^H2o`0000;o
i^KV9Oooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o
00000_oVi^H2o`0000?oi^KV>?ooool001cooooo0ol00009ooooo`Co00001?ooool3onKViPKo0000
0_oVi^HPooooo`;o00000_ooool2o`0000oooooo1?oVi^H6o`000003onKVi_oooooooooo01oooooo
1Ol00004ooooo`?oi^KV1_l00002onKViP04oooooooVi^Koi^KVonKViPKo00000_oVi^Hhooooo`00
<?ooool;onKViR3ooooo0_l00002ooooo`;o00003oooool;onKViR7ooooo0_l00007ooooo`_oi^KV
00?oooooonKVi_oVi^H02OoVi^Hhooooo`00<Oooool9onKViR;ooooo1?l0000Aooooo`Woi^KV8_oo
ool6o`0000Cooooo2OoVi^H3ooooo`Woi^KV>Oooool003;ooooo1ooVi^Hiooooo`Ooi^KV;_ooool7
onKViPGooooo1ooVi^Hjooooo`00<oooool5onKViS_ooooo1OoVi^HYooooo`03o`000?oooooooooo
00Cooooo1OoVi^H7ooooo`Goi^KV>oooool0027ooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0nooooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03kooooo
000Rooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0?oooool002;ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02kooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0oooooo`008oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo043ooooo000Sooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0<?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0@?ooool002?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo033ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`10ooooo`009?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo047ooooo000Tooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0booooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0@Oooool002Gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`12ooooo`009Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;o
oooo000Vooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0=Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool0@oooool002Kooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooooooo03Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0eoooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`13ooooo`009_ooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo03Kooooo00Co0000oooooooooooo00000oooool00ol0003ooooooooo
o`13ooooo`009oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0gooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0A?ooool002Oooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo04Cooooo000Wooooo`Goi^KV00?o0000ooooooooool0
>Oooool5onKViS_ooooo1OoVi^I7ooooo`009_ooool2onKViPCo000000?oi^KVooooooooool0>?oo
ool7onKViSWooooo1ooVi^I6ooooo`009Oooool6onKViP;o000000?oi^KVooooooooool0=_ooool9
onKViSOooooo2OoVi^I5ooooo`002Oooool4o`0001Oooooo1?oVi^H5o`0000;oi^KV6Oooool4o`00
01Wooooo0_oVi^H7o`0000;oi^KV5oooool6o`0001Sooooo0_oVi^H7o`0000;oi^KVA?ooool000[o
oooo0_l0000Hooooo`?oi^KV0_l00002onKViP;o00000_oVi^HHooooo`;o00000_ooool2o`0001So
oooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV6?ooool2o`000003ooooool0003o000001So
oooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KVA?ooool000Oooooo1_l0000Gooooo`?oi^KV
0_l00002onKViP;o00000_oVi^HHooooo`;o00007?ooool3onKViP;o000000?oi^KVo`000?l00000
0ooVi^HIooooo`;o00006_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`001ooo
ool2o`000003ooooool0003o000001Sooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQSooooo0_l0
0002ooooo`;o00006?ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^HJooooo`;o00006Ooo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`002?ooool4o`0000?ooooo0ol0000B
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0Gooooo`Co00006Oooool3onKViPCo00001?oVi^HG
ooooo`;o00000_ooool2o`0001Kooooo0_l00003onKViPCo00001?oVi^I4ooooo`002Oooool3o`00
00Kooooo0ol0000@ooooo`Woi^KV00?oooooo`000?l00000=Oooool2onKViP;o00001OoVi^HEoooo
o`;o000000?oooooo`000?l000000_ooool2o`0001?ooooo0ol00003ooooo`;oi^KV0_l00005onKV
iTGooooo000:ooooo`;o00002Oooool3o`0000kooooo1ooVi^H4ooooo`;o0000=?ooool3o`0000Co
i^KV5?ooool2o`0000Cooooo1?l0000Aooooo`?o00001oooool3o`0000Coi^KVA_ooool001Sooooo
0ol0000<ooooo`Goi^KV1oooool2o`0001Sooooo00?o0000ooooooooool05oooool00ol0003oi^KV
onKViP03onKViQ?ooooo0_l0000Hooooo`?o00002oooool5onKViTOooooo000Kooooo`?o00005ooo
ool2o`0001Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Dooooo`;o00005ooo
ool3o`0005[ooooo000Nooooo`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`?o0000GOooool0
027ooooo0ol0000Dooooo`;o00005?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01;ooooo0_l0000Dooooo`?o0000H?ooool002Cooooo0ol0000Cooooo`;o00004oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo017ooooo0_l0000Cooooo`?o0000Hoooool002Oooooo
0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
0_l0000Booooo`?o0000I_ooool002[ooooo0ol0000Aooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo0ol0
001Yooooo`00;Oooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03_ooool2o`0000oooooo0ol0001/ooooo`00<?ooool3o`0000kooooo0_l0000>oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001_oooo
o`00<oooool3o`0000gooooo0_l0000=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool02oooool2o`0000gooooo0ol0001booooo`00=_ooool3o`0000cooooo0_l0000<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02_ooool2o`0000cooooo0ol0001eooooo`00>Ooo
ool3o`0000_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool3o`0007Sooooo000looooo`?o00002Oooool2
o`0000[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`;o00002Oooool3
o`0007_ooooo000oooooo`?o00002?ooool2o`0000Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`06ooooo`;o00002?ooool3o`0007kooooo0012ooooo`?o00001oooool2o`0000Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00001oooool3o`00087o
oooo0015ooooo`?o00001_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`?o0000Q?ooool004Sooooo0ol0
0004ooooo`;o00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo0_l0
0004ooooo`?o0000Qoooool004_ooooo0ol00003ooooo`;o00001?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`?o0000R_ooool004kooooo0ol00002oooo
o`;o00000_ooool00ol0003oi^KVonKViP03onKViP03o`000?oooooooooo00;o00000_ooool3o`00
08gooooo001Aooooo`?o000000?oooooo`000?l000001ooVi^H2o`000004ooooool0003o0000o`00
093ooooo001Dooooo`;o000000?oi^KVo`000?l000001?l00002onKViP;o0000Toooool005Gooooo
1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2
o`0000Goi^KVU?ooool005Gooooo0ooVi^H5o`0000?oi^KVU?ooool005Gooooo1?oVi^H2o`0000Go
i^KVU?ooool005Kooooo1?oVi^H3o`0000;oi^KVUOooool005Oooooo1ooVi^JFooooo`00F?ooool5
onKViYOooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.36714 0.171665 0.603319 0.588604 [
[.02381 .4856 -5 -6 ]
[.02381 .4856 5 6 ]
[.11133 .36788 -5 -6 ]
[.11133 .36788 5 6 ]
[.16114 .36788 -5 -6 ]
[.16114 .36788 5 6 ]
[.12422 .25016 -5 -6 ]
[.12422 .25016 5 6 ]
[.21096 .25016 -5 -6 ]
[.21096 .25016 5 6 ]
[.29769 .25016 -5 -6 ]
[.29769 .25016 5 6 ]
[.21096 .36788 -5 -6 ]
[.21096 .36788 5 6 ]
[.16114 .4856 -5 -6 ]
[.16114 .4856 5 6 ]
[.29847 .4856 -5 -6 ]
[.29847 .4856 5 6 ]
[.38599 .36788 -5 -6 ]
[.38599 .36788 5 6 ]
[.35552 .25016 -5 -6 ]
[.35552 .25016 5 6 ]
[.61572 .25016 -5 -6 ]
[.61572 .25016 5 6 ]
[.48562 .36788 -5 -6 ]
[.48562 .36788 5 6 ]
[.43581 .4856 -5 -6 ]
[.43581 .4856 5 6 ]
[.57314 .4856 -5 -6 ]
[.57314 .4856 5 6 ]
[.66066 .36788 -5 -6 ]
[.66066 .36788 5 6 ]
[.62374 .25016 -5 -6 ]
[.62374 .25016 5 6 ]
[.68395 .13244 -5 -6 ]
[.68395 .13244 5 6 ]
[.73147 .01472 -5 -6 ]
[.73147 .01472 5 6 ]
[.86293 .01472 -5 -6 ]
[.86293 .01472 5 6 ]
[.7972 .13244 -5 -6 ]
[.7972 .13244 5 6 ]
[.84473 .01472 -5 -6 ]
[.84473 .01472 5 6 ]
[.91046 .01472 -5 -6 ]
[.91046 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.91046 .13244 -5 -6 ]
[.91046 .13244 5 6 ]
[.7972 .25016 -5 -6 ]
[.7972 .25016 5 6 ]
[.71047 .36788 -5 -6 ]
[.71047 .36788 5 6 ]
[.67355 .25016 -5 -6 ]
[.67355 .25016 5 6 ]
[.76029 .25016 -5 -6 ]
[.76029 .25016 5 6 ]
[.84702 .25016 -5 -6 ]
[.84702 .25016 5 6 ]
[.76029 .36788 -5 -6 ]
[.76029 .36788 5 6 ]
[.71047 .4856 -5 -6 ]
[.71047 .4856 5 6 ]
[.36714 .60332 -5 -6 ]
[.36714 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.36714 .60332 m
.02381 .4856 L
s
.36714 .60332 m
.16114 .4856 L
s
.36714 .60332 m
.29847 .4856 L
s
.36714 .60332 m
.43581 .4856 L
s
.36714 .60332 m
.57314 .4856 L
s
.36714 .60332 m
.71047 .4856 L
s
1 g
.05 w
.02381 .4856 Mdot
0 g
gsave
.02381 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.16114 .4856 m
.11133 .36788 L
s
.16114 .4856 m
.16114 .36788 L
s
.16114 .4856 m
.21096 .36788 L
s
1 g
.05 w
.11133 .36788 Mdot
0 g
gsave
.11133 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.16114 .36788 Mdot
0 g
gsave
.16114 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
.5 Mabswid
.21096 .36788 m
.12422 .25016 L
s
.21096 .36788 m
.21096 .25016 L
s
.21096 .36788 m
.29769 .25016 L
s
1 g
.05 w
.12422 .25016 Mdot
0 g
gsave
.12422 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.21096 .25016 Mdot
0 g
gsave
.21096 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.29769 .25016 Mdot
0 g
gsave
.29769 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.9 g
.21096 .36788 Mdot
0 g
gsave
.21096 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.16114 .4856 Mdot
0 g
gsave
.16114 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29847 .4856 Mdot
0 g
gsave
.29847 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.5 Mabswid
.43581 .4856 m
.38599 .36788 L
s
.43581 .4856 m
.48562 .36788 L
s
1 g
.05 w
.38599 .36788 Mdot
0 g
gsave
.38599 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.48562 .36788 m
.35552 .25016 L
s
.48562 .36788 m
.61572 .25016 L
s
1 g
.05 w
.35552 .25016 Mdot
0 g
gsave
.35552 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.61572 .25016 Mdot
0 g
gsave
.61572 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
.9 g
.48562 .36788 Mdot
0 g
gsave
.48562 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.43581 .4856 Mdot
0 g
gsave
.43581 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.57314 .4856 Mdot
0 g
gsave
.57314 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .4856 m
.66066 .36788 L
s
.71047 .4856 m
.71047 .36788 L
s
.71047 .4856 m
.76029 .36788 L
s
1 g
.05 w
.66066 .36788 Mdot
0 g
gsave
.66066 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.71047 .36788 m
.62374 .25016 L
s
.71047 .36788 m
.7972 .25016 L
s
1 g
.05 w
.62374 .25016 Mdot
0 g
gsave
.62374 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .25016 m
.68395 .13244 L
s
.7972 .25016 m
.7972 .13244 L
s
.7972 .25016 m
.91046 .13244 L
s
1 g
.05 w
.68395 .13244 Mdot
0 g
gsave
.68395 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 Mabswid
.7972 .13244 m
.73147 .01472 L
s
.7972 .13244 m
.86293 .01472 L
s
1 g
.05 w
.73147 .01472 Mdot
0 g
gsave
.73147 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
1.000 setlinewidth
grestore
1 g
.86293 .01472 Mdot
0 g
gsave
.86293 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.9 g
.7972 .13244 Mdot
0 g
gsave
.7972 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.91046 .13244 m
.84473 .01472 L
s
.91046 .13244 m
.91046 .01472 L
s
.91046 .13244 m
.97619 .01472 L
s
1 g
.05 w
.84473 .01472 Mdot
0 g
gsave
.84473 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
1.000 setlinewidth
grestore
1 g
.91046 .01472 Mdot
0 g
gsave
.91046 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
.9 g
.91046 .13244 Mdot
0 g
gsave
.91046 .13244 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7972 .25016 Mdot
0 g
gsave
.7972 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.71047 .36788 Mdot
0 g
gsave
.71047 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.76029 .36788 m
.67355 .25016 L
s
.76029 .36788 m
.76029 .25016 L
s
.76029 .36788 m
.84702 .25016 L
s
1 g
.05 w
.67355 .25016 Mdot
0 g
gsave
.67355 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
1.000 setlinewidth
grestore
1 g
.76029 .25016 Mdot
0 g
gsave
.76029 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(e) show
1.000 setlinewidth
grestore
1 g
.84702 .25016 Mdot
0 g
gsave
.84702 .25016 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.9 g
.76029 .36788 Mdot
0 g
gsave
.76029 .36788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.71047 .4856 Mdot
0 g
gsave
.71047 .4856 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.36714 .60332 Mdot
0 g
gsave
.36714 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool00:cooooo1Ol0000Gooooo`Go00000_ooool00ol0003ooooooooo
o`05ooooo`Go00002_ooool4o`0000[ooooo002]ooooo`;o000000?oooooo`000?l000005Oooool2
o`000003ooooool0003o000000?ooooo0_l00005ooooo`;o000000?oooooo`000?l000002_ooool2
o`0000;ooooo0_l00009ooooo`00[Oooool2o`000003ooooool0003o000001Kooooo1?l00003oooo
o`;o00001Oooool2o`000003ooooool0003o000000[ooooo0_l0000=ooooo`00[Oooool2o`000003
ooooool0003o000001Gooooo0_l000000ooooooo0000o`000003ooooo`;o00001Oooool2o`000003
ooooool0003o000000[ooooo0_l00002ooooo`;o00002Oooool00:gooooo1?l0000Gooooo`?o0000
1?ooool00ol0003oooooooooo`05ooooo`Co00002oooool4o`0000[ooooo002]ooooo`;o0000:_oo
ool2o`0001Wooooo002/ooooo`?o00007_ooool4o`0000Oooooo0ol0000Iooooo`00/_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool03?ooool00;;o
oooo00?o0000ooooooooool05_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool00;?ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`00
/oooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000002_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00gooooo002dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03_ooool00;Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0>ooooo`00]Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oooooo002foooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03oooool00;Kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`00]oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo017ooooo002hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Ooo
ool00;Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Booooo`00^Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01;ooooo002iooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00;[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Cooooo`00^oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01Cooooo002kooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool05?ooool00;cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Aooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05Oooool00;cooooo00?o
i^KVo`000?l000000ol0000Eooooo`Co000000?oi^KVooooooooool05_ooool00;_ooooo1OoVi^H2
o`0001Cooooo1?oVi^H2o`000003onKVi_oooooooooo01Gooooo002Rooooo`Co00005?ooool3onKV
iPGo000000?oi^KVooooooooool04?ooool2onKViPGo00000_oVi^HFooooo`00XOooool2o`0000;o
oooo0_l0000Booooo`?oi^KV0_l00002onKViP;o00000_oVi^H@ooooo`;oi^KV0_l00002onKViP;o
00000ooVi^HEooooo`00YOooool2o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQ3ooooo
0_oVi^H2o`0000;oi^KV0_l00003onKViQGooooo002Uooooo`;o00004_ooool3onKViP;o00000_oV
i^H2o`0000;oi^KV4?ooool2onKViP;o00000_oVi^H2o`0000?oi^KV5Oooool00:7ooooo1Ol0000C
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0>ooooo`?oi^KV1_l00002onKViQGooooo002Qoooo
o`;o00005_ooool;onKViQ3ooooo2ooVi^HEooooo`00XOooool6o`0001?ooooo2OoVi^HBooooo`Wo
i^KV5_ooool00:Sooooo00?o0000ooooooooool04?ooool7onKViQ?ooooo00?o0000onKVi_oVi^H0
1OoVi^HGooooo`00ZOooool00ol0003oooooooooo`0@ooooo`Goi^KV4oooool00ol0003ooooooooo
o`05onKViQSooooo002Zooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Nooooo`00Zoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool07oooool00:cooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo023ooooo002]ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0Qooooo`00[_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool08_ooool00:oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo02?ooooo002`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Toooo
o`00/Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool09Oooool00;;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo02Gooooo002cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Vooooo`00]?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool09oooool00;Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo02Sooooo002fooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Yooooo`00]oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool00;Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02_ooooo002i
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/
ooooo`00^_ooool00ol0003oooooonKViP04onKViP?ooooo00?o0000ooooooooool0;Oooool00;_o
oooo1ooVi^H00ooooooo0000ooooo`0_ooooo`00^oooool8onKViS7ooooo000Oooooo`Go00004?oo
ool4o`00017ooooo1?l00007ooooo`Go0000>oooool5o`0000Oooooo1?l0000@ooooo`Co00001?oo
ool7o`000003onKVi_oooooooooo00;ooooo1Ol0000Wooooo`007_ooool2o`000003ooooool0003o
000001;ooooo0_l0000Cooooo`;o00002Oooool2o`000003ooooool0003o000003Wooooo0_l00000
0ooooooo0000o`000007ooooo`;o00000_ooool2o`0000kooooo0_l00007ooooo`04onKVi_l0003o
0000onKViP;o00000_oVi^H3ooooo`;o000000?oooooo`000?l00000:?ooool001oooooo1?l0000?
ooooo`Ko00003oooool6o`0000Sooooo0_l000000ooooooo0000o`00000jooooo`Co00001oooool2
o`0001;ooooo1_l00003ooooo`04onKVi_l0003o0000onKViP;o00000_oVi^H3ooooo`;o000000?o
ooooo`000?l00000:?ooool001kooooo0_l000000ooooooo0000o`00000?ooooo`;o000000?ooooo
o`000?l000004?ooool2o`000003ooooool0003o000000Wooooo0_l000000ooooooo0000o`00000i
ooooo`;o000000?oooooo`000?l000001oooool2o`0000;ooooo0_l0000>ooooo`;o00000_ooool2
o`0000?ooooo00Coi^KVo`000?l0003oi^KV0_l00002onKViP?ooooo0_l000000ooooooo0000o`00
000Xooooo`007oooool3o`00017ooooo1?l0000Aooooo`Co00002Oooool4o`0003_ooooo0ol00009
ooooo`Co00004?ooool4o`0000Cooooo00?oi^KVo`000?l000000_l00003onKViPCooooo1?l0000X
ooooo`00=?ooool3o`0001;ooooo0ol00009ooooo`;o0000I?ooool2onKViP;o00001?oVi^H7oooo
o`;o0000:?ooool003Gooooo0_l0000Cooooo`;o00002?ooool3o`0000Gooooo00?o0000oooooooo
ool0<?ooool01?l0003oooooo`000?l0000Booooo`03o`000?oooooooooo01?ooooo00Coi^KVo`00
0?l0003o00000ooVi^H7ooooo`?o0000:?ooool002Cooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo01?ooooo00?o0000onKVi_oVi^H00ooVi^H6oooo
o`03o`000?oooooooooo02[ooooo000Uooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo02cooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02_ooooo000Vooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Gooooo`;o0000
:oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
3?ooool01Ol0003ooooooooooooooooo000000[ooooo00?o0000ooooooooool0;?ooool002Oooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo02go
oooo000Wooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo02Cooooo0_l0000Aooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02oooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo02gooooo
000Xooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooool000002_ooool00ol0003ooooooooo
o`0^ooooo`00:Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`;o00002_ooool00ol0003oooooooooo`0_
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0<?ooool002[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo02?ooooo0_l0000Mooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`07ooooo`;o00002_ooool00ol0003oooooooooo`0`ooooo`00
:oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Wooooo00?o0000ooooooooool0
<Oooool002cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000008ooooo`03o`000?oo
oooooooo03;ooooo000/ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00002?oo
ool00ol0003oooooooooo`0booooo`00;Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0cooooo`00;_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0@
ooooo`;o00008_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0dooooo`00;oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool02Oooool2o`0000Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0eooooo`00;oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0<?ooool2o`0000gooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0eooooo`00<?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool01oooool00ol0003oooooo`000004ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0=_ooool0037ooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000>Oooool003;ooooo1Ol000000ooVi^Ko0000ooooo`0hooooo`03
o`000?oVi^Ko000000?o00000_ooool00ol0003oooooooooo`0Zooooo`Go000000?oi^KVo`000?oo
ool01?ooool5o`000003onKVi_l0003ooooo03Wooooo000booooo`Coi^KV0_l000000ooVi^Kooooo
ooooo`0gooooo`Goi^KV0ol0000]ooooo`Coi^KV0_l000000ooVi^Koooooooooo`03ooooo`Coi^KV
0_l000000ooVi^Koooooooooo`0hooooo`007?ooool5o`0000Oooooo1?l00005ooooo`;oi^KV1Ol0
0002onKViR7ooooo1_l0000@ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Qooooo`Co00001Ooo
ool2onKViPGo00000_oVi^H3ooooo`;oi^KV1Ol00002onKViSWooooo000Kooooo`;o000000?ooooo
o`000?l000001oooool2o`0000Oooooo0_oVi^H2o`0000;oi^KV0_l00003onKViR7ooooo0_l00000
0ooooooo0000o`00000?ooooo`?oi^KV0_l00002onKViP;o00000_oVi^HQooooo`;o00000_ooool2
o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o00000_oVi^H2
o`0000?oi^KV>?ooool001cooooo1?l00007ooooo`Ko00000oooool2onKViP;o00000_oVi^H2o`00
00?oi^KV8_ooool2o`00017ooooo0ooVi^H2o`0000;oi^KV0_l00002onKViRGooooo0_l00003oooo
o`;oi^KV0_l00002onKViP;o00000ooVi^H00oooooooi^KVonKViP02o`0000;oi^KV0_l00003onKV
iSSooooo000Kooooo`;o000000?oooooo`000?l000001oooool2o`0000;ooooo0_l00003ooooo`;o
i^KV0_l00002onKViP;o00000ooVi^HSooooo`;o00004?ooool3onKViP;o00000_oVi^H2o`0000;o
i^KV9Oooool2o`0000?ooooo0_oVi^H2o`0000;oi^KV0_l00003onKViP03oooooooVi^Koi^KV00;o
00000_oVi^H2o`0000?oi^KV>?ooool001cooooo0ol00009ooooo`Co00001?ooool3onKViPKo0000
0_oVi^HPooooo`;o00000_ooool2o`0000oooooo1?oVi^H6o`000003onKVi_oooooooooo01oooooo
1Ol00004ooooo`?oi^KV1_l00002onKViP04oooooooVi^Koi^KVonKViPKo00000_oVi^Hhooooo`00
<?ooool;onKViR3ooooo0_l00002ooooo`;o00003oooool;onKViR7ooooo0_l00007ooooo`_oi^KV
00?oooooonKVi_oVi^H02OoVi^Hhooooo`00<Oooool9onKViR;ooooo1?l0000Aooooo`Woi^KV8_oo
ool6o`0000Cooooo2OoVi^H3ooooo`Woi^KV>Oooool003;ooooo1ooVi^Hiooooo`Ooi^KV;_ooool7
onKViPGooooo1ooVi^Hjooooo`00<oooool5onKViS_ooooo1OoVi^HYooooo`03o`000?oooooooooo
00Cooooo1OoVi^H7ooooo`Goi^KV>oooool0027ooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0nooooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo02cooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03kooooo
000Rooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0?oooool002;ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02kooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0oooooo`008oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo043ooooo000Sooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0<?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0@?ooool002?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo033ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`10ooooo`009?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo047ooooo000Tooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0booooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0@Oooool002Gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`12ooooo`009Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;o
oooo000Vooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0=Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool0@oooool002Kooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooooooo03Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0eoooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`13ooooo`009_ooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo03Kooooo00Co0000oooooooooooo00000oooool00ol0003ooooooooo
o`13ooooo`009oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo03Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0gooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0A?ooool002Oooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0=oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo04Cooooo000Wooooo`Goi^KV00?o0000ooooooooool0
>Oooool5onKViS_ooooo1OoVi^I7ooooo`009_ooool2onKViPCo000000?oi^KVooooooooool0>?oo
ool7onKViSWooooo1ooVi^I6ooooo`009Oooool6onKViP;o000000?oi^KVooooooooool0=_ooool9
onKViSOooooo2OoVi^I5ooooo`002Oooool4o`0001Oooooo1?oVi^H5o`0000;oi^KV6Oooool4o`00
01Wooooo0_oVi^H7o`0000;oi^KV5oooool6o`0001Sooooo0_oVi^H7o`0000;oi^KVA?ooool000[o
oooo0_l0000Hooooo`?oi^KV0_l00002onKViP;o00000_oVi^HHooooo`;o00000_ooool2o`0001So
oooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KV6?ooool2o`000003ooooool0003o000001So
oooo0ooVi^H2o`000003onKVi_l0003o000000?oi^KVA?ooool000Oooooo1_l0000Gooooo`?oi^KV
0_l00002onKViP;o00000_oVi^HHooooo`;o00007?ooool3onKViP;o000000?oi^KVo`000?l00000
0ooVi^HIooooo`;o00006_ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`001ooo
ool2o`000003ooooool0003o000001Sooooo0ooVi^H2o`0000;oi^KV0_l00002onKViQSooooo0_l0
0002ooooo`;o00006?ooool3onKViP;o000000?oi^KVo`000?l000000ooVi^HJooooo`;o00006Ooo
ool3onKViP;o000000?oi^KVo`000?l000000ooVi^I4ooooo`002?ooool4o`0000?ooooo0ol0000B
ooooo`Coi^KV1_l000000ooVi^Koooooooooo`0Gooooo`Co00006Oooool3onKViPCo00001?oVi^HG
ooooo`;o00000_ooool2o`0001Kooooo0_l00003onKViPCo00001?oVi^I4ooooo`002Oooool3o`00
00Kooooo0ol0000@ooooo`Woi^KV00?oooooo`000?l00000=Oooool2onKViP;o00001OoVi^HEoooo
o`;o000000?oooooo`000?l000000_ooool2o`0001?ooooo0ol00003ooooo`;oi^KV0_l00005onKV
iTGooooo000:ooooo`;o00002Oooool3o`0000kooooo1ooVi^H4ooooo`;o0000=?ooool3o`0000Co
i^KV5?ooool2o`0000Cooooo1?l0000Aooooo`?o00001oooool3o`0000Coi^KVA_ooool001Sooooo
0ol0000<ooooo`Goi^KV1oooool2o`0001Sooooo00?o0000ooooooooool05oooool00ol0003oi^KV
onKViP03onKViQ?ooooo0_l0000Hooooo`?o00002oooool5onKViTOooooo000Kooooo`?o00005ooo
ool2o`0001Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Dooooo`;o00005ooo
ool3o`0005[ooooo000Nooooo`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`?o0000GOooool0
027ooooo0ol0000Dooooo`;o00005?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01;ooooo0_l0000Dooooo`?o0000H?ooool002Cooooo0ol0000Cooooo`;o00004oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo017ooooo0_l0000Cooooo`?o0000Hoooool002Oooooo
0ol0000Booooo`;o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
0_l0000Booooo`?o0000I_ooool002[ooooo0ol0000Aooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo0ol0
001Yooooo`00;Oooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03_ooool2o`0000oooooo0ol0001/ooooo`00<?ooool3o`0000kooooo0_l0000>oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001_oooo
o`00<oooool3o`0000gooooo0_l0000=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool02oooool2o`0000gooooo0ol0001booooo`00=_ooool3o`0000cooooo0_l0000<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02_ooool2o`0000cooooo0ol0001eooooo`00>Ooo
ool3o`0000_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool3o`0007Sooooo000looooo`?o00002Oooool2
o`0000[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`;o00002Oooool3
o`0007_ooooo000oooooo`?o00002?ooool2o`0000Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`06ooooo`;o00002?ooool3o`0007kooooo0012ooooo`?o00001oooool2o`0000Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00001oooool3o`00087o
oooo0015ooooo`?o00001_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`?o0000Q?ooool004Sooooo0ol0
0004ooooo`;o00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo0_l0
0004ooooo`?o0000Qoooool004_ooooo0ol00003ooooo`;o00001?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`?o0000R_ooool004kooooo0ol00002oooo
o`;o00000_ooool00ol0003oi^KVonKViP03onKViP03o`000?oooooooooo00;o00000_ooool3o`00
08gooooo001Aooooo`?o000000?oooooo`000?l000001ooVi^H2o`000004ooooool0003o0000o`00
093ooooo001Dooooo`;o000000?oi^KVo`000?l000001?l00002onKViP;o0000Toooool005Gooooo
1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2o`0000Goi^KVU?ooool005Gooooo1?oVi^H2
o`0000Goi^KVU?ooool005Gooooo0ooVi^H5o`0000?oi^KVU?ooool005Gooooo1?oVi^H2o`0000Go
i^KVU?ooool005Kooooo1?oVi^H3o`0000;oi^KVUOooool005Oooooo1ooVi^JFooooo`00F?ooool5
onKViYOooooo0000\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.25037, -1.04355, \
0.0248915, 0.00725955}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Duplication - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.20018 .30902 -5 -6 ]
[.20018 .30902 5 6 ]
[.20018 .16187 -5 -6 ]
[.20018 .16187 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.52939 .30902 -5 -6 ]
[.52939 .30902 5 6 ]
[.57643 .30902 -5 -6 ]
[.57643 .30902 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.27072 .01472 -5.0625 -6 ]
[.27072 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.62346 .16187 -5 -6 ]
[.62346 .16187 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
gsave
.20018 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20018 .16187 Mdot
0 g
gsave
.20018 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52939 .30902 Mdot
0 g
gsave
.52939 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.57643 .30902 Mdot
0 g
gsave
.57643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
gsave
.27072 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.62346 .16187 Mdot
0 g
gsave
.62346 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{419.812, 259.438},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006S00010b000`400?l00000o`00003ooooooonT
ooooo`00oooooonTooooo`00oooooonTooooo`00oooooonTooooo`00oooooonTooooo`00oooooonT
ooooo`00oooooonTooooo`00oooooonTooooo`00LOooool7o`000?oooooo6?ooool5o`0000oooooo
001aooooo`;o00000_ooool2o`000?oooooo6_ooool2o`000003ooooool0003o000000kooooo001a
ooooo`Ko0000oooooolJooooo`;o000000?oooooo`000?l000003_ooool007;ooooo1?l0003ooooo
oa_ooooo1?l0000?ooooo`00L_ooool4o`000?oooooo6oooool2o`000003ooooool0003o000000ko
oooo001cooooo`;o0000oooooolLooooo`;o000000?oooooo`000?l000003_ooool007;ooooo0ol0
0009ooooo`;o0000ooooool8ooooo`;o00001_ooool5o`0000oooooo0020ooooo`;o0000ooooool4
ooooo`;o00007?ooool008;ooooo0_l0003oooooo`;o00007_ooool008Cooooo0ol0003iooooo`?o
00008?ooool008Oooooo0_l0003eooooo`;o00008oooool008Wooooo0ol0003_ooooo`?o00009Ooo
ool008cooooo0_l0003[ooooo`;o0000:?ooool008kooooo0_l0003Wooooo`;o0000:_ooool0093o
oooo0ol0003Qooooo`?o0000;?ooool009?ooooo0_l0003Mooooo`;o0000;oooool009Gooooo0ol0
003Gooooo`?o0000<Oooool009Sooooo0_l0003Cooooo`;o0000=?ooool009[ooooo0_l0003?oooo
o`;o0000=_ooool009cooooo0ol00039ooooo`?o0000>?ooool009oooooo0_l00035ooooo`;o0000
>oooool00:7ooooo0_l00031ooooo`;o0000?Oooool00:?ooooo0ol0002kooooo`?o0000?oooool0
0:Kooooo0_l0002gooooo`;o0000@_ooool00:Sooooo0ol0002aooooo`?o0000A?ooool00:_ooooo
0_l0002]ooooo`;o0000Aoooool00:gooooo0_l0002Yooooo`;o0000BOooool00:oooooo0ol0002S
ooooo`?o0000Boooool00;;ooooo0_l0002Oooooo`;o0000C_ooool00;Cooooo0ol0002Iooooo`?o
0000D?ooool00;Oooooo0_l0002Eooooo`;o0000Doooool00;Wooooo0_l0002Aooooo`;o0000EOoo
ool00;_ooooo0ol0002;ooooo`?o0000Eoooool00;kooooo0_l00027ooooo`;o0000F_ooool00<3o
oooo0_l00023ooooo`;o0000G?ooool00<;ooooo0ol0001mooooo`?o0000G_ooool00<Gooooo0_l0
001iooooo`;o0000HOooool00<Oooooo0ol0001cooooo`?o0000Hoooool00<[ooooo0_l0001_oooo
o`;o0000I_ooool00<cooooo0_l0001[ooooo`;o0000J?ooool00<kooooo0ol0001Uooooo`?o0000
J_ooool00=7ooooo0_l0001Qooooo`;o0000KOooool00=?ooooo0ol0001Kooooo`?o0000Koooool0
0=Kooooo0_l0001Gooooo`;o0000L_ooool00=Sooooo0_l0001Cooooo`;o0000M?ooool00=[ooooo
0ol0001=ooooo`?o0000M_ooool00=gooooo0_l00019ooooo`;o0000NOooool00=oooooo0_l00015
ooooo`;o0000Noooool00>7ooooo0ol0000oooooo`?o0000OOooool00>Cooooo0_l0000kooooo`;o
0000P?ooool00>Kooooo0ol0000eooooo`?o0000P_ooool00>Wooooo0_l0000aooooo`;o0000QOoo
ool00>_ooooo0_l0000Cooooo`Koi^KV5?ooool2o`0008Oooooo003]ooooo`?o00003_ooool:onKV
iPoooooo0ol00029ooooo`00l?ooool2o`0000[ooooo3_oVi^H;ooooo`;o0000S?ooool00?;ooooo
0ol00006oooooa3oi^KV1oooool3o`0008kooooo003eooooo`;o00001?ooool@onKViPGooooo0_l0
002Aooooo`00moooool2o`000003oooooooVi^Koi^KV013oi^KV0_ooool2o`0009?ooooo003ioooo
o`03o`000?oVi^Koi^KV00Goi^KV1?l00007onKViP;o0000UOooool00?Wooooo2ooVi^H2o`0000Oo
i^KVU_ooool005Oooooo1?l0002Nooooo`Soi^KV1Ol00007onKViYKooooo001Hooooo`;o0000Wooo
ool7onKViP;o00000_oVi^H2o`0000Ooi^KVU_ooool005Gooooo1_l0002Nooooo`Ooi^KV0_l00002
onKViP;o00001ooVi^JFooooo`00EOooool2o`000003ooooool0003o000009oooooo1ooVi^H2o`00
00;oi^KV0_l00007onKViYKooooo001Fooooo`Co0000Woooool8onKViPKo00001_oVi^JFooooo`00
Eoooool3o`000:3ooooo4_oVi^JGooooo`00F?ooool2o`000:3ooooo4_oVi^JGooooo`00noooool@
onKViYSooooo003koooooa3oi^KVV?ooool00?cooooo3_oVi^JIooooo`00F?ooool00ol0003ooooo
ooooo`2Sooooo`[oi^KVVoooool005Sooooo00?o0000ooooooooool0YOooool6onKViYgooooo001H
ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000oooo
ooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xooooo`03
o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0
WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool0
0ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo
0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0003o
ooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09gooooo
001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000
ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xoooo
o`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000oooooooo
ool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?oo
ool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooo
oooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0
003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09go
oooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o
0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2X
ooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000oooo
ooooool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00
F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oo
oooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo
09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo
00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003ooooooooo
o`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000
ooooooooool0WOooool005Sooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Moooo
o`00F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`00
0?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005Sooooo00?o0000ooooooooool0Z?oo
ool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooo
oooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool0WOooool005So
oooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`2Mooooo`00F?ooool00ol0003ooooo
ooooo`2Xooooo`03o`000?oooooooooo09gooooo001Hooooo`03o`000?oooooooooo0:Sooooo00?o
0000ooooooooool0WOooool005Gooooo1_oVi^JUooooo`Koi^KVWOooool005?ooooo2_oVi^JQoooo
o`[oi^KVVoooool0057ooooo3_oVi^JMooooo`koi^KVVOooool0053ooooo4?oVi^JKoooooa3oi^KV
V?ooool0053ooooo4?oVi^JKoooooa3oi^KVV?ooool004oooooo1ooVi^H4o`0000Ooi^KVVOooool7
onKViPCo00001ooVi^JGooooo`00Coooool:onKViP;o00001_oVi^JIooooo`[oi^KV0_l00006onKV
iYOooooo000hooooo`Go00004Oooool8onKViPGo00001ooVi^H@ooooo`Co0000D_ooool4o`0000ko
oooo1Ol0000>ooooo`Go00001oooool8onKViPGo00001ooVi^JFooooo`00>Oooool2o`000003oooo
ool0003o0000013ooooo1ooVi^H2o`0000;oi^KV0_l00007onKViPoooooo0_l00002ooooo`;o0000
D?ooool00ol0003oooooo`00000Aooooo`;o000000?oooooo`000?l000003_ooool2o`000003oooo
ool0003o000000Kooooo1ooVi^H2o`0000;oi^KV0_l00007onKViYKooooo000iooooo`;o000000?o
ooooo`000?l000004?ooool7onKViP;o00000_oVi^H2o`0000Ooi^KV4oooool2o`00053ooooo00?o
0000ooooool000000_l0000?ooooo`;o000000?oooooo`000?l000003_ooool2o`000003ooooool0
003o000000Kooooo1ooVi^H2o`0000;oi^KV0_l00007onKViYKooooo000iooooo`Co00004Oooool7
onKViP;o00000_oVi^H2o`0000Ooi^KV4Oooool3o`00057ooooo00Go0000ooooool0003oooooo`00
000?ooooo`;o000000?oooooo`000?l000003_ooool4o`0000Oooooo1ooVi^H2o`0000;oi^KV0_l0
0007onKViYKooooo000iooooo`;o000000?oooooo`000?l000004?ooool8onKViPKo00001_oVi^HC
ooooo`;o0000DOooool3o`00013ooooo0_l000000ooooooo0000o`00000>ooooo`;o000000?ooooo
o`000?l000001_ooool8onKViPKo00001_oVi^JFooooo`00>Oooool2o`000003ooooool0003o0000
013ooooo5?oVi^H?ooooo`;o00000_ooool2o`0006Cooooo0_l000000ooooooo0000o`00000>oooo
o`;o000000?oooooo`000?l000001_oooolDonKViYKooooo000hooooo`Go00004_oooolBonKViQ7o
oooo1?l0001Tooooo`Go00003_ooool5o`0000Sooooo4_oVi^JGooooo`00CooooolBonKViYWooooo
4_oVi^JGooooo`00D?ooool@onKViY_ooooo4?oVi^JHooooo`00D?ooool@onKViY_ooooo4?oVi^JH
ooooo`00DOooool>onKViYgooooo3_oVi^JIooooo`00Doooool:onKViZ7ooooo2_oVi^JKooooo`00
@?ooool00ol0003oooooooooo`0Booooo`Koi^KV5Oooool00ol0003oooooooooo`1Kooooo`03o`00
0?oooooooooo02gooooo00?o0000oooooooVi^H01OoVi^JMooooo`00@?ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`2Rooooo`00@Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0GOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`2Sooooo`00@Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2Soooo
o`00@_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0Goooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`2Tooooo`00@_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Tooooo`00@_oo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0HOoo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`2Tooooo`00@oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Uooooo`00@oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Hoooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`2Uooooo`00A?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Vooooo`00A?ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0IOooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`2Vooooo`00AOooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0Ioooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`2Wooooo`00AOooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2W
ooooo`00A_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0JOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`2Xooooo`00A_ooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool0JOooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Xooooo`00
Aoooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
JOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`2Yooooo`00Aoooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Yooooo`00B?ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Joooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`2Zooooo`00B?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool0KOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Zooooo`00BOooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0KOooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`2[ooooo`00BOooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0Koooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`2[ooooo`00B_ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Koooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`2/ooooo`00B_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0LOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`2/ooooo`00Boooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0LOooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2]oooo
o`00Boooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0Loooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`2]ooooo`00C?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2^ooooo`00C?oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0MOoo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`2^ooooo`00COooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0MOooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2_ooooo`00COooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Moooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`2_ooooo`00C_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0Moooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2`ooooo`00C_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Moooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`2`ooooo`00Coooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0NOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`2aooooo`00Coooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2a
ooooo`00D?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0Noooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`2booooo`00D?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2booooo`00
DOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
OOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`00002eooooo`00DOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0OOooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00001?ooool00ol0003oooooooooo`2cooooo`00DOooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0Ooooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2cooooo`00D_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Ooooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00002fooooo`00D_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0POooool01?l0003o
ooooooooool00003ooooo`05o`000?ooooooooooooooool00000]_ooool005?ooooo00?o0000oooo
oooVi^H01OoVi^H2ooooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool01_oVi^H00ooo
oooo0000ooooo`2fooooo`00Doooool:onKViXGooooo2_oVi^Jgooooo`00DOooool>onKViX7ooooo
3_oVi^Jeooooo`00D?ooool@onKViWoooooo4?oVi^Jdooooo`00D?ooool@onKViWoooooo4?oVi^Jd
ooooo`00CooooolBonKViWgooooo4_oVi^Jcooooo`00Coooool7onKViPCo00001ooVi^Imoooooa;o
i^KV/oooool004kooooo2ooVi^H2o`0000Ooi^KVNooooolDonKVi[;ooooo000=ooooo`Oo0000>_oo
ool8onKViPGo00001ooVi^Hjooooo`Go0000??ooool6onKViPOo00001ooVi^Hjooooo`Ko0000L_oo
ool000gooooo0_l00002ooooo`;o0000>oooool7onKViP;o00000_oVi^H2o`0000Ooi^KV>oooool2
o`000003ooooool0003o000003_ooooo1ooVi^H2o`000003onKVi_l0003o000000Soi^KV>oooool2
o`000003ooooool0003o000007;ooooo000=ooooo`Ko0000>oooool7onKViP;o00000_oVi^H2o`00
00Ooi^KV>oooool2o`000003ooooool0003o000003_ooooo1ooVi^H2o`000003onKVi_l0003o0000
00Soi^KV??ooool2o`0007Cooooo000>ooooo`Co0000??ooool7onKViP;o00000_oVi^H2o`0000Oo
i^KV>oooool2o`000003ooooool0003o000003_ooooo1ooVi^H2o`000003onKVi_l0003o000000So
i^KV?Oooool2o`0007?ooooo000>ooooo`Co0000??ooool8onKViPKo00001_oVi^Hkooooo`;o0000
00?oooooo`000?l00000>oooool7onKViPCo00002OoVi^Hjooooo`;o00000_ooool2o`0007;ooooo
000?ooooo`;o0000?_oooolBonKViScooooo0_l000000ooooooo0000o`00000looooo`Koi^KV0_l0
000:onKViS_ooooo0_l00002ooooo`;o0000L_ooool000kooooo0ol00009ooooo`;o0000<ooooolB
onKViS_ooooo1Ol0000mooooo`Goi^KV0ol0000:onKViS?ooooo0_l00007ooooo`Co0000Loooool0
01cooooo0_l0000boooooa3oi^KVOoooool@onKViS;ooooo0_l00020ooooo`007_ooool3o`0002oo
oooo4?oVi^H00ol0003oooooooooo`1kooooo`03o`000?oVi^Koi^KV00koi^KV;oooool3o`0008;o
oooo000Qooooo`;o0000;_ooool>onKViP;ooooo00?o0000ooooooooool0NOooool00ol0003ooooo
ooooo`0>onKViRkooooo0_l00025ooooo`008oooool3o`0002gooooo2_oVi^H5ooooo`03o`000?oo
oooooooo07Oooooo00?o0000ooooooooool00oooool:onKViRgooooo0ol00027ooooo`009_ooool2
o`0002gooooo1_oVi^H8ooooo`03o`000?oooooooooo07Gooooo00?o0000ooooooooool01_ooool6
onKViRgooooo0_l0002:ooooo`00:?ooool2o`0003[ooooo0_l0000iooooo`03o`000?oooooooooo
03Oooooo0_l0000jooooo`;o0000S?ooool002[ooooo0ol0000iooooo`03o`000?oooooooooo03Ko
oooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0gooooo`?o0000S_ooool002gooooo
0_l0000hooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003ooooo
ooooo`0fooooo`;o0000TOooool002oooooo0ol0000fooooo`03o`000?oooooooooo03Cooooo00?o
0000ooooooooool0=?ooool00ol0003oooooooooo`0dooooo`?o0000Toooool003;ooooo0_l0000e
ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0c
ooooo`;o0000U_ooool003Cooooo0ol0000cooooo`;o0000<oooool00ol0003oooooooooo`0aoooo
o`;o0000<oooool3o`0009Sooooo000gooooo`;o0000<oooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo033ooooo00?o0000ooooooooool0<Oooool2o`0009_ooooo000iooooo`;o0000
<_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
<?ooool2o`0009gooooo000kooooo`?o0000<?ooool00ol0003oooooooooo`0^ooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool0;_ooool3o`0009oooooo000nooooo`;o0000;oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool2
o`000:;ooooo0010ooooo`?o0000;Oooool2o`0002gooooo00?o0000ooooooooool0:oooool2o`00
02gooooo0ol0002Tooooo`00@oooool2o`0002gooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo02_ooooo0_l0002Wooooo`00AOooool3o`0002_ooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo
0ol0002Yooooo`00B?ooool2o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02Sooooo0_l0002/ooooo`00B_ooool2o`0002Wooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo0_l0002^
ooooo`00C?ooool3o`0002Oooooo0_l0000Wooooo`03o`000?oooooooooo02Gooooo0_l0000Woooo
o`?o0000/?ooool004oooooo0_l0000Wooooo`03o`000?oooooooooo02Cooooo00?o0000oooooooo
ool09?ooool00ol0003oooooooooo`0Uooooo`;o0000/oooool0057ooooo0ol0000Uooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`?o0000
]Oooool005Cooooo0_l0000Tooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0Rooooo`;o0000^?ooool005Kooooo0ol0000Rooooo`;o00008_ooool0
0ol0003oooooooooo`0Pooooo`;o00008_ooool3o`000;[ooooo001Iooooo`;o00008_ooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08?ooool2o`00
0;gooooo001Kooooo`;o00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07oooool2o`000;oooooo001Mooooo`?o00007oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool3o`000<7ooooo
001Pooooo`;o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool07?ooool2o`000<Cooooo001Rooooo`?o00007?ooool2o`0001cooooo00?o0000
ooooooooool06_ooool2o`0001cooooo0ol00036ooooo`00IOooool2o`0001cooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01[ooooo0_l00039oooo
o`00Ioooool2o`0001_ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo01Wooooo0_l0003;ooooo`00JOooool3o`0001Wooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0ol0003=ooooo`00K?oo
ool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo01Kooooo0_l0003@ooooo`00K_ooool3o`0001Kooooo0_l0000Fooooo`03o`000?oooooo
oooo01Cooooo0_l0000Fooooo`?o0000d_ooool0077ooooo0_l0000Fooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Dooooo`;o0000eOooool007?o
oooo0ol0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`?o0000eoooool007Kooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000f_ooool007Sooooo0_l0
000Booooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0@ooooo`;o0000g?ooool007[ooooo0ol0000@ooooo`;o00004?ooool00ol0003oooooooooo`0>
ooooo`;o00004?ooool3o`000=kooooo001mooooo`;o00004?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`000>7ooooo001oooooo`?o
00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool3o`000>?ooooo0022ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool2o`000>Kooooo0024ooooo`?o00002ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool3o`000>Sooooo0027ooooo`;o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2
o`0000[ooooo0_l0003[ooooo`00ROooool2o`0000[ooooo00?o0000ooooooooool01?ooool6onKV
iPOooooo00?o0000ooooooooool02?ooool2o`000>gooooo002;ooooo`?o00002?ooool01?l0003o
ooooooooooooool:onKViPCooooo00?o0000ooooooooool01_ooool3o`000>oooooo002>ooooo`;o
00001oooool00ol0003oi^KVonKViP0<onKViP03ooooool0003ooooo00Kooooo0_l0003booooo`00
T?ooool3o`0000Cooooo4?oVi^H5ooooo`?o0000m?ooool009?ooooo0_l00002oooooa3oi^KV0ooo
ool2o`000?Oooooo002Eooooo`03o`000?oVi^Koi^KV013oi^KV0_l0003iooooo`00U_oooolBonKV
i__ooooo002Eooooo`Ooi^KV1_l00007onKVi_[ooooo002Eooooo`Woi^KV0_l00009onKVi_[ooooo
002Eooooo`Woi^KV0_l00009onKVi_[ooooo002Eooooo`Woi^KV0_l00009onKVi_[ooooo002Eoooo
o`Soi^KV1Ol00007onKVi_[ooooo002Eooooo`Woi^KV0_l00009onKVi_[ooooo002Fooooo`Woi^KV
0ol00006onKVi__ooooo002Foooooa;oi^KVnoooool009Oooooo4?oVi^Klooooo`00Uoooool@onKV
i_cooooo002Hooooo`koi^KVoOooool009[ooooo2_oVi^Koooooo`00W?ooool6onKVi_oooooo0_oo
ool00001\
\>"],
  ImageRangeCache->{{{0, 418.812}, {258.438, 0}} -> {-2.23393, -0.833976, \
0.0140107, 0.00335849}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
TermPlot[theChromos, 
  TreeWidth -> .2, 
  LabelSize -> 0.04, LabelColor -> 0,
  TextDisplay -> False
];\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.04 w
.25889 .30902 Mdot
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.25889 .45617 Mdot
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.04 w
.79719 .30902 Mdot
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.79719 .16187 Mdot
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.72904 .45617 Mdot
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.49396 .60332 Mdot
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.188, 233.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007gooooo1Ol0000<ooooo`00iOooool2o`0000;ooooo0_l0001oooooo`;o000000?oooooo`00
0?l000002oooool00>Gooooo1_l0001oooooo`;o000000?oooooo`000?l000002oooool00>Kooooo
1?l00020ooooo`Co00003?ooool00>Kooooo1?l00020ooooo`;o000000?oooooo`000?l000002ooo
ool00>Oooooo0_l00021ooooo`;o000000?oooooo`000?l000002oooool00>Kooooo0ol00020oooo
o`Go00003?ooool00>kooooo0_l0001eooooo`;o00004oooool00?3ooooo00?o0000ooooooooool0
LOooool00ol0003oooooooooo`0Cooooo`00lOooool00ol0003oooooooooo`1_ooooo`03o`000?oo
oooooooo01Cooooo003booooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool05Oooool0
0??ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Fooooo`00m?ooool2o`0006Wo
oooo0_l0000Iooooo`00m_ooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo01Wooooo
003gooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool06_ooool00?Sooooo00?o0000
ooooooooool0HOooool00ol0003oooooooooo`0Kooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`03o`000?oooooooooo01cooooo003jooooo`;o0000GOooool2o`0001oooooo003looooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool07oooool00?gooooo00?o0000ooooooooool0Eooo
ool00ol0003oooooooooo`0Pooooo`00o_ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooo
oooo027ooooo003oooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool08_ooool00?oo
oooo0Oooool2o`00057ooooo0_l0000Uooooo`00ooooool3ooooo`03o`000?oooooooooo04gooooo
00?o0000ooooooooool09Oooool00?oooooo1?ooool00ol0003oooooooooo`1;ooooo`03o`000?oo
oooooooo02Kooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0W
ooooo`00ooooool6ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool0:?ooool00?oo
oooo1oooool2o`0004Gooooo0_l0000[ooooo`00ooooool9ooooo`03o`000?oooooooooo047ooooo
00?o0000ooooooooool0:oooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`03o`000?oo
oooooooo02cooooo003oooooo`_ooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0]
ooooo`00ooooool<ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0;_ooool00?oo
oooo3Oooool2o`0003Wooooo0_l0000aooooo`00ooooool?ooooo`03o`000?oooooooooo03Gooooo
00?o0000ooooooooool0<Oooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo03;ooooo003ooooooa7ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0c
ooooo`00oooooolBooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0=?ooool00?oo
oooo4oooool2o`0002gooooo0_l0000gooooo`00oooooolEooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0=oooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo03Sooooo003ooooooaOooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0i
ooooo`00oooooolHooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0>_ooool00?oo
oooo6Oooool2o`00027ooooo0_l0000mooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool0?Oooool00?oooooo7?ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo03kooooo003ooooooagooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0o
ooooo`00oooooolNooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0@?ooool00?oo
oooo7oooool2o`0001Gooooo0_l00013ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0@oooool00?oooooo8_ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo04Cooooo003oooooob?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`04o`000?ooooooooooooooo`Ko00001?ooool00ol0003oooooooooo`16
ooooo`00oooooolUooooo`[o000000?oooooo`000?l00000BOooool00?oooooo9_ooool:o`0004_o
oooo003oooooobGooooo3?l0001:ooooo`00H_ooool4o`000;gooooo3_l00019ooooo`00Hoooool2
o`000;kooooo3_l00019ooooo`00H?ooool6o`000;gooooo3_l00019ooooo`00H?ooool2o`000003
ooooool0003o00000;kooooo3_l00019ooooo`00HOooool4o`000;kooooo3_l00019ooooo`00H_oo
ool3o`000;kooooo3_l00019ooooo`00Hoooool2o`000;oooooo3?l0001:ooooo`00oooooolVoooo
o`[o0000Boooool00?oooooo9oooool8o`0004cooooo003oooooobSooooo1_l0001=ooooo`00Hooo
ool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooo
oooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0
003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04go
oooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o
0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34
ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000oooo
ooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00
Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oo
oooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool0
0ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo
04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo
00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooooooo
o`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000
ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=oooo
o`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`00
0?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?oo
ool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooo
oooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?o
oooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooo
ooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o
0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=
ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03
o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0
a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oo
oooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool0
06?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003o
ooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo
00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003ooooooooo
o`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Soooo
o`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooooooo
ool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`00
0?oooooooooo04gooooo001Pooooo`Ko0000`Oooool6o`0004gooooo001Oooooo`So0000_oooool8
o`0004cooooo001Nooooo`[o0000_Oooool:o`0004_ooooo001Mooooo`co0000^oooool<o`0004[o
oooo0017ooooo`Go00004?ooool>o`00013ooooo1?l0001hooooo`Co00002oooool5o`0000cooooo
1Ol00008ooooo`ko0000BOooool004Sooooo0_l000000ooooooo0000o`00000?ooooo`ko00003ooo
ool2o`0000;ooooo0_l0001fooooo`03o`000?oooooo000000kooooo0_l000000ooooooo0000o`00
000<ooooo`;o000000?oooooo`000?l000001oooool>o`0004Wooooo0018ooooo`;o000000?ooooo
o`000?l000003oooool>o`0001?ooooo0_l0001fooooo`03o`000?oooooo000000;o00003?ooool2
o`000003ooooool0003o000000cooooo0_l000000ooooooo0000o`000007ooooo`ko0000BOooool0
04Sooooo1?l0000@ooooo`ko00004Oooool3o`0007Oooooo00Go0000ooooool0003oooooo`00000<
ooooo`;o000000?oooooo`000?l000003?ooool4o`0000Sooooo3_l00019ooooo`00B?ooool2o`00
0003ooooool0003o000000oooooo3_l0000Cooooo`;o0000Moooool3o`0000gooooo0_l000000ooo
oooo0000o`00000<ooooo`;o000000?oooooo`000?l000001oooool>o`0004Wooooo0018ooooo`;o
000000?oooooo`000?l000003oooool>o`0000oooooo0_l00002ooooo`;o0000Qoooool2o`000003
ooooool0003o000000cooooo0_l000000ooooooo0000o`000007ooooo`ko0000BOooool004Oooooo
1Ol0000Aooooo`co00004Oooool4o`0008Oooooo1Ol0000<ooooo`Go00002Oooool<o`0004[ooooo
001Nooooo`[o0000_Oooool:o`0004_ooooo001Oooooo`So0000_oooool8o`0004cooooo001=oooo
o`03o`000?oooooooooo013ooooo1_l0002Eooooo`03o`000?oooooooooo02Wooooo1_l0001=oooo
o`00COooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0Ooooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1@ooooo`00C_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Aooooo`00C_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0POoo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1Aooooo`00Coooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Booooo`00Coooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Poooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`1Booooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Cooooo`00D?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0QOooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1Cooooo`00DOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0Qoooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`1Dooooo`00DOooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1D
ooooo`00D_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0ROooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`1Eooooo`00D_ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Eooooo`00
D_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
ROooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Eooooo`00Doooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Fooooo`00Doooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Roooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`1Fooooo`00E?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Gooooo`00E?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0SOooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1Gooooo`00EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Hooooo`00EOooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Soooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Hooooo`00E_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1Iooooo`00E_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Ioooo
o`00Eoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0Toooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`1Jooooo`00Eoooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Jooooo`00Eooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Tooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1Jooooo`00F?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Kooooo`00F?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0UOooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`1Kooooo`00FOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`00FOooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Uoooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`1Looooo`00F_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0VOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`1Mooooo`00F_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1M
ooooo`00Foooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0Voooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`1Nooooo`00Foooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Nooooo`00
G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
WOooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`1Oooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0WOooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Oooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`1Oooooo`00GOooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Woooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Rooooo`00GOooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Woooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Rooooo`00G_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0XOooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001Nooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Qooooo`04o`000?oooooo
ooooo`0000?ooooo00Co0000oooooooooooo0000Hoooool005oooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo0:?ooooo00?o0000ooooool000000_ooool01?l0003ooooo
ooooool0001Tooooo`00Goooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0Xoooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool0H_ooool0
063ooooo1ol0002Wooooo`Oo0000IOooool005oooooo2?l0002Vooooo`So0000IOooool005kooooo
2_l0002Tooooo`[o0000I?ooool005gooooo3?l0002Rooooo`co0000Hoooool005cooooo3_l0002P
ooooo`ko0000H_ooool000Wooooo1ol0001<ooooo`ko0000COooool5o`0004kooooo3_l0001=oooo
o`Ko00003oooool000Wooooo0_l00002ooooo`;o0000COooool>o`0004kooooo0_l000000ooooooo
0000o`00001=ooooo`ko0000C_ooool2o`000003ooooool0003o000000oooooo0009ooooo`Ko0000
COooool>o`0004kooooo0_l000000ooooooo0000o`00001=ooooo`ko0000Coooool2o`00017ooooo
000:ooooo`Co0000C_ooool>o`0004kooooo0_l000000ooooooo0000o`00001=ooooo`ko0000D?oo
ool2o`00013ooooo000:ooooo`Co00001Oooool2o`0004Oooooo3_l0001>ooooo`;o000000?ooooo
o`000?l00000COooool>o`0004Sooooo00?o0000ooooooooool00_ooool2o`0000;ooooo0_l0000?
ooooo`002oooool2o`0000Sooooo0ol00015ooooo`go0000C_ooool2o`000003ooooool0003o0000
04kooooo3?l00016ooooo`?o00001Oooool2o`0000;ooooo0_l0000?ooooo`002_ooool3o`0000_o
oooo1?l00012ooooo`[o00000_ooool00ol0003oooooooooo`1:ooooo`Go0000C_ooool00ol0003o
ooooo`000009o`0004?ooooo1?l00009ooooo`Co00004?ooool001cooooo0ol00010ooooo`So0000
1?ooool2o`0009_ooooo0_l00003ooooo`So0000@Oooool3o`00027ooooo000Oooooo`?o0000?_oo
ool6o`0000Oooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`04ooooo`Ko0000?ooo
ool3o`0002Cooooo000Rooooo`?o0000BOooool2o`0004[ooooo00?o0000ooooooooool0B?ooool2
o`0004Wooooo0ol0000Wooooo`009Oooool3o`0004Sooooo0_l00018ooooo`03o`000?oooooooooo
04Kooooo0_l00018ooooo`?o0000:_ooool002Sooooo1?l00016ooooo`03o`000?oooooooooo04Go
oooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`14ooooo`Co0000;Oooool002cooooo
0ol00014ooooo`;o0000AOooool00ol0003oooooooooo`13ooooo`;o0000A?ooool3o`00037ooooo
000_ooooo`?o0000@oooool2o`0004?ooooo00?o0000ooooooooool0@Oooool2o`0004?ooooo0ol0
000dooooo`00<_ooool3o`0004;ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10
ooooo`03o`000?oooooooooo043ooooo0ol0000gooooo`00=Oooool4o`0003oooooo0_l00010oooo
o`03o`000?oooooooooo03kooooo0_l0000oooooo`Co0000>_ooool003Wooooo0ol0000nooooo`03
o`000?oooooooooo03gooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0looooo`?o
0000?_ooool003cooooo0ol0000looooo`;o0000?Oooool00ol0003oooooooooo`0kooooo`;o0000
??ooool3o`00047ooooo000oooooo`?o0000>oooool2o`0003_ooooo00?o0000ooooooooool0>Ooo
ool2o`0003_ooooo0ol00014ooooo`00@_ooool3o`0003[ooooo00?o0000ooooooooool0>?ooool0
0ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo0ol00017ooooo`00AOooool4o`00
03Oooooo0_l0000hooooo`03o`000?oooooooooo03Kooooo0_l0000gooooo`Co0000B_ooool004Wo
oooo0ol0000fooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003o
ooooooooo`0dooooo`?o0000C_ooool004cooooo0ol0000dooooo`;o0000=Oooool00ol0003ooooo
ooooo`0cooooo`;o0000=?ooool3o`00057ooooo001?ooooo`?o0000<oooool2o`0003?ooooo00?o
0000ooooooooool0<Oooool2o`0003?ooooo0ol0001Dooooo`00D_ooool4o`00037ooooo00?o0000
ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02oooooo1?l0001G
ooooo`00E_ooool3o`0002oooooo0_l0000`ooooo`03o`000?oooooooooo02kooooo0_l0000_oooo
o`?o0000Foooool005Wooooo0ol0000^ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`0/ooooo`?o0000G_ooool005cooooo0ol0000/ooooo`;o0000
;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?ooool3o`00067ooooo001Oooooo`?o0000:ooo
ool2o`0002_ooooo00?o0000ooooooooool0:Oooool2o`0002_ooooo0ol0001Tooooo`00H_ooool4
o`0002Wooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooo
oooo02Oooooo1?l0001Wooooo`00I_ooool3o`0002Oooooo0_l0000Xooooo`03o`000?oooooooooo
02Kooooo0_l0000Wooooo`?o0000Joooool006Wooooo0ol0000Vooooo`;o00009_ooool00ol0003o
ooooooooo`0Tooooo`;o00009_ooool3o`0006kooooo001/ooooo`?o00009Oooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool3o`00077ooooo
001_ooooo`Co00008_ooool2o`0002?ooooo00?o0000ooooooooool08Oooool2o`0002;ooooo1?l0
001dooooo`00Loooool3o`00027ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo01oooooo0ol0001hooooo`00M_ooool3o`0001oooooo0_l0000Poooo
o`03o`000?oooooooooo01kooooo0_l0000Oooooo`?o0000Noooool007Wooooo0ol0000Nooooo`;o
00007_ooool00ol0003oooooooooo`0Looooo`;o00007_ooool3o`0007kooooo001looooo`?o0000
7Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
6oooool3o`00087ooooo001oooooo`Co00006_ooool2o`0001_ooooo00?o0000ooooooooool06Ooo
ool2o`0001[ooooo1?l00024ooooo`00Poooool3o`0001Wooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo0ol00028ooooo`00Q_ooool3o`00
01Oooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo0_l0000Gooooo`?o0000Roooool008Wo
oooo0ol0000Fooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`;o00005_ooool3o`0008ko
oooo002<ooooo`Co00005?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04_ooool4o`00097ooooo002@ooooo`?o00004_ooool2o`0001?ooooo00?o
0000ooooooooool04Oooool2o`0001;ooooo0ol0002Eooooo`00Toooool3o`00017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo0ol0002H
ooooo`00U_ooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0000?oooo
o`?o0000Voooool009Wooooo0ol0000>ooooo`;o00003_ooool00ol0003oooooooooo`0<ooooo`;o
00003_ooool3o`0009kooooo002Looooo`Co00003?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02_ooool4o`000:7ooooo002Pooooo`?o00002_oo
ool2o`0000_ooooo00?o0000ooooooooool02Oooool2o`0000[ooooo0ol0002Uooooo`00Xoooool3
o`0000Wooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`?o0000Z?ooool0
0:Kooooo0ol00008ooooo`03o`000?oooooooooo00?ooooo1_l00006ooooo`03o`000?oooooooooo
00Kooooo0ol0002[ooooo`00ZOooool4o`0000Gooooo0_l00002ooooo`So00000oooool2o`0000Go
oooo1?l0002^ooooo`00[Oooool3o`0000Cooooo2ol000000ooooooo0000ooooo`03ooooo`?o0000
/_ooool00;3ooooo0ol000000ooooooo0000o`00000:o`0000;ooooo0ol0002eooooo`00/oooool?
o`000;Sooooo002cooooo`ko0000^Oooool00;?ooooo3_l0002iooooo`00/oooool>o`000;Wooooo
002cooooo`ko0000^Oooool00;?ooooo3_l0002iooooo`00]?ooool<o`000;[ooooo002eooooo`[o
0000^oooool00;Kooooo2?l0002looooo`00]oooool6o`000;gooooo0000\
\>"],
  ImageRangeCache->{{{0, 377.188}, {232.75, 0}} -> {-2.14106, -0.82718, \
0.011489, 0.00367076}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dupChromos = Join @@ Table[
Duplication[theChromos, 
  Templates -> {{{_f}, 1},
                {{_h}, 1},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

dupChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, 
            h[\[ExponentialE], D, B, g[g[A, B]], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], A, g[B, g[4], 3], D, 
            h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2, D, 
            h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
            h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, B, g[g[A, B]]], 
            2]]], chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, 
            h[\[ExponentialE], \[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B, B]]], 
            2]]], chromo[q[undef], 
        p[f[A, g[B, g[4], B, g[4], 3], D, 
            h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], B, g[4], 3], D, 
            h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2, D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3, B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], \[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]], D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2, D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3, B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> False,
            LabelSize -> 0.04, LabelColor -> 0.9
]& /@ dupChromos;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.6836 .30902 -5 -6 ]
[.6836 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.72904 .30902 -5 -6 ]
[.72904 .30902 5 6 ]
[.55004 .01472 -5.0625 -6 ]
[.55004 .01472 5.0625 6 ]
[.90804 .01472 -5 -6 ]
[.90804 .01472 5 6 ]
[.72904 .16187 -5 -6 ]
[.72904 .16187 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.77447 .30902 -5 -6 ]
[.77447 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.6836 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.77447 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.6836 .30902 Mdot
0 g
gsave
.6836 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .30902 m
.72904 .16187 L
s
.9 g
.04 w
.72904 .30902 Mdot
0 g
gsave
.72904 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .16187 m
.55004 .01472 L
s
.72904 .16187 m
.90804 .01472 L
s
1 g
.04 w
.55004 .01472 Mdot
0 g
gsave
.55004 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.90804 .01472 Mdot
0 g
gsave
.90804 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.72904 .16187 Mdot
0 g
gsave
.72904 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.77447 .30902 Mdot
0 g
gsave
.77447 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00c?ooool7
o`0001;ooooo1ol0001Tooooo`Go00005Oooool5o`0000_ooooo003<ooooo`;o00000_ooool2o`00
01?ooooo0_l00002ooooo`;o0000I_ooool2o`000003ooooool0003o000001Gooooo0_l000000ooo
oooo0000o`00000:ooooo`00c?ooool6o`0001?ooooo1_l0001Vooooo`;o000000?oooooo`000?l0
00005Oooool2o`000003ooooool0003o000000[ooooo003=ooooo`Co00005Oooool4o`0006Oooooo
1?l0000Fooooo`Co00002oooool00<gooooo1?l0000Eooooo`Co0000Ioooool2o`000003ooooool0
003o000001Gooooo0_l000000ooooooo0000o`00000:ooooo`00c_ooool2o`0001Oooooo0_l0001X
ooooo`;o000000?oooooo`000?l000005Oooool2o`000003ooooool0003o000000[ooooo003=oooo
o`?o00005_ooool3o`0006Oooooo1Ol0000Eooooo`Go00002oooool00=Gooooo0_l0000Gooooo`;o
0000G?ooool2o`0001Sooooo0_l0000Booooo`00eoooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo05Sooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Booooo`00f?oo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo05Kooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0Cooooo`00fOooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo05Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Dooooo`00f_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool05_ooool2o`00
01Oooooo003Kooooo`;o00005oooool2o`00053ooooo0_l0000Hooooo`03o`000?oooooooooo01Oo
oooo003Mooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0C?ooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo01Sooooo003Nooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooooooool0B_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Wooooo003O
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo01[ooooo003Pooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0A_ooool00ol0003oooooooooo`0Fooooo`;o00007Oooool00>7ooooo0_l0000Gooooo`;o
0000A?ooool2o`0001Sooooo00?o0000ooooooooool07Oooool00>?ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
7_ooool00>Cooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0nooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool07oooool00>Gooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0looooo`03o`000?oooooooooo01Kooooo0_l0000Rooooo`00i_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`0Rooooo`00ioooool2o`0001Oooooo0_l0000hooooo`;o00006?ooool00ol0003o
ooooooooo`0Sooooo`00jOooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo03Cooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`0Tooooo`00j_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0Uooooo`00joooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool05_ooool2o`0002Sooooo003/ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo02Sooooo003]ooooo`;o
00005oooool2o`0002cooooo0_l0000Hooooo`03o`000?oooooooooo02Wooooo003_ooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo02[ooooo003`ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0Fooooo`;o0000;Oooool00?7ooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0;Oooool0
0?;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
01Kooooo00?o0000ooooooooool0;_ooool00??ooooo0_l0000Gooooo`;o00008?ooool2o`0001So
oooo00?o0000ooooooooool0;oooool00?Gooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0<?ooool00?Kooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Kooooo0_l0
000cooooo`00moooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool05_ooool00ol0003oooooooooo`0cooooo`00n?ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0doooo
o`00nOooool2o`0001Oooooo0_l0000Dooooo`;o00006?ooool00ol0003oooooooooo`0eooooo`00
noooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0fooooo`00o?ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool05_ooool2o`0003Wooooo003mooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo03Wooooo003nooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo03[ooooo003oooooo`;o00005oooool2o`0000So
oooo0_l0000Hooooo`03o`000?oooooooooo03_ooooo003oooooo`;ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Kooooo0_l0000nooooo`00oooo
ool3ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo03kooooo003oooooo`Cooooo00?o0000ooooooooool05_ooool0
1?l0003oooooooooool0000Hooooo`03o`000?oooooooooo03oooooo003oooooo`Gooooo00?o0000
ooooooooool05_ooool2o`0001Sooooo00?o0000ooooooooool0@?ooool00?oooooo1_ooool2o`00
01Gooooo1?l0000Fooooo`03o`000?oooooooooo047ooooo003oooooo`Sooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo017ooooo0_l00014ooooo`00
ooooool9ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo04Cooooo003oooooo`[ooooo00?o0000ooooooooool00_oo
ool6onKViPGooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`Koi^KV1Ooo
ool00ol0003oooooooooo`15ooooo`00ooooool;ooooo`03o`000?oooooooooo00Soi^KV0oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16
ooooo`00ooooool<ooooo`03o`000?oVi^Koi^KV00Soi^KV0_l0000<ooooo`03o`000?oVi^Koi^KV
00Soi^KV0_l00019ooooo`00ooooool<ooooo`Coi^KV1?l00004onKViPgooooo1?oVi^H4o`0000Co
i^KVB_ooool00?oooooo2oooool8onKViP;o00001?oVi^H;ooooo`Soi^KV0_l00004onKViTWooooo
001Rooooo`Co0000Y?ooool5onKViPGo00001?oVi^H;ooooo`Goi^KV1Ol00004onKViTWooooo001S
ooooo`;o0000YOooool4onKViP;o00000_oVi^H2o`0000Coi^KV2oooool4onKViP;o00000_oVi^H2
o`0000Coi^KVBOooool0063ooooo1_l0002Tooooo`Coi^KV0_l00002onKViP;o00001?oVi^H;oooo
o`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00H?ooool2o`000003ooooool0003o00000:Go
oooo1?oVi^H2o`0000;oi^KV0_l00004onKViP_ooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWo
oooo001Qooooo`Co0000YOooool5onKViPKo00000ooVi^H;ooooo`Goi^KV1_l00003onKViTWooooo
001Rooooo`?o0000Y_ooool<onKViPgooooo3?oVi^I:ooooo`00Hoooool2o`000:Oooooo2_oVi^H?
ooooo`[oi^KVBoooool00?oooooo3_ooool8onKViQ7ooooo2?oVi^I<ooooo`00ooooool?ooooo`Ko
i^KV4oooool6onKViTgooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zoooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo
0:_ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003o
ooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo
00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo
001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000
ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zooo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooo
oooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0
003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?o
oooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04go
oooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0
Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oo
oooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool0
0ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool0
06?ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zoooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000
ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[oooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooooooo
ool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`00
0?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hooo
ool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COoo
ool006?ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0Zoooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0:_ooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`2[
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooo
ooooool0Zoooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo04gooooo001Sooooo`03
o`000?oooooooooo0:_ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`1=ooooo`00
Hoooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
COooool0063ooooo1_oVi^JXooooo`Koi^KV4oooool6onKViTgooooo001Oooooo`Soi^KVY_ooool8
onKViQ7ooooo2?oVi^I<ooooo`00G_ooool3onKViPCo00000ooVi^JTooooo`?oi^KV1?l00002onKV
iQ3ooooo0ooVi^H4o`0000?oi^KVBoooool005gooooo1ooVi^H2o`0000?oi^KVX_ooool7onKViP;o
00004?ooool7onKViP;o00000ooVi^I:ooooo`00Aoooool5o`00013ooooo1OoVi^H5o`0000Coi^KV
4?ooool4o`0007Sooooo0ol00004ooooo`Go00001?ooool4o`0000Goi^KV1?l00003ooooo`Go0000
1?ooool4o`0000Goi^KV1Ol00004onKViTWooooo0018ooooo`;o000000?oooooo`000?l000003ooo
ool4onKViP;o00000_oVi^H2o`0000Coi^KV3oooool2o`0000;ooooo0_l0001fooooo`03o`000?oo
oooo000000Kooooo0_l000000ooooooo0000ooooo`04ooooo`;o000000?oooooonKVi_oVi^H00_oV
i^H2o`0000;oi^KV00?o0000ooooooooool00_ooool2o`000003ooooool0003ooooo00Cooooo0_l0
00000oooooooi^KVonKViP02onKViP;o00000_oVi^H2o`0000Coi^KVBOooool004Sooooo0_l00000
0ooooooo0000o`00000?ooooo`Coi^KV0_l00002onKViP;o00001?oVi^HCooooo`;o0000M_ooool0
1?l0003oooooo`000?l00005ooooo`;o000000?oooooo`000?ooool01?ooool2o`000003oooooooV
i^Koi^KV00;oi^KV0_l00002onKViP03o`000?oooooooooo00;ooooo0_l000000ooooooo0000oooo
o`04ooooo`;o000000?oooooonKVi_oVi^H00_oVi^H2o`0000;oi^KV0_l00004onKViTWooooo0018
ooooo`Co00004?ooool4onKViP;o00000_oVi^H2o`0000Coi^KV4Oooool3o`0007Oooooo00?o0000
ooooool000001_ooool2o`000003ooooool0003ooooo00Cooooo0ol00004onKViP;o00000_oVi^H0
0ol0003oooooooooo`02ooooo`;o000000?oooooo`000?ooool01?ooool3o`0000Coi^KV0_l00002
onKViP;o00001?oVi^I9ooooo`00B?ooool2o`000003ooooool0003o000000oooooo1OoVi^H6o`00
00?oi^KV4oooool2o`0007Oooooo0ol00005ooooo`;o000000?oooooo`000?ooool01?ooool2o`00
0003oooooooVi^Koi^KV00?oi^KV1?l00004ooooo`;o000000?oooooo`000?ooool01?ooool2o`00
0003oooooooVi^Koi^KV00?oi^KV1_l00003onKViTWooooo0018ooooo`;o000000?oooooo`000?l0
00003oooool>onKViPoooooo0_l00002ooooo`;o0000Ooooool2o`000003ooooool0003ooooo00Co
oooo0_l000000oooooooi^KVonKViP07onKViPCooooo0_l000000ooooooo0000ooooo`04ooooo`;o
000000?oooooonKVi_oVi^H03?oVi^I9ooooo`00Aoooool5o`00017ooooo3?oVi^HAooooo`Co0000
Ooooool5o`0000Cooooo1Ol00009onKViP;ooooo1Ol00004ooooo`Go00003?oVi^I:ooooo`00G_oo
ool:onKViZCooooo2OoVi^H@ooooo`[oi^KVBoooool005oooooo2?oVi^JVooooo`Soi^KV4Oooool8
onKViTcooooo001=ooooo`03o`000?oooooooooo013ooooo1_oVi^JEooooo`03o`000?oooooooooo
013ooooo1_oVi^HCooooo`Koi^KVCOooool004gooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0D?ooool004kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo087ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0DOooool004kooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0DOooool004oooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo08?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0D_ooool004oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo08?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0D_ooool0053ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo08Gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0Doooool0053ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo08Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0Doooool0057ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0E?oo
ool0057ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo08Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0E?ooool005;ooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0EOooool005;o
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo08Wo
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0EOooool005;ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0EOooool005?ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo08_ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0E_ooool005?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo08_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0E_ooool005Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo08gooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Eoooool005Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo08gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0Eoooool005Gooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo08oooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool00000F_ooool005Gooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo08oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0F?ooool005Ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo097o
oooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000Foooool005Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo097ooooo00Go0000
ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool00000Foooool005Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00?o0000ooooooooool0F_ooool005Oooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo09?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool0F_ooool005Oooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo09?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool0F_ooool005Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo09Gooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo05_ooooo001H
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2E
ooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooooooool00002ooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`1Kooooo`00FOooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Uoooool01?l0003ooooo
ooooool00003ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo05cooooo001Iooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`2Gooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo00000_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
G?ooool005[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo09Wooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0GOooool005[ooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo09Wooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0GOooool005_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooool000000_ooool01?l0003oooooooooool0
0002ooooo`06o`000?ooooooooooo`000?oooooo0000H?ooool005_ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo09_ooooo00Ko0000oooooooooooo
0000ooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003ooooooooo
o`1Nooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0WOooool00ol0003oooooo`000002ooooo`05o`000?oooooo0000ooooool000000_oo
ool00ol0003oooooo`00001Qooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0WOooool00ol0003oooooo`000002ooooo`05o`000?oooooo
0000ooooool000000_ooool00ol0003oooooo`00001Qooooo`00G?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0WOooool03?l0003oooooooooool0
003oooooo`000?oooooo0000ooooool0003oooooo`0000;ooooo00?o0000ooooooooool0Goooool0
05gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
09oooooo00go0000ooooool0003oooooo`000?oooooo0000ooooool0003oooooo`000?oooooo0000
06;ooooo001Mooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`2Oooooo`0=o`000?oooooo0000ooooool0003oooooo`000?oooooo0000ooooool0003o
ooooo`00001Rooooo`00G_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0XOooool2o`000007ooooool0003oooooo`000?oooooo0000ooooo`02o`00
06?ooooo001Nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`2Qooooo`07o`000?oooooo0000o`000?oooooo0000ooooo`02o`000003ooooool0003o
oooo06;ooooo001Oooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2S
ooooo`;o000000Goooooo`000?l0003o0000ooooo`02o`0006Cooooo001Oooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`2Sooooo`;o000000Goooooo`000?l0003o0000
ooooo`02o`0006Cooooo001Pooooo`Koi^KV00?o0000ooooooooool0YOooool6onKViP03o`000?oo
oooooooo06?ooooo001Oooooo`Soi^KVY_ooool8onKViVGooooo001Nooooo`[oi^KVY?ooool:onKV
iVCooooo001Mooooo`Coi^KV1?l00004onKViZ;ooooo3?oVi^ISooooo`00G?ooool8onKViP;o0000
1?oVi^JPooooo`koi^KVH_ooool000Wooooo1ol0001<ooooo`Goi^KV1Ol00004onKViTgooooo1Ol0
001>ooooo`Coi^KV1ol00003onKViTgooooo1_l0000?ooooo`002Oooool2o`0000;ooooo0_l0001=
ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l00000COooool5
onKViP;o000000?oi^KVo`000?l000001?oVi^I>ooooo`;o000000?oooooo`000?l000003oooool0
00Wooooo1_l0001=ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`00
0?l00000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I?ooooo`;o00004Oooool000[o
oooo1?l0001>ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l0
0000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I@ooooo`;o00004?ooool000[ooooo
1?l00005ooooo`;o0000Aoooool5onKViPKo00000ooVi^I>ooooo`;o000000?oooooo`000?l00000
COooool5onKViPCo00001OoVi^I8ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`;o0000
3oooool000_ooooo0_l00008ooooo`?o0000AOooool<onKViP03o`000?oooooooooo04cooooo0_l0
00000ooooooo0000o`00001>ooooo`Coi^KV0_l00006onKViTKooooo0ol00005ooooo`;o00000_oo
ool2o`0000oooooo000:ooooo`?o00002oooool4o`0004;ooooo2_oVi^H2ooooo`03o`000?oooooo
oooo04[ooooo1Ol0001>ooooo`04o`000?ooooooi^KVonKViP?o00001OoVi^I3ooooo`Co00002Ooo
ool4o`00013ooooo000Looooo`?o0000@?ooool8onKViPCooooo0_l0002Kooooo`;o00000oooool8
onKViT7ooooo0ol0000Qooooo`007oooool3o`0003kooooo1_oVi^H7ooooo`03o`000?oooooooooo
09Oooooo00?o0000ooooooooool01?ooool6onKViSoooooo0ol0000Tooooo`008_ooool3o`0004Wo
oooo0_l0001:ooooo`03o`000?oooooooooo04Sooooo0_l00019ooooo`?o00009oooool002Gooooo
0ol00018ooooo`;o0000B?ooool00ol0003oooooooooo`16ooooo`;o0000B?ooool3o`0002[ooooo
000Xooooo`Co0000A_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo00?o
0000ooooooooool0A?ooool4o`0002gooooo000/ooooo`?o0000A?ooool2o`0004Gooooo00?o0000
ooooooooool0@oooool2o`0004Cooooo0ol0000aooooo`00;oooool3o`0004?ooooo0_l00013oooo
o`03o`000?oooooooooo047ooooo0_l00013ooooo`?o0000=?ooool003;ooooo0ol00012ooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`?o
0000=oooool003Gooooo1?l0000oooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`;o0000
?oooool4o`0003[ooooo000iooooo`?o0000?_ooool00ol0003oooooooooo`0mooooo`03o`000?oo
oooooooo03gooooo00?o0000ooooooooool0??ooool3o`0003kooooo000looooo`?o0000??ooool2
o`0003gooooo00?o0000ooooooooool0>oooool2o`0003cooooo0ol00011ooooo`00?oooool3o`00
03_ooooo0_l0000kooooo`03o`000?oooooooooo03Wooooo0_l0000kooooo`?o0000A?ooool004;o
oooo0ol0000jooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003o
ooooooooo`0hooooo`?o0000Aoooool004Gooooo1?l0000gooooo`;o0000>?ooool00ol0003ooooo
ooooo`0fooooo`;o0000=oooool4o`0004[ooooo0019ooooo`?o0000=_ooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool3o`0004kooooo001<
ooooo`?o0000=?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001A
ooooo`00Coooool3o`0003?ooooo0_l0000cooooo`03o`000?oooooooooo037ooooo0_l0000coooo
o`?o0000E?ooool005;ooooo1?l0000aooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool0<?ooool00ol0003oooooooooo`0_ooooo`Co0000Eoooool005Kooooo0ol0000_ooooo`;o0000
<?ooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005_ooooo001Iooooo`?o0000;_oo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?oo
ool3o`0005kooooo001Looooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2
o`0002cooooo0ol0001Qooooo`00Goooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo
02Wooooo0_l0000[ooooo`?o0000I?ooool006;ooooo1?l0000Yooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`Co0000Ioooool006Kooooo
0ol0000Wooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`0006_ooooo
001Yooooo`?o00009_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0
001^ooooo`00K?ooool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo02?ooooo0ol0001aooooo`00Koooool4o`0002;ooooo0_l0000Soooo
o`03o`000?oooooooooo027ooooo0_l0000Rooooo`Co0000M?ooool007?ooooo0ol0000Qooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o
0000N?ooool007Kooooo0ol0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o0000
7oooool3o`0007_ooooo001iooooo`?o00007_ooool2o`0001kooooo00?o0000ooooooooool07?oo
ool2o`0001kooooo0ol0001nooooo`00O?ooool3o`0001gooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo0ol00021ooooo`00Ooooool4o`00
01[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`Co0000Q?ooool008?o
oooo0ol0000Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Gooooo`?o0000R?ooool008Kooooo0ol0000Gooooo`;o00006?ooool00ol0003ooooo
ooooo`0Fooooo`;o00005oooool3o`0008_ooooo0029ooooo`?o00005_ooool2o`0001Kooooo00?o
0000ooooooooool05?ooool2o`0001Kooooo0ol0002>ooooo`00S?ooool4o`0001Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo1?l0002A
ooooo`00T?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Boooo
o`?o0000UOooool009?ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0?ooooo`?o0000V?ooool009Kooooo0ol0000?ooooo`;o0000
4?ooool00ol0003oooooooooo`0>ooooo`;o00003oooool3o`0009_ooooo002Iooooo`?o00003_oo
ool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002Nooooo`00W?ooool4
o`0000cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00[ooooo1?l0002Qooooo`00X?ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo
00Wooooo0_l0000:ooooo`?o0000YOooool00:?ooooo0ol00009ooooo`;o00002Oooool00ol0003o
ooooooooo`07ooooo`;o00002Oooool3o`000:Sooooo002Vooooo`?o00002?ooool00ol0003ooooo
ooooo`03ooooo`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`?o0000Zoooool00:Wooooo1?l0
0005ooooo`;o00000_ooool8onKViP?ooooo0_l00005ooooo`Co0000[_ooool00:gooooo0ol00004
ooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool00oooool3o`000;;ooooo002`oooo
o`?o000000?oooooonKVi_oVi^H02_oVi^H2ooooo`?o0000]Oooool00;?ooooo1?oVi^H6o`0000Co
i^KV00?o0000ooooooooool0]_ooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1_oV
i^H2o`0000Koi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1OoVi^H5o`00
00Coi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;Cooooo1_oVi^H3o`0000?oi^KV
^_ooool00;Gooooo2_oVi^Jkooooo`00]_ooool8onKVi[cooooo002gooooo`Koi^KV_Oooool00001
\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.466584 0.221387 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12556 .30902 -5 -6 ]
[.12556 .30902 5 6 ]
[.1714 .30902 -5 -6 ]
[.1714 .30902 5 6 ]
[.1714 .16187 -5 -6 ]
[.1714 .16187 5 6 ]
[.21725 .30902 -5 -6 ]
[.21725 .30902 5 6 ]
[.1714 .45617 -5 -6 ]
[.1714 .45617 5 6 ]
[.31899 .45617 -5.0625 -6 ]
[.31899 .45617 5.0625 6 ]
[.42074 .30902 -5 -6 ]
[.42074 .30902 5 6 ]
[.46658 .30902 -5 -6 ]
[.46658 .30902 5 6 ]
[.46658 .16187 -5 -6 ]
[.46658 .16187 5 6 ]
[.51243 .30902 -5 -6 ]
[.51243 .30902 5 6 ]
[.46658 .45617 -5 -6 ]
[.46658 .45617 5 6 ]
[.61418 .45617 -5 -6 ]
[.61418 .45617 5 6 ]
[.71592 .30902 -5 -6 ]
[.71592 .30902 5 6 ]
[.74649 .30902 -5 -6 ]
[.74649 .30902 5 6 ]
[.77705 .30902 -5 -6 ]
[.77705 .30902 5 6 ]
[.80761 .30902 -5 -6 ]
[.80761 .30902 5 6 ]
[.63903 .01472 -5.0625 -6 ]
[.63903 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80761 .16187 -5 -6 ]
[.80761 .16187 5 6 ]
[.76177 .45617 -5 -6 ]
[.76177 .45617 5 6 ]
[.90936 .45617 -5 -6 ]
[.90936 .45617 5 6 ]
[.46658 .60332 -5 -6 ]
[.46658 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.46658 .60332 m
.02381 .45617 L
s
.46658 .60332 m
.1714 .45617 L
s
.46658 .60332 m
.31899 .45617 L
s
.46658 .60332 m
.46658 .45617 L
s
.46658 .60332 m
.61418 .45617 L
s
.46658 .60332 m
.76177 .45617 L
s
.46658 .60332 m
.90936 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.1714 .45617 m
.12556 .30902 L
s
.1714 .45617 m
.1714 .30902 L
s
.1714 .45617 m
.21725 .30902 L
s
1 g
.04 w
.12556 .30902 Mdot
0 g
gsave
.12556 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.1714 .30902 m
.1714 .16187 L
s
.9 g
.04 w
.1714 .30902 Mdot
0 g
gsave
.1714 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.1714 .16187 Mdot
0 g
gsave
.1714 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.21725 .30902 Mdot
0 g
gsave
.21725 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.1714 .45617 Mdot
0 g
gsave
.1714 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.31899 .45617 Mdot
0 g
gsave
.31899 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.46658 .45617 m
.42074 .30902 L
s
.46658 .45617 m
.46658 .30902 L
s
.46658 .45617 m
.51243 .30902 L
s
1 g
.04 w
.42074 .30902 Mdot
0 g
gsave
.42074 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.46658 .30902 m
.46658 .16187 L
s
.9 g
.04 w
.46658 .30902 Mdot
0 g
gsave
.46658 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.46658 .16187 Mdot
0 g
gsave
.46658 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.51243 .30902 Mdot
0 g
gsave
.51243 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.46658 .45617 Mdot
0 g
gsave
.46658 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.61418 .45617 Mdot
0 g
gsave
.61418 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.76177 .45617 m
.71592 .30902 L
s
.76177 .45617 m
.74649 .30902 L
s
.76177 .45617 m
.77705 .30902 L
s
.76177 .45617 m
.80761 .30902 L
s
1 g
.04 w
.71592 .30902 Mdot
0 g
gsave
.71592 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.74649 .30902 Mdot
0 g
gsave
.74649 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.77705 .30902 Mdot
0 g
gsave
.77705 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80761 .30902 m
.80761 .16187 L
s
.9 g
.04 w
.80761 .30902 Mdot
0 g
gsave
.80761 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80761 .16187 m
.63903 .01472 L
s
.80761 .16187 m
.97619 .01472 L
s
1 g
.04 w
.63903 .01472 Mdot
0 g
gsave
.63903 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.80761 .16187 Mdot
0 g
gsave
.80761 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.76177 .45617 Mdot
0 g
gsave
.76177 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.90936 .45617 Mdot
0 g
gsave
.90936 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.46658 .60332 Mdot
0 g
gsave
.46658 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00kOooool7
o`0007Kooooo1Ol0000;ooooo`00kOooool2o`0000;ooooo0_l0001hooooo`;o000000?oooooo`00
0?l000002_ooool00>gooooo1_l0001hooooo`;o000000?oooooo`000?l000002_ooool00>kooooo
1?l0001iooooo`Co00002oooool00>kooooo1?l0001iooooo`;o000000?oooooo`000?l000002_oo
ool00>oooooo0_l0001jooooo`;o000000?oooooo`000?l000002_ooool00>kooooo0ol0001ioooo
o`Go00002oooool00?Kooooo00?o0000ooooooooool0K_ooool00ol0003oooooooooo`0@ooooo`00
moooool00ol0003oooooooooo`1/ooooo`03o`000?oooooooooo017ooooo003hooooo`03o`000?oo
oooooooo06Wooooo0_l0000Dooooo`00nOooool2o`0006Sooooo00?o0000ooooooooool05?ooool0
0?_ooooo00?o0000ooooooooool0I?ooool00ol0003oooooooooo`0Eooooo`00o?ooool00ol0003o
ooooooooo`1Rooooo`03o`000?oooooooooo01Kooooo003mooooo`03o`000?oooooooooo063ooooo
00?o0000ooooooooool05oooool00?kooooo00?o0000ooooooooool0G_ooool00ol0003ooooooooo
o`0Hooooo`00ooooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo01Wooooo003ooooo
o`7ooooo00?o0000ooooooooool0FOooool2o`0001cooooo003oooooo`;ooooo00?o0000oooooooo
ool0Eoooool00ol0003oooooooooo`0Looooo`00ooooool3ooooo`;o0000E_ooool00ol0003ooooo
ooooo`0Mooooo`00ooooool5ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool07_oo
ool00?oooooo1_ooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo01oooooo003ooooo
o`Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Pooooo`00ooooool8ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool08Oooool00?oooooo2Oooool00ol0003ooooo
ooooo`19ooooo`;o00009?ooool00?oooooo2_ooool00ol0003oooooooooo`17ooooo`03o`000?oo
oooooooo02Cooooo003oooooo`_ooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0U
ooooo`00ooooool<ooooo`;o0000A?ooool00ol0003oooooooooo`0Vooooo`00ooooool>ooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool09oooool00?oooooo3oooool00ol0003ooooo
ooooo`0nooooo`03o`000?oooooooooo02Sooooo003ooooooa3ooooo00?o0000ooooooooool0>ooo
ool2o`0002_ooooo003ooooooa7ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0[
ooooo`00oooooolBooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0;?ooool00?oo
oooo4oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02gooooo003ooooooaCooooo
0_l0000dooooo`03o`000?oooooooooo02kooooo003ooooooaKooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0_ooooo`00oooooolGooooo`03o`000?oooooooooo02kooooo00?o0000
ooooooooool0<?ooool00?oooooo6?ooool00ol0003oooooooooo`0[ooooo`;o0000<oooool00?oo
oooo6Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo03?ooooo003ooooooa[ooooo
00?o0000ooooooooool09oooool00ol0003oooooooooo`0dooooo`00oooooolKooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0=Oooool00?oooooo7?ooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo03Kooooo003ooooooagooooo0_l0000Rooooo`03o`000?oooooooooo
03Oooooo003ooooooaoooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0hooooo`00
oooooolPooooo`03o`000?oooooooooo01_ooooo0_l0000kooooo`00oooooolQooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool0>oooool00?oooooo8_ooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo03cooooo003oooooob?ooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0mooooo`00oooooolTooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0?_ooool00?oooooo9Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03oooooo
003oooooobKooooo0_l0000@ooooo`03o`000?oooooooooo043ooooo003oooooobSooooo00Co0000
oooooooooooooooo1_oVi^H4ooooo`;o0000@oooool00?oooooo:Oooool00ol0003oooooonKViP07
onKViP;ooooo00?o0000ooooooooool0@oooool00?oooooo:_ooool:onKViP03o`000?oooooooooo
04Cooooo003oooooobWooooo1?oVi^H4o`0000Coi^KVA_ooool00?oooooo:?ooool8onKViP;o0000
1?oVi^I5ooooo`00@Oooool4o`0006[ooooo1?l0001dooooo`Goi^KV1Ol00004onKViTGooooo0012
ooooo`;o0000K?ooool2o`0007Gooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTGooooo000ooooo
o`Ko0000J?ooool6o`0007Cooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTGooooo000oooooo`;o
000000?oooooo`000?l00000JOooool2o`000003ooooool0003o000007Gooooo1?oVi^H2o`0000;o
i^KV0_l00004onKViTGooooo0010ooooo`Co0000J_ooool4o`0007Gooooo1OoVi^H6o`0000?oi^KV
AOooool0047ooooo0ol0001[ooooo`?o0000M_ooool<onKViTKooooo0012ooooo`;o0000K?ooool2
o`0007Oooooo2_oVi^I7ooooo`00ooooool[ooooo`Soi^KVB?ooool00?oooooo;?ooool6onKViTWo
oooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003ooooo
ooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000oooo
ooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03
o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0
Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oo
oooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool0
0ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool0
04;ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003o
ooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo
00?o0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000
ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[oooo
o`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000oooooooo
ool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`00
0?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_oo
ool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOoo
ool004;ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_o
oooo00?o0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[
ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000oooo
ooooool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03
o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00
@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0
BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oo
oooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo
07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003o
ooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003ooooooooo
o`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000
ooooooooool0Joooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012oooo
o`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`19oooo
o`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000oooooooo
ool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`1kooooo`03o`00
0?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0BOooool004;ooooo00?o0000ooooooooool0Joooool00ol0
003oooooooooo`1kooooo`03o`000?oooooooooo04Wooooo0012ooooo`03o`000?oooooooooo06_o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`19ooooo`00@_ooool00ol0003ooooo
ooooo`1[ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0BOooool0043ooooo1_oV
i^IWooooo`Koi^KVN?ooool6onKViTWooooo000oooooo`Soi^KVIOooool8onKViWKooooo2?oVi^I8
ooooo`00?_ooool2onKViPCo00001?oVi^ISooooo`?oi^KV1?l00003onKViWCooooo0ooVi^H4o`00
00?oi^KVAoooool003gooooo1_oVi^H2o`0000Coi^KVHOooool7onKViP;o00000ooVi^Ibooooo`Oo
i^KV0_l00003onKViTKooooo000_ooooo`Go00002?ooool4onKViPGo00001OoVi^H7ooooo`Co0000
Aoooool5o`0000Sooooo1OoVi^H5o`0000Coi^KV2?ooool4o`0004Oooooo1?l00007ooooo`Go0000
1_ooool5o`0000;ooooo1OoVi^H5o`0000Coi^KVAOooool0033ooooo0_l000000ooooooo0000o`00
0007ooooo`?oi^KV0_l00002onKViP;o00001OoVi^H6ooooo`;o00000_ooool2o`0004Oooooo0_l0
00000ooooooo0000o`000007ooooo`Coi^KV0_l00002onKViP;o00001?oVi^H7ooooo`;o00000_oo
ool2o`0004Gooooo00?o0000ooooool000002_ooool2o`000003ooooool0003o000000Kooooo0_l0
00001?oooooo0000o`000?ooool4onKViP;o00000_oVi^H2o`0000Coi^KVAOooool0033ooooo0_l0
00000ooooooo0000o`000007ooooo`?oi^KV0_l00002onKViP;o00001OoVi^H:ooooo`;o0000Aooo
ool2o`000003ooooool0003o000000Oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViP_ooooo0_l0
0015ooooo`03o`000?oooooo000000;o00002?ooool2o`000003ooooool0003o000000Kooooo0_l0
00001?oooooo0000o`000?ooool4onKViP;o00000_oVi^H2o`0000Coi^KVAOooool0033ooooo1?l0
0008ooooo`?oi^KV0_l00002onKViP;o00001OoVi^H8ooooo`?o0000B?ooool4o`0000Sooooo1?oV
i^H2o`0000;oi^KV0_l00004onKViPWooooo0ol00016ooooo`05o`000?oooooo0000ooooool00000
2?ooool2o`000003ooooool0003o000000Kooooo1?l00002ooooo`Coi^KV0_l00002onKViP;o0000
1?oVi^I5ooooo`00<?ooool2o`000003ooooool0003o000000Oooooo1?oVi^H6o`0000Coi^KV2_oo
ool2o`0004Oooooo0_l000000ooooooo0000o`000007ooooo`Goi^KV1_l00003onKViP_ooooo0_l0
0016ooooo`?o00002Oooool2o`000003ooooool0003o000000Kooooo0_l000001?oooooo0000o`00
0?ooool5onKViPKo00000ooVi^I5ooooo`00<?ooool2o`000003ooooool0003o000000Oooooo3_oV
i^H6ooooo`;o00000_ooool2o`0004Oooooo0_l000000ooooooo0000o`000007ooooo`koi^KV1ooo
ool2o`0000;ooooo0_l0001Booooo`;o000000?oooooo`000?l000001_ooool2o`000004ooooool0
003o0000ooooo`koi^KVAOooool002oooooo1Ol00009ooooo`coi^KV2?ooool4o`0004Oooooo1Ol0
0009ooooo`coi^KV2Oooool4o`0005;ooooo1Ol00006ooooo`Go00000oooool<onKViTKooooo000n
ooooo`[oi^KVHoooool:onKViWCooooo2_oVi^I7ooooo`00?oooool8onKViVGooooo2?oVi^Ifoooo
o`Soi^KVB?ooool0043ooooo1_oVi^IWooooo`Koi^KVN?ooool6onKViTWooooo000cooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo04_ooooo000dooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04cooooo000dooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo04cooooo000dooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`1?ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`1>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo04cooooo000eooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04go
oooo000eooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo04gooooo000eooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04gooooo000e
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1@
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo04gooooo000fooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04kooooo000fooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Cooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Booooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo04kooooo000fooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04kooooo000gooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Eooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Dooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo04oooooo000gooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`1Eooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`1Dooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo04oooooo000gooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
04oooooo000hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1Gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1Fooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo053ooooo000hooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo053ooooo
000hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Fooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo053ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo057ooooo000ioooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Ioooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Hoooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo057ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo057ooooo000jooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Kooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Jooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo05;ooooo000jooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05;ooooo000jooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Kooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Jooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo05;ooooo000jooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`1Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`1Jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo05;ooooo000kooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000005Gooooo000kooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Mooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
05?ooooo000kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Looooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo05?ooooo000looooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`1Nooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000005Kooooo000looooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Nooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000005Kooooo000looooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Nooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000005Kooooo000mooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`1Pooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo0000Eoooool003gooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo063ooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0005Oooooo000mooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Pooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool0001Gooooo`00?_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool0Hoooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0H_oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooo000005Sooooo000nooooo`05o`000?oo
ooooooooooooool000000oooool00ol0003oooooooooo`1Sooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Rooooo`06o`000?ooooooooooo`000?oooooo00000_ooool0
0ol0003oooooooooo`1Fooooo`00?_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool0Hoooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0H_oo
ool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool0E_ooool003kooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo06;ooooo00Ko0000oooooooooooo0000ooooool0
0002ooooo`03o`000?oooooooooo05Kooooo000oooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0IOooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo06Cooooo
00Oo0000ooooool0003oooooo`000?oooooo000005Wooooo000oooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0IOooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo06Cooooo00Oo0000ooooool0003oooooo`000?oooooo000005Wooooo000oooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Cooooo00Oo0000ooooool0003oooooo`000?oooooo000005Wooooo0010oooo
o`Koi^KVIoooool6onKViVOooooo1_oVi^IJooooo`00?oooool8onKViVGooooo2?oVi^IUooooo`So
i^KVFOooool003kooooo2_oVi^ISooooo`[oi^KVHoooool:onKViUSooooo000mooooo`?oi^KV1?l0
0005onKViV7ooooo1?oVi^H4o`0000Coi^KVHOooool<onKViUOooooo000looooo`Ooi^KV0_l00005
onKViUoooooo2?oVi^H2o`0000Coi^KVGoooool>onKViUKooooo0009ooooo`Oo0000;?ooool4onKV
iPGo00001OoVi^H/ooooo`Oo0000;?ooool5onKViPGo00001?oVi^H/ooooo`Go0000;_ooool4onKV
iPOo00000ooVi^H]ooooo`Ko00008oooool000Wooooo0_l00002ooooo`;o0000;Oooool3onKViP;o
00000_oVi^H2o`0000Goi^KV;?ooool2o`0000;ooooo0_l0000]ooooo`Coi^KV0_l00002onKViP;o
00001?oVi^H]ooooo`;o000000?oooooo`000?l00000;Oooool5onKViP;o000000?oi^KVo`000?l0
00001?oVi^H^ooooo`;o000000?oooooo`000?l000008oooool000Wooooo1_l0000]ooooo`?oi^KV
0_l00002onKViP;o00001OoVi^H/ooooo`Ko0000;Oooool4onKViP;o00000_oVi^H2o`0000Coi^KV
;Oooool2o`000003ooooool0003o000002gooooo1OoVi^H2o`000003onKVi_l0003o000000Coi^KV
;oooool2o`0002Gooooo000:ooooo`Co0000;_ooool3onKViP;o00000_oVi^H2o`0000Goi^KV;Ooo
ool4o`0002kooooo1?oVi^H2o`0000;oi^KV0_l00004onKViRgooooo0_l000000ooooooo0000o`00
000]ooooo`Goi^KV0_l000000ooVi^Ko0000o`000004onKViS3ooooo0_l0000Tooooo`002_ooool4
o`0000Gooooo0_l0000Wooooo`Coi^KV1_l00004onKViRgooooo1?l0000^ooooo`Goi^KV1_l00003
onKViRgooooo0_l000000ooooooo0000o`00000]ooooo`Goi^KV1?l00005onKViRSooooo00?o0000
ooooooooool00_ooool2o`0000;ooooo0_l0000Sooooo`002oooool2o`0000Sooooo0ol0000Uoooo
o`coi^KV00?o0000ooooooooool0;?ooool2o`00033ooooo3?oVi^H^ooooo`;o000000?oooooo`00
0?l00000;Oooool00ol0003oi^KVonKViP02onKViP;o00001_oVi^HVooooo`?o00001Oooool2o`00
00;ooooo0_l0000Sooooo`002_ooool3o`0000_ooooo0ol0000Sooooo`[oi^KV0_ooool2o`0002_o
oooo0ol00004ooooo`03o`000?oooooooooo02[ooooo2_oVi^H^ooooo`Go0000;?ooool2o`0000;o
oooo0_oVi^H3o`0000Goi^KV9?ooool3o`0000Wooooo1?l0000Tooooo`006oooool3o`00027ooooo
2?oVi^H5ooooo`;o0000<Oooool00ol0003oooooooooo`0Zooooo`Soi^KV;Oooool00ol0003ooooo
ooooo`0^ooooo`;o00001Oooool8onKViR;ooooo0ol0000dooooo`007_ooool3o`0001oooooo1_oV
i^H8ooooo`;o0000<?ooool00ol0003oooooooooo`0Zooooo`Koi^KV;Oooool00ol0003ooooooooo
o`0]ooooo`;o00002?ooool6onKViR3ooooo0ol0000gooooo`008Oooool3o`0002cooooo0_l0000_
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/
ooooo`;o0000;Oooool3o`0003[ooooo000Tooooo`?o0000:oooool2o`0002kooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo0_l0000/oooo
o`?o0000?Oooool002Oooooo0ol0000Zooooo`;o0000;Oooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool2o`0002_ooooo0ol00010ooooo`00
:_ooool3o`0002Wooooo0_l0000/ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`0Yooooo`;o0000:_ooool3o`0004?ooooo000]ooooo`?o0000:?oo
ool2o`0002_ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo02Sooooo0_l0000Yooooo`?o0000A_ooool0033ooooo0ol0000Wooooo`;o0000:_ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09oooool2
o`0002Sooooo0ol00019ooooo`00<oooool3o`0002Kooooo0ol0000Xooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`00
04cooooo000fooooo`?o00009_ooool2o`0002Oooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo0_l0000Vooooo`?o0000Coooool003Wooooo
0ol0000Uooooo`;o00009_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo
00?o0000ooooooooool09?ooool2o`0002Gooooo0ol0001Booooo`00??ooool3o`0002Cooooo0_l0
000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003ooooooooo
o`0Sooooo`;o00009?ooool3o`0005Gooooo000oooooo`?o00008oooool2o`0002Cooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo0_l0000S
ooooo`?o0000F?ooool004;ooooo0ol0000Rooooo`;o00008oooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Oooool2o`0002;ooooo0ol0001Koooo
o`00AOooool3o`00027ooooo0_l0000Rooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool08?ooool00ol0003oooooooooo`0Pooooo`;o00008Oooool3o`0005kooooo0018ooooo`?o0000
8?ooool2o`00027ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01oooooo0_l0000Pooooo`?o0000HOooool004_ooooo0ol0000Oooooo`;o00008?oo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_oo
ool2o`0001oooooo0ol0001Tooooo`00C_ooool3o`0001kooooo0_l0000Oooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`;o00007_ooool3
o`0006Oooooo001Aooooo`?o00007Oooool2o`0001kooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo0_l0000Mooooo`?o0000J_ooool005Co
oooo0ol0000Looooo`;o00007Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool06oooool2o`0001cooooo0ol0001]ooooo`00Eoooool3o`0001_ooooo
0_l0000Looooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0Jooooo`;o00006oooool3o`00073ooooo001Jooooo`?o00006_ooool2o`0001_ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0_l0
000Jooooo`?o0000Loooool005gooooo1?l0000Hooooo`;o00006_ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05oooool3o`0001Sooooo1?l0001f
ooooo`00HOooool3o`0001Oooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`0Fooooo`;o00006?ooool3o`0007[ooooo001Tooooo`?o
00005_ooool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Gooooo0_l0000Gooooo`?o0000OOooool006Oooooo0ol0000Eooooo`;o0000
5oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5?ooool2o`0001Kooooo0ol00020ooooo`00J_ooool3o`0001Cooooo0_l0000Fooooo`03o`000?oo
oooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Cooooo`;o00005Ooo
ool3o`0008?ooooo001]ooooo`?o00004oooool2o`0001Gooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo0_l0000Dooooo`?o0000Q_ooool0
073ooooo0ol0000Booooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool2o`0001?ooooo0ol00029ooooo`00Loooool3o`00017o
oooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0@ooooo`;o00004_ooool3o`0008cooooo001fooooo`?o00004?ooool2o`0001;ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo
0_l0000Aooooo`?o0000Soooool007Wooooo0ol0000?ooooo`;o00004Oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool2o`00013ooooo0ol0
002Booooo`00O?ooool3o`0000kooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`;o00003oooool3o`0009Gooooo001ooooo
o`?o00003Oooool2o`0000oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo0_l0000>ooooo`?o0000V?ooool008;ooooo0ol0000<ooooo`;o
00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool02oooool2o`0000gooooo0ol0002Kooooo`00QOooool3o`0000_ooooo0ol0000<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`;o0000
3?ooool3o`0009kooooo0028ooooo`?o00002oooool2o`0000_ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo0_l0000;ooooo`?o0000XOoo
ool008_ooooo0ol0000:ooooo`;o00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02?ooool2o`0000[ooooo0ol0002Tooooo`00S_ooool3o`00
00Wooooo0_l00009ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`07ooooo`;o00002Oooool3o`000:Oooooo002Aooooo`?o00002?ooool2o`0000So
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Ko
oooo0_l00008ooooo`?o0000Z_ooool009Cooooo0ol00007ooooo`;o00001oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool2o`0000Oooooo
0ol0002]ooooo`00Uoooool3o`0000Kooooo0_l00006ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`000;3ooooo002J
ooooo`?o00001Oooool2o`0000Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`?o0000/oooool009gooooo0ol00004oooo
o`;o00001?ooool00ol0003oooooooooo`06onKViP?ooooo00?o0000ooooooooool00_ooool2o`00
00Cooooo0ol0002fooooo`00X?ooool3o`0000?ooooo0_l00003ooooo`03o`000?oVi^Koi^KV00Ko
i^KV00?oooooo`000?ooool00_ooool2o`0000?ooooo0ol0002iooooo`00Xoooool3o`0000;ooooo
0_l000000oooooooi^KVonKViP08onKViP;ooooo0_l00002ooooo`?o0000_?ooool00:Kooooo0ol0
00000oooooooi^KVonKViP0:onKViP03o`000?oooooo000000;o0000_oooool00:Wooooo1?oVi^H6
o`0000Coi^KV00?o0000ooooooooool0`?ooool00:Wooooo1_oVi^H2o`0000Koi^KV`oooool00:Wo
oooo1_oVi^H2o`0000Koi^KV`oooool00:Wooooo1_oVi^H2o`0000Koi^KV`oooool00:Wooooo1OoV
i^H5o`0000Coi^KV`oooool00:Wooooo1_oVi^H2o`0000Koi^KV`oooool00:[ooooo1_oVi^H3o`00
00?oi^KVa?ooool00:_ooooo2_oVi^K5ooooo`00[?ooool8onKVi/Kooooo002]ooooo`Koi^KVaooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14969, -0.82718, \
0.0121928, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.459559 0.217875 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.10883 .30902 -5 -6 ]
[.10883 .30902 5 6 ]
[.14831 .30902 -5 -6 ]
[.14831 .30902 5 6 ]
[.14831 .16187 -5 -6 ]
[.14831 .16187 5 6 ]
[.18779 .30902 -5 -6 ]
[.18779 .30902 5 6 ]
[.14831 .45617 -5 -6 ]
[.14831 .45617 5 6 ]
[.27281 .45617 -5 -6 ]
[.27281 .45617 5 6 ]
[.35783 .30902 -5 -6 ]
[.35783 .30902 5 6 ]
[.38415 .30902 -5 -6 ]
[.38415 .30902 5 6 ]
[.41047 .30902 -5 -6 ]
[.41047 .30902 5 6 ]
[.43679 .30902 -5 -6 ]
[.43679 .30902 5 6 ]
[.27088 .01472 -5.0625 -6 ]
[.27088 .01472 5.0625 6 ]
[.60269 .01472 -5 -6 ]
[.60269 .01472 5 6 ]
[.43679 .16187 -5 -6 ]
[.43679 .16187 5 6 ]
[.39731 .45617 -5 -6 ]
[.39731 .45617 5 6 ]
[.52181 .45617 -5 -6 ]
[.52181 .45617 5 6 ]
[.64631 .45617 -5 -6 ]
[.64631 .45617 5 6 ]
[.73133 .30902 -5 -6 ]
[.73133 .30902 5 6 ]
[.75765 .30902 -5 -6 ]
[.75765 .30902 5 6 ]
[.78397 .30902 -5 -6 ]
[.78397 .30902 5 6 ]
[.81029 .30902 -5 -6 ]
[.81029 .30902 5 6 ]
[.64438 .01472 -5.0625 -6 ]
[.64438 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.81029 .16187 -5 -6 ]
[.81029 .16187 5 6 ]
[.77081 .45617 -5 -6 ]
[.77081 .45617 5 6 ]
[.89531 .45617 -5 -6 ]
[.89531 .45617 5 6 ]
[.45956 .60332 -5 -6 ]
[.45956 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.45956 .60332 m
.02381 .45617 L
s
.45956 .60332 m
.14831 .45617 L
s
.45956 .60332 m
.27281 .45617 L
s
.45956 .60332 m
.39731 .45617 L
s
.45956 .60332 m
.52181 .45617 L
s
.45956 .60332 m
.64631 .45617 L
s
.45956 .60332 m
.77081 .45617 L
s
.45956 .60332 m
.89531 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.14831 .45617 m
.10883 .30902 L
s
.14831 .45617 m
.14831 .30902 L
s
.14831 .45617 m
.18779 .30902 L
s
1 g
.04 w
.10883 .30902 Mdot
0 g
gsave
.10883 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.14831 .30902 m
.14831 .16187 L
s
.9 g
.04 w
.14831 .30902 Mdot
0 g
gsave
.14831 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.14831 .16187 Mdot
0 g
gsave
.14831 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.18779 .30902 Mdot
0 g
gsave
.18779 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.14831 .45617 Mdot
0 g
gsave
.14831 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.27281 .45617 Mdot
0 g
gsave
.27281 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.39731 .45617 m
.35783 .30902 L
s
.39731 .45617 m
.38415 .30902 L
s
.39731 .45617 m
.41047 .30902 L
s
.39731 .45617 m
.43679 .30902 L
s
1 g
.04 w
.35783 .30902 Mdot
0 g
gsave
.35783 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.38415 .30902 Mdot
0 g
gsave
.38415 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.41047 .30902 Mdot
0 g
gsave
.41047 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.43679 .30902 m
.43679 .16187 L
s
.9 g
.04 w
.43679 .30902 Mdot
0 g
gsave
.43679 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.43679 .16187 m
.27088 .01472 L
s
.43679 .16187 m
.60269 .01472 L
s
1 g
.04 w
.27088 .01472 Mdot
0 g
gsave
.27088 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.60269 .01472 Mdot
0 g
gsave
.60269 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.43679 .16187 Mdot
0 g
gsave
.43679 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.39731 .45617 Mdot
0 g
gsave
.39731 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.52181 .45617 Mdot
0 g
gsave
.52181 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.64631 .45617 Mdot
0 g
gsave
.64631 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.77081 .45617 m
.73133 .30902 L
s
.77081 .45617 m
.75765 .30902 L
s
.77081 .45617 m
.78397 .30902 L
s
.77081 .45617 m
.81029 .30902 L
s
1 g
.04 w
.73133 .30902 Mdot
0 g
gsave
.73133 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.75765 .30902 Mdot
0 g
gsave
.75765 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.78397 .30902 Mdot
0 g
gsave
.78397 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.81029 .30902 m
.81029 .16187 L
s
.9 g
.04 w
.81029 .30902 Mdot
0 g
gsave
.81029 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.81029 .16187 m
.64438 .01472 L
s
.81029 .16187 m
.97619 .01472 L
s
1 g
.04 w
.64438 .01472 Mdot
0 g
gsave
.64438 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.81029 .16187 Mdot
0 g
gsave
.81029 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.77081 .45617 Mdot
0 g
gsave
.77081 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.89531 .45617 Mdot
0 g
gsave
.89531 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.45956 .60332 Mdot
0 g
gsave
.45956 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00I?ooool7
o`0007Cooooo1Ol0000;ooooo`Oo0000M?ooool5o`0000_ooooo001Tooooo`;o00000_ooool2o`00
07Kooooo0_l000000ooooooo0000o`00000:ooooo`;o00000_ooool2o`0007Kooooo0_l000000ooo
oooo0000o`00000:ooooo`00I?ooool6o`0007Kooooo0_l000000ooooooo0000o`00000:ooooo`Ko
0000M_ooool2o`000003ooooool0003o000000[ooooo001Uooooo`Co0000Moooool4o`0000cooooo
1?l0001gooooo`Co00002oooool006Gooooo1?l0001gooooo`;o000000?oooooo`000?l000002ooo
ool4o`0007Oooooo0_l000000ooooooo0000o`00000:ooooo`00I_ooool2o`0007Sooooo0_l00000
0ooooooo0000o`00000<ooooo`;o0000N?ooool2o`000003ooooool0003o000000[ooooo001Uoooo
o`?o0000Moooool5o`0000cooooo0ol0001gooooo`Go00002oooool006gooooo00?o0000oooooooo
ool0K?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo06cooooo00?o0000oooooooo
ool04?ooool006kooooo00?o0000ooooooooool0J_ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo06[ooooo00?o0000ooooooooool04Oooool006oooooo00?o0000ooooooooool0J?oo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool04_oo
ool0073ooooo0_l0001Wooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0IOooool2
o`0001Gooooo001booooo`03o`000?oooooooooo06;ooooo0_l0000Sooooo`;o0000I?ooool00ol0
003oooooooooo`0Eooooo`00Loooool00ol0003oooooooooo`1Pooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0H?ooool00ol0003oooooooooo`0Fooooo`00M?ooool00ol0003ooooo
ooooo`1Nooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0G_ooool00ol0003ooooo
ooooo`0Gooooo`00MOooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0G?ooool00ol0003oooooooooo`0Hooooo`00M_ooool00ol0003oooooooooo`1J
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0I
ooooo`00Moooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0F?ooool00ol0003oooooooooo`0Jooooo`00N?ooool00ol0003oooooooooo`1Fooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`0Kooooo`00
NOooool2o`0005Gooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`1Cooooo`;o0000
7_ooool007_ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool07_ooool007cooooo00?o0000ooooooooool0C_ooool2
o`0003Oooooo0_l0001@ooooo`03o`000?oooooooooo01oooooo001mooooo`03o`000?oooooooooo
04cooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
023ooooo001nooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0>oooool00ol0003o
ooooooooo`1:ooooo`03o`000?oooooooooo027ooooo001oooooo`03o`000?oooooooooo04Sooooo
00?o0000ooooooooool0?Oooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo02;ooooo
0020ooooo`03o`000?oooooooooo04Kooooo00?o0000ooooooooool0?oooool00ol0003ooooooooo
o`16ooooo`03o`000?oooooooooo02?ooooo0021ooooo`03o`000?oooooooooo04Cooooo00?o0000
ooooooooool0@Oooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo02Cooooo0022oooo
o`;o0000@oooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo047ooooo0_l0000Woooo
o`00Q?ooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo04Gooooo00?o0000oooooooo
ool0?oooool00ol0003oooooooooo`0Wooooo`00QOooool00ol0003oooooooooo`0mooooo`03o`00
0?oooooooooo04Oooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0Xooooo`00Q_oo
ool00ol0003oooooooooo`0jooooo`;o0000Boooool2o`0003cooooo00?o0000ooooooooool0:Ooo
ool008Oooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooo
oooo03Sooooo00?o0000ooooooooool0:_ooool008Sooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`1?ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0:oooool008Wo
oooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo03Co
oooo00?o0000ooooooooool0;?ooool008[ooooo0_l0000cooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool0<Oooool2o`0002oooooo002<ooooo`03o`000?oooooooooo02oooooo00?o
0000ooooooooool0EOooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo002=
ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo033ooooo002>ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0FOooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo037ooooo002?ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo03;ooooo002@ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0
GOooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo03?ooooo002Aooooo`03o`000?oo
oooooooo02Cooooo0_l0001Qooooo`;o00009_ooool00ol0003oooooooooo`0dooooo`00T_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0eooooo`00Toooool2o`00027ooooo00?o0000ooooooooool0IOooool00ol0
003oooooooooo`0Oooooo`;o0000>?ooool009Gooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`1Wooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0>?ooool009Kooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool0>Oooool009Oooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`1[ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0>_ooool009Sooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0>oooool009Wooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`1_oooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0??ooool009[ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0?Oooool009_ooooo00?o0000ooooooooool04?ooool2o`0007Gooooo0_l0000Booooo`03o`00
0?oooooooooo03kooooo002Looooo`;o00003oooool00ol0003oooooooooo`1gooooo`03o`000?oo
oooooooo00gooooo0_l00011ooooo`00W_ooool01?l0003oooooooooooooool6onKViPCooooo00?o
0000ooooooooool0NOooool01?l0003oooooooooooooool6onKViPCooooo00?o0000ooooooooool0
@Oooool009oooooo00?o0000oooooooVi^H01ooVi^H2ooooo`03o`000?oooooooooo07_ooooo00?o
0000oooooooVi^H01ooVi^H2ooooo`03o`000?oooooooooo04;ooooo002Pooooo`[oi^KV00?o0000
ooooooooool0OOooool:onKViP03o`000?oooooooooo04?ooooo002Oooooo`Coi^KV1?l00004onKV
iWkooooo1?oVi^H4o`0000Coi^KVAOooool009kooooo2?oVi^H2o`0000Coi^KVO?ooool8onKViP;o
00001?oVi^I4ooooo`00>Oooool4o`00067ooooo1OoVi^H5o`0000Coi^KVO?ooool5onKViPGo0000
1?oVi^I4ooooo`00>_ooool2o`0006;ooooo1?oVi^H2o`0000;oi^KV0_l00004onKViWcooooo1?oV
i^H2o`0000;oi^KV0_l00004onKViTCooooo000gooooo`Ko0000HOooool4onKViP;o00000_oVi^H2
o`0000Coi^KVO?ooool4onKViP;o00000_oVi^H2o`0000Coi^KVA?ooool003Oooooo0_l000000ooo
oooo0000o`00001Rooooo`Coi^KV0_l00002onKViP;o00001?oVi^Ilooooo`Coi^KV0_l00002onKV
iP;o00001?oVi^I4ooooo`00>?ooool4o`0006;ooooo1OoVi^H6o`0000?oi^KVO?ooool5onKViPKo
00000ooVi^I4ooooo`00>Oooool3o`0006?ooooo3?oVi^Inooooo`coi^KVAOooool003[ooooo0_l0
001Tooooo`[oi^KVP?ooool:onKViTKooooo002Qooooo`Soi^KVP_ooool8onKViTOooooo002Roooo
o`Koi^KVQ?ooool6onKViTSooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000oooooooo
ool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03o`00
0?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0J?oo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oooooo
oooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0
003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[o
oooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04So
oooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003ooooo
ooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o
0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`27
ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000oooo
ooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03
o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0
J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oo
oooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool0
0ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool0
03[ooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo
04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003o
ooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo
00?o0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0J?ooool00ol0003ooooooooo
o`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000
ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xoooo
o`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000oooooooo
ool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`00
0?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_oo
ool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?oo
ool003[ooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooo
oooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0
003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oo
oooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0J?ooool00ol0003ooooo
ooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o
0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1X
ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000oooo
ooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03
o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00
>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0
B?ooool003[ooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oo
oooooooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool0
0ol0003oooooooooo`18ooooo`00>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo
08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000ooooooooool0J?ooool00ol0003o
ooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000jooooo`03o`000?oooooooooo06Sooooo
00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18ooooo`00>_ooool00ol0003ooooooooo
o`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0B?ooool003[ooooo00?o0000
ooooooooool0J?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo04Sooooo000joooo
o`03o`000?oooooooooo06Sooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`18oooo
o`00>_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo08Oooooo00?o0000oooooooo
ool0B?ooool003Oooooo1_oVi^IUooooo`Koi^KVQ?ooool6onKViTSooooo000fooooo`Soi^KVHooo
ool8onKViX;ooooo2?oVi^I7ooooo`00=Oooool3onKViPCo00000ooVi^IQooooo`?oi^KV1?l00003
onKViX3ooooo0ooVi^H4o`0000?oi^KVA_ooool003Cooooo1ooVi^H2o`0000?oi^KVGoooool7onKV
iP;o00000ooVi^Inooooo`Ooi^KV0_l00003onKViTGooooo000Xooooo`Go00001_ooool5onKViPGo
00001?oVi^H6ooooo`Co0000>oooool4o`0000Cooooo1Ol00005ooooo`Go000000?oooooonKVi_oV
i^H00ooVi^H5o`0000Coi^KVI?ooool4o`0000Gooooo1Ol00004ooooo`Go000000?oooooonKVi_oV
i^H00ooVi^H5o`0000Coi^KVA?ooool002Wooooo0_l000000ooooooo0000o`000005ooooo`Coi^KV
0_l00002onKViP;o00001?oVi^H5ooooo`;o00000_ooool2o`0003Wooooo00?o0000ooooool00000
1oooool2o`000003ooooool0003o000000Gooooo0_l000000ooooooo0000o`000004onKViP;o0000
0_oVi^H2o`0000Coi^KVHoooool00ol0003oooooo`000008ooooo`;o000000?oooooo`000?l00000
1?ooool2o`000003ooooool0003o000000Coi^KV0_l00002onKViP;o00001?oVi^I4ooooo`00:Ooo
ool2o`000003ooooool0003o000000Gooooo1?oVi^H2o`0000;oi^KV0_l00004onKViPWooooo0_l0
000iooooo`03o`000?oooooo000000;o00001Oooool2o`000003ooooool0003o000000Gooooo0_l0
00000ooooooo0000o`000004onKViP;o00000_oVi^H2o`0000Coi^KVHoooool00ol0003oooooo`00
0002o`0000Kooooo0_l000000ooooooo0000o`000004ooooo`;o000000?oooooo`000?l000001?oV
i^H2o`0000;oi^KV0_l00004onKViTCooooo000Yooooo`Co00001_ooool4onKViP;o00000_oVi^H2
o`0000Coi^KV1oooool3o`0003[ooooo00Go0000ooooool0003oooooo`000005ooooo`;o000000?o
ooooo`000?l000001Oooool4o`000003oooooooVi^Koi^KV00;oi^KV0_l00002onKViP;o00001?oV
i^ISooooo`05o`000?oooooo0000ooooool000001_ooool2o`000003ooooool0003o000000Cooooo
1?l000000oooooooi^KVonKViP02onKViP;o00000_oVi^H2o`0000Coi^KVA?ooool002Wooooo0_l0
00000ooooooo0000o`000005ooooo`Goi^KV1_l00003onKViPWooooo0_l0000jooooo`?o00001_oo
ool2o`000003ooooool0003o000000Gooooo0_l000000ooooooo0000o`000005onKViPKo00000ooV
i^ITooooo`?o00001oooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000o`00
0005onKViPKo00000ooVi^I4ooooo`00:Oooool2o`000003ooooool0003o000000Gooooo3_oVi^H5
ooooo`;o00000_ooool2o`0004?ooooo0_l000000ooooooo0000o`000005ooooo`;o000000?ooooo
o`000?l000003_oVi^I^ooooo`;o000000?oooooo`000?l000001?ooool2o`000003ooooool0003o
000000koi^KVA?ooool002Sooooo1Ol00007ooooo`coi^KV1oooool4o`0004?ooooo1Ol00005oooo
o`Go00000_ooool<onKViVkooooo1Ol00004ooooo`Go00000_ooool<onKViTGooooo000eooooo`[o
i^KVHOooool:onKViX3ooooo2_oVi^I6ooooo`00=_ooool8onKViV?ooooo2?oVi^J2ooooo`Soi^KV
Aoooool003Oooooo1_oVi^IUooooo`Koi^KVQ?ooool6onKViTSooooo000]ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`10ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo06kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0B_ooool002gooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0K_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`1:ooooo`00;_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1`ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04[o
oooo000^ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`12ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo073ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Boooool002kooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo04;ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0L?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`1;ooooo`00;_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1`
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo04_ooooo000_ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo07;ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0Boooool002oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo04Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0L_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1<ooooo`00
;oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
A?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo04cooooo000`ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`15ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo07Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0C?ooool0033ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0M?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`1<ooooo`00<?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1dooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
04gooooo000`ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`16ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo07Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0COooool0037ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0M_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`1=ooooo`00<Oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Aoooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`1fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo04gooooo000aooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo07Kooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0C_ooool0037ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo04Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1>oooo
o`00<_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0BOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1hooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04kooooo000booooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo07Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0C_ooool003;ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04[ooooo00Go0000oooooooooooooooo
o`000005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0N?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`1?ooooo`00<oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0Boooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1?ooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo04oooooo000cooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo07[ooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0Coooool003?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo04co
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0N_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`1@ooooo`00<oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0C?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo053ooooo000dooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1=ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000007kooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000D_ooool003Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04gooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000O_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00001Booooo`00=?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0C_ooool01?l0003ooooooooo
ool00003ooooo`05o`000?ooooooooooooooool00000O_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Co0000oooooooooooo0000Doooool003Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04kooooo00Co0000oooooooooooo00000oooool0
1Ol0003ooooooooooooooooo000007kooooo00Go0000ooooooooooooooooo`000002ooooo`05o`00
0?ooooooooooooooool00000Doooool003Gooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo04oooooo00Co0000oooooooooooo00000oooool01?l0003o
ooooooooool00020ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00
001Cooooo`00=Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0Coooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`00083ooooo
00Co0000oooooooooooo00000_ooool01Ol0003ooooooooooooooooo000005?ooooo000eooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1@ooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo0000P?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0005Cooooo000fooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`1Aooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003o
ooooooooo`20ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1B
ooooo`00=_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0DOooool0
1_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool0P?ooool01_l0003ooooo
ooooool0003oooooo`0000;ooooo00?o0000ooooooooool0D_ooool003Kooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo057ooooo00Ko0000oooooooooooo0000ooooool0
0002ooooo`03o`000?oooooooooo083ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03
o`000?oooooooooo05;ooooo000fooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Booooo`05o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`20oooo
o`08o`000?ooooooooooo`000?oooooo0000ooooool0001Eooooo`00=oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo05?ooooo00Oo0000ooooool0003oooooo`000?oooooo0000
08Cooooo00Oo0000ooooool0003oooooo`000?oooooo000005Gooooo000gooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool0Doooool01ol0003oooooo`000?oooooo0000ooooool0
0000Q?ooool01ol0003oooooo`000?oooooo0000ooooool00000EOooool003Oooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`1Cooooo`07o`000?oooooo0000ooooool0003ooooo
o`000024ooooo`07o`000?oooooo0000ooooool0003oooooo`00001Eooooo`00=oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo05Cooooo0_l000001?oooooo0000ooooool00024
ooooo`04o`000?oooooo0000ooooo`;o0000E_ooool003Sooooo00Go0000ooooool0003oooooo`00
001Gooooo`;o000000?oooooo`000?l00000Q_ooool2o`000003ooooool0003o000005Kooooo000g
ooooo`Koi^KVE_ooool6onKViXGooooo1_oVi^IFooooo`00=_ooool8onKViUCooooo2?oVi^J3oooo
o`Soi^KVEOooool003Gooooo2_oVi^IBooooo`[oi^KVPOooool:onKViUCooooo000dooooo`Coi^KV
1?l00004onKViU3ooooo3?oVi^Ioooooo`coi^KVDoooool003?ooooo2?oVi^H2o`0000Coi^KVC_oo
ool>onKViWgooooo3_oVi^IBooooo`002Oooool7o`0002?ooooo1OoVi^H5o`0000Coi^KV9?ooool5
o`0002Gooooo1?oVi^H7o`0000?oi^KV9?ooool6o`0002Sooooo1Ol0000Vooooo`Coi^KV1ol00003
onKViRCooooo1_l0000Xooooo`002Oooool2o`0000;ooooo0_l0000Tooooo`Coi^KV0_l00002onKV
iP;o00001?oVi^HUooooo`;o000000?oooooo`000?l000009?ooool5onKViP;o000000?oi^KVo`00
0?l000001?oVi^HUooooo`;o000000?oooooo`000?l00000:Oooool2o`000003ooooool0003o0000
02Gooooo1OoVi^H2o`000003onKVi_l0003o000000Coi^KV9Oooool2o`000003ooooool0003o0000
02Sooooo0009ooooo`Ko00009?ooool4onKViP;o00000_oVi^H2o`0000Coi^KV9Oooool2o`000003
ooooool0003o000002Cooooo1OoVi^H2o`000003onKVi_l0003o000000Coi^KV9_ooool2o`0002_o
oooo0_l000000ooooooo0000o`00000Uooooo`Goi^KV0_l000000ooVi^Ko0000o`000004onKViRKo
oooo0_l0000Zooooo`002_ooool4o`0002Gooooo1?oVi^H2o`0000;oi^KV0_l00004onKViRGooooo
0_l000000ooooooo0000o`00000Tooooo`Goi^KV0_l000000ooVi^Ko0000o`000004onKViROooooo
0_l0000Zooooo`;o000000?oooooo`000?l000009Oooool5onKViP;o000000?oi^KVo`000?l00000
1?oVi^HWooooo`;o0000:Oooool000[ooooo1?l00005ooooo`03o`000?oooooooooo01gooooo1OoV
i^H6o`0000?oi^KV9Oooool2o`000003ooooool0003o000002Cooooo1OoVi^H4o`0000Goi^KV9?oo
ool2o`0000;ooooo0_l0000Yooooo`;o000000?oooooo`000?l000009Oooool5onKViPCo00001OoV
i^HTooooo`;o00000_ooool2o`0002Sooooo000;ooooo`;o00001oooool3o`0001gooooo3?oVi^H2
o`0002Cooooo0_l000000ooooooo0000o`00000Uooooo`Coi^KV0_l00006onKViRGooooo0_l00002
ooooo`;o0000:Oooool2o`000003ooooool0003o000002Cooooo0_l00004onKViP;o00001_oVi^HN
ooooo`?o00001?ooool2o`0000;ooooo0_l0000Xooooo`002_ooool3o`0000[ooooo0ol0000Koooo
o`[oi^KV0oooool3o`00023ooooo1Ol00003ooooo`;o00008_ooool2onKViP?o00001OoVi^HWoooo
o`Co00009_ooool2o`000003ooooool0003o000000?o00008oooool2o`0000?ooooo0_oVi^H3o`00
00Goi^KV7?ooool3o`0000Sooooo1?l0000Yooooo`006_ooool3o`0001Wooooo2?oVi^H7ooooo`;o
0000:?ooool00ol0003oooooooooo`0Pooooo`Soi^KVDOooool00ol0003oooooooooo`0Wooooo`;o
00001_ooool8onKViQ[ooooo0ol0000hooooo`007Oooool3o`0001Oooooo1_oVi^H:ooooo`;o0000
9oooool00ol0003oooooooooo`0Pooooo`Koi^KVDOooool00ol0003oooooooooo`0Vooooo`;o0000
2Oooool6onKViQSooooo0ol0000kooooo`008?ooool3o`0002Kooooo0_l0000Vooooo`;o00009_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo0_l0000Wooooo`;o00009_oo
ool3o`0003kooooo000Sooooo`?o00009Oooool2o`0002Kooooo00?o0000ooooooooool08oooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool09Oooool2
o`0002Gooooo0ol00011ooooo`009_ooool3o`0002Cooooo0_l0000Uooooo`03o`000?oooooooooo
02?ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
02Cooooo0_l0000Tooooo`?o0000A?ooool002Wooooo0ol0000Sooooo`;o00009?ooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`0Rooooo`?o00008oooool3o`0004Oooooo000/ooooo`?o00008_ooool2o`0002?ooooo
0_l0000Rooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08?ooool2o`0002?ooooo
0_l0000Sooooo`?o0000B_ooool002oooooo0ol0000Qooooo`?o00008_ooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Qooooo`;o00008_ooool3o`0004gooooo000booooo`?o00008Oooool2o`00027ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool08?ooool2o`00027ooooo0ol0001@ooooo`00=Oooool3o`00023ooooo0_l0000Poooo
o`;o00008?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01kooooo0_l0000Qoooo
o`;o00008?ooool3o`0005?ooooo000hooooo`?o00007oooool2o`00023ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool07oooool2o`0001oooooo0ol0001Fooooo`00>oooool3o`0001kooooo0_l0000Oooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo01kooooo0_l0000Nooooo`?o0000FOooool003kooooo0ol0000Mooooo`;o00007_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Looooo`?o00007Oooool3o`0005cooooo0011ooooo`?o00007?ooool2
o`0001gooooo0_l0000Looooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool06_ooool2
o`0001gooooo0_l0000Mooooo`?o0000Goooool004Cooooo0ol0000Kooooo`?o00007?ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06_ooool00ol0
003oooooooooo`0Kooooo`;o00007?ooool3o`0006;ooooo0017ooooo`?o00006oooool2o`0001_o
oooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool06_ooool2o`0001_ooooo0ol0001Uooooo`00B_ooool3o`0001[ooooo
0_l0000Jooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`?o0000J?ooool004gooooo0ol0
000Iooooo`;o00006Oooool2o`0001Wooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`0Gooooo`;o00006_ooool2o`0001Wooooo0ol0001[ooooo`00D?ooool3o`0001Sooooo0_l0000I
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo01Sooooo0_l0000Hooooo`?o0000K_ooool005?ooooo0ol0000Goooo
o`;o00006?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`?o00005oooool3o`00077ooooo001Fooooo`?o
00005_ooool2o`0001Oooooo0_l0000Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool05?ooool2o`0001Oooooo0_l0000Gooooo`?o0000M?ooool005Wooooo0ol0000Eooooo`;o0000
5oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
5?ooool00ol0003oooooooooo`0Eooooo`;o00005_ooool3o`0007Oooooo001Looooo`?o00005?oo
ool3o`0001Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001jooooo`00Goooool3
o`0001Cooooo0_l0000Dooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0_l0000Dooooo`?o0000OOooool0
06;ooooo0ol0000Cooooo`;o00004oooool2o`0001?ooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Aooooo`;o00005?ooool2o`0001?ooooo0ol00020ooooo`00IOooool3o`0001;o
oooo0_l0000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0ol0000Booooo`?o0000Poooool006Sooooo
0ol0000Aooooo`;o00004_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o00004_ooool3o`0008Kooooo
001[ooooo`?o00004?ooool2o`00017ooooo0_l0000@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool03_ooool2o`00017ooooo0_l0000Aooooo`?o0000ROooool006kooooo0ol0000?
ooooo`;o00004Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`;o00004?ooool3o`0008cooooo001aoooo
o`?o00003_ooool2o`00013ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool2o`0000oooooo0ol0002?oooo
o`00M?ooool3o`0000gooooo0ol0000>ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo0_l0000>ooooo`?o
0000T_ooool007Oooooo0ol0000=ooooo`;o00003Oooool2o`0000gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0;ooooo`;o00003_ooool2o`0000gooooo0ol0002Eooooo`00N_oo
ool3o`0000cooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0ol0000<ooooo`?o0000V?oo
ool007gooooo0ol0000;ooooo`;o00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`;o00003?ooool3
o`0009_ooooo0020ooooo`?o00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool2o`00
00_ooooo0ol0002Nooooo`00Poooool3o`0000Wooooo0_l0000:ooooo`;o00002_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l0000:ooooo`;o00002_ooool3o`000:7o
oooo0026ooooo`?o00002?ooool2o`0000[ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool2o`0000Wooooo
0ol0002Tooooo`00ROooool3o`0000Oooooo0ol00008ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0_l0
0008ooooo`?o0000Yoooool008cooooo0ol00007ooooo`;o00001oooool2o`0000Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00002?ooool2o`0000Oooooo0ol0002Z
ooooo`00Soooool3o`0000Kooooo0_l00007ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo0ol00006oooo
o`?o0000[Oooool009;ooooo0ol00005ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`;o
00001_ooool3o`000;3ooooo002Eooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool2o`0000Gooooo0ol0002cooooo`00V?ooool3o`0000?ooooo0_l00004ooooo`;o00001?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o00001?oo
ool3o`000;Kooooo002Kooooo`?o00000_ooool2o`0000Cooooo00Co0000oooooooooooooooo1_oV
i^H01Ol0003ooooooooooooooooo000000Cooooo0_l00003ooooo`?o0000^Oooool009kooooo0ol0
00000ooooooo0000o`000003ooooo`03o`000?ooooooi^KV00Ooi^KV0_ooool01?l0003ooooooooo
ooooool2o`0000;ooooo0ol0002looooo`00XOooool6o`000003oooooooVi^Koi^KV00Soi^KV00?o
0000ooooooooool00_l000001?oooooo0000o`000?l0002oooooo`00Y?ooool3o`0000coi^KV1Ol0
0032ooooo`00Y_ooool4onKViPKo00001?oVi^H00ol0003oooooooooo`33ooooo`00Y_ooool6onKV
iP;o00001_oVi^K6ooooo`00Y_ooool6onKViP;o00001_oVi^K6ooooo`00Y_ooool6onKViP;o0000
1_oVi^K6ooooo`00Y_ooool5onKViPGo00001?oVi^K6ooooo`00Y_ooool6onKViP;o00001_oVi^K6
ooooo`00Yoooool6onKViP?o00000ooVi^K7ooooo`00Z?ooool:onKVi/Sooooo002Yooooo`Soi^KV
bOooool00:[ooooo1_oVi^K:ooooo`00\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.1521, -0.82718, \
0.0123893, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.21799 .30902 -5 -6 ]
[.21799 .30902 5 6 ]
[.21799 .16187 -5 -6 ]
[.21799 .16187 5 6 ]
[.24526 .30902 -5 -6 ]
[.24526 .30902 5 6 ]
[.27252 .30902 -5 -6 ]
[.27252 .30902 5 6 ]
[.29978 .30902 -5 -6 ]
[.29978 .30902 5 6 ]
[.29978 .16187 -5 -6 ]
[.29978 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.21799 .30902 L
s
.25889 .45617 m
.24526 .30902 L
s
.25889 .45617 m
.27252 .30902 L
s
.25889 .45617 m
.29978 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.21799 .30902 m
.21799 .16187 L
s
.9 g
.04 w
.21799 .30902 Mdot
0 g
gsave
.21799 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.21799 .16187 Mdot
0 g
gsave
.21799 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.24526 .30902 Mdot
0 g
gsave
.24526 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.27252 .30902 Mdot
0 g
gsave
.27252 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.29978 .30902 m
.29978 .16187 L
s
.9 g
.04 w
.29978 .30902 Mdot
0 g
gsave
.29978 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29978 .16187 Mdot
0 g
gsave
.29978 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007kooooo1Ol0000;ooooo`00iOooool2o`0000;ooooo0_l00020ooooo`;o000000?oooooo`00
0?l000002_ooool00>Gooooo1_l00020ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l00021ooooo`Co00002oooool00>Kooooo1?l00021ooooo`;o000000?oooooo`000?l000002_oo
ool00>Oooooo0_l00022ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol00021oooo
o`Go00002oooool00>kooooo0_l0001fooooo`;o00004_ooool00?3ooooo00?o0000ooooooooool0
L_ooool00ol0003oooooooooo`0Booooo`00lOooool00ol0003oooooooooo`1`ooooo`03o`000?oo
oooooooo01?ooooo003booooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool05?ooool0
0??ooooo00?o0000ooooooooool0Joooool2o`0001Oooooo003dooooo`;o0000J_ooool00ol0003o
ooooooooo`0Gooooo`00m_ooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01Sooooo
003gooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06Oooool00?Sooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0Jooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`;o00007Oooool00?[ooooo0_l0001Nooooo`03o`000?oooooooooo01gooooo003looooo`03o`00
0?oooooooooo05[ooooo00?o0000ooooooooool07_ooool00?gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`0Oooooo`00o_ooool00ol0003oooooooooo`1Eooooo`;o00008_ooool0
0?oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Rooooo`00ooooool1ooooo`;o
0000D_ooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo02Gooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool2o`0002Sooooo003ooooo
o`Kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0Xooooo`00ooooool7ooooo`;o
0000A_ooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`;o0000;Ooo
ool00?oooooo2oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02gooooo003ooooo
o`cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0^ooooo`00ooooool=ooooo`;o
0000>_ooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03Kooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`;o0000<ooo
ool00?oooooo4Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03?ooooo003ooooo
oa;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0dooooo`00oooooolCooooo`;o
0000;_ooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`;o0000>Ooo
ool00?oooooo5oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Wooooo003ooooo
oaSooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0jooooo`00oooooolIooooo`;o
00008_ooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
0_l0000nooooo`00oooooolLooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0?_oo
ool00?oooooo7Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03oooooo003ooooo
oakooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`10ooooo`00oooooolOooooo`;o
00005_ooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
0_l00014ooooo`00oooooolRooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A?oo
ool00?oooooo8oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16oooo
o`00oooooolUooooo`03o`000?oVi^Koi^KV00Soi^KV0_l00019ooooo`00oooooolUooooo`Coi^KV
1?l00004onKViT[ooooo003oooooobCooooo2?oVi^H2o`0000Coi^KVBOooool005?ooooo1?l0000J
ooooo`Co0000[_ooool5onKViPGo00001?oVi^I9ooooo`00E?ooool2o`0001cooooo0_l0002_oooo
o`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00DOooool6o`0001Sooooo1_l0002^ooooo`Co
i^KV0_l00002onKViP;o00001?oVi^I9ooooo`00DOooool2o`000003ooooool0003o000001Wooooo
0_l000000ooooooo0000o`00002_ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00D_oo
ool4o`0001[ooooo1?l0002_ooooo`Goi^KV1_l00003onKViTWooooo001Cooooo`?o00006oooool3
o`000;3ooooo3?oVi^I:ooooo`00E?ooool2o`0001cooooo0_l0002aooooo`[oi^KVBoooool00?oo
oooo9oooool8onKViTcooooo003oooooobSooooo1_oVi^I=ooooo`00E?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001Doooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=oooo
o`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000oooooooo
ool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`00
0?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Ooo
ool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001D
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=
ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000oooo
ooooool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03
o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo
001Dooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003ooooooooo
o`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000
ooooooooool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2eoooo
o`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Co
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04go
oooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003ooooo
ooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o
0000ooooooooool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2e
ooooo`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool005Cooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo04gooooo001Dooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`1=ooooo`00E?ooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0COooool0
05Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo
04gooooo001Dooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0]Oooool00ol0003o
ooooooooo`1=ooooo`00E?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0;Gooooo
00?o0000ooooooooool0COooool005Cooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`2eooooo`03o`000?oooooooooo04gooooo001Aooooo`Koi^KV6?ooool6onKVi[;ooooo1_oVi^I=
ooooo`00D?ooool8onKViQKooooo2?oVi^J`ooooo`Soi^KVC?ooool004oooooo0ooVi^H4o`0000?o
i^KV5?ooool3onKViPCo00000ooVi^J^ooooo`?oi^KV1?l00003onKViT_ooooo001>ooooo`Ooi^KV
0_l000000ooVi^Koooooooooo`0Booooo`Ooi^KV0_l000000ooVi^Koooooooooo`2/ooooo`Ooi^KV
0_l00003onKViT[ooooo0017ooooo`Go000000?oooooonKVi_oVi^H00ooVi^H5o`0000Gooooo1?l0
0005ooooo`Go000000?oooooonKVi_oVi^H00ooVi^H5o`0000Gooooo1?l0001hooooo`Co00003?oo
ool5o`0000_ooooo1Ol00008ooooo`Goi^KV1Ol00004onKViTWooooo0018ooooo`;o000000?ooooo
o`000?l000001?oVi^H2o`0000;oi^KV0_l00004ooooo`;o00000_ooool2o`0000Gooooo0_l00000
0ooooooo0000o`000004onKViP;o00000_oVi^H2o`0000Cooooo0_l00002ooooo`;o0000M_ooool0
0ol0003oooooo`00000?ooooo`;o000000?oooooo`000?l000002oooool2o`000003ooooool0003o
000000Oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo0018ooooo`;o000000?oooooo`00
0?l000001?oVi^H2o`0000;oi^KV0_l00008ooooo`;o00001Oooool2o`000003ooooool0003o0000
00Coi^KV0_l00002onKViP;o00002?ooool2o`0007Kooooo00?o0000ooooool000000_l0000=oooo
o`;o000000?oooooo`000?l000002oooool2o`000003ooooool0003o000000Oooooo1?oVi^H2o`00
00;oi^KV0_l00004onKViTWooooo0018ooooo`Co000000?oooooonKVi_oVi^H00_oVi^H2o`0000;o
i^KV0_l00006ooooo`?o00001_ooool4o`000003oooooooVi^Koi^KV00;oi^KV0_l00002onKViP;o
00001_ooool3o`0007Oooooo00Go0000ooooool0003oooooo`00000=ooooo`;o000000?oooooo`00
0?l000002oooool4o`0000Sooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo0018ooooo`;o
000000?oooooo`000?l000001OoVi^H5o`0000Sooooo0_l00005ooooo`;o000000?oooooo`000?l0
00001OoVi^H5o`0000Sooooo0_l0001gooooo`?o00003_ooool2o`000003ooooool0003o000000_o
oooo0_l000000ooooooo0000o`000007ooooo`Goi^KV1_l00003onKViTWooooo0018ooooo`;o0000
00?oooooo`000?l000002_oVi^H4ooooo`;o00000_ooool2o`0000Gooooo0_l000000ooooooo0000
o`00000:onKViPCooooo0_l00002ooooo`;o0000R?ooool2o`000003ooooool0003o000000_ooooo
0_l000000ooooooo0000o`000007ooooo`koi^KVBOooool004Oooooo1Ol00002ooooo`[oi^KV1?oo
ool4o`0000Gooooo1Ol00002ooooo`[oi^KV1?ooool4o`0008Sooooo1Ol0000;ooooo`Go00002Ooo
ool<onKViT[ooooo001?ooooo`[oi^KV5?ooool:onKViZkooooo2_oVi^I;ooooo`00D?ooool8onKV
iQKooooo2?oVi^J`ooooo`Soi^KVC?ooool004gooooo00Co0000oooooooooooooooo1_oVi^HHoooo
o`Koi^KVQ_ooool00ol0003oooooooooo`0Yooooo`Koi^KVCOooool004gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo07oooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0D?ooool004kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo087ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0DOooool004kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0DOoo
ool004oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo08?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0D_ooool004oooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo08?ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0D_ooool0053o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Go
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0Doooool0053ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo08Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Doooool0057ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Oooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0E?ooool0057ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0E?ooool005;ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0EOooool005;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo08Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0EOooool005;ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
EOooool005?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo08_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0E_ooool005?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo08_ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0E_ooool0
05Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
08gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0Eoooool005Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Eoooool005Gooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0F?ooool005Gooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0F?ooool005Kooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo097ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0FOooool005Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo097ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0FOooool005Oooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo09?ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0F_ooool005Oo
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo09?ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0F_ooool005Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
09?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0F_ooool005Sooooo00Go0000ooooooooooooooooo`000004oooo
o`05o`000?ooooooooooooooool000001?ooool01Ol0003ooooooooooooooooo000009Oooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0Foooool005Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo09Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0Foooool005Wooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000009Wooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool0G?ooool005Wooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000009Wooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0G?oo
ool005[ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Co0000oooooooooooo0000Voooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Mooooo`00F_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?oooooooooo
ooooool00000Voooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Mooooo`00Foooool01?l0003oooooooooool00002
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0002Mooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo05kooooo001Kooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0009gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0G_ooool005co
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooo`000002ooooo`04o`000?oooooooooo
o`0009oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o
0000ooooooooool0Goooool005cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooo`00
0002ooooo`04o`000?ooooooooooo`0009oooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool0Goooool005cooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`0009oooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0Goooool0
05gooooo00?o0000ooooool000000_ooool00ol0003oooooo`000002ooooo`03o`000?oooooo0000
0:7ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000H_oo
ool005gooooo00[o0000oooooooooooo0000ooooool0003oooooo`000?oooooo00000_ooool00ol0
003oooooooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000006;ooooo001Nooooo`0;o`000?oooooo0000ooooool0003oooooo`000?oooooo0000oooo
ool00000Xoooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001N
ooooo`0;o`000?oooooo0000ooooool0003oooooo`000?oooooo0000ooooool00000Xoooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001Oooooo`;o000000Gooooo
o`000?oooooo0000ooooo`02o`000:Gooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03
o`000?oooooooooo06;ooooo001Oooooo`05o`000?oooooo0000o`000?ooool00_l000000ooooooo
0000ooooo`2Tooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1R
ooooo`00H?ooool6onKViP03o`000?oooooooooo0:Gooooo1_oVi^H00ol0003oooooooooo`1Soooo
o`00Goooool8onKViZKooooo2?oVi^IUooooo`00G_ooool:onKViZCooooo2_oVi^ITooooo`00GOoo
ool4onKViPCo00001?oVi^JRooooo`coi^KVHoooool005cooooo2?oVi^H2o`0000Coi^KVX?ooool>
onKViV;ooooo0009ooooo`Oo0000C?ooool5onKViPGo00001?oVi^I=ooooo`Go0000C_ooool4onKV
iPOo00000ooVi^I=ooooo`Ko00003oooool000Wooooo0_l00002ooooo`;o0000COooool4onKViP;o
00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H2o`000003
onKVi_l0003o000000Coi^KVC_ooool2o`000003ooooool0003o000000oooooo0009ooooo`Ko0000
COooool4onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo
1OoVi^H2o`000003onKVi_l0003o000000Coi^KVCoooool2o`00017ooooo000:ooooo`Co0000C_oo
ool4onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoV
i^H2o`000003onKVi_l0003o000000Coi^KVD?ooool2o`00013ooooo000:ooooo`Co00001Oooool2
o`0004Oooooo1OoVi^H6o`0000?oi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H4
o`0000Goi^KVB?ooool00ol0003oooooooooo`02ooooo`;o00000_ooool2o`0000oooooo000;oooo
o`;o00002?ooool3o`0004Gooooo3?oVi^H00ol0003oooooooooo`1<ooooo`;o000000?oooooo`00
0?l00000C_ooool4onKViP;o00001_oVi^I6ooooo`?o00001Oooool2o`0000;ooooo0_l0000?oooo
o`002_ooool3o`0000_ooooo1?l00012ooooo`[oi^KV0_ooool00ol0003oooooooooo`1:ooooo`Go
0000C_ooool01?l0003oooooonKVi_oVi^H3o`0000Goi^KV@oooool4o`0000Wooooo1?l0000@oooo
o`007?ooool3o`00043ooooo2?oVi^H4ooooo`;o0000Voooool2o`0000?ooooo2?oVi^I1ooooo`?o
00008Oooool001oooooo0ol0000nooooo`Koi^KV1oooool00ol0003oooooooooo`2Gooooo`03o`00
0?oooooooooo00Cooooo1_oVi^Hoooooo`?o00009?ooool002;ooooo0ol00019ooooo`;o0000B_oo
ool00ol0003oooooooooo`18ooooo`;o0000BOooool3o`0002Oooooo000Uooooo`?o0000B?ooool2
o`0004Sooooo00?o0000ooooooooool0A_ooool2o`0004Sooooo0ol0000Zooooo`00:?ooool4o`00
04Kooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo
04Cooooo1?l0000]ooooo`00;?ooool3o`0004Cooooo0_l00015ooooo`03o`000?oooooooooo04?o
oooo0_l00014ooooo`?o0000<Oooool002oooooo0ol00013ooooo`;o0000@oooool00ol0003ooooo
ooooo`11ooooo`;o0000@oooool3o`0003Cooooo000booooo`?o0000@_ooool00ol0003ooooooooo
o`10ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool3o`0003Oooooo000e
ooooo`Co0000?oooool2o`00043ooooo00?o0000ooooooooool0?_ooool2o`0003oooooo1?l0000j
ooooo`00>Oooool3o`0003kooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0moooo
o`03o`000?oooooooooo03cooooo0ol0000nooooo`00??ooool3o`0003cooooo0_l0000mooooo`03
o`000?oooooooooo03_ooooo0_l0000looooo`?o0000@Oooool003oooooo0ol0000kooooo`;o0000
>oooool00ol0003oooooooooo`0iooooo`;o0000>oooool3o`0004Cooooo0012ooooo`?o0000>_oo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?oo
ool3o`0004Oooooo0015ooooo`Co0000=oooool2o`0003Sooooo00?o0000ooooooooool0=_ooool2
o`0003Oooooo1?l0001:ooooo`00BOooool3o`0003Kooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo03Cooooo0ol0001>ooooo`00C?ooool3o`0003Co
oooo0_l0000eooooo`03o`000?oooooooooo03?ooooo0_l0000dooooo`?o0000DOooool004oooooo
0ol0000cooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`;o0000<oooool3o`0005Cooooo
001Booooo`Co0000<Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0;oooool4o`0005Oooooo001Fooooo`?o0000;oooool2o`00033ooooo00?o0000
ooooooooool0;_ooool2o`0002oooooo0ol0001Kooooo`00FOooool3o`0002kooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo0ol0001Noooo
o`00G?ooool3o`0002cooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo0_l0000/ooooo`?o
0000HOooool005oooooo0ol0000[ooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`;o0000
:oooool3o`0006Cooooo001Rooooo`Co0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool09oooool4o`0006Oooooo001Vooooo`?o00009oooool2
o`0002Sooooo00?o0000ooooooooool09_ooool2o`0002Oooooo0ol0001[ooooo`00JOooool3o`00
02Kooooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo0_l0000Vooooo`?o0000K_ooool006co
oooo0ol0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Sooooo`?o0000LOooool006oooooo1?l0000Rooooo`;o00008oooool00ol0003ooooo
ooooo`0Qooooo`;o00008_ooool4o`0007Cooooo001cooooo`?o00008Oooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool3o`0007Sooooo001f
ooooo`?o00007oooool2o`00023ooooo00?o0000ooooooooool07_ooool2o`0001oooooo0ol0001k
ooooo`00NOooool3o`0001kooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo0_l0000Noooo
o`?o0000O_ooool007cooooo0ol0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0Kooooo`?o0000POooool007oooooo1?l0000Jooooo`;o0000
6oooool00ol0003oooooooooo`0Iooooo`;o00006_ooool4o`0008Cooooo0023ooooo`?o00006Ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05ooo
ool3o`0008Sooooo0026ooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool2
o`0001Oooooo0ol0002;ooooo`00ROooool3o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo
01Cooooo0_l0000Fooooo`?o0000S_ooool008cooooo1?l0000Dooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`Co0000TOooool0093ooooo
0ol0000Booooo`;o00004oooool00ol0003oooooooooo`0Aooooo`;o00004_ooool3o`0009Gooooo
002Cooooo`?o00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool03oooool3o`0009Sooooo002Fooooo`?o00003oooool2o`00013ooooo00?o0000
ooooooooool03_ooool2o`0000oooooo0ol0002Kooooo`00VOooool3o`0000kooooo0_l0000>oooo
o`03o`000?oooooooooo00cooooo0_l0000>ooooo`?o0000W_ooool009cooooo1?l0000<ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`Co
0000XOooool00:3ooooo0ol0000:ooooo`;o00002oooool00ol0003oooooooooo`09ooooo`;o0000
2_ooool3o`000:Gooooo002Sooooo`?o00002Oooool2o`0000Wooooo00?o0000ooooooooool01ooo
ool2o`0000Wooooo0ol0002Xooooo`00Y_ooool3o`0000Sooooo00?o0000ooooooooool00oooool6
onKViPKooooo00?o0000ooooooooool01_ooool3o`000:_ooooo002Yooooo`Co00001Oooool2o`00
00;ooooo2?oVi^H3ooooo`;o00001Oooool4o`000:kooooo002]ooooo`?o00001?ooool00ol0003o
i^KVonKViP08onKViP03ooooool0003ooooo00?ooooo0ol0002booooo`00/?ooool3o`000003oooo
oooVi^Koi^KV00[oi^KV0_ooool3o`000;Gooooo002cooooo`Coi^KV1_l00004onKViP03o`000?oo
oooooooo0;Kooooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Koi^KV0_l00006onKV
i[Wooooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Goi^KV1Ol00004onKVi[Wooooo
002cooooo`Koi^KV0_l00006onKVi[Wooooo002dooooo`Koi^KV0ol00003onKVi[[ooooo002eoooo
o`[oi^KV^oooool00;Kooooo2?oVi^Jlooooo`00]oooool6onKVi[gooooo0000\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.69496 .30902 -5 -6 ]
[.69496 .30902 5 6 ]
[.72904 .30902 -5 -6 ]
[.72904 .30902 5 6 ]
[.76311 .30902 -5 -6 ]
[.76311 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.69496 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.76311 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.69496 .30902 Mdot
0 g
gsave
.69496 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.72904 .30902 Mdot
0 g
gsave
.72904 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.76311 .30902 Mdot
0 g
gsave
.76311 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007kooooo1Ol0000;ooooo`00iOooool2o`0000;ooooo0_l00020ooooo`;o000000?oooooo`00
0?l000002_ooool00>Gooooo1_l00020ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l00021ooooo`Co00002oooool00>Kooooo1?l00021ooooo`;o000000?oooooo`000?l000002_oo
ool00>Oooooo0_l00022ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol00021oooo
o`Go00002oooool00>kooooo0_l0001fooooo`;o00004_ooool00?3ooooo00?o0000ooooooooool0
L_ooool00ol0003oooooooooo`0Booooo`00lOooool00ol0003oooooooooo`1`ooooo`03o`000?oo
oooooooo01?ooooo003booooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool05?ooool0
0??ooooo00?o0000ooooooooool0Joooool2o`0001Oooooo003dooooo`;o0000J_ooool00ol0003o
ooooooooo`0Gooooo`00m_ooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01Sooooo
003gooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06Oooool00?Sooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0Jooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`;o00007Oooool00?[ooooo0_l0001Nooooo`03o`000?oooooooooo01gooooo003looooo`03o`00
0?oooooooooo05[ooooo00?o0000ooooooooool07_ooool00?gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`0Oooooo`00o_ooool00ol0003oooooooooo`1Eooooo`;o00008_ooool0
0?oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Rooooo`00ooooool1ooooo`;o
0000D_ooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo02Gooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool2o`0002Sooooo003ooooo
o`Kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0Xooooo`00ooooool7ooooo`;o
0000A_ooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`;o0000;Ooo
ool00?oooooo2oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02gooooo003ooooo
o`cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0^ooooo`00ooooool=ooooo`;o
0000>_ooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03Kooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`;o0000<ooo
ool00?oooooo4Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03?ooooo003ooooo
oa;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0dooooo`00oooooolCooooo`;o
0000;_ooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`;o0000>Ooo
ool00?oooooo5oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Wooooo003ooooo
oaSooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0jooooo`00oooooolIooooo`;o
00008_ooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
0_l0000nooooo`00oooooolLooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0?_oo
ool00?oooooo7Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03oooooo003ooooo
oakooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`10ooooo`00oooooolOooooo`;o
00005_ooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
0_l00014ooooo`00oooooolRooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A?oo
ool00?oooooo8oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16oooo
o`00oooooolUooooo`03o`000?oVi^Koi^KV00Soi^KV0_l00019ooooo`00oooooolUooooo`Coi^KV
1?l00004onKViT[ooooo003oooooobCooooo2?oVi^H2o`0000Coi^KVBOooool006;ooooo1?l0002m
ooooo`Goi^KV1Ol00004onKViTWooooo001Sooooo`;o0000__ooool4onKViP;o00000_oVi^H2o`00
00Coi^KVBOooool0063ooooo1_l0002mooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00
H?ooool2o`000003ooooool0003o00000;kooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo
001Qooooo`Co0000__ooool5onKViPKo00000ooVi^I9ooooo`00H_ooool3o`000;oooooo3?oVi^I:
ooooo`00Hoooool2o`000<3ooooo2_oVi^I;ooooo`00oooooolWooooo`Soi^KVC?ooool00?oooooo
:?ooool6onKViTgooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COoo
ool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0
003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Co
oooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003ooooo
ooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001S
ooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooo
ooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03
o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0
COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool0
0ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo
0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003o
ooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo
001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000
ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34oooo
o`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000oooooooo
ool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hooo
ool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooo
oooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0
003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04go
oooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o
0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34
ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000oooo
ooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00
Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oo
oooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool0
0ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo
04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo
00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooooooo
o`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000
ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=oooo
o`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`00
0?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?oo
ool00ol0003oooooooooo`1=ooooo`00H?ooool6onKVi/7ooooo1_oVi^I=ooooo`00Goooool8onKV
i[oooooo2?oVi^I<ooooo`00G_ooool3onKViPCo00000ooVi^Jmooooo`?oi^KV1?l00003onKViT_o
oooo001Mooooo`Ooi^KV0_l00003onKVi[_ooooo1ooVi^H2o`0000?oi^KVB_ooool004Oooooo1Ol0
000@ooooo`Goi^KV1Ol00004onKViQ3ooooo1?l0001hooooo`Co00001oooool5o`0000Sooooo1Ol0
0008ooooo`Go00000oooool5onKViPGo00001?oVi^I9ooooo`00B?ooool2o`000003ooooool0003o
000000oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViPoooooo0_l00002ooooo`;o0000M_ooool0
0ol0003oooooo`00000:ooooo`;o000000?oooooo`000?l000002?ooool2o`000003ooooool0003o
000000Sooooo0_l000000ooooooo0000o`000002ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9
ooooo`00B?ooool2o`000003ooooool0003o000000oooooo1?oVi^H2o`0000;oi^KV0_l00004onKV
iQ?ooooo0_l0001fooooo`03o`000?oooooo000000;o00002?ooool2o`000003ooooool0003o0000
00Sooooo0_l000000ooooooo0000o`000008ooooo`;o000000?oooooo`000?l000000_ooool4onKV
iP;o00000_oVi^H2o`0000Coi^KVBOooool004Sooooo1?l0000@ooooo`Coi^KV0_l00002onKViP;o
00001?oVi^HAooooo`?o0000Moooool01Ol0003oooooo`000?oooooo000000Sooooo0_l000000ooo
oooo0000o`000008ooooo`Co00002Oooool4o`0000?ooooo1?oVi^H2o`0000;oi^KV0_l00004onKV
iTWooooo0018ooooo`;o000000?oooooo`000?l000003oooool5onKViPKo00000ooVi^HCooooo`;o
0000Moooool3o`0000Wooooo0_l000000ooooooo0000o`000008ooooo`;o000000?oooooo`000?l0
00002?ooool2o`000003ooooool0003o000000;ooooo1OoVi^H6o`0000?oi^KVBOooool004Sooooo
0_l000000ooooooo0000o`00000?ooooo`koi^KV3oooool2o`0000;ooooo0_l00023ooooo`;o0000
00?oooooo`000?l000002?ooool2o`000003ooooool0003o000000Sooooo0_l000000ooooooo0000
o`000002ooooo`koi^KVBOooool004Oooooo1Ol0000Aooooo`coi^KV4Oooool4o`0008?ooooo1Ol0
0008ooooo`Go00002?ooool5o`0000Cooooo3?oVi^I:ooooo`00G_ooool:onKVi[gooooo2_oVi^I;
ooooo`00Goooool8onKVi[oooooo2?oVi^I<ooooo`00COooool00ol0003oooooooooo`0@ooooo`Ko
i^KVUOooool00ol0003oooooooooo`0Yooooo`Koi^KVCOooool004gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`1@ooooo`00C_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo057ooooo001>ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`21ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0DOooool0
04oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
08?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Booooo`00Coooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Poooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo05;ooooo001@ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Doooool0053ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo08Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`1Cooooo`00DOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool0Qoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Cooooo001Aoooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`27oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0E?ooool005;ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo08Wooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`1Eooooo`00D_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo05Gooooo001Booooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0EOoo
ool005?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo08_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Fooooo`00Doooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Roooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05Kooooo001Dooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0Eoooool005Cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`1Gooooo`00EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05Sooooo001E
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0F?ooool005Kooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo097ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Iooooo`00E_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo05Wooooo001Gooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
F_ooool005Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo09?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Jooooo`00Eoooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Toooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo05[ooooo001Hooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0Foooool005Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`1Kooooo`00FOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0Uoooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05cooooo
001Iooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`2Gooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0G?ooool005[ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo09Wooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`00001Oooooo`00F_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0VOooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000005oooooo001Kooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Kooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0G_ooool005_o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo09_o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`1Nooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0WOooool01?l0003oooooooooool00003ooooo`05o`000?oooooo
ooooooooool000000_ooool00ol0003oooooooooo`1Oooooo`00G?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0WOooool01?l0003oooooooooool0
0003ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`1Oooooo`00G?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0WOoo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`1Oooooo`00GOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0Woooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0H?ooool005gooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo09oooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo063ooooo001Nooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Qooooo`03o`000?oooooo0000
00;ooooo00Ko0000oooooooooooo0000ooooool0001Sooooo`00G_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0XOooool02?l0003oooooooooool0
003oooooo`000?oooooo00000_ooool00ol0003oooooooooo`1Qooooo`00Goooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool0Xoooool02Ol0003oooooo`000?oooooo0000
ooooool0003oooooo`00001Tooooo`00Goooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0Xoooool02Ol0003oooooo`000?oooooo0000ooooool0003oooooo`00001Toooo
o`00H?ooool6onKViP03o`000?oooooooooo0:Gooooo1_oVi^H00ol0003oooooooooo`1Sooooo`00
Goooool8onKViZKooooo2?oVi^IUooooo`00G_ooool:onKViZCooooo2_oVi^ITooooo`00GOooool4
onKViPCo00001?oVi^JRooooo`coi^KVHoooool005cooooo2?oVi^H2o`0000Coi^KVX?ooool>onKV
iV;ooooo0009ooooo`Oo0000C?ooool5onKViPGo00001?oVi^I=ooooo`Go0000C_ooool4onKViPOo
00000ooVi^I=ooooo`Ko00003oooool000Wooooo0_l00002ooooo`;o0000COooool4onKViP;o0000
0_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H2o`000003onKV
i_l0003o000000Coi^KVC_ooool2o`000003ooooool0003o000000oooooo0009ooooo`Ko0000COoo
ool4onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoV
i^H2o`000003onKVi_l0003o000000Coi^KVCoooool2o`00017ooooo000:ooooo`Co0000C_ooool4
onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H2
o`000003onKVi_l0003o000000Coi^KVD?ooool2o`00013ooooo000:ooooo`Co00001Oooool2o`00
04Oooooo1OoVi^H6o`0000?oi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H4o`00
00Goi^KVB?ooool00ol0003oooooooooo`02ooooo`;o00000_ooool2o`0000oooooo000;ooooo`;o
00002?ooool3o`0004Gooooo3?oVi^H00ol0003oooooooooo`1<ooooo`;o000000?oooooo`000?l0
0000C_ooool4onKViP;o00001_oVi^I6ooooo`?o00001Oooool2o`0000;ooooo0_l0000?ooooo`00
2_ooool3o`0000_ooooo1?l00012ooooo`[oi^KV0_ooool00ol0003oooooooooo`1:ooooo`Go0000
C_ooool01?l0003oooooonKVi_oVi^H3o`0000Goi^KV@oooool4o`0000Wooooo1?l0000@ooooo`00
7?ooool3o`00043ooooo2?oVi^H4ooooo`;o0000Voooool2o`0000?ooooo2?oVi^I1ooooo`?o0000
8Oooool001oooooo0ol0000nooooo`Koi^KV1oooool00ol0003oooooooooo`2Gooooo`03o`000?oo
oooooooo00Cooooo1_oVi^Hoooooo`?o00009?ooool002;ooooo0ol00019ooooo`;o0000B_ooool0
0ol0003oooooooooo`18ooooo`;o0000BOooool3o`0002Oooooo000Uooooo`?o0000B?ooool2o`00
04Sooooo00?o0000ooooooooool0A_ooool2o`0004Sooooo0ol0000Zooooo`00:?ooool4o`0004Ko
oooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Co
oooo1?l0000]ooooo`00;?ooool3o`0004Cooooo0_l00015ooooo`03o`000?oooooooooo04?ooooo
0_l00014ooooo`?o0000<Oooool002oooooo0ol00013ooooo`;o0000@oooool00ol0003ooooooooo
o`11ooooo`;o0000@oooool3o`0003Cooooo000booooo`?o0000@_ooool00ol0003oooooooooo`10
ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool3o`0003Oooooo000eoooo
o`Co0000?oooool2o`00043ooooo00?o0000ooooooooool0?_ooool2o`0003oooooo1?l0000joooo
o`00>Oooool3o`0003kooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0mooooo`03
o`000?oooooooooo03cooooo0ol0000nooooo`00??ooool3o`0003cooooo0_l0000mooooo`03o`00
0?oooooooooo03_ooooo0_l0000looooo`?o0000@Oooool003oooooo0ol0000kooooo`;o0000>ooo
ool00ol0003oooooooooo`0iooooo`;o0000>oooool3o`0004Cooooo0012ooooo`?o0000>_ooool0
0ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool3
o`0004Oooooo0015ooooo`Co0000=oooool2o`0003Sooooo00?o0000ooooooooool0=_ooool2o`00
03Oooooo1?l0001:ooooo`00BOooool3o`0003Kooooo00?o0000ooooooooool0=Oooool00ol0003o
ooooooooo`0eooooo`03o`000?oooooooooo03Cooooo0ol0001>ooooo`00C?ooool3o`0003Cooooo
0_l0000eooooo`03o`000?oooooooooo03?ooooo0_l0000dooooo`?o0000DOooool004oooooo0ol0
000cooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`;o0000<oooool3o`0005Cooooo001B
ooooo`Co0000<Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool0;oooool4o`0005Oooooo001Fooooo`?o0000;oooool2o`00033ooooo00?o0000oooo
ooooool0;_ooool2o`0002oooooo0ol0001Kooooo`00FOooool3o`0002kooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo0ol0001Nooooo`00
G?ooool3o`0002cooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo0_l0000/ooooo`?o0000
HOooool005oooooo0ol0000[ooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`;o0000:ooo
ool3o`0006Cooooo001Rooooo`Co0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooo
oooo02Sooooo00?o0000ooooooooool09oooool4o`0006Oooooo001Vooooo`?o00009oooool2o`00
02Sooooo00?o0000ooooooooool09_ooool2o`0002Oooooo0ol0001[ooooo`00JOooool3o`0002Ko
oooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo0_l0000Vooooo`?o0000K_ooool006cooooo
0ol0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`0Sooooo`?o0000LOooool006oooooo1?l0000Rooooo`;o00008oooool00ol0003ooooooooo
o`0Qooooo`;o00008_ooool4o`0007Cooooo001cooooo`?o00008Oooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool3o`0007Sooooo001foooo
o`?o00007oooool2o`00023ooooo00?o0000ooooooooool07_ooool2o`0001oooooo0ol0001koooo
o`00NOooool3o`0001kooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo0_l0000Nooooo`?o
0000O_ooool007cooooo0ol0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0Kooooo`?o0000POooool007oooooo1?l0000Jooooo`;o00006ooo
ool00ol0003oooooooooo`0Iooooo`;o00006_ooool4o`0008Cooooo0023ooooo`?o00006Oooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05oooool3
o`0008Sooooo0026ooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool2o`00
01Oooooo0ol0002;ooooo`00ROooool3o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo01Co
oooo0_l0000Fooooo`?o0000S_ooool008cooooo1?l0000Dooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`Co0000TOooool0093ooooo0ol0
000Booooo`;o00004oooool00ol0003oooooooooo`0Aooooo`;o00004_ooool3o`0009Gooooo002C
ooooo`?o00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool03oooool3o`0009Sooooo002Fooooo`?o00003oooool2o`00013ooooo00?o0000oooo
ooooool03_ooool2o`0000oooooo0ol0002Kooooo`00VOooool3o`0000kooooo0_l0000>ooooo`03
o`000?oooooooooo00cooooo0_l0000>ooooo`?o0000W_ooool009cooooo1?l0000<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`Co0000
XOooool00:3ooooo0ol0000:ooooo`;o00002oooool00ol0003oooooooooo`09ooooo`;o00002_oo
ool3o`000:Gooooo002Sooooo`?o00002Oooool2o`0000Wooooo00?o0000ooooooooool01oooool2
o`0000Wooooo0ol0002Xooooo`00Y_ooool3o`0000Sooooo00?o0000ooooooooool00oooool6onKV
iPKooooo00?o0000ooooooooool01_ooool3o`000:_ooooo002Yooooo`Co00001Oooool2o`0000;o
oooo2?oVi^H3ooooo`;o00001Oooool4o`000:kooooo002]ooooo`?o00001?ooool00ol0003oi^KV
onKViP08onKViP03ooooool0003ooooo00?ooooo0ol0002booooo`00/?ooool3o`000003oooooooV
i^Koi^KV00[oi^KV0_ooool3o`000;Gooooo002cooooo`Coi^KV1_l00004onKViP03o`000?oooooo
oooo0;Kooooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Koi^KV0_l00006onKVi[Wo
oooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Goi^KV1Ol00004onKVi[Wooooo002c
ooooo`Koi^KV0_l00006onKVi[Wooooo002dooooo`Koi^KV0ol00003onKVi[[ooooo002eooooo`[o
i^KV^oooool00;Kooooo2?oVi^Jlooooo`00]oooool6onKVi[gooooo0000\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.69496 .30902 -5 -6 ]
[.69496 .30902 5 6 ]
[.72904 .30902 -5 -6 ]
[.72904 .30902 5 6 ]
[.76311 .30902 -5 -6 ]
[.76311 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.69496 .30902 L
s
.72904 .45617 m
.72904 .30902 L
s
.72904 .45617 m
.76311 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.69496 .30902 Mdot
0 g
gsave
.69496 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.72904 .30902 Mdot
0 g
gsave
.72904 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.76311 .30902 Mdot
0 g
gsave
.76311 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007kooooo1Ol0000;ooooo`00iOooool2o`0000;ooooo0_l00020ooooo`;o000000?oooooo`00
0?l000002_ooool00>Gooooo1_l00020ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l00021ooooo`Co00002oooool00>Kooooo1?l00021ooooo`;o000000?oooooo`000?l000002_oo
ool00>Oooooo0_l00022ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol00021oooo
o`Go00002oooool00>kooooo0_l0001fooooo`;o00004_ooool00?3ooooo00?o0000ooooooooool0
L_ooool00ol0003oooooooooo`0Booooo`00lOooool00ol0003oooooooooo`1`ooooo`03o`000?oo
oooooooo01?ooooo003booooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool05?ooool0
0??ooooo00?o0000ooooooooool0Joooool2o`0001Oooooo003dooooo`;o0000J_ooool00ol0003o
ooooooooo`0Gooooo`00m_ooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01Sooooo
003gooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06Oooool00?Sooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0Jooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`;o00007Oooool00?[ooooo0_l0001Nooooo`03o`000?oooooooooo01gooooo003looooo`03o`00
0?oooooooooo05[ooooo00?o0000ooooooooool07_ooool00?gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`0Oooooo`00o_ooool00ol0003oooooooooo`1Eooooo`;o00008_ooool0
0?oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Rooooo`00ooooool1ooooo`;o
0000D_ooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo02Gooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool2o`0002Sooooo003ooooo
o`Kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0Xooooo`00ooooool7ooooo`;o
0000A_ooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`;o0000;Ooo
ool00?oooooo2oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02gooooo003ooooo
o`cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0^ooooo`00ooooool=ooooo`;o
0000>_ooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03Kooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`;o0000<ooo
ool00?oooooo4Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03?ooooo003ooooo
oa;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0dooooo`00oooooolCooooo`;o
0000;_ooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`;o0000>Ooo
ool00?oooooo5oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Wooooo003ooooo
oaSooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0jooooo`00oooooolIooooo`;o
00008_ooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
0_l0000nooooo`00oooooolLooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0?_oo
ool00?oooooo7Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03oooooo003ooooo
oakooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`10ooooo`00oooooolOooooo`;o
00005_ooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
0_l00014ooooo`00oooooolRooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A?oo
ool00?oooooo8oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16oooo
o`00oooooolUooooo`03o`000?oVi^Koi^KV00Soi^KV0_l00019ooooo`00oooooolUooooo`Coi^KV
1?l00004onKViT[ooooo003oooooobCooooo2?oVi^H2o`0000Coi^KVBOooool006;ooooo1?l0002m
ooooo`Goi^KV1Ol00004onKViTWooooo001Sooooo`;o0000__ooool4onKViP;o00000_oVi^H2o`00
00Coi^KVBOooool0063ooooo1_l0002mooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00
H?ooool2o`000003ooooool0003o00000;kooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo
001Qooooo`Co0000__ooool5onKViPKo00000ooVi^I9ooooo`00H_ooool3o`000;oooooo3?oVi^I:
ooooo`00Hoooool2o`000<3ooooo2_oVi^I;ooooo`00oooooolWooooo`Soi^KVC?ooool00?oooooo
:?ooool6onKViTgooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COoo
ool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0
003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Co
oooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003ooooo
ooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001S
ooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooo
ooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03
o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0
COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool0
0ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo
0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003o
ooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo
001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000
ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34oooo
o`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000oooooooo
ool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hooo
ool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooo
oooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0
003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04go
oooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o
0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34
ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000oooo
ooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00
Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oo
oooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool0
0ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo
04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo
00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooooooo
o`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000
ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=oooo
o`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`00
0?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?oo
ool00ol0003oooooooooo`1=ooooo`00H?ooool6onKVi/7ooooo1_oVi^I=ooooo`00Goooool8onKV
i[oooooo2?oVi^I<ooooo`00G_ooool3onKViPCo00000ooVi^Jmooooo`?oi^KV1?l00003onKViT_o
oooo001Mooooo`Ooi^KV0_l00003onKVi[_ooooo1ooVi^H2o`0000?oi^KVB_ooool004Oooooo1Ol0
000@ooooo`Goi^KV1Ol00004onKViQ3ooooo1?l0001hooooo`Co00002?ooool4o`0000Sooooo1Ol0
0008ooooo`Go00000oooool5onKViPGo00001?oVi^I9ooooo`00B?ooool2o`000003ooooool0003o
000000oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViPoooooo0_l00002ooooo`;o0000M_ooool0
0ol0003oooooo`000009ooooo`03o`000?oooooo000000_ooooo0_l000000ooooooo0000o`000008
ooooo`;o000000?oooooo`000?l000000_ooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool0
04Sooooo0_l000000ooooooo0000o`00000?ooooo`Coi^KV0_l00002onKViP;o00001?oVi^HCoooo
o`;o0000M_ooool00ol0003oooooo`000002o`0000Oooooo00?o0000ooooool000000_l00009oooo
o`;o000000?oooooo`000?l000002?ooool2o`000003ooooool0003o000000;ooooo1?oVi^H2o`00
00;oi^KV0_l00004onKViTWooooo0018ooooo`Co00004?ooool4onKViP;o00000_oVi^H2o`0000Co
i^KV4Oooool3o`0007Oooooo00Go0000ooooool0003oooooo`000007ooooo`05o`000?oooooo0000
ooooool000002Oooool2o`000003ooooool0003o000000Sooooo1?l00003ooooo`Coi^KV0_l00002
onKViP;o00001?oVi^I9ooooo`00B?ooool2o`000003ooooool0003o000000oooooo1OoVi^H6o`00
00?oi^KV4oooool2o`0007Oooooo0ol00009ooooo`?o00002_ooool2o`000003ooooool0003o0000
00Sooooo0_l000000ooooooo0000o`000002ooooo`Goi^KV1_l00003onKViTWooooo0018ooooo`;o
000000?oooooo`000?l000003oooool>onKViPoooooo0_l00002ooooo`;o0000T?ooool2o`000003
ooooool0003o000000Sooooo0_l000000ooooooo0000o`000002ooooo`koi^KVBOooool004Oooooo
1Ol0000Aooooo`coi^KV4Oooool4o`00093ooooo1Ol00008ooooo`Go00001?ooool<onKViT[ooooo
001Nooooo`[oi^KV_Oooool:onKViT_ooooo001Oooooo`Soi^KV_oooool8onKViTcooooo001=oooo
o`03o`000?oooooooooo013ooooo1_oVi^JEooooo`03o`000?oooooooooo02Wooooo1_oVi^I=oooo
o`00COooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0Ooooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo053ooooo001>ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`21ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0DOooool004kooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`1Aooooo`00Coooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo05;ooooo001?ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`23ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0D_ooool0053o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo08Go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Cooooo`00D?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0QOooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo05?ooooo001Aooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0E?ooool0057ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1D
ooooo`00D_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool0ROooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Gooooo001Booooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`29ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0EOooool005;ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`1Eooooo`00Doooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo05Kooooo001Cooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`2;ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0E_ooool0
05Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
08gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Gooooo`00E?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0SOooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo05Oooooo001Eooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0F?ooool005Gooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`1Hooooo`00E_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05Wooooo001Foooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Aoooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0FOooool005Oooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`1Jooooo`00Eoooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo05[ooooo001Gooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0F_oo
ool005Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo09Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Kooooo`00F?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0UOooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo05_ooooo001Iooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0G?ooool005Wooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo09Oooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`1Looooo`00F_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0VOooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000005oooooo001Jooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`2Iooooo`05o`000?ooooooooooooooool0
00001?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000Goooool005_o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo09_o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`1Nooooo`00Foooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0Voooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo05kooooo001Looooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Mooooo`04o`000?oooooo
ooooo`0000?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo05oooooo
001Looooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`2Mooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`000002ooooo`03
o`000?oooooooooo05oooooo001Looooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`2Mooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo05oooooo001Mooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2Oooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`1Pooooo`00GOooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Woooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0H?oo
ool005kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0:7ooooo00?o0000ooooool000000_ooool01_l0003oooooooooool0003oooooo`0006?ooooo
001Nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`2Qooooo`08o`000?ooooooooooo`000?oooooo0000ooooool00002ooooo`03o`000?oooooooooo
067ooooo001Oooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2Soooo
o`09o`000?oooooo0000ooooool0003oooooo`000?oooooo000006Cooooo001Oooooo`05o`000?oo
ooooooooooooool000000oooool00ol0003oooooooooo`2Sooooo`09o`000?oooooo0000ooooool0
003oooooo`000?oooooo000006Cooooo001Pooooo`Koi^KV00?o0000ooooooooool0YOooool6onKV
iP03o`000?oooooooooo06?ooooo001Oooooo`Soi^KVY_ooool8onKViVGooooo001Nooooo`[oi^KV
Y?ooool:onKViVCooooo001Mooooo`Coi^KV1?l00004onKViZ;ooooo3?oVi^ISooooo`00G?ooool8
onKViP;o00001?oVi^JPooooo`koi^KVH_ooool000Wooooo1ol0001<ooooo`Goi^KV1Ol00004onKV
iTgooooo1Ol0001>ooooo`Coi^KV1ol00003onKViTgooooo1_l0000?ooooo`002Oooool2o`0000;o
oooo0_l0001=ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l0
0000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I>ooooo`;o000000?oooooo`000?l0
00003oooool000Wooooo1_l0001=ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o0000
00?oooooo`000?l00000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I?ooooo`;o0000
4Oooool000[ooooo1?l0001>ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?o
ooooo`000?l00000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I@ooooo`;o00004?oo
ool000[ooooo1?l00005ooooo`;o0000Aoooool5onKViPKo00000ooVi^I>ooooo`;o000000?ooooo
o`000?l00000COooool5onKViPCo00001OoVi^I8ooooo`03o`000?oooooooooo00;ooooo0_l00002
ooooo`;o00003oooool000_ooooo0_l00008ooooo`?o0000AOooool<onKViP03o`000?oooooooooo
04cooooo0_l000000ooooooo0000o`00001>ooooo`Coi^KV0_l00006onKViTKooooo0ol00005oooo
o`;o00000_ooool2o`0000oooooo000:ooooo`?o00002oooool4o`0004;ooooo2_oVi^H2ooooo`03
o`000?oooooooooo04[ooooo1Ol0001>ooooo`04o`000?ooooooi^KVonKViP?o00001OoVi^I3oooo
o`Co00002Oooool4o`00013ooooo000Looooo`?o0000@?ooool8onKViPCooooo0_l0002Kooooo`;o
00000oooool8onKViT7ooooo0ol0000Qooooo`007oooool3o`0003kooooo1_oVi^H7ooooo`03o`00
0?oooooooooo09Oooooo00?o0000ooooooooool01?ooool6onKViSoooooo0ol0000Tooooo`008_oo
ool3o`0004Wooooo0_l0001:ooooo`03o`000?oooooooooo04Sooooo0_l00019ooooo`?o00009ooo
ool002Gooooo0ol00018ooooo`;o0000B?ooool00ol0003oooooooooo`16ooooo`;o0000B?ooool3
o`0002[ooooo000Xooooo`Co0000A_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo
04Gooooo00?o0000ooooooooool0A?ooool4o`0002gooooo000/ooooo`?o0000A?ooool2o`0004Go
oooo00?o0000ooooooooool0@oooool2o`0004Cooooo0ol0000aooooo`00;oooool3o`0004?ooooo
0_l00013ooooo`03o`000?oooooooooo047ooooo0_l00013ooooo`?o0000=?ooool003;ooooo0ol0
0012ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool00ol0003ooooooooo
o`10ooooo`?o0000=oooool003Gooooo1?l0000oooooo`;o0000@?ooool00ol0003oooooooooo`0n
ooooo`;o0000?oooool4o`0003[ooooo000iooooo`?o0000?_ooool00ol0003oooooooooo`0moooo
o`03o`000?oooooooooo03gooooo00?o0000ooooooooool0??ooool3o`0003kooooo000looooo`?o
0000??ooool2o`0003gooooo00?o0000ooooooooool0>oooool2o`0003cooooo0ol00011ooooo`00
?oooool3o`0003_ooooo0_l0000kooooo`03o`000?oooooooooo03Wooooo0_l0000kooooo`?o0000
A?ooool004;ooooo0ol0000jooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?oo
ool00ol0003oooooooooo`0hooooo`?o0000Aoooool004Gooooo1?l0000gooooo`;o0000>?ooool0
0ol0003oooooooooo`0fooooo`;o0000=oooool4o`0004[ooooo0019ooooo`?o0000=_ooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool3o`00
04kooooo001<ooooo`?o0000=?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0003Co
oooo0ol0001Aooooo`00Coooool3o`0003?ooooo0_l0000cooooo`03o`000?oooooooooo037ooooo
0_l0000cooooo`?o0000E?ooool005;ooooo1?l0000aooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0<?ooool00ol0003oooooooooo`0_ooooo`Co0000Eoooool005Kooooo0ol0000_
ooooo`;o0000<?ooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005_ooooo001Ioooo
o`?o0000;_ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0;?ooool3o`0005kooooo001Looooo`?o0000;?ooool2o`0002gooooo00?o0000oooooooo
ool0:oooool2o`0002cooooo0ol0001Qooooo`00Goooool3o`0002_ooooo0_l0000[ooooo`03o`00
0?oooooooooo02Wooooo0_l0000[ooooo`?o0000I?ooool006;ooooo1?l0000Yooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`Co0000Iooo
ool006Kooooo0ol0000Wooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3
o`0006_ooooo001Yooooo`?o00009_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`00
02Kooooo0ol0001^ooooo`00K?ooool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo0ol0001aooooo`00Koooool4o`0002;ooooo
0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Rooooo`Co0000M?ooool007?ooooo0ol0
000Qooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Oooooo`?o0000N?ooool007Kooooo0ol0000Oooooo`;o00008?ooool00ol0003oooooooooo`0N
ooooo`;o00007oooool3o`0007_ooooo001iooooo`?o00007_ooool2o`0001kooooo00?o0000oooo
ooooool07?ooool2o`0001kooooo0ol0001nooooo`00O?ooool3o`0001gooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo0ol00021ooooo`00
Ooooool4o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`Co0000
Q?ooool008?ooooo0ol0000Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Gooooo`?o0000R?ooool008Kooooo0ol0000Gooooo`;o00006?ooool0
0ol0003oooooooooo`0Fooooo`;o00005oooool3o`0008_ooooo0029ooooo`?o00005_ooool2o`00
01Kooooo00?o0000ooooooooool05?ooool2o`0001Kooooo0ol0002>ooooo`00S?ooool4o`0001Co
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;o
oooo1?l0002Aooooo`00T?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo
0_l0000Booooo`?o0000UOooool009?ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0?ooooo`?o0000V?ooool009Kooooo0ol0000?
ooooo`;o00004?ooool00ol0003oooooooooo`0>ooooo`;o00003oooool3o`0009_ooooo002Ioooo
o`?o00003_ooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002Noooo
o`00W?ooool4o`0000cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00[ooooo1?l0002Qooooo`00X?ooool3o`0000[ooooo0_l0000;ooooo`03o`00
0?oooooooooo00Wooooo0_l0000:ooooo`?o0000YOooool00:?ooooo0ol00009ooooo`;o00002Ooo
ool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`000:Sooooo002Vooooo`?o00002?ooool0
0ol0003oooooooooo`03ooooo`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`?o0000Zoooool0
0:Wooooo1?l00005ooooo`;o00000_ooool8onKViP?ooooo0_l00005ooooo`Co0000[_ooool00:go
oooo0ol00004ooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool00oooool3o`000;;o
oooo002`ooooo`?o000000?oooooonKVi_oVi^H02_oVi^H2ooooo`?o0000]Oooool00;?ooooo1?oV
i^H6o`0000Coi^KV00?o0000ooooooooool0]_ooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool0
0;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo
1OoVi^H5o`0000Coi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;Cooooo1_oVi^H3
o`0000?oi^KV^_ooool00;Gooooo2_oVi^Jkooooo`00]_ooool8onKVi[cooooo002gooooo`Koi^KV
_Oooool00001\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.79719 .01472 -5 -6 ]
[.79719 .01472 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.79719 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.79719 .01472 Mdot
0 g
gsave
.79719 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0003_ooooo1Ol0000nooooo`Go00002oooool00>Gooooo0_l00002ooooo`;o0000?Oooool2o`00
0003ooooool0003o000003kooooo0_l000000ooooooo0000o`00000:ooooo`00iOooool6o`0003go
oooo0_l000000ooooooo0000o`00000nooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l0000nooooo`Co0000?oooool4o`0000_ooooo003Vooooo`Co0000?_ooool2o`000003ooooool0
003o000003kooooo0_l000000ooooooo0000o`00000:ooooo`00ioooool2o`0003oooooo0_l00000
0ooooooo0000o`00000nooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol0000noooo
o`Go0000?_ooool5o`0000_ooooo003^ooooo`;o0000M_ooool2o`0001;ooooo003`ooooo`03o`00
0?oooooooooo07;ooooo00?o0000ooooooooool04_ooool00?7ooooo00?o0000ooooooooool0L?oo
ool00ol0003oooooooooo`0Cooooo`00l_ooool00ol0003oooooooooo`0eooooo`03o`000?oooooo
oooo03Kooooo00?o0000ooooooooool05?ooool00??ooooo00?o0000ooooooooool0=?ooool00ol0
003oooooooooo`0dooooo`;o00005oooool00?Cooooo0_l0000dooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool05oooool00?Kooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0booooo`03o`000?oooooooooo01Sooooo003gooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`0Iooooo`00n?ooool00ol0003oooooooooo`0_
ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool06_ooool00?Wooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0^ooooo`;o00007Oooool00?[ooooo0_l0000^ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool07Oooool00?cooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo01kooooo003mooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Oooooo`00o_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo0_l0000Rooooo`00ooooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool08_ooool00?oo
oooo0Oooool2o`0002Sooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Sooooo`00
ooooool3ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0Tooooo`00ooooool4ooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Uooooo`00ooooool5ooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool08oooool2o`0002Sooooo003oooooo`Kooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo02Sooooo003oooooo`Oooooo0_l0000Rooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0:Oooool00?oooooo2Oooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0:_ooool00?oooooo2_oo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo0_l0000]ooooo`00ooooool;
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0]
ooooo`00ooooool<ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0^ooooo`00ooooool=ooooo`;o00007?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo02oooooo003oooooo`oooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo033ooooo003ooooooa3ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Hooooo`;o0000<oooool00?oooooo4Oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0<oooool00?oooooo4_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0=?ooool00?oo
oooo4oooool2o`0001Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0eooooo`00
oooooolEooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0fooooo`00oooooolFooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool2o`0003Wooooo003ooooooaOooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo03Wooooo003ooooooaSooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo03[ooooo003ooooooaWooooo0_l0000@ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0>oooool00?oooooo6oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo0_l0000nooooo`00oooooolLooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0nooooo`00oooooolM
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0o
ooooo`00oooooolNooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`10ooooo`00oooooolOooooo`;o00002_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo047ooooo003oooooob7ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`;o0000A?ooool00?oooooo8_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0A?ooool00?oooooo8oooool00ol0003oooooooooo`02
ooooo`Koi^KV1Oooool00ol0003oooooooooo`15ooooo`00oooooolTooooo`03o`000?oooooooooo
00Soi^KV0oooool00ol0003oooooooooo`16ooooo`00oooooolUooooo`03o`000?oVi^Koi^KV00So
i^KV0_l00019ooooo`00oooooolUooooo`Coi^KV1?l00004onKViT[ooooo003oooooobCooooo2?oV
i^H2o`0000Coi^KVBOooool006;ooooo1?l0002mooooo`Goi^KV1Ol00004onKViTWooooo001Soooo
o`;o0000__ooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool0063ooooo1_l0002mooooo`Co
i^KV0_l00002onKViP;o00001?oVi^I9ooooo`00H?ooool2o`000003ooooool0003o00000;kooooo
1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo001Qooooo`Co0000__ooool5onKViPKo00000ooV
i^I9ooooo`00H_ooool3o`000;oooooo3?oVi^I:ooooo`00Hoooool2o`000<3ooooo2_oVi^I;oooo
o`00oooooolWooooo`Soi^KVC?ooool00?oooooo:?ooool6onKViTgooooo001Sooooo`03o`000?oo
oooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool0
0ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo
04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo
00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooooooo
o`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000
ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=oooo
o`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`00
0?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?oo
ool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooo
oooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?o
oooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003ooooo
ooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o
0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=
ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03
o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0
a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oo
oooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool0
06?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003o
ooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo
00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003ooooooooo
o`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Soooo
o`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooooooo
ool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`00
0?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COoo
ool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0
003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Co
oooo00?o0000ooooooooool0COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003ooooo
ooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03o`000?oooooooooo04gooooo001S
ooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0COooool006?ooooo00?o0000oooo
ooooool0a?ooool00ol0003oooooooooo`1=ooooo`00Hoooool00ol0003oooooooooo`34ooooo`03
o`000?oooooooooo04gooooo001Sooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0
COooool006?ooooo00?o0000ooooooooool0a?ooool00ol0003oooooooooo`1=ooooo`00H?ooool6
onKVi/7ooooo1_oVi^I=ooooo`00Goooool8onKVi[oooooo2?oVi^I<ooooo`00G_ooool3onKViPCo
00000ooVi^Jmooooo`?oi^KV1?l00003onKViT_ooooo001Mooooo`Ooi^KV0_l00003onKVi[_ooooo
1ooVi^H2o`0000?oi^KVB_ooool004Oooooo1Ol0000@ooooo`Goi^KV1Ol00004onKViQ3ooooo1?l0
001hooooo`Co00003?ooool5o`0000_ooooo1Ol00008ooooo`Goi^KV1Ol00004onKViTWooooo0018
ooooo`;o000000?oooooo`000?l000003oooool4onKViP;o00000_oVi^H2o`0000Coi^KV3oooool2
o`0000;ooooo0_l0001fooooo`03o`000?oooooo000000oooooo0_l000000ooooooo0000o`00000;
ooooo`;o000000?oooooo`000?l000001oooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool0
04Sooooo0_l000000ooooooo0000o`00000?ooooo`Coi^KV0_l00002onKViP;o00001?oVi^HCoooo
o`;o0000M_ooool00ol0003oooooo`000002o`0000gooooo0_l000000ooooooo0000o`00000;oooo
o`;o000000?oooooo`000?l000001oooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool004So
oooo1?l0000@ooooo`Coi^KV0_l00002onKViP;o00001?oVi^HAooooo`?o0000Moooool01Ol0003o
ooooo`000?oooooo000000gooooo0_l000000ooooooo0000o`00000;ooooo`Co00002?ooool4onKV
iP;o00000_oVi^H2o`0000Coi^KVBOooool004Sooooo0_l000000ooooooo0000o`00000?ooooo`Go
i^KV1_l00003onKViQ?ooooo0_l0001gooooo`?o00003_ooool2o`000003ooooool0003o000000_o
oooo0_l000000ooooooo0000o`000007ooooo`Goi^KV1_l00003onKViTWooooo0018ooooo`;o0000
00?oooooo`000?l000003oooool>onKViPoooooo0_l00002ooooo`;o0000R?ooool2o`000003oooo
ool0003o000000_ooooo0_l000000ooooooo0000o`000007ooooo`koi^KVBOooool004Oooooo1Ol0
000Aooooo`coi^KV4Oooool4o`0008Sooooo1Ol0000;ooooo`Go00002Oooool<onKViT[ooooo001N
ooooo`[oi^KV_Oooool:onKViT_ooooo001Oooooo`Soi^KV_oooool8onKViTcooooo001=ooooo`03
o`000?oooooooooo013ooooo1_oVi^JEooooo`03o`000?oooooooooo02Wooooo1_oVi^I=ooooo`00
COooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
Ooooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`1@ooooo`00C_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Aooooo`00C_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0POooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`1Aooooo`00Coooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Booooo`00Coooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Poooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`1Booooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool0QOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Cooooo`00D?ooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0QOooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`1Cooooo`00DOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool0Qoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`1Dooooo`00DOooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Doooo
o`00D_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0ROooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`1Eooooo`00D_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Eooooo`00D_oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0ROoo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`1Eooooo`00Doooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Fooooo`00Doooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Roooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`1Fooooo`00E?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Gooooo`00E?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0SOooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1Gooooo`00EOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`1Hooooo`00EOooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1H
ooooo`00E_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0TOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Iooooo`00E_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Iooooo`00
Eoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
Toooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`1Jooooo`00Eoooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Jooooo`00Eoooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Toooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`1Jooooo`00F?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Kooooo`00F?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0UOooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`1Kooooo`00FOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0Uoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`00FOooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Uoooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`1Looooo`00F_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0VOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Mooooo`00F_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Moooo
o`00Foooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0Voooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Nooooo`00Foooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Nooooo`00G?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`1Oooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0WOooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1?ooool00ol0003oooooooooo`1Oooooo`00G?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`1Oooooo`00GOooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Woooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Rooooo`00GOooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Woooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Rooooo`00G_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0XOooool01?l0003o
ooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001Nooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Qooooo`04o`000?oooooooooo
o`0000?ooooo00Co0000oooooooooooo0000Hoooool005oooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo0:?ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03
o`000?oooooooooo06;ooooo001Oooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`2Sooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1R
ooooo`00H?ooool6onKViP03o`000?oooooooooo0:Gooooo1_oVi^H00ol0003oooooooooo`1Soooo
o`00Goooool8onKViZKooooo2?oVi^IUooooo`00G_ooool:onKViZCooooo2_oVi^ITooooo`00GOoo
ool4onKViPCo00001?oVi^JRooooo`coi^KVHoooool005cooooo2?oVi^H2o`0000Coi^KVX?ooool>
onKViV;ooooo0009ooooo`Oo0000C?ooool5onKViPGo00001?oVi^I=ooooo`Go0000C_ooool4onKV
iPOo00000ooVi^I=ooooo`Ko00003oooool000Wooooo0_l00002ooooo`;o0000COooool4onKViP;o
00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H2o`000003
onKVi_l0003o000000Coi^KVC_ooool2o`000003ooooool0003o000000oooooo0009ooooo`Ko0000
COooool4onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo
1OoVi^H2o`000003onKVi_l0003o000000Coi^KVCoooool2o`00017ooooo000:ooooo`Co0000C_oo
ool4onKViP;o00000_oVi^H2o`0000Coi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoV
i^H2o`000003onKVi_l0003o000000Coi^KVD?ooool2o`00013ooooo000:ooooo`Co00001Oooool2
o`0004Oooooo1OoVi^H6o`0000?oi^KVC_ooool2o`000003ooooool0003o000004gooooo1OoVi^H4
o`0000Goi^KVB?ooool00ol0003oooooooooo`02ooooo`;o00000_ooool2o`0000oooooo000;oooo
o`;o00002?ooool3o`0004Gooooo3?oVi^H00ol0003oooooooooo`1<ooooo`;o000000?oooooo`00
0?l00000C_ooool4onKViP;o00001_oVi^I6ooooo`?o00001Oooool2o`0000;ooooo0_l0000?oooo
o`002_ooool3o`0000_ooooo1?l00012ooooo`[oi^KV0_ooool00ol0003oooooooooo`1:ooooo`Go
0000C_ooool01?l0003oooooonKVi_oVi^H3o`0000Goi^KV@oooool4o`0000Wooooo1?l0000@oooo
o`007?ooool3o`00043ooooo2?oVi^H4ooooo`;o0000Voooool2o`0000?ooooo2?oVi^I1ooooo`?o
00008Oooool001oooooo0ol0000nooooo`Koi^KV1oooool00ol0003oooooooooo`2Gooooo`03o`00
0?oooooooooo00Cooooo1_oVi^Hoooooo`?o00009?ooool002;ooooo0ol00019ooooo`;o0000B_oo
ool00ol0003oooooooooo`18ooooo`;o0000BOooool3o`0002Oooooo000Uooooo`?o0000B?ooool2
o`0004Sooooo00?o0000ooooooooool0A_ooool2o`0004Sooooo0ol0000Zooooo`00:?ooool4o`00
04Kooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo
04Cooooo1?l0000]ooooo`00;?ooool3o`0004Cooooo0_l00015ooooo`03o`000?oooooooooo04?o
oooo0_l00014ooooo`?o0000<Oooool002oooooo0ol00013ooooo`;o0000@oooool00ol0003ooooo
ooooo`11ooooo`;o0000@oooool3o`0003Cooooo000booooo`?o0000@_ooool00ol0003ooooooooo
o`10ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool3o`0003Oooooo000e
ooooo`Co0000?oooool2o`00043ooooo00?o0000ooooooooool0?_ooool2o`0003oooooo1?l0000j
ooooo`00>Oooool3o`0003kooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0moooo
o`03o`000?oooooooooo03cooooo0ol0000nooooo`00??ooool3o`0003cooooo0_l0000mooooo`03
o`000?oooooooooo03_ooooo0_l0000looooo`?o0000@Oooool003oooooo0ol0000kooooo`;o0000
>oooool00ol0003oooooooooo`0iooooo`;o0000>oooool3o`0004Cooooo0012ooooo`?o0000>_oo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?oo
ool3o`0004Oooooo0015ooooo`Co0000=oooool2o`0003Sooooo00?o0000ooooooooool0=_ooool2
o`0003Oooooo1?l0001:ooooo`00BOooool3o`0003Kooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0eooooo`03o`000?oooooooooo03Cooooo0ol0001>ooooo`00C?ooool3o`0003Co
oooo0_l0000eooooo`03o`000?oooooooooo03?ooooo0_l0000dooooo`?o0000DOooool004oooooo
0ol0000cooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`;o0000<oooool3o`0005Cooooo
001Booooo`Co0000<Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0;oooool4o`0005Oooooo001Fooooo`?o0000;oooool2o`00033ooooo00?o0000
ooooooooool0;_ooool2o`0002oooooo0ol0001Kooooo`00FOooool3o`0002kooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02cooooo0ol0001Noooo
o`00G?ooool3o`0002cooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo0_l0000/ooooo`?o
0000HOooool005oooooo0ol0000[ooooo`;o0000:oooool00ol0003oooooooooo`0Yooooo`;o0000
:oooool3o`0006Cooooo001Rooooo`Co0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo02Sooooo00?o0000ooooooooool09oooool4o`0006Oooooo001Vooooo`?o00009oooool2
o`0002Sooooo00?o0000ooooooooool09_ooool2o`0002Oooooo0ol0001[ooooo`00JOooool3o`00
02Kooooo0_l0000Vooooo`03o`000?oooooooooo02Cooooo0_l0000Vooooo`?o0000K_ooool006co
oooo0ol0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Sooooo`?o0000LOooool006oooooo1?l0000Rooooo`;o00008oooool00ol0003ooooo
ooooo`0Qooooo`;o00008_ooool4o`0007Cooooo001cooooo`?o00008Oooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07oooool3o`0007Sooooo001f
ooooo`?o00007oooool2o`00023ooooo00?o0000ooooooooool07_ooool2o`0001oooooo0ol0001k
ooooo`00NOooool3o`0001kooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo0_l0000Noooo
o`?o0000O_ooool007cooooo0ol0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0Kooooo`?o0000POooool007oooooo1?l0000Jooooo`;o0000
6oooool00ol0003oooooooooo`0Iooooo`;o00006_ooool4o`0008Cooooo0023ooooo`?o00006Ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool05ooo
ool3o`0008Sooooo0026ooooo`?o00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool2
o`0001Oooooo0ol0002;ooooo`00ROooool3o`0001Kooooo0_l0000Fooooo`03o`000?oooooooooo
01Cooooo0_l0000Fooooo`?o0000S_ooool008cooooo1?l0000Dooooo`03o`000?oooooooooo01?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`Co0000TOooool0093ooooo
0ol0000Booooo`;o00004oooool00ol0003oooooooooo`0Aooooo`;o00004_ooool3o`0009Gooooo
002Cooooo`?o00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool03oooool3o`0009Sooooo002Fooooo`?o00003oooool2o`00013ooooo00?o0000
ooooooooool03_ooool2o`0000oooooo0ol0002Kooooo`00VOooool3o`0000kooooo0_l0000>oooo
o`03o`000?oooooooooo00cooooo0_l0000>ooooo`?o0000W_ooool009cooooo1?l0000<ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`Co
0000XOooool00:3ooooo0ol0000:ooooo`;o00002oooool00ol0003oooooooooo`09ooooo`;o0000
2_ooool3o`000:Gooooo002Sooooo`?o00002Oooool2o`0000Wooooo00?o0000ooooooooool01ooo
ool2o`0000Wooooo0ol0002Xooooo`00Y_ooool3o`0000Sooooo00?o0000ooooooooool00oooool6
onKViPKooooo00?o0000ooooooooool01_ooool3o`000:_ooooo002Yooooo`Co00001Oooool2o`00
00;ooooo2?oVi^H3ooooo`;o00001Oooool4o`000:kooooo002]ooooo`?o00001?ooool00ol0003o
i^KVonKViP08onKViP03ooooool0003ooooo00?ooooo0ol0002booooo`00/?ooool3o`000003oooo
oooVi^Koi^KV00[oi^KV0_ooool3o`000;Gooooo002cooooo`Coi^KV1_l00004onKViP03o`000?oo
oooooooo0;Kooooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Koi^KV0_l00006onKV
i[Wooooo002cooooo`Koi^KV0_l00006onKVi[Wooooo002cooooo`Goi^KV1Ol00004onKVi[Wooooo
002cooooo`Koi^KV0_l00006onKVi[Wooooo002dooooo`Koi^KV0ol00003onKVi[[ooooo002eoooo
o`[oi^KV^oooool00;Kooooo2?oVi^Jlooooo`00]oooool6onKVi[gooooo0000\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.22481 .30902 -5 -6 ]
[.22481 .30902 5 6 ]
[.22481 .16187 -5 -6 ]
[.22481 .16187 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.29296 .30902 -5 -6 ]
[.29296 .30902 5 6 ]
[.29296 .16187 -5 -6 ]
[.29296 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.22481 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.29296 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.22481 .30902 m
.22481 .16187 L
s
.9 g
.04 w
.22481 .30902 Mdot
0 g
gsave
.22481 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.22481 .16187 Mdot
0 g
gsave
.22481 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.29296 .30902 m
.29296 .16187 L
s
.9 g
.04 w
.29296 .30902 Mdot
0 g
gsave
.29296 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29296 .16187 Mdot
0 g
gsave
.29296 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007kooooo1Ol0000;ooooo`00iOooool2o`0000;ooooo0_l00020ooooo`;o000000?oooooo`00
0?l000002_ooool00>Gooooo1_l00020ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l00021ooooo`Co00002oooool00>Kooooo1?l00021ooooo`;o000000?oooooo`000?l000002_oo
ool00>Oooooo0_l00022ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol00021oooo
o`Go00002oooool00>kooooo0_l0001fooooo`;o00004_ooool00?3ooooo00?o0000ooooooooool0
L_ooool00ol0003oooooooooo`0Booooo`00lOooool00ol0003oooooooooo`1`ooooo`03o`000?oo
oooooooo01?ooooo003booooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool05?ooool0
0??ooooo00?o0000ooooooooool0Joooool2o`0001Oooooo003dooooo`;o0000J_ooool00ol0003o
ooooooooo`0Gooooo`00m_ooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01Sooooo
003gooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06Oooool00?Sooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0Jooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`;o00007Oooool00?[ooooo0_l0001Nooooo`03o`000?oooooooooo01gooooo003looooo`03o`00
0?oooooooooo05[ooooo00?o0000ooooooooool07_ooool00?gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`0Oooooo`00o_ooool00ol0003oooooooooo`1Eooooo`;o00008_ooool0
0?oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Rooooo`00ooooool1ooooo`;o
0000D_ooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo02Gooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool2o`0002Sooooo003ooooo
o`Kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0Xooooo`00ooooool7ooooo`;o
0000A_ooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`;o0000;Ooo
ool00?oooooo2oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02gooooo003ooooo
o`cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0^ooooo`00ooooool=ooooo`;o
0000>_ooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03Kooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`;o0000<ooo
ool00?oooooo4Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03?ooooo003ooooo
oa;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0dooooo`00oooooolCooooo`;o
0000;_ooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`;o0000>Ooo
ool00?oooooo5oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Wooooo003ooooo
oaSooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0jooooo`00oooooolIooooo`;o
00008_ooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
0_l0000nooooo`00oooooolLooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0?_oo
ool00?oooooo7Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03oooooo003ooooo
oakooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`10ooooo`00oooooolOooooo`;o
00005_ooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
0_l00014ooooo`00oooooolRooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A?oo
ool00?oooooo8oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16oooo
o`00oooooolUooooo`03o`000?oVi^Koi^KV00Soi^KV0_l00019ooooo`00oooooolUooooo`Coi^KV
1?l00004onKViT[ooooo003oooooobCooooo2?oVi^H2o`0000Coi^KVBOooool005Gooooo1?l0000E
ooooo`Co0000/Oooool5onKViPGo00001?oVi^I9ooooo`00E_ooool2o`0001Oooooo0_l0002boooo
o`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00Doooool6o`0001?ooooo1_l0002aooooo`Co
i^KV0_l00002onKViP;o00001?oVi^I9ooooo`00Doooool2o`000003ooooool0003o000001Cooooo
0_l000000ooooooo0000o`00002booooo`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00E?oo
ool4o`0001Gooooo1?l0002booooo`Goi^KV1_l00003onKViTWooooo001Eooooo`?o00005_ooool3
o`000;?ooooo3?oVi^I:ooooo`00E_ooool2o`0001Oooooo0_l0002dooooo`[oi^KVBoooool00?oo
oooo9oooool8onKViTcooooo003oooooobSooooo1_oVi^I=ooooo`00E_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000
ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Foooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=oooo
o`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000oooooooo
ool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`00
0?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?oo
ool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=
ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000oooo
ooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03
o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo
01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003o
ooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo
001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003ooooooooo
o`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000
ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hoooo
o`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04go
oooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003ooooo
ooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o
0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2h
ooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool0
05Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo
04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003o
ooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo
00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`2hooooo`03o`000?oooooooooo04gooooo001Cooooo`Koi^KV5?ooool6onKVi[Cooooo1_oVi^I=
ooooo`00D_ooool8onKViQ;ooooo2?oVi^Jbooooo`Soi^KVC?ooool0057ooooo0ooVi^H4o`0000?o
i^KV4?ooool2onKViPCo00001?oVi^J`ooooo`?oi^KV1?l00003onKViT_ooooo001@ooooo`Ooi^KV
0_l00003onKViPkooooo1_oVi^H2o`0000Coi^KV[_ooool7onKViP;o00000ooVi^I:ooooo`00Aooo
ool5o`0000?ooooo1OoVi^H5o`0000?oi^KV1?ooool5o`0000Cooooo1?oVi^H5o`0000?oi^KV1Ooo
ool4o`0007Sooooo1?l0000<ooooo`Go00002oooool5o`0000Sooooo1OoVi^H5o`0000Coi^KVBOoo
ool004Sooooo0_l000000ooooooo0000o`000002ooooo`Coi^KV0_l00002onKViP;o00000ooVi^H5
ooooo`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oVi^H2o`0000?oi^KV1?ooool2
o`0000;ooooo0_l0001fooooo`03o`000?oooooo000000oooooo0_l000000ooooooo0000o`00000;
ooooo`;o000000?oooooo`000?l000001oooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool0
04Sooooo0_l000000ooooooo0000o`000002ooooo`Coi^KV0_l00002onKViP;o00000ooVi^H5oooo
o`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oVi^H2o`0000?oi^KV2?ooool2o`00
07Kooooo00?o0000ooooool000000_l0000=ooooo`;o000000?oooooo`000?l000002oooool2o`00
0003ooooool0003o000000Oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo0018ooooo`Co
00000oooool4onKViP;o00000_oVi^H2o`0000?oi^KV1Oooool4o`0000Cooooo0ooVi^H2o`0000;o
i^KV0_l00003onKViPKooooo0ol0001gooooo`05o`000?oooooo0000ooooool000003Oooool2o`00
0003ooooool0003o000000_ooooo1?l00008ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9oooo
o`00B?ooool2o`000003ooooool0003o000000;ooooo1OoVi^H6o`0000;oi^KV1Oooool2o`000003
ooooool0003o000000?ooooo1?oVi^H6o`0000;oi^KV2?ooool2o`0007Oooooo0ol0000>ooooo`;o
000000?oooooo`000?l000002oooool2o`000003ooooool0003o000000Oooooo1OoVi^H6o`0000?o
i^KVBOooool004Sooooo0_l000000ooooooo0000o`000002ooooo`goi^KV1Oooool2o`000003oooo
ool0003o000000?ooooo3?oVi^H4ooooo`;o00000_ooool2o`0008Sooooo0_l000000ooooooo0000
o`00000;ooooo`;o000000?oooooo`000?l000001oooool>onKViTWooooo0017ooooo`Go00001?oo
ool<onKViPCooooo1Ol00005ooooo`coi^KV1?ooool4o`0008Sooooo1Ol0000;ooooo`Go00002Ooo
ool<onKViT[ooooo001Aooooo`[oi^KV4?ooool:onKVi[3ooooo2_oVi^I;ooooo`00D_ooool8onKV
iQ;ooooo2?oVi^Jbooooo`Soi^KVC?ooool004gooooo00?o0000ooooooooool00oooool6onKViQCo
oooo1_oVi^J8ooooo`03o`000?oooooooooo02Wooooo1_oVi^I=ooooo`00COooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0D?ooool004kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`21ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo057ooooo001>
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1A
ooooo`00Coooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo08?ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0D_ooool004oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`23ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo05;ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
QOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1Cooooo`00D?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo08Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool0Doooool0057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`27ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Cooooo001Aooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Dooooo`00D_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0EOooool005;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Gooooo
001Booooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0ROooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`1Eooooo`00Doooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo08_ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0E_ooool005?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2;oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo05Kooooo001Dooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0SOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1Gooooo`00E?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo08gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0Eoooool005Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Sooooo001Eooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Hooooo`00E_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0FOooool005Ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wo
oooo001Gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Toooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1Jooooo`00Eoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo09?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0F_ooool005Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2C
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo05[ooooo001Hooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0UOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1Kooooo`00F?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo09Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0Foooool005Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05cooooo001Iooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`00F_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo09Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0GOooool005[ooooo00Go0000oooooooooooooooo
o`000004ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`2Iooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo05gooooo001Kooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Noooo
o`00Foooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0G_ooool005cooooo00Co0000oooo
oooooooo00000oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`1Oooooo`00G?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`1Oooooo`00G?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo05oooooo001M
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
06;ooooo001Mooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000006;ooooo001Nooooo`03o`000?oooooo000000;ooooo00Ko0000oooooooooooo0000
ooooool0002Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000Hoooool0
05kooooo00So0000oooooooooooo0000ooooool0003oooooo`0000;ooooo00?o0000ooooooooool0
XOooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001Oooooo`09
o`000?oooooo0000ooooool0003oooooo`000?oooooo00000:Gooooo00Ko0000oooooooooooo0000
ooooool00002ooooo`03o`000?oooooooooo06;ooooo001Oooooo`09o`000?oooooo0000ooooool0
003oooooo`000?oooooo00000:Gooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`00
0?oooooooooo06;ooooo001Pooooo`Koi^KV00?o0000ooooooooool0YOooool6onKViP03o`000?oo
oooooooo06?ooooo001Oooooo`Soi^KVY_ooool8onKViVGooooo001Nooooo`[oi^KVY?ooool:onKV
iVCooooo001Mooooo`Coi^KV1?l00004onKViZ;ooooo3?oVi^ISooooo`00G?ooool8onKViP;o0000
1?oVi^JPooooo`koi^KVH_ooool000Wooooo1ol0001<ooooo`Goi^KV1Ol00004onKViTgooooo1Ol0
001>ooooo`Coi^KV1ol00003onKViTgooooo1_l0000?ooooo`002Oooool2o`0000;ooooo0_l0001=
ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l00000COooool5
onKViP;o000000?oi^KVo`000?l000001?oVi^I>ooooo`;o000000?oooooo`000?l000003oooool0
00Wooooo1_l0001=ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`00
0?l00000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I?ooooo`;o00004Oooool000[o
oooo1?l0001>ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l0
0000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I@ooooo`;o00004?ooool000[ooooo
1?l00005ooooo`;o0000Aoooool5onKViPKo00000ooVi^I>ooooo`;o000000?oooooo`000?l00000
COooool5onKViPCo00001OoVi^I8ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`;o0000
3oooool000_ooooo0_l00008ooooo`?o0000AOooool<onKViP03o`000?oooooooooo04cooooo0_l0
00000ooooooo0000o`00001>ooooo`Coi^KV0_l00006onKViTKooooo0ol00005ooooo`;o00000_oo
ool2o`0000oooooo000:ooooo`?o00002oooool4o`0004;ooooo2_oVi^H2ooooo`03o`000?oooooo
oooo04[ooooo1Ol0001>ooooo`04o`000?ooooooi^KVonKViP?o00001OoVi^I3ooooo`Co00002Ooo
ool4o`00013ooooo000Looooo`?o0000@?ooool8onKViPCooooo0_l0002Kooooo`;o00000oooool8
onKViT7ooooo0ol0000Qooooo`007oooool3o`0003kooooo1_oVi^H7ooooo`03o`000?oooooooooo
09Oooooo00?o0000ooooooooool01?ooool6onKViSoooooo0ol0000Tooooo`008_ooool3o`0004Wo
oooo0_l0001:ooooo`03o`000?oooooooooo04Sooooo0_l00019ooooo`?o00009oooool002Gooooo
0ol00018ooooo`;o0000B?ooool00ol0003oooooooooo`16ooooo`;o0000B?ooool3o`0002[ooooo
000Xooooo`Co0000A_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo00?o
0000ooooooooool0A?ooool4o`0002gooooo000/ooooo`?o0000A?ooool2o`0004Gooooo00?o0000
ooooooooool0@oooool2o`0004Cooooo0ol0000aooooo`00;oooool3o`0004?ooooo0_l00013oooo
o`03o`000?oooooooooo047ooooo0_l00013ooooo`?o0000=?ooool003;ooooo0ol00012ooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`?o
0000=oooool003Gooooo1?l0000oooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`;o0000
?oooool4o`0003[ooooo000iooooo`?o0000?_ooool00ol0003oooooooooo`0mooooo`03o`000?oo
oooooooo03gooooo00?o0000ooooooooool0??ooool3o`0003kooooo000looooo`?o0000??ooool2
o`0003gooooo00?o0000ooooooooool0>oooool2o`0003cooooo0ol00011ooooo`00?oooool3o`00
03_ooooo0_l0000kooooo`03o`000?oooooooooo03Wooooo0_l0000kooooo`?o0000A?ooool004;o
oooo0ol0000jooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003o
ooooooooo`0hooooo`?o0000Aoooool004Gooooo1?l0000gooooo`;o0000>?ooool00ol0003ooooo
ooooo`0fooooo`;o0000=oooool4o`0004[ooooo0019ooooo`?o0000=_ooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool3o`0004kooooo001<
ooooo`?o0000=?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001A
ooooo`00Coooool3o`0003?ooooo0_l0000cooooo`03o`000?oooooooooo037ooooo0_l0000coooo
o`?o0000E?ooool005;ooooo1?l0000aooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool0<?ooool00ol0003oooooooooo`0_ooooo`Co0000Eoooool005Kooooo0ol0000_ooooo`;o0000
<?ooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005_ooooo001Iooooo`?o0000;_oo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?oo
ool3o`0005kooooo001Looooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2
o`0002cooooo0ol0001Qooooo`00Goooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo
02Wooooo0_l0000[ooooo`?o0000I?ooool006;ooooo1?l0000Yooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`Co0000Ioooool006Kooooo
0ol0000Wooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`0006_ooooo
001Yooooo`?o00009_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0
001^ooooo`00K?ooool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo02?ooooo0ol0001aooooo`00Koooool4o`0002;ooooo0_l0000Soooo
o`03o`000?oooooooooo027ooooo0_l0000Rooooo`Co0000M?ooool007?ooooo0ol0000Qooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o
0000N?ooool007Kooooo0ol0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o0000
7oooool3o`0007_ooooo001iooooo`?o00007_ooool2o`0001kooooo00?o0000ooooooooool07?oo
ool2o`0001kooooo0ol0001nooooo`00O?ooool3o`0001gooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo0ol00021ooooo`00Ooooool4o`00
01[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`Co0000Q?ooool008?o
oooo0ol0000Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Gooooo`?o0000R?ooool008Kooooo0ol0000Gooooo`;o00006?ooool00ol0003ooooo
ooooo`0Fooooo`;o00005oooool3o`0008_ooooo0029ooooo`?o00005_ooool2o`0001Kooooo00?o
0000ooooooooool05?ooool2o`0001Kooooo0ol0002>ooooo`00S?ooool4o`0001Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo1?l0002A
ooooo`00T?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Boooo
o`?o0000UOooool009?ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0?ooooo`?o0000V?ooool009Kooooo0ol0000?ooooo`;o0000
4?ooool00ol0003oooooooooo`0>ooooo`;o00003oooool3o`0009_ooooo002Iooooo`?o00003_oo
ool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002Nooooo`00W?ooool4
o`0000cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00[ooooo1?l0002Qooooo`00X?ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo
00Wooooo0_l0000:ooooo`?o0000YOooool00:?ooooo0ol00009ooooo`;o00002Oooool00ol0003o
ooooooooo`07ooooo`;o00002Oooool3o`000:Sooooo002Vooooo`?o00002?ooool00ol0003ooooo
ooooo`03ooooo`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`?o0000Zoooool00:Wooooo1?l0
0005ooooo`;o00000_ooool8onKViP?ooooo0_l00005ooooo`Co0000[_ooool00:gooooo0ol00004
ooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool00oooool3o`000;;ooooo002`oooo
o`?o000000?oooooonKVi_oVi^H02_oVi^H2ooooo`?o0000]Oooool00;?ooooo1?oVi^H6o`0000Co
i^KV00?o0000ooooooooool0]_ooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1_oV
i^H2o`0000Koi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1OoVi^H5o`00
00Coi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;Cooooo1_oVi^H3o`0000?oi^KV
^_ooool00;Gooooo2_oVi^Jkooooo`00]_ooool8onKVi[cooooo002gooooo`Koi^KV_Oooool00001
\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.22481 .30902 -5 -6 ]
[.22481 .30902 5 6 ]
[.22481 .16187 -5 -6 ]
[.22481 .16187 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.29296 .30902 -5 -6 ]
[.29296 .30902 5 6 ]
[.29296 .16187 -5 -6 ]
[.29296 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.22481 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.29296 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.22481 .30902 m
.22481 .16187 L
s
.9 g
.04 w
.22481 .30902 Mdot
0 g
gsave
.22481 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.22481 .16187 Mdot
0 g
gsave
.22481 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.29296 .30902 m
.29296 .16187 L
s
.9 g
.04 w
.29296 .30902 Mdot
0 g
gsave
.29296 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.29296 .16187 Mdot
0 g
gsave
.29296 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00iOooool7
o`0007kooooo1Ol0000;ooooo`00iOooool2o`0000;ooooo0_l00020ooooo`;o000000?oooooo`00
0?l000002_ooool00>Gooooo1_l00020ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo
1?l00021ooooo`Co00002oooool00>Kooooo1?l00021ooooo`;o000000?oooooo`000?l000002_oo
ool00>Oooooo0_l00022ooooo`;o000000?oooooo`000?l000002_ooool00>Kooooo0ol00021oooo
o`Go00002oooool00>kooooo0_l0001fooooo`;o00004_ooool00?3ooooo00?o0000ooooooooool0
L_ooool00ol0003oooooooooo`0Booooo`00lOooool00ol0003oooooooooo`1`ooooo`03o`000?oo
oooooooo01?ooooo003booooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool05?ooool0
0??ooooo00?o0000ooooooooool0Joooool2o`0001Oooooo003dooooo`;o0000J_ooool00ol0003o
ooooooooo`0Gooooo`00m_ooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01Sooooo
003gooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool06Oooool00?Sooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0Jooooo`00nOooool00ol0003oooooooooo`1Ooooo
o`;o00007Oooool00?[ooooo0_l0001Nooooo`03o`000?oooooooooo01gooooo003looooo`03o`00
0?oooooooooo05[ooooo00?o0000ooooooooool07_ooool00?gooooo00?o0000ooooooooool0F?oo
ool00ol0003oooooooooo`0Oooooo`00o_ooool00ol0003oooooooooo`1Eooooo`;o00008_ooool0
0?oooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Rooooo`00ooooool1ooooo`;o
0000D_ooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo02Gooooo003oooooo`Gooooo00?o0000ooooooooool0BOooool2o`0002Sooooo003ooooo
o`Kooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0Xooooo`00ooooool7ooooo`;o
0000A_ooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04;ooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool00ol0003oooooooooo`0oooooo`;o0000;Ooo
ool00?oooooo2oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02gooooo003ooooo
o`cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0^ooooo`00ooooool=ooooo`;o
0000>_ooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03Kooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool00ol0003oooooooooo`0cooooo`;o0000<ooo
ool00?oooooo4Oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo03?ooooo003ooooo
oa;ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0dooooo`00oooooolCooooo`;o
0000;_ooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool00ol0003oooooooooo`0Wooooo`;o0000>Ooo
ool00?oooooo5oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo03Wooooo003ooooo
oaSooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0jooooo`00oooooolIooooo`;o
00008_ooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo01gooooo
0_l0000nooooo`00oooooolLooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0?_oo
ool00?oooooo7Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03oooooo003ooooo
oakooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`10ooooo`00oooooolOooooo`;o
00005_ooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo017ooooo
0_l00014ooooo`00oooooolRooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A?oo
ool00?oooooo8oooool00ol0003oooooooooo`02ooooo`Koi^KV1Oooool00ol0003oooooooooo`15
ooooo`00oooooolTooooo`03o`000?oooooooooo00Soi^KV0oooool00ol0003oooooooooo`16oooo
o`00oooooolUooooo`03o`000?oVi^Koi^KV00Soi^KV0_l00019ooooo`00oooooolUooooo`Coi^KV
1?l00004onKViT[ooooo003oooooobCooooo2?oVi^H2o`0000Coi^KVBOooool005Gooooo1?l0000E
ooooo`Co0000/Oooool5onKViPGo00001?oVi^I9ooooo`00E_ooool2o`0001Oooooo0_l0002boooo
o`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00Doooool6o`0001?ooooo1_l0002aooooo`Co
i^KV0_l00002onKViP;o00001?oVi^I9ooooo`00Doooool2o`000003ooooool0003o000001Cooooo
0_l000000ooooooo0000o`00002booooo`Coi^KV0_l00002onKViP;o00001?oVi^I9ooooo`00E?oo
ool4o`0001Gooooo1?l0002booooo`Goi^KV1_l00003onKViTWooooo001Eooooo`?o00005_ooool3
o`000;?ooooo3?oVi^I:ooooo`00E_ooool2o`0001Oooooo0_l0002dooooo`[oi^KVBoooool00?oo
oooo9oooool8onKViTcooooo003oooooobSooooo1_oVi^I=ooooo`00E_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000
ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Foooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=oooo
o`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000oooooooo
ool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`00
0?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?oo
ool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=
ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000oooo
ooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03
o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo
01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003o
ooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo
001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003ooooooooo
o`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000
ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hoooo
o`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04go
oooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003ooooo
ooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o
0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2h
ooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo04gooooo001Fooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003oooooooooo`1=ooooo`00E_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo00?o0000ooooooooool0COooool0
05Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo
04gooooo001Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0^?ooool00ol0003o
ooooooooo`1=ooooo`00E_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0;Sooooo
00?o0000ooooooooool0COooool005Kooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`2hooooo`03o`000?oooooooooo04gooooo001Cooooo`Koi^KV5?ooool6onKVi[Cooooo1_oVi^I=
ooooo`00D_ooool8onKViQ;ooooo2?oVi^Jbooooo`Soi^KVC?ooool0057ooooo0ooVi^H4o`0000?o
i^KV4?ooool2onKViPCo00001?oVi^J`ooooo`?oi^KV1?l00003onKViT_ooooo001@ooooo`Ooi^KV
0_l00003onKViPkooooo1_oVi^H2o`0000Coi^KV[_ooool7onKViP;o00000ooVi^I:ooooo`00Aooo
ool5o`0000?ooooo1OoVi^H5o`0000?oi^KV1?ooool5o`0000Cooooo1?oVi^H5o`0000?oi^KV1Ooo
ool4o`0007Sooooo1?l0000<ooooo`Go00002oooool5o`0000Sooooo1OoVi^H5o`0000Coi^KVBOoo
ool004Sooooo0_l000000ooooooo0000o`000002ooooo`Coi^KV0_l00002onKViP;o00000ooVi^H5
ooooo`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oVi^H2o`0000?oi^KV1?ooool2
o`0000;ooooo0_l0001fooooo`03o`000?oooooo000000oooooo0_l000000ooooooo0000o`00000;
ooooo`;o000000?oooooo`000?l000001oooool4onKViP;o00000_oVi^H2o`0000Coi^KVBOooool0
04Sooooo0_l000000ooooooo0000o`000002ooooo`Coi^KV0_l00002onKViP;o00000ooVi^H5oooo
o`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oVi^H2o`0000?oi^KV2?ooool2o`00
07Kooooo00?o0000ooooool000000_l0000=ooooo`;o000000?oooooo`000?l000002oooool2o`00
0003ooooool0003o000000Oooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTWooooo0018ooooo`Co
00000oooool4onKViP;o00000_oVi^H2o`0000?oi^KV1Oooool4o`0000Cooooo0ooVi^H2o`0000;o
i^KV0_l00003onKViPKooooo0ol0001gooooo`05o`000?oooooo0000ooooool000003Oooool2o`00
0003ooooool0003o000000_ooooo1?l00008ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I9oooo
o`00B?ooool2o`000003ooooool0003o000000;ooooo1OoVi^H6o`0000;oi^KV1Oooool2o`000003
ooooool0003o000000?ooooo1?oVi^H6o`0000;oi^KV2?ooool2o`0007Oooooo0ol0000>ooooo`;o
000000?oooooo`000?l000002oooool2o`000003ooooool0003o000000Oooooo1OoVi^H6o`0000?o
i^KVBOooool004Sooooo0_l000000ooooooo0000o`000002ooooo`goi^KV1Oooool2o`000003oooo
ool0003o000000?ooooo3?oVi^H4ooooo`;o00000_ooool2o`0008Sooooo0_l000000ooooooo0000
o`00000;ooooo`;o000000?oooooo`000?l000001oooool>onKViTWooooo0017ooooo`Go00001?oo
ool<onKViPCooooo1Ol00005ooooo`coi^KV1?ooool4o`0008Sooooo1Ol0000;ooooo`Go00002Ooo
ool<onKViT[ooooo001Aooooo`[oi^KV4?ooool:onKVi[3ooooo2_oVi^I;ooooo`00D_ooool8onKV
iQ;ooooo2?oVi^Jbooooo`Soi^KVC?ooool004gooooo00?o0000ooooooooool00oooool6onKViQCo
oooo1_oVi^J8ooooo`03o`000?oooooooooo02Wooooo1_oVi^I=ooooo`00COooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0D?ooool004kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`21ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo057ooooo001>
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1A
ooooo`00Coooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo08?ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0D_ooool004oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`23ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo05;ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
QOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1Cooooo`00D?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo08Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool0Doooool0057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`27ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Cooooo001Aooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Dooooo`00D_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0EOooool005;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Gooooo
001Booooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0ROooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`1Eooooo`00Doooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo08_ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0E_ooool005?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2;oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo05Kooooo001Dooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0SOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1Gooooo`00E?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo08gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0Eoooool005Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Sooooo001Eooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Hooooo`00E_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0FOooool005Ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wo
oooo001Gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Toooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1Jooooo`00Eoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo09?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0F_ooool005Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2C
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo05[ooooo001Hooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0UOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1Kooooo`00F?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo09Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0Foooool005Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05cooooo001Iooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Looooo`00F_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo09Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0GOooool005[ooooo00Go0000oooooooooooooooo
o`000004ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`2Iooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo05gooooo001Kooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Noooo
o`00Foooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0G_ooool005cooooo00Co0000oooo
oooooooo00000oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`1Oooooo`00G?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`1Oooooo`00G?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo05oooooo001M
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
06;ooooo001Mooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000006;ooooo001Nooooo`03o`000?oooooo000000;ooooo00Ko0000oooooooooooo0000
ooooool0002Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000Hoooool0
05kooooo00So0000oooooooooooo0000ooooool0003oooooo`0000;ooooo00?o0000ooooooooool0
XOooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0006?ooooo001Oooooo`09
o`000?oooooo0000ooooool0003oooooo`000?oooooo00000:Gooooo00Ko0000oooooooooooo0000
ooooool00002ooooo`03o`000?oooooooooo06;ooooo001Oooooo`09o`000?oooooo0000ooooool0
003oooooo`000?oooooo00000:Gooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`00
0?oooooooooo06;ooooo001Pooooo`Koi^KV00?o0000ooooooooool0YOooool6onKViP03o`000?oo
oooooooo06?ooooo001Oooooo`Soi^KVY_ooool8onKViVGooooo001Nooooo`[oi^KVY?ooool:onKV
iVCooooo001Mooooo`Coi^KV1?l00004onKViZ;ooooo3?oVi^ISooooo`00G?ooool8onKViP;o0000
1?oVi^JPooooo`koi^KVH_ooool000Wooooo1ol0001<ooooo`Goi^KV1Ol00004onKViTgooooo1Ol0
001>ooooo`Coi^KV1ol00003onKViTgooooo1_l0000?ooooo`002Oooool2o`0000;ooooo0_l0001=
ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l00000COooool5
onKViP;o000000?oi^KVo`000?l000001?oVi^I>ooooo`;o000000?oooooo`000?l000003oooool0
00Wooooo1_l0001=ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`00
0?l00000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I?ooooo`;o00004Oooool000[o
oooo1?l0001>ooooo`Coi^KV0_l00002onKViP;o00001?oVi^I>ooooo`;o000000?oooooo`000?l0
0000COooool5onKViP;o000000?oi^KVo`000?l000001?oVi^I@ooooo`;o00004?ooool000[ooooo
1?l00005ooooo`;o0000Aoooool5onKViPKo00000ooVi^I>ooooo`;o000000?oooooo`000?l00000
COooool5onKViPCo00001OoVi^I8ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`;o0000
3oooool000_ooooo0_l00008ooooo`?o0000AOooool<onKViP03o`000?oooooooooo04cooooo0_l0
00000ooooooo0000o`00001>ooooo`Coi^KV0_l00006onKViTKooooo0ol00005ooooo`;o00000_oo
ool2o`0000oooooo000:ooooo`?o00002oooool4o`0004;ooooo2_oVi^H2ooooo`03o`000?oooooo
oooo04[ooooo1Ol0001>ooooo`04o`000?ooooooi^KVonKViP?o00001OoVi^I3ooooo`Co00002Ooo
ool4o`00013ooooo000Looooo`?o0000@?ooool8onKViPCooooo0_l0002Kooooo`;o00000oooool8
onKViT7ooooo0ol0000Qooooo`007oooool3o`0003kooooo1_oVi^H7ooooo`03o`000?oooooooooo
09Oooooo00?o0000ooooooooool01?ooool6onKViSoooooo0ol0000Tooooo`008_ooool3o`0004Wo
oooo0_l0001:ooooo`03o`000?oooooooooo04Sooooo0_l00019ooooo`?o00009oooool002Gooooo
0ol00018ooooo`;o0000B?ooool00ol0003oooooooooo`16ooooo`;o0000B?ooool3o`0002[ooooo
000Xooooo`Co0000A_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo00?o
0000ooooooooool0A?ooool4o`0002gooooo000/ooooo`?o0000A?ooool2o`0004Gooooo00?o0000
ooooooooool0@oooool2o`0004Cooooo0ol0000aooooo`00;oooool3o`0004?ooooo0_l00013oooo
o`03o`000?oooooooooo047ooooo0_l00013ooooo`?o0000=?ooool003;ooooo0ol00012ooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`?o
0000=oooool003Gooooo1?l0000oooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`;o0000
?oooool4o`0003[ooooo000iooooo`?o0000?_ooool00ol0003oooooooooo`0mooooo`03o`000?oo
oooooooo03gooooo00?o0000ooooooooool0??ooool3o`0003kooooo000looooo`?o0000??ooool2
o`0003gooooo00?o0000ooooooooool0>oooool2o`0003cooooo0ol00011ooooo`00?oooool3o`00
03_ooooo0_l0000kooooo`03o`000?oooooooooo03Wooooo0_l0000kooooo`?o0000A?ooool004;o
oooo0ol0000jooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003o
ooooooooo`0hooooo`?o0000Aoooool004Gooooo1?l0000gooooo`;o0000>?ooool00ol0003ooooo
ooooo`0fooooo`;o0000=oooool4o`0004[ooooo0019ooooo`?o0000=_ooool00ol0003ooooooooo
o`0eooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool3o`0004kooooo001<
ooooo`?o0000=?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001A
ooooo`00Coooool3o`0003?ooooo0_l0000cooooo`03o`000?oooooooooo037ooooo0_l0000coooo
o`?o0000E?ooool005;ooooo1?l0000aooooo`03o`000?oooooooooo033ooooo00?o0000oooooooo
ool0<?ooool00ol0003oooooooooo`0_ooooo`Co0000Eoooool005Kooooo0ol0000_ooooo`;o0000
<?ooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005_ooooo001Iooooo`?o0000;_oo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?oo
ool3o`0005kooooo001Looooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2
o`0002cooooo0ol0001Qooooo`00Goooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo
02Wooooo0_l0000[ooooo`?o0000I?ooool006;ooooo1?l0000Yooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`Co0000Ioooool006Kooooo
0ol0000Wooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`0006_ooooo
001Yooooo`?o00009_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0
001^ooooo`00K?ooool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0S
ooooo`03o`000?oooooooooo02?ooooo0ol0001aooooo`00Koooool4o`0002;ooooo0_l0000Soooo
o`03o`000?oooooooooo027ooooo0_l0000Rooooo`Co0000M?ooool007?ooooo0ol0000Qooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o
0000N?ooool007Kooooo0ol0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o0000
7oooool3o`0007_ooooo001iooooo`?o00007_ooool2o`0001kooooo00?o0000ooooooooool07?oo
ool2o`0001kooooo0ol0001nooooo`00O?ooool3o`0001gooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo0ol00021ooooo`00Ooooool4o`00
01[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`Co0000Q?ooool008?o
oooo0ol0000Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Gooooo`?o0000R?ooool008Kooooo0ol0000Gooooo`;o00006?ooool00ol0003ooooo
ooooo`0Fooooo`;o00005oooool3o`0008_ooooo0029ooooo`?o00005_ooool2o`0001Kooooo00?o
0000ooooooooool05?ooool2o`0001Kooooo0ol0002>ooooo`00S?ooool4o`0001Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo1?l0002A
ooooo`00T?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Boooo
o`?o0000UOooool009?ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0?ooooo`?o0000V?ooool009Kooooo0ol0000?ooooo`;o0000
4?ooool00ol0003oooooooooo`0>ooooo`;o00003oooool3o`0009_ooooo002Iooooo`?o00003_oo
ool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002Nooooo`00W?ooool4
o`0000cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00[ooooo1?l0002Qooooo`00X?ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo
00Wooooo0_l0000:ooooo`?o0000YOooool00:?ooooo0ol00009ooooo`;o00002Oooool00ol0003o
ooooooooo`07ooooo`;o00002Oooool3o`000:Sooooo002Vooooo`?o00002?ooool00ol0003ooooo
ooooo`03ooooo`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`?o0000Zoooool00:Wooooo1?l0
0005ooooo`;o00000_ooool8onKViP?ooooo0_l00005ooooo`Co0000[_ooool00:gooooo0ol00004
ooooo`03o`000?oVi^Koi^KV00Soi^KV00?oooooo`000?ooool00oooool3o`000;;ooooo002`oooo
o`?o000000?oooooonKVi_oVi^H02_oVi^H2ooooo`?o0000]Oooool00;?ooooo1?oVi^H6o`0000Co
i^KV00?o0000ooooooooool0]_ooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1_oV
i^H2o`0000Koi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;?ooooo1OoVi^H5o`00
00Coi^KV^Oooool00;?ooooo1_oVi^H2o`0000Koi^KV^Oooool00;Cooooo1_oVi^H3o`0000?oi^KV
^_ooool00;Gooooo2_oVi^Jkooooo`00]_ooool8onKVi[cooooo002gooooo`Koi^KV_Oooool00001
\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14097, -0.82718, \
0.0114828, 0.00366879}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.476995 0.226593 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.15034 .30902 -5 -6 ]
[.15034 .30902 5 6 ]
[.20508 .30902 -5 -6 ]
[.20508 .30902 5 6 ]
[.20508 .16187 -5 -6 ]
[.20508 .16187 5 6 ]
[.25983 .30902 -5 -6 ]
[.25983 .30902 5 6 ]
[.20508 .45617 -5 -6 ]
[.20508 .45617 5 6 ]
[.38636 .45617 -5 -6 ]
[.38636 .45617 5 6 ]
[.56763 .45617 -5 -6 ]
[.56763 .45617 5 6 ]
[.69416 .30902 -5 -6 ]
[.69416 .30902 5 6 ]
[.73066 .30902 -5 -6 ]
[.73066 .30902 5 6 ]
[.76715 .30902 -5 -6 ]
[.76715 .30902 5 6 ]
[.80365 .30902 -5 -6 ]
[.80365 .30902 5 6 ]
[.63111 .01472 -5.0625 -6 ]
[.63111 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80365 .16187 -5 -6 ]
[.80365 .16187 5 6 ]
[.74891 .45617 -5 -6 ]
[.74891 .45617 5 6 ]
[.93018 .45617 -5 -6 ]
[.93018 .45617 5 6 ]
[.47699 .60332 -5 -6 ]
[.47699 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.47699 .60332 m
.02381 .45617 L
s
.47699 .60332 m
.20508 .45617 L
s
.47699 .60332 m
.38636 .45617 L
s
.47699 .60332 m
.56763 .45617 L
s
.47699 .60332 m
.74891 .45617 L
s
.47699 .60332 m
.93018 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20508 .45617 m
.15034 .30902 L
s
.20508 .45617 m
.20508 .30902 L
s
.20508 .45617 m
.25983 .30902 L
s
1 g
.04 w
.15034 .30902 Mdot
0 g
gsave
.15034 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20508 .30902 m
.20508 .16187 L
s
.9 g
.04 w
.20508 .30902 Mdot
0 g
gsave
.20508 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.20508 .16187 Mdot
0 g
gsave
.20508 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.25983 .30902 Mdot
0 g
gsave
.25983 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20508 .45617 Mdot
0 g
gsave
.20508 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.38636 .45617 Mdot
0 g
gsave
.38636 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.56763 .45617 Mdot
0 g
gsave
.56763 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.74891 .45617 m
.69416 .30902 L
s
.74891 .45617 m
.73066 .30902 L
s
.74891 .45617 m
.76715 .30902 L
s
.74891 .45617 m
.80365 .30902 L
s
1 g
.04 w
.69416 .30902 Mdot
0 g
gsave
.69416 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.73066 .30902 Mdot
0 g
gsave
.73066 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.76715 .30902 Mdot
0 g
gsave
.76715 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80365 .30902 m
.80365 .16187 L
s
.9 g
.04 w
.80365 .30902 Mdot
0 g
gsave
.80365 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80365 .16187 m
.63111 .01472 L
s
.80365 .16187 m
.97619 .01472 L
s
1 g
.04 w
.63111 .01472 Mdot
0 g
gsave
.63111 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.80365 .16187 Mdot
0 g
gsave
.80365 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.74891 .45617 Mdot
0 g
gsave
.74891 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.93018 .45617 Mdot
0 g
gsave
.93018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.47699 .60332 Mdot
0 g
gsave
.47699 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{378.375, 233.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005j0000jB000`400?l00000o`00003ooooooomk
ooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00oooooomkooooo`00j_ooool7
o`0007Wooooo1Ol0000;ooooo`00j_ooool2o`0000;ooooo0_l0001kooooo`;o000000?oooooo`00
0?l000002_ooool00>[ooooo1_l0001kooooo`;o000000?oooooo`000?l000002_ooool00>_ooooo
1?l0001looooo`Co00002oooool00>_ooooo1?l0001looooo`;o000000?oooooo`000?l000002_oo
ool00>cooooo0_l0001mooooo`;o000000?oooooo`000?l000002_ooool00>_ooooo0ol0001loooo
o`Go00002oooool00??ooooo00?o0000ooooooooool0LOooool00ol0003oooooooooo`0@ooooo`00
m?ooool2o`0006oooooo0_l0000Cooooo`00m_ooool00ol0003oooooooooo`1[ooooo`03o`000?oo
oooooooo01?ooooo003gooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool05?ooool0
0?Sooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`0Eooooo`00nOooool00ol0003o
ooooooooo`1Uooooo`03o`000?oooooooooo01Kooooo003jooooo`03o`000?oooooooooo06?ooooo
00?o0000ooooooooool05oooool00?_ooooo0_l0001Qooooo`;o00006_ooool00?gooooo00?o0000
ooooooooool0GOooool00ol0003oooooooooo`0Jooooo`00o_ooool00ol0003oooooooooo`1Koooo
o`03o`000?oooooooooo01_ooooo003oooooo`03o`000?oooooooooo05Wooooo00?o0000oooooooo
ool07?ooool00?oooooo0Oooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo01gooooo
003oooooo`;ooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0Nooooo`00ooooool3
ooooo`;o0000Doooool2o`00027ooooo003oooooo`Gooooo00?o0000ooooooooool0Coooool00ol0
003oooooooooo`0Qooooo`00ooooool6ooooo`03o`000?oooooooooo04gooooo00?o0000oooooooo
ool08_ooool00?oooooo1oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo02?ooooo
003oooooo`Sooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0Tooooo`00ooooool9
ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool09Oooool00?oooooo2_ooool2o`00
04Gooooo0_l0000Xooooo`00ooooool<ooooo`03o`000?oooooooooo047ooooo00?o0000oooooooo
ool0:?ooool00?oooooo3Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo02Wooooo
003oooooo`kooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0Zooooo`00ooooool?
ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0:oooool00?oooooo4?ooool00ol0
003oooooooooo`0iooooo`03o`000?oooooooooo02cooooo003ooooooa7ooooo00?o0000oooooooo
ool0=oooool00ol0003oooooooooo`0]ooooo`00oooooolBooooo`;o0000=Oooool2o`00033ooooo
003ooooooaCooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0`ooooo`00oooooolE
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0<Oooool00?oooooo5_ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo03;ooooo003ooooooaOooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`0cooooo`00oooooolHooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0=?ooool00?oooooo6Oooool2o`0002Oooooo0_l0000gooooo`00oooooolK
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool00?oooooo7?ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo03Sooooo003ooooooagooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0iooooo`00oooooolNooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool0>_ooool00?oooooo7oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo03_ooooo003oooooob3ooooo0_l0000Iooooo`;o0000?_ooool00?oooooo8_ooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo03kooooo003oooooob?ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0oooooo`00oooooolTooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0@?ooool00?oooooo9Oooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo047ooooo003oooooobKooooo00?o0000ooooooooool00_ooool6onKViPGooooo00?o0000
ooooooooool0@_ooool00?oooooo9oooool2o`000003oooooooVi^Koi^KV00Koi^KV0_ooool2o`00
04Gooooo003oooooobWooooo2_oVi^H00ol0003oooooooooo`15ooooo`00oooooolXooooo`Coi^KV
1?l00004onKViTOooooo003oooooobOooooo2?oVi^H2o`0000Coi^KVA_ooool004kooooo1?l0003D
ooooo`Goi^KV1Ol00004onKViTKooooo001?ooooo`;o0000eOooool4onKViP;o00000_oVi^H2o`00
00Coi^KVA_ooool004cooooo1_l0003Dooooo`Coi^KV0_l00002onKViP;o00001?oVi^I6ooooo`00
C?ooool2o`000003ooooool0003o00000=Gooooo1?oVi^H2o`0000;oi^KV0_l00004onKViTKooooo
001=ooooo`Co0000eOooool5onKViPKo00000ooVi^I6ooooo`00C_ooool3o`000=Kooooo3?oVi^I7
ooooo`00Coooool2o`000=Oooooo2_oVi^I8ooooo`00oooooolZooooo`Soi^KVBOooool00?oooooo
:oooool6onKViT[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0B_oo
ool004oooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool00ol0
003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo0=_o
oooo00?o0000ooooooooool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003ooooo
ooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?
ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000oooo
ooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Kooooo`03
o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0
B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool0
0ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo
0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003o
ooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo
001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000
ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Koooo
o`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000oooooooo
ool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Cooo
ool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooo
oooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0
003oooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[o
oooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o
0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3K
ooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000oooo
ooooool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00
Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oo
oooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000ooooooooool0foooool0
0ol0003oooooooooo`1:ooooo`00Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo
04[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo
00?o0000ooooooooool0foooool00ol0003oooooooooo`1:ooooo`00Coooool00ol0003ooooooooo
o`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`000?oooooooooo0=_ooooo00?o0000
ooooooooool0B_ooool004oooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`1:oooo
o`00Coooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo04[ooooo001?ooooo`03o`00
0?oooooooooo0=_ooooo00?o0000ooooooooool0B_ooool004oooooo00?o0000ooooooooool0fooo
ool00ol0003oooooooooo`1:ooooo`00C?ooool6onKVi]Sooooo1_oVi^I:ooooo`00Boooool8onKV
i]Kooooo2?oVi^I9ooooo`00B_ooool3onKViPCo00000ooVi^KDooooo`?oi^KV1?l00003onKViTSo
oooo0019ooooo`Ooi^KV0_l00003onKVi];ooooo1ooVi^H2o`0000?oi^KVAoooool003Sooooo1Ol0
000;ooooo`Goi^KV1Ol00004onKViP_ooooo1?l0002Mooooo`Co00002Oooool5o`0000Sooooo1Ol0
0005ooooo`Goi^KV1Ol00004onKViTKooooo000iooooo`;o000000?oooooo`000?l000002_ooool4
onKViP;o00000_oVi^H2o`0000Coi^KV2_ooool2o`0000;ooooo0_l0002Kooooo`03o`000?oooooo
000000cooooo0_l000000ooooooo0000o`000008ooooo`;o000000?oooooo`000?l000001?ooool4
onKViP;o00000_oVi^H2o`0000Coi^KVA_ooool003Wooooo0_l000000ooooooo0000o`00000:oooo
o`Coi^KV0_l00002onKViP;o00001?oVi^H>ooooo`;o0000Voooool00ol0003oooooo`000002o`00
00[ooooo0_l000000ooooooo0000o`000008ooooo`;o000000?oooooo`000?l000001?ooool4onKV
iP;o00000_oVi^H2o`0000Coi^KVA_ooool003Wooooo1?l0000;ooooo`Coi^KV0_l00002onKViP;o
00001?oVi^H<ooooo`?o0000W?ooool01Ol0003oooooo`000?oooooo000000[ooooo0_l000000ooo
oooo0000o`000008ooooo`Co00001Oooool4onKViP;o00000_oVi^H2o`0000Coi^KVA_ooool003Wo
oooo0_l000000ooooooo0000o`00000:ooooo`Goi^KV1_l00003onKViPkooooo0_l0002Looooo`?o
00002oooool2o`000003ooooool0003o000000Sooooo0_l000000ooooooo0000o`000004ooooo`Go
i^KV1_l00003onKViTKooooo000iooooo`;o000000?oooooo`000?l000002_ooool>onKViP[ooooo
0_l00002ooooo`;o0000Z_ooool2o`000003ooooool0003o000000Sooooo0_l000000ooooooo0000
o`000004ooooo`koi^KVA_ooool003Sooooo1Ol0000<ooooo`coi^KV3?ooool4o`000:[ooooo1Ol0
0008ooooo`Go00001_ooool<onKViTOooooo001:ooooo`[oi^KVe?ooool:onKViTSooooo001;oooo
o`Soi^KVe_ooool8onKViTWooooo001<ooooo`Koi^KVf?ooool6onKViT[ooooo000nooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2Tooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo04gooooo000nooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo04gooooo000nooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo04kooooo000oooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`2Vooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo04kooooo000oooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04ko
oooo0010ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`2Xooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo04oooooo0010ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04oooooo0010
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2X
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo053ooooo0011ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo053ooooo0011ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Zooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo053ooooo0011ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo057ooooo0012ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2/ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo057ooooo0012ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`2/ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo057ooooo0012ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2/ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
05;ooooo0013ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`2^ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo05;ooooo0013ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`2^ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05?ooooo
0014ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`2`ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo05?ooooo0014ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`2`ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05?ooooo0014oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2`oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo05Cooooo0015ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`2booooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05Cooooo0015ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo05Gooooo0015ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`2booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05Gooooo0016ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2dooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo05Gooooo0016ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`2dooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05Kooooo0016ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2dooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05Ko
oooo0017ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`2fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo05Kooooo0017ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05Oooooo0018
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2h
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo05Oooooo0018ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo05Sooooo0018ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2hooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo05Sooooo0019oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2joooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo05Sooooo0019ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`2jooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000005_ooooo0019ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`2jooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000005_ooooo001:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`2looooo`04o`000?ooooooooooo`0000?ooooo00Go0000oooooooooooo
ooooo`00001Kooooo`00B_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0_?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo0000G?ooool004[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo0;cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0005cooooo001;ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2n
ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1Kooooo`00Booo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0__ooool01_l0003ooooo
ooooool0003oooooo`0000;ooooo00?o0000ooooooooool0Foooool004cooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`30ooooo`05o`000?oooooo0000ooooool000000_ooool0
0ol0003oooooooooo`1Kooooo`00C?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo0<3ooooo00Oo0000ooooool0003oooooo`000?oooooo000005kooooo001<ooooo`Koi^KV00?o
0000ooooooooool0`?ooool00ol0003oi^KVonKViP04onKViUkooooo001;ooooo`Soi^KV`_ooool8
onKViUgooooo001:ooooo`[oi^KV`?ooool:onKViUcooooo0019ooooo`Coi^KV1?l00004onKVi[ko
oooo3?oVi^IKooooo`00B?ooool8onKViP;o00001?oVi^Jlooooo`koi^KVF_ooool000Wooooo1ol0
000hooooo`Goi^KV1Ol00004onKViSWooooo1Ol0000nooooo`Go0000>oooool3onKViPOo00001?oV
i^Hiooooo`Ko00006oooool000Wooooo0_l00002ooooo`;o0000>Oooool4onKViP;o00000_oVi^H2
o`0000Coi^KV>_ooool2o`000003ooooool0003o000003kooooo0_l000000ooooooo0000o`00000j
ooooo`Coi^KV0_l000000ooVi^Ko0000o`000005onKViS[ooooo0_l000000ooooooo0000o`00000K
ooooo`002Oooool6o`0003Wooooo1?oVi^H2o`0000;oi^KV0_l00004onKViS[ooooo0_l000000ooo
oooo0000o`00000nooooo`;o000000?oooooo`000?l00000>_ooool4onKViP;o000000?oi^KVo`00
0?l000001OoVi^Hkooooo`;o00007Oooool000[ooooo1?l0000jooooo`Coi^KV0_l00002onKViP;o
00001?oVi^Hjooooo`;o000000?oooooo`000?l00000?_ooool2o`000003ooooool0003o000003[o
oooo1?oVi^H2o`000003onKVi_l0003o000000Goi^KV??ooool2o`0001cooooo000:ooooo`Co0000
1Oooool2o`0003?ooooo1OoVi^H6o`0000?oi^KV>_ooool2o`000003ooooool0003o000003kooooo
0_l000000ooooooo0000o`00000jooooo`Coi^KV1?l00006onKViSCooooo00?o0000ooooooooool0
0_ooool2o`0000;ooooo0_l0000Kooooo`002oooool2o`0000Sooooo0ol0000aooooo`coi^KV0_l0
000iooooo`;o000000?oooooo`000?l00000?_ooool2o`000003ooooool0003o000003[ooooo00Co
0000onKVi_oVi^Koi^KV0_l00007onKViS;ooooo0ol00005ooooo`;o00000_ooool2o`0001_ooooo
000:ooooo`?o00002oooool3o`0002oooooo2_oVi^H3ooooo`03o`000?oooooooooo03Gooooo1Ol0
000nooooo`Go0000>Oooool2o`0000;ooooo00Coi^KVo`000?l0003o00001_oVi^H`ooooo`?o0000
2Oooool4o`0001cooooo000Kooooo`?o0000;Oooool8onKViPGooooo0_l0002dooooo`;o00001Ooo
ool8onKViRkooooo0ol0000/ooooo`007_ooool3o`0002_ooooo1_oVi^H8ooooo`;o0000>Oooool0
0ol0003oooooooooo`1dooooo`;o00002?ooool6onKViRcooooo0ol0000_ooooo`008Oooool3o`00
03Sooooo0_l0000hooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0=_ooool2o`00
03Wooooo0ol0000booooo`009?ooool3o`0003Oooooo0_l0000gooooo`03o`000?oooooooooo03Ko
oooo00?o0000ooooooooool0=Oooool2o`0003Sooooo0ol0000eooooo`009oooool4o`0003Gooooo
0_l0000eooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0<oooool2o`0003Kooooo
1?l0000hooooo`00:oooool3o`0003Cooooo0_l0000dooooo`03o`000?oooooooooo03Cooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0cooooo`?o0000??ooool002kooooo0ol0000c
ooooo`;o0000<oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo037ooooo0_l0000c
ooooo`?o0000?oooool0037ooooo0ol0000booooo`03o`000?oooooooooo033ooooo00?o0000oooo
ooooool0<_ooool00ol0003oooooooooo`0`ooooo`;o0000<_ooool3o`0004;ooooo000dooooo`?o
0000<?ooool2o`00037ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0_ooooo`;o
0000<Oooool3o`0004Gooooo000gooooo`?o0000;oooool2o`00033ooooo00?o0000ooooooooool0
;oooool00ol0003oooooooooo`0]ooooo`;o0000<?ooool3o`0004Sooooo000jooooo`?o0000;_oo
ool2o`0002kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0/ooooo`;o0000;ooo
ool3o`0004_ooooo000mooooo`?o0000;Oooool2o`0002gooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`0Zooooo`;o0000;_ooool3o`0004kooooo0010ooooo`?o0000;?ooool2o`00
02_ooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02_ooooo0ol0001Aooooo`00@oooool4o`0002[ooooo0_l0000Zooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0:Oooool2o`0002[ooooo1?l0001Dooooo`00Aoooool3o`0002Wooooo
00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Oooooo
0_l0000Yooooo`?o0000F?ooool004[ooooo0ol0000Wooooo`;o0000:?ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02Kooooo0_l0000Xooooo`?o0000Foooool004gooooo0ol0000V
ooooo`;o00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Gooooo0_l0000W
ooooo`?o0000G_ooool0053ooooo0ol0000Uooooo`;o00009_ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo02?ooooo0_l0000Vooooo`?o0000HOooool005?ooooo0ol0000Tooooo`;o
00009?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02;ooooo0_l0000Uooooo`?o
0000I?ooool005Kooooo0ol0000Sooooo`;o00008oooool00ol0003oooooooooo`0Sooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool08_ooool3o`0006Oooooo001Iooooo`?o00008_oo
ool2o`00027ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Pooooo`;o00008_oo
ool3o`0006[ooooo001Looooo`?o00008Oooool2o`00023ooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0Oooooo`;o00008Oooool3o`0006gooooo001Oooooo`Co00007oooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07Oooool2o`00
01oooooo1?l0001`ooooo`00Hoooool3o`0001gooooo0_l0000Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07?ooool2o`0001kooooo0ol0001dooooo`00I_ooool3o`0001cooooo
0_l0000Mooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool06_ooool2o`0001gooooo
0ol0001gooooo`00JOooool3o`0001_ooooo0_l0000Looooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`?o0000N_ooool006cooooo0ol0000J
ooooo`;o00006_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Wooooo0_l0000J
ooooo`?o0000OOooool006oooooo0ol0000Iooooo`;o00006Oooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01Oooooo0_l0000Iooooo`?o0000P?ooool007;ooooo0ol0000Hooooo`;o
00005oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Kooooo0_l0000Hooooo`?o
0000Poooool007Gooooo0ol0000Gooooo`;o00005_ooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo01Cooooo0_l0000Gooooo`?o0000Q_ooool007Sooooo0ol0000Fooooo`03o`000?oo
oooooooo01Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Cooooo`;o00005_oo
ool3o`0008Wooooo001kooooo`Co00004oooool2o`0001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Booooo`;o00005?ooool4o`0008cooooo001oooooo`?o00004_ooool2o`00
01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo0ol0002@ooooo`00P_ooool3o`00017ooooo0_l0000Booooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04?ooool2o`00017ooooo0ol0002Cooooo`00QOooool3o`00013ooooo
0_l0000@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool2o`00013ooooo
0ol0002Fooooo`00R?ooool3o`0000oooooo0_l0000?ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03Oooool2o`0000oooooo0ol0002Iooooo`00Roooool3o`0000kooooo0_l0000>
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002L
ooooo`00S_ooool3o`0000gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00[ooooo0_l0000=ooooo`?o0000Woooool0097ooooo0ol0000;ooooo`;o
00003?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo0_l0000<ooooo`?o
0000X_ooool009Cooooo0ol0000:ooooo`;o00002_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool3o`000:Gooooo002Gooooo`Co00002?oo
ool2o`0000Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`;o00002?oo
ool4o`000:Sooooo002Kooooo`?o00001oooool2o`0000Sooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`06ooooo`;o00001oooool3o`000:cooooo002Nooooo`?o00001_ooool2o`00
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`00
0:oooooo002Qooooo`?o00001Oooool2o`0000Gooooo00?o0000onKVi_oVi^H01?oVi^H00ooooooo
0000ooooo`04ooooo`;o00001Oooool3o`000;;ooooo002Tooooo`?o00001?ooool2o`0000?ooooo
2?oVi^H4ooooo`;o00001?ooool3o`000;Gooooo002Wooooo`?o00000oooool00ol0003oooooonKV
iP09onKViP03ooooool0003o000000?ooooo0ol0002hooooo`00Z_ooool3o`000003oooooooVi^Ko
i^KV00[oi^KV0_ooool3o`000;_ooooo002]ooooo`Coi^KV1_l00004onKViP03o`000?oooooooooo
0;cooooo002]ooooo`Koi^KV0_l00006onKVi[oooooo002]ooooo`Koi^KV0_l00006onKVi[oooooo
002]ooooo`Koi^KV0_l00006onKVi[oooooo002]ooooo`Goi^KV1Ol00004onKVi[oooooo002]oooo
o`Koi^KV0_l00006onKVi[oooooo002^ooooo`Koi^KV0ol00003onKVi/3ooooo002_ooooo`[oi^KV
`Oooool00;3ooooo2?oVi^K2ooooo`00/Oooool6onKVi/?ooooo0000\
\>"],
  ImageRangeCache->{{{0, 377.375}, {232.875, 0}} -> {-2.14625, -0.82718, \
0.0119127, 0.00366879}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Deletion - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.20018 .30902 -5 -6 ]
[.20018 .30902 5 6 ]
[.20018 .16187 -5 -6 ]
[.20018 .16187 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.52939 .30902 -5 -6 ]
[.52939 .30902 5 6 ]
[.57643 .30902 -5 -6 ]
[.57643 .30902 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.27072 .01472 -5.0625 -6 ]
[.27072 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.62346 .16187 -5 -6 ]
[.62346 .16187 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
gsave
.20018 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20018 .16187 Mdot
0 g
gsave
.20018 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52939 .30902 Mdot
0 g
gsave
.52939 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.57643 .30902 Mdot
0 g
gsave
.57643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
gsave
.27072 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.62346 .16187 Mdot
0 g
gsave
.62346 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{410.75, 253.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006J0000oB000`400?l00000o`00003ooooooonK
ooooo`00oooooonKooooo`00oooooonKooooo`00oooooonKooooo`00oooooonKooooo`00oooooonK
ooooo`00oooooonKooooo`00oooooonKooooo`00Koooool7o`000?oooooo4Oooool5o`0000oooooo
001_ooooo`;o00000_ooool2o`000?oooooo4oooool2o`000003ooooool0003o000000kooooo001_
ooooo`Ko0000oooooolCooooo`;o000000?oooooo`000?l000003_ooool0073ooooo1?l0003ooooo
oaCooooo1?l0000?ooooo`00L?ooool4o`000?oooooo5?ooool2o`000003ooooool0003o000000ko
oooo001aooooo`;o0000oooooolEooooo`;o000000?oooooo`000?l000003_ooool0073ooooo0ol0
0008ooooo`?o0000ooooool1ooooo`?o00001Oooool5o`0000oooooo001nooooo`;o0000o?ooool2
o`0001cooooo0020ooooo`?o0000m_ooool3o`0001kooooo0023ooooo`;o0000l_ooool2o`00027o
oooo0025ooooo`;o0000kOooool3o`0002?ooooo0027ooooo`?o0000j?ooool2o`0002Kooooo002:
ooooo`;o0000i?ooool2o`0002Sooooo002<ooooo`?o0000g_ooool3o`0002[ooooo002?ooooo`;o
0000f_ooool2o`0002gooooo002Aooooo`;o0000eOooool3o`0002oooooo002Cooooo`?o0000d?oo
ool2o`0003;ooooo002Fooooo`;o0000c?ooool2o`0003Cooooo002Hooooo`?o0000a_ooool3o`00
03Kooooo002Kooooo`;o0000`_ooool2o`0003Wooooo002Mooooo`;o0000_Oooool3o`0003_ooooo
002Oooooo`?o0000^?ooool2o`0003kooooo002Rooooo`;o0000]?ooool2o`00043ooooo002Toooo
o`?o0000[_ooool3o`0004;ooooo002Wooooo`;o0000Z_ooool2o`0004Gooooo002Yooooo`;o0000
YOooool3o`0004Oooooo002[ooooo`?o0000X?ooool2o`0004[ooooo002^ooooo`;o0000Voooool3
o`0004cooooo002`ooooo`?o0000U_ooool2o`0004oooooo002cooooo`;o0000T_ooool2o`00057o
oooo002eooooo`;o0000SOooool3o`0005?ooooo002gooooo`?o0000R?ooool2o`0005Kooooo002j
ooooo`;o0000Poooool3o`0005Sooooo002looooo`;o0000Ooooool2o`0005_ooooo002nooooo`?o
0000N_ooool2o`0005gooooo0031ooooo`;o0000MOooool3o`0005oooooo0033ooooo`?o0000L?oo
ool2o`0006;ooooo0036ooooo`;o0000Joooool3o`0006Cooooo0038ooooo`;o0000Ioooool2o`00
06Oooooo003:ooooo`?o0000HOooool3o`0006Wooooo003=ooooo`;o0000GOooool2o`0006cooooo
003?ooooo`?o0000F?ooool2o`0006kooooo003Booooo`;o0000Doooool3o`00073ooooo003Doooo
o`;o0000Coooool2o`0007?ooooo003Fooooo`?o0000BOooool3o`0007Gooooo003Iooooo`;o0000
AOooool2o`0007Sooooo003Kooooo`?o0000@?ooool2o`0007[ooooo003Nooooo`;o0000>oooool3
o`0007cooooo003Pooooo`;o0000=oooool2o`0007oooooo003Rooooo`?o0000<Oooool3o`00087o
oooo003Uooooo`;o0000;Oooool2o`0008Cooooo003Wooooo`?o00004?ooool7onKViQ7ooooo0_l0
0026ooooo`00j_ooool2o`0000cooooo2ooVi^H<ooooo`?o0000R?ooool00>cooooo0_l00009oooo
o`goi^KV2Oooool2o`0008_ooooo003^ooooo`?o00001Oooool?onKViPGooooo0ol0002=ooooo`00
lOooool2o`0000;ooooo4OoVi^H2ooooo`;o0000T?ooool00??ooooo0_l00006onKViPCo00001ooV
i^H2o`0009;ooooo003dooooo`[oi^KV0_l00007onKViY?ooooo001Eooooo`Co0000Voooool7onKV
iPGo00001ooVi^JCooooo`00E_ooool2o`0009cooooo1_oVi^H2o`0000;oi^KV0_l00007onKViY?o
oooo001Cooooo`Ko0000Voooool6onKViP;o00000_oVi^H2o`0000Ooi^KVToooool005?ooooo0_l0
00000ooooooo0000o`00002Looooo`Koi^KV0_l00002onKViP;o00001ooVi^JCooooo`00E?ooool4
o`0009cooooo1ooVi^H6o`0000Koi^KVToooool005Gooooo0ol0002Loooooa?oi^KVToooool005Ko
oooo0_l0002Moooooa7oi^KVU?ooool00?Gooooo4OoVi^JDooooo`00m_ooool?onKViYGooooo003g
ooooo`goi^KVU_ooool005Kooooo00?o0000ooooooooool0Woooool;onKViYOooooo001Fooooo`03
o`000?oooooooooo0:7ooooo1ooVi^JIooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03o`00
0?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0V_oo
ool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool00ol0
003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Co
oooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003ooooo
ooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo001F
ooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000oooo
ooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03
o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0
V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool0
0ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo
0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003o
ooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo
001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000
ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Toooo
o`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000oooooooo
ool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_oo
ool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooo
oooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0
003oooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[o
oooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o
0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2T
ooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000oooo
ooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00
E_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oo
oooooooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool0
0ol0003oooooooooo`2Jooooo`00E_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo
09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0V_ooool005Kooooo
00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Jooooo`00E_ooool00ol0003ooooooooo
o`2Tooooo`03o`000?oooooooooo09[ooooo001Fooooo`03o`000?oooooooooo0:Cooooo00?o0000
ooooooooool0V_ooool005Kooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`2Joooo
o`00D_ooool7onKViZ7ooooo1ooVi^JIooooo`00D?ooool;onKViYgooooo2ooVi^JGooooo`00Cooo
ool=onKViY_ooooo3OoVi^JFooooo`00C_ooool?onKViYWooooo3ooVi^JEooooo`00COoooolAonKV
iYOooooo4OoVi^JDooooo`00COooool7onKViPCo00001_oVi^JGooooo`Koi^KV1?l00007onKViYCo
oooo001<ooooo`_oi^KV0_l00006onKViYGooooo2_oVi^H2o`0000Ooi^KVToooool003Oooooo1Ol0
000@ooooo`Soi^KV1Ol00006onKViQ7ooooo1?l0001?ooooo`Co00003_ooool5o`0000kooooo1Ol0
0007ooooo`Ooi^KV1Ol00007onKViY?ooooo000hooooo`;o000000?oooooo`000?l000003oooool7
onKViP;o00000_oVi^H2o`0000Koi^KV4?ooool2o`0000;ooooo0_l0001=ooooo`03o`000?oooooo
0000017ooooo0_l000000ooooooo0000o`00000>ooooo`;o000000?oooooo`000?l000001_ooool6
onKViP;o00000_oVi^H2o`0000Ooi^KVToooool003Sooooo0_l000000ooooooo0000o`00000?oooo
o`Ooi^KV0_l00002onKViP;o00001_oVi^HDooooo`;o0000COooool00ol0003oooooo`000002o`00
00oooooo0_l000000ooooooo0000o`00000>ooooo`;o000000?oooooo`000?l000001_ooool6onKV
iP;o00000_oVi^H2o`0000Ooi^KVToooool003Sooooo1?l0000@ooooo`Ooi^KV0_l00002onKViP;o
00001_oVi^HBooooo`?o0000C_ooool01Ol0003oooooo`000?oooooo000000oooooo0_l000000ooo
oooo0000o`00000>ooooo`Co00001oooool6onKViP;o00000_oVi^H2o`0000Ooi^KVToooool003So
oooo0_l000000ooooooo0000o`00000?ooooo`Soi^KV1_l00005onKViQCooooo0_l0001>ooooo`?o
00004?ooool2o`000003ooooool0003o000000kooooo0_l000000ooooooo0000o`000006ooooo`Oo
i^KV1_l00006onKViY?ooooo000hooooo`;o000000?oooooo`000?l000003ooooolConKViQ3ooooo
0_l00002ooooo`;o0000HOooool2o`000003ooooool0003o000000kooooo0_l000000ooooooo0000
o`000006oooooa?oi^KVToooool003Oooooo1Ol0000Aoooooa7oi^KV4_ooool4o`00067ooooo1Ol0
000>ooooo`Go00002?oooolAonKViYCooooo001=oooooa7oi^KVUooooolAonKViYCooooo001>oooo
o`ooi^KVVOooool?onKViYGooooo001?ooooo`goi^KVVoooool=onKViYKooooo001@ooooo`_oi^KV
WOooool;onKViYOooooo000nooooo`03o`000?oooooooooo017ooooo1ooVi^I`ooooo`03o`000?oo
oooooooo02gooooo00?o0000onKVi_oVi^H01OoVi^JIooooo`00?oooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2O
ooooo`00?oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool0F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`2Oooooo`00@?ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0G?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Pooooo`00
@?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
G?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`2Pooooo`00@Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Qooooo`00@Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0G_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`2Qooooo`00@Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Qooooo`00@_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0H?ooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`2Rooooo`00@_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0H?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Rooooo`00@oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0H_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`2Sooooo`00@oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool0H_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`2Sooooo`00A?ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0I?ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Toooo
o`00A?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool0I?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`2Tooooo`00AOooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Uooooo`00AOoo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0I_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`2Uooooo`00A_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Vooooo`00A_ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0J?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`2Vooooo`00Aoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0J_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Wooooo`00Aoooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0J_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`2Wooooo`00B?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0K?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`2Xooooo`00B?ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0K?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2X
ooooo`00BOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0K_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`2Yooooo`00BOooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0K_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Yooooo`00
B_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
L?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`2Zooooo`00B_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool0L?ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Zooooo`00Boooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0L_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`2[ooooo`00Boooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0L_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2[ooooo`00C?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0M?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`2/ooooo`00C?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0M?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`2/ooooo`00COooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0M_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`2]ooooo`00COooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0M_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`2]ooooo`00C_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0N?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2^oooo
o`00C_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0N?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`2^ooooo`00Coooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0N_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00002aooooo`00Coooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0N_ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`2_ooooo`00
Coooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
N_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`2_ooooo`00D?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0O?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00002booooo`00D?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0O?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00002booooo`00DOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0O_ooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`000;?ooooo001Aooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`1nooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool0002cooooo`00D_ooool7onKViP03ooooool0003ooooo087ooooo00?o0000onKVi_oVi^H01OoV
i^H00ol0003oooooooooo`2booooo`00D?ooool;onKViX7ooooo2ooVi^Jcooooo`00Coooool=onKV
iWoooooo3OoVi^Jbooooo`00C_ooool?onKViWgooooo3ooVi^Jaooooo`00COooool7onKViPCo0000
1_oVi^Ikoooooa7oi^KV/?ooool004gooooo2_oVi^H2o`0000Goi^KVNooooolAonKVi[3ooooo000=
ooooo`Oo0000>?ooool8onKViPGo00001_oVi^Hiooooo`Go0000>oooool6onKViPOo00001_oVi^Hi
ooooo`Ko0000L?ooool000gooooo0_l00002ooooo`;o0000>Oooool7onKViP;o00000_oVi^H2o`00
00Koi^KV>_ooool2o`000003ooooool0003o000003[ooooo1ooVi^H2o`000003onKVi_l0003o0000
00Ooi^KV>_ooool2o`000003ooooool0003o0000073ooooo000=ooooo`Ko0000>Oooool7onKViP;o
00000_oVi^H2o`0000Koi^KV>_ooool2o`000003ooooool0003o000003[ooooo1ooVi^H2o`000003
onKVi_l0003o000000Ooi^KV>oooool2o`0007;ooooo000>ooooo`Co0000>_ooool7onKViP;o0000
0_oVi^H2o`0000Koi^KV>_ooool2o`000003ooooool0003o000003[ooooo1ooVi^H2o`000003onKV
i_l0003o000000Ooi^KV??ooool2o`00077ooooo000>ooooo`Co0000>_ooool8onKViPKo00001OoV
i^Hjooooo`;o000000?oooooo`000?l00000>_ooool7onKViPCo00002?oVi^Hiooooo`;o00000_oo
ool2o`00073ooooo000?ooooo`;o0000>ooooolConKViS[ooooo0_l000000ooooooo0000o`00000j
ooooo`Ooi^KV0_l0000:onKViSWooooo0_l00002ooooo`;o0000L?ooool000kooooo0ol00008oooo
o`?o0000<?oooolConKViSWooooo1Ol0000kooooo`Koi^KV0ol0000:onKViS7ooooo0_l00007oooo
o`Co0000LOooool001cooooo0_l0000_oooooa7oi^KVNooooolAonKViS3ooooo0_l0001nooooo`00
7_ooool2o`0002gooooo4OoVi^H00ol0003oooooooooo`1hoooooa7oi^KV;_ooool2o`00083ooooo
000Pooooo`?o0000:oooool?onKViP;ooooo00?o0000ooooooooool0M_ooool00ol0003oooooonKV
iP0>onKViRcooooo0ol00022ooooo`008oooool2o`0002[ooooo3OoVi^H4ooooo`03o`000?oooooo
oooo07Cooooo00Co0000oooooooooooooooo3OoVi^H[ooooo`;o0000QOooool002Gooooo0_l0000Y
ooooo`_oi^KV1_ooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo00?ooooo2ooVi^HY
ooooo`?o0000Qoooool002Oooooo0ol0000Xooooo`Ooi^KV2Oooool00ol0003oooooooooo`1`oooo
o`03o`000?oooooooooo00Kooooo1ooVi^HYooooo`;o0000R_ooool002[ooooo0_l0000gooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool2o`0003Oooooo0_l0002<ooooo`00
;?ooool2o`0003Kooooo0_l0000eooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0
=?ooool3o`0008kooooo000^ooooo`?o0000=Oooool00ol0003oooooooooo`0booooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool0<oooool2o`00097ooooo000aooooo`;o0000=?ooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool2
o`0009?ooooo000cooooo`?o0000<_ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
037ooooo00?o0000ooooooooool0<?ooool3o`0009Gooooo000fooooo`;o0000<Oooool00ol0003o
ooooooooo`0_ooooo`03o`000?oooooooooo02oooooo0_l0000aooooo`;o0000V?ooool003Sooooo
0_l0000`ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`0^ooooo`?o0000V_ooool003[ooooo0ol0000^ooooo`;o0000;_ooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02gooooo0_l0002Mooooo`00?Oooool2o`0002kooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo0_l0002O
ooooo`00?oooool2o`0002gooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo02[ooooo0ol0002Qooooo`00@Oooool3o`0002_ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0Yooooo`;o0000:oooool2o`000:Cooooo0014ooooo`;o0000
:_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
:Oooool2o`000:Kooooo0016ooooo`;o0000:Oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool09oooool3o`000:Sooooo0018ooooo`?o00009oooool2
o`0002Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o0000Zoooool0
04_ooooo0_l0000Wooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Tooooo`?o0000[Oooool004gooooo0_l0000Vooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`;o0000/?ooool004oooooo
0ol0000Tooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool2o`0002Cooooo
0_l0002booooo`00D_ooool2o`0002?ooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo027ooooo0ol0002dooooo`00E?ooool3o`00027ooooo0_l0000Q
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool2o`000;Oooooo001Goooo
o`;o00008Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool07oooool2o`000;Wooooo001Iooooo`;o00008?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool07Oooool3o`000;_ooooo001Kooooo`?o0000
7_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo0_l0000Nooooo`;o0000
__ooool005kooooo0_l0000Mooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`0Looooo`;o0000`?ooool0063ooooo0_l0000Looooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`?o0000`_ooool0
06;ooooo0ol0000Jooooo`;o00006_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01Wooooo0_l00035ooooo`00IOooool2o`0001[ooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo0ol00037ooooo`00Ioooool2o`0001Wooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Kooooo
0_l0003:ooooo`00JOooool3o`0001Oooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`0Eooooo`;o00005oooool2o`000<cooooo001/ooooo`;o00005_ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool3o`000<kooooo001^oooo
o`;o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool04oooool2o`000=7ooooo001`ooooo`?o00004oooool2o`0001?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`;o0000doooool007?ooooo0_l0000Cooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`?o0000
eOooool007Gooooo0_l0000Booooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03ooo
ool2o`00017ooooo0_l0003Hooooo`00Moooool3o`00013ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo0ol0003Jooooo`00N_ooool2o`00
00oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo0_l0003Mooooo`00O?ooool3o`0000gooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0_l0003Oooooo`00Ooooool2o`0000cooooo
0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool3o`000>7ooooo
0021ooooo`;o00003?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo0_l0
000;ooooo`;o0000i?ooool008?ooooo0ol0000:ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`09ooooo`;o0000i_ooool008Kooooo0_l00009oooo
o`03o`000?oooooooooo00Cooooo1ooVi^H6ooooo`03o`000?oooooooooo00Oooooo0ol0003Xoooo
o`00R?ooool2o`0000Sooooo00Co0000oooooooooooooooo2ooVi^H3ooooo`03o`000?oooooooooo
00Kooooo0_l0003[ooooo`00R_ooool3o`0000Kooooo00?o0000oooooooVi^H03?oVi^H00ooooooo
0000ooooo`05ooooo`?o0000kOooool008gooooo0_l00005ooooo`ooi^KV1Oooool2o`000?3ooooo
002?ooooo`;o00000_oooolAonKViP;ooooo0_l0003booooo`00TOooool2o`00017oi^KV0_l0003d
ooooo`00T_oooolConKVi_Gooooo002Booooo`Koi^KV1_l00007onKVi_Gooooo002Booooo`Soi^KV
0_l00009onKVi_Gooooo002Booooo`Soi^KV0_l00009onKVi_Gooooo002Booooo`Soi^KV0_l00009
onKVi_Gooooo002Booooo`Ooi^KV1Ol00007onKVi_Gooooo002Booooo`Soi^KV0_l00009onKVi_Go
oooo002Cooooo`Soi^KV0ol00006onKVi_Kooooo002Coooooa7oi^KVm_ooool009Cooooo3ooVi^Kg
ooooo`00UOooool=onKVi_Sooooo002Fooooo`_oi^KVnOooool009Sooooo1ooVi^Kkooooo`00\
\>"],
  ImageRangeCache->{{{0, 409.75}, {252.875, 0}} -> {-2.23356, -0.833972, \
0.0143188, 0.00343234}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
delChromos = Join @@ Table[
Deletion[theChromos, 
  Templates -> {{{_f}, 1},
                {{_h}, 1},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

delChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]]]]], 
      chromo[q[undef], 
        p[f[A, g[B], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]], 
      chromo[q[undef], p[f[h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B]]], 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]]]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B]]], 
                  2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ B]]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> False,
            LabelSize -> 0.05, LabelColor -> 0.9
]& /@ delChromos;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.395554 0.185872 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.20428 .30902 -5 -6 ]
[.20428 .30902 5 6 ]
[.27164 .30902 -5 -6 ]
[.27164 .30902 5 6 ]
[.27164 .16187 -5 -6 ]
[.27164 .16187 5 6 ]
[.339 .30902 -5 -6 ]
[.339 .30902 5 6 ]
[.27164 .45617 -5 -6 ]
[.27164 .45617 5 6 ]
[.51947 .45617 -5 -6 ]
[.51947 .45617 5 6 ]
[.69994 .30902 -5 -6 ]
[.69994 .30902 5 6 ]
[.74485 .30902 -5 -6 ]
[.74485 .30902 5 6 ]
[.78975 .30902 -5 -6 ]
[.78975 .30902 5 6 ]
[.83466 .30902 -5 -6 ]
[.83466 .30902 5 6 ]
[.69312 .01472 -5.0625 -6 ]
[.69312 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.83466 .16187 -5 -6 ]
[.83466 .16187 5 6 ]
[.7673 .45617 -5 -6 ]
[.7673 .45617 5 6 ]
[.39555 .60332 -5 -6 ]
[.39555 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.39555 .60332 m
.02381 .45617 L
s
.39555 .60332 m
.27164 .45617 L
s
.39555 .60332 m
.51947 .45617 L
s
.39555 .60332 m
.7673 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.27164 .45617 m
.20428 .30902 L
s
.27164 .45617 m
.27164 .30902 L
s
.27164 .45617 m
.339 .30902 L
s
1 g
.05 w
.20428 .30902 Mdot
0 g
gsave
.20428 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.27164 .30902 m
.27164 .16187 L
s
.9 g
.05 w
.27164 .30902 Mdot
0 g
gsave
.27164 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.27164 .16187 Mdot
0 g
gsave
.27164 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.339 .30902 Mdot
0 g
gsave
.339 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.27164 .45617 Mdot
0 g
gsave
.27164 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.51947 .45617 Mdot
0 g
gsave
.51947 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7673 .45617 m
.69994 .30902 L
s
.7673 .45617 m
.74485 .30902 L
s
.7673 .45617 m
.78975 .30902 L
s
.7673 .45617 m
.83466 .30902 L
s
1 g
.05 w
.69994 .30902 Mdot
0 g
gsave
.69994 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.74485 .30902 Mdot
0 g
gsave
.74485 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.78975 .30902 Mdot
0 g
gsave
.78975 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.83466 .30902 m
.83466 .16187 L
s
.9 g
.05 w
.83466 .30902 Mdot
0 g
gsave
.83466 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.83466 .16187 m
.69312 .01472 L
s
.83466 .16187 m
.97619 .01472 L
s
1 g
.05 w
.69312 .01472 Mdot
0 g
gsave
.69312 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.83466 .16187 Mdot
0 g
gsave
.83466 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.7673 .45617 Mdot
0 g
gsave
.7673 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.9 g
.39555 .60332 Mdot
0 g
gsave
.39555 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00_Oooool7o`0004Kooooo1Ol0
000:ooooo`00_Oooool2o`0000;ooooo0_l00018ooooo`;o000000?oooooo`000?l000002Oooool0
0;gooooo1_l00018ooooo`;o000000?oooooo`000?l000002Oooool00;kooooo1?l00019ooooo`Co
00002_ooool00;kooooo1?l00019ooooo`;o000000?oooooo`000?l000002Oooool00;oooooo0_l0
001:ooooo`;o000000?oooooo`000?l000002Oooool00;kooooo0ol00019ooooo`Go00002_ooool0
0?oooooo6_ooool00<Gooooo00?o0000ooooooooool0DOooool00<Kooooo00?o0000ooooooooool0
?_ooool00ol0003oooooooooo`0?ooooo`00aoooool00ol0003oooooooooo`0looooo`03o`000?oo
oooooooo013ooooo0038ooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool04Oooool0
0<Wooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Booooo`00b_ooool00ol0003o
ooooooooo`0fooooo`03o`000?oooooooooo01?ooooo003;ooooo`03o`000?oooooooooo03Cooooo
00?o0000ooooooooool05?ooool00<cooooo00?o0000ooooooooool0<_ooool00ol0003ooooooooo
o`0Eooooo`00cOooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo01Kooooo003>oooo
o`03o`000?oooooooooo02kooooo00?o0000ooooooooool05oooool00<oooooo00?o0000oooooooo
ool0;?ooool00ol0003oooooooooo`0Hooooo`00d?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo01Wooooo003Aooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool06_oo
ool00=;ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Kooooo`00doooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo01cooooo003Cooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool07Oooool00=Cooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`0Nooooo`00eOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo003F
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool08?ooool00=Oooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`0Qooooo`00f?ooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02;ooooo003Iooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
8oooool00=[ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Tooooo`00foooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo02Gooooo003Looooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool09_ooool00=gooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0Wooooo`00g_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02Sooooo
003Oooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0:Oooool00>3ooooo00Co0000
oooooooooooooooo1OoVi^H3ooooo`03o`000?oooooooooo02[ooooo003Qooooo`03o`000?oVi^Ko
i^KV00Ooi^KV00?o0000ooooooooool0:oooool00>7ooooo0ooVi^H4o`0000Coi^KV;Oooool00>7o
oooo1_oVi^H2o`0000?oi^KV;Oooool004gooooo1?l0002?ooooo`Coi^KV1Ol00004onKViRcooooo
001>ooooo`;o0000T?ooool3onKViP;o00000_oVi^H2o`0000Coi^KV;?ooool004_ooooo1_l0002?
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^H/ooooo`00Boooool2o`000003ooooool0003o0000
093ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViRcooooo001<ooooo`Co0000T?ooool4onKViPKo
00000ooVi^H/ooooo`00COooool3o`00097ooooo2ooVi^H]ooooo`00C_ooool2o`00097ooooo2ooV
i^H]ooooo`00h_ooool9onKViRkooooo001>ooooo`03o`000?oooooooooo09?ooooo1OoVi^H`oooo
o`00C_ooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`00
0?oooooooooo09Gooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0UOoo
ool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2Eooooo`03o`000?oooooo
oooo033ooooo001>ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool0<?ooool004ko
oooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003ooooo
ooooo`2Eooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09Gooooo00?o
0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`0`
ooooo`00C_ooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo033ooooo001>ooooo`03
o`000?oooooooooo09Gooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0
UOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2Eooooo`03o`000?oo
oooooooo033ooooo001>ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool0<?ooool0
04kooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003o
ooooooooo`2Eooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09Gooooo
00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0UOooool00ol0003ooooooooo
o`0`ooooo`00C_ooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo033ooooo001>oooo
o`03o`000?oooooooooo09Gooooo00?o0000ooooooooool0<?ooool004kooooo00?o0000oooooooo
ool0UOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0003oooooooooo`2Eooooo`03o`00
0?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool0<?oo
ool004kooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`0`ooooo`00C_ooool00ol0
003oooooooooo`2Eooooo`03o`000?oooooooooo033ooooo001>ooooo`03o`000?oooooooooo09Go
oooo00?o0000ooooooooool0<?ooool004kooooo00?o0000ooooooooool0UOooool00ol0003ooooo
ooooo`0`ooooo`00C?ooool5onKViY?ooooo1OoVi^H`ooooo`00B_ooool9onKViXoooooo2OoVi^H^
ooooo`00BOooool3onKViPCo00001?oVi^J=ooooo`?oi^KV1?l00004onKViRgooooo0019ooooo`Ko
i^KV0_l00003onKViXgooooo1_oVi^H2o`0000?oi^KV;Oooool003Wooooo1Ol0000:ooooo`Coi^KV
1Ol00004onKViPWooooo1?l0001Nooooo`Co00001oooool5o`0000Oooooo1Ol00004ooooo`Coi^KV
1Ol00004onKViRcooooo000jooooo`;o000000?oooooo`000?l000002Oooool3onKViP;o00000_oV
i^H2o`0000Coi^KV2?ooool2o`0000;ooooo0_l0001Looooo`03o`000?oooooo000000[ooooo0_l0
00000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oV
i^H2o`0000Coi^KV;?ooool003[ooooo0_l000000ooooooo0000o`000009ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^H<ooooo`;o0000G?ooool00ol0003oooooo`000002o`0000Sooooo0_l00000
0ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool3onKViP;o00000_oVi^H2
o`0000Coi^KV;?ooool003[ooooo1?l0000:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^H:oooo
o`?o0000GOooool01Ol0003oooooo`000?oooooo000000Sooooo0_l000000ooooooo0000o`000007
ooooo`Co00001?ooool3onKViP;o00000_oVi^H2o`0000Coi^KV;?ooool003[ooooo0_l000000ooo
oooo0000o`000009ooooo`Coi^KV1_l00003onKViPcooooo0_l0001Mooooo`?o00002Oooool2o`00
0003ooooool0003o000000Oooooo0_l000000ooooooo0000o`000003ooooo`Coi^KV1_l00003onKV
iRcooooo000jooooo`;o000000?oooooo`000?l000002_ooool;onKViPWooooo0_l00002ooooo`;o
0000JOooool2o`000003ooooool0003o000000Oooooo0_l000000ooooooo0000o`000004ooooo`_o
i^KV;Oooool003Wooooo1Ol0000;ooooo`_oi^KV2_ooool4o`0006Wooooo1Ol00007ooooo`Go0000
1Oooool;onKViRgooooo001:ooooo`Woi^KVSoooool9onKViRkooooo000nooooo`03o`000?oooooo
oooo00_ooooo1OoVi^JCooooo`Goi^KV<?ooool003oooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<oooool003oo
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo06Go
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0<oooool0043ooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=?ooool0043ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo06Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0047ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06Wooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0=Oooool004;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo06_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool004;ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
=_ooool004?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo06gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0=oooool004?ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=oooool0
04?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
06gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0=oooool004Cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool004Cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06oooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0>?ooool004Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo077ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool004Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo077ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0>Oooool004Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo07?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0>_ooool004Kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo07?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0>_ooool004Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo07Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool0>oooool004Oooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo07Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool0>oooool004Oooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo07Gooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0>oooool004Sooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo07Oooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool004So
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo07Oo
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool0
04Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
07Wooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0000oooooo`00BOooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0NOooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0003oooooo001:ooooo`05o`000?oo
ooooooooooooool000000oooool00ol0003oooooooooo`1kooooo`06o`000?ooooooooooo`000?oo
oooo00000_ooool00ol0003oooooooooo`0nooooo`00B_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool0Noooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o
0000ooooooooool0?_ooool004_ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`1mooooo`07o`000?oooooo0000ooooool0003oooooo`000011ooooo`00Boooool00ol0003oi^KV
onKViP03onKViP03o`000?oooooooooo07gooooo00?o0000onKVi_oVi^H00ooVi^H00ol0003ooooo
ooooo`0oooooo`00B_ooool9onKViWgooooo2OoVi^I0ooooo`00BOooool3onKViPCo00001?oVi^Ik
ooooo`_oi^KV?oooool004Wooooo1_oVi^H2o`0000?oi^KVNoooool;onKViSoooooo0008ooooo`Oo
0000>Oooool4onKViPGo00001?oVi^Hiooooo`Go0000>oooool3onKViPOo00000ooVi^Hnooooo`00
2?ooool2o`0000;ooooo0_l0000jooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hjooooo`;o0000
00?oooooo`000?l00000>_ooool4onKViP;o000000?oi^KVo`000?l000001?oVi^Hnooooo`002?oo
ool6o`0003[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViS[ooooo0_l000000ooooooo0000o`00
000jooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSkooooo0009ooooo`Co0000>oooool3
onKViP;o00000_oVi^H2o`0000Coi^KV>_ooool2o`000003ooooool0003o000003[ooooo1?oVi^H2
o`000003onKVi_l0003o000000Coi^KV?_ooool000Wooooo1?l0000kooooo`Coi^KV1_l00003onKV
iS[ooooo0_l000000ooooooo0000o`00000jooooo`Coi^KV1?l00005onKViSkooooo000:ooooo`;o
00001_ooool3o`0003Cooooo2ooVi^Hkooooo`;o000000?oooooo`000?l00000=oooool3o`000004
oooooooVi^Koi^KVonKViP;o00001_oVi^Hoooooo`002Oooool3o`0000Wooooo0_l0000booooo`_o
i^KV>_ooool5o`0003Kooooo0_l00004ooooo`;oi^KV0ol00006onKViSoooooo000Gooooo`?o0000
<?ooool9onKViW?ooooo0ol00007ooooo`Woi^KV@?ooool001[ooooo0_l0000`ooooo`Goi^KV0_oo
ool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Gooooo0_l0000<ooooo`Goi^KV@_oo
ool001cooooo0ol0000dooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0<oooool3
o`0005Gooooo000Oooooo`;o0000<oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo
037ooooo0_l0001Hooooo`008Oooool3o`00037ooooo00?o0000ooooooooool0<_ooool00ol0003o
ooooooooo`0_ooooo`?o0000F_ooool002Cooooo0_l0000`ooooo`03o`000?oooooooooo033ooooo
00?o0000ooooooooool0;Oooool3o`0005gooooo000Vooooo`?o0000;_ooool00ol0003ooooooooo
o`0^ooooo`03o`000?oooooooooo02cooooo0_l0001Pooooo`00:Oooool2o`0002cooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0Zooooo`?o0000H_ooool002_ooooo0ol0000Zoooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:Oooool2o`0006Gooooo000^ooooo`;o
0000:Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Kooooo0ol0001Wooooo`00
<?ooool3o`0002Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Uooooo`;o0000
J_ooool003?ooooo0_l0000Vooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool08ooo
ool3o`0006cooooo000eooooo`?o00009?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo02;ooooo0_l0001_ooooo`00>?ooool2o`0002;ooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0Pooooo`?o0000LOooool003[ooooo0ol0000Pooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool07oooool2o`0007Cooooo000mooooo`;o00007oooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo01gooooo0ol0001fooooo`00?oooool3o`0001gooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0Kooooo`;o0000NOooool004;ooooo0_l0000L
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool06Oooool3o`0007_ooooo0014oooo
o`?o00006_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01Sooooo0_l0001noooo
o`00Aoooool2o`0001Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Fooooo`?o
0000P?ooool004Wooooo0ol0000Fooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
5Oooool2o`0008?ooooo001<ooooo`;o00005Oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01?ooooo0ol00025ooooo`00C_ooool3o`0001?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Booooo`;o0000R?ooool0057ooooo0_l0000Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool03oooool3o`0008[ooooo001Cooooo`?o00004?ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo00kooooo0_l0002=ooooo`00E_ooool2o`0000kooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`0<ooooo`?o0000Soooool005Sooooo0ol0
000<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool02_ooool3o`0009;ooooo001K
ooooo`;o00002oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo0_l0002E
ooooo`00GOooool3o`0000Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07oooo
o`?o0000Uoooool0063ooooo0_l00008ooooo`03o`000?oooooooooo00Goi^KV0oooool00ol0003o
ooooooooo`05ooooo`;o0000V_ooool006;ooooo0ol00005ooooo`03o`000?oVi^Koi^KV00Ooi^KV
00?o0000ooooooooool00oooool3o`0009cooooo001Uooooo`;o00000oooool;onKViP?ooooo0_l0
002Oooooo`00Ioooool3o`0000_oi^KV0ol0002Qooooo`00JOooool3onKViPKo00001?oVi^JSoooo
o`00JOooool5onKViP;o00001_oVi^JSooooo`00JOooool5onKViP;o00001_oVi^JSooooo`00JOoo
ool5onKViP;o00001_oVi^JSooooo`00JOooool4onKViPGo00001?oVi^JSooooo`00J_ooool4onKV
iP;o00001OoVi^JTooooo`00J_ooool5onKViP?o00000ooVi^JTooooo`00Joooool9onKViZGooooo
001]ooooo`Goi^KVYoooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.22477, -0.833972, \
0.0198739, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.25889 .30902 L
s
.9 g
.05 w
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.05 w
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00ZOooool7o`0005[ooooo1Ol0
000:ooooo`00ZOooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000002Oooool0
0:Wooooo1_l0001Looooo`;o000000?oooooo`000?l000002Oooool00:[ooooo1?l0001Mooooo`Co
00002_ooool00:[ooooo1?l0001Mooooo`;o000000?oooooo`000?l000002Oooool00:_ooooo0_l0
001Nooooo`;o000000?oooooo`000?l000002Oooool00:[ooooo0ol00004ooooo`03o`000?oooooo
oooo05Kooooo1Ol0000:ooooo`00/_ooool2o`0005;ooooo00?o0000ooooooooool04?ooool00;Co
oooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Aooooo`00]Oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01;ooooo002fooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool04oooool00;Oooooo00?o0000ooooooooool0Aoooool2o`0001Kooooo002hoooo
o`;o0000A_ooool00ol0003oooooooooo`0Fooooo`00^_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo01Oooooo002kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
6?ooool00;cooooo00?o0000ooooooooool0?Oooool2o`0001_ooooo002mooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool06oooool00;kooooo0_l0000jooooo`03o`000?oooooooooo
01cooooo0030ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool07Oooool00<7ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Nooooo`00`_ooool00ol0003ooooooooo
o`0aooooo`;o00008Oooool00<?ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Q
ooooo`00a?ooool2o`0002kooooo00?o0000ooooooooool08_ooool00<Kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0Sooooo`00aoooool00ol0003oooooooooo`0Wooooo`;o0000
9_ooool00<Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`00bOooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Oooooo003:ooooo`;o00008_ooool00ol0
003oooooooooo`0Xooooo`00c?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Wo
oooo003=ooooo`03o`000?oooooooooo01_ooooo0_l0000/ooooo`00c_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo02cooooo003?ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0;Oooool00=3ooooo0_l0000Fooooo`03o`000?oooooooooo02kooooo003Booooo`03
o`000?oooooooooo017ooooo0_l0000aooooo`00doooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo037ooooo003Dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0<_oo
ool00=Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000ooooooooool0<oooool0
0=Kooooo0_l00009onKViP03ooooool0003ooooo03Gooooo003Gooooo`?oi^KV1?l00004onKViSOo
oooo003Gooooo`Koi^KV0_l00003onKViSOooooo003Fooooo`Coi^KV1Ol00004onKViSKooooo003F
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hfooooo`00e_ooool3onKViP;o00000_oVi^H2o`00
00Coi^KV=_ooool00=Kooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo003Fooooo`Coi^KV
1_l00003onKViSKooooo003Gooooo`_oi^KV=oooool00=Oooooo2ooVi^Hgooooo`00f?ooool9onKV
iSSooooo003Jooooo`Goi^KV>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o
0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000oooo
ooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0
>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool0
0=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo
00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000
ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000oooooooo
ool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_oo
ool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=co
oooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o
0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000oooo
ooooool0>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=cooooo00?o0000ooooooooool0
>_ooool00=cooooo00?o0000ooooooooool0>_ooool00=[ooooo1OoVi^Hjooooo`00f?ooool9onKV
iSSooooo003Gooooo`?oi^KV1?l00004onKViSOooooo003Gooooo`Koi^KV0_l00003onKViSOooooo
0017ooooo`Go0000JOooool4o`0000Sooooo1Ol00007ooooo`Go00001?ooool4onKViPGo00001?oV
i^Hfooooo`00B?ooool2o`000003ooooool0003o000006Oooooo00?o0000ooooool000002oooool2
o`000003ooooool0003o000000Oooooo0_l000000ooooooo0000o`000003ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^Hfooooo`00B?ooool2o`000003ooooool0003o000006Oooooo00?o0000oooo
ool000000_l00009ooooo`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o0000
00?ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo0018ooooo`Co0000J?ooool01Ol0003o
ooooo`000?oooooo000000Wooooo0_l000000ooooooo0000o`000007ooooo`Co00001?ooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV=_ooool004Sooooo0_l000000ooooooo0000o`00001Xooooo`?o
00002_ooool2o`000003ooooool0003o000000Oooooo0_l000000ooooooo0000o`000003ooooo`Co
i^KV1_l00003onKViSKooooo0018ooooo`;o000000?oooooo`000?l00000MOooool2o`000003oooo
ool0003o000000Oooooo0_l000000ooooooo0000o`000004ooooo`_oi^KV=oooool004Oooooo1Ol0
001eooooo`Go00001oooool5o`0000Gooooo2ooVi^Hgooooo`00f?ooool9onKViSSooooo001:oooo
o`03o`000?oooooooooo06gooooo00?o0000ooooooooool07Oooool5onKViS[ooooo001:ooooo`03
o`000?oooooooooo06gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0?Oooool004[ooooo00?o0000ooooooooool0
K_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0mooooo`00B_ooool00ol0003oooooooooo`1^ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo03kooooo001:ooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool0
04[ooooo00?o0000ooooooooool0Koooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0oooooo`00B_ooool00ol0003o
ooooooooo`1_ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo03oooooo001:ooooo`03o`000?oooooooooo073ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0@?ooool004[ooooo00?o0000ooooooooool0L?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`10ooooo`00B_ooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo047ooooo001:oooo
o`03o`000?oooooooooo077ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool004[ooooo00?o0000oooooooo
ool0L_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`11ooooo`00B_ooool00ol0003oooooooooo`1booooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo04;ooooo001:ooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_oo
ool004[ooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`13ooooo`00B_ooool00ol0
003oooooooooo`1dooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo04?ooooo001:ooooo`03o`000?oooooooooo07Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0A?ooool004[ooooo00?o0000ooooooooool0MOooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`14ooooo`00B_ooool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo04Gooooo001:ooooo`03o`000?oo
oooooooo07Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0AOooool004[ooooo00?o0000ooooooooool0M_ooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`15ooooo`00B_oo
ool00ol0003oooooooooo`1gooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000004Sooooo001:ooooo`03o`000?oooooooooo07Oooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000B?ooool004[ooooo00?o0000oooooooo
ool0N?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004Wooooo001:oooo
o`03o`000?oooooooooo07Sooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0
0019ooooo`00B_ooool00ol0003oooooooooo`1hooooo`07o`000?ooooooooooooooool0003ooooo
o`000002ooooo`03o`000?oooooooooo04Sooooo001:ooooo`03o`000?oooooooooo07Wooooo00Ko
0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo04Sooooo001:ooooo`03o`00
0?oooooooooo07Wooooo00So0000oooooooooooo0000ooooool0003oooooo`0004_ooooo0018oooo
o`Goi^KVN_ooool5onKViP03ooooool0003ooooo04[ooooo0016ooooo`Woi^KVM_ooool9onKViT_o
oooo0015ooooo`?oi^KV1?l00004onKViWCooooo2ooVi^I:ooooo`00AOooool6onKViP;o00000ooV
i^Idooooo`_oi^KVB_ooool000Sooooo1ol0000eooooo`Coi^KV1Ol00004onKViSKooooo1Ol0000g
ooooo`Coi^KV1ol00002onKViSKooooo1_l0000=ooooo`002?ooool2o`0000;ooooo0_l0000foooo
o`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKV
iP;o000000?oi^KVo`000?l000000ooVi^Hgooooo`;o000000?oooooo`000?l000003Oooool000So
oooo1_l0000fooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l0
0000=_ooool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hhooooo`;o00003oooool000Wooooo
1?l0000gooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000
=_ooool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hiooooo`;o00003_ooool000Wooooo1?l0
0005ooooo`;o0000<?ooool4onKViPKo00000ooVi^Hgooooo`;o000000?oooooo`000?l00000=_oo
ool5onKViPCo00001?oVi^Haooooo`;o00000oooool2o`0000;ooooo0_l0000=ooooo`002_ooool2
o`0000Sooooo0ol0000^ooooo`_oi^KV00?o0000ooooooooool0=Oooool2o`000003ooooool0003o
000003Oooooo1?oVi^H2o`0000Goi^KV;oooool3o`0000Gooooo0_l00002ooooo`;o00003Oooool0
00Wooooo0ol0000;ooooo`?o0000:oooool;onKViP03ooooool0003ooooo03Cooooo1Ol0000goooo
o`04o`000?oVi^Koi^KVonKViP?o00001OoVi^H/ooooo`?o00002Oooool4o`0000kooooo000Joooo
o`?o0000:Oooool9onKViP?ooooo0_l0001]ooooo`;o00000_ooool9onKViR[ooooo0ol0000Noooo
o`007Oooool4o`0002Oooooo1OoVi^H7ooooo`03o`000?oooooooooo06Wooooo00?o0000oooooooo
ool01?ooool5onKViRSooooo1?l0000Qooooo`008Oooool3o`00037ooooo0_l0000cooooo`03o`00
0?oooooooooo037ooooo0_l0000aooooo`?o00009Oooool002Cooooo0ol0000`ooooo`;o0000<Ooo
ool00ol0003oooooooooo`0_ooooo`;o0000<?ooool3o`0002Sooooo000Wooooo`?o0000;oooool0
0ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool3
o`0002_ooooo000Zooooo`?o0000;Oooool2o`0002kooooo00?o0000ooooooooool0;?ooool2o`00
02gooooo0ol0000^ooooo`00;Oooool4o`0002_ooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0[ooooo`03o`000?oooooooooo02Wooooo1?l0000aooooo`00<Oooool3o`0002Wooooo
0_l0000[ooooo`03o`000?oooooooooo02Wooooo0_l0000Yooooo`?o0000=Oooool003Cooooo0ol0
000Xooooo`;o0000:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0003Sooooo000g
ooooo`?o00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool09Oooool3o`0003_ooooo000jooooo`?o00009Oooool2o`0002Kooooo00?o0000oooo
ooooool09?ooool2o`0002Gooooo0ol0000nooooo`00?Oooool3o`0002Cooooo00?o0000oooooooo
ool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0ol00011ooooo`00
@?ooool4o`00027ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Qooooo`Co0000
A?ooool004Cooooo0ol0000Pooooo`;o00008Oooool00ol0003oooooooooo`0Oooooo`;o00008?oo
ool3o`0004Sooooo0017ooooo`?o00007oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool07Oooool3o`0004_ooooo001:ooooo`?o00007Oooool2o`00
01kooooo00?o0000ooooooooool07?ooool2o`0001gooooo0ol0001>ooooo`00COooool3o`0001co
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[o
oooo0ol0001Aooooo`00D?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo
0_l0000Jooooo`?o0000E?ooool005?ooooo1?l0000Hooooo`;o00006Oooool00ol0003ooooooooo
o`0Gooooo`;o00006?ooool4o`0005Oooooo001Gooooo`?o00005oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool3o`0005_ooooo001Joooo
o`?o00005Oooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001Noooo
o`00GOooool3o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo01;ooooo0ol0001Qooooo`00H?ooool3o`0001;ooooo0_l0000Cooooo`03o`00
0?oooooooooo017ooooo0_l0000Booooo`?o0000I?ooool006?ooooo0ol0000Aooooo`;o00004Ooo
ool00ol0003oooooooooo`0?ooooo`;o00004Oooool3o`0006Oooooo001Vooooo`Co00003oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool4
o`0006[ooooo001Zooooo`?o00003Oooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`00
00gooooo0ol0001^ooooo`00KOooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo0ol0001aooooo`00L?ooool3o`0000[ooooo
0_l0000;ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000M?ooool007?ooooo0ol0
0009ooooo`;o00002Oooool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`0007Oooooo001f
ooooo`Co00001oooool00ol0003oooooooooo`04ooooo`Goi^KV1_ooool00ol0003oooooooooo`05
ooooo`Co0000N_ooool007[ooooo0ol00005ooooo`;o00000_ooool9onKViP;ooooo0_l00005oooo
o`?o0000O_ooool007gooooo0ol00004ooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000oooooooo
ool00_ooool3o`00087ooooo0020ooooo`?o00000_ooool;onKViP;ooooo0ol00024ooooo`00Pooo
ool01?l0003oi^KVonKVi_oVi^H6o`0000Coi^KV00?o0000ooooooooool0QOooool008Cooooo1OoV
i^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`00
00Koi^KVR?ooool008Cooooo1?oVi^H5o`0000Coi^KVR?ooool008Gooooo1?oVi^H2o`0000Goi^KV
ROooool008Gooooo1OoVi^H3o`0000?oi^KVROooool008Kooooo2OoVi^J:ooooo`00R?ooool5onKV
iXcooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17772, -0.833972, \
0.0157141, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00ZOooool7o`0005[ooooo1Ol0
000:ooooo`00ZOooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000002Oooool0
0:Wooooo1_l0001Looooo`;o000000?oooooo`000?l000002Oooool00:[ooooo1?l0001Mooooo`Co
00002_ooool00:[ooooo1?l0001Mooooo`;o000000?oooooo`000?l000002Oooool00:_ooooo0_l0
001Nooooo`;o000000?oooooo`000?l000002Oooool00:[ooooo0ol00004ooooo`03o`000?oooooo
oooo05Kooooo1Ol0000:ooooo`00/_ooool2o`0005;ooooo00?o0000ooooooooool04?ooool00;Co
oooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Aooooo`00]Oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01;ooooo002fooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool04oooool00;Oooooo00?o0000ooooooooool0Aoooool2o`0001Kooooo002hoooo
o`;o0000A_ooool00ol0003oooooooooo`0Fooooo`00^_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo01Oooooo002kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
6?ooool00;cooooo00?o0000ooooooooool0?Oooool2o`0001_ooooo002mooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool06oooool00;kooooo0_l0000jooooo`03o`000?oooooooooo
01cooooo0030ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool07Oooool00<7ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Nooooo`00`_ooool00ol0003ooooooooo
o`0aooooo`;o00008Oooool00<?ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Q
ooooo`00a?ooool2o`0002kooooo00?o0000ooooooooool08_ooool00<Kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0Sooooo`00aoooool00ol0003oooooooooo`0Wooooo`;o0000
9_ooool00<Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`00bOooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Oooooo003:ooooo`;o00008_ooool00ol0
003oooooooooo`0Xooooo`00c?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Wo
oooo003=ooooo`03o`000?oooooooooo01_ooooo0_l0000/ooooo`00c_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo02cooooo003?ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0;Oooool00=3ooooo0_l0000Fooooo`03o`000?oooooooooo02kooooo003Booooo`03
o`000?oooooooooo017ooooo0_l0000aooooo`00doooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo037ooooo003Dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0<_oo
ool00=Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000ooooooooool0<oooool0
0=Kooooo0_l00009onKViP03ooooool0003ooooo03Gooooo003Gooooo`?oi^KV1?l00004onKViSOo
oooo003Gooooo`Koi^KV0_l00003onKViSOooooo0019ooooo`Co0000ROooool4onKViPGo00001?oV
i^Hfooooo`00B_ooool2o`0008[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo0017oooo
o`Ko0000ROooool3onKViP;o00000_oVi^H2o`0000Coi^KV=_ooool004Oooooo0_l000000ooooooo
0000o`00002:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hfooooo`00B?ooool4o`0008[ooooo
1?oVi^H6o`0000?oi^KV=_ooool004Wooooo0ol0002;ooooo`_oi^KV=oooool004[ooooo0_l0002;
ooooo`_oi^KV=oooool00=Sooooo2OoVi^Hhooooo`00B_ooool00ol0003oooooooooo`2=ooooo`Go
i^KV>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooo
oooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0
003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[o
oooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000oooo
ooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00
B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oo
oooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool0
0ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo
03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooooooo
o`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000
ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0joooo
o`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`00
0?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Sooo
ool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooo
oooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[o
oooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooo
ooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o
0000ooooooooool0>_ooool004Sooooo1OoVi^J=ooooo`Goi^KV>_ooool004Kooooo2OoVi^J9oooo
o`Woi^KV>?ooool004Gooooo0ooVi^H4o`0000Coi^KVQoooool3onKViPCo00001?oVi^Hgooooo`00
AOooool6onKViP;o00000ooVi^J7ooooo`Koi^KV0_l00003onKViSOooooo000eooooo`Go00002_oo
ool4onKViPGo00001?oVi^H:ooooo`Co0000E_ooool4o`0000Sooooo1Ol00007ooooo`Go00001?oo
ool4onKViPGo00001?oVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000Wooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViPWooooo0_l00002ooooo`;o0000E?ooool00ol0003oooooo`00000;
ooooo`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o000000?oooooo`000?l000002Oooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV3Oooool2o`0005Cooooo00?o0000ooooool000000_l00009oooo
o`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2o`00
00;oi^KV0_l00004onKViSKooooo000fooooo`Co00002_ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV2oooool3o`0005Gooooo00Go0000ooooool0003oooooo`000009ooooo`;o000000?oooooo`00
0?l000001oooool4o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o
000000?oooooo`000?l000002Oooool4onKViPKo00000ooVi^H=ooooo`;o0000EOooool3o`0000[o
oooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool4onKViPKo
00000ooVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000[ooooo2ooVi^H:ooooo`;o0000
0_ooool2o`0006;ooooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l00000
1?ooool;onKViSOooooo000eooooo`Go00002oooool;onKViP_ooooo1?l0001Rooooo`Go00001ooo
ool5o`0000Gooooo2ooVi^Hgooooo`00A_ooool9onKViXWooooo2OoVi^Hhooooo`00B?ooool5onKV
iPgooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0Mooooo`Goi^KV>_ooool003_o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05go
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0?Oooool003_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?Oooool003cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0?_ooool003cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool003gooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo067ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0?oooool003gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0?oooool003kooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
@?ooool003kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo06?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0@?ooool003oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0
03oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0@Oooool003oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0043ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo06Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0@_ooool0043ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_ooool0047ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0@oooool0047ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo06_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@oooool004;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo06_ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0A?ooool004;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo06gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0A?ooool004?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0AOooool004?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06oooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
AOooool004?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo06oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0AOooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000B?ooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000B?ooool004Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo07?ooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`00AOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0Loooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0004Wooooo0016ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`1cooooo`07o`000?ooooooooooooooool0003oooooo`000002ooooo`03o`000?oooooooooo04So
oooo0016ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1eooooo`06
o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`18ooooo`00Aoooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo07Gooooo00So0000oooooooooooo0000oooo
ool0003oooooo`0004_ooooo0017ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0
Moooool5onKViP03ooooool0003ooooo04[ooooo0016ooooo`Woi^KVM_ooool9onKViT_ooooo0015
ooooo`?oi^KV1?l00004onKViWCooooo2ooVi^I:ooooo`00AOooool6onKViP;o00000ooVi^Idoooo
o`_oi^KVB_ooool000Sooooo1ol0000eooooo`Coi^KV1Ol00004onKViSKooooo1Ol0000gooooo`Co
i^KV1ol00002onKViSKooooo1_l0000=ooooo`002?ooool2o`0000;ooooo0_l0000fooooo`?oi^KV
0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKViP;o0000
00?oi^KVo`000?l000000ooVi^Hgooooo`;o000000?oooooo`000?l000003Oooool000Sooooo1_l0
000fooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_oo
ool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hhooooo`;o00003oooool000Wooooo1?l0000g
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5
onKViP;o000000?oi^KVo`000?l000000ooVi^Hiooooo`;o00003_ooool000Wooooo1?l00005oooo
o`;o0000<?ooool4onKViPKo00000ooVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKV
iPCo00001?oVi^Haooooo`;o00000oooool2o`0000;ooooo0_l0000=ooooo`002_ooool2o`0000So
oooo0ol0000^ooooo`_oi^KV00?o0000ooooooooool0=Oooool2o`000003ooooool0003o000003Oo
oooo1?oVi^H2o`0000Goi^KV;oooool3o`0000Gooooo0_l00002ooooo`;o00003Oooool000Wooooo
0ol0000;ooooo`?o0000:oooool;onKViP03ooooool0003ooooo03Cooooo1Ol0000gooooo`04o`00
0?oVi^Koi^KVonKViP?o00001OoVi^H/ooooo`?o00002Oooool4o`0000kooooo000Jooooo`?o0000
:Oooool9onKViP?ooooo0_l0001]ooooo`;o00000_ooool9onKViR[ooooo0ol0000Nooooo`007Ooo
ool4o`0002Oooooo1OoVi^H7ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?oo
ool5onKViRSooooo1?l0000Qooooo`008Oooool3o`00037ooooo0_l0000cooooo`03o`000?oooooo
oooo037ooooo0_l0000aooooo`?o00009Oooool002Cooooo0ol0000`ooooo`;o0000<Oooool00ol0
003oooooooooo`0_ooooo`;o0000<?ooool3o`0002Sooooo000Wooooo`?o0000;oooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool3o`0002_o
oooo000Zooooo`?o0000;Oooool2o`0002kooooo00?o0000ooooooooool0;?ooool2o`0002gooooo
0ol0000^ooooo`00;Oooool4o`0002_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02Wooooo1?l0000aooooo`00<Oooool3o`0002Wooooo0_l0000[
ooooo`03o`000?oooooooooo02Wooooo0_l0000Yooooo`?o0000=Oooool003Cooooo0ol0000Xoooo
o`;o0000:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0003Sooooo000gooooo`?o
00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool09Oooool3o`0003_ooooo000jooooo`?o00009Oooool2o`0002Kooooo00?o0000ooooooooool0
9?ooool2o`0002Gooooo0ol0000nooooo`00?Oooool3o`0002Cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0ol00011ooooo`00@?ooool4
o`00027ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Qooooo`Co0000A?ooool0
04Cooooo0ol0000Pooooo`;o00008Oooool00ol0003oooooooooo`0Oooooo`;o00008?ooool3o`00
04Sooooo0017ooooo`?o00007oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07Oooool3o`0004_ooooo001:ooooo`?o00007Oooool2o`0001kooooo
00?o0000ooooooooool07?ooool2o`0001gooooo0ol0001>ooooo`00COooool3o`0001cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[ooooo0ol0
001Aooooo`00D?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000J
ooooo`?o0000E?ooool005?ooooo1?l0000Hooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`;o00006?ooool4o`0005Oooooo001Gooooo`?o00005oooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool3o`0005_ooooo001Jooooo`?o0000
5Oooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001Nooooo`00GOoo
ool3o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01;ooooo0ol0001Qooooo`00H?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooo
oooo017ooooo0_l0000Booooo`?o0000I?ooool006?ooooo0ol0000Aooooo`;o00004Oooool00ol0
003oooooooooo`0?ooooo`;o00004Oooool3o`0006Oooooo001Vooooo`Co00003oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool4o`0006[o
oooo001Zooooo`?o00003Oooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000gooooo
0ol0001^ooooo`00KOooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00[ooooo0ol0001aooooo`00L?ooool3o`0000[ooooo0_l0000;
ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000M?ooool007?ooooo0ol00009oooo
o`;o00002Oooool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`0007Oooooo001fooooo`Co
00001oooool00ol0003oooooooooo`04ooooo`Goi^KV1_ooool00ol0003oooooooooo`05ooooo`Co
0000N_ooool007[ooooo0ol00005ooooo`;o00000_ooool9onKViP;ooooo0_l00005ooooo`?o0000
O_ooool007gooooo0ol00004ooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000ooooooooool00_oo
ool3o`00087ooooo0020ooooo`?o00000_ooool;onKViP;ooooo0ol00024ooooo`00Poooool01?l0
003oi^KVonKVi_oVi^H6o`0000Coi^KV00?o0000ooooooooool0QOooool008Cooooo1OoVi^H2o`00
00Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KV
R?ooool008Cooooo1?oVi^H5o`0000Coi^KVR?ooool008Gooooo1?oVi^H2o`0000Goi^KVROooool0
08Gooooo1OoVi^H3o`0000?oi^KVROooool008Kooooo2OoVi^J:ooooo`00R?ooool5onKViXcooooo
0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17772, -0.833972, \
0.0157141, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00ZOooool7o`0005[ooooo1Ol0
000:ooooo`00ZOooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000002Oooool0
0:Wooooo1_l0001Looooo`;o000000?oooooo`000?l000002Oooool00:[ooooo1?l0001Mooooo`Co
00002_ooool00:[ooooo1?l0001Mooooo`;o000000?oooooo`000?l000002Oooool00:_ooooo0_l0
001Nooooo`;o000000?oooooo`000?l000002Oooool00:[ooooo0ol00004ooooo`03o`000?oooooo
oooo05Kooooo1Ol0000:ooooo`00/_ooool2o`0005;ooooo00?o0000ooooooooool04?ooool00;Co
oooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Aooooo`00]Oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01;ooooo002fooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool04oooool00;Oooooo00?o0000ooooooooool0Aoooool2o`0001Kooooo002hoooo
o`;o0000A_ooool00ol0003oooooooooo`0Fooooo`00^_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo01Oooooo002kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
6?ooool00;cooooo00?o0000ooooooooool0?Oooool2o`0001_ooooo002mooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool06oooool00;kooooo0_l0000jooooo`03o`000?oooooooooo
01cooooo0030ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool07Oooool00<7ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Nooooo`00`_ooool00ol0003ooooooooo
o`0aooooo`;o00008Oooool00<?ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Q
ooooo`00a?ooool2o`0002kooooo00?o0000ooooooooool08_ooool00<Kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0Sooooo`00aoooool00ol0003oooooooooo`0Wooooo`;o0000
9_ooool00<Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`00bOooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Oooooo003:ooooo`;o00008_ooool00ol0
003oooooooooo`0Xooooo`00c?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Wo
oooo003=ooooo`03o`000?oooooooooo01_ooooo0_l0000/ooooo`00c_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo02cooooo003?ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0;Oooool00=3ooooo0_l0000Fooooo`03o`000?oooooooooo02kooooo003Booooo`03
o`000?oooooooooo017ooooo0_l0000aooooo`00doooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo037ooooo003Dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0<_oo
ool00=Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000ooooooooool0<oooool0
0=Kooooo0_l00009onKViP03ooooool0003ooooo03Gooooo003Gooooo`?oi^KV1?l00004onKViSOo
oooo003Gooooo`Koi^KV0_l00003onKViSOooooo0019ooooo`Co0000ROooool4onKViPGo00001?oV
i^Hfooooo`00B_ooool2o`0008[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo0017oooo
o`Ko0000ROooool3onKViP;o00000_oVi^H2o`0000Coi^KV=_ooool004Oooooo0_l000000ooooooo
0000o`00002:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hfooooo`00B?ooool4o`0008[ooooo
1?oVi^H6o`0000?oi^KV=_ooool004Wooooo0ol0002;ooooo`_oi^KV=oooool004[ooooo0_l0002;
ooooo`_oi^KV=oooool00=Sooooo2OoVi^Hhooooo`00B_ooool00ol0003oooooooooo`2=ooooo`Go
i^KV>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooo
oooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0
003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[o
oooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000oooo
ooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00
B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oo
oooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool0
0ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo
03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooooooo
o`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000
ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0joooo
o`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`00
0?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Sooo
ool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooo
oooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[o
oooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooo
ooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o
0000ooooooooool0>_ooool004Sooooo1OoVi^J=ooooo`Goi^KV>_ooool004Kooooo2OoVi^J9oooo
o`Woi^KV>?ooool004Gooooo0ooVi^H4o`0000Coi^KVQoooool3onKViPCo00001?oVi^Hgooooo`00
AOooool6onKViP;o00000ooVi^J7ooooo`Koi^KV0_l00003onKViSOooooo000eooooo`Go00002_oo
ool4onKViPGo00001?oVi^H:ooooo`Co0000E_ooool4o`0000Sooooo1Ol00007ooooo`Go00001?oo
ool4onKViPGo00001?oVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000Wooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViPWooooo0_l00002ooooo`;o0000E?ooool00ol0003oooooo`00000;
ooooo`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o000000?oooooo`000?l000002Oooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV3Oooool2o`0005Cooooo00?o0000ooooool000000_l00009oooo
o`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2o`00
00;oi^KV0_l00004onKViSKooooo000fooooo`Co00002_ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV2oooool3o`0005Gooooo00Go0000ooooool0003oooooo`000009ooooo`;o000000?oooooo`00
0?l000001oooool4o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o
000000?oooooo`000?l000002Oooool4onKViPKo00000ooVi^H=ooooo`;o0000EOooool3o`0000[o
oooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool4onKViPKo
00000ooVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000[ooooo2ooVi^H:ooooo`;o0000
0_ooool2o`0006;ooooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l00000
1?ooool;onKViSOooooo000eooooo`Go00002oooool;onKViP_ooooo1?l0001Rooooo`Go00001ooo
ool5o`0000Gooooo2ooVi^Hgooooo`00A_ooool9onKViXWooooo2OoVi^Hhooooo`00B?ooool5onKV
iPgooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0Mooooo`Goi^KV>_ooool003_o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05go
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0?Oooool003_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?Oooool003cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0?_ooool003cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool003gooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo067ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0?oooool003gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0?oooool003kooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
@?ooool003kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo06?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0@?ooool003oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0
03oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0@Oooool003oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0043ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo06Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0@_ooool0043ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_ooool0047ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0@oooool0047ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo06_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@oooool004;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo06_ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0A?ooool004;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo06gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0A?ooool004?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0AOooool004?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06oooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
AOooool004?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo06oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0AOooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000B?ooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000B?ooool004Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo07?ooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`00AOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0Loooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0004Wooooo0016ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`1cooooo`07o`000?ooooooooooooooool0003oooooo`000002ooooo`03o`000?oooooooooo04So
oooo0016ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1eooooo`06
o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`18ooooo`00Aoooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo07Gooooo00So0000oooooooooooo0000oooo
ool0003oooooo`0004_ooooo0017ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0
Moooool5onKViP03ooooool0003ooooo04[ooooo0016ooooo`Woi^KVM_ooool9onKViT_ooooo0015
ooooo`?oi^KV1?l00004onKViWCooooo2ooVi^I:ooooo`00AOooool6onKViP;o00000ooVi^Idoooo
o`_oi^KVB_ooool000Sooooo1ol0000eooooo`Coi^KV1Ol00004onKViSKooooo1Ol0000gooooo`Co
i^KV1ol00002onKViSKooooo1_l0000=ooooo`002?ooool2o`0000;ooooo0_l0000fooooo`?oi^KV
0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKViP;o0000
00?oi^KVo`000?l000000ooVi^Hgooooo`;o000000?oooooo`000?l000003Oooool000Sooooo1_l0
000fooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_oo
ool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hhooooo`;o00003oooool000Wooooo1?l0000g
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5
onKViP;o000000?oi^KVo`000?l000000ooVi^Hiooooo`;o00003_ooool000Wooooo1?l00005oooo
o`;o0000<?ooool4onKViPKo00000ooVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKV
iPCo00001?oVi^Haooooo`;o00000oooool2o`0000;ooooo0_l0000=ooooo`002_ooool2o`0000So
oooo0ol0000^ooooo`_oi^KV00?o0000ooooooooool0=Oooool2o`000003ooooool0003o000003Oo
oooo1?oVi^H2o`0000Goi^KV;oooool3o`0000Gooooo0_l00002ooooo`;o00003Oooool000Wooooo
0ol0000;ooooo`?o0000:oooool;onKViP03ooooool0003ooooo03Cooooo1Ol0000gooooo`04o`00
0?oVi^Koi^KVonKViP?o00001OoVi^H/ooooo`?o00002Oooool4o`0000kooooo000Jooooo`?o0000
:Oooool9onKViP?ooooo0_l0001]ooooo`;o00000_ooool9onKViR[ooooo0ol0000Nooooo`007Ooo
ool4o`0002Oooooo1OoVi^H7ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?oo
ool5onKViRSooooo1?l0000Qooooo`008Oooool3o`00037ooooo0_l0000cooooo`03o`000?oooooo
oooo037ooooo0_l0000aooooo`?o00009Oooool002Cooooo0ol0000`ooooo`;o0000<Oooool00ol0
003oooooooooo`0_ooooo`;o0000<?ooool3o`0002Sooooo000Wooooo`?o0000;oooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool3o`0002_o
oooo000Zooooo`?o0000;Oooool2o`0002kooooo00?o0000ooooooooool0;?ooool2o`0002gooooo
0ol0000^ooooo`00;Oooool4o`0002_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02Wooooo1?l0000aooooo`00<Oooool3o`0002Wooooo0_l0000[
ooooo`03o`000?oooooooooo02Wooooo0_l0000Yooooo`?o0000=Oooool003Cooooo0ol0000Xoooo
o`;o0000:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0003Sooooo000gooooo`?o
00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool09Oooool3o`0003_ooooo000jooooo`?o00009Oooool2o`0002Kooooo00?o0000ooooooooool0
9?ooool2o`0002Gooooo0ol0000nooooo`00?Oooool3o`0002Cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0ol00011ooooo`00@?ooool4
o`00027ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Qooooo`Co0000A?ooool0
04Cooooo0ol0000Pooooo`;o00008Oooool00ol0003oooooooooo`0Oooooo`;o00008?ooool3o`00
04Sooooo0017ooooo`?o00007oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07Oooool3o`0004_ooooo001:ooooo`?o00007Oooool2o`0001kooooo
00?o0000ooooooooool07?ooool2o`0001gooooo0ol0001>ooooo`00COooool3o`0001cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[ooooo0ol0
001Aooooo`00D?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000J
ooooo`?o0000E?ooool005?ooooo1?l0000Hooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`;o00006?ooool4o`0005Oooooo001Gooooo`?o00005oooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool3o`0005_ooooo001Jooooo`?o0000
5Oooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001Nooooo`00GOoo
ool3o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01;ooooo0ol0001Qooooo`00H?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooo
oooo017ooooo0_l0000Booooo`?o0000I?ooool006?ooooo0ol0000Aooooo`;o00004Oooool00ol0
003oooooooooo`0?ooooo`;o00004Oooool3o`0006Oooooo001Vooooo`Co00003oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool4o`0006[o
oooo001Zooooo`?o00003Oooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000gooooo
0ol0001^ooooo`00KOooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00[ooooo0ol0001aooooo`00L?ooool3o`0000[ooooo0_l0000;
ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000M?ooool007?ooooo0ol00009oooo
o`;o00002Oooool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`0007Oooooo001fooooo`Co
00001oooool00ol0003oooooooooo`04ooooo`Goi^KV1_ooool00ol0003oooooooooo`05ooooo`Co
0000N_ooool007[ooooo0ol00005ooooo`;o00000_ooool9onKViP;ooooo0_l00005ooooo`?o0000
O_ooool007gooooo0ol00004ooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000ooooooooool00_oo
ool3o`00087ooooo0020ooooo`?o00000_ooool;onKViP;ooooo0ol00024ooooo`00Poooool01?l0
003oi^KVonKVi_oVi^H6o`0000Coi^KV00?o0000ooooooooool0QOooool008Cooooo1OoVi^H2o`00
00Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KV
R?ooool008Cooooo1?oVi^H5o`0000Coi^KVR?ooool008Gooooo1?oVi^H2o`0000Goi^KVROooool0
08Gooooo1OoVi^H3o`0000?oi^KVROooool008Kooooo2OoVi^J:ooooo`00R?ooool5onKViXcooooo
0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17772, -0.833972, \
0.0157141, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00ZOooool7o`0005[ooooo1Ol0
000:ooooo`00ZOooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000002Oooool0
0:Wooooo1_l0001Looooo`;o000000?oooooo`000?l000002Oooool00:[ooooo1?l0001Mooooo`Co
00002_ooool00:[ooooo1?l0001Mooooo`;o000000?oooooo`000?l000002Oooool00:_ooooo0_l0
001Nooooo`;o000000?oooooo`000?l000002Oooool00:[ooooo0ol00004ooooo`03o`000?oooooo
oooo05Kooooo1Ol0000:ooooo`00/_ooool2o`0005;ooooo00?o0000ooooooooool04?ooool00;Co
oooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Aooooo`00]Oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01;ooooo002fooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool04oooool00;Oooooo00?o0000ooooooooool0Aoooool2o`0001Kooooo002hoooo
o`;o0000A_ooool00ol0003oooooooooo`0Fooooo`00^_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo01Oooooo002kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
6?ooool00;cooooo00?o0000ooooooooool0?Oooool2o`0001_ooooo002mooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool06oooool00;kooooo0_l0000jooooo`03o`000?oooooooooo
01cooooo0030ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool07Oooool00<7ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Nooooo`00`_ooool00ol0003ooooooooo
o`0aooooo`;o00008Oooool00<?ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Q
ooooo`00a?ooool2o`0002kooooo00?o0000ooooooooool08_ooool00<Kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0Sooooo`00aoooool00ol0003oooooooooo`0Wooooo`;o0000
9_ooool00<Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`00bOooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Oooooo003:ooooo`;o00008_ooool00ol0
003oooooooooo`0Xooooo`00c?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Wo
oooo003=ooooo`03o`000?oooooooooo01_ooooo0_l0000/ooooo`00c_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo02cooooo003?ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0;Oooool00=3ooooo0_l0000Fooooo`03o`000?oooooooooo02kooooo003Booooo`03
o`000?oooooooooo017ooooo0_l0000aooooo`00doooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo037ooooo003Dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0<_oo
ool00=Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000ooooooooool0<oooool0
0=Kooooo0_l00009onKViP03ooooool0003ooooo03Gooooo003Gooooo`?oi^KV1?l00004onKViSOo
oooo003Gooooo`Koi^KV0_l00003onKViSOooooo0019ooooo`Co0000ROooool4onKViPGo00001?oV
i^Hfooooo`00B_ooool2o`0008[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo0017oooo
o`Ko0000ROooool3onKViP;o00000_oVi^H2o`0000Coi^KV=_ooool004Oooooo0_l000000ooooooo
0000o`00002:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hfooooo`00B?ooool4o`0008[ooooo
1?oVi^H6o`0000?oi^KV=_ooool004Wooooo0ol0002;ooooo`_oi^KV=oooool004[ooooo0_l0002;
ooooo`_oi^KV=oooool00=Sooooo2OoVi^Hhooooo`00B_ooool00ol0003oooooooooo`2=ooooo`Go
i^KV>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooo
oooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0
003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[o
oooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000oooo
ooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00
B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oo
oooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool0
0ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo
03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooooooo
o`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000
ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0joooo
o`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`00
0?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Sooo
ool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooo
oooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[o
oooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooo
ooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o
0000ooooooooool0>_ooool004Sooooo1OoVi^J=ooooo`Goi^KV>_ooool004Kooooo2OoVi^J9oooo
o`Woi^KV>?ooool004Gooooo0ooVi^H4o`0000Coi^KVQoooool3onKViPCo00001?oVi^Hgooooo`00
AOooool6onKViP;o00000ooVi^J7ooooo`Koi^KV0_l00003onKViSOooooo000eooooo`Go00002_oo
ool4onKViPGo00001?oVi^H:ooooo`Co0000E_ooool4o`0000Sooooo1Ol00007ooooo`Go00001?oo
ool4onKViPGo00001?oVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000Wooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViPWooooo0_l00002ooooo`;o0000E?ooool00ol0003oooooo`00000;
ooooo`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o000000?oooooo`000?l000002Oooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV3Oooool2o`0005Cooooo00?o0000ooooool000000_l00009oooo
o`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2o`00
00;oi^KV0_l00004onKViSKooooo000fooooo`Co00002_ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV2oooool3o`0005Gooooo00Go0000ooooool0003oooooo`000009ooooo`;o000000?oooooo`00
0?l000001oooool4o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o
000000?oooooo`000?l000002Oooool4onKViPKo00000ooVi^H=ooooo`;o0000EOooool3o`0000[o
oooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool4onKViPKo
00000ooVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000[ooooo2ooVi^H:ooooo`;o0000
0_ooool2o`0006;ooooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l00000
1?ooool;onKViSOooooo000eooooo`Go00002oooool;onKViP_ooooo1?l0001Rooooo`Go00001ooo
ool5o`0000Gooooo2ooVi^Hgooooo`00A_ooool9onKViXWooooo2OoVi^Hhooooo`00B?ooool5onKV
iPgooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0Mooooo`Goi^KV>_ooool003_o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05go
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0?Oooool003_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?Oooool003cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0?_ooool003cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool003gooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo067ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0?oooool003gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0?oooool003kooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
@?ooool003kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo06?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0@?ooool003oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0
03oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0@Oooool003oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0043ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo06Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0@_ooool0043ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_ooool0047ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0@oooool0047ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo06_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@oooool004;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo06_ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0A?ooool004;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo06gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0A?ooool004?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0AOooool004?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06oooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
AOooool004?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo06oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0AOooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000B?ooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000B?ooool004Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo07?ooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`00AOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0Loooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0004Wooooo0016ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`1cooooo`07o`000?ooooooooooooooool0003oooooo`000002ooooo`03o`000?oooooooooo04So
oooo0016ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1eooooo`06
o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`18ooooo`00Aoooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo07Gooooo00So0000oooooooooooo0000oooo
ool0003oooooo`0004_ooooo0017ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0
Moooool5onKViP03ooooool0003ooooo04[ooooo0016ooooo`Woi^KVM_ooool9onKViT_ooooo0015
ooooo`?oi^KV1?l00004onKViWCooooo2ooVi^I:ooooo`00AOooool6onKViP;o00000ooVi^Idoooo
o`_oi^KVB_ooool000Sooooo1ol0000eooooo`Coi^KV1Ol00004onKViSKooooo1Ol0000gooooo`Co
i^KV1ol00002onKViSKooooo1_l0000=ooooo`002?ooool2o`0000;ooooo0_l0000fooooo`?oi^KV
0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKViP;o0000
00?oi^KVo`000?l000000ooVi^Hgooooo`;o000000?oooooo`000?l000003Oooool000Sooooo1_l0
000fooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_oo
ool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hhooooo`;o00003oooool000Wooooo1?l0000g
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5
onKViP;o000000?oi^KVo`000?l000000ooVi^Hiooooo`;o00003_ooool000Wooooo1?l00005oooo
o`;o0000<?ooool4onKViPKo00000ooVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKV
iPCo00001?oVi^Haooooo`;o00000oooool2o`0000;ooooo0_l0000=ooooo`002_ooool2o`0000So
oooo0ol0000^ooooo`_oi^KV00?o0000ooooooooool0=Oooool2o`000003ooooool0003o000003Oo
oooo1?oVi^H2o`0000Goi^KV;oooool3o`0000Gooooo0_l00002ooooo`;o00003Oooool000Wooooo
0ol0000;ooooo`?o0000:oooool;onKViP03ooooool0003ooooo03Cooooo1Ol0000gooooo`04o`00
0?oVi^Koi^KVonKViP?o00001OoVi^H/ooooo`?o00002Oooool4o`0000kooooo000Jooooo`?o0000
:Oooool9onKViP?ooooo0_l0001]ooooo`;o00000_ooool9onKViR[ooooo0ol0000Nooooo`007Ooo
ool4o`0002Oooooo1OoVi^H7ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?oo
ool5onKViRSooooo1?l0000Qooooo`008Oooool3o`00037ooooo0_l0000cooooo`03o`000?oooooo
oooo037ooooo0_l0000aooooo`?o00009Oooool002Cooooo0ol0000`ooooo`;o0000<Oooool00ol0
003oooooooooo`0_ooooo`;o0000<?ooool3o`0002Sooooo000Wooooo`?o0000;oooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool3o`0002_o
oooo000Zooooo`?o0000;Oooool2o`0002kooooo00?o0000ooooooooool0;?ooool2o`0002gooooo
0ol0000^ooooo`00;Oooool4o`0002_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02Wooooo1?l0000aooooo`00<Oooool3o`0002Wooooo0_l0000[
ooooo`03o`000?oooooooooo02Wooooo0_l0000Yooooo`?o0000=Oooool003Cooooo0ol0000Xoooo
o`;o0000:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0003Sooooo000gooooo`?o
00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool09Oooool3o`0003_ooooo000jooooo`?o00009Oooool2o`0002Kooooo00?o0000ooooooooool0
9?ooool2o`0002Gooooo0ol0000nooooo`00?Oooool3o`0002Cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0ol00011ooooo`00@?ooool4
o`00027ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Qooooo`Co0000A?ooool0
04Cooooo0ol0000Pooooo`;o00008Oooool00ol0003oooooooooo`0Oooooo`;o00008?ooool3o`00
04Sooooo0017ooooo`?o00007oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07Oooool3o`0004_ooooo001:ooooo`?o00007Oooool2o`0001kooooo
00?o0000ooooooooool07?ooool2o`0001gooooo0ol0001>ooooo`00COooool3o`0001cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[ooooo0ol0
001Aooooo`00D?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000J
ooooo`?o0000E?ooool005?ooooo1?l0000Hooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`;o00006?ooool4o`0005Oooooo001Gooooo`?o00005oooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool3o`0005_ooooo001Jooooo`?o0000
5Oooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001Nooooo`00GOoo
ool3o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01;ooooo0ol0001Qooooo`00H?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooo
oooo017ooooo0_l0000Booooo`?o0000I?ooool006?ooooo0ol0000Aooooo`;o00004Oooool00ol0
003oooooooooo`0?ooooo`;o00004Oooool3o`0006Oooooo001Vooooo`Co00003oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool4o`0006[o
oooo001Zooooo`?o00003Oooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000gooooo
0ol0001^ooooo`00KOooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00[ooooo0ol0001aooooo`00L?ooool3o`0000[ooooo0_l0000;
ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000M?ooool007?ooooo0ol00009oooo
o`;o00002Oooool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`0007Oooooo001fooooo`Co
00001oooool00ol0003oooooooooo`04ooooo`Goi^KV1_ooool00ol0003oooooooooo`05ooooo`Co
0000N_ooool007[ooooo0ol00005ooooo`;o00000_ooool9onKViP;ooooo0_l00005ooooo`?o0000
O_ooool007gooooo0ol00004ooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000ooooooooool00_oo
ool3o`00087ooooo0020ooooo`?o00000_ooool;onKViP;ooooo0ol00024ooooo`00Poooool01?l0
003oi^KVonKVi_oVi^H6o`0000Coi^KV00?o0000ooooooooool0QOooool008Cooooo1OoVi^H2o`00
00Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KV
R?ooool008Cooooo1?oVi^H5o`0000Coi^KVR?ooool008Gooooo1?oVi^H2o`0000Goi^KVROooool0
08Gooooo1OoVi^H3o`0000?oi^KVROooool008Kooooo2OoVi^J:ooooo`00R?ooool5onKViXcooooo
0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17772, -0.833972, \
0.0157141, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19288 .30902 -5 -6 ]
[.19288 .30902 5 6 ]
[.2619 .30902 -5 -6 ]
[.2619 .30902 5 6 ]
[.2619 .16187 -5 -6 ]
[.2619 .16187 5 6 ]
[.33093 .30902 -5 -6 ]
[.33093 .30902 5 6 ]
[.2619 .45617 -5 -6 ]
[.2619 .45617 5 6 ]
[.5 .45617 -5 -6 ]
[.5 .45617 5 6 ]
[.7381 .45617 -5 -6 ]
[.7381 .45617 5 6 ]
[.7381 .30902 -5 -6 ]
[.7381 .30902 5 6 ]
[.55679 .01472 -5.0625 -6 ]
[.55679 .01472 5.0625 6 ]
[.9194 .01472 -5 -6 ]
[.9194 .01472 5 6 ]
[.7381 .16187 -5 -6 ]
[.7381 .16187 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.05 w
.19288 .30902 Mdot
0 g
gsave
.19288 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .30902 m
.2619 .16187 L
s
.9 g
.05 w
.2619 .30902 Mdot
0 g
gsave
.2619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .16187 Mdot
0 g
gsave
.2619 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .30902 Mdot
0 g
gsave
.33093 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.2619 .45617 Mdot
0 g
gsave
.2619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .45617 Mdot
0 g
gsave
.5 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .45617 m
.7381 .30902 L
s
.9 g
.05 w
.7381 .45617 Mdot
0 g
gsave
.7381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .30902 m
.7381 .16187 L
s
.9 g
.05 w
.7381 .30902 Mdot
0 g
gsave
.7381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .16187 m
.55679 .01472 L
s
.7381 .16187 m
.9194 .01472 L
s
1 g
.05 w
.55679 .01472 Mdot
0 g
gsave
.55679 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.9194 .01472 Mdot
0 g
gsave
.9194 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.7381 .16187 Mdot
0 g
gsave
.7381 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00V?ooool7o`0005_ooooo1Ol0
000Jooooo`00V?ooool2o`0000;ooooo0_l0001Mooooo`;o000000?oooooo`000?l000006Oooool0
09Sooooo1_l0001Mooooo`;o000000?oooooo`000?l000006Oooool009Wooooo1?l0001Nooooo`Co
00006_ooool009Wooooo1?l0001Nooooo`;o000000?oooooo`000?l000006Oooool009[ooooo0_l0
001Oooooo`;o000000?oooooo`000?l000006Oooool009Wooooo0ol00005ooooo`03o`000?oooooo
oooo05?ooooo00?o0000ooooooooool01Ol0000Jooooo`00X_ooool00ol0003oooooooooo`1Aoooo
o`03o`000?oooooooooo023ooooo002Sooooo`03o`000?oooooooooo04oooooo00?o0000oooooooo
ool08Oooool00:Cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0Rooooo`00YOoo
ool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo02?ooooo002Vooooo`;o0000BOooool2
o`0002Kooooo002Xooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool09_ooool00:Wo
oooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`0Wooooo`00Z_ooool00ol0003ooooo
ooooo`11ooooo`03o`000?oooooooooo02Sooooo002[ooooo`;o0000?oooool2o`0002_ooooo002]
ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0:oooool00:kooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`0/ooooo`00[oooool00ol0003oooooooooo`0gooooo`03
o`000?oooooooooo02gooooo002`ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0
;_ooool00;7ooooo0_l0000cooooo`;o0000<Oooool00;?ooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`0aooooo`00]?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
03;ooooo002eooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0<oooool00;Kooooo
0_l0000Yooooo`;o0000=_ooool00;Sooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0fooooo`00^Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo002joooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0>?ooool00;_ooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0iooooo`00_?ooool2o`0001gooooo0_l0000looooo`00__oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03cooooo002oooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0?Oooool00<3ooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0nooooo`00`Oooool2o`0001?ooooo0_l00011ooooo`00`oooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo047ooooo0034ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0@_ooool00<Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000
ooooooooool0@oooool00<Kooooo00?o0000oooooooVi^H02?oVi^H00ooooooo0000ooooo`15oooo
o`00aoooool3onKViPCo00001?oVi^I7ooooo`00aoooool6onKViP;o00000ooVi^I7ooooo`00B_oo
ool4o`0007Sooooo1?oVi^H5o`0000Coi^KVA_ooool004_ooooo0_l0001iooooo`?oi^KV0_l00002
onKViP;o00001?oVi^I6ooooo`00B?ooool6o`0007Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKV
iTKooooo0018ooooo`;o000000?oooooo`000?l00000NOooool3onKViP;o00000_oVi^H2o`0000Co
i^KVA_ooool004Wooooo1?l0001iooooo`Coi^KV1_l00003onKViTKooooo001:ooooo`?o0000N_oo
ool;onKViTOooooo001;ooooo`;o0000N_ooool;onKViTOooooo0038ooooo`Woi^KVB?ooool004_o
oooo00?o0000ooooooooool0O?ooool5onKViT[ooooo001;ooooo`03o`000?oooooooooo07kooooo
00?o0000ooooooooool0B_ooool004_ooooo00?o0000ooooooooool0O_ooool00ol0003ooooooooo
o`1:ooooo`00Boooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo001;oooo
o`03o`000?oooooooooo07kooooo00?o0000ooooooooool0B_ooool004_ooooo00?o0000oooooooo
ool0O_ooool00ol0003oooooooooo`1:ooooo`00Boooool00ol0003oooooooooo`1nooooo`03o`00
0?oooooooooo04[ooooo001;ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0B_oo
ool004_ooooo00?o0000ooooooooool0O_ooool00ol0003oooooooooo`1:ooooo`00Boooool00ol0
003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo001;ooooo`03o`000?oooooooooo07ko
oooo00?o0000ooooooooool0B_ooool004_ooooo00?o0000ooooooooool0O_ooool00ol0003ooooo
ooooo`1:ooooo`00Boooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo001;
ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0B_ooool004_ooooo00?o0000oooo
ooooool0O_ooool00ol0003oooooooooo`1:ooooo`00Boooool00ol0003oooooooooo`1nooooo`03
o`000?oooooooooo04[ooooo001;ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0
B_ooool004_ooooo00?o0000ooooooooool0O_ooool00ol0003oooooooooo`1:ooooo`00Boooool0
0ol0003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo001;ooooo`03o`000?oooooooooo
07kooooo00?o0000ooooooooool0B_ooool004_ooooo00?o0000ooooooooool0O_ooool00ol0003o
ooooooooo`1:ooooo`00Boooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo
001;ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0B_ooool004_ooooo00?o0000
ooooooooool0O_ooool00ol0003oooooooooo`1:ooooo`00Boooool00ol0003oooooooooo`1noooo
o`03o`000?oooooooooo04[ooooo001;ooooo`03o`000?oooooooooo07kooooo00?o0000oooooooo
ool0B_ooool004_ooooo00?o0000ooooooooool0O_ooool00ol0003oooooooooo`1:ooooo`00Booo
ool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo04[ooooo0019ooooo`Goi^KVO?ooool5
onKViT[ooooo0017ooooo`Woi^KVN?ooool9onKViTSooooo0016ooooo`?oi^KV1?l00004onKViWKo
oooo0ooVi^H4o`0000Coi^KVAoooool004Kooooo1_oVi^H2o`0000?oi^KVM_ooool6onKViP;o0000
0ooVi^I7ooooo`00=_ooool5o`0000[ooooo1?oVi^H5o`0000Coi^KV2_ooool4o`0006Kooooo1?oV
i^H5o`0000Coi^KVA_ooool003Oooooo0_l000000ooooooo0000o`000009ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^H9ooooo`;o00000_ooool2o`0006Gooooo0ooVi^H2o`0000;oi^KV0_l00004
onKViTKooooo000gooooo`;o000000?oooooo`000?l000002Oooool3onKViP;o00000_oVi^H2o`00
00Coi^KV3Oooool2o`0006Gooooo0ooVi^H2o`0000;oi^KV0_l00004onKViTKooooo000gooooo`Co
00002_ooool3onKViP;o00000_oVi^H2o`0000Coi^KV2oooool3o`0006Kooooo0ooVi^H2o`0000;o
i^KV0_l00004onKViTKooooo000gooooo`;o000000?oooooo`000?l000002Oooool4onKViPKo0000
0ooVi^H=ooooo`;o0000IOooool4onKViPKo00000ooVi^I6ooooo`00=oooool2o`000003ooooool0
003o000000[ooooo2ooVi^H:ooooo`;o00000_ooool2o`0006Kooooo2ooVi^I7ooooo`00=_ooool5
o`0000_ooooo2ooVi^H;ooooo`Co0000Ioooool;onKViTOooooo0017ooooo`Woi^KVN?ooool9onKV
iTSooooo000kooooo`03o`000?oooooooooo00_ooooo1OoVi^H=ooooo`03o`000?oooooooooo06co
oooo1OoVi^I:ooooo`00??ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0K_ooool00ol0003oooooooooo`1:ooooo`00??ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Koooool00ol0003ooooooooo
o`1:ooooo`00?Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0Koooool00ol0003oooooooooo`1:ooooo`00?Oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0L?ooool00ol0003oooooooooo`1:oooo
o`00?_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0L?ooool00ol0003oooooooooo`1:ooooo`00?_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0L?ooool00ol0003oooooooooo`1:ooooo`00?ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0LOoo
ool00ol0003oooooooooo`1:ooooo`00?oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0LOooool00ol0003oooooooooo`1:ooooo`00@?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0L_ooool00ol0
003oooooooooo`1:ooooo`00@?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0L_ooool00ol0003oooooooooo`1:ooooo`00@?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Loooool00ol0003ooooo
ooooo`1:ooooo`00@Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0Loooool00ol0003oooooooooo`1:ooooo`00@Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0M?ooool00ol0003oooooooooo`1:
ooooo`00@_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0M?ooool00ol0003oooooooooo`1:ooooo`00@_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0MOooool00ol0003oooooooooo`1:ooooo`00
@oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
MOooool00ol0003oooooooooo`1:ooooo`00@oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`1:ooooo`00A?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0M_ooool0
0ol0003oooooooooo`1:ooooo`00A?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0Moooool00ol0003oooooooooo`1:ooooo`00A?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Moooool00ol0003o
ooooooooo`1:ooooo`00AOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0N?ooool00ol0003oooooooooo`1:ooooo`00AOooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0N?ooool00ol0003ooooooooo
o`1:ooooo`00A_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0NOooool00ol0003oooooooooo`1:ooooo`00A_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`1:oooo
o`00Aoooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0NOooool00ol0
003oooooooooo`1:ooooo`00Aoooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool0N_ooool00ol0003oooooooooo`1:ooooo`00B?ooool01?l0003oooooooooool00003oooo
o`03o`000?oooooooooo07[ooooo00?o0000ooooooooool0B_ooool004Sooooo00?o0000onKVi_oV
i^H00ooVi^H00ol0003oooooooooo`1iooooo`Goi^KVB_ooool004Oooooo2OoVi^Ihooooo`Woi^KV
B?ooool004Kooooo0ooVi^H4o`0000Coi^KVM_ooool;onKViTOooooo0016ooooo`Koi^KV0_l00003
onKViWKooooo2ooVi^I7ooooo`002?ooool7o`0003Kooooo1?oVi^H5o`0000Coi^KV=oooool5o`00
03Sooooo0ooVi^H7o`0000?oi^KV=oooool6o`0000Wooooo0008ooooo`;o00000_ooool2o`0003Oo
oooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l000000ooooooo0000o`00000gooooo`Co
i^KV0_l000000ooVi^Ko0000o`000004onKViSSooooo0_l000000ooooooo0000o`000009ooooo`00
2?ooool6o`0003Oooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l000000ooooooo0000
o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSWooooo0_l0000;ooooo`002Ooo
ool4o`0003Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l000000ooooooo0000o`00
000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViS[ooooo0_l0000:ooooo`002Oooool4
o`0000Gooooo0_l0000aooooo`Coi^KV1_l00003onKViSSooooo0_l000000ooooooo0000o`00000g
ooooo`Coi^KV1?l00005onKViS;ooooo00?o0000ooooooooool00_ooool2o`0000;ooooo0_l00009
ooooo`002_ooool2o`0000Sooooo0ol0000_ooooo`_oi^KV00?o0000ooooooooool0=_ooool2o`00
0003ooooool0003o000003Oooooo00Co0000onKVi_oVi^Koi^KV0_l00006onKViS3ooooo0ol00005
ooooo`;o00000_ooool2o`0000Wooooo0009ooooo`?o00002oooool4o`0002_ooooo2ooVi^H00ooo
oooo0000ooooo`0eooooo`Go0000=oooool01?l0003oooooonKVi_oVi^H3o`0000Koi^KV;?ooool4
o`0000Wooooo1?l0000:ooooo`006oooool3o`0002Wooooo2OoVi^H3ooooo`;o0000K_ooool2o`00
00?ooooo2OoVi^HZooooo`?o00006oooool001kooooo0ol0000Xooooo`Goi^KV1oooool2o`0006_o
oooo00?o0000ooooooooool01Oooool5onKViRWooooo0ol0000Nooooo`008Oooool3o`0003?ooooo
00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0aooooo`;o0000<oooool3o`00027ooooo
000Tooooo`?o0000<Oooool2o`0003;ooooo00?o0000ooooooooool0;oooool2o`0003;ooooo0ol0
000Tooooo`009oooool4o`0002oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0^
ooooo`03o`000?oooooooooo02kooooo1?l0000Wooooo`00:oooool3o`0002gooooo0_l0000_oooo
o`03o`000?oooooooooo02cooooo0_l0000^ooooo`?o0000:oooool002kooooo0ol0000/ooooo`;o
0000;Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo0ol0000^ooooo`00
<Oooool3o`0002_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Yooooo`;o0000
:oooool3o`00037ooooo000dooooo`Co0000:?ooool2o`0002[ooooo00?o0000ooooooooool09ooo
ool2o`0002Wooooo1?l0000dooooo`00>?ooool3o`0002Oooooo0_l0000Xooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool09_ooool3o`0003Sooooo000kooooo`?o00009_ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo0_l0000Vooooo`?o0000>oooool003ko
oooo0ol0000Tooooo`;o00009Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?o
oooo0ol0000nooooo`00@Oooool3o`0002?ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`0Qooooo`;o00008oooool3o`00047ooooo0014ooooo`Co00008?ooool2o`0002;ooooo00?o
0000ooooooooool07oooool2o`00027ooooo1?l00014ooooo`00B?ooool3o`0001oooooo0_l0000P
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool3o`0004Sooooo001;oooo
o`?o00007_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01cooooo0_l0000Noooo
o`?o0000Boooool004kooooo0ol0000Looooo`;o00007Oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01_ooooo0ol0001>ooooo`00DOooool4o`0001[ooooo0_l0000Kooooo`03o`00
0?oooooooooo01Wooooo0_l0000Jooooo`Co0000DOooool005Gooooo0ol0000Iooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool05oooool2o`0001Wooooo0ol0001Eooooo`00F?ooool3
o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool3
o`0005Sooooo001Kooooo`?o00005_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Cooooo0_l0000Fooooo`?o0000Foooool005kooooo0ol0000Dooooo`;o00005Oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0ol0001Nooooo`00HOooool4o`0001;ooooo
0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Booooo`Co0000HOooool006Gooooo0ol0
000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool2o`00017ooooo0ol0
001Uooooo`00J?ooool3o`0000oooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03_ooool3o`0006Sooooo001[ooooo`?o00003_ooool2o`0000kooooo00?o0000oooo
ooooool03?ooool2o`0000kooooo0ol0001[ooooo`00K_ooool4o`0000cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo1?l0001^ooooo`00
L_ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000
L_ooool007Gooooo0ol00009ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01ooo
ool2o`0000Wooooo0ol0001eooooo`00N?ooool3o`0000Oooooo0_l00005ooooo`Goi^KV1oooool0
0ol0003oooooooooo`06ooooo`?o0000N?ooool007_ooooo0ol00006ooooo`;o000000?oooooonKV
i_oVi^H01ooVi^H3ooooo`;o00001_ooool3o`0007_ooooo001nooooo`Co00001?ooool;onKViP03
ooooool0003ooooo00?ooooo1?l0001nooooo`00P_ooool3o`000003oooooooVi^Koi^KV00Woi^KV
00?o0000ooooooooool00ol00022ooooo`00QOooool4onKViPKo00000ooVi^H2o`0008Gooooo0025
ooooo`Koi^KV0_l00005onKViXOooooo0025ooooo`Koi^KV0_l00005onKViXOooooo0025ooooo`Ko
i^KV0_l00005onKViXOooooo0025ooooo`Goi^KV1Ol00003onKViXOooooo0026ooooo`Goi^KV0_l0
0004onKViXSooooo0026ooooo`Koi^KV0ol00002onKViXSooooo0027ooooo`Woi^KVROooool008Wo
oooo1OoVi^J;ooooo`00\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17547, -0.833972, \
0.0155148, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.573047 0.201572 0.603319 0.735755 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.12121 .30902 -5 -6 ]
[.12121 .30902 5 6 ]
[.2186 .30902 -5 -6 ]
[.2186 .30902 5 6 ]
[.316 .30902 -5 -6 ]
[.316 .30902 5 6 ]
[.16251 .01472 -5.0625 -6 ]
[.16251 .01472 5.0625 6 ]
[.46949 .01472 -5 -6 ]
[.46949 .01472 5 6 ]
[.316 .16187 -5 -6 ]
[.316 .16187 5 6 ]
[.1699 .45617 -5 -6 ]
[.1699 .45617 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.57305 .60332 -5 -6 ]
[.57305 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.57305 .60332 m
.1699 .45617 L
s
.57305 .60332 m
.97619 .45617 L
s
.1699 .45617 m
.02381 .30902 L
s
.1699 .45617 m
.12121 .30902 L
s
.1699 .45617 m
.2186 .30902 L
s
.1699 .45617 m
.316 .30902 L
s
1 g
.05 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.12121 .30902 Mdot
0 g
gsave
.12121 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.2186 .30902 Mdot
0 g
gsave
.2186 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.316 .30902 m
.316 .16187 L
s
.9 g
.05 w
.316 .30902 Mdot
0 g
gsave
.316 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.316 .16187 m
.16251 .01472 L
s
.316 .16187 m
.46949 .01472 L
s
1 g
.05 w
.16251 .01472 Mdot
0 g
gsave
.16251 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.46949 .01472 Mdot
0 g
gsave
.46949 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.316 .16187 Mdot
0 g
gsave
.316 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.1699 .45617 Mdot
0 g
gsave
.1699 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.57305 .60332 Mdot
0 g
gsave
.57305 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00;Oooool7o`0004cooooo1Ol0
002Dooooo`00;Oooool2o`0000;ooooo0_l0001>ooooo`;o000000?oooooo`000?l00000Toooool0
02gooooo1_l0001>ooooo`;o000000?oooooo`000?l00000Toooool002kooooo1?l0001?ooooo`Co
0000U?ooool002kooooo1?l0001?ooooo`;o000000?oooooo`000?l00000Toooool002oooooo0_l0
001@ooooo`;o000000?oooooo`000?l00000Toooool002kooooo0ol0001?ooooo`Go0000U?ooool0
03Kooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`2Iooooo`00=oooool00ol0003o
ooooooooo`12ooooo`03o`000?oooooooooo09[ooooo000hooooo`03o`000?oooooooooo043ooooo
00?o0000ooooooooool0Voooool003Wooooo00?o0000ooooooooool0?_ooool00ol0003ooooooooo
o`2Looooo`00>_ooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo09gooooo000koooo
o`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0W_ooool003cooooo00?o0000oooooooo
ool0>?ooool00ol0003oooooooooo`2Oooooo`00?Oooool00ol0003oooooooooo`0fooooo`03o`00
0?oooooooooo0:3ooooo000nooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0XOoo
ool003oooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`2Rooooo`00@?ooool00ol0
003oooooooooo`0`ooooo`03o`000?oooooooooo0:?ooooo0011ooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool0Y?ooool004;ooooo00?o0000ooooooooool0;?ooool00ol0003ooooo
ooooo`2Uooooo`00@oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo0:Kooooo0014
ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0Yoooool004Gooooo0_l0000Woooo
o`03o`000?oooooooooo0:Sooooo0017ooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool0ZOooool004Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Zooooo`00BOoo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo0:_ooooo001:ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool0[?ooool004_ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`2]ooooo`00C?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0:ko
oooo001=ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0[oooool004kooooo00?o
0000ooooooooool05Oooool00ol0003oooooooooo`2`ooooo`00Coooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo0;7ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0/_ooool0057ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2cooooo`00
D_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0;Cooooo001Cooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0]Oooool005Cooooo00Co0000oooooooooooooooo1OoV
i^H3ooooo`03o`000?oooooooooo0;Kooooo001Eooooo`03o`000?oVi^Koi^KV00Ooi^KV00?o0000
ooooooooool0]oooool005Gooooo0ooVi^H4o`0000Coi^KV^Oooool005Gooooo1_oVi^H2o`0000?o
i^KV^Oooool005Cooooo1?oVi^H5o`0000Coi^KV^?ooool005Cooooo0ooVi^H2o`0000;oi^KV0_l0
0004onKVi[Sooooo001Dooooo`?oi^KV0_l00002onKViP;o00001?oVi^Jhooooo`00E?ooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV^?ooool005Cooooo1?oVi^H6o`0000?oi^KV^?ooool005Gooooo
2ooVi^Jiooooo`00EOooool;onKVi[Wooooo001Fooooo`Woi^KV^_ooool005Sooooo1OoVi^Jloooo
o`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_oo
ool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0
003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003ooooo
ooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2l
ooooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00
F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool0
0ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003o
ooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003ooooooooo
o`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2loooo
o`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_oo
ool00ol0003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0
003oooooooooo`2looooo`00F_ooool00ol0003oooooooooo`2looooo`00F_ooool00ol0003ooooo
ooooo`2looooo`00F?ooool5onKVi[cooooo001Fooooo`Woi^KV^_ooool005Gooooo0ooVi^H4o`00
00Coi^KV^Oooool005Gooooo1_oVi^H2o`0000?oi^KV^Oooool000Wooooo1?l0000Eooooo`Go0000
5_ooool5o`0001;ooooo1?oVi^H5o`0000Coi^KV^?ooool000Sooooo00?o0000ooooool000006?oo
ool2o`000003ooooool0003o000001Kooooo0_l000000ooooooo0000o`00000Aooooo`?oi^KV0_l0
0002onKViP;o00001?oVi^Jhooooo`002?ooool00ol0003oooooo`000002o`0001Kooooo0_l00000
0ooooooo0000o`00000Fooooo`;o000000?oooooo`000?l000004Oooool3onKViP;o00000_oVi^H2
o`0000Coi^KV^?ooool000Sooooo00Go0000ooooool0003oooooo`00000Fooooo`;o000000?ooooo
o`000?l000005_ooool4o`0001;ooooo0ooVi^H2o`0000;oi^KV0_l00004onKVi[Sooooo0009oooo
o`?o00005oooool2o`000003ooooool0003o000001Kooooo0_l000000ooooooo0000o`00000Aoooo
o`Coi^KV1_l00003onKVi[Sooooo000Sooooo`;o000000?oooooo`000?l000005_ooool2o`000003
ooooool0003o000001;ooooo2ooVi^Jiooooo`008_ooool5o`0001Kooooo1Ol0000Cooooo`_oi^KV
^Oooool005Gooooo00?o0000onKVi_oVi^H01ooVi^Jjooooo`004?ooool00ol0003oooooooooo`11
ooooo`04o`000?ooooooooooooooo`Goi^KV_?ooool0017ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0`oooool0
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool0a?ooool001?ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0aOooool001Cooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool0a_ooool001Gooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0aoooool001Kooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool0b?ooool001Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00kooooo00?o0000ooooooooool0bOooool001Sooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool0b_ooool001Wooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0boooool001[ooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0c?oo
ool001_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0cOooool001cooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0c_ooool001go
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0coooool001kooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0d?ooool001oooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0dOooool0023ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0d_ooool0027ooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0doooool002;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0e?ooool002?ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
eOooool002Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0e_ooool002Gooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0eoooool0
02Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0f?ooool002Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0fOooool002Sooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0f_ooool002Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0foooool002[ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0g?ooool002_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool00000goooool002cooooo00Co0000oooooooooooooooo1OoVi^H3
ooooo`03o`000?oooooooooo0=kooooo000]ooooo`03o`000?oVi^Koi^KV00Ooi^KV00?o0000oooo
ooooool0goooool002gooooo2ooVi^KQooooo`00;Oooool;onKVi^7ooooo000/ooooo`?oi^KV1ol0
0003onKVi]7ooooo1_l00009ooooo`00;?ooool4onKViP;o000000?oi^KVo`000?l000001?oVi^KB
ooooo`;o000000?oooooo`000?l000002Oooool002cooooo1?oVi^H2o`000003onKVi_l0003o0000
00Coi^KVdoooool2o`0000_ooooo000/ooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKVi]Co
oooo0_l0000:ooooo`00;?ooool4onKViPCo00001OoVi^H00ol0003oooooooooo`3>ooooo`;o0000
0_ooool2o`0000Wooooo000]ooooo`?oi^KV0_l00006onKViP;ooooo0ol00036ooooo`?o00001?oo
ool2o`0000;ooooo0_l00009ooooo`00;Oooool2onKViP?o00001_oVi^H5ooooo`;o0000`_ooool2
o`0000Sooooo1?l0000:ooooo`00;_ooool9onKViPSooooo0ol0002looooo`?o00006?ooool0033o
oooo1OoVi^H=ooooo`?o0000]_ooool3o`0001_ooooo0015ooooo`;o0000/Oooool3o`0001kooooo
0017ooooo`?o0000[?ooool2o`00027ooooo001:ooooo`?o0000Y_ooool3o`0002?ooooo001=oooo
o`?o0000X?ooool3o`0002Kooooo001@ooooo`;o0000Voooool3o`0002Wooooo001Booooo`?o0000
U_ooool2o`0002cooooo001Eooooo`?o0000T?ooool3o`0002kooooo001Hooooo`?o0000R_ooool3
o`00037ooooo001Kooooo`;o0000QOooool3o`0003Cooooo001Mooooo`?o0000P?ooool2o`0003Oo
oooo001Pooooo`?o0000N_ooool3o`0003Wooooo001Sooooo`;o0000MOooool3o`0003cooooo001U
ooooo`?o0000Koooool3o`0003oooooo001Xooooo`?o0000J_ooool2o`0004;ooooo001[ooooo`?o
0000I?ooool3o`0004Cooooo001^ooooo`;o0000Goooool3o`0004Oooooo001`ooooo`?o0000FOoo
ool3o`0004[ooooo001cooooo`?o0000E?ooool2o`0004gooooo001fooooo`;o0000Coooool3o`00
04oooooo001hooooo`?o0000BOooool3o`0005;ooooo001kooooo`?o0000@oooool3o`0005Gooooo
001nooooo`?o0000?_ooool2o`0005Sooooo0021ooooo`;o0000>Oooool3o`0005[ooooo0023oooo
o`?o0000<oooool3o`0005gooooo0026ooooo`?o0000;Oooool3o`00063ooooo0029ooooo`?o0000
:?ooool2o`0006?ooooo002<ooooo`;o00008oooool3o`0006Gooooo002>ooooo`?o00003?ooool5
onKViPcooooo0ol0001Xooooo`00TOooool3o`0000Oooooo2OoVi^H7ooooo`?o0000Joooool009Co
oooo0_l00004ooooo`_oi^KV1?ooool2o`0006kooooo002Fooooo`?o000000?oooooonKVi_oVi^H0
2OoVi^H01?oooooo0000o`000?l0001`ooooo`00VOooool3onKViPKo00001?oVi^Icooooo`00VOoo
ool5onKViP;o00001_oVi^Icooooo`00VOooool5onKViP;o00001_oVi^Icooooo`00VOooool5onKV
iP;o00001_oVi^Icooooo`00VOooool4onKViPGo00001?oVi^Icooooo`00V_ooool4onKViP;o0000
1OoVi^Idooooo`00V_ooool5onKViP?o00000ooVi^Idooooo`00Voooool9onKViWGooooo002Moooo
o`Goi^KVMoooool00001\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.93203, -0.833972, \
0.018326, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19288 .30902 -5 -6 ]
[.19288 .30902 5 6 ]
[.2619 .30902 -5 -6 ]
[.2619 .30902 5 6 ]
[.2619 .16187 -5 -6 ]
[.2619 .16187 5 6 ]
[.33093 .30902 -5 -6 ]
[.33093 .30902 5 6 ]
[.2619 .45617 -5 -6 ]
[.2619 .45617 5 6 ]
[.5 .45617 -5 -6 ]
[.5 .45617 5 6 ]
[.66907 .30902 -5 -6 ]
[.66907 .30902 5 6 ]
[.71509 .30902 -5 -6 ]
[.71509 .30902 5 6 ]
[.7611 .30902 -5 -6 ]
[.7611 .30902 5 6 ]
[.80712 .30902 -5 -6 ]
[.80712 .30902 5 6 ]
[.80712 .16187 -5 -6 ]
[.80712 .16187 5 6 ]
[.80712 .01472 -5 -6 ]
[.80712 .01472 5 6 ]
[.7381 .45617 -5 -6 ]
[.7381 .45617 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.05 w
.19288 .30902 Mdot
0 g
gsave
.19288 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .30902 m
.2619 .16187 L
s
.9 g
.05 w
.2619 .30902 Mdot
0 g
gsave
.2619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .16187 Mdot
0 g
gsave
.2619 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .30902 Mdot
0 g
gsave
.33093 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.2619 .45617 Mdot
0 g
gsave
.2619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .45617 Mdot
0 g
gsave
.5 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.05 w
.66907 .30902 Mdot
0 g
gsave
.66907 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .30902 Mdot
0 g
gsave
.71509 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .30902 Mdot
0 g
gsave
.7611 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .30902 m
.80712 .16187 L
s
.9 g
.05 w
.80712 .30902 Mdot
0 g
gsave
.80712 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .16187 m
.80712 .01472 L
s
.9 g
.05 w
.80712 .16187 Mdot
0 g
gsave
.80712 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.80712 .01472 Mdot
0 g
gsave
.80712 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.05 w
.7381 .45617 Mdot
0 g
gsave
.7381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00g?ooool5o`0003Sooooo003M
ooooo`;o000000?oooooo`000?l00000=oooool00=gooooo0_l000000ooooooo0000o`00000goooo
o`00gOooool4o`0003Sooooo003Mooooo`;o000000?oooooo`000?l00000=oooool00=gooooo0_l0
00000ooooooo0000o`00000gooooo`00g?ooool5o`0003Sooooo003ooooooa[ooooo003Oooooo`03
o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oo
oooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo
03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo
003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Ooooo
o`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`00
0?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooo
oooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oo
oooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003O
ooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03
o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oo
oooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo
03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo
003Oooooo`03o`000?oooooooooo03Oooooo003Mooooo`Goi^KV=oooool00=_ooooo2OoVi^Heoooo
o`00f_ooool3onKViPCo00001?oVi^Hdooooo`00f_ooool6onKViP;o00000ooVi^Hdooooo`00B_oo
ool4o`0008_ooooo1?oVi^H5o`0000Coi^KV<oooool004_ooooo0_l0002<ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^Hcooooo`00B?ooool6o`0008_ooooo0ooVi^H2o`0000;oi^KV0_l00004onKV
iS?ooooo0018ooooo`;o000000?oooooo`000?l00000S?ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV<oooool004Wooooo1?l0002<ooooo`Coi^KV1_l00003onKViS?ooooo001:ooooo`?o0000SOoo
ool;onKViSCooooo001;ooooo`;o0000SOooool;onKViSCooooo003Kooooo`Woi^KV=Oooool004_o
oooo00?o0000ooooooooool0Soooool5onKViSOooooo001;ooooo`03o`000?oooooooooo097ooooo
00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003ooooooooo
o`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;oooo
o`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000oooooooo
ool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`00
0?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=ooo
ool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0
003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097o
oooo00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003ooooo
ooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;
ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000oooo
ooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03
o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0
=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool0
0ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo
097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003o
ooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo
001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aoooo
o`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000oooooooo
ool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Booo
ool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo0019ooooo`Goi^KVSoooool5
onKViSOooooo0017ooooo`Woi^KVRoooool9onKViSGooooo0016ooooo`?oi^KV1?l00004onKViXWo
oooo0ooVi^H4o`0000Coi^KV=?ooool004Kooooo1_oVi^H2o`0000?oi^KVROooool6onKViP;o0000
0ooVi^Hdooooo`00=Oooool5o`0000_ooooo1?oVi^H5o`0000Coi^KV2_ooool4o`0005Sooooo1?l0
0007ooooo`Go00002?ooool5o`0000Cooooo1?oVi^H5o`0000Coi^KV<oooool003Kooooo0_l00000
0ooooooo0000o`00000:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^H9ooooo`;o00000_ooool2
o`0005Kooooo00?o0000ooooool000002_ooool2o`000003ooooool0003o000000Sooooo0_l00000
0ooooooo0000o`000003ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hcooooo`00=_ooool2o`00
0003ooooool0003o000000[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViPgooooo0_l0001Foooo
o`03o`000?oooooo000000;o00002?ooool2o`000003ooooool0003o000000Sooooo0_l000000ooo
oooo0000o`000003ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hcooooo`00=_ooool4o`0000_o
oooo0ooVi^H2o`0000;oi^KV0_l00004onKViP_ooooo0ol0001Gooooo`05o`000?oooooo0000oooo
ool000002?ooool2o`000003ooooool0003o000000Sooooo1?l00004ooooo`?oi^KV0_l00002onKV
iP;o00001?oVi^Hcooooo`00=_ooool2o`000003ooooool0003o000000[ooooo1?oVi^H6o`0000?o
i^KV3Oooool2o`0005Oooooo0ol00009ooooo`;o000000?oooooo`000?l000002?ooool2o`000003
ooooool0003o000000?ooooo1?oVi^H6o`0000?oi^KV<oooool003Kooooo0_l000000ooooooo0000
o`00000;ooooo`_oi^KV2_ooool2o`0000;ooooo0_l0001Sooooo`;o000000?oooooo`000?l00000
2?ooool2o`000003ooooool0003o000000Cooooo2ooVi^Hdooooo`00=Oooool5o`0000cooooo2ooV
i^H;ooooo`Co0000Hoooool5o`0000Sooooo1Ol00005ooooo`_oi^KV=?ooool004Oooooo2OoVi^J;
ooooo`Woi^KV=Oooool003_ooooo00?o0000ooooooooool02oooool5onKViVkooooo00?o0000oooo
ooooool07Oooool00ol0003oi^KVonKViP03onKViSOooooo000kooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03[o
oooo000looooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`1Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03_ooooo000m
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1R
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo03cooooo000mooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03cooooo000mooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Sooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo03cooooo000nooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03gooooo000nooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Uooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo03gooooo000oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Wooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03kooooo0010ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`1Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03oooooo0010ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03oooooo
0011ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Zooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo043ooooo0011ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo043ooooo0012oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1/oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo047ooooo0012ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo047ooooo0013ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1^ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo04;ooooo0013ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1_ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;ooooo0014ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1`ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000004Gooooo0014
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1`
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000004Gooooo0015ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`1booooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000004Kooooo0015ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`1booooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000004Kooooo0016ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`1dooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo0000Aoooool004Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo07Cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00017
ooooo`00A_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0MOooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004Oooooo0017
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1fooooo`06o`000?oo
ooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`16ooooo`00Aoooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool0Moooool01Ol0003oooooo`000?oooooo0000
00;ooooo00?o0000ooooooooool0A_ooool004Sooooo00?o0000onKVi_oVi^H00ooVi^H00ol0003o
ooooooooo`1hooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0Aoooool004Oooooo
2OoVi^Ihooooo`Woi^KVB?ooool004Kooooo0ooVi^H4o`0000Coi^KVM_ooool;onKViTOooooo0016
ooooo`Koi^KV0_l00003onKViWKooooo2ooVi^I7ooooo`001oooool7o`0003Oooooo1?oVi^H5o`00
00Coi^KV=oooool5o`0003Sooooo0ooVi^H7o`0000?oi^KV=oooool6o`0000Wooooo0007ooooo`;o
00000_ooool2o`0003Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l000000ooooooo
0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSSooooo0_l000000ooooooo
0000o`000009ooooo`001oooool6o`0003Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo
0_l000000ooooooo0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSWooooo
0_l0000;ooooo`002?ooool4o`0003Wooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l0
00000ooooooo0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViS[ooooo0_l0
000:ooooo`002?ooool4o`0000Gooooo0_l0000booooo`Coi^KV1_l00003onKViSSooooo0_l00000
0ooooooo0000o`00000gooooo`Coi^KV1?l00005onKViS;ooooo0_l00003ooooo`;o00000_ooool2
o`0000Wooooo0009ooooo`;o00002?ooool3o`00033ooooo2ooVi^H00ol0003oooooooooo`0foooo
o`;o000000?oooooo`000?l00000=oooool01?l0003oi^KVonKVi_oVi^H2o`0000Koi^KV<?ooool3
o`0000Gooooo0_l00002ooooo`;o00002Oooool000Sooooo0ol0000;ooooo`Co0000;?ooool;onKV
iP03ooooool0003ooooo03Gooooo1Ol0000gooooo`04o`000?ooooooi^KVonKViP?o00001_oVi^H/
ooooo`Co00002Oooool4o`0000[ooooo000Jooooo`?o0000:_ooool9onKViP?ooooo0_l0001^oooo
o`;o00000oooool9onKViR[ooooo0ol0000Kooooo`007Oooool3o`0002Wooooo1OoVi^H7ooooo`;o
0000Joooool00ol0003oooooooooo`05ooooo`Goi^KV:Oooool3o`0001kooooo000Pooooo`?o0000
=?ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo037ooooo0_l0000cooooo`?o0000
8Oooool002?ooooo1?l0000aooooo`;o0000<_ooool00ol0003oooooooooo`0_ooooo`;o0000<_oo
ool3o`0002Cooooo000Wooooo`?o0000<?ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool0;_ooool4o`0002Oooooo000Zooooo`?o0000;_ooool2o`00
02oooooo00?o0000ooooooooool0;?ooool2o`0002kooooo0ol0000[ooooo`00;Oooool3o`0002go
oooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool3o`0002ko
oooo000`ooooo`Co0000:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo
0_l0000[ooooo`?o0000<Oooool003Cooooo0ol0000Yooooo`;o0000:_ooool00ol0003ooooooooo
o`0Wooooo`;o0000:Oooool4o`0003Cooooo000gooooo`?o0000:?ooool2o`0002Sooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`?o0000>?ooool003[ooooo0ol0000Woooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0000koooo
o`00?Oooool4o`0002Cooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool08oooool3o`0003kooooo0011ooooo`?o00008oooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo027ooooo0_l0000Sooooo`?o0000@Oooool004Cooooo0ol0000Qooooo`;o00008_oo
ool00ol0003oooooooooo`0Oooooo`;o00008Oooool4o`0004Cooooo0017ooooo`?o00008?ooool2
o`00023ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`?o0000B?ooool0
04[ooooo1?l0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool2o`00
01kooooo0ol0001;ooooo`00C_ooool3o`0001cooooo0_l0000Mooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool06oooool3o`0004kooooo001Aooooo`?o00006oooool2o`0001_ooooo
00?o0000ooooooooool06Oooool2o`0001[ooooo1?l0001Aooooo`00E?ooool3o`0001[ooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0Gooooo`;o00006Oooool3o`0005Gooooo001G
ooooo`Co00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0F
ooooo`?o0000F?ooool005_ooooo0ol0000Fooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05?ooool2o`0001Kooooo0ol0001Kooooo`00G_ooool3o`0001Cooooo0_l0000Eooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0005kooooo001Qooooo`?o0000
4oooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001Qooooo`00I?oo
ool4o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0?ooooo`;o00004Ooo
ool3o`0006Gooooo001Xooooo`?o00003oooool2o`00013ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0>ooooo`?o0000J?ooool006_ooooo0ol0000>ooooo`;o00003_ooool00ol0
003oooooooooo`0<ooooo`;o00003_ooool3o`0006_ooooo001^ooooo`?o00003Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool4o`0006ko
oooo001aooooo`Co00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2o`0000[ooooo
0ol0001booooo`00MOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`07ooooo`;o00002Oooool3o`0007Gooooo001hooooo`?o00001oooool2o`0000Gooooo1OoVi^H7
ooooo`03o`000?oooooooooo00Kooooo0ol0001hooooo`00Noooool3o`0000Kooooo0_l000000ooo
ooooi^KVonKViP07onKViP?ooooo0_l00006ooooo`?o0000Noooool007kooooo1?l00004ooooo`_o
i^KV00?oooooo`000?ooool00oooool4o`0007kooooo0022ooooo`?o000000?oooooonKVi_oVi^H0
2OoVi^H00ol0003oooooooooo`03o`0008;ooooo0025ooooo`Coi^KV1_l00003onKViP;o0000QOoo
ool008Gooooo1_oVi^H2o`0000Goi^KVQoooool008Gooooo1_oVi^H2o`0000Goi^KVQoooool008Go
oooo1_oVi^H2o`0000Goi^KVQoooool008Gooooo1OoVi^H5o`0000?oi^KVQoooool008Kooooo1OoV
i^H2o`0000Coi^KVR?ooool008Kooooo1_oVi^H3o`0000;oi^KVR?ooool008Oooooo2OoVi^J9oooo
o`00ROooool5onKViX_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.16548, -0.829983, \
0.0154436, 0.00499764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00ZOooool7o`0005[ooooo1Ol0
000:ooooo`00ZOooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000002Oooool0
0:Wooooo1_l0001Looooo`;o000000?oooooo`000?l000002Oooool00:[ooooo1?l0001Mooooo`Co
00002_ooool00:[ooooo1?l0001Mooooo`;o000000?oooooo`000?l000002Oooool00:_ooooo0_l0
001Nooooo`;o000000?oooooo`000?l000002Oooool00:[ooooo0ol00004ooooo`03o`000?oooooo
oooo05Kooooo1Ol0000:ooooo`00/_ooool2o`0005;ooooo00?o0000ooooooooool04?ooool00;Co
oooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Aooooo`00]Oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo01;ooooo002fooooo`03o`000?oooooooooo04[ooooo00?o
0000ooooooooool04oooool00;Oooooo00?o0000ooooooooool0Aoooool2o`0001Kooooo002hoooo
o`;o0000A_ooool00ol0003oooooooooo`0Fooooo`00^_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo01Oooooo002kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
6?ooool00;cooooo00?o0000ooooooooool0?Oooool2o`0001_ooooo002mooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool06oooool00;kooooo0_l0000jooooo`03o`000?oooooooooo
01cooooo0030ooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool07Oooool00<7ooooo
00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Nooooo`00`_ooool00ol0003ooooooooo
o`0aooooo`;o00008Oooool00<?ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0Q
ooooo`00a?ooool2o`0002kooooo00?o0000ooooooooool08_ooool00<Kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0Sooooo`00aoooool00ol0003oooooooooo`0Wooooo`;o0000
9_ooool00<Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`00bOooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02Oooooo003:ooooo`;o00008_ooool00ol0
003oooooooooo`0Xooooo`00c?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Wo
oooo003=ooooo`03o`000?oooooooooo01_ooooo0_l0000/ooooo`00c_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooooooo02cooooo003?ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool0;Oooool00=3ooooo0_l0000Fooooo`03o`000?oooooooooo02kooooo003Booooo`03
o`000?oooooooooo017ooooo0_l0000aooooo`00doooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo037ooooo003Dooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0<_oo
ool00=Gooooo00?o0000ooooooooool00_ooool5onKViPCooooo00?o0000ooooooooool0<oooool0
0=Kooooo0_l00009onKViP03ooooool0003ooooo03Gooooo003Gooooo`?oi^KV1?l00004onKViSOo
oooo003Gooooo`Koi^KV0_l00003onKViSOooooo0019ooooo`Co0000ROooool4onKViPGo00001?oV
i^Hfooooo`00B_ooool2o`0008[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo0017oooo
o`Ko0000ROooool3onKViP;o00000_oVi^H2o`0000Coi^KV=_ooool004Oooooo0_l000000ooooooo
0000o`00002:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hfooooo`00B?ooool4o`0008[ooooo
1?oVi^H6o`0000?oi^KV=_ooool004Wooooo0ol0002;ooooo`_oi^KV=oooool004[ooooo0_l0002;
ooooo`_oi^KV=oooool00=Sooooo2OoVi^Hhooooo`00B_ooool00ol0003oooooooooo`2=ooooo`Go
i^KV>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_oo
ool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooo
oooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0
003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[o
oooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o
0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000oooo
ooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00
B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oo
oooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool0
0ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo
03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooooooo
o`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000
ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0joooo
o`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`00
0?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[ooooo00?o0000ooooooooool0Sooo
ool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooo
oooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o0000ooooooooool0>_ooool004[o
oooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0jooooo`00B_ooool00ol0003ooooo
ooooo`2?ooooo`03o`000?oooooooooo03[ooooo001:ooooo`03o`000?oooooooooo08oooooo00?o
0000ooooooooool0>_ooool004Sooooo1OoVi^J=ooooo`Goi^KV>_ooool004Kooooo2OoVi^J9oooo
o`Woi^KV>?ooool004Gooooo0ooVi^H4o`0000Coi^KVQoooool3onKViPCo00001?oVi^Hgooooo`00
AOooool6onKViP;o00000ooVi^J7ooooo`Koi^KV0_l00003onKViSOooooo000eooooo`Go00002_oo
ool4onKViPGo00001?oVi^H:ooooo`Co0000E_ooool4o`0000Sooooo1Ol00007ooooo`Go00001?oo
ool4onKViPGo00001?oVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000Wooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViPWooooo0_l00002ooooo`;o0000E?ooool00ol0003oooooo`00000;
ooooo`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2
o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o000000?oooooo`000?l000002Oooool3onKV
iP;o00000_oVi^H2o`0000Coi^KV3Oooool2o`0005Cooooo00?o0000ooooool000000_l00009oooo
o`;o000000?oooooo`000?l000001oooool2o`000003ooooool0003o000000?ooooo0ooVi^H2o`00
00;oi^KV0_l00004onKViSKooooo000fooooo`Co00002_ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV2oooool3o`0005Gooooo00Go0000ooooool0003oooooo`000009ooooo`;o000000?oooooo`00
0?l000001oooool4o`0000Cooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSKooooo000fooooo`;o
000000?oooooo`000?l000002Oooool4onKViPKo00000ooVi^H=ooooo`;o0000EOooool3o`0000[o
oooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l000000oooool4onKViPKo
00000ooVi^Hfooooo`00=_ooool2o`000003ooooool0003o000000[ooooo2ooVi^H:ooooo`;o0000
0_ooool2o`0006;ooooo0_l000000ooooooo0000o`000007ooooo`;o000000?oooooo`000?l00000
1?ooool;onKViSOooooo000eooooo`Go00002oooool;onKViP_ooooo1?l0001Rooooo`Go00001ooo
ool5o`0000Gooooo2ooVi^Hgooooo`00A_ooool9onKViXWooooo2OoVi^Hhooooo`00B?ooool5onKV
iPgooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0Mooooo`Goi^KV>_ooool003_o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo05go
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0?Oooool003_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0?Oooool003cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0?_ooool003cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0?_ooool003gooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo067ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0?oooool003gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0?oooool003kooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
@?ooool003kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo06?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0@?ooool003oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0
03oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
06Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0@Oooool003oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@Oooool0043ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo06Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0@_ooool0043ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_ooool0047ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0@oooool0047ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo06_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0@oooool004;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo06_ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0A?ooool004;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo06gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0A?ooool004?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0AOooool004?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06oooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
AOooool004?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo06oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0AOooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000B?ooool004Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo077ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000B?ooool004Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo07?ooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`00AOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0Loooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0004Wooooo0016ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`1cooooo`07o`000?ooooooooooooooool0003oooooo`000002ooooo`03o`000?oooooooooo04So
oooo0016ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1eooooo`06
o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`18ooooo`00Aoooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo07Gooooo00So0000oooooooooooo0000oooo
ool0003oooooo`0004_ooooo0017ooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0
Moooool5onKViP03ooooool0003ooooo04[ooooo0016ooooo`Woi^KVM_ooool9onKViT_ooooo0015
ooooo`?oi^KV1?l00004onKViWCooooo2ooVi^I:ooooo`00AOooool6onKViP;o00000ooVi^Idoooo
o`_oi^KVB_ooool000Sooooo1ol0000eooooo`Coi^KV1Ol00004onKViSKooooo1Ol0000gooooo`Co
i^KV1ol00002onKViSKooooo1_l0000=ooooo`002?ooool2o`0000;ooooo0_l0000fooooo`?oi^KV
0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKViP;o0000
00?oi^KVo`000?l000000ooVi^Hgooooo`;o000000?oooooo`000?l000003Oooool000Sooooo1_l0
000fooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_oo
ool5onKViP;o000000?oi^KVo`000?l000000ooVi^Hhooooo`;o00003oooool000Wooooo1?l0000g
ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5
onKViP;o000000?oi^KVo`000?l000000ooVi^Hiooooo`;o00003_ooool000Wooooo1?l00005oooo
o`;o0000<?ooool4onKViPKo00000ooVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool5onKV
iPCo00001?oVi^Haooooo`;o00000oooool2o`0000;ooooo0_l0000=ooooo`002_ooool2o`0000So
oooo0ol0000^ooooo`_oi^KV00?o0000ooooooooool0=Oooool2o`000003ooooool0003o000003Oo
oooo1?oVi^H2o`0000Goi^KV;oooool3o`0000Gooooo0_l00002ooooo`;o00003Oooool000Wooooo
0ol0000;ooooo`?o0000:oooool;onKViP03ooooool0003ooooo03Cooooo1Ol0000gooooo`04o`00
0?oVi^Koi^KVonKViP?o00001OoVi^H/ooooo`?o00002Oooool4o`0000kooooo000Jooooo`?o0000
:Oooool9onKViP?ooooo0_l0001]ooooo`;o00000_ooool9onKViR[ooooo0ol0000Nooooo`007Ooo
ool4o`0002Oooooo1OoVi^H7ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01?oo
ool5onKViRSooooo1?l0000Qooooo`008Oooool3o`00037ooooo0_l0000cooooo`03o`000?oooooo
oooo037ooooo0_l0000aooooo`?o00009Oooool002Cooooo0ol0000`ooooo`;o0000<Oooool00ol0
003oooooooooo`0_ooooo`;o0000<?ooool3o`0002Sooooo000Wooooo`?o0000;oooool00ol0003o
ooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool3o`0002_o
oooo000Zooooo`?o0000;Oooool2o`0002kooooo00?o0000ooooooooool0;?ooool2o`0002gooooo
0ol0000^ooooo`00;Oooool4o`0002_ooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo02Wooooo1?l0000aooooo`00<Oooool3o`0002Wooooo0_l0000[
ooooo`03o`000?oooooooooo02Wooooo0_l0000Yooooo`?o0000=Oooool003Cooooo0ol0000Xoooo
o`;o0000:Oooool00ol0003oooooooooo`0Wooooo`;o0000:?ooool3o`0003Sooooo000gooooo`?o
00009oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool09Oooool3o`0003_ooooo000jooooo`?o00009Oooool2o`0002Kooooo00?o0000ooooooooool0
9?ooool2o`0002Gooooo0ol0000nooooo`00?Oooool3o`0002Cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02;ooooo0ol00011ooooo`00@?ooool4
o`00027ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo0_l0000Qooooo`Co0000A?ooool0
04Cooooo0ol0000Pooooo`;o00008Oooool00ol0003oooooooooo`0Oooooo`;o00008?ooool3o`00
04Sooooo0017ooooo`?o00007oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool07Oooool3o`0004_ooooo001:ooooo`?o00007Oooool2o`0001kooooo
00?o0000ooooooooool07?ooool2o`0001gooooo0ol0001>ooooo`00COooool3o`0001cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01[ooooo0ol0
001Aooooo`00D?ooool3o`0001[ooooo0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000J
ooooo`?o0000E?ooool005?ooooo1?l0000Hooooo`;o00006Oooool00ol0003oooooooooo`0Goooo
o`;o00006?ooool4o`0005Oooooo001Gooooo`?o00005oooool00ol0003oooooooooo`0Fooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool05Oooool3o`0005_ooooo001Jooooo`?o0000
5Oooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`0001Gooooo0ol0001Nooooo`00GOoo
ool3o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01;ooooo0ol0001Qooooo`00H?ooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooo
oooo017ooooo0_l0000Booooo`?o0000I?ooool006?ooooo0ol0000Aooooo`;o00004Oooool00ol0
003oooooooooo`0?ooooo`;o00004Oooool3o`0006Oooooo001Vooooo`Co00003oooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool4o`0006[o
oooo001Zooooo`?o00003Oooool2o`0000kooooo00?o0000ooooooooool03?ooool2o`0000gooooo
0ol0001^ooooo`00KOooool3o`0000cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00[ooooo0ol0001aooooo`00L?ooool3o`0000[ooooo0_l0000;
ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`?o0000M?ooool007?ooooo0ol00009oooo
o`;o00002Oooool00ol0003oooooooooo`07ooooo`;o00002Oooool3o`0007Oooooo001fooooo`Co
00001oooool00ol0003oooooooooo`04ooooo`Goi^KV1_ooool00ol0003oooooooooo`05ooooo`Co
0000N_ooool007[ooooo0ol00005ooooo`;o00000_ooool9onKViP;ooooo0_l00005ooooo`?o0000
O_ooool007gooooo0ol00004ooooo`03o`000?oVi^Koi^KV00Woi^KV00?o0000ooooooooool00_oo
ool3o`00087ooooo0020ooooo`?o00000_ooool;onKViP;ooooo0ol00024ooooo`00Poooool01?l0
003oi^KVonKVi_oVi^H6o`0000Coi^KV00?o0000ooooooooool0QOooool008Cooooo1OoVi^H2o`00
00Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KVR?ooool008Cooooo1OoVi^H2o`0000Koi^KV
R?ooool008Cooooo1?oVi^H5o`0000Coi^KVR?ooool008Gooooo1?oVi^H2o`0000Goi^KVROooool0
08Gooooo1OoVi^H3o`0000?oi^KVROooool008Kooooo2OoVi^J:ooooo`00R?ooool5onKViXcooooo
0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.17772, -0.833972, \
0.0157141, 0.00502069}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19288 .30902 -5 -6 ]
[.19288 .30902 5 6 ]
[.2619 .30902 -5 -6 ]
[.2619 .30902 5 6 ]
[.2619 .16187 -5 -6 ]
[.2619 .16187 5 6 ]
[.33093 .30902 -5 -6 ]
[.33093 .30902 5 6 ]
[.2619 .45617 -5 -6 ]
[.2619 .45617 5 6 ]
[.5 .45617 -5 -6 ]
[.5 .45617 5 6 ]
[.66907 .30902 -5 -6 ]
[.66907 .30902 5 6 ]
[.71509 .30902 -5 -6 ]
[.71509 .30902 5 6 ]
[.7611 .30902 -5 -6 ]
[.7611 .30902 5 6 ]
[.80712 .30902 -5 -6 ]
[.80712 .30902 5 6 ]
[.80712 .16187 -5 -6 ]
[.80712 .16187 5 6 ]
[.80712 .01472 -5 -6 ]
[.80712 .01472 5 6 ]
[.7381 .45617 -5 -6 ]
[.7381 .45617 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.05 w
.19288 .30902 Mdot
0 g
gsave
.19288 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .30902 m
.2619 .16187 L
s
.9 g
.05 w
.2619 .30902 Mdot
0 g
gsave
.2619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .16187 Mdot
0 g
gsave
.2619 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .30902 Mdot
0 g
gsave
.33093 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.2619 .45617 Mdot
0 g
gsave
.2619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .45617 Mdot
0 g
gsave
.5 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.05 w
.66907 .30902 Mdot
0 g
gsave
.66907 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .30902 Mdot
0 g
gsave
.71509 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .30902 Mdot
0 g
gsave
.7611 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .30902 m
.80712 .16187 L
s
.9 g
.05 w
.80712 .30902 Mdot
0 g
gsave
.80712 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .16187 m
.80712 .01472 L
s
.9 g
.05 w
.80712 .16187 Mdot
0 g
gsave
.80712 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.80712 .01472 Mdot
0 g
gsave
.80712 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.05 w
.7381 .45617 Mdot
0 g
gsave
.7381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{281.438, 173.875},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004I0000[B000`400?l00000o`00003ooooooolJ
ooooo`00oooooolJooooo`00oooooolJooooo`00oooooolJooooo`00g?ooool5o`0003Sooooo003M
ooooo`;o000000?oooooo`000?l00000=oooool00=gooooo0_l000000ooooooo0000o`00000goooo
o`00gOooool4o`0003Sooooo003Mooooo`;o000000?oooooo`000?l00000=oooool00=gooooo0_l0
00000ooooooo0000o`00000gooooo`00g?ooool5o`0003Sooooo003ooooooa[ooooo003Oooooo`03
o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oo
oooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo
03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo
003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Ooooo
o`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`00
0?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooo
oooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oo
oooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003O
ooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03
o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oo
oooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo
03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo003Oooooo`03o`000?oooooooooo03Oooooo
003Oooooo`03o`000?oooooooooo03Oooooo003Mooooo`Goi^KV=oooool00=_ooooo2OoVi^Heoooo
o`00f_ooool3onKViPCo00001?oVi^Hdooooo`00f_ooool6onKViP;o00000ooVi^Hdooooo`00B_oo
ool4o`0008_ooooo1?oVi^H5o`0000Coi^KV<oooool004_ooooo0_l0002<ooooo`?oi^KV0_l00002
onKViP;o00001?oVi^Hcooooo`00B?ooool6o`0008_ooooo0ooVi^H2o`0000;oi^KV0_l00004onKV
iS?ooooo0018ooooo`;o000000?oooooo`000?l00000S?ooool3onKViP;o00000_oVi^H2o`0000Co
i^KV<oooool004Wooooo1?l0002<ooooo`Coi^KV1_l00003onKViS?ooooo001:ooooo`?o0000SOoo
ool;onKViSCooooo001;ooooo`;o0000SOooool;onKViSCooooo003Kooooo`Woi^KV=Oooool004_o
oooo00?o0000ooooooooool0Soooool5onKViSOooooo001;ooooo`03o`000?oooooooooo097ooooo
00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003ooooooooo
o`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;oooo
o`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000oooooooo
ool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`00
0?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=ooo
ool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0
003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097o
oooo00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003ooooo
ooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;
ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000oooo
ooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03
o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0
=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool0
0ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo
097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003o
ooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo
001;ooooo`03o`000?oooooooooo097ooooo00?o0000ooooooooool0=oooool004_ooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Boooool00ol0003oooooooooo`2Aoooo
o`03o`000?oooooooooo03Oooooo001;ooooo`03o`000?oooooooooo097ooooo00?o0000oooooooo
ool0=oooool004_ooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0gooooo`00Booo
ool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo03Oooooo0019ooooo`Goi^KVSoooool5
onKViSOooooo0017ooooo`Woi^KVRoooool9onKViSGooooo0016ooooo`?oi^KV1?l00004onKViXWo
oooo0ooVi^H4o`0000Coi^KV=?ooool004Kooooo1_oVi^H2o`0000?oi^KVROooool6onKViP;o0000
0ooVi^Hdooooo`00=Oooool5o`0000_ooooo1?oVi^H5o`0000Coi^KV2_ooool4o`0005Sooooo1?l0
0007ooooo`Go00002?ooool5o`0000Cooooo1?oVi^H5o`0000Coi^KV<oooool003Kooooo0_l00000
0ooooooo0000o`00000:ooooo`?oi^KV0_l00002onKViP;o00001?oVi^H9ooooo`;o00000_ooool2
o`0005Kooooo00?o0000ooooool000002_ooool2o`000003ooooool0003o000000Sooooo0_l00000
0ooooooo0000o`000003ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hcooooo`00=_ooool2o`00
0003ooooool0003o000000[ooooo0ooVi^H2o`0000;oi^KV0_l00004onKViPgooooo0_l0001Foooo
o`03o`000?oooooo000000;o00002?ooool2o`000003ooooool0003o000000Sooooo0_l000000ooo
oooo0000o`000003ooooo`?oi^KV0_l00002onKViP;o00001?oVi^Hcooooo`00=_ooool4o`0000_o
oooo0ooVi^H2o`0000;oi^KV0_l00004onKViP_ooooo0ol0001Gooooo`05o`000?oooooo0000oooo
ool000002?ooool2o`000003ooooool0003o000000Sooooo1?l00004ooooo`?oi^KV0_l00002onKV
iP;o00001?oVi^Hcooooo`00=_ooool2o`000003ooooool0003o000000[ooooo1?oVi^H6o`0000?o
i^KV3Oooool2o`0005Oooooo0ol00009ooooo`;o000000?oooooo`000?l000002?ooool2o`000003
ooooool0003o000000?ooooo1?oVi^H6o`0000?oi^KV<oooool003Kooooo0_l000000ooooooo0000
o`00000;ooooo`_oi^KV2_ooool2o`0000;ooooo0_l0001Sooooo`;o000000?oooooo`000?l00000
2?ooool2o`000003ooooool0003o000000Cooooo2ooVi^Hdooooo`00=Oooool5o`0000cooooo2ooV
i^H;ooooo`Co0000Hoooool5o`0000Sooooo1Ol00005ooooo`_oi^KV=?ooool004Oooooo2OoVi^J;
ooooo`Woi^KV=Oooool003_ooooo00?o0000ooooooooool02oooool5onKViVkooooo00?o0000oooo
ooooool07Oooool00ol0003oi^KVonKViP03onKViSOooooo000kooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03[o
oooo000looooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`1Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo03_ooooo000looooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03_ooooo000m
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1R
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo03cooooo000mooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03cooooo000mooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Sooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo03cooooo000nooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1Uooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03gooooo000nooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Uooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo03gooooo000oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Wooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03kooooo000oooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03kooooo0010ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`1Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03oooooo0010ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03oooooo
0011ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Zooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo043ooooo0011ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1[ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo043ooooo0012oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1/oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo047ooooo0012ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1]ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo047ooooo0013ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1^ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo04;ooooo0013ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1_ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;ooooo0014ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1`ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000004Gooooo0014
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1`
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000004Gooooo0015ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`1booooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000004Kooooo0015ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`1booooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000004Kooooo0016ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`1dooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo0000Aoooool004Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo07Cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00017
ooooo`00A_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0MOooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0004Oooooo0017
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1fooooo`06o`000?oo
ooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`16ooooo`00Aoooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool0Moooool01Ol0003oooooo`000?oooooo0000
00;ooooo00?o0000ooooooooool0A_ooool004Sooooo00?o0000onKVi_oVi^H00ooVi^H00ol0003o
ooooooooo`1hooooo`03o`000?oVi^Koi^KV00?oi^KV00?o0000ooooooooool0Aoooool004Oooooo
2OoVi^Ihooooo`Woi^KVB?ooool004Kooooo0ooVi^H4o`0000Coi^KVM_ooool;onKViTOooooo0016
ooooo`Koi^KV0_l00003onKViWKooooo2ooVi^I7ooooo`001oooool7o`0003Oooooo1?oVi^H5o`00
00Coi^KV=oooool5o`0003Sooooo0ooVi^H7o`0000?oi^KV=oooool6o`0000Wooooo0007ooooo`;o
00000_ooool2o`0003Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l000000ooooooo
0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSSooooo0_l000000ooooooo
0000o`000009ooooo`001oooool6o`0003Sooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo
0_l000000ooooooo0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViSWooooo
0_l0000;ooooo`002?ooool4o`0003Wooooo0ooVi^H2o`0000;oi^KV0_l00004onKViSSooooo0_l0
00000ooooooo0000o`00000gooooo`Coi^KV0_l000000ooVi^Ko0000o`000004onKViS[ooooo0_l0
000:ooooo`002?ooool4o`0000Gooooo0_l0000booooo`Coi^KV1_l00003onKViSSooooo0_l00000
0ooooooo0000o`00000gooooo`Coi^KV1?l00005onKViS;ooooo0_l00003ooooo`;o00000_ooool2
o`0000Wooooo0009ooooo`;o00002?ooool3o`00033ooooo2ooVi^H00ol0003oooooooooo`0foooo
o`;o000000?oooooo`000?l00000=oooool01?l0003oi^KVonKVi_oVi^H2o`0000Koi^KV<?ooool3
o`0000Gooooo0_l00002ooooo`;o00002Oooool000Sooooo0ol0000;ooooo`Co0000;?ooool;onKV
iP03ooooool0003ooooo03Gooooo1Ol0000gooooo`04o`000?ooooooi^KVonKViP?o00001_oVi^H/
ooooo`Co00002Oooool4o`0000[ooooo000Jooooo`?o0000:_ooool9onKViP?ooooo0_l0001^oooo
o`;o00000oooool9onKViR[ooooo0ol0000Kooooo`007Oooool3o`0002Wooooo1OoVi^H7ooooo`;o
0000Joooool00ol0003oooooooooo`05ooooo`Goi^KV:Oooool3o`0001kooooo000Pooooo`?o0000
=?ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo037ooooo0_l0000cooooo`?o0000
8Oooool002?ooooo1?l0000aooooo`;o0000<_ooool00ol0003oooooooooo`0_ooooo`;o0000<_oo
ool3o`0002Cooooo000Wooooo`?o0000<?ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool0;_ooool4o`0002Oooooo000Zooooo`?o0000;_ooool2o`00
02oooooo00?o0000ooooooooool0;?ooool2o`0002kooooo0ol0000[ooooo`00;Oooool3o`0002go
oooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool3o`0002ko
oooo000`ooooo`Co0000:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo
0_l0000[ooooo`?o0000<Oooool003Cooooo0ol0000Yooooo`;o0000:_ooool00ol0003ooooooooo
o`0Wooooo`;o0000:Oooool4o`0003Cooooo000gooooo`?o0000:?ooool2o`0002Sooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`?o0000>?ooool003[ooooo0ol0000Woooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0000koooo
o`00?Oooool4o`0002Cooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool08oooool3o`0003kooooo0011ooooo`?o00008oooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo027ooooo0_l0000Sooooo`?o0000@Oooool004Cooooo0ol0000Qooooo`;o00008_oo
ool00ol0003oooooooooo`0Oooooo`;o00008Oooool4o`0004Cooooo0017ooooo`?o00008?ooool2
o`00023ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`?o0000B?ooool0
04[ooooo1?l0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool2o`00
01kooooo0ol0001;ooooo`00C_ooool3o`0001cooooo0_l0000Mooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool06oooool3o`0004kooooo001Aooooo`?o00006oooool2o`0001_ooooo
00?o0000ooooooooool06Oooool2o`0001[ooooo1?l0001Aooooo`00E?ooool3o`0001[ooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0Gooooo`;o00006Oooool3o`0005Gooooo001G
ooooo`Co00005oooool2o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0F
ooooo`?o0000F?ooool005_ooooo0ol0000Fooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool05?ooool2o`0001Kooooo0ol0001Kooooo`00G_ooool3o`0001Cooooo0_l0000Eooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0005kooooo001Qooooo`?o0000
4oooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001Qooooo`00I?oo
ool4o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0?ooooo`;o00004Ooo
ool3o`0006Gooooo001Xooooo`?o00003oooool2o`00013ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0>ooooo`?o0000J?ooool006_ooooo0ol0000>ooooo`;o00003_ooool00ol0
003oooooooooo`0<ooooo`;o00003_ooool3o`0006_ooooo001^ooooo`?o00003Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool4o`0006ko
oooo001aooooo`Co00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2o`0000[ooooo
0ol0001booooo`00MOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`07ooooo`;o00002Oooool3o`0007Gooooo001hooooo`?o00001oooool2o`0000Gooooo1OoVi^H7
ooooo`03o`000?oooooooooo00Kooooo0ol0001hooooo`00Noooool3o`0000Kooooo0_l000000ooo
ooooi^KVonKViP07onKViP?ooooo0_l00006ooooo`?o0000Noooool007kooooo1?l00004ooooo`_o
i^KV00?oooooo`000?ooool00oooool4o`0007kooooo0022ooooo`?o000000?oooooonKVi_oVi^H0
2OoVi^H00ol0003oooooooooo`03o`0008;ooooo0025ooooo`Coi^KV1_l00003onKViP;o0000QOoo
ool008Gooooo1_oVi^H2o`0000Goi^KVQoooool008Gooooo1_oVi^H2o`0000Goi^KVQoooool008Go
oooo1_oVi^H2o`0000Goi^KVQoooool008Gooooo1OoVi^H5o`0000?oi^KVQoooool008Kooooo1OoV
i^H2o`0000Coi^KVR?ooool008Kooooo1_oVi^H3o`0000;oi^KVR?ooool008Oooooo2OoVi^J9oooo
o`00ROooool5onKViX_ooooo0000\
\>"],
  ImageRangeCache->{{{0, 280.438}, {172.875, 0}} -> {-2.16548, -0.829983, \
0.0154436, 0.00499764}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Inversion"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Inversion - Intro"],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.20018 .30902 -5 -6 ]
[.20018 .30902 5 6 ]
[.20018 .16187 -5 -6 ]
[.20018 .16187 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.52939 .30902 -5 -6 ]
[.52939 .30902 5 6 ]
[.57643 .30902 -5 -6 ]
[.57643 .30902 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.27072 .01472 -5.0625 -6 ]
[.27072 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.62346 .16187 -5 -6 ]
[.62346 .16187 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
gsave
.20018 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20018 .16187 Mdot
0 g
gsave
.20018 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52939 .30902 Mdot
0 g
gsave
.52939 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.57643 .30902 Mdot
0 g
gsave
.57643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
gsave
.27072 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.62346 .16187 Mdot
0 g
gsave
.62346 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{390.812, 241.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000660000lB000`400?l00000o`00003ooooooon7
ooooo`00oooooon7ooooo`00oooooon7ooooo`00oooooon7ooooo`00oooooon7ooooo`00oooooon7
ooooo`00oooooon7ooooo`00JOooool7o`000?oooooo1?ooool5o`0000kooooo001Yooooo`;o0000
0_ooool2o`000?oooooo1_ooool2o`000003ooooool0003o000000gooooo001Yooooo`Ko0000oooo
ool6ooooo`;o000000?oooooo`000?l000003Oooool006[ooooo1?l0003oooooo`Oooooo1?l0000>
ooooo`00J_ooool4o`000?oooooo1oooool2o`000003ooooool0003o000000gooooo001[ooooo`;o
0000ooooool8ooooo`;o000000?oooooo`000?l000003Oooool006[ooooo0ol00008ooooo`?o0000
loooool3o`0000Gooooo1Ol0000>ooooo`00N?ooool2o`000>oooooo0_l0000Kooooo`00N_ooool2
o`000>_ooooo0_l0000Mooooo`00O?ooool3o`000>Gooooo0ol0000Oooooo`00Ooooool2o`000>7o
oooo0_l0000Rooooo`00POooool3o`000=_ooooo0ol0000Tooooo`00Q?ooool2o`000=Oooooo0_l0
000Wooooo`00Q_ooool2o`000=?ooooo0_l0000Yooooo`00R?ooool3o`000<gooooo0ol0000[oooo
o`00Roooool2o`000<Wooooo0_l0000^ooooo`00SOooool2o`000<Gooooo0_l0000`ooooo`00Sooo
ool3o`000;oooooo0ol0000booooo`00T_ooool2o`000;_ooooo0_l0000eooooo`00U?ooool3o`00
0;Gooooo0ol0000gooooo`00Uoooool2o`000;7ooooo0_l0000jooooo`00VOooool2o`000:gooooo
0_l0000looooo`00Voooool3o`000:Oooooo0ol0000nooooo`00W_ooool2o`000:?ooooo0_l00011
ooooo`00X?ooool2o`0009oooooo0_l00013ooooo`00X_ooool3o`0009Wooooo0ol00015ooooo`00
YOooool2o`0009Gooooo0_l00018ooooo`00Yoooool3o`0008oooooo0ol0001:ooooo`00Z_ooool2
o`0008_ooooo0_l0001=ooooo`00[?ooool2o`0008Oooooo0_l0001?ooooo`00[_ooool3o`00087o
oooo0ol0001Aooooo`00/Oooool2o`0007gooooo0_l0001Dooooo`00/oooool2o`0007Wooooo0_l0
001Fooooo`00]Oooool3o`0007?ooooo0ol0001Hooooo`00^?ooool2o`0006oooooo0_l0001Koooo
o`00^_ooool3o`0006Wooooo0ol0001Mooooo`00_Oooool2o`0006Gooooo0_l0001Pooooo`00_ooo
ool2o`00067ooooo0_l0001Rooooo`00`Oooool3o`0005_ooooo0ol0001Tooooo`00a?ooool2o`00
05Oooooo0_l0001Wooooo`00a_ooool2o`0005?ooooo0_l0001Yooooo`00b?ooool3o`0004gooooo
0ol0001[ooooo`00boooool2o`0004Wooooo0_l0001^ooooo`00cOooool3o`0004?ooooo0ol0001`
ooooo`00d?ooool2o`0003oooooo0_l0001cooooo`00d_ooool2o`0003_ooooo0_l0001eooooo`00
e?ooool3o`0003Gooooo0ol0001gooooo`00eoooool2o`00037ooooo0_l0001jooooo`00fOooool2
o`0002gooooo0_l0001looooo`00foooool3o`0002Oooooo0ol0001nooooo`00g_ooool2o`0000ko
oooo1_oVi^H?ooooo`;o0000POooool00>3ooooo0ol00009ooooo`[oi^KV2_ooool3o`0008?ooooo
003Sooooo`;o00001_ooool<onKViPOooooo0_l00026ooooo`00iOooool2o`0000?ooooo3_oVi^H4
ooooo`;o0000R?ooool00>Oooooo0_l00006onKViPCo00001_oVi^H3o`0008[ooooo003Yooooo`Wo
i^KV0_l00005onKViXgooooo001@ooooo`Co0000U?ooool7onKViPGo00001_oVi^J<ooooo`00DOoo
ool2o`0009Gooooo1_oVi^H2o`0000;oi^KV0_l00006onKViXcooooo001>ooooo`Ko0000U?ooool6
onKViP;o00000_oVi^H2o`0000Koi^KVS?ooool004kooooo0_l000000ooooooo0000o`00002Eoooo
o`Koi^KV0_l00002onKViP;o00001_oVi^J<ooooo`00Coooool4o`0009Gooooo1ooVi^H6o`0000Go
i^KVS?ooool0053ooooo0ol0002Eoooooa;oi^KVS?ooool0057ooooo0_l0002Foooooa3oi^KVSOoo
ool00>Wooooo4?oVi^J=ooooo`00j_ooool>onKViXkooooo003[ooooo`coi^KVSoooool0057ooooo
00?o0000ooooooooool0V?ooool:onKViY3ooooo001Aooooo`03o`000?oooooooooo09[ooooo1_oV
i^JBooooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001Aoooo
o`03o`000?oooooooooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000oooooooo
ool0WOooool00ol0003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`00
0?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0T_oo
ool0057ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00DOooool00ol0
003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo09go
oooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0003ooooo
ooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001A
ooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000oooo
ooooool0WOooool00ol0003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03
o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0
T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00DOooool0
0ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo
09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0003o
ooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo
001Aooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000
ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Moooo
o`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo09gooooo00?o0000oooooooo
ool0T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00DOoo
ool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooo
oooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0
003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;o
oooo001Aooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o
0000ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2M
ooooo`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oooooooooo09gooooo00?o0000oooo
ooooool0T_ooool0057ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`2Booooo`00
DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo09;ooooo001Aooooo`03o`000?oo
oooooooo09gooooo00?o0000ooooooooool0T_ooool0057ooooo00?o0000ooooooooool0WOooool0
0ol0003oooooooooo`2Booooo`00DOooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo
09;ooooo001?ooooo`Koi^KVVOooool6onKViY;ooooo001=ooooo`[oi^KVUOooool:onKViY3ooooo
001<ooooo`coi^KVToooool<onKViXoooooo001;ooooo`koi^KVTOooool>onKViXkooooo001:oooo
o`Goi^KV1?l00007onKViXoooooo1_oVi^H4o`0000Koi^KVSOooool004[ooooo2?oVi^H2o`0000Ko
i^KVSoooool9onKViP;o00001OoVi^J=ooooo`00=?ooool5o`00013ooooo1_oVi^H5o`0000Ooi^KV
3oooool4o`0004cooooo1?l0000<ooooo`Go00003Oooool5o`0000Oooooo1ooVi^H5o`0000Koi^KV
S?ooool003Gooooo0_l000000ooooooo0000o`00000?ooooo`Goi^KV0_l00002onKViP;o00001ooV
i^H>ooooo`;o00000_ooool2o`0004[ooooo00?o0000ooooool000003oooool2o`000003ooooool0
003o000000gooooo0_l000000ooooooo0000o`000006ooooo`Koi^KV0_l00002onKViP;o00001_oV
i^J<ooooo`00=Oooool2o`000003ooooool0003o000000oooooo1OoVi^H2o`0000;oi^KV0_l00007
onKViQ;ooooo0_l0001:ooooo`03o`000?oooooo000000;o00003Oooool2o`000003ooooool0003o
000000gooooo0_l000000ooooooo0000o`000006ooooo`Koi^KV0_l00002onKViP;o00001_oVi^J<
ooooo`00=Oooool4o`00013ooooo1OoVi^H2o`0000;oi^KV0_l00007onKViQ3ooooo0ol0001;oooo
o`05o`000?oooooo0000ooooool000003Oooool2o`000003ooooool0003o000000gooooo1?l00007
ooooo`Koi^KV0_l00002onKViP;o00001_oVi^J<ooooo`00=Oooool2o`000003ooooool0003o0000
00oooooo1_oVi^H6o`0000Koi^KV4_ooool2o`0004_ooooo0ol0000>ooooo`;o000000?oooooo`00
0?l000003Oooool2o`000003ooooool0003o000000Kooooo1ooVi^H6o`0000Goi^KVS?ooool003Go
oooo0_l000000ooooooo0000o`00000?oooooa;oi^KV3_ooool2o`0000;ooooo0_l0001Looooo`;o
000000?oooooo`000?l000003Oooool2o`000003ooooool0003o000000Kooooo4_oVi^J<ooooo`00
=?ooool5o`00017ooooo4?oVi^H@ooooo`Co0000G?ooool5o`0000gooooo1Ol00008oooooa3oi^KV
SOooool004[ooooo4?oVi^J?oooooa3oi^KVSOooool004_ooooo3_oVi^JAooooo`koi^KVS_ooool0
04cooooo3?oVi^JCooooo`coi^KVSoooool004gooooo2_oVi^JEooooo`[oi^KVT?ooool003_ooooo
00?o0000ooooooooool04Oooool6onKViQ?ooooo00?o0000ooooooooool0EOooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oVi^Koi^KV00Coi^KVT_ooool003_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo05Kooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Uooo
ool003cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo05Oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0Uoooool003cooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0V?ooool003go
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo05Wo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool0V?ooool003gooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo05[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0VOooool003kooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo05_ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0VOooool003kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0VOooool003oooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo05gooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0V_ooool003oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo05gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0V_ooool0043ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
Voooool0043ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo05oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool0Voooool0047ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0W?ooool0
047ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
067ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0W?ooool0047ooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo06;ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0WOooool004;ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06?ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool0WOooool004;ooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0W_ooool004?ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo06Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0W_ooool004?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo06Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Woooool004Cooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0Woooool004Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo06Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0X?ooool004Gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0X?oo
ool004Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo06[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0XOooool004Kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0XOooool004Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo06co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0X_ooool004Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0X_ooool004Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06kooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0Xoooool004Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Xoooool004Sooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo073ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0Y?ooool004Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo073ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0Y?ooool004Wooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo07;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
YOooool004Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo07;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0YOooool004[ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo07Cooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0Y_ooool004[ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo07Cooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0Y_oo
ool004_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo07Gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0Y_ooool004_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo07Kooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000ZOooool004cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo07Oooooo00Co0000oooooooooooo00000oooool01Ol0003ooooo
oooooooooooo00000:Wooooo001<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`1hooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo0000Z_ooool004gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
07Wooooo00?o0000ooooool000000oooool01?l0003oooooooooool0002Zooooo`00COooool00ol0
003oooooonKViP05onKViP03o`000?oooooooooo07[ooooo00?o0000onKVi_oVi^H01?oVi^H00ooo
oooo0000ooooo`2Zooooo`00COooool:onKViW[ooooo2_oVi^J[ooooo`00C?ooool<onKViWSooooo
3?oVi^JZooooo`00Boooool>onKViWKooooo3_oVi^JYooooo`00B_ooool5onKViPCo00001ooVi^Id
oooooa3oi^KVZ?ooool004[ooooo2?oVi^H2o`0000Koi^KVM?ooool@onKViZSooooo000<ooooo`Oo
0000=_ooool6onKViPGo00001ooVi^Hfooooo`Go0000=oooool6onKViPOo00001OoVi^Hgooooo`Ko
0000J_ooool000cooooo0_l00002ooooo`;o0000=oooool5onKViP;o00000_oVi^H2o`0000Ooi^KV
=oooool2o`000003ooooool0003o000003Kooooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV
>?ooool2o`000003ooooool0003o000006[ooooo000<ooooo`Ko0000=oooool5onKViP;o00000_oV
i^H2o`0000Ooi^KV=oooool2o`000003ooooool0003o000003Kooooo1ooVi^H2o`000003onKVi_l0
003o000000Koi^KV>Oooool2o`0006cooooo000=ooooo`Co0000>?ooool5onKViP;o00000_oVi^H2
o`0000Ooi^KV=oooool2o`000003ooooool0003o000003Kooooo1ooVi^H2o`000003onKVi_l0003o
000000Koi^KV>_ooool2o`0006_ooooo000=ooooo`Co0000>?ooool6onKViPKo00001_oVi^Hgoooo
o`;o000000?oooooo`000?l00000=_ooool7onKViPCo00001ooVi^Hgooooo`;o00000_ooool2o`00
06[ooooo000>ooooo`;o0000>OoooolBonKViSOooooo0_l000000ooooooo0000o`00000fooooo`Oo
i^KV0_l00009onKViSOooooo0_l00002ooooo`;o0000J_ooool000gooooo0ol00008ooooo`?o0000
;oooool@onKViSOooooo1Ol0000hooooo`Goi^KV0ol00008onKViS3ooooo0ol00006ooooo`Co0000
Joooool001_ooooo0_l0000]oooooa3oi^KVM?ooool@onKViRkooooo0_l0001hooooo`007Oooool3
o`0002_ooooo3_oVi^H00ol0003oooooooooo`1booooo`03o`000?oVi^Koi^KV00coi^KV;?ooool3
o`0007[ooooo000Pooooo`;o0000:_ooool<onKViP;ooooo00?o0000ooooooooool0L?ooool00ol0
003oooooooooo`0<onKViR_ooooo0_l0001mooooo`008_ooool3o`0002Sooooo2_oVi^H4ooooo`03
o`000?oooooooooo06kooooo00?o0000ooooooooool00_ooool:onKViRWooooo0ol0001oooooo`00
9Oooool2o`0002Sooooo1_oVi^H7ooooo`;o0000KOooool00ol0003oooooooooo`05ooooo`Koi^KV
:Oooool2o`0008;ooooo000Wooooo`;o0000=Oooool00ol0003oooooooooo`0cooooo`03o`000?oo
oooooooo03;ooooo0_l0000eooooo`;o0000Q?ooool002Wooooo0ol0000cooooo`03o`000?oooooo
oooo03;ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0booooo`?o0000Q_ooool0
02cooooo0_l0000booooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<?ooool00ol0
003oooooooooo`0aooooo`;o0000ROooool002kooooo0ol0000`ooooo`03o`000?oooooooooo033o
oooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`?o0000Roooool0037ooooo
0_l0000_ooooo`;o0000<?ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo
0_l0002>ooooo`00<oooool2o`0002oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`0/ooooo`;o0000;oooool2o`00093ooooo000eooooo`?o0000;Oooool00ol0003oooooooooo`0/
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?ooool3o`0009;ooooo000hoooo
o`;o0000;?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool0:oooool2o`0009Gooooo000jooooo`?o0000:_ooool2o`0002_ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0Yooooo`?o0000Uoooool003gooooo0_l0000Zooooo`03o`00
0?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`;o0000
V_ooool003oooooo0ol0000Xooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09_oo
ool2o`0002Sooooo0ol0002Looooo`00@_ooool2o`0002Oooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Kooooo0_l0002Oooooo`00A?ooool2o`00
02Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02Gooooo0_l0002Qooooo`00A_ooool3o`0002Cooooo0_l0000Uooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool08oooool3o`000:?ooooo0019ooooo`;o00009?ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool2o`000:Kooooo
001;ooooo`?o00008_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`?o0000Z?ooool004kooooo0_l0000Qooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o0000Zoooool0053ooooo0ol0000Ooooo
o`;o00008?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01kooooo0ol0002]oooo
o`00Doooool2o`0001oooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01gooooo0_l0002`ooooo`00EOooool2o`0001kooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo0_l0002booooo`00Eooo
ool3o`0001cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Jooooo`;o00007?oo
ool3o`000;Cooooo001Jooooo`;o00006oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06_ooool2o`000;Oooooo001Looooo`?o00006Oooool2o`00
01[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`?o0000^Oooool005oo
oooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003o
ooooooooo`0Gooooo`;o0000_?ooool0067ooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`;o0000__ooool006?ooooo0ol0
000Fooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool2o`0001Kooooo0ol0
0030ooooo`00I_ooool2o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo01Cooooo0_l00033ooooo`00J?ooool3o`0001?ooooo0_l0000Doooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool3o`000<Gooooo001[ooooo`;o
00004oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool2o`000<Sooooo001]ooooo`?o00004Oooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool03oooool3o`000<[ooooo001`ooooo`;o00004?oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo0_l0000@ooooo`;o0000cOoo
ool007;ooooo0_l0000?ooooo`;o00003oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00kooooo0_l0003?ooooo`00M?ooool3o`0000kooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0ol0003Aooooo`00Moooool2o`0000go
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo0_l0003Dooooo`00NOooool3o`0000_ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo0ol0003Fooooo`00O?ooool2o`0000[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`;o00002_ooool2o`000=Wooooo001n
ooooo`;o00002Oooool2o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08
ooooo`;o0000foooool0083ooooo0ol00008ooooo`03o`000?oooooooooo00?ooooo1_oVi^H6oooo
o`03o`000?oooooooooo00Kooooo0ol0003Mooooo`00Poooool2o`0000Oooooo00?o0000oooooooo
ool02_oVi^H3ooooo`03o`000?oooooooooo00Gooooo0_l0003Pooooo`00QOooool3o`0000Gooooo
00?o0000onKVi_oVi^H02_oVi^H00ooooooo0000ooooo`04ooooo`?o0000h_ooool008Sooooo0_l0
0003ooooo`koi^KV1?ooool2o`000>Gooooo002:ooooo`;o00004?oVi^H3o`000>Oooooo002<oooo
oa3oi^KVj_ooool008_ooooo1_oVi^H6o`0000Koi^KVjOooool008_ooooo2?oVi^H2o`0000Soi^KV
jOooool008_ooooo2?oVi^H2o`0000Soi^KVjOooool008_ooooo2?oVi^H2o`0000Soi^KVjOooool0
08_ooooo1ooVi^H5o`0000Koi^KVjOooool008_ooooo2?oVi^H2o`0000Soi^KVjOooool008cooooo
2?oVi^H3o`0000Goi^KVj_ooool008cooooo4?oVi^KZooooo`00SOooool>onKVi^_ooooo002>oooo
o`coi^KVk?ooool008oooooo2_oVi^K]ooooo`00TOooool6onKVi^oooooo0000\
\>"],
  ImageRangeCache->{{{0, 389.812}, {240.5, 0}} -> {-2.23445, -0.833976, \
0.0150557, 0.00360898}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of inverted mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
invChromos = Join @@ Table[
Inversion[theChromos, 
  Templates -> {{{_f}, 2},
                {{_h}, 2},
                {{g[x__]/; Length[{x}] > 1}, 1}
               },
  
  SelectionMode -> RANDOM], {10}]

invChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[g[B, g[4], 3], A, D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[g[B, g[4], 3], A, D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], g[g[A, B]], B, D], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B, A]]], 2]]], 
      chromo[q[undef], 
        p[f[D, g[B, g[4], 3], A, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], B, D, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[g[B, g[4], 3], D, A, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[D, \[ExponentialE], B, g[g[A, B]]], 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], 
              p[f[g[B, g[4], 3], A, D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[g[B, g[4], 3], A, D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], g[g[A, B]], B, D], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[B, A]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[D, g[B, g[4], 3], A, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], B, D, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[g[B, g[4], 3], D, A, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[D, \[ExponentialE], B, g[g[A, B]]], 
                  2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 
                g[ B, 
                  g[ 4], 3], A, D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 
                g[ B, 
                  g[ 4], 3], A, D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, 
                  g[ 
                    g[ A, B]], B, D], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ B, A]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ D, 
                g[ B, 
                  g[ 4], 3], A, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, B, D, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ 
                g[ B, 
                  g[ 4], 3], D, A, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ D, E, B, 
                  g[ 
                    g[ A, B]]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection"],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, LabelSize -> .04]& /@ \
invChromos;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.526165 0.219378 0.603319 0.735755 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.08741 .30902 -5 -6 ]
[.08741 .30902 5 6 ]
[.08741 .16187 -5 -6 ]
[.08741 .16187 5 6 ]
[.15101 .30902 -5 -6 ]
[.15101 .30902 5 6 ]
[.08741 .45617 -5 -6 ]
[.08741 .45617 5 6 ]
[.30679 .45617 -5.0625 -6 ]
[.30679 .45617 5.0625 6 ]
[.52616 .45617 -5 -6 ]
[.52616 .45617 5 6 ]
[.68194 .30902 -5 -6 ]
[.68194 .30902 5 6 ]
[.72434 .30902 -5 -6 ]
[.72434 .30902 5 6 ]
[.76674 .30902 -5 -6 ]
[.76674 .30902 5 6 ]
[.80914 .30902 -5 -6 ]
[.80914 .30902 5 6 ]
[.6421 .01472 -5.0625 -6 ]
[.6421 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80914 .16187 -5 -6 ]
[.80914 .16187 5 6 ]
[.74554 .45617 -5 -6 ]
[.74554 .45617 5 6 ]
[.96492 .45617 -5 -6 ]
[.96492 .45617 5 6 ]
[.52616 .60332 -5 -6 ]
[.52616 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.52616 .60332 m
.08741 .45617 L
s
.52616 .60332 m
.30679 .45617 L
s
.52616 .60332 m
.52616 .45617 L
s
.52616 .60332 m
.74554 .45617 L
s
.52616 .60332 m
.96492 .45617 L
s
.08741 .45617 m
.02381 .30902 L
s
.08741 .45617 m
.08741 .30902 L
s
.08741 .45617 m
.15101 .30902 L
s
1 g
.04 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.08741 .30902 m
.08741 .16187 L
s
.9 g
.04 w
.08741 .30902 Mdot
0 g
gsave
.08741 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.08741 .16187 Mdot
0 g
gsave
.08741 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.15101 .30902 Mdot
0 g
gsave
.15101 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.08741 .45617 Mdot
0 g
gsave
.08741 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.30679 .45617 Mdot
0 g
gsave
.30679 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.52616 .45617 Mdot
0 g
gsave
.52616 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.74554 .45617 m
.68194 .30902 L
s
.74554 .45617 m
.72434 .30902 L
s
.74554 .45617 m
.76674 .30902 L
s
.74554 .45617 m
.80914 .30902 L
s
1 g
.04 w
.68194 .30902 Mdot
0 g
gsave
.68194 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.72434 .30902 Mdot
0 g
gsave
.72434 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.76674 .30902 Mdot
0 g
gsave
.76674 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .30902 m
.80914 .16187 L
s
.9 g
.04 w
.80914 .30902 Mdot
0 g
gsave
.80914 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .16187 m
.6421 .01472 L
s
.80914 .16187 m
.97619 .01472 L
s
1 g
.04 w
.6421 .01472 Mdot
0 g
gsave
.6421 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.80914 .16187 Mdot
0 g
gsave
.80914 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.74554 .45617 Mdot
0 g
gsave
.74554 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96492 .45617 Mdot
0 g
gsave
.96492 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.52616 .60332 Mdot
0 g
gsave
.52616 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Oooooo1ol00017ooooo`Go00002_ooool009Oooooo0_l00002
ooooo`;o0000BOooool2o`000003ooooool0003o000000Wooooo002Gooooo`Ko0000BOooool2o`00
0003ooooool0003o000000Wooooo002Hooooo`Co0000B_ooool4o`0000[ooooo002Hooooo`Co0000
B_ooool2o`000003ooooool0003o000000Wooooo002Iooooo`;o00000oooool00ol0003ooooooooo
o`13ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00V?ooool3o`0000Cooooo00?o
0000ooooooooool0@Oooool00ol0003oooooo`000004o`0000[ooooo002Pooooo`03o`000?oooooo
oooo03oooooo00?o0000ooooooooool03oooool00:7ooooo00?o0000ooooooooool0?Oooool00ol0
003oooooooooo`0@ooooo`00X_ooool2o`0003_ooooo0_l0000Cooooo`00Y?ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo01?ooooo002Uooooo`03o`000?oooooooooo03Gooooo00?o
0000ooooooooool05?ooool00:Kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0E
ooooo`00Yoooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Kooooo002Xooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool05oooool00:Wooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0Hooooo`00Z_ooool2o`0002_ooooo0_l0000Kooooo`00[?ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01_ooooo002]ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool07?ooool00:kooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Mooooo`00[oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01kooooo
002`ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00;7ooooo0_l0000M
ooooo`;o00008_ooool00;?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Roooo
o`00]?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02?ooooo002eooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool09?ooool00;Kooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Uooooo`00]oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo02Kooooo002hooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool09oooool00;Wo
oooo0_l0000=ooooo`;o0000:_ooool00;_ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Zooooo`00_?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02_ooooo002m
ooooo`03o`000?oooooo000000?o000000?oi^KVooooool00000;_ooool00;kooooo1?oVi^H2o`00
0003onKVi_oooooooooo02gooooo000Hooooo`Co0000XOooool2onKViPGo00000_oVi^H^ooooo`00
6Oooool2o`000:;ooooo00?oi^KVo`000?l000000_oVi^H2o`0000;oi^KV;_ooool001Kooooo1_l0
002Qooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo000Fooooo`;o000000?ooooo
o`000?l00000X_ooool00ooVi^Ko0000o`000002onKViP;o00000_oVi^H^ooooo`005oooool4o`00
0:;ooooo0_oVi^H6o`000003onKVi_oooooooooo02cooooo000Hooooo`?o0000Xoooool7onKViRoo
oooo000Iooooo`;o0000Y?ooool5onKViS3ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o
0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`
ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03
o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0
Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oo
oooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool0
01Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooooooo
o`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hoooo
o`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooooooo
ool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`00
0?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?oo
ool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0
003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Ko
oooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000H
ooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooo
ooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03
o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0
<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`005_ooool0
0ooVi^Ko0000o`000002o`000:Cooooo1?l000000ooVi^Koooooooooo`0^ooooo`005Oooool5onKV
iP;o0000X_ooool4onKViP;o000000?oi^KVooooooooool0;Oooool000Oooooo1Ol00008ooooo`?o
i^KV1Ol000000ooVi^Koooooooooo`06ooooo`Co0000NOooool4o`0000Gooooo1Ol00004ooooo`Go
00001?ooool2onKViPGo00000_oVi^H^ooooo`002?ooool2o`000003ooooool0003o000000Oooooo
0_oVi^H2o`0000;oi^KV0_l000000ooVi^Koooooooooo`05ooooo`;o00000_ooool2o`0007Oooooo
00?o0000ooooool000002?ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000
o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?o
ooooo`000?l000001oooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Wooooo0_l0
001gooooo`03o`000?oooooo000000;o00001_ooool2o`000003ooooool0003o000000Cooooo0_l0
00000ooooooo0000o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008
ooooo`Co00002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo0ol0001h
ooooo`05o`000?oooooo0000ooooool000001_ooool2o`000003ooooool0003o000000Cooooo1?l0
0004ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?ooooo
o`000?l000001oooool3onKViPKo00002oooool2o`0007Sooooo0ol00007ooooo`;o000000?ooooo
o`000?l000001?ooool2o`000003ooooool0003o000000?ooooo0_oVi^H6o`000003onKVi_oooooo
oooo02cooooo0008ooooo`;o000000?oooooo`000?l000002?ooool7onKViPSooooo0_l00002oooo
o`;o0000P_ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000o`000004oooo
o`Ooi^KV;oooool000Oooooo1Ol0000:ooooo`Goi^KV2_ooool4o`0008;ooooo1Ol00004ooooo`Go
00001_ooool5onKViS3ooooo000<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03;ooooo000<ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1nooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo03;ooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`20ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03?ooooo000=ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03?ooooo000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`22ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03Cooooo000>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Cooooo
000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`23ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo03Gooooo000?ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Gooooo000?oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`25oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Kooooo000@ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`26ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Oooooo000Aooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`28ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo03Oooooo000Aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`2:ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Booooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2<ooooo`05o`000?oo
ooooooooooooool000000_ooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2=ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool0000looooo`005?ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool0S_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003cooooo000Dooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`2?ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003o
ooooooooo`0kooooo`005Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo093o
oooo00Go0000ooooool0003oooooo`000002ooooo`03o`000?oooooooooo03_ooooo000Eooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0TOooool01ol0003oooooo`000?oooooo
0000ooooool00000?_ooool001Gooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`2Aooooo`07o`000?oooooo0000ooooool0003oooooo`00000nooooo`005_ooool01Ol0003ooooo
o`000?oooooo000009Gooooo0_l000000ooooooo0000o`00000oooooo`005_ooool00ooVi^Ko0000
o`000002o`0009Gooooo1OoVi^Hoooooo`005Oooool5onKViP;o0000Toooool7onKViSkooooo000D
ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Zooooo`Oo0000;?ooool5o`0002gooooo00?oi^KV
o`000?l000001Ol000000ooVi^Koooooooooo`0Zooooo`Ko00002oooool001Cooooo0_oVi^H2o`00
00;oi^KV0_l000000ooVi^Koooooooooo`0Zooooo`;o00000_ooool2o`0002kooooo0_l000000ooo
oooo0000o`00000/ooooo`;oi^KV0_l000000ooVi^Ko0000o`000002onKViRgooooo0_l000000ooo
oooo0000o`00000;ooooo`005?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo02[o
oooo1_l0000^ooooo`;o000000?oooooo`000?l00000;?ooool2onKViP;o000000?oi^KVo`000?l0
00000_oVi^H^ooooo`;o00003Oooool001Cooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000
ooooo`0[ooooo`Co0000;oooool2o`000003ooooool0003o000002cooooo0_oVi^H2o`000003onKV
i_l0003o000000;oi^KV:_ooool00ol0003oooooooooo`02ooooo`;o00003?ooool001Cooooo0ooV
i^H6o`000004ooooool0003o0000o`0002Wooooo1?l0000_ooooo`;o000000?oooooo`000?l00000
;?ooool2onKViPCo00000ooVi^HWooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`005Ooo
ool7onKViPGooooo0ol0000Wooooo`;o00001?ooool00ol0003oooooooooo`0Yooooo`;o000000?o
ooooo`000?l00000:oooool00ol0003oooooonKViP02o`0000Coi^KV9Oooool3o`0000Gooooo0_l0
0002ooooo`;o00002oooool001Kooooo1OoVi^H9ooooo`?o00008oooool3o`0000Gooooo0_l0000X
ooooo`Go0000:_ooool2o`0000;ooooo0ol00003onKViR?ooooo0ol00009ooooo`Co00003?ooool0
02Oooooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`?o00007?ooool002[ooooo0ol0000Xooooo`;o0000:?ooool00ol0003o
ooooooooo`0Vooooo`;o0000:?ooool3o`0001oooooo000]ooooo`?o00009oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool3o`0002;ooooo
000`ooooo`?o00009Oooool2o`0002Gooooo00?o0000ooooooooool08oooool2o`0002Gooooo0ol0
000Uooooo`00<oooool3o`0002Cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo02;ooooo0ol0000Xooooo`00=_ooool3o`0002;ooooo0_l0000Roooo
o`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o0000:oooool003Wooooo0ol0000Qooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`?o
0000;_ooool003cooooo0ol0000Oooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`;o0000
7oooool3o`00037ooooo000oooooo`?o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool07?ooool3o`0003Cooooo0012ooooo`?o00007?ooool2
o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo0ol0000gooooo`00AOooool3o`00
01_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01Wooooo0ol0000jooooo`00B?ooool3o`0001Wooooo0_l0000Iooooo`03o`000?oooooooooo01Oo
oooo0_l0000Iooooo`?o0000?Oooool004_ooooo0ol0000Hooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`?o0000@?ooool004kooooo0ol0
000Fooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`;o00005_ooool3o`0004?ooooo001A
ooooo`?o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04oooool3o`0004Kooooo001Dooooo`?o00004oooool2o`0001?ooooo00?o0000oooo
ooooool04Oooool2o`0001?ooooo0ol00019ooooo`00Eoooool3o`0001;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo0ol0001<ooooo`00
F_ooool3o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0000@ooooo`?o0000
Coooool005gooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`?o0000D_ooool0063ooooo0ol0000=ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool3o`0005Gooooo001Sooooo`?o00003?ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool3o`00
05Sooooo001Vooooo`?o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[o
oooo0ol0001Kooooo`00JOooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo0ol0001Nooooo`00K?ooool3o`0000Oooooo0_l0
0007ooooo`03o`000?oooooooooo00Gooooo0_l00007ooooo`?o0000HOooool006oooooo0ol00006
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`?o0000I?ooool007;ooooo0ol00004ooooo`;o00001?ooool00ol0003oooooooooo`02oooo
o`;o00001?ooool3o`0006Oooooo001eooooo`?o00000oooool00ol0003oooooonKViP04onKViP03
ooooool0003ooooo00;ooooo0ol0001Zooooo`00N?ooool3o`000003ooooool0003o000000Co0000
00?oi^KVooooool000000_l0001]ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool3
onKViP;o00001?oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool2onKViPGo
00000_oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00O?ooool3onKViP?o000000?o
i^KVooooooooool0Koooool007gooooo1OoVi^Ibooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.48582, -0.834843, \
0.0194778, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.526165 0.219378 0.603319 0.735755 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.08741 .30902 -5 -6 ]
[.08741 .30902 5 6 ]
[.08741 .16187 -5 -6 ]
[.08741 .16187 5 6 ]
[.15101 .30902 -5 -6 ]
[.15101 .30902 5 6 ]
[.08741 .45617 -5 -6 ]
[.08741 .45617 5 6 ]
[.30679 .45617 -5.0625 -6 ]
[.30679 .45617 5.0625 6 ]
[.52616 .45617 -5 -6 ]
[.52616 .45617 5 6 ]
[.68194 .30902 -5 -6 ]
[.68194 .30902 5 6 ]
[.72434 .30902 -5 -6 ]
[.72434 .30902 5 6 ]
[.76674 .30902 -5 -6 ]
[.76674 .30902 5 6 ]
[.80914 .30902 -5 -6 ]
[.80914 .30902 5 6 ]
[.6421 .01472 -5.0625 -6 ]
[.6421 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80914 .16187 -5 -6 ]
[.80914 .16187 5 6 ]
[.74554 .45617 -5 -6 ]
[.74554 .45617 5 6 ]
[.96492 .45617 -5 -6 ]
[.96492 .45617 5 6 ]
[.52616 .60332 -5 -6 ]
[.52616 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.52616 .60332 m
.08741 .45617 L
s
.52616 .60332 m
.30679 .45617 L
s
.52616 .60332 m
.52616 .45617 L
s
.52616 .60332 m
.74554 .45617 L
s
.52616 .60332 m
.96492 .45617 L
s
.08741 .45617 m
.02381 .30902 L
s
.08741 .45617 m
.08741 .30902 L
s
.08741 .45617 m
.15101 .30902 L
s
1 g
.04 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.08741 .30902 m
.08741 .16187 L
s
.9 g
.04 w
.08741 .30902 Mdot
0 g
gsave
.08741 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.08741 .16187 Mdot
0 g
gsave
.08741 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.15101 .30902 Mdot
0 g
gsave
.15101 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.08741 .45617 Mdot
0 g
gsave
.08741 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.30679 .45617 Mdot
0 g
gsave
.30679 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.52616 .45617 Mdot
0 g
gsave
.52616 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.74554 .45617 m
.68194 .30902 L
s
.74554 .45617 m
.72434 .30902 L
s
.74554 .45617 m
.76674 .30902 L
s
.74554 .45617 m
.80914 .30902 L
s
1 g
.04 w
.68194 .30902 Mdot
0 g
gsave
.68194 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.72434 .30902 Mdot
0 g
gsave
.72434 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.76674 .30902 Mdot
0 g
gsave
.76674 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .30902 m
.80914 .16187 L
s
.9 g
.04 w
.80914 .30902 Mdot
0 g
gsave
.80914 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .16187 m
.6421 .01472 L
s
.80914 .16187 m
.97619 .01472 L
s
1 g
.04 w
.6421 .01472 Mdot
0 g
gsave
.6421 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.80914 .16187 Mdot
0 g
gsave
.80914 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.74554 .45617 Mdot
0 g
gsave
.74554 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96492 .45617 Mdot
0 g
gsave
.96492 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.52616 .60332 Mdot
0 g
gsave
.52616 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Oooooo1ol00017ooooo`Go00002_ooool009Oooooo0_l00002
ooooo`;o0000BOooool2o`000003ooooool0003o000000Wooooo002Gooooo`Ko0000BOooool2o`00
0003ooooool0003o000000Wooooo002Hooooo`Co0000B_ooool4o`0000[ooooo002Hooooo`Co0000
B_ooool2o`000003ooooool0003o000000Wooooo002Iooooo`;o00000oooool00ol0003ooooooooo
o`13ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00V?ooool3o`0000Cooooo00?o
0000ooooooooool0@Oooool00ol0003oooooo`000004o`0000[ooooo002Pooooo`03o`000?oooooo
oooo03oooooo00?o0000ooooooooool03oooool00:7ooooo00?o0000ooooooooool0?Oooool00ol0
003oooooooooo`0@ooooo`00X_ooool2o`0003_ooooo0_l0000Cooooo`00Y?ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo01?ooooo002Uooooo`03o`000?oooooooooo03Gooooo00?o
0000ooooooooool05?ooool00:Kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0E
ooooo`00Yoooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Kooooo002Xooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool05oooool00:Wooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0Hooooo`00Z_ooool2o`0002_ooooo0_l0000Kooooo`00[?ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01_ooooo002]ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool07?ooool00:kooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Mooooo`00[oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01kooooo
002`ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00;7ooooo0_l0000M
ooooo`;o00008_ooool00;?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Roooo
o`00]?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02?ooooo002eooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool09?ooool00;Kooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Uooooo`00]oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo02Kooooo002hooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool09oooool00;Wo
oooo0_l0000=ooooo`;o0000:_ooool00;_ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Zooooo`00_?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02_ooooo002m
ooooo`03o`000?oooooo000000?o000000?oi^KVooooool00000;_ooool00;kooooo1?oVi^H2o`00
0003onKVi_oooooooooo02gooooo000Hooooo`Co0000XOooool2onKViPGo00000_oVi^H^ooooo`00
6Oooool2o`000:;ooooo00?oi^KVo`000?l000000_oVi^H2o`0000;oi^KV;_ooool001Kooooo1_l0
002Qooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo000Fooooo`;o000000?ooooo
o`000?l00000X_ooool00ooVi^Ko0000o`000002onKViP;o00000_oVi^H^ooooo`005oooool4o`00
0:;ooooo0_oVi^H6o`000003onKVi_oooooooooo02cooooo000Hooooo`?o0000Xoooool7onKViRoo
oooo000Iooooo`;o0000Y?ooool5onKViS3ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o
0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`
ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03
o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0
Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oo
oooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool0
01Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooooooo
o`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hoooo
o`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooooooo
ool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`00
0?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?oo
ool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0
003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Ko
oooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000H
ooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooo
ooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03
o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0
<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`005_ooool0
0ooVi^Ko0000o`000002o`000:Cooooo1?l000000ooVi^Koooooooooo`0^ooooo`005Oooool5onKV
iP;o0000X_ooool4onKViP;o000000?oi^KVooooooooool0;Oooool000Oooooo1Ol00008ooooo`?o
i^KV1Ol000000ooVi^Koooooooooo`06ooooo`Co0000NOooool4o`0000Gooooo1Ol00004ooooo`Go
00001?ooool2onKViPGo00000_oVi^H^ooooo`002?ooool2o`000003ooooool0003o000000Oooooo
0_oVi^H2o`0000;oi^KV0_l000000ooVi^Koooooooooo`05ooooo`;o00000_ooool2o`0007Oooooo
00?o0000ooooool000002?ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000
o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?o
ooooo`000?l000001oooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Wooooo0_l0
001gooooo`03o`000?oooooo000000;o00001_ooool2o`000003ooooool0003o000000Cooooo0_l0
00000ooooooo0000o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008
ooooo`Co00002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo0ol0001h
ooooo`05o`000?oooooo0000ooooool000001_ooool2o`000003ooooool0003o000000Cooooo1?l0
0004ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?ooooo
o`000?l000001oooool3onKViPKo00002oooool2o`0007Sooooo0ol00007ooooo`;o000000?ooooo
o`000?l000001?ooool2o`000003ooooool0003o000000?ooooo0_oVi^H6o`000003onKVi_oooooo
oooo02cooooo0008ooooo`;o000000?oooooo`000?l000002?ooool7onKViPSooooo0_l00002oooo
o`;o0000P_ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000o`000004oooo
o`Ooi^KV;oooool000Oooooo1Ol0000:ooooo`Goi^KV2_ooool4o`0008;ooooo1Ol00004ooooo`Go
00001_ooool5onKViS3ooooo000<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03;ooooo000<ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1nooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo03;ooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`20ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03?ooooo000=ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03?ooooo000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`22ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03Cooooo000>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Cooooo
000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`23ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo03Gooooo000?ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Gooooo000?oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`25oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Kooooo000@ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`26ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Oooooo000Aooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`28ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo03Oooooo000Aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`2:ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Booooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2<ooooo`05o`000?oo
ooooooooooooool000000_ooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2=ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool0000looooo`005?ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool0S_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003cooooo000Dooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`2?ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003o
ooooooooo`0kooooo`005Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo093o
oooo00Go0000ooooool0003oooooo`000002ooooo`03o`000?oooooooooo03_ooooo000Eooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0TOooool01ol0003oooooo`000?oooooo
0000ooooool00000?_ooool001Gooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`2Aooooo`07o`000?oooooo0000ooooool0003oooooo`00000nooooo`005_ooool01Ol0003ooooo
o`000?oooooo000009Gooooo0_l000000ooooooo0000o`00000oooooo`005_ooool00ooVi^Ko0000
o`000002o`0009Gooooo1OoVi^Hoooooo`005Oooool5onKViP;o0000Toooool7onKViSkooooo000D
ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Zooooo`Oo0000;?ooool5o`0002gooooo00?oi^KV
o`000?l000001Ol000000ooVi^Koooooooooo`0Zooooo`Ko00002oooool001Cooooo0_oVi^H2o`00
00;oi^KV0_l000000ooVi^Koooooooooo`0Zooooo`;o00000_ooool2o`0002kooooo0_l000000ooo
oooo0000o`00000/ooooo`;oi^KV0_l000000ooVi^Ko0000o`000002onKViRgooooo0_l000000ooo
oooo0000o`00000;ooooo`005?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo02[o
oooo1_l0000^ooooo`;o000000?oooooo`000?l00000;?ooool2onKViP;o000000?oi^KVo`000?l0
00000_oVi^H^ooooo`;o00003Oooool001Cooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000
ooooo`0[ooooo`Co0000;oooool2o`000003ooooool0003o000002cooooo0_oVi^H2o`000003onKV
i_l0003o000000;oi^KV:_ooool00ol0003oooooooooo`02ooooo`;o00003?ooool001Cooooo0ooV
i^H6o`000004ooooool0003o0000o`0002Wooooo1?l0000_ooooo`;o000000?oooooo`000?l00000
;?ooool2onKViPCo00000ooVi^HWooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`005Ooo
ool7onKViPGooooo0ol0000Wooooo`;o00001?ooool00ol0003oooooooooo`0Yooooo`;o000000?o
ooooo`000?l00000:oooool00ol0003oooooonKViP02o`0000Coi^KV9Oooool3o`0000Gooooo0_l0
0002ooooo`;o00002oooool001Kooooo1OoVi^H9ooooo`?o00008oooool3o`0000Gooooo0_l0000X
ooooo`Go0000:_ooool2o`0000;ooooo0ol00003onKViR?ooooo0ol00009ooooo`Co00003?ooool0
02Oooooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`?o00007?ooool002[ooooo0ol0000Xooooo`;o0000:?ooool00ol0003o
ooooooooo`0Vooooo`;o0000:?ooool3o`0001oooooo000]ooooo`?o00009oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool3o`0002;ooooo
000`ooooo`?o00009Oooool2o`0002Gooooo00?o0000ooooooooool08oooool2o`0002Gooooo0ol0
000Uooooo`00<oooool3o`0002Cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo02;ooooo0ol0000Xooooo`00=_ooool3o`0002;ooooo0_l0000Roooo
o`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o0000:oooool003Wooooo0ol0000Qooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`?o
0000;_ooool003cooooo0ol0000Oooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`;o0000
7oooool3o`00037ooooo000oooooo`?o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool07?ooool3o`0003Cooooo0012ooooo`?o00007?ooool2
o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo0ol0000gooooo`00AOooool3o`00
01_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01Wooooo0ol0000jooooo`00B?ooool3o`0001Wooooo0_l0000Iooooo`03o`000?oooooooooo01Oo
oooo0_l0000Iooooo`?o0000?Oooool004_ooooo0ol0000Hooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`?o0000@?ooool004kooooo0ol0
000Fooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`;o00005_ooool3o`0004?ooooo001A
ooooo`?o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04oooool3o`0004Kooooo001Dooooo`?o00004oooool2o`0001?ooooo00?o0000oooo
ooooool04Oooool2o`0001?ooooo0ol00019ooooo`00Eoooool3o`0001;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo0ol0001<ooooo`00
F_ooool3o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0000@ooooo`?o0000
Coooool005gooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`?o0000D_ooool0063ooooo0ol0000=ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool3o`0005Gooooo001Sooooo`?o00003?ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool3o`00
05Sooooo001Vooooo`?o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[o
oooo0ol0001Kooooo`00JOooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo0ol0001Nooooo`00K?ooool3o`0000Oooooo0_l0
0007ooooo`03o`000?oooooooooo00Gooooo0_l00007ooooo`?o0000HOooool006oooooo0ol00006
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`?o0000I?ooool007;ooooo0ol00004ooooo`;o00001?ooool00ol0003oooooooooo`02oooo
o`;o00001?ooool3o`0006Oooooo001eooooo`?o00000oooool00ol0003oooooonKViP04onKViP03
ooooool0003ooooo00;ooooo0ol0001Zooooo`00N?ooool3o`000003ooooool0003o000000Co0000
00?oi^KVooooool000000_l0001]ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool3
onKViP;o00001?oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool2onKViPGo
00000_oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00O?ooool3onKViP?o000000?o
i^KVooooooooool0Koooool007gooooo1OoVi^Ibooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.48582, -0.834843, \
0.0194778, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19288 .30902 -5 -6 ]
[.19288 .30902 5 6 ]
[.2619 .30902 -5 -6 ]
[.2619 .30902 5 6 ]
[.2619 .16187 -5 -6 ]
[.2619 .16187 5 6 ]
[.33093 .30902 -5 -6 ]
[.33093 .30902 5 6 ]
[.2619 .45617 -5 -6 ]
[.2619 .45617 5 6 ]
[.5 .45617 -5 -6 ]
[.5 .45617 5 6 ]
[.66907 .30902 -5 -6 ]
[.66907 .30902 5 6 ]
[.71509 .30902 -5 -6 ]
[.71509 .30902 5 6 ]
[.53379 .01472 -5.0625 -6 ]
[.53379 .01472 5.0625 6 ]
[.89639 .01472 -5 -6 ]
[.89639 .01472 5 6 ]
[.71509 .16187 -5 -6 ]
[.71509 .16187 5 6 ]
[.7611 .30902 -5 -6 ]
[.7611 .30902 5 6 ]
[.80712 .30902 -5 -6 ]
[.80712 .30902 5 6 ]
[.7381 .45617 -5 -6 ]
[.7381 .45617 5 6 ]
[.97619 .45617 -5 -6 ]
[.97619 .45617 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .45617 L
s
.5 .60332 m
.2619 .45617 L
s
.5 .60332 m
.5 .45617 L
s
.5 .60332 m
.7381 .45617 L
s
.5 .60332 m
.97619 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .45617 m
.19288 .30902 L
s
.2619 .45617 m
.2619 .30902 L
s
.2619 .45617 m
.33093 .30902 L
s
1 g
.04 w
.19288 .30902 Mdot
0 g
gsave
.19288 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .30902 m
.2619 .16187 L
s
.9 g
.04 w
.2619 .30902 Mdot
0 g
gsave
.2619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.2619 .16187 Mdot
0 g
gsave
.2619 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.33093 .30902 Mdot
0 g
gsave
.33093 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.2619 .45617 Mdot
0 g
gsave
.2619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .45617 Mdot
0 g
gsave
.5 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .45617 m
.66907 .30902 L
s
.7381 .45617 m
.71509 .30902 L
s
.7381 .45617 m
.7611 .30902 L
s
.7381 .45617 m
.80712 .30902 L
s
1 g
.04 w
.66907 .30902 Mdot
0 g
gsave
.66907 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
.5 Mabswid
.71509 .30902 m
.71509 .16187 L
s
.9 g
.04 w
.71509 .30902 Mdot
0 g
gsave
.71509 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.71509 .16187 m
.53379 .01472 L
s
.71509 .16187 m
.89639 .01472 L
s
1 g
.04 w
.53379 .01472 Mdot
0 g
gsave
.53379 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.89639 .01472 Mdot
0 g
gsave
.89639 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.71509 .16187 Mdot
0 g
gsave
.71509 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.7611 .30902 Mdot
0 g
gsave
.7611 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.80712 .30902 Mdot
0 g
gsave
.80712 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.9 g
.7381 .45617 Mdot
0 g
gsave
.7381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .45617 Mdot
0 g
gsave
.97619 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool007kooooo1ol0001>ooooo`Go00007?ooool007kooooo0_l00002
ooooo`;o0000D?ooool2o`000003ooooool0003o000001_ooooo001nooooo`Ko0000D?ooool2o`00
0003ooooool0003o000001_ooooo001oooooo`Co0000DOooool4o`0001cooooo001oooooo`Co0000
DOooool2o`000003ooooool0003o000001_ooooo0020ooooo`;o00000oooool00ol0003ooooooooo
o`1:ooooo`05o`000?oooooo0000o`000?ooool00_l0000Kooooo`00Ooooool3o`0000Cooooo0_l0
0018ooooo`;o000000?oooooo`000?l000000ol0000Looooo`00R?ooool00ol0003oooooooooo`14
ooooo`03o`000?oooooooooo02;ooooo0029ooooo`03o`000?oooooooooo04;ooooo00?o0000oooo
ooooool08oooool008[ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`0Tooooo`00
Roooool2o`0003kooooo0_l0000Wooooo`00SOooool00ol0003oooooooooo`0jooooo`03o`000?oo
oooooooo02Oooooo002>ooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0:?ooool0
08oooooo00?o0000ooooooooool0=Oooool2o`0002_ooooo002@ooooo`03o`000?oooooooooo03?o
oooo00?o0000ooooooooool0:oooool0097ooooo0_l0000booooo`03o`000?oooooooooo02cooooo
002Cooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool009Cooooo00?o0000
ooooooooool0:oooool2o`00033ooooo002Eooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0<?ooool009Kooooo0_l0000Xooooo`03o`000?oooooooooo037ooooo002Hooooo`03o`00
0?oooooooooo02Cooooo00?o0000ooooooooool0<_ooool009Wooooo00?o0000ooooooooool08Ooo
ool2o`0003Gooooo002Jooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0=Oooool0
09_ooooo0_l0000Nooooo`03o`000?oooooooooo03Kooooo002Mooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool0=oooool009kooooo00?o0000ooooooooool05oooool2o`0003[ooooo
002Oooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0>_ooool00:3ooooo0_l0000D
ooooo`03o`000?oooooooooo03_ooooo002Rooooo`03o`000?oooooooooo00oooooo0_l0000noooo
o`00Xoooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo03kooooo002Tooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0?oooool00:Gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`10ooooo`00Y_ooool2o`000003ooooool0003o000000;o000000Coi^KV
ooooool0003o0000@oooool00:Sooooo1?oVi^H2o`000003onKVi_oooooooooo04?ooooo0010oooo
o`Co0000Hoooool2onKViPGo00000_oVi^I4ooooo`00@Oooool2o`0006Cooooo00?oi^KVo`000?l0
00000_oVi^H2o`0000;oi^KVA?ooool003kooooo1_l0001Sooooo`03onKVi_l0003o000000;oi^KV
0_l00002onKViTCooooo000nooooo`;o000000?oooooo`000?l00000I?ooool00ooVi^Ko0000o`00
0002onKViP;o00000_oVi^I4ooooo`00?oooool4o`0006Cooooo0_oVi^H6o`000003onKVi_oooooo
oooo04;ooooo0010ooooo`?o0000IOooool7onKViTGooooo0011ooooo`;o0000I_ooool5onKViTKo
oooo0011ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0A_ooool0047ooooo00?o
0000ooooooooool0Ioooool00ol0003oooooooooo`16ooooo`00@Oooool00ol0003oooooooooo`1W
ooooo`03o`000?oooooooooo04Kooooo0011ooooo`03o`000?oooooooooo06Oooooo00?o0000oooo
ooooool0A_ooool0047ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`16ooooo`00
@Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo04Kooooo0011ooooo`03o`000?oo
oooooooo06Oooooo00?o0000ooooooooool0A_ooool0047ooooo00?o0000ooooooooool0Ioooool0
0ol0003oooooooooo`16ooooo`00@Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo
04Kooooo0011ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0A_ooool0047ooooo
00?o0000ooooooooool0Ioooool00ol0003oooooooooo`16ooooo`00@Oooool00ol0003ooooooooo
o`1Wooooo`03o`000?oooooooooo04Kooooo0011ooooo`03o`000?oooooooooo06Oooooo00?o0000
ooooooooool0A_ooool0047ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`16oooo
o`00@Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo04Kooooo0011ooooo`03o`00
0?oooooooooo06Oooooo00?o0000ooooooooool0A_ooool0047ooooo00?o0000ooooooooool0Iooo
ool00ol0003oooooooooo`16ooooo`00@Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooo
oooo04Kooooo0011ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool0A_ooool0047o
oooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`16ooooo`00@Oooool00ol0003ooooo
ooooo`1Wooooo`03o`000?oooooooooo04Kooooo0011ooooo`03o`000?oooooooooo06Oooooo00?o
0000ooooooooool0A_ooool0047ooooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`16
ooooo`00@Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo04Kooooo0011ooooo`03
o`000?oooooooooo06Oooooo00?o0000ooooooooool0A_ooool0047ooooo00?o0000ooooooooool0
Ioooool00ol0003oooooooooo`16ooooo`00?oooool4o`000003onKVi_oooooooooo06?ooooo1?l0
00000ooVi^Koooooooooo`14ooooo`00?_ooool4onKViP;o000000?oi^KVooooooooool0HOooool4
onKViP;o000000?oi^KVooooooooool0@oooool002kooooo1Ol0000:ooooo`;oi^KV1Ol00002onKV
iPWooooo1?l0001<ooooo`Co00001?ooool2onKViPGo00000_oVi^H3ooooo`Go00001_ooool5o`00
037ooooo000_ooooo`;o000000?oooooo`000?l000002Oooool00ooVi^Ko0000o`000002onKViP;o
00000_oVi^H8ooooo`;o00000_ooool2o`0004[ooooo00?o0000ooooool000001_ooool00ooVi^Ko
0000o`000002onKViP;o00000_oVi^H4ooooo`;o000000?oooooo`000?l000001_ooool2o`000003
ooooool0003o0000033ooooo000_ooooo`;o000000?oooooo`000?l000002Oooool00ooVi^Ko0000
o`000002onKViP;o00000_oVi^H<ooooo`;o0000B_ooool00ol0003oooooo`000002o`0000Cooooo
00?oi^KVo`000?l000000_oVi^H2o`0000;oi^KV1?ooool2o`000003ooooool0003o000000Kooooo
0_l000000ooooooo0000o`00000`ooooo`00;oooool4o`0000[ooooo00?oi^KVo`000?l000000_oV
i^H2o`0000;oi^KV2_ooool3o`0004_ooooo00Go0000ooooool0003oooooo`000004ooooo`03onKV
i_l0003o000000;oi^KV0_l00002onKViPCooooo1?l00007ooooo`;o000000?oooooo`000?l00000
<?ooool002oooooo0_l000000ooooooo0000o`000009ooooo`;oi^KV1_l000000ooVi^Kooooooooo
o`0:ooooo`;o0000Boooool3o`0000Gooooo0_oVi^H6o`000003onKVi_oooooooooo00;ooooo0_l0
00000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l00000<?ooool002oooooo0_l00000
0ooooooo0000o`00000:ooooo`Ooi^KV2Oooool2o`0000;ooooo0_l0001Dooooo`Ooi^KV1Oooool2
o`000003ooooool0003o000000Kooooo0_l000000ooooooo0000o`00000`ooooo`00;_ooool5o`00
00cooooo1OoVi^H;ooooo`Co0000D?ooool00ol0003oooooooooo`03ooooo`Goi^KV1Oooool5o`00
00Kooooo1Ol0000aooooo`00<oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0booooo`00=?ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0Doooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`0cooooo`00=?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0Doooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`0cooooo`00=Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0d
ooooo`00=Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0EOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0dooooo`00=Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0dooooo`00
=_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
Eoooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`0eooooo`00=_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0eooooo`00=oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0FOooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0fooooo`00=oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0fooooo`00>?ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Foooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`0gooooo`00>?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Foooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`0gooooo`00>Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0GOooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0hooooo`00>Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0GOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0hooooo`00>_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Goooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0iooooo`00>_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Goooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0i
ooooo`00>oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0HOooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000looooo`00>oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0HOooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000looooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0Hoooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0003go
oooo000looooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`1Sooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000?Oooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06Gooooo00?o0000oooo
ool000000_ooool01?l0003oooooooooool0000nooooo`00?Oooool01Ol0003ooooooooooooooooo
000000?ooooo00?o0000ooooooooool0IOooool01_l0003oooooooooool0003oooooo`0000;ooooo
00?o0000ooooooooool0??ooool003gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo06Gooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo
03cooooo000nooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0Ioooool01ol0
003oooooo`000?oooooo0000ooooool00000?oooool003kooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`1Wooooo`07o`000?oooooo0000ooooool0003oooooo`00000oooooo`00
?oooool4o`000003onKVi_oooooooooo06Wooooo1OoVi^I0ooooo`00?_ooool4onKViP;o000000?o
i^KVooooooooool0Ioooool7onKViSoooooo0007ooooo`Oo0000;oooool2onKViPGo00000_oVi^H`
ooooo`Go0000<_ooool00ooVi^Ko0000o`000005o`000003onKVi_oooooooooo02gooooo1_l00009
ooooo`001oooool2o`0000;ooooo0_l0000`ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKV
iS7ooooo0_l000000ooooooo0000o`00000aooooo`;oi^KV0_l000000ooVi^Ko0000o`000002onKV
iS3ooooo0_l000000ooooooo0000o`000009ooooo`001oooool6o`00033ooooo00?oi^KVo`000?l0
00000_oVi^H2o`0000;oi^KV<Oooool2o`000003ooooool0003o0000037ooooo0_oVi^H2o`000003
onKVi_l0003o000000;oi^KV<Oooool2o`0000_ooooo0008ooooo`Co00000_ooool2o`0002gooooo
00?oi^KVo`000?l000000_oVi^H2o`0000;oi^KV<Oooool2o`000003ooooool0003o0000037ooooo
0_oVi^H2o`000003onKVi_l0003o000000;oi^KV;Oooool00ol0003oooooooooo`02ooooo`;o0000
2_ooool000Sooooo1?l00004ooooo`?o0000:_ooool2onKViPKo000000?oi^KVooooooooool0;ooo
ool2o`000003ooooool0003o0000037ooooo0_oVi^H4o`0000?oi^KV:_ooool3o`0000;ooooo0_l0
0002ooooo`;o00002Oooool000Wooooo0_l00008ooooo`?o0000:?ooool7onKViP03ooooool0003o
000002oooooo0_l000000ooooooo0000o`00000_ooooo`;o000000CoooooonKVi_l0003o00001?oV
i^HXooooo`?o00001Oooool2o`0000;ooooo0_l00009ooooo`002?ooool3o`0000_ooooo1?l0000U
ooooo`Goi^KV1?ooool00ol0003oooooooooo`0[ooooo`Go0000;oooool01?l0003ooooooooooooo
ool3o`0000?oi^KV9Oooool4o`0000Wooooo1?l0000:ooooo`006_ooool3o`0002cooooo0_l0000^
ooooo`03o`000?oooooooooo02cooooo0_l0000/ooooo`?o00006oooool001gooooo0ol0000[oooo
o`;o0000;?ooool00ol0003oooooooooo`0Zooooo`;o0000:oooool3o`0001kooooo000Pooooo`?o
0000:_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool0:?ooool3o`00027ooooo000Sooooo`Co00009oooool2o`0002Wooooo00?o0000ooooooooool0
9oooool2o`0002Oooooo1?l0000Tooooo`009oooool3o`0002Kooooo0_l0000Wooooo`03o`000?oo
oooooooo02Gooooo0_l0000Vooooo`?o0000:?ooool002[ooooo0ol0000Uooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`?o0000:oooool0
02gooooo1?l0000Rooooo`;o00009?ooool00ol0003oooooooooo`0Rooooo`;o00008_ooool4o`00
02kooooo000aooooo`?o00008Oooool2o`0002;ooooo00?o0000ooooooooool08?ooool2o`00027o
oooo0ol0000booooo`00=?ooool3o`00023ooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo01kooooo0ol0000eooooo`00=oooool3o`0001kooooo0_l0
000Oooooo`03o`000?oooooooooo01gooooo0_l0000Nooooo`?o0000>?ooool003[ooooo1?l0000L
ooooo`;o00007Oooool00ol0003oooooooooo`0Kooooo`;o00007?ooool4o`0003_ooooo000noooo
o`?o00006oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool06Oooool3o`0003oooooo0011ooooo`?o00006Oooool2o`0001[ooooo00?o0000oooooooo
ool06?ooool2o`0001Wooooo0ol00012ooooo`00A?ooool3o`0001Sooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Kooooo0ol00015ooooo`00Aooo
ool4o`0001Gooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo0_l0000Eooooo`Co0000B?oo
ool004_ooooo0ol0000Dooooo`;o00005Oooool00ol0003oooooooooo`0Cooooo`;o00005?ooool3
o`0004cooooo001>ooooo`?o00004oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool3o`0004oooooo001Aooooo`?o00004Oooool2o`0001;o
oooo00?o0000ooooooooool04?ooool2o`00017ooooo0ol0001Booooo`00E?ooool4o`0000oooooo
0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0000?ooooo`Co0000EOooool005Sooooo0ol0
000>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0<ooooo`?o0000FOooool005_ooooo0ol0000<ooooo`;o00003Oooool00ol0003oooooooooo`0;
ooooo`;o00003?ooool3o`0005cooooo001Nooooo`Co00002_ooool2o`0000_ooooo00?o0000oooo
ooooool02Oooool2o`0000[ooooo1?l0001Oooooo`00H_ooool3o`0000Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0001Sooooo`00
IOooool3o`0000Oooooo0_l00008ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000
I_ooool006Sooooo0ol00006ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`;o00001_oo
ool3o`0006Wooooo001[ooooo`Co00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool4o`0006cooooo001_ooooo`?o00000_ooool2o`00
0003oooooooVi^Koi^KV00?oi^KV00?oooooo`000?l000000_ooool3o`00073ooooo001booooo`?o
000000?oooooo`000?l000001?l000000ooVi^Koooooo`000002o`0007?ooooo001eooooo`?oi^KV
0_l00004onKViWKooooo001eooooo`?oi^KV0_l00004onKViWKooooo001eooooo`?oi^KV0_l00004
onKViWKooooo001eooooo`;oi^KV1Ol00002onKViWKooooo001eooooo`?oi^KV0_l00004onKViWKo
oooo001fooooo`?oi^KV0ol000000ooVi^Koooooooooo`1eooooo`00Moooool5onKViWSooooo003d
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18051, -0.834843, \
0.0179466, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5 -6 ]
[.61819 .01472 5 6 ]
[.97619 .01472 -5.0625 -6 ]
[.97619 .01472 5.0625 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1Ol0001>ooooo`Oo00002?ooool009?ooooo0_l00000
0ooooooo0000o`00001=ooooo`;o00000_ooool2o`0000Wooooo002Cooooo`;o000000?oooooo`00
0?l00000COooool6o`0000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`;o0000
00?oooooo`000?l00000C_ooool4o`0000[ooooo002Cooooo`;o000000Goooooo`000?l0003ooooo
o`00001:ooooo`03o`000?oooooooooo00;o00002oooool009;ooooo1Ol00003ooooo`;o0000Aooo
ool00ol0003oooooooooo`03o`0000_ooooo002Looooo`03o`000?oooooooooo04;ooooo0_l0000A
ooooo`00WOooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo017ooooo002Nooooo`03
o`000?oooooooooo03kooooo00?o0000ooooooooool04_ooool009oooooo0_l0000mooooo`03o`00
0?oooooooooo01?ooooo002Qooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool05?oo
ool00:;ooooo00?o0000ooooooooool0=_ooool2o`0001Oooooo002Sooooo`03o`000?oooooooooo
03Cooooo00?o0000ooooooooool05oooool00:Cooooo00?o0000ooooooooool0<_ooool00ol0003o
ooooooooo`0Hooooo`00YOooool2o`00037ooooo00?o0000ooooooooool06Oooool00:Oooooo00?o
0000ooooooooool0;Oooool00ol0003oooooooooo`0Jooooo`00Z?ooool00ol0003oooooooooo`0Z
ooooo`;o00007Oooool00:Wooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Moooo
o`00Z_ooool2o`0002Oooooo00?o0000ooooooooool07_ooool00:cooooo00?o0000ooooooooool0
8oooool00ol0003oooooooooo`0Oooooo`00[Oooool00ol0003oooooooooo`0Pooooo`;o00008_oo
ool00:kooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Rooooo`00[oooool2o`00
01gooooo00?o0000ooooooooool08oooool00;7ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`0Tooooo`00/_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02Gooooo
002cooooo`03o`000?oooooooooo01Cooooo0_l0000Xooooo`00]?ooool2o`0001?ooooo00?o0000
ooooooooool0:?ooool00;Kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0Yoooo
o`00]oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo02[ooooo002hooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0:oooool00;Wooooo00?o0000ooooooooool02?oo
ool2o`0002kooooo002jooooo`;o000000?oi^KVo`000?l000000_l00002ooooo`03o`000?oooooo
oooo02kooooo002kooooo`Goi^KV0ol0000aooooo`00@?ooool4o`0007Kooooo0ooVi^H5o`000003
onKVi_oooooooooo02oooooo0011ooooo`;o0000Moooool2onKViP;o00000_oVi^H2o`000003onKV
i_oooooooooo02oooooo000nooooo`Ko0000M_ooool2onKViP;o00000_oVi^H2o`000003onKVi_oo
oooooooo02oooooo000nooooo`;o000000?oooooo`000?l00000Moooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo02oooooo000oooooo`Co0000Moooool3onKViPKo0000<Oooool0043o
oooo0ol0001hooooo`Ooi^KV<_ooool0047ooooo0_l0001iooooo`Goi^KV<oooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0b
ooooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03
o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0
Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oo
oooooooo03;ooooo000nooooo`03onKVi_l0003o000000;o0000NOooool00ooVi^Ko0000o`000002
o`0003?ooooo000mooooo`Goi^KV0_l0001gooooo`Goi^KV0_l0000booooo`00;_ooool5o`0000Wo
oooo0ooVi^H5o`000003onKVi_oooooooooo00Sooooo1?l0001:ooooo`Co00001Oooool5o`0000Ko
oooo1Ol00004ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0_ooooo`00;oooool2o`000003oooo
ool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Koooooooooo`07ooooo`;o0000
0_ooool2o`0004Sooooo00?o0000ooooool000002?ooool2o`000003ooooool0003o000000Kooooo
0_l000000ooooooo0000o`000003ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0
;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool02oooool2o`0004Sooooo00?o0000ooooool000000_l00006ooooo`;o000000?o
ooooo`000?l000001_ooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0_ooooo`00;oooool4o`0000Wooooo0_oVi^H2o`0000;oi^KV0_l00000
0ooVi^Koooooooooo`09ooooo`?o0000BOooool01Ol0003oooooo`000?oooooo000000Kooooo0_l0
00000ooooooo0000o`000006ooooo`Co00001?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oo
oooooooo02oooooo000_ooooo`;o000000?oooooo`000?l000002?ooool3onKViPKo00003Oooool2
o`0004Wooooo0ol00007ooooo`;o000000?oooooo`000?l000001_ooool2o`000003ooooool0003o
000000?ooooo0ooVi^H6o`00037ooooo000_ooooo`;o000000?oooooo`000?l000002Oooool7onKV
iP[ooooo0_l00002ooooo`;o0000Doooool2o`000003ooooool0003o000000Kooooo0_l000000ooo
oooo0000o`000004ooooo`Ooi^KV<_ooool002kooooo1_l0000:ooooo`Goi^KV3?ooool4o`0005?o
oooo1Ol00006ooooo`Go00001_ooool5onKViS?ooooo000cooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo
000dooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo03Gooooo000dooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03Gooooo000eoooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Coooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo03Kooooo000eooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Kooooo000eooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Cooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo03Kooooo000fooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Oooooo000fooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo03Oooooo000gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1Gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo03Sooooo000gooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Gooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03So
oooo000hooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1Iooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo03Wooooo000hooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Wooooo000i
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1K
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo03[ooooo000iooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03[ooooo000jooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Mooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
03_ooooo000jooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Mooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo03_ooooo000kooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`1Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003kooooo000kooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`1Oooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003kooooo000looooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`1Qooooo`04o`000?ooooooooooo`0000?ooooo00Co
0000oooooooooooo0000?oooool003cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool0000oooooo`00?Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0Hoooool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`00043ooooo000mooooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?oooooooooo
o`000?oooooo00000_ooool00ol0003oooooooooo`0nooooo`00?Oooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool0Hoooool01_l0003oooooooooool0003oooooo`0000;o
oooo00?o0000ooooooooool0?_ooool003kooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`1Uooooo`07o`000?oooooo0000ooooool0003oooooo`000011ooooo`00?_ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`00
0?oooooo0000047ooooo000nooooo`03onKVi_l0003o000000?o0000J?ooool5onKViP03o`000?oo
oooooooo043ooooo000mooooo`Goi^KV0_l0001Wooooo`Ooi^KV@_ooool000Oooooo1ol0000^oooo
o`?oi^KV1Ol000000ooVi^Koooooooooo`0^ooooo`Go0000<?ooool2onKViPOo0000<?ooool6o`00
00_ooooo0007ooooo`;o00000_ooool2o`0002oooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Ko
ooooooooo`0_ooooo`;o000000?oooooo`000?l00000;oooool3onKViP;o000000Coi^KVo`000?l0
003oi^KV<Oooool2o`000003ooooool0003o000000_ooooo0007ooooo`Ko0000;oooool2onKViP;o
00000_oVi^H2o`000003onKVi_oooooooooo02oooooo0_l000000ooooooo0000o`00000_ooooo`?o
i^KV0_l000001?oVi^Ko0000o`000?oVi^Hbooooo`;o00003Oooool000Sooooo1?l00002ooooo`;o
0000;?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo02oooooo0_l000000ooooooo
0000o`00000_ooooo`?oi^KV0_l000001?oVi^Ko0000o`000?oVi^Hcooooo`;o00003?ooool000So
oooo1?l00004ooooo`?o0000:Oooool3onKViPOo0000<?ooool2o`000003ooooool0003o000002oo
oooo0ooVi^H4o`0000;oi^KV:oooool3o`0000;ooooo0_l00002ooooo`;o00002oooool000Wooooo
0_l00008ooooo`?o00009oooool7onKViP;ooooo0_l0000^ooooo`;o000000?oooooo`000?l00000
;_ooool2o`0000;oi^KV0_l00003onKViRWooooo0ol00005ooooo`;o00000_ooool2o`0000_ooooo
0008ooooo`?o00002oooool4o`0002Cooooo1OoVi^H5ooooo`03o`000?oooooooooo02[ooooo1Ol0
000^ooooo`04o`000?ooooooooooooooo`?o00000_oVi^HVooooo`Co00002Oooool4o`0000cooooo
000Jooooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2o`0002cooooo0ol0
000Mooooo`007Oooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo0_l0000[
ooooo`?o00008?ooool0023ooooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000oooo
ooooool0:?ooool00ol0003oooooooooo`0Xooooo`?o00008oooool002?ooooo1?l0000Wooooo`;o
0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool4o`0002Kooooo000Wooooo`?o0000
9_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
9?ooool3o`0002[ooooo000Zooooo`?o00009?ooool2o`0002Gooooo00?o0000ooooooooool08ooo
ool2o`0002Cooooo0ol0000]ooooo`00;Oooool3o`0002?ooooo0_l0000Sooooo`03o`000?oooooo
oooo027ooooo0_l0000Sooooo`?o0000<?ooool0033ooooo0ol0000Rooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`?o0000<oooool003?o
oooo1?l0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o00007oooool4o`0003Ko
oooo000gooooo`?o00007_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool07?ooool3o`0003[ooooo000jooooo`?o00007?ooool2o`0001gooooo00?o
0000ooooooooool06oooool2o`0001cooooo0ol0000mooooo`00?Oooool3o`0001_ooooo0_l0000K
ooooo`03o`000?oooooooooo01Wooooo0_l0000Kooooo`?o0000@?ooool0043ooooo1?l0000Ioooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Goooo
o`Co0000@oooool004Cooooo0ol0000Gooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`;o
00005oooool3o`0004Oooooo0017ooooo`?o00005_ooool2o`0001Kooooo00?o0000ooooooooool0
5?ooool2o`0001Kooooo0ol0001:ooooo`00B_ooool3o`0001Gooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0ol0001=ooooo`00COooool4
o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Booooo`Co0000D?ooool0
057ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0?ooooo`?o0000E?ooool005Cooooo0ol0000?ooooo`;o00004?ooool00ol0003o
ooooooooo`0>ooooo`;o00003oooool3o`0005Oooooo001Gooooo`?o00003_ooool2o`0000kooooo
00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001Jooooo`00F_ooool4o`0000cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo1?l0
001Mooooo`00G_ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo00Wooooo0_l0000:
ooooo`?o0000HOooool0067ooooo0ol00009ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`07ooooo`?o0000I?ooool006Cooooo0ol00007ooooo`;o
00002?ooool00ol0003oooooooooo`06ooooo`;o00001oooool3o`0006Oooooo001Wooooo`?o0000
1_ooool2o`0000Kooooo00?o0000ooooooooool01?ooool2o`0000Kooooo0ol0001Zooooo`00J_oo
ool4o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00;ooooo1?l0001]ooooo`00K_ooool3o`0000;ooooo0_l00005onKViP;ooooo0_l00002
ooooo`?o0000LOooool0077ooooo0ol000000ooVi^Ko0000o`000005o`000004ooooool0003o0000
o`0007Cooooo001cooooo`Coi^KV0_l00003onKViP03o`000?oooooooooo07Gooooo001cooooo`Co
i^KV0_l00003onKViWSooooo001cooooo`Coi^KV0_l00003onKViWSooooo001cooooo`?oi^KV1Ol0
00000ooVi^Koooooooooo`1fooooo`00Loooool4onKViP;o00000ooVi^Ihooooo`00M?ooool4onKV
iP?o0000NOooool007Gooooo1OoVi^Ijooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5 -6 ]
[.02381 .45617 5 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5.0625 -6 ]
[.49396 .45617 5.0625 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1ol0001<ooooo`Go00002_ooool009;ooooo0_l00002
ooooo`;o0000C_ooool2o`000003ooooool0003o000000Wooooo002Booooo`Ko0000C_ooool2o`00
0003ooooool0003o000000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`Co0000
Coooool2o`000003ooooool0003o000000Wooooo002Dooooo`;o00000oooool00ol0003ooooooooo
o`18ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00Toooool3o`0000Cooooo0_l0
0017ooooo`03o`000?oooooo000000Co00002_ooool009cooooo00?o0000ooooooooool0@_ooool2
o`00017ooooo002Mooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04Oooool009ko
oooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Booooo`00Woooool2o`0003gooooo
00?o0000ooooooooool04oooool00:7ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0Dooooo`00X_ooool00ol0003oooooooooo`0fooooo`;o00005oooool00:?ooooo00?o0000oooo
ooooool0=?ooool00ol0003oooooooooo`0Gooooo`00Y?ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01Sooooo002Uooooo`;o0000<Oooool00ol0003oooooooooo`0Iooooo`00Yooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01[ooooo002Xooooo`03o`000?oooooo
oooo02[ooooo0_l0000Mooooo`00ZOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01gooooo002Zooooo`;o00009oooool00ol0003oooooooooo`0Nooooo`00[?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`00[_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02;ooooo002_oooo
o`;o00007Oooool00ol0003oooooooooo`0Sooooo`00/Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02Cooooo002booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
9Oooool00;?ooooo00?o0000ooooooooool05?ooool2o`0002Sooooo002dooooo`;o00004oooool0
0ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
02Wooooo002gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool00;Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0[ooooo`00^Oooool00ol0003ooooooooo
o`08ooooo`;o0000;_ooool00;[ooooo0_l000000ooVi^Ko0000o`000002o`0000;ooooo00?o0000
ooooooooool0;_ooool00;_ooooo1OoVi^H3o`00037ooooo0010ooooo`Co0000M_ooool3onKViPGo
000000?oi^KVooooooooool0;oooool0047ooooo0_l0001gooooo`;oi^KV0_l00002onKViP;o0000
00?oi^KVooooooooool0;oooool003kooooo1_l0001fooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool003kooooo0_l000000ooooooo0000o`00001gooooo`;oi^KV0_l00002
onKViP;o000000?oi^KVooooooooool0;oooool003oooooo1?l0001gooooo`?oi^KV1_l0000aoooo
o`00@?ooool3o`0007Sooooo1ooVi^Hbooooo`00@Oooool2o`0007Wooooo1OoVi^Hcooooo`00@Ooo
ool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;o
oooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool003kooooo00?oi^KVo`000?l000000_l0001iooooo`03onKVi_l0003o
000000;o0000<oooool003gooooo1OoVi^H2o`0007Oooooo1OoVi^H2o`0003;ooooo000^ooooo`Go
00002Oooool3onKViPGo000000?oi^KVooooooooool02?ooool4o`0004[ooooo1?l00005ooooo`Go
00001_ooool5o`0000Cooooo0ooVi^H5o`000003onKVi_oooooooooo02oooooo000_ooooo`;o0000
00?oooooo`000?l000002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo
0_l00002ooooo`;o0000B?ooool00ol0003oooooo`000008ooooo`;o000000?oooooo`000?l00000
1_ooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Kooooo
ooooo`0_ooooo`00;oooool2o`000003ooooool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0;ooooo`;o0000B?ooool00ol0003oooooo`000002o`0000Kooooo0_l0
00000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l000000oooool2onKViP;o00000_oV
i^H2o`000003onKVi_oooooooooo02oooooo000_ooooo`Co00002Oooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo00Wooooo0ol00019ooooo`05o`000?oooooo0000ooooool000001_oo
ool2o`000003ooooool0003o000000Kooooo1?l00004ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`?oi^KV1_l0000=
ooooo`;o0000BOooool3o`0000Oooooo0_l000000ooooooo0000o`000006ooooo`;o000000?ooooo
o`000?l000000oooool3onKViPKo0000<Oooool002oooooo0_l000000ooooooo0000o`000009oooo
o`Ooi^KV2_ooool2o`0000;ooooo0_l0001Cooooo`;o000000?oooooo`000?l000001_ooool2o`00
0003ooooool0003o000000Cooooo1ooVi^Hbooooo`00;_ooool6o`0000[ooooo1OoVi^H<ooooo`Co
0000Doooool5o`0000Kooooo1Ol00006ooooo`Goi^KV<oooool003?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
=?ooool003Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0=Oooool003Cooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0
03Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0=_ooool003Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool003Gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=_ooool003Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=oooool003Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0=oooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool003Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0>?ooool003Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool003Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Ooo
ool003Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo05_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0>_ooool003Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>_ooool003[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05go
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0>oooool003[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo05gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0>oooool003_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool003_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?_ooool003cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0000oooooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0003oooooo000mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo0000@?ooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo03kooooo000mooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0nooooo`00?_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`000?oooooo0000047ooooo000noooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01ol0003oooooo`000?oo
oooo0000ooooool00000@Oooool003kooooo00?oi^KVo`000?l000000ol0001Xooooo`Goi^KV00?o
0000ooooooooool0@?ooool003gooooo1OoVi^H2o`0006Oooooo1ooVi^I2ooooo`001oooool5o`00
033ooooo0ooVi^H5o`000003onKVi_oooooooooo02kooooo1ol0000^ooooo`;oi^KV1ol0000`oooo
o`Ko00002oooool000Sooooo0_l000000ooooooo0000o`00000_ooooo`;oi^KV0_l00002onKViP;o
000000?oi^KVooooooooool0;_ooool2o`0000;ooooo0_l0000_ooooo`?oi^KV0_l000001?oVi^Ko
0000o`000?oVi^Haooooo`;o000000?oooooo`000?l000002oooool000Sooooo0_l000000ooooooo
0000o`00000_ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0;_ooool6o`0002oo
oooo0ooVi^H2o`000004onKVi_l0003o0000onKViS;ooooo0_l0000=ooooo`002?ooool2o`000004
ooooool0003o0000ooooo`;o0000;?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo
02oooooo1?l0000`ooooo`?oi^KV0_l000001?oVi^Ko0000o`000?oVi^Hcooooo`;o00003?ooool0
00Sooooo0_l000000ooooooo0000o`000003ooooo`?o0000:Oooool3onKViPOo0000<?ooool4o`00
033ooooo0ooVi^H4o`0000;oi^KV:oooool3o`0000;ooooo0_l00002ooooo`;o00002oooool000So
oooo0_l000000ooooooo0000o`000006ooooo`?o00009oooool7onKViP;ooooo0_l0000_ooooo`;o
0000<?ooool2o`0000;oi^KV0_l00003onKViRWooooo0ol00005ooooo`;o00000_ooool2o`0000_o
oooo0007ooooo`Go00002_ooool4o`0002Cooooo1OoVi^H5ooooo`03o`000?oooooooooo02_ooooo
0ol0000_ooooo`04o`000?ooooooooooooooo`?o00000_oVi^HVooooo`Co00002Oooool4o`0000co
oooo000Jooooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2o`0002cooooo
0ol0000Mooooo`007Oooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo0_l0
000[ooooo`?o00008?ooool0023ooooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000
ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`?o00008oooool002?ooooo1?l0000Woooo
o`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool4o`0002Kooooo000Wooooo`?o
00009_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool09?ooool3o`0002[ooooo000Zooooo`?o00009?ooool2o`0002Gooooo00?o0000ooooooooool0
8oooool2o`0002Cooooo0ol0000]ooooo`00;Oooool3o`0002?ooooo0_l0000Sooooo`03o`000?oo
oooooooo027ooooo0_l0000Sooooo`?o0000<?ooool0033ooooo0ol0000Rooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Pooooo`?o0000<oooool0
03?ooooo1?l0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o00007oooool4o`00
03Kooooo000gooooo`?o00007_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07?ooool3o`0003[ooooo000jooooo`?o00007?ooool2o`0001gooooo
00?o0000ooooooooool06oooool2o`0001cooooo0ol0000mooooo`00?Oooool3o`0001_ooooo0_l0
000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Kooooo`?o0000@?ooool0043ooooo1?l0000I
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0G
ooooo`Co0000@oooool004Cooooo0ol0000Gooooo`;o00006?ooool00ol0003oooooooooo`0Foooo
o`;o00005oooool3o`0004Oooooo0017ooooo`?o00005_ooool2o`0001Kooooo00?o0000oooooooo
ool05?ooool2o`0001Kooooo0ol0001:ooooo`00B_ooool3o`0001Gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0ol0001=ooooo`00COoo
ool4o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Booooo`Co0000D?oo
ool0057ooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`0?ooooo`?o0000E?ooool005Cooooo0ol0000?ooooo`;o00004?ooool00ol0
003oooooooooo`0>ooooo`;o00003oooool3o`0005Oooooo001Gooooo`?o00003_ooool2o`0000ko
oooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0001Jooooo`00F_ooool4o`0000cooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo
1?l0001Mooooo`00G_ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooooooo00Wooooo0_l0
000:ooooo`?o0000HOooool0067ooooo0ol00009ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`07ooooo`?o0000I?ooool006Cooooo0ol00007oooo
o`;o00002?ooool00ol0003oooooooooo`06ooooo`;o00001oooool3o`0006Oooooo001Wooooo`?o
00001_ooool2o`0000Kooooo00?o0000ooooooooool01?ooool2o`0000Kooooo0ol0001Zooooo`00
J_ooool4o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo1?l0001]ooooo`00K_ooool3o`0000;ooooo0_l00005onKViP;ooooo0_l0
0002ooooo`?o0000LOooool0077ooooo0ol000000ooVi^Ko0000o`000005o`000004ooooool0003o
0000o`0007Cooooo001cooooo`Coi^KV0_l00003onKViP03o`000?oooooooooo07Gooooo001coooo
o`Coi^KV0_l00003onKViWSooooo001cooooo`Coi^KV0_l00003onKViWSooooo001cooooo`?oi^KV
1Ol000000ooVi^Koooooooooo`1fooooo`00Loooool4onKViP;o00000ooVi^Ihooooo`00M?ooool4
onKViP?o0000NOooool007Gooooo1OoVi^Ijooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1ol0001<ooooo`Go00002_ooool009;ooooo0_l00002
ooooo`;o0000C_ooool2o`000003ooooool0003o000000Wooooo002Booooo`Ko0000C_ooool2o`00
0003ooooool0003o000000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`Co0000
Coooool2o`000003ooooool0003o000000Wooooo002Dooooo`;o00000oooool00ol0003ooooooooo
o`18ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00Toooool3o`0000Cooooo0_l0
0017ooooo`03o`000?oooooo000000Co00002_ooool009cooooo00?o0000ooooooooool0@_ooool2
o`00017ooooo002Mooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04Oooool009ko
oooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Booooo`00Woooool2o`0003gooooo
00?o0000ooooooooool04oooool00:7ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0Dooooo`00X_ooool00ol0003oooooooooo`0fooooo`;o00005oooool00:?ooooo00?o0000oooo
ooooool0=?ooool00ol0003oooooooooo`0Gooooo`00Y?ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01Sooooo002Uooooo`;o0000<Oooool00ol0003oooooooooo`0Iooooo`00Yooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01[ooooo002Xooooo`03o`000?oooooo
oooo02[ooooo0_l0000Mooooo`00ZOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01gooooo002Zooooo`;o00009oooool00ol0003oooooooooo`0Nooooo`00[?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`00[_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02;ooooo002_oooo
o`;o00007Oooool00ol0003oooooooooo`0Sooooo`00/Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02Cooooo002booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
9Oooool00;?ooooo00?o0000ooooooooool05?ooool2o`0002Sooooo002dooooo`;o00004oooool0
0ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
02Wooooo002gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool00;Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0[ooooo`00^Oooool00ol0003ooooooooo
o`08ooooo`;o0000;_ooool00;[ooooo0_l000000ooVi^Ko0000o`000002o`0000;ooooo00?o0000
ooooooooool0;_ooool00;_ooooo1OoVi^H3o`00037ooooo0010ooooo`Co0000M_ooool3onKViPGo
000000?oi^KVooooooooool0;oooool0047ooooo0_l0001gooooo`;oi^KV0_l00002onKViP;o0000
00?oi^KVooooooooool0;oooool003kooooo1_l0001fooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool003kooooo0_l000000ooooooo0000o`00001gooooo`;oi^KV0_l00002
onKViP;o000000?oi^KVooooooooool0;oooool003oooooo1?l0001gooooo`?oi^KV1_l0000aoooo
o`00@?ooool3o`0007Sooooo1ooVi^Hbooooo`00@Oooool2o`0007Wooooo1OoVi^Hcooooo`00@Ooo
ool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;o
oooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool003kooooo00?oi^KVo`000?l000000_l0001iooooo`03onKVi_l0003o
000000;o0000<oooool003gooooo1OoVi^H2o`0007Oooooo1OoVi^H2o`0003;ooooo000^ooooo`Go
00002Oooool3onKViPGo000000?oi^KVooooooooool02?ooool4o`0004[ooooo1?l00005ooooo`Go
00001_ooool5o`0000Cooooo0ooVi^H5o`000003onKVi_oooooooooo02oooooo000_ooooo`;o0000
00?oooooo`000?l000002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo
0_l00002ooooo`;o0000B?ooool00ol0003oooooo`000008ooooo`;o000000?oooooo`000?l00000
1_ooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Kooooo
ooooo`0_ooooo`00;oooool2o`000003ooooool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0;ooooo`;o0000B?ooool00ol0003oooooo`000002o`0000Kooooo0_l0
00000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l000000oooool2onKViP;o00000_oV
i^H2o`000003onKVi_oooooooooo02oooooo000_ooooo`Co00002Oooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo00Wooooo0ol00019ooooo`05o`000?oooooo0000ooooool000001_oo
ool2o`000003ooooool0003o000000Kooooo1?l00004ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`?oi^KV1_l0000=
ooooo`;o0000BOooool3o`0000Oooooo0_l000000ooooooo0000o`000006ooooo`;o000000?ooooo
o`000?l000000oooool3onKViPKo0000<Oooool002oooooo0_l000000ooooooo0000o`000009oooo
o`Ooi^KV2_ooool2o`0000;ooooo0_l0001Cooooo`;o000000?oooooo`000?l000001_ooool2o`00
0003ooooool0003o000000Cooooo1ooVi^Hbooooo`00;_ooool6o`0000[ooooo1OoVi^H<ooooo`Co
0000Doooool5o`0000Kooooo1Ol00006ooooo`Goi^KV<oooool003?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
=?ooool003Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0=Oooool003Cooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0
03Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0=_ooool003Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool003Gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=_ooool003Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=oooool003Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0=oooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool003Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0>?ooool003Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool003Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Ooo
ool003Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo05_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0>_ooool003Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>_ooool003[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05go
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0>oooool003[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo05gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0>oooool003_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool003_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?_ooool003cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0000oooooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0003oooooo000mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo0000@?ooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo03kooooo000mooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0nooooo`00?_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`000?oooooo0000047ooooo000noooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01ol0003oooooo`000?oo
oooo0000ooooool00000@Oooool003kooooo00?oi^KVo`000?l000000ol0001Xooooo`Goi^KV00?o
0000ooooooooool0@?ooool003gooooo1OoVi^H2o`0006Oooooo1ooVi^I2ooooo`001oooool7o`00
02kooooo0ooVi^H5o`000003onKVi_oooooooooo02kooooo1Ol0000`ooooo`;oi^KV1ol0000`oooo
o`Ko00002oooool000Oooooo0_l00002ooooo`;o0000;oooool2onKViP;o00000_oVi^H2o`000003
onKVi_oooooooooo02oooooo0_l000000ooooooo0000o`00000_ooooo`?oi^KV0_l000001?oVi^Ko
0000o`000?oVi^Haooooo`;o000000?oooooo`000?l000002oooool000Oooooo1_l0000_ooooo`;o
i^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003ooooool0003o000002oo
oooo0ooVi^H2o`000004onKVi_l0003o0000onKViS;ooooo0_l0000=ooooo`002?ooool4o`0000;o
oooo0_l0000/ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003
ooooool0003o000002oooooo0ooVi^H2o`000004onKVi_l0003o0000onKViS?ooooo0_l0000<oooo
o`002?ooool4o`0000Cooooo0ol0000Yooooo`?oi^KV1ol0000`ooooo`;o000000?oooooo`000?l0
0000;oooool3onKViPCo00000_oVi^H[ooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`00
2Oooool2o`0000Sooooo0ol0000Wooooo`Ooi^KV0_ooool2o`0002kooooo0_l000000ooooooo0000
o`00000^ooooo`;o00000_oVi^H2o`0000?oi^KV:Oooool3o`0000Gooooo0_l00002ooooo`;o0000
2oooool000Sooooo0ol0000;ooooo`Co00009?ooool5onKViPGooooo00?o0000ooooooooool0:_oo
ool5o`0002kooooo00Co0000oooooooooooooooo0ol00002onKViRKooooo1?l00009ooooo`Co0000
3?ooool001[ooooo0ol0000/ooooo`;o0000;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?oo
ool3o`0001gooooo000Mooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2
o`0002_ooooo0ol0000Pooooo`008?ooool3o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0ol0000Sooooo`008oooool4o`0002Oo
oooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Wooooo`Co00009_ooool002Oooooo
0ol0000Vooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Tooooo`?o0000:_ooool002[ooooo0ol0000Tooooo`;o00009Oooool00ol0003ooooooooo
o`0Sooooo`;o00009?ooool3o`0002gooooo000]ooooo`?o00008oooool2o`0002?ooooo00?o0000
ooooooooool08Oooool2o`0002?ooooo0ol0000`ooooo`00<?ooool3o`0002;ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0000coooo
o`00<oooool4o`0001oooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Oooooo`Co
0000=_ooool003Oooooo0ol0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Looooo`?o0000>_ooool003[ooooo0ol0000Looooo`;o00007Ooo
ool00ol0003oooooooooo`0Kooooo`;o00007?ooool3o`0003gooooo000mooooo`?o00006oooool2
o`0001_ooooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol00010ooooo`00@?ooool4o`00
01Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Oooooo1?l00013ooooo`00A?ooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Ko
oooo0_l0000Gooooo`?o0000Aoooool004Oooooo0ol0000Fooooo`;o00005_ooool00ol0003ooooo
ooooo`0Dooooo`;o00005_ooool3o`0004[ooooo001:ooooo`?o00005Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0004gooooo001=
ooooo`Co00004_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001@
ooooo`00DOooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00oooooo0ol0001Dooooo`00E?ooool3o`0000oooooo0_l0000@ooooo`03
o`000?oooooooooo00kooooo0_l0000?ooooo`?o0000Eoooool005Oooooo0ol0000>ooooo`;o0000
3_ooool00ol0003oooooooooo`0<ooooo`;o00003_ooool3o`0005[ooooo001Jooooo`Co00003?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool4o`0005gooooo001Nooooo`?o00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2
o`0000[ooooo0ol0001Qooooo`00HOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0001Tooooo`00I?ooool3o`0000Oo
oooo0_l00008ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000Ioooool006Oooooo
0ol00006ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`0006[ooooo
001Zooooo`Co00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool4o`0006gooooo001^ooooo`?o00000_ooool2o`0000Goi^KV0_ooool2
o`0000;ooooo0ol0001aooooo`00LOooool3o`000003onKVi_l0003o000000Go000000Coooooo`00
0?l0003o0000M?ooool007?ooooo1?oVi^H2o`0000?oi^KV00?o0000ooooooooool0MOooool007?o
oooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo0ooV
i^H5o`000003onKVi_oooooooooo07Kooooo001cooooo`Coi^KV0_l00003onKViWSooooo001doooo
o`Coi^KV0ol0001iooooo`00MOooool5onKViW[ooooo003dooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1ol0001<ooooo`Go00002_ooool009;ooooo0_l00002
ooooo`;o0000C_ooool2o`000003ooooool0003o000000Wooooo002Booooo`Ko0000C_ooool2o`00
0003ooooool0003o000000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`Co0000
Coooool2o`000003ooooool0003o000000Wooooo002Dooooo`;o00000oooool00ol0003ooooooooo
o`18ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00Toooool3o`0000Cooooo0_l0
0017ooooo`03o`000?oooooo000000Co00002_ooool009cooooo00?o0000ooooooooool0@_ooool2
o`00017ooooo002Mooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04Oooool009ko
oooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Booooo`00Woooool2o`0003gooooo
00?o0000ooooooooool04oooool00:7ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0Dooooo`00X_ooool00ol0003oooooooooo`0fooooo`;o00005oooool00:?ooooo00?o0000oooo
ooooool0=?ooool00ol0003oooooooooo`0Gooooo`00Y?ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01Sooooo002Uooooo`;o0000<Oooool00ol0003oooooooooo`0Iooooo`00Yooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01[ooooo002Xooooo`03o`000?oooooo
oooo02[ooooo0_l0000Mooooo`00ZOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01gooooo002Zooooo`;o00009oooool00ol0003oooooooooo`0Nooooo`00[?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`00[_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02;ooooo002_oooo
o`;o00007Oooool00ol0003oooooooooo`0Sooooo`00/Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02Cooooo002booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
9Oooool00;?ooooo00?o0000ooooooooool05?ooool2o`0002Sooooo002dooooo`;o00004oooool0
0ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
02Wooooo002gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool00;Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0[ooooo`00^Oooool00ol0003ooooooooo
o`08ooooo`;o0000;_ooool00;[ooooo0_l000000ooVi^Ko0000o`000002o`0000;ooooo00?o0000
ooooooooool0;_ooool00;_ooooo1OoVi^H3o`00037ooooo0010ooooo`Co0000M_ooool3onKViPGo
000000?oi^KVooooooooool0;oooool0047ooooo0_l0001gooooo`;oi^KV0_l00002onKViP;o0000
00?oi^KVooooooooool0;oooool003kooooo1_l0001fooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool003kooooo0_l000000ooooooo0000o`00001gooooo`;oi^KV0_l00002
onKViP;o000000?oi^KVooooooooool0;oooool003oooooo1?l0001gooooo`?oi^KV1_l0000aoooo
o`00@?ooool3o`0007Sooooo1ooVi^Hbooooo`00@Oooool2o`0007Wooooo1OoVi^Hcooooo`00@Ooo
ool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;o
oooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool003kooooo00?oi^KVo`000?l000000_l0001iooooo`03onKVi_l0003o
000000;o0000<oooool003gooooo1OoVi^H2o`0007Oooooo1OoVi^H2o`0003;ooooo000^ooooo`Go
00002Oooool3onKViPGo000000?oi^KVooooooooool02?ooool4o`0004[ooooo1?l00005ooooo`Go
00001_ooool5o`0000Cooooo0ooVi^H5o`000003onKVi_oooooooooo02oooooo000_ooooo`;o0000
00?oooooo`000?l000002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo
0_l00002ooooo`;o0000B?ooool00ol0003oooooo`000008ooooo`;o000000?oooooo`000?l00000
1_ooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Kooooo
ooooo`0_ooooo`00;oooool2o`000003ooooool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0;ooooo`;o0000B?ooool00ol0003oooooo`000002o`0000Kooooo0_l0
00000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l000000oooool2onKViP;o00000_oV
i^H2o`000003onKVi_oooooooooo02oooooo000_ooooo`Co00002Oooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo00Wooooo0ol00019ooooo`05o`000?oooooo0000ooooool000001_oo
ool2o`000003ooooool0003o000000Kooooo1?l00004ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`?oi^KV1_l0000=
ooooo`;o0000BOooool3o`0000Oooooo0_l000000ooooooo0000o`000006ooooo`;o000000?ooooo
o`000?l000000oooool3onKViPKo0000<Oooool002oooooo0_l000000ooooooo0000o`000009oooo
o`Ooi^KV2_ooool2o`0000;ooooo0_l0001Cooooo`;o000000?oooooo`000?l000001_ooool2o`00
0003ooooool0003o000000Cooooo1ooVi^Hbooooo`00;_ooool6o`0000[ooooo1OoVi^H<ooooo`Co
0000Doooool5o`0000Kooooo1Ol00006ooooo`Goi^KV<oooool003?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
=?ooool003Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0=Oooool003Cooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0
03Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0=_ooool003Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool003Gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=_ooool003Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=oooool003Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0=oooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool003Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0>?ooool003Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool003Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Ooo
ool003Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo05_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0>_ooool003Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>_ooool003[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05go
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0>oooool003[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo05gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0>oooool003_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool003_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?_ooool003cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0000oooooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0003oooooo000mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo0000@?ooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo03kooooo000mooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0nooooo`00?_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`000?oooooo0000047ooooo000noooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01ol0003oooooo`000?oo
oooo0000ooooool00000@Oooool003kooooo00?oi^KVo`000?l000000ol0001Xooooo`Goi^KV00?o
0000ooooooooool0@?ooool003gooooo1OoVi^H2o`0006Oooooo1ooVi^I2ooooo`001oooool7o`00
02kooooo0ooVi^H5o`000003onKVi_oooooooooo02kooooo1Ol0000`ooooo`;oi^KV1ol0000`oooo
o`Ko00002oooool000Oooooo0_l00002ooooo`;o0000;oooool2onKViP;o00000_oVi^H2o`000003
onKVi_oooooooooo02oooooo0_l000000ooooooo0000o`00000_ooooo`?oi^KV0_l000001?oVi^Ko
0000o`000?oVi^Haooooo`;o000000?oooooo`000?l000002oooool000Oooooo1_l0000_ooooo`;o
i^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003ooooool0003o000002oo
oooo0ooVi^H2o`000004onKVi_l0003o0000onKViS;ooooo0_l0000=ooooo`002?ooool4o`0000;o
oooo0_l0000/ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003
ooooool0003o000002oooooo0ooVi^H2o`000004onKVi_l0003o0000onKViS?ooooo0_l0000<oooo
o`002?ooool4o`0000Cooooo0ol0000Yooooo`?oi^KV1ol0000`ooooo`;o000000?oooooo`000?l0
0000;oooool3onKViPCo00000_oVi^H[ooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`00
2Oooool2o`0000Sooooo0ol0000Wooooo`Ooi^KV0_ooool2o`0002kooooo0_l000000ooooooo0000
o`00000^ooooo`;o00000_oVi^H2o`0000?oi^KV:Oooool3o`0000Gooooo0_l00002ooooo`;o0000
2oooool000Sooooo0ol0000;ooooo`Co00009?ooool5onKViPGooooo00?o0000ooooooooool0:_oo
ool5o`0002kooooo00Co0000oooooooooooooooo0ol00002onKViRKooooo1?l00009ooooo`Co0000
3?ooool001[ooooo0ol0000/ooooo`;o0000;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?oo
ool3o`0001gooooo000Mooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2
o`0002_ooooo0ol0000Pooooo`008?ooool3o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0ol0000Sooooo`008oooool4o`0002Oo
oooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Wooooo`Co00009_ooool002Oooooo
0ol0000Vooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Tooooo`?o0000:_ooool002[ooooo0ol0000Tooooo`;o00009Oooool00ol0003ooooooooo
o`0Sooooo`;o00009?ooool3o`0002gooooo000]ooooo`?o00008oooool2o`0002?ooooo00?o0000
ooooooooool08Oooool2o`0002?ooooo0ol0000`ooooo`00<?ooool3o`0002;ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0000coooo
o`00<oooool4o`0001oooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Oooooo`Co
0000=_ooool003Oooooo0ol0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Looooo`?o0000>_ooool003[ooooo0ol0000Looooo`;o00007Ooo
ool00ol0003oooooooooo`0Kooooo`;o00007?ooool3o`0003gooooo000mooooo`?o00006oooool2
o`0001_ooooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol00010ooooo`00@?ooool4o`00
01Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Oooooo1?l00013ooooo`00A?ooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Ko
oooo0_l0000Gooooo`?o0000Aoooool004Oooooo0ol0000Fooooo`;o00005_ooool00ol0003ooooo
ooooo`0Dooooo`;o00005_ooool3o`0004[ooooo001:ooooo`?o00005Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0004gooooo001=
ooooo`Co00004_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001@
ooooo`00DOooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00oooooo0ol0001Dooooo`00E?ooool3o`0000oooooo0_l0000@ooooo`03
o`000?oooooooooo00kooooo0_l0000?ooooo`?o0000Eoooool005Oooooo0ol0000>ooooo`;o0000
3_ooool00ol0003oooooooooo`0<ooooo`;o00003_ooool3o`0005[ooooo001Jooooo`Co00003?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool4o`0005gooooo001Nooooo`?o00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2
o`0000[ooooo0ol0001Qooooo`00HOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0001Tooooo`00I?ooool3o`0000Oo
oooo0_l00008ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000Ioooool006Oooooo
0ol00006ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`0006[ooooo
001Zooooo`Co00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool4o`0006gooooo001^ooooo`?o00000_ooool2o`0000Goi^KV0_ooool2
o`0000;ooooo0ol0001aooooo`00LOooool3o`000003onKVi_l0003o000000Go000000Coooooo`00
0?l0003o0000M?ooool007?ooooo1?oVi^H2o`0000?oi^KV00?o0000ooooooooool0MOooool007?o
oooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo0ooV
i^H5o`000003onKVi_oooooooooo07Kooooo001cooooo`Coi^KV0_l00003onKViWSooooo001doooo
o`Coi^KV0ol0001iooooo`00MOooool5onKViW[ooooo003dooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1ol0001<ooooo`Go00002_ooool009;ooooo0_l00002
ooooo`;o0000C_ooool2o`000003ooooool0003o000000Wooooo002Booooo`Ko0000C_ooool2o`00
0003ooooool0003o000000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`Co0000
Coooool2o`000003ooooool0003o000000Wooooo002Dooooo`;o00000oooool00ol0003ooooooooo
o`18ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00Toooool3o`0000Cooooo0_l0
0017ooooo`03o`000?oooooo000000Co00002_ooool009cooooo00?o0000ooooooooool0@_ooool2
o`00017ooooo002Mooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04Oooool009ko
oooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Booooo`00Woooool2o`0003gooooo
00?o0000ooooooooool04oooool00:7ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0Dooooo`00X_ooool00ol0003oooooooooo`0fooooo`;o00005oooool00:?ooooo00?o0000oooo
ooooool0=?ooool00ol0003oooooooooo`0Gooooo`00Y?ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01Sooooo002Uooooo`;o0000<Oooool00ol0003oooooooooo`0Iooooo`00Yooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01[ooooo002Xooooo`03o`000?oooooo
oooo02[ooooo0_l0000Mooooo`00ZOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01gooooo002Zooooo`;o00009oooool00ol0003oooooooooo`0Nooooo`00[?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`00[_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02;ooooo002_oooo
o`;o00007Oooool00ol0003oooooooooo`0Sooooo`00/Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02Cooooo002booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
9Oooool00;?ooooo00?o0000ooooooooool05?ooool2o`0002Sooooo002dooooo`;o00004oooool0
0ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
02Wooooo002gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool00;Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0[ooooo`00^Oooool00ol0003ooooooooo
o`08ooooo`;o0000;_ooool00;[ooooo0_l000000ooVi^Ko0000o`000002o`0000;ooooo00?o0000
ooooooooool0;_ooool00;_ooooo1OoVi^H3o`00037ooooo0010ooooo`Co0000M_ooool3onKViPGo
000000?oi^KVooooooooool0;oooool0047ooooo0_l0001gooooo`;oi^KV0_l00002onKViP;o0000
00?oi^KVooooooooool0;oooool003kooooo1_l0001fooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool003kooooo0_l000000ooooooo0000o`00001gooooo`;oi^KV0_l00002
onKViP;o000000?oi^KVooooooooool0;oooool003oooooo1?l0001gooooo`?oi^KV1_l0000aoooo
o`00@?ooool3o`0007Sooooo1ooVi^Hbooooo`00@Oooool2o`0007Wooooo1OoVi^Hcooooo`00@Ooo
ool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;o
oooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool003kooooo00?oi^KVo`000?l000000_l0001iooooo`03onKVi_l0003o
000000;o0000<oooool003gooooo1OoVi^H2o`0007Oooooo1OoVi^H2o`0003;ooooo000^ooooo`Go
00002Oooool3onKViPGo000000?oi^KVooooooooool02?ooool4o`0004[ooooo1?l00005ooooo`Go
00001_ooool5o`0000Cooooo0ooVi^H5o`000003onKVi_oooooooooo02oooooo000_ooooo`;o0000
00?oooooo`000?l000002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo
0_l00002ooooo`;o0000B?ooool00ol0003oooooo`000008ooooo`;o000000?oooooo`000?l00000
1_ooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Kooooo
ooooo`0_ooooo`00;oooool2o`000003ooooool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0;ooooo`;o0000B?ooool00ol0003oooooo`000002o`0000Kooooo0_l0
00000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l000000oooool2onKViP;o00000_oV
i^H2o`000003onKVi_oooooooooo02oooooo000_ooooo`Co00002Oooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo00Wooooo0ol00019ooooo`05o`000?oooooo0000ooooool000001_oo
ool4o`0000Oooooo0_l000000ooooooo0000o`000003ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`?oi^KV1_l0000=
ooooo`;o0000BOooool3o`0000Oooooo0_l000000ooooooo0000o`000006ooooo`;o000000?ooooo
o`000?l000000oooool3onKViPKo0000<Oooool002oooooo0_l000000ooooooo0000o`000009oooo
o`Ooi^KV2_ooool2o`0000;ooooo0_l0001Cooooo`;o000000?oooooo`000?l000001_ooool2o`00
0003ooooool0003o000000Cooooo1ooVi^Hbooooo`00;_ooool6o`0000[ooooo1OoVi^H<ooooo`Co
0000Doooool5o`0000Kooooo1Ol00006ooooo`Goi^KV<oooool003?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
=?ooool003Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0=Oooool003Cooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0
03Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0=_ooool003Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool003Gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=_ooool003Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=oooool003Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0=oooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool003Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0>?ooool003Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool003Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Ooo
ool003Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo05_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0>_ooool003Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>_ooool003[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05go
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0>oooool003[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo05gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0>oooool003_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool003_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?_ooool003cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0000oooooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0003oooooo000mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo0000@?ooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo03kooooo000mooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0nooooo`00?_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`000?oooooo0000047ooooo000noooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01ol0003oooooo`000?oo
oooo0000ooooool00000@Oooool003kooooo00?oi^KVo`000?l000000ol0001Xooooo`Goi^KV00?o
0000ooooooooool0@?ooool003gooooo1OoVi^H2o`0006Oooooo1ooVi^I2ooooo`001oooool7o`00
02kooooo0ooVi^H5o`000003onKVi_oooooooooo02kooooo1Ol0000`ooooo`;oi^KV1ol0000`oooo
o`Ko00002oooool000Oooooo0_l00002ooooo`;o0000;oooool2onKViP;o00000_oVi^H2o`000003
onKVi_oooooooooo02oooooo0_l000000ooooooo0000o`00000_ooooo`?oi^KV0_l000001?oVi^Ko
0000o`000?oVi^Haooooo`;o000000?oooooo`000?l000002oooool000Oooooo1_l0000_ooooo`;o
i^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003ooooool0003o000002oo
oooo0ooVi^H2o`000004onKVi_l0003o0000onKViS;ooooo0_l0000=ooooo`002?ooool4o`0000;o
oooo0_l0000/ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003
ooooool0003o000002oooooo0ooVi^H2o`000004onKVi_l0003o0000onKViS?ooooo0_l0000<oooo
o`002?ooool4o`0000Cooooo0ol0000Yooooo`?oi^KV1ol0000`ooooo`;o000000?oooooo`000?l0
0000;oooool3onKViPCo00000_oVi^H[ooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`00
2Oooool2o`0000Sooooo0ol0000Wooooo`Ooi^KV0_ooool2o`0002kooooo0_l000000ooooooo0000
o`00000^ooooo`;o00000_oVi^H2o`0000?oi^KV:Oooool3o`0000Gooooo0_l00002ooooo`;o0000
2oooool000Sooooo0ol0000;ooooo`Co00009?ooool5onKViPGooooo00?o0000ooooooooool0:_oo
ool5o`0002kooooo00Co0000oooooooooooooooo0ol00002onKViRKooooo1?l00009ooooo`Co0000
3?ooool001[ooooo0ol0000/ooooo`;o0000;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?oo
ool3o`0001gooooo000Mooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2
o`0002_ooooo0ol0000Pooooo`008?ooool3o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0ol0000Sooooo`008oooool4o`0002Oo
oooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Wooooo`Co00009_ooool002Oooooo
0ol0000Vooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Tooooo`?o0000:_ooool002[ooooo0ol0000Tooooo`;o00009Oooool00ol0003ooooooooo
o`0Sooooo`;o00009?ooool3o`0002gooooo000]ooooo`?o00008oooool2o`0002?ooooo00?o0000
ooooooooool08Oooool2o`0002?ooooo0ol0000`ooooo`00<?ooool3o`0002;ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0000coooo
o`00<oooool4o`0001oooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Oooooo`Co
0000=_ooool003Oooooo0ol0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Looooo`?o0000>_ooool003[ooooo0ol0000Looooo`;o00007Ooo
ool00ol0003oooooooooo`0Kooooo`;o00007?ooool3o`0003gooooo000mooooo`?o00006oooool2
o`0001_ooooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol00010ooooo`00@?ooool4o`00
01Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Oooooo1?l00013ooooo`00A?ooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Ko
oooo0_l0000Gooooo`?o0000Aoooool004Oooooo0ol0000Fooooo`;o00005_ooool00ol0003ooooo
ooooo`0Dooooo`;o00005_ooool3o`0004[ooooo001:ooooo`?o00005Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0004gooooo001=
ooooo`Co00004_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001@
ooooo`00DOooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00oooooo0ol0001Dooooo`00E?ooool3o`0000oooooo0_l0000@ooooo`03
o`000?oooooooooo00kooooo0_l0000?ooooo`?o0000Eoooool005Oooooo0ol0000>ooooo`;o0000
3_ooool00ol0003oooooooooo`0<ooooo`;o00003_ooool3o`0005[ooooo001Jooooo`Co00003?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool4o`0005gooooo001Nooooo`?o00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2
o`0000[ooooo0ol0001Qooooo`00HOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0001Tooooo`00I?ooool3o`0000Oo
oooo0_l00008ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000Ioooool006Oooooo
0ol00006ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`0006[ooooo
001Zooooo`Co00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool4o`0006gooooo001^ooooo`?o00000_ooool2o`0000Goi^KV0_ooool2
o`0000;ooooo0ol0001aooooo`00LOooool3o`000003onKVi_l0003o000000Go000000Coooooo`00
0?l0003o0000M?ooool007?ooooo1?oVi^H2o`0000?oi^KV00?o0000ooooooooool0MOooool007?o
oooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo0ooV
i^H5o`000003onKVi_oooooooooo07Kooooo001cooooo`Coi^KV0_l00003onKViWSooooo001doooo
o`Coi^KV0ol0001iooooo`00MOooool5onKViW[ooooo003dooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.526165 0.219378 0.603319 0.735755 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.08741 .30902 -5 -6 ]
[.08741 .30902 5 6 ]
[.08741 .16187 -5 -6 ]
[.08741 .16187 5 6 ]
[.15101 .30902 -5 -6 ]
[.15101 .30902 5 6 ]
[.08741 .45617 -5 -6 ]
[.08741 .45617 5 6 ]
[.30679 .45617 -5 -6 ]
[.30679 .45617 5 6 ]
[.52616 .45617 -5.0625 -6 ]
[.52616 .45617 5.0625 6 ]
[.68194 .30902 -5 -6 ]
[.68194 .30902 5 6 ]
[.72434 .30902 -5 -6 ]
[.72434 .30902 5 6 ]
[.76674 .30902 -5 -6 ]
[.76674 .30902 5 6 ]
[.80914 .30902 -5 -6 ]
[.80914 .30902 5 6 ]
[.6421 .01472 -5.0625 -6 ]
[.6421 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.80914 .16187 -5 -6 ]
[.80914 .16187 5 6 ]
[.74554 .45617 -5 -6 ]
[.74554 .45617 5 6 ]
[.96492 .45617 -5 -6 ]
[.96492 .45617 5 6 ]
[.52616 .60332 -5 -6 ]
[.52616 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.52616 .60332 m
.08741 .45617 L
s
.52616 .60332 m
.30679 .45617 L
s
.52616 .60332 m
.52616 .45617 L
s
.52616 .60332 m
.74554 .45617 L
s
.52616 .60332 m
.96492 .45617 L
s
.08741 .45617 m
.02381 .30902 L
s
.08741 .45617 m
.08741 .30902 L
s
.08741 .45617 m
.15101 .30902 L
s
1 g
.04 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.08741 .30902 m
.08741 .16187 L
s
.9 g
.04 w
.08741 .30902 Mdot
0 g
gsave
.08741 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.08741 .16187 Mdot
0 g
gsave
.08741 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.15101 .30902 Mdot
0 g
gsave
.15101 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.08741 .45617 Mdot
0 g
gsave
.08741 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.30679 .45617 Mdot
0 g
gsave
.30679 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.52616 .45617 Mdot
0 g
gsave
.52616 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.74554 .45617 m
.68194 .30902 L
s
.74554 .45617 m
.72434 .30902 L
s
.74554 .45617 m
.76674 .30902 L
s
.74554 .45617 m
.80914 .30902 L
s
1 g
.04 w
.68194 .30902 Mdot
0 g
gsave
.68194 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.72434 .30902 Mdot
0 g
gsave
.72434 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.76674 .30902 Mdot
0 g
gsave
.76674 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .30902 m
.80914 .16187 L
s
.9 g
.04 w
.80914 .30902 Mdot
0 g
gsave
.80914 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.80914 .16187 m
.6421 .01472 L
s
.80914 .16187 m
.97619 .01472 L
s
1 g
.04 w
.6421 .01472 Mdot
0 g
gsave
.6421 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.80914 .16187 Mdot
0 g
gsave
.80914 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.74554 .45617 Mdot
0 g
gsave
.74554 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96492 .45617 Mdot
0 g
gsave
.96492 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.52616 .60332 Mdot
0 g
gsave
.52616 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009Oooooo1ol00017ooooo`Go00002_ooool009Oooooo0_l00002
ooooo`;o0000BOooool2o`000003ooooool0003o000000Wooooo002Gooooo`Ko0000BOooool2o`00
0003ooooool0003o000000Wooooo002Hooooo`Co0000B_ooool4o`0000[ooooo002Hooooo`Co0000
B_ooool2o`000003ooooool0003o000000Wooooo002Iooooo`;o00000oooool00ol0003ooooooooo
o`13ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00V?ooool3o`0000Cooooo00?o
0000ooooooooool0@Oooool00ol0003oooooo`000004o`0000[ooooo002Pooooo`03o`000?oooooo
oooo03oooooo00?o0000ooooooooool03oooool00:7ooooo00?o0000ooooooooool0?Oooool00ol0
003oooooooooo`0@ooooo`00X_ooool2o`0003_ooooo0_l0000Cooooo`00Y?ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo01?ooooo002Uooooo`03o`000?oooooooooo03Gooooo00?o
0000ooooooooool05?ooool00:Kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0E
ooooo`00Yoooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo01Kooooo002Xooooo`03
o`000?oooooooooo02oooooo00?o0000ooooooooool05oooool00:Wooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`0Hooooo`00Z_ooool2o`0002_ooooo0_l0000Kooooo`00[?ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo01_ooooo002]ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool07?ooool00:kooooo00?o0000ooooooooool08oooool00ol0003o
ooooooooo`0Mooooo`00[oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01kooooo
002`ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00;7ooooo0_l0000M
ooooo`;o00008_ooool00;?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Roooo
o`00]?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo02?ooooo002eooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool09?ooool00;Kooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Uooooo`00]oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo02Kooooo002hooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool09oooool00;Wo
oooo0_l0000=ooooo`;o0000:_ooool00;_ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0Zooooo`00_?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02_ooooo002m
ooooo`03o`000?oooooo000000?o000000?oi^KVooooool00000;_ooool00;kooooo1?oVi^H2o`00
0003onKVi_oooooooooo02gooooo000Hooooo`Co0000XOooool2onKViPGo00000_oVi^H^ooooo`00
6Oooool2o`000:;ooooo00?oi^KVo`000?l000000_oVi^H2o`0000;oi^KV;_ooool001Kooooo1_l0
002Qooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo000Fooooo`;o000000?ooooo
o`000?l00000X_ooool00ooVi^Ko0000o`000002onKViP;o00000_oVi^H^ooooo`005oooool4o`00
0:;ooooo0_oVi^H6o`000003onKVi_oooooooooo02cooooo000Hooooo`?o0000Xoooool7onKViRoo
oooo000Iooooo`;o0000Y?ooool5onKViS3ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o
0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`
ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03
o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0
Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oo
oooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool0
01Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooooooo
o`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hoooo
o`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooooooo
ool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`00
0?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?oo
ool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0
003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Ko
oooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo033ooooo000H
ooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0<?ooool001Sooooo00?o0000oooo
ooooool0Y_ooool00ol0003oooooooooo`0`ooooo`006?ooool00ol0003oooooooooo`2Vooooo`03
o`000?oooooooooo033ooooo000Hooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0
<?ooool001Sooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0`ooooo`005_ooool0
0ooVi^Ko0000o`000002o`000:Cooooo1?l000000ooVi^Koooooooooo`0^ooooo`005Oooool5onKV
iP;o0000X_ooool4onKViP;o000000?oi^KVooooooooool0;Oooool000Oooooo1Ol00008ooooo`?o
i^KV1Ol000000ooVi^Koooooooooo`06ooooo`Co0000NOooool4o`0000Gooooo1Ol00004ooooo`Go
00001?ooool2onKViPGo00000_oVi^H^ooooo`002?ooool2o`000003ooooool0003o000000Oooooo
0_oVi^H2o`0000;oi^KV0_l000000ooVi^Koooooooooo`05ooooo`;o00000_ooool2o`0007Oooooo
00?o0000ooooool000002?ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000
o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?o
ooooo`000?l000001oooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Wooooo0_l0
001gooooo`03o`000?oooooo000000;o00001_ooool2o`000003ooooool0003o000000Cooooo0_l0
00000ooooooo0000o`000003ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008
ooooo`Co00002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo0ol0001h
ooooo`05o`000?oooooo0000ooooool000001_ooool2o`000003ooooool0003o000000Cooooo1?l0
0004ooooo`03onKVi_l0003o000000;oi^KV0_l00002onKViRkooooo0008ooooo`;o000000?ooooo
o`000?l000001oooool3onKViPKo00002oooool2o`0007Sooooo0ol00007ooooo`;o000000?ooooo
o`000?l000001?ooool2o`000003ooooool0003o000000?ooooo0_oVi^H6o`000003onKVi_oooooo
oooo02cooooo0008ooooo`;o000000?oooooo`000?l000002?ooool7onKViPSooooo0_l00002oooo
o`;o0000P_ooool2o`000003ooooool0003o000000Cooooo0_l000000ooooooo0000o`000004oooo
o`Ooi^KV;oooool000Oooooo1Ol0000:ooooo`Goi^KV2_ooool4o`0008;ooooo1Ol00004ooooo`Go
00001_ooool5onKViS3ooooo000<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo03;ooooo000<ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1nooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo03;ooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`20ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo03?ooooo000=ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
03?ooooo000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`22ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo03Cooooo000>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Cooooo
000>ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`23ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo03Gooooo000?ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Gooooo000?oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`25oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03Kooooo000@ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`26ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo03Kooooo000@ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Oooooo000Aooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`28ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo03Oooooo000Aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`2:ooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo03Sooooo000Booooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Booooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2;ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2<ooooo`05o`000?oo
ooooooooooooool000000_ooool01Ol0003ooooooooooooooooo000003_ooooo000Cooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2=ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool0000looooo`005?ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool0S_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0003cooooo000Dooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`2?ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003o
ooooooooo`0kooooo`005Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo093o
oooo00Go0000ooooool0003oooooo`000002ooooo`03o`000?oooooooooo03_ooooo000Eooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0TOooool01ol0003oooooo`000?oooooo
0000ooooool00000?_ooool001Gooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`2Aooooo`07o`000?oooooo0000ooooool0003oooooo`00000nooooo`005_ooool01Ol0003ooooo
o`000?oooooo000009Gooooo0_l000000ooooooo0000o`00000oooooo`005_ooool00ooVi^Ko0000
o`000002o`0009Gooooo1OoVi^Hoooooo`005Oooool5onKViP;o0000Toooool7onKViSkooooo000D
ooooo`?oi^KV1Ol000000ooVi^Koooooooooo`0Zooooo`Go0000;_ooool7o`0002_ooooo00?oi^KV
o`000?l000001Ol000000ooVi^Koooooooooo`0Zooooo`Ko00002oooool001Cooooo0_oVi^H2o`00
00;oi^KV0_l000000ooVi^Koooooooooo`0[ooooo`;o000000?oooooo`000?l00000;Oooool2o`00
00;ooooo0_l0000/ooooo`;oi^KV0_l000000ooVi^Ko0000o`000002onKViRgooooo0_l000000ooo
oooo0000o`00000;ooooo`005?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo02_o
oooo0_l000000ooooooo0000o`00000]ooooo`Ko0000;?ooool2onKViP;o000000?oi^KVo`000?l0
00000_oVi^H^ooooo`;o00003Oooool001Cooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Ko0000
ooooo`0[ooooo`;o000000?oooooo`000?l00000;_ooool4o`0002gooooo0_oVi^H2o`000003onKV
i_l0003o000000;oi^KV:_ooool00ol0003oooooooooo`02ooooo`;o00003?ooool001Cooooo0ooV
i^H6o`000004ooooool0003o0000o`0002Wooooo0_l000000ooooooo0000o`00000^ooooo`Co0000
;Oooool2onKViPCo00000ooVi^HWooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`005Ooo
ool7onKViPGooooo0ol0000Vooooo`;o000000?oooooo`000?l000000_ooool00ol0003ooooooooo
o`0Zooooo`;o0000;Oooool00ol0003oooooonKViP02o`0000Coi^KV9Oooool3o`0000Gooooo0_l0
0002ooooo`;o00002oooool001Kooooo1OoVi^H9ooooo`?o00008_ooool5o`0000Cooooo0_l0000Y
ooooo`?o0000:oooool2o`0000;ooooo0ol00003onKViR?ooooo0ol00009ooooo`Co00003?ooool0
02Oooooo0ol0000Zooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`?o00007?ooool002[ooooo0ol0000Xooooo`;o0000:?ooool00ol0003o
ooooooooo`0Vooooo`;o0000:?ooool3o`0001oooooo000]ooooo`?o00009oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool3o`0002;ooooo
000`ooooo`?o00009Oooool2o`0002Gooooo00?o0000ooooooooool08oooool2o`0002Gooooo0ol0
000Uooooo`00<oooool3o`0002Cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo02;ooooo0ol0000Xooooo`00=_ooool3o`0002;ooooo0_l0000Roooo
o`03o`000?oooooooooo023ooooo0_l0000Rooooo`?o0000:oooool003Wooooo0ol0000Qooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`?o
0000;_ooool003cooooo0ol0000Oooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`;o0000
7oooool3o`00037ooooo000oooooo`?o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool07?ooool3o`0003Cooooo0012ooooo`?o00007?ooool2
o`0001cooooo00?o0000ooooooooool06_ooool2o`0001cooooo0ol0000gooooo`00AOooool3o`00
01_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01Wooooo0ol0000jooooo`00B?ooool3o`0001Wooooo0_l0000Iooooo`03o`000?oooooooooo01Oo
oooo0_l0000Iooooo`?o0000?Oooool004_ooooo0ol0000Hooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`?o0000@?ooool004kooooo0ol0
000Fooooo`;o00005_ooool00ol0003oooooooooo`0Dooooo`;o00005_ooool3o`0004?ooooo001A
ooooo`?o00005Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04oooool3o`0004Kooooo001Dooooo`?o00004oooool2o`0001?ooooo00?o0000oooo
ooooool04Oooool2o`0001?ooooo0ol00019ooooo`00Eoooool3o`0001;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo0ol0001<ooooo`00
F_ooool3o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00kooooo0_l0000@ooooo`?o0000
Coooool005gooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`?o0000D_ooool0063ooooo0ol0000=ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool3o`0005Gooooo001Sooooo`?o00003?ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool3o`00
05Sooooo001Vooooo`?o00002_ooool2o`0000[ooooo00?o0000ooooooooool02?ooool2o`0000[o
oooo0ol0001Kooooo`00JOooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo0ol0001Nooooo`00K?ooool3o`0000Oooooo0_l0
0007ooooo`03o`000?oooooooooo00Gooooo0_l00007ooooo`?o0000HOooool006oooooo0ol00006
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`?o0000I?ooool007;ooooo0ol00004ooooo`;o00001?ooool00ol0003oooooooooo`02oooo
o`;o00001?ooool3o`0006Oooooo001eooooo`?o00000oooool00ol0003oooooonKViP04onKViP03
ooooool0003ooooo00;ooooo0ol0001Zooooo`00N?ooool3o`000003ooooool0003o000000Co0000
00?oi^KVooooool000000_l0001]ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool3
onKViP;o00001?oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00Noooool2onKViPGo
00000_oVi^I`ooooo`00Noooool3onKViP;o00001?oVi^I`ooooo`00O?ooool3onKViP?o000000?o
i^KVooooooooool0Koooool007gooooo1OoVi^Ibooooo`00m?ooool00001\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.48582, -0.834843, \
0.0194778, 0.00580764}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ 0 -0.00528 0 0 ]
[ 1 .62332 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.04 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.04 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
.9 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.04 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
.9 g
.04 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.04 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{244, 150.75},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003d0000UR000`400?l00000o`00003om?ooool0
0?Cooooo003dooooo`00m?ooool009;ooooo1ol0001<ooooo`Go00002_ooool009;ooooo0_l00002
ooooo`;o0000C_ooool2o`000003ooooool0003o000000Wooooo002Booooo`Ko0000C_ooool2o`00
0003ooooool0003o000000Wooooo002Cooooo`Co0000Coooool4o`0000[ooooo002Cooooo`Co0000
Coooool2o`000003ooooool0003o000000Wooooo002Dooooo`;o00000oooool00ol0003ooooooooo
o`18ooooo`05o`000?oooooo0000o`000?ooool00_l00009ooooo`00Toooool3o`0000Cooooo0_l0
0017ooooo`03o`000?oooooo000000Co00002_ooool009cooooo00?o0000ooooooooool0@_ooool2
o`00017ooooo002Mooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool04Oooool009ko
oooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Booooo`00Woooool2o`0003gooooo
00?o0000ooooooooool04oooool00:7ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0Dooooo`00X_ooool00ol0003oooooooooo`0fooooo`;o00005oooool00:?ooooo00?o0000oooo
ooooool0=?ooool00ol0003oooooooooo`0Gooooo`00Y?ooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01Sooooo002Uooooo`;o0000<Oooool00ol0003oooooooooo`0Iooooo`00Yooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo01[ooooo002Xooooo`03o`000?oooooo
oooo02[ooooo0_l0000Mooooo`00ZOooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
01gooooo002Zooooo`;o00009oooool00ol0003oooooooooo`0Nooooo`00[?ooool00ol0003ooooo
ooooo`0Sooooo`03o`000?oooooooooo01oooooo002]ooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`00[_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02;ooooo002_oooo
o`;o00007Oooool00ol0003oooooooooo`0Sooooo`00/Oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo02Cooooo002booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
9Oooool00;?ooooo00?o0000ooooooooool05?ooool2o`0002Sooooo002dooooo`;o00004oooool0
0ol0003oooooooooo`0Xooooo`00]_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
02Wooooo002gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0:_ooool00;Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0[ooooo`00^Oooool00ol0003ooooooooo
o`08ooooo`;o0000;_ooool00;[ooooo0_l000000ooVi^Ko0000o`000002o`0000;ooooo00?o0000
ooooooooool0;_ooool00;_ooooo1OoVi^H3o`00037ooooo0010ooooo`Co0000M_ooool3onKViPGo
000000?oi^KVooooooooool0;oooool0047ooooo0_l0001gooooo`;oi^KV0_l00002onKViP;o0000
00?oi^KVooooooooool0;oooool003kooooo1_l0001fooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool003kooooo0_l000000ooooooo0000o`00001gooooo`;oi^KV0_l00002
onKViP;o000000?oi^KVooooooooool0;oooool003oooooo1?l0001gooooo`?oi^KV1_l0000aoooo
o`00@?ooool3o`0007Sooooo1ooVi^Hbooooo`00@Oooool2o`0007Wooooo1OoVi^Hcooooo`00@Ooo
ool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooo
oooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;o
oooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o
0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1k
ooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000oooo
ooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00
@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oo
oooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool0
0ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo
03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo
00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooooooo
o`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000
ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0boooo
o`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`00
0?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047ooooo00?o0000ooooooooool0Nooo
ool00ol0003oooooooooo`0booooo`00@Oooool00ol0003oooooooooo`1kooooo`03o`000?oooooo
oooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool0<_ooool0047o
oooo00?o0000ooooooooool0Noooool00ol0003oooooooooo`0booooo`00@Oooool00ol0003ooooo
ooooo`1kooooo`03o`000?oooooooooo03;ooooo0011ooooo`03o`000?oooooooooo07_ooooo00?o
0000ooooooooool0<_ooool003kooooo00?oi^KVo`000?l000000_l0001iooooo`03onKVi_l0003o
000000;o0000<oooool003gooooo1OoVi^H2o`0007Oooooo1OoVi^H2o`0003;ooooo000^ooooo`Go
00002Oooool3onKViPGo000000?oi^KVooooooooool02?ooool4o`0004Wooooo1Ol00006ooooo`Co
00001_ooool5o`0000Cooooo0ooVi^H5o`000003onKVi_oooooooooo02oooooo000_ooooo`;o0000
00?oooooo`000?l000002?ooool2onKViP;o00000_oVi^H2o`000003onKVi_oooooooooo00Oooooo
0_l00002ooooo`;o0000BOooool2o`000003ooooool0003o000000Cooooo00?o0000ooooool00000
2Oooool2o`000003ooooool0003o000000?ooooo0_oVi^H2o`0000;oi^KV0_l000000ooVi^Kooooo
ooooo`0_ooooo`00;oooool2o`000003ooooool0003o000000Sooooo0_oVi^H2o`0000;oi^KV0_l0
00000ooVi^Koooooooooo`0;ooooo`;o0000BOooool2o`000003ooooool0003o000000Cooooo00?o
0000ooooool000000_l00007ooooo`;o000000?oooooo`000?l000000oooool2onKViP;o00000_oV
i^H2o`000003onKVi_oooooooooo02oooooo000_ooooo`Co00002Oooool2onKViP;o00000_oVi^H2
o`000003onKVi_oooooooooo00Wooooo0ol0001:ooooo`;o000000?oooooo`000?l000001?ooool0
1Ol0003oooooo`000?oooooo000000Oooooo1?l00004ooooo`;oi^KV0_l00002onKViP;o000000?o
i^KVooooooooool0;oooool002oooooo0_l000000ooooooo0000o`000008ooooo`?oi^KV1_l0000=
ooooo`;o0000BOooool2o`000003ooooool0003o000000Gooooo0ol00008ooooo`;o000000?ooooo
o`000?l000000oooool3onKViPKo0000<Oooool002oooooo0_l000000ooooooo0000o`000009oooo
o`Ooi^KV2_ooool2o`0000;ooooo0_l00019ooooo`;o000000?oooooo`000?l000004?ooool2o`00
0003ooooool0003o000000Cooooo1ooVi^Hbooooo`00;_ooool6o`0000[ooooo1OoVi^H<ooooo`Co
0000BOooool5o`00013ooooo1Ol00006ooooo`Goi^KV<oooool003?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
=?ooool003Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0=Oooool003Cooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0=Oooool0
03Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
05?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0=_ooool003Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=_ooool003Gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0=_ooool003Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0=oooool003Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Gooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0=oooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo05Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool003Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0>?ooool003Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0>Oooool003Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>Ooo
ool003Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo05_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0>_ooool003Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0>_ooool003[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05go
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0>oooool003[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo05gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0>oooool003_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool003_ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?_ooool003cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0000oooooo`00??ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0003oooooo000mooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`1Sooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo0000@?ooool003go
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo06?ooooo00Ko0000oooo
oooooooo0000ooooool00002ooooo`03o`000?oooooooooo03kooooo000mooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`1Sooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0nooooo`00?_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo06Gooooo00Oo0000ooooool0003oooooo`000?oooooo0000047ooooo000noooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0IOooool01ol0003oooooo`000?oo
oooo0000ooooool00000@Oooool003kooooo00?oi^KVo`000?l000000ol0001Xooooo`Goi^KV00?o
0000ooooooooool0@?ooool003gooooo1OoVi^H2o`0006Oooooo1ooVi^I2ooooo`001oooool7o`00
02kooooo0ooVi^H5o`000003onKVi_oooooooooo02kooooo1Ol0000`ooooo`;oi^KV1ol0000`oooo
o`Ko00002oooool000Oooooo0_l00002ooooo`;o0000;oooool2onKViP;o00000_oVi^H2o`000003
onKVi_oooooooooo02oooooo0_l000000ooooooo0000o`00000_ooooo`?oi^KV0_l000001?oVi^Ko
0000o`000?oVi^Haooooo`;o000000?oooooo`000?l000002oooool000Oooooo1_l0000_ooooo`;o
i^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003ooooool0003o000002oo
oooo0ooVi^H2o`000004onKVi_l0003o0000onKViS;ooooo0_l0000=ooooo`002?ooool4o`0000;o
oooo0_l0000/ooooo`;oi^KV0_l00002onKViP;o000000?oi^KVooooooooool0;oooool2o`000003
ooooool0003o000002oooooo0ooVi^H2o`000004onKVi_l0003o0000onKViS?ooooo0_l0000<oooo
o`002?ooool4o`0000Cooooo0ol0000Yooooo`?oi^KV1ol0000`ooooo`;o000000?oooooo`000?l0
0000;oooool3onKViPCo00000_oVi^H[ooooo`?o00000_ooool2o`0000;ooooo0_l0000;ooooo`00
2Oooool2o`0000Sooooo0ol0000Wooooo`Ooi^KV0_ooool2o`0002kooooo0_l000000ooooooo0000
o`00000^ooooo`;o00000_oVi^H2o`0000?oi^KV:Oooool3o`0000Gooooo0_l00002ooooo`;o0000
2oooool000Sooooo0ol0000;ooooo`Co00009?ooool5onKViPGooooo00?o0000ooooooooool0:_oo
ool5o`0002kooooo00Co0000oooooooooooooooo0ol00002onKViRKooooo1?l00009ooooo`Co0000
3?ooool001[ooooo0ol0000/ooooo`;o0000;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?oo
ool3o`0001gooooo000Mooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2
o`0002_ooooo0ol0000Pooooo`008?ooool3o`0002[ooooo00?o0000ooooooooool0:?ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0ol0000Sooooo`008oooool4o`0002Oo
oooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Wooooo`Co00009_ooool002Oooooo
0ol0000Vooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Tooooo`?o0000:_ooool002[ooooo0ol0000Tooooo`;o00009Oooool00ol0003ooooooooo
o`0Sooooo`;o00009?ooool3o`0002gooooo000]ooooo`?o00008oooool2o`0002?ooooo00?o0000
ooooooooool08Oooool2o`0002?ooooo0ol0000`ooooo`00<?ooool3o`0002;ooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0ol0000coooo
o`00<oooool4o`0001oooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Oooooo`Co
0000=_ooool003Oooooo0ol0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0Looooo`?o0000>_ooool003[ooooo0ol0000Looooo`;o00007Ooo
ool00ol0003oooooooooo`0Kooooo`;o00007?ooool3o`0003gooooo000mooooo`?o00006oooool2
o`0001_ooooo00?o0000ooooooooool06Oooool2o`0001_ooooo0ol00010ooooo`00@?ooool4o`00
01Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
01Oooooo1?l00013ooooo`00A?ooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Ko
oooo0_l0000Gooooo`?o0000Aoooool004Oooooo0ol0000Fooooo`;o00005_ooool00ol0003ooooo
ooooo`0Dooooo`;o00005_ooool3o`0004[ooooo001:ooooo`?o00005Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool3o`0004gooooo001=
ooooo`Co00004_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo1?l0001@
ooooo`00DOooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00oooooo0ol0001Dooooo`00E?ooool3o`0000oooooo0_l0000@ooooo`03
o`000?oooooooooo00kooooo0_l0000?ooooo`?o0000Eoooool005Oooooo0ol0000>ooooo`;o0000
3_ooool00ol0003oooooooooo`0<ooooo`;o00003_ooool3o`0005[ooooo001Jooooo`Co00003?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool4o`0005gooooo001Nooooo`?o00002_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool2
o`0000[ooooo0ol0001Qooooo`00HOooool3o`0000Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0001Tooooo`00I?ooool3o`0000Oo
oooo0_l00008ooooo`03o`000?oooooooooo00Kooooo0_l00007ooooo`?o0000Ioooool006Oooooo
0ol00006ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`;o00001_ooool3o`0006[ooooo
001Zooooo`Co00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool4o`0006gooooo001^ooooo`?o00000_ooool2o`0000Goi^KV0_ooool2
o`0000;ooooo0ol0001aooooo`00LOooool3o`000003onKVi_l0003o000000Go000000Coooooo`00
0?l0003o0000M?ooool007?ooooo1?oVi^H2o`0000?oi^KV00?o0000ooooooooool0MOooool007?o
oooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo1?oVi^H2o`0000?oi^KVN?ooool007?ooooo0ooV
i^H5o`000003onKVi_oooooooooo07Kooooo001cooooo`Coi^KV0_l00003onKViWSooooo001doooo
o`Coi^KV0ol0001iooooo`00MOooool5onKViW[ooooo003dooooo`00\
\>"],
  ImageRangeCache->{{{0, 243}, {149.75, 0}} -> {-2.18283, -0.834843, \
0.0181771, 0.00580764}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation and Decapsulation", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Encapsulation - Intro"],

Cell[CellGroupData[{

Cell["Introducory encapsulation example", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
theExpr = 
f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
EncapsulationRules = {};

{encExpr, encPos, encRule} =
exprEncapsulation[theExpr, Templates -> {{{_,_},1}}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({f[A, g[B, g[4], 3], D, h$7040[], 2], {4}, 
      h$7040[] \[RuleDelayed] 
        h[\[ExponentialE], D, B, g[g[A, B]]]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EncapsulationRules", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({h$7040[] \[RuleDelayed] 
        h[\[ExponentialE], D, B, g[g[A, B]]]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exprDecapsulation[encExpr]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
        2], {}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.20018 .30902 -5 -6 ]
[.20018 .30902 5 6 ]
[.20018 .16187 -5 -6 ]
[.20018 .16187 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.52939 .30902 -5 -6 ]
[.52939 .30902 5 6 ]
[.57643 .30902 -5 -6 ]
[.57643 .30902 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.27072 .01472 -5.0625 -6 ]
[.27072 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.62346 .16187 -5 -6 ]
[.62346 .16187 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
gsave
.20018 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20018 .16187 Mdot
0 g
gsave
.20018 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52939 .30902 Mdot
0 g
gsave
.52939 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.57643 .30902 Mdot
0 g
gsave
.57643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
gsave
.27072 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.62346 .16187 Mdot
0 g
gsave
.62346 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{387.812, 239.688},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000630000kb000`400?l00000o`00003ooooooon4
ooooo`00oooooon4ooooo`00oooooon4ooooo`00oooooon4ooooo`00oooooon4ooooo`00oooooon4
ooooo`00oooooon4ooooo`00J?ooool7o`000?oooooo0_ooool5o`0000kooooo001Xooooo`;o0000
0_ooool2o`000?oooooo1?ooool2o`000003ooooool0003o000000gooooo001Xooooo`Ko0000oooo
ool4ooooo`;o000000?oooooo`000?l000003Oooool006Wooooo1?l0003oooooo`Gooooo1?l0000>
ooooo`00JOooool4o`000?oooooo1Oooool2o`000003ooooool0003o000000gooooo001Zooooo`;o
0000ooooool6ooooo`;o000000?oooooo`000?l000003Oooool006Wooooo0ol00008ooooo`?o0000
lOooool3o`0000Gooooo1Ol0000>ooooo`00Moooool2o`000>gooooo0_l0000Kooooo`00NOooool3
o`000>Oooooo0ol0000Mooooo`00O?ooool2o`000>?ooooo0_l0000Pooooo`00O_ooool2o`000=oo
oooo0_l0000Rooooo`00P?ooool3o`000=Wooooo0ol0000Tooooo`00Poooool2o`000=Gooooo0_l0
000Wooooo`00QOooool3o`000<oooooo0ol0000Yooooo`00R?ooool2o`000<_ooooo0_l0000/oooo
o`00R_ooool2o`000<Oooooo0_l0000^ooooo`00S?ooool3o`000<7ooooo0ol0000`ooooo`00Sooo
ool2o`000;gooooo0_l0000cooooo`00TOooool3o`000;Oooooo0ol0000eooooo`00U?ooool2o`00
0;?ooooo0_l0000hooooo`00U_ooool2o`000:oooooo0_l0000jooooo`00V?ooool3o`000:Wooooo
0ol0000looooo`00Voooool2o`000:Gooooo0_l0000oooooo`00WOooool3o`0009oooooo0ol00011
ooooo`00X?ooool2o`0009_ooooo0_l00014ooooo`00X_ooool2o`0009Oooooo0_l00016ooooo`00
Y?ooool3o`00097ooooo0ol00018ooooo`00Yoooool2o`0008gooooo0_l0001;ooooo`00ZOooool3
o`0008Oooooo0ol0001=ooooo`00[?ooool2o`0008?ooooo0_l0001@ooooo`00[_ooool2o`0007oo
oooo0_l0001Booooo`00/?ooool3o`0007Wooooo0ol0001Dooooo`00/oooool2o`0007Gooooo0_l0
001Gooooo`00]Oooool3o`0006oooooo0ol0001Iooooo`00^?ooool2o`0006_ooooo0_l0001Loooo
o`00^_ooool2o`0006Oooooo0_l0001Nooooo`00_?ooool3o`00067ooooo0ol0001Pooooo`00_ooo
ool2o`0005gooooo0_l0001Sooooo`00`Oooool3o`0005Oooooo0ol0001Uooooo`00a?ooool2o`00
05?ooooo0_l0001Xooooo`00a_ooool2o`0004oooooo0_l0001Zooooo`00b?ooool3o`0004Wooooo
0ol0001/ooooo`00boooool2o`0004Gooooo0_l0001_ooooo`00cOooool3o`0003oooooo0ol0001a
ooooo`00d?ooool2o`0003_ooooo0_l0001dooooo`00d_ooool2o`0003Oooooo0_l0001fooooo`00
e?ooool3o`00037ooooo0ol0001hooooo`00eoooool2o`0002gooooo0_l0001kooooo`00fOooool3
o`0002Oooooo0ol0001mooooo`00g?ooool2o`0000kooooo1_oVi^H?ooooo`;o0000P?ooool00=ko
oooo0_l0000:ooooo`[oi^KV2oooool2o`0008;ooooo003Pooooo`?o00001_ooool<onKViPOooooo
0ol00024ooooo`00hoooool2o`0000?ooooo3_oVi^H4ooooo`;o0000Qoooool00>Gooooo0_l00006
onKViPCo00001_oVi^H3o`0008Wooooo003Wooooo`Woi^KV0_l00005onKViXcooooo001@ooooo`Co
0000T_ooool7onKViPGo00001_oVi^J;ooooo`00DOooool2o`0009?ooooo1_oVi^H2o`0000;oi^KV
0_l00006onKViX_ooooo001>ooooo`Ko0000T_ooool6onKViP;o00000_oVi^H2o`0000Koi^KVRooo
ool004kooooo0_l000000ooooooo0000o`00002Cooooo`Koi^KV0_l00002onKViP;o00001_oVi^J;
ooooo`00Coooool4o`0009?ooooo1ooVi^H6o`0000Goi^KVRoooool0053ooooo0ol0002Coooooa;o
i^KVRoooool0057ooooo0_l0002Doooooa3oi^KVS?ooool00>Oooooo4?oVi^J<ooooo`00j?ooool>
onKViXgooooo003Yooooo`coi^KVS_ooool0057ooooo00?o0000ooooooooool0U_ooool:onKViXoo
oooo001Aooooo`03o`000?oooooooooo09Sooooo1_oVi^JAooooo`00DOooool00ol0003ooooooooo
o`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o0000
ooooooooool0TOooool0057ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2Aoooo
o`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03o`00
0?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0057ooooo00?o0000ooooooooool0Vooo
ool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oooooo
oooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0057o
oooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003ooooo
ooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o
0000ooooooooool0TOooool0057ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2A
ooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03
o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0057ooooo00?o0000ooooooooool0
Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oo
oooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0
057ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003o
ooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo
00?o0000ooooooooool0TOooool0057ooooo00?o0000ooooooooool0Voooool00ol0003ooooooooo
o`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aoooo
o`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0057ooooo00?o0000oooooooo
ool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`00
0?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOoo
ool0057ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0
003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_o
oooo00?o0000ooooooooool0TOooool0057ooooo00?o0000ooooooooool0Voooool00ol0003ooooo
ooooo`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001A
ooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0TOooool0057ooooo00?o0000oooo
ooooool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool00ol0003oooooooooo`2Kooooo`03
o`000?oooooooooo097ooooo001Aooooo`03o`000?oooooooooo09_ooooo00?o0000ooooooooool0
TOooool0057ooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`2Aooooo`00DOooool0
0ol0003oooooooooo`2Kooooo`03o`000?oooooooooo097ooooo001>ooooo`Koi^KVV?ooool6onKV
iY7ooooo001<ooooo`[oi^KVU?ooool:onKViXoooooo001;ooooo`coi^KVT_ooool<onKViXkooooo
001:ooooo`koi^KVT?ooool>onKViXgooooo0019ooooo`Koi^KV1?l00006onKViXkooooo1_oVi^H4
o`0000Koi^KVS?ooool004Wooooo2OoVi^H2o`0000Goi^KVS_ooool9onKViP;o00001OoVi^J<oooo
o`00=?ooool5o`0000oooooo1ooVi^H5o`0000Koi^KV3oooool4o`0004_ooooo1?l0000=ooooo`Go
00003?ooool5o`0000Oooooo1ooVi^H5o`0000Koi^KVRoooool003Gooooo0_l000000ooooooo0000
o`00000>ooooo`Koi^KV0_l00002onKViP;o00001_oVi^H>ooooo`;o00000_ooool2o`0004Wooooo
00?o0000ooooool000004?ooool2o`000003ooooool0003o000000cooooo0_l000000ooooooo0000
o`000006ooooo`Koi^KV0_l00002onKViP;o00001_oVi^J;ooooo`00=Oooool2o`000003ooooool0
003o000000kooooo1_oVi^H2o`0000;oi^KV0_l00006onKViQ;ooooo0_l00019ooooo`03o`000?oo
oooo000000;o00003_ooool2o`000003ooooool0003o000000cooooo0_l000000ooooooo0000o`00
0006ooooo`Koi^KV0_l00002onKViP;o00001_oVi^J;ooooo`00=Oooool4o`0000oooooo1_oVi^H2
o`0000;oi^KV0_l00006onKViQ3ooooo0ol0001:ooooo`05o`000?oooooo0000ooooool000003_oo
ool2o`000003ooooool0003o000000cooooo1?l00007ooooo`Koi^KV0_l00002onKViP;o00001_oV
i^J;ooooo`00=Oooool2o`000003ooooool0003o000000kooooo1ooVi^H6o`0000Goi^KV4_ooool2
o`0004[ooooo0ol0000?ooooo`;o000000?oooooo`000?l000003?ooool2o`000003ooooool0003o
000000Kooooo1ooVi^H6o`0000Goi^KVRoooool003Gooooo0_l000000ooooooo0000o`00000>oooo
oa;oi^KV3_ooool2o`0000;ooooo0_l0001Looooo`;o000000?oooooo`000?l000003?ooool2o`00
0003ooooool0003o000000Kooooo4_oVi^J;ooooo`00=?ooool5o`00013ooooo4?oVi^H@ooooo`Co
0000G?ooool5o`0000cooooo1Ol00008oooooa3oi^KVS?ooool004Wooooo4?oVi^J>oooooa3oi^KV
S?ooool004[ooooo3_oVi^J@ooooo`koi^KVSOooool004_ooooo3?oVi^JBooooo`coi^KVS_ooool0
04cooooo2_oVi^JDooooo`[oi^KVSoooool003[ooooo00?o0000ooooooooool04Oooool6onKViQ?o
oooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Zooooo`03o`000?oVi^Koi^KV00Co
i^KVTOooool003_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo05Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0UOooool003_ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo05Kooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0U_oo
ool003cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo05Oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0U_ooool003cooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo05Sooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Uoooool003go
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo05Wo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool0Uoooool003gooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo05[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0V?ooool003kooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo05_ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0V?ooool003kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0VOooool003oooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo05gooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0VOooool003oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo05kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0V_ooool0043ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
V_ooool0043ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo063ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0Voooool0047ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Voooool0
047ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
06;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0W?ooool004;ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0W?ooool004;ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo06Cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0WOooool004?ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0WOooool004?ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0W_ooool004Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo06Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0W_ooool004Cooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo06Oooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0W_ooool004Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo06Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0Woooool004Gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Wooo
ool004Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo06[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0X?ooool004Kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0X?ooool004Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0XOooool004Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0XOooool004Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo06kooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0X_ooool004Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0X_ooool004Sooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo073ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Xoooool004Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo077ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0Xoooool004Wooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo07;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
Y?ooool004[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo07?ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00?o0000ooooooooool0Y?ooool004[ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo07Cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0YOooool004_ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo07Gooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000Yoooool004_ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo07Kooooo00Go0000oooooooooooo
ooooo`000003ooooo`04o`000?ooooooooooo`000:Sooooo001<ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1gooooo`04o`000?ooooooooooo`00
00?ooooo00Co0000oooooooooooo0000Z?ooool004cooooo00?o0000ooooooooool00_ooool01Ol0
003ooooooooooooooooo000007[ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0002Yooooo`00COooool00ol0003oi^KVonKViP04onKViP03ooooool0003ooooo07[ooooo00?o
0000onKVi_oVi^H01?oVi^H00ooooooo0000ooooo`2Xooooo`00C?ooool:onKViW[ooooo2_oVi^JY
ooooo`00Boooool<onKViWSooooo3?oVi^JXooooo`00B_ooool>onKViWKooooo3_oVi^JWooooo`00
BOooool6onKViPCo00001_oVi^Idoooooa3oi^KVY_ooool004Wooooo2OoVi^H2o`0000Goi^KVM?oo
ool@onKViZKooooo000<ooooo`Oo0000=Oooool7onKViPGo00001_oVi^Hfooooo`Go0000=oooool6
onKViPOo00001OoVi^Hfooooo`Ko0000JOooool000cooooo0_l00002ooooo`;o0000=_ooool6onKV
iP;o00000_oVi^H2o`0000Koi^KV=oooool2o`000003ooooool0003o000003Kooooo1ooVi^H2o`00
0003onKVi_l0003o000000Koi^KV=oooool2o`000003ooooool0003o000006Wooooo000<ooooo`Ko
0000=_ooool6onKViP;o00000_oVi^H2o`0000Koi^KV=oooool2o`000003ooooool0003o000003Ko
oooo1ooVi^H2o`000003onKVi_l0003o000000Koi^KV>?ooool2o`0006_ooooo000=ooooo`Co0000
=oooool6onKViP;o00000_oVi^H2o`0000Koi^KV=oooool2o`000003ooooool0003o000003Kooooo
1ooVi^H2o`000003onKVi_l0003o000000Koi^KV>Oooool2o`0006[ooooo000=ooooo`Co0000=ooo
ool7onKViPKo00001OoVi^Hgooooo`;o000000?oooooo`000?l00000=_ooool7onKViPCo00001ooV
i^Hfooooo`;o00000_ooool2o`0006Wooooo000>ooooo`;o0000>?oooolBonKViSOooooo0_l00000
0ooooooo0000o`00000fooooo`Ooi^KV0_l00009onKViSKooooo0_l00002ooooo`;o0000JOooool0
00gooooo0ol00008ooooo`?o0000;_ooool@onKViSOooooo1Ol0000hooooo`Goi^KV0ol00008onKV
iRoooooo0ol00006ooooo`Co0000J_ooool001_ooooo0_l0000/oooooa3oi^KVM?ooool@onKViRgo
oooo0_l0001gooooo`007Oooool3o`0002[ooooo3_oVi^H00ooooooo0000ooooo`1booooo`03o`00
0?oVi^Koi^KV00coi^KV:oooool3o`0007Wooooo000Pooooo`;o0000:Oooool<onKViP?ooooo00?o
0000ooooooooool0Koooool00ol0003oooooooooo`0<onKViR[ooooo0_l0001looooo`008_ooool2
o`0002Sooooo2_oVi^H5ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00_ooool:
onKViRWooooo0_l0001nooooo`009?ooool3o`0002Oooooo1_oVi^H8ooooo`03o`000?oooooooooo
06_ooooo00?o0000ooooooooool01Oooool6onKViRSooooo0ol00020ooooo`009oooool2o`0003Co
oooo0_l0000dooooo`03o`000?oooooooooo03;ooooo0_l0000dooooo`;o0000Poooool002Wooooo
0ol0000cooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0aooooo`?o0000QOooool002cooooo0_l0000booooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`;o0000R?ooool002kooooo0_l0000a
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_
ooooo`;o0000R_ooool0033ooooo0ol0000_ooooo`03o`000?oooooooooo02kooooo00?o0000oooo
ooooool0;_ooool00ol0003oooooooooo`0]ooooo`?o0000S?ooool003?ooooo0_l0000^ooooo`;o
0000;_ooool00ol0003oooooooooo`0/ooooo`;o0000;_ooool2o`0008oooooo000eooooo`?o0000
;Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
:oooool3o`00097ooooo000hooooo`;o0000;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool0:_ooool2o`0009Cooooo000jooooo`;o0000:oooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0:Oooool2
o`0009Kooooo000looooo`?o0000:Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
02Sooooo00?o0000ooooooooool09oooool3o`0009Sooooo000oooooo`;o0000:?ooool2o`0002So
oooo00?o0000ooooooooool09_ooool2o`0002Sooooo0_l0002Kooooo`00@Oooool3o`0002Oooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo
0ol0002Mooooo`00A?ooool2o`0002Kooooo00?o0000ooooooooool09?ooool00ol0003ooooooooo
o`0Tooooo`03o`000?oooooooooo02Cooooo0_l0002Pooooo`00A_ooool2o`0002Gooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo0_l0002R
ooooo`00B?ooool3o`0002?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo027ooooo0ol0002Tooooo`00Boooool2o`0002;ooooo0_l0000Rooooo`03
o`000?oooooooooo023ooooo0_l0000Rooooo`;o0000Yoooool004gooooo0ol0000Qooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`?o0000
ZOooool0053ooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`0Nooooo`;o0000[?ooool005;ooooo0_l0000Oooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Mooooo`;o0000[_ooool0
05Cooooo0ol0000Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Kooooo`?o0000/?ooool005Oooooo0_l0000Looooo`;o00007?ooool00ol0003o
ooooooooo`0Jooooo`;o00007?ooool2o`000;?ooooo001Iooooo`?o00006oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool3o`000;Gooooo
001Looooo`;o00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool06?ooool2o`000;Sooooo001Nooooo`;o00006Oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool2o`000;[ooooo001Poooo
o`?o00005oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool05Oooool3o`000;cooooo001Sooooo`;o00005_ooool2o`0001Kooooo00?o0000oooooooo
ool05?ooool2o`0001Kooooo0_l0002oooooo`00IOooool3o`0001Gooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0ol00031ooooo`00J?oo
ool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo0_l00034ooooo`00J_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0_l00036ooooo`00K?ooool3o`00
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
00oooooo0ol00038ooooo`00Koooool2o`00013ooooo0_l0000@ooooo`03o`000?oooooooooo00ko
oooo0_l0000@ooooo`;o0000boooool0077ooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`?o0000cOooool007Cooooo0_l0
000>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`;o0000d?ooool007Kooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000d_ooool007Sooooo0ol0000;oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09oooo
o`?o0000e?ooool007_ooooo0_l0000:ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`;o
00002_ooool2o`000=Oooooo001mooooo`?o00002Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01oooool3o`000=Wooooo0020ooooo`;o00002?oo
ool00ol0003oooooooooo`03ooooo`Koi^KV1_ooool00ol0003oooooooooo`06ooooo`;o0000g?oo
ool008;ooooo0_l00007ooooo`03o`000?oooooooooo00[oi^KV0oooool00ol0003oooooooooo`05
ooooo`;o0000g_ooool008Cooooo0ol00005ooooo`03o`000?oVi^Koi^KV00[oi^KV00?oooooo`00
0?ooool01?ooool3o`000>3ooooo0027ooooo`;o00000oooool>onKViPCooooo0_l0003Sooooo`00
ROooool2o`00013oi^KV0ol0003Uooooo`00Roooool@onKVi^Sooooo002:ooooo`Koi^KV1_l00006
onKVi^Oooooo002:ooooo`Soi^KV0_l00008onKVi^Oooooo002:ooooo`Soi^KV0_l00008onKVi^Oo
oooo002:ooooo`Soi^KV0_l00008onKVi^Oooooo002:ooooo`Ooi^KV1Ol00006onKVi^Oooooo002:
ooooo`Soi^KV0_l00008onKVi^Oooooo002;ooooo`Soi^KV0ol00005onKVi^Sooooo002;oooooa3o
i^KVj?ooool008cooooo3_oVi^KYooooo`00SOooool<onKVi^[ooooo002>ooooo`[oi^KVjoooool0
093ooooo1_oVi^K]ooooo`00\
\>"],
  ImageRangeCache->{{{0, 386.812}, {238.688, 0}} -> {-2.23398, -0.833976, \
0.01517, 0.00363639}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of encapsulated exprressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
encChromos = Join @@ Table[
Encapsulation[theChromos, 
  Templates -> {{{_, _}, 1}},
  SelectionMode -> RANDOM], {10}]

encChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g$7263[]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g$7283[], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]], chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g$7303[]]], 2]]], 
      chromo[q[undef], p[f$7323[]]], chromo[q[undef], p[f$7343[]]], 
      chromo[q[undef], p[f$7363[]]], 
      chromo[q[undef], 
        p[f[A, g[B, g$7383[], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]], chromo[q[undef], p[f$7403[]]], 
      chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$7423[], 2]]], 
      chromo[q[undef], 
        p[f[A, g$7443[], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g$7263[]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g$7283[], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g$7303[]]], 
                  2]]]\)},
          {\(chromo[q[undef], p[f$7323[]]]\)},
          {\(chromo[q[undef], p[f$7343[]]]\)},
          {\(chromo[q[undef], p[f$7363[]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g$7383[], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], p[f$7403[]]]\)},
          {\(chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$7423[], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g$7443[], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g$7263[ ]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g$7283[ ], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g$7303[ ]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f$7323[ ]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f$7343[ ]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f$7363[ ]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g$7383[ ], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f$7403[ ]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h$7423[ ], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g$7443[ ], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> True,
            LabelSize -> 0.05, LabelColor -> 1
]& /@ encChromos;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.2619 .21092 -5 -6 ]
[.2619 .21092 5 6 ]
[.2619 .01472 -5 -6 ]
[.2619 .01472 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.66907 .21092 -5 -6 ]
[.66907 .21092 5 6 ]
[.71509 .21092 -5 -6 ]
[.71509 .21092 5 6 ]
[.7611 .21092 -5 -6 ]
[.7611 .21092 5 6 ]
[.80712 .21092 -20 -6 ]
[.80712 .21092 20 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
gsave
.2619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .01472 Mdot
0 g
gsave
.2619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
gsave
.66907 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .21092 Mdot
0 g
gsave
.71509 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .21092 Mdot
0 g
gsave
.7611 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.80712 .21092 Mdot
0 g
gsave
.80712 .21092 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7263) show
1.000 setlinewidth
grestore
1 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00IOooool4o`000?oooooo5oooool006Kooooo0_l0003ooooooaSooooo001Sooooo`Ko0000
oooooolGooooo`00Hoooool2o`000003ooooool0003o00000?oooooo6?ooool006Cooooo1?l0003o
oooooaSooooo001Uooooo`?o0000oooooolHooooo`00I_ooool2o`000?oooooo6?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool006Cooooo1?l0002hooooo`Co
0000Foooool006Oooooo0_l0002jooooo`;o00000oooool2o`0005Gooooo0019ooooo`Go00005_oo
ool5o`0001Gooooo1?l0001jooooo`Co00003?ooool5o`0000cooooo2?l00002ooooo`Co00001?oo
ool2o`0000?ooooo1_l00002ooooo`Co00000oooool4o`0003Sooooo001:ooooo`;o000000?ooooo
o`000?l000005?ooool2o`0000;ooooo0_l0000Dooooo`;o00000_ooool2o`0007Sooooo00?o0000
ooooool000003oooool2o`000003ooooool0003o000000cooooo1ol000000ooooooo0000o`000004
o`0000?ooooo0_l00004ooooo`;o000000Coooooo`000?l0003ooooo0_l00002ooooo`;o000000?o
ooooo`000?l000000_ooool2o`0003Oooooo001:ooooo`;o000000?oooooo`000?l000005?ooool2
o`0000;ooooo0_l0000Hooooo`;o0000N?ooool00ol0003oooooo`000002o`0000gooooo0_l00000
0ooooooo0000o`00000<ooooo`Oo00000oooool4o`0000Cooooo0_l00004ooooo`;o00000oooool2
o`0000;ooooo0_l00005ooooo`;o0000=oooool004[ooooo1?l0000Eooooo`;o00000_ooool2o`00
01Kooooo0ol0001iooooo`05o`000?oooooo0000ooooool000003Oooool2o`000003ooooool0003o
000000cooooo1?l000000ooooooo0000o`000002ooooo`Co00001Oooool2o`0000Gooooo0_l00002
ooooo`Go00001?ooool3o`0003Sooooo001:ooooo`;o000000?oooooo`000?l000005Oooool6o`00
01Oooooo0_l0001iooooo`?o00003_ooool2o`000003ooooool0003o000000cooooo3?l00007oooo
o`;o000000?oooooo`000?l000000_ooool2o`000003ooooool0003o000000Wooooo0_l0000goooo
o`00B_ooool2o`000003ooooool0003o000002kooooo0_l00002ooooo`;o0000R_ooool2o`000003
ooooool0003o000000cooooo0_l000000ooooooo0000o`000003ooooo`Ko000000?oooooo`000?l0
00000_ooool2o`000003ooooool0003o000000;ooooo0_l00002ooooo`;o00001?ooool2o`0000;o
oooo0_l0000gooooo`00BOooool5o`00033ooooo1?l0002:ooooo`Go00003?ooool5o`0000Gooooo
1?l00002ooooo`Ko00000_ooool4o`0000Cooooo0ol00003ooooo`Co0000>?ooool00?oooooo:Ooo
ool2o`0005Gooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003oooooo`;ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1>ooooo`00Coooool00ol0003ooooooooo
o`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0POooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1>ooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Poooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`1?ooooo`00D?ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1?oooo
o`00D?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0Poooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`1?ooooo`00DOooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1@ooooo`00DOoo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0QOoo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1@ooooo`00D_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1@ooooo`00D_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Qoooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`1Aooooo`00D_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Aooooo`00Doooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0ROooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1Aooooo`00Doooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool0ROooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`1Booooo`00Doooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1B
ooooo`00E?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0Roooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`1Booooo`00E?ooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Cooooo`00
E?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
Roooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Cooooo`00EOooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Cooooo`00EOooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0SOooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`1Dooooo`00EOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Dooooo`00E_ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Soooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`1Dooooo`00E_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0Soooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1Eooooo`00Eoooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0TOooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1Eooooo`00Eoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1Eooooo`00Eoooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Foooo
o`00F?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0Toooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1Fooooo`00F?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Fooooo`00F?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Tooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`1Gooooo`00FOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Gooooo`00FOooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0UOooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`1Hooooo`00FOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Hooooo`00F_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Uoooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1Hooooo`00F_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0Uoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`1Iooooo`00F_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1I
ooooo`00Foooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0VOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`1Iooooo`00Foooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Jooooo`00
Foooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
VOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`1Jooooo`00G?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Jooooo`00G?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Voooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`1Kooooo`00GOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Kooooo`00GOooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0WOooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`1Kooooo`00GOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0WOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Looooo`00G_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Woooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`1Looooo`00G_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0Woooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`1Looooo`00G_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Moooo
o`00Goooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0XOooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`1Mooooo`00Goooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`1Mooooo`00Goooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`1Nooooo`00H?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Xoooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Pooooo`00H?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Xoooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00001Pooooo`00H?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Xoooool0
1Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooooooo0000HOooool0067ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:Gooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool0001Qooooo`00HOooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0YOooool01?l0003ooooo
ooooool00002ooooo`05o`000?ooooooooooooooool00000HOooool006;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo0:Oooooo00?o0000ooooool000000_ooool01?l0
003oooooooooool0001Rooooo`00H_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool0Yoooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool0
H?ooool006;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0:Oooooo
00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo063ooooo001Sooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0ZOooool01ol0003oooooo`000?oooooo
0000ooooool00000Hoooool006Wooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`1Q
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00I?ooool4o`000?oooooo6?oo
ool006Oooooo0_l0003ooooooaOooooo000:ooooo`Oo0000Doooool5o`0005?ooooo1Ol0001Doooo
o`Oo0000DOooool6o`0000cooooo000:ooooo`;o00000_ooool2o`0005?ooooo0_l00002ooooo`;o
0000E?ooool2o`000003ooooool0003o000005Cooooo0_l000000ooooooo0000o`00001Cooooo`;o
000000?oooooo`000?l000003?ooool000[ooooo1_l0001Cooooo`;o00000_ooool2o`0005Cooooo
0_l000000ooooooo0000o`00001Dooooo`;o000000?oooooo`000?l00000E?ooool2o`0000kooooo
000;ooooo`Co0000E?ooool2o`0000;ooooo0_l0001Dooooo`;o000000?oooooo`000?l00000E?oo
ool2o`000003ooooool0003o000005Gooooo0_l0000=ooooo`002oooool4o`0005Gooooo1_l0001C
ooooo`;o000000?oooooo`000?l00000E?ooool4o`0005?ooooo0_l00002ooooo`;o00003?ooool0
00cooooo0_l0002_ooooo`;o000000?oooooo`000?l00000E?ooool2o`0005Gooooo0_l00002oooo
o`;o00003?ooool000_ooooo0ol00009ooooo`;o0000Xoooool5o`0005Cooooo0ol0001=ooooo`?o
00001_ooool4o`0000gooooo000Iooooo`;o0000oooooom9ooooo`;o00006_ooool001_ooooo0ol0
001@ooooo`03o`000?oooooooooo09oooooo00?o0000ooooooooool0COooool3o`0001cooooo000N
ooooo`;o0000Coooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo04cooooo0_l0000O
ooooo`008?ooool3o`0004gooooo00?o0000ooooooooool0Voooool00ol0003oooooooooo`1:oooo
o`?o00008Oooool002?ooooo0_l0001<ooooo`;o0000VOooool2o`0004_ooooo0_l0000Tooooo`00
9Oooool3o`0004_ooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo04Wooooo0_l0000Vooooo`00:?ooool2o`0004[ooooo00?o0000ooooooooool0B?oo
ool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04Oooooo0ol0000Xooooo`00:_ooool2
o`0004Wooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`17ooooo`03o`000?oooooo
oooo04Kooooo0_l0000[ooooo`00;?ooool3o`0004Oooooo00?o0000ooooooooool0A_ooool00ol0
003oooooooooo`16ooooo`03o`000?oooooooooo04Cooooo0ol0000]ooooo`00;oooool2o`0004Ko
oooo0_l00016ooooo`03o`000?oooooooooo04Cooooo0_l00015ooooo`;o0000<?ooool0037ooooo
0ol00015ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0@oooool00ol0003ooooo
ooooo`12ooooo`?o0000<_ooool003Cooooo0_l00014ooooo`03o`000?oooooooooo04;ooooo00?o
0000ooooooooool0@_ooool00ol0003oooooooooo`11ooooo`;o0000=Oooool003Kooooo0ol00012
ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`10
ooooo`;o0000=oooool003Wooooo0_l00011ooooo`;o0000@Oooool00ol0003oooooooooo`0ooooo
o`;o0000@?ooool3o`0003Wooooo000kooooo`?o0000@?ooool00ol0003oooooooooo`0nooooo`03
o`000?oooooooooo03kooooo00?o0000ooooooooool0?_ooool2o`0003cooooo000nooooo`;o0000
?oooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0
??ooool3o`0003kooooo0010ooooo`;o0000?_ooool00ol0003oooooooooo`0looooo`03o`000?oo
oooooooo03cooooo00?o0000ooooooooool0>oooool2o`00047ooooo0012ooooo`?o0000??ooool0
0ol0003oooooooooo`0kooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0>Oooool3
o`0004?ooooo0015ooooo`;o0000>oooool2o`0003_ooooo00?o0000ooooooooool0>Oooool2o`00
03[ooooo0_l00016ooooo`00Aoooool3o`0003[ooooo00?o0000ooooooooool0>?ooool00ol0003o
ooooooooo`0hooooo`03o`000?oooooooooo03Sooooo0_l00018ooooo`00B_ooool2o`0003Wooooo
00?o0000ooooooooool0=oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo03Kooooo
0ol0001:ooooo`00C?ooool3o`0003Oooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`0fooooo`03o`000?oooooooooo03Gooooo0_l0001=ooooo`00Coooool2o`0003Kooooo0_l0000f
ooooo`03o`000?oooooooooo03Cooooo0_l0000eooooo`?o0000Coooool0057ooooo0_l0000foooo
o`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`0coooo
o`;o0000D_ooool005?ooooo0ol0000dooooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0aooooo`?o0000E?ooool005Kooooo0_l0000cooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0`ooooo`;o0000
Eoooool005Sooooo0ol0000aooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0_ooooo`;o0000FOooool005_ooooo0_l0000`ooooo`;o0000<?ooool0
0ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005_ooooo001Mooooo`?o0000;oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;Oooool2o`00
05kooooo001Pooooo`;o0000;_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02co
oooo00?o0000ooooooooool0:oooool3o`00063ooooo001Rooooo`?o0000;?ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:_ooool2o`0006?ooooo
001Uooooo`;o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2o`0002[ooooo0ol0
001Uooooo`00Ioooool2o`0002_ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0X
ooooo`03o`000?oooooooooo02Sooooo0_l0001Xooooo`00JOooool3o`0002Wooooo00?o0000oooo
ooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo0_l0001Zoooo
o`00K?ooool2o`0002Sooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo02Gooooo0ol0001/ooooo`00K_ooool3o`0002Kooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Cooooo0_l0001_ooooo`00LOoo
ool2o`0002Gooooo0_l0000Uooooo`03o`000?oooooooooo02?ooooo0_l0000Tooooo`?o0000LOoo
ool007?ooooo0ol0000Tooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0Rooooo`;o0000M?ooool007Kooooo0_l0000Sooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`;o0000M_ooool007So
oooo0ol0000Qooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`0Oooooo`?o0000N?ooool007_ooooo0_l0000Pooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0Nooooo`;o0000Noooool007gooooo0_l0
000Oooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`;o00007_ooool3o`0007gooooo001o
ooooo`?o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool07?ooool2o`00083ooooo0022ooooo`;o00007Oooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06_ooool3o`0008;ooooo0024ooooo`?o
00006oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool06Oooool2o`0008Gooooo0027ooooo`;o00006_ooool2o`0001[ooooo00?o0000ooooooooool0
6?ooool2o`0001[ooooo0_l00027ooooo`00ROooool3o`0001Wooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oooooo0ol00029ooooo`00S?ooool2
o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo01Kooooo0_l0002<ooooo`00S_ooool2o`0001Oooooo00?o0000ooooooooool05Oooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo0ol0002>ooooo`00T?ooool3o`0001Go
oooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01?o
oooo0_l0002Aooooo`00Toooool2o`0001Cooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`?o0000Toooool009Gooooo0ol0000Cooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`;o0000U_ooool009Sooooo0_l0000B
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@
ooooo`;o0000V?ooool009[ooooo0ol0000@ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0>ooooo`?o0000V_ooool009gooooo0_l0000?ooooo`;o
00003oooool00ol0003oooooooooo`0=ooooo`;o00003oooool2o`0009gooooo002Oooooo`?o0000
3_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3?ooool3o`0009oooooo002Rooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02oooool2o`000:;ooooo002Tooooo`;o00003?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool3
o`000:Cooooo002Vooooo`?o00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02?ooool2o`000:Oooooo002Yooooo`;o00002Oooool2o`0000Wo
oooo00?o0000ooooooooool01oooool2o`0000Wooooo0_l0002Yooooo`00Zoooool3o`0000Sooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`06ooooo`?o0000Zoooool00:kooooo0_l0
0007ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01Oooool2o`000:kooooo002`
ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo0ol0002`
ooooo`00/oooool2o`0001Gooooo0_l0002cooooo`00]Oooool2o`00013ooooo0ol0002eooooo`00
oooooon0ooooo`00_?ooool6o`000;gooooo002nooooo`;o0000_oooool00;kooooo0_l0002ooooo
o`00__ooool2o`000;oooooo002mooooo`Go0000_Oooool00;kooooo0_l0002oooooo`00_oooool3
o`000;gooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003o
oooooh3ooooo0000\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.15638, -0.620386, \
0.0112641, 0.00273386}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -20 -6 ]
[.25889 .30902 20 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7283) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00j?ooool7o`0007gooooo1Ol0000>ooooo`00j?ooool2o`0000;ooooo
0_l0001oooooo`;o000000?oooooo`000?l000003Oooool00>Sooooo1_l0001oooooo`;o000000?o
ooooo`000?l000003Oooool00>Wooooo1?l00020ooooo`Co00003_ooool00>Wooooo1?l00020oooo
o`;o000000?oooooo`000?l000003Oooool00>[ooooo0_l00021ooooo`;o000000?oooooo`000?l0
00003Oooool00>Wooooo0ol00020ooooo`Go00003_ooool00?ooooooP?ooool00??ooooo00?o0000
ooooooooool0LOooool00ol0003oooooooooo`0Eooooo`00m?ooool00ol0003oooooooooo`1_oooo
o`03o`000?oooooooooo01Kooooo003eooooo`03o`000?oooooooooo06gooooo00?o0000oooooooo
ool05oooool00?Kooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Hooooo`00mooo
ool2o`0006Wooooo0_l0000Kooooo`00nOooool00ol0003oooooooooo`1Uooooo`03o`000?oooooo
oooo01_ooooo003jooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool07?ooool00?_o
oooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Mooooo`00o?ooool00ol0003ooooo
ooooo`1Oooooo`03o`000?oooooooooo01kooooo003mooooo`;o0000GOooool2o`00027ooooo003o
ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool08Oooool00?oooooo0Oooool00ol0
003oooooooooo`1Gooooo`03o`000?oooooooooo02;ooooo003oooooo`;ooooo00?o0000oooooooo
ool0EOooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool2o`00057ooooo0_l0000Wooooo`00ooooool6
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool09oooool00?oooooo1oooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo02Sooooo003oooooo`Sooooo00?o0000oooooooo
ool0BOooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool2o`0004Gooooo0_l0000]ooooo`00ooooool<
ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0;Oooool00?oooooo3Oooool00ol0
003oooooooooo`0oooooo`03o`000?oooooooooo02kooooo003oooooo`kooooo00?o0000oooooooo
ool0?Oooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03_ooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool2o`0003Wooooo0_l0000cooooo`00oooooolB
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0<oooool00?oooooo4oooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo03Cooooo003ooooooaCooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool2o`0002gooooo0_l0000iooooo`00oooooolH
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0>Oooool00?oooooo6Oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo03[ooooo003ooooooa[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool0??ooool00?oooooo7?ooool2o`00027ooooo0_l0000oooooo`00oooooolN
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0?oooool00?oooooo7oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo043ooooo003oooooob3ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool0@_ooool00?oooooo8_ooool2o`0001Gooooo0_l00015ooooo`00oooooolT
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0AOooool00?oooooo9Oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo04Kooooo003oooooobKooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`17ooooo`00oooooolWooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0B?ooool00?ooooooP?ooool00?oooooo;?ooool4o`00053ooooo003ooooo
oboooooo0_l0001?ooooo`00ooooool/ooooo`Go0000Coooool00?oooooo:oooool2o`0000;ooooo
0_l0001?ooooo`00ooooool[ooooo`;o00000_ooool2o`0004oooooo003oooooob_ooooo0_l00002
ooooo`;o0000Coooool00?oooooo;?ooool6o`0004kooooo003ooooooh3ooooo003ooooooh3ooooo
003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
001Eooooo`Co0000d_ooool4o`00053ooooo001Hooooo`;o00000oooool2o`000<oooooo0_l0001?
ooooo`00B_ooool5o`0000Kooooo1Ol00002ooooo`Co00001?ooool2o`0000?ooooo1_l00002oooo
o`Co00002?ooool4o`0007Oooooo1?l0000<ooooo`Go00003?ooool5o`0000gooooo1Ol0001?oooo
o`00Boooool2o`000003ooooool0003o000000Cooooo0_l00002ooooo`;o000000?oooooo`000?l0
00001?l00003ooooo`;o00001?ooool2o`000004ooooool0003o0000ooooo`;o00000_ooool2o`00
00Kooooo0_l00002ooooo`;o0000MOooool00ol0003oooooo`00000?ooooo`;o000000?oooooo`00
0?l000003?ooool2o`000003ooooool0003o000000_ooooo0_l00002ooooo`;o0000Coooool004_o
oooo0_l000000ooooooo0000o`000004ooooo`;o00000_ooool2o`0000?ooooo1?l00004ooooo`;o
00001?ooool2o`0000?ooooo0_l00002ooooo`;o00002_ooool2o`0007Gooooo00?o0000ooooool0
00000_l0000=ooooo`;o000000?oooooo`000?l000003?ooool2o`000003ooooool0003o000000_o
oooo0_l00002ooooo`;o0000Coooool004_ooooo1?l00005ooooo`;o00000_ooool2o`0000;ooooo
1?l00005ooooo`;o00001Oooool2o`0000?ooooo1?l00009ooooo`?o0000M_ooool01Ol0003ooooo
o`000?oooooo000000gooooo0_l000000ooooooo0000o`00000<ooooo`Co00003?ooool2o`0000;o
oooo0_l0001?ooooo`00Boooool2o`000003ooooool0003o000000Gooooo2_l00007ooooo`;o0000
00?oooooo`000?l000000_ooool2o`000003ooooool0003o000000;ooooo0_l0000:ooooo`;o0000
M_ooool3o`0000kooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?oooooo`000?l00000
3?ooool6o`0004kooooo001;ooooo`;o000000?oooooo`000?l000002oooool6o`000003ooooool0
003o000000;ooooo0_l000000ooooooo0000o`000002ooooo`;o000000?oooooo`000?l000000_oo
ool2o`0000Kooooo0_l00002ooooo`;o0000Qoooool2o`000003ooooool0003o000000cooooo0_l0
00000ooooooo0000o`00001Pooooo`00B_ooool5o`0000gooooo1?l00002ooooo`Ko00000_ooool4
o`0000?ooooo1?l00008ooooo`Co0000Qoooool5o`0000cooooo1Ol0001Qooooo`00GOooool2o`00
0?oooooo8Oooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool0057ooooo00?o0000
ooooooooool09oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo02Sooooo00?o0000
ooooooooool0Doooool0057ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Doooool005;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo08;ooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0E?ooool005;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo08;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0E?ooool005?ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo08Cooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0EOoo
ool005?ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo08Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0EOooool005Cooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo08Kooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0E_ooool005Co
oooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo08Ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0E_ooool005Gooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo08Sooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Eoooool005Gooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo08Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0Eoooool005Gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Eoooool005Kooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo08[ooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0F?ooool005Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo08_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0F?ooool005Oooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
FOooool005Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo08gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0FOooool005Sooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo08kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0F_ooool0
05Sooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
08oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0F_ooool005Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo093ooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Foooool005Wooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo097ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0Foooool005[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo09;ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0G?ooool005[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0G?ooool005[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo09?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0G?ooool005_ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo09Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0GOooool005_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo09Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0GOooool005cooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo09Kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0G_oo
ool005cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo09Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0G_ooool005gooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo09Sooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Goooool005go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo09Wo
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Goooool005kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0H?ooool005kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo09_ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0H?ooool005oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0HOooool005oooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo09gooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0HOooool0
05oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
09gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool0HOooool0063ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo09oooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000I?ooool0063ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo09oooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000I?ooool0067ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo0:7ooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool0001Uooooo`00HOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0XOooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`00
06Gooooo001Rooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Xoooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo06Cooooo003ooooooh3ooooo003ooooooh3ooooo003o
oooooh3ooooo003ooooooh3ooooo001Tooooo`Co0000oooooolHooooo`00Ioooool2o`000?oooooo
5oooool000cooooo1ol0001Aooooo`Go0000DOooool5o`0005;ooooo1ol0001@ooooo`Ko00004Ooo
ool000cooooo0_l00002ooooo`;o0000DOooool2o`0000;ooooo0_l0001Booooo`;o000000?ooooo
o`000?l00000D_ooool2o`000003ooooool0003o000005;ooooo0_l000000ooooooo0000o`00000A
ooooo`003?ooool6o`00057ooooo0_l00002ooooo`;o0000D_ooool2o`000003ooooool0003o0000
05;ooooo0_l000000ooooooo0000o`00001Cooooo`;o00004oooool000gooooo1?l0001Booooo`;o
00000_ooool2o`0005;ooooo0_l000000ooooooo0000o`00001Booooo`;o000000?oooooo`000?l0
0000E?ooool2o`0001;ooooo000=ooooo`Co0000Doooool6o`00057ooooo0_l000000ooooooo0000
o`00001Booooo`Co0000D_ooool2o`0000;ooooo0_l0000Aooooo`003_ooool2o`0000Sooooo0ol0
002Pooooo`;o000000?oooooo`000?l00000D_ooool2o`0004cooooo0ol00005ooooo`;o00000_oo
ool2o`00017ooooo000=ooooo`?o00002oooool4o`0009_ooooo1Ol0001Booooo`?o0000B?ooool4
o`0000Wooooo1?l0000Booooo`007oooool3o`0004cooooo0_l0002Kooooo`;o0000C?ooool3o`00
02?ooooo000Rooooo`?o0000Boooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo04Wo
oooo0ol0000Vooooo`009Oooool3o`0004Wooooo0_l0002Eooooo`;o0000BOooool3o`0002Wooooo
000Xooooo`?o0000B?ooool2o`00097ooooo0_l00018ooooo`?o0000;?ooool002_ooooo1?l00016
ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`14
ooooo`Co0000;oooool002oooooo0ol00014ooooo`;o0000AOooool00ol0003oooooooooo`13oooo
o`;o0000A?ooool3o`0003?ooooo000booooo`?o0000@oooool2o`0004?ooooo00?o0000oooooooo
ool0@Oooool2o`0004?ooooo0ol0000fooooo`00=Oooool3o`0004;ooooo00?o0000ooooooooool0
@?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo043ooooo0ol0000iooooo`00>?oo
ool4o`0003oooooo0_l00010ooooo`03o`000?oooooooooo03kooooo0_l0000oooooo`Co0000??oo
ool003cooooo0ol0000nooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0?Oooool0
0ol0003oooooooooo`0looooo`?o0000@?ooool003oooooo0ol0000looooo`;o0000?Oooool00ol0
003oooooooooo`0kooooo`;o0000??ooool3o`0004?ooooo0012ooooo`?o0000>oooool2o`0003_o
oooo00?o0000ooooooooool0>Oooool2o`0003_ooooo0ol00016ooooo`00AOooool3o`0003[ooooo
00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo
0ol00019ooooo`00B?ooool4o`0003Oooooo0_l0000hooooo`03o`000?oooooooooo03Kooooo0_l0
000gooooo`Co0000C?ooool004cooooo0ol0000fooooo`03o`000?oooooooooo03Gooooo00?o0000
ooooooooool0=Oooool00ol0003oooooooooo`0dooooo`?o0000D?ooool004oooooo0ol0000doooo
o`;o0000=Oooool00ol0003oooooooooo`0cooooo`;o0000=?ooool3o`0005?ooooo001Booooo`?o
0000<oooool2o`0003?ooooo00?o0000ooooooooool0<Oooool2o`0003?ooooo0ol0001Fooooo`00
EOooool4o`00037ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`03o`00
0?oooooooooo02oooooo1?l0001Iooooo`00FOooool3o`0002oooooo0_l0000`ooooo`03o`000?oo
oooooooo02kooooo0_l0000_ooooo`?o0000GOooool005cooooo0ol0000^ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`?o0000H?ooool0
05oooooo0ol0000/ooooo`;o0000;Oooool00ol0003oooooooooo`0[ooooo`;o0000;?ooool3o`00
06?ooooo001Rooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:Oooool2o`0002_o
oooo0ol0001Vooooo`00IOooool4o`0002Wooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`0Xooooo`03o`000?oooooooooo02Oooooo1?l0001Yooooo`00JOooool3o`0002Oooooo0_l0
000Xooooo`03o`000?oooooooooo02Kooooo0_l0000Wooooo`?o0000KOooool006cooooo0ol0000V
ooooo`;o00009_ooool00ol0003oooooooooo`0Tooooo`;o00009_ooool3o`00073ooooo001_oooo
o`?o00009Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool08oooool3o`0007?ooooo001booooo`Co00008_ooool2o`0002?ooooo00?o0000oooooooo
ool08Oooool2o`0002;ooooo1?l0001fooooo`00M_ooool3o`00027ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01oooooo0ol0001jooooo`00NOoo
ool3o`0001oooooo0_l0000Pooooo`03o`000?oooooooooo01kooooo0_l0000Oooooo`?o0000OOoo
ool007cooooo0ol0000Nooooo`;o00007_ooool00ol0003oooooooooo`0Looooo`;o00007_ooool3
o`00083ooooo001oooooo`?o00007Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool06oooool3o`0008?ooooo0022ooooo`Co00006_ooool2o`0001_o
oooo00?o0000ooooooooool06Oooool2o`0001[ooooo1?l00026ooooo`00Q_ooool3o`0001Wooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Oooooo
0ol0002:ooooo`00ROooool3o`0001Oooooo0_l0000Hooooo`03o`000?oooooooooo01Kooooo0_l0
000Gooooo`?o0000SOooool008cooooo0ol0000Fooooo`;o00005_ooool00ol0003oooooooooo`0D
ooooo`;o00005_ooool3o`00093ooooo002?ooooo`Co00005?ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool4o`0009?ooooo002Cooooo`?o
00004_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`0001;ooooo0ol0002Gooooo`00
U_ooool3o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00oooooo0ol0002Jooooo`00VOooool3o`0000oooooo0_l0000@ooooo`03o`000?oo
oooooooo00kooooo0_l0000?ooooo`?o0000WOooool009cooooo0ol0000>ooooo`;o00003_ooool0
0ol0003oooooooooo`0<ooooo`;o00003_ooool3o`000:3ooooo002Oooooo`Co00003?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool4o`00
0:?ooooo002Sooooo`?o00002_ooool2o`0001Oooooo0_l0000:ooooo`?o0000Yoooool00:Kooooo
0ol00009ooooo`;o00004oooool2o`0000Wooooo0ol0002Zooooo`00ZOooool3o`0000Sooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`06ooooo`?o0000[Oooool00:cooooo1?l00005
ooooo`03o`000?oooooooooo00cooooo0_l00005ooooo`Co0000/?ooool00;3ooooo0ol0000Eoooo
o`?o0000]?ooool00;?ooooo0_l0000@ooooo`?o0000]oooool00;[ooooo1_l0002oooooo`00_?oo
ool2o`000<7ooooo002looooo`;o0000`Oooool00;cooooo0_l00031ooooo`00^oooool5o`000;oo
oooo002looooo`;o0000`Oooool00;gooooo0ol0002oooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.1756, -0.833972, \
0.0114987, 0.00367387}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.2619 .21092 -5 -6 ]
[.2619 .21092 5 6 ]
[.2619 .01472 -5 -6 ]
[.2619 .01472 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.66907 .21092 -5 -6 ]
[.66907 .21092 5 6 ]
[.71509 .21092 -5 -6 ]
[.71509 .21092 5 6 ]
[.7611 .21092 -5 -6 ]
[.7611 .21092 5 6 ]
[.80712 .21092 -5 -6 ]
[.80712 .21092 5 6 ]
[.80712 .01472 -20 -6 ]
[.80712 .01472 20 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
gsave
.2619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .01472 Mdot
0 g
gsave
.2619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
gsave
.66907 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .21092 Mdot
0 g
gsave
.71509 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .21092 Mdot
0 g
gsave
.7611 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .21092 m
.80712 .01472 L
s
1 g
.05 w
.80712 .21092 Mdot
0 g
gsave
.80712 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.80712 .01472 Mdot
0 g
gsave
.80712 .01472 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7303) show
1.000 setlinewidth
grestore
1 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooolQ
ooooo`Co0000Foooool00?oooooo9?ooool2o`0000?ooooo0_l0001Eooooo`00I_ooool4o`000;Ko
oooo1Ol00002ooooo`Co00001?ooool2o`0000Cooooo1?l00004ooooo`?o00000oooool4o`0003So
oooo001Wooooo`;o0000]_ooool2o`0000;ooooo0_l000000ooooooo0000o`000004o`0000?ooooo
0_l00003ooooo`;o00000_ooool2o`0000;ooooo0_l000001?oooooo0000o`000?ooool2o`0000;o
oooo0_l0000gooooo`00I?ooool6o`000;Gooooo0_l00002ooooo`;o00000oooool4o`0000Cooooo
0_l00006ooooo`;o00000_ooool2o`000003ooooool0003o000000Gooooo0_l0000gooooo`00I?oo
ool2o`000003ooooool0003o00000;Kooooo0_l00002ooooo`;o00000_ooool4o`0000Gooooo0_l0
0004ooooo`?o00000oooool2o`000003ooooool0003o000000?ooooo0ol0000hooooo`00IOooool4
o`000;Oooooo2_l00007ooooo`;o00001Oooool2o`0000;ooooo0_l000000ooooooo0000o`000005
ooooo`;o0000=oooool006Kooooo0ol0002mooooo`Ko000000?oooooo`000?l000000_ooool2o`00
0003ooooool0003o000000;ooooo0_l00002ooooo`;o000000Coooooo`000?l0003ooooo0_l00002
ooooo`;o0000=oooool006Oooooo0_l0002nooooo`Co00000_ooool6o`0000;ooooo1?l00004oooo
o`?o00000oooool4o`0003Sooooo003oooooobWooooo0_l0001Eooooo`00oooooon0ooooo`00oooo
oon0ooooo`00Ioooool00ol0003oooooooooo`3ooooooaKooooo001Wooooo`03o`000?oooooooooo
0?oooooo5_ooool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00
Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oo
oooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool0
0ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo
04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo
00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003ooooooooo
o`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000
ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;oooo
o`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`00
0?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aooo
ool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooo
oooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oo
oooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003ooooo
ooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o
0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;
ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03
o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0
aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oo
oooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool0
06Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003o
ooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo
00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003ooooooooo
o`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Woooo
o`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000oooooooo
ool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`00
0?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Booo
ool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0
003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oo
oooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003ooooo
ooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001W
ooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000oooo
ooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03
o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0
Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool0
0ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo
0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003o
ooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo
001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000
ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Ioooool00ol0003oooooooooo`37oooo
o`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooooooo0<Oooooo00?o0000oooooooo
ool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1;ooooo`00Iooo
ool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04_ooooo001Wooooo`03o`000?oooooo
oooo0<Oooooo00?o0000ooooooooool0Boooool006Oooooo00?o0000ooooooooool0aoooool00ol0
003oooooooooo`1;ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00IOooool4o`000<Kooooo1?l0001<ooooo`00J?ooool2o`000<Sooooo0_l0001;ooooo`00
B_ooool5o`0001Kooooo1Ol0000Dooooo`Co0000NOooool4o`0000gooooo1Ol0000<ooooo`Go0000
3Oooool5o`0004_ooooo001;ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0
000Cooooo`;o00000_ooool2o`0007Oooooo00?o0000ooooool000004?ooool2o`000003ooooool0
003o000000cooooo0_l000000ooooooo0000o`00000;ooooo`;o00000_ooool2o`0004_ooooo001;
ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0000Gooooo`;o0000Moooool0
0ol0003oooooo`000002o`0000kooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?ooooo
o`000?l000002oooool2o`0000;ooooo0_l0001;ooooo`00Boooool4o`0001Gooooo0_l00002oooo
o`;o00005Oooool3o`0007Sooooo00Go0000ooooool0003oooooo`00000>ooooo`;o000000?ooooo
o`000?l000003?ooool4o`0000cooooo0_l00002ooooo`;o0000Boooool004_ooooo0_l000000ooo
oooo0000o`00000Eooooo`Ko00005_ooool2o`0007Sooooo0ol0000?ooooo`;o000000?oooooo`00
0?l000003?ooool2o`000003ooooool0003o000000cooooo1_l0001:ooooo`00Boooool2o`000003
ooooool0003o000002gooooo0_l00002ooooo`;o0000R_ooool2o`000003ooooool0003o000000co
oooo0_l000000ooooooo0000o`00001Looooo`00B_ooool5o`0002oooooo1?l0002:ooooo`Go0000
3?ooool5o`0005gooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3o
oooo001mooooo`03o`000?oooooooooo0?oooooo001@ooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo04kooooo001A
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`22
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo04oooooo001Aooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04oooooo001Aooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`22ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo04oooooo001Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo053ooooo001Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`24ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo053ooooo001Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`25ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo057ooooo001Cooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
057ooooo001Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`26ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo057ooooo001Dooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05;ooooo
001Dooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`28ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo05;ooooo001Dooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05;ooooo001Eoooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`29oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo05?ooooo001Eooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05?ooooo001Eooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo05?ooooo001Fooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`2;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Cooooo001Fooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2<ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo05Cooooo001Fooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`2<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo05Cooooo001Gooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Go
oooo001Gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`2>ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo05Gooooo001Hooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Kooooo001H
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2?
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05Kooooo001Hooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`2@ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Kooooo001Iooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2Aooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo05Oooooo001Iooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Oooooo001Iooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Booooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo05Oooooo001Jooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`2Cooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Sooooo001Jooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Dooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
05Sooooo001Jooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`2Dooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo05Sooooo001Kooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Wooooo
001Kooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`2Fooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo05Wooooo001Kooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`2Fooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo05Wooooo001Loooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Goooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo05[ooooo001Looooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05[ooooo001Looooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Hooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo05[ooooo001Mooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05_ooooo001Mooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo05_ooooo001Nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`2Kooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo05cooooo001Nooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05co
oooo001Nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`2Looooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo05cooooo001Oooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05gooooo001O
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2M
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo05gooooo001Oooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`2Nooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo05gooooo001Pooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Oooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
063ooooo001Pooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`2Oooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo05kooooo001Pooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo05kooooo001Qooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2Qooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo0000067ooooo001Qooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2Qooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo0000067ooooo001Qooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Rooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo0000067ooooo001Rooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2Sooooo`04o`000?oo
ooooooooo`0000?ooooo00Co0000oooooooooooo0000H_ooool006;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:?ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0006;ooooo001Sooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`2Uooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooool00000Hoooool006?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo0:Gooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo067ooooo
001Sooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2Uooooo`06o`00
0?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1Qooooo`00J_ooool00ol0003o
ooooooooo`2]ooooo`03o`000?oooooooooo06;ooooo003ooooooh3ooooo003ooooooh3ooooo003o
oooooh3ooooo003ooooooh3ooooo001Uooooo`Co0000oooooolGooooo`00J?ooool2o`000?oooooo
5_ooool000cooooo1ol0001Booooo`Go0000D_ooool5o`0005?ooooo1ol0001Aooooo`Ko00003Ooo
ool000cooooo0_l00002ooooo`;o0000D_ooool2o`0000;ooooo0_l0001Cooooo`;o000000?ooooo
o`000?l00000Doooool2o`000003ooooool0003o000005?ooooo0_l000000ooooooo0000o`00000=
ooooo`003?ooool6o`0005;ooooo0_l00002ooooo`;o0000Doooool2o`000003ooooool0003o0000
05?ooooo0_l000000ooooooo0000o`00001Dooooo`;o00003oooool000gooooo1?l0001Cooooo`;o
00000_ooool2o`0005?ooooo0_l000000ooooooo0000o`00001Cooooo`;o000000?oooooo`000?l0
0000EOooool2o`0000kooooo000=ooooo`Co0000E?ooool6o`0005;ooooo0_l000000ooooooo0000
o`00001Cooooo`Co0000Doooool2o`0000;ooooo0_l0000=ooooo`003_ooool2o`0000Oooooo0_l0
002Tooooo`;o000000?oooooo`000?l00000Doooool2o`0004oooooo00?o0000ooooooooool00ooo
ool2o`0000;ooooo0_l0000=ooooo`003Oooool3o`0000Wooooo0_l0002Qooooo`Go0000Doooool3
o`0004gooooo0_l00007ooooo`Co00003_ooool001_ooooo0_l0001Aooooo`03o`000?oooooooooo
0?7ooooo0_l0000Kooooo`007Oooool3o`0004oooooo00?o0000ooooooooool0WOooool00ol0003o
ooooooooo`1=ooooo`?o00007Oooool0023ooooo0_l0001>ooooo`03o`000?oooooooooo09_ooooo
00?o0000ooooooooool0C?ooool2o`00023ooooo000Rooooo`?o0000C?ooool00ol0003ooooooooo
o`2Iooooo`03o`000?oooooooooo04[ooooo0ol0000Rooooo`009Oooool2o`0004_ooooo0_l0001;
ooooo`03o`000?oooooooooo04Wooooo0_l0001;ooooo`;o00009Oooool002Oooooo0ol0001:oooo
o`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`18oooo
o`?o00009oooool002[ooooo0_l00019ooooo`03o`000?oooooooooo04Oooooo00?o0000oooooooo
ool0Aoooool00ol0003oooooooooo`17ooooo`;o0000:_ooool002cooooo0ol00017ooooo`03o`00
0?oooooooooo04Kooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`15ooooo`?o0000
;?ooool002oooooo0_l00016ooooo`;o0000A_ooool00ol0003oooooooooo`14ooooo`;o0000A_oo
ool2o`0002oooooo000aooooo`;o0000A_ooool00ol0003oooooooooo`13ooooo`03o`000?oooooo
oooo04?ooooo00?o0000ooooooooool0A?ooool2o`00037ooooo000cooooo`?o0000A?ooool00ol0
003oooooooooo`12ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@_ooool3o`00
03?ooooo000fooooo`;o0000@oooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo047o
oooo00?o0000ooooooooool0@Oooool2o`0003Kooooo000hooooo`?o0000@Oooool00ol0003ooooo
ooooo`10ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0?oooool3o`0003Sooooo
000kooooo`;o0000@?ooool2o`00043ooooo00?o0000ooooooooool0?_ooool2o`00043ooooo0_l0
000kooooo`00?Oooool3o`0003oooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0m
ooooo`03o`000?oooooooooo03gooooo0ol0000mooooo`00@?ooool2o`0003kooooo00?o0000oooo
ooooool0??ooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo03cooooo0_l00010oooo
o`00@_ooool3o`0003cooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0kooooo`03
o`000?oooooooooo03[ooooo0ol00012ooooo`00AOooool2o`0003_ooooo0_l0000kooooo`03o`00
0?oooooooooo03Wooooo0_l0000kooooo`;o0000AOooool004Oooooo0_l0000kooooo`03o`000?oo
oooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0iooooo`;o0000Aooo
ool004Wooooo0ol0000iooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool0
0ol0003oooooooooo`0gooooo`?o0000BOooool004cooooo0_l0000hooooo`03o`000?oooooooooo
03Kooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0fooooo`;o0000C?ooool004ko
oooo0ol0000fooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003o
ooooooooo`0dooooo`?o0000C_ooool0057ooooo0_l0000eooooo`;o0000=Oooool00ol0003ooooo
ooooo`0cooooo`;o0000=Oooool2o`00057ooooo001Cooooo`?o0000=?ooool00ol0003ooooooooo
o`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool3o`0005?ooooo001F
ooooo`;o0000<oooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000
ooooooooool0<Oooool2o`0005Kooooo001Hooooo`?o0000<Oooool00ol0003oooooooooo`0`oooo
o`03o`000?oooooooooo033ooooo00?o0000ooooooooool0;oooool3o`0005Sooooo001Kooooo`;o
0000<?ooool2o`00033ooooo00?o0000ooooooooool0;_ooool2o`00033ooooo0_l0001Kooooo`00
GOooool2o`00033ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo02kooooo0_l0001Mooooo`00Goooool3o`0002kooooo00?o0000ooooooooool0;?oo
ool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02cooooo0ol0001Oooooo`00H_ooool2
o`0002gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo02_ooooo0_l0001Rooooo`00I?ooool3o`0002_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo0ol0001Tooooo`00Ioooool2o`0002[o
oooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo0_l0000Zooooo`;o0000Ioooool006Wooooo
0ol0000Yooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09oooool00ol0003ooooo
ooooo`0Wooooo`?o0000JOooool006cooooo0_l0000Xooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o0000K?ooool006kooooo0ol0000V
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0T
ooooo`?o0000K_ooool0077ooooo0_l0000Uooooo`;o00009Oooool00ol0003oooooooooo`0Soooo
o`;o00009Oooool2o`00077ooooo001cooooo`;o00009Oooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool2o`0007?ooooo001eooooo`?o0000
8oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
8Oooool3o`0007Gooooo001hooooo`;o00008_ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo023ooooo00?o0000ooooooooool08?ooool2o`0007Sooooo001jooooo`?o00008?ooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07_ooool3
o`0007[ooooo001mooooo`;o00007oooool2o`0001oooooo00?o0000ooooooooool07Oooool2o`00
01oooooo0_l0001mooooo`00Ooooool3o`0001kooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo01cooooo0ol0001oooooo`00P_ooool2o`0001gooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo
0_l00022ooooo`00Q?ooool3o`0001_ooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo01Wooooo0ol00024ooooo`00Qoooool2o`0001[ooooo0_l0000J
ooooo`03o`000?oooooooooo01Sooooo0_l0000Jooooo`;o0000Qoooool008Wooooo0_l0000Joooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Hoooo
o`;o0000ROooool008_ooooo0ol0000Hooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Fooooo`?o0000Roooool008kooooo0_l0000Gooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`;o0000
S_ooool0093ooooo0ol0000Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`0Cooooo`?o0000T?ooool009?ooooo0_l0000Dooooo`;o00005?ooool0
0ol0003oooooooooo`0Booooo`;o00005?ooool2o`0009?ooooo002Eooooo`?o00004oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool3o`00
09Gooooo002Hooooo`;o00004_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool2o`0009Sooooo002Jooooo`?o00004?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool3o`0009[ooooo
002Mooooo`;o00003oooool2o`0000oooooo00?o0000ooooooooool03Oooool2o`0000oooooo0_l0
002Mooooo`00Woooool2o`0000oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00gooooo0_l0002Oooooo`00XOooool3o`0000gooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0ol0002Qoooo
o`00Y?ooool2o`0000cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo0_l0002Tooooo`00Y_ooool3o`0000[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0ol0002Vooooo`00ZOoo
ool2o`0000Wooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`;o0000ZOoo
ool00:_ooooo0ol00008ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01_ooool3
o`000:_ooooo002^ooooo`;o00001oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00Gooooo0_l0002^ooooo`00/?ooool3o`0000Gooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`03ooooo`?o0000/?ooool00;?ooooo0_l0000Eooooo`;o0000/oooool00;Gooooo0_l0
000Aooooo`;o0000]Oooool00<Oooooo00?o0000ooooooooool0]Oooool00;cooooo1_l0002moooo
o`00__ooool2o`000;oooooo002nooooo`;o0000_oooool00;kooooo0_l0002oooooo`00_Oooool5
o`000;gooooo002nooooo`;o0000_oooool00;oooooo0ol0002mooooo`00oooooon0ooooo`00oooo
oon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.17337, -0.625479, \
0.0113529, 0.0027554}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[.5 .30902 -20 -6 ]
[.5 .30902 20 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
1 g
.05 w
.5 .30902 Mdot
0 g
gsave
.5 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7323) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00]_ooool2
o`000<Oooooo002]ooooo`Ko00000_ooool4o`0000Cooooo0_l00004ooooo`Co00000_ooool6o`00
00;ooooo1?l0002Zooooo`00[oooool2o`0000?ooooo1_l00003ooooo`;o00000oooool2o`0000;o
oooo0_l00002ooooo`;o000000Coooooo`000?l0003ooooo0_l00002ooooo`;o0000ZOooool00:oo
oooo0_l00005ooooo`Co00001?ooool2o`0000Kooooo0_l00003ooooo`;o00001oooool2o`000:Wo
oooo002_ooooo`;o00001?ooool4o`0000Gooooo0_l00004ooooo`?o00001Oooool2o`0000Cooooo
0ol0002Zooooo`00[_ooool5o`000003ooooool0003o000000;o00001oooool2o`0000Gooooo0_l0
00000ooooooo0000o`000002ooooo`;o00001Oooool2o`000:Wooooo002_ooooo`;o00000oooool6
o`000003ooooool0003o000000;ooooo0_l000000ooooooo0000o`000002ooooo`;o000000?ooooo
o`000?l000000_ooool2o`000003ooooool0003o000000;ooooo0_l0002Yooooo`00/?ooool3o`00
00;ooooo1?l00002ooooo`Ko00000_ooool4o`0000?ooooo1?l00003ooooo`Co0000Z_ooool00;Ko
oooo0_l00037ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-1.05169, -1.05001, \
0.00549366, 0.00888892}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[.5 .30902 -20 -6 ]
[.5 .30902 20 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
1 g
.05 w
.5 .30902 Mdot
0 g
gsave
.5 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7343) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00]_ooool2
o`000<Oooooo002]ooooo`Ko00000_ooool4o`0000Cooooo0_l00004ooooo`Co00001?ooool4o`00
00;ooooo1?l0002Zooooo`00[oooool2o`0000?ooooo1_l00003ooooo`;o00000oooool2o`0000;o
oooo0_l00004ooooo`;o00000_ooool2o`0000;ooooo0_l0002Yooooo`00[oooool2o`0000Gooooo
1?l00004ooooo`;o00001_ooool2o`000003ooooool0003o000000Co00001Oooool2o`000:Wooooo
002_ooooo`;o00001?ooool4o`0000Gooooo0_l00004ooooo`?o00000_ooool2o`000003ooooool0
003o000000Cooooo0ol0002Zooooo`00[_ooool5o`000003ooooool0003o000000;o00001oooool2
o`0000Gooooo0_l00002ooooo`Co00001_ooool2o`000:Wooooo002_ooooo`;o00000oooool6o`00
0003ooooool0003o000000;ooooo0_l000000ooooooo0000o`000002ooooo`;o00000oooool3o`00
00;ooooo0_l00002ooooo`;o0000ZOooool00;3ooooo0ol00002ooooo`Co00000_ooool6o`0000;o
oooo1?l00005ooooo`;o00000oooool4o`000:[ooooo002fooooo`;o0000aoooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00001\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-1.05169, -1.05001, \
0.00549366, 0.00888892}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[.5 .30902 -20 -6 ]
[.5 .30902 20 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
1 g
.05 w
.5 .30902 Mdot
0 g
gsave
.5 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7363) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00]_ooool2
o`000<Oooooo002]ooooo`Ko00000_ooool4o`0000Cooooo0_l00004ooooo`Co00000oooool4o`00
00?ooooo1?l0002Zooooo`00[oooool2o`0000?ooooo1_l00003ooooo`;o00000oooool2o`0000;o
oooo0_l000000ooooooo0000o`000002ooooo`;o000000?oooooo`000?l000000_ooool2o`000:Wo
oooo002_ooooo`;o00001Oooool4o`0000Cooooo0_l00006ooooo`;o000000?oooooo`000?l00000
0_ooool2o`0000Gooooo0_l0002Yooooo`00[oooool2o`0000Cooooo1?l00005ooooo`;o00001?oo
ool3o`0000;ooooo1Ol00004ooooo`?o0000Z_ooool00:kooooo1Ol000000ooooooo0000o`000002
o`0000Oooooo0_l00005ooooo`;o000000?oooooo`000?l000002Oooool2o`000:Wooooo002_oooo
o`;o00000oooool6o`000003ooooool0003o000000;ooooo0_l000000ooooooo0000o`000002oooo
o`;o00000_ooool2o`0000Cooooo0_l00002ooooo`;o0000ZOooool00;3ooooo0ol00002ooooo`Co
00000_ooool6o`0000;ooooo1?l00004ooooo`?o00000oooool4o`000:[ooooo002fooooo`;o0000
aoooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00001\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-1.05169, -1.05001, \
0.00549366, 0.00888892}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -20 -6 ]
[.25889 .30902 20 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7383) show
1.000 setlinewidth
grestore
1 g
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00j?ooool7o`0007gooooo1Ol0000>ooooo`00j?ooool2o`0000;ooooo
0_l0001oooooo`;o000000?oooooo`000?l000003Oooool00>Sooooo1_l0001oooooo`;o000000?o
ooooo`000?l000003Oooool00>Wooooo1?l00020ooooo`Co00003_ooool00>Wooooo1?l00020oooo
o`;o000000?oooooo`000?l000003Oooool00>[ooooo0_l00021ooooo`;o000000?oooooo`000?l0
00003Oooool00>Wooooo0ol00020ooooo`Go00003_ooool00?ooooooP?ooool00??ooooo00?o0000
ooooooooool0LOooool00ol0003oooooooooo`0Eooooo`00m?ooool00ol0003oooooooooo`1_oooo
o`03o`000?oooooooooo01Kooooo003eooooo`03o`000?oooooooooo06gooooo00?o0000oooooooo
ool05oooool00?Kooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Hooooo`00mooo
ool2o`0006Wooooo0_l0000Kooooo`00nOooool00ol0003oooooooooo`1Uooooo`03o`000?oooooo
oooo01_ooooo003jooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool07?ooool00?_o
oooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Mooooo`00o?ooool00ol0003ooooo
ooooo`1Oooooo`03o`000?oooooooooo01kooooo003mooooo`;o0000GOooool2o`00027ooooo003o
ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool08Oooool00?oooooo0Oooool00ol0
003oooooooooo`1Gooooo`03o`000?oooooooooo02;ooooo003oooooo`;ooooo00?o0000oooooooo
ool0EOooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool2o`00057ooooo0_l0000Wooooo`00ooooool6
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool09oooool00?oooooo1oooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo02Sooooo003oooooo`Sooooo00?o0000oooooooo
ool0BOooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool2o`0004Gooooo0_l0000]ooooo`00ooooool<
ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0;Oooool00?oooooo3Oooool00ol0
003oooooooooo`0oooooo`03o`000?oooooooooo02kooooo003oooooo`kooooo00?o0000oooooooo
ool0?Oooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03_ooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool2o`0003Wooooo0_l0000cooooo`00oooooolB
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0<oooool00?oooooo4oooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo03Cooooo003ooooooaCooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool2o`0002gooooo0_l0000iooooo`00oooooolH
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0>Oooool00?oooooo6Oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo03[ooooo003ooooooa[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool0??ooool00?oooooo7?ooool2o`00027ooooo0_l0000oooooo`00oooooolN
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0?oooool00?oooooo7oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo043ooooo003oooooob3ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool0@_ooool00?oooooo8_ooool2o`0001Gooooo0_l00015ooooo`00oooooolT
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0AOooool00?oooooo9Oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo04Kooooo003oooooobKooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`17ooooo`00oooooolWooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0B?ooool00?ooooooP?ooool00?oooooo;?ooool4o`00053ooooo003ooooo
oboooooo0_l0001?ooooo`00ooooool/ooooo`Go0000Coooool00?oooooo:oooool2o`0000;ooooo
0_l0001?ooooo`00ooooool[ooooo`;o00000_ooool2o`0004oooooo003oooooob_ooooo0_l00002
ooooo`;o0000Coooool00?oooooo;?ooool6o`0004kooooo003ooooooh3ooooo003ooooooh3ooooo
003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
001Eooooo`Co0000d_ooool4o`00053ooooo001Hooooo`;o00000oooool2o`000<oooooo0_l0001?
ooooo`00B_ooool5o`0000Kooooo1Ol00002ooooo`Co00001?ooool2o`0000Cooooo1?l00003oooo
o`Co00002?ooool4o`0007Oooooo1?l0000<ooooo`Go00003?ooool5o`0000gooooo1Ol0001?oooo
o`00Boooool2o`000003ooooool0003o000000Cooooo0_l00002ooooo`;o000000?oooooo`000?l0
00001?l00003ooooo`;o00000oooool2o`0000;ooooo0_l000000ooooooo0000o`000002ooooo`;o
00001_ooool2o`0000;ooooo0_l0001eooooo`03o`000?oooooo000000oooooo0_l000000ooooooo
0000o`00000<ooooo`;o000000?oooooo`000?l000002oooool2o`0000;ooooo0_l0001?ooooo`00
Boooool2o`000003ooooool0003o000000Cooooo0_l00002ooooo`;o00000oooool4o`0000Cooooo
0_l00006ooooo`;o000000?oooooo`000?l000000_ooool2o`0000[ooooo0_l0001eooooo`03o`00
0?oooooo000000;o00003Oooool2o`000003ooooool0003o000000cooooo0_l000000ooooooo0000
o`00000;ooooo`;o00000_ooool2o`0004oooooo001;ooooo`Co00001Oooool2o`0000;ooooo0_l0
0002ooooo`Co00001Oooool2o`0000Cooooo0ol00003ooooo`Co00002Oooool3o`0007Kooooo00Go
0000ooooool0003oooooo`00000=ooooo`;o000000?oooooo`000?l000003?ooool4o`0000cooooo
0_l00002ooooo`;o0000Coooool004_ooooo0_l000000ooooooo0000o`000005ooooo`[o00001ooo
ool2o`0000Gooooo0_l000000ooooooo0000o`000002ooooo`;o00002_ooool2o`0007Kooooo0ol0
000>ooooo`;o000000?oooooo`000?l000003?ooool2o`000003ooooool0003o000000cooooo1_l0
001>ooooo`00Boooool2o`000003ooooool0003o000000_ooooo1_l000000ooooooo0000o`000002
ooooo`;o000000?oooooo`000?l000000_ooool2o`000003ooooool0003o000000;ooooo0_l00006
ooooo`;o00000_ooool2o`0008Oooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?ooooo
o`000?l00000H?ooool004[ooooo1Ol0000=ooooo`Co00000_ooool6o`0000;ooooo1?l00003oooo
o`Co00002?ooool4o`0008Oooooo1Ol0000<ooooo`Go0000HOooool005gooooo0_l0003oooooob7o
oooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo001Aooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0P?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo
05?ooooo001Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`20ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo05?ooooo001Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo
001Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`22ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo05Cooooo001Cooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Gooooo001Coooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`24oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Gooooo001Dooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Kooooo001Dooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`26ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo05Kooooo001Eooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05Oooooo001Eooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`28ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo05Oooooo001Eooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo05Oooooo001Fooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05So
oooo001Fooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`2;ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo05Sooooo001Gooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05Wooooo001G
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2=
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo05Wooooo001Hooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`2>ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05[ooooo001Hooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`2?ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo05[ooooo001Iooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`2@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05_ooooo001Iooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Aooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo05_ooooo001Jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`2Booooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo05cooooo001Jooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Booooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
05cooooo001Jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`2Cooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo05cooooo001Kooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Dooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05gooooo
001Kooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`2Eooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo05gooooo001Looooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`2Fooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05kooooo001Loooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Goooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo05kooooo001Mooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo05oooooo001Mooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2Iooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo05oooooo001Nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo063ooooo001Nooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Kooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo063ooooo001Oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`2Looooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo001Oooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Mooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo001Oooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Mooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
067ooooo001Pooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000006Cooooo001Pooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`2Oooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000006Cooooo001Qooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`2Qooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000
IOooool0067ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0:7ooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0001Uooooo`00
H_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0:?ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`1Tooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0oooo
o`00oooooon0ooooo`00I?ooool4o`000?oooooo6?ooool006Oooooo0_l0003ooooooaOooooo000<
ooooo`Oo0000DOooool5o`00057ooooo1Ol0001Booooo`Oo0000D?ooool6o`00017ooooo000<oooo
o`;o00000_ooool2o`00057ooooo0_l00002ooooo`;o0000D_ooool2o`000003ooooool0003o0000
05;ooooo0_l000000ooooooo0000o`00001Booooo`;o000000?oooooo`000?l000004Oooool000co
oooo1_l0001Aooooo`;o00000_ooool2o`0005;ooooo0_l000000ooooooo0000o`00001Booooo`;o
000000?oooooo`000?l00000Doooool2o`0001?ooooo000=ooooo`Co0000D_ooool2o`0000;ooooo
0_l0001Booooo`;o000000?oooooo`000?l00000D_ooool2o`000003ooooool0003o000005Cooooo
0_l0000Booooo`003Oooool4o`0005?ooooo1_l0001Aooooo`;o000000?oooooo`000?l00000D_oo
ool4o`0005;ooooo0_l00002ooooo`;o00004Oooool000kooooo0_l00008ooooo`?o0000X?ooool2
o`000003ooooool0003o000005;ooooo0_l0001<ooooo`?o00001Oooool2o`0000;ooooo0_l0000A
ooooo`003Oooool3o`0000_ooooo1?l0002Kooooo`Go0000D_ooool3o`0004Sooooo1?l00009oooo
o`Co00004_ooool001oooooo0ol0001<ooooo`;o0000Voooool2o`0004cooooo0ol0000Sooooo`00
8_ooool3o`0004_ooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`19ooooo`?o0000
9_ooool002Gooooo0ol00019ooooo`;o0000UOooool2o`0004Wooooo0ol0000Yooooo`00:?ooool3
o`0004Sooooo0_l0002Aooooo`;o0000B?ooool3o`0002cooooo000[ooooo`Co0000A_ooool00ol0
003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0A?ooool4o`00
02oooooo000_ooooo`?o0000A?ooool2o`0004Gooooo00?o0000ooooooooool0@oooool2o`0004Co
oooo0ol0000cooooo`00<_ooool3o`0004?ooooo0_l00013ooooo`03o`000?oooooooooo047ooooo
0_l00013ooooo`?o0000=_ooool003Gooooo0ol00012ooooo`03o`000?oooooooooo043ooooo00?o
0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`?o0000>Oooool003Sooooo1?l0000o
ooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`;o0000?oooool4o`0003cooooo000loooo
o`?o0000?_ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo03gooooo00?o0000oooo
ooooool0??ooool3o`00043ooooo000oooooo`?o0000??ooool2o`0003gooooo00?o0000oooooooo
ool0>oooool2o`0003cooooo0ol00013ooooo`00@_ooool3o`0003_ooooo0_l0000kooooo`03o`00
0?oooooooooo03Wooooo0_l0000kooooo`?o0000A_ooool004Gooooo0ol0000jooooo`03o`000?oo
oooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0hooooo`?o0000BOoo
ool004Sooooo1?l0000gooooo`;o0000>?ooool00ol0003oooooooooo`0fooooo`;o0000=oooool4
o`0004cooooo001<ooooo`?o0000=_ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
03Gooooo00?o0000ooooooooool0=?ooool3o`00053ooooo001?ooooo`?o0000=?ooool2o`0003Go
oooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001Cooooo`00D_ooool3o`0003?ooooo
0_l0000cooooo`03o`000?oooooooooo037ooooo0_l0000cooooo`?o0000E_ooool005Gooooo1?l0
000aooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0<?ooool00ol0003ooooooooo
o`0_ooooo`Co0000FOooool005Wooooo0ol0000_ooooo`;o0000<?ooool00ol0003oooooooooo`0^
ooooo`;o0000;oooool3o`0005gooooo001Looooo`?o0000;_ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?ooool3o`00063ooooo001Oooooo`?o
0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2o`0002cooooo0ol0001Sooooo`00
H_ooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo0_l0000[ooooo`?o0000
I_ooool006Gooooo1?l0000Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?oo
ool00ol0003oooooooooo`0Wooooo`Co0000JOooool006Wooooo0ol0000Wooooo`;o0000:?ooool0
0ol0003oooooooooo`0Vooooo`;o00009oooool3o`0006gooooo001/ooooo`?o00009_ooool2o`00
02Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0001`ooooo`00Koooool3o`0002Go
oooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo02?o
oooo0ol0001cooooo`00L_ooool4o`0002;ooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo
0_l0000Rooooo`Co0000M_ooool007Kooooo0ol0000Qooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o0000N_ooool007Wooooo0ol0000O
ooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o00007oooool3o`0007gooooo001loooo
o`?o00007_ooool2o`0001kooooo00?o0000ooooooooool07?ooool2o`0001kooooo0ol00020oooo
o`00Ooooool3o`0001gooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01_ooooo0ol00023ooooo`00P_ooool4o`0001[ooooo0_l0000Kooooo`03o`00
0?oooooooooo01Wooooo0_l0000Jooooo`Co0000Q_ooool008Kooooo0ol0000Iooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Gooooo`?o0000R_oo
ool008Wooooo0ol0000Gooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`;o00005oooool3
o`0008gooooo002<ooooo`?o00005_ooool2o`0001Kooooo00?o0000ooooooooool05?ooool2o`00
01Kooooo0ol0002@ooooo`00Soooool4o`0001Cooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo1?l0002Cooooo`00Toooool3o`0001;ooooo
0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Booooo`?o0000Uoooool009Kooooo0ol0
000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0?ooooo`?o0000V_ooool009Wooooo0ol0000?ooooo`;o00004?ooool00ol0003oooooooooo`0>
ooooo`;o00003oooool3o`0009gooooo002Looooo`?o00003_ooool2o`0000kooooo00?o0000oooo
ooooool03?ooool2o`0000kooooo0ol0002Pooooo`00Woooool4o`0000cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo1?l0002Sooooo`00
Xoooool3o`0000[ooooo0_l0000Gooooo`;o00002_ooool3o`000:Oooooo002Vooooo`?o00002Ooo
ool2o`0001?ooooo0_l00009ooooo`?o0000Z_ooool00:Wooooo0ol00008ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool01_ooool3o`000:gooooo002/ooooo`Co00001Oooool00ol0
003oooooooooo`0<ooooo`;o00001Oooool4o`000;3ooooo002`ooooo`?o00005Oooool3o`000;Co
oooo002cooooo`;o00004?ooool3o`000;Oooooo002jooooo`Ko0000_oooool00;cooooo0_l00031
ooooo`00_?ooool2o`000<7ooooo002looooo`;o0000`Oooool00;_ooooo1Ol0002oooooo`00_?oo
ool2o`000<7ooooo002mooooo`?o0000_oooool00?ooooooP?ooool00?ooooooP?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00001\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.1756, -0.833972, \
0.0114987, 0.00367387}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[.5 .30902 -20 -6 ]
[.5 .30902 20 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
1 g
.05 w
.5 .30902 Mdot
0 g
gsave
.5 .30902 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7403) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00]_ooool2
o`000<Oooooo002]ooooo`Ko00000_ooool4o`0000Cooooo0_l00005ooooo`Co00000oooool3o`00
00?ooooo1?l0002Zooooo`00[oooool2o`0000?ooooo1_l00003ooooo`;o00001_ooool2o`0000?o
oooo0_l000001?oooooo0000o`000?ooool2o`0000;ooooo0_l0002Yooooo`00[oooool2o`0000Go
oooo1?l00004ooooo`;o00000_ooool6o`0000;ooooo0_l000000ooooooo0000o`000005ooooo`;o
0000ZOooool00:oooooo0_l00004ooooo`Co00001Oooool2o`0000;ooooo0_l000000ooooooo0000
o`000003ooooo`;o000000?oooooo`000?l000000oooool3o`000:[ooooo002^ooooo`Go000000?o
ooooo`000?l000000_l00007ooooo`;o00000_ooool4o`0000?ooooo0_l000000ooooooo0000o`00
0005ooooo`;o0000ZOooool00:oooooo0_l00003ooooo`Ko000000?oooooo`000?l000000_ooool2
o`0000?ooooo0ol00003ooooo`;o000000Coooooo`000?l0003ooooo0_l00002ooooo`;o0000ZOoo
ool00;3ooooo0ol00002ooooo`Co00000_ooool6o`0000Cooooo0_l00004ooooo`?o00000oooool4
o`000:[ooooo002fooooo`;o0000aoooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00001\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-1.05169, -1.05001, \
0.00549366, 0.00888892}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.2619 .21092 -5 -6 ]
[.2619 .21092 5 6 ]
[.2619 .01472 -5 -6 ]
[.2619 .01472 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.7381 .40712 -20 -6 ]
[.7381 .40712 20 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
gsave
.2619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .01472 Mdot
0 g
gsave
.2619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h$7423) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00IOooool4o`000?oooooo5oooool006Kooooo0_l0003ooooooaSooooo001Sooooo`Ko0000
oooooolGooooo`00Hoooool2o`000003ooooool0003o00000?oooooo6?ooool006Cooooo1?l0003o
oooooaSooooo001Uooooo`?o0000oooooolHooooo`00I_ooool2o`000?oooooo6?ooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo
00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001V
ooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGoooo
o`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo
5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3o
oooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool006Kooooo00?o0000oooooooo
ool0oooooolGooooo`00I_ooool00ol0003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oo
oooooooo0?oooooo5oooool006Kooooo00?o0000ooooooooool0oooooolGooooo`00I_ooool00ol0
003oooooooooo`3ooooooaOooooo001Vooooo`03o`000?oooooooooo0?oooooo5oooool00?oooooo
P?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool006Cooooo1?l0003ooooooaSo
oooo001Wooooo`;o0000oooooolGooooo`00BOooool5o`0001Kooooo1Ol0000Eooooo`Co0000oOoo
ool004[ooooo0_l000000ooooooo0000o`00000Dooooo`;o00000_ooool2o`0001Cooooo0_l00002
ooooo`;o0000o?ooool004[ooooo0_l000000ooooooo0000o`00000Dooooo`;o00000_ooool2o`00
01Sooooo0_l0003looooo`00B_ooool4o`0001Gooooo0_l00002ooooo`;o00005_ooool3o`000?go
oooo001:ooooo`;o000000?oooooo`000?l000005Oooool6o`0001Oooooo0_l0003looooo`00B_oo
ool2o`000003ooooool0003o000002kooooo0_l00002ooooo`;o0000o?ooool004Wooooo1Ol0000`
ooooo`Co0000oOooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?oo
ool00?ooooooP?ooool004oooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo0?oooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`3oooooo`7ooooo001@ooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`3oooooo`7ooooo001@ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3oooooo`7ooooo001A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3o
ooooo`;ooooo001Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`3oooooo`;ooooo001Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`3oooooo`?ooooo001Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`3oooooo`?ooooo001Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3oooooo`?ooooo001C
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3o
ooooo`Cooooo001Cooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`3oooooo`Cooooo001Cooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`3oooooo`Cooooo001Dooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool03oooool00ol0003oooooooooo`3oooooo`Gooooo001Dooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3oooooo`Gooooo001D
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3o
ooooo`Gooooo001Eooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`3oooooo`Kooooo001Eooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`3oooooo`Kooooo001Eooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`3oooooo`Kooooo001Fooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooo`Oooooo001F
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3o
ooooo`Oooooo001Gooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`3oooooo`Sooooo001Gooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`3oooooo`Sooooo001Gooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`3oooooo`Sooooo001Hooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3oooooo`Wooooo001H
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3o
ooooo`Wooooo001Hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`3oooooo`Wooooo001Iooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`3oooooo`[ooooo001Iooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooo`[ooooo001Iooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooo`[ooooo001J
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3o
ooooo`_ooooo001Jooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`3oooooo`_ooooo001Jooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`3oooooo`_ooooo001Kooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`3oooooo`cooooo001Kooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3oooooo`cooooo001K
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3o
ooooo`cooooo001Looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`3oooooo`gooooo001Looooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`3oooooo`gooooo001Mooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`3oooooo`kooooo001Mooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3oooooo`kooooo001M
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3o
ooooo`kooooo001Nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooo`oooooo001Nooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooo`oooooo001Nooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooo`oooooo001Oooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooa3ooooo001O
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3o
oooooa3ooooo001Oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3ooooooa3ooooo001Pooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`3ooooooa7ooooo001Pooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooa7ooooo001Pooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooa7ooooo001Q
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3o
oooooa;ooooo001Qooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3ooooooa;ooooo001Rooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`3ooooooa?ooooo001Rooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`3ooooooa?ooooo001Rooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`3ooooooa?ooooo001Sooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0oooooolDooooo`00JOooool00ol0003oooooooooo`3ooooooaCooooo003ooooooh3ooooo
003ooooooh3ooooo003ooooooh3ooooo001Tooooo`Co0000oooooolHooooo`00Ioooool2o`000:Ko
oooo0_l0001^ooooo`002_ooool7o`0005?ooooo1Ol0001Cooooo`Go0000AOooool7o`000003oooo
ool0003o000000;o00001?ooool2o`0000Gooooo1?l000000ooooooo0000o`000004o`0000;ooooo
1?l0000oooooo`Ko00003?ooool000[ooooo0_l00002ooooo`;o0000Doooool2o`0000;ooooo0_l0
001Dooooo`;o000000?oooooo`000?l00000AOooool2o`000004ooooool0003o0000ooooo`Ko0000
0oooool2o`0000Kooooo0_l00003ooooo`;o000000Coooooo`000?l0003ooooo0_l00002ooooo`;o
0000?oooool2o`000003ooooool0003o000000cooooo000:ooooo`Ko0000Doooool2o`0000;ooooo
0_l0001Dooooo`;o000000?oooooo`000?l00000AOooool2o`000003ooooool0003o000000?ooooo
1?l00004ooooo`;o00000_ooool6o`0000?ooooo0_l00007ooooo`;o0000@?ooool2o`0000kooooo
000;ooooo`Co0000E?ooool2o`0000;ooooo0_l0001Dooooo`;o000000?oooooo`000?l00000AOoo
ool2o`000003ooooool0003o000000;ooooo1?l00005ooooo`;o00000_ooool2o`000003ooooool0
003o000000Gooooo0_l00004ooooo`?o0000@_ooool2o`0000gooooo000;ooooo`Co0000EOooool6
o`0005?ooooo0_l000000ooooooo0000o`000015ooooo`Co00000_ooool4o`0000Oooooo0_l00002
ooooo`Co00000_ooool2o`0000;ooooo0_l00005ooooo`;o0000?_ooool2o`0000;ooooo0_l0000<
ooooo`003?ooool2o`000:oooooo0_l000000ooooooo0000o`000015ooooo`;o00001?ooool6o`00
0003ooooool0003o000000;ooooo0_l00003ooooo`?o00000_ooool2o`0000;ooooo0_l000000ooo
oooo0000o`000002ooooo`;o0000?_ooool2o`0000;ooooo0_l0000<ooooo`002oooool3o`0000Wo
oooo0_l0002Sooooo`Go0000AOooool3o`0000Gooooo1?l00002ooooo`Ko00001?ooool2o`0000?o
oooo1?l00003ooooo`Co0000=oooool3o`0000Kooooo1?l0000=ooooo`006Oooool2o`000?Cooooo
0_l0001Booooo`;o00006_ooool001_ooooo0ol0001@ooooo`03o`000?oooooooooo09oooooo00?o
0000ooooooooool0COooool3o`0001cooooo000Nooooo`;o0000Coooool00ol0003oooooooooo`2M
ooooo`03o`000?oooooooooo04cooooo0_l0000Oooooo`008?ooool3o`0004gooooo00?o0000oooo
ooooool0Voooool00ol0003oooooooooo`1:ooooo`?o00008Oooool002?ooooo0_l0001<ooooo`;o
0000VOooool2o`0004_ooooo0_l0000Tooooo`009Oooool3o`0004_ooooo00?o0000ooooooooool0
BOooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo04Wooooo0_l0000Vooooo`00:?oo
ool2o`0004[ooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`18ooooo`03o`000?oo
oooooooo04Oooooo0ol0000Xooooo`00:_ooool2o`0004Wooooo00?o0000ooooooooool0Aoooool0
0ol0003oooooooooo`17ooooo`03o`000?oooooooooo04Kooooo0_l0000[ooooo`00;?ooool3o`00
04Oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo
04Cooooo0ol0000]ooooo`00;oooool2o`0004Kooooo0_l00016ooooo`03o`000?oooooooooo04Co
oooo0_l00015ooooo`;o0000<?ooool0037ooooo0ol00015ooooo`03o`000?oooooooooo04?ooooo
00?o0000ooooooooool0@oooool00ol0003oooooooooo`12ooooo`?o0000<_ooool003Cooooo0_l0
0014ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@_ooool00ol0003ooooooooo
o`11ooooo`;o0000=Oooool003Kooooo0ol00012ooooo`03o`000?oooooooooo047ooooo00?o0000
ooooooooool0@Oooool00ol0003oooooooooo`10ooooo`;o0000=oooool003Wooooo0_l00011oooo
o`;o0000@Oooool00ol0003oooooooooo`0oooooo`;o0000@?ooool3o`0003Wooooo000kooooo`?o
0000@?ooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo03kooooo00?o0000oooooooo
ool0?_ooool2o`0003cooooo000nooooo`;o0000?oooool00ol0003oooooooooo`0mooooo`03o`00
0?oooooooooo03gooooo00?o0000ooooooooool0??ooool3o`0003kooooo0010ooooo`;o0000?_oo
ool00ol0003oooooooooo`0looooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool0>ooo
ool2o`00047ooooo0012ooooo`?o0000??ooool00ol0003oooooooooo`0kooooo`03o`000?oooooo
oooo03_ooooo00?o0000ooooooooool0>Oooool3o`0004?ooooo0015ooooo`;o0000>oooool2o`00
03_ooooo00?o0000ooooooooool0>Oooool2o`0003[ooooo0_l00016ooooo`00Aoooool3o`0003[o
oooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03So
oooo0_l00018ooooo`00B_ooool2o`0003Wooooo00?o0000ooooooooool0=oooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo03Kooooo0ol0001:ooooo`00C?ooool3o`0003Oooooo00?o
0000ooooooooool0=_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo03Gooooo0_l0
001=ooooo`00Coooool2o`0003Kooooo0_l0000fooooo`03o`000?oooooooooo03Cooooo0_l0000e
ooooo`?o0000Coooool0057ooooo0_l0000fooooo`03o`000?oooooooooo03?ooooo00?o0000oooo
ooooool0<oooool00ol0003oooooooooo`0cooooo`;o0000D_ooool005?ooooo0ol0000dooooo`03
o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0aooooo`?o
0000E?ooool005Kooooo0_l0000cooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0
<Oooool00ol0003oooooooooo`0`ooooo`;o0000Eoooool005Sooooo0ol0000aooooo`03o`000?oo
oooooooo033ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0_ooooo`;o0000FOoo
ool005_ooooo0_l0000`ooooo`;o0000<?ooool00ol0003oooooooooo`0^ooooo`;o0000;oooool3
o`0005_ooooo001Mooooo`?o0000;oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0;Oooool2o`0005kooooo001Pooooo`;o0000;_ooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0:oooool3o`00063o
oooo001Rooooo`?o0000;?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0:_ooool2o`0006?ooooo001Uooooo`;o0000:oooool2o`0002_ooooo00?o
0000ooooooooool0:Oooool2o`0002[ooooo0ol0001Uooooo`00Ioooool2o`0002_ooooo00?o0000
ooooooooool0:?ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo0_l0001X
ooooo`00JOooool3o`0002Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo02Oooooo0_l0001Zooooo`00K?ooool2o`0002Sooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Gooooo0ol0001/ooooo`00
K_ooool3o`0002Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo02Cooooo0_l0001_ooooo`00LOooool2o`0002Gooooo0_l0000Uooooo`03o`000?oo
oooooooo02?ooooo0_l0000Tooooo`?o0000LOooool007?ooooo0ol0000Tooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Rooooo`;o0000M?ooool0
07Kooooo0_l0000Sooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`0Qooooo`;o0000M_ooool007Sooooo0ol0000Qooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o0000N?ooool007_ooooo
0_l0000Pooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`0Nooooo`;o0000Noooool007gooooo0_l0000Oooooo`;o00007oooool00ol0003ooooooooo
o`0Mooooo`;o00007_ooool3o`0007gooooo001oooooo`?o00007_ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool2o`00083ooooo0022oooo
o`;o00007Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool06_ooool3o`0008;ooooo0024ooooo`?o00006oooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool06Oooool2o`0008Gooooo0027ooooo`;o0000
6_ooool2o`0001[ooooo00?o0000ooooooooool06?ooool2o`0001[ooooo0_l00027ooooo`00ROoo
ool3o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Oooooo0ol00029ooooo`00S?ooool2o`0001Sooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo0_l0002<ooooo`00S_ooool2o`00
01Oooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
01Cooooo0ol0002>ooooo`00T?ooool3o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01?ooooo0_l0002Aooooo`00Toooool2o`0001Cooooo
0_l0000Dooooo`03o`000?oooooooooo01;ooooo0_l0000Cooooo`?o0000Toooool009Gooooo0ol0
000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`;o0000U_ooool009Sooooo0_l0000Booooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`;o0000V?ooool009[ooooo0ol0000@oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0>oooo
o`?o0000V_ooool009gooooo0_l0000?ooooo`;o00003oooool00ol0003oooooooooo`0=ooooo`;o
00003oooool2o`0009gooooo002Oooooo`?o00003_ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool3o`0009oooooo002Rooooo`;o00003Ooo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool2o`000:;ooooo002Tooooo`;o00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02Oooool3o`000:Cooooo002Vooooo`?o00002_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool2o`00
0:Oooooo002Yooooo`;o00002Oooool2o`0000Wooooo00?o0000ooooooooool01oooool2o`0000Wo
oooo0_l0002Yooooo`00Zoooool3o`0000Sooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`06ooooo`?o0000Zoooool00:kooooo0_l00007ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool01Oooool2o`000:kooooo002`ooooo`?o00001Oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00?ooooo0ol0002`ooooo`00/oooool2o`0001Gooooo0_l0002coooo
o`00]Oooool2o`00013ooooo0ol0002eooooo`00oooooon0ooooo`00_?ooool6o`000;gooooo002n
ooooo`;o0000_oooool00;kooooo0_l0002oooooo`00__ooool2o`000;oooooo002mooooo`Go0000
_Oooool00;kooooo0_l0002oooooo`00_oooool3o`000;gooooo003ooooooh3ooooo003ooooooh3o
oooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo0000\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.15638, -0.620386, \
0.0112641, 0.00273386}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.25889 .45617 -20 -6 ]
[.25889 .45617 20 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7443) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{383.875, 237.25},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005o0000kB000`400?l00000o`00003ooooooon0
ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0ooooo`00oooooon0
ooooo`00oooooon0ooooo`00j?ooool7o`0007gooooo1Ol0000>ooooo`00j?ooool2o`0000;ooooo
0_l0001oooooo`;o000000?oooooo`000?l000003Oooool00>Sooooo1_l0001oooooo`;o000000?o
ooooo`000?l000003Oooool00>Wooooo1?l00020ooooo`Co00003_ooool00>Wooooo1?l00020oooo
o`;o000000?oooooo`000?l000003Oooool00>[ooooo0_l00021ooooo`;o000000?oooooo`000?l0
00003Oooool00>Wooooo0ol00020ooooo`Go00003_ooool00?ooooooP?ooool00??ooooo00?o0000
ooooooooool0LOooool00ol0003oooooooooo`0Eooooo`00m?ooool00ol0003oooooooooo`1_oooo
o`03o`000?oooooooooo01Kooooo003eooooo`03o`000?oooooooooo06gooooo00?o0000oooooooo
ool05oooool00?Kooooo00?o0000ooooooooool0Joooool00ol0003oooooooooo`0Hooooo`00mooo
ool2o`0006Wooooo0_l0000Kooooo`00nOooool00ol0003oooooooooo`1Uooooo`03o`000?oooooo
oooo01_ooooo003jooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool07?ooool00?_o
oooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0Mooooo`00o?ooool00ol0003ooooo
ooooo`1Oooooo`03o`000?oooooooooo01kooooo003mooooo`;o0000GOooool2o`00027ooooo003o
ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool08Oooool00?oooooo0Oooool00ol0
003oooooooooo`1Gooooo`03o`000?oooooooooo02;ooooo003oooooo`;ooooo00?o0000oooooooo
ool0EOooool00ol0003oooooooooo`0Sooooo`00ooooool3ooooo`03o`000?oooooooooo05?ooooo
00?o0000ooooooooool09?ooool00?oooooo1?ooool2o`00057ooooo0_l0000Wooooo`00ooooool6
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool09oooool00?oooooo1oooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo02Sooooo003oooooo`Sooooo00?o0000oooooooo
ool0BOooool00ol0003oooooooooo`0Yooooo`00ooooool9ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool0:_ooool00?oooooo2_ooool2o`0004Gooooo0_l0000]ooooo`00ooooool<
ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0;Oooool00?oooooo3Oooool00ol0
003oooooooooo`0oooooo`03o`000?oooooooooo02kooooo003oooooo`kooooo00?o0000oooooooo
ool0?Oooool00ol0003oooooooooo`0_ooooo`00ooooool?ooooo`03o`000?oooooooooo03_ooooo
00?o0000ooooooooool0<?ooool00?oooooo4?ooool2o`0003Wooooo0_l0000cooooo`00oooooolB
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0<oooool00?oooooo4oooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo03Cooooo003ooooooaCooooo00?o0000oooooooo
ool0<Oooool00ol0003oooooooooo`0eooooo`00oooooolEooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0=_ooool00?oooooo5_ooool2o`0002gooooo0_l0000iooooo`00oooooolH
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0>Oooool00?oooooo6Oooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo03[ooooo003ooooooa[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`0kooooo`00oooooolKooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool0??ooool00?oooooo7?ooool2o`00027ooooo0_l0000oooooo`00oooooolN
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0?oooool00?oooooo7oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo043ooooo003oooooob3ooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`11ooooo`00oooooolQooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool0@_ooool00?oooooo8_ooool2o`0001Gooooo0_l00015ooooo`00oooooolT
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0AOooool00?oooooo9Oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo04Kooooo003oooooobKooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`17ooooo`00oooooolWooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0B?ooool00?ooooooP?ooool00?oooooo;?ooool4o`00053ooooo003ooooo
oboooooo0_l0001?ooooo`00ooooool/ooooo`Go0000Coooool00?oooooo:oooool2o`0000;ooooo
0_l0001?ooooo`00ooooool[ooooo`;o00000_ooool2o`0004oooooo003oooooob_ooooo0_l00002
ooooo`;o0000Coooool00?oooooo;?ooool6o`0004kooooo003ooooooh3ooooo003ooooooh3ooooo
003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0
003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo
00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^
ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000ooooooooool0Coooool00?oo
oooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo
003oooooobkooooo00?o0000ooooooooool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?
ooooo`00ooooool^ooooo`03o`000?oooooooooo04oooooo003oooooobkooooo00?o0000oooooooo
ool0Coooool00?oooooo;_ooool00ol0003oooooooooo`1?ooooo`00ooooool^ooooo`03o`000?oo
oooooooo04oooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo
003oooooobcooooo1?l0001@ooooo`00ooooool_ooooo`;o0000Coooool00?Sooooo1?l0000<oooo
o`Go00003?ooool5o`0000gooooo1Ol0001?ooooo`00moooool00ol0003oooooo`00000?ooooo`;o
000000?oooooo`000?l000003?ooool2o`000003ooooool0003o000000_ooooo0_l00002ooooo`;o
0000Coooool00?Oooooo00?o0000ooooool000000_l0000=ooooo`;o000000?oooooo`000?l00000
3?ooool2o`000003ooooool0003o000000_ooooo0_l00002ooooo`;o0000Coooool00?Oooooo00Go
0000ooooool0003oooooo`00000=ooooo`;o000000?oooooo`000?l000003?ooool4o`0000cooooo
0_l00002ooooo`;o0000Coooool00?Sooooo0ol0000>ooooo`;o000000?oooooo`000?l000003?oo
ool2o`000003ooooool0003o000000cooooo1_l0001>ooooo`00ooooool:ooooo`;o000000?ooooo
o`000?l000003?ooool2o`000003ooooool0003o0000063ooooo003oooooo`Wooooo1Ol0000<oooo
o`Go0000HOooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool0
0?kooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`1Cooooo`00o_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`1Cooooo`00ooooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`1Dooooo`00ooooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`1Dooooo`00ooooool1ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Gooooo003oooooo`7ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0EOooool00?oooooo0_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Fooooo`00ooooool2ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo05Kooooo003oooooo`?ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Eoooool00?oooooo0oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`1Gooooo`00ooooool4ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05Oooooo003oooooo`Co
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool0F?ooool00?oooooo1Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Hooooo`00oooo
ool5ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo05Wooooo003oooooo`Kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0FOooool0
0?oooooo1_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`1Jooooo`00ooooool7ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05[o
oooo003oooooo`Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0Foooool00?oooooo2?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`1Kooooo`00ooooool8ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo05cooooo003oooooo`Sooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0G?ooool00?oooooo2Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Looooo`00ooooool9ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo05gooooo003oooooo`[ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0GOooool00?oooooo2_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`1Nooooo`00ooooool;ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo05kooooo003oooooo`_o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Goooool00?oooooo3?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1Oooooo`00oooo
ool<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo063ooooo003oooooo`gooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0H?ooool0
0?oooooo3Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`1Qooooo`00ooooool>ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo067ooooo003oooooo`ko
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooo
ooooool0HOooool00?oooooo3oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00001Tooooo`00ooooool?ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000006Cooooo003ooooooa3ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0001Uooooo`00ooooool@ooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo0000IOooool00?oooooo4Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo06Cooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3ooooo003ooooooh3o
oooo001Eooooo`Co0000oooooolWooooo`00F?ooool2o`0000?ooooo0_l0003oooooob7ooooo000<
ooooo`Oo0000@_ooool5o`0000;ooooo1?l00004ooooo`;o00001Oooool4o`0000?ooooo1?l00002
ooooo`Co0000?_ooool5o`0005;ooooo1ol0001@ooooo`Ko00004Oooool000cooooo0_l00002oooo
o`;o0000@_ooool2o`0000;ooooo0_l000000ooooooo0000o`000004o`0000?ooooo0_l00006oooo
o`;o00001Oooool2o`0000;ooooo0_l00002ooooo`;o0000?_ooool2o`000003ooooool0003o0000
05;ooooo0_l000000ooooooo0000o`00001Booooo`;o000000?oooooo`000?l000004Oooool000co
oooo1_l00012ooooo`;o00000_ooool2o`0000?ooooo1?l00004ooooo`;o00000_ooool6o`000003
ooooool0003o000000Co00001Oooool2o`0003kooooo0_l000000ooooooo0000o`00001Booooo`;o
000000?oooooo`000?l00000Doooool2o`0001?ooooo000=ooooo`Co0000@oooool2o`0000;ooooo
0_l00002ooooo`Co00001Oooool2o`0000;ooooo0_l000000ooooooo0000o`000002ooooo`;o0000
00?oooooo`000?l000001?ooool3o`0003oooooo0_l000000ooooooo0000o`00001Booooo`;o0000
00?oooooo`000?l00000E?ooool2o`0001;ooooo000=ooooo`Co0000A?ooool:o`0000Oooooo0_l0
0002ooooo`Co00000oooool4o`0000Kooooo0_l0000nooooo`;o000000?oooooo`000?l00000D_oo
ool4o`0005;ooooo0_l00002ooooo`;o00004Oooool000kooooo0_l00008ooooo`?o0000@?ooool6
o`000003ooooool0003o000000;ooooo0_l00003ooooo`?o00001?ooool3o`0000;ooooo0_l00002
ooooo`;o0000?_ooool2o`000003ooooool0003o000005;ooooo0_l0001<ooooo`?o00001Oooool2
o`0000;ooooo0_l0000Aooooo`003Oooool3o`0000_ooooo1?l0000mooooo`Co00000_ooool6o`00
00Cooooo0_l00005ooooo`;o00000oooool4o`0003kooooo1Ol0001Booooo`?o0000B?ooool4o`00
00Wooooo1?l0000Booooo`007oooool3o`0003_ooooo0_l0000?ooooo`;o0000Voooool2o`0004co
oooo0ol0000Sooooo`008_ooool3o`0004_ooooo00?o0000ooooooooool0Uoooool00ol0003ooooo
ooooo`19ooooo`?o00009_ooool002Gooooo0ol00019ooooo`;o0000UOooool2o`0004Wooooo0ol0
000Yooooo`00:?ooool3o`0004Sooooo0_l0002Aooooo`;o0000B?ooool3o`0002cooooo000[oooo
o`Co0000A_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Gooooo00?o0000oooo
ooooool0A?ooool4o`0002oooooo000_ooooo`?o0000A?ooool2o`0004Gooooo00?o0000oooooooo
ool0@oooool2o`0004Cooooo0ol0000cooooo`00<_ooool3o`0004?ooooo0_l00013ooooo`03o`00
0?oooooooooo047ooooo0_l00013ooooo`?o0000=_ooool003Gooooo0ol00012ooooo`03o`000?oo
oooooooo043ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`?o0000>Ooo
ool003Sooooo1?l0000oooooo`;o0000@?ooool00ol0003oooooooooo`0nooooo`;o0000?oooool4
o`0003cooooo000looooo`?o0000?_ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo
03gooooo00?o0000ooooooooool0??ooool3o`00043ooooo000oooooo`?o0000??ooool2o`0003go
oooo00?o0000ooooooooool0>oooool2o`0003cooooo0ol00013ooooo`00@_ooool3o`0003_ooooo
0_l0000kooooo`03o`000?oooooooooo03Wooooo0_l0000kooooo`?o0000A_ooool004Gooooo0ol0
000jooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0>?ooool00ol0003ooooooooo
o`0hooooo`?o0000BOooool004Sooooo1?l0000gooooo`;o0000>?ooool00ol0003oooooooooo`0f
ooooo`;o0000=oooool4o`0004cooooo001<ooooo`?o0000=_ooool00ol0003oooooooooo`0eoooo
o`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool3o`00053ooooo001?ooooo`?o
0000=?ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001Cooooo`00
D_ooool3o`0003?ooooo0_l0000cooooo`03o`000?oooooooooo037ooooo0_l0000cooooo`?o0000
E_ooool005Gooooo1?l0000aooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0_ooooo`Co0000FOooool005Wooooo0ol0000_ooooo`;o0000<?ooool0
0ol0003oooooooooo`0^ooooo`;o0000;oooool3o`0005gooooo001Looooo`?o0000;_ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?ooool3o`00
063ooooo001Oooooo`?o0000;?ooool2o`0002gooooo00?o0000ooooooooool0:oooool2o`0002co
oooo0ol0001Sooooo`00H_ooool3o`0002_ooooo0_l0000[ooooo`03o`000?oooooooooo02Wooooo
0_l0000[ooooo`?o0000I_ooool006Gooooo1?l0000Yooooo`03o`000?oooooooooo02Sooooo00?o
0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`Co0000JOooool006Wooooo0ol0000W
ooooo`;o0000:?ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`0006gooooo001/oooo
o`?o00009_ooool2o`0002Kooooo00?o0000ooooooooool09?ooool2o`0002Kooooo0ol0001`oooo
o`00Koooool3o`0002Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo02?ooooo0ol0001cooooo`00L_ooool4o`0002;ooooo0_l0000Sooooo`03o`00
0?oooooooooo027ooooo0_l0000Rooooo`Co0000M_ooool007Kooooo0ol0000Qooooo`03o`000?oo
oooooooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Oooooo`?o0000N_oo
ool007Wooooo0ol0000Oooooo`;o00008?ooool00ol0003oooooooooo`0Nooooo`;o00007oooool3
o`0007gooooo001looooo`?o00007_ooool2o`0001kooooo00?o0000ooooooooool07?ooool2o`00
01kooooo0ol00020ooooo`00Ooooool3o`0001gooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo01_ooooo0ol00023ooooo`00P_ooool4o`0001[ooooo
0_l0000Kooooo`03o`000?oooooooooo01Wooooo0_l0000Jooooo`Co0000Q_ooool008Kooooo0ol0
000Iooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0Gooooo`?o0000R_ooool008Wooooo0ol0000Gooooo`;o00006?ooool00ol0003oooooooooo`0F
ooooo`;o00005oooool3o`0008gooooo002<ooooo`?o00005_ooool2o`0001Kooooo00?o0000oooo
ooooool05?ooool2o`0001Kooooo0ol0002@ooooo`00Soooool4o`0001Cooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo1?l0002Cooooo`00
Toooool3o`0001;ooooo0_l0000Cooooo`03o`000?oooooooooo017ooooo0_l0000Booooo`?o0000
Uoooool009Kooooo0ol0000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`0?ooooo`?o0000V_ooool009Wooooo0ol0000?ooooo`;o00004?ooool0
0ol0003oooooooooo`0>ooooo`;o00003oooool3o`0009gooooo002Looooo`?o00003_ooool2o`00
00kooooo00?o0000ooooooooool03?ooool2o`0000kooooo0ol0002Pooooo`00Woooool4o`0000co
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[o
oooo1?l0002Sooooo`00Xoooool3o`0000[ooooo0_l0000Gooooo`;o00002_ooool3o`000:Oooooo
002Vooooo`?o00002Oooool2o`0001?ooooo0_l00009ooooo`?o0000Z_ooool00:Wooooo0ol00008
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01_ooool3o`000:gooooo002/oooo
o`Co00001Oooool00ol0003oooooooooo`0<ooooo`;o00001Oooool4o`000;3ooooo002`ooooo`?o
00005Oooool3o`000;Cooooo002cooooo`;o00004?ooool3o`000;Oooooo002jooooo`Ko0000_ooo
ool00;cooooo0_l00031ooooo`00_?ooool2o`000<7ooooo002looooo`;o0000`Oooool00;_ooooo
1Ol0002oooooo`00_?ooool2o`000<7ooooo002mooooo`?o0000_oooool00?ooooooP?ooool00?oo
ooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00?ooooooP?ooool00001\
\>"],
  ImageRangeCache->{{{0, 382.875}, {236.25, 0}} -> {-2.1756, -0.833972, \
0.0114987, 0.00367387}}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern extraction", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[" ", "Text",
  CellTags->"Pattern extraction - Intro"],

Cell[CellGroupData[{

Cell["Introduction: Pattern extraction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Basic expression", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["theExpr = f[a, g[b, h[d]], i[e]];", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Depth[theExpr]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(4\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 0:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 0]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({f[a, g[b, h[d]], i[e]], {}}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 1:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 1] // ColumnForm", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(f$7458[x1_Symbol, x2_g, x3_i] \[RuleDelayed] f[x1, x2, x3]\)},
          {\(f$7458[a, g[b, h[d]], i[e]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {f$7458[ 
          Pattern[ x1, 
            Blank[ Symbol]], 
          Pattern[ x2, 
            Blank[ g]], 
          Pattern[ x3, 
            Blank[ i]]] :> f[ x1, x2, x3], 
        f$7458[ a, 
          g[ b, 
            h[ d]], 
          i[ e]]}],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 2:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 2] // ColumnForm", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(f$7460[x1_Symbol, x2_h, x3_Symbol] \[RuleDelayed] 
              f[a, g[x1, x2], i[x3]]\)},
          {\(f$7460[b, h[d], e]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {f$7460[ 
          Pattern[ x1, 
            Blank[ Symbol]], 
          Pattern[ x2, 
            Blank[ h]], 
          Pattern[ x3, 
            Blank[ Symbol]]] :> f[ a, 
          g[ x1, x2], 
          i[ x3]], 
        f$7460[ b, 
          h[ d], e]}],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 3:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 3] // ColumnForm", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(f$7462[x1_Symbol] \[RuleDelayed] f[a, g[b, h[x1]], i[e]]\)},
          {\(f$7462[d]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {f$7462[ 
          Pattern[ x1, 
            Blank[ Symbol]]] :> f[ a, 
          g[ b, 
            h[ x1]], 
          i[ e]], 
        f$7462[ d]}],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 4:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 4] // ColumnForm", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(f$7464[] \[RuleDelayed] f[a, g[b, h[d]], i[e]]\)},
          {\(f$7464[]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {f$7464[ ] :> f[ a, 
          g[ b, 
            h[ d]], 
          i[ e]], 
        f$7464[ ]}],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pattern extraction, level 5:", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["patternExtraction[theExpr, 5] // ColumnForm", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(f$7466[] \[RuleDelayed] f[a, g[b, h[d]], i[e]]\)},
          {\(f$7466[]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {f$7466[ ] :> f[ a, 
          g[ b, 
            h[ d]], 
          i[ e]], 
        f$7466[ ]}],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic expression", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
theChromos = 
pop[
  chromo[q[undef],
    p[
      f[A, g[B, g[4], 3], D, h[E, D, B, g[g[A,B]]], 2]
    ]
  ]
]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["TermPlot[theChromos, TreeWidth -> 1];", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.376543 0.176367 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.12963 .30902 -5 -6 ]
[.12963 .30902 5 6 ]
[.20018 .30902 -5 -6 ]
[.20018 .30902 5 6 ]
[.20018 .16187 -5 -6 ]
[.20018 .16187 5 6 ]
[.27072 .30902 -5 -6 ]
[.27072 .30902 5 6 ]
[.20018 .45617 -5 -6 ]
[.20018 .45617 5 6 ]
[.37654 .45617 -5 -6 ]
[.37654 .45617 5 6 ]
[.48236 .30902 -5 -6 ]
[.48236 .30902 5 6 ]
[.52939 .30902 -5 -6 ]
[.52939 .30902 5 6 ]
[.57643 .30902 -5 -6 ]
[.57643 .30902 5 6 ]
[.62346 .30902 -5 -6 ]
[.62346 .30902 5 6 ]
[.27072 .01472 -5.0625 -6 ]
[.27072 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.62346 .16187 -5 -6 ]
[.62346 .16187 5 6 ]
[.55291 .45617 -5 -6 ]
[.55291 .45617 5 6 ]
[.72928 .45617 -5 -6 ]
[.72928 .45617 5 6 ]
[.37654 .60332 -5 -6 ]
[.37654 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.37654 .60332 m
.02381 .45617 L
s
.37654 .60332 m
.20018 .45617 L
s
.37654 .60332 m
.37654 .45617 L
s
.37654 .60332 m
.55291 .45617 L
s
.37654 .60332 m
.72928 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .45617 m
.12963 .30902 L
s
.20018 .45617 m
.20018 .30902 L
s
.20018 .45617 m
.27072 .30902 L
s
1 g
.05 w
.12963 .30902 Mdot
0 g
gsave
.12963 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.20018 .30902 m
.20018 .16187 L
s
.9 g
.05 w
.20018 .30902 Mdot
0 g
gsave
.20018 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.20018 .16187 Mdot
0 g
gsave
.20018 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27072 .30902 Mdot
0 g
gsave
.27072 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.9 g
.20018 .45617 Mdot
0 g
gsave
.20018 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.37654 .45617 Mdot
0 g
gsave
.37654 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.55291 .45617 m
.48236 .30902 L
s
.55291 .45617 m
.52939 .30902 L
s
.55291 .45617 m
.57643 .30902 L
s
.55291 .45617 m
.62346 .30902 L
s
1 g
.05 w
.48236 .30902 Mdot
0 g
gsave
.48236 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52939 .30902 Mdot
0 g
gsave
.52939 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.57643 .30902 Mdot
0 g
gsave
.57643 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .30902 m
.62346 .16187 L
s
.9 g
.05 w
.62346 .30902 Mdot
0 g
gsave
.62346 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.62346 .16187 m
.27072 .01472 L
s
.62346 .16187 m
.97619 .01472 L
s
1 g
.05 w
.27072 .01472 Mdot
0 g
gsave
.27072 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.9 g
.62346 .16187 Mdot
0 g
gsave
.62346 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.9 g
.55291 .45617 Mdot
0 g
gsave
.55291 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.72928 .45617 Mdot
0 g
gsave
.72928 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.9 g
.37654 .60332 Mdot
0 g
gsave
.37654 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{415.812, 257},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006O00010B000`400?l00000o`00003ooooooonP
ooooo`00oooooonPooooo`00oooooonPooooo`00oooooonPooooo`00oooooonPooooo`00oooooonP
ooooo`00oooooonPooooo`00oooooonPooooo`00oooooonPooooo`00L?ooool7o`000?oooooo5Ooo
ool5o`0000oooooo001`ooooo`;o00000_ooool2o`000?oooooo5oooool2o`000003ooooool0003o
000000kooooo001`ooooo`Ko0000oooooolGooooo`;o000000?oooooo`000?l000003_ooool0077o
oooo1?l0003ooooooaSooooo1?l0000?ooooo`00LOooool4o`000?oooooo6?ooool2o`000003oooo
ool0003o000000kooooo001booooo`;o0000oooooolIooooo`;o000000?oooooo`000?l000003_oo
ool0077ooooo0ol00008ooooo`?o0000ooooool5ooooo`;o00001_ooool5o`0000oooooo001ooooo
o`;o0000ooooool1ooooo`;o00007?ooool0087ooooo0ol0003jooooo`?o00007_ooool008Cooooo
0_l0003fooooo`;o00008Oooool008Kooooo0_l0003booooo`;o00008oooool008Sooooo0ol0003/
ooooo`?o00009Oooool008_ooooo0_l0003Xooooo`;o0000:?ooool008gooooo0_l0003Sooooo`?o
0000:_ooool008oooooo0ol0003Nooooo`;o0000;Oooool009;ooooo0_l0003Jooooo`;o0000;ooo
ool009Cooooo0ol0003Dooooo`?o0000<Oooool009Oooooo0_l0003@ooooo`;o0000=?ooool009Wo
oooo0_l0003;ooooo`?o0000=_ooool009_ooooo0ol00036ooooo`;o0000>Oooool009kooooo0_l0
0031ooooo`?o0000>oooool00:3ooooo0ol0002looooo`;o0000?_ooool00:?ooooo0_l0002hoooo
o`;o0000@?ooool00:Gooooo0_l0002cooooo`?o0000@_ooool00:Oooooo0ol0002^ooooo`;o0000
AOooool00:[ooooo0_l0002Yooooo`?o0000Aoooool00:cooooo0ol0002Tooooo`;o0000B_ooool0
0:oooooo0_l0002Pooooo`;o0000C?ooool00;7ooooo0_l0002Kooooo`?o0000C_ooool00;?ooooo
0ol0002Fooooo`;o0000DOooool00;Kooooo0_l0002Aooooo`?o0000Doooool00;Sooooo0ol0002<
ooooo`;o0000E_ooool00;_ooooo0_l00028ooooo`;o0000F?ooool00;gooooo0_l00023ooooo`?o
0000F_ooool00;oooooo0ol0001nooooo`;o0000GOooool00<;ooooo0_l0001iooooo`?o0000Gooo
ool00<Cooooo0_l0001eooooo`;o0000H_ooool00<Kooooo0ol0001`ooooo`;o0000I?ooool00<Wo
oooo0_l0001[ooooo`?o0000I_ooool00<_ooooo0ol0001Vooooo`;o0000JOooool00<kooooo0_l0
001Qooooo`?o0000Joooool00=3ooooo0_l0001Mooooo`;o0000K_ooool00=;ooooo0ol0001Hoooo
o`;o0000L?ooool00=Gooooo0_l0001Cooooo`?o0000L_ooool00=Oooooo0ol0001>ooooo`;o0000
MOooool00=[ooooo0_l00019ooooo`?o0000Moooool00=cooooo0_l00015ooooo`;o0000N_ooool0
0=kooooo0ol0000oooooo`?o0000O?ooool00>7ooooo0_l0000kooooo`;o0000Ooooool00>?ooooo
0ol0000fooooo`;o0000POooool00>Kooooo0_l0000aooooo`?o0000Poooool00>Sooooo0_l0000D
ooooo`Koi^KV4oooool2o`0008Kooooo003Zooooo`?o00003oooool:onKViPkooooo0ol00028oooo
o`00kOooool2o`0000_ooooo3_oVi^H:ooooo`;o0000Roooool00>oooooo0_l00008oooooa3oi^KV
1oooool2o`0008gooooo003aooooo`?o00001Oooool@onKViPCooooo0ol0002?ooooo`00m?ooool2
o`0000;ooooo4_oVi^H00ooooooo0000o`00002Booooo`00m_ooool2o`0000Koi^KV1?l00008onKV
iP03o`000?oooooooooo09;ooooo003gooooo`[oi^KV0_l00008onKViYCooooo001Fooooo`Co0000
WOooool7onKViPGo00002?oVi^JDooooo`00Eoooool2o`0009kooooo1_oVi^H2o`0000;oi^KV0_l0
0008onKViYCooooo001Dooooo`Ko0000WOooool6onKViP;o00000_oVi^H2o`0000Soi^KVU?ooool0
05Cooooo0_l000000ooooooo0000o`00002Nooooo`Koi^KV0_l00002onKViP;o00002?oVi^JDoooo
o`00EOooool4o`0009kooooo1ooVi^H6o`0000Ooi^KVU?ooool005Kooooo0ol0002Ooooooa;oi^KV
UOooool005Oooooo0_l0002Ooooooa;oi^KVUOooool00?Wooooo4?oVi^JFooooo`00nOooool@onKV
iYKooooo003jooooo`koi^KVUoooool005Oooooo00?o0000ooooooooool0X_ooool:onKViYWooooo
001Gooooo`03o`000?oooooooooo0:Cooooo1_oVi^JKooooo`00Eoooool00ol0003oooooooooo`2V
ooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000oooo
ooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Looooo`00
Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oo
oooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool0
0ol0003oooooooooo`2Looooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo
09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oooooo
00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003ooooooooo
o`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000
ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Loooo
o`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`00
0?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_oo
ool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooo
oooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oo
oooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003ooooo
ooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o
0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2L
ooooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03
o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0
Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oo
oooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool0
05Oooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003ooooooooo
o`2Looooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Goooo
o`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?ooool005Oooooo00?o0000oooooooo
ool0Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0003oooooooooo`2Vooooo`03o`00
0?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0W?oo
ool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`2Looooo`00Eoooool00ol0
003oooooooooo`2Vooooo`03o`000?oooooooooo09cooooo001Gooooo`03o`000?oooooooooo0:Ko
oooo00?o0000ooooooooool0W?ooool005Oooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`2Looooo`00E?ooool6onKViZCooooo1_oVi^JKooooo`00D_ooool:onKViZ3ooooo2_oVi^JI
ooooo`00D?ooool>onKViYcooooo3_oVi^JGooooo`00Coooool@onKViY[ooooo4?oVi^JFooooo`00
Coooool@onKViY[ooooo4?oVi^JFooooo`00C_ooool7onKViPCo00001ooVi^JHooooo`Koi^KV1?l0
0008onKViYGooooo001>ooooo`[oi^KV0_l00006onKViYSooooo2OoVi^H2o`0000Ooi^KVUOooool0
03Oooooo1Ol0000Aooooo`Soi^KV1Ol00007onKViQ3ooooo1?l0001Aooooo`Co00003_ooool5o`00
00kooooo1Ol00007ooooo`Ooi^KV1Ol00008onKViYCooooo000hooooo`;o000000?oooooo`000?l0
00004?ooool7onKViP;o00000_oVi^H2o`0000Ooi^KV3oooool2o`0000;ooooo0_l0001?ooooo`03
o`000?oooooo0000017ooooo0_l000000ooooooo0000o`00000>ooooo`;o000000?oooooo`000?l0
00001_ooool6onKViP;o00000_oVi^H2o`0000Soi^KVU?ooool003Sooooo0_l000000ooooooo0000
o`00000@ooooo`Ooi^KV0_l00002onKViP;o00001ooVi^HCooooo`;o0000Coooool00ol0003ooooo
o`000002o`0000oooooo0_l000000ooooooo0000o`00000>ooooo`;o000000?oooooo`000?l00000
1_ooool6onKViP;o00000_oVi^H2o`0000Soi^KVU?ooool003Sooooo1?l0000Aooooo`Ooi^KV0_l0
0002onKViP;o00001ooVi^HAooooo`?o0000D?ooool01Ol0003oooooo`000?oooooo000000oooooo
0_l000000ooooooo0000o`00000>ooooo`Co00001oooool6onKViP;o00000_oVi^H2o`0000Soi^KV
U?ooool003Sooooo0_l000000ooooooo0000o`00000@ooooo`Soi^KV1_l00006onKViQ?ooooo0_l0
001@ooooo`?o00004?ooool2o`000003ooooool0003o000000kooooo0_l000000ooooooo0000o`00
0006ooooo`Ooi^KV1_l00007onKViYCooooo000hooooo`;o000000?oooooo`000?l000004?oooolD
onKViPoooooo0_l00002ooooo`;o0000Hoooool2o`000003ooooool0003o000000kooooo0_l00000
0ooooooo0000o`000006oooooaCoi^KVU?ooool003Oooooo1Ol0000Boooooa;oi^KV4Oooool4o`00
06?ooooo1Ol0000>ooooo`Go00002?oooolBonKViYGooooo001>oooooa;oi^KVV?oooolBonKViYGo
oooo001?oooooa3oi^KVV_ooool@onKViYKooooo001?oooooa3oi^KVV_ooool@onKViYKooooo001@
ooooo`koi^KVW?ooool>onKViYOooooo001Booooo`[oi^KVX?ooool:onKViYWooooo000oooooo`03
o`000?oooooooooo01;ooooo1_oVi^HDooooo`03o`000?oooooooooo05cooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`06onKViY_ooooo000oooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool05?ooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0:7ooooo
0010ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003ooooooooo
o`1Looooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo0:7ooooo0010ooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0:;ooooo0011oooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1Noooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo0:;ooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`1Pooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0:?ooooo0012ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`1Pooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0:?ooooo0012ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0:Cooooo0013ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo0:Cooooo0013ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`1Tooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo0:Gooooo0014ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`1Tooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:Go
oooo0014ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`1Vooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo0:Kooooo0015ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:Kooooo0015
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1X
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo0:Oooooo0016ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0:Oooooo0016ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`1Zooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo0:Sooooo0017ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1Zooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:Sooooo0017ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1/ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo0:Wooooo0018ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:Wooooo0018ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1^ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
0:[ooooo0019ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`1^ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo0:[ooooo0019ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`1^ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0:[ooooo
0019ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`1`ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo0:_ooooo001:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`1`ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0:_ooooo001:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1boooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0:cooooo001;ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0:cooooo001;ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1dooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo0:gooooo001<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`1dooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0:gooooo001<ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1fooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo0:kooooo001=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1fooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo0:kooooo001=ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1hooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:oo
oooo001>ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1hooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0:oooooo001>ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0;3ooooo001?
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1j
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo0;3ooooo001?ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo00000;?ooooo001@ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1looooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0;7ooooo001@oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1noooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo00000;Cooooo001A
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1n
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo00000;Cooooo
001Aooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`20ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000]Oooool005;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo083ooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool0002eooooo`00D_ooool00ol0003o
ooooonKViP05onKViP;ooooo00?o0000ooooooooool0P?ooool00ol0003oooooooooo`06onKViP03
ooooool0003ooooo0;Cooooo001Booooo`[oi^KVQ?ooool:onKVi[Gooooo001@ooooo`koi^KVP?oo
ool>onKVi[?ooooo001?oooooa3oi^KVO_ooool@onKVi[;ooooo001?oooooa3oi^KVO_ooool@onKV
i[;ooooo001>ooooo`Ooi^KV1?l00007onKViWcooooo4_oVi^Jaooooo`00C_ooool:onKViP;o0000
1_oVi^Iloooooa;oi^KV/Oooool000gooooo1ol0000iooooo`Soi^KV1Ol00007onKViSWooooo1Ol0
000looooo`Koi^KV1ol00007onKViSWooooo1_l0001aooooo`003Oooool2o`0000;ooooo0_l0000j
ooooo`Ooi^KV0_l00002onKViP;o00001ooVi^Hjooooo`;o000000?oooooo`000?l00000>oooool7
onKViP;o000000?oi^KVo`000?l000002?oVi^Hjooooo`;o000000?oooooo`000?l00000LOooool0
00gooooo1_l0000jooooo`Ooi^KV0_l00002onKViP;o00001ooVi^Hjooooo`;o000000?oooooo`00
0?l00000>oooool7onKViP;o000000?oi^KVo`000?l000002?oVi^Hkooooo`;o0000Loooool000ko
oooo1?l0000kooooo`Ooi^KV0_l00002onKViP;o00001ooVi^Hjooooo`;o000000?oooooo`000?l0
0000>oooool7onKViP;o000000?oi^KVo`000?l000002?oVi^Hlooooo`;o0000L_ooool000kooooo
1?l0000kooooo`Soi^KV1_l00006onKViS[ooooo0_l000000ooooooo0000o`00000kooooo`Ooi^KV
1?l00009onKViSWooooo0_l00002ooooo`;o0000LOooool000oooooo0_l0000loooooaCoi^KV>_oo
ool2o`000003ooooool0003o000003_ooooo1ooVi^H2o`0000_oi^KV>Oooool2o`0000;ooooo0_l0
001aooooo`003_ooool3o`0000Wooooo0_l0000boooooa;oi^KV>_ooool5o`0003gooooo1OoVi^H3
o`0000[oi^KV<_ooool2o`0000Oooooo1?l0001booooo`007?ooool2o`00033ooooo4_oVi^Iloooo
oa;oi^KV<?ooool2o`0007oooooo000Nooooo`?o0000;_ooool@onKViP03o`000?oooooooooo07[o
oooo00?o0000onKVi_oVi^H03_oVi^H^ooooo`?o0000POooool0027ooooo0_l0000/oooooa3oi^KV
00?oooooo`000?ooool0NOooool00ol0003oooooonKViP0?onKViRcooooo0_l00024ooooo`008ooo
ool2o`0002_ooooo3_oVi^H3ooooo`03o`000?oooooooooo07Kooooo00Co0000oooooooooooooooo
3_oVi^H[ooooo`;o0000Q_ooool002Gooooo0ol0000Zooooo`[oi^KV1_ooool00ol0003ooooooooo
o`1dooooo`03o`000?oooooooooo00Cooooo2_oVi^HZooooo`?o0000R?ooool002Sooooo0_l0000Z
ooooo`Koi^KV2Oooool00ol0003oooooooooo`1aooooo`;o00002Oooool6onKViR[ooooo0_l0002;
ooooo`00:_ooool2o`0003Sooooo0_l0000gooooo`03o`000?oooooooooo03Kooooo00?o0000oooo
ooooool0=_ooool3o`0008gooooo000/ooooo`?o0000=oooool00ol0003oooooooooo`0dooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool2o`00093ooooo000_ooooo`;o0000
=_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0
=?ooool2o`0009;ooooo000aooooo`?o0000=?ooool00ol0003oooooooooo`0booooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool0<_ooool3o`0009Cooooo000dooooo`;o0000<oooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo0_l0000cooooo`;o0000Uoooool0
03Kooooo0_l0000booooo`;o0000<Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo
033ooooo0ol0002Iooooo`00>?ooool3o`00037ooooo00?o0000ooooooooool0;_ooool00ol0003o
ooooooooo`0_ooooo`03o`000?oooooooooo02oooooo0_l0002Looooo`00>oooool2o`00033ooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02gooooo
0ol0002Nooooo`00?Oooool3o`0002kooooo00?o0000ooooooooool0;?ooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo02cooooo0_l0002Qooooo`00@?ooool2o`0002gooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0[ooooo`;o0000;Oooool2o`000:?ooooo0012oooo
o`;o0000;?ooool2o`0002_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zoooo
o`?o0000YOooool004Cooooo0ol0000[ooooo`03o`000?oooooooooo02Sooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0Yooooo`;o0000Z?ooool004Oooooo0_l0000Zooooo`03o`00
0?oooooooooo02Oooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Wooooo`?o0000
Z_ooool004Wooooo0ol0000Xooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0Vooooo`;o0000[Oooool004cooooo0_l0000Wooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool09Oooool2o`0002Oooooo0_l0002_ooooo`00C_ooool2o`00
02Kooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
02Cooooo0ol0002aooooo`00D?ooool3o`0002Cooooo0_l0000Tooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool08oooool2o`000;Cooooo001Cooooo`;o00009?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08Oooool3o`000;Kooooo
001Eooooo`?o00008_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo0_l0
000Rooooo`;o0000^Oooool005Sooooo0_l0000Qooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0Pooooo`;o0000^oooool005[ooooo0_l0000Poooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Noooo
o`?o0000_Oooool005cooooo0ol0000Nooooo`;o00007_ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01gooooo0_l00030ooooo`00Goooool2o`0001kooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01_ooooo0ol00032ooooo`00HOoo
ool2o`0001gooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Jooooo`;o00007?oo
ool2o`000<Gooooo001Sooooo`?o00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool06_ooool2o`000<Oooooo001Vooooo`;o00006_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool3o`00
0<Wooooo001Xooooo`?o00006?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool05oooool2o`000<cooooo001[ooooo`;o00005oooool2o`0001Oooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`?o0000c_ooool006gooooo0_l0
000Gooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool2o`0001Kooooo0_l0
003Aooooo`00Koooool3o`0001Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo01Cooooo0_l0003Cooooo`00L_ooool2o`0001Cooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo0ol0003Eoooo
o`00M?ooool3o`0001;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo0_l0003Hooooo`00Moooool2o`00017ooooo0_l0000Aooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool03oooool3o`000=[ooooo001iooooo`;o00004Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo0_l0000@ooooo`;o0000gOoo
ool007_ooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`?o0000goooool007kooooo0_l0000>ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`;o0000h_ooool0083o
oooo0ol0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0;ooooo`;o0000i?ooool008?ooooo0_l0000;ooooo`;o00002oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo0ol0003Vooooo`00QOooool2o`0000_ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o00002_ooool2o`000>Wooooo0027
ooooo`?o00002Oooool00ol0003oooooooooo`05ooooo`Koi^KV1_ooool00ol0003oooooooooo`07
ooooo`?o0000joooool008[ooooo0_l00008ooooo`03o`000?oooooooooo00;ooooo2_oVi^H3oooo
o`03o`000?oooooooooo00Kooooo0_l0003^ooooo`00S?ooool2o`0000Oooooo00?o0000oooooooV
i^H03OoVi^H00ol0003oooooooooo`05ooooo`;o0000l?ooool008kooooo0ol00005oooooa3oi^KV
1?ooool3o`000?;ooooo002Aooooo`;o00000oooool@onKViP;ooooo0_l0003eooooo`00Toooool2
o`0001;oi^KV00?o0000ooooooooool0mOooool009Gooooo4_oVi^Khooooo`00U?ooool6onKViPKo
00002?oVi^Kgooooo`00U?ooool8onKViP;o00002_oVi^Kgooooo`00U?ooool8onKViP;o00002_oV
i^Kgooooo`00U?ooool8onKViP;o00002_oVi^Kgooooo`00U?ooool7onKViPGo00002?oVi^Kgoooo
o`00U?ooool8onKViP;o00002_oVi^Kgooooo`00UOooool8onKViP?o00001ooVi^Khooooo`00UOoo
oolBonKVi_Sooooo002Foooooa3oi^KVnOooool009Kooooo4?oVi^Kiooooo`00Uoooool>onKVi_[o
oooo002Iooooo`[oi^KVo?ooool009_ooooo1_oVi^Knooooo`00\
\>"],
  ImageRangeCache->{{{0, 414.812}, {256, 0}} -> {-2.23358, -0.833976, \
0.0141441, 0.00339047}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern extraction examples", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Population of mutants", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
EncapsulationRules = {};

macroChromos = Join @@ Table[
MacroExtraction[theChromos, SelectionMode -> RANDOM], {10}]

macroChromos // ColumnForm\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[chromo[q[undef], p[f$7487[4, g[A, B]]]], 
      chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$7506[g[A, B]], 2]]], 
      chromo[q[undef], p[f[A, g[B, g[4], 3], D, h$7525[g[A, B]], 2]]], 
      chromo[q[undef], 
        p[f[A, g$7544[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]], chromo[q[undef], 
        p[f$7563[B, g[4], 3, \[ExponentialE], D, B, g[g[A, B]]]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h$7582[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]], chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g$7601[]], 2]]], 
      chromo[q[undef], 
        p[f[A, g$7620[4], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g$7639[], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g$7658[A, B]], 
            2]]]]\)], "Output"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(chromo[q[undef], p[f$7487[4, g[A, B]]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h$7506[g[A, B]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h$7525[g[A, B]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g$7544[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f$7563[B, g[4], 3, \[ExponentialE], D, B, g[g[A, B]]]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h$7582[\[ExponentialE], D, B, g[g[A, B]]], 2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g$7601[]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g$7620[4], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g$7639[], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
                  2]]]\)},
          {\(chromo[q[undef], 
              p[f[A, g[B, g[4], 3], D, 
                  h[\[ExponentialE], D, B, g$7658[A, B]], 2]]]\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ 
        pop[ 
          chromo[ 
            q[ undef], 
            p[ 
              f$7487[ 4, 
                g[ A, B]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h$7506[ 
                  g[ A, B]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h$7525[ 
                  g[ A, B]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g$7544[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f$7563[ B, 
                g[ 4], 3, E, D, B, 
                g[ 
                  g[ A, B]]]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h$7582[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g$7601[ ]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g$7620[ 4], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g$7639[ ], D, 
                h[ E, D, B, 
                  g[ 
                    g[ A, B]]], 2]]], 
          chromo[ 
            q[ undef], 
            p[ 
              f[ A, 
                g[ B, 
                  g[ 4], 3], D, 
                h[ E, D, B, 
                  g$7658[ A, B]], 2]]]]],
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Encapsulation / decapsulation rules", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["EncapsulationRules", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \({f$7487[x1_Integer, x2_g] \[RuleDelayed] 
        f[A, g[B, g[x1], 3], D, h[\[ExponentialE], D, B, g[x2]], 2], 
      h$7506[x1_g] \[RuleDelayed] h[\[ExponentialE], D, B, g[x1]], 
      h$7525[x1_g] \[RuleDelayed] h[\[ExponentialE], D, B, g[x1]], 
      g$7544[x1_Symbol, x2_g, x3_Integer] \[RuleDelayed] g[x1, x2, x3], 
      f$7563[x1_Symbol, x2_g, x3_Integer, x4_Symbol, x5_Symbol, x6_Symbol, 
          x7_g] \[RuleDelayed] f[A, g[x6, x2, x3], D, h[x4, x5, B, x7], 2], 
      h$7582[x1_Symbol, x2_Symbol, x3_Symbol, x4_g] \[RuleDelayed] 
        h[x1, x2, x3, x4], g$7601[] \[RuleDelayed] g[g[A, B]], 
      g$7620[x1_Integer] \[RuleDelayed] g[B, g[x1], 3], 
      g$7639[] \[RuleDelayed] g[B, g[4], 3], 
      g$7658[x1_Symbol, x2_Symbol] \[RuleDelayed] g[g[x1, x2]]}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Visualisation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
TermPlot[#, TreeWidth -> .2, TextDisplay -> True,
            LabelSize -> 0.05, LabelColor -> 1
]& /@ macroChromos;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.426953 0.201572 0.603319 1.47151 [
[.02381 .30902 -5 -6 ]
[.02381 .30902 5 6 ]
[.684 .01472 -5.0625 -6 ]
[.684 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.8301 .30902 -5 -6 ]
[.8301 .30902 5 6 ]
[.42695 .60332 -20 -6 ]
[.42695 .60332 20 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.42695 .60332 m
.02381 .30902 L
s
.42695 .60332 m
.8301 .30902 L
s
1 g
.05 w
.02381 .30902 Mdot
0 g
gsave
.02381 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 Mabswid
.8301 .30902 m
.684 .01472 L
s
.8301 .30902 m
.97619 .01472 L
s
1 g
.05 w
.684 .01472 Mdot
0 g
gsave
.684 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.8301 .30902 Mdot
0 g
gsave
.8301 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.42695 .60332 Mdot
0 g
gsave
.42695 .60332 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7487) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00ooooool;ooooo`Oo0000JOooool5o`0000oooooo
003oooooo`_ooooo0_l00002ooooo`;o0000Joooool2o`000003ooooool0003o000000kooooo003o
ooooo`_ooooo1_l0001[ooooo`;o000000?oooooo`000?l000003_ooool00?oooooo3?ooool4o`00
06cooooo1?l0000?ooooo`00ooooool<ooooo`Co0000K?ooool2o`000003ooooool0003o000000ko
oooo003oooooo`gooooo0_l0001]ooooo`;o000000?oooooo`000?l000003_ooool00?oooooo3?oo
ool3o`0006cooooo1Ol0000?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00
oooooon?ooooo`00oooooolBooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool04_oo
ool00?oooooo4oooool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo01?ooooo003ooooo
oa?ooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`0Cooooo`00oooooolDooooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool05?ooool00?oooooo5?ooool00ol0003ooooo
ooooo`1Qooooo`03o`000?oooooooooo01Cooooo003ooooooaGooooo00?o0000ooooooooool0Gooo
ool00ol0003oooooooooo`0Eooooo`00oooooolEooooo`03o`000?oooooooooo05oooooo00?o0000
ooooooooool05Oooool00?oooooo5_ooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo
01Kooooo003ooooooaKooooo00?o0000ooooooooool0GOooool00ol0003oooooooooo`0Fooooo`00
oooooolGooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool05oooool00?oooooo5ooo
ool00ol0003oooooooooo`1Kooooo`03o`000?oooooooooo01Oooooo003ooooooaSooooo00?o0000
ooooooooool0FOooool00ol0003oooooooooo`0Hooooo`00oooooolHooooo`03o`000?oooooooooo
05Wooooo00?o0000ooooooooool06?ooool00?oooooo6Oooool00ol0003oooooooooo`1Gooooo`03
o`000?oooooooooo01Wooooo003ooooooaWooooo00?o0000ooooooooool0Eoooool00ol0003ooooo
ooooo`0Iooooo`00oooooolJooooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool06_oo
ool00?oooooo6_ooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo01[ooooo003ooooo
oa_ooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0Kooooo`00oooooolKooooo`03
o`000?oooooooooo05?ooooo00?o0000ooooooooool06oooool00?oooooo7?ooool00ol0003ooooo
ooooo`1Aooooo`03o`000?oooooooooo01cooooo003ooooooacooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`0Looooo`00oooooolMooooo`03o`000?oooooooooo04oooooo00?o0000
ooooooooool07Oooool00?oooooo7Oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo
01gooooo003ooooooakooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0Nooooo`00
oooooolNooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool07_ooool00?oooooo7ooo
ool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo01oooooo003ooooooaoooooo00?o0000
ooooooooool0Boooool00ol0003oooooooooo`0Oooooo`00oooooolPooooo`03o`000?oooooooooo
04Wooooo00?o0000ooooooooool08?ooool00?oooooo8?ooool00ol0003oooooooooo`19ooooo`03
o`000?oooooooooo023ooooo003oooooob7ooooo00?o0000ooooooooool0Aoooool00ol0003ooooo
ooooo`0Qooooo`00oooooolQooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool08Ooo
ool00?oooooo8_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo02;ooooo003ooooo
ob;ooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0Rooooo`00oooooolSooooo`03
o`000?oooooooooo04?ooooo00?o0000ooooooooool08oooool00?oooooo8oooool00ol0003ooooo
ooooo`13ooooo`03o`000?oooooooooo02?ooooo003oooooobCooooo00?o0000ooooooooool0@Ooo
ool00ol0003oooooooooo`0Tooooo`00oooooolTooooo`03o`000?oooooooooo047ooooo00?o0000
ooooooooool09?ooool00?oooooo9Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo
02Gooooo003oooooobGooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0Uooooo`00
oooooolVooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool09_ooool00?oooooo9_oo
ool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo02Kooooo003oooooobOooooo00?o0000
ooooooooool0>oooool00ol0003oooooooooo`0Wooooo`00oooooolWooooo`03o`000?oooooooooo
03_ooooo00?o0000ooooooooool09oooool00?oooooo:?ooool00ol0003oooooooooo`0iooooo`03
o`000?oooooooooo02Sooooo003oooooobSooooo00?o0000ooooooooool0>Oooool00ol0003ooooo
ooooo`0Xooooo`00oooooolYooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0:Ooo
ool00?oooooo:Oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02Wooooo003ooooo
ob[ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0Zooooo`00oooooolZooooo`03
o`000?oooooooooo03Gooooo00?o0000ooooooooool0:_ooool00?oooooo:_ooool00ol0003ooooo
ooooo`0eooooo`03o`000?oooooooooo02[ooooo003oooooob_ooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`0[ooooo`00ooooool[ooooo`03o`000?oooooooooo03?ooooo00?o0000
ooooooooool0:oooool00?oooooo;?ooool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo
02cooooo003oooooobcooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0/ooooo`00
ooooool]ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;Oooool00?oooooo;Ooo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02gooooo003oooooobkooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`00ooooool^ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0;_ooool00?oooooo;oooool00ol0003oooooooooo`0[ooooo`03
o`000?oooooooooo02oooooo003ooooooboooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0_ooooo`00ooooool`ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0<?oo
ool00?oooooo<?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo033ooooo003ooooo
oc7ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0aooooo`00oooooolaooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool0<Oooool00?oooooo<_ooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo03;ooooo003ooooooc;ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0booooo`00oooooolcooooo`03o`000?oooooooooo02?ooooo00?o0000
ooooooooool0<oooool00?oooooo<oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo
03?ooooo003oooooocCooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0dooooo`00
ooooooldooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0=?ooool00?oooooo=Ooo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo03Gooooo003oooooocGooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0eooooo`00oooooolfooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool0=_ooool00?oooooo=_ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo03Kooooo003oooooocOooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0gooooo`00oooooolgooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0=ooo
ool00?oooooo>?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo03Sooooo003ooooo
ocSooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0hooooo`00ooooooliooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool0>Oooool00?oooooo>Oooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo03Wooooo003ooooooc[ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0jooooo`00ooooooljooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool0>_ooool00?oooooo>oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
03_ooooo003ooooooc_ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0kooooo`00
oooooollooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0??ooool00?oooooo??oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03cooooo003oooooocgooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`0mooooo`00oooooolmooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0?Oooool00?oooooo?_ooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo03kooooo003oooooockooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0nooooo`00ooooooloooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0?ooo
ool00?oooooo?oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo03oooooo003ooooo
od3ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`10ooooo`00oooooom0ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0@?ooool00?oooooo@Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo047ooooo003ooooood7ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`11ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00
oooooon?ooooo`00oooooom4ooooo`Co0000Aoooool00?ooooooAoooool2o`0004Kooooo000>oooo
o`Co0000oooooolbooooo`Go0000A_ooool000oooooo0_l0003ooooooc;ooooo0_l00002ooooo`;o
0000A_ooool000cooooo1_l0003ooooooc7ooooo0_l00002ooooo`;o0000A_ooool000cooooo0_l0
00000ooooooo0000o`00003ooooooc;ooooo0_l00002ooooo`;o0000A_ooool000gooooo1?l0003o
oooooc?ooooo1_l00015ooooo`003_ooool3o`000?ooooooO_ooool000oooooo0_l0003oooooogko
oooo003oooooohoooooo000Hooooo`03o`000?oooooooooo0?oooooo8_ooool00ol0003ooooooooo
o`1?ooooo`006Oooool00ol0003oooooooooo`3oooooob3ooooo00?o0000ooooooooool0D?ooool0
01[ooooo0_l0003ooooooakooooo0_l0001Cooooo`007?ooool00ol0003oooooooooo`3ooooooa[o
oooo00?o0000ooooooooool0Doooool001gooooo00?o0000ooooooooool0oooooolHooooo`03o`00
0?oooooooooo05Cooooo000Nooooo`;o0000oooooolFooooo`;o0000Eoooool0023ooooo00?o0000
ooooooooool0oooooolBooooo`03o`000?oooooooooo05Oooooo000Qooooo`;o0000ooooool@oooo
o`;o0000F_ooool002?ooooo00?o0000ooooooooool0ooooool<ooooo`03o`000?oooooooooo05[o
oooo000Tooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0003oooooooooo`1Kooooo`009Ooo
ool2o`000?oooooo2?ooool2o`0005kooooo000Wooooo`03o`000?oooooooooo0?oooooo1?ooool0
0ol0003oooooooooo`1Nooooo`00:?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o0000oooo
ooooool0Goooool002Wooooo0_l0003oooooo`;o0000H_ooool002_ooooo00?o0000ooooooooool0
noooool00ol0003oooooooooo`1Rooooo`00;?ooool00ol0003oooooooooo`3iooooo`03o`000?oo
oooooooo06?ooooo000]ooooo`;o0000moooool2o`0006Kooooo000_ooooo`03o`000?oooooooooo
0??ooooo00?o0000ooooooooool0I_ooool0033ooooo0_l0003aooooo`;o0000JOooool003;ooooo
00?o0000ooooooooool0kOooool00ol0003oooooooooo`1Yooooo`00<oooool00ol0003ooooooooo
o`3[ooooo`03o`000?oooooooooo06[ooooo000dooooo`;o0000jOooool2o`0006gooooo000foooo
o`03o`000?oooooooooo0>Gooooo00?o0000ooooooooool0KOooool003Oooooo00?o0000oooooooo
ool0hoooool00ol0003oooooooooo`1^ooooo`00>?ooool2o`000>7ooooo0_l0001aooooo`00>_oo
ool00ol0003oooooooooo`3Mooooo`03o`000?oooooooooo077ooooo000kooooo`;o0000foooool2
o`0007Cooooo000mooooo`03o`000?oooooooooo0=Oooooo00?o0000ooooooooool0M?ooool003ko
oooo00?o0000ooooooooool0eOooool00ol0003oooooooooo`1eooooo`00?oooool2o`000=?ooooo
0_l0001hooooo`00@Oooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo07Sooooo0012
ooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0NOooool004?ooooo0_l0003;oooo
o`;o0000O?ooool004Gooooo00?o0000ooooooooool0aoooool00ol0003oooooooooo`1looooo`00
A_ooool2o`000<Gooooo0_l0001oooooo`00B?ooool00ol0003oooooooooo`31ooooo`03o`000?oo
oooooooo07oooooo0019ooooo`03o`000?oooooooooo0;oooooo00?o0000ooooooooool0P?ooool0
04[ooooo0_l0002mooooo`;o0000Poooool004cooooo00?o0000ooooooooool0^Oooool00ol0003o
ooooooooo`23ooooo`00COooool00ol0003oooooooooo`2gooooo`03o`000?oooooooooo08Cooooo
001>ooooo`;o0000]Oooool2o`0008Oooooo001@ooooo`03o`000?oooooooooo0;7ooooo00?o0000
ooooooooool0Qoooool0057ooooo0_l0002_ooooo`;o0000R_ooool005?ooooo00?o0000oooooooo
ool0Zoooool00ol0003oooooooooo`2:ooooo`00E?ooool00ol0003oooooooooo`2Yooooo`03o`00
0?oooooooooo08_ooooo001Eooooo`;o0000Yoooool2o`0008kooooo001Gooooo`03o`000?oooooo
oooo0:?ooooo00?o0000ooooooooool0S_ooool005Sooooo00?o0000ooooooooool0XOooool00ol0
003oooooooooo`2?ooooo`00FOooool2o`0009oooooo0_l0002Booooo`00Foooool00ol0003ooooo
ooooo`2Kooooo`03o`000?oooooooooo09;ooooo001Looooo`;o0000VOooool2o`0009Gooooo001N
ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool0UOooool005oooooo00?o0000oooo
ooooool0Toooool00ol0003oooooooooo`2Fooooo`00H?ooool2o`00097ooooo0_l0002Iooooo`00
H_ooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo09Wooooo001Sooooo`03o`000?oo
oooooooo08_ooooo00?o0000ooooooooool0V_ooool006Cooooo0_l00029ooooo`;o0000WOooool0
06Kooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`2Mooooo`00Ioooool00ol0003o
ooooooooo`23ooooo`03o`000?oooooooooo09kooooo001Xooooo`;o0000POooool2o`000:7ooooo
001Zooooo`03o`000?oooooooooo07gooooo00?o0000ooooooooool0XOooool006_ooooo0_l0001k
ooooo`;o0000Y?ooool006gooooo00?o0000ooooooooool0Moooool00ol0003oooooooooo`2Toooo
o`00K_ooool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo0:Gooooo001_ooooo`;o0000
Loooool2o`000:Sooooo001aooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool0Z?oo
ool007;ooooo00?o0000ooooooooool0KOooool00ol0003oooooooooo`2Yooooo`00Loooool2o`00
06_ooooo0_l0002/ooooo`00MOooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo0:co
oooo001fooooo`;o0000IOooool2o`000:oooooo001hooooo`03o`000?oooooooooo067ooooo00?o
0000ooooooooool0[oooool007Wooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`2`
ooooo`00N_ooool2o`0005gooooo0_l0002cooooo`00O?ooool00ol0003oooooooooo`1Iooooo`03
o`000?oooooooooo0;?ooooo001mooooo`03o`000?oooooooooo05Oooooo00?o0000ooooooooool0
]?ooool007kooooo0_l0001Eooooo`;o0000]oooool0083ooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`2gooooo`00POooool2o`0004oooooo0_l0002jooooo`00Poooool00ol0003o
ooooooooo`1;ooooo`03o`000?oooooooooo0;[ooooo0024ooooo`03o`000?oooooooooo04Wooooo
00?o0000ooooooooool0^oooool008Gooooo0_l00017ooooo`;o0000__ooool008Oooooo00?o0000
ooooooooool0@oooool00ol0003oooooooooo`2nooooo`00R?ooool00ol0003oooooooooo`11oooo
o`03o`000?oooooooooo0;oooooo0029ooooo`;o0000?oooool2o`000<;ooooo002;ooooo`03o`00
0?oooooooooo03_ooooo00?o0000ooooooooool0`_ooool008cooooo0_l0000iooooo`;o0000aOoo
ool008kooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`35ooooo`00Soooool00ol0
003oooooooooo`0cooooo`03o`000?oooooooooo0<Kooooo002@ooooo`;o0000<Oooool2o`000<Wo
oooo002Booooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0bOooool009?ooooo00?o
0000ooooooooool0:oooool00ol0003oooooooooo`3:ooooo`00U?ooool2o`0002Wooooo0_l0003=
ooooo`00U_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<gooooo002Gooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0c_ooool009Sooooo0_l0000Qooooo`;o0000
dOooool009[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3Aooooo`00Voooool2
o`0001_ooooo0_l0003Dooooo`00WOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
0=Cooooo002Nooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0eOooool009oooooo
0_l0000Cooooo`;o0000f?ooool00:7ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`3Hooooo`00X_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0=Wooooo003ooooo
ohoooooo003oooooohoooooo002Qooooo`;o0000joooool009Sooooo1_l00002ooooo`Co00001?oo
ool2o`0000Gooooo1?l00002ooooo`Co00001?ooool2o`000<oooooo002Jooooo`;o00000oooool6
o`0000?ooooo0_l00006ooooo`;o00000_ooool2o`0000;ooooo0_l00003ooooo`;o0000coooool0
09[ooooo0_l00005ooooo`Co00001?ooool2o`0000;ooooo1_l000000ooooooo0000o`000002oooo
o`;o00001?ooool2o`000<kooooo002Jooooo`;o00001?ooool4o`0000Gooooo0_l00002ooooo`;o
000000?oooooo`000?l000000oooool4o`0000Gooooo0_l0003>ooooo`00VOooool5o`000003oooo
ool0003o000000;o00001oooool2o`0000;ooooo1?l00002ooooo`;o00000_ooool2o`0000Gooooo
0_l0003=ooooo`00V_ooool2o`0000?ooooo1_l000000ooooooo0000o`000002ooooo`;o00000ooo
ool3o`0000;ooooo0_l00002ooooo`;o000000?oooooo`000?l000000_ooool2o`000<gooooo002K
ooooo`?o00000_ooool4o`0000;ooooo1_l00004ooooo`;o00000oooool4o`0000;ooooo1_l0003=
ooooo`00XOooool2o`000>_ooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003o
ooooohoooooo0000\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.20446, -0.416988, \
0.0129048, 0.00176774}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.49405 0.23512 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19077 .21092 -5 -6 ]
[.19077 .21092 5 6 ]
[.25893 .21092 -5 -6 ]
[.25893 .21092 5 6 ]
[.25893 .01472 -5 -6 ]
[.25893 .01472 5 6 ]
[.32709 .21092 -5 -6 ]
[.32709 .21092 5 6 ]
[.25893 .40712 -5 -6 ]
[.25893 .40712 5 6 ]
[.49405 .40712 -5 -6 ]
[.49405 .40712 5 6 ]
[.72917 .40712 -20 -6 ]
[.72917 .40712 20 6 ]
[.48215 .01472 -5.0625 -6 ]
[.48215 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.72917 .21092 -5 -6 ]
[.72917 .21092 5 6 ]
[.96429 .40712 -5 -6 ]
[.96429 .40712 5 6 ]
[.49405 .60332 -5 -6 ]
[.49405 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49405 .60332 m
.02381 .40712 L
s
.49405 .60332 m
.25893 .40712 L
s
.49405 .60332 m
.49405 .40712 L
s
.49405 .60332 m
.72917 .40712 L
s
.49405 .60332 m
.96429 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25893 .40712 m
.19077 .21092 L
s
.25893 .40712 m
.25893 .21092 L
s
.25893 .40712 m
.32709 .21092 L
s
1 g
.05 w
.19077 .21092 Mdot
0 g
gsave
.19077 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25893 .21092 m
.25893 .01472 L
s
1 g
.05 w
.25893 .21092 Mdot
0 g
gsave
.25893 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25893 .01472 Mdot
0 g
gsave
.25893 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32709 .21092 Mdot
0 g
gsave
.32709 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25893 .40712 Mdot
0 g
gsave
.25893 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49405 .40712 Mdot
0 g
gsave
.49405 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72917 .40712 m
.72917 .21092 L
s
1 g
.05 w
.72917 .40712 Mdot
0 g
gsave
.72917 .40712 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h$7506) show
1.000 setlinewidth
grestore
.5 Mabswid
.72917 .21092 m
.48215 .01472 L
s
.72917 .21092 m
.97619 .01472 L
s
1 g
.05 w
.48215 .01472 Mdot
0 g
gsave
.48215 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.72917 .21092 Mdot
0 g
gsave
.72917 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.96429 .40712 Mdot
0 g
gsave
.96429 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49405 .60332 Mdot
0 g
gsave
.49405 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00JOooool4o`00053ooooo1ol0002fooooo`Go0000
3oooool006[ooooo0_l0001Aooooo`;o00000_ooool2o`000;Sooooo0_l000000ooooooo0000o`00
000>ooooo`00Ioooool6o`00053ooooo1_l0002hooooo`;o000000?oooooo`000?l000003_ooool0
06Oooooo0_l000000ooooooo0000o`00001Booooo`Co0000^Oooool4o`0000oooooo001Xooooo`Co
0000D_ooool4o`000;Wooooo0_l000000ooooooo0000o`00000>ooooo`00JOooool3o`0005?ooooo
0_l0002jooooo`;o000000?oooooo`000?l000003_ooool006[ooooo0_l0001Booooo`?o0000^Ooo
ool5o`0000oooooo003oooooohoooooo0038ooooo`03o`000?oooooooooo0:[ooooo00?o0000oooo
ooooool05_ooool00<Wooooo0_l0002Yooooo`03o`000?oooooooooo01Oooooo001Zooooo`03o`00
0?oooooooooo05kooooo00?o0000ooooooooool0Y?ooool2o`0001[ooooo001Zooooo`03o`000?oo
oooooooo05oooooo00?o0000ooooooooool0X_ooool00ol0003oooooooooo`0Jooooo`00J_ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool06oooool0
06[ooooo00?o0000ooooooooool0HOooool2o`0009oooooo00?o0000ooooooooool07?ooool006[o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`2Jooooo`;o00007oooool006[ooooo
00?o0000ooooooooool0I?ooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo01oooooo
001Zooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool0U_ooool00ol0003ooooooooo
o`0Pooooo`00J_ooool00ol0003oooooooooo`1Vooooo`;o0000UOooool00ol0003oooooooooo`0Q
ooooo`00J_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo093ooooo0_l0000Toooo
o`00J_ooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo08kooooo00?o0000oooooooo
ool09?ooool006[ooooo00?o0000ooooooooool0J_ooool00ol0003oooooooooo`2<ooooo`03o`00
0?oooooooooo02Gooooo001Zooooo`03o`000?oooooooooo06_ooooo0_l0002;ooooo`03o`000?oo
oooooooo02Kooooo001Zooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool0Q_ooool2
o`0002Wooooo001Zooooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool0Q?ooool00ol0
003oooooooooo`0Yooooo`00J_ooool00ol0003oooooooooo`1_ooooo`;o0000Poooool00ol0003o
ooooooooo`0Zooooo`00J_ooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo07oooooo
00?o0000ooooooooool0:oooool006[ooooo00?o0000ooooooooool0L_ooool00ol0003ooooooooo
o`1looooo`;o0000;_ooool006[ooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`1j
ooooo`03o`000?oooooooooo02kooooo001Zooooo`03o`000?oooooooooo07Cooooo0_l0001ioooo
o`03o`000?oooooooooo02oooooo001Zooooo`03o`000?oooooooooo07Kooooo00?o0000oooooooo
ool0MOooool00ol0003oooooooooo`0`ooooo`00J_ooool00ol0003oooooooooo`1gooooo`03o`00
0?oooooooooo07;ooooo0_l0000cooooo`00J_ooool00ol0003oooooooooo`1hooooo`03o`000?oo
oooooooo073ooooo00?o0000ooooooooool0<oooool006[ooooo00?o0000ooooooooool0NOooool2
o`0006oooooo00?o0000ooooooooool0=?ooool006[ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`1[ooooo`03o`000?oooooooooo03Gooooo001Zooooo`03o`000?oooooooooo07co
oooo00?o0000ooooooooool0J?ooool2o`0003Sooooo001Zooooo`03o`000?oooooooooo07gooooo
00?o0000ooooooooool0I_ooool00ol0003oooooooooo`0hooooo`00J_ooool00ol0003ooooooooo
o`1nooooo`;o0000IOooool00ol0003oooooooooo`0iooooo`00J_ooool00ol0003oooooooooo`20
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool0>_ooool006[ooooo00?o0000oooo
ooooool0POooool00ol0003oooooooooo`1Nooooo`;o0000?Oooool006[ooooo00?o0000oooooooo
ool0P_ooool2o`0005gooooo00?o0000ooooooooool0?Oooool006[ooooo00?o0000ooooooooool0
Q?ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo03kooooo001Zooooo`03o`000?oo
oooooooo08Gooooo00?o0000ooooooooool0E_ooool2o`00047ooooo001Zooooo`03o`000?oooooo
oooo08Kooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`11ooooo`00J_ooool00ol0
003oooooooooo`27ooooo`;o0000Doooool00ol0003oooooooooo`12ooooo`00J_ooool00ol0003o
ooooooooo`29ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0@oooool006[ooooo
00?o0000ooooooooool0R_ooool00ol0003oooooooooo`1<ooooo`;o0000A_ooool006[ooooo00?o
0000ooooooooool0Roooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04Kooooo001Z
ooooo`03o`000?oooooooooo08cooooo0_l00019ooooo`03o`000?oooooooooo04Oooooo001Zoooo
o`03o`000?oooooooooo08kooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`18oooo
o`00J_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo04;ooooo0_l0001;ooooo`00
J_ooool00ol0003oooooooooo`2@ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
Boooool006[ooooo00?o0000ooooooooool0TOooool2o`0003oooooo00?o0000ooooooooool0C?oo
ool006[ooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`0kooooo`03o`000?oooooo
oooo04gooooo001Zooooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool0>?ooool2o`00
053ooooo001Zooooo`03o`000?oooooooooo09Gooooo0_l0000gooooo`03o`000?oooooooooo053o
oooo001Zooooo`03o`000?oooooooooo09Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`1Aooooo`00J_ooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`0^
ooooo`;o0000EOooool006[ooooo00?o0000ooooooooool0V_ooool2o`0002gooooo00?o0000oooo
ooooool0EOooool006[ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo05Kooooo001Zooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`1Gooooo`00J_ooool00ol0003oooooooooo`2Nooooo`03o`000?oo
oooooooo02Cooooo0_l0001Jooooo`00J_ooool00ol0003oooooooooo`2Oooooo`;o00008oooool0
0ol0003oooooooooo`1Jooooo`00J_ooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool0Foooool006[ooooo00?o0000ooooooooool0X_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo05cooooo001Zooooo`03o`000?oooooooooo0:?ooooo
00?o0000ooooooooool06_ooool2o`0005oooooo001Zooooo`03o`000?oooooooooo0:Cooooo0_l0
000Iooooo`03o`000?oooooooooo05oooooo001Zooooo`03o`000?oooooooooo0:Kooooo00?o0000
ooooooooool05Oooool00ol0003oooooooooo`1Pooooo`00oooooolEooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0HOooool00?oooooo5_ooool2o`00017ooooo0_l0001Tooooo`00
oooooolHooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0I?ooool00?oooooo9ooo
ool00ol0003oooooooooo`1Uooooo`00oooooon?ooooo`00J?ooool4o`000;7ooooo1?l0001]oooo
o`00Joooool2o`000;?ooooo0_l0001/ooooo`00COooool5o`0001Kooooo1Ol0000Eooooo`Co0000
Uoooool5o`0006cooooo001>ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0
000Dooooo`;o00000_ooool2o`0009Gooooo0_l00002ooooo`;o0000K?ooool004kooooo0_l00000
0ooooooo0000o`00000Dooooo`;o00000_ooool2o`0001Sooooo0_l0002Eooooo`;o00000_ooool2
o`0006cooooo001>ooooo`Co00005Oooool2o`0000;ooooo0_l0000Fooooo`?o0000U_ooool2o`00
00;ooooo0_l0001/ooooo`00C_ooool2o`000003ooooool0003o000001Gooooo1_l0000Gooooo`;o
0000U_ooool6o`0006_ooooo001>ooooo`;o000000?oooooo`000?l00000;_ooool2o`0000;ooooo
0_l0003oooooo`Sooooo001=ooooo`Go0000<?ooool4o`000?oooooo2Oooool00?ooooooSoooool0
0?ooooooSoooool00?ooooooSoooool00?ooooooSoooool005?ooooo00?o0000ooooooooool0oooo
ooliooooo`00Doooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0Voooool00ol0003oooooooooo`1/ooooo`00E?ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1/oooo
o`00E?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0W?ooool00ol0003oooooooooo`1/ooooo`00E?ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1/ooooo`00EOoo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`1/ooooo`00EOooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`1/ooooo`00EOooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0WOooool00ol0
003oooooooooo`1/ooooo`00E_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`1/ooooo`00E_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0W_ooool00ol0003ooooo
ooooo`1/ooooo`00E_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0W_ooool00ol0003oooooooooo`1/ooooo`00Eoooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`1/
ooooo`00Eoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool0Woooool00ol0003oooooooooo`1/ooooo`00Eoooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`1/ooooo`00
F?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
X?ooool00ol0003oooooooooo`1/ooooo`00F?ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool0X?ooool00ol0003oooooooooo`1/ooooo`00F?ooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0X?ooool0
0ol0003oooooooooo`1/ooooo`00FOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`1/ooooo`00FOooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0XOooool00ol0003o
ooooooooo`1/ooooo`00F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0X_ooool00ol0003oooooooooo`1/ooooo`00F_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0X_ooool00ol0003ooooooooo
o`1/ooooo`00F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0X_ooool00ol0003oooooooooo`1/ooooo`00Foooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Xoooool00ol0003oooooooooo`1/oooo
o`00Foooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0Xoooool00ol0003oooooooooo`1/ooooo`00Foooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0Xoooool00ol0003oooooooooo`1/ooooo`00G?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Y?oo
ool00ol0003oooooooooo`1/ooooo`00G?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`1/ooooo`00G?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Y?ooool00ol0
003oooooooooo`1/ooooo`00GOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0YOooool00ol0003oooooooooo`1/ooooo`00GOooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0YOooool00ol0003ooooo
ooooo`1/ooooo`00GOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0YOooool00ol0003oooooooooo`1/ooooo`00G_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`1/
ooooo`00G_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0Y_ooool00ol0003oooooooooo`1/ooooo`00G_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`1/ooooo`00
Goooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
Yoooool00ol0003oooooooooo`1/ooooo`00Goooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0Yoooool00ol0003oooooooooo`1/ooooo`00Goooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Yoooool0
0ol0003oooooooooo`1/ooooo`00H?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`1/ooooo`00H?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Z?ooool00ol0003o
ooooooooo`1/ooooo`00H?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`1/ooooo`00HOooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0ZOooool00ol0003ooooooooo
o`1/ooooo`00HOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0ZOooool00ol0003oooooooooo`1/ooooo`00H_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`1/oooo
o`00H_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0Z_ooool00ol0003oooooooooo`1/ooooo`00H_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`1/ooooo`00Hooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Zooo
ool00ol0003oooooooooo`1/ooooo`00Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`1/ooooo`00Hoooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Zoooool00ol0
003oooooooooo`1/ooooo`00I?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0[?ooool00ol0003oooooooooo`1/ooooo`00I?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0[?ooool00ol0003ooooo
ooooo`1/ooooo`00I?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0[?ooool00ol0003oooooooooo`1/ooooo`00IOooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0[Oooool00ol0003oooooooooo`1/
ooooo`00IOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0[Oooool00ol0003oooooooooo`1/ooooo`00IOooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0[Oooool00ol0003oooooooooo`1/ooooo`00
I_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0[_ooool00ol0003o
ooooooooo`1/ooooo`00I_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0[_ooool00ol0003oooooooooo`1/ooooo`00I_ooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool0[_ooool00ol0003oooooooooo`1/ooooo`00Ioooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0K?ooool00?oooooo
Soooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool006Sooooo1?l0003oooooob?o
oooo001[ooooo`;o0000ZOooool2o`0007Kooooo000<ooooo`Oo0000EOooool5o`0005Cooooo1Ol0
0017ooooo`Oo000000?oooooo`000?l000000_l00004ooooo`;o00001?ooool4o`0000Cooooo0ol0
0003ooooo`Co0000@Oooool6o`0001;ooooo000<ooooo`;o00000_ooool2o`0005Gooooo0_l00002
ooooo`;o0000EOooool2o`000003ooooool0003o000004Oooooo0_l000001?oooooo0000o`000?oo
ool6o`0000?ooooo0_l00003ooooo`;o00000_ooool2o`0000;ooooo0_l000001?oooooo0000o`00
0?ooool2o`0000;ooooo0_l00011ooooo`;o000000?oooooo`000?l000004_ooool000cooooo1_l0
001Eooooo`;o00000_ooool2o`0005Gooooo0_l000000ooooooo0000o`000017ooooo`;o000000?o
ooooo`000?l000000oooool4o`0000Cooooo0_l00006ooooo`;o00000_ooool2o`000004ooooool0
003o0000ooooo`;o00000_ooool2o`0004;ooooo0_l0000Dooooo`003Oooool4o`0005Kooooo0_l0
0002ooooo`;o0000EOooool2o`000003ooooool0003o000004Oooooo0_l000000ooooooo0000o`00
0002ooooo`Co00001Oooool2o`0000Kooooo0_l00002ooooo`;o000000Coooooo`000?l0003ooooo
1Ol00014ooooo`;o00004oooool000gooooo1?l0001Gooooo`Ko0000E?ooool2o`000003ooooool0
003o000004Oooooo1?l00002ooooo`Co00001oooool2o`000003ooooool0003o000000?o00000ooo
ool2o`000004ooooool0003o0000ooooo`;o0000A?ooool2o`0000;ooooo0_l0000Booooo`003_oo
ool2o`000;;ooooo0_l000000ooooooo0000o`000017ooooo`;o00001?ooool6o`000003ooooool0
003o000000;ooooo0_l000000ooooooo0000o`000006ooooo`;o000000?oooooo`000?l000000_oo
ool2o`0004?ooooo0_l00002ooooo`;o00004_ooool000gooooo0ol00009ooooo`;o0000Y_ooool5
o`0004Oooooo0ol00005ooooo`Co00000_ooool6o`000003ooooool0003o000000Co00000oooool3
o`0000Cooooo0ol0000iooooo`;o00001oooool4o`0001?ooooo000Kooooo`;o0000nOooool2o`00
05Cooooo0_l0000Pooooo`007Oooool2o`000?ooooooC?ooool2o`0002;ooooo000Oooooo`?o0000
DOooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo04kooooo0ol0000Tooooo`008_oo
ool2o`00053ooooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`1=ooooo`;o00009ooo
ool002Cooooo0ol0001>ooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool0Boooool3
o`0002Wooooo000Wooooo`;o0000COooool00ol0003oooooooooo`2Iooooo`;o0000C?ooool2o`00
02cooooo000Yooooo`;o0000C?ooool2o`0004_ooooo00?o0000ooooooooool0B_ooool00ol0003o
ooooooooo`1:ooooo`;o0000;_ooool002_ooooo0ol0001;ooooo`03o`000?oooooooooo04Sooooo
00?o0000ooooooooool0BOooool00ol0003oooooooooo`18ooooo`?o0000<?ooool002kooooo0_l0
001:ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool0B?ooool00ol0003ooooooooo
o`17ooooo`;o0000<oooool0033ooooo0ol00018ooooo`03o`000?oooooooooo04Kooooo00?o0000
ooooooooool0Aoooool00ol0003oooooooooo`15ooooo`?o0000=Oooool003?ooooo0_l00017oooo
o`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0AOooool2o`0004Kooooo0_l0000hoooo
o`00=Oooool2o`0004Kooooo0_l00015ooooo`03o`000?oooooooooo04Cooooo00?o0000oooooooo
ool0A?ooool2o`0003[ooooo000gooooo`?o0000AOooool00ol0003oooooooooo`12ooooo`03o`00
0?oooooooooo04?ooooo00?o0000ooooooooool0@_ooool3o`0003cooooo000jooooo`;o0000A?oo
ool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@Ooo
ool2o`0003oooooo000looooo`;o0000@oooool00ol0003oooooooooo`10ooooo`03o`000?oooooo
oooo047ooooo00?o0000ooooooooool0@?ooool2o`00047ooooo000nooooo`?o0000@Oooool00ol0
003oooooooooo`0oooooo`03o`000?oooooooooo03oooooo0_l00010ooooo`?o0000@oooool0047o
oooo0_l00010ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0?_ooool00ol0003o
ooooooooo`0nooooo`;o0000A_ooool004?ooooo0ol0000nooooo`;o0000?_ooool00ol0003ooooo
ooooo`0mooooo`03o`000?oooooooooo03cooooo0ol00018ooooo`00A_ooool2o`0003kooooo00?o
0000ooooooooool0>oooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo03_ooooo0_l0
001;ooooo`00B?ooool2o`0003gooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0k
ooooo`03o`000?oooooooooo03[ooooo0_l0001=ooooo`00B_ooool3o`0003_ooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`0iooooo`;o0000>_ooool3o`0004oooooo001=ooooo`;o
0000>_ooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool0>?ooool2o`0005;ooooo001?ooooo`;o0000>Oooool2o`0003Sooooo00?o0000ooooooooool0
=oooool00ol0003oooooooooo`0gooooo`;o0000E?ooool0057ooooo0ol0000hooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0eooooo`?o0000E_oo
ool005Cooooo0_l0000gooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0=Oooool0
0ol0003oooooooooo`0dooooo`;o0000FOooool005Kooooo0ol0000eooooo`03o`000?oooooooooo
03?ooooo00?o0000ooooooooool0<oooool2o`0003Cooooo0ol0001Kooooo`00FOooool2o`0003Co
oooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;o
oooo0_l0001Nooooo`00Foooool2o`0003?ooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0aooooo`03o`000?oooooooooo037ooooo0_l0001Pooooo`00GOooool3o`00037ooooo0_l0
000aooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0;oooool3o`0006;ooooo001P
ooooo`;o0000<Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02oooooo00?o0000
ooooooooool0;_ooool2o`0006Gooooo001Rooooo`?o0000;oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo02gooooo0_l0000^ooooo`?o0000Ioooool006Gooooo0_l0000^ooooo`03
o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`;o
0000J_ooool006Oooooo0_l0000]ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0[ooooo`;o0000K?ooool006Wooooo0ol0000[ooooo`;o0000:ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Wooooo0ol0001^ooooo`00K?ooool2
o`0002_ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo02Sooooo0_l0001aooooo`00K_ooool2o`0002[ooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo02Oooooo0_l0001cooooo`00L?ooool3o`0002So
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Vooooo`;o00009oooool3o`0007Go
oooo001cooooo`;o00009oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool09Oooool2o`0007Sooooo001eooooo`?o00009Oooool2o`0002Gooooo00?o
0000ooooooooool09?ooool00ol0003oooooooooo`0Sooooo`?o0000N_ooool007Sooooo0_l0000U
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0R
ooooo`;o0000OOooool007[ooooo0_l0000Tooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0Qooooo`;o0000Ooooool007cooooo0ol0000Rooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool08?ooool2o`00027ooooo0ol00021ooooo`00
Ooooool2o`00027ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo01oooooo0_l00024ooooo`00POooool3o`0001oooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01gooooo0ol00026ooooo`00Q?ooool2
o`0001kooooo0_l0000Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool2
o`0008Wooooo0026ooooo`;o00007_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool06oooool2o`0008_ooooo0028ooooo`?o00007?ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo01[ooooo0_l0000Kooooo`?o0000SOooool008_ooooo
0_l0000Kooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`0Iooooo`;o0000T?ooool008gooooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`;o0000T_ooool008oooooo0ol0000H
ooooo`;o00006?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Kooooo0ol0002D
ooooo`00T_ooool2o`0001Sooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo01Gooooo0_l0002Gooooo`00U?ooool3o`0001Kooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0Dooooo`;o00005Oooool3o`0009Wooooo002Gooooo`;o0000
5Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4oooool2o`0009cooooo002Iooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool2o`0009kooooo002Kooooo`?o00004_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool3
o`000:3ooooo002Nooooo`;o00004Oooool2o`00017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0?ooooo`;o0000Xoooool00:3ooooo0_l0000Aooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool2o`00013ooooo0_l0002Uooooo`00X_ooool3o`0000oooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
0ol0002Wooooo`00YOooool2o`0000kooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00cooooo0_l0002Zooooo`00Yoooool3o`0000cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo0ol0002/
ooooo`00Z_ooool2o`0000_ooooo0_l0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool2o`000:oooooo002/ooooo`;o00002oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Sooooo0_l0000:ooooo`;o0000/Oooool00:kooooo0ol00009ooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool01oooool3o`000;?ooooo002aooooo`;o00002?oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00Kooooo0_l0002fooooo`00/oooool3
o`0000Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`?o0000^?ooool0
0;Kooooo0_l0000Iooooo`;o0000^oooool00;Sooooo0_l0000Eooooo`;o0000_Oooool00;[ooooo
0_l0000Aooooo`;o0000_oooool00?ooooooSoooool00<7ooooo1_l00037ooooo`00`oooool2o`00
0<Wooooo0033ooooo`;o0000bOooool00<?ooooo0_l00039ooooo`00`_ooool5o`000<Oooooo0033
ooooo`;o0000bOooool00<Cooooo0ol00037ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooo
oon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17529, -0.625483, \
0.0110635, 0.00265161}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.49405 0.23512 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19077 .21092 -5 -6 ]
[.19077 .21092 5 6 ]
[.25893 .21092 -5 -6 ]
[.25893 .21092 5 6 ]
[.25893 .01472 -5 -6 ]
[.25893 .01472 5 6 ]
[.32709 .21092 -5 -6 ]
[.32709 .21092 5 6 ]
[.25893 .40712 -5 -6 ]
[.25893 .40712 5 6 ]
[.49405 .40712 -5 -6 ]
[.49405 .40712 5 6 ]
[.72917 .40712 -20 -6 ]
[.72917 .40712 20 6 ]
[.48215 .01472 -5.0625 -6 ]
[.48215 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.72917 .21092 -5 -6 ]
[.72917 .21092 5 6 ]
[.96429 .40712 -5 -6 ]
[.96429 .40712 5 6 ]
[.49405 .60332 -5 -6 ]
[.49405 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49405 .60332 m
.02381 .40712 L
s
.49405 .60332 m
.25893 .40712 L
s
.49405 .60332 m
.49405 .40712 L
s
.49405 .60332 m
.72917 .40712 L
s
.49405 .60332 m
.96429 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25893 .40712 m
.19077 .21092 L
s
.25893 .40712 m
.25893 .21092 L
s
.25893 .40712 m
.32709 .21092 L
s
1 g
.05 w
.19077 .21092 Mdot
0 g
gsave
.19077 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25893 .21092 m
.25893 .01472 L
s
1 g
.05 w
.25893 .21092 Mdot
0 g
gsave
.25893 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25893 .01472 Mdot
0 g
gsave
.25893 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32709 .21092 Mdot
0 g
gsave
.32709 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25893 .40712 Mdot
0 g
gsave
.25893 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49405 .40712 Mdot
0 g
gsave
.49405 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72917 .40712 m
.72917 .21092 L
s
1 g
.05 w
.72917 .40712 Mdot
0 g
gsave
.72917 .40712 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h$7525) show
1.000 setlinewidth
grestore
.5 Mabswid
.72917 .21092 m
.48215 .01472 L
s
.72917 .21092 m
.97619 .01472 L
s
1 g
.05 w
.48215 .01472 Mdot
0 g
gsave
.48215 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.72917 .21092 Mdot
0 g
gsave
.72917 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.96429 .40712 Mdot
0 g
gsave
.96429 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49405 .60332 Mdot
0 g
gsave
.49405 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00JOooool4o`00053ooooo1ol0002fooooo`Go0000
3oooool006[ooooo0_l0001Aooooo`;o00000_ooool2o`000;Sooooo0_l000000ooooooo0000o`00
000>ooooo`00Ioooool6o`00053ooooo1_l0002hooooo`;o000000?oooooo`000?l000003_ooool0
06Oooooo0_l000000ooooooo0000o`00001Booooo`Co0000^Oooool4o`0000oooooo001Xooooo`Co
0000D_ooool4o`000;Wooooo0_l000000ooooooo0000o`00000>ooooo`00JOooool3o`0005?ooooo
0_l0002jooooo`;o000000?oooooo`000?l000003_ooool006[ooooo0_l0001Booooo`?o0000^Ooo
ool5o`0000oooooo003oooooohoooooo0038ooooo`03o`000?oooooooooo0:[ooooo00?o0000oooo
ooooool05_ooool00<Wooooo0_l0002Yooooo`03o`000?oooooooooo01Oooooo001Zooooo`03o`00
0?oooooooooo05kooooo00?o0000ooooooooool0Y?ooool2o`0001[ooooo001Zooooo`03o`000?oo
oooooooo05oooooo00?o0000ooooooooool0X_ooool00ol0003oooooooooo`0Jooooo`00J_ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool06oooool0
06[ooooo00?o0000ooooooooool0HOooool2o`0009oooooo00?o0000ooooooooool07?ooool006[o
oooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`2Jooooo`;o00007oooool006[ooooo
00?o0000ooooooooool0I?ooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo01oooooo
001Zooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool0U_ooool00ol0003ooooooooo
o`0Pooooo`00J_ooool00ol0003oooooooooo`1Vooooo`;o0000UOooool00ol0003oooooooooo`0Q
ooooo`00J_ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo093ooooo0_l0000Toooo
o`00J_ooool00ol0003oooooooooo`1Yooooo`03o`000?oooooooooo08kooooo00?o0000oooooooo
ool09?ooool006[ooooo00?o0000ooooooooool0J_ooool00ol0003oooooooooo`2<ooooo`03o`00
0?oooooooooo02Gooooo001Zooooo`03o`000?oooooooooo06_ooooo0_l0002;ooooo`03o`000?oo
oooooooo02Kooooo001Zooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool0Q_ooool2
o`0002Wooooo001Zooooo`03o`000?oooooooooo06kooooo00?o0000ooooooooool0Q?ooool00ol0
003oooooooooo`0Yooooo`00J_ooool00ol0003oooooooooo`1_ooooo`;o0000Poooool00ol0003o
ooooooooo`0Zooooo`00J_ooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo07oooooo
00?o0000ooooooooool0:oooool006[ooooo00?o0000ooooooooool0L_ooool00ol0003ooooooooo
o`1looooo`;o0000;_ooool006[ooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`1j
ooooo`03o`000?oooooooooo02kooooo001Zooooo`03o`000?oooooooooo07Cooooo0_l0001ioooo
o`03o`000?oooooooooo02oooooo001Zooooo`03o`000?oooooooooo07Kooooo00?o0000oooooooo
ool0MOooool00ol0003oooooooooo`0`ooooo`00J_ooool00ol0003oooooooooo`1gooooo`03o`00
0?oooooooooo07;ooooo0_l0000cooooo`00J_ooool00ol0003oooooooooo`1hooooo`03o`000?oo
oooooooo073ooooo00?o0000ooooooooool0<oooool006[ooooo00?o0000ooooooooool0NOooool2
o`0006oooooo00?o0000ooooooooool0=?ooool006[ooooo00?o0000ooooooooool0Noooool00ol0
003oooooooooo`1[ooooo`03o`000?oooooooooo03Gooooo001Zooooo`03o`000?oooooooooo07co
oooo00?o0000ooooooooool0J?ooool2o`0003Sooooo001Zooooo`03o`000?oooooooooo07gooooo
00?o0000ooooooooool0I_ooool00ol0003oooooooooo`0hooooo`00J_ooool00ol0003ooooooooo
o`1nooooo`;o0000IOooool00ol0003oooooooooo`0iooooo`00J_ooool00ol0003oooooooooo`20
ooooo`03o`000?oooooooooo067ooooo00?o0000ooooooooool0>_ooool006[ooooo00?o0000oooo
ooooool0POooool00ol0003oooooooooo`1Nooooo`;o0000?Oooool006[ooooo00?o0000oooooooo
ool0P_ooool2o`0005gooooo00?o0000ooooooooool0?Oooool006[ooooo00?o0000ooooooooool0
Q?ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo03kooooo001Zooooo`03o`000?oo
oooooooo08Gooooo00?o0000ooooooooool0E_ooool2o`00047ooooo001Zooooo`03o`000?oooooo
oooo08Kooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`11ooooo`00J_ooool00ol0
003oooooooooo`27ooooo`;o0000Doooool00ol0003oooooooooo`12ooooo`00J_ooool00ol0003o
ooooooooo`29ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0@oooool006[ooooo
00?o0000ooooooooool0R_ooool00ol0003oooooooooo`1<ooooo`;o0000A_ooool006[ooooo00?o
0000ooooooooool0Roooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04Kooooo001Z
ooooo`03o`000?oooooooooo08cooooo0_l00019ooooo`03o`000?oooooooooo04Oooooo001Zoooo
o`03o`000?oooooooooo08kooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`18oooo
o`00J_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo04;ooooo0_l0001;ooooo`00
J_ooool00ol0003oooooooooo`2@ooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0
Boooool006[ooooo00?o0000ooooooooool0TOooool2o`0003oooooo00?o0000ooooooooool0C?oo
ool006[ooooo00?o0000ooooooooool0Toooool00ol0003oooooooooo`0kooooo`03o`000?oooooo
oooo04gooooo001Zooooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool0>?ooool2o`00
053ooooo001Zooooo`03o`000?oooooooooo09Gooooo0_l0000gooooo`03o`000?oooooooooo053o
oooo001Zooooo`03o`000?oooooooooo09Oooooo00?o0000ooooooooool0<oooool00ol0003ooooo
ooooo`1Aooooo`00J_ooool00ol0003oooooooooo`2Hooooo`03o`000?oooooooooo037ooooo00?o
0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`0^
ooooo`;o0000EOooool006[ooooo00?o0000ooooooooool0V_ooool2o`0002gooooo00?o0000oooo
ooooool0EOooool006[ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo05Kooooo001Zooooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`1Gooooo`00J_ooool00ol0003oooooooooo`2Nooooo`03o`000?oo
oooooooo02Cooooo0_l0001Jooooo`00J_ooool00ol0003oooooooooo`2Oooooo`;o00008oooool0
0ol0003oooooooooo`1Jooooo`00J_ooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool0Foooool006[ooooo00?o0000ooooooooool0X_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo05cooooo001Zooooo`03o`000?oooooooooo0:?ooooo
00?o0000ooooooooool06_ooool2o`0005oooooo001Zooooo`03o`000?oooooooooo0:Cooooo0_l0
000Iooooo`03o`000?oooooooooo05oooooo001Zooooo`03o`000?oooooooooo0:Kooooo00?o0000
ooooooooool05Oooool00ol0003oooooooooo`1Pooooo`00oooooolEooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0HOooool00?oooooo5_ooool2o`00017ooooo0_l0001Tooooo`00
oooooolHooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0I?ooool00?oooooo9ooo
ool00ol0003oooooooooo`1Uooooo`00oooooon?ooooo`00J?ooool4o`000;7ooooo1?l0001]oooo
o`00Joooool2o`000;?ooooo0_l0001/ooooo`00COooool5o`0001Kooooo1Ol0000Eooooo`Co0000
Uoooool5o`0006cooooo001>ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0
000Dooooo`;o00000_ooool2o`0009Gooooo0_l00002ooooo`;o0000K?ooool004kooooo0_l00000
0ooooooo0000o`00000Dooooo`;o00000_ooool2o`0001Sooooo0_l0002Eooooo`;o00000_ooool2
o`0006cooooo001>ooooo`Co00005Oooool2o`0000;ooooo0_l0000Fooooo`?o0000U_ooool2o`00
00;ooooo0_l0001/ooooo`00C_ooool2o`000003ooooool0003o000001Gooooo1_l0000Gooooo`;o
0000U_ooool6o`0006_ooooo001>ooooo`;o000000?oooooo`000?l00000;_ooool2o`0000;ooooo
0_l0003oooooo`Sooooo001=ooooo`Go0000<?ooool4o`000?oooooo2Oooool00?ooooooSoooool0
0?ooooooSoooool00?ooooooSoooool00?ooooooSoooool005?ooooo00?o0000ooooooooool0oooo
ooliooooo`00Doooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0Voooool00ol0003oooooooooo`1/ooooo`00E?ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1/oooo
o`00E?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0W?ooool00ol0003oooooooooo`1/ooooo`00E?ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1/ooooo`00EOoo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`1/ooooo`00EOooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`1/ooooo`00EOooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0WOooool00ol0
003oooooooooo`1/ooooo`00E_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`1/ooooo`00E_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0W_ooool00ol0003ooooo
ooooo`1/ooooo`00E_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0W_ooool00ol0003oooooooooo`1/ooooo`00Eoooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`1/
ooooo`00Eoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool0Woooool00ol0003oooooooooo`1/ooooo`00Eoooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`1/ooooo`00
F?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
X?ooool00ol0003oooooooooo`1/ooooo`00F?ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool0X?ooool00ol0003oooooooooo`1/ooooo`00F?ooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0X?ooool0
0ol0003oooooooooo`1/ooooo`00FOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`1/ooooo`00FOooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0XOooool00ol0003o
ooooooooo`1/ooooo`00F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0X_ooool00ol0003oooooooooo`1/ooooo`00F_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0X_ooool00ol0003ooooooooo
o`1/ooooo`00F_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool0X_ooool00ol0003oooooooooo`1/ooooo`00Foooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool0Xoooool00ol0003oooooooooo`1/oooo
o`00Foooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0Xoooool00ol0003oooooooooo`1/ooooo`00Foooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0Xoooool00ol0003oooooooooo`1/ooooo`00G?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Y?oo
ool00ol0003oooooooooo`1/ooooo`00G?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`1/ooooo`00G?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Y?ooool00ol0
003oooooooooo`1/ooooo`00GOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0YOooool00ol0003oooooooooo`1/ooooo`00GOooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0YOooool00ol0003ooooo
ooooo`1/ooooo`00GOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0YOooool00ol0003oooooooooo`1/ooooo`00G_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`1/
ooooo`00G_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0Y_ooool00ol0003oooooooooo`1/ooooo`00G_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`1/ooooo`00
Goooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
Yoooool00ol0003oooooooooo`1/ooooo`00Goooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0Yoooool00ol0003oooooooooo`1/ooooo`00Goooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Yoooool0
0ol0003oooooooooo`1/ooooo`00H?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`1/ooooo`00H?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Z?ooool00ol0003o
ooooooooo`1/ooooo`00H?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0Z?ooool00ol0003oooooooooo`1/ooooo`00HOooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0ZOooool00ol0003ooooooooo
o`1/ooooo`00HOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0ZOooool00ol0003oooooooooo`1/ooooo`00H_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`1/oooo
o`00H_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0Z_ooool00ol0003oooooooooo`1/ooooo`00H_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`1/ooooo`00Hooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Zooo
ool00ol0003oooooooooo`1/ooooo`00Hoooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`1/ooooo`00Hoooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Zoooool00ol0
003oooooooooo`1/ooooo`00I?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0[?ooool00ol0003oooooooooo`1/ooooo`00I?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0[?ooool00ol0003ooooo
ooooo`1/ooooo`00I?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0[?ooool00ol0003oooooooooo`1/ooooo`00IOooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0[Oooool00ol0003oooooooooo`1/
ooooo`00IOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0[Oooool00ol0003oooooooooo`1/ooooo`00IOooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0[Oooool00ol0003oooooooooo`1/ooooo`00
I_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0[_ooool00ol0003o
ooooooooo`1/ooooo`00I_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool0[_ooool00ol0003oooooooooo`1/ooooo`00I_ooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool0[_ooool00ol0003oooooooooo`1/ooooo`00Ioooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0K?ooool00?oooooo
Soooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool006Sooooo1?l0003oooooob?o
oooo001[ooooo`;o0000ZOooool2o`0007Kooooo000<ooooo`Oo0000EOooool5o`0005Cooooo1Ol0
0017ooooo`Oo000000?oooooo`000?l000000_l00004ooooo`;o00001?ooool4o`0000;ooooo1_l0
0002ooooo`Co0000@Oooool6o`0001;ooooo000<ooooo`;o00000_ooool2o`0005Gooooo0_l00002
ooooo`;o0000EOooool2o`000003ooooool0003o000004Oooooo0_l000001?oooooo0000o`000?oo
ool6o`0000?ooooo0_l00003ooooo`;o00000_ooool2o`0000;ooooo0_l000001?oooooo0000o`00
0?ooool2o`0000;ooooo0_l00011ooooo`;o000000?oooooo`000?l000004_ooool000cooooo1_l0
001Eooooo`;o00000_ooool2o`0005Gooooo0_l000000ooooooo0000o`000017ooooo`;o000000?o
ooooo`000?l000000oooool4o`0000Cooooo0_l00006ooooo`;o00000oooool2o`0000Oooooo0_l0
0012ooooo`;o00005?ooool000gooooo1?l0001Fooooo`;o00000_ooool2o`0005Gooooo0_l00000
0ooooooo0000o`000017ooooo`;o000000?oooooo`000?l000000_ooool4o`0000Gooooo0_l00006
ooooo`;o00001?ooool2o`0000Kooooo0_l00013ooooo`;o00004oooool000gooooo1?l0001Goooo
o`Ko0000E?ooool2o`000003ooooool0003o000004Oooooo1?l00002ooooo`Co00001oooool2o`00
0003ooooool0003o000000?o00000_ooool2o`0000;ooooo0_l000000ooooooo0000o`000003o`00
047ooooo0_l00002ooooo`;o00004_ooool000kooooo0_l0002booooo`;o000000?oooooo`000?l0
0000Aoooool2o`0000Cooooo1_l000000ooooooo0000o`000002ooooo`;o000000?oooooo`000?l0
00001Oooool2o`0000;ooooo0_l000000ooooooo0000o`000014ooooo`;o00000_ooool2o`0001;o
oooo000=ooooo`?o00002Oooool2o`000:Kooooo1Ol00017ooooo`?o00001Oooool4o`0000;ooooo
1_l000000ooooooo0000o`000004o`0000;ooooo1?l00002ooooo`Ko0000>?ooool2o`0000Oooooo
1?l0000Cooooo`006oooool2o`000?Wooooo0_l0001Dooooo`;o00008?ooool001gooooo0_l0003o
ooooodcooooo0_l0000Rooooo`007oooool3o`00057ooooo00?o0000ooooooooool0X?ooool00ol0
003oooooooooo`1>ooooo`?o00009?ooool002;ooooo0_l0001@ooooo`03o`000?oooooooooo09ko
oooo00?o0000ooooooooool0COooool2o`0002Oooooo000Tooooo`?o0000C_ooool00ol0003ooooo
ooooo`2Looooo`03o`000?oooooooooo04_ooooo0ol0000Yooooo`009oooool2o`0004gooooo00?o
0000ooooooooool0VOooool2o`0004cooooo0_l0000/ooooo`00:Oooool2o`0004cooooo0_l0001;
ooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0B_ooool2o`0002kooooo000[oooo
o`?o0000Boooool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo04Wooooo00?o0000oooo
ooooool0B?ooool3o`00033ooooo000^ooooo`;o0000B_ooool00ol0003oooooooooo`17ooooo`03
o`000?oooooooooo04Sooooo00?o0000ooooooooool0Aoooool2o`0003?ooooo000`ooooo`?o0000
B?ooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool0
AOooool3o`0003Gooooo000cooooo`;o0000Aoooool00ol0003oooooooooo`15ooooo`03o`000?oo
oooooooo04Gooooo0_l00016ooooo`;o0000>?ooool003Gooooo0_l00016ooooo`;o0000AOooool0
0ol0003oooooooooo`14ooooo`03o`000?oooooooooo04Cooooo0_l0000jooooo`00=oooool3o`00
04Gooooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo
04;ooooo0ol0000looooo`00>_ooool2o`0004Cooooo00?o0000ooooooooool0@Oooool00ol0003o
ooooooooo`12ooooo`03o`000?oooooooooo047ooooo0_l0000oooooo`00??ooool2o`0004?ooooo
00?o0000ooooooooool0@?ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo043ooooo
0_l00011ooooo`00?_ooool3o`00047ooooo00?o0000ooooooooool0?oooool00ol0003ooooooooo
o`0oooooo`;o0000@?ooool3o`0004?ooooo0011ooooo`;o0000@?ooool00ol0003oooooooooo`0n
ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0?_ooool2o`0004Kooooo0013oooo
o`?o0000?_ooool2o`0003kooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0loooo
o`?o0000B?ooool004Kooooo0_l0000nooooo`03o`000?oooooooooo03_ooooo00?o0000oooooooo
ool0??ooool00ol0003oooooooooo`0kooooo`;o0000Boooool004Sooooo0_l0000mooooo`03o`00
0?oooooooooo03[ooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0jooooo`;o0000
COooool004[ooooo0ol0000kooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0>Ooo
ool2o`0003[ooooo0ol0001?ooooo`00COooool2o`0003[ooooo00?o0000ooooooooool0>?ooool0
0ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Sooooo0_l0001Booooo`00Coooool2o`00
03Wooooo0_l0000hooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0=oooool2o`00
05Cooooo001Aooooo`?o0000>?ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo03Ko
oooo00?o0000ooooooooool0=Oooool3o`0005Kooooo001Dooooo`;o0000=oooool00ol0003ooooo
ooooo`0dooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=?ooool2o`0005Wooooo
001Fooooo`?o0000=Oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03?ooooo0_l0
000dooooo`?o0000Foooool005Wooooo0_l0000dooooo`03o`000?oooooooooo03;ooooo00?o0000
ooooooooool0<_ooool00ol0003oooooooooo`0booooo`;o0000G_ooool005_ooooo0_l0000coooo
o`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0aoooo
o`;o0000H?ooool005gooooo0ol0000aooooo`;o0000<Oooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo02oooooo0ol0001Rooooo`00H?ooool2o`00037ooooo00?o0000ooooooooool0
;_ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02kooooo0_l0001Uooooo`00H_oo
ool3o`0002oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0]ooooo`;o0000;_oo
ool3o`0006Oooooo001Uooooo`;o0000;_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool0;?ooool2o`0006[ooooo001Wooooo`;o0000;Oooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool2o`00
06cooooo001Yooooo`?o0000:oooool2o`0002_ooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`0Yooooo`?o0000K_ooool006cooooo0_l0000[ooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Xooooo`;o0000LOooool006kooooo0_l0
000Zooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`0Wooooo`;o0000Loooool0073ooooo0ol0000Xooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool09_ooool2o`0002Oooooo0ol0001eooooo`00Loooool2o`0002Oooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Gooooo0_l0001hoooo
o`00MOooool3o`0002Gooooo0_l0000Uooooo`03o`000?oooooooooo02Cooooo00?o0000oooooooo
ool08oooool3o`0007[ooooo001hooooo`;o00009Oooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool08_ooool2o`0007gooooo001jooooo`;o00009?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08Ooo
ool2o`0007oooooo001looooo`?o00008_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo023ooooo0_l0000Qooooo`?o0000POooool007oooooo0_l0000Qooooo`03o`000?oooooooooo
01oooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Oooooo`;o0000Q?ooool0087o
oooo0ol0000Oooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0Mooooo`?o0000Q_ooool008Cooooo0_l0000Nooooo`;o00007_ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01cooooo0_l00029ooooo`00Q_ooool2o`0001kooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01_ooooo0_l0
002;ooooo`00R?ooool3o`0001cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0J
ooooo`;o00006oooool3o`0008gooooo002;ooooo`;o00006oooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool2o`00093ooooo002=ooooo`;o
00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool06?ooool2o`0009;ooooo002?ooooo`?o00006?ooool2o`0001Sooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0Fooooo`?o0000U?ooool009;ooooo0_l0000Hooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`;o0000Uooo
ool009Cooooo0ol0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool2
o`0001Gooooo0ol0002Iooooo`00Uoooool2o`0001Gooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo0_l0002Looooo`00VOooool2o`0001Co
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo0_l0002Nooooo`00Voooool3o`0001;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo013ooooo0ol0002Pooooo`00W_ooool2o`00017ooooo0_l0
000Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool2o`000:?ooooo002P
ooooo`;o00004Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo0_l0000@
ooooo`;o0000YOooool00:;ooooo0ol0000?ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`?o0000Yoooool00:Gooooo0_l0000>ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`;o
0000Z_ooool00:Oooooo0ol0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0:ooooo`?o0000[?ooool00:[ooooo0_l0000;ooooo`;o00002ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo0_l0002_ooooo`00[?ooool2
o`0000_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o00002_ooool2
o`000;7ooooo002^ooooo`?o00002Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
00Oooooo0ol0002cooooo`00/Oooool2o`0000Sooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`06ooooo`;o0000]_ooool00;?ooooo0ol00006ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool01?ooool3o`000;Sooooo002fooooo`;o00006Oooool2o`000;_ooooo002h
ooooo`;o00005Oooool2o`000;gooooo002jooooo`;o00004Oooool2o`000;oooooo003oooooohoo
oooo0031ooooo`Ko0000aoooool00<?ooooo0_l00039ooooo`00`oooool2o`000<Wooooo0033oooo
o`;o0000bOooool00<;ooooo1Ol00037ooooo`00`oooool2o`000<Wooooo0034ooooo`?o0000aooo
ool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?ooooooSooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17529, -0.625483, \
0.0110635, 0.00265161}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -20 -6 ]
[.25889 .45617 20 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
1 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7544) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00lOooool7o`0008;ooooo1Ol0000?ooooo`00lOoo
ool2o`0000;ooooo0_l00024ooooo`;o000000?oooooo`000?l000003_ooool00?7ooooo1_l00024
ooooo`;o000000?oooooo`000?l000003_ooool00?;ooooo1?l00025ooooo`Co00003oooool00?;o
oooo1?l00025ooooo`;o000000?oooooo`000?l000003_ooool00??ooooo0_l00026ooooo`;o0000
00?oooooo`000?l000003_ooool00?;ooooo0ol00025ooooo`Go00003oooool00?ooooooSoooool0
0?cooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`0Fooooo`00oOooool00ol0003o
ooooooooo`1dooooo`03o`000?oooooooooo01Oooooo003nooooo`03o`000?oooooooooo07;ooooo
00?o0000ooooooooool06?ooool00?oooooo0_l0001`ooooo`;o00006oooool00?oooooo0_ooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo01_ooooo003oooooo`?ooooo00?o0000oooo
ooooool0J_ooool00ol0003oooooooooo`0Looooo`00ooooool4ooooo`03o`000?oooooooooo06So
oooo00?o0000ooooooooool07Oooool00?oooooo1Oooool2o`0006Oooooo00?o0000ooooooooool0
7_ooool00?oooooo1oooool00ol0003oooooooooo`1Rooooo`;o00008Oooool00?oooooo2?ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo027ooooo003oooooo`Wooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`0Rooooo`00ooooool:ooooo`;o0000GOooool00ol0003o
ooooooooo`0Sooooo`00ooooool<ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool0
9?ooool00?oooooo3Oooool00ol0003oooooooooo`1Fooooo`;o00009oooool00?oooooo3_ooool0
0ol0003oooooooooo`1Dooooo`03o`000?oooooooooo02Oooooo003oooooo`oooooo00?o0000oooo
ooooool0D_ooool00ol0003oooooooooo`0Xooooo`00ooooool@ooooo`;o0000DOooool00ol0003o
ooooooooo`0Yooooo`00oooooolBooooo`03o`000?oooooooooo04cooooo0_l0000/ooooo`00oooo
oolCooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0;?ooool00?oooooo5?ooool0
0ol0003oooooooooo`18ooooo`03o`000?oooooooooo02gooooo003ooooooaGooooo0_l00017oooo
o`03o`000?oooooooooo02kooooo003ooooooaOooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`0_ooooo`00oooooolHooooo`03o`000?oooooooooo043ooooo0_l0000booooo`00oooo
oolIooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0<_ooool00?oooooo6_ooool2
o`0003gooooo00?o0000ooooooooool0<oooool00?oooooo7?ooool00ol0003oooooooooo`0ioooo
o`03o`000?oooooooooo03Cooooo003ooooooagooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0eooooo`00oooooolNooooo`03o`000?oooooooooo03Cooooo0_l0000hooooo`00oooo
oolOooooo`;o0000<oooool00ol0003oooooooooo`0hooooo`00oooooolQooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0>Oooool00?oooooo8_ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo03[ooooo003oooooob?ooooo00?o0000ooooooooool0:_ooool2o`0003go
oooo003oooooobCooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0mooooo`00oooo
oolUooooo`;o00009oooool00ol0003oooooooooo`0nooooo`00oooooolWooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0?oooool00?oooooo:?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo043ooooo003oooooobWooooo00?o0000ooooooooool07_ooool2o`0004?o
oooo003oooooob[ooooo0_l0000Mooooo`03o`000?oooooooooo04?ooooo003oooooobcooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`14ooooo`00ooooool]ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0AOooool00?oooooo;_ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo04Kooooo003ooooooboooooo0_l0000Cooooo`;o0000BOooool00?oooooo
<Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04Wooooo003ooooooc;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`1:ooooo`00oooooon?ooooo`00oooooon?oooo
o`00oooooolhooooo`Co0000Doooool00?oooooo>oooool2o`0005;ooooo001Yooooo`Co0000b_oo
ool5o`0005;ooooo001Zooooo`;o0000b_ooool2o`0000;ooooo0_l0001Booooo`00Ioooool6o`00
0<Wooooo0_l00002ooooo`;o0000D_ooool006Oooooo0_l000000ooooooo0000o`00003:ooooo`;o
00000_ooool2o`0005;ooooo001Xooooo`Co0000boooool6o`00057ooooo001Yooooo`?o0000oooo
oolSooooo`00J_ooool2o`000?oooooo8oooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[o
oooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003ooooo
ooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o
0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1B
ooooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03
o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0
c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oo
oooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool0
06[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003o
ooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo
00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003ooooooooo
o`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zoooo
o`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000oooooooo
ool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`00
0?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_oo
ool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0
003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<co
oooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003ooooo
ooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Z
ooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000oooo
ooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03
o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0
D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool0
0ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo
0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003o
ooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo
001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000
ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<oooo
o`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000oooooooo
ool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00oooo
oon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00J?oo
ool4o`000<_ooooo1?l0001Cooooo`00Joooool2o`000<gooooo0_l0001Booooo`00COooool5o`00
01Kooooo1Ol0000Eooooo`Co0000O?ooool4o`0000gooooo1Ol0000<ooooo`Go00003_ooool5o`00
05;ooooo001>ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0000Dooooo`;o
00000_ooool2o`0007[ooooo00?o0000ooooool000004?ooool2o`000003ooooool0003o000000co
oooo0_l000000ooooooo0000o`00000<ooooo`;o00000_ooool2o`0005;ooooo001>ooooo`;o0000
00?oooooo`000?l000005?ooool2o`0000;ooooo0_l0000Hooooo`;o0000N_ooool00ol0003ooooo
o`000002o`0000kooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?oooooo`000?l00000
3?ooool2o`0000;ooooo0_l0001Booooo`00C_ooool4o`0001Gooooo0_l00002ooooo`;o00005_oo
ool3o`0007_ooooo00Go0000ooooool0003oooooo`00000>ooooo`;o000000?oooooo`000?l00000
3?ooool4o`0000gooooo0_l00002ooooo`;o0000D_ooool004kooooo0_l000000ooooooo0000o`00
000Eooooo`Ko00005oooool2o`0007_ooooo0ol0000?ooooo`;o000000?oooooo`000?l000003?oo
ool2o`000003ooooool0003o000000gooooo1_l0001Aooooo`00C_ooool2o`000003ooooool0003o
000002kooooo0_l00002ooooo`;o0000SOooool2o`000003ooooool0003o000000cooooo0_l00000
0ooooooo0000o`00001Tooooo`00COooool5o`00033ooooo1?l0002=ooooo`Go00003?ooool5o`00
06Gooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo001Doooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo05Kooooo001Dooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05Oooooo001Eooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`27ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo05Oooooo001Eooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Sooooo001Fooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`29ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo05Sooooo001Fooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo05Wooooo001Gooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`2;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Wo
oooo001Gooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`2;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo05Wooooo001Hooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05[ooooo001H
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2=
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo05[ooooo001Iooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05_ooooo001Iooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2?ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo05_ooooo001Jooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05cooooo001Jooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Aooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo05cooooo001Jooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo05gooooo001Kooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
05gooooo001Kooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`2Cooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo05kooooo001Looooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05kooooo
001Looooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`2Eooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo05oooooo001Mooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo001Moooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Goooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo063ooooo001Nooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo063ooooo001Nooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Iooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo067ooooo001Oooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo067ooooo001Oooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Kooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo06;ooooo001Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`2Mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo06;ooooo001Pooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?o
oooo001Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`2Mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo06?ooooo001Qooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Cooooo001Q
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2O
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo06Cooooo001Rooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Gooooo001Rooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Qooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo06Gooooo001Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo06Kooooo001Sooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo06Kooooo001Tooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2Uooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Ko
oooo001Tooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`2Uooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
06Wooooo001Uooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`2Wooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`00001Y
ooooo`00IOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Yoooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000J_oo
ool006Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0J?ooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool00?ooooooSoooool005Wooooo1?l0003ooooooc;ooooo001Looooo`;o00000oooool2o`00
0?oooooo;?ooool000cooooo1ol00016ooooo`Go00000_ooool4o`0000Cooooo0_l00004ooooo`Co
00001?ooool4o`0000?ooooo1?l00010ooooo`Go0000EOooool7o`0005Cooooo1_l0000Booooo`00
3?ooool2o`0000;ooooo0_l00016ooooo`;o00000_ooool2o`000003ooooool0003o000000Co0000
0oooool2o`0000?ooooo0_l00002ooooo`;o00001?ooool2o`0000Gooooo0_l00012ooooo`;o0000
00?oooooo`000?l00000EOooool2o`000003ooooool0003o000005Kooooo0_l000000ooooooo0000
o`00000Booooo`003?ooool6o`0004Kooooo0_l00002ooooo`;o00000oooool4o`0000Cooooo0_l0
0006ooooo`;o000000?oooooo`000?l000001?l000000ooooooo0000o`000004o`00047ooooo0_l0
00000ooooooo0000o`00001Eooooo`;o000000?oooooo`000?l00000Eoooool2o`0001Cooooo000=
ooooo`Co0000Aoooool2o`0000;ooooo0_l00002ooooo`Co00001Oooool2o`0000Kooooo0_l00000
1?oooooo0000o`000?ooool2o`0000;ooooo0_l000000ooooooo0000o`000012ooooo`;o000000?o
ooooo`000?l00000EOooool2o`000003ooooool0003o000005Sooooo0_l0000Cooooo`003Oooool4
o`0004Sooooo2_l00007ooooo`;o000000?oooooo`000?l000000ol00003ooooo`Co00000oooool4
o`0004;ooooo0_l000000ooooooo0000o`00001Eooooo`Co0000E_ooool2o`0000;ooooo0_l0000B
ooooo`003_ooool2o`0000Wooooo0_l00014ooooo`Ko000000?oooooo`000?l000000_ooool2o`00
0003ooooool0003o000000Oooooo0ol00004ooooo`?o0000@_ooool2o`000003ooooool0003o0000
05Gooooo0_l0001@ooooo`;o00001_ooool2o`0000;ooooo0_l0000Booooo`003Oooool3o`0000_o
oooo0ol00012ooooo`Co00000_ooool6o`000003ooooool0003o000000Co00001?ooool2o`0000Go
oooo0_l00011ooooo`Go0000EOooool3o`0004gooooo0ol00009ooooo`Co00004oooool001kooooo
0ol00010ooooo`;o00004?ooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo053ooooo
0ol0000Sooooo`008Oooool4o`0004oooooo00?o0000ooooooooool0WOooool00ol0003ooooooooo
o`1=ooooo`Co00009_ooool002Gooooo0ol0001=ooooo`;o0000Voooool2o`0004gooooo0ol0000Z
ooooo`00:?ooool3o`0004cooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`1:oooo
o`?o0000;Oooool002_ooooo0ol0001:ooooo`;o0000UOooool2o`0004[ooooo0ol0000`ooooo`00
;_ooool3o`0004Wooooo0_l00018ooooo`03o`000?oooooooooo04Kooooo0_l00019ooooo`?o0000
<oooool0037ooooo1?l00017ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0AOoo
ool00ol0003oooooooooo`15ooooo`Co0000=_ooool003Gooooo0ol00015ooooo`;o0000AOooool0
0ol0003oooooooooo`13ooooo`;o0000AOooool3o`0003[ooooo000hooooo`?o0000A?ooool00ol0
003oooooooooo`12ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@_ooool3o`00
03gooooo000kooooo`?o0000@_ooool2o`0004;ooooo00?o0000ooooooooool0@?ooool2o`0004;o
oooo0ol00010ooooo`00?_ooool3o`00047ooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`0oooooo`03o`000?oooooooooo03oooooo0ol00013ooooo`00@Oooool3o`0003oooooo0_l0
000oooooo`03o`000?oooooooooo03gooooo0_l0000oooooo`?o0000A_ooool004Cooooo1?l0000m
ooooo`;o0000?Oooool00ol0003oooooooooo`0kooooo`;o0000?Oooool4o`0004Wooooo0018oooo
o`?o0000??ooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo03[ooooo00?o0000oooo
ooooool0>_ooool3o`0004gooooo001;ooooo`?o0000>_ooool2o`0003[ooooo00?o0000oooooooo
ool0>?ooool2o`0003[ooooo0ol0001@ooooo`00C_ooool3o`0003Wooooo00?o0000ooooooooool0
=oooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo03Oooooo0ol0001Cooooo`00DOoo
ool3o`0003Oooooo0_l0000gooooo`03o`000?oooooooooo03Gooooo0_l0000gooooo`?o0000E_oo
ool005Cooooo0ol0000fooooo`;o0000=Oooool00ol0003oooooooooo`0cooooo`;o0000=_ooool3
o`0005Wooooo001Gooooo`Co0000=?ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool0<_ooool4o`0005cooooo001Kooooo`?o0000<_ooool2o`0003;o
oooo00?o0000ooooooooool0<?ooool2o`0003;ooooo0ol0001Pooooo`00G_ooool3o`00037ooooo
00?o0000ooooooooool0;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo
0ol0001Sooooo`00HOooool3o`0002oooooo0_l0000_ooooo`03o`000?oooooooooo02gooooo0_l0
000_ooooo`?o0000I_ooool006Cooooo0ol0000^ooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`?o0000JOooool006Oooooo1?l0000[oooo
o`;o0000;?ooool00ol0003oooooooooo`0Zooooo`;o0000:oooool4o`0006cooooo001[ooooo`?o
0000:_ooool2o`0002[ooooo00?o0000ooooooooool0:?ooool2o`0002[ooooo0ol0001`ooooo`00
K_ooool3o`0002Wooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`00
0?oooooooooo02Oooooo0ol0001cooooo`00LOooool3o`0002Oooooo0_l0000Wooooo`03o`000?oo
oooooooo02Gooooo0_l0000Wooooo`?o0000M_ooool007Cooooo0ol0000Vooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`?o0000NOooool0
07Oooooo0ol0000Tooooo`;o00009?ooool00ol0003oooooooooo`0Rooooo`;o00009?ooool3o`00
07cooooo001jooooo`Co00008_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool08?ooool4o`0007oooooo001nooooo`?o00008?ooool2o`00027ooooo
00?o0000ooooooooool07oooool2o`00023ooooo0ol00023ooooo`00POooool3o`0001oooooo0_l0
000Oooooo`03o`000?oooooooooo01gooooo0_l0000Oooooo`?o0000Q_ooool008Cooooo0ol0000N
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0L
ooooo`?o0000ROooool008Oooooo0ol0000Looooo`;o00007?ooool00ol0003oooooooooo`0Joooo
o`;o00007?ooool3o`0008cooooo002:ooooo`?o00006oooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool06Oooool3o`0008oooooo002=ooooo`Co0000
6?ooool2o`0001Wooooo00?o0000ooooooooool05oooool2o`0001Sooooo1?l0002Booooo`00TOoo
ool3o`0001Oooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo0_l0000Gooooo`?o0000U_oo
ool009Cooooo0ol0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Dooooo`?o0000VOooool009Oooooo0ol0000Dooooo`;o00005?ooool00ol0
003oooooooooo`0Booooo`;o00005?ooool3o`0009cooooo002Jooooo`?o00004oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool3o`0009oo
oooo002Mooooo`?o00004Oooool2o`00017ooooo00?o0000ooooooooool03oooool2o`00017ooooo
0ol0002Rooooo`00X?ooool4o`0000oooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo1?l0002Uooooo`00Y?ooool3o`0000gooooo0_l0000>
ooooo`03o`000?oooooooooo00cooooo0_l0000=ooooo`?o0000ZOooool00:Oooooo0ol0000<oooo
o`;o00006Oooool2o`0000cooooo0ol0002/ooooo`00Z_ooool3o`0000_ooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`09ooooo`?o0000[oooool00:gooooo0ol00009ooooo`;o0000
4oooool2o`0000Wooooo0ol0002booooo`00/?ooool4o`0000Oooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`05ooooo`Co0000]Oooool00;Cooooo0ol0000Kooooo`?o0000^Oooool0
0;Oooooo0ol0000Eooooo`?o0000_?ooool00;[ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`2mooooo`00`Oooool6o`000<Oooooo0033ooooo`;o0000bOooool00<?ooooo0_l00039
ooooo`00`oooool2o`000<Wooooo0032ooooo`Go0000aoooool00<?ooooo0_l00039ooooo`00a?oo
ool3o`000<Oooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo
003oooooohoooooo0000\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17532, -0.833976, \
0.0110656, 0.00353548}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.400944 0.188567 0.603319 0.981006 [
[.02381 .40712 -5 -6 ]
[.02381 .40712 5 6 ]
[.14952 .40712 -5 -6 ]
[.14952 .40712 5 6 ]
[.14952 .21092 -5 -6 ]
[.14952 .21092 5 6 ]
[.27523 .40712 -5 -6 ]
[.27523 .40712 5 6 ]
[.40094 .40712 -5 -6 ]
[.40094 .40712 5 6 ]
[.52666 .40712 -5 -6 ]
[.52666 .40712 5 6 ]
[.65237 .40712 -5 -6 ]
[.65237 .40712 5 6 ]
[.77808 .40712 -5 -6 ]
[.77808 .40712 5 6 ]
[.57997 .01472 -5.0625 -6 ]
[.57997 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.77808 .21092 -5 -6 ]
[.77808 .21092 5 6 ]
[.40094 .60332 -20 -6 ]
[.40094 .60332 20 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.40094 .60332 m
.02381 .40712 L
s
.40094 .60332 m
.14952 .40712 L
s
.40094 .60332 m
.27523 .40712 L
s
.40094 .60332 m
.40094 .40712 L
s
.40094 .60332 m
.52666 .40712 L
s
.40094 .60332 m
.65237 .40712 L
s
.40094 .60332 m
.77808 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.14952 .40712 m
.14952 .21092 L
s
1 g
.05 w
.14952 .40712 Mdot
0 g
gsave
.14952 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.14952 .21092 Mdot
0 g
gsave
.14952 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.27523 .40712 Mdot
0 g
gsave
.27523 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.40094 .40712 Mdot
0 g
gsave
.40094 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.52666 .40712 Mdot
0 g
gsave
.52666 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.65237 .40712 Mdot
0 g
gsave
.65237 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.77808 .40712 m
.77808 .21092 L
s
1 g
.05 w
.77808 .40712 Mdot
0 g
gsave
.77808 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.77808 .21092 m
.57997 .01472 L
s
.77808 .21092 m
.97619 .01472 L
s
1 g
.05 w
.57997 .01472 Mdot
0 g
gsave
.57997 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.77808 .21092 Mdot
0 g
gsave
.77808 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.40094 .60332 Mdot
0 g
gsave
.40094 .60332 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f$7563) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00h_ooool7o`00097ooooo1Ol0000?ooooo`00h_oo
ool2o`0000;ooooo0_l0002Cooooo`;o000000?oooooo`000?l000003_ooool00>;ooooo1_l0002C
ooooo`;o000000?oooooo`000?l000003_ooool00>?ooooo1?l0002Dooooo`Co00003oooool00>?o
oooo1?l0002Dooooo`;o000000?oooooo`000?l000003_ooool00>Cooooo0_l0002Eooooo`;o0000
00?oooooo`000?l000003_ooool00>?ooooo0ol0002Dooooo`Go00003oooool00?ooooooSoooool0
0?ooooooSoooool00>gooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0Fooooo`00
k_ooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo01Oooooo003_ooooo`03o`000?oo
oooooooo087ooooo00?o0000ooooooooool06?ooool00?3ooooo00?o0000ooooooooool0Ooooool0
0ol0003oooooooooo`0Iooooo`00lOooool00ol0003oooooooooo`1mooooo`03o`000?oooooooooo
01[ooooo003booooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool06oooool00??ooooo
00?o0000ooooooooool0NOooool00ol0003oooooooooo`0Looooo`00m?ooool00ol0003ooooooooo
o`1gooooo`03o`000?oooooooooo01gooooo003eooooo`03o`000?oooooooooo07Gooooo00?o0000
ooooooooool07_ooool00?Kooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`0Ooooo
o`00moooool00ol0003oooooooooo`1aooooo`03o`000?oooooooooo023ooooo003hooooo`03o`00
0?oooooooooo06oooooo00?o0000ooooooooool08Oooool00?Wooooo00?o0000ooooooooool0KOoo
ool00ol0003oooooooooo`0Rooooo`00n_ooool00ol0003oooooooooo`1[ooooo`03o`000?oooooo
oooo02?ooooo003kooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool09?ooool00?co
oooo00?o0000ooooooooool0Ioooool00ol0003oooooooooo`0Uooooo`00oOooool00ol0003ooooo
ooooo`1Uooooo`03o`000?oooooooooo02Kooooo003nooooo`03o`000?oooooooooo06?ooooo00?o
0000ooooooooool09oooool00?oooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`0X
ooooo`00ooooool1ooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool0:Oooool00?oo
oooo0_ooool00ol0003oooooooooo`1Mooooo`03o`000?oooooooooo02[ooooo003oooooo`?ooooo
00?o0000ooooooooool0Foooool00ol0003oooooooooo`0[ooooo`00ooooool4ooooo`03o`000?oo
oooooooo05Wooooo00?o0000ooooooooool0;?ooool00?oooooo1Oooool00ol0003oooooooooo`1G
ooooo`03o`000?oooooooooo02gooooo003oooooo`Kooooo00?o0000ooooooooool0EOooool00ol0
003oooooooooo`0^ooooo`00ooooool7ooooo`03o`000?oooooooooo05?ooooo00?o0000oooooooo
ool0;oooool00?oooooo2?ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo033ooooo
003oooooo`Wooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`0aooooo`00ooooool:
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0<_ooool00?oooooo2oooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo03?ooooo003oooooo`cooooo00?o0000oooooooo
ool0BOooool00ol0003oooooooooo`0dooooo`00ooooool=ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool0=Oooool00?oooooo3_ooool00ol0003oooooooooo`15ooooo`03o`000?oo
oooooooo03Kooooo003oooooo`oooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`0g
ooooo`00ooooool@ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0>?ooool00?oo
oooo4Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo03Wooooo003ooooooa;ooooo
00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0jooooo`00oooooolCooooo`03o`000?oo
oooooooo03_ooooo00?o0000ooooooooool0>oooool00?oooooo5?ooool00ol0003oooooooooo`0i
ooooo`03o`000?oooooooooo03cooooo003ooooooaGooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`0mooooo`00oooooolFooooo`03o`000?oooooooooo03Gooooo00?o0000oooooooo
ool0?_ooool00?oooooo5oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo03oooooo
003ooooooaSooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`10ooooo`00oooooolI
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0@Oooool00?oooooo6_ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo04;ooooo003ooooooa_ooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`13ooooo`00oooooolLooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0A?ooool00?oooooo7Oooool00ol0003oooooooooo`0Wooooo`03o`000?oo
oooooooo04Gooooo003ooooooakooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`16
ooooo`00oooooolOooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0Aoooool00?oo
oooo8?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo04Sooooo003oooooob7ooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`19ooooo`00oooooolRooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0B_ooool00?oooooo8oooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo04_ooooo003oooooobCooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`1<ooooo`00oooooolUooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0COooool00?oooooo9_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo04kooooo
003oooooobOooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`1?ooooo`00oooooolX
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0D?ooool00?oooooo:Oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo057ooooo003oooooob[ooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`1Booooo`00ooooool[ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0Doooool00?ooooooSoooool00?ooooooSoooool00?oooooo<?ooool4o`00
05_ooooo003ooooooc?ooooo0_l0001Jooooo`00?oooool4o`000>cooooo1Ol0001Jooooo`00@?oo
ool2o`000>cooooo0_l00002ooooo`;o0000F_ooool003gooooo1_l0003[ooooo`;o00000_ooool2
o`0005[ooooo000mooooo`;o000000?oooooo`000?l00000k?ooool2o`0000;ooooo0_l0001Joooo
o`00?_ooool4o`000>gooooo1_l0001Iooooo`00?oooool3o`000?ooooooCOooool0043ooooo0_l0
003oooooodgooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo0010ooooo`03o`00
0?oooooooooo0?ooooooC?ooool0043ooooo00?o0000ooooooooool0oooooom<ooooo`00@?ooool0
0ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo
0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003o
ooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo
0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000
ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^oooo
o`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000oooooooo
ool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?oo
ool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooo
oooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0
003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[o
oooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o
0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^
ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000oooo
ooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00
@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oo
oooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool0
0ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo
05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo
00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003ooooooooo
o`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000
ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Joooo
o`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`00
0?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_oo
ool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooo
oooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043o
oooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003ooooo
ooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o
0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1J
ooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03
o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0
k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oo
oooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0
043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003o
ooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo
00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003ooooooooo
o`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010oooo
o`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000oooooooo
ool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`00
0?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_oo
ool0043ooooo00?o0000ooooooooool0k_ooool00ol0003oooooooooo`1Jooooo`00@?ooool00ol0
003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010ooooo`03o`000?oooooooooo0>ko
oooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000ooooooooool0k_ooool00ol0003ooooo
ooooo`1Jooooo`00@?ooool00ol0003oooooooooo`3^ooooo`03o`000?oooooooooo05[ooooo0010
ooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool0F_ooool0043ooooo00?o0000oooo
ooooool0k_ooool00ol0003oooooooooo`1Jooooo`00oooooon?ooooo`00oooooon?ooooo`00oooo
oon?ooooo`00oooooon?ooooo`00?_ooool4o`000>gooooo1?l0001Kooooo`00@Oooool2o`000>oo
oooo0_l0001Jooooo`003?ooool5o`0002gooooo1Ol0000[ooooo`Co0000;?ooool4o`0002cooooo
1Ol0000[ooooo`Go0000;?ooool5o`0005[ooooo000=ooooo`;o000000?oooooo`000?l00000:ooo
ool2o`0000;ooooo0_l0000Zooooo`;o00000_ooool2o`0002[ooooo00?o0000ooooool00000;ooo
ool2o`000003ooooool0003o000002_ooooo0_l000000ooooooo0000o`00000Zooooo`;o00000_oo
ool2o`0005[ooooo000=ooooo`;o000000?oooooo`000?l00000:oooool2o`0000;ooooo0_l0000^
ooooo`;o0000:_ooool00ol0003oooooo`000002o`0002gooooo0_l000000ooooooo0000o`00000[
ooooo`;o000000?oooooo`000?l00000:_ooool2o`0000;ooooo0_l0001Jooooo`003Oooool4o`00
02cooooo0_l00002ooooo`;o0000;?ooool3o`0002_ooooo00Go0000ooooool0003oooooo`00000]
ooooo`;o000000?oooooo`000?l00000:oooool4o`0002_ooooo0_l00002ooooo`;o0000F_ooool0
00gooooo0_l000000ooooooo0000o`00000/ooooo`Ko0000;Oooool2o`0002_ooooo0ol0000^oooo
o`;o000000?oooooo`000?l00000:oooool2o`000003ooooool0003o000002_ooooo1_l0001Ioooo
o`003Oooool2o`000003ooooool0003o000005_ooooo0_l00002ooooo`;o0000G?ooool2o`000003
ooooool0003o000002_ooooo0_l000000ooooooo0000o`00002:ooooo`003?ooool5o`0005gooooo
1?l0001Looooo`Go0000:oooool5o`0008_ooooo000Iooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0003oooooooooo`1Tooooo`006_ooool2o`000?oooooo2_ooool2o`0006Oooooo000Loooo
o`;o0000:oooool00ol0003oooooooooo`2[ooooo`;o0000:_ooool2o`0006Wooooo000Nooooo`;o
0000:_ooool2o`000:[ooooo00?o0000ooooooooool0:?ooool2o`0006_ooooo000Pooooo`;o0000
:_ooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo02Oooooo0_l0001]ooooo`008_oo
ool2o`0002Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool09_ooool2o`0006oooooo000Tooooo`;o0000:?ooool2
o`0002Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo02Gooooo0_l0000Wooooo`;o0000LOooool002Kooooo0_l0000Xooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
02Cooooo00?o0000ooooooooool09Oooool2o`0007?ooooo000Xooooo`;o00009oooool00ol0003o
ooooooooo`0Tooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo0_l0001eooooo`00:_ooool2o`0002Kooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool08oooool2o`0002Gooooo0_l0001gooooo`00;?ooool2o`0002Gooooo0_l0
000Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo02?ooooo0_l0001iooooo`00;_ooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1i
ooooo`00;oooool2o`0002Gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Roooo
o`;o0000O?ooool0037ooooo0_l0000Tooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo023ooooo0_l0000Sooooo`;o
0000O_ooool003?ooooo0_l0000Sooooo`;o00008_ooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Qooooo`;o0000
P?ooool003Gooooo0_l0000Sooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool08?oo
ool2o`0008;ooooo000gooooo`;o00008_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo01oooooo0_l00024ooooo`00>Oooool2o`00027ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool07_ooool2o`00
023ooooo0_l00026ooooo`00>oooool2o`00023ooooo0_l0000Oooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01ko
oooo0_l00028ooooo`00?Oooool2o`00023ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Mooooo`;o0000R_ooool003oooooo0_l0000Oooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01cooooo0_l0
000Nooooo`;o0000S?ooool0047ooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool07?ooool2o`0008kooooo0013ooooo`03o`000?oooooooooo01cooooo0_l0000Moooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool0S_ooool004Cooooo0_l0000Nooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool2o`00097ooooo0016ooooo`;o0000
7Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0Iooooo`;o00007?ooool2o`0009?ooooo0018ooooo`;o00007?oo
ool2o`0001_ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool06_ooool2o`0009Gooooo001:ooooo`;o00007?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0_l0002Gooooo`00C?ooool2o`00
01_ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hooooo`;o0000VOooool004ko
oooo0_l0000Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo01Oooooo0_l0000Iooooo`;o0000Voooool0053ooooo
0_l0000Iooooo`;o00006?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o0000WOooool005;ooooo0_l0
000Iooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool2o`0009oooooo001D
ooooo`;o00006?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Eooooo`;o00005oooool2o`000:7ooooo001Foooo
o`;o00005oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo0_l0002Soooo
o`00F?ooool00ol0003oooooooooo`0Eooooo`;o00005_ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo0:?ooooo001Iooooo`;o00005oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo01Cooooo0_l0002Vooooo`00Foooool2o`0001Kooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool04_oo
ool2o`0001Gooooo0_l0002Xooooo`00GOooool2o`0001Gooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Cooooo`;o0000Z_ooool005oooooo0_l0000Dooooo`;o00004oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`;o0000[?ooool0067ooooo0_l0000Dooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo013o
oooo0_l0000Cooooo`;o0000[_ooool006?ooooo0_l0000Cooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool2o`000;3ooooo001Uooooo`;o00004_ooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo013ooooo0_l0002booooo`00Ioooool2o`00017ooooo0_l0000A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00oooooo0_l0002dooooo`00JOooool2o`00017ooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool03_ooool2o`00013ooooo0_l0002fooooo`00Joooool2o`00013ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0>ooooo`;o0000^?ooool006gooooo00?o0000ooooooooool0
3_ooool2o`0000oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2hooooo`00K_oo
ool2o`00013ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`;o0000^ooo
ool0073ooooo0_l0000?ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo0_l0000>ooooo`;o0000_Oooool0
07;ooooo0_l0000>ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool2o`00
0;oooooo001dooooo`;o00003Oooool2o`0000cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool2o`000<7o
oooo001fooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`;o00003?ooool2o`000<?ooooo
001hooooo`;o00003?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo0_l0
0035ooooo`00N_ooool2o`0000_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09
ooooo`;o0000aoooool007cooooo0_l0000:ooooo`;o00002_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`;o0000bOooool007kooooo0_l0000:ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`;o
0000boooool0083ooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool2o`000<gooooo0022ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0<gooooo0023ooooo`;o00002?ooool2
o`0000Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool2o`000=3ooooo0025ooooo`;o00002?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`05ooooo`;o00001oooool2o`000=;ooooo0027ooooo`;o00001oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo0_l0003Dooooo`00ROooool2o`0000Kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`;o0000e_ooool008_ooooo0_l0
0005ooooo`;o00001Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool00oooool2o`0000Gooooo0_l0003Hooooo`00SOooool2o`0000Gooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`03ooooo`;o0000f_ooool008oooooo0_l00004oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00;ooooo0_l0003Looooo`00TOooool2o`0000?ooooo0_l0000Booooo`04
o`000?ooooooooooooooo`;o0000g_ooool009?ooooo0_l00003ooooo`03o`000?oooooooooo00go
oooo0_l00002ooooo`;o0000h?ooool009Gooooo0_l0000Cooooo`;o0000h_ooool009Oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`3Rooooo`00oooooon?ooooo`00Uoooool2o`00
0?Gooooo002>ooooo`Ko00000_ooool4o`0000Cooooo0_l00004ooooo`Co00000oooool4o`0000?o
oooo1?l0003Hooooo`00T?ooool2o`0000?ooooo1_l00003ooooo`;o00000oooool2o`0000;ooooo
0_l000000ooooooo0000o`000002ooooo`;o000000?oooooo`000?l000000_ooool2o`000=Oooooo
002@ooooo`;o00001Oooool4o`0000Cooooo0_l00006ooooo`;o000000?oooooo`000?l000000_oo
ool2o`0000Gooooo0_l0003Gooooo`00T?ooool2o`0000Cooooo1?l00005ooooo`;o00001_ooool2
o`000003ooooool0003o000000?o00001?ooool3o`000=Sooooo002?ooooo`Go000000?oooooo`00
0?l000000_l00007ooooo`;o000000?oooooo`000?l000000ol00002ooooo`;o00002Oooool2o`00
0=Oooooo002@ooooo`;o00000oooool6o`000003ooooool0003o000000;ooooo0_l000000ooooooo
0000o`000006ooooo`;o00001?ooool2o`0000;ooooo0_l0003Gooooo`00TOooool3o`0000;ooooo
1?l00002ooooo`Ko000000?oooooo`000?l000001?l00003ooooo`?o00000oooool4o`000=Sooooo
002Gooooo`;o0000mOooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool00001\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.21857, -0.625483, \
0.0137948, 0.00265161}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.19073 .30902 -5 -6 ]
[.19073 .30902 5 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.25889 .16187 -5 -6 ]
[.25889 .16187 5 6 ]
[.32704 .30902 -5 -6 ]
[.32704 .30902 5 6 ]
[.25889 .45617 -5 -6 ]
[.25889 .45617 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -20 -6 ]
[.72904 .45617 20 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.19073 .30902 L
s
.25889 .45617 m
.25889 .30902 L
s
.25889 .45617 m
.32704 .30902 L
s
1 g
.05 w
.19073 .30902 Mdot
0 g
gsave
.19073 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .30902 m
.25889 .16187 L
s
1 g
.05 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .16187 Mdot
0 g
gsave
.25889 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.32704 .30902 Mdot
0 g
gsave
.32704 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h$7582) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00lOooool7o`0008;ooooo1Ol0000?ooooo`00lOoo
ool2o`0000;ooooo0_l00024ooooo`;o000000?oooooo`000?l000003_ooool00?7ooooo1_l00024
ooooo`;o000000?oooooo`000?l000003_ooool00?;ooooo1?l00025ooooo`Co00003oooool00?;o
oooo1?l00025ooooo`;o000000?oooooo`000?l000003_ooool00??ooooo0_l00026ooooo`;o0000
00?oooooo`000?l000003_ooool00?;ooooo0ol00025ooooo`Go00003oooool00?ooooooSoooool0
0?cooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`0Fooooo`00oOooool00ol0003o
ooooooooo`1dooooo`03o`000?oooooooooo01Oooooo003nooooo`03o`000?oooooooooo07;ooooo
00?o0000ooooooooool06?ooool00?oooooo0_l0001`ooooo`;o00006oooool00?oooooo0_ooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo01_ooooo003oooooo`?ooooo00?o0000oooo
ooooool0J_ooool00ol0003oooooooooo`0Looooo`00ooooool4ooooo`03o`000?oooooooooo06So
oooo00?o0000ooooooooool07Oooool00?oooooo1Oooool2o`0006Oooooo00?o0000ooooooooool0
7_ooool00?oooooo1oooool00ol0003oooooooooo`1Rooooo`;o00008Oooool00?oooooo2?ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo027ooooo003oooooo`Wooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`0Rooooo`00ooooool:ooooo`;o0000GOooool00ol0003o
ooooooooo`0Sooooo`00ooooool<ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool0
9?ooool00?oooooo3Oooool00ol0003oooooooooo`1Fooooo`;o00009oooool00?oooooo3_ooool0
0ol0003oooooooooo`1Dooooo`03o`000?oooooooooo02Oooooo003oooooo`oooooo00?o0000oooo
ooooool0D_ooool00ol0003oooooooooo`0Xooooo`00ooooool@ooooo`;o0000DOooool00ol0003o
ooooooooo`0Yooooo`00oooooolBooooo`03o`000?oooooooooo04cooooo0_l0000/ooooo`00oooo
oolCooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0;?ooool00?oooooo5?ooool0
0ol0003oooooooooo`18ooooo`03o`000?oooooooooo02gooooo003ooooooaGooooo0_l00017oooo
o`03o`000?oooooooooo02kooooo003ooooooaOooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`0_ooooo`00oooooolHooooo`03o`000?oooooooooo043ooooo0_l0000booooo`00oooo
oolIooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0<_ooool00?oooooo6_ooool2
o`0003gooooo00?o0000ooooooooool0<oooool00?oooooo7?ooool00ol0003oooooooooo`0ioooo
o`03o`000?oooooooooo03Cooooo003ooooooagooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0eooooo`00oooooolNooooo`03o`000?oooooooooo03Cooooo0_l0000hooooo`00oooo
oolOooooo`;o0000<oooool00ol0003oooooooooo`0hooooo`00oooooolQooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0>Oooool00?oooooo8_ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo03[ooooo003oooooob?ooooo00?o0000ooooooooool0:_ooool2o`0003go
oooo003oooooobCooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0mooooo`00oooo
oolUooooo`;o00009oooool00ol0003oooooooooo`0nooooo`00oooooolWooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0?oooool00?oooooo:?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo043ooooo003oooooobWooooo00?o0000ooooooooool07_ooool2o`0004?o
oooo003oooooob[ooooo0_l0000Mooooo`03o`000?oooooooooo04?ooooo003oooooobcooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`14ooooo`00ooooool]ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0AOooool00?oooooo;_ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo04Kooooo003ooooooboooooo0_l0000Cooooo`;o0000BOooool00?oooooo
<Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04Wooooo003ooooooc;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`1:ooooo`00oooooon?ooooo`00oooooon?oooo
o`00oooooolhooooo`Co0000Doooool00?oooooo>oooool2o`0005;ooooo001Yooooo`Co0000b_oo
ool5o`0005;ooooo001Zooooo`;o0000b_ooool2o`0000;ooooo0_l0001Booooo`00Ioooool6o`00
0<Wooooo0_l00002ooooo`;o0000D_ooool006Oooooo0_l000000ooooooo0000o`00003:ooooo`;o
00000_ooool2o`0005;ooooo001Xooooo`Co0000boooool6o`00057ooooo001Yooooo`?o0000oooo
oolSooooo`00J_ooool2o`000?oooooo8oooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[o
oooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003ooooo
ooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o
0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1B
ooooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03
o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0
c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oo
oooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool0
06[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003o
ooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo
00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003ooooooooo
o`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zoooo
o`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000oooooooo
ool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`00
0?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_oo
ool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0
003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<co
oooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003ooooo
ooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Z
ooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000oooo
ooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03
o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0
D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool0
0ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo
0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003o
ooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo05;ooooo
001Zooooo`03o`000?oooooooooo0<cooooo00?o0000ooooooooool0D_ooool006[ooooo00?o0000
ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00J_ooool00ol0003oooooooooo`3<oooo
o`03o`000?oooooooooo05;ooooo001Zooooo`03o`000?oooooooooo0<cooooo00?o0000oooooooo
ool0D_ooool006[ooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`1Booooo`00oooo
oon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00J?oo
ool4o`000<_ooooo1?l0001Cooooo`00Joooool2o`000<gooooo0_l0001Booooo`00COooool5o`00
01Kooooo1Ol0000Eooooo`Co0000O?ooool4o`0000gooooo1Ol0000<ooooo`Go00003_ooool5o`00
05;ooooo001>ooooo`;o000000?oooooo`000?l000005?ooool2o`0000;ooooo0_l0000Dooooo`;o
00000_ooool2o`0007[ooooo00?o0000ooooool000004?ooool2o`000003ooooool0003o000000co
oooo0_l000000ooooooo0000o`00000<ooooo`;o00000_ooool2o`0005;ooooo001>ooooo`;o0000
00?oooooo`000?l000005?ooool2o`0000;ooooo0_l0000Hooooo`;o0000N_ooool00ol0003ooooo
o`000002o`0000kooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?oooooo`000?l00000
3?ooool2o`0000;ooooo0_l0001Booooo`00C_ooool4o`0001Gooooo0_l00002ooooo`;o00005_oo
ool3o`0007_ooooo00Go0000ooooool0003oooooo`00000>ooooo`;o000000?oooooo`000?l00000
3?ooool4o`0000gooooo0_l00002ooooo`;o0000D_ooool004kooooo0_l000000ooooooo0000o`00
000Eooooo`Ko00005oooool2o`0007_ooooo0ol0000?ooooo`;o000000?oooooo`000?l000003?oo
ool2o`000003ooooool0003o000000gooooo1_l0001Aooooo`00C_ooool2o`000003ooooool0003o
000002kooooo0_l00002ooooo`;o0000SOooool2o`000003ooooool0003o000000cooooo0_l00000
0ooooooo0000o`00001Tooooo`00COooool5o`00033ooooo1?l0002=ooooo`Go00003?ooool5o`00
06Gooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo001Doooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo05Kooooo001Dooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05Oooooo001Eooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`27ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo05Oooooo001Eooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo05Sooooo001Fooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`29ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo05Sooooo001Fooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo05Wooooo001Gooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`2;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Wo
oooo001Gooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`2;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo05Wooooo001Hooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05[ooooo001H
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`2=
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo05[ooooo001Iooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05_ooooo001Iooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`2?ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo05_ooooo001Jooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05cooooo001Jooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`2Aooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo05cooooo001Jooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`2Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo05gooooo001Kooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
05gooooo001Kooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`2Cooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo05kooooo001Looooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05kooooo
001Looooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`2Eooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo05oooooo001Mooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo001Moooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`2Goooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo063ooooo001Nooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo063ooooo001Nooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`2Iooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo067ooooo001Oooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo067ooooo001Oooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`2Kooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo06;ooooo001Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`2Mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo06;ooooo001Pooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?o
oooo001Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`2Mooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo06?ooooo001Qooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Cooooo001Q
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2O
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo06Cooooo001Rooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Gooooo001Rooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Qooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo06Gooooo001Sooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo06Kooooo001Sooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo06Kooooo001Tooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`2Uooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo06Ko
oooo001Tooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`2Uooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
06Wooooo001Uooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`2Wooooo`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`00001Y
ooooo`00IOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0Yoooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000J_oo
ool006Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Yooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0J?ooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool00?ooooooSoooool006Sooooo1?l0003oooooob?ooooo001[ooooo`;o0000Z?ooool2o`00
07Oooooo000<ooooo`Oo0000EOooool5o`0005Cooooo1Ol00016ooooo`Oo000000?oooooo`000?l0
00000_l00004ooooo`;o00001?ooool4o`0000?ooooo1?l00002ooooo`Ko0000@Oooool6o`0001;o
oooo000<ooooo`;o00000_ooool2o`0005Gooooo0_l00002ooooo`;o0000EOooool2o`000003oooo
ool0003o000004Kooooo0_l000001?oooooo0000o`000?ooool6o`0000?ooooo0_l00003ooooo`;o
00000_ooool2o`000003ooooool0003o000000;ooooo0_l00002ooooo`;o000000?oooooo`000?l0
0000@_ooool2o`000003ooooool0003o000001;ooooo000<ooooo`Ko0000EOooool2o`0000;ooooo
0_l0001Eooooo`;o000000?oooooo`000?l00000A_ooool2o`000003ooooool0003o000000?ooooo
1?l00004ooooo`;o00001_ooool2o`000003ooooool0003o000000;ooooo0_l00003ooooo`;o0000
AOooool2o`0001Cooooo000=ooooo`Co0000E_ooool2o`0000;ooooo0_l0001Eooooo`;o000000?o
ooooo`000?l00000A_ooool2o`000003ooooool0003o000000;ooooo1?l00005ooooo`;o00001_oo
ool2o`0000;ooooo1?l00005ooooo`;o0000AOooool2o`0001?ooooo000=ooooo`Co0000Eoooool6
o`0005Cooooo0_l000000ooooooo0000o`000016ooooo`Co00000_ooool4o`0000Oooooo0_l00000
0ooooooo0000o`000003o`0000;ooooo0_l00002ooooo`;o000000?oooooo`000?l000000_ooool2
o`00047ooooo0_l00002ooooo`;o00004_ooool000kooooo0_l00009ooooo`;o0000Yoooool2o`00
0003ooooool0003o000004Kooooo0_l00004ooooo`Ko000000?oooooo`000?l000000_ooool2o`00
0003ooooool0003o000000Gooooo0_l00002ooooo`;o000000?oooooo`000?l000000_ooool2o`00
03Wooooo0_l00006ooooo`;o00000_ooool2o`0001;ooooo000=ooooo`?o00002oooool3o`000:?o
oooo1Ol00016ooooo`?o00001Oooool4o`0000;ooooo1_l000000ooooooo0000o`000004o`0000;o
oooo1?l00003ooooo`Co0000=oooool3o`0000Wooooo1?l0000Cooooo`007_ooool3o`0005;ooooo
00?o0000ooooooooool0Woooool2o`00057ooooo0ol0000Sooooo`008Oooool4o`0004oooooo00?o
0000ooooooooool0WOooool00ol0003oooooooooo`1=ooooo`Co00009_ooool002Gooooo0ol0001=
ooooo`;o0000Voooool2o`0004gooooo0ol0000Zooooo`00:?ooool3o`0004cooooo00?o0000oooo
ooooool0Uoooool00ol0003oooooooooo`1:ooooo`?o0000;Oooool002_ooooo0ol0001:ooooo`;o
0000UOooool2o`0004[ooooo0ol0000`ooooo`00;_ooool3o`0004Wooooo0_l00018ooooo`03o`00
0?oooooooooo04Kooooo0_l00019ooooo`?o0000<oooool0037ooooo1?l00017ooooo`03o`000?oo
oooooooo04Gooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15ooooo`Co0000=_oo
ool003Gooooo0ol00015ooooo`;o0000AOooool00ol0003oooooooooo`13ooooo`;o0000AOooool3
o`0003[ooooo000hooooo`?o0000A?ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo
04;ooooo00?o0000ooooooooool0@_ooool3o`0003gooooo000kooooo`?o0000@_ooool2o`0004;o
oooo00?o0000ooooooooool0@?ooool2o`0004;ooooo0ol00010ooooo`00?_ooool3o`00047ooooo
00?o0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo03oooooo
0ol00013ooooo`00@Oooool3o`0003oooooo0_l0000oooooo`03o`000?oooooooooo03gooooo0_l0
000oooooo`?o0000A_ooool004Cooooo1?l0000mooooo`;o0000?Oooool00ol0003oooooooooo`0k
ooooo`;o0000?Oooool4o`0004Wooooo0018ooooo`?o0000??ooool00ol0003oooooooooo`0joooo
o`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0>_ooool3o`0004gooooo001;ooooo`?o
0000>_ooool2o`0003[ooooo00?o0000ooooooooool0>?ooool2o`0003[ooooo0ol0001@ooooo`00
C_ooool3o`0003Wooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0gooooo`03o`00
0?oooooooooo03Oooooo0ol0001Cooooo`00DOooool3o`0003Oooooo0_l0000gooooo`03o`000?oo
oooooooo03Gooooo0_l0000gooooo`?o0000E_ooool005Cooooo0ol0000fooooo`;o0000=Oooool0
0ol0003oooooooooo`0cooooo`;o0000=_ooool3o`0005Wooooo001Gooooo`Co0000=?ooool00ol0
003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool4o`00
05cooooo001Kooooo`?o0000<_ooool2o`0003;ooooo00?o0000ooooooooool0<?ooool2o`0003;o
oooo0ol0001Pooooo`00G_ooool3o`00037ooooo00?o0000ooooooooool0;oooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02oooooo0ol0001Sooooo`00HOooool3o`0002oooooo0_l0
000_ooooo`03o`000?oooooooooo02gooooo0_l0000_ooooo`?o0000I_ooool006Cooooo0ol0000^
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/
ooooo`?o0000JOooool006Oooooo1?l0000[ooooo`;o0000;?ooool00ol0003oooooooooo`0Zoooo
o`;o0000:oooool4o`0006cooooo001[ooooo`?o0000:_ooool2o`0002[ooooo00?o0000oooooooo
ool0:?ooool2o`0002[ooooo0ol0001`ooooo`00K_ooool3o`0002Wooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo0ol0001cooooo`00LOoo
ool3o`0002Oooooo0_l0000Wooooo`03o`000?oooooooooo02Gooooo0_l0000Wooooo`?o0000M_oo
ool007Cooooo0ol0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Tooooo`?o0000NOooool007Oooooo0ol0000Tooooo`;o00009?ooool00ol0
003oooooooooo`0Rooooo`;o00009?ooool3o`0007cooooo001jooooo`Co00008_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08?ooool4o`0007oo
oooo001nooooo`?o00008?ooool2o`00027ooooo00?o0000ooooooooool07oooool2o`00023ooooo
0ol00023ooooo`00POooool3o`0001oooooo0_l0000Oooooo`03o`000?oooooooooo01gooooo0_l0
000Oooooo`?o0000Q_ooool008Cooooo0ol0000Nooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0Looooo`?o0000ROooool008Oooooo0ol0000Loooo
o`;o00007?ooool00ol0003oooooooooo`0Jooooo`;o00007?ooool3o`0008cooooo002:ooooo`?o
00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool06Oooool3o`0008oooooo002=ooooo`Co00006?ooool2o`0001Wooooo00?o0000ooooooooool0
5oooool2o`0001Sooooo1?l0002Booooo`00TOooool3o`0001Oooooo0_l0000Gooooo`03o`000?oo
oooooooo01Gooooo0_l0000Gooooo`?o0000U_ooool009Cooooo0ol0000Fooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`?o0000VOooool0
09Oooooo0ol0000Dooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`;o00005?ooool3o`00
09cooooo002Jooooo`?o00004oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool3o`0009oooooo002Mooooo`?o00004Oooool2o`00017ooooo
00?o0000ooooooooool03oooool2o`00017ooooo0ol0002Rooooo`00X?ooool4o`0000oooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo1?l0
002Uooooo`00Y?ooool3o`0000gooooo0_l0000>ooooo`03o`000?oooooooooo00cooooo0_l0000=
ooooo`?o0000ZOooool00:Oooooo0ol0000<ooooo`;o00006Oooool2o`0000cooooo0ol0002/oooo
o`00Z_ooool3o`0000_ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`09ooooo`?o
0000[oooool00:gooooo0ol00009ooooo`;o00004oooool2o`0000Wooooo0ol0002booooo`00/?oo
ool4o`0000Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`05ooooo`Co0000]Ooo
ool00;Cooooo0ol0000Kooooo`?o0000^Oooool00;Oooooo0ol0000Eooooo`?o0000_?ooool00;[o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`2mooooo`00`Oooool6o`000<Oooooo
0033ooooo`;o0000bOooool00<?ooooo0_l00039ooooo`00`oooool2o`000<Wooooo0032ooooo`Go
0000aoooool00<?ooooo0_l00039ooooo`00a?ooool3o`000<Oooooo003oooooohoooooo003ooooo
ohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo0000\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17532, -0.833976, \
0.0110656, 0.00353548}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.2619 .21092 -5 -6 ]
[.2619 .21092 5 6 ]
[.2619 .01472 -5 -6 ]
[.2619 .01472 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.66907 .21092 -5 -6 ]
[.66907 .21092 5 6 ]
[.71509 .21092 -5 -6 ]
[.71509 .21092 5 6 ]
[.7611 .21092 -5 -6 ]
[.7611 .21092 5 6 ]
[.80712 .21092 -20 -6 ]
[.80712 .21092 20 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.00528 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
gsave
.2619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .01472 Mdot
0 g
gsave
.2619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
gsave
.66907 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .21092 Mdot
0 g
gsave
.71509 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .21092 Mdot
0 g
gsave
.7611 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.80712 .21092 Mdot
0 g
gsave
.80712 .21092 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7601) show
1.000 setlinewidth
grestore
1 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00JOooool4o`000?oooooo8_ooool006[ooooo0_l0003oooooob?ooooo001Wooooo`Ko0000
oooooolRooooo`00Ioooool2o`000003ooooool0003o00000?oooooo8oooool006Sooooo1?l0003o
ooooob?ooooo001Yooooo`?o0000oooooolSooooo`00J_ooool2o`000?oooooo8oooool00?oooooo
Soooool00?ooooooSoooool00?ooooooSoooool006[ooooo00?o0000ooooooooool0oooooolRoooo
o`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo
8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000oooooooo
ool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oo
oooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0
003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo
00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Z
ooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRoooo
o`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo
8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000oooooooo
ool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oo
oooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0
003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo
00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Z
ooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRoooo
o`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo
8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000oooooooo
ool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oo
oooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0
003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo
00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Z
ooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRoooo
o`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo
8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3o
ooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo00?o0000oooooooo
ool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oo
oooooooo0?oooooo8_ooool006[ooooo00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0
003oooooooooo`3oooooob;ooooo001Zooooo`03o`000?oooooooooo0?oooooo8_ooool006[ooooo
00?o0000ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`3oooooob;ooooo003o
ooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo001X
ooooo`Co0000`?ooool4o`0005kooooo001[ooooo`;o0000`_ooool2o`0000?ooooo0_l0001Hoooo
o`00C?ooool5o`0001Oooooo1Ol0000Fooooo`Co0000Ooooool4o`0000gooooo1Ol0000=ooooo`So
00000_ooool4o`0000Cooooo0_l00004ooooo`Co00001?ooool3o`0000?ooooo1?l0000kooooo`00
COooool2o`000003ooooool0003o000001Gooooo0_l00002ooooo`;o00005Oooool2o`0000;ooooo
0_l0001mooooo`03o`000?oooooo0000013ooooo0_l000000ooooooo0000o`00000=ooooo`Oo0000
00?oooooo`000?l000001?l00003ooooo`;o00000oooool2o`0000;ooooo0_l00002ooooo`;o0000
00?oooooo`000?l000000oooool2o`0003cooooo001=ooooo`;o000000?oooooo`000?l000005Ooo
ool2o`0000;ooooo0_l0000Iooooo`;o0000OOooool00ol0003oooooo`000002o`0000kooooo0_l0
00000ooooooo0000o`00000=ooooo`Oo00000oooool4o`0000Cooooo0_l00002ooooo`;o00000_oo
ool2o`0000;ooooo0_l000000ooooooo0000o`000003ooooo`;o0000??ooool004gooooo1?l0000F
ooooo`;o00000_ooool2o`0001Oooooo0ol0001nooooo`05o`000?oooooo0000ooooool000003_oo
ool2o`000003ooooool0003o000000gooooo1?l000000ooooooo0000o`000002ooooo`Co00001Ooo
ool2o`0000;ooooo1Ol00003ooooo`;o000000?oooooo`000?l000000oooool2o`0003cooooo001=
ooooo`;o000000?oooooo`000?l000005_ooool6o`0001Sooooo0_l0001nooooo`?o00003oooool2
o`000003ooooool0003o000000gooooo3?l00007ooooo`;o000000?oooooo`000?l000001_ooool2
o`000003ooooool0003o000000?ooooo0_l0000looooo`00COooool2o`000003ooooool0003o0000
033ooooo0_l00002ooooo`;o0000T?ooool2o`000003ooooool0003o000000gooooo0_l000000ooo
oooo0000o`000003ooooo`Ko000000?oooooo`000?l000000_ooool2o`0000;ooooo0_l00005oooo
o`;o000000?oooooo`000?l000000_ooool3o`0003cooooo001<ooooo`Go0000<_ooool4o`00093o
oooo1Ol0000=ooooo`Go00001Oooool4o`0000;ooooo1_l00003ooooo`?o00001?ooool3o`0000Co
oooo0_l0000looooo`00ooooooleooooo`;o0000F?ooool00?ooooooSoooool00?ooooooSoooool0
0?ooooooSoooool00?ooooooSoooool005;ooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo08Kooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0DOooool005?ooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo08Sooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0D_ooool005?ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo08Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0D_ooool005?ooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo08Sooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0D_ooool005Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo08[ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool0Doooool005Cooooo00?o0000ooooooooool0
4oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo08[ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
Doooool005Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo08cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0Doooool005Gooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0E?ooool0
05Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
08cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool0E?ooool005Kooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo08kooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0E?ooool005Kooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo08kooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool0EOooool005Kooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo08kooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0EOooool005Oooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo093ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0EOooool005Oooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo093ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0E_ooool005Oooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo093ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0E_ooool005Sooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo09;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0E_ooool005Sooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo09;ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Eooo
ool005Sooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo09;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0Eoooool005Wooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Eoooool005Wo
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo09Co
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0F?ooool005Wooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0F?ooool005[ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo09Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0F?ooool005[ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo09Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0FOooool005_ooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo09Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0FOooool005_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo09Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0FOooool005_ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo09Sooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
F_ooool005cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo09[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0F_ooool005cooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0F_ooool0
05cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
09[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0Foooool005gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0Foooool005gooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo09cooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0G?ooool005gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0G?ooool005kooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0G?ooool005kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo09kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0GOooool005kooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo09kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0GOooool005oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0:3ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0GOooool005oooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0G_oo
ool0063ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo0:;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0G_ooool0063ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo0:;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0G_ooool0063o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Goooool0067ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Goooool0067ooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0:Cooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0Goooool0067ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0H?ooool006;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0:Kooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0H?ooool006;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0:Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0H?ooool006;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool00000Hoooool006?ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0:Sooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooooooo
ool0HOooool006?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo0:Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool0HOooool006?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo0:Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool0H_ooool006Cooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:[ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000I?ooool006Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:[ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000I?ooool006Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:[ooooo00Go0000oooo
ooooooooooooo`000003ooooo`04o`000?ooooooooooo`0006Gooooo001Uooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2/ooooo`04o`000?oooooo
ooooo`0000?ooooo00Co0000oooooooooooo0000IOooool006Gooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:cooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool0001Uooooo`00I_ooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool0[_ooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000
ooooooooool0I?ooool006Kooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo0:kooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo06Cooooo
001Vooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`2^ooooo`06o`00
0?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1Tooooo`00oooooolWooooo`03
o`000?oooooooooo06Gooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003ooooo
ohoooooo001Xooooo`Co0000oooooolSooooo`00Joooool2o`000?oooooo8_ooool000_ooooo1ol0
001Fooooo`Go0000E_ooool5o`0005Sooooo1ol0001Eooooo`Ko00003?ooool000_ooooo0_l00002
ooooo`;o0000E_ooool2o`0000;ooooo0_l0001Gooooo`;o000000?oooooo`000?l00000F?ooool2
o`000003ooooool0003o000005Oooooo0_l000000ooooooo0000o`00000<ooooo`002oooool6o`00
05Kooooo0_l00002ooooo`;o0000Eoooool2o`000003ooooool0003o000005Sooooo0_l000000ooo
oooo0000o`00001Hooooo`;o00003_ooool000cooooo1?l0001Gooooo`;o00000_ooool2o`0005Oo
oooo0_l000000ooooooo0000o`00001Hooooo`;o000000?oooooo`000?l00000FOooool2o`0000go
oooo000<ooooo`Co0000F?ooool6o`0005Kooooo0_l000000ooooooo0000o`00001Hooooo`Co0000
Eoooool2o`0000;ooooo0_l0000<ooooo`003Oooool2o`000;Gooooo0_l000000ooooooo0000o`00
001Hooooo`;o0000FOooool2o`0000;ooooo0_l0000<ooooo`003?ooool3o`0000Sooooo0ol0002Y
ooooo`Go0000F?ooool3o`00057ooooo0_l00007ooooo`Co00003Oooool001[ooooo0_l0003ooooo
oeOooooo0_l0000Jooooo`007?ooool3o`0005?ooooo00?o0000ooooooooool0n_ooool3o`0001co
oooo000Oooooo`;o0000D_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo053ooooo
0_l0000Oooooo`008Oooool3o`00053ooooo00?o0000ooooooooool0X_ooool00ol0003ooooooooo
o`1>ooooo`?o00008Oooool002Cooooo0_l0001?ooooo`;o0000X?ooool2o`0004oooooo0_l0000T
ooooo`009_ooool2o`0004oooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo04cooooo0ol0000Vooooo`00:?ooool3o`0004gooooo00?o0000oooooooo
ool0Boooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04_ooooo0_l0000Yooooo`00
:oooool2o`0004cooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`1;ooooo`03o`00
0?oooooooooo04[ooooo0_l0000[ooooo`00;Oooool3o`0004[ooooo00?o0000ooooooooool0BOoo
ool00ol0003oooooooooo`19ooooo`;o0000B_ooool3o`0002gooooo000`ooooo`;o0000BOooool2
o`0004Wooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`18ooooo`;o0000<?ooool0
03;ooooo0ol00018ooooo`03o`000?oooooooooo04Kooooo00?o0000ooooooooool0Aoooool00ol0
003oooooooooo`16ooooo`?o0000<_ooool003Gooooo0_l00017ooooo`03o`000?oooooooooo04Go
oooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`15ooooo`;o0000=Oooool003Oooooo
0_l00016ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool0AOooool00ol0003ooooo
ooooo`13ooooo`?o0000=oooool003Wooooo0ol00014ooooo`03o`000?oooooooooo04?ooooo00?o
0000ooooooooool0@oooool2o`0004Cooooo0_l0000jooooo`00??ooool2o`0004?ooooo0_l00013
ooooo`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0@_ooool2o`0003cooooo000noooo
o`?o0000@_ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo047ooooo00?o0000oooo
ooooool0@?ooool3o`0003kooooo0011ooooo`;o0000@Oooool00ol0003oooooooooo`0oooooo`03
o`000?oooooooooo043ooooo00?o0000ooooooooool0?oooool2o`00047ooooo0013ooooo`;o0000
@?ooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo03kooooo0_l0000oooooo`?o0000
@oooool004Gooooo0ol0000nooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool0?Ooo
ool00ol0003oooooooooo`0mooooo`;o0000A_ooool004Sooooo0_l0000mooooo`;o0000?Oooool0
0ol0003oooooooooo`0looooo`03o`000?oooooooooo03_ooooo0ol00018ooooo`00B_ooool3o`00
03cooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo
03[ooooo0_l0001;ooooo`00COooool2o`0003_ooooo00?o0000ooooooooool0>Oooool00ol0003o
ooooooooo`0jooooo`03o`000?oooooooooo03Sooooo0ol0001=ooooo`00Coooool3o`0003Wooooo
00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0hooooo`;o0000>Oooool2o`00053ooooo
001Booooo`;o0000>?ooool2o`0003Sooooo00?o0000ooooooooool0=oooool00ol0003ooooooooo
o`0gooooo`;o0000D_ooool005Cooooo0_l0000hooooo`03o`000?oooooooooo03Gooooo00?o0000
ooooooooool0=_ooool00ol0003oooooooooo`0eooooo`?o0000E?ooool005Kooooo0ol0000foooo
o`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0doooo
o`;o0000Eoooool005Wooooo0_l0000eooooo`03o`000?oooooooooo03?ooooo00?o0000oooooooo
ool0<oooool2o`0003Cooooo0ol0001Iooooo`00Foooool3o`0003?ooooo00?o0000ooooooooool0
<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo0_l0001Looooo`00G_oo
ool2o`0003;ooooo0_l0000booooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<?oo
ool3o`0005kooooo001Pooooo`?o0000<Oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo033ooooo00?o0000ooooooooool0;oooool2o`00067ooooo001Sooooo`;o0000<?ooool00ol0
003oooooooooo`0^ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;_ooool2o`00
06?ooooo001Uooooo`;o0000;oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02go
oooo0_l0000^ooooo`?o0000IOooool006Oooooo0ol0000]ooooo`03o`000?oooooooooo02cooooo
00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/ooooo`;o0000J?ooool006[ooooo0_l0
000/ooooo`;o0000;?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo0ol0
001Zooooo`00K?ooool3o`0002_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo02Wooooo0_l0001]ooooo`00Koooool2o`0002[ooooo00?o0000oooo
ooooool0:?ooool00ol0003oooooooooo`0Xooooo`;o0000:Oooool3o`0006oooooo001aooooo`;o
0000:Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool09oooool2o`0007;ooooo001cooooo`?o00009oooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool09_ooool2o`0007Cooooo001fooooo`;o00009_oo
ool2o`0002Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Tooooo`?o0000M_oo
ool007Sooooo0ol0000Uooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0Sooooo`;o0000NOooool007_ooooo0_l0000Tooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool08_ooool2o`0002?ooooo0ol0001kooooo`00OOooool3o`0002;o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027o
oooo0_l0001nooooo`00P?ooool2o`00027ooooo0_l0000Qooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool07oooool3o`00083ooooo0022ooooo`;o00008Oooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool07_ooool2o`0008?ooooo0024
ooooo`?o00007oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01gooooo0_l0000O
ooooo`;o0000QOooool008Oooooo0_l0000Nooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0Looooo`?o0000Qoooool008Wooooo0ol0000Looooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0Kooooo`;o
0000R_ooool008cooooo0_l0000Kooooo`;o00006oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo01Wooooo0ol0002<ooooo`00S_ooool3o`0001[ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Sooooo0_l0002?ooooo`00TOooool2
o`0001Wooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0Gooooo`;o00006?ooool3
o`00097ooooo002Cooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
01Kooooo00?o0000ooooooooool05_ooool2o`0009Cooooo002Eooooo`?o00005_ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool3o`0009Ko
oooo002Hooooo`;o00005Oooool2o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`0Cooooo`;o0000VOooool009[ooooo0ol0000Dooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool2o`0001Cooooo0_l0002Kooooo`00WOooool2o`0001?ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo0ol0002M
ooooo`00Woooool2o`0001;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo013ooooo0_l0002Pooooo`00XOooool3o`00013ooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo0ol0002Rooooo`00
Y?ooool2o`0000oooooo0_l0000?ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool2o`000:Gooooo002Vooooo`?o00003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00cooooo0_l0000=ooooo`?o0000Yoooool00:Wooooo0_l0000=ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`;o0000Z_ooool0
0:_ooooo0ol0000;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`;o0000[?ooool00:kooooo0_l0000:ooooo`;o00002_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0ol0002^ooooo`00/?ooool2o`0000[ooooo
00?o0000ooooooooool04Oooool2o`0000Wooooo0_l0002aooooo`00/_ooool3o`0000Sooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`06ooooo`?o0000/oooool00;Gooooo0_l00007
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01Oooool2o`000;Kooooo002goooo
o`?o00006Oooool3o`000;Sooooo002jooooo`;o00005Oooool2o`000;_ooooo002looooo`;o0000
4Oooool2o`000;gooooo003oooooohoooooo0033ooooo`Ko0000aOooool00<Gooooo0_l00037oooo
o`00aOooool2o`000<Oooooo0035ooooo`;o0000aoooool00<Cooooo1Ol00035ooooo`00aOooool2
o`000<Oooooo0036ooooo`?o0000aOooool00?ooooooSoooool00?ooooooSoooool00?ooooooSooo
ool00?ooooooSoooool00?ooooooSoooool00001\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.15609, -0.620386, \
0.0108397, 0.00263085}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.25889 .45617 -20 -6 ]
[.25889 .45617 20 6 ]
[.25889 .30902 -5 -6 ]
[.25889 .30902 5 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.25889 .45617 m
.25889 .30902 L
s
1 g
.05 w
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7620) show
1.000 setlinewidth
grestore
1 g
.04 w
.25889 .30902 Mdot
0 g
gsave
.25889 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00lOooool7o`0008;ooooo1Ol0000?ooooo`00lOoo
ool2o`0000;ooooo0_l00024ooooo`;o000000?oooooo`000?l000003_ooool00?7ooooo1_l00024
ooooo`;o000000?oooooo`000?l000003_ooool00?;ooooo1?l00025ooooo`Co00003oooool00?;o
oooo1?l00025ooooo`;o000000?oooooo`000?l000003_ooool00??ooooo0_l00026ooooo`;o0000
00?oooooo`000?l000003_ooool00?;ooooo0ol00025ooooo`Go00003oooool00?ooooooSoooool0
0?cooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`0Fooooo`00oOooool00ol0003o
ooooooooo`1dooooo`03o`000?oooooooooo01Oooooo003nooooo`03o`000?oooooooooo07;ooooo
00?o0000ooooooooool06?ooool00?oooooo0_l0001`ooooo`;o00006oooool00?oooooo0_ooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo01_ooooo003oooooo`?ooooo00?o0000oooo
ooooool0J_ooool00ol0003oooooooooo`0Looooo`00ooooool4ooooo`03o`000?oooooooooo06So
oooo00?o0000ooooooooool07Oooool00?oooooo1Oooool2o`0006Oooooo00?o0000ooooooooool0
7_ooool00?oooooo1oooool00ol0003oooooooooo`1Rooooo`;o00008Oooool00?oooooo2?ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo027ooooo003oooooo`Wooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`0Rooooo`00ooooool:ooooo`;o0000GOooool00ol0003o
ooooooooo`0Sooooo`00ooooool<ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool0
9?ooool00?oooooo3Oooool00ol0003oooooooooo`1Fooooo`;o00009oooool00?oooooo3_ooool0
0ol0003oooooooooo`1Dooooo`03o`000?oooooooooo02Oooooo003oooooo`oooooo00?o0000oooo
ooooool0D_ooool00ol0003oooooooooo`0Xooooo`00ooooool@ooooo`;o0000DOooool00ol0003o
ooooooooo`0Yooooo`00oooooolBooooo`03o`000?oooooooooo04cooooo0_l0000/ooooo`00oooo
oolCooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0;?ooool00?oooooo5?ooool0
0ol0003oooooooooo`18ooooo`03o`000?oooooooooo02gooooo003ooooooaGooooo0_l00017oooo
o`03o`000?oooooooooo02kooooo003ooooooaOooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`0_ooooo`00oooooolHooooo`03o`000?oooooooooo043ooooo0_l0000booooo`00oooo
oolIooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0<_ooool00?oooooo6_ooool2
o`0003gooooo00?o0000ooooooooool0<oooool00?oooooo7?ooool00ol0003oooooooooo`0ioooo
o`03o`000?oooooooooo03Cooooo003ooooooagooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0eooooo`00oooooolNooooo`03o`000?oooooooooo03Cooooo0_l0000hooooo`00oooo
oolOooooo`;o0000<oooool00ol0003oooooooooo`0hooooo`00oooooolQooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0>Oooool00?oooooo8_ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo03[ooooo003oooooob?ooooo00?o0000ooooooooool0:_ooool2o`0003go
oooo003oooooobCooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0mooooo`00oooo
oolUooooo`;o00009oooool00ol0003oooooooooo`0nooooo`00oooooolWooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0?oooool00?oooooo:?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo043ooooo003oooooobWooooo00?o0000ooooooooool07_ooool2o`0004?o
oooo003oooooob[ooooo0_l0000Mooooo`03o`000?oooooooooo04?ooooo003oooooobcooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`14ooooo`00ooooool]ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0AOooool00?oooooo;_ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo04Kooooo003ooooooboooooo0_l0000Cooooo`;o0000BOooool00?oooooo
<Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04Wooooo003ooooooc;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`1:ooooo`00oooooon?ooooo`00oooooon?oooo
o`00oooooolhooooo`Co0000Doooool00?oooooo>oooool2o`0005;ooooo003oooooocSooooo1Ol0
001Booooo`00oooooolgooooo`;o00000_ooool2o`0005;ooooo003oooooocOooooo0_l00002oooo
o`;o0000D_ooool00?oooooo=oooool2o`0000;ooooo0_l0001Booooo`00oooooolhooooo`Ko0000
DOooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool00?ooooooSoooool00?ooooooSoooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o
0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljoooo
o`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo
>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003o
oooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o
0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljoooo
o`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo
>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003o
oooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003oooooohoooooo003o
ooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooocSooooo1?l0
001Cooooo`00oooooolkooooo`;o0000D_ooool006Wooooo1?l0002Eooooo`Co00003Oooool5o`00
00cooooo1Ol0000>ooooo`Go0000D_ooool006[ooooo0_l0002Eooooo`03o`000?oooooo0000013o
oooo0_l000000ooooooo0000o`00000<ooooo`;o000000?oooooo`000?l000003?ooool2o`0000;o
oooo0_l0001Booooo`00Ioooool6o`0009Cooooo00?o0000ooooool000000_l0000>ooooo`;o0000
00?oooooo`000?l000003?ooool2o`000003ooooool0003o000000cooooo0_l00002ooooo`;o0000
D_ooool006Oooooo0_l000000ooooooo0000o`00002Eooooo`05o`000?oooooo0000ooooool00000
3_ooool2o`000003ooooool0003o000000cooooo1?l0000=ooooo`;o00000_ooool2o`0005;ooooo
001Xooooo`Co0000U_ooool3o`0000oooooo0_l000000ooooooo0000o`00000<ooooo`;o000000?o
ooooo`000?l000003Oooool6o`00057ooooo001Yooooo`?o0000Z?ooool2o`000003ooooool0003o
000000cooooo0_l000000ooooooo0000o`00001Tooooo`00J_ooool2o`000:Oooooo1Ol0000<oooo
o`Go0000IOooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool006[ooooo00?o0000
ooooooooool0oooooolRooooo`00J_ooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool0E_ooool006[ooooo00?o0000ooooooooool0Voooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`1Gooooo`00J_ooool00ol0003oooooooooo`2Looooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo05Oooooo
001Zooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0F?ooool006[ooooo00?o0000
ooooooooool0WOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`1Hooooo`00J_ooool00ol0003oooooooooo`2Moooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo05Wooooo001Zooooo`03o`000?oooooooooo09kooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0FOooool006[ooooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Iooooo`00J_oo
ool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05[ooooo001Zooooo`03o`000?oooooo
oooo09oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0F_ooool006[ooooo00?o0000ooooooooool0X?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`1Kooooo`00J_ooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo05_o
oooo001Zooooo`03o`000?oooooooooo0:7ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0G?ooool006[ooooo00?o
0000ooooooooool0XOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`1Looooo`00J_ooool00ol0003oooooooooo`2Q
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo05gooooo001Zooooo`03o`000?oooooooooo0:;ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0GOooool006[ooooo00?o0000ooooooooool0X_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Nooooo`00
J_ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo05kooooo001Zooooo`03o`000?oo
oooooooo0:?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0Goooool006[ooooo00?o0000ooooooooool0Y?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1Oooooo`00J_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
063ooooo001Zooooo`03o`000?oooooooooo0:Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0H?ooool006[ooooo
00?o0000ooooooooool0YOooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Qooooo`00J_ooool00ol0003ooooooooo
o`2Vooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo067ooooo001Zooooo`03o`000?oooooooooo0:Kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0H_ooool006[ooooo00?o0000ooooooooool0Yoooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Roooo
o`00J_ooool00ol0003oooooooooo`2Wooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo06?ooooo001Zooooo`03o`00
0?oooooooooo0:Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0Hoooool006[ooooo00?o0000ooooooooool0Z?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`1Tooooo`00J_ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo06Cooooo001Zooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0IOooool006[o
oooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Uooooo`00J_ooool00ol0003ooooo
ooooo`2Zooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004ooooo`03
o`000?oooooooooo06Kooooo001Zooooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0I_ooool006[ooooo
00?o0000ooooooooool0Zoooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Vooooo`00J_ooool00ol0003oooooooooo`2[ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000006Wooooo001Zooooo`03
o`000?oooooooooo0:cooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo
000006Wooooo001Zooooo`03o`000?oooooooooo0:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0006[ooooo003ooooooa_ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1Xooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooo
oon?ooooo`00FOooool4o`000?oooooo<_ooool005cooooo0_l00003ooooo`;o0000ooooool/oooo
o`003?ooool7o`0004Kooooo1Ol00002ooooo`Co00001?ooool2o`0000Cooooo1?l00002ooooo`Ko
00000oooool3o`00047ooooo1Ol0001Eooooo`Oo0000E?ooool6o`0001;ooooo000<ooooo`;o0000
0_ooool2o`0004Kooooo0_l00002ooooo`;o000000?oooooo`000?l000001?l00003ooooo`;o0000
0oooool2o`0000;ooooo0_l00002ooooo`;o000000?oooooo`000?l000000_ooool2o`000003oooo
ool0003o0000047ooooo0_l000000ooooooo0000o`00001Eooooo`;o000000?oooooo`000?l00000
E_ooool2o`000003ooooool0003o000001;ooooo000<ooooo`Ko0000A_ooool2o`0000;ooooo0_l0
0003ooooo`Co00001?ooool2o`0000;ooooo0_l00002ooooo`;o00000oooool2o`0000Cooooo0_l0
00000ooooooo0000o`000011ooooo`;o000000?oooooo`000?l00000EOooool2o`000003ooooool0
003o000005Oooooo0_l0000Dooooo`003Oooool4o`0004Oooooo0_l00002ooooo`;o00000_ooool4
o`0000Gooooo0_l00002ooooo`Go00001Oooool2o`0000?ooooo0_l000000ooooooo0000o`000011
ooooo`;o000000?oooooo`000?l00000EOooool2o`000003ooooool0003o000005Sooooo0_l0000C
ooooo`003Oooool4o`0004Sooooo2_l00007ooooo`;o000000?oooooo`000?l000001Oooool2o`00
00;ooooo0_l00002ooooo`;o000000?oooooo`000?l00000@Oooool2o`000003ooooool0003o0000
05Gooooo1?l0001Fooooo`;o00000_ooool2o`0001;ooooo000>ooooo`;o00002Oooool2o`0004Co
oooo1_l000000ooooooo0000o`000002ooooo`;o00000_ooool2o`0000Cooooo0_l00002ooooo`;o
00000_ooool2o`000003ooooool0003o0000047ooooo0_l000000ooooooo0000o`00001Eooooo`;o
0000D?ooool2o`0000Kooooo0_l00002ooooo`;o00004_ooool000gooooo0ol0000;ooooo`?o0000
@_ooool4o`0000;ooooo1_l00003ooooo`?o00000oooool4o`0000Cooooo0ol00011ooooo`Go0000
EOooool3o`0004gooooo0ol00009ooooo`Co00004oooool001kooooo0ol00010ooooo`;o00004?oo
ool00ol0003oooooooooo`2Oooooo`03o`000?oooooooooo053ooooo0ol0000Sooooo`008Oooool4
o`0004oooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`1=ooooo`Co00009_ooool0
02Gooooo0ol0001=ooooo`;o0000Voooool2o`0004gooooo0ol0000Zooooo`00:?ooool3o`0004co
oooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`1:ooooo`?o0000;Oooool002_ooooo
0ol0001:ooooo`;o0000UOooool2o`0004[ooooo0ol0000`ooooo`00;_ooool3o`0004Wooooo0_l0
0018ooooo`03o`000?oooooooooo04Kooooo0_l00019ooooo`?o0000<oooool0037ooooo1?l00017
ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`15
ooooo`Co0000=_ooool003Gooooo0ol00015ooooo`;o0000AOooool00ol0003oooooooooo`13oooo
o`;o0000AOooool3o`0003[ooooo000hooooo`?o0000A?ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo04;ooooo00?o0000ooooooooool0@_ooool3o`0003gooooo000kooooo`?o0000
@_ooool2o`0004;ooooo00?o0000ooooooooool0@?ooool2o`0004;ooooo0ol00010ooooo`00?_oo
ool3o`00047ooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`03o`000?oo
oooooooo03oooooo0ol00013ooooo`00@Oooool3o`0003oooooo0_l0000oooooo`03o`000?oooooo
oooo03gooooo0_l0000oooooo`?o0000A_ooool004Cooooo1?l0000mooooo`;o0000?Oooool00ol0
003oooooooooo`0kooooo`;o0000?Oooool4o`0004Wooooo0018ooooo`?o0000??ooool00ol0003o
ooooooooo`0jooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0>_ooool3o`0004go
oooo001;ooooo`?o0000>_ooool2o`0003[ooooo00?o0000ooooooooool0>?ooool2o`0003[ooooo
0ol0001@ooooo`00C_ooool3o`0003Wooooo00?o0000ooooooooool0=oooool00ol0003ooooooooo
o`0gooooo`03o`000?oooooooooo03Oooooo0ol0001Cooooo`00DOooool3o`0003Oooooo0_l0000g
ooooo`03o`000?oooooooooo03Gooooo0_l0000gooooo`?o0000E_ooool005Cooooo0ol0000foooo
o`;o0000=Oooool00ol0003oooooooooo`0cooooo`;o0000=_ooool3o`0005Wooooo001Gooooo`Co
0000=?ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool0<_ooool4o`0005cooooo001Kooooo`?o0000<_ooool2o`0003;ooooo00?o0000ooooooooool0
<?ooool2o`0003;ooooo0ol0001Pooooo`00G_ooool3o`00037ooooo00?o0000ooooooooool0;ooo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo0ol0001Sooooo`00HOooool3
o`0002oooooo0_l0000_ooooo`03o`000?oooooooooo02gooooo0_l0000_ooooo`?o0000I_ooool0
06Cooooo0ol0000^ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool00ol0
003oooooooooo`0/ooooo`?o0000JOooool006Oooooo1?l0000[ooooo`;o0000;?ooool00ol0003o
ooooooooo`0Zooooo`;o0000:oooool4o`0006cooooo001[ooooo`?o0000:_ooool2o`0002[ooooo
00?o0000ooooooooool0:?ooool2o`0002[ooooo0ol0001`ooooo`00K_ooool3o`0002Wooooo00?o
0000ooooooooool09oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02Oooooo0ol0
001cooooo`00LOooool3o`0002Oooooo0_l0000Wooooo`03o`000?oooooooooo02Gooooo0_l0000W
ooooo`?o0000M_ooool007Cooooo0ol0000Vooooo`03o`000?oooooooooo02Cooooo00?o0000oooo
ooooool09?ooool00ol0003oooooooooo`0Tooooo`?o0000NOooool007Oooooo0ol0000Tooooo`;o
00009?ooool00ol0003oooooooooo`0Rooooo`;o00009?ooool3o`0007cooooo001jooooo`Co0000
8_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
8?ooool4o`0007oooooo001nooooo`?o00008?ooool2o`00027ooooo00?o0000ooooooooool07ooo
ool2o`00023ooooo0ol00023ooooo`00POooool3o`0001oooooo0_l0000Oooooo`03o`000?oooooo
oooo01gooooo0_l0000Oooooo`?o0000Q_ooool008Cooooo0ol0000Nooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`?o0000ROooool008Oo
oooo0ol0000Looooo`;o00007?ooool00ol0003oooooooooo`0Jooooo`;o00007?ooool3o`0008co
oooo002:ooooo`?o00006oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool06Oooool3o`0008oooooo002=ooooo`Co00006?ooool2o`0001Wooooo00?o
0000ooooooooool05oooool2o`0001Sooooo1?l0002Booooo`00TOooool3o`0001Oooooo0_l0000G
ooooo`03o`000?oooooooooo01Gooooo0_l0000Gooooo`?o0000U_ooool009Cooooo0ol0000Foooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Doooo
o`?o0000VOooool009Oooooo0ol0000Dooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`;o
00005?ooool3o`0009cooooo002Jooooo`?o00004oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04Oooool3o`0009oooooo002Mooooo`?o00004Ooo
ool2o`00017ooooo00?o0000ooooooooool03oooool2o`00017ooooo0ol0002Rooooo`00X?ooool4
o`0000oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00gooooo1?l0002Uooooo`00Y?ooool3o`0000gooooo0_l0000>ooooo`03o`000?oooooooooo
00cooooo0_l0000=ooooo`?o0000ZOooool00:Oooooo0ol0000<ooooo`;o00006Oooool2o`0000co
oooo0ol0002/ooooo`00Z_ooool3o`0000_ooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`09ooooo`?o0000[oooool00:gooooo0ol00009ooooo`;o00004oooool2o`0000Wooooo0ol0
002booooo`00/?ooool4o`0000Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`05
ooooo`Co0000]Oooool00;Cooooo0ol0000Kooooo`?o0000^Oooool00;Oooooo0ol0000Eooooo`?o
0000_?ooool00;[ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`2mooooo`00`Ooo
ool6o`000<Oooooo0033ooooo`;o0000bOooool00<?ooooo0_l00039ooooo`00`oooool2o`000<Wo
oooo0032ooooo`Go0000aoooool00<?ooooo0_l00039ooooo`00a?ooool3o`000<Oooooo003ooooo
ohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo0000\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17532, -0.833976, \
0.0110656, 0.00353548}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.493962 0.235076 0.603319 0.735755 [
[.02381 .45617 -5.0625 -6 ]
[.02381 .45617 5.0625 6 ]
[.25889 .45617 -20 -6 ]
[.25889 .45617 20 6 ]
[.49396 .45617 -5 -6 ]
[.49396 .45617 5 6 ]
[.66089 .30902 -5 -6 ]
[.66089 .30902 5 6 ]
[.70632 .30902 -5 -6 ]
[.70632 .30902 5 6 ]
[.75175 .30902 -5 -6 ]
[.75175 .30902 5 6 ]
[.79719 .30902 -5 -6 ]
[.79719 .30902 5 6 ]
[.61819 .01472 -5.0625 -6 ]
[.61819 .01472 5.0625 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.79719 .16187 -5 -6 ]
[.79719 .16187 5 6 ]
[.72904 .45617 -5 -6 ]
[.72904 .45617 5 6 ]
[.96411 .45617 -5 -6 ]
[.96411 .45617 5 6 ]
[.49396 .60332 -5 -6 ]
[.49396 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.49396 .60332 m
.02381 .45617 L
s
.49396 .60332 m
.25889 .45617 L
s
.49396 .60332 m
.49396 .45617 L
s
.49396 .60332 m
.72904 .45617 L
s
.49396 .60332 m
.96411 .45617 L
s
1 g
.05 w
.02381 .45617 Mdot
0 g
gsave
.02381 .45617 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.25889 .45617 Mdot
0 g
gsave
.25889 .45617 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7639) show
1.000 setlinewidth
grestore
1 g
.49396 .45617 Mdot
0 g
gsave
.49396 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.72904 .45617 m
.66089 .30902 L
s
.72904 .45617 m
.70632 .30902 L
s
.72904 .45617 m
.75175 .30902 L
s
.72904 .45617 m
.79719 .30902 L
s
1 g
.05 w
.66089 .30902 Mdot
0 g
gsave
.66089 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.70632 .30902 Mdot
0 g
gsave
.70632 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.75175 .30902 Mdot
0 g
gsave
.75175 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .30902 m
.79719 .16187 L
s
1 g
.05 w
.79719 .30902 Mdot
0 g
gsave
.79719 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
.5 Mabswid
.79719 .16187 m
.61819 .01472 L
s
.79719 .16187 m
.97619 .01472 L
s
1 g
.05 w
.61819 .01472 Mdot
0 g
gsave
.61819 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.97619 .01472 Mdot
0 g
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.79719 .16187 Mdot
0 g
gsave
.79719 .16187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.72904 .45617 Mdot
0 g
gsave
.72904 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.96411 .45617 Mdot
0 g
gsave
.96411 .45617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.49396 .60332 Mdot
0 g
gsave
.49396 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00lOooool7o`0008;ooooo1Ol0000?ooooo`00lOoo
ool2o`0000;ooooo0_l00024ooooo`;o000000?oooooo`000?l000003_ooool00?7ooooo1_l00024
ooooo`;o000000?oooooo`000?l000003_ooool00?;ooooo1?l00025ooooo`Co00003oooool00?;o
oooo1?l00025ooooo`;o000000?oooooo`000?l000003_ooool00??ooooo0_l00026ooooo`;o0000
00?oooooo`000?l000003_ooool00?;ooooo0ol00025ooooo`Go00003oooool00?ooooooSoooool0
0?cooooo00?o0000ooooooooool0M_ooool00ol0003oooooooooo`0Fooooo`00oOooool00ol0003o
ooooooooo`1dooooo`03o`000?oooooooooo01Oooooo003nooooo`03o`000?oooooooooo07;ooooo
00?o0000ooooooooool06?ooool00?oooooo0_l0001`ooooo`;o00006oooool00?oooooo0_ooool0
0ol0003oooooooooo`1/ooooo`03o`000?oooooooooo01_ooooo003oooooo`?ooooo00?o0000oooo
ooooool0J_ooool00ol0003oooooooooo`0Looooo`00ooooool4ooooo`03o`000?oooooooooo06So
oooo00?o0000ooooooooool07Oooool00?oooooo1Oooool2o`0006Oooooo00?o0000ooooooooool0
7_ooool00?oooooo1oooool00ol0003oooooooooo`1Rooooo`;o00008Oooool00?oooooo2?ooool0
0ol0003oooooooooo`1Pooooo`03o`000?oooooooooo027ooooo003oooooo`Wooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`0Rooooo`00ooooool:ooooo`;o0000GOooool00ol0003o
ooooooooo`0Sooooo`00ooooool<ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool0
9?ooool00?oooooo3Oooool00ol0003oooooooooo`1Fooooo`;o00009oooool00?oooooo3_ooool0
0ol0003oooooooooo`1Dooooo`03o`000?oooooooooo02Oooooo003oooooo`oooooo00?o0000oooo
ooooool0D_ooool00ol0003oooooooooo`0Xooooo`00ooooool@ooooo`;o0000DOooool00ol0003o
ooooooooo`0Yooooo`00oooooolBooooo`03o`000?oooooooooo04cooooo0_l0000/ooooo`00oooo
oolCooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0;?ooool00?oooooo5?ooool0
0ol0003oooooooooo`18ooooo`03o`000?oooooooooo02gooooo003ooooooaGooooo0_l00017oooo
o`03o`000?oooooooooo02kooooo003ooooooaOooooo00?o0000ooooooooool0@oooool00ol0003o
ooooooooo`0_ooooo`00oooooolHooooo`03o`000?oooooooooo043ooooo0_l0000booooo`00oooo
oolIooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool0<_ooool00?oooooo6_ooool2
o`0003gooooo00?o0000ooooooooool0<oooool00?oooooo7?ooool00ol0003oooooooooo`0ioooo
o`03o`000?oooooooooo03Cooooo003ooooooagooooo00?o0000ooooooooool0=oooool00ol0003o
ooooooooo`0eooooo`00oooooolNooooo`03o`000?oooooooooo03Cooooo0_l0000hooooo`00oooo
oolOooooo`;o0000<oooool00ol0003oooooooooo`0hooooo`00oooooolQooooo`03o`000?oooooo
oooo02oooooo00?o0000ooooooooool0>Oooool00?oooooo8_ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo03[ooooo003oooooob?ooooo00?o0000ooooooooool0:_ooool2o`0003go
oooo003oooooobCooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0mooooo`00oooo
oolUooooo`;o00009oooool00ol0003oooooooooo`0nooooo`00oooooolWooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool0?oooool00?oooooo:?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo043ooooo003oooooobWooooo00?o0000ooooooooool07_ooool2o`0004?o
oooo003oooooob[ooooo0_l0000Mooooo`03o`000?oooooooooo04?ooooo003oooooobcooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`14ooooo`00ooooool]ooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool0AOooool00?oooooo;_ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo04Kooooo003ooooooboooooo0_l0000Cooooo`;o0000BOooool00?oooooo
<Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo04Wooooo003ooooooc;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`1:ooooo`00oooooon?ooooo`00oooooon?oooo
o`00oooooolhooooo`Co0000Doooool00?oooooo>oooool2o`0005;ooooo003oooooocSooooo1Ol0
001Booooo`00oooooolgooooo`;o00000_ooool2o`0005;ooooo003oooooocOooooo0_l00002oooo
o`;o0000D_ooool00?oooooo=oooool2o`0000;ooooo0_l0001Booooo`00oooooolhooooo`Ko0000
DOooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?oooooo
Soooool00?ooooooSoooool00?ooooooSoooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o
0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljoooo
o`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo
>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003o
oooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o
0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljoooo
o`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo
>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003o
oooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Boooo
o`00ooooooljooooo`03o`000?oooooooooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0
D_ooool00?oooooo>_ooool00ol0003oooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooo
oooo05;ooooo003ooooooc[ooooo00?o0000ooooooooool0D_ooool00?oooooo>_ooool00ol0003o
ooooooooo`1Booooo`00ooooooljooooo`03o`000?oooooooooo05;ooooo003oooooohoooooo003o
ooooohoooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003oooooocSooooo1?l0
001Cooooo`00oooooolkooooo`;o0000D_ooool00?oooooo0oooool4o`0000gooooo1Ol0000<oooo
o`Go00003_ooool5o`0005;ooooo003oooooo`;ooooo00?o0000ooooool000004?ooool2o`000003
ooooool0003o000000cooooo0_l000000ooooooo0000o`00000<ooooo`;o00000_ooool2o`0005;o
oooo003oooooo`;ooooo00?o0000ooooool000000_l0000>ooooo`;o000000?oooooo`000?l00000
3?ooool2o`000003ooooool0003o000000cooooo0_l00002ooooo`;o0000D_ooool00?oooooo0_oo
ool01Ol0003oooooo`000?oooooo000000kooooo0_l000000ooooooo0000o`00000<ooooo`Co0000
3Oooool2o`0000;ooooo0_l0001Booooo`00ooooool3ooooo`?o00003oooool2o`000003ooooool0
003o000000cooooo0_l000000ooooooo0000o`00000=ooooo`Ko0000DOooool00?oooooo5Oooool2
o`000003ooooool0003o000000cooooo0_l000000ooooooo0000o`00001Tooooo`00oooooolDoooo
o`Go00003?ooool5o`0006Gooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo003o
ooooohoooooo003oooooo`Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Foooo
o`00ooooool9ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo05Oooooo003oooooo`[ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
Eoooool00?oooooo2_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`1Hooooo`00ooooool;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo05Sooooo003oooooo`_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0FOooool00?oooooo3?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`1Iooooo`00ooooool<ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05Wooooo003oooooo`gooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0F_ooool00?oooooo3Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Jooooo`00ooooool>oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo05_ooooo003oooooo`kooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Foooool00?oooooo
3oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`1Looooo`00ooooool?ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo05cooooo003o
ooooo`oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0GOooool00?oooooo4?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Moooo
o`00ooooool@ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo05kooooo003ooooooa7ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
G_ooool00?oooooo4Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`1Oooooo`00oooooolBooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo05oooooo003ooooooa;ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0H?ooool00?oooooo4oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`1Pooooo`00oooooolCooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo067ooooo003ooooooaCooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0HOooool00?oooooo5?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Rooooo`00oooooolEoooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo06;ooooo003ooooooaGooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Hoooool00?oooooo
5Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`1Sooooo`00oooooolFooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo06Cooooo003o
oooooaKooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0I?ooool00?oooooo5oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Uoooo
o`00oooooolGooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo06Gooooo003ooooooaSooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0I_ooool00?oooooo
6?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`1Vooooo`00oooooolIooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo06Kooooo003ooooooaWooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000JOooool00?oooooo6_ooool01?l0003o
ooooooooool00003ooooo`05o`000?ooooooooooooooool00000JOooool00?oooooo6_ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000J_ooool00?oooooo6oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo06Sooooo003oooooohoooooo003oooooohoo
oooo003oooooohoooooo003oooooohoooooo001Iooooo`Co0000oooooolbooooo`00G?ooool2o`00
00?ooooo0_l0003oooooobcooooo000<ooooo`Oo0000A_ooool5o`0000;ooooo1?l00004ooooo`;o
00001?ooool4o`0000?ooooo1?l00003ooooo`?o0000@_ooool5o`0005Gooooo1ol0001Dooooo`Ko
00004_ooool000cooooo0_l00002ooooo`;o0000A_ooool2o`0000;ooooo0_l000000ooooooo0000
o`000004o`0000?ooooo0_l00003ooooo`;o00000_ooool2o`000003ooooool0003o000000;ooooo
0_l00004ooooo`;o0000@_ooool2o`000003ooooool0003o000005Gooooo0_l000000ooooooo0000
o`00001Fooooo`;o000000?oooooo`000?l000004_ooool000cooooo1_l00016ooooo`;o00000_oo
ool2o`0000?ooooo1?l00004ooooo`;o00000_ooool2o`0000;ooooo0_l00005ooooo`;o00001Ooo
ool2o`00047ooooo0_l000000ooooooo0000o`00001Eooooo`;o000000?oooooo`000?l00000Eooo
ool2o`0001Cooooo000=ooooo`Co0000Aoooool2o`0000;ooooo0_l00002ooooo`Co00001Oooool2
o`0000;ooooo1Ol00004ooooo`?o00000oooool5o`00047ooooo0_l000000ooooooo0000o`00001E
ooooo`;o000000?oooooo`000?l00000F?ooool2o`0001?ooooo000=ooooo`Co0000B?ooool:o`00
00Oooooo0_l000000ooooooo0000o`000009ooooo`;o000000?oooooo`000?l000000_ooool2o`00
047ooooo0_l000000ooooooo0000o`00001Eooooo`Co0000E_ooool2o`0000;ooooo0_l0000Boooo
o`003_ooool2o`0000Wooooo0_l00014ooooo`Ko000000?oooooo`000?l000000_ooool2o`0000;o
oooo0_l00004ooooo`;o00000_ooool2o`000003ooooool0003o000000;ooooo0_l00011ooooo`;o
000000?oooooo`000?l00000EOooool2o`00053ooooo0_l00006ooooo`;o00000_ooool2o`0001;o
oooo000=ooooo`?o00002oooool3o`0004;ooooo1?l00002ooooo`Ko00000oooool3o`0000?ooooo
1?l00003ooooo`Co0000@Oooool5o`0005Gooooo0ol0001=ooooo`?o00002Oooool4o`0001?ooooo
000Nooooo`?o0000@?ooool2o`00013ooooo00?o0000ooooooooool0Woooool00ol0003ooooooooo
o`1@ooooo`?o00008oooool0027ooooo1?l0001?ooooo`03o`000?oooooooooo09gooooo00?o0000
ooooooooool0COooool4o`0002Kooooo000Uooooo`?o0000COooool2o`0009_ooooo0_l0001=oooo
o`?o0000:_ooool002Sooooo0ol0001<ooooo`03o`000?oooooooooo09Oooooo00?o0000oooooooo
ool0B_ooool3o`0002gooooo000[ooooo`?o0000B_ooool2o`0009Gooooo0_l0001:ooooo`?o0000
<?ooool002kooooo0ol00019ooooo`;o0000B?ooool00ol0003oooooooooo`16ooooo`;o0000BOoo
ool3o`0003?ooooo000aooooo`Co0000Aoooool00ol0003oooooooooo`15ooooo`03o`000?oooooo
oooo04Gooooo00?o0000ooooooooool0AOooool4o`0003Kooooo000eooooo`?o0000AOooool2o`00
04Gooooo00?o0000ooooooooool0@oooool2o`0004Gooooo0ol0000jooooo`00>?ooool3o`0004Co
oooo00?o0000ooooooooool0@_ooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo04;o
oooo0ol0000mooooo`00>oooool3o`0004;ooooo0_l00012ooooo`03o`000?oooooooooo043ooooo
0_l00012ooooo`?o0000@?ooool003kooooo0ol00011ooooo`03o`000?oooooooooo03oooooo00?o
0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`?o0000@oooool0047ooooo0ol0000o
ooooo`;o0000?oooool00ol0003oooooooooo`0mooooo`;o0000?oooool3o`0004Kooooo0014oooo
o`Co0000?Oooool2o`0003gooooo00?o0000ooooooooool0>oooool2o`0003gooooo1?l00019oooo
o`00B?ooool3o`0003cooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0jooooo`03
o`000?oooooooooo03[ooooo0ol0001=ooooo`00Boooool3o`0003[ooooo0_l0000jooooo`03o`00
0?oooooooooo03Sooooo0_l0000jooooo`?o0000D?ooool004kooooo0ol0000iooooo`03o`000?oo
oooooooo03Oooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0gooooo`?o0000Dooo
ool0057ooooo0ol0000gooooo`;o0000=oooool00ol0003oooooooooo`0eooooo`;o0000=oooool3
o`0005Kooooo001Dooooo`?o0000=_ooool2o`0003Gooooo00?o0000ooooooooool0<oooool2o`00
03Kooooo0ol0001Iooooo`00Eoooool4o`0003Cooooo00?o0000ooooooooool0<_ooool00ol0003o
ooooooooo`0booooo`03o`000?oooooooooo03;ooooo1?l0001Looooo`00Foooool3o`0003;ooooo
0_l0000booooo`03o`000?oooooooooo033ooooo0_l0000booooo`?o0000H?ooool005kooooo0ol0
000aooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003ooooooooo
o`0_ooooo`?o0000Hoooool0067ooooo0ol0000_ooooo`;o0000;oooool00ol0003oooooooooo`0]
ooooo`;o0000;oooool3o`0006Kooooo001Tooooo`?o0000;_ooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo02cooooo00?o0000ooooooooool0;?ooool3o`0006Wooooo001Wooooo`Co
0000:oooool2o`0002cooooo00?o0000ooooooooool0:_ooool2o`0002_ooooo1?l0001/ooooo`00
Joooool3o`0002[ooooo0_l0000Zooooo`03o`000?oooooooooo02Sooooo0_l0000Zooooo`?o0000
L?ooool006kooooo0ol0000Yooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`0Wooooo`?o0000Loooool0077ooooo0ol0000Wooooo`;o00009oooool0
0ol0003oooooooooo`0Uooooo`;o00009oooool3o`0007Kooooo001dooooo`?o00009_ooool00ol0
003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool09?ooool3o`00
07Wooooo001gooooo`?o00009?ooool2o`0002Cooooo00?o0000ooooooooool08_ooool2o`0002Co
oooo0ol0001looooo`00N_ooool4o`0002;ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo023ooooo1?l0001oooooo`00O_ooool3o`00023ooooo0_l0
000Qooooo`03o`000?oooooooooo01oooooo0_l0000Pooooo`?o0000Poooool0087ooooo0ol0000O
ooooo`;o00007oooool00ol0003oooooooooo`0Mooooo`;o00007oooool3o`0008Kooooo0024oooo
o`?o00007_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool07?ooool3o`0008Wooooo0027ooooo`?o00007?ooool2o`0001cooooo00?o0000oooooooo
ool06_ooool2o`0001cooooo0ol0002<ooooo`00R_ooool3o`0001_ooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo01Wooooo0ol0002?ooooo`00SOoo
ool4o`0001Sooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo0_l0000Hooooo`Co0000T_oo
ool0097ooooo0ol0000Gooooo`;o00005oooool00ol0003oooooooooo`0Eooooo`;o00005oooool3
o`0009Kooooo002Dooooo`?o00005_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
01Cooooo00?o0000ooooooooool05?ooool3o`0009Wooooo002Gooooo`?o00005?ooool2o`0001Co
oooo00?o0000ooooooooool04_ooool2o`0001Cooooo0ol0002Looooo`00V_ooool3o`0001?ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
0ol0002Oooooo`00WOooool3o`00017ooooo0_l0000Aooooo`03o`000?oooooooooo00oooooo0_l0
000Aooooo`?o0000X_ooool00:3ooooo1?l0000?ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`Co0000YOooool00:Cooooo0ol0000=oooo
o`;o00003_ooool00ol0003oooooooooo`0<ooooo`;o00003Oooool3o`000:Wooooo002Wooooo`?o
00003?ooool2o`0001Wooooo0_l0000<ooooo`?o0000[?ooool00:[ooooo0ol0000;ooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool02Oooool3o`000:oooooo002]ooooo`?o00002Ooo
ool2o`0001?ooooo0_l00009ooooo`?o0000/_ooool00;3ooooo1?l00007ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool01Oooool4o`000;Gooooo002dooooo`?o00006oooool3o`00
0;Wooooo002gooooo`?o00005Oooool3o`000;cooooo002jooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0_Oooool00<7ooooo1_l00037ooooo`00`oooool2o`000<Wooooo0033oooo
o`;o0000bOooool00<?ooooo0_l00039ooooo`00`_ooool5o`000<Oooooo0033ooooo`;o0000bOoo
ool00<Cooooo0ol00037ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooo
oon?ooooo`00oooooon?ooooo`00\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.17532, -0.833976, \
0.0110656, 0.00353548}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.238095 0.603319 0.981006 [
[.02381 .40712 -5.0625 -6 ]
[.02381 .40712 5.0625 6 ]
[.19288 .21092 -5 -6 ]
[.19288 .21092 5 6 ]
[.2619 .21092 -5 -6 ]
[.2619 .21092 5 6 ]
[.2619 .01472 -5 -6 ]
[.2619 .01472 5 6 ]
[.33093 .21092 -5 -6 ]
[.33093 .21092 5 6 ]
[.2619 .40712 -5 -6 ]
[.2619 .40712 5 6 ]
[.5 .40712 -5 -6 ]
[.5 .40712 5 6 ]
[.66907 .21092 -5 -6 ]
[.66907 .21092 5 6 ]
[.71509 .21092 -5 -6 ]
[.71509 .21092 5 6 ]
[.7611 .21092 -5 -6 ]
[.7611 .21092 5 6 ]
[.74459 .01472 -5.0625 -6 ]
[.74459 .01472 5.0625 6 ]
[.86966 .01472 -5 -6 ]
[.86966 .01472 5 6 ]
[.80712 .21092 -20 -6 ]
[.80712 .21092 20 6 ]
[.7381 .40712 -5 -6 ]
[.7381 .40712 5 6 ]
[.97619 .40712 -5 -6 ]
[.97619 .40712 5 6 ]
[.5 .60332 -5 -6 ]
[.5 .60332 5 6 ]
[ -0.00119 -0.01028 0 0 ]
[ 1.00119 .62832 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.5 .60332 m
.02381 .40712 L
s
.5 .60332 m
.2619 .40712 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.7381 .40712 L
s
.5 .60332 m
.97619 .40712 L
s
1 g
.05 w
.02381 .40712 Mdot
0 g
gsave
.02381 .40712 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .40712 m
.19288 .21092 L
s
.2619 .40712 m
.2619 .21092 L
s
.2619 .40712 m
.33093 .21092 L
s
1 g
.05 w
.19288 .21092 Mdot
0 g
gsave
.19288 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.2619 .21092 m
.2619 .01472 L
s
1 g
.05 w
.2619 .21092 Mdot
0 g
gsave
.2619 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.04 w
.2619 .01472 Mdot
0 g
gsave
.2619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
1 g
.05 w
.33093 .21092 Mdot
0 g
gsave
.33093 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
1 g
.2619 .40712 Mdot
0 g
gsave
.2619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
1.000 setlinewidth
grestore
1 g
.5 .40712 Mdot
0 g
gsave
.5 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
.5 Mabswid
.7381 .40712 m
.66907 .21092 L
s
.7381 .40712 m
.71509 .21092 L
s
.7381 .40712 m
.7611 .21092 L
s
.7381 .40712 m
.80712 .21092 L
s
1 g
.05 w
.66907 .21092 Mdot
0 g
gsave
.66907 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\343) show
1.000 setlinewidth
grestore
1 g
.71509 .21092 Mdot
0 g
gsave
.71509 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(D) show
1.000 setlinewidth
grestore
1 g
.7611 .21092 Mdot
0 g
gsave
.7611 .21092 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
.5 Mabswid
.80712 .21092 m
.74459 .01472 L
s
.80712 .21092 m
.86966 .01472 L
s
1 g
.05 w
.74459 .01472 Mdot
0 g
gsave
.74459 .01472 -66.0625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.062 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(A) show
1.000 setlinewidth
grestore
1 g
.86966 .01472 Mdot
0 g
gsave
.86966 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(B) show
1.000 setlinewidth
grestore
1 g
.80712 .21092 Mdot
0 g
gsave
.80712 .21092 -81 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g$7658) show
1.000 setlinewidth
grestore
1 g
.7381 .40712 Mdot
0 g
gsave
.7381 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(h) show
1.000 setlinewidth
grestore
1 g
.97619 .40712 Mdot
0 g
gsave
.97619 .40712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
1 g
.5 .60332 Mdot
0 g
gsave
.5 .60332 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
/Courier-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(f) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{398.812, 246.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006>0000mR000`400?l00000o`00003ooooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00J_ooool4o`000;?ooooo1ol0000Zooooo`Go0000
=oooool006_ooooo0_l0002dooooo`;o00000_ooool2o`0002cooooo0_l000000ooooooo0000o`00
000fooooo`00J?ooool6o`000;?ooooo1_l0000/ooooo`;o000000?oooooo`000?l00000=_ooool0
06Sooooo0_l000000ooooooo0000o`00002eooooo`Co0000;Oooool4o`0003Oooooo001Yooooo`Co
0000]Oooool4o`0002gooooo0_l000000ooooooo0000o`00000fooooo`00J_ooool3o`000;Kooooo
0_l0000^ooooo`;o000000?oooooo`000?l00000=_ooool006_ooooo0_l0002eooooo`?o0000;Ooo
ool5o`0003Oooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo001[ooooo`03o`00
0?oooooooooo0?oooooo8Oooool006_ooooo00?o0000ooooooooool0oooooolQooooo`00Joooool0
0ol0003oooooooooo`2iooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0>Oooool0
06_ooooo00?o0000ooooooooool0^Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
03[ooooo001[ooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0jooooo`00Joooool00ol0003oooooooooo`2jooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool0>_ooool006_ooooo00?o0000ooooooooool0^_ooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo03_ooooo001[ooooo`03o`000?oooooooooo0;_ooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0kooooo`00Joooool00ol0003oooooooooo`2koooo
o`03o`000?oooooooooo02Cooooo00?o0000ooooooooool0>oooool006_ooooo00?o0000oooooooo
ool0^oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03cooooo001[ooooo`03o`00
0?oooooooooo0;cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0looooo`00Jooo
ool00ol0003oooooooooo`2looooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0??oo
ool006_ooooo00?o0000ooooooooool0_?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo03gooooo001[ooooo`03o`000?oooooooooo0;gooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0mooooo`00Joooool00ol0003oooooooooo`2mooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool0?Oooool006_ooooo00?o0000ooooooooool0_Oooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo03kooooo001[ooooo`03o`000?oooooooooo0;kooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0nooooo`00Joooool00ol0003oooooooooo`2n
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0?_ooool006_ooooo00?o0000oooo
ooooool0__ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo03oooooo001[ooooo`03
o`000?oooooooooo0;kooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0oooooo`00
Joooool00ol0003oooooooooo`2oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
?oooool006_ooooo00?o0000ooooooooool0_oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo043ooooo001[ooooo`03o`000?oooooooooo0;oooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`10ooooo`00Joooool00ol0003oooooooooo`30ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool0@?ooool006_ooooo00?o0000ooooooooool0`?ooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo047ooooo001[ooooo`03o`000?oooooooooo0<3ooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`11ooooo`00Joooool00ol0003ooooooooo
o`31ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0@Oooool006_ooooo00?o0000
ooooooooool0`Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo04;ooooo001[oooo
o`03o`000?oooooooooo0<7ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`12oooo
o`00Joooool00ol0003oooooooooo`32ooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0@_ooool006_ooooo00?o0000ooooooooool0`_ooool00ol0003oooooooooo`0Eooooo`03o`00
0?oooooooooo04?ooooo001[ooooo`03o`000?oooooooooo0<;ooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`13ooooo`00Joooool00ol0003oooooooooo`33ooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool0@oooool006_ooooo00?o0000ooooooooool0`oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo04Cooooo001[ooooo`03o`000?oooooooooo0<?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`14ooooo`00Joooool00ol0003ooooo
ooooo`34ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0A?ooool006_ooooo00?o
0000ooooooooool0a?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo04Gooooo001[
ooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`15
ooooo`00Joooool00ol0003oooooooooo`35ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool0AOooool006_ooooo00?o0000ooooooooool0aOooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo04Kooooo001[ooooo`03o`000?oooooooooo0<Gooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`16ooooo`00Joooool00ol0003oooooooooo`36ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0A_ooool006_ooooo00?o0000ooooooooool0a_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo04Oooooo001[ooooo`03o`000?oooooooooo
0<Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`17ooooo`00Joooool00ol0003o
ooooooooo`36ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Aoooool006_ooooo
00?o0000ooooooooool0aoooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04Sooooo
001[ooooo`03o`000?oooooooooo0<Oooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`18ooooo`00Joooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0B?ooool006_ooooo00?o0000ooooooooool0b?ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo04Wooooo001[ooooo`03o`000?oooooooooo0<Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`19ooooo`00Joooool00ol0003oooooooooo`38ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0BOooool006_ooooo00?o0000ooooooooool0bOoo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04[ooooo001[ooooo`03o`000?oooooo
oooo0<Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1:ooooo`00Joooool00ol0
003oooooooooo`39ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0B_ooool006_o
oooo00?o0000ooooooooool0b_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04_o
oooo001[ooooo`03o`000?oooooooooo0<[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`1;ooooo`00Joooool00ol0003oooooooooo`3:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0Boooool006_ooooo00?o0000ooooooooool0boooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo04cooooo003oooooohoooooo003oooooohoooooo003oooooohoooooo
003oooooohoooooo003oooooohoooooo001Yooooo`Co0000__ooool4o`0005oooooo001/ooooo`;o
0000`?ooool2o`0000?ooooo0_l0001Iooooo`00COooool5o`0001Oooooo1Ol0000Eooooo`Co0000
O_ooool4o`0000gooooo1Ol0000=ooooo`So00000_ooool4o`0000Cooooo0_l00004ooooo`Co0000
0oooool4o`0000?ooooo1?l0000looooo`00C_ooool2o`000003ooooool0003o000001Gooooo0_l0
0002ooooo`;o00005?ooool2o`0000;ooooo0_l0001looooo`03o`000?oooooo0000013ooooo0_l0
00000ooooooo0000o`00000=ooooo`Oo000000?oooooo`000?l000001?l00003ooooo`;o00000ooo
ool2o`0000;ooooo0_l000000ooooooo0000o`000002ooooo`;o000000?oooooo`000?l000000_oo
ool2o`0003_ooooo001>ooooo`;o000000?oooooo`000?l000005Oooool2o`0000;ooooo0_l0000H
ooooo`;o0000O?ooool00ol0003oooooo`000002o`0000kooooo0_l000000ooooooo0000o`00000=
ooooo`Oo00000oooool4o`0000Cooooo0_l00002ooooo`;o00000_ooool2o`0000Gooooo0_l00000
0ooooooo0000o`000002ooooo`;o0000>oooool004kooooo1?l0000Fooooo`;o00000_ooool2o`00
01Kooooo0ol0001mooooo`05o`000?oooooo0000ooooool000003_ooool2o`000003ooooool0003o
000000gooooo1?l000000ooooooo0000o`000002ooooo`Co00001Oooool2o`0000;ooooo1Ol00006
ooooo`;o00000_ooool4o`0003cooooo001>ooooo`;o000000?oooooo`000?l000005_ooool6o`00
01Oooooo0_l0001mooooo`?o00003oooool2o`000003ooooool0003o000000gooooo3?l00007oooo
o`;o000000?oooooo`000?l000001Oooool5o`0000;ooooo0_l00002ooooo`;o0000>oooool004ko
oooo0_l000000ooooooo0000o`00000_ooooo`;o00000_ooool2o`0008oooooo0_l000000ooooooo
0000o`00000=ooooo`;o000000?oooooo`000?l000000oooool6o`000003ooooool0003o000000;o
oooo0_l00002ooooo`;o00001?ooool2o`0000Gooooo0_l00002ooooo`;o0000>oooool004gooooo
1Ol0000aooooo`Co0000Soooool5o`0000gooooo1Ol00005ooooo`Co00000_ooool6o`0000?ooooo
0ol00002ooooo`Ko00000_ooool4o`0003cooooo003oooooocCooooo0_l0001Iooooo`00oooooon?
ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00Doooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0QOooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`1Booooo`00E?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0Qoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`1Cooooo`00E?ooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Coooo
o`00EOooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0R?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`1Cooooo`00EOooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Dooooo`00EOoo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0ROoo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`1Dooooo`00E_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0R_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Dooooo`00E_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Roooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`1Eooooo`00E_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`1Eooooo`00Eoooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0S?ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`1Eooooo`00Eoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool0SOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`1Fooooo`00Eoooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1F
ooooo`00F?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool0S_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`1Fooooo`00F?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Gooooo`00
F?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
Soooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`1Gooooo`00FOooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool0T?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`1Gooooo`00FOooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0TOooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`1Hooooo`00F_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool0T_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1Hooooo`00F_ooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0Toooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1Iooooo`00F_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool0Toooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1Iooooo`00Foooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0U?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`1Iooooo`00Foooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0UOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1Jooooo`00Foooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1Joooo
o`00G?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0U_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1Jooooo`00G?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Kooooo`00G?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Uooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`1Kooooo`00GOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool0V?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Kooooo`00GOooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0VOooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`1Looooo`00G_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Looooo`00G_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0V_ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1Looooo`00G_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0Voooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`1Mooooo`00Goooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1M
ooooo`00Goooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0W?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`1Mooooo`00Goooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Nooooo`00
H?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
W_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`1Nooooo`00H?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Nooooo`00H?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Woooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`1Oooooo`00HOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0X?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`1Oooooo`00HOooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0X?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`1Oooooo`00HOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0XOooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`1Pooooo`00H_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0X_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`1Pooooo`00H_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0Xoooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`1Qooooo`00Hoooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1Qoooo
o`00Hoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0Y?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1Qooooo`00Hoooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0YOooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00Go0000ooooooooooooooooo`00001Tooooo`00I?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Y_ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`1Rooooo`00
I?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
Y_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`1Rooooo`00I?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0Yoooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`1Sooooo`00IOooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0Z?ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00001Uooooo`00IOooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0Z?ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00001Uooooo`00IOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0ZOooool01Ol0003ooooooooooooooooo
000000?ooooo00Co0000oooooooooooo0000I_ooool006Kooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo0:[ooooo00Co0000oooooooooooo00000ooo
ool01?l0003oooooooooool0001Vooooo`00I_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0Z_ooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0006Kooooo001Wooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`2/ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`1U
ooooo`00Ioooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0[?ooool0
1_l0003oooooooooool0003oooooo`0000;ooooo00?o0000ooooooooool0IOooool006Oooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0:cooooo00Ko0000oooooooooooo
0000ooooool00002ooooo`03o`000?oooooooooo06Gooooo001Xooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0[_ooool01ol0003oooooo`000?oooooo0000ooooool00000J?oo
ool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool00?ooooooSoooool006Wooooo1?l0
003oooooob;ooooo001/ooooo`;o0000oooooolQooooo`003?ooool7o`0005Kooooo1Ol0001Eoooo
o`Go0000Eoooool7o`0005Cooooo1_l0000>ooooo`003?ooool2o`0000;ooooo0_l0001Fooooo`;o
00000_ooool2o`0005Kooooo0_l000000ooooooo0000o`00001Gooooo`;o000000?oooooo`000?l0
0000E_ooool2o`000003ooooool0003o000000kooooo000<ooooo`Ko0000E_ooool2o`0000;ooooo
0_l0001Fooooo`;o000000?oooooo`000?l00000Eoooool2o`000003ooooool0003o000005Oooooo
0_l0000@ooooo`003Oooool4o`0005Oooooo0_l00002ooooo`;o0000E_ooool2o`000003ooooool0
003o000005Oooooo0_l000000ooooooo0000o`00001Hooooo`;o00003oooool000gooooo1?l0001H
ooooo`Ko0000EOooool2o`000003ooooool0003o000005Oooooo1?l0001Fooooo`;o00000_ooool2
o`0000kooooo000>ooooo`;o0000]?ooool2o`000003ooooool0003o000005Oooooo0_l0001Hoooo
o`;o00000_ooool2o`0000kooooo000=ooooo`?o00002Oooool2o`000:Sooooo1Ol0001Gooooo`?o
0000D?ooool2o`0000Oooooo1?l0000?ooooo`006oooool2o`000?ooooooE?ooool2o`0001cooooo
000Mooooo`?o0000oooooom>ooooo`?o00007_ooool0023ooooo0_l0001Booooo`03o`000?oooooo
oooo0:;ooooo00?o0000ooooooooool0Coooool2o`00027ooooo000Rooooo`;o0000DOooool00ol0
003oooooooooo`2Pooooo`03o`000?oooooooooo04kooooo0_l0000Sooooo`009?ooool3o`0004oo
oooo00?o0000ooooooooool0WOooool2o`0004kooooo0ol0000Uooooo`009oooool2o`0004kooooo
0_l0002Looooo`03o`000?oooooooooo04cooooo0_l0000Xooooo`00:Oooool3o`0004gooooo00?o
0000ooooooooool0B_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04[ooooo0ol0
000Zooooo`00;?ooool2o`0004cooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`1:
ooooo`03o`000?oooooooooo04Wooooo0_l0000]ooooo`00;_ooool3o`0004[ooooo00?o0000oooo
ooooool0B?ooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo04Oooooo0ol0000_oooo
o`00<Oooool2o`0004Wooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`17ooooo`;o
0000B?ooool2o`0003;ooooo000cooooo`;o0000B?ooool2o`0004Oooooo00?o0000ooooooooool0
A_ooool00ol0003oooooooooo`16ooooo`;o0000=?ooool003Gooooo0ol00017ooooo`03o`000?oo
oooooooo04Cooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`14ooooo`?o0000=_oo
ool003Sooooo0_l00016ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0A?ooool0
0ol0003oooooooooo`13ooooo`;o0000>Oooool003[ooooo0ol00014ooooo`03o`000?oooooooooo
04;ooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`11ooooo`?o0000>oooool003go
oooo0_l00013ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0@Oooool2o`0004;o
oooo0_l0000nooooo`00?oooool2o`0004;ooooo0_l00011ooooo`03o`000?oooooooooo043ooooo
00?o0000ooooooooool0@?ooool2o`00043ooooo0011ooooo`?o0000@Oooool00ol0003ooooooooo
o`0nooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool0?_ooool3o`0004;ooooo0014
ooooo`;o0000@?ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo03kooooo00?o0000
ooooooooool0?Oooool2o`0004Gooooo0016ooooo`?o0000?_ooool00ol0003oooooooooo`0loooo
o`03o`000?oooooooooo03gooooo00?o0000ooooooooool0>oooool3o`0004Oooooo0019ooooo`;o
0000?Oooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03_ooooo0_l0000looooo`;o
0000B_ooool004_ooooo0_l0000looooo`;o0000>oooool00ol0003oooooooooo`0jooooo`03o`00
0?oooooooooo03[ooooo0_l0001<ooooo`00COooool3o`0003_ooooo00?o0000ooooooooool0>?oo
ool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo03Sooooo0ol0001>ooooo`00D?ooool2
o`0003[ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0hooooo`03o`000?oooooo
oooo03Oooooo0_l0001Aooooo`00D_ooool3o`0003Sooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`0fooooo`;o0000=oooool3o`0005?ooooo001Eooooo`;o0000=oooool00ol0003o
ooooooooo`0eooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool2o`0005Ko
oooo001Gooooo`;o0000=_ooool2o`0003Gooooo00?o0000ooooooooool0=?ooool00ol0003ooooo
ooooo`0dooooo`;o0000F?ooool005Wooooo0ol0000eooooo`03o`000?oooooooooo03;ooooo00?o
0000ooooooooool0<oooool00ol0003oooooooooo`0booooo`?o0000F_ooool005cooooo0_l0000d
ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0a
ooooo`;o0000GOooool005kooooo0ol0000booooo`03o`000?oooooooooo033ooooo00?o0000oooo
ooooool0<?ooool2o`00037ooooo0ol0001Oooooo`00HOooool2o`00037ooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo0_l0001Rooooo`00
Hoooool2o`00033ooooo0_l0000_ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0
;_ooool2o`0006Cooooo001Uooooo`?o0000;oooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;?ooool3o`0006Kooooo001Xooooo`;o0000;_ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0:oooool2
o`0006Wooooo001Zooooo`?o0000;?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02[ooooo0_l0000[ooooo`?o0000Joooool006gooooo0_l0000[ooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`;o0000K_ooool006oooooo
0ol0000Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool00ol0003ooooo
ooooo`0Wooooo`?o0000L?ooool007;ooooo0_l0000Xooooo`;o0000:?ooool00ol0003ooooooooo
o`0Wooooo`03o`000?oooooooooo02Kooooo0_l0001cooooo`00M?ooool2o`0002Sooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo02Gooooo0_l0001e
ooooo`00M_ooool3o`0002Kooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Toooo
o`;o00009Oooool3o`0007Oooooo001iooooo`;o00009Oooool00ol0003oooooooooo`0Sooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool08oooool2o`0007[ooooo001kooooo`?o0000
8oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
8Oooool3o`0007cooooo001nooooo`;o00008_ooool2o`0002;ooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0Pooooo`;o0000Ooooool0083ooooo0_l0000Rooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool07oooool2o`00027ooooo0_l00021ooooo`00P_ooool3o`00
023ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
01kooooo0ol00023ooooo`00QOooool2o`0001oooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo01gooooo0_l00026ooooo`00Qoooool3o`0001gooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01_ooooo
0ol00028ooooo`00R_ooool2o`0001cooooo0_l0000Looooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool06_ooool2o`0008_ooooo002<ooooo`;o00007?ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo01Wooooo0_l0000Kooooo`;o0000SOooool008kooooo0ol0000Joooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0Hoooo
o`?o0000Soooool0097ooooo0_l0000Iooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0Gooooo`;o0000T_ooool009?ooooo0ol0000Gooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Eooooo`?o0000
U?ooool009Kooooo0_l0000Fooooo`;o00005_ooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo01Cooooo0_l0002Gooooo`00V?ooool2o`0001Kooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0Cooooo`;o00005Oooool2o`0009Wooooo002Jooooo`?o00005?ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool3o`00
09_ooooo002Mooooo`;o00004oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool2o`0009kooooo002Oooooo`?o00004Oooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03oooool3o`000:3ooooo
002Rooooo`;o00004?ooool2o`00013ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`0>ooooo`;o0000Xoooool00:Cooooo0_l0000@ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool2o`0000oooooo0_l0002Uooooo`00Y_ooool3o`0000kooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo0ol0002Woooo
o`00ZOooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00_ooooo0_l0002Zooooo`00Zoooool3o`0000_ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo0ol0002/ooooo`00[_oo
ool2o`0000[ooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo0_l0000:ooooo`;o0000[ooo
ool00;3ooooo0ol00009ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool3
o`000;7ooooo002cooooo`;o00002?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
00Kooooo0_l0002dooooo`00]Oooool2o`0000Oooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`05ooooo`;o0000]_ooool00;Oooooo0ol0000Iooooo`?o0000^?ooool00;[ooooo0_l0
000Eooooo`;o0000^oooool00;cooooo0_l0000Aooooo`;o0000_Oooool00?ooooooSoooool00<?o
oooo1_l00035ooooo`00aOooool2o`000<Oooooo0035ooooo`;o0000aoooool00<Gooooo0_l00037
ooooo`00a?ooool5o`000<Gooooo0035ooooo`;o0000aoooool00<Kooooo0ol00035ooooo`00oooo
oon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00oooooon?ooooo`00\
\>"],
  ImageRangeCache->{{{0, 397.812}, {245.5, 0}} -> {-2.1731, -0.625483, \
0.0109253, 0.00265161}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Decapsulation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Decapsulation /@ macroChromos", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(pop[
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 2]]], 
      chromo[q[undef], 
        p[f[A, g[B, g[4], 3], D, h[\[ExponentialE], D, B, g[g[A, B]]], 
            2]]]]\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Loading external packages", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Defining the packages directory", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "Note",
  StyleBox[": Evaluate the following cells to load the definitions needed to \
perform any calculations in this notebook.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  "For setting the ",
  StyleBox["Evolvica Directory",
    FontWeight->"Bold"],
  StyleBox[" ",
    FontSlant->"Italic"],
  "please refer to the ",
  ButtonBox["IEC Notebook",
    ButtonData:>{
      FrontEnd`FileName[ {"..", "..", "IEC-Contents.nb"}], 
      "Setting EVOLVICA Directory"},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SetDirectory[\[IndentingNewLine]ToFileName[{EvolvicaDirectory, \
"\<Chapters\>", \[IndentingNewLine]"\<08-AdvancedGP\>", "\<Packages\>"}]]\)], \
"Input",
  InitializationCell->True],

Cell[BoxData[
    \("/Users/jacob/Desktop/EvolvicaNotebooks/EvolvicaNotebooks/Chapters/08-\
AdvancedGP/Packages"\)], "Output"]
}, Open  ]],

Cell["To turn off spelling error messages:", "Text"],

Cell["Off[General::spell1]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reading packages", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Expression Generation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"ExprGeneration.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extraction of Substructures", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Get[\"Filters.m\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Implementation", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating Expressions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating Lists of Expressions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
createExpressions[howMany_Integer, startPattern_, opts___] :=
Module[{exprs = {}, lim = 10 howMany, i=0},

  While[(Length[exprs] < howMany) && (i < lim),
  
    exprs = Union[exprs ~Join~ 
      {createExpression[startPattern, opts]}];
    i++
  ];
  
  If[i === lim, 
    Print[\"Warning: \",howMany,
          \" diff. expressions not possible.\"]];
    
  exprs
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Options[createExpressions] := Options[createExpression]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["createExpressions[2, x, ExprPatterns -> {a}]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[\("Warning: "\[InvisibleSpace]2\[InvisibleSpace]" diff. \
expressions not possible."\),
      SequenceForm[ "Warning: ", 2, " diff. expressions not possible."],
      Editable->False]], "Print"],

Cell[BoxData[
    \({createExpression[x, ExprPatterns \[Rule] {a}]}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generation Function for Expressions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
createExpression[startPattern_, opts___] :=
Module[{patts, depth, cont = True, i = 1, tr, expr},

  depth = MaxDepth /. {opts} /. Options[createExpression];
  patts = ExprPatterns /. {opts} /. Options[createExpression];
  tr    = Trials /. {opts} /. Options[createExpression];
  
  While[cont,
    expr = randomExpr[startPattern, depth, patts, opts];
             
    If[Not[PatternQ[expr]], cont = False];
    
    If[i > tr,
      Print[\"Warning: No pattern free expression after \",
        tr,\" trials.\"];
      cont = False
    ];
    i++
  ];
  
  expr
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[createExpression] =
{
  MaxDepth -> 10, Trials -> 10,
  ExprPatterns -> {}, ExprWeights -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Random Expressions: randomExpr", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[randomExpr]", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Variable Number of Arguments", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_BlankSequence, depth_?Positive,
           patterns_List, opts___] :=
Module[{argRange},
  
  argRange = SequenceRange /. {opts} /. Options[randomExpr];
  
  Sequence @@ Table[
    randomExpr[
      If[Length[pat]>0,
        If[Head[First[pat]] === Alternatives,
          First[pat],
          Blank[First[pat]]],
        _],
      depth, patterns, opts],
    {Random[Integer,argRange]}]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_BlankNullSequence, depth_?Positive,
           patterns_List, opts___] :=
Module[{argRange},
  
  argRange = SequenceRange /. {opts} /. Options[randomExpr];
  
  Sequence @@ Table[
    randomExpr[
      If[Length[pat]>0,
        If[Head[First[pat]] === Alternatives,
          First[pat],
          Blank[First[pat]]],
        _],
      depth, patterns, opts],
    {randomSelect[Union[{0},argRange]]}]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Alternative Arguments", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Alternatives, depth_?Positive,
           patterns_List, opts___] :=
Module[{},
  
  (*randomExpr[randomSelect[pat], depth, patterns, opts]*)
  
  randomExpr[
    randomSelectWeight[patterns,pat,opts], 
    depth, patterns, opts
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Condition", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Condition, depth_?Positive,
           patterns_List, opts___] :=
Module[{randPat},
  
  randPat = randomSelectWeight[patterns, pat, opts];
  
  If[randPat === {},
    pat,
    randomExpr[randPat, depth, patterns, opts]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Blank Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[pat_Blank, depth_?Positive,
           patterns_List, opts___] :=
Module[{randPat},
  
  randPat = randomSelectWeight[patterns, pat, opts];
  
  If[randPat === {},
    pat,
    randomExpr[randPat, depth, patterns, opts]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expressions with Patterns or Alternatives", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[startPattern_/; (PatternQ[startPattern] ||
                            AlternativesQ[startPattern]), 
           maxDepth_?Positive,
           patterns_List, opts___] :=
Module[{},
      
  Map[
    randomExpr[#, maxDepth-1,patterns,opts]&, 
    startPattern, Heads -> True]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Expressions without Patterns or Alternatives", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomExpr[np_/; Not[PatternQ[np]] && Not[AlternativesQ[np]], 
           maxDepth_?NonNegative,
           patterns_List, opts___] := np\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Level-0 Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["randomExpr[pat_, 0, _List, opts___] := pat", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[randomExpr] =
{
  SequenceRange -> {1,1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["S-Expression Chromosomes", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["S-Expression Chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(createChromosomes[howMany_, \ opts___]\  := \n
      Apply[pop, \n\ \ \(chromo[q[undef], 
              p[#]] &\)\  /@ \n\ \ createExpressions[
            howMany, \n\ \ \ \ \(StartPattern\  /. \ {opts}\)\  /. \ 
              Options[createChromosomes], \n\ \ \ \ opts]]\)], "Input",
  InitializationCell->True],

Cell["\<\
Options[createChromosomes] =
{
  StartPattern -> _
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Genetic Operators", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Reproduction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Copying a GP Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Copy[chromoPop_pop, opts___] :=
Module[{},

  pop[ Selection[chromoPop, opts]//First ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Recombination of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Recombination[chromoPop_pop, opts___] :=
Module[{exprOne, exprTwo},

  exprOne = First[Last[Selection[chromoPop, opts]//First]];
  exprTwo = First[Last[Selection[chromoPop, opts]//First]];
  
  pop @@ Map[chromo[q[undef],p[#]]&,
    exprRecombination[{exprOne,exprTwo},opts]//First]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Recombination] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Recombination] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Recombination of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprRecombination[exprs_List, opts___] :=
Module[{randPos, randSubs},

  randPos = 
  Map[
    randomSelect[
      exprInstances[#, 
        selectTemplate[getTemplates[Recombination,opts]]]//Last
    ]&, 
    exprs];
      
  randSubs = 
  MapThread[Part[#1, Sequence @@ #2]&, {exprs,randPos}];
  
  {MapThread[ReplacePart,
    {exprs, RotateRight[randSubs], randPos}], randPos}
  
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Extension of ReplacePart", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Unprotect[ReplacePart];

ReplacePart[expr_, new_, {}] := new

Protect[ReplacePart];\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Mutation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Mutation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Mutation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Mutation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprMutation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Mutation] = {RespectHead -> True};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Mutation] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Mutation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMutation[expr_, opts___] :=
Module[{randPos, newSubExpr, insts, instPos, theHead},

  {insts, instPos} =
  exprInstances[expr, 
    selectTemplate[getTemplates[Mutation,opts]]];
    
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  
  theHead = 
  If[RespectHead /. {opts} /. Options[Mutation],
    Blank[Head[Part[expr, Sequence @@ randPos]]], 
    Blank[]
  ];
  
  newSubExpr = createExpression[theHead, opts];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Duplication of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Duplication[chromoPop_pop, opts___] :=
Module[{},

  pop[ Duplication[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Duplication[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDuplication[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Duplication] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Duplication] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Duplication of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprDuplication[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprDuplication[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Duplication,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  l = Length[subExpr];
  {i1, i2} = 
  Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];
  
  newSubExpr = 
  Join[
    Take[subExpr, Max[0,i1-1]],
    Take[subExpr, {i1,i2}], Take[subExpr, {i1,i2}],
    Take[subExpr, Min[l,i2]-l]
  ];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Deletion of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Deletion[chromoPop_pop, opts___] :=
Module[{},

  pop[ Deletion[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Deletion[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDeletion[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Deletion] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Deletion] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Deletion of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprDeletion[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[TextData[{
  "exprDeletion[expr_, opts___] :=\nModule[{instPos, randPos, subExpr, \
newSubExpr, i1, i2, l},\n\n  instPos =\n  exprInstances[expr, \n    \
selectTemplate[getTemplates[Deletion,opts]]] // Last;\n  \n  If[instPos === \
{}, Return[{expr,{}}]];\n  \n  randPos = randomSelect[instPos];\n  subExpr = \
Part[expr, Sequence @@ randPos];\n  \n  l = Length[subExpr];\n  {i1, i2} = \n \
 Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];\n  \n  newSubExpr = \
\n  Join[\n    Take[subExpr, Max[0,i1-1]],\n    Take[subExpr, Min[l,i2]-l]\n  \
];\n  \n  ",
  StyleBox["(* If no argument left, return original expression *)",
    FontSlant->"Italic"],
  "\n  If[Length[newSubExpr] == 0, newSubExpr = subExpr];\n  \n  \
{ReplacePart[expr, newSubExpr, randPos], randPos}\n]"
}], "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Inversion of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Inversion[chromoPop_pop, opts___] :=
Module[{},

  pop[ Inversion[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Inversion[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprInversion[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Options[Inversion] =
{
  InvPermutation :> 
    randomSelect[
    {
      Reverse, 
      RotateRight[#,Random[Integer,{1,Length[#]}]]&
    }]
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Inversion] =
{
  {{_, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Inversion of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["exprInversion[atomExpr_?AtomQ, opts___] := atomExpr", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
exprInversion[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, 
        i1, i2, l, perm},

  perm = InvPermutation /. {opts} /. Options[Inversion];
  
  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Inversion,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  l = Length[subExpr];
  {i1, i2} = 
  Sort[Table[Random[Integer,{1,l=Length[subExpr]}],{2}]];
  
  newSubExpr = 
  Join[
    Take[subExpr, Max[0,i1-1]],
    perm[Take[subExpr, {i1,i2}]],
    Take[subExpr, Min[l,i2]-l]
  ];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Encapsulation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Encapsulation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Encapsulation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Encapsulation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprEncapsulation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Encapsulation] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Encapsulation] =
{
  {{_, _, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprEncapsulation[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Encapsulation,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
  
  {encRule, newSubExpr} = 
    patternExtraction[subExpr,Depth[subExpr]];
    
  AppendTo[EncapsulationRules, encRule];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos, encRule}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Decapsulation of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Decapsulation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Decapsulation[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation of an S-Expression Chromosome", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Decapsulation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprDecapsulation[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[Decapsulation] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[Decapsulation] =
{
  {{_}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Decapsulation of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprDecapsulation[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr, i1, i2, l},
  
  {expr /. EncapsulationRules, {}}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Macro Extraction of S-Expression Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
MacroExtraction[chromoPop_pop, opts___] :=
Module[{},

  pop[ MacroExtraction[Selection[chromoPop, opts]//First, opts] ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction of an S-Expression Chromosome ", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
MacroExtraction[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[exprMacroExtraction[prog//First, opts]//First]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Options[MacroExtraction] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Templates", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Templates[MacroExtraction] =
{
  {{_, _, _}, 1}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Macro Extraction of Expressions", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
exprMacroExtraction[expr_, opts___] :=
Module[{instPos, randPos, subExpr, newSubExpr},

  instPos =
  exprInstances[expr, 
    selectTemplate[getTemplates[Encapsulation,opts]]] // Last;
  
  If[instPos === {}, Return[{expr,{}}]];
  
  randPos = randomSelect[instPos];
  subExpr = Part[expr, Sequence @@ randPos];
    
  {encRule, newSubExpr} = 
    patternExtraction[subExpr,
      Random[Integer,{1,Depth[subExpr]}]];
    
  AppendTo[EncapsulationRules, encRule];
  
  {ReplacePart[expr, newSubExpr, randPos], randPos, encRule}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Pattern Extraction", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[patternExtraction]", "Input",
  AspectRatioFixed->True],

Cell["patternExtraction[expr_, 0] := {expr, {}}", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
patternExtraction[expr_, level_Integer /; level > 0] :=
Module[{doReplacePart, uniqueVars, searchLevel,
        instances, instHeads, patternList, patternPosList,
        vars, fctHead},

  (* Locally defined functions *)
  
  doReplacePart[e_,{n_,p_}] := ReplacePart[e,n,p];
  
  uniqueVars[sym_String, howMany_Integer] :=
    ToExpression[sym <> ToString[#]]& /@ Range[howMany];
    
  (* Extract instances and their heads *)
  searchLevel = {level,level};
  instances   = Cases[expr, _, searchLevel];
  instHeads   = Head /@ instances;
  
  patternList = 
    MapThread[
      (**If[#1 === Symbol, 
        Pattern[#2,Blank[]], Pattern[#2,Blank[#1]]]&,**)
      Pattern[#2,Blank[#1]]&,
      {instHeads, vars = uniqueVars[\"x\",Length[instHeads]]}];
      
  patternPosList = 
    First[Position[expr,#,searchLevel]]& /@ instances;
    
  fctHead = Unique[Head[expr]];
  
  {(**Fold[doReplacePart, expr, 
     {patternList, patternPosList} // Transpose],**)
     
   RULE[
     fctHead @@ patternList,
     Fold[doReplacePart, expr,
       {vars, patternPosList} // Transpose]
   ] /. {RULE -> RuleDelayed},
   
   vars = {vars, Part[expr, Sequence @@ #]& /@ patternPosList}
          // Transpose;
   fctHead @@ (#[[2]]& /@ vars)
  }   
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Template Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
selectTemplate[templList_List] :=
Module[{templs, weights},

  (* Extract templates and weights *)
  
  templs = First /@ templList;
  weights = Last /@ templList;
  (**Print[templs]; Print[weights];**)
  
  (* Select template index fitness-proportionate *)
  
  templs[[selectFitProp[weights]]] 
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Template Composition", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
getTemplates[op_, opts___] :=
Module[{},

  Templates /. {opts} /. {Templates -> Templates[op]}
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection on Lists", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelect[s_List] := 
  s[[Random[Integer,{1,Length[s]}]]]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Multiple Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelectMultiple[s_List,n_Integer:1,opts___] :=
Module[{m,i},
  m=Map[s[[#]]&,i=Take[RandomPermutation[Length[s]],n]];
  
  If[ReturnIndices /. {opts} /. Options[randomSelectMultiple],
    {m,i},
    m
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Options[randomSelectMultiple] = {ReturnIndices -> False};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection on Lists", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Fitness-proportionate Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[selectFitProp]", "Input",
  AspectRatioFixed->True],

Cell["\<\
selectFitProp[fitnesses_, opts___] :=
Module[{cumFits, fits, r, m},

  fits = 
  If[Negative[m = Min[fitnesses]], fitnesses -m, fitnesses];
  
  cumFits = FoldList[Plus, 0, fits] // Rest;
  
  r = Random[] Last[cumFits];
  
  Position[cumFits, _?(# >= r &), {1}, 1][[1,1]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["selectFitProp[{-2,-2,-2}]", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
1\
\>", "\<\
1\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Rank-based Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[selectRankBased]", "Input",
  AspectRatioFixed->True],

Cell["\<\
selectRankBased[fitnesses_, opts___] :=
Module[{fitsAndIndsSorted, index},
  
  fitsAndIndsSorted = 
    Sort[MapIndexed[{#1,First[#2]}&,fitnesses]];
  
  index = selectFitProp[Range[Length[fitnesses]]];
  
  fitsAndIndsSorted[[index]]//Last
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Elite Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
selectElite[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Elite /. {opts} /. Options[selectElite];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  selectRandom[
    Last /@ 
    If[IntegerQ[bestCount],
      Take[fitsAndIndsSorted, bestCount],
      Take[fitsAndIndsSorted, 
        Max[1, Floor[bestCount Length[fitnesses]]]]
    ]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[selectElite] =
{
  Elite -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Best Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
selectBest[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Best /. {opts} /. Options[selectBest];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  Last /@ 
  If[IntegerQ[bestCount],
    Take[fitsAndIndsSorted, bestCount],
    Take[fitsAndIndsSorted, 
      Max[1, Floor[bestCount Length[fitnesses]]]]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Best\)\" is similar to \
existing symbols \!\({Nest, Rest}\)."\)], "Message"]
}, Open  ]],

Cell["\<\
Options[selectBest] =
{
  Best -> 1
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection of GP Chromosomes", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Selection Function", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Selection[population_pop,howMany_Integer:1,
  opts___] :=
  
Module[{},
  
  Switch[
    SelectionMode /. {opts} /. Options[Selection],
    
    BEST,
      Take[
        population // Sort // Reverse,
        howMany
      ],
      
    RANDOM,
      pop @@
      Table[
        population[[Random[Integer,
                           {1,Length[population]}]]],
        {howMany}
      ],
      
    FITPROP,
      Table[
        population[[
          selectFitProp[extractQuals[population],opts]
        ]],
        {howMany}],
        
    RANKBASED,
      Table[
        population[[
          selectRankBased[extractQuals[population],opts]
        ]],
        {howMany}],
        
    ELITE,
      Table[
        population[[
          selectElite[extractQuals[population],opts,
            Elite -> 1.
          ]
        ]],
        {howMany}]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[Selection] =
{
  SelectionMode -> FITPROP
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Extraction of Fitness Values", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
extractQuals[population_pop] := 
  List @@ Map[First[First[#]]&,population]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Evaluation Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Evaluation Function", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Evaluation[chromo[quality_q,prog_p,x___],
  opts___] :=

Module[{g},

  g = EvaluationFunction /. {opts} /. Options[Evaluation];
  
  chromo[q[g[prog]//N],prog,x]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[Evaluation] =
{
  EvaluationFunction :> Depth
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GP Evolution Scheme", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["ClearAll[Evolution]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Evolution[\[IndentingNewLine]GP[
            m_?IntegerQ,  (*parents*) \[IndentingNewLine]s_?
              AtomQ,  (*PLUS\ or\ COMMA*) \[IndentingNewLine]l_?
              IntegerQ,  (*children*) \[IndentingNewLine]g_?
              IntegerQ,  (*generations*) \[IndentingNewLine]opts___]\ i_:  
          1\  (*options*) \  (*independent\ runs*) ] \
:= \[IndentingNewLine]Module[\[IndentingNewLine]{initialParents, evalFct, 
          parents, children, selPool, selectOperator, opsAndProbs, 
          gen}, \[IndentingNewLine]\[IndentingNewLine]Print["\<GP evolution \
...\>"]; \[IndentingNewLine]\[IndentingNewLine] (*Define\ an\ operator\ \
selection\ function*) 
          opsAndProbs = \(Operators /. {opts}\) /. 
            Options[Evolution]; \
\[IndentingNewLine]\[IndentingNewLine]selectOperator := \(First[
              Transpose[opsAndProbs]]\)[\([selectFitProp[
                Last[Transpose[
                    opsAndProbs]]]]\)]; \
\[IndentingNewLine]\[IndentingNewLine] (*Generate\ m\ initial\ individuals\
*) \[IndentingNewLine]If[\((initialParents = \((\(InitialPopulation /. {opts}\
\) /. Options[Evolution])\))\) === {}, \(initialParents = 
              createChromosomes[m, 
                opts];\)\[IndentingNewLine]]; \[IndentingNewLine]\
\[IndentingNewLine] (*Get\ the\ evaluation\ \
function*) \[IndentingNewLine]evalFct = \(EvaluationFunction /. {opts}\) /. 
            Options[Evaluation]; \[IndentingNewLine]\[IndentingNewLine] \
(*Evaluate\ initial\ individuals*) Print["\<Generation \>", 
          gen = 0]; \[IndentingNewLine]\[IndentingNewLine]initialParents = 
          Map[Evaluation[#, EvaluationFunction \[RuleDelayed] evalFct] &, 
            initialParents]; \[IndentingNewLine]\[IndentingNewLine] (*Iterate\
\ for\ i\ independent\ runs*) \[IndentingNewLine]Table[ (*Iterate\ for\ g\ \
generations*) 
            NestList[\((Print["\<Generation \>", \(++gen\)]; \
\[IndentingNewLine]parents = #; \[IndentingNewLine]children = 
                  pop[]; \[IndentingNewLine]\[IndentingNewLine]While[
                  Length[children] < l, 
                  children = 
                    children~Join~
                      selectOperator[parents, 
                        opts]]; \
\[IndentingNewLine]\[IndentingNewLine]children = 
                  Map[Evaluation[#, opts] &, 
                    Take[children, 
                      l]]; \[IndentingNewLine]\[IndentingNewLine]selPool = 
                  Switch[s, PLUS, Join[parents, children], COMMA, 
                    children]; \[IndentingNewLine]\[IndentingNewLine]selPool \
= Join[selPool, Selection[parents, 1, 
                      SelectionMode \[Rule] 
                        BEST]]; \
\[IndentingNewLine]\[IndentingNewLine]Selection[selPool, m, 
                  SelectionMode \[Rule] BEST])\) &, initialParents, 
            g\[IndentingNewLine]],  (*end\ nesting*) \[IndentingNewLine]{i}\  \
(*independent\ runs*) \[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  InitializationCell->True],

Cell["\<\
Options[Evolution] = 
{
  InitialPopulation -> {},
  SelectionMode -> FITPROP,
  
  Operators -> {{Recombination, .5},
                {Mutation -> .25},
                {Copy -> .25}
               },
  
  MaxDepth -> 2,
  ExprPatterns -> {},
  ExprAtoms -> {}
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Visualization", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Terms as Trees", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Terms in Chromosomes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TermPlot[chromo[_q, p[t_]], opts___] := TermPlot[t,opts]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Terms in Chromosome Populations", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["TermPlot[p_pop, opts___] := TermPlot[#,opts]& /@ p", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fitness Values", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Needs[\"Statistics`DescriptiveStatistics`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["Needs[\"Graphics`FilledPlot`\"]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["ClearAll[plotFitnesses]", "Input",
  AspectRatioFixed->True],

Cell["\<\
plotFitnesses[es_List,opts___] :=
Module[{fitnesses},

  fitnesses =
    Map[Sort[Cases[#,_q,Infinity]]&,es] /. {q[x_] :> x};
    
  ListFilledPlot[Map[Max[#]&,fitnesses],
                 Map[Mean[#]&,fitnesses],
    PlotRange -> All,
    AxesLabel -> {\"Gen.\",\"Fit.\"},
    PlotLabel -> FontForm[\"Best and Mean Fitness\\n\" <>
      PlotTitle /. {opts} /. Options[plotFitnesses],
                   {\"Helvetica-Bold\",10}]
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["\<\
Options[plotFitnesses] =
{
  PlotTitle -> \"\"
};\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Playground ", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
printFitnesses[es_List] :=
Module[{fitnesses},

  fitnesses =
    Map[Sort[Cases[#,_q,Infinity]]&,es] /. {q[x_] :> x}
]\
\>", "Input",
  AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Saving GP Experiment Data", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
saveGPData[gp_,file_String:\"\"] := 
Module[{fileName},

  If[file === \"\",
    fileName = StringReplace[\"GP-Data.\" <> ToString[Unique[GA]],
                 \"$\" -> \"\"],
    fileName = file
  ];
  
  Put[gp,fileName];
  
  fileName
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Utility Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Random Selection: randomSelect, randomSelectWeight, fitPropSelect\
\
\>", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Random Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["randomSelect[s_] := s[[Random[Integer,{1,Length[s]}]]]", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["randomSelect[{}] = {};", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Selection of Weighted Patterns", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
randomSelectWeight[selExpr_, pat_, opts___] :=
Module[{weights, matchPat, matchPos, matchWeights},

  weights = ExprWeights /. {opts} 
            /. {ExprWeights :> Table[1,{Length[selExpr]}]};
  
  {matchPat, matchPos} = 
    {Cases[selExpr, pat], 
     Position[selExpr, pat, 1, Heads -> False]};
  (**Print[\"matchPat: \",matchPat];**)
  (**Print[\"matchPos: \",matchPos];**)
  
  matchWeights = Map[weights[[#//First]]&, matchPos];
  (**Print[\"matchWeights: \", matchWeights];**)
  pos = fitPropSelect[matchWeights];
  (**Print[\"pos: \",pos];**)
  matchPat[[pos]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Fitness-proportionate Selection", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
fitPropSelect[fitnesses_, opts___] :=
Module[{cumFits, fits, r, m},

  fits = 
  If[Negative[m = Min[fitnesses]], fitnesses -m, fitnesses];
  
  cumFits = FoldList[Plus, 0, fits] // Rest;
  
  r = Random[] Last[cumFits];
  
  Position[cumFits, _?(# >= r &), {1}, 1][[1,1]]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell["fitPropSelect[{}, opts___] := {}", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Testing for Pattern Expressions: PatternQ", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
PatternQ[x_] :=
Module[{realPats,pats},

  {realPats,pats} = {{Blank, BlankSequence,BlankNullSequence},
                     {BLANK, BLANKSEQ, BLANKNULLSEQ}};

  If[Count[{x} /. MapThread[#1->#2&,{realPats,pats}],
       Alternatives @@ Map[#[___]&,pats],Infinity,
       Heads -> True] > 0, 
    True, False
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Testing for Alternatives: AlternativesQ", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
AlternativesQ[x_] :=
Module[{realPats,pats},

  {realPats,pats} = {{Alternatives},
                     {ALTERNATIVES}};

  If[Count[{x} /. MapThread[#1->#2&,{realPats,pats}],
       Alternatives @@ Map[#[___]&,pats],Infinity,
       Heads -> True] > 0, 
    True, False
  ]
]\
\>", "Input",
  InitializationCell->True,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["AlternativesQ[g[a ]]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(False\)], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  "C. Jacob, ",
  StyleBox["Illustrating Evolutionary Computation with Mathematica.",
    FontWeight->"Bold"],
  " Morgan Kaufmann Publishers, San Fancisco, 2001. Chapter 8.\n"
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 746}},
AutoGeneratedPackage->None,
WindowToolbars->{},
InitializationCellEvaluation->True,
CellGrouping->Automatic,
WindowSize->{822, 704},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellBracket->False,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"MacintoshAutomaticEncoding",
StyleDefinitions -> FrontEnd`FileName[{ParentDirectory[ParentDirectory[]], \
"IEC-Setup"}, "EvolvicaStyle.nb", CharacterEncoding -> "MacintoshRoman"]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Mutation - Intro"->{
    Cell[28934, 834, 49, 1, 26, "Text",
      CellTags->"Mutation - Intro"]},
  "Recombination - Intro"->{
    Cell[1064042, 27712, 54, 1, 26, "Text",
      CellTags->"Recombination - Intro"]},
  "Duplication - Intro"->{
    Cell[1909694, 52152, 52, 1, 26, "Text",
      CellTags->"Duplication - Intro"]},
  "Deletion - Intro"->{
    Cell[2483335, 67164, 49, 1, 26, "Text",
      CellTags->"Deletion - Intro"]},
  "Inversion - Intro"->{
    Cell[2848981, 77484, 50, 1, 26, "Text",
      CellTags->"Inversion - Intro"]},
  "Encapsulation - Intro"->{
    Cell[3227240, 88418, 54, 1, 26, "Text",
      CellTags->"Encapsulation - Intro"]},
  "Pattern extraction - Intro"->{
    Cell[3514590, 95735, 59, 1, 26, "Text",
      CellTags->"Pattern extraction - Intro"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Mutation - Intro", 3974139, 108278},
  {"Recombination - Intro", 3974246, 108281},
  {"Duplication - Intro", 3974360, 108284},
  {"Deletion - Intro", 3974469, 108287},
  {"Inversion - Intro", 3974576, 108290},
  {"Encapsulation - Intro", 3974688, 108293},
  {"Pattern extraction - Intro", 3974809, 108296}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 185, 6, 167, "Title",
  Evaluatable->False],
Cell[1964, 61, 113, 3, 62, "Subsubtitle"],
Cell[2080, 66, 25970, 732, 152, "Text"],

Cell[CellGroupData[{
Cell[28075, 802, 80, 2, 76, "Subtitle",
  Evaluatable->False],
Cell[28158, 806, 325, 8, 44, "Text"],
Cell[28486, 816, 223, 3, 152, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28746, 824, 85, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[28856, 830, 75, 2, 78, "Section",
  Evaluatable->False],
Cell[28934, 834, 49, 1, 26, "Text",
  CellTags->"Mutation - Intro"],

Cell[CellGroupData[{
Cell[29008, 839, 79, 2, 56, "Subsection",
  Evaluatable->False],
Cell[29090, 843, 195, 14, 206, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[29322, 862, 105, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[29452, 868, 238, 8, 116, "Input"],
Cell[29693, 878, 159, 4, 56, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29889, 887, 81, 1, 41, "Input"],
Cell[29973, 890, 47226, 1334, 245, 25272, 1057, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[77248, 2230, 88, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[77361, 2236, 89, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[77475, 2242, 272, 10, 146, "Input"],
Cell[77750, 2254, 1167, 22, 248, "Output"],
Cell[78920, 2278, 4233, 135, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[83202, 2419, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[83313, 2425, 87, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[83425, 2430, 55587, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[139015, 3868, 55660, 1437, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[194678, 5307, 55571, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[250252, 6745, 51107, 1321, 311, 23260, 971, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[301362, 8068, 48813, 1263, 311, 22230, 929, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[350178, 9333, 55547, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[405728, 10771, 55551, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[461282, 12209, 55587, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[516872, 13647, 55571, 1436, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[572446, 15085, 55620, 1437, 311, 25323, 1057, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[628139, 16530, 89, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[628253, 16536, 45, 0, 60, "Subsubsection"],
Cell[628301, 16538, 135, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[628461, 16547, 80, 1, 41, "Input"],
Cell[628544, 16550, 33851, 871, 311, 15055, 633, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[662444, 17427, 101, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[662548, 17431, 155, 3, 44, "Text"],

Cell[CellGroupData[{
Cell[662728, 17438, 387, 11, 161, "Input"],
Cell[663118, 17451, 874, 16, 200, "Output"],
Cell[663995, 17469, 3389, 111, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[667433, 17586, 119, 3, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[667577, 17593, 87, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[667689, 17598, 36852, 878, 311, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[704544, 18478, 36892, 878, 311, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[741439, 19358, 36399, 932, 311, 16072, 675, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[777841, 20292, 34279, 816, 311, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[812123, 21110, 53201, 1621, 311, 32488, 1359, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[865327, 22733, 34192, 876, 311, 15047, 633, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[899522, 23611, 36912, 878, 311, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[936437, 24491, 48461, 1322, 311, 24299, 1017, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[984901, 25815, 42090, 1004, 311, 15963, 675, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1026994, 26821, 36880, 878, 311, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1063959, 27708, 80, 2, 62, "Section",
  Evaluatable->False],
Cell[1064042, 27712, 54, 1, 26, "Text",
  CellTags->"Recombination - Intro"],

Cell[CellGroupData[{
Cell[1064121, 27717, 79, 2, 56, "Subsection",
  Evaluatable->False],
Cell[1064203, 27721, 195, 14, 206, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1064435, 27740, 105, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1064565, 27746, 238, 8, 116, "Input"],
Cell[1064806, 27756, 243, 4, 72, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1065086, 27765, 81, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[1065192, 27770, 36743, 847, 345, 12912, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1101938, 28619, 70374, 1891, 345, 34590, 1443, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1172373, 30517, 113, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1172511, 30523, 109, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1172645, 30529, 164, 6, 86, "Input"],
Cell[1172812, 30537, 3032, 99, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1175893, 30642, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1176004, 30648, 87, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[1176116, 30653, 26444, 719, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1202563, 31374, 26444, 719, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1229010, 32095, 30819, 834, 221, 15039, 633, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1259832, 32931, 27430, 672, 221, 10823, 461, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1287265, 33605, 63775, 2137, 221, 45947, 1911, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1351043, 35744, 3523, 106, 221, 1586, 76, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[1354569, 35852, 26412, 719, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1380984, 36573, 26477, 720, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1407464, 37295, 22007, 604, 221, 10905, 461, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1429474, 37901, 30888, 835, 221, 15039, 633, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1460435, 38744, 103, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1460563, 38750, 121, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1460709, 38756, 194, 7, 101, "Input"],
Cell[1460906, 38765, 4473, 141, 183, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1465416, 38911, 53, 1, 41, "Input"],
Cell[1465472, 38914, 1180, 22, 280, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1466701, 38942, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1466812, 38948, 87, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[1466924, 38953, 26444, 719, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1493371, 39674, 26444, 719, 221, 12973, 547, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1519818, 40395, 62254, 1910, 221, 38702, 1613, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1582075, 42307, 49560, 1515, 221, 30467, 1273, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1631638, 43824, 54413, 1664, 221, 33559, 1401, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1686054, 45490, 28389, 773, 221, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1714446, 46265, 28543, 775, 221, 13998, 589, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1742992, 47042, 54632, 1667, 221, 33559, 1401, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1797627, 48711, 55949, 1713, 221, 34584, 1443, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[1853579, 50426, 55949, 1713, 221, 34584, 1443, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1909613, 52148, 78, 2, 62, "Section",
  Evaluatable->False],
Cell[1909694, 52152, 52, 1, 26, "Text",
  CellTags->"Duplication - Intro"],

Cell[CellGroupData[{
Cell[1909771, 52157, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1909882, 52163, 162, 10, 146, "Input"],
Cell[1910047, 52175, 152, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1910236, 52184, 80, 1, 41, "Input"],
Cell[1910319, 52187, 41318, 1065, 330, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[1951674, 53257, 156, 7, 101, "Input"],
Cell[1951833, 53266, 39910, 1034, 304, 18413, 763, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1991792, 54306, 90, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1991907, 54312, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1992026, 54318, 286, 12, 176, "Input"],
Cell[1992315, 54332, 1309, 29, 216, "Output"],
Cell[1993627, 54363, 4305, 139, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1997981, 54508, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1998092, 54514, 168, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[1998285, 54523, 53069, 1388, 304, 24663, 1031, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2051357, 55913, 54035, 1400, 304, 24649, 1031, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2105395, 57315, 62304, 1631, 304, 29088, 1215, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2167702, 58948, 48868, 1275, 304, 22585, 945, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2216573, 60225, 42855, 1111, 304, 19492, 817, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2259431, 61338, 43109, 1125, 304, 19794, 831, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2302543, 62465, 43183, 1115, 304, 19492, 817, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2345729, 63582, 47293, 1227, 304, 21560, 903, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2393025, 64811, 47293, 1227, 304, 21560, 903, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2440321, 66040, 42851, 1111, 304, 19492, 817, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[2483257, 67160, 75, 2, 62, "Section",
  Evaluatable->False],
Cell[2483335, 67164, 49, 1, 26, "Text",
  CellTags->"Deletion - Intro"],

Cell[CellGroupData[{
Cell[2483409, 67169, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2483520, 67175, 162, 10, 146, "Input"],
Cell[2483685, 67187, 152, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2483874, 67196, 80, 1, 41, "Input"],
Cell[2483957, 67199, 41060, 1061, 324, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2525066, 68266, 87, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2525178, 68272, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2525297, 68278, 283, 12, 176, "Input"],
Cell[2525583, 68292, 990, 20, 184, "Output"],
Cell[2526576, 68314, 3598, 121, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2530223, 68441, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2530334, 68447, 168, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[2530527, 68456, 33247, 936, 244, 17448, 735, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2563777, 69394, 28995, 823, 244, 15399, 649, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2592775, 70219, 34834, 985, 244, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2627612, 71206, 34834, 985, 244, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2662449, 72193, 34834, 985, 244, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2697286, 73180, 29020, 816, 244, 15011, 637, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2726309, 73998, 21803, 612, 244, 11197, 475, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2748115, 74612, 32926, 935, 244, 17370, 737, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2781044, 75549, 34834, 985, 244, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2815881, 76536, 32926, 935, 244, 17370, 737, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[2848892, 77480, 86, 2, 62, "Section",
  Evaluatable->False],
Cell[2848981, 77484, 50, 1, 26, "Text",
  CellTags->"Inversion - Intro"],

Cell[CellGroupData[{
Cell[2849056, 77489, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2849167, 77495, 162, 10, 146, "Input"],
Cell[2849332, 77507, 152, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2849521, 77516, 80, 1, 41, "Input"],
Cell[2849604, 77519, 39993, 1048, 312, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2889646, 78573, 88, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2889759, 78579, 103, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2889887, 78585, 284, 12, 176, "Input"],
Cell[2890174, 78599, 1070, 22, 184, "Output"],
Cell[2891247, 78623, 3823, 127, 183, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[2895119, 78756, 38, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[2895182, 78760, 115, 4, 41, "Input"],

Cell[CellGroupData[{
Cell[2895322, 78768, 33213, 961, 221, 18445, 773, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2928538, 79731, 33213, 961, 221, 18445, 773, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2961754, 80694, 33170, 964, 221, 18373, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2994927, 81660, 33146, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3028076, 82624, 33150, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3061229, 83588, 33150, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3094382, 84552, 33150, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3127535, 85516, 33150, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3160688, 86480, 33213, 961, 221, 18445, 773, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3193904, 87443, 33150, 962, 221, 18467, 775, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3227139, 88414, 98, 2, 62, "Section",
  Evaluatable->False],
Cell[3227240, 88418, 54, 1, 26, "Text",
  CellTags->"Encapsulation - Intro"],

Cell[CellGroupData[{
Cell[3227319, 88423, 103, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3227425, 88427, 111, 4, 56, "Input"],

Cell[CellGroupData[{
Cell[3227561, 88435, 158, 6, 86, "Input"],
Cell[3227722, 88443, 154, 3, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3227913, 88451, 61, 1, 41, "Input"],
Cell[3227977, 88454, 105, 2, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3228119, 88461, 69, 1, 41, "Input"],
Cell[3228191, 88464, 112, 2, 40, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3228352, 88472, 86, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3228463, 88478, 162, 10, 146, "Input"],
Cell[3228628, 88490, 152, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3228817, 88499, 80, 1, 41, "Input"],
Cell[3228900, 88502, 39793, 1046, 310, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3268742, 89554, 92, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3268859, 89560, 112, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3268996, 89566, 195, 8, 116, "Input"],
Cell[3269194, 89576, 784, 16, 168, "Output"],
Cell[3269981, 89594, 2755, 93, 192, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3272785, 89693, 86, 2, 34, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3272896, 89699, 165, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[3273086, 89708, 38836, 944, 308, 15275, 647, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3311925, 90654, 37633, 986, 308, 17439, 731, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3349561, 91642, 41136, 1003, 308, 16317, 691, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3390700, 92647, 6495, 142, 308, 1593, 76, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[3397198, 92791, 6467, 142, 308, 1593, 76, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[3403668, 92935, 6487, 142, 308, 1593, 76, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[3410158, 93079, 37625, 986, 308, 17439, 731, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3447786, 94067, 6516, 143, 308, 1593, 76, "GraphicsData", "PostScript", \
"Graphics",
  Evaluatable->False],
Cell[3454305, 94212, 28715, 689, 308, 10865, 463, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3483023, 94903, 31394, 819, 308, 14347, 603, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3514502, 95731, 85, 2, 62, "Section",
  Evaluatable->False],
Cell[3514590, 95735, 59, 1, 26, "Text",
  CellTags->"Pattern extraction - Intro"],

Cell[CellGroupData[{
Cell[3514674, 95740, 102, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3514801, 95746, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3514893, 95750, 76, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[3514994, 95755, 57, 1, 41, "Input"],
Cell[3515054, 95758, 35, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3515138, 95765, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3515264, 95771, 72, 1, 41, "Input"],
Cell[3515339, 95774, 62, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3515450, 95781, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3515576, 95787, 86, 1, 41, "Input"],
Cell[3515665, 95790, 567, 18, 56, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3516281, 95814, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3516407, 95820, 86, 1, 41, "Input"],
Cell[3516496, 95823, 590, 19, 56, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3517135, 95848, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3517261, 95854, 86, 1, 41, "Input"],
Cell[3517350, 95857, 441, 14, 56, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3517840, 95877, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3517966, 95883, 86, 1, 41, "Input"],
Cell[3518055, 95886, 376, 12, 56, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3518480, 95904, 101, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3518606, 95910, 86, 1, 41, "Input"],
Cell[3518695, 95913, 376, 12, 56, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3519132, 95932, 86, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3519243, 95938, 162, 10, 146, "Input"],
Cell[3519408, 95950, 152, 4, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3519597, 95959, 80, 1, 41, "Input"],
Cell[3519680, 95962, 41111, 1062, 327, 18492, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3560840, 97030, 97, 2, 40, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3560962, 97036, 94, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3561081, 97042, 194, 8, 116, "Input"],
Cell[3561278, 97052, 952, 18, 184, "Output"],
Cell[3562233, 97072, 3332, 110, 192, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3565614, 97188, 108, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3565747, 97194, 61, 1, 41, "Input"],
Cell[3565811, 97197, 806, 12, 152, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3566666, 97215, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3566777, 97221, 167, 5, 71, "Input"],

Cell[CellGroupData[{
Cell[3566969, 97230, 20427, 436, 317, 5778, 249, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3587399, 97668, 36606, 877, 317, 14072, 593, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3624008, 98547, 36570, 877, 317, 14072, 593, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3660581, 99426, 40355, 1053, 317, 18493, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3700939, 100481, 34930, 836, 317, 13319, 563, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3735872, 101319, 40395, 1053, 317, 18493, 777, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3776270, 102374, 39587, 953, 317, 15275, 647, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3815860, 103329, 34079, 885, 317, 15401, 649, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3849942, 104216, 32086, 828, 317, 14347, 603, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3882031, 105046, 44377, 1072, 317, 17357, 733, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3926469, 106125, 86, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3926580, 106131, 72, 1, 41, "Input"],
Cell[3926655, 106134, 1070, 22, 184, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3927810, 106165, 93, 2, 76, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3927928, 106171, 101, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3928032, 106175, 208, 6, 26, "Text"],
Cell[3928243, 106183, 355, 13, 26, "Text"],

Cell[CellGroupData[{
Cell[3928623, 106200, 201, 4, 73, "Input",
  InitializationCell->True],
Cell[3928827, 106206, 126, 2, 56, "Output"]
}, Open  ]],
Cell[3928968, 106211, 52, 0, 26, "Text"],
Cell[3929023, 106213, 91, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3929151, 106220, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3929262, 106226, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3929359, 106230, 96, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3929492, 106237, 100, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3929595, 106241, 89, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3929745, 106250, 82, 2, 50, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3929852, 106256, 89, 2, 78, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3929966, 106262, 101, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3930070, 106266, 446, 19, 266, "Input",
  InitializationCell->True],
Cell[3930519, 106287, 126, 2, 41, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3930670, 106293, 87, 1, 41, "Input"],
Cell[3930760, 106296, 230, 4, 70, "Print"],
Cell[3930993, 106302, 81, 1, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3931123, 106309, 105, 2, 40, "Subsection",
  Evaluatable->False],
Cell[3931231, 106313, 643, 25, 356, "Input",
  InitializationCell->True],
Cell[3931877, 106340, 183, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3932097, 106353, 100, 2, 40, "Subsection",
  Evaluatable->False],
Cell[3932200, 106357, 63, 1, 41, "Input"],

Cell[CellGroupData[{
Cell[3932288, 106362, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3932392, 106366, 484, 19, 266, "Input",
  InitializationCell->True],
Cell[3932879, 106387, 497, 19, 266, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3933413, 106411, 94, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3933510, 106415, 328, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3933875, 106434, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3933960, 106438, 319, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3934316, 106457, 90, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3934409, 106461, 315, 14, 191, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3934761, 106480, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3934878, 106484, 367, 13, 176, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3935282, 106502, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3935402, 106506, 216, 6, 71, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3935655, 106517, 92, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3935750, 106521, 113, 2, 41, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[3935900, 106528, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3935983, 106532, 130, 7, 86, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3936174, 106546, 91, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3936290, 106552, 94, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3936387, 106556, 333, 6, 121, "Input",
  InitializationCell->True],
Cell[3936723, 106564, 132, 7, 86, "Input",
  InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3936904, 106577, 84, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3937013, 106583, 82, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3937120, 106589, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3937219, 106593, 167, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3937435, 106607, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3937543, 106613, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3937660, 106617, 363, 12, 161, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3938060, 106634, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3938143, 106638, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3938279, 106645, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3938364, 106649, 121, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3938522, 106661, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3938626, 106665, 463, 21, 296, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3939126, 106691, 97, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3939226, 106695, 162, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3939437, 106709, 78, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3939540, 106715, 109, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3939652, 106719, 187, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3939876, 106732, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3939990, 106736, 211, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3940238, 106751, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3940321, 106755, 113, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3940471, 106762, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3940556, 106766, 116, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3940709, 106778, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3940808, 106782, 585, 24, 341, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3941442, 106812, 81, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3941548, 106818, 112, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3941663, 106822, 193, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3941893, 106835, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3942010, 106839, 217, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3942264, 106854, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3942347, 106858, 97, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3942481, 106865, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3942566, 106869, 122, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3942725, 106881, 99, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3942827, 106885, 124, 2, 41, "Input",
  InitializationCell->True],
Cell[3942954, 106889, 698, 28, 401, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3943701, 106923, 78, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3943804, 106929, 109, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3943916, 106933, 187, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3944140, 106946, 111, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3944254, 106950, 211, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3944502, 106965, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3944585, 106969, 94, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3944716, 106976, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3944801, 106980, 119, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3944957, 106992, 96, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3945056, 106996, 121, 2, 41, "Input",
  InitializationCell->True],
Cell[3945180, 107000, 849, 15, 431, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3946078, 107021, 79, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3946182, 107027, 110, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3946295, 107031, 189, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3946521, 107044, 112, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3946636, 107048, 213, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3946886, 107063, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3946969, 107067, 224, 12, 161, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3947230, 107084, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3947315, 107088, 120, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3947472, 107100, 97, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3947572, 107104, 122, 2, 41, "Input",
  InitializationCell->True],
Cell[3947697, 107108, 751, 31, 446, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3948497, 107145, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3948605, 107151, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3948722, 107155, 197, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3948956, 107168, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3949075, 107172, 221, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3949333, 107187, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3949416, 107191, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3949552, 107198, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3949637, 107202, 127, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3949801, 107214, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3949905, 107218, 589, 22, 311, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3950543, 107246, 83, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3950651, 107252, 114, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3950768, 107256, 197, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3951002, 107269, 116, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3951121, 107273, 221, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3951379, 107288, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3951462, 107292, 99, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3951598, 107299, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3951683, 107303, 121, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3951841, 107315, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3951945, 107319, 214, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3952208, 107333, 86, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3952319, 107339, 117, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3952439, 107343, 201, 8, 101, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3952677, 107356, 120, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3952800, 107360, 225, 10, 131, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3953062, 107375, 80, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3953145, 107379, 101, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3953283, 107386, 82, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3953368, 107390, 129, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3953534, 107402, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3953641, 107406, 609, 23, 326, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3954287, 107434, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3954381, 107438, 70, 1, 41, "Input"],
Cell[3954454, 107441, 112, 2, 41, "Input",
  InitializationCell->True],
Cell[3954569, 107445, 1321, 46, 671, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3955939, 107497, 87, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3956051, 107503, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3956145, 107507, 377, 16, 221, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3956559, 107528, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3956655, 107532, 176, 8, 101, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3956892, 107547, 86, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3957003, 107553, 95, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3957123, 107559, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3957215, 107563, 140, 5, 56, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3957392, 107573, 98, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3957493, 107577, 290, 12, 161, "Input",
  InitializationCell->True],
Cell[3957786, 107591, 128, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3957963, 107599, 88, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3958076, 107605, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3958183, 107609, 66, 1, 41, "Input"],
Cell[3958252, 107612, 353, 15, 206, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3958630, 107631, 68, 1, 41, "Input"],
Cell[3958701, 107634, 104, 6, 43, "Output",
  Evaluatable->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3958854, 107646, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3958950, 107650, 68, 1, 41, "Input"],
Cell[3959021, 107653, 322, 13, 176, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3959380, 107671, 88, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3959471, 107675, 492, 20, 281, "Input",
  InitializationCell->True],
Cell[3959966, 107697, 119, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3960122, 107709, 87, 2, 60, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3960234, 107715, 457, 18, 251, "Input",
  InitializationCell->True],
Cell[3960694, 107735, 185, 3, 70, "Message"]
}, Open  ]],
Cell[3960894, 107741, 117, 7, 86, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3961060, 107754, 97, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3961182, 107760, 91, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3961276, 107764, 935, 49, 716, "Input",
  InitializationCell->True],
Cell[3962214, 107815, 131, 7, 86, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3962382, 107827, 101, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3962486, 107831, 154, 5, 56, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3962701, 107843, 87, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3962813, 107849, 89, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3962905, 107853, 243, 12, 161, "Input",
  InitializationCell->True],
Cell[3963151, 107867, 135, 7, 86, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3963335, 107880, 86, 2, 62, "Section",
  Evaluatable->False],
Cell[3963424, 107884, 62, 1, 41, "Input"],
Cell[3963489, 107887, 3037, 53, 857, "Input",
  InitializationCell->True],
Cell[3966529, 107942, 343, 17, 236, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3966909, 107964, 80, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3967014, 107970, 84, 2, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3967123, 107976, 93, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3967219, 107980, 127, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3967383, 107987, 104, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3967490, 107991, 121, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3967660, 107999, 84, 2, 56, "Subsection",
  Evaluatable->False],
Cell[3967747, 108003, 115, 2, 41, "Input",
  InitializationCell->True],
Cell[3967865, 108007, 102, 2, 41, "Input",
  InitializationCell->True],
Cell[3967970, 108011, 66, 1, 41, "Input"],
Cell[3968039, 108014, 513, 18, 251, "Input",
  InitializationCell->True],
Cell[3968555, 108034, 128, 7, 86, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3968708, 108045, 84, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3968795, 108049, 170, 8, 116, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3969026, 108064, 92, 2, 62, "Section",
  Evaluatable->False],
Cell[3969121, 108068, 319, 16, 221, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3969477, 108089, 84, 2, 62, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3969586, 108095, 145, 5, 56, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3969756, 108104, 89, 2, 60, "Subsubsection",
  Evaluatable->False],
Cell[3969848, 108108, 125, 2, 41, "Input",
  InitializationCell->True],
Cell[3969976, 108112, 93, 2, 41, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3970106, 108119, 103, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[3970212, 108123, 651, 21, 296, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3970900, 108149, 104, 2, 34, "Subsubsection",
  Evaluatable->False],
Cell[3971007, 108153, 353, 15, 206, "Input",
  InitializationCell->True],
Cell[3971363, 108170, 103, 2, 41, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3971515, 108178, 111, 2, 40, "Subsection",
  Evaluatable->False],
Cell[3971629, 108182, 393, 15, 206, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[3972059, 108202, 109, 2, 40, "Subsection",
  Evaluatable->False],
Cell[3972171, 108206, 355, 15, 206, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3972551, 108225, 63, 1, 41, "Input"],
Cell[3972617, 108228, 39, 1, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[3972729, 108237, 78, 2, 50, "Subtitle",
  Evaluatable->False],
Cell[3972810, 108241, 204, 5, 62, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

